'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var path$M = require('path');
var require$$0$9 = require('fs');
var require$$0$a = require('os');
var require$$2$1 = require('vite');
var require$$3$2 = require('module');
var tty$2 = require('tty');
var require$$0$b = require('util');
var U$1 = require('node:fs');
var X$1 = require('node:path');
var require$$3$3 = require('crypto');
var require$$0$c = require('constants');
var require$$0$d = require('stream');
var require$$0$e = require('assert');
var require$$0$f = require('events');
var require$$1$4 = require('url');
var require$$0$g = require('http');
var require$$1$5 = require('https');
var require$$9 = require('@babel/preset-typescript/package.json');
var require$$2$2 = require('process');
var require$$6 = require('v8');
var require$$5$1 = require('buffer');
var require$$7 = require('inspector');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

function _interopNamespace(e) {
    if (e && e.__esModule) return e;
    var n = Object.create(null);
    if (e) {
        Object.keys(e).forEach(function (k) {
            if (k !== 'default') {
                var d = Object.getOwnPropertyDescriptor(e, k);
                Object.defineProperty(n, k, d.get ? d : {
                    enumerable: true,
                    get: function () { return e[k]; }
                });
            }
        });
    }
    n["default"] = e;
    return Object.freeze(n);
}

var path__default = /*#__PURE__*/_interopDefaultLegacy(path$M);
var path__namespace = /*#__PURE__*/_interopNamespace(path$M);
var require$$0__default = /*#__PURE__*/_interopDefaultLegacy(require$$0$9);
var require$$0__default$1 = /*#__PURE__*/_interopDefaultLegacy(require$$0$a);
var require$$2__default$1 = /*#__PURE__*/_interopDefaultLegacy(require$$2$1);
var require$$3__default = /*#__PURE__*/_interopDefaultLegacy(require$$3$2);
var tty__default = /*#__PURE__*/_interopDefaultLegacy(tty$2);
var tty__namespace = /*#__PURE__*/_interopNamespace(tty$2);
var require$$0__default$2 = /*#__PURE__*/_interopDefaultLegacy(require$$0$b);
var U__default = /*#__PURE__*/_interopDefaultLegacy(U$1);
var X__default = /*#__PURE__*/_interopDefaultLegacy(X$1);
var require$$3__default$1 = /*#__PURE__*/_interopDefaultLegacy(require$$3$3);
var require$$0__default$3 = /*#__PURE__*/_interopDefaultLegacy(require$$0$c);
var require$$0__default$4 = /*#__PURE__*/_interopDefaultLegacy(require$$0$d);
var require$$0__default$5 = /*#__PURE__*/_interopDefaultLegacy(require$$0$e);
var require$$0__default$6 = /*#__PURE__*/_interopDefaultLegacy(require$$0$f);
var require$$1__default = /*#__PURE__*/_interopDefaultLegacy(require$$1$4);
var require$$0__default$7 = /*#__PURE__*/_interopDefaultLegacy(require$$0$g);
var require$$1__default$1 = /*#__PURE__*/_interopDefaultLegacy(require$$1$5);
var require$$9__default = /*#__PURE__*/_interopDefaultLegacy(require$$9);
var require$$2__default = /*#__PURE__*/_interopDefaultLegacy(require$$2$2);
var require$$6__default = /*#__PURE__*/_interopDefaultLegacy(require$$6);
var require$$5__default = /*#__PURE__*/_interopDefaultLegacy(require$$5$1);
var require$$7__default = /*#__PURE__*/_interopDefaultLegacy(require$$7);

const defaultOpts$2 = {
    xml: false,
    decodeEntities: true,
};
const xmlModeDefault = {
    _useHtmlParser2: true,
    xmlMode: true,
};
/**
 * Flatten the options for Cheerio.
 *
 * This will set `_useHtmlParser2` to true if `xml` is set to true.
 *
 * @param options - The options to flatten.
 * @returns The flattened options.
 */
function flatten$1(options) {
    return (options === null || options === void 0 ? void 0 : options.xml)
        ? typeof options.xml === 'boolean'
            ? xmlModeDefault
            : { ...xmlModeDefault, ...options.xml }
        : options !== null && options !== void 0 ? options : undefined;
}

/** Types of elements found in htmlparser2's DOM */
var ElementType$1;
(function (ElementType) {
    /** Type for the root element of a document */
    ElementType["Root"] = "root";
    /** Type for Text */
    ElementType["Text"] = "text";
    /** Type for <? ... ?> */
    ElementType["Directive"] = "directive";
    /** Type for <!-- ... --> */
    ElementType["Comment"] = "comment";
    /** Type for <script> tags */
    ElementType["Script"] = "script";
    /** Type for <style> tags */
    ElementType["Style"] = "style";
    /** Type for Any tag */
    ElementType["Tag"] = "tag";
    /** Type for <![CDATA[ ... ]]> */
    ElementType["CDATA"] = "cdata";
    /** Type for <!doctype ...> */
    ElementType["Doctype"] = "doctype";
})(ElementType$1 || (ElementType$1 = {}));
/**
 * Tests whether an element is a tag or not.
 *
 * @param elem Element to test
 */
function isTag$3(elem) {
    return (elem.type === ElementType$1.Tag ||
        elem.type === ElementType$1.Script ||
        elem.type === ElementType$1.Style);
}
// Exports for backwards compatibility
/** Type for the root element of a document */
const Root = ElementType$1.Root;
/** Type for Text */
const Text$2 = ElementType$1.Text;
/** Type for <? ... ?> */
const Directive = ElementType$1.Directive;
/** Type for <!-- ... --> */
const Comment$2 = ElementType$1.Comment;
/** Type for <script> tags */
const Script = ElementType$1.Script;
/** Type for <style> tags */
const Style = ElementType$1.Style;
/** Type for Any tag */
const Tag = ElementType$1.Tag;
/** Type for <![CDATA[ ... ]]> */
const CDATA$1 = ElementType$1.CDATA;
/** Type for <!doctype ...> */
const Doctype = ElementType$1.Doctype;

/**
 * This object will be used as the prototype for Nodes when creating a
 * DOM-Level-1-compliant structure.
 */
class Node$2 {
    constructor() {
        /** Parent of the node */
        this.parent = null;
        /** Previous sibling */
        this.prev = null;
        /** Next sibling */
        this.next = null;
        /** The start index of the node. Requires `withStartIndices` on the handler to be `true. */
        this.startIndex = null;
        /** The end index of the node. Requires `withEndIndices` on the handler to be `true. */
        this.endIndex = null;
    }
    // Read-write aliases for properties
    /**
     * Same as {@link parent}.
     * [DOM spec](https://dom.spec.whatwg.org)-compatible alias.
     */
    get parentNode() {
        return this.parent;
    }
    set parentNode(parent) {
        this.parent = parent;
    }
    /**
     * Same as {@link prev}.
     * [DOM spec](https://dom.spec.whatwg.org)-compatible alias.
     */
    get previousSibling() {
        return this.prev;
    }
    set previousSibling(prev) {
        this.prev = prev;
    }
    /**
     * Same as {@link next}.
     * [DOM spec](https://dom.spec.whatwg.org)-compatible alias.
     */
    get nextSibling() {
        return this.next;
    }
    set nextSibling(next) {
        this.next = next;
    }
    /**
     * Clone this node, and optionally its children.
     *
     * @param recursive Clone child nodes as well.
     * @returns A clone of the node.
     */
    cloneNode(recursive = false) {
        return cloneNode$2(this, recursive);
    }
}
/**
 * A node that contains some data.
 */
class DataNode$1 extends Node$2 {
    /**
     * @param data The content of the data node
     */
    constructor(data) {
        super();
        this.data = data;
    }
    /**
     * Same as {@link data}.
     * [DOM spec](https://dom.spec.whatwg.org)-compatible alias.
     */
    get nodeValue() {
        return this.data;
    }
    set nodeValue(data) {
        this.data = data;
    }
}
/**
 * Text within the document.
 */
class Text$1 extends DataNode$1 {
    constructor() {
        super(...arguments);
        this.type = ElementType$1.Text;
    }
    get nodeType() {
        return 3;
    }
}
/**
 * Comments within the document.
 */
class Comment$1 extends DataNode$1 {
    constructor() {
        super(...arguments);
        this.type = ElementType$1.Comment;
    }
    get nodeType() {
        return 8;
    }
}
/**
 * Processing instructions, including doc types.
 */
class ProcessingInstruction$1 extends DataNode$1 {
    constructor(name, data) {
        super(data);
        this.name = name;
        this.type = ElementType$1.Directive;
    }
    get nodeType() {
        return 1;
    }
}
/**
 * A `Node` that can have children.
 */
class NodeWithChildren$1 extends Node$2 {
    /**
     * @param children Children of the node. Only certain node types can have children.
     */
    constructor(children) {
        super();
        this.children = children;
    }
    // Aliases
    /** First child of the node. */
    get firstChild() {
        var _a;
        return (_a = this.children[0]) !== null && _a !== void 0 ? _a : null;
    }
    /** Last child of the node. */
    get lastChild() {
        return this.children.length > 0
            ? this.children[this.children.length - 1]
            : null;
    }
    /**
     * Same as {@link children}.
     * [DOM spec](https://dom.spec.whatwg.org)-compatible alias.
     */
    get childNodes() {
        return this.children;
    }
    set childNodes(children) {
        this.children = children;
    }
}
class CDATA extends NodeWithChildren$1 {
    constructor() {
        super(...arguments);
        this.type = ElementType$1.CDATA;
    }
    get nodeType() {
        return 4;
    }
}
/**
 * The root node of the document.
 */
class Document$1 extends NodeWithChildren$1 {
    constructor() {
        super(...arguments);
        this.type = ElementType$1.Root;
    }
    get nodeType() {
        return 9;
    }
}
/**
 * An element within the DOM.
 */
class Element$2 extends NodeWithChildren$1 {
    /**
     * @param name Name of the tag, eg. `div`, `span`.
     * @param attribs Object mapping attribute names to attribute values.
     * @param children Children of the node.
     */
    constructor(name, attribs, children = [], type = name === "script"
        ? ElementType$1.Script
        : name === "style"
            ? ElementType$1.Style
            : ElementType$1.Tag) {
        super(children);
        this.name = name;
        this.attribs = attribs;
        this.type = type;
    }
    get nodeType() {
        return 1;
    }
    // DOM Level 1 aliases
    /**
     * Same as {@link name}.
     * [DOM spec](https://dom.spec.whatwg.org)-compatible alias.
     */
    get tagName() {
        return this.name;
    }
    set tagName(name) {
        this.name = name;
    }
    get attributes() {
        return Object.keys(this.attribs).map((name) => {
            var _a, _b;
            return ({
                name,
                value: this.attribs[name],
                namespace: (_a = this["x-attribsNamespace"]) === null || _a === void 0 ? void 0 : _a[name],
                prefix: (_b = this["x-attribsPrefix"]) === null || _b === void 0 ? void 0 : _b[name],
            });
        });
    }
}
/**
 * @param node Node to check.
 * @returns `true` if the node is a `Element`, `false` otherwise.
 */
function isTag$2(node) {
    return isTag$3(node);
}
/**
 * @param node Node to check.
 * @returns `true` if the node has the type `CDATA`, `false` otherwise.
 */
function isCDATA$1(node) {
    return node.type === ElementType$1.CDATA;
}
/**
 * @param node Node to check.
 * @returns `true` if the node has the type `Text`, `false` otherwise.
 */
function isText$1(node) {
    return node.type === ElementType$1.Text;
}
/**
 * @param node Node to check.
 * @returns `true` if the node has the type `Comment`, `false` otherwise.
 */
function isComment$1(node) {
    return node.type === ElementType$1.Comment;
}
/**
 * @param node Node to check.
 * @returns `true` if the node has the type `ProcessingInstruction`, `false` otherwise.
 */
function isDirective$1(node) {
    return node.type === ElementType$1.Directive;
}
/**
 * @param node Node to check.
 * @returns `true` if the node has the type `ProcessingInstruction`, `false` otherwise.
 */
function isDocument$1(node) {
    return node.type === ElementType$1.Root;
}
/**
 * @param node Node to check.
 * @returns `true` if the node has children, `false` otherwise.
 */
function hasChildren$1(node) {
    return Object.prototype.hasOwnProperty.call(node, "children");
}
/**
 * Clone a node, and optionally its children.
 *
 * @param recursive Clone child nodes as well.
 * @returns A clone of the node.
 */
function cloneNode$2(node, recursive = false) {
    let result;
    if (isText$1(node)) {
        result = new Text$1(node.data);
    }
    else if (isComment$1(node)) {
        result = new Comment$1(node.data);
    }
    else if (isTag$2(node)) {
        const children = recursive ? cloneChildren$1(node.children) : [];
        const clone = new Element$2(node.name, { ...node.attribs }, children);
        children.forEach((child) => (child.parent = clone));
        if (node.namespace != null) {
            clone.namespace = node.namespace;
        }
        if (node["x-attribsNamespace"]) {
            clone["x-attribsNamespace"] = { ...node["x-attribsNamespace"] };
        }
        if (node["x-attribsPrefix"]) {
            clone["x-attribsPrefix"] = { ...node["x-attribsPrefix"] };
        }
        result = clone;
    }
    else if (isCDATA$1(node)) {
        const children = recursive ? cloneChildren$1(node.children) : [];
        const clone = new CDATA(children);
        children.forEach((child) => (child.parent = clone));
        result = clone;
    }
    else if (isDocument$1(node)) {
        const children = recursive ? cloneChildren$1(node.children) : [];
        const clone = new Document$1(children);
        children.forEach((child) => (child.parent = clone));
        if (node["x-mode"]) {
            clone["x-mode"] = node["x-mode"];
        }
        result = clone;
    }
    else if (isDirective$1(node)) {
        const instruction = new ProcessingInstruction$1(node.name, node.data);
        if (node["x-name"] != null) {
            instruction["x-name"] = node["x-name"];
            instruction["x-publicId"] = node["x-publicId"];
            instruction["x-systemId"] = node["x-systemId"];
        }
        result = instruction;
    }
    else {
        throw new Error(`Not implemented yet: ${node.type}`);
    }
    result.startIndex = node.startIndex;
    result.endIndex = node.endIndex;
    if (node.sourceCodeLocation != null) {
        result.sourceCodeLocation = node.sourceCodeLocation;
    }
    return result;
}
function cloneChildren$1(childs) {
    const children = childs.map((child) => cloneNode$2(child, true));
    for (let i = 1; i < children.length; i++) {
        children[i].prev = children[i - 1];
        children[i - 1].next = children[i];
    }
    return children;
}

// Default options
const defaultOpts$1 = {
    withStartIndices: false,
    withEndIndices: false,
    xmlMode: false,
};
class DomHandler {
    /**
     * @param callback Called once parsing has completed.
     * @param options Settings for the handler.
     * @param elementCB Callback whenever a tag is closed.
     */
    constructor(callback, options, elementCB) {
        /** The elements of the DOM */
        this.dom = [];
        /** The root element for the DOM */
        this.root = new Document$1(this.dom);
        /** Indicated whether parsing has been completed. */
        this.done = false;
        /** Stack of open tags. */
        this.tagStack = [this.root];
        /** A data node that is still being written to. */
        this.lastNode = null;
        /** Reference to the parser instance. Used for location information. */
        this.parser = null;
        // Make it possible to skip arguments, for backwards-compatibility
        if (typeof options === "function") {
            elementCB = options;
            options = defaultOpts$1;
        }
        if (typeof callback === "object") {
            options = callback;
            callback = undefined;
        }
        this.callback = callback !== null && callback !== void 0 ? callback : null;
        this.options = options !== null && options !== void 0 ? options : defaultOpts$1;
        this.elementCB = elementCB !== null && elementCB !== void 0 ? elementCB : null;
    }
    onparserinit(parser) {
        this.parser = parser;
    }
    // Resets the handler back to starting state
    onreset() {
        this.dom = [];
        this.root = new Document$1(this.dom);
        this.done = false;
        this.tagStack = [this.root];
        this.lastNode = null;
        this.parser = null;
    }
    // Signals the handler that parsing is done
    onend() {
        if (this.done)
            return;
        this.done = true;
        this.parser = null;
        this.handleCallback(null);
    }
    onerror(error) {
        this.handleCallback(error);
    }
    onclosetag() {
        this.lastNode = null;
        const elem = this.tagStack.pop();
        if (this.options.withEndIndices) {
            elem.endIndex = this.parser.endIndex;
        }
        if (this.elementCB)
            this.elementCB(elem);
    }
    onopentag(name, attribs) {
        const type = this.options.xmlMode ? ElementType$1.Tag : undefined;
        const element = new Element$2(name, attribs, undefined, type);
        this.addNode(element);
        this.tagStack.push(element);
    }
    ontext(data) {
        const { lastNode } = this;
        if (lastNode && lastNode.type === ElementType$1.Text) {
            lastNode.data += data;
            if (this.options.withEndIndices) {
                lastNode.endIndex = this.parser.endIndex;
            }
        }
        else {
            const node = new Text$1(data);
            this.addNode(node);
            this.lastNode = node;
        }
    }
    oncomment(data) {
        if (this.lastNode && this.lastNode.type === ElementType$1.Comment) {
            this.lastNode.data += data;
            return;
        }
        const node = new Comment$1(data);
        this.addNode(node);
        this.lastNode = node;
    }
    oncommentend() {
        this.lastNode = null;
    }
    oncdatastart() {
        const text = new Text$1("");
        const node = new CDATA([text]);
        this.addNode(node);
        text.parent = node;
        this.lastNode = text;
    }
    oncdataend() {
        this.lastNode = null;
    }
    onprocessinginstruction(name, data) {
        const node = new ProcessingInstruction$1(name, data);
        this.addNode(node);
    }
    handleCallback(error) {
        if (typeof this.callback === "function") {
            this.callback(error, this.dom);
        }
        else if (error) {
            throw error;
        }
    }
    addNode(node) {
        const parent = this.tagStack[this.tagStack.length - 1];
        const previousSibling = parent.children[parent.children.length - 1];
        if (this.options.withStartIndices) {
            node.startIndex = this.parser.startIndex;
        }
        if (this.options.withEndIndices) {
            node.endIndex = this.parser.endIndex;
        }
        parent.children.push(node);
        if (previousSibling) {
            node.prev = previousSibling;
            previousSibling.next = node;
        }
        node.parent = parent;
        this.lastNode = null;
    }
}

// Generated using scripts/write-decode-map.ts
var htmlDecodeTree = new Uint16Array(
// prettier-ignore
"\u1d41<\xd5\u0131\u028a\u049d\u057b\u05d0\u0675\u06de\u07a2\u07d6\u080f\u0a4a\u0a91\u0da1\u0e6d\u0f09\u0f26\u10ca\u1228\u12e1\u1415\u149d\u14c3\u14df\u1525\0\0\0\0\0\0\u156b\u16cd\u198d\u1c12\u1ddd\u1f7e\u2060\u21b0\u228d\u23c0\u23fb\u2442\u2824\u2912\u2d08\u2e48\u2fce\u3016\u32ba\u3639\u37ac\u38fe\u3a28\u3a71\u3ae0\u3b2e\u0800EMabcfglmnoprstu\\bfms\x7f\x84\x8b\x90\x95\x98\xa6\xb3\xb9\xc8\xcflig\u803b\xc6\u40c6P\u803b&\u4026cute\u803b\xc1\u40c1reve;\u4102\u0100iyx}rc\u803b\xc2\u40c2;\u4410r;\uc000\ud835\udd04rave\u803b\xc0\u40c0pha;\u4391acr;\u4100d;\u6a53\u0100gp\x9d\xa1on;\u4104f;\uc000\ud835\udd38plyFunction;\u6061ing\u803b\xc5\u40c5\u0100cs\xbe\xc3r;\uc000\ud835\udc9cign;\u6254ilde\u803b\xc3\u40c3ml\u803b\xc4\u40c4\u0400aceforsu\xe5\xfb\xfe\u0117\u011c\u0122\u0127\u012a\u0100cr\xea\xf2kslash;\u6216\u0176\xf6\xf8;\u6ae7ed;\u6306y;\u4411\u0180crt\u0105\u010b\u0114ause;\u6235noullis;\u612ca;\u4392r;\uc000\ud835\udd05pf;\uc000\ud835\udd39eve;\u42d8c\xf2\u0113mpeq;\u624e\u0700HOacdefhilorsu\u014d\u0151\u0156\u0180\u019e\u01a2\u01b5\u01b7\u01ba\u01dc\u0215\u0273\u0278\u027ecy;\u4427PY\u803b\xa9\u40a9\u0180cpy\u015d\u0162\u017aute;\u4106\u0100;i\u0167\u0168\u62d2talDifferentialD;\u6145leys;\u612d\u0200aeio\u0189\u018e\u0194\u0198ron;\u410cdil\u803b\xc7\u40c7rc;\u4108nint;\u6230ot;\u410a\u0100dn\u01a7\u01adilla;\u40b8terDot;\u40b7\xf2\u017fi;\u43a7rcle\u0200DMPT\u01c7\u01cb\u01d1\u01d6ot;\u6299inus;\u6296lus;\u6295imes;\u6297o\u0100cs\u01e2\u01f8kwiseContourIntegral;\u6232eCurly\u0100DQ\u0203\u020foubleQuote;\u601duote;\u6019\u0200lnpu\u021e\u0228\u0247\u0255on\u0100;e\u0225\u0226\u6237;\u6a74\u0180git\u022f\u0236\u023aruent;\u6261nt;\u622fourIntegral;\u622e\u0100fr\u024c\u024e;\u6102oduct;\u6210nterClockwiseContourIntegral;\u6233oss;\u6a2fcr;\uc000\ud835\udc9ep\u0100;C\u0284\u0285\u62d3ap;\u624d\u0580DJSZacefios\u02a0\u02ac\u02b0\u02b4\u02b8\u02cb\u02d7\u02e1\u02e6\u0333\u048d\u0100;o\u0179\u02a5trahd;\u6911cy;\u4402cy;\u4405cy;\u440f\u0180grs\u02bf\u02c4\u02c7ger;\u6021r;\u61a1hv;\u6ae4\u0100ay\u02d0\u02d5ron;\u410e;\u4414l\u0100;t\u02dd\u02de\u6207a;\u4394r;\uc000\ud835\udd07\u0100af\u02eb\u0327\u0100cm\u02f0\u0322ritical\u0200ADGT\u0300\u0306\u0316\u031ccute;\u40b4o\u0174\u030b\u030d;\u42d9bleAcute;\u42ddrave;\u4060ilde;\u42dcond;\u62c4ferentialD;\u6146\u0470\u033d\0\0\0\u0342\u0354\0\u0405f;\uc000\ud835\udd3b\u0180;DE\u0348\u0349\u034d\u40a8ot;\u60dcqual;\u6250ble\u0300CDLRUV\u0363\u0372\u0382\u03cf\u03e2\u03f8ontourIntegra\xec\u0239o\u0274\u0379\0\0\u037b\xbb\u0349nArrow;\u61d3\u0100eo\u0387\u03a4ft\u0180ART\u0390\u0396\u03a1rrow;\u61d0ightArrow;\u61d4e\xe5\u02cang\u0100LR\u03ab\u03c4eft\u0100AR\u03b3\u03b9rrow;\u67f8ightArrow;\u67faightArrow;\u67f9ight\u0100AT\u03d8\u03derrow;\u61d2ee;\u62a8p\u0241\u03e9\0\0\u03efrrow;\u61d1ownArrow;\u61d5erticalBar;\u6225n\u0300ABLRTa\u0412\u042a\u0430\u045e\u047f\u037crrow\u0180;BU\u041d\u041e\u0422\u6193ar;\u6913pArrow;\u61f5reve;\u4311eft\u02d2\u043a\0\u0446\0\u0450ightVector;\u6950eeVector;\u695eector\u0100;B\u0459\u045a\u61bdar;\u6956ight\u01d4\u0467\0\u0471eeVector;\u695fector\u0100;B\u047a\u047b\u61c1ar;\u6957ee\u0100;A\u0486\u0487\u62a4rrow;\u61a7\u0100ct\u0492\u0497r;\uc000\ud835\udc9frok;\u4110\u0800NTacdfglmopqstux\u04bd\u04c0\u04c4\u04cb\u04de\u04e2\u04e7\u04ee\u04f5\u0521\u052f\u0536\u0552\u055d\u0560\u0565G;\u414aH\u803b\xd0\u40d0cute\u803b\xc9\u40c9\u0180aiy\u04d2\u04d7\u04dcron;\u411arc\u803b\xca\u40ca;\u442dot;\u4116r;\uc000\ud835\udd08rave\u803b\xc8\u40c8ement;\u6208\u0100ap\u04fa\u04fecr;\u4112ty\u0253\u0506\0\0\u0512mallSquare;\u65fberySmallSquare;\u65ab\u0100gp\u0526\u052aon;\u4118f;\uc000\ud835\udd3csilon;\u4395u\u0100ai\u053c\u0549l\u0100;T\u0542\u0543\u6a75ilde;\u6242librium;\u61cc\u0100ci\u0557\u055ar;\u6130m;\u6a73a;\u4397ml\u803b\xcb\u40cb\u0100ip\u056a\u056fsts;\u6203onentialE;\u6147\u0280cfios\u0585\u0588\u058d\u05b2\u05ccy;\u4424r;\uc000\ud835\udd09lled\u0253\u0597\0\0\u05a3mallSquare;\u65fcerySmallSquare;\u65aa\u0370\u05ba\0\u05bf\0\0\u05c4f;\uc000\ud835\udd3dAll;\u6200riertrf;\u6131c\xf2\u05cb\u0600JTabcdfgorst\u05e8\u05ec\u05ef\u05fa\u0600\u0612\u0616\u061b\u061d\u0623\u066c\u0672cy;\u4403\u803b>\u403emma\u0100;d\u05f7\u05f8\u4393;\u43dcreve;\u411e\u0180eiy\u0607\u060c\u0610dil;\u4122rc;\u411c;\u4413ot;\u4120r;\uc000\ud835\udd0a;\u62d9pf;\uc000\ud835\udd3eeater\u0300EFGLST\u0635\u0644\u064e\u0656\u065b\u0666qual\u0100;L\u063e\u063f\u6265ess;\u62dbullEqual;\u6267reater;\u6aa2ess;\u6277lantEqual;\u6a7eilde;\u6273cr;\uc000\ud835\udca2;\u626b\u0400Aacfiosu\u0685\u068b\u0696\u069b\u069e\u06aa\u06be\u06caRDcy;\u442a\u0100ct\u0690\u0694ek;\u42c7;\u405eirc;\u4124r;\u610clbertSpace;\u610b\u01f0\u06af\0\u06b2f;\u610dizontalLine;\u6500\u0100ct\u06c3\u06c5\xf2\u06a9rok;\u4126mp\u0144\u06d0\u06d8ownHum\xf0\u012fqual;\u624f\u0700EJOacdfgmnostu\u06fa\u06fe\u0703\u0707\u070e\u071a\u071e\u0721\u0728\u0744\u0778\u078b\u078f\u0795cy;\u4415lig;\u4132cy;\u4401cute\u803b\xcd\u40cd\u0100iy\u0713\u0718rc\u803b\xce\u40ce;\u4418ot;\u4130r;\u6111rave\u803b\xcc\u40cc\u0180;ap\u0720\u072f\u073f\u0100cg\u0734\u0737r;\u412ainaryI;\u6148lie\xf3\u03dd\u01f4\u0749\0\u0762\u0100;e\u074d\u074e\u622c\u0100gr\u0753\u0758ral;\u622bsection;\u62c2isible\u0100CT\u076c\u0772omma;\u6063imes;\u6062\u0180gpt\u077f\u0783\u0788on;\u412ef;\uc000\ud835\udd40a;\u4399cr;\u6110ilde;\u4128\u01eb\u079a\0\u079ecy;\u4406l\u803b\xcf\u40cf\u0280cfosu\u07ac\u07b7\u07bc\u07c2\u07d0\u0100iy\u07b1\u07b5rc;\u4134;\u4419r;\uc000\ud835\udd0dpf;\uc000\ud835\udd41\u01e3\u07c7\0\u07ccr;\uc000\ud835\udca5rcy;\u4408kcy;\u4404\u0380HJacfos\u07e4\u07e8\u07ec\u07f1\u07fd\u0802\u0808cy;\u4425cy;\u440cppa;\u439a\u0100ey\u07f6\u07fbdil;\u4136;\u441ar;\uc000\ud835\udd0epf;\uc000\ud835\udd42cr;\uc000\ud835\udca6\u0580JTaceflmost\u0825\u0829\u082c\u0850\u0863\u09b3\u09b8\u09c7\u09cd\u0a37\u0a47cy;\u4409\u803b<\u403c\u0280cmnpr\u0837\u083c\u0841\u0844\u084dute;\u4139bda;\u439bg;\u67ealacetrf;\u6112r;\u619e\u0180aey\u0857\u085c\u0861ron;\u413ddil;\u413b;\u441b\u0100fs\u0868\u0970t\u0500ACDFRTUVar\u087e\u08a9\u08b1\u08e0\u08e6\u08fc\u092f\u095b\u0390\u096a\u0100nr\u0883\u088fgleBracket;\u67e8row\u0180;BR\u0899\u089a\u089e\u6190ar;\u61e4ightArrow;\u61c6eiling;\u6308o\u01f5\u08b7\0\u08c3bleBracket;\u67e6n\u01d4\u08c8\0\u08d2eeVector;\u6961ector\u0100;B\u08db\u08dc\u61c3ar;\u6959loor;\u630aight\u0100AV\u08ef\u08f5rrow;\u6194ector;\u694e\u0100er\u0901\u0917e\u0180;AV\u0909\u090a\u0910\u62a3rrow;\u61a4ector;\u695aiangle\u0180;BE\u0924\u0925\u0929\u62b2ar;\u69cfqual;\u62b4p\u0180DTV\u0937\u0942\u094cownVector;\u6951eeVector;\u6960ector\u0100;B\u0956\u0957\u61bfar;\u6958ector\u0100;B\u0965\u0966\u61bcar;\u6952ight\xe1\u039cs\u0300EFGLST\u097e\u098b\u0995\u099d\u09a2\u09adqualGreater;\u62daullEqual;\u6266reater;\u6276ess;\u6aa1lantEqual;\u6a7dilde;\u6272r;\uc000\ud835\udd0f\u0100;e\u09bd\u09be\u62d8ftarrow;\u61daidot;\u413f\u0180npw\u09d4\u0a16\u0a1bg\u0200LRlr\u09de\u09f7\u0a02\u0a10eft\u0100AR\u09e6\u09ecrrow;\u67f5ightArrow;\u67f7ightArrow;\u67f6eft\u0100ar\u03b3\u0a0aight\xe1\u03bfight\xe1\u03caf;\uc000\ud835\udd43er\u0100LR\u0a22\u0a2ceftArrow;\u6199ightArrow;\u6198\u0180cht\u0a3e\u0a40\u0a42\xf2\u084c;\u61b0rok;\u4141;\u626a\u0400acefiosu\u0a5a\u0a5d\u0a60\u0a77\u0a7c\u0a85\u0a8b\u0a8ep;\u6905y;\u441c\u0100dl\u0a65\u0a6fiumSpace;\u605flintrf;\u6133r;\uc000\ud835\udd10nusPlus;\u6213pf;\uc000\ud835\udd44c\xf2\u0a76;\u439c\u0480Jacefostu\u0aa3\u0aa7\u0aad\u0ac0\u0b14\u0b19\u0d91\u0d97\u0d9ecy;\u440acute;\u4143\u0180aey\u0ab4\u0ab9\u0aberon;\u4147dil;\u4145;\u441d\u0180gsw\u0ac7\u0af0\u0b0eative\u0180MTV\u0ad3\u0adf\u0ae8ediumSpace;\u600bhi\u0100cn\u0ae6\u0ad8\xeb\u0ad9eryThi\xee\u0ad9ted\u0100GL\u0af8\u0b06reaterGreate\xf2\u0673essLes\xf3\u0a48Line;\u400ar;\uc000\ud835\udd11\u0200Bnpt\u0b22\u0b28\u0b37\u0b3areak;\u6060BreakingSpace;\u40a0f;\u6115\u0680;CDEGHLNPRSTV\u0b55\u0b56\u0b6a\u0b7c\u0ba1\u0beb\u0c04\u0c5e\u0c84\u0ca6\u0cd8\u0d61\u0d85\u6aec\u0100ou\u0b5b\u0b64ngruent;\u6262pCap;\u626doubleVerticalBar;\u6226\u0180lqx\u0b83\u0b8a\u0b9bement;\u6209ual\u0100;T\u0b92\u0b93\u6260ilde;\uc000\u2242\u0338ists;\u6204reater\u0380;EFGLST\u0bb6\u0bb7\u0bbd\u0bc9\u0bd3\u0bd8\u0be5\u626fqual;\u6271ullEqual;\uc000\u2267\u0338reater;\uc000\u226b\u0338ess;\u6279lantEqual;\uc000\u2a7e\u0338ilde;\u6275ump\u0144\u0bf2\u0bfdownHump;\uc000\u224e\u0338qual;\uc000\u224f\u0338e\u0100fs\u0c0a\u0c27tTriangle\u0180;BE\u0c1a\u0c1b\u0c21\u62eaar;\uc000\u29cf\u0338qual;\u62ecs\u0300;EGLST\u0c35\u0c36\u0c3c\u0c44\u0c4b\u0c58\u626equal;\u6270reater;\u6278ess;\uc000\u226a\u0338lantEqual;\uc000\u2a7d\u0338ilde;\u6274ested\u0100GL\u0c68\u0c79reaterGreater;\uc000\u2aa2\u0338essLess;\uc000\u2aa1\u0338recedes\u0180;ES\u0c92\u0c93\u0c9b\u6280qual;\uc000\u2aaf\u0338lantEqual;\u62e0\u0100ei\u0cab\u0cb9verseElement;\u620cghtTriangle\u0180;BE\u0ccb\u0ccc\u0cd2\u62ebar;\uc000\u29d0\u0338qual;\u62ed\u0100qu\u0cdd\u0d0cuareSu\u0100bp\u0ce8\u0cf9set\u0100;E\u0cf0\u0cf3\uc000\u228f\u0338qual;\u62e2erset\u0100;E\u0d03\u0d06\uc000\u2290\u0338qual;\u62e3\u0180bcp\u0d13\u0d24\u0d4eset\u0100;E\u0d1b\u0d1e\uc000\u2282\u20d2qual;\u6288ceeds\u0200;EST\u0d32\u0d33\u0d3b\u0d46\u6281qual;\uc000\u2ab0\u0338lantEqual;\u62e1ilde;\uc000\u227f\u0338erset\u0100;E\u0d58\u0d5b\uc000\u2283\u20d2qual;\u6289ilde\u0200;EFT\u0d6e\u0d6f\u0d75\u0d7f\u6241qual;\u6244ullEqual;\u6247ilde;\u6249erticalBar;\u6224cr;\uc000\ud835\udca9ilde\u803b\xd1\u40d1;\u439d\u0700Eacdfgmoprstuv\u0dbd\u0dc2\u0dc9\u0dd5\u0ddb\u0de0\u0de7\u0dfc\u0e02\u0e20\u0e22\u0e32\u0e3f\u0e44lig;\u4152cute\u803b\xd3\u40d3\u0100iy\u0dce\u0dd3rc\u803b\xd4\u40d4;\u441eblac;\u4150r;\uc000\ud835\udd12rave\u803b\xd2\u40d2\u0180aei\u0dee\u0df2\u0df6cr;\u414cga;\u43a9cron;\u439fpf;\uc000\ud835\udd46enCurly\u0100DQ\u0e0e\u0e1aoubleQuote;\u601cuote;\u6018;\u6a54\u0100cl\u0e27\u0e2cr;\uc000\ud835\udcaaash\u803b\xd8\u40d8i\u016c\u0e37\u0e3cde\u803b\xd5\u40d5es;\u6a37ml\u803b\xd6\u40d6er\u0100BP\u0e4b\u0e60\u0100ar\u0e50\u0e53r;\u603eac\u0100ek\u0e5a\u0e5c;\u63deet;\u63b4arenthesis;\u63dc\u0480acfhilors\u0e7f\u0e87\u0e8a\u0e8f\u0e92\u0e94\u0e9d\u0eb0\u0efcrtialD;\u6202y;\u441fr;\uc000\ud835\udd13i;\u43a6;\u43a0usMinus;\u40b1\u0100ip\u0ea2\u0eadncareplan\xe5\u069df;\u6119\u0200;eio\u0eb9\u0eba\u0ee0\u0ee4\u6abbcedes\u0200;EST\u0ec8\u0ec9\u0ecf\u0eda\u627aqual;\u6aaflantEqual;\u627cilde;\u627eme;\u6033\u0100dp\u0ee9\u0eeeuct;\u620fortion\u0100;a\u0225\u0ef9l;\u621d\u0100ci\u0f01\u0f06r;\uc000\ud835\udcab;\u43a8\u0200Ufos\u0f11\u0f16\u0f1b\u0f1fOT\u803b\"\u4022r;\uc000\ud835\udd14pf;\u611acr;\uc000\ud835\udcac\u0600BEacefhiorsu\u0f3e\u0f43\u0f47\u0f60\u0f73\u0fa7\u0faa\u0fad\u1096\u10a9\u10b4\u10bearr;\u6910G\u803b\xae\u40ae\u0180cnr\u0f4e\u0f53\u0f56ute;\u4154g;\u67ebr\u0100;t\u0f5c\u0f5d\u61a0l;\u6916\u0180aey\u0f67\u0f6c\u0f71ron;\u4158dil;\u4156;\u4420\u0100;v\u0f78\u0f79\u611cerse\u0100EU\u0f82\u0f99\u0100lq\u0f87\u0f8eement;\u620builibrium;\u61cbpEquilibrium;\u696fr\xbb\u0f79o;\u43a1ght\u0400ACDFTUVa\u0fc1\u0feb\u0ff3\u1022\u1028\u105b\u1087\u03d8\u0100nr\u0fc6\u0fd2gleBracket;\u67e9row\u0180;BL\u0fdc\u0fdd\u0fe1\u6192ar;\u61e5eftArrow;\u61c4eiling;\u6309o\u01f5\u0ff9\0\u1005bleBracket;\u67e7n\u01d4\u100a\0\u1014eeVector;\u695dector\u0100;B\u101d\u101e\u61c2ar;\u6955loor;\u630b\u0100er\u102d\u1043e\u0180;AV\u1035\u1036\u103c\u62a2rrow;\u61a6ector;\u695biangle\u0180;BE\u1050\u1051\u1055\u62b3ar;\u69d0qual;\u62b5p\u0180DTV\u1063\u106e\u1078ownVector;\u694feeVector;\u695cector\u0100;B\u1082\u1083\u61bear;\u6954ector\u0100;B\u1091\u1092\u61c0ar;\u6953\u0100pu\u109b\u109ef;\u611dndImplies;\u6970ightarrow;\u61db\u0100ch\u10b9\u10bcr;\u611b;\u61b1leDelayed;\u69f4\u0680HOacfhimoqstu\u10e4\u10f1\u10f7\u10fd\u1119\u111e\u1151\u1156\u1161\u1167\u11b5\u11bb\u11bf\u0100Cc\u10e9\u10eeHcy;\u4429y;\u4428FTcy;\u442ccute;\u415a\u0280;aeiy\u1108\u1109\u110e\u1113\u1117\u6abcron;\u4160dil;\u415erc;\u415c;\u4421r;\uc000\ud835\udd16ort\u0200DLRU\u112a\u1134\u113e\u1149ownArrow\xbb\u041eeftArrow\xbb\u089aightArrow\xbb\u0fddpArrow;\u6191gma;\u43a3allCircle;\u6218pf;\uc000\ud835\udd4a\u0272\u116d\0\0\u1170t;\u621aare\u0200;ISU\u117b\u117c\u1189\u11af\u65a1ntersection;\u6293u\u0100bp\u118f\u119eset\u0100;E\u1197\u1198\u628fqual;\u6291erset\u0100;E\u11a8\u11a9\u6290qual;\u6292nion;\u6294cr;\uc000\ud835\udcaear;\u62c6\u0200bcmp\u11c8\u11db\u1209\u120b\u0100;s\u11cd\u11ce\u62d0et\u0100;E\u11cd\u11d5qual;\u6286\u0100ch\u11e0\u1205eeds\u0200;EST\u11ed\u11ee\u11f4\u11ff\u627bqual;\u6ab0lantEqual;\u627dilde;\u627fTh\xe1\u0f8c;\u6211\u0180;es\u1212\u1213\u1223\u62d1rset\u0100;E\u121c\u121d\u6283qual;\u6287et\xbb\u1213\u0580HRSacfhiors\u123e\u1244\u1249\u1255\u125e\u1271\u1276\u129f\u12c2\u12c8\u12d1ORN\u803b\xde\u40deADE;\u6122\u0100Hc\u124e\u1252cy;\u440by;\u4426\u0100bu\u125a\u125c;\u4009;\u43a4\u0180aey\u1265\u126a\u126fron;\u4164dil;\u4162;\u4422r;\uc000\ud835\udd17\u0100ei\u127b\u1289\u01f2\u1280\0\u1287efore;\u6234a;\u4398\u0100cn\u128e\u1298kSpace;\uc000\u205f\u200aSpace;\u6009lde\u0200;EFT\u12ab\u12ac\u12b2\u12bc\u623cqual;\u6243ullEqual;\u6245ilde;\u6248pf;\uc000\ud835\udd4bipleDot;\u60db\u0100ct\u12d6\u12dbr;\uc000\ud835\udcafrok;\u4166\u0ae1\u12f7\u130e\u131a\u1326\0\u132c\u1331\0\0\0\0\0\u1338\u133d\u1377\u1385\0\u13ff\u1404\u140a\u1410\u0100cr\u12fb\u1301ute\u803b\xda\u40dar\u0100;o\u1307\u1308\u619fcir;\u6949r\u01e3\u1313\0\u1316y;\u440eve;\u416c\u0100iy\u131e\u1323rc\u803b\xdb\u40db;\u4423blac;\u4170r;\uc000\ud835\udd18rave\u803b\xd9\u40d9acr;\u416a\u0100di\u1341\u1369er\u0100BP\u1348\u135d\u0100ar\u134d\u1350r;\u405fac\u0100ek\u1357\u1359;\u63dfet;\u63b5arenthesis;\u63ddon\u0100;P\u1370\u1371\u62c3lus;\u628e\u0100gp\u137b\u137fon;\u4172f;\uc000\ud835\udd4c\u0400ADETadps\u1395\u13ae\u13b8\u13c4\u03e8\u13d2\u13d7\u13f3rrow\u0180;BD\u1150\u13a0\u13a4ar;\u6912ownArrow;\u61c5ownArrow;\u6195quilibrium;\u696eee\u0100;A\u13cb\u13cc\u62a5rrow;\u61a5own\xe1\u03f3er\u0100LR\u13de\u13e8eftArrow;\u6196ightArrow;\u6197i\u0100;l\u13f9\u13fa\u43d2on;\u43a5ing;\u416ecr;\uc000\ud835\udcb0ilde;\u4168ml\u803b\xdc\u40dc\u0480Dbcdefosv\u1427\u142c\u1430\u1433\u143e\u1485\u148a\u1490\u1496ash;\u62abar;\u6aeby;\u4412ash\u0100;l\u143b\u143c\u62a9;\u6ae6\u0100er\u1443\u1445;\u62c1\u0180bty\u144c\u1450\u147aar;\u6016\u0100;i\u144f\u1455cal\u0200BLST\u1461\u1465\u146a\u1474ar;\u6223ine;\u407ceparator;\u6758ilde;\u6240ThinSpace;\u600ar;\uc000\ud835\udd19pf;\uc000\ud835\udd4dcr;\uc000\ud835\udcb1dash;\u62aa\u0280cefos\u14a7\u14ac\u14b1\u14b6\u14bcirc;\u4174dge;\u62c0r;\uc000\ud835\udd1apf;\uc000\ud835\udd4ecr;\uc000\ud835\udcb2\u0200fios\u14cb\u14d0\u14d2\u14d8r;\uc000\ud835\udd1b;\u439epf;\uc000\ud835\udd4fcr;\uc000\ud835\udcb3\u0480AIUacfosu\u14f1\u14f5\u14f9\u14fd\u1504\u150f\u1514\u151a\u1520cy;\u442fcy;\u4407cy;\u442ecute\u803b\xdd\u40dd\u0100iy\u1509\u150drc;\u4176;\u442br;\uc000\ud835\udd1cpf;\uc000\ud835\udd50cr;\uc000\ud835\udcb4ml;\u4178\u0400Hacdefos\u1535\u1539\u153f\u154b\u154f\u155d\u1560\u1564cy;\u4416cute;\u4179\u0100ay\u1544\u1549ron;\u417d;\u4417ot;\u417b\u01f2\u1554\0\u155boWidt\xe8\u0ad9a;\u4396r;\u6128pf;\u6124cr;\uc000\ud835\udcb5\u0be1\u1583\u158a\u1590\0\u15b0\u15b6\u15bf\0\0\0\0\u15c6\u15db\u15eb\u165f\u166d\0\u1695\u169b\u16b2\u16b9\0\u16becute\u803b\xe1\u40e1reve;\u4103\u0300;Ediuy\u159c\u159d\u15a1\u15a3\u15a8\u15ad\u623e;\uc000\u223e\u0333;\u623frc\u803b\xe2\u40e2te\u80bb\xb4\u0306;\u4430lig\u803b\xe6\u40e6\u0100;r\xb2\u15ba;\uc000\ud835\udd1erave\u803b\xe0\u40e0\u0100ep\u15ca\u15d6\u0100fp\u15cf\u15d4sym;\u6135\xe8\u15d3ha;\u43b1\u0100ap\u15dfc\u0100cl\u15e4\u15e7r;\u4101g;\u6a3f\u0264\u15f0\0\0\u160a\u0280;adsv\u15fa\u15fb\u15ff\u1601\u1607\u6227nd;\u6a55;\u6a5clope;\u6a58;\u6a5a\u0380;elmrsz\u1618\u1619\u161b\u161e\u163f\u164f\u1659\u6220;\u69a4e\xbb\u1619sd\u0100;a\u1625\u1626\u6221\u0461\u1630\u1632\u1634\u1636\u1638\u163a\u163c\u163e;\u69a8;\u69a9;\u69aa;\u69ab;\u69ac;\u69ad;\u69ae;\u69aft\u0100;v\u1645\u1646\u621fb\u0100;d\u164c\u164d\u62be;\u699d\u0100pt\u1654\u1657h;\u6222\xbb\xb9arr;\u637c\u0100gp\u1663\u1667on;\u4105f;\uc000\ud835\udd52\u0380;Eaeiop\u12c1\u167b\u167d\u1682\u1684\u1687\u168a;\u6a70cir;\u6a6f;\u624ad;\u624bs;\u4027rox\u0100;e\u12c1\u1692\xf1\u1683ing\u803b\xe5\u40e5\u0180cty\u16a1\u16a6\u16a8r;\uc000\ud835\udcb6;\u402amp\u0100;e\u12c1\u16af\xf1\u0288ilde\u803b\xe3\u40e3ml\u803b\xe4\u40e4\u0100ci\u16c2\u16c8onin\xf4\u0272nt;\u6a11\u0800Nabcdefiklnoprsu\u16ed\u16f1\u1730\u173c\u1743\u1748\u1778\u177d\u17e0\u17e6\u1839\u1850\u170d\u193d\u1948\u1970ot;\u6aed\u0100cr\u16f6\u171ek\u0200ceps\u1700\u1705\u170d\u1713ong;\u624cpsilon;\u43f6rime;\u6035im\u0100;e\u171a\u171b\u623dq;\u62cd\u0176\u1722\u1726ee;\u62bded\u0100;g\u172c\u172d\u6305e\xbb\u172drk\u0100;t\u135c\u1737brk;\u63b6\u0100oy\u1701\u1741;\u4431quo;\u601e\u0280cmprt\u1753\u175b\u1761\u1764\u1768aus\u0100;e\u010a\u0109ptyv;\u69b0s\xe9\u170cno\xf5\u0113\u0180ahw\u176f\u1771\u1773;\u43b2;\u6136een;\u626cr;\uc000\ud835\udd1fg\u0380costuvw\u178d\u179d\u17b3\u17c1\u17d5\u17db\u17de\u0180aiu\u1794\u1796\u179a\xf0\u0760rc;\u65efp\xbb\u1371\u0180dpt\u17a4\u17a8\u17adot;\u6a00lus;\u6a01imes;\u6a02\u0271\u17b9\0\0\u17becup;\u6a06ar;\u6605riangle\u0100du\u17cd\u17d2own;\u65bdp;\u65b3plus;\u6a04e\xe5\u1444\xe5\u14adarow;\u690d\u0180ako\u17ed\u1826\u1835\u0100cn\u17f2\u1823k\u0180lst\u17fa\u05ab\u1802ozenge;\u69ebriangle\u0200;dlr\u1812\u1813\u1818\u181d\u65b4own;\u65beeft;\u65c2ight;\u65b8k;\u6423\u01b1\u182b\0\u1833\u01b2\u182f\0\u1831;\u6592;\u65914;\u6593ck;\u6588\u0100eo\u183e\u184d\u0100;q\u1843\u1846\uc000=\u20e5uiv;\uc000\u2261\u20e5t;\u6310\u0200ptwx\u1859\u185e\u1867\u186cf;\uc000\ud835\udd53\u0100;t\u13cb\u1863om\xbb\u13cctie;\u62c8\u0600DHUVbdhmptuv\u1885\u1896\u18aa\u18bb\u18d7\u18db\u18ec\u18ff\u1905\u190a\u1910\u1921\u0200LRlr\u188e\u1890\u1892\u1894;\u6557;\u6554;\u6556;\u6553\u0280;DUdu\u18a1\u18a2\u18a4\u18a6\u18a8\u6550;\u6566;\u6569;\u6564;\u6567\u0200LRlr\u18b3\u18b5\u18b7\u18b9;\u655d;\u655a;\u655c;\u6559\u0380;HLRhlr\u18ca\u18cb\u18cd\u18cf\u18d1\u18d3\u18d5\u6551;\u656c;\u6563;\u6560;\u656b;\u6562;\u655fox;\u69c9\u0200LRlr\u18e4\u18e6\u18e8\u18ea;\u6555;\u6552;\u6510;\u650c\u0280;DUdu\u06bd\u18f7\u18f9\u18fb\u18fd;\u6565;\u6568;\u652c;\u6534inus;\u629flus;\u629eimes;\u62a0\u0200LRlr\u1919\u191b\u191d\u191f;\u655b;\u6558;\u6518;\u6514\u0380;HLRhlr\u1930\u1931\u1933\u1935\u1937\u1939\u193b\u6502;\u656a;\u6561;\u655e;\u653c;\u6524;\u651c\u0100ev\u0123\u1942bar\u803b\xa6\u40a6\u0200ceio\u1951\u1956\u195a\u1960r;\uc000\ud835\udcb7mi;\u604fm\u0100;e\u171a\u171cl\u0180;bh\u1968\u1969\u196b\u405c;\u69c5sub;\u67c8\u016c\u1974\u197el\u0100;e\u1979\u197a\u6022t\xbb\u197ap\u0180;Ee\u012f\u1985\u1987;\u6aae\u0100;q\u06dc\u06db\u0ce1\u19a7\0\u19e8\u1a11\u1a15\u1a32\0\u1a37\u1a50\0\0\u1ab4\0\0\u1ac1\0\0\u1b21\u1b2e\u1b4d\u1b52\0\u1bfd\0\u1c0c\u0180cpr\u19ad\u19b2\u19ddute;\u4107\u0300;abcds\u19bf\u19c0\u19c4\u19ca\u19d5\u19d9\u6229nd;\u6a44rcup;\u6a49\u0100au\u19cf\u19d2p;\u6a4bp;\u6a47ot;\u6a40;\uc000\u2229\ufe00\u0100eo\u19e2\u19e5t;\u6041\xee\u0693\u0200aeiu\u19f0\u19fb\u1a01\u1a05\u01f0\u19f5\0\u19f8s;\u6a4don;\u410ddil\u803b\xe7\u40e7rc;\u4109ps\u0100;s\u1a0c\u1a0d\u6a4cm;\u6a50ot;\u410b\u0180dmn\u1a1b\u1a20\u1a26il\u80bb\xb8\u01adptyv;\u69b2t\u8100\xa2;e\u1a2d\u1a2e\u40a2r\xe4\u01b2r;\uc000\ud835\udd20\u0180cei\u1a3d\u1a40\u1a4dy;\u4447ck\u0100;m\u1a47\u1a48\u6713ark\xbb\u1a48;\u43c7r\u0380;Ecefms\u1a5f\u1a60\u1a62\u1a6b\u1aa4\u1aaa\u1aae\u65cb;\u69c3\u0180;el\u1a69\u1a6a\u1a6d\u42c6q;\u6257e\u0261\u1a74\0\0\u1a88rrow\u0100lr\u1a7c\u1a81eft;\u61baight;\u61bb\u0280RSacd\u1a92\u1a94\u1a96\u1a9a\u1a9f\xbb\u0f47;\u64c8st;\u629birc;\u629aash;\u629dnint;\u6a10id;\u6aefcir;\u69c2ubs\u0100;u\u1abb\u1abc\u6663it\xbb\u1abc\u02ec\u1ac7\u1ad4\u1afa\0\u1b0aon\u0100;e\u1acd\u1ace\u403a\u0100;q\xc7\xc6\u026d\u1ad9\0\0\u1ae2a\u0100;t\u1ade\u1adf\u402c;\u4040\u0180;fl\u1ae8\u1ae9\u1aeb\u6201\xee\u1160e\u0100mx\u1af1\u1af6ent\xbb\u1ae9e\xf3\u024d\u01e7\u1afe\0\u1b07\u0100;d\u12bb\u1b02ot;\u6a6dn\xf4\u0246\u0180fry\u1b10\u1b14\u1b17;\uc000\ud835\udd54o\xe4\u0254\u8100\xa9;s\u0155\u1b1dr;\u6117\u0100ao\u1b25\u1b29rr;\u61b5ss;\u6717\u0100cu\u1b32\u1b37r;\uc000\ud835\udcb8\u0100bp\u1b3c\u1b44\u0100;e\u1b41\u1b42\u6acf;\u6ad1\u0100;e\u1b49\u1b4a\u6ad0;\u6ad2dot;\u62ef\u0380delprvw\u1b60\u1b6c\u1b77\u1b82\u1bac\u1bd4\u1bf9arr\u0100lr\u1b68\u1b6a;\u6938;\u6935\u0270\u1b72\0\0\u1b75r;\u62dec;\u62dfarr\u0100;p\u1b7f\u1b80\u61b6;\u693d\u0300;bcdos\u1b8f\u1b90\u1b96\u1ba1\u1ba5\u1ba8\u622arcap;\u6a48\u0100au\u1b9b\u1b9ep;\u6a46p;\u6a4aot;\u628dr;\u6a45;\uc000\u222a\ufe00\u0200alrv\u1bb5\u1bbf\u1bde\u1be3rr\u0100;m\u1bbc\u1bbd\u61b7;\u693cy\u0180evw\u1bc7\u1bd4\u1bd8q\u0270\u1bce\0\0\u1bd2re\xe3\u1b73u\xe3\u1b75ee;\u62ceedge;\u62cfen\u803b\xa4\u40a4earrow\u0100lr\u1bee\u1bf3eft\xbb\u1b80ight\xbb\u1bbde\xe4\u1bdd\u0100ci\u1c01\u1c07onin\xf4\u01f7nt;\u6231lcty;\u632d\u0980AHabcdefhijlorstuwz\u1c38\u1c3b\u1c3f\u1c5d\u1c69\u1c75\u1c8a\u1c9e\u1cac\u1cb7\u1cfb\u1cff\u1d0d\u1d7b\u1d91\u1dab\u1dbb\u1dc6\u1dcdr\xf2\u0381ar;\u6965\u0200glrs\u1c48\u1c4d\u1c52\u1c54ger;\u6020eth;\u6138\xf2\u1133h\u0100;v\u1c5a\u1c5b\u6010\xbb\u090a\u016b\u1c61\u1c67arow;\u690fa\xe3\u0315\u0100ay\u1c6e\u1c73ron;\u410f;\u4434\u0180;ao\u0332\u1c7c\u1c84\u0100gr\u02bf\u1c81r;\u61catseq;\u6a77\u0180glm\u1c91\u1c94\u1c98\u803b\xb0\u40b0ta;\u43b4ptyv;\u69b1\u0100ir\u1ca3\u1ca8sht;\u697f;\uc000\ud835\udd21ar\u0100lr\u1cb3\u1cb5\xbb\u08dc\xbb\u101e\u0280aegsv\u1cc2\u0378\u1cd6\u1cdc\u1ce0m\u0180;os\u0326\u1cca\u1cd4nd\u0100;s\u0326\u1cd1uit;\u6666amma;\u43ddin;\u62f2\u0180;io\u1ce7\u1ce8\u1cf8\u40f7de\u8100\xf7;o\u1ce7\u1cf0ntimes;\u62c7n\xf8\u1cf7cy;\u4452c\u026f\u1d06\0\0\u1d0arn;\u631eop;\u630d\u0280lptuw\u1d18\u1d1d\u1d22\u1d49\u1d55lar;\u4024f;\uc000\ud835\udd55\u0280;emps\u030b\u1d2d\u1d37\u1d3d\u1d42q\u0100;d\u0352\u1d33ot;\u6251inus;\u6238lus;\u6214quare;\u62a1blebarwedg\xe5\xfan\u0180adh\u112e\u1d5d\u1d67ownarrow\xf3\u1c83arpoon\u0100lr\u1d72\u1d76ef\xf4\u1cb4igh\xf4\u1cb6\u0162\u1d7f\u1d85karo\xf7\u0f42\u026f\u1d8a\0\0\u1d8ern;\u631fop;\u630c\u0180cot\u1d98\u1da3\u1da6\u0100ry\u1d9d\u1da1;\uc000\ud835\udcb9;\u4455l;\u69f6rok;\u4111\u0100dr\u1db0\u1db4ot;\u62f1i\u0100;f\u1dba\u1816\u65bf\u0100ah\u1dc0\u1dc3r\xf2\u0429a\xf2\u0fa6angle;\u69a6\u0100ci\u1dd2\u1dd5y;\u445fgrarr;\u67ff\u0900Dacdefglmnopqrstux\u1e01\u1e09\u1e19\u1e38\u0578\u1e3c\u1e49\u1e61\u1e7e\u1ea5\u1eaf\u1ebd\u1ee1\u1f2a\u1f37\u1f44\u1f4e\u1f5a\u0100Do\u1e06\u1d34o\xf4\u1c89\u0100cs\u1e0e\u1e14ute\u803b\xe9\u40e9ter;\u6a6e\u0200aioy\u1e22\u1e27\u1e31\u1e36ron;\u411br\u0100;c\u1e2d\u1e2e\u6256\u803b\xea\u40ealon;\u6255;\u444dot;\u4117\u0100Dr\u1e41\u1e45ot;\u6252;\uc000\ud835\udd22\u0180;rs\u1e50\u1e51\u1e57\u6a9aave\u803b\xe8\u40e8\u0100;d\u1e5c\u1e5d\u6a96ot;\u6a98\u0200;ils\u1e6a\u1e6b\u1e72\u1e74\u6a99nters;\u63e7;\u6113\u0100;d\u1e79\u1e7a\u6a95ot;\u6a97\u0180aps\u1e85\u1e89\u1e97cr;\u4113ty\u0180;sv\u1e92\u1e93\u1e95\u6205et\xbb\u1e93p\u01001;\u1e9d\u1ea4\u0133\u1ea1\u1ea3;\u6004;\u6005\u6003\u0100gs\u1eaa\u1eac;\u414bp;\u6002\u0100gp\u1eb4\u1eb8on;\u4119f;\uc000\ud835\udd56\u0180als\u1ec4\u1ece\u1ed2r\u0100;s\u1eca\u1ecb\u62d5l;\u69e3us;\u6a71i\u0180;lv\u1eda\u1edb\u1edf\u43b5on\xbb\u1edb;\u43f5\u0200csuv\u1eea\u1ef3\u1f0b\u1f23\u0100io\u1eef\u1e31rc\xbb\u1e2e\u0269\u1ef9\0\0\u1efb\xed\u0548ant\u0100gl\u1f02\u1f06tr\xbb\u1e5dess\xbb\u1e7a\u0180aei\u1f12\u1f16\u1f1als;\u403dst;\u625fv\u0100;D\u0235\u1f20D;\u6a78parsl;\u69e5\u0100Da\u1f2f\u1f33ot;\u6253rr;\u6971\u0180cdi\u1f3e\u1f41\u1ef8r;\u612fo\xf4\u0352\u0100ah\u1f49\u1f4b;\u43b7\u803b\xf0\u40f0\u0100mr\u1f53\u1f57l\u803b\xeb\u40ebo;\u60ac\u0180cip\u1f61\u1f64\u1f67l;\u4021s\xf4\u056e\u0100eo\u1f6c\u1f74ctatio\xee\u0559nential\xe5\u0579\u09e1\u1f92\0\u1f9e\0\u1fa1\u1fa7\0\0\u1fc6\u1fcc\0\u1fd3\0\u1fe6\u1fea\u2000\0\u2008\u205allingdotse\xf1\u1e44y;\u4444male;\u6640\u0180ilr\u1fad\u1fb3\u1fc1lig;\u8000\ufb03\u0269\u1fb9\0\0\u1fbdg;\u8000\ufb00ig;\u8000\ufb04;\uc000\ud835\udd23lig;\u8000\ufb01lig;\uc000fj\u0180alt\u1fd9\u1fdc\u1fe1t;\u666dig;\u8000\ufb02ns;\u65b1of;\u4192\u01f0\u1fee\0\u1ff3f;\uc000\ud835\udd57\u0100ak\u05bf\u1ff7\u0100;v\u1ffc\u1ffd\u62d4;\u6ad9artint;\u6a0d\u0100ao\u200c\u2055\u0100cs\u2011\u2052\u03b1\u201a\u2030\u2038\u2045\u2048\0\u2050\u03b2\u2022\u2025\u2027\u202a\u202c\0\u202e\u803b\xbd\u40bd;\u6153\u803b\xbc\u40bc;\u6155;\u6159;\u615b\u01b3\u2034\0\u2036;\u6154;\u6156\u02b4\u203e\u2041\0\0\u2043\u803b\xbe\u40be;\u6157;\u615c5;\u6158\u01b6\u204c\0\u204e;\u615a;\u615d8;\u615el;\u6044wn;\u6322cr;\uc000\ud835\udcbb\u0880Eabcdefgijlnorstv\u2082\u2089\u209f\u20a5\u20b0\u20b4\u20f0\u20f5\u20fa\u20ff\u2103\u2112\u2138\u0317\u213e\u2152\u219e\u0100;l\u064d\u2087;\u6a8c\u0180cmp\u2090\u2095\u209dute;\u41f5ma\u0100;d\u209c\u1cda\u43b3;\u6a86reve;\u411f\u0100iy\u20aa\u20aerc;\u411d;\u4433ot;\u4121\u0200;lqs\u063e\u0642\u20bd\u20c9\u0180;qs\u063e\u064c\u20c4lan\xf4\u0665\u0200;cdl\u0665\u20d2\u20d5\u20e5c;\u6aa9ot\u0100;o\u20dc\u20dd\u6a80\u0100;l\u20e2\u20e3\u6a82;\u6a84\u0100;e\u20ea\u20ed\uc000\u22db\ufe00s;\u6a94r;\uc000\ud835\udd24\u0100;g\u0673\u061bmel;\u6137cy;\u4453\u0200;Eaj\u065a\u210c\u210e\u2110;\u6a92;\u6aa5;\u6aa4\u0200Eaes\u211b\u211d\u2129\u2134;\u6269p\u0100;p\u2123\u2124\u6a8arox\xbb\u2124\u0100;q\u212e\u212f\u6a88\u0100;q\u212e\u211bim;\u62e7pf;\uc000\ud835\udd58\u0100ci\u2143\u2146r;\u610am\u0180;el\u066b\u214e\u2150;\u6a8e;\u6a90\u8300>;cdlqr\u05ee\u2160\u216a\u216e\u2173\u2179\u0100ci\u2165\u2167;\u6aa7r;\u6a7aot;\u62d7Par;\u6995uest;\u6a7c\u0280adels\u2184\u216a\u2190\u0656\u219b\u01f0\u2189\0\u218epro\xf8\u209er;\u6978q\u0100lq\u063f\u2196les\xf3\u2088i\xed\u066b\u0100en\u21a3\u21adrtneqq;\uc000\u2269\ufe00\xc5\u21aa\u0500Aabcefkosy\u21c4\u21c7\u21f1\u21f5\u21fa\u2218\u221d\u222f\u2268\u227dr\xf2\u03a0\u0200ilmr\u21d0\u21d4\u21d7\u21dbrs\xf0\u1484f\xbb\u2024il\xf4\u06a9\u0100dr\u21e0\u21e4cy;\u444a\u0180;cw\u08f4\u21eb\u21efir;\u6948;\u61adar;\u610firc;\u4125\u0180alr\u2201\u220e\u2213rts\u0100;u\u2209\u220a\u6665it\xbb\u220alip;\u6026con;\u62b9r;\uc000\ud835\udd25s\u0100ew\u2223\u2229arow;\u6925arow;\u6926\u0280amopr\u223a\u223e\u2243\u225e\u2263rr;\u61fftht;\u623bk\u0100lr\u2249\u2253eftarrow;\u61a9ightarrow;\u61aaf;\uc000\ud835\udd59bar;\u6015\u0180clt\u226f\u2274\u2278r;\uc000\ud835\udcbdas\xe8\u21f4rok;\u4127\u0100bp\u2282\u2287ull;\u6043hen\xbb\u1c5b\u0ae1\u22a3\0\u22aa\0\u22b8\u22c5\u22ce\0\u22d5\u22f3\0\0\u22f8\u2322\u2367\u2362\u237f\0\u2386\u23aa\u23b4cute\u803b\xed\u40ed\u0180;iy\u0771\u22b0\u22b5rc\u803b\xee\u40ee;\u4438\u0100cx\u22bc\u22bfy;\u4435cl\u803b\xa1\u40a1\u0100fr\u039f\u22c9;\uc000\ud835\udd26rave\u803b\xec\u40ec\u0200;ino\u073e\u22dd\u22e9\u22ee\u0100in\u22e2\u22e6nt;\u6a0ct;\u622dfin;\u69dcta;\u6129lig;\u4133\u0180aop\u22fe\u231a\u231d\u0180cgt\u2305\u2308\u2317r;\u412b\u0180elp\u071f\u230f\u2313in\xe5\u078ear\xf4\u0720h;\u4131f;\u62b7ed;\u41b5\u0280;cfot\u04f4\u232c\u2331\u233d\u2341are;\u6105in\u0100;t\u2338\u2339\u621eie;\u69dddo\xf4\u2319\u0280;celp\u0757\u234c\u2350\u235b\u2361al;\u62ba\u0100gr\u2355\u2359er\xf3\u1563\xe3\u234darhk;\u6a17rod;\u6a3c\u0200cgpt\u236f\u2372\u2376\u237by;\u4451on;\u412ff;\uc000\ud835\udd5aa;\u43b9uest\u803b\xbf\u40bf\u0100ci\u238a\u238fr;\uc000\ud835\udcben\u0280;Edsv\u04f4\u239b\u239d\u23a1\u04f3;\u62f9ot;\u62f5\u0100;v\u23a6\u23a7\u62f4;\u62f3\u0100;i\u0777\u23aelde;\u4129\u01eb\u23b8\0\u23bccy;\u4456l\u803b\xef\u40ef\u0300cfmosu\u23cc\u23d7\u23dc\u23e1\u23e7\u23f5\u0100iy\u23d1\u23d5rc;\u4135;\u4439r;\uc000\ud835\udd27ath;\u4237pf;\uc000\ud835\udd5b\u01e3\u23ec\0\u23f1r;\uc000\ud835\udcbfrcy;\u4458kcy;\u4454\u0400acfghjos\u240b\u2416\u2422\u2427\u242d\u2431\u2435\u243bppa\u0100;v\u2413\u2414\u43ba;\u43f0\u0100ey\u241b\u2420dil;\u4137;\u443ar;\uc000\ud835\udd28reen;\u4138cy;\u4445cy;\u445cpf;\uc000\ud835\udd5ccr;\uc000\ud835\udcc0\u0b80ABEHabcdefghjlmnoprstuv\u2470\u2481\u2486\u248d\u2491\u250e\u253d\u255a\u2580\u264e\u265e\u2665\u2679\u267d\u269a\u26b2\u26d8\u275d\u2768\u278b\u27c0\u2801\u2812\u0180art\u2477\u247a\u247cr\xf2\u09c6\xf2\u0395ail;\u691barr;\u690e\u0100;g\u0994\u248b;\u6a8bar;\u6962\u0963\u24a5\0\u24aa\0\u24b1\0\0\0\0\0\u24b5\u24ba\0\u24c6\u24c8\u24cd\0\u24f9ute;\u413amptyv;\u69b4ra\xee\u084cbda;\u43bbg\u0180;dl\u088e\u24c1\u24c3;\u6991\xe5\u088e;\u6a85uo\u803b\xab\u40abr\u0400;bfhlpst\u0899\u24de\u24e6\u24e9\u24eb\u24ee\u24f1\u24f5\u0100;f\u089d\u24e3s;\u691fs;\u691d\xeb\u2252p;\u61abl;\u6939im;\u6973l;\u61a2\u0180;ae\u24ff\u2500\u2504\u6aabil;\u6919\u0100;s\u2509\u250a\u6aad;\uc000\u2aad\ufe00\u0180abr\u2515\u2519\u251drr;\u690crk;\u6772\u0100ak\u2522\u252cc\u0100ek\u2528\u252a;\u407b;\u405b\u0100es\u2531\u2533;\u698bl\u0100du\u2539\u253b;\u698f;\u698d\u0200aeuy\u2546\u254b\u2556\u2558ron;\u413e\u0100di\u2550\u2554il;\u413c\xec\u08b0\xe2\u2529;\u443b\u0200cqrs\u2563\u2566\u256d\u257da;\u6936uo\u0100;r\u0e19\u1746\u0100du\u2572\u2577har;\u6967shar;\u694bh;\u61b2\u0280;fgqs\u258b\u258c\u0989\u25f3\u25ff\u6264t\u0280ahlrt\u2598\u25a4\u25b7\u25c2\u25e8rrow\u0100;t\u0899\u25a1a\xe9\u24f6arpoon\u0100du\u25af\u25b4own\xbb\u045ap\xbb\u0966eftarrows;\u61c7ight\u0180ahs\u25cd\u25d6\u25derrow\u0100;s\u08f4\u08a7arpoon\xf3\u0f98quigarro\xf7\u21f0hreetimes;\u62cb\u0180;qs\u258b\u0993\u25falan\xf4\u09ac\u0280;cdgs\u09ac\u260a\u260d\u261d\u2628c;\u6aa8ot\u0100;o\u2614\u2615\u6a7f\u0100;r\u261a\u261b\u6a81;\u6a83\u0100;e\u2622\u2625\uc000\u22da\ufe00s;\u6a93\u0280adegs\u2633\u2639\u263d\u2649\u264bppro\xf8\u24c6ot;\u62d6q\u0100gq\u2643\u2645\xf4\u0989gt\xf2\u248c\xf4\u099bi\xed\u09b2\u0180ilr\u2655\u08e1\u265asht;\u697c;\uc000\ud835\udd29\u0100;E\u099c\u2663;\u6a91\u0161\u2669\u2676r\u0100du\u25b2\u266e\u0100;l\u0965\u2673;\u696alk;\u6584cy;\u4459\u0280;acht\u0a48\u2688\u268b\u2691\u2696r\xf2\u25c1orne\xf2\u1d08ard;\u696bri;\u65fa\u0100io\u269f\u26a4dot;\u4140ust\u0100;a\u26ac\u26ad\u63b0che\xbb\u26ad\u0200Eaes\u26bb\u26bd\u26c9\u26d4;\u6268p\u0100;p\u26c3\u26c4\u6a89rox\xbb\u26c4\u0100;q\u26ce\u26cf\u6a87\u0100;q\u26ce\u26bbim;\u62e6\u0400abnoptwz\u26e9\u26f4\u26f7\u271a\u272f\u2741\u2747\u2750\u0100nr\u26ee\u26f1g;\u67ecr;\u61fdr\xeb\u08c1g\u0180lmr\u26ff\u270d\u2714eft\u0100ar\u09e6\u2707ight\xe1\u09f2apsto;\u67fcight\xe1\u09fdparrow\u0100lr\u2725\u2729ef\xf4\u24edight;\u61ac\u0180afl\u2736\u2739\u273dr;\u6985;\uc000\ud835\udd5dus;\u6a2dimes;\u6a34\u0161\u274b\u274fst;\u6217\xe1\u134e\u0180;ef\u2757\u2758\u1800\u65cange\xbb\u2758ar\u0100;l\u2764\u2765\u4028t;\u6993\u0280achmt\u2773\u2776\u277c\u2785\u2787r\xf2\u08a8orne\xf2\u1d8car\u0100;d\u0f98\u2783;\u696d;\u600eri;\u62bf\u0300achiqt\u2798\u279d\u0a40\u27a2\u27ae\u27bbquo;\u6039r;\uc000\ud835\udcc1m\u0180;eg\u09b2\u27aa\u27ac;\u6a8d;\u6a8f\u0100bu\u252a\u27b3o\u0100;r\u0e1f\u27b9;\u601arok;\u4142\u8400<;cdhilqr\u082b\u27d2\u2639\u27dc\u27e0\u27e5\u27ea\u27f0\u0100ci\u27d7\u27d9;\u6aa6r;\u6a79re\xe5\u25f2mes;\u62c9arr;\u6976uest;\u6a7b\u0100Pi\u27f5\u27f9ar;\u6996\u0180;ef\u2800\u092d\u181b\u65c3r\u0100du\u2807\u280dshar;\u694ahar;\u6966\u0100en\u2817\u2821rtneqq;\uc000\u2268\ufe00\xc5\u281e\u0700Dacdefhilnopsu\u2840\u2845\u2882\u288e\u2893\u28a0\u28a5\u28a8\u28da\u28e2\u28e4\u0a83\u28f3\u2902Dot;\u623a\u0200clpr\u284e\u2852\u2863\u287dr\u803b\xaf\u40af\u0100et\u2857\u2859;\u6642\u0100;e\u285e\u285f\u6720se\xbb\u285f\u0100;s\u103b\u2868to\u0200;dlu\u103b\u2873\u2877\u287bow\xee\u048cef\xf4\u090f\xf0\u13d1ker;\u65ae\u0100oy\u2887\u288cmma;\u6a29;\u443cash;\u6014asuredangle\xbb\u1626r;\uc000\ud835\udd2ao;\u6127\u0180cdn\u28af\u28b4\u28c9ro\u803b\xb5\u40b5\u0200;acd\u1464\u28bd\u28c0\u28c4s\xf4\u16a7ir;\u6af0ot\u80bb\xb7\u01b5us\u0180;bd\u28d2\u1903\u28d3\u6212\u0100;u\u1d3c\u28d8;\u6a2a\u0163\u28de\u28e1p;\u6adb\xf2\u2212\xf0\u0a81\u0100dp\u28e9\u28eeels;\u62a7f;\uc000\ud835\udd5e\u0100ct\u28f8\u28fdr;\uc000\ud835\udcc2pos\xbb\u159d\u0180;lm\u2909\u290a\u290d\u43bctimap;\u62b8\u0c00GLRVabcdefghijlmoprstuvw\u2942\u2953\u297e\u2989\u2998\u29da\u29e9\u2a15\u2a1a\u2a58\u2a5d\u2a83\u2a95\u2aa4\u2aa8\u2b04\u2b07\u2b44\u2b7f\u2bae\u2c34\u2c67\u2c7c\u2ce9\u0100gt\u2947\u294b;\uc000\u22d9\u0338\u0100;v\u2950\u0bcf\uc000\u226b\u20d2\u0180elt\u295a\u2972\u2976ft\u0100ar\u2961\u2967rrow;\u61cdightarrow;\u61ce;\uc000\u22d8\u0338\u0100;v\u297b\u0c47\uc000\u226a\u20d2ightarrow;\u61cf\u0100Dd\u298e\u2993ash;\u62afash;\u62ae\u0280bcnpt\u29a3\u29a7\u29ac\u29b1\u29ccla\xbb\u02deute;\u4144g;\uc000\u2220\u20d2\u0280;Eiop\u0d84\u29bc\u29c0\u29c5\u29c8;\uc000\u2a70\u0338d;\uc000\u224b\u0338s;\u4149ro\xf8\u0d84ur\u0100;a\u29d3\u29d4\u666el\u0100;s\u29d3\u0b38\u01f3\u29df\0\u29e3p\u80bb\xa0\u0b37mp\u0100;e\u0bf9\u0c00\u0280aeouy\u29f4\u29fe\u2a03\u2a10\u2a13\u01f0\u29f9\0\u29fb;\u6a43on;\u4148dil;\u4146ng\u0100;d\u0d7e\u2a0aot;\uc000\u2a6d\u0338p;\u6a42;\u443dash;\u6013\u0380;Aadqsx\u0b92\u2a29\u2a2d\u2a3b\u2a41\u2a45\u2a50rr;\u61d7r\u0100hr\u2a33\u2a36k;\u6924\u0100;o\u13f2\u13f0ot;\uc000\u2250\u0338ui\xf6\u0b63\u0100ei\u2a4a\u2a4ear;\u6928\xed\u0b98ist\u0100;s\u0ba0\u0b9fr;\uc000\ud835\udd2b\u0200Eest\u0bc5\u2a66\u2a79\u2a7c\u0180;qs\u0bbc\u2a6d\u0be1\u0180;qs\u0bbc\u0bc5\u2a74lan\xf4\u0be2i\xed\u0bea\u0100;r\u0bb6\u2a81\xbb\u0bb7\u0180Aap\u2a8a\u2a8d\u2a91r\xf2\u2971rr;\u61aear;\u6af2\u0180;sv\u0f8d\u2a9c\u0f8c\u0100;d\u2aa1\u2aa2\u62fc;\u62facy;\u445a\u0380AEadest\u2ab7\u2aba\u2abe\u2ac2\u2ac5\u2af6\u2af9r\xf2\u2966;\uc000\u2266\u0338rr;\u619ar;\u6025\u0200;fqs\u0c3b\u2ace\u2ae3\u2aeft\u0100ar\u2ad4\u2ad9rro\xf7\u2ac1ightarro\xf7\u2a90\u0180;qs\u0c3b\u2aba\u2aealan\xf4\u0c55\u0100;s\u0c55\u2af4\xbb\u0c36i\xed\u0c5d\u0100;r\u0c35\u2afei\u0100;e\u0c1a\u0c25i\xe4\u0d90\u0100pt\u2b0c\u2b11f;\uc000\ud835\udd5f\u8180\xac;in\u2b19\u2b1a\u2b36\u40acn\u0200;Edv\u0b89\u2b24\u2b28\u2b2e;\uc000\u22f9\u0338ot;\uc000\u22f5\u0338\u01e1\u0b89\u2b33\u2b35;\u62f7;\u62f6i\u0100;v\u0cb8\u2b3c\u01e1\u0cb8\u2b41\u2b43;\u62fe;\u62fd\u0180aor\u2b4b\u2b63\u2b69r\u0200;ast\u0b7b\u2b55\u2b5a\u2b5flle\xec\u0b7bl;\uc000\u2afd\u20e5;\uc000\u2202\u0338lint;\u6a14\u0180;ce\u0c92\u2b70\u2b73u\xe5\u0ca5\u0100;c\u0c98\u2b78\u0100;e\u0c92\u2b7d\xf1\u0c98\u0200Aait\u2b88\u2b8b\u2b9d\u2ba7r\xf2\u2988rr\u0180;cw\u2b94\u2b95\u2b99\u619b;\uc000\u2933\u0338;\uc000\u219d\u0338ghtarrow\xbb\u2b95ri\u0100;e\u0ccb\u0cd6\u0380chimpqu\u2bbd\u2bcd\u2bd9\u2b04\u0b78\u2be4\u2bef\u0200;cer\u0d32\u2bc6\u0d37\u2bc9u\xe5\u0d45;\uc000\ud835\udcc3ort\u026d\u2b05\0\0\u2bd6ar\xe1\u2b56m\u0100;e\u0d6e\u2bdf\u0100;q\u0d74\u0d73su\u0100bp\u2beb\u2bed\xe5\u0cf8\xe5\u0d0b\u0180bcp\u2bf6\u2c11\u2c19\u0200;Ees\u2bff\u2c00\u0d22\u2c04\u6284;\uc000\u2ac5\u0338et\u0100;e\u0d1b\u2c0bq\u0100;q\u0d23\u2c00c\u0100;e\u0d32\u2c17\xf1\u0d38\u0200;Ees\u2c22\u2c23\u0d5f\u2c27\u6285;\uc000\u2ac6\u0338et\u0100;e\u0d58\u2c2eq\u0100;q\u0d60\u2c23\u0200gilr\u2c3d\u2c3f\u2c45\u2c47\xec\u0bd7lde\u803b\xf1\u40f1\xe7\u0c43iangle\u0100lr\u2c52\u2c5ceft\u0100;e\u0c1a\u2c5a\xf1\u0c26ight\u0100;e\u0ccb\u2c65\xf1\u0cd7\u0100;m\u2c6c\u2c6d\u43bd\u0180;es\u2c74\u2c75\u2c79\u4023ro;\u6116p;\u6007\u0480DHadgilrs\u2c8f\u2c94\u2c99\u2c9e\u2ca3\u2cb0\u2cb6\u2cd3\u2ce3ash;\u62adarr;\u6904p;\uc000\u224d\u20d2ash;\u62ac\u0100et\u2ca8\u2cac;\uc000\u2265\u20d2;\uc000>\u20d2nfin;\u69de\u0180Aet\u2cbd\u2cc1\u2cc5rr;\u6902;\uc000\u2264\u20d2\u0100;r\u2cca\u2ccd\uc000<\u20d2ie;\uc000\u22b4\u20d2\u0100At\u2cd8\u2cdcrr;\u6903rie;\uc000\u22b5\u20d2im;\uc000\u223c\u20d2\u0180Aan\u2cf0\u2cf4\u2d02rr;\u61d6r\u0100hr\u2cfa\u2cfdk;\u6923\u0100;o\u13e7\u13e5ear;\u6927\u1253\u1a95\0\0\0\0\0\0\0\0\0\0\0\0\0\u2d2d\0\u2d38\u2d48\u2d60\u2d65\u2d72\u2d84\u1b07\0\0\u2d8d\u2dab\0\u2dc8\u2dce\0\u2ddc\u2e19\u2e2b\u2e3e\u2e43\u0100cs\u2d31\u1a97ute\u803b\xf3\u40f3\u0100iy\u2d3c\u2d45r\u0100;c\u1a9e\u2d42\u803b\xf4\u40f4;\u443e\u0280abios\u1aa0\u2d52\u2d57\u01c8\u2d5alac;\u4151v;\u6a38old;\u69bclig;\u4153\u0100cr\u2d69\u2d6dir;\u69bf;\uc000\ud835\udd2c\u036f\u2d79\0\0\u2d7c\0\u2d82n;\u42dbave\u803b\xf2\u40f2;\u69c1\u0100bm\u2d88\u0df4ar;\u69b5\u0200acit\u2d95\u2d98\u2da5\u2da8r\xf2\u1a80\u0100ir\u2d9d\u2da0r;\u69beoss;\u69bbn\xe5\u0e52;\u69c0\u0180aei\u2db1\u2db5\u2db9cr;\u414dga;\u43c9\u0180cdn\u2dc0\u2dc5\u01cdron;\u43bf;\u69b6pf;\uc000\ud835\udd60\u0180ael\u2dd4\u2dd7\u01d2r;\u69b7rp;\u69b9\u0380;adiosv\u2dea\u2deb\u2dee\u2e08\u2e0d\u2e10\u2e16\u6228r\xf2\u1a86\u0200;efm\u2df7\u2df8\u2e02\u2e05\u6a5dr\u0100;o\u2dfe\u2dff\u6134f\xbb\u2dff\u803b\xaa\u40aa\u803b\xba\u40bagof;\u62b6r;\u6a56lope;\u6a57;\u6a5b\u0180clo\u2e1f\u2e21\u2e27\xf2\u2e01ash\u803b\xf8\u40f8l;\u6298i\u016c\u2e2f\u2e34de\u803b\xf5\u40f5es\u0100;a\u01db\u2e3as;\u6a36ml\u803b\xf6\u40f6bar;\u633d\u0ae1\u2e5e\0\u2e7d\0\u2e80\u2e9d\0\u2ea2\u2eb9\0\0\u2ecb\u0e9c\0\u2f13\0\0\u2f2b\u2fbc\0\u2fc8r\u0200;ast\u0403\u2e67\u2e72\u0e85\u8100\xb6;l\u2e6d\u2e6e\u40b6le\xec\u0403\u0269\u2e78\0\0\u2e7bm;\u6af3;\u6afdy;\u443fr\u0280cimpt\u2e8b\u2e8f\u2e93\u1865\u2e97nt;\u4025od;\u402eil;\u6030enk;\u6031r;\uc000\ud835\udd2d\u0180imo\u2ea8\u2eb0\u2eb4\u0100;v\u2ead\u2eae\u43c6;\u43d5ma\xf4\u0a76ne;\u660e\u0180;tv\u2ebf\u2ec0\u2ec8\u43c0chfork\xbb\u1ffd;\u43d6\u0100au\u2ecf\u2edfn\u0100ck\u2ed5\u2eddk\u0100;h\u21f4\u2edb;\u610e\xf6\u21f4s\u0480;abcdemst\u2ef3\u2ef4\u1908\u2ef9\u2efd\u2f04\u2f06\u2f0a\u2f0e\u402bcir;\u6a23ir;\u6a22\u0100ou\u1d40\u2f02;\u6a25;\u6a72n\u80bb\xb1\u0e9dim;\u6a26wo;\u6a27\u0180ipu\u2f19\u2f20\u2f25ntint;\u6a15f;\uc000\ud835\udd61nd\u803b\xa3\u40a3\u0500;Eaceinosu\u0ec8\u2f3f\u2f41\u2f44\u2f47\u2f81\u2f89\u2f92\u2f7e\u2fb6;\u6ab3p;\u6ab7u\xe5\u0ed9\u0100;c\u0ece\u2f4c\u0300;acens\u0ec8\u2f59\u2f5f\u2f66\u2f68\u2f7eppro\xf8\u2f43urlye\xf1\u0ed9\xf1\u0ece\u0180aes\u2f6f\u2f76\u2f7approx;\u6ab9qq;\u6ab5im;\u62e8i\xed\u0edfme\u0100;s\u2f88\u0eae\u6032\u0180Eas\u2f78\u2f90\u2f7a\xf0\u2f75\u0180dfp\u0eec\u2f99\u2faf\u0180als\u2fa0\u2fa5\u2faalar;\u632eine;\u6312urf;\u6313\u0100;t\u0efb\u2fb4\xef\u0efbrel;\u62b0\u0100ci\u2fc0\u2fc5r;\uc000\ud835\udcc5;\u43c8ncsp;\u6008\u0300fiopsu\u2fda\u22e2\u2fdf\u2fe5\u2feb\u2ff1r;\uc000\ud835\udd2epf;\uc000\ud835\udd62rime;\u6057cr;\uc000\ud835\udcc6\u0180aeo\u2ff8\u3009\u3013t\u0100ei\u2ffe\u3005rnion\xf3\u06b0nt;\u6a16st\u0100;e\u3010\u3011\u403f\xf1\u1f19\xf4\u0f14\u0a80ABHabcdefhilmnoprstux\u3040\u3051\u3055\u3059\u30e0\u310e\u312b\u3147\u3162\u3172\u318e\u3206\u3215\u3224\u3229\u3258\u326e\u3272\u3290\u32b0\u32b7\u0180art\u3047\u304a\u304cr\xf2\u10b3\xf2\u03ddail;\u691car\xf2\u1c65ar;\u6964\u0380cdenqrt\u3068\u3075\u3078\u307f\u308f\u3094\u30cc\u0100eu\u306d\u3071;\uc000\u223d\u0331te;\u4155i\xe3\u116emptyv;\u69b3g\u0200;del\u0fd1\u3089\u308b\u308d;\u6992;\u69a5\xe5\u0fd1uo\u803b\xbb\u40bbr\u0580;abcfhlpstw\u0fdc\u30ac\u30af\u30b7\u30b9\u30bc\u30be\u30c0\u30c3\u30c7\u30cap;\u6975\u0100;f\u0fe0\u30b4s;\u6920;\u6933s;\u691e\xeb\u225d\xf0\u272el;\u6945im;\u6974l;\u61a3;\u619d\u0100ai\u30d1\u30d5il;\u691ao\u0100;n\u30db\u30dc\u6236al\xf3\u0f1e\u0180abr\u30e7\u30ea\u30eer\xf2\u17e5rk;\u6773\u0100ak\u30f3\u30fdc\u0100ek\u30f9\u30fb;\u407d;\u405d\u0100es\u3102\u3104;\u698cl\u0100du\u310a\u310c;\u698e;\u6990\u0200aeuy\u3117\u311c\u3127\u3129ron;\u4159\u0100di\u3121\u3125il;\u4157\xec\u0ff2\xe2\u30fa;\u4440\u0200clqs\u3134\u3137\u313d\u3144a;\u6937dhar;\u6969uo\u0100;r\u020e\u020dh;\u61b3\u0180acg\u314e\u315f\u0f44l\u0200;ips\u0f78\u3158\u315b\u109cn\xe5\u10bbar\xf4\u0fa9t;\u65ad\u0180ilr\u3169\u1023\u316esht;\u697d;\uc000\ud835\udd2f\u0100ao\u3177\u3186r\u0100du\u317d\u317f\xbb\u047b\u0100;l\u1091\u3184;\u696c\u0100;v\u318b\u318c\u43c1;\u43f1\u0180gns\u3195\u31f9\u31fcht\u0300ahlrst\u31a4\u31b0\u31c2\u31d8\u31e4\u31eerrow\u0100;t\u0fdc\u31ada\xe9\u30c8arpoon\u0100du\u31bb\u31bfow\xee\u317ep\xbb\u1092eft\u0100ah\u31ca\u31d0rrow\xf3\u0feaarpoon\xf3\u0551ightarrows;\u61c9quigarro\xf7\u30cbhreetimes;\u62ccg;\u42daingdotse\xf1\u1f32\u0180ahm\u320d\u3210\u3213r\xf2\u0feaa\xf2\u0551;\u600foust\u0100;a\u321e\u321f\u63b1che\xbb\u321fmid;\u6aee\u0200abpt\u3232\u323d\u3240\u3252\u0100nr\u3237\u323ag;\u67edr;\u61fer\xeb\u1003\u0180afl\u3247\u324a\u324er;\u6986;\uc000\ud835\udd63us;\u6a2eimes;\u6a35\u0100ap\u325d\u3267r\u0100;g\u3263\u3264\u4029t;\u6994olint;\u6a12ar\xf2\u31e3\u0200achq\u327b\u3280\u10bc\u3285quo;\u603ar;\uc000\ud835\udcc7\u0100bu\u30fb\u328ao\u0100;r\u0214\u0213\u0180hir\u3297\u329b\u32a0re\xe5\u31f8mes;\u62cai\u0200;efl\u32aa\u1059\u1821\u32ab\u65b9tri;\u69celuhar;\u6968;\u611e\u0d61\u32d5\u32db\u32df\u332c\u3338\u3371\0\u337a\u33a4\0\0\u33ec\u33f0\0\u3428\u3448\u345a\u34ad\u34b1\u34ca\u34f1\0\u3616\0\0\u3633cute;\u415bqu\xef\u27ba\u0500;Eaceinpsy\u11ed\u32f3\u32f5\u32ff\u3302\u330b\u330f\u331f\u3326\u3329;\u6ab4\u01f0\u32fa\0\u32fc;\u6ab8on;\u4161u\xe5\u11fe\u0100;d\u11f3\u3307il;\u415frc;\u415d\u0180Eas\u3316\u3318\u331b;\u6ab6p;\u6abaim;\u62e9olint;\u6a13i\xed\u1204;\u4441ot\u0180;be\u3334\u1d47\u3335\u62c5;\u6a66\u0380Aacmstx\u3346\u334a\u3357\u335b\u335e\u3363\u336drr;\u61d8r\u0100hr\u3350\u3352\xeb\u2228\u0100;o\u0a36\u0a34t\u803b\xa7\u40a7i;\u403bwar;\u6929m\u0100in\u3369\xf0nu\xf3\xf1t;\u6736r\u0100;o\u3376\u2055\uc000\ud835\udd30\u0200acoy\u3382\u3386\u3391\u33a0rp;\u666f\u0100hy\u338b\u338fcy;\u4449;\u4448rt\u026d\u3399\0\0\u339ci\xe4\u1464ara\xec\u2e6f\u803b\xad\u40ad\u0100gm\u33a8\u33b4ma\u0180;fv\u33b1\u33b2\u33b2\u43c3;\u43c2\u0400;deglnpr\u12ab\u33c5\u33c9\u33ce\u33d6\u33de\u33e1\u33e6ot;\u6a6a\u0100;q\u12b1\u12b0\u0100;E\u33d3\u33d4\u6a9e;\u6aa0\u0100;E\u33db\u33dc\u6a9d;\u6a9fe;\u6246lus;\u6a24arr;\u6972ar\xf2\u113d\u0200aeit\u33f8\u3408\u340f\u3417\u0100ls\u33fd\u3404lsetm\xe9\u336ahp;\u6a33parsl;\u69e4\u0100dl\u1463\u3414e;\u6323\u0100;e\u341c\u341d\u6aaa\u0100;s\u3422\u3423\u6aac;\uc000\u2aac\ufe00\u0180flp\u342e\u3433\u3442tcy;\u444c\u0100;b\u3438\u3439\u402f\u0100;a\u343e\u343f\u69c4r;\u633ff;\uc000\ud835\udd64a\u0100dr\u344d\u0402es\u0100;u\u3454\u3455\u6660it\xbb\u3455\u0180csu\u3460\u3479\u349f\u0100au\u3465\u346fp\u0100;s\u1188\u346b;\uc000\u2293\ufe00p\u0100;s\u11b4\u3475;\uc000\u2294\ufe00u\u0100bp\u347f\u348f\u0180;es\u1197\u119c\u3486et\u0100;e\u1197\u348d\xf1\u119d\u0180;es\u11a8\u11ad\u3496et\u0100;e\u11a8\u349d\xf1\u11ae\u0180;af\u117b\u34a6\u05b0r\u0165\u34ab\u05b1\xbb\u117car\xf2\u1148\u0200cemt\u34b9\u34be\u34c2\u34c5r;\uc000\ud835\udcc8tm\xee\xf1i\xec\u3415ar\xe6\u11be\u0100ar\u34ce\u34d5r\u0100;f\u34d4\u17bf\u6606\u0100an\u34da\u34edight\u0100ep\u34e3\u34eapsilo\xee\u1ee0h\xe9\u2eafs\xbb\u2852\u0280bcmnp\u34fb\u355e\u1209\u358b\u358e\u0480;Edemnprs\u350e\u350f\u3511\u3515\u351e\u3523\u352c\u3531\u3536\u6282;\u6ac5ot;\u6abd\u0100;d\u11da\u351aot;\u6ac3ult;\u6ac1\u0100Ee\u3528\u352a;\u6acb;\u628alus;\u6abfarr;\u6979\u0180eiu\u353d\u3552\u3555t\u0180;en\u350e\u3545\u354bq\u0100;q\u11da\u350feq\u0100;q\u352b\u3528m;\u6ac7\u0100bp\u355a\u355c;\u6ad5;\u6ad3c\u0300;acens\u11ed\u356c\u3572\u3579\u357b\u3326ppro\xf8\u32faurlye\xf1\u11fe\xf1\u11f3\u0180aes\u3582\u3588\u331bppro\xf8\u331aq\xf1\u3317g;\u666a\u0680123;Edehlmnps\u35a9\u35ac\u35af\u121c\u35b2\u35b4\u35c0\u35c9\u35d5\u35da\u35df\u35e8\u35ed\u803b\xb9\u40b9\u803b\xb2\u40b2\u803b\xb3\u40b3;\u6ac6\u0100os\u35b9\u35bct;\u6abeub;\u6ad8\u0100;d\u1222\u35c5ot;\u6ac4s\u0100ou\u35cf\u35d2l;\u67c9b;\u6ad7arr;\u697bult;\u6ac2\u0100Ee\u35e4\u35e6;\u6acc;\u628blus;\u6ac0\u0180eiu\u35f4\u3609\u360ct\u0180;en\u121c\u35fc\u3602q\u0100;q\u1222\u35b2eq\u0100;q\u35e7\u35e4m;\u6ac8\u0100bp\u3611\u3613;\u6ad4;\u6ad6\u0180Aan\u361c\u3620\u362drr;\u61d9r\u0100hr\u3626\u3628\xeb\u222e\u0100;o\u0a2b\u0a29war;\u692alig\u803b\xdf\u40df\u0be1\u3651\u365d\u3660\u12ce\u3673\u3679\0\u367e\u36c2\0\0\0\0\0\u36db\u3703\0\u3709\u376c\0\0\0\u3787\u0272\u3656\0\0\u365bget;\u6316;\u43c4r\xeb\u0e5f\u0180aey\u3666\u366b\u3670ron;\u4165dil;\u4163;\u4442lrec;\u6315r;\uc000\ud835\udd31\u0200eiko\u3686\u369d\u36b5\u36bc\u01f2\u368b\0\u3691e\u01004f\u1284\u1281a\u0180;sv\u3698\u3699\u369b\u43b8ym;\u43d1\u0100cn\u36a2\u36b2k\u0100as\u36a8\u36aeppro\xf8\u12c1im\xbb\u12acs\xf0\u129e\u0100as\u36ba\u36ae\xf0\u12c1rn\u803b\xfe\u40fe\u01ec\u031f\u36c6\u22e7es\u8180\xd7;bd\u36cf\u36d0\u36d8\u40d7\u0100;a\u190f\u36d5r;\u6a31;\u6a30\u0180eps\u36e1\u36e3\u3700\xe1\u2a4d\u0200;bcf\u0486\u36ec\u36f0\u36f4ot;\u6336ir;\u6af1\u0100;o\u36f9\u36fc\uc000\ud835\udd65rk;\u6ada\xe1\u3362rime;\u6034\u0180aip\u370f\u3712\u3764d\xe5\u1248\u0380adempst\u3721\u374d\u3740\u3751\u3757\u375c\u375fngle\u0280;dlqr\u3730\u3731\u3736\u3740\u3742\u65b5own\xbb\u1dbbeft\u0100;e\u2800\u373e\xf1\u092e;\u625cight\u0100;e\u32aa\u374b\xf1\u105aot;\u65ecinus;\u6a3alus;\u6a39b;\u69cdime;\u6a3bezium;\u63e2\u0180cht\u3772\u377d\u3781\u0100ry\u3777\u377b;\uc000\ud835\udcc9;\u4446cy;\u445brok;\u4167\u0100io\u378b\u378ex\xf4\u1777head\u0100lr\u3797\u37a0eftarro\xf7\u084fightarrow\xbb\u0f5d\u0900AHabcdfghlmoprstuw\u37d0\u37d3\u37d7\u37e4\u37f0\u37fc\u380e\u381c\u3823\u3834\u3851\u385d\u386b\u38a9\u38cc\u38d2\u38ea\u38f6r\xf2\u03edar;\u6963\u0100cr\u37dc\u37e2ute\u803b\xfa\u40fa\xf2\u1150r\u01e3\u37ea\0\u37edy;\u445eve;\u416d\u0100iy\u37f5\u37farc\u803b\xfb\u40fb;\u4443\u0180abh\u3803\u3806\u380br\xf2\u13adlac;\u4171a\xf2\u13c3\u0100ir\u3813\u3818sht;\u697e;\uc000\ud835\udd32rave\u803b\xf9\u40f9\u0161\u3827\u3831r\u0100lr\u382c\u382e\xbb\u0957\xbb\u1083lk;\u6580\u0100ct\u3839\u384d\u026f\u383f\0\0\u384arn\u0100;e\u3845\u3846\u631cr\xbb\u3846op;\u630fri;\u65f8\u0100al\u3856\u385acr;\u416b\u80bb\xa8\u0349\u0100gp\u3862\u3866on;\u4173f;\uc000\ud835\udd66\u0300adhlsu\u114b\u3878\u387d\u1372\u3891\u38a0own\xe1\u13b3arpoon\u0100lr\u3888\u388cef\xf4\u382digh\xf4\u382fi\u0180;hl\u3899\u389a\u389c\u43c5\xbb\u13faon\xbb\u389aparrows;\u61c8\u0180cit\u38b0\u38c4\u38c8\u026f\u38b6\0\0\u38c1rn\u0100;e\u38bc\u38bd\u631dr\xbb\u38bdop;\u630eng;\u416fri;\u65f9cr;\uc000\ud835\udcca\u0180dir\u38d9\u38dd\u38e2ot;\u62f0lde;\u4169i\u0100;f\u3730\u38e8\xbb\u1813\u0100am\u38ef\u38f2r\xf2\u38a8l\u803b\xfc\u40fcangle;\u69a7\u0780ABDacdeflnoprsz\u391c\u391f\u3929\u392d\u39b5\u39b8\u39bd\u39df\u39e4\u39e8\u39f3\u39f9\u39fd\u3a01\u3a20r\xf2\u03f7ar\u0100;v\u3926\u3927\u6ae8;\u6ae9as\xe8\u03e1\u0100nr\u3932\u3937grt;\u699c\u0380eknprst\u34e3\u3946\u394b\u3952\u395d\u3964\u3996app\xe1\u2415othin\xe7\u1e96\u0180hir\u34eb\u2ec8\u3959op\xf4\u2fb5\u0100;h\u13b7\u3962\xef\u318d\u0100iu\u3969\u396dgm\xe1\u33b3\u0100bp\u3972\u3984setneq\u0100;q\u397d\u3980\uc000\u228a\ufe00;\uc000\u2acb\ufe00setneq\u0100;q\u398f\u3992\uc000\u228b\ufe00;\uc000\u2acc\ufe00\u0100hr\u399b\u399fet\xe1\u369ciangle\u0100lr\u39aa\u39afeft\xbb\u0925ight\xbb\u1051y;\u4432ash\xbb\u1036\u0180elr\u39c4\u39d2\u39d7\u0180;be\u2dea\u39cb\u39cfar;\u62bbq;\u625alip;\u62ee\u0100bt\u39dc\u1468a\xf2\u1469r;\uc000\ud835\udd33tr\xe9\u39aesu\u0100bp\u39ef\u39f1\xbb\u0d1c\xbb\u0d59pf;\uc000\ud835\udd67ro\xf0\u0efbtr\xe9\u39b4\u0100cu\u3a06\u3a0br;\uc000\ud835\udccb\u0100bp\u3a10\u3a18n\u0100Ee\u3980\u3a16\xbb\u397en\u0100Ee\u3992\u3a1e\xbb\u3990igzag;\u699a\u0380cefoprs\u3a36\u3a3b\u3a56\u3a5b\u3a54\u3a61\u3a6airc;\u4175\u0100di\u3a40\u3a51\u0100bg\u3a45\u3a49ar;\u6a5fe\u0100;q\u15fa\u3a4f;\u6259erp;\u6118r;\uc000\ud835\udd34pf;\uc000\ud835\udd68\u0100;e\u1479\u3a66at\xe8\u1479cr;\uc000\ud835\udccc\u0ae3\u178e\u3a87\0\u3a8b\0\u3a90\u3a9b\0\0\u3a9d\u3aa8\u3aab\u3aaf\0\0\u3ac3\u3ace\0\u3ad8\u17dc\u17dftr\xe9\u17d1r;\uc000\ud835\udd35\u0100Aa\u3a94\u3a97r\xf2\u03c3r\xf2\u09f6;\u43be\u0100Aa\u3aa1\u3aa4r\xf2\u03b8r\xf2\u09eba\xf0\u2713is;\u62fb\u0180dpt\u17a4\u3ab5\u3abe\u0100fl\u3aba\u17a9;\uc000\ud835\udd69im\xe5\u17b2\u0100Aa\u3ac7\u3acar\xf2\u03cer\xf2\u0a01\u0100cq\u3ad2\u17b8r;\uc000\ud835\udccd\u0100pt\u17d6\u3adcr\xe9\u17d4\u0400acefiosu\u3af0\u3afd\u3b08\u3b0c\u3b11\u3b15\u3b1b\u3b21c\u0100uy\u3af6\u3afbte\u803b\xfd\u40fd;\u444f\u0100iy\u3b02\u3b06rc;\u4177;\u444bn\u803b\xa5\u40a5r;\uc000\ud835\udd36cy;\u4457pf;\uc000\ud835\udd6acr;\uc000\ud835\udcce\u0100cm\u3b26\u3b29y;\u444el\u803b\xff\u40ff\u0500acdefhiosw\u3b42\u3b48\u3b54\u3b58\u3b64\u3b69\u3b6d\u3b74\u3b7a\u3b80cute;\u417a\u0100ay\u3b4d\u3b52ron;\u417e;\u4437ot;\u417c\u0100et\u3b5d\u3b61tr\xe6\u155fa;\u43b6r;\uc000\ud835\udd37cy;\u4436grarr;\u61ddpf;\uc000\ud835\udd6bcr;\uc000\ud835\udccf\u0100jn\u3b85\u3b87;\u600dj;\u600c"
    .split("")
    .map((c) => c.charCodeAt(0)));

// Generated using scripts/write-decode-map.ts
var xmlDecodeTree = new Uint16Array(
// prettier-ignore
"\u0200aglq\t\x15\x18\x1b\u026d\x0f\0\0\x12p;\u4026os;\u4027t;\u403et;\u403cuot;\u4022"
    .split("")
    .map((c) => c.charCodeAt(0)));

// Adapted from https://github.com/mathiasbynens/he/blob/36afe179392226cf1b6ccdb16ebbb7a5a844d93a/src/he.js#L106-L134
var _a;
const decodeMap = new Map([
    [0, 65533],
    // C1 Unicode control character reference replacements
    [128, 8364],
    [130, 8218],
    [131, 402],
    [132, 8222],
    [133, 8230],
    [134, 8224],
    [135, 8225],
    [136, 710],
    [137, 8240],
    [138, 352],
    [139, 8249],
    [140, 338],
    [142, 381],
    [145, 8216],
    [146, 8217],
    [147, 8220],
    [148, 8221],
    [149, 8226],
    [150, 8211],
    [151, 8212],
    [152, 732],
    [153, 8482],
    [154, 353],
    [155, 8250],
    [156, 339],
    [158, 382],
    [159, 376],
]);
/**
 * Polyfill for `String.fromCodePoint`. It is used to create a string from a Unicode code point.
 */
const fromCodePoint$1 = 
// eslint-disable-next-line @typescript-eslint/no-unnecessary-condition, node/no-unsupported-features/es-builtins
(_a = String.fromCodePoint) !== null && _a !== void 0 ? _a : function (codePoint) {
    let output = "";
    if (codePoint > 0xffff) {
        codePoint -= 0x10000;
        output += String.fromCharCode(((codePoint >>> 10) & 0x3ff) | 0xd800);
        codePoint = 0xdc00 | (codePoint & 0x3ff);
    }
    output += String.fromCharCode(codePoint);
    return output;
};
/**
 * Replace the given code point with a replacement character if it is a
 * surrogate or is outside the valid range. Otherwise return the code
 * point unchanged.
 */
function replaceCodePoint(codePoint) {
    var _a;
    if ((codePoint >= 0xd800 && codePoint <= 0xdfff) || codePoint > 0x10ffff) {
        return 0xfffd;
    }
    return (_a = decodeMap.get(codePoint)) !== null && _a !== void 0 ? _a : codePoint;
}

var CharCodes$1;
(function (CharCodes) {
    CharCodes[CharCodes["NUM"] = 35] = "NUM";
    CharCodes[CharCodes["SEMI"] = 59] = "SEMI";
    CharCodes[CharCodes["EQUALS"] = 61] = "EQUALS";
    CharCodes[CharCodes["ZERO"] = 48] = "ZERO";
    CharCodes[CharCodes["NINE"] = 57] = "NINE";
    CharCodes[CharCodes["LOWER_A"] = 97] = "LOWER_A";
    CharCodes[CharCodes["LOWER_F"] = 102] = "LOWER_F";
    CharCodes[CharCodes["LOWER_X"] = 120] = "LOWER_X";
    CharCodes[CharCodes["LOWER_Z"] = 122] = "LOWER_Z";
    CharCodes[CharCodes["UPPER_A"] = 65] = "UPPER_A";
    CharCodes[CharCodes["UPPER_F"] = 70] = "UPPER_F";
    CharCodes[CharCodes["UPPER_Z"] = 90] = "UPPER_Z";
})(CharCodes$1 || (CharCodes$1 = {}));
/** Bit that needs to be set to convert an upper case ASCII character to lower case */
const TO_LOWER_BIT = 0b100000;
var BinTrieFlags;
(function (BinTrieFlags) {
    BinTrieFlags[BinTrieFlags["VALUE_LENGTH"] = 49152] = "VALUE_LENGTH";
    BinTrieFlags[BinTrieFlags["BRANCH_LENGTH"] = 16256] = "BRANCH_LENGTH";
    BinTrieFlags[BinTrieFlags["JUMP_TABLE"] = 127] = "JUMP_TABLE";
})(BinTrieFlags || (BinTrieFlags = {}));
function isNumber$5(code) {
    return code >= CharCodes$1.ZERO && code <= CharCodes$1.NINE;
}
function isHexadecimalCharacter(code) {
    return ((code >= CharCodes$1.UPPER_A && code <= CharCodes$1.UPPER_F) ||
        (code >= CharCodes$1.LOWER_A && code <= CharCodes$1.LOWER_F));
}
function isAsciiAlphaNumeric$1(code) {
    return ((code >= CharCodes$1.UPPER_A && code <= CharCodes$1.UPPER_Z) ||
        (code >= CharCodes$1.LOWER_A && code <= CharCodes$1.LOWER_Z) ||
        isNumber$5(code));
}
/**
 * Checks if the given character is a valid end character for an entity in an attribute.
 *
 * Attribute values that aren't terminated properly aren't parsed, and shouldn't lead to a parser error.
 * See the example in https://html.spec.whatwg.org/multipage/parsing.html#named-character-reference-state
 */
function isEntityInAttributeInvalidEnd$1(code) {
    return code === CharCodes$1.EQUALS || isAsciiAlphaNumeric$1(code);
}
var EntityDecoderState;
(function (EntityDecoderState) {
    EntityDecoderState[EntityDecoderState["EntityStart"] = 0] = "EntityStart";
    EntityDecoderState[EntityDecoderState["NumericStart"] = 1] = "NumericStart";
    EntityDecoderState[EntityDecoderState["NumericDecimal"] = 2] = "NumericDecimal";
    EntityDecoderState[EntityDecoderState["NumericHex"] = 3] = "NumericHex";
    EntityDecoderState[EntityDecoderState["NamedEntity"] = 4] = "NamedEntity";
})(EntityDecoderState || (EntityDecoderState = {}));
var DecodingMode;
(function (DecodingMode) {
    /** Entities in text nodes that can end with any character. */
    DecodingMode[DecodingMode["Legacy"] = 0] = "Legacy";
    /** Only allow entities terminated with a semicolon. */
    DecodingMode[DecodingMode["Strict"] = 1] = "Strict";
    /** Entities in attributes have limitations on ending characters. */
    DecodingMode[DecodingMode["Attribute"] = 2] = "Attribute";
})(DecodingMode || (DecodingMode = {}));
/**
 * Token decoder with support of writing partial entities.
 */
class EntityDecoder {
    constructor(
    /** The tree used to decode entities. */
    decodeTree, 
    /**
     * The function that is called when a codepoint is decoded.
     *
     * For multi-byte named entities, this will be called multiple times,
     * with the second codepoint, and the same `consumed` value.
     *
     * @param codepoint The decoded codepoint.
     * @param consumed The number of bytes consumed by the decoder.
     */
    emitCodePoint, 
    /** An object that is used to produce errors. */
    errors) {
        this.decodeTree = decodeTree;
        this.emitCodePoint = emitCodePoint;
        this.errors = errors;
        /** The current state of the decoder. */
        this.state = EntityDecoderState.EntityStart;
        /** Characters that were consumed while parsing an entity. */
        this.consumed = 1;
        /**
         * The result of the entity.
         *
         * Either the result index of a numeric entity, or the codepoint of a
         * numeric entity.
         */
        this.result = 0;
        /** The current index in the decode tree. */
        this.treeIndex = 0;
        /** The number of characters that were consumed in excess. */
        this.excess = 1;
        /** The mode in which the decoder is operating. */
        this.decodeMode = DecodingMode.Strict;
    }
    /** Resets the instance to make it reusable. */
    startEntity(decodeMode) {
        this.decodeMode = decodeMode;
        this.state = EntityDecoderState.EntityStart;
        this.result = 0;
        this.treeIndex = 0;
        this.excess = 1;
        this.consumed = 1;
    }
    /**
     * Write an entity to the decoder. This can be called multiple times with partial entities.
     * If the entity is incomplete, the decoder will return -1.
     *
     * Mirrors the implementation of `getDecoder`, but with the ability to stop decoding if the
     * entity is incomplete, and resume when the next string is written.
     *
     * @param string The string containing the entity (or a continuation of the entity).
     * @param offset The offset at which the entity begins. Should be 0 if this is not the first call.
     * @returns The number of characters that were consumed, or -1 if the entity is incomplete.
     */
    write(str, offset) {
        switch (this.state) {
            case EntityDecoderState.EntityStart: {
                if (str.charCodeAt(offset) === CharCodes$1.NUM) {
                    this.state = EntityDecoderState.NumericStart;
                    this.consumed += 1;
                    return this.stateNumericStart(str, offset + 1);
                }
                this.state = EntityDecoderState.NamedEntity;
                return this.stateNamedEntity(str, offset);
            }
            case EntityDecoderState.NumericStart: {
                return this.stateNumericStart(str, offset);
            }
            case EntityDecoderState.NumericDecimal: {
                return this.stateNumericDecimal(str, offset);
            }
            case EntityDecoderState.NumericHex: {
                return this.stateNumericHex(str, offset);
            }
            case EntityDecoderState.NamedEntity: {
                return this.stateNamedEntity(str, offset);
            }
        }
    }
    /**
     * Switches between the numeric decimal and hexadecimal states.
     *
     * Equivalent to the `Numeric character reference state` in the HTML spec.
     *
     * @param str The string containing the entity (or a continuation of the entity).
     * @param offset The current offset.
     * @returns The number of characters that were consumed, or -1 if the entity is incomplete.
     */
    stateNumericStart(str, offset) {
        if (offset >= str.length) {
            return -1;
        }
        if ((str.charCodeAt(offset) | TO_LOWER_BIT) === CharCodes$1.LOWER_X) {
            this.state = EntityDecoderState.NumericHex;
            this.consumed += 1;
            return this.stateNumericHex(str, offset + 1);
        }
        this.state = EntityDecoderState.NumericDecimal;
        return this.stateNumericDecimal(str, offset);
    }
    addToNumericResult(str, start, end, base) {
        if (start !== end) {
            const digitCount = end - start;
            this.result =
                this.result * Math.pow(base, digitCount) +
                    parseInt(str.substr(start, digitCount), base);
            this.consumed += digitCount;
        }
    }
    /**
     * Parses a hexadecimal numeric entity.
     *
     * Equivalent to the `Hexademical character reference state` in the HTML spec.
     *
     * @param str The string containing the entity (or a continuation of the entity).
     * @param offset The current offset.
     * @returns The number of characters that were consumed, or -1 if the entity is incomplete.
     */
    stateNumericHex(str, offset) {
        const startIdx = offset;
        while (offset < str.length) {
            const char = str.charCodeAt(offset);
            if (isNumber$5(char) || isHexadecimalCharacter(char)) {
                offset += 1;
            }
            else {
                this.addToNumericResult(str, startIdx, offset, 16);
                return this.emitNumericEntity(char, 3);
            }
        }
        this.addToNumericResult(str, startIdx, offset, 16);
        return -1;
    }
    /**
     * Parses a decimal numeric entity.
     *
     * Equivalent to the `Decimal character reference state` in the HTML spec.
     *
     * @param str The string containing the entity (or a continuation of the entity).
     * @param offset The current offset.
     * @returns The number of characters that were consumed, or -1 if the entity is incomplete.
     */
    stateNumericDecimal(str, offset) {
        const startIdx = offset;
        while (offset < str.length) {
            const char = str.charCodeAt(offset);
            if (isNumber$5(char)) {
                offset += 1;
            }
            else {
                this.addToNumericResult(str, startIdx, offset, 10);
                return this.emitNumericEntity(char, 2);
            }
        }
        this.addToNumericResult(str, startIdx, offset, 10);
        return -1;
    }
    /**
     * Validate and emit a numeric entity.
     *
     * Implements the logic from the `Hexademical character reference start
     * state` and `Numeric character reference end state` in the HTML spec.
     *
     * @param lastCp The last code point of the entity. Used to see if the
     *               entity was terminated with a semicolon.
     * @param expectedLength The minimum number of characters that should be
     *                       consumed. Used to validate that at least one digit
     *                       was consumed.
     * @returns The number of characters that were consumed.
     */
    emitNumericEntity(lastCp, expectedLength) {
        var _a;
        // Ensure we consumed at least one digit.
        if (this.consumed <= expectedLength) {
            (_a = this.errors) === null || _a === void 0 ? void 0 : _a.absenceOfDigitsInNumericCharacterReference(this.consumed);
            return 0;
        }
        // Figure out if this is a legit end of the entity
        if (lastCp === CharCodes$1.SEMI) {
            this.consumed += 1;
        }
        else if (this.decodeMode === DecodingMode.Strict) {
            return 0;
        }
        this.emitCodePoint(replaceCodePoint(this.result), this.consumed);
        if (this.errors) {
            if (lastCp !== CharCodes$1.SEMI) {
                this.errors.missingSemicolonAfterCharacterReference();
            }
            this.errors.validateNumericCharacterReference(this.result);
        }
        return this.consumed;
    }
    /**
     * Parses a named entity.
     *
     * Equivalent to the `Named character reference state` in the HTML spec.
     *
     * @param str The string containing the entity (or a continuation of the entity).
     * @param offset The current offset.
     * @returns The number of characters that were consumed, or -1 if the entity is incomplete.
     */
    stateNamedEntity(str, offset) {
        const { decodeTree } = this;
        let current = decodeTree[this.treeIndex];
        // The mask is the number of bytes of the value, including the current byte.
        let valueLength = (current & BinTrieFlags.VALUE_LENGTH) >> 14;
        for (; offset < str.length; offset++, this.excess++) {
            const char = str.charCodeAt(offset);
            this.treeIndex = determineBranch(decodeTree, current, this.treeIndex + Math.max(1, valueLength), char);
            if (this.treeIndex < 0) {
                return this.result === 0 ||
                    // If we are parsing an attribute
                    (this.decodeMode === DecodingMode.Attribute &&
                        // We shouldn't have consumed any characters after the entity,
                        (valueLength === 0 ||
                            // And there should be no invalid characters.
                            isEntityInAttributeInvalidEnd$1(char)))
                    ? 0
                    : this.emitNotTerminatedNamedEntity();
            }
            current = decodeTree[this.treeIndex];
            valueLength = (current & BinTrieFlags.VALUE_LENGTH) >> 14;
            // If the branch is a value, store it and continue
            if (valueLength !== 0) {
                // If the entity is terminated by a semicolon, we are done.
                if (char === CharCodes$1.SEMI) {
                    return this.emitNamedEntityData(this.treeIndex, valueLength, this.consumed + this.excess);
                }
                // If we encounter a non-terminated (legacy) entity while parsing strictly, then ignore it.
                if (this.decodeMode !== DecodingMode.Strict) {
                    this.result = this.treeIndex;
                    this.consumed += this.excess;
                    this.excess = 0;
                }
            }
        }
        return -1;
    }
    /**
     * Emit a named entity that was not terminated with a semicolon.
     *
     * @returns The number of characters consumed.
     */
    emitNotTerminatedNamedEntity() {
        var _a;
        const { result, decodeTree } = this;
        const valueLength = (decodeTree[result] & BinTrieFlags.VALUE_LENGTH) >> 14;
        this.emitNamedEntityData(result, valueLength, this.consumed);
        (_a = this.errors) === null || _a === void 0 ? void 0 : _a.missingSemicolonAfterCharacterReference();
        return this.consumed;
    }
    /**
     * Emit a named entity.
     *
     * @param result The index of the entity in the decode tree.
     * @param valueLength The number of bytes in the entity.
     * @param consumed The number of characters consumed.
     *
     * @returns The number of characters consumed.
     */
    emitNamedEntityData(result, valueLength, consumed) {
        const { decodeTree } = this;
        this.emitCodePoint(valueLength === 1
            ? decodeTree[result] & ~BinTrieFlags.VALUE_LENGTH
            : decodeTree[result + 1], consumed);
        if (valueLength === 3) {
            // For multi-byte values, we need to emit the second byte.
            this.emitCodePoint(decodeTree[result + 2], consumed);
        }
        return consumed;
    }
    /**
     * Signal to the parser that the end of the input was reached.
     *
     * Remaining data will be emitted and relevant errors will be produced.
     *
     * @returns The number of characters consumed.
     */
    end() {
        var _a;
        switch (this.state) {
            case EntityDecoderState.NamedEntity: {
                // Emit a named entity if we have one.
                return this.result !== 0 &&
                    (this.decodeMode !== DecodingMode.Attribute ||
                        this.result === this.treeIndex)
                    ? this.emitNotTerminatedNamedEntity()
                    : 0;
            }
            // Otherwise, emit a numeric entity if we have one.
            case EntityDecoderState.NumericDecimal: {
                return this.emitNumericEntity(0, 2);
            }
            case EntityDecoderState.NumericHex: {
                return this.emitNumericEntity(0, 3);
            }
            case EntityDecoderState.NumericStart: {
                (_a = this.errors) === null || _a === void 0 ? void 0 : _a.absenceOfDigitsInNumericCharacterReference(this.consumed);
                return 0;
            }
            case EntityDecoderState.EntityStart: {
                // Return 0 if we have no entity.
                return 0;
            }
        }
    }
}
/**
 * Creates a function that decodes entities in a string.
 *
 * @param decodeTree The decode tree.
 * @returns A function that decodes entities in a string.
 */
function getDecoder(decodeTree) {
    let ret = "";
    const decoder = new EntityDecoder(decodeTree, (str) => (ret += fromCodePoint$1(str)));
    return function decodeWithTrie(str, decodeMode) {
        let lastIndex = 0;
        let offset = 0;
        while ((offset = str.indexOf("&", offset)) >= 0) {
            ret += str.slice(lastIndex, offset);
            decoder.startEntity(decodeMode);
            const len = decoder.write(str, 
            // Skip the "&"
            offset + 1);
            if (len < 0) {
                lastIndex = offset + decoder.end();
                break;
            }
            lastIndex = offset + len;
            // If `len` is 0, skip the current `&` and continue.
            offset = len === 0 ? lastIndex + 1 : lastIndex;
        }
        const result = ret + str.slice(lastIndex);
        // Make sure we don't keep a reference to the final string.
        ret = "";
        return result;
    };
}
/**
 * Determines the branch of the current node that is taken given the current
 * character. This function is used to traverse the trie.
 *
 * @param decodeTree The trie.
 * @param current The current node.
 * @param nodeIdx The index right after the current node and its value.
 * @param char The current character.
 * @returns The index of the next node, or -1 if no branch is taken.
 */
function determineBranch(decodeTree, current, nodeIdx, char) {
    const branchCount = (current & BinTrieFlags.BRANCH_LENGTH) >> 7;
    const jumpOffset = current & BinTrieFlags.JUMP_TABLE;
    // Case 1: Single branch encoded in jump offset
    if (branchCount === 0) {
        return jumpOffset !== 0 && char === jumpOffset ? nodeIdx : -1;
    }
    // Case 2: Multiple branches encoded in jump table
    if (jumpOffset) {
        const value = char - jumpOffset;
        return value < 0 || value >= branchCount
            ? -1
            : decodeTree[nodeIdx + value] - 1;
    }
    // Case 3: Multiple branches encoded in dictionary
    // Binary search for the character.
    let lo = nodeIdx;
    let hi = lo + branchCount - 1;
    while (lo <= hi) {
        const mid = (lo + hi) >>> 1;
        const midVal = decodeTree[mid];
        if (midVal < char) {
            lo = mid + 1;
        }
        else if (midVal > char) {
            hi = mid - 1;
        }
        else {
            return decodeTree[mid + branchCount];
        }
    }
    return -1;
}
getDecoder(htmlDecodeTree);
getDecoder(xmlDecodeTree);

const xmlReplacer$1 = /["&'<>$\x80-\uFFFF]/g;
const xmlCodeMap = new Map([
    [34, "&quot;"],
    [38, "&amp;"],
    [39, "&apos;"],
    [60, "&lt;"],
    [62, "&gt;"],
]);
// For compatibility with node < 4, we wrap `codePointAt`
const getCodePoint$1 = 
// eslint-disable-next-line @typescript-eslint/no-unnecessary-condition
String.prototype.codePointAt != null
    ? (str, index) => str.codePointAt(index)
    : // http://mathiasbynens.be/notes/javascript-encoding#surrogate-formulae
        (c, index) => (c.charCodeAt(index) & 0xfc00) === 0xd800
            ? (c.charCodeAt(index) - 0xd800) * 0x400 +
                c.charCodeAt(index + 1) -
                0xdc00 +
                0x10000
            : c.charCodeAt(index);
/**
 * Encodes all non-ASCII characters, as well as characters not valid in XML
 * documents using XML entities.
 *
 * If a character has no equivalent entity, a
 * numeric hexadecimal reference (eg. `&#xfc;`) will be used.
 */
function encodeXML(str) {
    let ret = "";
    let lastIdx = 0;
    let match;
    while ((match = xmlReplacer$1.exec(str)) !== null) {
        const i = match.index;
        const char = str.charCodeAt(i);
        const next = xmlCodeMap.get(char);
        if (next !== undefined) {
            ret += str.substring(lastIdx, i) + next;
            lastIdx = i + 1;
        }
        else {
            ret += `${str.substring(lastIdx, i)}&#x${getCodePoint$1(str, i).toString(16)};`;
            // Increase by 1 if we have a surrogate pair
            lastIdx = xmlReplacer$1.lastIndex += Number((char & 0xfc00) === 0xd800);
        }
    }
    return ret + str.substr(lastIdx);
}
/**
 * Creates a function that escapes all characters matched by the given regular
 * expression using the given map of characters to escape to their entities.
 *
 * @param regex Regular expression to match characters to escape.
 * @param map Map of characters to escape to their entities.
 *
 * @returns Function that escapes all characters matched by the given regular
 * expression using the given map of characters to escape to their entities.
 */
function getEscaper(regex, map) {
    return function escape(data) {
        let match;
        let lastIdx = 0;
        let result = "";
        while ((match = regex.exec(data))) {
            if (lastIdx !== match.index) {
                result += data.substring(lastIdx, match.index);
            }
            // We know that this character will be in the map.
            result += map.get(match[0].charCodeAt(0));
            // Every match will be of length 1
            lastIdx = match.index + 1;
        }
        return result + data.substring(lastIdx);
    };
}
/**
 * Encodes all characters that have to be escaped in HTML attributes,
 * following {@link https://html.spec.whatwg.org/multipage/parsing.html#escapingString}.
 *
 * @param data String to escape.
 */
const escapeAttribute = getEscaper(/["&\u00A0]/g, new Map([
    [34, "&quot;"],
    [38, "&amp;"],
    [160, "&nbsp;"],
]));
/**
 * Encodes all characters that have to be escaped in HTML text,
 * following {@link https://html.spec.whatwg.org/multipage/parsing.html#escapingString}.
 *
 * @param data String to escape.
 */
const escapeText = getEscaper(/[&<>\u00A0]/g, new Map([
    [38, "&amp;"],
    [60, "&lt;"],
    [62, "&gt;"],
    [160, "&nbsp;"],
]));

const elementNames = new Map([
    "altGlyph",
    "altGlyphDef",
    "altGlyphItem",
    "animateColor",
    "animateMotion",
    "animateTransform",
    "clipPath",
    "feBlend",
    "feColorMatrix",
    "feComponentTransfer",
    "feComposite",
    "feConvolveMatrix",
    "feDiffuseLighting",
    "feDisplacementMap",
    "feDistantLight",
    "feDropShadow",
    "feFlood",
    "feFuncA",
    "feFuncB",
    "feFuncG",
    "feFuncR",
    "feGaussianBlur",
    "feImage",
    "feMerge",
    "feMergeNode",
    "feMorphology",
    "feOffset",
    "fePointLight",
    "feSpecularLighting",
    "feSpotLight",
    "feTile",
    "feTurbulence",
    "foreignObject",
    "glyphRef",
    "linearGradient",
    "radialGradient",
    "textPath",
].map((val) => [val.toLowerCase(), val]));
const attributeNames = new Map([
    "definitionURL",
    "attributeName",
    "attributeType",
    "baseFrequency",
    "baseProfile",
    "calcMode",
    "clipPathUnits",
    "diffuseConstant",
    "edgeMode",
    "filterUnits",
    "glyphRef",
    "gradientTransform",
    "gradientUnits",
    "kernelMatrix",
    "kernelUnitLength",
    "keyPoints",
    "keySplines",
    "keyTimes",
    "lengthAdjust",
    "limitingConeAngle",
    "markerHeight",
    "markerUnits",
    "markerWidth",
    "maskContentUnits",
    "maskUnits",
    "numOctaves",
    "pathLength",
    "patternContentUnits",
    "patternTransform",
    "patternUnits",
    "pointsAtX",
    "pointsAtY",
    "pointsAtZ",
    "preserveAlpha",
    "preserveAspectRatio",
    "primitiveUnits",
    "refX",
    "refY",
    "repeatCount",
    "repeatDur",
    "requiredExtensions",
    "requiredFeatures",
    "specularConstant",
    "specularExponent",
    "spreadMethod",
    "startOffset",
    "stdDeviation",
    "stitchTiles",
    "surfaceScale",
    "systemLanguage",
    "tableValues",
    "targetX",
    "targetY",
    "textLength",
    "viewBox",
    "viewTarget",
    "xChannelSelector",
    "yChannelSelector",
    "zoomAndPan",
].map((val) => [val.toLowerCase(), val]));

/*
 * Module dependencies
 */
const unencodedElements$1 = new Set([
    "style",
    "script",
    "xmp",
    "iframe",
    "noembed",
    "noframes",
    "plaintext",
    "noscript",
]);
function replaceQuotes(value) {
    return value.replace(/"/g, "&quot;");
}
/**
 * Format attributes
 */
function formatAttributes$1(attributes, opts) {
    var _a;
    if (!attributes)
        return;
    const encode = ((_a = opts.encodeEntities) !== null && _a !== void 0 ? _a : opts.decodeEntities) === false
        ? replaceQuotes
        : opts.xmlMode || opts.encodeEntities !== "utf8"
            ? encodeXML
            : escapeAttribute;
    return Object.keys(attributes)
        .map((key) => {
        var _a, _b;
        const value = (_a = attributes[key]) !== null && _a !== void 0 ? _a : "";
        if (opts.xmlMode === "foreign") {
            /* Fix up mixed-case attribute names */
            key = (_b = attributeNames.get(key)) !== null && _b !== void 0 ? _b : key;
        }
        if (!opts.emptyAttrs && !opts.xmlMode && value === "") {
            return key;
        }
        return `${key}="${encode(value)}"`;
    })
        .join(" ");
}
/**
 * Self-enclosing tags
 */
const singleTag$1 = new Set([
    "area",
    "base",
    "basefont",
    "br",
    "col",
    "command",
    "embed",
    "frame",
    "hr",
    "img",
    "input",
    "isindex",
    "keygen",
    "link",
    "meta",
    "param",
    "source",
    "track",
    "wbr",
]);
/**
 * Renders a DOM node or an array of DOM nodes to a string.
 *
 * Can be thought of as the equivalent of the `outerHTML` of the passed node(s).
 *
 * @param node Node to be rendered.
 * @param options Changes serialization behavior
 */
function render$2(node, options = {}) {
    const nodes = "length" in node ? node : [node];
    let output = "";
    for (let i = 0; i < nodes.length; i++) {
        output += renderNode$1(nodes[i], options);
    }
    return output;
}
function renderNode$1(node, options) {
    switch (node.type) {
        case Root:
            return render$2(node.children, options);
        // @ts-expect-error We don't use `Doctype` yet
        case Doctype:
        case Directive:
            return renderDirective$1(node);
        case Comment$2:
            return renderComment$1(node);
        case CDATA$1:
            return renderCdata$1(node);
        case Script:
        case Style:
        case Tag:
            return renderTag$1(node, options);
        case Text$2:
            return renderText$1(node, options);
    }
}
const foreignModeIntegrationPoints$1 = new Set([
    "mi",
    "mo",
    "mn",
    "ms",
    "mtext",
    "annotation-xml",
    "foreignObject",
    "desc",
    "title",
]);
const foreignElements$1 = new Set(["svg", "math"]);
function renderTag$1(elem, opts) {
    var _a;
    // Handle SVG / MathML in HTML
    if (opts.xmlMode === "foreign") {
        /* Fix up mixed-case element names */
        elem.name = (_a = elementNames.get(elem.name)) !== null && _a !== void 0 ? _a : elem.name;
        /* Exit foreign mode at integration points */
        if (elem.parent &&
            foreignModeIntegrationPoints$1.has(elem.parent.name)) {
            opts = { ...opts, xmlMode: false };
        }
    }
    if (!opts.xmlMode && foreignElements$1.has(elem.name)) {
        opts = { ...opts, xmlMode: "foreign" };
    }
    let tag = `<${elem.name}`;
    const attribs = formatAttributes$1(elem.attribs, opts);
    if (attribs) {
        tag += ` ${attribs}`;
    }
    if (elem.children.length === 0 &&
        (opts.xmlMode
            ? // In XML mode or foreign mode, and user hasn't explicitly turned off self-closing tags
                opts.selfClosingTags !== false
            : // User explicitly asked for self-closing tags, even in HTML mode
                opts.selfClosingTags && singleTag$1.has(elem.name))) {
        if (!opts.xmlMode)
            tag += " ";
        tag += "/>";
    }
    else {
        tag += ">";
        if (elem.children.length > 0) {
            tag += render$2(elem.children, opts);
        }
        if (opts.xmlMode || !singleTag$1.has(elem.name)) {
            tag += `</${elem.name}>`;
        }
    }
    return tag;
}
function renderDirective$1(elem) {
    return `<${elem.data}>`;
}
function renderText$1(elem, opts) {
    var _a;
    let data = elem.data || "";
    // If entities weren't decoded, no need to encode them back
    if (((_a = opts.encodeEntities) !== null && _a !== void 0 ? _a : opts.decodeEntities) !== false &&
        !(!opts.xmlMode &&
            elem.parent &&
            unencodedElements$1.has(elem.parent.name))) {
        data =
            opts.xmlMode || opts.encodeEntities !== "utf8"
                ? encodeXML(data)
                : escapeText(data);
    }
    return data;
}
function renderCdata$1(elem) {
    return `<![CDATA[${elem.children[0].data}]]>`;
}
function renderComment$1(elem) {
    return `<!--${elem.data}-->`;
}

/**
 * @category Stringify
 * @deprecated Use the `dom-serializer` module directly.
 * @param node Node to get the outer HTML of.
 * @param options Options for serialization.
 * @returns `node`'s outer HTML.
 */
function getOuterHTML$1(node, options) {
    return render$2(node, options);
}
/**
 * @category Stringify
 * @deprecated Use the `dom-serializer` module directly.
 * @param node Node to get the inner HTML of.
 * @param options Options for serialization.
 * @returns `node`'s inner HTML.
 */
function getInnerHTML$1(node, options) {
    return hasChildren$1(node)
        ? node.children.map((node) => getOuterHTML$1(node, options)).join("")
        : "";
}
/**
 * Get a node's inner text. Same as `textContent`, but inserts newlines for `<br>` tags. Ignores comments.
 *
 * @category Stringify
 * @deprecated Use `textContent` instead.
 * @param node Node to get the inner text of.
 * @returns `node`'s inner text.
 */
function getText$2(node) {
    if (Array.isArray(node))
        return node.map(getText$2).join("");
    if (isTag$2(node))
        return node.name === "br" ? "\n" : getText$2(node.children);
    if (isCDATA$1(node))
        return getText$2(node.children);
    if (isText$1(node))
        return node.data;
    return "";
}
/**
 * Get a node's text content. Ignores comments.
 *
 * @category Stringify
 * @param node Node to get the text content of.
 * @returns `node`'s text content.
 * @see {@link https://developer.mozilla.org/en-US/docs/Web/API/Node/textContent}
 */
function textContent$1(node) {
    if (Array.isArray(node))
        return node.map(textContent$1).join("");
    if (hasChildren$1(node) && !isComment$1(node)) {
        return textContent$1(node.children);
    }
    if (isText$1(node))
        return node.data;
    return "";
}
/**
 * Get a node's inner text, ignoring `<script>` and `<style>` tags. Ignores comments.
 *
 * @category Stringify
 * @param node Node to get the inner text of.
 * @returns `node`'s inner text.
 * @see {@link https://developer.mozilla.org/en-US/docs/Web/API/Node/innerText}
 */
function innerText$1(node) {
    if (Array.isArray(node))
        return node.map(innerText$1).join("");
    if (hasChildren$1(node) && (node.type === ElementType$1.Tag || isCDATA$1(node))) {
        return innerText$1(node.children);
    }
    if (isText$1(node))
        return node.data;
    return "";
}

/**
 * Get a node's children.
 *
 * @category Traversal
 * @param elem Node to get the children of.
 * @returns `elem`'s children, or an empty array.
 */
function getChildren$2(elem) {
    return hasChildren$1(elem) ? elem.children : [];
}
/**
 * Get a node's parent.
 *
 * @category Traversal
 * @param elem Node to get the parent of.
 * @returns `elem`'s parent node, or `null` if `elem` is a root node.
 */
function getParent$2(elem) {
    return elem.parent || null;
}
/**
 * Gets an elements siblings, including the element itself.
 *
 * Attempts to get the children through the element's parent first. If we don't
 * have a parent (the element is a root node), we walk the element's `prev` &
 * `next` to get all remaining nodes.
 *
 * @category Traversal
 * @param elem Element to get the siblings of.
 * @returns `elem`'s siblings, including `elem`.
 */
function getSiblings$2(elem) {
    const parent = getParent$2(elem);
    if (parent != null)
        return getChildren$2(parent);
    const siblings = [elem];
    let { prev, next } = elem;
    while (prev != null) {
        siblings.unshift(prev);
        ({ prev } = prev);
    }
    while (next != null) {
        siblings.push(next);
        ({ next } = next);
    }
    return siblings;
}
/**
 * Gets an attribute from an element.
 *
 * @category Traversal
 * @param elem Element to check.
 * @param name Attribute name to retrieve.
 * @returns The element's attribute value, or `undefined`.
 */
function getAttributeValue$2(elem, name) {
    var _a;
    return (_a = elem.attribs) === null || _a === void 0 ? void 0 : _a[name];
}
/**
 * Checks whether an element has an attribute.
 *
 * @category Traversal
 * @param elem Element to check.
 * @param name Attribute name to look for.
 * @returns Returns whether `elem` has the attribute `name`.
 */
function hasAttrib$2(elem, name) {
    return (elem.attribs != null &&
        Object.prototype.hasOwnProperty.call(elem.attribs, name) &&
        elem.attribs[name] != null);
}
/**
 * Get the tag name of an element.
 *
 * @category Traversal
 * @param elem The element to get the name for.
 * @returns The tag name of `elem`.
 */
function getName$2(elem) {
    return elem.name;
}
/**
 * Returns the next element sibling of a node.
 *
 * @category Traversal
 * @param elem The element to get the next sibling of.
 * @returns `elem`'s next sibling that is a tag, or `null` if there is no next
 * sibling.
 */
function nextElementSibling$1(elem) {
    let { next } = elem;
    while (next !== null && !isTag$2(next))
        ({ next } = next);
    return next;
}
/**
 * Returns the previous element sibling of a node.
 *
 * @category Traversal
 * @param elem The element to get the previous sibling of.
 * @returns `elem`'s previous sibling that is a tag, or `null` if there is no
 * previous sibling.
 */
function prevElementSibling$1(elem) {
    let { prev } = elem;
    while (prev !== null && !isTag$2(prev))
        ({ prev } = prev);
    return prev;
}

/**
 * Remove an element from the dom
 *
 * @category Manipulation
 * @param elem The element to be removed
 */
function removeElement$1(elem) {
    if (elem.prev)
        elem.prev.next = elem.next;
    if (elem.next)
        elem.next.prev = elem.prev;
    if (elem.parent) {
        const childs = elem.parent.children;
        const childsIndex = childs.lastIndexOf(elem);
        if (childsIndex >= 0) {
            childs.splice(childsIndex, 1);
        }
    }
    elem.next = null;
    elem.prev = null;
    elem.parent = null;
}
/**
 * Replace an element in the dom
 *
 * @category Manipulation
 * @param elem The element to be replaced
 * @param replacement The element to be added
 */
function replaceElement$1(elem, replacement) {
    const prev = (replacement.prev = elem.prev);
    if (prev) {
        prev.next = replacement;
    }
    const next = (replacement.next = elem.next);
    if (next) {
        next.prev = replacement;
    }
    const parent = (replacement.parent = elem.parent);
    if (parent) {
        const childs = parent.children;
        childs[childs.lastIndexOf(elem)] = replacement;
        elem.parent = null;
    }
}
/**
 * Append a child to an element.
 *
 * @category Manipulation
 * @param parent The element to append to.
 * @param child The element to be added as a child.
 */
function appendChild$1(parent, child) {
    removeElement$1(child);
    child.next = null;
    child.parent = parent;
    if (parent.children.push(child) > 1) {
        const sibling = parent.children[parent.children.length - 2];
        sibling.next = child;
        child.prev = sibling;
    }
    else {
        child.prev = null;
    }
}
/**
 * Append an element after another.
 *
 * @category Manipulation
 * @param elem The element to append after.
 * @param next The element be added.
 */
function append$3(elem, next) {
    removeElement$1(next);
    const { parent } = elem;
    const currNext = elem.next;
    next.next = currNext;
    next.prev = elem;
    elem.next = next;
    next.parent = parent;
    if (currNext) {
        currNext.prev = next;
        if (parent) {
            const childs = parent.children;
            childs.splice(childs.lastIndexOf(currNext), 0, next);
        }
    }
    else if (parent) {
        parent.children.push(next);
    }
}
/**
 * Prepend a child to an element.
 *
 * @category Manipulation
 * @param parent The element to prepend before.
 * @param child The element to be added as a child.
 */
function prependChild$1(parent, child) {
    removeElement$1(child);
    child.parent = parent;
    child.prev = null;
    if (parent.children.unshift(child) !== 1) {
        const sibling = parent.children[1];
        sibling.prev = child;
        child.next = sibling;
    }
    else {
        child.next = null;
    }
}
/**
 * Prepend an element before another.
 *
 * @category Manipulation
 * @param elem The element to prepend before.
 * @param prev The element be added.
 */
function prepend$2(elem, prev) {
    removeElement$1(prev);
    const { parent } = elem;
    if (parent) {
        const childs = parent.children;
        childs.splice(childs.indexOf(elem), 0, prev);
    }
    if (elem.prev) {
        elem.prev.next = prev;
    }
    prev.parent = parent;
    prev.prev = elem.prev;
    prev.next = elem;
    elem.prev = prev;
}

/**
 * Search a node and its children for nodes passing a test function. If `node` is not an array, it will be wrapped in one.
 *
 * @category Querying
 * @param test Function to test nodes on.
 * @param node Node to search. Will be included in the result set if it matches.
 * @param recurse Also consider child nodes.
 * @param limit Maximum number of nodes to return.
 * @returns All nodes passing `test`.
 */
function filter$4(test, node, recurse = true, limit = Infinity) {
    return find$3(test, Array.isArray(node) ? node : [node], recurse, limit);
}
/**
 * Search an array of nodes and their children for nodes passing a test function.
 *
 * @category Querying
 * @param test Function to test nodes on.
 * @param nodes Array of nodes to search.
 * @param recurse Also consider child nodes.
 * @param limit Maximum number of nodes to return.
 * @returns All nodes passing `test`.
 */
function find$3(test, nodes, recurse, limit) {
    const result = [];
    /** Stack of the arrays we are looking at. */
    const nodeStack = [nodes];
    /** Stack of the indices within the arrays. */
    const indexStack = [0];
    for (;;) {
        // First, check if the current array has any more elements to look at.
        if (indexStack[0] >= nodeStack[0].length) {
            // If we have no more arrays to look at, we are done.
            if (indexStack.length === 1) {
                return result;
            }
            // Otherwise, remove the current array from the stack.
            nodeStack.shift();
            indexStack.shift();
            // Loop back to the start to continue with the next array.
            continue;
        }
        const elem = nodeStack[0][indexStack[0]++];
        if (test(elem)) {
            result.push(elem);
            if (--limit <= 0)
                return result;
        }
        if (recurse && hasChildren$1(elem) && elem.children.length > 0) {
            /*
             * Add the children to the stack. We are depth-first, so this is
             * the next array we look at.
             */
            indexStack.unshift(0);
            nodeStack.unshift(elem.children);
        }
    }
}
/**
 * Finds the first element inside of an array that matches a test function. This is an alias for `Array.prototype.find`.
 *
 * @category Querying
 * @param test Function to test nodes on.
 * @param nodes Array of nodes to search.
 * @returns The first node in the array that passes `test`.
 * @deprecated Use `Array.prototype.find` directly.
 */
function findOneChild$1(test, nodes) {
    return nodes.find(test);
}
/**
 * Finds one element in a tree that passes a test.
 *
 * @category Querying
 * @param test Function to test nodes on.
 * @param nodes Node or array of nodes to search.
 * @param recurse Also consider child nodes.
 * @returns The first node that passes `test`.
 */
function findOne$2(test, nodes, recurse = true) {
    let elem = null;
    for (let i = 0; i < nodes.length && !elem; i++) {
        const node = nodes[i];
        if (!isTag$2(node)) {
            continue;
        }
        else if (test(node)) {
            elem = node;
        }
        else if (recurse && node.children.length > 0) {
            elem = findOne$2(test, node.children, true);
        }
    }
    return elem;
}
/**
 * Checks if a tree of nodes contains at least one node passing a test.
 *
 * @category Querying
 * @param test Function to test nodes on.
 * @param nodes Array of nodes to search.
 * @returns Whether a tree of nodes contains at least one node passing the test.
 */
function existsOne$2(test, nodes) {
    return nodes.some((checked) => isTag$2(checked) &&
        (test(checked) || existsOne$2(test, checked.children)));
}
/**
 * Search an array of nodes and their children for elements passing a test function.
 *
 * Same as `find`, but limited to elements and with less options, leading to reduced complexity.
 *
 * @category Querying
 * @param test Function to test nodes on.
 * @param nodes Array of nodes to search.
 * @returns All nodes passing `test`.
 */
function findAll$2(test, nodes) {
    const result = [];
    const nodeStack = [nodes];
    const indexStack = [0];
    for (;;) {
        if (indexStack[0] >= nodeStack[0].length) {
            if (nodeStack.length === 1) {
                return result;
            }
            // Otherwise, remove the current array from the stack.
            nodeStack.shift();
            indexStack.shift();
            // Loop back to the start to continue with the next array.
            continue;
        }
        const elem = nodeStack[0][indexStack[0]++];
        if (!isTag$2(elem))
            continue;
        if (test(elem))
            result.push(elem);
        if (elem.children.length > 0) {
            indexStack.unshift(0);
            nodeStack.unshift(elem.children);
        }
    }
}

/**
 * A map of functions to check nodes against.
 */
const Checks$1 = {
    tag_name(name) {
        if (typeof name === "function") {
            return (elem) => isTag$2(elem) && name(elem.name);
        }
        else if (name === "*") {
            return isTag$2;
        }
        return (elem) => isTag$2(elem) && elem.name === name;
    },
    tag_type(type) {
        if (typeof type === "function") {
            return (elem) => type(elem.type);
        }
        return (elem) => elem.type === type;
    },
    tag_contains(data) {
        if (typeof data === "function") {
            return (elem) => isText$1(elem) && data(elem.data);
        }
        return (elem) => isText$1(elem) && elem.data === data;
    },
};
/**
 * Returns a function to check whether a node has an attribute with a particular
 * value.
 *
 * @param attrib Attribute to check.
 * @param value Attribute value to look for.
 * @returns A function to check whether the a node has an attribute with a
 *   particular value.
 */
function getAttribCheck$1(attrib, value) {
    if (typeof value === "function") {
        return (elem) => isTag$2(elem) && value(elem.attribs[attrib]);
    }
    return (elem) => isTag$2(elem) && elem.attribs[attrib] === value;
}
/**
 * Returns a function that returns `true` if either of the input functions
 * returns `true` for a node.
 *
 * @param a First function to combine.
 * @param b Second function to combine.
 * @returns A function taking a node and returning `true` if either of the input
 *   functions returns `true` for the node.
 */
function combineFuncs$1(a, b) {
    return (elem) => a(elem) || b(elem);
}
/**
 * Returns a function that executes all checks in `options` and returns `true`
 * if any of them match a node.
 *
 * @param options An object describing nodes to look for.
 * @returns A function that executes all checks in `options` and returns `true`
 *   if any of them match a node.
 */
function compileTest$1(options) {
    const funcs = Object.keys(options).map((key) => {
        const value = options[key];
        return Object.prototype.hasOwnProperty.call(Checks$1, key)
            ? Checks$1[key](value)
            : getAttribCheck$1(key, value);
    });
    return funcs.length === 0 ? null : funcs.reduce(combineFuncs$1);
}
/**
 * Checks whether a node matches the description in `options`.
 *
 * @category Legacy Query Functions
 * @param options An object describing nodes to look for.
 * @param node The element to test.
 * @returns Whether the element matches the description in `options`.
 */
function testElement$1(options, node) {
    const test = compileTest$1(options);
    return test ? test(node) : true;
}
/**
 * Returns all nodes that match `options`.
 *
 * @category Legacy Query Functions
 * @param options An object describing nodes to look for.
 * @param nodes Nodes to search through.
 * @param recurse Also consider child nodes.
 * @param limit Maximum number of nodes to return.
 * @returns All nodes that match `options`.
 */
function getElements$1(options, nodes, recurse, limit = Infinity) {
    const test = compileTest$1(options);
    return test ? filter$4(test, nodes, recurse, limit) : [];
}
/**
 * Returns the node with the supplied ID.
 *
 * @category Legacy Query Functions
 * @param id The unique ID attribute value to look for.
 * @param nodes Nodes to search through.
 * @param recurse Also consider child nodes.
 * @returns The node with the supplied ID.
 */
function getElementById$1(id, nodes, recurse = true) {
    if (!Array.isArray(nodes))
        nodes = [nodes];
    return findOne$2(getAttribCheck$1("id", id), nodes, recurse);
}
/**
 * Returns all nodes with the supplied `tagName`.
 *
 * @category Legacy Query Functions
 * @param tagName Tag name to search for.
 * @param nodes Nodes to search through.
 * @param recurse Also consider child nodes.
 * @param limit Maximum number of nodes to return.
 * @returns All nodes with the supplied `tagName`.
 */
function getElementsByTagName$1(tagName, nodes, recurse = true, limit = Infinity) {
    return filter$4(Checks$1["tag_name"](tagName), nodes, recurse, limit);
}
/**
 * Returns all nodes with the supplied `type`.
 *
 * @category Legacy Query Functions
 * @param type Element type to look for.
 * @param nodes Nodes to search through.
 * @param recurse Also consider child nodes.
 * @param limit Maximum number of nodes to return.
 * @returns All nodes with the supplied `type`.
 */
function getElementsByTagType$1(type, nodes, recurse = true, limit = Infinity) {
    return filter$4(Checks$1["tag_type"](type), nodes, recurse, limit);
}

/**
 * Given an array of nodes, remove any member that is contained by another
 * member.
 *
 * @category Helpers
 * @param nodes Nodes to filter.
 * @returns Remaining nodes that aren't contained by other nodes.
 */
function removeSubsets$2(nodes) {
    let idx = nodes.length;
    /*
     * Check if each node (or one of its ancestors) is already contained in the
     * array.
     */
    while (--idx >= 0) {
        const node = nodes[idx];
        /*
         * Remove the node if it is not unique.
         * We are going through the array from the end, so we only
         * have to check nodes that preceed the node under consideration in the array.
         */
        if (idx > 0 && nodes.lastIndexOf(node, idx - 1) >= 0) {
            nodes.splice(idx, 1);
            continue;
        }
        for (let ancestor = node.parent; ancestor; ancestor = ancestor.parent) {
            if (nodes.includes(ancestor)) {
                nodes.splice(idx, 1);
                break;
            }
        }
    }
    return nodes;
}
/**
 * @category Helpers
 * @see {@link http://dom.spec.whatwg.org/#dom-node-comparedocumentposition}
 */
var DocumentPosition;
(function (DocumentPosition) {
    DocumentPosition[DocumentPosition["DISCONNECTED"] = 1] = "DISCONNECTED";
    DocumentPosition[DocumentPosition["PRECEDING"] = 2] = "PRECEDING";
    DocumentPosition[DocumentPosition["FOLLOWING"] = 4] = "FOLLOWING";
    DocumentPosition[DocumentPosition["CONTAINS"] = 8] = "CONTAINS";
    DocumentPosition[DocumentPosition["CONTAINED_BY"] = 16] = "CONTAINED_BY";
})(DocumentPosition || (DocumentPosition = {}));
/**
 * Compare the position of one node against another node in any other document,
 * returning a bitmask with the values from {@link DocumentPosition}.
 *
 * Document order:
 * > There is an ordering, document order, defined on all the nodes in the
 * > document corresponding to the order in which the first character of the
 * > XML representation of each node occurs in the XML representation of the
 * > document after expansion of general entities. Thus, the document element
 * > node will be the first node. Element nodes occur before their children.
 * > Thus, document order orders element nodes in order of the occurrence of
 * > their start-tag in the XML (after expansion of entities). The attribute
 * > nodes of an element occur after the element and before its children. The
 * > relative order of attribute nodes is implementation-dependent.
 *
 * Source:
 * http://www.w3.org/TR/DOM-Level-3-Core/glossary.html#dt-document-order
 *
 * @category Helpers
 * @param nodeA The first node to use in the comparison
 * @param nodeB The second node to use in the comparison
 * @returns A bitmask describing the input nodes' relative position.
 *
 * See http://dom.spec.whatwg.org/#dom-node-comparedocumentposition for
 * a description of these values.
 */
function compareDocumentPosition$1(nodeA, nodeB) {
    const aParents = [];
    const bParents = [];
    if (nodeA === nodeB) {
        return 0;
    }
    let current = hasChildren$1(nodeA) ? nodeA : nodeA.parent;
    while (current) {
        aParents.unshift(current);
        current = current.parent;
    }
    current = hasChildren$1(nodeB) ? nodeB : nodeB.parent;
    while (current) {
        bParents.unshift(current);
        current = current.parent;
    }
    const maxIdx = Math.min(aParents.length, bParents.length);
    let idx = 0;
    while (idx < maxIdx && aParents[idx] === bParents[idx]) {
        idx++;
    }
    if (idx === 0) {
        return DocumentPosition.DISCONNECTED;
    }
    const sharedParent = aParents[idx - 1];
    const siblings = sharedParent.children;
    const aSibling = aParents[idx];
    const bSibling = bParents[idx];
    if (siblings.indexOf(aSibling) > siblings.indexOf(bSibling)) {
        if (sharedParent === nodeB) {
            return DocumentPosition.FOLLOWING | DocumentPosition.CONTAINED_BY;
        }
        return DocumentPosition.FOLLOWING;
    }
    if (sharedParent === nodeA) {
        return DocumentPosition.PRECEDING | DocumentPosition.CONTAINS;
    }
    return DocumentPosition.PRECEDING;
}
/**
 * Sort an array of nodes based on their relative position in the document,
 * removing any duplicate nodes. If the array contains nodes that do not belong
 * to the same document, sort order is unspecified.
 *
 * @category Helpers
 * @param nodes Array of DOM nodes.
 * @returns Collection of unique nodes, sorted in document order.
 */
function uniqueSort$1(nodes) {
    nodes = nodes.filter((node, i, arr) => !arr.includes(node, i + 1));
    nodes.sort((a, b) => {
        const relative = compareDocumentPosition$1(a, b);
        if (relative & DocumentPosition.PRECEDING) {
            return -1;
        }
        else if (relative & DocumentPosition.FOLLOWING) {
            return 1;
        }
        return 0;
    });
    return nodes;
}

/**
 * Get the feed object from the root of a DOM tree.
 *
 * @category Feeds
 * @param doc - The DOM to to extract the feed from.
 * @returns The feed.
 */
function getFeed$1(doc) {
    const feedRoot = getOneElement$1(isValidFeed$1, doc);
    return !feedRoot
        ? null
        : feedRoot.name === "feed"
            ? getAtomFeed$1(feedRoot)
            : getRssFeed$1(feedRoot);
}
/**
 * Parse an Atom feed.
 *
 * @param feedRoot The root of the feed.
 * @returns The parsed feed.
 */
function getAtomFeed$1(feedRoot) {
    var _a;
    const childs = feedRoot.children;
    const feed = {
        type: "atom",
        items: getElementsByTagName$1("entry", childs).map((item) => {
            var _a;
            const { children } = item;
            const entry = { media: getMediaElements$1(children) };
            addConditionally$1(entry, "id", "id", children);
            addConditionally$1(entry, "title", "title", children);
            const href = (_a = getOneElement$1("link", children)) === null || _a === void 0 ? void 0 : _a.attribs["href"];
            if (href) {
                entry.link = href;
            }
            const description = fetch$2("summary", children) || fetch$2("content", children);
            if (description) {
                entry.description = description;
            }
            const pubDate = fetch$2("updated", children);
            if (pubDate) {
                entry.pubDate = new Date(pubDate);
            }
            return entry;
        }),
    };
    addConditionally$1(feed, "id", "id", childs);
    addConditionally$1(feed, "title", "title", childs);
    const href = (_a = getOneElement$1("link", childs)) === null || _a === void 0 ? void 0 : _a.attribs["href"];
    if (href) {
        feed.link = href;
    }
    addConditionally$1(feed, "description", "subtitle", childs);
    const updated = fetch$2("updated", childs);
    if (updated) {
        feed.updated = new Date(updated);
    }
    addConditionally$1(feed, "author", "email", childs, true);
    return feed;
}
/**
 * Parse a RSS feed.
 *
 * @param feedRoot The root of the feed.
 * @returns The parsed feed.
 */
function getRssFeed$1(feedRoot) {
    var _a, _b;
    const childs = (_b = (_a = getOneElement$1("channel", feedRoot.children)) === null || _a === void 0 ? void 0 : _a.children) !== null && _b !== void 0 ? _b : [];
    const feed = {
        type: feedRoot.name.substr(0, 3),
        id: "",
        items: getElementsByTagName$1("item", feedRoot.children).map((item) => {
            const { children } = item;
            const entry = { media: getMediaElements$1(children) };
            addConditionally$1(entry, "id", "guid", children);
            addConditionally$1(entry, "title", "title", children);
            addConditionally$1(entry, "link", "link", children);
            addConditionally$1(entry, "description", "description", children);
            const pubDate = fetch$2("pubDate", children) || fetch$2("dc:date", children);
            if (pubDate)
                entry.pubDate = new Date(pubDate);
            return entry;
        }),
    };
    addConditionally$1(feed, "title", "title", childs);
    addConditionally$1(feed, "link", "link", childs);
    addConditionally$1(feed, "description", "description", childs);
    const updated = fetch$2("lastBuildDate", childs);
    if (updated) {
        feed.updated = new Date(updated);
    }
    addConditionally$1(feed, "author", "managingEditor", childs, true);
    return feed;
}
const MEDIA_KEYS_STRING$1 = ["url", "type", "lang"];
const MEDIA_KEYS_INT$1 = [
    "fileSize",
    "bitrate",
    "framerate",
    "samplingrate",
    "channels",
    "duration",
    "height",
    "width",
];
/**
 * Get all media elements of a feed item.
 *
 * @param where Nodes to search in.
 * @returns Media elements.
 */
function getMediaElements$1(where) {
    return getElementsByTagName$1("media:content", where).map((elem) => {
        const { attribs } = elem;
        const media = {
            medium: attribs["medium"],
            isDefault: !!attribs["isDefault"],
        };
        for (const attrib of MEDIA_KEYS_STRING$1) {
            if (attribs[attrib]) {
                media[attrib] = attribs[attrib];
            }
        }
        for (const attrib of MEDIA_KEYS_INT$1) {
            if (attribs[attrib]) {
                media[attrib] = parseInt(attribs[attrib], 10);
            }
        }
        if (attribs["expression"]) {
            media.expression = attribs["expression"];
        }
        return media;
    });
}
/**
 * Get one element by tag name.
 *
 * @param tagName Tag name to look for
 * @param node Node to search in
 * @returns The element or null
 */
function getOneElement$1(tagName, node) {
    return getElementsByTagName$1(tagName, node, true, 1)[0];
}
/**
 * Get the text content of an element with a certain tag name.
 *
 * @param tagName Tag name to look for.
 * @param where Node to search in.
 * @param recurse Whether to recurse into child nodes.
 * @returns The text content of the element.
 */
function fetch$2(tagName, where, recurse = false) {
    return textContent$1(getElementsByTagName$1(tagName, where, recurse, 1)).trim();
}
/**
 * Adds a property to an object if it has a value.
 *
 * @param obj Object to be extended
 * @param prop Property name
 * @param tagName Tag name that contains the conditionally added property
 * @param where Element to search for the property
 * @param recurse Whether to recurse into child nodes.
 */
function addConditionally$1(obj, prop, tagName, where, recurse = false) {
    const val = fetch$2(tagName, where, recurse);
    if (val)
        obj[prop] = val;
}
/**
 * Checks if an element is a feed root node.
 *
 * @param value The name of the element to check.
 * @returns Whether an element is a feed root node.
 */
function isValidFeed$1(value) {
    return value === "rss" || value === "feed" || value === "rdf:RDF";
}

var DomUtils = /*#__PURE__*/Object.freeze({
    __proto__: null,
    isTag: isTag$2,
    isCDATA: isCDATA$1,
    isText: isText$1,
    isComment: isComment$1,
    isDocument: isDocument$1,
    hasChildren: hasChildren$1,
    getOuterHTML: getOuterHTML$1,
    getInnerHTML: getInnerHTML$1,
    getText: getText$2,
    textContent: textContent$1,
    innerText: innerText$1,
    getChildren: getChildren$2,
    getParent: getParent$2,
    getSiblings: getSiblings$2,
    getAttributeValue: getAttributeValue$2,
    hasAttrib: hasAttrib$2,
    getName: getName$2,
    nextElementSibling: nextElementSibling$1,
    prevElementSibling: prevElementSibling$1,
    removeElement: removeElement$1,
    replaceElement: replaceElement$1,
    appendChild: appendChild$1,
    append: append$3,
    prependChild: prependChild$1,
    prepend: prepend$2,
    filter: filter$4,
    find: find$3,
    findOneChild: findOneChild$1,
    findOne: findOne$2,
    existsOne: existsOne$2,
    findAll: findAll$2,
    testElement: testElement$1,
    getElements: getElements$1,
    getElementById: getElementById$1,
    getElementsByTagName: getElementsByTagName$1,
    getElementsByTagType: getElementsByTagType$1,
    removeSubsets: removeSubsets$2,
    get DocumentPosition () { return DocumentPosition; },
    compareDocumentPosition: compareDocumentPosition$1,
    uniqueSort: uniqueSort$1,
    getFeed: getFeed$1
});

/**
 * Helper function to render a DOM.
 *
 * @param that - Cheerio instance to render.
 * @param dom - The DOM to render. Defaults to `that`'s root.
 * @param options - Options for rendering.
 * @returns The rendered document.
 */
function render$1(that, dom, options) {
    if (!that)
        return '';
    return that(dom !== null && dom !== void 0 ? dom : that._root.children, null, undefined, options).toString();
}
/**
 * Checks if a passed object is an options object.
 *
 * @param dom - Object to check if it is an options object.
 * @returns Whether the object is an options object.
 */
function isOptions(dom, options) {
    return (!options &&
        typeof dom === 'object' &&
        dom != null &&
        !('length' in dom) &&
        !('type' in dom));
}
function html$2(dom, options) {
    /*
     * Be flexible about parameters, sometimes we call html(),
     * with options as only parameter
     * check dom argument for dom element specific properties
     * assume there is no 'length' or 'type' properties in the options object
     */
    const toRender = isOptions(dom) ? ((options = dom), undefined) : dom;
    /*
     * Sometimes `$.html()` is used without preloading html,
     * so fallback non-existing options to the default ones.
     */
    const opts = {
        ...defaultOpts$2,
        ...this === null || this === void 0 ? void 0 : this._options,
        ...flatten$1(options !== null && options !== void 0 ? options : {}),
    };
    return render$1(this, toRender, opts);
}
/**
 * Render the document as XML.
 *
 * @param dom - Element to render.
 * @returns THe rendered document.
 */
function xml(dom) {
    const options = { ...this._options, xmlMode: true };
    return render$1(this, dom, options);
}
/**
 * Render the document as text.
 *
 * This returns the `textContent` of the passed elements. The result will
 * include the contents of `script` and `stype` elements. To avoid this, use
 * `.prop('innerText')` instead.
 *
 * @param elements - Elements to render.
 * @returns The rendered document.
 */
function text$2(elements) {
    const elems = elements ? elements : this ? this.root() : [];
    let ret = '';
    for (let i = 0; i < elems.length; i++) {
        ret += textContent$1(elems[i]);
    }
    return ret;
}
function parseHTML(data, context, keepScripts = typeof context === 'boolean' ? context : false) {
    if (!data || typeof data !== 'string') {
        return null;
    }
    if (typeof context === 'boolean') {
        keepScripts = context;
    }
    const parsed = this.load(data, defaultOpts$2, false);
    if (!keepScripts) {
        parsed('script').remove();
    }
    /*
     * The `children` array is used by Cheerio internally to group elements that
     * share the same parents. When nodes created through `parseHTML` are
     * inserted into previously-existing DOM structures, they will be removed
     * from the `children` array. The results of `parseHTML` should remain
     * constant across these operations, so a shallow copy should be returned.
     */
    return parsed.root()[0].children.slice();
}
/**
 * Sometimes you need to work with the top-level root element. To query it, you
 * can use `$.root()`.
 *
 * @example
 *
 * ```js
 * $.root().append('<ul id="vegetables"></ul>').html();
 * //=> <ul id="fruits">...</ul><ul id="vegetables"></ul>
 * ```
 *
 * @returns Cheerio instance wrapping the root node.
 * @alias Cheerio.root
 */
function root$1() {
    return this(this._root);
}
/**
 * Checks to see if the `contained` DOM element is a descendant of the
 * `container` DOM element.
 *
 * @param container - Potential parent node.
 * @param contained - Potential child node.
 * @returns Indicates if the nodes contain one another.
 * @alias Cheerio.contains
 * @see {@link https://api.jquery.com/jQuery.contains/}
 */
function contains$1(container, contained) {
    // According to the jQuery API, an element does not "contain" itself
    if (contained === container) {
        return false;
    }
    /*
     * Step up the descendants, stopping when the root element is reached
     * (signaled by `.parent` returning a reference to the same object)
     */
    let next = contained;
    while (next && next !== next.parent) {
        next = next.parent;
        if (next === container) {
            return true;
        }
    }
    return false;
}
/**
 * $.merge().
 *
 * @param arr1 - First array.
 * @param arr2 - Second array.
 * @returns `arr1`, with elements of `arr2` inserted.
 * @alias Cheerio.merge
 * @see {@link https://api.jquery.com/jQuery.merge/}
 */
function merge$2(arr1, arr2) {
    if (!isArrayLike(arr1) || !isArrayLike(arr2)) {
        return;
    }
    let newLength = arr1.length;
    const len = +arr2.length;
    for (let i = 0; i < len; i++) {
        arr1[newLength++] = arr2[i];
    }
    arr1.length = newLength;
    return arr1;
}
/**
 * Checks if an object is array-like.
 *
 * @param item - Item to check.
 * @returns Indicates if the item is array-like.
 */
function isArrayLike(item) {
    if (Array.isArray(item)) {
        return true;
    }
    if (typeof item !== 'object' ||
        !Object.prototype.hasOwnProperty.call(item, 'length') ||
        typeof item.length !== 'number' ||
        item.length < 0) {
        return false;
    }
    for (let i = 0; i < item.length; i++) {
        if (!(i in item)) {
            return false;
        }
    }
    return true;
}

var staticMethods = /*#__PURE__*/Object.freeze({
    __proto__: null,
    html: html$2,
    xml: xml,
    text: text$2,
    parseHTML: parseHTML,
    root: root$1,
    contains: contains$1,
    merge: merge$2
});

/**
 * Checks if an object is a Cheerio instance.
 *
 * @category Utils
 * @param maybeCheerio - The object to check.
 * @returns Whether the object is a Cheerio instance.
 */
function isCheerio(maybeCheerio) {
    return maybeCheerio.cheerio != null;
}
/**
 * Convert a string to camel case notation.
 *
 * @private
 * @category Utils
 * @param str - The string to be converted.
 * @returns String in camel case notation.
 */
function camelCase(str) {
    return str.replace(/[_.-](\w|$)/g, (_, x) => x.toUpperCase());
}
/**
 * Convert a string from camel case to "CSS case", where word boundaries are
 * described by hyphens ("-") and all characters are lower-case.
 *
 * @private
 * @category Utils
 * @param str - The string to be converted.
 * @returns String in "CSS case".
 */
function cssCase(str) {
    return str.replace(/[A-Z]/g, '-$&').toLowerCase();
}
/**
 * Iterate over each DOM element without creating intermediary Cheerio instances.
 *
 * This is indented for use internally to avoid otherwise unnecessary memory
 * pressure introduced by _make.
 *
 * @category Utils
 * @param array - The array to iterate over.
 * @param fn - Function to call.
 * @returns The original instance.
 */
function domEach(array, fn) {
    const len = array.length;
    for (let i = 0; i < len; i++)
        fn(array[i], i);
    return array;
}
/**
 * Create a deep copy of the given DOM structure. Sets the parents of the copies
 * of the passed nodes to `null`.
 *
 * @private
 * @category Utils
 * @param dom - The domhandler-compliant DOM structure.
 * @returns - The cloned DOM.
 */
function cloneDom(dom) {
    const clone = 'length' in dom
        ? Array.prototype.map.call(dom, (el) => cloneNode$2(el, true))
        : [cloneNode$2(dom, true)];
    // Add a root node around the cloned nodes
    const root = new Document$1(clone);
    clone.forEach((node) => {
        node.parent = root;
    });
    return clone;
}
var CharacterCodes;
(function (CharacterCodes) {
    CharacterCodes[CharacterCodes["LowerA"] = 97] = "LowerA";
    CharacterCodes[CharacterCodes["LowerZ"] = 122] = "LowerZ";
    CharacterCodes[CharacterCodes["UpperA"] = 65] = "UpperA";
    CharacterCodes[CharacterCodes["UpperZ"] = 90] = "UpperZ";
    CharacterCodes[CharacterCodes["Exclamation"] = 33] = "Exclamation";
})(CharacterCodes || (CharacterCodes = {}));
/**
 * Check if string is HTML.
 *
 * Tests for a `<` within a string, immediate followed by a letter and
 * eventually followed by a `>`.
 *
 * @private
 * @category Utils
 * @param str - The string to check.
 * @returns Indicates if `str` is HTML.
 */
function isHtml(str) {
    const tagStart = str.indexOf('<');
    if (tagStart < 0 || tagStart > str.length - 3)
        return false;
    const tagChar = str.charCodeAt(tagStart + 1);
    return (((tagChar >= CharacterCodes.LowerA && tagChar <= CharacterCodes.LowerZ) ||
        (tagChar >= CharacterCodes.UpperA && tagChar <= CharacterCodes.UpperZ) ||
        tagChar === CharacterCodes.Exclamation) &&
        str.includes('>', tagStart + 2));
}

/**
 * Methods for getting and modifying attributes.
 *
 * @module cheerio/attributes
 */
const hasOwn$1 = Object.prototype.hasOwnProperty;
const rspace = /\s+/;
const dataAttrPrefix = 'data-';
/*
 * Lookup table for coercing string data-* attributes to their corresponding
 * JavaScript primitives
 */
const primitives = {
    null: null,
    true: true,
    false: false,
};
// Attributes that are booleans
const rboolean = /^(?:autofocus|autoplay|async|checked|controls|defer|disabled|hidden|loop|multiple|open|readonly|required|scoped|selected)$/i;
// Matches strings that look like JSON objects or arrays
const rbrace$1 = /^{[^]*}$|^\[[^]*]$/;
function getAttr(elem, name, xmlMode) {
    var _a;
    if (!elem || !isTag$2(elem))
        return undefined;
    (_a = elem.attribs) !== null && _a !== void 0 ? _a : (elem.attribs = {});
    // Return the entire attribs object if no attribute specified
    if (!name) {
        return elem.attribs;
    }
    if (hasOwn$1.call(elem.attribs, name)) {
        // Get the (decoded) attribute
        return !xmlMode && rboolean.test(name) ? name : elem.attribs[name];
    }
    // Mimic the DOM and return text content as value for `option's`
    if (elem.name === 'option' && name === 'value') {
        return text$2(elem.children);
    }
    // Mimic DOM with default value for radios/checkboxes
    if (elem.name === 'input' &&
        (elem.attribs['type'] === 'radio' || elem.attribs['type'] === 'checkbox') &&
        name === 'value') {
        return 'on';
    }
    return undefined;
}
/**
 * Sets the value of an attribute. The attribute will be deleted if the value is `null`.
 *
 * @private
 * @param el - The element to set the attribute on.
 * @param name - The attribute's name.
 * @param value - The attribute's value.
 */
function setAttr(el, name, value) {
    if (value === null) {
        removeAttribute(el, name);
    }
    else {
        el.attribs[name] = `${value}`;
    }
}
function attr(name, value) {
    // Set the value (with attr map support)
    if (typeof name === 'object' || value !== undefined) {
        if (typeof value === 'function') {
            if (typeof name !== 'string') {
                {
                    throw new Error('Bad combination of arguments.');
                }
            }
            return domEach(this, (el, i) => {
                if (isTag$2(el))
                    setAttr(el, name, value.call(el, i, el.attribs[name]));
            });
        }
        return domEach(this, (el) => {
            if (!isTag$2(el))
                return;
            if (typeof name === 'object') {
                Object.keys(name).forEach((objName) => {
                    const objValue = name[objName];
                    setAttr(el, objName, objValue);
                });
            }
            else {
                setAttr(el, name, value);
            }
        });
    }
    return arguments.length > 1
        ? this
        : getAttr(this[0], name, this.options.xmlMode);
}
/**
 * Gets a node's prop.
 *
 * @private
 * @category Attributes
 * @param el - Element to get the prop of.
 * @param name - Name of the prop.
 * @returns The prop's value.
 */
function getProp(el, name, xmlMode) {
    return name in el
        ? // @ts-expect-error TS doesn't like us accessing the value directly here.
            el[name]
        : !xmlMode && rboolean.test(name)
            ? getAttr(el, name, false) !== undefined
            : getAttr(el, name, xmlMode);
}
/**
 * Sets the value of a prop.
 *
 * @private
 * @param el - The element to set the prop on.
 * @param name - The prop's name.
 * @param value - The prop's value.
 */
function setProp(el, name, value, xmlMode) {
    if (name in el) {
        // @ts-expect-error Overriding value
        el[name] = value;
    }
    else {
        setAttr(el, name, !xmlMode && rboolean.test(name) ? (value ? '' : null) : `${value}`);
    }
}
function prop$1(name, value) {
    var _a;
    if (typeof name === 'string' && value === undefined) {
        const el = this[0];
        if (!el || !isTag$2(el))
            return undefined;
        switch (name) {
            case 'style': {
                const property = this.css();
                const keys = Object.keys(property);
                keys.forEach((p, i) => {
                    property[i] = p;
                });
                property.length = keys.length;
                return property;
            }
            case 'tagName':
            case 'nodeName': {
                return el.name.toUpperCase();
            }
            case 'href':
            case 'src': {
                const prop = (_a = el.attribs) === null || _a === void 0 ? void 0 : _a[name];
                /* eslint-disable node/no-unsupported-features/node-builtins */
                if (typeof URL !== 'undefined' &&
                    ((name === 'href' && (el.tagName === 'a' || el.name === 'link')) ||
                        (name === 'src' &&
                            (el.tagName === 'img' ||
                                el.tagName === 'iframe' ||
                                el.tagName === 'audio' ||
                                el.tagName === 'video' ||
                                el.tagName === 'source'))) &&
                    prop !== undefined &&
                    this.options.baseURI) {
                    return new URL(prop, this.options.baseURI).href;
                }
                /* eslint-enable node/no-unsupported-features/node-builtins */
                return prop;
            }
            case 'innerText': {
                return innerText$1(el);
            }
            case 'textContent': {
                return textContent$1(el);
            }
            case 'outerHTML':
                return this.clone().wrap('<container />').parent().html();
            case 'innerHTML':
                return this.html();
            default:
                return getProp(el, name, this.options.xmlMode);
        }
    }
    if (typeof name === 'object' || value !== undefined) {
        if (typeof value === 'function') {
            if (typeof name === 'object') {
                throw new Error('Bad combination of arguments.');
            }
            return domEach(this, (el, i) => {
                if (isTag$2(el)) {
                    setProp(el, name, value.call(el, i, getProp(el, name, this.options.xmlMode)), this.options.xmlMode);
                }
            });
        }
        return domEach(this, (el) => {
            if (!isTag$2(el))
                return;
            if (typeof name === 'object') {
                Object.keys(name).forEach((key) => {
                    const val = name[key];
                    setProp(el, key, val, this.options.xmlMode);
                });
            }
            else {
                setProp(el, name, value, this.options.xmlMode);
            }
        });
    }
    return undefined;
}
/**
 * Sets the value of a data attribute.
 *
 * @private
 * @param el - The element to set the data attribute on.
 * @param name - The data attribute's name.
 * @param value - The data attribute's value.
 */
function setData(el, name, value) {
    var _a;
    const elem = el;
    (_a = elem.data) !== null && _a !== void 0 ? _a : (elem.data = {});
    if (typeof name === 'object')
        Object.assign(elem.data, name);
    else if (typeof name === 'string' && value !== undefined) {
        elem.data[name] = value;
    }
}
/**
 * Read the specified attribute from the equivalent HTML5 `data-*` attribute,
 * and (if present) cache the value in the node's internal data store. If no
 * attribute name is specified, read _all_ HTML5 `data-*` attributes in this manner.
 *
 * @private
 * @category Attributes
 * @param el - Element to get the data attribute of.
 * @param name - Name of the data attribute.
 * @returns The data attribute's value, or a map with all of the data attributes.
 */
function readData(el, name) {
    let domNames;
    let jsNames;
    let value;
    if (name == null) {
        domNames = Object.keys(el.attribs).filter((attrName) => attrName.startsWith(dataAttrPrefix));
        jsNames = domNames.map((domName) => camelCase(domName.slice(dataAttrPrefix.length)));
    }
    else {
        domNames = [dataAttrPrefix + cssCase(name)];
        jsNames = [name];
    }
    for (let idx = 0; idx < domNames.length; ++idx) {
        const domName = domNames[idx];
        const jsName = jsNames[idx];
        if (hasOwn$1.call(el.attribs, domName) &&
            !hasOwn$1.call(el.data, jsName)) {
            value = el.attribs[domName];
            if (hasOwn$1.call(primitives, value)) {
                value = primitives[value];
            }
            else if (value === String(Number(value))) {
                value = Number(value);
            }
            else if (rbrace$1.test(value)) {
                try {
                    value = JSON.parse(value);
                }
                catch (e) {
                    /* Ignore */
                }
            }
            el.data[jsName] = value;
        }
    }
    return name == null ? el.data : value;
}
function data$2(name, value) {
    var _a;
    const elem = this[0];
    if (!elem || !isTag$2(elem))
        return;
    const dataEl = elem;
    (_a = dataEl.data) !== null && _a !== void 0 ? _a : (dataEl.data = {});
    // Return the entire data object if no data specified
    if (!name) {
        return readData(dataEl);
    }
    // Set the value (with attr map support)
    if (typeof name === 'object' || value !== undefined) {
        domEach(this, (el) => {
            if (isTag$2(el)) {
                if (typeof name === 'object')
                    setData(el, name);
                else
                    setData(el, name, value);
            }
        });
        return this;
    }
    if (hasOwn$1.call(dataEl.data, name)) {
        return dataEl.data[name];
    }
    return readData(dataEl, name);
}
function val(value) {
    const querying = arguments.length === 0;
    const element = this[0];
    if (!element || !isTag$2(element))
        return querying ? undefined : this;
    switch (element.name) {
        case 'textarea':
            return this.text(value);
        case 'select': {
            const option = this.find('option:selected');
            if (!querying) {
                if (this.attr('multiple') == null && typeof value === 'object') {
                    return this;
                }
                this.find('option').removeAttr('selected');
                const values = typeof value !== 'object' ? [value] : value;
                for (let i = 0; i < values.length; i++) {
                    this.find(`option[value="${values[i]}"]`).attr('selected', '');
                }
                return this;
            }
            return this.attr('multiple')
                ? option.toArray().map((el) => text$2(el.children))
                : option.attr('value');
        }
        case 'input':
        case 'option':
            return querying
                ? this.attr('value')
                : this.attr('value', value);
    }
    return undefined;
}
/**
 * Remove an attribute.
 *
 * @private
 * @param elem - Node to remove attribute from.
 * @param name - Name of the attribute to remove.
 */
function removeAttribute(elem, name) {
    if (!elem.attribs || !hasOwn$1.call(elem.attribs, name))
        return;
    delete elem.attribs[name];
}
/**
 * Splits a space-separated list of names to individual names.
 *
 * @category Attributes
 * @param names - Names to split.
 * @returns - Split names.
 */
function splitNames(names) {
    return names ? names.trim().split(rspace) : [];
}
/**
 * Method for removing attributes by `name`.
 *
 * @category Attributes
 * @example
 *
 * ```js
 * $('.pear').removeAttr('class').html();
 * //=> <li>Pear</li>
 *
 * $('.apple').attr('id', 'favorite');
 * $('.apple').removeAttr('id class').html();
 * //=> <li>Apple</li>
 * ```
 *
 * @param name - Name of the attribute.
 * @returns The instance itself.
 * @see {@link https://api.jquery.com/removeAttr/}
 */
function removeAttr(name) {
    const attrNames = splitNames(name);
    for (let i = 0; i < attrNames.length; i++) {
        domEach(this, (elem) => {
            if (isTag$2(elem))
                removeAttribute(elem, attrNames[i]);
        });
    }
    return this;
}
/**
 * Check to see if _any_ of the matched elements have the given `className`.
 *
 * @category Attributes
 * @example
 *
 * ```js
 * $('.pear').hasClass('pear');
 * //=> true
 *
 * $('apple').hasClass('fruit');
 * //=> false
 *
 * $('li').hasClass('pear');
 * //=> true
 * ```
 *
 * @param className - Name of the class.
 * @returns Indicates if an element has the given `className`.
 * @see {@link https://api.jquery.com/hasClass/}
 */
function hasClass(className) {
    return this.toArray().some((elem) => {
        const clazz = isTag$2(elem) && elem.attribs['class'];
        let idx = -1;
        if (clazz && className.length) {
            while ((idx = clazz.indexOf(className, idx + 1)) > -1) {
                const end = idx + className.length;
                if ((idx === 0 || rspace.test(clazz[idx - 1])) &&
                    (end === clazz.length || rspace.test(clazz[end]))) {
                    return true;
                }
            }
        }
        return false;
    });
}
/**
 * Adds class(es) to all of the matched elements. Also accepts a `function`.
 *
 * @category Attributes
 * @example
 *
 * ```js
 * $('.pear').addClass('fruit').html();
 * //=> <li class="pear fruit">Pear</li>
 *
 * $('.apple').addClass('fruit red').html();
 * //=> <li class="apple fruit red">Apple</li>
 * ```
 *
 * @param value - Name of new class.
 * @returns The instance itself.
 * @see {@link https://api.jquery.com/addClass/}
 */
function addClass(value) {
    // Support functions
    if (typeof value === 'function') {
        return domEach(this, (el, i) => {
            if (isTag$2(el)) {
                const className = el.attribs['class'] || '';
                addClass.call([el], value.call(el, i, className));
            }
        });
    }
    // Return if no value or not a string or function
    if (!value || typeof value !== 'string')
        return this;
    const classNames = value.split(rspace);
    const numElements = this.length;
    for (let i = 0; i < numElements; i++) {
        const el = this[i];
        // If selected element isn't a tag, move on
        if (!isTag$2(el))
            continue;
        // If we don't already have classes — always set xmlMode to false here, as it doesn't matter for classes
        const className = getAttr(el, 'class', false);
        if (!className) {
            setAttr(el, 'class', classNames.join(' ').trim());
        }
        else {
            let setClass = ` ${className} `;
            // Check if class already exists
            for (let j = 0; j < classNames.length; j++) {
                const appendClass = `${classNames[j]} `;
                if (!setClass.includes(` ${appendClass}`))
                    setClass += appendClass;
            }
            setAttr(el, 'class', setClass.trim());
        }
    }
    return this;
}
/**
 * Removes one or more space-separated classes from the selected elements. If no
 * `className` is defined, all classes will be removed. Also accepts a `function`.
 *
 * @category Attributes
 * @example
 *
 * ```js
 * $('.pear').removeClass('pear').html();
 * //=> <li class="">Pear</li>
 *
 * $('.apple').addClass('red').removeClass().html();
 * //=> <li class="">Apple</li>
 * ```
 *
 * @param name - Name of the class. If not specified, removes all elements.
 * @returns The instance itself.
 * @see {@link https://api.jquery.com/removeClass/}
 */
function removeClass(name) {
    // Handle if value is a function
    if (typeof name === 'function') {
        return domEach(this, (el, i) => {
            if (isTag$2(el)) {
                removeClass.call([el], name.call(el, i, el.attribs['class'] || ''));
            }
        });
    }
    const classes = splitNames(name);
    const numClasses = classes.length;
    const removeAll = arguments.length === 0;
    return domEach(this, (el) => {
        if (!isTag$2(el))
            return;
        if (removeAll) {
            // Short circuit the remove all case as this is the nice one
            el.attribs['class'] = '';
        }
        else {
            const elClasses = splitNames(el.attribs['class']);
            let changed = false;
            for (let j = 0; j < numClasses; j++) {
                const index = elClasses.indexOf(classes[j]);
                if (index >= 0) {
                    elClasses.splice(index, 1);
                    changed = true;
                    /*
                     * We have to do another pass to ensure that there are not duplicate
                     * classes listed
                     */
                    j--;
                }
            }
            if (changed) {
                el.attribs['class'] = elClasses.join(' ');
            }
        }
    });
}
/**
 * Add or remove class(es) from the matched elements, depending on either the
 * class's presence or the value of the switch argument. Also accepts a `function`.
 *
 * @category Attributes
 * @example
 *
 * ```js
 * $('.apple.green').toggleClass('fruit green red').html();
 * //=> <li class="apple fruit red">Apple</li>
 *
 * $('.apple.green').toggleClass('fruit green red', true).html();
 * //=> <li class="apple green fruit red">Apple</li>
 * ```
 *
 * @param value - Name of the class. Can also be a function.
 * @param stateVal - If specified the state of the class.
 * @returns The instance itself.
 * @see {@link https://api.jquery.com/toggleClass/}
 */
function toggleClass(value, stateVal) {
    // Support functions
    if (typeof value === 'function') {
        return domEach(this, (el, i) => {
            if (isTag$2(el)) {
                toggleClass.call([el], value.call(el, i, el.attribs['class'] || '', stateVal), stateVal);
            }
        });
    }
    // Return if no value or not a string or function
    if (!value || typeof value !== 'string')
        return this;
    const classNames = value.split(rspace);
    const numClasses = classNames.length;
    const state = typeof stateVal === 'boolean' ? (stateVal ? 1 : -1) : 0;
    const numElements = this.length;
    for (let i = 0; i < numElements; i++) {
        const el = this[i];
        // If selected element isn't a tag, move on
        if (!isTag$2(el))
            continue;
        const elementClasses = splitNames(el.attribs['class']);
        // Check if class already exists
        for (let j = 0; j < numClasses; j++) {
            // Check if the class name is currently defined
            const index = elementClasses.indexOf(classNames[j]);
            // Add if stateValue === true or we are toggling and there is no value
            if (state >= 0 && index < 0) {
                elementClasses.push(classNames[j]);
            }
            else if (state <= 0 && index >= 0) {
                // Otherwise remove but only if the item exists
                elementClasses.splice(index, 1);
            }
        }
        el.attribs['class'] = elementClasses.join(' ');
    }
    return this;
}

var Attributes = /*#__PURE__*/Object.freeze({
    __proto__: null,
    attr: attr,
    prop: prop$1,
    data: data$2,
    val: val,
    removeAttr: removeAttr,
    hasClass: hasClass,
    addClass: addClass,
    removeClass: removeClass,
    toggleClass: toggleClass
});

var SelectorType;
(function (SelectorType) {
    SelectorType["Attribute"] = "attribute";
    SelectorType["Pseudo"] = "pseudo";
    SelectorType["PseudoElement"] = "pseudo-element";
    SelectorType["Tag"] = "tag";
    SelectorType["Universal"] = "universal";
    // Traversals
    SelectorType["Adjacent"] = "adjacent";
    SelectorType["Child"] = "child";
    SelectorType["Descendant"] = "descendant";
    SelectorType["Parent"] = "parent";
    SelectorType["Sibling"] = "sibling";
    SelectorType["ColumnCombinator"] = "column-combinator";
})(SelectorType || (SelectorType = {}));
/**
 * Modes for ignore case.
 *
 * This could be updated to an enum, and the object is
 * the current stand-in that will allow code to be updated
 * without big changes.
 */
const IgnoreCaseMode = {
    Unknown: null,
    QuirksMode: "quirks",
    IgnoreCase: true,
    CaseSensitive: false,
};
var AttributeAction;
(function (AttributeAction) {
    AttributeAction["Any"] = "any";
    AttributeAction["Element"] = "element";
    AttributeAction["End"] = "end";
    AttributeAction["Equals"] = "equals";
    AttributeAction["Exists"] = "exists";
    AttributeAction["Hyphen"] = "hyphen";
    AttributeAction["Not"] = "not";
    AttributeAction["Start"] = "start";
})(AttributeAction || (AttributeAction = {}));

const reName = /^[^\\#]?(?:\\(?:[\da-f]{1,6}\s?|.)|[\w\-\u00b0-\uFFFF])+/;
const reEscape = /\\([\da-f]{1,6}\s?|(\s)|.)/gi;
const actionTypes = new Map([
    [126 /* Tilde */, AttributeAction.Element],
    [94 /* Circumflex */, AttributeAction.Start],
    [36 /* Dollar */, AttributeAction.End],
    [42 /* Asterisk */, AttributeAction.Any],
    [33 /* ExclamationMark */, AttributeAction.Not],
    [124 /* Pipe */, AttributeAction.Hyphen],
]);
// Pseudos, whose data property is parsed as well.
const unpackPseudos = new Set([
    "has",
    "not",
    "matches",
    "is",
    "where",
    "host",
    "host-context",
]);
/**
 * Checks whether a specific selector is a traversal.
 * This is useful eg. in swapping the order of elements that
 * are not traversals.
 *
 * @param selector Selector to check.
 */
function isTraversal$1(selector) {
    switch (selector.type) {
        case SelectorType.Adjacent:
        case SelectorType.Child:
        case SelectorType.Descendant:
        case SelectorType.Parent:
        case SelectorType.Sibling:
        case SelectorType.ColumnCombinator:
            return true;
        default:
            return false;
    }
}
const stripQuotesFromPseudos = new Set(["contains", "icontains"]);
// Unescape function taken from https://github.com/jquery/sizzle/blob/master/src/sizzle.js#L152
function funescape(_, escaped, escapedWhitespace) {
    const high = parseInt(escaped, 16) - 0x10000;
    // NaN means non-codepoint
    return high !== high || escapedWhitespace
        ? escaped
        : high < 0
            ? // BMP codepoint
                String.fromCharCode(high + 0x10000)
            : // Supplemental Plane codepoint (surrogate pair)
                String.fromCharCode((high >> 10) | 0xd800, (high & 0x3ff) | 0xdc00);
}
function unescapeCSS(str) {
    return str.replace(reEscape, funescape);
}
function isQuote(c) {
    return c === 39 /* SingleQuote */ || c === 34 /* DoubleQuote */;
}
function isWhitespace$2(c) {
    return (c === 32 /* Space */ ||
        c === 9 /* Tab */ ||
        c === 10 /* NewLine */ ||
        c === 12 /* FormFeed */ ||
        c === 13 /* CarriageReturn */);
}
/**
 * Parses `selector`, optionally with the passed `options`.
 *
 * @param selector Selector to parse.
 * @param options Options for parsing.
 * @returns Returns a two-dimensional array.
 * The first dimension represents selectors separated by commas (eg. `sub1, sub2`),
 * the second contains the relevant tokens for that selector.
 */
function parse$m(selector) {
    const subselects = [];
    const endIndex = parseSelector(subselects, `${selector}`, 0);
    if (endIndex < selector.length) {
        throw new Error(`Unmatched selector: ${selector.slice(endIndex)}`);
    }
    return subselects;
}
function parseSelector(subselects, selector, selectorIndex) {
    let tokens = [];
    function getName(offset) {
        const match = selector.slice(selectorIndex + offset).match(reName);
        if (!match) {
            throw new Error(`Expected name, found ${selector.slice(selectorIndex)}`);
        }
        const [name] = match;
        selectorIndex += offset + name.length;
        return unescapeCSS(name);
    }
    function stripWhitespace(offset) {
        selectorIndex += offset;
        while (selectorIndex < selector.length &&
            isWhitespace$2(selector.charCodeAt(selectorIndex))) {
            selectorIndex++;
        }
    }
    function readValueWithParenthesis() {
        selectorIndex += 1;
        const start = selectorIndex;
        let counter = 1;
        for (; counter > 0 && selectorIndex < selector.length; selectorIndex++) {
            if (selector.charCodeAt(selectorIndex) ===
                40 /* LeftParenthesis */ &&
                !isEscaped(selectorIndex)) {
                counter++;
            }
            else if (selector.charCodeAt(selectorIndex) ===
                41 /* RightParenthesis */ &&
                !isEscaped(selectorIndex)) {
                counter--;
            }
        }
        if (counter) {
            throw new Error("Parenthesis not matched");
        }
        return unescapeCSS(selector.slice(start, selectorIndex - 1));
    }
    function isEscaped(pos) {
        let slashCount = 0;
        while (selector.charCodeAt(--pos) === 92 /* BackSlash */)
            slashCount++;
        return (slashCount & 1) === 1;
    }
    function ensureNotTraversal() {
        if (tokens.length > 0 && isTraversal$1(tokens[tokens.length - 1])) {
            throw new Error("Did not expect successive traversals.");
        }
    }
    function addTraversal(type) {
        if (tokens.length > 0 &&
            tokens[tokens.length - 1].type === SelectorType.Descendant) {
            tokens[tokens.length - 1].type = type;
            return;
        }
        ensureNotTraversal();
        tokens.push({ type });
    }
    function addSpecialAttribute(name, action) {
        tokens.push({
            type: SelectorType.Attribute,
            name,
            action,
            value: getName(1),
            namespace: null,
            ignoreCase: "quirks",
        });
    }
    /**
     * We have finished parsing the current part of the selector.
     *
     * Remove descendant tokens at the end if they exist,
     * and return the last index, so that parsing can be
     * picked up from here.
     */
    function finalizeSubselector() {
        if (tokens.length &&
            tokens[tokens.length - 1].type === SelectorType.Descendant) {
            tokens.pop();
        }
        if (tokens.length === 0) {
            throw new Error("Empty sub-selector");
        }
        subselects.push(tokens);
    }
    stripWhitespace(0);
    if (selector.length === selectorIndex) {
        return selectorIndex;
    }
    loop: while (selectorIndex < selector.length) {
        const firstChar = selector.charCodeAt(selectorIndex);
        switch (firstChar) {
            // Whitespace
            case 32 /* Space */:
            case 9 /* Tab */:
            case 10 /* NewLine */:
            case 12 /* FormFeed */:
            case 13 /* CarriageReturn */: {
                if (tokens.length === 0 ||
                    tokens[0].type !== SelectorType.Descendant) {
                    ensureNotTraversal();
                    tokens.push({ type: SelectorType.Descendant });
                }
                stripWhitespace(1);
                break;
            }
            // Traversals
            case 62 /* GreaterThan */: {
                addTraversal(SelectorType.Child);
                stripWhitespace(1);
                break;
            }
            case 60 /* LessThan */: {
                addTraversal(SelectorType.Parent);
                stripWhitespace(1);
                break;
            }
            case 126 /* Tilde */: {
                addTraversal(SelectorType.Sibling);
                stripWhitespace(1);
                break;
            }
            case 43 /* Plus */: {
                addTraversal(SelectorType.Adjacent);
                stripWhitespace(1);
                break;
            }
            // Special attribute selectors: .class, #id
            case 46 /* Period */: {
                addSpecialAttribute("class", AttributeAction.Element);
                break;
            }
            case 35 /* Hash */: {
                addSpecialAttribute("id", AttributeAction.Equals);
                break;
            }
            case 91 /* LeftSquareBracket */: {
                stripWhitespace(1);
                // Determine attribute name and namespace
                let name;
                let namespace = null;
                if (selector.charCodeAt(selectorIndex) === 124 /* Pipe */) {
                    // Equivalent to no namespace
                    name = getName(1);
                }
                else if (selector.startsWith("*|", selectorIndex)) {
                    namespace = "*";
                    name = getName(2);
                }
                else {
                    name = getName(0);
                    if (selector.charCodeAt(selectorIndex) === 124 /* Pipe */ &&
                        selector.charCodeAt(selectorIndex + 1) !==
                            61 /* Equal */) {
                        namespace = name;
                        name = getName(1);
                    }
                }
                stripWhitespace(0);
                // Determine comparison operation
                let action = AttributeAction.Exists;
                const possibleAction = actionTypes.get(selector.charCodeAt(selectorIndex));
                if (possibleAction) {
                    action = possibleAction;
                    if (selector.charCodeAt(selectorIndex + 1) !==
                        61 /* Equal */) {
                        throw new Error("Expected `=`");
                    }
                    stripWhitespace(2);
                }
                else if (selector.charCodeAt(selectorIndex) === 61 /* Equal */) {
                    action = AttributeAction.Equals;
                    stripWhitespace(1);
                }
                // Determine value
                let value = "";
                let ignoreCase = null;
                if (action !== "exists") {
                    if (isQuote(selector.charCodeAt(selectorIndex))) {
                        const quote = selector.charCodeAt(selectorIndex);
                        let sectionEnd = selectorIndex + 1;
                        while (sectionEnd < selector.length &&
                            (selector.charCodeAt(sectionEnd) !== quote ||
                                isEscaped(sectionEnd))) {
                            sectionEnd += 1;
                        }
                        if (selector.charCodeAt(sectionEnd) !== quote) {
                            throw new Error("Attribute value didn't end");
                        }
                        value = unescapeCSS(selector.slice(selectorIndex + 1, sectionEnd));
                        selectorIndex = sectionEnd + 1;
                    }
                    else {
                        const valueStart = selectorIndex;
                        while (selectorIndex < selector.length &&
                            ((!isWhitespace$2(selector.charCodeAt(selectorIndex)) &&
                                selector.charCodeAt(selectorIndex) !==
                                    93 /* RightSquareBracket */) ||
                                isEscaped(selectorIndex))) {
                            selectorIndex += 1;
                        }
                        value = unescapeCSS(selector.slice(valueStart, selectorIndex));
                    }
                    stripWhitespace(0);
                    // See if we have a force ignore flag
                    const forceIgnore = selector.charCodeAt(selectorIndex) | 0x20;
                    // If the forceIgnore flag is set (either `i` or `s`), use that value
                    if (forceIgnore === 115 /* LowerS */) {
                        ignoreCase = false;
                        stripWhitespace(1);
                    }
                    else if (forceIgnore === 105 /* LowerI */) {
                        ignoreCase = true;
                        stripWhitespace(1);
                    }
                }
                if (selector.charCodeAt(selectorIndex) !==
                    93 /* RightSquareBracket */) {
                    throw new Error("Attribute selector didn't terminate");
                }
                selectorIndex += 1;
                const attributeSelector = {
                    type: SelectorType.Attribute,
                    name,
                    action,
                    value,
                    namespace,
                    ignoreCase,
                };
                tokens.push(attributeSelector);
                break;
            }
            case 58 /* Colon */: {
                if (selector.charCodeAt(selectorIndex + 1) === 58 /* Colon */) {
                    tokens.push({
                        type: SelectorType.PseudoElement,
                        name: getName(2).toLowerCase(),
                        data: selector.charCodeAt(selectorIndex) ===
                            40 /* LeftParenthesis */
                            ? readValueWithParenthesis()
                            : null,
                    });
                    continue;
                }
                const name = getName(1).toLowerCase();
                let data = null;
                if (selector.charCodeAt(selectorIndex) ===
                    40 /* LeftParenthesis */) {
                    if (unpackPseudos.has(name)) {
                        if (isQuote(selector.charCodeAt(selectorIndex + 1))) {
                            throw new Error(`Pseudo-selector ${name} cannot be quoted`);
                        }
                        data = [];
                        selectorIndex = parseSelector(data, selector, selectorIndex + 1);
                        if (selector.charCodeAt(selectorIndex) !==
                            41 /* RightParenthesis */) {
                            throw new Error(`Missing closing parenthesis in :${name} (${selector})`);
                        }
                        selectorIndex += 1;
                    }
                    else {
                        data = readValueWithParenthesis();
                        if (stripQuotesFromPseudos.has(name)) {
                            const quot = data.charCodeAt(0);
                            if (quot === data.charCodeAt(data.length - 1) &&
                                isQuote(quot)) {
                                data = data.slice(1, -1);
                            }
                        }
                        data = unescapeCSS(data);
                    }
                }
                tokens.push({ type: SelectorType.Pseudo, name, data });
                break;
            }
            case 44 /* Comma */: {
                finalizeSubselector();
                tokens = [];
                stripWhitespace(1);
                break;
            }
            default: {
                if (selector.startsWith("/*", selectorIndex)) {
                    const endIndex = selector.indexOf("*/", selectorIndex + 2);
                    if (endIndex < 0) {
                        throw new Error("Comment was not terminated");
                    }
                    selectorIndex = endIndex + 2;
                    // Remove leading whitespace
                    if (tokens.length === 0) {
                        stripWhitespace(0);
                    }
                    break;
                }
                let namespace = null;
                let name;
                if (firstChar === 42 /* Asterisk */) {
                    selectorIndex += 1;
                    name = "*";
                }
                else if (firstChar === 124 /* Pipe */) {
                    name = "";
                    if (selector.charCodeAt(selectorIndex + 1) === 124 /* Pipe */) {
                        addTraversal(SelectorType.ColumnCombinator);
                        stripWhitespace(2);
                        break;
                    }
                }
                else if (reName.test(selector.slice(selectorIndex))) {
                    name = getName(0);
                }
                else {
                    break loop;
                }
                if (selector.charCodeAt(selectorIndex) === 124 /* Pipe */ &&
                    selector.charCodeAt(selectorIndex + 1) !== 124 /* Pipe */) {
                    namespace = name;
                    if (selector.charCodeAt(selectorIndex + 1) ===
                        42 /* Asterisk */) {
                        name = "*";
                        selectorIndex += 2;
                    }
                    else {
                        name = getName(1);
                    }
                }
                tokens.push(name === "*"
                    ? { type: SelectorType.Universal, namespace }
                    : { type: SelectorType.Tag, name, namespace });
            }
        }
    }
    finalizeSubselector();
    return selectorIndex;
}

const attribValChars = ["\\", '"'];
const pseudoValChars = [...attribValChars, "(", ")"];
const charsToEscapeInAttributeValue = new Set(attribValChars.map((c) => c.charCodeAt(0)));
const charsToEscapeInPseudoValue = new Set(pseudoValChars.map((c) => c.charCodeAt(0)));
const charsToEscapeInName = new Set([
    ...pseudoValChars,
    "~",
    "^",
    "$",
    "*",
    "+",
    "!",
    "|",
    ":",
    "[",
    "]",
    " ",
    ".",
].map((c) => c.charCodeAt(0)));
/**
 * Turns `selector` back into a string.
 *
 * @param selector Selector to stringify.
 */
function stringify$d(selector) {
    return selector
        .map((token) => token.map(stringifyToken).join(""))
        .join(", ");
}
function stringifyToken(token, index, arr) {
    switch (token.type) {
        // Simple types
        case SelectorType.Child:
            return index === 0 ? "> " : " > ";
        case SelectorType.Parent:
            return index === 0 ? "< " : " < ";
        case SelectorType.Sibling:
            return index === 0 ? "~ " : " ~ ";
        case SelectorType.Adjacent:
            return index === 0 ? "+ " : " + ";
        case SelectorType.Descendant:
            return " ";
        case SelectorType.ColumnCombinator:
            return index === 0 ? "|| " : " || ";
        case SelectorType.Universal:
            // Return an empty string if the selector isn't needed.
            return token.namespace === "*" &&
                index + 1 < arr.length &&
                "name" in arr[index + 1]
                ? ""
                : `${getNamespace(token.namespace)}*`;
        case SelectorType.Tag:
            return getNamespacedName(token);
        case SelectorType.PseudoElement:
            return `::${escapeName(token.name, charsToEscapeInName)}${token.data === null
                ? ""
                : `(${escapeName(token.data, charsToEscapeInPseudoValue)})`}`;
        case SelectorType.Pseudo:
            return `:${escapeName(token.name, charsToEscapeInName)}${token.data === null
                ? ""
                : `(${typeof token.data === "string"
                    ? escapeName(token.data, charsToEscapeInPseudoValue)
                    : stringify$d(token.data)})`}`;
        case SelectorType.Attribute: {
            if (token.name === "id" &&
                token.action === AttributeAction.Equals &&
                token.ignoreCase === "quirks" &&
                !token.namespace) {
                return `#${escapeName(token.value, charsToEscapeInName)}`;
            }
            if (token.name === "class" &&
                token.action === AttributeAction.Element &&
                token.ignoreCase === "quirks" &&
                !token.namespace) {
                return `.${escapeName(token.value, charsToEscapeInName)}`;
            }
            const name = getNamespacedName(token);
            if (token.action === AttributeAction.Exists) {
                return `[${name}]`;
            }
            return `[${name}${getActionValue(token.action)}="${escapeName(token.value, charsToEscapeInAttributeValue)}"${token.ignoreCase === null ? "" : token.ignoreCase ? " i" : " s"}]`;
        }
    }
}
function getActionValue(action) {
    switch (action) {
        case AttributeAction.Equals:
            return "";
        case AttributeAction.Element:
            return "~";
        case AttributeAction.Start:
            return "^";
        case AttributeAction.End:
            return "$";
        case AttributeAction.Any:
            return "*";
        case AttributeAction.Not:
            return "!";
        case AttributeAction.Hyphen:
            return "|";
        case AttributeAction.Exists:
            throw new Error("Shouldn't be here");
    }
}
function getNamespacedName(token) {
    return `${getNamespace(token.namespace)}${escapeName(token.name, charsToEscapeInName)}`;
}
function getNamespace(namespace) {
    return namespace !== null
        ? `${namespace === "*"
            ? "*"
            : escapeName(namespace, charsToEscapeInName)}|`
        : "";
}
function escapeName(str, charsToEscape) {
    let lastIdx = 0;
    let ret = "";
    for (let i = 0; i < str.length; i++) {
        if (charsToEscape.has(str.charCodeAt(i))) {
            ret += `${str.slice(lastIdx, i)}\\${str.charAt(i)}`;
            lastIdx = i + 1;
        }
    }
    return ret.length > 0 ? ret + str.slice(lastIdx) : str;
}

var es = /*#__PURE__*/Object.freeze({
    __proto__: null,
    isTraversal: isTraversal$1,
    parse: parse$m,
    stringify: stringify$d,
    get SelectorType () { return SelectorType; },
    IgnoreCaseMode: IgnoreCaseMode,
    get AttributeAction () { return AttributeAction; }
});

var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

function getDefaultExportFromCjs (x) {
	return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;
}

function getAugmentedNamespace(n) {
  if (n.__esModule) return n;
  var f = n.default;
	if (typeof f == "function") {
		var a = function a () {
			if (this instanceof a) {
        return Reflect.construct(f, arguments, this.constructor);
			}
			return f.apply(this, arguments);
		};
		a.prototype = f.prototype;
  } else a = {};
  Object.defineProperty(a, '__esModule', {value: true});
	Object.keys(n).forEach(function (k) {
		var d = Object.getOwnPropertyDescriptor(n, k);
		Object.defineProperty(a, k, d.get ? d : {
			enumerable: true,
			get: function () {
				return n[k];
			}
		});
	});
	return a;
}

var boolbase = {
	trueFunc: function trueFunc(){
		return true;
	},
	falseFunc: function falseFunc(){
		return false;
	}
};

var boolbase$1 = /*@__PURE__*/getDefaultExportFromCjs(boolbase);

const procedure$1 = new Map([
    [SelectorType.Universal, 50],
    [SelectorType.Tag, 30],
    [SelectorType.Attribute, 1],
    [SelectorType.Pseudo, 0],
]);
function isTraversal(token) {
    return !procedure$1.has(token.type);
}
const attributes$2 = new Map([
    [AttributeAction.Exists, 10],
    [AttributeAction.Equals, 8],
    [AttributeAction.Not, 7],
    [AttributeAction.Start, 6],
    [AttributeAction.End, 6],
    [AttributeAction.Any, 5],
]);
/**
 * Sort the parts of the passed selector,
 * as there is potential for optimization
 * (some types of selectors are faster than others)
 *
 * @param arr Selector to sort
 */
function sortByProcedure$1(arr) {
    const procs = arr.map(getProcedure$1);
    for (let i = 1; i < arr.length; i++) {
        const procNew = procs[i];
        if (procNew < 0)
            continue;
        for (let j = i - 1; j >= 0 && procNew < procs[j]; j--) {
            const token = arr[j + 1];
            arr[j + 1] = arr[j];
            arr[j] = token;
            procs[j + 1] = procs[j];
            procs[j] = procNew;
        }
    }
}
function getProcedure$1(token) {
    var _a, _b;
    let proc = (_a = procedure$1.get(token.type)) !== null && _a !== void 0 ? _a : -1;
    if (token.type === SelectorType.Attribute) {
        proc = (_b = attributes$2.get(token.action)) !== null && _b !== void 0 ? _b : 4;
        if (token.action === AttributeAction.Equals && token.name === "id") {
            // Prefer ID selectors (eg. #ID)
            proc = 9;
        }
        if (token.ignoreCase) {
            /*
             * IgnoreCase adds some overhead, prefer "normal" token
             * this is a binary operation, to ensure it's still an int
             */
            proc >>= 1;
        }
    }
    else if (token.type === SelectorType.Pseudo) {
        if (!token.data) {
            proc = 3;
        }
        else if (token.name === "has" || token.name === "contains") {
            proc = 0; // Expensive in any case
        }
        else if (Array.isArray(token.data)) {
            // Eg. :matches, :not
            proc = Math.min(...token.data.map((d) => Math.min(...d.map(getProcedure$1))));
            // If we have traversals, try to avoid executing this selector
            if (proc < 0) {
                proc = 0;
            }
        }
        else {
            proc = 2;
        }
    }
    return proc;
}

/**
 * All reserved characters in a regex, used for escaping.
 *
 * Taken from XRegExp, (c) 2007-2020 Steven Levithan under the MIT license
 * https://github.com/slevithan/xregexp/blob/95eeebeb8fac8754d54eafe2b4743661ac1cf028/src/xregexp.js#L794
 */
const reChars$1 = /[-[\]{}()*+?.,\\^$|#\s]/g;
function escapeRegex$1(value) {
    return value.replace(reChars$1, "\\$&");
}
/**
 * Attributes that are case-insensitive in HTML.
 *
 * @private
 * @see https://html.spec.whatwg.org/multipage/semantics-other.html#case-sensitivity-of-selectors
 */
const caseInsensitiveAttributes$1 = new Set([
    "accept",
    "accept-charset",
    "align",
    "alink",
    "axis",
    "bgcolor",
    "charset",
    "checked",
    "clear",
    "codetype",
    "color",
    "compact",
    "declare",
    "defer",
    "dir",
    "direction",
    "disabled",
    "enctype",
    "face",
    "frame",
    "hreflang",
    "http-equiv",
    "lang",
    "language",
    "link",
    "media",
    "method",
    "multiple",
    "nohref",
    "noresize",
    "noshade",
    "nowrap",
    "readonly",
    "rel",
    "rev",
    "rules",
    "scope",
    "scrolling",
    "selected",
    "shape",
    "target",
    "text",
    "type",
    "valign",
    "valuetype",
    "vlink",
]);
function shouldIgnoreCase$1(selector, options) {
    return typeof selector.ignoreCase === "boolean"
        ? selector.ignoreCase
        : selector.ignoreCase === "quirks"
            ? !!options.quirksMode
            : !options.xmlMode && caseInsensitiveAttributes$1.has(selector.name);
}
/**
 * Attribute selectors
 */
const attributeRules = {
    equals(next, data, options) {
        const { adapter } = options;
        const { name } = data;
        let { value } = data;
        if (shouldIgnoreCase$1(data, options)) {
            value = value.toLowerCase();
            return (elem) => {
                const attr = adapter.getAttributeValue(elem, name);
                return (attr != null &&
                    attr.length === value.length &&
                    attr.toLowerCase() === value &&
                    next(elem));
            };
        }
        return (elem) => adapter.getAttributeValue(elem, name) === value && next(elem);
    },
    hyphen(next, data, options) {
        const { adapter } = options;
        const { name } = data;
        let { value } = data;
        const len = value.length;
        if (shouldIgnoreCase$1(data, options)) {
            value = value.toLowerCase();
            return function hyphenIC(elem) {
                const attr = adapter.getAttributeValue(elem, name);
                return (attr != null &&
                    (attr.length === len || attr.charAt(len) === "-") &&
                    attr.substr(0, len).toLowerCase() === value &&
                    next(elem));
            };
        }
        return function hyphen(elem) {
            const attr = adapter.getAttributeValue(elem, name);
            return (attr != null &&
                (attr.length === len || attr.charAt(len) === "-") &&
                attr.substr(0, len) === value &&
                next(elem));
        };
    },
    element(next, data, options) {
        const { adapter } = options;
        const { name, value } = data;
        if (/\s/.test(value)) {
            return boolbase$1.falseFunc;
        }
        const regex = new RegExp(`(?:^|\\s)${escapeRegex$1(value)}(?:$|\\s)`, shouldIgnoreCase$1(data, options) ? "i" : "");
        return function element(elem) {
            const attr = adapter.getAttributeValue(elem, name);
            return (attr != null &&
                attr.length >= value.length &&
                regex.test(attr) &&
                next(elem));
        };
    },
    exists(next, { name }, { adapter }) {
        return (elem) => adapter.hasAttrib(elem, name) && next(elem);
    },
    start(next, data, options) {
        const { adapter } = options;
        const { name } = data;
        let { value } = data;
        const len = value.length;
        if (len === 0) {
            return boolbase$1.falseFunc;
        }
        if (shouldIgnoreCase$1(data, options)) {
            value = value.toLowerCase();
            return (elem) => {
                const attr = adapter.getAttributeValue(elem, name);
                return (attr != null &&
                    attr.length >= len &&
                    attr.substr(0, len).toLowerCase() === value &&
                    next(elem));
            };
        }
        return (elem) => {
            var _a;
            return !!((_a = adapter.getAttributeValue(elem, name)) === null || _a === void 0 ? void 0 : _a.startsWith(value)) &&
                next(elem);
        };
    },
    end(next, data, options) {
        const { adapter } = options;
        const { name } = data;
        let { value } = data;
        const len = -value.length;
        if (len === 0) {
            return boolbase$1.falseFunc;
        }
        if (shouldIgnoreCase$1(data, options)) {
            value = value.toLowerCase();
            return (elem) => {
                var _a;
                return ((_a = adapter
                    .getAttributeValue(elem, name)) === null || _a === void 0 ? void 0 : _a.substr(len).toLowerCase()) === value && next(elem);
            };
        }
        return (elem) => {
            var _a;
            return !!((_a = adapter.getAttributeValue(elem, name)) === null || _a === void 0 ? void 0 : _a.endsWith(value)) &&
                next(elem);
        };
    },
    any(next, data, options) {
        const { adapter } = options;
        const { name, value } = data;
        if (value === "") {
            return boolbase$1.falseFunc;
        }
        if (shouldIgnoreCase$1(data, options)) {
            const regex = new RegExp(escapeRegex$1(value), "i");
            return function anyIC(elem) {
                const attr = adapter.getAttributeValue(elem, name);
                return (attr != null &&
                    attr.length >= value.length &&
                    regex.test(attr) &&
                    next(elem));
            };
        }
        return (elem) => {
            var _a;
            return !!((_a = adapter.getAttributeValue(elem, name)) === null || _a === void 0 ? void 0 : _a.includes(value)) &&
                next(elem);
        };
    },
    not(next, data, options) {
        const { adapter } = options;
        const { name } = data;
        let { value } = data;
        if (value === "") {
            return (elem) => !!adapter.getAttributeValue(elem, name) && next(elem);
        }
        else if (shouldIgnoreCase$1(data, options)) {
            value = value.toLowerCase();
            return (elem) => {
                const attr = adapter.getAttributeValue(elem, name);
                return ((attr == null ||
                    attr.length !== value.length ||
                    attr.toLowerCase() !== value) &&
                    next(elem));
            };
        }
        return (elem) => adapter.getAttributeValue(elem, name) !== value && next(elem);
    },
};

// Following http://www.w3.org/TR/css3-selectors/#nth-child-pseudo
// Whitespace as per https://www.w3.org/TR/selectors-3/#lex is " \t\r\n\f"
const whitespace$3 = new Set([9, 10, 12, 13, 32]);
const ZERO$1 = "0".charCodeAt(0);
const NINE$1 = "9".charCodeAt(0);
/**
 * Parses an expression.
 *
 * @throws An `Error` if parsing fails.
 * @returns An array containing the integer step size and the integer offset of the nth rule.
 * @example nthCheck.parse("2n+3"); // returns [2, 3]
 */
function parse$l(formula) {
    formula = formula.trim().toLowerCase();
    if (formula === "even") {
        return [2, 0];
    }
    else if (formula === "odd") {
        return [2, 1];
    }
    // Parse [ ['-'|'+']? INTEGER? {N} [ S* ['-'|'+'] S* INTEGER ]?
    let idx = 0;
    let a = 0;
    let sign = readSign();
    let number = readNumber();
    if (idx < formula.length && formula.charAt(idx) === "n") {
        idx++;
        a = sign * (number !== null && number !== void 0 ? number : 1);
        skipWhitespace();
        if (idx < formula.length) {
            sign = readSign();
            skipWhitespace();
            number = readNumber();
        }
        else {
            sign = number = 0;
        }
    }
    // Throw if there is anything else
    if (number === null || idx < formula.length) {
        throw new Error(`n-th rule couldn't be parsed ('${formula}')`);
    }
    return [a, sign * number];
    function readSign() {
        if (formula.charAt(idx) === "-") {
            idx++;
            return -1;
        }
        if (formula.charAt(idx) === "+") {
            idx++;
        }
        return 1;
    }
    function readNumber() {
        const start = idx;
        let value = 0;
        while (idx < formula.length &&
            formula.charCodeAt(idx) >= ZERO$1 &&
            formula.charCodeAt(idx) <= NINE$1) {
            value = value * 10 + (formula.charCodeAt(idx) - ZERO$1);
            idx++;
        }
        // Return `null` if we didn't read anything.
        return idx === start ? null : value;
    }
    function skipWhitespace() {
        while (idx < formula.length &&
            whitespace$3.has(formula.charCodeAt(idx))) {
            idx++;
        }
    }
}

/**
 * Returns a function that checks if an elements index matches the given rule
 * highly optimized to return the fastest solution.
 *
 * @param parsed A tuple [a, b], as returned by `parse`.
 * @returns A highly optimized function that returns whether an index matches the nth-check.
 * @example
 *
 * ```js
 * const check = nthCheck.compile([2, 3]);
 *
 * check(0); // `false`
 * check(1); // `false`
 * check(2); // `true`
 * check(3); // `false`
 * check(4); // `true`
 * check(5); // `false`
 * check(6); // `true`
 * ```
 */
function compile$6(parsed) {
    const a = parsed[0];
    // Subtract 1 from `b`, to convert from one- to zero-indexed.
    const b = parsed[1] - 1;
    /*
     * When `b <= 0`, `a * n` won't be lead to any matches for `a < 0`.
     * Besides, the specification states that no elements are
     * matched when `a` and `b` are 0.
     *
     * `b < 0` here as we subtracted 1 from `b` above.
     */
    if (b < 0 && a <= 0)
        return boolbase$1.falseFunc;
    // When `a` is in the range -1..1, it matches any element (so only `b` is checked).
    if (a === -1)
        return (index) => index <= b;
    if (a === 0)
        return (index) => index === b;
    // When `b <= 0` and `a === 1`, they match any element.
    if (a === 1)
        return b < 0 ? boolbase$1.trueFunc : (index) => index >= b;
    /*
     * Otherwise, modulo can be used to check if there is a match.
     *
     * Modulo doesn't care about the sign, so let's use `a`s absolute value.
     */
    const absA = Math.abs(a);
    // Get `b mod a`, + a if this is negative.
    const bMod = ((b % absA) + absA) % absA;
    return a > 1
        ? (index) => index >= b && index % absA === bMod
        : (index) => index <= b && index % absA === bMod;
}

/**
 * Parses and compiles a formula to a highly optimized function.
 * Combination of {@link parse} and {@link compile}.
 *
 * If the formula doesn't match any elements,
 * it returns [`boolbase`](https://github.com/fb55/boolbase)'s `falseFunc`.
 * Otherwise, a function accepting an _index_ is returned, which returns
 * whether or not the passed _index_ matches the formula.
 *
 * Note: The nth-rule starts counting at `1`, the returned function at `0`.
 *
 * @param formula The formula to compile.
 * @example
 * const check = nthCheck("2n+3");
 *
 * check(0); // `false`
 * check(1); // `false`
 * check(2); // `true`
 * check(3); // `false`
 * check(4); // `true`
 * check(5); // `false`
 * check(6); // `true`
 */
function nthCheck(formula) {
    return compile$6(parse$l(formula));
}

function getChildFunc(next, adapter) {
    return (elem) => {
        const parent = adapter.getParent(elem);
        return parent != null && adapter.isTag(parent) && next(elem);
    };
}
const filters$1 = {
    contains(next, text, { adapter }) {
        return function contains(elem) {
            return next(elem) && adapter.getText(elem).includes(text);
        };
    },
    icontains(next, text, { adapter }) {
        const itext = text.toLowerCase();
        return function icontains(elem) {
            return (next(elem) &&
                adapter.getText(elem).toLowerCase().includes(itext));
        };
    },
    // Location specific methods
    "nth-child"(next, rule, { adapter, equals }) {
        const func = nthCheck(rule);
        if (func === boolbase$1.falseFunc)
            return boolbase$1.falseFunc;
        if (func === boolbase$1.trueFunc)
            return getChildFunc(next, adapter);
        return function nthChild(elem) {
            const siblings = adapter.getSiblings(elem);
            let pos = 0;
            for (let i = 0; i < siblings.length; i++) {
                if (equals(elem, siblings[i]))
                    break;
                if (adapter.isTag(siblings[i])) {
                    pos++;
                }
            }
            return func(pos) && next(elem);
        };
    },
    "nth-last-child"(next, rule, { adapter, equals }) {
        const func = nthCheck(rule);
        if (func === boolbase$1.falseFunc)
            return boolbase$1.falseFunc;
        if (func === boolbase$1.trueFunc)
            return getChildFunc(next, adapter);
        return function nthLastChild(elem) {
            const siblings = adapter.getSiblings(elem);
            let pos = 0;
            for (let i = siblings.length - 1; i >= 0; i--) {
                if (equals(elem, siblings[i]))
                    break;
                if (adapter.isTag(siblings[i])) {
                    pos++;
                }
            }
            return func(pos) && next(elem);
        };
    },
    "nth-of-type"(next, rule, { adapter, equals }) {
        const func = nthCheck(rule);
        if (func === boolbase$1.falseFunc)
            return boolbase$1.falseFunc;
        if (func === boolbase$1.trueFunc)
            return getChildFunc(next, adapter);
        return function nthOfType(elem) {
            const siblings = adapter.getSiblings(elem);
            let pos = 0;
            for (let i = 0; i < siblings.length; i++) {
                const currentSibling = siblings[i];
                if (equals(elem, currentSibling))
                    break;
                if (adapter.isTag(currentSibling) &&
                    adapter.getName(currentSibling) === adapter.getName(elem)) {
                    pos++;
                }
            }
            return func(pos) && next(elem);
        };
    },
    "nth-last-of-type"(next, rule, { adapter, equals }) {
        const func = nthCheck(rule);
        if (func === boolbase$1.falseFunc)
            return boolbase$1.falseFunc;
        if (func === boolbase$1.trueFunc)
            return getChildFunc(next, adapter);
        return function nthLastOfType(elem) {
            const siblings = adapter.getSiblings(elem);
            let pos = 0;
            for (let i = siblings.length - 1; i >= 0; i--) {
                const currentSibling = siblings[i];
                if (equals(elem, currentSibling))
                    break;
                if (adapter.isTag(currentSibling) &&
                    adapter.getName(currentSibling) === adapter.getName(elem)) {
                    pos++;
                }
            }
            return func(pos) && next(elem);
        };
    },
    // TODO determine the actual root element
    root(next, _rule, { adapter }) {
        return (elem) => {
            const parent = adapter.getParent(elem);
            return (parent == null || !adapter.isTag(parent)) && next(elem);
        };
    },
    scope(next, rule, options, context) {
        const { equals } = options;
        if (!context || context.length === 0) {
            // Equivalent to :root
            return filters$1["root"](next, rule, options);
        }
        if (context.length === 1) {
            // NOTE: can't be unpacked, as :has uses this for side-effects
            return (elem) => equals(context[0], elem) && next(elem);
        }
        return (elem) => context.includes(elem) && next(elem);
    },
    hover: dynamicStatePseudo("isHovered"),
    visited: dynamicStatePseudo("isVisited"),
    active: dynamicStatePseudo("isActive"),
};
/**
 * Dynamic state pseudos. These depend on optional Adapter methods.
 *
 * @param name The name of the adapter method to call.
 * @returns Pseudo for the `filters` object.
 */
function dynamicStatePseudo(name) {
    return function dynamicPseudo(next, _rule, { adapter }) {
        const func = adapter[name];
        if (typeof func !== "function") {
            return boolbase$1.falseFunc;
        }
        return function active(elem) {
            return func(elem) && next(elem);
        };
    };
}

// While filters are precompiled, pseudos get called when they are needed
const pseudos$1 = {
    empty(elem, { adapter }) {
        return !adapter.getChildren(elem).some((elem) => 
        // FIXME: `getText` call is potentially expensive.
        adapter.isTag(elem) || adapter.getText(elem) !== "");
    },
    "first-child"(elem, { adapter, equals }) {
        if (adapter.prevElementSibling) {
            return adapter.prevElementSibling(elem) == null;
        }
        const firstChild = adapter
            .getSiblings(elem)
            .find((elem) => adapter.isTag(elem));
        return firstChild != null && equals(elem, firstChild);
    },
    "last-child"(elem, { adapter, equals }) {
        const siblings = adapter.getSiblings(elem);
        for (let i = siblings.length - 1; i >= 0; i--) {
            if (equals(elem, siblings[i]))
                return true;
            if (adapter.isTag(siblings[i]))
                break;
        }
        return false;
    },
    "first-of-type"(elem, { adapter, equals }) {
        const siblings = adapter.getSiblings(elem);
        const elemName = adapter.getName(elem);
        for (let i = 0; i < siblings.length; i++) {
            const currentSibling = siblings[i];
            if (equals(elem, currentSibling))
                return true;
            if (adapter.isTag(currentSibling) &&
                adapter.getName(currentSibling) === elemName) {
                break;
            }
        }
        return false;
    },
    "last-of-type"(elem, { adapter, equals }) {
        const siblings = adapter.getSiblings(elem);
        const elemName = adapter.getName(elem);
        for (let i = siblings.length - 1; i >= 0; i--) {
            const currentSibling = siblings[i];
            if (equals(elem, currentSibling))
                return true;
            if (adapter.isTag(currentSibling) &&
                adapter.getName(currentSibling) === elemName) {
                break;
            }
        }
        return false;
    },
    "only-of-type"(elem, { adapter, equals }) {
        const elemName = adapter.getName(elem);
        return adapter
            .getSiblings(elem)
            .every((sibling) => equals(elem, sibling) ||
            !adapter.isTag(sibling) ||
            adapter.getName(sibling) !== elemName);
    },
    "only-child"(elem, { adapter, equals }) {
        return adapter
            .getSiblings(elem)
            .every((sibling) => equals(elem, sibling) || !adapter.isTag(sibling));
    },
};
function verifyPseudoArgs$1(func, name, subselect, argIndex) {
    if (subselect === null) {
        if (func.length > argIndex) {
            throw new Error(`Pseudo-class :${name} requires an argument`);
        }
    }
    else if (func.length === argIndex) {
        throw new Error(`Pseudo-class :${name} doesn't have any arguments`);
    }
}

/**
 * Aliases are pseudos that are expressed as selectors.
 */
const aliases$1 = {
    // Links
    "any-link": ":is(a, area, link)[href]",
    link: ":any-link:not(:visited)",
    // Forms
    // https://html.spec.whatwg.org/multipage/scripting.html#disabled-elements
    disabled: `:is(
        :is(button, input, select, textarea, optgroup, option)[disabled],
        optgroup[disabled] > option,
        fieldset[disabled]:not(fieldset[disabled] legend:first-of-type *)
    )`,
    enabled: ":not(:disabled)",
    checked: ":is(:is(input[type=radio], input[type=checkbox])[checked], option:selected)",
    required: ":is(input, select, textarea)[required]",
    optional: ":is(input, select, textarea):not([required])",
    // JQuery extensions
    // https://html.spec.whatwg.org/multipage/form-elements.html#concept-option-selectedness
    selected: "option:is([selected], select:not([multiple]):not(:has(> option[selected])) > :first-of-type)",
    checkbox: "[type=checkbox]",
    file: "[type=file]",
    password: "[type=password]",
    radio: "[type=radio]",
    reset: "[type=reset]",
    image: "[type=image]",
    submit: "[type=submit]",
    parent: ":not(:empty)",
    header: ":is(h1, h2, h3, h4, h5, h6)",
    button: ":is(button, input[type=button])",
    input: ":is(input, textarea, select, button)",
    text: "input:is(:not([type!='']), [type=text])",
};

/** Used as a placeholder for :has. Will be replaced with the actual element. */
const PLACEHOLDER_ELEMENT = {};
function ensureIsTag(next, adapter) {
    if (next === boolbase$1.falseFunc)
        return boolbase$1.falseFunc;
    return (elem) => adapter.isTag(elem) && next(elem);
}
function getNextSiblings(elem, adapter) {
    const siblings = adapter.getSiblings(elem);
    if (siblings.length <= 1)
        return [];
    const elemIndex = siblings.indexOf(elem);
    if (elemIndex < 0 || elemIndex === siblings.length - 1)
        return [];
    return siblings.slice(elemIndex + 1).filter(adapter.isTag);
}
function copyOptions(options) {
    // Not copied: context, rootFunc
    return {
        xmlMode: !!options.xmlMode,
        lowerCaseAttributeNames: !!options.lowerCaseAttributeNames,
        lowerCaseTags: !!options.lowerCaseTags,
        quirksMode: !!options.quirksMode,
        cacheResults: !!options.cacheResults,
        pseudos: options.pseudos,
        adapter: options.adapter,
        equals: options.equals,
    };
}
const is$4 = (next, token, options, context, compileToken) => {
    const func = compileToken(token, copyOptions(options), context);
    return func === boolbase$1.trueFunc
        ? next
        : func === boolbase$1.falseFunc
            ? boolbase$1.falseFunc
            : (elem) => func(elem) && next(elem);
};
/*
 * :not, :has, :is, :matches and :where have to compile selectors
 * doing this in src/pseudos.ts would lead to circular dependencies,
 * so we add them here
 */
const subselects$1 = {
    is: is$4,
    /**
     * `:matches` and `:where` are aliases for `:is`.
     */
    matches: is$4,
    where: is$4,
    not(next, token, options, context, compileToken) {
        const func = compileToken(token, copyOptions(options), context);
        return func === boolbase$1.falseFunc
            ? next
            : func === boolbase$1.trueFunc
                ? boolbase$1.falseFunc
                : (elem) => !func(elem) && next(elem);
    },
    has(next, subselect, options, _context, compileToken) {
        const { adapter } = options;
        const opts = copyOptions(options);
        opts.relativeSelector = true;
        const context = subselect.some((s) => s.some(isTraversal))
            ? // Used as a placeholder. Will be replaced with the actual element.
                [PLACEHOLDER_ELEMENT]
            : undefined;
        const compiled = compileToken(subselect, opts, context);
        if (compiled === boolbase$1.falseFunc)
            return boolbase$1.falseFunc;
        const hasElement = ensureIsTag(compiled, adapter);
        // If `compiled` is `trueFunc`, we can skip this.
        if (context && compiled !== boolbase$1.trueFunc) {
            /*
             * `shouldTestNextSiblings` will only be true if the query starts with
             * a traversal (sibling or adjacent). That means we will always have a context.
             */
            const { shouldTestNextSiblings = false } = compiled;
            return (elem) => {
                if (!next(elem))
                    return false;
                context[0] = elem;
                const childs = adapter.getChildren(elem);
                const nextElements = shouldTestNextSiblings
                    ? [...childs, ...getNextSiblings(elem, adapter)]
                    : childs;
                return adapter.existsOne(hasElement, nextElements);
            };
        }
        return (elem) => next(elem) &&
            adapter.existsOne(hasElement, adapter.getChildren(elem));
    },
};

function compilePseudoSelector(next, selector, options, context, compileToken) {
    var _a;
    const { name, data } = selector;
    if (Array.isArray(data)) {
        if (!(name in subselects$1)) {
            throw new Error(`Unknown pseudo-class :${name}(${data})`);
        }
        return subselects$1[name](next, data, options, context, compileToken);
    }
    const userPseudo = (_a = options.pseudos) === null || _a === void 0 ? void 0 : _a[name];
    const stringPseudo = typeof userPseudo === "string" ? userPseudo : aliases$1[name];
    if (typeof stringPseudo === "string") {
        if (data != null) {
            throw new Error(`Pseudo ${name} doesn't have any arguments`);
        }
        // The alias has to be parsed here, to make sure options are respected.
        const alias = parse$m(stringPseudo);
        return subselects$1["is"](next, alias, options, context, compileToken);
    }
    if (typeof userPseudo === "function") {
        verifyPseudoArgs$1(userPseudo, name, data, 1);
        return (elem) => userPseudo(elem, data) && next(elem);
    }
    if (name in filters$1) {
        return filters$1[name](next, data, options, context);
    }
    if (name in pseudos$1) {
        const pseudo = pseudos$1[name];
        verifyPseudoArgs$1(pseudo, name, data, 2);
        return (elem) => pseudo(elem, options, data) && next(elem);
    }
    throw new Error(`Unknown pseudo-class :${name}`);
}

function getElementParent(node, adapter) {
    const parent = adapter.getParent(node);
    if (parent && adapter.isTag(parent)) {
        return parent;
    }
    return null;
}
/*
 * All available rules
 */
function compileGeneralSelector$1(next, selector, options, context, compileToken) {
    const { adapter, equals } = options;
    switch (selector.type) {
        case SelectorType.PseudoElement: {
            throw new Error("Pseudo-elements are not supported by css-select");
        }
        case SelectorType.ColumnCombinator: {
            throw new Error("Column combinators are not yet supported by css-select");
        }
        case SelectorType.Attribute: {
            if (selector.namespace != null) {
                throw new Error("Namespaced attributes are not yet supported by css-select");
            }
            if (!options.xmlMode || options.lowerCaseAttributeNames) {
                selector.name = selector.name.toLowerCase();
            }
            return attributeRules[selector.action](next, selector, options);
        }
        case SelectorType.Pseudo: {
            return compilePseudoSelector(next, selector, options, context, compileToken);
        }
        // Tags
        case SelectorType.Tag: {
            if (selector.namespace != null) {
                throw new Error("Namespaced tag names are not yet supported by css-select");
            }
            let { name } = selector;
            if (!options.xmlMode || options.lowerCaseTags) {
                name = name.toLowerCase();
            }
            return function tag(elem) {
                return adapter.getName(elem) === name && next(elem);
            };
        }
        // Traversal
        case SelectorType.Descendant: {
            if (options.cacheResults === false ||
                typeof WeakSet === "undefined") {
                return function descendant(elem) {
                    let current = elem;
                    while ((current = getElementParent(current, adapter))) {
                        if (next(current)) {
                            return true;
                        }
                    }
                    return false;
                };
            }
            // @ts-expect-error `ElementNode` is not extending object
            const isFalseCache = new WeakSet();
            return function cachedDescendant(elem) {
                let current = elem;
                while ((current = getElementParent(current, adapter))) {
                    if (!isFalseCache.has(current)) {
                        if (adapter.isTag(current) && next(current)) {
                            return true;
                        }
                        isFalseCache.add(current);
                    }
                }
                return false;
            };
        }
        case "_flexibleDescendant": {
            // Include element itself, only used while querying an array
            return function flexibleDescendant(elem) {
                let current = elem;
                do {
                    if (next(current))
                        return true;
                } while ((current = getElementParent(current, adapter)));
                return false;
            };
        }
        case SelectorType.Parent: {
            return function parent(elem) {
                return adapter
                    .getChildren(elem)
                    .some((elem) => adapter.isTag(elem) && next(elem));
            };
        }
        case SelectorType.Child: {
            return function child(elem) {
                const parent = adapter.getParent(elem);
                return parent != null && adapter.isTag(parent) && next(parent);
            };
        }
        case SelectorType.Sibling: {
            return function sibling(elem) {
                const siblings = adapter.getSiblings(elem);
                for (let i = 0; i < siblings.length; i++) {
                    const currentSibling = siblings[i];
                    if (equals(elem, currentSibling))
                        break;
                    if (adapter.isTag(currentSibling) && next(currentSibling)) {
                        return true;
                    }
                }
                return false;
            };
        }
        case SelectorType.Adjacent: {
            if (adapter.prevElementSibling) {
                return function adjacent(elem) {
                    const previous = adapter.prevElementSibling(elem);
                    return previous != null && next(previous);
                };
            }
            return function adjacent(elem) {
                const siblings = adapter.getSiblings(elem);
                let lastElement;
                for (let i = 0; i < siblings.length; i++) {
                    const currentSibling = siblings[i];
                    if (equals(elem, currentSibling))
                        break;
                    if (adapter.isTag(currentSibling)) {
                        lastElement = currentSibling;
                    }
                }
                return !!lastElement && next(lastElement);
            };
        }
        case SelectorType.Universal: {
            if (selector.namespace != null && selector.namespace !== "*") {
                throw new Error("Namespaced universal selectors are not yet supported by css-select");
            }
            return next;
        }
    }
}

function includesScopePseudo$1(t) {
    return (t.type === SelectorType.Pseudo &&
        (t.name === "scope" ||
            (Array.isArray(t.data) &&
                t.data.some((data) => data.some(includesScopePseudo$1)))));
}
const DESCENDANT_TOKEN$1 = { type: SelectorType.Descendant };
const FLEXIBLE_DESCENDANT_TOKEN$1 = {
    type: "_flexibleDescendant",
};
const SCOPE_TOKEN$1 = {
    type: SelectorType.Pseudo,
    name: "scope",
    data: null,
};
/*
 * CSS 4 Spec (Draft): 3.4.1. Absolutizing a Relative Selector
 * http://www.w3.org/TR/selectors4/#absolutizing
 */
function absolutize$3(token, { adapter }, context) {
    // TODO Use better check if the context is a document
    const hasContext = !!(context === null || context === void 0 ? void 0 : context.every((e) => {
        const parent = adapter.isTag(e) && adapter.getParent(e);
        return e === PLACEHOLDER_ELEMENT || (parent && adapter.isTag(parent));
    }));
    for (const t of token) {
        if (t.length > 0 &&
            isTraversal(t[0]) &&
            t[0].type !== SelectorType.Descendant) ;
        else if (hasContext && !t.some(includesScopePseudo$1)) {
            t.unshift(DESCENDANT_TOKEN$1);
        }
        else {
            continue;
        }
        t.unshift(SCOPE_TOKEN$1);
    }
}
function compileToken$1(token, options, context) {
    var _a;
    token.forEach(sortByProcedure$1);
    context = (_a = options.context) !== null && _a !== void 0 ? _a : context;
    const isArrayContext = Array.isArray(context);
    const finalContext = context && (Array.isArray(context) ? context : [context]);
    // Check if the selector is relative
    if (options.relativeSelector !== false) {
        absolutize$3(token, options, finalContext);
    }
    else if (token.some((t) => t.length > 0 && isTraversal(t[0]))) {
        throw new Error("Relative selectors are not allowed when the `relativeSelector` option is disabled");
    }
    let shouldTestNextSiblings = false;
    const query = token
        .map((rules) => {
        if (rules.length >= 2) {
            const [first, second] = rules;
            if (first.type !== SelectorType.Pseudo ||
                first.name !== "scope") ;
            else if (isArrayContext &&
                second.type === SelectorType.Descendant) {
                rules[1] = FLEXIBLE_DESCENDANT_TOKEN$1;
            }
            else if (second.type === SelectorType.Adjacent ||
                second.type === SelectorType.Sibling) {
                shouldTestNextSiblings = true;
            }
        }
        return compileRules$1(rules, options, finalContext);
    })
        .reduce(reduceRules$1, boolbase$1.falseFunc);
    query.shouldTestNextSiblings = shouldTestNextSiblings;
    return query;
}
function compileRules$1(rules, options, context) {
    var _a;
    return rules.reduce((previous, rule) => previous === boolbase$1.falseFunc
        ? boolbase$1.falseFunc
        : compileGeneralSelector$1(previous, rule, options, context, compileToken$1), (_a = options.rootFunc) !== null && _a !== void 0 ? _a : boolbase$1.trueFunc);
}
function reduceRules$1(a, b) {
    if (b === boolbase$1.falseFunc || a === boolbase$1.trueFunc) {
        return a;
    }
    if (a === boolbase$1.falseFunc || b === boolbase$1.trueFunc) {
        return b;
    }
    return function combine(elem) {
        return a(elem) || b(elem);
    };
}

const defaultEquals = (a, b) => a === b;
const defaultOptions = {
    adapter: DomUtils,
    equals: defaultEquals,
};
function convertOptionFormats(options) {
    var _a, _b, _c, _d;
    /*
     * We force one format of options to the other one.
     */
    // @ts-expect-error Default options may have incompatible `Node` / `ElementNode`.
    const opts = options !== null && options !== void 0 ? options : defaultOptions;
    // @ts-expect-error Same as above.
    (_a = opts.adapter) !== null && _a !== void 0 ? _a : (opts.adapter = DomUtils);
    // @ts-expect-error `equals` does not exist on `Options`
    (_b = opts.equals) !== null && _b !== void 0 ? _b : (opts.equals = (_d = (_c = opts.adapter) === null || _c === void 0 ? void 0 : _c.equals) !== null && _d !== void 0 ? _d : defaultEquals);
    return opts;
}
function wrapCompile(func) {
    return function addAdapter(selector, options, context) {
        const opts = convertOptionFormats(options);
        return func(selector, opts, context);
    };
}
const _compileToken = wrapCompile(compileToken$1);
function prepareContext(elems, adapter, shouldTestNextSiblings = false) {
    /*
     * Add siblings if the query requires them.
     * See https://github.com/fb55/css-select/pull/43#issuecomment-225414692
     */
    if (shouldTestNextSiblings) {
        elems = appendNextSiblings(elems, adapter);
    }
    return Array.isArray(elems)
        ? adapter.removeSubsets(elems)
        : adapter.getChildren(elems);
}
function appendNextSiblings(elem, adapter) {
    // Order matters because jQuery seems to check the children before the siblings
    const elems = Array.isArray(elem) ? elem.slice(0) : [elem];
    const elemsLength = elems.length;
    for (let i = 0; i < elemsLength; i++) {
        const nextSiblings = getNextSiblings(elems[i], adapter);
        elems.push(...nextSiblings);
    }
    return elems;
}

const filterNames = new Set([
    "first",
    "last",
    "eq",
    "gt",
    "nth",
    "lt",
    "even",
    "odd",
]);
function isFilter(s) {
    if (s.type !== "pseudo")
        return false;
    if (filterNames.has(s.name))
        return true;
    if (s.name === "not" && Array.isArray(s.data)) {
        // Only consider `:not` with embedded filters
        return s.data.some((s) => s.some(isFilter));
    }
    return false;
}
function getLimit(filter, data, partLimit) {
    const num = data != null ? parseInt(data, 10) : NaN;
    switch (filter) {
        case "first":
            return 1;
        case "nth":
        case "eq":
            return isFinite(num) ? (num >= 0 ? num + 1 : Infinity) : 0;
        case "lt":
            return isFinite(num)
                ? num >= 0
                    ? Math.min(num, partLimit)
                    : Infinity
                : 0;
        case "gt":
            return isFinite(num) ? Infinity : 0;
        case "odd":
            return 2 * partLimit;
        case "even":
            return 2 * partLimit - 1;
        case "last":
        case "not":
            return Infinity;
    }
}

function getDocumentRoot(node) {
    while (node.parent)
        node = node.parent;
    return node;
}
function groupSelectors(selectors) {
    const filteredSelectors = [];
    const plainSelectors = [];
    for (const selector of selectors) {
        if (selector.some(isFilter)) {
            filteredSelectors.push(selector);
        }
        else {
            plainSelectors.push(selector);
        }
    }
    return [plainSelectors, filteredSelectors];
}

const UNIVERSAL_SELECTOR = {
    type: SelectorType.Universal,
    namespace: null,
};
const SCOPE_PSEUDO = {
    type: SelectorType.Pseudo,
    name: "scope",
    data: null,
};
function is$3(element, selector, options = {}) {
    return some([element], selector, options);
}
function some(elements, selector, options = {}) {
    if (typeof selector === "function")
        return elements.some(selector);
    const [plain, filtered] = groupSelectors(parse$m(selector));
    return ((plain.length > 0 && elements.some(_compileToken(plain, options))) ||
        filtered.some((sel) => filterBySelector(sel, elements, options).length > 0));
}
function filterByPosition(filter, elems, data, options) {
    const num = typeof data === "string" ? parseInt(data, 10) : NaN;
    switch (filter) {
        case "first":
        case "lt":
            // Already done in `getLimit`
            return elems;
        case "last":
            return elems.length > 0 ? [elems[elems.length - 1]] : elems;
        case "nth":
        case "eq":
            return isFinite(num) && Math.abs(num) < elems.length
                ? [num < 0 ? elems[elems.length + num] : elems[num]]
                : [];
        case "gt":
            return isFinite(num) ? elems.slice(num + 1) : [];
        case "even":
            return elems.filter((_, i) => i % 2 === 0);
        case "odd":
            return elems.filter((_, i) => i % 2 === 1);
        case "not": {
            const filtered = new Set(filterParsed(data, elems, options));
            return elems.filter((e) => !filtered.has(e));
        }
    }
}
function filter$3(selector, elements, options = {}) {
    return filterParsed(parse$m(selector), elements, options);
}
/**
 * Filter a set of elements by a selector.
 *
 * Will return elements in the original order.
 *
 * @param selector Selector to filter by.
 * @param elements Elements to filter.
 * @param options Options for selector.
 */
function filterParsed(selector, elements, options) {
    if (elements.length === 0)
        return [];
    const [plainSelectors, filteredSelectors] = groupSelectors(selector);
    let found;
    if (plainSelectors.length) {
        const filtered = filterElements(elements, plainSelectors, options);
        // If there are no filters, just return
        if (filteredSelectors.length === 0) {
            return filtered;
        }
        // Otherwise, we have to do some filtering
        if (filtered.length) {
            found = new Set(filtered);
        }
    }
    for (let i = 0; i < filteredSelectors.length && (found === null || found === void 0 ? void 0 : found.size) !== elements.length; i++) {
        const filteredSelector = filteredSelectors[i];
        const missing = found
            ? elements.filter((e) => isTag$2(e) && !found.has(e))
            : elements;
        if (missing.length === 0)
            break;
        const filtered = filterBySelector(filteredSelector, elements, options);
        if (filtered.length) {
            if (!found) {
                /*
                 * If we haven't found anything before the last selector,
                 * just return what we found now.
                 */
                if (i === filteredSelectors.length - 1) {
                    return filtered;
                }
                found = new Set(filtered);
            }
            else {
                filtered.forEach((el) => found.add(el));
            }
        }
    }
    return typeof found !== "undefined"
        ? (found.size === elements.length
            ? elements
            : // Filter elements to preserve order
                elements.filter((el) => found.has(el)))
        : [];
}
function filterBySelector(selector, elements, options) {
    var _a;
    if (selector.some(isTraversal$1)) {
        /*
         * Get root node, run selector with the scope
         * set to all of our nodes.
         */
        const root = (_a = options.root) !== null && _a !== void 0 ? _a : getDocumentRoot(elements[0]);
        const opts = { ...options, context: elements, relativeSelector: false };
        selector.push(SCOPE_PSEUDO);
        return findFilterElements(root, selector, opts, true, elements.length);
    }
    // Performance optimization: If we don't have to traverse, just filter set.
    return findFilterElements(elements, selector, options, false, elements.length);
}
function select(selector, root, options = {}, limit = Infinity) {
    if (typeof selector === "function") {
        return find$2(root, selector);
    }
    const [plain, filtered] = groupSelectors(parse$m(selector));
    const results = filtered.map((sel) => findFilterElements(root, sel, options, true, limit));
    // Plain selectors can be queried in a single go
    if (plain.length) {
        results.push(findElements(root, plain, options, limit));
    }
    if (results.length === 0) {
        return [];
    }
    // If there was only a single selector, just return the result
    if (results.length === 1) {
        return results[0];
    }
    // Sort results, filtering for duplicates
    return uniqueSort$1(results.reduce((a, b) => [...a, ...b]));
}
/**
 *
 * @param root Element(s) to search from.
 * @param selector Selector to look for.
 * @param options Options for querying.
 * @param queryForSelector Query multiple levels deep for the initial selector, even if it doesn't contain a traversal.
 */
function findFilterElements(root, selector, options, queryForSelector, totalLimit) {
    const filterIndex = selector.findIndex(isFilter);
    const sub = selector.slice(0, filterIndex);
    const filter = selector[filterIndex];
    // If we are at the end of the selector, we can limit the number of elements to retrieve.
    const partLimit = selector.length - 1 === filterIndex ? totalLimit : Infinity;
    /*
     * Set the number of elements to retrieve.
     * Eg. for :first, we only have to get a single element.
     */
    const limit = getLimit(filter.name, filter.data, partLimit);
    if (limit === 0)
        return [];
    /*
     * Skip `findElements` call if our selector starts with a positional
     * pseudo.
     */
    const elemsNoLimit = sub.length === 0 && !Array.isArray(root)
        ? getChildren$2(root).filter(isTag$2)
        : sub.length === 0
            ? (Array.isArray(root) ? root : [root]).filter(isTag$2)
            : queryForSelector || sub.some(isTraversal$1)
                ? findElements(root, [sub], options, limit)
                : filterElements(root, [sub], options);
    const elems = elemsNoLimit.slice(0, limit);
    let result = filterByPosition(filter.name, elems, filter.data, options);
    if (result.length === 0 || selector.length === filterIndex + 1) {
        return result;
    }
    const remainingSelector = selector.slice(filterIndex + 1);
    const remainingHasTraversal = remainingSelector.some(isTraversal$1);
    if (remainingHasTraversal) {
        if (isTraversal$1(remainingSelector[0])) {
            const { type } = remainingSelector[0];
            if (type === SelectorType.Sibling ||
                type === SelectorType.Adjacent) {
                // If we have a sibling traversal, we need to also look at the siblings.
                result = prepareContext(result, DomUtils, true);
            }
            // Avoid a traversal-first selector error.
            remainingSelector.unshift(UNIVERSAL_SELECTOR);
        }
        options = {
            ...options,
            // Avoid absolutizing the selector
            relativeSelector: false,
            /*
             * Add a custom root func, to make sure traversals don't match elements
             * that aren't a part of the considered tree.
             */
            rootFunc: (el) => result.includes(el),
        };
    }
    else if (options.rootFunc && options.rootFunc !== boolbase.trueFunc) {
        options = { ...options, rootFunc: boolbase.trueFunc };
    }
    /*
     * If we have another filter, recursively call `findFilterElements`,
     * with the `recursive` flag disabled. We only have to look for more
     * elements when we see a traversal.
     *
     * Otherwise,
     */
    return remainingSelector.some(isFilter)
        ? findFilterElements(result, remainingSelector, options, false, totalLimit)
        : remainingHasTraversal
            ? // Query existing elements to resolve traversal.
                findElements(result, [remainingSelector], options, totalLimit)
            : // If we don't have any more traversals, simply filter elements.
                filterElements(result, [remainingSelector], options);
}
function findElements(root, sel, options, limit) {
    const query = _compileToken(sel, options, root);
    return find$2(root, query, limit);
}
function find$2(root, query, limit = Infinity) {
    const elems = prepareContext(root, DomUtils, query.shouldTestNextSiblings);
    return find$3((node) => isTag$2(node) && query(node), elems, true, limit);
}
function filterElements(elements, sel, options) {
    const els = (Array.isArray(elements) ? elements : [elements]).filter(isTag$2);
    if (els.length === 0)
        return els;
    const query = _compileToken(sel, options);
    return query === boolbase.trueFunc ? els : els.filter(query);
}

/**
 * Methods for traversing the DOM structure.
 *
 * @module cheerio/traversing
 */
const reSiblingSelector = /^\s*[~+]/;
/**
 * Get the descendants of each element in the current set of matched elements,
 * filtered by a selector, jQuery object, or element.
 *
 * @category Traversing
 * @example
 *
 * ```js
 * $('#fruits').find('li').length;
 * //=> 3
 * $('#fruits').find($('.apple')).length;
 * //=> 1
 * ```
 *
 * @param selectorOrHaystack - Element to look for.
 * @returns The found elements.
 * @see {@link https://api.jquery.com/find/}
 */
function find$1(selectorOrHaystack) {
    var _a;
    if (!selectorOrHaystack) {
        return this._make([]);
    }
    const context = this.toArray();
    if (typeof selectorOrHaystack !== 'string') {
        const haystack = isCheerio(selectorOrHaystack)
            ? selectorOrHaystack.toArray()
            : [selectorOrHaystack];
        return this._make(haystack.filter((elem) => context.some((node) => contains$1(node, elem))));
    }
    const elems = reSiblingSelector.test(selectorOrHaystack)
        ? context
        : this.children().toArray();
    const options = {
        context,
        root: (_a = this._root) === null || _a === void 0 ? void 0 : _a[0],
        // Pass options that are recognized by `cheerio-select`
        xmlMode: this.options.xmlMode,
        lowerCaseTags: this.options.lowerCaseTags,
        lowerCaseAttributeNames: this.options.lowerCaseAttributeNames,
        pseudos: this.options.pseudos,
        quirksMode: this.options.quirksMode,
    };
    return this._make(select(selectorOrHaystack, elems, options));
}
/**
 * Creates a matcher, using a particular mapping function. Matchers provide a
 * function that finds elements using a generating function, supporting filtering.
 *
 * @private
 * @param matchMap - Mapping function.
 * @returns - Function for wrapping generating functions.
 */
function _getMatcher(matchMap) {
    return function (fn, ...postFns) {
        return function (selector) {
            var _a;
            let matched = matchMap(fn, this);
            if (selector) {
                matched = filterArray(matched, selector, this.options.xmlMode, (_a = this._root) === null || _a === void 0 ? void 0 : _a[0]);
            }
            return this._make(
            // Post processing is only necessary if there is more than one element.
            this.length > 1 && matched.length > 1
                ? postFns.reduce((elems, fn) => fn(elems), matched)
                : matched);
        };
    };
}
/** Matcher that adds multiple elements for each entry in the input. */
const _matcher = _getMatcher((fn, elems) => {
    const ret = [];
    for (let i = 0; i < elems.length; i++) {
        const value = fn(elems[i]);
        ret.push(value);
    }
    return new Array().concat(...ret);
});
/** Matcher that adds at most one element for each entry in the input. */
const _singleMatcher = _getMatcher((fn, elems) => {
    const ret = [];
    for (let i = 0; i < elems.length; i++) {
        const value = fn(elems[i]);
        if (value !== null) {
            ret.push(value);
        }
    }
    return ret;
});
/**
 * Matcher that supports traversing until a condition is met.
 *
 * @returns A function usable for `*Until` methods.
 */
function _matchUntil(nextElem, ...postFns) {
    // We use a variable here that is used from within the matcher.
    let matches = null;
    const innerMatcher = _getMatcher((nextElem, elems) => {
        const matched = [];
        domEach(elems, (elem) => {
            for (let next; (next = nextElem(elem)); elem = next) {
                // FIXME: `matched` might contain duplicates here and the index is too large.
                if (matches === null || matches === void 0 ? void 0 : matches(next, matched.length))
                    break;
                matched.push(next);
            }
        });
        return matched;
    })(nextElem, ...postFns);
    return function (selector, filterSelector) {
        // Override `matches` variable with the new target.
        matches =
            typeof selector === 'string'
                ? (elem) => is$3(elem, selector, this.options)
                : selector
                    ? getFilterFn(selector)
                    : null;
        const ret = innerMatcher.call(this, filterSelector);
        // Set `matches` to `null`, so we don't waste memory.
        matches = null;
        return ret;
    };
}
function _removeDuplicates(elems) {
    return Array.from(new Set(elems));
}
/**
 * Get the parent of each element in the current set of matched elements,
 * optionally filtered by a selector.
 *
 * @category Traversing
 * @example
 *
 * ```js
 * $('.pear').parent().attr('id');
 * //=> fruits
 * ```
 *
 * @param selector - If specified filter for parent.
 * @returns The parents.
 * @see {@link https://api.jquery.com/parent/}
 */
const parent = _singleMatcher(({ parent }) => (parent && !isDocument$1(parent) ? parent : null), _removeDuplicates);
/**
 * Get a set of parents filtered by `selector` of each element in the current
 * set of match elements.
 *
 * @category Traversing
 * @example
 *
 * ```js
 * $('.orange').parents().length;
 * //=> 2
 * $('.orange').parents('#fruits').length;
 * //=> 1
 * ```
 *
 * @param selector - If specified filter for parents.
 * @returns The parents.
 * @see {@link https://api.jquery.com/parents/}
 */
const parents = _matcher((elem) => {
    const matched = [];
    while (elem.parent && !isDocument$1(elem.parent)) {
        matched.push(elem.parent);
        elem = elem.parent;
    }
    return matched;
}, uniqueSort$1, (elems) => elems.reverse());
/**
 * Get the ancestors of each element in the current set of matched elements, up
 * to but not including the element matched by the selector, DOM node, or cheerio object.
 *
 * @category Traversing
 * @example
 *
 * ```js
 * $('.orange').parentsUntil('#food').length;
 * //=> 1
 * ```
 *
 * @param selector - Selector for element to stop at.
 * @param filterSelector - Optional filter for parents.
 * @returns The parents.
 * @see {@link https://api.jquery.com/parentsUntil/}
 */
const parentsUntil = _matchUntil(({ parent }) => (parent && !isDocument$1(parent) ? parent : null), uniqueSort$1, (elems) => elems.reverse());
/**
 * For each element in the set, get the first element that matches the selector
 * by testing the element itself and traversing up through its ancestors in the DOM tree.
 *
 * @category Traversing
 * @example
 *
 * ```js
 * $('.orange').closest();
 * //=> []
 *
 * $('.orange').closest('.apple');
 * // => []
 *
 * $('.orange').closest('li');
 * //=> [<li class="orange">Orange</li>]
 *
 * $('.orange').closest('#fruits');
 * //=> [<ul id="fruits"> ... </ul>]
 * ```
 *
 * @param selector - Selector for the element to find.
 * @returns The closest nodes.
 * @see {@link https://api.jquery.com/closest/}
 */
function closest(selector) {
    var _a;
    const set = [];
    if (!selector) {
        return this._make(set);
    }
    const selectOpts = {
        xmlMode: this.options.xmlMode,
        root: (_a = this._root) === null || _a === void 0 ? void 0 : _a[0],
    };
    const selectFn = typeof selector === 'string'
        ? (elem) => is$3(elem, selector, selectOpts)
        : getFilterFn(selector);
    domEach(this, (elem) => {
        while (elem && isTag$2(elem)) {
            if (selectFn(elem, 0)) {
                // Do not add duplicate elements to the set
                if (!set.includes(elem)) {
                    set.push(elem);
                }
                break;
            }
            elem = elem.parent;
        }
    });
    return this._make(set);
}
/**
 * Gets the next sibling of the first selected element, optionally filtered by a selector.
 *
 * @category Traversing
 * @example
 *
 * ```js
 * $('.apple').next().hasClass('orange');
 * //=> true
 * ```
 *
 * @param selector - If specified filter for sibling.
 * @returns The next nodes.
 * @see {@link https://api.jquery.com/next/}
 */
const next = _singleMatcher((elem) => nextElementSibling$1(elem));
/**
 * Gets all the following siblings of the first selected element, optionally
 * filtered by a selector.
 *
 * @category Traversing
 * @example
 *
 * ```js
 * $('.apple').nextAll();
 * //=> [<li class="orange">Orange</li>, <li class="pear">Pear</li>]
 * $('.apple').nextAll('.orange');
 * //=> [<li class="orange">Orange</li>]
 * ```
 *
 * @param selector - If specified filter for siblings.
 * @returns The next nodes.
 * @see {@link https://api.jquery.com/nextAll/}
 */
const nextAll = _matcher((elem) => {
    const matched = [];
    while (elem.next) {
        elem = elem.next;
        if (isTag$2(elem))
            matched.push(elem);
    }
    return matched;
}, _removeDuplicates);
/**
 * Gets all the following siblings up to but not including the element matched
 * by the selector, optionally filtered by another selector.
 *
 * @category Traversing
 * @example
 *
 * ```js
 * $('.apple').nextUntil('.pear');
 * //=> [<li class="orange">Orange</li>]
 * ```
 *
 * @param selector - Selector for element to stop at.
 * @param filterSelector - If specified filter for siblings.
 * @returns The next nodes.
 * @see {@link https://api.jquery.com/nextUntil/}
 */
const nextUntil = _matchUntil((el) => nextElementSibling$1(el), _removeDuplicates);
/**
 * Gets the previous sibling of the first selected element optionally filtered
 * by a selector.
 *
 * @category Traversing
 * @example
 *
 * ```js
 * $('.orange').prev().hasClass('apple');
 * //=> true
 * ```
 *
 * @param selector - If specified filter for siblings.
 * @returns The previous nodes.
 * @see {@link https://api.jquery.com/prev/}
 */
const prev = _singleMatcher((elem) => prevElementSibling$1(elem));
/**
 * Gets all the preceding siblings of the first selected element, optionally
 * filtered by a selector.
 *
 * @category Traversing
 * @example
 *
 * ```js
 * $('.pear').prevAll();
 * //=> [<li class="orange">Orange</li>, <li class="apple">Apple</li>]
 *
 * $('.pear').prevAll('.orange');
 * //=> [<li class="orange">Orange</li>]
 * ```
 *
 * @param selector - If specified filter for siblings.
 * @returns The previous nodes.
 * @see {@link https://api.jquery.com/prevAll/}
 */
const prevAll = _matcher((elem) => {
    const matched = [];
    while (elem.prev) {
        elem = elem.prev;
        if (isTag$2(elem))
            matched.push(elem);
    }
    return matched;
}, _removeDuplicates);
/**
 * Gets all the preceding siblings up to but not including the element matched
 * by the selector, optionally filtered by another selector.
 *
 * @category Traversing
 * @example
 *
 * ```js
 * $('.pear').prevUntil('.apple');
 * //=> [<li class="orange">Orange</li>]
 * ```
 *
 * @param selector - Selector for element to stop at.
 * @param filterSelector - If specified filter for siblings.
 * @returns The previous nodes.
 * @see {@link https://api.jquery.com/prevUntil/}
 */
const prevUntil = _matchUntil((el) => prevElementSibling$1(el), _removeDuplicates);
/**
 * Get the siblings of each element (excluding the element) in the set of
 * matched elements, optionally filtered by a selector.
 *
 * @category Traversing
 * @example
 *
 * ```js
 * $('.pear').siblings().length;
 * //=> 2
 *
 * $('.pear').siblings('.orange').length;
 * //=> 1
 * ```
 *
 * @param selector - If specified filter for siblings.
 * @returns The siblings.
 * @see {@link https://api.jquery.com/siblings/}
 */
const siblings = _matcher((elem) => getSiblings$2(elem).filter((el) => isTag$2(el) && el !== elem), uniqueSort$1);
/**
 * Gets the element children of each element in the set of matched elements.
 *
 * @category Traversing
 * @example
 *
 * ```js
 * $('#fruits').children().length;
 * //=> 3
 *
 * $('#fruits').children('.pear').text();
 * //=> Pear
 * ```
 *
 * @param selector - If specified filter for children.
 * @returns The children.
 * @see {@link https://api.jquery.com/children/}
 */
const children = _matcher((elem) => getChildren$2(elem).filter(isTag$2), _removeDuplicates);
/**
 * Gets the children of each element in the set of matched elements, including
 * text and comment nodes.
 *
 * @category Traversing
 * @example
 *
 * ```js
 * $('#fruits').contents().length;
 * //=> 3
 * ```
 *
 * @returns The children.
 * @see {@link https://api.jquery.com/contents/}
 */
function contents() {
    const elems = this.toArray().reduce((newElems, elem) => hasChildren$1(elem) ? newElems.concat(elem.children) : newElems, []);
    return this._make(elems);
}
/**
 * Iterates over a cheerio object, executing a function for each matched
 * element. When the callback is fired, the function is fired in the context of
 * the DOM element, so `this` refers to the current element, which is equivalent
 * to the function parameter `element`. To break out of the `each` loop early,
 * return with `false`.
 *
 * @category Traversing
 * @example
 *
 * ```js
 * const fruits = [];
 *
 * $('li').each(function (i, elem) {
 *   fruits[i] = $(this).text();
 * });
 *
 * fruits.join(', ');
 * //=> Apple, Orange, Pear
 * ```
 *
 * @param fn - Function to execute.
 * @returns The instance itself, useful for chaining.
 * @see {@link https://api.jquery.com/each/}
 */
function each(fn) {
    let i = 0;
    const len = this.length;
    while (i < len && fn.call(this[i], i, this[i]) !== false)
        ++i;
    return this;
}
/**
 * Pass each element in the current matched set through a function, producing a
 * new Cheerio object containing the return values. The function can return an
 * individual data item or an array of data items to be inserted into the
 * resulting set. If an array is returned, the elements inside the array are
 * inserted into the set. If the function returns null or undefined, no element
 * will be inserted.
 *
 * @category Traversing
 * @example
 *
 * ```js
 * $('li')
 *   .map(function (i, el) {
 *     // this === el
 *     return $(this).text();
 *   })
 *   .toArray()
 *   .join(' ');
 * //=> "apple orange pear"
 * ```
 *
 * @param fn - Function to execute.
 * @returns The mapped elements, wrapped in a Cheerio collection.
 * @see {@link https://api.jquery.com/map/}
 */
function map$1(fn) {
    let elems = [];
    for (let i = 0; i < this.length; i++) {
        const el = this[i];
        const val = fn.call(el, i, el);
        if (val != null) {
            elems = elems.concat(val);
        }
    }
    return this._make(elems);
}
/**
 * Creates a function to test if a filter is matched.
 *
 * @param match - A filter.
 * @returns A function that determines if a filter has been matched.
 */
function getFilterFn(match) {
    if (typeof match === 'function') {
        return (el, i) => match.call(el, i, el);
    }
    if (isCheerio(match)) {
        return (el) => Array.prototype.includes.call(match, el);
    }
    return function (el) {
        return match === el;
    };
}
function filter$2(match) {
    var _a;
    return this._make(filterArray(this.toArray(), match, this.options.xmlMode, (_a = this._root) === null || _a === void 0 ? void 0 : _a[0]));
}
function filterArray(nodes, match, xmlMode, root) {
    return typeof match === 'string'
        ? filter$3(match, nodes, { xmlMode, root })
        : nodes.filter(getFilterFn(match));
}
/**
 * Checks the current list of elements and returns `true` if _any_ of the
 * elements match the selector. If using an element or Cheerio selection,
 * returns `true` if _any_ of the elements match. If using a predicate function,
 * the function is executed in the context of the selected element, so `this`
 * refers to the current element.
 *
 * @category Attributes
 * @param selector - Selector for the selection.
 * @returns Whether or not the selector matches an element of the instance.
 * @see {@link https://api.jquery.com/is/}
 */
function is$2(selector) {
    const nodes = this.toArray();
    return typeof selector === 'string'
        ? some(nodes.filter(isTag$2), selector, this.options)
        : selector
            ? nodes.some(getFilterFn(selector))
            : false;
}
/**
 * Remove elements from the set of matched elements. Given a Cheerio object that
 * represents a set of DOM elements, the `.not()` method constructs a new
 * Cheerio object from a subset of the matching elements. The supplied selector
 * is tested against each element; the elements that don't match the selector
 * will be included in the result.
 *
 * The `.not()` method can take a function as its argument in the same way that
 * `.filter()` does. Elements for which the function returns `true` are excluded
 * from the filtered set; all other elements are included.
 *
 * @category Traversing
 * @example <caption>Selector</caption>
 *
 * ```js
 * $('li').not('.apple').length;
 * //=> 2
 * ```
 *
 * @example <caption>Function</caption>
 *
 * ```js
 * $('li').not(function (i, el) {
 *   // this === el
 *   return $(this).attr('class') === 'orange';
 * }).length; //=> 2
 * ```
 *
 * @param match - Value to look for, following the rules above.
 * @param container - Optional node to filter instead.
 * @returns The filtered collection.
 * @see {@link https://api.jquery.com/not/}
 */
function not$2(match) {
    let nodes = this.toArray();
    if (typeof match === 'string') {
        const matches = new Set(filter$3(match, nodes, this.options));
        nodes = nodes.filter((el) => !matches.has(el));
    }
    else {
        const filterFn = getFilterFn(match);
        nodes = nodes.filter((el, i) => !filterFn(el, i));
    }
    return this._make(nodes);
}
/**
 * Filters the set of matched elements to only those which have the given DOM
 * element as a descendant or which have a descendant that matches the given
 * selector. Equivalent to `.filter(':has(selector)')`.
 *
 * @category Traversing
 * @example <caption>Selector</caption>
 *
 * ```js
 * $('ul').has('.pear').attr('id');
 * //=> fruits
 * ```
 *
 * @example <caption>Element</caption>
 *
 * ```js
 * $('ul').has($('.pear')[0]).attr('id');
 * //=> fruits
 * ```
 *
 * @param selectorOrHaystack - Element to look for.
 * @returns The filtered collection.
 * @see {@link https://api.jquery.com/has/}
 */
function has(selectorOrHaystack) {
    return this.filter(typeof selectorOrHaystack === 'string'
        ? // Using the `:has` selector here short-circuits searches.
            `:has(${selectorOrHaystack})`
        : (_, el) => this._make(el).find(selectorOrHaystack).length > 0);
}
/**
 * Will select the first element of a cheerio object.
 *
 * @category Traversing
 * @example
 *
 * ```js
 * $('#fruits').children().first().text();
 * //=> Apple
 * ```
 *
 * @returns The first element.
 * @see {@link https://api.jquery.com/first/}
 */
function first() {
    return this.length > 1 ? this._make(this[0]) : this;
}
/**
 * Will select the last element of a cheerio object.
 *
 * @category Traversing
 * @example
 *
 * ```js
 * $('#fruits').children().last().text();
 * //=> Pear
 * ```
 *
 * @returns The last element.
 * @see {@link https://api.jquery.com/last/}
 */
function last() {
    return this.length > 0 ? this._make(this[this.length - 1]) : this;
}
/**
 * Reduce the set of matched elements to the one at the specified index. Use
 * `.eq(-i)` to count backwards from the last selected element.
 *
 * @category Traversing
 * @example
 *
 * ```js
 * $('li').eq(0).text();
 * //=> Apple
 *
 * $('li').eq(-1).text();
 * //=> Pear
 * ```
 *
 * @param i - Index of the element to select.
 * @returns The element at the `i`th position.
 * @see {@link https://api.jquery.com/eq/}
 */
function eq(i) {
    var _a;
    i = +i;
    // Use the first identity optimization if possible
    if (i === 0 && this.length <= 1)
        return this;
    if (i < 0)
        i = this.length + i;
    return this._make((_a = this[i]) !== null && _a !== void 0 ? _a : []);
}
function get(i) {
    if (i == null) {
        return this.toArray();
    }
    return this[i < 0 ? this.length + i : i];
}
/**
 * Retrieve all the DOM elements contained in the jQuery set as an array.
 *
 * @example
 *
 * ```js
 * $('li').toArray();
 * //=> [ {...}, {...}, {...} ]
 * ```
 *
 * @returns The contained items.
 */
function toArray() {
    return Array.prototype.slice.call(this);
}
/**
 * Search for a given element from among the matched elements.
 *
 * @category Traversing
 * @example
 *
 * ```js
 * $('.pear').index();
 * //=> 2 $('.orange').index('li');
 * //=> 1
 * $('.apple').index($('#fruit, li'));
 * //=> 1
 * ```
 *
 * @param selectorOrNeedle - Element to look for.
 * @returns The index of the element.
 * @see {@link https://api.jquery.com/index/}
 */
function index$1(selectorOrNeedle) {
    let $haystack;
    let needle;
    if (selectorOrNeedle == null) {
        $haystack = this.parent().children();
        needle = this[0];
    }
    else if (typeof selectorOrNeedle === 'string') {
        $haystack = this._make(selectorOrNeedle);
        needle = this[0];
    }
    else {
        // eslint-disable-next-line @typescript-eslint/no-this-alias
        $haystack = this;
        needle = isCheerio(selectorOrNeedle)
            ? selectorOrNeedle[0]
            : selectorOrNeedle;
    }
    return Array.prototype.indexOf.call($haystack, needle);
}
/**
 * Gets the elements matching the specified range (0-based position).
 *
 * @category Traversing
 * @example
 *
 * ```js
 * $('li').slice(1).eq(0).text();
 * //=> 'Orange'
 *
 * $('li').slice(1, 2).length;
 * //=> 1
 * ```
 *
 * @param start - A position at which the elements begin to be selected. If
 *   negative, it indicates an offset from the end of the set.
 * @param end - A position at which the elements stop being selected. If
 *   negative, it indicates an offset from the end of the set. If omitted, the
 *   range continues until the end of the set.
 * @returns The elements matching the specified range.
 * @see {@link https://api.jquery.com/slice/}
 */
function slice$1(start, end) {
    return this._make(Array.prototype.slice.call(this, start, end));
}
/**
 * End the most recent filtering operation in the current chain and return the
 * set of matched elements to its previous state.
 *
 * @category Traversing
 * @example
 *
 * ```js
 * $('li').eq(0).end().length;
 * //=> 3
 * ```
 *
 * @returns The previous state of the set of matched elements.
 * @see {@link https://api.jquery.com/end/}
 */
function end() {
    var _a;
    return (_a = this.prevObject) !== null && _a !== void 0 ? _a : this._make([]);
}
/**
 * Add elements to the set of matched elements.
 *
 * @category Traversing
 * @example
 *
 * ```js
 * $('.apple').add('.orange').length;
 * //=> 2
 * ```
 *
 * @param other - Elements to add.
 * @param context - Optionally the context of the new selection.
 * @returns The combined set.
 * @see {@link https://api.jquery.com/add/}
 */
function add(other, context) {
    const selection = this._make(other, context);
    const contents = uniqueSort$1([...this.get(), ...selection.get()]);
    return this._make(contents);
}
/**
 * Add the previous set of elements on the stack to the current set, optionally
 * filtered by a selector.
 *
 * @category Traversing
 * @example
 *
 * ```js
 * $('li').eq(0).addBack('.orange').length;
 * //=> 2
 * ```
 *
 * @param selector - Selector for the elements to add.
 * @returns The combined set.
 * @see {@link https://api.jquery.com/addBack/}
 */
function addBack(selector) {
    return this.prevObject
        ? this.add(selector ? this.prevObject.filter(selector) : this.prevObject)
        : this;
}

var Traversing = /*#__PURE__*/Object.freeze({
    __proto__: null,
    find: find$1,
    parent: parent,
    parents: parents,
    parentsUntil: parentsUntil,
    closest: closest,
    next: next,
    nextAll: nextAll,
    nextUntil: nextUntil,
    prev: prev,
    prevAll: prevAll,
    prevUntil: prevUntil,
    siblings: siblings,
    children: children,
    contents: contents,
    each: each,
    map: map$1,
    filter: filter$2,
    filterArray: filterArray,
    is: is$2,
    not: not$2,
    has: has,
    first: first,
    last: last,
    eq: eq,
    get: get,
    toArray: toArray,
    index: index$1,
    slice: slice$1,
    end: end,
    add: add,
    addBack: addBack
});

/**
 * Get the parse function with options.
 *
 * @param parser - The parser function.
 * @returns The parse function with options.
 */
function getParse(parser) {
    /**
     * Parse a HTML string or a node.
     *
     * @param content - The HTML string or node.
     * @param options - The parser options.
     * @param isDocument - If `content` is a document.
     * @param context - The context node in the DOM tree.
     * @returns The parsed document node.
     */
    return function parse(content, options, isDocument, context) {
        if (typeof Buffer !== 'undefined' && Buffer.isBuffer(content)) {
            content = content.toString();
        }
        if (typeof content === 'string') {
            return parser(content, options, isDocument, context);
        }
        const doc = content;
        if (!Array.isArray(doc) && isDocument$1(doc)) {
            // If `doc` is already a root, just return it
            return doc;
        }
        // Add conent to new root element
        const root = new Document$1([]);
        // Update the DOM using the root
        update(doc, root);
        return root;
    };
}
/**
 * Update the dom structure, for one changed layer.
 *
 * @param newChilds - The new children.
 * @param parent - The new parent.
 * @returns The parent node.
 */
function update(newChilds, parent) {
    // Normalize
    const arr = Array.isArray(newChilds) ? newChilds : [newChilds];
    // Update parent
    if (parent) {
        parent.children = arr;
    }
    else {
        parent = null;
    }
    // Update neighbors
    for (let i = 0; i < arr.length; i++) {
        const node = arr[i];
        // Cleanly remove existing nodes from their previous structures.
        if (node.parent && node.parent.children !== arr) {
            removeElement$1(node);
        }
        if (parent) {
            node.prev = arr[i - 1] || null;
            node.next = arr[i + 1] || null;
        }
        else {
            node.prev = node.next = null;
        }
        node.parent = parent;
    }
    return parent;
}

/**
 * Methods for modifying the DOM structure.
 *
 * @module cheerio/manipulation
 */
/**
 * Create an array of nodes, recursing into arrays and parsing strings if necessary.
 *
 * @private
 * @category Manipulation
 * @param elem - Elements to make an array of.
 * @param clone - Optionally clone nodes.
 * @returns The array of nodes.
 */
function _makeDomArray(elem, clone) {
    if (elem == null) {
        return [];
    }
    if (isCheerio(elem)) {
        return clone ? cloneDom(elem.get()) : elem.get();
    }
    if (Array.isArray(elem)) {
        return elem.reduce((newElems, el) => newElems.concat(this._makeDomArray(el, clone)), []);
    }
    if (typeof elem === 'string') {
        return this._parse(elem, this.options, false, null).children;
    }
    return clone ? cloneDom([elem]) : [elem];
}
function _insert(concatenator) {
    return function (...elems) {
        const lastIdx = this.length - 1;
        return domEach(this, (el, i) => {
            if (!hasChildren$1(el))
                return;
            const domSrc = typeof elems[0] === 'function'
                ? elems[0].call(el, i, this._render(el.children))
                : elems;
            const dom = this._makeDomArray(domSrc, i < lastIdx);
            concatenator(dom, el.children, el);
        });
    };
}
/**
 * Modify an array in-place, removing some number of elements and adding new
 * elements directly following them.
 *
 * @private
 * @category Manipulation
 * @param array - Target array to splice.
 * @param spliceIdx - Index at which to begin changing the array.
 * @param spliceCount - Number of elements to remove from the array.
 * @param newElems - Elements to insert into the array.
 * @param parent - The parent of the node.
 * @returns The spliced array.
 */
function uniqueSplice(array, spliceIdx, spliceCount, newElems, parent) {
    var _a, _b;
    const spliceArgs = [
        spliceIdx,
        spliceCount,
        ...newElems,
    ];
    const prev = spliceIdx === 0 ? null : array[spliceIdx - 1];
    const next = spliceIdx + spliceCount >= array.length
        ? null
        : array[spliceIdx + spliceCount];
    /*
     * Before splicing in new elements, ensure they do not already appear in the
     * current array.
     */
    for (let idx = 0; idx < newElems.length; ++idx) {
        const node = newElems[idx];
        const oldParent = node.parent;
        if (oldParent) {
            const oldSiblings = oldParent.children;
            const prevIdx = oldSiblings.indexOf(node);
            if (prevIdx > -1) {
                oldParent.children.splice(prevIdx, 1);
                if (parent === oldParent && spliceIdx > prevIdx) {
                    spliceArgs[0]--;
                }
            }
        }
        node.parent = parent;
        if (node.prev) {
            node.prev.next = (_a = node.next) !== null && _a !== void 0 ? _a : null;
        }
        if (node.next) {
            node.next.prev = (_b = node.prev) !== null && _b !== void 0 ? _b : null;
        }
        node.prev = idx === 0 ? prev : newElems[idx - 1];
        node.next = idx === newElems.length - 1 ? next : newElems[idx + 1];
    }
    if (prev) {
        prev.next = newElems[0];
    }
    if (next) {
        next.prev = newElems[newElems.length - 1];
    }
    return array.splice(...spliceArgs);
}
/**
 * Insert every element in the set of matched elements to the end of the target.
 *
 * @category Manipulation
 * @example
 *
 * ```js
 * $('<li class="plum">Plum</li>').appendTo('#fruits');
 * $.html();
 * //=>  <ul id="fruits">
 * //      <li class="apple">Apple</li>
 * //      <li class="orange">Orange</li>
 * //      <li class="pear">Pear</li>
 * //      <li class="plum">Plum</li>
 * //    </ul>
 * ```
 *
 * @param target - Element to append elements to.
 * @returns The instance itself.
 * @see {@link https://api.jquery.com/appendTo/}
 */
function appendTo(target) {
    const appendTarget = isCheerio(target) ? target : this._make(target);
    appendTarget.append(this);
    return this;
}
/**
 * Insert every element in the set of matched elements to the beginning of the target.
 *
 * @category Manipulation
 * @example
 *
 * ```js
 * $('<li class="plum">Plum</li>').prependTo('#fruits');
 * $.html();
 * //=>  <ul id="fruits">
 * //      <li class="plum">Plum</li>
 * //      <li class="apple">Apple</li>
 * //      <li class="orange">Orange</li>
 * //      <li class="pear">Pear</li>
 * //    </ul>
 * ```
 *
 * @param target - Element to prepend elements to.
 * @returns The instance itself.
 * @see {@link https://api.jquery.com/prependTo/}
 */
function prependTo(target) {
    const prependTarget = isCheerio(target) ? target : this._make(target);
    prependTarget.prepend(this);
    return this;
}
/**
 * Inserts content as the _last_ child of each of the selected elements.
 *
 * @category Manipulation
 * @example
 *
 * ```js
 * $('ul').append('<li class="plum">Plum</li>');
 * $.html();
 * //=>  <ul id="fruits">
 * //      <li class="apple">Apple</li>
 * //      <li class="orange">Orange</li>
 * //      <li class="pear">Pear</li>
 * //      <li class="plum">Plum</li>
 * //    </ul>
 * ```
 *
 * @see {@link https://api.jquery.com/append/}
 */
const append$2 = _insert((dom, children, parent) => {
    uniqueSplice(children, children.length, 0, dom, parent);
});
/**
 * Inserts content as the _first_ child of each of the selected elements.
 *
 * @category Manipulation
 * @example
 *
 * ```js
 * $('ul').prepend('<li class="plum">Plum</li>');
 * $.html();
 * //=>  <ul id="fruits">
 * //      <li class="plum">Plum</li>
 * //      <li class="apple">Apple</li>
 * //      <li class="orange">Orange</li>
 * //      <li class="pear">Pear</li>
 * //    </ul>
 * ```
 *
 * @see {@link https://api.jquery.com/prepend/}
 */
const prepend$1 = _insert((dom, children, parent) => {
    uniqueSplice(children, 0, 0, dom, parent);
});
function _wrap(insert) {
    return function (wrapper) {
        const lastIdx = this.length - 1;
        const lastParent = this.parents().last();
        for (let i = 0; i < this.length; i++) {
            const el = this[i];
            const wrap = typeof wrapper === 'function'
                ? wrapper.call(el, i, el)
                : typeof wrapper === 'string' && !isHtml(wrapper)
                    ? lastParent.find(wrapper).clone()
                    : wrapper;
            const [wrapperDom] = this._makeDomArray(wrap, i < lastIdx);
            if (!wrapperDom || !hasChildren$1(wrapperDom))
                continue;
            let elInsertLocation = wrapperDom;
            /*
             * Find the deepest child. Only consider the first tag child of each node
             * (ignore text); stop if no children are found.
             */
            let j = 0;
            while (j < elInsertLocation.children.length) {
                const child = elInsertLocation.children[j];
                if (isTag$2(child)) {
                    elInsertLocation = child;
                    j = 0;
                }
                else {
                    j++;
                }
            }
            insert(el, elInsertLocation, [wrapperDom]);
        }
        return this;
    };
}
/**
 * The .wrap() function can take any string or object that could be passed to
 * the $() factory function to specify a DOM structure. This structure may be
 * nested several levels deep, but should contain only one inmost element. A
 * copy of this structure will be wrapped around each of the elements in the set
 * of matched elements. This method returns the original set of elements for
 * chaining purposes.
 *
 * @category Manipulation
 * @example
 *
 * ```js
 * const redFruit = $('<div class="red-fruit"></div>');
 * $('.apple').wrap(redFruit);
 *
 * //=> <ul id="fruits">
 * //     <div class="red-fruit">
 * //      <li class="apple">Apple</li>
 * //     </div>
 * //     <li class="orange">Orange</li>
 * //     <li class="plum">Plum</li>
 * //   </ul>
 *
 * const healthy = $('<div class="healthy"></div>');
 * $('li').wrap(healthy);
 *
 * //=> <ul id="fruits">
 * //     <div class="healthy">
 * //       <li class="apple">Apple</li>
 * //     </div>
 * //     <div class="healthy">
 * //       <li class="orange">Orange</li>
 * //     </div>
 * //     <div class="healthy">
 * //        <li class="plum">Plum</li>
 * //     </div>
 * //   </ul>
 * ```
 *
 * @param wrapper - The DOM structure to wrap around each element in the selection.
 * @see {@link https://api.jquery.com/wrap/}
 */
const wrap$2 = _wrap((el, elInsertLocation, wrapperDom) => {
    const { parent } = el;
    if (!parent)
        return;
    const siblings = parent.children;
    const index = siblings.indexOf(el);
    update([el], elInsertLocation);
    /*
     * The previous operation removed the current element from the `siblings`
     * array, so the `dom` array can be inserted without removing any
     * additional elements.
     */
    uniqueSplice(siblings, index, 0, wrapperDom, parent);
});
/**
 * The .wrapInner() function can take any string or object that could be passed
 * to the $() factory function to specify a DOM structure. This structure may be
 * nested several levels deep, but should contain only one inmost element. The
 * structure will be wrapped around the content of each of the elements in the
 * set of matched elements.
 *
 * @category Manipulation
 * @example
 *
 * ```js
 * const redFruit = $('<div class="red-fruit"></div>');
 * $('.apple').wrapInner(redFruit);
 *
 * //=> <ul id="fruits">
 * //     <li class="apple">
 * //       <div class="red-fruit">Apple</div>
 * //     </li>
 * //     <li class="orange">Orange</li>
 * //     <li class="pear">Pear</li>
 * //   </ul>
 *
 * const healthy = $('<div class="healthy"></div>');
 * $('li').wrapInner(healthy);
 *
 * //=> <ul id="fruits">
 * //     <li class="apple">
 * //       <div class="healthy">Apple</div>
 * //     </li>
 * //     <li class="orange">
 * //       <div class="healthy">Orange</div>
 * //     </li>
 * //     <li class="pear">
 * //       <div class="healthy">Pear</div>
 * //     </li>
 * //   </ul>
 * ```
 *
 * @param wrapper - The DOM structure to wrap around the content of each element
 *   in the selection.
 * @returns The instance itself, for chaining.
 * @see {@link https://api.jquery.com/wrapInner/}
 */
const wrapInner = _wrap((el, elInsertLocation, wrapperDom) => {
    if (!hasChildren$1(el))
        return;
    update(el.children, elInsertLocation);
    update(wrapperDom, el);
});
/**
 * The .unwrap() function, removes the parents of the set of matched elements
 * from the DOM, leaving the matched elements in their place.
 *
 * @category Manipulation
 * @example <caption>without selector</caption>
 *
 * ```js
 * const $ = cheerio.load(
 *   '<div id=test>\n  <div><p>Hello</p></div>\n  <div><p>World</p></div>\n</div>'
 * );
 * $('#test p').unwrap();
 *
 * //=> <div id=test>
 * //     <p>Hello</p>
 * //     <p>World</p>
 * //   </div>
 * ```
 *
 * @example <caption>with selector</caption>
 *
 * ```js
 * const $ = cheerio.load(
 *   '<div id=test>\n  <p>Hello</p>\n  <b><p>World</p></b>\n</div>'
 * );
 * $('#test p').unwrap('b');
 *
 * //=> <div id=test>
 * //     <p>Hello</p>
 * //     <p>World</p>
 * //   </div>
 * ```
 *
 * @param selector - A selector to check the parent element against. If an
 *   element's parent does not match the selector, the element won't be unwrapped.
 * @returns The instance itself, for chaining.
 * @see {@link https://api.jquery.com/unwrap/}
 */
function unwrap(selector) {
    this.parent(selector)
        .not('body')
        .each((_, el) => {
        this._make(el).replaceWith(el.children);
    });
    return this;
}
/**
 * The .wrapAll() function can take any string or object that could be passed to
 * the $() function to specify a DOM structure. This structure may be nested
 * several levels deep, but should contain only one inmost element. The
 * structure will be wrapped around all of the elements in the set of matched
 * elements, as a single group.
 *
 * @category Manipulation
 * @example <caption>With markup passed to `wrapAll`</caption>
 *
 * ```js
 * const $ = cheerio.load(
 *   '<div class="container"><div class="inner">First</div><div class="inner">Second</div></div>'
 * );
 * $('.inner').wrapAll("<div class='new'></div>");
 *
 * //=> <div class="container">
 * //     <div class='new'>
 * //       <div class="inner">First</div>
 * //       <div class="inner">Second</div>
 * //     </div>
 * //   </div>
 * ```
 *
 * @example <caption>With an existing cheerio instance</caption>
 *
 * ```js
 * const $ = cheerio.load(
 *   '<span>Span 1</span><strong>Strong</strong><span>Span 2</span>'
 * );
 * const wrap = $('<div><p><em><b></b></em></p></div>');
 * $('span').wrapAll(wrap);
 *
 * //=> <div>
 * //     <p>
 * //       <em>
 * //         <b>
 * //           <span>Span 1</span>
 * //           <span>Span 2</span>
 * //         </b>
 * //       </em>
 * //     </p>
 * //   </div>
 * //   <strong>Strong</strong>
 * ```
 *
 * @param wrapper - The DOM structure to wrap around all matched elements in the
 *   selection.
 * @returns The instance itself.
 * @see {@link https://api.jquery.com/wrapAll/}
 */
function wrapAll$1(wrapper) {
    const el = this[0];
    if (el) {
        const wrap = this._make(typeof wrapper === 'function' ? wrapper.call(el, 0, el) : wrapper).insertBefore(el);
        // If html is given as wrapper, wrap may contain text elements
        let elInsertLocation;
        for (let i = 0; i < wrap.length; i++) {
            if (wrap[i].type === 'tag')
                elInsertLocation = wrap[i];
        }
        let j = 0;
        /*
         * Find the deepest child. Only consider the first tag child of each node
         * (ignore text); stop if no children are found.
         */
        while (elInsertLocation && j < elInsertLocation.children.length) {
            const child = elInsertLocation.children[j];
            if (child.type === 'tag') {
                elInsertLocation = child;
                j = 0;
            }
            else {
                j++;
            }
        }
        if (elInsertLocation)
            this._make(elInsertLocation).append(this);
    }
    return this;
}
/* eslint-disable jsdoc/check-param-names*/
/**
 * Insert content next to each element in the set of matched elements.
 *
 * @category Manipulation
 * @example
 *
 * ```js
 * $('.apple').after('<li class="plum">Plum</li>');
 * $.html();
 * //=>  <ul id="fruits">
 * //      <li class="apple">Apple</li>
 * //      <li class="plum">Plum</li>
 * //      <li class="orange">Orange</li>
 * //      <li class="pear">Pear</li>
 * //    </ul>
 * ```
 *
 * @param content - HTML string, DOM element, array of DOM elements or Cheerio
 *   to insert after each element in the set of matched elements.
 * @returns The instance itself.
 * @see {@link https://api.jquery.com/after/}
 */
function after(...elems) {
    const lastIdx = this.length - 1;
    return domEach(this, (el, i) => {
        const { parent } = el;
        if (!hasChildren$1(el) || !parent) {
            return;
        }
        const siblings = parent.children;
        const index = siblings.indexOf(el);
        // If not found, move on
        /* istanbul ignore next */
        if (index < 0)
            return;
        const domSrc = typeof elems[0] === 'function'
            ? elems[0].call(el, i, this._render(el.children))
            : elems;
        const dom = this._makeDomArray(domSrc, i < lastIdx);
        // Add element after `this` element
        uniqueSplice(siblings, index + 1, 0, dom, parent);
    });
}
/* eslint-enable jsdoc/check-param-names*/
/**
 * Insert every element in the set of matched elements after the target.
 *
 * @category Manipulation
 * @example
 *
 * ```js
 * $('<li class="plum">Plum</li>').insertAfter('.apple');
 * $.html();
 * //=>  <ul id="fruits">
 * //      <li class="apple">Apple</li>
 * //      <li class="plum">Plum</li>
 * //      <li class="orange">Orange</li>
 * //      <li class="pear">Pear</li>
 * //    </ul>
 * ```
 *
 * @param target - Element to insert elements after.
 * @returns The set of newly inserted elements.
 * @see {@link https://api.jquery.com/insertAfter/}
 */
function insertAfter(target) {
    if (typeof target === 'string') {
        target = this._make(target);
    }
    this.remove();
    const clones = [];
    this._makeDomArray(target).forEach((el) => {
        const clonedSelf = this.clone().toArray();
        const { parent } = el;
        if (!parent) {
            return;
        }
        const siblings = parent.children;
        const index = siblings.indexOf(el);
        // If not found, move on
        /* istanbul ignore next */
        if (index < 0)
            return;
        // Add cloned `this` element(s) after target element
        uniqueSplice(siblings, index + 1, 0, clonedSelf, parent);
        clones.push(...clonedSelf);
    });
    return this._make(clones);
}
/* eslint-disable jsdoc/check-param-names*/
/**
 * Insert content previous to each element in the set of matched elements.
 *
 * @category Manipulation
 * @example
 *
 * ```js
 * $('.apple').before('<li class="plum">Plum</li>');
 * $.html();
 * //=>  <ul id="fruits">
 * //      <li class="plum">Plum</li>
 * //      <li class="apple">Apple</li>
 * //      <li class="orange">Orange</li>
 * //      <li class="pear">Pear</li>
 * //    </ul>
 * ```
 *
 * @param content - HTML string, DOM element, array of DOM elements or Cheerio
 *   to insert before each element in the set of matched elements.
 * @returns The instance itself.
 * @see {@link https://api.jquery.com/before/}
 */
function before(...elems) {
    const lastIdx = this.length - 1;
    return domEach(this, (el, i) => {
        const { parent } = el;
        if (!hasChildren$1(el) || !parent) {
            return;
        }
        const siblings = parent.children;
        const index = siblings.indexOf(el);
        // If not found, move on
        /* istanbul ignore next */
        if (index < 0)
            return;
        const domSrc = typeof elems[0] === 'function'
            ? elems[0].call(el, i, this._render(el.children))
            : elems;
        const dom = this._makeDomArray(domSrc, i < lastIdx);
        // Add element before `el` element
        uniqueSplice(siblings, index, 0, dom, parent);
    });
}
/* eslint-enable jsdoc/check-param-names*/
/**
 * Insert every element in the set of matched elements before the target.
 *
 * @category Manipulation
 * @example
 *
 * ```js
 * $('<li class="plum">Plum</li>').insertBefore('.apple');
 * $.html();
 * //=>  <ul id="fruits">
 * //      <li class="plum">Plum</li>
 * //      <li class="apple">Apple</li>
 * //      <li class="orange">Orange</li>
 * //      <li class="pear">Pear</li>
 * //    </ul>
 * ```
 *
 * @param target - Element to insert elements before.
 * @returns The set of newly inserted elements.
 * @see {@link https://api.jquery.com/insertBefore/}
 */
function insertBefore(target) {
    const targetArr = this._make(target);
    this.remove();
    const clones = [];
    domEach(targetArr, (el) => {
        const clonedSelf = this.clone().toArray();
        const { parent } = el;
        if (!parent) {
            return;
        }
        const siblings = parent.children;
        const index = siblings.indexOf(el);
        // If not found, move on
        /* istanbul ignore next */
        if (index < 0)
            return;
        // Add cloned `this` element(s) after target element
        uniqueSplice(siblings, index, 0, clonedSelf, parent);
        clones.push(...clonedSelf);
    });
    return this._make(clones);
}
/**
 * Removes the set of matched elements from the DOM and all their children.
 * `selector` filters the set of matched elements to be removed.
 *
 * @category Manipulation
 * @example
 *
 * ```js
 * $('.pear').remove();
 * $.html();
 * //=>  <ul id="fruits">
 * //      <li class="apple">Apple</li>
 * //      <li class="orange">Orange</li>
 * //    </ul>
 * ```
 *
 * @param selector - Optional selector for elements to remove.
 * @returns The instance itself.
 * @see {@link https://api.jquery.com/remove/}
 */
function remove$3(selector) {
    // Filter if we have selector
    const elems = selector ? this.filter(selector) : this;
    domEach(elems, (el) => {
        removeElement$1(el);
        el.prev = el.next = el.parent = null;
    });
    return this;
}
/**
 * Replaces matched elements with `content`.
 *
 * @category Manipulation
 * @example
 *
 * ```js
 * const plum = $('<li class="plum">Plum</li>');
 * $('.pear').replaceWith(plum);
 * $.html();
 * //=> <ul id="fruits">
 * //     <li class="apple">Apple</li>
 * //     <li class="orange">Orange</li>
 * //     <li class="plum">Plum</li>
 * //   </ul>
 * ```
 *
 * @param content - Replacement for matched elements.
 * @returns The instance itself.
 * @see {@link https://api.jquery.com/replaceWith/}
 */
function replaceWith(content) {
    return domEach(this, (el, i) => {
        const { parent } = el;
        if (!parent) {
            return;
        }
        const siblings = parent.children;
        const cont = typeof content === 'function' ? content.call(el, i, el) : content;
        const dom = this._makeDomArray(cont);
        /*
         * In the case that `dom` contains nodes that already exist in other
         * structures, ensure those nodes are properly removed.
         */
        update(dom, null);
        const index = siblings.indexOf(el);
        // Completely remove old element
        uniqueSplice(siblings, index, 1, dom, parent);
        if (!dom.includes(el)) {
            el.parent = el.prev = el.next = null;
        }
    });
}
/**
 * Empties an element, removing all its children.
 *
 * @category Manipulation
 * @example
 *
 * ```js
 * $('ul').empty();
 * $.html();
 * //=>  <ul id="fruits"></ul>
 * ```
 *
 * @returns The instance itself.
 * @see {@link https://api.jquery.com/empty/}
 */
function empty$3() {
    return domEach(this, (el) => {
        if (!hasChildren$1(el))
            return;
        el.children.forEach((child) => {
            child.next = child.prev = child.parent = null;
        });
        el.children.length = 0;
    });
}
function html$1(str) {
    if (str === undefined) {
        const el = this[0];
        if (!el || !hasChildren$1(el))
            return null;
        return this._render(el.children);
    }
    return domEach(this, (el) => {
        if (!hasChildren$1(el))
            return;
        el.children.forEach((child) => {
            child.next = child.prev = child.parent = null;
        });
        const content = isCheerio(str)
            ? str.toArray()
            : this._parse(`${str}`, this.options, false, el).children;
        update(content, el);
    });
}
/**
 * Turns the collection to a string. Alias for `.html()`.
 *
 * @category Manipulation
 * @returns The rendered document.
 */
function toString$1() {
    return this._render(this);
}
function text$1(str) {
    // If `str` is undefined, act as a "getter"
    if (str === undefined) {
        return text$2(this);
    }
    if (typeof str === 'function') {
        // Function support
        return domEach(this, (el, i) => this._make(el).text(str.call(el, i, text$2([el]))));
    }
    // Append text node to each selected elements
    return domEach(this, (el) => {
        if (!hasChildren$1(el))
            return;
        el.children.forEach((child) => {
            child.next = child.prev = child.parent = null;
        });
        const textNode = new Text$1(`${str}`);
        update(textNode, el);
    });
}
/**
 * Clone the cheerio object.
 *
 * @category Manipulation
 * @example
 *
 * ```js
 * const moreFruit = $('#fruits').clone();
 * ```
 *
 * @returns The cloned object.
 * @see {@link https://api.jquery.com/clone/}
 */
function clone$5() {
    return this._make(cloneDom(this.get()));
}

var Manipulation = /*#__PURE__*/Object.freeze({
    __proto__: null,
    _makeDomArray: _makeDomArray,
    appendTo: appendTo,
    prependTo: prependTo,
    append: append$2,
    prepend: prepend$1,
    wrap: wrap$2,
    wrapInner: wrapInner,
    unwrap: unwrap,
    wrapAll: wrapAll$1,
    after: after,
    insertAfter: insertAfter,
    before: before,
    insertBefore: insertBefore,
    remove: remove$3,
    replaceWith: replaceWith,
    empty: empty$3,
    html: html$1,
    toString: toString$1,
    text: text$1,
    clone: clone$5
});

/**
 * Set multiple CSS properties for every matched element.
 *
 * @category CSS
 * @param prop - The names of the properties.
 * @param val - The new values.
 * @returns The instance itself.
 * @see {@link https://api.jquery.com/css/}
 */
function css(prop, val) {
    if ((prop != null && val != null) ||
        // When `prop` is a "plain" object
        (typeof prop === 'object' && !Array.isArray(prop))) {
        return domEach(this, (el, i) => {
            if (isTag$2(el)) {
                // `prop` can't be an array here anymore.
                setCss(el, prop, val, i);
            }
        });
    }
    if (this.length === 0) {
        return undefined;
    }
    return getCss(this[0], prop);
}
/**
 * Set styles of all elements.
 *
 * @private
 * @param el - Element to set style of.
 * @param prop - Name of property.
 * @param value - Value to set property to.
 * @param idx - Optional index within the selection.
 */
function setCss(el, prop, value, idx) {
    if (typeof prop === 'string') {
        const styles = getCss(el);
        const val = typeof value === 'function' ? value.call(el, idx, styles[prop]) : value;
        if (val === '') {
            delete styles[prop];
        }
        else if (val != null) {
            styles[prop] = val;
        }
        el.attribs['style'] = stringify$c(styles);
    }
    else if (typeof prop === 'object') {
        Object.keys(prop).forEach((k, i) => {
            setCss(el, k, prop[k], i);
        });
    }
}
function getCss(el, prop) {
    if (!el || !isTag$2(el))
        return;
    const styles = parse$k(el.attribs['style']);
    if (typeof prop === 'string') {
        return styles[prop];
    }
    if (Array.isArray(prop)) {
        const newStyles = {};
        prop.forEach((item) => {
            if (styles[item] != null) {
                newStyles[item] = styles[item];
            }
        });
        return newStyles;
    }
    return styles;
}
/**
 * Stringify `obj` to styles.
 *
 * @private
 * @category CSS
 * @param obj - Object to stringify.
 * @returns The serialized styles.
 */
function stringify$c(obj) {
    return Object.keys(obj).reduce((str, prop) => `${str}${str ? ' ' : ''}${prop}: ${obj[prop]};`, '');
}
/**
 * Parse `styles`.
 *
 * @private
 * @category CSS
 * @param styles - Styles to be parsed.
 * @returns The parsed styles.
 */
function parse$k(styles) {
    styles = (styles || '').trim();
    if (!styles)
        return {};
    const obj = {};
    let key;
    for (const str of styles.split(';')) {
        const n = str.indexOf(':');
        // If there is no :, or if it is the first/last character, add to the previous item's value
        if (n < 1 || n === str.length - 1) {
            const trimmed = str.trimEnd();
            if (trimmed.length > 0 && key !== undefined) {
                obj[key] += `;${trimmed}`;
            }
        }
        else {
            key = str.slice(0, n).trim();
            obj[key] = str.slice(n + 1).trim();
        }
    }
    return obj;
}

var Css = /*#__PURE__*/Object.freeze({
    __proto__: null,
    css: css
});

/*
 * https://github.com/jquery/jquery/blob/2.1.3/src/manipulation/var/rcheckableType.js
 * https://github.com/jquery/jquery/blob/2.1.3/src/serialize.js
 */
const submittableSelector = 'input,select,textarea,keygen';
const r20 = /%20/g;
const rCRLF = /\r?\n/g;
/**
 * Encode a set of form elements as a string for submission.
 *
 * @category Forms
 * @example
 *
 * ```js
 * $('<form><input name="foo" value="bar" /></form>').serialize();
 * //=> 'foo=bar'
 * ```
 *
 * @returns The serialized form.
 * @see {@link https://api.jquery.com/serialize/}
 */
function serialize() {
    // Convert form elements into name/value objects
    const arr = this.serializeArray();
    // Serialize each element into a key/value string
    const retArr = arr.map((data) => `${encodeURIComponent(data.name)}=${encodeURIComponent(data.value)}`);
    // Return the resulting serialization
    return retArr.join('&').replace(r20, '+');
}
/**
 * Encode a set of form elements as an array of names and values.
 *
 * @category Forms
 * @example
 *
 * ```js
 * $('<form><input name="foo" value="bar" /></form>').serializeArray();
 * //=> [ { name: 'foo', value: 'bar' } ]
 * ```
 *
 * @returns The serialized form.
 * @see {@link https://api.jquery.com/serializeArray/}
 */
function serializeArray() {
    // Resolve all form elements from either forms or collections of form elements
    return this.map((_, elem) => {
        const $elem = this._make(elem);
        if (isTag$2(elem) && elem.name === 'form') {
            return $elem.find(submittableSelector).toArray();
        }
        return $elem.filter(submittableSelector).toArray();
    })
        .filter(
    // Verify elements have a name (`attr.name`) and are not disabled (`:enabled`)
    '[name!=""]:enabled' +
        // And cannot be clicked (`[type=submit]`) or are used in `x-www-form-urlencoded` (`[type=file]`)
        ':not(:submit, :button, :image, :reset, :file)' +
        // And are either checked/don't have a checkable state
        ':matches([checked], :not(:checkbox, :radio))'
    // Convert each of the elements to its value(s)
    )
        .map((_, elem) => {
        var _a;
        const $elem = this._make(elem);
        const name = $elem.attr('name'); // We have filtered for elements with a name before.
        // If there is no value set (e.g. `undefined`, `null`), then default value to empty
        const value = (_a = $elem.val()) !== null && _a !== void 0 ? _a : '';
        // If we have an array of values (e.g. `<select multiple>`), return an array of key/value pairs
        if (Array.isArray(value)) {
            return value.map((val) => 
            /*
             * We trim replace any line endings (e.g. `\r` or `\r\n` with `\r\n`) to guarantee consistency across platforms
             * These can occur inside of `<textarea>'s`
             */
            ({ name, value: val.replace(rCRLF, '\r\n') }));
        }
        // Otherwise (e.g. `<input type="text">`, return only one key/value pair
        return { name, value: value.replace(rCRLF, '\r\n') };
    })
        .toArray();
}

var Forms = /*#__PURE__*/Object.freeze({
    __proto__: null,
    serialize: serialize,
    serializeArray: serializeArray
});

class Cheerio {
    /**
     * Instance of cheerio. Methods are specified in the modules. Usage of this
     * constructor is not recommended. Please use `$.load` instead.
     *
     * @private
     * @param elements - The new selection.
     * @param root - Sets the root node.
     * @param options - Options for the instance.
     */
    constructor(elements, root, options) {
        this.length = 0;
        this.options = options;
        this._root = root;
        if (elements) {
            for (let idx = 0; idx < elements.length; idx++) {
                this[idx] = elements[idx];
            }
            this.length = elements.length;
        }
    }
}
/** Set a signature of the object. */
Cheerio.prototype.cheerio = '[cheerio object]';
/*
 * Make cheerio an array-like object
 */
Cheerio.prototype.splice = Array.prototype.splice;
// Support for (const element of $(...)) iteration:
Cheerio.prototype[Symbol.iterator] = Array.prototype[Symbol.iterator];
// Plug in the API
Object.assign(Cheerio.prototype, Attributes, Traversing, Manipulation, Css, Forms);

function getLoad(parse, render) {
    /**
     * Create a querying function, bound to a document created from the provided markup.
     *
     * Note that similar to web browser contexts, this operation may introduce
     * `<html>`, `<head>`, and `<body>` elements; set `isDocument` to `false` to
     * switch to fragment mode and disable this.
     *
     * @param content - Markup to be loaded.
     * @param options - Options for the created instance.
     * @param isDocument - Allows parser to be switched to fragment mode.
     * @returns The loaded document.
     * @see {@link https://cheerio.js.org#loading} for additional usage information.
     */
    return function load(content, options, isDocument = true) {
        if (content == null) {
            throw new Error('cheerio.load() expects a string');
        }
        const internalOpts = { ...defaultOpts$2, ...flatten$1(options) };
        const initialRoot = parse(content, internalOpts, isDocument, null);
        /** Create an extended class here, so that extensions only live on one instance. */
        class LoadedCheerio extends Cheerio {
            _make(selector, context) {
                const cheerio = initialize(selector, context);
                cheerio.prevObject = this;
                return cheerio;
            }
            _parse(content, options, isDocument, context) {
                return parse(content, options, isDocument, context);
            }
            _render(dom) {
                return render(dom, this.options);
            }
        }
        function initialize(selector, context, root = initialRoot, opts) {
            // $($)
            if (selector && isCheerio(selector))
                return selector;
            const options = {
                ...internalOpts,
                ...flatten$1(opts),
            };
            const r = typeof root === 'string'
                ? [parse(root, options, false, null)]
                : 'length' in root
                    ? root
                    : [root];
            const rootInstance = isCheerio(r)
                ? r
                : new LoadedCheerio(r, null, options);
            // Add a cyclic reference, so that calling methods on `_root` never fails.
            rootInstance._root = rootInstance;
            // $(), $(null), $(undefined), $(false)
            if (!selector) {
                return new LoadedCheerio(undefined, rootInstance, options);
            }
            const elements = typeof selector === 'string' && isHtml(selector)
                ? // $(<html>)
                    parse(selector, options, false, null).children
                : isNode$1(selector)
                    ? // $(dom)
                        [selector]
                    : Array.isArray(selector)
                        ? // $([dom])
                            selector
                        : undefined;
            const instance = new LoadedCheerio(elements, rootInstance, options);
            if (elements) {
                return instance;
            }
            if (typeof selector !== 'string') {
                throw new Error('Unexpected type of selector');
            }
            // We know that our selector is a string now.
            let search = selector;
            const searchContext = !context
                ? // If we don't have a context, maybe we have a root, from loading
                    rootInstance
                : typeof context === 'string'
                    ? isHtml(context)
                        ? // $('li', '<ul>...</ul>')
                            new LoadedCheerio([parse(context, options, false, null)], rootInstance, options)
                        : // $('li', 'ul')
                            ((search = `${context} ${search}`), rootInstance)
                    : isCheerio(context)
                        ? // $('li', $)
                            context
                        : // $('li', node), $('li', [nodes])
                            new LoadedCheerio(Array.isArray(context) ? context : [context], rootInstance, options);
            // If we still don't have a context, return
            if (!searchContext)
                return instance;
            /*
             * #id, .class, tag
             */
            return searchContext.find(search);
        }
        // Add in static methods & properties
        Object.assign(initialize, staticMethods, {
            load,
            // `_root` and `_options` are used in static methods.
            _root: initialRoot,
            _options: internalOpts,
            // Add `fn` for plugins
            fn: LoadedCheerio.prototype,
            // Add the prototype here to maintain `instanceof` behavior.
            prototype: LoadedCheerio.prototype,
        });
        return initialize;
    };
}
function isNode$1(obj) {
    return (!!obj.name ||
        obj.type === 'root' ||
        obj.type === 'text' ||
        obj.type === 'comment');
}

const UNDEFINED_CODE_POINTS = new Set([
    65534, 65535, 131070, 131071, 196606, 196607, 262142, 262143, 327678, 327679, 393214,
    393215, 458750, 458751, 524286, 524287, 589822, 589823, 655358, 655359, 720894,
    720895, 786430, 786431, 851966, 851967, 917502, 917503, 983038, 983039, 1048574,
    1048575, 1114110, 1114111,
]);
const REPLACEMENT_CHARACTER = '\uFFFD';
var CODE_POINTS;
(function (CODE_POINTS) {
    CODE_POINTS[CODE_POINTS["EOF"] = -1] = "EOF";
    CODE_POINTS[CODE_POINTS["NULL"] = 0] = "NULL";
    CODE_POINTS[CODE_POINTS["TABULATION"] = 9] = "TABULATION";
    CODE_POINTS[CODE_POINTS["CARRIAGE_RETURN"] = 13] = "CARRIAGE_RETURN";
    CODE_POINTS[CODE_POINTS["LINE_FEED"] = 10] = "LINE_FEED";
    CODE_POINTS[CODE_POINTS["FORM_FEED"] = 12] = "FORM_FEED";
    CODE_POINTS[CODE_POINTS["SPACE"] = 32] = "SPACE";
    CODE_POINTS[CODE_POINTS["EXCLAMATION_MARK"] = 33] = "EXCLAMATION_MARK";
    CODE_POINTS[CODE_POINTS["QUOTATION_MARK"] = 34] = "QUOTATION_MARK";
    CODE_POINTS[CODE_POINTS["NUMBER_SIGN"] = 35] = "NUMBER_SIGN";
    CODE_POINTS[CODE_POINTS["AMPERSAND"] = 38] = "AMPERSAND";
    CODE_POINTS[CODE_POINTS["APOSTROPHE"] = 39] = "APOSTROPHE";
    CODE_POINTS[CODE_POINTS["HYPHEN_MINUS"] = 45] = "HYPHEN_MINUS";
    CODE_POINTS[CODE_POINTS["SOLIDUS"] = 47] = "SOLIDUS";
    CODE_POINTS[CODE_POINTS["DIGIT_0"] = 48] = "DIGIT_0";
    CODE_POINTS[CODE_POINTS["DIGIT_9"] = 57] = "DIGIT_9";
    CODE_POINTS[CODE_POINTS["SEMICOLON"] = 59] = "SEMICOLON";
    CODE_POINTS[CODE_POINTS["LESS_THAN_SIGN"] = 60] = "LESS_THAN_SIGN";
    CODE_POINTS[CODE_POINTS["EQUALS_SIGN"] = 61] = "EQUALS_SIGN";
    CODE_POINTS[CODE_POINTS["GREATER_THAN_SIGN"] = 62] = "GREATER_THAN_SIGN";
    CODE_POINTS[CODE_POINTS["QUESTION_MARK"] = 63] = "QUESTION_MARK";
    CODE_POINTS[CODE_POINTS["LATIN_CAPITAL_A"] = 65] = "LATIN_CAPITAL_A";
    CODE_POINTS[CODE_POINTS["LATIN_CAPITAL_F"] = 70] = "LATIN_CAPITAL_F";
    CODE_POINTS[CODE_POINTS["LATIN_CAPITAL_X"] = 88] = "LATIN_CAPITAL_X";
    CODE_POINTS[CODE_POINTS["LATIN_CAPITAL_Z"] = 90] = "LATIN_CAPITAL_Z";
    CODE_POINTS[CODE_POINTS["RIGHT_SQUARE_BRACKET"] = 93] = "RIGHT_SQUARE_BRACKET";
    CODE_POINTS[CODE_POINTS["GRAVE_ACCENT"] = 96] = "GRAVE_ACCENT";
    CODE_POINTS[CODE_POINTS["LATIN_SMALL_A"] = 97] = "LATIN_SMALL_A";
    CODE_POINTS[CODE_POINTS["LATIN_SMALL_F"] = 102] = "LATIN_SMALL_F";
    CODE_POINTS[CODE_POINTS["LATIN_SMALL_X"] = 120] = "LATIN_SMALL_X";
    CODE_POINTS[CODE_POINTS["LATIN_SMALL_Z"] = 122] = "LATIN_SMALL_Z";
    CODE_POINTS[CODE_POINTS["REPLACEMENT_CHARACTER"] = 65533] = "REPLACEMENT_CHARACTER";
})(CODE_POINTS = CODE_POINTS || (CODE_POINTS = {}));
const SEQUENCES = {
    DASH_DASH: '--',
    CDATA_START: '[CDATA[',
    DOCTYPE: 'doctype',
    SCRIPT: 'script',
    PUBLIC: 'public',
    SYSTEM: 'system',
};
//Surrogates
function isSurrogate(cp) {
    return cp >= 55296 && cp <= 57343;
}
function isSurrogatePair(cp) {
    return cp >= 56320 && cp <= 57343;
}
function getSurrogatePairCodePoint(cp1, cp2) {
    return (cp1 - 55296) * 1024 + 9216 + cp2;
}
//NOTE: excluding NULL and ASCII whitespace
function isControlCodePoint(cp) {
    return ((cp !== 0x20 && cp !== 0x0a && cp !== 0x0d && cp !== 0x09 && cp !== 0x0c && cp >= 0x01 && cp <= 0x1f) ||
        (cp >= 0x7f && cp <= 0x9f));
}
function isUndefinedCodePoint(cp) {
    return (cp >= 64976 && cp <= 65007) || UNDEFINED_CODE_POINTS.has(cp);
}

var ERR;
(function (ERR) {
    ERR["controlCharacterInInputStream"] = "control-character-in-input-stream";
    ERR["noncharacterInInputStream"] = "noncharacter-in-input-stream";
    ERR["surrogateInInputStream"] = "surrogate-in-input-stream";
    ERR["nonVoidHtmlElementStartTagWithTrailingSolidus"] = "non-void-html-element-start-tag-with-trailing-solidus";
    ERR["endTagWithAttributes"] = "end-tag-with-attributes";
    ERR["endTagWithTrailingSolidus"] = "end-tag-with-trailing-solidus";
    ERR["unexpectedSolidusInTag"] = "unexpected-solidus-in-tag";
    ERR["unexpectedNullCharacter"] = "unexpected-null-character";
    ERR["unexpectedQuestionMarkInsteadOfTagName"] = "unexpected-question-mark-instead-of-tag-name";
    ERR["invalidFirstCharacterOfTagName"] = "invalid-first-character-of-tag-name";
    ERR["unexpectedEqualsSignBeforeAttributeName"] = "unexpected-equals-sign-before-attribute-name";
    ERR["missingEndTagName"] = "missing-end-tag-name";
    ERR["unexpectedCharacterInAttributeName"] = "unexpected-character-in-attribute-name";
    ERR["unknownNamedCharacterReference"] = "unknown-named-character-reference";
    ERR["missingSemicolonAfterCharacterReference"] = "missing-semicolon-after-character-reference";
    ERR["unexpectedCharacterAfterDoctypeSystemIdentifier"] = "unexpected-character-after-doctype-system-identifier";
    ERR["unexpectedCharacterInUnquotedAttributeValue"] = "unexpected-character-in-unquoted-attribute-value";
    ERR["eofBeforeTagName"] = "eof-before-tag-name";
    ERR["eofInTag"] = "eof-in-tag";
    ERR["missingAttributeValue"] = "missing-attribute-value";
    ERR["missingWhitespaceBetweenAttributes"] = "missing-whitespace-between-attributes";
    ERR["missingWhitespaceAfterDoctypePublicKeyword"] = "missing-whitespace-after-doctype-public-keyword";
    ERR["missingWhitespaceBetweenDoctypePublicAndSystemIdentifiers"] = "missing-whitespace-between-doctype-public-and-system-identifiers";
    ERR["missingWhitespaceAfterDoctypeSystemKeyword"] = "missing-whitespace-after-doctype-system-keyword";
    ERR["missingQuoteBeforeDoctypePublicIdentifier"] = "missing-quote-before-doctype-public-identifier";
    ERR["missingQuoteBeforeDoctypeSystemIdentifier"] = "missing-quote-before-doctype-system-identifier";
    ERR["missingDoctypePublicIdentifier"] = "missing-doctype-public-identifier";
    ERR["missingDoctypeSystemIdentifier"] = "missing-doctype-system-identifier";
    ERR["abruptDoctypePublicIdentifier"] = "abrupt-doctype-public-identifier";
    ERR["abruptDoctypeSystemIdentifier"] = "abrupt-doctype-system-identifier";
    ERR["cdataInHtmlContent"] = "cdata-in-html-content";
    ERR["incorrectlyOpenedComment"] = "incorrectly-opened-comment";
    ERR["eofInScriptHtmlCommentLikeText"] = "eof-in-script-html-comment-like-text";
    ERR["eofInDoctype"] = "eof-in-doctype";
    ERR["nestedComment"] = "nested-comment";
    ERR["abruptClosingOfEmptyComment"] = "abrupt-closing-of-empty-comment";
    ERR["eofInComment"] = "eof-in-comment";
    ERR["incorrectlyClosedComment"] = "incorrectly-closed-comment";
    ERR["eofInCdata"] = "eof-in-cdata";
    ERR["absenceOfDigitsInNumericCharacterReference"] = "absence-of-digits-in-numeric-character-reference";
    ERR["nullCharacterReference"] = "null-character-reference";
    ERR["surrogateCharacterReference"] = "surrogate-character-reference";
    ERR["characterReferenceOutsideUnicodeRange"] = "character-reference-outside-unicode-range";
    ERR["controlCharacterReference"] = "control-character-reference";
    ERR["noncharacterCharacterReference"] = "noncharacter-character-reference";
    ERR["missingWhitespaceBeforeDoctypeName"] = "missing-whitespace-before-doctype-name";
    ERR["missingDoctypeName"] = "missing-doctype-name";
    ERR["invalidCharacterSequenceAfterDoctypeName"] = "invalid-character-sequence-after-doctype-name";
    ERR["duplicateAttribute"] = "duplicate-attribute";
    ERR["nonConformingDoctype"] = "non-conforming-doctype";
    ERR["missingDoctype"] = "missing-doctype";
    ERR["misplacedDoctype"] = "misplaced-doctype";
    ERR["endTagWithoutMatchingOpenElement"] = "end-tag-without-matching-open-element";
    ERR["closingOfElementWithOpenChildElements"] = "closing-of-element-with-open-child-elements";
    ERR["disallowedContentInNoscriptInHead"] = "disallowed-content-in-noscript-in-head";
    ERR["openElementsLeftAfterEof"] = "open-elements-left-after-eof";
    ERR["abandonedHeadElementChild"] = "abandoned-head-element-child";
    ERR["misplacedStartTagForHeadElement"] = "misplaced-start-tag-for-head-element";
    ERR["nestedNoscriptInHead"] = "nested-noscript-in-head";
    ERR["eofInElementThatCanContainOnlyText"] = "eof-in-element-that-can-contain-only-text";
})(ERR = ERR || (ERR = {}));

//Const
const DEFAULT_BUFFER_WATERLINE = 1 << 16;
//Preprocessor
//NOTE: HTML input preprocessing
//(see: http://www.whatwg.org/specs/web-apps/current-work/multipage/parsing.html#preprocessing-the-input-stream)
class Preprocessor {
    constructor(handler) {
        this.handler = handler;
        this.html = '';
        this.pos = -1;
        // NOTE: Initial `lastGapPos` is -2, to ensure `col` on initialisation is 0
        this.lastGapPos = -2;
        this.gapStack = [];
        this.skipNextNewLine = false;
        this.lastChunkWritten = false;
        this.endOfChunkHit = false;
        this.bufferWaterline = DEFAULT_BUFFER_WATERLINE;
        this.isEol = false;
        this.lineStartPos = 0;
        this.droppedBufferSize = 0;
        this.line = 1;
        //NOTE: avoid reporting errors twice on advance/retreat
        this.lastErrOffset = -1;
    }
    /** The column on the current line. If we just saw a gap (eg. a surrogate pair), return the index before. */
    get col() {
        return this.pos - this.lineStartPos + Number(this.lastGapPos !== this.pos);
    }
    get offset() {
        return this.droppedBufferSize + this.pos;
    }
    getError(code) {
        const { line, col, offset } = this;
        return {
            code,
            startLine: line,
            endLine: line,
            startCol: col,
            endCol: col,
            startOffset: offset,
            endOffset: offset,
        };
    }
    _err(code) {
        if (this.handler.onParseError && this.lastErrOffset !== this.offset) {
            this.lastErrOffset = this.offset;
            this.handler.onParseError(this.getError(code));
        }
    }
    _addGap() {
        this.gapStack.push(this.lastGapPos);
        this.lastGapPos = this.pos;
    }
    _processSurrogate(cp) {
        //NOTE: try to peek a surrogate pair
        if (this.pos !== this.html.length - 1) {
            const nextCp = this.html.charCodeAt(this.pos + 1);
            if (isSurrogatePair(nextCp)) {
                //NOTE: we have a surrogate pair. Peek pair character and recalculate code point.
                this.pos++;
                //NOTE: add a gap that should be avoided during retreat
                this._addGap();
                return getSurrogatePairCodePoint(cp, nextCp);
            }
        }
        //NOTE: we are at the end of a chunk, therefore we can't infer the surrogate pair yet.
        else if (!this.lastChunkWritten) {
            this.endOfChunkHit = true;
            return CODE_POINTS.EOF;
        }
        //NOTE: isolated surrogate
        this._err(ERR.surrogateInInputStream);
        return cp;
    }
    willDropParsedChunk() {
        return this.pos > this.bufferWaterline;
    }
    dropParsedChunk() {
        if (this.willDropParsedChunk()) {
            this.html = this.html.substring(this.pos);
            this.lineStartPos -= this.pos;
            this.droppedBufferSize += this.pos;
            this.pos = 0;
            this.lastGapPos = -2;
            this.gapStack.length = 0;
        }
    }
    write(chunk, isLastChunk) {
        if (this.html.length > 0) {
            this.html += chunk;
        }
        else {
            this.html = chunk;
        }
        this.endOfChunkHit = false;
        this.lastChunkWritten = isLastChunk;
    }
    insertHtmlAtCurrentPos(chunk) {
        this.html = this.html.substring(0, this.pos + 1) + chunk + this.html.substring(this.pos + 1);
        this.endOfChunkHit = false;
    }
    startsWith(pattern, caseSensitive) {
        // Check if our buffer has enough characters
        if (this.pos + pattern.length > this.html.length) {
            this.endOfChunkHit = !this.lastChunkWritten;
            return false;
        }
        if (caseSensitive) {
            return this.html.startsWith(pattern, this.pos);
        }
        for (let i = 0; i < pattern.length; i++) {
            const cp = this.html.charCodeAt(this.pos + i) | 0x20;
            if (cp !== pattern.charCodeAt(i)) {
                return false;
            }
        }
        return true;
    }
    peek(offset) {
        const pos = this.pos + offset;
        if (pos >= this.html.length) {
            this.endOfChunkHit = !this.lastChunkWritten;
            return CODE_POINTS.EOF;
        }
        const code = this.html.charCodeAt(pos);
        return code === CODE_POINTS.CARRIAGE_RETURN ? CODE_POINTS.LINE_FEED : code;
    }
    advance() {
        this.pos++;
        //NOTE: LF should be in the last column of the line
        if (this.isEol) {
            this.isEol = false;
            this.line++;
            this.lineStartPos = this.pos;
        }
        if (this.pos >= this.html.length) {
            this.endOfChunkHit = !this.lastChunkWritten;
            return CODE_POINTS.EOF;
        }
        let cp = this.html.charCodeAt(this.pos);
        //NOTE: all U+000D CARRIAGE RETURN (CR) characters must be converted to U+000A LINE FEED (LF) characters
        if (cp === CODE_POINTS.CARRIAGE_RETURN) {
            this.isEol = true;
            this.skipNextNewLine = true;
            return CODE_POINTS.LINE_FEED;
        }
        //NOTE: any U+000A LINE FEED (LF) characters that immediately follow a U+000D CARRIAGE RETURN (CR) character
        //must be ignored.
        if (cp === CODE_POINTS.LINE_FEED) {
            this.isEol = true;
            if (this.skipNextNewLine) {
                // `line` will be bumped again in the recursive call.
                this.line--;
                this.skipNextNewLine = false;
                this._addGap();
                return this.advance();
            }
        }
        this.skipNextNewLine = false;
        if (isSurrogate(cp)) {
            cp = this._processSurrogate(cp);
        }
        //OPTIMIZATION: first check if code point is in the common allowed
        //range (ASCII alphanumeric, whitespaces, big chunk of BMP)
        //before going into detailed performance cost validation.
        const isCommonValidRange = this.handler.onParseError === null ||
            (cp > 0x1f && cp < 0x7f) ||
            cp === CODE_POINTS.LINE_FEED ||
            cp === CODE_POINTS.CARRIAGE_RETURN ||
            (cp > 0x9f && cp < 64976);
        if (!isCommonValidRange) {
            this._checkForProblematicCharacters(cp);
        }
        return cp;
    }
    _checkForProblematicCharacters(cp) {
        if (isControlCodePoint(cp)) {
            this._err(ERR.controlCharacterInInputStream);
        }
        else if (isUndefinedCodePoint(cp)) {
            this._err(ERR.noncharacterInInputStream);
        }
    }
    retreat(count) {
        this.pos -= count;
        while (this.pos < this.lastGapPos) {
            this.lastGapPos = this.gapStack.pop();
            this.pos--;
        }
        this.isEol = false;
    }
}

var TokenType;
(function (TokenType) {
    TokenType[TokenType["CHARACTER"] = 0] = "CHARACTER";
    TokenType[TokenType["NULL_CHARACTER"] = 1] = "NULL_CHARACTER";
    TokenType[TokenType["WHITESPACE_CHARACTER"] = 2] = "WHITESPACE_CHARACTER";
    TokenType[TokenType["START_TAG"] = 3] = "START_TAG";
    TokenType[TokenType["END_TAG"] = 4] = "END_TAG";
    TokenType[TokenType["COMMENT"] = 5] = "COMMENT";
    TokenType[TokenType["DOCTYPE"] = 6] = "DOCTYPE";
    TokenType[TokenType["EOF"] = 7] = "EOF";
    TokenType[TokenType["HIBERNATION"] = 8] = "HIBERNATION";
})(TokenType = TokenType || (TokenType = {}));
function getTokenAttr(token, attrName) {
    for (let i = token.attrs.length - 1; i >= 0; i--) {
        if (token.attrs[i].name === attrName) {
            return token.attrs[i].value;
        }
    }
    return null;
}

/** All valid namespaces in HTML. */
var NS;
(function (NS) {
    NS["HTML"] = "http://www.w3.org/1999/xhtml";
    NS["MATHML"] = "http://www.w3.org/1998/Math/MathML";
    NS["SVG"] = "http://www.w3.org/2000/svg";
    NS["XLINK"] = "http://www.w3.org/1999/xlink";
    NS["XML"] = "http://www.w3.org/XML/1998/namespace";
    NS["XMLNS"] = "http://www.w3.org/2000/xmlns/";
})(NS = NS || (NS = {}));
var ATTRS;
(function (ATTRS) {
    ATTRS["TYPE"] = "type";
    ATTRS["ACTION"] = "action";
    ATTRS["ENCODING"] = "encoding";
    ATTRS["PROMPT"] = "prompt";
    ATTRS["NAME"] = "name";
    ATTRS["COLOR"] = "color";
    ATTRS["FACE"] = "face";
    ATTRS["SIZE"] = "size";
})(ATTRS = ATTRS || (ATTRS = {}));
/**
 * The mode of the document.
 *
 * @see {@link https://dom.spec.whatwg.org/#concept-document-limited-quirks}
 */
var DOCUMENT_MODE;
(function (DOCUMENT_MODE) {
    DOCUMENT_MODE["NO_QUIRKS"] = "no-quirks";
    DOCUMENT_MODE["QUIRKS"] = "quirks";
    DOCUMENT_MODE["LIMITED_QUIRKS"] = "limited-quirks";
})(DOCUMENT_MODE = DOCUMENT_MODE || (DOCUMENT_MODE = {}));
var TAG_NAMES;
(function (TAG_NAMES) {
    TAG_NAMES["A"] = "a";
    TAG_NAMES["ADDRESS"] = "address";
    TAG_NAMES["ANNOTATION_XML"] = "annotation-xml";
    TAG_NAMES["APPLET"] = "applet";
    TAG_NAMES["AREA"] = "area";
    TAG_NAMES["ARTICLE"] = "article";
    TAG_NAMES["ASIDE"] = "aside";
    TAG_NAMES["B"] = "b";
    TAG_NAMES["BASE"] = "base";
    TAG_NAMES["BASEFONT"] = "basefont";
    TAG_NAMES["BGSOUND"] = "bgsound";
    TAG_NAMES["BIG"] = "big";
    TAG_NAMES["BLOCKQUOTE"] = "blockquote";
    TAG_NAMES["BODY"] = "body";
    TAG_NAMES["BR"] = "br";
    TAG_NAMES["BUTTON"] = "button";
    TAG_NAMES["CAPTION"] = "caption";
    TAG_NAMES["CENTER"] = "center";
    TAG_NAMES["CODE"] = "code";
    TAG_NAMES["COL"] = "col";
    TAG_NAMES["COLGROUP"] = "colgroup";
    TAG_NAMES["DD"] = "dd";
    TAG_NAMES["DESC"] = "desc";
    TAG_NAMES["DETAILS"] = "details";
    TAG_NAMES["DIALOG"] = "dialog";
    TAG_NAMES["DIR"] = "dir";
    TAG_NAMES["DIV"] = "div";
    TAG_NAMES["DL"] = "dl";
    TAG_NAMES["DT"] = "dt";
    TAG_NAMES["EM"] = "em";
    TAG_NAMES["EMBED"] = "embed";
    TAG_NAMES["FIELDSET"] = "fieldset";
    TAG_NAMES["FIGCAPTION"] = "figcaption";
    TAG_NAMES["FIGURE"] = "figure";
    TAG_NAMES["FONT"] = "font";
    TAG_NAMES["FOOTER"] = "footer";
    TAG_NAMES["FOREIGN_OBJECT"] = "foreignObject";
    TAG_NAMES["FORM"] = "form";
    TAG_NAMES["FRAME"] = "frame";
    TAG_NAMES["FRAMESET"] = "frameset";
    TAG_NAMES["H1"] = "h1";
    TAG_NAMES["H2"] = "h2";
    TAG_NAMES["H3"] = "h3";
    TAG_NAMES["H4"] = "h4";
    TAG_NAMES["H5"] = "h5";
    TAG_NAMES["H6"] = "h6";
    TAG_NAMES["HEAD"] = "head";
    TAG_NAMES["HEADER"] = "header";
    TAG_NAMES["HGROUP"] = "hgroup";
    TAG_NAMES["HR"] = "hr";
    TAG_NAMES["HTML"] = "html";
    TAG_NAMES["I"] = "i";
    TAG_NAMES["IMG"] = "img";
    TAG_NAMES["IMAGE"] = "image";
    TAG_NAMES["INPUT"] = "input";
    TAG_NAMES["IFRAME"] = "iframe";
    TAG_NAMES["KEYGEN"] = "keygen";
    TAG_NAMES["LABEL"] = "label";
    TAG_NAMES["LI"] = "li";
    TAG_NAMES["LINK"] = "link";
    TAG_NAMES["LISTING"] = "listing";
    TAG_NAMES["MAIN"] = "main";
    TAG_NAMES["MALIGNMARK"] = "malignmark";
    TAG_NAMES["MARQUEE"] = "marquee";
    TAG_NAMES["MATH"] = "math";
    TAG_NAMES["MENU"] = "menu";
    TAG_NAMES["META"] = "meta";
    TAG_NAMES["MGLYPH"] = "mglyph";
    TAG_NAMES["MI"] = "mi";
    TAG_NAMES["MO"] = "mo";
    TAG_NAMES["MN"] = "mn";
    TAG_NAMES["MS"] = "ms";
    TAG_NAMES["MTEXT"] = "mtext";
    TAG_NAMES["NAV"] = "nav";
    TAG_NAMES["NOBR"] = "nobr";
    TAG_NAMES["NOFRAMES"] = "noframes";
    TAG_NAMES["NOEMBED"] = "noembed";
    TAG_NAMES["NOSCRIPT"] = "noscript";
    TAG_NAMES["OBJECT"] = "object";
    TAG_NAMES["OL"] = "ol";
    TAG_NAMES["OPTGROUP"] = "optgroup";
    TAG_NAMES["OPTION"] = "option";
    TAG_NAMES["P"] = "p";
    TAG_NAMES["PARAM"] = "param";
    TAG_NAMES["PLAINTEXT"] = "plaintext";
    TAG_NAMES["PRE"] = "pre";
    TAG_NAMES["RB"] = "rb";
    TAG_NAMES["RP"] = "rp";
    TAG_NAMES["RT"] = "rt";
    TAG_NAMES["RTC"] = "rtc";
    TAG_NAMES["RUBY"] = "ruby";
    TAG_NAMES["S"] = "s";
    TAG_NAMES["SCRIPT"] = "script";
    TAG_NAMES["SECTION"] = "section";
    TAG_NAMES["SELECT"] = "select";
    TAG_NAMES["SOURCE"] = "source";
    TAG_NAMES["SMALL"] = "small";
    TAG_NAMES["SPAN"] = "span";
    TAG_NAMES["STRIKE"] = "strike";
    TAG_NAMES["STRONG"] = "strong";
    TAG_NAMES["STYLE"] = "style";
    TAG_NAMES["SUB"] = "sub";
    TAG_NAMES["SUMMARY"] = "summary";
    TAG_NAMES["SUP"] = "sup";
    TAG_NAMES["TABLE"] = "table";
    TAG_NAMES["TBODY"] = "tbody";
    TAG_NAMES["TEMPLATE"] = "template";
    TAG_NAMES["TEXTAREA"] = "textarea";
    TAG_NAMES["TFOOT"] = "tfoot";
    TAG_NAMES["TD"] = "td";
    TAG_NAMES["TH"] = "th";
    TAG_NAMES["THEAD"] = "thead";
    TAG_NAMES["TITLE"] = "title";
    TAG_NAMES["TR"] = "tr";
    TAG_NAMES["TRACK"] = "track";
    TAG_NAMES["TT"] = "tt";
    TAG_NAMES["U"] = "u";
    TAG_NAMES["UL"] = "ul";
    TAG_NAMES["SVG"] = "svg";
    TAG_NAMES["VAR"] = "var";
    TAG_NAMES["WBR"] = "wbr";
    TAG_NAMES["XMP"] = "xmp";
})(TAG_NAMES = TAG_NAMES || (TAG_NAMES = {}));
/**
 * Tag IDs are numeric IDs for known tag names.
 *
 * We use tag IDs to improve the performance of tag name comparisons.
 */
var TAG_ID;
(function (TAG_ID) {
    TAG_ID[TAG_ID["UNKNOWN"] = 0] = "UNKNOWN";
    TAG_ID[TAG_ID["A"] = 1] = "A";
    TAG_ID[TAG_ID["ADDRESS"] = 2] = "ADDRESS";
    TAG_ID[TAG_ID["ANNOTATION_XML"] = 3] = "ANNOTATION_XML";
    TAG_ID[TAG_ID["APPLET"] = 4] = "APPLET";
    TAG_ID[TAG_ID["AREA"] = 5] = "AREA";
    TAG_ID[TAG_ID["ARTICLE"] = 6] = "ARTICLE";
    TAG_ID[TAG_ID["ASIDE"] = 7] = "ASIDE";
    TAG_ID[TAG_ID["B"] = 8] = "B";
    TAG_ID[TAG_ID["BASE"] = 9] = "BASE";
    TAG_ID[TAG_ID["BASEFONT"] = 10] = "BASEFONT";
    TAG_ID[TAG_ID["BGSOUND"] = 11] = "BGSOUND";
    TAG_ID[TAG_ID["BIG"] = 12] = "BIG";
    TAG_ID[TAG_ID["BLOCKQUOTE"] = 13] = "BLOCKQUOTE";
    TAG_ID[TAG_ID["BODY"] = 14] = "BODY";
    TAG_ID[TAG_ID["BR"] = 15] = "BR";
    TAG_ID[TAG_ID["BUTTON"] = 16] = "BUTTON";
    TAG_ID[TAG_ID["CAPTION"] = 17] = "CAPTION";
    TAG_ID[TAG_ID["CENTER"] = 18] = "CENTER";
    TAG_ID[TAG_ID["CODE"] = 19] = "CODE";
    TAG_ID[TAG_ID["COL"] = 20] = "COL";
    TAG_ID[TAG_ID["COLGROUP"] = 21] = "COLGROUP";
    TAG_ID[TAG_ID["DD"] = 22] = "DD";
    TAG_ID[TAG_ID["DESC"] = 23] = "DESC";
    TAG_ID[TAG_ID["DETAILS"] = 24] = "DETAILS";
    TAG_ID[TAG_ID["DIALOG"] = 25] = "DIALOG";
    TAG_ID[TAG_ID["DIR"] = 26] = "DIR";
    TAG_ID[TAG_ID["DIV"] = 27] = "DIV";
    TAG_ID[TAG_ID["DL"] = 28] = "DL";
    TAG_ID[TAG_ID["DT"] = 29] = "DT";
    TAG_ID[TAG_ID["EM"] = 30] = "EM";
    TAG_ID[TAG_ID["EMBED"] = 31] = "EMBED";
    TAG_ID[TAG_ID["FIELDSET"] = 32] = "FIELDSET";
    TAG_ID[TAG_ID["FIGCAPTION"] = 33] = "FIGCAPTION";
    TAG_ID[TAG_ID["FIGURE"] = 34] = "FIGURE";
    TAG_ID[TAG_ID["FONT"] = 35] = "FONT";
    TAG_ID[TAG_ID["FOOTER"] = 36] = "FOOTER";
    TAG_ID[TAG_ID["FOREIGN_OBJECT"] = 37] = "FOREIGN_OBJECT";
    TAG_ID[TAG_ID["FORM"] = 38] = "FORM";
    TAG_ID[TAG_ID["FRAME"] = 39] = "FRAME";
    TAG_ID[TAG_ID["FRAMESET"] = 40] = "FRAMESET";
    TAG_ID[TAG_ID["H1"] = 41] = "H1";
    TAG_ID[TAG_ID["H2"] = 42] = "H2";
    TAG_ID[TAG_ID["H3"] = 43] = "H3";
    TAG_ID[TAG_ID["H4"] = 44] = "H4";
    TAG_ID[TAG_ID["H5"] = 45] = "H5";
    TAG_ID[TAG_ID["H6"] = 46] = "H6";
    TAG_ID[TAG_ID["HEAD"] = 47] = "HEAD";
    TAG_ID[TAG_ID["HEADER"] = 48] = "HEADER";
    TAG_ID[TAG_ID["HGROUP"] = 49] = "HGROUP";
    TAG_ID[TAG_ID["HR"] = 50] = "HR";
    TAG_ID[TAG_ID["HTML"] = 51] = "HTML";
    TAG_ID[TAG_ID["I"] = 52] = "I";
    TAG_ID[TAG_ID["IMG"] = 53] = "IMG";
    TAG_ID[TAG_ID["IMAGE"] = 54] = "IMAGE";
    TAG_ID[TAG_ID["INPUT"] = 55] = "INPUT";
    TAG_ID[TAG_ID["IFRAME"] = 56] = "IFRAME";
    TAG_ID[TAG_ID["KEYGEN"] = 57] = "KEYGEN";
    TAG_ID[TAG_ID["LABEL"] = 58] = "LABEL";
    TAG_ID[TAG_ID["LI"] = 59] = "LI";
    TAG_ID[TAG_ID["LINK"] = 60] = "LINK";
    TAG_ID[TAG_ID["LISTING"] = 61] = "LISTING";
    TAG_ID[TAG_ID["MAIN"] = 62] = "MAIN";
    TAG_ID[TAG_ID["MALIGNMARK"] = 63] = "MALIGNMARK";
    TAG_ID[TAG_ID["MARQUEE"] = 64] = "MARQUEE";
    TAG_ID[TAG_ID["MATH"] = 65] = "MATH";
    TAG_ID[TAG_ID["MENU"] = 66] = "MENU";
    TAG_ID[TAG_ID["META"] = 67] = "META";
    TAG_ID[TAG_ID["MGLYPH"] = 68] = "MGLYPH";
    TAG_ID[TAG_ID["MI"] = 69] = "MI";
    TAG_ID[TAG_ID["MO"] = 70] = "MO";
    TAG_ID[TAG_ID["MN"] = 71] = "MN";
    TAG_ID[TAG_ID["MS"] = 72] = "MS";
    TAG_ID[TAG_ID["MTEXT"] = 73] = "MTEXT";
    TAG_ID[TAG_ID["NAV"] = 74] = "NAV";
    TAG_ID[TAG_ID["NOBR"] = 75] = "NOBR";
    TAG_ID[TAG_ID["NOFRAMES"] = 76] = "NOFRAMES";
    TAG_ID[TAG_ID["NOEMBED"] = 77] = "NOEMBED";
    TAG_ID[TAG_ID["NOSCRIPT"] = 78] = "NOSCRIPT";
    TAG_ID[TAG_ID["OBJECT"] = 79] = "OBJECT";
    TAG_ID[TAG_ID["OL"] = 80] = "OL";
    TAG_ID[TAG_ID["OPTGROUP"] = 81] = "OPTGROUP";
    TAG_ID[TAG_ID["OPTION"] = 82] = "OPTION";
    TAG_ID[TAG_ID["P"] = 83] = "P";
    TAG_ID[TAG_ID["PARAM"] = 84] = "PARAM";
    TAG_ID[TAG_ID["PLAINTEXT"] = 85] = "PLAINTEXT";
    TAG_ID[TAG_ID["PRE"] = 86] = "PRE";
    TAG_ID[TAG_ID["RB"] = 87] = "RB";
    TAG_ID[TAG_ID["RP"] = 88] = "RP";
    TAG_ID[TAG_ID["RT"] = 89] = "RT";
    TAG_ID[TAG_ID["RTC"] = 90] = "RTC";
    TAG_ID[TAG_ID["RUBY"] = 91] = "RUBY";
    TAG_ID[TAG_ID["S"] = 92] = "S";
    TAG_ID[TAG_ID["SCRIPT"] = 93] = "SCRIPT";
    TAG_ID[TAG_ID["SECTION"] = 94] = "SECTION";
    TAG_ID[TAG_ID["SELECT"] = 95] = "SELECT";
    TAG_ID[TAG_ID["SOURCE"] = 96] = "SOURCE";
    TAG_ID[TAG_ID["SMALL"] = 97] = "SMALL";
    TAG_ID[TAG_ID["SPAN"] = 98] = "SPAN";
    TAG_ID[TAG_ID["STRIKE"] = 99] = "STRIKE";
    TAG_ID[TAG_ID["STRONG"] = 100] = "STRONG";
    TAG_ID[TAG_ID["STYLE"] = 101] = "STYLE";
    TAG_ID[TAG_ID["SUB"] = 102] = "SUB";
    TAG_ID[TAG_ID["SUMMARY"] = 103] = "SUMMARY";
    TAG_ID[TAG_ID["SUP"] = 104] = "SUP";
    TAG_ID[TAG_ID["TABLE"] = 105] = "TABLE";
    TAG_ID[TAG_ID["TBODY"] = 106] = "TBODY";
    TAG_ID[TAG_ID["TEMPLATE"] = 107] = "TEMPLATE";
    TAG_ID[TAG_ID["TEXTAREA"] = 108] = "TEXTAREA";
    TAG_ID[TAG_ID["TFOOT"] = 109] = "TFOOT";
    TAG_ID[TAG_ID["TD"] = 110] = "TD";
    TAG_ID[TAG_ID["TH"] = 111] = "TH";
    TAG_ID[TAG_ID["THEAD"] = 112] = "THEAD";
    TAG_ID[TAG_ID["TITLE"] = 113] = "TITLE";
    TAG_ID[TAG_ID["TR"] = 114] = "TR";
    TAG_ID[TAG_ID["TRACK"] = 115] = "TRACK";
    TAG_ID[TAG_ID["TT"] = 116] = "TT";
    TAG_ID[TAG_ID["U"] = 117] = "U";
    TAG_ID[TAG_ID["UL"] = 118] = "UL";
    TAG_ID[TAG_ID["SVG"] = 119] = "SVG";
    TAG_ID[TAG_ID["VAR"] = 120] = "VAR";
    TAG_ID[TAG_ID["WBR"] = 121] = "WBR";
    TAG_ID[TAG_ID["XMP"] = 122] = "XMP";
})(TAG_ID = TAG_ID || (TAG_ID = {}));
const TAG_NAME_TO_ID = new Map([
    [TAG_NAMES.A, TAG_ID.A],
    [TAG_NAMES.ADDRESS, TAG_ID.ADDRESS],
    [TAG_NAMES.ANNOTATION_XML, TAG_ID.ANNOTATION_XML],
    [TAG_NAMES.APPLET, TAG_ID.APPLET],
    [TAG_NAMES.AREA, TAG_ID.AREA],
    [TAG_NAMES.ARTICLE, TAG_ID.ARTICLE],
    [TAG_NAMES.ASIDE, TAG_ID.ASIDE],
    [TAG_NAMES.B, TAG_ID.B],
    [TAG_NAMES.BASE, TAG_ID.BASE],
    [TAG_NAMES.BASEFONT, TAG_ID.BASEFONT],
    [TAG_NAMES.BGSOUND, TAG_ID.BGSOUND],
    [TAG_NAMES.BIG, TAG_ID.BIG],
    [TAG_NAMES.BLOCKQUOTE, TAG_ID.BLOCKQUOTE],
    [TAG_NAMES.BODY, TAG_ID.BODY],
    [TAG_NAMES.BR, TAG_ID.BR],
    [TAG_NAMES.BUTTON, TAG_ID.BUTTON],
    [TAG_NAMES.CAPTION, TAG_ID.CAPTION],
    [TAG_NAMES.CENTER, TAG_ID.CENTER],
    [TAG_NAMES.CODE, TAG_ID.CODE],
    [TAG_NAMES.COL, TAG_ID.COL],
    [TAG_NAMES.COLGROUP, TAG_ID.COLGROUP],
    [TAG_NAMES.DD, TAG_ID.DD],
    [TAG_NAMES.DESC, TAG_ID.DESC],
    [TAG_NAMES.DETAILS, TAG_ID.DETAILS],
    [TAG_NAMES.DIALOG, TAG_ID.DIALOG],
    [TAG_NAMES.DIR, TAG_ID.DIR],
    [TAG_NAMES.DIV, TAG_ID.DIV],
    [TAG_NAMES.DL, TAG_ID.DL],
    [TAG_NAMES.DT, TAG_ID.DT],
    [TAG_NAMES.EM, TAG_ID.EM],
    [TAG_NAMES.EMBED, TAG_ID.EMBED],
    [TAG_NAMES.FIELDSET, TAG_ID.FIELDSET],
    [TAG_NAMES.FIGCAPTION, TAG_ID.FIGCAPTION],
    [TAG_NAMES.FIGURE, TAG_ID.FIGURE],
    [TAG_NAMES.FONT, TAG_ID.FONT],
    [TAG_NAMES.FOOTER, TAG_ID.FOOTER],
    [TAG_NAMES.FOREIGN_OBJECT, TAG_ID.FOREIGN_OBJECT],
    [TAG_NAMES.FORM, TAG_ID.FORM],
    [TAG_NAMES.FRAME, TAG_ID.FRAME],
    [TAG_NAMES.FRAMESET, TAG_ID.FRAMESET],
    [TAG_NAMES.H1, TAG_ID.H1],
    [TAG_NAMES.H2, TAG_ID.H2],
    [TAG_NAMES.H3, TAG_ID.H3],
    [TAG_NAMES.H4, TAG_ID.H4],
    [TAG_NAMES.H5, TAG_ID.H5],
    [TAG_NAMES.H6, TAG_ID.H6],
    [TAG_NAMES.HEAD, TAG_ID.HEAD],
    [TAG_NAMES.HEADER, TAG_ID.HEADER],
    [TAG_NAMES.HGROUP, TAG_ID.HGROUP],
    [TAG_NAMES.HR, TAG_ID.HR],
    [TAG_NAMES.HTML, TAG_ID.HTML],
    [TAG_NAMES.I, TAG_ID.I],
    [TAG_NAMES.IMG, TAG_ID.IMG],
    [TAG_NAMES.IMAGE, TAG_ID.IMAGE],
    [TAG_NAMES.INPUT, TAG_ID.INPUT],
    [TAG_NAMES.IFRAME, TAG_ID.IFRAME],
    [TAG_NAMES.KEYGEN, TAG_ID.KEYGEN],
    [TAG_NAMES.LABEL, TAG_ID.LABEL],
    [TAG_NAMES.LI, TAG_ID.LI],
    [TAG_NAMES.LINK, TAG_ID.LINK],
    [TAG_NAMES.LISTING, TAG_ID.LISTING],
    [TAG_NAMES.MAIN, TAG_ID.MAIN],
    [TAG_NAMES.MALIGNMARK, TAG_ID.MALIGNMARK],
    [TAG_NAMES.MARQUEE, TAG_ID.MARQUEE],
    [TAG_NAMES.MATH, TAG_ID.MATH],
    [TAG_NAMES.MENU, TAG_ID.MENU],
    [TAG_NAMES.META, TAG_ID.META],
    [TAG_NAMES.MGLYPH, TAG_ID.MGLYPH],
    [TAG_NAMES.MI, TAG_ID.MI],
    [TAG_NAMES.MO, TAG_ID.MO],
    [TAG_NAMES.MN, TAG_ID.MN],
    [TAG_NAMES.MS, TAG_ID.MS],
    [TAG_NAMES.MTEXT, TAG_ID.MTEXT],
    [TAG_NAMES.NAV, TAG_ID.NAV],
    [TAG_NAMES.NOBR, TAG_ID.NOBR],
    [TAG_NAMES.NOFRAMES, TAG_ID.NOFRAMES],
    [TAG_NAMES.NOEMBED, TAG_ID.NOEMBED],
    [TAG_NAMES.NOSCRIPT, TAG_ID.NOSCRIPT],
    [TAG_NAMES.OBJECT, TAG_ID.OBJECT],
    [TAG_NAMES.OL, TAG_ID.OL],
    [TAG_NAMES.OPTGROUP, TAG_ID.OPTGROUP],
    [TAG_NAMES.OPTION, TAG_ID.OPTION],
    [TAG_NAMES.P, TAG_ID.P],
    [TAG_NAMES.PARAM, TAG_ID.PARAM],
    [TAG_NAMES.PLAINTEXT, TAG_ID.PLAINTEXT],
    [TAG_NAMES.PRE, TAG_ID.PRE],
    [TAG_NAMES.RB, TAG_ID.RB],
    [TAG_NAMES.RP, TAG_ID.RP],
    [TAG_NAMES.RT, TAG_ID.RT],
    [TAG_NAMES.RTC, TAG_ID.RTC],
    [TAG_NAMES.RUBY, TAG_ID.RUBY],
    [TAG_NAMES.S, TAG_ID.S],
    [TAG_NAMES.SCRIPT, TAG_ID.SCRIPT],
    [TAG_NAMES.SECTION, TAG_ID.SECTION],
    [TAG_NAMES.SELECT, TAG_ID.SELECT],
    [TAG_NAMES.SOURCE, TAG_ID.SOURCE],
    [TAG_NAMES.SMALL, TAG_ID.SMALL],
    [TAG_NAMES.SPAN, TAG_ID.SPAN],
    [TAG_NAMES.STRIKE, TAG_ID.STRIKE],
    [TAG_NAMES.STRONG, TAG_ID.STRONG],
    [TAG_NAMES.STYLE, TAG_ID.STYLE],
    [TAG_NAMES.SUB, TAG_ID.SUB],
    [TAG_NAMES.SUMMARY, TAG_ID.SUMMARY],
    [TAG_NAMES.SUP, TAG_ID.SUP],
    [TAG_NAMES.TABLE, TAG_ID.TABLE],
    [TAG_NAMES.TBODY, TAG_ID.TBODY],
    [TAG_NAMES.TEMPLATE, TAG_ID.TEMPLATE],
    [TAG_NAMES.TEXTAREA, TAG_ID.TEXTAREA],
    [TAG_NAMES.TFOOT, TAG_ID.TFOOT],
    [TAG_NAMES.TD, TAG_ID.TD],
    [TAG_NAMES.TH, TAG_ID.TH],
    [TAG_NAMES.THEAD, TAG_ID.THEAD],
    [TAG_NAMES.TITLE, TAG_ID.TITLE],
    [TAG_NAMES.TR, TAG_ID.TR],
    [TAG_NAMES.TRACK, TAG_ID.TRACK],
    [TAG_NAMES.TT, TAG_ID.TT],
    [TAG_NAMES.U, TAG_ID.U],
    [TAG_NAMES.UL, TAG_ID.UL],
    [TAG_NAMES.SVG, TAG_ID.SVG],
    [TAG_NAMES.VAR, TAG_ID.VAR],
    [TAG_NAMES.WBR, TAG_ID.WBR],
    [TAG_NAMES.XMP, TAG_ID.XMP],
]);
function getTagID(tagName) {
    var _a;
    return (_a = TAG_NAME_TO_ID.get(tagName)) !== null && _a !== void 0 ? _a : TAG_ID.UNKNOWN;
}
const $$1 = TAG_ID;
const SPECIAL_ELEMENTS = {
    [NS.HTML]: new Set([
        $$1.ADDRESS,
        $$1.APPLET,
        $$1.AREA,
        $$1.ARTICLE,
        $$1.ASIDE,
        $$1.BASE,
        $$1.BASEFONT,
        $$1.BGSOUND,
        $$1.BLOCKQUOTE,
        $$1.BODY,
        $$1.BR,
        $$1.BUTTON,
        $$1.CAPTION,
        $$1.CENTER,
        $$1.COL,
        $$1.COLGROUP,
        $$1.DD,
        $$1.DETAILS,
        $$1.DIR,
        $$1.DIV,
        $$1.DL,
        $$1.DT,
        $$1.EMBED,
        $$1.FIELDSET,
        $$1.FIGCAPTION,
        $$1.FIGURE,
        $$1.FOOTER,
        $$1.FORM,
        $$1.FRAME,
        $$1.FRAMESET,
        $$1.H1,
        $$1.H2,
        $$1.H3,
        $$1.H4,
        $$1.H5,
        $$1.H6,
        $$1.HEAD,
        $$1.HEADER,
        $$1.HGROUP,
        $$1.HR,
        $$1.HTML,
        $$1.IFRAME,
        $$1.IMG,
        $$1.INPUT,
        $$1.LI,
        $$1.LINK,
        $$1.LISTING,
        $$1.MAIN,
        $$1.MARQUEE,
        $$1.MENU,
        $$1.META,
        $$1.NAV,
        $$1.NOEMBED,
        $$1.NOFRAMES,
        $$1.NOSCRIPT,
        $$1.OBJECT,
        $$1.OL,
        $$1.P,
        $$1.PARAM,
        $$1.PLAINTEXT,
        $$1.PRE,
        $$1.SCRIPT,
        $$1.SECTION,
        $$1.SELECT,
        $$1.SOURCE,
        $$1.STYLE,
        $$1.SUMMARY,
        $$1.TABLE,
        $$1.TBODY,
        $$1.TD,
        $$1.TEMPLATE,
        $$1.TEXTAREA,
        $$1.TFOOT,
        $$1.TH,
        $$1.THEAD,
        $$1.TITLE,
        $$1.TR,
        $$1.TRACK,
        $$1.UL,
        $$1.WBR,
        $$1.XMP,
    ]),
    [NS.MATHML]: new Set([$$1.MI, $$1.MO, $$1.MN, $$1.MS, $$1.MTEXT, $$1.ANNOTATION_XML]),
    [NS.SVG]: new Set([$$1.TITLE, $$1.FOREIGN_OBJECT, $$1.DESC]),
    [NS.XLINK]: new Set(),
    [NS.XML]: new Set(),
    [NS.XMLNS]: new Set(),
};
function isNumberedHeader(tn) {
    return tn === $$1.H1 || tn === $$1.H2 || tn === $$1.H3 || tn === $$1.H4 || tn === $$1.H5 || tn === $$1.H6;
}
const UNESCAPED_TEXT = new Set([
    TAG_NAMES.STYLE,
    TAG_NAMES.SCRIPT,
    TAG_NAMES.XMP,
    TAG_NAMES.IFRAME,
    TAG_NAMES.NOEMBED,
    TAG_NAMES.NOFRAMES,
    TAG_NAMES.PLAINTEXT,
]);
function hasUnescapedText(tn, scriptingEnabled) {
    return UNESCAPED_TEXT.has(tn) || (scriptingEnabled && tn === TAG_NAMES.NOSCRIPT);
}

//C1 Unicode control character reference replacements
const C1_CONTROLS_REFERENCE_REPLACEMENTS = new Map([
    [0x80, 8364],
    [0x82, 8218],
    [0x83, 402],
    [0x84, 8222],
    [0x85, 8230],
    [0x86, 8224],
    [0x87, 8225],
    [0x88, 710],
    [0x89, 8240],
    [0x8a, 352],
    [0x8b, 8249],
    [0x8c, 338],
    [0x8e, 381],
    [0x91, 8216],
    [0x92, 8217],
    [0x93, 8220],
    [0x94, 8221],
    [0x95, 8226],
    [0x96, 8211],
    [0x97, 8212],
    [0x98, 732],
    [0x99, 8482],
    [0x9a, 353],
    [0x9b, 8250],
    [0x9c, 339],
    [0x9e, 382],
    [0x9f, 376],
]);
//States
var State$1;
(function (State) {
    State[State["DATA"] = 0] = "DATA";
    State[State["RCDATA"] = 1] = "RCDATA";
    State[State["RAWTEXT"] = 2] = "RAWTEXT";
    State[State["SCRIPT_DATA"] = 3] = "SCRIPT_DATA";
    State[State["PLAINTEXT"] = 4] = "PLAINTEXT";
    State[State["TAG_OPEN"] = 5] = "TAG_OPEN";
    State[State["END_TAG_OPEN"] = 6] = "END_TAG_OPEN";
    State[State["TAG_NAME"] = 7] = "TAG_NAME";
    State[State["RCDATA_LESS_THAN_SIGN"] = 8] = "RCDATA_LESS_THAN_SIGN";
    State[State["RCDATA_END_TAG_OPEN"] = 9] = "RCDATA_END_TAG_OPEN";
    State[State["RCDATA_END_TAG_NAME"] = 10] = "RCDATA_END_TAG_NAME";
    State[State["RAWTEXT_LESS_THAN_SIGN"] = 11] = "RAWTEXT_LESS_THAN_SIGN";
    State[State["RAWTEXT_END_TAG_OPEN"] = 12] = "RAWTEXT_END_TAG_OPEN";
    State[State["RAWTEXT_END_TAG_NAME"] = 13] = "RAWTEXT_END_TAG_NAME";
    State[State["SCRIPT_DATA_LESS_THAN_SIGN"] = 14] = "SCRIPT_DATA_LESS_THAN_SIGN";
    State[State["SCRIPT_DATA_END_TAG_OPEN"] = 15] = "SCRIPT_DATA_END_TAG_OPEN";
    State[State["SCRIPT_DATA_END_TAG_NAME"] = 16] = "SCRIPT_DATA_END_TAG_NAME";
    State[State["SCRIPT_DATA_ESCAPE_START"] = 17] = "SCRIPT_DATA_ESCAPE_START";
    State[State["SCRIPT_DATA_ESCAPE_START_DASH"] = 18] = "SCRIPT_DATA_ESCAPE_START_DASH";
    State[State["SCRIPT_DATA_ESCAPED"] = 19] = "SCRIPT_DATA_ESCAPED";
    State[State["SCRIPT_DATA_ESCAPED_DASH"] = 20] = "SCRIPT_DATA_ESCAPED_DASH";
    State[State["SCRIPT_DATA_ESCAPED_DASH_DASH"] = 21] = "SCRIPT_DATA_ESCAPED_DASH_DASH";
    State[State["SCRIPT_DATA_ESCAPED_LESS_THAN_SIGN"] = 22] = "SCRIPT_DATA_ESCAPED_LESS_THAN_SIGN";
    State[State["SCRIPT_DATA_ESCAPED_END_TAG_OPEN"] = 23] = "SCRIPT_DATA_ESCAPED_END_TAG_OPEN";
    State[State["SCRIPT_DATA_ESCAPED_END_TAG_NAME"] = 24] = "SCRIPT_DATA_ESCAPED_END_TAG_NAME";
    State[State["SCRIPT_DATA_DOUBLE_ESCAPE_START"] = 25] = "SCRIPT_DATA_DOUBLE_ESCAPE_START";
    State[State["SCRIPT_DATA_DOUBLE_ESCAPED"] = 26] = "SCRIPT_DATA_DOUBLE_ESCAPED";
    State[State["SCRIPT_DATA_DOUBLE_ESCAPED_DASH"] = 27] = "SCRIPT_DATA_DOUBLE_ESCAPED_DASH";
    State[State["SCRIPT_DATA_DOUBLE_ESCAPED_DASH_DASH"] = 28] = "SCRIPT_DATA_DOUBLE_ESCAPED_DASH_DASH";
    State[State["SCRIPT_DATA_DOUBLE_ESCAPED_LESS_THAN_SIGN"] = 29] = "SCRIPT_DATA_DOUBLE_ESCAPED_LESS_THAN_SIGN";
    State[State["SCRIPT_DATA_DOUBLE_ESCAPE_END"] = 30] = "SCRIPT_DATA_DOUBLE_ESCAPE_END";
    State[State["BEFORE_ATTRIBUTE_NAME"] = 31] = "BEFORE_ATTRIBUTE_NAME";
    State[State["ATTRIBUTE_NAME"] = 32] = "ATTRIBUTE_NAME";
    State[State["AFTER_ATTRIBUTE_NAME"] = 33] = "AFTER_ATTRIBUTE_NAME";
    State[State["BEFORE_ATTRIBUTE_VALUE"] = 34] = "BEFORE_ATTRIBUTE_VALUE";
    State[State["ATTRIBUTE_VALUE_DOUBLE_QUOTED"] = 35] = "ATTRIBUTE_VALUE_DOUBLE_QUOTED";
    State[State["ATTRIBUTE_VALUE_SINGLE_QUOTED"] = 36] = "ATTRIBUTE_VALUE_SINGLE_QUOTED";
    State[State["ATTRIBUTE_VALUE_UNQUOTED"] = 37] = "ATTRIBUTE_VALUE_UNQUOTED";
    State[State["AFTER_ATTRIBUTE_VALUE_QUOTED"] = 38] = "AFTER_ATTRIBUTE_VALUE_QUOTED";
    State[State["SELF_CLOSING_START_TAG"] = 39] = "SELF_CLOSING_START_TAG";
    State[State["BOGUS_COMMENT"] = 40] = "BOGUS_COMMENT";
    State[State["MARKUP_DECLARATION_OPEN"] = 41] = "MARKUP_DECLARATION_OPEN";
    State[State["COMMENT_START"] = 42] = "COMMENT_START";
    State[State["COMMENT_START_DASH"] = 43] = "COMMENT_START_DASH";
    State[State["COMMENT"] = 44] = "COMMENT";
    State[State["COMMENT_LESS_THAN_SIGN"] = 45] = "COMMENT_LESS_THAN_SIGN";
    State[State["COMMENT_LESS_THAN_SIGN_BANG"] = 46] = "COMMENT_LESS_THAN_SIGN_BANG";
    State[State["COMMENT_LESS_THAN_SIGN_BANG_DASH"] = 47] = "COMMENT_LESS_THAN_SIGN_BANG_DASH";
    State[State["COMMENT_LESS_THAN_SIGN_BANG_DASH_DASH"] = 48] = "COMMENT_LESS_THAN_SIGN_BANG_DASH_DASH";
    State[State["COMMENT_END_DASH"] = 49] = "COMMENT_END_DASH";
    State[State["COMMENT_END"] = 50] = "COMMENT_END";
    State[State["COMMENT_END_BANG"] = 51] = "COMMENT_END_BANG";
    State[State["DOCTYPE"] = 52] = "DOCTYPE";
    State[State["BEFORE_DOCTYPE_NAME"] = 53] = "BEFORE_DOCTYPE_NAME";
    State[State["DOCTYPE_NAME"] = 54] = "DOCTYPE_NAME";
    State[State["AFTER_DOCTYPE_NAME"] = 55] = "AFTER_DOCTYPE_NAME";
    State[State["AFTER_DOCTYPE_PUBLIC_KEYWORD"] = 56] = "AFTER_DOCTYPE_PUBLIC_KEYWORD";
    State[State["BEFORE_DOCTYPE_PUBLIC_IDENTIFIER"] = 57] = "BEFORE_DOCTYPE_PUBLIC_IDENTIFIER";
    State[State["DOCTYPE_PUBLIC_IDENTIFIER_DOUBLE_QUOTED"] = 58] = "DOCTYPE_PUBLIC_IDENTIFIER_DOUBLE_QUOTED";
    State[State["DOCTYPE_PUBLIC_IDENTIFIER_SINGLE_QUOTED"] = 59] = "DOCTYPE_PUBLIC_IDENTIFIER_SINGLE_QUOTED";
    State[State["AFTER_DOCTYPE_PUBLIC_IDENTIFIER"] = 60] = "AFTER_DOCTYPE_PUBLIC_IDENTIFIER";
    State[State["BETWEEN_DOCTYPE_PUBLIC_AND_SYSTEM_IDENTIFIERS"] = 61] = "BETWEEN_DOCTYPE_PUBLIC_AND_SYSTEM_IDENTIFIERS";
    State[State["AFTER_DOCTYPE_SYSTEM_KEYWORD"] = 62] = "AFTER_DOCTYPE_SYSTEM_KEYWORD";
    State[State["BEFORE_DOCTYPE_SYSTEM_IDENTIFIER"] = 63] = "BEFORE_DOCTYPE_SYSTEM_IDENTIFIER";
    State[State["DOCTYPE_SYSTEM_IDENTIFIER_DOUBLE_QUOTED"] = 64] = "DOCTYPE_SYSTEM_IDENTIFIER_DOUBLE_QUOTED";
    State[State["DOCTYPE_SYSTEM_IDENTIFIER_SINGLE_QUOTED"] = 65] = "DOCTYPE_SYSTEM_IDENTIFIER_SINGLE_QUOTED";
    State[State["AFTER_DOCTYPE_SYSTEM_IDENTIFIER"] = 66] = "AFTER_DOCTYPE_SYSTEM_IDENTIFIER";
    State[State["BOGUS_DOCTYPE"] = 67] = "BOGUS_DOCTYPE";
    State[State["CDATA_SECTION"] = 68] = "CDATA_SECTION";
    State[State["CDATA_SECTION_BRACKET"] = 69] = "CDATA_SECTION_BRACKET";
    State[State["CDATA_SECTION_END"] = 70] = "CDATA_SECTION_END";
    State[State["CHARACTER_REFERENCE"] = 71] = "CHARACTER_REFERENCE";
    State[State["NAMED_CHARACTER_REFERENCE"] = 72] = "NAMED_CHARACTER_REFERENCE";
    State[State["AMBIGUOUS_AMPERSAND"] = 73] = "AMBIGUOUS_AMPERSAND";
    State[State["NUMERIC_CHARACTER_REFERENCE"] = 74] = "NUMERIC_CHARACTER_REFERENCE";
    State[State["HEXADEMICAL_CHARACTER_REFERENCE_START"] = 75] = "HEXADEMICAL_CHARACTER_REFERENCE_START";
    State[State["HEXADEMICAL_CHARACTER_REFERENCE"] = 76] = "HEXADEMICAL_CHARACTER_REFERENCE";
    State[State["DECIMAL_CHARACTER_REFERENCE"] = 77] = "DECIMAL_CHARACTER_REFERENCE";
    State[State["NUMERIC_CHARACTER_REFERENCE_END"] = 78] = "NUMERIC_CHARACTER_REFERENCE_END";
})(State$1 || (State$1 = {}));
//Tokenizer initial states for different modes
const TokenizerMode = {
    DATA: State$1.DATA,
    RCDATA: State$1.RCDATA,
    RAWTEXT: State$1.RAWTEXT,
    SCRIPT_DATA: State$1.SCRIPT_DATA,
    PLAINTEXT: State$1.PLAINTEXT,
    CDATA_SECTION: State$1.CDATA_SECTION,
};
//Utils
//OPTIMIZATION: these utility functions should not be moved out of this module. V8 Crankshaft will not inline
//this functions if they will be situated in another module due to context switch.
//Always perform inlining check before modifying this functions ('node --trace-inlining').
function isAsciiDigit(cp) {
    return cp >= CODE_POINTS.DIGIT_0 && cp <= CODE_POINTS.DIGIT_9;
}
function isAsciiUpper(cp) {
    return cp >= CODE_POINTS.LATIN_CAPITAL_A && cp <= CODE_POINTS.LATIN_CAPITAL_Z;
}
function isAsciiLower(cp) {
    return cp >= CODE_POINTS.LATIN_SMALL_A && cp <= CODE_POINTS.LATIN_SMALL_Z;
}
function isAsciiLetter(cp) {
    return isAsciiLower(cp) || isAsciiUpper(cp);
}
function isAsciiAlphaNumeric(cp) {
    return isAsciiLetter(cp) || isAsciiDigit(cp);
}
function isAsciiUpperHexDigit(cp) {
    return cp >= CODE_POINTS.LATIN_CAPITAL_A && cp <= CODE_POINTS.LATIN_CAPITAL_F;
}
function isAsciiLowerHexDigit(cp) {
    return cp >= CODE_POINTS.LATIN_SMALL_A && cp <= CODE_POINTS.LATIN_SMALL_F;
}
function isAsciiHexDigit(cp) {
    return isAsciiDigit(cp) || isAsciiUpperHexDigit(cp) || isAsciiLowerHexDigit(cp);
}
function toAsciiLower(cp) {
    return cp + 32;
}
function isWhitespace$1(cp) {
    return cp === CODE_POINTS.SPACE || cp === CODE_POINTS.LINE_FEED || cp === CODE_POINTS.TABULATION || cp === CODE_POINTS.FORM_FEED;
}
function isEntityInAttributeInvalidEnd(nextCp) {
    return nextCp === CODE_POINTS.EQUALS_SIGN || isAsciiAlphaNumeric(nextCp);
}
function isScriptDataDoubleEscapeSequenceEnd(cp) {
    return isWhitespace$1(cp) || cp === CODE_POINTS.SOLIDUS || cp === CODE_POINTS.GREATER_THAN_SIGN;
}
//Tokenizer
class Tokenizer$1 {
    constructor(options, handler) {
        this.options = options;
        this.handler = handler;
        this.paused = false;
        /** Ensures that the parsing loop isn't run multiple times at once. */
        this.inLoop = false;
        /**
         * Indicates that the current adjusted node exists, is not an element in the HTML namespace,
         * and that it is not an integration point for either MathML or HTML.
         *
         * @see {@link https://html.spec.whatwg.org/multipage/parsing.html#tree-construction}
         */
        this.inForeignNode = false;
        this.lastStartTagName = '';
        this.active = false;
        this.state = State$1.DATA;
        this.returnState = State$1.DATA;
        this.charRefCode = -1;
        this.consumedAfterSnapshot = -1;
        this.currentCharacterToken = null;
        this.currentToken = null;
        this.currentAttr = { name: '', value: '' };
        this.preprocessor = new Preprocessor(handler);
        this.currentLocation = this.getCurrentLocation(-1);
    }
    //Errors
    _err(code) {
        var _a, _b;
        (_b = (_a = this.handler).onParseError) === null || _b === void 0 ? void 0 : _b.call(_a, this.preprocessor.getError(code));
    }
    // NOTE: `offset` may never run across line boundaries.
    getCurrentLocation(offset) {
        if (!this.options.sourceCodeLocationInfo) {
            return null;
        }
        return {
            startLine: this.preprocessor.line,
            startCol: this.preprocessor.col - offset,
            startOffset: this.preprocessor.offset - offset,
            endLine: -1,
            endCol: -1,
            endOffset: -1,
        };
    }
    _runParsingLoop() {
        if (this.inLoop)
            return;
        this.inLoop = true;
        while (this.active && !this.paused) {
            this.consumedAfterSnapshot = 0;
            const cp = this._consume();
            if (!this._ensureHibernation()) {
                this._callState(cp);
            }
        }
        this.inLoop = false;
    }
    //API
    pause() {
        this.paused = true;
    }
    resume(writeCallback) {
        if (!this.paused) {
            throw new Error('Parser was already resumed');
        }
        this.paused = false;
        // Necessary for synchronous resume.
        if (this.inLoop)
            return;
        this._runParsingLoop();
        if (!this.paused) {
            writeCallback === null || writeCallback === void 0 ? void 0 : writeCallback();
        }
    }
    write(chunk, isLastChunk, writeCallback) {
        this.active = true;
        this.preprocessor.write(chunk, isLastChunk);
        this._runParsingLoop();
        if (!this.paused) {
            writeCallback === null || writeCallback === void 0 ? void 0 : writeCallback();
        }
    }
    insertHtmlAtCurrentPos(chunk) {
        this.active = true;
        this.preprocessor.insertHtmlAtCurrentPos(chunk);
        this._runParsingLoop();
    }
    //Hibernation
    _ensureHibernation() {
        if (this.preprocessor.endOfChunkHit) {
            this._unconsume(this.consumedAfterSnapshot);
            this.active = false;
            return true;
        }
        return false;
    }
    //Consumption
    _consume() {
        this.consumedAfterSnapshot++;
        return this.preprocessor.advance();
    }
    _unconsume(count) {
        this.consumedAfterSnapshot -= count;
        this.preprocessor.retreat(count);
    }
    _reconsumeInState(state, cp) {
        this.state = state;
        this._callState(cp);
    }
    _advanceBy(count) {
        this.consumedAfterSnapshot += count;
        for (let i = 0; i < count; i++) {
            this.preprocessor.advance();
        }
    }
    _consumeSequenceIfMatch(pattern, caseSensitive) {
        if (this.preprocessor.startsWith(pattern, caseSensitive)) {
            // We will already have consumed one character before calling this method.
            this._advanceBy(pattern.length - 1);
            return true;
        }
        return false;
    }
    //Token creation
    _createStartTagToken() {
        this.currentToken = {
            type: TokenType.START_TAG,
            tagName: '',
            tagID: TAG_ID.UNKNOWN,
            selfClosing: false,
            ackSelfClosing: false,
            attrs: [],
            location: this.getCurrentLocation(1),
        };
    }
    _createEndTagToken() {
        this.currentToken = {
            type: TokenType.END_TAG,
            tagName: '',
            tagID: TAG_ID.UNKNOWN,
            selfClosing: false,
            ackSelfClosing: false,
            attrs: [],
            location: this.getCurrentLocation(2),
        };
    }
    _createCommentToken(offset) {
        this.currentToken = {
            type: TokenType.COMMENT,
            data: '',
            location: this.getCurrentLocation(offset),
        };
    }
    _createDoctypeToken(initialName) {
        this.currentToken = {
            type: TokenType.DOCTYPE,
            name: initialName,
            forceQuirks: false,
            publicId: null,
            systemId: null,
            location: this.currentLocation,
        };
    }
    _createCharacterToken(type, chars) {
        this.currentCharacterToken = {
            type,
            chars,
            location: this.currentLocation,
        };
    }
    //Tag attributes
    _createAttr(attrNameFirstCh) {
        this.currentAttr = {
            name: attrNameFirstCh,
            value: '',
        };
        this.currentLocation = this.getCurrentLocation(0);
    }
    _leaveAttrName() {
        var _a;
        var _b;
        const token = this.currentToken;
        if (getTokenAttr(token, this.currentAttr.name) === null) {
            token.attrs.push(this.currentAttr);
            if (token.location && this.currentLocation) {
                const attrLocations = ((_a = (_b = token.location).attrs) !== null && _a !== void 0 ? _a : (_b.attrs = Object.create(null)));
                attrLocations[this.currentAttr.name] = this.currentLocation;
                // Set end location
                this._leaveAttrValue();
            }
        }
        else {
            this._err(ERR.duplicateAttribute);
        }
    }
    _leaveAttrValue() {
        if (this.currentLocation) {
            this.currentLocation.endLine = this.preprocessor.line;
            this.currentLocation.endCol = this.preprocessor.col;
            this.currentLocation.endOffset = this.preprocessor.offset;
        }
    }
    //Token emission
    prepareToken(ct) {
        this._emitCurrentCharacterToken(ct.location);
        this.currentToken = null;
        if (ct.location) {
            ct.location.endLine = this.preprocessor.line;
            ct.location.endCol = this.preprocessor.col + 1;
            ct.location.endOffset = this.preprocessor.offset + 1;
        }
        this.currentLocation = this.getCurrentLocation(-1);
    }
    emitCurrentTagToken() {
        const ct = this.currentToken;
        this.prepareToken(ct);
        ct.tagID = getTagID(ct.tagName);
        if (ct.type === TokenType.START_TAG) {
            this.lastStartTagName = ct.tagName;
            this.handler.onStartTag(ct);
        }
        else {
            if (ct.attrs.length > 0) {
                this._err(ERR.endTagWithAttributes);
            }
            if (ct.selfClosing) {
                this._err(ERR.endTagWithTrailingSolidus);
            }
            this.handler.onEndTag(ct);
        }
        this.preprocessor.dropParsedChunk();
    }
    emitCurrentComment(ct) {
        this.prepareToken(ct);
        this.handler.onComment(ct);
        this.preprocessor.dropParsedChunk();
    }
    emitCurrentDoctype(ct) {
        this.prepareToken(ct);
        this.handler.onDoctype(ct);
        this.preprocessor.dropParsedChunk();
    }
    _emitCurrentCharacterToken(nextLocation) {
        if (this.currentCharacterToken) {
            //NOTE: if we have a pending character token, make it's end location equal to the
            //current token's start location.
            if (nextLocation && this.currentCharacterToken.location) {
                this.currentCharacterToken.location.endLine = nextLocation.startLine;
                this.currentCharacterToken.location.endCol = nextLocation.startCol;
                this.currentCharacterToken.location.endOffset = nextLocation.startOffset;
            }
            switch (this.currentCharacterToken.type) {
                case TokenType.CHARACTER: {
                    this.handler.onCharacter(this.currentCharacterToken);
                    break;
                }
                case TokenType.NULL_CHARACTER: {
                    this.handler.onNullCharacter(this.currentCharacterToken);
                    break;
                }
                case TokenType.WHITESPACE_CHARACTER: {
                    this.handler.onWhitespaceCharacter(this.currentCharacterToken);
                    break;
                }
            }
            this.currentCharacterToken = null;
        }
    }
    _emitEOFToken() {
        const location = this.getCurrentLocation(0);
        if (location) {
            location.endLine = location.startLine;
            location.endCol = location.startCol;
            location.endOffset = location.startOffset;
        }
        this._emitCurrentCharacterToken(location);
        this.handler.onEof({ type: TokenType.EOF, location });
        this.active = false;
    }
    //Characters emission
    //OPTIMIZATION: specification uses only one type of character tokens (one token per character).
    //This causes a huge memory overhead and a lot of unnecessary parser loops. parse5 uses 3 groups of characters.
    //If we have a sequence of characters that belong to the same group, the parser can process it
    //as a single solid character token.
    //So, there are 3 types of character tokens in parse5:
    //1)TokenType.NULL_CHARACTER - \u0000-character sequences (e.g. '\u0000\u0000\u0000')
    //2)TokenType.WHITESPACE_CHARACTER - any whitespace/new-line character sequences (e.g. '\n  \r\t   \f')
    //3)TokenType.CHARACTER - any character sequence which don't belong to groups 1 and 2 (e.g. 'abcdef1234@@#$%^')
    _appendCharToCurrentCharacterToken(type, ch) {
        if (this.currentCharacterToken) {
            if (this.currentCharacterToken.type !== type) {
                this.currentLocation = this.getCurrentLocation(0);
                this._emitCurrentCharacterToken(this.currentLocation);
                this.preprocessor.dropParsedChunk();
            }
            else {
                this.currentCharacterToken.chars += ch;
                return;
            }
        }
        this._createCharacterToken(type, ch);
    }
    _emitCodePoint(cp) {
        const type = isWhitespace$1(cp)
            ? TokenType.WHITESPACE_CHARACTER
            : cp === CODE_POINTS.NULL
                ? TokenType.NULL_CHARACTER
                : TokenType.CHARACTER;
        this._appendCharToCurrentCharacterToken(type, String.fromCodePoint(cp));
    }
    //NOTE: used when we emit characters explicitly.
    //This is always for non-whitespace and non-null characters, which allows us to avoid additional checks.
    _emitChars(ch) {
        this._appendCharToCurrentCharacterToken(TokenType.CHARACTER, ch);
    }
    // Character reference helpers
    _matchNamedCharacterReference(cp) {
        let result = null;
        let excess = 0;
        let withoutSemicolon = false;
        for (let i = 0, current = htmlDecodeTree[0]; i >= 0; cp = this._consume()) {
            i = determineBranch(htmlDecodeTree, current, i + 1, cp);
            if (i < 0)
                break;
            excess += 1;
            current = htmlDecodeTree[i];
            const masked = current & BinTrieFlags.VALUE_LENGTH;
            // If the branch is a value, store it and continue
            if (masked) {
                // The mask is the number of bytes of the value, including the current byte.
                const valueLength = (masked >> 14) - 1;
                // Attribute values that aren't terminated properly aren't parsed, and shouldn't lead to a parser error.
                // See the example in https://html.spec.whatwg.org/multipage/parsing.html#named-character-reference-state
                if (cp !== CODE_POINTS.SEMICOLON &&
                    this._isCharacterReferenceInAttribute() &&
                    isEntityInAttributeInvalidEnd(this.preprocessor.peek(1))) {
                    //NOTE: we don't flush all consumed code points here, and instead switch back to the original state after
                    //emitting an ampersand. This is fine, as alphanumeric characters won't be parsed differently in attributes.
                    result = [CODE_POINTS.AMPERSAND];
                    // Skip over the value.
                    i += valueLength;
                }
                else {
                    // If this is a surrogate pair, consume the next two bytes.
                    result =
                        valueLength === 0
                            ? [htmlDecodeTree[i] & ~BinTrieFlags.VALUE_LENGTH]
                            : valueLength === 1
                                ? [htmlDecodeTree[++i]]
                                : [htmlDecodeTree[++i], htmlDecodeTree[++i]];
                    excess = 0;
                    withoutSemicolon = cp !== CODE_POINTS.SEMICOLON;
                }
                if (valueLength === 0) {
                    // If the value is zero-length, we're done.
                    this._consume();
                    break;
                }
            }
        }
        this._unconsume(excess);
        if (withoutSemicolon && !this.preprocessor.endOfChunkHit) {
            this._err(ERR.missingSemicolonAfterCharacterReference);
        }
        // We want to emit the error above on the code point after the entity.
        // We always consume one code point too many in the loop, and we wait to
        // unconsume it until after the error is emitted.
        this._unconsume(1);
        return result;
    }
    _isCharacterReferenceInAttribute() {
        return (this.returnState === State$1.ATTRIBUTE_VALUE_DOUBLE_QUOTED ||
            this.returnState === State$1.ATTRIBUTE_VALUE_SINGLE_QUOTED ||
            this.returnState === State$1.ATTRIBUTE_VALUE_UNQUOTED);
    }
    _flushCodePointConsumedAsCharacterReference(cp) {
        if (this._isCharacterReferenceInAttribute()) {
            this.currentAttr.value += String.fromCodePoint(cp);
        }
        else {
            this._emitCodePoint(cp);
        }
    }
    // Calling states this way turns out to be much faster than any other approach.
    _callState(cp) {
        switch (this.state) {
            case State$1.DATA: {
                this._stateData(cp);
                break;
            }
            case State$1.RCDATA: {
                this._stateRcdata(cp);
                break;
            }
            case State$1.RAWTEXT: {
                this._stateRawtext(cp);
                break;
            }
            case State$1.SCRIPT_DATA: {
                this._stateScriptData(cp);
                break;
            }
            case State$1.PLAINTEXT: {
                this._statePlaintext(cp);
                break;
            }
            case State$1.TAG_OPEN: {
                this._stateTagOpen(cp);
                break;
            }
            case State$1.END_TAG_OPEN: {
                this._stateEndTagOpen(cp);
                break;
            }
            case State$1.TAG_NAME: {
                this._stateTagName(cp);
                break;
            }
            case State$1.RCDATA_LESS_THAN_SIGN: {
                this._stateRcdataLessThanSign(cp);
                break;
            }
            case State$1.RCDATA_END_TAG_OPEN: {
                this._stateRcdataEndTagOpen(cp);
                break;
            }
            case State$1.RCDATA_END_TAG_NAME: {
                this._stateRcdataEndTagName(cp);
                break;
            }
            case State$1.RAWTEXT_LESS_THAN_SIGN: {
                this._stateRawtextLessThanSign(cp);
                break;
            }
            case State$1.RAWTEXT_END_TAG_OPEN: {
                this._stateRawtextEndTagOpen(cp);
                break;
            }
            case State$1.RAWTEXT_END_TAG_NAME: {
                this._stateRawtextEndTagName(cp);
                break;
            }
            case State$1.SCRIPT_DATA_LESS_THAN_SIGN: {
                this._stateScriptDataLessThanSign(cp);
                break;
            }
            case State$1.SCRIPT_DATA_END_TAG_OPEN: {
                this._stateScriptDataEndTagOpen(cp);
                break;
            }
            case State$1.SCRIPT_DATA_END_TAG_NAME: {
                this._stateScriptDataEndTagName(cp);
                break;
            }
            case State$1.SCRIPT_DATA_ESCAPE_START: {
                this._stateScriptDataEscapeStart(cp);
                break;
            }
            case State$1.SCRIPT_DATA_ESCAPE_START_DASH: {
                this._stateScriptDataEscapeStartDash(cp);
                break;
            }
            case State$1.SCRIPT_DATA_ESCAPED: {
                this._stateScriptDataEscaped(cp);
                break;
            }
            case State$1.SCRIPT_DATA_ESCAPED_DASH: {
                this._stateScriptDataEscapedDash(cp);
                break;
            }
            case State$1.SCRIPT_DATA_ESCAPED_DASH_DASH: {
                this._stateScriptDataEscapedDashDash(cp);
                break;
            }
            case State$1.SCRIPT_DATA_ESCAPED_LESS_THAN_SIGN: {
                this._stateScriptDataEscapedLessThanSign(cp);
                break;
            }
            case State$1.SCRIPT_DATA_ESCAPED_END_TAG_OPEN: {
                this._stateScriptDataEscapedEndTagOpen(cp);
                break;
            }
            case State$1.SCRIPT_DATA_ESCAPED_END_TAG_NAME: {
                this._stateScriptDataEscapedEndTagName(cp);
                break;
            }
            case State$1.SCRIPT_DATA_DOUBLE_ESCAPE_START: {
                this._stateScriptDataDoubleEscapeStart(cp);
                break;
            }
            case State$1.SCRIPT_DATA_DOUBLE_ESCAPED: {
                this._stateScriptDataDoubleEscaped(cp);
                break;
            }
            case State$1.SCRIPT_DATA_DOUBLE_ESCAPED_DASH: {
                this._stateScriptDataDoubleEscapedDash(cp);
                break;
            }
            case State$1.SCRIPT_DATA_DOUBLE_ESCAPED_DASH_DASH: {
                this._stateScriptDataDoubleEscapedDashDash(cp);
                break;
            }
            case State$1.SCRIPT_DATA_DOUBLE_ESCAPED_LESS_THAN_SIGN: {
                this._stateScriptDataDoubleEscapedLessThanSign(cp);
                break;
            }
            case State$1.SCRIPT_DATA_DOUBLE_ESCAPE_END: {
                this._stateScriptDataDoubleEscapeEnd(cp);
                break;
            }
            case State$1.BEFORE_ATTRIBUTE_NAME: {
                this._stateBeforeAttributeName(cp);
                break;
            }
            case State$1.ATTRIBUTE_NAME: {
                this._stateAttributeName(cp);
                break;
            }
            case State$1.AFTER_ATTRIBUTE_NAME: {
                this._stateAfterAttributeName(cp);
                break;
            }
            case State$1.BEFORE_ATTRIBUTE_VALUE: {
                this._stateBeforeAttributeValue(cp);
                break;
            }
            case State$1.ATTRIBUTE_VALUE_DOUBLE_QUOTED: {
                this._stateAttributeValueDoubleQuoted(cp);
                break;
            }
            case State$1.ATTRIBUTE_VALUE_SINGLE_QUOTED: {
                this._stateAttributeValueSingleQuoted(cp);
                break;
            }
            case State$1.ATTRIBUTE_VALUE_UNQUOTED: {
                this._stateAttributeValueUnquoted(cp);
                break;
            }
            case State$1.AFTER_ATTRIBUTE_VALUE_QUOTED: {
                this._stateAfterAttributeValueQuoted(cp);
                break;
            }
            case State$1.SELF_CLOSING_START_TAG: {
                this._stateSelfClosingStartTag(cp);
                break;
            }
            case State$1.BOGUS_COMMENT: {
                this._stateBogusComment(cp);
                break;
            }
            case State$1.MARKUP_DECLARATION_OPEN: {
                this._stateMarkupDeclarationOpen(cp);
                break;
            }
            case State$1.COMMENT_START: {
                this._stateCommentStart(cp);
                break;
            }
            case State$1.COMMENT_START_DASH: {
                this._stateCommentStartDash(cp);
                break;
            }
            case State$1.COMMENT: {
                this._stateComment(cp);
                break;
            }
            case State$1.COMMENT_LESS_THAN_SIGN: {
                this._stateCommentLessThanSign(cp);
                break;
            }
            case State$1.COMMENT_LESS_THAN_SIGN_BANG: {
                this._stateCommentLessThanSignBang(cp);
                break;
            }
            case State$1.COMMENT_LESS_THAN_SIGN_BANG_DASH: {
                this._stateCommentLessThanSignBangDash(cp);
                break;
            }
            case State$1.COMMENT_LESS_THAN_SIGN_BANG_DASH_DASH: {
                this._stateCommentLessThanSignBangDashDash(cp);
                break;
            }
            case State$1.COMMENT_END_DASH: {
                this._stateCommentEndDash(cp);
                break;
            }
            case State$1.COMMENT_END: {
                this._stateCommentEnd(cp);
                break;
            }
            case State$1.COMMENT_END_BANG: {
                this._stateCommentEndBang(cp);
                break;
            }
            case State$1.DOCTYPE: {
                this._stateDoctype(cp);
                break;
            }
            case State$1.BEFORE_DOCTYPE_NAME: {
                this._stateBeforeDoctypeName(cp);
                break;
            }
            case State$1.DOCTYPE_NAME: {
                this._stateDoctypeName(cp);
                break;
            }
            case State$1.AFTER_DOCTYPE_NAME: {
                this._stateAfterDoctypeName(cp);
                break;
            }
            case State$1.AFTER_DOCTYPE_PUBLIC_KEYWORD: {
                this._stateAfterDoctypePublicKeyword(cp);
                break;
            }
            case State$1.BEFORE_DOCTYPE_PUBLIC_IDENTIFIER: {
                this._stateBeforeDoctypePublicIdentifier(cp);
                break;
            }
            case State$1.DOCTYPE_PUBLIC_IDENTIFIER_DOUBLE_QUOTED: {
                this._stateDoctypePublicIdentifierDoubleQuoted(cp);
                break;
            }
            case State$1.DOCTYPE_PUBLIC_IDENTIFIER_SINGLE_QUOTED: {
                this._stateDoctypePublicIdentifierSingleQuoted(cp);
                break;
            }
            case State$1.AFTER_DOCTYPE_PUBLIC_IDENTIFIER: {
                this._stateAfterDoctypePublicIdentifier(cp);
                break;
            }
            case State$1.BETWEEN_DOCTYPE_PUBLIC_AND_SYSTEM_IDENTIFIERS: {
                this._stateBetweenDoctypePublicAndSystemIdentifiers(cp);
                break;
            }
            case State$1.AFTER_DOCTYPE_SYSTEM_KEYWORD: {
                this._stateAfterDoctypeSystemKeyword(cp);
                break;
            }
            case State$1.BEFORE_DOCTYPE_SYSTEM_IDENTIFIER: {
                this._stateBeforeDoctypeSystemIdentifier(cp);
                break;
            }
            case State$1.DOCTYPE_SYSTEM_IDENTIFIER_DOUBLE_QUOTED: {
                this._stateDoctypeSystemIdentifierDoubleQuoted(cp);
                break;
            }
            case State$1.DOCTYPE_SYSTEM_IDENTIFIER_SINGLE_QUOTED: {
                this._stateDoctypeSystemIdentifierSingleQuoted(cp);
                break;
            }
            case State$1.AFTER_DOCTYPE_SYSTEM_IDENTIFIER: {
                this._stateAfterDoctypeSystemIdentifier(cp);
                break;
            }
            case State$1.BOGUS_DOCTYPE: {
                this._stateBogusDoctype(cp);
                break;
            }
            case State$1.CDATA_SECTION: {
                this._stateCdataSection(cp);
                break;
            }
            case State$1.CDATA_SECTION_BRACKET: {
                this._stateCdataSectionBracket(cp);
                break;
            }
            case State$1.CDATA_SECTION_END: {
                this._stateCdataSectionEnd(cp);
                break;
            }
            case State$1.CHARACTER_REFERENCE: {
                this._stateCharacterReference(cp);
                break;
            }
            case State$1.NAMED_CHARACTER_REFERENCE: {
                this._stateNamedCharacterReference(cp);
                break;
            }
            case State$1.AMBIGUOUS_AMPERSAND: {
                this._stateAmbiguousAmpersand(cp);
                break;
            }
            case State$1.NUMERIC_CHARACTER_REFERENCE: {
                this._stateNumericCharacterReference(cp);
                break;
            }
            case State$1.HEXADEMICAL_CHARACTER_REFERENCE_START: {
                this._stateHexademicalCharacterReferenceStart(cp);
                break;
            }
            case State$1.HEXADEMICAL_CHARACTER_REFERENCE: {
                this._stateHexademicalCharacterReference(cp);
                break;
            }
            case State$1.DECIMAL_CHARACTER_REFERENCE: {
                this._stateDecimalCharacterReference(cp);
                break;
            }
            case State$1.NUMERIC_CHARACTER_REFERENCE_END: {
                this._stateNumericCharacterReferenceEnd(cp);
                break;
            }
            default: {
                throw new Error('Unknown state');
            }
        }
    }
    // State machine
    // Data state
    //------------------------------------------------------------------
    _stateData(cp) {
        switch (cp) {
            case CODE_POINTS.LESS_THAN_SIGN: {
                this.state = State$1.TAG_OPEN;
                break;
            }
            case CODE_POINTS.AMPERSAND: {
                this.returnState = State$1.DATA;
                this.state = State$1.CHARACTER_REFERENCE;
                break;
            }
            case CODE_POINTS.NULL: {
                this._err(ERR.unexpectedNullCharacter);
                this._emitCodePoint(cp);
                break;
            }
            case CODE_POINTS.EOF: {
                this._emitEOFToken();
                break;
            }
            default: {
                this._emitCodePoint(cp);
            }
        }
    }
    //  RCDATA state
    //------------------------------------------------------------------
    _stateRcdata(cp) {
        switch (cp) {
            case CODE_POINTS.AMPERSAND: {
                this.returnState = State$1.RCDATA;
                this.state = State$1.CHARACTER_REFERENCE;
                break;
            }
            case CODE_POINTS.LESS_THAN_SIGN: {
                this.state = State$1.RCDATA_LESS_THAN_SIGN;
                break;
            }
            case CODE_POINTS.NULL: {
                this._err(ERR.unexpectedNullCharacter);
                this._emitChars(REPLACEMENT_CHARACTER);
                break;
            }
            case CODE_POINTS.EOF: {
                this._emitEOFToken();
                break;
            }
            default: {
                this._emitCodePoint(cp);
            }
        }
    }
    // RAWTEXT state
    //------------------------------------------------------------------
    _stateRawtext(cp) {
        switch (cp) {
            case CODE_POINTS.LESS_THAN_SIGN: {
                this.state = State$1.RAWTEXT_LESS_THAN_SIGN;
                break;
            }
            case CODE_POINTS.NULL: {
                this._err(ERR.unexpectedNullCharacter);
                this._emitChars(REPLACEMENT_CHARACTER);
                break;
            }
            case CODE_POINTS.EOF: {
                this._emitEOFToken();
                break;
            }
            default: {
                this._emitCodePoint(cp);
            }
        }
    }
    // Script data state
    //------------------------------------------------------------------
    _stateScriptData(cp) {
        switch (cp) {
            case CODE_POINTS.LESS_THAN_SIGN: {
                this.state = State$1.SCRIPT_DATA_LESS_THAN_SIGN;
                break;
            }
            case CODE_POINTS.NULL: {
                this._err(ERR.unexpectedNullCharacter);
                this._emitChars(REPLACEMENT_CHARACTER);
                break;
            }
            case CODE_POINTS.EOF: {
                this._emitEOFToken();
                break;
            }
            default: {
                this._emitCodePoint(cp);
            }
        }
    }
    // PLAINTEXT state
    //------------------------------------------------------------------
    _statePlaintext(cp) {
        switch (cp) {
            case CODE_POINTS.NULL: {
                this._err(ERR.unexpectedNullCharacter);
                this._emitChars(REPLACEMENT_CHARACTER);
                break;
            }
            case CODE_POINTS.EOF: {
                this._emitEOFToken();
                break;
            }
            default: {
                this._emitCodePoint(cp);
            }
        }
    }
    // Tag open state
    //------------------------------------------------------------------
    _stateTagOpen(cp) {
        if (isAsciiLetter(cp)) {
            this._createStartTagToken();
            this.state = State$1.TAG_NAME;
            this._stateTagName(cp);
        }
        else
            switch (cp) {
                case CODE_POINTS.EXCLAMATION_MARK: {
                    this.state = State$1.MARKUP_DECLARATION_OPEN;
                    break;
                }
                case CODE_POINTS.SOLIDUS: {
                    this.state = State$1.END_TAG_OPEN;
                    break;
                }
                case CODE_POINTS.QUESTION_MARK: {
                    this._err(ERR.unexpectedQuestionMarkInsteadOfTagName);
                    this._createCommentToken(1);
                    this.state = State$1.BOGUS_COMMENT;
                    this._stateBogusComment(cp);
                    break;
                }
                case CODE_POINTS.EOF: {
                    this._err(ERR.eofBeforeTagName);
                    this._emitChars('<');
                    this._emitEOFToken();
                    break;
                }
                default: {
                    this._err(ERR.invalidFirstCharacterOfTagName);
                    this._emitChars('<');
                    this.state = State$1.DATA;
                    this._stateData(cp);
                }
            }
    }
    // End tag open state
    //------------------------------------------------------------------
    _stateEndTagOpen(cp) {
        if (isAsciiLetter(cp)) {
            this._createEndTagToken();
            this.state = State$1.TAG_NAME;
            this._stateTagName(cp);
        }
        else
            switch (cp) {
                case CODE_POINTS.GREATER_THAN_SIGN: {
                    this._err(ERR.missingEndTagName);
                    this.state = State$1.DATA;
                    break;
                }
                case CODE_POINTS.EOF: {
                    this._err(ERR.eofBeforeTagName);
                    this._emitChars('</');
                    this._emitEOFToken();
                    break;
                }
                default: {
                    this._err(ERR.invalidFirstCharacterOfTagName);
                    this._createCommentToken(2);
                    this.state = State$1.BOGUS_COMMENT;
                    this._stateBogusComment(cp);
                }
            }
    }
    // Tag name state
    //------------------------------------------------------------------
    _stateTagName(cp) {
        const token = this.currentToken;
        switch (cp) {
            case CODE_POINTS.SPACE:
            case CODE_POINTS.LINE_FEED:
            case CODE_POINTS.TABULATION:
            case CODE_POINTS.FORM_FEED: {
                this.state = State$1.BEFORE_ATTRIBUTE_NAME;
                break;
            }
            case CODE_POINTS.SOLIDUS: {
                this.state = State$1.SELF_CLOSING_START_TAG;
                break;
            }
            case CODE_POINTS.GREATER_THAN_SIGN: {
                this.state = State$1.DATA;
                this.emitCurrentTagToken();
                break;
            }
            case CODE_POINTS.NULL: {
                this._err(ERR.unexpectedNullCharacter);
                token.tagName += REPLACEMENT_CHARACTER;
                break;
            }
            case CODE_POINTS.EOF: {
                this._err(ERR.eofInTag);
                this._emitEOFToken();
                break;
            }
            default: {
                token.tagName += String.fromCodePoint(isAsciiUpper(cp) ? toAsciiLower(cp) : cp);
            }
        }
    }
    // RCDATA less-than sign state
    //------------------------------------------------------------------
    _stateRcdataLessThanSign(cp) {
        if (cp === CODE_POINTS.SOLIDUS) {
            this.state = State$1.RCDATA_END_TAG_OPEN;
        }
        else {
            this._emitChars('<');
            this.state = State$1.RCDATA;
            this._stateRcdata(cp);
        }
    }
    // RCDATA end tag open state
    //------------------------------------------------------------------
    _stateRcdataEndTagOpen(cp) {
        if (isAsciiLetter(cp)) {
            this.state = State$1.RCDATA_END_TAG_NAME;
            this._stateRcdataEndTagName(cp);
        }
        else {
            this._emitChars('</');
            this.state = State$1.RCDATA;
            this._stateRcdata(cp);
        }
    }
    handleSpecialEndTag(_cp) {
        if (!this.preprocessor.startsWith(this.lastStartTagName, false)) {
            return !this._ensureHibernation();
        }
        this._createEndTagToken();
        const token = this.currentToken;
        token.tagName = this.lastStartTagName;
        const cp = this.preprocessor.peek(this.lastStartTagName.length);
        switch (cp) {
            case CODE_POINTS.SPACE:
            case CODE_POINTS.LINE_FEED:
            case CODE_POINTS.TABULATION:
            case CODE_POINTS.FORM_FEED: {
                this._advanceBy(this.lastStartTagName.length);
                this.state = State$1.BEFORE_ATTRIBUTE_NAME;
                return false;
            }
            case CODE_POINTS.SOLIDUS: {
                this._advanceBy(this.lastStartTagName.length);
                this.state = State$1.SELF_CLOSING_START_TAG;
                return false;
            }
            case CODE_POINTS.GREATER_THAN_SIGN: {
                this._advanceBy(this.lastStartTagName.length);
                this.emitCurrentTagToken();
                this.state = State$1.DATA;
                return false;
            }
            default: {
                return !this._ensureHibernation();
            }
        }
    }
    // RCDATA end tag name state
    //------------------------------------------------------------------
    _stateRcdataEndTagName(cp) {
        if (this.handleSpecialEndTag(cp)) {
            this._emitChars('</');
            this.state = State$1.RCDATA;
            this._stateRcdata(cp);
        }
    }
    // RAWTEXT less-than sign state
    //------------------------------------------------------------------
    _stateRawtextLessThanSign(cp) {
        if (cp === CODE_POINTS.SOLIDUS) {
            this.state = State$1.RAWTEXT_END_TAG_OPEN;
        }
        else {
            this._emitChars('<');
            this.state = State$1.RAWTEXT;
            this._stateRawtext(cp);
        }
    }
    // RAWTEXT end tag open state
    //------------------------------------------------------------------
    _stateRawtextEndTagOpen(cp) {
        if (isAsciiLetter(cp)) {
            this.state = State$1.RAWTEXT_END_TAG_NAME;
            this._stateRawtextEndTagName(cp);
        }
        else {
            this._emitChars('</');
            this.state = State$1.RAWTEXT;
            this._stateRawtext(cp);
        }
    }
    // RAWTEXT end tag name state
    //------------------------------------------------------------------
    _stateRawtextEndTagName(cp) {
        if (this.handleSpecialEndTag(cp)) {
            this._emitChars('</');
            this.state = State$1.RAWTEXT;
            this._stateRawtext(cp);
        }
    }
    // Script data less-than sign state
    //------------------------------------------------------------------
    _stateScriptDataLessThanSign(cp) {
        switch (cp) {
            case CODE_POINTS.SOLIDUS: {
                this.state = State$1.SCRIPT_DATA_END_TAG_OPEN;
                break;
            }
            case CODE_POINTS.EXCLAMATION_MARK: {
                this.state = State$1.SCRIPT_DATA_ESCAPE_START;
                this._emitChars('<!');
                break;
            }
            default: {
                this._emitChars('<');
                this.state = State$1.SCRIPT_DATA;
                this._stateScriptData(cp);
            }
        }
    }
    // Script data end tag open state
    //------------------------------------------------------------------
    _stateScriptDataEndTagOpen(cp) {
        if (isAsciiLetter(cp)) {
            this.state = State$1.SCRIPT_DATA_END_TAG_NAME;
            this._stateScriptDataEndTagName(cp);
        }
        else {
            this._emitChars('</');
            this.state = State$1.SCRIPT_DATA;
            this._stateScriptData(cp);
        }
    }
    // Script data end tag name state
    //------------------------------------------------------------------
    _stateScriptDataEndTagName(cp) {
        if (this.handleSpecialEndTag(cp)) {
            this._emitChars('</');
            this.state = State$1.SCRIPT_DATA;
            this._stateScriptData(cp);
        }
    }
    // Script data escape start state
    //------------------------------------------------------------------
    _stateScriptDataEscapeStart(cp) {
        if (cp === CODE_POINTS.HYPHEN_MINUS) {
            this.state = State$1.SCRIPT_DATA_ESCAPE_START_DASH;
            this._emitChars('-');
        }
        else {
            this.state = State$1.SCRIPT_DATA;
            this._stateScriptData(cp);
        }
    }
    // Script data escape start dash state
    //------------------------------------------------------------------
    _stateScriptDataEscapeStartDash(cp) {
        if (cp === CODE_POINTS.HYPHEN_MINUS) {
            this.state = State$1.SCRIPT_DATA_ESCAPED_DASH_DASH;
            this._emitChars('-');
        }
        else {
            this.state = State$1.SCRIPT_DATA;
            this._stateScriptData(cp);
        }
    }
    // Script data escaped state
    //------------------------------------------------------------------
    _stateScriptDataEscaped(cp) {
        switch (cp) {
            case CODE_POINTS.HYPHEN_MINUS: {
                this.state = State$1.SCRIPT_DATA_ESCAPED_DASH;
                this._emitChars('-');
                break;
            }
            case CODE_POINTS.LESS_THAN_SIGN: {
                this.state = State$1.SCRIPT_DATA_ESCAPED_LESS_THAN_SIGN;
                break;
            }
            case CODE_POINTS.NULL: {
                this._err(ERR.unexpectedNullCharacter);
                this._emitChars(REPLACEMENT_CHARACTER);
                break;
            }
            case CODE_POINTS.EOF: {
                this._err(ERR.eofInScriptHtmlCommentLikeText);
                this._emitEOFToken();
                break;
            }
            default: {
                this._emitCodePoint(cp);
            }
        }
    }
    // Script data escaped dash state
    //------------------------------------------------------------------
    _stateScriptDataEscapedDash(cp) {
        switch (cp) {
            case CODE_POINTS.HYPHEN_MINUS: {
                this.state = State$1.SCRIPT_DATA_ESCAPED_DASH_DASH;
                this._emitChars('-');
                break;
            }
            case CODE_POINTS.LESS_THAN_SIGN: {
                this.state = State$1.SCRIPT_DATA_ESCAPED_LESS_THAN_SIGN;
                break;
            }
            case CODE_POINTS.NULL: {
                this._err(ERR.unexpectedNullCharacter);
                this.state = State$1.SCRIPT_DATA_ESCAPED;
                this._emitChars(REPLACEMENT_CHARACTER);
                break;
            }
            case CODE_POINTS.EOF: {
                this._err(ERR.eofInScriptHtmlCommentLikeText);
                this._emitEOFToken();
                break;
            }
            default: {
                this.state = State$1.SCRIPT_DATA_ESCAPED;
                this._emitCodePoint(cp);
            }
        }
    }
    // Script data escaped dash dash state
    //------------------------------------------------------------------
    _stateScriptDataEscapedDashDash(cp) {
        switch (cp) {
            case CODE_POINTS.HYPHEN_MINUS: {
                this._emitChars('-');
                break;
            }
            case CODE_POINTS.LESS_THAN_SIGN: {
                this.state = State$1.SCRIPT_DATA_ESCAPED_LESS_THAN_SIGN;
                break;
            }
            case CODE_POINTS.GREATER_THAN_SIGN: {
                this.state = State$1.SCRIPT_DATA;
                this._emitChars('>');
                break;
            }
            case CODE_POINTS.NULL: {
                this._err(ERR.unexpectedNullCharacter);
                this.state = State$1.SCRIPT_DATA_ESCAPED;
                this._emitChars(REPLACEMENT_CHARACTER);
                break;
            }
            case CODE_POINTS.EOF: {
                this._err(ERR.eofInScriptHtmlCommentLikeText);
                this._emitEOFToken();
                break;
            }
            default: {
                this.state = State$1.SCRIPT_DATA_ESCAPED;
                this._emitCodePoint(cp);
            }
        }
    }
    // Script data escaped less-than sign state
    //------------------------------------------------------------------
    _stateScriptDataEscapedLessThanSign(cp) {
        if (cp === CODE_POINTS.SOLIDUS) {
            this.state = State$1.SCRIPT_DATA_ESCAPED_END_TAG_OPEN;
        }
        else if (isAsciiLetter(cp)) {
            this._emitChars('<');
            this.state = State$1.SCRIPT_DATA_DOUBLE_ESCAPE_START;
            this._stateScriptDataDoubleEscapeStart(cp);
        }
        else {
            this._emitChars('<');
            this.state = State$1.SCRIPT_DATA_ESCAPED;
            this._stateScriptDataEscaped(cp);
        }
    }
    // Script data escaped end tag open state
    //------------------------------------------------------------------
    _stateScriptDataEscapedEndTagOpen(cp) {
        if (isAsciiLetter(cp)) {
            this.state = State$1.SCRIPT_DATA_ESCAPED_END_TAG_NAME;
            this._stateScriptDataEscapedEndTagName(cp);
        }
        else {
            this._emitChars('</');
            this.state = State$1.SCRIPT_DATA_ESCAPED;
            this._stateScriptDataEscaped(cp);
        }
    }
    // Script data escaped end tag name state
    //------------------------------------------------------------------
    _stateScriptDataEscapedEndTagName(cp) {
        if (this.handleSpecialEndTag(cp)) {
            this._emitChars('</');
            this.state = State$1.SCRIPT_DATA_ESCAPED;
            this._stateScriptDataEscaped(cp);
        }
    }
    // Script data double escape start state
    //------------------------------------------------------------------
    _stateScriptDataDoubleEscapeStart(cp) {
        if (this.preprocessor.startsWith(SEQUENCES.SCRIPT, false) &&
            isScriptDataDoubleEscapeSequenceEnd(this.preprocessor.peek(SEQUENCES.SCRIPT.length))) {
            this._emitCodePoint(cp);
            for (let i = 0; i < SEQUENCES.SCRIPT.length; i++) {
                this._emitCodePoint(this._consume());
            }
            this.state = State$1.SCRIPT_DATA_DOUBLE_ESCAPED;
        }
        else if (!this._ensureHibernation()) {
            this.state = State$1.SCRIPT_DATA_ESCAPED;
            this._stateScriptDataEscaped(cp);
        }
    }
    // Script data double escaped state
    //------------------------------------------------------------------
    _stateScriptDataDoubleEscaped(cp) {
        switch (cp) {
            case CODE_POINTS.HYPHEN_MINUS: {
                this.state = State$1.SCRIPT_DATA_DOUBLE_ESCAPED_DASH;
                this._emitChars('-');
                break;
            }
            case CODE_POINTS.LESS_THAN_SIGN: {
                this.state = State$1.SCRIPT_DATA_DOUBLE_ESCAPED_LESS_THAN_SIGN;
                this._emitChars('<');
                break;
            }
            case CODE_POINTS.NULL: {
                this._err(ERR.unexpectedNullCharacter);
                this._emitChars(REPLACEMENT_CHARACTER);
                break;
            }
            case CODE_POINTS.EOF: {
                this._err(ERR.eofInScriptHtmlCommentLikeText);
                this._emitEOFToken();
                break;
            }
            default: {
                this._emitCodePoint(cp);
            }
        }
    }
    // Script data double escaped dash state
    //------------------------------------------------------------------
    _stateScriptDataDoubleEscapedDash(cp) {
        switch (cp) {
            case CODE_POINTS.HYPHEN_MINUS: {
                this.state = State$1.SCRIPT_DATA_DOUBLE_ESCAPED_DASH_DASH;
                this._emitChars('-');
                break;
            }
            case CODE_POINTS.LESS_THAN_SIGN: {
                this.state = State$1.SCRIPT_DATA_DOUBLE_ESCAPED_LESS_THAN_SIGN;
                this._emitChars('<');
                break;
            }
            case CODE_POINTS.NULL: {
                this._err(ERR.unexpectedNullCharacter);
                this.state = State$1.SCRIPT_DATA_DOUBLE_ESCAPED;
                this._emitChars(REPLACEMENT_CHARACTER);
                break;
            }
            case CODE_POINTS.EOF: {
                this._err(ERR.eofInScriptHtmlCommentLikeText);
                this._emitEOFToken();
                break;
            }
            default: {
                this.state = State$1.SCRIPT_DATA_DOUBLE_ESCAPED;
                this._emitCodePoint(cp);
            }
        }
    }
    // Script data double escaped dash dash state
    //------------------------------------------------------------------
    _stateScriptDataDoubleEscapedDashDash(cp) {
        switch (cp) {
            case CODE_POINTS.HYPHEN_MINUS: {
                this._emitChars('-');
                break;
            }
            case CODE_POINTS.LESS_THAN_SIGN: {
                this.state = State$1.SCRIPT_DATA_DOUBLE_ESCAPED_LESS_THAN_SIGN;
                this._emitChars('<');
                break;
            }
            case CODE_POINTS.GREATER_THAN_SIGN: {
                this.state = State$1.SCRIPT_DATA;
                this._emitChars('>');
                break;
            }
            case CODE_POINTS.NULL: {
                this._err(ERR.unexpectedNullCharacter);
                this.state = State$1.SCRIPT_DATA_DOUBLE_ESCAPED;
                this._emitChars(REPLACEMENT_CHARACTER);
                break;
            }
            case CODE_POINTS.EOF: {
                this._err(ERR.eofInScriptHtmlCommentLikeText);
                this._emitEOFToken();
                break;
            }
            default: {
                this.state = State$1.SCRIPT_DATA_DOUBLE_ESCAPED;
                this._emitCodePoint(cp);
            }
        }
    }
    // Script data double escaped less-than sign state
    //------------------------------------------------------------------
    _stateScriptDataDoubleEscapedLessThanSign(cp) {
        if (cp === CODE_POINTS.SOLIDUS) {
            this.state = State$1.SCRIPT_DATA_DOUBLE_ESCAPE_END;
            this._emitChars('/');
        }
        else {
            this.state = State$1.SCRIPT_DATA_DOUBLE_ESCAPED;
            this._stateScriptDataDoubleEscaped(cp);
        }
    }
    // Script data double escape end state
    //------------------------------------------------------------------
    _stateScriptDataDoubleEscapeEnd(cp) {
        if (this.preprocessor.startsWith(SEQUENCES.SCRIPT, false) &&
            isScriptDataDoubleEscapeSequenceEnd(this.preprocessor.peek(SEQUENCES.SCRIPT.length))) {
            this._emitCodePoint(cp);
            for (let i = 0; i < SEQUENCES.SCRIPT.length; i++) {
                this._emitCodePoint(this._consume());
            }
            this.state = State$1.SCRIPT_DATA_ESCAPED;
        }
        else if (!this._ensureHibernation()) {
            this.state = State$1.SCRIPT_DATA_DOUBLE_ESCAPED;
            this._stateScriptDataDoubleEscaped(cp);
        }
    }
    // Before attribute name state
    //------------------------------------------------------------------
    _stateBeforeAttributeName(cp) {
        switch (cp) {
            case CODE_POINTS.SPACE:
            case CODE_POINTS.LINE_FEED:
            case CODE_POINTS.TABULATION:
            case CODE_POINTS.FORM_FEED: {
                // Ignore whitespace
                break;
            }
            case CODE_POINTS.SOLIDUS:
            case CODE_POINTS.GREATER_THAN_SIGN:
            case CODE_POINTS.EOF: {
                this.state = State$1.AFTER_ATTRIBUTE_NAME;
                this._stateAfterAttributeName(cp);
                break;
            }
            case CODE_POINTS.EQUALS_SIGN: {
                this._err(ERR.unexpectedEqualsSignBeforeAttributeName);
                this._createAttr('=');
                this.state = State$1.ATTRIBUTE_NAME;
                break;
            }
            default: {
                this._createAttr('');
                this.state = State$1.ATTRIBUTE_NAME;
                this._stateAttributeName(cp);
            }
        }
    }
    // Attribute name state
    //------------------------------------------------------------------
    _stateAttributeName(cp) {
        switch (cp) {
            case CODE_POINTS.SPACE:
            case CODE_POINTS.LINE_FEED:
            case CODE_POINTS.TABULATION:
            case CODE_POINTS.FORM_FEED:
            case CODE_POINTS.SOLIDUS:
            case CODE_POINTS.GREATER_THAN_SIGN:
            case CODE_POINTS.EOF: {
                this._leaveAttrName();
                this.state = State$1.AFTER_ATTRIBUTE_NAME;
                this._stateAfterAttributeName(cp);
                break;
            }
            case CODE_POINTS.EQUALS_SIGN: {
                this._leaveAttrName();
                this.state = State$1.BEFORE_ATTRIBUTE_VALUE;
                break;
            }
            case CODE_POINTS.QUOTATION_MARK:
            case CODE_POINTS.APOSTROPHE:
            case CODE_POINTS.LESS_THAN_SIGN: {
                this._err(ERR.unexpectedCharacterInAttributeName);
                this.currentAttr.name += String.fromCodePoint(cp);
                break;
            }
            case CODE_POINTS.NULL: {
                this._err(ERR.unexpectedNullCharacter);
                this.currentAttr.name += REPLACEMENT_CHARACTER;
                break;
            }
            default: {
                this.currentAttr.name += String.fromCodePoint(isAsciiUpper(cp) ? toAsciiLower(cp) : cp);
            }
        }
    }
    // After attribute name state
    //------------------------------------------------------------------
    _stateAfterAttributeName(cp) {
        switch (cp) {
            case CODE_POINTS.SPACE:
            case CODE_POINTS.LINE_FEED:
            case CODE_POINTS.TABULATION:
            case CODE_POINTS.FORM_FEED: {
                // Ignore whitespace
                break;
            }
            case CODE_POINTS.SOLIDUS: {
                this.state = State$1.SELF_CLOSING_START_TAG;
                break;
            }
            case CODE_POINTS.EQUALS_SIGN: {
                this.state = State$1.BEFORE_ATTRIBUTE_VALUE;
                break;
            }
            case CODE_POINTS.GREATER_THAN_SIGN: {
                this.state = State$1.DATA;
                this.emitCurrentTagToken();
                break;
            }
            case CODE_POINTS.EOF: {
                this._err(ERR.eofInTag);
                this._emitEOFToken();
                break;
            }
            default: {
                this._createAttr('');
                this.state = State$1.ATTRIBUTE_NAME;
                this._stateAttributeName(cp);
            }
        }
    }
    // Before attribute value state
    //------------------------------------------------------------------
    _stateBeforeAttributeValue(cp) {
        switch (cp) {
            case CODE_POINTS.SPACE:
            case CODE_POINTS.LINE_FEED:
            case CODE_POINTS.TABULATION:
            case CODE_POINTS.FORM_FEED: {
                // Ignore whitespace
                break;
            }
            case CODE_POINTS.QUOTATION_MARK: {
                this.state = State$1.ATTRIBUTE_VALUE_DOUBLE_QUOTED;
                break;
            }
            case CODE_POINTS.APOSTROPHE: {
                this.state = State$1.ATTRIBUTE_VALUE_SINGLE_QUOTED;
                break;
            }
            case CODE_POINTS.GREATER_THAN_SIGN: {
                this._err(ERR.missingAttributeValue);
                this.state = State$1.DATA;
                this.emitCurrentTagToken();
                break;
            }
            default: {
                this.state = State$1.ATTRIBUTE_VALUE_UNQUOTED;
                this._stateAttributeValueUnquoted(cp);
            }
        }
    }
    // Attribute value (double-quoted) state
    //------------------------------------------------------------------
    _stateAttributeValueDoubleQuoted(cp) {
        switch (cp) {
            case CODE_POINTS.QUOTATION_MARK: {
                this.state = State$1.AFTER_ATTRIBUTE_VALUE_QUOTED;
                break;
            }
            case CODE_POINTS.AMPERSAND: {
                this.returnState = State$1.ATTRIBUTE_VALUE_DOUBLE_QUOTED;
                this.state = State$1.CHARACTER_REFERENCE;
                break;
            }
            case CODE_POINTS.NULL: {
                this._err(ERR.unexpectedNullCharacter);
                this.currentAttr.value += REPLACEMENT_CHARACTER;
                break;
            }
            case CODE_POINTS.EOF: {
                this._err(ERR.eofInTag);
                this._emitEOFToken();
                break;
            }
            default: {
                this.currentAttr.value += String.fromCodePoint(cp);
            }
        }
    }
    // Attribute value (single-quoted) state
    //------------------------------------------------------------------
    _stateAttributeValueSingleQuoted(cp) {
        switch (cp) {
            case CODE_POINTS.APOSTROPHE: {
                this.state = State$1.AFTER_ATTRIBUTE_VALUE_QUOTED;
                break;
            }
            case CODE_POINTS.AMPERSAND: {
                this.returnState = State$1.ATTRIBUTE_VALUE_SINGLE_QUOTED;
                this.state = State$1.CHARACTER_REFERENCE;
                break;
            }
            case CODE_POINTS.NULL: {
                this._err(ERR.unexpectedNullCharacter);
                this.currentAttr.value += REPLACEMENT_CHARACTER;
                break;
            }
            case CODE_POINTS.EOF: {
                this._err(ERR.eofInTag);
                this._emitEOFToken();
                break;
            }
            default: {
                this.currentAttr.value += String.fromCodePoint(cp);
            }
        }
    }
    // Attribute value (unquoted) state
    //------------------------------------------------------------------
    _stateAttributeValueUnquoted(cp) {
        switch (cp) {
            case CODE_POINTS.SPACE:
            case CODE_POINTS.LINE_FEED:
            case CODE_POINTS.TABULATION:
            case CODE_POINTS.FORM_FEED: {
                this._leaveAttrValue();
                this.state = State$1.BEFORE_ATTRIBUTE_NAME;
                break;
            }
            case CODE_POINTS.AMPERSAND: {
                this.returnState = State$1.ATTRIBUTE_VALUE_UNQUOTED;
                this.state = State$1.CHARACTER_REFERENCE;
                break;
            }
            case CODE_POINTS.GREATER_THAN_SIGN: {
                this._leaveAttrValue();
                this.state = State$1.DATA;
                this.emitCurrentTagToken();
                break;
            }
            case CODE_POINTS.NULL: {
                this._err(ERR.unexpectedNullCharacter);
                this.currentAttr.value += REPLACEMENT_CHARACTER;
                break;
            }
            case CODE_POINTS.QUOTATION_MARK:
            case CODE_POINTS.APOSTROPHE:
            case CODE_POINTS.LESS_THAN_SIGN:
            case CODE_POINTS.EQUALS_SIGN:
            case CODE_POINTS.GRAVE_ACCENT: {
                this._err(ERR.unexpectedCharacterInUnquotedAttributeValue);
                this.currentAttr.value += String.fromCodePoint(cp);
                break;
            }
            case CODE_POINTS.EOF: {
                this._err(ERR.eofInTag);
                this._emitEOFToken();
                break;
            }
            default: {
                this.currentAttr.value += String.fromCodePoint(cp);
            }
        }
    }
    // After attribute value (quoted) state
    //------------------------------------------------------------------
    _stateAfterAttributeValueQuoted(cp) {
        switch (cp) {
            case CODE_POINTS.SPACE:
            case CODE_POINTS.LINE_FEED:
            case CODE_POINTS.TABULATION:
            case CODE_POINTS.FORM_FEED: {
                this._leaveAttrValue();
                this.state = State$1.BEFORE_ATTRIBUTE_NAME;
                break;
            }
            case CODE_POINTS.SOLIDUS: {
                this._leaveAttrValue();
                this.state = State$1.SELF_CLOSING_START_TAG;
                break;
            }
            case CODE_POINTS.GREATER_THAN_SIGN: {
                this._leaveAttrValue();
                this.state = State$1.DATA;
                this.emitCurrentTagToken();
                break;
            }
            case CODE_POINTS.EOF: {
                this._err(ERR.eofInTag);
                this._emitEOFToken();
                break;
            }
            default: {
                this._err(ERR.missingWhitespaceBetweenAttributes);
                this.state = State$1.BEFORE_ATTRIBUTE_NAME;
                this._stateBeforeAttributeName(cp);
            }
        }
    }
    // Self-closing start tag state
    //------------------------------------------------------------------
    _stateSelfClosingStartTag(cp) {
        switch (cp) {
            case CODE_POINTS.GREATER_THAN_SIGN: {
                const token = this.currentToken;
                token.selfClosing = true;
                this.state = State$1.DATA;
                this.emitCurrentTagToken();
                break;
            }
            case CODE_POINTS.EOF: {
                this._err(ERR.eofInTag);
                this._emitEOFToken();
                break;
            }
            default: {
                this._err(ERR.unexpectedSolidusInTag);
                this.state = State$1.BEFORE_ATTRIBUTE_NAME;
                this._stateBeforeAttributeName(cp);
            }
        }
    }
    // Bogus comment state
    //------------------------------------------------------------------
    _stateBogusComment(cp) {
        const token = this.currentToken;
        switch (cp) {
            case CODE_POINTS.GREATER_THAN_SIGN: {
                this.state = State$1.DATA;
                this.emitCurrentComment(token);
                break;
            }
            case CODE_POINTS.EOF: {
                this.emitCurrentComment(token);
                this._emitEOFToken();
                break;
            }
            case CODE_POINTS.NULL: {
                this._err(ERR.unexpectedNullCharacter);
                token.data += REPLACEMENT_CHARACTER;
                break;
            }
            default: {
                token.data += String.fromCodePoint(cp);
            }
        }
    }
    // Markup declaration open state
    //------------------------------------------------------------------
    _stateMarkupDeclarationOpen(cp) {
        if (this._consumeSequenceIfMatch(SEQUENCES.DASH_DASH, true)) {
            this._createCommentToken(SEQUENCES.DASH_DASH.length + 1);
            this.state = State$1.COMMENT_START;
        }
        else if (this._consumeSequenceIfMatch(SEQUENCES.DOCTYPE, false)) {
            // NOTE: Doctypes tokens are created without fixed offsets. We keep track of the moment a doctype *might* start here.
            this.currentLocation = this.getCurrentLocation(SEQUENCES.DOCTYPE.length + 1);
            this.state = State$1.DOCTYPE;
        }
        else if (this._consumeSequenceIfMatch(SEQUENCES.CDATA_START, true)) {
            if (this.inForeignNode) {
                this.state = State$1.CDATA_SECTION;
            }
            else {
                this._err(ERR.cdataInHtmlContent);
                this._createCommentToken(SEQUENCES.CDATA_START.length + 1);
                this.currentToken.data = '[CDATA[';
                this.state = State$1.BOGUS_COMMENT;
            }
        }
        //NOTE: Sequence lookups can be abrupted by hibernation. In that case, lookup
        //results are no longer valid and we will need to start over.
        else if (!this._ensureHibernation()) {
            this._err(ERR.incorrectlyOpenedComment);
            this._createCommentToken(2);
            this.state = State$1.BOGUS_COMMENT;
            this._stateBogusComment(cp);
        }
    }
    // Comment start state
    //------------------------------------------------------------------
    _stateCommentStart(cp) {
        switch (cp) {
            case CODE_POINTS.HYPHEN_MINUS: {
                this.state = State$1.COMMENT_START_DASH;
                break;
            }
            case CODE_POINTS.GREATER_THAN_SIGN: {
                this._err(ERR.abruptClosingOfEmptyComment);
                this.state = State$1.DATA;
                const token = this.currentToken;
                this.emitCurrentComment(token);
                break;
            }
            default: {
                this.state = State$1.COMMENT;
                this._stateComment(cp);
            }
        }
    }
    // Comment start dash state
    //------------------------------------------------------------------
    _stateCommentStartDash(cp) {
        const token = this.currentToken;
        switch (cp) {
            case CODE_POINTS.HYPHEN_MINUS: {
                this.state = State$1.COMMENT_END;
                break;
            }
            case CODE_POINTS.GREATER_THAN_SIGN: {
                this._err(ERR.abruptClosingOfEmptyComment);
                this.state = State$1.DATA;
                this.emitCurrentComment(token);
                break;
            }
            case CODE_POINTS.EOF: {
                this._err(ERR.eofInComment);
                this.emitCurrentComment(token);
                this._emitEOFToken();
                break;
            }
            default: {
                token.data += '-';
                this.state = State$1.COMMENT;
                this._stateComment(cp);
            }
        }
    }
    // Comment state
    //------------------------------------------------------------------
    _stateComment(cp) {
        const token = this.currentToken;
        switch (cp) {
            case CODE_POINTS.HYPHEN_MINUS: {
                this.state = State$1.COMMENT_END_DASH;
                break;
            }
            case CODE_POINTS.LESS_THAN_SIGN: {
                token.data += '<';
                this.state = State$1.COMMENT_LESS_THAN_SIGN;
                break;
            }
            case CODE_POINTS.NULL: {
                this._err(ERR.unexpectedNullCharacter);
                token.data += REPLACEMENT_CHARACTER;
                break;
            }
            case CODE_POINTS.EOF: {
                this._err(ERR.eofInComment);
                this.emitCurrentComment(token);
                this._emitEOFToken();
                break;
            }
            default: {
                token.data += String.fromCodePoint(cp);
            }
        }
    }
    // Comment less-than sign state
    //------------------------------------------------------------------
    _stateCommentLessThanSign(cp) {
        const token = this.currentToken;
        switch (cp) {
            case CODE_POINTS.EXCLAMATION_MARK: {
                token.data += '!';
                this.state = State$1.COMMENT_LESS_THAN_SIGN_BANG;
                break;
            }
            case CODE_POINTS.LESS_THAN_SIGN: {
                token.data += '<';
                break;
            }
            default: {
                this.state = State$1.COMMENT;
                this._stateComment(cp);
            }
        }
    }
    // Comment less-than sign bang state
    //------------------------------------------------------------------
    _stateCommentLessThanSignBang(cp) {
        if (cp === CODE_POINTS.HYPHEN_MINUS) {
            this.state = State$1.COMMENT_LESS_THAN_SIGN_BANG_DASH;
        }
        else {
            this.state = State$1.COMMENT;
            this._stateComment(cp);
        }
    }
    // Comment less-than sign bang dash state
    //------------------------------------------------------------------
    _stateCommentLessThanSignBangDash(cp) {
        if (cp === CODE_POINTS.HYPHEN_MINUS) {
            this.state = State$1.COMMENT_LESS_THAN_SIGN_BANG_DASH_DASH;
        }
        else {
            this.state = State$1.COMMENT_END_DASH;
            this._stateCommentEndDash(cp);
        }
    }
    // Comment less-than sign bang dash dash state
    //------------------------------------------------------------------
    _stateCommentLessThanSignBangDashDash(cp) {
        if (cp !== CODE_POINTS.GREATER_THAN_SIGN && cp !== CODE_POINTS.EOF) {
            this._err(ERR.nestedComment);
        }
        this.state = State$1.COMMENT_END;
        this._stateCommentEnd(cp);
    }
    // Comment end dash state
    //------------------------------------------------------------------
    _stateCommentEndDash(cp) {
        const token = this.currentToken;
        switch (cp) {
            case CODE_POINTS.HYPHEN_MINUS: {
                this.state = State$1.COMMENT_END;
                break;
            }
            case CODE_POINTS.EOF: {
                this._err(ERR.eofInComment);
                this.emitCurrentComment(token);
                this._emitEOFToken();
                break;
            }
            default: {
                token.data += '-';
                this.state = State$1.COMMENT;
                this._stateComment(cp);
            }
        }
    }
    // Comment end state
    //------------------------------------------------------------------
    _stateCommentEnd(cp) {
        const token = this.currentToken;
        switch (cp) {
            case CODE_POINTS.GREATER_THAN_SIGN: {
                this.state = State$1.DATA;
                this.emitCurrentComment(token);
                break;
            }
            case CODE_POINTS.EXCLAMATION_MARK: {
                this.state = State$1.COMMENT_END_BANG;
                break;
            }
            case CODE_POINTS.HYPHEN_MINUS: {
                token.data += '-';
                break;
            }
            case CODE_POINTS.EOF: {
                this._err(ERR.eofInComment);
                this.emitCurrentComment(token);
                this._emitEOFToken();
                break;
            }
            default: {
                token.data += '--';
                this.state = State$1.COMMENT;
                this._stateComment(cp);
            }
        }
    }
    // Comment end bang state
    //------------------------------------------------------------------
    _stateCommentEndBang(cp) {
        const token = this.currentToken;
        switch (cp) {
            case CODE_POINTS.HYPHEN_MINUS: {
                token.data += '--!';
                this.state = State$1.COMMENT_END_DASH;
                break;
            }
            case CODE_POINTS.GREATER_THAN_SIGN: {
                this._err(ERR.incorrectlyClosedComment);
                this.state = State$1.DATA;
                this.emitCurrentComment(token);
                break;
            }
            case CODE_POINTS.EOF: {
                this._err(ERR.eofInComment);
                this.emitCurrentComment(token);
                this._emitEOFToken();
                break;
            }
            default: {
                token.data += '--!';
                this.state = State$1.COMMENT;
                this._stateComment(cp);
            }
        }
    }
    // DOCTYPE state
    //------------------------------------------------------------------
    _stateDoctype(cp) {
        switch (cp) {
            case CODE_POINTS.SPACE:
            case CODE_POINTS.LINE_FEED:
            case CODE_POINTS.TABULATION:
            case CODE_POINTS.FORM_FEED: {
                this.state = State$1.BEFORE_DOCTYPE_NAME;
                break;
            }
            case CODE_POINTS.GREATER_THAN_SIGN: {
                this.state = State$1.BEFORE_DOCTYPE_NAME;
                this._stateBeforeDoctypeName(cp);
                break;
            }
            case CODE_POINTS.EOF: {
                this._err(ERR.eofInDoctype);
                this._createDoctypeToken(null);
                const token = this.currentToken;
                token.forceQuirks = true;
                this.emitCurrentDoctype(token);
                this._emitEOFToken();
                break;
            }
            default: {
                this._err(ERR.missingWhitespaceBeforeDoctypeName);
                this.state = State$1.BEFORE_DOCTYPE_NAME;
                this._stateBeforeDoctypeName(cp);
            }
        }
    }
    // Before DOCTYPE name state
    //------------------------------------------------------------------
    _stateBeforeDoctypeName(cp) {
        if (isAsciiUpper(cp)) {
            this._createDoctypeToken(String.fromCharCode(toAsciiLower(cp)));
            this.state = State$1.DOCTYPE_NAME;
        }
        else
            switch (cp) {
                case CODE_POINTS.SPACE:
                case CODE_POINTS.LINE_FEED:
                case CODE_POINTS.TABULATION:
                case CODE_POINTS.FORM_FEED: {
                    // Ignore whitespace
                    break;
                }
                case CODE_POINTS.NULL: {
                    this._err(ERR.unexpectedNullCharacter);
                    this._createDoctypeToken(REPLACEMENT_CHARACTER);
                    this.state = State$1.DOCTYPE_NAME;
                    break;
                }
                case CODE_POINTS.GREATER_THAN_SIGN: {
                    this._err(ERR.missingDoctypeName);
                    this._createDoctypeToken(null);
                    const token = this.currentToken;
                    token.forceQuirks = true;
                    this.emitCurrentDoctype(token);
                    this.state = State$1.DATA;
                    break;
                }
                case CODE_POINTS.EOF: {
                    this._err(ERR.eofInDoctype);
                    this._createDoctypeToken(null);
                    const token = this.currentToken;
                    token.forceQuirks = true;
                    this.emitCurrentDoctype(token);
                    this._emitEOFToken();
                    break;
                }
                default: {
                    this._createDoctypeToken(String.fromCodePoint(cp));
                    this.state = State$1.DOCTYPE_NAME;
                }
            }
    }
    // DOCTYPE name state
    //------------------------------------------------------------------
    _stateDoctypeName(cp) {
        const token = this.currentToken;
        switch (cp) {
            case CODE_POINTS.SPACE:
            case CODE_POINTS.LINE_FEED:
            case CODE_POINTS.TABULATION:
            case CODE_POINTS.FORM_FEED: {
                this.state = State$1.AFTER_DOCTYPE_NAME;
                break;
            }
            case CODE_POINTS.GREATER_THAN_SIGN: {
                this.state = State$1.DATA;
                this.emitCurrentDoctype(token);
                break;
            }
            case CODE_POINTS.NULL: {
                this._err(ERR.unexpectedNullCharacter);
                token.name += REPLACEMENT_CHARACTER;
                break;
            }
            case CODE_POINTS.EOF: {
                this._err(ERR.eofInDoctype);
                token.forceQuirks = true;
                this.emitCurrentDoctype(token);
                this._emitEOFToken();
                break;
            }
            default: {
                token.name += String.fromCodePoint(isAsciiUpper(cp) ? toAsciiLower(cp) : cp);
            }
        }
    }
    // After DOCTYPE name state
    //------------------------------------------------------------------
    _stateAfterDoctypeName(cp) {
        const token = this.currentToken;
        switch (cp) {
            case CODE_POINTS.SPACE:
            case CODE_POINTS.LINE_FEED:
            case CODE_POINTS.TABULATION:
            case CODE_POINTS.FORM_FEED: {
                // Ignore whitespace
                break;
            }
            case CODE_POINTS.GREATER_THAN_SIGN: {
                this.state = State$1.DATA;
                this.emitCurrentDoctype(token);
                break;
            }
            case CODE_POINTS.EOF: {
                this._err(ERR.eofInDoctype);
                token.forceQuirks = true;
                this.emitCurrentDoctype(token);
                this._emitEOFToken();
                break;
            }
            default: {
                if (this._consumeSequenceIfMatch(SEQUENCES.PUBLIC, false)) {
                    this.state = State$1.AFTER_DOCTYPE_PUBLIC_KEYWORD;
                }
                else if (this._consumeSequenceIfMatch(SEQUENCES.SYSTEM, false)) {
                    this.state = State$1.AFTER_DOCTYPE_SYSTEM_KEYWORD;
                }
                //NOTE: sequence lookup can be abrupted by hibernation. In that case lookup
                //results are no longer valid and we will need to start over.
                else if (!this._ensureHibernation()) {
                    this._err(ERR.invalidCharacterSequenceAfterDoctypeName);
                    token.forceQuirks = true;
                    this.state = State$1.BOGUS_DOCTYPE;
                    this._stateBogusDoctype(cp);
                }
            }
        }
    }
    // After DOCTYPE public keyword state
    //------------------------------------------------------------------
    _stateAfterDoctypePublicKeyword(cp) {
        const token = this.currentToken;
        switch (cp) {
            case CODE_POINTS.SPACE:
            case CODE_POINTS.LINE_FEED:
            case CODE_POINTS.TABULATION:
            case CODE_POINTS.FORM_FEED: {
                this.state = State$1.BEFORE_DOCTYPE_PUBLIC_IDENTIFIER;
                break;
            }
            case CODE_POINTS.QUOTATION_MARK: {
                this._err(ERR.missingWhitespaceAfterDoctypePublicKeyword);
                token.publicId = '';
                this.state = State$1.DOCTYPE_PUBLIC_IDENTIFIER_DOUBLE_QUOTED;
                break;
            }
            case CODE_POINTS.APOSTROPHE: {
                this._err(ERR.missingWhitespaceAfterDoctypePublicKeyword);
                token.publicId = '';
                this.state = State$1.DOCTYPE_PUBLIC_IDENTIFIER_SINGLE_QUOTED;
                break;
            }
            case CODE_POINTS.GREATER_THAN_SIGN: {
                this._err(ERR.missingDoctypePublicIdentifier);
                token.forceQuirks = true;
                this.state = State$1.DATA;
                this.emitCurrentDoctype(token);
                break;
            }
            case CODE_POINTS.EOF: {
                this._err(ERR.eofInDoctype);
                token.forceQuirks = true;
                this.emitCurrentDoctype(token);
                this._emitEOFToken();
                break;
            }
            default: {
                this._err(ERR.missingQuoteBeforeDoctypePublicIdentifier);
                token.forceQuirks = true;
                this.state = State$1.BOGUS_DOCTYPE;
                this._stateBogusDoctype(cp);
            }
        }
    }
    // Before DOCTYPE public identifier state
    //------------------------------------------------------------------
    _stateBeforeDoctypePublicIdentifier(cp) {
        const token = this.currentToken;
        switch (cp) {
            case CODE_POINTS.SPACE:
            case CODE_POINTS.LINE_FEED:
            case CODE_POINTS.TABULATION:
            case CODE_POINTS.FORM_FEED: {
                // Ignore whitespace
                break;
            }
            case CODE_POINTS.QUOTATION_MARK: {
                token.publicId = '';
                this.state = State$1.DOCTYPE_PUBLIC_IDENTIFIER_DOUBLE_QUOTED;
                break;
            }
            case CODE_POINTS.APOSTROPHE: {
                token.publicId = '';
                this.state = State$1.DOCTYPE_PUBLIC_IDENTIFIER_SINGLE_QUOTED;
                break;
            }
            case CODE_POINTS.GREATER_THAN_SIGN: {
                this._err(ERR.missingDoctypePublicIdentifier);
                token.forceQuirks = true;
                this.state = State$1.DATA;
                this.emitCurrentDoctype(token);
                break;
            }
            case CODE_POINTS.EOF: {
                this._err(ERR.eofInDoctype);
                token.forceQuirks = true;
                this.emitCurrentDoctype(token);
                this._emitEOFToken();
                break;
            }
            default: {
                this._err(ERR.missingQuoteBeforeDoctypePublicIdentifier);
                token.forceQuirks = true;
                this.state = State$1.BOGUS_DOCTYPE;
                this._stateBogusDoctype(cp);
            }
        }
    }
    // DOCTYPE public identifier (double-quoted) state
    //------------------------------------------------------------------
    _stateDoctypePublicIdentifierDoubleQuoted(cp) {
        const token = this.currentToken;
        switch (cp) {
            case CODE_POINTS.QUOTATION_MARK: {
                this.state = State$1.AFTER_DOCTYPE_PUBLIC_IDENTIFIER;
                break;
            }
            case CODE_POINTS.NULL: {
                this._err(ERR.unexpectedNullCharacter);
                token.publicId += REPLACEMENT_CHARACTER;
                break;
            }
            case CODE_POINTS.GREATER_THAN_SIGN: {
                this._err(ERR.abruptDoctypePublicIdentifier);
                token.forceQuirks = true;
                this.emitCurrentDoctype(token);
                this.state = State$1.DATA;
                break;
            }
            case CODE_POINTS.EOF: {
                this._err(ERR.eofInDoctype);
                token.forceQuirks = true;
                this.emitCurrentDoctype(token);
                this._emitEOFToken();
                break;
            }
            default: {
                token.publicId += String.fromCodePoint(cp);
            }
        }
    }
    // DOCTYPE public identifier (single-quoted) state
    //------------------------------------------------------------------
    _stateDoctypePublicIdentifierSingleQuoted(cp) {
        const token = this.currentToken;
        switch (cp) {
            case CODE_POINTS.APOSTROPHE: {
                this.state = State$1.AFTER_DOCTYPE_PUBLIC_IDENTIFIER;
                break;
            }
            case CODE_POINTS.NULL: {
                this._err(ERR.unexpectedNullCharacter);
                token.publicId += REPLACEMENT_CHARACTER;
                break;
            }
            case CODE_POINTS.GREATER_THAN_SIGN: {
                this._err(ERR.abruptDoctypePublicIdentifier);
                token.forceQuirks = true;
                this.emitCurrentDoctype(token);
                this.state = State$1.DATA;
                break;
            }
            case CODE_POINTS.EOF: {
                this._err(ERR.eofInDoctype);
                token.forceQuirks = true;
                this.emitCurrentDoctype(token);
                this._emitEOFToken();
                break;
            }
            default: {
                token.publicId += String.fromCodePoint(cp);
            }
        }
    }
    // After DOCTYPE public identifier state
    //------------------------------------------------------------------
    _stateAfterDoctypePublicIdentifier(cp) {
        const token = this.currentToken;
        switch (cp) {
            case CODE_POINTS.SPACE:
            case CODE_POINTS.LINE_FEED:
            case CODE_POINTS.TABULATION:
            case CODE_POINTS.FORM_FEED: {
                this.state = State$1.BETWEEN_DOCTYPE_PUBLIC_AND_SYSTEM_IDENTIFIERS;
                break;
            }
            case CODE_POINTS.GREATER_THAN_SIGN: {
                this.state = State$1.DATA;
                this.emitCurrentDoctype(token);
                break;
            }
            case CODE_POINTS.QUOTATION_MARK: {
                this._err(ERR.missingWhitespaceBetweenDoctypePublicAndSystemIdentifiers);
                token.systemId = '';
                this.state = State$1.DOCTYPE_SYSTEM_IDENTIFIER_DOUBLE_QUOTED;
                break;
            }
            case CODE_POINTS.APOSTROPHE: {
                this._err(ERR.missingWhitespaceBetweenDoctypePublicAndSystemIdentifiers);
                token.systemId = '';
                this.state = State$1.DOCTYPE_SYSTEM_IDENTIFIER_SINGLE_QUOTED;
                break;
            }
            case CODE_POINTS.EOF: {
                this._err(ERR.eofInDoctype);
                token.forceQuirks = true;
                this.emitCurrentDoctype(token);
                this._emitEOFToken();
                break;
            }
            default: {
                this._err(ERR.missingQuoteBeforeDoctypeSystemIdentifier);
                token.forceQuirks = true;
                this.state = State$1.BOGUS_DOCTYPE;
                this._stateBogusDoctype(cp);
            }
        }
    }
    // Between DOCTYPE public and system identifiers state
    //------------------------------------------------------------------
    _stateBetweenDoctypePublicAndSystemIdentifiers(cp) {
        const token = this.currentToken;
        switch (cp) {
            case CODE_POINTS.SPACE:
            case CODE_POINTS.LINE_FEED:
            case CODE_POINTS.TABULATION:
            case CODE_POINTS.FORM_FEED: {
                // Ignore whitespace
                break;
            }
            case CODE_POINTS.GREATER_THAN_SIGN: {
                this.emitCurrentDoctype(token);
                this.state = State$1.DATA;
                break;
            }
            case CODE_POINTS.QUOTATION_MARK: {
                token.systemId = '';
                this.state = State$1.DOCTYPE_SYSTEM_IDENTIFIER_DOUBLE_QUOTED;
                break;
            }
            case CODE_POINTS.APOSTROPHE: {
                token.systemId = '';
                this.state = State$1.DOCTYPE_SYSTEM_IDENTIFIER_SINGLE_QUOTED;
                break;
            }
            case CODE_POINTS.EOF: {
                this._err(ERR.eofInDoctype);
                token.forceQuirks = true;
                this.emitCurrentDoctype(token);
                this._emitEOFToken();
                break;
            }
            default: {
                this._err(ERR.missingQuoteBeforeDoctypeSystemIdentifier);
                token.forceQuirks = true;
                this.state = State$1.BOGUS_DOCTYPE;
                this._stateBogusDoctype(cp);
            }
        }
    }
    // After DOCTYPE system keyword state
    //------------------------------------------------------------------
    _stateAfterDoctypeSystemKeyword(cp) {
        const token = this.currentToken;
        switch (cp) {
            case CODE_POINTS.SPACE:
            case CODE_POINTS.LINE_FEED:
            case CODE_POINTS.TABULATION:
            case CODE_POINTS.FORM_FEED: {
                this.state = State$1.BEFORE_DOCTYPE_SYSTEM_IDENTIFIER;
                break;
            }
            case CODE_POINTS.QUOTATION_MARK: {
                this._err(ERR.missingWhitespaceAfterDoctypeSystemKeyword);
                token.systemId = '';
                this.state = State$1.DOCTYPE_SYSTEM_IDENTIFIER_DOUBLE_QUOTED;
                break;
            }
            case CODE_POINTS.APOSTROPHE: {
                this._err(ERR.missingWhitespaceAfterDoctypeSystemKeyword);
                token.systemId = '';
                this.state = State$1.DOCTYPE_SYSTEM_IDENTIFIER_SINGLE_QUOTED;
                break;
            }
            case CODE_POINTS.GREATER_THAN_SIGN: {
                this._err(ERR.missingDoctypeSystemIdentifier);
                token.forceQuirks = true;
                this.state = State$1.DATA;
                this.emitCurrentDoctype(token);
                break;
            }
            case CODE_POINTS.EOF: {
                this._err(ERR.eofInDoctype);
                token.forceQuirks = true;
                this.emitCurrentDoctype(token);
                this._emitEOFToken();
                break;
            }
            default: {
                this._err(ERR.missingQuoteBeforeDoctypeSystemIdentifier);
                token.forceQuirks = true;
                this.state = State$1.BOGUS_DOCTYPE;
                this._stateBogusDoctype(cp);
            }
        }
    }
    // Before DOCTYPE system identifier state
    //------------------------------------------------------------------
    _stateBeforeDoctypeSystemIdentifier(cp) {
        const token = this.currentToken;
        switch (cp) {
            case CODE_POINTS.SPACE:
            case CODE_POINTS.LINE_FEED:
            case CODE_POINTS.TABULATION:
            case CODE_POINTS.FORM_FEED: {
                // Ignore whitespace
                break;
            }
            case CODE_POINTS.QUOTATION_MARK: {
                token.systemId = '';
                this.state = State$1.DOCTYPE_SYSTEM_IDENTIFIER_DOUBLE_QUOTED;
                break;
            }
            case CODE_POINTS.APOSTROPHE: {
                token.systemId = '';
                this.state = State$1.DOCTYPE_SYSTEM_IDENTIFIER_SINGLE_QUOTED;
                break;
            }
            case CODE_POINTS.GREATER_THAN_SIGN: {
                this._err(ERR.missingDoctypeSystemIdentifier);
                token.forceQuirks = true;
                this.state = State$1.DATA;
                this.emitCurrentDoctype(token);
                break;
            }
            case CODE_POINTS.EOF: {
                this._err(ERR.eofInDoctype);
                token.forceQuirks = true;
                this.emitCurrentDoctype(token);
                this._emitEOFToken();
                break;
            }
            default: {
                this._err(ERR.missingQuoteBeforeDoctypeSystemIdentifier);
                token.forceQuirks = true;
                this.state = State$1.BOGUS_DOCTYPE;
                this._stateBogusDoctype(cp);
            }
        }
    }
    // DOCTYPE system identifier (double-quoted) state
    //------------------------------------------------------------------
    _stateDoctypeSystemIdentifierDoubleQuoted(cp) {
        const token = this.currentToken;
        switch (cp) {
            case CODE_POINTS.QUOTATION_MARK: {
                this.state = State$1.AFTER_DOCTYPE_SYSTEM_IDENTIFIER;
                break;
            }
            case CODE_POINTS.NULL: {
                this._err(ERR.unexpectedNullCharacter);
                token.systemId += REPLACEMENT_CHARACTER;
                break;
            }
            case CODE_POINTS.GREATER_THAN_SIGN: {
                this._err(ERR.abruptDoctypeSystemIdentifier);
                token.forceQuirks = true;
                this.emitCurrentDoctype(token);
                this.state = State$1.DATA;
                break;
            }
            case CODE_POINTS.EOF: {
                this._err(ERR.eofInDoctype);
                token.forceQuirks = true;
                this.emitCurrentDoctype(token);
                this._emitEOFToken();
                break;
            }
            default: {
                token.systemId += String.fromCodePoint(cp);
            }
        }
    }
    // DOCTYPE system identifier (single-quoted) state
    //------------------------------------------------------------------
    _stateDoctypeSystemIdentifierSingleQuoted(cp) {
        const token = this.currentToken;
        switch (cp) {
            case CODE_POINTS.APOSTROPHE: {
                this.state = State$1.AFTER_DOCTYPE_SYSTEM_IDENTIFIER;
                break;
            }
            case CODE_POINTS.NULL: {
                this._err(ERR.unexpectedNullCharacter);
                token.systemId += REPLACEMENT_CHARACTER;
                break;
            }
            case CODE_POINTS.GREATER_THAN_SIGN: {
                this._err(ERR.abruptDoctypeSystemIdentifier);
                token.forceQuirks = true;
                this.emitCurrentDoctype(token);
                this.state = State$1.DATA;
                break;
            }
            case CODE_POINTS.EOF: {
                this._err(ERR.eofInDoctype);
                token.forceQuirks = true;
                this.emitCurrentDoctype(token);
                this._emitEOFToken();
                break;
            }
            default: {
                token.systemId += String.fromCodePoint(cp);
            }
        }
    }
    // After DOCTYPE system identifier state
    //------------------------------------------------------------------
    _stateAfterDoctypeSystemIdentifier(cp) {
        const token = this.currentToken;
        switch (cp) {
            case CODE_POINTS.SPACE:
            case CODE_POINTS.LINE_FEED:
            case CODE_POINTS.TABULATION:
            case CODE_POINTS.FORM_FEED: {
                // Ignore whitespace
                break;
            }
            case CODE_POINTS.GREATER_THAN_SIGN: {
                this.emitCurrentDoctype(token);
                this.state = State$1.DATA;
                break;
            }
            case CODE_POINTS.EOF: {
                this._err(ERR.eofInDoctype);
                token.forceQuirks = true;
                this.emitCurrentDoctype(token);
                this._emitEOFToken();
                break;
            }
            default: {
                this._err(ERR.unexpectedCharacterAfterDoctypeSystemIdentifier);
                this.state = State$1.BOGUS_DOCTYPE;
                this._stateBogusDoctype(cp);
            }
        }
    }
    // Bogus DOCTYPE state
    //------------------------------------------------------------------
    _stateBogusDoctype(cp) {
        const token = this.currentToken;
        switch (cp) {
            case CODE_POINTS.GREATER_THAN_SIGN: {
                this.emitCurrentDoctype(token);
                this.state = State$1.DATA;
                break;
            }
            case CODE_POINTS.NULL: {
                this._err(ERR.unexpectedNullCharacter);
                break;
            }
            case CODE_POINTS.EOF: {
                this.emitCurrentDoctype(token);
                this._emitEOFToken();
                break;
            }
            // Do nothing
        }
    }
    // CDATA section state
    //------------------------------------------------------------------
    _stateCdataSection(cp) {
        switch (cp) {
            case CODE_POINTS.RIGHT_SQUARE_BRACKET: {
                this.state = State$1.CDATA_SECTION_BRACKET;
                break;
            }
            case CODE_POINTS.EOF: {
                this._err(ERR.eofInCdata);
                this._emitEOFToken();
                break;
            }
            default: {
                this._emitCodePoint(cp);
            }
        }
    }
    // CDATA section bracket state
    //------------------------------------------------------------------
    _stateCdataSectionBracket(cp) {
        if (cp === CODE_POINTS.RIGHT_SQUARE_BRACKET) {
            this.state = State$1.CDATA_SECTION_END;
        }
        else {
            this._emitChars(']');
            this.state = State$1.CDATA_SECTION;
            this._stateCdataSection(cp);
        }
    }
    // CDATA section end state
    //------------------------------------------------------------------
    _stateCdataSectionEnd(cp) {
        switch (cp) {
            case CODE_POINTS.GREATER_THAN_SIGN: {
                this.state = State$1.DATA;
                break;
            }
            case CODE_POINTS.RIGHT_SQUARE_BRACKET: {
                this._emitChars(']');
                break;
            }
            default: {
                this._emitChars(']]');
                this.state = State$1.CDATA_SECTION;
                this._stateCdataSection(cp);
            }
        }
    }
    // Character reference state
    //------------------------------------------------------------------
    _stateCharacterReference(cp) {
        if (cp === CODE_POINTS.NUMBER_SIGN) {
            this.state = State$1.NUMERIC_CHARACTER_REFERENCE;
        }
        else if (isAsciiAlphaNumeric(cp)) {
            this.state = State$1.NAMED_CHARACTER_REFERENCE;
            this._stateNamedCharacterReference(cp);
        }
        else {
            this._flushCodePointConsumedAsCharacterReference(CODE_POINTS.AMPERSAND);
            this._reconsumeInState(this.returnState, cp);
        }
    }
    // Named character reference state
    //------------------------------------------------------------------
    _stateNamedCharacterReference(cp) {
        const matchResult = this._matchNamedCharacterReference(cp);
        //NOTE: Matching can be abrupted by hibernation. In that case, match
        //results are no longer valid and we will need to start over.
        if (this._ensureHibernation()) ;
        else if (matchResult) {
            for (let i = 0; i < matchResult.length; i++) {
                this._flushCodePointConsumedAsCharacterReference(matchResult[i]);
            }
            this.state = this.returnState;
        }
        else {
            this._flushCodePointConsumedAsCharacterReference(CODE_POINTS.AMPERSAND);
            this.state = State$1.AMBIGUOUS_AMPERSAND;
        }
    }
    // Ambiguos ampersand state
    //------------------------------------------------------------------
    _stateAmbiguousAmpersand(cp) {
        if (isAsciiAlphaNumeric(cp)) {
            this._flushCodePointConsumedAsCharacterReference(cp);
        }
        else {
            if (cp === CODE_POINTS.SEMICOLON) {
                this._err(ERR.unknownNamedCharacterReference);
            }
            this._reconsumeInState(this.returnState, cp);
        }
    }
    // Numeric character reference state
    //------------------------------------------------------------------
    _stateNumericCharacterReference(cp) {
        this.charRefCode = 0;
        if (cp === CODE_POINTS.LATIN_SMALL_X || cp === CODE_POINTS.LATIN_CAPITAL_X) {
            this.state = State$1.HEXADEMICAL_CHARACTER_REFERENCE_START;
        }
        // Inlined decimal character reference start state
        else if (isAsciiDigit(cp)) {
            this.state = State$1.DECIMAL_CHARACTER_REFERENCE;
            this._stateDecimalCharacterReference(cp);
        }
        else {
            this._err(ERR.absenceOfDigitsInNumericCharacterReference);
            this._flushCodePointConsumedAsCharacterReference(CODE_POINTS.AMPERSAND);
            this._flushCodePointConsumedAsCharacterReference(CODE_POINTS.NUMBER_SIGN);
            this._reconsumeInState(this.returnState, cp);
        }
    }
    // Hexademical character reference start state
    //------------------------------------------------------------------
    _stateHexademicalCharacterReferenceStart(cp) {
        if (isAsciiHexDigit(cp)) {
            this.state = State$1.HEXADEMICAL_CHARACTER_REFERENCE;
            this._stateHexademicalCharacterReference(cp);
        }
        else {
            this._err(ERR.absenceOfDigitsInNumericCharacterReference);
            this._flushCodePointConsumedAsCharacterReference(CODE_POINTS.AMPERSAND);
            this._flushCodePointConsumedAsCharacterReference(CODE_POINTS.NUMBER_SIGN);
            this._unconsume(2);
            this.state = this.returnState;
        }
    }
    // Hexademical character reference state
    //------------------------------------------------------------------
    _stateHexademicalCharacterReference(cp) {
        if (isAsciiUpperHexDigit(cp)) {
            this.charRefCode = this.charRefCode * 16 + cp - 0x37;
        }
        else if (isAsciiLowerHexDigit(cp)) {
            this.charRefCode = this.charRefCode * 16 + cp - 0x57;
        }
        else if (isAsciiDigit(cp)) {
            this.charRefCode = this.charRefCode * 16 + cp - 0x30;
        }
        else if (cp === CODE_POINTS.SEMICOLON) {
            this.state = State$1.NUMERIC_CHARACTER_REFERENCE_END;
        }
        else {
            this._err(ERR.missingSemicolonAfterCharacterReference);
            this.state = State$1.NUMERIC_CHARACTER_REFERENCE_END;
            this._stateNumericCharacterReferenceEnd(cp);
        }
    }
    // Decimal character reference state
    //------------------------------------------------------------------
    _stateDecimalCharacterReference(cp) {
        if (isAsciiDigit(cp)) {
            this.charRefCode = this.charRefCode * 10 + cp - 0x30;
        }
        else if (cp === CODE_POINTS.SEMICOLON) {
            this.state = State$1.NUMERIC_CHARACTER_REFERENCE_END;
        }
        else {
            this._err(ERR.missingSemicolonAfterCharacterReference);
            this.state = State$1.NUMERIC_CHARACTER_REFERENCE_END;
            this._stateNumericCharacterReferenceEnd(cp);
        }
    }
    // Numeric character reference end state
    //------------------------------------------------------------------
    _stateNumericCharacterReferenceEnd(cp) {
        if (this.charRefCode === CODE_POINTS.NULL) {
            this._err(ERR.nullCharacterReference);
            this.charRefCode = CODE_POINTS.REPLACEMENT_CHARACTER;
        }
        else if (this.charRefCode > 1114111) {
            this._err(ERR.characterReferenceOutsideUnicodeRange);
            this.charRefCode = CODE_POINTS.REPLACEMENT_CHARACTER;
        }
        else if (isSurrogate(this.charRefCode)) {
            this._err(ERR.surrogateCharacterReference);
            this.charRefCode = CODE_POINTS.REPLACEMENT_CHARACTER;
        }
        else if (isUndefinedCodePoint(this.charRefCode)) {
            this._err(ERR.noncharacterCharacterReference);
        }
        else if (isControlCodePoint(this.charRefCode) || this.charRefCode === CODE_POINTS.CARRIAGE_RETURN) {
            this._err(ERR.controlCharacterReference);
            const replacement = C1_CONTROLS_REFERENCE_REPLACEMENTS.get(this.charRefCode);
            if (replacement !== undefined) {
                this.charRefCode = replacement;
            }
        }
        this._flushCodePointConsumedAsCharacterReference(this.charRefCode);
        this._reconsumeInState(this.returnState, cp);
    }
}

//Element utils
const IMPLICIT_END_TAG_REQUIRED = new Set([TAG_ID.DD, TAG_ID.DT, TAG_ID.LI, TAG_ID.OPTGROUP, TAG_ID.OPTION, TAG_ID.P, TAG_ID.RB, TAG_ID.RP, TAG_ID.RT, TAG_ID.RTC]);
const IMPLICIT_END_TAG_REQUIRED_THOROUGHLY = new Set([
    ...IMPLICIT_END_TAG_REQUIRED,
    TAG_ID.CAPTION,
    TAG_ID.COLGROUP,
    TAG_ID.TBODY,
    TAG_ID.TD,
    TAG_ID.TFOOT,
    TAG_ID.TH,
    TAG_ID.THEAD,
    TAG_ID.TR,
]);
const SCOPING_ELEMENT_NS = new Map([
    [TAG_ID.APPLET, NS.HTML],
    [TAG_ID.CAPTION, NS.HTML],
    [TAG_ID.HTML, NS.HTML],
    [TAG_ID.MARQUEE, NS.HTML],
    [TAG_ID.OBJECT, NS.HTML],
    [TAG_ID.TABLE, NS.HTML],
    [TAG_ID.TD, NS.HTML],
    [TAG_ID.TEMPLATE, NS.HTML],
    [TAG_ID.TH, NS.HTML],
    [TAG_ID.ANNOTATION_XML, NS.MATHML],
    [TAG_ID.MI, NS.MATHML],
    [TAG_ID.MN, NS.MATHML],
    [TAG_ID.MO, NS.MATHML],
    [TAG_ID.MS, NS.MATHML],
    [TAG_ID.MTEXT, NS.MATHML],
    [TAG_ID.DESC, NS.SVG],
    [TAG_ID.FOREIGN_OBJECT, NS.SVG],
    [TAG_ID.TITLE, NS.SVG],
]);
const NAMED_HEADERS = [TAG_ID.H1, TAG_ID.H2, TAG_ID.H3, TAG_ID.H4, TAG_ID.H5, TAG_ID.H6];
const TABLE_ROW_CONTEXT = [TAG_ID.TR, TAG_ID.TEMPLATE, TAG_ID.HTML];
const TABLE_BODY_CONTEXT = [TAG_ID.TBODY, TAG_ID.TFOOT, TAG_ID.THEAD, TAG_ID.TEMPLATE, TAG_ID.HTML];
const TABLE_CONTEXT = [TAG_ID.TABLE, TAG_ID.TEMPLATE, TAG_ID.HTML];
const TABLE_CELLS = [TAG_ID.TD, TAG_ID.TH];
//Stack of open elements
class OpenElementStack {
    get currentTmplContentOrNode() {
        return this._isInTemplate() ? this.treeAdapter.getTemplateContent(this.current) : this.current;
    }
    constructor(document, treeAdapter, handler) {
        this.treeAdapter = treeAdapter;
        this.handler = handler;
        this.items = [];
        this.tagIDs = [];
        this.stackTop = -1;
        this.tmplCount = 0;
        this.currentTagId = TAG_ID.UNKNOWN;
        this.current = document;
    }
    //Index of element
    _indexOf(element) {
        return this.items.lastIndexOf(element, this.stackTop);
    }
    //Update current element
    _isInTemplate() {
        return this.currentTagId === TAG_ID.TEMPLATE && this.treeAdapter.getNamespaceURI(this.current) === NS.HTML;
    }
    _updateCurrentElement() {
        this.current = this.items[this.stackTop];
        this.currentTagId = this.tagIDs[this.stackTop];
    }
    //Mutations
    push(element, tagID) {
        this.stackTop++;
        this.items[this.stackTop] = element;
        this.current = element;
        this.tagIDs[this.stackTop] = tagID;
        this.currentTagId = tagID;
        if (this._isInTemplate()) {
            this.tmplCount++;
        }
        this.handler.onItemPush(element, tagID, true);
    }
    pop() {
        const popped = this.current;
        if (this.tmplCount > 0 && this._isInTemplate()) {
            this.tmplCount--;
        }
        this.stackTop--;
        this._updateCurrentElement();
        this.handler.onItemPop(popped, true);
    }
    replace(oldElement, newElement) {
        const idx = this._indexOf(oldElement);
        this.items[idx] = newElement;
        if (idx === this.stackTop) {
            this.current = newElement;
        }
    }
    insertAfter(referenceElement, newElement, newElementID) {
        const insertionIdx = this._indexOf(referenceElement) + 1;
        this.items.splice(insertionIdx, 0, newElement);
        this.tagIDs.splice(insertionIdx, 0, newElementID);
        this.stackTop++;
        if (insertionIdx === this.stackTop) {
            this._updateCurrentElement();
        }
        this.handler.onItemPush(this.current, this.currentTagId, insertionIdx === this.stackTop);
    }
    popUntilTagNamePopped(tagName) {
        let targetIdx = this.stackTop + 1;
        do {
            targetIdx = this.tagIDs.lastIndexOf(tagName, targetIdx - 1);
        } while (targetIdx > 0 && this.treeAdapter.getNamespaceURI(this.items[targetIdx]) !== NS.HTML);
        this.shortenToLength(targetIdx < 0 ? 0 : targetIdx);
    }
    shortenToLength(idx) {
        while (this.stackTop >= idx) {
            const popped = this.current;
            if (this.tmplCount > 0 && this._isInTemplate()) {
                this.tmplCount -= 1;
            }
            this.stackTop--;
            this._updateCurrentElement();
            this.handler.onItemPop(popped, this.stackTop < idx);
        }
    }
    popUntilElementPopped(element) {
        const idx = this._indexOf(element);
        this.shortenToLength(idx < 0 ? 0 : idx);
    }
    popUntilPopped(tagNames, targetNS) {
        const idx = this._indexOfTagNames(tagNames, targetNS);
        this.shortenToLength(idx < 0 ? 0 : idx);
    }
    popUntilNumberedHeaderPopped() {
        this.popUntilPopped(NAMED_HEADERS, NS.HTML);
    }
    popUntilTableCellPopped() {
        this.popUntilPopped(TABLE_CELLS, NS.HTML);
    }
    popAllUpToHtmlElement() {
        //NOTE: here we assume that the root <html> element is always first in the open element stack, so
        //we perform this fast stack clean up.
        this.tmplCount = 0;
        this.shortenToLength(1);
    }
    _indexOfTagNames(tagNames, namespace) {
        for (let i = this.stackTop; i >= 0; i--) {
            if (tagNames.includes(this.tagIDs[i]) && this.treeAdapter.getNamespaceURI(this.items[i]) === namespace) {
                return i;
            }
        }
        return -1;
    }
    clearBackTo(tagNames, targetNS) {
        const idx = this._indexOfTagNames(tagNames, targetNS);
        this.shortenToLength(idx + 1);
    }
    clearBackToTableContext() {
        this.clearBackTo(TABLE_CONTEXT, NS.HTML);
    }
    clearBackToTableBodyContext() {
        this.clearBackTo(TABLE_BODY_CONTEXT, NS.HTML);
    }
    clearBackToTableRowContext() {
        this.clearBackTo(TABLE_ROW_CONTEXT, NS.HTML);
    }
    remove(element) {
        const idx = this._indexOf(element);
        if (idx >= 0) {
            if (idx === this.stackTop) {
                this.pop();
            }
            else {
                this.items.splice(idx, 1);
                this.tagIDs.splice(idx, 1);
                this.stackTop--;
                this._updateCurrentElement();
                this.handler.onItemPop(element, false);
            }
        }
    }
    //Search
    tryPeekProperlyNestedBodyElement() {
        //Properly nested <body> element (should be second element in stack).
        return this.stackTop >= 1 && this.tagIDs[1] === TAG_ID.BODY ? this.items[1] : null;
    }
    contains(element) {
        return this._indexOf(element) > -1;
    }
    getCommonAncestor(element) {
        const elementIdx = this._indexOf(element) - 1;
        return elementIdx >= 0 ? this.items[elementIdx] : null;
    }
    isRootHtmlElementCurrent() {
        return this.stackTop === 0 && this.tagIDs[0] === TAG_ID.HTML;
    }
    //Element in scope
    hasInScope(tagName) {
        for (let i = this.stackTop; i >= 0; i--) {
            const tn = this.tagIDs[i];
            const ns = this.treeAdapter.getNamespaceURI(this.items[i]);
            if (tn === tagName && ns === NS.HTML) {
                return true;
            }
            if (SCOPING_ELEMENT_NS.get(tn) === ns) {
                return false;
            }
        }
        return true;
    }
    hasNumberedHeaderInScope() {
        for (let i = this.stackTop; i >= 0; i--) {
            const tn = this.tagIDs[i];
            const ns = this.treeAdapter.getNamespaceURI(this.items[i]);
            if (isNumberedHeader(tn) && ns === NS.HTML) {
                return true;
            }
            if (SCOPING_ELEMENT_NS.get(tn) === ns) {
                return false;
            }
        }
        return true;
    }
    hasInListItemScope(tagName) {
        for (let i = this.stackTop; i >= 0; i--) {
            const tn = this.tagIDs[i];
            const ns = this.treeAdapter.getNamespaceURI(this.items[i]);
            if (tn === tagName && ns === NS.HTML) {
                return true;
            }
            if (((tn === TAG_ID.UL || tn === TAG_ID.OL) && ns === NS.HTML) || SCOPING_ELEMENT_NS.get(tn) === ns) {
                return false;
            }
        }
        return true;
    }
    hasInButtonScope(tagName) {
        for (let i = this.stackTop; i >= 0; i--) {
            const tn = this.tagIDs[i];
            const ns = this.treeAdapter.getNamespaceURI(this.items[i]);
            if (tn === tagName && ns === NS.HTML) {
                return true;
            }
            if ((tn === TAG_ID.BUTTON && ns === NS.HTML) || SCOPING_ELEMENT_NS.get(tn) === ns) {
                return false;
            }
        }
        return true;
    }
    hasInTableScope(tagName) {
        for (let i = this.stackTop; i >= 0; i--) {
            const tn = this.tagIDs[i];
            const ns = this.treeAdapter.getNamespaceURI(this.items[i]);
            if (ns !== NS.HTML) {
                continue;
            }
            if (tn === tagName) {
                return true;
            }
            if (tn === TAG_ID.TABLE || tn === TAG_ID.TEMPLATE || tn === TAG_ID.HTML) {
                return false;
            }
        }
        return true;
    }
    hasTableBodyContextInTableScope() {
        for (let i = this.stackTop; i >= 0; i--) {
            const tn = this.tagIDs[i];
            const ns = this.treeAdapter.getNamespaceURI(this.items[i]);
            if (ns !== NS.HTML) {
                continue;
            }
            if (tn === TAG_ID.TBODY || tn === TAG_ID.THEAD || tn === TAG_ID.TFOOT) {
                return true;
            }
            if (tn === TAG_ID.TABLE || tn === TAG_ID.HTML) {
                return false;
            }
        }
        return true;
    }
    hasInSelectScope(tagName) {
        for (let i = this.stackTop; i >= 0; i--) {
            const tn = this.tagIDs[i];
            const ns = this.treeAdapter.getNamespaceURI(this.items[i]);
            if (ns !== NS.HTML) {
                continue;
            }
            if (tn === tagName) {
                return true;
            }
            if (tn !== TAG_ID.OPTION && tn !== TAG_ID.OPTGROUP) {
                return false;
            }
        }
        return true;
    }
    //Implied end tags
    generateImpliedEndTags() {
        while (IMPLICIT_END_TAG_REQUIRED.has(this.currentTagId)) {
            this.pop();
        }
    }
    generateImpliedEndTagsThoroughly() {
        while (IMPLICIT_END_TAG_REQUIRED_THOROUGHLY.has(this.currentTagId)) {
            this.pop();
        }
    }
    generateImpliedEndTagsWithExclusion(exclusionId) {
        while (this.currentTagId !== exclusionId && IMPLICIT_END_TAG_REQUIRED_THOROUGHLY.has(this.currentTagId)) {
            this.pop();
        }
    }
}

//Const
const NOAH_ARK_CAPACITY = 3;
var EntryType;
(function (EntryType) {
    EntryType[EntryType["Marker"] = 0] = "Marker";
    EntryType[EntryType["Element"] = 1] = "Element";
})(EntryType = EntryType || (EntryType = {}));
const MARKER = { type: EntryType.Marker };
//List of formatting elements
class FormattingElementList {
    constructor(treeAdapter) {
        this.treeAdapter = treeAdapter;
        this.entries = [];
        this.bookmark = null;
    }
    //Noah Ark's condition
    //OPTIMIZATION: at first we try to find possible candidates for exclusion using
    //lightweight heuristics without thorough attributes check.
    _getNoahArkConditionCandidates(newElement, neAttrs) {
        const candidates = [];
        const neAttrsLength = neAttrs.length;
        const neTagName = this.treeAdapter.getTagName(newElement);
        const neNamespaceURI = this.treeAdapter.getNamespaceURI(newElement);
        for (let i = 0; i < this.entries.length; i++) {
            const entry = this.entries[i];
            if (entry.type === EntryType.Marker) {
                break;
            }
            const { element } = entry;
            if (this.treeAdapter.getTagName(element) === neTagName &&
                this.treeAdapter.getNamespaceURI(element) === neNamespaceURI) {
                const elementAttrs = this.treeAdapter.getAttrList(element);
                if (elementAttrs.length === neAttrsLength) {
                    candidates.push({ idx: i, attrs: elementAttrs });
                }
            }
        }
        return candidates;
    }
    _ensureNoahArkCondition(newElement) {
        if (this.entries.length < NOAH_ARK_CAPACITY)
            return;
        const neAttrs = this.treeAdapter.getAttrList(newElement);
        const candidates = this._getNoahArkConditionCandidates(newElement, neAttrs);
        if (candidates.length < NOAH_ARK_CAPACITY)
            return;
        //NOTE: build attrs map for the new element, so we can perform fast lookups
        const neAttrsMap = new Map(neAttrs.map((neAttr) => [neAttr.name, neAttr.value]));
        let validCandidates = 0;
        //NOTE: remove bottommost candidates, until Noah's Ark condition will not be met
        for (let i = 0; i < candidates.length; i++) {
            const candidate = candidates[i];
            // We know that `candidate.attrs.length === neAttrs.length`
            if (candidate.attrs.every((cAttr) => neAttrsMap.get(cAttr.name) === cAttr.value)) {
                validCandidates += 1;
                if (validCandidates >= NOAH_ARK_CAPACITY) {
                    this.entries.splice(candidate.idx, 1);
                }
            }
        }
    }
    //Mutations
    insertMarker() {
        this.entries.unshift(MARKER);
    }
    pushElement(element, token) {
        this._ensureNoahArkCondition(element);
        this.entries.unshift({
            type: EntryType.Element,
            element,
            token,
        });
    }
    insertElementAfterBookmark(element, token) {
        const bookmarkIdx = this.entries.indexOf(this.bookmark);
        this.entries.splice(bookmarkIdx, 0, {
            type: EntryType.Element,
            element,
            token,
        });
    }
    removeEntry(entry) {
        const entryIndex = this.entries.indexOf(entry);
        if (entryIndex >= 0) {
            this.entries.splice(entryIndex, 1);
        }
    }
    /**
     * Clears the list of formatting elements up to the last marker.
     *
     * @see https://html.spec.whatwg.org/multipage/parsing.html#clear-the-list-of-active-formatting-elements-up-to-the-last-marker
     */
    clearToLastMarker() {
        const markerIdx = this.entries.indexOf(MARKER);
        if (markerIdx >= 0) {
            this.entries.splice(0, markerIdx + 1);
        }
        else {
            this.entries.length = 0;
        }
    }
    //Search
    getElementEntryInScopeWithTagName(tagName) {
        const entry = this.entries.find((entry) => entry.type === EntryType.Marker || this.treeAdapter.getTagName(entry.element) === tagName);
        return entry && entry.type === EntryType.Element ? entry : null;
    }
    getElementEntry(element) {
        return this.entries.find((entry) => entry.type === EntryType.Element && entry.element === element);
    }
}

function createTextNode$1(value) {
    return {
        nodeName: '#text',
        value,
        parentNode: null,
    };
}
const defaultTreeAdapter = {
    //Node construction
    createDocument() {
        return {
            nodeName: '#document',
            mode: DOCUMENT_MODE.NO_QUIRKS,
            childNodes: [],
        };
    },
    createDocumentFragment() {
        return {
            nodeName: '#document-fragment',
            childNodes: [],
        };
    },
    createElement(tagName, namespaceURI, attrs) {
        return {
            nodeName: tagName,
            tagName,
            attrs,
            namespaceURI,
            childNodes: [],
            parentNode: null,
        };
    },
    createCommentNode(data) {
        return {
            nodeName: '#comment',
            data,
            parentNode: null,
        };
    },
    //Tree mutation
    appendChild(parentNode, newNode) {
        parentNode.childNodes.push(newNode);
        newNode.parentNode = parentNode;
    },
    insertBefore(parentNode, newNode, referenceNode) {
        const insertionIdx = parentNode.childNodes.indexOf(referenceNode);
        parentNode.childNodes.splice(insertionIdx, 0, newNode);
        newNode.parentNode = parentNode;
    },
    setTemplateContent(templateElement, contentElement) {
        templateElement.content = contentElement;
    },
    getTemplateContent(templateElement) {
        return templateElement.content;
    },
    setDocumentType(document, name, publicId, systemId) {
        const doctypeNode = document.childNodes.find((node) => node.nodeName === '#documentType');
        if (doctypeNode) {
            doctypeNode.name = name;
            doctypeNode.publicId = publicId;
            doctypeNode.systemId = systemId;
        }
        else {
            const node = {
                nodeName: '#documentType',
                name,
                publicId,
                systemId,
                parentNode: null,
            };
            defaultTreeAdapter.appendChild(document, node);
        }
    },
    setDocumentMode(document, mode) {
        document.mode = mode;
    },
    getDocumentMode(document) {
        return document.mode;
    },
    detachNode(node) {
        if (node.parentNode) {
            const idx = node.parentNode.childNodes.indexOf(node);
            node.parentNode.childNodes.splice(idx, 1);
            node.parentNode = null;
        }
    },
    insertText(parentNode, text) {
        if (parentNode.childNodes.length > 0) {
            const prevNode = parentNode.childNodes[parentNode.childNodes.length - 1];
            if (defaultTreeAdapter.isTextNode(prevNode)) {
                prevNode.value += text;
                return;
            }
        }
        defaultTreeAdapter.appendChild(parentNode, createTextNode$1(text));
    },
    insertTextBefore(parentNode, text, referenceNode) {
        const prevNode = parentNode.childNodes[parentNode.childNodes.indexOf(referenceNode) - 1];
        if (prevNode && defaultTreeAdapter.isTextNode(prevNode)) {
            prevNode.value += text;
        }
        else {
            defaultTreeAdapter.insertBefore(parentNode, createTextNode$1(text), referenceNode);
        }
    },
    adoptAttributes(recipient, attrs) {
        const recipientAttrsMap = new Set(recipient.attrs.map((attr) => attr.name));
        for (let j = 0; j < attrs.length; j++) {
            if (!recipientAttrsMap.has(attrs[j].name)) {
                recipient.attrs.push(attrs[j]);
            }
        }
    },
    //Tree traversing
    getFirstChild(node) {
        return node.childNodes[0];
    },
    getChildNodes(node) {
        return node.childNodes;
    },
    getParentNode(node) {
        return node.parentNode;
    },
    getAttrList(element) {
        return element.attrs;
    },
    //Node data
    getTagName(element) {
        return element.tagName;
    },
    getNamespaceURI(element) {
        return element.namespaceURI;
    },
    getTextNodeContent(textNode) {
        return textNode.value;
    },
    getCommentNodeContent(commentNode) {
        return commentNode.data;
    },
    getDocumentTypeNodeName(doctypeNode) {
        return doctypeNode.name;
    },
    getDocumentTypeNodePublicId(doctypeNode) {
        return doctypeNode.publicId;
    },
    getDocumentTypeNodeSystemId(doctypeNode) {
        return doctypeNode.systemId;
    },
    //Node types
    isTextNode(node) {
        return node.nodeName === '#text';
    },
    isCommentNode(node) {
        return node.nodeName === '#comment';
    },
    isDocumentTypeNode(node) {
        return node.nodeName === '#documentType';
    },
    isElementNode(node) {
        return Object.prototype.hasOwnProperty.call(node, 'tagName');
    },
    // Source code location
    setNodeSourceCodeLocation(node, location) {
        node.sourceCodeLocation = location;
    },
    getNodeSourceCodeLocation(node) {
        return node.sourceCodeLocation;
    },
    updateNodeSourceCodeLocation(node, endLocation) {
        node.sourceCodeLocation = { ...node.sourceCodeLocation, ...endLocation };
    },
};

//Const
const VALID_DOCTYPE_NAME = 'html';
const VALID_SYSTEM_ID = 'about:legacy-compat';
const QUIRKS_MODE_SYSTEM_ID = 'http://www.ibm.com/data/dtd/v11/ibmxhtml1-transitional.dtd';
const QUIRKS_MODE_PUBLIC_ID_PREFIXES = [
    '+//silmaril//dtd html pro v0r11 19970101//',
    '-//as//dtd html 3.0 aswedit + extensions//',
    '-//advasoft ltd//dtd html 3.0 aswedit + extensions//',
    '-//ietf//dtd html 2.0 level 1//',
    '-//ietf//dtd html 2.0 level 2//',
    '-//ietf//dtd html 2.0 strict level 1//',
    '-//ietf//dtd html 2.0 strict level 2//',
    '-//ietf//dtd html 2.0 strict//',
    '-//ietf//dtd html 2.0//',
    '-//ietf//dtd html 2.1e//',
    '-//ietf//dtd html 3.0//',
    '-//ietf//dtd html 3.2 final//',
    '-//ietf//dtd html 3.2//',
    '-//ietf//dtd html 3//',
    '-//ietf//dtd html level 0//',
    '-//ietf//dtd html level 1//',
    '-//ietf//dtd html level 2//',
    '-//ietf//dtd html level 3//',
    '-//ietf//dtd html strict level 0//',
    '-//ietf//dtd html strict level 1//',
    '-//ietf//dtd html strict level 2//',
    '-//ietf//dtd html strict level 3//',
    '-//ietf//dtd html strict//',
    '-//ietf//dtd html//',
    '-//metrius//dtd metrius presentational//',
    '-//microsoft//dtd internet explorer 2.0 html strict//',
    '-//microsoft//dtd internet explorer 2.0 html//',
    '-//microsoft//dtd internet explorer 2.0 tables//',
    '-//microsoft//dtd internet explorer 3.0 html strict//',
    '-//microsoft//dtd internet explorer 3.0 html//',
    '-//microsoft//dtd internet explorer 3.0 tables//',
    '-//netscape comm. corp.//dtd html//',
    '-//netscape comm. corp.//dtd strict html//',
    "-//o'reilly and associates//dtd html 2.0//",
    "-//o'reilly and associates//dtd html extended 1.0//",
    "-//o'reilly and associates//dtd html extended relaxed 1.0//",
    '-//sq//dtd html 2.0 hotmetal + extensions//',
    '-//softquad software//dtd hotmetal pro 6.0::19990601::extensions to html 4.0//',
    '-//softquad//dtd hotmetal pro 4.0::19971010::extensions to html 4.0//',
    '-//spyglass//dtd html 2.0 extended//',
    '-//sun microsystems corp.//dtd hotjava html//',
    '-//sun microsystems corp.//dtd hotjava strict html//',
    '-//w3c//dtd html 3 1995-03-24//',
    '-//w3c//dtd html 3.2 draft//',
    '-//w3c//dtd html 3.2 final//',
    '-//w3c//dtd html 3.2//',
    '-//w3c//dtd html 3.2s draft//',
    '-//w3c//dtd html 4.0 frameset//',
    '-//w3c//dtd html 4.0 transitional//',
    '-//w3c//dtd html experimental 19960712//',
    '-//w3c//dtd html experimental 970421//',
    '-//w3c//dtd w3 html//',
    '-//w3o//dtd w3 html 3.0//',
    '-//webtechs//dtd mozilla html 2.0//',
    '-//webtechs//dtd mozilla html//',
];
const QUIRKS_MODE_NO_SYSTEM_ID_PUBLIC_ID_PREFIXES = [
    ...QUIRKS_MODE_PUBLIC_ID_PREFIXES,
    '-//w3c//dtd html 4.01 frameset//',
    '-//w3c//dtd html 4.01 transitional//',
];
const QUIRKS_MODE_PUBLIC_IDS = new Set([
    '-//w3o//dtd w3 html strict 3.0//en//',
    '-/w3c/dtd html 4.0 transitional/en',
    'html',
]);
const LIMITED_QUIRKS_PUBLIC_ID_PREFIXES = ['-//w3c//dtd xhtml 1.0 frameset//', '-//w3c//dtd xhtml 1.0 transitional//'];
const LIMITED_QUIRKS_WITH_SYSTEM_ID_PUBLIC_ID_PREFIXES = [
    ...LIMITED_QUIRKS_PUBLIC_ID_PREFIXES,
    '-//w3c//dtd html 4.01 frameset//',
    '-//w3c//dtd html 4.01 transitional//',
];
//Utils
function hasPrefix(publicId, prefixes) {
    return prefixes.some((prefix) => publicId.startsWith(prefix));
}
//API
function isConforming(token) {
    return (token.name === VALID_DOCTYPE_NAME &&
        token.publicId === null &&
        (token.systemId === null || token.systemId === VALID_SYSTEM_ID));
}
function getDocumentMode(token) {
    if (token.name !== VALID_DOCTYPE_NAME) {
        return DOCUMENT_MODE.QUIRKS;
    }
    const { systemId } = token;
    if (systemId && systemId.toLowerCase() === QUIRKS_MODE_SYSTEM_ID) {
        return DOCUMENT_MODE.QUIRKS;
    }
    let { publicId } = token;
    if (publicId !== null) {
        publicId = publicId.toLowerCase();
        if (QUIRKS_MODE_PUBLIC_IDS.has(publicId)) {
            return DOCUMENT_MODE.QUIRKS;
        }
        let prefixes = systemId === null ? QUIRKS_MODE_NO_SYSTEM_ID_PUBLIC_ID_PREFIXES : QUIRKS_MODE_PUBLIC_ID_PREFIXES;
        if (hasPrefix(publicId, prefixes)) {
            return DOCUMENT_MODE.QUIRKS;
        }
        prefixes =
            systemId === null ? LIMITED_QUIRKS_PUBLIC_ID_PREFIXES : LIMITED_QUIRKS_WITH_SYSTEM_ID_PUBLIC_ID_PREFIXES;
        if (hasPrefix(publicId, prefixes)) {
            return DOCUMENT_MODE.LIMITED_QUIRKS;
        }
    }
    return DOCUMENT_MODE.NO_QUIRKS;
}

//MIME types
const MIME_TYPES = {
    TEXT_HTML: 'text/html',
    APPLICATION_XML: 'application/xhtml+xml',
};
//Attributes
const DEFINITION_URL_ATTR = 'definitionurl';
const ADJUSTED_DEFINITION_URL_ATTR = 'definitionURL';
const SVG_ATTRS_ADJUSTMENT_MAP = new Map([
    'attributeName',
    'attributeType',
    'baseFrequency',
    'baseProfile',
    'calcMode',
    'clipPathUnits',
    'diffuseConstant',
    'edgeMode',
    'filterUnits',
    'glyphRef',
    'gradientTransform',
    'gradientUnits',
    'kernelMatrix',
    'kernelUnitLength',
    'keyPoints',
    'keySplines',
    'keyTimes',
    'lengthAdjust',
    'limitingConeAngle',
    'markerHeight',
    'markerUnits',
    'markerWidth',
    'maskContentUnits',
    'maskUnits',
    'numOctaves',
    'pathLength',
    'patternContentUnits',
    'patternTransform',
    'patternUnits',
    'pointsAtX',
    'pointsAtY',
    'pointsAtZ',
    'preserveAlpha',
    'preserveAspectRatio',
    'primitiveUnits',
    'refX',
    'refY',
    'repeatCount',
    'repeatDur',
    'requiredExtensions',
    'requiredFeatures',
    'specularConstant',
    'specularExponent',
    'spreadMethod',
    'startOffset',
    'stdDeviation',
    'stitchTiles',
    'surfaceScale',
    'systemLanguage',
    'tableValues',
    'targetX',
    'targetY',
    'textLength',
    'viewBox',
    'viewTarget',
    'xChannelSelector',
    'yChannelSelector',
    'zoomAndPan',
].map((attr) => [attr.toLowerCase(), attr]));
const XML_ATTRS_ADJUSTMENT_MAP = new Map([
    ['xlink:actuate', { prefix: 'xlink', name: 'actuate', namespace: NS.XLINK }],
    ['xlink:arcrole', { prefix: 'xlink', name: 'arcrole', namespace: NS.XLINK }],
    ['xlink:href', { prefix: 'xlink', name: 'href', namespace: NS.XLINK }],
    ['xlink:role', { prefix: 'xlink', name: 'role', namespace: NS.XLINK }],
    ['xlink:show', { prefix: 'xlink', name: 'show', namespace: NS.XLINK }],
    ['xlink:title', { prefix: 'xlink', name: 'title', namespace: NS.XLINK }],
    ['xlink:type', { prefix: 'xlink', name: 'type', namespace: NS.XLINK }],
    ['xml:base', { prefix: 'xml', name: 'base', namespace: NS.XML }],
    ['xml:lang', { prefix: 'xml', name: 'lang', namespace: NS.XML }],
    ['xml:space', { prefix: 'xml', name: 'space', namespace: NS.XML }],
    ['xmlns', { prefix: '', name: 'xmlns', namespace: NS.XMLNS }],
    ['xmlns:xlink', { prefix: 'xmlns', name: 'xlink', namespace: NS.XMLNS }],
]);
//SVG tag names adjustment map
const SVG_TAG_NAMES_ADJUSTMENT_MAP = new Map([
    'altGlyph',
    'altGlyphDef',
    'altGlyphItem',
    'animateColor',
    'animateMotion',
    'animateTransform',
    'clipPath',
    'feBlend',
    'feColorMatrix',
    'feComponentTransfer',
    'feComposite',
    'feConvolveMatrix',
    'feDiffuseLighting',
    'feDisplacementMap',
    'feDistantLight',
    'feFlood',
    'feFuncA',
    'feFuncB',
    'feFuncG',
    'feFuncR',
    'feGaussianBlur',
    'feImage',
    'feMerge',
    'feMergeNode',
    'feMorphology',
    'feOffset',
    'fePointLight',
    'feSpecularLighting',
    'feSpotLight',
    'feTile',
    'feTurbulence',
    'foreignObject',
    'glyphRef',
    'linearGradient',
    'radialGradient',
    'textPath',
].map((tn) => [tn.toLowerCase(), tn]));
//Tags that causes exit from foreign content
const EXITS_FOREIGN_CONTENT = new Set([
    TAG_ID.B,
    TAG_ID.BIG,
    TAG_ID.BLOCKQUOTE,
    TAG_ID.BODY,
    TAG_ID.BR,
    TAG_ID.CENTER,
    TAG_ID.CODE,
    TAG_ID.DD,
    TAG_ID.DIV,
    TAG_ID.DL,
    TAG_ID.DT,
    TAG_ID.EM,
    TAG_ID.EMBED,
    TAG_ID.H1,
    TAG_ID.H2,
    TAG_ID.H3,
    TAG_ID.H4,
    TAG_ID.H5,
    TAG_ID.H6,
    TAG_ID.HEAD,
    TAG_ID.HR,
    TAG_ID.I,
    TAG_ID.IMG,
    TAG_ID.LI,
    TAG_ID.LISTING,
    TAG_ID.MENU,
    TAG_ID.META,
    TAG_ID.NOBR,
    TAG_ID.OL,
    TAG_ID.P,
    TAG_ID.PRE,
    TAG_ID.RUBY,
    TAG_ID.S,
    TAG_ID.SMALL,
    TAG_ID.SPAN,
    TAG_ID.STRONG,
    TAG_ID.STRIKE,
    TAG_ID.SUB,
    TAG_ID.SUP,
    TAG_ID.TABLE,
    TAG_ID.TT,
    TAG_ID.U,
    TAG_ID.UL,
    TAG_ID.VAR,
]);
//Check exit from foreign content
function causesExit(startTagToken) {
    const tn = startTagToken.tagID;
    const isFontWithAttrs = tn === TAG_ID.FONT &&
        startTagToken.attrs.some(({ name }) => name === ATTRS.COLOR || name === ATTRS.SIZE || name === ATTRS.FACE);
    return isFontWithAttrs || EXITS_FOREIGN_CONTENT.has(tn);
}
//Token adjustments
function adjustTokenMathMLAttrs(token) {
    for (let i = 0; i < token.attrs.length; i++) {
        if (token.attrs[i].name === DEFINITION_URL_ATTR) {
            token.attrs[i].name = ADJUSTED_DEFINITION_URL_ATTR;
            break;
        }
    }
}
function adjustTokenSVGAttrs(token) {
    for (let i = 0; i < token.attrs.length; i++) {
        const adjustedAttrName = SVG_ATTRS_ADJUSTMENT_MAP.get(token.attrs[i].name);
        if (adjustedAttrName != null) {
            token.attrs[i].name = adjustedAttrName;
        }
    }
}
function adjustTokenXMLAttrs(token) {
    for (let i = 0; i < token.attrs.length; i++) {
        const adjustedAttrEntry = XML_ATTRS_ADJUSTMENT_MAP.get(token.attrs[i].name);
        if (adjustedAttrEntry) {
            token.attrs[i].prefix = adjustedAttrEntry.prefix;
            token.attrs[i].name = adjustedAttrEntry.name;
            token.attrs[i].namespace = adjustedAttrEntry.namespace;
        }
    }
}
function adjustTokenSVGTagName(token) {
    const adjustedTagName = SVG_TAG_NAMES_ADJUSTMENT_MAP.get(token.tagName);
    if (adjustedTagName != null) {
        token.tagName = adjustedTagName;
        token.tagID = getTagID(token.tagName);
    }
}
//Integration points
function isMathMLTextIntegrationPoint(tn, ns) {
    return ns === NS.MATHML && (tn === TAG_ID.MI || tn === TAG_ID.MO || tn === TAG_ID.MN || tn === TAG_ID.MS || tn === TAG_ID.MTEXT);
}
function isHtmlIntegrationPoint(tn, ns, attrs) {
    if (ns === NS.MATHML && tn === TAG_ID.ANNOTATION_XML) {
        for (let i = 0; i < attrs.length; i++) {
            if (attrs[i].name === ATTRS.ENCODING) {
                const value = attrs[i].value.toLowerCase();
                return value === MIME_TYPES.TEXT_HTML || value === MIME_TYPES.APPLICATION_XML;
            }
        }
    }
    return ns === NS.SVG && (tn === TAG_ID.FOREIGN_OBJECT || tn === TAG_ID.DESC || tn === TAG_ID.TITLE);
}
function isIntegrationPoint(tn, ns, attrs, foreignNS) {
    return (((!foreignNS || foreignNS === NS.HTML) && isHtmlIntegrationPoint(tn, ns, attrs)) ||
        ((!foreignNS || foreignNS === NS.MATHML) && isMathMLTextIntegrationPoint(tn, ns)));
}

//Misc constants
const HIDDEN_INPUT_TYPE = 'hidden';
//Adoption agency loops iteration count
const AA_OUTER_LOOP_ITER = 8;
const AA_INNER_LOOP_ITER = 3;
//Insertion modes
var InsertionMode;
(function (InsertionMode) {
    InsertionMode[InsertionMode["INITIAL"] = 0] = "INITIAL";
    InsertionMode[InsertionMode["BEFORE_HTML"] = 1] = "BEFORE_HTML";
    InsertionMode[InsertionMode["BEFORE_HEAD"] = 2] = "BEFORE_HEAD";
    InsertionMode[InsertionMode["IN_HEAD"] = 3] = "IN_HEAD";
    InsertionMode[InsertionMode["IN_HEAD_NO_SCRIPT"] = 4] = "IN_HEAD_NO_SCRIPT";
    InsertionMode[InsertionMode["AFTER_HEAD"] = 5] = "AFTER_HEAD";
    InsertionMode[InsertionMode["IN_BODY"] = 6] = "IN_BODY";
    InsertionMode[InsertionMode["TEXT"] = 7] = "TEXT";
    InsertionMode[InsertionMode["IN_TABLE"] = 8] = "IN_TABLE";
    InsertionMode[InsertionMode["IN_TABLE_TEXT"] = 9] = "IN_TABLE_TEXT";
    InsertionMode[InsertionMode["IN_CAPTION"] = 10] = "IN_CAPTION";
    InsertionMode[InsertionMode["IN_COLUMN_GROUP"] = 11] = "IN_COLUMN_GROUP";
    InsertionMode[InsertionMode["IN_TABLE_BODY"] = 12] = "IN_TABLE_BODY";
    InsertionMode[InsertionMode["IN_ROW"] = 13] = "IN_ROW";
    InsertionMode[InsertionMode["IN_CELL"] = 14] = "IN_CELL";
    InsertionMode[InsertionMode["IN_SELECT"] = 15] = "IN_SELECT";
    InsertionMode[InsertionMode["IN_SELECT_IN_TABLE"] = 16] = "IN_SELECT_IN_TABLE";
    InsertionMode[InsertionMode["IN_TEMPLATE"] = 17] = "IN_TEMPLATE";
    InsertionMode[InsertionMode["AFTER_BODY"] = 18] = "AFTER_BODY";
    InsertionMode[InsertionMode["IN_FRAMESET"] = 19] = "IN_FRAMESET";
    InsertionMode[InsertionMode["AFTER_FRAMESET"] = 20] = "AFTER_FRAMESET";
    InsertionMode[InsertionMode["AFTER_AFTER_BODY"] = 21] = "AFTER_AFTER_BODY";
    InsertionMode[InsertionMode["AFTER_AFTER_FRAMESET"] = 22] = "AFTER_AFTER_FRAMESET";
})(InsertionMode || (InsertionMode = {}));
const BASE_LOC = {
    startLine: -1,
    startCol: -1,
    startOffset: -1,
    endLine: -1,
    endCol: -1,
    endOffset: -1,
};
const TABLE_STRUCTURE_TAGS = new Set([TAG_ID.TABLE, TAG_ID.TBODY, TAG_ID.TFOOT, TAG_ID.THEAD, TAG_ID.TR]);
const defaultParserOptions = {
    scriptingEnabled: true,
    sourceCodeLocationInfo: false,
    treeAdapter: defaultTreeAdapter,
    onParseError: null,
};
//Parser
class Parser$1 {
    constructor(options, document, fragmentContext = null, scriptHandler = null) {
        this.fragmentContext = fragmentContext;
        this.scriptHandler = scriptHandler;
        this.currentToken = null;
        this.stopped = false;
        this.insertionMode = InsertionMode.INITIAL;
        this.originalInsertionMode = InsertionMode.INITIAL;
        this.headElement = null;
        this.formElement = null;
        /** Indicates that the current node is not an element in the HTML namespace */
        this.currentNotInHTML = false;
        /**
         * The template insertion mode stack is maintained from the left.
         * Ie. the topmost element will always have index 0.
         */
        this.tmplInsertionModeStack = [];
        this.pendingCharacterTokens = [];
        this.hasNonWhitespacePendingCharacterToken = false;
        this.framesetOk = true;
        this.skipNextNewLine = false;
        this.fosterParentingEnabled = false;
        this.options = {
            ...defaultParserOptions,
            ...options,
        };
        this.treeAdapter = this.options.treeAdapter;
        this.onParseError = this.options.onParseError;
        // Always enable location info if we report parse errors.
        if (this.onParseError) {
            this.options.sourceCodeLocationInfo = true;
        }
        this.document = document !== null && document !== void 0 ? document : this.treeAdapter.createDocument();
        this.tokenizer = new Tokenizer$1(this.options, this);
        this.activeFormattingElements = new FormattingElementList(this.treeAdapter);
        this.fragmentContextID = fragmentContext ? getTagID(this.treeAdapter.getTagName(fragmentContext)) : TAG_ID.UNKNOWN;
        this._setContextModes(fragmentContext !== null && fragmentContext !== void 0 ? fragmentContext : this.document, this.fragmentContextID);
        this.openElements = new OpenElementStack(this.document, this.treeAdapter, this);
    }
    // API
    static parse(html, options) {
        const parser = new this(options);
        parser.tokenizer.write(html, true);
        return parser.document;
    }
    static getFragmentParser(fragmentContext, options) {
        const opts = {
            ...defaultParserOptions,
            ...options,
        };
        //NOTE: use a <template> element as the fragment context if no context element was provided,
        //so we will parse in a "forgiving" manner
        fragmentContext !== null && fragmentContext !== void 0 ? fragmentContext : (fragmentContext = opts.treeAdapter.createElement(TAG_NAMES.TEMPLATE, NS.HTML, []));
        //NOTE: create a fake element which will be used as the `document` for fragment parsing.
        //This is important for jsdom, where a new `document` cannot be created. This led to
        //fragment parsing messing with the main `document`.
        const documentMock = opts.treeAdapter.createElement('documentmock', NS.HTML, []);
        const parser = new this(opts, documentMock, fragmentContext);
        if (parser.fragmentContextID === TAG_ID.TEMPLATE) {
            parser.tmplInsertionModeStack.unshift(InsertionMode.IN_TEMPLATE);
        }
        parser._initTokenizerForFragmentParsing();
        parser._insertFakeRootElement();
        parser._resetInsertionMode();
        parser._findFormInFragmentContext();
        return parser;
    }
    getFragment() {
        const rootElement = this.treeAdapter.getFirstChild(this.document);
        const fragment = this.treeAdapter.createDocumentFragment();
        this._adoptNodes(rootElement, fragment);
        return fragment;
    }
    //Errors
    _err(token, code, beforeToken) {
        var _a;
        if (!this.onParseError)
            return;
        const loc = (_a = token.location) !== null && _a !== void 0 ? _a : BASE_LOC;
        const err = {
            code,
            startLine: loc.startLine,
            startCol: loc.startCol,
            startOffset: loc.startOffset,
            endLine: beforeToken ? loc.startLine : loc.endLine,
            endCol: beforeToken ? loc.startCol : loc.endCol,
            endOffset: beforeToken ? loc.startOffset : loc.endOffset,
        };
        this.onParseError(err);
    }
    //Stack events
    onItemPush(node, tid, isTop) {
        var _a, _b;
        (_b = (_a = this.treeAdapter).onItemPush) === null || _b === void 0 ? void 0 : _b.call(_a, node);
        if (isTop && this.openElements.stackTop > 0)
            this._setContextModes(node, tid);
    }
    onItemPop(node, isTop) {
        var _a, _b;
        if (this.options.sourceCodeLocationInfo) {
            this._setEndLocation(node, this.currentToken);
        }
        (_b = (_a = this.treeAdapter).onItemPop) === null || _b === void 0 ? void 0 : _b.call(_a, node, this.openElements.current);
        if (isTop) {
            let current;
            let currentTagId;
            if (this.openElements.stackTop === 0 && this.fragmentContext) {
                current = this.fragmentContext;
                currentTagId = this.fragmentContextID;
            }
            else {
                ({ current, currentTagId } = this.openElements);
            }
            this._setContextModes(current, currentTagId);
        }
    }
    _setContextModes(current, tid) {
        const isHTML = current === this.document || this.treeAdapter.getNamespaceURI(current) === NS.HTML;
        this.currentNotInHTML = !isHTML;
        this.tokenizer.inForeignNode = !isHTML && !this._isIntegrationPoint(tid, current);
    }
    _switchToTextParsing(currentToken, nextTokenizerState) {
        this._insertElement(currentToken, NS.HTML);
        this.tokenizer.state = nextTokenizerState;
        this.originalInsertionMode = this.insertionMode;
        this.insertionMode = InsertionMode.TEXT;
    }
    switchToPlaintextParsing() {
        this.insertionMode = InsertionMode.TEXT;
        this.originalInsertionMode = InsertionMode.IN_BODY;
        this.tokenizer.state = TokenizerMode.PLAINTEXT;
    }
    //Fragment parsing
    _getAdjustedCurrentElement() {
        return this.openElements.stackTop === 0 && this.fragmentContext
            ? this.fragmentContext
            : this.openElements.current;
    }
    _findFormInFragmentContext() {
        let node = this.fragmentContext;
        while (node) {
            if (this.treeAdapter.getTagName(node) === TAG_NAMES.FORM) {
                this.formElement = node;
                break;
            }
            node = this.treeAdapter.getParentNode(node);
        }
    }
    _initTokenizerForFragmentParsing() {
        if (!this.fragmentContext || this.treeAdapter.getNamespaceURI(this.fragmentContext) !== NS.HTML) {
            return;
        }
        switch (this.fragmentContextID) {
            case TAG_ID.TITLE:
            case TAG_ID.TEXTAREA: {
                this.tokenizer.state = TokenizerMode.RCDATA;
                break;
            }
            case TAG_ID.STYLE:
            case TAG_ID.XMP:
            case TAG_ID.IFRAME:
            case TAG_ID.NOEMBED:
            case TAG_ID.NOFRAMES:
            case TAG_ID.NOSCRIPT: {
                this.tokenizer.state = TokenizerMode.RAWTEXT;
                break;
            }
            case TAG_ID.SCRIPT: {
                this.tokenizer.state = TokenizerMode.SCRIPT_DATA;
                break;
            }
            case TAG_ID.PLAINTEXT: {
                this.tokenizer.state = TokenizerMode.PLAINTEXT;
                break;
            }
            // Do nothing
        }
    }
    //Tree mutation
    _setDocumentType(token) {
        const name = token.name || '';
        const publicId = token.publicId || '';
        const systemId = token.systemId || '';
        this.treeAdapter.setDocumentType(this.document, name, publicId, systemId);
        if (token.location) {
            const documentChildren = this.treeAdapter.getChildNodes(this.document);
            const docTypeNode = documentChildren.find((node) => this.treeAdapter.isDocumentTypeNode(node));
            if (docTypeNode) {
                this.treeAdapter.setNodeSourceCodeLocation(docTypeNode, token.location);
            }
        }
    }
    _attachElementToTree(element, location) {
        if (this.options.sourceCodeLocationInfo) {
            const loc = location && {
                ...location,
                startTag: location,
            };
            this.treeAdapter.setNodeSourceCodeLocation(element, loc);
        }
        if (this._shouldFosterParentOnInsertion()) {
            this._fosterParentElement(element);
        }
        else {
            const parent = this.openElements.currentTmplContentOrNode;
            this.treeAdapter.appendChild(parent, element);
        }
    }
    _appendElement(token, namespaceURI) {
        const element = this.treeAdapter.createElement(token.tagName, namespaceURI, token.attrs);
        this._attachElementToTree(element, token.location);
    }
    _insertElement(token, namespaceURI) {
        const element = this.treeAdapter.createElement(token.tagName, namespaceURI, token.attrs);
        this._attachElementToTree(element, token.location);
        this.openElements.push(element, token.tagID);
    }
    _insertFakeElement(tagName, tagID) {
        const element = this.treeAdapter.createElement(tagName, NS.HTML, []);
        this._attachElementToTree(element, null);
        this.openElements.push(element, tagID);
    }
    _insertTemplate(token) {
        const tmpl = this.treeAdapter.createElement(token.tagName, NS.HTML, token.attrs);
        const content = this.treeAdapter.createDocumentFragment();
        this.treeAdapter.setTemplateContent(tmpl, content);
        this._attachElementToTree(tmpl, token.location);
        this.openElements.push(tmpl, token.tagID);
        if (this.options.sourceCodeLocationInfo)
            this.treeAdapter.setNodeSourceCodeLocation(content, null);
    }
    _insertFakeRootElement() {
        const element = this.treeAdapter.createElement(TAG_NAMES.HTML, NS.HTML, []);
        if (this.options.sourceCodeLocationInfo)
            this.treeAdapter.setNodeSourceCodeLocation(element, null);
        this.treeAdapter.appendChild(this.openElements.current, element);
        this.openElements.push(element, TAG_ID.HTML);
    }
    _appendCommentNode(token, parent) {
        const commentNode = this.treeAdapter.createCommentNode(token.data);
        this.treeAdapter.appendChild(parent, commentNode);
        if (this.options.sourceCodeLocationInfo) {
            this.treeAdapter.setNodeSourceCodeLocation(commentNode, token.location);
        }
    }
    _insertCharacters(token) {
        let parent;
        let beforeElement;
        if (this._shouldFosterParentOnInsertion()) {
            ({ parent, beforeElement } = this._findFosterParentingLocation());
            if (beforeElement) {
                this.treeAdapter.insertTextBefore(parent, token.chars, beforeElement);
            }
            else {
                this.treeAdapter.insertText(parent, token.chars);
            }
        }
        else {
            parent = this.openElements.currentTmplContentOrNode;
            this.treeAdapter.insertText(parent, token.chars);
        }
        if (!token.location)
            return;
        const siblings = this.treeAdapter.getChildNodes(parent);
        const textNodeIdx = beforeElement ? siblings.lastIndexOf(beforeElement) : siblings.length;
        const textNode = siblings[textNodeIdx - 1];
        //NOTE: if we have a location assigned by another token, then just update the end position
        const tnLoc = this.treeAdapter.getNodeSourceCodeLocation(textNode);
        if (tnLoc) {
            const { endLine, endCol, endOffset } = token.location;
            this.treeAdapter.updateNodeSourceCodeLocation(textNode, { endLine, endCol, endOffset });
        }
        else if (this.options.sourceCodeLocationInfo) {
            this.treeAdapter.setNodeSourceCodeLocation(textNode, token.location);
        }
    }
    _adoptNodes(donor, recipient) {
        for (let child = this.treeAdapter.getFirstChild(donor); child; child = this.treeAdapter.getFirstChild(donor)) {
            this.treeAdapter.detachNode(child);
            this.treeAdapter.appendChild(recipient, child);
        }
    }
    _setEndLocation(element, closingToken) {
        if (this.treeAdapter.getNodeSourceCodeLocation(element) && closingToken.location) {
            const ctLoc = closingToken.location;
            const tn = this.treeAdapter.getTagName(element);
            const endLoc = 
            // NOTE: For cases like <p> <p> </p> - First 'p' closes without a closing
            // tag and for cases like <td> <p> </td> - 'p' closes without a closing tag.
            closingToken.type === TokenType.END_TAG && tn === closingToken.tagName
                ? {
                    endTag: { ...ctLoc },
                    endLine: ctLoc.endLine,
                    endCol: ctLoc.endCol,
                    endOffset: ctLoc.endOffset,
                }
                : {
                    endLine: ctLoc.startLine,
                    endCol: ctLoc.startCol,
                    endOffset: ctLoc.startOffset,
                };
            this.treeAdapter.updateNodeSourceCodeLocation(element, endLoc);
        }
    }
    //Token processing
    shouldProcessStartTagTokenInForeignContent(token) {
        // Check that neither current === document, or ns === NS.HTML
        if (!this.currentNotInHTML)
            return false;
        let current;
        let currentTagId;
        if (this.openElements.stackTop === 0 && this.fragmentContext) {
            current = this.fragmentContext;
            currentTagId = this.fragmentContextID;
        }
        else {
            ({ current, currentTagId } = this.openElements);
        }
        if (token.tagID === TAG_ID.SVG &&
            this.treeAdapter.getTagName(current) === TAG_NAMES.ANNOTATION_XML &&
            this.treeAdapter.getNamespaceURI(current) === NS.MATHML) {
            return false;
        }
        return (
        // Check that `current` is not an integration point for HTML or MathML elements.
        this.tokenizer.inForeignNode ||
            // If it _is_ an integration point, then we might have to check that it is not an HTML
            // integration point.
            ((token.tagID === TAG_ID.MGLYPH || token.tagID === TAG_ID.MALIGNMARK) &&
                !this._isIntegrationPoint(currentTagId, current, NS.HTML)));
    }
    _processToken(token) {
        switch (token.type) {
            case TokenType.CHARACTER: {
                this.onCharacter(token);
                break;
            }
            case TokenType.NULL_CHARACTER: {
                this.onNullCharacter(token);
                break;
            }
            case TokenType.COMMENT: {
                this.onComment(token);
                break;
            }
            case TokenType.DOCTYPE: {
                this.onDoctype(token);
                break;
            }
            case TokenType.START_TAG: {
                this._processStartTag(token);
                break;
            }
            case TokenType.END_TAG: {
                this.onEndTag(token);
                break;
            }
            case TokenType.EOF: {
                this.onEof(token);
                break;
            }
            case TokenType.WHITESPACE_CHARACTER: {
                this.onWhitespaceCharacter(token);
                break;
            }
        }
    }
    //Integration points
    _isIntegrationPoint(tid, element, foreignNS) {
        const ns = this.treeAdapter.getNamespaceURI(element);
        const attrs = this.treeAdapter.getAttrList(element);
        return isIntegrationPoint(tid, ns, attrs, foreignNS);
    }
    //Active formatting elements reconstruction
    _reconstructActiveFormattingElements() {
        const listLength = this.activeFormattingElements.entries.length;
        if (listLength) {
            const endIndex = this.activeFormattingElements.entries.findIndex((entry) => entry.type === EntryType.Marker || this.openElements.contains(entry.element));
            const unopenIdx = endIndex < 0 ? listLength - 1 : endIndex - 1;
            for (let i = unopenIdx; i >= 0; i--) {
                const entry = this.activeFormattingElements.entries[i];
                this._insertElement(entry.token, this.treeAdapter.getNamespaceURI(entry.element));
                entry.element = this.openElements.current;
            }
        }
    }
    //Close elements
    _closeTableCell() {
        this.openElements.generateImpliedEndTags();
        this.openElements.popUntilTableCellPopped();
        this.activeFormattingElements.clearToLastMarker();
        this.insertionMode = InsertionMode.IN_ROW;
    }
    _closePElement() {
        this.openElements.generateImpliedEndTagsWithExclusion(TAG_ID.P);
        this.openElements.popUntilTagNamePopped(TAG_ID.P);
    }
    //Insertion modes
    _resetInsertionMode() {
        for (let i = this.openElements.stackTop; i >= 0; i--) {
            //Insertion mode reset map
            switch (i === 0 && this.fragmentContext ? this.fragmentContextID : this.openElements.tagIDs[i]) {
                case TAG_ID.TR: {
                    this.insertionMode = InsertionMode.IN_ROW;
                    return;
                }
                case TAG_ID.TBODY:
                case TAG_ID.THEAD:
                case TAG_ID.TFOOT: {
                    this.insertionMode = InsertionMode.IN_TABLE_BODY;
                    return;
                }
                case TAG_ID.CAPTION: {
                    this.insertionMode = InsertionMode.IN_CAPTION;
                    return;
                }
                case TAG_ID.COLGROUP: {
                    this.insertionMode = InsertionMode.IN_COLUMN_GROUP;
                    return;
                }
                case TAG_ID.TABLE: {
                    this.insertionMode = InsertionMode.IN_TABLE;
                    return;
                }
                case TAG_ID.BODY: {
                    this.insertionMode = InsertionMode.IN_BODY;
                    return;
                }
                case TAG_ID.FRAMESET: {
                    this.insertionMode = InsertionMode.IN_FRAMESET;
                    return;
                }
                case TAG_ID.SELECT: {
                    this._resetInsertionModeForSelect(i);
                    return;
                }
                case TAG_ID.TEMPLATE: {
                    this.insertionMode = this.tmplInsertionModeStack[0];
                    return;
                }
                case TAG_ID.HTML: {
                    this.insertionMode = this.headElement ? InsertionMode.AFTER_HEAD : InsertionMode.BEFORE_HEAD;
                    return;
                }
                case TAG_ID.TD:
                case TAG_ID.TH: {
                    if (i > 0) {
                        this.insertionMode = InsertionMode.IN_CELL;
                        return;
                    }
                    break;
                }
                case TAG_ID.HEAD: {
                    if (i > 0) {
                        this.insertionMode = InsertionMode.IN_HEAD;
                        return;
                    }
                    break;
                }
            }
        }
        this.insertionMode = InsertionMode.IN_BODY;
    }
    _resetInsertionModeForSelect(selectIdx) {
        if (selectIdx > 0) {
            for (let i = selectIdx - 1; i > 0; i--) {
                const tn = this.openElements.tagIDs[i];
                if (tn === TAG_ID.TEMPLATE) {
                    break;
                }
                else if (tn === TAG_ID.TABLE) {
                    this.insertionMode = InsertionMode.IN_SELECT_IN_TABLE;
                    return;
                }
            }
        }
        this.insertionMode = InsertionMode.IN_SELECT;
    }
    //Foster parenting
    _isElementCausesFosterParenting(tn) {
        return TABLE_STRUCTURE_TAGS.has(tn);
    }
    _shouldFosterParentOnInsertion() {
        return this.fosterParentingEnabled && this._isElementCausesFosterParenting(this.openElements.currentTagId);
    }
    _findFosterParentingLocation() {
        for (let i = this.openElements.stackTop; i >= 0; i--) {
            const openElement = this.openElements.items[i];
            switch (this.openElements.tagIDs[i]) {
                case TAG_ID.TEMPLATE: {
                    if (this.treeAdapter.getNamespaceURI(openElement) === NS.HTML) {
                        return { parent: this.treeAdapter.getTemplateContent(openElement), beforeElement: null };
                    }
                    break;
                }
                case TAG_ID.TABLE: {
                    const parent = this.treeAdapter.getParentNode(openElement);
                    if (parent) {
                        return { parent, beforeElement: openElement };
                    }
                    return { parent: this.openElements.items[i - 1], beforeElement: null };
                }
                // Do nothing
            }
        }
        return { parent: this.openElements.items[0], beforeElement: null };
    }
    _fosterParentElement(element) {
        const location = this._findFosterParentingLocation();
        if (location.beforeElement) {
            this.treeAdapter.insertBefore(location.parent, element, location.beforeElement);
        }
        else {
            this.treeAdapter.appendChild(location.parent, element);
        }
    }
    //Special elements
    _isSpecialElement(element, id) {
        const ns = this.treeAdapter.getNamespaceURI(element);
        return SPECIAL_ELEMENTS[ns].has(id);
    }
    onCharacter(token) {
        this.skipNextNewLine = false;
        if (this.tokenizer.inForeignNode) {
            characterInForeignContent(this, token);
            return;
        }
        switch (this.insertionMode) {
            case InsertionMode.INITIAL: {
                tokenInInitialMode(this, token);
                break;
            }
            case InsertionMode.BEFORE_HTML: {
                tokenBeforeHtml(this, token);
                break;
            }
            case InsertionMode.BEFORE_HEAD: {
                tokenBeforeHead(this, token);
                break;
            }
            case InsertionMode.IN_HEAD: {
                tokenInHead(this, token);
                break;
            }
            case InsertionMode.IN_HEAD_NO_SCRIPT: {
                tokenInHeadNoScript(this, token);
                break;
            }
            case InsertionMode.AFTER_HEAD: {
                tokenAfterHead(this, token);
                break;
            }
            case InsertionMode.IN_BODY:
            case InsertionMode.IN_CAPTION:
            case InsertionMode.IN_CELL:
            case InsertionMode.IN_TEMPLATE: {
                characterInBody(this, token);
                break;
            }
            case InsertionMode.TEXT:
            case InsertionMode.IN_SELECT:
            case InsertionMode.IN_SELECT_IN_TABLE: {
                this._insertCharacters(token);
                break;
            }
            case InsertionMode.IN_TABLE:
            case InsertionMode.IN_TABLE_BODY:
            case InsertionMode.IN_ROW: {
                characterInTable(this, token);
                break;
            }
            case InsertionMode.IN_TABLE_TEXT: {
                characterInTableText(this, token);
                break;
            }
            case InsertionMode.IN_COLUMN_GROUP: {
                tokenInColumnGroup(this, token);
                break;
            }
            case InsertionMode.AFTER_BODY: {
                tokenAfterBody(this, token);
                break;
            }
            case InsertionMode.AFTER_AFTER_BODY: {
                tokenAfterAfterBody(this, token);
                break;
            }
            // Do nothing
        }
    }
    onNullCharacter(token) {
        this.skipNextNewLine = false;
        if (this.tokenizer.inForeignNode) {
            nullCharacterInForeignContent(this, token);
            return;
        }
        switch (this.insertionMode) {
            case InsertionMode.INITIAL: {
                tokenInInitialMode(this, token);
                break;
            }
            case InsertionMode.BEFORE_HTML: {
                tokenBeforeHtml(this, token);
                break;
            }
            case InsertionMode.BEFORE_HEAD: {
                tokenBeforeHead(this, token);
                break;
            }
            case InsertionMode.IN_HEAD: {
                tokenInHead(this, token);
                break;
            }
            case InsertionMode.IN_HEAD_NO_SCRIPT: {
                tokenInHeadNoScript(this, token);
                break;
            }
            case InsertionMode.AFTER_HEAD: {
                tokenAfterHead(this, token);
                break;
            }
            case InsertionMode.TEXT: {
                this._insertCharacters(token);
                break;
            }
            case InsertionMode.IN_TABLE:
            case InsertionMode.IN_TABLE_BODY:
            case InsertionMode.IN_ROW: {
                characterInTable(this, token);
                break;
            }
            case InsertionMode.IN_COLUMN_GROUP: {
                tokenInColumnGroup(this, token);
                break;
            }
            case InsertionMode.AFTER_BODY: {
                tokenAfterBody(this, token);
                break;
            }
            case InsertionMode.AFTER_AFTER_BODY: {
                tokenAfterAfterBody(this, token);
                break;
            }
            // Do nothing
        }
    }
    onComment(token) {
        this.skipNextNewLine = false;
        if (this.currentNotInHTML) {
            appendComment(this, token);
            return;
        }
        switch (this.insertionMode) {
            case InsertionMode.INITIAL:
            case InsertionMode.BEFORE_HTML:
            case InsertionMode.BEFORE_HEAD:
            case InsertionMode.IN_HEAD:
            case InsertionMode.IN_HEAD_NO_SCRIPT:
            case InsertionMode.AFTER_HEAD:
            case InsertionMode.IN_BODY:
            case InsertionMode.IN_TABLE:
            case InsertionMode.IN_CAPTION:
            case InsertionMode.IN_COLUMN_GROUP:
            case InsertionMode.IN_TABLE_BODY:
            case InsertionMode.IN_ROW:
            case InsertionMode.IN_CELL:
            case InsertionMode.IN_SELECT:
            case InsertionMode.IN_SELECT_IN_TABLE:
            case InsertionMode.IN_TEMPLATE:
            case InsertionMode.IN_FRAMESET:
            case InsertionMode.AFTER_FRAMESET: {
                appendComment(this, token);
                break;
            }
            case InsertionMode.IN_TABLE_TEXT: {
                tokenInTableText(this, token);
                break;
            }
            case InsertionMode.AFTER_BODY: {
                appendCommentToRootHtmlElement(this, token);
                break;
            }
            case InsertionMode.AFTER_AFTER_BODY:
            case InsertionMode.AFTER_AFTER_FRAMESET: {
                appendCommentToDocument(this, token);
                break;
            }
            // Do nothing
        }
    }
    onDoctype(token) {
        this.skipNextNewLine = false;
        switch (this.insertionMode) {
            case InsertionMode.INITIAL: {
                doctypeInInitialMode(this, token);
                break;
            }
            case InsertionMode.BEFORE_HEAD:
            case InsertionMode.IN_HEAD:
            case InsertionMode.IN_HEAD_NO_SCRIPT:
            case InsertionMode.AFTER_HEAD: {
                this._err(token, ERR.misplacedDoctype);
                break;
            }
            case InsertionMode.IN_TABLE_TEXT: {
                tokenInTableText(this, token);
                break;
            }
            // Do nothing
        }
    }
    onStartTag(token) {
        this.skipNextNewLine = false;
        this.currentToken = token;
        this._processStartTag(token);
        if (token.selfClosing && !token.ackSelfClosing) {
            this._err(token, ERR.nonVoidHtmlElementStartTagWithTrailingSolidus);
        }
    }
    /**
     * Processes a given start tag.
     *
     * `onStartTag` checks if a self-closing tag was recognized. When a token
     * is moved inbetween multiple insertion modes, this check for self-closing
     * could lead to false positives. To avoid this, `_processStartTag` is used
     * for nested calls.
     *
     * @param token The token to process.
     */
    _processStartTag(token) {
        if (this.shouldProcessStartTagTokenInForeignContent(token)) {
            startTagInForeignContent(this, token);
        }
        else {
            this._startTagOutsideForeignContent(token);
        }
    }
    _startTagOutsideForeignContent(token) {
        switch (this.insertionMode) {
            case InsertionMode.INITIAL: {
                tokenInInitialMode(this, token);
                break;
            }
            case InsertionMode.BEFORE_HTML: {
                startTagBeforeHtml(this, token);
                break;
            }
            case InsertionMode.BEFORE_HEAD: {
                startTagBeforeHead(this, token);
                break;
            }
            case InsertionMode.IN_HEAD: {
                startTagInHead(this, token);
                break;
            }
            case InsertionMode.IN_HEAD_NO_SCRIPT: {
                startTagInHeadNoScript(this, token);
                break;
            }
            case InsertionMode.AFTER_HEAD: {
                startTagAfterHead(this, token);
                break;
            }
            case InsertionMode.IN_BODY: {
                startTagInBody(this, token);
                break;
            }
            case InsertionMode.IN_TABLE: {
                startTagInTable(this, token);
                break;
            }
            case InsertionMode.IN_TABLE_TEXT: {
                tokenInTableText(this, token);
                break;
            }
            case InsertionMode.IN_CAPTION: {
                startTagInCaption(this, token);
                break;
            }
            case InsertionMode.IN_COLUMN_GROUP: {
                startTagInColumnGroup(this, token);
                break;
            }
            case InsertionMode.IN_TABLE_BODY: {
                startTagInTableBody(this, token);
                break;
            }
            case InsertionMode.IN_ROW: {
                startTagInRow(this, token);
                break;
            }
            case InsertionMode.IN_CELL: {
                startTagInCell(this, token);
                break;
            }
            case InsertionMode.IN_SELECT: {
                startTagInSelect(this, token);
                break;
            }
            case InsertionMode.IN_SELECT_IN_TABLE: {
                startTagInSelectInTable(this, token);
                break;
            }
            case InsertionMode.IN_TEMPLATE: {
                startTagInTemplate(this, token);
                break;
            }
            case InsertionMode.AFTER_BODY: {
                startTagAfterBody(this, token);
                break;
            }
            case InsertionMode.IN_FRAMESET: {
                startTagInFrameset(this, token);
                break;
            }
            case InsertionMode.AFTER_FRAMESET: {
                startTagAfterFrameset(this, token);
                break;
            }
            case InsertionMode.AFTER_AFTER_BODY: {
                startTagAfterAfterBody(this, token);
                break;
            }
            case InsertionMode.AFTER_AFTER_FRAMESET: {
                startTagAfterAfterFrameset(this, token);
                break;
            }
            // Do nothing
        }
    }
    onEndTag(token) {
        this.skipNextNewLine = false;
        this.currentToken = token;
        if (this.currentNotInHTML) {
            endTagInForeignContent(this, token);
        }
        else {
            this._endTagOutsideForeignContent(token);
        }
    }
    _endTagOutsideForeignContent(token) {
        switch (this.insertionMode) {
            case InsertionMode.INITIAL: {
                tokenInInitialMode(this, token);
                break;
            }
            case InsertionMode.BEFORE_HTML: {
                endTagBeforeHtml(this, token);
                break;
            }
            case InsertionMode.BEFORE_HEAD: {
                endTagBeforeHead(this, token);
                break;
            }
            case InsertionMode.IN_HEAD: {
                endTagInHead(this, token);
                break;
            }
            case InsertionMode.IN_HEAD_NO_SCRIPT: {
                endTagInHeadNoScript(this, token);
                break;
            }
            case InsertionMode.AFTER_HEAD: {
                endTagAfterHead(this, token);
                break;
            }
            case InsertionMode.IN_BODY: {
                endTagInBody(this, token);
                break;
            }
            case InsertionMode.TEXT: {
                endTagInText(this, token);
                break;
            }
            case InsertionMode.IN_TABLE: {
                endTagInTable(this, token);
                break;
            }
            case InsertionMode.IN_TABLE_TEXT: {
                tokenInTableText(this, token);
                break;
            }
            case InsertionMode.IN_CAPTION: {
                endTagInCaption(this, token);
                break;
            }
            case InsertionMode.IN_COLUMN_GROUP: {
                endTagInColumnGroup(this, token);
                break;
            }
            case InsertionMode.IN_TABLE_BODY: {
                endTagInTableBody(this, token);
                break;
            }
            case InsertionMode.IN_ROW: {
                endTagInRow(this, token);
                break;
            }
            case InsertionMode.IN_CELL: {
                endTagInCell(this, token);
                break;
            }
            case InsertionMode.IN_SELECT: {
                endTagInSelect(this, token);
                break;
            }
            case InsertionMode.IN_SELECT_IN_TABLE: {
                endTagInSelectInTable(this, token);
                break;
            }
            case InsertionMode.IN_TEMPLATE: {
                endTagInTemplate(this, token);
                break;
            }
            case InsertionMode.AFTER_BODY: {
                endTagAfterBody(this, token);
                break;
            }
            case InsertionMode.IN_FRAMESET: {
                endTagInFrameset(this, token);
                break;
            }
            case InsertionMode.AFTER_FRAMESET: {
                endTagAfterFrameset(this, token);
                break;
            }
            case InsertionMode.AFTER_AFTER_BODY: {
                tokenAfterAfterBody(this, token);
                break;
            }
            // Do nothing
        }
    }
    onEof(token) {
        switch (this.insertionMode) {
            case InsertionMode.INITIAL: {
                tokenInInitialMode(this, token);
                break;
            }
            case InsertionMode.BEFORE_HTML: {
                tokenBeforeHtml(this, token);
                break;
            }
            case InsertionMode.BEFORE_HEAD: {
                tokenBeforeHead(this, token);
                break;
            }
            case InsertionMode.IN_HEAD: {
                tokenInHead(this, token);
                break;
            }
            case InsertionMode.IN_HEAD_NO_SCRIPT: {
                tokenInHeadNoScript(this, token);
                break;
            }
            case InsertionMode.AFTER_HEAD: {
                tokenAfterHead(this, token);
                break;
            }
            case InsertionMode.IN_BODY:
            case InsertionMode.IN_TABLE:
            case InsertionMode.IN_CAPTION:
            case InsertionMode.IN_COLUMN_GROUP:
            case InsertionMode.IN_TABLE_BODY:
            case InsertionMode.IN_ROW:
            case InsertionMode.IN_CELL:
            case InsertionMode.IN_SELECT:
            case InsertionMode.IN_SELECT_IN_TABLE: {
                eofInBody(this, token);
                break;
            }
            case InsertionMode.TEXT: {
                eofInText(this, token);
                break;
            }
            case InsertionMode.IN_TABLE_TEXT: {
                tokenInTableText(this, token);
                break;
            }
            case InsertionMode.IN_TEMPLATE: {
                eofInTemplate(this, token);
                break;
            }
            case InsertionMode.AFTER_BODY:
            case InsertionMode.IN_FRAMESET:
            case InsertionMode.AFTER_FRAMESET:
            case InsertionMode.AFTER_AFTER_BODY:
            case InsertionMode.AFTER_AFTER_FRAMESET: {
                stopParsing(this, token);
                break;
            }
            // Do nothing
        }
    }
    onWhitespaceCharacter(token) {
        if (this.skipNextNewLine) {
            this.skipNextNewLine = false;
            if (token.chars.charCodeAt(0) === CODE_POINTS.LINE_FEED) {
                if (token.chars.length === 1) {
                    return;
                }
                token.chars = token.chars.substr(1);
            }
        }
        if (this.tokenizer.inForeignNode) {
            this._insertCharacters(token);
            return;
        }
        switch (this.insertionMode) {
            case InsertionMode.IN_HEAD:
            case InsertionMode.IN_HEAD_NO_SCRIPT:
            case InsertionMode.AFTER_HEAD:
            case InsertionMode.TEXT:
            case InsertionMode.IN_COLUMN_GROUP:
            case InsertionMode.IN_SELECT:
            case InsertionMode.IN_SELECT_IN_TABLE:
            case InsertionMode.IN_FRAMESET:
            case InsertionMode.AFTER_FRAMESET: {
                this._insertCharacters(token);
                break;
            }
            case InsertionMode.IN_BODY:
            case InsertionMode.IN_CAPTION:
            case InsertionMode.IN_CELL:
            case InsertionMode.IN_TEMPLATE:
            case InsertionMode.AFTER_BODY:
            case InsertionMode.AFTER_AFTER_BODY:
            case InsertionMode.AFTER_AFTER_FRAMESET: {
                whitespaceCharacterInBody(this, token);
                break;
            }
            case InsertionMode.IN_TABLE:
            case InsertionMode.IN_TABLE_BODY:
            case InsertionMode.IN_ROW: {
                characterInTable(this, token);
                break;
            }
            case InsertionMode.IN_TABLE_TEXT: {
                whitespaceCharacterInTableText(this, token);
                break;
            }
            // Do nothing
        }
    }
}
//Adoption agency algorithm
//(see: http://www.whatwg.org/specs/web-apps/current-work/multipage/tree-construction.html#adoptionAgency)
//------------------------------------------------------------------
//Steps 5-8 of the algorithm
function aaObtainFormattingElementEntry(p, token) {
    let formattingElementEntry = p.activeFormattingElements.getElementEntryInScopeWithTagName(token.tagName);
    if (formattingElementEntry) {
        if (!p.openElements.contains(formattingElementEntry.element)) {
            p.activeFormattingElements.removeEntry(formattingElementEntry);
            formattingElementEntry = null;
        }
        else if (!p.openElements.hasInScope(token.tagID)) {
            formattingElementEntry = null;
        }
    }
    else {
        genericEndTagInBody(p, token);
    }
    return formattingElementEntry;
}
//Steps 9 and 10 of the algorithm
function aaObtainFurthestBlock(p, formattingElementEntry) {
    let furthestBlock = null;
    let idx = p.openElements.stackTop;
    for (; idx >= 0; idx--) {
        const element = p.openElements.items[idx];
        if (element === formattingElementEntry.element) {
            break;
        }
        if (p._isSpecialElement(element, p.openElements.tagIDs[idx])) {
            furthestBlock = element;
        }
    }
    if (!furthestBlock) {
        p.openElements.shortenToLength(idx < 0 ? 0 : idx);
        p.activeFormattingElements.removeEntry(formattingElementEntry);
    }
    return furthestBlock;
}
//Step 13 of the algorithm
function aaInnerLoop(p, furthestBlock, formattingElement) {
    let lastElement = furthestBlock;
    let nextElement = p.openElements.getCommonAncestor(furthestBlock);
    for (let i = 0, element = nextElement; element !== formattingElement; i++, element = nextElement) {
        //NOTE: store the next element for the next loop iteration (it may be deleted from the stack by step 9.5)
        nextElement = p.openElements.getCommonAncestor(element);
        const elementEntry = p.activeFormattingElements.getElementEntry(element);
        const counterOverflow = elementEntry && i >= AA_INNER_LOOP_ITER;
        const shouldRemoveFromOpenElements = !elementEntry || counterOverflow;
        if (shouldRemoveFromOpenElements) {
            if (counterOverflow) {
                p.activeFormattingElements.removeEntry(elementEntry);
            }
            p.openElements.remove(element);
        }
        else {
            element = aaRecreateElementFromEntry(p, elementEntry);
            if (lastElement === furthestBlock) {
                p.activeFormattingElements.bookmark = elementEntry;
            }
            p.treeAdapter.detachNode(lastElement);
            p.treeAdapter.appendChild(element, lastElement);
            lastElement = element;
        }
    }
    return lastElement;
}
//Step 13.7 of the algorithm
function aaRecreateElementFromEntry(p, elementEntry) {
    const ns = p.treeAdapter.getNamespaceURI(elementEntry.element);
    const newElement = p.treeAdapter.createElement(elementEntry.token.tagName, ns, elementEntry.token.attrs);
    p.openElements.replace(elementEntry.element, newElement);
    elementEntry.element = newElement;
    return newElement;
}
//Step 14 of the algorithm
function aaInsertLastNodeInCommonAncestor(p, commonAncestor, lastElement) {
    const tn = p.treeAdapter.getTagName(commonAncestor);
    const tid = getTagID(tn);
    if (p._isElementCausesFosterParenting(tid)) {
        p._fosterParentElement(lastElement);
    }
    else {
        const ns = p.treeAdapter.getNamespaceURI(commonAncestor);
        if (tid === TAG_ID.TEMPLATE && ns === NS.HTML) {
            commonAncestor = p.treeAdapter.getTemplateContent(commonAncestor);
        }
        p.treeAdapter.appendChild(commonAncestor, lastElement);
    }
}
//Steps 15-19 of the algorithm
function aaReplaceFormattingElement(p, furthestBlock, formattingElementEntry) {
    const ns = p.treeAdapter.getNamespaceURI(formattingElementEntry.element);
    const { token } = formattingElementEntry;
    const newElement = p.treeAdapter.createElement(token.tagName, ns, token.attrs);
    p._adoptNodes(furthestBlock, newElement);
    p.treeAdapter.appendChild(furthestBlock, newElement);
    p.activeFormattingElements.insertElementAfterBookmark(newElement, token);
    p.activeFormattingElements.removeEntry(formattingElementEntry);
    p.openElements.remove(formattingElementEntry.element);
    p.openElements.insertAfter(furthestBlock, newElement, token.tagID);
}
//Algorithm entry point
function callAdoptionAgency(p, token) {
    for (let i = 0; i < AA_OUTER_LOOP_ITER; i++) {
        const formattingElementEntry = aaObtainFormattingElementEntry(p, token);
        if (!formattingElementEntry) {
            break;
        }
        const furthestBlock = aaObtainFurthestBlock(p, formattingElementEntry);
        if (!furthestBlock) {
            break;
        }
        p.activeFormattingElements.bookmark = formattingElementEntry;
        const lastElement = aaInnerLoop(p, furthestBlock, formattingElementEntry.element);
        const commonAncestor = p.openElements.getCommonAncestor(formattingElementEntry.element);
        p.treeAdapter.detachNode(lastElement);
        if (commonAncestor)
            aaInsertLastNodeInCommonAncestor(p, commonAncestor, lastElement);
        aaReplaceFormattingElement(p, furthestBlock, formattingElementEntry);
    }
}
//Generic token handlers
//------------------------------------------------------------------
function appendComment(p, token) {
    p._appendCommentNode(token, p.openElements.currentTmplContentOrNode);
}
function appendCommentToRootHtmlElement(p, token) {
    p._appendCommentNode(token, p.openElements.items[0]);
}
function appendCommentToDocument(p, token) {
    p._appendCommentNode(token, p.document);
}
function stopParsing(p, token) {
    p.stopped = true;
    // NOTE: Set end locations for elements that remain on the open element stack.
    if (token.location) {
        // NOTE: If we are not in a fragment, `html` and `body` will stay on the stack.
        // This is a problem, as we might overwrite their end position here.
        const target = p.fragmentContext ? 0 : 2;
        for (let i = p.openElements.stackTop; i >= target; i--) {
            p._setEndLocation(p.openElements.items[i], token);
        }
        // Handle `html` and `body`
        if (!p.fragmentContext && p.openElements.stackTop >= 0) {
            const htmlElement = p.openElements.items[0];
            const htmlLocation = p.treeAdapter.getNodeSourceCodeLocation(htmlElement);
            if (htmlLocation && !htmlLocation.endTag) {
                p._setEndLocation(htmlElement, token);
                if (p.openElements.stackTop >= 1) {
                    const bodyElement = p.openElements.items[1];
                    const bodyLocation = p.treeAdapter.getNodeSourceCodeLocation(bodyElement);
                    if (bodyLocation && !bodyLocation.endTag) {
                        p._setEndLocation(bodyElement, token);
                    }
                }
            }
        }
    }
}
// The "initial" insertion mode
//------------------------------------------------------------------
function doctypeInInitialMode(p, token) {
    p._setDocumentType(token);
    const mode = token.forceQuirks ? DOCUMENT_MODE.QUIRKS : getDocumentMode(token);
    if (!isConforming(token)) {
        p._err(token, ERR.nonConformingDoctype);
    }
    p.treeAdapter.setDocumentMode(p.document, mode);
    p.insertionMode = InsertionMode.BEFORE_HTML;
}
function tokenInInitialMode(p, token) {
    p._err(token, ERR.missingDoctype, true);
    p.treeAdapter.setDocumentMode(p.document, DOCUMENT_MODE.QUIRKS);
    p.insertionMode = InsertionMode.BEFORE_HTML;
    p._processToken(token);
}
// The "before html" insertion mode
//------------------------------------------------------------------
function startTagBeforeHtml(p, token) {
    if (token.tagID === TAG_ID.HTML) {
        p._insertElement(token, NS.HTML);
        p.insertionMode = InsertionMode.BEFORE_HEAD;
    }
    else {
        tokenBeforeHtml(p, token);
    }
}
function endTagBeforeHtml(p, token) {
    const tn = token.tagID;
    if (tn === TAG_ID.HTML || tn === TAG_ID.HEAD || tn === TAG_ID.BODY || tn === TAG_ID.BR) {
        tokenBeforeHtml(p, token);
    }
}
function tokenBeforeHtml(p, token) {
    p._insertFakeRootElement();
    p.insertionMode = InsertionMode.BEFORE_HEAD;
    p._processToken(token);
}
// The "before head" insertion mode
//------------------------------------------------------------------
function startTagBeforeHead(p, token) {
    switch (token.tagID) {
        case TAG_ID.HTML: {
            startTagInBody(p, token);
            break;
        }
        case TAG_ID.HEAD: {
            p._insertElement(token, NS.HTML);
            p.headElement = p.openElements.current;
            p.insertionMode = InsertionMode.IN_HEAD;
            break;
        }
        default: {
            tokenBeforeHead(p, token);
        }
    }
}
function endTagBeforeHead(p, token) {
    const tn = token.tagID;
    if (tn === TAG_ID.HEAD || tn === TAG_ID.BODY || tn === TAG_ID.HTML || tn === TAG_ID.BR) {
        tokenBeforeHead(p, token);
    }
    else {
        p._err(token, ERR.endTagWithoutMatchingOpenElement);
    }
}
function tokenBeforeHead(p, token) {
    p._insertFakeElement(TAG_NAMES.HEAD, TAG_ID.HEAD);
    p.headElement = p.openElements.current;
    p.insertionMode = InsertionMode.IN_HEAD;
    p._processToken(token);
}
// The "in head" insertion mode
//------------------------------------------------------------------
function startTagInHead(p, token) {
    switch (token.tagID) {
        case TAG_ID.HTML: {
            startTagInBody(p, token);
            break;
        }
        case TAG_ID.BASE:
        case TAG_ID.BASEFONT:
        case TAG_ID.BGSOUND:
        case TAG_ID.LINK:
        case TAG_ID.META: {
            p._appendElement(token, NS.HTML);
            token.ackSelfClosing = true;
            break;
        }
        case TAG_ID.TITLE: {
            p._switchToTextParsing(token, TokenizerMode.RCDATA);
            break;
        }
        case TAG_ID.NOSCRIPT: {
            if (p.options.scriptingEnabled) {
                p._switchToTextParsing(token, TokenizerMode.RAWTEXT);
            }
            else {
                p._insertElement(token, NS.HTML);
                p.insertionMode = InsertionMode.IN_HEAD_NO_SCRIPT;
            }
            break;
        }
        case TAG_ID.NOFRAMES:
        case TAG_ID.STYLE: {
            p._switchToTextParsing(token, TokenizerMode.RAWTEXT);
            break;
        }
        case TAG_ID.SCRIPT: {
            p._switchToTextParsing(token, TokenizerMode.SCRIPT_DATA);
            break;
        }
        case TAG_ID.TEMPLATE: {
            p._insertTemplate(token);
            p.activeFormattingElements.insertMarker();
            p.framesetOk = false;
            p.insertionMode = InsertionMode.IN_TEMPLATE;
            p.tmplInsertionModeStack.unshift(InsertionMode.IN_TEMPLATE);
            break;
        }
        case TAG_ID.HEAD: {
            p._err(token, ERR.misplacedStartTagForHeadElement);
            break;
        }
        default: {
            tokenInHead(p, token);
        }
    }
}
function endTagInHead(p, token) {
    switch (token.tagID) {
        case TAG_ID.HEAD: {
            p.openElements.pop();
            p.insertionMode = InsertionMode.AFTER_HEAD;
            break;
        }
        case TAG_ID.BODY:
        case TAG_ID.BR:
        case TAG_ID.HTML: {
            tokenInHead(p, token);
            break;
        }
        case TAG_ID.TEMPLATE: {
            templateEndTagInHead(p, token);
            break;
        }
        default: {
            p._err(token, ERR.endTagWithoutMatchingOpenElement);
        }
    }
}
function templateEndTagInHead(p, token) {
    if (p.openElements.tmplCount > 0) {
        p.openElements.generateImpliedEndTagsThoroughly();
        if (p.openElements.currentTagId !== TAG_ID.TEMPLATE) {
            p._err(token, ERR.closingOfElementWithOpenChildElements);
        }
        p.openElements.popUntilTagNamePopped(TAG_ID.TEMPLATE);
        p.activeFormattingElements.clearToLastMarker();
        p.tmplInsertionModeStack.shift();
        p._resetInsertionMode();
    }
    else {
        p._err(token, ERR.endTagWithoutMatchingOpenElement);
    }
}
function tokenInHead(p, token) {
    p.openElements.pop();
    p.insertionMode = InsertionMode.AFTER_HEAD;
    p._processToken(token);
}
// The "in head no script" insertion mode
//------------------------------------------------------------------
function startTagInHeadNoScript(p, token) {
    switch (token.tagID) {
        case TAG_ID.HTML: {
            startTagInBody(p, token);
            break;
        }
        case TAG_ID.BASEFONT:
        case TAG_ID.BGSOUND:
        case TAG_ID.HEAD:
        case TAG_ID.LINK:
        case TAG_ID.META:
        case TAG_ID.NOFRAMES:
        case TAG_ID.STYLE: {
            startTagInHead(p, token);
            break;
        }
        case TAG_ID.NOSCRIPT: {
            p._err(token, ERR.nestedNoscriptInHead);
            break;
        }
        default: {
            tokenInHeadNoScript(p, token);
        }
    }
}
function endTagInHeadNoScript(p, token) {
    switch (token.tagID) {
        case TAG_ID.NOSCRIPT: {
            p.openElements.pop();
            p.insertionMode = InsertionMode.IN_HEAD;
            break;
        }
        case TAG_ID.BR: {
            tokenInHeadNoScript(p, token);
            break;
        }
        default: {
            p._err(token, ERR.endTagWithoutMatchingOpenElement);
        }
    }
}
function tokenInHeadNoScript(p, token) {
    const errCode = token.type === TokenType.EOF ? ERR.openElementsLeftAfterEof : ERR.disallowedContentInNoscriptInHead;
    p._err(token, errCode);
    p.openElements.pop();
    p.insertionMode = InsertionMode.IN_HEAD;
    p._processToken(token);
}
// The "after head" insertion mode
//------------------------------------------------------------------
function startTagAfterHead(p, token) {
    switch (token.tagID) {
        case TAG_ID.HTML: {
            startTagInBody(p, token);
            break;
        }
        case TAG_ID.BODY: {
            p._insertElement(token, NS.HTML);
            p.framesetOk = false;
            p.insertionMode = InsertionMode.IN_BODY;
            break;
        }
        case TAG_ID.FRAMESET: {
            p._insertElement(token, NS.HTML);
            p.insertionMode = InsertionMode.IN_FRAMESET;
            break;
        }
        case TAG_ID.BASE:
        case TAG_ID.BASEFONT:
        case TAG_ID.BGSOUND:
        case TAG_ID.LINK:
        case TAG_ID.META:
        case TAG_ID.NOFRAMES:
        case TAG_ID.SCRIPT:
        case TAG_ID.STYLE:
        case TAG_ID.TEMPLATE:
        case TAG_ID.TITLE: {
            p._err(token, ERR.abandonedHeadElementChild);
            p.openElements.push(p.headElement, TAG_ID.HEAD);
            startTagInHead(p, token);
            p.openElements.remove(p.headElement);
            break;
        }
        case TAG_ID.HEAD: {
            p._err(token, ERR.misplacedStartTagForHeadElement);
            break;
        }
        default: {
            tokenAfterHead(p, token);
        }
    }
}
function endTagAfterHead(p, token) {
    switch (token.tagID) {
        case TAG_ID.BODY:
        case TAG_ID.HTML:
        case TAG_ID.BR: {
            tokenAfterHead(p, token);
            break;
        }
        case TAG_ID.TEMPLATE: {
            templateEndTagInHead(p, token);
            break;
        }
        default: {
            p._err(token, ERR.endTagWithoutMatchingOpenElement);
        }
    }
}
function tokenAfterHead(p, token) {
    p._insertFakeElement(TAG_NAMES.BODY, TAG_ID.BODY);
    p.insertionMode = InsertionMode.IN_BODY;
    modeInBody(p, token);
}
// The "in body" insertion mode
//------------------------------------------------------------------
function modeInBody(p, token) {
    switch (token.type) {
        case TokenType.CHARACTER: {
            characterInBody(p, token);
            break;
        }
        case TokenType.WHITESPACE_CHARACTER: {
            whitespaceCharacterInBody(p, token);
            break;
        }
        case TokenType.COMMENT: {
            appendComment(p, token);
            break;
        }
        case TokenType.START_TAG: {
            startTagInBody(p, token);
            break;
        }
        case TokenType.END_TAG: {
            endTagInBody(p, token);
            break;
        }
        case TokenType.EOF: {
            eofInBody(p, token);
            break;
        }
        // Do nothing
    }
}
function whitespaceCharacterInBody(p, token) {
    p._reconstructActiveFormattingElements();
    p._insertCharacters(token);
}
function characterInBody(p, token) {
    p._reconstructActiveFormattingElements();
    p._insertCharacters(token);
    p.framesetOk = false;
}
function htmlStartTagInBody(p, token) {
    if (p.openElements.tmplCount === 0) {
        p.treeAdapter.adoptAttributes(p.openElements.items[0], token.attrs);
    }
}
function bodyStartTagInBody(p, token) {
    const bodyElement = p.openElements.tryPeekProperlyNestedBodyElement();
    if (bodyElement && p.openElements.tmplCount === 0) {
        p.framesetOk = false;
        p.treeAdapter.adoptAttributes(bodyElement, token.attrs);
    }
}
function framesetStartTagInBody(p, token) {
    const bodyElement = p.openElements.tryPeekProperlyNestedBodyElement();
    if (p.framesetOk && bodyElement) {
        p.treeAdapter.detachNode(bodyElement);
        p.openElements.popAllUpToHtmlElement();
        p._insertElement(token, NS.HTML);
        p.insertionMode = InsertionMode.IN_FRAMESET;
    }
}
function addressStartTagInBody(p, token) {
    if (p.openElements.hasInButtonScope(TAG_ID.P)) {
        p._closePElement();
    }
    p._insertElement(token, NS.HTML);
}
function numberedHeaderStartTagInBody(p, token) {
    if (p.openElements.hasInButtonScope(TAG_ID.P)) {
        p._closePElement();
    }
    if (isNumberedHeader(p.openElements.currentTagId)) {
        p.openElements.pop();
    }
    p._insertElement(token, NS.HTML);
}
function preStartTagInBody(p, token) {
    if (p.openElements.hasInButtonScope(TAG_ID.P)) {
        p._closePElement();
    }
    p._insertElement(token, NS.HTML);
    //NOTE: If the next token is a U+000A LINE FEED (LF) character token, then ignore that token and move
    //on to the next one. (Newlines at the start of pre blocks are ignored as an authoring convenience.)
    p.skipNextNewLine = true;
    p.framesetOk = false;
}
function formStartTagInBody(p, token) {
    const inTemplate = p.openElements.tmplCount > 0;
    if (!p.formElement || inTemplate) {
        if (p.openElements.hasInButtonScope(TAG_ID.P)) {
            p._closePElement();
        }
        p._insertElement(token, NS.HTML);
        if (!inTemplate) {
            p.formElement = p.openElements.current;
        }
    }
}
function listItemStartTagInBody(p, token) {
    p.framesetOk = false;
    const tn = token.tagID;
    for (let i = p.openElements.stackTop; i >= 0; i--) {
        const elementId = p.openElements.tagIDs[i];
        if ((tn === TAG_ID.LI && elementId === TAG_ID.LI) ||
            ((tn === TAG_ID.DD || tn === TAG_ID.DT) && (elementId === TAG_ID.DD || elementId === TAG_ID.DT))) {
            p.openElements.generateImpliedEndTagsWithExclusion(elementId);
            p.openElements.popUntilTagNamePopped(elementId);
            break;
        }
        if (elementId !== TAG_ID.ADDRESS &&
            elementId !== TAG_ID.DIV &&
            elementId !== TAG_ID.P &&
            p._isSpecialElement(p.openElements.items[i], elementId)) {
            break;
        }
    }
    if (p.openElements.hasInButtonScope(TAG_ID.P)) {
        p._closePElement();
    }
    p._insertElement(token, NS.HTML);
}
function plaintextStartTagInBody(p, token) {
    if (p.openElements.hasInButtonScope(TAG_ID.P)) {
        p._closePElement();
    }
    p._insertElement(token, NS.HTML);
    p.tokenizer.state = TokenizerMode.PLAINTEXT;
}
function buttonStartTagInBody(p, token) {
    if (p.openElements.hasInScope(TAG_ID.BUTTON)) {
        p.openElements.generateImpliedEndTags();
        p.openElements.popUntilTagNamePopped(TAG_ID.BUTTON);
    }
    p._reconstructActiveFormattingElements();
    p._insertElement(token, NS.HTML);
    p.framesetOk = false;
}
function aStartTagInBody(p, token) {
    const activeElementEntry = p.activeFormattingElements.getElementEntryInScopeWithTagName(TAG_NAMES.A);
    if (activeElementEntry) {
        callAdoptionAgency(p, token);
        p.openElements.remove(activeElementEntry.element);
        p.activeFormattingElements.removeEntry(activeElementEntry);
    }
    p._reconstructActiveFormattingElements();
    p._insertElement(token, NS.HTML);
    p.activeFormattingElements.pushElement(p.openElements.current, token);
}
function bStartTagInBody(p, token) {
    p._reconstructActiveFormattingElements();
    p._insertElement(token, NS.HTML);
    p.activeFormattingElements.pushElement(p.openElements.current, token);
}
function nobrStartTagInBody(p, token) {
    p._reconstructActiveFormattingElements();
    if (p.openElements.hasInScope(TAG_ID.NOBR)) {
        callAdoptionAgency(p, token);
        p._reconstructActiveFormattingElements();
    }
    p._insertElement(token, NS.HTML);
    p.activeFormattingElements.pushElement(p.openElements.current, token);
}
function appletStartTagInBody(p, token) {
    p._reconstructActiveFormattingElements();
    p._insertElement(token, NS.HTML);
    p.activeFormattingElements.insertMarker();
    p.framesetOk = false;
}
function tableStartTagInBody(p, token) {
    if (p.treeAdapter.getDocumentMode(p.document) !== DOCUMENT_MODE.QUIRKS && p.openElements.hasInButtonScope(TAG_ID.P)) {
        p._closePElement();
    }
    p._insertElement(token, NS.HTML);
    p.framesetOk = false;
    p.insertionMode = InsertionMode.IN_TABLE;
}
function areaStartTagInBody(p, token) {
    p._reconstructActiveFormattingElements();
    p._appendElement(token, NS.HTML);
    p.framesetOk = false;
    token.ackSelfClosing = true;
}
function isHiddenInput(token) {
    const inputType = getTokenAttr(token, ATTRS.TYPE);
    return inputType != null && inputType.toLowerCase() === HIDDEN_INPUT_TYPE;
}
function inputStartTagInBody(p, token) {
    p._reconstructActiveFormattingElements();
    p._appendElement(token, NS.HTML);
    if (!isHiddenInput(token)) {
        p.framesetOk = false;
    }
    token.ackSelfClosing = true;
}
function paramStartTagInBody(p, token) {
    p._appendElement(token, NS.HTML);
    token.ackSelfClosing = true;
}
function hrStartTagInBody(p, token) {
    if (p.openElements.hasInButtonScope(TAG_ID.P)) {
        p._closePElement();
    }
    p._appendElement(token, NS.HTML);
    p.framesetOk = false;
    token.ackSelfClosing = true;
}
function imageStartTagInBody(p, token) {
    token.tagName = TAG_NAMES.IMG;
    token.tagID = TAG_ID.IMG;
    areaStartTagInBody(p, token);
}
function textareaStartTagInBody(p, token) {
    p._insertElement(token, NS.HTML);
    //NOTE: If the next token is a U+000A LINE FEED (LF) character token, then ignore that token and move
    //on to the next one. (Newlines at the start of textarea elements are ignored as an authoring convenience.)
    p.skipNextNewLine = true;
    p.tokenizer.state = TokenizerMode.RCDATA;
    p.originalInsertionMode = p.insertionMode;
    p.framesetOk = false;
    p.insertionMode = InsertionMode.TEXT;
}
function xmpStartTagInBody(p, token) {
    if (p.openElements.hasInButtonScope(TAG_ID.P)) {
        p._closePElement();
    }
    p._reconstructActiveFormattingElements();
    p.framesetOk = false;
    p._switchToTextParsing(token, TokenizerMode.RAWTEXT);
}
function iframeStartTagInBody(p, token) {
    p.framesetOk = false;
    p._switchToTextParsing(token, TokenizerMode.RAWTEXT);
}
//NOTE: here we assume that we always act as an user agent with enabled plugins, so we parse
//<noembed> as rawtext.
function noembedStartTagInBody(p, token) {
    p._switchToTextParsing(token, TokenizerMode.RAWTEXT);
}
function selectStartTagInBody(p, token) {
    p._reconstructActiveFormattingElements();
    p._insertElement(token, NS.HTML);
    p.framesetOk = false;
    p.insertionMode =
        p.insertionMode === InsertionMode.IN_TABLE ||
            p.insertionMode === InsertionMode.IN_CAPTION ||
            p.insertionMode === InsertionMode.IN_TABLE_BODY ||
            p.insertionMode === InsertionMode.IN_ROW ||
            p.insertionMode === InsertionMode.IN_CELL
            ? InsertionMode.IN_SELECT_IN_TABLE
            : InsertionMode.IN_SELECT;
}
function optgroupStartTagInBody(p, token) {
    if (p.openElements.currentTagId === TAG_ID.OPTION) {
        p.openElements.pop();
    }
    p._reconstructActiveFormattingElements();
    p._insertElement(token, NS.HTML);
}
function rbStartTagInBody(p, token) {
    if (p.openElements.hasInScope(TAG_ID.RUBY)) {
        p.openElements.generateImpliedEndTags();
    }
    p._insertElement(token, NS.HTML);
}
function rtStartTagInBody(p, token) {
    if (p.openElements.hasInScope(TAG_ID.RUBY)) {
        p.openElements.generateImpliedEndTagsWithExclusion(TAG_ID.RTC);
    }
    p._insertElement(token, NS.HTML);
}
function mathStartTagInBody(p, token) {
    p._reconstructActiveFormattingElements();
    adjustTokenMathMLAttrs(token);
    adjustTokenXMLAttrs(token);
    if (token.selfClosing) {
        p._appendElement(token, NS.MATHML);
    }
    else {
        p._insertElement(token, NS.MATHML);
    }
    token.ackSelfClosing = true;
}
function svgStartTagInBody(p, token) {
    p._reconstructActiveFormattingElements();
    adjustTokenSVGAttrs(token);
    adjustTokenXMLAttrs(token);
    if (token.selfClosing) {
        p._appendElement(token, NS.SVG);
    }
    else {
        p._insertElement(token, NS.SVG);
    }
    token.ackSelfClosing = true;
}
function genericStartTagInBody(p, token) {
    p._reconstructActiveFormattingElements();
    p._insertElement(token, NS.HTML);
}
function startTagInBody(p, token) {
    switch (token.tagID) {
        case TAG_ID.I:
        case TAG_ID.S:
        case TAG_ID.B:
        case TAG_ID.U:
        case TAG_ID.EM:
        case TAG_ID.TT:
        case TAG_ID.BIG:
        case TAG_ID.CODE:
        case TAG_ID.FONT:
        case TAG_ID.SMALL:
        case TAG_ID.STRIKE:
        case TAG_ID.STRONG: {
            bStartTagInBody(p, token);
            break;
        }
        case TAG_ID.A: {
            aStartTagInBody(p, token);
            break;
        }
        case TAG_ID.H1:
        case TAG_ID.H2:
        case TAG_ID.H3:
        case TAG_ID.H4:
        case TAG_ID.H5:
        case TAG_ID.H6: {
            numberedHeaderStartTagInBody(p, token);
            break;
        }
        case TAG_ID.P:
        case TAG_ID.DL:
        case TAG_ID.OL:
        case TAG_ID.UL:
        case TAG_ID.DIV:
        case TAG_ID.DIR:
        case TAG_ID.NAV:
        case TAG_ID.MAIN:
        case TAG_ID.MENU:
        case TAG_ID.ASIDE:
        case TAG_ID.CENTER:
        case TAG_ID.FIGURE:
        case TAG_ID.FOOTER:
        case TAG_ID.HEADER:
        case TAG_ID.HGROUP:
        case TAG_ID.DIALOG:
        case TAG_ID.DETAILS:
        case TAG_ID.ADDRESS:
        case TAG_ID.ARTICLE:
        case TAG_ID.SECTION:
        case TAG_ID.SUMMARY:
        case TAG_ID.FIELDSET:
        case TAG_ID.BLOCKQUOTE:
        case TAG_ID.FIGCAPTION: {
            addressStartTagInBody(p, token);
            break;
        }
        case TAG_ID.LI:
        case TAG_ID.DD:
        case TAG_ID.DT: {
            listItemStartTagInBody(p, token);
            break;
        }
        case TAG_ID.BR:
        case TAG_ID.IMG:
        case TAG_ID.WBR:
        case TAG_ID.AREA:
        case TAG_ID.EMBED:
        case TAG_ID.KEYGEN: {
            areaStartTagInBody(p, token);
            break;
        }
        case TAG_ID.HR: {
            hrStartTagInBody(p, token);
            break;
        }
        case TAG_ID.RB:
        case TAG_ID.RTC: {
            rbStartTagInBody(p, token);
            break;
        }
        case TAG_ID.RT:
        case TAG_ID.RP: {
            rtStartTagInBody(p, token);
            break;
        }
        case TAG_ID.PRE:
        case TAG_ID.LISTING: {
            preStartTagInBody(p, token);
            break;
        }
        case TAG_ID.XMP: {
            xmpStartTagInBody(p, token);
            break;
        }
        case TAG_ID.SVG: {
            svgStartTagInBody(p, token);
            break;
        }
        case TAG_ID.HTML: {
            htmlStartTagInBody(p, token);
            break;
        }
        case TAG_ID.BASE:
        case TAG_ID.LINK:
        case TAG_ID.META:
        case TAG_ID.STYLE:
        case TAG_ID.TITLE:
        case TAG_ID.SCRIPT:
        case TAG_ID.BGSOUND:
        case TAG_ID.BASEFONT:
        case TAG_ID.TEMPLATE: {
            startTagInHead(p, token);
            break;
        }
        case TAG_ID.BODY: {
            bodyStartTagInBody(p, token);
            break;
        }
        case TAG_ID.FORM: {
            formStartTagInBody(p, token);
            break;
        }
        case TAG_ID.NOBR: {
            nobrStartTagInBody(p, token);
            break;
        }
        case TAG_ID.MATH: {
            mathStartTagInBody(p, token);
            break;
        }
        case TAG_ID.TABLE: {
            tableStartTagInBody(p, token);
            break;
        }
        case TAG_ID.INPUT: {
            inputStartTagInBody(p, token);
            break;
        }
        case TAG_ID.PARAM:
        case TAG_ID.TRACK:
        case TAG_ID.SOURCE: {
            paramStartTagInBody(p, token);
            break;
        }
        case TAG_ID.IMAGE: {
            imageStartTagInBody(p, token);
            break;
        }
        case TAG_ID.BUTTON: {
            buttonStartTagInBody(p, token);
            break;
        }
        case TAG_ID.APPLET:
        case TAG_ID.OBJECT:
        case TAG_ID.MARQUEE: {
            appletStartTagInBody(p, token);
            break;
        }
        case TAG_ID.IFRAME: {
            iframeStartTagInBody(p, token);
            break;
        }
        case TAG_ID.SELECT: {
            selectStartTagInBody(p, token);
            break;
        }
        case TAG_ID.OPTION:
        case TAG_ID.OPTGROUP: {
            optgroupStartTagInBody(p, token);
            break;
        }
        case TAG_ID.NOEMBED: {
            noembedStartTagInBody(p, token);
            break;
        }
        case TAG_ID.FRAMESET: {
            framesetStartTagInBody(p, token);
            break;
        }
        case TAG_ID.TEXTAREA: {
            textareaStartTagInBody(p, token);
            break;
        }
        case TAG_ID.NOSCRIPT: {
            if (p.options.scriptingEnabled) {
                noembedStartTagInBody(p, token);
            }
            else {
                genericStartTagInBody(p, token);
            }
            break;
        }
        case TAG_ID.PLAINTEXT: {
            plaintextStartTagInBody(p, token);
            break;
        }
        case TAG_ID.COL:
        case TAG_ID.TH:
        case TAG_ID.TD:
        case TAG_ID.TR:
        case TAG_ID.HEAD:
        case TAG_ID.FRAME:
        case TAG_ID.TBODY:
        case TAG_ID.TFOOT:
        case TAG_ID.THEAD:
        case TAG_ID.CAPTION:
        case TAG_ID.COLGROUP: {
            // Ignore token
            break;
        }
        default: {
            genericStartTagInBody(p, token);
        }
    }
}
function bodyEndTagInBody(p, token) {
    if (p.openElements.hasInScope(TAG_ID.BODY)) {
        p.insertionMode = InsertionMode.AFTER_BODY;
        //NOTE: <body> is never popped from the stack, so we need to updated
        //the end location explicitly.
        if (p.options.sourceCodeLocationInfo) {
            const bodyElement = p.openElements.tryPeekProperlyNestedBodyElement();
            if (bodyElement) {
                p._setEndLocation(bodyElement, token);
            }
        }
    }
}
function htmlEndTagInBody(p, token) {
    if (p.openElements.hasInScope(TAG_ID.BODY)) {
        p.insertionMode = InsertionMode.AFTER_BODY;
        endTagAfterBody(p, token);
    }
}
function addressEndTagInBody(p, token) {
    const tn = token.tagID;
    if (p.openElements.hasInScope(tn)) {
        p.openElements.generateImpliedEndTags();
        p.openElements.popUntilTagNamePopped(tn);
    }
}
function formEndTagInBody(p) {
    const inTemplate = p.openElements.tmplCount > 0;
    const { formElement } = p;
    if (!inTemplate) {
        p.formElement = null;
    }
    if ((formElement || inTemplate) && p.openElements.hasInScope(TAG_ID.FORM)) {
        p.openElements.generateImpliedEndTags();
        if (inTemplate) {
            p.openElements.popUntilTagNamePopped(TAG_ID.FORM);
        }
        else if (formElement) {
            p.openElements.remove(formElement);
        }
    }
}
function pEndTagInBody(p) {
    if (!p.openElements.hasInButtonScope(TAG_ID.P)) {
        p._insertFakeElement(TAG_NAMES.P, TAG_ID.P);
    }
    p._closePElement();
}
function liEndTagInBody(p) {
    if (p.openElements.hasInListItemScope(TAG_ID.LI)) {
        p.openElements.generateImpliedEndTagsWithExclusion(TAG_ID.LI);
        p.openElements.popUntilTagNamePopped(TAG_ID.LI);
    }
}
function ddEndTagInBody(p, token) {
    const tn = token.tagID;
    if (p.openElements.hasInScope(tn)) {
        p.openElements.generateImpliedEndTagsWithExclusion(tn);
        p.openElements.popUntilTagNamePopped(tn);
    }
}
function numberedHeaderEndTagInBody(p) {
    if (p.openElements.hasNumberedHeaderInScope()) {
        p.openElements.generateImpliedEndTags();
        p.openElements.popUntilNumberedHeaderPopped();
    }
}
function appletEndTagInBody(p, token) {
    const tn = token.tagID;
    if (p.openElements.hasInScope(tn)) {
        p.openElements.generateImpliedEndTags();
        p.openElements.popUntilTagNamePopped(tn);
        p.activeFormattingElements.clearToLastMarker();
    }
}
function brEndTagInBody(p) {
    p._reconstructActiveFormattingElements();
    p._insertFakeElement(TAG_NAMES.BR, TAG_ID.BR);
    p.openElements.pop();
    p.framesetOk = false;
}
function genericEndTagInBody(p, token) {
    const tn = token.tagName;
    const tid = token.tagID;
    for (let i = p.openElements.stackTop; i > 0; i--) {
        const element = p.openElements.items[i];
        const elementId = p.openElements.tagIDs[i];
        // Compare the tag name here, as the tag might not be a known tag with an ID.
        if (tid === elementId && (tid !== TAG_ID.UNKNOWN || p.treeAdapter.getTagName(element) === tn)) {
            p.openElements.generateImpliedEndTagsWithExclusion(tid);
            if (p.openElements.stackTop >= i)
                p.openElements.shortenToLength(i);
            break;
        }
        if (p._isSpecialElement(element, elementId)) {
            break;
        }
    }
}
function endTagInBody(p, token) {
    switch (token.tagID) {
        case TAG_ID.A:
        case TAG_ID.B:
        case TAG_ID.I:
        case TAG_ID.S:
        case TAG_ID.U:
        case TAG_ID.EM:
        case TAG_ID.TT:
        case TAG_ID.BIG:
        case TAG_ID.CODE:
        case TAG_ID.FONT:
        case TAG_ID.NOBR:
        case TAG_ID.SMALL:
        case TAG_ID.STRIKE:
        case TAG_ID.STRONG: {
            callAdoptionAgency(p, token);
            break;
        }
        case TAG_ID.P: {
            pEndTagInBody(p);
            break;
        }
        case TAG_ID.DL:
        case TAG_ID.UL:
        case TAG_ID.OL:
        case TAG_ID.DIR:
        case TAG_ID.DIV:
        case TAG_ID.NAV:
        case TAG_ID.PRE:
        case TAG_ID.MAIN:
        case TAG_ID.MENU:
        case TAG_ID.ASIDE:
        case TAG_ID.BUTTON:
        case TAG_ID.CENTER:
        case TAG_ID.FIGURE:
        case TAG_ID.FOOTER:
        case TAG_ID.HEADER:
        case TAG_ID.HGROUP:
        case TAG_ID.DIALOG:
        case TAG_ID.ADDRESS:
        case TAG_ID.ARTICLE:
        case TAG_ID.DETAILS:
        case TAG_ID.SECTION:
        case TAG_ID.SUMMARY:
        case TAG_ID.LISTING:
        case TAG_ID.FIELDSET:
        case TAG_ID.BLOCKQUOTE:
        case TAG_ID.FIGCAPTION: {
            addressEndTagInBody(p, token);
            break;
        }
        case TAG_ID.LI: {
            liEndTagInBody(p);
            break;
        }
        case TAG_ID.DD:
        case TAG_ID.DT: {
            ddEndTagInBody(p, token);
            break;
        }
        case TAG_ID.H1:
        case TAG_ID.H2:
        case TAG_ID.H3:
        case TAG_ID.H4:
        case TAG_ID.H5:
        case TAG_ID.H6: {
            numberedHeaderEndTagInBody(p);
            break;
        }
        case TAG_ID.BR: {
            brEndTagInBody(p);
            break;
        }
        case TAG_ID.BODY: {
            bodyEndTagInBody(p, token);
            break;
        }
        case TAG_ID.HTML: {
            htmlEndTagInBody(p, token);
            break;
        }
        case TAG_ID.FORM: {
            formEndTagInBody(p);
            break;
        }
        case TAG_ID.APPLET:
        case TAG_ID.OBJECT:
        case TAG_ID.MARQUEE: {
            appletEndTagInBody(p, token);
            break;
        }
        case TAG_ID.TEMPLATE: {
            templateEndTagInHead(p, token);
            break;
        }
        default: {
            genericEndTagInBody(p, token);
        }
    }
}
function eofInBody(p, token) {
    if (p.tmplInsertionModeStack.length > 0) {
        eofInTemplate(p, token);
    }
    else {
        stopParsing(p, token);
    }
}
// The "text" insertion mode
//------------------------------------------------------------------
function endTagInText(p, token) {
    var _a;
    if (token.tagID === TAG_ID.SCRIPT) {
        (_a = p.scriptHandler) === null || _a === void 0 ? void 0 : _a.call(p, p.openElements.current);
    }
    p.openElements.pop();
    p.insertionMode = p.originalInsertionMode;
}
function eofInText(p, token) {
    p._err(token, ERR.eofInElementThatCanContainOnlyText);
    p.openElements.pop();
    p.insertionMode = p.originalInsertionMode;
    p.onEof(token);
}
// The "in table" insertion mode
//------------------------------------------------------------------
function characterInTable(p, token) {
    if (TABLE_STRUCTURE_TAGS.has(p.openElements.currentTagId)) {
        p.pendingCharacterTokens.length = 0;
        p.hasNonWhitespacePendingCharacterToken = false;
        p.originalInsertionMode = p.insertionMode;
        p.insertionMode = InsertionMode.IN_TABLE_TEXT;
        switch (token.type) {
            case TokenType.CHARACTER: {
                characterInTableText(p, token);
                break;
            }
            case TokenType.WHITESPACE_CHARACTER: {
                whitespaceCharacterInTableText(p, token);
                break;
            }
            // Ignore null
        }
    }
    else {
        tokenInTable(p, token);
    }
}
function captionStartTagInTable(p, token) {
    p.openElements.clearBackToTableContext();
    p.activeFormattingElements.insertMarker();
    p._insertElement(token, NS.HTML);
    p.insertionMode = InsertionMode.IN_CAPTION;
}
function colgroupStartTagInTable(p, token) {
    p.openElements.clearBackToTableContext();
    p._insertElement(token, NS.HTML);
    p.insertionMode = InsertionMode.IN_COLUMN_GROUP;
}
function colStartTagInTable(p, token) {
    p.openElements.clearBackToTableContext();
    p._insertFakeElement(TAG_NAMES.COLGROUP, TAG_ID.COLGROUP);
    p.insertionMode = InsertionMode.IN_COLUMN_GROUP;
    startTagInColumnGroup(p, token);
}
function tbodyStartTagInTable(p, token) {
    p.openElements.clearBackToTableContext();
    p._insertElement(token, NS.HTML);
    p.insertionMode = InsertionMode.IN_TABLE_BODY;
}
function tdStartTagInTable(p, token) {
    p.openElements.clearBackToTableContext();
    p._insertFakeElement(TAG_NAMES.TBODY, TAG_ID.TBODY);
    p.insertionMode = InsertionMode.IN_TABLE_BODY;
    startTagInTableBody(p, token);
}
function tableStartTagInTable(p, token) {
    if (p.openElements.hasInTableScope(TAG_ID.TABLE)) {
        p.openElements.popUntilTagNamePopped(TAG_ID.TABLE);
        p._resetInsertionMode();
        p._processStartTag(token);
    }
}
function inputStartTagInTable(p, token) {
    if (isHiddenInput(token)) {
        p._appendElement(token, NS.HTML);
    }
    else {
        tokenInTable(p, token);
    }
    token.ackSelfClosing = true;
}
function formStartTagInTable(p, token) {
    if (!p.formElement && p.openElements.tmplCount === 0) {
        p._insertElement(token, NS.HTML);
        p.formElement = p.openElements.current;
        p.openElements.pop();
    }
}
function startTagInTable(p, token) {
    switch (token.tagID) {
        case TAG_ID.TD:
        case TAG_ID.TH:
        case TAG_ID.TR: {
            tdStartTagInTable(p, token);
            break;
        }
        case TAG_ID.STYLE:
        case TAG_ID.SCRIPT:
        case TAG_ID.TEMPLATE: {
            startTagInHead(p, token);
            break;
        }
        case TAG_ID.COL: {
            colStartTagInTable(p, token);
            break;
        }
        case TAG_ID.FORM: {
            formStartTagInTable(p, token);
            break;
        }
        case TAG_ID.TABLE: {
            tableStartTagInTable(p, token);
            break;
        }
        case TAG_ID.TBODY:
        case TAG_ID.TFOOT:
        case TAG_ID.THEAD: {
            tbodyStartTagInTable(p, token);
            break;
        }
        case TAG_ID.INPUT: {
            inputStartTagInTable(p, token);
            break;
        }
        case TAG_ID.CAPTION: {
            captionStartTagInTable(p, token);
            break;
        }
        case TAG_ID.COLGROUP: {
            colgroupStartTagInTable(p, token);
            break;
        }
        default: {
            tokenInTable(p, token);
        }
    }
}
function endTagInTable(p, token) {
    switch (token.tagID) {
        case TAG_ID.TABLE: {
            if (p.openElements.hasInTableScope(TAG_ID.TABLE)) {
                p.openElements.popUntilTagNamePopped(TAG_ID.TABLE);
                p._resetInsertionMode();
            }
            break;
        }
        case TAG_ID.TEMPLATE: {
            templateEndTagInHead(p, token);
            break;
        }
        case TAG_ID.BODY:
        case TAG_ID.CAPTION:
        case TAG_ID.COL:
        case TAG_ID.COLGROUP:
        case TAG_ID.HTML:
        case TAG_ID.TBODY:
        case TAG_ID.TD:
        case TAG_ID.TFOOT:
        case TAG_ID.TH:
        case TAG_ID.THEAD:
        case TAG_ID.TR: {
            // Ignore token
            break;
        }
        default: {
            tokenInTable(p, token);
        }
    }
}
function tokenInTable(p, token) {
    const savedFosterParentingState = p.fosterParentingEnabled;
    p.fosterParentingEnabled = true;
    // Process token in `In Body` mode
    modeInBody(p, token);
    p.fosterParentingEnabled = savedFosterParentingState;
}
// The "in table text" insertion mode
//------------------------------------------------------------------
function whitespaceCharacterInTableText(p, token) {
    p.pendingCharacterTokens.push(token);
}
function characterInTableText(p, token) {
    p.pendingCharacterTokens.push(token);
    p.hasNonWhitespacePendingCharacterToken = true;
}
function tokenInTableText(p, token) {
    let i = 0;
    if (p.hasNonWhitespacePendingCharacterToken) {
        for (; i < p.pendingCharacterTokens.length; i++) {
            tokenInTable(p, p.pendingCharacterTokens[i]);
        }
    }
    else {
        for (; i < p.pendingCharacterTokens.length; i++) {
            p._insertCharacters(p.pendingCharacterTokens[i]);
        }
    }
    p.insertionMode = p.originalInsertionMode;
    p._processToken(token);
}
// The "in caption" insertion mode
//------------------------------------------------------------------
const TABLE_VOID_ELEMENTS = new Set([TAG_ID.CAPTION, TAG_ID.COL, TAG_ID.COLGROUP, TAG_ID.TBODY, TAG_ID.TD, TAG_ID.TFOOT, TAG_ID.TH, TAG_ID.THEAD, TAG_ID.TR]);
function startTagInCaption(p, token) {
    const tn = token.tagID;
    if (TABLE_VOID_ELEMENTS.has(tn)) {
        if (p.openElements.hasInTableScope(TAG_ID.CAPTION)) {
            p.openElements.generateImpliedEndTags();
            p.openElements.popUntilTagNamePopped(TAG_ID.CAPTION);
            p.activeFormattingElements.clearToLastMarker();
            p.insertionMode = InsertionMode.IN_TABLE;
            startTagInTable(p, token);
        }
    }
    else {
        startTagInBody(p, token);
    }
}
function endTagInCaption(p, token) {
    const tn = token.tagID;
    switch (tn) {
        case TAG_ID.CAPTION:
        case TAG_ID.TABLE: {
            if (p.openElements.hasInTableScope(TAG_ID.CAPTION)) {
                p.openElements.generateImpliedEndTags();
                p.openElements.popUntilTagNamePopped(TAG_ID.CAPTION);
                p.activeFormattingElements.clearToLastMarker();
                p.insertionMode = InsertionMode.IN_TABLE;
                if (tn === TAG_ID.TABLE) {
                    endTagInTable(p, token);
                }
            }
            break;
        }
        case TAG_ID.BODY:
        case TAG_ID.COL:
        case TAG_ID.COLGROUP:
        case TAG_ID.HTML:
        case TAG_ID.TBODY:
        case TAG_ID.TD:
        case TAG_ID.TFOOT:
        case TAG_ID.TH:
        case TAG_ID.THEAD:
        case TAG_ID.TR: {
            // Ignore token
            break;
        }
        default: {
            endTagInBody(p, token);
        }
    }
}
// The "in column group" insertion mode
//------------------------------------------------------------------
function startTagInColumnGroup(p, token) {
    switch (token.tagID) {
        case TAG_ID.HTML: {
            startTagInBody(p, token);
            break;
        }
        case TAG_ID.COL: {
            p._appendElement(token, NS.HTML);
            token.ackSelfClosing = true;
            break;
        }
        case TAG_ID.TEMPLATE: {
            startTagInHead(p, token);
            break;
        }
        default: {
            tokenInColumnGroup(p, token);
        }
    }
}
function endTagInColumnGroup(p, token) {
    switch (token.tagID) {
        case TAG_ID.COLGROUP: {
            if (p.openElements.currentTagId === TAG_ID.COLGROUP) {
                p.openElements.pop();
                p.insertionMode = InsertionMode.IN_TABLE;
            }
            break;
        }
        case TAG_ID.TEMPLATE: {
            templateEndTagInHead(p, token);
            break;
        }
        case TAG_ID.COL: {
            // Ignore token
            break;
        }
        default: {
            tokenInColumnGroup(p, token);
        }
    }
}
function tokenInColumnGroup(p, token) {
    if (p.openElements.currentTagId === TAG_ID.COLGROUP) {
        p.openElements.pop();
        p.insertionMode = InsertionMode.IN_TABLE;
        p._processToken(token);
    }
}
// The "in table body" insertion mode
//------------------------------------------------------------------
function startTagInTableBody(p, token) {
    switch (token.tagID) {
        case TAG_ID.TR: {
            p.openElements.clearBackToTableBodyContext();
            p._insertElement(token, NS.HTML);
            p.insertionMode = InsertionMode.IN_ROW;
            break;
        }
        case TAG_ID.TH:
        case TAG_ID.TD: {
            p.openElements.clearBackToTableBodyContext();
            p._insertFakeElement(TAG_NAMES.TR, TAG_ID.TR);
            p.insertionMode = InsertionMode.IN_ROW;
            startTagInRow(p, token);
            break;
        }
        case TAG_ID.CAPTION:
        case TAG_ID.COL:
        case TAG_ID.COLGROUP:
        case TAG_ID.TBODY:
        case TAG_ID.TFOOT:
        case TAG_ID.THEAD: {
            if (p.openElements.hasTableBodyContextInTableScope()) {
                p.openElements.clearBackToTableBodyContext();
                p.openElements.pop();
                p.insertionMode = InsertionMode.IN_TABLE;
                startTagInTable(p, token);
            }
            break;
        }
        default: {
            startTagInTable(p, token);
        }
    }
}
function endTagInTableBody(p, token) {
    const tn = token.tagID;
    switch (token.tagID) {
        case TAG_ID.TBODY:
        case TAG_ID.TFOOT:
        case TAG_ID.THEAD: {
            if (p.openElements.hasInTableScope(tn)) {
                p.openElements.clearBackToTableBodyContext();
                p.openElements.pop();
                p.insertionMode = InsertionMode.IN_TABLE;
            }
            break;
        }
        case TAG_ID.TABLE: {
            if (p.openElements.hasTableBodyContextInTableScope()) {
                p.openElements.clearBackToTableBodyContext();
                p.openElements.pop();
                p.insertionMode = InsertionMode.IN_TABLE;
                endTagInTable(p, token);
            }
            break;
        }
        case TAG_ID.BODY:
        case TAG_ID.CAPTION:
        case TAG_ID.COL:
        case TAG_ID.COLGROUP:
        case TAG_ID.HTML:
        case TAG_ID.TD:
        case TAG_ID.TH:
        case TAG_ID.TR: {
            // Ignore token
            break;
        }
        default: {
            endTagInTable(p, token);
        }
    }
}
// The "in row" insertion mode
//------------------------------------------------------------------
function startTagInRow(p, token) {
    switch (token.tagID) {
        case TAG_ID.TH:
        case TAG_ID.TD: {
            p.openElements.clearBackToTableRowContext();
            p._insertElement(token, NS.HTML);
            p.insertionMode = InsertionMode.IN_CELL;
            p.activeFormattingElements.insertMarker();
            break;
        }
        case TAG_ID.CAPTION:
        case TAG_ID.COL:
        case TAG_ID.COLGROUP:
        case TAG_ID.TBODY:
        case TAG_ID.TFOOT:
        case TAG_ID.THEAD:
        case TAG_ID.TR: {
            if (p.openElements.hasInTableScope(TAG_ID.TR)) {
                p.openElements.clearBackToTableRowContext();
                p.openElements.pop();
                p.insertionMode = InsertionMode.IN_TABLE_BODY;
                startTagInTableBody(p, token);
            }
            break;
        }
        default: {
            startTagInTable(p, token);
        }
    }
}
function endTagInRow(p, token) {
    switch (token.tagID) {
        case TAG_ID.TR: {
            if (p.openElements.hasInTableScope(TAG_ID.TR)) {
                p.openElements.clearBackToTableRowContext();
                p.openElements.pop();
                p.insertionMode = InsertionMode.IN_TABLE_BODY;
            }
            break;
        }
        case TAG_ID.TABLE: {
            if (p.openElements.hasInTableScope(TAG_ID.TR)) {
                p.openElements.clearBackToTableRowContext();
                p.openElements.pop();
                p.insertionMode = InsertionMode.IN_TABLE_BODY;
                endTagInTableBody(p, token);
            }
            break;
        }
        case TAG_ID.TBODY:
        case TAG_ID.TFOOT:
        case TAG_ID.THEAD: {
            if (p.openElements.hasInTableScope(token.tagID) || p.openElements.hasInTableScope(TAG_ID.TR)) {
                p.openElements.clearBackToTableRowContext();
                p.openElements.pop();
                p.insertionMode = InsertionMode.IN_TABLE_BODY;
                endTagInTableBody(p, token);
            }
            break;
        }
        case TAG_ID.BODY:
        case TAG_ID.CAPTION:
        case TAG_ID.COL:
        case TAG_ID.COLGROUP:
        case TAG_ID.HTML:
        case TAG_ID.TD:
        case TAG_ID.TH: {
            // Ignore end tag
            break;
        }
        default: {
            endTagInTable(p, token);
        }
    }
}
// The "in cell" insertion mode
//------------------------------------------------------------------
function startTagInCell(p, token) {
    const tn = token.tagID;
    if (TABLE_VOID_ELEMENTS.has(tn)) {
        if (p.openElements.hasInTableScope(TAG_ID.TD) || p.openElements.hasInTableScope(TAG_ID.TH)) {
            p._closeTableCell();
            startTagInRow(p, token);
        }
    }
    else {
        startTagInBody(p, token);
    }
}
function endTagInCell(p, token) {
    const tn = token.tagID;
    switch (tn) {
        case TAG_ID.TD:
        case TAG_ID.TH: {
            if (p.openElements.hasInTableScope(tn)) {
                p.openElements.generateImpliedEndTags();
                p.openElements.popUntilTagNamePopped(tn);
                p.activeFormattingElements.clearToLastMarker();
                p.insertionMode = InsertionMode.IN_ROW;
            }
            break;
        }
        case TAG_ID.TABLE:
        case TAG_ID.TBODY:
        case TAG_ID.TFOOT:
        case TAG_ID.THEAD:
        case TAG_ID.TR: {
            if (p.openElements.hasInTableScope(tn)) {
                p._closeTableCell();
                endTagInRow(p, token);
            }
            break;
        }
        case TAG_ID.BODY:
        case TAG_ID.CAPTION:
        case TAG_ID.COL:
        case TAG_ID.COLGROUP:
        case TAG_ID.HTML: {
            // Ignore token
            break;
        }
        default: {
            endTagInBody(p, token);
        }
    }
}
// The "in select" insertion mode
//------------------------------------------------------------------
function startTagInSelect(p, token) {
    switch (token.tagID) {
        case TAG_ID.HTML: {
            startTagInBody(p, token);
            break;
        }
        case TAG_ID.OPTION: {
            if (p.openElements.currentTagId === TAG_ID.OPTION) {
                p.openElements.pop();
            }
            p._insertElement(token, NS.HTML);
            break;
        }
        case TAG_ID.OPTGROUP: {
            if (p.openElements.currentTagId === TAG_ID.OPTION) {
                p.openElements.pop();
            }
            if (p.openElements.currentTagId === TAG_ID.OPTGROUP) {
                p.openElements.pop();
            }
            p._insertElement(token, NS.HTML);
            break;
        }
        case TAG_ID.INPUT:
        case TAG_ID.KEYGEN:
        case TAG_ID.TEXTAREA:
        case TAG_ID.SELECT: {
            if (p.openElements.hasInSelectScope(TAG_ID.SELECT)) {
                p.openElements.popUntilTagNamePopped(TAG_ID.SELECT);
                p._resetInsertionMode();
                if (token.tagID !== TAG_ID.SELECT) {
                    p._processStartTag(token);
                }
            }
            break;
        }
        case TAG_ID.SCRIPT:
        case TAG_ID.TEMPLATE: {
            startTagInHead(p, token);
            break;
        }
        // Do nothing
    }
}
function endTagInSelect(p, token) {
    switch (token.tagID) {
        case TAG_ID.OPTGROUP: {
            if (p.openElements.stackTop > 0 &&
                p.openElements.currentTagId === TAG_ID.OPTION &&
                p.openElements.tagIDs[p.openElements.stackTop - 1] === TAG_ID.OPTGROUP) {
                p.openElements.pop();
            }
            if (p.openElements.currentTagId === TAG_ID.OPTGROUP) {
                p.openElements.pop();
            }
            break;
        }
        case TAG_ID.OPTION: {
            if (p.openElements.currentTagId === TAG_ID.OPTION) {
                p.openElements.pop();
            }
            break;
        }
        case TAG_ID.SELECT: {
            if (p.openElements.hasInSelectScope(TAG_ID.SELECT)) {
                p.openElements.popUntilTagNamePopped(TAG_ID.SELECT);
                p._resetInsertionMode();
            }
            break;
        }
        case TAG_ID.TEMPLATE: {
            templateEndTagInHead(p, token);
            break;
        }
        // Do nothing
    }
}
// The "in select in table" insertion mode
//------------------------------------------------------------------
function startTagInSelectInTable(p, token) {
    const tn = token.tagID;
    if (tn === TAG_ID.CAPTION ||
        tn === TAG_ID.TABLE ||
        tn === TAG_ID.TBODY ||
        tn === TAG_ID.TFOOT ||
        tn === TAG_ID.THEAD ||
        tn === TAG_ID.TR ||
        tn === TAG_ID.TD ||
        tn === TAG_ID.TH) {
        p.openElements.popUntilTagNamePopped(TAG_ID.SELECT);
        p._resetInsertionMode();
        p._processStartTag(token);
    }
    else {
        startTagInSelect(p, token);
    }
}
function endTagInSelectInTable(p, token) {
    const tn = token.tagID;
    if (tn === TAG_ID.CAPTION ||
        tn === TAG_ID.TABLE ||
        tn === TAG_ID.TBODY ||
        tn === TAG_ID.TFOOT ||
        tn === TAG_ID.THEAD ||
        tn === TAG_ID.TR ||
        tn === TAG_ID.TD ||
        tn === TAG_ID.TH) {
        if (p.openElements.hasInTableScope(tn)) {
            p.openElements.popUntilTagNamePopped(TAG_ID.SELECT);
            p._resetInsertionMode();
            p.onEndTag(token);
        }
    }
    else {
        endTagInSelect(p, token);
    }
}
// The "in template" insertion mode
//------------------------------------------------------------------
function startTagInTemplate(p, token) {
    switch (token.tagID) {
        // First, handle tags that can start without a mode change
        case TAG_ID.BASE:
        case TAG_ID.BASEFONT:
        case TAG_ID.BGSOUND:
        case TAG_ID.LINK:
        case TAG_ID.META:
        case TAG_ID.NOFRAMES:
        case TAG_ID.SCRIPT:
        case TAG_ID.STYLE:
        case TAG_ID.TEMPLATE:
        case TAG_ID.TITLE: {
            startTagInHead(p, token);
            break;
        }
        // Re-process the token in the appropriate mode
        case TAG_ID.CAPTION:
        case TAG_ID.COLGROUP:
        case TAG_ID.TBODY:
        case TAG_ID.TFOOT:
        case TAG_ID.THEAD: {
            p.tmplInsertionModeStack[0] = InsertionMode.IN_TABLE;
            p.insertionMode = InsertionMode.IN_TABLE;
            startTagInTable(p, token);
            break;
        }
        case TAG_ID.COL: {
            p.tmplInsertionModeStack[0] = InsertionMode.IN_COLUMN_GROUP;
            p.insertionMode = InsertionMode.IN_COLUMN_GROUP;
            startTagInColumnGroup(p, token);
            break;
        }
        case TAG_ID.TR: {
            p.tmplInsertionModeStack[0] = InsertionMode.IN_TABLE_BODY;
            p.insertionMode = InsertionMode.IN_TABLE_BODY;
            startTagInTableBody(p, token);
            break;
        }
        case TAG_ID.TD:
        case TAG_ID.TH: {
            p.tmplInsertionModeStack[0] = InsertionMode.IN_ROW;
            p.insertionMode = InsertionMode.IN_ROW;
            startTagInRow(p, token);
            break;
        }
        default: {
            p.tmplInsertionModeStack[0] = InsertionMode.IN_BODY;
            p.insertionMode = InsertionMode.IN_BODY;
            startTagInBody(p, token);
        }
    }
}
function endTagInTemplate(p, token) {
    if (token.tagID === TAG_ID.TEMPLATE) {
        templateEndTagInHead(p, token);
    }
}
function eofInTemplate(p, token) {
    if (p.openElements.tmplCount > 0) {
        p.openElements.popUntilTagNamePopped(TAG_ID.TEMPLATE);
        p.activeFormattingElements.clearToLastMarker();
        p.tmplInsertionModeStack.shift();
        p._resetInsertionMode();
        p.onEof(token);
    }
    else {
        stopParsing(p, token);
    }
}
// The "after body" insertion mode
//------------------------------------------------------------------
function startTagAfterBody(p, token) {
    if (token.tagID === TAG_ID.HTML) {
        startTagInBody(p, token);
    }
    else {
        tokenAfterBody(p, token);
    }
}
function endTagAfterBody(p, token) {
    var _a;
    if (token.tagID === TAG_ID.HTML) {
        if (!p.fragmentContext) {
            p.insertionMode = InsertionMode.AFTER_AFTER_BODY;
        }
        //NOTE: <html> is never popped from the stack, so we need to updated
        //the end location explicitly.
        if (p.options.sourceCodeLocationInfo && p.openElements.tagIDs[0] === TAG_ID.HTML) {
            p._setEndLocation(p.openElements.items[0], token);
            // Update the body element, if it doesn't have an end tag
            const bodyElement = p.openElements.items[1];
            if (bodyElement && !((_a = p.treeAdapter.getNodeSourceCodeLocation(bodyElement)) === null || _a === void 0 ? void 0 : _a.endTag)) {
                p._setEndLocation(bodyElement, token);
            }
        }
    }
    else {
        tokenAfterBody(p, token);
    }
}
function tokenAfterBody(p, token) {
    p.insertionMode = InsertionMode.IN_BODY;
    modeInBody(p, token);
}
// The "in frameset" insertion mode
//------------------------------------------------------------------
function startTagInFrameset(p, token) {
    switch (token.tagID) {
        case TAG_ID.HTML: {
            startTagInBody(p, token);
            break;
        }
        case TAG_ID.FRAMESET: {
            p._insertElement(token, NS.HTML);
            break;
        }
        case TAG_ID.FRAME: {
            p._appendElement(token, NS.HTML);
            token.ackSelfClosing = true;
            break;
        }
        case TAG_ID.NOFRAMES: {
            startTagInHead(p, token);
            break;
        }
        // Do nothing
    }
}
function endTagInFrameset(p, token) {
    if (token.tagID === TAG_ID.FRAMESET && !p.openElements.isRootHtmlElementCurrent()) {
        p.openElements.pop();
        if (!p.fragmentContext && p.openElements.currentTagId !== TAG_ID.FRAMESET) {
            p.insertionMode = InsertionMode.AFTER_FRAMESET;
        }
    }
}
// The "after frameset" insertion mode
//------------------------------------------------------------------
function startTagAfterFrameset(p, token) {
    switch (token.tagID) {
        case TAG_ID.HTML: {
            startTagInBody(p, token);
            break;
        }
        case TAG_ID.NOFRAMES: {
            startTagInHead(p, token);
            break;
        }
        // Do nothing
    }
}
function endTagAfterFrameset(p, token) {
    if (token.tagID === TAG_ID.HTML) {
        p.insertionMode = InsertionMode.AFTER_AFTER_FRAMESET;
    }
}
// The "after after body" insertion mode
//------------------------------------------------------------------
function startTagAfterAfterBody(p, token) {
    if (token.tagID === TAG_ID.HTML) {
        startTagInBody(p, token);
    }
    else {
        tokenAfterAfterBody(p, token);
    }
}
function tokenAfterAfterBody(p, token) {
    p.insertionMode = InsertionMode.IN_BODY;
    modeInBody(p, token);
}
// The "after after frameset" insertion mode
//------------------------------------------------------------------
function startTagAfterAfterFrameset(p, token) {
    switch (token.tagID) {
        case TAG_ID.HTML: {
            startTagInBody(p, token);
            break;
        }
        case TAG_ID.NOFRAMES: {
            startTagInHead(p, token);
            break;
        }
        // Do nothing
    }
}
// The rules for parsing tokens in foreign content
//------------------------------------------------------------------
function nullCharacterInForeignContent(p, token) {
    token.chars = REPLACEMENT_CHARACTER;
    p._insertCharacters(token);
}
function characterInForeignContent(p, token) {
    p._insertCharacters(token);
    p.framesetOk = false;
}
function popUntilHtmlOrIntegrationPoint(p) {
    while (p.treeAdapter.getNamespaceURI(p.openElements.current) !== NS.HTML &&
        !p._isIntegrationPoint(p.openElements.currentTagId, p.openElements.current)) {
        p.openElements.pop();
    }
}
function startTagInForeignContent(p, token) {
    if (causesExit(token)) {
        popUntilHtmlOrIntegrationPoint(p);
        p._startTagOutsideForeignContent(token);
    }
    else {
        const current = p._getAdjustedCurrentElement();
        const currentNs = p.treeAdapter.getNamespaceURI(current);
        if (currentNs === NS.MATHML) {
            adjustTokenMathMLAttrs(token);
        }
        else if (currentNs === NS.SVG) {
            adjustTokenSVGTagName(token);
            adjustTokenSVGAttrs(token);
        }
        adjustTokenXMLAttrs(token);
        if (token.selfClosing) {
            p._appendElement(token, currentNs);
        }
        else {
            p._insertElement(token, currentNs);
        }
        token.ackSelfClosing = true;
    }
}
function endTagInForeignContent(p, token) {
    if (token.tagID === TAG_ID.P || token.tagID === TAG_ID.BR) {
        popUntilHtmlOrIntegrationPoint(p);
        p._endTagOutsideForeignContent(token);
        return;
    }
    for (let i = p.openElements.stackTop; i > 0; i--) {
        const element = p.openElements.items[i];
        if (p.treeAdapter.getNamespaceURI(element) === NS.HTML) {
            p._endTagOutsideForeignContent(token);
            break;
        }
        const tagName = p.treeAdapter.getTagName(element);
        if (tagName.toLowerCase() === token.tagName) {
            //NOTE: update the token tag name for `_setEndLocation`.
            token.tagName = tagName;
            p.openElements.shortenToLength(i);
            break;
        }
    }
}

// Sets
const VOID_ELEMENTS = new Set([
    TAG_NAMES.AREA,
    TAG_NAMES.BASE,
    TAG_NAMES.BASEFONT,
    TAG_NAMES.BGSOUND,
    TAG_NAMES.BR,
    TAG_NAMES.COL,
    TAG_NAMES.EMBED,
    TAG_NAMES.FRAME,
    TAG_NAMES.HR,
    TAG_NAMES.IMG,
    TAG_NAMES.INPUT,
    TAG_NAMES.KEYGEN,
    TAG_NAMES.LINK,
    TAG_NAMES.META,
    TAG_NAMES.PARAM,
    TAG_NAMES.SOURCE,
    TAG_NAMES.TRACK,
    TAG_NAMES.WBR,
]);
function isVoidElement(node, options) {
    return (options.treeAdapter.isElementNode(node) &&
        options.treeAdapter.getNamespaceURI(node) === NS.HTML &&
        VOID_ELEMENTS.has(options.treeAdapter.getTagName(node)));
}
const defaultOpts = { treeAdapter: defaultTreeAdapter, scriptingEnabled: true };
/**
 * Serializes an AST element node to an HTML string, including the element node.
 *
 * @example
 *
 * ```js
 * const parse5 = require('parse5');
 *
 * const document = parse5.parseFragment('<div>Hello, <b>world</b>!</div>');
 *
 * // Serializes the <div> element.
 * const html = parse5.serializeOuter(document.childNodes[0]);
 *
 * console.log(str); //> '<div>Hello, <b>world</b>!</div>'
 * ```
 *
 * @param node Node to serialize.
 * @param options Serialization options.
 */
function serializeOuter(node, options) {
    const opts = { ...defaultOpts, ...options };
    return serializeNode(node, opts);
}
function serializeChildNodes(parentNode, options) {
    let html = '';
    // Get container of the child nodes
    const container = options.treeAdapter.isElementNode(parentNode) &&
        options.treeAdapter.getTagName(parentNode) === TAG_NAMES.TEMPLATE &&
        options.treeAdapter.getNamespaceURI(parentNode) === NS.HTML
        ? options.treeAdapter.getTemplateContent(parentNode)
        : parentNode;
    const childNodes = options.treeAdapter.getChildNodes(container);
    if (childNodes) {
        for (const currentNode of childNodes) {
            html += serializeNode(currentNode, options);
        }
    }
    return html;
}
function serializeNode(node, options) {
    if (options.treeAdapter.isElementNode(node)) {
        return serializeElement(node, options);
    }
    if (options.treeAdapter.isTextNode(node)) {
        return serializeTextNode(node, options);
    }
    if (options.treeAdapter.isCommentNode(node)) {
        return serializeCommentNode(node, options);
    }
    if (options.treeAdapter.isDocumentTypeNode(node)) {
        return serializeDocumentTypeNode(node, options);
    }
    // Return an empty string for unknown nodes
    return '';
}
function serializeElement(node, options) {
    const tn = options.treeAdapter.getTagName(node);
    return `<${tn}${serializeAttributes(node, options)}>${isVoidElement(node, options) ? '' : `${serializeChildNodes(node, options)}</${tn}>`}`;
}
function serializeAttributes(node, { treeAdapter }) {
    let html = '';
    for (const attr of treeAdapter.getAttrList(node)) {
        html += ' ';
        if (!attr.namespace) {
            html += attr.name;
        }
        else
            switch (attr.namespace) {
                case NS.XML: {
                    html += `xml:${attr.name}`;
                    break;
                }
                case NS.XMLNS: {
                    if (attr.name !== 'xmlns') {
                        html += 'xmlns:';
                    }
                    html += attr.name;
                    break;
                }
                case NS.XLINK: {
                    html += `xlink:${attr.name}`;
                    break;
                }
                default: {
                    html += `${attr.prefix}:${attr.name}`;
                }
            }
        html += `="${escapeAttribute(attr.value)}"`;
    }
    return html;
}
function serializeTextNode(node, options) {
    const { treeAdapter } = options;
    const content = treeAdapter.getTextNodeContent(node);
    const parent = treeAdapter.getParentNode(node);
    const parentTn = parent && treeAdapter.isElementNode(parent) && treeAdapter.getTagName(parent);
    return parentTn &&
        treeAdapter.getNamespaceURI(parent) === NS.HTML &&
        hasUnescapedText(parentTn, options.scriptingEnabled)
        ? content
        : escapeText(content);
}
function serializeCommentNode(node, { treeAdapter }) {
    return `<!--${treeAdapter.getCommentNodeContent(node)}-->`;
}
function serializeDocumentTypeNode(node, { treeAdapter }) {
    return `<!DOCTYPE ${treeAdapter.getDocumentTypeNodeName(node)}>`;
}

// Shorthands
/**
 * Parses an HTML string.
 *
 * @param html Input HTML string.
 * @param options Parsing options.
 * @returns Document
 *
 * @example
 *
 * ```js
 * const parse5 = require('parse5');
 *
 * const document = parse5.parse('<!DOCTYPE html><html><head></head><body>Hi there!</body></html>');
 *
 * console.log(document.childNodes[1].tagName); //> 'html'
 *```
 */
function parse$j(html, options) {
    return Parser$1.parse(html, options);
}
function parseFragment(fragmentContext, html, options) {
    if (typeof fragmentContext === 'string') {
        options = html;
        html = fragmentContext;
        fragmentContext = null;
    }
    const parser = Parser$1.getFragmentParser(fragmentContext, options);
    parser.tokenizer.write(html, true);
    return parser.getFragment();
}

function createTextNode(value) {
    return new Text$1(value);
}
function enquoteDoctypeId(id) {
    const quote = id.includes('"') ? "'" : '"';
    return quote + id + quote;
}
/** @internal */
function serializeDoctypeContent(name, publicId, systemId) {
    let str = '!DOCTYPE ';
    if (name) {
        str += name;
    }
    if (publicId) {
        str += ` PUBLIC ${enquoteDoctypeId(publicId)}`;
    }
    else if (systemId) {
        str += ' SYSTEM';
    }
    if (systemId) {
        str += ` ${enquoteDoctypeId(systemId)}`;
    }
    return str;
}
const adapter = {
    // Re-exports from domhandler
    isCommentNode: isComment$1,
    isElementNode: isTag$2,
    isTextNode: isText$1,
    //Node construction
    createDocument() {
        const node = new Document$1([]);
        node['x-mode'] = DOCUMENT_MODE.NO_QUIRKS;
        return node;
    },
    createDocumentFragment() {
        return new Document$1([]);
    },
    createElement(tagName, namespaceURI, attrs) {
        const attribs = Object.create(null);
        const attribsNamespace = Object.create(null);
        const attribsPrefix = Object.create(null);
        for (let i = 0; i < attrs.length; i++) {
            const attrName = attrs[i].name;
            attribs[attrName] = attrs[i].value;
            attribsNamespace[attrName] = attrs[i].namespace;
            attribsPrefix[attrName] = attrs[i].prefix;
        }
        const node = new Element$2(tagName, attribs, []);
        node.namespace = namespaceURI;
        node['x-attribsNamespace'] = attribsNamespace;
        node['x-attribsPrefix'] = attribsPrefix;
        return node;
    },
    createCommentNode(data) {
        return new Comment$1(data);
    },
    //Tree mutation
    appendChild(parentNode, newNode) {
        const prev = parentNode.children[parentNode.children.length - 1];
        if (prev) {
            prev.next = newNode;
            newNode.prev = prev;
        }
        parentNode.children.push(newNode);
        newNode.parent = parentNode;
    },
    insertBefore(parentNode, newNode, referenceNode) {
        const insertionIdx = parentNode.children.indexOf(referenceNode);
        const { prev } = referenceNode;
        if (prev) {
            prev.next = newNode;
            newNode.prev = prev;
        }
        referenceNode.prev = newNode;
        newNode.next = referenceNode;
        parentNode.children.splice(insertionIdx, 0, newNode);
        newNode.parent = parentNode;
    },
    setTemplateContent(templateElement, contentElement) {
        adapter.appendChild(templateElement, contentElement);
    },
    getTemplateContent(templateElement) {
        return templateElement.children[0];
    },
    setDocumentType(document, name, publicId, systemId) {
        const data = serializeDoctypeContent(name, publicId, systemId);
        let doctypeNode = document.children.find((node) => isDirective$1(node) && node.name === '!doctype');
        if (doctypeNode) {
            doctypeNode.data = data !== null && data !== void 0 ? data : null;
        }
        else {
            doctypeNode = new ProcessingInstruction$1('!doctype', data);
            adapter.appendChild(document, doctypeNode);
        }
        doctypeNode['x-name'] = name !== null && name !== void 0 ? name : undefined;
        doctypeNode['x-publicId'] = publicId !== null && publicId !== void 0 ? publicId : undefined;
        doctypeNode['x-systemId'] = systemId !== null && systemId !== void 0 ? systemId : undefined;
    },
    setDocumentMode(document, mode) {
        document['x-mode'] = mode;
    },
    getDocumentMode(document) {
        return document['x-mode'];
    },
    detachNode(node) {
        if (node.parent) {
            const idx = node.parent.children.indexOf(node);
            const { prev, next } = node;
            node.prev = null;
            node.next = null;
            if (prev) {
                prev.next = next;
            }
            if (next) {
                next.prev = prev;
            }
            node.parent.children.splice(idx, 1);
            node.parent = null;
        }
    },
    insertText(parentNode, text) {
        const lastChild = parentNode.children[parentNode.children.length - 1];
        if (lastChild && isText$1(lastChild)) {
            lastChild.data += text;
        }
        else {
            adapter.appendChild(parentNode, createTextNode(text));
        }
    },
    insertTextBefore(parentNode, text, referenceNode) {
        const prevNode = parentNode.children[parentNode.children.indexOf(referenceNode) - 1];
        if (prevNode && isText$1(prevNode)) {
            prevNode.data += text;
        }
        else {
            adapter.insertBefore(parentNode, createTextNode(text), referenceNode);
        }
    },
    adoptAttributes(recipient, attrs) {
        for (let i = 0; i < attrs.length; i++) {
            const attrName = attrs[i].name;
            if (typeof recipient.attribs[attrName] === 'undefined') {
                recipient.attribs[attrName] = attrs[i].value;
                recipient['x-attribsNamespace'][attrName] = attrs[i].namespace;
                recipient['x-attribsPrefix'][attrName] = attrs[i].prefix;
            }
        }
    },
    //Tree traversing
    getFirstChild(node) {
        return node.children[0];
    },
    getChildNodes(node) {
        return node.children;
    },
    getParentNode(node) {
        return node.parent;
    },
    getAttrList(element) {
        return element.attributes;
    },
    //Node data
    getTagName(element) {
        return element.name;
    },
    getNamespaceURI(element) {
        return element.namespace;
    },
    getTextNodeContent(textNode) {
        return textNode.data;
    },
    getCommentNodeContent(commentNode) {
        return commentNode.data;
    },
    getDocumentTypeNodeName(doctypeNode) {
        var _a;
        return (_a = doctypeNode['x-name']) !== null && _a !== void 0 ? _a : '';
    },
    getDocumentTypeNodePublicId(doctypeNode) {
        var _a;
        return (_a = doctypeNode['x-publicId']) !== null && _a !== void 0 ? _a : '';
    },
    getDocumentTypeNodeSystemId(doctypeNode) {
        var _a;
        return (_a = doctypeNode['x-systemId']) !== null && _a !== void 0 ? _a : '';
    },
    //Node types
    isDocumentTypeNode(node) {
        return isDirective$1(node) && node.name === '!doctype';
    },
    // Source code location
    setNodeSourceCodeLocation(node, location) {
        if (location) {
            node.startIndex = location.startOffset;
            node.endIndex = location.endOffset;
        }
        node.sourceCodeLocation = location;
    },
    getNodeSourceCodeLocation(node) {
        return node.sourceCodeLocation;
    },
    updateNodeSourceCodeLocation(node, endLocation) {
        if (endLocation.endOffset != null)
            node.endIndex = endLocation.endOffset;
        node.sourceCodeLocation = {
            ...node.sourceCodeLocation,
            ...endLocation,
        };
    },
};

/**
 * Parse the content with `parse5` in the context of the given `ParentNode`.
 *
 * @param content - The content to parse.
 * @param options - A set of options to use to parse.
 * @param isDocument - Whether to parse the content as a full HTML document.
 * @param context - The context in which to parse the content.
 * @returns The parsed content.
 */
function parseWithParse5(content, options, isDocument, context) {
    const opts = {
        scriptingEnabled: typeof options.scriptingEnabled === 'boolean'
            ? options.scriptingEnabled
            : true,
        treeAdapter: adapter,
        sourceCodeLocationInfo: options.sourceCodeLocationInfo,
    };
    return isDocument
        ? parse$j(content, opts)
        : parseFragment(context, content, opts);
}
const renderOpts = { treeAdapter: adapter };
/**
 * Renders the given DOM tree with `parse5` and returns the result as a string.
 *
 * @param dom - The DOM tree to render.
 * @returns The rendered document.
 */
function renderWithParse5(dom) {
    /*
     * `dom-serializer` passes over the special "root" node and renders the
     * node's children in its place. To mimic this behavior with `parse5`, an
     * equivalent operation must be applied to the input array.
     */
    const nodes = 'length' in dom ? dom : [dom];
    for (let index = 0; index < nodes.length; index += 1) {
        const node = nodes[index];
        if (isDocument$1(node)) {
            Array.prototype.splice.call(nodes, index, 1, ...node.children);
        }
    }
    let result = '';
    for (let index = 0; index < nodes.length; index += 1) {
        const node = nodes[index];
        result += serializeOuter(node, renderOpts);
    }
    return result;
}

var CharCodes;
(function (CharCodes) {
    CharCodes[CharCodes["Tab"] = 9] = "Tab";
    CharCodes[CharCodes["NewLine"] = 10] = "NewLine";
    CharCodes[CharCodes["FormFeed"] = 12] = "FormFeed";
    CharCodes[CharCodes["CarriageReturn"] = 13] = "CarriageReturn";
    CharCodes[CharCodes["Space"] = 32] = "Space";
    CharCodes[CharCodes["ExclamationMark"] = 33] = "ExclamationMark";
    CharCodes[CharCodes["Number"] = 35] = "Number";
    CharCodes[CharCodes["Amp"] = 38] = "Amp";
    CharCodes[CharCodes["SingleQuote"] = 39] = "SingleQuote";
    CharCodes[CharCodes["DoubleQuote"] = 34] = "DoubleQuote";
    CharCodes[CharCodes["Dash"] = 45] = "Dash";
    CharCodes[CharCodes["Slash"] = 47] = "Slash";
    CharCodes[CharCodes["Zero"] = 48] = "Zero";
    CharCodes[CharCodes["Nine"] = 57] = "Nine";
    CharCodes[CharCodes["Semi"] = 59] = "Semi";
    CharCodes[CharCodes["Lt"] = 60] = "Lt";
    CharCodes[CharCodes["Eq"] = 61] = "Eq";
    CharCodes[CharCodes["Gt"] = 62] = "Gt";
    CharCodes[CharCodes["Questionmark"] = 63] = "Questionmark";
    CharCodes[CharCodes["UpperA"] = 65] = "UpperA";
    CharCodes[CharCodes["LowerA"] = 97] = "LowerA";
    CharCodes[CharCodes["UpperF"] = 70] = "UpperF";
    CharCodes[CharCodes["LowerF"] = 102] = "LowerF";
    CharCodes[CharCodes["UpperZ"] = 90] = "UpperZ";
    CharCodes[CharCodes["LowerZ"] = 122] = "LowerZ";
    CharCodes[CharCodes["LowerX"] = 120] = "LowerX";
    CharCodes[CharCodes["OpeningSquareBracket"] = 91] = "OpeningSquareBracket";
})(CharCodes || (CharCodes = {}));
/** All the states the tokenizer can be in. */
var State;
(function (State) {
    State[State["Text"] = 1] = "Text";
    State[State["BeforeTagName"] = 2] = "BeforeTagName";
    State[State["InTagName"] = 3] = "InTagName";
    State[State["InSelfClosingTag"] = 4] = "InSelfClosingTag";
    State[State["BeforeClosingTagName"] = 5] = "BeforeClosingTagName";
    State[State["InClosingTagName"] = 6] = "InClosingTagName";
    State[State["AfterClosingTagName"] = 7] = "AfterClosingTagName";
    // Attributes
    State[State["BeforeAttributeName"] = 8] = "BeforeAttributeName";
    State[State["InAttributeName"] = 9] = "InAttributeName";
    State[State["AfterAttributeName"] = 10] = "AfterAttributeName";
    State[State["BeforeAttributeValue"] = 11] = "BeforeAttributeValue";
    State[State["InAttributeValueDq"] = 12] = "InAttributeValueDq";
    State[State["InAttributeValueSq"] = 13] = "InAttributeValueSq";
    State[State["InAttributeValueNq"] = 14] = "InAttributeValueNq";
    // Declarations
    State[State["BeforeDeclaration"] = 15] = "BeforeDeclaration";
    State[State["InDeclaration"] = 16] = "InDeclaration";
    // Processing instructions
    State[State["InProcessingInstruction"] = 17] = "InProcessingInstruction";
    // Comments & CDATA
    State[State["BeforeComment"] = 18] = "BeforeComment";
    State[State["CDATASequence"] = 19] = "CDATASequence";
    State[State["InSpecialComment"] = 20] = "InSpecialComment";
    State[State["InCommentLike"] = 21] = "InCommentLike";
    // Special tags
    State[State["BeforeSpecialS"] = 22] = "BeforeSpecialS";
    State[State["SpecialStartSequence"] = 23] = "SpecialStartSequence";
    State[State["InSpecialTag"] = 24] = "InSpecialTag";
    State[State["BeforeEntity"] = 25] = "BeforeEntity";
    State[State["BeforeNumericEntity"] = 26] = "BeforeNumericEntity";
    State[State["InNamedEntity"] = 27] = "InNamedEntity";
    State[State["InNumericEntity"] = 28] = "InNumericEntity";
    State[State["InHexEntity"] = 29] = "InHexEntity";
})(State || (State = {}));
function isWhitespace(c) {
    return (c === CharCodes.Space ||
        c === CharCodes.NewLine ||
        c === CharCodes.Tab ||
        c === CharCodes.FormFeed ||
        c === CharCodes.CarriageReturn);
}
function isEndOfTagSection(c) {
    return c === CharCodes.Slash || c === CharCodes.Gt || isWhitespace(c);
}
function isNumber$4(c) {
    return c >= CharCodes.Zero && c <= CharCodes.Nine;
}
function isASCIIAlpha(c) {
    return ((c >= CharCodes.LowerA && c <= CharCodes.LowerZ) ||
        (c >= CharCodes.UpperA && c <= CharCodes.UpperZ));
}
function isHexDigit(c) {
    return ((c >= CharCodes.UpperA && c <= CharCodes.UpperF) ||
        (c >= CharCodes.LowerA && c <= CharCodes.LowerF));
}
var QuoteType;
(function (QuoteType) {
    QuoteType[QuoteType["NoValue"] = 0] = "NoValue";
    QuoteType[QuoteType["Unquoted"] = 1] = "Unquoted";
    QuoteType[QuoteType["Single"] = 2] = "Single";
    QuoteType[QuoteType["Double"] = 3] = "Double";
})(QuoteType || (QuoteType = {}));
/**
 * Sequences used to match longer strings.
 *
 * We don't have `Script`, `Style`, or `Title` here. Instead, we re-use the *End
 * sequences with an increased offset.
 */
const Sequences = {
    Cdata: new Uint8Array([0x43, 0x44, 0x41, 0x54, 0x41, 0x5b]),
    CdataEnd: new Uint8Array([0x5d, 0x5d, 0x3e]),
    CommentEnd: new Uint8Array([0x2d, 0x2d, 0x3e]),
    ScriptEnd: new Uint8Array([0x3c, 0x2f, 0x73, 0x63, 0x72, 0x69, 0x70, 0x74]),
    StyleEnd: new Uint8Array([0x3c, 0x2f, 0x73, 0x74, 0x79, 0x6c, 0x65]),
    TitleEnd: new Uint8Array([0x3c, 0x2f, 0x74, 0x69, 0x74, 0x6c, 0x65]), // `</title`
};
class Tokenizer {
    constructor({ xmlMode = false, decodeEntities = true, }, cbs) {
        this.cbs = cbs;
        /** The current state the tokenizer is in. */
        this.state = State.Text;
        /** The read buffer. */
        this.buffer = "";
        /** The beginning of the section that is currently being read. */
        this.sectionStart = 0;
        /** The index within the buffer that we are currently looking at. */
        this.index = 0;
        /** Some behavior, eg. when decoding entities, is done while we are in another state. This keeps track of the other state type. */
        this.baseState = State.Text;
        /** For special parsing behavior inside of script and style tags. */
        this.isSpecial = false;
        /** Indicates whether the tokenizer has been paused. */
        this.running = true;
        /** The offset of the current buffer. */
        this.offset = 0;
        this.currentSequence = undefined;
        this.sequenceIndex = 0;
        this.trieIndex = 0;
        this.trieCurrent = 0;
        /** For named entities, the index of the value. For numeric entities, the code point. */
        this.entityResult = 0;
        this.entityExcess = 0;
        this.xmlMode = xmlMode;
        this.decodeEntities = decodeEntities;
        this.entityTrie = xmlMode ? xmlDecodeTree : htmlDecodeTree;
    }
    reset() {
        this.state = State.Text;
        this.buffer = "";
        this.sectionStart = 0;
        this.index = 0;
        this.baseState = State.Text;
        this.currentSequence = undefined;
        this.running = true;
        this.offset = 0;
    }
    write(chunk) {
        this.offset += this.buffer.length;
        this.buffer = chunk;
        this.parse();
    }
    end() {
        if (this.running)
            this.finish();
    }
    pause() {
        this.running = false;
    }
    resume() {
        this.running = true;
        if (this.index < this.buffer.length + this.offset) {
            this.parse();
        }
    }
    /**
     * The current index within all of the written data.
     */
    getIndex() {
        return this.index;
    }
    /**
     * The start of the current section.
     */
    getSectionStart() {
        return this.sectionStart;
    }
    stateText(c) {
        if (c === CharCodes.Lt ||
            (!this.decodeEntities && this.fastForwardTo(CharCodes.Lt))) {
            if (this.index > this.sectionStart) {
                this.cbs.ontext(this.sectionStart, this.index);
            }
            this.state = State.BeforeTagName;
            this.sectionStart = this.index;
        }
        else if (this.decodeEntities && c === CharCodes.Amp) {
            this.state = State.BeforeEntity;
        }
    }
    stateSpecialStartSequence(c) {
        const isEnd = this.sequenceIndex === this.currentSequence.length;
        const isMatch = isEnd
            ? // If we are at the end of the sequence, make sure the tag name has ended
                isEndOfTagSection(c)
            : // Otherwise, do a case-insensitive comparison
                (c | 0x20) === this.currentSequence[this.sequenceIndex];
        if (!isMatch) {
            this.isSpecial = false;
        }
        else if (!isEnd) {
            this.sequenceIndex++;
            return;
        }
        this.sequenceIndex = 0;
        this.state = State.InTagName;
        this.stateInTagName(c);
    }
    /** Look for an end tag. For <title> tags, also decode entities. */
    stateInSpecialTag(c) {
        if (this.sequenceIndex === this.currentSequence.length) {
            if (c === CharCodes.Gt || isWhitespace(c)) {
                const endOfText = this.index - this.currentSequence.length;
                if (this.sectionStart < endOfText) {
                    // Spoof the index so that reported locations match up.
                    const actualIndex = this.index;
                    this.index = endOfText;
                    this.cbs.ontext(this.sectionStart, endOfText);
                    this.index = actualIndex;
                }
                this.isSpecial = false;
                this.sectionStart = endOfText + 2; // Skip over the `</`
                this.stateInClosingTagName(c);
                return; // We are done; skip the rest of the function.
            }
            this.sequenceIndex = 0;
        }
        if ((c | 0x20) === this.currentSequence[this.sequenceIndex]) {
            this.sequenceIndex += 1;
        }
        else if (this.sequenceIndex === 0) {
            if (this.currentSequence === Sequences.TitleEnd) {
                // We have to parse entities in <title> tags.
                if (this.decodeEntities && c === CharCodes.Amp) {
                    this.state = State.BeforeEntity;
                }
            }
            else if (this.fastForwardTo(CharCodes.Lt)) {
                // Outside of <title> tags, we can fast-forward.
                this.sequenceIndex = 1;
            }
        }
        else {
            // If we see a `<`, set the sequence index to 1; useful for eg. `<</script>`.
            this.sequenceIndex = Number(c === CharCodes.Lt);
        }
    }
    stateCDATASequence(c) {
        if (c === Sequences.Cdata[this.sequenceIndex]) {
            if (++this.sequenceIndex === Sequences.Cdata.length) {
                this.state = State.InCommentLike;
                this.currentSequence = Sequences.CdataEnd;
                this.sequenceIndex = 0;
                this.sectionStart = this.index + 1;
            }
        }
        else {
            this.sequenceIndex = 0;
            this.state = State.InDeclaration;
            this.stateInDeclaration(c); // Reconsume the character
        }
    }
    /**
     * When we wait for one specific character, we can speed things up
     * by skipping through the buffer until we find it.
     *
     * @returns Whether the character was found.
     */
    fastForwardTo(c) {
        while (++this.index < this.buffer.length + this.offset) {
            if (this.buffer.charCodeAt(this.index - this.offset) === c) {
                return true;
            }
        }
        /*
         * We increment the index at the end of the `parse` loop,
         * so set it to `buffer.length - 1` here.
         *
         * TODO: Refactor `parse` to increment index before calling states.
         */
        this.index = this.buffer.length + this.offset - 1;
        return false;
    }
    /**
     * Comments and CDATA end with `-->` and `]]>`.
     *
     * Their common qualities are:
     * - Their end sequences have a distinct character they start with.
     * - That character is then repeated, so we have to check multiple repeats.
     * - All characters but the start character of the sequence can be skipped.
     */
    stateInCommentLike(c) {
        if (c === this.currentSequence[this.sequenceIndex]) {
            if (++this.sequenceIndex === this.currentSequence.length) {
                if (this.currentSequence === Sequences.CdataEnd) {
                    this.cbs.oncdata(this.sectionStart, this.index, 2);
                }
                else {
                    this.cbs.oncomment(this.sectionStart, this.index, 2);
                }
                this.sequenceIndex = 0;
                this.sectionStart = this.index + 1;
                this.state = State.Text;
            }
        }
        else if (this.sequenceIndex === 0) {
            // Fast-forward to the first character of the sequence
            if (this.fastForwardTo(this.currentSequence[0])) {
                this.sequenceIndex = 1;
            }
        }
        else if (c !== this.currentSequence[this.sequenceIndex - 1]) {
            // Allow long sequences, eg. --->, ]]]>
            this.sequenceIndex = 0;
        }
    }
    /**
     * HTML only allows ASCII alpha characters (a-z and A-Z) at the beginning of a tag name.
     *
     * XML allows a lot more characters here (@see https://www.w3.org/TR/REC-xml/#NT-NameStartChar).
     * We allow anything that wouldn't end the tag.
     */
    isTagStartChar(c) {
        return this.xmlMode ? !isEndOfTagSection(c) : isASCIIAlpha(c);
    }
    startSpecial(sequence, offset) {
        this.isSpecial = true;
        this.currentSequence = sequence;
        this.sequenceIndex = offset;
        this.state = State.SpecialStartSequence;
    }
    stateBeforeTagName(c) {
        if (c === CharCodes.ExclamationMark) {
            this.state = State.BeforeDeclaration;
            this.sectionStart = this.index + 1;
        }
        else if (c === CharCodes.Questionmark) {
            this.state = State.InProcessingInstruction;
            this.sectionStart = this.index + 1;
        }
        else if (this.isTagStartChar(c)) {
            const lower = c | 0x20;
            this.sectionStart = this.index;
            if (!this.xmlMode && lower === Sequences.TitleEnd[2]) {
                this.startSpecial(Sequences.TitleEnd, 3);
            }
            else {
                this.state =
                    !this.xmlMode && lower === Sequences.ScriptEnd[2]
                        ? State.BeforeSpecialS
                        : State.InTagName;
            }
        }
        else if (c === CharCodes.Slash) {
            this.state = State.BeforeClosingTagName;
        }
        else {
            this.state = State.Text;
            this.stateText(c);
        }
    }
    stateInTagName(c) {
        if (isEndOfTagSection(c)) {
            this.cbs.onopentagname(this.sectionStart, this.index);
            this.sectionStart = -1;
            this.state = State.BeforeAttributeName;
            this.stateBeforeAttributeName(c);
        }
    }
    stateBeforeClosingTagName(c) {
        if (isWhitespace(c)) ;
        else if (c === CharCodes.Gt) {
            this.state = State.Text;
        }
        else {
            this.state = this.isTagStartChar(c)
                ? State.InClosingTagName
                : State.InSpecialComment;
            this.sectionStart = this.index;
        }
    }
    stateInClosingTagName(c) {
        if (c === CharCodes.Gt || isWhitespace(c)) {
            this.cbs.onclosetag(this.sectionStart, this.index);
            this.sectionStart = -1;
            this.state = State.AfterClosingTagName;
            this.stateAfterClosingTagName(c);
        }
    }
    stateAfterClosingTagName(c) {
        // Skip everything until ">"
        if (c === CharCodes.Gt || this.fastForwardTo(CharCodes.Gt)) {
            this.state = State.Text;
            this.baseState = State.Text;
            this.sectionStart = this.index + 1;
        }
    }
    stateBeforeAttributeName(c) {
        if (c === CharCodes.Gt) {
            this.cbs.onopentagend(this.index);
            if (this.isSpecial) {
                this.state = State.InSpecialTag;
                this.sequenceIndex = 0;
            }
            else {
                this.state = State.Text;
            }
            this.baseState = this.state;
            this.sectionStart = this.index + 1;
        }
        else if (c === CharCodes.Slash) {
            this.state = State.InSelfClosingTag;
        }
        else if (!isWhitespace(c)) {
            this.state = State.InAttributeName;
            this.sectionStart = this.index;
        }
    }
    stateInSelfClosingTag(c) {
        if (c === CharCodes.Gt) {
            this.cbs.onselfclosingtag(this.index);
            this.state = State.Text;
            this.baseState = State.Text;
            this.sectionStart = this.index + 1;
            this.isSpecial = false; // Reset special state, in case of self-closing special tags
        }
        else if (!isWhitespace(c)) {
            this.state = State.BeforeAttributeName;
            this.stateBeforeAttributeName(c);
        }
    }
    stateInAttributeName(c) {
        if (c === CharCodes.Eq || isEndOfTagSection(c)) {
            this.cbs.onattribname(this.sectionStart, this.index);
            this.sectionStart = -1;
            this.state = State.AfterAttributeName;
            this.stateAfterAttributeName(c);
        }
    }
    stateAfterAttributeName(c) {
        if (c === CharCodes.Eq) {
            this.state = State.BeforeAttributeValue;
        }
        else if (c === CharCodes.Slash || c === CharCodes.Gt) {
            this.cbs.onattribend(QuoteType.NoValue, this.index);
            this.state = State.BeforeAttributeName;
            this.stateBeforeAttributeName(c);
        }
        else if (!isWhitespace(c)) {
            this.cbs.onattribend(QuoteType.NoValue, this.index);
            this.state = State.InAttributeName;
            this.sectionStart = this.index;
        }
    }
    stateBeforeAttributeValue(c) {
        if (c === CharCodes.DoubleQuote) {
            this.state = State.InAttributeValueDq;
            this.sectionStart = this.index + 1;
        }
        else if (c === CharCodes.SingleQuote) {
            this.state = State.InAttributeValueSq;
            this.sectionStart = this.index + 1;
        }
        else if (!isWhitespace(c)) {
            this.sectionStart = this.index;
            this.state = State.InAttributeValueNq;
            this.stateInAttributeValueNoQuotes(c); // Reconsume token
        }
    }
    handleInAttributeValue(c, quote) {
        if (c === quote ||
            (!this.decodeEntities && this.fastForwardTo(quote))) {
            this.cbs.onattribdata(this.sectionStart, this.index);
            this.sectionStart = -1;
            this.cbs.onattribend(quote === CharCodes.DoubleQuote
                ? QuoteType.Double
                : QuoteType.Single, this.index);
            this.state = State.BeforeAttributeName;
        }
        else if (this.decodeEntities && c === CharCodes.Amp) {
            this.baseState = this.state;
            this.state = State.BeforeEntity;
        }
    }
    stateInAttributeValueDoubleQuotes(c) {
        this.handleInAttributeValue(c, CharCodes.DoubleQuote);
    }
    stateInAttributeValueSingleQuotes(c) {
        this.handleInAttributeValue(c, CharCodes.SingleQuote);
    }
    stateInAttributeValueNoQuotes(c) {
        if (isWhitespace(c) || c === CharCodes.Gt) {
            this.cbs.onattribdata(this.sectionStart, this.index);
            this.sectionStart = -1;
            this.cbs.onattribend(QuoteType.Unquoted, this.index);
            this.state = State.BeforeAttributeName;
            this.stateBeforeAttributeName(c);
        }
        else if (this.decodeEntities && c === CharCodes.Amp) {
            this.baseState = this.state;
            this.state = State.BeforeEntity;
        }
    }
    stateBeforeDeclaration(c) {
        if (c === CharCodes.OpeningSquareBracket) {
            this.state = State.CDATASequence;
            this.sequenceIndex = 0;
        }
        else {
            this.state =
                c === CharCodes.Dash
                    ? State.BeforeComment
                    : State.InDeclaration;
        }
    }
    stateInDeclaration(c) {
        if (c === CharCodes.Gt || this.fastForwardTo(CharCodes.Gt)) {
            this.cbs.ondeclaration(this.sectionStart, this.index);
            this.state = State.Text;
            this.sectionStart = this.index + 1;
        }
    }
    stateInProcessingInstruction(c) {
        if (c === CharCodes.Gt || this.fastForwardTo(CharCodes.Gt)) {
            this.cbs.onprocessinginstruction(this.sectionStart, this.index);
            this.state = State.Text;
            this.sectionStart = this.index + 1;
        }
    }
    stateBeforeComment(c) {
        if (c === CharCodes.Dash) {
            this.state = State.InCommentLike;
            this.currentSequence = Sequences.CommentEnd;
            // Allow short comments (eg. <!-->)
            this.sequenceIndex = 2;
            this.sectionStart = this.index + 1;
        }
        else {
            this.state = State.InDeclaration;
        }
    }
    stateInSpecialComment(c) {
        if (c === CharCodes.Gt || this.fastForwardTo(CharCodes.Gt)) {
            this.cbs.oncomment(this.sectionStart, this.index, 0);
            this.state = State.Text;
            this.sectionStart = this.index + 1;
        }
    }
    stateBeforeSpecialS(c) {
        const lower = c | 0x20;
        if (lower === Sequences.ScriptEnd[3]) {
            this.startSpecial(Sequences.ScriptEnd, 4);
        }
        else if (lower === Sequences.StyleEnd[3]) {
            this.startSpecial(Sequences.StyleEnd, 4);
        }
        else {
            this.state = State.InTagName;
            this.stateInTagName(c); // Consume the token again
        }
    }
    stateBeforeEntity(c) {
        // Start excess with 1 to include the '&'
        this.entityExcess = 1;
        this.entityResult = 0;
        if (c === CharCodes.Number) {
            this.state = State.BeforeNumericEntity;
        }
        else if (c === CharCodes.Amp) ;
        else {
            this.trieIndex = 0;
            this.trieCurrent = this.entityTrie[0];
            this.state = State.InNamedEntity;
            this.stateInNamedEntity(c);
        }
    }
    stateInNamedEntity(c) {
        this.entityExcess += 1;
        this.trieIndex = determineBranch(this.entityTrie, this.trieCurrent, this.trieIndex + 1, c);
        if (this.trieIndex < 0) {
            this.emitNamedEntity();
            this.index--;
            return;
        }
        this.trieCurrent = this.entityTrie[this.trieIndex];
        const masked = this.trieCurrent & BinTrieFlags.VALUE_LENGTH;
        // If the branch is a value, store it and continue
        if (masked) {
            // The mask is the number of bytes of the value, including the current byte.
            const valueLength = (masked >> 14) - 1;
            // If we have a legacy entity while parsing strictly, just skip the number of bytes
            if (!this.allowLegacyEntity() && c !== CharCodes.Semi) {
                this.trieIndex += valueLength;
            }
            else {
                // Add 1 as we have already incremented the excess
                const entityStart = this.index - this.entityExcess + 1;
                if (entityStart > this.sectionStart) {
                    this.emitPartial(this.sectionStart, entityStart);
                }
                // If this is a surrogate pair, consume the next two bytes
                this.entityResult = this.trieIndex;
                this.trieIndex += valueLength;
                this.entityExcess = 0;
                this.sectionStart = this.index + 1;
                if (valueLength === 0) {
                    this.emitNamedEntity();
                }
            }
        }
    }
    emitNamedEntity() {
        this.state = this.baseState;
        if (this.entityResult === 0) {
            return;
        }
        const valueLength = (this.entityTrie[this.entityResult] & BinTrieFlags.VALUE_LENGTH) >>
            14;
        switch (valueLength) {
            case 1: {
                this.emitCodePoint(this.entityTrie[this.entityResult] &
                    ~BinTrieFlags.VALUE_LENGTH);
                break;
            }
            case 2: {
                this.emitCodePoint(this.entityTrie[this.entityResult + 1]);
                break;
            }
            case 3: {
                this.emitCodePoint(this.entityTrie[this.entityResult + 1]);
                this.emitCodePoint(this.entityTrie[this.entityResult + 2]);
            }
        }
    }
    stateBeforeNumericEntity(c) {
        if ((c | 0x20) === CharCodes.LowerX) {
            this.entityExcess++;
            this.state = State.InHexEntity;
        }
        else {
            this.state = State.InNumericEntity;
            this.stateInNumericEntity(c);
        }
    }
    emitNumericEntity(strict) {
        const entityStart = this.index - this.entityExcess - 1;
        const numberStart = entityStart + 2 + Number(this.state === State.InHexEntity);
        if (numberStart !== this.index) {
            // Emit leading data if any
            if (entityStart > this.sectionStart) {
                this.emitPartial(this.sectionStart, entityStart);
            }
            this.sectionStart = this.index + Number(strict);
            this.emitCodePoint(replaceCodePoint(this.entityResult));
        }
        this.state = this.baseState;
    }
    stateInNumericEntity(c) {
        if (c === CharCodes.Semi) {
            this.emitNumericEntity(true);
        }
        else if (isNumber$4(c)) {
            this.entityResult = this.entityResult * 10 + (c - CharCodes.Zero);
            this.entityExcess++;
        }
        else {
            if (this.allowLegacyEntity()) {
                this.emitNumericEntity(false);
            }
            else {
                this.state = this.baseState;
            }
            this.index--;
        }
    }
    stateInHexEntity(c) {
        if (c === CharCodes.Semi) {
            this.emitNumericEntity(true);
        }
        else if (isNumber$4(c)) {
            this.entityResult = this.entityResult * 16 + (c - CharCodes.Zero);
            this.entityExcess++;
        }
        else if (isHexDigit(c)) {
            this.entityResult =
                this.entityResult * 16 + ((c | 0x20) - CharCodes.LowerA + 10);
            this.entityExcess++;
        }
        else {
            if (this.allowLegacyEntity()) {
                this.emitNumericEntity(false);
            }
            else {
                this.state = this.baseState;
            }
            this.index--;
        }
    }
    allowLegacyEntity() {
        return (!this.xmlMode &&
            (this.baseState === State.Text ||
                this.baseState === State.InSpecialTag));
    }
    /**
     * Remove data that has already been consumed from the buffer.
     */
    cleanup() {
        // If we are inside of text or attributes, emit what we already have.
        if (this.running && this.sectionStart !== this.index) {
            if (this.state === State.Text ||
                (this.state === State.InSpecialTag && this.sequenceIndex === 0)) {
                this.cbs.ontext(this.sectionStart, this.index);
                this.sectionStart = this.index;
            }
            else if (this.state === State.InAttributeValueDq ||
                this.state === State.InAttributeValueSq ||
                this.state === State.InAttributeValueNq) {
                this.cbs.onattribdata(this.sectionStart, this.index);
                this.sectionStart = this.index;
            }
        }
    }
    shouldContinue() {
        return this.index < this.buffer.length + this.offset && this.running;
    }
    /**
     * Iterates through the buffer, calling the function corresponding to the current state.
     *
     * States that are more likely to be hit are higher up, as a performance improvement.
     */
    parse() {
        while (this.shouldContinue()) {
            const c = this.buffer.charCodeAt(this.index - this.offset);
            switch (this.state) {
                case State.Text: {
                    this.stateText(c);
                    break;
                }
                case State.SpecialStartSequence: {
                    this.stateSpecialStartSequence(c);
                    break;
                }
                case State.InSpecialTag: {
                    this.stateInSpecialTag(c);
                    break;
                }
                case State.CDATASequence: {
                    this.stateCDATASequence(c);
                    break;
                }
                case State.InAttributeValueDq: {
                    this.stateInAttributeValueDoubleQuotes(c);
                    break;
                }
                case State.InAttributeName: {
                    this.stateInAttributeName(c);
                    break;
                }
                case State.InCommentLike: {
                    this.stateInCommentLike(c);
                    break;
                }
                case State.InSpecialComment: {
                    this.stateInSpecialComment(c);
                    break;
                }
                case State.BeforeAttributeName: {
                    this.stateBeforeAttributeName(c);
                    break;
                }
                case State.InTagName: {
                    this.stateInTagName(c);
                    break;
                }
                case State.InClosingTagName: {
                    this.stateInClosingTagName(c);
                    break;
                }
                case State.BeforeTagName: {
                    this.stateBeforeTagName(c);
                    break;
                }
                case State.AfterAttributeName: {
                    this.stateAfterAttributeName(c);
                    break;
                }
                case State.InAttributeValueSq: {
                    this.stateInAttributeValueSingleQuotes(c);
                    break;
                }
                case State.BeforeAttributeValue: {
                    this.stateBeforeAttributeValue(c);
                    break;
                }
                case State.BeforeClosingTagName: {
                    this.stateBeforeClosingTagName(c);
                    break;
                }
                case State.AfterClosingTagName: {
                    this.stateAfterClosingTagName(c);
                    break;
                }
                case State.BeforeSpecialS: {
                    this.stateBeforeSpecialS(c);
                    break;
                }
                case State.InAttributeValueNq: {
                    this.stateInAttributeValueNoQuotes(c);
                    break;
                }
                case State.InSelfClosingTag: {
                    this.stateInSelfClosingTag(c);
                    break;
                }
                case State.InDeclaration: {
                    this.stateInDeclaration(c);
                    break;
                }
                case State.BeforeDeclaration: {
                    this.stateBeforeDeclaration(c);
                    break;
                }
                case State.BeforeComment: {
                    this.stateBeforeComment(c);
                    break;
                }
                case State.InProcessingInstruction: {
                    this.stateInProcessingInstruction(c);
                    break;
                }
                case State.InNamedEntity: {
                    this.stateInNamedEntity(c);
                    break;
                }
                case State.BeforeEntity: {
                    this.stateBeforeEntity(c);
                    break;
                }
                case State.InHexEntity: {
                    this.stateInHexEntity(c);
                    break;
                }
                case State.InNumericEntity: {
                    this.stateInNumericEntity(c);
                    break;
                }
                default: {
                    // `this._state === State.BeforeNumericEntity`
                    this.stateBeforeNumericEntity(c);
                }
            }
            this.index++;
        }
        this.cleanup();
    }
    finish() {
        if (this.state === State.InNamedEntity) {
            this.emitNamedEntity();
        }
        // If there is remaining data, emit it in a reasonable way
        if (this.sectionStart < this.index) {
            this.handleTrailingData();
        }
        this.cbs.onend();
    }
    /** Handle any trailing data. */
    handleTrailingData() {
        const endIndex = this.buffer.length + this.offset;
        if (this.state === State.InCommentLike) {
            if (this.currentSequence === Sequences.CdataEnd) {
                this.cbs.oncdata(this.sectionStart, endIndex, 0);
            }
            else {
                this.cbs.oncomment(this.sectionStart, endIndex, 0);
            }
        }
        else if (this.state === State.InNumericEntity &&
            this.allowLegacyEntity()) {
            this.emitNumericEntity(false);
            // All trailing data will have been consumed
        }
        else if (this.state === State.InHexEntity &&
            this.allowLegacyEntity()) {
            this.emitNumericEntity(false);
            // All trailing data will have been consumed
        }
        else if (this.state === State.InTagName ||
            this.state === State.BeforeAttributeName ||
            this.state === State.BeforeAttributeValue ||
            this.state === State.AfterAttributeName ||
            this.state === State.InAttributeName ||
            this.state === State.InAttributeValueSq ||
            this.state === State.InAttributeValueDq ||
            this.state === State.InAttributeValueNq ||
            this.state === State.InClosingTagName) ;
        else {
            this.cbs.ontext(this.sectionStart, endIndex);
        }
    }
    emitPartial(start, endIndex) {
        if (this.baseState !== State.Text &&
            this.baseState !== State.InSpecialTag) {
            this.cbs.onattribdata(start, endIndex);
        }
        else {
            this.cbs.ontext(start, endIndex);
        }
    }
    emitCodePoint(cp) {
        if (this.baseState !== State.Text &&
            this.baseState !== State.InSpecialTag) {
            this.cbs.onattribentity(cp);
        }
        else {
            this.cbs.ontextentity(cp);
        }
    }
}

const formTags = new Set([
    "input",
    "option",
    "optgroup",
    "select",
    "button",
    "datalist",
    "textarea",
]);
const pTag = new Set(["p"]);
const tableSectionTags$1 = new Set(["thead", "tbody"]);
const ddtTags = new Set(["dd", "dt"]);
const rtpTags = new Set(["rt", "rp"]);
const openImpliesClose = new Map([
    ["tr", new Set(["tr", "th", "td"])],
    ["th", new Set(["th"])],
    ["td", new Set(["thead", "th", "td"])],
    ["body", new Set(["head", "link", "script"])],
    ["li", new Set(["li"])],
    ["p", pTag],
    ["h1", pTag],
    ["h2", pTag],
    ["h3", pTag],
    ["h4", pTag],
    ["h5", pTag],
    ["h6", pTag],
    ["select", formTags],
    ["input", formTags],
    ["output", formTags],
    ["button", formTags],
    ["datalist", formTags],
    ["textarea", formTags],
    ["option", new Set(["option"])],
    ["optgroup", new Set(["optgroup", "option"])],
    ["dd", ddtTags],
    ["dt", ddtTags],
    ["address", pTag],
    ["article", pTag],
    ["aside", pTag],
    ["blockquote", pTag],
    ["details", pTag],
    ["div", pTag],
    ["dl", pTag],
    ["fieldset", pTag],
    ["figcaption", pTag],
    ["figure", pTag],
    ["footer", pTag],
    ["form", pTag],
    ["header", pTag],
    ["hr", pTag],
    ["main", pTag],
    ["nav", pTag],
    ["ol", pTag],
    ["pre", pTag],
    ["section", pTag],
    ["table", pTag],
    ["ul", pTag],
    ["rt", rtpTags],
    ["rp", rtpTags],
    ["tbody", tableSectionTags$1],
    ["tfoot", tableSectionTags$1],
]);
const voidElements = new Set([
    "area",
    "base",
    "basefont",
    "br",
    "col",
    "command",
    "embed",
    "frame",
    "hr",
    "img",
    "input",
    "isindex",
    "keygen",
    "link",
    "meta",
    "param",
    "source",
    "track",
    "wbr",
]);
const foreignContextElements = new Set(["math", "svg"]);
const htmlIntegrationElements = new Set([
    "mi",
    "mo",
    "mn",
    "ms",
    "mtext",
    "annotation-xml",
    "foreignobject",
    "desc",
    "title",
]);
const reNameEnd = /\s|\//;
class Parser {
    constructor(cbs, options = {}) {
        var _a, _b, _c, _d, _e;
        this.options = options;
        /** The start index of the last event. */
        this.startIndex = 0;
        /** The end index of the last event. */
        this.endIndex = 0;
        /**
         * Store the start index of the current open tag,
         * so we can update the start index for attributes.
         */
        this.openTagStart = 0;
        this.tagname = "";
        this.attribname = "";
        this.attribvalue = "";
        this.attribs = null;
        this.stack = [];
        this.foreignContext = [];
        this.buffers = [];
        this.bufferOffset = 0;
        /** The index of the last written buffer. Used when resuming after a `pause()`. */
        this.writeIndex = 0;
        /** Indicates whether the parser has finished running / `.end` has been called. */
        this.ended = false;
        this.cbs = cbs !== null && cbs !== void 0 ? cbs : {};
        this.lowerCaseTagNames = (_a = options.lowerCaseTags) !== null && _a !== void 0 ? _a : !options.xmlMode;
        this.lowerCaseAttributeNames =
            (_b = options.lowerCaseAttributeNames) !== null && _b !== void 0 ? _b : !options.xmlMode;
        this.tokenizer = new ((_c = options.Tokenizer) !== null && _c !== void 0 ? _c : Tokenizer)(this.options, this);
        (_e = (_d = this.cbs).onparserinit) === null || _e === void 0 ? void 0 : _e.call(_d, this);
    }
    // Tokenizer event handlers
    /** @internal */
    ontext(start, endIndex) {
        var _a, _b;
        const data = this.getSlice(start, endIndex);
        this.endIndex = endIndex - 1;
        (_b = (_a = this.cbs).ontext) === null || _b === void 0 ? void 0 : _b.call(_a, data);
        this.startIndex = endIndex;
    }
    /** @internal */
    ontextentity(cp) {
        var _a, _b;
        /*
         * Entities can be emitted on the character, or directly after.
         * We use the section start here to get accurate indices.
         */
        const index = this.tokenizer.getSectionStart();
        this.endIndex = index - 1;
        (_b = (_a = this.cbs).ontext) === null || _b === void 0 ? void 0 : _b.call(_a, fromCodePoint$1(cp));
        this.startIndex = index;
    }
    isVoidElement(name) {
        return !this.options.xmlMode && voidElements.has(name);
    }
    /** @internal */
    onopentagname(start, endIndex) {
        this.endIndex = endIndex;
        let name = this.getSlice(start, endIndex);
        if (this.lowerCaseTagNames) {
            name = name.toLowerCase();
        }
        this.emitOpenTag(name);
    }
    emitOpenTag(name) {
        var _a, _b, _c, _d;
        this.openTagStart = this.startIndex;
        this.tagname = name;
        const impliesClose = !this.options.xmlMode && openImpliesClose.get(name);
        if (impliesClose) {
            while (this.stack.length > 0 &&
                impliesClose.has(this.stack[this.stack.length - 1])) {
                const element = this.stack.pop();
                (_b = (_a = this.cbs).onclosetag) === null || _b === void 0 ? void 0 : _b.call(_a, element, true);
            }
        }
        if (!this.isVoidElement(name)) {
            this.stack.push(name);
            if (foreignContextElements.has(name)) {
                this.foreignContext.push(true);
            }
            else if (htmlIntegrationElements.has(name)) {
                this.foreignContext.push(false);
            }
        }
        (_d = (_c = this.cbs).onopentagname) === null || _d === void 0 ? void 0 : _d.call(_c, name);
        if (this.cbs.onopentag)
            this.attribs = {};
    }
    endOpenTag(isImplied) {
        var _a, _b;
        this.startIndex = this.openTagStart;
        if (this.attribs) {
            (_b = (_a = this.cbs).onopentag) === null || _b === void 0 ? void 0 : _b.call(_a, this.tagname, this.attribs, isImplied);
            this.attribs = null;
        }
        if (this.cbs.onclosetag && this.isVoidElement(this.tagname)) {
            this.cbs.onclosetag(this.tagname, true);
        }
        this.tagname = "";
    }
    /** @internal */
    onopentagend(endIndex) {
        this.endIndex = endIndex;
        this.endOpenTag(false);
        // Set `startIndex` for next node
        this.startIndex = endIndex + 1;
    }
    /** @internal */
    onclosetag(start, endIndex) {
        var _a, _b, _c, _d, _e, _f;
        this.endIndex = endIndex;
        let name = this.getSlice(start, endIndex);
        if (this.lowerCaseTagNames) {
            name = name.toLowerCase();
        }
        if (foreignContextElements.has(name) ||
            htmlIntegrationElements.has(name)) {
            this.foreignContext.pop();
        }
        if (!this.isVoidElement(name)) {
            const pos = this.stack.lastIndexOf(name);
            if (pos !== -1) {
                if (this.cbs.onclosetag) {
                    let count = this.stack.length - pos;
                    while (count--) {
                        // We know the stack has sufficient elements.
                        this.cbs.onclosetag(this.stack.pop(), count !== 0);
                    }
                }
                else
                    this.stack.length = pos;
            }
            else if (!this.options.xmlMode && name === "p") {
                // Implicit open before close
                this.emitOpenTag("p");
                this.closeCurrentTag(true);
            }
        }
        else if (!this.options.xmlMode && name === "br") {
            // We can't use `emitOpenTag` for implicit open, as `br` would be implicitly closed.
            (_b = (_a = this.cbs).onopentagname) === null || _b === void 0 ? void 0 : _b.call(_a, "br");
            (_d = (_c = this.cbs).onopentag) === null || _d === void 0 ? void 0 : _d.call(_c, "br", {}, true);
            (_f = (_e = this.cbs).onclosetag) === null || _f === void 0 ? void 0 : _f.call(_e, "br", false);
        }
        // Set `startIndex` for next node
        this.startIndex = endIndex + 1;
    }
    /** @internal */
    onselfclosingtag(endIndex) {
        this.endIndex = endIndex;
        if (this.options.xmlMode ||
            this.options.recognizeSelfClosing ||
            this.foreignContext[this.foreignContext.length - 1]) {
            this.closeCurrentTag(false);
            // Set `startIndex` for next node
            this.startIndex = endIndex + 1;
        }
        else {
            // Ignore the fact that the tag is self-closing.
            this.onopentagend(endIndex);
        }
    }
    closeCurrentTag(isOpenImplied) {
        var _a, _b;
        const name = this.tagname;
        this.endOpenTag(isOpenImplied);
        // Self-closing tags will be on the top of the stack
        if (this.stack[this.stack.length - 1] === name) {
            // If the opening tag isn't implied, the closing tag has to be implied.
            (_b = (_a = this.cbs).onclosetag) === null || _b === void 0 ? void 0 : _b.call(_a, name, !isOpenImplied);
            this.stack.pop();
        }
    }
    /** @internal */
    onattribname(start, endIndex) {
        this.startIndex = start;
        const name = this.getSlice(start, endIndex);
        this.attribname = this.lowerCaseAttributeNames
            ? name.toLowerCase()
            : name;
    }
    /** @internal */
    onattribdata(start, endIndex) {
        this.attribvalue += this.getSlice(start, endIndex);
    }
    /** @internal */
    onattribentity(cp) {
        this.attribvalue += fromCodePoint$1(cp);
    }
    /** @internal */
    onattribend(quote, endIndex) {
        var _a, _b;
        this.endIndex = endIndex;
        (_b = (_a = this.cbs).onattribute) === null || _b === void 0 ? void 0 : _b.call(_a, this.attribname, this.attribvalue, quote === QuoteType.Double
            ? '"'
            : quote === QuoteType.Single
                ? "'"
                : quote === QuoteType.NoValue
                    ? undefined
                    : null);
        if (this.attribs &&
            !Object.prototype.hasOwnProperty.call(this.attribs, this.attribname)) {
            this.attribs[this.attribname] = this.attribvalue;
        }
        this.attribvalue = "";
    }
    getInstructionName(value) {
        const index = value.search(reNameEnd);
        let name = index < 0 ? value : value.substr(0, index);
        if (this.lowerCaseTagNames) {
            name = name.toLowerCase();
        }
        return name;
    }
    /** @internal */
    ondeclaration(start, endIndex) {
        this.endIndex = endIndex;
        const value = this.getSlice(start, endIndex);
        if (this.cbs.onprocessinginstruction) {
            const name = this.getInstructionName(value);
            this.cbs.onprocessinginstruction(`!${name}`, `!${value}`);
        }
        // Set `startIndex` for next node
        this.startIndex = endIndex + 1;
    }
    /** @internal */
    onprocessinginstruction(start, endIndex) {
        this.endIndex = endIndex;
        const value = this.getSlice(start, endIndex);
        if (this.cbs.onprocessinginstruction) {
            const name = this.getInstructionName(value);
            this.cbs.onprocessinginstruction(`?${name}`, `?${value}`);
        }
        // Set `startIndex` for next node
        this.startIndex = endIndex + 1;
    }
    /** @internal */
    oncomment(start, endIndex, offset) {
        var _a, _b, _c, _d;
        this.endIndex = endIndex;
        (_b = (_a = this.cbs).oncomment) === null || _b === void 0 ? void 0 : _b.call(_a, this.getSlice(start, endIndex - offset));
        (_d = (_c = this.cbs).oncommentend) === null || _d === void 0 ? void 0 : _d.call(_c);
        // Set `startIndex` for next node
        this.startIndex = endIndex + 1;
    }
    /** @internal */
    oncdata(start, endIndex, offset) {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k;
        this.endIndex = endIndex;
        const value = this.getSlice(start, endIndex - offset);
        if (this.options.xmlMode || this.options.recognizeCDATA) {
            (_b = (_a = this.cbs).oncdatastart) === null || _b === void 0 ? void 0 : _b.call(_a);
            (_d = (_c = this.cbs).ontext) === null || _d === void 0 ? void 0 : _d.call(_c, value);
            (_f = (_e = this.cbs).oncdataend) === null || _f === void 0 ? void 0 : _f.call(_e);
        }
        else {
            (_h = (_g = this.cbs).oncomment) === null || _h === void 0 ? void 0 : _h.call(_g, `[CDATA[${value}]]`);
            (_k = (_j = this.cbs).oncommentend) === null || _k === void 0 ? void 0 : _k.call(_j);
        }
        // Set `startIndex` for next node
        this.startIndex = endIndex + 1;
    }
    /** @internal */
    onend() {
        var _a, _b;
        if (this.cbs.onclosetag) {
            // Set the end index for all remaining tags
            this.endIndex = this.startIndex;
            for (let index = this.stack.length; index > 0; this.cbs.onclosetag(this.stack[--index], true))
                ;
        }
        (_b = (_a = this.cbs).onend) === null || _b === void 0 ? void 0 : _b.call(_a);
    }
    /**
     * Resets the parser to a blank state, ready to parse a new HTML document
     */
    reset() {
        var _a, _b, _c, _d;
        (_b = (_a = this.cbs).onreset) === null || _b === void 0 ? void 0 : _b.call(_a);
        this.tokenizer.reset();
        this.tagname = "";
        this.attribname = "";
        this.attribs = null;
        this.stack.length = 0;
        this.startIndex = 0;
        this.endIndex = 0;
        (_d = (_c = this.cbs).onparserinit) === null || _d === void 0 ? void 0 : _d.call(_c, this);
        this.buffers.length = 0;
        this.bufferOffset = 0;
        this.writeIndex = 0;
        this.ended = false;
    }
    /**
     * Resets the parser, then parses a complete document and
     * pushes it to the handler.
     *
     * @param data Document to parse.
     */
    parseComplete(data) {
        this.reset();
        this.end(data);
    }
    getSlice(start, end) {
        while (start - this.bufferOffset >= this.buffers[0].length) {
            this.shiftBuffer();
        }
        let slice = this.buffers[0].slice(start - this.bufferOffset, end - this.bufferOffset);
        while (end - this.bufferOffset > this.buffers[0].length) {
            this.shiftBuffer();
            slice += this.buffers[0].slice(0, end - this.bufferOffset);
        }
        return slice;
    }
    shiftBuffer() {
        this.bufferOffset += this.buffers[0].length;
        this.writeIndex--;
        this.buffers.shift();
    }
    /**
     * Parses a chunk of data and calls the corresponding callbacks.
     *
     * @param chunk Chunk to parse.
     */
    write(chunk) {
        var _a, _b;
        if (this.ended) {
            (_b = (_a = this.cbs).onerror) === null || _b === void 0 ? void 0 : _b.call(_a, new Error(".write() after done!"));
            return;
        }
        this.buffers.push(chunk);
        if (this.tokenizer.running) {
            this.tokenizer.write(chunk);
            this.writeIndex++;
        }
    }
    /**
     * Parses the end of the buffer and clears the stack, calls onend.
     *
     * @param chunk Optional final chunk to parse.
     */
    end(chunk) {
        var _a, _b;
        if (this.ended) {
            (_b = (_a = this.cbs).onerror) === null || _b === void 0 ? void 0 : _b.call(_a, new Error(".end() after done!"));
            return;
        }
        if (chunk)
            this.write(chunk);
        this.ended = true;
        this.tokenizer.end();
    }
    /**
     * Pauses parsing. The parser won't emit events until `resume` is called.
     */
    pause() {
        this.tokenizer.pause();
    }
    /**
     * Resumes parsing after `pause` was called.
     */
    resume() {
        this.tokenizer.resume();
        while (this.tokenizer.running &&
            this.writeIndex < this.buffers.length) {
            this.tokenizer.write(this.buffers[this.writeIndex++]);
        }
        if (this.ended)
            this.tokenizer.end();
    }
    /**
     * Alias of `write`, for backwards compatibility.
     *
     * @param chunk Chunk to parse.
     * @deprecated
     */
    parseChunk(chunk) {
        this.write(chunk);
    }
    /**
     * Alias of `end`, for backwards compatibility.
     *
     * @param chunk Optional final chunk to parse.
     * @deprecated
     */
    done(chunk) {
        this.end(chunk);
    }
}

// Helper methods
/**
 * Parses the data, returns the resulting document.
 *
 * @param data The data that should be parsed.
 * @param options Optional options for the parser and DOM builder.
 */
function parseDocument(data, options) {
    const handler = new DomHandler(undefined, options);
    new Parser(handler, options).end(data);
    return handler.root;
}

/**
 * Types used in signatures of Cheerio methods.
 *
 * @category Cheerio
 */
const parse$i = getParse((content, options, isDocument, context) => options.xmlMode || options._useHtmlParser2
    ? parseDocument(content, options)
    : parseWithParse5(content, options, isDocument, context));
// Duplicate docs due to https://github.com/TypeStrong/typedoc/issues/1616
/**
 * Create a querying function, bound to a document created from the provided markup.
 *
 * Note that similar to web browser contexts, this operation may introduce
 * `<html>`, `<head>`, and `<body>` elements; set `isDocument` to `false` to
 * switch to fragment mode and disable this.
 *
 * @param content - Markup to be loaded.
 * @param options - Options for the created instance.
 * @param isDocument - Allows parser to be switched to fragment mode.
 * @returns The loaded document.
 * @see {@link https://cheerio.js.org#loading} for additional usage information.
 */
const load = getLoad(parse$i, (dom, options) => options.xmlMode || options._useHtmlParser2
    ? render$2(dom, options)
    : renderWithParse5(dom));
/**
 * The default cheerio instance.
 *
 * @deprecated Use the function returned by `load` instead.
 */
var cheerio = load([]);

/*!
 * vite-plugin-qiankun.js v1.0.14
 * (c) 2021-2022 Teng Mao Qing
 * Released under the MIT License.
 */

/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

function __spreadArray$3(to, from) {
    for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
        to[j] = from[i];
    return to;
}

var createQiankunHelper = function (qiankunName) { return "\n  const createDeffer = (hookName) => {\n    const d = new Promise((resolve, reject) => {\n      window.proxy && (window.proxy[`vite${hookName}`] = resolve)\n    })\n    return props => d.then(fn => fn(props));\n  }\n  const bootstrap = createDeffer('bootstrap');\n  const mount = createDeffer('mount');\n  const unmount = createDeffer('unmount');\n  const update = createDeffer('update');\n\n  ;(global => {\n    global.qiankunName = '" + qiankunName + "';\n    global['" + qiankunName + "'] = {\n      bootstrap,\n      mount,\n      unmount,\n      update\n    };\n  })(window);\n"; };
var createImportFinallyResolve = function (qiankunName) {
    return "\n    const qiankunLifeCycle = window.moudleQiankunAppLifeCycles && window.moudleQiankunAppLifeCycles['" + qiankunName + "'];\n    if (qiankunLifeCycle) {\n      window.proxy.vitemount((props) => qiankunLifeCycle.mount(props));\n      window.proxy.viteunmount((props) => qiankunLifeCycle.unmount(props));\n      window.proxy.vitebootstrap(() => qiankunLifeCycle.bootstrap());\n      window.proxy.viteupdate((props) => qiankunLifeCycle.update(props));\n    }\n  ";
};
var htmlPlugin = function (qiankunName, microOption) {
    if (microOption === void 0) { microOption = {}; }
    var isProduction;
    var base = '';
    var module2DynamicImport = function ($, scriptTag) {
        if (!scriptTag) {
            return;
        }
        var script$ = $(scriptTag);
        var moduleSrc = script$.attr('src');
        var appendBase = '';
        if (microOption.useDevMode && !isProduction) {
            appendBase = '(window.proxy ? (window.proxy.__INJECTED_PUBLIC_PATH_BY_QIANKUN__ + \'..\') : \'\') + ';
        }
        script$.removeAttr('src');
        script$.removeAttr('type');
        script$.html("import(" + appendBase + "'" + moduleSrc + "')");
        return script$;
    };
    return {
        name: 'qiankun-html-transform',
        configResolved: function (config) {
            isProduction = config.command === 'build' || config.isProduction;
            base = config.base;
        },
        configureServer: function (server) {
            return function () {
                server.middlewares.use(function (req, res, next) {
                    if (isProduction || !microOption.useDevMode) {
                        next();
                        return;
                    }
                    var end = res.end.bind(res);
                    res.end = function () {
                        var args = [];
                        for (var _i = 0; _i < arguments.length; _i++) {
                            args[_i] = arguments[_i];
                        }
                        var htmlStr = args[0], rest = args.slice(1);
                        if (typeof htmlStr === 'string') {
                            var $ = cheerio.load(htmlStr);
                            module2DynamicImport($, $("script[src=" + base + "@vite/client]").get(0));
                            htmlStr = $.html();
                        }
                        end.apply(void 0, __spreadArray$3([htmlStr], rest));
                    };
                    next();
                });
            };
        },
        transformIndexHtml: function (html) {
            var $ = cheerio.load(html);
            var moduleTags = $('body script[type=module], head script[crossorigin=""]');
            if (!moduleTags || !moduleTags.length) {
                return;
            }
            var len = moduleTags.length;
            moduleTags.each(function (i, moduleTag) {
                var script$ = module2DynamicImport($, moduleTag);
                if (len - 1 === i) {
                    script$ === null || script$ === void 0 ? void 0 : script$.html(script$.html() + ".finally(() => {\n            " + createImportFinallyResolve(qiankunName) + "\n          })");
                }
            });
            $('body').append("<script>" + createQiankunHelper(qiankunName) + "</script>");
            var output = $.html();
            return output;
        }
    };
};

var utils$s = {};

const path$L = path__default["default"];
const WIN_SLASH = '\\\\/';
const WIN_NO_SLASH = `[^${WIN_SLASH}]`;

/**
 * Posix glob regex
 */

const DOT_LITERAL = '\\.';
const PLUS_LITERAL = '\\+';
const QMARK_LITERAL = '\\?';
const SLASH_LITERAL = '\\/';
const ONE_CHAR = '(?=.)';
const QMARK = '[^/]';
const END_ANCHOR = `(?:${SLASH_LITERAL}|$)`;
const START_ANCHOR = `(?:^|${SLASH_LITERAL})`;
const DOTS_SLASH = `${DOT_LITERAL}{1,2}${END_ANCHOR}`;
const NO_DOT = `(?!${DOT_LITERAL})`;
const NO_DOTS = `(?!${START_ANCHOR}${DOTS_SLASH})`;
const NO_DOT_SLASH = `(?!${DOT_LITERAL}{0,1}${END_ANCHOR})`;
const NO_DOTS_SLASH = `(?!${DOTS_SLASH})`;
const QMARK_NO_DOT = `[^.${SLASH_LITERAL}]`;
const STAR = `${QMARK}*?`;

const POSIX_CHARS = {
  DOT_LITERAL,
  PLUS_LITERAL,
  QMARK_LITERAL,
  SLASH_LITERAL,
  ONE_CHAR,
  QMARK,
  END_ANCHOR,
  DOTS_SLASH,
  NO_DOT,
  NO_DOTS,
  NO_DOT_SLASH,
  NO_DOTS_SLASH,
  QMARK_NO_DOT,
  STAR,
  START_ANCHOR
};

/**
 * Windows glob regex
 */

const WINDOWS_CHARS = {
  ...POSIX_CHARS,

  SLASH_LITERAL: `[${WIN_SLASH}]`,
  QMARK: WIN_NO_SLASH,
  STAR: `${WIN_NO_SLASH}*?`,
  DOTS_SLASH: `${DOT_LITERAL}{1,2}(?:[${WIN_SLASH}]|$)`,
  NO_DOT: `(?!${DOT_LITERAL})`,
  NO_DOTS: `(?!(?:^|[${WIN_SLASH}])${DOT_LITERAL}{1,2}(?:[${WIN_SLASH}]|$))`,
  NO_DOT_SLASH: `(?!${DOT_LITERAL}{0,1}(?:[${WIN_SLASH}]|$))`,
  NO_DOTS_SLASH: `(?!${DOT_LITERAL}{1,2}(?:[${WIN_SLASH}]|$))`,
  QMARK_NO_DOT: `[^.${WIN_SLASH}]`,
  START_ANCHOR: `(?:^|[${WIN_SLASH}])`,
  END_ANCHOR: `(?:[${WIN_SLASH}]|$)`
};

/**
 * POSIX Bracket Regex
 */

const POSIX_REGEX_SOURCE$1 = {
  alnum: 'a-zA-Z0-9',
  alpha: 'a-zA-Z',
  ascii: '\\x00-\\x7F',
  blank: ' \\t',
  cntrl: '\\x00-\\x1F\\x7F',
  digit: '0-9',
  graph: '\\x21-\\x7E',
  lower: 'a-z',
  print: '\\x20-\\x7E ',
  punct: '\\-!"#$%&\'()\\*+,./:;<=>?@[\\]^_`{|}~',
  space: ' \\t\\r\\n\\v\\f',
  upper: 'A-Z',
  word: 'A-Za-z0-9_',
  xdigit: 'A-Fa-f0-9'
};

var constants$b = {
  MAX_LENGTH: 1024 * 64,
  POSIX_REGEX_SOURCE: POSIX_REGEX_SOURCE$1,

  // regular expressions
  REGEX_BACKSLASH: /\\(?![*+?^${}(|)[\]])/g,
  REGEX_NON_SPECIAL_CHARS: /^[^@![\].,$*+?^{}()|\\/]+/,
  REGEX_SPECIAL_CHARS: /[-*+?.^${}(|)[\]]/,
  REGEX_SPECIAL_CHARS_BACKREF: /(\\?)((\W)(\3*))/g,
  REGEX_SPECIAL_CHARS_GLOBAL: /([-*+?.^${}(|)[\]])/g,
  REGEX_REMOVE_BACKSLASH: /(?:\[.*?[^\\]\]|\\(?=.))/g,

  // Replace globs with equivalent patterns to reduce parsing time.
  REPLACEMENTS: {
    '***': '*',
    '**/**': '**',
    '**/**/**': '**'
  },

  // Digits
  CHAR_0: 48, /* 0 */
  CHAR_9: 57, /* 9 */

  // Alphabet chars.
  CHAR_UPPERCASE_A: 65, /* A */
  CHAR_LOWERCASE_A: 97, /* a */
  CHAR_UPPERCASE_Z: 90, /* Z */
  CHAR_LOWERCASE_Z: 122, /* z */

  CHAR_LEFT_PARENTHESES: 40, /* ( */
  CHAR_RIGHT_PARENTHESES: 41, /* ) */

  CHAR_ASTERISK: 42, /* * */

  // Non-alphabetic chars.
  CHAR_AMPERSAND: 38, /* & */
  CHAR_AT: 64, /* @ */
  CHAR_BACKWARD_SLASH: 92, /* \ */
  CHAR_CARRIAGE_RETURN: 13, /* \r */
  CHAR_CIRCUMFLEX_ACCENT: 94, /* ^ */
  CHAR_COLON: 58, /* : */
  CHAR_COMMA: 44, /* , */
  CHAR_DOT: 46, /* . */
  CHAR_DOUBLE_QUOTE: 34, /* " */
  CHAR_EQUAL: 61, /* = */
  CHAR_EXCLAMATION_MARK: 33, /* ! */
  CHAR_FORM_FEED: 12, /* \f */
  CHAR_FORWARD_SLASH: 47, /* / */
  CHAR_GRAVE_ACCENT: 96, /* ` */
  CHAR_HASH: 35, /* # */
  CHAR_HYPHEN_MINUS: 45, /* - */
  CHAR_LEFT_ANGLE_BRACKET: 60, /* < */
  CHAR_LEFT_CURLY_BRACE: 123, /* { */
  CHAR_LEFT_SQUARE_BRACKET: 91, /* [ */
  CHAR_LINE_FEED: 10, /* \n */
  CHAR_NO_BREAK_SPACE: 160, /* \u00A0 */
  CHAR_PERCENT: 37, /* % */
  CHAR_PLUS: 43, /* + */
  CHAR_QUESTION_MARK: 63, /* ? */
  CHAR_RIGHT_ANGLE_BRACKET: 62, /* > */
  CHAR_RIGHT_CURLY_BRACE: 125, /* } */
  CHAR_RIGHT_SQUARE_BRACKET: 93, /* ] */
  CHAR_SEMICOLON: 59, /* ; */
  CHAR_SINGLE_QUOTE: 39, /* ' */
  CHAR_SPACE: 32, /*   */
  CHAR_TAB: 9, /* \t */
  CHAR_UNDERSCORE: 95, /* _ */
  CHAR_VERTICAL_LINE: 124, /* | */
  CHAR_ZERO_WIDTH_NOBREAK_SPACE: 65279, /* \uFEFF */

  SEP: path$L.sep,

  /**
   * Create EXTGLOB_CHARS
   */

  extglobChars(chars) {
    return {
      '!': { type: 'negate', open: '(?:(?!(?:', close: `))${chars.STAR})` },
      '?': { type: 'qmark', open: '(?:', close: ')?' },
      '+': { type: 'plus', open: '(?:', close: ')+' },
      '*': { type: 'star', open: '(?:', close: ')*' },
      '@': { type: 'at', open: '(?:', close: ')' }
    };
  },

  /**
   * Create GLOB_CHARS
   */

  globChars(win32) {
    return win32 === true ? WINDOWS_CHARS : POSIX_CHARS;
  }
};

(function (exports) {

	const path = path__default["default"];
	const win32 = process.platform === 'win32';
	const {
	  REGEX_BACKSLASH,
	  REGEX_REMOVE_BACKSLASH,
	  REGEX_SPECIAL_CHARS,
	  REGEX_SPECIAL_CHARS_GLOBAL
	} = constants$b;

	exports.isObject = val => val !== null && typeof val === 'object' && !Array.isArray(val);
	exports.hasRegexChars = str => REGEX_SPECIAL_CHARS.test(str);
	exports.isRegexChar = str => str.length === 1 && exports.hasRegexChars(str);
	exports.escapeRegex = str => str.replace(REGEX_SPECIAL_CHARS_GLOBAL, '\\$1');
	exports.toPosixSlashes = str => str.replace(REGEX_BACKSLASH, '/');

	exports.removeBackslashes = str => {
	  return str.replace(REGEX_REMOVE_BACKSLASH, match => {
	    return match === '\\' ? '' : match;
	  });
	};

	exports.supportsLookbehinds = () => {
	  const segs = process.version.slice(1).split('.').map(Number);
	  if (segs.length === 3 && segs[0] >= 9 || (segs[0] === 8 && segs[1] >= 10)) {
	    return true;
	  }
	  return false;
	};

	exports.isWindows = options => {
	  if (options && typeof options.windows === 'boolean') {
	    return options.windows;
	  }
	  return win32 === true || path.sep === '\\';
	};

	exports.escapeLast = (input, char, lastIdx) => {
	  const idx = input.lastIndexOf(char, lastIdx);
	  if (idx === -1) return input;
	  if (input[idx - 1] === '\\') return exports.escapeLast(input, char, idx - 1);
	  return `${input.slice(0, idx)}\\${input.slice(idx)}`;
	};

	exports.removePrefix = (input, state = {}) => {
	  let output = input;
	  if (output.startsWith('./')) {
	    output = output.slice(2);
	    state.prefix = './';
	  }
	  return output;
	};

	exports.wrapOutput = (input, state = {}, options = {}) => {
	  const prepend = options.contains ? '' : '^';
	  const append = options.contains ? '' : '$';

	  let output = `${prepend}(?:${input})${append}`;
	  if (state.negated === true) {
	    output = `(?:^(?!${output}).*$)`;
	  }
	  return output;
	}; 
} (utils$s));

const utils$r = utils$s;
const {
  CHAR_ASTERISK,             /* * */
  CHAR_AT,                   /* @ */
  CHAR_BACKWARD_SLASH,       /* \ */
  CHAR_COMMA: CHAR_COMMA$1,                /* , */
  CHAR_DOT: CHAR_DOT$1,                  /* . */
  CHAR_EXCLAMATION_MARK,     /* ! */
  CHAR_FORWARD_SLASH,        /* / */
  CHAR_LEFT_CURLY_BRACE: CHAR_LEFT_CURLY_BRACE$1,     /* { */
  CHAR_LEFT_PARENTHESES: CHAR_LEFT_PARENTHESES$1,     /* ( */
  CHAR_LEFT_SQUARE_BRACKET: CHAR_LEFT_SQUARE_BRACKET$1,  /* [ */
  CHAR_PLUS,                 /* + */
  CHAR_QUESTION_MARK,        /* ? */
  CHAR_RIGHT_CURLY_BRACE: CHAR_RIGHT_CURLY_BRACE$1,    /* } */
  CHAR_RIGHT_PARENTHESES: CHAR_RIGHT_PARENTHESES$1,    /* ) */
  CHAR_RIGHT_SQUARE_BRACKET: CHAR_RIGHT_SQUARE_BRACKET$1  /* ] */
} = constants$b;

const isPathSeparator = code => {
  return code === CHAR_FORWARD_SLASH || code === CHAR_BACKWARD_SLASH;
};

const depth = token => {
  if (token.isPrefix !== true) {
    token.depth = token.isGlobstar ? Infinity : 1;
  }
};

/**
 * Quickly scans a glob pattern and returns an object with a handful of
 * useful properties, like `isGlob`, `path` (the leading non-glob, if it exists),
 * `glob` (the actual pattern), `negated` (true if the path starts with `!` but not
 * with `!(`) and `negatedExtglob` (true if the path starts with `!(`).
 *
 * ```js
 * const pm = require('picomatch');
 * console.log(pm.scan('foo/bar/*.js'));
 * { isGlob: true, input: 'foo/bar/*.js', base: 'foo/bar', glob: '*.js' }
 * ```
 * @param {String} `str`
 * @param {Object} `options`
 * @return {Object} Returns an object with tokens and regex source string.
 * @api public
 */

const scan$1 = (input, options) => {
  const opts = options || {};

  const length = input.length - 1;
  const scanToEnd = opts.parts === true || opts.scanToEnd === true;
  const slashes = [];
  const tokens = [];
  const parts = [];

  let str = input;
  let index = -1;
  let start = 0;
  let lastIndex = 0;
  let isBrace = false;
  let isBracket = false;
  let isGlob = false;
  let isExtglob = false;
  let isGlobstar = false;
  let braceEscaped = false;
  let backslashes = false;
  let negated = false;
  let negatedExtglob = false;
  let finished = false;
  let braces = 0;
  let prev;
  let code;
  let token = { value: '', depth: 0, isGlob: false };

  const eos = () => index >= length;
  const peek = () => str.charCodeAt(index + 1);
  const advance = () => {
    prev = code;
    return str.charCodeAt(++index);
  };

  while (index < length) {
    code = advance();
    let next;

    if (code === CHAR_BACKWARD_SLASH) {
      backslashes = token.backslashes = true;
      code = advance();

      if (code === CHAR_LEFT_CURLY_BRACE$1) {
        braceEscaped = true;
      }
      continue;
    }

    if (braceEscaped === true || code === CHAR_LEFT_CURLY_BRACE$1) {
      braces++;

      while (eos() !== true && (code = advance())) {
        if (code === CHAR_BACKWARD_SLASH) {
          backslashes = token.backslashes = true;
          advance();
          continue;
        }

        if (code === CHAR_LEFT_CURLY_BRACE$1) {
          braces++;
          continue;
        }

        if (braceEscaped !== true && code === CHAR_DOT$1 && (code = advance()) === CHAR_DOT$1) {
          isBrace = token.isBrace = true;
          isGlob = token.isGlob = true;
          finished = true;

          if (scanToEnd === true) {
            continue;
          }

          break;
        }

        if (braceEscaped !== true && code === CHAR_COMMA$1) {
          isBrace = token.isBrace = true;
          isGlob = token.isGlob = true;
          finished = true;

          if (scanToEnd === true) {
            continue;
          }

          break;
        }

        if (code === CHAR_RIGHT_CURLY_BRACE$1) {
          braces--;

          if (braces === 0) {
            braceEscaped = false;
            isBrace = token.isBrace = true;
            finished = true;
            break;
          }
        }
      }

      if (scanToEnd === true) {
        continue;
      }

      break;
    }

    if (code === CHAR_FORWARD_SLASH) {
      slashes.push(index);
      tokens.push(token);
      token = { value: '', depth: 0, isGlob: false };

      if (finished === true) continue;
      if (prev === CHAR_DOT$1 && index === (start + 1)) {
        start += 2;
        continue;
      }

      lastIndex = index + 1;
      continue;
    }

    if (opts.noext !== true) {
      const isExtglobChar = code === CHAR_PLUS
        || code === CHAR_AT
        || code === CHAR_ASTERISK
        || code === CHAR_QUESTION_MARK
        || code === CHAR_EXCLAMATION_MARK;

      if (isExtglobChar === true && peek() === CHAR_LEFT_PARENTHESES$1) {
        isGlob = token.isGlob = true;
        isExtglob = token.isExtglob = true;
        finished = true;
        if (code === CHAR_EXCLAMATION_MARK && index === start) {
          negatedExtglob = true;
        }

        if (scanToEnd === true) {
          while (eos() !== true && (code = advance())) {
            if (code === CHAR_BACKWARD_SLASH) {
              backslashes = token.backslashes = true;
              code = advance();
              continue;
            }

            if (code === CHAR_RIGHT_PARENTHESES$1) {
              isGlob = token.isGlob = true;
              finished = true;
              break;
            }
          }
          continue;
        }
        break;
      }
    }

    if (code === CHAR_ASTERISK) {
      if (prev === CHAR_ASTERISK) isGlobstar = token.isGlobstar = true;
      isGlob = token.isGlob = true;
      finished = true;

      if (scanToEnd === true) {
        continue;
      }
      break;
    }

    if (code === CHAR_QUESTION_MARK) {
      isGlob = token.isGlob = true;
      finished = true;

      if (scanToEnd === true) {
        continue;
      }
      break;
    }

    if (code === CHAR_LEFT_SQUARE_BRACKET$1) {
      while (eos() !== true && (next = advance())) {
        if (next === CHAR_BACKWARD_SLASH) {
          backslashes = token.backslashes = true;
          advance();
          continue;
        }

        if (next === CHAR_RIGHT_SQUARE_BRACKET$1) {
          isBracket = token.isBracket = true;
          isGlob = token.isGlob = true;
          finished = true;
          break;
        }
      }

      if (scanToEnd === true) {
        continue;
      }

      break;
    }

    if (opts.nonegate !== true && code === CHAR_EXCLAMATION_MARK && index === start) {
      negated = token.negated = true;
      start++;
      continue;
    }

    if (opts.noparen !== true && code === CHAR_LEFT_PARENTHESES$1) {
      isGlob = token.isGlob = true;

      if (scanToEnd === true) {
        while (eos() !== true && (code = advance())) {
          if (code === CHAR_LEFT_PARENTHESES$1) {
            backslashes = token.backslashes = true;
            code = advance();
            continue;
          }

          if (code === CHAR_RIGHT_PARENTHESES$1) {
            finished = true;
            break;
          }
        }
        continue;
      }
      break;
    }

    if (isGlob === true) {
      finished = true;

      if (scanToEnd === true) {
        continue;
      }

      break;
    }
  }

  if (opts.noext === true) {
    isExtglob = false;
    isGlob = false;
  }

  let base = str;
  let prefix = '';
  let glob = '';

  if (start > 0) {
    prefix = str.slice(0, start);
    str = str.slice(start);
    lastIndex -= start;
  }

  if (base && isGlob === true && lastIndex > 0) {
    base = str.slice(0, lastIndex);
    glob = str.slice(lastIndex);
  } else if (isGlob === true) {
    base = '';
    glob = str;
  } else {
    base = str;
  }

  if (base && base !== '' && base !== '/' && base !== str) {
    if (isPathSeparator(base.charCodeAt(base.length - 1))) {
      base = base.slice(0, -1);
    }
  }

  if (opts.unescape === true) {
    if (glob) glob = utils$r.removeBackslashes(glob);

    if (base && backslashes === true) {
      base = utils$r.removeBackslashes(base);
    }
  }

  const state = {
    prefix,
    input,
    start,
    base,
    glob,
    isBrace,
    isBracket,
    isGlob,
    isExtglob,
    isGlobstar,
    negated,
    negatedExtglob
  };

  if (opts.tokens === true) {
    state.maxDepth = 0;
    if (!isPathSeparator(code)) {
      tokens.push(token);
    }
    state.tokens = tokens;
  }

  if (opts.parts === true || opts.tokens === true) {
    let prevIndex;

    for (let idx = 0; idx < slashes.length; idx++) {
      const n = prevIndex ? prevIndex + 1 : start;
      const i = slashes[idx];
      const value = input.slice(n, i);
      if (opts.tokens) {
        if (idx === 0 && start !== 0) {
          tokens[idx].isPrefix = true;
          tokens[idx].value = prefix;
        } else {
          tokens[idx].value = value;
        }
        depth(tokens[idx]);
        state.maxDepth += tokens[idx].depth;
      }
      if (idx !== 0 || value !== '') {
        parts.push(value);
      }
      prevIndex = i;
    }

    if (prevIndex && prevIndex + 1 < input.length) {
      const value = input.slice(prevIndex + 1);
      parts.push(value);

      if (opts.tokens) {
        tokens[tokens.length - 1].value = value;
        depth(tokens[tokens.length - 1]);
        state.maxDepth += tokens[tokens.length - 1].depth;
      }
    }

    state.slashes = slashes;
    state.parts = parts;
  }

  return state;
};

var scan_1 = scan$1;

const constants$a = constants$b;
const utils$q = utils$s;

/**
 * Constants
 */

const {
  MAX_LENGTH: MAX_LENGTH$1,
  POSIX_REGEX_SOURCE,
  REGEX_NON_SPECIAL_CHARS,
  REGEX_SPECIAL_CHARS_BACKREF,
  REPLACEMENTS
} = constants$a;

/**
 * Helpers
 */

const expandRange = (args, options) => {
  if (typeof options.expandRange === 'function') {
    return options.expandRange(...args, options);
  }

  args.sort();
  const value = `[${args.join('-')}]`;

  try {
    /* eslint-disable-next-line no-new */
    new RegExp(value);
  } catch (ex) {
    return args.map(v => utils$q.escapeRegex(v)).join('..');
  }

  return value;
};

/**
 * Create the message for a syntax error
 */

const syntaxError$1 = (type, char) => {
  return `Missing ${type}: "${char}" - use "\\\\${char}" to match literal characters`;
};

/**
 * Parse the given input string.
 * @param {String} input
 * @param {Object} options
 * @return {Object}
 */

const parse$h = (input, options) => {
  if (typeof input !== 'string') {
    throw new TypeError('Expected a string');
  }

  input = REPLACEMENTS[input] || input;

  const opts = { ...options };
  const max = typeof opts.maxLength === 'number' ? Math.min(MAX_LENGTH$1, opts.maxLength) : MAX_LENGTH$1;

  let len = input.length;
  if (len > max) {
    throw new SyntaxError(`Input length: ${len}, exceeds maximum allowed length: ${max}`);
  }

  const bos = { type: 'bos', value: '', output: opts.prepend || '' };
  const tokens = [bos];

  const capture = opts.capture ? '' : '?:';
  const win32 = utils$q.isWindows(options);

  // create constants based on platform, for windows or posix
  const PLATFORM_CHARS = constants$a.globChars(win32);
  const EXTGLOB_CHARS = constants$a.extglobChars(PLATFORM_CHARS);

  const {
    DOT_LITERAL,
    PLUS_LITERAL,
    SLASH_LITERAL,
    ONE_CHAR,
    DOTS_SLASH,
    NO_DOT,
    NO_DOT_SLASH,
    NO_DOTS_SLASH,
    QMARK,
    QMARK_NO_DOT,
    STAR,
    START_ANCHOR
  } = PLATFORM_CHARS;

  const globstar = opts => {
    return `(${capture}(?:(?!${START_ANCHOR}${opts.dot ? DOTS_SLASH : DOT_LITERAL}).)*?)`;
  };

  const nodot = opts.dot ? '' : NO_DOT;
  const qmarkNoDot = opts.dot ? QMARK : QMARK_NO_DOT;
  let star = opts.bash === true ? globstar(opts) : STAR;

  if (opts.capture) {
    star = `(${star})`;
  }

  // minimatch options support
  if (typeof opts.noext === 'boolean') {
    opts.noextglob = opts.noext;
  }

  const state = {
    input,
    index: -1,
    start: 0,
    dot: opts.dot === true,
    consumed: '',
    output: '',
    prefix: '',
    backtrack: false,
    negated: false,
    brackets: 0,
    braces: 0,
    parens: 0,
    quotes: 0,
    globstar: false,
    tokens
  };

  input = utils$q.removePrefix(input, state);
  len = input.length;

  const extglobs = [];
  const braces = [];
  const stack = [];
  let prev = bos;
  let value;

  /**
   * Tokenizing helpers
   */

  const eos = () => state.index === len - 1;
  const peek = state.peek = (n = 1) => input[state.index + n];
  const advance = state.advance = () => input[++state.index] || '';
  const remaining = () => input.slice(state.index + 1);
  const consume = (value = '', num = 0) => {
    state.consumed += value;
    state.index += num;
  };

  const append = token => {
    state.output += token.output != null ? token.output : token.value;
    consume(token.value);
  };

  const negate = () => {
    let count = 1;

    while (peek() === '!' && (peek(2) !== '(' || peek(3) === '?')) {
      advance();
      state.start++;
      count++;
    }

    if (count % 2 === 0) {
      return false;
    }

    state.negated = true;
    state.start++;
    return true;
  };

  const increment = type => {
    state[type]++;
    stack.push(type);
  };

  const decrement = type => {
    state[type]--;
    stack.pop();
  };

  /**
   * Push tokens onto the tokens array. This helper speeds up
   * tokenizing by 1) helping us avoid backtracking as much as possible,
   * and 2) helping us avoid creating extra tokens when consecutive
   * characters are plain text. This improves performance and simplifies
   * lookbehinds.
   */

  const push = tok => {
    if (prev.type === 'globstar') {
      const isBrace = state.braces > 0 && (tok.type === 'comma' || tok.type === 'brace');
      const isExtglob = tok.extglob === true || (extglobs.length && (tok.type === 'pipe' || tok.type === 'paren'));

      if (tok.type !== 'slash' && tok.type !== 'paren' && !isBrace && !isExtglob) {
        state.output = state.output.slice(0, -prev.output.length);
        prev.type = 'star';
        prev.value = '*';
        prev.output = star;
        state.output += prev.output;
      }
    }

    if (extglobs.length && tok.type !== 'paren') {
      extglobs[extglobs.length - 1].inner += tok.value;
    }

    if (tok.value || tok.output) append(tok);
    if (prev && prev.type === 'text' && tok.type === 'text') {
      prev.value += tok.value;
      prev.output = (prev.output || '') + tok.value;
      return;
    }

    tok.prev = prev;
    tokens.push(tok);
    prev = tok;
  };

  const extglobOpen = (type, value) => {
    const token = { ...EXTGLOB_CHARS[value], conditions: 1, inner: '' };

    token.prev = prev;
    token.parens = state.parens;
    token.output = state.output;
    const output = (opts.capture ? '(' : '') + token.open;

    increment('parens');
    push({ type, value, output: state.output ? '' : ONE_CHAR });
    push({ type: 'paren', extglob: true, value: advance(), output });
    extglobs.push(token);
  };

  const extglobClose = token => {
    let output = token.close + (opts.capture ? ')' : '');
    let rest;

    if (token.type === 'negate') {
      let extglobStar = star;

      if (token.inner && token.inner.length > 1 && token.inner.includes('/')) {
        extglobStar = globstar(opts);
      }

      if (extglobStar !== star || eos() || /^\)+$/.test(remaining())) {
        output = token.close = `)$))${extglobStar}`;
      }

      if (token.inner.includes('*') && (rest = remaining()) && /^\.[^\\/.]+$/.test(rest)) {
        // Any non-magical string (`.ts`) or even nested expression (`.{ts,tsx}`) can follow after the closing parenthesis.
        // In this case, we need to parse the string and use it in the output of the original pattern.
        // Suitable patterns: `/!(*.d).ts`, `/!(*.d).{ts,tsx}`, `**/!(*-dbg).@(js)`.
        //
        // Disabling the `fastpaths` option due to a problem with parsing strings as `.ts` in the pattern like `**/!(*.d).ts`.
        const expression = parse$h(rest, { ...options, fastpaths: false }).output;

        output = token.close = `)${expression})${extglobStar})`;
      }

      if (token.prev.type === 'bos') {
        state.negatedExtglob = true;
      }
    }

    push({ type: 'paren', extglob: true, value, output });
    decrement('parens');
  };

  /**
   * Fast paths
   */

  if (opts.fastpaths !== false && !/(^[*!]|[/()[\]{}"])/.test(input)) {
    let backslashes = false;

    let output = input.replace(REGEX_SPECIAL_CHARS_BACKREF, (m, esc, chars, first, rest, index) => {
      if (first === '\\') {
        backslashes = true;
        return m;
      }

      if (first === '?') {
        if (esc) {
          return esc + first + (rest ? QMARK.repeat(rest.length) : '');
        }
        if (index === 0) {
          return qmarkNoDot + (rest ? QMARK.repeat(rest.length) : '');
        }
        return QMARK.repeat(chars.length);
      }

      if (first === '.') {
        return DOT_LITERAL.repeat(chars.length);
      }

      if (first === '*') {
        if (esc) {
          return esc + first + (rest ? star : '');
        }
        return star;
      }
      return esc ? m : `\\${m}`;
    });

    if (backslashes === true) {
      if (opts.unescape === true) {
        output = output.replace(/\\/g, '');
      } else {
        output = output.replace(/\\+/g, m => {
          return m.length % 2 === 0 ? '\\\\' : (m ? '\\' : '');
        });
      }
    }

    if (output === input && opts.contains === true) {
      state.output = input;
      return state;
    }

    state.output = utils$q.wrapOutput(output, state, options);
    return state;
  }

  /**
   * Tokenize input until we reach end-of-string
   */

  while (!eos()) {
    value = advance();

    if (value === '\u0000') {
      continue;
    }

    /**
     * Escaped characters
     */

    if (value === '\\') {
      const next = peek();

      if (next === '/' && opts.bash !== true) {
        continue;
      }

      if (next === '.' || next === ';') {
        continue;
      }

      if (!next) {
        value += '\\';
        push({ type: 'text', value });
        continue;
      }

      // collapse slashes to reduce potential for exploits
      const match = /^\\+/.exec(remaining());
      let slashes = 0;

      if (match && match[0].length > 2) {
        slashes = match[0].length;
        state.index += slashes;
        if (slashes % 2 !== 0) {
          value += '\\';
        }
      }

      if (opts.unescape === true) {
        value = advance();
      } else {
        value += advance();
      }

      if (state.brackets === 0) {
        push({ type: 'text', value });
        continue;
      }
    }

    /**
     * If we're inside a regex character class, continue
     * until we reach the closing bracket.
     */

    if (state.brackets > 0 && (value !== ']' || prev.value === '[' || prev.value === '[^')) {
      if (opts.posix !== false && value === ':') {
        const inner = prev.value.slice(1);
        if (inner.includes('[')) {
          prev.posix = true;

          if (inner.includes(':')) {
            const idx = prev.value.lastIndexOf('[');
            const pre = prev.value.slice(0, idx);
            const rest = prev.value.slice(idx + 2);
            const posix = POSIX_REGEX_SOURCE[rest];
            if (posix) {
              prev.value = pre + posix;
              state.backtrack = true;
              advance();

              if (!bos.output && tokens.indexOf(prev) === 1) {
                bos.output = ONE_CHAR;
              }
              continue;
            }
          }
        }
      }

      if ((value === '[' && peek() !== ':') || (value === '-' && peek() === ']')) {
        value = `\\${value}`;
      }

      if (value === ']' && (prev.value === '[' || prev.value === '[^')) {
        value = `\\${value}`;
      }

      if (opts.posix === true && value === '!' && prev.value === '[') {
        value = '^';
      }

      prev.value += value;
      append({ value });
      continue;
    }

    /**
     * If we're inside a quoted string, continue
     * until we reach the closing double quote.
     */

    if (state.quotes === 1 && value !== '"') {
      value = utils$q.escapeRegex(value);
      prev.value += value;
      append({ value });
      continue;
    }

    /**
     * Double quotes
     */

    if (value === '"') {
      state.quotes = state.quotes === 1 ? 0 : 1;
      if (opts.keepQuotes === true) {
        push({ type: 'text', value });
      }
      continue;
    }

    /**
     * Parentheses
     */

    if (value === '(') {
      increment('parens');
      push({ type: 'paren', value });
      continue;
    }

    if (value === ')') {
      if (state.parens === 0 && opts.strictBrackets === true) {
        throw new SyntaxError(syntaxError$1('opening', '('));
      }

      const extglob = extglobs[extglobs.length - 1];
      if (extglob && state.parens === extglob.parens + 1) {
        extglobClose(extglobs.pop());
        continue;
      }

      push({ type: 'paren', value, output: state.parens ? ')' : '\\)' });
      decrement('parens');
      continue;
    }

    /**
     * Square brackets
     */

    if (value === '[') {
      if (opts.nobracket === true || !remaining().includes(']')) {
        if (opts.nobracket !== true && opts.strictBrackets === true) {
          throw new SyntaxError(syntaxError$1('closing', ']'));
        }

        value = `\\${value}`;
      } else {
        increment('brackets');
      }

      push({ type: 'bracket', value });
      continue;
    }

    if (value === ']') {
      if (opts.nobracket === true || (prev && prev.type === 'bracket' && prev.value.length === 1)) {
        push({ type: 'text', value, output: `\\${value}` });
        continue;
      }

      if (state.brackets === 0) {
        if (opts.strictBrackets === true) {
          throw new SyntaxError(syntaxError$1('opening', '['));
        }

        push({ type: 'text', value, output: `\\${value}` });
        continue;
      }

      decrement('brackets');

      const prevValue = prev.value.slice(1);
      if (prev.posix !== true && prevValue[0] === '^' && !prevValue.includes('/')) {
        value = `/${value}`;
      }

      prev.value += value;
      append({ value });

      // when literal brackets are explicitly disabled
      // assume we should match with a regex character class
      if (opts.literalBrackets === false || utils$q.hasRegexChars(prevValue)) {
        continue;
      }

      const escaped = utils$q.escapeRegex(prev.value);
      state.output = state.output.slice(0, -prev.value.length);

      // when literal brackets are explicitly enabled
      // assume we should escape the brackets to match literal characters
      if (opts.literalBrackets === true) {
        state.output += escaped;
        prev.value = escaped;
        continue;
      }

      // when the user specifies nothing, try to match both
      prev.value = `(${capture}${escaped}|${prev.value})`;
      state.output += prev.value;
      continue;
    }

    /**
     * Braces
     */

    if (value === '{' && opts.nobrace !== true) {
      increment('braces');

      const open = {
        type: 'brace',
        value,
        output: '(',
        outputIndex: state.output.length,
        tokensIndex: state.tokens.length
      };

      braces.push(open);
      push(open);
      continue;
    }

    if (value === '}') {
      const brace = braces[braces.length - 1];

      if (opts.nobrace === true || !brace) {
        push({ type: 'text', value, output: value });
        continue;
      }

      let output = ')';

      if (brace.dots === true) {
        const arr = tokens.slice();
        const range = [];

        for (let i = arr.length - 1; i >= 0; i--) {
          tokens.pop();
          if (arr[i].type === 'brace') {
            break;
          }
          if (arr[i].type !== 'dots') {
            range.unshift(arr[i].value);
          }
        }

        output = expandRange(range, opts);
        state.backtrack = true;
      }

      if (brace.comma !== true && brace.dots !== true) {
        const out = state.output.slice(0, brace.outputIndex);
        const toks = state.tokens.slice(brace.tokensIndex);
        brace.value = brace.output = '\\{';
        value = output = '\\}';
        state.output = out;
        for (const t of toks) {
          state.output += (t.output || t.value);
        }
      }

      push({ type: 'brace', value, output });
      decrement('braces');
      braces.pop();
      continue;
    }

    /**
     * Pipes
     */

    if (value === '|') {
      if (extglobs.length > 0) {
        extglobs[extglobs.length - 1].conditions++;
      }
      push({ type: 'text', value });
      continue;
    }

    /**
     * Commas
     */

    if (value === ',') {
      let output = value;

      const brace = braces[braces.length - 1];
      if (brace && stack[stack.length - 1] === 'braces') {
        brace.comma = true;
        output = '|';
      }

      push({ type: 'comma', value, output });
      continue;
    }

    /**
     * Slashes
     */

    if (value === '/') {
      // if the beginning of the glob is "./", advance the start
      // to the current index, and don't add the "./" characters
      // to the state. This greatly simplifies lookbehinds when
      // checking for BOS characters like "!" and "." (not "./")
      if (prev.type === 'dot' && state.index === state.start + 1) {
        state.start = state.index + 1;
        state.consumed = '';
        state.output = '';
        tokens.pop();
        prev = bos; // reset "prev" to the first token
        continue;
      }

      push({ type: 'slash', value, output: SLASH_LITERAL });
      continue;
    }

    /**
     * Dots
     */

    if (value === '.') {
      if (state.braces > 0 && prev.type === 'dot') {
        if (prev.value === '.') prev.output = DOT_LITERAL;
        const brace = braces[braces.length - 1];
        prev.type = 'dots';
        prev.output += value;
        prev.value += value;
        brace.dots = true;
        continue;
      }

      if ((state.braces + state.parens) === 0 && prev.type !== 'bos' && prev.type !== 'slash') {
        push({ type: 'text', value, output: DOT_LITERAL });
        continue;
      }

      push({ type: 'dot', value, output: DOT_LITERAL });
      continue;
    }

    /**
     * Question marks
     */

    if (value === '?') {
      const isGroup = prev && prev.value === '(';
      if (!isGroup && opts.noextglob !== true && peek() === '(' && peek(2) !== '?') {
        extglobOpen('qmark', value);
        continue;
      }

      if (prev && prev.type === 'paren') {
        const next = peek();
        let output = value;

        if (next === '<' && !utils$q.supportsLookbehinds()) {
          throw new Error('Node.js v10 or higher is required for regex lookbehinds');
        }

        if ((prev.value === '(' && !/[!=<:]/.test(next)) || (next === '<' && !/<([!=]|\w+>)/.test(remaining()))) {
          output = `\\${value}`;
        }

        push({ type: 'text', value, output });
        continue;
      }

      if (opts.dot !== true && (prev.type === 'slash' || prev.type === 'bos')) {
        push({ type: 'qmark', value, output: QMARK_NO_DOT });
        continue;
      }

      push({ type: 'qmark', value, output: QMARK });
      continue;
    }

    /**
     * Exclamation
     */

    if (value === '!') {
      if (opts.noextglob !== true && peek() === '(') {
        if (peek(2) !== '?' || !/[!=<:]/.test(peek(3))) {
          extglobOpen('negate', value);
          continue;
        }
      }

      if (opts.nonegate !== true && state.index === 0) {
        negate();
        continue;
      }
    }

    /**
     * Plus
     */

    if (value === '+') {
      if (opts.noextglob !== true && peek() === '(' && peek(2) !== '?') {
        extglobOpen('plus', value);
        continue;
      }

      if ((prev && prev.value === '(') || opts.regex === false) {
        push({ type: 'plus', value, output: PLUS_LITERAL });
        continue;
      }

      if ((prev && (prev.type === 'bracket' || prev.type === 'paren' || prev.type === 'brace')) || state.parens > 0) {
        push({ type: 'plus', value });
        continue;
      }

      push({ type: 'plus', value: PLUS_LITERAL });
      continue;
    }

    /**
     * Plain text
     */

    if (value === '@') {
      if (opts.noextglob !== true && peek() === '(' && peek(2) !== '?') {
        push({ type: 'at', extglob: true, value, output: '' });
        continue;
      }

      push({ type: 'text', value });
      continue;
    }

    /**
     * Plain text
     */

    if (value !== '*') {
      if (value === '$' || value === '^') {
        value = `\\${value}`;
      }

      const match = REGEX_NON_SPECIAL_CHARS.exec(remaining());
      if (match) {
        value += match[0];
        state.index += match[0].length;
      }

      push({ type: 'text', value });
      continue;
    }

    /**
     * Stars
     */

    if (prev && (prev.type === 'globstar' || prev.star === true)) {
      prev.type = 'star';
      prev.star = true;
      prev.value += value;
      prev.output = star;
      state.backtrack = true;
      state.globstar = true;
      consume(value);
      continue;
    }

    let rest = remaining();
    if (opts.noextglob !== true && /^\([^?]/.test(rest)) {
      extglobOpen('star', value);
      continue;
    }

    if (prev.type === 'star') {
      if (opts.noglobstar === true) {
        consume(value);
        continue;
      }

      const prior = prev.prev;
      const before = prior.prev;
      const isStart = prior.type === 'slash' || prior.type === 'bos';
      const afterStar = before && (before.type === 'star' || before.type === 'globstar');

      if (opts.bash === true && (!isStart || (rest[0] && rest[0] !== '/'))) {
        push({ type: 'star', value, output: '' });
        continue;
      }

      const isBrace = state.braces > 0 && (prior.type === 'comma' || prior.type === 'brace');
      const isExtglob = extglobs.length && (prior.type === 'pipe' || prior.type === 'paren');
      if (!isStart && prior.type !== 'paren' && !isBrace && !isExtglob) {
        push({ type: 'star', value, output: '' });
        continue;
      }

      // strip consecutive `/**/`
      while (rest.slice(0, 3) === '/**') {
        const after = input[state.index + 4];
        if (after && after !== '/') {
          break;
        }
        rest = rest.slice(3);
        consume('/**', 3);
      }

      if (prior.type === 'bos' && eos()) {
        prev.type = 'globstar';
        prev.value += value;
        prev.output = globstar(opts);
        state.output = prev.output;
        state.globstar = true;
        consume(value);
        continue;
      }

      if (prior.type === 'slash' && prior.prev.type !== 'bos' && !afterStar && eos()) {
        state.output = state.output.slice(0, -(prior.output + prev.output).length);
        prior.output = `(?:${prior.output}`;

        prev.type = 'globstar';
        prev.output = globstar(opts) + (opts.strictSlashes ? ')' : '|$)');
        prev.value += value;
        state.globstar = true;
        state.output += prior.output + prev.output;
        consume(value);
        continue;
      }

      if (prior.type === 'slash' && prior.prev.type !== 'bos' && rest[0] === '/') {
        const end = rest[1] !== void 0 ? '|$' : '';

        state.output = state.output.slice(0, -(prior.output + prev.output).length);
        prior.output = `(?:${prior.output}`;

        prev.type = 'globstar';
        prev.output = `${globstar(opts)}${SLASH_LITERAL}|${SLASH_LITERAL}${end})`;
        prev.value += value;

        state.output += prior.output + prev.output;
        state.globstar = true;

        consume(value + advance());

        push({ type: 'slash', value: '/', output: '' });
        continue;
      }

      if (prior.type === 'bos' && rest[0] === '/') {
        prev.type = 'globstar';
        prev.value += value;
        prev.output = `(?:^|${SLASH_LITERAL}|${globstar(opts)}${SLASH_LITERAL})`;
        state.output = prev.output;
        state.globstar = true;
        consume(value + advance());
        push({ type: 'slash', value: '/', output: '' });
        continue;
      }

      // remove single star from output
      state.output = state.output.slice(0, -prev.output.length);

      // reset previous token to globstar
      prev.type = 'globstar';
      prev.output = globstar(opts);
      prev.value += value;

      // reset output with globstar
      state.output += prev.output;
      state.globstar = true;
      consume(value);
      continue;
    }

    const token = { type: 'star', value, output: star };

    if (opts.bash === true) {
      token.output = '.*?';
      if (prev.type === 'bos' || prev.type === 'slash') {
        token.output = nodot + token.output;
      }
      push(token);
      continue;
    }

    if (prev && (prev.type === 'bracket' || prev.type === 'paren') && opts.regex === true) {
      token.output = value;
      push(token);
      continue;
    }

    if (state.index === state.start || prev.type === 'slash' || prev.type === 'dot') {
      if (prev.type === 'dot') {
        state.output += NO_DOT_SLASH;
        prev.output += NO_DOT_SLASH;

      } else if (opts.dot === true) {
        state.output += NO_DOTS_SLASH;
        prev.output += NO_DOTS_SLASH;

      } else {
        state.output += nodot;
        prev.output += nodot;
      }

      if (peek() !== '*') {
        state.output += ONE_CHAR;
        prev.output += ONE_CHAR;
      }
    }

    push(token);
  }

  while (state.brackets > 0) {
    if (opts.strictBrackets === true) throw new SyntaxError(syntaxError$1('closing', ']'));
    state.output = utils$q.escapeLast(state.output, '[');
    decrement('brackets');
  }

  while (state.parens > 0) {
    if (opts.strictBrackets === true) throw new SyntaxError(syntaxError$1('closing', ')'));
    state.output = utils$q.escapeLast(state.output, '(');
    decrement('parens');
  }

  while (state.braces > 0) {
    if (opts.strictBrackets === true) throw new SyntaxError(syntaxError$1('closing', '}'));
    state.output = utils$q.escapeLast(state.output, '{');
    decrement('braces');
  }

  if (opts.strictSlashes !== true && (prev.type === 'star' || prev.type === 'bracket')) {
    push({ type: 'maybe_slash', value: '', output: `${SLASH_LITERAL}?` });
  }

  // rebuild the output if we had to backtrack at any point
  if (state.backtrack === true) {
    state.output = '';

    for (const token of state.tokens) {
      state.output += token.output != null ? token.output : token.value;

      if (token.suffix) {
        state.output += token.suffix;
      }
    }
  }

  return state;
};

/**
 * Fast paths for creating regular expressions for common glob patterns.
 * This can significantly speed up processing and has very little downside
 * impact when none of the fast paths match.
 */

parse$h.fastpaths = (input, options) => {
  const opts = { ...options };
  const max = typeof opts.maxLength === 'number' ? Math.min(MAX_LENGTH$1, opts.maxLength) : MAX_LENGTH$1;
  const len = input.length;
  if (len > max) {
    throw new SyntaxError(`Input length: ${len}, exceeds maximum allowed length: ${max}`);
  }

  input = REPLACEMENTS[input] || input;
  const win32 = utils$q.isWindows(options);

  // create constants based on platform, for windows or posix
  const {
    DOT_LITERAL,
    SLASH_LITERAL,
    ONE_CHAR,
    DOTS_SLASH,
    NO_DOT,
    NO_DOTS,
    NO_DOTS_SLASH,
    STAR,
    START_ANCHOR
  } = constants$a.globChars(win32);

  const nodot = opts.dot ? NO_DOTS : NO_DOT;
  const slashDot = opts.dot ? NO_DOTS_SLASH : NO_DOT;
  const capture = opts.capture ? '' : '?:';
  const state = { negated: false, prefix: '' };
  let star = opts.bash === true ? '.*?' : STAR;

  if (opts.capture) {
    star = `(${star})`;
  }

  const globstar = opts => {
    if (opts.noglobstar === true) return star;
    return `(${capture}(?:(?!${START_ANCHOR}${opts.dot ? DOTS_SLASH : DOT_LITERAL}).)*?)`;
  };

  const create = str => {
    switch (str) {
      case '*':
        return `${nodot}${ONE_CHAR}${star}`;

      case '.*':
        return `${DOT_LITERAL}${ONE_CHAR}${star}`;

      case '*.*':
        return `${nodot}${star}${DOT_LITERAL}${ONE_CHAR}${star}`;

      case '*/*':
        return `${nodot}${star}${SLASH_LITERAL}${ONE_CHAR}${slashDot}${star}`;

      case '**':
        return nodot + globstar(opts);

      case '**/*':
        return `(?:${nodot}${globstar(opts)}${SLASH_LITERAL})?${slashDot}${ONE_CHAR}${star}`;

      case '**/*.*':
        return `(?:${nodot}${globstar(opts)}${SLASH_LITERAL})?${slashDot}${star}${DOT_LITERAL}${ONE_CHAR}${star}`;

      case '**/.*':
        return `(?:${nodot}${globstar(opts)}${SLASH_LITERAL})?${DOT_LITERAL}${ONE_CHAR}${star}`;

      default: {
        const match = /^(.*?)\.(\w+)$/.exec(str);
        if (!match) return;

        const source = create(match[1]);
        if (!source) return;

        return source + DOT_LITERAL + match[2];
      }
    }
  };

  const output = utils$q.removePrefix(input, state);
  let source = create(output);

  if (source && opts.strictSlashes !== true) {
    source += `${SLASH_LITERAL}?`;
  }

  return source;
};

var parse_1$2 = parse$h;

const path$K = path__default["default"];
const scan = scan_1;
const parse$g = parse_1$2;
const utils$p = utils$s;
const constants$9 = constants$b;
const isObject$2 = val => val && typeof val === 'object' && !Array.isArray(val);

/**
 * Creates a matcher function from one or more glob patterns. The
 * returned function takes a string to match as its first argument,
 * and returns true if the string is a match. The returned matcher
 * function also takes a boolean as the second argument that, when true,
 * returns an object with additional information.
 *
 * ```js
 * const picomatch = require('picomatch');
 * // picomatch(glob[, options]);
 *
 * const isMatch = picomatch('*.!(*a)');
 * console.log(isMatch('a.a')); //=> false
 * console.log(isMatch('a.b')); //=> true
 * ```
 * @name picomatch
 * @param {String|Array} `globs` One or more glob patterns.
 * @param {Object=} `options`
 * @return {Function=} Returns a matcher function.
 * @api public
 */

const picomatch$2 = (glob, options, returnState = false) => {
  if (Array.isArray(glob)) {
    const fns = glob.map(input => picomatch$2(input, options, returnState));
    const arrayMatcher = str => {
      for (const isMatch of fns) {
        const state = isMatch(str);
        if (state) return state;
      }
      return false;
    };
    return arrayMatcher;
  }

  const isState = isObject$2(glob) && glob.tokens && glob.input;

  if (glob === '' || (typeof glob !== 'string' && !isState)) {
    throw new TypeError('Expected pattern to be a non-empty string');
  }

  const opts = options || {};
  const posix = utils$p.isWindows(options);
  const regex = isState
    ? picomatch$2.compileRe(glob, options)
    : picomatch$2.makeRe(glob, options, false, true);

  const state = regex.state;
  delete regex.state;

  let isIgnored = () => false;
  if (opts.ignore) {
    const ignoreOpts = { ...options, ignore: null, onMatch: null, onResult: null };
    isIgnored = picomatch$2(opts.ignore, ignoreOpts, returnState);
  }

  const matcher = (input, returnObject = false) => {
    const { isMatch, match, output } = picomatch$2.test(input, regex, options, { glob, posix });
    const result = { glob, state, regex, posix, input, output, match, isMatch };

    if (typeof opts.onResult === 'function') {
      opts.onResult(result);
    }

    if (isMatch === false) {
      result.isMatch = false;
      return returnObject ? result : false;
    }

    if (isIgnored(input)) {
      if (typeof opts.onIgnore === 'function') {
        opts.onIgnore(result);
      }
      result.isMatch = false;
      return returnObject ? result : false;
    }

    if (typeof opts.onMatch === 'function') {
      opts.onMatch(result);
    }
    return returnObject ? result : true;
  };

  if (returnState) {
    matcher.state = state;
  }

  return matcher;
};

/**
 * Test `input` with the given `regex`. This is used by the main
 * `picomatch()` function to test the input string.
 *
 * ```js
 * const picomatch = require('picomatch');
 * // picomatch.test(input, regex[, options]);
 *
 * console.log(picomatch.test('foo/bar', /^(?:([^/]*?)\/([^/]*?))$/));
 * // { isMatch: true, match: [ 'foo/', 'foo', 'bar' ], output: 'foo/bar' }
 * ```
 * @param {String} `input` String to test.
 * @param {RegExp} `regex`
 * @return {Object} Returns an object with matching info.
 * @api public
 */

picomatch$2.test = (input, regex, options, { glob, posix } = {}) => {
  if (typeof input !== 'string') {
    throw new TypeError('Expected input to be a string');
  }

  if (input === '') {
    return { isMatch: false, output: '' };
  }

  const opts = options || {};
  const format = opts.format || (posix ? utils$p.toPosixSlashes : null);
  let match = input === glob;
  let output = (match && format) ? format(input) : input;

  if (match === false) {
    output = format ? format(input) : input;
    match = output === glob;
  }

  if (match === false || opts.capture === true) {
    if (opts.matchBase === true || opts.basename === true) {
      match = picomatch$2.matchBase(input, regex, options, posix);
    } else {
      match = regex.exec(output);
    }
  }

  return { isMatch: Boolean(match), match, output };
};

/**
 * Match the basename of a filepath.
 *
 * ```js
 * const picomatch = require('picomatch');
 * // picomatch.matchBase(input, glob[, options]);
 * console.log(picomatch.matchBase('foo/bar.js', '*.js'); // true
 * ```
 * @param {String} `input` String to test.
 * @param {RegExp|String} `glob` Glob pattern or regex created by [.makeRe](#makeRe).
 * @return {Boolean}
 * @api public
 */

picomatch$2.matchBase = (input, glob, options, posix = utils$p.isWindows(options)) => {
  const regex = glob instanceof RegExp ? glob : picomatch$2.makeRe(glob, options);
  return regex.test(path$K.basename(input));
};

/**
 * Returns true if **any** of the given glob `patterns` match the specified `string`.
 *
 * ```js
 * const picomatch = require('picomatch');
 * // picomatch.isMatch(string, patterns[, options]);
 *
 * console.log(picomatch.isMatch('a.a', ['b.*', '*.a'])); //=> true
 * console.log(picomatch.isMatch('a.a', 'b.*')); //=> false
 * ```
 * @param {String|Array} str The string to test.
 * @param {String|Array} patterns One or more glob patterns to use for matching.
 * @param {Object} [options] See available [options](#options).
 * @return {Boolean} Returns true if any patterns match `str`
 * @api public
 */

picomatch$2.isMatch = (str, patterns, options) => picomatch$2(patterns, options)(str);

/**
 * Parse a glob pattern to create the source string for a regular
 * expression.
 *
 * ```js
 * const picomatch = require('picomatch');
 * const result = picomatch.parse(pattern[, options]);
 * ```
 * @param {String} `pattern`
 * @param {Object} `options`
 * @return {Object} Returns an object with useful properties and output to be used as a regex source string.
 * @api public
 */

picomatch$2.parse = (pattern, options) => {
  if (Array.isArray(pattern)) return pattern.map(p => picomatch$2.parse(p, options));
  return parse$g(pattern, { ...options, fastpaths: false });
};

/**
 * Scan a glob pattern to separate the pattern into segments.
 *
 * ```js
 * const picomatch = require('picomatch');
 * // picomatch.scan(input[, options]);
 *
 * const result = picomatch.scan('!./foo/*.js');
 * console.log(result);
 * { prefix: '!./',
 *   input: '!./foo/*.js',
 *   start: 3,
 *   base: 'foo',
 *   glob: '*.js',
 *   isBrace: false,
 *   isBracket: false,
 *   isGlob: true,
 *   isExtglob: false,
 *   isGlobstar: false,
 *   negated: true }
 * ```
 * @param {String} `input` Glob pattern to scan.
 * @param {Object} `options`
 * @return {Object} Returns an object with
 * @api public
 */

picomatch$2.scan = (input, options) => scan(input, options);

/**
 * Compile a regular expression from the `state` object returned by the
 * [parse()](#parse) method.
 *
 * @param {Object} `state`
 * @param {Object} `options`
 * @param {Boolean} `returnOutput` Intended for implementors, this argument allows you to return the raw output from the parser.
 * @param {Boolean} `returnState` Adds the state to a `state` property on the returned regex. Useful for implementors and debugging.
 * @return {RegExp}
 * @api public
 */

picomatch$2.compileRe = (state, options, returnOutput = false, returnState = false) => {
  if (returnOutput === true) {
    return state.output;
  }

  const opts = options || {};
  const prepend = opts.contains ? '' : '^';
  const append = opts.contains ? '' : '$';

  let source = `${prepend}(?:${state.output})${append}`;
  if (state && state.negated === true) {
    source = `^(?!${source}).*$`;
  }

  const regex = picomatch$2.toRegex(source, options);
  if (returnState === true) {
    regex.state = state;
  }

  return regex;
};

/**
 * Create a regular expression from a parsed glob pattern.
 *
 * ```js
 * const picomatch = require('picomatch');
 * const state = picomatch.parse('*.js');
 * // picomatch.compileRe(state[, options]);
 *
 * console.log(picomatch.compileRe(state));
 * //=> /^(?:(?!\.)(?=.)[^/]*?\.js)$/
 * ```
 * @param {String} `state` The object returned from the `.parse` method.
 * @param {Object} `options`
 * @param {Boolean} `returnOutput` Implementors may use this argument to return the compiled output, instead of a regular expression. This is not exposed on the options to prevent end-users from mutating the result.
 * @param {Boolean} `returnState` Implementors may use this argument to return the state from the parsed glob with the returned regular expression.
 * @return {RegExp} Returns a regex created from the given pattern.
 * @api public
 */

picomatch$2.makeRe = (input, options = {}, returnOutput = false, returnState = false) => {
  if (!input || typeof input !== 'string') {
    throw new TypeError('Expected a non-empty string');
  }

  let parsed = { negated: false, fastpaths: true };

  if (options.fastpaths !== false && (input[0] === '.' || input[0] === '*')) {
    parsed.output = parse$g.fastpaths(input, options);
  }

  if (!parsed.output) {
    parsed = parse$g(input, options);
  }

  return picomatch$2.compileRe(parsed, options, returnOutput, returnState);
};

/**
 * Create a regular expression from the given regex source string.
 *
 * ```js
 * const picomatch = require('picomatch');
 * // picomatch.toRegex(source[, options]);
 *
 * const { output } = picomatch.parse('*.js');
 * console.log(picomatch.toRegex(output));
 * //=> /^(?:(?!\.)(?=.)[^/]*?\.js)$/
 * ```
 * @param {String} `source` Regular expression source string.
 * @param {Object} `options`
 * @return {RegExp}
 * @api public
 */

picomatch$2.toRegex = (source, options) => {
  try {
    const opts = options || {};
    return new RegExp(source, opts.flags || (opts.nocase ? 'i' : ''));
  } catch (err) {
    if (options && options.debug === true) throw err;
    return /$^/;
  }
};

/**
 * Picomatch constants.
 * @return {Object}
 */

picomatch$2.constants = constants$9;

/**
 * Expose "picomatch"
 */

var picomatch_1 = picomatch$2;

var picomatch$1 = picomatch_1;

var pm$1 = /*@__PURE__*/getDefaultExportFromCjs(picomatch$1);

// Helper since Typescript can't detect readonly arrays with Array.isArray
function isArray$1(arg) {
    return Array.isArray(arg);
}
function ensureArray$1(thing) {
    if (isArray$1(thing))
        return thing;
    if (thing == null)
        return [];
    return [thing];
}

const normalizePath$4 = function normalizePath(filename) {
    return filename.split(path$M.win32.sep).join(path$M.posix.sep);
};

function getMatcherString$1(id, resolutionBase) {
    if (resolutionBase === false || path$M.isAbsolute(id) || id.startsWith('*')) {
        return normalizePath$4(id);
    }
    // resolve('') is valid and will default to process.cwd()
    const basePath = normalizePath$4(path$M.resolve(resolutionBase || ''))
        // escape all possible (posix + win) path characters that might interfere with regex
        .replace(/[-^$*+?.()|[\]{}]/g, '\\$&');
    // Note that we use posix.join because:
    // 1. the basePath has been normalized to use /
    // 2. the incoming glob (id) matcher, also uses /
    // otherwise Node will force backslash (\) on windows
    return path$M.posix.join(basePath, normalizePath$4(id));
}
const createFilter$1 = function createFilter(include, exclude, options) {
    const resolutionBase = options && options.resolve;
    const getMatcher = (id) => id instanceof RegExp
        ? id
        : {
            test: (what) => {
                // this refactor is a tad overly verbose but makes for easy debugging
                const pattern = getMatcherString$1(id, resolutionBase);
                const fn = pm$1(pattern, { dot: true });
                const result = fn(what);
                return result;
            }
        };
    const includeMatchers = ensureArray$1(include).map(getMatcher);
    const excludeMatchers = ensureArray$1(exclude).map(getMatcher);
    return function result(id) {
        if (typeof id !== 'string')
            return false;
        if (/\0/.test(id))
            return false;
        const pathId = normalizePath$4(id);
        for (let i = 0; i < excludeMatchers.length; ++i) {
            const matcher = excludeMatchers[i];
            if (matcher.test(pathId))
                return false;
        }
        for (let i = 0; i < includeMatchers.length; ++i) {
            const matcher = includeMatchers[i];
            if (matcher.test(pathId))
                return true;
        }
        return !includeMatchers.length;
    };
};

const reservedWords$1 = 'break case class catch const continue debugger default delete do else export extends finally for function if import in instanceof let new return super switch this throw try typeof var void while with yield enum await implements package protected static interface private public';
const builtins$1 = 'arguments Infinity NaN undefined null true false eval uneval isFinite isNaN parseFloat parseInt decodeURI decodeURIComponent encodeURI encodeURIComponent escape unescape Object Function Boolean Symbol Error EvalError InternalError RangeError ReferenceError SyntaxError TypeError URIError Number Math Date String RegExp Array Int8Array Uint8Array Uint8ClampedArray Int16Array Uint16Array Int32Array Uint32Array Float32Array Float64Array Map Set WeakMap WeakSet SIMD ArrayBuffer DataView JSON Promise Generator GeneratorFunction Reflect Proxy Intl';
const forbiddenIdentifiers$1 = new Set(`${reservedWords$1} ${builtins$1}`.split(' '));
forbiddenIdentifiers$1.add('');

var d$1="vite-plugin-eslint";function g$1(r){return r.split("?",2)[0]}function h$1(r){return !require$$0$9.existsSync(r)}function y$1(r){let{eslintPath:n,lintOnStart:f,include:o,exclude:t,formatter:p,emitWarning:a,emitError:l,failOnWarning:u,failOnError:s,...i}=r;return i}async function c$2(r){return r.then(n=>[null,n]).catch(n=>[n,void 0])}async function m$1(r,n,f,o,t,p){let[a,l]=await c$2(n.lintFiles(f));if(a)return Promise.reject(a);let u=l.some(e=>e.warningCount>0),s=l.some(e=>e.errorCount>0),i=t(l);if(o.fix&&l){let[e]=await c$2(p(l));if(e)return Promise.reject(e)}if(u&&o.emitWarning){let e=typeof i=="string"?i:await i;o.failOnWarning?r.error(e):r.warn(e);}if(s&&o.emitError){let e=typeof i=="string"?i:await i;o.failOnError?r.error(e):console.log(e);}return Promise.resolve()}function S$1(r={}){let n,f,o,t,p,a=new Set;return {name:d$1,async configResolved(l){t=Object.assign({lintOnStart:!1,include:["**/*.js","**/*.jsx","**/*.ts","**/*.tsx","**/*.vue","**/*.svelte"],exclude:["**/node_modules/**"],cacheLocation:path$M.resolve(l.cacheDir,".eslintcache"),formatter:"stylish",emitWarning:!0,emitError:!0,failOnWarning:!1,failOnError:!0,errorOnUnmatchedPattern:!1},r);},async buildStart(){let[l,u]=await c$2((function (t) { return Promise.resolve().then(function () { return /*#__PURE__*/_interopNamespace(require(t)); }); })(t.eslintPath??"eslint"));if(l)this.error("Failed to import ESLint, do you install or configure eslintPath?");else {let s=y$1(t);switch(n=new u.ESLint(s),p=u.ESLint.outputFixes,f=createFilter$1(t.include,t.exclude),typeof t.formatter){case"string":o=(await n.loadFormatter(t.formatter)).format;break;case"function":o=t.formatter;}if(t.lintOnStart&&t.include){this.warn("LintOnStart is turned on, and it will check for all matching files.");let[i]=await c$2(m$1(this,n,t.include,t,o,p));i&&this.error(i.message);}}},async transform(l,u){let s=g$1(u),i=h$1(s);if(i&&a.has(s)&&a.delete(s),!f(s)||await n.isPathIgnored(s)||i)return null;t.cache&&a.add(s);let[e]=await c$2(m$1(this,n,t.cache?Array.from(a):s,t,o,p));return e&&this.error(e.message),null}}}

var lib$v = {};

function commonjsRequire(path) {
	throw new Error('Could not dynamically require "' + path + '". Please configure the dynamicRequireTargets or/and ignoreDynamicRequires option of @rollup/plugin-commonjs appropriately for this require call to work.');
}

var matchPathSync = {};

var filesystem = {};

Object.defineProperty(filesystem, "__esModule", { value: true });
filesystem.removeExtension = filesystem.fileExistsAsync = filesystem.readJsonFromDiskAsync = filesystem.readJsonFromDiskSync = filesystem.fileExistsSync = void 0;
var fs$G = require$$0__default["default"];
function fileExistsSync(path) {
    // If the file doesn't exist, avoid throwing an exception over the native barrier for every miss
    if (!fs$G.existsSync(path)) {
        return false;
    }
    try {
        var stats = fs$G.statSync(path);
        return stats.isFile();
    }
    catch (err) {
        // If error, assume file did not exist
        return false;
    }
}
filesystem.fileExistsSync = fileExistsSync;
/**
 * Reads package.json from disk
 *
 * @param file Path to package.json
 */
// eslint-disable-next-line @typescript-eslint/no-explicit-any
function readJsonFromDiskSync(packageJsonPath) {
    if (!fs$G.existsSync(packageJsonPath)) {
        return undefined;
    }
    // eslint-disable-next-line @typescript-eslint/no-require-imports
    return commonjsRequire(packageJsonPath);
}
filesystem.readJsonFromDiskSync = readJsonFromDiskSync;
function readJsonFromDiskAsync(path, 
// eslint-disable-next-line @typescript-eslint/no-explicit-any
callback) {
    fs$G.readFile(path, "utf8", function (err, result) {
        // If error, assume file did not exist
        if (err || !result) {
            return callback();
        }
        var json = JSON.parse(result);
        return callback(undefined, json);
    });
}
filesystem.readJsonFromDiskAsync = readJsonFromDiskAsync;
function fileExistsAsync(path2, callback2) {
    fs$G.stat(path2, function (err, stats) {
        if (err) {
            // If error assume file does not exist
            return callback2(undefined, false);
        }
        callback2(undefined, stats ? stats.isFile() : false);
    });
}
filesystem.fileExistsAsync = fileExistsAsync;
function removeExtension(path) {
    return path.substring(0, path.lastIndexOf(".")) || path;
}
filesystem.removeExtension = removeExtension;

var mappingEntry = {};

Object.defineProperty(mappingEntry, "__esModule", { value: true });
mappingEntry.getAbsoluteMappingEntries = void 0;
var path$J = path__default["default"];
/**
 * Converts an absolute baseUrl and paths to an array of absolute mapping entries.
 * The array is sorted by longest prefix.
 * Having an array with entries allows us to keep a sorting order rather than
 * sort by keys each time we use the mappings.
 *
 * @param absoluteBaseUrl
 * @param paths
 * @param addMatchAll
 */
function getAbsoluteMappingEntries(absoluteBaseUrl, paths, addMatchAll) {
    // Resolve all paths to absolute form once here, and sort them by
    // longest prefix once here, this saves time on each request later.
    // We need to put them in an array to preserve the sorting order.
    var sortedKeys = sortByLongestPrefix(Object.keys(paths));
    var absolutePaths = [];
    for (var _i = 0, sortedKeys_1 = sortedKeys; _i < sortedKeys_1.length; _i++) {
        var key = sortedKeys_1[_i];
        absolutePaths.push({
            pattern: key,
            paths: paths[key].map(function (pathToResolve) {
                return path$J.resolve(absoluteBaseUrl, pathToResolve);
            }),
        });
    }
    // If there is no match-all path specified in the paths section of tsconfig, then try to match
    // all paths relative to baseUrl, this is how typescript works.
    if (!paths["*"] && addMatchAll) {
        absolutePaths.push({
            pattern: "*",
            paths: ["".concat(absoluteBaseUrl.replace(/\/$/, ""), "/*")],
        });
    }
    return absolutePaths;
}
mappingEntry.getAbsoluteMappingEntries = getAbsoluteMappingEntries;
/**
 * Sort path patterns.
 * If a module name can be matched with multiple patterns then pattern with the longest prefix will be picked.
 */
function sortByLongestPrefix(arr) {
    return arr
        .concat()
        .sort(function (a, b) { return getPrefixLength(b) - getPrefixLength(a); });
}
function getPrefixLength(pattern) {
    var prefixLength = pattern.indexOf("*");
    return pattern.substr(0, prefixLength).length;
}

var tryPath = {};

Object.defineProperty(tryPath, "__esModule", { value: true });
tryPath.exhaustiveTypeException = tryPath.getStrippedPath = tryPath.getPathsToTry = void 0;
var path$I = path__default["default"];
var path_1 = path__default["default"];
var filesystem_1 = filesystem;
/**
 * Builds a list of all physical paths to try by:
 * 1. Check for file named exactly as request.
 * 2. Check for files named as request ending in any of the extensions.
 * 3. Check for file specified in package.json's main property.
 * 4. Check for files named as request ending in "index" with any of the extensions.
 */
function getPathsToTry(extensions, absolutePathMappings, requestedModule) {
    if (!absolutePathMappings || !requestedModule || requestedModule[0] === ".") {
        return undefined;
    }
    var pathsToTry = [];
    for (var _i = 0, absolutePathMappings_1 = absolutePathMappings; _i < absolutePathMappings_1.length; _i++) {
        var entry = absolutePathMappings_1[_i];
        var starMatch = entry.pattern === requestedModule
            ? ""
            : matchStar(entry.pattern, requestedModule);
        if (starMatch !== undefined) {
            var _loop_1 = function (physicalPathPattern) {
                var physicalPath = physicalPathPattern.replace("*", starMatch);
                pathsToTry.push({ type: "file", path: physicalPath });
                pathsToTry.push.apply(pathsToTry, extensions.map(function (e) { return ({ type: "extension", path: physicalPath + e }); }));
                pathsToTry.push({
                    type: "package",
                    path: path$I.join(physicalPath, "/package.json"),
                });
                var indexPath = path$I.join(physicalPath, "/index");
                pathsToTry.push.apply(pathsToTry, extensions.map(function (e) { return ({ type: "index", path: indexPath + e }); }));
            };
            for (var _a = 0, _b = entry.paths; _a < _b.length; _a++) {
                var physicalPathPattern = _b[_a];
                _loop_1(physicalPathPattern);
            }
        }
    }
    return pathsToTry.length === 0 ? undefined : pathsToTry;
}
tryPath.getPathsToTry = getPathsToTry;
// Not sure why we don't just return the full found path?
function getStrippedPath(tryPath) {
    return tryPath.type === "index"
        ? (0, path_1.dirname)(tryPath.path)
        : tryPath.type === "file"
            ? tryPath.path
            : tryPath.type === "extension"
                ? (0, filesystem_1.removeExtension)(tryPath.path)
                : tryPath.type === "package"
                    ? tryPath.path
                    : exhaustiveTypeException(tryPath.type);
}
tryPath.getStrippedPath = getStrippedPath;
function exhaustiveTypeException(check) {
    throw new Error("Unknown type ".concat(check));
}
tryPath.exhaustiveTypeException = exhaustiveTypeException;
/**
 * Matches pattern with a single star against search.
 * Star must match at least one character to be considered a match.
 *
 * @param patttern for example "foo*"
 * @param search for example "fooawesomebar"
 * @returns the part of search that * matches, or undefined if no match.
 */
function matchStar(pattern, search) {
    if (search.length < pattern.length) {
        return undefined;
    }
    if (pattern === "*") {
        return search;
    }
    var star = pattern.indexOf("*");
    if (star === -1) {
        return undefined;
    }
    var part1 = pattern.substring(0, star);
    var part2 = pattern.substring(star + 1);
    if (search.substr(0, star) !== part1) {
        return undefined;
    }
    if (search.substr(search.length - part2.length) !== part2) {
        return undefined;
    }
    return search.substr(star, search.length - part2.length);
}

Object.defineProperty(matchPathSync, "__esModule", { value: true });
matchPathSync.matchFromAbsolutePaths = matchPathSync.createMatchPath = void 0;
var path$H = path__default["default"];
var Filesystem$1 = filesystem;
var MappingEntry$1 = mappingEntry;
var TryPath$1 = tryPath;
/**
 * Creates a function that can resolve paths according to tsconfig paths property.
 *
 * @param absoluteBaseUrl Absolute version of baseUrl as specified in tsconfig.
 * @param paths The paths as specified in tsconfig.
 * @param mainFields A list of package.json field names to try when resolving module files. Select a nested field using an array of field names.
 * @param addMatchAll Add a match-all "*" rule if none is present
 * @returns a function that can resolve paths.
 */
function createMatchPath(absoluteBaseUrl, paths, mainFields, addMatchAll) {
    if (mainFields === void 0) { mainFields = ["main"]; }
    if (addMatchAll === void 0) { addMatchAll = true; }
    var absolutePaths = MappingEntry$1.getAbsoluteMappingEntries(absoluteBaseUrl, paths, addMatchAll);
    return function (requestedModule, readJson, fileExists, extensions) {
        return matchFromAbsolutePaths(absolutePaths, requestedModule, readJson, fileExists, extensions, mainFields);
    };
}
matchPathSync.createMatchPath = createMatchPath;
/**
 * Finds a path from tsconfig that matches a module load request.
 *
 * @param absolutePathMappings The paths to try as specified in tsconfig but resolved to absolute form.
 * @param requestedModule The required module name.
 * @param readJson Function that can read json from a path (useful for testing).
 * @param fileExists Function that checks for existence of a file at a path (useful for testing).
 * @param extensions File extensions to probe for (useful for testing).
 * @param mainFields A list of package.json field names to try when resolving module files. Select a nested field using an array of field names.
 * @returns the found path, or undefined if no path was found.
 */
function matchFromAbsolutePaths(absolutePathMappings, requestedModule, readJson, fileExists, extensions, mainFields) {
    if (readJson === void 0) { readJson = Filesystem$1.readJsonFromDiskSync; }
    if (fileExists === void 0) { fileExists = Filesystem$1.fileExistsSync; }
    if (extensions === void 0) { extensions = Object.keys(commonjsRequire.extensions); }
    if (mainFields === void 0) { mainFields = ["main"]; }
    var tryPaths = TryPath$1.getPathsToTry(extensions, absolutePathMappings, requestedModule);
    if (!tryPaths) {
        return undefined;
    }
    return findFirstExistingPath$1(tryPaths, readJson, fileExists, mainFields);
}
matchPathSync.matchFromAbsolutePaths = matchFromAbsolutePaths;
function findFirstExistingMainFieldMappedFile$1(packageJson, mainFields, packageJsonPath, fileExists) {
    for (var index = 0; index < mainFields.length; index++) {
        var mainFieldSelector = mainFields[index];
        var candidateMapping = typeof mainFieldSelector === "string"
            ? packageJson[mainFieldSelector]
            : mainFieldSelector.reduce(function (obj, key) { return obj[key]; }, packageJson);
        if (candidateMapping && typeof candidateMapping === "string") {
            var candidateFilePath = path$H.join(path$H.dirname(packageJsonPath), candidateMapping);
            if (fileExists(candidateFilePath)) {
                return candidateFilePath;
            }
        }
    }
    return undefined;
}
function findFirstExistingPath$1(tryPaths, readJson, fileExists, mainFields) {
    if (readJson === void 0) { readJson = Filesystem$1.readJsonFromDiskSync; }
    if (mainFields === void 0) { mainFields = ["main"]; }
    for (var _i = 0, tryPaths_1 = tryPaths; _i < tryPaths_1.length; _i++) {
        var tryPath = tryPaths_1[_i];
        if (tryPath.type === "file" ||
            tryPath.type === "extension" ||
            tryPath.type === "index") {
            if (fileExists(tryPath.path)) {
                return TryPath$1.getStrippedPath(tryPath);
            }
        }
        else if (tryPath.type === "package") {
            var packageJson = readJson(tryPath.path);
            if (packageJson) {
                var mainFieldMappedFile = findFirstExistingMainFieldMappedFile$1(packageJson, mainFields, tryPath.path, fileExists);
                if (mainFieldMappedFile) {
                    return mainFieldMappedFile;
                }
            }
        }
        else {
            TryPath$1.exhaustiveTypeException(tryPath.type);
        }
    }
    return undefined;
}

var matchPathAsync = {};

Object.defineProperty(matchPathAsync, "__esModule", { value: true });
matchPathAsync.matchFromAbsolutePathsAsync = matchPathAsync.createMatchPathAsync = void 0;
var path$G = path__default["default"];
var TryPath = tryPath;
var MappingEntry = mappingEntry;
var Filesystem = filesystem;
/**
 * See the sync version for docs.
 */
function createMatchPathAsync(absoluteBaseUrl, paths, mainFields, addMatchAll) {
    if (mainFields === void 0) { mainFields = ["main"]; }
    if (addMatchAll === void 0) { addMatchAll = true; }
    var absolutePaths = MappingEntry.getAbsoluteMappingEntries(absoluteBaseUrl, paths, addMatchAll);
    return function (requestedModule, readJson, fileExists, extensions, callback) {
        return matchFromAbsolutePathsAsync(absolutePaths, requestedModule, readJson, fileExists, extensions, callback, mainFields);
    };
}
matchPathAsync.createMatchPathAsync = createMatchPathAsync;
/**
 * See the sync version for docs.
 */
function matchFromAbsolutePathsAsync(absolutePathMappings, requestedModule, readJson, fileExists, extensions, callback, mainFields) {
    if (readJson === void 0) { readJson = Filesystem.readJsonFromDiskAsync; }
    if (fileExists === void 0) { fileExists = Filesystem.fileExistsAsync; }
    if (extensions === void 0) { extensions = Object.keys(commonjsRequire.extensions); }
    if (mainFields === void 0) { mainFields = ["main"]; }
    var tryPaths = TryPath.getPathsToTry(extensions, absolutePathMappings, requestedModule);
    if (!tryPaths) {
        return callback();
    }
    findFirstExistingPath(tryPaths, readJson, fileExists, callback, 0, mainFields);
}
matchPathAsync.matchFromAbsolutePathsAsync = matchFromAbsolutePathsAsync;
function findFirstExistingMainFieldMappedFile(packageJson, mainFields, packageJsonPath, fileExistsAsync, doneCallback, index) {
    if (index === void 0) { index = 0; }
    if (index >= mainFields.length) {
        return doneCallback(undefined, undefined);
    }
    var tryNext = function () {
        return findFirstExistingMainFieldMappedFile(packageJson, mainFields, packageJsonPath, fileExistsAsync, doneCallback, index + 1);
    };
    var mainFieldSelector = mainFields[index];
    var mainFieldMapping = typeof mainFieldSelector === "string"
        ? packageJson[mainFieldSelector]
        : mainFieldSelector.reduce(function (obj, key) { return obj[key]; }, packageJson);
    if (typeof mainFieldMapping !== "string") {
        // Skip mappings that are not pointers to replacement files
        return tryNext();
    }
    var mappedFilePath = path$G.join(path$G.dirname(packageJsonPath), mainFieldMapping);
    fileExistsAsync(mappedFilePath, function (err, exists) {
        if (err) {
            return doneCallback(err);
        }
        if (exists) {
            return doneCallback(undefined, mappedFilePath);
        }
        return tryNext();
    });
}
// Recursive loop to probe for physical files
function findFirstExistingPath(tryPaths, readJson, fileExists, doneCallback, index, mainFields) {
    if (index === void 0) { index = 0; }
    if (mainFields === void 0) { mainFields = ["main"]; }
    var tryPath = tryPaths[index];
    if (tryPath.type === "file" ||
        tryPath.type === "extension" ||
        tryPath.type === "index") {
        fileExists(tryPath.path, function (err, exists) {
            if (err) {
                return doneCallback(err);
            }
            if (exists) {
                return doneCallback(undefined, TryPath.getStrippedPath(tryPath));
            }
            if (index === tryPaths.length - 1) {
                return doneCallback();
            }
            // Continue with the next path
            return findFirstExistingPath(tryPaths, readJson, fileExists, doneCallback, index + 1, mainFields);
        });
    }
    else if (tryPath.type === "package") {
        readJson(tryPath.path, function (err, packageJson) {
            if (err) {
                return doneCallback(err);
            }
            if (packageJson) {
                return findFirstExistingMainFieldMappedFile(packageJson, mainFields, tryPath.path, fileExists, function (mainFieldErr, mainFieldMappedFile) {
                    if (mainFieldErr) {
                        return doneCallback(mainFieldErr);
                    }
                    if (mainFieldMappedFile) {
                        return doneCallback(undefined, mainFieldMappedFile);
                    }
                    // No field in package json was a valid option. Continue with the next path.
                    return findFirstExistingPath(tryPaths, readJson, fileExists, doneCallback, index + 1, mainFields);
                });
            }
            // This is async code, we need to return unconditionally, otherwise the code still falls
            // through and keeps recursing. While this might work in general, libraries that use neo-async
            // like Webpack will actually not allow you to call the same callback twice.
            //
            // An example of where this caused issues:
            // https://github.com/dividab/tsconfig-paths-webpack-plugin/issues/11
            //
            // Continue with the next path
            return findFirstExistingPath(tryPaths, readJson, fileExists, doneCallback, index + 1, mainFields);
        });
    }
    else {
        TryPath.exhaustiveTypeException(tryPath.type);
    }
}

var register$1 = {};

var configLoader$1 = {};

var tsconfigLoader = {};

// This is a generated file. Do not edit.
var Space_Separator = /[\u1680\u2000-\u200A\u202F\u205F\u3000]/;
var ID_Start = /[\xAA\xB5\xBA\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0561-\u0587\u05D0-\u05EA\u05F0-\u05F2\u0620-\u064A\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07CA-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08BD\u0904-\u0939\u093D\u0950\u0958-\u0961\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09F0\u09F1\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B71\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CF1\u0CF2\u0D05-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D5F-\u0D61\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E81\u0E82\u0E84\u0E87\u0E88\u0E8A\u0E8D\u0E94-\u0E97\u0E99-\u0E9F\u0EA1-\u0EA3\u0EA5\u0EA7\u0EAA\u0EAB\u0EAD-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0EDC-\u0EDF\u0F00\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u1820-\u1877\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1950-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u1A00-\u1A16\u1A20-\u1A54\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B83-\u1BA0\u1BAE\u1BAF\u1BBA-\u1BE5\u1C00-\u1C23\u1C4D-\u1C4F\u1C5A-\u1C7D\u1C80-\u1C88\u1CE9-\u1CEC\u1CEE-\u1CF1\u1CF5\u1CF6\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2071\u207F\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2160-\u2188\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312E\u3131-\u318E\u31A0-\u31BA\u31F0-\u31FF\u3400-\u4DB5\u4E00-\u9FEA\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA61F\uA62A\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7AE\uA7B0-\uA7B7\uA7F7-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA840-\uA873\uA882-\uA8B3\uA8F2-\uA8F7\uA8FB\uA8FD\uA90A-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF\uA9E0-\uA9E4\uA9E6-\uA9EF\uA9FA-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB65\uAB70-\uABE2\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD40-\uDD74\uDE80-\uDE9C\uDEA0-\uDED0\uDF00-\uDF1F\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC60-\uDC76\uDC80-\uDC9E\uDCE0-\uDCF2\uDCF4\uDCF5\uDD00-\uDD15\uDD20-\uDD39\uDD80-\uDDB7\uDDBE\uDDBF\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE33\uDE60-\uDE7C\uDE80-\uDE9C\uDEC0-\uDEC7\uDEC9-\uDEE4\uDF00-\uDF35\uDF40-\uDF55\uDF60-\uDF72\uDF80-\uDF91]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2]|\uD804[\uDC03-\uDC37\uDC83-\uDCAF\uDCD0-\uDCE8\uDD03-\uDD26\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDDA\uDDDC\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE80-\uDEAA\uDF00-\uDF19]|\uD806[\uDCA0-\uDCDF\uDCFF\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE83\uDE86-\uDE89\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDF00-\uDF44\uDF50\uDF93-\uDF9F\uDFE0\uDFE1]|\uD821[\uDC00-\uDFEC]|\uD822[\uDC00-\uDEF2]|\uD82C[\uDC00-\uDD1E\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB]|\uD83A[\uDC00-\uDCC4\uDD00-\uDD43]|\uD83B[\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD869[\uDC00-\uDED6\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]/;
var ID_Continue = /[\xAA\xB5\xBA\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0300-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u0483-\u0487\u048A-\u052F\u0531-\u0556\u0559\u0561-\u0587\u0591-\u05BD\u05BF\u05C1\u05C2\u05C4\u05C5\u05C7\u05D0-\u05EA\u05F0-\u05F2\u0610-\u061A\u0620-\u0669\u066E-\u06D3\u06D5-\u06DC\u06DF-\u06E8\u06EA-\u06FC\u06FF\u0710-\u074A\u074D-\u07B1\u07C0-\u07F5\u07FA\u0800-\u082D\u0840-\u085B\u0860-\u086A\u08A0-\u08B4\u08B6-\u08BD\u08D4-\u08E1\u08E3-\u0963\u0966-\u096F\u0971-\u0983\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BC-\u09C4\u09C7\u09C8\u09CB-\u09CE\u09D7\u09DC\u09DD\u09DF-\u09E3\u09E6-\u09F1\u09FC\u0A01-\u0A03\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A3C\u0A3E-\u0A42\u0A47\u0A48\u0A4B-\u0A4D\u0A51\u0A59-\u0A5C\u0A5E\u0A66-\u0A75\u0A81-\u0A83\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABC-\u0AC5\u0AC7-\u0AC9\u0ACB-\u0ACD\u0AD0\u0AE0-\u0AE3\u0AE6-\u0AEF\u0AF9-\u0AFF\u0B01-\u0B03\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3C-\u0B44\u0B47\u0B48\u0B4B-\u0B4D\u0B56\u0B57\u0B5C\u0B5D\u0B5F-\u0B63\u0B66-\u0B6F\u0B71\u0B82\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BBE-\u0BC2\u0BC6-\u0BC8\u0BCA-\u0BCD\u0BD0\u0BD7\u0BE6-\u0BEF\u0C00-\u0C03\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D-\u0C44\u0C46-\u0C48\u0C4A-\u0C4D\u0C55\u0C56\u0C58-\u0C5A\u0C60-\u0C63\u0C66-\u0C6F\u0C80-\u0C83\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBC-\u0CC4\u0CC6-\u0CC8\u0CCA-\u0CCD\u0CD5\u0CD6\u0CDE\u0CE0-\u0CE3\u0CE6-\u0CEF\u0CF1\u0CF2\u0D00-\u0D03\u0D05-\u0D0C\u0D0E-\u0D10\u0D12-\u0D44\u0D46-\u0D48\u0D4A-\u0D4E\u0D54-\u0D57\u0D5F-\u0D63\u0D66-\u0D6F\u0D7A-\u0D7F\u0D82\u0D83\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DCA\u0DCF-\u0DD4\u0DD6\u0DD8-\u0DDF\u0DE6-\u0DEF\u0DF2\u0DF3\u0E01-\u0E3A\u0E40-\u0E4E\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E87\u0E88\u0E8A\u0E8D\u0E94-\u0E97\u0E99-\u0E9F\u0EA1-\u0EA3\u0EA5\u0EA7\u0EAA\u0EAB\u0EAD-\u0EB9\u0EBB-\u0EBD\u0EC0-\u0EC4\u0EC6\u0EC8-\u0ECD\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F18\u0F19\u0F20-\u0F29\u0F35\u0F37\u0F39\u0F3E-\u0F47\u0F49-\u0F6C\u0F71-\u0F84\u0F86-\u0F97\u0F99-\u0FBC\u0FC6\u1000-\u1049\u1050-\u109D\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u135D-\u135F\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1714\u1720-\u1734\u1740-\u1753\u1760-\u176C\u176E-\u1770\u1772\u1773\u1780-\u17D3\u17D7\u17DC\u17DD\u17E0-\u17E9\u180B-\u180D\u1810-\u1819\u1820-\u1877\u1880-\u18AA\u18B0-\u18F5\u1900-\u191E\u1920-\u192B\u1930-\u193B\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19D9\u1A00-\u1A1B\u1A20-\u1A5E\u1A60-\u1A7C\u1A7F-\u1A89\u1A90-\u1A99\u1AA7\u1AB0-\u1ABD\u1B00-\u1B4B\u1B50-\u1B59\u1B6B-\u1B73\u1B80-\u1BF3\u1C00-\u1C37\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1CD0-\u1CD2\u1CD4-\u1CF9\u1D00-\u1DF9\u1DFB-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u203F\u2040\u2054\u2071\u207F\u2090-\u209C\u20D0-\u20DC\u20E1\u20E5-\u20F0\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2160-\u2188\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D7F-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2DE0-\u2DFF\u2E2F\u3005-\u3007\u3021-\u302F\u3031-\u3035\u3038-\u303C\u3041-\u3096\u3099\u309A\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312E\u3131-\u318E\u31A0-\u31BA\u31F0-\u31FF\u3400-\u4DB5\u4E00-\u9FEA\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66F\uA674-\uA67D\uA67F-\uA6F1\uA717-\uA71F\uA722-\uA788\uA78B-\uA7AE\uA7B0-\uA7B7\uA7F7-\uA827\uA840-\uA873\uA880-\uA8C5\uA8D0-\uA8D9\uA8E0-\uA8F7\uA8FB\uA8FD\uA900-\uA92D\uA930-\uA953\uA960-\uA97C\uA980-\uA9C0\uA9CF-\uA9D9\uA9E0-\uA9FE\uAA00-\uAA36\uAA40-\uAA4D\uAA50-\uAA59\uAA60-\uAA76\uAA7A-\uAAC2\uAADB-\uAADD\uAAE0-\uAAEF\uAAF2-\uAAF6\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB65\uAB70-\uABEA\uABEC\uABED\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE00-\uFE0F\uFE20-\uFE2F\uFE33\uFE34\uFE4D-\uFE4F\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF3F\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD40-\uDD74\uDDFD\uDE80-\uDE9C\uDEA0-\uDED0\uDEE0\uDF00-\uDF1F\uDF2D-\uDF4A\uDF50-\uDF7A\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC60-\uDC76\uDC80-\uDC9E\uDCE0-\uDCF2\uDCF4\uDCF5\uDD00-\uDD15\uDD20-\uDD39\uDD80-\uDDB7\uDDBE\uDDBF\uDE00-\uDE03\uDE05\uDE06\uDE0C-\uDE13\uDE15-\uDE17\uDE19-\uDE33\uDE38-\uDE3A\uDE3F\uDE60-\uDE7C\uDE80-\uDE9C\uDEC0-\uDEC7\uDEC9-\uDEE6\uDF00-\uDF35\uDF40-\uDF55\uDF60-\uDF72\uDF80-\uDF91]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2]|\uD804[\uDC00-\uDC46\uDC66-\uDC6F\uDC7F-\uDCBA\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD00-\uDD34\uDD36-\uDD3F\uDD50-\uDD73\uDD76\uDD80-\uDDC4\uDDCA-\uDDCC\uDDD0-\uDDDA\uDDDC\uDE00-\uDE11\uDE13-\uDE37\uDE3E\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEEA\uDEF0-\uDEF9\uDF00-\uDF03\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3C-\uDF44\uDF47\uDF48\uDF4B-\uDF4D\uDF50\uDF57\uDF5D-\uDF63\uDF66-\uDF6C\uDF70-\uDF74]|\uD805[\uDC00-\uDC4A\uDC50-\uDC59\uDC80-\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDB5\uDDB8-\uDDC0\uDDD8-\uDDDD\uDE00-\uDE40\uDE44\uDE50-\uDE59\uDE80-\uDEB7\uDEC0-\uDEC9\uDF00-\uDF19\uDF1D-\uDF2B\uDF30-\uDF39]|\uD806[\uDCA0-\uDCE9\uDCFF\uDE00-\uDE3E\uDE47\uDE50-\uDE83\uDE86-\uDE99\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC36\uDC38-\uDC40\uDC50-\uDC59\uDC72-\uDC8F\uDC92-\uDCA7\uDCA9-\uDCB6\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD36\uDD3A\uDD3C\uDD3D\uDD3F-\uDD47\uDD50-\uDD59]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDEF0-\uDEF4\uDF00-\uDF36\uDF40-\uDF43\uDF50-\uDF59\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDF00-\uDF44\uDF50-\uDF7E\uDF8F-\uDF9F\uDFE0\uDFE1]|\uD821[\uDC00-\uDFEC]|\uD822[\uDC00-\uDEF2]|\uD82C[\uDC00-\uDD1E\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99\uDC9D\uDC9E]|\uD834[\uDD65-\uDD69\uDD6D-\uDD72\uDD7B-\uDD82\uDD85-\uDD8B\uDDAA-\uDDAD\uDE42-\uDE44]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD836[\uDE00-\uDE36\uDE3B-\uDE6C\uDE75\uDE84\uDE9B-\uDE9F\uDEA1-\uDEAF]|\uD838[\uDC00-\uDC06\uDC08-\uDC18\uDC1B-\uDC21\uDC23\uDC24\uDC26-\uDC2A]|\uD83A[\uDC00-\uDCC4\uDCD0-\uDCD6\uDD00-\uDD4A\uDD50-\uDD59]|\uD83B[\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD869[\uDC00-\uDED6\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uDB40[\uDD00-\uDDEF]/;

var unicode = {
	Space_Separator: Space_Separator,
	ID_Start: ID_Start,
	ID_Continue: ID_Continue
};

var util$9 = {
    isSpaceSeparator (c) {
        return typeof c === 'string' && unicode.Space_Separator.test(c)
    },

    isIdStartChar (c) {
        return typeof c === 'string' && (
            (c >= 'a' && c <= 'z') ||
        (c >= 'A' && c <= 'Z') ||
        (c === '$') || (c === '_') ||
        unicode.ID_Start.test(c)
        )
    },

    isIdContinueChar (c) {
        return typeof c === 'string' && (
            (c >= 'a' && c <= 'z') ||
        (c >= 'A' && c <= 'Z') ||
        (c >= '0' && c <= '9') ||
        (c === '$') || (c === '_') ||
        (c === '\u200C') || (c === '\u200D') ||
        unicode.ID_Continue.test(c)
        )
    },

    isDigit (c) {
        return typeof c === 'string' && /[0-9]/.test(c)
    },

    isHexDigit (c) {
        return typeof c === 'string' && /[0-9A-Fa-f]/.test(c)
    },
};

let source;
let parseState;
let stack;
let pos;
let line;
let column;
let token$1;
let key;
let root;

var parse$f = function parse (text, reviver) {
    source = String(text);
    parseState = 'start';
    stack = [];
    pos = 0;
    line = 1;
    column = 0;
    token$1 = undefined;
    key = undefined;
    root = undefined;

    do {
        token$1 = lex();

        // This code is unreachable.
        // if (!parseStates[parseState]) {
        //     throw invalidParseState()
        // }

        parseStates[parseState]();
    } while (token$1.type !== 'eof')

    if (typeof reviver === 'function') {
        return internalize({'': root}, '', reviver)
    }

    return root
};

function internalize (holder, name, reviver) {
    const value = holder[name];
    if (value != null && typeof value === 'object') {
        if (Array.isArray(value)) {
            for (let i = 0; i < value.length; i++) {
                const key = String(i);
                const replacement = internalize(value, key, reviver);
                if (replacement === undefined) {
                    delete value[key];
                } else {
                    Object.defineProperty(value, key, {
                        value: replacement,
                        writable: true,
                        enumerable: true,
                        configurable: true,
                    });
                }
            }
        } else {
            for (const key in value) {
                const replacement = internalize(value, key, reviver);
                if (replacement === undefined) {
                    delete value[key];
                } else {
                    Object.defineProperty(value, key, {
                        value: replacement,
                        writable: true,
                        enumerable: true,
                        configurable: true,
                    });
                }
            }
        }
    }

    return reviver.call(holder, name, value)
}

let lexState;
let buffer$3;
let doubleQuote;
let sign;
let c$1;

function lex () {
    lexState = 'default';
    buffer$3 = '';
    doubleQuote = false;
    sign = 1;

    for (;;) {
        c$1 = peek();

        // This code is unreachable.
        // if (!lexStates[lexState]) {
        //     throw invalidLexState(lexState)
        // }

        const token = lexStates[lexState]();
        if (token) {
            return token
        }
    }
}

function peek () {
    if (source[pos]) {
        return String.fromCodePoint(source.codePointAt(pos))
    }
}

function read$5 () {
    const c = peek();

    if (c === '\n') {
        line++;
        column = 0;
    } else if (c) {
        column += c.length;
    } else {
        column++;
    }

    if (c) {
        pos += c.length;
    }

    return c
}

const lexStates = {
    default () {
        switch (c$1) {
        case '\t':
        case '\v':
        case '\f':
        case ' ':
        case '\u00A0':
        case '\uFEFF':
        case '\n':
        case '\r':
        case '\u2028':
        case '\u2029':
            read$5();
            return

        case '/':
            read$5();
            lexState = 'comment';
            return

        case undefined:
            read$5();
            return newToken('eof')
        }

        if (util$9.isSpaceSeparator(c$1)) {
            read$5();
            return
        }

        // This code is unreachable.
        // if (!lexStates[parseState]) {
        //     throw invalidLexState(parseState)
        // }

        return lexStates[parseState]()
    },

    comment () {
        switch (c$1) {
        case '*':
            read$5();
            lexState = 'multiLineComment';
            return

        case '/':
            read$5();
            lexState = 'singleLineComment';
            return
        }

        throw invalidChar(read$5())
    },

    multiLineComment () {
        switch (c$1) {
        case '*':
            read$5();
            lexState = 'multiLineCommentAsterisk';
            return

        case undefined:
            throw invalidChar(read$5())
        }

        read$5();
    },

    multiLineCommentAsterisk () {
        switch (c$1) {
        case '*':
            read$5();
            return

        case '/':
            read$5();
            lexState = 'default';
            return

        case undefined:
            throw invalidChar(read$5())
        }

        read$5();
        lexState = 'multiLineComment';
    },

    singleLineComment () {
        switch (c$1) {
        case '\n':
        case '\r':
        case '\u2028':
        case '\u2029':
            read$5();
            lexState = 'default';
            return

        case undefined:
            read$5();
            return newToken('eof')
        }

        read$5();
    },

    value () {
        switch (c$1) {
        case '{':
        case '[':
            return newToken('punctuator', read$5())

        case 'n':
            read$5();
            literal$1('ull');
            return newToken('null', null)

        case 't':
            read$5();
            literal$1('rue');
            return newToken('boolean', true)

        case 'f':
            read$5();
            literal$1('alse');
            return newToken('boolean', false)

        case '-':
        case '+':
            if (read$5() === '-') {
                sign = -1;
            }

            lexState = 'sign';
            return

        case '.':
            buffer$3 = read$5();
            lexState = 'decimalPointLeading';
            return

        case '0':
            buffer$3 = read$5();
            lexState = 'zero';
            return

        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
            buffer$3 = read$5();
            lexState = 'decimalInteger';
            return

        case 'I':
            read$5();
            literal$1('nfinity');
            return newToken('numeric', Infinity)

        case 'N':
            read$5();
            literal$1('aN');
            return newToken('numeric', NaN)

        case '"':
        case "'":
            doubleQuote = (read$5() === '"');
            buffer$3 = '';
            lexState = 'string';
            return
        }

        throw invalidChar(read$5())
    },

    identifierNameStartEscape () {
        if (c$1 !== 'u') {
            throw invalidChar(read$5())
        }

        read$5();
        const u = unicodeEscape();
        switch (u) {
        case '$':
        case '_':
            break

        default:
            if (!util$9.isIdStartChar(u)) {
                throw invalidIdentifier()
            }

            break
        }

        buffer$3 += u;
        lexState = 'identifierName';
    },

    identifierName () {
        switch (c$1) {
        case '$':
        case '_':
        case '\u200C':
        case '\u200D':
            buffer$3 += read$5();
            return

        case '\\':
            read$5();
            lexState = 'identifierNameEscape';
            return
        }

        if (util$9.isIdContinueChar(c$1)) {
            buffer$3 += read$5();
            return
        }

        return newToken('identifier', buffer$3)
    },

    identifierNameEscape () {
        if (c$1 !== 'u') {
            throw invalidChar(read$5())
        }

        read$5();
        const u = unicodeEscape();
        switch (u) {
        case '$':
        case '_':
        case '\u200C':
        case '\u200D':
            break

        default:
            if (!util$9.isIdContinueChar(u)) {
                throw invalidIdentifier()
            }

            break
        }

        buffer$3 += u;
        lexState = 'identifierName';
    },

    sign () {
        switch (c$1) {
        case '.':
            buffer$3 = read$5();
            lexState = 'decimalPointLeading';
            return

        case '0':
            buffer$3 = read$5();
            lexState = 'zero';
            return

        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
            buffer$3 = read$5();
            lexState = 'decimalInteger';
            return

        case 'I':
            read$5();
            literal$1('nfinity');
            return newToken('numeric', sign * Infinity)

        case 'N':
            read$5();
            literal$1('aN');
            return newToken('numeric', NaN)
        }

        throw invalidChar(read$5())
    },

    zero () {
        switch (c$1) {
        case '.':
            buffer$3 += read$5();
            lexState = 'decimalPoint';
            return

        case 'e':
        case 'E':
            buffer$3 += read$5();
            lexState = 'decimalExponent';
            return

        case 'x':
        case 'X':
            buffer$3 += read$5();
            lexState = 'hexadecimal';
            return
        }

        return newToken('numeric', sign * 0)
    },

    decimalInteger () {
        switch (c$1) {
        case '.':
            buffer$3 += read$5();
            lexState = 'decimalPoint';
            return

        case 'e':
        case 'E':
            buffer$3 += read$5();
            lexState = 'decimalExponent';
            return
        }

        if (util$9.isDigit(c$1)) {
            buffer$3 += read$5();
            return
        }

        return newToken('numeric', sign * Number(buffer$3))
    },

    decimalPointLeading () {
        if (util$9.isDigit(c$1)) {
            buffer$3 += read$5();
            lexState = 'decimalFraction';
            return
        }

        throw invalidChar(read$5())
    },

    decimalPoint () {
        switch (c$1) {
        case 'e':
        case 'E':
            buffer$3 += read$5();
            lexState = 'decimalExponent';
            return
        }

        if (util$9.isDigit(c$1)) {
            buffer$3 += read$5();
            lexState = 'decimalFraction';
            return
        }

        return newToken('numeric', sign * Number(buffer$3))
    },

    decimalFraction () {
        switch (c$1) {
        case 'e':
        case 'E':
            buffer$3 += read$5();
            lexState = 'decimalExponent';
            return
        }

        if (util$9.isDigit(c$1)) {
            buffer$3 += read$5();
            return
        }

        return newToken('numeric', sign * Number(buffer$3))
    },

    decimalExponent () {
        switch (c$1) {
        case '+':
        case '-':
            buffer$3 += read$5();
            lexState = 'decimalExponentSign';
            return
        }

        if (util$9.isDigit(c$1)) {
            buffer$3 += read$5();
            lexState = 'decimalExponentInteger';
            return
        }

        throw invalidChar(read$5())
    },

    decimalExponentSign () {
        if (util$9.isDigit(c$1)) {
            buffer$3 += read$5();
            lexState = 'decimalExponentInteger';
            return
        }

        throw invalidChar(read$5())
    },

    decimalExponentInteger () {
        if (util$9.isDigit(c$1)) {
            buffer$3 += read$5();
            return
        }

        return newToken('numeric', sign * Number(buffer$3))
    },

    hexadecimal () {
        if (util$9.isHexDigit(c$1)) {
            buffer$3 += read$5();
            lexState = 'hexadecimalInteger';
            return
        }

        throw invalidChar(read$5())
    },

    hexadecimalInteger () {
        if (util$9.isHexDigit(c$1)) {
            buffer$3 += read$5();
            return
        }

        return newToken('numeric', sign * Number(buffer$3))
    },

    string () {
        switch (c$1) {
        case '\\':
            read$5();
            buffer$3 += escape$2();
            return

        case '"':
            if (doubleQuote) {
                read$5();
                return newToken('string', buffer$3)
            }

            buffer$3 += read$5();
            return

        case "'":
            if (!doubleQuote) {
                read$5();
                return newToken('string', buffer$3)
            }

            buffer$3 += read$5();
            return

        case '\n':
        case '\r':
            throw invalidChar(read$5())

        case '\u2028':
        case '\u2029':
            separatorChar(c$1);
            break

        case undefined:
            throw invalidChar(read$5())
        }

        buffer$3 += read$5();
    },

    start () {
        switch (c$1) {
        case '{':
        case '[':
            return newToken('punctuator', read$5())

        // This code is unreachable since the default lexState handles eof.
        // case undefined:
        //     return newToken('eof')
        }

        lexState = 'value';
    },

    beforePropertyName () {
        switch (c$1) {
        case '$':
        case '_':
            buffer$3 = read$5();
            lexState = 'identifierName';
            return

        case '\\':
            read$5();
            lexState = 'identifierNameStartEscape';
            return

        case '}':
            return newToken('punctuator', read$5())

        case '"':
        case "'":
            doubleQuote = (read$5() === '"');
            lexState = 'string';
            return
        }

        if (util$9.isIdStartChar(c$1)) {
            buffer$3 += read$5();
            lexState = 'identifierName';
            return
        }

        throw invalidChar(read$5())
    },

    afterPropertyName () {
        if (c$1 === ':') {
            return newToken('punctuator', read$5())
        }

        throw invalidChar(read$5())
    },

    beforePropertyValue () {
        lexState = 'value';
    },

    afterPropertyValue () {
        switch (c$1) {
        case ',':
        case '}':
            return newToken('punctuator', read$5())
        }

        throw invalidChar(read$5())
    },

    beforeArrayValue () {
        if (c$1 === ']') {
            return newToken('punctuator', read$5())
        }

        lexState = 'value';
    },

    afterArrayValue () {
        switch (c$1) {
        case ',':
        case ']':
            return newToken('punctuator', read$5())
        }

        throw invalidChar(read$5())
    },

    end () {
        // This code is unreachable since it's handled by the default lexState.
        // if (c === undefined) {
        //     read()
        //     return newToken('eof')
        // }

        throw invalidChar(read$5())
    },
};

function newToken (type, value) {
    return {
        type,
        value,
        line,
        column,
    }
}

function literal$1 (s) {
    for (const c of s) {
        const p = peek();

        if (p !== c) {
            throw invalidChar(read$5())
        }

        read$5();
    }
}

function escape$2 () {
    const c = peek();
    switch (c) {
    case 'b':
        read$5();
        return '\b'

    case 'f':
        read$5();
        return '\f'

    case 'n':
        read$5();
        return '\n'

    case 'r':
        read$5();
        return '\r'

    case 't':
        read$5();
        return '\t'

    case 'v':
        read$5();
        return '\v'

    case '0':
        read$5();
        if (util$9.isDigit(peek())) {
            throw invalidChar(read$5())
        }

        return '\0'

    case 'x':
        read$5();
        return hexEscape()

    case 'u':
        read$5();
        return unicodeEscape()

    case '\n':
    case '\u2028':
    case '\u2029':
        read$5();
        return ''

    case '\r':
        read$5();
        if (peek() === '\n') {
            read$5();
        }

        return ''

    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
        throw invalidChar(read$5())

    case undefined:
        throw invalidChar(read$5())
    }

    return read$5()
}

function hexEscape () {
    let buffer = '';
    let c = peek();

    if (!util$9.isHexDigit(c)) {
        throw invalidChar(read$5())
    }

    buffer += read$5();

    c = peek();
    if (!util$9.isHexDigit(c)) {
        throw invalidChar(read$5())
    }

    buffer += read$5();

    return String.fromCodePoint(parseInt(buffer, 16))
}

function unicodeEscape () {
    let buffer = '';
    let count = 4;

    while (count-- > 0) {
        const c = peek();
        if (!util$9.isHexDigit(c)) {
            throw invalidChar(read$5())
        }

        buffer += read$5();
    }

    return String.fromCodePoint(parseInt(buffer, 16))
}

const parseStates = {
    start () {
        if (token$1.type === 'eof') {
            throw invalidEOF()
        }

        push();
    },

    beforePropertyName () {
        switch (token$1.type) {
        case 'identifier':
        case 'string':
            key = token$1.value;
            parseState = 'afterPropertyName';
            return

        case 'punctuator':
            // This code is unreachable since it's handled by the lexState.
            // if (token.value !== '}') {
            //     throw invalidToken()
            // }

            pop();
            return

        case 'eof':
            throw invalidEOF()
        }

        // This code is unreachable since it's handled by the lexState.
        // throw invalidToken()
    },

    afterPropertyName () {
        // This code is unreachable since it's handled by the lexState.
        // if (token.type !== 'punctuator' || token.value !== ':') {
        //     throw invalidToken()
        // }

        if (token$1.type === 'eof') {
            throw invalidEOF()
        }

        parseState = 'beforePropertyValue';
    },

    beforePropertyValue () {
        if (token$1.type === 'eof') {
            throw invalidEOF()
        }

        push();
    },

    beforeArrayValue () {
        if (token$1.type === 'eof') {
            throw invalidEOF()
        }

        if (token$1.type === 'punctuator' && token$1.value === ']') {
            pop();
            return
        }

        push();
    },

    afterPropertyValue () {
        // This code is unreachable since it's handled by the lexState.
        // if (token.type !== 'punctuator') {
        //     throw invalidToken()
        // }

        if (token$1.type === 'eof') {
            throw invalidEOF()
        }

        switch (token$1.value) {
        case ',':
            parseState = 'beforePropertyName';
            return

        case '}':
            pop();
        }

        // This code is unreachable since it's handled by the lexState.
        // throw invalidToken()
    },

    afterArrayValue () {
        // This code is unreachable since it's handled by the lexState.
        // if (token.type !== 'punctuator') {
        //     throw invalidToken()
        // }

        if (token$1.type === 'eof') {
            throw invalidEOF()
        }

        switch (token$1.value) {
        case ',':
            parseState = 'beforeArrayValue';
            return

        case ']':
            pop();
        }

        // This code is unreachable since it's handled by the lexState.
        // throw invalidToken()
    },

    end () {
        // This code is unreachable since it's handled by the lexState.
        // if (token.type !== 'eof') {
        //     throw invalidToken()
        // }
    },
};

function push () {
    let value;

    switch (token$1.type) {
    case 'punctuator':
        switch (token$1.value) {
        case '{':
            value = {};
            break

        case '[':
            value = [];
            break
        }

        break

    case 'null':
    case 'boolean':
    case 'numeric':
    case 'string':
        value = token$1.value;
        break

    // This code is unreachable.
    // default:
    //     throw invalidToken()
    }

    if (root === undefined) {
        root = value;
    } else {
        const parent = stack[stack.length - 1];
        if (Array.isArray(parent)) {
            parent.push(value);
        } else {
            Object.defineProperty(parent, key, {
                value,
                writable: true,
                enumerable: true,
                configurable: true,
            });
        }
    }

    if (value !== null && typeof value === 'object') {
        stack.push(value);

        if (Array.isArray(value)) {
            parseState = 'beforeArrayValue';
        } else {
            parseState = 'beforePropertyName';
        }
    } else {
        const current = stack[stack.length - 1];
        if (current == null) {
            parseState = 'end';
        } else if (Array.isArray(current)) {
            parseState = 'afterArrayValue';
        } else {
            parseState = 'afterPropertyValue';
        }
    }
}

function pop () {
    stack.pop();

    const current = stack[stack.length - 1];
    if (current == null) {
        parseState = 'end';
    } else if (Array.isArray(current)) {
        parseState = 'afterArrayValue';
    } else {
        parseState = 'afterPropertyValue';
    }
}

// This code is unreachable.
// function invalidParseState () {
//     return new Error(`JSON5: invalid parse state '${parseState}'`)
// }

// This code is unreachable.
// function invalidLexState (state) {
//     return new Error(`JSON5: invalid lex state '${state}'`)
// }

function invalidChar (c) {
    if (c === undefined) {
        return syntaxError(`JSON5: invalid end of input at ${line}:${column}`)
    }

    return syntaxError(`JSON5: invalid character '${formatChar(c)}' at ${line}:${column}`)
}

function invalidEOF () {
    return syntaxError(`JSON5: invalid end of input at ${line}:${column}`)
}

// This code is unreachable.
// function invalidToken () {
//     if (token.type === 'eof') {
//         return syntaxError(`JSON5: invalid end of input at ${line}:${column}`)
//     }

//     const c = String.fromCodePoint(token.value.codePointAt(0))
//     return syntaxError(`JSON5: invalid character '${formatChar(c)}' at ${line}:${column}`)
// }

function invalidIdentifier () {
    column -= 5;
    return syntaxError(`JSON5: invalid identifier character at ${line}:${column}`)
}

function separatorChar (c) {
    console.warn(`JSON5: '${formatChar(c)}' in strings is not valid ECMAScript; consider escaping`);
}

function formatChar (c) {
    const replacements = {
        "'": "\\'",
        '"': '\\"',
        '\\': '\\\\',
        '\b': '\\b',
        '\f': '\\f',
        '\n': '\\n',
        '\r': '\\r',
        '\t': '\\t',
        '\v': '\\v',
        '\0': '\\0',
        '\u2028': '\\u2028',
        '\u2029': '\\u2029',
    };

    if (replacements[c]) {
        return replacements[c]
    }

    if (c < ' ') {
        const hexString = c.charCodeAt(0).toString(16);
        return '\\x' + ('00' + hexString).substring(hexString.length)
    }

    return c
}

function syntaxError (message) {
    const err = new SyntaxError(message);
    err.lineNumber = line;
    err.columnNumber = column;
    return err
}

var stringify$b = function stringify (value, replacer, space) {
    const stack = [];
    let indent = '';
    let propertyList;
    let replacerFunc;
    let gap = '';
    let quote;

    if (
        replacer != null &&
        typeof replacer === 'object' &&
        !Array.isArray(replacer)
    ) {
        space = replacer.space;
        quote = replacer.quote;
        replacer = replacer.replacer;
    }

    if (typeof replacer === 'function') {
        replacerFunc = replacer;
    } else if (Array.isArray(replacer)) {
        propertyList = [];
        for (const v of replacer) {
            let item;

            if (typeof v === 'string') {
                item = v;
            } else if (
                typeof v === 'number' ||
                v instanceof String ||
                v instanceof Number
            ) {
                item = String(v);
            }

            if (item !== undefined && propertyList.indexOf(item) < 0) {
                propertyList.push(item);
            }
        }
    }

    if (space instanceof Number) {
        space = Number(space);
    } else if (space instanceof String) {
        space = String(space);
    }

    if (typeof space === 'number') {
        if (space > 0) {
            space = Math.min(10, Math.floor(space));
            gap = '          '.substr(0, space);
        }
    } else if (typeof space === 'string') {
        gap = space.substr(0, 10);
    }

    return serializeProperty('', {'': value})

    function serializeProperty (key, holder) {
        let value = holder[key];
        if (value != null) {
            if (typeof value.toJSON5 === 'function') {
                value = value.toJSON5(key);
            } else if (typeof value.toJSON === 'function') {
                value = value.toJSON(key);
            }
        }

        if (replacerFunc) {
            value = replacerFunc.call(holder, key, value);
        }

        if (value instanceof Number) {
            value = Number(value);
        } else if (value instanceof String) {
            value = String(value);
        } else if (value instanceof Boolean) {
            value = value.valueOf();
        }

        switch (value) {
        case null: return 'null'
        case true: return 'true'
        case false: return 'false'
        }

        if (typeof value === 'string') {
            return quoteString(value)
        }

        if (typeof value === 'number') {
            return String(value)
        }

        if (typeof value === 'object') {
            return Array.isArray(value) ? serializeArray(value) : serializeObject(value)
        }

        return undefined
    }

    function quoteString (value) {
        const quotes = {
            "'": 0.1,
            '"': 0.2,
        };

        const replacements = {
            "'": "\\'",
            '"': '\\"',
            '\\': '\\\\',
            '\b': '\\b',
            '\f': '\\f',
            '\n': '\\n',
            '\r': '\\r',
            '\t': '\\t',
            '\v': '\\v',
            '\0': '\\0',
            '\u2028': '\\u2028',
            '\u2029': '\\u2029',
        };

        let product = '';

        for (let i = 0; i < value.length; i++) {
            const c = value[i];
            switch (c) {
            case "'":
            case '"':
                quotes[c]++;
                product += c;
                continue

            case '\0':
                if (util$9.isDigit(value[i + 1])) {
                    product += '\\x00';
                    continue
                }
            }

            if (replacements[c]) {
                product += replacements[c];
                continue
            }

            if (c < ' ') {
                let hexString = c.charCodeAt(0).toString(16);
                product += '\\x' + ('00' + hexString).substring(hexString.length);
                continue
            }

            product += c;
        }

        const quoteChar = quote || Object.keys(quotes).reduce((a, b) => (quotes[a] < quotes[b]) ? a : b);

        product = product.replace(new RegExp(quoteChar, 'g'), replacements[quoteChar]);

        return quoteChar + product + quoteChar
    }

    function serializeObject (value) {
        if (stack.indexOf(value) >= 0) {
            throw TypeError('Converting circular structure to JSON5')
        }

        stack.push(value);

        let stepback = indent;
        indent = indent + gap;

        let keys = propertyList || Object.keys(value);
        let partial = [];
        for (const key of keys) {
            const propertyString = serializeProperty(key, value);
            if (propertyString !== undefined) {
                let member = serializeKey(key) + ':';
                if (gap !== '') {
                    member += ' ';
                }
                member += propertyString;
                partial.push(member);
            }
        }

        let final;
        if (partial.length === 0) {
            final = '{}';
        } else {
            let properties;
            if (gap === '') {
                properties = partial.join(',');
                final = '{' + properties + '}';
            } else {
                let separator = ',\n' + indent;
                properties = partial.join(separator);
                final = '{\n' + indent + properties + ',\n' + stepback + '}';
            }
        }

        stack.pop();
        indent = stepback;
        return final
    }

    function serializeKey (key) {
        if (key.length === 0) {
            return quoteString(key)
        }

        const firstChar = String.fromCodePoint(key.codePointAt(0));
        if (!util$9.isIdStartChar(firstChar)) {
            return quoteString(key)
        }

        for (let i = firstChar.length; i < key.length; i++) {
            if (!util$9.isIdContinueChar(String.fromCodePoint(key.codePointAt(i)))) {
                return quoteString(key)
            }
        }

        return key
    }

    function serializeArray (value) {
        if (stack.indexOf(value) >= 0) {
            throw TypeError('Converting circular structure to JSON5')
        }

        stack.push(value);

        let stepback = indent;
        indent = indent + gap;

        let partial = [];
        for (let i = 0; i < value.length; i++) {
            const propertyString = serializeProperty(String(i), value);
            partial.push((propertyString !== undefined) ? propertyString : 'null');
        }

        let final;
        if (partial.length === 0) {
            final = '[]';
        } else {
            if (gap === '') {
                let properties = partial.join(',');
                final = '[' + properties + ']';
            } else {
                let separator = ',\n' + indent;
                let properties = partial.join(separator);
                final = '[\n' + indent + properties + ',\n' + stepback + ']';
            }
        }

        stack.pop();
        indent = stepback;
        return final
    }
};

const JSON5$1 = {
    parse: parse$f,
    stringify: stringify$b,
};

var lib$u = JSON5$1;

var dist$2 = /*#__PURE__*/Object.freeze({
    __proto__: null,
    'default': lib$u
});

var require$$3$1 = /*@__PURE__*/getAugmentedNamespace(dist$2);

var stripBom$2 = x => {
	if (typeof x !== 'string') {
		throw new TypeError('Expected a string, got ' + typeof x);
	}

	// Catches EFBBBF (UTF-8 BOM) because the buffer-to-string
	// conversion translates it to FEFF (UTF-16 BOM)
	if (x.charCodeAt(0) === 0xFEFF) {
		return x.slice(1);
	}

	return x;
};

var __assign$4 = (commonjsGlobal && commonjsGlobal.__assign) || function () {
    __assign$4 = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign$4.apply(this, arguments);
};
Object.defineProperty(tsconfigLoader, "__esModule", { value: true });
var loadTsconfig_1 = tsconfigLoader.loadTsconfig = walkForTsConfig_1 = tsconfigLoader.walkForTsConfig = tsconfigLoader.tsConfigLoader = void 0;
var path$F = path__default["default"];
var fs$F = require$$0__default["default"];
// eslint-disable-next-line @typescript-eslint/no-require-imports
var JSON5 = require$$3$1;
// eslint-disable-next-line @typescript-eslint/no-require-imports
var StripBom = stripBom$2;
function tsConfigLoader(_a) {
    var getEnv = _a.getEnv, cwd = _a.cwd, _b = _a.loadSync, loadSync = _b === void 0 ? loadSyncDefault : _b;
    var TS_NODE_PROJECT = getEnv("TS_NODE_PROJECT");
    var TS_NODE_BASEURL = getEnv("TS_NODE_BASEURL");
    // tsconfig.loadSync handles if TS_NODE_PROJECT is a file or directory
    // and also overrides baseURL if TS_NODE_BASEURL is available.
    var loadResult = loadSync(cwd, TS_NODE_PROJECT, TS_NODE_BASEURL);
    return loadResult;
}
tsconfigLoader.tsConfigLoader = tsConfigLoader;
function loadSyncDefault(cwd, filename, baseUrl) {
    // Tsconfig.loadSync uses path.resolve. This is why we can use an absolute path as filename
    var configPath = resolveConfigPath$1(cwd, filename);
    if (!configPath) {
        return {
            tsConfigPath: undefined,
            baseUrl: undefined,
            paths: undefined,
        };
    }
    var config = loadTsconfig(configPath);
    return {
        tsConfigPath: configPath,
        baseUrl: baseUrl ||
            (config && config.compilerOptions && config.compilerOptions.baseUrl),
        paths: config && config.compilerOptions && config.compilerOptions.paths,
    };
}
function resolveConfigPath$1(cwd, filename) {
    if (filename) {
        var absolutePath = fs$F.lstatSync(filename).isDirectory()
            ? path$F.resolve(filename, "./tsconfig.json")
            : path$F.resolve(cwd, filename);
        return absolutePath;
    }
    if (fs$F.statSync(cwd).isFile()) {
        return path$F.resolve(cwd);
    }
    var configAbsolutePath = walkForTsConfig(cwd);
    return configAbsolutePath ? path$F.resolve(configAbsolutePath) : undefined;
}
function walkForTsConfig(directory, readdirSync) {
    if (readdirSync === void 0) { readdirSync = fs$F.readdirSync; }
    var files = readdirSync(directory);
    var filesToCheck = ["tsconfig.json", "jsconfig.json"];
    for (var _i = 0, filesToCheck_1 = filesToCheck; _i < filesToCheck_1.length; _i++) {
        var fileToCheck = filesToCheck_1[_i];
        if (files.indexOf(fileToCheck) !== -1) {
            return path$F.join(directory, fileToCheck);
        }
    }
    var parentDirectory = path$F.dirname(directory);
    // If we reached the top
    if (directory === parentDirectory) {
        return undefined;
    }
    return walkForTsConfig(parentDirectory, readdirSync);
}
var walkForTsConfig_1 = tsconfigLoader.walkForTsConfig = walkForTsConfig;
function loadTsconfig(configFilePath, 
// eslint-disable-next-line no-shadow
existsSync, readFileSync) {
    if (existsSync === void 0) { existsSync = fs$F.existsSync; }
    if (readFileSync === void 0) { readFileSync = function (filename) {
        return fs$F.readFileSync(filename, "utf8");
    }; }
    if (!existsSync(configFilePath)) {
        return undefined;
    }
    var configString = readFileSync(configFilePath);
    var cleanedJson = StripBom(configString);
    var config;
    try {
        config = JSON5.parse(cleanedJson);
    }
    catch (e) {
        throw new Error("".concat(configFilePath, " is malformed ").concat(e.message));
    }
    var extendedConfig = config.extends;
    if (extendedConfig) {
        var base = void 0;
        if (Array.isArray(extendedConfig)) {
            base = extendedConfig.reduce(function (currBase, extendedConfigElement) {
                return mergeTsconfigs(currBase, loadTsconfigFromExtends(configFilePath, extendedConfigElement, existsSync, readFileSync));
            }, {});
        }
        else {
            base = loadTsconfigFromExtends(configFilePath, extendedConfig, existsSync, readFileSync);
        }
        return mergeTsconfigs(base, config);
    }
    return config;
}
loadTsconfig_1 = tsconfigLoader.loadTsconfig = loadTsconfig;
/**
 * Intended to be called only from loadTsconfig.
 * Parameters don't have defaults because they should use the same as loadTsconfig.
 */
function loadTsconfigFromExtends(configFilePath, extendedConfigValue, 
// eslint-disable-next-line no-shadow
existsSync, readFileSync) {
    var _a;
    if (typeof extendedConfigValue === "string" &&
        extendedConfigValue.indexOf(".json") === -1) {
        extendedConfigValue += ".json";
    }
    var currentDir = path$F.dirname(configFilePath);
    var extendedConfigPath = path$F.join(currentDir, extendedConfigValue);
    if (extendedConfigValue.indexOf("/") !== -1 &&
        extendedConfigValue.indexOf(".") !== -1 &&
        !existsSync(extendedConfigPath)) {
        extendedConfigPath = path$F.join(currentDir, "node_modules", extendedConfigValue);
    }
    var config = loadTsconfig(extendedConfigPath, existsSync, readFileSync) || {};
    // baseUrl should be interpreted as relative to extendedConfigPath,
    // but we need to update it so it is relative to the original tsconfig being loaded
    if ((_a = config.compilerOptions) === null || _a === void 0 ? void 0 : _a.baseUrl) {
        var extendsDir = path$F.dirname(extendedConfigValue);
        config.compilerOptions.baseUrl = path$F.join(extendsDir, config.compilerOptions.baseUrl);
    }
    return config;
}
function mergeTsconfigs(base, config) {
    base = base || {};
    config = config || {};
    return __assign$4(__assign$4(__assign$4({}, base), config), { compilerOptions: __assign$4(__assign$4({}, base.compilerOptions), config.compilerOptions) });
}

Object.defineProperty(configLoader$1, "__esModule", { value: true });
configLoader$1.configLoader = configLoader$1.loadConfig = void 0;
var TsConfigLoader2 = tsconfigLoader;
var path$E = path__default["default"];
function loadConfig$1(cwd) {
    if (cwd === void 0) { cwd = process.cwd(); }
    return configLoader({ cwd: cwd });
}
configLoader$1.loadConfig = loadConfig$1;
function configLoader(_a) {
    var cwd = _a.cwd, explicitParams = _a.explicitParams, _b = _a.tsConfigLoader, tsConfigLoader = _b === void 0 ? TsConfigLoader2.tsConfigLoader : _b;
    if (explicitParams) {
        var absoluteBaseUrl = path$E.isAbsolute(explicitParams.baseUrl)
            ? explicitParams.baseUrl
            : path$E.join(cwd, explicitParams.baseUrl);
        return {
            resultType: "success",
            configFileAbsolutePath: "",
            baseUrl: explicitParams.baseUrl,
            absoluteBaseUrl: absoluteBaseUrl,
            paths: explicitParams.paths,
            mainFields: explicitParams.mainFields,
            addMatchAll: explicitParams.addMatchAll,
        };
    }
    // Load tsconfig and create path matching function
    var loadResult = tsConfigLoader({
        cwd: cwd,
        getEnv: function (key) { return process.env[key]; },
    });
    if (!loadResult.tsConfigPath) {
        return {
            resultType: "failed",
            message: "Couldn't find tsconfig.json",
        };
    }
    return {
        resultType: "success",
        configFileAbsolutePath: loadResult.tsConfigPath,
        baseUrl: loadResult.baseUrl,
        absoluteBaseUrl: path$E.resolve(path$E.dirname(loadResult.tsConfigPath), loadResult.baseUrl || ""),
        paths: loadResult.paths || {},
        addMatchAll: loadResult.baseUrl !== undefined,
    };
}
configLoader$1.configLoader = configLoader;

var minimist;
var hasRequiredMinimist;

function requireMinimist () {
	if (hasRequiredMinimist) return minimist;
	hasRequiredMinimist = 1;

	function hasKey(obj, keys) {
		var o = obj;
		keys.slice(0, -1).forEach(function (key) {
			o = o[key] || {};
		});

		var key = keys[keys.length - 1];
		return key in o;
	}

	function isNumber(x) {
		if (typeof x === 'number') { return true; }
		if ((/^0x[0-9a-f]+$/i).test(x)) { return true; }
		return (/^[-+]?(?:\d+(?:\.\d*)?|\.\d+)(e[-+]?\d+)?$/).test(x);
	}

	function isConstructorOrProto(obj, key) {
		return (key === 'constructor' && typeof obj[key] === 'function') || key === '__proto__';
	}

	minimist = function (args, opts) {
		if (!opts) { opts = {}; }

		var flags = {
			bools: {},
			strings: {},
			unknownFn: null,
		};

		if (typeof opts.unknown === 'function') {
			flags.unknownFn = opts.unknown;
		}

		if (typeof opts.boolean === 'boolean' && opts.boolean) {
			flags.allBools = true;
		} else {
			[].concat(opts.boolean).filter(Boolean).forEach(function (key) {
				flags.bools[key] = true;
			});
		}

		var aliases = {};

		function aliasIsBoolean(key) {
			return aliases[key].some(function (x) {
				return flags.bools[x];
			});
		}

		Object.keys(opts.alias || {}).forEach(function (key) {
			aliases[key] = [].concat(opts.alias[key]);
			aliases[key].forEach(function (x) {
				aliases[x] = [key].concat(aliases[key].filter(function (y) {
					return x !== y;
				}));
			});
		});

		[].concat(opts.string).filter(Boolean).forEach(function (key) {
			flags.strings[key] = true;
			if (aliases[key]) {
				[].concat(aliases[key]).forEach(function (k) {
					flags.strings[k] = true;
				});
			}
		});

		var defaults = opts.default || {};

		var argv = { _: [] };

		function argDefined(key, arg) {
			return (flags.allBools && (/^--[^=]+$/).test(arg))
				|| flags.strings[key]
				|| flags.bools[key]
				|| aliases[key];
		}

		function setKey(obj, keys, value) {
			var o = obj;
			for (var i = 0; i < keys.length - 1; i++) {
				var key = keys[i];
				if (isConstructorOrProto(o, key)) { return; }
				if (o[key] === undefined) { o[key] = {}; }
				if (
					o[key] === Object.prototype
					|| o[key] === Number.prototype
					|| o[key] === String.prototype
				) {
					o[key] = {};
				}
				if (o[key] === Array.prototype) { o[key] = []; }
				o = o[key];
			}

			var lastKey = keys[keys.length - 1];
			if (isConstructorOrProto(o, lastKey)) { return; }
			if (
				o === Object.prototype
				|| o === Number.prototype
				|| o === String.prototype
			) {
				o = {};
			}
			if (o === Array.prototype) { o = []; }
			if (o[lastKey] === undefined || flags.bools[lastKey] || typeof o[lastKey] === 'boolean') {
				o[lastKey] = value;
			} else if (Array.isArray(o[lastKey])) {
				o[lastKey].push(value);
			} else {
				o[lastKey] = [o[lastKey], value];
			}
		}

		function setArg(key, val, arg) {
			if (arg && flags.unknownFn && !argDefined(key, arg)) {
				if (flags.unknownFn(arg) === false) { return; }
			}

			var value = !flags.strings[key] && isNumber(val)
				? Number(val)
				: val;
			setKey(argv, key.split('.'), value);

			(aliases[key] || []).forEach(function (x) {
				setKey(argv, x.split('.'), value);
			});
		}

		Object.keys(flags.bools).forEach(function (key) {
			setArg(key, defaults[key] === undefined ? false : defaults[key]);
		});

		var notFlags = [];

		if (args.indexOf('--') !== -1) {
			notFlags = args.slice(args.indexOf('--') + 1);
			args = args.slice(0, args.indexOf('--'));
		}

		for (var i = 0; i < args.length; i++) {
			var arg = args[i];
			var key;
			var next;

			if ((/^--.+=/).test(arg)) {
				// Using [\s\S] instead of . because js doesn't support the
				// 'dotall' regex modifier. See:
				// http://stackoverflow.com/a/1068308/13216
				var m = arg.match(/^--([^=]+)=([\s\S]*)$/);
				key = m[1];
				var value = m[2];
				if (flags.bools[key]) {
					value = value !== 'false';
				}
				setArg(key, value, arg);
			} else if ((/^--no-.+/).test(arg)) {
				key = arg.match(/^--no-(.+)/)[1];
				setArg(key, false, arg);
			} else if ((/^--.+/).test(arg)) {
				key = arg.match(/^--(.+)/)[1];
				next = args[i + 1];
				if (
					next !== undefined
					&& !(/^(-|--)[^-]/).test(next)
					&& !flags.bools[key]
					&& !flags.allBools
					&& (aliases[key] ? !aliasIsBoolean(key) : true)
				) {
					setArg(key, next, arg);
					i += 1;
				} else if ((/^(true|false)$/).test(next)) {
					setArg(key, next === 'true', arg);
					i += 1;
				} else {
					setArg(key, flags.strings[key] ? '' : true, arg);
				}
			} else if ((/^-[^-]+/).test(arg)) {
				var letters = arg.slice(1, -1).split('');

				var broken = false;
				for (var j = 0; j < letters.length; j++) {
					next = arg.slice(j + 2);

					if (next === '-') {
						setArg(letters[j], next, arg);
						continue;
					}

					if ((/[A-Za-z]/).test(letters[j]) && next[0] === '=') {
						setArg(letters[j], next.slice(1), arg);
						broken = true;
						break;
					}

					if (
						(/[A-Za-z]/).test(letters[j])
						&& (/-?\d+(\.\d*)?(e-?\d+)?$/).test(next)
					) {
						setArg(letters[j], next, arg);
						broken = true;
						break;
					}

					if (letters[j + 1] && letters[j + 1].match(/\W/)) {
						setArg(letters[j], arg.slice(j + 2), arg);
						broken = true;
						break;
					} else {
						setArg(letters[j], flags.strings[letters[j]] ? '' : true, arg);
					}
				}

				key = arg.slice(-1)[0];
				if (!broken && key !== '-') {
					if (
						args[i + 1]
						&& !(/^(-|--)[^-]/).test(args[i + 1])
						&& !flags.bools[key]
						&& (aliases[key] ? !aliasIsBoolean(key) : true)
					) {
						setArg(key, args[i + 1], arg);
						i += 1;
					} else if (args[i + 1] && (/^(true|false)$/).test(args[i + 1])) {
						setArg(key, args[i + 1] === 'true', arg);
						i += 1;
					} else {
						setArg(key, flags.strings[key] ? '' : true, arg);
					}
				}
			} else {
				if (!flags.unknownFn || flags.unknownFn(arg) !== false) {
					argv._.push(flags.strings._ || !isNumber(arg) ? arg : Number(arg));
				}
				if (opts.stopEarly) {
					argv._.push.apply(argv._, args.slice(i + 1));
					break;
				}
			}
		}

		Object.keys(defaults).forEach(function (k) {
			if (!hasKey(argv, k.split('.'))) {
				setKey(argv, k.split('.'), defaults[k]);

				(aliases[k] || []).forEach(function (x) {
					setKey(argv, x.split('.'), defaults[k]);
				});
			}
		});

		if (opts['--']) {
			argv['--'] = notFlags.slice();
		} else {
			notFlags.forEach(function (k) {
				argv._.push(k);
			});
		}

		return argv;
	};
	return minimist;
}

var __spreadArray$2 = (commonjsGlobal && commonjsGlobal.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(register$1, "__esModule", { value: true });
register$1.register = void 0;
var match_path_sync_1 = matchPathSync;
var config_loader_1 = configLoader$1;
var noOp = function () { return void 0; };
function getCoreModules(builtinModules) {
    builtinModules = builtinModules || [
        "assert",
        "buffer",
        "child_process",
        "cluster",
        "crypto",
        "dgram",
        "dns",
        "domain",
        "events",
        "fs",
        "http",
        "https",
        "net",
        "os",
        "path",
        "punycode",
        "querystring",
        "readline",
        "stream",
        "string_decoder",
        "tls",
        "tty",
        "url",
        "util",
        "v8",
        "vm",
        "zlib",
    ];
    var coreModules = {};
    for (var _i = 0, builtinModules_1 = builtinModules; _i < builtinModules_1.length; _i++) {
        var module_1 = builtinModules_1[_i];
        coreModules[module_1] = true;
    }
    return coreModules;
}
/**
 * Installs a custom module load function that can adhere to paths in tsconfig.
 * Returns a function to undo paths registration.
 */
function register(params) {
    var cwd;
    var explicitParams;
    if (params) {
        cwd = params.cwd;
        if (params.baseUrl || params.paths) {
            explicitParams = params;
        }
    }
    else {
        // eslint-disable-next-line
        var minimist = requireMinimist();
        var argv = minimist(process.argv.slice(2), {
            // eslint-disable-next-line id-denylist
            string: ["project"],
            alias: {
                project: ["P"],
            },
        });
        cwd = argv.project;
    }
    var configLoaderResult = (0, config_loader_1.configLoader)({
        cwd: cwd !== null && cwd !== void 0 ? cwd : process.cwd(),
        explicitParams: explicitParams,
    });
    if (configLoaderResult.resultType === "failed") {
        console.warn("".concat(configLoaderResult.message, ". tsconfig-paths will be skipped"));
        return noOp;
    }
    var matchPath = (0, match_path_sync_1.createMatchPath)(configLoaderResult.absoluteBaseUrl, configLoaderResult.paths, configLoaderResult.mainFields, configLoaderResult.addMatchAll);
    // Patch node's module loading
    // eslint-disable-next-line @typescript-eslint/no-require-imports,@typescript-eslint/no-var-requires
    var Module = require$$3__default["default"];
    // eslint-disable-next-line no-underscore-dangle
    var originalResolveFilename = Module._resolveFilename;
    var coreModules = getCoreModules(Module.builtinModules);
    // eslint-disable-next-line @typescript-eslint/no-explicit-any,no-underscore-dangle
    Module._resolveFilename = function (request, _parent) {
        var isCoreModule = coreModules.hasOwnProperty(request);
        if (!isCoreModule) {
            var found = matchPath(request);
            if (found) {
                var modifiedArguments = __spreadArray$2([found], [].slice.call(arguments, 1), true); // Passes all arguments. Even those that is not specified above.
                return originalResolveFilename.apply(this, modifiedArguments);
            }
        }
        return originalResolveFilename.apply(this, arguments);
    };
    return function () {
        // Return node's module loading to original state.
        // eslint-disable-next-line no-underscore-dangle
        Module._resolveFilename = originalResolveFilename;
    };
}
register$1.register = register;

(function (exports) {
	Object.defineProperty(exports, "__esModule", { value: true });
	exports.loadConfig = exports.register = exports.matchFromAbsolutePathsAsync = exports.createMatchPathAsync = exports.matchFromAbsolutePaths = exports.createMatchPath = void 0;
	// register is used from register.js in root dir
	var match_path_sync_1 = matchPathSync;
	Object.defineProperty(exports, "createMatchPath", { enumerable: true, get: function () { return match_path_sync_1.createMatchPath; } });
	Object.defineProperty(exports, "matchFromAbsolutePaths", { enumerable: true, get: function () { return match_path_sync_1.matchFromAbsolutePaths; } });
	var match_path_async_1 = matchPathAsync;
	Object.defineProperty(exports, "createMatchPathAsync", { enumerable: true, get: function () { return match_path_async_1.createMatchPathAsync; } });
	Object.defineProperty(exports, "matchFromAbsolutePathsAsync", { enumerable: true, get: function () { return match_path_async_1.matchFromAbsolutePathsAsync; } });
	var register_1 = register$1;
	Object.defineProperty(exports, "register", { enumerable: true, get: function () { return register_1.register; } });
	var config_loader_1 = configLoader$1;
	Object.defineProperty(exports, "loadConfig", { enumerable: true, get: function () { return config_loader_1.loadConfig; } });
	
} (lib$v));

var recrawl$1 = {};

/******************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */
/* global Reflect, Promise, SuppressedError, Symbol */

var extendStatics = function(d, b) {
    extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
    return extendStatics(d, b);
};

function __extends$4(d, b) {
    if (typeof b !== "function" && b !== null)
        throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}

var __assign$3 = function() {
    __assign$3 = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign$3.apply(this, arguments);
};

function __rest(s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
}

function __decorate(decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
}

function __param(paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
}

function __esDecorate(ctor, descriptorIn, decorators, contextIn, initializers, extraInitializers) {
    function accept(f) { if (f !== void 0 && typeof f !== "function") throw new TypeError("Function expected"); return f; }
    var kind = contextIn.kind, key = kind === "getter" ? "get" : kind === "setter" ? "set" : "value";
    var target = !descriptorIn && ctor ? contextIn["static"] ? ctor : ctor.prototype : null;
    var descriptor = descriptorIn || (target ? Object.getOwnPropertyDescriptor(target, contextIn.name) : {});
    var _, done = false;
    for (var i = decorators.length - 1; i >= 0; i--) {
        var context = {};
        for (var p in contextIn) context[p] = p === "access" ? {} : contextIn[p];
        for (var p in contextIn.access) context.access[p] = contextIn.access[p];
        context.addInitializer = function (f) { if (done) throw new TypeError("Cannot add initializers after decoration has completed"); extraInitializers.push(accept(f || null)); };
        var result = (0, decorators[i])(kind === "accessor" ? { get: descriptor.get, set: descriptor.set } : descriptor[key], context);
        if (kind === "accessor") {
            if (result === void 0) continue;
            if (result === null || typeof result !== "object") throw new TypeError("Object expected");
            if (_ = accept(result.get)) descriptor.get = _;
            if (_ = accept(result.set)) descriptor.set = _;
            if (_ = accept(result.init)) initializers.unshift(_);
        }
        else if (_ = accept(result)) {
            if (kind === "field") initializers.unshift(_);
            else descriptor[key] = _;
        }
    }
    if (target) Object.defineProperty(target, contextIn.name, descriptor);
    done = true;
}
function __runInitializers(thisArg, initializers, value) {
    var useValue = arguments.length > 2;
    for (var i = 0; i < initializers.length; i++) {
        value = useValue ? initializers[i].call(thisArg, value) : initializers[i].call(thisArg);
    }
    return useValue ? value : void 0;
}
function __propKey(x) {
    return typeof x === "symbol" ? x : "".concat(x);
}
function __setFunctionName(f, name, prefix) {
    if (typeof name === "symbol") name = name.description ? "[".concat(name.description, "]") : "";
    return Object.defineProperty(f, "name", { configurable: true, value: prefix ? "".concat(prefix, " ", name) : name });
}
function __metadata(metadataKey, metadataValue) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
}

function __awaiter(thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
}

function __generator(thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
}

var __createBinding$1 = Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
});

function __exportStar(m, o) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p)) __createBinding$1(o, m, p);
}

function __values(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
}

function __read(o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
}

/** @deprecated */
function __spread() {
    for (var ar = [], i = 0; i < arguments.length; i++)
        ar = ar.concat(__read(arguments[i]));
    return ar;
}

/** @deprecated */
function __spreadArrays() {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
}

function __spreadArray$1(to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
}

function __await(v) {
    return this instanceof __await ? (this.v = v, this) : new __await(v);
}

function __asyncGenerator(thisArg, _arguments, generator) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var g = generator.apply(thisArg, _arguments || []), i, q = [];
    return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
    function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
    function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
    function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
    function fulfill(value) { resume("next", value); }
    function reject(value) { resume("throw", value); }
    function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
}

function __asyncDelegator(o) {
    var i, p;
    return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
    function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: false } : f ? f(v) : v; } : f; }
}

function __asyncValues(o) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var m = o[Symbol.asyncIterator], i;
    return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
    function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
    function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
}

function __makeTemplateObject(cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
}
var __setModuleDefault$1 = Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
};

function __importStar$1(mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding$1(result, mod, k);
    __setModuleDefault$1(result, mod);
    return result;
}

function __importDefault$b(mod) {
    return (mod && mod.__esModule) ? mod : { default: mod };
}

function __classPrivateFieldGet(receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
}

function __classPrivateFieldSet(receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
}

function __classPrivateFieldIn(state, receiver) {
    if (receiver === null || (typeof receiver !== "object" && typeof receiver !== "function")) throw new TypeError("Cannot use 'in' operator on non-object");
    return typeof state === "function" ? receiver === state : state.has(receiver);
}

function __addDisposableResource(env, value, async) {
    if (value !== null && value !== void 0) {
        if (typeof value !== "object" && typeof value !== "function") throw new TypeError("Object expected.");
        var dispose;
        if (async) {
            if (!Symbol.asyncDispose) throw new TypeError("Symbol.asyncDispose is not defined.");
            dispose = value[Symbol.asyncDispose];
        }
        if (dispose === void 0) {
            if (!Symbol.dispose) throw new TypeError("Symbol.dispose is not defined.");
            dispose = value[Symbol.dispose];
        }
        if (typeof dispose !== "function") throw new TypeError("Object not disposable.");
        env.stack.push({ value: value, dispose: dispose, async: async });
    }
    else if (async) {
        env.stack.push({ async: true });
    }
    return value;
}

var _SuppressedError = typeof SuppressedError === "function" ? SuppressedError : function (error, suppressed, message) {
    var e = new Error(message);
    return e.name = "SuppressedError", e.error = error, e.suppressed = suppressed, e;
};

function __disposeResources(env) {
    function fail(e) {
        env.error = env.hasError ? new _SuppressedError(e, env.error, "An error was suppressed during disposal.") : e;
        env.hasError = true;
    }
    function next() {
        while (env.stack.length) {
            var rec = env.stack.pop();
            try {
                var result = rec.dispose && rec.dispose.call(rec.value);
                if (rec.async) return Promise.resolve(result).then(next, function(e) { fail(e); return next(); });
            }
            catch (e) {
                fail(e);
            }
        }
        if (env.hasError) throw env.error;
    }
    return next();
}

var tslib_es6 = {
    __extends: __extends$4,
    __assign: __assign$3,
    __rest: __rest,
    __decorate: __decorate,
    __param: __param,
    __metadata: __metadata,
    __awaiter: __awaiter,
    __generator: __generator,
    __createBinding: __createBinding$1,
    __exportStar: __exportStar,
    __values: __values,
    __read: __read,
    __spread: __spread,
    __spreadArrays: __spreadArrays,
    __spreadArray: __spreadArray$1,
    __await: __await,
    __asyncGenerator: __asyncGenerator,
    __asyncDelegator: __asyncDelegator,
    __asyncValues: __asyncValues,
    __makeTemplateObject: __makeTemplateObject,
    __importStar: __importStar$1,
    __importDefault: __importDefault$b,
    __classPrivateFieldGet: __classPrivateFieldGet,
    __classPrivateFieldSet: __classPrivateFieldSet,
    __classPrivateFieldIn: __classPrivateFieldIn,
    __addDisposableResource: __addDisposableResource,
    __disposeResources: __disposeResources,
};

var tslib_es6$1 = /*#__PURE__*/Object.freeze({
    __proto__: null,
    __extends: __extends$4,
    get __assign () { return __assign$3; },
    __rest: __rest,
    __decorate: __decorate,
    __param: __param,
    __esDecorate: __esDecorate,
    __runInitializers: __runInitializers,
    __propKey: __propKey,
    __setFunctionName: __setFunctionName,
    __metadata: __metadata,
    __awaiter: __awaiter,
    __generator: __generator,
    __createBinding: __createBinding$1,
    __exportStar: __exportStar,
    __values: __values,
    __read: __read,
    __spread: __spread,
    __spreadArrays: __spreadArrays,
    __spreadArray: __spreadArray$1,
    __await: __await,
    __asyncGenerator: __asyncGenerator,
    __asyncDelegator: __asyncDelegator,
    __asyncValues: __asyncValues,
    __makeTemplateObject: __makeTemplateObject,
    __importStar: __importStar$1,
    __importDefault: __importDefault$b,
    __classPrivateFieldGet: __classPrivateFieldGet,
    __classPrivateFieldSet: __classPrivateFieldSet,
    __classPrivateFieldIn: __classPrivateFieldIn,
    __addDisposableResource: __addDisposableResource,
    __disposeResources: __disposeResources,
    'default': tslib_es6
});

var require$$0$8 = /*@__PURE__*/getAugmentedNamespace(tslib_es6$1);

var relative$4 = {};

Object.defineProperty(relative$4, "__esModule", { value: true });
relative$4.relative = void 0;
const parentRE = /^((?:\.\.\/)*\.\.)$/;
const cousinRE = /^((?:\.\.\/)+)(.+)?$/;
/**
 * Resolve `ref` relative to `file` (not a directory).
 *
 * The `ref` must begin with `./` or `../` or equal `.` or `..`
 */
function relative$3(file, ref) {
    return ref.length == 1
        ? dirname$1(file, 1) // parent
        : ref[1] == '/'
            ? join$2(dirname$1(file, 1), ref.slice(2)) // sibling or nephew
            : relativeRegex(file, ref);
}
relative$4.relative = relative$3;
function relativeRegex(file, ref) {
    let id = parentRE.exec(ref); // grand-parent
    if (id) {
        return dirname$1(file, 1 + (id[1].length + 1) / 3);
    }
    id = cousinRE.exec(ref); // cousin or uncle
    if (id) {
        const dir = dirname$1(file, 1 + id[1].length / 3);
        return dir == null ? null : join$2(dir, id[2]);
    }
    return null; // invalid path
}
function join$2(a, b) {
    return b ? (a ? (a == '/' ? a : a + '/') + b : b) : a;
}
/**
 * This assumes `file` never ends with a path separator.
 * It returns an empty string if no parent directory exists.
 */
function dirname$1(file, n) {
    let i;
    if (n <= 1) {
        i = file.lastIndexOf('/');
        if (i < 0) {
            return '';
        }
    }
    else {
        i = file.length;
        while (--n >= 0) {
            i = i ? file.lastIndexOf('/', i - 1) : -1;
            if (i < 0) {
                return n || file[0] == '/' ? null : '';
            }
        }
    }
    return i ? file.slice(0, i) : '/';
}

var globRegex_1;
var hasRequiredGlobRegex;

function requireGlobRegex () {
	if (hasRequiredGlobRegex) return globRegex_1;
	hasRequiredGlobRegex = 1;
	var dotRE = /\./g;
	var dotPattern = '\\.';

	var restRE = /\*\*$/g;
	var restPattern = '(.+)';

	var globRE = /(?:\*\*\/|\*\*|\*)/g;
	var globPatterns = {
	  '*': '([^/]+)',        // no backslashes
	  '**': '(.+/)?([^/]+)', // short for "**/*"
	  '**/': '(.+/)?',       // one or more directories
	};

	function mapToPattern(str) {
	  return globPatterns[str]
	}

	function replace(glob) {
	  return glob
	    .replace(dotRE, dotPattern)
	    .replace(restRE, restPattern)
	    .replace(globRE, mapToPattern)
	}

	function join(globs) {
	  return '((' + globs.map(replace).join(')|(') + '))'
	}

	function globRegex(glob) {
	  return new RegExp('^' + (Array.isArray(glob) ? join : replace)(glob) + '$')
	}

	globRegex.replace = replace;
	Object.defineProperty(globRegex, 'default', { value: globRegex });
	globRegex_1 = globRegex;
	return globRegex_1;
}

var slash$1;
var hasRequiredSlash;

function requireSlash () {
	if (hasRequiredSlash) return slash$1;
	hasRequiredSlash = 1;
	slash$1 = path => {
		const isExtendedLengthPath = /^\\\\\?\\/.test(path);
		const hasNonAscii = /[^\u0000-\u0080]+/.test(path); // eslint-disable-line no-control-regex

		if (isExtendedLengthPath || hasNonAscii) {
			return path;
		}

		return path.replace(/\\/g, '/');
	};
	return slash$1;
}

var fs$E = {};

var hasRequiredFs;

function requireFs () {
	if (hasRequiredFs) return fs$E;
	hasRequiredFs = 1;
	Object.defineProperty(fs$E, "__esModule", { value: true });
	fs$E.localFs = void 0;
	const tslib_1 = require$$0$8;
	const fs = tslib_1.__importStar(require$$0__default["default"]);
	fs$E.localFs = {
	    readdir: name => fs.readdirSync(name),
	    readlink: name => fs.readlinkSync(name),
	    lstat: name => fs.lstatSync(name),
	    stat: name => fs.statSync(name),
	};
	
	return fs$E;
}

Object.defineProperty(recrawl$1, "__esModule", { value: true });
recrawl$1.createMatcher = recrawl$1.compileGlob = recrawl$1.recrawl = crawl_1 = recrawl$1.crawl = void 0;
const tslib_1 = require$$0$8;
const relative_1 = relative$4;
const fs$D = tslib_1.__importStar(require$$0__default["default"]);
const glob_regex_1 = tslib_1.__importDefault(requireGlobRegex());
const slash_1 = tslib_1.__importDefault(requireSlash());
const path$D = tslib_1.__importStar(path__default["default"]);
const fs_1 = requireFs();
const { S_IFMT, S_IFLNK, S_IFDIR } = fs$D.constants;
const limitDepth = (limit) => (_, depth) => depth < limit;
const alwaysTrue = () => true;
const alwaysFalse = () => false;
/** Create a crawl function, and crawl the given root immediately */
const crawl = (root, opts = {}) => recrawl(opts)(root);
var crawl_1 = recrawl$1.crawl = crawl;
/** Create a crawl function */
function recrawl(opts = {}) {
    const only = createMatcher(opts.only) || alwaysTrue;
    const skip = createMatcher(opts.skip) || alwaysFalse;
    const fs = opts.adapter || fs_1.localFs;
    const enter = opts.enter || alwaysTrue;
    const filter = opts.filter || alwaysTrue;
    const follow = createFollower(opts);
    const maxDepth = typeof opts.depth == 'number'
        ? Math.max(0, opts.depth)
        : opts.deep === false
            ? 0
            : Infinity;
    return (root, arg) => {
        root = (0, slash_1.default)(path$D.resolve(root)) + '/';
        let each;
        let files;
        if (typeof arg == 'function') {
            each = arg;
        }
        else {
            files = arg || (follow ? {} : []);
            each = Array.isArray(files)
                ? file => files.push(file)
                : (file, link) => {
                    files[file] = link !== null ? link : true;
                };
        }
        let depth = 0;
        const crawl = (dir) => {
            for (const name of fs.readdir(root + dir)) {
                let file = dir + name;
                if (skip(file, name)) {
                    continue;
                }
                let mode;
                try {
                    mode = fs.stat(root + file).mode & S_IFMT;
                }
                catch (err) {
                    if (err.code == 'ENOENT' || err.code == 'ELOOP') {
                        continue; // Ignore broken symlinks.
                    }
                    throw err;
                }
                if (mode == S_IFDIR) {
                    if (depth == maxDepth) {
                        continue;
                    }
                    if (enter(file, depth)) {
                        depth++;
                        try {
                            crawl(file + '/');
                        }
                        catch (err) {
                            if (err.code !== 'EACCES') {
                                throw err;
                            }
                        }
                        depth--;
                    }
                }
                else if (only(file, name) && filter(file, name)) {
                    let link = null;
                    if (follow) {
                        mode = fs.lstat(root + file).mode & S_IFMT;
                        if (mode === S_IFLNK)
                            link = follow(file, root);
                    }
                    if (opts.absolute) {
                        file = root + file;
                    }
                    each(file, link);
                }
            }
        };
        crawl('');
        return files;
    };
}
recrawl$1.recrawl = recrawl;
/** Tests true for absolute paths and globs starting with two asterisks. */
const globAllRE = /(?:\/|\*\*)/;
/** Merge regular expressions together. */
const matchAny$1 = (patterns) => new RegExp(`^(?:${patterns.join('|')})$`);
/**
 * Compile a single Recrawl glob string into its "RegExp pattern" equivalent.
 *
 * Note: This is only useful for globs with "/" or "**" in them.
 */
function compileGlob$1(glob, root) {
    if (glob[0] == '/') {
        glob = glob.slice(1);
    }
    else if (glob[0] !== '*') {
        glob = '**/' + glob;
    }
    if (glob.endsWith('/')) {
        glob += '**';
    }
    if (root)
        glob = path$D.posix.join(root, glob);
    return glob_regex_1.default.replace(glob);
}
recrawl$1.compileGlob = compileGlob$1;
/**
 * Create a function that tests against an array of Recrawl glob strings by
 * compiling them into RegExp objects.
 */
function createMatcher(globs, root) {
    if (!globs || !globs.length) {
        return null;
    }
    const fileGlobs = [];
    const nameGlobs = [];
    globs.forEach(glob => {
        if (glob instanceof RegExp) {
            fileGlobs.push(glob.source);
        }
        else if (globAllRE.test(glob)) {
            fileGlobs.push(compileGlob$1(glob, root));
        }
        else {
            nameGlobs.push(glob_regex_1.default.replace(glob));
        }
    });
    const fileRE = fileGlobs.length ? matchAny$1(fileGlobs) : false;
    const nameRE = nameGlobs.length ? matchAny$1(nameGlobs) : false;
    return (file, name) => (nameRE && nameRE.test(name || path$D.basename(file))) ||
        (fileRE && fileRE.test(file));
}
recrawl$1.createMatcher = createMatcher;
// Create a function that follows symlinks.
function createFollower(opts) {
    const fs = opts.adapter || fs_1.localFs;
    const filter = opts.follow === true
        ? alwaysTrue
        : typeof opts.follow == 'number'
            ? limitDepth(opts.follow)
            : typeof opts.follow == 'function'
                ? opts.follow
                : null;
    // The "name" argument must be relative to the "root" argument.
    if (!filter)
        return null;
    return (name, root) => {
        let depth = 0;
        if (name === null || !filter(name, depth)) {
            return null;
        }
        let link = root + name;
        let mode;
        do {
            let target = (0, slash_1.default)(fs.readlink(link));
            if (path$D.isAbsolute(target)) {
                name = null;
                link = target;
            }
            // When "target" is relative, resolve it.
            else if (name !== null) {
                // The "relative" function expects ./ or ../
                if (!/^\.\.?\//.test(target[0])) {
                    target = './' + target;
                }
                // This code path is faster.
                name = (0, relative_1.relative)(name, target);
                link = root + name;
            }
            else {
                link = (0, slash_1.default)(path$D.resolve(path$D.dirname(link), target));
            }
            try {
                mode = fs.lstat(link).mode & S_IFMT;
                if (mode !== S_IFLNK)
                    break;
            }
            catch (_a) {
                break;
            }
        } while (filter(name == null ? link : name, ++depth));
        return name == null ? link : name;
    };
}

const isWin = process.platform === 'win32';
const SEP = isWin ? `\\\\+` : `\\/`;
const SEP_ESC = isWin ? `\\\\` : `/`;
const GLOBSTAR$1 = `((?:[^/]*(?:/|$))*)`;
const WILDCARD = `([^/]*)`;
const GLOBSTAR_SEGMENT = `((?:[^${SEP_ESC}]*(?:${SEP_ESC}|$))*)`;
const WILDCARD_SEGMENT = `([^${SEP_ESC}]*)`;

/**
 * Convert any glob pattern to a JavaScript Regexp object
 * @param {String} glob Glob pattern to convert
 * @param {Object} opts Configuration object
 * @param {Boolean} [opts.extended=false] Support advanced ext globbing
 * @param {Boolean} [opts.globstar=false] Support globstar
 * @param {Boolean} [opts.strict=true] be laissez faire about mutiple slashes
 * @param {Boolean} [opts.filepath=''] Parse as filepath for extra path related features
 * @param {String} [opts.flags=''] RegExp globs
 * @returns {Object} converted object with string, segments and RegExp object
 */
function globrex(glob, {extended = false, globstar = false, strict = false, filepath = false, flags = ''} = {}) {
    let regex = '';
    let segment = '';
    let path = { regex: '', segments: [] };

    // If we are doing extended matching, this boolean is true when we are inside
    // a group (eg {*.html,*.js}), and false otherwise.
    let inGroup = false;
    let inRange = false;

    // extglob stack. Keep track of scope
    const ext = [];

    // Helper function to build string and segments
    function add(str, {split, last, only}={}) {
        if (only !== 'path') regex += str;
        if (filepath && only !== 'regex') {
            path.regex += (str === '\\/' ? SEP : str);
            if (split) {
                if (last) segment += str;
                if (segment !== '') {
                    if (!flags.includes('g')) segment = `^${segment}$`; // change it 'includes'
                    path.segments.push(new RegExp(segment, flags));
                }
                segment = '';
            } else {
                segment += str;
            }
        }
    }

    let c, n;
    for (let i = 0; i < glob.length; i++) {
        c = glob[i];
        n = glob[i + 1];

        if (['\\', '$', '^', '.', '='].includes(c)) {
            add(`\\${c}`);
            continue;
        }

        if (c === '/') {
            add(`\\${c}`, {split: true});
            if (n === '/' && !strict) regex += '?';
            continue;
        }

        if (c === '(') {
            if (ext.length) {
                add(c);
                continue;
            }
            add(`\\${c}`);
            continue;
        }

        if (c === ')') {
            if (ext.length) {
                add(c);
                let type = ext.pop();
                if (type === '@') {
                    add('{1}');
                } else if (type === '!') {
                    add('([^\/]*)');
                } else {
                    add(type);
                }
                continue;
            }
            add(`\\${c}`);
            continue;
        }
        
        if (c === '|') {
            if (ext.length) {
                add(c);
                continue;
            }
            add(`\\${c}`);
            continue;
        }

        if (c === '+') {
            if (n === '(' && extended) {
                ext.push(c);
                continue;
            }
            add(`\\${c}`);
            continue;
        }

        if (c === '@' && extended) {
            if (n === '(') {
                ext.push(c);
                continue;
            }
        }

        if (c === '!') {
            if (extended) {
                if (inRange) {
                    add('^');
                    continue
                }
                if (n === '(') {
                    ext.push(c);
                    add('(?!');
                    i++;
                    continue;
                }
                add(`\\${c}`);
                continue;
            }
            add(`\\${c}`);
            continue;
        }

        if (c === '?') {
            if (extended) {
                if (n === '(') {
                    ext.push(c);
                } else {
                    add('.');
                }
                continue;
            }
            add(`\\${c}`);
            continue;
        }

        if (c === '[') {
            if (inRange && n === ':') {
                i++; // skip [
                let value = '';
                while(glob[++i] !== ':') value += glob[i];
                if (value === 'alnum') add('(\\w|\\d)');
                else if (value === 'space') add('\\s');
                else if (value === 'digit') add('\\d');
                i++; // skip last ]
                continue;
            }
            if (extended) {
                inRange = true;
                add(c);
                continue;
            }
            add(`\\${c}`);
            continue;
        }

        if (c === ']') {
            if (extended) {
                inRange = false;
                add(c);
                continue;
            }
            add(`\\${c}`);
            continue;
        }

        if (c === '{') {
            if (extended) {
                inGroup = true;
                add('(');
                continue;
            }
            add(`\\${c}`);
            continue;
        }

        if (c === '}') {
            if (extended) {
                inGroup = false;
                add(')');
                continue;
            }
            add(`\\${c}`);
            continue;
        }

        if (c === ',') {
            if (inGroup) {
                add('|');
                continue;
            }
            add(`\\${c}`);
            continue;
        }

        if (c === '*') {
            if (n === '(' && extended) {
                ext.push(c);
                continue;
            }
            // Move over all consecutive "*"'s.
            // Also store the previous and next characters
            let prevChar = glob[i - 1];
            let starCount = 1;
            while (glob[i + 1] === '*') {
                starCount++;
                i++;
            }
            let nextChar = glob[i + 1];
            if (!globstar) {
                // globstar is disabled, so treat any number of "*" as one
                add('.*');
            } else {
                // globstar is enabled, so determine if this is a globstar segment
                let isGlobstar =
                    starCount > 1 && // multiple "*"'s
                    (prevChar === '/' || prevChar === undefined) && // from the start of the segment
                    (nextChar === '/' || nextChar === undefined); // to the end of the segment
                if (isGlobstar) {
                    // it's a globstar, so match zero or more path segments
                    add(GLOBSTAR$1, {only:'regex'});
                    add(GLOBSTAR_SEGMENT, {only:'path', last:true, split:true});
                    i++; // move over the "/"
                } else {
                    // it's not a globstar, so only match one path segment
                    add(WILDCARD, {only:'regex'});
                    add(WILDCARD_SEGMENT, {only:'path'});
                }
            }
            continue;
        }

        add(c);
    }


    // When regexp 'g' flag is specified don't
    // constrain the regular expression with ^ & $
    if (!flags.includes('g')) {
        regex = `^${regex}$`;
        segment = `^${segment}$`;
        if (filepath) path.regex = `^${path.regex}$`;
    }

    const result = {regex: new RegExp(regex, flags)};

    // Push the last segment
    if (filepath) {
        path.segments.push(new RegExp(segment, flags));
        path.regex = new RegExp(path.regex, flags);
        path.globstar = new RegExp(!flags.includes('g') ? `^${GLOBSTAR_SEGMENT}$` : GLOBSTAR_SEGMENT, flags);
        result.path = path;
    }

    return result;
}

var globrex_1 = globrex;

var globRex = /*@__PURE__*/getDefaultExportFromCjs(globrex_1);

var src = {exports: {}};

var browser$2 = {exports: {}};

/**
 * Helpers.
 */

var ms;
var hasRequiredMs;

function requireMs () {
	if (hasRequiredMs) return ms;
	hasRequiredMs = 1;
	var s = 1000;
	var m = s * 60;
	var h = m * 60;
	var d = h * 24;
	var w = d * 7;
	var y = d * 365.25;

	/**
	 * Parse or format the given `val`.
	 *
	 * Options:
	 *
	 *  - `long` verbose formatting [false]
	 *
	 * @param {String|Number} val
	 * @param {Object} [options]
	 * @throws {Error} throw an error if val is not a non-empty string or a number
	 * @return {String|Number}
	 * @api public
	 */

	ms = function(val, options) {
	  options = options || {};
	  var type = typeof val;
	  if (type === 'string' && val.length > 0) {
	    return parse(val);
	  } else if (type === 'number' && isFinite(val)) {
	    return options.long ? fmtLong(val) : fmtShort(val);
	  }
	  throw new Error(
	    'val is not a non-empty string or a valid number. val=' +
	      JSON.stringify(val)
	  );
	};

	/**
	 * Parse the given `str` and return milliseconds.
	 *
	 * @param {String} str
	 * @return {Number}
	 * @api private
	 */

	function parse(str) {
	  str = String(str);
	  if (str.length > 100) {
	    return;
	  }
	  var match = /^(-?(?:\d+)?\.?\d+) *(milliseconds?|msecs?|ms|seconds?|secs?|s|minutes?|mins?|m|hours?|hrs?|h|days?|d|weeks?|w|years?|yrs?|y)?$/i.exec(
	    str
	  );
	  if (!match) {
	    return;
	  }
	  var n = parseFloat(match[1]);
	  var type = (match[2] || 'ms').toLowerCase();
	  switch (type) {
	    case 'years':
	    case 'year':
	    case 'yrs':
	    case 'yr':
	    case 'y':
	      return n * y;
	    case 'weeks':
	    case 'week':
	    case 'w':
	      return n * w;
	    case 'days':
	    case 'day':
	    case 'd':
	      return n * d;
	    case 'hours':
	    case 'hour':
	    case 'hrs':
	    case 'hr':
	    case 'h':
	      return n * h;
	    case 'minutes':
	    case 'minute':
	    case 'mins':
	    case 'min':
	    case 'm':
	      return n * m;
	    case 'seconds':
	    case 'second':
	    case 'secs':
	    case 'sec':
	    case 's':
	      return n * s;
	    case 'milliseconds':
	    case 'millisecond':
	    case 'msecs':
	    case 'msec':
	    case 'ms':
	      return n;
	    default:
	      return undefined;
	  }
	}

	/**
	 * Short format for `ms`.
	 *
	 * @param {Number} ms
	 * @return {String}
	 * @api private
	 */

	function fmtShort(ms) {
	  var msAbs = Math.abs(ms);
	  if (msAbs >= d) {
	    return Math.round(ms / d) + 'd';
	  }
	  if (msAbs >= h) {
	    return Math.round(ms / h) + 'h';
	  }
	  if (msAbs >= m) {
	    return Math.round(ms / m) + 'm';
	  }
	  if (msAbs >= s) {
	    return Math.round(ms / s) + 's';
	  }
	  return ms + 'ms';
	}

	/**
	 * Long format for `ms`.
	 *
	 * @param {Number} ms
	 * @return {String}
	 * @api private
	 */

	function fmtLong(ms) {
	  var msAbs = Math.abs(ms);
	  if (msAbs >= d) {
	    return plural(ms, msAbs, d, 'day');
	  }
	  if (msAbs >= h) {
	    return plural(ms, msAbs, h, 'hour');
	  }
	  if (msAbs >= m) {
	    return plural(ms, msAbs, m, 'minute');
	  }
	  if (msAbs >= s) {
	    return plural(ms, msAbs, s, 'second');
	  }
	  return ms + ' ms';
	}

	/**
	 * Pluralization helper.
	 */

	function plural(ms, msAbs, n, name) {
	  var isPlural = msAbs >= n * 1.5;
	  return Math.round(ms / n) + ' ' + name + (isPlural ? 's' : '');
	}
	return ms;
}

var common$7;
var hasRequiredCommon;

function requireCommon () {
	if (hasRequiredCommon) return common$7;
	hasRequiredCommon = 1;
	/**
	 * This is the common logic for both the Node.js and web browser
	 * implementations of `debug()`.
	 */

	function setup(env) {
		createDebug.debug = createDebug;
		createDebug.default = createDebug;
		createDebug.coerce = coerce;
		createDebug.disable = disable;
		createDebug.enable = enable;
		createDebug.enabled = enabled;
		createDebug.humanize = requireMs();
		createDebug.destroy = destroy;

		Object.keys(env).forEach(key => {
			createDebug[key] = env[key];
		});

		/**
		* The currently active debug mode names, and names to skip.
		*/

		createDebug.names = [];
		createDebug.skips = [];

		/**
		* Map of special "%n" handling functions, for the debug "format" argument.
		*
		* Valid key names are a single, lower or upper-case letter, i.e. "n" and "N".
		*/
		createDebug.formatters = {};

		/**
		* Selects a color for a debug namespace
		* @param {String} namespace The namespace string for the debug instance to be colored
		* @return {Number|String} An ANSI color code for the given namespace
		* @api private
		*/
		function selectColor(namespace) {
			let hash = 0;

			for (let i = 0; i < namespace.length; i++) {
				hash = ((hash << 5) - hash) + namespace.charCodeAt(i);
				hash |= 0; // Convert to 32bit integer
			}

			return createDebug.colors[Math.abs(hash) % createDebug.colors.length];
		}
		createDebug.selectColor = selectColor;

		/**
		* Create a debugger with the given `namespace`.
		*
		* @param {String} namespace
		* @return {Function}
		* @api public
		*/
		function createDebug(namespace) {
			let prevTime;
			let enableOverride = null;
			let namespacesCache;
			let enabledCache;

			function debug(...args) {
				// Disabled?
				if (!debug.enabled) {
					return;
				}

				const self = debug;

				// Set `diff` timestamp
				const curr = Number(new Date());
				const ms = curr - (prevTime || curr);
				self.diff = ms;
				self.prev = prevTime;
				self.curr = curr;
				prevTime = curr;

				args[0] = createDebug.coerce(args[0]);

				if (typeof args[0] !== 'string') {
					// Anything else let's inspect with %O
					args.unshift('%O');
				}

				// Apply any `formatters` transformations
				let index = 0;
				args[0] = args[0].replace(/%([a-zA-Z%])/g, (match, format) => {
					// If we encounter an escaped % then don't increase the array index
					if (match === '%%') {
						return '%';
					}
					index++;
					const formatter = createDebug.formatters[format];
					if (typeof formatter === 'function') {
						const val = args[index];
						match = formatter.call(self, val);

						// Now we need to remove `args[index]` since it's inlined in the `format`
						args.splice(index, 1);
						index--;
					}
					return match;
				});

				// Apply env-specific formatting (colors, etc.)
				createDebug.formatArgs.call(self, args);

				const logFn = self.log || createDebug.log;
				logFn.apply(self, args);
			}

			debug.namespace = namespace;
			debug.useColors = createDebug.useColors();
			debug.color = createDebug.selectColor(namespace);
			debug.extend = extend;
			debug.destroy = createDebug.destroy; // XXX Temporary. Will be removed in the next major release.

			Object.defineProperty(debug, 'enabled', {
				enumerable: true,
				configurable: false,
				get: () => {
					if (enableOverride !== null) {
						return enableOverride;
					}
					if (namespacesCache !== createDebug.namespaces) {
						namespacesCache = createDebug.namespaces;
						enabledCache = createDebug.enabled(namespace);
					}

					return enabledCache;
				},
				set: v => {
					enableOverride = v;
				}
			});

			// Env-specific initialization logic for debug instances
			if (typeof createDebug.init === 'function') {
				createDebug.init(debug);
			}

			return debug;
		}

		function extend(namespace, delimiter) {
			const newDebug = createDebug(this.namespace + (typeof delimiter === 'undefined' ? ':' : delimiter) + namespace);
			newDebug.log = this.log;
			return newDebug;
		}

		/**
		* Enables a debug mode by namespaces. This can include modes
		* separated by a colon and wildcards.
		*
		* @param {String} namespaces
		* @api public
		*/
		function enable(namespaces) {
			createDebug.save(namespaces);
			createDebug.namespaces = namespaces;

			createDebug.names = [];
			createDebug.skips = [];

			let i;
			const split = (typeof namespaces === 'string' ? namespaces : '').split(/[\s,]+/);
			const len = split.length;

			for (i = 0; i < len; i++) {
				if (!split[i]) {
					// ignore empty strings
					continue;
				}

				namespaces = split[i].replace(/\*/g, '.*?');

				if (namespaces[0] === '-') {
					createDebug.skips.push(new RegExp('^' + namespaces.slice(1) + '$'));
				} else {
					createDebug.names.push(new RegExp('^' + namespaces + '$'));
				}
			}
		}

		/**
		* Disable debug output.
		*
		* @return {String} namespaces
		* @api public
		*/
		function disable() {
			const namespaces = [
				...createDebug.names.map(toNamespace),
				...createDebug.skips.map(toNamespace).map(namespace => '-' + namespace)
			].join(',');
			createDebug.enable('');
			return namespaces;
		}

		/**
		* Returns true if the given mode name is enabled, false otherwise.
		*
		* @param {String} name
		* @return {Boolean}
		* @api public
		*/
		function enabled(name) {
			if (name[name.length - 1] === '*') {
				return true;
			}

			let i;
			let len;

			for (i = 0, len = createDebug.skips.length; i < len; i++) {
				if (createDebug.skips[i].test(name)) {
					return false;
				}
			}

			for (i = 0, len = createDebug.names.length; i < len; i++) {
				if (createDebug.names[i].test(name)) {
					return true;
				}
			}

			return false;
		}

		/**
		* Convert regexp to namespace
		*
		* @param {RegExp} regxep
		* @return {String} namespace
		* @api private
		*/
		function toNamespace(regexp) {
			return regexp.toString()
				.substring(2, regexp.toString().length - 2)
				.replace(/\.\*\?$/, '*');
		}

		/**
		* Coerce `val`.
		*
		* @param {Mixed} val
		* @return {Mixed}
		* @api private
		*/
		function coerce(val) {
			if (val instanceof Error) {
				return val.stack || val.message;
			}
			return val;
		}

		/**
		* XXX DO NOT USE. This is a temporary stub function.
		* XXX It WILL be removed in the next major release.
		*/
		function destroy() {
			console.warn('Instance method `debug.destroy()` is deprecated and no longer does anything. It will be removed in the next major version of `debug`.');
		}

		createDebug.enable(createDebug.load());

		return createDebug;
	}

	common$7 = setup;
	return common$7;
}

/* eslint-env browser */
browser$2.exports;

var hasRequiredBrowser;

function requireBrowser () {
	if (hasRequiredBrowser) return browser$2.exports;
	hasRequiredBrowser = 1;
	(function (module, exports) {
		/**
		 * This is the web browser implementation of `debug()`.
		 */

		exports.formatArgs = formatArgs;
		exports.save = save;
		exports.load = load;
		exports.useColors = useColors;
		exports.storage = localstorage();
		exports.destroy = (() => {
			let warned = false;

			return () => {
				if (!warned) {
					warned = true;
					console.warn('Instance method `debug.destroy()` is deprecated and no longer does anything. It will be removed in the next major version of `debug`.');
				}
			};
		})();

		/**
		 * Colors.
		 */

		exports.colors = [
			'#0000CC',
			'#0000FF',
			'#0033CC',
			'#0033FF',
			'#0066CC',
			'#0066FF',
			'#0099CC',
			'#0099FF',
			'#00CC00',
			'#00CC33',
			'#00CC66',
			'#00CC99',
			'#00CCCC',
			'#00CCFF',
			'#3300CC',
			'#3300FF',
			'#3333CC',
			'#3333FF',
			'#3366CC',
			'#3366FF',
			'#3399CC',
			'#3399FF',
			'#33CC00',
			'#33CC33',
			'#33CC66',
			'#33CC99',
			'#33CCCC',
			'#33CCFF',
			'#6600CC',
			'#6600FF',
			'#6633CC',
			'#6633FF',
			'#66CC00',
			'#66CC33',
			'#9900CC',
			'#9900FF',
			'#9933CC',
			'#9933FF',
			'#99CC00',
			'#99CC33',
			'#CC0000',
			'#CC0033',
			'#CC0066',
			'#CC0099',
			'#CC00CC',
			'#CC00FF',
			'#CC3300',
			'#CC3333',
			'#CC3366',
			'#CC3399',
			'#CC33CC',
			'#CC33FF',
			'#CC6600',
			'#CC6633',
			'#CC9900',
			'#CC9933',
			'#CCCC00',
			'#CCCC33',
			'#FF0000',
			'#FF0033',
			'#FF0066',
			'#FF0099',
			'#FF00CC',
			'#FF00FF',
			'#FF3300',
			'#FF3333',
			'#FF3366',
			'#FF3399',
			'#FF33CC',
			'#FF33FF',
			'#FF6600',
			'#FF6633',
			'#FF9900',
			'#FF9933',
			'#FFCC00',
			'#FFCC33'
		];

		/**
		 * Currently only WebKit-based Web Inspectors, Firefox >= v31,
		 * and the Firebug extension (any Firefox version) are known
		 * to support "%c" CSS customizations.
		 *
		 * TODO: add a `localStorage` variable to explicitly enable/disable colors
		 */

		// eslint-disable-next-line complexity
		function useColors() {
			// NB: In an Electron preload script, document will be defined but not fully
			// initialized. Since we know we're in Chrome, we'll just detect this case
			// explicitly
			if (typeof window !== 'undefined' && window.process && (window.process.type === 'renderer' || window.process.__nwjs)) {
				return true;
			}

			// Internet Explorer and Edge do not support colors.
			if (typeof navigator !== 'undefined' && navigator.userAgent && navigator.userAgent.toLowerCase().match(/(edge|trident)\/(\d+)/)) {
				return false;
			}

			// Is webkit? http://stackoverflow.com/a/16459606/376773
			// document is undefined in react-native: https://github.com/facebook/react-native/pull/1632
			return (typeof document !== 'undefined' && document.documentElement && document.documentElement.style && document.documentElement.style.WebkitAppearance) ||
				// Is firebug? http://stackoverflow.com/a/398120/376773
				(typeof window !== 'undefined' && window.console && (window.console.firebug || (window.console.exception && window.console.table))) ||
				// Is firefox >= v31?
				// https://developer.mozilla.org/en-US/docs/Tools/Web_Console#Styling_messages
				(typeof navigator !== 'undefined' && navigator.userAgent && navigator.userAgent.toLowerCase().match(/firefox\/(\d+)/) && parseInt(RegExp.$1, 10) >= 31) ||
				// Double check webkit in userAgent just in case we are in a worker
				(typeof navigator !== 'undefined' && navigator.userAgent && navigator.userAgent.toLowerCase().match(/applewebkit\/(\d+)/));
		}

		/**
		 * Colorize log arguments if enabled.
		 *
		 * @api public
		 */

		function formatArgs(args) {
			args[0] = (this.useColors ? '%c' : '') +
				this.namespace +
				(this.useColors ? ' %c' : ' ') +
				args[0] +
				(this.useColors ? '%c ' : ' ') +
				'+' + module.exports.humanize(this.diff);

			if (!this.useColors) {
				return;
			}

			const c = 'color: ' + this.color;
			args.splice(1, 0, c, 'color: inherit');

			// The final "%c" is somewhat tricky, because there could be other
			// arguments passed either before or after the %c, so we need to
			// figure out the correct index to insert the CSS into
			let index = 0;
			let lastC = 0;
			args[0].replace(/%[a-zA-Z%]/g, match => {
				if (match === '%%') {
					return;
				}
				index++;
				if (match === '%c') {
					// We only are interested in the *last* %c
					// (the user may have provided their own)
					lastC = index;
				}
			});

			args.splice(lastC, 0, c);
		}

		/**
		 * Invokes `console.debug()` when available.
		 * No-op when `console.debug` is not a "function".
		 * If `console.debug` is not available, falls back
		 * to `console.log`.
		 *
		 * @api public
		 */
		exports.log = console.debug || console.log || (() => {});

		/**
		 * Save `namespaces`.
		 *
		 * @param {String} namespaces
		 * @api private
		 */
		function save(namespaces) {
			try {
				if (namespaces) {
					exports.storage.setItem('debug', namespaces);
				} else {
					exports.storage.removeItem('debug');
				}
			} catch (error) {
				// Swallow
				// XXX (@Qix-) should we be logging these?
			}
		}

		/**
		 * Load `namespaces`.
		 *
		 * @return {String} returns the previously persisted debug modes
		 * @api private
		 */
		function load() {
			let r;
			try {
				r = exports.storage.getItem('debug');
			} catch (error) {
				// Swallow
				// XXX (@Qix-) should we be logging these?
			}

			// If debug isn't set in LS, and we're in Electron, try to load $DEBUG
			if (!r && typeof process !== 'undefined' && 'env' in process) {
				r = process.env.DEBUG;
			}

			return r;
		}

		/**
		 * Localstorage attempts to return the localstorage.
		 *
		 * This is necessary because safari throws
		 * when a user disables cookies/localstorage
		 * and you attempt to access it.
		 *
		 * @return {LocalStorage}
		 * @api private
		 */

		function localstorage() {
			try {
				// TVMLKit (Apple TV JS Runtime) does not have a window object, just localStorage in the global context
				// The Browser also has localStorage in the global context.
				return localStorage;
			} catch (error) {
				// Swallow
				// XXX (@Qix-) should we be logging these?
			}
		}

		module.exports = requireCommon()(exports);

		const {formatters} = module.exports;

		/**
		 * Map %j to `JSON.stringify()`, since no Web Inspectors do that by default.
		 */

		formatters.j = function (v) {
			try {
				return JSON.stringify(v);
			} catch (error) {
				return '[UnexpectedJSONParseError]: ' + error.message;
			}
		}; 
	} (browser$2, browser$2.exports));
	return browser$2.exports;
}

var node$5 = {exports: {}};

var hasFlag$1;
var hasRequiredHasFlag$1;

function requireHasFlag$1 () {
	if (hasRequiredHasFlag$1) return hasFlag$1;
	hasRequiredHasFlag$1 = 1;

	hasFlag$1 = (flag, argv = process.argv) => {
		const prefix = flag.startsWith('-') ? '' : (flag.length === 1 ? '-' : '--');
		const position = argv.indexOf(prefix + flag);
		const terminatorPosition = argv.indexOf('--');
		return position !== -1 && (terminatorPosition === -1 || position < terminatorPosition);
	};
	return hasFlag$1;
}

var supportsColor_1$1;
var hasRequiredSupportsColor$1;

function requireSupportsColor$1 () {
	if (hasRequiredSupportsColor$1) return supportsColor_1$1;
	hasRequiredSupportsColor$1 = 1;
	const os = require$$0__default$1["default"];
	const tty = tty__default["default"];
	const hasFlag = requireHasFlag$1();

	const {env} = process;

	let forceColor;
	if (hasFlag('no-color') ||
		hasFlag('no-colors') ||
		hasFlag('color=false') ||
		hasFlag('color=never')) {
		forceColor = 0;
	} else if (hasFlag('color') ||
		hasFlag('colors') ||
		hasFlag('color=true') ||
		hasFlag('color=always')) {
		forceColor = 1;
	}

	if ('FORCE_COLOR' in env) {
		if (env.FORCE_COLOR === 'true') {
			forceColor = 1;
		} else if (env.FORCE_COLOR === 'false') {
			forceColor = 0;
		} else {
			forceColor = env.FORCE_COLOR.length === 0 ? 1 : Math.min(parseInt(env.FORCE_COLOR, 10), 3);
		}
	}

	function translateLevel(level) {
		if (level === 0) {
			return false;
		}

		return {
			level,
			hasBasic: true,
			has256: level >= 2,
			has16m: level >= 3
		};
	}

	function supportsColor(haveStream, streamIsTTY) {
		if (forceColor === 0) {
			return 0;
		}

		if (hasFlag('color=16m') ||
			hasFlag('color=full') ||
			hasFlag('color=truecolor')) {
			return 3;
		}

		if (hasFlag('color=256')) {
			return 2;
		}

		if (haveStream && !streamIsTTY && forceColor === undefined) {
			return 0;
		}

		const min = forceColor || 0;

		if (env.TERM === 'dumb') {
			return min;
		}

		if (process.platform === 'win32') {
			// Windows 10 build 10586 is the first Windows release that supports 256 colors.
			// Windows 10 build 14931 is the first release that supports 16m/TrueColor.
			const osRelease = os.release().split('.');
			if (
				Number(osRelease[0]) >= 10 &&
				Number(osRelease[2]) >= 10586
			) {
				return Number(osRelease[2]) >= 14931 ? 3 : 2;
			}

			return 1;
		}

		if ('CI' in env) {
			if (['TRAVIS', 'CIRCLECI', 'APPVEYOR', 'GITLAB_CI', 'GITHUB_ACTIONS', 'BUILDKITE'].some(sign => sign in env) || env.CI_NAME === 'codeship') {
				return 1;
			}

			return min;
		}

		if ('TEAMCITY_VERSION' in env) {
			return /^(9\.(0*[1-9]\d*)\.|\d{2,}\.)/.test(env.TEAMCITY_VERSION) ? 1 : 0;
		}

		if (env.COLORTERM === 'truecolor') {
			return 3;
		}

		if ('TERM_PROGRAM' in env) {
			const version = parseInt((env.TERM_PROGRAM_VERSION || '').split('.')[0], 10);

			switch (env.TERM_PROGRAM) {
				case 'iTerm.app':
					return version >= 3 ? 3 : 2;
				case 'Apple_Terminal':
					return 2;
				// No default
			}
		}

		if (/-256(color)?$/i.test(env.TERM)) {
			return 2;
		}

		if (/^screen|^xterm|^vt100|^vt220|^rxvt|color|ansi|cygwin|linux/i.test(env.TERM)) {
			return 1;
		}

		if ('COLORTERM' in env) {
			return 1;
		}

		return min;
	}

	function getSupportLevel(stream) {
		const level = supportsColor(stream, stream && stream.isTTY);
		return translateLevel(level);
	}

	supportsColor_1$1 = {
		supportsColor: getSupportLevel,
		stdout: translateLevel(supportsColor(true, tty.isatty(1))),
		stderr: translateLevel(supportsColor(true, tty.isatty(2)))
	};
	return supportsColor_1$1;
}

/**
 * Module dependencies.
 */
node$5.exports;

var hasRequiredNode$2;

function requireNode$2 () {
	if (hasRequiredNode$2) return node$5.exports;
	hasRequiredNode$2 = 1;
	(function (module, exports) {
		const tty = tty__default["default"];
		const util = require$$0__default$2["default"];

		/**
		 * This is the Node.js implementation of `debug()`.
		 */

		exports.init = init;
		exports.log = log;
		exports.formatArgs = formatArgs;
		exports.save = save;
		exports.load = load;
		exports.useColors = useColors;
		exports.destroy = util.deprecate(
			() => {},
			'Instance method `debug.destroy()` is deprecated and no longer does anything. It will be removed in the next major version of `debug`.'
		);

		/**
		 * Colors.
		 */

		exports.colors = [6, 2, 3, 4, 5, 1];

		try {
			// Optional dependency (as in, doesn't need to be installed, NOT like optionalDependencies in package.json)
			// eslint-disable-next-line import/no-extraneous-dependencies
			const supportsColor = requireSupportsColor$1();

			if (supportsColor && (supportsColor.stderr || supportsColor).level >= 2) {
				exports.colors = [
					20,
					21,
					26,
					27,
					32,
					33,
					38,
					39,
					40,
					41,
					42,
					43,
					44,
					45,
					56,
					57,
					62,
					63,
					68,
					69,
					74,
					75,
					76,
					77,
					78,
					79,
					80,
					81,
					92,
					93,
					98,
					99,
					112,
					113,
					128,
					129,
					134,
					135,
					148,
					149,
					160,
					161,
					162,
					163,
					164,
					165,
					166,
					167,
					168,
					169,
					170,
					171,
					172,
					173,
					178,
					179,
					184,
					185,
					196,
					197,
					198,
					199,
					200,
					201,
					202,
					203,
					204,
					205,
					206,
					207,
					208,
					209,
					214,
					215,
					220,
					221
				];
			}
		} catch (error) {
			// Swallow - we only care if `supports-color` is available; it doesn't have to be.
		}

		/**
		 * Build up the default `inspectOpts` object from the environment variables.
		 *
		 *   $ DEBUG_COLORS=no DEBUG_DEPTH=10 DEBUG_SHOW_HIDDEN=enabled node script.js
		 */

		exports.inspectOpts = Object.keys(process.env).filter(key => {
			return /^debug_/i.test(key);
		}).reduce((obj, key) => {
			// Camel-case
			const prop = key
				.substring(6)
				.toLowerCase()
				.replace(/_([a-z])/g, (_, k) => {
					return k.toUpperCase();
				});

			// Coerce string value into JS value
			let val = process.env[key];
			if (/^(yes|on|true|enabled)$/i.test(val)) {
				val = true;
			} else if (/^(no|off|false|disabled)$/i.test(val)) {
				val = false;
			} else if (val === 'null') {
				val = null;
			} else {
				val = Number(val);
			}

			obj[prop] = val;
			return obj;
		}, {});

		/**
		 * Is stdout a TTY? Colored output is enabled when `true`.
		 */

		function useColors() {
			return 'colors' in exports.inspectOpts ?
				Boolean(exports.inspectOpts.colors) :
				tty.isatty(process.stderr.fd);
		}

		/**
		 * Adds ANSI color escape codes if enabled.
		 *
		 * @api public
		 */

		function formatArgs(args) {
			const {namespace: name, useColors} = this;

			if (useColors) {
				const c = this.color;
				const colorCode = '\u001B[3' + (c < 8 ? c : '8;5;' + c);
				const prefix = `  ${colorCode};1m${name} \u001B[0m`;

				args[0] = prefix + args[0].split('\n').join('\n' + prefix);
				args.push(colorCode + 'm+' + module.exports.humanize(this.diff) + '\u001B[0m');
			} else {
				args[0] = getDate() + name + ' ' + args[0];
			}
		}

		function getDate() {
			if (exports.inspectOpts.hideDate) {
				return '';
			}
			return new Date().toISOString() + ' ';
		}

		/**
		 * Invokes `util.format()` with the specified arguments and writes to stderr.
		 */

		function log(...args) {
			return process.stderr.write(util.format(...args) + '\n');
		}

		/**
		 * Save `namespaces`.
		 *
		 * @param {String} namespaces
		 * @api private
		 */
		function save(namespaces) {
			if (namespaces) {
				process.env.DEBUG = namespaces;
			} else {
				// If you set a process.env field to null or undefined, it gets cast to the
				// string 'null' or 'undefined'. Just delete instead.
				delete process.env.DEBUG;
			}
		}

		/**
		 * Load `namespaces`.
		 *
		 * @return {String} returns the previously persisted debug modes
		 * @api private
		 */

		function load() {
			return process.env.DEBUG;
		}

		/**
		 * Init logic for `debug` instances.
		 *
		 * Create a new `inspectOpts` object in case `useColors` is set
		 * differently for a particular `debug` instance.
		 */

		function init(debug) {
			debug.inspectOpts = {};

			const keys = Object.keys(exports.inspectOpts);
			for (let i = 0; i < keys.length; i++) {
				debug.inspectOpts[keys[i]] = exports.inspectOpts[keys[i]];
			}
		}

		module.exports = requireCommon()(exports);

		const {formatters} = module.exports;

		/**
		 * Map %o to `util.inspect()`, all on a single line.
		 */

		formatters.o = function (v) {
			this.inspectOpts.colors = this.useColors;
			return util.inspect(v, this.inspectOpts)
				.split('\n')
				.map(str => str.trim())
				.join(' ');
		};

		/**
		 * Map %O to `util.inspect()`, allowing multiple lines if needed.
		 */

		formatters.O = function (v) {
			this.inspectOpts.colors = this.useColors;
			return util.inspect(v, this.inspectOpts);
		}; 
	} (node$5, node$5.exports));
	return node$5.exports;
}

/**
 * Detect Electron renderer / nwjs process, which is node, but we should
 * treat as a browser.
 */

if (typeof process === 'undefined' || process.type === 'renderer' || process.browser === true || process.__nwjs) {
	src.exports = requireBrowser();
} else {
	src.exports = requireNode$2();
}

var srcExports = src.exports;
var _debug$1 = /*@__PURE__*/getDefaultExportFromCjs(srcExports);

// src/path.ts
var isWindows$4 = require$$0$a.platform() == "win32";
var resolve$4 = isWindows$4 ? (...paths) => require$$2$1.normalizePath(path$M.win32.resolve(...paths)) : path$M.posix.resolve;
var isAbsolute$2 = isWindows$4 ? path$M.win32.isAbsolute : path$M.posix.isAbsolute;
var join$1 = path$M.posix.join;
var relative$2 = path$M.posix.relative;
var basename$1 = path$M.posix.basename;
function loadConfig(cwd) {
  const configPath = resolveConfigPath(cwd);
  if (configPath) {
    const config = loadTsconfig_1(configPath);
    const {
      compilerOptions: { allowJs, checkJs, baseUrl, paths, outDir } = {}
    } = config;
    return {
      configPath: require$$2$1.normalizePath(configPath),
      include: config.include,
      exclude: config.exclude,
      allowJs: allowJs || checkJs,
      baseUrl: baseUrl && require$$2$1.normalizePath(path$M.resolve(configPath, "..", baseUrl)),
      paths,
      outDir
    };
  }
}
function resolveConfigPath(cwd) {
  if (require$$0$9.statSync(cwd).isFile()) {
    return cwd;
  }
  const configPath = walkForTsConfig_1(cwd);
  if (configPath) {
    return configPath;
  }
}
var debug$2 = _debug$1("vite-tsconfig-paths");
var src_default = (opts = {}) => {
  let resolvers;
  return {
    name: "vite:tsconfig-paths",
    enforce: "pre",
    configResolved(config) {
      const projects = findProjects(config.root, opts);
      const extensions = getFileExtensions(opts.extensions);
      debug$2("options:", { projects, extensions });
      resolvers = projects.map((project) => createResolver(project, extensions)).filter(Boolean);
    },
    async resolveId(id, importer) {
      if (importer && !relativeImportRE.test(id) && !isAbsolute$2(id)) {
        const viteResolve = async (id2, importer2) => {
          var _a;
          return (_a = await this.resolve(id2, importer2, { skipSelf: true })) == null ? void 0 : _a.id;
        };
        for (const resolve3 of resolvers) {
          const resolved = await resolve3(viteResolve, id, importer);
          if (resolved) {
            return resolved;
          }
        }
      }
    }
  };
  function createResolver(root, extensions) {
    const configPath = root.endsWith(".json") ? root : null;
    if (configPath)
      root = path$M.dirname(root);
    root += "/";
    const config = loadConfig(configPath || root);
    if (!config) {
      debug$2(`[!] config not found: "${configPath || root}"`);
      return null;
    }
    const { baseUrl, paths } = config;
    if (!baseUrl && !paths) {
      debug$2(`[!] missing baseUrl and paths: "${config.configPath}"`);
      return null;
    }
    debug$2("config loaded:", config);
    const resolveWithBaseUrl = baseUrl ? (viteResolve, id, importer) => viteResolve(join$1(baseUrl, id), importer) : void 0;
    let resolveId;
    if (paths) {
      const matchPath = lib$v.createMatchPathAsync(baseUrl != null ? baseUrl : root, paths, mainFields);
      const resolveWithPaths = (viteResolve, id, importer) => new Promise((done) => {
        matchPath(id, void 0, void 0, extensions, (error, path2) => {
          if (path2) {
            path2 = require$$2$1.normalizePath(path2);
            done(viteResolve(path2, importer));
          } else {
            error && debug$2(error.message);
            done(void 0);
          }
        });
      });
      if (resolveWithBaseUrl) {
        resolveId = (viteResolve, id, importer) => resolveWithPaths(viteResolve, id, importer).then((resolved2) => {
          return resolved2 != null ? resolved2 : resolveWithBaseUrl(viteResolve, id, importer);
        });
      } else {
        resolveId = resolveWithPaths;
      }
    } else {
      resolveId = resolveWithBaseUrl;
    }
    const isIncluded = getIncluder(config);
    let importerExtRE = /./;
    if (!opts.loose) {
      importerExtRE = config.allowJs || basename$1(config.configPath) === "jsconfig.json" ? /\.(vue|svelte|mdx|mjs|[jt]sx?)$/ : /\.tsx?$/;
    }
    const resolved = new Map();
    return async (viteResolve, id, importer) => {
      var _a;
      if (id.includes("\0"))
        return;
      importer = require$$2$1.normalizePath(importer);
      const importerFile = importer.replace(/[#?].+$/, "");
      if (!importerExtRE.test(importerFile))
        return;
      if (!isIncluded(relative$2(root, importerFile)))
        return;
      const suffix = (_a = /\?.+$/.exec(id)) == null ? void 0 : _a[0];
      if (suffix) {
        id = id.slice(0, -suffix.length);
      }
      let path2 = resolved.get(id);
      if (!path2) {
        path2 = await resolveId(viteResolve, id, importer);
        if (path2) {
          resolved.set(id, path2);
          debug$2(`resolved:`, {
            id,
            importer,
            resolvedId: path2,
            configPath: config.configPath
          });
        }
      }
      return path2 && suffix ? path2 + suffix : path2;
    };
  }
};
var relativeImportRE = /^\.\.?(\/|$)/;
var mainFields = ["module", "jsnext", "jsnext:main", "browser", "main"];
var defaultInclude = ["**/*"];
var defaultExclude = ["node_modules", "bower_components", "jspm_packages"];
function compileGlob(glob) {
  if (!relativeImportRE.test(glob)) {
    glob = "./" + glob;
  }
  if (!glob.split("/").pop().includes("*")) {
    glob += "/**";
  }
  return globRex(glob, {
    extended: true,
    globstar: true
  }).regex;
}
function getIncluder({
  include = defaultInclude,
  exclude = defaultExclude,
  outDir
}) {
  if (outDir) {
    exclude = exclude.concat(outDir);
  }
  if (include.length || exclude.length) {
    const included = include.map(compileGlob);
    const excluded = exclude.map(compileGlob);
    debug$2(`compiled globs:`, { included, excluded });
    return (path2) => {
      path2 = path2.replace(/\?.+$/, "");
      if (!relativeImportRE.test(path2)) {
        path2 = "./" + path2;
      }
      const test = (glob) => glob.test(path2);
      return included.some(test) && !excluded.some(test);
    };
  }
  return () => true;
}
function findProjects(viteRoot, opts) {
  const root = opts.root ? resolve$4(viteRoot, require$$2$1.normalizePath(opts.root)) : viteRoot;
  let { projects } = opts;
  if (!projects) {
    debug$2(`crawling "${root}"`);
    projects = crawl_1(root, {
      only: ["jsconfig.json", "tsconfig.json"],
      skip: ["node_modules", ".git"]
    });
  }
  const depthMap = {};
  projects = projects.map((projectPath) => {
    projectPath = resolve$4(root, require$$2$1.normalizePath(projectPath));
    depthMap[projectPath] = projectPath.split("/").length - (projectPath.endsWith(".json") ? 1 : 0);
    return projectPath;
  });
  return projects.sort((a, b) => depthMap[b] - depthMap[a]);
}
function getFileExtensions(exts) {
  const requiredExts = [".ts", ".tsx", ".js", ".jsx", ".mjs"];
  return exts ? exts.concat(requiredExts) : requiredExts;
}

var require$1=require$$3$2.createRequire((typeof document === 'undefined' ? new (require('u' + 'rl').URL)('file:' + __filename).href : (document.currentScript && document.currentScript.src || new URL('index.cjs.js', document.baseURI).href)));
var T$1=Object.create;var F$1=Object.defineProperty;var q$1=Object.getOwnPropertyDescriptor;var B$1=Object.getOwnPropertyNames;var G$1=Object.getPrototypeOf,J$1=Object.prototype.hasOwnProperty;var O$1=(e=>typeof require$1<"u"?require$1:typeof Proxy<"u"?new Proxy(e,{get:(t,l)=>(typeof require$1<"u"?require$1:t)[l]}):e)(function(e){if(typeof require$1<"u")return require$1.apply(this,arguments);throw new Error('Dynamic require of "'+e+'" is not supported')});var K$1=(e,t,l,s)=>{if(t&&typeof t=="object"||typeof t=="function")for(let n of B$1(t))!J$1.call(e,n)&&n!==l&&F$1(e,n,{get:()=>t[n],enumerable:!(s=q$1(t,n))||s.enumerable});return e};var L$1=(e,t,l)=>(l=e!=null?T$1(G$1(e)):{},K$1(t||!e||!e.__esModule?F$1(l,"default",{value:e,enumerable:!0}):l,e));function Y$1(e={}){var h,P,S,w,E,v,b,W,x;let t=(h=e==null?void 0:e.cache)!=null?h:!0,l="",s=(P=e==null?void 0:e.include)!=null?P:["src/**/*.css","src/**/*.scss","src/**/*.sass","src/**/*.less","src/**/*.styl","src/**/*.vue","src/**/*.svelte"],n=(S=e==null?void 0:e.exclude)!=null?S:["node_modules","virtual:"],o=(w=e==null?void 0:e.stylelintPath)!=null?w:"stylelint",V=(E=e==null?void 0:e.lintOnStart)!=null?E:!1,C=(v=e==null?void 0:e.emitError)!=null?v:!0,_=(b=e==null?void 0:e.emitErrorAsWarning)!=null?b:!1,$=(W=e==null?void 0:e.emitWarning)!=null?W:!0,j=(x=e==null?void 0:e.emitWarningAsError)!=null?x:!1,k=createFilter$1(s,n),z=a=>!U__default["default"].existsSync(a),y,d;return {name:"vite:stylelint",configResolved(a){var r;l=(r=e==null?void 0:e.cacheLocation)!=null?r:X__default["default"].resolve(a.cacheDir,"vite-plugin-stylelint");},async buildStart(){var a;if(!y)try{y=(await Promise.resolve().then(()=>L$1(O$1(o)))).default,d=async(i,D)=>await y.lint({...e,allowEmptyInput:!0,cache:t,cacheLocation:l,files:D}).then(c=>{if(!c)return;let{results:u}=c;u.forEach(H=>{let{warnings:I,ignored:M}=H;M||I.forEach(R=>{console.log("");let{severity:A,text:m,line:f,column:g}=R;A==="error"&&C?_?i.warn(m,{line:f,column:g}):i.error(m,{line:f,column:g}):A==="warning"&&$&&(j?i.error(m,{line:f,column:g}):i.warn(m,{line:f,column:g}));});});}).catch(c=>{var u;console.log(""),i.error(`${(u=c==null?void 0:c.message)!=null?u:c}`);});}catch(r){console.log(""),this.error(`${(a=r==null?void 0:r.message)!=null?a:"Failed to import Stylelint. Have you installed and configured correctly?"}`);}V&&(console.log(""),this.warn("Stylelint is linting all files in the project because `lintOnStart` is true. This will significantly slow down Vite."),await d(this,s));},async transform(a,r){let i=normalizePath$4(r).split("?")[0];return !k(i)||z(i)||await d(this,i),null}}}

var ejs = {};

var utils$o = {};

/*
 * EJS Embedded JavaScript templates
 * Copyright 2112 Matthew Eernisse (mde@fleegix.org)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *         http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
*/

(function (exports) {

	var regExpChars = /[|\\{}()[\]^$+*?.]/g;
	var hasOwnProperty = Object.prototype.hasOwnProperty;
	var hasOwn = function (obj, key) { return hasOwnProperty.apply(obj, [key]); };

	/**
	 * Escape characters reserved in regular expressions.
	 *
	 * If `string` is `undefined` or `null`, the empty string is returned.
	 *
	 * @param {String} string Input string
	 * @return {String} Escaped string
	 * @static
	 * @private
	 */
	exports.escapeRegExpChars = function (string) {
	  // istanbul ignore if
	  if (!string) {
	    return '';
	  }
	  return String(string).replace(regExpChars, '\\$&');
	};

	var _ENCODE_HTML_RULES = {
	  '&': '&amp;',
	  '<': '&lt;',
	  '>': '&gt;',
	  '"': '&#34;',
	  "'": '&#39;'
	};
	var _MATCH_HTML = /[&<>'"]/g;

	function encode_char(c) {
	  return _ENCODE_HTML_RULES[c] || c;
	}

	/**
	 * Stringified version of constants used by {@link module:utils.escapeXML}.
	 *
	 * It is used in the process of generating {@link ClientFunction}s.
	 *
	 * @readonly
	 * @type {String}
	 */

	var escapeFuncStr =
	  'var _ENCODE_HTML_RULES = {\n'
	+ '      "&": "&amp;"\n'
	+ '    , "<": "&lt;"\n'
	+ '    , ">": "&gt;"\n'
	+ '    , \'"\': "&#34;"\n'
	+ '    , "\'": "&#39;"\n'
	+ '    }\n'
	+ '  , _MATCH_HTML = /[&<>\'"]/g;\n'
	+ 'function encode_char(c) {\n'
	+ '  return _ENCODE_HTML_RULES[c] || c;\n'
	+ '};\n';

	/**
	 * Escape characters reserved in XML.
	 *
	 * If `markup` is `undefined` or `null`, the empty string is returned.
	 *
	 * @implements {EscapeCallback}
	 * @param {String} markup Input string
	 * @return {String} Escaped string
	 * @static
	 * @private
	 */

	exports.escapeXML = function (markup) {
	  return markup == undefined
	    ? ''
	    : String(markup)
	      .replace(_MATCH_HTML, encode_char);
	};

	function escapeXMLToString() {
	  return Function.prototype.toString.call(this) + ';\n' + escapeFuncStr;
	}

	try {
	  if (typeof Object.defineProperty === 'function') {
	  // If the Function prototype is frozen, the "toString" property is non-writable. This means that any objects which inherit this property
	  // cannot have the property changed using an assignment. If using strict mode, attempting that will cause an error. If not using strict
	  // mode, attempting that will be silently ignored.
	  // However, we can still explicitly shadow the prototype's "toString" property by defining a new "toString" property on this object.
	    Object.defineProperty(exports.escapeXML, 'toString', { value: escapeXMLToString });
	  } else {
	    // If Object.defineProperty() doesn't exist, attempt to shadow this property using the assignment operator.
	    exports.escapeXML.toString = escapeXMLToString;
	  }
	} catch (err) {
	  console.warn('Unable to set escapeXML.toString (is the Function prototype frozen?)');
	}

	/**
	 * Naive copy of properties from one object to another.
	 * Does not recurse into non-scalar properties
	 * Does not check to see if the property has a value before copying
	 *
	 * @param  {Object} to   Destination object
	 * @param  {Object} from Source object
	 * @return {Object}      Destination object
	 * @static
	 * @private
	 */
	exports.shallowCopy = function (to, from) {
	  from = from || {};
	  if ((to !== null) && (to !== undefined)) {
	    for (var p in from) {
	      if (!hasOwn(from, p)) {
	        continue;
	      }
	      if (p === '__proto__' || p === 'constructor') {
	        continue;
	      }
	      to[p] = from[p];
	    }
	  }
	  return to;
	};

	/**
	 * Naive copy of a list of key names, from one object to another.
	 * Only copies property if it is actually defined
	 * Does not recurse into non-scalar properties
	 *
	 * @param  {Object} to   Destination object
	 * @param  {Object} from Source object
	 * @param  {Array} list List of properties to copy
	 * @return {Object}      Destination object
	 * @static
	 * @private
	 */
	exports.shallowCopyFromList = function (to, from, list) {
	  list = list || [];
	  from = from || {};
	  if ((to !== null) && (to !== undefined)) {
	    for (var i = 0; i < list.length; i++) {
	      var p = list[i];
	      if (typeof from[p] != 'undefined') {
	        if (!hasOwn(from, p)) {
	          continue;
	        }
	        if (p === '__proto__' || p === 'constructor') {
	          continue;
	        }
	        to[p] = from[p];
	      }
	    }
	  }
	  return to;
	};

	/**
	 * Simple in-process cache implementation. Does not implement limits of any
	 * sort.
	 *
	 * @implements {Cache}
	 * @static
	 * @private
	 */
	exports.cache = {
	  _data: {},
	  set: function (key, val) {
	    this._data[key] = val;
	  },
	  get: function (key) {
	    return this._data[key];
	  },
	  remove: function (key) {
	    delete this._data[key];
	  },
	  reset: function () {
	    this._data = {};
	  }
	};

	/**
	 * Transforms hyphen case variable into camel case.
	 *
	 * @param {String} string Hyphen case string
	 * @return {String} Camel case string
	 * @static
	 * @private
	 */
	exports.hyphenToCamel = function (str) {
	  return str.replace(/-[a-z]/g, function (match) { return match[1].toUpperCase(); });
	};

	/**
	 * Returns a null-prototype object in runtimes that support it
	 *
	 * @return {Object} Object, prototype will be set to null where possible
	 * @static
	 * @private
	 */
	exports.createNullProtoObjWherePossible = (function () {
	  if (typeof Object.create == 'function') {
	    return function () {
	      return Object.create(null);
	    };
	  }
	  if (!({__proto__: null} instanceof Object)) {
	    return function () {
	      return {__proto__: null};
	    };
	  }
	  // Not possible, just pass through
	  return function () {
	    return {};
	  };
	})();

	exports.hasOwnOnlyObject = function (obj) {
	  var o = exports.createNullProtoObjWherePossible();
	  for (var p in obj) {
	    if (hasOwn(obj, p)) {
	      o[p] = obj[p];
	    }
	  }
	  return o;
	}; 
} (utils$o));

var name$3 = "ejs";
var description$2 = "Embedded JavaScript templates";
var keywords$2 = [
	"template",
	"engine",
	"ejs"
];
var version$3 = "3.1.10";
var author$1 = "Matthew Eernisse <mde@fleegix.org> (http://fleegix.org)";
var license$2 = "Apache-2.0";
var bin = {
	ejs: "./bin/cli.js"
};
var main$5 = "./lib/ejs.js";
var jsdelivr = "ejs.min.js";
var unpkg = "ejs.min.js";
var repository$2 = {
	type: "git",
	url: "git://github.com/mde/ejs.git"
};
var bugs = "https://github.com/mde/ejs/issues";
var homepage = "https://github.com/mde/ejs";
var dependencies = {
	jake: "^10.8.5"
};
var devDependencies$1 = {
	browserify: "^16.5.1",
	eslint: "^6.8.0",
	"git-directory-deploy": "^1.5.1",
	jsdoc: "^4.0.2",
	"lru-cache": "^4.0.1",
	mocha: "^10.2.0",
	"uglify-js": "^3.3.16"
};
var engines$1 = {
	node: ">=0.10.0"
};
var scripts$2 = {
	test: "npx jake test"
};
var require$$3 = {
	name: name$3,
	description: description$2,
	keywords: keywords$2,
	version: version$3,
	author: author$1,
	license: license$2,
	bin: bin,
	main: main$5,
	jsdelivr: jsdelivr,
	unpkg: unpkg,
	repository: repository$2,
	bugs: bugs,
	homepage: homepage,
	dependencies: dependencies,
	devDependencies: devDependencies$1,
	engines: engines$1,
	scripts: scripts$2
};

/*
 * EJS Embedded JavaScript templates
 * Copyright 2112 Matthew Eernisse (mde@fleegix.org)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *         http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
*/

(function (exports) {

	/**
	 * @file Embedded JavaScript templating engine. {@link http://ejs.co}
	 * @author Matthew Eernisse <mde@fleegix.org>
	 * @author Tiancheng "Timothy" Gu <timothygu99@gmail.com>
	 * @project EJS
	 * @license {@link http://www.apache.org/licenses/LICENSE-2.0 Apache License, Version 2.0}
	 */

	/**
	 * EJS internal functions.
	 *
	 * Technically this "module" lies in the same file as {@link module:ejs}, for
	 * the sake of organization all the private functions re grouped into this
	 * module.
	 *
	 * @module ejs-internal
	 * @private
	 */

	/**
	 * Embedded JavaScript templating engine.
	 *
	 * @module ejs
	 * @public
	 */


	var fs = require$$0__default["default"];
	var path = path__default["default"];
	var utils = utils$o;

	var scopeOptionWarned = false;
	/** @type {string} */
	var _VERSION_STRING = require$$3.version;
	var _DEFAULT_OPEN_DELIMITER = '<';
	var _DEFAULT_CLOSE_DELIMITER = '>';
	var _DEFAULT_DELIMITER = '%';
	var _DEFAULT_LOCALS_NAME = 'locals';
	var _NAME = 'ejs';
	var _REGEX_STRING = '(<%%|%%>|<%=|<%-|<%_|<%#|<%|%>|-%>|_%>)';
	var _OPTS_PASSABLE_WITH_DATA = ['delimiter', 'scope', 'context', 'debug', 'compileDebug',
	  'client', '_with', 'rmWhitespace', 'strict', 'filename', 'async'];
	// We don't allow 'cache' option to be passed in the data obj for
	// the normal `render` call, but this is where Express 2 & 3 put it
	// so we make an exception for `renderFile`
	var _OPTS_PASSABLE_WITH_DATA_EXPRESS = _OPTS_PASSABLE_WITH_DATA.concat('cache');
	var _BOM = /^\uFEFF/;
	var _JS_IDENTIFIER = /^[a-zA-Z_$][0-9a-zA-Z_$]*$/;

	/**
	 * EJS template function cache. This can be a LRU object from lru-cache NPM
	 * module. By default, it is {@link module:utils.cache}, a simple in-process
	 * cache that grows continuously.
	 *
	 * @type {Cache}
	 */

	exports.cache = utils.cache;

	/**
	 * Custom file loader. Useful for template preprocessing or restricting access
	 * to a certain part of the filesystem.
	 *
	 * @type {fileLoader}
	 */

	exports.fileLoader = fs.readFileSync;

	/**
	 * Name of the object containing the locals.
	 *
	 * This variable is overridden by {@link Options}`.localsName` if it is not
	 * `undefined`.
	 *
	 * @type {String}
	 * @public
	 */

	exports.localsName = _DEFAULT_LOCALS_NAME;

	/**
	 * Promise implementation -- defaults to the native implementation if available
	 * This is mostly just for testability
	 *
	 * @type {PromiseConstructorLike}
	 * @public
	 */

	exports.promiseImpl = (new Function('return this;'))().Promise;

	/**
	 * Get the path to the included file from the parent file path and the
	 * specified path.
	 *
	 * @param {String}  name     specified path
	 * @param {String}  filename parent file path
	 * @param {Boolean} [isDir=false] whether the parent file path is a directory
	 * @return {String}
	 */
	exports.resolveInclude = function(name, filename, isDir) {
	  var dirname = path.dirname;
	  var extname = path.extname;
	  var resolve = path.resolve;
	  var includePath = resolve(isDir ? filename : dirname(filename), name);
	  var ext = extname(name);
	  if (!ext) {
	    includePath += '.ejs';
	  }
	  return includePath;
	};

	/**
	 * Try to resolve file path on multiple directories
	 *
	 * @param  {String}        name  specified path
	 * @param  {Array<String>} paths list of possible parent directory paths
	 * @return {String}
	 */
	function resolvePaths(name, paths) {
	  var filePath;
	  if (paths.some(function (v) {
	    filePath = exports.resolveInclude(name, v, true);
	    return fs.existsSync(filePath);
	  })) {
	    return filePath;
	  }
	}

	/**
	 * Get the path to the included file by Options
	 *
	 * @param  {String}  path    specified path
	 * @param  {Options} options compilation options
	 * @return {String}
	 */
	function getIncludePath(path, options) {
	  var includePath;
	  var filePath;
	  var views = options.views;
	  var match = /^[A-Za-z]+:\\|^\//.exec(path);

	  // Abs path
	  if (match && match.length) {
	    path = path.replace(/^\/*/, '');
	    if (Array.isArray(options.root)) {
	      includePath = resolvePaths(path, options.root);
	    } else {
	      includePath = exports.resolveInclude(path, options.root || '/', true);
	    }
	  }
	  // Relative paths
	  else {
	    // Look relative to a passed filename first
	    if (options.filename) {
	      filePath = exports.resolveInclude(path, options.filename);
	      if (fs.existsSync(filePath)) {
	        includePath = filePath;
	      }
	    }
	    // Then look in any views directories
	    if (!includePath && Array.isArray(views)) {
	      includePath = resolvePaths(path, views);
	    }
	    if (!includePath && typeof options.includer !== 'function') {
	      throw new Error('Could not find the include file "' +
	          options.escapeFunction(path) + '"');
	    }
	  }
	  return includePath;
	}

	/**
	 * Get the template from a string or a file, either compiled on-the-fly or
	 * read from cache (if enabled), and cache the template if needed.
	 *
	 * If `template` is not set, the file specified in `options.filename` will be
	 * read.
	 *
	 * If `options.cache` is true, this function reads the file from
	 * `options.filename` so it must be set prior to calling this function.
	 *
	 * @memberof module:ejs-internal
	 * @param {Options} options   compilation options
	 * @param {String} [template] template source
	 * @return {(TemplateFunction|ClientFunction)}
	 * Depending on the value of `options.client`, either type might be returned.
	 * @static
	 */

	function handleCache(options, template) {
	  var func;
	  var filename = options.filename;
	  var hasTemplate = arguments.length > 1;

	  if (options.cache) {
	    if (!filename) {
	      throw new Error('cache option requires a filename');
	    }
	    func = exports.cache.get(filename);
	    if (func) {
	      return func;
	    }
	    if (!hasTemplate) {
	      template = fileLoader(filename).toString().replace(_BOM, '');
	    }
	  }
	  else if (!hasTemplate) {
	    // istanbul ignore if: should not happen at all
	    if (!filename) {
	      throw new Error('Internal EJS error: no file name or template '
	                    + 'provided');
	    }
	    template = fileLoader(filename).toString().replace(_BOM, '');
	  }
	  func = exports.compile(template, options);
	  if (options.cache) {
	    exports.cache.set(filename, func);
	  }
	  return func;
	}

	/**
	 * Try calling handleCache with the given options and data and call the
	 * callback with the result. If an error occurs, call the callback with
	 * the error. Used by renderFile().
	 *
	 * @memberof module:ejs-internal
	 * @param {Options} options    compilation options
	 * @param {Object} data        template data
	 * @param {RenderFileCallback} cb callback
	 * @static
	 */

	function tryHandleCache(options, data, cb) {
	  var result;
	  if (!cb) {
	    if (typeof exports.promiseImpl == 'function') {
	      return new exports.promiseImpl(function (resolve, reject) {
	        try {
	          result = handleCache(options)(data);
	          resolve(result);
	        }
	        catch (err) {
	          reject(err);
	        }
	      });
	    }
	    else {
	      throw new Error('Please provide a callback function');
	    }
	  }
	  else {
	    try {
	      result = handleCache(options)(data);
	    }
	    catch (err) {
	      return cb(err);
	    }

	    cb(null, result);
	  }
	}

	/**
	 * fileLoader is independent
	 *
	 * @param {String} filePath ejs file path.
	 * @return {String} The contents of the specified file.
	 * @static
	 */

	function fileLoader(filePath){
	  return exports.fileLoader(filePath);
	}

	/**
	 * Get the template function.
	 *
	 * If `options.cache` is `true`, then the template is cached.
	 *
	 * @memberof module:ejs-internal
	 * @param {String}  path    path for the specified file
	 * @param {Options} options compilation options
	 * @return {(TemplateFunction|ClientFunction)}
	 * Depending on the value of `options.client`, either type might be returned
	 * @static
	 */

	function includeFile(path, options) {
	  var opts = utils.shallowCopy(utils.createNullProtoObjWherePossible(), options);
	  opts.filename = getIncludePath(path, opts);
	  if (typeof options.includer === 'function') {
	    var includerResult = options.includer(path, opts.filename);
	    if (includerResult) {
	      if (includerResult.filename) {
	        opts.filename = includerResult.filename;
	      }
	      if (includerResult.template) {
	        return handleCache(opts, includerResult.template);
	      }
	    }
	  }
	  return handleCache(opts);
	}

	/**
	 * Re-throw the given `err` in context to the `str` of ejs, `filename`, and
	 * `lineno`.
	 *
	 * @implements {RethrowCallback}
	 * @memberof module:ejs-internal
	 * @param {Error}  err      Error object
	 * @param {String} str      EJS source
	 * @param {String} flnm     file name of the EJS file
	 * @param {Number} lineno   line number of the error
	 * @param {EscapeCallback} esc
	 * @static
	 */

	function rethrow(err, str, flnm, lineno, esc) {
	  var lines = str.split('\n');
	  var start = Math.max(lineno - 3, 0);
	  var end = Math.min(lines.length, lineno + 3);
	  var filename = esc(flnm);
	  // Error context
	  var context = lines.slice(start, end).map(function (line, i){
	    var curr = i + start + 1;
	    return (curr == lineno ? ' >> ' : '    ')
	      + curr
	      + '| '
	      + line;
	  }).join('\n');

	  // Alter exception message
	  err.path = filename;
	  err.message = (filename || 'ejs') + ':'
	    + lineno + '\n'
	    + context + '\n\n'
	    + err.message;

	  throw err;
	}

	function stripSemi(str){
	  return str.replace(/;(\s*$)/, '$1');
	}

	/**
	 * Compile the given `str` of ejs into a template function.
	 *
	 * @param {String}  template EJS template
	 *
	 * @param {Options} [opts] compilation options
	 *
	 * @return {(TemplateFunction|ClientFunction)}
	 * Depending on the value of `opts.client`, either type might be returned.
	 * Note that the return type of the function also depends on the value of `opts.async`.
	 * @public
	 */

	exports.compile = function compile(template, opts) {
	  var templ;

	  // v1 compat
	  // 'scope' is 'context'
	  // FIXME: Remove this in a future version
	  if (opts && opts.scope) {
	    if (!scopeOptionWarned){
	      console.warn('`scope` option is deprecated and will be removed in EJS 3');
	      scopeOptionWarned = true;
	    }
	    if (!opts.context) {
	      opts.context = opts.scope;
	    }
	    delete opts.scope;
	  }
	  templ = new Template(template, opts);
	  return templ.compile();
	};

	/**
	 * Render the given `template` of ejs.
	 *
	 * If you would like to include options but not data, you need to explicitly
	 * call this function with `data` being an empty object or `null`.
	 *
	 * @param {String}   template EJS template
	 * @param {Object}  [data={}] template data
	 * @param {Options} [opts={}] compilation and rendering options
	 * @return {(String|Promise<String>)}
	 * Return value type depends on `opts.async`.
	 * @public
	 */

	exports.render = function (template, d, o) {
	  var data = d || utils.createNullProtoObjWherePossible();
	  var opts = o || utils.createNullProtoObjWherePossible();

	  // No options object -- if there are optiony names
	  // in the data, copy them to options
	  if (arguments.length == 2) {
	    utils.shallowCopyFromList(opts, data, _OPTS_PASSABLE_WITH_DATA);
	  }

	  return handleCache(opts, template)(data);
	};

	/**
	 * Render an EJS file at the given `path` and callback `cb(err, str)`.
	 *
	 * If you would like to include options but not data, you need to explicitly
	 * call this function with `data` being an empty object or `null`.
	 *
	 * @param {String}             path     path to the EJS file
	 * @param {Object}            [data={}] template data
	 * @param {Options}           [opts={}] compilation and rendering options
	 * @param {RenderFileCallback} cb callback
	 * @public
	 */

	exports.renderFile = function () {
	  var args = Array.prototype.slice.call(arguments);
	  var filename = args.shift();
	  var cb;
	  var opts = {filename: filename};
	  var data;
	  var viewOpts;

	  // Do we have a callback?
	  if (typeof arguments[arguments.length - 1] == 'function') {
	    cb = args.pop();
	  }
	  // Do we have data/opts?
	  if (args.length) {
	    // Should always have data obj
	    data = args.shift();
	    // Normal passed opts (data obj + opts obj)
	    if (args.length) {
	      // Use shallowCopy so we don't pollute passed in opts obj with new vals
	      utils.shallowCopy(opts, args.pop());
	    }
	    // Special casing for Express (settings + opts-in-data)
	    else {
	      // Express 3 and 4
	      if (data.settings) {
	        // Pull a few things from known locations
	        if (data.settings.views) {
	          opts.views = data.settings.views;
	        }
	        if (data.settings['view cache']) {
	          opts.cache = true;
	        }
	        // Undocumented after Express 2, but still usable, esp. for
	        // items that are unsafe to be passed along with data, like `root`
	        viewOpts = data.settings['view options'];
	        if (viewOpts) {
	          utils.shallowCopy(opts, viewOpts);
	        }
	      }
	      // Express 2 and lower, values set in app.locals, or people who just
	      // want to pass options in their data. NOTE: These values will override
	      // anything previously set in settings  or settings['view options']
	      utils.shallowCopyFromList(opts, data, _OPTS_PASSABLE_WITH_DATA_EXPRESS);
	    }
	    opts.filename = filename;
	  }
	  else {
	    data = utils.createNullProtoObjWherePossible();
	  }

	  return tryHandleCache(opts, data, cb);
	};

	/**
	 * Clear intermediate JavaScript cache. Calls {@link Cache#reset}.
	 * @public
	 */

	/**
	 * EJS template class
	 * @public
	 */
	exports.Template = Template;

	exports.clearCache = function () {
	  exports.cache.reset();
	};

	function Template(text, optsParam) {
	  var opts = utils.hasOwnOnlyObject(optsParam);
	  var options = utils.createNullProtoObjWherePossible();
	  this.templateText = text;
	  /** @type {string | null} */
	  this.mode = null;
	  this.truncate = false;
	  this.currentLine = 1;
	  this.source = '';
	  options.client = opts.client || false;
	  options.escapeFunction = opts.escape || opts.escapeFunction || utils.escapeXML;
	  options.compileDebug = opts.compileDebug !== false;
	  options.debug = !!opts.debug;
	  options.filename = opts.filename;
	  options.openDelimiter = opts.openDelimiter || exports.openDelimiter || _DEFAULT_OPEN_DELIMITER;
	  options.closeDelimiter = opts.closeDelimiter || exports.closeDelimiter || _DEFAULT_CLOSE_DELIMITER;
	  options.delimiter = opts.delimiter || exports.delimiter || _DEFAULT_DELIMITER;
	  options.strict = opts.strict || false;
	  options.context = opts.context;
	  options.cache = opts.cache || false;
	  options.rmWhitespace = opts.rmWhitespace;
	  options.root = opts.root;
	  options.includer = opts.includer;
	  options.outputFunctionName = opts.outputFunctionName;
	  options.localsName = opts.localsName || exports.localsName || _DEFAULT_LOCALS_NAME;
	  options.views = opts.views;
	  options.async = opts.async;
	  options.destructuredLocals = opts.destructuredLocals;
	  options.legacyInclude = typeof opts.legacyInclude != 'undefined' ? !!opts.legacyInclude : true;

	  if (options.strict) {
	    options._with = false;
	  }
	  else {
	    options._with = typeof opts._with != 'undefined' ? opts._with : true;
	  }

	  this.opts = options;

	  this.regex = this.createRegex();
	}

	Template.modes = {
	  EVAL: 'eval',
	  ESCAPED: 'escaped',
	  RAW: 'raw',
	  COMMENT: 'comment',
	  LITERAL: 'literal'
	};

	Template.prototype = {
	  createRegex: function () {
	    var str = _REGEX_STRING;
	    var delim = utils.escapeRegExpChars(this.opts.delimiter);
	    var open = utils.escapeRegExpChars(this.opts.openDelimiter);
	    var close = utils.escapeRegExpChars(this.opts.closeDelimiter);
	    str = str.replace(/%/g, delim)
	      .replace(/</g, open)
	      .replace(/>/g, close);
	    return new RegExp(str);
	  },

	  compile: function () {
	    /** @type {string} */
	    var src;
	    /** @type {ClientFunction} */
	    var fn;
	    var opts = this.opts;
	    var prepended = '';
	    var appended = '';
	    /** @type {EscapeCallback} */
	    var escapeFn = opts.escapeFunction;
	    /** @type {FunctionConstructor} */
	    var ctor;
	    /** @type {string} */
	    var sanitizedFilename = opts.filename ? JSON.stringify(opts.filename) : 'undefined';

	    if (!this.source) {
	      this.generateSource();
	      prepended +=
	        '  var __output = "";\n' +
	        '  function __append(s) { if (s !== undefined && s !== null) __output += s }\n';
	      if (opts.outputFunctionName) {
	        if (!_JS_IDENTIFIER.test(opts.outputFunctionName)) {
	          throw new Error('outputFunctionName is not a valid JS identifier.');
	        }
	        prepended += '  var ' + opts.outputFunctionName + ' = __append;' + '\n';
	      }
	      if (opts.localsName && !_JS_IDENTIFIER.test(opts.localsName)) {
	        throw new Error('localsName is not a valid JS identifier.');
	      }
	      if (opts.destructuredLocals && opts.destructuredLocals.length) {
	        var destructuring = '  var __locals = (' + opts.localsName + ' || {}),\n';
	        for (var i = 0; i < opts.destructuredLocals.length; i++) {
	          var name = opts.destructuredLocals[i];
	          if (!_JS_IDENTIFIER.test(name)) {
	            throw new Error('destructuredLocals[' + i + '] is not a valid JS identifier.');
	          }
	          if (i > 0) {
	            destructuring += ',\n  ';
	          }
	          destructuring += name + ' = __locals.' + name;
	        }
	        prepended += destructuring + ';\n';
	      }
	      if (opts._with !== false) {
	        prepended +=  '  with (' + opts.localsName + ' || {}) {' + '\n';
	        appended += '  }' + '\n';
	      }
	      appended += '  return __output;' + '\n';
	      this.source = prepended + this.source + appended;
	    }

	    if (opts.compileDebug) {
	      src = 'var __line = 1' + '\n'
	        + '  , __lines = ' + JSON.stringify(this.templateText) + '\n'
	        + '  , __filename = ' + sanitizedFilename + ';' + '\n'
	        + 'try {' + '\n'
	        + this.source
	        + '} catch (e) {' + '\n'
	        + '  rethrow(e, __lines, __filename, __line, escapeFn);' + '\n'
	        + '}' + '\n';
	    }
	    else {
	      src = this.source;
	    }

	    if (opts.client) {
	      src = 'escapeFn = escapeFn || ' + escapeFn.toString() + ';' + '\n' + src;
	      if (opts.compileDebug) {
	        src = 'rethrow = rethrow || ' + rethrow.toString() + ';' + '\n' + src;
	      }
	    }

	    if (opts.strict) {
	      src = '"use strict";\n' + src;
	    }
	    if (opts.debug) {
	      console.log(src);
	    }
	    if (opts.compileDebug && opts.filename) {
	      src = src + '\n'
	        + '//# sourceURL=' + sanitizedFilename + '\n';
	    }

	    try {
	      if (opts.async) {
	        // Have to use generated function for this, since in envs without support,
	        // it breaks in parsing
	        try {
	          ctor = (new Function('return (async function(){}).constructor;'))();
	        }
	        catch(e) {
	          if (e instanceof SyntaxError) {
	            throw new Error('This environment does not support async/await');
	          }
	          else {
	            throw e;
	          }
	        }
	      }
	      else {
	        ctor = Function;
	      }
	      fn = new ctor(opts.localsName + ', escapeFn, include, rethrow', src);
	    }
	    catch(e) {
	      // istanbul ignore else
	      if (e instanceof SyntaxError) {
	        if (opts.filename) {
	          e.message += ' in ' + opts.filename;
	        }
	        e.message += ' while compiling ejs\n\n';
	        e.message += 'If the above error is not helpful, you may want to try EJS-Lint:\n';
	        e.message += 'https://github.com/RyanZim/EJS-Lint';
	        if (!opts.async) {
	          e.message += '\n';
	          e.message += 'Or, if you meant to create an async function, pass `async: true` as an option.';
	        }
	      }
	      throw e;
	    }

	    // Return a callable function which will execute the function
	    // created by the source-code, with the passed data as locals
	    // Adds a local `include` function which allows full recursive include
	    var returnedFn = opts.client ? fn : function anonymous(data) {
	      var include = function (path, includeData) {
	        var d = utils.shallowCopy(utils.createNullProtoObjWherePossible(), data);
	        if (includeData) {
	          d = utils.shallowCopy(d, includeData);
	        }
	        return includeFile(path, opts)(d);
	      };
	      return fn.apply(opts.context,
	        [data || utils.createNullProtoObjWherePossible(), escapeFn, include, rethrow]);
	    };
	    if (opts.filename && typeof Object.defineProperty === 'function') {
	      var filename = opts.filename;
	      var basename = path.basename(filename, path.extname(filename));
	      try {
	        Object.defineProperty(returnedFn, 'name', {
	          value: basename,
	          writable: false,
	          enumerable: false,
	          configurable: true
	        });
	      } catch (e) {/* ignore */}
	    }
	    return returnedFn;
	  },

	  generateSource: function () {
	    var opts = this.opts;

	    if (opts.rmWhitespace) {
	      // Have to use two separate replace here as `^` and `$` operators don't
	      // work well with `\r` and empty lines don't work well with the `m` flag.
	      this.templateText =
	        this.templateText.replace(/[\r\n]+/g, '\n').replace(/^\s+|\s+$/gm, '');
	    }

	    // Slurp spaces and tabs before <%_ and after _%>
	    this.templateText =
	      this.templateText.replace(/[ \t]*<%_/gm, '<%_').replace(/_%>[ \t]*/gm, '_%>');

	    var self = this;
	    var matches = this.parseTemplateText();
	    var d = this.opts.delimiter;
	    var o = this.opts.openDelimiter;
	    var c = this.opts.closeDelimiter;

	    if (matches && matches.length) {
	      matches.forEach(function (line, index) {
	        var closing;
	        // If this is an opening tag, check for closing tags
	        // FIXME: May end up with some false positives here
	        // Better to store modes as k/v with openDelimiter + delimiter as key
	        // Then this can simply check against the map
	        if ( line.indexOf(o + d) === 0        // If it is a tag
	          && line.indexOf(o + d + d) !== 0) { // and is not escaped
	          closing = matches[index + 2];
	          if (!(closing == d + c || closing == '-' + d + c || closing == '_' + d + c)) {
	            throw new Error('Could not find matching close tag for "' + line + '".');
	          }
	        }
	        self.scanLine(line);
	      });
	    }

	  },

	  parseTemplateText: function () {
	    var str = this.templateText;
	    var pat = this.regex;
	    var result = pat.exec(str);
	    var arr = [];
	    var firstPos;

	    while (result) {
	      firstPos = result.index;

	      if (firstPos !== 0) {
	        arr.push(str.substring(0, firstPos));
	        str = str.slice(firstPos);
	      }

	      arr.push(result[0]);
	      str = str.slice(result[0].length);
	      result = pat.exec(str);
	    }

	    if (str) {
	      arr.push(str);
	    }

	    return arr;
	  },

	  _addOutput: function (line) {
	    if (this.truncate) {
	      // Only replace single leading linebreak in the line after
	      // -%> tag -- this is the single, trailing linebreak
	      // after the tag that the truncation mode replaces
	      // Handle Win / Unix / old Mac linebreaks -- do the \r\n
	      // combo first in the regex-or
	      line = line.replace(/^(?:\r\n|\r|\n)/, '');
	      this.truncate = false;
	    }
	    if (!line) {
	      return line;
	    }

	    // Preserve literal slashes
	    line = line.replace(/\\/g, '\\\\');

	    // Convert linebreaks
	    line = line.replace(/\n/g, '\\n');
	    line = line.replace(/\r/g, '\\r');

	    // Escape double-quotes
	    // - this will be the delimiter during execution
	    line = line.replace(/"/g, '\\"');
	    this.source += '    ; __append("' + line + '")' + '\n';
	  },

	  scanLine: function (line) {
	    var self = this;
	    var d = this.opts.delimiter;
	    var o = this.opts.openDelimiter;
	    var c = this.opts.closeDelimiter;
	    var newLineCount = 0;

	    newLineCount = (line.split('\n').length - 1);

	    switch (line) {
	    case o + d:
	    case o + d + '_':
	      this.mode = Template.modes.EVAL;
	      break;
	    case o + d + '=':
	      this.mode = Template.modes.ESCAPED;
	      break;
	    case o + d + '-':
	      this.mode = Template.modes.RAW;
	      break;
	    case o + d + '#':
	      this.mode = Template.modes.COMMENT;
	      break;
	    case o + d + d:
	      this.mode = Template.modes.LITERAL;
	      this.source += '    ; __append("' + line.replace(o + d + d, o + d) + '")' + '\n';
	      break;
	    case d + d + c:
	      this.mode = Template.modes.LITERAL;
	      this.source += '    ; __append("' + line.replace(d + d + c, d + c) + '")' + '\n';
	      break;
	    case d + c:
	    case '-' + d + c:
	    case '_' + d + c:
	      if (this.mode == Template.modes.LITERAL) {
	        this._addOutput(line);
	      }

	      this.mode = null;
	      this.truncate = line.indexOf('-') === 0 || line.indexOf('_') === 0;
	      break;
	    default:
	      // In script mode, depends on type of tag
	      if (this.mode) {
	        // If '//' is found without a line break, add a line break.
	        switch (this.mode) {
	        case Template.modes.EVAL:
	        case Template.modes.ESCAPED:
	        case Template.modes.RAW:
	          if (line.lastIndexOf('//') > line.lastIndexOf('\n')) {
	            line += '\n';
	          }
	        }
	        switch (this.mode) {
	        // Just executing code
	        case Template.modes.EVAL:
	          this.source += '    ; ' + line + '\n';
	          break;
	          // Exec, esc, and output
	        case Template.modes.ESCAPED:
	          this.source += '    ; __append(escapeFn(' + stripSemi(line) + '))' + '\n';
	          break;
	          // Exec and output
	        case Template.modes.RAW:
	          this.source += '    ; __append(' + stripSemi(line) + ')' + '\n';
	          break;
	        case Template.modes.COMMENT:
	          // Do nothing
	          break;
	          // Literal <%% mode, append as raw output
	        case Template.modes.LITERAL:
	          this._addOutput(line);
	          break;
	        }
	      }
	      // In string mode, just add the output
	      else {
	        this._addOutput(line);
	      }
	    }

	    if (self.opts.compileDebug && newLineCount) {
	      this.currentLine += newLineCount;
	      this.source += '    ; __line = ' + this.currentLine + '\n';
	    }
	  }
	};

	/**
	 * Escape characters reserved in XML.
	 *
	 * This is simply an export of {@link module:utils.escapeXML}.
	 *
	 * If `markup` is `undefined` or `null`, the empty string is returned.
	 *
	 * @param {String} markup Input string
	 * @return {String} Escaped string
	 * @public
	 * @func
	 * */
	exports.escapeXML = utils.escapeXML;

	/**
	 * Express.js support.
	 *
	 * This is an alias for {@link module:ejs.renderFile}, in order to support
	 * Express.js out-of-the-box.
	 *
	 * @func
	 */

	exports.__express = exports.renderFile;

	/**
	 * Version of EJS.
	 *
	 * @readonly
	 * @type {String}
	 * @public
	 */

	exports.VERSION = _VERSION_STRING;

	/**
	 * Name for detection of EJS.
	 *
	 * @readonly
	 * @type {String}
	 * @public
	 */

	exports.name = _NAME;

	/* istanbul ignore if */
	if (typeof window != 'undefined') {
	  window.ejs = exports;
	} 
} (ejs));

function _interpolate (envValue, environment, config) {
  const matches = envValue.match(/(.?\${*[\w]*(?::-[\w/]*)?}*)/g) || [];

  return matches.reduce(function (newEnv, match, index) {
    const parts = /(.?)\${*([\w]*(?::-[\w/]*)?)?}*/g.exec(match);
    if (!parts || parts.length === 0) {
      return newEnv
    }

    const prefix = parts[1];

    let value, replacePart;

    if (prefix === '\\') {
      replacePart = parts[0];
      value = replacePart.replace('\\$', '$');
    } else {
      const keyParts = parts[2].split(':-');
      const key = keyParts[0];
      replacePart = parts[0].substring(prefix.length);
      // process.env value 'wins' over .env file's value
      value = Object.prototype.hasOwnProperty.call(environment, key)
        ? environment[key]
        : (config.parsed[key] || keyParts[1] || '');

      // If the value is found, remove nested expansions.
      if (keyParts.length > 1 && value) {
        const replaceNested = matches[index + 1];
        matches[index + 1] = '';

        newEnv = newEnv.replace(replaceNested, '');
      }
      // Resolve recursive interpolations
      value = _interpolate(value, environment, config);
    }

    return newEnv.replace(replacePart, value)
  }, envValue)
}

function expand$2 (config) {
  // if ignoring process.env, use a blank object
  const environment = config.ignoreProcessEnv ? {} : process.env;

  for (const configKey in config.parsed) {
    const value = Object.prototype.hasOwnProperty.call(environment, configKey) ? environment[configKey] : config.parsed[configKey];

    config.parsed[configKey] = _interpolate(value, environment, config);
  }

  for (const processKey in config.parsed) {
    environment[processKey] = config.parsed[processKey];
  }

  return config
}

var expand_1$1 = expand$2;

var main$4 = {exports: {}};

var name$2 = "dotenv";
var version$2 = "16.4.5";
var description$1 = "Loads environment variables from .env file";
var main$3 = "lib/main.js";
var types$1 = "lib/main.d.ts";
var exports$1 = {
	".": {
		types: "./lib/main.d.ts",
		require: "./lib/main.js",
		"default": "./lib/main.js"
	},
	"./config": "./config.js",
	"./config.js": "./config.js",
	"./lib/env-options": "./lib/env-options.js",
	"./lib/env-options.js": "./lib/env-options.js",
	"./lib/cli-options": "./lib/cli-options.js",
	"./lib/cli-options.js": "./lib/cli-options.js",
	"./package.json": "./package.json"
};
var scripts$1 = {
	"dts-check": "tsc --project tests/types/tsconfig.json",
	lint: "standard",
	"lint-readme": "standard-markdown",
	pretest: "npm run lint && npm run dts-check",
	test: "tap tests/*.js --100 -Rspec",
	"test:coverage": "tap --coverage-report=lcov",
	prerelease: "npm test",
	release: "standard-version"
};
var repository$1 = {
	type: "git",
	url: "git://github.com/motdotla/dotenv.git"
};
var funding$1 = "https://dotenvx.com";
var keywords$1 = [
	"dotenv",
	"env",
	".env",
	"environment",
	"variables",
	"config",
	"settings"
];
var readmeFilename = "README.md";
var license$1 = "BSD-2-Clause";
var devDependencies = {
	"@definitelytyped/dtslint": "^0.0.133",
	"@types/node": "^18.11.3",
	decache: "^4.6.1",
	sinon: "^14.0.1",
	standard: "^17.0.0",
	"standard-markdown": "^7.1.0",
	"standard-version": "^9.5.0",
	tap: "^16.3.0",
	tar: "^6.1.11",
	typescript: "^4.8.4"
};
var engines = {
	node: ">=12"
};
var browser$1 = {
	fs: false
};
var require$$4 = {
	name: name$2,
	version: version$2,
	description: description$1,
	main: main$3,
	types: types$1,
	exports: exports$1,
	scripts: scripts$1,
	repository: repository$1,
	funding: funding$1,
	keywords: keywords$1,
	readmeFilename: readmeFilename,
	license: license$1,
	devDependencies: devDependencies,
	engines: engines,
	browser: browser$1
};

const fs$C = require$$0__default["default"];
const path$C = path__default["default"];
const os$5 = require$$0__default$1["default"];
const crypto$2 = require$$3__default$1["default"];
const packageJson = require$$4;

const version$1 = packageJson.version;

const LINE = /(?:^|^)\s*(?:export\s+)?([\w.-]+)(?:\s*=\s*?|:\s+?)(\s*'(?:\\'|[^'])*'|\s*"(?:\\"|[^"])*"|\s*`(?:\\`|[^`])*`|[^#\r\n]+)?\s*(?:#.*)?(?:$|$)/mg;

// Parse src into an Object
function parse$e (src) {
  const obj = {};

  // Convert buffer to string
  let lines = src.toString();

  // Convert line breaks to same format
  lines = lines.replace(/\r\n?/mg, '\n');

  let match;
  while ((match = LINE.exec(lines)) != null) {
    const key = match[1];

    // Default undefined or null to empty string
    let value = (match[2] || '');

    // Remove whitespace
    value = value.trim();

    // Check if double quoted
    const maybeQuote = value[0];

    // Remove surrounding quotes
    value = value.replace(/^(['"`])([\s\S]*)\1$/mg, '$2');

    // Expand newlines if double quoted
    if (maybeQuote === '"') {
      value = value.replace(/\\n/g, '\n');
      value = value.replace(/\\r/g, '\r');
    }

    // Add to object
    obj[key] = value;
  }

  return obj
}

function _parseVault (options) {
  const vaultPath = _vaultPath(options);

  // Parse .env.vault
  const result = DotenvModule$1.configDotenv({ path: vaultPath });
  if (!result.parsed) {
    const err = new Error(`MISSING_DATA: Cannot parse ${vaultPath} for an unknown reason`);
    err.code = 'MISSING_DATA';
    throw err
  }

  // handle scenario for comma separated keys - for use with key rotation
  // example: DOTENV_KEY="dotenv://:key_1234@dotenvx.com/vault/.env.vault?environment=prod,dotenv://:key_7890@dotenvx.com/vault/.env.vault?environment=prod"
  const keys = _dotenvKey(options).split(',');
  const length = keys.length;

  let decrypted;
  for (let i = 0; i < length; i++) {
    try {
      // Get full key
      const key = keys[i].trim();

      // Get instructions for decrypt
      const attrs = _instructions(result, key);

      // Decrypt
      decrypted = DotenvModule$1.decrypt(attrs.ciphertext, attrs.key);

      break
    } catch (error) {
      // last key
      if (i + 1 >= length) {
        throw error
      }
      // try next key
    }
  }

  // Parse decrypted .env string
  return DotenvModule$1.parse(decrypted)
}

function _log (message) {
  console.log(`[dotenv@${version$1}][INFO] ${message}`);
}

function _warn (message) {
  console.log(`[dotenv@${version$1}][WARN] ${message}`);
}

function _debug (message) {
  console.log(`[dotenv@${version$1}][DEBUG] ${message}`);
}

function _dotenvKey (options) {
  // prioritize developer directly setting options.DOTENV_KEY
  if (options && options.DOTENV_KEY && options.DOTENV_KEY.length > 0) {
    return options.DOTENV_KEY
  }

  // secondary infra already contains a DOTENV_KEY environment variable
  if (process.env.DOTENV_KEY && process.env.DOTENV_KEY.length > 0) {
    return process.env.DOTENV_KEY
  }

  // fallback to empty string
  return ''
}

function _instructions (result, dotenvKey) {
  // Parse DOTENV_KEY. Format is a URI
  let uri;
  try {
    uri = new URL(dotenvKey);
  } catch (error) {
    if (error.code === 'ERR_INVALID_URL') {
      const err = new Error('INVALID_DOTENV_KEY: Wrong format. Must be in valid uri format like dotenv://:key_1234@dotenvx.com/vault/.env.vault?environment=development');
      err.code = 'INVALID_DOTENV_KEY';
      throw err
    }

    throw error
  }

  // Get decrypt key
  const key = uri.password;
  if (!key) {
    const err = new Error('INVALID_DOTENV_KEY: Missing key part');
    err.code = 'INVALID_DOTENV_KEY';
    throw err
  }

  // Get environment
  const environment = uri.searchParams.get('environment');
  if (!environment) {
    const err = new Error('INVALID_DOTENV_KEY: Missing environment part');
    err.code = 'INVALID_DOTENV_KEY';
    throw err
  }

  // Get ciphertext payload
  const environmentKey = `DOTENV_VAULT_${environment.toUpperCase()}`;
  const ciphertext = result.parsed[environmentKey]; // DOTENV_VAULT_PRODUCTION
  if (!ciphertext) {
    const err = new Error(`NOT_FOUND_DOTENV_ENVIRONMENT: Cannot locate environment ${environmentKey} in your .env.vault file.`);
    err.code = 'NOT_FOUND_DOTENV_ENVIRONMENT';
    throw err
  }

  return { ciphertext, key }
}

function _vaultPath (options) {
  let possibleVaultPath = null;

  if (options && options.path && options.path.length > 0) {
    if (Array.isArray(options.path)) {
      for (const filepath of options.path) {
        if (fs$C.existsSync(filepath)) {
          possibleVaultPath = filepath.endsWith('.vault') ? filepath : `${filepath}.vault`;
        }
      }
    } else {
      possibleVaultPath = options.path.endsWith('.vault') ? options.path : `${options.path}.vault`;
    }
  } else {
    possibleVaultPath = path$C.resolve(process.cwd(), '.env.vault');
  }

  if (fs$C.existsSync(possibleVaultPath)) {
    return possibleVaultPath
  }

  return null
}

function _resolveHome (envPath) {
  return envPath[0] === '~' ? path$C.join(os$5.homedir(), envPath.slice(1)) : envPath
}

function _configVault (options) {
  _log('Loading env from encrypted .env.vault');

  const parsed = DotenvModule$1._parseVault(options);

  let processEnv = process.env;
  if (options && options.processEnv != null) {
    processEnv = options.processEnv;
  }

  DotenvModule$1.populate(processEnv, parsed, options);

  return { parsed }
}

function configDotenv (options) {
  const dotenvPath = path$C.resolve(process.cwd(), '.env');
  let encoding = 'utf8';
  const debug = Boolean(options && options.debug);

  if (options && options.encoding) {
    encoding = options.encoding;
  } else {
    if (debug) {
      _debug('No encoding is specified. UTF-8 is used by default');
    }
  }

  let optionPaths = [dotenvPath]; // default, look for .env
  if (options && options.path) {
    if (!Array.isArray(options.path)) {
      optionPaths = [_resolveHome(options.path)];
    } else {
      optionPaths = []; // reset default
      for (const filepath of options.path) {
        optionPaths.push(_resolveHome(filepath));
      }
    }
  }

  // Build the parsed data in a temporary object (because we need to return it).  Once we have the final
  // parsed data, we will combine it with process.env (or options.processEnv if provided).
  let lastError;
  const parsedAll = {};
  for (const path of optionPaths) {
    try {
      // Specifying an encoding returns a string instead of a buffer
      const parsed = DotenvModule$1.parse(fs$C.readFileSync(path, { encoding }));

      DotenvModule$1.populate(parsedAll, parsed, options);
    } catch (e) {
      if (debug) {
        _debug(`Failed to load ${path} ${e.message}`);
      }
      lastError = e;
    }
  }

  let processEnv = process.env;
  if (options && options.processEnv != null) {
    processEnv = options.processEnv;
  }

  DotenvModule$1.populate(processEnv, parsedAll, options);

  if (lastError) {
    return { parsed: parsedAll, error: lastError }
  } else {
    return { parsed: parsedAll }
  }
}

// Populates process.env from .env file
function config$2 (options) {
  // fallback to original dotenv if DOTENV_KEY is not set
  if (_dotenvKey(options).length === 0) {
    return DotenvModule$1.configDotenv(options)
  }

  const vaultPath = _vaultPath(options);

  // dotenvKey exists but .env.vault file does not exist
  if (!vaultPath) {
    _warn(`You set DOTENV_KEY but you are missing a .env.vault file at ${vaultPath}. Did you forget to build it?`);

    return DotenvModule$1.configDotenv(options)
  }

  return DotenvModule$1._configVault(options)
}

function decrypt (encrypted, keyStr) {
  const key = Buffer.from(keyStr.slice(-64), 'hex');
  let ciphertext = Buffer.from(encrypted, 'base64');

  const nonce = ciphertext.subarray(0, 12);
  const authTag = ciphertext.subarray(-16);
  ciphertext = ciphertext.subarray(12, -16);

  try {
    const aesgcm = crypto$2.createDecipheriv('aes-256-gcm', key, nonce);
    aesgcm.setAuthTag(authTag);
    return `${aesgcm.update(ciphertext)}${aesgcm.final()}`
  } catch (error) {
    const isRange = error instanceof RangeError;
    const invalidKeyLength = error.message === 'Invalid key length';
    const decryptionFailed = error.message === 'Unsupported state or unable to authenticate data';

    if (isRange || invalidKeyLength) {
      const err = new Error('INVALID_DOTENV_KEY: It must be 64 characters long (or more)');
      err.code = 'INVALID_DOTENV_KEY';
      throw err
    } else if (decryptionFailed) {
      const err = new Error('DECRYPTION_FAILED: Please check your DOTENV_KEY');
      err.code = 'DECRYPTION_FAILED';
      throw err
    } else {
      throw error
    }
  }
}

// Populate process.env with parsed values
function populate$1 (processEnv, parsed, options = {}) {
  const debug = Boolean(options && options.debug);
  const override = Boolean(options && options.override);

  if (typeof parsed !== 'object') {
    const err = new Error('OBJECT_REQUIRED: Please check the processEnv argument being passed to populate');
    err.code = 'OBJECT_REQUIRED';
    throw err
  }

  // Set process.env
  for (const key of Object.keys(parsed)) {
    if (Object.prototype.hasOwnProperty.call(processEnv, key)) {
      if (override === true) {
        processEnv[key] = parsed[key];
      }

      if (debug) {
        if (override === true) {
          _debug(`"${key}" is already defined and WAS overwritten`);
        } else {
          _debug(`"${key}" is already defined and was NOT overwritten`);
        }
      }
    } else {
      processEnv[key] = parsed[key];
    }
  }
}

const DotenvModule$1 = {
  configDotenv,
  _configVault,
  _parseVault,
  config: config$2,
  decrypt,
  parse: parse$e,
  populate: populate$1
};

main$4.exports.configDotenv = DotenvModule$1.configDotenv;
main$4.exports._configVault = DotenvModule$1._configVault;
main$4.exports._parseVault = DotenvModule$1._parseVault;
main$4.exports.config = DotenvModule$1.config;
main$4.exports.decrypt = DotenvModule$1.decrypt;
main$4.exports.parse = DotenvModule$1.parse;
main$4.exports.populate = DotenvModule$1.populate;

main$4.exports = DotenvModule$1;

var mainExports = main$4.exports;
var dotenv = /*@__PURE__*/getDefaultExportFromCjs(mainExports);

function normalizeWindowsPath(input = "") {
  if (!input.includes("\\")) {
    return input;
  }
  return input.replace(/\\/g, "/");
}

const _UNC_REGEX = /^[/][/]/;
const _UNC_DRIVE_REGEX = /^[/][/]([.]{1,2}[/])?([a-zA-Z]):[/]/;
const _IS_ABSOLUTE_RE = /^\/|^\\|^[a-zA-Z]:[/\\]/;
const sep$1 = "/";
const delimiter = ":";
const normalize$2 = function(path2) {
  if (path2.length === 0) {
    return ".";
  }
  path2 = normalizeWindowsPath(path2);
  const isUNCPath = path2.match(_UNC_REGEX);
  const hasUNCDrive = isUNCPath && path2.match(_UNC_DRIVE_REGEX);
  const isPathAbsolute = isAbsolute$1(path2);
  const trailingSeparator = path2[path2.length - 1] === "/";
  path2 = normalizeString(path2, !isPathAbsolute);
  if (path2.length === 0) {
    if (isPathAbsolute) {
      return "/";
    }
    return trailingSeparator ? "./" : ".";
  }
  if (trailingSeparator) {
    path2 += "/";
  }
  if (isUNCPath) {
    if (hasUNCDrive) {
      return `//./${path2}`;
    }
    return `//${path2}`;
  }
  return isPathAbsolute && !isAbsolute$1(path2) ? `/${path2}` : path2;
};
const join = function(...args) {
  if (args.length === 0) {
    return ".";
  }
  let joined;
  for (let i = 0; i < args.length; ++i) {
    const arg = args[i];
    if (arg.length > 0) {
      if (joined === void 0) {
        joined = arg;
      } else {
        joined += `/${arg}`;
      }
    }
  }
  if (joined === void 0) {
    return ".";
  }
  return normalize$2(joined);
};
const resolve$3 = function(...args) {
  args = args.map((arg) => normalizeWindowsPath(arg));
  let resolvedPath = "";
  let resolvedAbsolute = false;
  for (let i = args.length - 1; i >= -1 && !resolvedAbsolute; i--) {
    const path2 = i >= 0 ? args[i] : process.cwd();
    if (path2.length === 0) {
      continue;
    }
    resolvedPath = `${path2}/${resolvedPath}`;
    resolvedAbsolute = isAbsolute$1(path2);
  }
  resolvedPath = normalizeString(resolvedPath, !resolvedAbsolute);
  if (resolvedAbsolute && !isAbsolute$1(resolvedPath)) {
    return `/${resolvedPath}`;
  }
  return resolvedPath.length > 0 ? resolvedPath : ".";
};
function normalizeString(path2, allowAboveRoot) {
  let res = "";
  let lastSegmentLength = 0;
  let lastSlash = -1;
  let dots = 0;
  let char = null;
  for (let i = 0; i <= path2.length; ++i) {
    if (i < path2.length) {
      char = path2[i];
    } else if (char === "/") {
      break;
    } else {
      char = "/";
    }
    if (char === "/") {
      if (lastSlash === i - 1 || dots === 1) ; else if (dots === 2) {
        if (res.length < 2 || lastSegmentLength !== 2 || res[res.length - 1] !== "." || res[res.length - 2] !== ".") {
          if (res.length > 2) {
            const lastSlashIndex = res.lastIndexOf("/");
            if (lastSlashIndex === -1) {
              res = "";
              lastSegmentLength = 0;
            } else {
              res = res.slice(0, lastSlashIndex);
              lastSegmentLength = res.length - 1 - res.lastIndexOf("/");
            }
            lastSlash = i;
            dots = 0;
            continue;
          } else if (res.length !== 0) {
            res = "";
            lastSegmentLength = 0;
            lastSlash = i;
            dots = 0;
            continue;
          }
        }
        if (allowAboveRoot) {
          res += res.length > 0 ? "/.." : "..";
          lastSegmentLength = 2;
        }
      } else {
        if (res.length > 0) {
          res += `/${path2.slice(lastSlash + 1, i)}`;
        } else {
          res = path2.slice(lastSlash + 1, i);
        }
        lastSegmentLength = i - lastSlash - 1;
      }
      lastSlash = i;
      dots = 0;
    } else if (char === "." && dots !== -1) {
      ++dots;
    } else {
      dots = -1;
    }
  }
  return res;
}
const isAbsolute$1 = function(p) {
  return _IS_ABSOLUTE_RE.test(p);
};
const toNamespacedPath = function(p) {
  return normalizeWindowsPath(p);
};
const extname$1 = function(p) {
  return path__default["default"].posix.extname(normalizeWindowsPath(p));
};
const relative$1 = function(from, to) {
  return path__default["default"].posix.relative(normalizeWindowsPath(from), normalizeWindowsPath(to));
};
const dirname = function(p) {
  return path__default["default"].posix.dirname(normalizeWindowsPath(p));
};
const format$2 = function(p) {
  return normalizeWindowsPath(path__default["default"].posix.format(p));
};
const basename = function(p, ext) {
  return path__default["default"].posix.basename(normalizeWindowsPath(p), ext);
};
const parse$d = function(p) {
  return path__default["default"].posix.parse(normalizeWindowsPath(p));
};

const _path$5 = /*#__PURE__*/Object.freeze({
  __proto__: null,
  sep: sep$1,
  delimiter: delimiter,
  normalize: normalize$2,
  join: join,
  resolve: resolve$3,
  normalizeString: normalizeString,
  isAbsolute: isAbsolute$1,
  toNamespacedPath: toNamespacedPath,
  extname: extname$1,
  relative: relative$1,
  dirname: dirname,
  format: format$2,
  basename: basename,
  parse: parse$d
});

const index = {
  ..._path$5
};

var fs$B = {};

var universalify$1 = {};

universalify$1.fromCallback = function (fn) {
  return Object.defineProperty(function (...args) {
    if (typeof args[args.length - 1] === 'function') fn.apply(this, args);
    else {
      return new Promise((resolve, reject) => {
        args.push((err, res) => (err != null) ? reject(err) : resolve(res));
        fn.apply(this, args);
      })
    }
  }, 'name', { value: fn.name })
};

universalify$1.fromPromise = function (fn) {
  return Object.defineProperty(function (...args) {
    const cb = args[args.length - 1];
    if (typeof cb !== 'function') return fn.apply(this, args)
    else {
      args.pop();
      fn.apply(this, args).then(r => cb(null, r), cb);
    }
  }, 'name', { value: fn.name })
};

var constants$8 = require$$0__default$3["default"];

var origCwd = process.cwd;
var cwd$1 = null;

var platform$1 = process.env.GRACEFUL_FS_PLATFORM || process.platform;

process.cwd = function() {
  if (!cwd$1)
    cwd$1 = origCwd.call(process);
  return cwd$1
};
try {
  process.cwd();
} catch (er) {}

// This check is needed until node.js 12 is required
if (typeof process.chdir === 'function') {
  var chdir = process.chdir;
  process.chdir = function (d) {
    cwd$1 = null;
    chdir.call(process, d);
  };
  if (Object.setPrototypeOf) Object.setPrototypeOf(process.chdir, chdir);
}

var polyfills$1 = patch$1;

function patch$1 (fs) {
  // (re-)implement some things that are known busted or missing.

  // lchmod, broken prior to 0.6.2
  // back-port the fix here.
  if (constants$8.hasOwnProperty('O_SYMLINK') &&
      process.version.match(/^v0\.6\.[0-2]|^v0\.5\./)) {
    patchLchmod(fs);
  }

  // lutimes implementation, or no-op
  if (!fs.lutimes) {
    patchLutimes(fs);
  }

  // https://github.com/isaacs/node-graceful-fs/issues/4
  // Chown should not fail on einval or eperm if non-root.
  // It should not fail on enosys ever, as this just indicates
  // that a fs doesn't support the intended operation.

  fs.chown = chownFix(fs.chown);
  fs.fchown = chownFix(fs.fchown);
  fs.lchown = chownFix(fs.lchown);

  fs.chmod = chmodFix(fs.chmod);
  fs.fchmod = chmodFix(fs.fchmod);
  fs.lchmod = chmodFix(fs.lchmod);

  fs.chownSync = chownFixSync(fs.chownSync);
  fs.fchownSync = chownFixSync(fs.fchownSync);
  fs.lchownSync = chownFixSync(fs.lchownSync);

  fs.chmodSync = chmodFixSync(fs.chmodSync);
  fs.fchmodSync = chmodFixSync(fs.fchmodSync);
  fs.lchmodSync = chmodFixSync(fs.lchmodSync);

  fs.stat = statFix(fs.stat);
  fs.fstat = statFix(fs.fstat);
  fs.lstat = statFix(fs.lstat);

  fs.statSync = statFixSync(fs.statSync);
  fs.fstatSync = statFixSync(fs.fstatSync);
  fs.lstatSync = statFixSync(fs.lstatSync);

  // if lchmod/lchown do not exist, then make them no-ops
  if (fs.chmod && !fs.lchmod) {
    fs.lchmod = function (path, mode, cb) {
      if (cb) process.nextTick(cb);
    };
    fs.lchmodSync = function () {};
  }
  if (fs.chown && !fs.lchown) {
    fs.lchown = function (path, uid, gid, cb) {
      if (cb) process.nextTick(cb);
    };
    fs.lchownSync = function () {};
  }

  // on Windows, A/V software can lock the directory, causing this
  // to fail with an EACCES or EPERM if the directory contains newly
  // created files.  Try again on failure, for up to 60 seconds.

  // Set the timeout this long because some Windows Anti-Virus, such as Parity
  // bit9, may lock files for up to a minute, causing npm package install
  // failures. Also, take care to yield the scheduler. Windows scheduling gives
  // CPU to a busy looping process, which can cause the program causing the lock
  // contention to be starved of CPU by node, so the contention doesn't resolve.
  if (platform$1 === "win32") {
    fs.rename = typeof fs.rename !== 'function' ? fs.rename
    : (function (fs$rename) {
      function rename (from, to, cb) {
        var start = Date.now();
        var backoff = 0;
        fs$rename(from, to, function CB (er) {
          if (er
              && (er.code === "EACCES" || er.code === "EPERM" || er.code === "EBUSY")
              && Date.now() - start < 60000) {
            setTimeout(function() {
              fs.stat(to, function (stater, st) {
                if (stater && stater.code === "ENOENT")
                  fs$rename(from, to, CB);
                else
                  cb(er);
              });
            }, backoff);
            if (backoff < 100)
              backoff += 10;
            return;
          }
          if (cb) cb(er);
        });
      }
      if (Object.setPrototypeOf) Object.setPrototypeOf(rename, fs$rename);
      return rename
    })(fs.rename);
  }

  // if read() returns EAGAIN, then just try it again.
  fs.read = typeof fs.read !== 'function' ? fs.read
  : (function (fs$read) {
    function read (fd, buffer, offset, length, position, callback_) {
      var callback;
      if (callback_ && typeof callback_ === 'function') {
        var eagCounter = 0;
        callback = function (er, _, __) {
          if (er && er.code === 'EAGAIN' && eagCounter < 10) {
            eagCounter ++;
            return fs$read.call(fs, fd, buffer, offset, length, position, callback)
          }
          callback_.apply(this, arguments);
        };
      }
      return fs$read.call(fs, fd, buffer, offset, length, position, callback)
    }

    // This ensures `util.promisify` works as it does for native `fs.read`.
    if (Object.setPrototypeOf) Object.setPrototypeOf(read, fs$read);
    return read
  })(fs.read);

  fs.readSync = typeof fs.readSync !== 'function' ? fs.readSync
  : (function (fs$readSync) { return function (fd, buffer, offset, length, position) {
    var eagCounter = 0;
    while (true) {
      try {
        return fs$readSync.call(fs, fd, buffer, offset, length, position)
      } catch (er) {
        if (er.code === 'EAGAIN' && eagCounter < 10) {
          eagCounter ++;
          continue
        }
        throw er
      }
    }
  }})(fs.readSync);

  function patchLchmod (fs) {
    fs.lchmod = function (path, mode, callback) {
      fs.open( path
             , constants$8.O_WRONLY | constants$8.O_SYMLINK
             , mode
             , function (err, fd) {
        if (err) {
          if (callback) callback(err);
          return
        }
        // prefer to return the chmod error, if one occurs,
        // but still try to close, and report closing errors if they occur.
        fs.fchmod(fd, mode, function (err) {
          fs.close(fd, function(err2) {
            if (callback) callback(err || err2);
          });
        });
      });
    };

    fs.lchmodSync = function (path, mode) {
      var fd = fs.openSync(path, constants$8.O_WRONLY | constants$8.O_SYMLINK, mode);

      // prefer to return the chmod error, if one occurs,
      // but still try to close, and report closing errors if they occur.
      var threw = true;
      var ret;
      try {
        ret = fs.fchmodSync(fd, mode);
        threw = false;
      } finally {
        if (threw) {
          try {
            fs.closeSync(fd);
          } catch (er) {}
        } else {
          fs.closeSync(fd);
        }
      }
      return ret
    };
  }

  function patchLutimes (fs) {
    if (constants$8.hasOwnProperty("O_SYMLINK") && fs.futimes) {
      fs.lutimes = function (path, at, mt, cb) {
        fs.open(path, constants$8.O_SYMLINK, function (er, fd) {
          if (er) {
            if (cb) cb(er);
            return
          }
          fs.futimes(fd, at, mt, function (er) {
            fs.close(fd, function (er2) {
              if (cb) cb(er || er2);
            });
          });
        });
      };

      fs.lutimesSync = function (path, at, mt) {
        var fd = fs.openSync(path, constants$8.O_SYMLINK);
        var ret;
        var threw = true;
        try {
          ret = fs.futimesSync(fd, at, mt);
          threw = false;
        } finally {
          if (threw) {
            try {
              fs.closeSync(fd);
            } catch (er) {}
          } else {
            fs.closeSync(fd);
          }
        }
        return ret
      };

    } else if (fs.futimes) {
      fs.lutimes = function (_a, _b, _c, cb) { if (cb) process.nextTick(cb); };
      fs.lutimesSync = function () {};
    }
  }

  function chmodFix (orig) {
    if (!orig) return orig
    return function (target, mode, cb) {
      return orig.call(fs, target, mode, function (er) {
        if (chownErOk(er)) er = null;
        if (cb) cb.apply(this, arguments);
      })
    }
  }

  function chmodFixSync (orig) {
    if (!orig) return orig
    return function (target, mode) {
      try {
        return orig.call(fs, target, mode)
      } catch (er) {
        if (!chownErOk(er)) throw er
      }
    }
  }


  function chownFix (orig) {
    if (!orig) return orig
    return function (target, uid, gid, cb) {
      return orig.call(fs, target, uid, gid, function (er) {
        if (chownErOk(er)) er = null;
        if (cb) cb.apply(this, arguments);
      })
    }
  }

  function chownFixSync (orig) {
    if (!orig) return orig
    return function (target, uid, gid) {
      try {
        return orig.call(fs, target, uid, gid)
      } catch (er) {
        if (!chownErOk(er)) throw er
      }
    }
  }

  function statFix (orig) {
    if (!orig) return orig
    // Older versions of Node erroneously returned signed integers for
    // uid + gid.
    return function (target, options, cb) {
      if (typeof options === 'function') {
        cb = options;
        options = null;
      }
      function callback (er, stats) {
        if (stats) {
          if (stats.uid < 0) stats.uid += 0x100000000;
          if (stats.gid < 0) stats.gid += 0x100000000;
        }
        if (cb) cb.apply(this, arguments);
      }
      return options ? orig.call(fs, target, options, callback)
        : orig.call(fs, target, callback)
    }
  }

  function statFixSync (orig) {
    if (!orig) return orig
    // Older versions of Node erroneously returned signed integers for
    // uid + gid.
    return function (target, options) {
      var stats = options ? orig.call(fs, target, options)
        : orig.call(fs, target);
      if (stats) {
        if (stats.uid < 0) stats.uid += 0x100000000;
        if (stats.gid < 0) stats.gid += 0x100000000;
      }
      return stats;
    }
  }

  // ENOSYS means that the fs doesn't support the op. Just ignore
  // that, because it doesn't matter.
  //
  // if there's no getuid, or if getuid() is something other
  // than 0, and the error is EINVAL or EPERM, then just ignore
  // it.
  //
  // This specific case is a silent failure in cp, install, tar,
  // and most other unix tools that manage permissions.
  //
  // When running as root, or if other types of errors are
  // encountered, then it's strict.
  function chownErOk (er) {
    if (!er)
      return true

    if (er.code === "ENOSYS")
      return true

    var nonroot = !process.getuid || process.getuid() !== 0;
    if (nonroot) {
      if (er.code === "EINVAL" || er.code === "EPERM")
        return true
    }

    return false
  }
}

var Stream$1 = require$$0__default$4["default"].Stream;

var legacyStreams = legacy$3;

function legacy$3 (fs) {
  return {
    ReadStream: ReadStream,
    WriteStream: WriteStream
  }

  function ReadStream (path, options) {
    if (!(this instanceof ReadStream)) return new ReadStream(path, options);

    Stream$1.call(this);

    var self = this;

    this.path = path;
    this.fd = null;
    this.readable = true;
    this.paused = false;

    this.flags = 'r';
    this.mode = 438; /*=0666*/
    this.bufferSize = 64 * 1024;

    options = options || {};

    // Mixin options into this
    var keys = Object.keys(options);
    for (var index = 0, length = keys.length; index < length; index++) {
      var key = keys[index];
      this[key] = options[key];
    }

    if (this.encoding) this.setEncoding(this.encoding);

    if (this.start !== undefined) {
      if ('number' !== typeof this.start) {
        throw TypeError('start must be a Number');
      }
      if (this.end === undefined) {
        this.end = Infinity;
      } else if ('number' !== typeof this.end) {
        throw TypeError('end must be a Number');
      }

      if (this.start > this.end) {
        throw new Error('start must be <= end');
      }

      this.pos = this.start;
    }

    if (this.fd !== null) {
      process.nextTick(function() {
        self._read();
      });
      return;
    }

    fs.open(this.path, this.flags, this.mode, function (err, fd) {
      if (err) {
        self.emit('error', err);
        self.readable = false;
        return;
      }

      self.fd = fd;
      self.emit('open', fd);
      self._read();
    });
  }

  function WriteStream (path, options) {
    if (!(this instanceof WriteStream)) return new WriteStream(path, options);

    Stream$1.call(this);

    this.path = path;
    this.fd = null;
    this.writable = true;

    this.flags = 'w';
    this.encoding = 'binary';
    this.mode = 438; /*=0666*/
    this.bytesWritten = 0;

    options = options || {};

    // Mixin options into this
    var keys = Object.keys(options);
    for (var index = 0, length = keys.length; index < length; index++) {
      var key = keys[index];
      this[key] = options[key];
    }

    if (this.start !== undefined) {
      if ('number' !== typeof this.start) {
        throw TypeError('start must be a Number');
      }
      if (this.start < 0) {
        throw new Error('start must be >= zero');
      }

      this.pos = this.start;
    }

    this.busy = false;
    this._queue = [];

    if (this.fd === null) {
      this._open = fs.open;
      this._queue.push([this._open, this.path, this.flags, this.mode, undefined]);
      this.flush();
    }
  }
}

var clone_1 = clone$4;

var getPrototypeOf = Object.getPrototypeOf || function (obj) {
  return obj.__proto__
};

function clone$4 (obj) {
  if (obj === null || typeof obj !== 'object')
    return obj

  if (obj instanceof Object)
    var copy = { __proto__: getPrototypeOf(obj) };
  else
    var copy = Object.create(null);

  Object.getOwnPropertyNames(obj).forEach(function (key) {
    Object.defineProperty(copy, key, Object.getOwnPropertyDescriptor(obj, key));
  });

  return copy
}

var fs$A = require$$0__default["default"];
var polyfills = polyfills$1;
var legacy$2 = legacyStreams;
var clone$3 = clone_1;

var util$8 = require$$0__default$2["default"];

/* istanbul ignore next - node 0.x polyfill */
var gracefulQueue;
var previousSymbol;

/* istanbul ignore else - node 0.x polyfill */
if (typeof Symbol === 'function' && typeof Symbol.for === 'function') {
  gracefulQueue = Symbol.for('graceful-fs.queue');
  // This is used in testing by future versions
  previousSymbol = Symbol.for('graceful-fs.previous');
} else {
  gracefulQueue = '___graceful-fs.queue';
  previousSymbol = '___graceful-fs.previous';
}

function noop$2 () {}

function publishQueue(context, queue) {
  Object.defineProperty(context, gracefulQueue, {
    get: function() {
      return queue
    }
  });
}

var debug$1 = noop$2;
if (util$8.debuglog)
  debug$1 = util$8.debuglog('gfs4');
else if (/\bgfs4\b/i.test(process.env.NODE_DEBUG || ''))
  debug$1 = function() {
    var m = util$8.format.apply(util$8, arguments);
    m = 'GFS4: ' + m.split(/\n/).join('\nGFS4: ');
    console.error(m);
  };

// Once time initialization
if (!fs$A[gracefulQueue]) {
  // This queue can be shared by multiple loaded instances
  var queue$1 = commonjsGlobal[gracefulQueue] || [];
  publishQueue(fs$A, queue$1);

  // Patch fs.close/closeSync to shared queue version, because we need
  // to retry() whenever a close happens *anywhere* in the program.
  // This is essential when multiple graceful-fs instances are
  // in play at the same time.
  fs$A.close = (function (fs$close) {
    function close (fd, cb) {
      return fs$close.call(fs$A, fd, function (err) {
        // This function uses the graceful-fs shared queue
        if (!err) {
          resetQueue();
        }

        if (typeof cb === 'function')
          cb.apply(this, arguments);
      })
    }

    Object.defineProperty(close, previousSymbol, {
      value: fs$close
    });
    return close
  })(fs$A.close);

  fs$A.closeSync = (function (fs$closeSync) {
    function closeSync (fd) {
      // This function uses the graceful-fs shared queue
      fs$closeSync.apply(fs$A, arguments);
      resetQueue();
    }

    Object.defineProperty(closeSync, previousSymbol, {
      value: fs$closeSync
    });
    return closeSync
  })(fs$A.closeSync);

  if (/\bgfs4\b/i.test(process.env.NODE_DEBUG || '')) {
    process.on('exit', function() {
      debug$1(fs$A[gracefulQueue]);
      require$$0__default$5["default"].equal(fs$A[gracefulQueue].length, 0);
    });
  }
}

if (!commonjsGlobal[gracefulQueue]) {
  publishQueue(commonjsGlobal, fs$A[gracefulQueue]);
}

var gracefulFs = patch(clone$3(fs$A));
if (process.env.TEST_GRACEFUL_FS_GLOBAL_PATCH && !fs$A.__patched) {
    gracefulFs = patch(fs$A);
    fs$A.__patched = true;
}

function patch (fs) {
  // Everything that references the open() function needs to be in here
  polyfills(fs);
  fs.gracefulify = patch;

  fs.createReadStream = createReadStream;
  fs.createWriteStream = createWriteStream;
  var fs$readFile = fs.readFile;
  fs.readFile = readFile;
  function readFile (path, options, cb) {
    if (typeof options === 'function')
      cb = options, options = null;

    return go$readFile(path, options, cb)

    function go$readFile (path, options, cb, startTime) {
      return fs$readFile(path, options, function (err) {
        if (err && (err.code === 'EMFILE' || err.code === 'ENFILE'))
          enqueue([go$readFile, [path, options, cb], err, startTime || Date.now(), Date.now()]);
        else {
          if (typeof cb === 'function')
            cb.apply(this, arguments);
        }
      })
    }
  }

  var fs$writeFile = fs.writeFile;
  fs.writeFile = writeFile;
  function writeFile (path, data, options, cb) {
    if (typeof options === 'function')
      cb = options, options = null;

    return go$writeFile(path, data, options, cb)

    function go$writeFile (path, data, options, cb, startTime) {
      return fs$writeFile(path, data, options, function (err) {
        if (err && (err.code === 'EMFILE' || err.code === 'ENFILE'))
          enqueue([go$writeFile, [path, data, options, cb], err, startTime || Date.now(), Date.now()]);
        else {
          if (typeof cb === 'function')
            cb.apply(this, arguments);
        }
      })
    }
  }

  var fs$appendFile = fs.appendFile;
  if (fs$appendFile)
    fs.appendFile = appendFile;
  function appendFile (path, data, options, cb) {
    if (typeof options === 'function')
      cb = options, options = null;

    return go$appendFile(path, data, options, cb)

    function go$appendFile (path, data, options, cb, startTime) {
      return fs$appendFile(path, data, options, function (err) {
        if (err && (err.code === 'EMFILE' || err.code === 'ENFILE'))
          enqueue([go$appendFile, [path, data, options, cb], err, startTime || Date.now(), Date.now()]);
        else {
          if (typeof cb === 'function')
            cb.apply(this, arguments);
        }
      })
    }
  }

  var fs$copyFile = fs.copyFile;
  if (fs$copyFile)
    fs.copyFile = copyFile;
  function copyFile (src, dest, flags, cb) {
    if (typeof flags === 'function') {
      cb = flags;
      flags = 0;
    }
    return go$copyFile(src, dest, flags, cb)

    function go$copyFile (src, dest, flags, cb, startTime) {
      return fs$copyFile(src, dest, flags, function (err) {
        if (err && (err.code === 'EMFILE' || err.code === 'ENFILE'))
          enqueue([go$copyFile, [src, dest, flags, cb], err, startTime || Date.now(), Date.now()]);
        else {
          if (typeof cb === 'function')
            cb.apply(this, arguments);
        }
      })
    }
  }

  var fs$readdir = fs.readdir;
  fs.readdir = readdir;
  var noReaddirOptionVersions = /^v[0-5]\./;
  function readdir (path, options, cb) {
    if (typeof options === 'function')
      cb = options, options = null;

    var go$readdir = noReaddirOptionVersions.test(process.version)
      ? function go$readdir (path, options, cb, startTime) {
        return fs$readdir(path, fs$readdirCallback(
          path, options, cb, startTime
        ))
      }
      : function go$readdir (path, options, cb, startTime) {
        return fs$readdir(path, options, fs$readdirCallback(
          path, options, cb, startTime
        ))
      };

    return go$readdir(path, options, cb)

    function fs$readdirCallback (path, options, cb, startTime) {
      return function (err, files) {
        if (err && (err.code === 'EMFILE' || err.code === 'ENFILE'))
          enqueue([
            go$readdir,
            [path, options, cb],
            err,
            startTime || Date.now(),
            Date.now()
          ]);
        else {
          if (files && files.sort)
            files.sort();

          if (typeof cb === 'function')
            cb.call(this, err, files);
        }
      }
    }
  }

  if (process.version.substr(0, 4) === 'v0.8') {
    var legStreams = legacy$2(fs);
    ReadStream = legStreams.ReadStream;
    WriteStream = legStreams.WriteStream;
  }

  var fs$ReadStream = fs.ReadStream;
  if (fs$ReadStream) {
    ReadStream.prototype = Object.create(fs$ReadStream.prototype);
    ReadStream.prototype.open = ReadStream$open;
  }

  var fs$WriteStream = fs.WriteStream;
  if (fs$WriteStream) {
    WriteStream.prototype = Object.create(fs$WriteStream.prototype);
    WriteStream.prototype.open = WriteStream$open;
  }

  Object.defineProperty(fs, 'ReadStream', {
    get: function () {
      return ReadStream
    },
    set: function (val) {
      ReadStream = val;
    },
    enumerable: true,
    configurable: true
  });
  Object.defineProperty(fs, 'WriteStream', {
    get: function () {
      return WriteStream
    },
    set: function (val) {
      WriteStream = val;
    },
    enumerable: true,
    configurable: true
  });

  // legacy names
  var FileReadStream = ReadStream;
  Object.defineProperty(fs, 'FileReadStream', {
    get: function () {
      return FileReadStream
    },
    set: function (val) {
      FileReadStream = val;
    },
    enumerable: true,
    configurable: true
  });
  var FileWriteStream = WriteStream;
  Object.defineProperty(fs, 'FileWriteStream', {
    get: function () {
      return FileWriteStream
    },
    set: function (val) {
      FileWriteStream = val;
    },
    enumerable: true,
    configurable: true
  });

  function ReadStream (path, options) {
    if (this instanceof ReadStream)
      return fs$ReadStream.apply(this, arguments), this
    else
      return ReadStream.apply(Object.create(ReadStream.prototype), arguments)
  }

  function ReadStream$open () {
    var that = this;
    open(that.path, that.flags, that.mode, function (err, fd) {
      if (err) {
        if (that.autoClose)
          that.destroy();

        that.emit('error', err);
      } else {
        that.fd = fd;
        that.emit('open', fd);
        that.read();
      }
    });
  }

  function WriteStream (path, options) {
    if (this instanceof WriteStream)
      return fs$WriteStream.apply(this, arguments), this
    else
      return WriteStream.apply(Object.create(WriteStream.prototype), arguments)
  }

  function WriteStream$open () {
    var that = this;
    open(that.path, that.flags, that.mode, function (err, fd) {
      if (err) {
        that.destroy();
        that.emit('error', err);
      } else {
        that.fd = fd;
        that.emit('open', fd);
      }
    });
  }

  function createReadStream (path, options) {
    return new fs.ReadStream(path, options)
  }

  function createWriteStream (path, options) {
    return new fs.WriteStream(path, options)
  }

  var fs$open = fs.open;
  fs.open = open;
  function open (path, flags, mode, cb) {
    if (typeof mode === 'function')
      cb = mode, mode = null;

    return go$open(path, flags, mode, cb)

    function go$open (path, flags, mode, cb, startTime) {
      return fs$open(path, flags, mode, function (err, fd) {
        if (err && (err.code === 'EMFILE' || err.code === 'ENFILE'))
          enqueue([go$open, [path, flags, mode, cb], err, startTime || Date.now(), Date.now()]);
        else {
          if (typeof cb === 'function')
            cb.apply(this, arguments);
        }
      })
    }
  }

  return fs
}

function enqueue (elem) {
  debug$1('ENQUEUE', elem[0].name, elem[1]);
  fs$A[gracefulQueue].push(elem);
  retry();
}

// keep track of the timeout between retry() calls
var retryTimer;

// reset the startTime and lastTime to now
// this resets the start of the 60 second overall timeout as well as the
// delay between attempts so that we'll retry these jobs sooner
function resetQueue () {
  var now = Date.now();
  for (var i = 0; i < fs$A[gracefulQueue].length; ++i) {
    // entries that are only a length of 2 are from an older version, don't
    // bother modifying those since they'll be retried anyway.
    if (fs$A[gracefulQueue][i].length > 2) {
      fs$A[gracefulQueue][i][3] = now; // startTime
      fs$A[gracefulQueue][i][4] = now; // lastTime
    }
  }
  // call retry to make sure we're actively processing the queue
  retry();
}

function retry () {
  // clear the timer and remove it to help prevent unintended concurrency
  clearTimeout(retryTimer);
  retryTimer = undefined;

  if (fs$A[gracefulQueue].length === 0)
    return

  var elem = fs$A[gracefulQueue].shift();
  var fn = elem[0];
  var args = elem[1];
  // these items may be unset if they were added by an older graceful-fs
  var err = elem[2];
  var startTime = elem[3];
  var lastTime = elem[4];

  // if we don't have a startTime we have no way of knowing if we've waited
  // long enough, so go ahead and retry this item now
  if (startTime === undefined) {
    debug$1('RETRY', fn.name, args);
    fn.apply(null, args);
  } else if (Date.now() - startTime >= 60000) {
    // it's been more than 60 seconds total, bail now
    debug$1('TIMEOUT', fn.name, args);
    var cb = args.pop();
    if (typeof cb === 'function')
      cb.call(null, err);
  } else {
    // the amount of time between the last attempt and right now
    var sinceAttempt = Date.now() - lastTime;
    // the amount of time between when we first tried, and when we last tried
    // rounded up to at least 1
    var sinceStart = Math.max(lastTime - startTime, 1);
    // backoff. wait longer than the total time we've been retrying, but only
    // up to a maximum of 100ms
    var desiredDelay = Math.min(sinceStart * 1.2, 100);
    // it's been long enough since the last retry, do it again
    if (sinceAttempt >= desiredDelay) {
      debug$1('RETRY', fn.name, args);
      fn.apply(null, args.concat([startTime]));
    } else {
      // if we can't do this job yet, push it to the end of the queue
      // and let the next iteration check again
      fs$A[gracefulQueue].push(elem);
    }
  }

  // schedule our next run if one isn't already scheduled
  if (retryTimer === undefined) {
    retryTimer = setTimeout(retry, 0);
  }
}

(function (exports) {
	// This is adapted from https://github.com/normalize/mz
	// Copyright (c) 2014-2016 Jonathan Ong me@jongleberry.com and Contributors
	const u = universalify$1.fromCallback;
	const fs = gracefulFs;

	const api = [
	  'access',
	  'appendFile',
	  'chmod',
	  'chown',
	  'close',
	  'copyFile',
	  'fchmod',
	  'fchown',
	  'fdatasync',
	  'fstat',
	  'fsync',
	  'ftruncate',
	  'futimes',
	  'lchmod',
	  'lchown',
	  'link',
	  'lstat',
	  'mkdir',
	  'mkdtemp',
	  'open',
	  'opendir',
	  'readdir',
	  'readFile',
	  'readlink',
	  'realpath',
	  'rename',
	  'rm',
	  'rmdir',
	  'stat',
	  'symlink',
	  'truncate',
	  'unlink',
	  'utimes',
	  'writeFile'
	].filter(key => {
	  // Some commands are not available on some systems. Ex:
	  // fs.opendir was added in Node.js v12.12.0
	  // fs.rm was added in Node.js v14.14.0
	  // fs.lchown is not available on at least some Linux
	  return typeof fs[key] === 'function'
	});

	// Export cloned fs:
	Object.assign(exports, fs);

	// Universalify async methods:
	api.forEach(method => {
	  exports[method] = u(fs[method]);
	});

	// We differ from mz/fs in that we still ship the old, broken, fs.exists()
	// since we are a drop-in replacement for the native module
	exports.exists = function (filename, callback) {
	  if (typeof callback === 'function') {
	    return fs.exists(filename, callback)
	  }
	  return new Promise(resolve => {
	    return fs.exists(filename, resolve)
	  })
	};

	// fs.read(), fs.write(), & fs.writev() need special treatment due to multiple callback args

	exports.read = function (fd, buffer, offset, length, position, callback) {
	  if (typeof callback === 'function') {
	    return fs.read(fd, buffer, offset, length, position, callback)
	  }
	  return new Promise((resolve, reject) => {
	    fs.read(fd, buffer, offset, length, position, (err, bytesRead, buffer) => {
	      if (err) return reject(err)
	      resolve({ bytesRead, buffer });
	    });
	  })
	};

	// Function signature can be
	// fs.write(fd, buffer[, offset[, length[, position]]], callback)
	// OR
	// fs.write(fd, string[, position[, encoding]], callback)
	// We need to handle both cases, so we use ...args
	exports.write = function (fd, buffer, ...args) {
	  if (typeof args[args.length - 1] === 'function') {
	    return fs.write(fd, buffer, ...args)
	  }

	  return new Promise((resolve, reject) => {
	    fs.write(fd, buffer, ...args, (err, bytesWritten, buffer) => {
	      if (err) return reject(err)
	      resolve({ bytesWritten, buffer });
	    });
	  })
	};

	// fs.writev only available in Node v12.9.0+
	if (typeof fs.writev === 'function') {
	  // Function signature is
	  // s.writev(fd, buffers[, position], callback)
	  // We need to handle the optional arg, so we use ...args
	  exports.writev = function (fd, buffers, ...args) {
	    if (typeof args[args.length - 1] === 'function') {
	      return fs.writev(fd, buffers, ...args)
	    }

	    return new Promise((resolve, reject) => {
	      fs.writev(fd, buffers, ...args, (err, bytesWritten, buffers) => {
	        if (err) return reject(err)
	        resolve({ bytesWritten, buffers });
	      });
	    })
	  };
	}

	// fs.realpath.native sometimes not available if fs is monkey-patched
	if (typeof fs.realpath.native === 'function') {
	  exports.realpath.native = u(fs.realpath.native);
	} else {
	  process.emitWarning(
	    'fs.realpath.native is not a function. Is fs being monkey-patched?',
	    'Warning', 'fs-extra-WARN0003'
	  );
	} 
} (fs$B));

var makeDir$1 = {};

var utils$n = {};

const path$B = path__default["default"];

// https://github.com/nodejs/node/issues/8987
// https://github.com/libuv/libuv/pull/1088
utils$n.checkPath = function checkPath (pth) {
  if (process.platform === 'win32') {
    const pathHasInvalidWinCharacters = /[<>:"|?*]/.test(pth.replace(path$B.parse(pth).root, ''));

    if (pathHasInvalidWinCharacters) {
      const error = new Error(`Path contains invalid characters: ${pth}`);
      error.code = 'EINVAL';
      throw error
    }
  }
};

const fs$z = fs$B;
const { checkPath } = utils$n;

const getMode = options => {
  const defaults = { mode: 0o777 };
  if (typeof options === 'number') return options
  return ({ ...defaults, ...options }).mode
};

makeDir$1.makeDir = async (dir, options) => {
  checkPath(dir);

  return fs$z.mkdir(dir, {
    mode: getMode(options),
    recursive: true
  })
};

makeDir$1.makeDirSync = (dir, options) => {
  checkPath(dir);

  return fs$z.mkdirSync(dir, {
    mode: getMode(options),
    recursive: true
  })
};

const u$b = universalify$1.fromPromise;
const { makeDir: _makeDir, makeDirSync } = makeDir$1;
const makeDir = u$b(_makeDir);

var mkdirs$2 = {
  mkdirs: makeDir,
  mkdirsSync: makeDirSync,
  // alias
  mkdirp: makeDir,
  mkdirpSync: makeDirSync,
  ensureDir: makeDir,
  ensureDirSync: makeDirSync
};

const u$a = universalify$1.fromPromise;
const fs$y = fs$B;

function pathExists$6 (path) {
  return fs$y.access(path).then(() => true).catch(() => false)
}

var pathExists_1 = {
  pathExists: u$a(pathExists$6),
  pathExistsSync: fs$y.existsSync
};

const fs$x = gracefulFs;

function utimesMillis$1 (path, atime, mtime, callback) {
  // if (!HAS_MILLIS_RES) return fs.utimes(path, atime, mtime, callback)
  fs$x.open(path, 'r+', (err, fd) => {
    if (err) return callback(err)
    fs$x.futimes(fd, atime, mtime, futimesErr => {
      fs$x.close(fd, closeErr => {
        if (callback) callback(futimesErr || closeErr);
      });
    });
  });
}

function utimesMillisSync$1 (path, atime, mtime) {
  const fd = fs$x.openSync(path, 'r+');
  fs$x.futimesSync(fd, atime, mtime);
  return fs$x.closeSync(fd)
}

var utimes = {
  utimesMillis: utimesMillis$1,
  utimesMillisSync: utimesMillisSync$1
};

const fs$w = fs$B;
const path$A = path__default["default"];
const util$7 = require$$0__default$2["default"];

function getStats$2 (src, dest, opts) {
  const statFunc = opts.dereference
    ? (file) => fs$w.stat(file, { bigint: true })
    : (file) => fs$w.lstat(file, { bigint: true });
  return Promise.all([
    statFunc(src),
    statFunc(dest).catch(err => {
      if (err.code === 'ENOENT') return null
      throw err
    })
  ]).then(([srcStat, destStat]) => ({ srcStat, destStat }))
}

function getStatsSync (src, dest, opts) {
  let destStat;
  const statFunc = opts.dereference
    ? (file) => fs$w.statSync(file, { bigint: true })
    : (file) => fs$w.lstatSync(file, { bigint: true });
  const srcStat = statFunc(src);
  try {
    destStat = statFunc(dest);
  } catch (err) {
    if (err.code === 'ENOENT') return { srcStat, destStat: null }
    throw err
  }
  return { srcStat, destStat }
}

function checkPaths (src, dest, funcName, opts, cb) {
  util$7.callbackify(getStats$2)(src, dest, opts, (err, stats) => {
    if (err) return cb(err)
    const { srcStat, destStat } = stats;

    if (destStat) {
      if (areIdentical$2(srcStat, destStat)) {
        const srcBaseName = path$A.basename(src);
        const destBaseName = path$A.basename(dest);
        if (funcName === 'move' &&
          srcBaseName !== destBaseName &&
          srcBaseName.toLowerCase() === destBaseName.toLowerCase()) {
          return cb(null, { srcStat, destStat, isChangingCase: true })
        }
        return cb(new Error('Source and destination must not be the same.'))
      }
      if (srcStat.isDirectory() && !destStat.isDirectory()) {
        return cb(new Error(`Cannot overwrite non-directory '${dest}' with directory '${src}'.`))
      }
      if (!srcStat.isDirectory() && destStat.isDirectory()) {
        return cb(new Error(`Cannot overwrite directory '${dest}' with non-directory '${src}'.`))
      }
    }

    if (srcStat.isDirectory() && isSrcSubdir(src, dest)) {
      return cb(new Error(errMsg(src, dest, funcName)))
    }
    return cb(null, { srcStat, destStat })
  });
}

function checkPathsSync (src, dest, funcName, opts) {
  const { srcStat, destStat } = getStatsSync(src, dest, opts);

  if (destStat) {
    if (areIdentical$2(srcStat, destStat)) {
      const srcBaseName = path$A.basename(src);
      const destBaseName = path$A.basename(dest);
      if (funcName === 'move' &&
        srcBaseName !== destBaseName &&
        srcBaseName.toLowerCase() === destBaseName.toLowerCase()) {
        return { srcStat, destStat, isChangingCase: true }
      }
      throw new Error('Source and destination must not be the same.')
    }
    if (srcStat.isDirectory() && !destStat.isDirectory()) {
      throw new Error(`Cannot overwrite non-directory '${dest}' with directory '${src}'.`)
    }
    if (!srcStat.isDirectory() && destStat.isDirectory()) {
      throw new Error(`Cannot overwrite directory '${dest}' with non-directory '${src}'.`)
    }
  }

  if (srcStat.isDirectory() && isSrcSubdir(src, dest)) {
    throw new Error(errMsg(src, dest, funcName))
  }
  return { srcStat, destStat }
}

// recursively check if dest parent is a subdirectory of src.
// It works for all file types including symlinks since it
// checks the src and dest inodes. It starts from the deepest
// parent and stops once it reaches the src parent or the root path.
function checkParentPaths (src, srcStat, dest, funcName, cb) {
  const srcParent = path$A.resolve(path$A.dirname(src));
  const destParent = path$A.resolve(path$A.dirname(dest));
  if (destParent === srcParent || destParent === path$A.parse(destParent).root) return cb()
  fs$w.stat(destParent, { bigint: true }, (err, destStat) => {
    if (err) {
      if (err.code === 'ENOENT') return cb()
      return cb(err)
    }
    if (areIdentical$2(srcStat, destStat)) {
      return cb(new Error(errMsg(src, dest, funcName)))
    }
    return checkParentPaths(src, srcStat, destParent, funcName, cb)
  });
}

function checkParentPathsSync (src, srcStat, dest, funcName) {
  const srcParent = path$A.resolve(path$A.dirname(src));
  const destParent = path$A.resolve(path$A.dirname(dest));
  if (destParent === srcParent || destParent === path$A.parse(destParent).root) return
  let destStat;
  try {
    destStat = fs$w.statSync(destParent, { bigint: true });
  } catch (err) {
    if (err.code === 'ENOENT') return
    throw err
  }
  if (areIdentical$2(srcStat, destStat)) {
    throw new Error(errMsg(src, dest, funcName))
  }
  return checkParentPathsSync(src, srcStat, destParent, funcName)
}

function areIdentical$2 (srcStat, destStat) {
  return destStat.ino && destStat.dev && destStat.ino === srcStat.ino && destStat.dev === srcStat.dev
}

// return true if dest is a subdir of src, otherwise false.
// It only checks the path strings.
function isSrcSubdir (src, dest) {
  const srcArr = path$A.resolve(src).split(path$A.sep).filter(i => i);
  const destArr = path$A.resolve(dest).split(path$A.sep).filter(i => i);
  return srcArr.reduce((acc, cur, i) => acc && destArr[i] === cur, true)
}

function errMsg (src, dest, funcName) {
  return `Cannot ${funcName} '${src}' to a subdirectory of itself, '${dest}'.`
}

var stat$5 = {
  checkPaths,
  checkPathsSync,
  checkParentPaths,
  checkParentPathsSync,
  isSrcSubdir,
  areIdentical: areIdentical$2
};

const fs$v = gracefulFs;
const path$z = path__default["default"];
const mkdirs$1 = mkdirs$2.mkdirs;
const pathExists$5 = pathExists_1.pathExists;
const utimesMillis = utimes.utimesMillis;
const stat$4 = stat$5;

function copy$4 (src, dest, opts, cb) {
  if (typeof opts === 'function' && !cb) {
    cb = opts;
    opts = {};
  } else if (typeof opts === 'function') {
    opts = { filter: opts };
  }

  cb = cb || function () {};
  opts = opts || {};

  opts.clobber = 'clobber' in opts ? !!opts.clobber : true; // default to true for now
  opts.overwrite = 'overwrite' in opts ? !!opts.overwrite : opts.clobber; // overwrite falls back to clobber

  // Warn about using preserveTimestamps on 32-bit node
  if (opts.preserveTimestamps && process.arch === 'ia32') {
    process.emitWarning(
      'Using the preserveTimestamps option in 32-bit node is not recommended;\n\n' +
      '\tsee https://github.com/jprichardson/node-fs-extra/issues/269',
      'Warning', 'fs-extra-WARN0001'
    );
  }

  stat$4.checkPaths(src, dest, 'copy', opts, (err, stats) => {
    if (err) return cb(err)
    const { srcStat, destStat } = stats;
    stat$4.checkParentPaths(src, srcStat, dest, 'copy', err => {
      if (err) return cb(err)
      if (opts.filter) return handleFilter(checkParentDir, destStat, src, dest, opts, cb)
      return checkParentDir(destStat, src, dest, opts, cb)
    });
  });
}

function checkParentDir (destStat, src, dest, opts, cb) {
  const destParent = path$z.dirname(dest);
  pathExists$5(destParent, (err, dirExists) => {
    if (err) return cb(err)
    if (dirExists) return getStats$1(destStat, src, dest, opts, cb)
    mkdirs$1(destParent, err => {
      if (err) return cb(err)
      return getStats$1(destStat, src, dest, opts, cb)
    });
  });
}

function handleFilter (onInclude, destStat, src, dest, opts, cb) {
  Promise.resolve(opts.filter(src, dest)).then(include => {
    if (include) return onInclude(destStat, src, dest, opts, cb)
    return cb()
  }, error => cb(error));
}

function startCopy$1 (destStat, src, dest, opts, cb) {
  if (opts.filter) return handleFilter(getStats$1, destStat, src, dest, opts, cb)
  return getStats$1(destStat, src, dest, opts, cb)
}

function getStats$1 (destStat, src, dest, opts, cb) {
  const stat = opts.dereference ? fs$v.stat : fs$v.lstat;
  stat(src, (err, srcStat) => {
    if (err) return cb(err)

    if (srcStat.isDirectory()) return onDir$1(srcStat, destStat, src, dest, opts, cb)
    else if (srcStat.isFile() ||
             srcStat.isCharacterDevice() ||
             srcStat.isBlockDevice()) return onFile$1(srcStat, destStat, src, dest, opts, cb)
    else if (srcStat.isSymbolicLink()) return onLink$1(destStat, src, dest, opts, cb)
    else if (srcStat.isSocket()) return cb(new Error(`Cannot copy a socket file: ${src}`))
    else if (srcStat.isFIFO()) return cb(new Error(`Cannot copy a FIFO pipe: ${src}`))
    return cb(new Error(`Unknown file: ${src}`))
  });
}

function onFile$1 (srcStat, destStat, src, dest, opts, cb) {
  if (!destStat) return copyFile$1(srcStat, src, dest, opts, cb)
  return mayCopyFile$1(srcStat, src, dest, opts, cb)
}

function mayCopyFile$1 (srcStat, src, dest, opts, cb) {
  if (opts.overwrite) {
    fs$v.unlink(dest, err => {
      if (err) return cb(err)
      return copyFile$1(srcStat, src, dest, opts, cb)
    });
  } else if (opts.errorOnExist) {
    return cb(new Error(`'${dest}' already exists`))
  } else return cb()
}

function copyFile$1 (srcStat, src, dest, opts, cb) {
  fs$v.copyFile(src, dest, err => {
    if (err) return cb(err)
    if (opts.preserveTimestamps) return handleTimestampsAndMode(srcStat.mode, src, dest, cb)
    return setDestMode$1(dest, srcStat.mode, cb)
  });
}

function handleTimestampsAndMode (srcMode, src, dest, cb) {
  // Make sure the file is writable before setting the timestamp
  // otherwise open fails with EPERM when invoked with 'r+'
  // (through utimes call)
  if (fileIsNotWritable$1(srcMode)) {
    return makeFileWritable$1(dest, srcMode, err => {
      if (err) return cb(err)
      return setDestTimestampsAndMode(srcMode, src, dest, cb)
    })
  }
  return setDestTimestampsAndMode(srcMode, src, dest, cb)
}

function fileIsNotWritable$1 (srcMode) {
  return (srcMode & 0o200) === 0
}

function makeFileWritable$1 (dest, srcMode, cb) {
  return setDestMode$1(dest, srcMode | 0o200, cb)
}

function setDestTimestampsAndMode (srcMode, src, dest, cb) {
  setDestTimestamps$1(src, dest, err => {
    if (err) return cb(err)
    return setDestMode$1(dest, srcMode, cb)
  });
}

function setDestMode$1 (dest, srcMode, cb) {
  return fs$v.chmod(dest, srcMode, cb)
}

function setDestTimestamps$1 (src, dest, cb) {
  // The initial srcStat.atime cannot be trusted
  // because it is modified by the read(2) system call
  // (See https://nodejs.org/api/fs.html#fs_stat_time_values)
  fs$v.stat(src, (err, updatedSrcStat) => {
    if (err) return cb(err)
    return utimesMillis(dest, updatedSrcStat.atime, updatedSrcStat.mtime, cb)
  });
}

function onDir$1 (srcStat, destStat, src, dest, opts, cb) {
  if (!destStat) return mkDirAndCopy$1(srcStat.mode, src, dest, opts, cb)
  return copyDir$1(src, dest, opts, cb)
}

function mkDirAndCopy$1 (srcMode, src, dest, opts, cb) {
  fs$v.mkdir(dest, err => {
    if (err) return cb(err)
    copyDir$1(src, dest, opts, err => {
      if (err) return cb(err)
      return setDestMode$1(dest, srcMode, cb)
    });
  });
}

function copyDir$1 (src, dest, opts, cb) {
  fs$v.readdir(src, (err, items) => {
    if (err) return cb(err)
    return copyDirItems(items, src, dest, opts, cb)
  });
}

function copyDirItems (items, src, dest, opts, cb) {
  const item = items.pop();
  if (!item) return cb()
  return copyDirItem$1(items, item, src, dest, opts, cb)
}

function copyDirItem$1 (items, item, src, dest, opts, cb) {
  const srcItem = path$z.join(src, item);
  const destItem = path$z.join(dest, item);
  stat$4.checkPaths(srcItem, destItem, 'copy', opts, (err, stats) => {
    if (err) return cb(err)
    const { destStat } = stats;
    startCopy$1(destStat, srcItem, destItem, opts, err => {
      if (err) return cb(err)
      return copyDirItems(items, src, dest, opts, cb)
    });
  });
}

function onLink$1 (destStat, src, dest, opts, cb) {
  fs$v.readlink(src, (err, resolvedSrc) => {
    if (err) return cb(err)
    if (opts.dereference) {
      resolvedSrc = path$z.resolve(process.cwd(), resolvedSrc);
    }

    if (!destStat) {
      return fs$v.symlink(resolvedSrc, dest, cb)
    } else {
      fs$v.readlink(dest, (err, resolvedDest) => {
        if (err) {
          // dest exists and is a regular file or directory,
          // Windows may throw UNKNOWN error. If dest already exists,
          // fs throws error anyway, so no need to guard against it here.
          if (err.code === 'EINVAL' || err.code === 'UNKNOWN') return fs$v.symlink(resolvedSrc, dest, cb)
          return cb(err)
        }
        if (opts.dereference) {
          resolvedDest = path$z.resolve(process.cwd(), resolvedDest);
        }
        if (stat$4.isSrcSubdir(resolvedSrc, resolvedDest)) {
          return cb(new Error(`Cannot copy '${resolvedSrc}' to a subdirectory of itself, '${resolvedDest}'.`))
        }

        // do not copy if src is a subdir of dest since unlinking
        // dest in this case would result in removing src contents
        // and therefore a broken symlink would be created.
        if (destStat.isDirectory() && stat$4.isSrcSubdir(resolvedDest, resolvedSrc)) {
          return cb(new Error(`Cannot overwrite '${resolvedDest}' with '${resolvedSrc}'.`))
        }
        return copyLink$1(resolvedSrc, dest, cb)
      });
    }
  });
}

function copyLink$1 (resolvedSrc, dest, cb) {
  fs$v.unlink(dest, err => {
    if (err) return cb(err)
    return fs$v.symlink(resolvedSrc, dest, cb)
  });
}

var copy_1 = copy$4;

const fs$u = gracefulFs;
const path$y = path__default["default"];
const mkdirsSync$1 = mkdirs$2.mkdirsSync;
const utimesMillisSync = utimes.utimesMillisSync;
const stat$3 = stat$5;

function copySync$1 (src, dest, opts) {
  if (typeof opts === 'function') {
    opts = { filter: opts };
  }

  opts = opts || {};
  opts.clobber = 'clobber' in opts ? !!opts.clobber : true; // default to true for now
  opts.overwrite = 'overwrite' in opts ? !!opts.overwrite : opts.clobber; // overwrite falls back to clobber

  // Warn about using preserveTimestamps on 32-bit node
  if (opts.preserveTimestamps && process.arch === 'ia32') {
    process.emitWarning(
      'Using the preserveTimestamps option in 32-bit node is not recommended;\n\n' +
      '\tsee https://github.com/jprichardson/node-fs-extra/issues/269',
      'Warning', 'fs-extra-WARN0002'
    );
  }

  const { srcStat, destStat } = stat$3.checkPathsSync(src, dest, 'copy', opts);
  stat$3.checkParentPathsSync(src, srcStat, dest, 'copy');
  return handleFilterAndCopy(destStat, src, dest, opts)
}

function handleFilterAndCopy (destStat, src, dest, opts) {
  if (opts.filter && !opts.filter(src, dest)) return
  const destParent = path$y.dirname(dest);
  if (!fs$u.existsSync(destParent)) mkdirsSync$1(destParent);
  return getStats(destStat, src, dest, opts)
}

function startCopy (destStat, src, dest, opts) {
  if (opts.filter && !opts.filter(src, dest)) return
  return getStats(destStat, src, dest, opts)
}

function getStats (destStat, src, dest, opts) {
  const statSync = opts.dereference ? fs$u.statSync : fs$u.lstatSync;
  const srcStat = statSync(src);

  if (srcStat.isDirectory()) return onDir(srcStat, destStat, src, dest, opts)
  else if (srcStat.isFile() ||
           srcStat.isCharacterDevice() ||
           srcStat.isBlockDevice()) return onFile(srcStat, destStat, src, dest, opts)
  else if (srcStat.isSymbolicLink()) return onLink(destStat, src, dest, opts)
  else if (srcStat.isSocket()) throw new Error(`Cannot copy a socket file: ${src}`)
  else if (srcStat.isFIFO()) throw new Error(`Cannot copy a FIFO pipe: ${src}`)
  throw new Error(`Unknown file: ${src}`)
}

function onFile (srcStat, destStat, src, dest, opts) {
  if (!destStat) return copyFile(srcStat, src, dest, opts)
  return mayCopyFile(srcStat, src, dest, opts)
}

function mayCopyFile (srcStat, src, dest, opts) {
  if (opts.overwrite) {
    fs$u.unlinkSync(dest);
    return copyFile(srcStat, src, dest, opts)
  } else if (opts.errorOnExist) {
    throw new Error(`'${dest}' already exists`)
  }
}

function copyFile (srcStat, src, dest, opts) {
  fs$u.copyFileSync(src, dest);
  if (opts.preserveTimestamps) handleTimestamps(srcStat.mode, src, dest);
  return setDestMode(dest, srcStat.mode)
}

function handleTimestamps (srcMode, src, dest) {
  // Make sure the file is writable before setting the timestamp
  // otherwise open fails with EPERM when invoked with 'r+'
  // (through utimes call)
  if (fileIsNotWritable(srcMode)) makeFileWritable(dest, srcMode);
  return setDestTimestamps(src, dest)
}

function fileIsNotWritable (srcMode) {
  return (srcMode & 0o200) === 0
}

function makeFileWritable (dest, srcMode) {
  return setDestMode(dest, srcMode | 0o200)
}

function setDestMode (dest, srcMode) {
  return fs$u.chmodSync(dest, srcMode)
}

function setDestTimestamps (src, dest) {
  // The initial srcStat.atime cannot be trusted
  // because it is modified by the read(2) system call
  // (See https://nodejs.org/api/fs.html#fs_stat_time_values)
  const updatedSrcStat = fs$u.statSync(src);
  return utimesMillisSync(dest, updatedSrcStat.atime, updatedSrcStat.mtime)
}

function onDir (srcStat, destStat, src, dest, opts) {
  if (!destStat) return mkDirAndCopy(srcStat.mode, src, dest, opts)
  return copyDir(src, dest, opts)
}

function mkDirAndCopy (srcMode, src, dest, opts) {
  fs$u.mkdirSync(dest);
  copyDir(src, dest, opts);
  return setDestMode(dest, srcMode)
}

function copyDir (src, dest, opts) {
  fs$u.readdirSync(src).forEach(item => copyDirItem(item, src, dest, opts));
}

function copyDirItem (item, src, dest, opts) {
  const srcItem = path$y.join(src, item);
  const destItem = path$y.join(dest, item);
  const { destStat } = stat$3.checkPathsSync(srcItem, destItem, 'copy', opts);
  return startCopy(destStat, srcItem, destItem, opts)
}

function onLink (destStat, src, dest, opts) {
  let resolvedSrc = fs$u.readlinkSync(src);
  if (opts.dereference) {
    resolvedSrc = path$y.resolve(process.cwd(), resolvedSrc);
  }

  if (!destStat) {
    return fs$u.symlinkSync(resolvedSrc, dest)
  } else {
    let resolvedDest;
    try {
      resolvedDest = fs$u.readlinkSync(dest);
    } catch (err) {
      // dest exists and is a regular file or directory,
      // Windows may throw UNKNOWN error. If dest already exists,
      // fs throws error anyway, so no need to guard against it here.
      if (err.code === 'EINVAL' || err.code === 'UNKNOWN') return fs$u.symlinkSync(resolvedSrc, dest)
      throw err
    }
    if (opts.dereference) {
      resolvedDest = path$y.resolve(process.cwd(), resolvedDest);
    }
    if (stat$3.isSrcSubdir(resolvedSrc, resolvedDest)) {
      throw new Error(`Cannot copy '${resolvedSrc}' to a subdirectory of itself, '${resolvedDest}'.`)
    }

    // prevent copy if src is a subdir of dest since unlinking
    // dest in this case would result in removing src contents
    // and therefore a broken symlink would be created.
    if (fs$u.statSync(dest).isDirectory() && stat$3.isSrcSubdir(resolvedDest, resolvedSrc)) {
      throw new Error(`Cannot overwrite '${resolvedDest}' with '${resolvedSrc}'.`)
    }
    return copyLink(resolvedSrc, dest)
  }
}

function copyLink (resolvedSrc, dest) {
  fs$u.unlinkSync(dest);
  return fs$u.symlinkSync(resolvedSrc, dest)
}

var copySync_1 = copySync$1;

const u$9 = universalify$1.fromCallback;
var copy$3 = {
  copy: u$9(copy_1),
  copySync: copySync_1
};

const fs$t = gracefulFs;
const path$x = path__default["default"];
const assert$2 = require$$0__default$5["default"];

const isWindows$3 = (process.platform === 'win32');

function defaults$2 (options) {
  const methods = [
    'unlink',
    'chmod',
    'stat',
    'lstat',
    'rmdir',
    'readdir'
  ];
  methods.forEach(m => {
    options[m] = options[m] || fs$t[m];
    m = m + 'Sync';
    options[m] = options[m] || fs$t[m];
  });

  options.maxBusyTries = options.maxBusyTries || 3;
}

function rimraf$1 (p, options, cb) {
  let busyTries = 0;

  if (typeof options === 'function') {
    cb = options;
    options = {};
  }

  assert$2(p, 'rimraf: missing path');
  assert$2.strictEqual(typeof p, 'string', 'rimraf: path should be a string');
  assert$2.strictEqual(typeof cb, 'function', 'rimraf: callback function required');
  assert$2(options, 'rimraf: invalid options argument provided');
  assert$2.strictEqual(typeof options, 'object', 'rimraf: options should be object');

  defaults$2(options);

  rimraf_(p, options, function CB (er) {
    if (er) {
      if ((er.code === 'EBUSY' || er.code === 'ENOTEMPTY' || er.code === 'EPERM') &&
          busyTries < options.maxBusyTries) {
        busyTries++;
        const time = busyTries * 100;
        // try again, with the same exact callback as this one.
        return setTimeout(() => rimraf_(p, options, CB), time)
      }

      // already gone
      if (er.code === 'ENOENT') er = null;
    }

    cb(er);
  });
}

// Two possible strategies.
// 1. Assume it's a file.  unlink it, then do the dir stuff on EPERM or EISDIR
// 2. Assume it's a directory.  readdir, then do the file stuff on ENOTDIR
//
// Both result in an extra syscall when you guess wrong.  However, there
// are likely far more normal files in the world than directories.  This
// is based on the assumption that a the average number of files per
// directory is >= 1.
//
// If anyone ever complains about this, then I guess the strategy could
// be made configurable somehow.  But until then, YAGNI.
function rimraf_ (p, options, cb) {
  assert$2(p);
  assert$2(options);
  assert$2(typeof cb === 'function');

  // sunos lets the root user unlink directories, which is... weird.
  // so we have to lstat here and make sure it's not a dir.
  options.lstat(p, (er, st) => {
    if (er && er.code === 'ENOENT') {
      return cb(null)
    }

    // Windows can EPERM on stat.  Life is suffering.
    if (er && er.code === 'EPERM' && isWindows$3) {
      return fixWinEPERM(p, options, er, cb)
    }

    if (st && st.isDirectory()) {
      return rmdir(p, options, er, cb)
    }

    options.unlink(p, er => {
      if (er) {
        if (er.code === 'ENOENT') {
          return cb(null)
        }
        if (er.code === 'EPERM') {
          return (isWindows$3)
            ? fixWinEPERM(p, options, er, cb)
            : rmdir(p, options, er, cb)
        }
        if (er.code === 'EISDIR') {
          return rmdir(p, options, er, cb)
        }
      }
      return cb(er)
    });
  });
}

function fixWinEPERM (p, options, er, cb) {
  assert$2(p);
  assert$2(options);
  assert$2(typeof cb === 'function');

  options.chmod(p, 0o666, er2 => {
    if (er2) {
      cb(er2.code === 'ENOENT' ? null : er);
    } else {
      options.stat(p, (er3, stats) => {
        if (er3) {
          cb(er3.code === 'ENOENT' ? null : er);
        } else if (stats.isDirectory()) {
          rmdir(p, options, er, cb);
        } else {
          options.unlink(p, cb);
        }
      });
    }
  });
}

function fixWinEPERMSync (p, options, er) {
  let stats;

  assert$2(p);
  assert$2(options);

  try {
    options.chmodSync(p, 0o666);
  } catch (er2) {
    if (er2.code === 'ENOENT') {
      return
    } else {
      throw er
    }
  }

  try {
    stats = options.statSync(p);
  } catch (er3) {
    if (er3.code === 'ENOENT') {
      return
    } else {
      throw er
    }
  }

  if (stats.isDirectory()) {
    rmdirSync(p, options, er);
  } else {
    options.unlinkSync(p);
  }
}

function rmdir (p, options, originalEr, cb) {
  assert$2(p);
  assert$2(options);
  assert$2(typeof cb === 'function');

  // try to rmdir first, and only readdir on ENOTEMPTY or EEXIST (SunOS)
  // if we guessed wrong, and it's not a directory, then
  // raise the original error.
  options.rmdir(p, er => {
    if (er && (er.code === 'ENOTEMPTY' || er.code === 'EEXIST' || er.code === 'EPERM')) {
      rmkids(p, options, cb);
    } else if (er && er.code === 'ENOTDIR') {
      cb(originalEr);
    } else {
      cb(er);
    }
  });
}

function rmkids (p, options, cb) {
  assert$2(p);
  assert$2(options);
  assert$2(typeof cb === 'function');

  options.readdir(p, (er, files) => {
    if (er) return cb(er)

    let n = files.length;
    let errState;

    if (n === 0) return options.rmdir(p, cb)

    files.forEach(f => {
      rimraf$1(path$x.join(p, f), options, er => {
        if (errState) {
          return
        }
        if (er) return cb(errState = er)
        if (--n === 0) {
          options.rmdir(p, cb);
        }
      });
    });
  });
}

// this looks simpler, and is strictly *faster*, but will
// tie up the JavaScript thread and fail on excessively
// deep directory trees.
function rimrafSync (p, options) {
  let st;

  options = options || {};
  defaults$2(options);

  assert$2(p, 'rimraf: missing path');
  assert$2.strictEqual(typeof p, 'string', 'rimraf: path should be a string');
  assert$2(options, 'rimraf: missing options');
  assert$2.strictEqual(typeof options, 'object', 'rimraf: options should be object');

  try {
    st = options.lstatSync(p);
  } catch (er) {
    if (er.code === 'ENOENT') {
      return
    }

    // Windows can EPERM on stat.  Life is suffering.
    if (er.code === 'EPERM' && isWindows$3) {
      fixWinEPERMSync(p, options, er);
    }
  }

  try {
    // sunos lets the root user unlink directories, which is... weird.
    if (st && st.isDirectory()) {
      rmdirSync(p, options, null);
    } else {
      options.unlinkSync(p);
    }
  } catch (er) {
    if (er.code === 'ENOENT') {
      return
    } else if (er.code === 'EPERM') {
      return isWindows$3 ? fixWinEPERMSync(p, options, er) : rmdirSync(p, options, er)
    } else if (er.code !== 'EISDIR') {
      throw er
    }
    rmdirSync(p, options, er);
  }
}

function rmdirSync (p, options, originalEr) {
  assert$2(p);
  assert$2(options);

  try {
    options.rmdirSync(p);
  } catch (er) {
    if (er.code === 'ENOTDIR') {
      throw originalEr
    } else if (er.code === 'ENOTEMPTY' || er.code === 'EEXIST' || er.code === 'EPERM') {
      rmkidsSync(p, options);
    } else if (er.code !== 'ENOENT') {
      throw er
    }
  }
}

function rmkidsSync (p, options) {
  assert$2(p);
  assert$2(options);
  options.readdirSync(p).forEach(f => rimrafSync(path$x.join(p, f), options));

  if (isWindows$3) {
    // We only end up here once we got ENOTEMPTY at least once, and
    // at this point, we are guaranteed to have removed all the kids.
    // So, we know that it won't be ENOENT or ENOTDIR or anything else.
    // try really hard to delete stuff on windows, because it has a
    // PROFOUNDLY annoying habit of not closing handles promptly when
    // files are deleted, resulting in spurious ENOTEMPTY errors.
    const startTime = Date.now();
    do {
      try {
        const ret = options.rmdirSync(p, options);
        return ret
      } catch {}
    } while (Date.now() - startTime < 500) // give up after 500ms
  } else {
    const ret = options.rmdirSync(p, options);
    return ret
  }
}

var rimraf_1 = rimraf$1;
rimraf$1.sync = rimrafSync;

const fs$s = gracefulFs;
const u$8 = universalify$1.fromCallback;
const rimraf = rimraf_1;

function remove$2 (path, callback) {
  // Node 14.14.0+
  if (fs$s.rm) return fs$s.rm(path, { recursive: true, force: true }, callback)
  rimraf(path, callback);
}

function removeSync$1 (path) {
  // Node 14.14.0+
  if (fs$s.rmSync) return fs$s.rmSync(path, { recursive: true, force: true })
  rimraf.sync(path);
}

var remove_1 = {
  remove: u$8(remove$2),
  removeSync: removeSync$1
};

const u$7 = universalify$1.fromPromise;
const fs$r = fs$B;
const path$w = path__default["default"];
const mkdir$3 = mkdirs$2;
const remove$1 = remove_1;

const emptyDir = u$7(async function emptyDir (dir) {
  let items;
  try {
    items = await fs$r.readdir(dir);
  } catch {
    return mkdir$3.mkdirs(dir)
  }

  return Promise.all(items.map(item => remove$1.remove(path$w.join(dir, item))))
});

function emptyDirSync (dir) {
  let items;
  try {
    items = fs$r.readdirSync(dir);
  } catch {
    return mkdir$3.mkdirsSync(dir)
  }

  items.forEach(item => {
    item = path$w.join(dir, item);
    remove$1.removeSync(item);
  });
}

var empty$2 = {
  emptyDirSync,
  emptydirSync: emptyDirSync,
  emptyDir,
  emptydir: emptyDir
};

const u$6 = universalify$1.fromCallback;
const path$v = path__default["default"];
const fs$q = gracefulFs;
const mkdir$2 = mkdirs$2;

function createFile$1 (file, callback) {
  function makeFile () {
    fs$q.writeFile(file, '', err => {
      if (err) return callback(err)
      callback();
    });
  }

  fs$q.stat(file, (err, stats) => { // eslint-disable-line handle-callback-err
    if (!err && stats.isFile()) return callback()
    const dir = path$v.dirname(file);
    fs$q.stat(dir, (err, stats) => {
      if (err) {
        // if the directory doesn't exist, make it
        if (err.code === 'ENOENT') {
          return mkdir$2.mkdirs(dir, err => {
            if (err) return callback(err)
            makeFile();
          })
        }
        return callback(err)
      }

      if (stats.isDirectory()) makeFile();
      else {
        // parent is not a directory
        // This is just to cause an internal ENOTDIR error to be thrown
        fs$q.readdir(dir, err => {
          if (err) return callback(err)
        });
      }
    });
  });
}

function createFileSync$1 (file) {
  let stats;
  try {
    stats = fs$q.statSync(file);
  } catch {}
  if (stats && stats.isFile()) return

  const dir = path$v.dirname(file);
  try {
    if (!fs$q.statSync(dir).isDirectory()) {
      // parent is not a directory
      // This is just to cause an internal ENOTDIR error to be thrown
      fs$q.readdirSync(dir);
    }
  } catch (err) {
    // If the stat call above failed because the directory doesn't exist, create it
    if (err && err.code === 'ENOENT') mkdir$2.mkdirsSync(dir);
    else throw err
  }

  fs$q.writeFileSync(file, '');
}

var file$1 = {
  createFile: u$6(createFile$1),
  createFileSync: createFileSync$1
};

const u$5 = universalify$1.fromCallback;
const path$u = path__default["default"];
const fs$p = gracefulFs;
const mkdir$1 = mkdirs$2;
const pathExists$4 = pathExists_1.pathExists;
const { areIdentical: areIdentical$1 } = stat$5;

function createLink$1 (srcpath, dstpath, callback) {
  function makeLink (srcpath, dstpath) {
    fs$p.link(srcpath, dstpath, err => {
      if (err) return callback(err)
      callback(null);
    });
  }

  fs$p.lstat(dstpath, (_, dstStat) => {
    fs$p.lstat(srcpath, (err, srcStat) => {
      if (err) {
        err.message = err.message.replace('lstat', 'ensureLink');
        return callback(err)
      }
      if (dstStat && areIdentical$1(srcStat, dstStat)) return callback(null)

      const dir = path$u.dirname(dstpath);
      pathExists$4(dir, (err, dirExists) => {
        if (err) return callback(err)
        if (dirExists) return makeLink(srcpath, dstpath)
        mkdir$1.mkdirs(dir, err => {
          if (err) return callback(err)
          makeLink(srcpath, dstpath);
        });
      });
    });
  });
}

function createLinkSync$1 (srcpath, dstpath) {
  let dstStat;
  try {
    dstStat = fs$p.lstatSync(dstpath);
  } catch {}

  try {
    const srcStat = fs$p.lstatSync(srcpath);
    if (dstStat && areIdentical$1(srcStat, dstStat)) return
  } catch (err) {
    err.message = err.message.replace('lstat', 'ensureLink');
    throw err
  }

  const dir = path$u.dirname(dstpath);
  const dirExists = fs$p.existsSync(dir);
  if (dirExists) return fs$p.linkSync(srcpath, dstpath)
  mkdir$1.mkdirsSync(dir);

  return fs$p.linkSync(srcpath, dstpath)
}

var link = {
  createLink: u$5(createLink$1),
  createLinkSync: createLinkSync$1
};

const path$t = path__default["default"];
const fs$o = gracefulFs;
const pathExists$3 = pathExists_1.pathExists;

/**
 * Function that returns two types of paths, one relative to symlink, and one
 * relative to the current working directory. Checks if path is absolute or
 * relative. If the path is relative, this function checks if the path is
 * relative to symlink or relative to current working directory. This is an
 * initiative to find a smarter `srcpath` to supply when building symlinks.
 * This allows you to determine which path to use out of one of three possible
 * types of source paths. The first is an absolute path. This is detected by
 * `path.isAbsolute()`. When an absolute path is provided, it is checked to
 * see if it exists. If it does it's used, if not an error is returned
 * (callback)/ thrown (sync). The other two options for `srcpath` are a
 * relative url. By default Node's `fs.symlink` works by creating a symlink
 * using `dstpath` and expects the `srcpath` to be relative to the newly
 * created symlink. If you provide a `srcpath` that does not exist on the file
 * system it results in a broken symlink. To minimize this, the function
 * checks to see if the 'relative to symlink' source file exists, and if it
 * does it will use it. If it does not, it checks if there's a file that
 * exists that is relative to the current working directory, if does its used.
 * This preserves the expectations of the original fs.symlink spec and adds
 * the ability to pass in `relative to current working direcotry` paths.
 */

function symlinkPaths$1 (srcpath, dstpath, callback) {
  if (path$t.isAbsolute(srcpath)) {
    return fs$o.lstat(srcpath, (err) => {
      if (err) {
        err.message = err.message.replace('lstat', 'ensureSymlink');
        return callback(err)
      }
      return callback(null, {
        toCwd: srcpath,
        toDst: srcpath
      })
    })
  } else {
    const dstdir = path$t.dirname(dstpath);
    const relativeToDst = path$t.join(dstdir, srcpath);
    return pathExists$3(relativeToDst, (err, exists) => {
      if (err) return callback(err)
      if (exists) {
        return callback(null, {
          toCwd: relativeToDst,
          toDst: srcpath
        })
      } else {
        return fs$o.lstat(srcpath, (err) => {
          if (err) {
            err.message = err.message.replace('lstat', 'ensureSymlink');
            return callback(err)
          }
          return callback(null, {
            toCwd: srcpath,
            toDst: path$t.relative(dstdir, srcpath)
          })
        })
      }
    })
  }
}

function symlinkPathsSync$1 (srcpath, dstpath) {
  let exists;
  if (path$t.isAbsolute(srcpath)) {
    exists = fs$o.existsSync(srcpath);
    if (!exists) throw new Error('absolute srcpath does not exist')
    return {
      toCwd: srcpath,
      toDst: srcpath
    }
  } else {
    const dstdir = path$t.dirname(dstpath);
    const relativeToDst = path$t.join(dstdir, srcpath);
    exists = fs$o.existsSync(relativeToDst);
    if (exists) {
      return {
        toCwd: relativeToDst,
        toDst: srcpath
      }
    } else {
      exists = fs$o.existsSync(srcpath);
      if (!exists) throw new Error('relative srcpath does not exist')
      return {
        toCwd: srcpath,
        toDst: path$t.relative(dstdir, srcpath)
      }
    }
  }
}

var symlinkPaths_1 = {
  symlinkPaths: symlinkPaths$1,
  symlinkPathsSync: symlinkPathsSync$1
};

const fs$n = gracefulFs;

function symlinkType$1 (srcpath, type, callback) {
  callback = (typeof type === 'function') ? type : callback;
  type = (typeof type === 'function') ? false : type;
  if (type) return callback(null, type)
  fs$n.lstat(srcpath, (err, stats) => {
    if (err) return callback(null, 'file')
    type = (stats && stats.isDirectory()) ? 'dir' : 'file';
    callback(null, type);
  });
}

function symlinkTypeSync$1 (srcpath, type) {
  let stats;

  if (type) return type
  try {
    stats = fs$n.lstatSync(srcpath);
  } catch {
    return 'file'
  }
  return (stats && stats.isDirectory()) ? 'dir' : 'file'
}

var symlinkType_1 = {
  symlinkType: symlinkType$1,
  symlinkTypeSync: symlinkTypeSync$1
};

const u$4 = universalify$1.fromCallback;
const path$s = path__default["default"];
const fs$m = fs$B;
const _mkdirs = mkdirs$2;
const mkdirs = _mkdirs.mkdirs;
const mkdirsSync = _mkdirs.mkdirsSync;

const _symlinkPaths = symlinkPaths_1;
const symlinkPaths = _symlinkPaths.symlinkPaths;
const symlinkPathsSync = _symlinkPaths.symlinkPathsSync;

const _symlinkType = symlinkType_1;
const symlinkType = _symlinkType.symlinkType;
const symlinkTypeSync = _symlinkType.symlinkTypeSync;

const pathExists$2 = pathExists_1.pathExists;

const { areIdentical } = stat$5;

function createSymlink$1 (srcpath, dstpath, type, callback) {
  callback = (typeof type === 'function') ? type : callback;
  type = (typeof type === 'function') ? false : type;

  fs$m.lstat(dstpath, (err, stats) => {
    if (!err && stats.isSymbolicLink()) {
      Promise.all([
        fs$m.stat(srcpath),
        fs$m.stat(dstpath)
      ]).then(([srcStat, dstStat]) => {
        if (areIdentical(srcStat, dstStat)) return callback(null)
        _createSymlink(srcpath, dstpath, type, callback);
      });
    } else _createSymlink(srcpath, dstpath, type, callback);
  });
}

function _createSymlink (srcpath, dstpath, type, callback) {
  symlinkPaths(srcpath, dstpath, (err, relative) => {
    if (err) return callback(err)
    srcpath = relative.toDst;
    symlinkType(relative.toCwd, type, (err, type) => {
      if (err) return callback(err)
      const dir = path$s.dirname(dstpath);
      pathExists$2(dir, (err, dirExists) => {
        if (err) return callback(err)
        if (dirExists) return fs$m.symlink(srcpath, dstpath, type, callback)
        mkdirs(dir, err => {
          if (err) return callback(err)
          fs$m.symlink(srcpath, dstpath, type, callback);
        });
      });
    });
  });
}

function createSymlinkSync$1 (srcpath, dstpath, type) {
  let stats;
  try {
    stats = fs$m.lstatSync(dstpath);
  } catch {}
  if (stats && stats.isSymbolicLink()) {
    const srcStat = fs$m.statSync(srcpath);
    const dstStat = fs$m.statSync(dstpath);
    if (areIdentical(srcStat, dstStat)) return
  }

  const relative = symlinkPathsSync(srcpath, dstpath);
  srcpath = relative.toDst;
  type = symlinkTypeSync(relative.toCwd, type);
  const dir = path$s.dirname(dstpath);
  const exists = fs$m.existsSync(dir);
  if (exists) return fs$m.symlinkSync(srcpath, dstpath, type)
  mkdirsSync(dir);
  return fs$m.symlinkSync(srcpath, dstpath, type)
}

var symlink = {
  createSymlink: u$4(createSymlink$1),
  createSymlinkSync: createSymlinkSync$1
};

const { createFile, createFileSync } = file$1;
const { createLink, createLinkSync } = link;
const { createSymlink, createSymlinkSync } = symlink;

var ensure = {
  // file
  createFile,
  createFileSync,
  ensureFile: createFile,
  ensureFileSync: createFileSync,
  // link
  createLink,
  createLinkSync,
  ensureLink: createLink,
  ensureLinkSync: createLinkSync,
  // symlink
  createSymlink,
  createSymlinkSync,
  ensureSymlink: createSymlink,
  ensureSymlinkSync: createSymlinkSync
};

function stringify$a (obj, { EOL = '\n', finalEOL = true, replacer = null, spaces } = {}) {
  const EOF = finalEOL ? EOL : '';
  const str = JSON.stringify(obj, replacer, spaces);

  return str.replace(/\n/g, EOL) + EOF
}

function stripBom$1 (content) {
  // we do this because JSON.parse would convert it to a utf8 string if encoding wasn't specified
  if (Buffer.isBuffer(content)) content = content.toString('utf8');
  return content.replace(/^\uFEFF/, '')
}

var utils$m = { stringify: stringify$a, stripBom: stripBom$1 };

let _fs$2;
try {
  _fs$2 = gracefulFs;
} catch (_) {
  _fs$2 = require$$0__default["default"];
}
const universalify = universalify$1;
const { stringify: stringify$9, stripBom } = utils$m;

async function _readFile (file, options = {}) {
  if (typeof options === 'string') {
    options = { encoding: options };
  }

  const fs = options.fs || _fs$2;

  const shouldThrow = 'throws' in options ? options.throws : true;

  let data = await universalify.fromCallback(fs.readFile)(file, options);

  data = stripBom(data);

  let obj;
  try {
    obj = JSON.parse(data, options ? options.reviver : null);
  } catch (err) {
    if (shouldThrow) {
      err.message = `${file}: ${err.message}`;
      throw err
    } else {
      return null
    }
  }

  return obj
}

const readFile = universalify.fromPromise(_readFile);

function readFileSync (file, options = {}) {
  if (typeof options === 'string') {
    options = { encoding: options };
  }

  const fs = options.fs || _fs$2;

  const shouldThrow = 'throws' in options ? options.throws : true;

  try {
    let content = fs.readFileSync(file, options);
    content = stripBom(content);
    return JSON.parse(content, options.reviver)
  } catch (err) {
    if (shouldThrow) {
      err.message = `${file}: ${err.message}`;
      throw err
    } else {
      return null
    }
  }
}

async function _writeFile (file, obj, options = {}) {
  const fs = options.fs || _fs$2;

  const str = stringify$9(obj, options);

  await universalify.fromCallback(fs.writeFile)(file, str, options);
}

const writeFile = universalify.fromPromise(_writeFile);

function writeFileSync (file, obj, options = {}) {
  const fs = options.fs || _fs$2;

  const str = stringify$9(obj, options);
  // not sure if fs.writeFileSync returns anything, but just in case
  return fs.writeFileSync(file, str, options)
}

const jsonfile$1 = {
  readFile,
  readFileSync,
  writeFile,
  writeFileSync
};

var jsonfile_1 = jsonfile$1;

const jsonFile$1 = jsonfile_1;

var jsonfile = {
  // jsonfile exports
  readJson: jsonFile$1.readFile,
  readJsonSync: jsonFile$1.readFileSync,
  writeJson: jsonFile$1.writeFile,
  writeJsonSync: jsonFile$1.writeFileSync
};

const u$3 = universalify$1.fromCallback;
const fs$l = gracefulFs;
const path$r = path__default["default"];
const mkdir = mkdirs$2;
const pathExists$1 = pathExists_1.pathExists;

function outputFile$1 (file, data, encoding, callback) {
  if (typeof encoding === 'function') {
    callback = encoding;
    encoding = 'utf8';
  }

  const dir = path$r.dirname(file);
  pathExists$1(dir, (err, itDoes) => {
    if (err) return callback(err)
    if (itDoes) return fs$l.writeFile(file, data, encoding, callback)

    mkdir.mkdirs(dir, err => {
      if (err) return callback(err)

      fs$l.writeFile(file, data, encoding, callback);
    });
  });
}

function outputFileSync$1 (file, ...args) {
  const dir = path$r.dirname(file);
  if (fs$l.existsSync(dir)) {
    return fs$l.writeFileSync(file, ...args)
  }
  mkdir.mkdirsSync(dir);
  fs$l.writeFileSync(file, ...args);
}

var outputFile_1 = {
  outputFile: u$3(outputFile$1),
  outputFileSync: outputFileSync$1
};

const { stringify: stringify$8 } = utils$m;
const { outputFile } = outputFile_1;

async function outputJson (file, data, options = {}) {
  const str = stringify$8(data, options);

  await outputFile(file, str, options);
}

var outputJson_1 = outputJson;

const { stringify: stringify$7 } = utils$m;
const { outputFileSync } = outputFile_1;

function outputJsonSync (file, data, options) {
  const str = stringify$7(data, options);

  outputFileSync(file, str, options);
}

var outputJsonSync_1 = outputJsonSync;

const u$2 = universalify$1.fromPromise;
const jsonFile = jsonfile;

jsonFile.outputJson = u$2(outputJson_1);
jsonFile.outputJsonSync = outputJsonSync_1;
// aliases
jsonFile.outputJSON = jsonFile.outputJson;
jsonFile.outputJSONSync = jsonFile.outputJsonSync;
jsonFile.writeJSON = jsonFile.writeJson;
jsonFile.writeJSONSync = jsonFile.writeJsonSync;
jsonFile.readJSON = jsonFile.readJson;
jsonFile.readJSONSync = jsonFile.readJsonSync;

var json = jsonFile;

const fs$k = gracefulFs;
const path$q = path__default["default"];
const copy$2 = copy$3.copy;
const remove = remove_1.remove;
const mkdirp = mkdirs$2.mkdirp;
const pathExists = pathExists_1.pathExists;
const stat$2 = stat$5;

function move$1 (src, dest, opts, cb) {
  if (typeof opts === 'function') {
    cb = opts;
    opts = {};
  }

  opts = opts || {};

  const overwrite = opts.overwrite || opts.clobber || false;

  stat$2.checkPaths(src, dest, 'move', opts, (err, stats) => {
    if (err) return cb(err)
    const { srcStat, isChangingCase = false } = stats;
    stat$2.checkParentPaths(src, srcStat, dest, 'move', err => {
      if (err) return cb(err)
      if (isParentRoot$1(dest)) return doRename$1(src, dest, overwrite, isChangingCase, cb)
      mkdirp(path$q.dirname(dest), err => {
        if (err) return cb(err)
        return doRename$1(src, dest, overwrite, isChangingCase, cb)
      });
    });
  });
}

function isParentRoot$1 (dest) {
  const parent = path$q.dirname(dest);
  const parsedPath = path$q.parse(parent);
  return parsedPath.root === parent
}

function doRename$1 (src, dest, overwrite, isChangingCase, cb) {
  if (isChangingCase) return rename$1(src, dest, overwrite, cb)
  if (overwrite) {
    return remove(dest, err => {
      if (err) return cb(err)
      return rename$1(src, dest, overwrite, cb)
    })
  }
  pathExists(dest, (err, destExists) => {
    if (err) return cb(err)
    if (destExists) return cb(new Error('dest already exists.'))
    return rename$1(src, dest, overwrite, cb)
  });
}

function rename$1 (src, dest, overwrite, cb) {
  fs$k.rename(src, dest, err => {
    if (!err) return cb()
    if (err.code !== 'EXDEV') return cb(err)
    return moveAcrossDevice$1(src, dest, overwrite, cb)
  });
}

function moveAcrossDevice$1 (src, dest, overwrite, cb) {
  const opts = {
    overwrite,
    errorOnExist: true
  };
  copy$2(src, dest, opts, err => {
    if (err) return cb(err)
    return remove(src, cb)
  });
}

var move_1 = move$1;

const fs$j = gracefulFs;
const path$p = path__default["default"];
const copySync = copy$3.copySync;
const removeSync = remove_1.removeSync;
const mkdirpSync = mkdirs$2.mkdirpSync;
const stat$1 = stat$5;

function moveSync (src, dest, opts) {
  opts = opts || {};
  const overwrite = opts.overwrite || opts.clobber || false;

  const { srcStat, isChangingCase = false } = stat$1.checkPathsSync(src, dest, 'move', opts);
  stat$1.checkParentPathsSync(src, srcStat, dest, 'move');
  if (!isParentRoot(dest)) mkdirpSync(path$p.dirname(dest));
  return doRename(src, dest, overwrite, isChangingCase)
}

function isParentRoot (dest) {
  const parent = path$p.dirname(dest);
  const parsedPath = path$p.parse(parent);
  return parsedPath.root === parent
}

function doRename (src, dest, overwrite, isChangingCase) {
  if (isChangingCase) return rename(src, dest, overwrite)
  if (overwrite) {
    removeSync(dest);
    return rename(src, dest, overwrite)
  }
  if (fs$j.existsSync(dest)) throw new Error('dest already exists.')
  return rename(src, dest, overwrite)
}

function rename (src, dest, overwrite) {
  try {
    fs$j.renameSync(src, dest);
  } catch (err) {
    if (err.code !== 'EXDEV') throw err
    return moveAcrossDevice(src, dest, overwrite)
  }
}

function moveAcrossDevice (src, dest, overwrite) {
  const opts = {
    overwrite,
    errorOnExist: true
  };
  copySync(src, dest, opts);
  return removeSync(src)
}

var moveSync_1 = moveSync;

const u$1 = universalify$1.fromCallback;
var move = {
  move: u$1(move_1),
  moveSync: moveSync_1
};

var lib$t = {
  // Export promiseified graceful-fs:
  ...fs$B,
  // Export extra methods:
  ...copy$3,
  ...empty$2,
  ...ensure,
  ...json,
  ...mkdirs$2,
  ...move,
  ...outputFile_1,
  ...pathExists_1,
  ...remove_1
};

var fse = /*@__PURE__*/getDefaultExportFromCjs(lib$t);

var dist$1 = {};

var comment = {};

var node$4 = {};

var he = {exports: {}};

/*! https://mths.be/he v1.2.0 by @mathias | MIT license */
he.exports;

(function (module, exports) {
(function(root) {

		// Detect free variables `exports`.
		var freeExports = exports;

		// Detect free variable `module`.
		var freeModule = module &&
			module.exports == freeExports && module;

		// Detect free variable `global`, from Node.js or Browserified code,
		// and use it as `root`.
		var freeGlobal = typeof commonjsGlobal == 'object' && commonjsGlobal;
		if (freeGlobal.global === freeGlobal || freeGlobal.window === freeGlobal) {
			root = freeGlobal;
		}

		/*--------------------------------------------------------------------------*/

		// All astral symbols.
		var regexAstralSymbols = /[\uD800-\uDBFF][\uDC00-\uDFFF]/g;
		// All ASCII symbols (not just printable ASCII) except those listed in the
		// first column of the overrides table.
		// https://html.spec.whatwg.org/multipage/syntax.html#table-charref-overrides
		var regexAsciiWhitelist = /[\x01-\x7F]/g;
		// All BMP symbols that are not ASCII newlines, printable ASCII symbols, or
		// code points listed in the first column of the overrides table on
		// https://html.spec.whatwg.org/multipage/syntax.html#table-charref-overrides.
		var regexBmpWhitelist = /[\x01-\t\x0B\f\x0E-\x1F\x7F\x81\x8D\x8F\x90\x9D\xA0-\uFFFF]/g;

		var regexEncodeNonAscii = /<\u20D2|=\u20E5|>\u20D2|\u205F\u200A|\u219D\u0338|\u2202\u0338|\u2220\u20D2|\u2229\uFE00|\u222A\uFE00|\u223C\u20D2|\u223D\u0331|\u223E\u0333|\u2242\u0338|\u224B\u0338|\u224D\u20D2|\u224E\u0338|\u224F\u0338|\u2250\u0338|\u2261\u20E5|\u2264\u20D2|\u2265\u20D2|\u2266\u0338|\u2267\u0338|\u2268\uFE00|\u2269\uFE00|\u226A\u0338|\u226A\u20D2|\u226B\u0338|\u226B\u20D2|\u227F\u0338|\u2282\u20D2|\u2283\u20D2|\u228A\uFE00|\u228B\uFE00|\u228F\u0338|\u2290\u0338|\u2293\uFE00|\u2294\uFE00|\u22B4\u20D2|\u22B5\u20D2|\u22D8\u0338|\u22D9\u0338|\u22DA\uFE00|\u22DB\uFE00|\u22F5\u0338|\u22F9\u0338|\u2933\u0338|\u29CF\u0338|\u29D0\u0338|\u2A6D\u0338|\u2A70\u0338|\u2A7D\u0338|\u2A7E\u0338|\u2AA1\u0338|\u2AA2\u0338|\u2AAC\uFE00|\u2AAD\uFE00|\u2AAF\u0338|\u2AB0\u0338|\u2AC5\u0338|\u2AC6\u0338|\u2ACB\uFE00|\u2ACC\uFE00|\u2AFD\u20E5|[\xA0-\u0113\u0116-\u0122\u0124-\u012B\u012E-\u014D\u0150-\u017E\u0192\u01B5\u01F5\u0237\u02C6\u02C7\u02D8-\u02DD\u0311\u0391-\u03A1\u03A3-\u03A9\u03B1-\u03C9\u03D1\u03D2\u03D5\u03D6\u03DC\u03DD\u03F0\u03F1\u03F5\u03F6\u0401-\u040C\u040E-\u044F\u0451-\u045C\u045E\u045F\u2002-\u2005\u2007-\u2010\u2013-\u2016\u2018-\u201A\u201C-\u201E\u2020-\u2022\u2025\u2026\u2030-\u2035\u2039\u203A\u203E\u2041\u2043\u2044\u204F\u2057\u205F-\u2063\u20AC\u20DB\u20DC\u2102\u2105\u210A-\u2113\u2115-\u211E\u2122\u2124\u2127-\u2129\u212C\u212D\u212F-\u2131\u2133-\u2138\u2145-\u2148\u2153-\u215E\u2190-\u219B\u219D-\u21A7\u21A9-\u21AE\u21B0-\u21B3\u21B5-\u21B7\u21BA-\u21DB\u21DD\u21E4\u21E5\u21F5\u21FD-\u2205\u2207-\u2209\u220B\u220C\u220F-\u2214\u2216-\u2218\u221A\u221D-\u2238\u223A-\u2257\u2259\u225A\u225C\u225F-\u2262\u2264-\u228B\u228D-\u229B\u229D-\u22A5\u22A7-\u22B0\u22B2-\u22BB\u22BD-\u22DB\u22DE-\u22E3\u22E6-\u22F7\u22F9-\u22FE\u2305\u2306\u2308-\u2310\u2312\u2313\u2315\u2316\u231C-\u231F\u2322\u2323\u232D\u232E\u2336\u233D\u233F\u237C\u23B0\u23B1\u23B4-\u23B6\u23DC-\u23DF\u23E2\u23E7\u2423\u24C8\u2500\u2502\u250C\u2510\u2514\u2518\u251C\u2524\u252C\u2534\u253C\u2550-\u256C\u2580\u2584\u2588\u2591-\u2593\u25A1\u25AA\u25AB\u25AD\u25AE\u25B1\u25B3-\u25B5\u25B8\u25B9\u25BD-\u25BF\u25C2\u25C3\u25CA\u25CB\u25EC\u25EF\u25F8-\u25FC\u2605\u2606\u260E\u2640\u2642\u2660\u2663\u2665\u2666\u266A\u266D-\u266F\u2713\u2717\u2720\u2736\u2758\u2772\u2773\u27C8\u27C9\u27E6-\u27ED\u27F5-\u27FA\u27FC\u27FF\u2902-\u2905\u290C-\u2913\u2916\u2919-\u2920\u2923-\u292A\u2933\u2935-\u2939\u293C\u293D\u2945\u2948-\u294B\u294E-\u2976\u2978\u2979\u297B-\u297F\u2985\u2986\u298B-\u2996\u299A\u299C\u299D\u29A4-\u29B7\u29B9\u29BB\u29BC\u29BE-\u29C5\u29C9\u29CD-\u29D0\u29DC-\u29DE\u29E3-\u29E5\u29EB\u29F4\u29F6\u2A00-\u2A02\u2A04\u2A06\u2A0C\u2A0D\u2A10-\u2A17\u2A22-\u2A27\u2A29\u2A2A\u2A2D-\u2A31\u2A33-\u2A3C\u2A3F\u2A40\u2A42-\u2A4D\u2A50\u2A53-\u2A58\u2A5A-\u2A5D\u2A5F\u2A66\u2A6A\u2A6D-\u2A75\u2A77-\u2A9A\u2A9D-\u2AA2\u2AA4-\u2AB0\u2AB3-\u2AC8\u2ACB\u2ACC\u2ACF-\u2ADB\u2AE4\u2AE6-\u2AE9\u2AEB-\u2AF3\u2AFD\uFB00-\uFB04]|\uD835[\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDCCF\uDD04\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDD6B]/g;
		var encodeMap = {'\xAD':'shy','\u200C':'zwnj','\u200D':'zwj','\u200E':'lrm','\u2063':'ic','\u2062':'it','\u2061':'af','\u200F':'rlm','\u200B':'ZeroWidthSpace','\u2060':'NoBreak','\u0311':'DownBreve','\u20DB':'tdot','\u20DC':'DotDot','\t':'Tab','\n':'NewLine','\u2008':'puncsp','\u205F':'MediumSpace','\u2009':'thinsp','\u200A':'hairsp','\u2004':'emsp13','\u2002':'ensp','\u2005':'emsp14','\u2003':'emsp','\u2007':'numsp','\xA0':'nbsp','\u205F\u200A':'ThickSpace','\u203E':'oline','_':'lowbar','\u2010':'dash','\u2013':'ndash','\u2014':'mdash','\u2015':'horbar',',':'comma',';':'semi','\u204F':'bsemi',':':'colon','\u2A74':'Colone','!':'excl','\xA1':'iexcl','?':'quest','\xBF':'iquest','.':'period','\u2025':'nldr','\u2026':'mldr','\xB7':'middot','\'':'apos','\u2018':'lsquo','\u2019':'rsquo','\u201A':'sbquo','\u2039':'lsaquo','\u203A':'rsaquo','"':'quot','\u201C':'ldquo','\u201D':'rdquo','\u201E':'bdquo','\xAB':'laquo','\xBB':'raquo','(':'lpar',')':'rpar','[':'lsqb',']':'rsqb','{':'lcub','}':'rcub','\u2308':'lceil','\u2309':'rceil','\u230A':'lfloor','\u230B':'rfloor','\u2985':'lopar','\u2986':'ropar','\u298B':'lbrke','\u298C':'rbrke','\u298D':'lbrkslu','\u298E':'rbrksld','\u298F':'lbrksld','\u2990':'rbrkslu','\u2991':'langd','\u2992':'rangd','\u2993':'lparlt','\u2994':'rpargt','\u2995':'gtlPar','\u2996':'ltrPar','\u27E6':'lobrk','\u27E7':'robrk','\u27E8':'lang','\u27E9':'rang','\u27EA':'Lang','\u27EB':'Rang','\u27EC':'loang','\u27ED':'roang','\u2772':'lbbrk','\u2773':'rbbrk','\u2016':'Vert','\xA7':'sect','\xB6':'para','@':'commat','*':'ast','/':'sol','undefined':null,'&':'amp','#':'num','%':'percnt','\u2030':'permil','\u2031':'pertenk','\u2020':'dagger','\u2021':'Dagger','\u2022':'bull','\u2043':'hybull','\u2032':'prime','\u2033':'Prime','\u2034':'tprime','\u2057':'qprime','\u2035':'bprime','\u2041':'caret','`':'grave','\xB4':'acute','\u02DC':'tilde','^':'Hat','\xAF':'macr','\u02D8':'breve','\u02D9':'dot','\xA8':'die','\u02DA':'ring','\u02DD':'dblac','\xB8':'cedil','\u02DB':'ogon','\u02C6':'circ','\u02C7':'caron','\xB0':'deg','\xA9':'copy','\xAE':'reg','\u2117':'copysr','\u2118':'wp','\u211E':'rx','\u2127':'mho','\u2129':'iiota','\u2190':'larr','\u219A':'nlarr','\u2192':'rarr','\u219B':'nrarr','\u2191':'uarr','\u2193':'darr','\u2194':'harr','\u21AE':'nharr','\u2195':'varr','\u2196':'nwarr','\u2197':'nearr','\u2198':'searr','\u2199':'swarr','\u219D':'rarrw','\u219D\u0338':'nrarrw','\u219E':'Larr','\u219F':'Uarr','\u21A0':'Rarr','\u21A1':'Darr','\u21A2':'larrtl','\u21A3':'rarrtl','\u21A4':'mapstoleft','\u21A5':'mapstoup','\u21A6':'map','\u21A7':'mapstodown','\u21A9':'larrhk','\u21AA':'rarrhk','\u21AB':'larrlp','\u21AC':'rarrlp','\u21AD':'harrw','\u21B0':'lsh','\u21B1':'rsh','\u21B2':'ldsh','\u21B3':'rdsh','\u21B5':'crarr','\u21B6':'cularr','\u21B7':'curarr','\u21BA':'olarr','\u21BB':'orarr','\u21BC':'lharu','\u21BD':'lhard','\u21BE':'uharr','\u21BF':'uharl','\u21C0':'rharu','\u21C1':'rhard','\u21C2':'dharr','\u21C3':'dharl','\u21C4':'rlarr','\u21C5':'udarr','\u21C6':'lrarr','\u21C7':'llarr','\u21C8':'uuarr','\u21C9':'rrarr','\u21CA':'ddarr','\u21CB':'lrhar','\u21CC':'rlhar','\u21D0':'lArr','\u21CD':'nlArr','\u21D1':'uArr','\u21D2':'rArr','\u21CF':'nrArr','\u21D3':'dArr','\u21D4':'iff','\u21CE':'nhArr','\u21D5':'vArr','\u21D6':'nwArr','\u21D7':'neArr','\u21D8':'seArr','\u21D9':'swArr','\u21DA':'lAarr','\u21DB':'rAarr','\u21DD':'zigrarr','\u21E4':'larrb','\u21E5':'rarrb','\u21F5':'duarr','\u21FD':'loarr','\u21FE':'roarr','\u21FF':'hoarr','\u2200':'forall','\u2201':'comp','\u2202':'part','\u2202\u0338':'npart','\u2203':'exist','\u2204':'nexist','\u2205':'empty','\u2207':'Del','\u2208':'in','\u2209':'notin','\u220B':'ni','\u220C':'notni','\u03F6':'bepsi','\u220F':'prod','\u2210':'coprod','\u2211':'sum','+':'plus','\xB1':'pm','\xF7':'div','\xD7':'times','<':'lt','\u226E':'nlt','<\u20D2':'nvlt','=':'equals','\u2260':'ne','=\u20E5':'bne','\u2A75':'Equal','>':'gt','\u226F':'ngt','>\u20D2':'nvgt','\xAC':'not','|':'vert','\xA6':'brvbar','\u2212':'minus','\u2213':'mp','\u2214':'plusdo','\u2044':'frasl','\u2216':'setmn','\u2217':'lowast','\u2218':'compfn','\u221A':'Sqrt','\u221D':'prop','\u221E':'infin','\u221F':'angrt','\u2220':'ang','\u2220\u20D2':'nang','\u2221':'angmsd','\u2222':'angsph','\u2223':'mid','\u2224':'nmid','\u2225':'par','\u2226':'npar','\u2227':'and','\u2228':'or','\u2229':'cap','\u2229\uFE00':'caps','\u222A':'cup','\u222A\uFE00':'cups','\u222B':'int','\u222C':'Int','\u222D':'tint','\u2A0C':'qint','\u222E':'oint','\u222F':'Conint','\u2230':'Cconint','\u2231':'cwint','\u2232':'cwconint','\u2233':'awconint','\u2234':'there4','\u2235':'becaus','\u2236':'ratio','\u2237':'Colon','\u2238':'minusd','\u223A':'mDDot','\u223B':'homtht','\u223C':'sim','\u2241':'nsim','\u223C\u20D2':'nvsim','\u223D':'bsim','\u223D\u0331':'race','\u223E':'ac','\u223E\u0333':'acE','\u223F':'acd','\u2240':'wr','\u2242':'esim','\u2242\u0338':'nesim','\u2243':'sime','\u2244':'nsime','\u2245':'cong','\u2247':'ncong','\u2246':'simne','\u2248':'ap','\u2249':'nap','\u224A':'ape','\u224B':'apid','\u224B\u0338':'napid','\u224C':'bcong','\u224D':'CupCap','\u226D':'NotCupCap','\u224D\u20D2':'nvap','\u224E':'bump','\u224E\u0338':'nbump','\u224F':'bumpe','\u224F\u0338':'nbumpe','\u2250':'doteq','\u2250\u0338':'nedot','\u2251':'eDot','\u2252':'efDot','\u2253':'erDot','\u2254':'colone','\u2255':'ecolon','\u2256':'ecir','\u2257':'cire','\u2259':'wedgeq','\u225A':'veeeq','\u225C':'trie','\u225F':'equest','\u2261':'equiv','\u2262':'nequiv','\u2261\u20E5':'bnequiv','\u2264':'le','\u2270':'nle','\u2264\u20D2':'nvle','\u2265':'ge','\u2271':'nge','\u2265\u20D2':'nvge','\u2266':'lE','\u2266\u0338':'nlE','\u2267':'gE','\u2267\u0338':'ngE','\u2268\uFE00':'lvnE','\u2268':'lnE','\u2269':'gnE','\u2269\uFE00':'gvnE','\u226A':'ll','\u226A\u0338':'nLtv','\u226A\u20D2':'nLt','\u226B':'gg','\u226B\u0338':'nGtv','\u226B\u20D2':'nGt','\u226C':'twixt','\u2272':'lsim','\u2274':'nlsim','\u2273':'gsim','\u2275':'ngsim','\u2276':'lg','\u2278':'ntlg','\u2277':'gl','\u2279':'ntgl','\u227A':'pr','\u2280':'npr','\u227B':'sc','\u2281':'nsc','\u227C':'prcue','\u22E0':'nprcue','\u227D':'sccue','\u22E1':'nsccue','\u227E':'prsim','\u227F':'scsim','\u227F\u0338':'NotSucceedsTilde','\u2282':'sub','\u2284':'nsub','\u2282\u20D2':'vnsub','\u2283':'sup','\u2285':'nsup','\u2283\u20D2':'vnsup','\u2286':'sube','\u2288':'nsube','\u2287':'supe','\u2289':'nsupe','\u228A\uFE00':'vsubne','\u228A':'subne','\u228B\uFE00':'vsupne','\u228B':'supne','\u228D':'cupdot','\u228E':'uplus','\u228F':'sqsub','\u228F\u0338':'NotSquareSubset','\u2290':'sqsup','\u2290\u0338':'NotSquareSuperset','\u2291':'sqsube','\u22E2':'nsqsube','\u2292':'sqsupe','\u22E3':'nsqsupe','\u2293':'sqcap','\u2293\uFE00':'sqcaps','\u2294':'sqcup','\u2294\uFE00':'sqcups','\u2295':'oplus','\u2296':'ominus','\u2297':'otimes','\u2298':'osol','\u2299':'odot','\u229A':'ocir','\u229B':'oast','\u229D':'odash','\u229E':'plusb','\u229F':'minusb','\u22A0':'timesb','\u22A1':'sdotb','\u22A2':'vdash','\u22AC':'nvdash','\u22A3':'dashv','\u22A4':'top','\u22A5':'bot','\u22A7':'models','\u22A8':'vDash','\u22AD':'nvDash','\u22A9':'Vdash','\u22AE':'nVdash','\u22AA':'Vvdash','\u22AB':'VDash','\u22AF':'nVDash','\u22B0':'prurel','\u22B2':'vltri','\u22EA':'nltri','\u22B3':'vrtri','\u22EB':'nrtri','\u22B4':'ltrie','\u22EC':'nltrie','\u22B4\u20D2':'nvltrie','\u22B5':'rtrie','\u22ED':'nrtrie','\u22B5\u20D2':'nvrtrie','\u22B6':'origof','\u22B7':'imof','\u22B8':'mumap','\u22B9':'hercon','\u22BA':'intcal','\u22BB':'veebar','\u22BD':'barvee','\u22BE':'angrtvb','\u22BF':'lrtri','\u22C0':'Wedge','\u22C1':'Vee','\u22C2':'xcap','\u22C3':'xcup','\u22C4':'diam','\u22C5':'sdot','\u22C6':'Star','\u22C7':'divonx','\u22C8':'bowtie','\u22C9':'ltimes','\u22CA':'rtimes','\u22CB':'lthree','\u22CC':'rthree','\u22CD':'bsime','\u22CE':'cuvee','\u22CF':'cuwed','\u22D0':'Sub','\u22D1':'Sup','\u22D2':'Cap','\u22D3':'Cup','\u22D4':'fork','\u22D5':'epar','\u22D6':'ltdot','\u22D7':'gtdot','\u22D8':'Ll','\u22D8\u0338':'nLl','\u22D9':'Gg','\u22D9\u0338':'nGg','\u22DA\uFE00':'lesg','\u22DA':'leg','\u22DB':'gel','\u22DB\uFE00':'gesl','\u22DE':'cuepr','\u22DF':'cuesc','\u22E6':'lnsim','\u22E7':'gnsim','\u22E8':'prnsim','\u22E9':'scnsim','\u22EE':'vellip','\u22EF':'ctdot','\u22F0':'utdot','\u22F1':'dtdot','\u22F2':'disin','\u22F3':'isinsv','\u22F4':'isins','\u22F5':'isindot','\u22F5\u0338':'notindot','\u22F6':'notinvc','\u22F7':'notinvb','\u22F9':'isinE','\u22F9\u0338':'notinE','\u22FA':'nisd','\u22FB':'xnis','\u22FC':'nis','\u22FD':'notnivc','\u22FE':'notnivb','\u2305':'barwed','\u2306':'Barwed','\u230C':'drcrop','\u230D':'dlcrop','\u230E':'urcrop','\u230F':'ulcrop','\u2310':'bnot','\u2312':'profline','\u2313':'profsurf','\u2315':'telrec','\u2316':'target','\u231C':'ulcorn','\u231D':'urcorn','\u231E':'dlcorn','\u231F':'drcorn','\u2322':'frown','\u2323':'smile','\u232D':'cylcty','\u232E':'profalar','\u2336':'topbot','\u233D':'ovbar','\u233F':'solbar','\u237C':'angzarr','\u23B0':'lmoust','\u23B1':'rmoust','\u23B4':'tbrk','\u23B5':'bbrk','\u23B6':'bbrktbrk','\u23DC':'OverParenthesis','\u23DD':'UnderParenthesis','\u23DE':'OverBrace','\u23DF':'UnderBrace','\u23E2':'trpezium','\u23E7':'elinters','\u2423':'blank','\u2500':'boxh','\u2502':'boxv','\u250C':'boxdr','\u2510':'boxdl','\u2514':'boxur','\u2518':'boxul','\u251C':'boxvr','\u2524':'boxvl','\u252C':'boxhd','\u2534':'boxhu','\u253C':'boxvh','\u2550':'boxH','\u2551':'boxV','\u2552':'boxdR','\u2553':'boxDr','\u2554':'boxDR','\u2555':'boxdL','\u2556':'boxDl','\u2557':'boxDL','\u2558':'boxuR','\u2559':'boxUr','\u255A':'boxUR','\u255B':'boxuL','\u255C':'boxUl','\u255D':'boxUL','\u255E':'boxvR','\u255F':'boxVr','\u2560':'boxVR','\u2561':'boxvL','\u2562':'boxVl','\u2563':'boxVL','\u2564':'boxHd','\u2565':'boxhD','\u2566':'boxHD','\u2567':'boxHu','\u2568':'boxhU','\u2569':'boxHU','\u256A':'boxvH','\u256B':'boxVh','\u256C':'boxVH','\u2580':'uhblk','\u2584':'lhblk','\u2588':'block','\u2591':'blk14','\u2592':'blk12','\u2593':'blk34','\u25A1':'squ','\u25AA':'squf','\u25AB':'EmptyVerySmallSquare','\u25AD':'rect','\u25AE':'marker','\u25B1':'fltns','\u25B3':'xutri','\u25B4':'utrif','\u25B5':'utri','\u25B8':'rtrif','\u25B9':'rtri','\u25BD':'xdtri','\u25BE':'dtrif','\u25BF':'dtri','\u25C2':'ltrif','\u25C3':'ltri','\u25CA':'loz','\u25CB':'cir','\u25EC':'tridot','\u25EF':'xcirc','\u25F8':'ultri','\u25F9':'urtri','\u25FA':'lltri','\u25FB':'EmptySmallSquare','\u25FC':'FilledSmallSquare','\u2605':'starf','\u2606':'star','\u260E':'phone','\u2640':'female','\u2642':'male','\u2660':'spades','\u2663':'clubs','\u2665':'hearts','\u2666':'diams','\u266A':'sung','\u2713':'check','\u2717':'cross','\u2720':'malt','\u2736':'sext','\u2758':'VerticalSeparator','\u27C8':'bsolhsub','\u27C9':'suphsol','\u27F5':'xlarr','\u27F6':'xrarr','\u27F7':'xharr','\u27F8':'xlArr','\u27F9':'xrArr','\u27FA':'xhArr','\u27FC':'xmap','\u27FF':'dzigrarr','\u2902':'nvlArr','\u2903':'nvrArr','\u2904':'nvHarr','\u2905':'Map','\u290C':'lbarr','\u290D':'rbarr','\u290E':'lBarr','\u290F':'rBarr','\u2910':'RBarr','\u2911':'DDotrahd','\u2912':'UpArrowBar','\u2913':'DownArrowBar','\u2916':'Rarrtl','\u2919':'latail','\u291A':'ratail','\u291B':'lAtail','\u291C':'rAtail','\u291D':'larrfs','\u291E':'rarrfs','\u291F':'larrbfs','\u2920':'rarrbfs','\u2923':'nwarhk','\u2924':'nearhk','\u2925':'searhk','\u2926':'swarhk','\u2927':'nwnear','\u2928':'toea','\u2929':'tosa','\u292A':'swnwar','\u2933':'rarrc','\u2933\u0338':'nrarrc','\u2935':'cudarrr','\u2936':'ldca','\u2937':'rdca','\u2938':'cudarrl','\u2939':'larrpl','\u293C':'curarrm','\u293D':'cularrp','\u2945':'rarrpl','\u2948':'harrcir','\u2949':'Uarrocir','\u294A':'lurdshar','\u294B':'ldrushar','\u294E':'LeftRightVector','\u294F':'RightUpDownVector','\u2950':'DownLeftRightVector','\u2951':'LeftUpDownVector','\u2952':'LeftVectorBar','\u2953':'RightVectorBar','\u2954':'RightUpVectorBar','\u2955':'RightDownVectorBar','\u2956':'DownLeftVectorBar','\u2957':'DownRightVectorBar','\u2958':'LeftUpVectorBar','\u2959':'LeftDownVectorBar','\u295A':'LeftTeeVector','\u295B':'RightTeeVector','\u295C':'RightUpTeeVector','\u295D':'RightDownTeeVector','\u295E':'DownLeftTeeVector','\u295F':'DownRightTeeVector','\u2960':'LeftUpTeeVector','\u2961':'LeftDownTeeVector','\u2962':'lHar','\u2963':'uHar','\u2964':'rHar','\u2965':'dHar','\u2966':'luruhar','\u2967':'ldrdhar','\u2968':'ruluhar','\u2969':'rdldhar','\u296A':'lharul','\u296B':'llhard','\u296C':'rharul','\u296D':'lrhard','\u296E':'udhar','\u296F':'duhar','\u2970':'RoundImplies','\u2971':'erarr','\u2972':'simrarr','\u2973':'larrsim','\u2974':'rarrsim','\u2975':'rarrap','\u2976':'ltlarr','\u2978':'gtrarr','\u2979':'subrarr','\u297B':'suplarr','\u297C':'lfisht','\u297D':'rfisht','\u297E':'ufisht','\u297F':'dfisht','\u299A':'vzigzag','\u299C':'vangrt','\u299D':'angrtvbd','\u29A4':'ange','\u29A5':'range','\u29A6':'dwangle','\u29A7':'uwangle','\u29A8':'angmsdaa','\u29A9':'angmsdab','\u29AA':'angmsdac','\u29AB':'angmsdad','\u29AC':'angmsdae','\u29AD':'angmsdaf','\u29AE':'angmsdag','\u29AF':'angmsdah','\u29B0':'bemptyv','\u29B1':'demptyv','\u29B2':'cemptyv','\u29B3':'raemptyv','\u29B4':'laemptyv','\u29B5':'ohbar','\u29B6':'omid','\u29B7':'opar','\u29B9':'operp','\u29BB':'olcross','\u29BC':'odsold','\u29BE':'olcir','\u29BF':'ofcir','\u29C0':'olt','\u29C1':'ogt','\u29C2':'cirscir','\u29C3':'cirE','\u29C4':'solb','\u29C5':'bsolb','\u29C9':'boxbox','\u29CD':'trisb','\u29CE':'rtriltri','\u29CF':'LeftTriangleBar','\u29CF\u0338':'NotLeftTriangleBar','\u29D0':'RightTriangleBar','\u29D0\u0338':'NotRightTriangleBar','\u29DC':'iinfin','\u29DD':'infintie','\u29DE':'nvinfin','\u29E3':'eparsl','\u29E4':'smeparsl','\u29E5':'eqvparsl','\u29EB':'lozf','\u29F4':'RuleDelayed','\u29F6':'dsol','\u2A00':'xodot','\u2A01':'xoplus','\u2A02':'xotime','\u2A04':'xuplus','\u2A06':'xsqcup','\u2A0D':'fpartint','\u2A10':'cirfnint','\u2A11':'awint','\u2A12':'rppolint','\u2A13':'scpolint','\u2A14':'npolint','\u2A15':'pointint','\u2A16':'quatint','\u2A17':'intlarhk','\u2A22':'pluscir','\u2A23':'plusacir','\u2A24':'simplus','\u2A25':'plusdu','\u2A26':'plussim','\u2A27':'plustwo','\u2A29':'mcomma','\u2A2A':'minusdu','\u2A2D':'loplus','\u2A2E':'roplus','\u2A2F':'Cross','\u2A30':'timesd','\u2A31':'timesbar','\u2A33':'smashp','\u2A34':'lotimes','\u2A35':'rotimes','\u2A36':'otimesas','\u2A37':'Otimes','\u2A38':'odiv','\u2A39':'triplus','\u2A3A':'triminus','\u2A3B':'tritime','\u2A3C':'iprod','\u2A3F':'amalg','\u2A40':'capdot','\u2A42':'ncup','\u2A43':'ncap','\u2A44':'capand','\u2A45':'cupor','\u2A46':'cupcap','\u2A47':'capcup','\u2A48':'cupbrcap','\u2A49':'capbrcup','\u2A4A':'cupcup','\u2A4B':'capcap','\u2A4C':'ccups','\u2A4D':'ccaps','\u2A50':'ccupssm','\u2A53':'And','\u2A54':'Or','\u2A55':'andand','\u2A56':'oror','\u2A57':'orslope','\u2A58':'andslope','\u2A5A':'andv','\u2A5B':'orv','\u2A5C':'andd','\u2A5D':'ord','\u2A5F':'wedbar','\u2A66':'sdote','\u2A6A':'simdot','\u2A6D':'congdot','\u2A6D\u0338':'ncongdot','\u2A6E':'easter','\u2A6F':'apacir','\u2A70':'apE','\u2A70\u0338':'napE','\u2A71':'eplus','\u2A72':'pluse','\u2A73':'Esim','\u2A77':'eDDot','\u2A78':'equivDD','\u2A79':'ltcir','\u2A7A':'gtcir','\u2A7B':'ltquest','\u2A7C':'gtquest','\u2A7D':'les','\u2A7D\u0338':'nles','\u2A7E':'ges','\u2A7E\u0338':'nges','\u2A7F':'lesdot','\u2A80':'gesdot','\u2A81':'lesdoto','\u2A82':'gesdoto','\u2A83':'lesdotor','\u2A84':'gesdotol','\u2A85':'lap','\u2A86':'gap','\u2A87':'lne','\u2A88':'gne','\u2A89':'lnap','\u2A8A':'gnap','\u2A8B':'lEg','\u2A8C':'gEl','\u2A8D':'lsime','\u2A8E':'gsime','\u2A8F':'lsimg','\u2A90':'gsiml','\u2A91':'lgE','\u2A92':'glE','\u2A93':'lesges','\u2A94':'gesles','\u2A95':'els','\u2A96':'egs','\u2A97':'elsdot','\u2A98':'egsdot','\u2A99':'el','\u2A9A':'eg','\u2A9D':'siml','\u2A9E':'simg','\u2A9F':'simlE','\u2AA0':'simgE','\u2AA1':'LessLess','\u2AA1\u0338':'NotNestedLessLess','\u2AA2':'GreaterGreater','\u2AA2\u0338':'NotNestedGreaterGreater','\u2AA4':'glj','\u2AA5':'gla','\u2AA6':'ltcc','\u2AA7':'gtcc','\u2AA8':'lescc','\u2AA9':'gescc','\u2AAA':'smt','\u2AAB':'lat','\u2AAC':'smte','\u2AAC\uFE00':'smtes','\u2AAD':'late','\u2AAD\uFE00':'lates','\u2AAE':'bumpE','\u2AAF':'pre','\u2AAF\u0338':'npre','\u2AB0':'sce','\u2AB0\u0338':'nsce','\u2AB3':'prE','\u2AB4':'scE','\u2AB5':'prnE','\u2AB6':'scnE','\u2AB7':'prap','\u2AB8':'scap','\u2AB9':'prnap','\u2ABA':'scnap','\u2ABB':'Pr','\u2ABC':'Sc','\u2ABD':'subdot','\u2ABE':'supdot','\u2ABF':'subplus','\u2AC0':'supplus','\u2AC1':'submult','\u2AC2':'supmult','\u2AC3':'subedot','\u2AC4':'supedot','\u2AC5':'subE','\u2AC5\u0338':'nsubE','\u2AC6':'supE','\u2AC6\u0338':'nsupE','\u2AC7':'subsim','\u2AC8':'supsim','\u2ACB\uFE00':'vsubnE','\u2ACB':'subnE','\u2ACC\uFE00':'vsupnE','\u2ACC':'supnE','\u2ACF':'csub','\u2AD0':'csup','\u2AD1':'csube','\u2AD2':'csupe','\u2AD3':'subsup','\u2AD4':'supsub','\u2AD5':'subsub','\u2AD6':'supsup','\u2AD7':'suphsub','\u2AD8':'supdsub','\u2AD9':'forkv','\u2ADA':'topfork','\u2ADB':'mlcp','\u2AE4':'Dashv','\u2AE6':'Vdashl','\u2AE7':'Barv','\u2AE8':'vBar','\u2AE9':'vBarv','\u2AEB':'Vbar','\u2AEC':'Not','\u2AED':'bNot','\u2AEE':'rnmid','\u2AEF':'cirmid','\u2AF0':'midcir','\u2AF1':'topcir','\u2AF2':'nhpar','\u2AF3':'parsim','\u2AFD':'parsl','\u2AFD\u20E5':'nparsl','\u266D':'flat','\u266E':'natur','\u266F':'sharp','\xA4':'curren','\xA2':'cent','$':'dollar','\xA3':'pound','\xA5':'yen','\u20AC':'euro','\xB9':'sup1','\xBD':'half','\u2153':'frac13','\xBC':'frac14','\u2155':'frac15','\u2159':'frac16','\u215B':'frac18','\xB2':'sup2','\u2154':'frac23','\u2156':'frac25','\xB3':'sup3','\xBE':'frac34','\u2157':'frac35','\u215C':'frac38','\u2158':'frac45','\u215A':'frac56','\u215D':'frac58','\u215E':'frac78','\uD835\uDCB6':'ascr','\uD835\uDD52':'aopf','\uD835\uDD1E':'afr','\uD835\uDD38':'Aopf','\uD835\uDD04':'Afr','\uD835\uDC9C':'Ascr','\xAA':'ordf','\xE1':'aacute','\xC1':'Aacute','\xE0':'agrave','\xC0':'Agrave','\u0103':'abreve','\u0102':'Abreve','\xE2':'acirc','\xC2':'Acirc','\xE5':'aring','\xC5':'angst','\xE4':'auml','\xC4':'Auml','\xE3':'atilde','\xC3':'Atilde','\u0105':'aogon','\u0104':'Aogon','\u0101':'amacr','\u0100':'Amacr','\xE6':'aelig','\xC6':'AElig','\uD835\uDCB7':'bscr','\uD835\uDD53':'bopf','\uD835\uDD1F':'bfr','\uD835\uDD39':'Bopf','\u212C':'Bscr','\uD835\uDD05':'Bfr','\uD835\uDD20':'cfr','\uD835\uDCB8':'cscr','\uD835\uDD54':'copf','\u212D':'Cfr','\uD835\uDC9E':'Cscr','\u2102':'Copf','\u0107':'cacute','\u0106':'Cacute','\u0109':'ccirc','\u0108':'Ccirc','\u010D':'ccaron','\u010C':'Ccaron','\u010B':'cdot','\u010A':'Cdot','\xE7':'ccedil','\xC7':'Ccedil','\u2105':'incare','\uD835\uDD21':'dfr','\u2146':'dd','\uD835\uDD55':'dopf','\uD835\uDCB9':'dscr','\uD835\uDC9F':'Dscr','\uD835\uDD07':'Dfr','\u2145':'DD','\uD835\uDD3B':'Dopf','\u010F':'dcaron','\u010E':'Dcaron','\u0111':'dstrok','\u0110':'Dstrok','\xF0':'eth','\xD0':'ETH','\u2147':'ee','\u212F':'escr','\uD835\uDD22':'efr','\uD835\uDD56':'eopf','\u2130':'Escr','\uD835\uDD08':'Efr','\uD835\uDD3C':'Eopf','\xE9':'eacute','\xC9':'Eacute','\xE8':'egrave','\xC8':'Egrave','\xEA':'ecirc','\xCA':'Ecirc','\u011B':'ecaron','\u011A':'Ecaron','\xEB':'euml','\xCB':'Euml','\u0117':'edot','\u0116':'Edot','\u0119':'eogon','\u0118':'Eogon','\u0113':'emacr','\u0112':'Emacr','\uD835\uDD23':'ffr','\uD835\uDD57':'fopf','\uD835\uDCBB':'fscr','\uD835\uDD09':'Ffr','\uD835\uDD3D':'Fopf','\u2131':'Fscr','\uFB00':'fflig','\uFB03':'ffilig','\uFB04':'ffllig','\uFB01':'filig','fj':'fjlig','\uFB02':'fllig','\u0192':'fnof','\u210A':'gscr','\uD835\uDD58':'gopf','\uD835\uDD24':'gfr','\uD835\uDCA2':'Gscr','\uD835\uDD3E':'Gopf','\uD835\uDD0A':'Gfr','\u01F5':'gacute','\u011F':'gbreve','\u011E':'Gbreve','\u011D':'gcirc','\u011C':'Gcirc','\u0121':'gdot','\u0120':'Gdot','\u0122':'Gcedil','\uD835\uDD25':'hfr','\u210E':'planckh','\uD835\uDCBD':'hscr','\uD835\uDD59':'hopf','\u210B':'Hscr','\u210C':'Hfr','\u210D':'Hopf','\u0125':'hcirc','\u0124':'Hcirc','\u210F':'hbar','\u0127':'hstrok','\u0126':'Hstrok','\uD835\uDD5A':'iopf','\uD835\uDD26':'ifr','\uD835\uDCBE':'iscr','\u2148':'ii','\uD835\uDD40':'Iopf','\u2110':'Iscr','\u2111':'Im','\xED':'iacute','\xCD':'Iacute','\xEC':'igrave','\xCC':'Igrave','\xEE':'icirc','\xCE':'Icirc','\xEF':'iuml','\xCF':'Iuml','\u0129':'itilde','\u0128':'Itilde','\u0130':'Idot','\u012F':'iogon','\u012E':'Iogon','\u012B':'imacr','\u012A':'Imacr','\u0133':'ijlig','\u0132':'IJlig','\u0131':'imath','\uD835\uDCBF':'jscr','\uD835\uDD5B':'jopf','\uD835\uDD27':'jfr','\uD835\uDCA5':'Jscr','\uD835\uDD0D':'Jfr','\uD835\uDD41':'Jopf','\u0135':'jcirc','\u0134':'Jcirc','\u0237':'jmath','\uD835\uDD5C':'kopf','\uD835\uDCC0':'kscr','\uD835\uDD28':'kfr','\uD835\uDCA6':'Kscr','\uD835\uDD42':'Kopf','\uD835\uDD0E':'Kfr','\u0137':'kcedil','\u0136':'Kcedil','\uD835\uDD29':'lfr','\uD835\uDCC1':'lscr','\u2113':'ell','\uD835\uDD5D':'lopf','\u2112':'Lscr','\uD835\uDD0F':'Lfr','\uD835\uDD43':'Lopf','\u013A':'lacute','\u0139':'Lacute','\u013E':'lcaron','\u013D':'Lcaron','\u013C':'lcedil','\u013B':'Lcedil','\u0142':'lstrok','\u0141':'Lstrok','\u0140':'lmidot','\u013F':'Lmidot','\uD835\uDD2A':'mfr','\uD835\uDD5E':'mopf','\uD835\uDCC2':'mscr','\uD835\uDD10':'Mfr','\uD835\uDD44':'Mopf','\u2133':'Mscr','\uD835\uDD2B':'nfr','\uD835\uDD5F':'nopf','\uD835\uDCC3':'nscr','\u2115':'Nopf','\uD835\uDCA9':'Nscr','\uD835\uDD11':'Nfr','\u0144':'nacute','\u0143':'Nacute','\u0148':'ncaron','\u0147':'Ncaron','\xF1':'ntilde','\xD1':'Ntilde','\u0146':'ncedil','\u0145':'Ncedil','\u2116':'numero','\u014B':'eng','\u014A':'ENG','\uD835\uDD60':'oopf','\uD835\uDD2C':'ofr','\u2134':'oscr','\uD835\uDCAA':'Oscr','\uD835\uDD12':'Ofr','\uD835\uDD46':'Oopf','\xBA':'ordm','\xF3':'oacute','\xD3':'Oacute','\xF2':'ograve','\xD2':'Ograve','\xF4':'ocirc','\xD4':'Ocirc','\xF6':'ouml','\xD6':'Ouml','\u0151':'odblac','\u0150':'Odblac','\xF5':'otilde','\xD5':'Otilde','\xF8':'oslash','\xD8':'Oslash','\u014D':'omacr','\u014C':'Omacr','\u0153':'oelig','\u0152':'OElig','\uD835\uDD2D':'pfr','\uD835\uDCC5':'pscr','\uD835\uDD61':'popf','\u2119':'Popf','\uD835\uDD13':'Pfr','\uD835\uDCAB':'Pscr','\uD835\uDD62':'qopf','\uD835\uDD2E':'qfr','\uD835\uDCC6':'qscr','\uD835\uDCAC':'Qscr','\uD835\uDD14':'Qfr','\u211A':'Qopf','\u0138':'kgreen','\uD835\uDD2F':'rfr','\uD835\uDD63':'ropf','\uD835\uDCC7':'rscr','\u211B':'Rscr','\u211C':'Re','\u211D':'Ropf','\u0155':'racute','\u0154':'Racute','\u0159':'rcaron','\u0158':'Rcaron','\u0157':'rcedil','\u0156':'Rcedil','\uD835\uDD64':'sopf','\uD835\uDCC8':'sscr','\uD835\uDD30':'sfr','\uD835\uDD4A':'Sopf','\uD835\uDD16':'Sfr','\uD835\uDCAE':'Sscr','\u24C8':'oS','\u015B':'sacute','\u015A':'Sacute','\u015D':'scirc','\u015C':'Scirc','\u0161':'scaron','\u0160':'Scaron','\u015F':'scedil','\u015E':'Scedil','\xDF':'szlig','\uD835\uDD31':'tfr','\uD835\uDCC9':'tscr','\uD835\uDD65':'topf','\uD835\uDCAF':'Tscr','\uD835\uDD17':'Tfr','\uD835\uDD4B':'Topf','\u0165':'tcaron','\u0164':'Tcaron','\u0163':'tcedil','\u0162':'Tcedil','\u2122':'trade','\u0167':'tstrok','\u0166':'Tstrok','\uD835\uDCCA':'uscr','\uD835\uDD66':'uopf','\uD835\uDD32':'ufr','\uD835\uDD4C':'Uopf','\uD835\uDD18':'Ufr','\uD835\uDCB0':'Uscr','\xFA':'uacute','\xDA':'Uacute','\xF9':'ugrave','\xD9':'Ugrave','\u016D':'ubreve','\u016C':'Ubreve','\xFB':'ucirc','\xDB':'Ucirc','\u016F':'uring','\u016E':'Uring','\xFC':'uuml','\xDC':'Uuml','\u0171':'udblac','\u0170':'Udblac','\u0169':'utilde','\u0168':'Utilde','\u0173':'uogon','\u0172':'Uogon','\u016B':'umacr','\u016A':'Umacr','\uD835\uDD33':'vfr','\uD835\uDD67':'vopf','\uD835\uDCCB':'vscr','\uD835\uDD19':'Vfr','\uD835\uDD4D':'Vopf','\uD835\uDCB1':'Vscr','\uD835\uDD68':'wopf','\uD835\uDCCC':'wscr','\uD835\uDD34':'wfr','\uD835\uDCB2':'Wscr','\uD835\uDD4E':'Wopf','\uD835\uDD1A':'Wfr','\u0175':'wcirc','\u0174':'Wcirc','\uD835\uDD35':'xfr','\uD835\uDCCD':'xscr','\uD835\uDD69':'xopf','\uD835\uDD4F':'Xopf','\uD835\uDD1B':'Xfr','\uD835\uDCB3':'Xscr','\uD835\uDD36':'yfr','\uD835\uDCCE':'yscr','\uD835\uDD6A':'yopf','\uD835\uDCB4':'Yscr','\uD835\uDD1C':'Yfr','\uD835\uDD50':'Yopf','\xFD':'yacute','\xDD':'Yacute','\u0177':'ycirc','\u0176':'Ycirc','\xFF':'yuml','\u0178':'Yuml','\uD835\uDCCF':'zscr','\uD835\uDD37':'zfr','\uD835\uDD6B':'zopf','\u2128':'Zfr','\u2124':'Zopf','\uD835\uDCB5':'Zscr','\u017A':'zacute','\u0179':'Zacute','\u017E':'zcaron','\u017D':'Zcaron','\u017C':'zdot','\u017B':'Zdot','\u01B5':'imped','\xFE':'thorn','\xDE':'THORN','\u0149':'napos','\u03B1':'alpha','\u0391':'Alpha','\u03B2':'beta','\u0392':'Beta','\u03B3':'gamma','\u0393':'Gamma','\u03B4':'delta','\u0394':'Delta','\u03B5':'epsi','\u03F5':'epsiv','\u0395':'Epsilon','\u03DD':'gammad','\u03DC':'Gammad','\u03B6':'zeta','\u0396':'Zeta','\u03B7':'eta','\u0397':'Eta','\u03B8':'theta','\u03D1':'thetav','\u0398':'Theta','\u03B9':'iota','\u0399':'Iota','\u03BA':'kappa','\u03F0':'kappav','\u039A':'Kappa','\u03BB':'lambda','\u039B':'Lambda','\u03BC':'mu','\xB5':'micro','\u039C':'Mu','\u03BD':'nu','\u039D':'Nu','\u03BE':'xi','\u039E':'Xi','\u03BF':'omicron','\u039F':'Omicron','\u03C0':'pi','\u03D6':'piv','\u03A0':'Pi','\u03C1':'rho','\u03F1':'rhov','\u03A1':'Rho','\u03C3':'sigma','\u03A3':'Sigma','\u03C2':'sigmaf','\u03C4':'tau','\u03A4':'Tau','\u03C5':'upsi','\u03A5':'Upsilon','\u03D2':'Upsi','\u03C6':'phi','\u03D5':'phiv','\u03A6':'Phi','\u03C7':'chi','\u03A7':'Chi','\u03C8':'psi','\u03A8':'Psi','\u03C9':'omega','\u03A9':'ohm','\u0430':'acy','\u0410':'Acy','\u0431':'bcy','\u0411':'Bcy','\u0432':'vcy','\u0412':'Vcy','\u0433':'gcy','\u0413':'Gcy','\u0453':'gjcy','\u0403':'GJcy','\u0434':'dcy','\u0414':'Dcy','\u0452':'djcy','\u0402':'DJcy','\u0435':'iecy','\u0415':'IEcy','\u0451':'iocy','\u0401':'IOcy','\u0454':'jukcy','\u0404':'Jukcy','\u0436':'zhcy','\u0416':'ZHcy','\u0437':'zcy','\u0417':'Zcy','\u0455':'dscy','\u0405':'DScy','\u0438':'icy','\u0418':'Icy','\u0456':'iukcy','\u0406':'Iukcy','\u0457':'yicy','\u0407':'YIcy','\u0439':'jcy','\u0419':'Jcy','\u0458':'jsercy','\u0408':'Jsercy','\u043A':'kcy','\u041A':'Kcy','\u045C':'kjcy','\u040C':'KJcy','\u043B':'lcy','\u041B':'Lcy','\u0459':'ljcy','\u0409':'LJcy','\u043C':'mcy','\u041C':'Mcy','\u043D':'ncy','\u041D':'Ncy','\u045A':'njcy','\u040A':'NJcy','\u043E':'ocy','\u041E':'Ocy','\u043F':'pcy','\u041F':'Pcy','\u0440':'rcy','\u0420':'Rcy','\u0441':'scy','\u0421':'Scy','\u0442':'tcy','\u0422':'Tcy','\u045B':'tshcy','\u040B':'TSHcy','\u0443':'ucy','\u0423':'Ucy','\u045E':'ubrcy','\u040E':'Ubrcy','\u0444':'fcy','\u0424':'Fcy','\u0445':'khcy','\u0425':'KHcy','\u0446':'tscy','\u0426':'TScy','\u0447':'chcy','\u0427':'CHcy','\u045F':'dzcy','\u040F':'DZcy','\u0448':'shcy','\u0428':'SHcy','\u0449':'shchcy','\u0429':'SHCHcy','\u044A':'hardcy','\u042A':'HARDcy','\u044B':'ycy','\u042B':'Ycy','\u044C':'softcy','\u042C':'SOFTcy','\u044D':'ecy','\u042D':'Ecy','\u044E':'yucy','\u042E':'YUcy','\u044F':'yacy','\u042F':'YAcy','\u2135':'aleph','\u2136':'beth','\u2137':'gimel','\u2138':'daleth'};

		var regexEscape = /["&'<>`]/g;
		var escapeMap = {
			'"': '&quot;',
			'&': '&amp;',
			'\'': '&#x27;',
			'<': '&lt;',
			// See https://mathiasbynens.be/notes/ambiguous-ampersands: in HTML, the
			// following is not strictly necessary unless it’s part of a tag or an
			// unquoted attribute value. We’re only escaping it to support those
			// situations, and for XML support.
			'>': '&gt;',
			// In Internet Explorer ≤ 8, the backtick character can be used
			// to break out of (un)quoted attribute values or HTML comments.
			// See http://html5sec.org/#102, http://html5sec.org/#108, and
			// http://html5sec.org/#133.
			'`': '&#x60;'
		};

		var regexInvalidEntity = /&#(?:[xX][^a-fA-F0-9]|[^0-9xX])/;
		var regexInvalidRawCodePoint = /[\0-\x08\x0B\x0E-\x1F\x7F-\x9F\uFDD0-\uFDEF\uFFFE\uFFFF]|[\uD83F\uD87F\uD8BF\uD8FF\uD93F\uD97F\uD9BF\uD9FF\uDA3F\uDA7F\uDABF\uDAFF\uDB3F\uDB7F\uDBBF\uDBFF][\uDFFE\uDFFF]|[\uD800-\uDBFF](?![\uDC00-\uDFFF])|(?:[^\uD800-\uDBFF]|^)[\uDC00-\uDFFF]/;
		var regexDecode = /&(CounterClockwiseContourIntegral|DoubleLongLeftRightArrow|ClockwiseContourIntegral|NotNestedGreaterGreater|NotSquareSupersetEqual|DiacriticalDoubleAcute|NotRightTriangleEqual|NotSucceedsSlantEqual|NotPrecedesSlantEqual|CloseCurlyDoubleQuote|NegativeVeryThinSpace|DoubleContourIntegral|FilledVerySmallSquare|CapitalDifferentialD|OpenCurlyDoubleQuote|EmptyVerySmallSquare|NestedGreaterGreater|DoubleLongRightArrow|NotLeftTriangleEqual|NotGreaterSlantEqual|ReverseUpEquilibrium|DoubleLeftRightArrow|NotSquareSubsetEqual|NotDoubleVerticalBar|RightArrowLeftArrow|NotGreaterFullEqual|NotRightTriangleBar|SquareSupersetEqual|DownLeftRightVector|DoubleLongLeftArrow|leftrightsquigarrow|LeftArrowRightArrow|NegativeMediumSpace|blacktriangleright|RightDownVectorBar|PrecedesSlantEqual|RightDoubleBracket|SucceedsSlantEqual|NotLeftTriangleBar|RightTriangleEqual|SquareIntersection|RightDownTeeVector|ReverseEquilibrium|NegativeThickSpace|longleftrightarrow|Longleftrightarrow|LongLeftRightArrow|DownRightTeeVector|DownRightVectorBar|GreaterSlantEqual|SquareSubsetEqual|LeftDownVectorBar|LeftDoubleBracket|VerticalSeparator|rightleftharpoons|NotGreaterGreater|NotSquareSuperset|blacktriangleleft|blacktriangledown|NegativeThinSpace|LeftDownTeeVector|NotLessSlantEqual|leftrightharpoons|DoubleUpDownArrow|DoubleVerticalBar|LeftTriangleEqual|FilledSmallSquare|twoheadrightarrow|NotNestedLessLess|DownLeftTeeVector|DownLeftVectorBar|RightAngleBracket|NotTildeFullEqual|NotReverseElement|RightUpDownVector|DiacriticalTilde|NotSucceedsTilde|circlearrowright|NotPrecedesEqual|rightharpoondown|DoubleRightArrow|NotSucceedsEqual|NonBreakingSpace|NotRightTriangle|LessEqualGreater|RightUpTeeVector|LeftAngleBracket|GreaterFullEqual|DownArrowUpArrow|RightUpVectorBar|twoheadleftarrow|GreaterEqualLess|downharpoonright|RightTriangleBar|ntrianglerighteq|NotSupersetEqual|LeftUpDownVector|DiacriticalAcute|rightrightarrows|vartriangleright|UpArrowDownArrow|DiacriticalGrave|UnderParenthesis|EmptySmallSquare|LeftUpVectorBar|leftrightarrows|DownRightVector|downharpoonleft|trianglerighteq|ShortRightArrow|OverParenthesis|DoubleLeftArrow|DoubleDownArrow|NotSquareSubset|bigtriangledown|ntrianglelefteq|UpperRightArrow|curvearrowright|vartriangleleft|NotLeftTriangle|nleftrightarrow|LowerRightArrow|NotHumpDownHump|NotGreaterTilde|rightthreetimes|LeftUpTeeVector|NotGreaterEqual|straightepsilon|LeftTriangleBar|rightsquigarrow|ContourIntegral|rightleftarrows|CloseCurlyQuote|RightDownVector|LeftRightVector|nLeftrightarrow|leftharpoondown|circlearrowleft|SquareSuperset|OpenCurlyQuote|hookrightarrow|HorizontalLine|DiacriticalDot|NotLessGreater|ntriangleright|DoubleRightTee|InvisibleComma|InvisibleTimes|LowerLeftArrow|DownLeftVector|NotSubsetEqual|curvearrowleft|trianglelefteq|NotVerticalBar|TildeFullEqual|downdownarrows|NotGreaterLess|RightTeeVector|ZeroWidthSpace|looparrowright|LongRightArrow|doublebarwedge|ShortLeftArrow|ShortDownArrow|RightVectorBar|GreaterGreater|ReverseElement|rightharpoonup|LessSlantEqual|leftthreetimes|upharpoonright|rightarrowtail|LeftDownVector|Longrightarrow|NestedLessLess|UpperLeftArrow|nshortparallel|leftleftarrows|leftrightarrow|Leftrightarrow|LeftRightArrow|longrightarrow|upharpoonleft|RightArrowBar|ApplyFunction|LeftTeeVector|leftarrowtail|NotEqualTilde|varsubsetneqq|varsupsetneqq|RightTeeArrow|SucceedsEqual|SucceedsTilde|LeftVectorBar|SupersetEqual|hookleftarrow|DifferentialD|VerticalTilde|VeryThinSpace|blacktriangle|bigtriangleup|LessFullEqual|divideontimes|leftharpoonup|UpEquilibrium|ntriangleleft|RightTriangle|measuredangle|shortparallel|longleftarrow|Longleftarrow|LongLeftArrow|DoubleLeftTee|Poincareplane|PrecedesEqual|triangleright|DoubleUpArrow|RightUpVector|fallingdotseq|looparrowleft|PrecedesTilde|NotTildeEqual|NotTildeTilde|smallsetminus|Proportional|triangleleft|triangledown|UnderBracket|NotHumpEqual|exponentiale|ExponentialE|NotLessTilde|HilbertSpace|RightCeiling|blacklozenge|varsupsetneq|HumpDownHump|GreaterEqual|VerticalLine|LeftTeeArrow|NotLessEqual|DownTeeArrow|LeftTriangle|varsubsetneq|Intersection|NotCongruent|DownArrowBar|LeftUpVector|LeftArrowBar|risingdotseq|GreaterTilde|RoundImplies|SquareSubset|ShortUpArrow|NotSuperset|quaternions|precnapprox|backepsilon|preccurlyeq|OverBracket|blacksquare|MediumSpace|VerticalBar|circledcirc|circleddash|CircleMinus|CircleTimes|LessGreater|curlyeqprec|curlyeqsucc|diamondsuit|UpDownArrow|Updownarrow|RuleDelayed|Rrightarrow|updownarrow|RightVector|nRightarrow|nrightarrow|eqslantless|LeftCeiling|Equilibrium|SmallCircle|expectation|NotSucceeds|thickapprox|GreaterLess|SquareUnion|NotPrecedes|NotLessLess|straightphi|succnapprox|succcurlyeq|SubsetEqual|sqsupseteq|Proportion|Laplacetrf|ImaginaryI|supsetneqq|NotGreater|gtreqqless|NotElement|ThickSpace|TildeEqual|TildeTilde|Fouriertrf|rmoustache|EqualTilde|eqslantgtr|UnderBrace|LeftVector|UpArrowBar|nLeftarrow|nsubseteqq|subsetneqq|nsupseteqq|nleftarrow|succapprox|lessapprox|UpTeeArrow|upuparrows|curlywedge|lesseqqgtr|varepsilon|varnothing|RightFloor|complement|CirclePlus|sqsubseteq|Lleftarrow|circledast|RightArrow|Rightarrow|rightarrow|lmoustache|Bernoullis|precapprox|mapstoleft|mapstodown|longmapsto|dotsquare|downarrow|DoubleDot|nsubseteq|supsetneq|leftarrow|nsupseteq|subsetneq|ThinSpace|ngeqslant|subseteqq|HumpEqual|NotSubset|triangleq|NotCupCap|lesseqgtr|heartsuit|TripleDot|Leftarrow|Coproduct|Congruent|varpropto|complexes|gvertneqq|LeftArrow|LessTilde|supseteqq|MinusPlus|CircleDot|nleqslant|NotExists|gtreqless|nparallel|UnionPlus|LeftFloor|checkmark|CenterDot|centerdot|Mellintrf|gtrapprox|bigotimes|OverBrace|spadesuit|therefore|pitchfork|rationals|PlusMinus|Backslash|Therefore|DownBreve|backsimeq|backprime|DownArrow|nshortmid|Downarrow|lvertneqq|eqvparsl|imagline|imagpart|infintie|integers|Integral|intercal|LessLess|Uarrocir|intlarhk|sqsupset|angmsdaf|sqsubset|llcorner|vartheta|cupbrcap|lnapprox|Superset|SuchThat|succnsim|succneqq|angmsdag|biguplus|curlyvee|trpezium|Succeeds|NotTilde|bigwedge|angmsdah|angrtvbd|triminus|cwconint|fpartint|lrcorner|smeparsl|subseteq|urcorner|lurdshar|laemptyv|DDotrahd|approxeq|ldrushar|awconint|mapstoup|backcong|shortmid|triangle|geqslant|gesdotol|timesbar|circledR|circledS|setminus|multimap|naturals|scpolint|ncongdot|RightTee|boxminus|gnapprox|boxtimes|andslope|thicksim|angmsdaa|varsigma|cirfnint|rtriltri|angmsdab|rppolint|angmsdac|barwedge|drbkarow|clubsuit|thetasym|bsolhsub|capbrcup|dzigrarr|doteqdot|DotEqual|dotminus|UnderBar|NotEqual|realpart|otimesas|ulcorner|hksearow|hkswarow|parallel|PartialD|elinters|emptyset|plusacir|bbrktbrk|angmsdad|pointint|bigoplus|angmsdae|Precedes|bigsqcup|varkappa|notindot|supseteq|precneqq|precnsim|profalar|profline|profsurf|leqslant|lesdotor|raemptyv|subplus|notnivb|notnivc|subrarr|zigrarr|vzigzag|submult|subedot|Element|between|cirscir|larrbfs|larrsim|lotimes|lbrksld|lbrkslu|lozenge|ldrdhar|dbkarow|bigcirc|epsilon|simrarr|simplus|ltquest|Epsilon|luruhar|gtquest|maltese|npolint|eqcolon|npreceq|bigodot|ddagger|gtrless|bnequiv|harrcir|ddotseq|equivDD|backsim|demptyv|nsqsube|nsqsupe|Upsilon|nsubset|upsilon|minusdu|nsucceq|swarrow|nsupset|coloneq|searrow|boxplus|napprox|natural|asympeq|alefsym|congdot|nearrow|bigstar|diamond|supplus|tritime|LeftTee|nvinfin|triplus|NewLine|nvltrie|nvrtrie|nwarrow|nexists|Diamond|ruluhar|Implies|supmult|angzarr|suplarr|suphsub|questeq|because|digamma|Because|olcross|bemptyv|omicron|Omicron|rotimes|NoBreak|intprod|angrtvb|orderof|uwangle|suphsol|lesdoto|orslope|DownTee|realine|cudarrl|rdldhar|OverBar|supedot|lessdot|supdsub|topfork|succsim|rbrkslu|rbrksld|pertenk|cudarrr|isindot|planckh|lessgtr|pluscir|gesdoto|plussim|plustwo|lesssim|cularrp|rarrsim|Cayleys|notinva|notinvb|notinvc|UpArrow|Uparrow|uparrow|NotLess|dwangle|precsim|Product|curarrm|Cconint|dotplus|rarrbfs|ccupssm|Cedilla|cemptyv|notniva|quatint|frac35|frac38|frac45|frac56|frac58|frac78|tridot|xoplus|gacute|gammad|Gammad|lfisht|lfloor|bigcup|sqsupe|gbreve|Gbreve|lharul|sqsube|sqcups|Gcedil|apacir|llhard|lmidot|Lmidot|lmoust|andand|sqcaps|approx|Abreve|spades|circeq|tprime|divide|topcir|Assign|topbot|gesdot|divonx|xuplus|timesd|gesles|atilde|solbar|SOFTcy|loplus|timesb|lowast|lowbar|dlcorn|dlcrop|softcy|dollar|lparlt|thksim|lrhard|Atilde|lsaquo|smashp|bigvee|thinsp|wreath|bkarow|lsquor|lstrok|Lstrok|lthree|ltimes|ltlarr|DotDot|simdot|ltrPar|weierp|xsqcup|angmsd|sigmav|sigmaf|zeetrf|Zcaron|zcaron|mapsto|vsupne|thetav|cirmid|marker|mcomma|Zacute|vsubnE|there4|gtlPar|vsubne|bottom|gtrarr|SHCHcy|shchcy|midast|midcir|middot|minusb|minusd|gtrdot|bowtie|sfrown|mnplus|models|colone|seswar|Colone|mstpos|searhk|gtrsim|nacute|Nacute|boxbox|telrec|hairsp|Tcedil|nbumpe|scnsim|ncaron|Ncaron|ncedil|Ncedil|hamilt|Scedil|nearhk|hardcy|HARDcy|tcedil|Tcaron|commat|nequiv|nesear|tcaron|target|hearts|nexist|varrho|scedil|Scaron|scaron|hellip|Sacute|sacute|hercon|swnwar|compfn|rtimes|rthree|rsquor|rsaquo|zacute|wedgeq|homtht|barvee|barwed|Barwed|rpargt|horbar|conint|swarhk|roplus|nltrie|hslash|hstrok|Hstrok|rmoust|Conint|bprime|hybull|hyphen|iacute|Iacute|supsup|supsub|supsim|varphi|coprod|brvbar|agrave|Supset|supset|igrave|Igrave|notinE|Agrave|iiiint|iinfin|copysr|wedbar|Verbar|vangrt|becaus|incare|verbar|inodot|bullet|drcorn|intcal|drcrop|cularr|vellip|Utilde|bumpeq|cupcap|dstrok|Dstrok|CupCap|cupcup|cupdot|eacute|Eacute|supdot|iquest|easter|ecaron|Ecaron|ecolon|isinsv|utilde|itilde|Itilde|curarr|succeq|Bumpeq|cacute|ulcrop|nparsl|Cacute|nprcue|egrave|Egrave|nrarrc|nrarrw|subsup|subsub|nrtrie|jsercy|nsccue|Jsercy|kappav|kcedil|Kcedil|subsim|ulcorn|nsimeq|egsdot|veebar|kgreen|capand|elsdot|Subset|subset|curren|aacute|lacute|Lacute|emptyv|ntilde|Ntilde|lagran|lambda|Lambda|capcap|Ugrave|langle|subdot|emsp13|numero|emsp14|nvdash|nvDash|nVdash|nVDash|ugrave|ufisht|nvHarr|larrfs|nvlArr|larrhk|larrlp|larrpl|nvrArr|Udblac|nwarhk|larrtl|nwnear|oacute|Oacute|latail|lAtail|sstarf|lbrace|odblac|Odblac|lbrack|udblac|odsold|eparsl|lcaron|Lcaron|ograve|Ograve|lcedil|Lcedil|Aacute|ssmile|ssetmn|squarf|ldquor|capcup|ominus|cylcty|rharul|eqcirc|dagger|rfloor|rfisht|Dagger|daleth|equals|origof|capdot|equest|dcaron|Dcaron|rdquor|oslash|Oslash|otilde|Otilde|otimes|Otimes|urcrop|Ubreve|ubreve|Yacute|Uacute|uacute|Rcedil|rcedil|urcorn|parsim|Rcaron|Vdashl|rcaron|Tstrok|percnt|period|permil|Exists|yacute|rbrack|rbrace|phmmat|ccaron|Ccaron|planck|ccedil|plankv|tstrok|female|plusdo|plusdu|ffilig|plusmn|ffllig|Ccedil|rAtail|dfisht|bernou|ratail|Rarrtl|rarrtl|angsph|rarrpl|rarrlp|rarrhk|xwedge|xotime|forall|ForAll|Vvdash|vsupnE|preceq|bigcap|frac12|frac13|frac14|primes|rarrfs|prnsim|frac15|Square|frac16|square|lesdot|frac18|frac23|propto|prurel|rarrap|rangle|puncsp|frac25|Racute|qprime|racute|lesges|frac34|abreve|AElig|eqsim|utdot|setmn|urtri|Equal|Uring|seArr|uring|searr|dashv|Dashv|mumap|nabla|iogon|Iogon|sdote|sdotb|scsim|napid|napos|equiv|natur|Acirc|dblac|erarr|nbump|iprod|erDot|ucirc|awint|esdot|angrt|ncong|isinE|scnap|Scirc|scirc|ndash|isins|Ubrcy|nearr|neArr|isinv|nedot|ubrcy|acute|Ycirc|iukcy|Iukcy|xutri|nesim|caret|jcirc|Jcirc|caron|twixt|ddarr|sccue|exist|jmath|sbquo|ngeqq|angst|ccaps|lceil|ngsim|UpTee|delta|Delta|rtrif|nharr|nhArr|nhpar|rtrie|jukcy|Jukcy|kappa|rsquo|Kappa|nlarr|nlArr|TSHcy|rrarr|aogon|Aogon|fflig|xrarr|tshcy|ccirc|nleqq|filig|upsih|nless|dharl|nlsim|fjlig|ropar|nltri|dharr|robrk|roarr|fllig|fltns|roang|rnmid|subnE|subne|lAarr|trisb|Ccirc|acirc|ccups|blank|VDash|forkv|Vdash|langd|cedil|blk12|blk14|laquo|strns|diams|notin|vDash|larrb|blk34|block|disin|uplus|vdash|vBarv|aelig|starf|Wedge|check|xrArr|lates|lbarr|lBarr|notni|lbbrk|bcong|frasl|lbrke|frown|vrtri|vprop|vnsup|gamma|Gamma|wedge|xodot|bdquo|srarr|doteq|ldquo|boxdl|boxdL|gcirc|Gcirc|boxDl|boxDL|boxdr|boxdR|boxDr|TRADE|trade|rlhar|boxDR|vnsub|npart|vltri|rlarr|boxhd|boxhD|nprec|gescc|nrarr|nrArr|boxHd|boxHD|boxhu|boxhU|nrtri|boxHu|clubs|boxHU|times|colon|Colon|gimel|xlArr|Tilde|nsime|tilde|nsmid|nspar|THORN|thorn|xlarr|nsube|nsubE|thkap|xhArr|comma|nsucc|boxul|boxuL|nsupe|nsupE|gneqq|gnsim|boxUl|boxUL|grave|boxur|boxuR|boxUr|boxUR|lescc|angle|bepsi|boxvh|varpi|boxvH|numsp|Theta|gsime|gsiml|theta|boxVh|boxVH|boxvl|gtcir|gtdot|boxvL|boxVl|boxVL|crarr|cross|Cross|nvsim|boxvr|nwarr|nwArr|sqsup|dtdot|Uogon|lhard|lharu|dtrif|ocirc|Ocirc|lhblk|duarr|odash|sqsub|Hacek|sqcup|llarr|duhar|oelig|OElig|ofcir|boxvR|uogon|lltri|boxVr|csube|uuarr|ohbar|csupe|ctdot|olarr|olcir|harrw|oline|sqcap|omacr|Omacr|omega|Omega|boxVR|aleph|lneqq|lnsim|loang|loarr|rharu|lobrk|hcirc|operp|oplus|rhard|Hcirc|orarr|Union|order|ecirc|Ecirc|cuepr|szlig|cuesc|breve|reals|eDDot|Breve|hoarr|lopar|utrif|rdquo|Umacr|umacr|efDot|swArr|ultri|alpha|rceil|ovbar|swarr|Wcirc|wcirc|smtes|smile|bsemi|lrarr|aring|parsl|lrhar|bsime|uhblk|lrtri|cupor|Aring|uharr|uharl|slarr|rbrke|bsolb|lsime|rbbrk|RBarr|lsimg|phone|rBarr|rbarr|icirc|lsquo|Icirc|emacr|Emacr|ratio|simne|plusb|simlE|simgE|simeq|pluse|ltcir|ltdot|empty|xharr|xdtri|iexcl|Alpha|ltrie|rarrw|pound|ltrif|xcirc|bumpe|prcue|bumpE|asymp|amacr|cuvee|Sigma|sigma|iiint|udhar|iiota|ijlig|IJlig|supnE|imacr|Imacr|prime|Prime|image|prnap|eogon|Eogon|rarrc|mdash|mDDot|cuwed|imath|supne|imped|Amacr|udarr|prsim|micro|rarrb|cwint|raquo|infin|eplus|range|rangd|Ucirc|radic|minus|amalg|veeeq|rAarr|epsiv|ycirc|quest|sharp|quot|zwnj|Qscr|race|qscr|Qopf|qopf|qint|rang|Rang|Zscr|zscr|Zopf|zopf|rarr|rArr|Rarr|Pscr|pscr|prop|prod|prnE|prec|ZHcy|zhcy|prap|Zeta|zeta|Popf|popf|Zdot|plus|zdot|Yuml|yuml|phiv|YUcy|yucy|Yscr|yscr|perp|Yopf|yopf|part|para|YIcy|Ouml|rcub|yicy|YAcy|rdca|ouml|osol|Oscr|rdsh|yacy|real|oscr|xvee|andd|rect|andv|Xscr|oror|ordm|ordf|xscr|ange|aopf|Aopf|rHar|Xopf|opar|Oopf|xopf|xnis|rhov|oopf|omid|xmap|oint|apid|apos|ogon|ascr|Ascr|odot|odiv|xcup|xcap|ocir|oast|nvlt|nvle|nvgt|nvge|nvap|Wscr|wscr|auml|ntlg|ntgl|nsup|nsub|nsim|Nscr|nscr|nsce|Wopf|ring|npre|wopf|npar|Auml|Barv|bbrk|Nopf|nopf|nmid|nLtv|beta|ropf|Ropf|Beta|beth|nles|rpar|nleq|bnot|bNot|nldr|NJcy|rscr|Rscr|Vscr|vscr|rsqb|njcy|bopf|nisd|Bopf|rtri|Vopf|nGtv|ngtr|vopf|boxh|boxH|boxv|nges|ngeq|boxV|bscr|scap|Bscr|bsim|Vert|vert|bsol|bull|bump|caps|cdot|ncup|scnE|ncap|nbsp|napE|Cdot|cent|sdot|Vbar|nang|vBar|chcy|Mscr|mscr|sect|semi|CHcy|Mopf|mopf|sext|circ|cire|mldr|mlcp|cirE|comp|shcy|SHcy|vArr|varr|cong|copf|Copf|copy|COPY|malt|male|macr|lvnE|cscr|ltri|sime|ltcc|simg|Cscr|siml|csub|Uuml|lsqb|lsim|uuml|csup|Lscr|lscr|utri|smid|lpar|cups|smte|lozf|darr|Lopf|Uscr|solb|lopf|sopf|Sopf|lneq|uscr|spar|dArr|lnap|Darr|dash|Sqrt|LJcy|ljcy|lHar|dHar|Upsi|upsi|diam|lesg|djcy|DJcy|leqq|dopf|Dopf|dscr|Dscr|dscy|ldsh|ldca|squf|DScy|sscr|Sscr|dsol|lcub|late|star|Star|Uopf|Larr|lArr|larr|uopf|dtri|dzcy|sube|subE|Lang|lang|Kscr|kscr|Kopf|kopf|KJcy|kjcy|KHcy|khcy|DZcy|ecir|edot|eDot|Jscr|jscr|succ|Jopf|jopf|Edot|uHar|emsp|ensp|Iuml|iuml|eopf|isin|Iscr|iscr|Eopf|epar|sung|epsi|escr|sup1|sup2|sup3|Iota|iota|supe|supE|Iopf|iopf|IOcy|iocy|Escr|esim|Esim|imof|Uarr|QUOT|uArr|uarr|euml|IEcy|iecy|Idot|Euml|euro|excl|Hscr|hscr|Hopf|hopf|TScy|tscy|Tscr|hbar|tscr|flat|tbrk|fnof|hArr|harr|half|fopf|Fopf|tdot|gvnE|fork|trie|gtcc|fscr|Fscr|gdot|gsim|Gscr|gscr|Gopf|gopf|gneq|Gdot|tosa|gnap|Topf|topf|geqq|toea|GJcy|gjcy|tint|gesl|mid|Sfr|ggg|top|ges|gla|glE|glj|geq|gne|gEl|gel|gnE|Gcy|gcy|gap|Tfr|tfr|Tcy|tcy|Hat|Tau|Ffr|tau|Tab|hfr|Hfr|ffr|Fcy|fcy|icy|Icy|iff|ETH|eth|ifr|Ifr|Eta|eta|int|Int|Sup|sup|ucy|Ucy|Sum|sum|jcy|ENG|ufr|Ufr|eng|Jcy|jfr|els|ell|egs|Efr|efr|Jfr|uml|kcy|Kcy|Ecy|ecy|kfr|Kfr|lap|Sub|sub|lat|lcy|Lcy|leg|Dot|dot|lEg|leq|les|squ|div|die|lfr|Lfr|lgE|Dfr|dfr|Del|deg|Dcy|dcy|lne|lnE|sol|loz|smt|Cup|lrm|cup|lsh|Lsh|sim|shy|map|Map|mcy|Mcy|mfr|Mfr|mho|gfr|Gfr|sfr|cir|Chi|chi|nap|Cfr|vcy|Vcy|cfr|Scy|scy|ncy|Ncy|vee|Vee|Cap|cap|nfr|scE|sce|Nfr|nge|ngE|nGg|vfr|Vfr|ngt|bot|nGt|nis|niv|Rsh|rsh|nle|nlE|bne|Bfr|bfr|nLl|nlt|nLt|Bcy|bcy|not|Not|rlm|wfr|Wfr|npr|nsc|num|ocy|ast|Ocy|ofr|xfr|Xfr|Ofr|ogt|ohm|apE|olt|Rho|ape|rho|Rfr|rfr|ord|REG|ang|reg|orv|And|and|AMP|Rcy|amp|Afr|ycy|Ycy|yen|yfr|Yfr|rcy|par|pcy|Pcy|pfr|Pfr|phi|Phi|afr|Acy|acy|zcy|Zcy|piv|acE|acd|zfr|Zfr|pre|prE|psi|Psi|qfr|Qfr|zwj|Or|ge|Gg|gt|gg|el|oS|lt|Lt|LT|Re|lg|gl|eg|ne|Im|it|le|DD|wp|wr|nu|Nu|dd|lE|Sc|sc|pi|Pi|ee|af|ll|Ll|rx|gE|xi|pm|Xi|ic|pr|Pr|in|ni|mp|mu|ac|Mu|or|ap|Gt|GT|ii);|&(Aacute|Agrave|Atilde|Ccedil|Eacute|Egrave|Iacute|Igrave|Ntilde|Oacute|Ograve|Oslash|Otilde|Uacute|Ugrave|Yacute|aacute|agrave|atilde|brvbar|ccedil|curren|divide|eacute|egrave|frac12|frac14|frac34|iacute|igrave|iquest|middot|ntilde|oacute|ograve|oslash|otilde|plusmn|uacute|ugrave|yacute|AElig|Acirc|Aring|Ecirc|Icirc|Ocirc|THORN|Ucirc|acirc|acute|aelig|aring|cedil|ecirc|icirc|iexcl|laquo|micro|ocirc|pound|raquo|szlig|thorn|times|ucirc|Auml|COPY|Euml|Iuml|Ouml|QUOT|Uuml|auml|cent|copy|euml|iuml|macr|nbsp|ordf|ordm|ouml|para|quot|sect|sup1|sup2|sup3|uuml|yuml|AMP|ETH|REG|amp|deg|eth|not|reg|shy|uml|yen|GT|LT|gt|lt)(?!;)([=a-zA-Z0-9]?)|&#([0-9]+)(;?)|&#[xX]([a-fA-F0-9]+)(;?)|&([0-9a-zA-Z]+)/g;
		var decodeMap = {'aacute':'\xE1','Aacute':'\xC1','abreve':'\u0103','Abreve':'\u0102','ac':'\u223E','acd':'\u223F','acE':'\u223E\u0333','acirc':'\xE2','Acirc':'\xC2','acute':'\xB4','acy':'\u0430','Acy':'\u0410','aelig':'\xE6','AElig':'\xC6','af':'\u2061','afr':'\uD835\uDD1E','Afr':'\uD835\uDD04','agrave':'\xE0','Agrave':'\xC0','alefsym':'\u2135','aleph':'\u2135','alpha':'\u03B1','Alpha':'\u0391','amacr':'\u0101','Amacr':'\u0100','amalg':'\u2A3F','amp':'&','AMP':'&','and':'\u2227','And':'\u2A53','andand':'\u2A55','andd':'\u2A5C','andslope':'\u2A58','andv':'\u2A5A','ang':'\u2220','ange':'\u29A4','angle':'\u2220','angmsd':'\u2221','angmsdaa':'\u29A8','angmsdab':'\u29A9','angmsdac':'\u29AA','angmsdad':'\u29AB','angmsdae':'\u29AC','angmsdaf':'\u29AD','angmsdag':'\u29AE','angmsdah':'\u29AF','angrt':'\u221F','angrtvb':'\u22BE','angrtvbd':'\u299D','angsph':'\u2222','angst':'\xC5','angzarr':'\u237C','aogon':'\u0105','Aogon':'\u0104','aopf':'\uD835\uDD52','Aopf':'\uD835\uDD38','ap':'\u2248','apacir':'\u2A6F','ape':'\u224A','apE':'\u2A70','apid':'\u224B','apos':'\'','ApplyFunction':'\u2061','approx':'\u2248','approxeq':'\u224A','aring':'\xE5','Aring':'\xC5','ascr':'\uD835\uDCB6','Ascr':'\uD835\uDC9C','Assign':'\u2254','ast':'*','asymp':'\u2248','asympeq':'\u224D','atilde':'\xE3','Atilde':'\xC3','auml':'\xE4','Auml':'\xC4','awconint':'\u2233','awint':'\u2A11','backcong':'\u224C','backepsilon':'\u03F6','backprime':'\u2035','backsim':'\u223D','backsimeq':'\u22CD','Backslash':'\u2216','Barv':'\u2AE7','barvee':'\u22BD','barwed':'\u2305','Barwed':'\u2306','barwedge':'\u2305','bbrk':'\u23B5','bbrktbrk':'\u23B6','bcong':'\u224C','bcy':'\u0431','Bcy':'\u0411','bdquo':'\u201E','becaus':'\u2235','because':'\u2235','Because':'\u2235','bemptyv':'\u29B0','bepsi':'\u03F6','bernou':'\u212C','Bernoullis':'\u212C','beta':'\u03B2','Beta':'\u0392','beth':'\u2136','between':'\u226C','bfr':'\uD835\uDD1F','Bfr':'\uD835\uDD05','bigcap':'\u22C2','bigcirc':'\u25EF','bigcup':'\u22C3','bigodot':'\u2A00','bigoplus':'\u2A01','bigotimes':'\u2A02','bigsqcup':'\u2A06','bigstar':'\u2605','bigtriangledown':'\u25BD','bigtriangleup':'\u25B3','biguplus':'\u2A04','bigvee':'\u22C1','bigwedge':'\u22C0','bkarow':'\u290D','blacklozenge':'\u29EB','blacksquare':'\u25AA','blacktriangle':'\u25B4','blacktriangledown':'\u25BE','blacktriangleleft':'\u25C2','blacktriangleright':'\u25B8','blank':'\u2423','blk12':'\u2592','blk14':'\u2591','blk34':'\u2593','block':'\u2588','bne':'=\u20E5','bnequiv':'\u2261\u20E5','bnot':'\u2310','bNot':'\u2AED','bopf':'\uD835\uDD53','Bopf':'\uD835\uDD39','bot':'\u22A5','bottom':'\u22A5','bowtie':'\u22C8','boxbox':'\u29C9','boxdl':'\u2510','boxdL':'\u2555','boxDl':'\u2556','boxDL':'\u2557','boxdr':'\u250C','boxdR':'\u2552','boxDr':'\u2553','boxDR':'\u2554','boxh':'\u2500','boxH':'\u2550','boxhd':'\u252C','boxhD':'\u2565','boxHd':'\u2564','boxHD':'\u2566','boxhu':'\u2534','boxhU':'\u2568','boxHu':'\u2567','boxHU':'\u2569','boxminus':'\u229F','boxplus':'\u229E','boxtimes':'\u22A0','boxul':'\u2518','boxuL':'\u255B','boxUl':'\u255C','boxUL':'\u255D','boxur':'\u2514','boxuR':'\u2558','boxUr':'\u2559','boxUR':'\u255A','boxv':'\u2502','boxV':'\u2551','boxvh':'\u253C','boxvH':'\u256A','boxVh':'\u256B','boxVH':'\u256C','boxvl':'\u2524','boxvL':'\u2561','boxVl':'\u2562','boxVL':'\u2563','boxvr':'\u251C','boxvR':'\u255E','boxVr':'\u255F','boxVR':'\u2560','bprime':'\u2035','breve':'\u02D8','Breve':'\u02D8','brvbar':'\xA6','bscr':'\uD835\uDCB7','Bscr':'\u212C','bsemi':'\u204F','bsim':'\u223D','bsime':'\u22CD','bsol':'\\','bsolb':'\u29C5','bsolhsub':'\u27C8','bull':'\u2022','bullet':'\u2022','bump':'\u224E','bumpe':'\u224F','bumpE':'\u2AAE','bumpeq':'\u224F','Bumpeq':'\u224E','cacute':'\u0107','Cacute':'\u0106','cap':'\u2229','Cap':'\u22D2','capand':'\u2A44','capbrcup':'\u2A49','capcap':'\u2A4B','capcup':'\u2A47','capdot':'\u2A40','CapitalDifferentialD':'\u2145','caps':'\u2229\uFE00','caret':'\u2041','caron':'\u02C7','Cayleys':'\u212D','ccaps':'\u2A4D','ccaron':'\u010D','Ccaron':'\u010C','ccedil':'\xE7','Ccedil':'\xC7','ccirc':'\u0109','Ccirc':'\u0108','Cconint':'\u2230','ccups':'\u2A4C','ccupssm':'\u2A50','cdot':'\u010B','Cdot':'\u010A','cedil':'\xB8','Cedilla':'\xB8','cemptyv':'\u29B2','cent':'\xA2','centerdot':'\xB7','CenterDot':'\xB7','cfr':'\uD835\uDD20','Cfr':'\u212D','chcy':'\u0447','CHcy':'\u0427','check':'\u2713','checkmark':'\u2713','chi':'\u03C7','Chi':'\u03A7','cir':'\u25CB','circ':'\u02C6','circeq':'\u2257','circlearrowleft':'\u21BA','circlearrowright':'\u21BB','circledast':'\u229B','circledcirc':'\u229A','circleddash':'\u229D','CircleDot':'\u2299','circledR':'\xAE','circledS':'\u24C8','CircleMinus':'\u2296','CirclePlus':'\u2295','CircleTimes':'\u2297','cire':'\u2257','cirE':'\u29C3','cirfnint':'\u2A10','cirmid':'\u2AEF','cirscir':'\u29C2','ClockwiseContourIntegral':'\u2232','CloseCurlyDoubleQuote':'\u201D','CloseCurlyQuote':'\u2019','clubs':'\u2663','clubsuit':'\u2663','colon':':','Colon':'\u2237','colone':'\u2254','Colone':'\u2A74','coloneq':'\u2254','comma':',','commat':'@','comp':'\u2201','compfn':'\u2218','complement':'\u2201','complexes':'\u2102','cong':'\u2245','congdot':'\u2A6D','Congruent':'\u2261','conint':'\u222E','Conint':'\u222F','ContourIntegral':'\u222E','copf':'\uD835\uDD54','Copf':'\u2102','coprod':'\u2210','Coproduct':'\u2210','copy':'\xA9','COPY':'\xA9','copysr':'\u2117','CounterClockwiseContourIntegral':'\u2233','crarr':'\u21B5','cross':'\u2717','Cross':'\u2A2F','cscr':'\uD835\uDCB8','Cscr':'\uD835\uDC9E','csub':'\u2ACF','csube':'\u2AD1','csup':'\u2AD0','csupe':'\u2AD2','ctdot':'\u22EF','cudarrl':'\u2938','cudarrr':'\u2935','cuepr':'\u22DE','cuesc':'\u22DF','cularr':'\u21B6','cularrp':'\u293D','cup':'\u222A','Cup':'\u22D3','cupbrcap':'\u2A48','cupcap':'\u2A46','CupCap':'\u224D','cupcup':'\u2A4A','cupdot':'\u228D','cupor':'\u2A45','cups':'\u222A\uFE00','curarr':'\u21B7','curarrm':'\u293C','curlyeqprec':'\u22DE','curlyeqsucc':'\u22DF','curlyvee':'\u22CE','curlywedge':'\u22CF','curren':'\xA4','curvearrowleft':'\u21B6','curvearrowright':'\u21B7','cuvee':'\u22CE','cuwed':'\u22CF','cwconint':'\u2232','cwint':'\u2231','cylcty':'\u232D','dagger':'\u2020','Dagger':'\u2021','daleth':'\u2138','darr':'\u2193','dArr':'\u21D3','Darr':'\u21A1','dash':'\u2010','dashv':'\u22A3','Dashv':'\u2AE4','dbkarow':'\u290F','dblac':'\u02DD','dcaron':'\u010F','Dcaron':'\u010E','dcy':'\u0434','Dcy':'\u0414','dd':'\u2146','DD':'\u2145','ddagger':'\u2021','ddarr':'\u21CA','DDotrahd':'\u2911','ddotseq':'\u2A77','deg':'\xB0','Del':'\u2207','delta':'\u03B4','Delta':'\u0394','demptyv':'\u29B1','dfisht':'\u297F','dfr':'\uD835\uDD21','Dfr':'\uD835\uDD07','dHar':'\u2965','dharl':'\u21C3','dharr':'\u21C2','DiacriticalAcute':'\xB4','DiacriticalDot':'\u02D9','DiacriticalDoubleAcute':'\u02DD','DiacriticalGrave':'`','DiacriticalTilde':'\u02DC','diam':'\u22C4','diamond':'\u22C4','Diamond':'\u22C4','diamondsuit':'\u2666','diams':'\u2666','die':'\xA8','DifferentialD':'\u2146','digamma':'\u03DD','disin':'\u22F2','div':'\xF7','divide':'\xF7','divideontimes':'\u22C7','divonx':'\u22C7','djcy':'\u0452','DJcy':'\u0402','dlcorn':'\u231E','dlcrop':'\u230D','dollar':'$','dopf':'\uD835\uDD55','Dopf':'\uD835\uDD3B','dot':'\u02D9','Dot':'\xA8','DotDot':'\u20DC','doteq':'\u2250','doteqdot':'\u2251','DotEqual':'\u2250','dotminus':'\u2238','dotplus':'\u2214','dotsquare':'\u22A1','doublebarwedge':'\u2306','DoubleContourIntegral':'\u222F','DoubleDot':'\xA8','DoubleDownArrow':'\u21D3','DoubleLeftArrow':'\u21D0','DoubleLeftRightArrow':'\u21D4','DoubleLeftTee':'\u2AE4','DoubleLongLeftArrow':'\u27F8','DoubleLongLeftRightArrow':'\u27FA','DoubleLongRightArrow':'\u27F9','DoubleRightArrow':'\u21D2','DoubleRightTee':'\u22A8','DoubleUpArrow':'\u21D1','DoubleUpDownArrow':'\u21D5','DoubleVerticalBar':'\u2225','downarrow':'\u2193','Downarrow':'\u21D3','DownArrow':'\u2193','DownArrowBar':'\u2913','DownArrowUpArrow':'\u21F5','DownBreve':'\u0311','downdownarrows':'\u21CA','downharpoonleft':'\u21C3','downharpoonright':'\u21C2','DownLeftRightVector':'\u2950','DownLeftTeeVector':'\u295E','DownLeftVector':'\u21BD','DownLeftVectorBar':'\u2956','DownRightTeeVector':'\u295F','DownRightVector':'\u21C1','DownRightVectorBar':'\u2957','DownTee':'\u22A4','DownTeeArrow':'\u21A7','drbkarow':'\u2910','drcorn':'\u231F','drcrop':'\u230C','dscr':'\uD835\uDCB9','Dscr':'\uD835\uDC9F','dscy':'\u0455','DScy':'\u0405','dsol':'\u29F6','dstrok':'\u0111','Dstrok':'\u0110','dtdot':'\u22F1','dtri':'\u25BF','dtrif':'\u25BE','duarr':'\u21F5','duhar':'\u296F','dwangle':'\u29A6','dzcy':'\u045F','DZcy':'\u040F','dzigrarr':'\u27FF','eacute':'\xE9','Eacute':'\xC9','easter':'\u2A6E','ecaron':'\u011B','Ecaron':'\u011A','ecir':'\u2256','ecirc':'\xEA','Ecirc':'\xCA','ecolon':'\u2255','ecy':'\u044D','Ecy':'\u042D','eDDot':'\u2A77','edot':'\u0117','eDot':'\u2251','Edot':'\u0116','ee':'\u2147','efDot':'\u2252','efr':'\uD835\uDD22','Efr':'\uD835\uDD08','eg':'\u2A9A','egrave':'\xE8','Egrave':'\xC8','egs':'\u2A96','egsdot':'\u2A98','el':'\u2A99','Element':'\u2208','elinters':'\u23E7','ell':'\u2113','els':'\u2A95','elsdot':'\u2A97','emacr':'\u0113','Emacr':'\u0112','empty':'\u2205','emptyset':'\u2205','EmptySmallSquare':'\u25FB','emptyv':'\u2205','EmptyVerySmallSquare':'\u25AB','emsp':'\u2003','emsp13':'\u2004','emsp14':'\u2005','eng':'\u014B','ENG':'\u014A','ensp':'\u2002','eogon':'\u0119','Eogon':'\u0118','eopf':'\uD835\uDD56','Eopf':'\uD835\uDD3C','epar':'\u22D5','eparsl':'\u29E3','eplus':'\u2A71','epsi':'\u03B5','epsilon':'\u03B5','Epsilon':'\u0395','epsiv':'\u03F5','eqcirc':'\u2256','eqcolon':'\u2255','eqsim':'\u2242','eqslantgtr':'\u2A96','eqslantless':'\u2A95','Equal':'\u2A75','equals':'=','EqualTilde':'\u2242','equest':'\u225F','Equilibrium':'\u21CC','equiv':'\u2261','equivDD':'\u2A78','eqvparsl':'\u29E5','erarr':'\u2971','erDot':'\u2253','escr':'\u212F','Escr':'\u2130','esdot':'\u2250','esim':'\u2242','Esim':'\u2A73','eta':'\u03B7','Eta':'\u0397','eth':'\xF0','ETH':'\xD0','euml':'\xEB','Euml':'\xCB','euro':'\u20AC','excl':'!','exist':'\u2203','Exists':'\u2203','expectation':'\u2130','exponentiale':'\u2147','ExponentialE':'\u2147','fallingdotseq':'\u2252','fcy':'\u0444','Fcy':'\u0424','female':'\u2640','ffilig':'\uFB03','fflig':'\uFB00','ffllig':'\uFB04','ffr':'\uD835\uDD23','Ffr':'\uD835\uDD09','filig':'\uFB01','FilledSmallSquare':'\u25FC','FilledVerySmallSquare':'\u25AA','fjlig':'fj','flat':'\u266D','fllig':'\uFB02','fltns':'\u25B1','fnof':'\u0192','fopf':'\uD835\uDD57','Fopf':'\uD835\uDD3D','forall':'\u2200','ForAll':'\u2200','fork':'\u22D4','forkv':'\u2AD9','Fouriertrf':'\u2131','fpartint':'\u2A0D','frac12':'\xBD','frac13':'\u2153','frac14':'\xBC','frac15':'\u2155','frac16':'\u2159','frac18':'\u215B','frac23':'\u2154','frac25':'\u2156','frac34':'\xBE','frac35':'\u2157','frac38':'\u215C','frac45':'\u2158','frac56':'\u215A','frac58':'\u215D','frac78':'\u215E','frasl':'\u2044','frown':'\u2322','fscr':'\uD835\uDCBB','Fscr':'\u2131','gacute':'\u01F5','gamma':'\u03B3','Gamma':'\u0393','gammad':'\u03DD','Gammad':'\u03DC','gap':'\u2A86','gbreve':'\u011F','Gbreve':'\u011E','Gcedil':'\u0122','gcirc':'\u011D','Gcirc':'\u011C','gcy':'\u0433','Gcy':'\u0413','gdot':'\u0121','Gdot':'\u0120','ge':'\u2265','gE':'\u2267','gel':'\u22DB','gEl':'\u2A8C','geq':'\u2265','geqq':'\u2267','geqslant':'\u2A7E','ges':'\u2A7E','gescc':'\u2AA9','gesdot':'\u2A80','gesdoto':'\u2A82','gesdotol':'\u2A84','gesl':'\u22DB\uFE00','gesles':'\u2A94','gfr':'\uD835\uDD24','Gfr':'\uD835\uDD0A','gg':'\u226B','Gg':'\u22D9','ggg':'\u22D9','gimel':'\u2137','gjcy':'\u0453','GJcy':'\u0403','gl':'\u2277','gla':'\u2AA5','glE':'\u2A92','glj':'\u2AA4','gnap':'\u2A8A','gnapprox':'\u2A8A','gne':'\u2A88','gnE':'\u2269','gneq':'\u2A88','gneqq':'\u2269','gnsim':'\u22E7','gopf':'\uD835\uDD58','Gopf':'\uD835\uDD3E','grave':'`','GreaterEqual':'\u2265','GreaterEqualLess':'\u22DB','GreaterFullEqual':'\u2267','GreaterGreater':'\u2AA2','GreaterLess':'\u2277','GreaterSlantEqual':'\u2A7E','GreaterTilde':'\u2273','gscr':'\u210A','Gscr':'\uD835\uDCA2','gsim':'\u2273','gsime':'\u2A8E','gsiml':'\u2A90','gt':'>','Gt':'\u226B','GT':'>','gtcc':'\u2AA7','gtcir':'\u2A7A','gtdot':'\u22D7','gtlPar':'\u2995','gtquest':'\u2A7C','gtrapprox':'\u2A86','gtrarr':'\u2978','gtrdot':'\u22D7','gtreqless':'\u22DB','gtreqqless':'\u2A8C','gtrless':'\u2277','gtrsim':'\u2273','gvertneqq':'\u2269\uFE00','gvnE':'\u2269\uFE00','Hacek':'\u02C7','hairsp':'\u200A','half':'\xBD','hamilt':'\u210B','hardcy':'\u044A','HARDcy':'\u042A','harr':'\u2194','hArr':'\u21D4','harrcir':'\u2948','harrw':'\u21AD','Hat':'^','hbar':'\u210F','hcirc':'\u0125','Hcirc':'\u0124','hearts':'\u2665','heartsuit':'\u2665','hellip':'\u2026','hercon':'\u22B9','hfr':'\uD835\uDD25','Hfr':'\u210C','HilbertSpace':'\u210B','hksearow':'\u2925','hkswarow':'\u2926','hoarr':'\u21FF','homtht':'\u223B','hookleftarrow':'\u21A9','hookrightarrow':'\u21AA','hopf':'\uD835\uDD59','Hopf':'\u210D','horbar':'\u2015','HorizontalLine':'\u2500','hscr':'\uD835\uDCBD','Hscr':'\u210B','hslash':'\u210F','hstrok':'\u0127','Hstrok':'\u0126','HumpDownHump':'\u224E','HumpEqual':'\u224F','hybull':'\u2043','hyphen':'\u2010','iacute':'\xED','Iacute':'\xCD','ic':'\u2063','icirc':'\xEE','Icirc':'\xCE','icy':'\u0438','Icy':'\u0418','Idot':'\u0130','iecy':'\u0435','IEcy':'\u0415','iexcl':'\xA1','iff':'\u21D4','ifr':'\uD835\uDD26','Ifr':'\u2111','igrave':'\xEC','Igrave':'\xCC','ii':'\u2148','iiiint':'\u2A0C','iiint':'\u222D','iinfin':'\u29DC','iiota':'\u2129','ijlig':'\u0133','IJlig':'\u0132','Im':'\u2111','imacr':'\u012B','Imacr':'\u012A','image':'\u2111','ImaginaryI':'\u2148','imagline':'\u2110','imagpart':'\u2111','imath':'\u0131','imof':'\u22B7','imped':'\u01B5','Implies':'\u21D2','in':'\u2208','incare':'\u2105','infin':'\u221E','infintie':'\u29DD','inodot':'\u0131','int':'\u222B','Int':'\u222C','intcal':'\u22BA','integers':'\u2124','Integral':'\u222B','intercal':'\u22BA','Intersection':'\u22C2','intlarhk':'\u2A17','intprod':'\u2A3C','InvisibleComma':'\u2063','InvisibleTimes':'\u2062','iocy':'\u0451','IOcy':'\u0401','iogon':'\u012F','Iogon':'\u012E','iopf':'\uD835\uDD5A','Iopf':'\uD835\uDD40','iota':'\u03B9','Iota':'\u0399','iprod':'\u2A3C','iquest':'\xBF','iscr':'\uD835\uDCBE','Iscr':'\u2110','isin':'\u2208','isindot':'\u22F5','isinE':'\u22F9','isins':'\u22F4','isinsv':'\u22F3','isinv':'\u2208','it':'\u2062','itilde':'\u0129','Itilde':'\u0128','iukcy':'\u0456','Iukcy':'\u0406','iuml':'\xEF','Iuml':'\xCF','jcirc':'\u0135','Jcirc':'\u0134','jcy':'\u0439','Jcy':'\u0419','jfr':'\uD835\uDD27','Jfr':'\uD835\uDD0D','jmath':'\u0237','jopf':'\uD835\uDD5B','Jopf':'\uD835\uDD41','jscr':'\uD835\uDCBF','Jscr':'\uD835\uDCA5','jsercy':'\u0458','Jsercy':'\u0408','jukcy':'\u0454','Jukcy':'\u0404','kappa':'\u03BA','Kappa':'\u039A','kappav':'\u03F0','kcedil':'\u0137','Kcedil':'\u0136','kcy':'\u043A','Kcy':'\u041A','kfr':'\uD835\uDD28','Kfr':'\uD835\uDD0E','kgreen':'\u0138','khcy':'\u0445','KHcy':'\u0425','kjcy':'\u045C','KJcy':'\u040C','kopf':'\uD835\uDD5C','Kopf':'\uD835\uDD42','kscr':'\uD835\uDCC0','Kscr':'\uD835\uDCA6','lAarr':'\u21DA','lacute':'\u013A','Lacute':'\u0139','laemptyv':'\u29B4','lagran':'\u2112','lambda':'\u03BB','Lambda':'\u039B','lang':'\u27E8','Lang':'\u27EA','langd':'\u2991','langle':'\u27E8','lap':'\u2A85','Laplacetrf':'\u2112','laquo':'\xAB','larr':'\u2190','lArr':'\u21D0','Larr':'\u219E','larrb':'\u21E4','larrbfs':'\u291F','larrfs':'\u291D','larrhk':'\u21A9','larrlp':'\u21AB','larrpl':'\u2939','larrsim':'\u2973','larrtl':'\u21A2','lat':'\u2AAB','latail':'\u2919','lAtail':'\u291B','late':'\u2AAD','lates':'\u2AAD\uFE00','lbarr':'\u290C','lBarr':'\u290E','lbbrk':'\u2772','lbrace':'{','lbrack':'[','lbrke':'\u298B','lbrksld':'\u298F','lbrkslu':'\u298D','lcaron':'\u013E','Lcaron':'\u013D','lcedil':'\u013C','Lcedil':'\u013B','lceil':'\u2308','lcub':'{','lcy':'\u043B','Lcy':'\u041B','ldca':'\u2936','ldquo':'\u201C','ldquor':'\u201E','ldrdhar':'\u2967','ldrushar':'\u294B','ldsh':'\u21B2','le':'\u2264','lE':'\u2266','LeftAngleBracket':'\u27E8','leftarrow':'\u2190','Leftarrow':'\u21D0','LeftArrow':'\u2190','LeftArrowBar':'\u21E4','LeftArrowRightArrow':'\u21C6','leftarrowtail':'\u21A2','LeftCeiling':'\u2308','LeftDoubleBracket':'\u27E6','LeftDownTeeVector':'\u2961','LeftDownVector':'\u21C3','LeftDownVectorBar':'\u2959','LeftFloor':'\u230A','leftharpoondown':'\u21BD','leftharpoonup':'\u21BC','leftleftarrows':'\u21C7','leftrightarrow':'\u2194','Leftrightarrow':'\u21D4','LeftRightArrow':'\u2194','leftrightarrows':'\u21C6','leftrightharpoons':'\u21CB','leftrightsquigarrow':'\u21AD','LeftRightVector':'\u294E','LeftTee':'\u22A3','LeftTeeArrow':'\u21A4','LeftTeeVector':'\u295A','leftthreetimes':'\u22CB','LeftTriangle':'\u22B2','LeftTriangleBar':'\u29CF','LeftTriangleEqual':'\u22B4','LeftUpDownVector':'\u2951','LeftUpTeeVector':'\u2960','LeftUpVector':'\u21BF','LeftUpVectorBar':'\u2958','LeftVector':'\u21BC','LeftVectorBar':'\u2952','leg':'\u22DA','lEg':'\u2A8B','leq':'\u2264','leqq':'\u2266','leqslant':'\u2A7D','les':'\u2A7D','lescc':'\u2AA8','lesdot':'\u2A7F','lesdoto':'\u2A81','lesdotor':'\u2A83','lesg':'\u22DA\uFE00','lesges':'\u2A93','lessapprox':'\u2A85','lessdot':'\u22D6','lesseqgtr':'\u22DA','lesseqqgtr':'\u2A8B','LessEqualGreater':'\u22DA','LessFullEqual':'\u2266','LessGreater':'\u2276','lessgtr':'\u2276','LessLess':'\u2AA1','lesssim':'\u2272','LessSlantEqual':'\u2A7D','LessTilde':'\u2272','lfisht':'\u297C','lfloor':'\u230A','lfr':'\uD835\uDD29','Lfr':'\uD835\uDD0F','lg':'\u2276','lgE':'\u2A91','lHar':'\u2962','lhard':'\u21BD','lharu':'\u21BC','lharul':'\u296A','lhblk':'\u2584','ljcy':'\u0459','LJcy':'\u0409','ll':'\u226A','Ll':'\u22D8','llarr':'\u21C7','llcorner':'\u231E','Lleftarrow':'\u21DA','llhard':'\u296B','lltri':'\u25FA','lmidot':'\u0140','Lmidot':'\u013F','lmoust':'\u23B0','lmoustache':'\u23B0','lnap':'\u2A89','lnapprox':'\u2A89','lne':'\u2A87','lnE':'\u2268','lneq':'\u2A87','lneqq':'\u2268','lnsim':'\u22E6','loang':'\u27EC','loarr':'\u21FD','lobrk':'\u27E6','longleftarrow':'\u27F5','Longleftarrow':'\u27F8','LongLeftArrow':'\u27F5','longleftrightarrow':'\u27F7','Longleftrightarrow':'\u27FA','LongLeftRightArrow':'\u27F7','longmapsto':'\u27FC','longrightarrow':'\u27F6','Longrightarrow':'\u27F9','LongRightArrow':'\u27F6','looparrowleft':'\u21AB','looparrowright':'\u21AC','lopar':'\u2985','lopf':'\uD835\uDD5D','Lopf':'\uD835\uDD43','loplus':'\u2A2D','lotimes':'\u2A34','lowast':'\u2217','lowbar':'_','LowerLeftArrow':'\u2199','LowerRightArrow':'\u2198','loz':'\u25CA','lozenge':'\u25CA','lozf':'\u29EB','lpar':'(','lparlt':'\u2993','lrarr':'\u21C6','lrcorner':'\u231F','lrhar':'\u21CB','lrhard':'\u296D','lrm':'\u200E','lrtri':'\u22BF','lsaquo':'\u2039','lscr':'\uD835\uDCC1','Lscr':'\u2112','lsh':'\u21B0','Lsh':'\u21B0','lsim':'\u2272','lsime':'\u2A8D','lsimg':'\u2A8F','lsqb':'[','lsquo':'\u2018','lsquor':'\u201A','lstrok':'\u0142','Lstrok':'\u0141','lt':'<','Lt':'\u226A','LT':'<','ltcc':'\u2AA6','ltcir':'\u2A79','ltdot':'\u22D6','lthree':'\u22CB','ltimes':'\u22C9','ltlarr':'\u2976','ltquest':'\u2A7B','ltri':'\u25C3','ltrie':'\u22B4','ltrif':'\u25C2','ltrPar':'\u2996','lurdshar':'\u294A','luruhar':'\u2966','lvertneqq':'\u2268\uFE00','lvnE':'\u2268\uFE00','macr':'\xAF','male':'\u2642','malt':'\u2720','maltese':'\u2720','map':'\u21A6','Map':'\u2905','mapsto':'\u21A6','mapstodown':'\u21A7','mapstoleft':'\u21A4','mapstoup':'\u21A5','marker':'\u25AE','mcomma':'\u2A29','mcy':'\u043C','Mcy':'\u041C','mdash':'\u2014','mDDot':'\u223A','measuredangle':'\u2221','MediumSpace':'\u205F','Mellintrf':'\u2133','mfr':'\uD835\uDD2A','Mfr':'\uD835\uDD10','mho':'\u2127','micro':'\xB5','mid':'\u2223','midast':'*','midcir':'\u2AF0','middot':'\xB7','minus':'\u2212','minusb':'\u229F','minusd':'\u2238','minusdu':'\u2A2A','MinusPlus':'\u2213','mlcp':'\u2ADB','mldr':'\u2026','mnplus':'\u2213','models':'\u22A7','mopf':'\uD835\uDD5E','Mopf':'\uD835\uDD44','mp':'\u2213','mscr':'\uD835\uDCC2','Mscr':'\u2133','mstpos':'\u223E','mu':'\u03BC','Mu':'\u039C','multimap':'\u22B8','mumap':'\u22B8','nabla':'\u2207','nacute':'\u0144','Nacute':'\u0143','nang':'\u2220\u20D2','nap':'\u2249','napE':'\u2A70\u0338','napid':'\u224B\u0338','napos':'\u0149','napprox':'\u2249','natur':'\u266E','natural':'\u266E','naturals':'\u2115','nbsp':'\xA0','nbump':'\u224E\u0338','nbumpe':'\u224F\u0338','ncap':'\u2A43','ncaron':'\u0148','Ncaron':'\u0147','ncedil':'\u0146','Ncedil':'\u0145','ncong':'\u2247','ncongdot':'\u2A6D\u0338','ncup':'\u2A42','ncy':'\u043D','Ncy':'\u041D','ndash':'\u2013','ne':'\u2260','nearhk':'\u2924','nearr':'\u2197','neArr':'\u21D7','nearrow':'\u2197','nedot':'\u2250\u0338','NegativeMediumSpace':'\u200B','NegativeThickSpace':'\u200B','NegativeThinSpace':'\u200B','NegativeVeryThinSpace':'\u200B','nequiv':'\u2262','nesear':'\u2928','nesim':'\u2242\u0338','NestedGreaterGreater':'\u226B','NestedLessLess':'\u226A','NewLine':'\n','nexist':'\u2204','nexists':'\u2204','nfr':'\uD835\uDD2B','Nfr':'\uD835\uDD11','nge':'\u2271','ngE':'\u2267\u0338','ngeq':'\u2271','ngeqq':'\u2267\u0338','ngeqslant':'\u2A7E\u0338','nges':'\u2A7E\u0338','nGg':'\u22D9\u0338','ngsim':'\u2275','ngt':'\u226F','nGt':'\u226B\u20D2','ngtr':'\u226F','nGtv':'\u226B\u0338','nharr':'\u21AE','nhArr':'\u21CE','nhpar':'\u2AF2','ni':'\u220B','nis':'\u22FC','nisd':'\u22FA','niv':'\u220B','njcy':'\u045A','NJcy':'\u040A','nlarr':'\u219A','nlArr':'\u21CD','nldr':'\u2025','nle':'\u2270','nlE':'\u2266\u0338','nleftarrow':'\u219A','nLeftarrow':'\u21CD','nleftrightarrow':'\u21AE','nLeftrightarrow':'\u21CE','nleq':'\u2270','nleqq':'\u2266\u0338','nleqslant':'\u2A7D\u0338','nles':'\u2A7D\u0338','nless':'\u226E','nLl':'\u22D8\u0338','nlsim':'\u2274','nlt':'\u226E','nLt':'\u226A\u20D2','nltri':'\u22EA','nltrie':'\u22EC','nLtv':'\u226A\u0338','nmid':'\u2224','NoBreak':'\u2060','NonBreakingSpace':'\xA0','nopf':'\uD835\uDD5F','Nopf':'\u2115','not':'\xAC','Not':'\u2AEC','NotCongruent':'\u2262','NotCupCap':'\u226D','NotDoubleVerticalBar':'\u2226','NotElement':'\u2209','NotEqual':'\u2260','NotEqualTilde':'\u2242\u0338','NotExists':'\u2204','NotGreater':'\u226F','NotGreaterEqual':'\u2271','NotGreaterFullEqual':'\u2267\u0338','NotGreaterGreater':'\u226B\u0338','NotGreaterLess':'\u2279','NotGreaterSlantEqual':'\u2A7E\u0338','NotGreaterTilde':'\u2275','NotHumpDownHump':'\u224E\u0338','NotHumpEqual':'\u224F\u0338','notin':'\u2209','notindot':'\u22F5\u0338','notinE':'\u22F9\u0338','notinva':'\u2209','notinvb':'\u22F7','notinvc':'\u22F6','NotLeftTriangle':'\u22EA','NotLeftTriangleBar':'\u29CF\u0338','NotLeftTriangleEqual':'\u22EC','NotLess':'\u226E','NotLessEqual':'\u2270','NotLessGreater':'\u2278','NotLessLess':'\u226A\u0338','NotLessSlantEqual':'\u2A7D\u0338','NotLessTilde':'\u2274','NotNestedGreaterGreater':'\u2AA2\u0338','NotNestedLessLess':'\u2AA1\u0338','notni':'\u220C','notniva':'\u220C','notnivb':'\u22FE','notnivc':'\u22FD','NotPrecedes':'\u2280','NotPrecedesEqual':'\u2AAF\u0338','NotPrecedesSlantEqual':'\u22E0','NotReverseElement':'\u220C','NotRightTriangle':'\u22EB','NotRightTriangleBar':'\u29D0\u0338','NotRightTriangleEqual':'\u22ED','NotSquareSubset':'\u228F\u0338','NotSquareSubsetEqual':'\u22E2','NotSquareSuperset':'\u2290\u0338','NotSquareSupersetEqual':'\u22E3','NotSubset':'\u2282\u20D2','NotSubsetEqual':'\u2288','NotSucceeds':'\u2281','NotSucceedsEqual':'\u2AB0\u0338','NotSucceedsSlantEqual':'\u22E1','NotSucceedsTilde':'\u227F\u0338','NotSuperset':'\u2283\u20D2','NotSupersetEqual':'\u2289','NotTilde':'\u2241','NotTildeEqual':'\u2244','NotTildeFullEqual':'\u2247','NotTildeTilde':'\u2249','NotVerticalBar':'\u2224','npar':'\u2226','nparallel':'\u2226','nparsl':'\u2AFD\u20E5','npart':'\u2202\u0338','npolint':'\u2A14','npr':'\u2280','nprcue':'\u22E0','npre':'\u2AAF\u0338','nprec':'\u2280','npreceq':'\u2AAF\u0338','nrarr':'\u219B','nrArr':'\u21CF','nrarrc':'\u2933\u0338','nrarrw':'\u219D\u0338','nrightarrow':'\u219B','nRightarrow':'\u21CF','nrtri':'\u22EB','nrtrie':'\u22ED','nsc':'\u2281','nsccue':'\u22E1','nsce':'\u2AB0\u0338','nscr':'\uD835\uDCC3','Nscr':'\uD835\uDCA9','nshortmid':'\u2224','nshortparallel':'\u2226','nsim':'\u2241','nsime':'\u2244','nsimeq':'\u2244','nsmid':'\u2224','nspar':'\u2226','nsqsube':'\u22E2','nsqsupe':'\u22E3','nsub':'\u2284','nsube':'\u2288','nsubE':'\u2AC5\u0338','nsubset':'\u2282\u20D2','nsubseteq':'\u2288','nsubseteqq':'\u2AC5\u0338','nsucc':'\u2281','nsucceq':'\u2AB0\u0338','nsup':'\u2285','nsupe':'\u2289','nsupE':'\u2AC6\u0338','nsupset':'\u2283\u20D2','nsupseteq':'\u2289','nsupseteqq':'\u2AC6\u0338','ntgl':'\u2279','ntilde':'\xF1','Ntilde':'\xD1','ntlg':'\u2278','ntriangleleft':'\u22EA','ntrianglelefteq':'\u22EC','ntriangleright':'\u22EB','ntrianglerighteq':'\u22ED','nu':'\u03BD','Nu':'\u039D','num':'#','numero':'\u2116','numsp':'\u2007','nvap':'\u224D\u20D2','nvdash':'\u22AC','nvDash':'\u22AD','nVdash':'\u22AE','nVDash':'\u22AF','nvge':'\u2265\u20D2','nvgt':'>\u20D2','nvHarr':'\u2904','nvinfin':'\u29DE','nvlArr':'\u2902','nvle':'\u2264\u20D2','nvlt':'<\u20D2','nvltrie':'\u22B4\u20D2','nvrArr':'\u2903','nvrtrie':'\u22B5\u20D2','nvsim':'\u223C\u20D2','nwarhk':'\u2923','nwarr':'\u2196','nwArr':'\u21D6','nwarrow':'\u2196','nwnear':'\u2927','oacute':'\xF3','Oacute':'\xD3','oast':'\u229B','ocir':'\u229A','ocirc':'\xF4','Ocirc':'\xD4','ocy':'\u043E','Ocy':'\u041E','odash':'\u229D','odblac':'\u0151','Odblac':'\u0150','odiv':'\u2A38','odot':'\u2299','odsold':'\u29BC','oelig':'\u0153','OElig':'\u0152','ofcir':'\u29BF','ofr':'\uD835\uDD2C','Ofr':'\uD835\uDD12','ogon':'\u02DB','ograve':'\xF2','Ograve':'\xD2','ogt':'\u29C1','ohbar':'\u29B5','ohm':'\u03A9','oint':'\u222E','olarr':'\u21BA','olcir':'\u29BE','olcross':'\u29BB','oline':'\u203E','olt':'\u29C0','omacr':'\u014D','Omacr':'\u014C','omega':'\u03C9','Omega':'\u03A9','omicron':'\u03BF','Omicron':'\u039F','omid':'\u29B6','ominus':'\u2296','oopf':'\uD835\uDD60','Oopf':'\uD835\uDD46','opar':'\u29B7','OpenCurlyDoubleQuote':'\u201C','OpenCurlyQuote':'\u2018','operp':'\u29B9','oplus':'\u2295','or':'\u2228','Or':'\u2A54','orarr':'\u21BB','ord':'\u2A5D','order':'\u2134','orderof':'\u2134','ordf':'\xAA','ordm':'\xBA','origof':'\u22B6','oror':'\u2A56','orslope':'\u2A57','orv':'\u2A5B','oS':'\u24C8','oscr':'\u2134','Oscr':'\uD835\uDCAA','oslash':'\xF8','Oslash':'\xD8','osol':'\u2298','otilde':'\xF5','Otilde':'\xD5','otimes':'\u2297','Otimes':'\u2A37','otimesas':'\u2A36','ouml':'\xF6','Ouml':'\xD6','ovbar':'\u233D','OverBar':'\u203E','OverBrace':'\u23DE','OverBracket':'\u23B4','OverParenthesis':'\u23DC','par':'\u2225','para':'\xB6','parallel':'\u2225','parsim':'\u2AF3','parsl':'\u2AFD','part':'\u2202','PartialD':'\u2202','pcy':'\u043F','Pcy':'\u041F','percnt':'%','period':'.','permil':'\u2030','perp':'\u22A5','pertenk':'\u2031','pfr':'\uD835\uDD2D','Pfr':'\uD835\uDD13','phi':'\u03C6','Phi':'\u03A6','phiv':'\u03D5','phmmat':'\u2133','phone':'\u260E','pi':'\u03C0','Pi':'\u03A0','pitchfork':'\u22D4','piv':'\u03D6','planck':'\u210F','planckh':'\u210E','plankv':'\u210F','plus':'+','plusacir':'\u2A23','plusb':'\u229E','pluscir':'\u2A22','plusdo':'\u2214','plusdu':'\u2A25','pluse':'\u2A72','PlusMinus':'\xB1','plusmn':'\xB1','plussim':'\u2A26','plustwo':'\u2A27','pm':'\xB1','Poincareplane':'\u210C','pointint':'\u2A15','popf':'\uD835\uDD61','Popf':'\u2119','pound':'\xA3','pr':'\u227A','Pr':'\u2ABB','prap':'\u2AB7','prcue':'\u227C','pre':'\u2AAF','prE':'\u2AB3','prec':'\u227A','precapprox':'\u2AB7','preccurlyeq':'\u227C','Precedes':'\u227A','PrecedesEqual':'\u2AAF','PrecedesSlantEqual':'\u227C','PrecedesTilde':'\u227E','preceq':'\u2AAF','precnapprox':'\u2AB9','precneqq':'\u2AB5','precnsim':'\u22E8','precsim':'\u227E','prime':'\u2032','Prime':'\u2033','primes':'\u2119','prnap':'\u2AB9','prnE':'\u2AB5','prnsim':'\u22E8','prod':'\u220F','Product':'\u220F','profalar':'\u232E','profline':'\u2312','profsurf':'\u2313','prop':'\u221D','Proportion':'\u2237','Proportional':'\u221D','propto':'\u221D','prsim':'\u227E','prurel':'\u22B0','pscr':'\uD835\uDCC5','Pscr':'\uD835\uDCAB','psi':'\u03C8','Psi':'\u03A8','puncsp':'\u2008','qfr':'\uD835\uDD2E','Qfr':'\uD835\uDD14','qint':'\u2A0C','qopf':'\uD835\uDD62','Qopf':'\u211A','qprime':'\u2057','qscr':'\uD835\uDCC6','Qscr':'\uD835\uDCAC','quaternions':'\u210D','quatint':'\u2A16','quest':'?','questeq':'\u225F','quot':'"','QUOT':'"','rAarr':'\u21DB','race':'\u223D\u0331','racute':'\u0155','Racute':'\u0154','radic':'\u221A','raemptyv':'\u29B3','rang':'\u27E9','Rang':'\u27EB','rangd':'\u2992','range':'\u29A5','rangle':'\u27E9','raquo':'\xBB','rarr':'\u2192','rArr':'\u21D2','Rarr':'\u21A0','rarrap':'\u2975','rarrb':'\u21E5','rarrbfs':'\u2920','rarrc':'\u2933','rarrfs':'\u291E','rarrhk':'\u21AA','rarrlp':'\u21AC','rarrpl':'\u2945','rarrsim':'\u2974','rarrtl':'\u21A3','Rarrtl':'\u2916','rarrw':'\u219D','ratail':'\u291A','rAtail':'\u291C','ratio':'\u2236','rationals':'\u211A','rbarr':'\u290D','rBarr':'\u290F','RBarr':'\u2910','rbbrk':'\u2773','rbrace':'}','rbrack':']','rbrke':'\u298C','rbrksld':'\u298E','rbrkslu':'\u2990','rcaron':'\u0159','Rcaron':'\u0158','rcedil':'\u0157','Rcedil':'\u0156','rceil':'\u2309','rcub':'}','rcy':'\u0440','Rcy':'\u0420','rdca':'\u2937','rdldhar':'\u2969','rdquo':'\u201D','rdquor':'\u201D','rdsh':'\u21B3','Re':'\u211C','real':'\u211C','realine':'\u211B','realpart':'\u211C','reals':'\u211D','rect':'\u25AD','reg':'\xAE','REG':'\xAE','ReverseElement':'\u220B','ReverseEquilibrium':'\u21CB','ReverseUpEquilibrium':'\u296F','rfisht':'\u297D','rfloor':'\u230B','rfr':'\uD835\uDD2F','Rfr':'\u211C','rHar':'\u2964','rhard':'\u21C1','rharu':'\u21C0','rharul':'\u296C','rho':'\u03C1','Rho':'\u03A1','rhov':'\u03F1','RightAngleBracket':'\u27E9','rightarrow':'\u2192','Rightarrow':'\u21D2','RightArrow':'\u2192','RightArrowBar':'\u21E5','RightArrowLeftArrow':'\u21C4','rightarrowtail':'\u21A3','RightCeiling':'\u2309','RightDoubleBracket':'\u27E7','RightDownTeeVector':'\u295D','RightDownVector':'\u21C2','RightDownVectorBar':'\u2955','RightFloor':'\u230B','rightharpoondown':'\u21C1','rightharpoonup':'\u21C0','rightleftarrows':'\u21C4','rightleftharpoons':'\u21CC','rightrightarrows':'\u21C9','rightsquigarrow':'\u219D','RightTee':'\u22A2','RightTeeArrow':'\u21A6','RightTeeVector':'\u295B','rightthreetimes':'\u22CC','RightTriangle':'\u22B3','RightTriangleBar':'\u29D0','RightTriangleEqual':'\u22B5','RightUpDownVector':'\u294F','RightUpTeeVector':'\u295C','RightUpVector':'\u21BE','RightUpVectorBar':'\u2954','RightVector':'\u21C0','RightVectorBar':'\u2953','ring':'\u02DA','risingdotseq':'\u2253','rlarr':'\u21C4','rlhar':'\u21CC','rlm':'\u200F','rmoust':'\u23B1','rmoustache':'\u23B1','rnmid':'\u2AEE','roang':'\u27ED','roarr':'\u21FE','robrk':'\u27E7','ropar':'\u2986','ropf':'\uD835\uDD63','Ropf':'\u211D','roplus':'\u2A2E','rotimes':'\u2A35','RoundImplies':'\u2970','rpar':')','rpargt':'\u2994','rppolint':'\u2A12','rrarr':'\u21C9','Rrightarrow':'\u21DB','rsaquo':'\u203A','rscr':'\uD835\uDCC7','Rscr':'\u211B','rsh':'\u21B1','Rsh':'\u21B1','rsqb':']','rsquo':'\u2019','rsquor':'\u2019','rthree':'\u22CC','rtimes':'\u22CA','rtri':'\u25B9','rtrie':'\u22B5','rtrif':'\u25B8','rtriltri':'\u29CE','RuleDelayed':'\u29F4','ruluhar':'\u2968','rx':'\u211E','sacute':'\u015B','Sacute':'\u015A','sbquo':'\u201A','sc':'\u227B','Sc':'\u2ABC','scap':'\u2AB8','scaron':'\u0161','Scaron':'\u0160','sccue':'\u227D','sce':'\u2AB0','scE':'\u2AB4','scedil':'\u015F','Scedil':'\u015E','scirc':'\u015D','Scirc':'\u015C','scnap':'\u2ABA','scnE':'\u2AB6','scnsim':'\u22E9','scpolint':'\u2A13','scsim':'\u227F','scy':'\u0441','Scy':'\u0421','sdot':'\u22C5','sdotb':'\u22A1','sdote':'\u2A66','searhk':'\u2925','searr':'\u2198','seArr':'\u21D8','searrow':'\u2198','sect':'\xA7','semi':';','seswar':'\u2929','setminus':'\u2216','setmn':'\u2216','sext':'\u2736','sfr':'\uD835\uDD30','Sfr':'\uD835\uDD16','sfrown':'\u2322','sharp':'\u266F','shchcy':'\u0449','SHCHcy':'\u0429','shcy':'\u0448','SHcy':'\u0428','ShortDownArrow':'\u2193','ShortLeftArrow':'\u2190','shortmid':'\u2223','shortparallel':'\u2225','ShortRightArrow':'\u2192','ShortUpArrow':'\u2191','shy':'\xAD','sigma':'\u03C3','Sigma':'\u03A3','sigmaf':'\u03C2','sigmav':'\u03C2','sim':'\u223C','simdot':'\u2A6A','sime':'\u2243','simeq':'\u2243','simg':'\u2A9E','simgE':'\u2AA0','siml':'\u2A9D','simlE':'\u2A9F','simne':'\u2246','simplus':'\u2A24','simrarr':'\u2972','slarr':'\u2190','SmallCircle':'\u2218','smallsetminus':'\u2216','smashp':'\u2A33','smeparsl':'\u29E4','smid':'\u2223','smile':'\u2323','smt':'\u2AAA','smte':'\u2AAC','smtes':'\u2AAC\uFE00','softcy':'\u044C','SOFTcy':'\u042C','sol':'/','solb':'\u29C4','solbar':'\u233F','sopf':'\uD835\uDD64','Sopf':'\uD835\uDD4A','spades':'\u2660','spadesuit':'\u2660','spar':'\u2225','sqcap':'\u2293','sqcaps':'\u2293\uFE00','sqcup':'\u2294','sqcups':'\u2294\uFE00','Sqrt':'\u221A','sqsub':'\u228F','sqsube':'\u2291','sqsubset':'\u228F','sqsubseteq':'\u2291','sqsup':'\u2290','sqsupe':'\u2292','sqsupset':'\u2290','sqsupseteq':'\u2292','squ':'\u25A1','square':'\u25A1','Square':'\u25A1','SquareIntersection':'\u2293','SquareSubset':'\u228F','SquareSubsetEqual':'\u2291','SquareSuperset':'\u2290','SquareSupersetEqual':'\u2292','SquareUnion':'\u2294','squarf':'\u25AA','squf':'\u25AA','srarr':'\u2192','sscr':'\uD835\uDCC8','Sscr':'\uD835\uDCAE','ssetmn':'\u2216','ssmile':'\u2323','sstarf':'\u22C6','star':'\u2606','Star':'\u22C6','starf':'\u2605','straightepsilon':'\u03F5','straightphi':'\u03D5','strns':'\xAF','sub':'\u2282','Sub':'\u22D0','subdot':'\u2ABD','sube':'\u2286','subE':'\u2AC5','subedot':'\u2AC3','submult':'\u2AC1','subne':'\u228A','subnE':'\u2ACB','subplus':'\u2ABF','subrarr':'\u2979','subset':'\u2282','Subset':'\u22D0','subseteq':'\u2286','subseteqq':'\u2AC5','SubsetEqual':'\u2286','subsetneq':'\u228A','subsetneqq':'\u2ACB','subsim':'\u2AC7','subsub':'\u2AD5','subsup':'\u2AD3','succ':'\u227B','succapprox':'\u2AB8','succcurlyeq':'\u227D','Succeeds':'\u227B','SucceedsEqual':'\u2AB0','SucceedsSlantEqual':'\u227D','SucceedsTilde':'\u227F','succeq':'\u2AB0','succnapprox':'\u2ABA','succneqq':'\u2AB6','succnsim':'\u22E9','succsim':'\u227F','SuchThat':'\u220B','sum':'\u2211','Sum':'\u2211','sung':'\u266A','sup':'\u2283','Sup':'\u22D1','sup1':'\xB9','sup2':'\xB2','sup3':'\xB3','supdot':'\u2ABE','supdsub':'\u2AD8','supe':'\u2287','supE':'\u2AC6','supedot':'\u2AC4','Superset':'\u2283','SupersetEqual':'\u2287','suphsol':'\u27C9','suphsub':'\u2AD7','suplarr':'\u297B','supmult':'\u2AC2','supne':'\u228B','supnE':'\u2ACC','supplus':'\u2AC0','supset':'\u2283','Supset':'\u22D1','supseteq':'\u2287','supseteqq':'\u2AC6','supsetneq':'\u228B','supsetneqq':'\u2ACC','supsim':'\u2AC8','supsub':'\u2AD4','supsup':'\u2AD6','swarhk':'\u2926','swarr':'\u2199','swArr':'\u21D9','swarrow':'\u2199','swnwar':'\u292A','szlig':'\xDF','Tab':'\t','target':'\u2316','tau':'\u03C4','Tau':'\u03A4','tbrk':'\u23B4','tcaron':'\u0165','Tcaron':'\u0164','tcedil':'\u0163','Tcedil':'\u0162','tcy':'\u0442','Tcy':'\u0422','tdot':'\u20DB','telrec':'\u2315','tfr':'\uD835\uDD31','Tfr':'\uD835\uDD17','there4':'\u2234','therefore':'\u2234','Therefore':'\u2234','theta':'\u03B8','Theta':'\u0398','thetasym':'\u03D1','thetav':'\u03D1','thickapprox':'\u2248','thicksim':'\u223C','ThickSpace':'\u205F\u200A','thinsp':'\u2009','ThinSpace':'\u2009','thkap':'\u2248','thksim':'\u223C','thorn':'\xFE','THORN':'\xDE','tilde':'\u02DC','Tilde':'\u223C','TildeEqual':'\u2243','TildeFullEqual':'\u2245','TildeTilde':'\u2248','times':'\xD7','timesb':'\u22A0','timesbar':'\u2A31','timesd':'\u2A30','tint':'\u222D','toea':'\u2928','top':'\u22A4','topbot':'\u2336','topcir':'\u2AF1','topf':'\uD835\uDD65','Topf':'\uD835\uDD4B','topfork':'\u2ADA','tosa':'\u2929','tprime':'\u2034','trade':'\u2122','TRADE':'\u2122','triangle':'\u25B5','triangledown':'\u25BF','triangleleft':'\u25C3','trianglelefteq':'\u22B4','triangleq':'\u225C','triangleright':'\u25B9','trianglerighteq':'\u22B5','tridot':'\u25EC','trie':'\u225C','triminus':'\u2A3A','TripleDot':'\u20DB','triplus':'\u2A39','trisb':'\u29CD','tritime':'\u2A3B','trpezium':'\u23E2','tscr':'\uD835\uDCC9','Tscr':'\uD835\uDCAF','tscy':'\u0446','TScy':'\u0426','tshcy':'\u045B','TSHcy':'\u040B','tstrok':'\u0167','Tstrok':'\u0166','twixt':'\u226C','twoheadleftarrow':'\u219E','twoheadrightarrow':'\u21A0','uacute':'\xFA','Uacute':'\xDA','uarr':'\u2191','uArr':'\u21D1','Uarr':'\u219F','Uarrocir':'\u2949','ubrcy':'\u045E','Ubrcy':'\u040E','ubreve':'\u016D','Ubreve':'\u016C','ucirc':'\xFB','Ucirc':'\xDB','ucy':'\u0443','Ucy':'\u0423','udarr':'\u21C5','udblac':'\u0171','Udblac':'\u0170','udhar':'\u296E','ufisht':'\u297E','ufr':'\uD835\uDD32','Ufr':'\uD835\uDD18','ugrave':'\xF9','Ugrave':'\xD9','uHar':'\u2963','uharl':'\u21BF','uharr':'\u21BE','uhblk':'\u2580','ulcorn':'\u231C','ulcorner':'\u231C','ulcrop':'\u230F','ultri':'\u25F8','umacr':'\u016B','Umacr':'\u016A','uml':'\xA8','UnderBar':'_','UnderBrace':'\u23DF','UnderBracket':'\u23B5','UnderParenthesis':'\u23DD','Union':'\u22C3','UnionPlus':'\u228E','uogon':'\u0173','Uogon':'\u0172','uopf':'\uD835\uDD66','Uopf':'\uD835\uDD4C','uparrow':'\u2191','Uparrow':'\u21D1','UpArrow':'\u2191','UpArrowBar':'\u2912','UpArrowDownArrow':'\u21C5','updownarrow':'\u2195','Updownarrow':'\u21D5','UpDownArrow':'\u2195','UpEquilibrium':'\u296E','upharpoonleft':'\u21BF','upharpoonright':'\u21BE','uplus':'\u228E','UpperLeftArrow':'\u2196','UpperRightArrow':'\u2197','upsi':'\u03C5','Upsi':'\u03D2','upsih':'\u03D2','upsilon':'\u03C5','Upsilon':'\u03A5','UpTee':'\u22A5','UpTeeArrow':'\u21A5','upuparrows':'\u21C8','urcorn':'\u231D','urcorner':'\u231D','urcrop':'\u230E','uring':'\u016F','Uring':'\u016E','urtri':'\u25F9','uscr':'\uD835\uDCCA','Uscr':'\uD835\uDCB0','utdot':'\u22F0','utilde':'\u0169','Utilde':'\u0168','utri':'\u25B5','utrif':'\u25B4','uuarr':'\u21C8','uuml':'\xFC','Uuml':'\xDC','uwangle':'\u29A7','vangrt':'\u299C','varepsilon':'\u03F5','varkappa':'\u03F0','varnothing':'\u2205','varphi':'\u03D5','varpi':'\u03D6','varpropto':'\u221D','varr':'\u2195','vArr':'\u21D5','varrho':'\u03F1','varsigma':'\u03C2','varsubsetneq':'\u228A\uFE00','varsubsetneqq':'\u2ACB\uFE00','varsupsetneq':'\u228B\uFE00','varsupsetneqq':'\u2ACC\uFE00','vartheta':'\u03D1','vartriangleleft':'\u22B2','vartriangleright':'\u22B3','vBar':'\u2AE8','Vbar':'\u2AEB','vBarv':'\u2AE9','vcy':'\u0432','Vcy':'\u0412','vdash':'\u22A2','vDash':'\u22A8','Vdash':'\u22A9','VDash':'\u22AB','Vdashl':'\u2AE6','vee':'\u2228','Vee':'\u22C1','veebar':'\u22BB','veeeq':'\u225A','vellip':'\u22EE','verbar':'|','Verbar':'\u2016','vert':'|','Vert':'\u2016','VerticalBar':'\u2223','VerticalLine':'|','VerticalSeparator':'\u2758','VerticalTilde':'\u2240','VeryThinSpace':'\u200A','vfr':'\uD835\uDD33','Vfr':'\uD835\uDD19','vltri':'\u22B2','vnsub':'\u2282\u20D2','vnsup':'\u2283\u20D2','vopf':'\uD835\uDD67','Vopf':'\uD835\uDD4D','vprop':'\u221D','vrtri':'\u22B3','vscr':'\uD835\uDCCB','Vscr':'\uD835\uDCB1','vsubne':'\u228A\uFE00','vsubnE':'\u2ACB\uFE00','vsupne':'\u228B\uFE00','vsupnE':'\u2ACC\uFE00','Vvdash':'\u22AA','vzigzag':'\u299A','wcirc':'\u0175','Wcirc':'\u0174','wedbar':'\u2A5F','wedge':'\u2227','Wedge':'\u22C0','wedgeq':'\u2259','weierp':'\u2118','wfr':'\uD835\uDD34','Wfr':'\uD835\uDD1A','wopf':'\uD835\uDD68','Wopf':'\uD835\uDD4E','wp':'\u2118','wr':'\u2240','wreath':'\u2240','wscr':'\uD835\uDCCC','Wscr':'\uD835\uDCB2','xcap':'\u22C2','xcirc':'\u25EF','xcup':'\u22C3','xdtri':'\u25BD','xfr':'\uD835\uDD35','Xfr':'\uD835\uDD1B','xharr':'\u27F7','xhArr':'\u27FA','xi':'\u03BE','Xi':'\u039E','xlarr':'\u27F5','xlArr':'\u27F8','xmap':'\u27FC','xnis':'\u22FB','xodot':'\u2A00','xopf':'\uD835\uDD69','Xopf':'\uD835\uDD4F','xoplus':'\u2A01','xotime':'\u2A02','xrarr':'\u27F6','xrArr':'\u27F9','xscr':'\uD835\uDCCD','Xscr':'\uD835\uDCB3','xsqcup':'\u2A06','xuplus':'\u2A04','xutri':'\u25B3','xvee':'\u22C1','xwedge':'\u22C0','yacute':'\xFD','Yacute':'\xDD','yacy':'\u044F','YAcy':'\u042F','ycirc':'\u0177','Ycirc':'\u0176','ycy':'\u044B','Ycy':'\u042B','yen':'\xA5','yfr':'\uD835\uDD36','Yfr':'\uD835\uDD1C','yicy':'\u0457','YIcy':'\u0407','yopf':'\uD835\uDD6A','Yopf':'\uD835\uDD50','yscr':'\uD835\uDCCE','Yscr':'\uD835\uDCB4','yucy':'\u044E','YUcy':'\u042E','yuml':'\xFF','Yuml':'\u0178','zacute':'\u017A','Zacute':'\u0179','zcaron':'\u017E','Zcaron':'\u017D','zcy':'\u0437','Zcy':'\u0417','zdot':'\u017C','Zdot':'\u017B','zeetrf':'\u2128','ZeroWidthSpace':'\u200B','zeta':'\u03B6','Zeta':'\u0396','zfr':'\uD835\uDD37','Zfr':'\u2128','zhcy':'\u0436','ZHcy':'\u0416','zigrarr':'\u21DD','zopf':'\uD835\uDD6B','Zopf':'\u2124','zscr':'\uD835\uDCCF','Zscr':'\uD835\uDCB5','zwj':'\u200D','zwnj':'\u200C'};
		var decodeMapLegacy = {'aacute':'\xE1','Aacute':'\xC1','acirc':'\xE2','Acirc':'\xC2','acute':'\xB4','aelig':'\xE6','AElig':'\xC6','agrave':'\xE0','Agrave':'\xC0','amp':'&','AMP':'&','aring':'\xE5','Aring':'\xC5','atilde':'\xE3','Atilde':'\xC3','auml':'\xE4','Auml':'\xC4','brvbar':'\xA6','ccedil':'\xE7','Ccedil':'\xC7','cedil':'\xB8','cent':'\xA2','copy':'\xA9','COPY':'\xA9','curren':'\xA4','deg':'\xB0','divide':'\xF7','eacute':'\xE9','Eacute':'\xC9','ecirc':'\xEA','Ecirc':'\xCA','egrave':'\xE8','Egrave':'\xC8','eth':'\xF0','ETH':'\xD0','euml':'\xEB','Euml':'\xCB','frac12':'\xBD','frac14':'\xBC','frac34':'\xBE','gt':'>','GT':'>','iacute':'\xED','Iacute':'\xCD','icirc':'\xEE','Icirc':'\xCE','iexcl':'\xA1','igrave':'\xEC','Igrave':'\xCC','iquest':'\xBF','iuml':'\xEF','Iuml':'\xCF','laquo':'\xAB','lt':'<','LT':'<','macr':'\xAF','micro':'\xB5','middot':'\xB7','nbsp':'\xA0','not':'\xAC','ntilde':'\xF1','Ntilde':'\xD1','oacute':'\xF3','Oacute':'\xD3','ocirc':'\xF4','Ocirc':'\xD4','ograve':'\xF2','Ograve':'\xD2','ordf':'\xAA','ordm':'\xBA','oslash':'\xF8','Oslash':'\xD8','otilde':'\xF5','Otilde':'\xD5','ouml':'\xF6','Ouml':'\xD6','para':'\xB6','plusmn':'\xB1','pound':'\xA3','quot':'"','QUOT':'"','raquo':'\xBB','reg':'\xAE','REG':'\xAE','sect':'\xA7','shy':'\xAD','sup1':'\xB9','sup2':'\xB2','sup3':'\xB3','szlig':'\xDF','thorn':'\xFE','THORN':'\xDE','times':'\xD7','uacute':'\xFA','Uacute':'\xDA','ucirc':'\xFB','Ucirc':'\xDB','ugrave':'\xF9','Ugrave':'\xD9','uml':'\xA8','uuml':'\xFC','Uuml':'\xDC','yacute':'\xFD','Yacute':'\xDD','yen':'\xA5','yuml':'\xFF'};
		var decodeMapNumeric = {'0':'\uFFFD','128':'\u20AC','130':'\u201A','131':'\u0192','132':'\u201E','133':'\u2026','134':'\u2020','135':'\u2021','136':'\u02C6','137':'\u2030','138':'\u0160','139':'\u2039','140':'\u0152','142':'\u017D','145':'\u2018','146':'\u2019','147':'\u201C','148':'\u201D','149':'\u2022','150':'\u2013','151':'\u2014','152':'\u02DC','153':'\u2122','154':'\u0161','155':'\u203A','156':'\u0153','158':'\u017E','159':'\u0178'};
		var invalidReferenceCodePoints = [1,2,3,4,5,6,7,8,11,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,64976,64977,64978,64979,64980,64981,64982,64983,64984,64985,64986,64987,64988,64989,64990,64991,64992,64993,64994,64995,64996,64997,64998,64999,65000,65001,65002,65003,65004,65005,65006,65007,65534,65535,131070,131071,196606,196607,262142,262143,327678,327679,393214,393215,458750,458751,524286,524287,589822,589823,655358,655359,720894,720895,786430,786431,851966,851967,917502,917503,983038,983039,1048574,1048575,1114110,1114111];

		/*--------------------------------------------------------------------------*/

		var stringFromCharCode = String.fromCharCode;

		var object = {};
		var hasOwnProperty = object.hasOwnProperty;
		var has = function(object, propertyName) {
			return hasOwnProperty.call(object, propertyName);
		};

		var contains = function(array, value) {
			var index = -1;
			var length = array.length;
			while (++index < length) {
				if (array[index] == value) {
					return true;
				}
			}
			return false;
		};

		var merge = function(options, defaults) {
			if (!options) {
				return defaults;
			}
			var result = {};
			var key;
			for (key in defaults) {
				// A `hasOwnProperty` check is not needed here, since only recognized
				// option names are used anyway. Any others are ignored.
				result[key] = has(options, key) ? options[key] : defaults[key];
			}
			return result;
		};

		// Modified version of `ucs2encode`; see https://mths.be/punycode.
		var codePointToSymbol = function(codePoint, strict) {
			var output = '';
			if ((codePoint >= 0xD800 && codePoint <= 0xDFFF) || codePoint > 0x10FFFF) {
				// See issue #4:
				// “Otherwise, if the number is in the range 0xD800 to 0xDFFF or is
				// greater than 0x10FFFF, then this is a parse error. Return a U+FFFD
				// REPLACEMENT CHARACTER.”
				if (strict) {
					parseError('character reference outside the permissible Unicode range');
				}
				return '\uFFFD';
			}
			if (has(decodeMapNumeric, codePoint)) {
				if (strict) {
					parseError('disallowed character reference');
				}
				return decodeMapNumeric[codePoint];
			}
			if (strict && contains(invalidReferenceCodePoints, codePoint)) {
				parseError('disallowed character reference');
			}
			if (codePoint > 0xFFFF) {
				codePoint -= 0x10000;
				output += stringFromCharCode(codePoint >>> 10 & 0x3FF | 0xD800);
				codePoint = 0xDC00 | codePoint & 0x3FF;
			}
			output += stringFromCharCode(codePoint);
			return output;
		};

		var hexEscape = function(codePoint) {
			return '&#x' + codePoint.toString(16).toUpperCase() + ';';
		};

		var decEscape = function(codePoint) {
			return '&#' + codePoint + ';';
		};

		var parseError = function(message) {
			throw Error('Parse error: ' + message);
		};

		/*--------------------------------------------------------------------------*/

		var encode = function(string, options) {
			options = merge(options, encode.options);
			var strict = options.strict;
			if (strict && regexInvalidRawCodePoint.test(string)) {
				parseError('forbidden code point');
			}
			var encodeEverything = options.encodeEverything;
			var useNamedReferences = options.useNamedReferences;
			var allowUnsafeSymbols = options.allowUnsafeSymbols;
			var escapeCodePoint = options.decimal ? decEscape : hexEscape;

			var escapeBmpSymbol = function(symbol) {
				return escapeCodePoint(symbol.charCodeAt(0));
			};

			if (encodeEverything) {
				// Encode ASCII symbols.
				string = string.replace(regexAsciiWhitelist, function(symbol) {
					// Use named references if requested & possible.
					if (useNamedReferences && has(encodeMap, symbol)) {
						return '&' + encodeMap[symbol] + ';';
					}
					return escapeBmpSymbol(symbol);
				});
				// Shorten a few escapes that represent two symbols, of which at least one
				// is within the ASCII range.
				if (useNamedReferences) {
					string = string
						.replace(/&gt;\u20D2/g, '&nvgt;')
						.replace(/&lt;\u20D2/g, '&nvlt;')
						.replace(/&#x66;&#x6A;/g, '&fjlig;');
				}
				// Encode non-ASCII symbols.
				if (useNamedReferences) {
					// Encode non-ASCII symbols that can be replaced with a named reference.
					string = string.replace(regexEncodeNonAscii, function(string) {
						// Note: there is no need to check `has(encodeMap, string)` here.
						return '&' + encodeMap[string] + ';';
					});
				}
				// Note: any remaining non-ASCII symbols are handled outside of the `if`.
			} else if (useNamedReferences) {
				// Apply named character references.
				// Encode `<>"'&` using named character references.
				if (!allowUnsafeSymbols) {
					string = string.replace(regexEscape, function(string) {
						return '&' + encodeMap[string] + ';'; // no need to check `has()` here
					});
				}
				// Shorten escapes that represent two symbols, of which at least one is
				// `<>"'&`.
				string = string
					.replace(/&gt;\u20D2/g, '&nvgt;')
					.replace(/&lt;\u20D2/g, '&nvlt;');
				// Encode non-ASCII symbols that can be replaced with a named reference.
				string = string.replace(regexEncodeNonAscii, function(string) {
					// Note: there is no need to check `has(encodeMap, string)` here.
					return '&' + encodeMap[string] + ';';
				});
			} else if (!allowUnsafeSymbols) {
				// Encode `<>"'&` using hexadecimal escapes, now that they’re not handled
				// using named character references.
				string = string.replace(regexEscape, escapeBmpSymbol);
			}
			return string
				// Encode astral symbols.
				.replace(regexAstralSymbols, function($0) {
					// https://mathiasbynens.be/notes/javascript-encoding#surrogate-formulae
					var high = $0.charCodeAt(0);
					var low = $0.charCodeAt(1);
					var codePoint = (high - 0xD800) * 0x400 + low - 0xDC00 + 0x10000;
					return escapeCodePoint(codePoint);
				})
				// Encode any remaining BMP symbols that are not printable ASCII symbols
				// using a hexadecimal escape.
				.replace(regexBmpWhitelist, escapeBmpSymbol);
		};
		// Expose default options (so they can be overridden globally).
		encode.options = {
			'allowUnsafeSymbols': false,
			'encodeEverything': false,
			'strict': false,
			'useNamedReferences': false,
			'decimal' : false
		};

		var decode = function(html, options) {
			options = merge(options, decode.options);
			var strict = options.strict;
			if (strict && regexInvalidEntity.test(html)) {
				parseError('malformed character reference');
			}
			return html.replace(regexDecode, function($0, $1, $2, $3, $4, $5, $6, $7, $8) {
				var codePoint;
				var semicolon;
				var decDigits;
				var hexDigits;
				var reference;
				var next;

				if ($1) {
					reference = $1;
					// Note: there is no need to check `has(decodeMap, reference)`.
					return decodeMap[reference];
				}

				if ($2) {
					// Decode named character references without trailing `;`, e.g. `&amp`.
					// This is only a parse error if it gets converted to `&`, or if it is
					// followed by `=` in an attribute context.
					reference = $2;
					next = $3;
					if (next && options.isAttributeValue) {
						if (strict && next == '=') {
							parseError('`&` did not start a character reference');
						}
						return $0;
					} else {
						if (strict) {
							parseError(
								'named character reference was not terminated by a semicolon'
							);
						}
						// Note: there is no need to check `has(decodeMapLegacy, reference)`.
						return decodeMapLegacy[reference] + (next || '');
					}
				}

				if ($4) {
					// Decode decimal escapes, e.g. `&#119558;`.
					decDigits = $4;
					semicolon = $5;
					if (strict && !semicolon) {
						parseError('character reference was not terminated by a semicolon');
					}
					codePoint = parseInt(decDigits, 10);
					return codePointToSymbol(codePoint, strict);
				}

				if ($6) {
					// Decode hexadecimal escapes, e.g. `&#x1D306;`.
					hexDigits = $6;
					semicolon = $7;
					if (strict && !semicolon) {
						parseError('character reference was not terminated by a semicolon');
					}
					codePoint = parseInt(hexDigits, 16);
					return codePointToSymbol(codePoint, strict);
				}

				// If we’re still here, `if ($7)` is implied; it’s an ambiguous
				// ampersand for sure. https://mths.be/notes/ambiguous-ampersands
				if (strict) {
					parseError(
						'named character reference was not terminated by a semicolon'
					);
				}
				return $0;
			});
		};
		// Expose default options (so they can be overridden globally).
		decode.options = {
			'isAttributeValue': false,
			'strict': false
		};

		var escape = function(string) {
			return string.replace(regexEscape, function($0) {
				// Note: there is no need to check `has(escapeMap, $0)` here.
				return escapeMap[$0];
			});
		};

		/*--------------------------------------------------------------------------*/

		var he = {
			'version': '1.2.0',
			'encode': encode,
			'decode': decode,
			'escape': escape,
			'unescape': decode
		};

		// Some AMD build optimizers, like r.js, check for specific condition patterns
		// like the following:
		if (freeExports && !freeExports.nodeType) {
			if (freeModule) { // in Node.js, io.js, or RingoJS v0.8.0+
				freeModule.exports = he;
			} else { // in Narwhal or RingoJS v0.7.0-
				for (var key in he) {
					has(he, key) && (freeExports[key] = he[key]);
				}
			}
		} else { // in Rhino or a web browser
			root.he = he;
		}

	}(commonjsGlobal)); 
} (he, he.exports));

var heExports = he.exports;

Object.defineProperty(node$4, "__esModule", { value: true });
var he_1$2 = heExports;
/**
 * Node Class as base class for TextNode and HTMLElement.
 */
var Node$1 = /** @class */ (function () {
    function Node(parentNode, range) {
        if (parentNode === void 0) { parentNode = null; }
        this.parentNode = parentNode;
        this.childNodes = [];
        Object.defineProperty(this, 'range', {
            enumerable: false,
            writable: true,
            configurable: true,
            value: range !== null && range !== void 0 ? range : [-1, -1]
        });
    }
    /**
     * Remove current node
     */
    Node.prototype.remove = function () {
        var _this = this;
        if (this.parentNode) {
            var children = this.parentNode.childNodes;
            this.parentNode.childNodes = children.filter(function (child) {
                return _this !== child;
            });
            this.parentNode = null;
        }
        return this;
    };
    Object.defineProperty(Node.prototype, "innerText", {
        get: function () {
            return this.rawText;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Node.prototype, "textContent", {
        get: function () {
            return (0, he_1$2.decode)(this.rawText);
        },
        set: function (val) {
            this.rawText = (0, he_1$2.encode)(val);
        },
        enumerable: false,
        configurable: true
    });
    return Node;
}());
node$4.default = Node$1;

var type$1 = {};

Object.defineProperty(type$1, "__esModule", { value: true });
var NodeType;
(function (NodeType) {
    NodeType[NodeType["ELEMENT_NODE"] = 1] = "ELEMENT_NODE";
    NodeType[NodeType["TEXT_NODE"] = 3] = "TEXT_NODE";
    NodeType[NodeType["COMMENT_NODE"] = 8] = "COMMENT_NODE";
})(NodeType || (NodeType = {}));
type$1.default = NodeType;

var __extends$3 = (commonjsGlobal && commonjsGlobal.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault$a = (commonjsGlobal && commonjsGlobal.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(comment, "__esModule", { value: true });
var node_1$3 = __importDefault$a(node$4);
var type_1$4 = __importDefault$a(type$1);
var CommentNode = /** @class */ (function (_super) {
    __extends$3(CommentNode, _super);
    function CommentNode(rawText, parentNode, range) {
        var _this = _super.call(this, parentNode, range) || this;
        _this.rawText = rawText;
        /**
         * Node Type declaration.
         * @type {Number}
         */
        _this.nodeType = type_1$4.default.COMMENT_NODE;
        return _this;
    }
    CommentNode.prototype.clone = function () {
        return new CommentNode(this.rawText, null);
    };
    Object.defineProperty(CommentNode.prototype, "text", {
        /**
         * Get unescaped text value of current node and its children.
         * @return {string} text content
         */
        get: function () {
            return this.rawText;
        },
        enumerable: false,
        configurable: true
    });
    CommentNode.prototype.toString = function () {
        return "<!--".concat(this.rawText, "-->");
    };
    return CommentNode;
}(node_1$3.default));
comment.default = CommentNode;

var html = {};

var lib$s = {};

var lib$r = {};

var stringify$6 = {};

var lib$q = {};

var lib$p = {};

(function (exports) {
	Object.defineProperty(exports, "__esModule", { value: true });
	exports.Doctype = exports.CDATA = exports.Tag = exports.Style = exports.Script = exports.Comment = exports.Directive = exports.Text = exports.Root = exports.isTag = exports.ElementType = void 0;
	/** Types of elements found in htmlparser2's DOM */
	var ElementType;
	(function (ElementType) {
	    /** Type for the root element of a document */
	    ElementType["Root"] = "root";
	    /** Type for Text */
	    ElementType["Text"] = "text";
	    /** Type for <? ... ?> */
	    ElementType["Directive"] = "directive";
	    /** Type for <!-- ... --> */
	    ElementType["Comment"] = "comment";
	    /** Type for <script> tags */
	    ElementType["Script"] = "script";
	    /** Type for <style> tags */
	    ElementType["Style"] = "style";
	    /** Type for Any tag */
	    ElementType["Tag"] = "tag";
	    /** Type for <![CDATA[ ... ]]> */
	    ElementType["CDATA"] = "cdata";
	    /** Type for <!doctype ...> */
	    ElementType["Doctype"] = "doctype";
	})(ElementType = exports.ElementType || (exports.ElementType = {}));
	/**
	 * Tests whether an element is a tag or not.
	 *
	 * @param elem Element to test
	 */
	function isTag(elem) {
	    return (elem.type === ElementType.Tag ||
	        elem.type === ElementType.Script ||
	        elem.type === ElementType.Style);
	}
	exports.isTag = isTag;
	// Exports for backwards compatibility
	/** Type for the root element of a document */
	exports.Root = ElementType.Root;
	/** Type for Text */
	exports.Text = ElementType.Text;
	/** Type for <? ... ?> */
	exports.Directive = ElementType.Directive;
	/** Type for <!-- ... --> */
	exports.Comment = ElementType.Comment;
	/** Type for <script> tags */
	exports.Script = ElementType.Script;
	/** Type for <style> tags */
	exports.Style = ElementType.Style;
	/** Type for Any tag */
	exports.Tag = ElementType.Tag;
	/** Type for <![CDATA[ ... ]]> */
	exports.CDATA = ElementType.CDATA;
	/** Type for <!doctype ...> */
	exports.Doctype = ElementType.Doctype; 
} (lib$p));

var node$3 = {};

var __extends$2 = (commonjsGlobal && commonjsGlobal.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign$2 = (commonjsGlobal && commonjsGlobal.__assign) || function () {
    __assign$2 = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign$2.apply(this, arguments);
};
Object.defineProperty(node$3, "__esModule", { value: true });
node$3.cloneNode = node$3.hasChildren = node$3.isDocument = node$3.isDirective = node$3.isComment = node$3.isText = node$3.isCDATA = node$3.isTag = node$3.Element = node$3.Document = node$3.NodeWithChildren = node$3.ProcessingInstruction = node$3.Comment = node$3.Text = node$3.DataNode = node$3.Node = void 0;
var domelementtype_1$1 = lib$p;
var nodeTypes = new Map([
    [domelementtype_1$1.ElementType.Tag, 1],
    [domelementtype_1$1.ElementType.Script, 1],
    [domelementtype_1$1.ElementType.Style, 1],
    [domelementtype_1$1.ElementType.Directive, 1],
    [domelementtype_1$1.ElementType.Text, 3],
    [domelementtype_1$1.ElementType.CDATA, 4],
    [domelementtype_1$1.ElementType.Comment, 8],
    [domelementtype_1$1.ElementType.Root, 9],
]);
/**
 * This object will be used as the prototype for Nodes when creating a
 * DOM-Level-1-compliant structure.
 */
var Node = /** @class */ (function () {
    /**
     *
     * @param type The type of the node.
     */
    function Node(type) {
        this.type = type;
        /** Parent of the node */
        this.parent = null;
        /** Previous sibling */
        this.prev = null;
        /** Next sibling */
        this.next = null;
        /** The start index of the node. Requires `withStartIndices` on the handler to be `true. */
        this.startIndex = null;
        /** The end index of the node. Requires `withEndIndices` on the handler to be `true. */
        this.endIndex = null;
    }
    Object.defineProperty(Node.prototype, "nodeType", {
        // Read-only aliases
        /**
         * [DOM spec](https://dom.spec.whatwg.org/#dom-node-nodetype)-compatible
         * node {@link type}.
         */
        get: function () {
            var _a;
            return (_a = nodeTypes.get(this.type)) !== null && _a !== void 0 ? _a : 1;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Node.prototype, "parentNode", {
        // Read-write aliases for properties
        /**
         * Same as {@link parent}.
         * [DOM spec](https://dom.spec.whatwg.org)-compatible alias.
         */
        get: function () {
            return this.parent;
        },
        set: function (parent) {
            this.parent = parent;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Node.prototype, "previousSibling", {
        /**
         * Same as {@link prev}.
         * [DOM spec](https://dom.spec.whatwg.org)-compatible alias.
         */
        get: function () {
            return this.prev;
        },
        set: function (prev) {
            this.prev = prev;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Node.prototype, "nextSibling", {
        /**
         * Same as {@link next}.
         * [DOM spec](https://dom.spec.whatwg.org)-compatible alias.
         */
        get: function () {
            return this.next;
        },
        set: function (next) {
            this.next = next;
        },
        enumerable: false,
        configurable: true
    });
    /**
     * Clone this node, and optionally its children.
     *
     * @param recursive Clone child nodes as well.
     * @returns A clone of the node.
     */
    Node.prototype.cloneNode = function (recursive) {
        if (recursive === void 0) { recursive = false; }
        return cloneNode$1(this, recursive);
    };
    return Node;
}());
node$3.Node = Node;
/**
 * A node that contains some data.
 */
var DataNode = /** @class */ (function (_super) {
    __extends$2(DataNode, _super);
    /**
     * @param type The type of the node
     * @param data The content of the data node
     */
    function DataNode(type, data) {
        var _this = _super.call(this, type) || this;
        _this.data = data;
        return _this;
    }
    Object.defineProperty(DataNode.prototype, "nodeValue", {
        /**
         * Same as {@link data}.
         * [DOM spec](https://dom.spec.whatwg.org)-compatible alias.
         */
        get: function () {
            return this.data;
        },
        set: function (data) {
            this.data = data;
        },
        enumerable: false,
        configurable: true
    });
    return DataNode;
}(Node));
node$3.DataNode = DataNode;
/**
 * Text within the document.
 */
var Text = /** @class */ (function (_super) {
    __extends$2(Text, _super);
    function Text(data) {
        return _super.call(this, domelementtype_1$1.ElementType.Text, data) || this;
    }
    return Text;
}(DataNode));
node$3.Text = Text;
/**
 * Comments within the document.
 */
var Comment = /** @class */ (function (_super) {
    __extends$2(Comment, _super);
    function Comment(data) {
        return _super.call(this, domelementtype_1$1.ElementType.Comment, data) || this;
    }
    return Comment;
}(DataNode));
node$3.Comment = Comment;
/**
 * Processing instructions, including doc types.
 */
var ProcessingInstruction = /** @class */ (function (_super) {
    __extends$2(ProcessingInstruction, _super);
    function ProcessingInstruction(name, data) {
        var _this = _super.call(this, domelementtype_1$1.ElementType.Directive, data) || this;
        _this.name = name;
        return _this;
    }
    return ProcessingInstruction;
}(DataNode));
node$3.ProcessingInstruction = ProcessingInstruction;
/**
 * A `Node` that can have children.
 */
var NodeWithChildren = /** @class */ (function (_super) {
    __extends$2(NodeWithChildren, _super);
    /**
     * @param type Type of the node.
     * @param children Children of the node. Only certain node types can have children.
     */
    function NodeWithChildren(type, children) {
        var _this = _super.call(this, type) || this;
        _this.children = children;
        return _this;
    }
    Object.defineProperty(NodeWithChildren.prototype, "firstChild", {
        // Aliases
        /** First child of the node. */
        get: function () {
            var _a;
            return (_a = this.children[0]) !== null && _a !== void 0 ? _a : null;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(NodeWithChildren.prototype, "lastChild", {
        /** Last child of the node. */
        get: function () {
            return this.children.length > 0
                ? this.children[this.children.length - 1]
                : null;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(NodeWithChildren.prototype, "childNodes", {
        /**
         * Same as {@link children}.
         * [DOM spec](https://dom.spec.whatwg.org)-compatible alias.
         */
        get: function () {
            return this.children;
        },
        set: function (children) {
            this.children = children;
        },
        enumerable: false,
        configurable: true
    });
    return NodeWithChildren;
}(Node));
node$3.NodeWithChildren = NodeWithChildren;
/**
 * The root node of the document.
 */
var Document = /** @class */ (function (_super) {
    __extends$2(Document, _super);
    function Document(children) {
        return _super.call(this, domelementtype_1$1.ElementType.Root, children) || this;
    }
    return Document;
}(NodeWithChildren));
node$3.Document = Document;
/**
 * An element within the DOM.
 */
var Element$1 = /** @class */ (function (_super) {
    __extends$2(Element, _super);
    /**
     * @param name Name of the tag, eg. `div`, `span`.
     * @param attribs Object mapping attribute names to attribute values.
     * @param children Children of the node.
     */
    function Element(name, attribs, children, type) {
        if (children === void 0) { children = []; }
        if (type === void 0) { type = name === "script"
            ? domelementtype_1$1.ElementType.Script
            : name === "style"
                ? domelementtype_1$1.ElementType.Style
                : domelementtype_1$1.ElementType.Tag; }
        var _this = _super.call(this, type, children) || this;
        _this.name = name;
        _this.attribs = attribs;
        return _this;
    }
    Object.defineProperty(Element.prototype, "tagName", {
        // DOM Level 1 aliases
        /**
         * Same as {@link name}.
         * [DOM spec](https://dom.spec.whatwg.org)-compatible alias.
         */
        get: function () {
            return this.name;
        },
        set: function (name) {
            this.name = name;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Element.prototype, "attributes", {
        get: function () {
            var _this = this;
            return Object.keys(this.attribs).map(function (name) {
                var _a, _b;
                return ({
                    name: name,
                    value: _this.attribs[name],
                    namespace: (_a = _this["x-attribsNamespace"]) === null || _a === void 0 ? void 0 : _a[name],
                    prefix: (_b = _this["x-attribsPrefix"]) === null || _b === void 0 ? void 0 : _b[name],
                });
            });
        },
        enumerable: false,
        configurable: true
    });
    return Element;
}(NodeWithChildren));
node$3.Element = Element$1;
/**
 * @param node Node to check.
 * @returns `true` if the node is a `Element`, `false` otherwise.
 */
function isTag$1(node) {
    return (0, domelementtype_1$1.isTag)(node);
}
node$3.isTag = isTag$1;
/**
 * @param node Node to check.
 * @returns `true` if the node has the type `CDATA`, `false` otherwise.
 */
function isCDATA(node) {
    return node.type === domelementtype_1$1.ElementType.CDATA;
}
node$3.isCDATA = isCDATA;
/**
 * @param node Node to check.
 * @returns `true` if the node has the type `Text`, `false` otherwise.
 */
function isText(node) {
    return node.type === domelementtype_1$1.ElementType.Text;
}
node$3.isText = isText;
/**
 * @param node Node to check.
 * @returns `true` if the node has the type `Comment`, `false` otherwise.
 */
function isComment(node) {
    return node.type === domelementtype_1$1.ElementType.Comment;
}
node$3.isComment = isComment;
/**
 * @param node Node to check.
 * @returns `true` if the node has the type `ProcessingInstruction`, `false` otherwise.
 */
function isDirective(node) {
    return node.type === domelementtype_1$1.ElementType.Directive;
}
node$3.isDirective = isDirective;
/**
 * @param node Node to check.
 * @returns `true` if the node has the type `ProcessingInstruction`, `false` otherwise.
 */
function isDocument(node) {
    return node.type === domelementtype_1$1.ElementType.Root;
}
node$3.isDocument = isDocument;
/**
 * @param node Node to check.
 * @returns `true` if the node is a `NodeWithChildren` (has children), `false` otherwise.
 */
function hasChildren(node) {
    return Object.prototype.hasOwnProperty.call(node, "children");
}
node$3.hasChildren = hasChildren;
/**
 * Clone a node, and optionally its children.
 *
 * @param recursive Clone child nodes as well.
 * @returns A clone of the node.
 */
function cloneNode$1(node, recursive) {
    if (recursive === void 0) { recursive = false; }
    var result;
    if (isText(node)) {
        result = new Text(node.data);
    }
    else if (isComment(node)) {
        result = new Comment(node.data);
    }
    else if (isTag$1(node)) {
        var children = recursive ? cloneChildren(node.children) : [];
        var clone_1 = new Element$1(node.name, __assign$2({}, node.attribs), children);
        children.forEach(function (child) { return (child.parent = clone_1); });
        if (node.namespace != null) {
            clone_1.namespace = node.namespace;
        }
        if (node["x-attribsNamespace"]) {
            clone_1["x-attribsNamespace"] = __assign$2({}, node["x-attribsNamespace"]);
        }
        if (node["x-attribsPrefix"]) {
            clone_1["x-attribsPrefix"] = __assign$2({}, node["x-attribsPrefix"]);
        }
        result = clone_1;
    }
    else if (isCDATA(node)) {
        var children = recursive ? cloneChildren(node.children) : [];
        var clone_2 = new NodeWithChildren(domelementtype_1$1.ElementType.CDATA, children);
        children.forEach(function (child) { return (child.parent = clone_2); });
        result = clone_2;
    }
    else if (isDocument(node)) {
        var children = recursive ? cloneChildren(node.children) : [];
        var clone_3 = new Document(children);
        children.forEach(function (child) { return (child.parent = clone_3); });
        if (node["x-mode"]) {
            clone_3["x-mode"] = node["x-mode"];
        }
        result = clone_3;
    }
    else if (isDirective(node)) {
        var instruction = new ProcessingInstruction(node.name, node.data);
        if (node["x-name"] != null) {
            instruction["x-name"] = node["x-name"];
            instruction["x-publicId"] = node["x-publicId"];
            instruction["x-systemId"] = node["x-systemId"];
        }
        result = instruction;
    }
    else {
        throw new Error("Not implemented yet: ".concat(node.type));
    }
    result.startIndex = node.startIndex;
    result.endIndex = node.endIndex;
    if (node.sourceCodeLocation != null) {
        result.sourceCodeLocation = node.sourceCodeLocation;
    }
    return result;
}
node$3.cloneNode = cloneNode$1;
function cloneChildren(childs) {
    var children = childs.map(function (child) { return cloneNode$1(child, true); });
    for (var i = 1; i < children.length; i++) {
        children[i].prev = children[i - 1];
        children[i - 1].next = children[i];
    }
    return children;
}

(function (exports) {
	var __createBinding = (commonjsGlobal && commonjsGlobal.__createBinding) || (Object.create ? (function(o, m, k, k2) {
	    if (k2 === undefined) k2 = k;
	    var desc = Object.getOwnPropertyDescriptor(m, k);
	    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
	      desc = { enumerable: true, get: function() { return m[k]; } };
	    }
	    Object.defineProperty(o, k2, desc);
	}) : (function(o, m, k, k2) {
	    if (k2 === undefined) k2 = k;
	    o[k2] = m[k];
	}));
	var __exportStar = (commonjsGlobal && commonjsGlobal.__exportStar) || function(m, exports) {
	    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
	};
	Object.defineProperty(exports, "__esModule", { value: true });
	exports.DomHandler = void 0;
	var domelementtype_1 = lib$p;
	var node_1 = node$3;
	__exportStar(node$3, exports);
	var reWhitespace = /\s+/g;
	// Default options
	var defaultOpts = {
	    normalizeWhitespace: false,
	    withStartIndices: false,
	    withEndIndices: false,
	    xmlMode: false,
	};
	var DomHandler = /** @class */ (function () {
	    /**
	     * @param callback Called once parsing has completed.
	     * @param options Settings for the handler.
	     * @param elementCB Callback whenever a tag is closed.
	     */
	    function DomHandler(callback, options, elementCB) {
	        /** The elements of the DOM */
	        this.dom = [];
	        /** The root element for the DOM */
	        this.root = new node_1.Document(this.dom);
	        /** Indicated whether parsing has been completed. */
	        this.done = false;
	        /** Stack of open tags. */
	        this.tagStack = [this.root];
	        /** A data node that is still being written to. */
	        this.lastNode = null;
	        /** Reference to the parser instance. Used for location information. */
	        this.parser = null;
	        // Make it possible to skip arguments, for backwards-compatibility
	        if (typeof options === "function") {
	            elementCB = options;
	            options = defaultOpts;
	        }
	        if (typeof callback === "object") {
	            options = callback;
	            callback = undefined;
	        }
	        this.callback = callback !== null && callback !== void 0 ? callback : null;
	        this.options = options !== null && options !== void 0 ? options : defaultOpts;
	        this.elementCB = elementCB !== null && elementCB !== void 0 ? elementCB : null;
	    }
	    DomHandler.prototype.onparserinit = function (parser) {
	        this.parser = parser;
	    };
	    // Resets the handler back to starting state
	    DomHandler.prototype.onreset = function () {
	        this.dom = [];
	        this.root = new node_1.Document(this.dom);
	        this.done = false;
	        this.tagStack = [this.root];
	        this.lastNode = null;
	        this.parser = null;
	    };
	    // Signals the handler that parsing is done
	    DomHandler.prototype.onend = function () {
	        if (this.done)
	            return;
	        this.done = true;
	        this.parser = null;
	        this.handleCallback(null);
	    };
	    DomHandler.prototype.onerror = function (error) {
	        this.handleCallback(error);
	    };
	    DomHandler.prototype.onclosetag = function () {
	        this.lastNode = null;
	        var elem = this.tagStack.pop();
	        if (this.options.withEndIndices) {
	            elem.endIndex = this.parser.endIndex;
	        }
	        if (this.elementCB)
	            this.elementCB(elem);
	    };
	    DomHandler.prototype.onopentag = function (name, attribs) {
	        var type = this.options.xmlMode ? domelementtype_1.ElementType.Tag : undefined;
	        var element = new node_1.Element(name, attribs, undefined, type);
	        this.addNode(element);
	        this.tagStack.push(element);
	    };
	    DomHandler.prototype.ontext = function (data) {
	        var normalizeWhitespace = this.options.normalizeWhitespace;
	        var lastNode = this.lastNode;
	        if (lastNode && lastNode.type === domelementtype_1.ElementType.Text) {
	            if (normalizeWhitespace) {
	                lastNode.data = (lastNode.data + data).replace(reWhitespace, " ");
	            }
	            else {
	                lastNode.data += data;
	            }
	            if (this.options.withEndIndices) {
	                lastNode.endIndex = this.parser.endIndex;
	            }
	        }
	        else {
	            if (normalizeWhitespace) {
	                data = data.replace(reWhitespace, " ");
	            }
	            var node = new node_1.Text(data);
	            this.addNode(node);
	            this.lastNode = node;
	        }
	    };
	    DomHandler.prototype.oncomment = function (data) {
	        if (this.lastNode && this.lastNode.type === domelementtype_1.ElementType.Comment) {
	            this.lastNode.data += data;
	            return;
	        }
	        var node = new node_1.Comment(data);
	        this.addNode(node);
	        this.lastNode = node;
	    };
	    DomHandler.prototype.oncommentend = function () {
	        this.lastNode = null;
	    };
	    DomHandler.prototype.oncdatastart = function () {
	        var text = new node_1.Text("");
	        var node = new node_1.NodeWithChildren(domelementtype_1.ElementType.CDATA, [text]);
	        this.addNode(node);
	        text.parent = node;
	        this.lastNode = text;
	    };
	    DomHandler.prototype.oncdataend = function () {
	        this.lastNode = null;
	    };
	    DomHandler.prototype.onprocessinginstruction = function (name, data) {
	        var node = new node_1.ProcessingInstruction(name, data);
	        this.addNode(node);
	    };
	    DomHandler.prototype.handleCallback = function (error) {
	        if (typeof this.callback === "function") {
	            this.callback(error, this.dom);
	        }
	        else if (error) {
	            throw error;
	        }
	    };
	    DomHandler.prototype.addNode = function (node) {
	        var parent = this.tagStack[this.tagStack.length - 1];
	        var previousSibling = parent.children[parent.children.length - 1];
	        if (this.options.withStartIndices) {
	            node.startIndex = this.parser.startIndex;
	        }
	        if (this.options.withEndIndices) {
	            node.endIndex = this.parser.endIndex;
	        }
	        parent.children.push(node);
	        if (previousSibling) {
	            node.prev = previousSibling;
	            previousSibling.next = node;
	        }
	        node.parent = parent;
	        this.lastNode = null;
	    };
	    return DomHandler;
	}());
	exports.DomHandler = DomHandler;
	exports.default = DomHandler; 
} (lib$q));

var lib$o = {};

var lib$n = {};

var decode$3 = {};

var Aacute$1 = "Á";
var aacute$1 = "á";
var Abreve = "Ă";
var abreve = "ă";
var ac = "∾";
var acd = "∿";
var acE = "∾̳";
var Acirc$1 = "Â";
var acirc$1 = "â";
var acute$1 = "´";
var Acy = "А";
var acy = "а";
var AElig$1 = "Æ";
var aelig$1 = "æ";
var af = "⁡";
var Afr = "𝔄";
var afr = "𝔞";
var Agrave$1 = "À";
var agrave$1 = "à";
var alefsym = "ℵ";
var aleph = "ℵ";
var Alpha = "Α";
var alpha = "α";
var Amacr = "Ā";
var amacr = "ā";
var amalg = "⨿";
var amp$2 = "&";
var AMP$1 = "&";
var andand = "⩕";
var And = "⩓";
var and = "∧";
var andd = "⩜";
var andslope = "⩘";
var andv = "⩚";
var ang = "∠";
var ange = "⦤";
var angle = "∠";
var angmsdaa = "⦨";
var angmsdab = "⦩";
var angmsdac = "⦪";
var angmsdad = "⦫";
var angmsdae = "⦬";
var angmsdaf = "⦭";
var angmsdag = "⦮";
var angmsdah = "⦯";
var angmsd = "∡";
var angrt = "∟";
var angrtvb = "⊾";
var angrtvbd = "⦝";
var angsph = "∢";
var angst = "Å";
var angzarr = "⍼";
var Aogon = "Ą";
var aogon = "ą";
var Aopf = "𝔸";
var aopf = "𝕒";
var apacir = "⩯";
var ap = "≈";
var apE = "⩰";
var ape = "≊";
var apid = "≋";
var apos$1 = "'";
var ApplyFunction = "⁡";
var approx = "≈";
var approxeq = "≊";
var Aring$1 = "Å";
var aring$1 = "å";
var Ascr = "𝒜";
var ascr = "𝒶";
var Assign = "≔";
var ast = "*";
var asymp = "≈";
var asympeq = "≍";
var Atilde$1 = "Ã";
var atilde$1 = "ã";
var Auml$1 = "Ä";
var auml$1 = "ä";
var awconint = "∳";
var awint = "⨑";
var backcong = "≌";
var backepsilon = "϶";
var backprime = "‵";
var backsim = "∽";
var backsimeq = "⋍";
var Backslash = "∖";
var Barv = "⫧";
var barvee = "⊽";
var barwed = "⌅";
var Barwed = "⌆";
var barwedge = "⌅";
var bbrk = "⎵";
var bbrktbrk = "⎶";
var bcong = "≌";
var Bcy = "Б";
var bcy = "б";
var bdquo = "„";
var becaus = "∵";
var because = "∵";
var Because = "∵";
var bemptyv = "⦰";
var bepsi = "϶";
var bernou = "ℬ";
var Bernoullis = "ℬ";
var Beta = "Β";
var beta = "β";
var beth = "ℶ";
var between = "≬";
var Bfr = "𝔅";
var bfr = "𝔟";
var bigcap = "⋂";
var bigcirc = "◯";
var bigcup = "⋃";
var bigodot = "⨀";
var bigoplus = "⨁";
var bigotimes = "⨂";
var bigsqcup = "⨆";
var bigstar = "★";
var bigtriangledown = "▽";
var bigtriangleup = "△";
var biguplus = "⨄";
var bigvee = "⋁";
var bigwedge = "⋀";
var bkarow = "⤍";
var blacklozenge = "⧫";
var blacksquare = "▪";
var blacktriangle = "▴";
var blacktriangledown = "▾";
var blacktriangleleft = "◂";
var blacktriangleright = "▸";
var blank = "␣";
var blk12 = "▒";
var blk14 = "░";
var blk34 = "▓";
var block = "█";
var bne = "=⃥";
var bnequiv = "≡⃥";
var bNot = "⫭";
var bnot = "⌐";
var Bopf = "𝔹";
var bopf = "𝕓";
var bot = "⊥";
var bottom = "⊥";
var bowtie = "⋈";
var boxbox = "⧉";
var boxdl = "┐";
var boxdL = "╕";
var boxDl = "╖";
var boxDL = "╗";
var boxdr = "┌";
var boxdR = "╒";
var boxDr = "╓";
var boxDR = "╔";
var boxh = "─";
var boxH = "═";
var boxhd = "┬";
var boxHd = "╤";
var boxhD = "╥";
var boxHD = "╦";
var boxhu = "┴";
var boxHu = "╧";
var boxhU = "╨";
var boxHU = "╩";
var boxminus = "⊟";
var boxplus = "⊞";
var boxtimes = "⊠";
var boxul = "┘";
var boxuL = "╛";
var boxUl = "╜";
var boxUL = "╝";
var boxur = "└";
var boxuR = "╘";
var boxUr = "╙";
var boxUR = "╚";
var boxv = "│";
var boxV = "║";
var boxvh = "┼";
var boxvH = "╪";
var boxVh = "╫";
var boxVH = "╬";
var boxvl = "┤";
var boxvL = "╡";
var boxVl = "╢";
var boxVL = "╣";
var boxvr = "├";
var boxvR = "╞";
var boxVr = "╟";
var boxVR = "╠";
var bprime = "‵";
var breve = "˘";
var Breve = "˘";
var brvbar$1 = "¦";
var bscr = "𝒷";
var Bscr = "ℬ";
var bsemi = "⁏";
var bsim = "∽";
var bsime = "⋍";
var bsolb = "⧅";
var bsol = "\\";
var bsolhsub = "⟈";
var bull = "•";
var bullet = "•";
var bump = "≎";
var bumpE = "⪮";
var bumpe = "≏";
var Bumpeq = "≎";
var bumpeq = "≏";
var Cacute = "Ć";
var cacute = "ć";
var capand = "⩄";
var capbrcup = "⩉";
var capcap = "⩋";
var cap = "∩";
var Cap = "⋒";
var capcup = "⩇";
var capdot = "⩀";
var CapitalDifferentialD = "ⅅ";
var caps = "∩︀";
var caret = "⁁";
var caron = "ˇ";
var Cayleys = "ℭ";
var ccaps = "⩍";
var Ccaron = "Č";
var ccaron = "č";
var Ccedil$1 = "Ç";
var ccedil$1 = "ç";
var Ccirc = "Ĉ";
var ccirc = "ĉ";
var Cconint = "∰";
var ccups = "⩌";
var ccupssm = "⩐";
var Cdot = "Ċ";
var cdot = "ċ";
var cedil$1 = "¸";
var Cedilla = "¸";
var cemptyv = "⦲";
var cent$1 = "¢";
var centerdot = "·";
var CenterDot = "·";
var cfr = "𝔠";
var Cfr = "ℭ";
var CHcy = "Ч";
var chcy = "ч";
var check = "✓";
var checkmark = "✓";
var Chi = "Χ";
var chi = "χ";
var circ = "ˆ";
var circeq = "≗";
var circlearrowleft = "↺";
var circlearrowright = "↻";
var circledast = "⊛";
var circledcirc = "⊚";
var circleddash = "⊝";
var CircleDot = "⊙";
var circledR = "®";
var circledS = "Ⓢ";
var CircleMinus = "⊖";
var CirclePlus = "⊕";
var CircleTimes = "⊗";
var cir = "○";
var cirE = "⧃";
var cire = "≗";
var cirfnint = "⨐";
var cirmid = "⫯";
var cirscir = "⧂";
var ClockwiseContourIntegral = "∲";
var CloseCurlyDoubleQuote = "”";
var CloseCurlyQuote = "’";
var clubs = "♣";
var clubsuit = "♣";
var colon$1 = ":";
var Colon = "∷";
var Colone = "⩴";
var colone = "≔";
var coloneq = "≔";
var comma$1 = ",";
var commat = "@";
var comp = "∁";
var compfn = "∘";
var complement = "∁";
var complexes = "ℂ";
var cong = "≅";
var congdot = "⩭";
var Congruent = "≡";
var conint = "∮";
var Conint = "∯";
var ContourIntegral = "∮";
var copf = "𝕔";
var Copf = "ℂ";
var coprod = "∐";
var Coproduct = "∐";
var copy$1 = "©";
var COPY$1 = "©";
var copysr = "℗";
var CounterClockwiseContourIntegral = "∳";
var crarr = "↵";
var cross = "✗";
var Cross = "⨯";
var Cscr = "𝒞";
var cscr = "𝒸";
var csub = "⫏";
var csube = "⫑";
var csup = "⫐";
var csupe = "⫒";
var ctdot = "⋯";
var cudarrl = "⤸";
var cudarrr = "⤵";
var cuepr = "⋞";
var cuesc = "⋟";
var cularr = "↶";
var cularrp = "⤽";
var cupbrcap = "⩈";
var cupcap = "⩆";
var CupCap = "≍";
var cup = "∪";
var Cup = "⋓";
var cupcup = "⩊";
var cupdot = "⊍";
var cupor = "⩅";
var cups = "∪︀";
var curarr = "↷";
var curarrm = "⤼";
var curlyeqprec = "⋞";
var curlyeqsucc = "⋟";
var curlyvee = "⋎";
var curlywedge = "⋏";
var curren$1 = "¤";
var curvearrowleft = "↶";
var curvearrowright = "↷";
var cuvee = "⋎";
var cuwed = "⋏";
var cwconint = "∲";
var cwint = "∱";
var cylcty = "⌭";
var dagger = "†";
var Dagger = "‡";
var daleth = "ℸ";
var darr = "↓";
var Darr = "↡";
var dArr = "⇓";
var dash = "‐";
var Dashv = "⫤";
var dashv = "⊣";
var dbkarow = "⤏";
var dblac = "˝";
var Dcaron = "Ď";
var dcaron = "ď";
var Dcy = "Д";
var dcy = "д";
var ddagger = "‡";
var ddarr = "⇊";
var DD = "ⅅ";
var dd = "ⅆ";
var DDotrahd = "⤑";
var ddotseq = "⩷";
var deg$1 = "°";
var Del = "∇";
var Delta = "Δ";
var delta = "δ";
var demptyv = "⦱";
var dfisht = "⥿";
var Dfr = "𝔇";
var dfr = "𝔡";
var dHar = "⥥";
var dharl = "⇃";
var dharr = "⇂";
var DiacriticalAcute = "´";
var DiacriticalDot = "˙";
var DiacriticalDoubleAcute = "˝";
var DiacriticalGrave = "`";
var DiacriticalTilde = "˜";
var diam = "⋄";
var diamond = "⋄";
var Diamond = "⋄";
var diamondsuit = "♦";
var diams = "♦";
var die = "¨";
var DifferentialD = "ⅆ";
var digamma = "ϝ";
var disin = "⋲";
var div = "÷";
var divide$1 = "÷";
var divideontimes = "⋇";
var divonx = "⋇";
var DJcy = "Ђ";
var djcy = "ђ";
var dlcorn = "⌞";
var dlcrop = "⌍";
var dollar = "$";
var Dopf = "𝔻";
var dopf = "𝕕";
var Dot = "¨";
var dot = "˙";
var DotDot = "⃜";
var doteq = "≐";
var doteqdot = "≑";
var DotEqual = "≐";
var dotminus = "∸";
var dotplus = "∔";
var dotsquare = "⊡";
var doublebarwedge = "⌆";
var DoubleContourIntegral = "∯";
var DoubleDot = "¨";
var DoubleDownArrow = "⇓";
var DoubleLeftArrow = "⇐";
var DoubleLeftRightArrow = "⇔";
var DoubleLeftTee = "⫤";
var DoubleLongLeftArrow = "⟸";
var DoubleLongLeftRightArrow = "⟺";
var DoubleLongRightArrow = "⟹";
var DoubleRightArrow = "⇒";
var DoubleRightTee = "⊨";
var DoubleUpArrow = "⇑";
var DoubleUpDownArrow = "⇕";
var DoubleVerticalBar = "∥";
var DownArrowBar = "⤓";
var downarrow = "↓";
var DownArrow = "↓";
var Downarrow = "⇓";
var DownArrowUpArrow = "⇵";
var DownBreve = "̑";
var downdownarrows = "⇊";
var downharpoonleft = "⇃";
var downharpoonright = "⇂";
var DownLeftRightVector = "⥐";
var DownLeftTeeVector = "⥞";
var DownLeftVectorBar = "⥖";
var DownLeftVector = "↽";
var DownRightTeeVector = "⥟";
var DownRightVectorBar = "⥗";
var DownRightVector = "⇁";
var DownTeeArrow = "↧";
var DownTee = "⊤";
var drbkarow = "⤐";
var drcorn = "⌟";
var drcrop = "⌌";
var Dscr = "𝒟";
var dscr = "𝒹";
var DScy = "Ѕ";
var dscy = "ѕ";
var dsol = "⧶";
var Dstrok = "Đ";
var dstrok = "đ";
var dtdot = "⋱";
var dtri = "▿";
var dtrif = "▾";
var duarr = "⇵";
var duhar = "⥯";
var dwangle = "⦦";
var DZcy = "Џ";
var dzcy = "џ";
var dzigrarr = "⟿";
var Eacute$1 = "É";
var eacute$1 = "é";
var easter = "⩮";
var Ecaron = "Ě";
var ecaron = "ě";
var Ecirc$1 = "Ê";
var ecirc$1 = "ê";
var ecir = "≖";
var ecolon = "≕";
var Ecy = "Э";
var ecy = "э";
var eDDot = "⩷";
var Edot = "Ė";
var edot = "ė";
var eDot = "≑";
var ee = "ⅇ";
var efDot = "≒";
var Efr = "𝔈";
var efr = "𝔢";
var eg = "⪚";
var Egrave$1 = "È";
var egrave$1 = "è";
var egs = "⪖";
var egsdot = "⪘";
var el = "⪙";
var Element = "∈";
var elinters = "⏧";
var ell = "ℓ";
var els = "⪕";
var elsdot = "⪗";
var Emacr = "Ē";
var emacr = "ē";
var empty$1 = "∅";
var emptyset = "∅";
var EmptySmallSquare = "◻";
var emptyv = "∅";
var EmptyVerySmallSquare = "▫";
var emsp13 = " ";
var emsp14 = " ";
var emsp = " ";
var ENG = "Ŋ";
var eng = "ŋ";
var ensp = " ";
var Eogon = "Ę";
var eogon = "ę";
var Eopf = "𝔼";
var eopf = "𝕖";
var epar = "⋕";
var eparsl = "⧣";
var eplus = "⩱";
var epsi = "ε";
var Epsilon = "Ε";
var epsilon = "ε";
var epsiv = "ϵ";
var eqcirc = "≖";
var eqcolon = "≕";
var eqsim = "≂";
var eqslantgtr = "⪖";
var eqslantless = "⪕";
var Equal = "⩵";
var equals = "=";
var EqualTilde = "≂";
var equest = "≟";
var Equilibrium = "⇌";
var equiv = "≡";
var equivDD = "⩸";
var eqvparsl = "⧥";
var erarr = "⥱";
var erDot = "≓";
var escr = "ℯ";
var Escr = "ℰ";
var esdot = "≐";
var Esim = "⩳";
var esim = "≂";
var Eta = "Η";
var eta = "η";
var ETH$1 = "Ð";
var eth$1 = "ð";
var Euml$1 = "Ë";
var euml$1 = "ë";
var euro = "€";
var excl = "!";
var exist = "∃";
var Exists = "∃";
var expectation = "ℰ";
var exponentiale = "ⅇ";
var ExponentialE = "ⅇ";
var fallingdotseq = "≒";
var Fcy = "Ф";
var fcy = "ф";
var female = "♀";
var ffilig = "ﬃ";
var fflig = "ﬀ";
var ffllig = "ﬄ";
var Ffr = "𝔉";
var ffr = "𝔣";
var filig = "ﬁ";
var FilledSmallSquare = "◼";
var FilledVerySmallSquare = "▪";
var fjlig = "fj";
var flat = "♭";
var fllig = "ﬂ";
var fltns = "▱";
var fnof = "ƒ";
var Fopf = "𝔽";
var fopf = "𝕗";
var forall = "∀";
var ForAll = "∀";
var fork = "⋔";
var forkv = "⫙";
var Fouriertrf = "ℱ";
var fpartint = "⨍";
var frac12$1 = "½";
var frac13 = "⅓";
var frac14$1 = "¼";
var frac15 = "⅕";
var frac16 = "⅙";
var frac18 = "⅛";
var frac23 = "⅔";
var frac25 = "⅖";
var frac34$1 = "¾";
var frac35 = "⅗";
var frac38 = "⅜";
var frac45 = "⅘";
var frac56 = "⅚";
var frac58 = "⅝";
var frac78 = "⅞";
var frasl = "⁄";
var frown = "⌢";
var fscr = "𝒻";
var Fscr = "ℱ";
var gacute = "ǵ";
var Gamma = "Γ";
var gamma = "γ";
var Gammad = "Ϝ";
var gammad = "ϝ";
var gap = "⪆";
var Gbreve = "Ğ";
var gbreve = "ğ";
var Gcedil = "Ģ";
var Gcirc = "Ĝ";
var gcirc = "ĝ";
var Gcy = "Г";
var gcy = "г";
var Gdot = "Ġ";
var gdot = "ġ";
var ge = "≥";
var gE = "≧";
var gEl = "⪌";
var gel = "⋛";
var geq = "≥";
var geqq = "≧";
var geqslant = "⩾";
var gescc = "⪩";
var ges = "⩾";
var gesdot = "⪀";
var gesdoto = "⪂";
var gesdotol = "⪄";
var gesl = "⋛︀";
var gesles = "⪔";
var Gfr = "𝔊";
var gfr = "𝔤";
var gg = "≫";
var Gg = "⋙";
var ggg = "⋙";
var gimel = "ℷ";
var GJcy = "Ѓ";
var gjcy = "ѓ";
var gla = "⪥";
var gl = "≷";
var glE = "⪒";
var glj = "⪤";
var gnap = "⪊";
var gnapprox = "⪊";
var gne = "⪈";
var gnE = "≩";
var gneq = "⪈";
var gneqq = "≩";
var gnsim = "⋧";
var Gopf = "𝔾";
var gopf = "𝕘";
var grave = "`";
var GreaterEqual = "≥";
var GreaterEqualLess = "⋛";
var GreaterFullEqual = "≧";
var GreaterGreater = "⪢";
var GreaterLess = "≷";
var GreaterSlantEqual = "⩾";
var GreaterTilde = "≳";
var Gscr = "𝒢";
var gscr = "ℊ";
var gsim = "≳";
var gsime = "⪎";
var gsiml = "⪐";
var gtcc = "⪧";
var gtcir = "⩺";
var gt$2 = ">";
var GT$1 = ">";
var Gt = "≫";
var gtdot = "⋗";
var gtlPar = "⦕";
var gtquest = "⩼";
var gtrapprox = "⪆";
var gtrarr = "⥸";
var gtrdot = "⋗";
var gtreqless = "⋛";
var gtreqqless = "⪌";
var gtrless = "≷";
var gtrsim = "≳";
var gvertneqq = "≩︀";
var gvnE = "≩︀";
var Hacek = "ˇ";
var hairsp = " ";
var half = "½";
var hamilt = "ℋ";
var HARDcy = "Ъ";
var hardcy = "ъ";
var harrcir = "⥈";
var harr = "↔";
var hArr = "⇔";
var harrw = "↭";
var Hat = "^";
var hbar = "ℏ";
var Hcirc = "Ĥ";
var hcirc = "ĥ";
var hearts = "♥";
var heartsuit = "♥";
var hellip = "…";
var hercon = "⊹";
var hfr = "𝔥";
var Hfr = "ℌ";
var HilbertSpace = "ℋ";
var hksearow = "⤥";
var hkswarow = "⤦";
var hoarr = "⇿";
var homtht = "∻";
var hookleftarrow = "↩";
var hookrightarrow = "↪";
var hopf = "𝕙";
var Hopf = "ℍ";
var horbar = "―";
var HorizontalLine = "─";
var hscr = "𝒽";
var Hscr = "ℋ";
var hslash = "ℏ";
var Hstrok = "Ħ";
var hstrok = "ħ";
var HumpDownHump = "≎";
var HumpEqual = "≏";
var hybull = "⁃";
var hyphen = "‐";
var Iacute$1 = "Í";
var iacute$1 = "í";
var ic = "⁣";
var Icirc$1 = "Î";
var icirc$1 = "î";
var Icy = "И";
var icy = "и";
var Idot = "İ";
var IEcy = "Е";
var iecy = "е";
var iexcl$1 = "¡";
var iff = "⇔";
var ifr = "𝔦";
var Ifr = "ℑ";
var Igrave$1 = "Ì";
var igrave$1 = "ì";
var ii = "ⅈ";
var iiiint = "⨌";
var iiint = "∭";
var iinfin = "⧜";
var iiota = "℩";
var IJlig = "Ĳ";
var ijlig = "ĳ";
var Imacr = "Ī";
var imacr = "ī";
var image$1 = "ℑ";
var ImaginaryI = "ⅈ";
var imagline = "ℐ";
var imagpart = "ℑ";
var imath = "ı";
var Im = "ℑ";
var imof = "⊷";
var imped = "Ƶ";
var Implies = "⇒";
var incare = "℅";
var infin = "∞";
var infintie = "⧝";
var inodot = "ı";
var intcal = "⊺";
var int = "∫";
var Int = "∬";
var integers = "ℤ";
var Integral = "∫";
var intercal = "⊺";
var Intersection = "⋂";
var intlarhk = "⨗";
var intprod = "⨼";
var InvisibleComma = "⁣";
var InvisibleTimes = "⁢";
var IOcy = "Ё";
var iocy = "ё";
var Iogon = "Į";
var iogon = "į";
var Iopf = "𝕀";
var iopf = "𝕚";
var Iota = "Ι";
var iota = "ι";
var iprod = "⨼";
var iquest$1 = "¿";
var iscr = "𝒾";
var Iscr = "ℐ";
var isin = "∈";
var isindot = "⋵";
var isinE = "⋹";
var isins = "⋴";
var isinsv = "⋳";
var isinv = "∈";
var it = "⁢";
var Itilde = "Ĩ";
var itilde = "ĩ";
var Iukcy = "І";
var iukcy = "і";
var Iuml$1 = "Ï";
var iuml$1 = "ï";
var Jcirc = "Ĵ";
var jcirc = "ĵ";
var Jcy = "Й";
var jcy = "й";
var Jfr = "𝔍";
var jfr = "𝔧";
var jmath = "ȷ";
var Jopf = "𝕁";
var jopf = "𝕛";
var Jscr = "𝒥";
var jscr = "𝒿";
var Jsercy = "Ј";
var jsercy = "ј";
var Jukcy = "Є";
var jukcy = "є";
var Kappa = "Κ";
var kappa = "κ";
var kappav = "ϰ";
var Kcedil = "Ķ";
var kcedil = "ķ";
var Kcy = "К";
var kcy = "к";
var Kfr = "𝔎";
var kfr = "𝔨";
var kgreen = "ĸ";
var KHcy = "Х";
var khcy = "х";
var KJcy = "Ќ";
var kjcy = "ќ";
var Kopf = "𝕂";
var kopf = "𝕜";
var Kscr = "𝒦";
var kscr = "𝓀";
var lAarr = "⇚";
var Lacute = "Ĺ";
var lacute = "ĺ";
var laemptyv = "⦴";
var lagran = "ℒ";
var Lambda = "Λ";
var lambda = "λ";
var lang = "⟨";
var Lang = "⟪";
var langd = "⦑";
var langle = "⟨";
var lap = "⪅";
var Laplacetrf = "ℒ";
var laquo$1 = "«";
var larrb = "⇤";
var larrbfs = "⤟";
var larr = "←";
var Larr = "↞";
var lArr = "⇐";
var larrfs = "⤝";
var larrhk = "↩";
var larrlp = "↫";
var larrpl = "⤹";
var larrsim = "⥳";
var larrtl = "↢";
var latail = "⤙";
var lAtail = "⤛";
var lat = "⪫";
var late = "⪭";
var lates = "⪭︀";
var lbarr = "⤌";
var lBarr = "⤎";
var lbbrk = "❲";
var lbrace = "{";
var lbrack = "[";
var lbrke = "⦋";
var lbrksld = "⦏";
var lbrkslu = "⦍";
var Lcaron = "Ľ";
var lcaron = "ľ";
var Lcedil = "Ļ";
var lcedil = "ļ";
var lceil = "⌈";
var lcub = "{";
var Lcy = "Л";
var lcy = "л";
var ldca = "⤶";
var ldquo = "“";
var ldquor = "„";
var ldrdhar = "⥧";
var ldrushar = "⥋";
var ldsh = "↲";
var le = "≤";
var lE = "≦";
var LeftAngleBracket = "⟨";
var LeftArrowBar = "⇤";
var leftarrow = "←";
var LeftArrow = "←";
var Leftarrow = "⇐";
var LeftArrowRightArrow = "⇆";
var leftarrowtail = "↢";
var LeftCeiling = "⌈";
var LeftDoubleBracket = "⟦";
var LeftDownTeeVector = "⥡";
var LeftDownVectorBar = "⥙";
var LeftDownVector = "⇃";
var LeftFloor = "⌊";
var leftharpoondown = "↽";
var leftharpoonup = "↼";
var leftleftarrows = "⇇";
var leftrightarrow = "↔";
var LeftRightArrow = "↔";
var Leftrightarrow = "⇔";
var leftrightarrows = "⇆";
var leftrightharpoons = "⇋";
var leftrightsquigarrow = "↭";
var LeftRightVector = "⥎";
var LeftTeeArrow = "↤";
var LeftTee = "⊣";
var LeftTeeVector = "⥚";
var leftthreetimes = "⋋";
var LeftTriangleBar = "⧏";
var LeftTriangle = "⊲";
var LeftTriangleEqual = "⊴";
var LeftUpDownVector = "⥑";
var LeftUpTeeVector = "⥠";
var LeftUpVectorBar = "⥘";
var LeftUpVector = "↿";
var LeftVectorBar = "⥒";
var LeftVector = "↼";
var lEg = "⪋";
var leg = "⋚";
var leq = "≤";
var leqq = "≦";
var leqslant = "⩽";
var lescc = "⪨";
var les = "⩽";
var lesdot = "⩿";
var lesdoto = "⪁";
var lesdotor = "⪃";
var lesg = "⋚︀";
var lesges = "⪓";
var lessapprox = "⪅";
var lessdot = "⋖";
var lesseqgtr = "⋚";
var lesseqqgtr = "⪋";
var LessEqualGreater = "⋚";
var LessFullEqual = "≦";
var LessGreater = "≶";
var lessgtr = "≶";
var LessLess = "⪡";
var lesssim = "≲";
var LessSlantEqual = "⩽";
var LessTilde = "≲";
var lfisht = "⥼";
var lfloor = "⌊";
var Lfr = "𝔏";
var lfr = "𝔩";
var lg = "≶";
var lgE = "⪑";
var lHar = "⥢";
var lhard = "↽";
var lharu = "↼";
var lharul = "⥪";
var lhblk = "▄";
var LJcy = "Љ";
var ljcy = "љ";
var llarr = "⇇";
var ll = "≪";
var Ll = "⋘";
var llcorner = "⌞";
var Lleftarrow = "⇚";
var llhard = "⥫";
var lltri = "◺";
var Lmidot = "Ŀ";
var lmidot = "ŀ";
var lmoustache = "⎰";
var lmoust = "⎰";
var lnap = "⪉";
var lnapprox = "⪉";
var lne = "⪇";
var lnE = "≨";
var lneq = "⪇";
var lneqq = "≨";
var lnsim = "⋦";
var loang = "⟬";
var loarr = "⇽";
var lobrk = "⟦";
var longleftarrow = "⟵";
var LongLeftArrow = "⟵";
var Longleftarrow = "⟸";
var longleftrightarrow = "⟷";
var LongLeftRightArrow = "⟷";
var Longleftrightarrow = "⟺";
var longmapsto = "⟼";
var longrightarrow = "⟶";
var LongRightArrow = "⟶";
var Longrightarrow = "⟹";
var looparrowleft = "↫";
var looparrowright = "↬";
var lopar = "⦅";
var Lopf = "𝕃";
var lopf = "𝕝";
var loplus = "⨭";
var lotimes = "⨴";
var lowast = "∗";
var lowbar = "_";
var LowerLeftArrow = "↙";
var LowerRightArrow = "↘";
var loz = "◊";
var lozenge = "◊";
var lozf = "⧫";
var lpar = "(";
var lparlt = "⦓";
var lrarr = "⇆";
var lrcorner = "⌟";
var lrhar = "⇋";
var lrhard = "⥭";
var lrm = "‎";
var lrtri = "⊿";
var lsaquo = "‹";
var lscr = "𝓁";
var Lscr = "ℒ";
var lsh = "↰";
var Lsh = "↰";
var lsim = "≲";
var lsime = "⪍";
var lsimg = "⪏";
var lsqb = "[";
var lsquo = "‘";
var lsquor = "‚";
var Lstrok = "Ł";
var lstrok = "ł";
var ltcc = "⪦";
var ltcir = "⩹";
var lt$2 = "<";
var LT$1 = "<";
var Lt = "≪";
var ltdot = "⋖";
var lthree = "⋋";
var ltimes = "⋉";
var ltlarr = "⥶";
var ltquest = "⩻";
var ltri = "◃";
var ltrie = "⊴";
var ltrif = "◂";
var ltrPar = "⦖";
var lurdshar = "⥊";
var luruhar = "⥦";
var lvertneqq = "≨︀";
var lvnE = "≨︀";
var macr$1 = "¯";
var male = "♂";
var malt = "✠";
var maltese = "✠";
var map = "↦";
var mapsto = "↦";
var mapstodown = "↧";
var mapstoleft = "↤";
var mapstoup = "↥";
var marker$1 = "▮";
var mcomma = "⨩";
var Mcy = "М";
var mcy = "м";
var mdash = "—";
var mDDot = "∺";
var measuredangle = "∡";
var MediumSpace = " ";
var Mellintrf = "ℳ";
var Mfr = "𝔐";
var mfr = "𝔪";
var mho = "℧";
var micro$1 = "µ";
var midast = "*";
var midcir = "⫰";
var mid = "∣";
var middot$1 = "·";
var minusb = "⊟";
var minus = "−";
var minusd = "∸";
var minusdu = "⨪";
var MinusPlus = "∓";
var mlcp = "⫛";
var mldr = "…";
var mnplus = "∓";
var models = "⊧";
var Mopf = "𝕄";
var mopf = "𝕞";
var mp = "∓";
var mscr = "𝓂";
var Mscr = "ℳ";
var mstpos = "∾";
var Mu$1 = "Μ";
var mu$1 = "μ";
var multimap = "⊸";
var mumap = "⊸";
var nabla = "∇";
var Nacute = "Ń";
var nacute = "ń";
var nang = "∠⃒";
var nap = "≉";
var napE = "⩰̸";
var napid = "≋̸";
var napos = "ŉ";
var napprox = "≉";
var natural = "♮";
var naturals = "ℕ";
var natur = "♮";
var nbsp$1 = " ";
var nbump = "≎̸";
var nbumpe = "≏̸";
var ncap = "⩃";
var Ncaron = "Ň";
var ncaron = "ň";
var Ncedil = "Ņ";
var ncedil = "ņ";
var ncong = "≇";
var ncongdot = "⩭̸";
var ncup = "⩂";
var Ncy = "Н";
var ncy = "н";
var ndash = "–";
var nearhk = "⤤";
var nearr = "↗";
var neArr = "⇗";
var nearrow = "↗";
var ne = "≠";
var nedot = "≐̸";
var NegativeMediumSpace = "​";
var NegativeThickSpace = "​";
var NegativeThinSpace = "​";
var NegativeVeryThinSpace = "​";
var nequiv = "≢";
var nesear = "⤨";
var nesim = "≂̸";
var NestedGreaterGreater = "≫";
var NestedLessLess = "≪";
var NewLine = "\n";
var nexist = "∄";
var nexists = "∄";
var Nfr = "𝔑";
var nfr = "𝔫";
var ngE = "≧̸";
var nge = "≱";
var ngeq = "≱";
var ngeqq = "≧̸";
var ngeqslant = "⩾̸";
var nges = "⩾̸";
var nGg = "⋙̸";
var ngsim = "≵";
var nGt = "≫⃒";
var ngt = "≯";
var ngtr = "≯";
var nGtv = "≫̸";
var nharr = "↮";
var nhArr = "⇎";
var nhpar = "⫲";
var ni = "∋";
var nis = "⋼";
var nisd = "⋺";
var niv = "∋";
var NJcy = "Њ";
var njcy = "њ";
var nlarr = "↚";
var nlArr = "⇍";
var nldr = "‥";
var nlE = "≦̸";
var nle = "≰";
var nleftarrow = "↚";
var nLeftarrow = "⇍";
var nleftrightarrow = "↮";
var nLeftrightarrow = "⇎";
var nleq = "≰";
var nleqq = "≦̸";
var nleqslant = "⩽̸";
var nles = "⩽̸";
var nless = "≮";
var nLl = "⋘̸";
var nlsim = "≴";
var nLt = "≪⃒";
var nlt = "≮";
var nltri = "⋪";
var nltrie = "⋬";
var nLtv = "≪̸";
var nmid = "∤";
var NoBreak = "⁠";
var NonBreakingSpace = " ";
var nopf = "𝕟";
var Nopf = "ℕ";
var Not = "⫬";
var not$1 = "¬";
var NotCongruent = "≢";
var NotCupCap = "≭";
var NotDoubleVerticalBar = "∦";
var NotElement = "∉";
var NotEqual = "≠";
var NotEqualTilde = "≂̸";
var NotExists = "∄";
var NotGreater = "≯";
var NotGreaterEqual = "≱";
var NotGreaterFullEqual = "≧̸";
var NotGreaterGreater = "≫̸";
var NotGreaterLess = "≹";
var NotGreaterSlantEqual = "⩾̸";
var NotGreaterTilde = "≵";
var NotHumpDownHump = "≎̸";
var NotHumpEqual = "≏̸";
var notin = "∉";
var notindot = "⋵̸";
var notinE = "⋹̸";
var notinva = "∉";
var notinvb = "⋷";
var notinvc = "⋶";
var NotLeftTriangleBar = "⧏̸";
var NotLeftTriangle = "⋪";
var NotLeftTriangleEqual = "⋬";
var NotLess = "≮";
var NotLessEqual = "≰";
var NotLessGreater = "≸";
var NotLessLess = "≪̸";
var NotLessSlantEqual = "⩽̸";
var NotLessTilde = "≴";
var NotNestedGreaterGreater = "⪢̸";
var NotNestedLessLess = "⪡̸";
var notni = "∌";
var notniva = "∌";
var notnivb = "⋾";
var notnivc = "⋽";
var NotPrecedes = "⊀";
var NotPrecedesEqual = "⪯̸";
var NotPrecedesSlantEqual = "⋠";
var NotReverseElement = "∌";
var NotRightTriangleBar = "⧐̸";
var NotRightTriangle = "⋫";
var NotRightTriangleEqual = "⋭";
var NotSquareSubset = "⊏̸";
var NotSquareSubsetEqual = "⋢";
var NotSquareSuperset = "⊐̸";
var NotSquareSupersetEqual = "⋣";
var NotSubset = "⊂⃒";
var NotSubsetEqual = "⊈";
var NotSucceeds = "⊁";
var NotSucceedsEqual = "⪰̸";
var NotSucceedsSlantEqual = "⋡";
var NotSucceedsTilde = "≿̸";
var NotSuperset = "⊃⃒";
var NotSupersetEqual = "⊉";
var NotTilde = "≁";
var NotTildeEqual = "≄";
var NotTildeFullEqual = "≇";
var NotTildeTilde = "≉";
var NotVerticalBar = "∤";
var nparallel = "∦";
var npar = "∦";
var nparsl = "⫽⃥";
var npart = "∂̸";
var npolint = "⨔";
var npr = "⊀";
var nprcue = "⋠";
var nprec = "⊀";
var npreceq = "⪯̸";
var npre = "⪯̸";
var nrarrc = "⤳̸";
var nrarr = "↛";
var nrArr = "⇏";
var nrarrw = "↝̸";
var nrightarrow = "↛";
var nRightarrow = "⇏";
var nrtri = "⋫";
var nrtrie = "⋭";
var nsc = "⊁";
var nsccue = "⋡";
var nsce = "⪰̸";
var Nscr = "𝒩";
var nscr = "𝓃";
var nshortmid = "∤";
var nshortparallel = "∦";
var nsim = "≁";
var nsime = "≄";
var nsimeq = "≄";
var nsmid = "∤";
var nspar = "∦";
var nsqsube = "⋢";
var nsqsupe = "⋣";
var nsub = "⊄";
var nsubE = "⫅̸";
var nsube = "⊈";
var nsubset = "⊂⃒";
var nsubseteq = "⊈";
var nsubseteqq = "⫅̸";
var nsucc = "⊁";
var nsucceq = "⪰̸";
var nsup = "⊅";
var nsupE = "⫆̸";
var nsupe = "⊉";
var nsupset = "⊃⃒";
var nsupseteq = "⊉";
var nsupseteqq = "⫆̸";
var ntgl = "≹";
var Ntilde$1 = "Ñ";
var ntilde$1 = "ñ";
var ntlg = "≸";
var ntriangleleft = "⋪";
var ntrianglelefteq = "⋬";
var ntriangleright = "⋫";
var ntrianglerighteq = "⋭";
var Nu$1 = "Ν";
var nu$1 = "ν";
var num = "#";
var numero = "№";
var numsp = " ";
var nvap = "≍⃒";
var nvdash = "⊬";
var nvDash = "⊭";
var nVdash = "⊮";
var nVDash = "⊯";
var nvge = "≥⃒";
var nvgt = ">⃒";
var nvHarr = "⤄";
var nvinfin = "⧞";
var nvlArr = "⤂";
var nvle = "≤⃒";
var nvlt = "<⃒";
var nvltrie = "⊴⃒";
var nvrArr = "⤃";
var nvrtrie = "⊵⃒";
var nvsim = "∼⃒";
var nwarhk = "⤣";
var nwarr = "↖";
var nwArr = "⇖";
var nwarrow = "↖";
var nwnear = "⤧";
var Oacute$1 = "Ó";
var oacute$1 = "ó";
var oast = "⊛";
var Ocirc$1 = "Ô";
var ocirc$1 = "ô";
var ocir = "⊚";
var Ocy = "О";
var ocy = "о";
var odash = "⊝";
var Odblac = "Ő";
var odblac = "ő";
var odiv = "⨸";
var odot = "⊙";
var odsold = "⦼";
var OElig = "Œ";
var oelig = "œ";
var ofcir = "⦿";
var Ofr = "𝔒";
var ofr = "𝔬";
var ogon = "˛";
var Ograve$1 = "Ò";
var ograve$1 = "ò";
var ogt = "⧁";
var ohbar = "⦵";
var ohm = "Ω";
var oint = "∮";
var olarr = "↺";
var olcir = "⦾";
var olcross = "⦻";
var oline = "‾";
var olt = "⧀";
var Omacr = "Ō";
var omacr = "ō";
var Omega = "Ω";
var omega = "ω";
var Omicron = "Ο";
var omicron = "ο";
var omid = "⦶";
var ominus = "⊖";
var Oopf = "𝕆";
var oopf = "𝕠";
var opar = "⦷";
var OpenCurlyDoubleQuote = "“";
var OpenCurlyQuote = "‘";
var operp = "⦹";
var oplus = "⊕";
var orarr = "↻";
var Or = "⩔";
var or = "∨";
var ord = "⩝";
var order = "ℴ";
var orderof = "ℴ";
var ordf$1 = "ª";
var ordm$1 = "º";
var origof = "⊶";
var oror = "⩖";
var orslope = "⩗";
var orv = "⩛";
var oS = "Ⓢ";
var Oscr = "𝒪";
var oscr = "ℴ";
var Oslash$1 = "Ø";
var oslash$1 = "ø";
var osol = "⊘";
var Otilde$1 = "Õ";
var otilde$1 = "õ";
var otimesas = "⨶";
var Otimes = "⨷";
var otimes = "⊗";
var Ouml$1 = "Ö";
var ouml$1 = "ö";
var ovbar = "⌽";
var OverBar = "‾";
var OverBrace = "⏞";
var OverBracket = "⎴";
var OverParenthesis = "⏜";
var para$1 = "¶";
var parallel = "∥";
var par = "∥";
var parsim = "⫳";
var parsl = "⫽";
var part = "∂";
var PartialD = "∂";
var Pcy = "П";
var pcy = "п";
var percnt = "%";
var period = ".";
var permil = "‰";
var perp = "⊥";
var pertenk = "‱";
var Pfr = "𝔓";
var pfr = "𝔭";
var Phi = "Φ";
var phi = "φ";
var phiv = "ϕ";
var phmmat = "ℳ";
var phone = "☎";
var Pi = "Π";
var pi = "π";
var pitchfork = "⋔";
var piv = "ϖ";
var planck = "ℏ";
var planckh = "ℎ";
var plankv = "ℏ";
var plusacir = "⨣";
var plusb = "⊞";
var pluscir = "⨢";
var plus = "+";
var plusdo = "∔";
var plusdu = "⨥";
var pluse = "⩲";
var PlusMinus = "±";
var plusmn$1 = "±";
var plussim = "⨦";
var plustwo = "⨧";
var pm = "±";
var Poincareplane = "ℌ";
var pointint = "⨕";
var popf = "𝕡";
var Popf = "ℙ";
var pound$1 = "£";
var prap = "⪷";
var Pr = "⪻";
var pr = "≺";
var prcue = "≼";
var precapprox = "⪷";
var prec = "≺";
var preccurlyeq = "≼";
var Precedes = "≺";
var PrecedesEqual = "⪯";
var PrecedesSlantEqual = "≼";
var PrecedesTilde = "≾";
var preceq = "⪯";
var precnapprox = "⪹";
var precneqq = "⪵";
var precnsim = "⋨";
var pre = "⪯";
var prE = "⪳";
var precsim = "≾";
var prime = "′";
var Prime = "″";
var primes = "ℙ";
var prnap = "⪹";
var prnE = "⪵";
var prnsim = "⋨";
var prod = "∏";
var Product = "∏";
var profalar = "⌮";
var profline = "⌒";
var profsurf = "⌓";
var prop = "∝";
var Proportional = "∝";
var Proportion = "∷";
var propto = "∝";
var prsim = "≾";
var prurel = "⊰";
var Pscr = "𝒫";
var pscr = "𝓅";
var Psi = "Ψ";
var psi = "ψ";
var puncsp = " ";
var Qfr = "𝔔";
var qfr = "𝔮";
var qint = "⨌";
var qopf = "𝕢";
var Qopf = "ℚ";
var qprime = "⁗";
var Qscr = "𝒬";
var qscr = "𝓆";
var quaternions = "ℍ";
var quatint = "⨖";
var quest = "?";
var questeq = "≟";
var quot$2 = "\"";
var QUOT$1 = "\"";
var rAarr = "⇛";
var race = "∽̱";
var Racute = "Ŕ";
var racute = "ŕ";
var radic = "√";
var raemptyv = "⦳";
var rang = "⟩";
var Rang = "⟫";
var rangd = "⦒";
var range = "⦥";
var rangle = "⟩";
var raquo$1 = "»";
var rarrap = "⥵";
var rarrb = "⇥";
var rarrbfs = "⤠";
var rarrc = "⤳";
var rarr = "→";
var Rarr = "↠";
var rArr = "⇒";
var rarrfs = "⤞";
var rarrhk = "↪";
var rarrlp = "↬";
var rarrpl = "⥅";
var rarrsim = "⥴";
var Rarrtl = "⤖";
var rarrtl = "↣";
var rarrw = "↝";
var ratail = "⤚";
var rAtail = "⤜";
var ratio = "∶";
var rationals = "ℚ";
var rbarr = "⤍";
var rBarr = "⤏";
var RBarr = "⤐";
var rbbrk = "❳";
var rbrace = "}";
var rbrack = "]";
var rbrke = "⦌";
var rbrksld = "⦎";
var rbrkslu = "⦐";
var Rcaron = "Ř";
var rcaron = "ř";
var Rcedil = "Ŗ";
var rcedil = "ŗ";
var rceil = "⌉";
var rcub = "}";
var Rcy = "Р";
var rcy = "р";
var rdca = "⤷";
var rdldhar = "⥩";
var rdquo = "”";
var rdquor = "”";
var rdsh = "↳";
var real = "ℜ";
var realine = "ℛ";
var realpart = "ℜ";
var reals = "ℝ";
var Re = "ℜ";
var rect = "▭";
var reg$1 = "®";
var REG$1 = "®";
var ReverseElement = "∋";
var ReverseEquilibrium = "⇋";
var ReverseUpEquilibrium = "⥯";
var rfisht = "⥽";
var rfloor = "⌋";
var rfr = "𝔯";
var Rfr = "ℜ";
var rHar = "⥤";
var rhard = "⇁";
var rharu = "⇀";
var rharul = "⥬";
var Rho = "Ρ";
var rho = "ρ";
var rhov = "ϱ";
var RightAngleBracket = "⟩";
var RightArrowBar = "⇥";
var rightarrow = "→";
var RightArrow = "→";
var Rightarrow = "⇒";
var RightArrowLeftArrow = "⇄";
var rightarrowtail = "↣";
var RightCeiling = "⌉";
var RightDoubleBracket = "⟧";
var RightDownTeeVector = "⥝";
var RightDownVectorBar = "⥕";
var RightDownVector = "⇂";
var RightFloor = "⌋";
var rightharpoondown = "⇁";
var rightharpoonup = "⇀";
var rightleftarrows = "⇄";
var rightleftharpoons = "⇌";
var rightrightarrows = "⇉";
var rightsquigarrow = "↝";
var RightTeeArrow = "↦";
var RightTee = "⊢";
var RightTeeVector = "⥛";
var rightthreetimes = "⋌";
var RightTriangleBar = "⧐";
var RightTriangle = "⊳";
var RightTriangleEqual = "⊵";
var RightUpDownVector = "⥏";
var RightUpTeeVector = "⥜";
var RightUpVectorBar = "⥔";
var RightUpVector = "↾";
var RightVectorBar = "⥓";
var RightVector = "⇀";
var ring = "˚";
var risingdotseq = "≓";
var rlarr = "⇄";
var rlhar = "⇌";
var rlm = "‏";
var rmoustache = "⎱";
var rmoust = "⎱";
var rnmid = "⫮";
var roang = "⟭";
var roarr = "⇾";
var robrk = "⟧";
var ropar = "⦆";
var ropf = "𝕣";
var Ropf = "ℝ";
var roplus = "⨮";
var rotimes = "⨵";
var RoundImplies = "⥰";
var rpar = ")";
var rpargt = "⦔";
var rppolint = "⨒";
var rrarr = "⇉";
var Rrightarrow = "⇛";
var rsaquo = "›";
var rscr = "𝓇";
var Rscr = "ℛ";
var rsh = "↱";
var Rsh = "↱";
var rsqb = "]";
var rsquo = "’";
var rsquor = "’";
var rthree = "⋌";
var rtimes = "⋊";
var rtri = "▹";
var rtrie = "⊵";
var rtrif = "▸";
var rtriltri = "⧎";
var RuleDelayed = "⧴";
var ruluhar = "⥨";
var rx = "℞";
var Sacute = "Ś";
var sacute = "ś";
var sbquo = "‚";
var scap = "⪸";
var Scaron = "Š";
var scaron = "š";
var Sc = "⪼";
var sc = "≻";
var sccue = "≽";
var sce = "⪰";
var scE = "⪴";
var Scedil = "Ş";
var scedil = "ş";
var Scirc = "Ŝ";
var scirc = "ŝ";
var scnap = "⪺";
var scnE = "⪶";
var scnsim = "⋩";
var scpolint = "⨓";
var scsim = "≿";
var Scy = "С";
var scy = "с";
var sdotb = "⊡";
var sdot = "⋅";
var sdote = "⩦";
var searhk = "⤥";
var searr = "↘";
var seArr = "⇘";
var searrow = "↘";
var sect$1 = "§";
var semi = ";";
var seswar = "⤩";
var setminus = "∖";
var setmn = "∖";
var sext = "✶";
var Sfr = "𝔖";
var sfr = "𝔰";
var sfrown = "⌢";
var sharp = "♯";
var SHCHcy = "Щ";
var shchcy = "щ";
var SHcy = "Ш";
var shcy = "ш";
var ShortDownArrow = "↓";
var ShortLeftArrow = "←";
var shortmid = "∣";
var shortparallel = "∥";
var ShortRightArrow = "→";
var ShortUpArrow = "↑";
var shy$1 = "­";
var Sigma = "Σ";
var sigma = "σ";
var sigmaf = "ς";
var sigmav = "ς";
var sim = "∼";
var simdot = "⩪";
var sime = "≃";
var simeq = "≃";
var simg = "⪞";
var simgE = "⪠";
var siml = "⪝";
var simlE = "⪟";
var simne = "≆";
var simplus = "⨤";
var simrarr = "⥲";
var slarr = "←";
var SmallCircle = "∘";
var smallsetminus = "∖";
var smashp = "⨳";
var smeparsl = "⧤";
var smid = "∣";
var smile = "⌣";
var smt = "⪪";
var smte = "⪬";
var smtes = "⪬︀";
var SOFTcy = "Ь";
var softcy = "ь";
var solbar = "⌿";
var solb = "⧄";
var sol = "/";
var Sopf = "𝕊";
var sopf = "𝕤";
var spades = "♠";
var spadesuit = "♠";
var spar = "∥";
var sqcap = "⊓";
var sqcaps = "⊓︀";
var sqcup = "⊔";
var sqcups = "⊔︀";
var Sqrt = "√";
var sqsub = "⊏";
var sqsube = "⊑";
var sqsubset = "⊏";
var sqsubseteq = "⊑";
var sqsup = "⊐";
var sqsupe = "⊒";
var sqsupset = "⊐";
var sqsupseteq = "⊒";
var square = "□";
var Square = "□";
var SquareIntersection = "⊓";
var SquareSubset = "⊏";
var SquareSubsetEqual = "⊑";
var SquareSuperset = "⊐";
var SquareSupersetEqual = "⊒";
var SquareUnion = "⊔";
var squarf = "▪";
var squ = "□";
var squf = "▪";
var srarr = "→";
var Sscr = "𝒮";
var sscr = "𝓈";
var ssetmn = "∖";
var ssmile = "⌣";
var sstarf = "⋆";
var Star = "⋆";
var star = "☆";
var starf = "★";
var straightepsilon = "ϵ";
var straightphi = "ϕ";
var strns = "¯";
var sub = "⊂";
var Sub = "⋐";
var subdot = "⪽";
var subE = "⫅";
var sube = "⊆";
var subedot = "⫃";
var submult = "⫁";
var subnE = "⫋";
var subne = "⊊";
var subplus = "⪿";
var subrarr = "⥹";
var subset = "⊂";
var Subset = "⋐";
var subseteq = "⊆";
var subseteqq = "⫅";
var SubsetEqual = "⊆";
var subsetneq = "⊊";
var subsetneqq = "⫋";
var subsim = "⫇";
var subsub = "⫕";
var subsup = "⫓";
var succapprox = "⪸";
var succ = "≻";
var succcurlyeq = "≽";
var Succeeds = "≻";
var SucceedsEqual = "⪰";
var SucceedsSlantEqual = "≽";
var SucceedsTilde = "≿";
var succeq = "⪰";
var succnapprox = "⪺";
var succneqq = "⪶";
var succnsim = "⋩";
var succsim = "≿";
var SuchThat = "∋";
var sum = "∑";
var Sum = "∑";
var sung = "♪";
var sup1$1 = "¹";
var sup2$1 = "²";
var sup3$1 = "³";
var sup = "⊃";
var Sup = "⋑";
var supdot = "⪾";
var supdsub = "⫘";
var supE = "⫆";
var supe = "⊇";
var supedot = "⫄";
var Superset = "⊃";
var SupersetEqual = "⊇";
var suphsol = "⟉";
var suphsub = "⫗";
var suplarr = "⥻";
var supmult = "⫂";
var supnE = "⫌";
var supne = "⊋";
var supplus = "⫀";
var supset = "⊃";
var Supset = "⋑";
var supseteq = "⊇";
var supseteqq = "⫆";
var supsetneq = "⊋";
var supsetneqq = "⫌";
var supsim = "⫈";
var supsub = "⫔";
var supsup = "⫖";
var swarhk = "⤦";
var swarr = "↙";
var swArr = "⇙";
var swarrow = "↙";
var swnwar = "⤪";
var szlig$1 = "ß";
var Tab = "\t";
var target = "⌖";
var Tau = "Τ";
var tau = "τ";
var tbrk = "⎴";
var Tcaron = "Ť";
var tcaron = "ť";
var Tcedil = "Ţ";
var tcedil = "ţ";
var Tcy = "Т";
var tcy = "т";
var tdot = "⃛";
var telrec = "⌕";
var Tfr = "𝔗";
var tfr = "𝔱";
var there4 = "∴";
var therefore = "∴";
var Therefore = "∴";
var Theta = "Θ";
var theta = "θ";
var thetasym = "ϑ";
var thetav = "ϑ";
var thickapprox = "≈";
var thicksim = "∼";
var ThickSpace = "  ";
var ThinSpace = " ";
var thinsp = " ";
var thkap = "≈";
var thksim = "∼";
var THORN$1 = "Þ";
var thorn$1 = "þ";
var tilde = "˜";
var Tilde = "∼";
var TildeEqual = "≃";
var TildeFullEqual = "≅";
var TildeTilde = "≈";
var timesbar = "⨱";
var timesb = "⊠";
var times$1 = "×";
var timesd = "⨰";
var tint = "∭";
var toea = "⤨";
var topbot = "⌶";
var topcir = "⫱";
var top = "⊤";
var Topf = "𝕋";
var topf = "𝕥";
var topfork = "⫚";
var tosa = "⤩";
var tprime = "‴";
var trade = "™";
var TRADE = "™";
var triangle = "▵";
var triangledown = "▿";
var triangleleft = "◃";
var trianglelefteq = "⊴";
var triangleq = "≜";
var triangleright = "▹";
var trianglerighteq = "⊵";
var tridot = "◬";
var trie = "≜";
var triminus = "⨺";
var TripleDot = "⃛";
var triplus = "⨹";
var trisb = "⧍";
var tritime = "⨻";
var trpezium = "⏢";
var Tscr = "𝒯";
var tscr = "𝓉";
var TScy = "Ц";
var tscy = "ц";
var TSHcy = "Ћ";
var tshcy = "ћ";
var Tstrok = "Ŧ";
var tstrok = "ŧ";
var twixt = "≬";
var twoheadleftarrow = "↞";
var twoheadrightarrow = "↠";
var Uacute$1 = "Ú";
var uacute$1 = "ú";
var uarr = "↑";
var Uarr = "↟";
var uArr = "⇑";
var Uarrocir = "⥉";
var Ubrcy = "Ў";
var ubrcy = "ў";
var Ubreve = "Ŭ";
var ubreve = "ŭ";
var Ucirc$1 = "Û";
var ucirc$1 = "û";
var Ucy = "У";
var ucy = "у";
var udarr = "⇅";
var Udblac = "Ű";
var udblac = "ű";
var udhar = "⥮";
var ufisht = "⥾";
var Ufr = "𝔘";
var ufr = "𝔲";
var Ugrave$1 = "Ù";
var ugrave$1 = "ù";
var uHar = "⥣";
var uharl = "↿";
var uharr = "↾";
var uhblk = "▀";
var ulcorn = "⌜";
var ulcorner = "⌜";
var ulcrop = "⌏";
var ultri = "◸";
var Umacr = "Ū";
var umacr = "ū";
var uml$1 = "¨";
var UnderBar = "_";
var UnderBrace = "⏟";
var UnderBracket = "⎵";
var UnderParenthesis = "⏝";
var Union = "⋃";
var UnionPlus = "⊎";
var Uogon = "Ų";
var uogon = "ų";
var Uopf = "𝕌";
var uopf = "𝕦";
var UpArrowBar = "⤒";
var uparrow = "↑";
var UpArrow = "↑";
var Uparrow = "⇑";
var UpArrowDownArrow = "⇅";
var updownarrow = "↕";
var UpDownArrow = "↕";
var Updownarrow = "⇕";
var UpEquilibrium = "⥮";
var upharpoonleft = "↿";
var upharpoonright = "↾";
var uplus = "⊎";
var UpperLeftArrow = "↖";
var UpperRightArrow = "↗";
var upsi = "υ";
var Upsi = "ϒ";
var upsih = "ϒ";
var Upsilon = "Υ";
var upsilon = "υ";
var UpTeeArrow = "↥";
var UpTee = "⊥";
var upuparrows = "⇈";
var urcorn = "⌝";
var urcorner = "⌝";
var urcrop = "⌎";
var Uring = "Ů";
var uring = "ů";
var urtri = "◹";
var Uscr = "𝒰";
var uscr = "𝓊";
var utdot = "⋰";
var Utilde = "Ũ";
var utilde = "ũ";
var utri = "▵";
var utrif = "▴";
var uuarr = "⇈";
var Uuml$1 = "Ü";
var uuml$1 = "ü";
var uwangle = "⦧";
var vangrt = "⦜";
var varepsilon = "ϵ";
var varkappa = "ϰ";
var varnothing = "∅";
var varphi = "ϕ";
var varpi = "ϖ";
var varpropto = "∝";
var varr = "↕";
var vArr = "⇕";
var varrho = "ϱ";
var varsigma = "ς";
var varsubsetneq = "⊊︀";
var varsubsetneqq = "⫋︀";
var varsupsetneq = "⊋︀";
var varsupsetneqq = "⫌︀";
var vartheta = "ϑ";
var vartriangleleft = "⊲";
var vartriangleright = "⊳";
var vBar = "⫨";
var Vbar = "⫫";
var vBarv = "⫩";
var Vcy = "В";
var vcy = "в";
var vdash = "⊢";
var vDash = "⊨";
var Vdash = "⊩";
var VDash = "⊫";
var Vdashl = "⫦";
var veebar = "⊻";
var vee = "∨";
var Vee = "⋁";
var veeeq = "≚";
var vellip = "⋮";
var verbar = "|";
var Verbar = "‖";
var vert = "|";
var Vert = "‖";
var VerticalBar = "∣";
var VerticalLine = "|";
var VerticalSeparator = "❘";
var VerticalTilde = "≀";
var VeryThinSpace = " ";
var Vfr = "𝔙";
var vfr = "𝔳";
var vltri = "⊲";
var vnsub = "⊂⃒";
var vnsup = "⊃⃒";
var Vopf = "𝕍";
var vopf = "𝕧";
var vprop = "∝";
var vrtri = "⊳";
var Vscr = "𝒱";
var vscr = "𝓋";
var vsubnE = "⫋︀";
var vsubne = "⊊︀";
var vsupnE = "⫌︀";
var vsupne = "⊋︀";
var Vvdash = "⊪";
var vzigzag = "⦚";
var Wcirc = "Ŵ";
var wcirc = "ŵ";
var wedbar = "⩟";
var wedge = "∧";
var Wedge = "⋀";
var wedgeq = "≙";
var weierp = "℘";
var Wfr = "𝔚";
var wfr = "𝔴";
var Wopf = "𝕎";
var wopf = "𝕨";
var wp = "℘";
var wr = "≀";
var wreath = "≀";
var Wscr = "𝒲";
var wscr = "𝓌";
var xcap = "⋂";
var xcirc = "◯";
var xcup = "⋃";
var xdtri = "▽";
var Xfr = "𝔛";
var xfr = "𝔵";
var xharr = "⟷";
var xhArr = "⟺";
var Xi = "Ξ";
var xi = "ξ";
var xlarr = "⟵";
var xlArr = "⟸";
var xmap = "⟼";
var xnis = "⋻";
var xodot = "⨀";
var Xopf = "𝕏";
var xopf = "𝕩";
var xoplus = "⨁";
var xotime = "⨂";
var xrarr = "⟶";
var xrArr = "⟹";
var Xscr = "𝒳";
var xscr = "𝓍";
var xsqcup = "⨆";
var xuplus = "⨄";
var xutri = "△";
var xvee = "⋁";
var xwedge = "⋀";
var Yacute$1 = "Ý";
var yacute$1 = "ý";
var YAcy = "Я";
var yacy = "я";
var Ycirc = "Ŷ";
var ycirc = "ŷ";
var Ycy = "Ы";
var ycy = "ы";
var yen$1 = "¥";
var Yfr = "𝔜";
var yfr = "𝔶";
var YIcy = "Ї";
var yicy = "ї";
var Yopf = "𝕐";
var yopf = "𝕪";
var Yscr = "𝒴";
var yscr = "𝓎";
var YUcy = "Ю";
var yucy = "ю";
var yuml$1 = "ÿ";
var Yuml = "Ÿ";
var Zacute = "Ź";
var zacute = "ź";
var Zcaron = "Ž";
var zcaron = "ž";
var Zcy = "З";
var zcy = "з";
var Zdot = "Ż";
var zdot = "ż";
var zeetrf = "ℨ";
var ZeroWidthSpace = "​";
var Zeta = "Ζ";
var zeta = "ζ";
var zfr = "𝔷";
var Zfr = "ℨ";
var ZHcy = "Ж";
var zhcy = "ж";
var zigrarr = "⇝";
var zopf = "𝕫";
var Zopf = "ℤ";
var Zscr = "𝒵";
var zscr = "𝓏";
var zwj = "‍";
var zwnj = "‌";
var require$$1$3 = {
	Aacute: Aacute$1,
	aacute: aacute$1,
	Abreve: Abreve,
	abreve: abreve,
	ac: ac,
	acd: acd,
	acE: acE,
	Acirc: Acirc$1,
	acirc: acirc$1,
	acute: acute$1,
	Acy: Acy,
	acy: acy,
	AElig: AElig$1,
	aelig: aelig$1,
	af: af,
	Afr: Afr,
	afr: afr,
	Agrave: Agrave$1,
	agrave: agrave$1,
	alefsym: alefsym,
	aleph: aleph,
	Alpha: Alpha,
	alpha: alpha,
	Amacr: Amacr,
	amacr: amacr,
	amalg: amalg,
	amp: amp$2,
	AMP: AMP$1,
	andand: andand,
	And: And,
	and: and,
	andd: andd,
	andslope: andslope,
	andv: andv,
	ang: ang,
	ange: ange,
	angle: angle,
	angmsdaa: angmsdaa,
	angmsdab: angmsdab,
	angmsdac: angmsdac,
	angmsdad: angmsdad,
	angmsdae: angmsdae,
	angmsdaf: angmsdaf,
	angmsdag: angmsdag,
	angmsdah: angmsdah,
	angmsd: angmsd,
	angrt: angrt,
	angrtvb: angrtvb,
	angrtvbd: angrtvbd,
	angsph: angsph,
	angst: angst,
	angzarr: angzarr,
	Aogon: Aogon,
	aogon: aogon,
	Aopf: Aopf,
	aopf: aopf,
	apacir: apacir,
	ap: ap,
	apE: apE,
	ape: ape,
	apid: apid,
	apos: apos$1,
	ApplyFunction: ApplyFunction,
	approx: approx,
	approxeq: approxeq,
	Aring: Aring$1,
	aring: aring$1,
	Ascr: Ascr,
	ascr: ascr,
	Assign: Assign,
	ast: ast,
	asymp: asymp,
	asympeq: asympeq,
	Atilde: Atilde$1,
	atilde: atilde$1,
	Auml: Auml$1,
	auml: auml$1,
	awconint: awconint,
	awint: awint,
	backcong: backcong,
	backepsilon: backepsilon,
	backprime: backprime,
	backsim: backsim,
	backsimeq: backsimeq,
	Backslash: Backslash,
	Barv: Barv,
	barvee: barvee,
	barwed: barwed,
	Barwed: Barwed,
	barwedge: barwedge,
	bbrk: bbrk,
	bbrktbrk: bbrktbrk,
	bcong: bcong,
	Bcy: Bcy,
	bcy: bcy,
	bdquo: bdquo,
	becaus: becaus,
	because: because,
	Because: Because,
	bemptyv: bemptyv,
	bepsi: bepsi,
	bernou: bernou,
	Bernoullis: Bernoullis,
	Beta: Beta,
	beta: beta,
	beth: beth,
	between: between,
	Bfr: Bfr,
	bfr: bfr,
	bigcap: bigcap,
	bigcirc: bigcirc,
	bigcup: bigcup,
	bigodot: bigodot,
	bigoplus: bigoplus,
	bigotimes: bigotimes,
	bigsqcup: bigsqcup,
	bigstar: bigstar,
	bigtriangledown: bigtriangledown,
	bigtriangleup: bigtriangleup,
	biguplus: biguplus,
	bigvee: bigvee,
	bigwedge: bigwedge,
	bkarow: bkarow,
	blacklozenge: blacklozenge,
	blacksquare: blacksquare,
	blacktriangle: blacktriangle,
	blacktriangledown: blacktriangledown,
	blacktriangleleft: blacktriangleleft,
	blacktriangleright: blacktriangleright,
	blank: blank,
	blk12: blk12,
	blk14: blk14,
	blk34: blk34,
	block: block,
	bne: bne,
	bnequiv: bnequiv,
	bNot: bNot,
	bnot: bnot,
	Bopf: Bopf,
	bopf: bopf,
	bot: bot,
	bottom: bottom,
	bowtie: bowtie,
	boxbox: boxbox,
	boxdl: boxdl,
	boxdL: boxdL,
	boxDl: boxDl,
	boxDL: boxDL,
	boxdr: boxdr,
	boxdR: boxdR,
	boxDr: boxDr,
	boxDR: boxDR,
	boxh: boxh,
	boxH: boxH,
	boxhd: boxhd,
	boxHd: boxHd,
	boxhD: boxhD,
	boxHD: boxHD,
	boxhu: boxhu,
	boxHu: boxHu,
	boxhU: boxhU,
	boxHU: boxHU,
	boxminus: boxminus,
	boxplus: boxplus,
	boxtimes: boxtimes,
	boxul: boxul,
	boxuL: boxuL,
	boxUl: boxUl,
	boxUL: boxUL,
	boxur: boxur,
	boxuR: boxuR,
	boxUr: boxUr,
	boxUR: boxUR,
	boxv: boxv,
	boxV: boxV,
	boxvh: boxvh,
	boxvH: boxvH,
	boxVh: boxVh,
	boxVH: boxVH,
	boxvl: boxvl,
	boxvL: boxvL,
	boxVl: boxVl,
	boxVL: boxVL,
	boxvr: boxvr,
	boxvR: boxvR,
	boxVr: boxVr,
	boxVR: boxVR,
	bprime: bprime,
	breve: breve,
	Breve: Breve,
	brvbar: brvbar$1,
	bscr: bscr,
	Bscr: Bscr,
	bsemi: bsemi,
	bsim: bsim,
	bsime: bsime,
	bsolb: bsolb,
	bsol: bsol,
	bsolhsub: bsolhsub,
	bull: bull,
	bullet: bullet,
	bump: bump,
	bumpE: bumpE,
	bumpe: bumpe,
	Bumpeq: Bumpeq,
	bumpeq: bumpeq,
	Cacute: Cacute,
	cacute: cacute,
	capand: capand,
	capbrcup: capbrcup,
	capcap: capcap,
	cap: cap,
	Cap: Cap,
	capcup: capcup,
	capdot: capdot,
	CapitalDifferentialD: CapitalDifferentialD,
	caps: caps,
	caret: caret,
	caron: caron,
	Cayleys: Cayleys,
	ccaps: ccaps,
	Ccaron: Ccaron,
	ccaron: ccaron,
	Ccedil: Ccedil$1,
	ccedil: ccedil$1,
	Ccirc: Ccirc,
	ccirc: ccirc,
	Cconint: Cconint,
	ccups: ccups,
	ccupssm: ccupssm,
	Cdot: Cdot,
	cdot: cdot,
	cedil: cedil$1,
	Cedilla: Cedilla,
	cemptyv: cemptyv,
	cent: cent$1,
	centerdot: centerdot,
	CenterDot: CenterDot,
	cfr: cfr,
	Cfr: Cfr,
	CHcy: CHcy,
	chcy: chcy,
	check: check,
	checkmark: checkmark,
	Chi: Chi,
	chi: chi,
	circ: circ,
	circeq: circeq,
	circlearrowleft: circlearrowleft,
	circlearrowright: circlearrowright,
	circledast: circledast,
	circledcirc: circledcirc,
	circleddash: circleddash,
	CircleDot: CircleDot,
	circledR: circledR,
	circledS: circledS,
	CircleMinus: CircleMinus,
	CirclePlus: CirclePlus,
	CircleTimes: CircleTimes,
	cir: cir,
	cirE: cirE,
	cire: cire,
	cirfnint: cirfnint,
	cirmid: cirmid,
	cirscir: cirscir,
	ClockwiseContourIntegral: ClockwiseContourIntegral,
	CloseCurlyDoubleQuote: CloseCurlyDoubleQuote,
	CloseCurlyQuote: CloseCurlyQuote,
	clubs: clubs,
	clubsuit: clubsuit,
	colon: colon$1,
	Colon: Colon,
	Colone: Colone,
	colone: colone,
	coloneq: coloneq,
	comma: comma$1,
	commat: commat,
	comp: comp,
	compfn: compfn,
	complement: complement,
	complexes: complexes,
	cong: cong,
	congdot: congdot,
	Congruent: Congruent,
	conint: conint,
	Conint: Conint,
	ContourIntegral: ContourIntegral,
	copf: copf,
	Copf: Copf,
	coprod: coprod,
	Coproduct: Coproduct,
	copy: copy$1,
	COPY: COPY$1,
	copysr: copysr,
	CounterClockwiseContourIntegral: CounterClockwiseContourIntegral,
	crarr: crarr,
	cross: cross,
	Cross: Cross,
	Cscr: Cscr,
	cscr: cscr,
	csub: csub,
	csube: csube,
	csup: csup,
	csupe: csupe,
	ctdot: ctdot,
	cudarrl: cudarrl,
	cudarrr: cudarrr,
	cuepr: cuepr,
	cuesc: cuesc,
	cularr: cularr,
	cularrp: cularrp,
	cupbrcap: cupbrcap,
	cupcap: cupcap,
	CupCap: CupCap,
	cup: cup,
	Cup: Cup,
	cupcup: cupcup,
	cupdot: cupdot,
	cupor: cupor,
	cups: cups,
	curarr: curarr,
	curarrm: curarrm,
	curlyeqprec: curlyeqprec,
	curlyeqsucc: curlyeqsucc,
	curlyvee: curlyvee,
	curlywedge: curlywedge,
	curren: curren$1,
	curvearrowleft: curvearrowleft,
	curvearrowright: curvearrowright,
	cuvee: cuvee,
	cuwed: cuwed,
	cwconint: cwconint,
	cwint: cwint,
	cylcty: cylcty,
	dagger: dagger,
	Dagger: Dagger,
	daleth: daleth,
	darr: darr,
	Darr: Darr,
	dArr: dArr,
	dash: dash,
	Dashv: Dashv,
	dashv: dashv,
	dbkarow: dbkarow,
	dblac: dblac,
	Dcaron: Dcaron,
	dcaron: dcaron,
	Dcy: Dcy,
	dcy: dcy,
	ddagger: ddagger,
	ddarr: ddarr,
	DD: DD,
	dd: dd,
	DDotrahd: DDotrahd,
	ddotseq: ddotseq,
	deg: deg$1,
	Del: Del,
	Delta: Delta,
	delta: delta,
	demptyv: demptyv,
	dfisht: dfisht,
	Dfr: Dfr,
	dfr: dfr,
	dHar: dHar,
	dharl: dharl,
	dharr: dharr,
	DiacriticalAcute: DiacriticalAcute,
	DiacriticalDot: DiacriticalDot,
	DiacriticalDoubleAcute: DiacriticalDoubleAcute,
	DiacriticalGrave: DiacriticalGrave,
	DiacriticalTilde: DiacriticalTilde,
	diam: diam,
	diamond: diamond,
	Diamond: Diamond,
	diamondsuit: diamondsuit,
	diams: diams,
	die: die,
	DifferentialD: DifferentialD,
	digamma: digamma,
	disin: disin,
	div: div,
	divide: divide$1,
	divideontimes: divideontimes,
	divonx: divonx,
	DJcy: DJcy,
	djcy: djcy,
	dlcorn: dlcorn,
	dlcrop: dlcrop,
	dollar: dollar,
	Dopf: Dopf,
	dopf: dopf,
	Dot: Dot,
	dot: dot,
	DotDot: DotDot,
	doteq: doteq,
	doteqdot: doteqdot,
	DotEqual: DotEqual,
	dotminus: dotminus,
	dotplus: dotplus,
	dotsquare: dotsquare,
	doublebarwedge: doublebarwedge,
	DoubleContourIntegral: DoubleContourIntegral,
	DoubleDot: DoubleDot,
	DoubleDownArrow: DoubleDownArrow,
	DoubleLeftArrow: DoubleLeftArrow,
	DoubleLeftRightArrow: DoubleLeftRightArrow,
	DoubleLeftTee: DoubleLeftTee,
	DoubleLongLeftArrow: DoubleLongLeftArrow,
	DoubleLongLeftRightArrow: DoubleLongLeftRightArrow,
	DoubleLongRightArrow: DoubleLongRightArrow,
	DoubleRightArrow: DoubleRightArrow,
	DoubleRightTee: DoubleRightTee,
	DoubleUpArrow: DoubleUpArrow,
	DoubleUpDownArrow: DoubleUpDownArrow,
	DoubleVerticalBar: DoubleVerticalBar,
	DownArrowBar: DownArrowBar,
	downarrow: downarrow,
	DownArrow: DownArrow,
	Downarrow: Downarrow,
	DownArrowUpArrow: DownArrowUpArrow,
	DownBreve: DownBreve,
	downdownarrows: downdownarrows,
	downharpoonleft: downharpoonleft,
	downharpoonright: downharpoonright,
	DownLeftRightVector: DownLeftRightVector,
	DownLeftTeeVector: DownLeftTeeVector,
	DownLeftVectorBar: DownLeftVectorBar,
	DownLeftVector: DownLeftVector,
	DownRightTeeVector: DownRightTeeVector,
	DownRightVectorBar: DownRightVectorBar,
	DownRightVector: DownRightVector,
	DownTeeArrow: DownTeeArrow,
	DownTee: DownTee,
	drbkarow: drbkarow,
	drcorn: drcorn,
	drcrop: drcrop,
	Dscr: Dscr,
	dscr: dscr,
	DScy: DScy,
	dscy: dscy,
	dsol: dsol,
	Dstrok: Dstrok,
	dstrok: dstrok,
	dtdot: dtdot,
	dtri: dtri,
	dtrif: dtrif,
	duarr: duarr,
	duhar: duhar,
	dwangle: dwangle,
	DZcy: DZcy,
	dzcy: dzcy,
	dzigrarr: dzigrarr,
	Eacute: Eacute$1,
	eacute: eacute$1,
	easter: easter,
	Ecaron: Ecaron,
	ecaron: ecaron,
	Ecirc: Ecirc$1,
	ecirc: ecirc$1,
	ecir: ecir,
	ecolon: ecolon,
	Ecy: Ecy,
	ecy: ecy,
	eDDot: eDDot,
	Edot: Edot,
	edot: edot,
	eDot: eDot,
	ee: ee,
	efDot: efDot,
	Efr: Efr,
	efr: efr,
	eg: eg,
	Egrave: Egrave$1,
	egrave: egrave$1,
	egs: egs,
	egsdot: egsdot,
	el: el,
	Element: Element,
	elinters: elinters,
	ell: ell,
	els: els,
	elsdot: elsdot,
	Emacr: Emacr,
	emacr: emacr,
	empty: empty$1,
	emptyset: emptyset,
	EmptySmallSquare: EmptySmallSquare,
	emptyv: emptyv,
	EmptyVerySmallSquare: EmptyVerySmallSquare,
	emsp13: emsp13,
	emsp14: emsp14,
	emsp: emsp,
	ENG: ENG,
	eng: eng,
	ensp: ensp,
	Eogon: Eogon,
	eogon: eogon,
	Eopf: Eopf,
	eopf: eopf,
	epar: epar,
	eparsl: eparsl,
	eplus: eplus,
	epsi: epsi,
	Epsilon: Epsilon,
	epsilon: epsilon,
	epsiv: epsiv,
	eqcirc: eqcirc,
	eqcolon: eqcolon,
	eqsim: eqsim,
	eqslantgtr: eqslantgtr,
	eqslantless: eqslantless,
	Equal: Equal,
	equals: equals,
	EqualTilde: EqualTilde,
	equest: equest,
	Equilibrium: Equilibrium,
	equiv: equiv,
	equivDD: equivDD,
	eqvparsl: eqvparsl,
	erarr: erarr,
	erDot: erDot,
	escr: escr,
	Escr: Escr,
	esdot: esdot,
	Esim: Esim,
	esim: esim,
	Eta: Eta,
	eta: eta,
	ETH: ETH$1,
	eth: eth$1,
	Euml: Euml$1,
	euml: euml$1,
	euro: euro,
	excl: excl,
	exist: exist,
	Exists: Exists,
	expectation: expectation,
	exponentiale: exponentiale,
	ExponentialE: ExponentialE,
	fallingdotseq: fallingdotseq,
	Fcy: Fcy,
	fcy: fcy,
	female: female,
	ffilig: ffilig,
	fflig: fflig,
	ffllig: ffllig,
	Ffr: Ffr,
	ffr: ffr,
	filig: filig,
	FilledSmallSquare: FilledSmallSquare,
	FilledVerySmallSquare: FilledVerySmallSquare,
	fjlig: fjlig,
	flat: flat,
	fllig: fllig,
	fltns: fltns,
	fnof: fnof,
	Fopf: Fopf,
	fopf: fopf,
	forall: forall,
	ForAll: ForAll,
	fork: fork,
	forkv: forkv,
	Fouriertrf: Fouriertrf,
	fpartint: fpartint,
	frac12: frac12$1,
	frac13: frac13,
	frac14: frac14$1,
	frac15: frac15,
	frac16: frac16,
	frac18: frac18,
	frac23: frac23,
	frac25: frac25,
	frac34: frac34$1,
	frac35: frac35,
	frac38: frac38,
	frac45: frac45,
	frac56: frac56,
	frac58: frac58,
	frac78: frac78,
	frasl: frasl,
	frown: frown,
	fscr: fscr,
	Fscr: Fscr,
	gacute: gacute,
	Gamma: Gamma,
	gamma: gamma,
	Gammad: Gammad,
	gammad: gammad,
	gap: gap,
	Gbreve: Gbreve,
	gbreve: gbreve,
	Gcedil: Gcedil,
	Gcirc: Gcirc,
	gcirc: gcirc,
	Gcy: Gcy,
	gcy: gcy,
	Gdot: Gdot,
	gdot: gdot,
	ge: ge,
	gE: gE,
	gEl: gEl,
	gel: gel,
	geq: geq,
	geqq: geqq,
	geqslant: geqslant,
	gescc: gescc,
	ges: ges,
	gesdot: gesdot,
	gesdoto: gesdoto,
	gesdotol: gesdotol,
	gesl: gesl,
	gesles: gesles,
	Gfr: Gfr,
	gfr: gfr,
	gg: gg,
	Gg: Gg,
	ggg: ggg,
	gimel: gimel,
	GJcy: GJcy,
	gjcy: gjcy,
	gla: gla,
	gl: gl,
	glE: glE,
	glj: glj,
	gnap: gnap,
	gnapprox: gnapprox,
	gne: gne,
	gnE: gnE,
	gneq: gneq,
	gneqq: gneqq,
	gnsim: gnsim,
	Gopf: Gopf,
	gopf: gopf,
	grave: grave,
	GreaterEqual: GreaterEqual,
	GreaterEqualLess: GreaterEqualLess,
	GreaterFullEqual: GreaterFullEqual,
	GreaterGreater: GreaterGreater,
	GreaterLess: GreaterLess,
	GreaterSlantEqual: GreaterSlantEqual,
	GreaterTilde: GreaterTilde,
	Gscr: Gscr,
	gscr: gscr,
	gsim: gsim,
	gsime: gsime,
	gsiml: gsiml,
	gtcc: gtcc,
	gtcir: gtcir,
	gt: gt$2,
	GT: GT$1,
	Gt: Gt,
	gtdot: gtdot,
	gtlPar: gtlPar,
	gtquest: gtquest,
	gtrapprox: gtrapprox,
	gtrarr: gtrarr,
	gtrdot: gtrdot,
	gtreqless: gtreqless,
	gtreqqless: gtreqqless,
	gtrless: gtrless,
	gtrsim: gtrsim,
	gvertneqq: gvertneqq,
	gvnE: gvnE,
	Hacek: Hacek,
	hairsp: hairsp,
	half: half,
	hamilt: hamilt,
	HARDcy: HARDcy,
	hardcy: hardcy,
	harrcir: harrcir,
	harr: harr,
	hArr: hArr,
	harrw: harrw,
	Hat: Hat,
	hbar: hbar,
	Hcirc: Hcirc,
	hcirc: hcirc,
	hearts: hearts,
	heartsuit: heartsuit,
	hellip: hellip,
	hercon: hercon,
	hfr: hfr,
	Hfr: Hfr,
	HilbertSpace: HilbertSpace,
	hksearow: hksearow,
	hkswarow: hkswarow,
	hoarr: hoarr,
	homtht: homtht,
	hookleftarrow: hookleftarrow,
	hookrightarrow: hookrightarrow,
	hopf: hopf,
	Hopf: Hopf,
	horbar: horbar,
	HorizontalLine: HorizontalLine,
	hscr: hscr,
	Hscr: Hscr,
	hslash: hslash,
	Hstrok: Hstrok,
	hstrok: hstrok,
	HumpDownHump: HumpDownHump,
	HumpEqual: HumpEqual,
	hybull: hybull,
	hyphen: hyphen,
	Iacute: Iacute$1,
	iacute: iacute$1,
	ic: ic,
	Icirc: Icirc$1,
	icirc: icirc$1,
	Icy: Icy,
	icy: icy,
	Idot: Idot,
	IEcy: IEcy,
	iecy: iecy,
	iexcl: iexcl$1,
	iff: iff,
	ifr: ifr,
	Ifr: Ifr,
	Igrave: Igrave$1,
	igrave: igrave$1,
	ii: ii,
	iiiint: iiiint,
	iiint: iiint,
	iinfin: iinfin,
	iiota: iiota,
	IJlig: IJlig,
	ijlig: ijlig,
	Imacr: Imacr,
	imacr: imacr,
	image: image$1,
	ImaginaryI: ImaginaryI,
	imagline: imagline,
	imagpart: imagpart,
	imath: imath,
	Im: Im,
	imof: imof,
	imped: imped,
	Implies: Implies,
	incare: incare,
	"in": "∈",
	infin: infin,
	infintie: infintie,
	inodot: inodot,
	intcal: intcal,
	int: int,
	Int: Int,
	integers: integers,
	Integral: Integral,
	intercal: intercal,
	Intersection: Intersection,
	intlarhk: intlarhk,
	intprod: intprod,
	InvisibleComma: InvisibleComma,
	InvisibleTimes: InvisibleTimes,
	IOcy: IOcy,
	iocy: iocy,
	Iogon: Iogon,
	iogon: iogon,
	Iopf: Iopf,
	iopf: iopf,
	Iota: Iota,
	iota: iota,
	iprod: iprod,
	iquest: iquest$1,
	iscr: iscr,
	Iscr: Iscr,
	isin: isin,
	isindot: isindot,
	isinE: isinE,
	isins: isins,
	isinsv: isinsv,
	isinv: isinv,
	it: it,
	Itilde: Itilde,
	itilde: itilde,
	Iukcy: Iukcy,
	iukcy: iukcy,
	Iuml: Iuml$1,
	iuml: iuml$1,
	Jcirc: Jcirc,
	jcirc: jcirc,
	Jcy: Jcy,
	jcy: jcy,
	Jfr: Jfr,
	jfr: jfr,
	jmath: jmath,
	Jopf: Jopf,
	jopf: jopf,
	Jscr: Jscr,
	jscr: jscr,
	Jsercy: Jsercy,
	jsercy: jsercy,
	Jukcy: Jukcy,
	jukcy: jukcy,
	Kappa: Kappa,
	kappa: kappa,
	kappav: kappav,
	Kcedil: Kcedil,
	kcedil: kcedil,
	Kcy: Kcy,
	kcy: kcy,
	Kfr: Kfr,
	kfr: kfr,
	kgreen: kgreen,
	KHcy: KHcy,
	khcy: khcy,
	KJcy: KJcy,
	kjcy: kjcy,
	Kopf: Kopf,
	kopf: kopf,
	Kscr: Kscr,
	kscr: kscr,
	lAarr: lAarr,
	Lacute: Lacute,
	lacute: lacute,
	laemptyv: laemptyv,
	lagran: lagran,
	Lambda: Lambda,
	lambda: lambda,
	lang: lang,
	Lang: Lang,
	langd: langd,
	langle: langle,
	lap: lap,
	Laplacetrf: Laplacetrf,
	laquo: laquo$1,
	larrb: larrb,
	larrbfs: larrbfs,
	larr: larr,
	Larr: Larr,
	lArr: lArr,
	larrfs: larrfs,
	larrhk: larrhk,
	larrlp: larrlp,
	larrpl: larrpl,
	larrsim: larrsim,
	larrtl: larrtl,
	latail: latail,
	lAtail: lAtail,
	lat: lat,
	late: late,
	lates: lates,
	lbarr: lbarr,
	lBarr: lBarr,
	lbbrk: lbbrk,
	lbrace: lbrace,
	lbrack: lbrack,
	lbrke: lbrke,
	lbrksld: lbrksld,
	lbrkslu: lbrkslu,
	Lcaron: Lcaron,
	lcaron: lcaron,
	Lcedil: Lcedil,
	lcedil: lcedil,
	lceil: lceil,
	lcub: lcub,
	Lcy: Lcy,
	lcy: lcy,
	ldca: ldca,
	ldquo: ldquo,
	ldquor: ldquor,
	ldrdhar: ldrdhar,
	ldrushar: ldrushar,
	ldsh: ldsh,
	le: le,
	lE: lE,
	LeftAngleBracket: LeftAngleBracket,
	LeftArrowBar: LeftArrowBar,
	leftarrow: leftarrow,
	LeftArrow: LeftArrow,
	Leftarrow: Leftarrow,
	LeftArrowRightArrow: LeftArrowRightArrow,
	leftarrowtail: leftarrowtail,
	LeftCeiling: LeftCeiling,
	LeftDoubleBracket: LeftDoubleBracket,
	LeftDownTeeVector: LeftDownTeeVector,
	LeftDownVectorBar: LeftDownVectorBar,
	LeftDownVector: LeftDownVector,
	LeftFloor: LeftFloor,
	leftharpoondown: leftharpoondown,
	leftharpoonup: leftharpoonup,
	leftleftarrows: leftleftarrows,
	leftrightarrow: leftrightarrow,
	LeftRightArrow: LeftRightArrow,
	Leftrightarrow: Leftrightarrow,
	leftrightarrows: leftrightarrows,
	leftrightharpoons: leftrightharpoons,
	leftrightsquigarrow: leftrightsquigarrow,
	LeftRightVector: LeftRightVector,
	LeftTeeArrow: LeftTeeArrow,
	LeftTee: LeftTee,
	LeftTeeVector: LeftTeeVector,
	leftthreetimes: leftthreetimes,
	LeftTriangleBar: LeftTriangleBar,
	LeftTriangle: LeftTriangle,
	LeftTriangleEqual: LeftTriangleEqual,
	LeftUpDownVector: LeftUpDownVector,
	LeftUpTeeVector: LeftUpTeeVector,
	LeftUpVectorBar: LeftUpVectorBar,
	LeftUpVector: LeftUpVector,
	LeftVectorBar: LeftVectorBar,
	LeftVector: LeftVector,
	lEg: lEg,
	leg: leg,
	leq: leq,
	leqq: leqq,
	leqslant: leqslant,
	lescc: lescc,
	les: les,
	lesdot: lesdot,
	lesdoto: lesdoto,
	lesdotor: lesdotor,
	lesg: lesg,
	lesges: lesges,
	lessapprox: lessapprox,
	lessdot: lessdot,
	lesseqgtr: lesseqgtr,
	lesseqqgtr: lesseqqgtr,
	LessEqualGreater: LessEqualGreater,
	LessFullEqual: LessFullEqual,
	LessGreater: LessGreater,
	lessgtr: lessgtr,
	LessLess: LessLess,
	lesssim: lesssim,
	LessSlantEqual: LessSlantEqual,
	LessTilde: LessTilde,
	lfisht: lfisht,
	lfloor: lfloor,
	Lfr: Lfr,
	lfr: lfr,
	lg: lg,
	lgE: lgE,
	lHar: lHar,
	lhard: lhard,
	lharu: lharu,
	lharul: lharul,
	lhblk: lhblk,
	LJcy: LJcy,
	ljcy: ljcy,
	llarr: llarr,
	ll: ll,
	Ll: Ll,
	llcorner: llcorner,
	Lleftarrow: Lleftarrow,
	llhard: llhard,
	lltri: lltri,
	Lmidot: Lmidot,
	lmidot: lmidot,
	lmoustache: lmoustache,
	lmoust: lmoust,
	lnap: lnap,
	lnapprox: lnapprox,
	lne: lne,
	lnE: lnE,
	lneq: lneq,
	lneqq: lneqq,
	lnsim: lnsim,
	loang: loang,
	loarr: loarr,
	lobrk: lobrk,
	longleftarrow: longleftarrow,
	LongLeftArrow: LongLeftArrow,
	Longleftarrow: Longleftarrow,
	longleftrightarrow: longleftrightarrow,
	LongLeftRightArrow: LongLeftRightArrow,
	Longleftrightarrow: Longleftrightarrow,
	longmapsto: longmapsto,
	longrightarrow: longrightarrow,
	LongRightArrow: LongRightArrow,
	Longrightarrow: Longrightarrow,
	looparrowleft: looparrowleft,
	looparrowright: looparrowright,
	lopar: lopar,
	Lopf: Lopf,
	lopf: lopf,
	loplus: loplus,
	lotimes: lotimes,
	lowast: lowast,
	lowbar: lowbar,
	LowerLeftArrow: LowerLeftArrow,
	LowerRightArrow: LowerRightArrow,
	loz: loz,
	lozenge: lozenge,
	lozf: lozf,
	lpar: lpar,
	lparlt: lparlt,
	lrarr: lrarr,
	lrcorner: lrcorner,
	lrhar: lrhar,
	lrhard: lrhard,
	lrm: lrm,
	lrtri: lrtri,
	lsaquo: lsaquo,
	lscr: lscr,
	Lscr: Lscr,
	lsh: lsh,
	Lsh: Lsh,
	lsim: lsim,
	lsime: lsime,
	lsimg: lsimg,
	lsqb: lsqb,
	lsquo: lsquo,
	lsquor: lsquor,
	Lstrok: Lstrok,
	lstrok: lstrok,
	ltcc: ltcc,
	ltcir: ltcir,
	lt: lt$2,
	LT: LT$1,
	Lt: Lt,
	ltdot: ltdot,
	lthree: lthree,
	ltimes: ltimes,
	ltlarr: ltlarr,
	ltquest: ltquest,
	ltri: ltri,
	ltrie: ltrie,
	ltrif: ltrif,
	ltrPar: ltrPar,
	lurdshar: lurdshar,
	luruhar: luruhar,
	lvertneqq: lvertneqq,
	lvnE: lvnE,
	macr: macr$1,
	male: male,
	malt: malt,
	maltese: maltese,
	"Map": "⤅",
	map: map,
	mapsto: mapsto,
	mapstodown: mapstodown,
	mapstoleft: mapstoleft,
	mapstoup: mapstoup,
	marker: marker$1,
	mcomma: mcomma,
	Mcy: Mcy,
	mcy: mcy,
	mdash: mdash,
	mDDot: mDDot,
	measuredangle: measuredangle,
	MediumSpace: MediumSpace,
	Mellintrf: Mellintrf,
	Mfr: Mfr,
	mfr: mfr,
	mho: mho,
	micro: micro$1,
	midast: midast,
	midcir: midcir,
	mid: mid,
	middot: middot$1,
	minusb: minusb,
	minus: minus,
	minusd: minusd,
	minusdu: minusdu,
	MinusPlus: MinusPlus,
	mlcp: mlcp,
	mldr: mldr,
	mnplus: mnplus,
	models: models,
	Mopf: Mopf,
	mopf: mopf,
	mp: mp,
	mscr: mscr,
	Mscr: Mscr,
	mstpos: mstpos,
	Mu: Mu$1,
	mu: mu$1,
	multimap: multimap,
	mumap: mumap,
	nabla: nabla,
	Nacute: Nacute,
	nacute: nacute,
	nang: nang,
	nap: nap,
	napE: napE,
	napid: napid,
	napos: napos,
	napprox: napprox,
	natural: natural,
	naturals: naturals,
	natur: natur,
	nbsp: nbsp$1,
	nbump: nbump,
	nbumpe: nbumpe,
	ncap: ncap,
	Ncaron: Ncaron,
	ncaron: ncaron,
	Ncedil: Ncedil,
	ncedil: ncedil,
	ncong: ncong,
	ncongdot: ncongdot,
	ncup: ncup,
	Ncy: Ncy,
	ncy: ncy,
	ndash: ndash,
	nearhk: nearhk,
	nearr: nearr,
	neArr: neArr,
	nearrow: nearrow,
	ne: ne,
	nedot: nedot,
	NegativeMediumSpace: NegativeMediumSpace,
	NegativeThickSpace: NegativeThickSpace,
	NegativeThinSpace: NegativeThinSpace,
	NegativeVeryThinSpace: NegativeVeryThinSpace,
	nequiv: nequiv,
	nesear: nesear,
	nesim: nesim,
	NestedGreaterGreater: NestedGreaterGreater,
	NestedLessLess: NestedLessLess,
	NewLine: NewLine,
	nexist: nexist,
	nexists: nexists,
	Nfr: Nfr,
	nfr: nfr,
	ngE: ngE,
	nge: nge,
	ngeq: ngeq,
	ngeqq: ngeqq,
	ngeqslant: ngeqslant,
	nges: nges,
	nGg: nGg,
	ngsim: ngsim,
	nGt: nGt,
	ngt: ngt,
	ngtr: ngtr,
	nGtv: nGtv,
	nharr: nharr,
	nhArr: nhArr,
	nhpar: nhpar,
	ni: ni,
	nis: nis,
	nisd: nisd,
	niv: niv,
	NJcy: NJcy,
	njcy: njcy,
	nlarr: nlarr,
	nlArr: nlArr,
	nldr: nldr,
	nlE: nlE,
	nle: nle,
	nleftarrow: nleftarrow,
	nLeftarrow: nLeftarrow,
	nleftrightarrow: nleftrightarrow,
	nLeftrightarrow: nLeftrightarrow,
	nleq: nleq,
	nleqq: nleqq,
	nleqslant: nleqslant,
	nles: nles,
	nless: nless,
	nLl: nLl,
	nlsim: nlsim,
	nLt: nLt,
	nlt: nlt,
	nltri: nltri,
	nltrie: nltrie,
	nLtv: nLtv,
	nmid: nmid,
	NoBreak: NoBreak,
	NonBreakingSpace: NonBreakingSpace,
	nopf: nopf,
	Nopf: Nopf,
	Not: Not,
	not: not$1,
	NotCongruent: NotCongruent,
	NotCupCap: NotCupCap,
	NotDoubleVerticalBar: NotDoubleVerticalBar,
	NotElement: NotElement,
	NotEqual: NotEqual,
	NotEqualTilde: NotEqualTilde,
	NotExists: NotExists,
	NotGreater: NotGreater,
	NotGreaterEqual: NotGreaterEqual,
	NotGreaterFullEqual: NotGreaterFullEqual,
	NotGreaterGreater: NotGreaterGreater,
	NotGreaterLess: NotGreaterLess,
	NotGreaterSlantEqual: NotGreaterSlantEqual,
	NotGreaterTilde: NotGreaterTilde,
	NotHumpDownHump: NotHumpDownHump,
	NotHumpEqual: NotHumpEqual,
	notin: notin,
	notindot: notindot,
	notinE: notinE,
	notinva: notinva,
	notinvb: notinvb,
	notinvc: notinvc,
	NotLeftTriangleBar: NotLeftTriangleBar,
	NotLeftTriangle: NotLeftTriangle,
	NotLeftTriangleEqual: NotLeftTriangleEqual,
	NotLess: NotLess,
	NotLessEqual: NotLessEqual,
	NotLessGreater: NotLessGreater,
	NotLessLess: NotLessLess,
	NotLessSlantEqual: NotLessSlantEqual,
	NotLessTilde: NotLessTilde,
	NotNestedGreaterGreater: NotNestedGreaterGreater,
	NotNestedLessLess: NotNestedLessLess,
	notni: notni,
	notniva: notniva,
	notnivb: notnivb,
	notnivc: notnivc,
	NotPrecedes: NotPrecedes,
	NotPrecedesEqual: NotPrecedesEqual,
	NotPrecedesSlantEqual: NotPrecedesSlantEqual,
	NotReverseElement: NotReverseElement,
	NotRightTriangleBar: NotRightTriangleBar,
	NotRightTriangle: NotRightTriangle,
	NotRightTriangleEqual: NotRightTriangleEqual,
	NotSquareSubset: NotSquareSubset,
	NotSquareSubsetEqual: NotSquareSubsetEqual,
	NotSquareSuperset: NotSquareSuperset,
	NotSquareSupersetEqual: NotSquareSupersetEqual,
	NotSubset: NotSubset,
	NotSubsetEqual: NotSubsetEqual,
	NotSucceeds: NotSucceeds,
	NotSucceedsEqual: NotSucceedsEqual,
	NotSucceedsSlantEqual: NotSucceedsSlantEqual,
	NotSucceedsTilde: NotSucceedsTilde,
	NotSuperset: NotSuperset,
	NotSupersetEqual: NotSupersetEqual,
	NotTilde: NotTilde,
	NotTildeEqual: NotTildeEqual,
	NotTildeFullEqual: NotTildeFullEqual,
	NotTildeTilde: NotTildeTilde,
	NotVerticalBar: NotVerticalBar,
	nparallel: nparallel,
	npar: npar,
	nparsl: nparsl,
	npart: npart,
	npolint: npolint,
	npr: npr,
	nprcue: nprcue,
	nprec: nprec,
	npreceq: npreceq,
	npre: npre,
	nrarrc: nrarrc,
	nrarr: nrarr,
	nrArr: nrArr,
	nrarrw: nrarrw,
	nrightarrow: nrightarrow,
	nRightarrow: nRightarrow,
	nrtri: nrtri,
	nrtrie: nrtrie,
	nsc: nsc,
	nsccue: nsccue,
	nsce: nsce,
	Nscr: Nscr,
	nscr: nscr,
	nshortmid: nshortmid,
	nshortparallel: nshortparallel,
	nsim: nsim,
	nsime: nsime,
	nsimeq: nsimeq,
	nsmid: nsmid,
	nspar: nspar,
	nsqsube: nsqsube,
	nsqsupe: nsqsupe,
	nsub: nsub,
	nsubE: nsubE,
	nsube: nsube,
	nsubset: nsubset,
	nsubseteq: nsubseteq,
	nsubseteqq: nsubseteqq,
	nsucc: nsucc,
	nsucceq: nsucceq,
	nsup: nsup,
	nsupE: nsupE,
	nsupe: nsupe,
	nsupset: nsupset,
	nsupseteq: nsupseteq,
	nsupseteqq: nsupseteqq,
	ntgl: ntgl,
	Ntilde: Ntilde$1,
	ntilde: ntilde$1,
	ntlg: ntlg,
	ntriangleleft: ntriangleleft,
	ntrianglelefteq: ntrianglelefteq,
	ntriangleright: ntriangleright,
	ntrianglerighteq: ntrianglerighteq,
	Nu: Nu$1,
	nu: nu$1,
	num: num,
	numero: numero,
	numsp: numsp,
	nvap: nvap,
	nvdash: nvdash,
	nvDash: nvDash,
	nVdash: nVdash,
	nVDash: nVDash,
	nvge: nvge,
	nvgt: nvgt,
	nvHarr: nvHarr,
	nvinfin: nvinfin,
	nvlArr: nvlArr,
	nvle: nvle,
	nvlt: nvlt,
	nvltrie: nvltrie,
	nvrArr: nvrArr,
	nvrtrie: nvrtrie,
	nvsim: nvsim,
	nwarhk: nwarhk,
	nwarr: nwarr,
	nwArr: nwArr,
	nwarrow: nwarrow,
	nwnear: nwnear,
	Oacute: Oacute$1,
	oacute: oacute$1,
	oast: oast,
	Ocirc: Ocirc$1,
	ocirc: ocirc$1,
	ocir: ocir,
	Ocy: Ocy,
	ocy: ocy,
	odash: odash,
	Odblac: Odblac,
	odblac: odblac,
	odiv: odiv,
	odot: odot,
	odsold: odsold,
	OElig: OElig,
	oelig: oelig,
	ofcir: ofcir,
	Ofr: Ofr,
	ofr: ofr,
	ogon: ogon,
	Ograve: Ograve$1,
	ograve: ograve$1,
	ogt: ogt,
	ohbar: ohbar,
	ohm: ohm,
	oint: oint,
	olarr: olarr,
	olcir: olcir,
	olcross: olcross,
	oline: oline,
	olt: olt,
	Omacr: Omacr,
	omacr: omacr,
	Omega: Omega,
	omega: omega,
	Omicron: Omicron,
	omicron: omicron,
	omid: omid,
	ominus: ominus,
	Oopf: Oopf,
	oopf: oopf,
	opar: opar,
	OpenCurlyDoubleQuote: OpenCurlyDoubleQuote,
	OpenCurlyQuote: OpenCurlyQuote,
	operp: operp,
	oplus: oplus,
	orarr: orarr,
	Or: Or,
	or: or,
	ord: ord,
	order: order,
	orderof: orderof,
	ordf: ordf$1,
	ordm: ordm$1,
	origof: origof,
	oror: oror,
	orslope: orslope,
	orv: orv,
	oS: oS,
	Oscr: Oscr,
	oscr: oscr,
	Oslash: Oslash$1,
	oslash: oslash$1,
	osol: osol,
	Otilde: Otilde$1,
	otilde: otilde$1,
	otimesas: otimesas,
	Otimes: Otimes,
	otimes: otimes,
	Ouml: Ouml$1,
	ouml: ouml$1,
	ovbar: ovbar,
	OverBar: OverBar,
	OverBrace: OverBrace,
	OverBracket: OverBracket,
	OverParenthesis: OverParenthesis,
	para: para$1,
	parallel: parallel,
	par: par,
	parsim: parsim,
	parsl: parsl,
	part: part,
	PartialD: PartialD,
	Pcy: Pcy,
	pcy: pcy,
	percnt: percnt,
	period: period,
	permil: permil,
	perp: perp,
	pertenk: pertenk,
	Pfr: Pfr,
	pfr: pfr,
	Phi: Phi,
	phi: phi,
	phiv: phiv,
	phmmat: phmmat,
	phone: phone,
	Pi: Pi,
	pi: pi,
	pitchfork: pitchfork,
	piv: piv,
	planck: planck,
	planckh: planckh,
	plankv: plankv,
	plusacir: plusacir,
	plusb: plusb,
	pluscir: pluscir,
	plus: plus,
	plusdo: plusdo,
	plusdu: plusdu,
	pluse: pluse,
	PlusMinus: PlusMinus,
	plusmn: plusmn$1,
	plussim: plussim,
	plustwo: plustwo,
	pm: pm,
	Poincareplane: Poincareplane,
	pointint: pointint,
	popf: popf,
	Popf: Popf,
	pound: pound$1,
	prap: prap,
	Pr: Pr,
	pr: pr,
	prcue: prcue,
	precapprox: precapprox,
	prec: prec,
	preccurlyeq: preccurlyeq,
	Precedes: Precedes,
	PrecedesEqual: PrecedesEqual,
	PrecedesSlantEqual: PrecedesSlantEqual,
	PrecedesTilde: PrecedesTilde,
	preceq: preceq,
	precnapprox: precnapprox,
	precneqq: precneqq,
	precnsim: precnsim,
	pre: pre,
	prE: prE,
	precsim: precsim,
	prime: prime,
	Prime: Prime,
	primes: primes,
	prnap: prnap,
	prnE: prnE,
	prnsim: prnsim,
	prod: prod,
	Product: Product,
	profalar: profalar,
	profline: profline,
	profsurf: profsurf,
	prop: prop,
	Proportional: Proportional,
	Proportion: Proportion,
	propto: propto,
	prsim: prsim,
	prurel: prurel,
	Pscr: Pscr,
	pscr: pscr,
	Psi: Psi,
	psi: psi,
	puncsp: puncsp,
	Qfr: Qfr,
	qfr: qfr,
	qint: qint,
	qopf: qopf,
	Qopf: Qopf,
	qprime: qprime,
	Qscr: Qscr,
	qscr: qscr,
	quaternions: quaternions,
	quatint: quatint,
	quest: quest,
	questeq: questeq,
	quot: quot$2,
	QUOT: QUOT$1,
	rAarr: rAarr,
	race: race,
	Racute: Racute,
	racute: racute,
	radic: radic,
	raemptyv: raemptyv,
	rang: rang,
	Rang: Rang,
	rangd: rangd,
	range: range,
	rangle: rangle,
	raquo: raquo$1,
	rarrap: rarrap,
	rarrb: rarrb,
	rarrbfs: rarrbfs,
	rarrc: rarrc,
	rarr: rarr,
	Rarr: Rarr,
	rArr: rArr,
	rarrfs: rarrfs,
	rarrhk: rarrhk,
	rarrlp: rarrlp,
	rarrpl: rarrpl,
	rarrsim: rarrsim,
	Rarrtl: Rarrtl,
	rarrtl: rarrtl,
	rarrw: rarrw,
	ratail: ratail,
	rAtail: rAtail,
	ratio: ratio,
	rationals: rationals,
	rbarr: rbarr,
	rBarr: rBarr,
	RBarr: RBarr,
	rbbrk: rbbrk,
	rbrace: rbrace,
	rbrack: rbrack,
	rbrke: rbrke,
	rbrksld: rbrksld,
	rbrkslu: rbrkslu,
	Rcaron: Rcaron,
	rcaron: rcaron,
	Rcedil: Rcedil,
	rcedil: rcedil,
	rceil: rceil,
	rcub: rcub,
	Rcy: Rcy,
	rcy: rcy,
	rdca: rdca,
	rdldhar: rdldhar,
	rdquo: rdquo,
	rdquor: rdquor,
	rdsh: rdsh,
	real: real,
	realine: realine,
	realpart: realpart,
	reals: reals,
	Re: Re,
	rect: rect,
	reg: reg$1,
	REG: REG$1,
	ReverseElement: ReverseElement,
	ReverseEquilibrium: ReverseEquilibrium,
	ReverseUpEquilibrium: ReverseUpEquilibrium,
	rfisht: rfisht,
	rfloor: rfloor,
	rfr: rfr,
	Rfr: Rfr,
	rHar: rHar,
	rhard: rhard,
	rharu: rharu,
	rharul: rharul,
	Rho: Rho,
	rho: rho,
	rhov: rhov,
	RightAngleBracket: RightAngleBracket,
	RightArrowBar: RightArrowBar,
	rightarrow: rightarrow,
	RightArrow: RightArrow,
	Rightarrow: Rightarrow,
	RightArrowLeftArrow: RightArrowLeftArrow,
	rightarrowtail: rightarrowtail,
	RightCeiling: RightCeiling,
	RightDoubleBracket: RightDoubleBracket,
	RightDownTeeVector: RightDownTeeVector,
	RightDownVectorBar: RightDownVectorBar,
	RightDownVector: RightDownVector,
	RightFloor: RightFloor,
	rightharpoondown: rightharpoondown,
	rightharpoonup: rightharpoonup,
	rightleftarrows: rightleftarrows,
	rightleftharpoons: rightleftharpoons,
	rightrightarrows: rightrightarrows,
	rightsquigarrow: rightsquigarrow,
	RightTeeArrow: RightTeeArrow,
	RightTee: RightTee,
	RightTeeVector: RightTeeVector,
	rightthreetimes: rightthreetimes,
	RightTriangleBar: RightTriangleBar,
	RightTriangle: RightTriangle,
	RightTriangleEqual: RightTriangleEqual,
	RightUpDownVector: RightUpDownVector,
	RightUpTeeVector: RightUpTeeVector,
	RightUpVectorBar: RightUpVectorBar,
	RightUpVector: RightUpVector,
	RightVectorBar: RightVectorBar,
	RightVector: RightVector,
	ring: ring,
	risingdotseq: risingdotseq,
	rlarr: rlarr,
	rlhar: rlhar,
	rlm: rlm,
	rmoustache: rmoustache,
	rmoust: rmoust,
	rnmid: rnmid,
	roang: roang,
	roarr: roarr,
	robrk: robrk,
	ropar: ropar,
	ropf: ropf,
	Ropf: Ropf,
	roplus: roplus,
	rotimes: rotimes,
	RoundImplies: RoundImplies,
	rpar: rpar,
	rpargt: rpargt,
	rppolint: rppolint,
	rrarr: rrarr,
	Rrightarrow: Rrightarrow,
	rsaquo: rsaquo,
	rscr: rscr,
	Rscr: Rscr,
	rsh: rsh,
	Rsh: Rsh,
	rsqb: rsqb,
	rsquo: rsquo,
	rsquor: rsquor,
	rthree: rthree,
	rtimes: rtimes,
	rtri: rtri,
	rtrie: rtrie,
	rtrif: rtrif,
	rtriltri: rtriltri,
	RuleDelayed: RuleDelayed,
	ruluhar: ruluhar,
	rx: rx,
	Sacute: Sacute,
	sacute: sacute,
	sbquo: sbquo,
	scap: scap,
	Scaron: Scaron,
	scaron: scaron,
	Sc: Sc,
	sc: sc,
	sccue: sccue,
	sce: sce,
	scE: scE,
	Scedil: Scedil,
	scedil: scedil,
	Scirc: Scirc,
	scirc: scirc,
	scnap: scnap,
	scnE: scnE,
	scnsim: scnsim,
	scpolint: scpolint,
	scsim: scsim,
	Scy: Scy,
	scy: scy,
	sdotb: sdotb,
	sdot: sdot,
	sdote: sdote,
	searhk: searhk,
	searr: searr,
	seArr: seArr,
	searrow: searrow,
	sect: sect$1,
	semi: semi,
	seswar: seswar,
	setminus: setminus,
	setmn: setmn,
	sext: sext,
	Sfr: Sfr,
	sfr: sfr,
	sfrown: sfrown,
	sharp: sharp,
	SHCHcy: SHCHcy,
	shchcy: shchcy,
	SHcy: SHcy,
	shcy: shcy,
	ShortDownArrow: ShortDownArrow,
	ShortLeftArrow: ShortLeftArrow,
	shortmid: shortmid,
	shortparallel: shortparallel,
	ShortRightArrow: ShortRightArrow,
	ShortUpArrow: ShortUpArrow,
	shy: shy$1,
	Sigma: Sigma,
	sigma: sigma,
	sigmaf: sigmaf,
	sigmav: sigmav,
	sim: sim,
	simdot: simdot,
	sime: sime,
	simeq: simeq,
	simg: simg,
	simgE: simgE,
	siml: siml,
	simlE: simlE,
	simne: simne,
	simplus: simplus,
	simrarr: simrarr,
	slarr: slarr,
	SmallCircle: SmallCircle,
	smallsetminus: smallsetminus,
	smashp: smashp,
	smeparsl: smeparsl,
	smid: smid,
	smile: smile,
	smt: smt,
	smte: smte,
	smtes: smtes,
	SOFTcy: SOFTcy,
	softcy: softcy,
	solbar: solbar,
	solb: solb,
	sol: sol,
	Sopf: Sopf,
	sopf: sopf,
	spades: spades,
	spadesuit: spadesuit,
	spar: spar,
	sqcap: sqcap,
	sqcaps: sqcaps,
	sqcup: sqcup,
	sqcups: sqcups,
	Sqrt: Sqrt,
	sqsub: sqsub,
	sqsube: sqsube,
	sqsubset: sqsubset,
	sqsubseteq: sqsubseteq,
	sqsup: sqsup,
	sqsupe: sqsupe,
	sqsupset: sqsupset,
	sqsupseteq: sqsupseteq,
	square: square,
	Square: Square,
	SquareIntersection: SquareIntersection,
	SquareSubset: SquareSubset,
	SquareSubsetEqual: SquareSubsetEqual,
	SquareSuperset: SquareSuperset,
	SquareSupersetEqual: SquareSupersetEqual,
	SquareUnion: SquareUnion,
	squarf: squarf,
	squ: squ,
	squf: squf,
	srarr: srarr,
	Sscr: Sscr,
	sscr: sscr,
	ssetmn: ssetmn,
	ssmile: ssmile,
	sstarf: sstarf,
	Star: Star,
	star: star,
	starf: starf,
	straightepsilon: straightepsilon,
	straightphi: straightphi,
	strns: strns,
	sub: sub,
	Sub: Sub,
	subdot: subdot,
	subE: subE,
	sube: sube,
	subedot: subedot,
	submult: submult,
	subnE: subnE,
	subne: subne,
	subplus: subplus,
	subrarr: subrarr,
	subset: subset,
	Subset: Subset,
	subseteq: subseteq,
	subseteqq: subseteqq,
	SubsetEqual: SubsetEqual,
	subsetneq: subsetneq,
	subsetneqq: subsetneqq,
	subsim: subsim,
	subsub: subsub,
	subsup: subsup,
	succapprox: succapprox,
	succ: succ,
	succcurlyeq: succcurlyeq,
	Succeeds: Succeeds,
	SucceedsEqual: SucceedsEqual,
	SucceedsSlantEqual: SucceedsSlantEqual,
	SucceedsTilde: SucceedsTilde,
	succeq: succeq,
	succnapprox: succnapprox,
	succneqq: succneqq,
	succnsim: succnsim,
	succsim: succsim,
	SuchThat: SuchThat,
	sum: sum,
	Sum: Sum,
	sung: sung,
	sup1: sup1$1,
	sup2: sup2$1,
	sup3: sup3$1,
	sup: sup,
	Sup: Sup,
	supdot: supdot,
	supdsub: supdsub,
	supE: supE,
	supe: supe,
	supedot: supedot,
	Superset: Superset,
	SupersetEqual: SupersetEqual,
	suphsol: suphsol,
	suphsub: suphsub,
	suplarr: suplarr,
	supmult: supmult,
	supnE: supnE,
	supne: supne,
	supplus: supplus,
	supset: supset,
	Supset: Supset,
	supseteq: supseteq,
	supseteqq: supseteqq,
	supsetneq: supsetneq,
	supsetneqq: supsetneqq,
	supsim: supsim,
	supsub: supsub,
	supsup: supsup,
	swarhk: swarhk,
	swarr: swarr,
	swArr: swArr,
	swarrow: swarrow,
	swnwar: swnwar,
	szlig: szlig$1,
	Tab: Tab,
	target: target,
	Tau: Tau,
	tau: tau,
	tbrk: tbrk,
	Tcaron: Tcaron,
	tcaron: tcaron,
	Tcedil: Tcedil,
	tcedil: tcedil,
	Tcy: Tcy,
	tcy: tcy,
	tdot: tdot,
	telrec: telrec,
	Tfr: Tfr,
	tfr: tfr,
	there4: there4,
	therefore: therefore,
	Therefore: Therefore,
	Theta: Theta,
	theta: theta,
	thetasym: thetasym,
	thetav: thetav,
	thickapprox: thickapprox,
	thicksim: thicksim,
	ThickSpace: ThickSpace,
	ThinSpace: ThinSpace,
	thinsp: thinsp,
	thkap: thkap,
	thksim: thksim,
	THORN: THORN$1,
	thorn: thorn$1,
	tilde: tilde,
	Tilde: Tilde,
	TildeEqual: TildeEqual,
	TildeFullEqual: TildeFullEqual,
	TildeTilde: TildeTilde,
	timesbar: timesbar,
	timesb: timesb,
	times: times$1,
	timesd: timesd,
	tint: tint,
	toea: toea,
	topbot: topbot,
	topcir: topcir,
	top: top,
	Topf: Topf,
	topf: topf,
	topfork: topfork,
	tosa: tosa,
	tprime: tprime,
	trade: trade,
	TRADE: TRADE,
	triangle: triangle,
	triangledown: triangledown,
	triangleleft: triangleleft,
	trianglelefteq: trianglelefteq,
	triangleq: triangleq,
	triangleright: triangleright,
	trianglerighteq: trianglerighteq,
	tridot: tridot,
	trie: trie,
	triminus: triminus,
	TripleDot: TripleDot,
	triplus: triplus,
	trisb: trisb,
	tritime: tritime,
	trpezium: trpezium,
	Tscr: Tscr,
	tscr: tscr,
	TScy: TScy,
	tscy: tscy,
	TSHcy: TSHcy,
	tshcy: tshcy,
	Tstrok: Tstrok,
	tstrok: tstrok,
	twixt: twixt,
	twoheadleftarrow: twoheadleftarrow,
	twoheadrightarrow: twoheadrightarrow,
	Uacute: Uacute$1,
	uacute: uacute$1,
	uarr: uarr,
	Uarr: Uarr,
	uArr: uArr,
	Uarrocir: Uarrocir,
	Ubrcy: Ubrcy,
	ubrcy: ubrcy,
	Ubreve: Ubreve,
	ubreve: ubreve,
	Ucirc: Ucirc$1,
	ucirc: ucirc$1,
	Ucy: Ucy,
	ucy: ucy,
	udarr: udarr,
	Udblac: Udblac,
	udblac: udblac,
	udhar: udhar,
	ufisht: ufisht,
	Ufr: Ufr,
	ufr: ufr,
	Ugrave: Ugrave$1,
	ugrave: ugrave$1,
	uHar: uHar,
	uharl: uharl,
	uharr: uharr,
	uhblk: uhblk,
	ulcorn: ulcorn,
	ulcorner: ulcorner,
	ulcrop: ulcrop,
	ultri: ultri,
	Umacr: Umacr,
	umacr: umacr,
	uml: uml$1,
	UnderBar: UnderBar,
	UnderBrace: UnderBrace,
	UnderBracket: UnderBracket,
	UnderParenthesis: UnderParenthesis,
	Union: Union,
	UnionPlus: UnionPlus,
	Uogon: Uogon,
	uogon: uogon,
	Uopf: Uopf,
	uopf: uopf,
	UpArrowBar: UpArrowBar,
	uparrow: uparrow,
	UpArrow: UpArrow,
	Uparrow: Uparrow,
	UpArrowDownArrow: UpArrowDownArrow,
	updownarrow: updownarrow,
	UpDownArrow: UpDownArrow,
	Updownarrow: Updownarrow,
	UpEquilibrium: UpEquilibrium,
	upharpoonleft: upharpoonleft,
	upharpoonright: upharpoonright,
	uplus: uplus,
	UpperLeftArrow: UpperLeftArrow,
	UpperRightArrow: UpperRightArrow,
	upsi: upsi,
	Upsi: Upsi,
	upsih: upsih,
	Upsilon: Upsilon,
	upsilon: upsilon,
	UpTeeArrow: UpTeeArrow,
	UpTee: UpTee,
	upuparrows: upuparrows,
	urcorn: urcorn,
	urcorner: urcorner,
	urcrop: urcrop,
	Uring: Uring,
	uring: uring,
	urtri: urtri,
	Uscr: Uscr,
	uscr: uscr,
	utdot: utdot,
	Utilde: Utilde,
	utilde: utilde,
	utri: utri,
	utrif: utrif,
	uuarr: uuarr,
	Uuml: Uuml$1,
	uuml: uuml$1,
	uwangle: uwangle,
	vangrt: vangrt,
	varepsilon: varepsilon,
	varkappa: varkappa,
	varnothing: varnothing,
	varphi: varphi,
	varpi: varpi,
	varpropto: varpropto,
	varr: varr,
	vArr: vArr,
	varrho: varrho,
	varsigma: varsigma,
	varsubsetneq: varsubsetneq,
	varsubsetneqq: varsubsetneqq,
	varsupsetneq: varsupsetneq,
	varsupsetneqq: varsupsetneqq,
	vartheta: vartheta,
	vartriangleleft: vartriangleleft,
	vartriangleright: vartriangleright,
	vBar: vBar,
	Vbar: Vbar,
	vBarv: vBarv,
	Vcy: Vcy,
	vcy: vcy,
	vdash: vdash,
	vDash: vDash,
	Vdash: Vdash,
	VDash: VDash,
	Vdashl: Vdashl,
	veebar: veebar,
	vee: vee,
	Vee: Vee,
	veeeq: veeeq,
	vellip: vellip,
	verbar: verbar,
	Verbar: Verbar,
	vert: vert,
	Vert: Vert,
	VerticalBar: VerticalBar,
	VerticalLine: VerticalLine,
	VerticalSeparator: VerticalSeparator,
	VerticalTilde: VerticalTilde,
	VeryThinSpace: VeryThinSpace,
	Vfr: Vfr,
	vfr: vfr,
	vltri: vltri,
	vnsub: vnsub,
	vnsup: vnsup,
	Vopf: Vopf,
	vopf: vopf,
	vprop: vprop,
	vrtri: vrtri,
	Vscr: Vscr,
	vscr: vscr,
	vsubnE: vsubnE,
	vsubne: vsubne,
	vsupnE: vsupnE,
	vsupne: vsupne,
	Vvdash: Vvdash,
	vzigzag: vzigzag,
	Wcirc: Wcirc,
	wcirc: wcirc,
	wedbar: wedbar,
	wedge: wedge,
	Wedge: Wedge,
	wedgeq: wedgeq,
	weierp: weierp,
	Wfr: Wfr,
	wfr: wfr,
	Wopf: Wopf,
	wopf: wopf,
	wp: wp,
	wr: wr,
	wreath: wreath,
	Wscr: Wscr,
	wscr: wscr,
	xcap: xcap,
	xcirc: xcirc,
	xcup: xcup,
	xdtri: xdtri,
	Xfr: Xfr,
	xfr: xfr,
	xharr: xharr,
	xhArr: xhArr,
	Xi: Xi,
	xi: xi,
	xlarr: xlarr,
	xlArr: xlArr,
	xmap: xmap,
	xnis: xnis,
	xodot: xodot,
	Xopf: Xopf,
	xopf: xopf,
	xoplus: xoplus,
	xotime: xotime,
	xrarr: xrarr,
	xrArr: xrArr,
	Xscr: Xscr,
	xscr: xscr,
	xsqcup: xsqcup,
	xuplus: xuplus,
	xutri: xutri,
	xvee: xvee,
	xwedge: xwedge,
	Yacute: Yacute$1,
	yacute: yacute$1,
	YAcy: YAcy,
	yacy: yacy,
	Ycirc: Ycirc,
	ycirc: ycirc,
	Ycy: Ycy,
	ycy: ycy,
	yen: yen$1,
	Yfr: Yfr,
	yfr: yfr,
	YIcy: YIcy,
	yicy: yicy,
	Yopf: Yopf,
	yopf: yopf,
	Yscr: Yscr,
	yscr: yscr,
	YUcy: YUcy,
	yucy: yucy,
	yuml: yuml$1,
	Yuml: Yuml,
	Zacute: Zacute,
	zacute: zacute,
	Zcaron: Zcaron,
	zcaron: zcaron,
	Zcy: Zcy,
	zcy: zcy,
	Zdot: Zdot,
	zdot: zdot,
	zeetrf: zeetrf,
	ZeroWidthSpace: ZeroWidthSpace,
	Zeta: Zeta,
	zeta: zeta,
	zfr: zfr,
	Zfr: Zfr,
	ZHcy: ZHcy,
	zhcy: zhcy,
	zigrarr: zigrarr,
	zopf: zopf,
	Zopf: Zopf,
	Zscr: Zscr,
	zscr: zscr,
	zwj: zwj,
	zwnj: zwnj
};

var Aacute = "Á";
var aacute = "á";
var Acirc = "Â";
var acirc = "â";
var acute = "´";
var AElig = "Æ";
var aelig = "æ";
var Agrave = "À";
var agrave = "à";
var amp$1 = "&";
var AMP = "&";
var Aring = "Å";
var aring = "å";
var Atilde = "Ã";
var atilde = "ã";
var Auml = "Ä";
var auml = "ä";
var brvbar = "¦";
var Ccedil = "Ç";
var ccedil = "ç";
var cedil = "¸";
var cent = "¢";
var copy = "©";
var COPY = "©";
var curren = "¤";
var deg = "°";
var divide = "÷";
var Eacute = "É";
var eacute = "é";
var Ecirc = "Ê";
var ecirc = "ê";
var Egrave = "È";
var egrave = "è";
var ETH = "Ð";
var eth = "ð";
var Euml = "Ë";
var euml = "ë";
var frac12 = "½";
var frac14 = "¼";
var frac34 = "¾";
var gt$1 = ">";
var GT = ">";
var Iacute = "Í";
var iacute = "í";
var Icirc = "Î";
var icirc = "î";
var iexcl = "¡";
var Igrave = "Ì";
var igrave = "ì";
var iquest = "¿";
var Iuml = "Ï";
var iuml = "ï";
var laquo = "«";
var lt$1 = "<";
var LT = "<";
var macr = "¯";
var micro = "µ";
var middot = "·";
var nbsp = " ";
var not = "¬";
var Ntilde = "Ñ";
var ntilde = "ñ";
var Oacute = "Ó";
var oacute = "ó";
var Ocirc = "Ô";
var ocirc = "ô";
var Ograve = "Ò";
var ograve = "ò";
var ordf = "ª";
var ordm = "º";
var Oslash = "Ø";
var oslash = "ø";
var Otilde = "Õ";
var otilde = "õ";
var Ouml = "Ö";
var ouml = "ö";
var para = "¶";
var plusmn = "±";
var pound = "£";
var quot$1 = "\"";
var QUOT = "\"";
var raquo = "»";
var reg = "®";
var REG = "®";
var sect = "§";
var shy = "­";
var sup1 = "¹";
var sup2 = "²";
var sup3 = "³";
var szlig = "ß";
var THORN = "Þ";
var thorn = "þ";
var times = "×";
var Uacute = "Ú";
var uacute = "ú";
var Ucirc = "Û";
var ucirc = "û";
var Ugrave = "Ù";
var ugrave = "ù";
var uml = "¨";
var Uuml = "Ü";
var uuml = "ü";
var Yacute = "Ý";
var yacute = "ý";
var yen = "¥";
var yuml = "ÿ";
var require$$1$2 = {
	Aacute: Aacute,
	aacute: aacute,
	Acirc: Acirc,
	acirc: acirc,
	acute: acute,
	AElig: AElig,
	aelig: aelig,
	Agrave: Agrave,
	agrave: agrave,
	amp: amp$1,
	AMP: AMP,
	Aring: Aring,
	aring: aring,
	Atilde: Atilde,
	atilde: atilde,
	Auml: Auml,
	auml: auml,
	brvbar: brvbar,
	Ccedil: Ccedil,
	ccedil: ccedil,
	cedil: cedil,
	cent: cent,
	copy: copy,
	COPY: COPY,
	curren: curren,
	deg: deg,
	divide: divide,
	Eacute: Eacute,
	eacute: eacute,
	Ecirc: Ecirc,
	ecirc: ecirc,
	Egrave: Egrave,
	egrave: egrave,
	ETH: ETH,
	eth: eth,
	Euml: Euml,
	euml: euml,
	frac12: frac12,
	frac14: frac14,
	frac34: frac34,
	gt: gt$1,
	GT: GT,
	Iacute: Iacute,
	iacute: iacute,
	Icirc: Icirc,
	icirc: icirc,
	iexcl: iexcl,
	Igrave: Igrave,
	igrave: igrave,
	iquest: iquest,
	Iuml: Iuml,
	iuml: iuml,
	laquo: laquo,
	lt: lt$1,
	LT: LT,
	macr: macr,
	micro: micro,
	middot: middot,
	nbsp: nbsp,
	not: not,
	Ntilde: Ntilde,
	ntilde: ntilde,
	Oacute: Oacute,
	oacute: oacute,
	Ocirc: Ocirc,
	ocirc: ocirc,
	Ograve: Ograve,
	ograve: ograve,
	ordf: ordf,
	ordm: ordm,
	Oslash: Oslash,
	oslash: oslash,
	Otilde: Otilde,
	otilde: otilde,
	Ouml: Ouml,
	ouml: ouml,
	para: para,
	plusmn: plusmn,
	pound: pound,
	quot: quot$1,
	QUOT: QUOT,
	raquo: raquo,
	reg: reg,
	REG: REG,
	sect: sect,
	shy: shy,
	sup1: sup1,
	sup2: sup2,
	sup3: sup3,
	szlig: szlig,
	THORN: THORN,
	thorn: thorn,
	times: times,
	Uacute: Uacute,
	uacute: uacute,
	Ucirc: Ucirc,
	ucirc: ucirc,
	Ugrave: Ugrave,
	ugrave: ugrave,
	uml: uml,
	Uuml: Uuml,
	uuml: uuml,
	Yacute: Yacute,
	yacute: yacute,
	yen: yen,
	yuml: yuml
};

var amp = "&";
var apos = "'";
var gt = ">";
var lt = "<";
var quot = "\"";
var require$$0$7 = {
	amp: amp,
	apos: apos,
	gt: gt,
	lt: lt,
	quot: quot
};

var decode_codepoint = {};

var require$$0$6 = {
	"0": 65533,
	"128": 8364,
	"130": 8218,
	"131": 402,
	"132": 8222,
	"133": 8230,
	"134": 8224,
	"135": 8225,
	"136": 710,
	"137": 8240,
	"138": 352,
	"139": 8249,
	"140": 338,
	"142": 381,
	"145": 8216,
	"146": 8217,
	"147": 8220,
	"148": 8221,
	"149": 8226,
	"150": 8211,
	"151": 8212,
	"152": 732,
	"153": 8482,
	"154": 353,
	"155": 8250,
	"156": 339,
	"158": 382,
	"159": 376
};

var __importDefault$9 = (commonjsGlobal && commonjsGlobal.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(decode_codepoint, "__esModule", { value: true });
var decode_json_1 = __importDefault$9(require$$0$6);
// Adapted from https://github.com/mathiasbynens/he/blob/master/src/he.js#L94-L119
var fromCodePoint = 
// eslint-disable-next-line @typescript-eslint/no-unnecessary-condition
String.fromCodePoint ||
    function (codePoint) {
        var output = "";
        if (codePoint > 0xffff) {
            codePoint -= 0x10000;
            output += String.fromCharCode(((codePoint >>> 10) & 0x3ff) | 0xd800);
            codePoint = 0xdc00 | (codePoint & 0x3ff);
        }
        output += String.fromCharCode(codePoint);
        return output;
    };
function decodeCodePoint(codePoint) {
    if ((codePoint >= 0xd800 && codePoint <= 0xdfff) || codePoint > 0x10ffff) {
        return "\uFFFD";
    }
    if (codePoint in decode_json_1.default) {
        codePoint = decode_json_1.default[codePoint];
    }
    return fromCodePoint(codePoint);
}
decode_codepoint.default = decodeCodePoint;

var __importDefault$8 = (commonjsGlobal && commonjsGlobal.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(decode$3, "__esModule", { value: true });
decode$3.decodeHTML = decode$3.decodeHTMLStrict = decode$3.decodeXML = void 0;
var entities_json_1$1 = __importDefault$8(require$$1$3);
var legacy_json_1 = __importDefault$8(require$$1$2);
var xml_json_1$1 = __importDefault$8(require$$0$7);
var decode_codepoint_1 = __importDefault$8(decode_codepoint);
var strictEntityRe = /&(?:[a-zA-Z0-9]+|#[xX][\da-fA-F]+|#\d+);/g;
decode$3.decodeXML = getStrictDecoder(xml_json_1$1.default);
decode$3.decodeHTMLStrict = getStrictDecoder(entities_json_1$1.default);
function getStrictDecoder(map) {
    var replace = getReplacer(map);
    return function (str) { return String(str).replace(strictEntityRe, replace); };
}
var sorter = function (a, b) { return (a < b ? 1 : -1); };
decode$3.decodeHTML = (function () {
    var legacy = Object.keys(legacy_json_1.default).sort(sorter);
    var keys = Object.keys(entities_json_1$1.default).sort(sorter);
    for (var i = 0, j = 0; i < keys.length; i++) {
        if (legacy[j] === keys[i]) {
            keys[i] += ";?";
            j++;
        }
        else {
            keys[i] += ";";
        }
    }
    var re = new RegExp("&(?:" + keys.join("|") + "|#[xX][\\da-fA-F]+;?|#\\d+;?)", "g");
    var replace = getReplacer(entities_json_1$1.default);
    function replacer(str) {
        if (str.substr(-1) !== ";")
            str += ";";
        return replace(str);
    }
    // TODO consider creating a merged map
    return function (str) { return String(str).replace(re, replacer); };
})();
function getReplacer(map) {
    return function replace(str) {
        if (str.charAt(1) === "#") {
            var secondChar = str.charAt(2);
            if (secondChar === "X" || secondChar === "x") {
                return decode_codepoint_1.default(parseInt(str.substr(3), 16));
            }
            return decode_codepoint_1.default(parseInt(str.substr(2), 10));
        }
        // eslint-disable-next-line @typescript-eslint/prefer-nullish-coalescing
        return map[str.slice(1, -1)] || str;
    };
}

var encode$1 = {};

var __importDefault$7 = (commonjsGlobal && commonjsGlobal.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(encode$1, "__esModule", { value: true });
encode$1.escapeUTF8 = encode$1.escape = encode$1.encodeNonAsciiHTML = encode$1.encodeHTML = encode$1.encodeXML = void 0;
var xml_json_1 = __importDefault$7(require$$0$7);
var inverseXML = getInverseObj(xml_json_1.default);
var xmlReplacer = getInverseReplacer(inverseXML);
/**
 * Encodes all non-ASCII characters, as well as characters not valid in XML
 * documents using XML entities.
 *
 * If a character has no equivalent entity, a
 * numeric hexadecimal reference (eg. `&#xfc;`) will be used.
 */
encode$1.encodeXML = getASCIIEncoder(inverseXML);
var entities_json_1 = __importDefault$7(require$$1$3);
var inverseHTML = getInverseObj(entities_json_1.default);
var htmlReplacer = getInverseReplacer(inverseHTML);
/**
 * Encodes all entities and non-ASCII characters in the input.
 *
 * This includes characters that are valid ASCII characters in HTML documents.
 * For example `#` will be encoded as `&num;`. To get a more compact output,
 * consider using the `encodeNonAsciiHTML` function.
 *
 * If a character has no equivalent entity, a
 * numeric hexadecimal reference (eg. `&#xfc;`) will be used.
 */
encode$1.encodeHTML = getInverse(inverseHTML, htmlReplacer);
/**
 * Encodes all non-ASCII characters, as well as characters not valid in HTML
 * documents using HTML entities.
 *
 * If a character has no equivalent entity, a
 * numeric hexadecimal reference (eg. `&#xfc;`) will be used.
 */
encode$1.encodeNonAsciiHTML = getASCIIEncoder(inverseHTML);
function getInverseObj(obj) {
    return Object.keys(obj)
        .sort()
        .reduce(function (inverse, name) {
        inverse[obj[name]] = "&" + name + ";";
        return inverse;
    }, {});
}
function getInverseReplacer(inverse) {
    var single = [];
    var multiple = [];
    for (var _i = 0, _a = Object.keys(inverse); _i < _a.length; _i++) {
        var k = _a[_i];
        if (k.length === 1) {
            // Add value to single array
            single.push("\\" + k);
        }
        else {
            // Add value to multiple array
            multiple.push(k);
        }
    }
    // Add ranges to single characters.
    single.sort();
    for (var start = 0; start < single.length - 1; start++) {
        // Find the end of a run of characters
        var end = start;
        while (end < single.length - 1 &&
            single[end].charCodeAt(1) + 1 === single[end + 1].charCodeAt(1)) {
            end += 1;
        }
        var count = 1 + end - start;
        // We want to replace at least three characters
        if (count < 3)
            continue;
        single.splice(start, count, single[start] + "-" + single[end]);
    }
    multiple.unshift("[" + single.join("") + "]");
    return new RegExp(multiple.join("|"), "g");
}
// /[^\0-\x7F]/gu
var reNonASCII = /(?:[\x80-\uD7FF\uE000-\uFFFF]|[\uD800-\uDBFF][\uDC00-\uDFFF]|[\uD800-\uDBFF](?![\uDC00-\uDFFF])|(?:[^\uD800-\uDBFF]|^)[\uDC00-\uDFFF])/g;
var getCodePoint = 
// eslint-disable-next-line @typescript-eslint/no-unnecessary-condition
String.prototype.codePointAt != null
    ? // eslint-disable-next-line @typescript-eslint/no-non-null-assertion
        function (str) { return str.codePointAt(0); }
    : // http://mathiasbynens.be/notes/javascript-encoding#surrogate-formulae
        function (c) {
            return (c.charCodeAt(0) - 0xd800) * 0x400 +
                c.charCodeAt(1) -
                0xdc00 +
                0x10000;
        };
function singleCharReplacer(c) {
    return "&#x" + (c.length > 1 ? getCodePoint(c) : c.charCodeAt(0))
        .toString(16)
        .toUpperCase() + ";";
}
function getInverse(inverse, re) {
    return function (data) {
        return data
            .replace(re, function (name) { return inverse[name]; })
            .replace(reNonASCII, singleCharReplacer);
    };
}
var reEscapeChars = new RegExp(xmlReplacer.source + "|" + reNonASCII.source, "g");
/**
 * Encodes all non-ASCII characters, as well as characters not valid in XML
 * documents using numeric hexadecimal reference (eg. `&#xfc;`).
 *
 * Have a look at `escapeUTF8` if you want a more concise output at the expense
 * of reduced transportability.
 *
 * @param data String to escape.
 */
function escape$1(data) {
    return data.replace(reEscapeChars, singleCharReplacer);
}
encode$1.escape = escape$1;
/**
 * Encodes all characters not valid in XML documents using numeric hexadecimal
 * reference (eg. `&#xfc;`).
 *
 * Note that the output will be character-set dependent.
 *
 * @param data String to escape.
 */
function escapeUTF8(data) {
    return data.replace(xmlReplacer, singleCharReplacer);
}
encode$1.escapeUTF8 = escapeUTF8;
function getASCIIEncoder(obj) {
    return function (data) {
        return data.replace(reEscapeChars, function (c) { return obj[c] || singleCharReplacer(c); });
    };
}

(function (exports) {
	Object.defineProperty(exports, "__esModule", { value: true });
	exports.decodeXMLStrict = exports.decodeHTML5Strict = exports.decodeHTML4Strict = exports.decodeHTML5 = exports.decodeHTML4 = exports.decodeHTMLStrict = exports.decodeHTML = exports.decodeXML = exports.encodeHTML5 = exports.encodeHTML4 = exports.escapeUTF8 = exports.escape = exports.encodeNonAsciiHTML = exports.encodeHTML = exports.encodeXML = exports.encode = exports.decodeStrict = exports.decode = void 0;
	var decode_1 = decode$3;
	var encode_1 = encode$1;
	/**
	 * Decodes a string with entities.
	 *
	 * @param data String to decode.
	 * @param level Optional level to decode at. 0 = XML, 1 = HTML. Default is 0.
	 * @deprecated Use `decodeXML` or `decodeHTML` directly.
	 */
	function decode(data, level) {
	    return (!level || level <= 0 ? decode_1.decodeXML : decode_1.decodeHTML)(data);
	}
	exports.decode = decode;
	/**
	 * Decodes a string with entities. Does not allow missing trailing semicolons for entities.
	 *
	 * @param data String to decode.
	 * @param level Optional level to decode at. 0 = XML, 1 = HTML. Default is 0.
	 * @deprecated Use `decodeHTMLStrict` or `decodeXML` directly.
	 */
	function decodeStrict(data, level) {
	    return (!level || level <= 0 ? decode_1.decodeXML : decode_1.decodeHTMLStrict)(data);
	}
	exports.decodeStrict = decodeStrict;
	/**
	 * Encodes a string with entities.
	 *
	 * @param data String to encode.
	 * @param level Optional level to encode at. 0 = XML, 1 = HTML. Default is 0.
	 * @deprecated Use `encodeHTML`, `encodeXML` or `encodeNonAsciiHTML` directly.
	 */
	function encode(data, level) {
	    return (!level || level <= 0 ? encode_1.encodeXML : encode_1.encodeHTML)(data);
	}
	exports.encode = encode;
	var encode_2 = encode$1;
	Object.defineProperty(exports, "encodeXML", { enumerable: true, get: function () { return encode_2.encodeXML; } });
	Object.defineProperty(exports, "encodeHTML", { enumerable: true, get: function () { return encode_2.encodeHTML; } });
	Object.defineProperty(exports, "encodeNonAsciiHTML", { enumerable: true, get: function () { return encode_2.encodeNonAsciiHTML; } });
	Object.defineProperty(exports, "escape", { enumerable: true, get: function () { return encode_2.escape; } });
	Object.defineProperty(exports, "escapeUTF8", { enumerable: true, get: function () { return encode_2.escapeUTF8; } });
	// Legacy aliases (deprecated)
	Object.defineProperty(exports, "encodeHTML4", { enumerable: true, get: function () { return encode_2.encodeHTML; } });
	Object.defineProperty(exports, "encodeHTML5", { enumerable: true, get: function () { return encode_2.encodeHTML; } });
	var decode_2 = decode$3;
	Object.defineProperty(exports, "decodeXML", { enumerable: true, get: function () { return decode_2.decodeXML; } });
	Object.defineProperty(exports, "decodeHTML", { enumerable: true, get: function () { return decode_2.decodeHTML; } });
	Object.defineProperty(exports, "decodeHTMLStrict", { enumerable: true, get: function () { return decode_2.decodeHTMLStrict; } });
	// Legacy aliases (deprecated)
	Object.defineProperty(exports, "decodeHTML4", { enumerable: true, get: function () { return decode_2.decodeHTML; } });
	Object.defineProperty(exports, "decodeHTML5", { enumerable: true, get: function () { return decode_2.decodeHTML; } });
	Object.defineProperty(exports, "decodeHTML4Strict", { enumerable: true, get: function () { return decode_2.decodeHTMLStrict; } });
	Object.defineProperty(exports, "decodeHTML5Strict", { enumerable: true, get: function () { return decode_2.decodeHTMLStrict; } });
	Object.defineProperty(exports, "decodeXMLStrict", { enumerable: true, get: function () { return decode_2.decodeXML; } }); 
} (lib$n));

var foreignNames = {};

Object.defineProperty(foreignNames, "__esModule", { value: true });
foreignNames.attributeNames = foreignNames.elementNames = void 0;
foreignNames.elementNames = new Map([
    ["altglyph", "altGlyph"],
    ["altglyphdef", "altGlyphDef"],
    ["altglyphitem", "altGlyphItem"],
    ["animatecolor", "animateColor"],
    ["animatemotion", "animateMotion"],
    ["animatetransform", "animateTransform"],
    ["clippath", "clipPath"],
    ["feblend", "feBlend"],
    ["fecolormatrix", "feColorMatrix"],
    ["fecomponenttransfer", "feComponentTransfer"],
    ["fecomposite", "feComposite"],
    ["feconvolvematrix", "feConvolveMatrix"],
    ["fediffuselighting", "feDiffuseLighting"],
    ["fedisplacementmap", "feDisplacementMap"],
    ["fedistantlight", "feDistantLight"],
    ["fedropshadow", "feDropShadow"],
    ["feflood", "feFlood"],
    ["fefunca", "feFuncA"],
    ["fefuncb", "feFuncB"],
    ["fefuncg", "feFuncG"],
    ["fefuncr", "feFuncR"],
    ["fegaussianblur", "feGaussianBlur"],
    ["feimage", "feImage"],
    ["femerge", "feMerge"],
    ["femergenode", "feMergeNode"],
    ["femorphology", "feMorphology"],
    ["feoffset", "feOffset"],
    ["fepointlight", "fePointLight"],
    ["fespecularlighting", "feSpecularLighting"],
    ["fespotlight", "feSpotLight"],
    ["fetile", "feTile"],
    ["feturbulence", "feTurbulence"],
    ["foreignobject", "foreignObject"],
    ["glyphref", "glyphRef"],
    ["lineargradient", "linearGradient"],
    ["radialgradient", "radialGradient"],
    ["textpath", "textPath"],
]);
foreignNames.attributeNames = new Map([
    ["definitionurl", "definitionURL"],
    ["attributename", "attributeName"],
    ["attributetype", "attributeType"],
    ["basefrequency", "baseFrequency"],
    ["baseprofile", "baseProfile"],
    ["calcmode", "calcMode"],
    ["clippathunits", "clipPathUnits"],
    ["diffuseconstant", "diffuseConstant"],
    ["edgemode", "edgeMode"],
    ["filterunits", "filterUnits"],
    ["glyphref", "glyphRef"],
    ["gradienttransform", "gradientTransform"],
    ["gradientunits", "gradientUnits"],
    ["kernelmatrix", "kernelMatrix"],
    ["kernelunitlength", "kernelUnitLength"],
    ["keypoints", "keyPoints"],
    ["keysplines", "keySplines"],
    ["keytimes", "keyTimes"],
    ["lengthadjust", "lengthAdjust"],
    ["limitingconeangle", "limitingConeAngle"],
    ["markerheight", "markerHeight"],
    ["markerunits", "markerUnits"],
    ["markerwidth", "markerWidth"],
    ["maskcontentunits", "maskContentUnits"],
    ["maskunits", "maskUnits"],
    ["numoctaves", "numOctaves"],
    ["pathlength", "pathLength"],
    ["patterncontentunits", "patternContentUnits"],
    ["patterntransform", "patternTransform"],
    ["patternunits", "patternUnits"],
    ["pointsatx", "pointsAtX"],
    ["pointsaty", "pointsAtY"],
    ["pointsatz", "pointsAtZ"],
    ["preservealpha", "preserveAlpha"],
    ["preserveaspectratio", "preserveAspectRatio"],
    ["primitiveunits", "primitiveUnits"],
    ["refx", "refX"],
    ["refy", "refY"],
    ["repeatcount", "repeatCount"],
    ["repeatdur", "repeatDur"],
    ["requiredextensions", "requiredExtensions"],
    ["requiredfeatures", "requiredFeatures"],
    ["specularconstant", "specularConstant"],
    ["specularexponent", "specularExponent"],
    ["spreadmethod", "spreadMethod"],
    ["startoffset", "startOffset"],
    ["stddeviation", "stdDeviation"],
    ["stitchtiles", "stitchTiles"],
    ["surfacescale", "surfaceScale"],
    ["systemlanguage", "systemLanguage"],
    ["tablevalues", "tableValues"],
    ["targetx", "targetX"],
    ["targety", "targetY"],
    ["textlength", "textLength"],
    ["viewbox", "viewBox"],
    ["viewtarget", "viewTarget"],
    ["xchannelselector", "xChannelSelector"],
    ["ychannelselector", "yChannelSelector"],
    ["zoomandpan", "zoomAndPan"],
]);

var __assign$1 = (commonjsGlobal && commonjsGlobal.__assign) || function () {
    __assign$1 = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign$1.apply(this, arguments);
};
var __createBinding = (commonjsGlobal && commonjsGlobal.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (commonjsGlobal && commonjsGlobal.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (commonjsGlobal && commonjsGlobal.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(lib$o, "__esModule", { value: true });
/*
 * Module dependencies
 */
var ElementType = __importStar(lib$p);
var entities_1 = lib$n;
/**
 * Mixed-case SVG and MathML tags & attributes
 * recognized by the HTML parser.
 *
 * @see https://html.spec.whatwg.org/multipage/parsing.html#parsing-main-inforeign
 */
var foreignNames_1 = foreignNames;
var unencodedElements = new Set([
    "style",
    "script",
    "xmp",
    "iframe",
    "noembed",
    "noframes",
    "plaintext",
    "noscript",
]);
/**
 * Format attributes
 */
function formatAttributes(attributes, opts) {
    if (!attributes)
        return;
    return Object.keys(attributes)
        .map(function (key) {
        var _a, _b;
        var value = (_a = attributes[key]) !== null && _a !== void 0 ? _a : "";
        if (opts.xmlMode === "foreign") {
            /* Fix up mixed-case attribute names */
            key = (_b = foreignNames_1.attributeNames.get(key)) !== null && _b !== void 0 ? _b : key;
        }
        if (!opts.emptyAttrs && !opts.xmlMode && value === "") {
            return key;
        }
        return key + "=\"" + (opts.decodeEntities !== false
            ? entities_1.encodeXML(value)
            : value.replace(/"/g, "&quot;")) + "\"";
    })
        .join(" ");
}
/**
 * Self-enclosing tags
 */
var singleTag = new Set([
    "area",
    "base",
    "basefont",
    "br",
    "col",
    "command",
    "embed",
    "frame",
    "hr",
    "img",
    "input",
    "isindex",
    "keygen",
    "link",
    "meta",
    "param",
    "source",
    "track",
    "wbr",
]);
/**
 * Renders a DOM node or an array of DOM nodes to a string.
 *
 * Can be thought of as the equivalent of the `outerHTML` of the passed node(s).
 *
 * @param node Node to be rendered.
 * @param options Changes serialization behavior
 */
function render(node, options) {
    if (options === void 0) { options = {}; }
    var nodes = "length" in node ? node : [node];
    var output = "";
    for (var i = 0; i < nodes.length; i++) {
        output += renderNode(nodes[i], options);
    }
    return output;
}
lib$o.default = render;
function renderNode(node, options) {
    switch (node.type) {
        case ElementType.Root:
            return render(node.children, options);
        case ElementType.Directive:
        case ElementType.Doctype:
            return renderDirective(node);
        case ElementType.Comment:
            return renderComment(node);
        case ElementType.CDATA:
            return renderCdata(node);
        case ElementType.Script:
        case ElementType.Style:
        case ElementType.Tag:
            return renderTag(node, options);
        case ElementType.Text:
            return renderText(node, options);
    }
}
var foreignModeIntegrationPoints = new Set([
    "mi",
    "mo",
    "mn",
    "ms",
    "mtext",
    "annotation-xml",
    "foreignObject",
    "desc",
    "title",
]);
var foreignElements = new Set(["svg", "math"]);
function renderTag(elem, opts) {
    var _a;
    // Handle SVG / MathML in HTML
    if (opts.xmlMode === "foreign") {
        /* Fix up mixed-case element names */
        elem.name = (_a = foreignNames_1.elementNames.get(elem.name)) !== null && _a !== void 0 ? _a : elem.name;
        /* Exit foreign mode at integration points */
        if (elem.parent &&
            foreignModeIntegrationPoints.has(elem.parent.name)) {
            opts = __assign$1(__assign$1({}, opts), { xmlMode: false });
        }
    }
    if (!opts.xmlMode && foreignElements.has(elem.name)) {
        opts = __assign$1(__assign$1({}, opts), { xmlMode: "foreign" });
    }
    var tag = "<" + elem.name;
    var attribs = formatAttributes(elem.attribs, opts);
    if (attribs) {
        tag += " " + attribs;
    }
    if (elem.children.length === 0 &&
        (opts.xmlMode
            ? // In XML mode or foreign mode, and user hasn't explicitly turned off self-closing tags
                opts.selfClosingTags !== false
            : // User explicitly asked for self-closing tags, even in HTML mode
                opts.selfClosingTags && singleTag.has(elem.name))) {
        if (!opts.xmlMode)
            tag += " ";
        tag += "/>";
    }
    else {
        tag += ">";
        if (elem.children.length > 0) {
            tag += render(elem.children, opts);
        }
        if (opts.xmlMode || !singleTag.has(elem.name)) {
            tag += "</" + elem.name + ">";
        }
    }
    return tag;
}
function renderDirective(elem) {
    return "<" + elem.data + ">";
}
function renderText(elem, opts) {
    var data = elem.data || "";
    // If entities weren't decoded, no need to encode them back
    if (opts.decodeEntities !== false &&
        !(!opts.xmlMode &&
            elem.parent &&
            unencodedElements.has(elem.parent.name))) {
        data = entities_1.encodeXML(data);
    }
    return data;
}
function renderCdata(elem) {
    return "<![CDATA[" + elem.children[0].data + "]]>";
}
function renderComment(elem) {
    return "<!--" + elem.data + "-->";
}

var __importDefault$6 = (commonjsGlobal && commonjsGlobal.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(stringify$6, "__esModule", { value: true });
stringify$6.innerText = stringify$6.textContent = stringify$6.getText = stringify$6.getInnerHTML = stringify$6.getOuterHTML = void 0;
var domhandler_1$4 = lib$q;
var dom_serializer_1 = __importDefault$6(lib$o);
var domelementtype_1 = lib$p;
/**
 * @param node Node to get the outer HTML of.
 * @param options Options for serialization.
 * @deprecated Use the `dom-serializer` module directly.
 * @returns `node`'s outer HTML.
 */
function getOuterHTML(node, options) {
    return (0, dom_serializer_1.default)(node, options);
}
stringify$6.getOuterHTML = getOuterHTML;
/**
 * @param node Node to get the inner HTML of.
 * @param options Options for serialization.
 * @deprecated Use the `dom-serializer` module directly.
 * @returns `node`'s inner HTML.
 */
function getInnerHTML(node, options) {
    return (0, domhandler_1$4.hasChildren)(node)
        ? node.children.map(function (node) { return getOuterHTML(node, options); }).join("")
        : "";
}
stringify$6.getInnerHTML = getInnerHTML;
/**
 * Get a node's inner text. Same as `textContent`, but inserts newlines for `<br>` tags.
 *
 * @deprecated Use `textContent` instead.
 * @param node Node to get the inner text of.
 * @returns `node`'s inner text.
 */
function getText$1(node) {
    if (Array.isArray(node))
        return node.map(getText$1).join("");
    if ((0, domhandler_1$4.isTag)(node))
        return node.name === "br" ? "\n" : getText$1(node.children);
    if ((0, domhandler_1$4.isCDATA)(node))
        return getText$1(node.children);
    if ((0, domhandler_1$4.isText)(node))
        return node.data;
    return "";
}
stringify$6.getText = getText$1;
/**
 * Get a node's text content.
 *
 * @param node Node to get the text content of.
 * @returns `node`'s text content.
 * @see {@link https://developer.mozilla.org/en-US/docs/Web/API/Node/textContent}
 */
function textContent(node) {
    if (Array.isArray(node))
        return node.map(textContent).join("");
    if ((0, domhandler_1$4.hasChildren)(node) && !(0, domhandler_1$4.isComment)(node)) {
        return textContent(node.children);
    }
    if ((0, domhandler_1$4.isText)(node))
        return node.data;
    return "";
}
stringify$6.textContent = textContent;
/**
 * Get a node's inner text.
 *
 * @param node Node to get the inner text of.
 * @returns `node`'s inner text.
 * @see {@link https://developer.mozilla.org/en-US/docs/Web/API/Node/innerText}
 */
function innerText(node) {
    if (Array.isArray(node))
        return node.map(innerText).join("");
    if ((0, domhandler_1$4.hasChildren)(node) && (node.type === domelementtype_1.ElementType.Tag || (0, domhandler_1$4.isCDATA)(node))) {
        return innerText(node.children);
    }
    if ((0, domhandler_1$4.isText)(node))
        return node.data;
    return "";
}
stringify$6.innerText = innerText;

var traversal = {};

Object.defineProperty(traversal, "__esModule", { value: true });
traversal.prevElementSibling = traversal.nextElementSibling = traversal.getName = traversal.hasAttrib = traversal.getAttributeValue = traversal.getSiblings = traversal.getParent = traversal.getChildren = void 0;
var domhandler_1$3 = lib$q;
var emptyArray = [];
/**
 * Get a node's children.
 *
 * @param elem Node to get the children of.
 * @returns `elem`'s children, or an empty array.
 */
function getChildren$1(elem) {
    var _a;
    return (_a = elem.children) !== null && _a !== void 0 ? _a : emptyArray;
}
traversal.getChildren = getChildren$1;
/**
 * Get a node's parent.
 *
 * @param elem Node to get the parent of.
 * @returns `elem`'s parent node.
 */
function getParent$1(elem) {
    return elem.parent || null;
}
traversal.getParent = getParent$1;
/**
 * Gets an elements siblings, including the element itself.
 *
 * Attempts to get the children through the element's parent first.
 * If we don't have a parent (the element is a root node),
 * we walk the element's `prev` & `next` to get all remaining nodes.
 *
 * @param elem Element to get the siblings of.
 * @returns `elem`'s siblings.
 */
function getSiblings$1(elem) {
    var _a, _b;
    var parent = getParent$1(elem);
    if (parent != null)
        return getChildren$1(parent);
    var siblings = [elem];
    var prev = elem.prev, next = elem.next;
    while (prev != null) {
        siblings.unshift(prev);
        (_a = prev, prev = _a.prev);
    }
    while (next != null) {
        siblings.push(next);
        (_b = next, next = _b.next);
    }
    return siblings;
}
traversal.getSiblings = getSiblings$1;
/**
 * Gets an attribute from an element.
 *
 * @param elem Element to check.
 * @param name Attribute name to retrieve.
 * @returns The element's attribute value, or `undefined`.
 */
function getAttributeValue$1(elem, name) {
    var _a;
    return (_a = elem.attribs) === null || _a === void 0 ? void 0 : _a[name];
}
traversal.getAttributeValue = getAttributeValue$1;
/**
 * Checks whether an element has an attribute.
 *
 * @param elem Element to check.
 * @param name Attribute name to look for.
 * @returns Returns whether `elem` has the attribute `name`.
 */
function hasAttrib$1(elem, name) {
    return (elem.attribs != null &&
        Object.prototype.hasOwnProperty.call(elem.attribs, name) &&
        elem.attribs[name] != null);
}
traversal.hasAttrib = hasAttrib$1;
/**
 * Get the tag name of an element.
 *
 * @param elem The element to get the name for.
 * @returns The tag name of `elem`.
 */
function getName$1(elem) {
    return elem.name;
}
traversal.getName = getName$1;
/**
 * Returns the next element sibling of a node.
 *
 * @param elem The element to get the next sibling of.
 * @returns `elem`'s next sibling that is a tag.
 */
function nextElementSibling(elem) {
    var _a;
    var next = elem.next;
    while (next !== null && !(0, domhandler_1$3.isTag)(next))
        (_a = next, next = _a.next);
    return next;
}
traversal.nextElementSibling = nextElementSibling;
/**
 * Returns the previous element sibling of a node.
 *
 * @param elem The element to get the previous sibling of.
 * @returns `elem`'s previous sibling that is a tag.
 */
function prevElementSibling(elem) {
    var _a;
    var prev = elem.prev;
    while (prev !== null && !(0, domhandler_1$3.isTag)(prev))
        (_a = prev, prev = _a.prev);
    return prev;
}
traversal.prevElementSibling = prevElementSibling;

var manipulation = {};

Object.defineProperty(manipulation, "__esModule", { value: true });
manipulation.prepend = manipulation.prependChild = manipulation.append = manipulation.appendChild = manipulation.replaceElement = manipulation.removeElement = void 0;
/**
 * Remove an element from the dom
 *
 * @param elem The element to be removed
 */
function removeElement(elem) {
    if (elem.prev)
        elem.prev.next = elem.next;
    if (elem.next)
        elem.next.prev = elem.prev;
    if (elem.parent) {
        var childs = elem.parent.children;
        childs.splice(childs.lastIndexOf(elem), 1);
    }
}
manipulation.removeElement = removeElement;
/**
 * Replace an element in the dom
 *
 * @param elem The element to be replaced
 * @param replacement The element to be added
 */
function replaceElement(elem, replacement) {
    var prev = (replacement.prev = elem.prev);
    if (prev) {
        prev.next = replacement;
    }
    var next = (replacement.next = elem.next);
    if (next) {
        next.prev = replacement;
    }
    var parent = (replacement.parent = elem.parent);
    if (parent) {
        var childs = parent.children;
        childs[childs.lastIndexOf(elem)] = replacement;
    }
}
manipulation.replaceElement = replaceElement;
/**
 * Append a child to an element.
 *
 * @param elem The element to append to.
 * @param child The element to be added as a child.
 */
function appendChild(elem, child) {
    removeElement(child);
    child.next = null;
    child.parent = elem;
    if (elem.children.push(child) > 1) {
        var sibling = elem.children[elem.children.length - 2];
        sibling.next = child;
        child.prev = sibling;
    }
    else {
        child.prev = null;
    }
}
manipulation.appendChild = appendChild;
/**
 * Append an element after another.
 *
 * @param elem The element to append after.
 * @param next The element be added.
 */
function append$1(elem, next) {
    removeElement(next);
    var parent = elem.parent;
    var currNext = elem.next;
    next.next = currNext;
    next.prev = elem;
    elem.next = next;
    next.parent = parent;
    if (currNext) {
        currNext.prev = next;
        if (parent) {
            var childs = parent.children;
            childs.splice(childs.lastIndexOf(currNext), 0, next);
        }
    }
    else if (parent) {
        parent.children.push(next);
    }
}
manipulation.append = append$1;
/**
 * Prepend a child to an element.
 *
 * @param elem The element to prepend before.
 * @param child The element to be added as a child.
 */
function prependChild(elem, child) {
    removeElement(child);
    child.parent = elem;
    child.prev = null;
    if (elem.children.unshift(child) !== 1) {
        var sibling = elem.children[1];
        sibling.prev = child;
        child.next = sibling;
    }
    else {
        child.next = null;
    }
}
manipulation.prependChild = prependChild;
/**
 * Prepend an element before another.
 *
 * @param elem The element to prepend before.
 * @param prev The element be added.
 */
function prepend(elem, prev) {
    removeElement(prev);
    var parent = elem.parent;
    if (parent) {
        var childs = parent.children;
        childs.splice(childs.indexOf(elem), 0, prev);
    }
    if (elem.prev) {
        elem.prev.next = prev;
    }
    prev.parent = parent;
    prev.prev = elem.prev;
    prev.next = elem;
    elem.prev = prev;
}
manipulation.prepend = prepend;

var querying = {};

Object.defineProperty(querying, "__esModule", { value: true });
querying.findAll = querying.existsOne = querying.findOne = querying.findOneChild = querying.find = querying.filter = void 0;
var domhandler_1$2 = lib$q;
/**
 * Search a node and its children for nodes passing a test function.
 *
 * @param test Function to test nodes on.
 * @param node Node to search. Will be included in the result set if it matches.
 * @param recurse Also consider child nodes.
 * @param limit Maximum number of nodes to return.
 * @returns All nodes passing `test`.
 */
function filter$1(test, node, recurse, limit) {
    if (recurse === void 0) { recurse = true; }
    if (limit === void 0) { limit = Infinity; }
    if (!Array.isArray(node))
        node = [node];
    return find(test, node, recurse, limit);
}
querying.filter = filter$1;
/**
 * Search an array of node and its children for nodes passing a test function.
 *
 * @param test Function to test nodes on.
 * @param nodes Array of nodes to search.
 * @param recurse Also consider child nodes.
 * @param limit Maximum number of nodes to return.
 * @returns All nodes passing `test`.
 */
function find(test, nodes, recurse, limit) {
    var result = [];
    for (var _i = 0, nodes_1 = nodes; _i < nodes_1.length; _i++) {
        var elem = nodes_1[_i];
        if (test(elem)) {
            result.push(elem);
            if (--limit <= 0)
                break;
        }
        if (recurse && (0, domhandler_1$2.hasChildren)(elem) && elem.children.length > 0) {
            var children = find(test, elem.children, recurse, limit);
            result.push.apply(result, children);
            limit -= children.length;
            if (limit <= 0)
                break;
        }
    }
    return result;
}
querying.find = find;
/**
 * Finds the first element inside of an array that matches a test function.
 *
 * @param test Function to test nodes on.
 * @param nodes Array of nodes to search.
 * @returns The first node in the array that passes `test`.
 */
function findOneChild(test, nodes) {
    return nodes.find(test);
}
querying.findOneChild = findOneChild;
/**
 * Finds one element in a tree that passes a test.
 *
 * @param test Function to test nodes on.
 * @param nodes Array of nodes to search.
 * @param recurse Also consider child nodes.
 * @returns The first child node that passes `test`.
 */
function findOne$1(test, nodes, recurse) {
    if (recurse === void 0) { recurse = true; }
    var elem = null;
    for (var i = 0; i < nodes.length && !elem; i++) {
        var checked = nodes[i];
        if (!(0, domhandler_1$2.isTag)(checked)) {
            continue;
        }
        else if (test(checked)) {
            elem = checked;
        }
        else if (recurse && checked.children.length > 0) {
            elem = findOne$1(test, checked.children);
        }
    }
    return elem;
}
querying.findOne = findOne$1;
/**
 * @param test Function to test nodes on.
 * @param nodes Array of nodes to search.
 * @returns Whether a tree of nodes contains at least one node passing a test.
 */
function existsOne$1(test, nodes) {
    return nodes.some(function (checked) {
        return (0, domhandler_1$2.isTag)(checked) &&
            (test(checked) ||
                (checked.children.length > 0 &&
                    existsOne$1(test, checked.children)));
    });
}
querying.existsOne = existsOne$1;
/**
 * Search and array of nodes and its children for nodes passing a test function.
 *
 * Same as `find`, only with less options, leading to reduced complexity.
 *
 * @param test Function to test nodes on.
 * @param nodes Array of nodes to search.
 * @returns All nodes passing `test`.
 */
function findAll$1(test, nodes) {
    var _a;
    var result = [];
    var stack = nodes.filter(domhandler_1$2.isTag);
    var elem;
    while ((elem = stack.shift())) {
        var children = (_a = elem.children) === null || _a === void 0 ? void 0 : _a.filter(domhandler_1$2.isTag);
        if (children && children.length > 0) {
            stack.unshift.apply(stack, children);
        }
        if (test(elem))
            result.push(elem);
    }
    return result;
}
querying.findAll = findAll$1;

var legacy$1 = {};

Object.defineProperty(legacy$1, "__esModule", { value: true });
legacy$1.getElementsByTagType = legacy$1.getElementsByTagName = legacy$1.getElementById = legacy$1.getElements = legacy$1.testElement = void 0;
var domhandler_1$1 = lib$q;
var querying_1 = querying;
var Checks = {
    tag_name: function (name) {
        if (typeof name === "function") {
            return function (elem) { return (0, domhandler_1$1.isTag)(elem) && name(elem.name); };
        }
        else if (name === "*") {
            return domhandler_1$1.isTag;
        }
        return function (elem) { return (0, domhandler_1$1.isTag)(elem) && elem.name === name; };
    },
    tag_type: function (type) {
        if (typeof type === "function") {
            return function (elem) { return type(elem.type); };
        }
        return function (elem) { return elem.type === type; };
    },
    tag_contains: function (data) {
        if (typeof data === "function") {
            return function (elem) { return (0, domhandler_1$1.isText)(elem) && data(elem.data); };
        }
        return function (elem) { return (0, domhandler_1$1.isText)(elem) && elem.data === data; };
    },
};
/**
 * @param attrib Attribute to check.
 * @param value Attribute value to look for.
 * @returns A function to check whether the a node has an attribute with a particular value.
 */
function getAttribCheck(attrib, value) {
    if (typeof value === "function") {
        return function (elem) { return (0, domhandler_1$1.isTag)(elem) && value(elem.attribs[attrib]); };
    }
    return function (elem) { return (0, domhandler_1$1.isTag)(elem) && elem.attribs[attrib] === value; };
}
/**
 * @param a First function to combine.
 * @param b Second function to combine.
 * @returns A function taking a node and returning `true` if either
 * of the input functions returns `true` for the node.
 */
function combineFuncs(a, b) {
    return function (elem) { return a(elem) || b(elem); };
}
/**
 * @param options An object describing nodes to look for.
 * @returns A function executing all checks in `options` and returning `true`
 * if any of them match a node.
 */
function compileTest(options) {
    var funcs = Object.keys(options).map(function (key) {
        var value = options[key];
        return Object.prototype.hasOwnProperty.call(Checks, key)
            ? Checks[key](value)
            : getAttribCheck(key, value);
    });
    return funcs.length === 0 ? null : funcs.reduce(combineFuncs);
}
/**
 * @param options An object describing nodes to look for.
 * @param node The element to test.
 * @returns Whether the element matches the description in `options`.
 */
function testElement(options, node) {
    var test = compileTest(options);
    return test ? test(node) : true;
}
legacy$1.testElement = testElement;
/**
 * @param options An object describing nodes to look for.
 * @param nodes Nodes to search through.
 * @param recurse Also consider child nodes.
 * @param limit Maximum number of nodes to return.
 * @returns All nodes that match `options`.
 */
function getElements(options, nodes, recurse, limit) {
    if (limit === void 0) { limit = Infinity; }
    var test = compileTest(options);
    return test ? (0, querying_1.filter)(test, nodes, recurse, limit) : [];
}
legacy$1.getElements = getElements;
/**
 * @param id The unique ID attribute value to look for.
 * @param nodes Nodes to search through.
 * @param recurse Also consider child nodes.
 * @returns The node with the supplied ID.
 */
function getElementById(id, nodes, recurse) {
    if (recurse === void 0) { recurse = true; }
    if (!Array.isArray(nodes))
        nodes = [nodes];
    return (0, querying_1.findOne)(getAttribCheck("id", id), nodes, recurse);
}
legacy$1.getElementById = getElementById;
/**
 * @param tagName Tag name to search for.
 * @param nodes Nodes to search through.
 * @param recurse Also consider child nodes.
 * @param limit Maximum number of nodes to return.
 * @returns All nodes with the supplied `tagName`.
 */
function getElementsByTagName(tagName, nodes, recurse, limit) {
    if (recurse === void 0) { recurse = true; }
    if (limit === void 0) { limit = Infinity; }
    return (0, querying_1.filter)(Checks.tag_name(tagName), nodes, recurse, limit);
}
legacy$1.getElementsByTagName = getElementsByTagName;
/**
 * @param type Element type to look for.
 * @param nodes Nodes to search through.
 * @param recurse Also consider child nodes.
 * @param limit Maximum number of nodes to return.
 * @returns All nodes with the supplied `type`.
 */
function getElementsByTagType(type, nodes, recurse, limit) {
    if (recurse === void 0) { recurse = true; }
    if (limit === void 0) { limit = Infinity; }
    return (0, querying_1.filter)(Checks.tag_type(type), nodes, recurse, limit);
}
legacy$1.getElementsByTagType = getElementsByTagType;

var helpers$3 = {};

Object.defineProperty(helpers$3, "__esModule", { value: true });
helpers$3.uniqueSort = helpers$3.compareDocumentPosition = helpers$3.removeSubsets = void 0;
var domhandler_1 = lib$q;
/**
 * Given an array of nodes, remove any member that is contained by another.
 *
 * @param nodes Nodes to filter.
 * @returns Remaining nodes that aren't subtrees of each other.
 */
function removeSubsets$1(nodes) {
    var idx = nodes.length;
    /*
     * Check if each node (or one of its ancestors) is already contained in the
     * array.
     */
    while (--idx >= 0) {
        var node = nodes[idx];
        /*
         * Remove the node if it is not unique.
         * We are going through the array from the end, so we only
         * have to check nodes that preceed the node under consideration in the array.
         */
        if (idx > 0 && nodes.lastIndexOf(node, idx - 1) >= 0) {
            nodes.splice(idx, 1);
            continue;
        }
        for (var ancestor = node.parent; ancestor; ancestor = ancestor.parent) {
            if (nodes.includes(ancestor)) {
                nodes.splice(idx, 1);
                break;
            }
        }
    }
    return nodes;
}
helpers$3.removeSubsets = removeSubsets$1;
/**
 * Compare the position of one node against another node in any other document.
 * The return value is a bitmask with the following values:
 *
 * Document order:
 * > There is an ordering, document order, defined on all the nodes in the
 * > document corresponding to the order in which the first character of the
 * > XML representation of each node occurs in the XML representation of the
 * > document after expansion of general entities. Thus, the document element
 * > node will be the first node. Element nodes occur before their children.
 * > Thus, document order orders element nodes in order of the occurrence of
 * > their start-tag in the XML (after expansion of entities). The attribute
 * > nodes of an element occur after the element and before its children. The
 * > relative order of attribute nodes is implementation-dependent./
 *
 * Source:
 * http://www.w3.org/TR/DOM-Level-3-Core/glossary.html#dt-document-order
 *
 * @param nodeA The first node to use in the comparison
 * @param nodeB The second node to use in the comparison
 * @returns A bitmask describing the input nodes' relative position.
 *
 * See http://dom.spec.whatwg.org/#dom-node-comparedocumentposition for
 * a description of these values.
 */
function compareDocumentPosition(nodeA, nodeB) {
    var aParents = [];
    var bParents = [];
    if (nodeA === nodeB) {
        return 0;
    }
    var current = (0, domhandler_1.hasChildren)(nodeA) ? nodeA : nodeA.parent;
    while (current) {
        aParents.unshift(current);
        current = current.parent;
    }
    current = (0, domhandler_1.hasChildren)(nodeB) ? nodeB : nodeB.parent;
    while (current) {
        bParents.unshift(current);
        current = current.parent;
    }
    var maxIdx = Math.min(aParents.length, bParents.length);
    var idx = 0;
    while (idx < maxIdx && aParents[idx] === bParents[idx]) {
        idx++;
    }
    if (idx === 0) {
        return 1 /* DISCONNECTED */;
    }
    var sharedParent = aParents[idx - 1];
    var siblings = sharedParent.children;
    var aSibling = aParents[idx];
    var bSibling = bParents[idx];
    if (siblings.indexOf(aSibling) > siblings.indexOf(bSibling)) {
        if (sharedParent === nodeB) {
            return 4 /* FOLLOWING */ | 16 /* CONTAINED_BY */;
        }
        return 4 /* FOLLOWING */;
    }
    if (sharedParent === nodeA) {
        return 2 /* PRECEDING */ | 8 /* CONTAINS */;
    }
    return 2 /* PRECEDING */;
}
helpers$3.compareDocumentPosition = compareDocumentPosition;
/**
 * Sort an array of nodes based on their relative position in the document and
 * remove any duplicate nodes. If the array contains nodes that do not belong
 * to the same document, sort order is unspecified.
 *
 * @param nodes Array of DOM nodes.
 * @returns Collection of unique nodes, sorted in document order.
 */
function uniqueSort(nodes) {
    nodes = nodes.filter(function (node, i, arr) { return !arr.includes(node, i + 1); });
    nodes.sort(function (a, b) {
        var relative = compareDocumentPosition(a, b);
        if (relative & 2 /* PRECEDING */) {
            return -1;
        }
        else if (relative & 4 /* FOLLOWING */) {
            return 1;
        }
        return 0;
    });
    return nodes;
}
helpers$3.uniqueSort = uniqueSort;

var feeds = {};

Object.defineProperty(feeds, "__esModule", { value: true });
feeds.getFeed = void 0;
var stringify_1 = stringify$6;
var legacy_1 = legacy$1;
/**
 * Get the feed object from the root of a DOM tree.
 *
 * @param doc - The DOM to to extract the feed from.
 * @returns The feed.
 */
function getFeed(doc) {
    var feedRoot = getOneElement(isValidFeed, doc);
    return !feedRoot
        ? null
        : feedRoot.name === "feed"
            ? getAtomFeed(feedRoot)
            : getRssFeed(feedRoot);
}
feeds.getFeed = getFeed;
/**
 * Parse an Atom feed.
 *
 * @param feedRoot The root of the feed.
 * @returns The parsed feed.
 */
function getAtomFeed(feedRoot) {
    var _a;
    var childs = feedRoot.children;
    var feed = {
        type: "atom",
        items: (0, legacy_1.getElementsByTagName)("entry", childs).map(function (item) {
            var _a;
            var children = item.children;
            var entry = { media: getMediaElements(children) };
            addConditionally(entry, "id", "id", children);
            addConditionally(entry, "title", "title", children);
            var href = (_a = getOneElement("link", children)) === null || _a === void 0 ? void 0 : _a.attribs.href;
            if (href) {
                entry.link = href;
            }
            var description = fetch$1("summary", children) || fetch$1("content", children);
            if (description) {
                entry.description = description;
            }
            var pubDate = fetch$1("updated", children);
            if (pubDate) {
                entry.pubDate = new Date(pubDate);
            }
            return entry;
        }),
    };
    addConditionally(feed, "id", "id", childs);
    addConditionally(feed, "title", "title", childs);
    var href = (_a = getOneElement("link", childs)) === null || _a === void 0 ? void 0 : _a.attribs.href;
    if (href) {
        feed.link = href;
    }
    addConditionally(feed, "description", "subtitle", childs);
    var updated = fetch$1("updated", childs);
    if (updated) {
        feed.updated = new Date(updated);
    }
    addConditionally(feed, "author", "email", childs, true);
    return feed;
}
/**
 * Parse a RSS feed.
 *
 * @param feedRoot The root of the feed.
 * @returns The parsed feed.
 */
function getRssFeed(feedRoot) {
    var _a, _b;
    var childs = (_b = (_a = getOneElement("channel", feedRoot.children)) === null || _a === void 0 ? void 0 : _a.children) !== null && _b !== void 0 ? _b : [];
    var feed = {
        type: feedRoot.name.substr(0, 3),
        id: "",
        items: (0, legacy_1.getElementsByTagName)("item", feedRoot.children).map(function (item) {
            var children = item.children;
            var entry = { media: getMediaElements(children) };
            addConditionally(entry, "id", "guid", children);
            addConditionally(entry, "title", "title", children);
            addConditionally(entry, "link", "link", children);
            addConditionally(entry, "description", "description", children);
            var pubDate = fetch$1("pubDate", children);
            if (pubDate)
                entry.pubDate = new Date(pubDate);
            return entry;
        }),
    };
    addConditionally(feed, "title", "title", childs);
    addConditionally(feed, "link", "link", childs);
    addConditionally(feed, "description", "description", childs);
    var updated = fetch$1("lastBuildDate", childs);
    if (updated) {
        feed.updated = new Date(updated);
    }
    addConditionally(feed, "author", "managingEditor", childs, true);
    return feed;
}
var MEDIA_KEYS_STRING = ["url", "type", "lang"];
var MEDIA_KEYS_INT = [
    "fileSize",
    "bitrate",
    "framerate",
    "samplingrate",
    "channels",
    "duration",
    "height",
    "width",
];
/**
 * Get all media elements of a feed item.
 *
 * @param where Nodes to search in.
 * @returns Media elements.
 */
function getMediaElements(where) {
    return (0, legacy_1.getElementsByTagName)("media:content", where).map(function (elem) {
        var attribs = elem.attribs;
        var media = {
            medium: attribs.medium,
            isDefault: !!attribs.isDefault,
        };
        for (var _i = 0, MEDIA_KEYS_STRING_1 = MEDIA_KEYS_STRING; _i < MEDIA_KEYS_STRING_1.length; _i++) {
            var attrib = MEDIA_KEYS_STRING_1[_i];
            if (attribs[attrib]) {
                media[attrib] = attribs[attrib];
            }
        }
        for (var _a = 0, MEDIA_KEYS_INT_1 = MEDIA_KEYS_INT; _a < MEDIA_KEYS_INT_1.length; _a++) {
            var attrib = MEDIA_KEYS_INT_1[_a];
            if (attribs[attrib]) {
                media[attrib] = parseInt(attribs[attrib], 10);
            }
        }
        if (attribs.expression) {
            media.expression =
                attribs.expression;
        }
        return media;
    });
}
/**
 * Get one element by tag name.
 *
 * @param tagName Tag name to look for
 * @param node Node to search in
 * @returns The element or null
 */
function getOneElement(tagName, node) {
    return (0, legacy_1.getElementsByTagName)(tagName, node, true, 1)[0];
}
/**
 * Get the text content of an element with a certain tag name.
 *
 * @param tagName Tag name to look for.
 * @param where  Node to search in.
 * @param recurse Whether to recurse into child nodes.
 * @returns The text content of the element.
 */
function fetch$1(tagName, where, recurse) {
    if (recurse === void 0) { recurse = false; }
    return (0, stringify_1.textContent)((0, legacy_1.getElementsByTagName)(tagName, where, recurse, 1)).trim();
}
/**
 * Adds a property to an object if it has a value.
 *
 * @param obj Object to be extended
 * @param prop Property name
 * @param tagName Tag name that contains the conditionally added property
 * @param where Element to search for the property
 * @param recurse Whether to recurse into child nodes.
 */
function addConditionally(obj, prop, tagName, where, recurse) {
    if (recurse === void 0) { recurse = false; }
    var val = fetch$1(tagName, where, recurse);
    if (val)
        obj[prop] = val;
}
/**
 * Checks if an element is a feed root node.
 *
 * @param value The name of the element to check.
 * @returns Whether an element is a feed root node.
 */
function isValidFeed(value) {
    return value === "rss" || value === "feed" || value === "rdf:RDF";
}

(function (exports) {
	var __createBinding = (commonjsGlobal && commonjsGlobal.__createBinding) || (Object.create ? (function(o, m, k, k2) {
	    if (k2 === undefined) k2 = k;
	    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
	}) : (function(o, m, k, k2) {
	    if (k2 === undefined) k2 = k;
	    o[k2] = m[k];
	}));
	var __exportStar = (commonjsGlobal && commonjsGlobal.__exportStar) || function(m, exports) {
	    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
	};
	Object.defineProperty(exports, "__esModule", { value: true });
	exports.hasChildren = exports.isDocument = exports.isComment = exports.isText = exports.isCDATA = exports.isTag = void 0;
	__exportStar(stringify$6, exports);
	__exportStar(traversal, exports);
	__exportStar(manipulation, exports);
	__exportStar(querying, exports);
	__exportStar(legacy$1, exports);
	__exportStar(helpers$3, exports);
	__exportStar(feeds, exports);
	/** @deprecated Use these methods from `domhandler` directly. */
	var domhandler_1 = lib$q;
	Object.defineProperty(exports, "isTag", { enumerable: true, get: function () { return domhandler_1.isTag; } });
	Object.defineProperty(exports, "isCDATA", { enumerable: true, get: function () { return domhandler_1.isCDATA; } });
	Object.defineProperty(exports, "isText", { enumerable: true, get: function () { return domhandler_1.isText; } });
	Object.defineProperty(exports, "isComment", { enumerable: true, get: function () { return domhandler_1.isComment; } });
	Object.defineProperty(exports, "isDocument", { enumerable: true, get: function () { return domhandler_1.isDocument; } });
	Object.defineProperty(exports, "hasChildren", { enumerable: true, get: function () { return domhandler_1.hasChildren; } }); 
} (lib$r));

var compile$5 = {};

var require$$0$5 = /*@__PURE__*/getAugmentedNamespace(es);

var sort = {};

var procedure = {};

(function (exports) {
	Object.defineProperty(exports, "__esModule", { value: true });
	exports.isTraversal = exports.procedure = void 0;
	exports.procedure = {
	    universal: 50,
	    tag: 30,
	    attribute: 1,
	    pseudo: 0,
	    "pseudo-element": 0,
	    "column-combinator": -1,
	    descendant: -1,
	    child: -1,
	    parent: -1,
	    sibling: -1,
	    adjacent: -1,
	    _flexibleDescendant: -1,
	};
	function isTraversal(t) {
	    return exports.procedure[t.type] < 0;
	}
	exports.isTraversal = isTraversal; 
} (procedure));

Object.defineProperty(sort, "__esModule", { value: true });
var css_what_1$2 = require$$0$5;
var procedure_1$1 = procedure;
var attributes$1 = {
    exists: 10,
    equals: 8,
    not: 7,
    start: 6,
    end: 6,
    any: 5,
    hyphen: 4,
    element: 4,
};
/**
 * Sort the parts of the passed selector,
 * as there is potential for optimization
 * (some types of selectors are faster than others)
 *
 * @param arr Selector to sort
 */
function sortByProcedure(arr) {
    var procs = arr.map(getProcedure);
    for (var i = 1; i < arr.length; i++) {
        var procNew = procs[i];
        if (procNew < 0)
            continue;
        for (var j = i - 1; j >= 0 && procNew < procs[j]; j--) {
            var token = arr[j + 1];
            arr[j + 1] = arr[j];
            arr[j] = token;
            procs[j + 1] = procs[j];
            procs[j] = procNew;
        }
    }
}
sort.default = sortByProcedure;
function getProcedure(token) {
    var proc = procedure_1$1.procedure[token.type];
    if (token.type === css_what_1$2.SelectorType.Attribute) {
        proc = attributes$1[token.action];
        if (proc === attributes$1.equals && token.name === "id") {
            // Prefer ID selectors (eg. #ID)
            proc = 9;
        }
        if (token.ignoreCase) {
            /*
             * IgnoreCase adds some overhead, prefer "normal" token
             * this is a binary operation, to ensure it's still an int
             */
            proc >>= 1;
        }
    }
    else if (token.type === css_what_1$2.SelectorType.Pseudo) {
        if (!token.data) {
            proc = 3;
        }
        else if (token.name === "has" || token.name === "contains") {
            proc = 0; // Expensive in any case
        }
        else if (Array.isArray(token.data)) {
            // "matches" and "not"
            proc = 0;
            for (var i = 0; i < token.data.length; i++) {
                // TODO better handling of complex selectors
                if (token.data[i].length !== 1)
                    continue;
                var cur = getProcedure(token.data[i][0]);
                // Avoid executing :has or :contains
                if (cur === 0) {
                    proc = 0;
                    break;
                }
                if (cur > proc)
                    proc = cur;
            }
            if (token.data.length > 1 && proc > 0)
                proc -= 1;
        }
        else {
            proc = 1;
        }
    }
    return proc;
}

var general = {};

var attributes = {};

Object.defineProperty(attributes, "__esModule", { value: true });
attributes.attributeRules = void 0;
var boolbase_1$2 = boolbase;
/**
 * All reserved characters in a regex, used for escaping.
 *
 * Taken from XRegExp, (c) 2007-2020 Steven Levithan under the MIT license
 * https://github.com/slevithan/xregexp/blob/95eeebeb8fac8754d54eafe2b4743661ac1cf028/src/xregexp.js#L794
 */
var reChars = /[-[\]{}()*+?.,\\^$|#\s]/g;
function escapeRegex(value) {
    return value.replace(reChars, "\\$&");
}
/**
 * Attributes that are case-insensitive in HTML.
 *
 * @private
 * @see https://html.spec.whatwg.org/multipage/semantics-other.html#case-sensitivity-of-selectors
 */
var caseInsensitiveAttributes = new Set([
    "accept",
    "accept-charset",
    "align",
    "alink",
    "axis",
    "bgcolor",
    "charset",
    "checked",
    "clear",
    "codetype",
    "color",
    "compact",
    "declare",
    "defer",
    "dir",
    "direction",
    "disabled",
    "enctype",
    "face",
    "frame",
    "hreflang",
    "http-equiv",
    "lang",
    "language",
    "link",
    "media",
    "method",
    "multiple",
    "nohref",
    "noresize",
    "noshade",
    "nowrap",
    "readonly",
    "rel",
    "rev",
    "rules",
    "scope",
    "scrolling",
    "selected",
    "shape",
    "target",
    "text",
    "type",
    "valign",
    "valuetype",
    "vlink",
]);
function shouldIgnoreCase(selector, options) {
    return typeof selector.ignoreCase === "boolean"
        ? selector.ignoreCase
        : selector.ignoreCase === "quirks"
            ? !!options.quirksMode
            : !options.xmlMode && caseInsensitiveAttributes.has(selector.name);
}
/**
 * Attribute selectors
 */
attributes.attributeRules = {
    equals: function (next, data, options) {
        var adapter = options.adapter;
        var name = data.name;
        var value = data.value;
        if (shouldIgnoreCase(data, options)) {
            value = value.toLowerCase();
            return function (elem) {
                var attr = adapter.getAttributeValue(elem, name);
                return (attr != null &&
                    attr.length === value.length &&
                    attr.toLowerCase() === value &&
                    next(elem));
            };
        }
        return function (elem) {
            return adapter.getAttributeValue(elem, name) === value && next(elem);
        };
    },
    hyphen: function (next, data, options) {
        var adapter = options.adapter;
        var name = data.name;
        var value = data.value;
        var len = value.length;
        if (shouldIgnoreCase(data, options)) {
            value = value.toLowerCase();
            return function hyphenIC(elem) {
                var attr = adapter.getAttributeValue(elem, name);
                return (attr != null &&
                    (attr.length === len || attr.charAt(len) === "-") &&
                    attr.substr(0, len).toLowerCase() === value &&
                    next(elem));
            };
        }
        return function hyphen(elem) {
            var attr = adapter.getAttributeValue(elem, name);
            return (attr != null &&
                (attr.length === len || attr.charAt(len) === "-") &&
                attr.substr(0, len) === value &&
                next(elem));
        };
    },
    element: function (next, data, options) {
        var adapter = options.adapter;
        var name = data.name, value = data.value;
        if (/\s/.test(value)) {
            return boolbase_1$2.falseFunc;
        }
        var regex = new RegExp("(?:^|\\s)".concat(escapeRegex(value), "(?:$|\\s)"), shouldIgnoreCase(data, options) ? "i" : "");
        return function element(elem) {
            var attr = adapter.getAttributeValue(elem, name);
            return (attr != null &&
                attr.length >= value.length &&
                regex.test(attr) &&
                next(elem));
        };
    },
    exists: function (next, _a, _b) {
        var name = _a.name;
        var adapter = _b.adapter;
        return function (elem) { return adapter.hasAttrib(elem, name) && next(elem); };
    },
    start: function (next, data, options) {
        var adapter = options.adapter;
        var name = data.name;
        var value = data.value;
        var len = value.length;
        if (len === 0) {
            return boolbase_1$2.falseFunc;
        }
        if (shouldIgnoreCase(data, options)) {
            value = value.toLowerCase();
            return function (elem) {
                var attr = adapter.getAttributeValue(elem, name);
                return (attr != null &&
                    attr.length >= len &&
                    attr.substr(0, len).toLowerCase() === value &&
                    next(elem));
            };
        }
        return function (elem) {
            var _a;
            return !!((_a = adapter.getAttributeValue(elem, name)) === null || _a === void 0 ? void 0 : _a.startsWith(value)) &&
                next(elem);
        };
    },
    end: function (next, data, options) {
        var adapter = options.adapter;
        var name = data.name;
        var value = data.value;
        var len = -value.length;
        if (len === 0) {
            return boolbase_1$2.falseFunc;
        }
        if (shouldIgnoreCase(data, options)) {
            value = value.toLowerCase();
            return function (elem) {
                var _a;
                return ((_a = adapter
                    .getAttributeValue(elem, name)) === null || _a === void 0 ? void 0 : _a.substr(len).toLowerCase()) === value && next(elem);
            };
        }
        return function (elem) {
            var _a;
            return !!((_a = adapter.getAttributeValue(elem, name)) === null || _a === void 0 ? void 0 : _a.endsWith(value)) &&
                next(elem);
        };
    },
    any: function (next, data, options) {
        var adapter = options.adapter;
        var name = data.name, value = data.value;
        if (value === "") {
            return boolbase_1$2.falseFunc;
        }
        if (shouldIgnoreCase(data, options)) {
            var regex_1 = new RegExp(escapeRegex(value), "i");
            return function anyIC(elem) {
                var attr = adapter.getAttributeValue(elem, name);
                return (attr != null &&
                    attr.length >= value.length &&
                    regex_1.test(attr) &&
                    next(elem));
            };
        }
        return function (elem) {
            var _a;
            return !!((_a = adapter.getAttributeValue(elem, name)) === null || _a === void 0 ? void 0 : _a.includes(value)) &&
                next(elem);
        };
    },
    not: function (next, data, options) {
        var adapter = options.adapter;
        var name = data.name;
        var value = data.value;
        if (value === "") {
            return function (elem) {
                return !!adapter.getAttributeValue(elem, name) && next(elem);
            };
        }
        else if (shouldIgnoreCase(data, options)) {
            value = value.toLowerCase();
            return function (elem) {
                var attr = adapter.getAttributeValue(elem, name);
                return ((attr == null ||
                    attr.length !== value.length ||
                    attr.toLowerCase() !== value) &&
                    next(elem));
            };
        }
        return function (elem) {
            return adapter.getAttributeValue(elem, name) !== value && next(elem);
        };
    },
};

var pseudoSelectors = {};

var filters = {};

var lib$m = {};

var parse$c = {};

// Following http://www.w3.org/TR/css3-selectors/#nth-child-pseudo
Object.defineProperty(parse$c, "__esModule", { value: true });
parse$c.parse = void 0;
// Whitespace as per https://www.w3.org/TR/selectors-3/#lex is " \t\r\n\f"
var whitespace$2 = new Set([9, 10, 12, 13, 32]);
var ZERO = "0".charCodeAt(0);
var NINE = "9".charCodeAt(0);
/**
 * Parses an expression.
 *
 * @throws An `Error` if parsing fails.
 * @returns An array containing the integer step size and the integer offset of the nth rule.
 * @example nthCheck.parse("2n+3"); // returns [2, 3]
 */
function parse$b(formula) {
    formula = formula.trim().toLowerCase();
    if (formula === "even") {
        return [2, 0];
    }
    else if (formula === "odd") {
        return [2, 1];
    }
    // Parse [ ['-'|'+']? INTEGER? {N} [ S* ['-'|'+'] S* INTEGER ]?
    var idx = 0;
    var a = 0;
    var sign = readSign();
    var number = readNumber();
    if (idx < formula.length && formula.charAt(idx) === "n") {
        idx++;
        a = sign * (number !== null && number !== void 0 ? number : 1);
        skipWhitespace();
        if (idx < formula.length) {
            sign = readSign();
            skipWhitespace();
            number = readNumber();
        }
        else {
            sign = number = 0;
        }
    }
    // Throw if there is anything else
    if (number === null || idx < formula.length) {
        throw new Error("n-th rule couldn't be parsed ('".concat(formula, "')"));
    }
    return [a, sign * number];
    function readSign() {
        if (formula.charAt(idx) === "-") {
            idx++;
            return -1;
        }
        if (formula.charAt(idx) === "+") {
            idx++;
        }
        return 1;
    }
    function readNumber() {
        var start = idx;
        var value = 0;
        while (idx < formula.length &&
            formula.charCodeAt(idx) >= ZERO &&
            formula.charCodeAt(idx) <= NINE) {
            value = value * 10 + (formula.charCodeAt(idx) - ZERO);
            idx++;
        }
        // Return `null` if we didn't read anything.
        return idx === start ? null : value;
    }
    function skipWhitespace() {
        while (idx < formula.length &&
            whitespace$2.has(formula.charCodeAt(idx))) {
            idx++;
        }
    }
}
parse$c.parse = parse$b;

var compile$4 = {};

var __importDefault$5 = (commonjsGlobal && commonjsGlobal.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(compile$4, "__esModule", { value: true });
compile$4.generate = compile$4.compile = void 0;
var boolbase_1$1 = __importDefault$5(boolbase);
/**
 * Returns a function that checks if an elements index matches the given rule
 * highly optimized to return the fastest solution.
 *
 * @param parsed A tuple [a, b], as returned by `parse`.
 * @returns A highly optimized function that returns whether an index matches the nth-check.
 * @example
 *
 * ```js
 * const check = nthCheck.compile([2, 3]);
 *
 * check(0); // `false`
 * check(1); // `false`
 * check(2); // `true`
 * check(3); // `false`
 * check(4); // `true`
 * check(5); // `false`
 * check(6); // `true`
 * ```
 */
function compile$3(parsed) {
    var a = parsed[0];
    // Subtract 1 from `b`, to convert from one- to zero-indexed.
    var b = parsed[1] - 1;
    /*
     * When `b <= 0`, `a * n` won't be lead to any matches for `a < 0`.
     * Besides, the specification states that no elements are
     * matched when `a` and `b` are 0.
     *
     * `b < 0` here as we subtracted 1 from `b` above.
     */
    if (b < 0 && a <= 0)
        return boolbase_1$1.default.falseFunc;
    // When `a` is in the range -1..1, it matches any element (so only `b` is checked).
    if (a === -1)
        return function (index) { return index <= b; };
    if (a === 0)
        return function (index) { return index === b; };
    // When `b <= 0` and `a === 1`, they match any element.
    if (a === 1)
        return b < 0 ? boolbase_1$1.default.trueFunc : function (index) { return index >= b; };
    /*
     * Otherwise, modulo can be used to check if there is a match.
     *
     * Modulo doesn't care about the sign, so let's use `a`s absolute value.
     */
    var absA = Math.abs(a);
    // Get `b mod a`, + a if this is negative.
    var bMod = ((b % absA) + absA) % absA;
    return a > 1
        ? function (index) { return index >= b && index % absA === bMod; }
        : function (index) { return index <= b && index % absA === bMod; };
}
compile$4.compile = compile$3;
/**
 * Returns a function that produces a monotonously increasing sequence of indices.
 *
 * If the sequence has an end, the returned function will return `null` after
 * the last index in the sequence.
 *
 * @param parsed A tuple [a, b], as returned by `parse`.
 * @returns A function that produces a sequence of indices.
 * @example <caption>Always increasing (2n+3)</caption>
 *
 * ```js
 * const gen = nthCheck.generate([2, 3])
 *
 * gen() // `1`
 * gen() // `3`
 * gen() // `5`
 * gen() // `8`
 * gen() // `11`
 * ```
 *
 * @example <caption>With end value (-2n+10)</caption>
 *
 * ```js
 *
 * const gen = nthCheck.generate([-2, 5]);
 *
 * gen() // 0
 * gen() // 2
 * gen() // 4
 * gen() // null
 * ```
 */
function generate$2(parsed) {
    var a = parsed[0];
    // Subtract 1 from `b`, to convert from one- to zero-indexed.
    var b = parsed[1] - 1;
    var n = 0;
    // Make sure to always return an increasing sequence
    if (a < 0) {
        var aPos_1 = -a;
        // Get `b mod a`
        var minValue_1 = ((b % aPos_1) + aPos_1) % aPos_1;
        return function () {
            var val = minValue_1 + aPos_1 * n++;
            return val > b ? null : val;
        };
    }
    if (a === 0)
        return b < 0
            ? // There are no result — always return `null`
                function () { return null; }
            : // Return `b` exactly once
                function () { return (n++ === 0 ? b : null); };
    if (b < 0) {
        b += a * Math.ceil(-b / a);
    }
    return function () { return a * n++ + b; };
}
compile$4.generate = generate$2;

(function (exports) {
	Object.defineProperty(exports, "__esModule", { value: true });
	exports.sequence = exports.generate = exports.compile = exports.parse = void 0;
	var parse_js_1 = parse$c;
	Object.defineProperty(exports, "parse", { enumerable: true, get: function () { return parse_js_1.parse; } });
	var compile_js_1 = compile$4;
	Object.defineProperty(exports, "compile", { enumerable: true, get: function () { return compile_js_1.compile; } });
	Object.defineProperty(exports, "generate", { enumerable: true, get: function () { return compile_js_1.generate; } });
	/**
	 * Parses and compiles a formula to a highly optimized function.
	 * Combination of {@link parse} and {@link compile}.
	 *
	 * If the formula doesn't match any elements,
	 * it returns [`boolbase`](https://github.com/fb55/boolbase)'s `falseFunc`.
	 * Otherwise, a function accepting an _index_ is returned, which returns
	 * whether or not the passed _index_ matches the formula.
	 *
	 * Note: The nth-rule starts counting at `1`, the returned function at `0`.
	 *
	 * @param formula The formula to compile.
	 * @example
	 * const check = nthCheck("2n+3");
	 *
	 * check(0); // `false`
	 * check(1); // `false`
	 * check(2); // `true`
	 * check(3); // `false`
	 * check(4); // `true`
	 * check(5); // `false`
	 * check(6); // `true`
	 */
	function nthCheck(formula) {
	    return (0, compile_js_1.compile)((0, parse_js_1.parse)(formula));
	}
	exports.default = nthCheck;
	/**
	 * Parses and compiles a formula to a generator that produces a sequence of indices.
	 * Combination of {@link parse} and {@link generate}.
	 *
	 * @param formula The formula to compile.
	 * @returns A function that produces a sequence of indices.
	 * @example <caption>Always increasing</caption>
	 *
	 * ```js
	 * const gen = nthCheck.sequence('2n+3')
	 *
	 * gen() // `1`
	 * gen() // `3`
	 * gen() // `5`
	 * gen() // `8`
	 * gen() // `11`
	 * ```
	 *
	 * @example <caption>With end value</caption>
	 *
	 * ```js
	 *
	 * const gen = nthCheck.sequence('-2n+5');
	 *
	 * gen() // 0
	 * gen() // 2
	 * gen() // 4
	 * gen() // null
	 * ```
	 */
	function sequence(formula) {
	    return (0, compile_js_1.generate)((0, parse_js_1.parse)(formula));
	}
	exports.sequence = sequence;
	
} (lib$m));

(function (exports) {
	var __importDefault = (commonjsGlobal && commonjsGlobal.__importDefault) || function (mod) {
	    return (mod && mod.__esModule) ? mod : { "default": mod };
	};
	Object.defineProperty(exports, "__esModule", { value: true });
	exports.filters = void 0;
	var nth_check_1 = __importDefault(lib$m);
	var boolbase_1 = boolbase;
	function getChildFunc(next, adapter) {
	    return function (elem) {
	        var parent = adapter.getParent(elem);
	        return parent != null && adapter.isTag(parent) && next(elem);
	    };
	}
	exports.filters = {
	    contains: function (next, text, _a) {
	        var adapter = _a.adapter;
	        return function contains(elem) {
	            return next(elem) && adapter.getText(elem).includes(text);
	        };
	    },
	    icontains: function (next, text, _a) {
	        var adapter = _a.adapter;
	        var itext = text.toLowerCase();
	        return function icontains(elem) {
	            return (next(elem) &&
	                adapter.getText(elem).toLowerCase().includes(itext));
	        };
	    },
	    // Location specific methods
	    "nth-child": function (next, rule, _a) {
	        var adapter = _a.adapter, equals = _a.equals;
	        var func = (0, nth_check_1.default)(rule);
	        if (func === boolbase_1.falseFunc)
	            return boolbase_1.falseFunc;
	        if (func === boolbase_1.trueFunc)
	            return getChildFunc(next, adapter);
	        return function nthChild(elem) {
	            var siblings = adapter.getSiblings(elem);
	            var pos = 0;
	            for (var i = 0; i < siblings.length; i++) {
	                if (equals(elem, siblings[i]))
	                    break;
	                if (adapter.isTag(siblings[i])) {
	                    pos++;
	                }
	            }
	            return func(pos) && next(elem);
	        };
	    },
	    "nth-last-child": function (next, rule, _a) {
	        var adapter = _a.adapter, equals = _a.equals;
	        var func = (0, nth_check_1.default)(rule);
	        if (func === boolbase_1.falseFunc)
	            return boolbase_1.falseFunc;
	        if (func === boolbase_1.trueFunc)
	            return getChildFunc(next, adapter);
	        return function nthLastChild(elem) {
	            var siblings = adapter.getSiblings(elem);
	            var pos = 0;
	            for (var i = siblings.length - 1; i >= 0; i--) {
	                if (equals(elem, siblings[i]))
	                    break;
	                if (adapter.isTag(siblings[i])) {
	                    pos++;
	                }
	            }
	            return func(pos) && next(elem);
	        };
	    },
	    "nth-of-type": function (next, rule, _a) {
	        var adapter = _a.adapter, equals = _a.equals;
	        var func = (0, nth_check_1.default)(rule);
	        if (func === boolbase_1.falseFunc)
	            return boolbase_1.falseFunc;
	        if (func === boolbase_1.trueFunc)
	            return getChildFunc(next, adapter);
	        return function nthOfType(elem) {
	            var siblings = adapter.getSiblings(elem);
	            var pos = 0;
	            for (var i = 0; i < siblings.length; i++) {
	                var currentSibling = siblings[i];
	                if (equals(elem, currentSibling))
	                    break;
	                if (adapter.isTag(currentSibling) &&
	                    adapter.getName(currentSibling) === adapter.getName(elem)) {
	                    pos++;
	                }
	            }
	            return func(pos) && next(elem);
	        };
	    },
	    "nth-last-of-type": function (next, rule, _a) {
	        var adapter = _a.adapter, equals = _a.equals;
	        var func = (0, nth_check_1.default)(rule);
	        if (func === boolbase_1.falseFunc)
	            return boolbase_1.falseFunc;
	        if (func === boolbase_1.trueFunc)
	            return getChildFunc(next, adapter);
	        return function nthLastOfType(elem) {
	            var siblings = adapter.getSiblings(elem);
	            var pos = 0;
	            for (var i = siblings.length - 1; i >= 0; i--) {
	                var currentSibling = siblings[i];
	                if (equals(elem, currentSibling))
	                    break;
	                if (adapter.isTag(currentSibling) &&
	                    adapter.getName(currentSibling) === adapter.getName(elem)) {
	                    pos++;
	                }
	            }
	            return func(pos) && next(elem);
	        };
	    },
	    // TODO determine the actual root element
	    root: function (next, _rule, _a) {
	        var adapter = _a.adapter;
	        return function (elem) {
	            var parent = adapter.getParent(elem);
	            return (parent == null || !adapter.isTag(parent)) && next(elem);
	        };
	    },
	    scope: function (next, rule, options, context) {
	        var equals = options.equals;
	        if (!context || context.length === 0) {
	            // Equivalent to :root
	            return exports.filters.root(next, rule, options);
	        }
	        if (context.length === 1) {
	            // NOTE: can't be unpacked, as :has uses this for side-effects
	            return function (elem) { return equals(context[0], elem) && next(elem); };
	        }
	        return function (elem) { return context.includes(elem) && next(elem); };
	    },
	    hover: dynamicStatePseudo("isHovered"),
	    visited: dynamicStatePseudo("isVisited"),
	    active: dynamicStatePseudo("isActive"),
	};
	/**
	 * Dynamic state pseudos. These depend on optional Adapter methods.
	 *
	 * @param name The name of the adapter method to call.
	 * @returns Pseudo for the `filters` object.
	 */
	function dynamicStatePseudo(name) {
	    return function dynamicPseudo(next, _rule, _a) {
	        var adapter = _a.adapter;
	        var func = adapter[name];
	        if (typeof func !== "function") {
	            return boolbase_1.falseFunc;
	        }
	        return function active(elem) {
	            return func(elem) && next(elem);
	        };
	    };
	} 
} (filters));

var pseudos = {};

Object.defineProperty(pseudos, "__esModule", { value: true });
pseudos.verifyPseudoArgs = pseudos.pseudos = void 0;
// While filters are precompiled, pseudos get called when they are needed
pseudos.pseudos = {
    empty: function (elem, _a) {
        var adapter = _a.adapter;
        return !adapter.getChildren(elem).some(function (elem) {
            // FIXME: `getText` call is potentially expensive.
            return adapter.isTag(elem) || adapter.getText(elem) !== "";
        });
    },
    "first-child": function (elem, _a) {
        var adapter = _a.adapter, equals = _a.equals;
        var firstChild = adapter
            .getSiblings(elem)
            .find(function (elem) { return adapter.isTag(elem); });
        return firstChild != null && equals(elem, firstChild);
    },
    "last-child": function (elem, _a) {
        var adapter = _a.adapter, equals = _a.equals;
        var siblings = adapter.getSiblings(elem);
        for (var i = siblings.length - 1; i >= 0; i--) {
            if (equals(elem, siblings[i]))
                return true;
            if (adapter.isTag(siblings[i]))
                break;
        }
        return false;
    },
    "first-of-type": function (elem, _a) {
        var adapter = _a.adapter, equals = _a.equals;
        var siblings = adapter.getSiblings(elem);
        var elemName = adapter.getName(elem);
        for (var i = 0; i < siblings.length; i++) {
            var currentSibling = siblings[i];
            if (equals(elem, currentSibling))
                return true;
            if (adapter.isTag(currentSibling) &&
                adapter.getName(currentSibling) === elemName) {
                break;
            }
        }
        return false;
    },
    "last-of-type": function (elem, _a) {
        var adapter = _a.adapter, equals = _a.equals;
        var siblings = adapter.getSiblings(elem);
        var elemName = adapter.getName(elem);
        for (var i = siblings.length - 1; i >= 0; i--) {
            var currentSibling = siblings[i];
            if (equals(elem, currentSibling))
                return true;
            if (adapter.isTag(currentSibling) &&
                adapter.getName(currentSibling) === elemName) {
                break;
            }
        }
        return false;
    },
    "only-of-type": function (elem, _a) {
        var adapter = _a.adapter, equals = _a.equals;
        var elemName = adapter.getName(elem);
        return adapter
            .getSiblings(elem)
            .every(function (sibling) {
            return equals(elem, sibling) ||
                !adapter.isTag(sibling) ||
                adapter.getName(sibling) !== elemName;
        });
    },
    "only-child": function (elem, _a) {
        var adapter = _a.adapter, equals = _a.equals;
        return adapter
            .getSiblings(elem)
            .every(function (sibling) { return equals(elem, sibling) || !adapter.isTag(sibling); });
    },
};
function verifyPseudoArgs(func, name, subselect) {
    if (subselect === null) {
        if (func.length > 2) {
            throw new Error("pseudo-selector :".concat(name, " requires an argument"));
        }
    }
    else if (func.length === 2) {
        throw new Error("pseudo-selector :".concat(name, " doesn't have any arguments"));
    }
}
pseudos.verifyPseudoArgs = verifyPseudoArgs;

var aliases = {};

Object.defineProperty(aliases, "__esModule", { value: true });
aliases.aliases = void 0;
/**
 * Aliases are pseudos that are expressed as selectors.
 */
aliases.aliases = {
    // Links
    "any-link": ":is(a, area, link)[href]",
    link: ":any-link:not(:visited)",
    // Forms
    // https://html.spec.whatwg.org/multipage/scripting.html#disabled-elements
    disabled: ":is(\n        :is(button, input, select, textarea, optgroup, option)[disabled],\n        optgroup[disabled] > option,\n        fieldset[disabled]:not(fieldset[disabled] legend:first-of-type *)\n    )",
    enabled: ":not(:disabled)",
    checked: ":is(:is(input[type=radio], input[type=checkbox])[checked], option:selected)",
    required: ":is(input, select, textarea)[required]",
    optional: ":is(input, select, textarea):not([required])",
    // JQuery extensions
    // https://html.spec.whatwg.org/multipage/form-elements.html#concept-option-selectedness
    selected: "option:is([selected], select:not([multiple]):not(:has(> option[selected])) > :first-of-type)",
    checkbox: "[type=checkbox]",
    file: "[type=file]",
    password: "[type=password]",
    radio: "[type=radio]",
    reset: "[type=reset]",
    image: "[type=image]",
    submit: "[type=submit]",
    parent: ":not(:empty)",
    header: ":is(h1, h2, h3, h4, h5, h6)",
    button: ":is(button, input[type=button])",
    input: ":is(input, textarea, select, button)",
    text: "input:is(:not([type!='']), [type=text])",
};

var subselects = {};

(function (exports) {
	var __spreadArray = (commonjsGlobal && commonjsGlobal.__spreadArray) || function (to, from, pack) {
	    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
	        if (ar || !(i in from)) {
	            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
	            ar[i] = from[i];
	        }
	    }
	    return to.concat(ar || Array.prototype.slice.call(from));
	};
	Object.defineProperty(exports, "__esModule", { value: true });
	exports.subselects = exports.getNextSiblings = exports.ensureIsTag = exports.PLACEHOLDER_ELEMENT = void 0;
	var boolbase_1 = boolbase;
	var procedure_1 = procedure;
	/** Used as a placeholder for :has. Will be replaced with the actual element. */
	exports.PLACEHOLDER_ELEMENT = {};
	function ensureIsTag(next, adapter) {
	    if (next === boolbase_1.falseFunc)
	        return boolbase_1.falseFunc;
	    return function (elem) { return adapter.isTag(elem) && next(elem); };
	}
	exports.ensureIsTag = ensureIsTag;
	function getNextSiblings(elem, adapter) {
	    var siblings = adapter.getSiblings(elem);
	    if (siblings.length <= 1)
	        return [];
	    var elemIndex = siblings.indexOf(elem);
	    if (elemIndex < 0 || elemIndex === siblings.length - 1)
	        return [];
	    return siblings.slice(elemIndex + 1).filter(adapter.isTag);
	}
	exports.getNextSiblings = getNextSiblings;
	var is = function (next, token, options, context, compileToken) {
	    var opts = {
	        xmlMode: !!options.xmlMode,
	        adapter: options.adapter,
	        equals: options.equals,
	    };
	    var func = compileToken(token, opts, context);
	    return function (elem) { return func(elem) && next(elem); };
	};
	/*
	 * :not, :has, :is, :matches and :where have to compile selectors
	 * doing this in src/pseudos.ts would lead to circular dependencies,
	 * so we add them here
	 */
	exports.subselects = {
	    is: is,
	    /**
	     * `:matches` and `:where` are aliases for `:is`.
	     */
	    matches: is,
	    where: is,
	    not: function (next, token, options, context, compileToken) {
	        var opts = {
	            xmlMode: !!options.xmlMode,
	            adapter: options.adapter,
	            equals: options.equals,
	        };
	        var func = compileToken(token, opts, context);
	        if (func === boolbase_1.falseFunc)
	            return next;
	        if (func === boolbase_1.trueFunc)
	            return boolbase_1.falseFunc;
	        return function not(elem) {
	            return !func(elem) && next(elem);
	        };
	    },
	    has: function (next, subselect, options, _context, compileToken) {
	        var adapter = options.adapter;
	        var opts = {
	            xmlMode: !!options.xmlMode,
	            adapter: adapter,
	            equals: options.equals,
	        };
	        // @ts-expect-error Uses an array as a pointer to the current element (side effects)
	        var context = subselect.some(function (s) {
	            return s.some(procedure_1.isTraversal);
	        })
	            ? [exports.PLACEHOLDER_ELEMENT]
	            : undefined;
	        var compiled = compileToken(subselect, opts, context);
	        if (compiled === boolbase_1.falseFunc)
	            return boolbase_1.falseFunc;
	        if (compiled === boolbase_1.trueFunc) {
	            return function (elem) {
	                return adapter.getChildren(elem).some(adapter.isTag) && next(elem);
	            };
	        }
	        var hasElement = ensureIsTag(compiled, adapter);
	        var _a = compiled.shouldTestNextSiblings, shouldTestNextSiblings = _a === void 0 ? false : _a;
	        /*
	         * `shouldTestNextSiblings` will only be true if the query starts with
	         * a traversal (sibling or adjacent). That means we will always have a context.
	         */
	        if (context) {
	            return function (elem) {
	                context[0] = elem;
	                var childs = adapter.getChildren(elem);
	                var nextElements = shouldTestNextSiblings
	                    ? __spreadArray(__spreadArray([], childs, true), getNextSiblings(elem, adapter), true) : childs;
	                return (next(elem) && adapter.existsOne(hasElement, nextElements));
	            };
	        }
	        return function (elem) {
	            return next(elem) &&
	                adapter.existsOne(hasElement, adapter.getChildren(elem));
	        };
	    },
	}; 
} (subselects));

(function (exports) {
	Object.defineProperty(exports, "__esModule", { value: true });
	exports.compilePseudoSelector = exports.aliases = exports.pseudos = exports.filters = void 0;
	/*
	 * Pseudo selectors
	 *
	 * Pseudo selectors are available in three forms:
	 *
	 * 1. Filters are called when the selector is compiled and return a function
	 *  that has to return either false, or the results of `next()`.
	 * 2. Pseudos are called on execution. They have to return a boolean.
	 * 3. Subselects work like filters, but have an embedded selector that will be run separately.
	 *
	 * Filters are great if you want to do some pre-processing, or change the call order
	 * of `next()` and your code.
	 * Pseudos should be used to implement simple checks.
	 */
	var boolbase_1 = boolbase;
	var css_what_1 = require$$0$5;
	var filters_1 = filters;
	Object.defineProperty(exports, "filters", { enumerable: true, get: function () { return filters_1.filters; } });
	var pseudos_1 = pseudos;
	Object.defineProperty(exports, "pseudos", { enumerable: true, get: function () { return pseudos_1.pseudos; } });
	var aliases_1 = aliases;
	Object.defineProperty(exports, "aliases", { enumerable: true, get: function () { return aliases_1.aliases; } });
	var subselects_1 = subselects;
	function compilePseudoSelector(next, selector, options, context, compileToken) {
	    var name = selector.name, data = selector.data;
	    if (Array.isArray(data)) {
	        return subselects_1.subselects[name](next, data, options, context, compileToken);
	    }
	    if (name in aliases_1.aliases) {
	        if (data != null) {
	            throw new Error("Pseudo ".concat(name, " doesn't have any arguments"));
	        }
	        // The alias has to be parsed here, to make sure options are respected.
	        var alias = (0, css_what_1.parse)(aliases_1.aliases[name]);
	        return subselects_1.subselects.is(next, alias, options, context, compileToken);
	    }
	    if (name in filters_1.filters) {
	        return filters_1.filters[name](next, data, options, context);
	    }
	    if (name in pseudos_1.pseudos) {
	        var pseudo_1 = pseudos_1.pseudos[name];
	        (0, pseudos_1.verifyPseudoArgs)(pseudo_1, name, data);
	        return pseudo_1 === boolbase_1.falseFunc
	            ? boolbase_1.falseFunc
	            : next === boolbase_1.trueFunc
	                ? function (elem) { return pseudo_1(elem, options, data); }
	                : function (elem) { return pseudo_1(elem, options, data) && next(elem); };
	    }
	    throw new Error("unmatched pseudo-class :".concat(name));
	}
	exports.compilePseudoSelector = compilePseudoSelector; 
} (pseudoSelectors));

Object.defineProperty(general, "__esModule", { value: true });
general.compileGeneralSelector = void 0;
var attributes_1 = attributes;
var pseudo_selectors_1 = pseudoSelectors;
var css_what_1$1 = require$$0$5;
/*
 * All available rules
 */
function compileGeneralSelector(next, selector, options, context, compileToken) {
    var adapter = options.adapter, equals = options.equals;
    switch (selector.type) {
        case css_what_1$1.SelectorType.PseudoElement: {
            throw new Error("Pseudo-elements are not supported by css-select");
        }
        case css_what_1$1.SelectorType.ColumnCombinator: {
            throw new Error("Column combinators are not yet supported by css-select");
        }
        case css_what_1$1.SelectorType.Attribute: {
            if (selector.namespace != null) {
                throw new Error("Namespaced attributes are not yet supported by css-select");
            }
            if (!options.xmlMode || options.lowerCaseAttributeNames) {
                selector.name = selector.name.toLowerCase();
            }
            return attributes_1.attributeRules[selector.action](next, selector, options);
        }
        case css_what_1$1.SelectorType.Pseudo: {
            return (0, pseudo_selectors_1.compilePseudoSelector)(next, selector, options, context, compileToken);
        }
        // Tags
        case css_what_1$1.SelectorType.Tag: {
            if (selector.namespace != null) {
                throw new Error("Namespaced tag names are not yet supported by css-select");
            }
            var name_1 = selector.name;
            if (!options.xmlMode || options.lowerCaseTags) {
                name_1 = name_1.toLowerCase();
            }
            return function tag(elem) {
                return adapter.getName(elem) === name_1 && next(elem);
            };
        }
        // Traversal
        case css_what_1$1.SelectorType.Descendant: {
            if (options.cacheResults === false ||
                typeof WeakSet === "undefined") {
                return function descendant(elem) {
                    var current = elem;
                    while ((current = adapter.getParent(current))) {
                        if (adapter.isTag(current) && next(current)) {
                            return true;
                        }
                    }
                    return false;
                };
            }
            // @ts-expect-error `ElementNode` is not extending object
            var isFalseCache_1 = new WeakSet();
            return function cachedDescendant(elem) {
                var current = elem;
                while ((current = adapter.getParent(current))) {
                    if (!isFalseCache_1.has(current)) {
                        if (adapter.isTag(current) && next(current)) {
                            return true;
                        }
                        isFalseCache_1.add(current);
                    }
                }
                return false;
            };
        }
        case "_flexibleDescendant": {
            // Include element itself, only used while querying an array
            return function flexibleDescendant(elem) {
                var current = elem;
                do {
                    if (adapter.isTag(current) && next(current))
                        return true;
                } while ((current = adapter.getParent(current)));
                return false;
            };
        }
        case css_what_1$1.SelectorType.Parent: {
            return function parent(elem) {
                return adapter
                    .getChildren(elem)
                    .some(function (elem) { return adapter.isTag(elem) && next(elem); });
            };
        }
        case css_what_1$1.SelectorType.Child: {
            return function child(elem) {
                var parent = adapter.getParent(elem);
                return parent != null && adapter.isTag(parent) && next(parent);
            };
        }
        case css_what_1$1.SelectorType.Sibling: {
            return function sibling(elem) {
                var siblings = adapter.getSiblings(elem);
                for (var i = 0; i < siblings.length; i++) {
                    var currentSibling = siblings[i];
                    if (equals(elem, currentSibling))
                        break;
                    if (adapter.isTag(currentSibling) && next(currentSibling)) {
                        return true;
                    }
                }
                return false;
            };
        }
        case css_what_1$1.SelectorType.Adjacent: {
            if (adapter.prevElementSibling) {
                return function adjacent(elem) {
                    var previous = adapter.prevElementSibling(elem);
                    return previous != null && next(previous);
                };
            }
            return function adjacent(elem) {
                var siblings = adapter.getSiblings(elem);
                var lastElement;
                for (var i = 0; i < siblings.length; i++) {
                    var currentSibling = siblings[i];
                    if (equals(elem, currentSibling))
                        break;
                    if (adapter.isTag(currentSibling)) {
                        lastElement = currentSibling;
                    }
                }
                return !!lastElement && next(lastElement);
            };
        }
        case css_what_1$1.SelectorType.Universal: {
            if (selector.namespace != null && selector.namespace !== "*") {
                throw new Error("Namespaced universal selectors are not yet supported by css-select");
            }
            return next;
        }
    }
}
general.compileGeneralSelector = compileGeneralSelector;

var __importDefault$4 = (commonjsGlobal && commonjsGlobal.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(compile$5, "__esModule", { value: true });
compile$5.compileToken = compile$5.compileUnsafe = compile$5.compile = void 0;
var css_what_1 = require$$0$5;
var boolbase_1 = boolbase;
var sort_1 = __importDefault$4(sort);
var procedure_1 = procedure;
var general_1 = general;
var subselects_1 = subselects;
/**
 * Compiles a selector to an executable function.
 *
 * @param selector Selector to compile.
 * @param options Compilation options.
 * @param context Optional context for the selector.
 */
function compile$2(selector, options, context) {
    var next = compileUnsafe(selector, options, context);
    return (0, subselects_1.ensureIsTag)(next, options.adapter);
}
compile$5.compile = compile$2;
function compileUnsafe(selector, options, context) {
    var token = typeof selector === "string" ? (0, css_what_1.parse)(selector) : selector;
    return compileToken(token, options, context);
}
compile$5.compileUnsafe = compileUnsafe;
function includesScopePseudo(t) {
    return (t.type === "pseudo" &&
        (t.name === "scope" ||
            (Array.isArray(t.data) &&
                t.data.some(function (data) { return data.some(includesScopePseudo); }))));
}
var DESCENDANT_TOKEN = { type: css_what_1.SelectorType.Descendant };
var FLEXIBLE_DESCENDANT_TOKEN = {
    type: "_flexibleDescendant",
};
var SCOPE_TOKEN = {
    type: css_what_1.SelectorType.Pseudo,
    name: "scope",
    data: null,
};
/*
 * CSS 4 Spec (Draft): 3.3.1. Absolutizing a Scope-relative Selector
 * http://www.w3.org/TR/selectors4/#absolutizing
 */
function absolutize$2(token, _a, context) {
    var adapter = _a.adapter;
    // TODO Use better check if the context is a document
    var hasContext = !!(context === null || context === void 0 ? void 0 : context.every(function (e) {
        var parent = adapter.isTag(e) && adapter.getParent(e);
        return e === subselects_1.PLACEHOLDER_ELEMENT || (parent && adapter.isTag(parent));
    }));
    for (var _i = 0, token_1 = token; _i < token_1.length; _i++) {
        var t = token_1[_i];
        if (t.length > 0 && (0, procedure_1.isTraversal)(t[0]) && t[0].type !== "descendant") ;
        else if (hasContext && !t.some(includesScopePseudo)) {
            t.unshift(DESCENDANT_TOKEN);
        }
        else {
            continue;
        }
        t.unshift(SCOPE_TOKEN);
    }
}
function compileToken(token, options, context) {
    var _a;
    token = token.filter(function (t) { return t.length > 0; });
    token.forEach(sort_1.default);
    context = (_a = options.context) !== null && _a !== void 0 ? _a : context;
    var isArrayContext = Array.isArray(context);
    var finalContext = context && (Array.isArray(context) ? context : [context]);
    absolutize$2(token, options, finalContext);
    var shouldTestNextSiblings = false;
    var query = token
        .map(function (rules) {
        if (rules.length >= 2) {
            var first = rules[0], second = rules[1];
            if (first.type !== "pseudo" || first.name !== "scope") ;
            else if (isArrayContext && second.type === "descendant") {
                rules[1] = FLEXIBLE_DESCENDANT_TOKEN;
            }
            else if (second.type === "adjacent" ||
                second.type === "sibling") {
                shouldTestNextSiblings = true;
            }
        }
        return compileRules(rules, options, finalContext);
    })
        .reduce(reduceRules, boolbase_1.falseFunc);
    query.shouldTestNextSiblings = shouldTestNextSiblings;
    return query;
}
compile$5.compileToken = compileToken;
function compileRules(rules, options, context) {
    var _a;
    return rules.reduce(function (previous, rule) {
        return previous === boolbase_1.falseFunc
            ? boolbase_1.falseFunc
            : (0, general_1.compileGeneralSelector)(previous, rule, options, context, compileToken);
    }, (_a = options.rootFunc) !== null && _a !== void 0 ? _a : boolbase_1.trueFunc);
}
function reduceRules(a, b) {
    if (b === boolbase_1.falseFunc || a === boolbase_1.trueFunc) {
        return a;
    }
    if (a === boolbase_1.falseFunc || b === boolbase_1.trueFunc) {
        return b;
    }
    return function combine(elem) {
        return a(elem) || b(elem);
    };
}

(function (exports) {
	var __createBinding = (commonjsGlobal && commonjsGlobal.__createBinding) || (Object.create ? (function(o, m, k, k2) {
	    if (k2 === undefined) k2 = k;
	    var desc = Object.getOwnPropertyDescriptor(m, k);
	    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
	      desc = { enumerable: true, get: function() { return m[k]; } };
	    }
	    Object.defineProperty(o, k2, desc);
	}) : (function(o, m, k, k2) {
	    if (k2 === undefined) k2 = k;
	    o[k2] = m[k];
	}));
	var __setModuleDefault = (commonjsGlobal && commonjsGlobal.__setModuleDefault) || (Object.create ? (function(o, v) {
	    Object.defineProperty(o, "default", { enumerable: true, value: v });
	}) : function(o, v) {
	    o["default"] = v;
	});
	var __importStar = (commonjsGlobal && commonjsGlobal.__importStar) || function (mod) {
	    if (mod && mod.__esModule) return mod;
	    var result = {};
	    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
	    __setModuleDefault(result, mod);
	    return result;
	};
	Object.defineProperty(exports, "__esModule", { value: true });
	exports.aliases = exports.pseudos = exports.filters = exports.is = exports.selectOne = exports.selectAll = exports.prepareContext = exports._compileToken = exports._compileUnsafe = exports.compile = void 0;
	var DomUtils = __importStar(lib$r);
	var boolbase_1 = boolbase;
	var compile_1 = compile$5;
	var subselects_1 = subselects;
	var defaultEquals = function (a, b) { return a === b; };
	var defaultOptions = {
	    adapter: DomUtils,
	    equals: defaultEquals,
	};
	function convertOptionFormats(options) {
	    var _a, _b, _c, _d;
	    /*
	     * We force one format of options to the other one.
	     */
	    // @ts-expect-error Default options may have incompatible `Node` / `ElementNode`.
	    var opts = options !== null && options !== void 0 ? options : defaultOptions;
	    // @ts-expect-error Same as above.
	    (_a = opts.adapter) !== null && _a !== void 0 ? _a : (opts.adapter = DomUtils);
	    // @ts-expect-error `equals` does not exist on `Options`
	    (_b = opts.equals) !== null && _b !== void 0 ? _b : (opts.equals = (_d = (_c = opts.adapter) === null || _c === void 0 ? void 0 : _c.equals) !== null && _d !== void 0 ? _d : defaultEquals);
	    return opts;
	}
	function wrapCompile(func) {
	    return function addAdapter(selector, options, context) {
	        var opts = convertOptionFormats(options);
	        return func(selector, opts, context);
	    };
	}
	/**
	 * Compiles the query, returns a function.
	 */
	exports.compile = wrapCompile(compile_1.compile);
	exports._compileUnsafe = wrapCompile(compile_1.compileUnsafe);
	exports._compileToken = wrapCompile(compile_1.compileToken);
	function getSelectorFunc(searchFunc) {
	    return function select(query, elements, options) {
	        var opts = convertOptionFormats(options);
	        if (typeof query !== "function") {
	            query = (0, compile_1.compileUnsafe)(query, opts, elements);
	        }
	        var filteredElements = prepareContext(elements, opts.adapter, query.shouldTestNextSiblings);
	        return searchFunc(query, filteredElements, opts);
	    };
	}
	function prepareContext(elems, adapter, shouldTestNextSiblings) {
	    if (shouldTestNextSiblings === void 0) { shouldTestNextSiblings = false; }
	    /*
	     * Add siblings if the query requires them.
	     * See https://github.com/fb55/css-select/pull/43#issuecomment-225414692
	     */
	    if (shouldTestNextSiblings) {
	        elems = appendNextSiblings(elems, adapter);
	    }
	    return Array.isArray(elems)
	        ? adapter.removeSubsets(elems)
	        : adapter.getChildren(elems);
	}
	exports.prepareContext = prepareContext;
	function appendNextSiblings(elem, adapter) {
	    // Order matters because jQuery seems to check the children before the siblings
	    var elems = Array.isArray(elem) ? elem.slice(0) : [elem];
	    var elemsLength = elems.length;
	    for (var i = 0; i < elemsLength; i++) {
	        var nextSiblings = (0, subselects_1.getNextSiblings)(elems[i], adapter);
	        elems.push.apply(elems, nextSiblings);
	    }
	    return elems;
	}
	/**
	 * @template Node The generic Node type for the DOM adapter being used.
	 * @template ElementNode The Node type for elements for the DOM adapter being used.
	 * @param elems Elements to query. If it is an element, its children will be queried..
	 * @param query can be either a CSS selector string or a compiled query function.
	 * @param [options] options for querying the document.
	 * @see compile for supported selector queries.
	 * @returns All matching elements.
	 *
	 */
	exports.selectAll = getSelectorFunc(function (query, elems, options) {
	    return query === boolbase_1.falseFunc || !elems || elems.length === 0
	        ? []
	        : options.adapter.findAll(query, elems);
	});
	/**
	 * @template Node The generic Node type for the DOM adapter being used.
	 * @template ElementNode The Node type for elements for the DOM adapter being used.
	 * @param elems Elements to query. If it is an element, its children will be queried..
	 * @param query can be either a CSS selector string or a compiled query function.
	 * @param [options] options for querying the document.
	 * @see compile for supported selector queries.
	 * @returns the first match, or null if there was no match.
	 */
	exports.selectOne = getSelectorFunc(function (query, elems, options) {
	    return query === boolbase_1.falseFunc || !elems || elems.length === 0
	        ? null
	        : options.adapter.findOne(query, elems);
	});
	/**
	 * Tests whether or not an element is matched by query.
	 *
	 * @template Node The generic Node type for the DOM adapter being used.
	 * @template ElementNode The Node type for elements for the DOM adapter being used.
	 * @param elem The element to test if it matches the query.
	 * @param query can be either a CSS selector string or a compiled query function.
	 * @param [options] options for querying the document.
	 * @see compile for supported selector queries.
	 * @returns
	 */
	function is(elem, query, options) {
	    var opts = convertOptionFormats(options);
	    return (typeof query === "function" ? query : (0, compile_1.compile)(query, opts))(elem);
	}
	exports.is = is;
	/**
	 * Alias for selectAll(query, elems, options).
	 * @see [compile] for supported selector queries.
	 */
	exports.default = exports.selectAll;
	// Export filters, pseudos and aliases to allow users to supply their own.
	var pseudo_selectors_1 = pseudoSelectors;
	Object.defineProperty(exports, "filters", { enumerable: true, get: function () { return pseudo_selectors_1.filters; } });
	Object.defineProperty(exports, "pseudos", { enumerable: true, get: function () { return pseudo_selectors_1.pseudos; } });
	Object.defineProperty(exports, "aliases", { enumerable: true, get: function () { return pseudo_selectors_1.aliases; } }); 
} (lib$s));

var back = {};

Object.defineProperty(back, "__esModule", { value: true });
function arr_back(arr) {
    return arr[arr.length - 1];
}
back.default = arr_back;

var matcher$1 = {};

var __importDefault$3 = (commonjsGlobal && commonjsGlobal.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(matcher$1, "__esModule", { value: true });
var type_1$3 = __importDefault$3(type$1);
function isTag(node) {
    return node && node.nodeType === type_1$3.default.ELEMENT_NODE;
}
function getAttributeValue(elem, name) {
    return isTag(elem) ? elem.getAttribute(name) : undefined;
}
function getName(elem) {
    return ((elem && elem.rawTagName) || '').toLowerCase();
}
function getChildren(node) {
    return node && node.childNodes;
}
function getParent(node) {
    return node ? node.parentNode : null;
}
function getText(node) {
    return node.text;
}
function removeSubsets(nodes) {
    var idx = nodes.length;
    var node;
    var ancestor;
    var replace;
    // Check if each node (or one of its ancestors) is already contained in the
    // array.
    while (--idx > -1) {
        node = ancestor = nodes[idx];
        // Temporarily remove the node under consideration
        nodes[idx] = null;
        replace = true;
        while (ancestor) {
            if (nodes.indexOf(ancestor) > -1) {
                replace = false;
                nodes.splice(idx, 1);
                break;
            }
            ancestor = getParent(ancestor);
        }
        // If the node has been found to be unique, re-insert it.
        if (replace) {
            nodes[idx] = node;
        }
    }
    return nodes;
}
function existsOne(test, elems) {
    return elems.some(function (elem) {
        return isTag(elem) ? test(elem) || existsOne(test, getChildren(elem)) : false;
    });
}
function getSiblings(node) {
    var parent = getParent(node);
    return parent && getChildren(parent);
}
function hasAttrib(elem, name) {
    return getAttributeValue(elem, name) !== undefined;
}
function findOne(test, elems) {
    var elem = null;
    for (var i = 0, l = elems.length; i < l && !elem; i++) {
        var el = elems[i];
        if (test(el)) {
            elem = el;
        }
        else {
            var childs = getChildren(el);
            if (childs && childs.length > 0) {
                elem = findOne(test, childs);
            }
        }
    }
    return elem;
}
function findAll(test, nodes) {
    var result = [];
    for (var i = 0, j = nodes.length; i < j; i++) {
        if (!isTag(nodes[i]))
            continue;
        if (test(nodes[i]))
            result.push(nodes[i]);
        var childs = getChildren(nodes[i]);
        if (childs)
            result = result.concat(findAll(test, childs));
    }
    return result;
}
matcher$1.default = {
    isTag: isTag,
    getAttributeValue: getAttributeValue,
    getName: getName,
    getChildren: getChildren,
    getParent: getParent,
    getText: getText,
    removeSubsets: removeSubsets,
    existsOne: existsOne,
    getSiblings: getSiblings,
    hasAttrib: hasAttrib,
    findOne: findOne,
    findAll: findAll
};

var voidTag = {};

Object.defineProperty(voidTag, "__esModule", { value: true });
var VoidTag = /** @class */ (function () {
    function VoidTag(addClosingSlash, tags) {
        if (addClosingSlash === void 0) { addClosingSlash = false; }
        this.addClosingSlash = addClosingSlash;
        if (Array.isArray(tags)) {
            this.voidTags = tags.reduce(function (set, tag) {
                return set.add(tag.toLowerCase());
            }, new Set());
        }
        else {
            this.voidTags = ['area', 'base', 'br', 'col', 'embed', 'hr', 'img', 'input', 'link', 'meta', 'param', 'source', 'track', 'wbr'].reduce(function (set, tag) {
                return set.add(tag);
            }, new Set());
        }
    }
    VoidTag.prototype.formatNode = function (tag, attrs, innerHTML) {
        var addClosingSlash = this.addClosingSlash;
        var closingSpace = (addClosingSlash && attrs && !attrs.endsWith(' ')) ? ' ' : '';
        var closingSlash = addClosingSlash ? "".concat(closingSpace, "/") : '';
        return this.isVoidElement(tag.toLowerCase()) ? "<".concat(tag).concat(attrs).concat(closingSlash, ">") : "<".concat(tag).concat(attrs, ">").concat(innerHTML, "</").concat(tag, ">");
    };
    VoidTag.prototype.isVoidElement = function (tag) {
        return this.voidTags.has(tag);
    };
    return VoidTag;
}());
voidTag.default = VoidTag;

var text = {};

var __extends$1 = (commonjsGlobal && commonjsGlobal.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault$2 = (commonjsGlobal && commonjsGlobal.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(text, "__esModule", { value: true });
var he_1$1 = heExports;
var node_1$2 = __importDefault$2(node$4);
var type_1$2 = __importDefault$2(type$1);
/**
 * TextNode to contain a text element in DOM tree.
 * @param {string} value [description]
 */
var TextNode = /** @class */ (function (_super) {
    __extends$1(TextNode, _super);
    function TextNode(rawText, parentNode, range) {
        var _this = _super.call(this, parentNode, range) || this;
        /**
         * Node Type declaration.
         * @type {Number}
         */
        _this.nodeType = type_1$2.default.TEXT_NODE;
        _this._rawText = rawText;
        return _this;
    }
    TextNode.prototype.clone = function () {
        return new TextNode(this._rawText, null);
    };
    Object.defineProperty(TextNode.prototype, "rawText", {
        get: function () {
            return this._rawText;
        },
        /**
         * Set rawText and invalidate trimmed caches
         */
        set: function (text) {
            this._rawText = text;
            this._trimmedRawText = void 0;
            this._trimmedText = void 0;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TextNode.prototype, "trimmedRawText", {
        /**
         * Returns raw text with all whitespace trimmed except single leading/trailing non-breaking space
         */
        get: function () {
            if (this._trimmedRawText !== undefined)
                return this._trimmedRawText;
            this._trimmedRawText = trimText(this.rawText);
            return this._trimmedRawText;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TextNode.prototype, "trimmedText", {
        /**
         * Returns text with all whitespace trimmed except single leading/trailing non-breaking space
         */
        get: function () {
            if (this._trimmedText !== undefined)
                return this._trimmedText;
            this._trimmedText = trimText(this.text);
            return this._trimmedText;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TextNode.prototype, "text", {
        /**
         * Get unescaped text value of current node and its children.
         * @return {string} text content
         */
        get: function () {
            return (0, he_1$1.decode)(this.rawText);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TextNode.prototype, "isWhitespace", {
        /**
         * Detect if the node contains only white space.
         * @return {boolean}
         */
        get: function () {
            return /^(\s|&nbsp;)*$/.test(this.rawText);
        },
        enumerable: false,
        configurable: true
    });
    TextNode.prototype.toString = function () {
        return this.rawText;
    };
    return TextNode;
}(node_1$2.default));
text.default = TextNode;
/**
 * Trim whitespace except single leading/trailing non-breaking space
 */
function trimText(text) {
    var i = 0;
    var startPos;
    var endPos;
    while (i >= 0 && i < text.length) {
        if (/\S/.test(text[i])) {
            if (startPos === undefined) {
                startPos = i;
                i = text.length;
            }
            else {
                endPos = i;
                i = void 0;
            }
        }
        if (startPos === undefined)
            i++;
        else
            i--;
    }
    if (startPos === undefined)
        startPos = 0;
    if (endPos === undefined)
        endPos = text.length - 1;
    var hasLeadingSpace = startPos > 0 && /[^\S\r\n]/.test(text[startPos - 1]);
    var hasTrailingSpace = endPos < (text.length - 1) && /[^\S\r\n]/.test(text[endPos + 1]);
    return (hasLeadingSpace ? ' ' : '') + text.slice(startPos, endPos + 1) + (hasTrailingSpace ? ' ' : '');
}

var __extends = (commonjsGlobal && commonjsGlobal.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (commonjsGlobal && commonjsGlobal.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArray = (commonjsGlobal && commonjsGlobal.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault$1 = (commonjsGlobal && commonjsGlobal.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(html, "__esModule", { value: true });
html.parse = html.base_parse = void 0;
var css_select_1 = lib$s;
var he_1 = __importDefault$1(heExports);
var back_1 = __importDefault$1(back);
var matcher_1$1 = __importDefault$1(matcher$1);
var void_tag_1 = __importDefault$1(voidTag);
var comment_1$1 = __importDefault$1(comment);
var node_1$1 = __importDefault$1(node$4);
var text_1$1 = __importDefault$1(text);
var type_1$1 = __importDefault$1(type$1);
function decode$2(val) {
    // clone string
    return JSON.parse(JSON.stringify(he_1.default.decode(val)));
}
// https://developer.mozilla.org/en-US/docs/Web/HTML/Block-level_elements
var Htags = ['h1', 'h2', 'h3', 'h4', 'h5', 'h6', 'header', 'hgroup'];
var Dtags = ['details', 'dialog', 'dd', 'div', 'dt'];
var Ftags = ['fieldset', 'figcaption', 'figure', 'footer', 'form'];
var tableTags = ['table', 'td', 'tr'];
var htmlTags$1 = ['address', 'article', 'aside', 'blockquote', 'br', 'hr', 'li', 'main', 'nav', 'ol', 'p', 'pre', 'section', 'ul'];
var kBlockElements = new Set();
function addToKBlockElement() {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    var addToSet = function (array) {
        for (var index = 0; index < array.length; index++) {
            var element = array[index];
            kBlockElements.add(element);
            kBlockElements.add(element.toUpperCase());
        }
    };
    for (var _a = 0, args_1 = args; _a < args_1.length; _a++) {
        var arg = args_1[_a];
        addToSet(arg);
    }
}
addToKBlockElement(Htags, Dtags, Ftags, tableTags, htmlTags$1);
var DOMTokenList = /** @class */ (function () {
    function DOMTokenList(valuesInit, afterUpdate) {
        if (valuesInit === void 0) { valuesInit = []; }
        if (afterUpdate === void 0) { afterUpdate = function () { return null; }; }
        this._set = new Set(valuesInit);
        this._afterUpdate = afterUpdate;
    }
    DOMTokenList.prototype._validate = function (c) {
        if (/\s/.test(c)) {
            throw new Error("DOMException in DOMTokenList.add: The token '".concat(c, "' contains HTML space characters, which are not valid in tokens."));
        }
    };
    DOMTokenList.prototype.add = function (c) {
        this._validate(c);
        this._set.add(c);
        this._afterUpdate(this); // eslint-disable-line @typescript-eslint/no-unsafe-call
    };
    DOMTokenList.prototype.replace = function (c1, c2) {
        this._validate(c2);
        this._set.delete(c1);
        this._set.add(c2);
        this._afterUpdate(this); // eslint-disable-line @typescript-eslint/no-unsafe-call
    };
    DOMTokenList.prototype.remove = function (c) {
        this._set.delete(c) && this._afterUpdate(this); // eslint-disable-line @typescript-eslint/no-unsafe-call
    };
    DOMTokenList.prototype.toggle = function (c) {
        this._validate(c);
        if (this._set.has(c))
            this._set.delete(c);
        else
            this._set.add(c);
        this._afterUpdate(this); // eslint-disable-line @typescript-eslint/no-unsafe-call
    };
    DOMTokenList.prototype.contains = function (c) {
        return this._set.has(c);
    };
    Object.defineProperty(DOMTokenList.prototype, "length", {
        get: function () {
            return this._set.size;
        },
        enumerable: false,
        configurable: true
    });
    DOMTokenList.prototype.values = function () {
        return this._set.values();
    };
    Object.defineProperty(DOMTokenList.prototype, "value", {
        get: function () {
            return Array.from(this._set.values());
        },
        enumerable: false,
        configurable: true
    });
    DOMTokenList.prototype.toString = function () {
        return Array.from(this._set.values()).join(' ');
    };
    return DOMTokenList;
}());
/**
 * HTMLElement, which contains a set of children.
 *
 * Note: this is a minimalist implementation, no complete tree
 *   structure provided (no parentNode, nextSibling,
 *   previousSibling etc).
 * @class HTMLElement
 * @extends {Node}
 */
var HTMLElement = /** @class */ (function (_super) {
    __extends(HTMLElement, _super);
    /**
     * Creates an instance of HTMLElement.
     * @param keyAttrs	id and class attribute
     * @param [rawAttrs]	attributes in string
     *
     * @memberof HTMLElement
     */
    function HTMLElement(tagName, keyAttrs, rawAttrs, parentNode, range, voidTag) {
        if (rawAttrs === void 0) { rawAttrs = ''; }
        if (voidTag === void 0) { voidTag = new void_tag_1.default(); }
        var _this = _super.call(this, parentNode, range) || this;
        _this.rawAttrs = rawAttrs;
        _this.voidTag = voidTag;
        /**
         * Node Type declaration.
         */
        _this.nodeType = type_1$1.default.ELEMENT_NODE;
        _this.rawTagName = tagName;
        _this.rawAttrs = rawAttrs || '';
        _this.id = keyAttrs.id || '';
        _this.childNodes = [];
        _this.classList = new DOMTokenList(keyAttrs.class ? keyAttrs.class.split(/\s+/) : [], function (classList) { return _this.setAttribute('class', classList.toString()); } // eslint-disable-line @typescript-eslint/no-unsafe-member-access, @typescript-eslint/no-unsafe-call
        );
        if (keyAttrs.id) {
            if (!rawAttrs) {
                _this.rawAttrs = "id=\"".concat(keyAttrs.id, "\"");
            }
        }
        if (keyAttrs.class) {
            if (!rawAttrs) {
                var cls = "class=\"".concat(_this.classList.toString(), "\"");
                if (_this.rawAttrs) {
                    _this.rawAttrs += " ".concat(cls);
                }
                else {
                    _this.rawAttrs = cls;
                }
            }
        }
        return _this;
    }
    /**
     * Quote attribute values
     * @param attr attribute value
     * @returns {string} quoted value
     */
    HTMLElement.prototype.quoteAttribute = function (attr) {
        if (attr == null) {
            return 'null';
        }
        return JSON.stringify(attr.replace(/"/g, '&quot;'));
    };
    /**
     * Remove Child element from childNodes array
     * @param {HTMLElement} node     node to remove
     */
    HTMLElement.prototype.removeChild = function (node) {
        this.childNodes = this.childNodes.filter(function (child) {
            return child !== node;
        });
        return this;
    };
    /**
     * Exchanges given child with new child
     * @param {HTMLElement} oldNode     node to exchange
     * @param {HTMLElement} newNode     new node
     */
    HTMLElement.prototype.exchangeChild = function (oldNode, newNode) {
        var children = this.childNodes;
        this.childNodes = children.map(function (child) {
            if (child === oldNode) {
                return newNode;
            }
            return child;
        });
        return this;
    };
    Object.defineProperty(HTMLElement.prototype, "tagName", {
        get: function () {
            return this.rawTagName ? this.rawTagName.toUpperCase() : this.rawTagName;
        },
        set: function (newname) {
            this.rawTagName = newname.toLowerCase();
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(HTMLElement.prototype, "localName", {
        get: function () {
            return this.rawTagName.toLowerCase();
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(HTMLElement.prototype, "isVoidElement", {
        get: function () {
            return this.voidTag.isVoidElement(this.localName);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(HTMLElement.prototype, "rawText", {
        /**
         * Get escpaed (as-it) text value of current node and its children.
         * @return {string} text content
         */
        get: function () {
            return this.childNodes.reduce(function (pre, cur) {
                return (pre += cur.rawText);
            }, '');
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(HTMLElement.prototype, "textContent", {
        get: function () {
            return decode$2(this.rawText);
        },
        set: function (val) {
            var content = [new text_1$1.default(val, this)];
            this.childNodes = content;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(HTMLElement.prototype, "text", {
        /**
         * Get unescaped text value of current node and its children.
         * @return {string} text content
         */
        get: function () {
            return decode$2(this.rawText);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(HTMLElement.prototype, "structuredText", {
        /**
         * Get structured Text (with '\n' etc.)
         * @return {string} structured text
         */
        get: function () {
            var currentBlock = [];
            var blocks = [currentBlock];
            function dfs(node) {
                if (node.nodeType === type_1$1.default.ELEMENT_NODE) {
                    if (kBlockElements.has(node.rawTagName)) {
                        if (currentBlock.length > 0) {
                            blocks.push((currentBlock = []));
                        }
                        node.childNodes.forEach(dfs);
                        if (currentBlock.length > 0) {
                            blocks.push((currentBlock = []));
                        }
                    }
                    else {
                        node.childNodes.forEach(dfs);
                    }
                }
                else if (node.nodeType === type_1$1.default.TEXT_NODE) {
                    if (node.isWhitespace) {
                        // Whitespace node, postponed output
                        currentBlock.prependWhitespace = true;
                    }
                    else {
                        var text = node.trimmedText;
                        if (currentBlock.prependWhitespace) {
                            text = " ".concat(text);
                            currentBlock.prependWhitespace = false;
                        }
                        currentBlock.push(text);
                    }
                }
            }
            dfs(this);
            return blocks
                .map(function (block) {
                return block.join('').replace(/\s{2,}/g, ' '); // Normalize each line's whitespace
            })
                .join('\n')
                .replace(/\s+$/, ''); // trimRight;
        },
        enumerable: false,
        configurable: true
    });
    HTMLElement.prototype.toString = function () {
        var tag = this.rawTagName;
        if (tag) {
            var attrs = this.rawAttrs ? " ".concat(this.rawAttrs) : '';
            return this.voidTag.formatNode(tag, attrs, this.innerHTML);
        }
        return this.innerHTML;
    };
    Object.defineProperty(HTMLElement.prototype, "innerHTML", {
        get: function () {
            return this.childNodes
                .map(function (child) {
                return child.toString();
            })
                .join('');
        },
        set: function (content) {
            //const r = parse(content, global.options); // TODO global.options ?
            var r = parse$a(content);
            var nodes = r.childNodes.length ? r.childNodes : [new text_1$1.default(content, this)];
            resetParent(nodes, this);
            resetParent(this.childNodes, null);
            this.childNodes = nodes;
        },
        enumerable: false,
        configurable: true
    });
    HTMLElement.prototype.set_content = function (content, options) {
        if (options === void 0) { options = {}; }
        if (content instanceof node_1$1.default) {
            content = [content];
        }
        else if (typeof content == 'string') {
            var r = parse$a(content, options);
            content = r.childNodes.length ? r.childNodes : [new text_1$1.default(content, this)];
        }
        resetParent(this.childNodes, null);
        resetParent(content, this);
        this.childNodes = content;
        return this;
    };
    HTMLElement.prototype.replaceWith = function () {
        var _this = this;
        var nodes = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            nodes[_i] = arguments[_i];
        }
        var parent = this.parentNode;
        var content = nodes
            .map(function (node) {
            if (node instanceof node_1$1.default) {
                return [node];
            }
            else if (typeof node == 'string') {
                // const r = parse(content, global.options); // TODO global.options ?
                var r = parse$a(node);
                return r.childNodes.length ? r.childNodes : [new text_1$1.default(node, _this)];
            }
            return [];
        })
            .flat();
        var idx = parent.childNodes.findIndex(function (child) {
            return child === _this;
        });
        resetParent([this], null);
        parent.childNodes = __spreadArray(__spreadArray(__spreadArray([], parent.childNodes.slice(0, idx), true), resetParent(content, parent), true), parent.childNodes.slice(idx + 1), true);
    };
    Object.defineProperty(HTMLElement.prototype, "outerHTML", {
        get: function () {
            return this.toString();
        },
        enumerable: false,
        configurable: true
    });
    /**
     * Trim element from right (in block) after seeing pattern in a TextNode.
     * @param  {RegExp} pattern pattern to find
     * @return {HTMLElement}    reference to current node
     */
    HTMLElement.prototype.trimRight = function (pattern) {
        for (var i = 0; i < this.childNodes.length; i++) {
            var childNode = this.childNodes[i];
            if (childNode.nodeType === type_1$1.default.ELEMENT_NODE) {
                childNode.trimRight(pattern);
            }
            else {
                var index = childNode.rawText.search(pattern);
                if (index > -1) {
                    childNode.rawText = childNode.rawText.substr(0, index);
                    // trim all following nodes.
                    this.childNodes.length = i + 1;
                }
            }
        }
        return this;
    };
    Object.defineProperty(HTMLElement.prototype, "structure", {
        /**
         * Get DOM structure
         * @return {string} strucutre
         */
        get: function () {
            var res = [];
            var indention = 0;
            function write(str) {
                res.push('  '.repeat(indention) + str);
            }
            function dfs(node) {
                var idStr = node.id ? "#".concat(node.id) : '';
                var classStr = node.classList.length ? ".".concat(node.classList.value.join('.')) : ''; // eslint-disable-line @typescript-eslint/no-unsafe-member-access, @typescript-eslint/no-unsafe-member-access, @typescript-eslint/restrict-template-expressions, @typescript-eslint/no-unsafe-call
                write("".concat(node.rawTagName).concat(idStr).concat(classStr));
                indention++;
                node.childNodes.forEach(function (childNode) {
                    if (childNode.nodeType === type_1$1.default.ELEMENT_NODE) {
                        dfs(childNode);
                    }
                    else if (childNode.nodeType === type_1$1.default.TEXT_NODE) {
                        if (!childNode.isWhitespace) {
                            write('#text');
                        }
                    }
                });
                indention--;
            }
            dfs(this);
            return res.join('\n');
        },
        enumerable: false,
        configurable: true
    });
    /**
     * Remove whitespaces in this sub tree.
     * @return {HTMLElement} pointer to this
     */
    HTMLElement.prototype.removeWhitespace = function () {
        var _this = this;
        var o = 0;
        this.childNodes.forEach(function (node) {
            if (node.nodeType === type_1$1.default.TEXT_NODE) {
                if (node.isWhitespace) {
                    return;
                }
                node.rawText = node.trimmedRawText;
            }
            else if (node.nodeType === type_1$1.default.ELEMENT_NODE) {
                node.removeWhitespace();
            }
            _this.childNodes[o++] = node;
        });
        this.childNodes.length = o;
        return this;
    };
    /**
     * Query CSS selector to find matching nodes.
     * @param  {string}         selector Simplified CSS selector
     * @return {HTMLElement[]}  matching elements
     */
    HTMLElement.prototype.querySelectorAll = function (selector) {
        return (0, css_select_1.selectAll)(selector, this, {
            xmlMode: true,
            adapter: matcher_1$1.default,
        });
    };
    /**
     * Query CSS Selector to find matching node.
     * @param  {string}         selector Simplified CSS selector
     * @return {(HTMLElement|null)}    matching node
     */
    HTMLElement.prototype.querySelector = function (selector) {
        return (0, css_select_1.selectOne)(selector, this, {
            xmlMode: true,
            adapter: matcher_1$1.default,
        });
    };
    /**
     * find elements by their tagName
     * @param {string} tagName the tagName of the elements to select
     */
    HTMLElement.prototype.getElementsByTagName = function (tagName) {
        var upperCasedTagName = tagName.toUpperCase();
        var re = [];
        var stack = [];
        var currentNodeReference = this;
        var index = 0;
        // index turns to undefined once the stack is empty and the first condition occurs
        // which happens once all relevant children are searched through
        while (index !== undefined) {
            var child = void 0;
            // make it work with sparse arrays
            do {
                child = currentNodeReference.childNodes[index++];
            } while (index < currentNodeReference.childNodes.length && child === undefined);
            // if the child does not exist we move on with the last provided index (which belongs to the parentNode)
            if (child === undefined) {
                currentNodeReference = currentNodeReference.parentNode;
                index = stack.pop();
                continue;
            }
            if (child.nodeType === type_1$1.default.ELEMENT_NODE) {
                // https://developer.mozilla.org/en-US/docs/Web/API/Element/getElementsByTagName#syntax
                if (tagName === '*' || child.tagName === upperCasedTagName)
                    re.push(child);
                // if children are existing push the current status to the stack and keep searching for elements in the level below
                if (child.childNodes.length > 0) {
                    stack.push(index);
                    currentNodeReference = child;
                    index = 0;
                }
            }
        }
        return re;
    };
    /**
     * find element by it's id
     * @param {string} id the id of the element to select
     */
    HTMLElement.prototype.getElementById = function (id) {
        var stack = [];
        var currentNodeReference = this;
        var index = 0;
        // index turns to undefined once the stack is empty and the first condition occurs
        // which happens once all relevant children are searched through
        while (index !== undefined) {
            var child = void 0;
            // make it work with sparse arrays
            do {
                child = currentNodeReference.childNodes[index++];
            } while (index < currentNodeReference.childNodes.length && child === undefined);
            // if the child does not exist we move on with the last provided index (which belongs to the parentNode)
            if (child === undefined) {
                currentNodeReference = currentNodeReference.parentNode;
                index = stack.pop();
                continue;
            }
            if (child.nodeType === type_1$1.default.ELEMENT_NODE) {
                if (child.id === id) {
                    return child;
                }
                // if children are existing push the current status to the stack and keep searching for elements in the level below
                if (child.childNodes.length > 0) {
                    stack.push(index);
                    currentNodeReference = child;
                    index = 0;
                }
            }
        }
        return null;
    };
    /**
     * traverses the Element and its parents (heading toward the document root) until it finds a node that matches the provided selector string. Will return itself or the matching ancestor. If no such element exists, it returns null.
     * @param selector a DOMString containing a selector list
     */
    HTMLElement.prototype.closest = function (selector) {
        var mapChild = new Map();
        var el = this;
        var old = null;
        function findOne(test, elems) {
            var elem = null;
            for (var i = 0, l = elems.length; i < l && !elem; i++) {
                var el_1 = elems[i];
                if (test(el_1)) {
                    elem = el_1;
                }
                else {
                    var child = mapChild.get(el_1);
                    if (child) {
                        elem = findOne(test, [child]);
                    }
                }
            }
            return elem;
        }
        while (el) {
            mapChild.set(el, old);
            old = el;
            el = el.parentNode;
        }
        el = this;
        while (el) {
            var e = (0, css_select_1.selectOne)(selector, el, {
                xmlMode: true,
                adapter: __assign(__assign({}, matcher_1$1.default), { getChildren: function (node) {
                        var child = mapChild.get(node);
                        return child && [child];
                    }, getSiblings: function (node) {
                        return [node];
                    }, findOne: findOne, findAll: function () {
                        return [];
                    } }),
            });
            if (e) {
                return e;
            }
            el = el.parentNode;
        }
        return null;
    };
    /**
     * Append a child node to childNodes
     * @param  {Node} node node to append
     * @return {Node}      node appended
     */
    HTMLElement.prototype.appendChild = function (node) {
        // remove the node from it's parent
        node.remove();
        this.childNodes.push(node);
        node.parentNode = this;
        return node;
    };
    Object.defineProperty(HTMLElement.prototype, "firstChild", {
        /**
         * Get first child node
         * @return {Node} first child node
         */
        get: function () {
            return this.childNodes[0];
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(HTMLElement.prototype, "lastChild", {
        /**
         * Get last child node
         * @return {Node} last child node
         */
        get: function () {
            return (0, back_1.default)(this.childNodes);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(HTMLElement.prototype, "attrs", {
        /**
         * Get attributes
         * @access private
         * @return {Object} parsed and unescaped attributes
         */
        get: function () {
            if (this._attrs) {
                return this._attrs;
            }
            this._attrs = {};
            var attrs = this.rawAttributes;
            for (var key in attrs) {
                var val = attrs[key] || '';
                this._attrs[key.toLowerCase()] = decode$2(val);
            }
            return this._attrs;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(HTMLElement.prototype, "attributes", {
        get: function () {
            var ret_attrs = {};
            var attrs = this.rawAttributes;
            for (var key in attrs) {
                var val = attrs[key] || '';
                ret_attrs[key] = decode$2(val);
            }
            return ret_attrs;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(HTMLElement.prototype, "rawAttributes", {
        /**
         * Get escaped (as-is) attributes
         * @return {Object} parsed attributes
         */
        get: function () {
            if (this._rawAttrs) {
                return this._rawAttrs;
            }
            var attrs = {};
            if (this.rawAttrs) {
                var re = /([a-zA-Z()[\]#@][a-zA-Z0-9-_:()[\]#]*)(?:\s*=\s*((?:'[^']*')|(?:"[^"]*")|\S+))?/g;
                var match = void 0;
                while ((match = re.exec(this.rawAttrs))) {
                    var key = match[1];
                    var val = match[2] || null;
                    if (val && (val[0] === "'" || val[0] === "\""))
                        val = val.slice(1, val.length - 1);
                    attrs[key] = val;
                }
            }
            this._rawAttrs = attrs;
            return attrs;
        },
        enumerable: false,
        configurable: true
    });
    HTMLElement.prototype.removeAttribute = function (key) {
        var attrs = this.rawAttributes;
        delete attrs[key];
        // Update this.attribute
        if (this._attrs) {
            delete this._attrs[key];
        }
        // Update rawString
        this.rawAttrs = Object.keys(attrs)
            .map(function (name) {
            var val = JSON.stringify(attrs[name]);
            if (val === undefined || val === 'null') {
                return name;
            }
            return "".concat(name, "=").concat(val);
        })
            .join(' ');
        // Update this.id
        if (key === 'id') {
            this.id = '';
        }
        return this;
    };
    HTMLElement.prototype.hasAttribute = function (key) {
        return key.toLowerCase() in this.attrs;
    };
    /**
     * Get an attribute
     * @return {string} value of the attribute
     */
    HTMLElement.prototype.getAttribute = function (key) {
        return this.attrs[key.toLowerCase()];
    };
    /**
     * Set an attribute value to the HTMLElement
     * @param {string} key The attribute name
     * @param {string} value The value to set, or null / undefined to remove an attribute
     */
    HTMLElement.prototype.setAttribute = function (key, value) {
        var _this = this;
        if (arguments.length < 2) {
            throw new Error("Failed to execute 'setAttribute' on 'Element'");
        }
        var k2 = key.toLowerCase();
        var attrs = this.rawAttributes;
        for (var k in attrs) {
            if (k.toLowerCase() === k2) {
                key = k;
                break;
            }
        }
        attrs[key] = String(value);
        // update this.attrs
        if (this._attrs) {
            this._attrs[k2] = decode$2(attrs[key]);
        }
        // Update rawString
        this.rawAttrs = Object.keys(attrs)
            .map(function (name) {
            var val = _this.quoteAttribute(attrs[name]);
            if (val === 'null' || val === '""')
                return name;
            return "".concat(name, "=").concat(val);
        })
            .join(' ');
        // Update this.id
        if (key === 'id') {
            this.id = value;
        }
    };
    /**
     * Replace all the attributes of the HTMLElement by the provided attributes
     * @param {Attributes} attributes the new attribute set
     */
    HTMLElement.prototype.setAttributes = function (attributes) {
        var _this = this;
        // Invalidate current this.attributes
        if (this._attrs) {
            delete this._attrs;
        }
        // Invalidate current this.rawAttributes
        if (this._rawAttrs) {
            delete this._rawAttrs;
        }
        // Update rawString
        this.rawAttrs = Object.keys(attributes)
            .map(function (name) {
            var val = attributes[name];
            if (val === 'null' || val === '""')
                return name;
            return "".concat(name, "=").concat(_this.quoteAttribute(String(val)));
        })
            .join(' ');
        return this;
    };
    HTMLElement.prototype.insertAdjacentHTML = function (where, html) {
        var _a, _b, _c;
        var _this = this;
        if (arguments.length < 2) {
            throw new Error('2 arguments required');
        }
        var p = parse$a(html);
        if (where === 'afterend') {
            var idx = this.parentNode.childNodes.findIndex(function (child) {
                return child === _this;
            });
            resetParent(p.childNodes, this.parentNode);
            (_a = this.parentNode.childNodes).splice.apply(_a, __spreadArray([idx + 1, 0], p.childNodes, false));
        }
        else if (where === 'afterbegin') {
            resetParent(p.childNodes, this);
            (_b = this.childNodes).unshift.apply(_b, p.childNodes);
        }
        else if (where === 'beforeend') {
            p.childNodes.forEach(function (n) {
                _this.appendChild(n);
            });
        }
        else if (where === 'beforebegin') {
            var idx = this.parentNode.childNodes.findIndex(function (child) {
                return child === _this;
            });
            resetParent(p.childNodes, this.parentNode);
            (_c = this.parentNode.childNodes).splice.apply(_c, __spreadArray([idx, 0], p.childNodes, false));
        }
        else {
            throw new Error("The value provided ('".concat(where, "') is not one of 'beforebegin', 'afterbegin', 'beforeend', or 'afterend'"));
        }
        return this;
        // if (!where || html === undefined || html === null) {
        // 	return;
        // }
    };
    Object.defineProperty(HTMLElement.prototype, "nextSibling", {
        get: function () {
            if (this.parentNode) {
                var children = this.parentNode.childNodes;
                var i = 0;
                while (i < children.length) {
                    var child = children[i++];
                    if (this === child)
                        return children[i] || null;
                }
                return null;
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(HTMLElement.prototype, "nextElementSibling", {
        get: function () {
            if (this.parentNode) {
                var children = this.parentNode.childNodes;
                var i = 0;
                var find = false;
                while (i < children.length) {
                    var child = children[i++];
                    if (find) {
                        if (child instanceof HTMLElement) {
                            return child || null;
                        }
                    }
                    else if (this === child) {
                        find = true;
                    }
                }
                return null;
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(HTMLElement.prototype, "previousSibling", {
        get: function () {
            if (this.parentNode) {
                var children = this.parentNode.childNodes;
                var i = children.length;
                while (i > 0) {
                    var child = children[--i];
                    if (this === child)
                        return children[i - 1] || null;
                }
                return null;
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(HTMLElement.prototype, "previousElementSibling", {
        get: function () {
            if (this.parentNode) {
                var children = this.parentNode.childNodes;
                var i = children.length;
                var find = false;
                while (i > 0) {
                    var child = children[--i];
                    if (find) {
                        if (child instanceof HTMLElement) {
                            return child || null;
                        }
                    }
                    else if (this === child) {
                        find = true;
                    }
                }
                return null;
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(HTMLElement.prototype, "classNames", {
        get: function () {
            return this.classList.toString();
        },
        enumerable: false,
        configurable: true
    });
    /**
     * Clone this Node
     */
    HTMLElement.prototype.clone = function () {
        return parse$a(this.toString()).firstChild;
    };
    return HTMLElement;
}(node_1$1.default));
html.default = HTMLElement;
// https://html.spec.whatwg.org/multipage/custom-elements.html#valid-custom-element-name
var kMarkupPattern = /<!--[\s\S]*?-->|<(\/?)([a-zA-Z][-.:0-9_a-zA-Z]*)((?:\s+[^>]*?(?:(?:'[^']*')|(?:"[^"]*"))?)*)\s*(\/?)>/g;
var kAttributePattern = /(?:^|\s)(id|class)\s*=\s*((?:'[^']*')|(?:"[^"]*")|\S+)/gi;
var kSelfClosingElements = {
    area: true,
    AREA: true,
    base: true,
    BASE: true,
    br: true,
    BR: true,
    col: true,
    COL: true,
    hr: true,
    HR: true,
    img: true,
    IMG: true,
    input: true,
    INPUT: true,
    link: true,
    LINK: true,
    meta: true,
    META: true,
    source: true,
    SOURCE: true,
    embed: true,
    EMBED: true,
    param: true,
    PARAM: true,
    track: true,
    TRACK: true,
    wbr: true,
    WBR: true,
};
var kElementsClosedByOpening = {
    li: { li: true, LI: true },
    LI: { li: true, LI: true },
    p: { p: true, div: true, P: true, DIV: true },
    P: { p: true, div: true, P: true, DIV: true },
    b: { div: true, DIV: true },
    B: { div: true, DIV: true },
    td: { td: true, th: true, TD: true, TH: true },
    TD: { td: true, th: true, TD: true, TH: true },
    th: { td: true, th: true, TD: true, TH: true },
    TH: { td: true, th: true, TD: true, TH: true },
    h1: { h1: true, H1: true },
    H1: { h1: true, H1: true },
    h2: { h2: true, H2: true },
    H2: { h2: true, H2: true },
    h3: { h3: true, H3: true },
    H3: { h3: true, H3: true },
    h4: { h4: true, H4: true },
    H4: { h4: true, H4: true },
    h5: { h5: true, H5: true },
    H5: { h5: true, H5: true },
    h6: { h6: true, H6: true },
    H6: { h6: true, H6: true },
};
var kElementsClosedByClosing = {
    li: { ul: true, ol: true, UL: true, OL: true },
    LI: { ul: true, ol: true, UL: true, OL: true },
    a: { div: true, DIV: true },
    A: { div: true, DIV: true },
    b: { div: true, DIV: true },
    B: { div: true, DIV: true },
    i: { div: true, DIV: true },
    I: { div: true, DIV: true },
    p: { div: true, DIV: true },
    P: { div: true, DIV: true },
    td: { tr: true, table: true, TR: true, TABLE: true },
    TD: { tr: true, table: true, TR: true, TABLE: true },
    th: { tr: true, table: true, TR: true, TABLE: true },
    TH: { tr: true, table: true, TR: true, TABLE: true },
};
var frameflag = 'documentfragmentcontainer';
/**
 * Parses HTML and returns a root element
 * Parse a chuck of HTML source.
 * @param  {string} data      html
 * @return {HTMLElement}      root element
 */
function base_parse(data, options) {
    var _a, _b;
    if (options === void 0) { options = { lowerCaseTagName: false, comment: false }; }
    var voidTag = new void_tag_1.default((_a = options === null || options === void 0 ? void 0 : options.voidTag) === null || _a === void 0 ? void 0 : _a.closingSlash, (_b = options === null || options === void 0 ? void 0 : options.voidTag) === null || _b === void 0 ? void 0 : _b.tags);
    var elements = options.blockTextElements || {
        script: true,
        noscript: true,
        style: true,
        pre: true,
    };
    var element_names = Object.keys(elements);
    var kBlockTextElements = element_names.map(function (it) { return new RegExp("^".concat(it, "$"), 'i'); });
    var kIgnoreElements = element_names.filter(function (it) { return elements[it]; }).map(function (it) { return new RegExp("^".concat(it, "$"), 'i'); });
    function element_should_be_ignore(tag) {
        return kIgnoreElements.some(function (it) { return it.test(tag); });
    }
    function is_block_text_element(tag) {
        return kBlockTextElements.some(function (it) { return it.test(tag); });
    }
    var createRange = function (startPos, endPos) { return [startPos - frameFlagOffset, endPos - frameFlagOffset]; };
    var root = new HTMLElement(null, {}, '', null, [0, data.length], voidTag);
    var currentParent = root;
    var stack = [root];
    var lastTextPos = -1;
    var noNestedTagIndex = undefined;
    var match;
    // https://github.com/taoqf/node-html-parser/issues/38
    data = "<".concat(frameflag, ">").concat(data, "</").concat(frameflag, ">");
    var lowerCaseTagName = options.lowerCaseTagName;
    var dataEndPos = data.length - (frameflag.length + 2);
    var frameFlagOffset = frameflag.length + 2;
    while ((match = kMarkupPattern.exec(data))) {
        // Note: Object destructuring here consistently tests as higher performance than array destructuring
        // eslint-disable-next-line prefer-const
        var matchText = match[0], leadingSlash = match[1], tagName = match[2], attributes = match[3], closingSlash = match[4];
        var matchLength = matchText.length;
        var tagStartPos = kMarkupPattern.lastIndex - matchLength;
        var tagEndPos = kMarkupPattern.lastIndex;
        // Add TextNode if content
        if (lastTextPos > -1) {
            if (lastTextPos + matchLength < tagEndPos) {
                var text = data.substring(lastTextPos, tagStartPos);
                currentParent.appendChild(new text_1$1.default(text, currentParent, createRange(lastTextPos, tagStartPos)));
            }
        }
        lastTextPos = kMarkupPattern.lastIndex;
        // https://github.com/taoqf/node-html-parser/issues/38
        // Skip frameflag node
        if (tagName === frameflag)
            continue;
        // Handle comments
        if (matchText[1] === '!') {
            if (options.comment) {
                // Only keep what is in between <!-- and -->
                var text = data.substring(tagStartPos + 4, tagEndPos - 3);
                currentParent.appendChild(new comment_1$1.default(text, currentParent, createRange(tagStartPos, tagEndPos)));
            }
            continue;
        }
        /* -- Handle tag matching -- */
        // Fix tag casing if necessary
        if (lowerCaseTagName)
            tagName = tagName.toLowerCase();
        // Handle opening tags (ie. <this> not </that>)
        if (!leadingSlash) {
            /* Populate attributes */
            var attrs = {};
            for (var attMatch = void 0; (attMatch = kAttributePattern.exec(attributes));) {
                var key = attMatch[1], val = attMatch[2];
                var isQuoted = val[0] === "'" || val[0] === "\"";
                attrs[key.toLowerCase()] = isQuoted ? val.slice(1, val.length - 1) : val;
            }
            var parentTagName = currentParent.rawTagName;
            if (!closingSlash && kElementsClosedByOpening[parentTagName]) {
                if (kElementsClosedByOpening[parentTagName][tagName]) {
                    stack.pop();
                    currentParent = (0, back_1.default)(stack);
                }
            }
            // Prevent nested A tags by terminating the last A and starting a new one : see issue #144
            if (tagName === 'a' || tagName === 'A') {
                if (noNestedTagIndex !== undefined) {
                    stack.splice(noNestedTagIndex);
                    currentParent = (0, back_1.default)(stack);
                }
                noNestedTagIndex = stack.length;
            }
            var tagEndPos_1 = kMarkupPattern.lastIndex;
            var tagStartPos_1 = tagEndPos_1 - matchLength;
            currentParent = currentParent.appendChild(
            // Initialize range (end position updated later for closed tags)
            new HTMLElement(tagName, attrs, attributes.slice(1), null, createRange(tagStartPos_1, tagEndPos_1), voidTag));
            stack.push(currentParent);
            if (is_block_text_element(tagName)) {
                // Find closing tag
                var closeMarkup = "</".concat(tagName, ">");
                var closeIndex = lowerCaseTagName
                    ? data.toLocaleLowerCase().indexOf(closeMarkup, kMarkupPattern.lastIndex)
                    : data.indexOf(closeMarkup, kMarkupPattern.lastIndex);
                var textEndPos = closeIndex === -1 ? dataEndPos : closeIndex;
                if (element_should_be_ignore(tagName)) {
                    var text = data.substring(tagEndPos_1, textEndPos);
                    if (text.length > 0 && /\S/.test(text)) {
                        currentParent.appendChild(new text_1$1.default(text, currentParent, createRange(tagEndPos_1, textEndPos)));
                    }
                }
                if (closeIndex === -1) {
                    lastTextPos = kMarkupPattern.lastIndex = data.length + 1;
                }
                else {
                    lastTextPos = kMarkupPattern.lastIndex = closeIndex + closeMarkup.length;
                    // Cause to be treated as self-closing, because no close found
                    leadingSlash = '/';
                }
            }
        }
        // Handle closing tags or self-closed elements (ie </tag> or <br>)
        if (leadingSlash || closingSlash || kSelfClosingElements[tagName]) {
            while (true) {
                if (tagName === 'a' || tagName === 'A')
                    noNestedTagIndex = undefined;
                if (currentParent.rawTagName === tagName) {
                    // Update range end for closed tag
                    currentParent.range[1] = createRange(-1, Math.max(lastTextPos, tagEndPos))[1];
                    stack.pop();
                    currentParent = (0, back_1.default)(stack);
                    break;
                }
                else {
                    var parentTagName = currentParent.tagName;
                    // Trying to close current tag, and move on
                    if (kElementsClosedByClosing[parentTagName]) {
                        if (kElementsClosedByClosing[parentTagName][tagName]) {
                            stack.pop();
                            currentParent = (0, back_1.default)(stack);
                            continue;
                        }
                    }
                    // Use aggressive strategy to handle unmatching markups.
                    break;
                }
            }
        }
    }
    return stack;
}
html.base_parse = base_parse;
/**
 * Parses HTML and returns a root element
 * Parse a chuck of HTML source.
 */
function parse$a(data, options) {
    if (options === void 0) { options = { lowerCaseTagName: false, comment: false }; }
    var stack = base_parse(data, options);
    var root = stack[0];
    var _loop_1 = function () {
        // Handle each error elements.
        var last = stack.pop();
        var oneBefore = (0, back_1.default)(stack);
        if (last.parentNode && last.parentNode.parentNode) {
            if (last.parentNode === oneBefore && last.tagName === oneBefore.tagName) {
                // Pair error case <h3> <h3> handle : Fixes to <h3> </h3>
                // this is wrong, becouse this will put the H3 outside the current right position which should be inside the current Html Element, see issue 152 for more info
                if (options.parseNoneClosedTags !== true) {
                    oneBefore.removeChild(last);
                    last.childNodes.forEach(function (child) {
                        oneBefore.parentNode.appendChild(child);
                    });
                    stack.pop();
                }
            }
            else {
                // Single error  <div> <h3> </div> handle: Just removes <h3>
                // Why remove? this is already a HtmlElement and the missing <H3> is already added in this case. see issue 152 for more info
                // eslint-disable-next-line no-lonely-if
                if (options.parseNoneClosedTags !== true) {
                    oneBefore.removeChild(last);
                    last.childNodes.forEach(function (child) {
                        oneBefore.appendChild(child);
                    });
                }
            }
        }
    };
    while (stack.length > 1) {
        _loop_1();
    }
    // response.childNodes.forEach((node) => {
    // 	if (node instanceof HTMLElement) {
    // 		node.parentNode = null;
    // 	}
    // });
    return root;
}
html.parse = parse$a;
function resetParent(nodes, parent) {
    return nodes.map(function (node) {
        node.parentNode = parent;
        return node;
    });
}

var parse$9 = {};

(function (exports) {
	Object.defineProperty(exports, "__esModule", { value: true });
	exports.default = void 0;
	var html_1 = html;
	Object.defineProperty(exports, "default", { enumerable: true, get: function () { return html_1.parse; } }); 
} (parse$9));

var valid$1 = {};

Object.defineProperty(valid$1, "__esModule", { value: true });
var html_1$1 = html;
/**
 * Parses HTML and returns a root element
 * Parse a chuck of HTML source.
 */
function valid(data, options) {
    if (options === void 0) { options = { lowerCaseTagName: false, comment: false }; }
    var stack = (0, html_1$1.base_parse)(data, options);
    return Boolean(stack.length === 1);
}
valid$1.default = valid;

var __importDefault = (commonjsGlobal && commonjsGlobal.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(dist$1, "__esModule", { value: true });
dist$1.NodeType = dist$1.TextNode = dist$1.Node = dist$1.valid = dist$1.CommentNode = dist$1.HTMLElement = parse_2 = dist$1.parse = void 0;
var comment_1 = __importDefault(comment);
dist$1.CommentNode = comment_1.default;
var html_1 = __importDefault(html);
dist$1.HTMLElement = html_1.default;
var node_1 = __importDefault(node$4);
dist$1.Node = node_1.default;
var text_1 = __importDefault(text);
dist$1.TextNode = text_1.default;
var type_1 = __importDefault(type$1);
dist$1.NodeType = type_1.default;
var parse_1$1 = __importDefault(parse$9);
var valid_1 = __importDefault(valid$1);
dist$1.valid = valid_1.default;
function parse$8(data, options) {
    if (options === void 0) { options = {
        lowerCaseTagName: false,
        comment: false
    }; }
    return (0, parse_1$1.default)(data, options);
}
dist$1.default = parse$8;
var parse_2 = dist$1.parse = parse$8;
parse$8.parse = parse_1$1.default;
parse$8.HTMLElement = html_1.default;
parse$8.CommentNode = comment_1.default;
parse$8.valid = valid_1.default;
parse$8.Node = node_1.default;
parse$8.TextNode = text_1.default;
parse$8.NodeType = type_1.default;

var tasks = {};

var utils$l = {};

var array$1 = {};

Object.defineProperty(array$1, "__esModule", { value: true });
array$1.splitWhen = array$1.flatten = void 0;
function flatten(items) {
    return items.reduce((collection, item) => [].concat(collection, item), []);
}
array$1.flatten = flatten;
function splitWhen(items, predicate) {
    const result = [[]];
    let groupIndex = 0;
    for (const item of items) {
        if (predicate(item)) {
            groupIndex++;
            result[groupIndex] = [];
        }
        else {
            result[groupIndex].push(item);
        }
    }
    return result;
}
array$1.splitWhen = splitWhen;

var errno$1 = {};

Object.defineProperty(errno$1, "__esModule", { value: true });
errno$1.isEnoentCodeError = void 0;
function isEnoentCodeError(error) {
    return error.code === 'ENOENT';
}
errno$1.isEnoentCodeError = isEnoentCodeError;

var fs$i = {};

Object.defineProperty(fs$i, "__esModule", { value: true });
fs$i.createDirentFromStats = void 0;
class DirentFromStats$1 {
    constructor(name, stats) {
        this.name = name;
        this.isBlockDevice = stats.isBlockDevice.bind(stats);
        this.isCharacterDevice = stats.isCharacterDevice.bind(stats);
        this.isDirectory = stats.isDirectory.bind(stats);
        this.isFIFO = stats.isFIFO.bind(stats);
        this.isFile = stats.isFile.bind(stats);
        this.isSocket = stats.isSocket.bind(stats);
        this.isSymbolicLink = stats.isSymbolicLink.bind(stats);
    }
}
function createDirentFromStats$1(name, stats) {
    return new DirentFromStats$1(name, stats);
}
fs$i.createDirentFromStats = createDirentFromStats$1;

var path$o = {};

Object.defineProperty(path$o, "__esModule", { value: true });
path$o.convertPosixPathToPattern = path$o.convertWindowsPathToPattern = path$o.convertPathToPattern = path$o.escapePosixPath = path$o.escapeWindowsPath = path$o.escape = path$o.removeLeadingDotSegment = path$o.makeAbsolute = path$o.unixify = void 0;
const os$4 = require$$0__default$1["default"];
const path$n = path__default["default"];
const IS_WINDOWS_PLATFORM = os$4.platform() === 'win32';
const LEADING_DOT_SEGMENT_CHARACTERS_COUNT = 2; // ./ or .\\
/**
 * All non-escaped special characters.
 * Posix: ()*?[]{|}, !+@ before (, ! at the beginning, \\ before non-special characters.
 * Windows: (){}[], !+@ before (, ! at the beginning.
 */
const POSIX_UNESCAPED_GLOB_SYMBOLS_RE = /(\\?)([()*?[\]{|}]|^!|[!+@](?=\()|\\(?![!()*+?@[\]{|}]))/g;
const WINDOWS_UNESCAPED_GLOB_SYMBOLS_RE = /(\\?)([()[\]{}]|^!|[!+@](?=\())/g;
/**
 * The device path (\\.\ or \\?\).
 * https://learn.microsoft.com/en-us/dotnet/standard/io/file-path-formats#dos-device-paths
 */
const DOS_DEVICE_PATH_RE = /^\\\\([.?])/;
/**
 * All backslashes except those escaping special characters.
 * Windows: !()+@{}
 * https://learn.microsoft.com/en-us/windows/win32/fileio/naming-a-file#naming-conventions
 */
const WINDOWS_BACKSLASHES_RE = /\\(?![!()+@[\]{}])/g;
/**
 * Designed to work only with simple paths: `dir\\file`.
 */
function unixify(filepath) {
    return filepath.replace(/\\/g, '/');
}
path$o.unixify = unixify;
function makeAbsolute(cwd, filepath) {
    return path$n.resolve(cwd, filepath);
}
path$o.makeAbsolute = makeAbsolute;
function removeLeadingDotSegment(entry) {
    // We do not use `startsWith` because this is 10x slower than current implementation for some cases.
    // eslint-disable-next-line @typescript-eslint/prefer-string-starts-ends-with
    if (entry.charAt(0) === '.') {
        const secondCharactery = entry.charAt(1);
        if (secondCharactery === '/' || secondCharactery === '\\') {
            return entry.slice(LEADING_DOT_SEGMENT_CHARACTERS_COUNT);
        }
    }
    return entry;
}
path$o.removeLeadingDotSegment = removeLeadingDotSegment;
path$o.escape = IS_WINDOWS_PLATFORM ? escapeWindowsPath : escapePosixPath;
function escapeWindowsPath(pattern) {
    return pattern.replace(WINDOWS_UNESCAPED_GLOB_SYMBOLS_RE, '\\$2');
}
path$o.escapeWindowsPath = escapeWindowsPath;
function escapePosixPath(pattern) {
    return pattern.replace(POSIX_UNESCAPED_GLOB_SYMBOLS_RE, '\\$2');
}
path$o.escapePosixPath = escapePosixPath;
path$o.convertPathToPattern = IS_WINDOWS_PLATFORM ? convertWindowsPathToPattern : convertPosixPathToPattern;
function convertWindowsPathToPattern(filepath) {
    return escapeWindowsPath(filepath)
        .replace(DOS_DEVICE_PATH_RE, '//$1')
        .replace(WINDOWS_BACKSLASHES_RE, '/');
}
path$o.convertWindowsPathToPattern = convertWindowsPathToPattern;
function convertPosixPathToPattern(filepath) {
    return escapePosixPath(filepath);
}
path$o.convertPosixPathToPattern = convertPosixPathToPattern;

var pattern$1 = {};

/*!
 * is-extglob <https://github.com/jonschlinkert/is-extglob>
 *
 * Copyright (c) 2014-2016, Jon Schlinkert.
 * Licensed under the MIT License.
 */

var isExtglob$1 = function isExtglob(str) {
  if (typeof str !== 'string' || str === '') {
    return false;
  }

  var match;
  while ((match = /(\\).|([@?!+*]\(.*\))/g.exec(str))) {
    if (match[2]) return true;
    str = str.slice(match.index + match[0].length);
  }

  return false;
};

/*!
 * is-glob <https://github.com/jonschlinkert/is-glob>
 *
 * Copyright (c) 2014-2017, Jon Schlinkert.
 * Released under the MIT License.
 */

var isExtglob = isExtglob$1;
var chars$1 = { '{': '}', '(': ')', '[': ']'};
var strictCheck = function(str) {
  if (str[0] === '!') {
    return true;
  }
  var index = 0;
  var pipeIndex = -2;
  var closeSquareIndex = -2;
  var closeCurlyIndex = -2;
  var closeParenIndex = -2;
  var backSlashIndex = -2;
  while (index < str.length) {
    if (str[index] === '*') {
      return true;
    }

    if (str[index + 1] === '?' && /[\].+)]/.test(str[index])) {
      return true;
    }

    if (closeSquareIndex !== -1 && str[index] === '[' && str[index + 1] !== ']') {
      if (closeSquareIndex < index) {
        closeSquareIndex = str.indexOf(']', index);
      }
      if (closeSquareIndex > index) {
        if (backSlashIndex === -1 || backSlashIndex > closeSquareIndex) {
          return true;
        }
        backSlashIndex = str.indexOf('\\', index);
        if (backSlashIndex === -1 || backSlashIndex > closeSquareIndex) {
          return true;
        }
      }
    }

    if (closeCurlyIndex !== -1 && str[index] === '{' && str[index + 1] !== '}') {
      closeCurlyIndex = str.indexOf('}', index);
      if (closeCurlyIndex > index) {
        backSlashIndex = str.indexOf('\\', index);
        if (backSlashIndex === -1 || backSlashIndex > closeCurlyIndex) {
          return true;
        }
      }
    }

    if (closeParenIndex !== -1 && str[index] === '(' && str[index + 1] === '?' && /[:!=]/.test(str[index + 2]) && str[index + 3] !== ')') {
      closeParenIndex = str.indexOf(')', index);
      if (closeParenIndex > index) {
        backSlashIndex = str.indexOf('\\', index);
        if (backSlashIndex === -1 || backSlashIndex > closeParenIndex) {
          return true;
        }
      }
    }

    if (pipeIndex !== -1 && str[index] === '(' && str[index + 1] !== '|') {
      if (pipeIndex < index) {
        pipeIndex = str.indexOf('|', index);
      }
      if (pipeIndex !== -1 && str[pipeIndex + 1] !== ')') {
        closeParenIndex = str.indexOf(')', pipeIndex);
        if (closeParenIndex > pipeIndex) {
          backSlashIndex = str.indexOf('\\', pipeIndex);
          if (backSlashIndex === -1 || backSlashIndex > closeParenIndex) {
            return true;
          }
        }
      }
    }

    if (str[index] === '\\') {
      var open = str[index + 1];
      index += 2;
      var close = chars$1[open];

      if (close) {
        var n = str.indexOf(close, index);
        if (n !== -1) {
          index = n + 1;
        }
      }

      if (str[index] === '!') {
        return true;
      }
    } else {
      index++;
    }
  }
  return false;
};

var relaxedCheck = function(str) {
  if (str[0] === '!') {
    return true;
  }
  var index = 0;
  while (index < str.length) {
    if (/[*?{}()[\]]/.test(str[index])) {
      return true;
    }

    if (str[index] === '\\') {
      var open = str[index + 1];
      index += 2;
      var close = chars$1[open];

      if (close) {
        var n = str.indexOf(close, index);
        if (n !== -1) {
          index = n + 1;
        }
      }

      if (str[index] === '!') {
        return true;
      }
    } else {
      index++;
    }
  }
  return false;
};

var isGlob$1 = function isGlob(str, options) {
  if (typeof str !== 'string' || str === '') {
    return false;
  }

  if (isExtglob(str)) {
    return true;
  }

  var check = strictCheck;

  // optionally relax check
  if (options && options.strict === false) {
    check = relaxedCheck;
  }

  return check(str);
};

var isGlob = isGlob$1;
var pathPosixDirname = path__default["default"].posix.dirname;
var isWin32 = require$$0__default$1["default"].platform() === 'win32';

var slash = '/';
var backslash = /\\/g;
var enclosure = /[\{\[].*[\}\]]$/;
var globby = /(^|[^\\])([\{\[]|\([^\)]+$)/;
var escaped = /\\([\!\*\?\|\[\]\(\)\{\}])/g;

/**
 * @param {string} str
 * @param {Object} opts
 * @param {boolean} [opts.flipBackslashes=true]
 * @returns {string}
 */
var globParent$1 = function globParent(str, opts) {
  var options = Object.assign({ flipBackslashes: true }, opts);

  // flip windows path separators
  if (options.flipBackslashes && isWin32 && str.indexOf(slash) < 0) {
    str = str.replace(backslash, slash);
  }

  // special case for strings ending in enclosure containing path separator
  if (enclosure.test(str)) {
    str += slash;
  }

  // preserves full path in case of trailing path separator
  str += 'a';

  // remove path parts that are globby
  do {
    str = pathPosixDirname(str);
  } while (isGlob(str) || globby.test(str));

  // remove escape chars and return result
  return str.replace(escaped, '$1');
};

var utils$k = {};

(function (exports) {

	exports.isInteger = num => {
	  if (typeof num === 'number') {
	    return Number.isInteger(num);
	  }
	  if (typeof num === 'string' && num.trim() !== '') {
	    return Number.isInteger(Number(num));
	  }
	  return false;
	};

	/**
	 * Find a node of the given type
	 */

	exports.find = (node, type) => node.nodes.find(node => node.type === type);

	/**
	 * Find a node of the given type
	 */

	exports.exceedsLimit = (min, max, step = 1, limit) => {
	  if (limit === false) return false;
	  if (!exports.isInteger(min) || !exports.isInteger(max)) return false;
	  return ((Number(max) - Number(min)) / Number(step)) >= limit;
	};

	/**
	 * Escape the given node with '\\' before node.value
	 */

	exports.escapeNode = (block, n = 0, type) => {
	  let node = block.nodes[n];
	  if (!node) return;

	  if ((type && node.type === type) || node.type === 'open' || node.type === 'close') {
	    if (node.escaped !== true) {
	      node.value = '\\' + node.value;
	      node.escaped = true;
	    }
	  }
	};

	/**
	 * Returns true if the given brace node should be enclosed in literal braces
	 */

	exports.encloseBrace = node => {
	  if (node.type !== 'brace') return false;
	  if ((node.commas >> 0 + node.ranges >> 0) === 0) {
	    node.invalid = true;
	    return true;
	  }
	  return false;
	};

	/**
	 * Returns true if a brace node is invalid.
	 */

	exports.isInvalidBrace = block => {
	  if (block.type !== 'brace') return false;
	  if (block.invalid === true || block.dollar) return true;
	  if ((block.commas >> 0 + block.ranges >> 0) === 0) {
	    block.invalid = true;
	    return true;
	  }
	  if (block.open !== true || block.close !== true) {
	    block.invalid = true;
	    return true;
	  }
	  return false;
	};

	/**
	 * Returns true if a node is an open or close node
	 */

	exports.isOpenOrClose = node => {
	  if (node.type === 'open' || node.type === 'close') {
	    return true;
	  }
	  return node.open === true || node.close === true;
	};

	/**
	 * Reduce an array of text nodes.
	 */

	exports.reduce = nodes => nodes.reduce((acc, node) => {
	  if (node.type === 'text') acc.push(node.value);
	  if (node.type === 'range') node.type = 'text';
	  return acc;
	}, []);

	/**
	 * Flatten an array
	 */

	exports.flatten = (...args) => {
	  const result = [];
	  const flat = arr => {
	    for (let i = 0; i < arr.length; i++) {
	      let ele = arr[i];
	      Array.isArray(ele) ? flat(ele) : ele !== void 0 && result.push(ele);
	    }
	    return result;
	  };
	  flat(args);
	  return result;
	}; 
} (utils$k));

const utils$j = utils$k;

var stringify$5 = (ast, options = {}) => {
  let stringify = (node, parent = {}) => {
    let invalidBlock = options.escapeInvalid && utils$j.isInvalidBrace(parent);
    let invalidNode = node.invalid === true && options.escapeInvalid === true;
    let output = '';

    if (node.value) {
      if ((invalidBlock || invalidNode) && utils$j.isOpenOrClose(node)) {
        return '\\' + node.value;
      }
      return node.value;
    }

    if (node.value) {
      return node.value;
    }

    if (node.nodes) {
      for (let child of node.nodes) {
        output += stringify(child);
      }
    }
    return output;
  };

  return stringify(ast);
};

/*!
 * is-number <https://github.com/jonschlinkert/is-number>
 *
 * Copyright (c) 2014-present, Jon Schlinkert.
 * Released under the MIT License.
 */

var isNumber$3 = function(num) {
  if (typeof num === 'number') {
    return num - num === 0;
  }
  if (typeof num === 'string' && num.trim() !== '') {
    return Number.isFinite ? Number.isFinite(+num) : isFinite(+num);
  }
  return false;
};

/*!
 * to-regex-range <https://github.com/micromatch/to-regex-range>
 *
 * Copyright (c) 2015-present, Jon Schlinkert.
 * Released under the MIT License.
 */

const isNumber$2 = isNumber$3;

const toRegexRange$1 = (min, max, options) => {
  if (isNumber$2(min) === false) {
    throw new TypeError('toRegexRange: expected the first argument to be a number');
  }

  if (max === void 0 || min === max) {
    return String(min);
  }

  if (isNumber$2(max) === false) {
    throw new TypeError('toRegexRange: expected the second argument to be a number.');
  }

  let opts = { relaxZeros: true, ...options };
  if (typeof opts.strictZeros === 'boolean') {
    opts.relaxZeros = opts.strictZeros === false;
  }

  let relax = String(opts.relaxZeros);
  let shorthand = String(opts.shorthand);
  let capture = String(opts.capture);
  let wrap = String(opts.wrap);
  let cacheKey = min + ':' + max + '=' + relax + shorthand + capture + wrap;

  if (toRegexRange$1.cache.hasOwnProperty(cacheKey)) {
    return toRegexRange$1.cache[cacheKey].result;
  }

  let a = Math.min(min, max);
  let b = Math.max(min, max);

  if (Math.abs(a - b) === 1) {
    let result = min + '|' + max;
    if (opts.capture) {
      return `(${result})`;
    }
    if (opts.wrap === false) {
      return result;
    }
    return `(?:${result})`;
  }

  let isPadded = hasPadding(min) || hasPadding(max);
  let state = { min, max, a, b };
  let positives = [];
  let negatives = [];

  if (isPadded) {
    state.isPadded = isPadded;
    state.maxLen = String(state.max).length;
  }

  if (a < 0) {
    let newMin = b < 0 ? Math.abs(b) : 1;
    negatives = splitToPatterns(newMin, Math.abs(a), state, opts);
    a = state.a = 0;
  }

  if (b >= 0) {
    positives = splitToPatterns(a, b, state, opts);
  }

  state.negatives = negatives;
  state.positives = positives;
  state.result = collatePatterns(negatives, positives);

  if (opts.capture === true) {
    state.result = `(${state.result})`;
  } else if (opts.wrap !== false && (positives.length + negatives.length) > 1) {
    state.result = `(?:${state.result})`;
  }

  toRegexRange$1.cache[cacheKey] = state;
  return state.result;
};

function collatePatterns(neg, pos, options) {
  let onlyNegative = filterPatterns(neg, pos, '-', false) || [];
  let onlyPositive = filterPatterns(pos, neg, '', false) || [];
  let intersected = filterPatterns(neg, pos, '-?', true) || [];
  let subpatterns = onlyNegative.concat(intersected).concat(onlyPositive);
  return subpatterns.join('|');
}

function splitToRanges(min, max) {
  let nines = 1;
  let zeros = 1;

  let stop = countNines(min, nines);
  let stops = new Set([max]);

  while (min <= stop && stop <= max) {
    stops.add(stop);
    nines += 1;
    stop = countNines(min, nines);
  }

  stop = countZeros(max + 1, zeros) - 1;

  while (min < stop && stop <= max) {
    stops.add(stop);
    zeros += 1;
    stop = countZeros(max + 1, zeros) - 1;
  }

  stops = [...stops];
  stops.sort(compare);
  return stops;
}

/**
 * Convert a range to a regex pattern
 * @param {Number} `start`
 * @param {Number} `stop`
 * @return {String}
 */

function rangeToPattern(start, stop, options) {
  if (start === stop) {
    return { pattern: start, count: [], digits: 0 };
  }

  let zipped = zip(start, stop);
  let digits = zipped.length;
  let pattern = '';
  let count = 0;

  for (let i = 0; i < digits; i++) {
    let [startDigit, stopDigit] = zipped[i];

    if (startDigit === stopDigit) {
      pattern += startDigit;

    } else if (startDigit !== '0' || stopDigit !== '9') {
      pattern += toCharacterClass(startDigit, stopDigit);

    } else {
      count++;
    }
  }

  if (count) {
    pattern += options.shorthand === true ? '\\d' : '[0-9]';
  }

  return { pattern, count: [count], digits };
}

function splitToPatterns(min, max, tok, options) {
  let ranges = splitToRanges(min, max);
  let tokens = [];
  let start = min;
  let prev;

  for (let i = 0; i < ranges.length; i++) {
    let max = ranges[i];
    let obj = rangeToPattern(String(start), String(max), options);
    let zeros = '';

    if (!tok.isPadded && prev && prev.pattern === obj.pattern) {
      if (prev.count.length > 1) {
        prev.count.pop();
      }

      prev.count.push(obj.count[0]);
      prev.string = prev.pattern + toQuantifier(prev.count);
      start = max + 1;
      continue;
    }

    if (tok.isPadded) {
      zeros = padZeros(max, tok, options);
    }

    obj.string = zeros + obj.pattern + toQuantifier(obj.count);
    tokens.push(obj);
    start = max + 1;
    prev = obj;
  }

  return tokens;
}

function filterPatterns(arr, comparison, prefix, intersection, options) {
  let result = [];

  for (let ele of arr) {
    let { string } = ele;

    // only push if _both_ are negative...
    if (!intersection && !contains(comparison, 'string', string)) {
      result.push(prefix + string);
    }

    // or _both_ are positive
    if (intersection && contains(comparison, 'string', string)) {
      result.push(prefix + string);
    }
  }
  return result;
}

/**
 * Zip strings
 */

function zip(a, b) {
  let arr = [];
  for (let i = 0; i < a.length; i++) arr.push([a[i], b[i]]);
  return arr;
}

function compare(a, b) {
  return a > b ? 1 : b > a ? -1 : 0;
}

function contains(arr, key, val) {
  return arr.some(ele => ele[key] === val);
}

function countNines(min, len) {
  return Number(String(min).slice(0, -len) + '9'.repeat(len));
}

function countZeros(integer, zeros) {
  return integer - (integer % Math.pow(10, zeros));
}

function toQuantifier(digits) {
  let [start = 0, stop = ''] = digits;
  if (stop || start > 1) {
    return `{${start + (stop ? ',' + stop : '')}}`;
  }
  return '';
}

function toCharacterClass(a, b, options) {
  return `[${a}${(b - a === 1) ? '' : '-'}${b}]`;
}

function hasPadding(str) {
  return /^-?(0+)\d/.test(str);
}

function padZeros(value, tok, options) {
  if (!tok.isPadded) {
    return value;
  }

  let diff = Math.abs(tok.maxLen - String(value).length);
  let relax = options.relaxZeros !== false;

  switch (diff) {
    case 0:
      return '';
    case 1:
      return relax ? '0?' : '0';
    case 2:
      return relax ? '0{0,2}' : '00';
    default: {
      return relax ? `0{0,${diff}}` : `0{${diff}}`;
    }
  }
}

/**
 * Cache
 */

toRegexRange$1.cache = {};
toRegexRange$1.clearCache = () => (toRegexRange$1.cache = {});

/**
 * Expose `toRegexRange`
 */

var toRegexRange_1 = toRegexRange$1;

/*!
 * fill-range <https://github.com/jonschlinkert/fill-range>
 *
 * Copyright (c) 2014-present, Jon Schlinkert.
 * Licensed under the MIT License.
 */

const util$6 = require$$0__default$2["default"];
const toRegexRange = toRegexRange_1;

const isObject$1 = val => val !== null && typeof val === 'object' && !Array.isArray(val);

const transform$1 = toNumber => {
  return value => toNumber === true ? Number(value) : String(value);
};

const isValidValue = value => {
  return typeof value === 'number' || (typeof value === 'string' && value !== '');
};

const isNumber$1 = num => Number.isInteger(+num);

const zeros = input => {
  let value = `${input}`;
  let index = -1;
  if (value[0] === '-') value = value.slice(1);
  if (value === '0') return false;
  while (value[++index] === '0');
  return index > 0;
};

const stringify$4 = (start, end, options) => {
  if (typeof start === 'string' || typeof end === 'string') {
    return true;
  }
  return options.stringify === true;
};

const pad = (input, maxLength, toNumber) => {
  if (maxLength > 0) {
    let dash = input[0] === '-' ? '-' : '';
    if (dash) input = input.slice(1);
    input = (dash + input.padStart(dash ? maxLength - 1 : maxLength, '0'));
  }
  if (toNumber === false) {
    return String(input);
  }
  return input;
};

const toMaxLen = (input, maxLength) => {
  let negative = input[0] === '-' ? '-' : '';
  if (negative) {
    input = input.slice(1);
    maxLength--;
  }
  while (input.length < maxLength) input = '0' + input;
  return negative ? ('-' + input) : input;
};

const toSequence = (parts, options) => {
  parts.negatives.sort((a, b) => a < b ? -1 : a > b ? 1 : 0);
  parts.positives.sort((a, b) => a < b ? -1 : a > b ? 1 : 0);

  let prefix = options.capture ? '' : '?:';
  let positives = '';
  let negatives = '';
  let result;

  if (parts.positives.length) {
    positives = parts.positives.join('|');
  }

  if (parts.negatives.length) {
    negatives = `-(${prefix}${parts.negatives.join('|')})`;
  }

  if (positives && negatives) {
    result = `${positives}|${negatives}`;
  } else {
    result = positives || negatives;
  }

  if (options.wrap) {
    return `(${prefix}${result})`;
  }

  return result;
};

const toRange = (a, b, isNumbers, options) => {
  if (isNumbers) {
    return toRegexRange(a, b, { wrap: false, ...options });
  }

  let start = String.fromCharCode(a);
  if (a === b) return start;

  let stop = String.fromCharCode(b);
  return `[${start}-${stop}]`;
};

const toRegex = (start, end, options) => {
  if (Array.isArray(start)) {
    let wrap = options.wrap === true;
    let prefix = options.capture ? '' : '?:';
    return wrap ? `(${prefix}${start.join('|')})` : start.join('|');
  }
  return toRegexRange(start, end, options);
};

const rangeError = (...args) => {
  return new RangeError('Invalid range arguments: ' + util$6.inspect(...args));
};

const invalidRange = (start, end, options) => {
  if (options.strictRanges === true) throw rangeError([start, end]);
  return [];
};

const invalidStep = (step, options) => {
  if (options.strictRanges === true) {
    throw new TypeError(`Expected step "${step}" to be a number`);
  }
  return [];
};

const fillNumbers = (start, end, step = 1, options = {}) => {
  let a = Number(start);
  let b = Number(end);

  if (!Number.isInteger(a) || !Number.isInteger(b)) {
    if (options.strictRanges === true) throw rangeError([start, end]);
    return [];
  }

  // fix negative zero
  if (a === 0) a = 0;
  if (b === 0) b = 0;

  let descending = a > b;
  let startString = String(start);
  let endString = String(end);
  let stepString = String(step);
  step = Math.max(Math.abs(step), 1);

  let padded = zeros(startString) || zeros(endString) || zeros(stepString);
  let maxLen = padded ? Math.max(startString.length, endString.length, stepString.length) : 0;
  let toNumber = padded === false && stringify$4(start, end, options) === false;
  let format = options.transform || transform$1(toNumber);

  if (options.toRegex && step === 1) {
    return toRange(toMaxLen(start, maxLen), toMaxLen(end, maxLen), true, options);
  }

  let parts = { negatives: [], positives: [] };
  let push = num => parts[num < 0 ? 'negatives' : 'positives'].push(Math.abs(num));
  let range = [];
  let index = 0;

  while (descending ? a >= b : a <= b) {
    if (options.toRegex === true && step > 1) {
      push(a);
    } else {
      range.push(pad(format(a, index), maxLen, toNumber));
    }
    a = descending ? a - step : a + step;
    index++;
  }

  if (options.toRegex === true) {
    return step > 1
      ? toSequence(parts, options)
      : toRegex(range, null, { wrap: false, ...options });
  }

  return range;
};

const fillLetters = (start, end, step = 1, options = {}) => {
  if ((!isNumber$1(start) && start.length > 1) || (!isNumber$1(end) && end.length > 1)) {
    return invalidRange(start, end, options);
  }


  let format = options.transform || (val => String.fromCharCode(val));
  let a = `${start}`.charCodeAt(0);
  let b = `${end}`.charCodeAt(0);

  let descending = a > b;
  let min = Math.min(a, b);
  let max = Math.max(a, b);

  if (options.toRegex && step === 1) {
    return toRange(min, max, false, options);
  }

  let range = [];
  let index = 0;

  while (descending ? a >= b : a <= b) {
    range.push(format(a, index));
    a = descending ? a - step : a + step;
    index++;
  }

  if (options.toRegex === true) {
    return toRegex(range, null, { wrap: false, options });
  }

  return range;
};

const fill$2 = (start, end, step, options = {}) => {
  if (end == null && isValidValue(start)) {
    return [start];
  }

  if (!isValidValue(start) || !isValidValue(end)) {
    return invalidRange(start, end, options);
  }

  if (typeof step === 'function') {
    return fill$2(start, end, 1, { transform: step });
  }

  if (isObject$1(step)) {
    return fill$2(start, end, 0, step);
  }

  let opts = { ...options };
  if (opts.capture === true) opts.wrap = true;
  step = step || opts.step || 1;

  if (!isNumber$1(step)) {
    if (step != null && !isObject$1(step)) return invalidStep(step, opts);
    return fill$2(start, end, 1, step);
  }

  if (isNumber$1(start) && isNumber$1(end)) {
    return fillNumbers(start, end, step, opts);
  }

  return fillLetters(start, end, Math.max(Math.abs(step), 1), opts);
};

var fillRange = fill$2;

const fill$1 = fillRange;
const utils$i = utils$k;

const compile$1 = (ast, options = {}) => {
  let walk = (node, parent = {}) => {
    let invalidBlock = utils$i.isInvalidBrace(parent);
    let invalidNode = node.invalid === true && options.escapeInvalid === true;
    let invalid = invalidBlock === true || invalidNode === true;
    let prefix = options.escapeInvalid === true ? '\\' : '';
    let output = '';

    if (node.isOpen === true) {
      return prefix + node.value;
    }
    if (node.isClose === true) {
      return prefix + node.value;
    }

    if (node.type === 'open') {
      return invalid ? (prefix + node.value) : '(';
    }

    if (node.type === 'close') {
      return invalid ? (prefix + node.value) : ')';
    }

    if (node.type === 'comma') {
      return node.prev.type === 'comma' ? '' : (invalid ? node.value : '|');
    }

    if (node.value) {
      return node.value;
    }

    if (node.nodes && node.ranges > 0) {
      let args = utils$i.reduce(node.nodes);
      let range = fill$1(...args, { ...options, wrap: false, toRegex: true });

      if (range.length !== 0) {
        return args.length > 1 && range.length > 1 ? `(${range})` : range;
      }
    }

    if (node.nodes) {
      for (let child of node.nodes) {
        output += walk(child, node);
      }
    }
    return output;
  };

  return walk(ast);
};

var compile_1 = compile$1;

const fill = fillRange;
const stringify$3 = stringify$5;
const utils$h = utils$k;

const append = (queue = '', stash = '', enclose = false) => {
  let result = [];

  queue = [].concat(queue);
  stash = [].concat(stash);

  if (!stash.length) return queue;
  if (!queue.length) {
    return enclose ? utils$h.flatten(stash).map(ele => `{${ele}}`) : stash;
  }

  for (let item of queue) {
    if (Array.isArray(item)) {
      for (let value of item) {
        result.push(append(value, stash, enclose));
      }
    } else {
      for (let ele of stash) {
        if (enclose === true && typeof ele === 'string') ele = `{${ele}}`;
        result.push(Array.isArray(ele) ? append(item, ele, enclose) : (item + ele));
      }
    }
  }
  return utils$h.flatten(result);
};

const expand$1 = (ast, options = {}) => {
  let rangeLimit = options.rangeLimit === void 0 ? 1000 : options.rangeLimit;

  let walk = (node, parent = {}) => {
    node.queue = [];

    let p = parent;
    let q = parent.queue;

    while (p.type !== 'brace' && p.type !== 'root' && p.parent) {
      p = p.parent;
      q = p.queue;
    }

    if (node.invalid || node.dollar) {
      q.push(append(q.pop(), stringify$3(node, options)));
      return;
    }

    if (node.type === 'brace' && node.invalid !== true && node.nodes.length === 2) {
      q.push(append(q.pop(), ['{}']));
      return;
    }

    if (node.nodes && node.ranges > 0) {
      let args = utils$h.reduce(node.nodes);

      if (utils$h.exceedsLimit(...args, options.step, rangeLimit)) {
        throw new RangeError('expanded array length exceeds range limit. Use options.rangeLimit to increase or disable the limit.');
      }

      let range = fill(...args, options);
      if (range.length === 0) {
        range = stringify$3(node, options);
      }

      q.push(append(q.pop(), range));
      node.nodes = [];
      return;
    }

    let enclose = utils$h.encloseBrace(node);
    let queue = node.queue;
    let block = node;

    while (block.type !== 'brace' && block.type !== 'root' && block.parent) {
      block = block.parent;
      queue = block.queue;
    }

    for (let i = 0; i < node.nodes.length; i++) {
      let child = node.nodes[i];

      if (child.type === 'comma' && node.type === 'brace') {
        if (i === 1) queue.push('');
        queue.push('');
        continue;
      }

      if (child.type === 'close') {
        q.push(append(q.pop(), queue, enclose));
        continue;
      }

      if (child.value && child.type !== 'open') {
        queue.push(append(queue.pop(), child.value));
        continue;
      }

      if (child.nodes) {
        walk(child, node);
      }
    }

    return queue;
  };

  return utils$h.flatten(walk(ast));
};

var expand_1 = expand$1;

var constants$7 = {
  MAX_LENGTH: 1024 * 64,

  // Digits
  CHAR_0: '0', /* 0 */
  CHAR_9: '9', /* 9 */

  // Alphabet chars.
  CHAR_UPPERCASE_A: 'A', /* A */
  CHAR_LOWERCASE_A: 'a', /* a */
  CHAR_UPPERCASE_Z: 'Z', /* Z */
  CHAR_LOWERCASE_Z: 'z', /* z */

  CHAR_LEFT_PARENTHESES: '(', /* ( */
  CHAR_RIGHT_PARENTHESES: ')', /* ) */

  CHAR_ASTERISK: '*', /* * */

  // Non-alphabetic chars.
  CHAR_AMPERSAND: '&', /* & */
  CHAR_AT: '@', /* @ */
  CHAR_BACKSLASH: '\\', /* \ */
  CHAR_BACKTICK: '`', /* ` */
  CHAR_CARRIAGE_RETURN: '\r', /* \r */
  CHAR_CIRCUMFLEX_ACCENT: '^', /* ^ */
  CHAR_COLON: ':', /* : */
  CHAR_COMMA: ',', /* , */
  CHAR_DOLLAR: '$', /* . */
  CHAR_DOT: '.', /* . */
  CHAR_DOUBLE_QUOTE: '"', /* " */
  CHAR_EQUAL: '=', /* = */
  CHAR_EXCLAMATION_MARK: '!', /* ! */
  CHAR_FORM_FEED: '\f', /* \f */
  CHAR_FORWARD_SLASH: '/', /* / */
  CHAR_HASH: '#', /* # */
  CHAR_HYPHEN_MINUS: '-', /* - */
  CHAR_LEFT_ANGLE_BRACKET: '<', /* < */
  CHAR_LEFT_CURLY_BRACE: '{', /* { */
  CHAR_LEFT_SQUARE_BRACKET: '[', /* [ */
  CHAR_LINE_FEED: '\n', /* \n */
  CHAR_NO_BREAK_SPACE: '\u00A0', /* \u00A0 */
  CHAR_PERCENT: '%', /* % */
  CHAR_PLUS: '+', /* + */
  CHAR_QUESTION_MARK: '?', /* ? */
  CHAR_RIGHT_ANGLE_BRACKET: '>', /* > */
  CHAR_RIGHT_CURLY_BRACE: '}', /* } */
  CHAR_RIGHT_SQUARE_BRACKET: ']', /* ] */
  CHAR_SEMICOLON: ';', /* ; */
  CHAR_SINGLE_QUOTE: '\'', /* ' */
  CHAR_SPACE: ' ', /*   */
  CHAR_TAB: '\t', /* \t */
  CHAR_UNDERSCORE: '_', /* _ */
  CHAR_VERTICAL_LINE: '|', /* | */
  CHAR_ZERO_WIDTH_NOBREAK_SPACE: '\uFEFF' /* \uFEFF */
};

const stringify$2 = stringify$5;

/**
 * Constants
 */

const {
  MAX_LENGTH,
  CHAR_BACKSLASH, /* \ */
  CHAR_BACKTICK, /* ` */
  CHAR_COMMA, /* , */
  CHAR_DOT, /* . */
  CHAR_LEFT_PARENTHESES, /* ( */
  CHAR_RIGHT_PARENTHESES, /* ) */
  CHAR_LEFT_CURLY_BRACE, /* { */
  CHAR_RIGHT_CURLY_BRACE, /* } */
  CHAR_LEFT_SQUARE_BRACKET, /* [ */
  CHAR_RIGHT_SQUARE_BRACKET, /* ] */
  CHAR_DOUBLE_QUOTE, /* " */
  CHAR_SINGLE_QUOTE, /* ' */
  CHAR_NO_BREAK_SPACE,
  CHAR_ZERO_WIDTH_NOBREAK_SPACE
} = constants$7;

/**
 * parse
 */

const parse$7 = (input, options = {}) => {
  if (typeof input !== 'string') {
    throw new TypeError('Expected a string');
  }

  let opts = options || {};
  let max = typeof opts.maxLength === 'number' ? Math.min(MAX_LENGTH, opts.maxLength) : MAX_LENGTH;
  if (input.length > max) {
    throw new SyntaxError(`Input length (${input.length}), exceeds max characters (${max})`);
  }

  let ast = { type: 'root', input, nodes: [] };
  let stack = [ast];
  let block = ast;
  let prev = ast;
  let brackets = 0;
  let length = input.length;
  let index = 0;
  let depth = 0;
  let value;

  /**
   * Helpers
   */

  const advance = () => input[index++];
  const push = node => {
    if (node.type === 'text' && prev.type === 'dot') {
      prev.type = 'text';
    }

    if (prev && prev.type === 'text' && node.type === 'text') {
      prev.value += node.value;
      return;
    }

    block.nodes.push(node);
    node.parent = block;
    node.prev = prev;
    prev = node;
    return node;
  };

  push({ type: 'bos' });

  while (index < length) {
    block = stack[stack.length - 1];
    value = advance();

    /**
     * Invalid chars
     */

    if (value === CHAR_ZERO_WIDTH_NOBREAK_SPACE || value === CHAR_NO_BREAK_SPACE) {
      continue;
    }

    /**
     * Escaped chars
     */

    if (value === CHAR_BACKSLASH) {
      push({ type: 'text', value: (options.keepEscaping ? value : '') + advance() });
      continue;
    }

    /**
     * Right square bracket (literal): ']'
     */

    if (value === CHAR_RIGHT_SQUARE_BRACKET) {
      push({ type: 'text', value: '\\' + value });
      continue;
    }

    /**
     * Left square bracket: '['
     */

    if (value === CHAR_LEFT_SQUARE_BRACKET) {
      brackets++;
      let next;

      while (index < length && (next = advance())) {
        value += next;

        if (next === CHAR_LEFT_SQUARE_BRACKET) {
          brackets++;
          continue;
        }

        if (next === CHAR_BACKSLASH) {
          value += advance();
          continue;
        }

        if (next === CHAR_RIGHT_SQUARE_BRACKET) {
          brackets--;

          if (brackets === 0) {
            break;
          }
        }
      }

      push({ type: 'text', value });
      continue;
    }

    /**
     * Parentheses
     */

    if (value === CHAR_LEFT_PARENTHESES) {
      block = push({ type: 'paren', nodes: [] });
      stack.push(block);
      push({ type: 'text', value });
      continue;
    }

    if (value === CHAR_RIGHT_PARENTHESES) {
      if (block.type !== 'paren') {
        push({ type: 'text', value });
        continue;
      }
      block = stack.pop();
      push({ type: 'text', value });
      block = stack[stack.length - 1];
      continue;
    }

    /**
     * Quotes: '|"|`
     */

    if (value === CHAR_DOUBLE_QUOTE || value === CHAR_SINGLE_QUOTE || value === CHAR_BACKTICK) {
      let open = value;
      let next;

      if (options.keepQuotes !== true) {
        value = '';
      }

      while (index < length && (next = advance())) {
        if (next === CHAR_BACKSLASH) {
          value += next + advance();
          continue;
        }

        if (next === open) {
          if (options.keepQuotes === true) value += next;
          break;
        }

        value += next;
      }

      push({ type: 'text', value });
      continue;
    }

    /**
     * Left curly brace: '{'
     */

    if (value === CHAR_LEFT_CURLY_BRACE) {
      depth++;

      let dollar = prev.value && prev.value.slice(-1) === '$' || block.dollar === true;
      let brace = {
        type: 'brace',
        open: true,
        close: false,
        dollar,
        depth,
        commas: 0,
        ranges: 0,
        nodes: []
      };

      block = push(brace);
      stack.push(block);
      push({ type: 'open', value });
      continue;
    }

    /**
     * Right curly brace: '}'
     */

    if (value === CHAR_RIGHT_CURLY_BRACE) {
      if (block.type !== 'brace') {
        push({ type: 'text', value });
        continue;
      }

      let type = 'close';
      block = stack.pop();
      block.close = true;

      push({ type, value });
      depth--;

      block = stack[stack.length - 1];
      continue;
    }

    /**
     * Comma: ','
     */

    if (value === CHAR_COMMA && depth > 0) {
      if (block.ranges > 0) {
        block.ranges = 0;
        let open = block.nodes.shift();
        block.nodes = [open, { type: 'text', value: stringify$2(block) }];
      }

      push({ type: 'comma', value });
      block.commas++;
      continue;
    }

    /**
     * Dot: '.'
     */

    if (value === CHAR_DOT && depth > 0 && block.commas === 0) {
      let siblings = block.nodes;

      if (depth === 0 || siblings.length === 0) {
        push({ type: 'text', value });
        continue;
      }

      if (prev.type === 'dot') {
        block.range = [];
        prev.value += value;
        prev.type = 'range';

        if (block.nodes.length !== 3 && block.nodes.length !== 5) {
          block.invalid = true;
          block.ranges = 0;
          prev.type = 'text';
          continue;
        }

        block.ranges++;
        block.args = [];
        continue;
      }

      if (prev.type === 'range') {
        siblings.pop();

        let before = siblings[siblings.length - 1];
        before.value += prev.value + value;
        prev = before;
        block.ranges--;
        continue;
      }

      push({ type: 'dot', value });
      continue;
    }

    /**
     * Text
     */

    push({ type: 'text', value });
  }

  // Mark imbalanced braces and brackets as invalid
  do {
    block = stack.pop();

    if (block.type !== 'root') {
      block.nodes.forEach(node => {
        if (!node.nodes) {
          if (node.type === 'open') node.isOpen = true;
          if (node.type === 'close') node.isClose = true;
          if (!node.nodes) node.type = 'text';
          node.invalid = true;
        }
      });

      // get the location of the block on parent.nodes (block's siblings)
      let parent = stack[stack.length - 1];
      let index = parent.nodes.indexOf(block);
      // replace the (invalid) block with it's nodes
      parent.nodes.splice(index, 1, ...block.nodes);
    }
  } while (stack.length > 0);

  push({ type: 'eos' });
  return ast;
};

var parse_1 = parse$7;

const stringify$1 = stringify$5;
const compile = compile_1;
const expand = expand_1;
const parse$6 = parse_1;

/**
 * Expand the given pattern or create a regex-compatible string.
 *
 * ```js
 * const braces = require('braces');
 * console.log(braces('{a,b,c}', { compile: true })); //=> ['(a|b|c)']
 * console.log(braces('{a,b,c}')); //=> ['a', 'b', 'c']
 * ```
 * @param {String} `str`
 * @param {Object} `options`
 * @return {String}
 * @api public
 */

const braces$1 = (input, options = {}) => {
  let output = [];

  if (Array.isArray(input)) {
    for (let pattern of input) {
      let result = braces$1.create(pattern, options);
      if (Array.isArray(result)) {
        output.push(...result);
      } else {
        output.push(result);
      }
    }
  } else {
    output = [].concat(braces$1.create(input, options));
  }

  if (options && options.expand === true && options.nodupes === true) {
    output = [...new Set(output)];
  }
  return output;
};

/**
 * Parse the given `str` with the given `options`.
 *
 * ```js
 * // braces.parse(pattern, [, options]);
 * const ast = braces.parse('a/{b,c}/d');
 * console.log(ast);
 * ```
 * @param {String} pattern Brace pattern to parse
 * @param {Object} options
 * @return {Object} Returns an AST
 * @api public
 */

braces$1.parse = (input, options = {}) => parse$6(input, options);

/**
 * Creates a braces string from an AST, or an AST node.
 *
 * ```js
 * const braces = require('braces');
 * let ast = braces.parse('foo/{a,b}/bar');
 * console.log(stringify(ast.nodes[2])); //=> '{a,b}'
 * ```
 * @param {String} `input` Brace pattern or AST.
 * @param {Object} `options`
 * @return {Array} Returns an array of expanded values.
 * @api public
 */

braces$1.stringify = (input, options = {}) => {
  if (typeof input === 'string') {
    return stringify$1(braces$1.parse(input, options), options);
  }
  return stringify$1(input, options);
};

/**
 * Compiles a brace pattern into a regex-compatible, optimized string.
 * This method is called by the main [braces](#braces) function by default.
 *
 * ```js
 * const braces = require('braces');
 * console.log(braces.compile('a/{b,c}/d'));
 * //=> ['a/(b|c)/d']
 * ```
 * @param {String} `input` Brace pattern or AST.
 * @param {Object} `options`
 * @return {Array} Returns an array of expanded values.
 * @api public
 */

braces$1.compile = (input, options = {}) => {
  if (typeof input === 'string') {
    input = braces$1.parse(input, options);
  }
  return compile(input, options);
};

/**
 * Expands a brace pattern into an array. This method is called by the
 * main [braces](#braces) function when `options.expand` is true. Before
 * using this method it's recommended that you read the [performance notes](#performance))
 * and advantages of using [.compile](#compile) instead.
 *
 * ```js
 * const braces = require('braces');
 * console.log(braces.expand('a/{b,c}/d'));
 * //=> ['a/b/d', 'a/c/d'];
 * ```
 * @param {String} `pattern` Brace pattern
 * @param {Object} `options`
 * @return {Array} Returns an array of expanded values.
 * @api public
 */

braces$1.expand = (input, options = {}) => {
  if (typeof input === 'string') {
    input = braces$1.parse(input, options);
  }

  let result = expand(input, options);

  // filter out empty strings if specified
  if (options.noempty === true) {
    result = result.filter(Boolean);
  }

  // filter out duplicates if specified
  if (options.nodupes === true) {
    result = [...new Set(result)];
  }

  return result;
};

/**
 * Processes a brace pattern and returns either an expanded array
 * (if `options.expand` is true), a highly optimized regex-compatible string.
 * This method is called by the main [braces](#braces) function.
 *
 * ```js
 * const braces = require('braces');
 * console.log(braces.create('user-{200..300}/project-{a,b,c}-{1..10}'))
 * //=> 'user-(20[0-9]|2[1-9][0-9]|300)/project-(a|b|c)-([1-9]|10)'
 * ```
 * @param {String} `pattern` Brace pattern
 * @param {Object} `options`
 * @return {Array} Returns an array of expanded values.
 * @api public
 */

braces$1.create = (input, options = {}) => {
  if (input === '' || input.length < 3) {
    return [input];
  }

 return options.expand !== true
    ? braces$1.compile(input, options)
    : braces$1.expand(input, options);
};

/**
 * Expose "braces"
 */

var braces_1 = braces$1;

const util$5 = require$$0__default$2["default"];
const braces = braces_1;
const picomatch = picomatch$1;
const utils$g = utils$s;
const isEmptyString = val => val === '' || val === './';

/**
 * Returns an array of strings that match one or more glob patterns.
 *
 * ```js
 * const mm = require('micromatch');
 * // mm(list, patterns[, options]);
 *
 * console.log(mm(['a.js', 'a.txt'], ['*.js']));
 * //=> [ 'a.js' ]
 * ```
 * @param {String|Array<string>} `list` List of strings to match.
 * @param {String|Array<string>} `patterns` One or more glob patterns to use for matching.
 * @param {Object} `options` See available [options](#options)
 * @return {Array} Returns an array of matches
 * @summary false
 * @api public
 */

const micromatch$1 = (list, patterns, options) => {
  patterns = [].concat(patterns);
  list = [].concat(list);

  let omit = new Set();
  let keep = new Set();
  let items = new Set();
  let negatives = 0;

  let onResult = state => {
    items.add(state.output);
    if (options && options.onResult) {
      options.onResult(state);
    }
  };

  for (let i = 0; i < patterns.length; i++) {
    let isMatch = picomatch(String(patterns[i]), { ...options, onResult }, true);
    let negated = isMatch.state.negated || isMatch.state.negatedExtglob;
    if (negated) negatives++;

    for (let item of list) {
      let matched = isMatch(item, true);

      let match = negated ? !matched.isMatch : matched.isMatch;
      if (!match) continue;

      if (negated) {
        omit.add(matched.output);
      } else {
        omit.delete(matched.output);
        keep.add(matched.output);
      }
    }
  }

  let result = negatives === patterns.length ? [...items] : [...keep];
  let matches = result.filter(item => !omit.has(item));

  if (options && matches.length === 0) {
    if (options.failglob === true) {
      throw new Error(`No matches found for "${patterns.join(', ')}"`);
    }

    if (options.nonull === true || options.nullglob === true) {
      return options.unescape ? patterns.map(p => p.replace(/\\/g, '')) : patterns;
    }
  }

  return matches;
};

/**
 * Backwards compatibility
 */

micromatch$1.match = micromatch$1;

/**
 * Returns a matcher function from the given glob `pattern` and `options`.
 * The returned function takes a string to match as its only argument and returns
 * true if the string is a match.
 *
 * ```js
 * const mm = require('micromatch');
 * // mm.matcher(pattern[, options]);
 *
 * const isMatch = mm.matcher('*.!(*a)');
 * console.log(isMatch('a.a')); //=> false
 * console.log(isMatch('a.b')); //=> true
 * ```
 * @param {String} `pattern` Glob pattern
 * @param {Object} `options`
 * @return {Function} Returns a matcher function.
 * @api public
 */

micromatch$1.matcher = (pattern, options) => picomatch(pattern, options);

/**
 * Returns true if **any** of the given glob `patterns` match the specified `string`.
 *
 * ```js
 * const mm = require('micromatch');
 * // mm.isMatch(string, patterns[, options]);
 *
 * console.log(mm.isMatch('a.a', ['b.*', '*.a'])); //=> true
 * console.log(mm.isMatch('a.a', 'b.*')); //=> false
 * ```
 * @param {String} `str` The string to test.
 * @param {String|Array} `patterns` One or more glob patterns to use for matching.
 * @param {Object} `[options]` See available [options](#options).
 * @return {Boolean} Returns true if any patterns match `str`
 * @api public
 */

micromatch$1.isMatch = (str, patterns, options) => picomatch(patterns, options)(str);

/**
 * Backwards compatibility
 */

micromatch$1.any = micromatch$1.isMatch;

/**
 * Returns a list of strings that _**do not match any**_ of the given `patterns`.
 *
 * ```js
 * const mm = require('micromatch');
 * // mm.not(list, patterns[, options]);
 *
 * console.log(mm.not(['a.a', 'b.b', 'c.c'], '*.a'));
 * //=> ['b.b', 'c.c']
 * ```
 * @param {Array} `list` Array of strings to match.
 * @param {String|Array} `patterns` One or more glob pattern to use for matching.
 * @param {Object} `options` See available [options](#options) for changing how matches are performed
 * @return {Array} Returns an array of strings that **do not match** the given patterns.
 * @api public
 */

micromatch$1.not = (list, patterns, options = {}) => {
  patterns = [].concat(patterns).map(String);
  let result = new Set();
  let items = [];

  let onResult = state => {
    if (options.onResult) options.onResult(state);
    items.push(state.output);
  };

  let matches = new Set(micromatch$1(list, patterns, { ...options, onResult }));

  for (let item of items) {
    if (!matches.has(item)) {
      result.add(item);
    }
  }
  return [...result];
};

/**
 * Returns true if the given `string` contains the given pattern. Similar
 * to [.isMatch](#isMatch) but the pattern can match any part of the string.
 *
 * ```js
 * var mm = require('micromatch');
 * // mm.contains(string, pattern[, options]);
 *
 * console.log(mm.contains('aa/bb/cc', '*b'));
 * //=> true
 * console.log(mm.contains('aa/bb/cc', '*d'));
 * //=> false
 * ```
 * @param {String} `str` The string to match.
 * @param {String|Array} `patterns` Glob pattern to use for matching.
 * @param {Object} `options` See available [options](#options) for changing how matches are performed
 * @return {Boolean} Returns true if any of the patterns matches any part of `str`.
 * @api public
 */

micromatch$1.contains = (str, pattern, options) => {
  if (typeof str !== 'string') {
    throw new TypeError(`Expected a string: "${util$5.inspect(str)}"`);
  }

  if (Array.isArray(pattern)) {
    return pattern.some(p => micromatch$1.contains(str, p, options));
  }

  if (typeof pattern === 'string') {
    if (isEmptyString(str) || isEmptyString(pattern)) {
      return false;
    }

    if (str.includes(pattern) || (str.startsWith('./') && str.slice(2).includes(pattern))) {
      return true;
    }
  }

  return micromatch$1.isMatch(str, pattern, { ...options, contains: true });
};

/**
 * Filter the keys of the given object with the given `glob` pattern
 * and `options`. Does not attempt to match nested keys. If you need this feature,
 * use [glob-object][] instead.
 *
 * ```js
 * const mm = require('micromatch');
 * // mm.matchKeys(object, patterns[, options]);
 *
 * const obj = { aa: 'a', ab: 'b', ac: 'c' };
 * console.log(mm.matchKeys(obj, '*b'));
 * //=> { ab: 'b' }
 * ```
 * @param {Object} `object` The object with keys to filter.
 * @param {String|Array} `patterns` One or more glob patterns to use for matching.
 * @param {Object} `options` See available [options](#options) for changing how matches are performed
 * @return {Object} Returns an object with only keys that match the given patterns.
 * @api public
 */

micromatch$1.matchKeys = (obj, patterns, options) => {
  if (!utils$g.isObject(obj)) {
    throw new TypeError('Expected the first argument to be an object');
  }
  let keys = micromatch$1(Object.keys(obj), patterns, options);
  let res = {};
  for (let key of keys) res[key] = obj[key];
  return res;
};

/**
 * Returns true if some of the strings in the given `list` match any of the given glob `patterns`.
 *
 * ```js
 * const mm = require('micromatch');
 * // mm.some(list, patterns[, options]);
 *
 * console.log(mm.some(['foo.js', 'bar.js'], ['*.js', '!foo.js']));
 * // true
 * console.log(mm.some(['foo.js'], ['*.js', '!foo.js']));
 * // false
 * ```
 * @param {String|Array} `list` The string or array of strings to test. Returns as soon as the first match is found.
 * @param {String|Array} `patterns` One or more glob patterns to use for matching.
 * @param {Object} `options` See available [options](#options) for changing how matches are performed
 * @return {Boolean} Returns true if any `patterns` matches any of the strings in `list`
 * @api public
 */

micromatch$1.some = (list, patterns, options) => {
  let items = [].concat(list);

  for (let pattern of [].concat(patterns)) {
    let isMatch = picomatch(String(pattern), options);
    if (items.some(item => isMatch(item))) {
      return true;
    }
  }
  return false;
};

/**
 * Returns true if every string in the given `list` matches
 * any of the given glob `patterns`.
 *
 * ```js
 * const mm = require('micromatch');
 * // mm.every(list, patterns[, options]);
 *
 * console.log(mm.every('foo.js', ['foo.js']));
 * // true
 * console.log(mm.every(['foo.js', 'bar.js'], ['*.js']));
 * // true
 * console.log(mm.every(['foo.js', 'bar.js'], ['*.js', '!foo.js']));
 * // false
 * console.log(mm.every(['foo.js'], ['*.js', '!foo.js']));
 * // false
 * ```
 * @param {String|Array} `list` The string or array of strings to test.
 * @param {String|Array} `patterns` One or more glob patterns to use for matching.
 * @param {Object} `options` See available [options](#options) for changing how matches are performed
 * @return {Boolean} Returns true if all `patterns` matches all of the strings in `list`
 * @api public
 */

micromatch$1.every = (list, patterns, options) => {
  let items = [].concat(list);

  for (let pattern of [].concat(patterns)) {
    let isMatch = picomatch(String(pattern), options);
    if (!items.every(item => isMatch(item))) {
      return false;
    }
  }
  return true;
};

/**
 * Returns true if **all** of the given `patterns` match
 * the specified string.
 *
 * ```js
 * const mm = require('micromatch');
 * // mm.all(string, patterns[, options]);
 *
 * console.log(mm.all('foo.js', ['foo.js']));
 * // true
 *
 * console.log(mm.all('foo.js', ['*.js', '!foo.js']));
 * // false
 *
 * console.log(mm.all('foo.js', ['*.js', 'foo.js']));
 * // true
 *
 * console.log(mm.all('foo.js', ['*.js', 'f*', '*o*', '*o.js']));
 * // true
 * ```
 * @param {String|Array} `str` The string to test.
 * @param {String|Array} `patterns` One or more glob patterns to use for matching.
 * @param {Object} `options` See available [options](#options) for changing how matches are performed
 * @return {Boolean} Returns true if any patterns match `str`
 * @api public
 */

micromatch$1.all = (str, patterns, options) => {
  if (typeof str !== 'string') {
    throw new TypeError(`Expected a string: "${util$5.inspect(str)}"`);
  }

  return [].concat(patterns).every(p => picomatch(p, options)(str));
};

/**
 * Returns an array of matches captured by `pattern` in `string, or `null` if the pattern did not match.
 *
 * ```js
 * const mm = require('micromatch');
 * // mm.capture(pattern, string[, options]);
 *
 * console.log(mm.capture('test/*.js', 'test/foo.js'));
 * //=> ['foo']
 * console.log(mm.capture('test/*.js', 'foo/bar.css'));
 * //=> null
 * ```
 * @param {String} `glob` Glob pattern to use for matching.
 * @param {String} `input` String to match
 * @param {Object} `options` See available [options](#options) for changing how matches are performed
 * @return {Array|null} Returns an array of captures if the input matches the glob pattern, otherwise `null`.
 * @api public
 */

micromatch$1.capture = (glob, input, options) => {
  let posix = utils$g.isWindows(options);
  let regex = picomatch.makeRe(String(glob), { ...options, capture: true });
  let match = regex.exec(posix ? utils$g.toPosixSlashes(input) : input);

  if (match) {
    return match.slice(1).map(v => v === void 0 ? '' : v);
  }
};

/**
 * Create a regular expression from the given glob `pattern`.
 *
 * ```js
 * const mm = require('micromatch');
 * // mm.makeRe(pattern[, options]);
 *
 * console.log(mm.makeRe('*.js'));
 * //=> /^(?:(\.[\\\/])?(?!\.)(?=.)[^\/]*?\.js)$/
 * ```
 * @param {String} `pattern` A glob pattern to convert to regex.
 * @param {Object} `options`
 * @return {RegExp} Returns a regex created from the given pattern.
 * @api public
 */

micromatch$1.makeRe = (...args) => picomatch.makeRe(...args);

/**
 * Scan a glob pattern to separate the pattern into segments. Used
 * by the [split](#split) method.
 *
 * ```js
 * const mm = require('micromatch');
 * const state = mm.scan(pattern[, options]);
 * ```
 * @param {String} `pattern`
 * @param {Object} `options`
 * @return {Object} Returns an object with
 * @api public
 */

micromatch$1.scan = (...args) => picomatch.scan(...args);

/**
 * Parse a glob pattern to create the source string for a regular
 * expression.
 *
 * ```js
 * const mm = require('micromatch');
 * const state = mm.parse(pattern[, options]);
 * ```
 * @param {String} `glob`
 * @param {Object} `options`
 * @return {Object} Returns an object with useful properties and output to be used as regex source string.
 * @api public
 */

micromatch$1.parse = (patterns, options) => {
  let res = [];
  for (let pattern of [].concat(patterns || [])) {
    for (let str of braces(String(pattern), options)) {
      res.push(picomatch.parse(str, options));
    }
  }
  return res;
};

/**
 * Process the given brace `pattern`.
 *
 * ```js
 * const { braces } = require('micromatch');
 * console.log(braces('foo/{a,b,c}/bar'));
 * //=> [ 'foo/(a|b|c)/bar' ]
 *
 * console.log(braces('foo/{a,b,c}/bar', { expand: true }));
 * //=> [ 'foo/a/bar', 'foo/b/bar', 'foo/c/bar' ]
 * ```
 * @param {String} `pattern` String with brace pattern to process.
 * @param {Object} `options` Any [options](#options) to change how expansion is performed. See the [braces][] library for all available options.
 * @return {Array}
 * @api public
 */

micromatch$1.braces = (pattern, options) => {
  if (typeof pattern !== 'string') throw new TypeError('Expected a string');
  if ((options && options.nobrace === true) || !/\{.*\}/.test(pattern)) {
    return [pattern];
  }
  return braces(pattern, options);
};

/**
 * Expand braces
 */

micromatch$1.braceExpand = (pattern, options) => {
  if (typeof pattern !== 'string') throw new TypeError('Expected a string');
  return micromatch$1.braces(pattern, { ...options, expand: true });
};

/**
 * Expose micromatch
 */

var micromatch_1 = micromatch$1;

Object.defineProperty(pattern$1, "__esModule", { value: true });
pattern$1.removeDuplicateSlashes = pattern$1.matchAny = pattern$1.convertPatternsToRe = pattern$1.makeRe = pattern$1.getPatternParts = pattern$1.expandBraceExpansion = pattern$1.expandPatternsWithBraceExpansion = pattern$1.isAffectDepthOfReadingPattern = pattern$1.endsWithSlashGlobStar = pattern$1.hasGlobStar = pattern$1.getBaseDirectory = pattern$1.isPatternRelatedToParentDirectory = pattern$1.getPatternsOutsideCurrentDirectory = pattern$1.getPatternsInsideCurrentDirectory = pattern$1.getPositivePatterns = pattern$1.getNegativePatterns = pattern$1.isPositivePattern = pattern$1.isNegativePattern = pattern$1.convertToNegativePattern = pattern$1.convertToPositivePattern = pattern$1.isDynamicPattern = pattern$1.isStaticPattern = void 0;
const path$m = path__default["default"];
const globParent = globParent$1;
const micromatch = micromatch_1;
const GLOBSTAR = '**';
const ESCAPE_SYMBOL = '\\';
const COMMON_GLOB_SYMBOLS_RE = /[*?]|^!/;
const REGEX_CHARACTER_CLASS_SYMBOLS_RE = /\[[^[]*]/;
const REGEX_GROUP_SYMBOLS_RE = /(?:^|[^!*+?@])\([^(]*\|[^|]*\)/;
const GLOB_EXTENSION_SYMBOLS_RE = /[!*+?@]\([^(]*\)/;
const BRACE_EXPANSION_SEPARATORS_RE = /,|\.\./;
/**
 * Matches a sequence of two or more consecutive slashes, excluding the first two slashes at the beginning of the string.
 * The latter is due to the presence of the device path at the beginning of the UNC path.
 */
const DOUBLE_SLASH_RE = /(?!^)\/{2,}/g;
function isStaticPattern(pattern, options = {}) {
    return !isDynamicPattern(pattern, options);
}
pattern$1.isStaticPattern = isStaticPattern;
function isDynamicPattern(pattern, options = {}) {
    /**
     * A special case with an empty string is necessary for matching patterns that start with a forward slash.
     * An empty string cannot be a dynamic pattern.
     * For example, the pattern `/lib/*` will be spread into parts: '', 'lib', '*'.
     */
    if (pattern === '') {
        return false;
    }
    /**
     * When the `caseSensitiveMatch` option is disabled, all patterns must be marked as dynamic, because we cannot check
     * filepath directly (without read directory).
     */
    if (options.caseSensitiveMatch === false || pattern.includes(ESCAPE_SYMBOL)) {
        return true;
    }
    if (COMMON_GLOB_SYMBOLS_RE.test(pattern) || REGEX_CHARACTER_CLASS_SYMBOLS_RE.test(pattern) || REGEX_GROUP_SYMBOLS_RE.test(pattern)) {
        return true;
    }
    if (options.extglob !== false && GLOB_EXTENSION_SYMBOLS_RE.test(pattern)) {
        return true;
    }
    if (options.braceExpansion !== false && hasBraceExpansion(pattern)) {
        return true;
    }
    return false;
}
pattern$1.isDynamicPattern = isDynamicPattern;
function hasBraceExpansion(pattern) {
    const openingBraceIndex = pattern.indexOf('{');
    if (openingBraceIndex === -1) {
        return false;
    }
    const closingBraceIndex = pattern.indexOf('}', openingBraceIndex + 1);
    if (closingBraceIndex === -1) {
        return false;
    }
    const braceContent = pattern.slice(openingBraceIndex, closingBraceIndex);
    return BRACE_EXPANSION_SEPARATORS_RE.test(braceContent);
}
function convertToPositivePattern(pattern) {
    return isNegativePattern(pattern) ? pattern.slice(1) : pattern;
}
pattern$1.convertToPositivePattern = convertToPositivePattern;
function convertToNegativePattern(pattern) {
    return '!' + pattern;
}
pattern$1.convertToNegativePattern = convertToNegativePattern;
function isNegativePattern(pattern) {
    return pattern.startsWith('!') && pattern[1] !== '(';
}
pattern$1.isNegativePattern = isNegativePattern;
function isPositivePattern(pattern) {
    return !isNegativePattern(pattern);
}
pattern$1.isPositivePattern = isPositivePattern;
function getNegativePatterns(patterns) {
    return patterns.filter(isNegativePattern);
}
pattern$1.getNegativePatterns = getNegativePatterns;
function getPositivePatterns$1(patterns) {
    return patterns.filter(isPositivePattern);
}
pattern$1.getPositivePatterns = getPositivePatterns$1;
/**
 * Returns patterns that can be applied inside the current directory.
 *
 * @example
 * // ['./*', '*', 'a/*']
 * getPatternsInsideCurrentDirectory(['./*', '*', 'a/*', '../*', './../*'])
 */
function getPatternsInsideCurrentDirectory(patterns) {
    return patterns.filter((pattern) => !isPatternRelatedToParentDirectory(pattern));
}
pattern$1.getPatternsInsideCurrentDirectory = getPatternsInsideCurrentDirectory;
/**
 * Returns patterns to be expanded relative to (outside) the current directory.
 *
 * @example
 * // ['../*', './../*']
 * getPatternsInsideCurrentDirectory(['./*', '*', 'a/*', '../*', './../*'])
 */
function getPatternsOutsideCurrentDirectory(patterns) {
    return patterns.filter(isPatternRelatedToParentDirectory);
}
pattern$1.getPatternsOutsideCurrentDirectory = getPatternsOutsideCurrentDirectory;
function isPatternRelatedToParentDirectory(pattern) {
    return pattern.startsWith('..') || pattern.startsWith('./..');
}
pattern$1.isPatternRelatedToParentDirectory = isPatternRelatedToParentDirectory;
function getBaseDirectory(pattern) {
    return globParent(pattern, { flipBackslashes: false });
}
pattern$1.getBaseDirectory = getBaseDirectory;
function hasGlobStar(pattern) {
    return pattern.includes(GLOBSTAR);
}
pattern$1.hasGlobStar = hasGlobStar;
function endsWithSlashGlobStar(pattern) {
    return pattern.endsWith('/' + GLOBSTAR);
}
pattern$1.endsWithSlashGlobStar = endsWithSlashGlobStar;
function isAffectDepthOfReadingPattern(pattern) {
    const basename = path$m.basename(pattern);
    return endsWithSlashGlobStar(pattern) || isStaticPattern(basename);
}
pattern$1.isAffectDepthOfReadingPattern = isAffectDepthOfReadingPattern;
function expandPatternsWithBraceExpansion(patterns) {
    return patterns.reduce((collection, pattern) => {
        return collection.concat(expandBraceExpansion(pattern));
    }, []);
}
pattern$1.expandPatternsWithBraceExpansion = expandPatternsWithBraceExpansion;
function expandBraceExpansion(pattern) {
    const patterns = micromatch.braces(pattern, { expand: true, nodupes: true, keepEscaping: true });
    /**
     * Sort the patterns by length so that the same depth patterns are processed side by side.
     * `a/{b,}/{c,}/*` – `['a///*', 'a/b//*', 'a//c/*', 'a/b/c/*']`
     */
    patterns.sort((a, b) => a.length - b.length);
    /**
     * Micromatch can return an empty string in the case of patterns like `{a,}`.
     */
    return patterns.filter((pattern) => pattern !== '');
}
pattern$1.expandBraceExpansion = expandBraceExpansion;
function getPatternParts(pattern, options) {
    let { parts } = micromatch.scan(pattern, Object.assign(Object.assign({}, options), { parts: true }));
    /**
     * The scan method returns an empty array in some cases.
     * See micromatch/picomatch#58 for more details.
     */
    if (parts.length === 0) {
        parts = [pattern];
    }
    /**
     * The scan method does not return an empty part for the pattern with a forward slash.
     * This is another part of micromatch/picomatch#58.
     */
    if (parts[0].startsWith('/')) {
        parts[0] = parts[0].slice(1);
        parts.unshift('');
    }
    return parts;
}
pattern$1.getPatternParts = getPatternParts;
function makeRe(pattern, options) {
    return micromatch.makeRe(pattern, options);
}
pattern$1.makeRe = makeRe;
function convertPatternsToRe(patterns, options) {
    return patterns.map((pattern) => makeRe(pattern, options));
}
pattern$1.convertPatternsToRe = convertPatternsToRe;
function matchAny(entry, patternsRe) {
    return patternsRe.some((patternRe) => patternRe.test(entry));
}
pattern$1.matchAny = matchAny;
/**
 * This package only works with forward slashes as a path separator.
 * Because of this, we cannot use the standard `path.normalize` method, because on Windows platform it will use of backslashes.
 */
function removeDuplicateSlashes(pattern) {
    return pattern.replace(DOUBLE_SLASH_RE, '/');
}
pattern$1.removeDuplicateSlashes = removeDuplicateSlashes;

var stream$6 = {};

/*
 * merge2
 * https://github.com/teambition/merge2
 *
 * Copyright (c) 2014-2020 Teambition
 * Licensed under the MIT license.
 */
const Stream = require$$0__default$4["default"];
const PassThrough = Stream.PassThrough;
const slice = Array.prototype.slice;

var merge2_1 = merge2$1;

function merge2$1 () {
  const streamsQueue = [];
  const args = slice.call(arguments);
  let merging = false;
  let options = args[args.length - 1];

  if (options && !Array.isArray(options) && options.pipe == null) {
    args.pop();
  } else {
    options = {};
  }

  const doEnd = options.end !== false;
  const doPipeError = options.pipeError === true;
  if (options.objectMode == null) {
    options.objectMode = true;
  }
  if (options.highWaterMark == null) {
    options.highWaterMark = 64 * 1024;
  }
  const mergedStream = PassThrough(options);

  function addStream () {
    for (let i = 0, len = arguments.length; i < len; i++) {
      streamsQueue.push(pauseStreams(arguments[i], options));
    }
    mergeStream();
    return this
  }

  function mergeStream () {
    if (merging) {
      return
    }
    merging = true;

    let streams = streamsQueue.shift();
    if (!streams) {
      process.nextTick(endStream);
      return
    }
    if (!Array.isArray(streams)) {
      streams = [streams];
    }

    let pipesCount = streams.length + 1;

    function next () {
      if (--pipesCount > 0) {
        return
      }
      merging = false;
      mergeStream();
    }

    function pipe (stream) {
      function onend () {
        stream.removeListener('merge2UnpipeEnd', onend);
        stream.removeListener('end', onend);
        if (doPipeError) {
          stream.removeListener('error', onerror);
        }
        next();
      }
      function onerror (err) {
        mergedStream.emit('error', err);
      }
      // skip ended stream
      if (stream._readableState.endEmitted) {
        return next()
      }

      stream.on('merge2UnpipeEnd', onend);
      stream.on('end', onend);

      if (doPipeError) {
        stream.on('error', onerror);
      }

      stream.pipe(mergedStream, { end: false });
      // compatible for old stream
      stream.resume();
    }

    for (let i = 0; i < streams.length; i++) {
      pipe(streams[i]);
    }

    next();
  }

  function endStream () {
    merging = false;
    // emit 'queueDrain' when all streams merged.
    mergedStream.emit('queueDrain');
    if (doEnd) {
      mergedStream.end();
    }
  }

  mergedStream.setMaxListeners(0);
  mergedStream.add = addStream;
  mergedStream.on('unpipe', function (stream) {
    stream.emit('merge2UnpipeEnd');
  });

  if (args.length) {
    addStream.apply(null, args);
  }
  return mergedStream
}

// check and pause streams for pipe.
function pauseStreams (streams, options) {
  if (!Array.isArray(streams)) {
    // Backwards-compat with old-style streams
    if (!streams._readableState && streams.pipe) {
      streams = streams.pipe(PassThrough(options));
    }
    if (!streams._readableState || !streams.pause || !streams.pipe) {
      throw new Error('Only readable stream can be merged.')
    }
    streams.pause();
  } else {
    for (let i = 0, len = streams.length; i < len; i++) {
      streams[i] = pauseStreams(streams[i], options);
    }
  }
  return streams
}

Object.defineProperty(stream$6, "__esModule", { value: true });
stream$6.merge = void 0;
const merge2 = merge2_1;
function merge$1(streams) {
    const mergedStream = merge2(streams);
    streams.forEach((stream) => {
        stream.once('error', (error) => mergedStream.emit('error', error));
    });
    mergedStream.once('close', () => propagateCloseEventToSources(streams));
    mergedStream.once('end', () => propagateCloseEventToSources(streams));
    return mergedStream;
}
stream$6.merge = merge$1;
function propagateCloseEventToSources(streams) {
    streams.forEach((stream) => stream.emit('close'));
}

var string$2 = {};

Object.defineProperty(string$2, "__esModule", { value: true });
string$2.isEmpty = string$2.isString = void 0;
function isString(input) {
    return typeof input === 'string';
}
string$2.isString = isString;
function isEmpty(input) {
    return input === '';
}
string$2.isEmpty = isEmpty;

Object.defineProperty(utils$l, "__esModule", { value: true });
utils$l.string = utils$l.stream = utils$l.pattern = utils$l.path = utils$l.fs = utils$l.errno = utils$l.array = void 0;
const array = array$1;
utils$l.array = array;
const errno = errno$1;
utils$l.errno = errno;
const fs$h = fs$i;
utils$l.fs = fs$h;
const path$l = path$o;
utils$l.path = path$l;
const pattern = pattern$1;
utils$l.pattern = pattern;
const stream$5 = stream$6;
utils$l.stream = stream$5;
const string$1 = string$2;
utils$l.string = string$1;

Object.defineProperty(tasks, "__esModule", { value: true });
tasks.convertPatternGroupToTask = tasks.convertPatternGroupsToTasks = tasks.groupPatternsByBaseDirectory = tasks.getNegativePatternsAsPositive = tasks.getPositivePatterns = tasks.convertPatternsToTasks = tasks.generate = void 0;
const utils$f = utils$l;
function generate$1(input, settings) {
    const patterns = processPatterns(input, settings);
    const ignore = processPatterns(settings.ignore, settings);
    const positivePatterns = getPositivePatterns(patterns);
    const negativePatterns = getNegativePatternsAsPositive(patterns, ignore);
    const staticPatterns = positivePatterns.filter((pattern) => utils$f.pattern.isStaticPattern(pattern, settings));
    const dynamicPatterns = positivePatterns.filter((pattern) => utils$f.pattern.isDynamicPattern(pattern, settings));
    const staticTasks = convertPatternsToTasks(staticPatterns, negativePatterns, /* dynamic */ false);
    const dynamicTasks = convertPatternsToTasks(dynamicPatterns, negativePatterns, /* dynamic */ true);
    return staticTasks.concat(dynamicTasks);
}
tasks.generate = generate$1;
function processPatterns(input, settings) {
    let patterns = input;
    /**
     * The original pattern like `{,*,**,a/*}` can lead to problems checking the depth when matching entry
     * and some problems with the micromatch package (see fast-glob issues: #365, #394).
     *
     * To solve this problem, we expand all patterns containing brace expansion. This can lead to a slight slowdown
     * in matching in the case of a large set of patterns after expansion.
     */
    if (settings.braceExpansion) {
        patterns = utils$f.pattern.expandPatternsWithBraceExpansion(patterns);
    }
    /**
     * If the `baseNameMatch` option is enabled, we must add globstar to patterns, so that they can be used
     * at any nesting level.
     *
     * We do this here, because otherwise we have to complicate the filtering logic. For example, we need to change
     * the pattern in the filter before creating a regular expression. There is no need to change the patterns
     * in the application. Only on the input.
     */
    if (settings.baseNameMatch) {
        patterns = patterns.map((pattern) => pattern.includes('/') ? pattern : `**/${pattern}`);
    }
    /**
     * This method also removes duplicate slashes that may have been in the pattern or formed as a result of expansion.
     */
    return patterns.map((pattern) => utils$f.pattern.removeDuplicateSlashes(pattern));
}
/**
 * Returns tasks grouped by basic pattern directories.
 *
 * Patterns that can be found inside (`./`) and outside (`../`) the current directory are handled separately.
 * This is necessary because directory traversal starts at the base directory and goes deeper.
 */
function convertPatternsToTasks(positive, negative, dynamic) {
    const tasks = [];
    const patternsOutsideCurrentDirectory = utils$f.pattern.getPatternsOutsideCurrentDirectory(positive);
    const patternsInsideCurrentDirectory = utils$f.pattern.getPatternsInsideCurrentDirectory(positive);
    const outsideCurrentDirectoryGroup = groupPatternsByBaseDirectory(patternsOutsideCurrentDirectory);
    const insideCurrentDirectoryGroup = groupPatternsByBaseDirectory(patternsInsideCurrentDirectory);
    tasks.push(...convertPatternGroupsToTasks(outsideCurrentDirectoryGroup, negative, dynamic));
    /*
     * For the sake of reducing future accesses to the file system, we merge all tasks within the current directory
     * into a global task, if at least one pattern refers to the root (`.`). In this case, the global task covers the rest.
     */
    if ('.' in insideCurrentDirectoryGroup) {
        tasks.push(convertPatternGroupToTask('.', patternsInsideCurrentDirectory, negative, dynamic));
    }
    else {
        tasks.push(...convertPatternGroupsToTasks(insideCurrentDirectoryGroup, negative, dynamic));
    }
    return tasks;
}
tasks.convertPatternsToTasks = convertPatternsToTasks;
function getPositivePatterns(patterns) {
    return utils$f.pattern.getPositivePatterns(patterns);
}
tasks.getPositivePatterns = getPositivePatterns;
function getNegativePatternsAsPositive(patterns, ignore) {
    const negative = utils$f.pattern.getNegativePatterns(patterns).concat(ignore);
    const positive = negative.map(utils$f.pattern.convertToPositivePattern);
    return positive;
}
tasks.getNegativePatternsAsPositive = getNegativePatternsAsPositive;
function groupPatternsByBaseDirectory(patterns) {
    const group = {};
    return patterns.reduce((collection, pattern) => {
        const base = utils$f.pattern.getBaseDirectory(pattern);
        if (base in collection) {
            collection[base].push(pattern);
        }
        else {
            collection[base] = [pattern];
        }
        return collection;
    }, group);
}
tasks.groupPatternsByBaseDirectory = groupPatternsByBaseDirectory;
function convertPatternGroupsToTasks(positive, negative, dynamic) {
    return Object.keys(positive).map((base) => {
        return convertPatternGroupToTask(base, positive[base], negative, dynamic);
    });
}
tasks.convertPatternGroupsToTasks = convertPatternGroupsToTasks;
function convertPatternGroupToTask(base, positive, negative, dynamic) {
    return {
        dynamic,
        positive,
        negative,
        base,
        patterns: [].concat(positive, negative.map(utils$f.pattern.convertToNegativePattern))
    };
}
tasks.convertPatternGroupToTask = convertPatternGroupToTask;

var async$a = {};

var async$9 = {};

var out$3 = {};

var async$8 = {};

var async$7 = {};

var out$2 = {};

var async$6 = {};

var out$1 = {};

var async$5 = {};

Object.defineProperty(async$5, "__esModule", { value: true });
async$5.read = void 0;
function read$4(path, settings, callback) {
    settings.fs.lstat(path, (lstatError, lstat) => {
        if (lstatError !== null) {
            callFailureCallback$2(callback, lstatError);
            return;
        }
        if (!lstat.isSymbolicLink() || !settings.followSymbolicLink) {
            callSuccessCallback$2(callback, lstat);
            return;
        }
        settings.fs.stat(path, (statError, stat) => {
            if (statError !== null) {
                if (settings.throwErrorOnBrokenSymbolicLink) {
                    callFailureCallback$2(callback, statError);
                    return;
                }
                callSuccessCallback$2(callback, lstat);
                return;
            }
            if (settings.markSymbolicLink) {
                stat.isSymbolicLink = () => true;
            }
            callSuccessCallback$2(callback, stat);
        });
    });
}
async$5.read = read$4;
function callFailureCallback$2(callback, error) {
    callback(error);
}
function callSuccessCallback$2(callback, result) {
    callback(null, result);
}

var sync$8 = {};

Object.defineProperty(sync$8, "__esModule", { value: true });
sync$8.read = void 0;
function read$3(path, settings) {
    const lstat = settings.fs.lstatSync(path);
    if (!lstat.isSymbolicLink() || !settings.followSymbolicLink) {
        return lstat;
    }
    try {
        const stat = settings.fs.statSync(path);
        if (settings.markSymbolicLink) {
            stat.isSymbolicLink = () => true;
        }
        return stat;
    }
    catch (error) {
        if (!settings.throwErrorOnBrokenSymbolicLink) {
            return lstat;
        }
        throw error;
    }
}
sync$8.read = read$3;

var settings$3 = {};

var fs$g = {};

(function (exports) {
	Object.defineProperty(exports, "__esModule", { value: true });
	exports.createFileSystemAdapter = exports.FILE_SYSTEM_ADAPTER = void 0;
	const fs = require$$0__default["default"];
	exports.FILE_SYSTEM_ADAPTER = {
	    lstat: fs.lstat,
	    stat: fs.stat,
	    lstatSync: fs.lstatSync,
	    statSync: fs.statSync
	};
	function createFileSystemAdapter(fsMethods) {
	    if (fsMethods === undefined) {
	        return exports.FILE_SYSTEM_ADAPTER;
	    }
	    return Object.assign(Object.assign({}, exports.FILE_SYSTEM_ADAPTER), fsMethods);
	}
	exports.createFileSystemAdapter = createFileSystemAdapter; 
} (fs$g));

Object.defineProperty(settings$3, "__esModule", { value: true });
const fs$f = fs$g;
class Settings$2 {
    constructor(_options = {}) {
        this._options = _options;
        this.followSymbolicLink = this._getValue(this._options.followSymbolicLink, true);
        this.fs = fs$f.createFileSystemAdapter(this._options.fs);
        this.markSymbolicLink = this._getValue(this._options.markSymbolicLink, false);
        this.throwErrorOnBrokenSymbolicLink = this._getValue(this._options.throwErrorOnBrokenSymbolicLink, true);
    }
    _getValue(option, value) {
        return option !== null && option !== void 0 ? option : value;
    }
}
settings$3.default = Settings$2;

Object.defineProperty(out$1, "__esModule", { value: true });
out$1.statSync = out$1.stat = out$1.Settings = void 0;
const async$4 = async$5;
const sync$7 = sync$8;
const settings_1$3 = settings$3;
out$1.Settings = settings_1$3.default;
function stat(path, optionsOrSettingsOrCallback, callback) {
    if (typeof optionsOrSettingsOrCallback === 'function') {
        async$4.read(path, getSettings$2(), optionsOrSettingsOrCallback);
        return;
    }
    async$4.read(path, getSettings$2(optionsOrSettingsOrCallback), callback);
}
out$1.stat = stat;
function statSync(path, optionsOrSettings) {
    const settings = getSettings$2(optionsOrSettings);
    return sync$7.read(path, settings);
}
out$1.statSync = statSync;
function getSettings$2(settingsOrOptions = {}) {
    if (settingsOrOptions instanceof settings_1$3.default) {
        return settingsOrOptions;
    }
    return new settings_1$3.default(settingsOrOptions);
}

/*! queue-microtask. MIT License. Feross Aboukhadijeh <https://feross.org/opensource> */

let promise;

var queueMicrotask_1 = typeof queueMicrotask === 'function'
  ? queueMicrotask.bind(typeof window !== 'undefined' ? window : commonjsGlobal)
  // reuse resolved promise, and allocate it lazily
  : cb => (promise || (promise = Promise.resolve()))
    .then(cb)
    .catch(err => setTimeout(() => { throw err }, 0));

/*! run-parallel. MIT License. Feross Aboukhadijeh <https://feross.org/opensource> */

var runParallel_1 = runParallel;

const queueMicrotask$1 = queueMicrotask_1;

function runParallel (tasks, cb) {
  let results, pending, keys;
  let isSync = true;

  if (Array.isArray(tasks)) {
    results = [];
    pending = tasks.length;
  } else {
    keys = Object.keys(tasks);
    results = {};
    pending = keys.length;
  }

  function done (err) {
    function end () {
      if (cb) cb(err, results);
      cb = null;
    }
    if (isSync) queueMicrotask$1(end);
    else end();
  }

  function each (i, err, result) {
    results[i] = result;
    if (--pending === 0 || err) {
      done(err);
    }
  }

  if (!pending) {
    // empty
    done(null);
  } else if (keys) {
    // object
    keys.forEach(function (key) {
      tasks[key](function (err, result) { each(key, err, result); });
    });
  } else {
    // array
    tasks.forEach(function (task, i) {
      task(function (err, result) { each(i, err, result); });
    });
  }

  isSync = false;
}

var constants$6 = {};

Object.defineProperty(constants$6, "__esModule", { value: true });
constants$6.IS_SUPPORT_READDIR_WITH_FILE_TYPES = void 0;
const NODE_PROCESS_VERSION_PARTS = process.versions.node.split('.');
if (NODE_PROCESS_VERSION_PARTS[0] === undefined || NODE_PROCESS_VERSION_PARTS[1] === undefined) {
    throw new Error(`Unexpected behavior. The 'process.versions.node' variable has invalid value: ${process.versions.node}`);
}
const MAJOR_VERSION = Number.parseInt(NODE_PROCESS_VERSION_PARTS[0], 10);
const MINOR_VERSION = Number.parseInt(NODE_PROCESS_VERSION_PARTS[1], 10);
const SUPPORTED_MAJOR_VERSION = 10;
const SUPPORTED_MINOR_VERSION = 10;
const IS_MATCHED_BY_MAJOR = MAJOR_VERSION > SUPPORTED_MAJOR_VERSION;
const IS_MATCHED_BY_MAJOR_AND_MINOR = MAJOR_VERSION === SUPPORTED_MAJOR_VERSION && MINOR_VERSION >= SUPPORTED_MINOR_VERSION;
/**
 * IS `true` for Node.js 10.10 and greater.
 */
constants$6.IS_SUPPORT_READDIR_WITH_FILE_TYPES = IS_MATCHED_BY_MAJOR || IS_MATCHED_BY_MAJOR_AND_MINOR;

var utils$e = {};

var fs$e = {};

Object.defineProperty(fs$e, "__esModule", { value: true });
fs$e.createDirentFromStats = void 0;
class DirentFromStats {
    constructor(name, stats) {
        this.name = name;
        this.isBlockDevice = stats.isBlockDevice.bind(stats);
        this.isCharacterDevice = stats.isCharacterDevice.bind(stats);
        this.isDirectory = stats.isDirectory.bind(stats);
        this.isFIFO = stats.isFIFO.bind(stats);
        this.isFile = stats.isFile.bind(stats);
        this.isSocket = stats.isSocket.bind(stats);
        this.isSymbolicLink = stats.isSymbolicLink.bind(stats);
    }
}
function createDirentFromStats(name, stats) {
    return new DirentFromStats(name, stats);
}
fs$e.createDirentFromStats = createDirentFromStats;

Object.defineProperty(utils$e, "__esModule", { value: true });
utils$e.fs = void 0;
const fs$d = fs$e;
utils$e.fs = fs$d;

var common$6 = {};

Object.defineProperty(common$6, "__esModule", { value: true });
common$6.joinPathSegments = void 0;
function joinPathSegments$1(a, b, separator) {
    /**
     * The correct handling of cases when the first segment is a root (`/`, `C:/`) or UNC path (`//?/C:/`).
     */
    if (a.endsWith(separator)) {
        return a + b;
    }
    return a + separator + b;
}
common$6.joinPathSegments = joinPathSegments$1;

Object.defineProperty(async$6, "__esModule", { value: true });
async$6.readdir = async$6.readdirWithFileTypes = async$6.read = void 0;
const fsStat$5 = out$1;
const rpl = runParallel_1;
const constants_1$1 = constants$6;
const utils$d = utils$e;
const common$5 = common$6;
function read$2(directory, settings, callback) {
    if (!settings.stats && constants_1$1.IS_SUPPORT_READDIR_WITH_FILE_TYPES) {
        readdirWithFileTypes$1(directory, settings, callback);
        return;
    }
    readdir$1(directory, settings, callback);
}
async$6.read = read$2;
function readdirWithFileTypes$1(directory, settings, callback) {
    settings.fs.readdir(directory, { withFileTypes: true }, (readdirError, dirents) => {
        if (readdirError !== null) {
            callFailureCallback$1(callback, readdirError);
            return;
        }
        const entries = dirents.map((dirent) => ({
            dirent,
            name: dirent.name,
            path: common$5.joinPathSegments(directory, dirent.name, settings.pathSegmentSeparator)
        }));
        if (!settings.followSymbolicLinks) {
            callSuccessCallback$1(callback, entries);
            return;
        }
        const tasks = entries.map((entry) => makeRplTaskEntry(entry, settings));
        rpl(tasks, (rplError, rplEntries) => {
            if (rplError !== null) {
                callFailureCallback$1(callback, rplError);
                return;
            }
            callSuccessCallback$1(callback, rplEntries);
        });
    });
}
async$6.readdirWithFileTypes = readdirWithFileTypes$1;
function makeRplTaskEntry(entry, settings) {
    return (done) => {
        if (!entry.dirent.isSymbolicLink()) {
            done(null, entry);
            return;
        }
        settings.fs.stat(entry.path, (statError, stats) => {
            if (statError !== null) {
                if (settings.throwErrorOnBrokenSymbolicLink) {
                    done(statError);
                    return;
                }
                done(null, entry);
                return;
            }
            entry.dirent = utils$d.fs.createDirentFromStats(entry.name, stats);
            done(null, entry);
        });
    };
}
function readdir$1(directory, settings, callback) {
    settings.fs.readdir(directory, (readdirError, names) => {
        if (readdirError !== null) {
            callFailureCallback$1(callback, readdirError);
            return;
        }
        const tasks = names.map((name) => {
            const path = common$5.joinPathSegments(directory, name, settings.pathSegmentSeparator);
            return (done) => {
                fsStat$5.stat(path, settings.fsStatSettings, (error, stats) => {
                    if (error !== null) {
                        done(error);
                        return;
                    }
                    const entry = {
                        name,
                        path,
                        dirent: utils$d.fs.createDirentFromStats(name, stats)
                    };
                    if (settings.stats) {
                        entry.stats = stats;
                    }
                    done(null, entry);
                });
            };
        });
        rpl(tasks, (rplError, entries) => {
            if (rplError !== null) {
                callFailureCallback$1(callback, rplError);
                return;
            }
            callSuccessCallback$1(callback, entries);
        });
    });
}
async$6.readdir = readdir$1;
function callFailureCallback$1(callback, error) {
    callback(error);
}
function callSuccessCallback$1(callback, result) {
    callback(null, result);
}

var sync$6 = {};

Object.defineProperty(sync$6, "__esModule", { value: true });
sync$6.readdir = sync$6.readdirWithFileTypes = sync$6.read = void 0;
const fsStat$4 = out$1;
const constants_1 = constants$6;
const utils$c = utils$e;
const common$4 = common$6;
function read$1(directory, settings) {
    if (!settings.stats && constants_1.IS_SUPPORT_READDIR_WITH_FILE_TYPES) {
        return readdirWithFileTypes(directory, settings);
    }
    return readdir(directory, settings);
}
sync$6.read = read$1;
function readdirWithFileTypes(directory, settings) {
    const dirents = settings.fs.readdirSync(directory, { withFileTypes: true });
    return dirents.map((dirent) => {
        const entry = {
            dirent,
            name: dirent.name,
            path: common$4.joinPathSegments(directory, dirent.name, settings.pathSegmentSeparator)
        };
        if (entry.dirent.isSymbolicLink() && settings.followSymbolicLinks) {
            try {
                const stats = settings.fs.statSync(entry.path);
                entry.dirent = utils$c.fs.createDirentFromStats(entry.name, stats);
            }
            catch (error) {
                if (settings.throwErrorOnBrokenSymbolicLink) {
                    throw error;
                }
            }
        }
        return entry;
    });
}
sync$6.readdirWithFileTypes = readdirWithFileTypes;
function readdir(directory, settings) {
    const names = settings.fs.readdirSync(directory);
    return names.map((name) => {
        const entryPath = common$4.joinPathSegments(directory, name, settings.pathSegmentSeparator);
        const stats = fsStat$4.statSync(entryPath, settings.fsStatSettings);
        const entry = {
            name,
            path: entryPath,
            dirent: utils$c.fs.createDirentFromStats(name, stats)
        };
        if (settings.stats) {
            entry.stats = stats;
        }
        return entry;
    });
}
sync$6.readdir = readdir;

var settings$2 = {};

var fs$c = {};

(function (exports) {
	Object.defineProperty(exports, "__esModule", { value: true });
	exports.createFileSystemAdapter = exports.FILE_SYSTEM_ADAPTER = void 0;
	const fs = require$$0__default["default"];
	exports.FILE_SYSTEM_ADAPTER = {
	    lstat: fs.lstat,
	    stat: fs.stat,
	    lstatSync: fs.lstatSync,
	    statSync: fs.statSync,
	    readdir: fs.readdir,
	    readdirSync: fs.readdirSync
	};
	function createFileSystemAdapter(fsMethods) {
	    if (fsMethods === undefined) {
	        return exports.FILE_SYSTEM_ADAPTER;
	    }
	    return Object.assign(Object.assign({}, exports.FILE_SYSTEM_ADAPTER), fsMethods);
	}
	exports.createFileSystemAdapter = createFileSystemAdapter; 
} (fs$c));

Object.defineProperty(settings$2, "__esModule", { value: true });
const path$k = path__default["default"];
const fsStat$3 = out$1;
const fs$b = fs$c;
class Settings$1 {
    constructor(_options = {}) {
        this._options = _options;
        this.followSymbolicLinks = this._getValue(this._options.followSymbolicLinks, false);
        this.fs = fs$b.createFileSystemAdapter(this._options.fs);
        this.pathSegmentSeparator = this._getValue(this._options.pathSegmentSeparator, path$k.sep);
        this.stats = this._getValue(this._options.stats, false);
        this.throwErrorOnBrokenSymbolicLink = this._getValue(this._options.throwErrorOnBrokenSymbolicLink, true);
        this.fsStatSettings = new fsStat$3.Settings({
            followSymbolicLink: this.followSymbolicLinks,
            fs: this.fs,
            throwErrorOnBrokenSymbolicLink: this.throwErrorOnBrokenSymbolicLink
        });
    }
    _getValue(option, value) {
        return option !== null && option !== void 0 ? option : value;
    }
}
settings$2.default = Settings$1;

Object.defineProperty(out$2, "__esModule", { value: true });
out$2.Settings = out$2.scandirSync = out$2.scandir = void 0;
const async$3 = async$6;
const sync$5 = sync$6;
const settings_1$2 = settings$2;
out$2.Settings = settings_1$2.default;
function scandir(path, optionsOrSettingsOrCallback, callback) {
    if (typeof optionsOrSettingsOrCallback === 'function') {
        async$3.read(path, getSettings$1(), optionsOrSettingsOrCallback);
        return;
    }
    async$3.read(path, getSettings$1(optionsOrSettingsOrCallback), callback);
}
out$2.scandir = scandir;
function scandirSync(path, optionsOrSettings) {
    const settings = getSettings$1(optionsOrSettings);
    return sync$5.read(path, settings);
}
out$2.scandirSync = scandirSync;
function getSettings$1(settingsOrOptions = {}) {
    if (settingsOrOptions instanceof settings_1$2.default) {
        return settingsOrOptions;
    }
    return new settings_1$2.default(settingsOrOptions);
}

var queue = {exports: {}};

function reusify$1 (Constructor) {
  var head = new Constructor();
  var tail = head;

  function get () {
    var current = head;

    if (current.next) {
      head = current.next;
    } else {
      head = new Constructor();
      tail = head;
    }

    current.next = null;

    return current
  }

  function release (obj) {
    tail.next = obj;
    tail = obj;
  }

  return {
    get: get,
    release: release
  }
}

var reusify_1 = reusify$1;

/* eslint-disable no-var */

var reusify = reusify_1;

function fastqueue (context, worker, _concurrency) {
  if (typeof context === 'function') {
    _concurrency = worker;
    worker = context;
    context = null;
  }

  if (!(_concurrency >= 1)) {
    throw new Error('fastqueue concurrency must be equal to or greater than 1')
  }

  var cache = reusify(Task);
  var queueHead = null;
  var queueTail = null;
  var _running = 0;
  var errorHandler = null;

  var self = {
    push: push,
    drain: noop$1,
    saturated: noop$1,
    pause: pause,
    paused: false,

    get concurrency () {
      return _concurrency
    },
    set concurrency (value) {
      if (!(value >= 1)) {
        throw new Error('fastqueue concurrency must be equal to or greater than 1')
      }
      _concurrency = value;

      if (self.paused) return
      for (; queueHead && _running < _concurrency;) {
        _running++;
        release();
      }
    },

    running: running,
    resume: resume,
    idle: idle,
    length: length,
    getQueue: getQueue,
    unshift: unshift,
    empty: noop$1,
    kill: kill,
    killAndDrain: killAndDrain,
    error: error
  };

  return self

  function running () {
    return _running
  }

  function pause () {
    self.paused = true;
  }

  function length () {
    var current = queueHead;
    var counter = 0;

    while (current) {
      current = current.next;
      counter++;
    }

    return counter
  }

  function getQueue () {
    var current = queueHead;
    var tasks = [];

    while (current) {
      tasks.push(current.value);
      current = current.next;
    }

    return tasks
  }

  function resume () {
    if (!self.paused) return
    self.paused = false;
    if (queueHead === null) {
      _running++;
      release();
      return
    }
    for (; queueHead && _running < _concurrency;) {
      _running++;
      release();
    }
  }

  function idle () {
    return _running === 0 && self.length() === 0
  }

  function push (value, done) {
    var current = cache.get();

    current.context = context;
    current.release = release;
    current.value = value;
    current.callback = done || noop$1;
    current.errorHandler = errorHandler;

    if (_running >= _concurrency || self.paused) {
      if (queueTail) {
        queueTail.next = current;
        queueTail = current;
      } else {
        queueHead = current;
        queueTail = current;
        self.saturated();
      }
    } else {
      _running++;
      worker.call(context, current.value, current.worked);
    }
  }

  function unshift (value, done) {
    var current = cache.get();

    current.context = context;
    current.release = release;
    current.value = value;
    current.callback = done || noop$1;
    current.errorHandler = errorHandler;

    if (_running >= _concurrency || self.paused) {
      if (queueHead) {
        current.next = queueHead;
        queueHead = current;
      } else {
        queueHead = current;
        queueTail = current;
        self.saturated();
      }
    } else {
      _running++;
      worker.call(context, current.value, current.worked);
    }
  }

  function release (holder) {
    if (holder) {
      cache.release(holder);
    }
    var next = queueHead;
    if (next && _running <= _concurrency) {
      if (!self.paused) {
        if (queueTail === queueHead) {
          queueTail = null;
        }
        queueHead = next.next;
        next.next = null;
        worker.call(context, next.value, next.worked);
        if (queueTail === null) {
          self.empty();
        }
      } else {
        _running--;
      }
    } else if (--_running === 0) {
      self.drain();
    }
  }

  function kill () {
    queueHead = null;
    queueTail = null;
    self.drain = noop$1;
  }

  function killAndDrain () {
    queueHead = null;
    queueTail = null;
    self.drain();
    self.drain = noop$1;
  }

  function error (handler) {
    errorHandler = handler;
  }
}

function noop$1 () {}

function Task () {
  this.value = null;
  this.callback = noop$1;
  this.next = null;
  this.release = noop$1;
  this.context = null;
  this.errorHandler = null;

  var self = this;

  this.worked = function worked (err, result) {
    var callback = self.callback;
    var errorHandler = self.errorHandler;
    var val = self.value;
    self.value = null;
    self.callback = noop$1;
    if (self.errorHandler) {
      errorHandler(err, val);
    }
    callback.call(self.context, err, result);
    self.release(self);
  };
}

function queueAsPromised (context, worker, _concurrency) {
  if (typeof context === 'function') {
    _concurrency = worker;
    worker = context;
    context = null;
  }

  function asyncWrapper (arg, cb) {
    worker.call(this, arg)
      .then(function (res) {
        cb(null, res);
      }, cb);
  }

  var queue = fastqueue(context, asyncWrapper, _concurrency);

  var pushCb = queue.push;
  var unshiftCb = queue.unshift;

  queue.push = push;
  queue.unshift = unshift;
  queue.drained = drained;

  return queue

  function push (value) {
    var p = new Promise(function (resolve, reject) {
      pushCb(value, function (err, result) {
        if (err) {
          reject(err);
          return
        }
        resolve(result);
      });
    });

    // Let's fork the promise chain to
    // make the error bubble up to the user but
    // not lead to a unhandledRejection
    p.catch(noop$1);

    return p
  }

  function unshift (value) {
    var p = new Promise(function (resolve, reject) {
      unshiftCb(value, function (err, result) {
        if (err) {
          reject(err);
          return
        }
        resolve(result);
      });
    });

    // Let's fork the promise chain to
    // make the error bubble up to the user but
    // not lead to a unhandledRejection
    p.catch(noop$1);

    return p
  }

  function drained () {
    if (queue.idle()) {
      return new Promise(function (resolve) {
        resolve();
      })
    }

    var previousDrain = queue.drain;

    var p = new Promise(function (resolve) {
      queue.drain = function () {
        previousDrain();
        resolve();
      };
    });

    return p
  }
}

queue.exports = fastqueue;
queue.exports.promise = queueAsPromised;

var queueExports = queue.exports;

var common$3 = {};

Object.defineProperty(common$3, "__esModule", { value: true });
common$3.joinPathSegments = common$3.replacePathSegmentSeparator = common$3.isAppliedFilter = common$3.isFatalError = void 0;
function isFatalError(settings, error) {
    if (settings.errorFilter === null) {
        return true;
    }
    return !settings.errorFilter(error);
}
common$3.isFatalError = isFatalError;
function isAppliedFilter(filter, value) {
    return filter === null || filter(value);
}
common$3.isAppliedFilter = isAppliedFilter;
function replacePathSegmentSeparator(filepath, separator) {
    return filepath.split(/[/\\]/).join(separator);
}
common$3.replacePathSegmentSeparator = replacePathSegmentSeparator;
function joinPathSegments(a, b, separator) {
    if (a === '') {
        return b;
    }
    /**
     * The correct handling of cases when the first segment is a root (`/`, `C:/`) or UNC path (`//?/C:/`).
     */
    if (a.endsWith(separator)) {
        return a + b;
    }
    return a + separator + b;
}
common$3.joinPathSegments = joinPathSegments;

var reader$2 = {};

Object.defineProperty(reader$2, "__esModule", { value: true });
const common$2 = common$3;
class Reader$1 {
    constructor(_root, _settings) {
        this._root = _root;
        this._settings = _settings;
        this._root = common$2.replacePathSegmentSeparator(_root, _settings.pathSegmentSeparator);
    }
}
reader$2.default = Reader$1;

Object.defineProperty(async$7, "__esModule", { value: true });
const events_1 = require$$0__default$6["default"];
const fsScandir$2 = out$2;
const fastq = queueExports;
const common$1 = common$3;
const reader_1$4 = reader$2;
class AsyncReader extends reader_1$4.default {
    constructor(_root, _settings) {
        super(_root, _settings);
        this._settings = _settings;
        this._scandir = fsScandir$2.scandir;
        this._emitter = new events_1.EventEmitter();
        this._queue = fastq(this._worker.bind(this), this._settings.concurrency);
        this._isFatalError = false;
        this._isDestroyed = false;
        this._queue.drain = () => {
            if (!this._isFatalError) {
                this._emitter.emit('end');
            }
        };
    }
    read() {
        this._isFatalError = false;
        this._isDestroyed = false;
        setImmediate(() => {
            this._pushToQueue(this._root, this._settings.basePath);
        });
        return this._emitter;
    }
    get isDestroyed() {
        return this._isDestroyed;
    }
    destroy() {
        if (this._isDestroyed) {
            throw new Error('The reader is already destroyed');
        }
        this._isDestroyed = true;
        this._queue.killAndDrain();
    }
    onEntry(callback) {
        this._emitter.on('entry', callback);
    }
    onError(callback) {
        this._emitter.once('error', callback);
    }
    onEnd(callback) {
        this._emitter.once('end', callback);
    }
    _pushToQueue(directory, base) {
        const queueItem = { directory, base };
        this._queue.push(queueItem, (error) => {
            if (error !== null) {
                this._handleError(error);
            }
        });
    }
    _worker(item, done) {
        this._scandir(item.directory, this._settings.fsScandirSettings, (error, entries) => {
            if (error !== null) {
                done(error, undefined);
                return;
            }
            for (const entry of entries) {
                this._handleEntry(entry, item.base);
            }
            done(null, undefined);
        });
    }
    _handleError(error) {
        if (this._isDestroyed || !common$1.isFatalError(this._settings, error)) {
            return;
        }
        this._isFatalError = true;
        this._isDestroyed = true;
        this._emitter.emit('error', error);
    }
    _handleEntry(entry, base) {
        if (this._isDestroyed || this._isFatalError) {
            return;
        }
        const fullpath = entry.path;
        if (base !== undefined) {
            entry.path = common$1.joinPathSegments(base, entry.name, this._settings.pathSegmentSeparator);
        }
        if (common$1.isAppliedFilter(this._settings.entryFilter, entry)) {
            this._emitEntry(entry);
        }
        if (entry.dirent.isDirectory() && common$1.isAppliedFilter(this._settings.deepFilter, entry)) {
            this._pushToQueue(fullpath, base === undefined ? undefined : entry.path);
        }
    }
    _emitEntry(entry) {
        this._emitter.emit('entry', entry);
    }
}
async$7.default = AsyncReader;

Object.defineProperty(async$8, "__esModule", { value: true });
const async_1$4 = async$7;
class AsyncProvider {
    constructor(_root, _settings) {
        this._root = _root;
        this._settings = _settings;
        this._reader = new async_1$4.default(this._root, this._settings);
        this._storage = [];
    }
    read(callback) {
        this._reader.onError((error) => {
            callFailureCallback(callback, error);
        });
        this._reader.onEntry((entry) => {
            this._storage.push(entry);
        });
        this._reader.onEnd(() => {
            callSuccessCallback(callback, this._storage);
        });
        this._reader.read();
    }
}
async$8.default = AsyncProvider;
function callFailureCallback(callback, error) {
    callback(error);
}
function callSuccessCallback(callback, entries) {
    callback(null, entries);
}

var stream$4 = {};

Object.defineProperty(stream$4, "__esModule", { value: true });
const stream_1$5 = require$$0__default$4["default"];
const async_1$3 = async$7;
class StreamProvider {
    constructor(_root, _settings) {
        this._root = _root;
        this._settings = _settings;
        this._reader = new async_1$3.default(this._root, this._settings);
        this._stream = new stream_1$5.Readable({
            objectMode: true,
            read: () => { },
            destroy: () => {
                if (!this._reader.isDestroyed) {
                    this._reader.destroy();
                }
            }
        });
    }
    read() {
        this._reader.onError((error) => {
            this._stream.emit('error', error);
        });
        this._reader.onEntry((entry) => {
            this._stream.push(entry);
        });
        this._reader.onEnd(() => {
            this._stream.push(null);
        });
        this._reader.read();
        return this._stream;
    }
}
stream$4.default = StreamProvider;

var sync$4 = {};

var sync$3 = {};

Object.defineProperty(sync$3, "__esModule", { value: true });
const fsScandir$1 = out$2;
const common = common$3;
const reader_1$3 = reader$2;
class SyncReader extends reader_1$3.default {
    constructor() {
        super(...arguments);
        this._scandir = fsScandir$1.scandirSync;
        this._storage = [];
        this._queue = new Set();
    }
    read() {
        this._pushToQueue(this._root, this._settings.basePath);
        this._handleQueue();
        return this._storage;
    }
    _pushToQueue(directory, base) {
        this._queue.add({ directory, base });
    }
    _handleQueue() {
        for (const item of this._queue.values()) {
            this._handleDirectory(item.directory, item.base);
        }
    }
    _handleDirectory(directory, base) {
        try {
            const entries = this._scandir(directory, this._settings.fsScandirSettings);
            for (const entry of entries) {
                this._handleEntry(entry, base);
            }
        }
        catch (error) {
            this._handleError(error);
        }
    }
    _handleError(error) {
        if (!common.isFatalError(this._settings, error)) {
            return;
        }
        throw error;
    }
    _handleEntry(entry, base) {
        const fullpath = entry.path;
        if (base !== undefined) {
            entry.path = common.joinPathSegments(base, entry.name, this._settings.pathSegmentSeparator);
        }
        if (common.isAppliedFilter(this._settings.entryFilter, entry)) {
            this._pushToStorage(entry);
        }
        if (entry.dirent.isDirectory() && common.isAppliedFilter(this._settings.deepFilter, entry)) {
            this._pushToQueue(fullpath, base === undefined ? undefined : entry.path);
        }
    }
    _pushToStorage(entry) {
        this._storage.push(entry);
    }
}
sync$3.default = SyncReader;

Object.defineProperty(sync$4, "__esModule", { value: true });
const sync_1$3 = sync$3;
class SyncProvider {
    constructor(_root, _settings) {
        this._root = _root;
        this._settings = _settings;
        this._reader = new sync_1$3.default(this._root, this._settings);
    }
    read() {
        return this._reader.read();
    }
}
sync$4.default = SyncProvider;

var settings$1 = {};

Object.defineProperty(settings$1, "__esModule", { value: true });
const path$j = path__default["default"];
const fsScandir = out$2;
class Settings {
    constructor(_options = {}) {
        this._options = _options;
        this.basePath = this._getValue(this._options.basePath, undefined);
        this.concurrency = this._getValue(this._options.concurrency, Number.POSITIVE_INFINITY);
        this.deepFilter = this._getValue(this._options.deepFilter, null);
        this.entryFilter = this._getValue(this._options.entryFilter, null);
        this.errorFilter = this._getValue(this._options.errorFilter, null);
        this.pathSegmentSeparator = this._getValue(this._options.pathSegmentSeparator, path$j.sep);
        this.fsScandirSettings = new fsScandir.Settings({
            followSymbolicLinks: this._options.followSymbolicLinks,
            fs: this._options.fs,
            pathSegmentSeparator: this._options.pathSegmentSeparator,
            stats: this._options.stats,
            throwErrorOnBrokenSymbolicLink: this._options.throwErrorOnBrokenSymbolicLink
        });
    }
    _getValue(option, value) {
        return option !== null && option !== void 0 ? option : value;
    }
}
settings$1.default = Settings;

Object.defineProperty(out$3, "__esModule", { value: true });
out$3.Settings = out$3.walkStream = out$3.walkSync = out$3.walk = void 0;
const async_1$2 = async$8;
const stream_1$4 = stream$4;
const sync_1$2 = sync$4;
const settings_1$1 = settings$1;
out$3.Settings = settings_1$1.default;
function walk(directory, optionsOrSettingsOrCallback, callback) {
    if (typeof optionsOrSettingsOrCallback === 'function') {
        new async_1$2.default(directory, getSettings()).read(optionsOrSettingsOrCallback);
        return;
    }
    new async_1$2.default(directory, getSettings(optionsOrSettingsOrCallback)).read(callback);
}
out$3.walk = walk;
function walkSync(directory, optionsOrSettings) {
    const settings = getSettings(optionsOrSettings);
    const provider = new sync_1$2.default(directory, settings);
    return provider.read();
}
out$3.walkSync = walkSync;
function walkStream(directory, optionsOrSettings) {
    const settings = getSettings(optionsOrSettings);
    const provider = new stream_1$4.default(directory, settings);
    return provider.read();
}
out$3.walkStream = walkStream;
function getSettings(settingsOrOptions = {}) {
    if (settingsOrOptions instanceof settings_1$1.default) {
        return settingsOrOptions;
    }
    return new settings_1$1.default(settingsOrOptions);
}

var reader$1 = {};

Object.defineProperty(reader$1, "__esModule", { value: true });
const path$i = path__default["default"];
const fsStat$2 = out$1;
const utils$b = utils$l;
class Reader {
    constructor(_settings) {
        this._settings = _settings;
        this._fsStatSettings = new fsStat$2.Settings({
            followSymbolicLink: this._settings.followSymbolicLinks,
            fs: this._settings.fs,
            throwErrorOnBrokenSymbolicLink: this._settings.followSymbolicLinks
        });
    }
    _getFullEntryPath(filepath) {
        return path$i.resolve(this._settings.cwd, filepath);
    }
    _makeEntry(stats, pattern) {
        const entry = {
            name: pattern,
            path: pattern,
            dirent: utils$b.fs.createDirentFromStats(pattern, stats)
        };
        if (this._settings.stats) {
            entry.stats = stats;
        }
        return entry;
    }
    _isFatalError(error) {
        return !utils$b.errno.isEnoentCodeError(error) && !this._settings.suppressErrors;
    }
}
reader$1.default = Reader;

var stream$3 = {};

Object.defineProperty(stream$3, "__esModule", { value: true });
const stream_1$3 = require$$0__default$4["default"];
const fsStat$1 = out$1;
const fsWalk$2 = out$3;
const reader_1$2 = reader$1;
class ReaderStream extends reader_1$2.default {
    constructor() {
        super(...arguments);
        this._walkStream = fsWalk$2.walkStream;
        this._stat = fsStat$1.stat;
    }
    dynamic(root, options) {
        return this._walkStream(root, options);
    }
    static(patterns, options) {
        const filepaths = patterns.map(this._getFullEntryPath, this);
        const stream = new stream_1$3.PassThrough({ objectMode: true });
        stream._write = (index, _enc, done) => {
            return this._getEntry(filepaths[index], patterns[index], options)
                .then((entry) => {
                if (entry !== null && options.entryFilter(entry)) {
                    stream.push(entry);
                }
                if (index === filepaths.length - 1) {
                    stream.end();
                }
                done();
            })
                .catch(done);
        };
        for (let i = 0; i < filepaths.length; i++) {
            stream.write(i);
        }
        return stream;
    }
    _getEntry(filepath, pattern, options) {
        return this._getStat(filepath)
            .then((stats) => this._makeEntry(stats, pattern))
            .catch((error) => {
            if (options.errorFilter(error)) {
                return null;
            }
            throw error;
        });
    }
    _getStat(filepath) {
        return new Promise((resolve, reject) => {
            this._stat(filepath, this._fsStatSettings, (error, stats) => {
                return error === null ? resolve(stats) : reject(error);
            });
        });
    }
}
stream$3.default = ReaderStream;

Object.defineProperty(async$9, "__esModule", { value: true });
const fsWalk$1 = out$3;
const reader_1$1 = reader$1;
const stream_1$2 = stream$3;
class ReaderAsync extends reader_1$1.default {
    constructor() {
        super(...arguments);
        this._walkAsync = fsWalk$1.walk;
        this._readerStream = new stream_1$2.default(this._settings);
    }
    dynamic(root, options) {
        return new Promise((resolve, reject) => {
            this._walkAsync(root, options, (error, entries) => {
                if (error === null) {
                    resolve(entries);
                }
                else {
                    reject(error);
                }
            });
        });
    }
    async static(patterns, options) {
        const entries = [];
        const stream = this._readerStream.static(patterns, options);
        // After #235, replace it with an asynchronous iterator.
        return new Promise((resolve, reject) => {
            stream.once('error', reject);
            stream.on('data', (entry) => entries.push(entry));
            stream.once('end', () => resolve(entries));
        });
    }
}
async$9.default = ReaderAsync;

var provider = {};

var deep$1 = {};

var partial$1 = {};

var matcher = {};

Object.defineProperty(matcher, "__esModule", { value: true });
const utils$a = utils$l;
class Matcher {
    constructor(_patterns, _settings, _micromatchOptions) {
        this._patterns = _patterns;
        this._settings = _settings;
        this._micromatchOptions = _micromatchOptions;
        this._storage = [];
        this._fillStorage();
    }
    _fillStorage() {
        for (const pattern of this._patterns) {
            const segments = this._getPatternSegments(pattern);
            const sections = this._splitSegmentsIntoSections(segments);
            this._storage.push({
                complete: sections.length <= 1,
                pattern,
                segments,
                sections
            });
        }
    }
    _getPatternSegments(pattern) {
        const parts = utils$a.pattern.getPatternParts(pattern, this._micromatchOptions);
        return parts.map((part) => {
            const dynamic = utils$a.pattern.isDynamicPattern(part, this._settings);
            if (!dynamic) {
                return {
                    dynamic: false,
                    pattern: part
                };
            }
            return {
                dynamic: true,
                pattern: part,
                patternRe: utils$a.pattern.makeRe(part, this._micromatchOptions)
            };
        });
    }
    _splitSegmentsIntoSections(segments) {
        return utils$a.array.splitWhen(segments, (segment) => segment.dynamic && utils$a.pattern.hasGlobStar(segment.pattern));
    }
}
matcher.default = Matcher;

Object.defineProperty(partial$1, "__esModule", { value: true });
const matcher_1 = matcher;
class PartialMatcher extends matcher_1.default {
    match(filepath) {
        const parts = filepath.split('/');
        const levels = parts.length;
        const patterns = this._storage.filter((info) => !info.complete || info.segments.length > levels);
        for (const pattern of patterns) {
            const section = pattern.sections[0];
            /**
             * In this case, the pattern has a globstar and we must read all directories unconditionally,
             * but only if the level has reached the end of the first group.
             *
             * fixtures/{a,b}/**
             *  ^ true/false  ^ always true
            */
            if (!pattern.complete && levels > section.length) {
                return true;
            }
            const match = parts.every((part, index) => {
                const segment = pattern.segments[index];
                if (segment.dynamic && segment.patternRe.test(part)) {
                    return true;
                }
                if (!segment.dynamic && segment.pattern === part) {
                    return true;
                }
                return false;
            });
            if (match) {
                return true;
            }
        }
        return false;
    }
}
partial$1.default = PartialMatcher;

Object.defineProperty(deep$1, "__esModule", { value: true });
const utils$9 = utils$l;
const partial_1 = partial$1;
class DeepFilter {
    constructor(_settings, _micromatchOptions) {
        this._settings = _settings;
        this._micromatchOptions = _micromatchOptions;
    }
    getFilter(basePath, positive, negative) {
        const matcher = this._getMatcher(positive);
        const negativeRe = this._getNegativePatternsRe(negative);
        return (entry) => this._filter(basePath, entry, matcher, negativeRe);
    }
    _getMatcher(patterns) {
        return new partial_1.default(patterns, this._settings, this._micromatchOptions);
    }
    _getNegativePatternsRe(patterns) {
        const affectDepthOfReadingPatterns = patterns.filter(utils$9.pattern.isAffectDepthOfReadingPattern);
        return utils$9.pattern.convertPatternsToRe(affectDepthOfReadingPatterns, this._micromatchOptions);
    }
    _filter(basePath, entry, matcher, negativeRe) {
        if (this._isSkippedByDeep(basePath, entry.path)) {
            return false;
        }
        if (this._isSkippedSymbolicLink(entry)) {
            return false;
        }
        const filepath = utils$9.path.removeLeadingDotSegment(entry.path);
        if (this._isSkippedByPositivePatterns(filepath, matcher)) {
            return false;
        }
        return this._isSkippedByNegativePatterns(filepath, negativeRe);
    }
    _isSkippedByDeep(basePath, entryPath) {
        /**
         * Avoid unnecessary depth calculations when it doesn't matter.
         */
        if (this._settings.deep === Infinity) {
            return false;
        }
        return this._getEntryLevel(basePath, entryPath) >= this._settings.deep;
    }
    _getEntryLevel(basePath, entryPath) {
        const entryPathDepth = entryPath.split('/').length;
        if (basePath === '') {
            return entryPathDepth;
        }
        const basePathDepth = basePath.split('/').length;
        return entryPathDepth - basePathDepth;
    }
    _isSkippedSymbolicLink(entry) {
        return !this._settings.followSymbolicLinks && entry.dirent.isSymbolicLink();
    }
    _isSkippedByPositivePatterns(entryPath, matcher) {
        return !this._settings.baseNameMatch && !matcher.match(entryPath);
    }
    _isSkippedByNegativePatterns(entryPath, patternsRe) {
        return !utils$9.pattern.matchAny(entryPath, patternsRe);
    }
}
deep$1.default = DeepFilter;

var entry$1 = {};

Object.defineProperty(entry$1, "__esModule", { value: true });
const utils$8 = utils$l;
class EntryFilter {
    constructor(_settings, _micromatchOptions) {
        this._settings = _settings;
        this._micromatchOptions = _micromatchOptions;
        this.index = new Map();
    }
    getFilter(positive, negative) {
        const positiveRe = utils$8.pattern.convertPatternsToRe(positive, this._micromatchOptions);
        const negativeRe = utils$8.pattern.convertPatternsToRe(negative, Object.assign(Object.assign({}, this._micromatchOptions), { dot: true }));
        return (entry) => this._filter(entry, positiveRe, negativeRe);
    }
    _filter(entry, positiveRe, negativeRe) {
        const filepath = utils$8.path.removeLeadingDotSegment(entry.path);
        if (this._settings.unique && this._isDuplicateEntry(filepath)) {
            return false;
        }
        if (this._onlyFileFilter(entry) || this._onlyDirectoryFilter(entry)) {
            return false;
        }
        if (this._isSkippedByAbsoluteNegativePatterns(filepath, negativeRe)) {
            return false;
        }
        const isDirectory = entry.dirent.isDirectory();
        const isMatched = this._isMatchToPatterns(filepath, positiveRe, isDirectory) && !this._isMatchToPatterns(filepath, negativeRe, isDirectory);
        if (this._settings.unique && isMatched) {
            this._createIndexRecord(filepath);
        }
        return isMatched;
    }
    _isDuplicateEntry(filepath) {
        return this.index.has(filepath);
    }
    _createIndexRecord(filepath) {
        this.index.set(filepath, undefined);
    }
    _onlyFileFilter(entry) {
        return this._settings.onlyFiles && !entry.dirent.isFile();
    }
    _onlyDirectoryFilter(entry) {
        return this._settings.onlyDirectories && !entry.dirent.isDirectory();
    }
    _isSkippedByAbsoluteNegativePatterns(entryPath, patternsRe) {
        if (!this._settings.absolute) {
            return false;
        }
        const fullpath = utils$8.path.makeAbsolute(this._settings.cwd, entryPath);
        return utils$8.pattern.matchAny(fullpath, patternsRe);
    }
    _isMatchToPatterns(filepath, patternsRe, isDirectory) {
        // Trying to match files and directories by patterns.
        const isMatched = utils$8.pattern.matchAny(filepath, patternsRe);
        // A pattern with a trailling slash can be used for directory matching.
        // To apply such pattern, we need to add a tralling slash to the path.
        if (!isMatched && isDirectory) {
            return utils$8.pattern.matchAny(filepath + '/', patternsRe);
        }
        return isMatched;
    }
}
entry$1.default = EntryFilter;

var error$1 = {};

Object.defineProperty(error$1, "__esModule", { value: true });
const utils$7 = utils$l;
class ErrorFilter {
    constructor(_settings) {
        this._settings = _settings;
    }
    getFilter() {
        return (error) => this._isNonFatalError(error);
    }
    _isNonFatalError(error) {
        return utils$7.errno.isEnoentCodeError(error) || this._settings.suppressErrors;
    }
}
error$1.default = ErrorFilter;

var entry = {};

Object.defineProperty(entry, "__esModule", { value: true });
const utils$6 = utils$l;
class EntryTransformer {
    constructor(_settings) {
        this._settings = _settings;
    }
    getTransformer() {
        return (entry) => this._transform(entry);
    }
    _transform(entry) {
        let filepath = entry.path;
        if (this._settings.absolute) {
            filepath = utils$6.path.makeAbsolute(this._settings.cwd, filepath);
            filepath = utils$6.path.unixify(filepath);
        }
        if (this._settings.markDirectories && entry.dirent.isDirectory()) {
            filepath += '/';
        }
        if (!this._settings.objectMode) {
            return filepath;
        }
        return Object.assign(Object.assign({}, entry), { path: filepath });
    }
}
entry.default = EntryTransformer;

Object.defineProperty(provider, "__esModule", { value: true });
const path$h = path__default["default"];
const deep_1 = deep$1;
const entry_1 = entry$1;
const error_1 = error$1;
const entry_2 = entry;
class Provider {
    constructor(_settings) {
        this._settings = _settings;
        this.errorFilter = new error_1.default(this._settings);
        this.entryFilter = new entry_1.default(this._settings, this._getMicromatchOptions());
        this.deepFilter = new deep_1.default(this._settings, this._getMicromatchOptions());
        this.entryTransformer = new entry_2.default(this._settings);
    }
    _getRootDirectory(task) {
        return path$h.resolve(this._settings.cwd, task.base);
    }
    _getReaderOptions(task) {
        const basePath = task.base === '.' ? '' : task.base;
        return {
            basePath,
            pathSegmentSeparator: '/',
            concurrency: this._settings.concurrency,
            deepFilter: this.deepFilter.getFilter(basePath, task.positive, task.negative),
            entryFilter: this.entryFilter.getFilter(task.positive, task.negative),
            errorFilter: this.errorFilter.getFilter(),
            followSymbolicLinks: this._settings.followSymbolicLinks,
            fs: this._settings.fs,
            stats: this._settings.stats,
            throwErrorOnBrokenSymbolicLink: this._settings.throwErrorOnBrokenSymbolicLink,
            transform: this.entryTransformer.getTransformer()
        };
    }
    _getMicromatchOptions() {
        return {
            dot: this._settings.dot,
            matchBase: this._settings.baseNameMatch,
            nobrace: !this._settings.braceExpansion,
            nocase: !this._settings.caseSensitiveMatch,
            noext: !this._settings.extglob,
            noglobstar: !this._settings.globstar,
            posix: true,
            strictSlashes: false
        };
    }
}
provider.default = Provider;

Object.defineProperty(async$a, "__esModule", { value: true });
const async_1$1 = async$9;
const provider_1$2 = provider;
class ProviderAsync extends provider_1$2.default {
    constructor() {
        super(...arguments);
        this._reader = new async_1$1.default(this._settings);
    }
    async read(task) {
        const root = this._getRootDirectory(task);
        const options = this._getReaderOptions(task);
        const entries = await this.api(root, task, options);
        return entries.map((entry) => options.transform(entry));
    }
    api(root, task, options) {
        if (task.dynamic) {
            return this._reader.dynamic(root, options);
        }
        return this._reader.static(task.patterns, options);
    }
}
async$a.default = ProviderAsync;

var stream$2 = {};

Object.defineProperty(stream$2, "__esModule", { value: true });
const stream_1$1 = require$$0__default$4["default"];
const stream_2 = stream$3;
const provider_1$1 = provider;
class ProviderStream extends provider_1$1.default {
    constructor() {
        super(...arguments);
        this._reader = new stream_2.default(this._settings);
    }
    read(task) {
        const root = this._getRootDirectory(task);
        const options = this._getReaderOptions(task);
        const source = this.api(root, task, options);
        const destination = new stream_1$1.Readable({ objectMode: true, read: () => { } });
        source
            .once('error', (error) => destination.emit('error', error))
            .on('data', (entry) => destination.emit('data', options.transform(entry)))
            .once('end', () => destination.emit('end'));
        destination
            .once('close', () => source.destroy());
        return destination;
    }
    api(root, task, options) {
        if (task.dynamic) {
            return this._reader.dynamic(root, options);
        }
        return this._reader.static(task.patterns, options);
    }
}
stream$2.default = ProviderStream;

var sync$2 = {};

var sync$1 = {};

Object.defineProperty(sync$1, "__esModule", { value: true });
const fsStat = out$1;
const fsWalk = out$3;
const reader_1 = reader$1;
class ReaderSync extends reader_1.default {
    constructor() {
        super(...arguments);
        this._walkSync = fsWalk.walkSync;
        this._statSync = fsStat.statSync;
    }
    dynamic(root, options) {
        return this._walkSync(root, options);
    }
    static(patterns, options) {
        const entries = [];
        for (const pattern of patterns) {
            const filepath = this._getFullEntryPath(pattern);
            const entry = this._getEntry(filepath, pattern, options);
            if (entry === null || !options.entryFilter(entry)) {
                continue;
            }
            entries.push(entry);
        }
        return entries;
    }
    _getEntry(filepath, pattern, options) {
        try {
            const stats = this._getStat(filepath);
            return this._makeEntry(stats, pattern);
        }
        catch (error) {
            if (options.errorFilter(error)) {
                return null;
            }
            throw error;
        }
    }
    _getStat(filepath) {
        return this._statSync(filepath, this._fsStatSettings);
    }
}
sync$1.default = ReaderSync;

Object.defineProperty(sync$2, "__esModule", { value: true });
const sync_1$1 = sync$1;
const provider_1 = provider;
class ProviderSync extends provider_1.default {
    constructor() {
        super(...arguments);
        this._reader = new sync_1$1.default(this._settings);
    }
    read(task) {
        const root = this._getRootDirectory(task);
        const options = this._getReaderOptions(task);
        const entries = this.api(root, task, options);
        return entries.map(options.transform);
    }
    api(root, task, options) {
        if (task.dynamic) {
            return this._reader.dynamic(root, options);
        }
        return this._reader.static(task.patterns, options);
    }
}
sync$2.default = ProviderSync;

var settings = {};

(function (exports) {
	Object.defineProperty(exports, "__esModule", { value: true });
	exports.DEFAULT_FILE_SYSTEM_ADAPTER = void 0;
	const fs = require$$0__default["default"];
	const os = require$$0__default$1["default"];
	/**
	 * The `os.cpus` method can return zero. We expect the number of cores to be greater than zero.
	 * https://github.com/nodejs/node/blob/7faeddf23a98c53896f8b574a6e66589e8fb1eb8/lib/os.js#L106-L107
	 */
	const CPU_COUNT = Math.max(os.cpus().length, 1);
	exports.DEFAULT_FILE_SYSTEM_ADAPTER = {
	    lstat: fs.lstat,
	    lstatSync: fs.lstatSync,
	    stat: fs.stat,
	    statSync: fs.statSync,
	    readdir: fs.readdir,
	    readdirSync: fs.readdirSync
	};
	class Settings {
	    constructor(_options = {}) {
	        this._options = _options;
	        this.absolute = this._getValue(this._options.absolute, false);
	        this.baseNameMatch = this._getValue(this._options.baseNameMatch, false);
	        this.braceExpansion = this._getValue(this._options.braceExpansion, true);
	        this.caseSensitiveMatch = this._getValue(this._options.caseSensitiveMatch, true);
	        this.concurrency = this._getValue(this._options.concurrency, CPU_COUNT);
	        this.cwd = this._getValue(this._options.cwd, process.cwd());
	        this.deep = this._getValue(this._options.deep, Infinity);
	        this.dot = this._getValue(this._options.dot, false);
	        this.extglob = this._getValue(this._options.extglob, true);
	        this.followSymbolicLinks = this._getValue(this._options.followSymbolicLinks, true);
	        this.fs = this._getFileSystemMethods(this._options.fs);
	        this.globstar = this._getValue(this._options.globstar, true);
	        this.ignore = this._getValue(this._options.ignore, []);
	        this.markDirectories = this._getValue(this._options.markDirectories, false);
	        this.objectMode = this._getValue(this._options.objectMode, false);
	        this.onlyDirectories = this._getValue(this._options.onlyDirectories, false);
	        this.onlyFiles = this._getValue(this._options.onlyFiles, true);
	        this.stats = this._getValue(this._options.stats, false);
	        this.suppressErrors = this._getValue(this._options.suppressErrors, false);
	        this.throwErrorOnBrokenSymbolicLink = this._getValue(this._options.throwErrorOnBrokenSymbolicLink, false);
	        this.unique = this._getValue(this._options.unique, true);
	        if (this.onlyDirectories) {
	            this.onlyFiles = false;
	        }
	        if (this.stats) {
	            this.objectMode = true;
	        }
	        // Remove the cast to the array in the next major (#404).
	        this.ignore = [].concat(this.ignore);
	    }
	    _getValue(option, value) {
	        return option === undefined ? value : option;
	    }
	    _getFileSystemMethods(methods = {}) {
	        return Object.assign(Object.assign({}, exports.DEFAULT_FILE_SYSTEM_ADAPTER), methods);
	    }
	}
	exports.default = Settings; 
} (settings));

const taskManager = tasks;
const async_1 = async$a;
const stream_1 = stream$2;
const sync_1 = sync$2;
const settings_1 = settings;
const utils$5 = utils$l;
async function FastGlob(source, options) {
    assertPatternsInput(source);
    const works = getWorks(source, async_1.default, options);
    const result = await Promise.all(works);
    return utils$5.array.flatten(result);
}
// https://github.com/typescript-eslint/typescript-eslint/issues/60
// eslint-disable-next-line no-redeclare
(function (FastGlob) {
    FastGlob.glob = FastGlob;
    FastGlob.globSync = sync;
    FastGlob.globStream = stream;
    FastGlob.async = FastGlob;
    function sync(source, options) {
        assertPatternsInput(source);
        const works = getWorks(source, sync_1.default, options);
        return utils$5.array.flatten(works);
    }
    FastGlob.sync = sync;
    function stream(source, options) {
        assertPatternsInput(source);
        const works = getWorks(source, stream_1.default, options);
        /**
         * The stream returned by the provider cannot work with an asynchronous iterator.
         * To support asynchronous iterators, regardless of the number of tasks, we always multiplex streams.
         * This affects performance (+25%). I don't see best solution right now.
         */
        return utils$5.stream.merge(works);
    }
    FastGlob.stream = stream;
    function generateTasks(source, options) {
        assertPatternsInput(source);
        const patterns = [].concat(source);
        const settings = new settings_1.default(options);
        return taskManager.generate(patterns, settings);
    }
    FastGlob.generateTasks = generateTasks;
    function isDynamicPattern(source, options) {
        assertPatternsInput(source);
        const settings = new settings_1.default(options);
        return utils$5.pattern.isDynamicPattern(source, settings);
    }
    FastGlob.isDynamicPattern = isDynamicPattern;
    function escapePath(source) {
        assertPatternsInput(source);
        return utils$5.path.escape(source);
    }
    FastGlob.escapePath = escapePath;
    function convertPathToPattern(source) {
        assertPatternsInput(source);
        return utils$5.path.convertPathToPattern(source);
    }
    FastGlob.convertPathToPattern = convertPathToPattern;
    (function (posix) {
        function escapePath(source) {
            assertPatternsInput(source);
            return utils$5.path.escapePosixPath(source);
        }
        posix.escapePath = escapePath;
        function convertPathToPattern(source) {
            assertPatternsInput(source);
            return utils$5.path.convertPosixPathToPattern(source);
        }
        posix.convertPathToPattern = convertPathToPattern;
    })(FastGlob.posix || (FastGlob.posix = {}));
    (function (win32) {
        function escapePath(source) {
            assertPatternsInput(source);
            return utils$5.path.escapeWindowsPath(source);
        }
        win32.escapePath = escapePath;
        function convertPathToPattern(source) {
            assertPatternsInput(source);
            return utils$5.path.convertWindowsPathToPattern(source);
        }
        win32.convertPathToPattern = convertPathToPattern;
    })(FastGlob.win32 || (FastGlob.win32 = {}));
})(FastGlob || (FastGlob = {}));
function getWorks(source, _Provider, options) {
    const patterns = [].concat(source);
    const settings = new settings_1.default(options);
    const tasks = taskManager.generate(patterns, settings);
    const provider = new _Provider(settings);
    return tasks.map(provider.read, provider);
}
function assertPatternsInput(input) {
    const source = [].concat(input);
    const isValidSource = source.every((item) => utils$5.string.isString(item) && !utils$5.string.isEmpty(item));
    if (!isValidSource) {
        throw new TypeError('Patterns must be a string (non empty) or an array of strings');
    }
}
var out = FastGlob;

var fg = /*@__PURE__*/getDefaultExportFromCjs(out);

function u(u){return u&&"object"==typeof u&&"default"in u?u.default:u}var D=u(require$$0__default$2["default"]),e=path__default["default"],t=require$$0__default["default"],r=u(require$$0__default$1["default"]),n$1=u(tty__default["default"]);function s(u,D){return u(D={exports:{}},D.exports),D.exports}var o,i$2=(o=Object.freeze({__proto__:null,default:[{name:"AppVeyor",constant:"APPVEYOR",env:"APPVEYOR",pr:"APPVEYOR_PULL_REQUEST_NUMBER"},{name:"Bamboo",constant:"BAMBOO",env:"bamboo_planKey"},{name:"Bitbucket Pipelines",constant:"BITBUCKET",env:"BITBUCKET_COMMIT"},{name:"Bitrise",constant:"BITRISE",env:"BITRISE_IO",pr:"BITRISE_PULL_REQUEST"},{name:"Buddy",constant:"BUDDY",env:"BUDDY_WORKSPACE_ID",pr:"BUDDY_EXECUTION_PULL_REQUEST_ID"},{name:"Buildkite",constant:"BUILDKITE",env:"BUILDKITE",pr:{env:"BUILDKITE_PULL_REQUEST",ne:"false"}},{name:"CircleCI",constant:"CIRCLE",env:"CIRCLECI",pr:"CIRCLE_PULL_REQUEST"},{name:"Cirrus CI",constant:"CIRRUS",env:"CIRRUS_CI",pr:"CIRRUS_PR"},{name:"AWS CodeBuild",constant:"CODEBUILD",env:"CODEBUILD_BUILD_ARN"},{name:"Codeship",constant:"CODESHIP",env:{CI_NAME:"codeship"}},{name:"Drone",constant:"DRONE",env:"DRONE",pr:{DRONE_BUILD_EVENT:"pull_request"}},{name:"dsari",constant:"DSARI",env:"DSARI"},{name:"GitLab CI",constant:"GITLAB",env:"GITLAB_CI"},{name:"GoCD",constant:"GOCD",env:"GO_PIPELINE_LABEL"},{name:"Hudson",constant:"HUDSON",env:"HUDSON_URL"},{name:"Jenkins",constant:"JENKINS",env:["JENKINS_URL","BUILD_ID"],pr:{any:["ghprbPullId","CHANGE_ID"]}},{name:"Magnum CI",constant:"MAGNUM",env:"MAGNUM"},{name:"Sail CI",constant:"SAIL",env:"SAILCI",pr:"SAIL_PULL_REQUEST_NUMBER"},{name:"Semaphore",constant:"SEMAPHORE",env:"SEMAPHORE",pr:"PULL_REQUEST_NUMBER"},{name:"Shippable",constant:"SHIPPABLE",env:"SHIPPABLE",pr:{IS_PULL_REQUEST:"true"}},{name:"Solano CI",constant:"SOLANO",env:"TDDIUM",pr:"TDDIUM_PR_ID"},{name:"Strider CD",constant:"STRIDER",env:"STRIDER"},{name:"TaskCluster",constant:"TASKCLUSTER",env:["TASK_ID","RUN_ID"]},{name:"Solano CI",constant:"TDDIUM",env:"TDDIUM",pr:"TDDIUM_PR_ID",deprecated:!0},{name:"TeamCity",constant:"TEAMCITY",env:"TEAMCITY_VERSION"},{name:"Team Foundation Server",constant:"TFS",env:"TF_BUILD"},{name:"Travis CI",constant:"TRAVIS",env:"TRAVIS",pr:{env:"TRAVIS_PULL_REQUEST",ne:"false"}}]}))&&o.default||o,a=s((function(u,D){var e=process.env;function t(u){return "string"==typeof u?!!e[u]:Object.keys(u).every((function(D){return e[D]===u[D]}))}Object.defineProperty(D,"_vendors",{value:i$2.map((function(u){return u.constant}))}),D.name=null,D.isPR=null,i$2.forEach((function(u){var r=(Array.isArray(u.env)?u.env:[u.env]).every((function(u){return t(u)}));if(D[u.constant]=r,r)switch(D.name=u.name,typeof u.pr){case"string":D.isPR=!!e[u.pr];break;case"object":"env"in u.pr?D.isPR=u.pr.env in e&&e[u.pr.env]!==u.pr.ne:"any"in u.pr?D.isPR=u.pr.any.some((function(u){return !!e[u]})):D.isPR=t(u.pr);break;default:D.isPR=null;}})),D.isCI=!!(e.CI||e.CONTINUOUS_INTEGRATION||e.BUILD_NUMBER||e.RUN_ID||D.name);})),l=(a.name,a.isPR,a.isCI,!1),c=!1,h=!1,F="development",C="undefined"!=typeof window,f="",E=!1;function g(u){return !(!u||"false"===u)}"undefined"!=typeof process&&(process.platform&&(f=String(process.platform)),process.stdout&&(h=g(process.stdout.isTTY)),l=Boolean(a.isCI),process.env&&(process.env.NODE_ENV&&(F=process.env.NODE_ENV),c=g(process.env.DEBUG),E=g(process.env.MINIMAL)));var d={browser:C,test:"test"===F,dev:"development"===F||"dev"===F,production:"production"===F,debug:c,ci:l,tty:h,minimal:void 0,minimalCLI:void 0,windows:/^win/i.test(f),darwin:/^darwin/i.test(f),linux:/^linux/i.test(f)};d.minimal=E||d.ci||d.test||!d.tty,d.minimalCLI=d.minimal;var p=Object.freeze(d);const m={};m[m.Fatal=0]="Fatal",m[m.Error=0]="Error",m[m.Warn=1]="Warn",m[m.Log=2]="Log",m[m.Info=3]="Info",m[m.Success=3]="Success",m[m.Debug=4]="Debug",m[m.Trace=5]="Trace",m[m.Silent=-1/0]="Silent",m[m.Verbose=1/0]="Verbose";var b={silent:{level:-1},fatal:{level:m.Fatal},error:{level:m.Error},warn:{level:m.Warn},log:{level:m.Log},info:{level:m.Info},success:{level:m.Success},debug:{level:m.Debug},trace:{level:m.Trace},verbose:{level:m.Trace},ready:{level:m.Info},start:{level:m.Info}};function y(u){return D=u,"[object Object]"===Object.prototype.toString.call(D)&&(!(!u.message&&!u.args)&&!u.stack);var D;}let B=!1;const v=[];class _{constructor(u={}){this._reporters=u.reporters||[],this._types=u.types||b,this.level=void 0!==u.level?u.level:3,this._defaults=u.defaults||{},this._async=void 0!==u.async?u.async:void 0,this._stdout=u.stdout,this._stderr=u.stderr,this._mockFn=u.mockFn,this._throttle=u.throttle||1e3,this._throttleMin=u.throttleMin||5;for(const u in this._types){const D={type:u,...this._types[u],...this._defaults};this[u]=this._wrapLogFn(D),this[u].raw=this._wrapLogFn(D,!0);}this._mockFn&&this.mockTypes(),this._lastLogSerialized=void 0,this._lastLog=void 0,this._lastLogTime=void 0,this._lastLogCount=0,this._throttleTimeout=void 0;}get stdout(){return this._stdout||console._stdout}get stderr(){return this._stderr||console._stderr}create(u){return new _(Object.assign({reporters:this._reporters,level:this.level,types:this._types,defaults:this._defaults,stdout:this._stdout,stderr:this._stderr,mockFn:this._mockFn},u))}withDefaults(u){return this.create({defaults:Object.assign({},this._defaults,u)})}withTag(u){return this.withDefaults({tag:this._defaults.tag?this._defaults.tag+":"+u:u})}addReporter(u){return this._reporters.push(u),this}removeReporter(u){if(u){const D=this._reporters.indexOf(u);if(D>=0)return this._reporters.splice(D,1)}else this._reporters.splice(0);return this}setReporters(u){return this._reporters=Array.isArray(u)?u:[u],this}wrapAll(){this.wrapConsole(),this.wrapStd();}restoreAll(){this.restoreConsole(),this.restoreStd();}wrapConsole(){for(const u in this._types)console["__"+u]||(console["__"+u]=console[u]),console[u]=this[u].raw;}restoreConsole(){for(const u in this._types)console["__"+u]&&(console[u]=console["__"+u],delete console["__"+u]);}wrapStd(){this._wrapStream(this.stdout,"log"),this._wrapStream(this.stderr,"log");}_wrapStream(u,D){u&&(u.__write||(u.__write=u.write),u.write=u=>{this[D].raw(String(u).trim());});}restoreStd(){this._restoreStream(this.stdout),this._restoreStream(this.stderr);}_restoreStream(u){u&&u.__write&&(u.write=u.__write,delete u.__write);}pauseLogs(){B=!0;}resumeLogs(){B=!1;const u=v.splice(0);for(const D of u)D[0]._logFn(D[1],D[2]);}mockTypes(u){if(this._mockFn=u||this._mockFn,"function"==typeof this._mockFn)for(const u in this._types)this[u]=this._mockFn(u,this._types[u])||this[u],this[u].raw=this[u];}_wrapLogFn(u,D){return (...e)=>{if(!B)return this._logFn(u,e,D);v.push([this,u,e,D]);}}_logFn(u,D,e){if(u.level>this.level)return !!this._async&&Promise.resolve(!1);const t=Object.assign({date:new Date,args:[]},u);!e&&1===D.length&&y(D[0])?Object.assign(t,D[0]):t.args=Array.from(D),t.message&&(t.args.unshift(t.message),delete t.message),t.additional&&(Array.isArray(t.additional)||(t.additional=t.additional.split("\n")),t.args.push("\n"+t.additional.join("\n")),delete t.additional),t.type="string"==typeof t.type?t.type.toLowerCase():"",t.tag="string"==typeof t.tag?t.tag.toLowerCase():"";const r=(u=!1)=>{const D=this._lastLogCount-this._throttleMin;if(this._lastLog&&D>0){const u=[...this._lastLog.args];D>1&&u.push(`(repeated ${D} times)`),this._log({...this._lastLog,args:u}),this._lastLogCount=1;}if(u){if(this._lastLog=t,this._async)return this._logAsync(t);this._log(t);}};clearTimeout(this._throttleTimeout);const n=this._lastLogTime?t.date-this._lastLogTime:0;if(this._lastLogTime=t.date,n<this._throttle)try{const u=JSON.stringify([t.type,t.tag,t.args]),D=this._lastLogSerialized===u;if(this._lastLogSerialized=u,D&&(this._lastLogCount++,this._lastLogCount>this._throttleMin))return void(this._throttleTimeout=setTimeout(r,this._throttle))}catch(u){}r(!0);}_log(u){for(const D of this._reporters)D.log(u,{async:!1,stdout:this.stdout,stderr:this.stderr});}_logAsync(u){return Promise.all(this._reporters.map(D=>D.log(u,{async:!0,stdout:this.stdout,stderr:this.stderr})))}}function A(u){const D=process.cwd()+e.sep;return u.split("\n").splice(1).map(u=>u.trim().replace("file://","").replace(D,""))}_.prototype.add=_.prototype.addReporter,_.prototype.remove=_.prototype.removeReporter,_.prototype.clear=_.prototype.removeReporter,_.prototype.withScope=_.prototype.withTag,_.prototype.mock=_.prototype.mockTypes,_.prototype.pause=_.prototype.pauseLogs,_.prototype.resume=_.prototype.resumeLogs;var w=s((function(u,D){u.exports=function(){var u="millisecond",D="second",e="minute",t="hour",r="day",n="week",s="month",o="quarter",i="year",a=/^(\d{4})-?(\d{1,2})-?(\d{0,2})[^0-9]*(\d{1,2})?:?(\d{1,2})?:?(\d{1,2})?.?(\d{1,3})?$/,l=/\[([^\]]+)]|Y{2,4}|M{1,4}|D{1,2}|d{1,4}|H{1,2}|h{1,2}|a|A|m{1,2}|s{1,2}|Z{1,2}|SSS/g,c=function(u,D,e){var t=String(u);return !t||t.length>=D?u:""+Array(D+1-t.length).join(e)+u},h={s:c,z:function(u){var D=-u.utcOffset(),e=Math.abs(D),t=Math.floor(e/60),r=e%60;return (D<=0?"+":"-")+c(t,2,"0")+":"+c(r,2,"0")},m:function(u,D){var e=12*(D.year()-u.year())+(D.month()-u.month()),t=u.clone().add(e,s),r=D-t<0,n=u.clone().add(e+(r?-1:1),s);return Number(-(e+(D-t)/(r?t-n:n-t))||0)},a:function(u){return u<0?Math.ceil(u)||0:Math.floor(u)},p:function(a){return {M:s,y:i,w:n,d:r,D:"date",h:t,m:e,s:D,ms:u,Q:o}[a]||String(a||"").toLowerCase().replace(/s$/,"")},u:function(u){return void 0===u}},F={name:"en",weekdays:"Sunday_Monday_Tuesday_Wednesday_Thursday_Friday_Saturday".split("_"),months:"January_February_March_April_May_June_July_August_September_October_November_December".split("_")},C="en",f={};f[C]=F;var E=function(u){return u instanceof m},g=function(u,D,e){var t;if(!u)return C;if("string"==typeof u)f[u]&&(t=u),D&&(f[u]=D,t=u);else {var r=u.name;f[r]=u,t=r;}return !e&&t&&(C=t),t||!e&&C},d=function(u,D){if(E(u))return u.clone();var e="object"==typeof D?D:{};return e.date=u,e.args=arguments,new m(e)},p=h;p.l=g,p.i=E,p.w=function(u,D){return d(u,{locale:D.$L,utc:D.$u,$offset:D.$offset})};var m=function(){function c(u){this.$L=this.$L||g(u.locale,null,!0),this.parse(u);}var h=c.prototype;return h.parse=function(u){this.$d=function(u){var D=u.date,e=u.utc;if(null===D)return new Date(NaN);if(p.u(D))return new Date;if(D instanceof Date)return new Date(D);if("string"==typeof D&&!/Z$/i.test(D)){var t=D.match(a);if(t)return e?new Date(Date.UTC(t[1],t[2]-1,t[3]||1,t[4]||0,t[5]||0,t[6]||0,t[7]||0)):new Date(t[1],t[2]-1,t[3]||1,t[4]||0,t[5]||0,t[6]||0,t[7]||0)}return new Date(D)}(u),this.init();},h.init=function(){var u=this.$d;this.$y=u.getFullYear(),this.$M=u.getMonth(),this.$D=u.getDate(),this.$W=u.getDay(),this.$H=u.getHours(),this.$m=u.getMinutes(),this.$s=u.getSeconds(),this.$ms=u.getMilliseconds();},h.$utils=function(){return p},h.isValid=function(){return !("Invalid Date"===this.$d.toString())},h.isSame=function(u,D){var e=d(u);return this.startOf(D)<=e&&e<=this.endOf(D)},h.isAfter=function(u,D){return d(u)<this.startOf(D)},h.isBefore=function(u,D){return this.endOf(D)<d(u)},h.$g=function(u,D,e){return p.u(u)?this[D]:this.set(e,u)},h.year=function(u){return this.$g(u,"$y",i)},h.month=function(u){return this.$g(u,"$M",s)},h.day=function(u){return this.$g(u,"$W",r)},h.date=function(u){return this.$g(u,"$D","date")},h.hour=function(u){return this.$g(u,"$H",t)},h.minute=function(u){return this.$g(u,"$m",e)},h.second=function(u){return this.$g(u,"$s",D)},h.millisecond=function(D){return this.$g(D,"$ms",u)},h.unix=function(){return Math.floor(this.valueOf()/1e3)},h.valueOf=function(){return this.$d.getTime()},h.startOf=function(u,o){var a=this,l=!!p.u(o)||o,c=p.p(u),h=function(u,D){var e=p.w(a.$u?Date.UTC(a.$y,D,u):new Date(a.$y,D,u),a);return l?e:e.endOf(r)},F=function(u,D){return p.w(a.toDate()[u].apply(a.toDate("s"),(l?[0,0,0,0]:[23,59,59,999]).slice(D)),a)},C=this.$W,f=this.$M,E=this.$D,g="set"+(this.$u?"UTC":"");switch(c){case i:return l?h(1,0):h(31,11);case s:return l?h(1,f):h(0,f+1);case n:var d=this.$locale().weekStart||0,m=(C<d?C+7:C)-d;return h(l?E-m:E+(6-m),f);case r:case"date":return F(g+"Hours",0);case t:return F(g+"Minutes",1);case e:return F(g+"Seconds",2);case D:return F(g+"Milliseconds",3);default:return this.clone()}},h.endOf=function(u){return this.startOf(u,!1)},h.$set=function(n,o){var a,l=p.p(n),c="set"+(this.$u?"UTC":""),h=(a={},a.day=c+"Date",a.date=c+"Date",a[s]=c+"Month",a[i]=c+"FullYear",a[t]=c+"Hours",a[e]=c+"Minutes",a[D]=c+"Seconds",a[u]=c+"Milliseconds",a)[l],F=l===r?this.$D+(o-this.$W):o;if(l===s||l===i){var C=this.clone().set("date",1);C.$d[h](F),C.init(),this.$d=C.set("date",Math.min(this.$D,C.daysInMonth())).toDate();}else h&&this.$d[h](F);return this.init(),this},h.set=function(u,D){return this.clone().$set(u,D)},h.get=function(u){return this[p.p(u)]()},h.add=function(u,o){var a,l=this;u=Number(u);var c=p.p(o),h=function(D){var e=d(l);return p.w(e.date(e.date()+Math.round(D*u)),l)};if(c===s)return this.set(s,this.$M+u);if(c===i)return this.set(i,this.$y+u);if(c===r)return h(1);if(c===n)return h(7);var F=(a={},a[e]=6e4,a[t]=36e5,a[D]=1e3,a)[c]||1,C=this.$d.getTime()+u*F;return p.w(C,this)},h.subtract=function(u,D){return this.add(-1*u,D)},h.format=function(u){var D=this;if(!this.isValid())return "Invalid Date";var e=u||"YYYY-MM-DDTHH:mm:ssZ",t=p.z(this),r=this.$locale(),n=this.$H,s=this.$m,o=this.$M,i=r.weekdays,a=r.months,c=function(u,t,r,n){return u&&(u[t]||u(D,e))||r[t].substr(0,n)},h=function(u){return p.s(n%12||12,u,"0")},F=r.meridiem||function(u,D,e){var t=u<12?"AM":"PM";return e?t.toLowerCase():t},C={YY:String(this.$y).slice(-2),YYYY:this.$y,M:o+1,MM:p.s(o+1,2,"0"),MMM:c(r.monthsShort,o,a,3),MMMM:c(a,o),D:this.$D,DD:p.s(this.$D,2,"0"),d:String(this.$W),dd:c(r.weekdaysMin,this.$W,i,2),ddd:c(r.weekdaysShort,this.$W,i,3),dddd:i[this.$W],H:String(n),HH:p.s(n,2,"0"),h:h(1),hh:h(2),a:F(n,s,!0),A:F(n,s,!1),m:String(s),mm:p.s(s,2,"0"),s:String(this.$s),ss:p.s(this.$s,2,"0"),SSS:p.s(this.$ms,3,"0"),Z:t};return e.replace(l,(function(u,D){return D||C[u]||t.replace(":","")}))},h.utcOffset=function(){return 15*-Math.round(this.$d.getTimezoneOffset()/15)},h.diff=function(u,r,a){var l,c=p.p(r),h=d(u),F=6e4*(h.utcOffset()-this.utcOffset()),C=this-h,f=p.m(this,h);return f=(l={},l[i]=f/12,l[s]=f,l[o]=f/3,l[n]=(C-F)/6048e5,l.day=(C-F)/864e5,l[t]=C/36e5,l[e]=C/6e4,l[D]=C/1e3,l)[c]||C,a?f:p.a(f)},h.daysInMonth=function(){return this.endOf(s).$D},h.$locale=function(){return f[this.$L]},h.locale=function(u,D){if(!u)return this.$L;var e=this.clone(),t=g(u,D,!0);return t&&(e.$L=t),e},h.clone=function(){return p.w(this.$d,this)},h.toDate=function(){return new Date(this.valueOf())},h.toJSON=function(){return this.isValid()?this.toISOString():null},h.toISOString=function(){return this.$d.toISOString()},h.toString=function(){return this.$d.toUTCString()},c}();return d.prototype=m.prototype,d.extend=function(u,D){return u(D,m,d),d},d.locale=g,d.isDayjs=E,d.unix=function(u){return d(1e3*u)},d.en=f[C],d.Ls=f,d}();}));const O={dateFormat:"HH:mm:ss",formatOptions:{date:!0,colors:!1,compact:!0}},M=u=>u?`[${u}]`:"";class S{constructor(u){this.options=Object.assign({},O,u);}formatStack(u){return "  "+A(u).join("\n  ")}formatArgs(u){const e=u.map(u=>u&&"string"==typeof u.stack?u.message+"\n"+this.formatStack(u.stack):u);return "function"==typeof D.formatWithOptions?D.formatWithOptions(this.options.formatOptions,...e):D.format(...e)}formatDate(u){return this.options.formatOptions.date?function(u,D){return w(D).format(u)}(this.options.dateFormat,u):""}filterAndJoin(u){return u.filter(u=>u).join(" ")}formatLogObj(u){const D=this.formatArgs(u.args);return this.filterAndJoin([M(u.type),M(u.tag),D])}log(u,{async:D,stdout:e,stderr:r}={}){return function(u,D,e="default"){const r=D.__write||D.write;switch(e){case"async":return new Promise(e=>{!0===r.call(D,u)?e():D.once("drain",()=>{e();});});case"sync":return t.writeSync(D.fd,u);default:return r.call(D,u)}}(this.formatLogObj(u,{width:e.columns||0})+"\n",u.level<2?r:e,D?"async":"default")}}var I=u=>"string"==typeof u?u.replace((({onlyFirst:u=!1}={})=>{const D=["[\\u001B\\u009B][[\\]()#;?]*(?:(?:(?:[a-zA-Z\\d]*(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]*)*)?\\u0007)","(?:(?:\\d{1,4}(?:;\\d{0,4})*)?[\\dA-PR-TZcf-ntqry=><~]))"].join("|");return new RegExp(D,u?void 0:"g")})(),""):u;const k=u=>!Number.isNaN(u)&&(u>=4352&&(u<=4447||9001===u||9002===u||11904<=u&&u<=12871&&12351!==u||12880<=u&&u<=19903||19968<=u&&u<=42182||43360<=u&&u<=43388||44032<=u&&u<=55203||63744<=u&&u<=64255||65040<=u&&u<=65049||65072<=u&&u<=65131||65281<=u&&u<=65376||65504<=u&&u<=65510||110592<=u&&u<=110593||127488<=u&&u<=127569||131072<=u&&u<=262141));var R=k,T=k;R.default=T;const L=u=>{if("string"!=typeof(u=u.replace(/\uD83C\uDFF4\uDB40\uDC67\uDB40\uDC62(?:\uDB40\uDC65\uDB40\uDC6E\uDB40\uDC67|\uDB40\uDC73\uDB40\uDC63\uDB40\uDC74|\uDB40\uDC77\uDB40\uDC6C\uDB40\uDC73)\uDB40\uDC7F|\uD83D\uDC68(?:\uD83C\uDFFC\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFB|\uD83C[\uDF3E\uDF73\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFF\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFE])|\uD83C[\uDF3E\uDF73\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFE\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFD])|\uD83C[\uDF3E\uDF73\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFD\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB\uDFFC])|\uD83C[\uDF3E\uDF73\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\u200D(?:\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83D\uDC68|(?:\uD83D[\uDC68\uDC69])\u200D(?:\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67]))|\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67])|(?:\uD83D[\uDC68\uDC69])\u200D(?:\uD83D[\uDC66\uDC67])|[\u2695\u2696\u2708]\uFE0F|\uD83D[\uDC66\uDC67]|\uD83C[\uDF3E\uDF73\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|(?:\uD83C\uDFFB\u200D[\u2695\u2696\u2708]|\uD83C\uDFFF\u200D[\u2695\u2696\u2708]|\uD83C\uDFFE\u200D[\u2695\u2696\u2708]|\uD83C\uDFFD\u200D[\u2695\u2696\u2708]|\uD83C\uDFFC\u200D[\u2695\u2696\u2708])\uFE0F|\uD83C\uDFFB\u200D(?:\uD83C[\uDF3E\uDF73\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C[\uDFFB-\uDFFF])|(?:\uD83E\uDDD1\uD83C\uDFFB\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFC\u200D\uD83E\uDD1D\u200D\uD83D\uDC69)\uD83C\uDFFB|\uD83E\uDDD1(?:\uD83C\uDFFF\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1(?:\uD83C[\uDFFB-\uDFFF])|\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1)|(?:\uD83E\uDDD1\uD83C\uDFFE\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFF\u200D\uD83E\uDD1D\u200D(?:\uD83D[\uDC68\uDC69]))(?:\uD83C[\uDFFB-\uDFFE])|(?:\uD83E\uDDD1\uD83C\uDFFC\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFD\u200D\uD83E\uDD1D\u200D\uD83D\uDC69)(?:\uD83C[\uDFFB\uDFFC])|\uD83D\uDC69(?:\uD83C\uDFFE\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFD\uDFFF])|\uD83C[\uDF3E\uDF73\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFC\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB\uDFFD-\uDFFF])|\uD83C[\uDF3E\uDF73\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFB\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFC-\uDFFF])|\uD83C[\uDF3E\uDF73\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFD\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB\uDFFC\uDFFE\uDFFF])|\uD83C[\uDF3E\uDF73\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\u200D(?:\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D(?:\uD83D[\uDC68\uDC69])|\uD83D[\uDC68\uDC69])|\uD83C[\uDF3E\uDF73\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFF\u200D(?:\uD83C[\uDF3E\uDF73\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD]))|\uD83D\uDC69\u200D\uD83D\uDC69\u200D(?:\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67]))|(?:\uD83E\uDDD1\uD83C\uDFFD\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFE\u200D\uD83E\uDD1D\u200D\uD83D\uDC69)(?:\uD83C[\uDFFB-\uDFFD])|\uD83D\uDC69\u200D\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC69\u200D\uD83D\uDC69\u200D(?:\uD83D[\uDC66\uDC67])|(?:\uD83D\uDC41\uFE0F\u200D\uD83D\uDDE8|\uD83D\uDC69(?:\uD83C\uDFFF\u200D[\u2695\u2696\u2708]|\uD83C\uDFFE\u200D[\u2695\u2696\u2708]|\uD83C\uDFFC\u200D[\u2695\u2696\u2708]|\uD83C\uDFFB\u200D[\u2695\u2696\u2708]|\uD83C\uDFFD\u200D[\u2695\u2696\u2708]|\u200D[\u2695\u2696\u2708])|(?:(?:\u26F9|\uD83C[\uDFCB\uDFCC]|\uD83D\uDD75)\uFE0F|\uD83D\uDC6F|\uD83E[\uDD3C\uDDDE\uDDDF])\u200D[\u2640\u2642]|(?:\u26F9|\uD83C[\uDFCB\uDFCC]|\uD83D\uDD75)(?:\uD83C[\uDFFB-\uDFFF])\u200D[\u2640\u2642]|(?:\uD83C[\uDFC3\uDFC4\uDFCA]|\uD83D[\uDC6E\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6]|\uD83E[\uDD26\uDD37-\uDD39\uDD3D\uDD3E\uDDB8\uDDB9\uDDCD-\uDDCF\uDDD6-\uDDDD])(?:(?:\uD83C[\uDFFB-\uDFFF])\u200D[\u2640\u2642]|\u200D[\u2640\u2642])|\uD83C\uDFF4\u200D\u2620)\uFE0F|\uD83D\uDC69\u200D\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67])|\uD83C\uDFF3\uFE0F\u200D\uD83C\uDF08|\uD83D\uDC15\u200D\uD83E\uDDBA|\uD83D\uDC69\u200D\uD83D\uDC66|\uD83D\uDC69\u200D\uD83D\uDC67|\uD83C\uDDFD\uD83C\uDDF0|\uD83C\uDDF4\uD83C\uDDF2|\uD83C\uDDF6\uD83C\uDDE6|[#\*0-9]\uFE0F\u20E3|\uD83C\uDDE7(?:\uD83C[\uDDE6\uDDE7\uDDE9-\uDDEF\uDDF1-\uDDF4\uDDF6-\uDDF9\uDDFB\uDDFC\uDDFE\uDDFF])|\uD83C\uDDF9(?:\uD83C[\uDDE6\uDDE8\uDDE9\uDDEB-\uDDED\uDDEF-\uDDF4\uDDF7\uDDF9\uDDFB\uDDFC\uDDFF])|\uD83C\uDDEA(?:\uD83C[\uDDE6\uDDE8\uDDEA\uDDEC\uDDED\uDDF7-\uDDFA])|\uD83E\uDDD1(?:\uD83C[\uDFFB-\uDFFF])|\uD83C\uDDF7(?:\uD83C[\uDDEA\uDDF4\uDDF8\uDDFA\uDDFC])|\uD83D\uDC69(?:\uD83C[\uDFFB-\uDFFF])|\uD83C\uDDF2(?:\uD83C[\uDDE6\uDDE8-\uDDED\uDDF0-\uDDFF])|\uD83C\uDDE6(?:\uD83C[\uDDE8-\uDDEC\uDDEE\uDDF1\uDDF2\uDDF4\uDDF6-\uDDFA\uDDFC\uDDFD\uDDFF])|\uD83C\uDDF0(?:\uD83C[\uDDEA\uDDEC-\uDDEE\uDDF2\uDDF3\uDDF5\uDDF7\uDDFC\uDDFE\uDDFF])|\uD83C\uDDED(?:\uD83C[\uDDF0\uDDF2\uDDF3\uDDF7\uDDF9\uDDFA])|\uD83C\uDDE9(?:\uD83C[\uDDEA\uDDEC\uDDEF\uDDF0\uDDF2\uDDF4\uDDFF])|\uD83C\uDDFE(?:\uD83C[\uDDEA\uDDF9])|\uD83C\uDDEC(?:\uD83C[\uDDE6\uDDE7\uDDE9-\uDDEE\uDDF1-\uDDF3\uDDF5-\uDDFA\uDDFC\uDDFE])|\uD83C\uDDF8(?:\uD83C[\uDDE6-\uDDEA\uDDEC-\uDDF4\uDDF7-\uDDF9\uDDFB\uDDFD-\uDDFF])|\uD83C\uDDEB(?:\uD83C[\uDDEE-\uDDF0\uDDF2\uDDF4\uDDF7])|\uD83C\uDDF5(?:\uD83C[\uDDE6\uDDEA-\uDDED\uDDF0-\uDDF3\uDDF7-\uDDF9\uDDFC\uDDFE])|\uD83C\uDDFB(?:\uD83C[\uDDE6\uDDE8\uDDEA\uDDEC\uDDEE\uDDF3\uDDFA])|\uD83C\uDDF3(?:\uD83C[\uDDE6\uDDE8\uDDEA-\uDDEC\uDDEE\uDDF1\uDDF4\uDDF5\uDDF7\uDDFA\uDDFF])|\uD83C\uDDE8(?:\uD83C[\uDDE6\uDDE8\uDDE9\uDDEB-\uDDEE\uDDF0-\uDDF5\uDDF7\uDDFA-\uDDFF])|\uD83C\uDDF1(?:\uD83C[\uDDE6-\uDDE8\uDDEE\uDDF0\uDDF7-\uDDFB\uDDFE])|\uD83C\uDDFF(?:\uD83C[\uDDE6\uDDF2\uDDFC])|\uD83C\uDDFC(?:\uD83C[\uDDEB\uDDF8])|\uD83C\uDDFA(?:\uD83C[\uDDE6\uDDEC\uDDF2\uDDF3\uDDF8\uDDFE\uDDFF])|\uD83C\uDDEE(?:\uD83C[\uDDE8-\uDDEA\uDDF1-\uDDF4\uDDF6-\uDDF9])|\uD83C\uDDEF(?:\uD83C[\uDDEA\uDDF2\uDDF4\uDDF5])|(?:\uD83C[\uDFC3\uDFC4\uDFCA]|\uD83D[\uDC6E\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6]|\uD83E[\uDD26\uDD37-\uDD39\uDD3D\uDD3E\uDDB8\uDDB9\uDDCD-\uDDCF\uDDD6-\uDDDD])(?:\uD83C[\uDFFB-\uDFFF])|(?:\u26F9|\uD83C[\uDFCB\uDFCC]|\uD83D\uDD75)(?:\uD83C[\uDFFB-\uDFFF])|(?:[\u261D\u270A-\u270D]|\uD83C[\uDF85\uDFC2\uDFC7]|\uD83D[\uDC42\uDC43\uDC46-\uDC50\uDC66\uDC67\uDC6B-\uDC6D\uDC70\uDC72\uDC74-\uDC76\uDC78\uDC7C\uDC83\uDC85\uDCAA\uDD74\uDD7A\uDD90\uDD95\uDD96\uDE4C\uDE4F\uDEC0\uDECC]|\uD83E[\uDD0F\uDD18-\uDD1C\uDD1E\uDD1F\uDD30-\uDD36\uDDB5\uDDB6\uDDBB\uDDD2-\uDDD5])(?:\uD83C[\uDFFB-\uDFFF])|(?:[\u231A\u231B\u23E9-\u23EC\u23F0\u23F3\u25FD\u25FE\u2614\u2615\u2648-\u2653\u267F\u2693\u26A1\u26AA\u26AB\u26BD\u26BE\u26C4\u26C5\u26CE\u26D4\u26EA\u26F2\u26F3\u26F5\u26FA\u26FD\u2705\u270A\u270B\u2728\u274C\u274E\u2753-\u2755\u2757\u2795-\u2797\u27B0\u27BF\u2B1B\u2B1C\u2B50\u2B55]|\uD83C[\uDC04\uDCCF\uDD8E\uDD91-\uDD9A\uDDE6-\uDDFF\uDE01\uDE1A\uDE2F\uDE32-\uDE36\uDE38-\uDE3A\uDE50\uDE51\uDF00-\uDF20\uDF2D-\uDF35\uDF37-\uDF7C\uDF7E-\uDF93\uDFA0-\uDFCA\uDFCF-\uDFD3\uDFE0-\uDFF0\uDFF4\uDFF8-\uDFFF]|\uD83D[\uDC00-\uDC3E\uDC40\uDC42-\uDCFC\uDCFF-\uDD3D\uDD4B-\uDD4E\uDD50-\uDD67\uDD7A\uDD95\uDD96\uDDA4\uDDFB-\uDE4F\uDE80-\uDEC5\uDECC\uDED0-\uDED2\uDED5\uDEEB\uDEEC\uDEF4-\uDEFA\uDFE0-\uDFEB]|\uD83E[\uDD0D-\uDD3A\uDD3C-\uDD45\uDD47-\uDD71\uDD73-\uDD76\uDD7A-\uDDA2\uDDA5-\uDDAA\uDDAE-\uDDCA\uDDCD-\uDDFF\uDE70-\uDE73\uDE78-\uDE7A\uDE80-\uDE82\uDE90-\uDE95])|(?:[#\*0-9\xA9\xAE\u203C\u2049\u2122\u2139\u2194-\u2199\u21A9\u21AA\u231A\u231B\u2328\u23CF\u23E9-\u23F3\u23F8-\u23FA\u24C2\u25AA\u25AB\u25B6\u25C0\u25FB-\u25FE\u2600-\u2604\u260E\u2611\u2614\u2615\u2618\u261D\u2620\u2622\u2623\u2626\u262A\u262E\u262F\u2638-\u263A\u2640\u2642\u2648-\u2653\u265F\u2660\u2663\u2665\u2666\u2668\u267B\u267E\u267F\u2692-\u2697\u2699\u269B\u269C\u26A0\u26A1\u26AA\u26AB\u26B0\u26B1\u26BD\u26BE\u26C4\u26C5\u26C8\u26CE\u26CF\u26D1\u26D3\u26D4\u26E9\u26EA\u26F0-\u26F5\u26F7-\u26FA\u26FD\u2702\u2705\u2708-\u270D\u270F\u2712\u2714\u2716\u271D\u2721\u2728\u2733\u2734\u2744\u2747\u274C\u274E\u2753-\u2755\u2757\u2763\u2764\u2795-\u2797\u27A1\u27B0\u27BF\u2934\u2935\u2B05-\u2B07\u2B1B\u2B1C\u2B50\u2B55\u3030\u303D\u3297\u3299]|\uD83C[\uDC04\uDCCF\uDD70\uDD71\uDD7E\uDD7F\uDD8E\uDD91-\uDD9A\uDDE6-\uDDFF\uDE01\uDE02\uDE1A\uDE2F\uDE32-\uDE3A\uDE50\uDE51\uDF00-\uDF21\uDF24-\uDF93\uDF96\uDF97\uDF99-\uDF9B\uDF9E-\uDFF0\uDFF3-\uDFF5\uDFF7-\uDFFF]|\uD83D[\uDC00-\uDCFD\uDCFF-\uDD3D\uDD49-\uDD4E\uDD50-\uDD67\uDD6F\uDD70\uDD73-\uDD7A\uDD87\uDD8A-\uDD8D\uDD90\uDD95\uDD96\uDDA4\uDDA5\uDDA8\uDDB1\uDDB2\uDDBC\uDDC2-\uDDC4\uDDD1-\uDDD3\uDDDC-\uDDDE\uDDE1\uDDE3\uDDE8\uDDEF\uDDF3\uDDFA-\uDE4F\uDE80-\uDEC5\uDECB-\uDED2\uDED5\uDEE0-\uDEE5\uDEE9\uDEEB\uDEEC\uDEF0\uDEF3-\uDEFA\uDFE0-\uDFEB]|\uD83E[\uDD0D-\uDD3A\uDD3C-\uDD45\uDD47-\uDD71\uDD73-\uDD76\uDD7A-\uDDA2\uDDA5-\uDDAA\uDDAE-\uDDCA\uDDCD-\uDDFF\uDE70-\uDE73\uDE78-\uDE7A\uDE80-\uDE82\uDE90-\uDE95])\uFE0F|(?:[\u261D\u26F9\u270A-\u270D]|\uD83C[\uDF85\uDFC2-\uDFC4\uDFC7\uDFCA-\uDFCC]|\uD83D[\uDC42\uDC43\uDC46-\uDC50\uDC66-\uDC78\uDC7C\uDC81-\uDC83\uDC85-\uDC87\uDC8F\uDC91\uDCAA\uDD74\uDD75\uDD7A\uDD90\uDD95\uDD96\uDE45-\uDE47\uDE4B-\uDE4F\uDEA3\uDEB4-\uDEB6\uDEC0\uDECC]|\uD83E[\uDD0F\uDD18-\uDD1F\uDD26\uDD30-\uDD39\uDD3C-\uDD3E\uDDB5\uDDB6\uDDB8\uDDB9\uDDBB\uDDCD-\uDDCF\uDDD1-\uDDDD])/g,"  "))||0===u.length)return 0;u=I(u);let D=0;for(let e=0;e<u.length;e++){const t=u.codePointAt(e);t<=31||t>=127&&t<=159||(t>=768&&t<=879||(t>65535&&e++,D+=R(t)?2:1));}return D};var $=L,x=L;$.default=x;var U=/[|\\{}()[\]^$+*?.]/g,j=function(u){if("string"!=typeof u)throw new TypeError("Expected a string");return u.replace(U,"\\$&")};const{platform:P}=process,N={tick:"✔",cross:"✖",star:"★",square:"▇",squareSmall:"◻",squareSmallFilled:"◼",play:"▶",circle:"◯",circleFilled:"◉",circleDotted:"◌",circleDouble:"◎",circleCircle:"ⓞ",circleCross:"ⓧ",circlePipe:"Ⓘ",circleQuestionMark:"?⃝",bullet:"●",dot:"․",line:"─",ellipsis:"…",pointer:"❯",pointerSmall:"›",info:"ℹ",warning:"⚠",hamburger:"☰",smiley:"㋡",mustache:"෴",heart:"♥",nodejs:"⬢",arrowUp:"↑",arrowDown:"↓",arrowLeft:"←",arrowRight:"→",radioOn:"◉",radioOff:"◯",checkboxOn:"☒",checkboxOff:"☐",checkboxCircleOn:"ⓧ",checkboxCircleOff:"Ⓘ",questionMarkPrefix:"?⃝",oneHalf:"½",oneThird:"⅓",oneQuarter:"¼",oneFifth:"⅕",oneSixth:"⅙",oneSeventh:"⅐",oneEighth:"⅛",oneNinth:"⅑",oneTenth:"⅒",twoThirds:"⅔",twoFifths:"⅖",threeQuarters:"¾",threeFifths:"⅗",threeEighths:"⅜",fourFifths:"⅘",fiveSixths:"⅚",fiveEighths:"⅝",sevenEighths:"⅞"},q={tick:"√",cross:"×",star:"*",square:"█",squareSmall:"[ ]",squareSmallFilled:"[█]",play:"►",circle:"( )",circleFilled:"(*)",circleDotted:"( )",circleDouble:"( )",circleCircle:"(○)",circleCross:"(×)",circlePipe:"(│)",circleQuestionMark:"(?)",bullet:"*",dot:".",line:"─",ellipsis:"...",pointer:">",pointerSmall:"»",info:"i",warning:"‼",hamburger:"≡",smiley:"☺",mustache:"┌─┐",heart:N.heart,nodejs:"♦",arrowUp:N.arrowUp,arrowDown:N.arrowDown,arrowLeft:N.arrowLeft,arrowRight:N.arrowRight,radioOn:"(*)",radioOff:"( )",checkboxOn:"[×]",checkboxOff:"[ ]",checkboxCircleOn:"(×)",checkboxCircleOff:"( )",questionMarkPrefix:"？",oneHalf:"1/2",oneThird:"1/3",oneQuarter:"1/4",oneFifth:"1/5",oneSixth:"1/6",oneSeventh:"1/7",oneEighth:"1/8",oneNinth:"1/9",oneTenth:"1/10",twoThirds:"2/3",twoFifths:"2/5",threeQuarters:"3/4",threeFifths:"3/5",threeEighths:"3/8",fourFifths:"4/5",fiveSixths:"5/6",fiveEighths:"5/8",sevenEighths:"7/8"};"linux"===P&&(N.questionMarkPrefix="?");const Y="win32"===P?q:N;var H=Object.assign(u=>{if(Y===N)return u;for(const[D,e]of Object.entries(N))e!==Y[D]&&(u=u.replace(new RegExp(j(e),"g"),Y[D]));return u},Y),V=N,W=q;H.main=V,H.windows=W;var G={aliceblue:[240,248,255],antiquewhite:[250,235,215],aqua:[0,255,255],aquamarine:[127,255,212],azure:[240,255,255],beige:[245,245,220],bisque:[255,228,196],black:[0,0,0],blanchedalmond:[255,235,205],blue:[0,0,255],blueviolet:[138,43,226],brown:[165,42,42],burlywood:[222,184,135],cadetblue:[95,158,160],chartreuse:[127,255,0],chocolate:[210,105,30],coral:[255,127,80],cornflowerblue:[100,149,237],cornsilk:[255,248,220],crimson:[220,20,60],cyan:[0,255,255],darkblue:[0,0,139],darkcyan:[0,139,139],darkgoldenrod:[184,134,11],darkgray:[169,169,169],darkgreen:[0,100,0],darkgrey:[169,169,169],darkkhaki:[189,183,107],darkmagenta:[139,0,139],darkolivegreen:[85,107,47],darkorange:[255,140,0],darkorchid:[153,50,204],darkred:[139,0,0],darksalmon:[233,150,122],darkseagreen:[143,188,143],darkslateblue:[72,61,139],darkslategray:[47,79,79],darkslategrey:[47,79,79],darkturquoise:[0,206,209],darkviolet:[148,0,211],deeppink:[255,20,147],deepskyblue:[0,191,255],dimgray:[105,105,105],dimgrey:[105,105,105],dodgerblue:[30,144,255],firebrick:[178,34,34],floralwhite:[255,250,240],forestgreen:[34,139,34],fuchsia:[255,0,255],gainsboro:[220,220,220],ghostwhite:[248,248,255],gold:[255,215,0],goldenrod:[218,165,32],gray:[128,128,128],green:[0,128,0],greenyellow:[173,255,47],grey:[128,128,128],honeydew:[240,255,240],hotpink:[255,105,180],indianred:[205,92,92],indigo:[75,0,130],ivory:[255,255,240],khaki:[240,230,140],lavender:[230,230,250],lavenderblush:[255,240,245],lawngreen:[124,252,0],lemonchiffon:[255,250,205],lightblue:[173,216,230],lightcoral:[240,128,128],lightcyan:[224,255,255],lightgoldenrodyellow:[250,250,210],lightgray:[211,211,211],lightgreen:[144,238,144],lightgrey:[211,211,211],lightpink:[255,182,193],lightsalmon:[255,160,122],lightseagreen:[32,178,170],lightskyblue:[135,206,250],lightslategray:[119,136,153],lightslategrey:[119,136,153],lightsteelblue:[176,196,222],lightyellow:[255,255,224],lime:[0,255,0],limegreen:[50,205,50],linen:[250,240,230],magenta:[255,0,255],maroon:[128,0,0],mediumaquamarine:[102,205,170],mediumblue:[0,0,205],mediumorchid:[186,85,211],mediumpurple:[147,112,219],mediumseagreen:[60,179,113],mediumslateblue:[123,104,238],mediumspringgreen:[0,250,154],mediumturquoise:[72,209,204],mediumvioletred:[199,21,133],midnightblue:[25,25,112],mintcream:[245,255,250],mistyrose:[255,228,225],moccasin:[255,228,181],navajowhite:[255,222,173],navy:[0,0,128],oldlace:[253,245,230],olive:[128,128,0],olivedrab:[107,142,35],orange:[255,165,0],orangered:[255,69,0],orchid:[218,112,214],palegoldenrod:[238,232,170],palegreen:[152,251,152],paleturquoise:[175,238,238],palevioletred:[219,112,147],papayawhip:[255,239,213],peachpuff:[255,218,185],peru:[205,133,63],pink:[255,192,203],plum:[221,160,221],powderblue:[176,224,230],purple:[128,0,128],rebeccapurple:[102,51,153],red:[255,0,0],rosybrown:[188,143,143],royalblue:[65,105,225],saddlebrown:[139,69,19],salmon:[250,128,114],sandybrown:[244,164,96],seagreen:[46,139,87],seashell:[255,245,238],sienna:[160,82,45],silver:[192,192,192],skyblue:[135,206,235],slateblue:[106,90,205],slategray:[112,128,144],slategrey:[112,128,144],snow:[255,250,250],springgreen:[0,255,127],steelblue:[70,130,180],tan:[210,180,140],teal:[0,128,128],thistle:[216,191,216],tomato:[255,99,71],turquoise:[64,224,208],violet:[238,130,238],wheat:[245,222,179],white:[255,255,255],whitesmoke:[245,245,245],yellow:[255,255,0],yellowgreen:[154,205,50]};const z={};for(const u of Object.keys(G))z[G[u]]=u;const Q={rgb:{channels:3,labels:"rgb"},hsl:{channels:3,labels:"hsl"},hsv:{channels:3,labels:"hsv"},hwb:{channels:3,labels:"hwb"},cmyk:{channels:4,labels:"cmyk"},xyz:{channels:3,labels:"xyz"},lab:{channels:3,labels:"lab"},lch:{channels:3,labels:"lch"},hex:{channels:1,labels:["hex"]},keyword:{channels:1,labels:["keyword"]},ansi16:{channels:1,labels:["ansi16"]},ansi256:{channels:1,labels:["ansi256"]},hcg:{channels:3,labels:["h","c","g"]},apple:{channels:3,labels:["r16","g16","b16"]},gray:{channels:1,labels:["gray"]}};var J=Q;for(const u of Object.keys(Q)){if(!("channels"in Q[u]))throw new Error("missing channels property: "+u);if(!("labels"in Q[u]))throw new Error("missing channel labels property: "+u);if(Q[u].labels.length!==Q[u].channels)throw new Error("channel and label counts mismatch: "+u);const{channels:D,labels:e}=Q[u];delete Q[u].channels,delete Q[u].labels,Object.defineProperty(Q[u],"channels",{value:D}),Object.defineProperty(Q[u],"labels",{value:e});}function K(u){const D=function(){const u={},D=Object.keys(J);for(let e=D.length,t=0;t<e;t++)u[D[t]]={distance:-1,parent:null};return u}(),e=[u];for(D[u].distance=0;e.length;){const u=e.pop(),t=Object.keys(J[u]);for(let r=t.length,n=0;n<r;n++){const r=t[n],s=D[r];-1===s.distance&&(s.distance=D[u].distance+1,s.parent=u,e.unshift(r));}}return D}function Z(u,D){return function(e){return D(u(e))}}function X(u,D){const e=[D[u].parent,u];let t=J[D[u].parent][u],r=D[u].parent;for(;D[r].parent;)e.unshift(D[r].parent),t=Z(J[D[r].parent][r],t),r=D[r].parent;return t.conversion=e,t}Q.rgb.hsl=function(u){const D=u[0]/255,e=u[1]/255,t=u[2]/255,r=Math.min(D,e,t),n=Math.max(D,e,t),s=n-r;let o,i;n===r?o=0:D===n?o=(e-t)/s:e===n?o=2+(t-D)/s:t===n&&(o=4+(D-e)/s),o=Math.min(60*o,360),o<0&&(o+=360);const a=(r+n)/2;return i=n===r?0:a<=.5?s/(n+r):s/(2-n-r),[o,100*i,100*a]},Q.rgb.hsv=function(u){let D,e,t,r,n;const s=u[0]/255,o=u[1]/255,i=u[2]/255,a=Math.max(s,o,i),l=a-Math.min(s,o,i),c=function(u){return (a-u)/6/l+.5};return 0===l?(r=0,n=0):(n=l/a,D=c(s),e=c(o),t=c(i),s===a?r=t-e:o===a?r=1/3+D-t:i===a&&(r=2/3+e-D),r<0?r+=1:r>1&&(r-=1)),[360*r,100*n,100*a]},Q.rgb.hwb=function(u){const D=u[0],e=u[1];let t=u[2];const r=Q.rgb.hsl(u)[0],n=1/255*Math.min(D,Math.min(e,t));return t=1-1/255*Math.max(D,Math.max(e,t)),[r,100*n,100*t]},Q.rgb.cmyk=function(u){const D=u[0]/255,e=u[1]/255,t=u[2]/255,r=Math.min(1-D,1-e,1-t);return [100*((1-D-r)/(1-r)||0),100*((1-e-r)/(1-r)||0),100*((1-t-r)/(1-r)||0),100*r]},Q.rgb.keyword=function(u){const D=z[u];if(D)return D;let e,t=1/0;for(const D of Object.keys(G)){const s=(n=G[D],((r=u)[0]-n[0])**2+(r[1]-n[1])**2+(r[2]-n[2])**2);s<t&&(t=s,e=D);}var r,n;return e},Q.keyword.rgb=function(u){return G[u]},Q.rgb.xyz=function(u){let D=u[0]/255,e=u[1]/255,t=u[2]/255;D=D>.04045?((D+.055)/1.055)**2.4:D/12.92,e=e>.04045?((e+.055)/1.055)**2.4:e/12.92,t=t>.04045?((t+.055)/1.055)**2.4:t/12.92;return [100*(.4124*D+.3576*e+.1805*t),100*(.2126*D+.7152*e+.0722*t),100*(.0193*D+.1192*e+.9505*t)]},Q.rgb.lab=function(u){const D=Q.rgb.xyz(u);let e=D[0],t=D[1],r=D[2];e/=95.047,t/=100,r/=108.883,e=e>.008856?e**(1/3):7.787*e+16/116,t=t>.008856?t**(1/3):7.787*t+16/116,r=r>.008856?r**(1/3):7.787*r+16/116;return [116*t-16,500*(e-t),200*(t-r)]},Q.hsl.rgb=function(u){const D=u[0]/360,e=u[1]/100,t=u[2]/100;let r,n,s;if(0===e)return s=255*t,[s,s,s];r=t<.5?t*(1+e):t+e-t*e;const o=2*t-r,i=[0,0,0];for(let u=0;u<3;u++)n=D+1/3*-(u-1),n<0&&n++,n>1&&n--,s=6*n<1?o+6*(r-o)*n:2*n<1?r:3*n<2?o+(r-o)*(2/3-n)*6:o,i[u]=255*s;return i},Q.hsl.hsv=function(u){const D=u[0];let e=u[1]/100,t=u[2]/100,r=e;const n=Math.max(t,.01);t*=2,e*=t<=1?t:2-t,r*=n<=1?n:2-n;return [D,100*(0===t?2*r/(n+r):2*e/(t+e)),100*((t+e)/2)]},Q.hsv.rgb=function(u){const D=u[0]/60,e=u[1]/100;let t=u[2]/100;const r=Math.floor(D)%6,n=D-Math.floor(D),s=255*t*(1-e),o=255*t*(1-e*n),i=255*t*(1-e*(1-n));switch(t*=255,r){case 0:return [t,i,s];case 1:return [o,t,s];case 2:return [s,t,i];case 3:return [s,o,t];case 4:return [i,s,t];case 5:return [t,s,o]}},Q.hsv.hsl=function(u){const D=u[0],e=u[1]/100,t=u[2]/100,r=Math.max(t,.01);let n,s;s=(2-e)*t;const o=(2-e)*r;return n=e*r,n/=o<=1?o:2-o,n=n||0,s/=2,[D,100*n,100*s]},Q.hwb.rgb=function(u){const D=u[0]/360;let e=u[1]/100,t=u[2]/100;const r=e+t;let n;r>1&&(e/=r,t/=r);const s=Math.floor(6*D),o=1-t;n=6*D-s,0!=(1&s)&&(n=1-n);const i=e+n*(o-e);let a,l,c;switch(s){default:case 6:case 0:a=o,l=i,c=e;break;case 1:a=i,l=o,c=e;break;case 2:a=e,l=o,c=i;break;case 3:a=e,l=i,c=o;break;case 4:a=i,l=e,c=o;break;case 5:a=o,l=e,c=i;}return [255*a,255*l,255*c]},Q.cmyk.rgb=function(u){const D=u[0]/100,e=u[1]/100,t=u[2]/100,r=u[3]/100;return [255*(1-Math.min(1,D*(1-r)+r)),255*(1-Math.min(1,e*(1-r)+r)),255*(1-Math.min(1,t*(1-r)+r))]},Q.xyz.rgb=function(u){const D=u[0]/100,e=u[1]/100,t=u[2]/100;let r,n,s;return r=3.2406*D+-1.5372*e+-.4986*t,n=-.9689*D+1.8758*e+.0415*t,s=.0557*D+-.204*e+1.057*t,r=r>.0031308?1.055*r**(1/2.4)-.055:12.92*r,n=n>.0031308?1.055*n**(1/2.4)-.055:12.92*n,s=s>.0031308?1.055*s**(1/2.4)-.055:12.92*s,r=Math.min(Math.max(0,r),1),n=Math.min(Math.max(0,n),1),s=Math.min(Math.max(0,s),1),[255*r,255*n,255*s]},Q.xyz.lab=function(u){let D=u[0],e=u[1],t=u[2];D/=95.047,e/=100,t/=108.883,D=D>.008856?D**(1/3):7.787*D+16/116,e=e>.008856?e**(1/3):7.787*e+16/116,t=t>.008856?t**(1/3):7.787*t+16/116;return [116*e-16,500*(D-e),200*(e-t)]},Q.lab.xyz=function(u){let D,e,t;e=(u[0]+16)/116,D=u[1]/500+e,t=e-u[2]/200;const r=e**3,n=D**3,s=t**3;return e=r>.008856?r:(e-16/116)/7.787,D=n>.008856?n:(D-16/116)/7.787,t=s>.008856?s:(t-16/116)/7.787,D*=95.047,e*=100,t*=108.883,[D,e,t]},Q.lab.lch=function(u){const D=u[0],e=u[1],t=u[2];let r;r=360*Math.atan2(t,e)/2/Math.PI,r<0&&(r+=360);return [D,Math.sqrt(e*e+t*t),r]},Q.lch.lab=function(u){const D=u[0],e=u[1],t=u[2]/360*2*Math.PI;return [D,e*Math.cos(t),e*Math.sin(t)]},Q.rgb.ansi16=function(u,D=null){const[e,t,r]=u;let n=null===D?Q.rgb.hsv(u)[2]:D;if(n=Math.round(n/50),0===n)return 30;let s=30+(Math.round(r/255)<<2|Math.round(t/255)<<1|Math.round(e/255));return 2===n&&(s+=60),s},Q.hsv.ansi16=function(u){return Q.rgb.ansi16(Q.hsv.rgb(u),u[2])},Q.rgb.ansi256=function(u){const D=u[0],e=u[1],t=u[2];if(D===e&&e===t)return D<8?16:D>248?231:Math.round((D-8)/247*24)+232;return 16+36*Math.round(D/255*5)+6*Math.round(e/255*5)+Math.round(t/255*5)},Q.ansi16.rgb=function(u){let D=u%10;if(0===D||7===D)return u>50&&(D+=3.5),D=D/10.5*255,[D,D,D];const e=.5*(1+~~(u>50));return [(1&D)*e*255,(D>>1&1)*e*255,(D>>2&1)*e*255]},Q.ansi256.rgb=function(u){if(u>=232){const D=10*(u-232)+8;return [D,D,D]}let D;u-=16;return [Math.floor(u/36)/5*255,Math.floor((D=u%36)/6)/5*255,D%6/5*255]},Q.rgb.hex=function(u){const D=(((255&Math.round(u[0]))<<16)+((255&Math.round(u[1]))<<8)+(255&Math.round(u[2]))).toString(16).toUpperCase();return "000000".substring(D.length)+D},Q.hex.rgb=function(u){const D=u.toString(16).match(/[a-f0-9]{6}|[a-f0-9]{3}/i);if(!D)return [0,0,0];let e=D[0];3===D[0].length&&(e=e.split("").map(u=>u+u).join(""));const t=parseInt(e,16);return [t>>16&255,t>>8&255,255&t]},Q.rgb.hcg=function(u){const D=u[0]/255,e=u[1]/255,t=u[2]/255,r=Math.max(Math.max(D,e),t),n=Math.min(Math.min(D,e),t),s=r-n;let o,i;return o=s<1?n/(1-s):0,i=s<=0?0:r===D?(e-t)/s%6:r===e?2+(t-D)/s:4+(D-e)/s,i/=6,i%=1,[360*i,100*s,100*o]},Q.hsl.hcg=function(u){const D=u[1]/100,e=u[2]/100,t=e<.5?2*D*e:2*D*(1-e);let r=0;return t<1&&(r=(e-.5*t)/(1-t)),[u[0],100*t,100*r]},Q.hsv.hcg=function(u){const D=u[1]/100,e=u[2]/100,t=D*e;let r=0;return t<1&&(r=(e-t)/(1-t)),[u[0],100*t,100*r]},Q.hcg.rgb=function(u){const D=u[0]/360,e=u[1]/100,t=u[2]/100;if(0===e)return [255*t,255*t,255*t];const r=[0,0,0],n=D%1*6,s=n%1,o=1-s;let i=0;switch(Math.floor(n)){case 0:r[0]=1,r[1]=s,r[2]=0;break;case 1:r[0]=o,r[1]=1,r[2]=0;break;case 2:r[0]=0,r[1]=1,r[2]=s;break;case 3:r[0]=0,r[1]=o,r[2]=1;break;case 4:r[0]=s,r[1]=0,r[2]=1;break;default:r[0]=1,r[1]=0,r[2]=o;}return i=(1-e)*t,[255*(e*r[0]+i),255*(e*r[1]+i),255*(e*r[2]+i)]},Q.hcg.hsv=function(u){const D=u[1]/100,e=D+u[2]/100*(1-D);let t=0;return e>0&&(t=D/e),[u[0],100*t,100*e]},Q.hcg.hsl=function(u){const D=u[1]/100,e=u[2]/100*(1-D)+.5*D;let t=0;return e>0&&e<.5?t=D/(2*e):e>=.5&&e<1&&(t=D/(2*(1-e))),[u[0],100*t,100*e]},Q.hcg.hwb=function(u){const D=u[1]/100,e=D+u[2]/100*(1-D);return [u[0],100*(e-D),100*(1-e)]},Q.hwb.hcg=function(u){const D=u[1]/100,e=1-u[2]/100,t=e-D;let r=0;return t<1&&(r=(e-t)/(1-t)),[u[0],100*t,100*r]},Q.apple.rgb=function(u){return [u[0]/65535*255,u[1]/65535*255,u[2]/65535*255]},Q.rgb.apple=function(u){return [u[0]/255*65535,u[1]/255*65535,u[2]/255*65535]},Q.gray.rgb=function(u){return [u[0]/100*255,u[0]/100*255,u[0]/100*255]},Q.gray.hsl=function(u){return [0,0,u[0]]},Q.gray.hsv=Q.gray.hsl,Q.gray.hwb=function(u){return [0,100,u[0]]},Q.gray.cmyk=function(u){return [0,0,0,u[0]]},Q.gray.lab=function(u){return [u[0],0,0]},Q.gray.hex=function(u){const D=255&Math.round(u[0]/100*255),e=((D<<16)+(D<<8)+D).toString(16).toUpperCase();return "000000".substring(e.length)+e},Q.rgb.gray=function(u){return [(u[0]+u[1]+u[2])/3/255*100]};const uu={};Object.keys(J).forEach(u=>{uu[u]={},Object.defineProperty(uu[u],"channels",{value:J[u].channels}),Object.defineProperty(uu[u],"labels",{value:J[u].labels});const D=function(u){const D=K(u),e={},t=Object.keys(D);for(let u=t.length,r=0;r<u;r++){const u=t[r];null!==D[u].parent&&(e[u]=X(u,D));}return e}(u);Object.keys(D).forEach(e=>{const t=D[e];uu[u][e]=function(u){const D=function(...D){const e=D[0];if(null==e)return e;e.length>1&&(D=e);const t=u(D);if("object"==typeof t)for(let u=t.length,D=0;D<u;D++)t[D]=Math.round(t[D]);return t};return "conversion"in u&&(D.conversion=u.conversion),D}(t),uu[u][e].raw=function(u){const D=function(...D){const e=D[0];return null==e?e:(e.length>1&&(D=e),u(D))};return "conversion"in u&&(D.conversion=u.conversion),D}(t);});});var Du=uu,eu=s((function(u){const D=(u,D)=>(...e)=>`[${u(...e)+D}m`,e=(u,D)=>(...e)=>{const t=u(...e);return `[${38+D};5;${t}m`},t=(u,D)=>(...e)=>{const t=u(...e);return `[${38+D};2;${t[0]};${t[1]};${t[2]}m`},r=u=>u,n=(u,D,e)=>[u,D,e],s=(u,D,e)=>{Object.defineProperty(u,D,{get:()=>{const t=e();return Object.defineProperty(u,D,{value:t,enumerable:!0,configurable:!0}),t},enumerable:!0,configurable:!0});};let o;const i=(u,D,e,t)=>{void 0===o&&(o=Du);const r=t?10:0,n={};for(const[t,s]of Object.entries(o)){const o="ansi16"===t?"ansi":t;t===D?n[o]=u(e,r):"object"==typeof s&&(n[o]=u(s[D],r));}return n};Object.defineProperty(u,"exports",{enumerable:!0,get:function(){const u=new Map,o={modifier:{reset:[0,0],bold:[1,22],dim:[2,22],italic:[3,23],underline:[4,24],inverse:[7,27],hidden:[8,28],strikethrough:[9,29]},color:{black:[30,39],red:[31,39],green:[32,39],yellow:[33,39],blue:[34,39],magenta:[35,39],cyan:[36,39],white:[37,39],blackBright:[90,39],redBright:[91,39],greenBright:[92,39],yellowBright:[93,39],blueBright:[94,39],magentaBright:[95,39],cyanBright:[96,39],whiteBright:[97,39]},bgColor:{bgBlack:[40,49],bgRed:[41,49],bgGreen:[42,49],bgYellow:[43,49],bgBlue:[44,49],bgMagenta:[45,49],bgCyan:[46,49],bgWhite:[47,49],bgBlackBright:[100,49],bgRedBright:[101,49],bgGreenBright:[102,49],bgYellowBright:[103,49],bgBlueBright:[104,49],bgMagentaBright:[105,49],bgCyanBright:[106,49],bgWhiteBright:[107,49]}};o.color.gray=o.color.blackBright,o.bgColor.bgGray=o.bgColor.bgBlackBright,o.color.grey=o.color.blackBright,o.bgColor.bgGrey=o.bgColor.bgBlackBright;for(const[D,e]of Object.entries(o)){for(const[D,t]of Object.entries(e))o[D]={open:`[${t[0]}m`,close:`[${t[1]}m`},e[D]=o[D],u.set(t[0],t[1]);Object.defineProperty(o,D,{value:e,enumerable:!1});}return Object.defineProperty(o,"codes",{value:u,enumerable:!1}),o.color.close="[39m",o.bgColor.close="[49m",s(o.color,"ansi",()=>i(D,"ansi16",r,!1)),s(o.color,"ansi256",()=>i(e,"ansi256",r,!1)),s(o.color,"ansi16m",()=>i(t,"rgb",n,!1)),s(o.bgColor,"ansi",()=>i(D,"ansi16",r,!0)),s(o.bgColor,"ansi256",()=>i(e,"ansi256",r,!0)),s(o.bgColor,"ansi16m",()=>i(t,"rgb",n,!0)),o}});})),tu=(u,D=process.argv)=>{const e=u.startsWith("-")?"":1===u.length?"-":"--",t=D.indexOf(e+u),r=D.indexOf("--");return -1!==t&&(-1===r||t<r)};const{env:ru}=process;let nu;function su(u){return 0!==u&&{level:u,hasBasic:!0,has256:u>=2,has16m:u>=3}}function ou(u,D){if(0===nu)return 0;if(tu("color=16m")||tu("color=full")||tu("color=truecolor"))return 3;if(tu("color=256"))return 2;if(u&&!D&&void 0===nu)return 0;const e=nu||0;if("dumb"===ru.TERM)return e;if("win32"===process.platform){const u=r.release().split(".");return Number(u[0])>=10&&Number(u[2])>=10586?Number(u[2])>=14931?3:2:1}if("CI"in ru)return ["TRAVIS","CIRCLECI","APPVEYOR","GITLAB_CI"].some(u=>u in ru)||"codeship"===ru.CI_NAME?1:e;if("TEAMCITY_VERSION"in ru)return /^(9\.(0*[1-9]\d*)\.|\d{2,}\.)/.test(ru.TEAMCITY_VERSION)?1:0;if("GITHUB_ACTIONS"in ru)return 1;if("truecolor"===ru.COLORTERM)return 3;if("TERM_PROGRAM"in ru){const u=parseInt((ru.TERM_PROGRAM_VERSION||"").split(".")[0],10);switch(ru.TERM_PROGRAM){case"iTerm.app":return u>=3?3:2;case"Apple_Terminal":return 2}}return /-256(color)?$/i.test(ru.TERM)?2:/^screen|^xterm|^vt100|^vt220|^rxvt|color|ansi|cygwin|linux/i.test(ru.TERM)||"COLORTERM"in ru?1:e}tu("no-color")||tu("no-colors")||tu("color=false")||tu("color=never")?nu=0:(tu("color")||tu("colors")||tu("color=true")||tu("color=always"))&&(nu=1),"FORCE_COLOR"in ru&&(nu="true"===ru.FORCE_COLOR?1:"false"===ru.FORCE_COLOR?0:0===ru.FORCE_COLOR.length?1:Math.min(parseInt(ru.FORCE_COLOR,10),3));var iu={supportsColor:function(u){return su(ou(u,u&&u.isTTY))},stdout:su(ou(!0,n$1.isatty(1))),stderr:su(ou(!0,n$1.isatty(2)))};var au={stringReplaceAll:(u,D,e)=>{let t=u.indexOf(D);if(-1===t)return u;const r=D.length;let n=0,s="";do{s+=u.substr(n,t-n)+D+e,n=t+r,t=u.indexOf(D,n);}while(-1!==t);return s+=u.substr(n),s},stringEncaseCRLFWithFirstIndex:(u,D,e,t)=>{let r=0,n="";do{const s="\r"===u[t-1];n+=u.substr(r,(s?t-1:t)-r)+D+(s?"\r\n":"\n")+e,r=t+1,t=u.indexOf("\n",r);}while(-1!==t);return n+=u.substr(r),n}};const lu=/(?:\\(u(?:[a-f\d]{4}|\{[a-f\d]{1,6}\})|x[a-f\d]{2}|.))|(?:\{(~)?(\w+(?:\([^)]*\))?(?:\.\w+(?:\([^)]*\))?)*)(?:[ \t]|(?=\r?\n)))|(\})|((?:.|[\r\n\f])+?)/gi,cu=/(?:^|\.)(\w+)(?:\(([^)]*)\))?/g,hu=/^(['"])((?:\\.|(?!\1)[^\\])*)\1$/,Fu=/\\(u(?:[a-f\d]{4}|{[a-f\d]{1,6}})|x[a-f\d]{2}|.)|([^\\])/gi,Cu=new Map([["n","\n"],["r","\r"],["t","\t"],["b","\b"],["f","\f"],["v","\v"],["0","\0"],["\\","\\"],["e",""],["a",""]]);function fu(u){const D="u"===u[0],e="{"===u[1];return D&&!e&&5===u.length||"x"===u[0]&&3===u.length?String.fromCharCode(parseInt(u.slice(1),16)):D&&e?String.fromCodePoint(parseInt(u.slice(2,-1),16)):Cu.get(u)||u}function Eu(u,D){const e=[],t=D.trim().split(/\s*,\s*/g);let r;for(const D of t){const t=Number(D);if(Number.isNaN(t)){if(!(r=D.match(hu)))throw new Error(`Invalid Chalk template style argument: ${D} (in style '${u}')`);e.push(r[2].replace(Fu,(u,D,e)=>D?fu(D):e));}else e.push(t);}return e}function gu(u){cu.lastIndex=0;const D=[];let e;for(;null!==(e=cu.exec(u));){const u=e[1];if(e[2]){const t=Eu(u,e[2]);D.push([u].concat(t));}else D.push([u]);}return D}function du(u,D){const e={};for(const u of D)for(const D of u.styles)e[D[0]]=u.inverse?null:D.slice(1);let t=u;for(const[u,D]of Object.entries(e))if(Array.isArray(D)){if(!(u in t))throw new Error("Unknown Chalk style: "+u);t=D.length>0?t[u](...D):t[u];}return t}var pu=(u,D)=>{const e=[],t=[];let r=[];if(D.replace(lu,(D,n,s,o,i,a)=>{if(n)r.push(fu(n));else if(o){const D=r.join("");r=[],t.push(0===e.length?D:du(u,e)(D)),e.push({inverse:s,styles:gu(o)});}else if(i){if(0===e.length)throw new Error("Found extraneous } in Chalk template literal");t.push(du(u,e)(r.join(""))),r=[],e.pop();}else r.push(a);}),t.push(r.join("")),e.length>0){const u=`Chalk template literal is missing ${e.length} closing bracket${1===e.length?"":"s"} (\`}\`)`;throw new Error(u)}return t.join("")};const{stdout:mu,stderr:bu}=iu,{stringReplaceAll:yu,stringEncaseCRLFWithFirstIndex:Bu}=au,vu=["ansi","ansi","ansi256","ansi16m"],_u=Object.create(null);class Au{constructor(u){return wu(u)}}const wu=u=>{const D={};return ((u,D={})=>{if(D.level&&!(Number.isInteger(D.level)&&D.level>=0&&D.level<=3))throw new Error("The `level` option should be an integer from 0 to 3");const e=mu?mu.level:0;u.level=void 0===D.level?e:D.level;})(D,u),D.template=(...u)=>Lu(D.template,...u),Object.setPrototypeOf(D,Ou.prototype),Object.setPrototypeOf(D.template,D),D.template.constructor=()=>{throw new Error("`chalk.constructor()` is deprecated. Use `new chalk.Instance()` instead.")},D.template.Instance=Au,D.template};function Ou(u){return wu(u)}for(const[u,D]of Object.entries(eu))_u[u]={get(){const e=ku(this,Iu(D.open,D.close,this._styler),this._isEmpty);return Object.defineProperty(this,u,{value:e}),e}};_u.visible={get(){const u=ku(this,this._styler,!0);return Object.defineProperty(this,"visible",{value:u}),u}};const Mu=["rgb","hex","keyword","hsl","hsv","hwb","ansi","ansi256"];for(const u of Mu)_u[u]={get(){const{level:D}=this;return function(...e){const t=Iu(eu.color[vu[D]][u](...e),eu.color.close,this._styler);return ku(this,t,this._isEmpty)}}};for(const u of Mu){_u["bg"+u[0].toUpperCase()+u.slice(1)]={get(){const{level:D}=this;return function(...e){const t=Iu(eu.bgColor[vu[D]][u](...e),eu.bgColor.close,this._styler);return ku(this,t,this._isEmpty)}}};}const Su=Object.defineProperties(()=>{},{..._u,level:{enumerable:!0,get(){return this._generator.level},set(u){this._generator.level=u;}}}),Iu=(u,D,e)=>{let t,r;return void 0===e?(t=u,r=D):(t=e.openAll+u,r=D+e.closeAll),{open:u,close:D,openAll:t,closeAll:r,parent:e}},ku=(u,D,e)=>{const t=(...u)=>Ru(t,1===u.length?""+u[0]:u.join(" "));return Object.setPrototypeOf(t,Su),t._generator=u,t._styler=D,t._isEmpty=e,t},Ru=(u,D)=>{if(u.level<=0||!D)return u._isEmpty?"":D;let e=u._styler;if(void 0===e)return D;const{openAll:t,closeAll:r}=e;if(-1!==D.indexOf(""))for(;void 0!==e;)D=yu(D,e.close,e.open),e=e.parent;const n=D.indexOf("\n");return -1!==n&&(D=Bu(D,r,t,n)),t+D+r};let Tu;const Lu=(u,...D)=>{const[e]=D;if(!Array.isArray(e))return D.join(" ");const t=D.slice(1),r=[e.raw[0]];for(let u=1;u<e.length;u++)r.push(String(t[u-1]).replace(/[{}\\]/g,"\\$&"),String(e.raw[u]));return void 0===Tu&&(Tu=pu),Tu(u,r.join(""))};Object.defineProperties(Ou.prototype,_u);const $u=Ou();$u.supportsColor=mu,$u.stderr=Ou({level:bu?bu.level:0}),$u.stderr.supportsColor=bu;var xu=$u;const Uu={};function ju(u){let D=Uu[u];return D||(D="#"===u[0]?xu.hex(u):xu[u]||xu.keyword(u),Uu[u]=D,D)}const Pu={};const Nu={info:"cyan"},qu={0:"red",1:"yellow",2:"white",3:"green"},Yu={secondaryColor:"grey",formatOptions:{date:!0,colors:!0,compact:!1}},Hu={info:H("ℹ"),success:H("✔"),debug:H("›"),trace:H("›"),log:""};class Vu extends S{constructor(u){super(Object.assign({},Yu,u));}formatStack(u){const D=ju("grey"),e=ju("cyan");return "\n"+A(u).map(u=>"  "+u.replace(/^at +/,u=>D(u)).replace(/\((.+)\)/,(u,D)=>`(${e(D)})`)).join("\n")}formatType(u,D){const e=Nu[u.type]||qu[u.level]||this.options.secondaryColor;if(D)return function(u){let D=Pu[u];return D||(D="#"===u[0]?xu.bgHex(u):xu["bg"+u[0].toUpperCase()+u.slice(1)]||xu.bgKeyword(u),Pu[u]=D,D)}(e).black(` ${u.type.toUpperCase()} `);const t="string"==typeof Hu[u.type]?Hu[u.type]:u.icon||u.type;return t?ju(e)(t):""}formatLogObj(u,{width:D}){const[e,...t]=this.formatArgs(u.args).split("\n"),r=void 0!==u.badge?Boolean(u.badge):u.level<2,n=ju(this.options.secondaryColor),s=this.formatDate(u.date),o=s&&n(s),i=this.formatType(u,r),a=u.tag?n(u.tag):"",l=e.replace(/`([^`]+)`/g,(u,D)=>xu.cyan(D));let c;const h=this.filterAndJoin([i,l]),F=this.filterAndJoin([a,o]),C=D-$(h)-$(F)-2;return c=C>0&&D>=80?h+" ".repeat(C)+F:h,c+=t.length?"\n"+t.join("\n"):"",r?"\n"+c+"\n":c}}class Wu{constructor({stream:u}={}){this.stream=u||process.stdout;}log(u){this.stream.write(JSON.stringify(u)+"\n");}}const Gu="undefined"!=typeof __non_webpack_require__?__non_webpack_require__:commonjsRequire;class zu{constructor(u){if(u&&u.log)this.logger=u;else {const D=Gu("winston");this.logger=D.createLogger(Object.assign({level:"info",format:D.format.simple(),transports:[new D.transports.Console]},u));}}log(u){const D=[].concat(u.args),e=D.shift();this.logger.log({level:Qu[u.level]||"info",label:u.tag,message:e,args:D,timestamp:u.date.getTime()/1e3});}}const Qu={0:"error",1:"warn",2:"info",3:"verbose",4:"debug",5:"silly"};commonjsGlobal.consola||(commonjsGlobal.consola=function(){let u=p.debug?4:3;process.env.CONSOLA_LEVEL&&(u=parseInt(process.env.CONSOLA_LEVEL)||u);const D=new _({level:u,reporters:[p.ci||p.test?new S:new Vu]});return D.Consola=_,D.BasicReporter=S,D.FancyReporter=Vu,D.JSONReporter=Wu,D.WinstonReporter=zu,D.LogLevel=m,D}());var Ju=commonjsGlobal.consola;var consola=Ju;

var consola$1 = /*@__PURE__*/getDefaultExportFromCjs(consola);

const {
  env = {},
  argv = [],
  platform = "",
} = typeof process === "undefined" ? {} : process;

const isDisabled = "NO_COLOR" in env || argv.includes("--no-color");
const isForced = "FORCE_COLOR" in env || argv.includes("--color");
const isWindows$2 = platform === "win32";
const isDumbTerminal = env.TERM === "dumb";

const isCompatibleTerminal =
  tty__namespace && tty__namespace.isatty && tty__namespace.isatty(1) && env.TERM && !isDumbTerminal;

const isCI =
  "CI" in env &&
  ("GITHUB_ACTIONS" in env || "GITLAB_CI" in env || "CIRCLECI" in env);

const isColorSupported =
  !isDisabled &&
  (isForced || (isWindows$2 && !isDumbTerminal) || isCompatibleTerminal || isCI);

const replaceClose = (
  index,
  string,
  close,
  replace,
  head = string.substring(0, index) + replace,
  tail = string.substring(index + close.length),
  next = tail.indexOf(close)
) => head + (next < 0 ? tail : replaceClose(next, tail, close, replace));

const clearBleed = (index, string, open, close, replace) =>
  index < 0
    ? open + string + close
    : open + replaceClose(index, string, close, replace) + close;

const filterEmpty =
  (open, close, replace = open, at = open.length + 1) =>
  (string) =>
    string || !(string === "" || string === undefined)
      ? clearBleed(
          ("" + string).indexOf(close, at),
          string,
          open,
          close,
          replace
        )
      : "";

const init = (open, close, replace) =>
  filterEmpty(`\x1b[${open}m`, `\x1b[${close}m`, replace);

const colors = {
  reset: init(0, 0),
  bold: init(1, 22, "\x1b[22m\x1b[1m"),
  dim: init(2, 22, "\x1b[22m\x1b[2m"),
  italic: init(3, 23),
  underline: init(4, 24),
  inverse: init(7, 27),
  hidden: init(8, 28),
  strikethrough: init(9, 29),
  black: init(30, 39),
  red: init(31, 39),
  green: init(32, 39),
  yellow: init(33, 39),
  blue: init(34, 39),
  magenta: init(35, 39),
  cyan: init(36, 39),
  white: init(37, 39),
  gray: init(90, 39),
  bgBlack: init(40, 49),
  bgRed: init(41, 49),
  bgGreen: init(42, 49),
  bgYellow: init(43, 49),
  bgBlue: init(44, 49),
  bgMagenta: init(45, 49),
  bgCyan: init(46, 49),
  bgWhite: init(47, 49),
  blackBright: init(90, 39),
  redBright: init(91, 39),
  greenBright: init(92, 39),
  yellowBright: init(93, 39),
  blueBright: init(94, 39),
  magentaBright: init(95, 39),
  cyanBright: init(96, 39),
  whiteBright: init(97, 39),
  bgBlackBright: init(100, 49),
  bgRedBright: init(101, 49),
  bgGreenBright: init(102, 49),
  bgYellowBright: init(103, 49),
  bgBlueBright: init(104, 49),
  bgMagentaBright: init(105, 49),
  bgCyanBright: init(106, 49),
  bgWhiteBright: init(107, 49),
};

const createColors = ({ useColor = isColorSupported } = {}) =>
  useColor
    ? colors
    : Object.keys(colors).reduce(
        (colors, key) => ({ ...colors, [key]: String }),
        {}
      );

const {
  reset,
  bold,
  dim,
  italic,
  underline,
  inverse,
  hidden,
  strikethrough,
  black,
  red,
  green,
  yellow,
  blue,
  magenta,
  cyan,
  white,
  gray,
  bgBlack,
  bgRed,
  bgGreen,
  bgYellow,
  bgBlue,
  bgMagenta,
  bgCyan,
  bgWhite,
  blackBright,
  redBright,
  greenBright,
  yellowBright,
  blueBright,
  magentaBright,
  cyanBright,
  whiteBright,
  bgBlackBright,
  bgRedBright,
  bgGreenBright,
  bgYellowBright,
  bgBlueBright,
  bgMagentaBright,
  bgCyanBright,
  bgWhiteBright,
} = createColors();

var lib$l = {exports: {}};

lib$l.exports;

(function (module, exports) {

	var url = require$$1__default["default"];

	module.exports = function historyApiFallback(options) {
	  options = options || {};
	  var logger = getLogger(options);

	  return function(req, res, next) {
	    var headers = req.headers;
	    if (req.method !== 'GET') {
	      logger(
	        'Not rewriting',
	        req.method,
	        req.url,
	        'because the method is not GET.'
	      );
	      return next();
	    } else if (!headers || typeof headers.accept !== 'string') {
	      logger(
	        'Not rewriting',
	        req.method,
	        req.url,
	        'because the client did not send an HTTP accept header.'
	      );
	      return next();
	    } else if (headers.accept.indexOf('application/json') === 0) {
	      logger(
	        'Not rewriting',
	        req.method,
	        req.url,
	        'because the client prefers JSON.'
	      );
	      return next();
	    } else if (!acceptsHtml(headers.accept, options)) {
	      logger(
	        'Not rewriting',
	        req.method,
	        req.url,
	        'because the client does not accept HTML.'
	      );
	      return next();
	    }

	    var parsedUrl = url.parse(req.url);
	    var rewriteTarget;
	    options.rewrites = options.rewrites || [];
	    for (var i = 0; i < options.rewrites.length; i++) {
	      var rewrite = options.rewrites[i];
	      var match = parsedUrl.pathname.match(rewrite.from);
	      if (match !== null) {
	        rewriteTarget = evaluateRewriteRule(parsedUrl, match, rewrite.to, req);

	        if(rewriteTarget.charAt(0) !== '/') {
	          logger(
	            'We recommend using an absolute path for the rewrite target.',
	            'Received a non-absolute rewrite target',
	            rewriteTarget,
	            'for URL',
	            req.url
	          );
	        }

	        logger('Rewriting', req.method, req.url, 'to', rewriteTarget);
	        req.url = rewriteTarget;
	        return next();
	      }
	    }

	    var pathname = parsedUrl.pathname;
	    if (pathname.lastIndexOf('.') > pathname.lastIndexOf('/') &&
	        options.disableDotRule !== true) {
	      logger(
	        'Not rewriting',
	        req.method,
	        req.url,
	        'because the path includes a dot (.) character.'
	      );
	      return next();
	    }

	    rewriteTarget = options.index || '/index.html';
	    logger('Rewriting', req.method, req.url, 'to', rewriteTarget);
	    req.url = rewriteTarget;
	    next();
	  };
	};

	function evaluateRewriteRule(parsedUrl, match, rule, req) {
	  if (typeof rule === 'string') {
	    return rule;
	  } else if (typeof rule !== 'function') {
	    throw new Error('Rewrite rule can only be of type string or function.');
	  }

	  return rule({
	    parsedUrl: parsedUrl,
	    match: match,
	    request: req
	  });
	}

	function acceptsHtml(header, options) {
	  options.htmlAcceptHeaders = options.htmlAcceptHeaders || ['text/html', '*/*'];
	  for (var i = 0; i < options.htmlAcceptHeaders.length; i++) {
	    if (header.indexOf(options.htmlAcceptHeaders[i]) !== -1) {
	      return true;
	    }
	  }
	  return false;
	}

	function getLogger(options) {
	  if (options && options.logger) {
	    return options.logger;
	  } else if (options && options.verbose) {
	    return console.log.bind(console);
	  }
	  return function(){};
	} 
} (lib$l, lib$l.exports));

var libExports = lib$l.exports;
var history = /*@__PURE__*/getDefaultExportFromCjs(libExports);

var clean$1 = {exports: {}};

function level0Optimize$1(tokens) {
  // noop as level 0 means no optimizations!
  return tokens;
}

var optimize$4 = level0Optimize$1;

// adapted from http://nedbatchelder.com/blog/200712.html#e20071211T054956

var NUMBER_PATTERN = /([0-9]+)/;

function naturalCompare$1(value1, value2) {
  var keys1 = ('' + value1).split(NUMBER_PATTERN).map(tryParseInt);
  var keys2 = ('' + value2).split(NUMBER_PATTERN).map(tryParseInt);
  var key1;
  var key2;
  var compareFirst = Math.min(keys1.length, keys2.length);
  var i, l;

  for (i = 0, l = compareFirst; i < l; i++) {
    key1 = keys1[i];
    key2 = keys2[i];

    if (key1 != key2) {
      return key1 > key2 ? 1 : -1;
    }
  }

  return keys1.length > keys2.length ? 1 : (keys1.length == keys2.length ? 0 : -1);
}

function tryParseInt(value) {
  return ('' + parseInt(value)) == value
    ? parseInt(value)
    : value;
}

var naturalCompare_1 = naturalCompare$1;

var naturalCompare = naturalCompare_1;

function naturalSorter$1(scope1, scope2) {
  return naturalCompare(scope1[1], scope2[1]);
}

function standardSorter(scope1, scope2) {
  return scope1[1] > scope2[1] ? 1 : -1;
}

function sortSelectors$3(selectors, method) {
  switch (method) {
  case 'natural':
    return selectors.sort(naturalSorter$1);
  case 'standard':
    return selectors.sort(standardSorter);
  case 'none':
  case false:
    return selectors;
  }
}

var sortSelectors_1 = sortSelectors$3;

function override$7(source1, source2) {
  var target = {};
  var key1;
  var key2;
  var item;

  for (key1 in source1) {
    item = source1[key1];

    if (Array.isArray(item)) {
      target[key1] = item.slice(0);
    } else if (typeof item == 'object' && item !== null) {
      target[key1] = override$7(item, {});
    } else {
      target[key1] = item;
    }
  }

  for (key2 in source2) {
    item = source2[key2];

    if (key2 in target && Array.isArray(item)) {
      target[key2] = item.slice(0);
    } else if (key2 in target && typeof item == 'object' && item !== null) {
      target[key2] = override$7(target[key2], item);
    } else {
      target[key2] = item;
    }
  }

  return target;
}

var override_1 = override$7;

var override$6 = override_1;

function getSystemLineBreak() {
  var systemLineBreak = '\n';
  try {
    var os = require('os');
    systemLineBreak = os.EOL;
  } catch (_) {
    // no op
  }
  return systemLineBreak;
}

var Breaks$1 = {
  AfterAtRule: 'afterAtRule',
  AfterBlockBegins: 'afterBlockBegins',
  AfterBlockEnds: 'afterBlockEnds',
  AfterComment: 'afterComment',
  AfterProperty: 'afterProperty',
  AfterRuleBegins: 'afterRuleBegins',
  AfterRuleEnds: 'afterRuleEnds',
  BeforeBlockEnds: 'beforeBlockEnds',
  BetweenSelectors: 'betweenSelectors'
};

var BreakWith = {
  CarriageReturnLineFeed: '\r\n',
  LineFeed: '\n',
  System: getSystemLineBreak()
};

var IndentWith = {
  Space: ' ',
  Tab: '\t'
};

var Spaces$2 = {
  AroundSelectorRelation: 'aroundSelectorRelation',
  BeforeBlockBegins: 'beforeBlockBegins',
  BeforeValue: 'beforeValue'
};

var DEFAULTS$2 = {
  breaks: breaks(false),
  breakWith: BreakWith.System,
  indentBy: 0,
  indentWith: IndentWith.Space,
  spaces: spaces(false),
  wrapAt: false,
  semicolonAfterLastProperty: false
};

var BEAUTIFY_ALIAS = 'beautify';
var KEEP_BREAKS_ALIAS = 'keep-breaks';

var OPTION_SEPARATOR$1 = ';';
var OPTION_NAME_VALUE_SEPARATOR = ':';
var HASH_VALUES_OPTION_SEPARATOR = ',';
var HASH_VALUES_NAME_VALUE_SEPARATOR = '=';

var FALSE_KEYWORD_1$1 = 'false';
var FALSE_KEYWORD_2$1 = 'off';
var TRUE_KEYWORD_1$1 = 'true';
var TRUE_KEYWORD_2$1 = 'on';

function breaks(value) {
  var breakOptions = {};

  breakOptions[Breaks$1.AfterAtRule] = value;
  breakOptions[Breaks$1.AfterBlockBegins] = value;
  breakOptions[Breaks$1.AfterBlockEnds] = value;
  breakOptions[Breaks$1.AfterComment] = value;
  breakOptions[Breaks$1.AfterProperty] = value;
  breakOptions[Breaks$1.AfterRuleBegins] = value;
  breakOptions[Breaks$1.AfterRuleEnds] = value;
  breakOptions[Breaks$1.BeforeBlockEnds] = value;
  breakOptions[Breaks$1.BetweenSelectors] = value;

  return breakOptions;
}

function spaces(value) {
  var spaceOptions = {};

  spaceOptions[Spaces$2.AroundSelectorRelation] = value;
  spaceOptions[Spaces$2.BeforeBlockBegins] = value;
  spaceOptions[Spaces$2.BeforeValue] = value;

  return spaceOptions;
}

function formatFrom$1(source) {
  if (source === undefined || source === false) {
    return false;
  }

  if (typeof source == 'object' && 'breakWith' in source) {
    source = override$6(source, { breakWith: mapBreakWith(source.breakWith) });
  }

  if (typeof source == 'object' && 'indentBy' in source) {
    source = override$6(source, { indentBy: parseInt(source.indentBy) });
  }

  if (typeof source == 'object' && 'indentWith' in source) {
    source = override$6(source, { indentWith: mapIndentWith(source.indentWith) });
  }

  if (typeof source == 'object') {
    return remapBreaks(override$6(DEFAULTS$2, source));
  }

  if (typeof source == 'string' && source == BEAUTIFY_ALIAS) {
    return remapBreaks(
      override$6(DEFAULTS$2, {
        breaks: breaks(true),
        indentBy: 2,
        spaces: spaces(true)
      })
    );
  }

  if (typeof source == 'string' && source == KEEP_BREAKS_ALIAS) {
    return remapBreaks(
      override$6(DEFAULTS$2, {
        breaks: {
          afterAtRule: true,
          afterBlockBegins: true,
          afterBlockEnds: true,
          afterComment: true,
          afterRuleEnds: true,
          beforeBlockEnds: true
        }
      })
    );
  }

  if (typeof source == 'string') {
    return remapBreaks(override$6(DEFAULTS$2, toHash(source)));
  }

  return DEFAULTS$2;
}

function toHash(string) {
  return string
    .split(OPTION_SEPARATOR$1)
    .reduce(function(accumulator, directive) {
      var parts = directive.split(OPTION_NAME_VALUE_SEPARATOR);
      var name = parts[0];
      var value = parts[1];

      if (name == 'breaks' || name == 'spaces') {
        accumulator[name] = hashValuesToHash(value);
      } else if (name == 'indentBy' || name == 'wrapAt') {
        accumulator[name] = parseInt(value);
      } else if (name == 'indentWith') {
        accumulator[name] = mapIndentWith(value);
      } else if (name == 'breakWith') {
        accumulator[name] = mapBreakWith(value);
      }

      return accumulator;
    }, {});
}

function hashValuesToHash(string) {
  return string
    .split(HASH_VALUES_OPTION_SEPARATOR)
    .reduce(function(accumulator, directive) {
      var parts = directive.split(HASH_VALUES_NAME_VALUE_SEPARATOR);
      var name = parts[0];
      var value = parts[1];

      accumulator[name] = normalizeValue$1(value);

      return accumulator;
    }, {});
}

function normalizeValue$1(value) {
  switch (value) {
  case FALSE_KEYWORD_1$1:
  case FALSE_KEYWORD_2$1:
    return false;
  case TRUE_KEYWORD_1$1:
  case TRUE_KEYWORD_2$1:
    return true;
  default:
    return value;
  }
}

function mapBreakWith(value) {
  switch (value) {
  case 'windows':
  case 'crlf':
  case BreakWith.CarriageReturnLineFeed:
    return BreakWith.CarriageReturnLineFeed;
  case 'unix':
  case 'lf':
  case BreakWith.LineFeed:
    return BreakWith.LineFeed;
  default:
    return BreakWith.System;
  }
}

function mapIndentWith(value) {
  switch (value) {
  case 'space':
    return IndentWith.Space;
  case 'tab':
    return IndentWith.Tab;
  default:
    return value;
  }
}

function remapBreaks(source) {
  for (var key in Breaks$1) {
    var breakName = Breaks$1[key];
    var breakValue = source.breaks[breakName];

    if (breakValue === true) {
      source.breaks[breakName] = source.breakWith;
    } else if (breakValue === false) {
      source.breaks[breakName] = '';
    } else {
      source.breaks[breakName] = source.breakWith.repeat(parseInt(breakValue));
    }
  }

  return source;
}

var format$1 = {
  Breaks: Breaks$1,
  Spaces: Spaces$2,
  formatFrom: formatFrom$1
};

var Marker$g = {
  ASTERISK: '*',
  AT: '@',
  BACK_SLASH: '\\',
  CARRIAGE_RETURN: '\r',
  CLOSE_CURLY_BRACKET: '}',
  CLOSE_ROUND_BRACKET: ')',
  CLOSE_SQUARE_BRACKET: ']',
  COLON: ':',
  COMMA: ',',
  DOUBLE_QUOTE: '"',
  EXCLAMATION: '!',
  FORWARD_SLASH: '/',
  INTERNAL: '-clean-css-',
  NEW_LINE_NIX: '\n',
  OPEN_CURLY_BRACKET: '{',
  OPEN_ROUND_BRACKET: '(',
  OPEN_SQUARE_BRACKET: '[',
  SEMICOLON: ';',
  SINGLE_QUOTE: '\'',
  SPACE: ' ',
  TAB: '\t',
  UNDERSCORE: '_'
};

var marker = Marker$g;

function formatPosition$4(metadata) {
  var line = metadata[0];
  var column = metadata[1];
  var source = metadata[2];

  return source
    ? source + ':' + line + ':' + column
    : line + ':' + column;
}

var formatPosition_1 = formatPosition$4;

var Spaces$1 = format$1.Spaces;
var Marker$f = marker;
var formatPosition$3 = formatPosition_1;

var CASE_ATTRIBUTE_PATTERN = /[\s"'][iI]\s*\]/;
var CASE_RESTORE_PATTERN = /([\d\w])([iI])\]/g;
var DOUBLE_QUOTE_CASE_PATTERN = /="([a-zA-Z][a-zA-Z\d\-_]+)"([iI])/g;
var DOUBLE_QUOTE_PATTERN = /="([a-zA-Z][a-zA-Z\d\-_]+)"(\s|\])/g;
var HTML_COMMENT_PATTERN = /^(?:(?:<!--|-->)\s*)+/;
var SINGLE_QUOTE_CASE_PATTERN = /='([a-zA-Z][a-zA-Z\d\-_]+)'([iI])/g;
var SINGLE_QUOTE_PATTERN = /='([a-zA-Z][a-zA-Z\d\-_]+)'(\s|\])/g;
var RELATION_PATTERN$1 = /[>+~]/;
var WHITESPACE_PATTERN$2 = /\s/;

var ASTERISK_PLUS_HTML_HACK = '*+html ';
var ASTERISK_FIRST_CHILD_PLUS_HTML_HACK = '*:first-child+html ';
var LESS_THAN = '<';

var PSEUDO_CLASSES_WITH_SELECTORS = [
  ':current',
  ':future',
  ':has',
  ':host',
  ':host-context',
  ':is',
  ':not',
  ':past',
  ':where'
];

function hasInvalidCharacters(value) {
  var isEscaped;
  var isInvalid = false;
  var character;
  var isQuote = false;
  var i, l;

  for (i = 0, l = value.length; i < l; i++) {
    character = value[i];

    if (isEscaped) ; else if (character == Marker$f.SINGLE_QUOTE || character == Marker$f.DOUBLE_QUOTE) {
      isQuote = !isQuote;
    } else if (!isQuote
      && (character == Marker$f.CLOSE_CURLY_BRACKET
        || character == Marker$f.EXCLAMATION
        || character == LESS_THAN
        || character == Marker$f.SEMICOLON)
    ) {
      isInvalid = true;
      break;
    } else if (!isQuote && i === 0 && RELATION_PATTERN$1.test(character)) {
      isInvalid = true;
      break;
    }

    isEscaped = character == Marker$f.BACK_SLASH;
  }

  return isInvalid;
}

function removeWhitespace(value, format) {
  var stripped = [];
  var character;
  var isNewLineNix;
  var isNewLineWin;
  var isEscaped;
  var wasEscaped;
  var isQuoted;
  var isSingleQuoted;
  var isDoubleQuoted;
  var isAttribute;
  var isRelation;
  var isWhitespace;
  var isSpaceAwarePseudoClass;
  var roundBracketLevel = 0;
  var wasComma = false;
  var wasRelation = false;
  var wasWhitespace = false;
  var withCaseAttribute = CASE_ATTRIBUTE_PATTERN.test(value);
  var spaceAroundRelation = format && format.spaces[Spaces$1.AroundSelectorRelation];
  var i, l;

  for (i = 0, l = value.length; i < l; i++) {
    character = value[i];

    isNewLineNix = character == Marker$f.NEW_LINE_NIX;
    isNewLineWin = character == Marker$f.NEW_LINE_NIX && value[i - 1] == Marker$f.CARRIAGE_RETURN;
    isQuoted = isSingleQuoted || isDoubleQuoted;
    isRelation = !isAttribute && !isEscaped && roundBracketLevel === 0 && RELATION_PATTERN$1.test(character);
    isWhitespace = WHITESPACE_PATTERN$2.test(character);
    isSpaceAwarePseudoClass = roundBracketLevel == 1 && character == Marker$f.CLOSE_ROUND_BRACKET
      ? false
      : isSpaceAwarePseudoClass
        || (roundBracketLevel === 0 && character == Marker$f.COLON && isPseudoClassWithSelectors(value, i));

    if (wasEscaped && isQuoted && isNewLineWin) {
      // swallow escaped new windows lines in comments
      stripped.pop();
      stripped.pop();
    } else if (isEscaped && isQuoted && isNewLineNix) {
      // swallow escaped new *nix lines in comments
      stripped.pop();
    } else if (isEscaped) {
      stripped.push(character);
    } else if (character == Marker$f.OPEN_SQUARE_BRACKET && !isQuoted) {
      stripped.push(character);
      isAttribute = true;
    } else if (character == Marker$f.CLOSE_SQUARE_BRACKET && !isQuoted) {
      stripped.push(character);
      isAttribute = false;
    } else if (character == Marker$f.OPEN_ROUND_BRACKET && !isQuoted) {
      stripped.push(character);
      roundBracketLevel++;
    } else if (character == Marker$f.CLOSE_ROUND_BRACKET && !isQuoted) {
      stripped.push(character);
      roundBracketLevel--;
    } else if (character == Marker$f.SINGLE_QUOTE && !isQuoted) {
      stripped.push(character);
      isSingleQuoted = true;
    } else if (character == Marker$f.DOUBLE_QUOTE && !isQuoted) {
      stripped.push(character);
      isDoubleQuoted = true;
    } else if (character == Marker$f.SINGLE_QUOTE && isQuoted) {
      stripped.push(character);
      isSingleQuoted = false;
    } else if (character == Marker$f.DOUBLE_QUOTE && isQuoted) {
      stripped.push(character);
      isDoubleQuoted = false;
    } else if (isWhitespace && wasRelation && !spaceAroundRelation) {
      continue;
    } else if (!isWhitespace && wasRelation && spaceAroundRelation) {
      stripped.push(Marker$f.SPACE);
      stripped.push(character);
    } else if (isWhitespace && !wasWhitespace && wasComma && roundBracketLevel > 0 && isSpaceAwarePseudoClass) ; else if (isWhitespace && !wasWhitespace && roundBracketLevel > 0 && isSpaceAwarePseudoClass) {
      stripped.push(character);
    } else if (isWhitespace && (isAttribute || roundBracketLevel > 0) && !isQuoted) ; else if (isWhitespace && wasWhitespace && !isQuoted) ; else if ((isNewLineWin || isNewLineNix) && (isAttribute || roundBracketLevel > 0) && isQuoted) ; else if (isRelation && wasWhitespace && !spaceAroundRelation) {
      stripped.pop();
      stripped.push(character);
    } else if (isRelation && !wasWhitespace && spaceAroundRelation) {
      stripped.push(Marker$f.SPACE);
      stripped.push(character);
    } else if (isWhitespace) {
      stripped.push(Marker$f.SPACE);
    } else {
      stripped.push(character);
    }

    wasEscaped = isEscaped;
    isEscaped = character == Marker$f.BACK_SLASH;
    wasRelation = isRelation;
    wasWhitespace = isWhitespace;
    wasComma = character == Marker$f.COMMA;
  }

  return withCaseAttribute
    ? stripped.join('').replace(CASE_RESTORE_PATTERN, '$1 $2]')
    : stripped.join('');
}

function isPseudoClassWithSelectors(value, colonPosition) {
  var pseudoClass = value.substring(colonPosition, value.indexOf(Marker$f.OPEN_ROUND_BRACKET, colonPosition));

  return PSEUDO_CLASSES_WITH_SELECTORS.indexOf(pseudoClass) > -1;
}

function removeQuotes(value) {
  if (value.indexOf('\'') == -1 && value.indexOf('"') == -1) {
    return value;
  }

  return value
    .replace(SINGLE_QUOTE_CASE_PATTERN, '=$1 $2')
    .replace(SINGLE_QUOTE_PATTERN, '=$1$2')
    .replace(DOUBLE_QUOTE_CASE_PATTERN, '=$1 $2')
    .replace(DOUBLE_QUOTE_PATTERN, '=$1$2');
}

function replacePseudoClasses(value) {
  return value
    .replace('nth-child(1)', 'first-child')
    .replace('nth-of-type(1)', 'first-of-type')
    .replace('nth-of-type(even)', 'nth-of-type(2n)')
    .replace('nth-child(even)', 'nth-child(2n)')
    .replace('nth-of-type(2n+1)', 'nth-of-type(odd)')
    .replace('nth-child(2n+1)', 'nth-child(odd)')
    .replace('nth-last-child(1)', 'last-child')
    .replace('nth-last-of-type(1)', 'last-of-type')
    .replace('nth-last-of-type(even)', 'nth-last-of-type(2n)')
    .replace('nth-last-child(even)', 'nth-last-child(2n)')
    .replace('nth-last-of-type(2n+1)', 'nth-last-of-type(odd)')
    .replace('nth-last-child(2n+1)', 'nth-last-child(odd)');
}

function tidyRules$3(rules, removeUnsupported, adjacentSpace, format, warnings) {
  var list = [];
  var repeated = [];

  function removeHTMLComment(rule, match) {
    warnings.push('HTML comment \'' + match + '\' at ' + formatPosition$3(rule[2][0]) + '. Removing.');
    return '';
  }

  for (var i = 0, l = rules.length; i < l; i++) {
    var rule = rules[i];
    var reduced = rule[1];

    reduced = reduced.replace(HTML_COMMENT_PATTERN, removeHTMLComment.bind(null, rule));

    if (hasInvalidCharacters(reduced)) {
      warnings.push('Invalid selector \'' + rule[1] + '\' at ' + formatPosition$3(rule[2][0]) + '. Ignoring.');
      continue;
    }

    reduced = removeWhitespace(reduced, format);
    reduced = removeQuotes(reduced);

    if (adjacentSpace && reduced.indexOf('nav') > 0) {
      reduced = reduced.replace(/\+nav(\S|$)/, '+ nav$1');
    }

    if (removeUnsupported && reduced.indexOf(ASTERISK_PLUS_HTML_HACK) > -1) {
      continue;
    }

    if (removeUnsupported && reduced.indexOf(ASTERISK_FIRST_CHILD_PLUS_HTML_HACK) > -1) {
      continue;
    }

    if (reduced.indexOf('*') > -1) {
      reduced = reduced
        .replace(/\*([:#.[])/g, '$1')
        .replace(/^(:first-child)?\+html/, '*$1+html');
    }

    if (repeated.indexOf(reduced) > -1) {
      continue;
    }

    reduced = replacePseudoClasses(reduced);

    rule[1] = reduced;
    repeated.push(reduced);
    list.push(rule);
  }

  if (list.length == 1 && list[0][1].length === 0) {
    warnings.push('Empty selector \'' + list[0][1] + '\' at ' + formatPosition$3(list[0][2][0]) + '. Ignoring.');
    list = [];
  }

  return list;
}

var tidyRules_1 = tidyRules$3;

var SUPPORTED_COMPACT_BLOCK_MATCHER = /^@media\W/;
var SUPPORTED_QUOTE_REMOVAL_MATCHER = /^@(?:keyframes|-moz-keyframes|-o-keyframes|-webkit-keyframes)\W/;

function tidyBlock$1(values, spaceAfterClosingBrace) {
  var withoutSpaceAfterClosingBrace;
  var withoutQuotes;
  var i;

  for (i = values.length - 1; i >= 0; i--) {
    withoutSpaceAfterClosingBrace = !spaceAfterClosingBrace && SUPPORTED_COMPACT_BLOCK_MATCHER.test(values[i][1]);
    withoutQuotes = SUPPORTED_QUOTE_REMOVAL_MATCHER.test(values[i][1]);

    values[i][1] = values[i][1]
      .replace(/\n|\r\n/g, ' ')
      .replace(/\s+/g, ' ')
      .replace(/(,|:|\() /g, '$1')
      .replace(/ \)/g, ')');

    if (withoutQuotes) {
      values[i][1] = values[i][1]
        .replace(/'([a-zA-Z][a-zA-Z\d\-_]+)'/, '$1')
        .replace(/"([a-zA-Z][a-zA-Z\d\-_]+)"/, '$1');
    }

    if (withoutSpaceAfterClosingBrace) {
      values[i][1] = values[i][1]
        .replace(/\) /g, ')');
    }
  }

  return values;
}

var tidyBlock_1 = tidyBlock$1;

function tidyAtRule$1(value) {
  return value
    .replace(/\s+/g, ' ')
    .replace(/url\(\s+/g, 'url(')
    .replace(/\s+\)/g, ')')
    .trim();
}

var tidyAtRule_1 = tidyAtRule$1;

var Hack$3 = {
  ASTERISK: 'asterisk',
  BANG: 'bang',
  BACKSLASH: 'backslash',
  UNDERSCORE: 'underscore'
};

var hack = Hack$3;

function removeUnused$2(properties) {
  for (var i = properties.length - 1; i >= 0; i--) {
    var property = properties[i];

    if (property.unused) {
      property.all.splice(property.position, 1);
    }
  }
}

var removeUnused_1 = removeUnused$2;

var Hack$2 = hack;

var Marker$e = marker;

var ASTERISK_HACK = '*';
var BACKSLASH_HACK = '\\';
var IMPORTANT_TOKEN = '!important';
var UNDERSCORE_HACK = '_';
var BANG_HACK = '!ie';

function restoreFromOptimizing$5(properties, restoreCallback) {
  var property;
  var restored;
  var current;
  var i;

  for (i = properties.length - 1; i >= 0; i--) {
    property = properties[i];

    if (property.dynamic && property.important) {
      restoreImportant(property);
      continue;
    }

    if (property.dynamic) {
      continue;
    }

    if (property.unused) {
      continue;
    }

    if (!property.dirty && !property.important && !property.hack) {
      continue;
    }

    if (property.optimizable && restoreCallback) {
      restored = restoreCallback(property);
      property.value = restored;
    } else {
      restored = property.value;
    }

    if (property.important) {
      restoreImportant(property);
    }

    if (property.hack) {
      restoreHack(property);
    }

    if ('all' in property) {
      current = property.all[property.position];
      current[1][1] = property.name;

      current.splice(2, current.length - 1);
      Array.prototype.push.apply(current, restored);
    }
  }
}

function restoreImportant(property) {
  property.value[property.value.length - 1][1] += IMPORTANT_TOKEN;
}

function restoreHack(property) {
  if (property.hack[0] == Hack$2.UNDERSCORE) {
    property.name = UNDERSCORE_HACK + property.name;
  } else if (property.hack[0] == Hack$2.ASTERISK) {
    property.name = ASTERISK_HACK + property.name;
  } else if (property.hack[0] == Hack$2.BACKSLASH) {
    property.value[property.value.length - 1][1] += BACKSLASH_HACK + property.hack[1];
  } else if (property.hack[0] == Hack$2.BANG) {
    property.value[property.value.length - 1][1] += Marker$e.SPACE + BANG_HACK;
  }
}

var restoreFromOptimizing_1 = restoreFromOptimizing$5;

var Token$o = {
  AT_RULE: 'at-rule', // e.g. `@import`, `@charset`
  AT_RULE_BLOCK: 'at-rule-block', // e.g. `@font-face{...}`
  AT_RULE_BLOCK_SCOPE: 'at-rule-block-scope', // e.g. `@font-face`
  COMMENT: 'comment', // e.g. `/* comment */`
  NESTED_BLOCK: 'nested-block', // e.g. `@media screen{...}`, `@keyframes animation {...}`
  NESTED_BLOCK_SCOPE: 'nested-block-scope', // e.g. `@media`, `@keyframes`
  PROPERTY: 'property', // e.g. `color:red`
  PROPERTY_BLOCK: 'property-block', // e.g. `--var:{color:red}`
  PROPERTY_NAME: 'property-name', // e.g. `color`
  PROPERTY_VALUE: 'property-value', // e.g. `red`
  RAW: 'raw', // e.g. anything between /* clean-css ignore:start */ and /* clean-css ignore:end */ comments
  RULE: 'rule', // e.g `div > a{...}`
  RULE_SCOPE: 'rule-scope' // e.g `div > a`
};

var token = Token$o;

var Hack$1 = hack;

var Marker$d = marker;
var Token$n = token;

var Match = {
  ASTERISK: '*',
  BACKSLASH: '\\',
  BANG: '!',
  BANG_SUFFIX_PATTERN: /!\w+$/,
  IMPORTANT_TOKEN: '!important',
  IMPORTANT_TOKEN_PATTERN: new RegExp('!important$', 'i'),
  IMPORTANT_WORD: 'important',
  IMPORTANT_WORD_PATTERN: new RegExp('important$', 'i'),
  SUFFIX_BANG_PATTERN: /!$/,
  UNDERSCORE: '_',
  VARIABLE_REFERENCE_PATTERN: /var\(--.+\)$/
};

function wrapAll(properties, skipProperties) {
  var wrapped = [];
  var single;
  var property;
  var i;

  for (i = properties.length - 1; i >= 0; i--) {
    property = properties[i];

    if (property[0] != Token$n.PROPERTY) {
      continue;
    }

    if (skipProperties && skipProperties.indexOf(property[1][1]) > -1) {
      continue;
    }

    single = wrapSingle$3(property);
    single.all = properties;
    single.position = i;
    wrapped.unshift(single);
  }

  return wrapped;
}

function someVariableReferences(property) {
  var i, l;
  var value;

  // skipping `property` and property name tokens
  for (i = 2, l = property.length; i < l; i++) {
    value = property[i];

    if (value[0] != Token$n.PROPERTY_VALUE) {
      continue;
    }

    if (isVariableReference(value[1])) {
      return true;
    }
  }

  return false;
}

function isVariableReference(value) {
  return Match.VARIABLE_REFERENCE_PATTERN.test(value);
}

function isMultiplex(property) {
  var value;
  var i, l;

  for (i = 3, l = property.length; i < l; i++) {
    value = property[i];

    if (value[0] == Token$n.PROPERTY_VALUE && (value[1] == Marker$d.COMMA || value[1] == Marker$d.FORWARD_SLASH)) {
      return true;
    }
  }

  return false;
}

function hackFrom(property) {
  var match = false;
  var name = property[1][1];
  var lastValue = property[property.length - 1];

  if (name[0] == Match.UNDERSCORE) {
    match = [Hack$1.UNDERSCORE];
  } else if (name[0] == Match.ASTERISK) {
    match = [Hack$1.ASTERISK];
  } else if (lastValue[1][0] == Match.BANG && !lastValue[1].match(Match.IMPORTANT_WORD_PATTERN)) {
    match = [Hack$1.BANG];
  } else if (lastValue[1].indexOf(Match.BANG) > 0
    && !lastValue[1].match(Match.IMPORTANT_WORD_PATTERN)
    && Match.BANG_SUFFIX_PATTERN.test(lastValue[1])) {
    match = [Hack$1.BANG];
  } else if (lastValue[1].indexOf(Match.BACKSLASH) > 0
    && lastValue[1].indexOf(Match.BACKSLASH) == lastValue[1].length - Match.BACKSLASH.length - 1) {
    match = [Hack$1.BACKSLASH, lastValue[1].substring(lastValue[1].indexOf(Match.BACKSLASH) + 1)];
  } else if (lastValue[1].indexOf(Match.BACKSLASH) === 0 && lastValue[1].length == 2) {
    match = [Hack$1.BACKSLASH, lastValue[1].substring(1)];
  }

  return match;
}

function isImportant(property) {
  if (property.length < 3) { return false; }

  var lastValue = property[property.length - 1];
  if (Match.IMPORTANT_TOKEN_PATTERN.test(lastValue[1])) {
    return true;
  } if (Match.IMPORTANT_WORD_PATTERN.test(lastValue[1])
    && Match.SUFFIX_BANG_PATTERN.test(property[property.length - 2][1])) {
    return true;
  }

  return false;
}

function stripImportant(property) {
  var lastValue = property[property.length - 1];
  var oneButLastValue = property[property.length - 2];

  if (Match.IMPORTANT_TOKEN_PATTERN.test(lastValue[1])) {
    lastValue[1] = lastValue[1].replace(Match.IMPORTANT_TOKEN_PATTERN, '');
  } else {
    lastValue[1] = lastValue[1].replace(Match.IMPORTANT_WORD_PATTERN, '');
    oneButLastValue[1] = oneButLastValue[1].replace(Match.SUFFIX_BANG_PATTERN, '');
  }

  if (lastValue[1].length === 0) {
    property.pop();
  }

  if (oneButLastValue[1].length === 0) {
    property.pop();
  }
}

function stripPrefixHack(property) {
  property[1][1] = property[1][1].substring(1);
}

function stripSuffixHack(property, hackFrom) {
  var lastValue = property[property.length - 1];
  lastValue[1] = lastValue[1]
    .substring(0, lastValue[1].indexOf(hackFrom[0] == Hack$1.BACKSLASH ? Match.BACKSLASH : Match.BANG))
    .trim();

  if (lastValue[1].length === 0) {
    property.pop();
  }
}

function wrapSingle$3(property) {
  var importantProperty = isImportant(property);
  if (importantProperty) {
    stripImportant(property);
  }

  var whichHack = hackFrom(property);
  if (whichHack[0] == Hack$1.ASTERISK || whichHack[0] == Hack$1.UNDERSCORE) {
    stripPrefixHack(property);
  } else if (whichHack[0] == Hack$1.BACKSLASH || whichHack[0] == Hack$1.BANG) {
    stripSuffixHack(property, whichHack);
  }

  return {
    block: property[2] && property[2][0] == Token$n.PROPERTY_BLOCK,
    components: [],
    dirty: false,
    dynamic: someVariableReferences(property),
    hack: whichHack,
    important: importantProperty,
    name: property[1][1],
    multiplex: property.length > 3 ? isMultiplex(property) : false,
    optimizable: true,
    position: 0,
    shorthand: false,
    unused: false,
    value: property.slice(2)
  };
}

var wrapForOptimizing$3 = {
  all: wrapAll,
  single: wrapSingle$3
};

function InvalidPropertyError$2(message) {
  this.name = 'InvalidPropertyError';
  this.message = message;
  this.stack = (new Error()).stack;
}

InvalidPropertyError$2.prototype = Object.create(Error.prototype);
InvalidPropertyError$2.prototype.constructor = InvalidPropertyError$2;

var invalidPropertyError = InvalidPropertyError$2;

var InvalidPropertyError$1 = invalidPropertyError;

var wrapSingle$2 = wrapForOptimizing$3.single;

var Token$m = token;
var Marker$c = marker;

var formatPosition$2 = formatPosition_1;

function _anyIsInherit(values) {
  var i, l;

  for (i = 0, l = values.length; i < l; i++) {
    if (values[i][1] == 'inherit') {
      return true;
    }
  }

  return false;
}

function _colorFilter(validator) {
  return function(value) {
    return value[1] == 'invert' || validator.isColor(value[1]) || validator.isPrefixed(value[1]);
  };
}

function _styleFilter(validator) {
  return function(value) {
    return value[1] != 'inherit' && validator.isStyleKeyword(value[1]) && !validator.isColorFunction(value[1]);
  };
}

function _wrapDefault(name, property, configuration) {
  var descriptor = configuration[name];
  if (descriptor.doubleValues && descriptor.defaultValue.length == 2) {
    return wrapSingle$2([
      Token$m.PROPERTY,
      [Token$m.PROPERTY_NAME, name],
      [Token$m.PROPERTY_VALUE, descriptor.defaultValue[0]],
      [Token$m.PROPERTY_VALUE, descriptor.defaultValue[1]]
    ]);
  } if (descriptor.doubleValues && descriptor.defaultValue.length == 1) {
    return wrapSingle$2([
      Token$m.PROPERTY,
      [Token$m.PROPERTY_NAME, name],
      [Token$m.PROPERTY_VALUE, descriptor.defaultValue[0]]
    ]);
  }
  return wrapSingle$2([
    Token$m.PROPERTY,
    [Token$m.PROPERTY_NAME, name],
    [Token$m.PROPERTY_VALUE, descriptor.defaultValue]
  ]);
}

function _widthFilter(validator) {
  return function(value) {
    return value[1] != 'inherit'
      && (validator.isWidth(value[1]) || validator.isUnit(value[1]) || validator.isDynamicUnit(value[1]))
      && !validator.isStyleKeyword(value[1])
      && !validator.isColorFunction(value[1]);
  };
}

function animation(property, configuration, validator) {
  var duration = _wrapDefault(property.name + '-duration', property, configuration);
  var timing = _wrapDefault(property.name + '-timing-function', property, configuration);
  var delay = _wrapDefault(property.name + '-delay', property, configuration);
  var iteration = _wrapDefault(property.name + '-iteration-count', property, configuration);
  var direction = _wrapDefault(property.name + '-direction', property, configuration);
  var fill = _wrapDefault(property.name + '-fill-mode', property, configuration);
  var play = _wrapDefault(property.name + '-play-state', property, configuration);
  var name = _wrapDefault(property.name + '-name', property, configuration);
  var components = [duration, timing, delay, iteration, direction, fill, play, name];
  var values = property.value;
  var value;
  var durationSet = false;
  var timingSet = false;
  var delaySet = false;
  var iterationSet = false;
  var directionSet = false;
  var fillSet = false;
  var playSet = false;
  var nameSet = false;
  var i;
  var l;

  if (property.value.length == 1 && property.value[0][1] == 'inherit') {
    // eslint-disable-next-line max-len
    duration.value = timing.value = delay.value = iteration.value = direction.value = fill.value = play.value = name.value = property.value;
    return components;
  }

  if (values.length > 1 && _anyIsInherit(values)) {
    throw new InvalidPropertyError$1('Invalid animation values at ' + formatPosition$2(values[0][2][0]) + '. Ignoring.');
  }

  for (i = 0, l = values.length; i < l; i++) {
    value = values[i];

    if (validator.isTime(value[1]) && !durationSet) {
      duration.value = [value];
      durationSet = true;
    } else if (validator.isTime(value[1]) && !delaySet) {
      delay.value = [value];
      delaySet = true;
    } else if ((validator.isGlobal(value[1]) || validator.isTimingFunction(value[1])) && !timingSet) {
      timing.value = [value];
      timingSet = true;
    } else if ((validator.isAnimationIterationCountKeyword(value[1])
      || validator.isPositiveNumber(value[1]))
      && !iterationSet) {
      iteration.value = [value];
      iterationSet = true;
    } else if (validator.isAnimationDirectionKeyword(value[1]) && !directionSet) {
      direction.value = [value];
      directionSet = true;
    } else if (validator.isAnimationFillModeKeyword(value[1]) && !fillSet) {
      fill.value = [value];
      fillSet = true;
    } else if (validator.isAnimationPlayStateKeyword(value[1]) && !playSet) {
      play.value = [value];
      playSet = true;
    } else if ((validator.isAnimationNameKeyword(value[1]) || validator.isIdentifier(value[1])) && !nameSet) {
      name.value = [value];
      nameSet = true;
    } else {
      throw new InvalidPropertyError$1('Invalid animation value at ' + formatPosition$2(value[2][0]) + '. Ignoring.');
    }
  }

  return components;
}

function background$2(property, configuration, validator) {
  var image = _wrapDefault('background-image', property, configuration);
  var position = _wrapDefault('background-position', property, configuration);
  var size = _wrapDefault('background-size', property, configuration);
  var repeat = _wrapDefault('background-repeat', property, configuration);
  var attachment = _wrapDefault('background-attachment', property, configuration);
  var origin = _wrapDefault('background-origin', property, configuration);
  var clip = _wrapDefault('background-clip', property, configuration);
  var color = _wrapDefault('background-color', property, configuration);
  var components = [image, position, size, repeat, attachment, origin, clip, color];
  var values = property.value;

  var positionSet = false;
  var clipSet = false;
  var originSet = false;
  var repeatSet = false;

  var anyValueSet = false;

  if (property.value.length == 1 && property.value[0][1] == 'inherit') {
    // NOTE: 'inherit' is not a valid value for background-attachment
    color.value = image.value = repeat.value = position.value = size.value = origin.value = clip.value = property.value;
    return components;
  }

  if (property.value.length == 1 && property.value[0][1] == '0 0') {
    return components;
  }

  for (var i = values.length - 1; i >= 0; i--) {
    var value = values[i];

    if (validator.isBackgroundAttachmentKeyword(value[1])) {
      attachment.value = [value];
      anyValueSet = true;
    } else if (validator.isBackgroundClipKeyword(value[1]) || validator.isBackgroundOriginKeyword(value[1])) {
      if (clipSet) {
        origin.value = [value];
        originSet = true;
      } else {
        clip.value = [value];
        clipSet = true;
      }
      anyValueSet = true;
    } else if (validator.isBackgroundRepeatKeyword(value[1])) {
      if (repeatSet) {
        repeat.value.unshift(value);
      } else {
        repeat.value = [value];
        repeatSet = true;
      }
      anyValueSet = true;
    } else if (validator.isBackgroundPositionKeyword(value[1])
    || validator.isBackgroundSizeKeyword(value[1])
    || validator.isUnit(value[1])
    || validator.isDynamicUnit(value[1])) {
      if (i > 0) {
        var previousValue = values[i - 1];

        if (previousValue[1] == Marker$c.FORWARD_SLASH) {
          size.value = [value];
        } else if (i > 1 && values[i - 2][1] == Marker$c.FORWARD_SLASH) {
          size.value = [previousValue, value];
          i -= 2;
        } else {
          if (!positionSet) { position.value = []; }

          position.value.unshift(value);
          positionSet = true;
        }
      } else {
        if (!positionSet) { position.value = []; }

        position.value.unshift(value);
        positionSet = true;
      }
      anyValueSet = true;
    } else if ((color.value[0][1] == configuration[color.name].defaultValue || color.value[0][1] == 'none') && (validator.isColor(value[1]) || validator.isPrefixed(value[1]))) {
      color.value = [value];
      anyValueSet = true;
    } else if (validator.isUrl(value[1]) || validator.isFunction(value[1])) {
      image.value = [value];
      anyValueSet = true;
    }
  }

  if (clipSet && !originSet) { origin.value = clip.value.slice(0); }

  if (!anyValueSet) {
    throw new InvalidPropertyError$1('Invalid background value at ' + formatPosition$2(values[0][2][0]) + '. Ignoring.');
  }

  return components;
}

function borderRadius$2(property, configuration) {
  var values = property.value;
  var splitAt = -1;

  for (var i = 0, l = values.length; i < l; i++) {
    if (values[i][1] == Marker$c.FORWARD_SLASH) {
      splitAt = i;
      break;
    }
  }

  if (splitAt === 0 || splitAt === values.length - 1) {
    throw new InvalidPropertyError$1('Invalid border-radius value at ' + formatPosition$2(values[0][2][0]) + '. Ignoring.');
  }

  var target = _wrapDefault(property.name, property, configuration);
  target.value = splitAt > -1
    ? values.slice(0, splitAt)
    : values.slice(0);
  target.components = fourValues$1(target, configuration);

  var remainder = _wrapDefault(property.name, property, configuration);
  remainder.value = splitAt > -1
    ? values.slice(splitAt + 1)
    : values.slice(0);
  remainder.components = fourValues$1(remainder, configuration);

  for (var j = 0; j < 4; j++) {
    target.components[j].multiplex = true;
    target.components[j].value = target.components[j].value.concat(remainder.components[j].value);
  }

  return target.components;
}

function font$1(property, configuration, validator) {
  var style = _wrapDefault('font-style', property, configuration);
  var variant = _wrapDefault('font-variant', property, configuration);
  var weight = _wrapDefault('font-weight', property, configuration);
  var stretch = _wrapDefault('font-stretch', property, configuration);
  var size = _wrapDefault('font-size', property, configuration);
  var height = _wrapDefault('line-height', property, configuration);
  var family = _wrapDefault('font-family', property, configuration);
  var components = [style, variant, weight, stretch, size, height, family];
  var values = property.value;
  var fuzzyMatched = 4; // style, variant, weight, and stretch
  var index = 0;
  var isStretchSet = false;
  var isStretchValid;
  var isStyleSet = false;
  var isStyleValid;
  var isVariantSet = false;
  var isVariantValid;
  var isWeightSet = false;
  var isWeightValid;
  var appendableFamilyName = false;

  if (!values[index]) {
    throw new InvalidPropertyError$1('Missing font values at ' + formatPosition$2(property.all[property.position][1][2][0]) + '. Ignoring.');
  }

  if (values.length == 1 && values[0][1] == 'inherit') {
    style.value = variant.value = weight.value = stretch.value = size.value = height.value = family.value = values;
    return components;
  }

  if (values.length == 1
    && (validator.isFontKeyword(values[0][1])
    || validator.isGlobal(values[0][1])
    || validator.isPrefixed(values[0][1]))
  ) {
    values[0][1] = Marker$c.INTERNAL + values[0][1];
    style.value = variant.value = weight.value = stretch.value = size.value = height.value = family.value = values;
    return components;
  }

  if (values.length < 2 || !_anyIsFontSize(values, validator) || !_anyIsFontFamily(values, validator)) {
    throw new InvalidPropertyError$1('Invalid font values at ' + formatPosition$2(property.all[property.position][1][2][0]) + '. Ignoring.');
  }

  if (values.length > 1 && _anyIsInherit(values)) {
    throw new InvalidPropertyError$1('Invalid font values at ' + formatPosition$2(values[0][2][0]) + '. Ignoring.');
  }

  // fuzzy match style, variant, weight, and stretch on first elements
  while (index < fuzzyMatched) {
    isStretchValid = validator.isFontStretchKeyword(values[index][1]) || validator.isGlobal(values[index][1]);
    isStyleValid = validator.isFontStyleKeyword(values[index][1]) || validator.isGlobal(values[index][1]);
    isVariantValid = validator.isFontVariantKeyword(values[index][1]) || validator.isGlobal(values[index][1]);
    isWeightValid = validator.isFontWeightKeyword(values[index][1]) || validator.isGlobal(values[index][1]);

    if (isStyleValid && !isStyleSet) {
      style.value = [values[index]];
      isStyleSet = true;
    } else if (isVariantValid && !isVariantSet) {
      variant.value = [values[index]];
      isVariantSet = true;
    } else if (isWeightValid && !isWeightSet) {
      weight.value = [values[index]];
      isWeightSet = true;
    } else if (isStretchValid && !isStretchSet) {
      stretch.value = [values[index]];
      isStretchSet = true;
    } else if (isStyleValid
      && isStyleSet
      || isVariantValid
      && isVariantSet
      || isWeightValid
      && isWeightSet
      || isStretchValid
      && isStretchSet) {
      throw new InvalidPropertyError$1('Invalid font style / variant / weight / stretch value at ' + formatPosition$2(values[0][2][0]) + '. Ignoring.');
    } else {
      break;
    }

    index++;
  }

  // now comes font-size ...
  if (validator.isFontSizeKeyword(values[index][1])
    || validator.isUnit(values[index][1])
    && !validator.isDynamicUnit(values[index][1])) {
    size.value = [values[index]];
    index++;
  } else {
    throw new InvalidPropertyError$1('Missing font size at ' + formatPosition$2(values[0][2][0]) + '. Ignoring.');
  }

  if (!values[index]) {
    throw new InvalidPropertyError$1('Missing font family at ' + formatPosition$2(values[0][2][0]) + '. Ignoring.');
  }

  // ... and perhaps line-height
  if (values[index]
    && values[index][1] == Marker$c.FORWARD_SLASH
    && values[index + 1]
    && (validator.isLineHeightKeyword(values[index + 1][1])
    || validator.isUnit(values[index + 1][1])
    || validator.isNumber(values[index + 1][1]))) {
    height.value = [values[index + 1]];
    index++;
    index++;
  }

  // ... and whatever comes next is font-family
  family.value = [];

  while (values[index]) {
    if (values[index][1] == Marker$c.COMMA) {
      appendableFamilyName = false;
    } else {
      if (appendableFamilyName) {
        family.value[family.value.length - 1][1] += Marker$c.SPACE + values[index][1];
      } else {
        family.value.push(values[index]);
      }

      appendableFamilyName = true;
    }

    index++;
  }

  if (family.value.length === 0) {
    throw new InvalidPropertyError$1('Missing font family at ' + formatPosition$2(values[0][2][0]) + '. Ignoring.');
  }

  return components;
}

function _anyIsFontSize(values, validator) {
  var value;
  var i, l;

  for (i = 0, l = values.length; i < l; i++) {
    value = values[i];

    if (validator.isFontSizeKeyword(value[1])
      || validator.isUnit(value[1])
      && !validator.isDynamicUnit(value[1])
      || validator.isFunction(value[1])) {
      return true;
    }
  }

  return false;
}

function _anyIsFontFamily(values, validator) {
  var value;
  var i, l;

  for (i = 0, l = values.length; i < l; i++) {
    value = values[i];

    if (validator.isIdentifier(value[1]) || validator.isQuotedText(value[1])) {
      return true;
    }
  }

  return false;
}

function fourValues$1(property, configuration) {
  var componentNames = configuration[property.name].components;
  var components = [];
  var value = property.value;

  if (value.length < 1) { return []; }

  if (value.length < 2) { value[1] = value[0].slice(0); }
  if (value.length < 3) { value[2] = value[0].slice(0); }
  if (value.length < 4) { value[3] = value[1].slice(0); }

  for (var i = componentNames.length - 1; i >= 0; i--) {
    var component = wrapSingle$2([
      Token$m.PROPERTY,
      [Token$m.PROPERTY_NAME, componentNames[i]]
    ]);
    component.value = [value[i]];
    components.unshift(component);
  }

  return components;
}

function multiplex$1(splitWith) {
  return function(property, configuration, validator) {
    var splitsAt = [];
    var values = property.value;
    var i, j, l, m;

    // find split commas
    for (i = 0, l = values.length; i < l; i++) {
      if (values[i][1] == ',') { splitsAt.push(i); }
    }

    if (splitsAt.length === 0) { return splitWith(property, configuration, validator); }

    var splitComponents = [];

    // split over commas, and into components
    for (i = 0, l = splitsAt.length; i <= l; i++) {
      var from = i === 0 ? 0 : splitsAt[i - 1] + 1;
      var to = i < l ? splitsAt[i] : values.length;

      var _property = _wrapDefault(property.name, property, configuration);
      _property.value = values.slice(from, to);

      if (_property.value.length > 0) {
        splitComponents.push(splitWith(_property, configuration, validator));
      }
    }

    var components = splitComponents[0];

    // group component values from each split
    for (i = 0, l = components.length; i < l; i++) {
      components[i].multiplex = true;

      for (j = 1, m = splitComponents.length; j < m; j++) {
        components[i].value.push([Token$m.PROPERTY_VALUE, Marker$c.COMMA]);
        Array.prototype.push.apply(components[i].value, splitComponents[j][i].value);
      }
    }

    return components;
  };
}

function listStyle(property, configuration, validator) {
  var type = _wrapDefault('list-style-type', property, configuration);
  var position = _wrapDefault('list-style-position', property, configuration);
  var image = _wrapDefault('list-style-image', property, configuration);
  var components = [type, position, image];

  if (property.value.length == 1 && property.value[0][1] == 'inherit') {
    type.value = position.value = image.value = [property.value[0]];
    return components;
  }

  var values = property.value.slice(0);
  var total = values.length;
  var index = 0;

  // `image` first...
  for (index = 0, total = values.length; index < total; index++) {
    if (validator.isUrl(values[index][1]) || values[index][1] == '0') {
      image.value = [values[index]];
      values.splice(index, 1);
      break;
    }
  }

  // ... then `position`
  for (index = 0, total = values.length; index < total; index++) {
    if (validator.isListStylePositionKeyword(values[index][1])) {
      position.value = [values[index]];
      values.splice(index, 1);
      break;
    }
  }

  // ... and what's left is a `type`
  if (values.length > 0 && (validator.isListStyleTypeKeyword(values[0][1]) || validator.isIdentifier(values[0][1]))) {
    type.value = [values[0]];
  }

  return components;
}

function transition(property, configuration, validator) {
  var prop = _wrapDefault(property.name + '-property', property, configuration);
  var duration = _wrapDefault(property.name + '-duration', property, configuration);
  var timing = _wrapDefault(property.name + '-timing-function', property, configuration);
  var delay = _wrapDefault(property.name + '-delay', property, configuration);
  var components = [prop, duration, timing, delay];
  var values = property.value;
  var value;
  var durationSet = false;
  var delaySet = false;
  var propSet = false;
  var timingSet = false;
  var i;
  var l;

  if (property.value.length == 1 && property.value[0][1] == 'inherit') {
    prop.value = duration.value = timing.value = delay.value = property.value;
    return components;
  }

  if (values.length > 1 && _anyIsInherit(values)) {
    throw new InvalidPropertyError$1('Invalid animation values at ' + formatPosition$2(values[0][2][0]) + '. Ignoring.');
  }

  for (i = 0, l = values.length; i < l; i++) {
    value = values[i];

    if (validator.isTime(value[1]) && !durationSet) {
      duration.value = [value];
      durationSet = true;
    } else if (validator.isTime(value[1]) && !delaySet) {
      delay.value = [value];
      delaySet = true;
    } else if ((validator.isGlobal(value[1]) || validator.isTimingFunction(value[1])) && !timingSet) {
      timing.value = [value];
      timingSet = true;
    } else if (validator.isIdentifier(value[1]) && !propSet) {
      prop.value = [value];
      propSet = true;
    } else {
      throw new InvalidPropertyError$1('Invalid animation value at ' + formatPosition$2(value[2][0]) + '. Ignoring.');
    }
  }

  return components;
}

function widthStyleColor(property, configuration, validator) {
  var descriptor = configuration[property.name];
  var components = [
    _wrapDefault(descriptor.components[0], property, configuration),
    _wrapDefault(descriptor.components[1], property, configuration),
    _wrapDefault(descriptor.components[2], property, configuration)
  ];
  var color, style, width;

  for (var i = 0; i < 3; i++) {
    var component = components[i];

    if (component.name.indexOf('color') > 0) { color = component; } else if (component.name.indexOf('style') > 0) { style = component; } else { width = component; }
  }

  if ((property.value.length == 1 && property.value[0][1] == 'inherit')
      || (property.value.length == 3 && property.value[0][1] == 'inherit' && property.value[1][1] == 'inherit' && property.value[2][1] == 'inherit')) {
    color.value = style.value = width.value = [property.value[0]];
    return components;
  }

  var values = property.value.slice(0);
  var match, matches;

  // NOTE: usually users don't follow the required order of parts in this shorthand,
  // so we'll try to parse it caring as little about order as possible

  if (values.length > 0) {
    matches = values.filter(_widthFilter(validator));
    match = matches.length > 1 && (matches[0][1] == 'none' || matches[0][1] == 'auto') ? matches[1] : matches[0];
    if (match) {
      width.value = [match];
      values.splice(values.indexOf(match), 1);
    }
  }

  if (values.length > 0) {
    match = values.filter(_styleFilter(validator))[0];
    if (match) {
      style.value = [match];
      values.splice(values.indexOf(match), 1);
    }
  }

  if (values.length > 0) {
    match = values.filter(_colorFilter(validator))[0];
    if (match) {
      color.value = [match];
      values.splice(values.indexOf(match), 1);
    }
  }

  return components;
}

var breakUp$1 = {
  animation: animation,
  background: background$2,
  border: widthStyleColor,
  borderRadius: borderRadius$2,
  font: font$1,
  fourValues: fourValues$1,
  listStyle: listStyle,
  multiplex: multiplex$1,
  outline: widthStyleColor,
  transition: transition
};

var VENDOR_PREFIX_PATTERN = /(?:^|\W)(-\w+-)/g;

function unique(value) {
  var prefixes = [];
  var match;

  // eslint-disable-next-line no-cond-assign
  while ((match = VENDOR_PREFIX_PATTERN.exec(value)) !== null) {
    if (prefixes.indexOf(match[0]) == -1) {
      prefixes.push(match[0]);
    }
  }

  return prefixes;
}

function same(value1, value2) {
  return unique(value1).sort().join(',') == unique(value2).sort().join(',');
}

var vendorPrefixes = {
  unique: unique,
  same: same
};

var sameVendorPrefixes = vendorPrefixes.same;

function understandable$1(validator, value1, value2, _position, isPaired) {
  if (!sameVendorPrefixes(value1, value2)) {
    return false;
  }

  if (isPaired && validator.isVariable(value1) !== validator.isVariable(value2)) {
    return false;
  }

  return true;
}

var understandable_1 = understandable$1;

var understandable = understandable_1;

function animationIterationCount(validator, value1, value2) {
  if (!understandable(validator, value1, value2, 0, true)
    && !(validator.isAnimationIterationCountKeyword(value2) || validator.isPositiveNumber(value2))) {
    return false;
  } if (validator.isVariable(value1) && validator.isVariable(value2)) {
    return true;
  }

  return validator.isAnimationIterationCountKeyword(value2) || validator.isPositiveNumber(value2);
}

function animationName(validator, value1, value2) {
  if (!understandable(validator, value1, value2, 0, true)
    && !(validator.isAnimationNameKeyword(value2) || validator.isIdentifier(value2))) {
    return false;
  } if (validator.isVariable(value1) && validator.isVariable(value2)) {
    return true;
  }

  return validator.isAnimationNameKeyword(value2) || validator.isIdentifier(value2);
}

function areSameFunction(validator, value1, value2) {
  if (!validator.isFunction(value1) || !validator.isFunction(value2)) {
    return false;
  }

  var function1Name = value1.substring(0, value1.indexOf('('));
  var function2Name = value2.substring(0, value2.indexOf('('));

  var function1Value = value1.substring(function1Name.length + 1, value1.length - 1);
  var function2Value = value2.substring(function2Name.length + 1, value2.length - 1);

  if (validator.isFunction(function1Value) || validator.isFunction(function2Value)) {
    return function1Name === function2Name && areSameFunction(validator, function1Value, function2Value);
  }
  return function1Name === function2Name;
}

function backgroundPosition(validator, value1, value2) {
  if (!understandable(validator, value1, value2, 0, true)
    && !(validator.isBackgroundPositionKeyword(value2) || validator.isGlobal(value2))) {
    return false;
  } if (validator.isVariable(value1) && validator.isVariable(value2)) {
    return true;
  } if (validator.isBackgroundPositionKeyword(value2) || validator.isGlobal(value2)) {
    return true;
  }

  return unit$1(validator, value1, value2);
}

function backgroundSize(validator, value1, value2) {
  if (!understandable(validator, value1, value2, 0, true)
    && !(validator.isBackgroundSizeKeyword(value2) || validator.isGlobal(value2))) {
    return false;
  } if (validator.isVariable(value1) && validator.isVariable(value2)) {
    return true;
  } if (validator.isBackgroundSizeKeyword(value2) || validator.isGlobal(value2)) {
    return true;
  }

  return unit$1(validator, value1, value2);
}

function color$1(validator, value1, value2) {
  if (!understandable(validator, value1, value2, 0, true) && !validator.isColor(value2)) {
    return false;
  } if (validator.isVariable(value1) && validator.isVariable(value2)) {
    return true;
  } if (!validator.colorOpacity && (validator.isRgbColor(value1) || validator.isHslColor(value1))) {
    return false;
  } if (!validator.colorOpacity && (validator.isRgbColor(value2) || validator.isHslColor(value2))) {
    return false;
  } if (!validator.colorHexAlpha && (validator.isHexAlphaColor(value1) || validator.isHexAlphaColor(value2))) {
    return false;
  } if (validator.isColor(value1) && validator.isColor(value2)) {
    return true;
  }

  return sameFunctionOrValue(validator, value1, value2);
}

function components(overrideCheckers) {
  return function(validator, value1, value2, position) {
    return overrideCheckers[position](validator, value1, value2);
  };
}

function fontFamily(validator, value1, value2) {
  return understandable(validator, value1, value2, 0, true);
}

function image(validator, value1, value2) {
  if (!understandable(validator, value1, value2, 0, true) && !validator.isImage(value2)) {
    return false;
  } if (validator.isVariable(value1) && validator.isVariable(value2)) {
    return true;
  } if (validator.isImage(value2)) {
    return true;
  } if (validator.isImage(value1)) {
    return false;
  }

  return sameFunctionOrValue(validator, value1, value2);
}

function keyword$1(propertyName) {
  return function(validator, value1, value2) {
    if (!understandable(validator, value1, value2, 0, true) && !validator.isKeyword(propertyName)(value2)) {
      return false;
    } if (validator.isVariable(value1) && validator.isVariable(value2)) {
      return true;
    }

    return validator.isKeyword(propertyName)(value2);
  };
}

function keywordWithGlobal(propertyName) {
  return function(validator, value1, value2) {
    if (!understandable(validator, value1, value2, 0, true)
      && !(validator.isKeyword(propertyName)(value2) || validator.isGlobal(value2))) {
      return false;
    } if (validator.isVariable(value1) && validator.isVariable(value2)) {
      return true;
    }

    return validator.isKeyword(propertyName)(value2) || validator.isGlobal(value2);
  };
}

function propertyName$1(validator, value1, value2) {
  if (!understandable(validator, value1, value2, 0, true) && !validator.isIdentifier(value2)) {
    return false;
  } if (validator.isVariable(value1) && validator.isVariable(value2)) {
    return true;
  }

  return validator.isIdentifier(value2);
}

function sameFunctionOrValue(validator, value1, value2) {
  return areSameFunction(validator, value1, value2)
    ? true
    : value1 === value2;
}

function textShadow(validator, value1, value2) {
  if (!understandable(validator, value1, value2, 0, true)
    && !(validator.isUnit(value2)
    || validator.isColor(value2)
    || validator.isGlobal(value2))) {
    return false;
  } if (validator.isVariable(value1) && validator.isVariable(value2)) {
    return true;
  }

  return validator.isUnit(value2) || validator.isColor(value2) || validator.isGlobal(value2);
}

function time$1(validator, value1, value2) {
  if (!understandable(validator, value1, value2, 0, true) && !validator.isTime(value2)) {
    return false;
  } if (validator.isVariable(value1) && validator.isVariable(value2)) {
    return true;
  } if (validator.isTime(value1) && !validator.isTime(value2)) {
    return false;
  } if (validator.isTime(value2)) {
    return true;
  } if (validator.isTime(value1)) {
    return false;
  } if (validator.isFunction(value1)
    && !validator.isPrefixed(value1)
    && validator.isFunction(value2)
    && !validator.isPrefixed(value2)) {
    return true;
  }

  return sameFunctionOrValue(validator, value1, value2);
}

function timingFunction(validator, value1, value2) {
  if (!understandable(validator, value1, value2, 0, true)
    && !(validator.isTimingFunction(value2) || validator.isGlobal(value2))) {
    return false;
  } if (validator.isVariable(value1) && validator.isVariable(value2)) {
    return true;
  }

  return validator.isTimingFunction(value2) || validator.isGlobal(value2);
}

function unit$1(validator, value1, value2) {
  if (!understandable(validator, value1, value2, 0, true) && !validator.isUnit(value2)) {
    return false;
  } if (validator.isVariable(value1) && validator.isVariable(value2)) {
    return true;
  } if (validator.isUnit(value1) && !validator.isUnit(value2)) {
    return false;
  } if (validator.isUnit(value2)) {
    return true;
  } if (validator.isUnit(value1)) {
    return false;
  } if (validator.isFunction(value1)
    && !validator.isPrefixed(value1)
    && validator.isFunction(value2)
    && !validator.isPrefixed(value2)) {
    return true;
  }

  return sameFunctionOrValue(validator, value1, value2);
}

function unitOrKeywordWithGlobal(propertyName) {
  var byKeyword = keywordWithGlobal(propertyName);

  return function(validator, value1, value2) {
    return unit$1(validator, value1, value2) || byKeyword(validator, value1, value2);
  };
}

function unitOrNumber(validator, value1, value2) {
  if (!understandable(validator, value1, value2, 0, true)
    && !(validator.isUnit(value2)
    || validator.isNumber(value2))) {
    return false;
  } if (validator.isVariable(value1) && validator.isVariable(value2)) {
    return true;
  } if ((validator.isUnit(value1)
    || validator.isNumber(value1))
    && !(validator.isUnit(value2)
    || validator.isNumber(value2))) {
    return false;
  } if (validator.isUnit(value2) || validator.isNumber(value2)) {
    return true;
  } if (validator.isUnit(value1) || validator.isNumber(value1)) {
    return false;
  } if (validator.isFunction(value1)
    && !validator.isPrefixed(value1)
    && validator.isFunction(value2)
    && !validator.isPrefixed(value2)) {
    return true;
  }

  return sameFunctionOrValue(validator, value1, value2);
}

function zIndex(validator, value1, value2) {
  if (!understandable(validator, value1, value2, 0, true) && !validator.isZIndex(value2)) {
    return false;
  } if (validator.isVariable(value1) && validator.isVariable(value2)) {
    return true;
  }

  return validator.isZIndex(value2);
}

var canOverride$1 = {
  generic: {
    color: color$1,
    components: components,
    image: image,
    propertyName: propertyName$1,
    time: time$1,
    timingFunction: timingFunction,
    unit: unit$1,
    unitOrNumber: unitOrNumber
  },
  property: {
    animationDirection: keywordWithGlobal('animation-direction'),
    animationFillMode: keyword$1('animation-fill-mode'),
    animationIterationCount: animationIterationCount,
    animationName: animationName,
    animationPlayState: keywordWithGlobal('animation-play-state'),
    backgroundAttachment: keyword$1('background-attachment'),
    backgroundClip: keywordWithGlobal('background-clip'),
    backgroundOrigin: keyword$1('background-origin'),
    backgroundPosition: backgroundPosition,
    backgroundRepeat: keyword$1('background-repeat'),
    backgroundSize: backgroundSize,
    bottom: unitOrKeywordWithGlobal('bottom'),
    borderCollapse: keyword$1('border-collapse'),
    borderStyle: keywordWithGlobal('*-style'),
    clear: keywordWithGlobal('clear'),
    cursor: keywordWithGlobal('cursor'),
    display: keywordWithGlobal('display'),
    float: keywordWithGlobal('float'),
    left: unitOrKeywordWithGlobal('left'),
    fontFamily: fontFamily,
    fontStretch: keywordWithGlobal('font-stretch'),
    fontStyle: keywordWithGlobal('font-style'),
    fontVariant: keywordWithGlobal('font-variant'),
    fontWeight: keywordWithGlobal('font-weight'),
    listStyleType: keywordWithGlobal('list-style-type'),
    listStylePosition: keywordWithGlobal('list-style-position'),
    outlineStyle: keywordWithGlobal('*-style'),
    overflow: keywordWithGlobal('overflow'),
    position: keywordWithGlobal('position'),
    right: unitOrKeywordWithGlobal('right'),
    textAlign: keywordWithGlobal('text-align'),
    textDecoration: keywordWithGlobal('text-decoration'),
    textOverflow: keywordWithGlobal('text-overflow'),
    textShadow: textShadow,
    top: unitOrKeywordWithGlobal('top'),
    transform: sameFunctionOrValue,
    verticalAlign: unitOrKeywordWithGlobal('vertical-align'),
    visibility: keywordWithGlobal('visibility'),
    whiteSpace: keywordWithGlobal('white-space'),
    zIndex: zIndex
  }
};

var wrapSingle$1 = wrapForOptimizing$3.single;

var Token$l = token;

function deep(property) {
  var cloned = shallow(property);
  for (var i = property.components.length - 1; i >= 0; i--) {
    var component = shallow(property.components[i]);
    component.value = property.components[i].value.slice(0);
    cloned.components.unshift(component);
  }

  cloned.dirty = true;
  cloned.value = property.value.slice(0);

  return cloned;
}

function shallow(property) {
  var cloned = wrapSingle$1([
    Token$l.PROPERTY,
    [Token$l.PROPERTY_NAME, property.name]
  ]);
  cloned.important = property.important;
  cloned.hack = property.hack;
  cloned.unused = false;
  return cloned;
}

var clone$2 = {
  deep: deep,
  shallow: shallow
};

var shallowClone$1 = clone$2.shallow;

var Token$k = token;
var Marker$b = marker;

function isInheritOnly(values) {
  for (var i = 0, l = values.length; i < l; i++) {
    var value = values[i][1];

    if (value != 'inherit' && value != Marker$b.COMMA && value != Marker$b.FORWARD_SLASH) { return false; }
  }

  return true;
}

function background$1(property, configuration, lastInMultiplex) {
  var components = property.components;
  var restored = [];
  var needsOne, needsBoth;

  function restoreValue(component) {
    Array.prototype.unshift.apply(restored, component.value);
  }

  function isDefaultValue(component) {
    var descriptor = configuration[component.name];

    if (descriptor.doubleValues && descriptor.defaultValue.length == 1) {
      return component.value[0][1] == descriptor.defaultValue[0]
        && (component.value[1]
          ? component.value[1][1] == descriptor.defaultValue[0]
          : true);
    } if (descriptor.doubleValues && descriptor.defaultValue.length != 1) {
      return component.value[0][1] == descriptor.defaultValue[0]
      && ((component.value[1] ? component.value[1][1] : component.value[0][1])
        == descriptor.defaultValue[1]);
    }
    return component.value[0][1] == descriptor.defaultValue;
  }

  for (var i = components.length - 1; i >= 0; i--) {
    var component = components[i];
    var isDefault = isDefaultValue(component);

    if (component.name == 'background-clip') {
      var originComponent = components[i - 1];
      var isOriginDefault = isDefaultValue(originComponent);

      needsOne = component.value[0][1] == originComponent.value[0][1];

      needsBoth = !needsOne && (
        (isOriginDefault && !isDefault)
        || (!isOriginDefault && !isDefault)
        || (!isOriginDefault && isDefault && component.value[0][1] != originComponent.value[0][1]));

      if (needsOne) {
        restoreValue(originComponent);
      } else if (needsBoth) {
        restoreValue(component);
        restoreValue(originComponent);
      }

      i--;
    } else if (component.name == 'background-size') {
      var positionComponent = components[i - 1];
      var isPositionDefault = isDefaultValue(positionComponent);

      needsOne = !isPositionDefault && isDefault;

      needsBoth = !needsOne
        && (isPositionDefault && !isDefault || !isPositionDefault && !isDefault);

      if (needsOne) {
        restoreValue(positionComponent);
      } else if (needsBoth) {
        restoreValue(component);
        restored.unshift([Token$k.PROPERTY_VALUE, Marker$b.FORWARD_SLASH]);
        restoreValue(positionComponent);
      } else if (positionComponent.value.length == 1) {
        restoreValue(positionComponent);
      }

      i--;
    } else {
      if (isDefault || configuration[component.name].multiplexLastOnly && !lastInMultiplex) { continue; }

      restoreValue(component);
    }
  }

  if (restored.length === 0 && property.value.length == 1 && property.value[0][1] == '0') { restored.push(property.value[0]); }

  if (restored.length === 0) { restored.push([Token$k.PROPERTY_VALUE, configuration[property.name].defaultValue]); }

  if (isInheritOnly(restored)) { return [restored[0]]; }

  return restored;
}

function borderRadius$1(property) {
  if (property.multiplex) {
    var horizontal = shallowClone$1(property);
    var vertical = shallowClone$1(property);

    for (var i = 0; i < 4; i++) {
      var component = property.components[i];

      var horizontalComponent = shallowClone$1(property);
      horizontalComponent.value = [component.value[0]];
      horizontal.components.push(horizontalComponent);

      var verticalComponent = shallowClone$1(property);
      // FIXME: only shorthand compactor (see breakup#borderRadius) knows that border radius
      // longhands have two values, whereas tokenizer does not care about populating 2nd value
      // if it's missing, hence this fallback
      verticalComponent.value = [component.value[1] || component.value[0]];
      vertical.components.push(verticalComponent);
    }

    var horizontalValues = fourValues(horizontal);
    var verticalValues = fourValues(vertical);

    if (horizontalValues.length == verticalValues.length
        && horizontalValues[0][1] == verticalValues[0][1]
        && (horizontalValues.length > 1 ? horizontalValues[1][1] == verticalValues[1][1] : true)
        && (horizontalValues.length > 2 ? horizontalValues[2][1] == verticalValues[2][1] : true)
        && (horizontalValues.length > 3 ? horizontalValues[3][1] == verticalValues[3][1] : true)) {
      return horizontalValues;
    }
    return horizontalValues.concat([[Token$k.PROPERTY_VALUE, Marker$b.FORWARD_SLASH]]).concat(verticalValues);
  }
  return fourValues(property);
}

function font(property, configuration) {
  var components = property.components;
  var restored = [];
  var component;
  var componentIndex = 0;
  var fontFamilyIndex = 0;

  if (property.value[0][1].indexOf(Marker$b.INTERNAL) === 0) {
    property.value[0][1] = property.value[0][1].substring(Marker$b.INTERNAL.length);
    return property.value;
  }

  // first four components are optional
  while (componentIndex < 4) {
    component = components[componentIndex];

    if (component.value[0][1] != configuration[component.name].defaultValue) {
      Array.prototype.push.apply(restored, component.value);
    }

    componentIndex++;
  }

  // then comes font-size
  Array.prototype.push.apply(restored, components[componentIndex].value);
  componentIndex++;

  // then may come line-height
  if (components[componentIndex].value[0][1] != configuration[components[componentIndex].name].defaultValue) {
    Array.prototype.push.apply(restored, [[Token$k.PROPERTY_VALUE, Marker$b.FORWARD_SLASH]]);
    Array.prototype.push.apply(restored, components[componentIndex].value);
  }

  componentIndex++;

  // then comes font-family
  while (components[componentIndex].value[fontFamilyIndex]) {
    restored.push(components[componentIndex].value[fontFamilyIndex]);

    if (components[componentIndex].value[fontFamilyIndex + 1]) {
      restored.push([Token$k.PROPERTY_VALUE, Marker$b.COMMA]);
    }

    fontFamilyIndex++;
  }

  if (isInheritOnly(restored)) {
    return [restored[0]];
  }

  return restored;
}

function fourValues(property) {
  var components = property.components;
  var value1 = components[0].value[0];
  var value2 = components[1].value[0];
  var value3 = components[2].value[0];
  var value4 = components[3].value[0];

  if (value1[1] == value2[1] && value1[1] == value3[1] && value1[1] == value4[1]) {
    return [value1];
  } if (value1[1] == value3[1] && value2[1] == value4[1]) {
    return [value1, value2];
  } if (value2[1] == value4[1]) {
    return [value1, value2, value3];
  }
  return [value1, value2, value3, value4];
}

function multiplex(restoreWith) {
  return function(property, configuration) {
    if (!property.multiplex) { return restoreWith(property, configuration, true); }

    var multiplexSize = 0;
    var restored = [];
    var componentMultiplexSoFar = {};
    var i, l;

    // At this point we don't know what's the multiplex size, e.g. how many background layers are there
    for (i = 0, l = property.components[0].value.length; i < l; i++) {
      if (property.components[0].value[i][1] == Marker$b.COMMA) { multiplexSize++; }
    }

    for (i = 0; i <= multiplexSize; i++) {
      var _property = shallowClone$1(property);

      // We split multiplex into parts and restore them one by one
      for (var j = 0, m = property.components.length; j < m; j++) {
        var componentToClone = property.components[j];
        var _component = shallowClone$1(componentToClone);
        _property.components.push(_component);

        // The trick is some properties has more than one value, so we iterate over values looking for
        // a multiplex separator - a comma
        for (var k = componentMultiplexSoFar[_component.name] || 0, n = componentToClone.value.length; k < n; k++) {
          if (componentToClone.value[k][1] == Marker$b.COMMA) {
            componentMultiplexSoFar[_component.name] = k + 1;
            break;
          }

          _component.value.push(componentToClone.value[k]);
        }
      }

      // No we can restore shorthand value
      var lastInMultiplex = i == multiplexSize;
      var _restored = restoreWith(_property, configuration, lastInMultiplex);
      Array.prototype.push.apply(restored, _restored);

      if (i < multiplexSize) { restored.push([Token$k.PROPERTY_VALUE, Marker$b.COMMA]); }
    }

    return restored;
  };
}

function withoutDefaults(property, configuration) {
  var components = property.components;
  var restored = [];

  for (var i = components.length - 1; i >= 0; i--) {
    var component = components[i];
    var descriptor = configuration[component.name];

    if (component.value[0][1] != descriptor.defaultValue || ('keepUnlessDefault' in descriptor) && !isDefault(components, configuration, descriptor.keepUnlessDefault)) {
      restored.unshift(component.value[0]);
    }
  }

  if (restored.length === 0) { restored.push([Token$k.PROPERTY_VALUE, configuration[property.name].defaultValue]); }

  if (isInheritOnly(restored)) { return [restored[0]]; }

  return restored;
}

function isDefault(components, configuration, propertyName) {
  var component;
  var i, l;

  for (i = 0, l = components.length; i < l; i++) {
    component = components[i];

    if (component.name == propertyName && component.value[0][1] == configuration[propertyName].defaultValue) {
      return true;
    }
  }

  return false;
}

var restore$1 = {
  background: background$1,
  borderRadius: borderRadius$1,
  font: font,
  fourValues: fourValues,
  multiplex: multiplex,
  withoutDefaults: withoutDefaults
};

var override$5 = override_1;

var INTEGER_PATTERN = /^\d+$/;

var ALL_UNITS = ['*', 'all'];
var DEFAULT_PRECISION = 'off'; // all precision changes are disabled
var DIRECTIVES_SEPARATOR = ','; // e.g. *=5,px=3
var DIRECTIVE_VALUE_SEPARATOR = '='; // e.g. *=5

function roundingPrecisionFrom$1(source) {
  return override$5(defaults$1(DEFAULT_PRECISION), buildPrecisionFrom(source));
}

function defaults$1(value) {
  return {
    ch: value,
    cm: value,
    em: value,
    ex: value,
    in: value,
    mm: value,
    pc: value,
    pt: value,
    px: value,
    q: value,
    rem: value,
    vh: value,
    vmax: value,
    vmin: value,
    vw: value,
    '%': value
  };
}

function buildPrecisionFrom(source) {
  if (source === null || source === undefined) {
    return {};
  }

  if (typeof source == 'boolean') {
    return {};
  }

  if (typeof source == 'number' && source == -1) {
    return defaults$1(DEFAULT_PRECISION);
  }

  if (typeof source == 'number') {
    return defaults$1(source);
  }

  if (typeof source == 'string' && INTEGER_PATTERN.test(source)) {
    return defaults$1(parseInt(source));
  }

  if (typeof source == 'string' && source == DEFAULT_PRECISION) {
    return defaults$1(DEFAULT_PRECISION);
  }

  if (typeof source == 'object') {
    return source;
  }

  return source
    .split(DIRECTIVES_SEPARATOR)
    .reduce(function(accumulator, directive) {
      var directiveParts = directive.split(DIRECTIVE_VALUE_SEPARATOR);
      var name = directiveParts[0];
      var value = parseInt(directiveParts[1]);

      if (Number.isNaN(value) || value == -1) {
        value = DEFAULT_PRECISION;
      }

      if (ALL_UNITS.indexOf(name) > -1) {
        accumulator = override$5(accumulator, defaults$1(value));
      } else {
        accumulator[name] = value;
      }

      return accumulator;
    }, {});
}

var roundingPrecision = {
  DEFAULT: DEFAULT_PRECISION,
  roundingPrecisionFrom: roundingPrecisionFrom$1
};

var roundingPrecisionFrom = roundingPrecision.roundingPrecisionFrom;

var override$4 = override_1;

var OptimizationLevel$j = {
  Zero: '0',
  One: '1',
  Two: '2'
};

var DEFAULTS$1 = {};

DEFAULTS$1[OptimizationLevel$j.Zero] = {};
DEFAULTS$1[OptimizationLevel$j.One] = {
  cleanupCharsets: true,
  normalizeUrls: true,
  optimizeBackground: true,
  optimizeBorderRadius: true,
  optimizeFilter: true,
  optimizeFontWeight: true,
  optimizeOutline: true,
  removeEmpty: true,
  removeNegativePaddings: true,
  removeQuotes: true,
  removeWhitespace: true,
  replaceMultipleZeros: true,
  replaceTimeUnits: true,
  replaceZeroUnits: true,
  roundingPrecision: roundingPrecisionFrom(undefined),
  selectorsSortingMethod: 'standard',
  specialComments: 'all',
  tidyAtRules: true,
  tidyBlockScopes: true,
  tidySelectors: true,
  variableValueOptimizers: []
};
DEFAULTS$1[OptimizationLevel$j.Two] = {
  mergeAdjacentRules: true,
  mergeIntoShorthands: true,
  mergeMedia: true,
  mergeNonAdjacentRules: true,
  mergeSemantically: false,
  overrideProperties: true,
  removeEmpty: true,
  reduceNonAdjacentRules: true,
  removeDuplicateFontRules: true,
  removeDuplicateMediaBlocks: true,
  removeDuplicateRules: true,
  removeUnusedAtRules: false,
  restructureRules: false,
  skipProperties: []
};

var ALL_KEYWORD_1 = '*';
var ALL_KEYWORD_2 = 'all';
var FALSE_KEYWORD_1 = 'false';
var FALSE_KEYWORD_2 = 'off';
var TRUE_KEYWORD_1 = 'true';
var TRUE_KEYWORD_2 = 'on';

var LIST_VALUE_SEPARATOR = ',';
var OPTION_SEPARATOR = ';';
var OPTION_VALUE_SEPARATOR = ':';

function optimizationLevelFrom$1(source) {
  var level = override$4(DEFAULTS$1, {});
  var Zero = OptimizationLevel$j.Zero;
  var One = OptimizationLevel$j.One;
  var Two = OptimizationLevel$j.Two;

  if (undefined === source) {
    delete level[Two];
    return level;
  }

  if (typeof source == 'string') {
    source = parseInt(source);
  }

  if (typeof source == 'number' && source === parseInt(Two)) {
    return level;
  }

  if (typeof source == 'number' && source === parseInt(One)) {
    delete level[Two];
    return level;
  }

  if (typeof source == 'number' && source === parseInt(Zero)) {
    delete level[Two];
    delete level[One];
    return level;
  }

  if (typeof source == 'object') {
    source = covertValuesToHashes(source);
  }

  if (One in source && 'roundingPrecision' in source[One]) {
    source[One].roundingPrecision = roundingPrecisionFrom(source[One].roundingPrecision);
  }

  if (Two in source && 'skipProperties' in source[Two] && typeof (source[Two].skipProperties) == 'string') {
    source[Two].skipProperties = source[Two].skipProperties.split(LIST_VALUE_SEPARATOR);
  }

  if (Zero in source || One in source || Two in source) {
    level[Zero] = override$4(level[Zero], source[Zero]);
  }

  if (One in source && ALL_KEYWORD_1 in source[One]) {
    level[One] = override$4(level[One], defaults(One, normalizeValue(source[One][ALL_KEYWORD_1])));
    delete source[One][ALL_KEYWORD_1];
  }

  if (One in source && ALL_KEYWORD_2 in source[One]) {
    level[One] = override$4(level[One], defaults(One, normalizeValue(source[One][ALL_KEYWORD_2])));
    delete source[One][ALL_KEYWORD_2];
  }

  if (One in source || Two in source) {
    level[One] = override$4(level[One], source[One]);
  } else {
    delete level[One];
  }

  if (Two in source && ALL_KEYWORD_1 in source[Two]) {
    level[Two] = override$4(level[Two], defaults(Two, normalizeValue(source[Two][ALL_KEYWORD_1])));
    delete source[Two][ALL_KEYWORD_1];
  }

  if (Two in source && ALL_KEYWORD_2 in source[Two]) {
    level[Two] = override$4(level[Two], defaults(Two, normalizeValue(source[Two][ALL_KEYWORD_2])));
    delete source[Two][ALL_KEYWORD_2];
  }

  if (Two in source) {
    level[Two] = override$4(level[Two], source[Two]);
  } else {
    delete level[Two];
  }

  return level;
}

function defaults(level, value) {
  var options = override$4(DEFAULTS$1[level], {});
  var key;

  for (key in options) {
    if (typeof options[key] == 'boolean') {
      options[key] = value;
    }
  }

  return options;
}

function normalizeValue(value) {
  switch (value) {
  case FALSE_KEYWORD_1:
  case FALSE_KEYWORD_2:
    return false;
  case TRUE_KEYWORD_1:
  case TRUE_KEYWORD_2:
    return true;
  default:
    return value;
  }
}

function covertValuesToHashes(source) {
  var clonedSource = override$4(source, {});
  var level;
  var i;

  for (i = 0; i <= 2; i++) {
    level = '' + i;

    if (level in clonedSource && (clonedSource[level] === undefined || clonedSource[level] === false)) {
      delete clonedSource[level];
    }

    if (level in clonedSource && clonedSource[level] === true) {
      clonedSource[level] = {};
    }

    if (level in clonedSource && typeof clonedSource[level] == 'string') {
      clonedSource[level] = covertToHash(clonedSource[level], level);
    }
  }

  return clonedSource;
}

function covertToHash(asString, level) {
  return asString
    .split(OPTION_SEPARATOR)
    .reduce(function(accumulator, directive) {
      var parts = directive.split(OPTION_VALUE_SEPARATOR);
      var name = parts[0];
      var value = parts[1];
      var normalizedValue = normalizeValue(value);

      if (ALL_KEYWORD_1 == name || ALL_KEYWORD_2 == name) {
        accumulator = override$4(accumulator, defaults(level, normalizedValue));
      } else {
        accumulator[name] = normalizedValue;
      }

      return accumulator;
    }, {});
}

var optimizationLevel = {
  OptimizationLevel: OptimizationLevel$j,
  optimizationLevelFrom: optimizationLevelFrom$1
};

var OptimizationLevel$i = optimizationLevel.OptimizationLevel;

var plugin$k = {
  level1: {
    property: function background(_rule, property, options) {
      var values = property.value;

      if (!options.level[OptimizationLevel$i.One].optimizeBackground) {
        return;
      }

      if (values.length == 1 && values[0][1] == 'none') {
        values[0][1] = '0 0';
      }

      if (values.length == 1 && values[0][1] == 'transparent') {
        values[0][1] = '0 0';
      }
    }
  }
};

var background = plugin$k;

var plugin$j = {
  level1: {
    property: function boxShadow(_rule, property) {
      var values = property.value;

      // remove multiple zeros
      if (values.length == 4 && values[0][1] === '0' && values[1][1] === '0' && values[2][1] === '0' && values[3][1] === '0') {
        property.value.splice(2);
        property.dirty = true;
      }
    }
  }
};

var boxShadow = plugin$j;

var OptimizationLevel$h = optimizationLevel.OptimizationLevel;

var plugin$i = {
  level1: {
    property: function borderRadius(_rule, property, options) {
      var values = property.value;

      if (!options.level[OptimizationLevel$h.One].optimizeBorderRadius) {
        return;
      }

      if (values.length == 3 && values[1][1] == '/' && values[0][1] == values[2][1]) {
        property.value.splice(1);
        property.dirty = true;
      } else if (values.length == 5 && values[2][1] == '/' && values[0][1] == values[3][1] && values[1][1] == values[4][1]) {
        property.value.splice(2);
        property.dirty = true;
      } else if (values.length == 7 && values[3][1] == '/' && values[0][1] == values[4][1] && values[1][1] == values[5][1] && values[2][1] == values[6][1]) {
        property.value.splice(3);
        property.dirty = true;
      } else if (values.length == 9 && values[4][1] == '/' && values[0][1] == values[5][1] && values[1][1] == values[6][1] && values[2][1] == values[7][1] && values[3][1] == values[8][1]) {
        property.value.splice(4);
        property.dirty = true;
      }
    }
  }
};

var borderRadius = plugin$i;

var OptimizationLevel$g = optimizationLevel.OptimizationLevel;

var ALPHA_OR_CHROMA_FILTER_PATTERN = /progid:DXImageTransform\.Microsoft\.(Alpha|Chroma)(\W)/;
var NO_SPACE_AFTER_COMMA_PATTERN = /,(\S)/g;
var WHITESPACE_AROUND_EQUALS_PATTERN = / ?= ?/g;

var plugin$h = {
  level1: {
    property: function filter(_rule, property, options) {
      if (!options.compatibility.properties.ieFilters) {
        return;
      }

      if (!options.level[OptimizationLevel$g.One].optimizeFilter) {
        return;
      }

      if (property.value.length == 1) {
        property.value[0][1] = property.value[0][1].replace(
          ALPHA_OR_CHROMA_FILTER_PATTERN,
          function(match, filter, suffix) {
            return filter.toLowerCase() + suffix;
          }
        );
      }

      property.value[0][1] = property.value[0][1]
        .replace(NO_SPACE_AFTER_COMMA_PATTERN, ', $1')
        .replace(WHITESPACE_AROUND_EQUALS_PATTERN, '=');
    }
  }
};

var filter = plugin$h;

var OptimizationLevel$f = optimizationLevel.OptimizationLevel;

var plugin$g = {
  level1: {
    property: function fontWeight(_rule, property, options) {
      var value = property.value[0][1];

      if (!options.level[OptimizationLevel$f.One].optimizeFontWeight) {
        return;
      }

      if (value == 'normal') {
        value = '400';
      } else if (value == 'bold') {
        value = '700';
      }

      property.value[0][1] = value;
    }
  }
};

var fontWeight = plugin$g;

var OptimizationLevel$e = optimizationLevel.OptimizationLevel;

var plugin$f = {
  level1: {
    property: function margin(_rule, property, options) {
      var values = property.value;

      if (!options.level[OptimizationLevel$e.One].replaceMultipleZeros) {
        return;
      }

      // remove multiple zeros
      if (values.length == 4 && values[0][1] === '0' && values[1][1] === '0' && values[2][1] === '0' && values[3][1] === '0') {
        property.value.splice(1);
        property.dirty = true;
      }
    }
  }
};

var margin = plugin$f;

var OptimizationLevel$d = optimizationLevel.OptimizationLevel;

var plugin$e = {
  level1: {
    property: function outline(_rule, property, options) {
      var values = property.value;

      if (!options.level[OptimizationLevel$d.One].optimizeOutline) {
        return;
      }

      if (values.length == 1 && values[0][1] == 'none') {
        values[0][1] = '0';
      }
    }
  }
};

var outline = plugin$e;

var OptimizationLevel$c = optimizationLevel.OptimizationLevel;

function isNegative(value) {
  return value && value[1][0] == '-' && parseFloat(value[1]) < 0;
}

var plugin$d = {
  level1: {
    property: function padding(_rule, property, options) {
      var values = property.value;

      // remove multiple zeros
      if (values.length == 4 && values[0][1] === '0' && values[1][1] === '0' && values[2][1] === '0' && values[3][1] === '0') {
        property.value.splice(1);
        property.dirty = true;
      }

      // remove negative paddings
      if (options.level[OptimizationLevel$c.One].removeNegativePaddings
        && (
          isNegative(property.value[0])
          || isNegative(property.value[1])
          || isNegative(property.value[2])
          || isNegative(property.value[3])
        )) {
        property.unused = true;
      }
    }
  }
};

var padding = plugin$d;

var propertyOptimizers$1 = {
  background: background.level1.property,
  boxShadow: boxShadow.level1.property,
  borderRadius: borderRadius.level1.property,
  filter: filter.level1.property,
  fontWeight: fontWeight.level1.property,
  margin: margin.level1.property,
  outline: outline.level1.property,
  padding: padding.level1.property
};

var COLORS = {
  aliceblue: '#f0f8ff',
  antiquewhite: '#faebd7',
  aqua: '#0ff',
  aquamarine: '#7fffd4',
  azure: '#f0ffff',
  beige: '#f5f5dc',
  bisque: '#ffe4c4',
  black: '#000',
  blanchedalmond: '#ffebcd',
  blue: '#00f',
  blueviolet: '#8a2be2',
  brown: '#a52a2a',
  burlywood: '#deb887',
  cadetblue: '#5f9ea0',
  chartreuse: '#7fff00',
  chocolate: '#d2691e',
  coral: '#ff7f50',
  cornflowerblue: '#6495ed',
  cornsilk: '#fff8dc',
  crimson: '#dc143c',
  cyan: '#0ff',
  darkblue: '#00008b',
  darkcyan: '#008b8b',
  darkgoldenrod: '#b8860b',
  darkgray: '#a9a9a9',
  darkgreen: '#006400',
  darkgrey: '#a9a9a9',
  darkkhaki: '#bdb76b',
  darkmagenta: '#8b008b',
  darkolivegreen: '#556b2f',
  darkorange: '#ff8c00',
  darkorchid: '#9932cc',
  darkred: '#8b0000',
  darksalmon: '#e9967a',
  darkseagreen: '#8fbc8f',
  darkslateblue: '#483d8b',
  darkslategray: '#2f4f4f',
  darkslategrey: '#2f4f4f',
  darkturquoise: '#00ced1',
  darkviolet: '#9400d3',
  deeppink: '#ff1493',
  deepskyblue: '#00bfff',
  dimgray: '#696969',
  dimgrey: '#696969',
  dodgerblue: '#1e90ff',
  firebrick: '#b22222',
  floralwhite: '#fffaf0',
  forestgreen: '#228b22',
  fuchsia: '#f0f',
  gainsboro: '#dcdcdc',
  ghostwhite: '#f8f8ff',
  gold: '#ffd700',
  goldenrod: '#daa520',
  gray: '#808080',
  green: '#008000',
  greenyellow: '#adff2f',
  grey: '#808080',
  honeydew: '#f0fff0',
  hotpink: '#ff69b4',
  indianred: '#cd5c5c',
  indigo: '#4b0082',
  ivory: '#fffff0',
  khaki: '#f0e68c',
  lavender: '#e6e6fa',
  lavenderblush: '#fff0f5',
  lawngreen: '#7cfc00',
  lemonchiffon: '#fffacd',
  lightblue: '#add8e6',
  lightcoral: '#f08080',
  lightcyan: '#e0ffff',
  lightgoldenrodyellow: '#fafad2',
  lightgray: '#d3d3d3',
  lightgreen: '#90ee90',
  lightgrey: '#d3d3d3',
  lightpink: '#ffb6c1',
  lightsalmon: '#ffa07a',
  lightseagreen: '#20b2aa',
  lightskyblue: '#87cefa',
  lightslategray: '#778899',
  lightslategrey: '#778899',
  lightsteelblue: '#b0c4de',
  lightyellow: '#ffffe0',
  lime: '#0f0',
  limegreen: '#32cd32',
  linen: '#faf0e6',
  magenta: '#ff00ff',
  maroon: '#800000',
  mediumaquamarine: '#66cdaa',
  mediumblue: '#0000cd',
  mediumorchid: '#ba55d3',
  mediumpurple: '#9370db',
  mediumseagreen: '#3cb371',
  mediumslateblue: '#7b68ee',
  mediumspringgreen: '#00fa9a',
  mediumturquoise: '#48d1cc',
  mediumvioletred: '#c71585',
  midnightblue: '#191970',
  mintcream: '#f5fffa',
  mistyrose: '#ffe4e1',
  moccasin: '#ffe4b5',
  navajowhite: '#ffdead',
  navy: '#000080',
  oldlace: '#fdf5e6',
  olive: '#808000',
  olivedrab: '#6b8e23',
  orange: '#ffa500',
  orangered: '#ff4500',
  orchid: '#da70d6',
  palegoldenrod: '#eee8aa',
  palegreen: '#98fb98',
  paleturquoise: '#afeeee',
  palevioletred: '#db7093',
  papayawhip: '#ffefd5',
  peachpuff: '#ffdab9',
  peru: '#cd853f',
  pink: '#ffc0cb',
  plum: '#dda0dd',
  powderblue: '#b0e0e6',
  purple: '#800080',
  rebeccapurple: '#663399',
  red: '#f00',
  rosybrown: '#bc8f8f',
  royalblue: '#4169e1',
  saddlebrown: '#8b4513',
  salmon: '#fa8072',
  sandybrown: '#f4a460',
  seagreen: '#2e8b57',
  seashell: '#fff5ee',
  sienna: '#a0522d',
  silver: '#c0c0c0',
  skyblue: '#87ceeb',
  slateblue: '#6a5acd',
  slategray: '#708090',
  slategrey: '#708090',
  snow: '#fffafa',
  springgreen: '#00ff7f',
  steelblue: '#4682b4',
  tan: '#d2b48c',
  teal: '#008080',
  thistle: '#d8bfd8',
  tomato: '#ff6347',
  turquoise: '#40e0d0',
  violet: '#ee82ee',
  wheat: '#f5deb3',
  white: '#fff',
  whitesmoke: '#f5f5f5',
  yellow: '#ff0',
  yellowgreen: '#9acd32'
};

var toHex = {};
var toName = {};

for (var name$1 in COLORS) {
  var hex = COLORS[name$1];

  if (name$1.length < hex.length) {
    toName[hex] = name$1;
  } else {
    toHex[name$1] = hex;
  }
}

var toHexPattern = new RegExp('(^| |,|\\))(' + Object.keys(toHex).join('|') + ')( |,|\\)|$)', 'ig');
var toNamePattern = new RegExp('(' + Object.keys(toName).join('|') + ')([^a-f0-9]|$)', 'ig');

function hexConverter(match, prefix, colorValue, suffix) {
  return prefix + toHex[colorValue.toLowerCase()] + suffix;
}

function nameConverter(match, colorValue, suffix) {
  return toName[colorValue.toLowerCase()] + suffix;
}

function shortenHex$1(value) {
  var hasHex = value.indexOf('#') > -1;
  var shortened = value.replace(toHexPattern, hexConverter);

  if (shortened != value) {
    shortened = shortened.replace(toHexPattern, hexConverter);
  }

  return hasHex
    ? shortened.replace(toNamePattern, nameConverter)
    : shortened;
}

var shortenHex_1 = shortenHex$1;

// HSL to RGB converter. Both methods adapted from:
// http://mjijackson.com/2008/02/rgb-to-hsl-and-rgb-to-hsv-color-model-conversion-algorithms-in-javascript

function hslToRgb(h, s, l) {
  var r, g, b;

  // normalize hue orientation b/w 0 and 360 degrees
  h %= 360;
  if (h < 0) { h += 360; }
  h = ~~h / 360;

  if (s < 0) { s = 0; } else if (s > 100) { s = 100; }
  s = ~~s / 100;

  if (l < 0) { l = 0; } else if (l > 100) { l = 100; }
  l = ~~l / 100;

  if (s === 0) {
    r = g = b = l; // achromatic
  } else {
    var q = l < 0.5
      ? l * (1 + s)
      : l + s - l * s;
    var p = 2 * l - q;
    r = hueToRgb(p, q, h + 1 / 3);
    g = hueToRgb(p, q, h);
    b = hueToRgb(p, q, h - 1 / 3);
  }

  return [~~(r * 255), ~~(g * 255), ~~(b * 255)];
}

function hueToRgb(p, q, t) {
  if (t < 0) { t += 1; }
  if (t > 1) { t -= 1; }
  if (t < 1 / 6) { return p + (q - p) * 6 * t; }
  if (t < 1 / 2) { return q; }
  if (t < 2 / 3) { return p + (q - p) * (2 / 3 - t) * 6; }
  return p;
}

function shortenHsl$1(hue, saturation, lightness) {
  var asRgb = hslToRgb(hue, saturation, lightness);
  var redAsHex = asRgb[0].toString(16);
  var greenAsHex = asRgb[1].toString(16);
  var blueAsHex = asRgb[2].toString(16);

  return '#'
    + ((redAsHex.length == 1 ? '0' : '') + redAsHex)
    + ((greenAsHex.length == 1 ? '0' : '') + greenAsHex)
    + ((blueAsHex.length == 1 ? '0' : '') + blueAsHex);
}

var shortenHsl_1 = shortenHsl$1;

function shortenRgb$1(red, green, blue) {
  var normalizedRed = Math.max(0, Math.min(parseInt(red), 255));
  var normalizedGreen = Math.max(0, Math.min(parseInt(green), 255));
  var normalizedBlue = Math.max(0, Math.min(parseInt(blue), 255));

  // Credit: Asen  http://jsbin.com/UPUmaGOc/2/edit?js,console
  return '#' + ('00000' + (normalizedRed << 16 | normalizedGreen << 8 | normalizedBlue).toString(16)).slice(-6);
}

var shortenRgb_1 = shortenRgb$1;

var Marker$a = marker;

function is$1(value, separator, isSeparatorRegex) {
  return isSeparatorRegex
    ? separator.test(value)
    : value === separator;
}

function split$5(value, separator) {
  var openLevel = Marker$a.OPEN_ROUND_BRACKET;
  var closeLevel = Marker$a.CLOSE_ROUND_BRACKET;
  var level = 0;
  var cursor = 0;
  var lastStart = 0;
  var lastValue;
  var lastCharacter;
  var len = value.length;
  var parts = [];
  var isSeparatorRegex = typeof (separator) == 'object' && 'exec' in separator;

  if (!isSeparatorRegex && value.indexOf(separator) == -1) {
    return [value];
  }

  if (value.indexOf(openLevel) == -1) {
    return value.split(separator);
  }

  while (cursor < len) {
    if (value[cursor] == openLevel) {
      level++;
    } else if (value[cursor] == closeLevel) {
      level--;
    }

    if (level === 0 && cursor > 0 && cursor + 1 < len && is$1(value[cursor], separator, isSeparatorRegex)) {
      parts.push(value.substring(lastStart, cursor));

      if (isSeparatorRegex && separator.exec(value[cursor]).length > 1) {
        parts.push(value[cursor]);
      }

      lastStart = cursor + 1;
    }

    cursor++;
  }

  if (lastStart < cursor + 1) {
    lastValue = value.substring(lastStart);
    lastCharacter = lastValue[lastValue.length - 1];
    if (is$1(lastCharacter, separator, isSeparatorRegex)) {
      lastValue = lastValue.substring(0, lastValue.length - 1);
    }

    parts.push(lastValue);
  }

  return parts;
}

var split_1 = split$5;

var shortenHex = shortenHex_1;
var shortenHsl = shortenHsl_1;
var shortenRgb = shortenRgb_1;

var split$4 = split_1;

var ANY_COLOR_FUNCTION_PATTERN = /(rgb|rgba|hsl|hsla)\(([^()]+)\)/gi;
var COLOR_PREFIX_PATTERN = /#|rgb|hsl/gi;
var HEX_LONG_PATTERN = /(^|[^='"])#([0-9a-f]{6})/gi;
var HEX_SHORT_PATTERN = /(^|[^='"])#([0-9a-f]{3})/gi;
var HEX_VALUE_PATTERN = /[0-9a-f]/i;
var HSL_PATTERN = /hsl\((-?\d+),(-?\d+)%?,(-?\d+)%?\)/gi;
var RGBA_HSLA_PATTERN = /(rgb|hsl)a?\((-?\d+),(-?\d+%?),(-?\d+%?),(0*[1-9]+[0-9]*(\.?\d*)?)\)/gi;
var RGB_PATTERN = /rgb\((-?\d+),(-?\d+),(-?\d+)\)/gi;
var TRANSPARENT_FUNCTION_PATTERN = /(?:rgba|hsla)\(0,0%?,0%?,0\)/g;

var plugin$c = {
  level1: {
    value: function color(name, value, options) {
      if (!options.compatibility.properties.colors) {
        return value;
      }

      if (!value.match(COLOR_PREFIX_PATTERN)) {
        return shortenHex(value);
      }

      value = value
        .replace(RGBA_HSLA_PATTERN, function(match, colorFn, p1, p2, p3, alpha) {
          return (parseInt(alpha) >= 1 ? colorFn + '(' + [p1, p2, p3].join(',') + ')' : match);
        })
        .replace(RGB_PATTERN, function(match, red, green, blue) {
          return shortenRgb(red, green, blue);
        })
        .replace(HSL_PATTERN, function(match, hue, saturation, lightness) {
          return shortenHsl(hue, saturation, lightness);
        })
        .replace(HEX_LONG_PATTERN, function(match, prefix, color, at, inputValue) {
          var suffix = inputValue[at + match.length];

          if (suffix && HEX_VALUE_PATTERN.test(suffix)) {
            return match;
          } if (color[0] == color[1] && color[2] == color[3] && color[4] == color[5]) {
            return (prefix + '#' + color[0] + color[2] + color[4]).toLowerCase();
          }
          return (prefix + '#' + color).toLowerCase();
        })
        .replace(HEX_SHORT_PATTERN, function(match, prefix, color) {
          return prefix + '#' + color.toLowerCase();
        })
        .replace(ANY_COLOR_FUNCTION_PATTERN, function(match, colorFunction, colorDef) {
          var tokens = colorDef.split(',');
          var colorFnLowercase = colorFunction && colorFunction.toLowerCase();
          var applies = (colorFnLowercase == 'hsl' && tokens.length == 3)
            || (colorFnLowercase == 'hsla' && tokens.length == 4)
            || (colorFnLowercase == 'rgb' && tokens.length === 3 && colorDef.indexOf('%') > 0)
            || (colorFnLowercase == 'rgba' && tokens.length == 4 && tokens[0].indexOf('%') > 0);

          if (!applies) {
            return match;
          }

          if (tokens[1].indexOf('%') == -1) {
            tokens[1] += '%';
          }

          if (tokens[2].indexOf('%') == -1) {
            tokens[2] += '%';
          }

          return colorFunction + '(' + tokens.join(',') + ')';
        });

      if (options.compatibility.colors.opacity && name.indexOf('background') == -1) {
        value = value.replace(TRANSPARENT_FUNCTION_PATTERN, function(match) {
          if (split$4(value, ',').pop().indexOf('gradient(') > -1) {
            return match;
          }

          return 'transparent';
        });
      }

      return shortenHex(value);
    }
  }
};

var color = plugin$c;

var ZERO_DEG_PATTERN = /\(0deg\)/g;

var plugin$b = {
  level1: {
    value: function degrees(_name, value, options) {
      if (!options.compatibility.properties.zeroUnits) {
        return value;
      }

      if (value.indexOf('0deg') == -1) {
        return value;
      }

      return value.replace(ZERO_DEG_PATTERN, '(0)');
    }
  }
};

var degrees = plugin$b;

var URL_PREFIX_PATTERN$4 = /^url\(/i;

function startsAsUrl$4(value) {
  return URL_PREFIX_PATTERN$4.test(value);
}

var startsAsUrl_1 = startsAsUrl$4;

var split$3 = split_1;
var startsAsUrl$3 = startsAsUrl_1;

var OptimizationLevel$b = optimizationLevel.OptimizationLevel;

var EXPRESSION_PATTERN = /^expression\(.*\)$/;
var ANY_FUNCTION_PATTERN$1 = /^(-(?:moz|ms|o|webkit)-[a-z-]+|[a-z-]+)\((.+)\)$/;
var TOKEN_SEPARATOR_PATTERN$1 = /([\s,/])/;

var DOT_ZERO_PATTERN = /(^|\D)\.0+(\D|$)/g;
var FRACTION_PATTERN = /\.([1-9]*)0+(\D|$)/g;
var LEADING_ZERO_FRACTION_PATTERN = /(^|\D)0\.(\d)/g;
var MINUS_ZERO_FRACTION_PATTERN = /([^\w\d-]|^)-0([^.]|$)/g;
var ZERO_PREFIXED_UNIT_PATTERN = /(^|\s)0+([1-9])/g;

function optimizeRecursively(value) {
  var functionTokens;
  var tokens;

  if (startsAsUrl$3(value)) {
    return value;
  }

  if (EXPRESSION_PATTERN.test(value)) {
    return value;
  }

  functionTokens = ANY_FUNCTION_PATTERN$1.exec(value);

  if (!functionTokens) {
    return optimizeFractions(value);
  }

  tokens = split$3(functionTokens[2], TOKEN_SEPARATOR_PATTERN$1)
    .map(function(token) { return optimizeRecursively(token); });

  return functionTokens[1] + '(' + tokens.join('') + ')';
}

function optimizeFractions(value) {
  if (value.indexOf('0') == -1) {
    return value;
  }

  if (value.indexOf('-') > -1) {
    value = value
      .replace(MINUS_ZERO_FRACTION_PATTERN, '$10$2')
      .replace(MINUS_ZERO_FRACTION_PATTERN, '$10$2');
  }

  return value
    .replace(ZERO_PREFIXED_UNIT_PATTERN, '$1$2')
    .replace(DOT_ZERO_PATTERN, '$10$2')
    .replace(FRACTION_PATTERN, function(match, nonZeroPart, suffix) {
      return (nonZeroPart.length > 0 ? '.' : '') + nonZeroPart + suffix;
    })
    .replace(LEADING_ZERO_FRACTION_PATTERN, '$1.$2');
}

var plugin$a = {
  level1: {
    value: function fraction(name, value, options) {
      if (!options.level[OptimizationLevel$b.One].replaceZeroUnits) {
        return value;
      }

      return optimizeRecursively(value);
    }
  }
};

var fraction = plugin$a;

var plugin$9 = {
  level1: {
    value: function precision(_name, value, options) {
      if (!options.precision.enabled || value.indexOf('.') === -1) {
        return value;
      }

      return value
        .replace(options.precision.decimalPointMatcher, '$1$2$3')
        .replace(options.precision.zeroMatcher, function(match, integerPart, fractionPart, unit) {
          var multiplier = options.precision.units[unit].multiplier;
          var parsedInteger = parseInt(integerPart);
          var integer = Number.isNaN(parsedInteger) ? 0 : parsedInteger;
          var fraction = parseFloat(fractionPart);

          return Math.round((integer + fraction) * multiplier) / multiplier + unit;
        });
    }
  }
};

var precision = plugin$9;

var OptimizationLevel$a = optimizationLevel.OptimizationLevel;

var LOCAL_PREFIX_PATTERN = /^local\(/i;
var QUOTED_PATTERN = /^('.*'|".*")$/;
var QUOTED_BUT_SAFE_PATTERN = /^['"][a-zA-Z][a-zA-Z\d\-_]+['"]$/;
// eslint-disable-next-line max-len
var GENERIC_FONT_FAMILY_PATTERN = /^['"](?:cursive|default|emoji|fangsong|fantasy|inherit|initial|math|monospace|revert|revert-layer|sans-serif|serif|system-ui|ui-monospace|ui-rounded|ui-sans-serif|ui-serif|unset)['"]$/;

var plugin$8 = {
  level1: {
    value: function textQuotes(name, value, options) {
      if ((name == 'font-family' || name == 'font') && GENERIC_FONT_FAMILY_PATTERN.test(value)) {
        return value;
      }

      if (!options.level[OptimizationLevel$a.One].removeQuotes) {
        return value;
      }

      if (!QUOTED_PATTERN.test(value) && !LOCAL_PREFIX_PATTERN.test(value)) {
        return value;
      }

      return QUOTED_BUT_SAFE_PATTERN.test(value)
        ? value.substring(1, value.length - 1)
        : value;
    }
  }
};

var textQuotes = plugin$8;

var OptimizationLevel$9 = optimizationLevel.OptimizationLevel;

var TIME_VALUE = /^(-?[\d.]+)(m?s)$/;

var plugin$7 = {
  level1: {
    value: function time(name, value, options) {
      if (!options.level[OptimizationLevel$9.One].replaceTimeUnits) {
        return value;
      }

      if (!TIME_VALUE.test(value)) {
        return value;
      }

      return value.replace(TIME_VALUE, function(match, val, unit) {
        var newValue;

        if (unit == 'ms') {
          newValue = parseInt(val) / 1000 + 's';
        } else if (unit == 's') {
          newValue = parseFloat(val) * 1000 + 'ms';
        }

        return newValue.length < match.length ? newValue : match;
      });
    }
  }
};

var time = plugin$7;

var WHOLE_PIXEL_VALUE = /(?:^|\s|\()(-?\d+)px/;

var plugin$6 = {
  level1: {
    value: function unit(_name, value, options) {
      if (!WHOLE_PIXEL_VALUE.test(value)) {
        return value;
      }

      return value.replace(WHOLE_PIXEL_VALUE, function(match, val) {
        var newValue;
        var intVal = parseInt(val);

        if (intVal === 0) {
          return match;
        }

        if (options.compatibility.properties.shorterLengthUnits
          && options.compatibility.units.pt
          && intVal * 3 % 4 === 0) {
          newValue = intVal * 3 / 4 + 'pt';
        }

        if (options.compatibility.properties.shorterLengthUnits
          && options.compatibility.units.pc
          && intVal % 16 === 0) {
          newValue = intVal / 16 + 'pc';
        }

        if (options.compatibility.properties.shorterLengthUnits
          && options.compatibility.units.in
          && intVal % 96 === 0) {
          newValue = intVal / 96 + 'in';
        }

        if (newValue) {
          newValue = match.substring(0, match.indexOf(val)) + newValue;
        }

        return newValue && newValue.length < match.length ? newValue : match;
      });
    }
  }
};

var unit = plugin$6;

var startsAsUrl$2 = startsAsUrl_1;

var OptimizationLevel$8 = optimizationLevel.OptimizationLevel;

var URL_PREFIX_PATTERN$3 = /^url\(/i;

var plugin$5 = {
  level1: {
    value: function urlPrefix(_name, value, options) {
      if (!options.level[OptimizationLevel$8.One].normalizeUrls) {
        return value;
      }

      if (!startsAsUrl$2(value)) {
        return value;
      }

      return value.replace(URL_PREFIX_PATTERN$3, 'url(');
    }
  }
};

var urlPrefix = plugin$5;

var QUOTED_URL_PATTERN = /^url\(['"].+['"]\)$/;
var QUOTED_URL_WITH_WHITESPACE_PATTERN = /^url\(['"].*[*\s()'"].*['"]\)$/;
var QUOTES_PATTERN = /["']/g;
var URL_DATA_PATTERN = /^url\(['"]data:[^;]+;charset/;

var plugin$4 = {
  level1: {
    value: function urlQuotes(_name, value, options) {
      if (options.compatibility.properties.urlQuotes) {
        return value;
      }

      return QUOTED_URL_PATTERN.test(value)
        && !QUOTED_URL_WITH_WHITESPACE_PATTERN.test(value)
        && !URL_DATA_PATTERN.test(value)
        ? value.replace(QUOTES_PATTERN, '')
        : value;
    }
  }
};

var urlQuotes = plugin$4;

var startsAsUrl$1 = startsAsUrl_1;

var WHITESPACE_PATTERN$1 = /\\?\n|\\?\r\n/g;
var WHITESPACE_PREFIX_PATTERN = /(\()\s+/g;
var WHITESPACE_SUFFIX_PATTERN = /\s+(\))/g;

var plugin$3 = {
  level1: {
    value: function urlWhitespace(_name, value) {
      if (!startsAsUrl$1(value)) {
        return value;
      }

      return value
        .replace(WHITESPACE_PATTERN$1, '')
        .replace(WHITESPACE_PREFIX_PATTERN, '$1')
        .replace(WHITESPACE_SUFFIX_PATTERN, '$1');
    }
  }
};

var urlWhitespace = plugin$3;

var OptimizationLevel$7 = optimizationLevel.OptimizationLevel;

var Marker$9 = marker;

var CALC_DIVISION_WHITESPACE_PATTERN = /\) ?\/ ?/g;
var COMMA_AND_SPACE_PATTERN = /, /g;
var LINE_BREAK_PATTERN = /\r?\n/g;
var MULTI_WHITESPACE_PATTERN = /\s+/g;
var FUNCTION_CLOSING_BRACE_WHITESPACE_PATTERN = /\s+(;?\))/g;
var FUNCTION_OPENING_BRACE_WHITESPACE_PATTERN = /(\(;?)\s+/g;
var VARIABLE_NAME_PATTERN = /^--\S+$/;
var VARIABLE_VALUE_PATTERN = /^var\(\s*--\S+\s*\)$/;

var plugin$2 = {
  level1: {
    value: function whitespace(name, value, options) {
      if (!options.level[OptimizationLevel$7.One].removeWhitespace) {
        return value;
      }

      if (VARIABLE_NAME_PATTERN.test(name) && !VARIABLE_VALUE_PATTERN.test(value)) {
        return value;
      }

      if ((value.indexOf(' ') == -1 && value.indexOf('\n') == -1) || value.indexOf('expression') === 0) {
        return value;
      }

      if (value.indexOf(Marker$9.SINGLE_QUOTE) > -1 || value.indexOf(Marker$9.DOUBLE_QUOTE) > -1) {
        return value;
      }

      value = value.replace(LINE_BREAK_PATTERN, '');
      value = value.replace(MULTI_WHITESPACE_PATTERN, ' ');

      if (value.indexOf('calc') > -1) {
        value = value.replace(CALC_DIVISION_WHITESPACE_PATTERN, ')/ ');
      }

      return value
        .replace(FUNCTION_OPENING_BRACE_WHITESPACE_PATTERN, '$1')
        .replace(FUNCTION_CLOSING_BRACE_WHITESPACE_PATTERN, '$1')
        .replace(COMMA_AND_SPACE_PATTERN, ',');
    }
  }
};

var whitespace$1 = plugin$2;

var split$2 = split_1;

var ANY_FUNCTION_PATTERN = /^(-(?:moz|ms|o|webkit)-[a-z-]+|[a-z-]+)\((.+)\)$/;
var SKIP_FUNCTION_PATTERN = /^(?:-moz-calc|-webkit-calc|calc|rgb|hsl|rgba|hsla|min|max|clamp|expression)\(/;
var TOKEN_SEPARATOR_PATTERN = /([\s,/])/;

function removeRecursively(value, options) {
  var functionTokens;
  var tokens;

  if (SKIP_FUNCTION_PATTERN.test(value)) {
    return value;
  }

  functionTokens = ANY_FUNCTION_PATTERN.exec(value);

  if (!functionTokens) {
    return removeZeros(value, options);
  }

  tokens = split$2(functionTokens[2], TOKEN_SEPARATOR_PATTERN)
    .map(function(token) { return removeRecursively(token, options); });

  return functionTokens[1] + '(' + tokens.join('') + ')';
}

function removeZeros(value, options) {
  return value
    .replace(options.unitsRegexp, '$10$2')
    .replace(options.unitsRegexp, '$10$2');
}

var plugin$1 = {
  level1: {
    value: function zero(name, value, options) {
      if (!options.compatibility.properties.zeroUnits) {
        return value;
      }

      if (value.indexOf('%') > 0 && (name == 'height' || name == 'max-height' || name == 'width' || name == 'max-width')) {
        return value;
      }

      return removeRecursively(value, options);
    }
  }
};

var zero = plugin$1;

var valueOptimizers$1 = {
  color: color.level1.value,
  degrees: degrees.level1.value,
  fraction: fraction.level1.value,
  precision: precision.level1.value,
  textQuotes: textQuotes.level1.value,
  time: time.level1.value,
  unit: unit.level1.value,
  urlPrefix: urlPrefix.level1.value,
  urlQuotes: urlQuotes.level1.value,
  urlWhiteSpace: urlWhitespace.level1.value,
  whiteSpace: whitespace$1.level1.value,
  zero: zero.level1.value
};

// Contains the interpretation of CSS properties, as used by the property optimizer

var breakUp = breakUp$1;
var canOverride = canOverride$1;
var restore = restore$1;

var propertyOptimizers = propertyOptimizers$1;
var valueOptimizers = valueOptimizers$1;

var override$3 = override_1;

// Properties to process
// Extend this object in order to add support for more properties in the optimizer.
//
// Each key in this object represents a CSS property and should be an object.
// Such an object contains properties that describe how the represented CSS property should be handled.
// Possible options:
//
// * components: array (Only specify for shorthand properties.)
//   Contains the names of the granular properties this shorthand compacts.
//
// * canOverride: function
//   Returns whether two tokens of this property can be merged with each other.
//   This property has no meaning for shorthands.
//
// * defaultValue: string
//   Specifies the default value of the property according to the CSS standard.
//   For shorthand, this is used when every component is set to its default value, therefore it should be the shortest possible default value of all the components.
//
// * shortestValue: string
//   Specifies the shortest possible value the property can possibly have.
//   (Falls back to defaultValue if unspecified.)
//
// * breakUp: function (Only specify for shorthand properties.)
//   Breaks the shorthand up to its components.
//
// * restore: function (Only specify for shorthand properties.)
//   Puts the shorthand together from its components.
//
var configuration$9 = {
  animation: {
    canOverride: canOverride.generic.components([
      canOverride.generic.time,
      canOverride.generic.timingFunction,
      canOverride.generic.time,
      canOverride.property.animationIterationCount,
      canOverride.property.animationDirection,
      canOverride.property.animationFillMode,
      canOverride.property.animationPlayState,
      canOverride.property.animationName
    ]),
    components: [
      'animation-duration',
      'animation-timing-function',
      'animation-delay',
      'animation-iteration-count',
      'animation-direction',
      'animation-fill-mode',
      'animation-play-state',
      'animation-name'
    ],
    breakUp: breakUp.multiplex(breakUp.animation),
    defaultValue: 'none',
    restore: restore.multiplex(restore.withoutDefaults),
    shorthand: true,
    valueOptimizers: [
      valueOptimizers.whiteSpace,
      valueOptimizers.textQuotes,
      valueOptimizers.time,
      valueOptimizers.fraction,
      valueOptimizers.precision,
      valueOptimizers.unit,
      valueOptimizers.zero
    ],
    vendorPrefixes: [
      '-moz-',
      '-o-',
      '-webkit-'
    ]
  },
  'animation-delay': {
    canOverride: canOverride.generic.time,
    componentOf: [
      'animation'
    ],
    defaultValue: '0s',
    intoMultiplexMode: 'real',
    valueOptimizers: [
      valueOptimizers.time,
      valueOptimizers.fraction,
      valueOptimizers.precision,
      valueOptimizers.unit,
      valueOptimizers.zero
    ],
    vendorPrefixes: [
      '-moz-',
      '-o-',
      '-webkit-'
    ]
  },
  'animation-direction': {
    canOverride: canOverride.property.animationDirection,
    componentOf: [
      'animation'
    ],
    defaultValue: 'normal',
    intoMultiplexMode: 'real',
    vendorPrefixes: [
      '-moz-',
      '-o-',
      '-webkit-'
    ]
  },
  'animation-duration': {
    canOverride: canOverride.generic.time,
    componentOf: [
      'animation'
    ],
    defaultValue: '0s',
    intoMultiplexMode: 'real',
    keepUnlessDefault: 'animation-delay',
    valueOptimizers: [
      valueOptimizers.time,
      valueOptimizers.fraction,
      valueOptimizers.precision,
      valueOptimizers.unit,
      valueOptimizers.zero
    ],
    vendorPrefixes: [
      '-moz-',
      '-o-',
      '-webkit-'
    ]
  },
  'animation-fill-mode': {
    canOverride: canOverride.property.animationFillMode,
    componentOf: [
      'animation'
    ],
    defaultValue: 'none',
    intoMultiplexMode: 'real',
    vendorPrefixes: [
      '-moz-',
      '-o-',
      '-webkit-'
    ]
  },
  'animation-iteration-count': {
    canOverride: canOverride.property.animationIterationCount,
    componentOf: [
      'animation'
    ],
    defaultValue: '1',
    intoMultiplexMode: 'real',
    vendorPrefixes: [
      '-moz-',
      '-o-',
      '-webkit-'
    ]
  },
  'animation-name': {
    canOverride: canOverride.property.animationName,
    componentOf: [
      'animation'
    ],
    defaultValue: 'none',
    intoMultiplexMode: 'real',
    valueOptimizers: [
      valueOptimizers.textQuotes
    ],
    vendorPrefixes: [
      '-moz-',
      '-o-',
      '-webkit-'
    ]
  },
  'animation-play-state': {
    canOverride: canOverride.property.animationPlayState,
    componentOf: [
      'animation'
    ],
    defaultValue: 'running',
    intoMultiplexMode: 'real',
    vendorPrefixes: [
      '-moz-',
      '-o-',
      '-webkit-'
    ]
  },
  'animation-timing-function': {
    canOverride: canOverride.generic.timingFunction,
    componentOf: [
      'animation'
    ],
    defaultValue: 'ease',
    intoMultiplexMode: 'real',
    vendorPrefixes: [
      '-moz-',
      '-o-',
      '-webkit-'
    ]
  },
  background: {
    canOverride: canOverride.generic.components([
      canOverride.generic.image,
      canOverride.property.backgroundPosition,
      canOverride.property.backgroundSize,
      canOverride.property.backgroundRepeat,
      canOverride.property.backgroundAttachment,
      canOverride.property.backgroundOrigin,
      canOverride.property.backgroundClip,
      canOverride.generic.color
    ]),
    components: [
      'background-image',
      'background-position',
      'background-size',
      'background-repeat',
      'background-attachment',
      'background-origin',
      'background-clip',
      'background-color'
    ],
    breakUp: breakUp.multiplex(breakUp.background),
    defaultValue: '0 0',
    propertyOptimizer: propertyOptimizers.background,
    restore: restore.multiplex(restore.background),
    shortestValue: '0',
    shorthand: true,
    valueOptimizers: [
      valueOptimizers.whiteSpace,
      valueOptimizers.urlWhiteSpace,
      valueOptimizers.fraction,
      valueOptimizers.zero,
      valueOptimizers.color,
      valueOptimizers.urlPrefix,
      valueOptimizers.urlQuotes
    ]
  },
  'background-attachment': {
    canOverride: canOverride.property.backgroundAttachment,
    componentOf: [
      'background'
    ],
    defaultValue: 'scroll',
    intoMultiplexMode: 'real'
  },
  'background-clip': {
    canOverride: canOverride.property.backgroundClip,
    componentOf: [
      'background'
    ],
    defaultValue: 'border-box',
    intoMultiplexMode: 'real',
    shortestValue: 'border-box'
  },
  'background-color': {
    canOverride: canOverride.generic.color,
    componentOf: [
      'background'
    ],
    defaultValue: 'transparent',
    intoMultiplexMode: 'real', // otherwise real color will turn into default since color appears in last multiplex only
    multiplexLastOnly: true,
    nonMergeableValue: 'none',
    shortestValue: 'red',
    valueOptimizers: [
      valueOptimizers.whiteSpace,
      valueOptimizers.fraction,
      valueOptimizers.color
    ]
  },
  'background-image': {
    canOverride: canOverride.generic.image,
    componentOf: [
      'background'
    ],
    defaultValue: 'none',
    intoMultiplexMode: 'default',
    valueOptimizers: [
      valueOptimizers.urlWhiteSpace,
      valueOptimizers.urlPrefix,
      valueOptimizers.urlQuotes,
      valueOptimizers.whiteSpace,
      valueOptimizers.fraction,
      valueOptimizers.precision,
      valueOptimizers.unit,
      valueOptimizers.zero,
      valueOptimizers.color
    ]
  },
  'background-origin': {
    canOverride: canOverride.property.backgroundOrigin,
    componentOf: [
      'background'
    ],
    defaultValue: 'padding-box',
    intoMultiplexMode: 'real',
    shortestValue: 'border-box'
  },
  'background-position': {
    canOverride: canOverride.property.backgroundPosition,
    componentOf: [
      'background'
    ],
    defaultValue: ['0', '0'],
    doubleValues: true,
    intoMultiplexMode: 'real',
    shortestValue: '0',
    valueOptimizers: [
      valueOptimizers.whiteSpace,
      valueOptimizers.fraction,
      valueOptimizers.precision,
      valueOptimizers.unit,
      valueOptimizers.zero
    ]
  },
  'background-repeat': {
    canOverride: canOverride.property.backgroundRepeat,
    componentOf: [
      'background'
    ],
    defaultValue: ['repeat'],
    doubleValues: true,
    intoMultiplexMode: 'real'
  },
  'background-size': {
    canOverride: canOverride.property.backgroundSize,
    componentOf: [
      'background'
    ],
    defaultValue: ['auto'],
    doubleValues: true,
    intoMultiplexMode: 'real',
    shortestValue: '0 0',
    valueOptimizers: [
      valueOptimizers.whiteSpace,
      valueOptimizers.fraction,
      valueOptimizers.precision,
      valueOptimizers.unit,
      valueOptimizers.zero
    ]
  },
  bottom: {
    canOverride: canOverride.property.bottom,
    defaultValue: 'auto',
    valueOptimizers: [
      valueOptimizers.whiteSpace,
      valueOptimizers.fraction,
      valueOptimizers.precision,
      valueOptimizers.unit,
      valueOptimizers.zero
    ]
  },
  border: {
    breakUp: breakUp.border,
    canOverride: canOverride.generic.components([
      canOverride.generic.unit,
      canOverride.property.borderStyle,
      canOverride.generic.color
    ]),
    components: [
      'border-width',
      'border-style',
      'border-color'
    ],
    defaultValue: 'none',
    overridesShorthands: [
      'border-bottom',
      'border-left',
      'border-right',
      'border-top'
    ],
    restore: restore.withoutDefaults,
    shorthand: true,
    shorthandComponents: true,
    valueOptimizers: [
      valueOptimizers.whiteSpace,
      valueOptimizers.fraction,
      valueOptimizers.zero,
      valueOptimizers.color
    ]
  },
  'border-bottom': {
    breakUp: breakUp.border,
    canOverride: canOverride.generic.components([
      canOverride.generic.unit,
      canOverride.property.borderStyle,
      canOverride.generic.color
    ]),
    components: [
      'border-bottom-width',
      'border-bottom-style',
      'border-bottom-color'
    ],
    defaultValue: 'none',
    restore: restore.withoutDefaults,
    shorthand: true,
    valueOptimizers: [
      valueOptimizers.whiteSpace,
      valueOptimizers.fraction,
      valueOptimizers.zero,
      valueOptimizers.color
    ]
  },
  'border-bottom-color': {
    canOverride: canOverride.generic.color,
    componentOf: [
      'border-bottom',
      'border-color'
    ],
    defaultValue: 'none',
    valueOptimizers: [
      valueOptimizers.whiteSpace,
      valueOptimizers.fraction,
      valueOptimizers.color
    ]
  },
  'border-bottom-left-radius': {
    canOverride: canOverride.generic.unit,
    componentOf: [
      'border-radius'
    ],
    defaultValue: '0',
    propertyOptimizer: propertyOptimizers.borderRadius,
    valueOptimizers: [
      valueOptimizers.whiteSpace,
      valueOptimizers.fraction,
      valueOptimizers.precision,
      valueOptimizers.unit,
      valueOptimizers.zero
    ],
    vendorPrefixes: [
      '-moz-',
      '-o-'
    ]
  },
  'border-bottom-right-radius': {
    canOverride: canOverride.generic.unit,
    componentOf: [
      'border-radius'
    ],
    defaultValue: '0',
    propertyOptimizer: propertyOptimizers.borderRadius,
    valueOptimizers: [
      valueOptimizers.whiteSpace,
      valueOptimizers.fraction,
      valueOptimizers.precision,
      valueOptimizers.unit,
      valueOptimizers.zero
    ],
    vendorPrefixes: [
      '-moz-',
      '-o-'
    ]
  },
  'border-bottom-style': {
    canOverride: canOverride.property.borderStyle,
    componentOf: [
      'border-bottom',
      'border-style'
    ],
    defaultValue: 'none'
  },
  'border-bottom-width': {
    canOverride: canOverride.generic.unit,
    componentOf: [
      'border-bottom',
      'border-width'
    ],
    defaultValue: 'medium',
    oppositeTo: 'border-top-width',
    shortestValue: '0',
    valueOptimizers: [
      valueOptimizers.whiteSpace,
      valueOptimizers.fraction,
      valueOptimizers.precision,
      valueOptimizers.unit,
      valueOptimizers.zero
    ]
  },
  'border-collapse': {
    canOverride: canOverride.property.borderCollapse,
    defaultValue: 'separate'
  },
  'border-color': {
    breakUp: breakUp.fourValues,
    canOverride: canOverride.generic.components([
      canOverride.generic.color,
      canOverride.generic.color,
      canOverride.generic.color,
      canOverride.generic.color
    ]),
    componentOf: [
      'border'
    ],
    components: [
      'border-top-color',
      'border-right-color',
      'border-bottom-color',
      'border-left-color'
    ],
    defaultValue: 'none',
    restore: restore.fourValues,
    shortestValue: 'red',
    shorthand: true,
    singleTypeComponents: true,
    valueOptimizers: [
      valueOptimizers.whiteSpace,
      valueOptimizers.fraction,
      valueOptimizers.color
    ]
  },
  'border-left': {
    breakUp: breakUp.border,
    canOverride: canOverride.generic.components([
      canOverride.generic.unit,
      canOverride.property.borderStyle,
      canOverride.generic.color
    ]),
    components: [
      'border-left-width',
      'border-left-style',
      'border-left-color'
    ],
    defaultValue: 'none',
    restore: restore.withoutDefaults,
    shorthand: true,
    valueOptimizers: [
      valueOptimizers.whiteSpace,
      valueOptimizers.fraction,
      valueOptimizers.zero,
      valueOptimizers.color
    ]
  },
  'border-left-color': {
    canOverride: canOverride.generic.color,
    componentOf: [
      'border-color',
      'border-left'
    ],
    defaultValue: 'none',
    valueOptimizers: [
      valueOptimizers.whiteSpace,
      valueOptimizers.fraction,
      valueOptimizers.color
    ]
  },
  'border-left-style': {
    canOverride: canOverride.property.borderStyle,
    componentOf: [
      'border-left',
      'border-style'
    ],
    defaultValue: 'none'
  },
  'border-left-width': {
    canOverride: canOverride.generic.unit,
    componentOf: [
      'border-left',
      'border-width'
    ],
    defaultValue: 'medium',
    oppositeTo: 'border-right-width',
    shortestValue: '0',
    valueOptimizers: [
      valueOptimizers.whiteSpace,
      valueOptimizers.fraction,
      valueOptimizers.precision,
      valueOptimizers.unit,
      valueOptimizers.zero
    ]
  },
  'border-radius': {
    breakUp: breakUp.borderRadius,
    canOverride: canOverride.generic.components([
      canOverride.generic.unit,
      canOverride.generic.unit,
      canOverride.generic.unit,
      canOverride.generic.unit
    ]),
    components: [
      'border-top-left-radius',
      'border-top-right-radius',
      'border-bottom-right-radius',
      'border-bottom-left-radius'
    ],
    defaultValue: '0',
    propertyOptimizer: propertyOptimizers.borderRadius,
    restore: restore.borderRadius,
    shorthand: true,
    valueOptimizers: [
      valueOptimizers.whiteSpace,
      valueOptimizers.fraction,
      valueOptimizers.precision,
      valueOptimizers.unit,
      valueOptimizers.zero
    ],
    vendorPrefixes: [
      '-moz-',
      '-o-'
    ]
  },
  'border-right': {
    breakUp: breakUp.border,
    canOverride: canOverride.generic.components([
      canOverride.generic.unit,
      canOverride.property.borderStyle,
      canOverride.generic.color
    ]),
    components: [
      'border-right-width',
      'border-right-style',
      'border-right-color'
    ],
    defaultValue: 'none',
    restore: restore.withoutDefaults,
    shorthand: true,
    valueOptimizers: [
      valueOptimizers.whiteSpace,
      valueOptimizers.fraction,
      valueOptimizers.color
    ]
  },
  'border-right-color': {
    canOverride: canOverride.generic.color,
    componentOf: [
      'border-color',
      'border-right'
    ],
    defaultValue: 'none',
    valueOptimizers: [
      valueOptimizers.whiteSpace,
      valueOptimizers.fraction,
      valueOptimizers.color
    ]
  },
  'border-right-style': {
    canOverride: canOverride.property.borderStyle,
    componentOf: [
      'border-right',
      'border-style'
    ],
    defaultValue: 'none'
  },
  'border-right-width': {
    canOverride: canOverride.generic.unit,
    componentOf: [
      'border-right',
      'border-width'
    ],
    defaultValue: 'medium',
    oppositeTo: 'border-left-width',
    shortestValue: '0',
    valueOptimizers: [
      valueOptimizers.whiteSpace,
      valueOptimizers.fraction,
      valueOptimizers.precision,
      valueOptimizers.unit,
      valueOptimizers.zero
    ]
  },
  'border-style': {
    breakUp: breakUp.fourValues,
    canOverride: canOverride.generic.components([
      canOverride.property.borderStyle,
      canOverride.property.borderStyle,
      canOverride.property.borderStyle,
      canOverride.property.borderStyle
    ]),
    componentOf: [
      'border'
    ],
    components: [
      'border-top-style',
      'border-right-style',
      'border-bottom-style',
      'border-left-style'
    ],
    defaultValue: 'none',
    restore: restore.fourValues,
    shorthand: true,
    singleTypeComponents: true
  },
  'border-top': {
    breakUp: breakUp.border,
    canOverride: canOverride.generic.components([
      canOverride.generic.unit,
      canOverride.property.borderStyle,
      canOverride.generic.color
    ]),
    components: [
      'border-top-width',
      'border-top-style',
      'border-top-color'
    ],
    defaultValue: 'none',
    restore: restore.withoutDefaults,
    shorthand: true,
    valueOptimizers: [
      valueOptimizers.whiteSpace,
      valueOptimizers.fraction,
      valueOptimizers.precision,
      valueOptimizers.zero,
      valueOptimizers.color,
      valueOptimizers.unit
    ]
  },
  'border-top-color': {
    canOverride: canOverride.generic.color,
    componentOf: [
      'border-color',
      'border-top'
    ],
    defaultValue: 'none',
    valueOptimizers: [
      valueOptimizers.whiteSpace,
      valueOptimizers.fraction,
      valueOptimizers.color
    ]
  },
  'border-top-left-radius': {
    canOverride: canOverride.generic.unit,
    componentOf: [
      'border-radius'
    ],
    defaultValue: '0',
    propertyOptimizer: propertyOptimizers.borderRadius,
    valueOptimizers: [
      valueOptimizers.whiteSpace,
      valueOptimizers.fraction,
      valueOptimizers.precision,
      valueOptimizers.unit,
      valueOptimizers.zero
    ],
    vendorPrefixes: [
      '-moz-',
      '-o-'
    ]
  },
  'border-top-right-radius': {
    canOverride: canOverride.generic.unit,
    componentOf: [
      'border-radius'
    ],
    defaultValue: '0',
    propertyOptimizer: propertyOptimizers.borderRadius,
    valueOptimizers: [
      valueOptimizers.whiteSpace,
      valueOptimizers.fraction,
      valueOptimizers.precision,
      valueOptimizers.unit,
      valueOptimizers.zero
    ],
    vendorPrefixes: [
      '-moz-',
      '-o-'
    ]
  },
  'border-top-style': {
    canOverride: canOverride.property.borderStyle,
    componentOf: [
      'border-style',
      'border-top'
    ],
    defaultValue: 'none'
  },
  'border-top-width': {
    canOverride: canOverride.generic.unit,
    componentOf: [
      'border-top',
      'border-width'
    ],
    defaultValue: 'medium',
    oppositeTo: 'border-bottom-width',
    shortestValue: '0',
    valueOptimizers: [
      valueOptimizers.whiteSpace,
      valueOptimizers.fraction,
      valueOptimizers.precision,
      valueOptimizers.unit,
      valueOptimizers.zero
    ]
  },
  'border-width': {
    breakUp: breakUp.fourValues,
    canOverride: canOverride.generic.components([
      canOverride.generic.unit,
      canOverride.generic.unit,
      canOverride.generic.unit,
      canOverride.generic.unit
    ]),
    componentOf: [
      'border'
    ],
    components: [
      'border-top-width',
      'border-right-width',
      'border-bottom-width',
      'border-left-width'
    ],
    defaultValue: 'medium',
    restore: restore.fourValues,
    shortestValue: '0',
    shorthand: true,
    singleTypeComponents: true,
    valueOptimizers: [
      valueOptimizers.whiteSpace,
      valueOptimizers.fraction,
      valueOptimizers.precision,
      valueOptimizers.unit,
      valueOptimizers.zero
    ]
  },
  'box-shadow': {
    propertyOptimizer: propertyOptimizers.boxShadow,
    valueOptimizers: [
      valueOptimizers.whiteSpace,
      valueOptimizers.fraction,
      valueOptimizers.precision,
      valueOptimizers.unit,
      valueOptimizers.zero,
      valueOptimizers.color
    ],
    vendorPrefixes: [
      '-moz-',
      '-ms-',
      '-o-',
      '-webkit-'
    ]
  },
  clear: {
    canOverride: canOverride.property.clear,
    defaultValue: 'none'
  },
  clip: {
    valueOptimizers: [
      valueOptimizers.whiteSpace,
      valueOptimizers.fraction,
      valueOptimizers.precision,
      valueOptimizers.unit,
      valueOptimizers.zero
    ]
  },
  color: {
    canOverride: canOverride.generic.color,
    defaultValue: 'transparent',
    shortestValue: 'red',
    valueOptimizers: [
      valueOptimizers.whiteSpace,
      valueOptimizers.fraction,
      valueOptimizers.color
    ]
  },
  'column-gap': {
    valueOptimizers: [
      valueOptimizers.whiteSpace,
      valueOptimizers.fraction,
      valueOptimizers.precision,
      valueOptimizers.unit,
      valueOptimizers.zero
    ]
  },
  cursor: {
    canOverride: canOverride.property.cursor,
    defaultValue: 'auto'
  },
  display: { canOverride: canOverride.property.display },
  filter: {
    propertyOptimizer: propertyOptimizers.filter,
    valueOptimizers: [
      valueOptimizers.fraction
    ]
  },
  float: {
    canOverride: canOverride.property.float,
    defaultValue: 'none'
  },
  font: {
    breakUp: breakUp.font,
    canOverride: canOverride.generic.components([
      canOverride.property.fontStyle,
      canOverride.property.fontVariant,
      canOverride.property.fontWeight,
      canOverride.property.fontStretch,
      canOverride.generic.unit,
      canOverride.generic.unit,
      canOverride.property.fontFamily
    ]),
    components: [
      'font-style',
      'font-variant',
      'font-weight',
      'font-stretch',
      'font-size',
      'line-height',
      'font-family'
    ],
    restore: restore.font,
    shorthand: true,
    valueOptimizers: [
      valueOptimizers.textQuotes
    ]
  },
  'font-family': {
    canOverride: canOverride.property.fontFamily,
    defaultValue: 'user|agent|specific',
    valueOptimizers: [
      valueOptimizers.textQuotes
    ]
  },
  'font-size': {
    canOverride: canOverride.generic.unit,
    defaultValue: 'medium',
    shortestValue: '0',
    valueOptimizers: [
      valueOptimizers.fraction
    ]
  },
  'font-stretch': {
    canOverride: canOverride.property.fontStretch,
    defaultValue: 'normal'
  },
  'font-style': {
    canOverride: canOverride.property.fontStyle,
    defaultValue: 'normal'
  },
  'font-variant': {
    canOverride: canOverride.property.fontVariant,
    defaultValue: 'normal'
  },
  'font-weight': {
    canOverride: canOverride.property.fontWeight,
    defaultValue: 'normal',
    propertyOptimizer: propertyOptimizers.fontWeight,
    shortestValue: '400'
  },
  gap: {
    valueOptimizers: [
      valueOptimizers.whiteSpace,
      valueOptimizers.fraction,
      valueOptimizers.precision,
      valueOptimizers.unit,
      valueOptimizers.zero
    ]
  },
  height: {
    canOverride: canOverride.generic.unit,
    defaultValue: 'auto',
    shortestValue: '0',
    valueOptimizers: [
      valueOptimizers.whiteSpace,
      valueOptimizers.fraction,
      valueOptimizers.precision,
      valueOptimizers.unit,
      valueOptimizers.zero
    ]
  },
  left: {
    canOverride: canOverride.property.left,
    defaultValue: 'auto',
    valueOptimizers: [
      valueOptimizers.whiteSpace,
      valueOptimizers.fraction,
      valueOptimizers.precision,
      valueOptimizers.unit,
      valueOptimizers.zero
    ]
  },
  'letter-spacing': {
    valueOptimizers: [
      valueOptimizers.fraction,
      valueOptimizers.zero
    ]
  },
  'line-height': {
    canOverride: canOverride.generic.unitOrNumber,
    defaultValue: 'normal',
    shortestValue: '0',
    valueOptimizers: [
      valueOptimizers.fraction,
      valueOptimizers.zero
    ]
  },
  'list-style': {
    canOverride: canOverride.generic.components([
      canOverride.property.listStyleType,
      canOverride.property.listStylePosition,
      canOverride.property.listStyleImage
    ]),
    components: [
      'list-style-type',
      'list-style-position',
      'list-style-image'
    ],
    breakUp: breakUp.listStyle,
    restore: restore.withoutDefaults,
    defaultValue: 'outside', // can't use 'disc' because that'd override default 'decimal' for <ol>
    shortestValue: 'none',
    shorthand: true
  },
  'list-style-image': {
    canOverride: canOverride.generic.image,
    componentOf: [
      'list-style'
    ],
    defaultValue: 'none'
  },
  'list-style-position': {
    canOverride: canOverride.property.listStylePosition,
    componentOf: [
      'list-style'
    ],
    defaultValue: 'outside',
    shortestValue: 'inside'
  },
  'list-style-type': {
    canOverride: canOverride.property.listStyleType,
    componentOf: [
      'list-style'
    ],
    // NOTE: we can't tell the real default value here, it's 'disc' for <ul> and 'decimal' for <ol>
    // this is a hack, but it doesn't matter because this value will be either overridden or
    // it will disappear at the final step anyway
    defaultValue: 'decimal|disc',
    shortestValue: 'none'
  },
  margin: {
    breakUp: breakUp.fourValues,
    canOverride: canOverride.generic.components([
      canOverride.generic.unit,
      canOverride.generic.unit,
      canOverride.generic.unit,
      canOverride.generic.unit
    ]),
    components: [
      'margin-top',
      'margin-right',
      'margin-bottom',
      'margin-left'
    ],
    defaultValue: '0',
    propertyOptimizer: propertyOptimizers.margin,
    restore: restore.fourValues,
    shorthand: true,
    valueOptimizers: [
      valueOptimizers.whiteSpace,
      valueOptimizers.fraction,
      valueOptimizers.precision,
      valueOptimizers.unit,
      valueOptimizers.zero
    ]
  },
  'margin-bottom': {
    canOverride: canOverride.generic.unit,
    componentOf: [
      'margin'
    ],
    defaultValue: '0',
    oppositeTo: 'margin-top',
    propertyOptimizer: propertyOptimizers.margin,
    valueOptimizers: [
      valueOptimizers.whiteSpace,
      valueOptimizers.fraction,
      valueOptimizers.precision,
      valueOptimizers.unit,
      valueOptimizers.zero
    ]
  },
  'margin-inline-end': {
    valueOptimizers: [
      valueOptimizers.whiteSpace,
      valueOptimizers.fraction,
      valueOptimizers.precision,
      valueOptimizers.unit,
      valueOptimizers.zero
    ]
  },
  'margin-inline-start': {
    valueOptimizers: [
      valueOptimizers.whiteSpace,
      valueOptimizers.fraction,
      valueOptimizers.precision,
      valueOptimizers.unit,
      valueOptimizers.zero
    ]
  },
  'margin-left': {
    canOverride: canOverride.generic.unit,
    componentOf: [
      'margin'
    ],
    defaultValue: '0',
    oppositeTo: 'margin-right',
    propertyOptimizer: propertyOptimizers.margin,
    valueOptimizers: [
      valueOptimizers.whiteSpace,
      valueOptimizers.fraction,
      valueOptimizers.precision,
      valueOptimizers.unit,
      valueOptimizers.zero
    ]
  },
  'margin-right': {
    canOverride: canOverride.generic.unit,
    componentOf: [
      'margin'
    ],
    defaultValue: '0',
    oppositeTo: 'margin-left',
    propertyOptimizer: propertyOptimizers.margin,
    valueOptimizers: [
      valueOptimizers.whiteSpace,
      valueOptimizers.fraction,
      valueOptimizers.precision,
      valueOptimizers.unit,
      valueOptimizers.zero
    ]
  },
  'margin-top': {
    canOverride: canOverride.generic.unit,
    componentOf: [
      'margin'
    ],
    defaultValue: '0',
    oppositeTo: 'margin-bottom',
    propertyOptimizer: propertyOptimizers.margin,
    valueOptimizers: [
      valueOptimizers.whiteSpace,
      valueOptimizers.fraction,
      valueOptimizers.precision,
      valueOptimizers.unit,
      valueOptimizers.zero
    ]
  },
  'max-height': {
    canOverride: canOverride.generic.unit,
    defaultValue: 'none',
    shortestValue: '0',
    valueOptimizers: [
      valueOptimizers.whiteSpace,
      valueOptimizers.fraction,
      valueOptimizers.precision,
      valueOptimizers.unit,
      valueOptimizers.zero
    ]
  },
  'max-width': {
    canOverride: canOverride.generic.unit,
    defaultValue: 'none',
    shortestValue: '0',
    valueOptimizers: [
      valueOptimizers.whiteSpace,
      valueOptimizers.fraction,
      valueOptimizers.precision,
      valueOptimizers.unit,
      valueOptimizers.zero
    ]
  },
  'min-height': {
    canOverride: canOverride.generic.unit,
    defaultValue: '0',
    shortestValue: '0',
    valueOptimizers: [
      valueOptimizers.whiteSpace,
      valueOptimizers.fraction,
      valueOptimizers.precision,
      valueOptimizers.unit,
      valueOptimizers.zero
    ]
  },
  'min-width': {
    canOverride: canOverride.generic.unit,
    defaultValue: '0',
    shortestValue: '0',
    valueOptimizers: [
      valueOptimizers.whiteSpace,
      valueOptimizers.fraction,
      valueOptimizers.precision,
      valueOptimizers.unit,
      valueOptimizers.zero
    ]
  },
  opacity: {
    valueOptimizers: [
      valueOptimizers.fraction,
      valueOptimizers.precision
    ]
  },
  outline: {
    canOverride: canOverride.generic.components([
      canOverride.generic.color,
      canOverride.property.outlineStyle,
      canOverride.generic.unit
    ]),
    components: [
      'outline-color',
      'outline-style',
      'outline-width'
    ],
    breakUp: breakUp.outline,
    restore: restore.withoutDefaults,
    defaultValue: '0',
    propertyOptimizer: propertyOptimizers.outline,
    shorthand: true,
    valueOptimizers: [
      valueOptimizers.whiteSpace,
      valueOptimizers.fraction,
      valueOptimizers.precision,
      valueOptimizers.unit,
      valueOptimizers.zero
    ]
  },
  'outline-color': {
    canOverride: canOverride.generic.color,
    componentOf: [
      'outline'
    ],
    defaultValue: 'invert',
    shortestValue: 'red',
    valueOptimizers: [
      valueOptimizers.whiteSpace,
      valueOptimizers.fraction,
      valueOptimizers.color
    ]
  },
  'outline-style': {
    canOverride: canOverride.property.outlineStyle,
    componentOf: [
      'outline'
    ],
    defaultValue: 'none'
  },
  'outline-width': {
    canOverride: canOverride.generic.unit,
    componentOf: [
      'outline'
    ],
    defaultValue: 'medium',
    shortestValue: '0',
    valueOptimizers: [
      valueOptimizers.whiteSpace,
      valueOptimizers.fraction,
      valueOptimizers.precision,
      valueOptimizers.unit,
      valueOptimizers.zero
    ]
  },
  overflow: {
    canOverride: canOverride.property.overflow,
    defaultValue: 'visible'
  },
  'overflow-x': {
    canOverride: canOverride.property.overflow,
    defaultValue: 'visible'
  },
  'overflow-y': {
    canOverride: canOverride.property.overflow,
    defaultValue: 'visible'
  },
  padding: {
    breakUp: breakUp.fourValues,
    canOverride: canOverride.generic.components([
      canOverride.generic.unit,
      canOverride.generic.unit,
      canOverride.generic.unit,
      canOverride.generic.unit
    ]),
    components: [
      'padding-top',
      'padding-right',
      'padding-bottom',
      'padding-left'
    ],
    defaultValue: '0',
    propertyOptimizer: propertyOptimizers.padding,
    restore: restore.fourValues,
    shorthand: true,
    valueOptimizers: [
      valueOptimizers.whiteSpace,
      valueOptimizers.fraction,
      valueOptimizers.precision,
      valueOptimizers.unit,
      valueOptimizers.zero
    ]
  },
  'padding-bottom': {
    canOverride: canOverride.generic.unit,
    componentOf: [
      'padding'
    ],
    defaultValue: '0',
    oppositeTo: 'padding-top',
    propertyOptimizer: propertyOptimizers.padding,
    valueOptimizers: [
      valueOptimizers.whiteSpace,
      valueOptimizers.fraction,
      valueOptimizers.precision,
      valueOptimizers.unit,
      valueOptimizers.zero
    ]
  },
  'padding-left': {
    canOverride: canOverride.generic.unit,
    componentOf: [
      'padding'
    ],
    defaultValue: '0',
    oppositeTo: 'padding-right',
    propertyOptimizer: propertyOptimizers.padding,
    valueOptimizers: [
      valueOptimizers.whiteSpace,
      valueOptimizers.fraction,
      valueOptimizers.precision,
      valueOptimizers.unit,
      valueOptimizers.zero
    ]
  },
  'padding-right': {
    canOverride: canOverride.generic.unit,
    componentOf: [
      'padding'
    ],
    defaultValue: '0',
    oppositeTo: 'padding-left',
    propertyOptimizer: propertyOptimizers.padding,
    valueOptimizers: [
      valueOptimizers.whiteSpace,
      valueOptimizers.fraction,
      valueOptimizers.precision,
      valueOptimizers.unit,
      valueOptimizers.zero
    ]
  },
  'padding-top': {
    canOverride: canOverride.generic.unit,
    componentOf: [
      'padding'
    ],
    defaultValue: '0',
    oppositeTo: 'padding-bottom',
    propertyOptimizer: propertyOptimizers.padding,
    valueOptimizers: [
      valueOptimizers.whiteSpace,
      valueOptimizers.fraction,
      valueOptimizers.precision,
      valueOptimizers.unit,
      valueOptimizers.zero
    ]
  },
  position: {
    canOverride: canOverride.property.position,
    defaultValue: 'static'
  },
  right: {
    canOverride: canOverride.property.right,
    defaultValue: 'auto',
    valueOptimizers: [
      valueOptimizers.whiteSpace,
      valueOptimizers.fraction,
      valueOptimizers.precision,
      valueOptimizers.unit,
      valueOptimizers.zero
    ]
  },
  'row-gap': {
    valueOptimizers: [
      valueOptimizers.whiteSpace,
      valueOptimizers.fraction,
      valueOptimizers.precision,
      valueOptimizers.unit,
      valueOptimizers.zero
    ]
  },
  src: {
    valueOptimizers: [
      valueOptimizers.urlWhiteSpace,
      valueOptimizers.urlPrefix,
      valueOptimizers.urlQuotes
    ]
  },
  'stroke-width': {
    valueOptimizers: [
      valueOptimizers.whiteSpace,
      valueOptimizers.fraction,
      valueOptimizers.precision,
      valueOptimizers.unit,
      valueOptimizers.zero
    ]
  },
  'text-align': {
    canOverride: canOverride.property.textAlign,
    // NOTE: we can't tell the real default value here, as it depends on default text direction
    // this is a hack, but it doesn't matter because this value will be either overridden or
    // it will disappear anyway
    defaultValue: 'left|right'
  },
  'text-decoration': {
    canOverride: canOverride.property.textDecoration,
    defaultValue: 'none'
  },
  'text-indent': {
    canOverride: canOverride.property.textOverflow,
    defaultValue: 'none',
    valueOptimizers: [
      valueOptimizers.fraction,
      valueOptimizers.zero
    ]
  },
  'text-overflow': {
    canOverride: canOverride.property.textOverflow,
    defaultValue: 'none'
  },
  'text-shadow': {
    canOverride: canOverride.property.textShadow,
    defaultValue: 'none',
    valueOptimizers: [
      valueOptimizers.whiteSpace,
      valueOptimizers.fraction,
      valueOptimizers.zero,
      valueOptimizers.color
    ]
  },
  top: {
    canOverride: canOverride.property.top,
    defaultValue: 'auto',
    valueOptimizers: [
      valueOptimizers.whiteSpace,
      valueOptimizers.fraction,
      valueOptimizers.precision,
      valueOptimizers.unit,
      valueOptimizers.zero
    ]
  },
  transform: {
    canOverride: canOverride.property.transform,
    valueOptimizers: [
      valueOptimizers.whiteSpace,
      valueOptimizers.degrees,
      valueOptimizers.fraction,
      valueOptimizers.precision,
      valueOptimizers.unit,
      valueOptimizers.zero
    ],
    vendorPrefixes: [
      '-moz-',
      '-ms-',
      '-o-',
      '-webkit-'
    ]
  },
  transition: {
    breakUp: breakUp.multiplex(breakUp.transition),
    canOverride: canOverride.generic.components([
      canOverride.property.transitionProperty,
      canOverride.generic.time,
      canOverride.generic.timingFunction,
      canOverride.generic.time
    ]),
    components: [
      'transition-property',
      'transition-duration',
      'transition-timing-function',
      'transition-delay'
    ],
    defaultValue: 'none',
    restore: restore.multiplex(restore.withoutDefaults),
    shorthand: true,
    valueOptimizers: [
      valueOptimizers.time,
      valueOptimizers.fraction
    ],
    vendorPrefixes: [
      '-moz-',
      '-ms-',
      '-o-',
      '-webkit-'
    ]
  },
  'transition-delay': {
    canOverride: canOverride.generic.time,
    componentOf: [
      'transition'
    ],
    defaultValue: '0s',
    intoMultiplexMode: 'real',
    valueOptimizers: [
      valueOptimizers.time
    ],
    vendorPrefixes: [
      '-moz-',
      '-ms-',
      '-o-',
      '-webkit-'
    ]
  },
  'transition-duration': {
    canOverride: canOverride.generic.time,
    componentOf: [
      'transition'
    ],
    defaultValue: '0s',
    intoMultiplexMode: 'real',
    keepUnlessDefault: 'transition-delay',
    valueOptimizers: [
      valueOptimizers.time,
      valueOptimizers.fraction
    ],
    vendorPrefixes: [
      '-moz-',
      '-ms-',
      '-o-',
      '-webkit-'
    ]
  },
  'transition-property': {
    canOverride: canOverride.generic.propertyName,
    componentOf: [
      'transition'
    ],
    defaultValue: 'all',
    intoMultiplexMode: 'placeholder',
    placeholderValue: '_', // it's a short value that won't match any property and still be a valid `transition-property`
    vendorPrefixes: [
      '-moz-',
      '-ms-',
      '-o-',
      '-webkit-'
    ]
  },
  'transition-timing-function': {
    canOverride: canOverride.generic.timingFunction,
    componentOf: [
      'transition'
    ],
    defaultValue: 'ease',
    intoMultiplexMode: 'real',
    vendorPrefixes: [
      '-moz-',
      '-ms-',
      '-o-',
      '-webkit-'
    ]
  },
  'vertical-align': {
    canOverride: canOverride.property.verticalAlign,
    defaultValue: 'baseline',
    valueOptimizers: [
      valueOptimizers.whiteSpace,
      valueOptimizers.fraction,
      valueOptimizers.precision,
      valueOptimizers.unit,
      valueOptimizers.zero
    ]
  },
  visibility: {
    canOverride: canOverride.property.visibility,
    defaultValue: 'visible'
  },
  '-webkit-tap-highlight-color': {
    valueOptimizers: [
      valueOptimizers.whiteSpace,
      valueOptimizers.color
    ]
  },
  '-webkit-margin-end': {
    valueOptimizers: [
      valueOptimizers.whiteSpace,
      valueOptimizers.fraction,
      valueOptimizers.precision,
      valueOptimizers.unit,
      valueOptimizers.zero
    ]
  },
  'white-space': {
    canOverride: canOverride.property.whiteSpace,
    defaultValue: 'normal'
  },
  width: {
    canOverride: canOverride.generic.unit,
    defaultValue: 'auto',
    shortestValue: '0',
    valueOptimizers: [
      valueOptimizers.whiteSpace,
      valueOptimizers.fraction,
      valueOptimizers.precision,
      valueOptimizers.unit,
      valueOptimizers.zero
    ]
  },
  'z-index': {
    canOverride: canOverride.property.zIndex,
    defaultValue: 'auto'
  }
};

// generate vendor-prefixed configuration
var vendorPrefixedConfiguration = {};

function cloneDescriptor(propertyName, prefix) {
  var clonedDescriptor = override$3(configuration$9[propertyName], {});

  if ('componentOf' in clonedDescriptor) {
    clonedDescriptor.componentOf = clonedDescriptor.componentOf.map(function(shorthandName) {
      return prefix + shorthandName;
    });
  }

  if ('components' in clonedDescriptor) {
    clonedDescriptor.components = clonedDescriptor.components.map(function(longhandName) {
      return prefix + longhandName;
    });
  }

  if ('keepUnlessDefault' in clonedDescriptor) {
    clonedDescriptor.keepUnlessDefault = prefix + clonedDescriptor.keepUnlessDefault;
  }

  return clonedDescriptor;
}

for (var propertyName in configuration$9) {
  var descriptor = configuration$9[propertyName];

  if (!('vendorPrefixes' in descriptor)) {
    continue;
  }

  for (var i$1 = 0; i$1 < descriptor.vendorPrefixes.length; i$1++) {
    var prefix = descriptor.vendorPrefixes[i$1];
    var clonedDescriptor = cloneDescriptor(propertyName, prefix);
    delete clonedDescriptor.vendorPrefixes;

    vendorPrefixedConfiguration[prefix + propertyName] = clonedDescriptor;
  }

  delete descriptor.vendorPrefixes;
}

var configuration_1 = override$3(configuration$9, vendorPrefixedConfiguration);

var emptyCharacter = '';

var Breaks = format$1.Breaks;
var Spaces = format$1.Spaces;

var Marker$8 = marker;
var Token$j = token;

function supportsAfterClosingBrace(token) {
  return token[1][1] == 'background' || token[1][1] == 'transform' || token[1][1] == 'src';
}

function afterClosingBrace(token, valueIndex) {
  return token[valueIndex][1][token[valueIndex][1].length - 1] == Marker$8.CLOSE_ROUND_BRACKET;
}

function afterComma(token, valueIndex) {
  return token[valueIndex][1] == Marker$8.COMMA;
}

function afterSlash(token, valueIndex) {
  return token[valueIndex][1] == Marker$8.FORWARD_SLASH;
}

function beforeComma(token, valueIndex) {
  return token[valueIndex + 1] && token[valueIndex + 1][1] == Marker$8.COMMA;
}

function beforeSlash(token, valueIndex) {
  return token[valueIndex + 1] && token[valueIndex + 1][1] == Marker$8.FORWARD_SLASH;
}

function inFilter(token) {
  return token[1][1] == 'filter' || token[1][1] == '-ms-filter';
}

function disallowsSpace(context, token, valueIndex) {
  return !context.spaceAfterClosingBrace
    && supportsAfterClosingBrace(token)
    && afterClosingBrace(token, valueIndex)
    || beforeSlash(token, valueIndex)
    || afterSlash(token, valueIndex)
    || beforeComma(token, valueIndex)
    || afterComma(token, valueIndex);
}

function rules$1(context, tokens) {
  var store = context.store;

  for (var i = 0, l = tokens.length; i < l; i++) {
    store(context, tokens[i]);

    if (i < l - 1) {
      store(context, comma(context));
    }
  }
}

function body$1(context, tokens) {
  var lastPropertyAt = lastPropertyIndex(tokens);

  for (var i = 0, l = tokens.length; i < l; i++) {
    property$1(context, tokens, i, lastPropertyAt);
  }
}

function lastPropertyIndex(tokens) {
  var index = tokens.length - 1;

  for (; index >= 0; index--) {
    if (tokens[index][0] != Token$j.COMMENT) {
      break;
    }
  }

  return index;
}

function property$1(context, tokens, position, lastPropertyAt) {
  var store = context.store;
  var token = tokens[position];

  var propertyValue = token[2];
  var isPropertyBlock = propertyValue && propertyValue[0] === Token$j.PROPERTY_BLOCK;

  var needsSemicolon;
  if (context.format) {
    if (context.format.semicolonAfterLastProperty || isPropertyBlock) {
      needsSemicolon = true;
    } else if (position < lastPropertyAt) {
      needsSemicolon = true;
    } else {
      needsSemicolon = false;
    }
  } else {
    needsSemicolon = position < lastPropertyAt || isPropertyBlock;
  }

  var isLast = position === lastPropertyAt;

  switch (token[0]) {
  case Token$j.AT_RULE:
    store(context, token);
    store(context, semicolon(context, Breaks.AfterProperty, false));
    break;
  case Token$j.AT_RULE_BLOCK:
    rules$1(context, token[1]);
    store(context, openBrace(context, Breaks.AfterRuleBegins, true));
    body$1(context, token[2]);
    store(context, closeBrace(context, Breaks.AfterRuleEnds, false, isLast));
    break;
  case Token$j.COMMENT:
    store(context, token);
    store(context, breakFor(context, Breaks.AfterComment) + context.indentWith);
    break;
  case Token$j.PROPERTY:
    store(context, token[1]);
    store(context, colon(context));
    if (propertyValue) {
      value$2(context, token);
    }
    store(
      context,
      needsSemicolon ? semicolon(context, Breaks.AfterProperty, isLast) : emptyCharacter
    );
    break;
  case Token$j.RAW:
    store(context, token);
  }
}

function value$2(context, token) {
  var store = context.store;
  var j, m;

  if (token[2][0] == Token$j.PROPERTY_BLOCK) {
    store(context, openBrace(context, Breaks.AfterBlockBegins, false));
    body$1(context, token[2][1]);
    store(context, closeBrace(context, Breaks.AfterBlockEnds, false, true));
  } else {
    for (j = 2, m = token.length; j < m; j++) {
      store(context, token[j]);

      if (j < m - 1 && (inFilter(token) || !disallowsSpace(context, token, j))) {
        store(context, Marker$8.SPACE);
      }
    }
  }
}

function breakFor(context, where) {
  return context.format ? context.format.breaks[where] : emptyCharacter;
}

function allowsSpace(context, where) {
  return context.format && context.format.spaces[where];
}

function openBrace(context, where, needsPrefixSpace) {
  if (context.format) {
    context.indentBy += context.format.indentBy;
    context.indentWith = context.format.indentWith.repeat(context.indentBy);
    return (
      needsPrefixSpace
      && allowsSpace(context, Spaces.BeforeBlockBegins) ? Marker$8.SPACE : emptyCharacter
    ) + Marker$8.OPEN_CURLY_BRACKET
      + breakFor(context, where)
      + context.indentWith;
  }
  return Marker$8.OPEN_CURLY_BRACKET;
}

function closeBrace(context, where, beforeBlockEnd, isLast) {
  if (context.format) {
    context.indentBy -= context.format.indentBy;
    context.indentWith = context.format.indentWith.repeat(context.indentBy);
    return (
      beforeBlockEnd
        ? breakFor(context, Breaks.BeforeBlockEnds)
        : breakFor(context, Breaks.AfterProperty)
    ) + context.indentWith
      + Marker$8.CLOSE_CURLY_BRACKET
      + (isLast ? emptyCharacter : breakFor(context, where) + context.indentWith);
  }
  return Marker$8.CLOSE_CURLY_BRACKET;
}

function colon(context) {
  return context.format
    ? Marker$8.COLON + (allowsSpace(context, Spaces.BeforeValue) ? Marker$8.SPACE : emptyCharacter)
    : Marker$8.COLON;
}

function semicolon(context, where, isLast) {
  return context.format
    ? Marker$8.SEMICOLON + (isLast ? emptyCharacter : (breakFor(context, where) + context.indentWith))
    : Marker$8.SEMICOLON;
}

function comma(context) {
  return context.format
    ? Marker$8.COMMA + breakFor(context, Breaks.BetweenSelectors) + context.indentWith
    : Marker$8.COMMA;
}

function all$4(context, tokens) {
  var store = context.store;
  var token;
  var isLast;
  var i, l;

  for (i = 0, l = tokens.length; i < l; i++) {
    token = tokens[i];
    isLast = i == l - 1;

    switch (token[0]) {
    case Token$j.AT_RULE:
      store(context, token);
      store(context, semicolon(context, Breaks.AfterAtRule, isLast));
      break;
    case Token$j.AT_RULE_BLOCK:
      rules$1(context, token[1]);
      store(context, openBrace(context, Breaks.AfterRuleBegins, true));
      body$1(context, token[2]);
      store(context, closeBrace(context, Breaks.AfterRuleEnds, false, isLast));
      break;
    case Token$j.NESTED_BLOCK:
      rules$1(context, token[1]);
      store(context, openBrace(context, Breaks.AfterBlockBegins, true));
      all$4(context, token[2]);
      store(context, closeBrace(context, Breaks.AfterBlockEnds, true, isLast));
      break;
    case Token$j.COMMENT:
      store(context, token);
      store(context, breakFor(context, Breaks.AfterComment) + context.indentWith);
      break;
    case Token$j.RAW:
      store(context, token);
      break;
    case Token$j.RULE:
      rules$1(context, token[1]);
      store(context, openBrace(context, Breaks.AfterRuleBegins, true));
      body$1(context, token[2]);
      store(context, closeBrace(context, Breaks.AfterRuleEnds, false, isLast));
      break;
    }
  }
}

var helpers$2 = {
  all: all$4,
  body: body$1,
  property: property$1,
  rules: rules$1,
  value: value$2
};

var helpers$1 = helpers$2;

function store$2(serializeContext, token) {
  serializeContext.output.push(typeof token == 'string' ? token : token[1]);
}

function context$2() {
  var newContext = {
    output: [],
    store: store$2
  };

  return newContext;
}

function all$3(tokens) {
  var oneTimeContext = context$2();
  helpers$1.all(oneTimeContext, tokens);
  return oneTimeContext.output.join('');
}

function body(tokens) {
  var oneTimeContext = context$2();
  helpers$1.body(oneTimeContext, tokens);
  return oneTimeContext.output.join('');
}

function property(tokens, position) {
  var oneTimeContext = context$2();
  helpers$1.property(oneTimeContext, tokens, position, true);
  return oneTimeContext.output.join('');
}

function rules(tokens) {
  var oneTimeContext = context$2();
  helpers$1.rules(oneTimeContext, tokens);
  return oneTimeContext.output.join('');
}

function value$1(tokens) {
  var oneTimeContext = context$2();
  helpers$1.value(oneTimeContext, tokens);
  return oneTimeContext.output.join('');
}

var oneTime = {
  all: all$3,
  body: body,
  property: property,
  rules: rules,
  value: value$1
};

var sortSelectors$2 = sortSelectors_1;
var tidyRules$2 = tidyRules_1;
var tidyBlock = tidyBlock_1;
var tidyAtRule = tidyAtRule_1;

var Hack = hack;
var removeUnused$1 = removeUnused_1;
var restoreFromOptimizing$4 = restoreFromOptimizing_1;
var wrapForOptimizing$2 = wrapForOptimizing$3.all;

var configuration$8 = configuration_1;
var optimizers = valueOptimizers$1;

var OptimizationLevel$6 = optimizationLevel.OptimizationLevel;

var Token$i = token;
var Marker$7 = marker;

var formatPosition$1 = formatPosition_1;

var serializeRules$9 = oneTime.rules;

var CHARSET_TOKEN = '@charset';
var CHARSET_REGEXP = new RegExp('^' + CHARSET_TOKEN, 'i');

var DEFAULT_ROUNDING_PRECISION = roundingPrecision.DEFAULT;

var VARIABLE_PROPERTY_NAME_PATTERN = /^--\S+$/;
var PROPERTY_NAME_PATTERN = /^(?:-chrome-|-[\w-]+\w|\w[\w-]+\w|\w{1,})$/;
var IMPORT_PREFIX_PATTERN$2 = /^@import/i;
var URL_PREFIX_PATTERN$2 = /^url\(/i;

function startsAsUrl(value) {
  return URL_PREFIX_PATTERN$2.test(value);
}

function isImport$3(token) {
  return IMPORT_PREFIX_PATTERN$2.test(token[1]);
}

function isLegacyFilter(property) {
  var value;

  if (property.name == 'filter' || property.name == '-ms-filter') {
    value = property.value[0][1];

    return value.indexOf('progid') > -1
      || value.indexOf('alpha') === 0
      || value.indexOf('chroma') === 0;
  }
  return false;
}

function noop() {}

function noopValueOptimizer(_name, value, _options) { return value; }

function optimizeBody(rule, properties, context) {
  var options = context.options;
  var valueOptimizers;
  var property, name, type, value;
  var propertyToken;
  var propertyOptimizer;
  var serializedRule = serializeRules$9(rule);
  var _properties = wrapForOptimizing$2(properties);
  var pluginValueOptimizers = context.options.plugins.level1Value;
  var pluginPropertyOptimizers = context.options.plugins.level1Property;
  var isVariable;
  var i, l;

  for (i = 0, l = _properties.length; i < l; i++) {
    var j, k, m, n;

    property = _properties[i];
    name = property.name;
    propertyOptimizer = configuration$8[name] && configuration$8[name].propertyOptimizer || noop;
    valueOptimizers = configuration$8[name] && configuration$8[name].valueOptimizers || [optimizers.whiteSpace];
    isVariable = VARIABLE_PROPERTY_NAME_PATTERN.test(name);

    if (isVariable) {
      valueOptimizers = options.variableOptimizers.length > 0
        ? options.variableOptimizers
        : [optimizers.whiteSpace];
    }

    if (!isVariable && !PROPERTY_NAME_PATTERN.test(name)) {
      propertyToken = property.all[property.position];
      context.warnings.push('Invalid property name \'' + name + '\' at ' + formatPosition$1(propertyToken[1][2][0]) + '. Ignoring.');
      property.unused = true;
      continue;
    }

    if (property.value.length === 0) {
      propertyToken = property.all[property.position];
      context.warnings.push('Empty property \'' + name + '\' at ' + formatPosition$1(propertyToken[1][2][0]) + '. Ignoring.');
      property.unused = true;
      continue;
    }

    if (property.hack && (
      (property.hack[0] == Hack.ASTERISK || property.hack[0] == Hack.UNDERSCORE)
        && !options.compatibility.properties.iePrefixHack
        || property.hack[0] == Hack.BACKSLASH && !options.compatibility.properties.ieSuffixHack
        || property.hack[0] == Hack.BANG && !options.compatibility.properties.ieBangHack)) {
      property.unused = true;
      continue;
    }

    if (!options.compatibility.properties.ieFilters && isLegacyFilter(property)) {
      property.unused = true;
      continue;
    }

    if (property.block) {
      optimizeBody(rule, property.value[0][1], context);
      continue;
    }

    for (j = 0, m = property.value.length; j < m; j++) {
      type = property.value[j][0];
      value = property.value[j][1];

      if (type == Token$i.PROPERTY_BLOCK) {
        property.unused = true;
        context.warnings.push('Invalid value token at ' + formatPosition$1(value[0][1][2][0]) + '. Ignoring.');
        break;
      }

      if (startsAsUrl(value) && !context.validator.isUrl(value)) {
        property.unused = true;
        context.warnings.push('Broken URL \'' + value + '\' at ' + formatPosition$1(property.value[j][2][0]) + '. Ignoring.');
        break;
      }

      for (k = 0, n = valueOptimizers.length; k < n; k++) {
        value = valueOptimizers[k](name, value, options);
      }

      for (k = 0, n = pluginValueOptimizers.length; k < n; k++) {
        value = pluginValueOptimizers[k](name, value, options);
      }

      property.value[j][1] = value;
    }

    propertyOptimizer(serializedRule, property, options);

    for (j = 0, m = pluginPropertyOptimizers.length; j < m; j++) {
      pluginPropertyOptimizers[j](serializedRule, property, options);
    }
  }

  restoreFromOptimizing$4(_properties);
  removeUnused$1(_properties);
  removeComments$1(properties, options);
}

function removeComments$1(tokens, options) {
  var token;
  var i;

  for (i = 0; i < tokens.length; i++) {
    token = tokens[i];

    if (token[0] != Token$i.COMMENT) {
      continue;
    }

    optimizeComment(token, options);

    if (token[1].length === 0) {
      tokens.splice(i, 1);
      i--;
    }
  }
}

function optimizeComment(token, options) {
  if (token[1][2] == Marker$7.EXCLAMATION && (options.level[OptimizationLevel$6.One].specialComments == 'all' || options.commentsKept < options.level[OptimizationLevel$6.One].specialComments)) {
    options.commentsKept++;
    return;
  }

  token[1] = [];
}

function cleanupCharsets(tokens) {
  var hasCharset = false;

  for (var i = 0, l = tokens.length; i < l; i++) {
    var token = tokens[i];

    if (token[0] != Token$i.AT_RULE) { continue; }

    if (!CHARSET_REGEXP.test(token[1])) { continue; }

    if (hasCharset || token[1].indexOf(CHARSET_TOKEN) == -1) {
      tokens.splice(i, 1);
      i--;
      l--;
    } else {
      hasCharset = true;
      tokens.splice(i, 1);
      tokens.unshift([Token$i.AT_RULE, token[1].replace(CHARSET_REGEXP, CHARSET_TOKEN)]);
    }
  }
}

function buildUnitRegexp(options) {
  var units = ['px', 'em', 'ex', 'cm', 'mm', 'in', 'pt', 'pc', '%'];
  var otherUnits = ['ch', 'rem', 'vh', 'vm', 'vmax', 'vmin', 'vw'];

  otherUnits.forEach(function(unit) {
    if (options.compatibility.units[unit]) {
      units.push(unit);
    }
  });

  return new RegExp('(^|\\s|\\(|,)0(?:' + units.join('|') + ')(\\W|$)', 'g');
}

function buildPrecisionOptions(roundingPrecision) {
  var precisionOptions = {
    matcher: null,
    units: {}
  };
  var optimizable = [];
  var unit;
  var value;

  for (unit in roundingPrecision) {
    value = roundingPrecision[unit];

    if (value != DEFAULT_ROUNDING_PRECISION) {
      precisionOptions.units[unit] = {};
      precisionOptions.units[unit].value = value;
      precisionOptions.units[unit].multiplier = 10 ** value;

      optimizable.push(unit);
    }
  }

  if (optimizable.length > 0) {
    precisionOptions.enabled = true;
    precisionOptions.decimalPointMatcher = new RegExp('(\\d)\\.($|' + optimizable.join('|') + ')($|\\W)', 'g');
    precisionOptions.zeroMatcher = new RegExp('(\\d*)(\\.\\d+)(' + optimizable.join('|') + ')', 'g');
  }

  return precisionOptions;
}

function buildVariableOptimizers(options) {
  return options.level[OptimizationLevel$6.One].variableValueOptimizers.map(function(optimizer) {
    if (typeof (optimizer) == 'string') {
      return optimizers[optimizer] || noopValueOptimizer;
    }

    return optimizer;
  });
}

function level1Optimize$1(tokens, context) {
  var options = context.options;
  var levelOptions = options.level[OptimizationLevel$6.One];
  var ie7Hack = options.compatibility.selectors.ie7Hack;
  var adjacentSpace = options.compatibility.selectors.adjacentSpace;
  var spaceAfterClosingBrace = options.compatibility.properties.spaceAfterClosingBrace;
  var format = options.format;
  var mayHaveCharset = false;
  var afterRules = false;

  options.unitsRegexp = options.unitsRegexp || buildUnitRegexp(options);
  options.precision = options.precision || buildPrecisionOptions(levelOptions.roundingPrecision);
  options.commentsKept = options.commentsKept || 0;
  options.variableOptimizers = options.variableOptimizers || buildVariableOptimizers(options);

  for (var i = 0, l = tokens.length; i < l; i++) {
    var token = tokens[i];

    switch (token[0]) {
    case Token$i.AT_RULE:
      token[1] = isImport$3(token) && afterRules ? '' : token[1];
      token[1] = levelOptions.tidyAtRules ? tidyAtRule(token[1]) : token[1];
      mayHaveCharset = true;
      break;
    case Token$i.AT_RULE_BLOCK:
      optimizeBody(token[1], token[2], context);
      afterRules = true;
      break;
    case Token$i.NESTED_BLOCK:
      token[1] = levelOptions.tidyBlockScopes ? tidyBlock(token[1], spaceAfterClosingBrace) : token[1];
      level1Optimize$1(token[2], context);
      afterRules = true;
      break;
    case Token$i.COMMENT:
      optimizeComment(token, options);
      break;
    case Token$i.RULE:
      token[1] = levelOptions.tidySelectors
        ? tidyRules$2(token[1], !ie7Hack, adjacentSpace, format, context.warnings)
        : token[1];
      token[1] = token[1].length > 1 ? sortSelectors$2(token[1], levelOptions.selectorsSortingMethod) : token[1];
      optimizeBody(token[1], token[2], context);
      afterRules = true;
      break;
    }

    if (token[0] == Token$i.COMMENT
      && token[1].length === 0
      || levelOptions.removeEmpty
      && (token[1].length === 0 || (token[2] && token[2].length === 0))) {
      tokens.splice(i, 1);
      i--;
      l--;
    }
  }

  if (levelOptions.cleanupCharsets && mayHaveCharset) {
    cleanupCharsets(tokens);
  }

  return tokens;
}

var optimize$3 = level1Optimize$1;

var Marker$6 = marker;
var split$1 = split_1;

var DEEP_SELECTOR_PATTERN = /\/deep\//;
var DOUBLE_COLON_PATTERN = /^::/;
var VENDOR_PREFIXED_PATTERN = /:(-moz-|-ms-|-o-|-webkit-)/;

var NOT_PSEUDO = ':not';
var PSEUDO_CLASSES_WITH_ARGUMENTS = [
  ':dir',
  ':lang',
  ':not',
  ':nth-child',
  ':nth-last-child',
  ':nth-last-of-type',
  ':nth-of-type'
];
var RELATION_PATTERN = /[>+~]/;
var UNMIXABLE_PSEUDO_CLASSES = [
  ':after',
  ':before',
  ':first-letter',
  ':first-line',
  ':lang'
];
var UNMIXABLE_PSEUDO_ELEMENTS = [
  '::after',
  '::before',
  '::first-letter',
  '::first-line'
];

var Level$1 = {
  DOUBLE_QUOTE: 'double-quote',
  SINGLE_QUOTE: 'single-quote',
  ROOT: 'root'
};

function isMergeable$4(selector, mergeablePseudoClasses, mergeablePseudoElements, multiplePseudoMerging) {
  var singleSelectors = split$1(selector, Marker$6.COMMA);
  var singleSelector;
  var i, l;

  for (i = 0, l = singleSelectors.length; i < l; i++) {
    singleSelector = singleSelectors[i];

    if (singleSelector.length === 0
        || isDeepSelector(singleSelector)
        || isVendorPrefixed(singleSelector)
        || (singleSelector.indexOf(Marker$6.COLON) > -1
          && !areMergeable(
            singleSelector,
            extractPseudoFrom(singleSelector),
            mergeablePseudoClasses,
            mergeablePseudoElements,
            multiplePseudoMerging
          ))) {
      return false;
    }
  }

  return true;
}

function isDeepSelector(selector) {
  return DEEP_SELECTOR_PATTERN.test(selector);
}

function isVendorPrefixed(selector) {
  return VENDOR_PREFIXED_PATTERN.test(selector);
}

function extractPseudoFrom(selector) {
  var list = [];
  var character;
  var buffer = [];
  var level = Level$1.ROOT;
  var roundBracketLevel = 0;
  var isQuoted;
  var isEscaped;
  var isPseudo = false;
  var isRelation;
  var wasColon = false;
  var index;
  var len;

  for (index = 0, len = selector.length; index < len; index++) {
    character = selector[index];

    isRelation = !isEscaped && RELATION_PATTERN.test(character);
    isQuoted = level == Level$1.DOUBLE_QUOTE || level == Level$1.SINGLE_QUOTE;

    if (isEscaped) {
      buffer.push(character);
    } else if (character == Marker$6.DOUBLE_QUOTE && level == Level$1.ROOT) {
      buffer.push(character);
      level = Level$1.DOUBLE_QUOTE;
    } else if (character == Marker$6.DOUBLE_QUOTE && level == Level$1.DOUBLE_QUOTE) {
      buffer.push(character);
      level = Level$1.ROOT;
    } else if (character == Marker$6.SINGLE_QUOTE && level == Level$1.ROOT) {
      buffer.push(character);
      level = Level$1.SINGLE_QUOTE;
    } else if (character == Marker$6.SINGLE_QUOTE && level == Level$1.SINGLE_QUOTE) {
      buffer.push(character);
      level = Level$1.ROOT;
    } else if (isQuoted) {
      buffer.push(character);
    } else if (character == Marker$6.OPEN_ROUND_BRACKET) {
      buffer.push(character);
      roundBracketLevel++;
    } else if (character == Marker$6.CLOSE_ROUND_BRACKET && roundBracketLevel == 1 && isPseudo) {
      buffer.push(character);
      list.push(buffer.join(''));
      roundBracketLevel--;
      buffer = [];
      isPseudo = false;
    } else if (character == Marker$6.CLOSE_ROUND_BRACKET) {
      buffer.push(character);
      roundBracketLevel--;
    } else if (character == Marker$6.COLON && roundBracketLevel === 0 && isPseudo && !wasColon) {
      list.push(buffer.join(''));
      buffer = [];
      buffer.push(character);
    } else if (character == Marker$6.COLON && roundBracketLevel === 0 && !wasColon) {
      buffer = [];
      buffer.push(character);
      isPseudo = true;
    } else if (character == Marker$6.SPACE && roundBracketLevel === 0 && isPseudo) {
      list.push(buffer.join(''));
      buffer = [];
      isPseudo = false;
    } else if (isRelation && roundBracketLevel === 0 && isPseudo) {
      list.push(buffer.join(''));
      buffer = [];
      isPseudo = false;
    } else {
      buffer.push(character);
    }

    isEscaped = character == Marker$6.BACK_SLASH;
    wasColon = character == Marker$6.COLON;
  }

  if (buffer.length > 0 && isPseudo) {
    list.push(buffer.join(''));
  }

  return list;
}

function areMergeable(selector, matches, mergeablePseudoClasses, mergeablePseudoElements, multiplePseudoMerging) {
  return areAllowed(matches, mergeablePseudoClasses, mergeablePseudoElements)
    && needArguments(matches)
    && (matches.length < 2 || !someIncorrectlyChained(selector, matches))
    && (matches.length < 2 || multiplePseudoMerging && allMixable(matches));
}

function areAllowed(matches, mergeablePseudoClasses, mergeablePseudoElements) {
  var match;
  var name;
  var i, l;

  for (i = 0, l = matches.length; i < l; i++) {
    match = matches[i];
    name = match.indexOf(Marker$6.OPEN_ROUND_BRACKET) > -1
      ? match.substring(0, match.indexOf(Marker$6.OPEN_ROUND_BRACKET))
      : match;

    if (mergeablePseudoClasses.indexOf(name) === -1 && mergeablePseudoElements.indexOf(name) === -1) {
      return false;
    }
  }

  return true;
}

function needArguments(matches) {
  var match;
  var name;
  var bracketOpensAt;
  var hasArguments;
  var i, l;

  for (i = 0, l = matches.length; i < l; i++) {
    match = matches[i];

    bracketOpensAt = match.indexOf(Marker$6.OPEN_ROUND_BRACKET);
    hasArguments = bracketOpensAt > -1;
    name = hasArguments
      ? match.substring(0, bracketOpensAt)
      : match;

    if (hasArguments && PSEUDO_CLASSES_WITH_ARGUMENTS.indexOf(name) == -1) {
      return false;
    }

    if (!hasArguments && PSEUDO_CLASSES_WITH_ARGUMENTS.indexOf(name) > -1) {
      return false;
    }
  }

  return true;
}

function someIncorrectlyChained(selector, matches) {
  var positionInSelector = 0;
  var match;
  var matchAt;
  var nextMatch;
  var nextMatchAt;
  var name;
  var nextName;
  var areChained;
  var i, l;

  for (i = 0, l = matches.length; i < l; i++) {
    match = matches[i];
    nextMatch = matches[i + 1];

    if (!nextMatch) {
      break;
    }

    matchAt = selector.indexOf(match, positionInSelector);
    nextMatchAt = selector.indexOf(match, matchAt + 1);
    positionInSelector = nextMatchAt;
    areChained = matchAt + match.length == nextMatchAt;

    if (areChained) {
      name = match.indexOf(Marker$6.OPEN_ROUND_BRACKET) > -1
        ? match.substring(0, match.indexOf(Marker$6.OPEN_ROUND_BRACKET))
        : match;
      nextName = nextMatch.indexOf(Marker$6.OPEN_ROUND_BRACKET) > -1
        ? nextMatch.substring(0, nextMatch.indexOf(Marker$6.OPEN_ROUND_BRACKET))
        : nextMatch;

      if (name != NOT_PSEUDO || nextName != NOT_PSEUDO) {
        return true;
      }
    }
  }

  return false;
}

function allMixable(matches) {
  var unmixableMatches = 0;
  var match;
  var i, l;

  for (i = 0, l = matches.length; i < l; i++) {
    match = matches[i];

    if (isPseudoElement(match)) {
      unmixableMatches += UNMIXABLE_PSEUDO_ELEMENTS.indexOf(match) > -1 ? 1 : 0;
    } else {
      unmixableMatches += UNMIXABLE_PSEUDO_CLASSES.indexOf(match) > -1 ? 1 : 0;
    }

    if (unmixableMatches > 1) {
      return false;
    }
  }

  return true;
}

function isPseudoElement(pseudo) {
  return DOUBLE_COLON_PATTERN.test(pseudo);
}

var isMergeable_1 = isMergeable$4;

var Marker$5 = marker;

function everyValuesPair$2(fn, left, right) {
  var leftSize = left.value.length;
  var rightSize = right.value.length;
  var total = Math.max(leftSize, rightSize);
  var lowerBound = Math.min(leftSize, rightSize) - 1;
  var leftValue;
  var rightValue;
  var position;

  for (position = 0; position < total; position++) {
    leftValue = left.value[position] && left.value[position][1] || leftValue;
    rightValue = right.value[position] && right.value[position][1] || rightValue;

    if (leftValue == Marker$5.COMMA || rightValue == Marker$5.COMMA) {
      continue;
    }

    if (!fn(leftValue, rightValue, position, position <= lowerBound)) {
      return false;
    }
  }

  return true;
}

var everyValuesPair_1 = everyValuesPair$2;

function hasInherit$2(property) {
  for (var i = property.value.length - 1; i >= 0; i--) {
    if (property.value[i][1] == 'inherit') { return true; }
  }

  return false;
}

var hasInherit_1 = hasInherit$2;

function hasSameValues$1(property) {
  var firstValue = property.value[0][1];
  var i, l;

  for (i = 1, l = property.value.length; i < l; i++) {
    if (property.value[i][1] != firstValue) {
      return false;
    }
  }

  return true;
}

var hasSameValues_1 = hasSameValues$1;

var configuration$7 = configuration_1;
var InvalidPropertyError = invalidPropertyError;

function populateComponents$3(properties, validator, warnings) {
  var component;
  var j, m;

  for (var i = properties.length - 1; i >= 0; i--) {
    var property = properties[i];
    var descriptor = configuration$7[property.name];

    if (!property.dynamic && descriptor && descriptor.shorthand) {
      if (onlyValueIsVariable(property, validator) || moreThanOneValueIsVariable(property, validator)) {
        property.optimizable = false;
        continue;
      }

      property.shorthand = true;
      property.dirty = true;

      try {
        property.components = descriptor.breakUp(property, configuration$7, validator);

        if (descriptor.shorthandComponents) {
          for (j = 0, m = property.components.length; j < m; j++) {
            component = property.components[j];
            component.components = configuration$7[component.name].breakUp(component, configuration$7, validator);
          }
        }
      } catch (e) {
        if (e instanceof InvalidPropertyError) {
          property.components = []; // this will set property.unused to true below
          warnings.push(e.message);
        } else {
          throw e;
        }
      }

      if (property.components.length > 0) {
        property.multiplex = property.components[0].multiplex;
      } else {
        property.unused = true;
      }
    }
  }
}

function onlyValueIsVariable(property, validator) {
  return property.value.length == 1 && validator.isVariable(property.value[0][1]);
}

function moreThanOneValueIsVariable(property, validator) {
  return property.value.length > 1
    && property.value.filter(
      function(value) {
        return validator.isVariable(value[1]);
      }
    ).length > 1;
}

var populateComponents_1 = populateComponents$3;

var configuration$6 = configuration_1;

function restoreWithComponents$3(property) {
  var descriptor = configuration$6[property.name];

  if (descriptor && descriptor.shorthand) {
    return descriptor.restore(property, configuration$6);
  }
  return property.value;
}

var restoreWithComponents_1 = restoreWithComponents$3;

var everyValuesPair$1 = everyValuesPair_1;
var hasInherit$1 = hasInherit_1;
var hasSameValues = hasSameValues_1;
var populateComponents$2 = populateComponents_1;

var configuration$5 = configuration_1;
var deepClone$2 = clone$2.deep;
var restoreWithComponents$2 = restoreWithComponents_1;

var restoreFromOptimizing$3 = restoreFromOptimizing_1;
var wrapSingle = wrapForOptimizing$3.single;

var serializeBody$5 = oneTime.body;
var Token$h = token;

function mergeIntoShorthands$1(properties, validator) {
  var candidates = {};
  var descriptor;
  var componentOf;
  var property;
  var i, l;
  var j, m;

  // there is no shorthand property made up of less than 3 longhands
  if (properties.length < 3) {
    return;
  }

  for (i = 0, l = properties.length; i < l; i++) {
    property = properties[i];
    descriptor = configuration$5[property.name];

    if (property.dynamic) {
      continue;
    }

    if (property.unused) {
      continue;
    }

    if (property.hack) {
      continue;
    }

    if (property.block) {
      continue;
    }

    if (descriptor && descriptor.singleTypeComponents && !hasSameValues(property)) {
      continue;
    }

    invalidateOrCompact(properties, i, candidates, validator);

    if (descriptor && descriptor.componentOf) {
      for (j = 0, m = descriptor.componentOf.length; j < m; j++) {
        componentOf = descriptor.componentOf[j];

        candidates[componentOf] = candidates[componentOf] || {};
        candidates[componentOf][property.name] = property;
      }
    }
  }

  invalidateOrCompact(properties, i, candidates, validator);
}

function invalidateOrCompact(properties, position, candidates, validator) {
  var invalidatedBy = properties[position];
  var shorthandName;
  var shorthandDescriptor;
  var candidateComponents;
  var replacedCandidates = [];
  var i;

  for (shorthandName in candidates) {
    if (undefined !== invalidatedBy && shorthandName == invalidatedBy.name) {
      continue;
    }

    shorthandDescriptor = configuration$5[shorthandName];
    candidateComponents = candidates[shorthandName];
    if (invalidatedBy && invalidates(candidates, shorthandName, invalidatedBy)) {
      delete candidates[shorthandName];
      continue;
    }

    if (shorthandDescriptor.components.length > Object.keys(candidateComponents).length) {
      continue;
    }

    if (mixedImportance(candidateComponents)) {
      continue;
    }

    if (!overridable(candidateComponents, shorthandName, validator)) {
      continue;
    }

    if (!mergeable(candidateComponents)) {
      continue;
    }

    if (mixedInherit(candidateComponents)) {
      replaceWithInheritBestFit(properties, candidateComponents, shorthandName, validator);
    } else {
      replaceWithShorthand(properties, candidateComponents, shorthandName, validator);
    }

    replacedCandidates.push(shorthandName);
  }

  for (i = replacedCandidates.length - 1; i >= 0; i--) {
    delete candidates[replacedCandidates[i]];
  }
}

function invalidates(candidates, shorthandName, invalidatedBy) {
  var shorthandDescriptor = configuration$5[shorthandName];
  var invalidatedByDescriptor = configuration$5[invalidatedBy.name];
  var componentName;

  if ('overridesShorthands' in shorthandDescriptor && shorthandDescriptor.overridesShorthands.indexOf(invalidatedBy.name) > -1) {
    return true;
  }

  if (invalidatedByDescriptor && 'componentOf' in invalidatedByDescriptor) {
    for (componentName in candidates[shorthandName]) {
      if (invalidatedByDescriptor.componentOf.indexOf(componentName) > -1) {
        return true;
      }
    }
  }

  return false;
}

function mixedImportance(components) {
  var important;
  var componentName;

  for (componentName in components) {
    if (undefined !== important && components[componentName].important != important) {
      return true;
    }

    important = components[componentName].important;
  }

  return false;
}

function overridable(components, shorthandName, validator) {
  var descriptor = configuration$5[shorthandName];
  var newValuePlaceholder = [
    Token$h.PROPERTY,
    [Token$h.PROPERTY_NAME, shorthandName],
    [Token$h.PROPERTY_VALUE, descriptor.defaultValue]
  ];
  var newProperty = wrapSingle(newValuePlaceholder);
  var component;
  var mayOverride;
  var i, l;

  populateComponents$2([newProperty], validator, []);

  for (i = 0, l = descriptor.components.length; i < l; i++) {
    component = components[descriptor.components[i]];
    mayOverride = configuration$5[component.name].canOverride || sameValue$1;

    if (!everyValuesPair$1(mayOverride.bind(null, validator), newProperty.components[i], component)) {
      return false;
    }
  }

  return true;
}

function sameValue$1(_validator, value1, value2) {
  return value1 === value2;
}

function mergeable(components) {
  var lastCount = null;
  var currentCount;
  var componentName;
  var component;
  var descriptor;
  var values;

  for (componentName in components) {
    component = components[componentName];
    descriptor = configuration$5[componentName];

    if (!('restore' in descriptor)) {
      continue;
    }

    restoreFromOptimizing$3([component.all[component.position]], restoreWithComponents$2);
    values = descriptor.restore(component, configuration$5);

    currentCount = values.length;

    if (lastCount !== null && currentCount !== lastCount) {
      return false;
    }

    lastCount = currentCount;
  }

  return true;
}

function mixedInherit(components) {
  var componentName;
  var lastValue = null;
  var currentValue;

  for (componentName in components) {
    currentValue = hasInherit$1(components[componentName]);

    if (lastValue !== null && lastValue !== currentValue) {
      return true;
    }

    lastValue = currentValue;
  }

  return false;
}

function replaceWithInheritBestFit(properties, candidateComponents, shorthandName, validator) {
  var viaLonghands = buildSequenceWithInheritLonghands(candidateComponents, shorthandName, validator);
  var viaShorthand = buildSequenceWithInheritShorthand(candidateComponents, shorthandName, validator);
  var longhandTokensSequence = viaLonghands[0];
  var shorthandTokensSequence = viaShorthand[0];
  var isLonghandsShorter = serializeBody$5(longhandTokensSequence).length < serializeBody$5(shorthandTokensSequence).length;
  var newTokensSequence = isLonghandsShorter ? longhandTokensSequence : shorthandTokensSequence;
  var newProperty = isLonghandsShorter ? viaLonghands[1] : viaShorthand[1];
  var newComponents = isLonghandsShorter ? viaLonghands[2] : viaShorthand[2];
  var lastComponent = candidateComponents[Object.keys(candidateComponents).pop()];
  var all = lastComponent.all;
  var insertAt = lastComponent.position;
  var componentName;
  var oldComponent;
  var newComponent;
  var newToken;

  newProperty.position = insertAt;
  newProperty.shorthand = true;
  newProperty.important = lastComponent.important;
  newProperty.multiplex = false;
  newProperty.dirty = true;
  newProperty.all = all;
  newProperty.all[insertAt] = newTokensSequence[0];

  properties.splice(insertAt, 1, newProperty);

  for (componentName in candidateComponents) {
    oldComponent = candidateComponents[componentName];
    oldComponent.unused = true;

    newProperty.multiplex = newProperty.multiplex || oldComponent.multiplex;

    if (oldComponent.name in newComponents) {
      newComponent = newComponents[oldComponent.name];
      newToken = findTokenIn(newTokensSequence, componentName);

      newComponent.position = all.length;
      newComponent.all = all;
      newComponent.all.push(newToken);

      properties.push(newComponent);
    }
  }
}

function buildSequenceWithInheritLonghands(components, shorthandName, validator) {
  var tokensSequence = [];
  var inheritComponents = {};
  var nonInheritComponents = {};
  var descriptor = configuration$5[shorthandName];
  var shorthandToken = [
    Token$h.PROPERTY,
    [Token$h.PROPERTY_NAME, shorthandName],
    [Token$h.PROPERTY_VALUE, descriptor.defaultValue]
  ];
  var newProperty = wrapSingle(shorthandToken);
  var component;
  var longhandToken;
  var newComponent;
  var nameMetadata;
  var i, l;

  populateComponents$2([newProperty], validator, []);

  for (i = 0, l = descriptor.components.length; i < l; i++) {
    component = components[descriptor.components[i]];

    if (hasInherit$1(component)) {
      longhandToken = component.all[component.position].slice(0, 2);
      Array.prototype.push.apply(longhandToken, component.value);
      tokensSequence.push(longhandToken);

      newComponent = deepClone$2(component);
      newComponent.value = inferComponentValue(components, newComponent.name);

      newProperty.components[i] = newComponent;
      inheritComponents[component.name] = deepClone$2(component);
    } else {
      newComponent = deepClone$2(component);
      newComponent.all = component.all;
      newProperty.components[i] = newComponent;

      nonInheritComponents[component.name] = component;
    }
  }

  newProperty.important = components[Object.keys(components).pop()].important;

  nameMetadata = joinMetadata(nonInheritComponents, 1);
  shorthandToken[1].push(nameMetadata);

  restoreFromOptimizing$3([newProperty], restoreWithComponents$2);

  shorthandToken = shorthandToken.slice(0, 2);
  Array.prototype.push.apply(shorthandToken, newProperty.value);

  tokensSequence.unshift(shorthandToken);

  return [tokensSequence, newProperty, inheritComponents];
}

function inferComponentValue(components, propertyName) {
  var descriptor = configuration$5[propertyName];

  if ('oppositeTo' in descriptor) {
    return components[descriptor.oppositeTo].value;
  }
  return [[Token$h.PROPERTY_VALUE, descriptor.defaultValue]];
}

function joinMetadata(components, at) {
  var metadata = [];
  var component;
  var originalValue;
  var componentMetadata;
  var componentName;

  for (componentName in components) {
    component = components[componentName];
    originalValue = component.all[component.position];
    componentMetadata = originalValue[at][originalValue[at].length - 1];

    Array.prototype.push.apply(metadata, componentMetadata);
  }

  return metadata.sort(metadataSorter);
}

function metadataSorter(metadata1, metadata2) {
  var line1 = metadata1[0];
  var line2 = metadata2[0];
  var column1 = metadata1[1];
  var column2 = metadata2[1];

  if (line1 < line2) {
    return -1;
  } if (line1 === line2) {
    return column1 < column2 ? -1 : 1;
  }
  return 1;
}

function buildSequenceWithInheritShorthand(components, shorthandName, validator) {
  var tokensSequence = [];
  var inheritComponents = {};
  var nonInheritComponents = {};
  var descriptor = configuration$5[shorthandName];
  var shorthandToken = [
    Token$h.PROPERTY,
    [Token$h.PROPERTY_NAME, shorthandName],
    [Token$h.PROPERTY_VALUE, 'inherit']
  ];
  var newProperty = wrapSingle(shorthandToken);
  var component;
  var longhandToken;
  var nameMetadata;
  var valueMetadata;
  var i, l;

  populateComponents$2([newProperty], validator, []);

  for (i = 0, l = descriptor.components.length; i < l; i++) {
    component = components[descriptor.components[i]];

    if (hasInherit$1(component)) {
      inheritComponents[component.name] = component;
    } else {
      longhandToken = component.all[component.position].slice(0, 2);
      Array.prototype.push.apply(longhandToken, component.value);
      tokensSequence.push(longhandToken);

      nonInheritComponents[component.name] = deepClone$2(component);
    }
  }

  nameMetadata = joinMetadata(inheritComponents, 1);
  shorthandToken[1].push(nameMetadata);

  valueMetadata = joinMetadata(inheritComponents, 2);
  shorthandToken[2].push(valueMetadata);

  tokensSequence.unshift(shorthandToken);

  return [tokensSequence, newProperty, nonInheritComponents];
}

function findTokenIn(tokens, componentName) {
  var i, l;

  for (i = 0, l = tokens.length; i < l; i++) {
    if (tokens[i][1][1] == componentName) {
      return tokens[i];
    }
  }
}

function replaceWithShorthand(properties, candidateComponents, shorthandName, validator) {
  var descriptor = configuration$5[shorthandName];
  var nameMetadata;
  var valueMetadata;
  var newValuePlaceholder = [
    Token$h.PROPERTY,
    [Token$h.PROPERTY_NAME, shorthandName],
    [Token$h.PROPERTY_VALUE, descriptor.defaultValue]
  ];
  var all;
  var insertAt = inferInsertAtFrom(properties, candidateComponents, shorthandName);

  var newProperty = wrapSingle(newValuePlaceholder);
  newProperty.shorthand = true;
  newProperty.dirty = true;
  newProperty.multiplex = false;

  populateComponents$2([newProperty], validator, []);

  for (var i = 0, l = descriptor.components.length; i < l; i++) {
    var component = candidateComponents[descriptor.components[i]];

    newProperty.components[i] = deepClone$2(component);
    newProperty.important = component.important;
    newProperty.multiplex = newProperty.multiplex || component.multiplex;

    all = component.all;
  }

  for (var componentName in candidateComponents) {
    candidateComponents[componentName].unused = true;
  }

  nameMetadata = joinMetadata(candidateComponents, 1);
  newValuePlaceholder[1].push(nameMetadata);

  valueMetadata = joinMetadata(candidateComponents, 2);
  newValuePlaceholder[2].push(valueMetadata);

  newProperty.position = insertAt;
  newProperty.all = all;
  newProperty.all[insertAt] = newValuePlaceholder;

  properties.splice(insertAt, 1, newProperty);
}

function inferInsertAtFrom(properties, candidateComponents, shorthandName) {
  var candidateComponentNames = Object.keys(candidateComponents);
  var firstCandidatePosition = candidateComponents[candidateComponentNames[0]].position;
  var lastCandidatePosition = candidateComponents[candidateComponentNames[candidateComponentNames.length - 1]].position;

  if (shorthandName == 'border' && traversesVia(properties.slice(firstCandidatePosition, lastCandidatePosition), 'border-image')) {
    return firstCandidatePosition;
  }
  return lastCandidatePosition;
}

function traversesVia(properties, propertyName) {
  for (var i = properties.length - 1; i >= 0; i--) {
    if (properties[i].name == propertyName) {
      return true;
    }
  }

  return false;
}

var mergeIntoShorthands_1 = mergeIntoShorthands$1;

function hasUnset$1(property) {
  for (var i = property.value.length - 1; i >= 0; i--) {
    if (property.value[i][1] == 'unset') { return true; }
  }

  return false;
}

var hasUnset_1 = hasUnset$1;

var configuration$4 = configuration_1;

function findComponentIn$1(shorthand, longhand) {
  var comparator = nameComparator(longhand);

  return findInDirectComponents(shorthand, comparator) || findInSubComponents(shorthand, comparator);
}

function nameComparator(to) {
  return function(property) {
    return to.name === property.name;
  };
}

function findInDirectComponents(shorthand, comparator) {
  return shorthand.components.filter(comparator)[0];
}

function findInSubComponents(shorthand, comparator) {
  var shorthandComponent;
  var longhandMatch;
  var i, l;

  if (!configuration$4[shorthand.name].shorthandComponents) {
    return;
  }

  for (i = 0, l = shorthand.components.length; i < l; i++) {
    shorthandComponent = shorthand.components[i];
    longhandMatch = findInDirectComponents(shorthandComponent, comparator);

    if (longhandMatch) {
      return longhandMatch;
    }
  }
}

var findComponentIn_1 = findComponentIn$1;

var configuration$3 = configuration_1;

function isComponentOf$1(property1, property2, shallow) {
  return isDirectComponentOf(property1, property2)
    || !shallow && !!configuration$3[property1.name].shorthandComponents && isSubComponentOf(property1, property2);
}

function isDirectComponentOf(property1, property2) {
  var descriptor = configuration$3[property1.name];

  return 'components' in descriptor && descriptor.components.indexOf(property2.name) > -1;
}

function isSubComponentOf(property1, property2) {
  return property1
    .components
    .some(function(component) {
      return isDirectComponentOf(component, property2);
    });
}

var isComponentOf_1 = isComponentOf$1;

var Marker$4 = marker;

function isMergeableShorthand$1(shorthand) {
  if (shorthand.name != 'font') {
    return true;
  }

  return shorthand.value[0][1].indexOf(Marker$4.INTERNAL) == -1;
}

var isMergeableShorthand_1 = isMergeableShorthand$1;

var configuration$2 = configuration_1;

function overridesNonComponentShorthand$1(property1, property2) {
  return property1.name in configuration$2
    && 'overridesShorthands' in configuration$2[property1.name]
    && configuration$2[property1.name].overridesShorthands.indexOf(property2.name) > -1;
}

var overridesNonComponentShorthand_1 = overridesNonComponentShorthand$1;

var hasInherit = hasInherit_1;
var hasUnset = hasUnset_1;
var everyValuesPair = everyValuesPair_1;
var findComponentIn = findComponentIn_1;
var isComponentOf = isComponentOf_1;
var isMergeableShorthand = isMergeableShorthand_1;
var overridesNonComponentShorthand = overridesNonComponentShorthand_1;
var sameVendorPrefixesIn = vendorPrefixes.same;

var configuration$1 = configuration_1;
var deepClone$1 = clone$2.deep;
var restoreWithComponents$1 = restoreWithComponents_1;
var shallowClone = clone$2.shallow;

var restoreFromOptimizing$2 = restoreFromOptimizing_1;

var Token$g = token;
var Marker$3 = marker;

var serializeProperty = oneTime.property;

function sameValue(_validator, value1, value2) {
  return value1 === value2;
}

function wouldBreakCompatibility(property, validator) {
  for (var i = 0; i < property.components.length; i++) {
    var component = property.components[i];
    var descriptor = configuration$1[component.name];
    var canOverride = descriptor && descriptor.canOverride || sameValue;

    var _component = shallowClone(component);
    _component.value = [[Token$g.PROPERTY_VALUE, descriptor.defaultValue]];

    if (!everyValuesPair(canOverride.bind(null, validator), _component, component)) {
      return true;
    }
  }

  return false;
}

function overrideIntoMultiplex(property, by) {
  by.unused = true;

  turnIntoMultiplex(by, multiplexSize(property));
  property.value = by.value;
}

function overrideByMultiplex(property, by) {
  by.unused = true;
  property.multiplex = true;
  property.value = by.value;
}

function overrideSimple(property, by) {
  by.unused = true;
  property.value = by.value;
}

function override$2(property, by) {
  if (by.multiplex) {
    overrideByMultiplex(property, by);
  } else if (property.multiplex) {
    overrideIntoMultiplex(property, by);
  } else {
    overrideSimple(property, by);
  }
}

function overrideShorthand(property, by) {
  by.unused = true;

  for (var i = 0, l = property.components.length; i < l; i++) {
    override$2(property.components[i], by.components[i]);
  }
}

function turnIntoMultiplex(property, size) {
  property.multiplex = true;

  if (configuration$1[property.name].shorthand) {
    turnShorthandValueIntoMultiplex(property, size);
  } else {
    turnLonghandValueIntoMultiplex(property, size);
  }
}

function turnShorthandValueIntoMultiplex(property, size) {
  var component;
  var i, l;

  for (i = 0, l = property.components.length; i < l; i++) {
    component = property.components[i];

    if (!component.multiplex) {
      turnLonghandValueIntoMultiplex(component, size);
    }
  }
}

function turnLonghandValueIntoMultiplex(property, size) {
  var descriptor = configuration$1[property.name];
  var withRealValue = descriptor.intoMultiplexMode == 'real';
  var withValue = descriptor.intoMultiplexMode == 'real'
    ? property.value.slice(0)
    : (descriptor.intoMultiplexMode == 'placeholder' ? descriptor.placeholderValue : descriptor.defaultValue);
  var i = multiplexSize(property);
  var j;
  var m = withValue.length;

  for (; i < size; i++) {
    property.value.push([Token$g.PROPERTY_VALUE, Marker$3.COMMA]);

    if (Array.isArray(withValue)) {
      for (j = 0; j < m; j++) {
        property.value.push(withRealValue ? withValue[j] : [Token$g.PROPERTY_VALUE, withValue[j]]);
      }
    } else {
      property.value.push(withRealValue ? withValue : [Token$g.PROPERTY_VALUE, withValue]);
    }
  }
}

function multiplexSize(component) {
  var size = 0;

  for (var i = 0, l = component.value.length; i < l; i++) {
    if (component.value[i][1] == Marker$3.COMMA) { size++; }
  }

  return size + 1;
}

function lengthOf(property) {
  var fakeAsArray = [
    Token$g.PROPERTY,
    [Token$g.PROPERTY_NAME, property.name]
  ].concat(property.value);
  return serializeProperty([fakeAsArray], 0).length;
}

function moreSameShorthands(properties, startAt, name) {
  // Since we run the main loop in `compactOverrides` backwards, at this point some
  // properties may not be marked as unused.
  // We should consider reverting the order if possible
  var count = 0;

  for (var i = startAt; i >= 0; i--) {
    if (properties[i].name == name && !properties[i].unused) { count++; }
    if (count > 1) { break; }
  }

  return count > 1;
}

function overridingFunction(shorthand, validator) {
  for (var i = 0, l = shorthand.components.length; i < l; i++) {
    if (!anyValue(validator.isUrl, shorthand.components[i])
      && anyValue(validator.isFunction, shorthand.components[i])) { return true; }
  }

  return false;
}

function anyValue(fn, property) {
  for (var i = 0, l = property.value.length; i < l; i++) {
    if (property.value[i][1] == Marker$3.COMMA) { continue; }

    if (fn(property.value[i][1])) { return true; }
  }

  return false;
}

function wouldResultInLongerValue(left, right) {
  if (!left.multiplex && !right.multiplex || left.multiplex && right.multiplex) { return false; }

  var multiplex = left.multiplex ? left : right;
  var simple = left.multiplex ? right : left;
  var component;

  var multiplexClone = deepClone$1(multiplex);
  restoreFromOptimizing$2([multiplexClone], restoreWithComponents$1);

  var simpleClone = deepClone$1(simple);
  restoreFromOptimizing$2([simpleClone], restoreWithComponents$1);

  var lengthBefore = lengthOf(multiplexClone) + 1 + lengthOf(simpleClone);

  if (left.multiplex) {
    component = findComponentIn(multiplexClone, simpleClone);
    overrideIntoMultiplex(component, simpleClone);
  } else {
    component = findComponentIn(simpleClone, multiplexClone);
    turnIntoMultiplex(simpleClone, multiplexSize(multiplexClone));
    overrideByMultiplex(component, multiplexClone);
  }

  restoreFromOptimizing$2([simpleClone], restoreWithComponents$1);

  var lengthAfter = lengthOf(simpleClone);

  return lengthBefore <= lengthAfter;
}

function isCompactable(property) {
  return property.name in configuration$1;
}

function noneOverrideHack(left, right) {
  return !left.multiplex
    && (left.name == 'background' || left.name == 'background-image')
    && right.multiplex
    && (right.name == 'background' || right.name == 'background-image')
    && anyLayerIsNone(right.value);
}

function anyLayerIsNone(values) {
  var layers = intoLayers(values);

  for (var i = 0, l = layers.length; i < l; i++) {
    if (layers[i].length == 1 && layers[i][0][1] == 'none') { return true; }
  }

  return false;
}

function intoLayers(values) {
  var layers = [];

  for (var i = 0, layer = [], l = values.length; i < l; i++) {
    var value = values[i];
    if (value[1] == Marker$3.COMMA) {
      layers.push(layer);
      layer = [];
    } else {
      layer.push(value);
    }
  }

  layers.push(layer);
  return layers;
}

function overrideProperties$1(properties, withMerging, compatibility, validator) {
  var mayOverride, right, left, component;
  var overriddenComponents;
  var overriddenComponent;
  var overridingComponent;
  var overridable;
  var i, j, k;

  propertyLoop:
  for (i = properties.length - 1; i >= 0; i--) {
    right = properties[i];

    if (!isCompactable(right)) { continue; }

    if (right.block) { continue; }

    mayOverride = configuration$1[right.name].canOverride || sameValue;

    traverseLoop:
    for (j = i - 1; j >= 0; j--) {
      left = properties[j];

      if (!isCompactable(left)) { continue; }

      if (left.block) { continue; }

      if (left.dynamic || right.dynamic) { continue; }

      if (left.unused || right.unused) { continue; }

      if (left.hack && !right.hack && !right.important || !left.hack && !left.important && right.hack) { continue; }

      if (left.important == right.important && left.hack[0] != right.hack[0]) { continue; }

      if (left.important == right.important
        && (left.hack[0] != right.hack[0] || (left.hack[1] && left.hack[1] != right.hack[1]))) { continue; }

      if (hasInherit(right)) { continue; }

      if (noneOverrideHack(left, right)) { continue; }

      if (right.shorthand && isComponentOf(right, left)) {
        // maybe `left` can be overridden by `right` which is a shorthand?
        if (!right.important && left.important) { continue; }

        if (!sameVendorPrefixesIn([left], right.components)) { continue; }

        if (!anyValue(validator.isFunction, left) && overridingFunction(right, validator)) { continue; }

        if (!isMergeableShorthand(right)) {
          left.unused = true;
          continue;
        }

        component = findComponentIn(right, left);
        mayOverride = configuration$1[left.name].canOverride || sameValue;
        if (everyValuesPair(mayOverride.bind(null, validator), left, component)) {
          left.unused = true;
        }
      } else if (right.shorthand && overridesNonComponentShorthand(right, left)) {
        // `right` is a shorthand while `left` can be overriden by it, think `border` and `border-top`
        if (!right.important && left.important) {
          continue;
        }

        if (!sameVendorPrefixesIn([left], right.components)) {
          continue;
        }

        if (!anyValue(validator.isFunction, left) && overridingFunction(right, validator)) {
          continue;
        }

        overriddenComponents = left.shorthand
          ? left.components
          : [left];

        for (k = overriddenComponents.length - 1; k >= 0; k--) {
          overriddenComponent = overriddenComponents[k];
          overridingComponent = findComponentIn(right, overriddenComponent);
          mayOverride = configuration$1[overriddenComponent.name].canOverride || sameValue;

          if (!everyValuesPair(mayOverride.bind(null, validator), left, overridingComponent)) {
            continue traverseLoop;
          }
        }

        left.unused = true;
      } else if (withMerging && left.shorthand && !right.shorthand && isComponentOf(left, right, true)) {
        // maybe `right` can be pulled into `left` which is a shorthand?
        if (right.important && !left.important) { continue; }

        if (!right.important && left.important) {
          right.unused = true;
          continue;
        }

        // Pending more clever algorithm in #527
        if (moreSameShorthands(properties, i - 1, left.name)) { continue; }

        if (overridingFunction(left, validator)) { continue; }

        if (!isMergeableShorthand(left)) { continue; }

        if (hasUnset(left) || hasUnset(right)) { continue; }

        component = findComponentIn(left, right);
        if (everyValuesPair(mayOverride.bind(null, validator), component, right)) {
          var disabledBackgroundMerging = !compatibility.properties.backgroundClipMerging && component.name.indexOf('background-clip') > -1
            || !compatibility.properties.backgroundOriginMerging && component.name.indexOf('background-origin') > -1
            || !compatibility.properties.backgroundSizeMerging && component.name.indexOf('background-size') > -1;
          var nonMergeableValue = configuration$1[right.name].nonMergeableValue === right.value[0][1];

          if (disabledBackgroundMerging || nonMergeableValue) { continue; }

          if (!compatibility.properties.merging && wouldBreakCompatibility(left, validator)) { continue; }

          if (component.value[0][1] != right.value[0][1] && (hasInherit(left) || hasInherit(right))) { continue; }

          if (wouldResultInLongerValue(left, right)) { continue; }

          if (!left.multiplex && right.multiplex) { turnIntoMultiplex(left, multiplexSize(right)); }

          override$2(component, right);
          left.dirty = true;
        }
      } else if (withMerging && left.shorthand && right.shorthand && left.name == right.name) {
        // merge if all components can be merged

        if (!left.multiplex && right.multiplex) { continue; }

        if (!right.important && left.important) {
          right.unused = true;
          continue propertyLoop;
        }

        if (right.important && !left.important) {
          left.unused = true;
          continue;
        }

        if (!isMergeableShorthand(right)) {
          left.unused = true;
          continue;
        }

        for (k = left.components.length - 1; k >= 0; k--) {
          var leftComponent = left.components[k];
          var rightComponent = right.components[k];

          mayOverride = configuration$1[leftComponent.name].canOverride || sameValue;
          if (!everyValuesPair(mayOverride.bind(null, validator), leftComponent, rightComponent)) {
            continue propertyLoop;
          }
        }

        overrideShorthand(left, right);
        left.dirty = true;
      } else if (withMerging && left.shorthand && right.shorthand && isComponentOf(left, right)) {
        // border is a shorthand but any of its components is a shorthand too

        if (!left.important && right.important) { continue; }

        component = findComponentIn(left, right);
        mayOverride = configuration$1[right.name].canOverride || sameValue;
        if (!everyValuesPair(mayOverride.bind(null, validator), component, right)) { continue; }

        if (left.important && !right.important) {
          right.unused = true;
          continue;
        }

        var rightRestored = configuration$1[right.name].restore(right, configuration$1);
        if (rightRestored.length > 1) { continue; }

        component = findComponentIn(left, right);
        override$2(component, right);
        right.dirty = true;
      } else if (left.name == right.name) {
        // two non-shorthands should be merged based on understandability
        overridable = true;

        if (right.shorthand) {
          for (k = right.components.length - 1; k >= 0 && overridable; k--) {
            overriddenComponent = left.components[k];
            overridingComponent = right.components[k];
            mayOverride = configuration$1[overridingComponent.name].canOverride || sameValue;

            overridable = everyValuesPair(mayOverride.bind(null, validator), overriddenComponent, overridingComponent);
          }
        } else {
          mayOverride = configuration$1[right.name].canOverride || sameValue;
          overridable = everyValuesPair(mayOverride.bind(null, validator), left, right);
        }

        if (left.important && !right.important && overridable) {
          right.unused = true;
          continue;
        }

        if (!left.important && right.important && overridable) {
          left.unused = true;
          continue;
        }

        if (!overridable) {
          continue;
        }

        left.unused = true;
      }
    }
  }
}

var overrideProperties_1 = overrideProperties$1;

var mergeIntoShorthands = mergeIntoShorthands_1;
var overrideProperties = overrideProperties_1;
var populateComponents$1 = populateComponents_1;

var restoreWithComponents = restoreWithComponents_1;

var wrapForOptimizing$1 = wrapForOptimizing$3.all;
var removeUnused = removeUnused_1;
var restoreFromOptimizing$1 = restoreFromOptimizing_1;

var OptimizationLevel$5 = optimizationLevel.OptimizationLevel;

function optimizeProperties$4(properties, withOverriding, withMerging, context) {
  var levelOptions = context.options.level[OptimizationLevel$5.Two];
  var _properties = wrapForOptimizing$1(properties, levelOptions.skipProperties);
  var _property;
  var i, l;

  populateComponents$1(_properties, context.validator, context.warnings);

  for (i = 0, l = _properties.length; i < l; i++) {
    _property = _properties[i];
    if (_property.block) {
      optimizeProperties$4(_property.value[0][1], withOverriding, withMerging, context);
    }
  }

  if (withMerging && levelOptions.mergeIntoShorthands) {
    mergeIntoShorthands(_properties, context.validator);
  }

  if (withOverriding && levelOptions.overrideProperties) {
    overrideProperties(_properties, withMerging, context.options.compatibility, context.validator);
  }

  restoreFromOptimizing$1(_properties, restoreWithComponents);
  removeUnused(_properties);
}

var optimize$2 = optimizeProperties$4;

var isMergeable$3 = isMergeable_1;

var optimizeProperties$3 = optimize$2;

var sortSelectors$1 = sortSelectors_1;
var tidyRules$1 = tidyRules_1;

var OptimizationLevel$4 = optimizationLevel.OptimizationLevel;

var serializeBody$4 = oneTime.body;
var serializeRules$8 = oneTime.rules;

var Token$f = token;

function mergeAdjacent$1(tokens, context) {
  var lastToken = [null, [], []];
  var options = context.options;
  var adjacentSpace = options.compatibility.selectors.adjacentSpace;
  var selectorsSortingMethod = options.level[OptimizationLevel$4.One].selectorsSortingMethod;
  var mergeablePseudoClasses = options.compatibility.selectors.mergeablePseudoClasses;
  var mergeablePseudoElements = options.compatibility.selectors.mergeablePseudoElements;
  var mergeLimit = options.compatibility.selectors.mergeLimit;
  var multiplePseudoMerging = options.compatibility.selectors.multiplePseudoMerging;

  for (var i = 0, l = tokens.length; i < l; i++) {
    var token = tokens[i];

    if (token[0] != Token$f.RULE) {
      lastToken = [null, [], []];
      continue;
    }

    if (lastToken[0] == Token$f.RULE && serializeRules$8(token[1]) == serializeRules$8(lastToken[1])) {
      Array.prototype.push.apply(lastToken[2], token[2]);
      optimizeProperties$3(lastToken[2], true, true, context);
      token[2] = [];
    } else if (lastToken[0] == Token$f.RULE && serializeBody$4(token[2]) == serializeBody$4(lastToken[2])
        && isMergeable$3(serializeRules$8(token[1]), mergeablePseudoClasses, mergeablePseudoElements, multiplePseudoMerging)
        && isMergeable$3(
          serializeRules$8(lastToken[1]),
          mergeablePseudoClasses,
          mergeablePseudoElements,
          multiplePseudoMerging
        )
        && lastToken[1].length < mergeLimit) {
      lastToken[1] = tidyRules$1(lastToken[1].concat(token[1]), false, adjacentSpace, false, context.warnings);
      lastToken[1] = lastToken.length > 1 ? sortSelectors$1(lastToken[1], selectorsSortingMethod) : lastToken[1];
      token[2] = [];
    } else {
      lastToken = token;
    }
  }
}

var mergeAdjacent_1 = mergeAdjacent$1;

var MODIFIER_PATTERN = /--.+$/;

function rulesOverlap$2(rule1, rule2, bemMode) {
  var scope1;
  var scope2;
  var i, l;
  var j, m;

  for (i = 0, l = rule1.length; i < l; i++) {
    scope1 = rule1[i][1];

    for (j = 0, m = rule2.length; j < m; j++) {
      scope2 = rule2[j][1];

      if (scope1 == scope2) {
        return true;
      }

      if (bemMode && withoutModifiers(scope1) == withoutModifiers(scope2)) {
        return true;
      }
    }
  }

  return false;
}

function withoutModifiers(scope) {
  return scope.replace(MODIFIER_PATTERN, '');
}

var rulesOverlap_1 = rulesOverlap$2;

var Marker$2 = marker;

var Selector = {
  ADJACENT_SIBLING: '+',
  DESCENDANT: '>',
  DOT: '.',
  HASH: '#',
  NON_ADJACENT_SIBLING: '~',
  PSEUDO: ':'
};

var LETTER_PATTERN = /[a-zA-Z]/;
var NOT_PREFIX = ':not(';
var SEPARATOR_PATTERN = /[\s,(>~+]/;

function specificity$1(selector) {
  var result = [0, 0, 0];
  var character;
  var isEscaped;
  var isSingleQuoted;
  var isDoubleQuoted;
  var roundBracketLevel = 0;
  var couldIntroduceNewTypeSelector;
  var withinNotPseudoClass = false;
  var wasPseudoClass = false;
  var i, l;

  for (i = 0, l = selector.length; i < l; i++) {
    character = selector[i];

    if (isEscaped) ; else if (character == Marker$2.SINGLE_QUOTE && !isDoubleQuoted && !isSingleQuoted) {
      isSingleQuoted = true;
    } else if (character == Marker$2.SINGLE_QUOTE && !isDoubleQuoted && isSingleQuoted) {
      isSingleQuoted = false;
    } else if (character == Marker$2.DOUBLE_QUOTE && !isDoubleQuoted && !isSingleQuoted) {
      isDoubleQuoted = true;
    } else if (character == Marker$2.DOUBLE_QUOTE && isDoubleQuoted && !isSingleQuoted) {
      isDoubleQuoted = false;
    } else if (isSingleQuoted || isDoubleQuoted) {
      continue;
    } else if (roundBracketLevel > 0 && !withinNotPseudoClass) ; else if (character == Marker$2.OPEN_ROUND_BRACKET) {
      roundBracketLevel++;
    } else if (character == Marker$2.CLOSE_ROUND_BRACKET && roundBracketLevel == 1) {
      roundBracketLevel--;
      withinNotPseudoClass = false;
    } else if (character == Marker$2.CLOSE_ROUND_BRACKET) {
      roundBracketLevel--;
    } else if (character == Selector.HASH) {
      result[0]++;
    } else if (character == Selector.DOT || character == Marker$2.OPEN_SQUARE_BRACKET) {
      result[1]++;
    } else if (character == Selector.PSEUDO && !wasPseudoClass && !isNotPseudoClass(selector, i)) {
      result[1]++;
      withinNotPseudoClass = false;
    } else if (character == Selector.PSEUDO) {
      withinNotPseudoClass = true;
    } else if ((i === 0 || couldIntroduceNewTypeSelector) && LETTER_PATTERN.test(character)) {
      result[2]++;
    }

    isEscaped = character == Marker$2.BACK_SLASH;
    wasPseudoClass = character == Selector.PSEUDO;
    couldIntroduceNewTypeSelector = !isEscaped && SEPARATOR_PATTERN.test(character);
  }

  return result;
}

function isNotPseudoClass(selector, index) {
  return selector.indexOf(NOT_PREFIX, index) === index;
}

var specificity_1 = specificity$1;

var specificity = specificity_1;

function specificitiesOverlap$1(selector1, selector2, cache) {
  var specificity1;
  var specificity2;
  var i, l;
  var j, m;

  for (i = 0, l = selector1.length; i < l; i++) {
    specificity1 = findSpecificity(selector1[i][1], cache);

    for (j = 0, m = selector2.length; j < m; j++) {
      specificity2 = findSpecificity(selector2[j][1], cache);

      if (specificity1[0] === specificity2[0]
        && specificity1[1] === specificity2[1]
        && specificity1[2] === specificity2[2]) {
        return true;
      }
    }
  }

  return false;
}

function findSpecificity(selector, cache) {
  var value;

  if (!(selector in cache)) {
    cache[selector] = value = specificity(selector);
  }

  return value || cache[selector];
}

var specificitiesOverlap_1 = specificitiesOverlap$1;

// TODO: it'd be great to merge it with the other canReorder functionality

var rulesOverlap$1 = rulesOverlap_1;
var specificitiesOverlap = specificitiesOverlap_1;

var FLEX_PROPERTIES = /align-items|box-align|box-pack|flex|justify/;
var BORDER_PROPERTIES = /^border-(top|right|bottom|left|color|style|width|radius)/;

function canReorder$2(left, right, cache) {
  for (var i = right.length - 1; i >= 0; i--) {
    for (var j = left.length - 1; j >= 0; j--) {
      if (!canReorderSingle$2(left[j], right[i], cache)) { return false; }
    }
  }

  return true;
}

function canReorderSingle$2(left, right, cache) {
  var leftName = left[0];
  var leftValue = left[1];
  var leftNameRoot = left[2];
  var leftSelector = left[5];
  var leftInSpecificSelector = left[6];
  var rightName = right[0];
  var rightValue = right[1];
  var rightNameRoot = right[2];
  var rightSelector = right[5];
  var rightInSpecificSelector = right[6];

  if (leftName == 'font' && rightName == 'line-height' || rightName == 'font' && leftName == 'line-height') { return false; }
  if (FLEX_PROPERTIES.test(leftName) && FLEX_PROPERTIES.test(rightName)) { return false; }
  if (leftNameRoot == rightNameRoot
    && unprefixed(leftName) == unprefixed(rightName)
    && (vendorPrefixed(leftName) ^ vendorPrefixed(rightName))) { return false; }
  if (leftNameRoot == 'border' && BORDER_PROPERTIES.test(rightNameRoot) && (leftName == 'border' || leftName == rightNameRoot || (leftValue != rightValue && sameBorderComponent(leftName, rightName)))) { return false; }
  if (rightNameRoot == 'border' && BORDER_PROPERTIES.test(leftNameRoot) && (rightName == 'border' || rightName == leftNameRoot || (leftValue != rightValue && sameBorderComponent(leftName, rightName)))) { return false; }
  if (leftNameRoot == 'border' && rightNameRoot == 'border' && leftName != rightName && (isSideBorder(leftName) && isStyleBorder(rightName) || isStyleBorder(leftName) && isSideBorder(rightName))) { return false; }
  if (leftNameRoot != rightNameRoot) { return true; }
  if (leftName == rightName
    && leftNameRoot == rightNameRoot
    && (leftValue == rightValue || withDifferentVendorPrefix(leftValue, rightValue))) { return true; }
  if (leftName != rightName
    && leftNameRoot == rightNameRoot
    && leftName != leftNameRoot
    && rightName != rightNameRoot) { return true; }
  if (leftName != rightName
    && leftNameRoot == rightNameRoot
    && leftValue == rightValue) { return true; }
  if (rightInSpecificSelector
    && leftInSpecificSelector
    && !inheritable(leftNameRoot)
    && !inheritable(rightNameRoot)
    && !rulesOverlap$1(rightSelector, leftSelector, false)) { return true; }
  if (!specificitiesOverlap(leftSelector, rightSelector, cache)) { return true; }

  return false;
}

function vendorPrefixed(name) {
  return /^-(?:moz|webkit|ms|o)-/.test(name);
}

function unprefixed(name) {
  return name.replace(/^-(?:moz|webkit|ms|o)-/, '');
}

function sameBorderComponent(name1, name2) {
  return name1.split('-').pop() == name2.split('-').pop();
}

function isSideBorder(name) {
  return name == 'border-top' || name == 'border-right' || name == 'border-bottom' || name == 'border-left';
}

function isStyleBorder(name) {
  return name == 'border-color' || name == 'border-style' || name == 'border-width';
}

function withDifferentVendorPrefix(value1, value2) {
  return vendorPrefixed(value1) && vendorPrefixed(value2) && value1.split('-')[1] != value2.split('-')[2];
}

function inheritable(name) {
  // According to http://www.w3.org/TR/CSS21/propidx.html
  // Others will be catched by other, preceeding rules
  return name == 'font' || name == 'line-height' || name == 'list-style';
}

var reorderable = {
  canReorder: canReorder$2,
  canReorderSingle: canReorderSingle$2
};

// This extractor is used in level 2 optimizations
// IMPORTANT: Mind Token class and this code is not related!
// Properties will be tokenized in one step, see #429

var Token$e = token;
var serializeRules$7 = oneTime.rules;
var serializeValue = oneTime.value;

function extractProperties$3(token) {
  var properties = [];
  var inSpecificSelector;
  var property;
  var name;
  var value;
  var i, l;

  if (token[0] == Token$e.RULE) {
    inSpecificSelector = !/[.+>~]/.test(serializeRules$7(token[1]));

    for (i = 0, l = token[2].length; i < l; i++) {
      property = token[2][i];

      if (property[0] != Token$e.PROPERTY) { continue; }

      name = property[1][1];
      if (name.length === 0) { continue; }

      value = serializeValue(property, i);

      properties.push([
        name,
        value,
        findNameRoot(name),
        token[2][i],
        name + ':' + value,
        token[1],
        inSpecificSelector
      ]);
    }
  } else if (token[0] == Token$e.NESTED_BLOCK) {
    for (i = 0, l = token[2].length; i < l; i++) {
      properties = properties.concat(extractProperties$3(token[2][i]));
    }
  }

  return properties;
}

function findNameRoot(name) {
  if (name == 'list-style') { return name; }
  if (name.indexOf('-radius') > 0) { return 'border-radius'; }
  if (name == 'border-collapse' || name == 'border-spacing' || name == 'border-image') { return name; }
  if (name.indexOf('border-') === 0 && /^border-\w+-\w+$/.test(name)) { return name.match(/border-\w+/)[0]; }
  if (name.indexOf('border-') === 0 && /^border-\w+$/.test(name)) { return 'border'; }
  if (name.indexOf('text-') === 0) { return name; }
  if (name == '-chrome-') { return name; }

  return name.replace(/^-\w+-/, '').match(/([a-zA-Z]+)/)[0].toLowerCase();
}

var extractProperties_1 = extractProperties$3;

var canReorder$1 = reorderable.canReorder;
var canReorderSingle$1 = reorderable.canReorderSingle;
var extractProperties$2 = extractProperties_1;
var rulesOverlap = rulesOverlap_1;

var serializeRules$6 = oneTime.rules;
var OptimizationLevel$3 = optimizationLevel.OptimizationLevel;
var Token$d = token;

function mergeMediaQueries$1(tokens, context) {
  var mergeSemantically = context.options.level[OptimizationLevel$3.Two].mergeSemantically;
  var specificityCache = context.cache.specificity;
  var candidates = {};
  var reduced = [];

  for (var i = tokens.length - 1; i >= 0; i--) {
    var token = tokens[i];
    if (token[0] != Token$d.NESTED_BLOCK) {
      continue;
    }

    var key = serializeRules$6(token[1]);
    var candidate = candidates[key];
    if (!candidate) {
      candidate = [];
      candidates[key] = candidate;
    }

    candidate.push(i);
  }

  for (var name in candidates) {
    var positions = candidates[name];

    positionLoop:
    for (var j = positions.length - 1; j > 0; j--) {
      var positionOne = positions[j];
      var tokenOne = tokens[positionOne];
      var positionTwo = positions[j - 1];
      var tokenTwo = tokens[positionTwo];

      directionLoop:
      for (var direction = 1; direction >= -1; direction -= 2) {
        var topToBottom = direction == 1;
        var from = topToBottom ? positionOne + 1 : positionTwo - 1;
        var to = topToBottom ? positionTwo : positionOne;
        var delta = topToBottom ? 1 : -1;
        var source = topToBottom ? tokenOne : tokenTwo;
        var target = topToBottom ? tokenTwo : tokenOne;
        var movedProperties = extractProperties$2(source);

        while (from != to) {
          var traversedProperties = extractProperties$2(tokens[from]);
          from += delta;

          if (mergeSemantically
            && allSameRulePropertiesCanBeReordered(movedProperties, traversedProperties, specificityCache)
          ) {
            continue;
          }

          if (!canReorder$1(movedProperties, traversedProperties, specificityCache)) { continue directionLoop; }
        }

        target[2] = topToBottom
          ? source[2].concat(target[2])
          : target[2].concat(source[2]);
        source[2] = [];

        reduced.push(target);
        continue positionLoop;
      }
    }
  }

  return reduced;
}

function allSameRulePropertiesCanBeReordered(movedProperties, traversedProperties, specificityCache) {
  var movedProperty;
  var movedRule;
  var traversedProperty;
  var traversedRule;
  var i, l;
  var j, m;

  for (i = 0, l = movedProperties.length; i < l; i++) {
    movedProperty = movedProperties[i];
    movedRule = movedProperty[5];

    for (j = 0, m = traversedProperties.length; j < m; j++) {
      traversedProperty = traversedProperties[j];
      traversedRule = traversedProperty[5];

      if (rulesOverlap(movedRule, traversedRule, true)
        && !canReorderSingle$1(movedProperty, traversedProperty, specificityCache)) {
        return false;
      }
    }
  }

  return true;
}

var mergeMediaQueries_1 = mergeMediaQueries$1;

var isMergeable$2 = isMergeable_1;

var sortSelectors = sortSelectors_1;
var tidyRules = tidyRules_1;

var OptimizationLevel$2 = optimizationLevel.OptimizationLevel;

var serializeBody$3 = oneTime.body;
var serializeRules$5 = oneTime.rules;

var Token$c = token;

function unsafeSelector(value) {
  return /\.|\*| :/.test(value);
}

function isBemElement(token) {
  var asString = serializeRules$5(token[1]);
  return asString.indexOf('__') > -1 || asString.indexOf('--') > -1;
}

function withoutModifier(selector) {
  return selector.replace(/--[^ ,>+~:]+/g, '');
}

function removeAnyUnsafeElements(left, candidates) {
  var leftSelector = withoutModifier(serializeRules$5(left[1]));

  for (var body in candidates) {
    var right = candidates[body];
    var rightSelector = withoutModifier(serializeRules$5(right[1]));

    if (rightSelector.indexOf(leftSelector) > -1 || leftSelector.indexOf(rightSelector) > -1) {
      delete candidates[body];
    }
  }
}

function mergeNonAdjacentByBody$1(tokens, context) {
  var options = context.options;
  var mergeSemantically = options.level[OptimizationLevel$2.Two].mergeSemantically;
  var adjacentSpace = options.compatibility.selectors.adjacentSpace;
  var selectorsSortingMethod = options.level[OptimizationLevel$2.One].selectorsSortingMethod;
  var mergeablePseudoClasses = options.compatibility.selectors.mergeablePseudoClasses;
  var mergeablePseudoElements = options.compatibility.selectors.mergeablePseudoElements;
  var multiplePseudoMerging = options.compatibility.selectors.multiplePseudoMerging;
  var candidates = {};

  for (var i = tokens.length - 1; i >= 0; i--) {
    var token = tokens[i];
    if (token[0] != Token$c.RULE) { continue; }

    if (token[2].length > 0 && (!mergeSemantically && unsafeSelector(serializeRules$5(token[1])))) { candidates = {}; }

    if (token[2].length > 0 && mergeSemantically && isBemElement(token)) { removeAnyUnsafeElements(token, candidates); }

    var candidateBody = serializeBody$3(token[2]);
    var oldToken = candidates[candidateBody];
    if (oldToken
        && isMergeable$2(
          serializeRules$5(token[1]),
          mergeablePseudoClasses,
          mergeablePseudoElements,
          multiplePseudoMerging
        )
        && isMergeable$2(
          serializeRules$5(oldToken[1]),
          mergeablePseudoClasses,
          mergeablePseudoElements,
          multiplePseudoMerging
        )
    ) {
      if (token[2].length > 0) {
        token[1] = tidyRules(oldToken[1].concat(token[1]), false, adjacentSpace, false, context.warnings);
        token[1] = token[1].length > 1 ? sortSelectors(token[1], selectorsSortingMethod) : token[1];
      } else {
        token[1] = oldToken[1].concat(token[1]);
      }

      oldToken[2] = [];
      candidates[candidateBody] = null;
    }

    candidates[serializeBody$3(token[2])] = token;
  }
}

var mergeNonAdjacentByBody_1 = mergeNonAdjacentByBody$1;

var canReorder = reorderable.canReorder;
var extractProperties$1 = extractProperties_1;

var optimizeProperties$2 = optimize$2;

var serializeRules$4 = oneTime.rules;

var Token$b = token;

function mergeNonAdjacentBySelector$1(tokens, context) {
  var specificityCache = context.cache.specificity;
  var allSelectors = {};
  var repeatedSelectors = [];
  var i;

  for (i = tokens.length - 1; i >= 0; i--) {
    if (tokens[i][0] != Token$b.RULE) { continue; }
    if (tokens[i][2].length === 0) { continue; }

    var selector = serializeRules$4(tokens[i][1]);
    allSelectors[selector] = [i].concat(allSelectors[selector] || []);

    if (allSelectors[selector].length == 2) { repeatedSelectors.push(selector); }
  }

  for (i = repeatedSelectors.length - 1; i >= 0; i--) {
    var positions = allSelectors[repeatedSelectors[i]];

    selectorIterator:
    for (var j = positions.length - 1; j > 0; j--) {
      var positionOne = positions[j - 1];
      var tokenOne = tokens[positionOne];
      var positionTwo = positions[j];
      var tokenTwo = tokens[positionTwo];

      directionIterator:
      for (var direction = 1; direction >= -1; direction -= 2) {
        var topToBottom = direction == 1;
        var from = topToBottom ? positionOne + 1 : positionTwo - 1;
        var to = topToBottom ? positionTwo : positionOne;
        var delta = topToBottom ? 1 : -1;
        var moved = topToBottom ? tokenOne : tokenTwo;
        var target = topToBottom ? tokenTwo : tokenOne;
        var movedProperties = extractProperties$1(moved);

        while (from != to) {
          var traversedProperties = extractProperties$1(tokens[from]);
          from += delta;

          // traversed then moved as we move selectors towards the start
          var reorderable = topToBottom
            ? canReorder(movedProperties, traversedProperties, specificityCache)
            : canReorder(traversedProperties, movedProperties, specificityCache);

          if (!reorderable && !topToBottom) { continue selectorIterator; }
          if (!reorderable && topToBottom) { continue directionIterator; }
        }

        if (topToBottom) {
          Array.prototype.push.apply(moved[2], target[2]);
          target[2] = moved[2];
        } else {
          Array.prototype.push.apply(target[2], moved[2]);
        }

        optimizeProperties$2(target[2], true, true, context);
        moved[2] = [];
      }
    }
  }
}

var mergeNonAdjacentBySelector_1 = mergeNonAdjacentBySelector$1;

function cloneArray$2(array) {
  var cloned = array.slice(0);

  for (var i = 0, l = cloned.length; i < l; i++) {
    if (Array.isArray(cloned[i])) { cloned[i] = cloneArray$2(cloned[i]); }
  }

  return cloned;
}

var cloneArray_1 = cloneArray$2;

var isMergeable$1 = isMergeable_1;

var optimizeProperties$1 = optimize$2;

var cloneArray$1 = cloneArray_1;

var Token$a = token;

var serializeBody$2 = oneTime.body;
var serializeRules$3 = oneTime.rules;

function reduceNonAdjacent$1(tokens, context) {
  var options = context.options;
  var mergeablePseudoClasses = options.compatibility.selectors.mergeablePseudoClasses;
  var mergeablePseudoElements = options.compatibility.selectors.mergeablePseudoElements;
  var multiplePseudoMerging = options.compatibility.selectors.multiplePseudoMerging;
  var candidates = {};
  var repeated = [];

  for (var i = tokens.length - 1; i >= 0; i--) {
    var token = tokens[i];

    if (token[0] != Token$a.RULE) {
      continue;
    } else if (token[2].length === 0) {
      continue;
    }

    var selectorAsString = serializeRules$3(token[1]);
    var isComplexAndNotSpecial = token[1].length > 1
      && isMergeable$1(selectorAsString, mergeablePseudoClasses, mergeablePseudoElements, multiplePseudoMerging);
    var wrappedSelectors = wrappedSelectorsFrom(token[1]);
    var selectors = isComplexAndNotSpecial
      ? [selectorAsString].concat(wrappedSelectors)
      : [selectorAsString];

    for (var j = 0, m = selectors.length; j < m; j++) {
      var selector = selectors[j];

      if (!candidates[selector]) { candidates[selector] = []; } else { repeated.push(selector); }

      candidates[selector].push({
        where: i,
        list: wrappedSelectors,
        isPartial: isComplexAndNotSpecial && j > 0,
        isComplex: isComplexAndNotSpecial && j === 0
      });
    }
  }

  reduceSimpleNonAdjacentCases(tokens, repeated, candidates, options, context);
  reduceComplexNonAdjacentCases(tokens, candidates, options, context);
}

function wrappedSelectorsFrom(list) {
  var wrapped = [];

  for (var i = 0; i < list.length; i++) {
    wrapped.push([list[i][1]]);
  }

  return wrapped;
}

function reduceSimpleNonAdjacentCases(tokens, repeated, candidates, options, context) {
  function filterOut(idx, bodies) {
    return data[idx].isPartial && bodies.length === 0;
  }

  function reduceBody(token, newBody, processedCount, tokenIdx) {
    if (!data[processedCount - tokenIdx - 1].isPartial) { token[2] = newBody; }
  }

  for (var i = 0, l = repeated.length; i < l; i++) {
    var selector = repeated[i];
    var data = candidates[selector];

    reduceSelector(tokens, data, {
      filterOut: filterOut,
      callback: reduceBody
    }, options, context);
  }
}

function reduceComplexNonAdjacentCases(tokens, candidates, options, context) {
  var mergeablePseudoClasses = options.compatibility.selectors.mergeablePseudoClasses;
  var mergeablePseudoElements = options.compatibility.selectors.mergeablePseudoElements;
  var multiplePseudoMerging = options.compatibility.selectors.multiplePseudoMerging;
  var localContext = {};

  function filterOut(idx) {
    return localContext.data[idx].where < localContext.intoPosition;
  }

  function collectReducedBodies(token, newBody, processedCount, tokenIdx) {
    if (tokenIdx === 0) { localContext.reducedBodies.push(newBody); }
  }

  allSelectors:
  for (var complexSelector in candidates) {
    var into = candidates[complexSelector];
    if (!into[0].isComplex) { continue; }

    var intoPosition = into[into.length - 1].where;
    var intoToken = tokens[intoPosition];
    var reducedBodies = [];

    var selectors = isMergeable$1(complexSelector, mergeablePseudoClasses, mergeablePseudoElements, multiplePseudoMerging)
      ? into[0].list
      : [complexSelector];

    localContext.intoPosition = intoPosition;
    localContext.reducedBodies = reducedBodies;

    for (var j = 0, m = selectors.length; j < m; j++) {
      var selector = selectors[j];
      var data = candidates[selector];

      if (data.length < 2) { continue allSelectors; }

      localContext.data = data;

      reduceSelector(tokens, data, {
        filterOut: filterOut,
        callback: collectReducedBodies
      }, options, context);

      if (serializeBody$2(reducedBodies[reducedBodies.length - 1]) != serializeBody$2(reducedBodies[0])) {
        continue allSelectors;
      }
    }

    intoToken[2] = reducedBodies[0];
  }
}

function reduceSelector(tokens, data, context, options, outerContext) {
  var bodies = [];
  var bodiesAsList = [];
  var processedTokens = [];

  for (var j = data.length - 1; j >= 0; j--) {
    if (context.filterOut(j, bodies)) { continue; }

    var where = data[j].where;
    var token = tokens[where];
    var clonedBody = cloneArray$1(token[2]);

    bodies = bodies.concat(clonedBody);
    bodiesAsList.push(clonedBody);
    processedTokens.push(where);
  }

  optimizeProperties$1(bodies, true, false, outerContext);

  var processedCount = processedTokens.length;
  var propertyIdx = bodies.length - 1;
  var tokenIdx = processedCount - 1;

  while (tokenIdx >= 0) {
    if ((tokenIdx === 0
      || (bodies[propertyIdx] && bodiesAsList[tokenIdx].indexOf(bodies[propertyIdx]) > -1)) && propertyIdx > -1) {
      propertyIdx--;
      continue;
    }

    var newBody = bodies.splice(propertyIdx + 1);
    context.callback(tokens[processedTokens[tokenIdx]], newBody, processedCount, tokenIdx);

    tokenIdx--;
  }
}

var reduceNonAdjacent_1 = reduceNonAdjacent$1;

var Token$9 = token;

var serializeAll$1 = oneTime.all;

var FONT_FACE_SCOPE = '@font-face';

function removeDuplicateFontAtRules$1(tokens) {
  var fontAtRules = [];
  var token;
  var key;
  var i, l;

  for (i = 0, l = tokens.length; i < l; i++) {
    token = tokens[i];

    if (token[0] != Token$9.AT_RULE_BLOCK && token[1][0][1] != FONT_FACE_SCOPE) {
      continue;
    }

    key = serializeAll$1([token]);

    if (fontAtRules.indexOf(key) > -1) {
      token[2] = [];
    } else {
      fontAtRules.push(key);
    }
  }
}

var removeDuplicateFontAtRules_1 = removeDuplicateFontAtRules$1;

var Token$8 = token;

var serializeAll = oneTime.all;
var serializeRules$2 = oneTime.rules;

function removeDuplicateMediaQueries$1(tokens) {
  var candidates = {};
  var candidate;
  var token;
  var key;
  var i, l;

  for (i = 0, l = tokens.length; i < l; i++) {
    token = tokens[i];
    if (token[0] != Token$8.NESTED_BLOCK) {
      continue;
    }

    key = serializeRules$2(token[1]) + '%' + serializeAll(token[2]);
    candidate = candidates[key];

    if (candidate) {
      candidate[2] = [];
    }

    candidates[key] = token;
  }
}

var removeDuplicateMediaQueries_1 = removeDuplicateMediaQueries$1;

var Token$7 = token;

var serializeBody$1 = oneTime.body;
var serializeRules$1 = oneTime.rules;

function removeDuplicates$1(tokens) {
  var matched = {};
  var moreThanOnce = [];
  var id, token;
  var body, bodies;

  for (var i = 0, l = tokens.length; i < l; i++) {
    token = tokens[i];
    if (token[0] != Token$7.RULE) { continue; }

    id = serializeRules$1(token[1]);

    if (matched[id] && matched[id].length == 1) { moreThanOnce.push(id); } else { matched[id] = matched[id] || []; }

    matched[id].push(i);
  }

  for (i = 0, l = moreThanOnce.length; i < l; i++) {
    id = moreThanOnce[i];
    bodies = [];

    for (var j = matched[id].length - 1; j >= 0; j--) {
      token = tokens[matched[id][j]];
      body = serializeBody$1(token[2]);

      if (bodies.indexOf(body) > -1) { token[2] = []; } else { bodies.push(body); }
    }
  }
}

var removeDuplicates_1 = removeDuplicates$1;

var populateComponents = populateComponents_1;

var wrapForOptimizing = wrapForOptimizing$3.single;
var restoreFromOptimizing = restoreFromOptimizing_1;

var Token$6 = token;

var animationNameRegex = /^(-moz-|-o-|-webkit-)?animation-name$/;
var animationRegex = /^(-moz-|-o-|-webkit-)?animation$/;
var keyframeRegex = /^@(-moz-|-o-|-webkit-)?keyframes /;
var importantRegex = /\s{0,31}!important$/;
var optionalMatchingQuotesRegex = /^(['"]?)(.*)\1$/;

function normalize$1(value) {
  return value
    .replace(optionalMatchingQuotesRegex, '$2')
    .replace(importantRegex, '');
}

function removeUnusedAtRules$1(tokens, context) {
  removeUnusedAtRule(tokens, matchCounterStyle, markCounterStylesAsUsed, context);
  removeUnusedAtRule(tokens, matchFontFace, markFontFacesAsUsed, context);
  removeUnusedAtRule(tokens, matchKeyframe, markKeyframesAsUsed, context);
  removeUnusedAtRule(tokens, matchNamespace, markNamespacesAsUsed, context);
}

function removeUnusedAtRule(tokens, matchCallback, markCallback, context) {
  var atRules = {};
  var atRule;
  var atRuleTokens;
  var atRuleToken;
  var zeroAt;
  var i, l;

  for (i = 0, l = tokens.length; i < l; i++) {
    matchCallback(tokens[i], atRules);
  }

  if (Object.keys(atRules).length === 0) {
    return;
  }

  markUsedAtRules(tokens, markCallback, atRules, context);

  for (atRule in atRules) {
    atRuleTokens = atRules[atRule];

    for (i = 0, l = atRuleTokens.length; i < l; i++) {
      atRuleToken = atRuleTokens[i];
      zeroAt = atRuleToken[0] == Token$6.AT_RULE ? 1 : 2;
      atRuleToken[zeroAt] = [];
    }
  }
}

function markUsedAtRules(tokens, markCallback, atRules, context) {
  var boundMarkCallback = markCallback(atRules);
  var i, l;

  for (i = 0, l = tokens.length; i < l; i++) {
    switch (tokens[i][0]) {
    case Token$6.RULE:
      boundMarkCallback(tokens[i], context);
      break;
    case Token$6.NESTED_BLOCK:
      markUsedAtRules(tokens[i][2], markCallback, atRules, context);
    }
  }
}

function matchCounterStyle(token, atRules) {
  var match;

  if (token[0] == Token$6.AT_RULE_BLOCK && token[1][0][1].indexOf('@counter-style') === 0) {
    match = token[1][0][1].split(' ')[1];
    atRules[match] = atRules[match] || [];
    atRules[match].push(token);
  }
}

function markCounterStylesAsUsed(atRules) {
  return function(token, context) {
    var property;
    var wrappedProperty;
    var i, l;

    for (i = 0, l = token[2].length; i < l; i++) {
      property = token[2][i];

      if (property[1][1] == 'list-style') {
        wrappedProperty = wrapForOptimizing(property);
        populateComponents([wrappedProperty], context.validator, context.warnings);

        if (wrappedProperty.components[0].value[0][1] in atRules) {
          delete atRules[property[2][1]];
        }

        restoreFromOptimizing([wrappedProperty]);
      }

      if (property[1][1] == 'list-style-type' && property[2][1] in atRules) {
        delete atRules[property[2][1]];
      }
    }
  };
}

function matchFontFace(token, atRules) {
  var property;
  var match;
  var i, l;

  if (token[0] == Token$6.AT_RULE_BLOCK && token[1][0][1] == '@font-face') {
    for (i = 0, l = token[2].length; i < l; i++) {
      property = token[2][i];

      if (property[1][1] == 'font-family') {
        match = normalize$1(property[2][1].toLowerCase());
        atRules[match] = atRules[match] || [];
        atRules[match].push(token);
        break;
      }
    }
  }
}

function markFontFacesAsUsed(atRules) {
  return function(token, context) {
    var property;
    var wrappedProperty;
    var component;
    var normalizedMatch;
    var i, l;
    var j, m;

    for (i = 0, l = token[2].length; i < l; i++) {
      property = token[2][i];

      if (property[1][1] == 'font') {
        wrappedProperty = wrapForOptimizing(property);
        populateComponents([wrappedProperty], context.validator, context.warnings);
        component = wrappedProperty.components[6];

        for (j = 0, m = component.value.length; j < m; j++) {
          normalizedMatch = normalize$1(component.value[j][1].toLowerCase());

          if (normalizedMatch in atRules) {
            delete atRules[normalizedMatch];
          }
        }

        restoreFromOptimizing([wrappedProperty]);
      }

      if (property[1][1] == 'font-family') {
        for (j = 2, m = property.length; j < m; j++) {
          normalizedMatch = normalize$1(property[j][1].toLowerCase());

          if (normalizedMatch in atRules) {
            delete atRules[normalizedMatch];
          }
        }
      }
    }
  };
}

function matchKeyframe(token, atRules) {
  var match;

  if (token[0] == Token$6.NESTED_BLOCK && keyframeRegex.test(token[1][0][1])) {
    match = token[1][0][1].split(' ')[1];
    atRules[match] = atRules[match] || [];
    atRules[match].push(token);
  }
}

function markKeyframesAsUsed(atRules) {
  return function(token, context) {
    var property;
    var wrappedProperty;
    var component;
    var i, l;
    var j, m;

    for (i = 0, l = token[2].length; i < l; i++) {
      property = token[2][i];

      if (animationRegex.test(property[1][1])) {
        wrappedProperty = wrapForOptimizing(property);
        populateComponents([wrappedProperty], context.validator, context.warnings);
        component = wrappedProperty.components[7];

        for (j = 0, m = component.value.length; j < m; j++) {
          if (component.value[j][1] in atRules) {
            delete atRules[component.value[j][1]];
          }
        }

        restoreFromOptimizing([wrappedProperty]);
      }

      if (animationNameRegex.test(property[1][1])) {
        for (j = 2, m = property.length; j < m; j++) {
          if (property[j][1] in atRules) {
            delete atRules[property[j][1]];
          }
        }
      }
    }
  };
}

function matchNamespace(token, atRules) {
  var match;

  if (token[0] == Token$6.AT_RULE && token[1].indexOf('@namespace') === 0) {
    match = token[1].split(' ')[1];
    atRules[match] = atRules[match] || [];
    atRules[match].push(token);
  }
}

function markNamespacesAsUsed(atRules) {
  var namespaceRegex = new RegExp(Object.keys(atRules).join('\\||') + '\\|', 'g');

  return function(token) {
    var match;
    var scope;
    var normalizedMatch;
    var i, l;
    var j, m;

    for (i = 0, l = token[1].length; i < l; i++) {
      scope = token[1][i];
      match = scope[1].match(namespaceRegex);

      for (j = 0, m = match.length; j < m; j++) {
        normalizedMatch = match[j].substring(0, match[j].length - 1);

        if (normalizedMatch in atRules) {
          delete atRules[normalizedMatch];
        }
      }
    }
  };
}

var removeUnusedAtRules_1 = removeUnusedAtRules$1;

function ruleSorter(s1, s2) {
  return s1[1] > s2[1] ? 1 : -1;
}

function tidyRuleDuplicates$1(rules) {
  var list = [];
  var repeated = [];

  for (var i = 0, l = rules.length; i < l; i++) {
    var rule = rules[i];

    if (repeated.indexOf(rule[1]) == -1) {
      repeated.push(rule[1]);
      list.push(rule);
    }
  }

  return list.sort(ruleSorter);
}

var tidyRuleDuplicates_1 = tidyRuleDuplicates$1;

var canReorderSingle = reorderable.canReorderSingle;
var extractProperties = extractProperties_1;
var isMergeable = isMergeable_1;
var tidyRuleDuplicates = tidyRuleDuplicates_1;

var Token$5 = token;

var cloneArray = cloneArray_1;

var serializeBody = oneTime.body;
var serializeRules = oneTime.rules;

function naturalSorter(a, b) {
  return a > b ? 1 : -1;
}

function cloneAndMergeSelectors(propertyA, propertyB) {
  var cloned = cloneArray(propertyA);
  cloned[5] = cloned[5].concat(propertyB[5]);

  return cloned;
}

function restructure$1(tokens, context) {
  var options = context.options;
  var mergeablePseudoClasses = options.compatibility.selectors.mergeablePseudoClasses;
  var mergeablePseudoElements = options.compatibility.selectors.mergeablePseudoElements;
  var mergeLimit = options.compatibility.selectors.mergeLimit;
  var multiplePseudoMerging = options.compatibility.selectors.multiplePseudoMerging;
  var specificityCache = context.cache.specificity;
  var movableTokens = {};
  var movedProperties = [];
  var multiPropertyMoveCache = {};
  var movedToBeDropped = [];
  var maxCombinationsLevel = 2;
  var ID_JOIN_CHARACTER = '%';

  function sendToMultiPropertyMoveCache(position, movedProperty, allFits) {
    for (var i = allFits.length - 1; i >= 0; i--) {
      var fit = allFits[i][0];
      var id = addToCache(movedProperty, fit);

      if (multiPropertyMoveCache[id].length > 1 && processMultiPropertyMove(position, multiPropertyMoveCache[id])) {
        removeAllMatchingFromCache(id);
        break;
      }
    }
  }

  function addToCache(movedProperty, fit) {
    var id = cacheId(fit);
    multiPropertyMoveCache[id] = multiPropertyMoveCache[id] || [];
    multiPropertyMoveCache[id].push([movedProperty, fit]);
    return id;
  }

  function removeAllMatchingFromCache(matchId) {
    var matchSelectors = matchId.split(ID_JOIN_CHARACTER);
    var forRemoval = [];
    var i;

    for (var id in multiPropertyMoveCache) {
      var selectors = id.split(ID_JOIN_CHARACTER);
      for (i = selectors.length - 1; i >= 0; i--) {
        if (matchSelectors.indexOf(selectors[i]) > -1) {
          forRemoval.push(id);
          break;
        }
      }
    }

    for (i = forRemoval.length - 1; i >= 0; i--) {
      delete multiPropertyMoveCache[forRemoval[i]];
    }
  }

  function cacheId(cachedTokens) {
    var id = [];
    for (var i = 0, l = cachedTokens.length; i < l; i++) {
      id.push(serializeRules(cachedTokens[i][1]));
    }
    return id.join(ID_JOIN_CHARACTER);
  }

  function tokensToMerge(sourceTokens) {
    var uniqueTokensWithBody = [];
    var mergeableTokens = [];

    for (var i = sourceTokens.length - 1; i >= 0; i--) {
      if (!isMergeable(
        serializeRules(sourceTokens[i][1]),
        mergeablePseudoClasses,
        mergeablePseudoElements,
        multiplePseudoMerging
      )) {
        continue;
      }

      mergeableTokens.unshift(sourceTokens[i]);
      if (sourceTokens[i][2].length > 0
        && uniqueTokensWithBody.indexOf(sourceTokens[i]) == -1) {
        uniqueTokensWithBody.push(sourceTokens[i]);
      }
    }

    return uniqueTokensWithBody.length > 1
      ? mergeableTokens
      : [];
  }

  function shortenIfPossible(position, movedProperty) {
    var name = movedProperty[0];
    var value = movedProperty[1];
    var key = movedProperty[4];
    var valueSize = name.length + value.length + 1;
    var allSelectors = [];
    var qualifiedTokens = [];

    var mergeableTokens = tokensToMerge(movableTokens[key]);
    if (mergeableTokens.length < 2) { return; }

    var allFits = findAllFits(mergeableTokens, valueSize, 1);
    var bestFit = allFits[0];
    if (bestFit[1] > 0) { return sendToMultiPropertyMoveCache(position, movedProperty, allFits); }

    for (var i = bestFit[0].length - 1; i >= 0; i--) {
      allSelectors = bestFit[0][i][1].concat(allSelectors);
      qualifiedTokens.unshift(bestFit[0][i]);
    }

    allSelectors = tidyRuleDuplicates(allSelectors);
    dropAsNewTokenAt(position, [movedProperty], allSelectors, qualifiedTokens);
  }

  function fitSorter(fit1, fit2) {
    return fit1[1] > fit2[1] ? 1 : (fit1[1] == fit2[1] ? 0 : -1);
  }

  function findAllFits(mergeableTokens, propertySize, propertiesCount) {
    var combinations = allCombinations(mergeableTokens, propertySize, propertiesCount, maxCombinationsLevel - 1);
    return combinations.sort(fitSorter);
  }

  function allCombinations(tokensVariant, propertySize, propertiesCount, level) {
    var differenceVariants = [[tokensVariant, sizeDifference(tokensVariant, propertySize, propertiesCount)]];
    if (tokensVariant.length > 2 && level > 0) {
      for (var i = tokensVariant.length - 1; i >= 0; i--) {
        var subVariant = Array.prototype.slice.call(tokensVariant, 0);
        subVariant.splice(i, 1);
        differenceVariants = differenceVariants.concat(
          allCombinations(subVariant, propertySize, propertiesCount, level - 1)
        );
      }
    }

    return differenceVariants;
  }

  function sizeDifference(tokensVariant, propertySize, propertiesCount) {
    var allSelectorsSize = 0;
    for (var i = tokensVariant.length - 1; i >= 0; i--) {
      allSelectorsSize += tokensVariant[i][2].length > propertiesCount
        ? serializeRules(tokensVariant[i][1]).length
        : -1;
    }
    return allSelectorsSize - (tokensVariant.length - 1) * propertySize + 1;
  }

  function dropAsNewTokenAt(position, properties, allSelectors, mergeableTokens) {
    var i, j, k, m;
    var allProperties = [];

    for (i = mergeableTokens.length - 1; i >= 0; i--) {
      var mergeableToken = mergeableTokens[i];

      for (j = mergeableToken[2].length - 1; j >= 0; j--) {
        var mergeableProperty = mergeableToken[2][j];

        for (k = 0, m = properties.length; k < m; k++) {
          var property = properties[k];

          var mergeablePropertyName = mergeableProperty[1][1];
          var propertyName = property[0];
          var propertyBody = property[4];
          if (mergeablePropertyName == propertyName && serializeBody([mergeableProperty]) == propertyBody) {
            mergeableToken[2].splice(j, 1);
            break;
          }
        }
      }
    }

    for (i = properties.length - 1; i >= 0; i--) {
      allProperties.unshift(properties[i][3]);
    }

    var newToken = [Token$5.RULE, allSelectors, allProperties];
    tokens.splice(position, 0, newToken);
  }

  function dropPropertiesAt(position, movedProperty) {
    var key = movedProperty[4];
    var toMove = movableTokens[key];

    if (toMove && toMove.length > 1) {
      if (!shortenMultiMovesIfPossible(position, movedProperty)) { shortenIfPossible(position, movedProperty); }
    }
  }

  function shortenMultiMovesIfPossible(position, movedProperty) {
    var candidates = [];
    var propertiesAndMergableTokens = [];
    var key = movedProperty[4];
    var j, k;

    var mergeableTokens = tokensToMerge(movableTokens[key]);
    if (mergeableTokens.length < 2) { return; }

    movableLoop:
    for (var value in movableTokens) {
      var tokensList = movableTokens[value];

      for (j = mergeableTokens.length - 1; j >= 0; j--) {
        if (tokensList.indexOf(mergeableTokens[j]) == -1) { continue movableLoop; }
      }

      candidates.push(value);
    }

    if (candidates.length < 2) { return false; }

    for (j = candidates.length - 1; j >= 0; j--) {
      for (k = movedProperties.length - 1; k >= 0; k--) {
        if (movedProperties[k][4] == candidates[j]) {
          propertiesAndMergableTokens.unshift([movedProperties[k], mergeableTokens]);
          break;
        }
      }
    }

    return processMultiPropertyMove(position, propertiesAndMergableTokens);
  }

  function processMultiPropertyMove(position, propertiesAndMergableTokens) {
    var valueSize = 0;
    var properties = [];
    var property;

    for (var i = propertiesAndMergableTokens.length - 1; i >= 0; i--) {
      property = propertiesAndMergableTokens[i][0];
      var fullValue = property[4];
      valueSize += fullValue.length + (i > 0 ? 1 : 0);

      properties.push(property);
    }

    var mergeableTokens = propertiesAndMergableTokens[0][1];
    var bestFit = findAllFits(mergeableTokens, valueSize, properties.length)[0];
    if (bestFit[1] > 0) { return false; }

    var allSelectors = [];
    var qualifiedTokens = [];
    for (i = bestFit[0].length - 1; i >= 0; i--) {
      allSelectors = bestFit[0][i][1].concat(allSelectors);
      qualifiedTokens.unshift(bestFit[0][i]);
    }

    allSelectors = tidyRuleDuplicates(allSelectors);
    dropAsNewTokenAt(position, properties, allSelectors, qualifiedTokens);

    for (i = properties.length - 1; i >= 0; i--) {
      property = properties[i];
      var index = movedProperties.indexOf(property);

      delete movableTokens[property[4]];

      if (index > -1 && movedToBeDropped.indexOf(index) == -1) { movedToBeDropped.push(index); }
    }

    return true;
  }

  function boundToAnotherPropertyInCurrrentToken(property, movedProperty, token) {
    var propertyName = property[0];
    var movedPropertyName = movedProperty[0];
    if (propertyName != movedPropertyName) { return false; }

    var key = movedProperty[4];
    var toMove = movableTokens[key];
    return toMove && toMove.indexOf(token) > -1;
  }

  for (var i = tokens.length - 1; i >= 0; i--) {
    var token = tokens[i];
    var isRule;
    var j, k, m;
    var samePropertyAt;

    if (token[0] == Token$5.RULE) {
      isRule = true;
    } else if (token[0] == Token$5.NESTED_BLOCK) {
      isRule = false;
    } else {
      continue;
    }

    // We cache movedProperties.length as it may change in the loop
    var movedCount = movedProperties.length;

    var properties = extractProperties(token);
    movedToBeDropped = [];

    var unmovableInCurrentToken = [];
    for (j = properties.length - 1; j >= 0; j--) {
      for (k = j - 1; k >= 0; k--) {
        if (!canReorderSingle(properties[j], properties[k], specificityCache)) {
          unmovableInCurrentToken.push(j);
          break;
        }
      }
    }

    for (j = properties.length - 1; j >= 0; j--) {
      var property = properties[j];
      var movedSameProperty = false;

      for (k = 0; k < movedCount; k++) {
        var movedProperty = movedProperties[k];

        if (movedToBeDropped.indexOf(k) == -1 && (
          !canReorderSingle(property, movedProperty, specificityCache)
          && !boundToAnotherPropertyInCurrrentToken(property, movedProperty, token)
          || movableTokens[movedProperty[4]] && movableTokens[movedProperty[4]].length === mergeLimit)
        ) {
          dropPropertiesAt(i + 1, movedProperty);

          if (movedToBeDropped.indexOf(k) == -1) {
            movedToBeDropped.push(k);
            delete movableTokens[movedProperty[4]];
          }
        }

        if (!movedSameProperty) {
          movedSameProperty = property[0] == movedProperty[0] && property[1] == movedProperty[1];

          if (movedSameProperty) {
            samePropertyAt = k;
          }
        }
      }

      if (!isRule || unmovableInCurrentToken.indexOf(j) > -1) { continue; }

      var key = property[4];

      if (movedSameProperty && movedProperties[samePropertyAt][5].length + property[5].length > mergeLimit) {
        dropPropertiesAt(i + 1, movedProperties[samePropertyAt]);
        movedProperties.splice(samePropertyAt, 1);
        movableTokens[key] = [token];
        movedSameProperty = false;
      } else {
        movableTokens[key] = movableTokens[key] || [];
        movableTokens[key].push(token);
      }

      if (movedSameProperty) {
        movedProperties[samePropertyAt] = cloneAndMergeSelectors(movedProperties[samePropertyAt], property);
      } else {
        movedProperties.push(property);
      }
    }

    movedToBeDropped = movedToBeDropped.sort(naturalSorter);
    for (j = 0, m = movedToBeDropped.length; j < m; j++) {
      var dropAt = movedToBeDropped[j] - j;
      movedProperties.splice(dropAt, 1);
    }
  }

  var position = tokens[0] && tokens[0][0] == Token$5.AT_RULE && tokens[0][1].indexOf('@charset') === 0 ? 1 : 0;
  for (; position < tokens.length - 1; position++) {
    var isImportRule = tokens[position][0] === Token$5.AT_RULE && tokens[position][1].indexOf('@import') === 0;
    var isComment = tokens[position][0] === Token$5.COMMENT;
    if (!(isImportRule || isComment)) { break; }
  }

  for (i = 0; i < movedProperties.length; i++) {
    dropPropertiesAt(position, movedProperties[i]);
  }
}

var restructure_1 = restructure$1;

var mergeAdjacent = mergeAdjacent_1;
var mergeMediaQueries = mergeMediaQueries_1;
var mergeNonAdjacentByBody = mergeNonAdjacentByBody_1;
var mergeNonAdjacentBySelector = mergeNonAdjacentBySelector_1;
var reduceNonAdjacent = reduceNonAdjacent_1;
var removeDuplicateFontAtRules = removeDuplicateFontAtRules_1;
var removeDuplicateMediaQueries = removeDuplicateMediaQueries_1;
var removeDuplicates = removeDuplicates_1;
var removeUnusedAtRules = removeUnusedAtRules_1;
var restructure = restructure_1;

var optimizeProperties = optimize$2;

var OptimizationLevel$1 = optimizationLevel.OptimizationLevel;

var Token$4 = token;

function removeEmpty(tokens) {
  for (var i = 0, l = tokens.length; i < l; i++) {
    var token = tokens[i];
    var isEmpty = false;

    switch (token[0]) {
    case Token$4.RULE:
      isEmpty = token[1].length === 0 || token[2].length === 0;
      break;
    case Token$4.NESTED_BLOCK:
      removeEmpty(token[2]);
      isEmpty = token[2].length === 0;
      break;
    case Token$4.AT_RULE:
      isEmpty = token[1].length === 0;
      break;
    case Token$4.AT_RULE_BLOCK:
      isEmpty = token[2].length === 0;
    }

    if (isEmpty) {
      tokens.splice(i, 1);
      i--;
      l--;
    }
  }
}

function recursivelyOptimizeBlocks(tokens, context) {
  for (var i = 0, l = tokens.length; i < l; i++) {
    var token = tokens[i];

    if (token[0] == Token$4.NESTED_BLOCK) {
      var isKeyframes = /@(-moz-|-o-|-webkit-)?keyframes/.test(token[1][0][1]);
      level2Optimize$1(token[2], context, !isKeyframes);
    }
  }
}

function recursivelyOptimizeProperties(tokens, context) {
  for (var i = 0, l = tokens.length; i < l; i++) {
    var token = tokens[i];

    switch (token[0]) {
    case Token$4.RULE:
      optimizeProperties(token[2], true, true, context);
      break;
    case Token$4.NESTED_BLOCK:
      recursivelyOptimizeProperties(token[2], context);
    }
  }
}

function level2Optimize$1(tokens, context, withRestructuring) {
  var levelOptions = context.options.level[OptimizationLevel$1.Two];
  var level2Plugins = context.options.plugins.level2Block;
  var reduced;
  var i;

  recursivelyOptimizeBlocks(tokens, context);
  recursivelyOptimizeProperties(tokens, context);

  if (levelOptions.removeDuplicateRules) {
    removeDuplicates(tokens);
  }

  if (levelOptions.mergeAdjacentRules) {
    mergeAdjacent(tokens, context);
  }

  if (levelOptions.reduceNonAdjacentRules) {
    reduceNonAdjacent(tokens, context);
  }

  if (levelOptions.mergeNonAdjacentRules && levelOptions.mergeNonAdjacentRules != 'body') {
    mergeNonAdjacentBySelector(tokens, context);
  }

  if (levelOptions.mergeNonAdjacentRules && levelOptions.mergeNonAdjacentRules != 'selector') {
    mergeNonAdjacentByBody(tokens, context);
  }

  if (levelOptions.restructureRules && levelOptions.mergeAdjacentRules && withRestructuring) {
    restructure(tokens, context);
    mergeAdjacent(tokens, context);
  }

  if (levelOptions.restructureRules && !levelOptions.mergeAdjacentRules && withRestructuring) {
    restructure(tokens, context);
  }

  if (levelOptions.removeDuplicateFontRules) {
    removeDuplicateFontAtRules(tokens);
  }

  if (levelOptions.removeDuplicateMediaBlocks) {
    removeDuplicateMediaQueries(tokens);
  }

  if (levelOptions.removeUnusedAtRules) {
    removeUnusedAtRules(tokens, context);
  }

  if (levelOptions.mergeMedia) {
    reduced = mergeMediaQueries(tokens, context);
    for (i = reduced.length - 1; i >= 0; i--) {
      level2Optimize$1(reduced[i][2], context, false);
    }
  }

  for (i = 0; i < level2Plugins.length; i++) {
    level2Plugins[i](tokens);
  }

  if (levelOptions.removeEmpty) {
    removeEmpty(tokens);
  }

  return tokens;
}

var optimize$1 = level2Optimize$1;

var functionNoVendorRegexStr = '[A-Z]+(\\-|[A-Z]|[0-9])+\\(.*?\\)';
var functionVendorRegexStr = '\\-(\\-|[A-Z]|[0-9])+\\(.*?\\)';
var variableRegexStr = 'var\\(\\-\\-[^\\)]+\\)';
var functionAnyRegexStr = '(' + variableRegexStr + '|' + functionNoVendorRegexStr + '|' + functionVendorRegexStr + ')';

var calcRegex = new RegExp('^(\\-moz\\-|\\-webkit\\-)?calc\\([^\\)]+\\)$', 'i');
var decimalRegex = /[0-9]/;
var functionAnyRegex = new RegExp('^' + functionAnyRegexStr + '$', 'i');
var hexAlphaColorRegex = /^#(?:[0-9a-f]{4}|[0-9a-f]{8})$/i;
// eslint-disable-next-line max-len
var hslColorRegex = /^hsl\(\s{0,31}[-.]?\d+\s{0,31},\s{0,31}\d*\.?\d+%\s{0,31},\s{0,31}\d*\.?\d+%\s{0,31}\)|hsla\(\s{0,31}[-.]?\d+\s{0,31},\s{0,31}\d*\.?\d+%\s{0,31},\s{0,31}\d*\.?\d+%\s{0,31},\s{0,31}\.?\d+\s{0,31}\)$/;
// eslint-disable-next-line max-len
var hslColorWithSpacesRegex = /^hsl\(\s{0,31}[-.]?\d+(deg)?\s{1,31}\d*\.?\d+%\s{1,31}\d*\.?\d+%\s{0,31}\)|hsla\(\s{0,31}[-.]?\d+(deg)?\s{1,31}\d*\.?\d+%\s{1,31}\d*\.?\d+%\s{1,31}\/\s{1,31}\d*\.?\d+%?\s{0,31}\)$/;
var identifierRegex = /^(-[a-z0-9_][a-z0-9\-_]*|[a-z_][a-z0-9\-_]*)$/i;
var namedEntityRegex = /^[a-z]+$/i;
var prefixRegex = /^-([a-z0-9]|-)*$/i;
var quotedTextRegex = /^("[^"]*"|'[^']*')$/i;
// eslint-disable-next-line max-len
var rgbColorRegex = /^rgb\(\s{0,31}[\d]{1,3}\s{0,31},\s{0,31}[\d]{1,3}\s{0,31},\s{0,31}[\d]{1,3}\s{0,31}\)|rgba\(\s{0,31}[\d]{1,3}\s{0,31},\s{0,31}[\d]{1,3}\s{0,31},\s{0,31}[\d]{1,3}\s{0,31},\s{0,31}[.\d]+\s{0,31}\)$/i;
// eslint-disable-next-line max-len
var rgbColorWithSpacesRegex = /^rgb\(\s{0,31}[\d]{1,3}\s{1,31}[\d]{1,3}\s{1,31}[\d]{1,3}\s{0,31}\)|rgba\(\s{0,31}[\d]{1,3}\s{1,31}[\d]{1,3}\s{1,31}[\d]{1,3}\s{1,31}\/\s{1,31}[\d]*\.?[.\d]+%?\s{0,31}\)$/i;
var timeUnitPattern = /\d+(s|ms)/;
var timingFunctionRegex = /^(cubic-bezier|steps)\([^)]+\)$/;
var validTimeUnits = ['ms', 's'];
var urlRegex = /^url\([\s\S]+\)$/i;
var variableRegex = new RegExp('^' + variableRegexStr + '$', 'i');

var eightValueColorRegex = /^#[0-9a-f]{8}$/i;
var fourValueColorRegex = /^#[0-9a-f]{4}$/i;
var sixValueColorRegex = /^#[0-9a-f]{6}$/i;
var threeValueColorRegex = /^#[0-9a-f]{3}$/i;

var DECIMAL_DOT = '.';
var MINUS_SIGN = '-';
var PLUS_SIGN = '+';

var Keywords = {
  '^': [
    'inherit',
    'initial',
    'unset'
  ],
  '*-style': [
    'auto',
    'dashed',
    'dotted',
    'double',
    'groove',
    'hidden',
    'inset',
    'none',
    'outset',
    'ridge',
    'solid'
  ],
  '*-timing-function': [
    'ease',
    'ease-in',
    'ease-in-out',
    'ease-out',
    'linear',
    'step-end',
    'step-start'
  ],
  'animation-direction': [
    'alternate',
    'alternate-reverse',
    'normal',
    'reverse'
  ],
  'animation-fill-mode': [
    'backwards',
    'both',
    'forwards',
    'none'
  ],
  'animation-iteration-count': [
    'infinite'
  ],
  'animation-name': [
    'none'
  ],
  'animation-play-state': [
    'paused',
    'running'
  ],
  'background-attachment': [
    'fixed',
    'inherit',
    'local',
    'scroll'
  ],
  'background-clip': [
    'border-box',
    'content-box',
    'inherit',
    'padding-box',
    'text'
  ],
  'background-origin': [
    'border-box',
    'content-box',
    'inherit',
    'padding-box'
  ],
  'background-position': [
    'bottom',
    'center',
    'left',
    'right',
    'top'
  ],
  'background-repeat': [
    'no-repeat',
    'inherit',
    'repeat',
    'repeat-x',
    'repeat-y',
    'round',
    'space'
  ],
  'background-size': [
    'auto',
    'cover',
    'contain'
  ],
  'border-collapse': [
    'collapse',
    'inherit',
    'separate'
  ],
  bottom: [
    'auto'
  ],
  clear: [
    'both',
    'left',
    'none',
    'right'
  ],
  color: [
    'transparent'
  ],
  cursor: [
    'all-scroll',
    'auto',
    'col-resize',
    'crosshair',
    'default',
    'e-resize',
    'help',
    'move',
    'n-resize',
    'ne-resize',
    'no-drop',
    'not-allowed',
    'nw-resize',
    'pointer',
    'progress',
    'row-resize',
    's-resize',
    'se-resize',
    'sw-resize',
    'text',
    'vertical-text',
    'w-resize',
    'wait'
  ],
  display: [
    'block',
    'inline',
    'inline-block',
    'inline-table',
    'list-item',
    'none',
    'table',
    'table-caption',
    'table-cell',
    'table-column',
    'table-column-group',
    'table-footer-group',
    'table-header-group',
    'table-row',
    'table-row-group'
  ],
  float: [
    'left',
    'none',
    'right'
  ],
  left: [
    'auto'
  ],
  font: [
    'caption',
    'icon',
    'menu',
    'message-box',
    'small-caption',
    'status-bar',
    'unset'
  ],
  'font-size': [
    'large',
    'larger',
    'medium',
    'small',
    'smaller',
    'x-large',
    'x-small',
    'xx-large',
    'xx-small'
  ],
  'font-stretch': [
    'condensed',
    'expanded',
    'extra-condensed',
    'extra-expanded',
    'normal',
    'semi-condensed',
    'semi-expanded',
    'ultra-condensed',
    'ultra-expanded'
  ],
  'font-style': [
    'italic',
    'normal',
    'oblique'
  ],
  'font-variant': [
    'normal',
    'small-caps'
  ],
  'font-weight': [
    '100',
    '200',
    '300',
    '400',
    '500',
    '600',
    '700',
    '800',
    '900',
    'bold',
    'bolder',
    'lighter',
    'normal'
  ],
  'line-height': [
    'normal'
  ],
  'list-style-position': [
    'inside',
    'outside'
  ],
  'list-style-type': [
    'armenian',
    'circle',
    'decimal',
    'decimal-leading-zero',
    'disc',
    'decimal|disc', // this is the default value of list-style-type, see comment in configuration.js
    'georgian',
    'lower-alpha',
    'lower-greek',
    'lower-latin',
    'lower-roman',
    'none',
    'square',
    'upper-alpha',
    'upper-latin',
    'upper-roman'
  ],
  overflow: [
    'auto',
    'hidden',
    'scroll',
    'visible'
  ],
  position: [
    'absolute',
    'fixed',
    'relative',
    'static'
  ],
  right: [
    'auto'
  ],
  'text-align': [
    'center',
    'justify',
    'left',
    'left|right', // this is the default value of list-style-type, see comment in configuration.js
    'right'
  ],
  'text-decoration': [
    'line-through',
    'none',
    'overline',
    'underline'
  ],
  'text-overflow': [
    'clip',
    'ellipsis'
  ],
  top: [
    'auto'
  ],
  'vertical-align': [
    'baseline',
    'bottom',
    'middle',
    'sub',
    'super',
    'text-bottom',
    'text-top',
    'top'
  ],
  visibility: [
    'collapse',
    'hidden',
    'visible'
  ],
  'white-space': [
    'normal',
    'nowrap',
    'pre'
  ],
  width: [
    'inherit',
    'initial',
    'medium',
    'thick',
    'thin'
  ]
};

var Units = [
  '%',
  'ch',
  'cm',
  'em',
  'ex',
  'in',
  'mm',
  'pc',
  'pt',
  'px',
  'rem',
  'vh',
  'vm',
  'vmax',
  'vmin',
  'vw'
];

function isColor(value) {
  return value != 'auto'
    && (
      isKeyword('color')(value)
      || isHexColor(value)
      || isColorFunction(value)
      || isNamedEntity(value)
    );
}

function isColorFunction(value) {
  return isRgbColor(value) || isHslColor(value);
}

function isDynamicUnit(value) {
  return calcRegex.test(value);
}

function isFunction(value) {
  return functionAnyRegex.test(value);
}

function isHexColor(value) {
  return threeValueColorRegex.test(value)
    || fourValueColorRegex.test(value)
    || sixValueColorRegex.test(value)
    || eightValueColorRegex.test(value);
}

function isHslColor(value) {
  return hslColorRegex.test(value) || hslColorWithSpacesRegex.test(value);
}

function isHexAlphaColor(value) {
  return hexAlphaColorRegex.test(value);
}

function isIdentifier(value) {
  return identifierRegex.test(value);
}

function isQuotedText(value) {
  return quotedTextRegex.test(value);
}

function isImage(value) {
  return value == 'none' || value == 'inherit' || isUrl(value);
}

function isKeyword(propertyName) {
  return function(value) {
    return Keywords[propertyName].indexOf(value) > -1;
  };
}

function isNamedEntity(value) {
  return namedEntityRegex.test(value);
}

function isNumber(value) {
  return scanForNumber(value) == value.length;
}

function isRgbColor(value) {
  return rgbColorRegex.test(value) || rgbColorWithSpacesRegex.test(value);
}

function isPrefixed(value) {
  return prefixRegex.test(value);
}

function isPositiveNumber(value) {
  return isNumber(value)
    && parseFloat(value) >= 0;
}

function isVariable(value) {
  return variableRegex.test(value);
}

function isTime(value) {
  var numberUpTo = scanForNumber(value);

  return numberUpTo == value.length && parseInt(value) === 0
    || numberUpTo > -1 && validTimeUnits.indexOf(value.slice(numberUpTo + 1)) > -1
    || isCalculatedTime(value);
}

function isCalculatedTime(value) {
  return isFunction(value) && timeUnitPattern.test(value);
}

function isTimingFunction() {
  var isTimingFunctionKeyword = isKeyword('*-timing-function');

  return function(value) {
    return isTimingFunctionKeyword(value) || timingFunctionRegex.test(value);
  };
}

function isUnit(validUnits, value) {
  var numberUpTo = scanForNumber(value);

  return numberUpTo == value.length && parseInt(value) === 0
    || numberUpTo > -1 && validUnits.indexOf(value.slice(numberUpTo + 1).toLowerCase()) > -1
    || value == 'auto'
    || value == 'inherit';
}

function isUrl(value) {
  return urlRegex.test(value);
}

function isZIndex(value) {
  return value == 'auto'
    || isNumber(value)
    || isKeyword('^')(value);
}

function scanForNumber(value) {
  var hasDot = false;
  var hasSign = false;
  var character;
  var i, l;

  for (i = 0, l = value.length; i < l; i++) {
    character = value[i];

    if (i === 0 && (character == PLUS_SIGN || character == MINUS_SIGN)) {
      hasSign = true;
    } else if (i > 0 && hasSign && (character == PLUS_SIGN || character == MINUS_SIGN)) {
      return i - 1;
    } else if (character == DECIMAL_DOT && !hasDot) {
      hasDot = true;
    } else if (character == DECIMAL_DOT && hasDot) {
      return i - 1;
    } else if (decimalRegex.test(character)) {
      continue;
    } else {
      return i - 1;
    }
  }

  return i;
}

function validator$2(compatibility) {
  var validUnits = Units.slice(0).filter(function(value) {
    return !(value in compatibility.units) || compatibility.units[value] === true;
  });

  if (compatibility.customUnits.rpx) {
    validUnits.push('rpx');
  }

  return {
    colorOpacity: compatibility.colors.opacity,
    colorHexAlpha: compatibility.colors.hexAlpha,
    isAnimationDirectionKeyword: isKeyword('animation-direction'),
    isAnimationFillModeKeyword: isKeyword('animation-fill-mode'),
    isAnimationIterationCountKeyword: isKeyword('animation-iteration-count'),
    isAnimationNameKeyword: isKeyword('animation-name'),
    isAnimationPlayStateKeyword: isKeyword('animation-play-state'),
    isTimingFunction: isTimingFunction(),
    isBackgroundAttachmentKeyword: isKeyword('background-attachment'),
    isBackgroundClipKeyword: isKeyword('background-clip'),
    isBackgroundOriginKeyword: isKeyword('background-origin'),
    isBackgroundPositionKeyword: isKeyword('background-position'),
    isBackgroundRepeatKeyword: isKeyword('background-repeat'),
    isBackgroundSizeKeyword: isKeyword('background-size'),
    isColor: isColor,
    isColorFunction: isColorFunction,
    isDynamicUnit: isDynamicUnit,
    isFontKeyword: isKeyword('font'),
    isFontSizeKeyword: isKeyword('font-size'),
    isFontStretchKeyword: isKeyword('font-stretch'),
    isFontStyleKeyword: isKeyword('font-style'),
    isFontVariantKeyword: isKeyword('font-variant'),
    isFontWeightKeyword: isKeyword('font-weight'),
    isFunction: isFunction,
    isGlobal: isKeyword('^'),
    isHexAlphaColor: isHexAlphaColor,
    isHslColor: isHslColor,
    isIdentifier: isIdentifier,
    isImage: isImage,
    isKeyword: isKeyword,
    isLineHeightKeyword: isKeyword('line-height'),
    isListStylePositionKeyword: isKeyword('list-style-position'),
    isListStyleTypeKeyword: isKeyword('list-style-type'),
    isNumber: isNumber,
    isPrefixed: isPrefixed,
    isPositiveNumber: isPositiveNumber,
    isQuotedText: isQuotedText,
    isRgbColor: isRgbColor,
    isStyleKeyword: isKeyword('*-style'),
    isTime: isTime,
    isUnit: isUnit.bind(null, validUnits),
    isUrl: isUrl,
    isVariable: isVariable,
    isWidth: isKeyword('width'),
    isZIndex: isZIndex
  };
}

var validator_1 = validator$2;

var DEFAULTS = {
  '*': {
    colors: {
      hexAlpha: false, // 4- and 8-character hex notation
      opacity: true // rgba / hsla
    },
    customUnits: { rpx: false },
    properties: {
      backgroundClipMerging: true, // background-clip to shorthand
      backgroundOriginMerging: true, // background-origin to shorthand
      backgroundSizeMerging: true, // background-size to shorthand
      colors: true, // any kind of color transformations, like `#ff00ff` to `#f0f` or `#fff` into `red`
      ieBangHack: false, // !ie suffix hacks on IE<8
      ieFilters: false, // whether to preserve `filter` and `-ms-filter` properties
      iePrefixHack: false, // underscore / asterisk prefix hacks on IE
      ieSuffixHack: false, // \9 suffix hacks on IE6-9, \0 suffix hack on IE6-11
      merging: true, // merging properties into one
      shorterLengthUnits: false, // optimize pixel units into `pt`, `pc` or `in` units
      spaceAfterClosingBrace: true, // 'url() no-repeat' to 'url()no-repeat'
      urlQuotes: true, // whether to wrap content of `url()` into quotes or not
      zeroUnits: true // 0[unit] -> 0
    },
    selectors: {
      adjacentSpace: false, // div+ nav Android stock browser hack
      ie7Hack: false, // *+html hack
      mergeablePseudoClasses: [
        ':active',
        ':after',
        ':before',
        ':empty',
        ':checked',
        ':disabled',
        ':empty',
        ':enabled',
        ':first-child',
        ':first-letter',
        ':first-line',
        ':first-of-type',
        ':focus',
        ':hover',
        ':lang',
        ':last-child',
        ':last-of-type',
        ':link',
        ':not',
        ':nth-child',
        ':nth-last-child',
        ':nth-last-of-type',
        ':nth-of-type',
        ':only-child',
        ':only-of-type',
        ':root',
        ':target',
        ':visited'
      ], // selectors with these pseudo-classes can be merged as these are universally supported
      mergeablePseudoElements: [
        '::after',
        '::before',
        '::first-letter',
        '::first-line'
      ], // selectors with these pseudo-elements can be merged as these are universally supported
      mergeLimit: 8191, // number of rules that can be safely merged together
      multiplePseudoMerging: true
    },
    units: {
      ch: true,
      in: true,
      pc: true,
      pt: true,
      rem: true,
      vh: true,
      vm: true, // vm is vmin on IE9+ see https://developer.mozilla.org/en-US/docs/Web/CSS/length
      vmax: true,
      vmin: true,
      vw: true
    }
  }
};

DEFAULTS.ie11 = merge(DEFAULTS['*'], { properties: { ieSuffixHack: true } });

DEFAULTS.ie10 = merge(DEFAULTS['*'], { properties: { ieSuffixHack: true } });

DEFAULTS.ie9 = merge(DEFAULTS['*'], {
  properties: {
    ieFilters: true,
    ieSuffixHack: true
  }
});

DEFAULTS.ie8 = merge(DEFAULTS.ie9, {
  colors: { opacity: false },
  properties: {
    backgroundClipMerging: false,
    backgroundOriginMerging: false,
    backgroundSizeMerging: false,
    iePrefixHack: true,
    merging: false
  },
  selectors: {
    mergeablePseudoClasses: [
      ':after',
      ':before',
      ':first-child',
      ':first-letter',
      ':focus',
      ':hover',
      ':visited'
    ],
    mergeablePseudoElements: []
  },
  units: {
    ch: false,
    rem: false,
    vh: false,
    vm: false,
    vmax: false,
    vmin: false,
    vw: false
  }
});

DEFAULTS.ie7 = merge(DEFAULTS.ie8, {
  properties: { ieBangHack: true },
  selectors: {
    ie7Hack: true,
    mergeablePseudoClasses: [
      ':first-child',
      ':first-letter',
      ':hover',
      ':visited'
    ]
  }
});

function compatibilityFrom$1(source) {
  return merge(DEFAULTS['*'], calculateSource(source));
}

function merge(source, target) {
  for (var key in source) {
    if (Object.prototype.hasOwnProperty.call(source, key)) {
      var value = source[key];

      if (Object.prototype.hasOwnProperty.call(target, key) && typeof value === 'object' && !Array.isArray(value)) {
        target[key] = merge(value, target[key] || {});
      } else {
        target[key] = key in target ? target[key] : value;
      }
    }
  }

  return target;
}

function calculateSource(source) {
  if (typeof source == 'object') { return source; }

  if (!/[,+-]/.test(source)) { return DEFAULTS[source] || DEFAULTS['*']; }

  var parts = source.split(',');
  var template = parts[0] in DEFAULTS
    ? DEFAULTS[parts.shift()]
    : DEFAULTS['*'];

  source = {};

  parts.forEach(function(part) {
    var isAdd = part[0] == '+';
    var key = part.substring(1).split('.');
    var group = key[0];
    var option = key[1];

    source[group] = source[group] || {};
    source[group][option] = isAdd;
  });

  return merge(template, source);
}

var compatibility = compatibilityFrom$1;

var HTTP_RESOURCE_PATTERN = /^http:\/\//;

function isHttpResource$1(uri) {
  return HTTP_RESOURCE_PATTERN.test(uri);
}

var isHttpResource_1 = isHttpResource$1;

var HTTPS_RESOURCE_PATTERN = /^https:\/\//;

function isHttpsResource$1(uri) {
  return HTTPS_RESOURCE_PATTERN.test(uri);
}

var isHttpsResource_1 = isHttpsResource$1;

var http$2 = require$$0__default$7["default"];
var https$2 = require$$1__default$1["default"];
var url$6 = require$$1__default["default"];

var isHttpResource = isHttpResource_1;
var isHttpsResource = isHttpsResource_1;
var override$1 = override_1;

var HTTP_PROTOCOL$1 = 'http:';

function loadRemoteResource$1(uri, inlineRequest, inlineTimeout, callback) {
  var proxyProtocol = inlineRequest.protocol || inlineRequest.hostname;
  var errorHandled = false;
  var requestOptions;
  var fetch;

  requestOptions = override$1(
    url$6.parse(uri),
    inlineRequest || {}
  );

  if (inlineRequest.hostname !== undefined) {
    // overwrite as we always expect a http proxy currently
    requestOptions.protocol = inlineRequest.protocol || HTTP_PROTOCOL$1;
    requestOptions.path = requestOptions.href;
  }

  fetch = (proxyProtocol && !isHttpsResource(proxyProtocol)) || isHttpResource(uri)
    ? http$2.get
    : https$2.get;

  fetch(requestOptions, function(res) {
    var chunks = [];
    var movedUri;

    if (errorHandled) {
      return;
    }

    if (res.statusCode < 200 || res.statusCode > 399) {
      return callback(res.statusCode, null);
    } if (res.statusCode > 299) {
      movedUri = url$6.resolve(uri, res.headers.location);
      return loadRemoteResource$1(movedUri, inlineRequest, inlineTimeout, callback);
    }

    res.on('data', function(chunk) {
      chunks.push(chunk.toString());
    });
    res.on('end', function() {
      var body = chunks.join('');
      callback(null, body);
    });
  })
    .on('error', function(res) {
      if (errorHandled) {
        return;
      }

      errorHandled = true;
      callback(res.message, null);
    })
    .on('timeout', function() {
      if (errorHandled) {
        return;
      }

      errorHandled = true;
      callback('timeout', null);
    })
    .setTimeout(inlineTimeout);
}

var loadRemoteResource_1 = loadRemoteResource$1;

var loadRemoteResource = loadRemoteResource_1;

function fetchFrom$1(callback) {
  return callback || loadRemoteResource;
}

var fetch = fetchFrom$1;

function inlineOptionsFrom(rules) {
  if (Array.isArray(rules)) {
    return rules;
  }

  if (rules === false) {
    return ['none'];
  }

  return undefined === rules
    ? ['local']
    : rules.split(',');
}

var inline$2 = inlineOptionsFrom;

var url$5 = require$$1__default["default"];

var override = override_1;

function inlineRequestFrom$1(option) {
  return override(
    /* jshint camelcase: false */
    proxyOptionsFrom(process.env.HTTP_PROXY || process.env.http_proxy),
    option || {}
  );
}

function proxyOptionsFrom(httpProxy) {
  return httpProxy
    ? {
      hostname: url$5.parse(httpProxy).hostname,
      port: parseInt(url$5.parse(httpProxy).port)
    }
    : {};
}

var inlineRequest = inlineRequestFrom$1;

var DEFAULT_TIMEOUT = 5000;

function inlineTimeoutFrom$1(option) {
  return option || DEFAULT_TIMEOUT;
}

var inlineTimeout = inlineTimeoutFrom$1;

function pluginsFrom$1(plugins) {
  var flatPlugins = {
    level1Value: [],
    level1Property: [],
    level2Block: []
  };

  plugins = plugins || [];

  flatPlugins.level1Value = plugins
    .map(function(plugin) { return plugin.level1 && plugin.level1.value; })
    .filter(function(plugin) { return plugin != null; });

  flatPlugins.level1Property = plugins
    .map(function(plugin) { return plugin.level1 && plugin.level1.property; })
    .filter(function(plugin) { return plugin != null; });

  flatPlugins.level2Block = plugins
    .map(function(plugin) { return plugin.level2 && plugin.level2.block; })
    .filter(function(plugin) { return plugin != null; });

  return flatPlugins;
}

var plugins$3 = pluginsFrom$1;

function rebaseFrom$1(rebaseOption, rebaseToOption) {
  if (undefined !== rebaseToOption) {
    return true;
  } if (undefined === rebaseOption) {
    return false;
  }
  return !!rebaseOption;
}

var rebase$3 = rebaseFrom$1;

var path$g = path__default["default"];

function rebaseToFrom$1(option) {
  return option ? path$g.resolve(option) : process.cwd();
}

var rebaseTo = rebaseToFrom$1;

var sourceMap$2 = {};

var sourceMapGenerator = {};

var base64Vlq = {};

var base64 = {};

/* -*- Mode: js; js-indent-level: 2; -*- */

var hasRequiredBase64;

function requireBase64 () {
	if (hasRequiredBase64) return base64;
	hasRequiredBase64 = 1;
	/*
	 * Copyright 2011 Mozilla Foundation and contributors
	 * Licensed under the New BSD license. See LICENSE or:
	 * http://opensource.org/licenses/BSD-3-Clause
	 */

	var intToCharMap = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/'.split('');

	/**
	 * Encode an integer in the range of 0 to 63 to a single base 64 digit.
	 */
	base64.encode = function (number) {
	  if (0 <= number && number < intToCharMap.length) {
	    return intToCharMap[number];
	  }
	  throw new TypeError("Must be between 0 and 63: " + number);
	};

	/**
	 * Decode a single base 64 character code digit to an integer. Returns -1 on
	 * failure.
	 */
	base64.decode = function (charCode) {
	  var bigA = 65;     // 'A'
	  var bigZ = 90;     // 'Z'

	  var littleA = 97;  // 'a'
	  var littleZ = 122; // 'z'

	  var zero = 48;     // '0'
	  var nine = 57;     // '9'

	  var plus = 43;     // '+'
	  var slash = 47;    // '/'

	  var littleOffset = 26;
	  var numberOffset = 52;

	  // 0 - 25: ABCDEFGHIJKLMNOPQRSTUVWXYZ
	  if (bigA <= charCode && charCode <= bigZ) {
	    return (charCode - bigA);
	  }

	  // 26 - 51: abcdefghijklmnopqrstuvwxyz
	  if (littleA <= charCode && charCode <= littleZ) {
	    return (charCode - littleA + littleOffset);
	  }

	  // 52 - 61: 0123456789
	  if (zero <= charCode && charCode <= nine) {
	    return (charCode - zero + numberOffset);
	  }

	  // 62: +
	  if (charCode == plus) {
	    return 62;
	  }

	  // 63: /
	  if (charCode == slash) {
	    return 63;
	  }

	  // Invalid base64 digit.
	  return -1;
	};
	return base64;
}

/* -*- Mode: js; js-indent-level: 2; -*- */

var hasRequiredBase64Vlq;

function requireBase64Vlq () {
	if (hasRequiredBase64Vlq) return base64Vlq;
	hasRequiredBase64Vlq = 1;
	/*
	 * Copyright 2011 Mozilla Foundation and contributors
	 * Licensed under the New BSD license. See LICENSE or:
	 * http://opensource.org/licenses/BSD-3-Clause
	 *
	 * Based on the Base 64 VLQ implementation in Closure Compiler:
	 * https://code.google.com/p/closure-compiler/source/browse/trunk/src/com/google/debugging/sourcemap/Base64VLQ.java
	 *
	 * Copyright 2011 The Closure Compiler Authors. All rights reserved.
	 * Redistribution and use in source and binary forms, with or without
	 * modification, are permitted provided that the following conditions are
	 * met:
	 *
	 *  * Redistributions of source code must retain the above copyright
	 *    notice, this list of conditions and the following disclaimer.
	 *  * Redistributions in binary form must reproduce the above
	 *    copyright notice, this list of conditions and the following
	 *    disclaimer in the documentation and/or other materials provided
	 *    with the distribution.
	 *  * Neither the name of Google Inc. nor the names of its
	 *    contributors may be used to endorse or promote products derived
	 *    from this software without specific prior written permission.
	 *
	 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
	 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
	 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
	 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
	 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
	 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
	 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
	 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
	 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
	 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
	 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
	 */

	var base64 = requireBase64();

	// A single base 64 digit can contain 6 bits of data. For the base 64 variable
	// length quantities we use in the source map spec, the first bit is the sign,
	// the next four bits are the actual value, and the 6th bit is the
	// continuation bit. The continuation bit tells us whether there are more
	// digits in this value following this digit.
	//
	//   Continuation
	//   |    Sign
	//   |    |
	//   V    V
	//   101011

	var VLQ_BASE_SHIFT = 5;

	// binary: 100000
	var VLQ_BASE = 1 << VLQ_BASE_SHIFT;

	// binary: 011111
	var VLQ_BASE_MASK = VLQ_BASE - 1;

	// binary: 100000
	var VLQ_CONTINUATION_BIT = VLQ_BASE;

	/**
	 * Converts from a two-complement value to a value where the sign bit is
	 * placed in the least significant bit.  For example, as decimals:
	 *   1 becomes 2 (10 binary), -1 becomes 3 (11 binary)
	 *   2 becomes 4 (100 binary), -2 becomes 5 (101 binary)
	 */
	function toVLQSigned(aValue) {
	  return aValue < 0
	    ? ((-aValue) << 1) + 1
	    : (aValue << 1) + 0;
	}

	/**
	 * Converts to a two-complement value from a value where the sign bit is
	 * placed in the least significant bit.  For example, as decimals:
	 *   2 (10 binary) becomes 1, 3 (11 binary) becomes -1
	 *   4 (100 binary) becomes 2, 5 (101 binary) becomes -2
	 */
	function fromVLQSigned(aValue) {
	  var isNegative = (aValue & 1) === 1;
	  var shifted = aValue >> 1;
	  return isNegative
	    ? -shifted
	    : shifted;
	}

	/**
	 * Returns the base 64 VLQ encoded value.
	 */
	base64Vlq.encode = function base64VLQ_encode(aValue) {
	  var encoded = "";
	  var digit;

	  var vlq = toVLQSigned(aValue);

	  do {
	    digit = vlq & VLQ_BASE_MASK;
	    vlq >>>= VLQ_BASE_SHIFT;
	    if (vlq > 0) {
	      // There are still more digits in this value, so we must make sure the
	      // continuation bit is marked.
	      digit |= VLQ_CONTINUATION_BIT;
	    }
	    encoded += base64.encode(digit);
	  } while (vlq > 0);

	  return encoded;
	};

	/**
	 * Decodes the next base 64 VLQ value from the given string and returns the
	 * value and the rest of the string via the out parameter.
	 */
	base64Vlq.decode = function base64VLQ_decode(aStr, aIndex, aOutParam) {
	  var strLen = aStr.length;
	  var result = 0;
	  var shift = 0;
	  var continuation, digit;

	  do {
	    if (aIndex >= strLen) {
	      throw new Error("Expected more digits in base 64 VLQ value.");
	    }

	    digit = base64.decode(aStr.charCodeAt(aIndex++));
	    if (digit === -1) {
	      throw new Error("Invalid base64 digit: " + aStr.charAt(aIndex - 1));
	    }

	    continuation = !!(digit & VLQ_CONTINUATION_BIT);
	    digit &= VLQ_BASE_MASK;
	    result = result + (digit << shift);
	    shift += VLQ_BASE_SHIFT;
	  } while (continuation);

	  aOutParam.value = fromVLQSigned(result);
	  aOutParam.rest = aIndex;
	};
	return base64Vlq;
}

var util$4 = {};

/* -*- Mode: js; js-indent-level: 2; -*- */

var hasRequiredUtil$1;

function requireUtil$1 () {
	if (hasRequiredUtil$1) return util$4;
	hasRequiredUtil$1 = 1;
	(function (exports) {
		/*
		 * Copyright 2011 Mozilla Foundation and contributors
		 * Licensed under the New BSD license. See LICENSE or:
		 * http://opensource.org/licenses/BSD-3-Clause
		 */

		/**
		 * This is a helper function for getting values from parameter/options
		 * objects.
		 *
		 * @param args The object we are extracting values from
		 * @param name The name of the property we are getting.
		 * @param defaultValue An optional value to return if the property is missing
		 * from the object. If this is not specified and the property is missing, an
		 * error will be thrown.
		 */
		function getArg(aArgs, aName, aDefaultValue) {
		  if (aName in aArgs) {
		    return aArgs[aName];
		  } else if (arguments.length === 3) {
		    return aDefaultValue;
		  } else {
		    throw new Error('"' + aName + '" is a required argument.');
		  }
		}
		exports.getArg = getArg;

		var urlRegexp = /^(?:([\w+\-.]+):)?\/\/(?:(\w+:\w+)@)?([\w.-]*)(?::(\d+))?(.*)$/;
		var dataUrlRegexp = /^data:.+\,.+$/;

		function urlParse(aUrl) {
		  var match = aUrl.match(urlRegexp);
		  if (!match) {
		    return null;
		  }
		  return {
		    scheme: match[1],
		    auth: match[2],
		    host: match[3],
		    port: match[4],
		    path: match[5]
		  };
		}
		exports.urlParse = urlParse;

		function urlGenerate(aParsedUrl) {
		  var url = '';
		  if (aParsedUrl.scheme) {
		    url += aParsedUrl.scheme + ':';
		  }
		  url += '//';
		  if (aParsedUrl.auth) {
		    url += aParsedUrl.auth + '@';
		  }
		  if (aParsedUrl.host) {
		    url += aParsedUrl.host;
		  }
		  if (aParsedUrl.port) {
		    url += ":" + aParsedUrl.port;
		  }
		  if (aParsedUrl.path) {
		    url += aParsedUrl.path;
		  }
		  return url;
		}
		exports.urlGenerate = urlGenerate;

		/**
		 * Normalizes a path, or the path portion of a URL:
		 *
		 * - Replaces consecutive slashes with one slash.
		 * - Removes unnecessary '.' parts.
		 * - Removes unnecessary '<dir>/..' parts.
		 *
		 * Based on code in the Node.js 'path' core module.
		 *
		 * @param aPath The path or url to normalize.
		 */
		function normalize(aPath) {
		  var path = aPath;
		  var url = urlParse(aPath);
		  if (url) {
		    if (!url.path) {
		      return aPath;
		    }
		    path = url.path;
		  }
		  var isAbsolute = exports.isAbsolute(path);

		  var parts = path.split(/\/+/);
		  for (var part, up = 0, i = parts.length - 1; i >= 0; i--) {
		    part = parts[i];
		    if (part === '.') {
		      parts.splice(i, 1);
		    } else if (part === '..') {
		      up++;
		    } else if (up > 0) {
		      if (part === '') {
		        // The first part is blank if the path is absolute. Trying to go
		        // above the root is a no-op. Therefore we can remove all '..' parts
		        // directly after the root.
		        parts.splice(i + 1, up);
		        up = 0;
		      } else {
		        parts.splice(i, 2);
		        up--;
		      }
		    }
		  }
		  path = parts.join('/');

		  if (path === '') {
		    path = isAbsolute ? '/' : '.';
		  }

		  if (url) {
		    url.path = path;
		    return urlGenerate(url);
		  }
		  return path;
		}
		exports.normalize = normalize;

		/**
		 * Joins two paths/URLs.
		 *
		 * @param aRoot The root path or URL.
		 * @param aPath The path or URL to be joined with the root.
		 *
		 * - If aPath is a URL or a data URI, aPath is returned, unless aPath is a
		 *   scheme-relative URL: Then the scheme of aRoot, if any, is prepended
		 *   first.
		 * - Otherwise aPath is a path. If aRoot is a URL, then its path portion
		 *   is updated with the result and aRoot is returned. Otherwise the result
		 *   is returned.
		 *   - If aPath is absolute, the result is aPath.
		 *   - Otherwise the two paths are joined with a slash.
		 * - Joining for example 'http://' and 'www.example.com' is also supported.
		 */
		function join(aRoot, aPath) {
		  if (aRoot === "") {
		    aRoot = ".";
		  }
		  if (aPath === "") {
		    aPath = ".";
		  }
		  var aPathUrl = urlParse(aPath);
		  var aRootUrl = urlParse(aRoot);
		  if (aRootUrl) {
		    aRoot = aRootUrl.path || '/';
		  }

		  // `join(foo, '//www.example.org')`
		  if (aPathUrl && !aPathUrl.scheme) {
		    if (aRootUrl) {
		      aPathUrl.scheme = aRootUrl.scheme;
		    }
		    return urlGenerate(aPathUrl);
		  }

		  if (aPathUrl || aPath.match(dataUrlRegexp)) {
		    return aPath;
		  }

		  // `join('http://', 'www.example.com')`
		  if (aRootUrl && !aRootUrl.host && !aRootUrl.path) {
		    aRootUrl.host = aPath;
		    return urlGenerate(aRootUrl);
		  }

		  var joined = aPath.charAt(0) === '/'
		    ? aPath
		    : normalize(aRoot.replace(/\/+$/, '') + '/' + aPath);

		  if (aRootUrl) {
		    aRootUrl.path = joined;
		    return urlGenerate(aRootUrl);
		  }
		  return joined;
		}
		exports.join = join;

		exports.isAbsolute = function (aPath) {
		  return aPath.charAt(0) === '/' || urlRegexp.test(aPath);
		};

		/**
		 * Make a path relative to a URL or another path.
		 *
		 * @param aRoot The root path or URL.
		 * @param aPath The path or URL to be made relative to aRoot.
		 */
		function relative(aRoot, aPath) {
		  if (aRoot === "") {
		    aRoot = ".";
		  }

		  aRoot = aRoot.replace(/\/$/, '');

		  // It is possible for the path to be above the root. In this case, simply
		  // checking whether the root is a prefix of the path won't work. Instead, we
		  // need to remove components from the root one by one, until either we find
		  // a prefix that fits, or we run out of components to remove.
		  var level = 0;
		  while (aPath.indexOf(aRoot + '/') !== 0) {
		    var index = aRoot.lastIndexOf("/");
		    if (index < 0) {
		      return aPath;
		    }

		    // If the only part of the root that is left is the scheme (i.e. http://,
		    // file:///, etc.), one or more slashes (/), or simply nothing at all, we
		    // have exhausted all components, so the path is not relative to the root.
		    aRoot = aRoot.slice(0, index);
		    if (aRoot.match(/^([^\/]+:\/)?\/*$/)) {
		      return aPath;
		    }

		    ++level;
		  }

		  // Make sure we add a "../" for each component we removed from the root.
		  return Array(level + 1).join("../") + aPath.substr(aRoot.length + 1);
		}
		exports.relative = relative;

		var supportsNullProto = (function () {
		  var obj = Object.create(null);
		  return !('__proto__' in obj);
		}());

		function identity (s) {
		  return s;
		}

		/**
		 * Because behavior goes wacky when you set `__proto__` on objects, we
		 * have to prefix all the strings in our set with an arbitrary character.
		 *
		 * See https://github.com/mozilla/source-map/pull/31 and
		 * https://github.com/mozilla/source-map/issues/30
		 *
		 * @param String aStr
		 */
		function toSetString(aStr) {
		  if (isProtoString(aStr)) {
		    return '$' + aStr;
		  }

		  return aStr;
		}
		exports.toSetString = supportsNullProto ? identity : toSetString;

		function fromSetString(aStr) {
		  if (isProtoString(aStr)) {
		    return aStr.slice(1);
		  }

		  return aStr;
		}
		exports.fromSetString = supportsNullProto ? identity : fromSetString;

		function isProtoString(s) {
		  if (!s) {
		    return false;
		  }

		  var length = s.length;

		  if (length < 9 /* "__proto__".length */) {
		    return false;
		  }

		  if (s.charCodeAt(length - 1) !== 95  /* '_' */ ||
		      s.charCodeAt(length - 2) !== 95  /* '_' */ ||
		      s.charCodeAt(length - 3) !== 111 /* 'o' */ ||
		      s.charCodeAt(length - 4) !== 116 /* 't' */ ||
		      s.charCodeAt(length - 5) !== 111 /* 'o' */ ||
		      s.charCodeAt(length - 6) !== 114 /* 'r' */ ||
		      s.charCodeAt(length - 7) !== 112 /* 'p' */ ||
		      s.charCodeAt(length - 8) !== 95  /* '_' */ ||
		      s.charCodeAt(length - 9) !== 95  /* '_' */) {
		    return false;
		  }

		  for (var i = length - 10; i >= 0; i--) {
		    if (s.charCodeAt(i) !== 36 /* '$' */) {
		      return false;
		    }
		  }

		  return true;
		}

		/**
		 * Comparator between two mappings where the original positions are compared.
		 *
		 * Optionally pass in `true` as `onlyCompareGenerated` to consider two
		 * mappings with the same original source/line/column, but different generated
		 * line and column the same. Useful when searching for a mapping with a
		 * stubbed out mapping.
		 */
		function compareByOriginalPositions(mappingA, mappingB, onlyCompareOriginal) {
		  var cmp = strcmp(mappingA.source, mappingB.source);
		  if (cmp !== 0) {
		    return cmp;
		  }

		  cmp = mappingA.originalLine - mappingB.originalLine;
		  if (cmp !== 0) {
		    return cmp;
		  }

		  cmp = mappingA.originalColumn - mappingB.originalColumn;
		  if (cmp !== 0 || onlyCompareOriginal) {
		    return cmp;
		  }

		  cmp = mappingA.generatedColumn - mappingB.generatedColumn;
		  if (cmp !== 0) {
		    return cmp;
		  }

		  cmp = mappingA.generatedLine - mappingB.generatedLine;
		  if (cmp !== 0) {
		    return cmp;
		  }

		  return strcmp(mappingA.name, mappingB.name);
		}
		exports.compareByOriginalPositions = compareByOriginalPositions;

		/**
		 * Comparator between two mappings with deflated source and name indices where
		 * the generated positions are compared.
		 *
		 * Optionally pass in `true` as `onlyCompareGenerated` to consider two
		 * mappings with the same generated line and column, but different
		 * source/name/original line and column the same. Useful when searching for a
		 * mapping with a stubbed out mapping.
		 */
		function compareByGeneratedPositionsDeflated(mappingA, mappingB, onlyCompareGenerated) {
		  var cmp = mappingA.generatedLine - mappingB.generatedLine;
		  if (cmp !== 0) {
		    return cmp;
		  }

		  cmp = mappingA.generatedColumn - mappingB.generatedColumn;
		  if (cmp !== 0 || onlyCompareGenerated) {
		    return cmp;
		  }

		  cmp = strcmp(mappingA.source, mappingB.source);
		  if (cmp !== 0) {
		    return cmp;
		  }

		  cmp = mappingA.originalLine - mappingB.originalLine;
		  if (cmp !== 0) {
		    return cmp;
		  }

		  cmp = mappingA.originalColumn - mappingB.originalColumn;
		  if (cmp !== 0) {
		    return cmp;
		  }

		  return strcmp(mappingA.name, mappingB.name);
		}
		exports.compareByGeneratedPositionsDeflated = compareByGeneratedPositionsDeflated;

		function strcmp(aStr1, aStr2) {
		  if (aStr1 === aStr2) {
		    return 0;
		  }

		  if (aStr1 === null) {
		    return 1; // aStr2 !== null
		  }

		  if (aStr2 === null) {
		    return -1; // aStr1 !== null
		  }

		  if (aStr1 > aStr2) {
		    return 1;
		  }

		  return -1;
		}

		/**
		 * Comparator between two mappings with inflated source and name strings where
		 * the generated positions are compared.
		 */
		function compareByGeneratedPositionsInflated(mappingA, mappingB) {
		  var cmp = mappingA.generatedLine - mappingB.generatedLine;
		  if (cmp !== 0) {
		    return cmp;
		  }

		  cmp = mappingA.generatedColumn - mappingB.generatedColumn;
		  if (cmp !== 0) {
		    return cmp;
		  }

		  cmp = strcmp(mappingA.source, mappingB.source);
		  if (cmp !== 0) {
		    return cmp;
		  }

		  cmp = mappingA.originalLine - mappingB.originalLine;
		  if (cmp !== 0) {
		    return cmp;
		  }

		  cmp = mappingA.originalColumn - mappingB.originalColumn;
		  if (cmp !== 0) {
		    return cmp;
		  }

		  return strcmp(mappingA.name, mappingB.name);
		}
		exports.compareByGeneratedPositionsInflated = compareByGeneratedPositionsInflated;

		/**
		 * Strip any JSON XSSI avoidance prefix from the string (as documented
		 * in the source maps specification), and then parse the string as
		 * JSON.
		 */
		function parseSourceMapInput(str) {
		  return JSON.parse(str.replace(/^\)]}'[^\n]*\n/, ''));
		}
		exports.parseSourceMapInput = parseSourceMapInput;

		/**
		 * Compute the URL of a source given the the source root, the source's
		 * URL, and the source map's URL.
		 */
		function computeSourceURL(sourceRoot, sourceURL, sourceMapURL) {
		  sourceURL = sourceURL || '';

		  if (sourceRoot) {
		    // This follows what Chrome does.
		    if (sourceRoot[sourceRoot.length - 1] !== '/' && sourceURL[0] !== '/') {
		      sourceRoot += '/';
		    }
		    // The spec says:
		    //   Line 4: An optional source root, useful for relocating source
		    //   files on a server or removing repeated values in the
		    //   “sources” entry.  This value is prepended to the individual
		    //   entries in the “source” field.
		    sourceURL = sourceRoot + sourceURL;
		  }

		  // Historically, SourceMapConsumer did not take the sourceMapURL as
		  // a parameter.  This mode is still somewhat supported, which is why
		  // this code block is conditional.  However, it's preferable to pass
		  // the source map URL to SourceMapConsumer, so that this function
		  // can implement the source URL resolution algorithm as outlined in
		  // the spec.  This block is basically the equivalent of:
		  //    new URL(sourceURL, sourceMapURL).toString()
		  // ... except it avoids using URL, which wasn't available in the
		  // older releases of node still supported by this library.
		  //
		  // The spec says:
		  //   If the sources are not absolute URLs after prepending of the
		  //   “sourceRoot”, the sources are resolved relative to the
		  //   SourceMap (like resolving script src in a html document).
		  if (sourceMapURL) {
		    var parsed = urlParse(sourceMapURL);
		    if (!parsed) {
		      throw new Error("sourceMapURL could not be parsed");
		    }
		    if (parsed.path) {
		      // Strip the last path component, but keep the "/".
		      var index = parsed.path.lastIndexOf('/');
		      if (index >= 0) {
		        parsed.path = parsed.path.substring(0, index + 1);
		      }
		    }
		    sourceURL = join(urlGenerate(parsed), sourceURL);
		  }

		  return normalize(sourceURL);
		}
		exports.computeSourceURL = computeSourceURL; 
	} (util$4));
	return util$4;
}

var arraySet = {};

/* -*- Mode: js; js-indent-level: 2; -*- */

var hasRequiredArraySet;

function requireArraySet () {
	if (hasRequiredArraySet) return arraySet;
	hasRequiredArraySet = 1;
	/*
	 * Copyright 2011 Mozilla Foundation and contributors
	 * Licensed under the New BSD license. See LICENSE or:
	 * http://opensource.org/licenses/BSD-3-Clause
	 */

	var util = requireUtil$1();
	var has = Object.prototype.hasOwnProperty;
	var hasNativeMap = typeof Map !== "undefined";

	/**
	 * A data structure which is a combination of an array and a set. Adding a new
	 * member is O(1), testing for membership is O(1), and finding the index of an
	 * element is O(1). Removing elements from the set is not supported. Only
	 * strings are supported for membership.
	 */
	function ArraySet() {
	  this._array = [];
	  this._set = hasNativeMap ? new Map() : Object.create(null);
	}

	/**
	 * Static method for creating ArraySet instances from an existing array.
	 */
	ArraySet.fromArray = function ArraySet_fromArray(aArray, aAllowDuplicates) {
	  var set = new ArraySet();
	  for (var i = 0, len = aArray.length; i < len; i++) {
	    set.add(aArray[i], aAllowDuplicates);
	  }
	  return set;
	};

	/**
	 * Return how many unique items are in this ArraySet. If duplicates have been
	 * added, than those do not count towards the size.
	 *
	 * @returns Number
	 */
	ArraySet.prototype.size = function ArraySet_size() {
	  return hasNativeMap ? this._set.size : Object.getOwnPropertyNames(this._set).length;
	};

	/**
	 * Add the given string to this set.
	 *
	 * @param String aStr
	 */
	ArraySet.prototype.add = function ArraySet_add(aStr, aAllowDuplicates) {
	  var sStr = hasNativeMap ? aStr : util.toSetString(aStr);
	  var isDuplicate = hasNativeMap ? this.has(aStr) : has.call(this._set, sStr);
	  var idx = this._array.length;
	  if (!isDuplicate || aAllowDuplicates) {
	    this._array.push(aStr);
	  }
	  if (!isDuplicate) {
	    if (hasNativeMap) {
	      this._set.set(aStr, idx);
	    } else {
	      this._set[sStr] = idx;
	    }
	  }
	};

	/**
	 * Is the given string a member of this set?
	 *
	 * @param String aStr
	 */
	ArraySet.prototype.has = function ArraySet_has(aStr) {
	  if (hasNativeMap) {
	    return this._set.has(aStr);
	  } else {
	    var sStr = util.toSetString(aStr);
	    return has.call(this._set, sStr);
	  }
	};

	/**
	 * What is the index of the given string in the array?
	 *
	 * @param String aStr
	 */
	ArraySet.prototype.indexOf = function ArraySet_indexOf(aStr) {
	  if (hasNativeMap) {
	    var idx = this._set.get(aStr);
	    if (idx >= 0) {
	        return idx;
	    }
	  } else {
	    var sStr = util.toSetString(aStr);
	    if (has.call(this._set, sStr)) {
	      return this._set[sStr];
	    }
	  }

	  throw new Error('"' + aStr + '" is not in the set.');
	};

	/**
	 * What is the element at the given index?
	 *
	 * @param Number aIdx
	 */
	ArraySet.prototype.at = function ArraySet_at(aIdx) {
	  if (aIdx >= 0 && aIdx < this._array.length) {
	    return this._array[aIdx];
	  }
	  throw new Error('No element indexed by ' + aIdx);
	};

	/**
	 * Returns the array representation of this set (which has the proper indices
	 * indicated by indexOf). Note that this is a copy of the internal array used
	 * for storing the members so that no one can mess with internal state.
	 */
	ArraySet.prototype.toArray = function ArraySet_toArray() {
	  return this._array.slice();
	};

	arraySet.ArraySet = ArraySet;
	return arraySet;
}

var mappingList = {};

/* -*- Mode: js; js-indent-level: 2; -*- */

var hasRequiredMappingList;

function requireMappingList () {
	if (hasRequiredMappingList) return mappingList;
	hasRequiredMappingList = 1;
	/*
	 * Copyright 2014 Mozilla Foundation and contributors
	 * Licensed under the New BSD license. See LICENSE or:
	 * http://opensource.org/licenses/BSD-3-Clause
	 */

	var util = requireUtil$1();

	/**
	 * Determine whether mappingB is after mappingA with respect to generated
	 * position.
	 */
	function generatedPositionAfter(mappingA, mappingB) {
	  // Optimized for most common case
	  var lineA = mappingA.generatedLine;
	  var lineB = mappingB.generatedLine;
	  var columnA = mappingA.generatedColumn;
	  var columnB = mappingB.generatedColumn;
	  return lineB > lineA || lineB == lineA && columnB >= columnA ||
	         util.compareByGeneratedPositionsInflated(mappingA, mappingB) <= 0;
	}

	/**
	 * A data structure to provide a sorted view of accumulated mappings in a
	 * performance conscious manner. It trades a neglibable overhead in general
	 * case for a large speedup in case of mappings being added in order.
	 */
	function MappingList() {
	  this._array = [];
	  this._sorted = true;
	  // Serves as infimum
	  this._last = {generatedLine: -1, generatedColumn: 0};
	}

	/**
	 * Iterate through internal items. This method takes the same arguments that
	 * `Array.prototype.forEach` takes.
	 *
	 * NOTE: The order of the mappings is NOT guaranteed.
	 */
	MappingList.prototype.unsortedForEach =
	  function MappingList_forEach(aCallback, aThisArg) {
	    this._array.forEach(aCallback, aThisArg);
	  };

	/**
	 * Add the given source mapping.
	 *
	 * @param Object aMapping
	 */
	MappingList.prototype.add = function MappingList_add(aMapping) {
	  if (generatedPositionAfter(this._last, aMapping)) {
	    this._last = aMapping;
	    this._array.push(aMapping);
	  } else {
	    this._sorted = false;
	    this._array.push(aMapping);
	  }
	};

	/**
	 * Returns the flat, sorted array of mappings. The mappings are sorted by
	 * generated position.
	 *
	 * WARNING: This method returns internal data without copying, for
	 * performance. The return value must NOT be mutated, and should be treated as
	 * an immutable borrow. If you want to take ownership, you must make your own
	 * copy.
	 */
	MappingList.prototype.toArray = function MappingList_toArray() {
	  if (!this._sorted) {
	    this._array.sort(util.compareByGeneratedPositionsInflated);
	    this._sorted = true;
	  }
	  return this._array;
	};

	mappingList.MappingList = MappingList;
	return mappingList;
}

/* -*- Mode: js; js-indent-level: 2; -*- */

var hasRequiredSourceMapGenerator;

function requireSourceMapGenerator () {
	if (hasRequiredSourceMapGenerator) return sourceMapGenerator;
	hasRequiredSourceMapGenerator = 1;
	/*
	 * Copyright 2011 Mozilla Foundation and contributors
	 * Licensed under the New BSD license. See LICENSE or:
	 * http://opensource.org/licenses/BSD-3-Clause
	 */

	var base64VLQ = requireBase64Vlq();
	var util = requireUtil$1();
	var ArraySet = requireArraySet().ArraySet;
	var MappingList = requireMappingList().MappingList;

	/**
	 * An instance of the SourceMapGenerator represents a source map which is
	 * being built incrementally. You may pass an object with the following
	 * properties:
	 *
	 *   - file: The filename of the generated source.
	 *   - sourceRoot: A root for all relative URLs in this source map.
	 */
	function SourceMapGenerator(aArgs) {
	  if (!aArgs) {
	    aArgs = {};
	  }
	  this._file = util.getArg(aArgs, 'file', null);
	  this._sourceRoot = util.getArg(aArgs, 'sourceRoot', null);
	  this._skipValidation = util.getArg(aArgs, 'skipValidation', false);
	  this._sources = new ArraySet();
	  this._names = new ArraySet();
	  this._mappings = new MappingList();
	  this._sourcesContents = null;
	}

	SourceMapGenerator.prototype._version = 3;

	/**
	 * Creates a new SourceMapGenerator based on a SourceMapConsumer
	 *
	 * @param aSourceMapConsumer The SourceMap.
	 */
	SourceMapGenerator.fromSourceMap =
	  function SourceMapGenerator_fromSourceMap(aSourceMapConsumer) {
	    var sourceRoot = aSourceMapConsumer.sourceRoot;
	    var generator = new SourceMapGenerator({
	      file: aSourceMapConsumer.file,
	      sourceRoot: sourceRoot
	    });
	    aSourceMapConsumer.eachMapping(function (mapping) {
	      var newMapping = {
	        generated: {
	          line: mapping.generatedLine,
	          column: mapping.generatedColumn
	        }
	      };

	      if (mapping.source != null) {
	        newMapping.source = mapping.source;
	        if (sourceRoot != null) {
	          newMapping.source = util.relative(sourceRoot, newMapping.source);
	        }

	        newMapping.original = {
	          line: mapping.originalLine,
	          column: mapping.originalColumn
	        };

	        if (mapping.name != null) {
	          newMapping.name = mapping.name;
	        }
	      }

	      generator.addMapping(newMapping);
	    });
	    aSourceMapConsumer.sources.forEach(function (sourceFile) {
	      var sourceRelative = sourceFile;
	      if (sourceRoot !== null) {
	        sourceRelative = util.relative(sourceRoot, sourceFile);
	      }

	      if (!generator._sources.has(sourceRelative)) {
	        generator._sources.add(sourceRelative);
	      }

	      var content = aSourceMapConsumer.sourceContentFor(sourceFile);
	      if (content != null) {
	        generator.setSourceContent(sourceFile, content);
	      }
	    });
	    return generator;
	  };

	/**
	 * Add a single mapping from original source line and column to the generated
	 * source's line and column for this source map being created. The mapping
	 * object should have the following properties:
	 *
	 *   - generated: An object with the generated line and column positions.
	 *   - original: An object with the original line and column positions.
	 *   - source: The original source file (relative to the sourceRoot).
	 *   - name: An optional original token name for this mapping.
	 */
	SourceMapGenerator.prototype.addMapping =
	  function SourceMapGenerator_addMapping(aArgs) {
	    var generated = util.getArg(aArgs, 'generated');
	    var original = util.getArg(aArgs, 'original', null);
	    var source = util.getArg(aArgs, 'source', null);
	    var name = util.getArg(aArgs, 'name', null);

	    if (!this._skipValidation) {
	      this._validateMapping(generated, original, source, name);
	    }

	    if (source != null) {
	      source = String(source);
	      if (!this._sources.has(source)) {
	        this._sources.add(source);
	      }
	    }

	    if (name != null) {
	      name = String(name);
	      if (!this._names.has(name)) {
	        this._names.add(name);
	      }
	    }

	    this._mappings.add({
	      generatedLine: generated.line,
	      generatedColumn: generated.column,
	      originalLine: original != null && original.line,
	      originalColumn: original != null && original.column,
	      source: source,
	      name: name
	    });
	  };

	/**
	 * Set the source content for a source file.
	 */
	SourceMapGenerator.prototype.setSourceContent =
	  function SourceMapGenerator_setSourceContent(aSourceFile, aSourceContent) {
	    var source = aSourceFile;
	    if (this._sourceRoot != null) {
	      source = util.relative(this._sourceRoot, source);
	    }

	    if (aSourceContent != null) {
	      // Add the source content to the _sourcesContents map.
	      // Create a new _sourcesContents map if the property is null.
	      if (!this._sourcesContents) {
	        this._sourcesContents = Object.create(null);
	      }
	      this._sourcesContents[util.toSetString(source)] = aSourceContent;
	    } else if (this._sourcesContents) {
	      // Remove the source file from the _sourcesContents map.
	      // If the _sourcesContents map is empty, set the property to null.
	      delete this._sourcesContents[util.toSetString(source)];
	      if (Object.keys(this._sourcesContents).length === 0) {
	        this._sourcesContents = null;
	      }
	    }
	  };

	/**
	 * Applies the mappings of a sub-source-map for a specific source file to the
	 * source map being generated. Each mapping to the supplied source file is
	 * rewritten using the supplied source map. Note: The resolution for the
	 * resulting mappings is the minimium of this map and the supplied map.
	 *
	 * @param aSourceMapConsumer The source map to be applied.
	 * @param aSourceFile Optional. The filename of the source file.
	 *        If omitted, SourceMapConsumer's file property will be used.
	 * @param aSourceMapPath Optional. The dirname of the path to the source map
	 *        to be applied. If relative, it is relative to the SourceMapConsumer.
	 *        This parameter is needed when the two source maps aren't in the same
	 *        directory, and the source map to be applied contains relative source
	 *        paths. If so, those relative source paths need to be rewritten
	 *        relative to the SourceMapGenerator.
	 */
	SourceMapGenerator.prototype.applySourceMap =
	  function SourceMapGenerator_applySourceMap(aSourceMapConsumer, aSourceFile, aSourceMapPath) {
	    var sourceFile = aSourceFile;
	    // If aSourceFile is omitted, we will use the file property of the SourceMap
	    if (aSourceFile == null) {
	      if (aSourceMapConsumer.file == null) {
	        throw new Error(
	          'SourceMapGenerator.prototype.applySourceMap requires either an explicit source file, ' +
	          'or the source map\'s "file" property. Both were omitted.'
	        );
	      }
	      sourceFile = aSourceMapConsumer.file;
	    }
	    var sourceRoot = this._sourceRoot;
	    // Make "sourceFile" relative if an absolute Url is passed.
	    if (sourceRoot != null) {
	      sourceFile = util.relative(sourceRoot, sourceFile);
	    }
	    // Applying the SourceMap can add and remove items from the sources and
	    // the names array.
	    var newSources = new ArraySet();
	    var newNames = new ArraySet();

	    // Find mappings for the "sourceFile"
	    this._mappings.unsortedForEach(function (mapping) {
	      if (mapping.source === sourceFile && mapping.originalLine != null) {
	        // Check if it can be mapped by the source map, then update the mapping.
	        var original = aSourceMapConsumer.originalPositionFor({
	          line: mapping.originalLine,
	          column: mapping.originalColumn
	        });
	        if (original.source != null) {
	          // Copy mapping
	          mapping.source = original.source;
	          if (aSourceMapPath != null) {
	            mapping.source = util.join(aSourceMapPath, mapping.source);
	          }
	          if (sourceRoot != null) {
	            mapping.source = util.relative(sourceRoot, mapping.source);
	          }
	          mapping.originalLine = original.line;
	          mapping.originalColumn = original.column;
	          if (original.name != null) {
	            mapping.name = original.name;
	          }
	        }
	      }

	      var source = mapping.source;
	      if (source != null && !newSources.has(source)) {
	        newSources.add(source);
	      }

	      var name = mapping.name;
	      if (name != null && !newNames.has(name)) {
	        newNames.add(name);
	      }

	    }, this);
	    this._sources = newSources;
	    this._names = newNames;

	    // Copy sourcesContents of applied map.
	    aSourceMapConsumer.sources.forEach(function (sourceFile) {
	      var content = aSourceMapConsumer.sourceContentFor(sourceFile);
	      if (content != null) {
	        if (aSourceMapPath != null) {
	          sourceFile = util.join(aSourceMapPath, sourceFile);
	        }
	        if (sourceRoot != null) {
	          sourceFile = util.relative(sourceRoot, sourceFile);
	        }
	        this.setSourceContent(sourceFile, content);
	      }
	    }, this);
	  };

	/**
	 * A mapping can have one of the three levels of data:
	 *
	 *   1. Just the generated position.
	 *   2. The Generated position, original position, and original source.
	 *   3. Generated and original position, original source, as well as a name
	 *      token.
	 *
	 * To maintain consistency, we validate that any new mapping being added falls
	 * in to one of these categories.
	 */
	SourceMapGenerator.prototype._validateMapping =
	  function SourceMapGenerator_validateMapping(aGenerated, aOriginal, aSource,
	                                              aName) {
	    // When aOriginal is truthy but has empty values for .line and .column,
	    // it is most likely a programmer error. In this case we throw a very
	    // specific error message to try to guide them the right way.
	    // For example: https://github.com/Polymer/polymer-bundler/pull/519
	    if (aOriginal && typeof aOriginal.line !== 'number' && typeof aOriginal.column !== 'number') {
	        throw new Error(
	            'original.line and original.column are not numbers -- you probably meant to omit ' +
	            'the original mapping entirely and only map the generated position. If so, pass ' +
	            'null for the original mapping instead of an object with empty or null values.'
	        );
	    }

	    if (aGenerated && 'line' in aGenerated && 'column' in aGenerated
	        && aGenerated.line > 0 && aGenerated.column >= 0
	        && !aOriginal && !aSource && !aName) {
	      // Case 1.
	      return;
	    }
	    else if (aGenerated && 'line' in aGenerated && 'column' in aGenerated
	             && aOriginal && 'line' in aOriginal && 'column' in aOriginal
	             && aGenerated.line > 0 && aGenerated.column >= 0
	             && aOriginal.line > 0 && aOriginal.column >= 0
	             && aSource) {
	      // Cases 2 and 3.
	      return;
	    }
	    else {
	      throw new Error('Invalid mapping: ' + JSON.stringify({
	        generated: aGenerated,
	        source: aSource,
	        original: aOriginal,
	        name: aName
	      }));
	    }
	  };

	/**
	 * Serialize the accumulated mappings in to the stream of base 64 VLQs
	 * specified by the source map format.
	 */
	SourceMapGenerator.prototype._serializeMappings =
	  function SourceMapGenerator_serializeMappings() {
	    var previousGeneratedColumn = 0;
	    var previousGeneratedLine = 1;
	    var previousOriginalColumn = 0;
	    var previousOriginalLine = 0;
	    var previousName = 0;
	    var previousSource = 0;
	    var result = '';
	    var next;
	    var mapping;
	    var nameIdx;
	    var sourceIdx;

	    var mappings = this._mappings.toArray();
	    for (var i = 0, len = mappings.length; i < len; i++) {
	      mapping = mappings[i];
	      next = '';

	      if (mapping.generatedLine !== previousGeneratedLine) {
	        previousGeneratedColumn = 0;
	        while (mapping.generatedLine !== previousGeneratedLine) {
	          next += ';';
	          previousGeneratedLine++;
	        }
	      }
	      else {
	        if (i > 0) {
	          if (!util.compareByGeneratedPositionsInflated(mapping, mappings[i - 1])) {
	            continue;
	          }
	          next += ',';
	        }
	      }

	      next += base64VLQ.encode(mapping.generatedColumn
	                                 - previousGeneratedColumn);
	      previousGeneratedColumn = mapping.generatedColumn;

	      if (mapping.source != null) {
	        sourceIdx = this._sources.indexOf(mapping.source);
	        next += base64VLQ.encode(sourceIdx - previousSource);
	        previousSource = sourceIdx;

	        // lines are stored 0-based in SourceMap spec version 3
	        next += base64VLQ.encode(mapping.originalLine - 1
	                                   - previousOriginalLine);
	        previousOriginalLine = mapping.originalLine - 1;

	        next += base64VLQ.encode(mapping.originalColumn
	                                   - previousOriginalColumn);
	        previousOriginalColumn = mapping.originalColumn;

	        if (mapping.name != null) {
	          nameIdx = this._names.indexOf(mapping.name);
	          next += base64VLQ.encode(nameIdx - previousName);
	          previousName = nameIdx;
	        }
	      }

	      result += next;
	    }

	    return result;
	  };

	SourceMapGenerator.prototype._generateSourcesContent =
	  function SourceMapGenerator_generateSourcesContent(aSources, aSourceRoot) {
	    return aSources.map(function (source) {
	      if (!this._sourcesContents) {
	        return null;
	      }
	      if (aSourceRoot != null) {
	        source = util.relative(aSourceRoot, source);
	      }
	      var key = util.toSetString(source);
	      return Object.prototype.hasOwnProperty.call(this._sourcesContents, key)
	        ? this._sourcesContents[key]
	        : null;
	    }, this);
	  };

	/**
	 * Externalize the source map.
	 */
	SourceMapGenerator.prototype.toJSON =
	  function SourceMapGenerator_toJSON() {
	    var map = {
	      version: this._version,
	      sources: this._sources.toArray(),
	      names: this._names.toArray(),
	      mappings: this._serializeMappings()
	    };
	    if (this._file != null) {
	      map.file = this._file;
	    }
	    if (this._sourceRoot != null) {
	      map.sourceRoot = this._sourceRoot;
	    }
	    if (this._sourcesContents) {
	      map.sourcesContent = this._generateSourcesContent(map.sources, map.sourceRoot);
	    }

	    return map;
	  };

	/**
	 * Render the source map being generated to a string.
	 */
	SourceMapGenerator.prototype.toString =
	  function SourceMapGenerator_toString() {
	    return JSON.stringify(this.toJSON());
	  };

	sourceMapGenerator.SourceMapGenerator = SourceMapGenerator;
	return sourceMapGenerator;
}

var sourceMapConsumer = {};

var binarySearch = {};

/* -*- Mode: js; js-indent-level: 2; -*- */

var hasRequiredBinarySearch;

function requireBinarySearch () {
	if (hasRequiredBinarySearch) return binarySearch;
	hasRequiredBinarySearch = 1;
	(function (exports) {
		/*
		 * Copyright 2011 Mozilla Foundation and contributors
		 * Licensed under the New BSD license. See LICENSE or:
		 * http://opensource.org/licenses/BSD-3-Clause
		 */

		exports.GREATEST_LOWER_BOUND = 1;
		exports.LEAST_UPPER_BOUND = 2;

		/**
		 * Recursive implementation of binary search.
		 *
		 * @param aLow Indices here and lower do not contain the needle.
		 * @param aHigh Indices here and higher do not contain the needle.
		 * @param aNeedle The element being searched for.
		 * @param aHaystack The non-empty array being searched.
		 * @param aCompare Function which takes two elements and returns -1, 0, or 1.
		 * @param aBias Either 'binarySearch.GREATEST_LOWER_BOUND' or
		 *     'binarySearch.LEAST_UPPER_BOUND'. Specifies whether to return the
		 *     closest element that is smaller than or greater than the one we are
		 *     searching for, respectively, if the exact element cannot be found.
		 */
		function recursiveSearch(aLow, aHigh, aNeedle, aHaystack, aCompare, aBias) {
		  // This function terminates when one of the following is true:
		  //
		  //   1. We find the exact element we are looking for.
		  //
		  //   2. We did not find the exact element, but we can return the index of
		  //      the next-closest element.
		  //
		  //   3. We did not find the exact element, and there is no next-closest
		  //      element than the one we are searching for, so we return -1.
		  var mid = Math.floor((aHigh - aLow) / 2) + aLow;
		  var cmp = aCompare(aNeedle, aHaystack[mid], true);
		  if (cmp === 0) {
		    // Found the element we are looking for.
		    return mid;
		  }
		  else if (cmp > 0) {
		    // Our needle is greater than aHaystack[mid].
		    if (aHigh - mid > 1) {
		      // The element is in the upper half.
		      return recursiveSearch(mid, aHigh, aNeedle, aHaystack, aCompare, aBias);
		    }

		    // The exact needle element was not found in this haystack. Determine if
		    // we are in termination case (3) or (2) and return the appropriate thing.
		    if (aBias == exports.LEAST_UPPER_BOUND) {
		      return aHigh < aHaystack.length ? aHigh : -1;
		    } else {
		      return mid;
		    }
		  }
		  else {
		    // Our needle is less than aHaystack[mid].
		    if (mid - aLow > 1) {
		      // The element is in the lower half.
		      return recursiveSearch(aLow, mid, aNeedle, aHaystack, aCompare, aBias);
		    }

		    // we are in termination case (3) or (2) and return the appropriate thing.
		    if (aBias == exports.LEAST_UPPER_BOUND) {
		      return mid;
		    } else {
		      return aLow < 0 ? -1 : aLow;
		    }
		  }
		}

		/**
		 * This is an implementation of binary search which will always try and return
		 * the index of the closest element if there is no exact hit. This is because
		 * mappings between original and generated line/col pairs are single points,
		 * and there is an implicit region between each of them, so a miss just means
		 * that you aren't on the very start of a region.
		 *
		 * @param aNeedle The element you are looking for.
		 * @param aHaystack The array that is being searched.
		 * @param aCompare A function which takes the needle and an element in the
		 *     array and returns -1, 0, or 1 depending on whether the needle is less
		 *     than, equal to, or greater than the element, respectively.
		 * @param aBias Either 'binarySearch.GREATEST_LOWER_BOUND' or
		 *     'binarySearch.LEAST_UPPER_BOUND'. Specifies whether to return the
		 *     closest element that is smaller than or greater than the one we are
		 *     searching for, respectively, if the exact element cannot be found.
		 *     Defaults to 'binarySearch.GREATEST_LOWER_BOUND'.
		 */
		exports.search = function search(aNeedle, aHaystack, aCompare, aBias) {
		  if (aHaystack.length === 0) {
		    return -1;
		  }

		  var index = recursiveSearch(-1, aHaystack.length, aNeedle, aHaystack,
		                              aCompare, aBias || exports.GREATEST_LOWER_BOUND);
		  if (index < 0) {
		    return -1;
		  }

		  // We have found either the exact element, or the next-closest element than
		  // the one we are searching for. However, there may be more than one such
		  // element. Make sure we always return the smallest of these.
		  while (index - 1 >= 0) {
		    if (aCompare(aHaystack[index], aHaystack[index - 1], true) !== 0) {
		      break;
		    }
		    --index;
		  }

		  return index;
		}; 
	} (binarySearch));
	return binarySearch;
}

var quickSort = {};

/* -*- Mode: js; js-indent-level: 2; -*- */

var hasRequiredQuickSort;

function requireQuickSort () {
	if (hasRequiredQuickSort) return quickSort;
	hasRequiredQuickSort = 1;
	/*
	 * Copyright 2011 Mozilla Foundation and contributors
	 * Licensed under the New BSD license. See LICENSE or:
	 * http://opensource.org/licenses/BSD-3-Clause
	 */

	// It turns out that some (most?) JavaScript engines don't self-host
	// `Array.prototype.sort`. This makes sense because C++ will likely remain
	// faster than JS when doing raw CPU-intensive sorting. However, when using a
	// custom comparator function, calling back and forth between the VM's C++ and
	// JIT'd JS is rather slow *and* loses JIT type information, resulting in
	// worse generated code for the comparator function than would be optimal. In
	// fact, when sorting with a comparator, these costs outweigh the benefits of
	// sorting in C++. By using our own JS-implemented Quick Sort (below), we get
	// a ~3500ms mean speed-up in `bench/bench.html`.

	/**
	 * Swap the elements indexed by `x` and `y` in the array `ary`.
	 *
	 * @param {Array} ary
	 *        The array.
	 * @param {Number} x
	 *        The index of the first item.
	 * @param {Number} y
	 *        The index of the second item.
	 */
	function swap(ary, x, y) {
	  var temp = ary[x];
	  ary[x] = ary[y];
	  ary[y] = temp;
	}

	/**
	 * Returns a random integer within the range `low .. high` inclusive.
	 *
	 * @param {Number} low
	 *        The lower bound on the range.
	 * @param {Number} high
	 *        The upper bound on the range.
	 */
	function randomIntInRange(low, high) {
	  return Math.round(low + (Math.random() * (high - low)));
	}

	/**
	 * The Quick Sort algorithm.
	 *
	 * @param {Array} ary
	 *        An array to sort.
	 * @param {function} comparator
	 *        Function to use to compare two items.
	 * @param {Number} p
	 *        Start index of the array
	 * @param {Number} r
	 *        End index of the array
	 */
	function doQuickSort(ary, comparator, p, r) {
	  // If our lower bound is less than our upper bound, we (1) partition the
	  // array into two pieces and (2) recurse on each half. If it is not, this is
	  // the empty array and our base case.

	  if (p < r) {
	    // (1) Partitioning.
	    //
	    // The partitioning chooses a pivot between `p` and `r` and moves all
	    // elements that are less than or equal to the pivot to the before it, and
	    // all the elements that are greater than it after it. The effect is that
	    // once partition is done, the pivot is in the exact place it will be when
	    // the array is put in sorted order, and it will not need to be moved
	    // again. This runs in O(n) time.

	    // Always choose a random pivot so that an input array which is reverse
	    // sorted does not cause O(n^2) running time.
	    var pivotIndex = randomIntInRange(p, r);
	    var i = p - 1;

	    swap(ary, pivotIndex, r);
	    var pivot = ary[r];

	    // Immediately after `j` is incremented in this loop, the following hold
	    // true:
	    //
	    //   * Every element in `ary[p .. i]` is less than or equal to the pivot.
	    //
	    //   * Every element in `ary[i+1 .. j-1]` is greater than the pivot.
	    for (var j = p; j < r; j++) {
	      if (comparator(ary[j], pivot) <= 0) {
	        i += 1;
	        swap(ary, i, j);
	      }
	    }

	    swap(ary, i + 1, j);
	    var q = i + 1;

	    // (2) Recurse on each half.

	    doQuickSort(ary, comparator, p, q - 1);
	    doQuickSort(ary, comparator, q + 1, r);
	  }
	}

	/**
	 * Sort the given array in-place with the given comparator function.
	 *
	 * @param {Array} ary
	 *        An array to sort.
	 * @param {function} comparator
	 *        Function to use to compare two items.
	 */
	quickSort.quickSort = function (ary, comparator) {
	  doQuickSort(ary, comparator, 0, ary.length - 1);
	};
	return quickSort;
}

/* -*- Mode: js; js-indent-level: 2; -*- */

var hasRequiredSourceMapConsumer;

function requireSourceMapConsumer () {
	if (hasRequiredSourceMapConsumer) return sourceMapConsumer;
	hasRequiredSourceMapConsumer = 1;
	/*
	 * Copyright 2011 Mozilla Foundation and contributors
	 * Licensed under the New BSD license. See LICENSE or:
	 * http://opensource.org/licenses/BSD-3-Clause
	 */

	var util = requireUtil$1();
	var binarySearch = requireBinarySearch();
	var ArraySet = requireArraySet().ArraySet;
	var base64VLQ = requireBase64Vlq();
	var quickSort = requireQuickSort().quickSort;

	function SourceMapConsumer(aSourceMap, aSourceMapURL) {
	  var sourceMap = aSourceMap;
	  if (typeof aSourceMap === 'string') {
	    sourceMap = util.parseSourceMapInput(aSourceMap);
	  }

	  return sourceMap.sections != null
	    ? new IndexedSourceMapConsumer(sourceMap, aSourceMapURL)
	    : new BasicSourceMapConsumer(sourceMap, aSourceMapURL);
	}

	SourceMapConsumer.fromSourceMap = function(aSourceMap, aSourceMapURL) {
	  return BasicSourceMapConsumer.fromSourceMap(aSourceMap, aSourceMapURL);
	};

	/**
	 * The version of the source mapping spec that we are consuming.
	 */
	SourceMapConsumer.prototype._version = 3;

	// `__generatedMappings` and `__originalMappings` are arrays that hold the
	// parsed mapping coordinates from the source map's "mappings" attribute. They
	// are lazily instantiated, accessed via the `_generatedMappings` and
	// `_originalMappings` getters respectively, and we only parse the mappings
	// and create these arrays once queried for a source location. We jump through
	// these hoops because there can be many thousands of mappings, and parsing
	// them is expensive, so we only want to do it if we must.
	//
	// Each object in the arrays is of the form:
	//
	//     {
	//       generatedLine: The line number in the generated code,
	//       generatedColumn: The column number in the generated code,
	//       source: The path to the original source file that generated this
	//               chunk of code,
	//       originalLine: The line number in the original source that
	//                     corresponds to this chunk of generated code,
	//       originalColumn: The column number in the original source that
	//                       corresponds to this chunk of generated code,
	//       name: The name of the original symbol which generated this chunk of
	//             code.
	//     }
	//
	// All properties except for `generatedLine` and `generatedColumn` can be
	// `null`.
	//
	// `_generatedMappings` is ordered by the generated positions.
	//
	// `_originalMappings` is ordered by the original positions.

	SourceMapConsumer.prototype.__generatedMappings = null;
	Object.defineProperty(SourceMapConsumer.prototype, '_generatedMappings', {
	  configurable: true,
	  enumerable: true,
	  get: function () {
	    if (!this.__generatedMappings) {
	      this._parseMappings(this._mappings, this.sourceRoot);
	    }

	    return this.__generatedMappings;
	  }
	});

	SourceMapConsumer.prototype.__originalMappings = null;
	Object.defineProperty(SourceMapConsumer.prototype, '_originalMappings', {
	  configurable: true,
	  enumerable: true,
	  get: function () {
	    if (!this.__originalMappings) {
	      this._parseMappings(this._mappings, this.sourceRoot);
	    }

	    return this.__originalMappings;
	  }
	});

	SourceMapConsumer.prototype._charIsMappingSeparator =
	  function SourceMapConsumer_charIsMappingSeparator(aStr, index) {
	    var c = aStr.charAt(index);
	    return c === ";" || c === ",";
	  };

	/**
	 * Parse the mappings in a string in to a data structure which we can easily
	 * query (the ordered arrays in the `this.__generatedMappings` and
	 * `this.__originalMappings` properties).
	 */
	SourceMapConsumer.prototype._parseMappings =
	  function SourceMapConsumer_parseMappings(aStr, aSourceRoot) {
	    throw new Error("Subclasses must implement _parseMappings");
	  };

	SourceMapConsumer.GENERATED_ORDER = 1;
	SourceMapConsumer.ORIGINAL_ORDER = 2;

	SourceMapConsumer.GREATEST_LOWER_BOUND = 1;
	SourceMapConsumer.LEAST_UPPER_BOUND = 2;

	/**
	 * Iterate over each mapping between an original source/line/column and a
	 * generated line/column in this source map.
	 *
	 * @param Function aCallback
	 *        The function that is called with each mapping.
	 * @param Object aContext
	 *        Optional. If specified, this object will be the value of `this` every
	 *        time that `aCallback` is called.
	 * @param aOrder
	 *        Either `SourceMapConsumer.GENERATED_ORDER` or
	 *        `SourceMapConsumer.ORIGINAL_ORDER`. Specifies whether you want to
	 *        iterate over the mappings sorted by the generated file's line/column
	 *        order or the original's source/line/column order, respectively. Defaults to
	 *        `SourceMapConsumer.GENERATED_ORDER`.
	 */
	SourceMapConsumer.prototype.eachMapping =
	  function SourceMapConsumer_eachMapping(aCallback, aContext, aOrder) {
	    var context = aContext || null;
	    var order = aOrder || SourceMapConsumer.GENERATED_ORDER;

	    var mappings;
	    switch (order) {
	    case SourceMapConsumer.GENERATED_ORDER:
	      mappings = this._generatedMappings;
	      break;
	    case SourceMapConsumer.ORIGINAL_ORDER:
	      mappings = this._originalMappings;
	      break;
	    default:
	      throw new Error("Unknown order of iteration.");
	    }

	    var sourceRoot = this.sourceRoot;
	    mappings.map(function (mapping) {
	      var source = mapping.source === null ? null : this._sources.at(mapping.source);
	      source = util.computeSourceURL(sourceRoot, source, this._sourceMapURL);
	      return {
	        source: source,
	        generatedLine: mapping.generatedLine,
	        generatedColumn: mapping.generatedColumn,
	        originalLine: mapping.originalLine,
	        originalColumn: mapping.originalColumn,
	        name: mapping.name === null ? null : this._names.at(mapping.name)
	      };
	    }, this).forEach(aCallback, context);
	  };

	/**
	 * Returns all generated line and column information for the original source,
	 * line, and column provided. If no column is provided, returns all mappings
	 * corresponding to a either the line we are searching for or the next
	 * closest line that has any mappings. Otherwise, returns all mappings
	 * corresponding to the given line and either the column we are searching for
	 * or the next closest column that has any offsets.
	 *
	 * The only argument is an object with the following properties:
	 *
	 *   - source: The filename of the original source.
	 *   - line: The line number in the original source.  The line number is 1-based.
	 *   - column: Optional. the column number in the original source.
	 *    The column number is 0-based.
	 *
	 * and an array of objects is returned, each with the following properties:
	 *
	 *   - line: The line number in the generated source, or null.  The
	 *    line number is 1-based.
	 *   - column: The column number in the generated source, or null.
	 *    The column number is 0-based.
	 */
	SourceMapConsumer.prototype.allGeneratedPositionsFor =
	  function SourceMapConsumer_allGeneratedPositionsFor(aArgs) {
	    var line = util.getArg(aArgs, 'line');

	    // When there is no exact match, BasicSourceMapConsumer.prototype._findMapping
	    // returns the index of the closest mapping less than the needle. By
	    // setting needle.originalColumn to 0, we thus find the last mapping for
	    // the given line, provided such a mapping exists.
	    var needle = {
	      source: util.getArg(aArgs, 'source'),
	      originalLine: line,
	      originalColumn: util.getArg(aArgs, 'column', 0)
	    };

	    needle.source = this._findSourceIndex(needle.source);
	    if (needle.source < 0) {
	      return [];
	    }

	    var mappings = [];

	    var index = this._findMapping(needle,
	                                  this._originalMappings,
	                                  "originalLine",
	                                  "originalColumn",
	                                  util.compareByOriginalPositions,
	                                  binarySearch.LEAST_UPPER_BOUND);
	    if (index >= 0) {
	      var mapping = this._originalMappings[index];

	      if (aArgs.column === undefined) {
	        var originalLine = mapping.originalLine;

	        // Iterate until either we run out of mappings, or we run into
	        // a mapping for a different line than the one we found. Since
	        // mappings are sorted, this is guaranteed to find all mappings for
	        // the line we found.
	        while (mapping && mapping.originalLine === originalLine) {
	          mappings.push({
	            line: util.getArg(mapping, 'generatedLine', null),
	            column: util.getArg(mapping, 'generatedColumn', null),
	            lastColumn: util.getArg(mapping, 'lastGeneratedColumn', null)
	          });

	          mapping = this._originalMappings[++index];
	        }
	      } else {
	        var originalColumn = mapping.originalColumn;

	        // Iterate until either we run out of mappings, or we run into
	        // a mapping for a different line than the one we were searching for.
	        // Since mappings are sorted, this is guaranteed to find all mappings for
	        // the line we are searching for.
	        while (mapping &&
	               mapping.originalLine === line &&
	               mapping.originalColumn == originalColumn) {
	          mappings.push({
	            line: util.getArg(mapping, 'generatedLine', null),
	            column: util.getArg(mapping, 'generatedColumn', null),
	            lastColumn: util.getArg(mapping, 'lastGeneratedColumn', null)
	          });

	          mapping = this._originalMappings[++index];
	        }
	      }
	    }

	    return mappings;
	  };

	sourceMapConsumer.SourceMapConsumer = SourceMapConsumer;

	/**
	 * A BasicSourceMapConsumer instance represents a parsed source map which we can
	 * query for information about the original file positions by giving it a file
	 * position in the generated source.
	 *
	 * The first parameter is the raw source map (either as a JSON string, or
	 * already parsed to an object). According to the spec, source maps have the
	 * following attributes:
	 *
	 *   - version: Which version of the source map spec this map is following.
	 *   - sources: An array of URLs to the original source files.
	 *   - names: An array of identifiers which can be referrenced by individual mappings.
	 *   - sourceRoot: Optional. The URL root from which all sources are relative.
	 *   - sourcesContent: Optional. An array of contents of the original source files.
	 *   - mappings: A string of base64 VLQs which contain the actual mappings.
	 *   - file: Optional. The generated file this source map is associated with.
	 *
	 * Here is an example source map, taken from the source map spec[0]:
	 *
	 *     {
	 *       version : 3,
	 *       file: "out.js",
	 *       sourceRoot : "",
	 *       sources: ["foo.js", "bar.js"],
	 *       names: ["src", "maps", "are", "fun"],
	 *       mappings: "AA,AB;;ABCDE;"
	 *     }
	 *
	 * The second parameter, if given, is a string whose value is the URL
	 * at which the source map was found.  This URL is used to compute the
	 * sources array.
	 *
	 * [0]: https://docs.google.com/document/d/1U1RGAehQwRypUTovF1KRlpiOFze0b-_2gc6fAH0KY0k/edit?pli=1#
	 */
	function BasicSourceMapConsumer(aSourceMap, aSourceMapURL) {
	  var sourceMap = aSourceMap;
	  if (typeof aSourceMap === 'string') {
	    sourceMap = util.parseSourceMapInput(aSourceMap);
	  }

	  var version = util.getArg(sourceMap, 'version');
	  var sources = util.getArg(sourceMap, 'sources');
	  // Sass 3.3 leaves out the 'names' array, so we deviate from the spec (which
	  // requires the array) to play nice here.
	  var names = util.getArg(sourceMap, 'names', []);
	  var sourceRoot = util.getArg(sourceMap, 'sourceRoot', null);
	  var sourcesContent = util.getArg(sourceMap, 'sourcesContent', null);
	  var mappings = util.getArg(sourceMap, 'mappings');
	  var file = util.getArg(sourceMap, 'file', null);

	  // Once again, Sass deviates from the spec and supplies the version as a
	  // string rather than a number, so we use loose equality checking here.
	  if (version != this._version) {
	    throw new Error('Unsupported version: ' + version);
	  }

	  if (sourceRoot) {
	    sourceRoot = util.normalize(sourceRoot);
	  }

	  sources = sources
	    .map(String)
	    // Some source maps produce relative source paths like "./foo.js" instead of
	    // "foo.js".  Normalize these first so that future comparisons will succeed.
	    // See bugzil.la/1090768.
	    .map(util.normalize)
	    // Always ensure that absolute sources are internally stored relative to
	    // the source root, if the source root is absolute. Not doing this would
	    // be particularly problematic when the source root is a prefix of the
	    // source (valid, but why??). See github issue #199 and bugzil.la/1188982.
	    .map(function (source) {
	      return sourceRoot && util.isAbsolute(sourceRoot) && util.isAbsolute(source)
	        ? util.relative(sourceRoot, source)
	        : source;
	    });

	  // Pass `true` below to allow duplicate names and sources. While source maps
	  // are intended to be compressed and deduplicated, the TypeScript compiler
	  // sometimes generates source maps with duplicates in them. See Github issue
	  // #72 and bugzil.la/889492.
	  this._names = ArraySet.fromArray(names.map(String), true);
	  this._sources = ArraySet.fromArray(sources, true);

	  this._absoluteSources = this._sources.toArray().map(function (s) {
	    return util.computeSourceURL(sourceRoot, s, aSourceMapURL);
	  });

	  this.sourceRoot = sourceRoot;
	  this.sourcesContent = sourcesContent;
	  this._mappings = mappings;
	  this._sourceMapURL = aSourceMapURL;
	  this.file = file;
	}

	BasicSourceMapConsumer.prototype = Object.create(SourceMapConsumer.prototype);
	BasicSourceMapConsumer.prototype.consumer = SourceMapConsumer;

	/**
	 * Utility function to find the index of a source.  Returns -1 if not
	 * found.
	 */
	BasicSourceMapConsumer.prototype._findSourceIndex = function(aSource) {
	  var relativeSource = aSource;
	  if (this.sourceRoot != null) {
	    relativeSource = util.relative(this.sourceRoot, relativeSource);
	  }

	  if (this._sources.has(relativeSource)) {
	    return this._sources.indexOf(relativeSource);
	  }

	  // Maybe aSource is an absolute URL as returned by |sources|.  In
	  // this case we can't simply undo the transform.
	  var i;
	  for (i = 0; i < this._absoluteSources.length; ++i) {
	    if (this._absoluteSources[i] == aSource) {
	      return i;
	    }
	  }

	  return -1;
	};

	/**
	 * Create a BasicSourceMapConsumer from a SourceMapGenerator.
	 *
	 * @param SourceMapGenerator aSourceMap
	 *        The source map that will be consumed.
	 * @param String aSourceMapURL
	 *        The URL at which the source map can be found (optional)
	 * @returns BasicSourceMapConsumer
	 */
	BasicSourceMapConsumer.fromSourceMap =
	  function SourceMapConsumer_fromSourceMap(aSourceMap, aSourceMapURL) {
	    var smc = Object.create(BasicSourceMapConsumer.prototype);

	    var names = smc._names = ArraySet.fromArray(aSourceMap._names.toArray(), true);
	    var sources = smc._sources = ArraySet.fromArray(aSourceMap._sources.toArray(), true);
	    smc.sourceRoot = aSourceMap._sourceRoot;
	    smc.sourcesContent = aSourceMap._generateSourcesContent(smc._sources.toArray(),
	                                                            smc.sourceRoot);
	    smc.file = aSourceMap._file;
	    smc._sourceMapURL = aSourceMapURL;
	    smc._absoluteSources = smc._sources.toArray().map(function (s) {
	      return util.computeSourceURL(smc.sourceRoot, s, aSourceMapURL);
	    });

	    // Because we are modifying the entries (by converting string sources and
	    // names to indices into the sources and names ArraySets), we have to make
	    // a copy of the entry or else bad things happen. Shared mutable state
	    // strikes again! See github issue #191.

	    var generatedMappings = aSourceMap._mappings.toArray().slice();
	    var destGeneratedMappings = smc.__generatedMappings = [];
	    var destOriginalMappings = smc.__originalMappings = [];

	    for (var i = 0, length = generatedMappings.length; i < length; i++) {
	      var srcMapping = generatedMappings[i];
	      var destMapping = new Mapping;
	      destMapping.generatedLine = srcMapping.generatedLine;
	      destMapping.generatedColumn = srcMapping.generatedColumn;

	      if (srcMapping.source) {
	        destMapping.source = sources.indexOf(srcMapping.source);
	        destMapping.originalLine = srcMapping.originalLine;
	        destMapping.originalColumn = srcMapping.originalColumn;

	        if (srcMapping.name) {
	          destMapping.name = names.indexOf(srcMapping.name);
	        }

	        destOriginalMappings.push(destMapping);
	      }

	      destGeneratedMappings.push(destMapping);
	    }

	    quickSort(smc.__originalMappings, util.compareByOriginalPositions);

	    return smc;
	  };

	/**
	 * The version of the source mapping spec that we are consuming.
	 */
	BasicSourceMapConsumer.prototype._version = 3;

	/**
	 * The list of original sources.
	 */
	Object.defineProperty(BasicSourceMapConsumer.prototype, 'sources', {
	  get: function () {
	    return this._absoluteSources.slice();
	  }
	});

	/**
	 * Provide the JIT with a nice shape / hidden class.
	 */
	function Mapping() {
	  this.generatedLine = 0;
	  this.generatedColumn = 0;
	  this.source = null;
	  this.originalLine = null;
	  this.originalColumn = null;
	  this.name = null;
	}

	/**
	 * Parse the mappings in a string in to a data structure which we can easily
	 * query (the ordered arrays in the `this.__generatedMappings` and
	 * `this.__originalMappings` properties).
	 */
	BasicSourceMapConsumer.prototype._parseMappings =
	  function SourceMapConsumer_parseMappings(aStr, aSourceRoot) {
	    var generatedLine = 1;
	    var previousGeneratedColumn = 0;
	    var previousOriginalLine = 0;
	    var previousOriginalColumn = 0;
	    var previousSource = 0;
	    var previousName = 0;
	    var length = aStr.length;
	    var index = 0;
	    var cachedSegments = {};
	    var temp = {};
	    var originalMappings = [];
	    var generatedMappings = [];
	    var mapping, str, segment, end, value;

	    while (index < length) {
	      if (aStr.charAt(index) === ';') {
	        generatedLine++;
	        index++;
	        previousGeneratedColumn = 0;
	      }
	      else if (aStr.charAt(index) === ',') {
	        index++;
	      }
	      else {
	        mapping = new Mapping();
	        mapping.generatedLine = generatedLine;

	        // Because each offset is encoded relative to the previous one,
	        // many segments often have the same encoding. We can exploit this
	        // fact by caching the parsed variable length fields of each segment,
	        // allowing us to avoid a second parse if we encounter the same
	        // segment again.
	        for (end = index; end < length; end++) {
	          if (this._charIsMappingSeparator(aStr, end)) {
	            break;
	          }
	        }
	        str = aStr.slice(index, end);

	        segment = cachedSegments[str];
	        if (segment) {
	          index += str.length;
	        } else {
	          segment = [];
	          while (index < end) {
	            base64VLQ.decode(aStr, index, temp);
	            value = temp.value;
	            index = temp.rest;
	            segment.push(value);
	          }

	          if (segment.length === 2) {
	            throw new Error('Found a source, but no line and column');
	          }

	          if (segment.length === 3) {
	            throw new Error('Found a source and line, but no column');
	          }

	          cachedSegments[str] = segment;
	        }

	        // Generated column.
	        mapping.generatedColumn = previousGeneratedColumn + segment[0];
	        previousGeneratedColumn = mapping.generatedColumn;

	        if (segment.length > 1) {
	          // Original source.
	          mapping.source = previousSource + segment[1];
	          previousSource += segment[1];

	          // Original line.
	          mapping.originalLine = previousOriginalLine + segment[2];
	          previousOriginalLine = mapping.originalLine;
	          // Lines are stored 0-based
	          mapping.originalLine += 1;

	          // Original column.
	          mapping.originalColumn = previousOriginalColumn + segment[3];
	          previousOriginalColumn = mapping.originalColumn;

	          if (segment.length > 4) {
	            // Original name.
	            mapping.name = previousName + segment[4];
	            previousName += segment[4];
	          }
	        }

	        generatedMappings.push(mapping);
	        if (typeof mapping.originalLine === 'number') {
	          originalMappings.push(mapping);
	        }
	      }
	    }

	    quickSort(generatedMappings, util.compareByGeneratedPositionsDeflated);
	    this.__generatedMappings = generatedMappings;

	    quickSort(originalMappings, util.compareByOriginalPositions);
	    this.__originalMappings = originalMappings;
	  };

	/**
	 * Find the mapping that best matches the hypothetical "needle" mapping that
	 * we are searching for in the given "haystack" of mappings.
	 */
	BasicSourceMapConsumer.prototype._findMapping =
	  function SourceMapConsumer_findMapping(aNeedle, aMappings, aLineName,
	                                         aColumnName, aComparator, aBias) {
	    // To return the position we are searching for, we must first find the
	    // mapping for the given position and then return the opposite position it
	    // points to. Because the mappings are sorted, we can use binary search to
	    // find the best mapping.

	    if (aNeedle[aLineName] <= 0) {
	      throw new TypeError('Line must be greater than or equal to 1, got '
	                          + aNeedle[aLineName]);
	    }
	    if (aNeedle[aColumnName] < 0) {
	      throw new TypeError('Column must be greater than or equal to 0, got '
	                          + aNeedle[aColumnName]);
	    }

	    return binarySearch.search(aNeedle, aMappings, aComparator, aBias);
	  };

	/**
	 * Compute the last column for each generated mapping. The last column is
	 * inclusive.
	 */
	BasicSourceMapConsumer.prototype.computeColumnSpans =
	  function SourceMapConsumer_computeColumnSpans() {
	    for (var index = 0; index < this._generatedMappings.length; ++index) {
	      var mapping = this._generatedMappings[index];

	      // Mappings do not contain a field for the last generated columnt. We
	      // can come up with an optimistic estimate, however, by assuming that
	      // mappings are contiguous (i.e. given two consecutive mappings, the
	      // first mapping ends where the second one starts).
	      if (index + 1 < this._generatedMappings.length) {
	        var nextMapping = this._generatedMappings[index + 1];

	        if (mapping.generatedLine === nextMapping.generatedLine) {
	          mapping.lastGeneratedColumn = nextMapping.generatedColumn - 1;
	          continue;
	        }
	      }

	      // The last mapping for each line spans the entire line.
	      mapping.lastGeneratedColumn = Infinity;
	    }
	  };

	/**
	 * Returns the original source, line, and column information for the generated
	 * source's line and column positions provided. The only argument is an object
	 * with the following properties:
	 *
	 *   - line: The line number in the generated source.  The line number
	 *     is 1-based.
	 *   - column: The column number in the generated source.  The column
	 *     number is 0-based.
	 *   - bias: Either 'SourceMapConsumer.GREATEST_LOWER_BOUND' or
	 *     'SourceMapConsumer.LEAST_UPPER_BOUND'. Specifies whether to return the
	 *     closest element that is smaller than or greater than the one we are
	 *     searching for, respectively, if the exact element cannot be found.
	 *     Defaults to 'SourceMapConsumer.GREATEST_LOWER_BOUND'.
	 *
	 * and an object is returned with the following properties:
	 *
	 *   - source: The original source file, or null.
	 *   - line: The line number in the original source, or null.  The
	 *     line number is 1-based.
	 *   - column: The column number in the original source, or null.  The
	 *     column number is 0-based.
	 *   - name: The original identifier, or null.
	 */
	BasicSourceMapConsumer.prototype.originalPositionFor =
	  function SourceMapConsumer_originalPositionFor(aArgs) {
	    var needle = {
	      generatedLine: util.getArg(aArgs, 'line'),
	      generatedColumn: util.getArg(aArgs, 'column')
	    };

	    var index = this._findMapping(
	      needle,
	      this._generatedMappings,
	      "generatedLine",
	      "generatedColumn",
	      util.compareByGeneratedPositionsDeflated,
	      util.getArg(aArgs, 'bias', SourceMapConsumer.GREATEST_LOWER_BOUND)
	    );

	    if (index >= 0) {
	      var mapping = this._generatedMappings[index];

	      if (mapping.generatedLine === needle.generatedLine) {
	        var source = util.getArg(mapping, 'source', null);
	        if (source !== null) {
	          source = this._sources.at(source);
	          source = util.computeSourceURL(this.sourceRoot, source, this._sourceMapURL);
	        }
	        var name = util.getArg(mapping, 'name', null);
	        if (name !== null) {
	          name = this._names.at(name);
	        }
	        return {
	          source: source,
	          line: util.getArg(mapping, 'originalLine', null),
	          column: util.getArg(mapping, 'originalColumn', null),
	          name: name
	        };
	      }
	    }

	    return {
	      source: null,
	      line: null,
	      column: null,
	      name: null
	    };
	  };

	/**
	 * Return true if we have the source content for every source in the source
	 * map, false otherwise.
	 */
	BasicSourceMapConsumer.prototype.hasContentsOfAllSources =
	  function BasicSourceMapConsumer_hasContentsOfAllSources() {
	    if (!this.sourcesContent) {
	      return false;
	    }
	    return this.sourcesContent.length >= this._sources.size() &&
	      !this.sourcesContent.some(function (sc) { return sc == null; });
	  };

	/**
	 * Returns the original source content. The only argument is the url of the
	 * original source file. Returns null if no original source content is
	 * available.
	 */
	BasicSourceMapConsumer.prototype.sourceContentFor =
	  function SourceMapConsumer_sourceContentFor(aSource, nullOnMissing) {
	    if (!this.sourcesContent) {
	      return null;
	    }

	    var index = this._findSourceIndex(aSource);
	    if (index >= 0) {
	      return this.sourcesContent[index];
	    }

	    var relativeSource = aSource;
	    if (this.sourceRoot != null) {
	      relativeSource = util.relative(this.sourceRoot, relativeSource);
	    }

	    var url;
	    if (this.sourceRoot != null
	        && (url = util.urlParse(this.sourceRoot))) {
	      // XXX: file:// URIs and absolute paths lead to unexpected behavior for
	      // many users. We can help them out when they expect file:// URIs to
	      // behave like it would if they were running a local HTTP server. See
	      // https://bugzilla.mozilla.org/show_bug.cgi?id=885597.
	      var fileUriAbsPath = relativeSource.replace(/^file:\/\//, "");
	      if (url.scheme == "file"
	          && this._sources.has(fileUriAbsPath)) {
	        return this.sourcesContent[this._sources.indexOf(fileUriAbsPath)]
	      }

	      if ((!url.path || url.path == "/")
	          && this._sources.has("/" + relativeSource)) {
	        return this.sourcesContent[this._sources.indexOf("/" + relativeSource)];
	      }
	    }

	    // This function is used recursively from
	    // IndexedSourceMapConsumer.prototype.sourceContentFor. In that case, we
	    // don't want to throw if we can't find the source - we just want to
	    // return null, so we provide a flag to exit gracefully.
	    if (nullOnMissing) {
	      return null;
	    }
	    else {
	      throw new Error('"' + relativeSource + '" is not in the SourceMap.');
	    }
	  };

	/**
	 * Returns the generated line and column information for the original source,
	 * line, and column positions provided. The only argument is an object with
	 * the following properties:
	 *
	 *   - source: The filename of the original source.
	 *   - line: The line number in the original source.  The line number
	 *     is 1-based.
	 *   - column: The column number in the original source.  The column
	 *     number is 0-based.
	 *   - bias: Either 'SourceMapConsumer.GREATEST_LOWER_BOUND' or
	 *     'SourceMapConsumer.LEAST_UPPER_BOUND'. Specifies whether to return the
	 *     closest element that is smaller than or greater than the one we are
	 *     searching for, respectively, if the exact element cannot be found.
	 *     Defaults to 'SourceMapConsumer.GREATEST_LOWER_BOUND'.
	 *
	 * and an object is returned with the following properties:
	 *
	 *   - line: The line number in the generated source, or null.  The
	 *     line number is 1-based.
	 *   - column: The column number in the generated source, or null.
	 *     The column number is 0-based.
	 */
	BasicSourceMapConsumer.prototype.generatedPositionFor =
	  function SourceMapConsumer_generatedPositionFor(aArgs) {
	    var source = util.getArg(aArgs, 'source');
	    source = this._findSourceIndex(source);
	    if (source < 0) {
	      return {
	        line: null,
	        column: null,
	        lastColumn: null
	      };
	    }

	    var needle = {
	      source: source,
	      originalLine: util.getArg(aArgs, 'line'),
	      originalColumn: util.getArg(aArgs, 'column')
	    };

	    var index = this._findMapping(
	      needle,
	      this._originalMappings,
	      "originalLine",
	      "originalColumn",
	      util.compareByOriginalPositions,
	      util.getArg(aArgs, 'bias', SourceMapConsumer.GREATEST_LOWER_BOUND)
	    );

	    if (index >= 0) {
	      var mapping = this._originalMappings[index];

	      if (mapping.source === needle.source) {
	        return {
	          line: util.getArg(mapping, 'generatedLine', null),
	          column: util.getArg(mapping, 'generatedColumn', null),
	          lastColumn: util.getArg(mapping, 'lastGeneratedColumn', null)
	        };
	      }
	    }

	    return {
	      line: null,
	      column: null,
	      lastColumn: null
	    };
	  };

	sourceMapConsumer.BasicSourceMapConsumer = BasicSourceMapConsumer;

	/**
	 * An IndexedSourceMapConsumer instance represents a parsed source map which
	 * we can query for information. It differs from BasicSourceMapConsumer in
	 * that it takes "indexed" source maps (i.e. ones with a "sections" field) as
	 * input.
	 *
	 * The first parameter is a raw source map (either as a JSON string, or already
	 * parsed to an object). According to the spec for indexed source maps, they
	 * have the following attributes:
	 *
	 *   - version: Which version of the source map spec this map is following.
	 *   - file: Optional. The generated file this source map is associated with.
	 *   - sections: A list of section definitions.
	 *
	 * Each value under the "sections" field has two fields:
	 *   - offset: The offset into the original specified at which this section
	 *       begins to apply, defined as an object with a "line" and "column"
	 *       field.
	 *   - map: A source map definition. This source map could also be indexed,
	 *       but doesn't have to be.
	 *
	 * Instead of the "map" field, it's also possible to have a "url" field
	 * specifying a URL to retrieve a source map from, but that's currently
	 * unsupported.
	 *
	 * Here's an example source map, taken from the source map spec[0], but
	 * modified to omit a section which uses the "url" field.
	 *
	 *  {
	 *    version : 3,
	 *    file: "app.js",
	 *    sections: [{
	 *      offset: {line:100, column:10},
	 *      map: {
	 *        version : 3,
	 *        file: "section.js",
	 *        sources: ["foo.js", "bar.js"],
	 *        names: ["src", "maps", "are", "fun"],
	 *        mappings: "AAAA,E;;ABCDE;"
	 *      }
	 *    }],
	 *  }
	 *
	 * The second parameter, if given, is a string whose value is the URL
	 * at which the source map was found.  This URL is used to compute the
	 * sources array.
	 *
	 * [0]: https://docs.google.com/document/d/1U1RGAehQwRypUTovF1KRlpiOFze0b-_2gc6fAH0KY0k/edit#heading=h.535es3xeprgt
	 */
	function IndexedSourceMapConsumer(aSourceMap, aSourceMapURL) {
	  var sourceMap = aSourceMap;
	  if (typeof aSourceMap === 'string') {
	    sourceMap = util.parseSourceMapInput(aSourceMap);
	  }

	  var version = util.getArg(sourceMap, 'version');
	  var sections = util.getArg(sourceMap, 'sections');

	  if (version != this._version) {
	    throw new Error('Unsupported version: ' + version);
	  }

	  this._sources = new ArraySet();
	  this._names = new ArraySet();

	  var lastOffset = {
	    line: -1,
	    column: 0
	  };
	  this._sections = sections.map(function (s) {
	    if (s.url) {
	      // The url field will require support for asynchronicity.
	      // See https://github.com/mozilla/source-map/issues/16
	      throw new Error('Support for url field in sections not implemented.');
	    }
	    var offset = util.getArg(s, 'offset');
	    var offsetLine = util.getArg(offset, 'line');
	    var offsetColumn = util.getArg(offset, 'column');

	    if (offsetLine < lastOffset.line ||
	        (offsetLine === lastOffset.line && offsetColumn < lastOffset.column)) {
	      throw new Error('Section offsets must be ordered and non-overlapping.');
	    }
	    lastOffset = offset;

	    return {
	      generatedOffset: {
	        // The offset fields are 0-based, but we use 1-based indices when
	        // encoding/decoding from VLQ.
	        generatedLine: offsetLine + 1,
	        generatedColumn: offsetColumn + 1
	      },
	      consumer: new SourceMapConsumer(util.getArg(s, 'map'), aSourceMapURL)
	    }
	  });
	}

	IndexedSourceMapConsumer.prototype = Object.create(SourceMapConsumer.prototype);
	IndexedSourceMapConsumer.prototype.constructor = SourceMapConsumer;

	/**
	 * The version of the source mapping spec that we are consuming.
	 */
	IndexedSourceMapConsumer.prototype._version = 3;

	/**
	 * The list of original sources.
	 */
	Object.defineProperty(IndexedSourceMapConsumer.prototype, 'sources', {
	  get: function () {
	    var sources = [];
	    for (var i = 0; i < this._sections.length; i++) {
	      for (var j = 0; j < this._sections[i].consumer.sources.length; j++) {
	        sources.push(this._sections[i].consumer.sources[j]);
	      }
	    }
	    return sources;
	  }
	});

	/**
	 * Returns the original source, line, and column information for the generated
	 * source's line and column positions provided. The only argument is an object
	 * with the following properties:
	 *
	 *   - line: The line number in the generated source.  The line number
	 *     is 1-based.
	 *   - column: The column number in the generated source.  The column
	 *     number is 0-based.
	 *
	 * and an object is returned with the following properties:
	 *
	 *   - source: The original source file, or null.
	 *   - line: The line number in the original source, or null.  The
	 *     line number is 1-based.
	 *   - column: The column number in the original source, or null.  The
	 *     column number is 0-based.
	 *   - name: The original identifier, or null.
	 */
	IndexedSourceMapConsumer.prototype.originalPositionFor =
	  function IndexedSourceMapConsumer_originalPositionFor(aArgs) {
	    var needle = {
	      generatedLine: util.getArg(aArgs, 'line'),
	      generatedColumn: util.getArg(aArgs, 'column')
	    };

	    // Find the section containing the generated position we're trying to map
	    // to an original position.
	    var sectionIndex = binarySearch.search(needle, this._sections,
	      function(needle, section) {
	        var cmp = needle.generatedLine - section.generatedOffset.generatedLine;
	        if (cmp) {
	          return cmp;
	        }

	        return (needle.generatedColumn -
	                section.generatedOffset.generatedColumn);
	      });
	    var section = this._sections[sectionIndex];

	    if (!section) {
	      return {
	        source: null,
	        line: null,
	        column: null,
	        name: null
	      };
	    }

	    return section.consumer.originalPositionFor({
	      line: needle.generatedLine -
	        (section.generatedOffset.generatedLine - 1),
	      column: needle.generatedColumn -
	        (section.generatedOffset.generatedLine === needle.generatedLine
	         ? section.generatedOffset.generatedColumn - 1
	         : 0),
	      bias: aArgs.bias
	    });
	  };

	/**
	 * Return true if we have the source content for every source in the source
	 * map, false otherwise.
	 */
	IndexedSourceMapConsumer.prototype.hasContentsOfAllSources =
	  function IndexedSourceMapConsumer_hasContentsOfAllSources() {
	    return this._sections.every(function (s) {
	      return s.consumer.hasContentsOfAllSources();
	    });
	  };

	/**
	 * Returns the original source content. The only argument is the url of the
	 * original source file. Returns null if no original source content is
	 * available.
	 */
	IndexedSourceMapConsumer.prototype.sourceContentFor =
	  function IndexedSourceMapConsumer_sourceContentFor(aSource, nullOnMissing) {
	    for (var i = 0; i < this._sections.length; i++) {
	      var section = this._sections[i];

	      var content = section.consumer.sourceContentFor(aSource, true);
	      if (content) {
	        return content;
	      }
	    }
	    if (nullOnMissing) {
	      return null;
	    }
	    else {
	      throw new Error('"' + aSource + '" is not in the SourceMap.');
	    }
	  };

	/**
	 * Returns the generated line and column information for the original source,
	 * line, and column positions provided. The only argument is an object with
	 * the following properties:
	 *
	 *   - source: The filename of the original source.
	 *   - line: The line number in the original source.  The line number
	 *     is 1-based.
	 *   - column: The column number in the original source.  The column
	 *     number is 0-based.
	 *
	 * and an object is returned with the following properties:
	 *
	 *   - line: The line number in the generated source, or null.  The
	 *     line number is 1-based. 
	 *   - column: The column number in the generated source, or null.
	 *     The column number is 0-based.
	 */
	IndexedSourceMapConsumer.prototype.generatedPositionFor =
	  function IndexedSourceMapConsumer_generatedPositionFor(aArgs) {
	    for (var i = 0; i < this._sections.length; i++) {
	      var section = this._sections[i];

	      // Only consider this section if the requested source is in the list of
	      // sources of the consumer.
	      if (section.consumer._findSourceIndex(util.getArg(aArgs, 'source')) === -1) {
	        continue;
	      }
	      var generatedPosition = section.consumer.generatedPositionFor(aArgs);
	      if (generatedPosition) {
	        var ret = {
	          line: generatedPosition.line +
	            (section.generatedOffset.generatedLine - 1),
	          column: generatedPosition.column +
	            (section.generatedOffset.generatedLine === generatedPosition.line
	             ? section.generatedOffset.generatedColumn - 1
	             : 0)
	        };
	        return ret;
	      }
	    }

	    return {
	      line: null,
	      column: null
	    };
	  };

	/**
	 * Parse the mappings in a string in to a data structure which we can easily
	 * query (the ordered arrays in the `this.__generatedMappings` and
	 * `this.__originalMappings` properties).
	 */
	IndexedSourceMapConsumer.prototype._parseMappings =
	  function IndexedSourceMapConsumer_parseMappings(aStr, aSourceRoot) {
	    this.__generatedMappings = [];
	    this.__originalMappings = [];
	    for (var i = 0; i < this._sections.length; i++) {
	      var section = this._sections[i];
	      var sectionMappings = section.consumer._generatedMappings;
	      for (var j = 0; j < sectionMappings.length; j++) {
	        var mapping = sectionMappings[j];

	        var source = section.consumer._sources.at(mapping.source);
	        source = util.computeSourceURL(section.consumer.sourceRoot, source, this._sourceMapURL);
	        this._sources.add(source);
	        source = this._sources.indexOf(source);

	        var name = null;
	        if (mapping.name) {
	          name = section.consumer._names.at(mapping.name);
	          this._names.add(name);
	          name = this._names.indexOf(name);
	        }

	        // The mappings coming from the consumer for the section have
	        // generated positions relative to the start of the section, so we
	        // need to offset them to be relative to the start of the concatenated
	        // generated file.
	        var adjustedMapping = {
	          source: source,
	          generatedLine: mapping.generatedLine +
	            (section.generatedOffset.generatedLine - 1),
	          generatedColumn: mapping.generatedColumn +
	            (section.generatedOffset.generatedLine === mapping.generatedLine
	            ? section.generatedOffset.generatedColumn - 1
	            : 0),
	          originalLine: mapping.originalLine,
	          originalColumn: mapping.originalColumn,
	          name: name
	        };

	        this.__generatedMappings.push(adjustedMapping);
	        if (typeof adjustedMapping.originalLine === 'number') {
	          this.__originalMappings.push(adjustedMapping);
	        }
	      }
	    }

	    quickSort(this.__generatedMappings, util.compareByGeneratedPositionsDeflated);
	    quickSort(this.__originalMappings, util.compareByOriginalPositions);
	  };

	sourceMapConsumer.IndexedSourceMapConsumer = IndexedSourceMapConsumer;
	return sourceMapConsumer;
}

var sourceNode = {};

/* -*- Mode: js; js-indent-level: 2; -*- */

var hasRequiredSourceNode;

function requireSourceNode () {
	if (hasRequiredSourceNode) return sourceNode;
	hasRequiredSourceNode = 1;
	/*
	 * Copyright 2011 Mozilla Foundation and contributors
	 * Licensed under the New BSD license. See LICENSE or:
	 * http://opensource.org/licenses/BSD-3-Clause
	 */

	var SourceMapGenerator = requireSourceMapGenerator().SourceMapGenerator;
	var util = requireUtil$1();

	// Matches a Windows-style `\r\n` newline or a `\n` newline used by all other
	// operating systems these days (capturing the result).
	var REGEX_NEWLINE = /(\r?\n)/;

	// Newline character code for charCodeAt() comparisons
	var NEWLINE_CODE = 10;

	// Private symbol for identifying `SourceNode`s when multiple versions of
	// the source-map library are loaded. This MUST NOT CHANGE across
	// versions!
	var isSourceNode = "$$$isSourceNode$$$";

	/**
	 * SourceNodes provide a way to abstract over interpolating/concatenating
	 * snippets of generated JavaScript source code while maintaining the line and
	 * column information associated with the original source code.
	 *
	 * @param aLine The original line number.
	 * @param aColumn The original column number.
	 * @param aSource The original source's filename.
	 * @param aChunks Optional. An array of strings which are snippets of
	 *        generated JS, or other SourceNodes.
	 * @param aName The original identifier.
	 */
	function SourceNode(aLine, aColumn, aSource, aChunks, aName) {
	  this.children = [];
	  this.sourceContents = {};
	  this.line = aLine == null ? null : aLine;
	  this.column = aColumn == null ? null : aColumn;
	  this.source = aSource == null ? null : aSource;
	  this.name = aName == null ? null : aName;
	  this[isSourceNode] = true;
	  if (aChunks != null) this.add(aChunks);
	}

	/**
	 * Creates a SourceNode from generated code and a SourceMapConsumer.
	 *
	 * @param aGeneratedCode The generated code
	 * @param aSourceMapConsumer The SourceMap for the generated code
	 * @param aRelativePath Optional. The path that relative sources in the
	 *        SourceMapConsumer should be relative to.
	 */
	SourceNode.fromStringWithSourceMap =
	  function SourceNode_fromStringWithSourceMap(aGeneratedCode, aSourceMapConsumer, aRelativePath) {
	    // The SourceNode we want to fill with the generated code
	    // and the SourceMap
	    var node = new SourceNode();

	    // All even indices of this array are one line of the generated code,
	    // while all odd indices are the newlines between two adjacent lines
	    // (since `REGEX_NEWLINE` captures its match).
	    // Processed fragments are accessed by calling `shiftNextLine`.
	    var remainingLines = aGeneratedCode.split(REGEX_NEWLINE);
	    var remainingLinesIndex = 0;
	    var shiftNextLine = function() {
	      var lineContents = getNextLine();
	      // The last line of a file might not have a newline.
	      var newLine = getNextLine() || "";
	      return lineContents + newLine;

	      function getNextLine() {
	        return remainingLinesIndex < remainingLines.length ?
	            remainingLines[remainingLinesIndex++] : undefined;
	      }
	    };

	    // We need to remember the position of "remainingLines"
	    var lastGeneratedLine = 1, lastGeneratedColumn = 0;

	    // The generate SourceNodes we need a code range.
	    // To extract it current and last mapping is used.
	    // Here we store the last mapping.
	    var lastMapping = null;

	    aSourceMapConsumer.eachMapping(function (mapping) {
	      if (lastMapping !== null) {
	        // We add the code from "lastMapping" to "mapping":
	        // First check if there is a new line in between.
	        if (lastGeneratedLine < mapping.generatedLine) {
	          // Associate first line with "lastMapping"
	          addMappingWithCode(lastMapping, shiftNextLine());
	          lastGeneratedLine++;
	          lastGeneratedColumn = 0;
	          // The remaining code is added without mapping
	        } else {
	          // There is no new line in between.
	          // Associate the code between "lastGeneratedColumn" and
	          // "mapping.generatedColumn" with "lastMapping"
	          var nextLine = remainingLines[remainingLinesIndex] || '';
	          var code = nextLine.substr(0, mapping.generatedColumn -
	                                        lastGeneratedColumn);
	          remainingLines[remainingLinesIndex] = nextLine.substr(mapping.generatedColumn -
	                                              lastGeneratedColumn);
	          lastGeneratedColumn = mapping.generatedColumn;
	          addMappingWithCode(lastMapping, code);
	          // No more remaining code, continue
	          lastMapping = mapping;
	          return;
	        }
	      }
	      // We add the generated code until the first mapping
	      // to the SourceNode without any mapping.
	      // Each line is added as separate string.
	      while (lastGeneratedLine < mapping.generatedLine) {
	        node.add(shiftNextLine());
	        lastGeneratedLine++;
	      }
	      if (lastGeneratedColumn < mapping.generatedColumn) {
	        var nextLine = remainingLines[remainingLinesIndex] || '';
	        node.add(nextLine.substr(0, mapping.generatedColumn));
	        remainingLines[remainingLinesIndex] = nextLine.substr(mapping.generatedColumn);
	        lastGeneratedColumn = mapping.generatedColumn;
	      }
	      lastMapping = mapping;
	    }, this);
	    // We have processed all mappings.
	    if (remainingLinesIndex < remainingLines.length) {
	      if (lastMapping) {
	        // Associate the remaining code in the current line with "lastMapping"
	        addMappingWithCode(lastMapping, shiftNextLine());
	      }
	      // and add the remaining lines without any mapping
	      node.add(remainingLines.splice(remainingLinesIndex).join(""));
	    }

	    // Copy sourcesContent into SourceNode
	    aSourceMapConsumer.sources.forEach(function (sourceFile) {
	      var content = aSourceMapConsumer.sourceContentFor(sourceFile);
	      if (content != null) {
	        if (aRelativePath != null) {
	          sourceFile = util.join(aRelativePath, sourceFile);
	        }
	        node.setSourceContent(sourceFile, content);
	      }
	    });

	    return node;

	    function addMappingWithCode(mapping, code) {
	      if (mapping === null || mapping.source === undefined) {
	        node.add(code);
	      } else {
	        var source = aRelativePath
	          ? util.join(aRelativePath, mapping.source)
	          : mapping.source;
	        node.add(new SourceNode(mapping.originalLine,
	                                mapping.originalColumn,
	                                source,
	                                code,
	                                mapping.name));
	      }
	    }
	  };

	/**
	 * Add a chunk of generated JS to this source node.
	 *
	 * @param aChunk A string snippet of generated JS code, another instance of
	 *        SourceNode, or an array where each member is one of those things.
	 */
	SourceNode.prototype.add = function SourceNode_add(aChunk) {
	  if (Array.isArray(aChunk)) {
	    aChunk.forEach(function (chunk) {
	      this.add(chunk);
	    }, this);
	  }
	  else if (aChunk[isSourceNode] || typeof aChunk === "string") {
	    if (aChunk) {
	      this.children.push(aChunk);
	    }
	  }
	  else {
	    throw new TypeError(
	      "Expected a SourceNode, string, or an array of SourceNodes and strings. Got " + aChunk
	    );
	  }
	  return this;
	};

	/**
	 * Add a chunk of generated JS to the beginning of this source node.
	 *
	 * @param aChunk A string snippet of generated JS code, another instance of
	 *        SourceNode, or an array where each member is one of those things.
	 */
	SourceNode.prototype.prepend = function SourceNode_prepend(aChunk) {
	  if (Array.isArray(aChunk)) {
	    for (var i = aChunk.length-1; i >= 0; i--) {
	      this.prepend(aChunk[i]);
	    }
	  }
	  else if (aChunk[isSourceNode] || typeof aChunk === "string") {
	    this.children.unshift(aChunk);
	  }
	  else {
	    throw new TypeError(
	      "Expected a SourceNode, string, or an array of SourceNodes and strings. Got " + aChunk
	    );
	  }
	  return this;
	};

	/**
	 * Walk over the tree of JS snippets in this node and its children. The
	 * walking function is called once for each snippet of JS and is passed that
	 * snippet and the its original associated source's line/column location.
	 *
	 * @param aFn The traversal function.
	 */
	SourceNode.prototype.walk = function SourceNode_walk(aFn) {
	  var chunk;
	  for (var i = 0, len = this.children.length; i < len; i++) {
	    chunk = this.children[i];
	    if (chunk[isSourceNode]) {
	      chunk.walk(aFn);
	    }
	    else {
	      if (chunk !== '') {
	        aFn(chunk, { source: this.source,
	                     line: this.line,
	                     column: this.column,
	                     name: this.name });
	      }
	    }
	  }
	};

	/**
	 * Like `String.prototype.join` except for SourceNodes. Inserts `aStr` between
	 * each of `this.children`.
	 *
	 * @param aSep The separator.
	 */
	SourceNode.prototype.join = function SourceNode_join(aSep) {
	  var newChildren;
	  var i;
	  var len = this.children.length;
	  if (len > 0) {
	    newChildren = [];
	    for (i = 0; i < len-1; i++) {
	      newChildren.push(this.children[i]);
	      newChildren.push(aSep);
	    }
	    newChildren.push(this.children[i]);
	    this.children = newChildren;
	  }
	  return this;
	};

	/**
	 * Call String.prototype.replace on the very right-most source snippet. Useful
	 * for trimming whitespace from the end of a source node, etc.
	 *
	 * @param aPattern The pattern to replace.
	 * @param aReplacement The thing to replace the pattern with.
	 */
	SourceNode.prototype.replaceRight = function SourceNode_replaceRight(aPattern, aReplacement) {
	  var lastChild = this.children[this.children.length - 1];
	  if (lastChild[isSourceNode]) {
	    lastChild.replaceRight(aPattern, aReplacement);
	  }
	  else if (typeof lastChild === 'string') {
	    this.children[this.children.length - 1] = lastChild.replace(aPattern, aReplacement);
	  }
	  else {
	    this.children.push(''.replace(aPattern, aReplacement));
	  }
	  return this;
	};

	/**
	 * Set the source content for a source file. This will be added to the SourceMapGenerator
	 * in the sourcesContent field.
	 *
	 * @param aSourceFile The filename of the source file
	 * @param aSourceContent The content of the source file
	 */
	SourceNode.prototype.setSourceContent =
	  function SourceNode_setSourceContent(aSourceFile, aSourceContent) {
	    this.sourceContents[util.toSetString(aSourceFile)] = aSourceContent;
	  };

	/**
	 * Walk over the tree of SourceNodes. The walking function is called for each
	 * source file content and is passed the filename and source content.
	 *
	 * @param aFn The traversal function.
	 */
	SourceNode.prototype.walkSourceContents =
	  function SourceNode_walkSourceContents(aFn) {
	    for (var i = 0, len = this.children.length; i < len; i++) {
	      if (this.children[i][isSourceNode]) {
	        this.children[i].walkSourceContents(aFn);
	      }
	    }

	    var sources = Object.keys(this.sourceContents);
	    for (var i = 0, len = sources.length; i < len; i++) {
	      aFn(util.fromSetString(sources[i]), this.sourceContents[sources[i]]);
	    }
	  };

	/**
	 * Return the string representation of this source node. Walks over the tree
	 * and concatenates all the various snippets together to one string.
	 */
	SourceNode.prototype.toString = function SourceNode_toString() {
	  var str = "";
	  this.walk(function (chunk) {
	    str += chunk;
	  });
	  return str;
	};

	/**
	 * Returns the string representation of this source node along with a source
	 * map.
	 */
	SourceNode.prototype.toStringWithSourceMap = function SourceNode_toStringWithSourceMap(aArgs) {
	  var generated = {
	    code: "",
	    line: 1,
	    column: 0
	  };
	  var map = new SourceMapGenerator(aArgs);
	  var sourceMappingActive = false;
	  var lastOriginalSource = null;
	  var lastOriginalLine = null;
	  var lastOriginalColumn = null;
	  var lastOriginalName = null;
	  this.walk(function (chunk, original) {
	    generated.code += chunk;
	    if (original.source !== null
	        && original.line !== null
	        && original.column !== null) {
	      if(lastOriginalSource !== original.source
	         || lastOriginalLine !== original.line
	         || lastOriginalColumn !== original.column
	         || lastOriginalName !== original.name) {
	        map.addMapping({
	          source: original.source,
	          original: {
	            line: original.line,
	            column: original.column
	          },
	          generated: {
	            line: generated.line,
	            column: generated.column
	          },
	          name: original.name
	        });
	      }
	      lastOriginalSource = original.source;
	      lastOriginalLine = original.line;
	      lastOriginalColumn = original.column;
	      lastOriginalName = original.name;
	      sourceMappingActive = true;
	    } else if (sourceMappingActive) {
	      map.addMapping({
	        generated: {
	          line: generated.line,
	          column: generated.column
	        }
	      });
	      lastOriginalSource = null;
	      sourceMappingActive = false;
	    }
	    for (var idx = 0, length = chunk.length; idx < length; idx++) {
	      if (chunk.charCodeAt(idx) === NEWLINE_CODE) {
	        generated.line++;
	        generated.column = 0;
	        // Mappings end at eol
	        if (idx + 1 === length) {
	          lastOriginalSource = null;
	          sourceMappingActive = false;
	        } else if (sourceMappingActive) {
	          map.addMapping({
	            source: original.source,
	            original: {
	              line: original.line,
	              column: original.column
	            },
	            generated: {
	              line: generated.line,
	              column: generated.column
	            },
	            name: original.name
	          });
	        }
	      } else {
	        generated.column++;
	      }
	    }
	  });
	  this.walkSourceContents(function (sourceFile, sourceContent) {
	    map.setSourceContent(sourceFile, sourceContent);
	  });

	  return { code: generated.code, map: map };
	};

	sourceNode.SourceNode = SourceNode;
	return sourceNode;
}

/*
 * Copyright 2009-2011 Mozilla Foundation and contributors
 * Licensed under the New BSD license. See LICENSE.txt or:
 * http://opensource.org/licenses/BSD-3-Clause
 */

var hasRequiredSourceMap$2;

function requireSourceMap$2 () {
	if (hasRequiredSourceMap$2) return sourceMap$2;
	hasRequiredSourceMap$2 = 1;
	sourceMap$2.SourceMapGenerator = requireSourceMapGenerator().SourceMapGenerator;
	sourceMap$2.SourceMapConsumer = requireSourceMapConsumer().SourceMapConsumer;
	sourceMap$2.SourceNode = requireSourceNode().SourceNode;
	return sourceMap$2;
}

var SourceMapConsumer = requireSourceMap$2().SourceMapConsumer;

function inputSourceMapTracker$1() {
  var maps = {};

  return {
    all: all$2.bind(null, maps),
    isTracking: isTracking.bind(null, maps),
    originalPositionFor: originalPositionFor.bind(null, maps),
    track: track$2.bind(null, maps)
  };
}

function all$2(maps) {
  return maps;
}

function isTracking(maps, source) {
  return source in maps;
}

function originalPositionFor(maps, metadata, range, selectorFallbacks) {
  var line = metadata[0];
  var column = metadata[1];
  var source = metadata[2];
  var position = {
    line: line,
    column: column + range
  };
  var originalPosition;

  while (!originalPosition && position.column > column) {
    position.column--;
    originalPosition = maps[source].originalPositionFor(position);
  }

  if (!originalPosition || originalPosition.column < 0) {
    return metadata;
  }

  if (originalPosition.line === null && line > 1 && selectorFallbacks > 0) {
    return originalPositionFor(maps, [line - 1, column, source], range, selectorFallbacks - 1);
  }

  return originalPosition.line !== null
    ? toMetadata(originalPosition)
    : metadata;
}

function toMetadata(asHash) {
  return [asHash.line, asHash.column, asHash.source];
}

function track$2(maps, source, data) {
  maps[source] = new SourceMapConsumer(data);
}

var inputSourceMapTracker_1 = inputSourceMapTracker$1;

var REMOTE_RESOURCE_PATTERN = /^(\w+:\/\/|\/\/)/;
var FILE_RESOURCE_PATTERN = /^file:\/\//;

function isRemoteResource$5(uri) {
  return REMOTE_RESOURCE_PATTERN.test(uri) && !FILE_RESOURCE_PATTERN.test(uri);
}

var isRemoteResource_1 = isRemoteResource$5;

var NO_PROTOCOL_RESOURCE_PATTERN = /^\/\//;

function hasProtocol$4(uri) {
  return !NO_PROTOCOL_RESOURCE_PATTERN.test(uri);
}

var hasProtocol_1 = hasProtocol$4;

var path$f = path__default["default"];
var url$4 = require$$1__default["default"];

var isRemoteResource$4 = isRemoteResource_1;
var hasProtocol$3 = hasProtocol_1;

var HTTP_PROTOCOL = 'http:';

function isAllowedResource$3(uri, isRemote, rules) {
  var match;
  var absoluteUri;
  var allowed = !isRemote;
  var rule;
  var isNegated;
  var normalizedRule;
  var i;

  if (rules.length === 0) {
    return false;
  }

  if (isRemote && !hasProtocol$3(uri)) {
    uri = HTTP_PROTOCOL + uri;
  }

  match = isRemote
    ? url$4.parse(uri).host
    : uri;

  absoluteUri = isRemote
    ? uri
    : path$f.resolve(uri);

  for (i = 0; i < rules.length; i++) {
    rule = rules[i];
    isNegated = rule[0] == '!';
    normalizedRule = rule.substring(1);

    if (isNegated && isRemote && isRemoteRule(normalizedRule)) {
      allowed = allowed && !isAllowedResource$3(uri, true, [normalizedRule]);
    } else if (isNegated && !isRemote && !isRemoteRule(normalizedRule)) {
      allowed = allowed && !isAllowedResource$3(uri, false, [normalizedRule]);
    } else if (isNegated) {
      allowed = allowed && true;
    } else if (rule == 'all') {
      allowed = true;
    } else if (isRemote && rule == 'local') {
      allowed = allowed || false;
    } else if (isRemote && rule == 'remote') {
      allowed = true;
    } else if (!isRemote && rule == 'remote') {
      allowed = false;
    } else if (!isRemote && rule == 'local') {
      allowed = true;
    } else if (rule === match) {
      allowed = true;
    } else if (rule === uri) {
      allowed = true;
    } else if (isRemote && absoluteUri.indexOf(rule) === 0) {
      allowed = true;
    } else if (!isRemote && absoluteUri.indexOf(path$f.resolve(rule)) === 0) {
      allowed = true;
    } else if (isRemote != isRemoteRule(normalizedRule)) {
      allowed = allowed && true;
    } else {
      allowed = false;
    }
  }

  return allowed;
}

function isRemoteRule(rule) {
  return isRemoteResource$4(rule) || url$4.parse(HTTP_PROTOCOL + '//' + rule).host == rule;
}

var isAllowedResource_1 = isAllowedResource$3;

var DATA_URI_PATTERN$1 = /^data:(\S*?)?(;charset=(?:(?!;charset=)[^;])+)?(;[^,]+?)?,(.+)/;

function matchDataUri$1(uri) {
  return DATA_URI_PATTERN$1.exec(uri);
}

var matchDataUri_1 = matchDataUri$1;

var path$e = path__default["default"];

function rebaseLocalMap$2(sourceMap, sourceUri, rebaseTo) {
  var currentPath = path$e.resolve('');
  var absoluteUri = path$e.resolve(currentPath, sourceUri);
  var absoluteUriDirectory = path$e.dirname(absoluteUri);

  sourceMap.sources = sourceMap.sources.map(function(source) {
    return path$e.relative(rebaseTo, path$e.resolve(absoluteUriDirectory, source));
  });

  return sourceMap;
}

var rebaseLocalMap_1 = rebaseLocalMap$2;

var path$d = path__default["default"];
var url$3 = require$$1__default["default"];

function rebaseRemoteMap$2(sourceMap, sourceUri) {
  var sourceDirectory = path$d.dirname(sourceUri);

  sourceMap.sources = sourceMap.sources.map(function(source) {
    return url$3.resolve(sourceDirectory, source);
  });

  return sourceMap;
}

var rebaseRemoteMap_1 = rebaseRemoteMap$2;

var DATA_URI_PATTERN = /^data:(\S{0,31}?)?(;charset=(?:(?!;charset=)[^;])+)?(;[^,]+?)?,(.+)/;

function isDataUriResource$2(uri) {
  return DATA_URI_PATTERN.test(uri);
}

var isDataUriResource_1 = isDataUriResource$2;

var fs$a = require$$0__default["default"];
var path$c = path__default["default"];

var isAllowedResource$2 = isAllowedResource_1;
var matchDataUri = matchDataUri_1;
var rebaseLocalMap$1 = rebaseLocalMap_1;
var rebaseRemoteMap$1 = rebaseRemoteMap_1;

var Token$3 = token;
var hasProtocol$2 = hasProtocol_1;
var isDataUriResource$1 = isDataUriResource_1;
var isRemoteResource$3 = isRemoteResource_1;

var MAP_MARKER_PATTERN = /^\/\*# sourceMappingURL=(\S+) \*\/$/;

function applySourceMaps$1(tokens, context, callback) {
  var applyContext = {
    callback: callback,
    fetch: context.options.fetch,
    index: 0,
    inline: context.options.inline,
    inlineRequest: context.options.inlineRequest,
    inlineTimeout: context.options.inlineTimeout,
    inputSourceMapTracker: context.inputSourceMapTracker,
    localOnly: context.localOnly,
    processedTokens: [],
    rebaseTo: context.options.rebaseTo,
    sourceTokens: tokens,
    warnings: context.warnings
  };

  return context.options.sourceMap && tokens.length > 0
    ? doApplySourceMaps(applyContext)
    : callback(tokens);
}

function doApplySourceMaps(applyContext) {
  var singleSourceTokens = [];
  var lastSource = findTokenSource(applyContext.sourceTokens[0]);
  var source;
  var token;
  var l;

  for (l = applyContext.sourceTokens.length; applyContext.index < l; applyContext.index++) {
    token = applyContext.sourceTokens[applyContext.index];
    source = findTokenSource(token);

    if (source != lastSource) {
      singleSourceTokens = [];
      lastSource = source;
    }

    singleSourceTokens.push(token);
    applyContext.processedTokens.push(token);

    if (token[0] == Token$3.COMMENT && MAP_MARKER_PATTERN.test(token[1])) {
      return fetchAndApplySourceMap(token[1], source, singleSourceTokens, applyContext);
    }
  }

  return applyContext.callback(applyContext.processedTokens);
}

function findTokenSource(token) {
  var scope;
  var metadata;

  if (token[0] == Token$3.AT_RULE || token[0] == Token$3.COMMENT || token[0] == Token$3.RAW) {
    metadata = token[2][0];
  } else {
    scope = token[1][0];
    metadata = scope[2][0];
  }

  return metadata[2];
}

function fetchAndApplySourceMap(sourceMapComment, source, singleSourceTokens, applyContext) {
  return extractInputSourceMapFrom(sourceMapComment, applyContext, function(inputSourceMap) {
    if (inputSourceMap) {
      applyContext.inputSourceMapTracker.track(source, inputSourceMap);
      applySourceMapRecursively(singleSourceTokens, applyContext.inputSourceMapTracker);
    }

    applyContext.index++;
    return doApplySourceMaps(applyContext);
  });
}

function extractInputSourceMapFrom(sourceMapComment, applyContext, whenSourceMapReady) {
  var uri = MAP_MARKER_PATTERN.exec(sourceMapComment)[1];
  var absoluteUri;
  var sourceMap;
  var rebasedMap;

  if (isDataUriResource$1(uri)) {
    sourceMap = extractInputSourceMapFromDataUri(uri);
    return whenSourceMapReady(sourceMap);
  } if (isRemoteResource$3(uri)) {
    return loadInputSourceMapFromRemoteUri(uri, applyContext, function(sourceMap) {
      var parsedMap;

      if (sourceMap) {
        parsedMap = JSON.parse(sourceMap);
        rebasedMap = rebaseRemoteMap$1(parsedMap, uri);
        whenSourceMapReady(rebasedMap);
      } else {
        whenSourceMapReady(null);
      }
    });
  }
  // at this point `uri` is already rebased, see lib/reader/rebase.js#rebaseSourceMapComment
  // it is rebased to be consistent with rebasing other URIs
  // however here we need to resolve it back to read it from disk
  absoluteUri = path$c.resolve(applyContext.rebaseTo, uri);
  sourceMap = loadInputSourceMapFromLocalUri(absoluteUri, applyContext);

  if (sourceMap) {
    rebasedMap = rebaseLocalMap$1(sourceMap, absoluteUri, applyContext.rebaseTo);
    return whenSourceMapReady(rebasedMap);
  }
  return whenSourceMapReady(null);
}

function extractInputSourceMapFromDataUri(uri) {
  var dataUriMatch = matchDataUri(uri);
  var charset = dataUriMatch[2] ? dataUriMatch[2].split(/[=;]/)[2] : 'us-ascii';
  var encoding = dataUriMatch[3] ? dataUriMatch[3].split(';')[1] : 'utf8';
  var data = encoding == 'utf8' ? commonjsGlobal.unescape(dataUriMatch[4]) : dataUriMatch[4];

  var buffer = Buffer.from(data, encoding);
  buffer.charset = charset;

  return JSON.parse(buffer.toString());
}

function loadInputSourceMapFromRemoteUri(uri, applyContext, whenLoaded) {
  var isAllowed = isAllowedResource$2(uri, true, applyContext.inline);
  var isRuntimeResource = !hasProtocol$2(uri);

  if (applyContext.localOnly) {
    applyContext.warnings.push('Cannot fetch remote resource from "' + uri + '" as no callback given.');
    return whenLoaded(null);
  } if (isRuntimeResource) {
    applyContext.warnings.push('Cannot fetch "' + uri + '" as no protocol given.');
    return whenLoaded(null);
  } if (!isAllowed) {
    applyContext.warnings.push('Cannot fetch "' + uri + '" as resource is not allowed.');
    return whenLoaded(null);
  }

  applyContext.fetch(uri, applyContext.inlineRequest, applyContext.inlineTimeout, function(error, body) {
    if (error) {
      applyContext.warnings.push('Missing source map at "' + uri + '" - ' + error);
      return whenLoaded(null);
    }

    whenLoaded(body);
  });
}

function loadInputSourceMapFromLocalUri(uri, applyContext) {
  var isAllowed = isAllowedResource$2(uri, false, applyContext.inline);
  var sourceMap;

  if (!fs$a.existsSync(uri) || !fs$a.statSync(uri).isFile()) {
    applyContext.warnings.push('Ignoring local source map at "' + uri + '" as resource is missing.');
    return null;
  } if (!isAllowed) {
    applyContext.warnings.push('Cannot fetch "' + uri + '" as resource is not allowed.');
    return null;
  } if (!fs$a.statSync(uri).size) {
    applyContext.warnings.push('Cannot fetch "' + uri + '" as resource is empty.');
    return null;
  }

  sourceMap = fs$a.readFileSync(uri, 'utf-8');
  return JSON.parse(sourceMap);
}

function applySourceMapRecursively(tokens, inputSourceMapTracker) {
  var token;
  var i, l;

  for (i = 0, l = tokens.length; i < l; i++) {
    token = tokens[i];

    switch (token[0]) {
    case Token$3.AT_RULE:
      applySourceMapTo(token, inputSourceMapTracker);
      break;
    case Token$3.AT_RULE_BLOCK:
      applySourceMapRecursively(token[1], inputSourceMapTracker);
      applySourceMapRecursively(token[2], inputSourceMapTracker);
      break;
    case Token$3.AT_RULE_BLOCK_SCOPE:
      applySourceMapTo(token, inputSourceMapTracker);
      break;
    case Token$3.NESTED_BLOCK:
      applySourceMapRecursively(token[1], inputSourceMapTracker);
      applySourceMapRecursively(token[2], inputSourceMapTracker);
      break;
    case Token$3.NESTED_BLOCK_SCOPE:
      applySourceMapTo(token, inputSourceMapTracker);
      break;
    case Token$3.COMMENT:
      applySourceMapTo(token, inputSourceMapTracker);
      break;
    case Token$3.PROPERTY:
      applySourceMapRecursively(token, inputSourceMapTracker);
      break;
    case Token$3.PROPERTY_BLOCK:
      applySourceMapRecursively(token[1], inputSourceMapTracker);
      break;
    case Token$3.PROPERTY_NAME:
      applySourceMapTo(token, inputSourceMapTracker);
      break;
    case Token$3.PROPERTY_VALUE:
      applySourceMapTo(token, inputSourceMapTracker);
      break;
    case Token$3.RULE:
      applySourceMapRecursively(token[1], inputSourceMapTracker);
      applySourceMapRecursively(token[2], inputSourceMapTracker);
      break;
    case Token$3.RULE_SCOPE:
      applySourceMapTo(token, inputSourceMapTracker);
    }
  }

  return tokens;
}

function applySourceMapTo(token, inputSourceMapTracker) {
  var value = token[1];
  var metadata = token[2];
  var newMetadata = [];
  var i, l;

  for (i = 0, l = metadata.length; i < l; i++) {
    newMetadata.push(inputSourceMapTracker.originalPositionFor(metadata[i], value.length));
  }

  token[2] = newMetadata;
}

var applySourceMaps_1 = applySourceMaps$1;

var split = split_1;

var BRACE_PREFIX = /^\(/;
var BRACE_SUFFIX = /\)$/;
var IMPORT_PREFIX_PATTERN$1 = /^@import/i;
var QUOTE_PREFIX_PATTERN$1 = /['"]\s{0,31}/;
var QUOTE_SUFFIX_PATTERN$1 = /\s{0,31}['"]/;
var URL_PREFIX_PATTERN$1 = /^url\(\s{0,31}/i;
var URL_SUFFIX_PATTERN$1 = /\s{0,31}\)/i;

function extractImportUrlAndMedia$2(atRuleValue) {
  var uri;
  var mediaQuery;
  var normalized;
  var parts;

  normalized = atRuleValue
    .replace(IMPORT_PREFIX_PATTERN$1, '')
    .trim()
    .replace(URL_PREFIX_PATTERN$1, '(')
    .replace(URL_SUFFIX_PATTERN$1, ') ')
    .replace(QUOTE_PREFIX_PATTERN$1, '')
    .replace(QUOTE_SUFFIX_PATTERN$1, '');

  parts = split(normalized, ' ');

  uri = parts[0]
    .replace(BRACE_PREFIX, '')
    .replace(BRACE_SUFFIX, '');
  mediaQuery = parts.slice(1).join(' ');

  return [uri, mediaQuery];
}

var extractImportUrlAndMedia_1 = extractImportUrlAndMedia$2;

var fs$9 = require$$0__default["default"];
var path$b = path__default["default"];

var isAllowedResource$1 = isAllowedResource_1;

var hasProtocol$1 = hasProtocol_1;
var isRemoteResource$2 = isRemoteResource_1;

function loadOriginalSources$1(context, callback) {
  var loadContext = {
    callback: callback,
    fetch: context.options.fetch,
    index: 0,
    inline: context.options.inline,
    inlineRequest: context.options.inlineRequest,
    inlineTimeout: context.options.inlineTimeout,
    localOnly: context.localOnly,
    rebaseTo: context.options.rebaseTo,
    sourcesContent: context.sourcesContent,
    uriToSource: uriToSourceMapping(context.inputSourceMapTracker.all()),
    warnings: context.warnings
  };

  return context.options.sourceMap && context.options.sourceMapInlineSources
    ? doLoadOriginalSources(loadContext)
    : callback();
}

function uriToSourceMapping(allSourceMapConsumers) {
  var mapping = {};
  var consumer;
  var uri;
  var source;
  var i, l;

  for (source in allSourceMapConsumers) {
    consumer = allSourceMapConsumers[source];

    for (i = 0, l = consumer.sources.length; i < l; i++) {
      uri = consumer.sources[i];
      source = consumer.sourceContentFor(uri, true);

      mapping[uri] = source;
    }
  }

  return mapping;
}

function doLoadOriginalSources(loadContext) {
  var uris = Object.keys(loadContext.uriToSource);
  var uri;
  var source;
  var total;

  for (total = uris.length; loadContext.index < total; loadContext.index++) {
    uri = uris[loadContext.index];
    source = loadContext.uriToSource[uri];

    if (source) {
      loadContext.sourcesContent[uri] = source;
    } else {
      return loadOriginalSource(uri, loadContext);
    }
  }

  return loadContext.callback();
}

function loadOriginalSource(uri, loadContext) {
  var content;

  if (isRemoteResource$2(uri)) {
    return loadOriginalSourceFromRemoteUri(uri, loadContext, function(content) {
      loadContext.index++;
      loadContext.sourcesContent[uri] = content;
      return doLoadOriginalSources(loadContext);
    });
  }
  content = loadOriginalSourceFromLocalUri(uri, loadContext);
  loadContext.index++;
  loadContext.sourcesContent[uri] = content;
  return doLoadOriginalSources(loadContext);
}

function loadOriginalSourceFromRemoteUri(uri, loadContext, whenLoaded) {
  var isAllowed = isAllowedResource$1(uri, true, loadContext.inline);
  var isRuntimeResource = !hasProtocol$1(uri);

  if (loadContext.localOnly) {
    loadContext.warnings.push('Cannot fetch remote resource from "' + uri + '" as no callback given.');
    return whenLoaded(null);
  } if (isRuntimeResource) {
    loadContext.warnings.push('Cannot fetch "' + uri + '" as no protocol given.');
    return whenLoaded(null);
  } if (!isAllowed) {
    loadContext.warnings.push('Cannot fetch "' + uri + '" as resource is not allowed.');
    return whenLoaded(null);
  }

  loadContext.fetch(uri, loadContext.inlineRequest, loadContext.inlineTimeout, function(error, content) {
    if (error) {
      loadContext.warnings.push('Missing original source at "' + uri + '" - ' + error);
    }

    whenLoaded(content);
  });
}

function loadOriginalSourceFromLocalUri(relativeUri, loadContext) {
  var isAllowed = isAllowedResource$1(relativeUri, false, loadContext.inline);
  var absoluteUri = path$b.resolve(loadContext.rebaseTo, relativeUri);

  if (!fs$9.existsSync(absoluteUri) || !fs$9.statSync(absoluteUri).isFile()) {
    loadContext.warnings.push('Ignoring local source map at "' + absoluteUri + '" as resource is missing.');
    return null;
  } if (!isAllowed) {
    loadContext.warnings.push('Cannot fetch "' + absoluteUri + '" as resource is not allowed.');
    return null;
  }

  var result = fs$9.readFileSync(absoluteUri, 'utf8');
  if (result.charCodeAt(0) === 65279) {
    result = result.substring(1);
  }
  return result;
}

var loadOriginalSources_1 = loadOriginalSources$1;

var UNIX_SEPARATOR = '/';
var WINDOWS_SEPARATOR_PATTERN = /\\/g;

function normalizePath$3(path) {
  return path.replace(WINDOWS_SEPARATOR_PATTERN, UNIX_SEPARATOR);
}

var normalizePath_1 = normalizePath$3;

function restoreImport$2(uri, mediaQuery) {
  return ('@import ' + uri + ' ' + mediaQuery).trim();
}

var restoreImport_1 = restoreImport$2;

var path$a = path__default["default"];
var url$2 = require$$1__default["default"];

var isDataUriResource = isDataUriResource_1;

var DOUBLE_QUOTE = '"';
var SINGLE_QUOTE = '\'';
var URL_PREFIX = 'url(';
var URL_SUFFIX = ')';

var PROTOCOL_LESS_PREFIX_PATTERN = /^[^\w\d]*\/\//;
var QUOTE_PREFIX_PATTERN = /^["']/;
var QUOTE_SUFFIX_PATTERN = /["']$/;
var ROUND_BRACKETS_PATTERN = /[()]/;
var URL_PREFIX_PATTERN = /^url\(/i;
var URL_SUFFIX_PATTERN = /\)$/;
var WHITESPACE_PATTERN = /\s/;

var isWindows$1 = process.platform == 'win32';

function rebase$2(uri, rebaseConfig) {
  if (!rebaseConfig) {
    return uri;
  }

  if (isAbsolute(uri) && !isRemote(rebaseConfig.toBase)) {
    return uri;
  }

  if (isRemote(uri) || isSVGMarker(uri) || isInternal(uri) || isDataUriResource(uri)) {
    return uri;
  }

  if (isRemote(rebaseConfig.toBase)) {
    return url$2.resolve(rebaseConfig.toBase, uri);
  }

  return rebaseConfig.absolute
    ? normalize(absolute(uri, rebaseConfig))
    : normalize(relative(uri, rebaseConfig));
}

function isAbsolute(uri) {
  return path$a.isAbsolute(uri);
}

function isSVGMarker(uri) {
  return uri[0] == '#';
}

function isInternal(uri) {
  return /^\w+:\w+/.test(uri);
}

function isRemote(uri) {
  return /^[^:]+?:\/\//.test(uri) || PROTOCOL_LESS_PREFIX_PATTERN.test(uri);
}

function absolute(uri, rebaseConfig) {
  return path$a
    .resolve(path$a.join(rebaseConfig.fromBase || '', uri))
    .replace(rebaseConfig.toBase, '');
}

function relative(uri, rebaseConfig) {
  return path$a.relative(rebaseConfig.toBase, path$a.join(rebaseConfig.fromBase || '', uri));
}

function normalize(uri) {
  return isWindows$1 ? uri.replace(/\\/g, '/') : uri;
}

function quoteFor(unquotedUrl) {
  if (unquotedUrl.indexOf(SINGLE_QUOTE) > -1) {
    return DOUBLE_QUOTE;
  } if (unquotedUrl.indexOf(DOUBLE_QUOTE) > -1) {
    return SINGLE_QUOTE;
  } if (hasWhitespace(unquotedUrl) || hasRoundBrackets(unquotedUrl)) {
    return SINGLE_QUOTE;
  }
  return '';
}

function hasWhitespace(url) {
  return WHITESPACE_PATTERN.test(url);
}

function hasRoundBrackets(url) {
  return ROUND_BRACKETS_PATTERN.test(url);
}

function rewriteUrl$1(originalUrl, rebaseConfig, pathOnly) {
  var strippedUrl = originalUrl
    .replace(URL_PREFIX_PATTERN, '')
    .replace(URL_SUFFIX_PATTERN, '')
    .trim();

  var unquotedUrl = strippedUrl
    .replace(QUOTE_PREFIX_PATTERN, '')
    .replace(QUOTE_SUFFIX_PATTERN, '')
    .trim();

  var quote = strippedUrl[0] == SINGLE_QUOTE || strippedUrl[0] == DOUBLE_QUOTE
    ? strippedUrl[0]
    : quoteFor(unquotedUrl);

  return pathOnly
    ? rebase$2(unquotedUrl, rebaseConfig)
    : URL_PREFIX + quote + rebase$2(unquotedUrl, rebaseConfig) + quote + URL_SUFFIX;
}

var rewriteUrl_1 = rewriteUrl$1;

var IMPORT_PREFIX_PATTERN = /^@import/i;

function isImport$2(value) {
  return IMPORT_PREFIX_PATTERN.test(value);
}

var isImport_1 = isImport$2;

var extractImportUrlAndMedia$1 = extractImportUrlAndMedia_1;
var restoreImport$1 = restoreImport_1;
var rewriteUrl = rewriteUrl_1;

var Token$2 = token;
var isImport$1 = isImport_1;

var SOURCE_MAP_COMMENT_PATTERN = /^\/\*# sourceMappingURL=(\S+) \*\/$/;

function rebase$1(tokens, rebaseAll, validator, rebaseConfig) {
  return rebaseAll
    ? rebaseEverything(tokens, validator, rebaseConfig)
    : rebaseAtRules(tokens, validator, rebaseConfig);
}

function rebaseEverything(tokens, validator, rebaseConfig) {
  var token;
  var i, l;

  for (i = 0, l = tokens.length; i < l; i++) {
    token = tokens[i];

    switch (token[0]) {
    case Token$2.AT_RULE:
      rebaseAtRule(token, validator, rebaseConfig);
      break;
    case Token$2.AT_RULE_BLOCK:
      rebaseProperties(token[2], validator, rebaseConfig);
      break;
    case Token$2.COMMENT:
      rebaseSourceMapComment(token, rebaseConfig);
      break;
    case Token$2.NESTED_BLOCK:
      rebaseEverything(token[2], validator, rebaseConfig);
      break;
    case Token$2.RULE:
      rebaseProperties(token[2], validator, rebaseConfig);
      break;
    }
  }

  return tokens;
}

function rebaseAtRules(tokens, validator, rebaseConfig) {
  var token;
  var i, l;

  for (i = 0, l = tokens.length; i < l; i++) {
    token = tokens[i];

    switch (token[0]) {
    case Token$2.AT_RULE:
      rebaseAtRule(token, validator, rebaseConfig);
      break;
    }
  }

  return tokens;
}

function rebaseAtRule(token, validator, rebaseConfig) {
  if (!isImport$1(token[1])) {
    return;
  }

  var uriAndMediaQuery = extractImportUrlAndMedia$1(token[1]);
  var newUrl = rewriteUrl(uriAndMediaQuery[0], rebaseConfig);
  var mediaQuery = uriAndMediaQuery[1];

  token[1] = restoreImport$1(newUrl, mediaQuery);
}

function rebaseSourceMapComment(token, rebaseConfig) {
  var matches = SOURCE_MAP_COMMENT_PATTERN.exec(token[1]);

  if (matches && matches[1].indexOf('data:') === -1) {
    token[1] = token[1].replace(matches[1], rewriteUrl(matches[1], rebaseConfig, true));
  }
}

function rebaseProperties(properties, validator, rebaseConfig) {
  var property;
  var value;
  var i, l;
  var j, m;

  for (i = 0, l = properties.length; i < l; i++) {
    property = properties[i];

    for (j = 2 /* 0 is Token.PROPERTY, 1 is name */, m = property.length; j < m; j++) {
      value = property[j][1];

      if (validator.isUrl(value)) {
        property[j][1] = rewriteUrl(value, rebaseConfig);
      }
    }
  }
}

var rebase_1 = rebase$1;

var Marker$1 = marker;
var Token$1 = token;

var formatPosition = formatPosition_1;

var Level = {
  BLOCK: 'block',
  COMMENT: 'comment',
  DOUBLE_QUOTE: 'double-quote',
  RULE: 'rule',
  SINGLE_QUOTE: 'single-quote'
};

var AT_RULES = [
  '@charset',
  '@import'
];

var BLOCK_RULES = [
  '@-moz-document',
  '@document',
  '@-moz-keyframes',
  '@-ms-keyframes',
  '@-o-keyframes',
  '@-webkit-keyframes',
  '@keyframes',
  '@media',
  '@supports',
  '@container',
  '@layer'
];

var IGNORE_END_COMMENT_PATTERN = /\/\* clean-css ignore:end \*\/$/;
var IGNORE_START_COMMENT_PATTERN = /^\/\* clean-css ignore:start \*\//;

var PAGE_MARGIN_BOXES = [
  '@bottom-center',
  '@bottom-left',
  '@bottom-left-corner',
  '@bottom-right',
  '@bottom-right-corner',
  '@left-bottom',
  '@left-middle',
  '@left-top',
  '@right-bottom',
  '@right-middle',
  '@right-top',
  '@top-center',
  '@top-left',
  '@top-left-corner',
  '@top-right',
  '@top-right-corner'
];

var EXTRA_PAGE_BOXES = [
  '@footnote',
  '@footnotes',
  '@left',
  '@page-float-bottom',
  '@page-float-top',
  '@right'
];

var REPEAT_PATTERN = /^\[\s{0,31}\d+\s{0,31}\]$/;
var TAIL_BROKEN_VALUE_PATTERN = /([^}])\}*$/;
var RULE_WORD_SEPARATOR_PATTERN = /[\s(]/;

function tokenize$1(source, externalContext) {
  var internalContext = {
    level: Level.BLOCK,
    position: {
      source: externalContext.source || undefined,
      line: 1,
      column: 0,
      index: 0
    }
  };

  return intoTokens(source, externalContext, internalContext, false);
}

function intoTokens(source, externalContext, internalContext, isNested) {
  var allTokens = [];
  var newTokens = allTokens;
  var lastToken;
  var ruleToken;
  var ruleTokens = [];
  var propertyToken;
  var metadata;
  var metadatas = [];
  var level = internalContext.level;
  var levels = [];
  var buffer = [];
  var buffers = [];
  var isBufferEmpty = true;
  var serializedBuffer;
  var serializedBufferPart;
  var roundBracketLevel = 0;
  var isQuoted;
  var isSpace;
  var isNewLineNix;
  var isNewLineWin;
  var isCarriageReturn;
  var isCommentStart;
  var wasCommentStart = false;
  var isCommentEnd;
  var wasCommentEnd = false;
  var isCommentEndMarker;
  var isEscaped;
  var wasEscaped = false;
  var characterWithNoSpecialMeaning;
  var isPreviousDash = false;
  var isVariable = false;
  var isRaw = false;
  var seekingValue = false;
  var seekingPropertyBlockClosing = false;
  var position = internalContext.position;
  var lastCommentStartAt;

  for (; position.index < source.length; position.index++) {
    var character = source[position.index];

    isQuoted = level == Level.SINGLE_QUOTE || level == Level.DOUBLE_QUOTE;
    isSpace = character == Marker$1.SPACE || character == Marker$1.TAB;
    isNewLineNix = character == Marker$1.NEW_LINE_NIX;
    isNewLineWin = character == Marker$1.NEW_LINE_NIX
      && source[position.index - 1] == Marker$1.CARRIAGE_RETURN;
    isCarriageReturn = character == Marker$1.CARRIAGE_RETURN
      && source[position.index + 1] && source[position.index + 1] != Marker$1.NEW_LINE_NIX;
    isCommentStart = !wasCommentEnd
      && level != Level.COMMENT && !isQuoted
      && character == Marker$1.ASTERISK && source[position.index - 1] == Marker$1.FORWARD_SLASH;
    isCommentEndMarker = !wasCommentStart
      && !isQuoted && character == Marker$1.FORWARD_SLASH
      && source[position.index - 1] == Marker$1.ASTERISK;
    isCommentEnd = level == Level.COMMENT && isCommentEndMarker;
    characterWithNoSpecialMeaning = !isSpace && !isCarriageReturn && (character >= 'A' && character <= 'Z' || character >= 'a' && character <= 'z' || character >= '0' && character <= '9' || character == '-');
    isVariable = isVariable || (level != Level.COMMENT && !seekingValue && isPreviousDash && character === '-' && buffer.length === 1);
    isPreviousDash = character === '-';
    roundBracketLevel = Math.max(roundBracketLevel, 0);

    metadata = isBufferEmpty
      ? [position.line, position.column, position.source]
      : metadata;

    if (isEscaped) {
      // previous character was a backslash
      buffer.push(character);
      isBufferEmpty = false;
    } else if (characterWithNoSpecialMeaning) {
      // it's just an alphanumeric character or a hyphen (part of any rule or property name) so let's end it quickly
      buffer.push(character);
      isBufferEmpty = false;
    } else if ((isSpace || isNewLineNix && !isNewLineWin) && (isQuoted || level == Level.COMMENT)) {
      buffer.push(character);
      isBufferEmpty = false;
    } else if ((isSpace || isNewLineNix && !isNewLineWin) && isBufferEmpty) ; else if (!isCommentEnd && level == Level.COMMENT) {
      buffer.push(character);
      isBufferEmpty = false;
    } else if (!isCommentStart && !isCommentEnd && isRaw) {
      buffer.push(character);
      isBufferEmpty = false;
    } else if (isCommentStart
        && isVariable
        && (level == Level.BLOCK || level == Level.RULE) && buffer.length > 1) {
      // comment start within a variable, e.g. var(/*<--
      buffer.push(character);
      isBufferEmpty = false;

      levels.push(level);
      level = Level.COMMENT;
    } else if (isCommentStart && (level == Level.BLOCK || level == Level.RULE) && buffer.length > 1) {
      // comment start within block preceded by some content, e.g. div/*<--
      metadatas.push(metadata);
      buffer.push(character);
      buffers.push(buffer.slice(0, -2));
      isBufferEmpty = false;

      buffer = buffer.slice(-2);
      metadata = [position.line, position.column - 1, position.source];

      levels.push(level);
      level = Level.COMMENT;
    } else if (isCommentStart) {
      // comment start, e.g. /*<--
      levels.push(level);
      level = Level.COMMENT;
      buffer.push(character);
      isBufferEmpty = false;
    } else if (isCommentEnd && isVariable) {
      // comment end within a variable, e.g. var(/*!*/<--
      buffer.push(character);
      level = levels.pop();
    } else if (isCommentEnd && isIgnoreStartComment(buffer)) {
      // ignore:start comment end, e.g. /* clean-css ignore:start */<--
      serializedBuffer = buffer.join('').trim() + character;
      lastToken = [
        Token$1.COMMENT,
        serializedBuffer,
        [originalMetadata(metadata, serializedBuffer, externalContext)]
      ];
      newTokens.push(lastToken);

      isRaw = true;
      metadata = metadatas.pop() || null;
      buffer = buffers.pop() || [];
      isBufferEmpty = buffer.length === 0;
    } else if (isCommentEnd && isIgnoreEndComment(buffer)) {
      // ignore:start comment end, e.g. /* clean-css ignore:end */<--
      serializedBuffer = buffer.join('') + character;
      lastCommentStartAt = serializedBuffer.lastIndexOf(Marker$1.FORWARD_SLASH + Marker$1.ASTERISK);

      serializedBufferPart = serializedBuffer.substring(0, lastCommentStartAt);
      lastToken = [
        Token$1.RAW,
        serializedBufferPart,
        [originalMetadata(metadata, serializedBufferPart, externalContext)]
      ];
      newTokens.push(lastToken);

      serializedBufferPart = serializedBuffer.substring(lastCommentStartAt);
      metadata = [position.line, position.column - serializedBufferPart.length + 1, position.source];
      lastToken = [
        Token$1.COMMENT,
        serializedBufferPart,
        [originalMetadata(metadata, serializedBufferPart, externalContext)]
      ];
      newTokens.push(lastToken);

      isRaw = false;
      level = levels.pop();
      metadata = metadatas.pop() || null;
      buffer = buffers.pop() || [];
      isBufferEmpty = buffer.length === 0;
    } else if (isCommentEnd) {
      // comment end, e.g. /* comment */<--
      serializedBuffer = buffer.join('').trim() + character;
      lastToken = [
        Token$1.COMMENT,
        serializedBuffer,
        [originalMetadata(metadata, serializedBuffer, externalContext)]
      ];
      newTokens.push(lastToken);

      level = levels.pop();
      metadata = metadatas.pop() || null;
      buffer = buffers.pop() || [];
      isBufferEmpty = buffer.length === 0;
    } else if (isCommentEndMarker && source[position.index + 1] != Marker$1.ASTERISK) {
      externalContext.warnings.push('Unexpected \'*/\' at ' + formatPosition([position.line, position.column, position.source]) + '.');
      buffer = [];
      isBufferEmpty = true;
    } else if (character == Marker$1.SINGLE_QUOTE && !isQuoted) {
      // single quotation start, e.g. a[href^='https<--
      levels.push(level);
      level = Level.SINGLE_QUOTE;
      buffer.push(character);
      isBufferEmpty = false;
    } else if (character == Marker$1.SINGLE_QUOTE && level == Level.SINGLE_QUOTE) {
      // single quotation end, e.g. a[href^='https'<--
      level = levels.pop();
      buffer.push(character);
      isBufferEmpty = false;
    } else if (character == Marker$1.DOUBLE_QUOTE && !isQuoted) {
      // double quotation start, e.g. a[href^="<--
      levels.push(level);
      level = Level.DOUBLE_QUOTE;
      buffer.push(character);
      isBufferEmpty = false;
    } else if (character == Marker$1.DOUBLE_QUOTE && level == Level.DOUBLE_QUOTE) {
      // double quotation end, e.g. a[href^="https"<--
      level = levels.pop();
      buffer.push(character);
      isBufferEmpty = false;
    } else if (character != Marker$1.CLOSE_ROUND_BRACKET
      && character != Marker$1.OPEN_ROUND_BRACKET
      && level != Level.COMMENT && !isQuoted && roundBracketLevel > 0) {
      // character inside any function, e.g. hsla(.<--
      buffer.push(character);
      isBufferEmpty = false;
    } else if (character == Marker$1.OPEN_ROUND_BRACKET
      && !isQuoted && level != Level.COMMENT
      && !seekingValue) {
      // round open bracket, e.g. @import url(<--
      buffer.push(character);
      isBufferEmpty = false;

      roundBracketLevel++;
    } else if (character == Marker$1.CLOSE_ROUND_BRACKET
      && !isQuoted
      && level != Level.COMMENT
      && !seekingValue) {
      // round open bracket, e.g. @import url(test.css)<--
      buffer.push(character);
      isBufferEmpty = false;

      roundBracketLevel--;
    } else if (character == Marker$1.SEMICOLON && level == Level.BLOCK && buffer[0] == Marker$1.AT) {
      // semicolon ending rule at block level, e.g. @import '...';<--
      serializedBuffer = buffer.join('').trim();
      allTokens.push([
        Token$1.AT_RULE,
        serializedBuffer,
        [originalMetadata(metadata, serializedBuffer, externalContext)]
      ]);

      buffer = [];
      isBufferEmpty = true;
    } else if (character == Marker$1.COMMA && level == Level.BLOCK && ruleToken) {
      // comma separator at block level, e.g. a,div,<--
      serializedBuffer = buffer.join('').trim();
      ruleToken[1].push([
        tokenScopeFrom(ruleToken[0]),
        serializedBuffer,
        [originalMetadata(metadata, serializedBuffer, externalContext, ruleToken[1].length)]
      ]);

      buffer = [];
      isBufferEmpty = true;
    } else if (character == Marker$1.COMMA && level == Level.BLOCK && tokenTypeFrom(buffer) == Token$1.AT_RULE) {
      // comma separator at block level, e.g. @import url(...) screen,<--
      // keep iterating as end semicolon will create the token
      buffer.push(character);
      isBufferEmpty = false;
    } else if (character == Marker$1.COMMA && level == Level.BLOCK) {
      // comma separator at block level, e.g. a,<--
      ruleToken = [tokenTypeFrom(buffer), [], []];
      serializedBuffer = buffer.join('').trim();
      ruleToken[1].push([
        tokenScopeFrom(ruleToken[0]),
        serializedBuffer,
        [originalMetadata(metadata, serializedBuffer, externalContext, 0)]
      ]);

      buffer = [];
      isBufferEmpty = true;
    } else if (character == Marker$1.OPEN_CURLY_BRACKET
      && level == Level.BLOCK
      && ruleToken
      && ruleToken[0] == Token$1.NESTED_BLOCK) {
      // open brace opening at-rule at block level, e.g. @media{<--
      serializedBuffer = buffer.join('').trim();
      ruleToken[1].push([
        Token$1.NESTED_BLOCK_SCOPE,
        serializedBuffer,
        [originalMetadata(metadata, serializedBuffer, externalContext)]
      ]);
      allTokens.push(ruleToken);

      levels.push(level);
      position.column++;
      position.index++;
      buffer = [];
      isBufferEmpty = true;

      ruleToken[2] = intoTokens(source, externalContext, internalContext, true);
      ruleToken = null;
    } else if (character == Marker$1.OPEN_CURLY_BRACKET
      && level == Level.BLOCK
      && tokenTypeFrom(buffer) == Token$1.NESTED_BLOCK) {
      // open brace opening at-rule at block level, e.g. @media{<--
      serializedBuffer = buffer.join('').trim();
      ruleToken = ruleToken || [Token$1.NESTED_BLOCK, [], []];
      ruleToken[1].push([
        Token$1.NESTED_BLOCK_SCOPE,
        serializedBuffer,
        [originalMetadata(metadata, serializedBuffer, externalContext)]
      ]);
      allTokens.push(ruleToken);

      levels.push(level);
      position.column++;
      position.index++;
      buffer = [];
      isBufferEmpty = true;
      isVariable = false;

      ruleToken[2] = intoTokens(source, externalContext, internalContext, true);
      ruleToken = null;
    } else if (character == Marker$1.OPEN_CURLY_BRACKET && level == Level.BLOCK) {
      // open brace opening rule at block level, e.g. div{<--
      serializedBuffer = buffer.join('').trim();
      ruleToken = ruleToken || [tokenTypeFrom(buffer), [], []];
      ruleToken[1].push([
        tokenScopeFrom(ruleToken[0]),
        serializedBuffer,
        [originalMetadata(metadata, serializedBuffer, externalContext, ruleToken[1].length)]
      ]);
      newTokens = ruleToken[2];
      allTokens.push(ruleToken);

      levels.push(level);
      level = Level.RULE;
      buffer = [];
      isBufferEmpty = true;
    } else if (character == Marker$1.OPEN_CURLY_BRACKET && level == Level.RULE && seekingValue) {
      // open brace opening rule at rule level, e.g. div{--variable:{<--
      ruleTokens.push(ruleToken);
      ruleToken = [Token$1.PROPERTY_BLOCK, []];
      propertyToken.push(ruleToken);
      newTokens = ruleToken[1];

      levels.push(level);
      level = Level.RULE;
      seekingValue = false;
    } else if (character == Marker$1.OPEN_CURLY_BRACKET && level == Level.RULE && isPageMarginBox(buffer)) {
      // open brace opening page-margin box at rule level, e.g. @page{@top-center{<--
      serializedBuffer = buffer.join('').trim();
      ruleTokens.push(ruleToken);
      ruleToken = [Token$1.AT_RULE_BLOCK, [], []];
      ruleToken[1].push([
        Token$1.AT_RULE_BLOCK_SCOPE,
        serializedBuffer,
        [originalMetadata(metadata, serializedBuffer, externalContext)]
      ]);
      newTokens.push(ruleToken);
      newTokens = ruleToken[2];

      levels.push(level);
      level = Level.RULE;
      buffer = [];
      isBufferEmpty = true;
    } else if (character == Marker$1.COLON && level == Level.RULE && !seekingValue) {
      // colon at rule level, e.g. a{color:<--
      serializedBuffer = buffer.join('').trim();
      propertyToken = [
        Token$1.PROPERTY,
        [
          Token$1.PROPERTY_NAME,
          serializedBuffer,
          [originalMetadata(metadata, serializedBuffer, externalContext)]
        ]
      ];
      newTokens.push(propertyToken);

      seekingValue = true;
      buffer = [];
      isBufferEmpty = true;
    } else if (character == Marker$1.SEMICOLON
      && level == Level.RULE
      && propertyToken
      && ruleTokens.length > 0
      && !isBufferEmpty
      && buffer[0] == Marker$1.AT) {
      // semicolon at rule level for at-rule, e.g. a{--color:{@apply(--other-color);<--
      serializedBuffer = buffer.join('').trim();
      ruleToken[1].push([
        Token$1.AT_RULE,
        serializedBuffer,
        [originalMetadata(metadata, serializedBuffer, externalContext)]
      ]);

      buffer = [];
      isBufferEmpty = true;
    } else if (character == Marker$1.SEMICOLON && level == Level.RULE && propertyToken && !isBufferEmpty) {
      // semicolon at rule level, e.g. a{color:red;<--
      serializedBuffer = buffer.join('').trim();
      propertyToken.push([
        Token$1.PROPERTY_VALUE,
        serializedBuffer,
        [originalMetadata(metadata, serializedBuffer, externalContext)]
      ]);

      propertyToken = null;
      seekingValue = false;
      buffer = [];
      isBufferEmpty = true;
      isVariable = false;
    } else if (character == Marker$1.SEMICOLON
      && level == Level.RULE
      && propertyToken
      && isBufferEmpty
      && isVariable
      && !propertyToken[2]) {
      // semicolon after empty variable value at rule level, e.g. a{--color: ;<--
      propertyToken.push([Token$1.PROPERTY_VALUE, ' ', [originalMetadata(metadata, ' ', externalContext)]]);
      isVariable = false;
      propertyToken = null;
      seekingValue = false;
    } else if (character == Marker$1.SEMICOLON && level == Level.RULE && propertyToken && isBufferEmpty) {
      // semicolon after bracketed value at rule level, e.g. a{color:rgb(...);<--
      propertyToken = null;
      seekingValue = false;
    } else if (character == Marker$1.SEMICOLON
      && level == Level.RULE
      && !isBufferEmpty
      && buffer[0] == Marker$1.AT) {
      // semicolon for at-rule at rule level, e.g. a{@apply(--variable);<--
      serializedBuffer = buffer.join('');
      newTokens.push([
        Token$1.AT_RULE,
        serializedBuffer,
        [originalMetadata(metadata, serializedBuffer, externalContext)]
      ]);

      seekingValue = false;
      buffer = [];
      isBufferEmpty = true;
    } else if (character == Marker$1.SEMICOLON && level == Level.RULE && seekingPropertyBlockClosing) {
      // close brace after a property block at rule level, e.g. a{--custom:{color:red;};<--
      seekingPropertyBlockClosing = false;
      buffer = [];
      isBufferEmpty = true;
    } else if (character == Marker$1.SEMICOLON && level == Level.RULE && isBufferEmpty) ; else if (character == Marker$1.CLOSE_CURLY_BRACKET
      && level == Level.RULE
      && propertyToken
      && seekingValue
      && !isBufferEmpty && ruleTokens.length > 0) {
      // close brace at rule level, e.g. a{--color:{color:red}<--
      serializedBuffer = buffer.join('');
      propertyToken.push([
        Token$1.PROPERTY_VALUE,
        serializedBuffer,
        [originalMetadata(metadata, serializedBuffer, externalContext)]
      ]);
      propertyToken = null;
      ruleToken = ruleTokens.pop();
      newTokens = ruleToken[2];

      level = levels.pop();
      seekingValue = false;
      buffer = [];
      isBufferEmpty = true;
    } else if (character == Marker$1.CLOSE_CURLY_BRACKET
      && level == Level.RULE
      && propertyToken
      && !isBufferEmpty
      && buffer[0] == Marker$1.AT
      && ruleTokens.length > 0) {
      // close brace at rule level for at-rule, e.g. a{--color:{@apply(--other-color)}<--
      serializedBuffer = buffer.join('');
      ruleToken[1].push([
        Token$1.AT_RULE,
        serializedBuffer,
        [originalMetadata(metadata, serializedBuffer, externalContext)]
      ]);
      propertyToken = null;
      ruleToken = ruleTokens.pop();
      newTokens = ruleToken[2];

      level = levels.pop();
      seekingValue = false;
      buffer = [];
      isBufferEmpty = true;
    } else if (character == Marker$1.CLOSE_CURLY_BRACKET
      && level == Level.RULE
      && propertyToken
      && ruleTokens.length > 0) {
      // close brace at rule level after space, e.g. a{--color:{color:red }<--
      propertyToken = null;
      ruleToken = ruleTokens.pop();
      newTokens = ruleToken[2];

      level = levels.pop();
      seekingValue = false;
    } else if (character == Marker$1.CLOSE_CURLY_BRACKET
      && level == Level.RULE
      && propertyToken
      && !isBufferEmpty) {
      // close brace at rule level, e.g. a{color:red}<--
      serializedBuffer = buffer.join('');
      propertyToken.push([
        Token$1.PROPERTY_VALUE,
        serializedBuffer,
        [originalMetadata(metadata, serializedBuffer, externalContext)]
      ]);
      propertyToken = null;
      ruleToken = ruleTokens.pop();
      newTokens = allTokens;

      level = levels.pop();
      seekingValue = false;
      buffer = [];
      isBufferEmpty = true;
    } else if (character == Marker$1.CLOSE_CURLY_BRACKET
      && level == Level.RULE
      && !isBufferEmpty
      && buffer[0] == Marker$1.AT) {
      // close brace after at-rule at rule level, e.g. a{@apply(--variable)}<--
      propertyToken = null;
      ruleToken = null;
      serializedBuffer = buffer.join('').trim();
      newTokens.push([
        Token$1.AT_RULE,
        serializedBuffer,
        [originalMetadata(metadata, serializedBuffer, externalContext)]
      ]);
      newTokens = allTokens;

      level = levels.pop();
      seekingValue = false;
      buffer = [];
      isBufferEmpty = true;
    } else if (character == Marker$1.CLOSE_CURLY_BRACKET
      && level == Level.RULE
      && levels[levels.length - 1] == Level.RULE) {
      // close brace after a property block at rule level, e.g. a{--custom:{color:red;}<--
      propertyToken = null;
      ruleToken = ruleTokens.pop();
      newTokens = ruleToken[2];

      level = levels.pop();
      seekingValue = false;
      seekingPropertyBlockClosing = true;
      buffer = [];
      isBufferEmpty = true;
    } else if (character == Marker$1.CLOSE_CURLY_BRACKET
      && level == Level.RULE
      && isVariable
      && propertyToken
      && !propertyToken[2]) {
      // close brace after an empty variable declaration inside a rule, e.g. a{--color: }<--
      propertyToken.push([Token$1.PROPERTY_VALUE, ' ', [originalMetadata(metadata, ' ', externalContext)]]);
      isVariable = false;
      propertyToken = null;
      ruleToken = null;
      newTokens = allTokens;

      level = levels.pop();
      seekingValue = false;
      isVariable = false;
    } else if (character == Marker$1.CLOSE_CURLY_BRACKET && level == Level.RULE) {
      // close brace after a rule, e.g. a{color:red;}<--
      propertyToken = null;
      ruleToken = null;
      newTokens = allTokens;

      level = levels.pop();
      seekingValue = false;
      isVariable = false;
    } else if (character == Marker$1.CLOSE_CURLY_BRACKET
      && level == Level.BLOCK
      && !isNested
      && position.index <= source.length - 1) {
      // stray close brace at block level, e.g. a{color:red}color:blue}<--
      externalContext.warnings.push('Unexpected \'}\' at ' + formatPosition([position.line, position.column, position.source]) + '.');
      buffer.push(character);
      isBufferEmpty = false;
    } else if (character == Marker$1.CLOSE_CURLY_BRACKET && level == Level.BLOCK) {
      // close brace at block level, e.g. @media screen {...}<--
      break;
    } else if (character == Marker$1.OPEN_ROUND_BRACKET && level == Level.RULE && seekingValue) {
      // round open bracket, e.g. a{color:hsla(<--
      buffer.push(character);
      isBufferEmpty = false;
      roundBracketLevel++;
    } else if (character == Marker$1.CLOSE_ROUND_BRACKET
      && level == Level.RULE
      && seekingValue
      && roundBracketLevel == 1) {
      // round close bracket, e.g. a{color:hsla(0,0%,0%)<--
      buffer.push(character);
      isBufferEmpty = false;
      serializedBuffer = buffer.join('').trim();
      propertyToken.push([
        Token$1.PROPERTY_VALUE,
        serializedBuffer,
        [originalMetadata(metadata, serializedBuffer, externalContext)]
      ]);

      roundBracketLevel--;
      buffer = [];
      isBufferEmpty = true;
      isVariable = false;
    } else if (character == Marker$1.CLOSE_ROUND_BRACKET && level == Level.RULE && seekingValue) {
      // round close bracket within other brackets, e.g. a{width:calc((10rem / 2)<--
      buffer.push(character);
      isBufferEmpty = false;
      isVariable = false;
      roundBracketLevel--;
    } else if (character == Marker$1.FORWARD_SLASH
      && source[position.index + 1] != Marker$1.ASTERISK
      && level == Level.RULE
      && seekingValue
      && !isBufferEmpty) {
      // forward slash within a property, e.g. a{background:url(image.png) 0 0/<--
      serializedBuffer = buffer.join('').trim();
      propertyToken.push([
        Token$1.PROPERTY_VALUE,
        serializedBuffer,
        [originalMetadata(metadata, serializedBuffer, externalContext)]
      ]);
      propertyToken.push([
        Token$1.PROPERTY_VALUE,
        character,
        [[position.line, position.column, position.source]]
      ]);

      buffer = [];
      isBufferEmpty = true;
    } else if (character == Marker$1.FORWARD_SLASH
      && source[position.index + 1] != Marker$1.ASTERISK
      && level == Level.RULE
      && seekingValue) {
      // forward slash within a property after space, e.g. a{background:url(image.png) 0 0 /<--
      propertyToken.push([
        Token$1.PROPERTY_VALUE,
        character,
        [[position.line, position.column, position.source]]
      ]);

      buffer = [];
      isBufferEmpty = true;
    } else if (character == Marker$1.COMMA && level == Level.RULE && seekingValue && !isBufferEmpty) {
      // comma within a property, e.g. a{background:url(image.png),<--
      serializedBuffer = buffer.join('').trim();
      propertyToken.push([
        Token$1.PROPERTY_VALUE,
        serializedBuffer,
        [originalMetadata(metadata, serializedBuffer, externalContext)]
      ]);
      propertyToken.push([
        Token$1.PROPERTY_VALUE,
        character,
        [[position.line, position.column, position.source]]
      ]);

      buffer = [];
      isBufferEmpty = true;
    } else if (character == Marker$1.COMMA && level == Level.RULE && seekingValue) {
      // comma within a property after space, e.g. a{background:url(image.png) ,<--
      propertyToken.push([
        Token$1.PROPERTY_VALUE,
        character,
        [[position.line, position.column, position.source]]
      ]);

      buffer = [];
      isBufferEmpty = true;
    } else if (character == Marker$1.CLOSE_SQUARE_BRACKET
      && propertyToken
      && propertyToken.length > 1
      && !isBufferEmpty
      && isRepeatToken(buffer)) {
      buffer.push(character);
      serializedBuffer = buffer.join('').trim();
      propertyToken[propertyToken.length - 1][1] += serializedBuffer;

      buffer = [];
      isBufferEmpty = true;
    } else if ((isSpace || (isNewLineNix && !isNewLineWin))
      && level == Level.RULE
      && seekingValue
      && propertyToken
      && !isBufferEmpty) {
      // space or *nix newline within property, e.g. a{margin:0 <--
      serializedBuffer = buffer.join('').trim();
      propertyToken.push([
        Token$1.PROPERTY_VALUE,
        serializedBuffer,
        [originalMetadata(metadata, serializedBuffer, externalContext)]
      ]);

      buffer = [];
      isBufferEmpty = true;
    } else if (isNewLineWin && level == Level.RULE && seekingValue && propertyToken && buffer.length > 1) {
      // win newline within property, e.g. a{margin:0\r\n<--
      serializedBuffer = buffer.join('').trim();
      propertyToken.push([
        Token$1.PROPERTY_VALUE,
        serializedBuffer,
        [originalMetadata(metadata, serializedBuffer, externalContext)]
      ]);

      buffer = [];
      isBufferEmpty = true;
    } else if (isNewLineWin && level == Level.RULE && seekingValue) {
      // win newline
      buffer = [];
      isBufferEmpty = true;
    } else if (isNewLineWin && buffer.length == 1) {
      // ignore windows newline which is composed of two characters
      buffer.pop();
      isBufferEmpty = buffer.length === 0;
    } else if (!isBufferEmpty || !isSpace && !isNewLineNix && !isNewLineWin && !isCarriageReturn) {
      // any character
      buffer.push(character);
      isBufferEmpty = false;
    }

    wasEscaped = isEscaped;
    isEscaped = !wasEscaped && character == Marker$1.BACK_SLASH;
    wasCommentStart = isCommentStart;
    wasCommentEnd = isCommentEnd;

    position.line = (isNewLineWin || isNewLineNix || isCarriageReturn) ? position.line + 1 : position.line;
    position.column = (isNewLineWin || isNewLineNix || isCarriageReturn) ? 0 : position.column + 1;
  }

  if (seekingValue) {
    externalContext.warnings.push('Missing \'}\' at ' + formatPosition([position.line, position.column, position.source]) + '.');
  }

  if (seekingValue && buffer.length > 0) {
    serializedBuffer = buffer.join('').trimRight().replace(TAIL_BROKEN_VALUE_PATTERN, '$1').trimRight();
    propertyToken.push([
      Token$1.PROPERTY_VALUE,
      serializedBuffer,
      [originalMetadata(metadata, serializedBuffer, externalContext)]
    ]);

    buffer = [];
  }

  if (buffer.length > 0) {
    externalContext.warnings.push('Invalid character(s) \'' + buffer.join('') + '\' at ' + formatPosition(metadata) + '. Ignoring.');
  }

  return allTokens;
}

function isIgnoreStartComment(buffer) {
  return IGNORE_START_COMMENT_PATTERN.test(buffer.join('') + Marker$1.FORWARD_SLASH);
}

function isIgnoreEndComment(buffer) {
  return IGNORE_END_COMMENT_PATTERN.test(buffer.join('') + Marker$1.FORWARD_SLASH);
}

function originalMetadata(metadata, value, externalContext, selectorFallbacks) {
  var source = metadata[2];

  return externalContext.inputSourceMapTracker.isTracking(source)
    ? externalContext.inputSourceMapTracker.originalPositionFor(metadata, value.length, selectorFallbacks)
    : metadata;
}

function tokenTypeFrom(buffer) {
  var isAtRule = buffer[0] == Marker$1.AT || buffer[0] == Marker$1.UNDERSCORE;
  var ruleWord = buffer.join('').split(RULE_WORD_SEPARATOR_PATTERN)[0];

  if (isAtRule && BLOCK_RULES.indexOf(ruleWord) > -1) {
    return Token$1.NESTED_BLOCK;
  } if (isAtRule && AT_RULES.indexOf(ruleWord) > -1) {
    return Token$1.AT_RULE;
  } if (isAtRule) {
    return Token$1.AT_RULE_BLOCK;
  }
  return Token$1.RULE;
}

function tokenScopeFrom(tokenType) {
  if (tokenType == Token$1.RULE) {
    return Token$1.RULE_SCOPE;
  } if (tokenType == Token$1.NESTED_BLOCK) {
    return Token$1.NESTED_BLOCK_SCOPE;
  } if (tokenType == Token$1.AT_RULE_BLOCK) {
    return Token$1.AT_RULE_BLOCK_SCOPE;
  }
}

function isPageMarginBox(buffer) {
  var serializedBuffer = buffer.join('').trim();

  return PAGE_MARGIN_BOXES.indexOf(serializedBuffer) > -1 || EXTRA_PAGE_BOXES.indexOf(serializedBuffer) > -1;
}

function isRepeatToken(buffer) {
  return REPEAT_PATTERN.test(buffer.join('') + Marker$1.CLOSE_SQUARE_BRACKET);
}

var tokenize_1 = tokenize$1;

var fs$8 = require$$0__default["default"];
var path$9 = path__default["default"];

var applySourceMaps = applySourceMaps_1;
var extractImportUrlAndMedia = extractImportUrlAndMedia_1;
var isAllowedResource = isAllowedResource_1;
var loadOriginalSources = loadOriginalSources_1;
var normalizePath$2 = normalizePath_1;
var rebase = rebase_1;
var rebaseLocalMap = rebaseLocalMap_1;
var rebaseRemoteMap = rebaseRemoteMap_1;
var restoreImport = restoreImport_1;

var tokenize = tokenize_1;
var Token = token;
var Marker = marker;
var hasProtocol = hasProtocol_1;
var isImport = isImport_1;
var isRemoteResource$1 = isRemoteResource_1;

var UNKNOWN_URI = 'uri:unknown';
var FILE_RESOURCE_PROTOCOL = 'file://';

function readSources$1(input, context, callback) {
  return doReadSources(input, context, function(tokens) {
    return applySourceMaps(tokens, context, function() {
      return loadOriginalSources(context, function() { return callback(tokens); });
    });
  });
}

function doReadSources(input, context, callback) {
  if (typeof input == 'string') {
    return fromString(input, context, callback);
  } if (Buffer.isBuffer(input)) {
    return fromString(input.toString(), context, callback);
  } if (Array.isArray(input)) {
    return fromArray(input, context, callback);
  } if (typeof input == 'object') {
    return fromHash(input, context, callback);
  }
}

function fromString(input, context, callback) {
  context.source = undefined;
  context.sourcesContent[undefined] = input;
  context.stats.originalSize += input.length;

  return fromStyles(input, context, { inline: context.options.inline }, callback);
}

function fromArray(input, context, callback) {
  var inputAsImports = input.reduce(function(accumulator, uriOrHash) {
    if (typeof uriOrHash === 'string') {
      return addStringSource(uriOrHash, accumulator);
    }
    return addHashSource(uriOrHash, context, accumulator);
  }, []);

  return fromStyles(inputAsImports.join(''), context, { inline: ['all'] }, callback);
}

function fromHash(input, context, callback) {
  var inputAsImports = addHashSource(input, context, []);
  return fromStyles(inputAsImports.join(''), context, { inline: ['all'] }, callback);
}

function addStringSource(input, imports) {
  imports.push(restoreAsImport(normalizeUri(input)));
  return imports;
}

function addHashSource(input, context, imports) {
  var uri;
  var normalizedUri;
  var source;

  for (uri in input) {
    source = input[uri];
    normalizedUri = normalizeUri(uri);

    imports.push(restoreAsImport(normalizedUri));

    context.sourcesContent[normalizedUri] = source.styles;

    if (source.sourceMap) {
      trackSourceMap(source.sourceMap, normalizedUri, context);
    }
  }

  return imports;
}

function normalizeUri(uri) {
  var currentPath = path$9.resolve('');
  var absoluteUri;
  var relativeToCurrentPath;
  var normalizedUri;

  if (isRemoteResource$1(uri)) {
    return uri;
  }

  absoluteUri = path$9.isAbsolute(uri)
    ? uri
    : path$9.resolve(uri);
  relativeToCurrentPath = path$9.relative(currentPath, absoluteUri);
  normalizedUri = normalizePath$2(relativeToCurrentPath);

  return normalizedUri;
}

function trackSourceMap(sourceMap, uri, context) {
  var parsedMap = typeof sourceMap == 'string'
    ? JSON.parse(sourceMap)
    : sourceMap;
  var rebasedMap = isRemoteResource$1(uri)
    ? rebaseRemoteMap(parsedMap, uri)
    : rebaseLocalMap(parsedMap, uri || UNKNOWN_URI, context.options.rebaseTo);

  context.inputSourceMapTracker.track(uri, rebasedMap);
}

function restoreAsImport(uri) {
  return restoreImport('url(' + uri + ')', '') + Marker.SEMICOLON;
}

function fromStyles(styles, context, parentInlinerContext, callback) {
  var tokens;
  var rebaseConfig = {};

  if (!context.source) {
    rebaseConfig.fromBase = path$9.resolve('');
    rebaseConfig.toBase = context.options.rebaseTo;
  } else if (isRemoteResource$1(context.source)) {
    rebaseConfig.fromBase = context.source;
    rebaseConfig.toBase = context.source;
  } else if (path$9.isAbsolute(context.source)) {
    rebaseConfig.fromBase = path$9.dirname(context.source);
    rebaseConfig.toBase = context.options.rebaseTo;
  } else {
    rebaseConfig.fromBase = path$9.dirname(path$9.resolve(context.source));
    rebaseConfig.toBase = context.options.rebaseTo;
  }

  tokens = tokenize(styles, context);
  tokens = rebase(tokens, context.options.rebase, context.validator, rebaseConfig);

  return allowsAnyImports(parentInlinerContext.inline)
    ? inline$1(tokens, context, parentInlinerContext, callback)
    : callback(tokens);
}

function allowsAnyImports(inline) {
  return !(inline.length == 1 && inline[0] == 'none');
}

function inline$1(tokens, externalContext, parentInlinerContext, callback) {
  var inlinerContext = {
    afterContent: false,
    callback: callback,
    errors: externalContext.errors,
    externalContext: externalContext,
    fetch: externalContext.options.fetch,
    inlinedStylesheets: parentInlinerContext.inlinedStylesheets || externalContext.inlinedStylesheets,
    inline: parentInlinerContext.inline,
    inlineRequest: externalContext.options.inlineRequest,
    inlineTimeout: externalContext.options.inlineTimeout,
    isRemote: parentInlinerContext.isRemote || false,
    localOnly: externalContext.localOnly,
    outputTokens: [],
    rebaseTo: externalContext.options.rebaseTo,
    sourceTokens: tokens,
    warnings: externalContext.warnings
  };

  return doInlineImports(inlinerContext);
}

function doInlineImports(inlinerContext) {
  var token;
  var i, l;

  for (i = 0, l = inlinerContext.sourceTokens.length; i < l; i++) {
    token = inlinerContext.sourceTokens[i];

    if (token[0] == Token.AT_RULE && isImport(token[1])) {
      inlinerContext.sourceTokens.splice(0, i);
      return inlineStylesheet(token, inlinerContext);
    } if (token[0] == Token.AT_RULE || token[0] == Token.COMMENT) {
      inlinerContext.outputTokens.push(token);
    } else {
      inlinerContext.outputTokens.push(token);
      inlinerContext.afterContent = true;
    }
  }

  inlinerContext.sourceTokens = [];
  return inlinerContext.callback(inlinerContext.outputTokens);
}

function inlineStylesheet(token, inlinerContext) {
  var uriAndMediaQuery = extractImportUrlAndMedia(token[1]);
  var uri = uriAndMediaQuery[0];
  var mediaQuery = uriAndMediaQuery[1];
  var metadata = token[2];

  return isRemoteResource$1(uri)
    ? inlineRemoteStylesheet(uri, mediaQuery, metadata, inlinerContext)
    : inlineLocalStylesheet(uri, mediaQuery, metadata, inlinerContext);
}

function inlineRemoteStylesheet(uri, mediaQuery, metadata, inlinerContext) {
  var isAllowed = isAllowedResource(uri, true, inlinerContext.inline);
  var originalUri = uri;
  var isLoaded = uri in inlinerContext.externalContext.sourcesContent;
  var isRuntimeResource = !hasProtocol(uri);

  if (inlinerContext.inlinedStylesheets.indexOf(uri) > -1) {
    inlinerContext.warnings.push('Ignoring remote @import of "' + uri + '" as it has already been imported.');
    inlinerContext.sourceTokens = inlinerContext.sourceTokens.slice(1);
    return doInlineImports(inlinerContext);
  } if (inlinerContext.localOnly && inlinerContext.afterContent) {
    inlinerContext.warnings.push('Ignoring remote @import of "' + uri + '" as no callback given and after other content.');
    inlinerContext.sourceTokens = inlinerContext.sourceTokens.slice(1);
    return doInlineImports(inlinerContext);
  } if (isRuntimeResource) {
    inlinerContext.warnings.push('Skipping remote @import of "' + uri + '" as no protocol given.');
    inlinerContext.outputTokens = inlinerContext.outputTokens.concat(inlinerContext.sourceTokens.slice(0, 1));
    inlinerContext.sourceTokens = inlinerContext.sourceTokens.slice(1);
    return doInlineImports(inlinerContext);
  } if (inlinerContext.localOnly && !isLoaded) {
    inlinerContext.warnings.push('Skipping remote @import of "' + uri + '" as no callback given.');
    inlinerContext.outputTokens = inlinerContext.outputTokens.concat(inlinerContext.sourceTokens.slice(0, 1));
    inlinerContext.sourceTokens = inlinerContext.sourceTokens.slice(1);
    return doInlineImports(inlinerContext);
  } if (!isAllowed && inlinerContext.afterContent) {
    inlinerContext.warnings.push('Ignoring remote @import of "' + uri + '" as resource is not allowed and after other content.');
    inlinerContext.sourceTokens = inlinerContext.sourceTokens.slice(1);
    return doInlineImports(inlinerContext);
  } if (!isAllowed) {
    inlinerContext.warnings.push('Skipping remote @import of "' + uri + '" as resource is not allowed.');
    inlinerContext.outputTokens = inlinerContext.outputTokens.concat(inlinerContext.sourceTokens.slice(0, 1));
    inlinerContext.sourceTokens = inlinerContext.sourceTokens.slice(1);
    return doInlineImports(inlinerContext);
  }

  inlinerContext.inlinedStylesheets.push(uri);

  function whenLoaded(error, importedStyles) {
    if (error) {
      inlinerContext.errors.push('Broken @import declaration of "' + uri + '" - ' + error);

      return process.nextTick(function() {
        inlinerContext.outputTokens = inlinerContext.outputTokens.concat(inlinerContext.sourceTokens.slice(0, 1));
        inlinerContext.sourceTokens = inlinerContext.sourceTokens.slice(1);
        doInlineImports(inlinerContext);
      });
    }

    inlinerContext.inline = inlinerContext.externalContext.options.inline;
    inlinerContext.isRemote = true;

    inlinerContext.externalContext.source = originalUri;
    inlinerContext.externalContext.sourcesContent[uri] = importedStyles;
    inlinerContext.externalContext.stats.originalSize += importedStyles.length;

    return fromStyles(importedStyles, inlinerContext.externalContext, inlinerContext, function(importedTokens) {
      importedTokens = wrapInMedia(importedTokens, mediaQuery, metadata);

      inlinerContext.outputTokens = inlinerContext.outputTokens.concat(importedTokens);
      inlinerContext.sourceTokens = inlinerContext.sourceTokens.slice(1);

      return doInlineImports(inlinerContext);
    });
  }

  return isLoaded
    ? whenLoaded(null, inlinerContext.externalContext.sourcesContent[uri])
    : inlinerContext.fetch(uri, inlinerContext.inlineRequest, inlinerContext.inlineTimeout, whenLoaded);
}

function inlineLocalStylesheet(uri, mediaQuery, metadata, inlinerContext) {
  var protocolLessUri = uri.replace(FILE_RESOURCE_PROTOCOL, '');
  var currentPath = path$9.resolve('');
  var absoluteUri = path$9.isAbsolute(protocolLessUri)
    ? path$9.resolve(currentPath, protocolLessUri[0] == '/' ? protocolLessUri.substring(1) : protocolLessUri)
    : path$9.resolve(inlinerContext.rebaseTo, protocolLessUri);
  var relativeToCurrentPath = path$9.relative(currentPath, absoluteUri);
  var importedStyles;
  var isAllowed = isAllowedResource(protocolLessUri, false, inlinerContext.inline);
  var normalizedPath = normalizePath$2(relativeToCurrentPath);
  var isLoaded = normalizedPath in inlinerContext.externalContext.sourcesContent;

  if (inlinerContext.inlinedStylesheets.indexOf(absoluteUri) > -1) {
    inlinerContext.warnings.push('Ignoring local @import of "' + protocolLessUri + '" as it has already been imported.');
  } else if (isAllowed && !isLoaded && (!fs$8.existsSync(absoluteUri) || !fs$8.statSync(absoluteUri).isFile())) {
    inlinerContext.errors.push('Ignoring local @import of "' + protocolLessUri + '" as resource is missing.');
  } else if (!isAllowed && inlinerContext.afterContent) {
    inlinerContext.warnings.push('Ignoring local @import of "' + protocolLessUri + '" as resource is not allowed and after other content.');
  } else if (inlinerContext.afterContent) {
    inlinerContext.warnings.push('Ignoring local @import of "' + protocolLessUri + '" as after other content.');
  } else if (!isAllowed) {
    inlinerContext.warnings.push('Skipping local @import of "' + protocolLessUri + '" as resource is not allowed.');
    inlinerContext.outputTokens = inlinerContext.outputTokens.concat(inlinerContext.sourceTokens.slice(0, 1));
  } else {
    importedStyles = isLoaded
      ? inlinerContext.externalContext.sourcesContent[normalizedPath]
      : fs$8.readFileSync(absoluteUri, 'utf-8');

    if (importedStyles.charCodeAt(0) === 65279) {
      importedStyles = importedStyles.substring(1);
    }

    inlinerContext.inlinedStylesheets.push(absoluteUri);
    inlinerContext.inline = inlinerContext.externalContext.options.inline;

    inlinerContext.externalContext.source = normalizedPath;
    inlinerContext.externalContext.sourcesContent[normalizedPath] = importedStyles;
    inlinerContext.externalContext.stats.originalSize += importedStyles.length;

    return fromStyles(importedStyles, inlinerContext.externalContext, inlinerContext, function(importedTokens) {
      importedTokens = wrapInMedia(importedTokens, mediaQuery, metadata);

      inlinerContext.outputTokens = inlinerContext.outputTokens.concat(importedTokens);
      inlinerContext.sourceTokens = inlinerContext.sourceTokens.slice(1);

      return doInlineImports(inlinerContext);
    });
  }

  inlinerContext.sourceTokens = inlinerContext.sourceTokens.slice(1);

  return doInlineImports(inlinerContext);
}

function wrapInMedia(tokens, mediaQuery, metadata) {
  if (mediaQuery) {
    return [[Token.NESTED_BLOCK, [[Token.NESTED_BLOCK_SCOPE, '@media ' + mediaQuery, metadata]], tokens]];
  }
  return tokens;
}

var readSources_1 = readSources$1;

var all$1 = helpers$2.all;

function store$1(serializeContext, token) {
  var value = typeof token == 'string'
    ? token
    : token[1];
  var wrap = serializeContext.wrap;

  wrap(serializeContext, value);
  track$1(serializeContext, value);
  serializeContext.output.push(value);
}

function wrap$1(serializeContext, value) {
  if (serializeContext.column + value.length > serializeContext.format.wrapAt) {
    track$1(serializeContext, serializeContext.format.breakWith);
    serializeContext.output.push(serializeContext.format.breakWith);
  }
}

function track$1(serializeContext, value) {
  var parts = value.split('\n');

  serializeContext.line += parts.length - 1;
  serializeContext.column = parts.length > 1 ? 0 : (serializeContext.column + parts.pop().length);
}

function serializeStyles$1(tokens, context) {
  var serializeContext = {
    column: 0,
    format: context.options.format,
    indentBy: 0,
    indentWith: '',
    line: 1,
    output: [],
    spaceAfterClosingBrace: context.options.compatibility.properties.spaceAfterClosingBrace,
    store: store$1,
    wrap: context.options.format.wrapAt
      ? wrap$1
      : function() { /* noop */ }
  };

  all$1(serializeContext, tokens);

  return { styles: serializeContext.output.join('') };
}

var simple = serializeStyles$1;

var SourceMapGenerator = requireSourceMap$2().SourceMapGenerator;
var all = helpers$2.all;

var isRemoteResource = isRemoteResource_1;

var isWindows = process.platform == 'win32';

var NIX_SEPARATOR_PATTERN = /\//g;
var UNKNOWN_SOURCE = '$stdin';
var WINDOWS_SEPARATOR = '\\';

function store(serializeContext, element) {
  var fromString = typeof element == 'string';
  var value = fromString ? element : element[1];
  var mappings = fromString ? null : element[2];
  var wrap = serializeContext.wrap;

  wrap(serializeContext, value);
  track(serializeContext, value, mappings);
  serializeContext.output.push(value);
}

function wrap(serializeContext, value) {
  if (serializeContext.column + value.length > serializeContext.format.wrapAt) {
    track(serializeContext, serializeContext.format.breakWith, false);
    serializeContext.output.push(serializeContext.format.breakWith);
  }
}

function track(serializeContext, value, mappings) {
  var parts = value.split('\n');

  if (mappings) {
    trackAllMappings(serializeContext, mappings);
  }

  serializeContext.line += parts.length - 1;
  serializeContext.column = parts.length > 1 ? 0 : (serializeContext.column + parts.pop().length);
}

function trackAllMappings(serializeContext, mappings) {
  for (var i = 0, l = mappings.length; i < l; i++) {
    trackMapping(serializeContext, mappings[i]);
  }
}

function trackMapping(serializeContext, mapping) {
  var line = mapping[0];
  var column = mapping[1];
  var originalSource = mapping[2];
  var source = originalSource;
  var storedSource = source || UNKNOWN_SOURCE;

  if (isWindows && source && !isRemoteResource(source)) {
    storedSource = source.replace(NIX_SEPARATOR_PATTERN, WINDOWS_SEPARATOR);
  }

  serializeContext.outputMap.addMapping({
    generated: {
      line: serializeContext.line,
      column: serializeContext.column
    },
    source: storedSource,
    original: {
      line: line,
      column: column
    }
  });

  if (serializeContext.inlineSources && (originalSource in serializeContext.sourcesContent)) {
    serializeContext.outputMap.setSourceContent(
      storedSource,
      serializeContext.sourcesContent[originalSource]
    );
  }
}

function serializeStylesAndSourceMap$1(tokens, context) {
  var serializeContext = {
    column: 0,
    format: context.options.format,
    indentBy: 0,
    indentWith: '',
    inlineSources: context.options.sourceMapInlineSources,
    line: 1,
    output: [],
    outputMap: new SourceMapGenerator(),
    sourcesContent: context.sourcesContent,
    spaceAfterClosingBrace: context.options.compatibility.properties.spaceAfterClosingBrace,
    store: store,
    wrap: context.options.format.wrapAt
      ? wrap
      : function() { /* noop */ }
  };

  all(serializeContext, tokens);

  return {
    sourceMap: serializeContext.outputMap,
    styles: serializeContext.output.join('')
  };
}

var sourceMaps = serializeStylesAndSourceMap$1;

/**
 * Clean-css - https://github.com/clean-css/clean-css
 * Released under the terms of MIT license
 */

var level0Optimize = optimize$4;
var level1Optimize = optimize$3;
var level2Optimize = optimize$1;
var validator$1 = validator_1;

var compatibilityFrom = compatibility;
var fetchFrom = fetch;
var formatFrom = format$1.formatFrom;
var inlineFrom = inline$2;
var inlineRequestFrom = inlineRequest;
var inlineTimeoutFrom = inlineTimeout;
var OptimizationLevel = optimizationLevel.OptimizationLevel;
var optimizationLevelFrom = optimizationLevel.optimizationLevelFrom;
var pluginsFrom = plugins$3;
var rebaseFrom = rebase$3;
var rebaseToFrom = rebaseTo;

var inputSourceMapTracker = inputSourceMapTracker_1;
var readSources = readSources_1;

var serializeStyles = simple;
var serializeStylesAndSourceMap = sourceMaps;

var CleanCSS$1 = clean$1.exports = function CleanCSS(options) {
  options = options || {};

  this.options = {
    batch: !!options.batch,
    compatibility: compatibilityFrom(options.compatibility),
    explicitRebaseTo: 'rebaseTo' in options,
    fetch: fetchFrom(options.fetch),
    format: formatFrom(options.format),
    inline: inlineFrom(options.inline),
    inlineRequest: inlineRequestFrom(options.inlineRequest),
    inlineTimeout: inlineTimeoutFrom(options.inlineTimeout),
    level: optimizationLevelFrom(options.level),
    plugins: pluginsFrom(options.plugins),
    rebase: rebaseFrom(options.rebase, options.rebaseTo),
    rebaseTo: rebaseToFrom(options.rebaseTo),
    returnPromise: !!options.returnPromise,
    sourceMap: !!options.sourceMap,
    sourceMapInlineSources: !!options.sourceMapInlineSources
  };
};

// for compatibility with optimize-css-assets-webpack-plugin
CleanCSS$1.process = function(input, opts) {
  var cleanCss;
  var optsTo = opts.to;

  delete opts.to;
  cleanCss = new CleanCSS$1(Object.assign({
    returnPromise: true, rebaseTo: optsTo
  }, opts));

  return cleanCss.minify(input)
    .then(function(output) {
      return { css: output.styles };
    });
};

CleanCSS$1.prototype.minify = function(input, maybeSourceMap, maybeCallback) {
  var options = this.options;

  if (options.returnPromise) {
    return new Promise(function(resolve, reject) {
      minifyAll(input, options, maybeSourceMap, function(errors, output) {
        return errors
          ? reject(errors)
          : resolve(output);
      });
    });
  }
  return minifyAll(input, options, maybeSourceMap, maybeCallback);
};

function minifyAll(input, options, maybeSourceMap, maybeCallback) {
  if (options.batch && Array.isArray(input)) {
    return minifyInBatchesFromArray(input, options, maybeSourceMap, maybeCallback);
  } if (options.batch && (typeof input == 'object')) {
    return minifyInBatchesFromHash(input, options, maybeSourceMap, maybeCallback);
  }
  return minify$1(input, options, maybeSourceMap, maybeCallback);
}

function minifyInBatchesFromArray(input, options, maybeSourceMap, maybeCallback) {
  var callback = typeof maybeCallback == 'function'
    ? maybeCallback
    : (typeof maybeSourceMap == 'function' ? maybeSourceMap : null);
  var errors = [];
  var outputAsHash = {};
  var inputValue;
  var i, l;

  function whenHashBatchDone(innerErrors, output) {
    outputAsHash = Object.assign(outputAsHash, output);

    if (innerErrors !== null) {
      errors = errors.concat(innerErrors);
    }
  }

  for (i = 0, l = input.length; i < l; i++) {
    if (typeof input[i] == 'object') {
      minifyInBatchesFromHash(input[i], options, whenHashBatchDone);
    } else {
      inputValue = input[i];

      outputAsHash[inputValue] = minify$1([inputValue], options);
      errors = errors.concat(outputAsHash[inputValue].errors);
    }
  }

  return callback
    ? callback(errors.length > 0 ? errors : null, outputAsHash)
    : outputAsHash;
}

function minifyInBatchesFromHash(input, options, maybeSourceMap, maybeCallback) {
  var callback = typeof maybeCallback == 'function'
    ? maybeCallback
    : (typeof maybeSourceMap == 'function' ? maybeSourceMap : null);
  var errors = [];
  var outputAsHash = {};
  var inputKey;
  var inputValue;

  for (inputKey in input) {
    inputValue = input[inputKey];

    outputAsHash[inputKey] = minify$1(inputValue.styles, options, inputValue.sourceMap);
    errors = errors.concat(outputAsHash[inputKey].errors);
  }

  return callback
    ? callback(errors.length > 0 ? errors : null, outputAsHash)
    : outputAsHash;
}

function minify$1(input, options, maybeSourceMap, maybeCallback) {
  var sourceMap = typeof maybeSourceMap != 'function'
    ? maybeSourceMap
    : null;
  var callback = typeof maybeCallback == 'function'
    ? maybeCallback
    : (typeof maybeSourceMap == 'function' ? maybeSourceMap : null);
  var context = {
    stats: {
      efficiency: 0,
      minifiedSize: 0,
      originalSize: 0,
      startedAt: Date.now(),
      timeSpent: 0
    },
    cache: { specificity: {} },
    errors: [],
    inlinedStylesheets: [],
    inputSourceMapTracker: inputSourceMapTracker(),
    localOnly: !callback,
    options: options,
    source: null,
    sourcesContent: {},
    validator: validator$1(options.compatibility),
    warnings: []
  };
  var implicitRebaseToWarning;

  if (sourceMap) {
    context.inputSourceMapTracker.track(undefined, sourceMap);
  }

  if (options.rebase && !options.explicitRebaseTo) {
    implicitRebaseToWarning = 'You have set `rebase: true` without giving `rebaseTo` option, which, in this case, defaults to the current working directory. '
      + 'You are then warned this can lead to unexpected URL rebasing (aka here be dragons)! '
      + 'If you are OK with the clean-css output, then you can get rid of this warning by giving clean-css a `rebaseTo: process.cwd()` option.';
    context.warnings.push(implicitRebaseToWarning);
  }

  return runner(context.localOnly)(function() {
    return readSources(input, context, function(tokens) {
      var serialize = context.options.sourceMap
        ? serializeStylesAndSourceMap
        : serializeStyles;

      var optimizedTokens = optimize(tokens, context);
      var optimizedStyles = serialize(optimizedTokens, context);
      var output = withMetadata(optimizedStyles, context);

      return callback
        ? callback(context.errors.length > 0 ? context.errors : null, output)
        : output;
    });
  });
}

function runner(localOnly) {
  // to always execute code asynchronously when a callback is given
  // more at blog.izs.me/post/59142742143/designing-apis-for-asynchrony
  return localOnly
    ? function(callback) { return callback(); }
    : process.nextTick;
}

function optimize(tokens, context) {
  var optimized = level0Optimize(tokens);

  optimized = OptimizationLevel.One in context.options.level
    ? level1Optimize(tokens, context)
    : tokens;
  optimized = OptimizationLevel.Two in context.options.level
    ? level2Optimize(tokens, context, true)
    : optimized;

  return optimized;
}

function withMetadata(output, context) {
  output.stats = calculateStatsFrom(output.styles, context);
  output.errors = context.errors;
  output.inlinedStylesheets = context.inlinedStylesheets;
  output.warnings = context.warnings;

  return output;
}

function calculateStatsFrom(styles, context) {
  var finishedAt = Date.now();
  var timeSpent = finishedAt - context.stats.startedAt;

  delete context.stats.startedAt;
  context.stats.timeSpent = timeSpent;
  context.stats.efficiency = 1 - styles.length / context.stats.originalSize;
  context.stats.minifiedSize = styles.length;

  return context.stats;
}

var cleanExports = clean$1.exports;

var cleanCss = cleanExports;

var htmlparser = {};

var utils$4 = {};

function createMap(values, ignoreCase) {
  var map = {};
  values.forEach(function(value) {
    map[value] = 1;
  });
  return ignoreCase ? function(value) {
    return map[value.toLowerCase()] === 1;
  } : function(value) {
    return map[value] === 1;
  };
}

async function replaceAsync$1(str, regex, asyncFn) {
  const promises = [];
  str.replace(regex, (match, ...args) => {
    const promise = asyncFn(match, ...args);
    promises.push(promise);
  });
  const data = await Promise.all(promises);
  return str.replace(regex, () => data.shift());
}


utils$4.createMap = createMap;
utils$4.createMapFromString = function(values, ignoreCase) {
  return createMap(values.split(/,/), ignoreCase);
};

utils$4.replaceAsync = replaceAsync$1;

/*!
 * HTML Parser By John Resig (ejohn.org)
 * Modified by Juriy "kangax" Zaytsev
 * Original code by Erik Arvidsson, Mozilla Public License
 * http://erik.eae.net/simplehtmlparser/simplehtmlparser.js
 */

var createMapFromString$1 = utils$4.createMapFromString;
var replaceAsync = utils$4.replaceAsync;

function makeMap(values) {
  return createMapFromString$1(values, true);
}

// Regular Expressions for parsing tags and attributes
var singleAttrIdentifier = /([^\s"'<>/=]+)/,
    singleAttrAssigns = [/=/],
    singleAttrValues = [
    // attr value double quotes
      /"([^"]*)"+/.source,
      // attr value, single quotes
      /'([^']*)'+/.source,
      // attr value, no quotes
      /([^ \t\n\f\r"'`=<>]+)/.source
    ],
    // https://www.w3.org/TR/1999/REC-xml-names-19990114/#NT-QName
    qnameCapture = (function() {
    // based on https://www.npmjs.com/package/ncname
      var combiningChar = '\\u0300-\\u0345\\u0360\\u0361\\u0483-\\u0486\\u0591-\\u05A1\\u05A3-\\u05B9\\u05BB-\\u05BD\\u05BF\\u05C1\\u05C2\\u05C4\\u064B-\\u0652\\u0670\\u06D6-\\u06E4\\u06E7\\u06E8\\u06EA-\\u06ED\\u0901-\\u0903\\u093C\\u093E-\\u094D\\u0951-\\u0954\\u0962\\u0963\\u0981-\\u0983\\u09BC\\u09BE-\\u09C4\\u09C7\\u09C8\\u09CB-\\u09CD\\u09D7\\u09E2\\u09E3\\u0A02\\u0A3C\\u0A3E-\\u0A42\\u0A47\\u0A48\\u0A4B-\\u0A4D\\u0A70\\u0A71\\u0A81-\\u0A83\\u0ABC\\u0ABE-\\u0AC5\\u0AC7-\\u0AC9\\u0ACB-\\u0ACD\\u0B01-\\u0B03\\u0B3C\\u0B3E-\\u0B43\\u0B47\\u0B48\\u0B4B-\\u0B4D\\u0B56\\u0B57\\u0B82\\u0B83\\u0BBE-\\u0BC2\\u0BC6-\\u0BC8\\u0BCA-\\u0BCD\\u0BD7\\u0C01-\\u0C03\\u0C3E-\\u0C44\\u0C46-\\u0C48\\u0C4A-\\u0C4D\\u0C55\\u0C56\\u0C82\\u0C83\\u0CBE-\\u0CC4\\u0CC6-\\u0CC8\\u0CCA-\\u0CCD\\u0CD5\\u0CD6\\u0D02\\u0D03\\u0D3E-\\u0D43\\u0D46-\\u0D48\\u0D4A-\\u0D4D\\u0D57\\u0E31\\u0E34-\\u0E3A\\u0E47-\\u0E4E\\u0EB1\\u0EB4-\\u0EB9\\u0EBB\\u0EBC\\u0EC8-\\u0ECD\\u0F18\\u0F19\\u0F35\\u0F37\\u0F39\\u0F3E\\u0F3F\\u0F71-\\u0F84\\u0F86-\\u0F8B\\u0F90-\\u0F95\\u0F97\\u0F99-\\u0FAD\\u0FB1-\\u0FB7\\u0FB9\\u20D0-\\u20DC\\u20E1\\u302A-\\u302F\\u3099\\u309A';
      var digit = '0-9\\u0660-\\u0669\\u06F0-\\u06F9\\u0966-\\u096F\\u09E6-\\u09EF\\u0A66-\\u0A6F\\u0AE6-\\u0AEF\\u0B66-\\u0B6F\\u0BE7-\\u0BEF\\u0C66-\\u0C6F\\u0CE6-\\u0CEF\\u0D66-\\u0D6F\\u0E50-\\u0E59\\u0ED0-\\u0ED9\\u0F20-\\u0F29';
      var extender = '\\xB7\\u02D0\\u02D1\\u0387\\u0640\\u0E46\\u0EC6\\u3005\\u3031-\\u3035\\u309D\\u309E\\u30FC-\\u30FE';
      var letter = 'A-Za-z\\xC0-\\xD6\\xD8-\\xF6\\xF8-\\u0131\\u0134-\\u013E\\u0141-\\u0148\\u014A-\\u017E\\u0180-\\u01C3\\u01CD-\\u01F0\\u01F4\\u01F5\\u01FA-\\u0217\\u0250-\\u02A8\\u02BB-\\u02C1\\u0386\\u0388-\\u038A\\u038C\\u038E-\\u03A1\\u03A3-\\u03CE\\u03D0-\\u03D6\\u03DA\\u03DC\\u03DE\\u03E0\\u03E2-\\u03F3\\u0401-\\u040C\\u040E-\\u044F\\u0451-\\u045C\\u045E-\\u0481\\u0490-\\u04C4\\u04C7\\u04C8\\u04CB\\u04CC\\u04D0-\\u04EB\\u04EE-\\u04F5\\u04F8\\u04F9\\u0531-\\u0556\\u0559\\u0561-\\u0586\\u05D0-\\u05EA\\u05F0-\\u05F2\\u0621-\\u063A\\u0641-\\u064A\\u0671-\\u06B7\\u06BA-\\u06BE\\u06C0-\\u06CE\\u06D0-\\u06D3\\u06D5\\u06E5\\u06E6\\u0905-\\u0939\\u093D\\u0958-\\u0961\\u0985-\\u098C\\u098F\\u0990\\u0993-\\u09A8\\u09AA-\\u09B0\\u09B2\\u09B6-\\u09B9\\u09DC\\u09DD\\u09DF-\\u09E1\\u09F0\\u09F1\\u0A05-\\u0A0A\\u0A0F\\u0A10\\u0A13-\\u0A28\\u0A2A-\\u0A30\\u0A32\\u0A33\\u0A35\\u0A36\\u0A38\\u0A39\\u0A59-\\u0A5C\\u0A5E\\u0A72-\\u0A74\\u0A85-\\u0A8B\\u0A8D\\u0A8F-\\u0A91\\u0A93-\\u0AA8\\u0AAA-\\u0AB0\\u0AB2\\u0AB3\\u0AB5-\\u0AB9\\u0ABD\\u0AE0\\u0B05-\\u0B0C\\u0B0F\\u0B10\\u0B13-\\u0B28\\u0B2A-\\u0B30\\u0B32\\u0B33\\u0B36-\\u0B39\\u0B3D\\u0B5C\\u0B5D\\u0B5F-\\u0B61\\u0B85-\\u0B8A\\u0B8E-\\u0B90\\u0B92-\\u0B95\\u0B99\\u0B9A\\u0B9C\\u0B9E\\u0B9F\\u0BA3\\u0BA4\\u0BA8-\\u0BAA\\u0BAE-\\u0BB5\\u0BB7-\\u0BB9\\u0C05-\\u0C0C\\u0C0E-\\u0C10\\u0C12-\\u0C28\\u0C2A-\\u0C33\\u0C35-\\u0C39\\u0C60\\u0C61\\u0C85-\\u0C8C\\u0C8E-\\u0C90\\u0C92-\\u0CA8\\u0CAA-\\u0CB3\\u0CB5-\\u0CB9\\u0CDE\\u0CE0\\u0CE1\\u0D05-\\u0D0C\\u0D0E-\\u0D10\\u0D12-\\u0D28\\u0D2A-\\u0D39\\u0D60\\u0D61\\u0E01-\\u0E2E\\u0E30\\u0E32\\u0E33\\u0E40-\\u0E45\\u0E81\\u0E82\\u0E84\\u0E87\\u0E88\\u0E8A\\u0E8D\\u0E94-\\u0E97\\u0E99-\\u0E9F\\u0EA1-\\u0EA3\\u0EA5\\u0EA7\\u0EAA\\u0EAB\\u0EAD\\u0EAE\\u0EB0\\u0EB2\\u0EB3\\u0EBD\\u0EC0-\\u0EC4\\u0F40-\\u0F47\\u0F49-\\u0F69\\u10A0-\\u10C5\\u10D0-\\u10F6\\u1100\\u1102\\u1103\\u1105-\\u1107\\u1109\\u110B\\u110C\\u110E-\\u1112\\u113C\\u113E\\u1140\\u114C\\u114E\\u1150\\u1154\\u1155\\u1159\\u115F-\\u1161\\u1163\\u1165\\u1167\\u1169\\u116D\\u116E\\u1172\\u1173\\u1175\\u119E\\u11A8\\u11AB\\u11AE\\u11AF\\u11B7\\u11B8\\u11BA\\u11BC-\\u11C2\\u11EB\\u11F0\\u11F9\\u1E00-\\u1E9B\\u1EA0-\\u1EF9\\u1F00-\\u1F15\\u1F18-\\u1F1D\\u1F20-\\u1F45\\u1F48-\\u1F4D\\u1F50-\\u1F57\\u1F59\\u1F5B\\u1F5D\\u1F5F-\\u1F7D\\u1F80-\\u1FB4\\u1FB6-\\u1FBC\\u1FBE\\u1FC2-\\u1FC4\\u1FC6-\\u1FCC\\u1FD0-\\u1FD3\\u1FD6-\\u1FDB\\u1FE0-\\u1FEC\\u1FF2-\\u1FF4\\u1FF6-\\u1FFC\\u2126\\u212A\\u212B\\u212E\\u2180-\\u2182\\u3007\\u3021-\\u3029\\u3041-\\u3094\\u30A1-\\u30FA\\u3105-\\u312C\\u4E00-\\u9FA5\\uAC00-\\uD7A3';
      var ncname = '[' + letter + '_][' + letter + digit + '\\.\\-_' + combiningChar + extender + ']*';
      return '((?:' + ncname + '\\:)?' + ncname + ')';
    })(),
    startTagOpen = new RegExp('^<' + qnameCapture),
    startTagClose = /^\s*(\/?)>/,
    endTag$1 = new RegExp('^<\\/' + qnameCapture + '[^>]*>'),
    doctype = /^<!DOCTYPE\s?[^>]+>/i;

var IS_REGEX_CAPTURING_BROKEN = false;
'x'.replace(/x(.)?/g, function(m, g) {
  IS_REGEX_CAPTURING_BROKEN = g === '';
});

// Empty Elements
var empty = makeMap('area,base,basefont,br,col,embed,frame,hr,img,input,isindex,keygen,link,meta,param,source,track,wbr');

// Inline Elements
var inline = makeMap('a,abbr,acronym,applet,b,basefont,bdo,big,br,button,cite,code,del,dfn,em,font,i,iframe,img,input,ins,kbd,label,map,noscript,object,q,s,samp,script,select,small,span,strike,strong,sub,sup,svg,textarea,tt,u,var');

// Elements that you can, intentionally, leave open
// (and which close themselves)
var closeSelf = makeMap('colgroup,dd,dt,li,option,p,td,tfoot,th,thead,tr,source');

// Attributes that have their values filled in disabled='disabled'
var fillAttrs = makeMap('checked,compact,declare,defer,disabled,ismap,multiple,nohref,noresize,noshade,nowrap,readonly,selected');

// Special Elements (can contain anything)
var special = makeMap('script,style');

// HTML5 tags https://html.spec.whatwg.org/multipage/indices.html#elements-3
// Phrasing Content https://html.spec.whatwg.org/multipage/dom.html#phrasing-content
var nonPhrasing = makeMap('address,article,aside,base,blockquote,body,caption,col,colgroup,dd,details,dialog,div,dl,dt,fieldset,figcaption,figure,footer,form,h1,h2,h3,h4,h5,h6,head,header,hgroup,hr,html,legend,li,menuitem,meta,ol,optgroup,option,param,rp,rt,source,style,summary,tbody,td,tfoot,th,thead,title,tr,track,ul');

var reCache = {};

function attrForHandler(handler) {
  var pattern = singleAttrIdentifier.source +
    '(?:\\s*(' + joinSingleAttrAssigns(handler) + ')' +
    '[ \\t\\n\\f\\r]*(?:' + singleAttrValues.join('|') + '))?';
  if (handler.customAttrSurround) {
    var attrClauses = [];
    for (var i = handler.customAttrSurround.length - 1; i >= 0; i--) {
      attrClauses[i] = '(?:' +
        '(' + handler.customAttrSurround[i][0].source + ')\\s*' +
        pattern +
        '\\s*(' + handler.customAttrSurround[i][1].source + ')' +
        ')';
    }
    attrClauses.push('(?:' + pattern + ')');
    pattern = '(?:' + attrClauses.join('|') + ')';
  }
  return new RegExp('^\\s*' + pattern);
}

function joinSingleAttrAssigns(handler) {
  return singleAttrAssigns.concat(
    handler.customAttrAssign || []
  ).map(function(assign) {
    return '(?:' + assign.source + ')';
  }).join('|');
}

class HTMLParser$1 {
  constructor(html, handler) {
    this.html = html;
    this.handler = handler;
  }

  async parse() {
    let html = this.html;
    const handler = this.handler;

    var stack = [], lastTag;
    var attribute = attrForHandler(handler);
    var last, prevTag, nextTag;
    while (html) {
      last = html;
      // Make sure we're not in a script or style element
      if (!lastTag || !special(lastTag)) {
        var textEnd = html.indexOf('<');
        if (textEnd === 0) {
          // Comment:
          if (/^<!--/.test(html)) {
            var commentEnd = html.indexOf('-->');

            if (commentEnd >= 0) {
              if (handler.comment) {
                await handler.comment(html.substring(4, commentEnd));
              }
              html = html.substring(commentEnd + 3);
              prevTag = '';
              continue;
            }
          }

          // https://en.wikipedia.org/wiki/Conditional_comment#Downlevel-revealed_conditional_comment
          if (/^<!\[/.test(html)) {
            var conditionalEnd = html.indexOf(']>');

            if (conditionalEnd >= 0) {
              if (handler.comment) {
                await handler.comment(html.substring(2, conditionalEnd + 1), true /* non-standard */);
              }
              html = html.substring(conditionalEnd + 2);
              prevTag = '';
              continue;
            }
          }

          // Doctype:
          var doctypeMatch = html.match(doctype);
          if (doctypeMatch) {
            if (handler.doctype) {
              handler.doctype(doctypeMatch[0]);
            }
            html = html.substring(doctypeMatch[0].length);
            prevTag = '';
            continue;
          }

          // End tag:
          var endTagMatch = html.match(endTag$1);
          if (endTagMatch) {
            html = html.substring(endTagMatch[0].length);
            await replaceAsync(endTagMatch[0], endTag$1, parseEndTag);
            prevTag = '/' + endTagMatch[1].toLowerCase();
            continue;
          }

          // Start tag:
          var startTagMatch = parseStartTag(html);
          if (startTagMatch) {
            html = startTagMatch.rest;
            await handleStartTag(startTagMatch);
            prevTag = startTagMatch.tagName.toLowerCase();
            continue;
          }

          // Treat `<` as text
          if (handler.continueOnParseError) {
            textEnd = html.indexOf('<', 1);
          }
        }

        var text;
        if (textEnd >= 0) {
          text = html.substring(0, textEnd);
          html = html.substring(textEnd);
        }
        else {
          text = html;
          html = '';
        }

        // next tag
        var nextTagMatch = parseStartTag(html);
        if (nextTagMatch) {
          nextTag = nextTagMatch.tagName;
        }
        else {
          nextTagMatch = html.match(endTag$1);
          if (nextTagMatch) {
            nextTag = '/' + nextTagMatch[1];
          }
          else {
            nextTag = '';
          }
        }

        if (handler.chars) {
          await handler.chars(text, prevTag, nextTag);
        }
        prevTag = '';
      }
      else {
        var stackedTag = lastTag.toLowerCase();
        var reStackedTag = reCache[stackedTag] || (reCache[stackedTag] = new RegExp('([\\s\\S]*?)</' + stackedTag + '[^>]*>', 'i'));

        html = await replaceAsync(html, reStackedTag, async(_, text) => {
          if (stackedTag !== 'script' && stackedTag !== 'style' && stackedTag !== 'noscript') {
            text = text
              .replace(/<!--([\s\S]*?)-->/g, '$1')
              .replace(/<!\[CDATA\[([\s\S]*?)]]>/g, '$1');
          }


          if (handler.chars) {
            await handler.chars(text);
          }

          return '';
        });

        await parseEndTag('</' + stackedTag + '>', stackedTag);
      }

      if (html === last) {
        throw new Error('Parse Error: ' + html);
      }
    }

    if (!handler.partialMarkup) {
      // Clean up any remaining tags
      await parseEndTag();
    }

    function parseStartTag(input) {
      var start = input.match(startTagOpen);
      if (start) {
        var match = {
          tagName: start[1],
          attrs: []
        };
        input = input.slice(start[0].length);
        var end, attr;
        while (!(end = input.match(startTagClose)) && (attr = input.match(attribute))) {
          input = input.slice(attr[0].length);
          match.attrs.push(attr);
        }
        if (end) {
          match.unarySlash = end[1];
          match.rest = input.slice(end[0].length);
          return match;
        }
      }
    }

    async function closeIfFound(tagName) {
      if (findTag(tagName) >= 0) {
        await parseEndTag('', tagName);
        return true;
      }
    }

    async function handleStartTag(match) {
      var tagName = match.tagName;
      var unarySlash = match.unarySlash;

      if (handler.html5) {
        if (lastTag === 'p' && nonPhrasing(tagName)) {
          await parseEndTag('', lastTag);
        }
        else if (tagName === 'tbody') {
          await closeIfFound('thead');
        }
        else if (tagName === 'tfoot') {
          if (!await closeIfFound('tbody')) {
            await closeIfFound('thead');
          }
        }
        if (tagName === 'col' && findTag('colgroup') < 0) {
          lastTag = 'colgroup';
          stack.push({ tag: lastTag, attrs: [] });
          if (handler.start) {
            await handler.start(lastTag, [], false, '');
          }
        }
      }

      if (!handler.html5 && !inline(tagName)) {
        while (lastTag && inline(lastTag)) {
          await parseEndTag('', lastTag);
        }
      }

      if (closeSelf(tagName) && lastTag === tagName) {
        await parseEndTag('', tagName);
      }

      var unary = empty(tagName) || tagName === 'html' && lastTag === 'head' || !!unarySlash;

      var attrs = match.attrs.map(function(args) {
        var name, value, customOpen, customClose, customAssign, quote;
        var ncp = 7; // number of captured parts, scalar

        // hackish work around FF bug https://bugzilla.mozilla.org/show_bug.cgi?id=369778
        if (IS_REGEX_CAPTURING_BROKEN && args[0].indexOf('""') === -1) {
          if (args[3] === '') { delete args[3]; }
          if (args[4] === '') { delete args[4]; }
          if (args[5] === '') { delete args[5]; }
        }

        function populate(index) {
          customAssign = args[index];
          value = args[index + 1];
          if (typeof value !== 'undefined') {
            return '"';
          }
          value = args[index + 2];
          if (typeof value !== 'undefined') {
            return '\'';
          }
          value = args[index + 3];
          if (typeof value === 'undefined' && fillAttrs(name)) {
            value = name;
          }
          return '';
        }

        var j = 1;
        if (handler.customAttrSurround) {
          for (var i = 0, l = handler.customAttrSurround.length; i < l; i++, j += ncp) {
            name = args[j + 1];
            if (name) {
              quote = populate(j + 2);
              customOpen = args[j];
              customClose = args[j + 6];
              break;
            }
          }
        }

        if (!name && (name = args[j])) {
          quote = populate(j + 1);
        }

        return {
          name: name,
          value: value,
          customAssign: customAssign || '=',
          customOpen: customOpen || '',
          customClose: customClose || '',
          quote: quote || ''
        };
      });

      if (!unary) {
        stack.push({ tag: tagName, attrs: attrs });
        lastTag = tagName;
        unarySlash = '';
      }

      if (handler.start) {
        await handler.start(tagName, attrs, unary, unarySlash);
      }
    }

    function findTag(tagName) {
      var pos;
      var needle = tagName.toLowerCase();
      for (pos = stack.length - 1; pos >= 0; pos--) {
        if (stack[pos].tag.toLowerCase() === needle) {
          break;
        }
      }
      return pos;
    }

    async function parseEndTag(tag, tagName) {
      var pos;

      // Find the closest opened tag of the same type
      if (tagName) {
        pos = findTag(tagName);
      }
      // If no tag name is provided, clean shop
      else {
        pos = 0;
      }

      if (pos >= 0) {
        // Close all the open elements, up the stack
        for (var i = stack.length - 1; i >= pos; i--) {
          if (handler.end) {
            handler.end(stack[i].tag, stack[i].attrs, i > pos || !tag);
          }
        }

        // Remove the open elements from the stack
        stack.length = pos;
        lastTag = pos && stack[pos - 1].tag;
      }
      else if (tagName.toLowerCase() === 'br') {
        if (handler.start) {
          await handler.start(tagName, [], true, '');
        }
      }
      else if (tagName.toLowerCase() === 'p') {
        if (handler.start) {
          await handler.start(tagName, [], false, '', true);
        }
        if (handler.end) {
          handler.end(tagName, []);
        }
      }
    }
  }
}

htmlparser.HTMLParser = HTMLParser$1;
htmlparser.HTMLtoXML = function(html) {
  var results = '';

  new HTMLParser$1(html, {
    start: function(tag, attrs, unary) {
      results += '<' + tag;

      for (var i = 0, len = attrs.length; i < len; i++) {
        results += ' ' + attrs[i].name + '="' + (attrs[i].value || '').replace(/"/g, '&#34;') + '"';
      }

      results += (unary ? '/' : '') + '>';
    },
    end: function(tag) {
      results += '</' + tag + '>';
    },
    chars: function(text) {
      results += text;
    },
    comment: function(text) {
      results += '<!--' + text + '-->';
    },
    ignore: function(text) {
      results += text;
    }
  });

  return results;
};

htmlparser.HTMLtoDOM = function(html, doc) {
  // There can be only one of these elements
  var one = {
    html: true,
    head: true,
    body: true,
    title: true
  };

  // Enforce a structure for the document
  var structure = {
    link: 'head',
    base: 'head'
  };

  if (doc) {
    doc = doc.ownerDocument || doc.getOwnerDocument && doc.getOwnerDocument() || doc;
  }
  else if (typeof DOMDocument !== 'undefined') {
    doc = new DOMDocument();
  }
  else if (typeof document !== 'undefined' && document.implementation && document.implementation.createDocument) {
    doc = document.implementation.createDocument('', '', null);
  }
  else if (typeof ActiveX !== 'undefined') {
    doc = new ActiveXObject('Msxml.DOMDocument');
  }

  var elems = [],
      documentElement = doc.documentElement ||
      doc.getDocumentElement && doc.getDocumentElement();

  // If we're dealing with an empty document then we
  // need to pre-populate it with the HTML document structure
  if (!documentElement && doc.createElement) {
    (function() {
      var html = doc.createElement('html');
      var head = doc.createElement('head');
      head.appendChild(doc.createElement('title'));
      html.appendChild(head);
      html.appendChild(doc.createElement('body'));
      doc.appendChild(html);
    })();
  }

  // Find all the unique elements
  if (doc.getElementsByTagName) {
    for (var i in one) {
      one[i] = doc.getElementsByTagName(i)[0];
    }
  }

  // If we're working with a document, inject contents into
  // the body element
  var curParentNode = one.body;

  new HTMLParser$1(html, {
    start: function(tagName, attrs, unary) {
      // If it's a pre-built element, then we can ignore
      // its construction
      if (one[tagName]) {
        curParentNode = one[tagName];
        return;
      }

      var elem = doc.createElement(tagName);

      for (var attr in attrs) {
        elem.setAttribute(attrs[attr].name, attrs[attr].value);
      }

      if (structure[tagName] && typeof one[structure[tagName]] !== 'boolean') {
        one[structure[tagName]].appendChild(elem);
      }
      else if (curParentNode && curParentNode.appendChild) {
        curParentNode.appendChild(elem);
      }

      if (!unary) {
        elems.push(elem);
        curParentNode = elem;
      }
    },
    end: function(/* tag */) {
      elems.length -= 1;

      // Init the new parentNode
      curParentNode = elems[elems.length - 1];
    },
    chars: function(text) {
      curParentNode.appendChild(doc.createTextNode(text));
    },
    comment: function(/* text */) {
      // create comment node
    },
    ignore: function(/* text */) {
      // What to do here?
    }
  });

  return doc;
};

htmlparser.endTag = endTag$1;

var constants$5 =
{
	// Output
	ABSOLUTE:      "absolute",
	PATH_RELATIVE: "pathRelative",
	ROOT_RELATIVE: "rootRelative",
	SHORTEST:      "shortest"
};

var constants$4 = constants$5;



function formatAuth(urlObj, options)
{
	if (urlObj.auth && !options.removeAuth && (urlObj.extra.relation.maximumHost || options.output===constants$4.ABSOLUTE))
	{
		return urlObj.auth + "@";
	}
	
	return "";
}



function formatHash(urlObj, options)
{
	return urlObj.hash ? urlObj.hash : "";
}



function formatHost(urlObj, options)
{
	if (urlObj.host.full && (urlObj.extra.relation.maximumAuth || options.output===constants$4.ABSOLUTE))
	{
		return urlObj.host.full;
	}
	
	return "";
}



function formatPath(urlObj, options)
{
	var str = "";
	
	var absolutePath = urlObj.path.absolute.string;
	var relativePath = urlObj.path.relative.string;
	var resource = showResource(urlObj, options);
	
	if (urlObj.extra.relation.maximumHost || options.output===constants$4.ABSOLUTE || options.output===constants$4.ROOT_RELATIVE)
	{
		str = absolutePath;
	}
	else if (relativePath.length<=absolutePath.length && options.output===constants$4.SHORTEST || options.output===constants$4.PATH_RELATIVE)
	{
		str = relativePath;
		
		if (str === "")
		{
			var query = showQuery(urlObj,options) && !!getQuery(urlObj,options);
			
			if (urlObj.extra.relation.maximumPath && !resource)
			{
				str = "./";
			}
			else if (urlObj.extra.relation.overridesQuery && !resource && !query)
			{
				str = "./";
			}
		}
	}
	else
	{
		str = absolutePath;
	}
	
	if ( str==="/" && !resource && options.removeRootTrailingSlash && (!urlObj.extra.relation.minimumPort || options.output===constants$4.ABSOLUTE) )
	{
		str = "";
	}
	
	return str;
}



function formatPort(urlObj, options)
{
	if (urlObj.port && !urlObj.extra.portIsDefault && urlObj.extra.relation.maximumHost)
	{
		return ":" + urlObj.port;
	}
	
	return "";
}



function formatQuery(urlObj, options)
{
	return showQuery(urlObj,options) ? getQuery(urlObj, options) : "";
}



function formatResource(urlObj, options)
{
	return showResource(urlObj,options) ? urlObj.resource : "";
}



function formatScheme(urlObj, options)
{
	var str = "";
	
	if (urlObj.extra.relation.maximumHost || options.output===constants$4.ABSOLUTE)
	{
		if (!urlObj.extra.relation.minimumScheme || !options.schemeRelative || options.output===constants$4.ABSOLUTE)
		{
			str += urlObj.scheme + "://";
		}
		else
		{
			str += "//";
		}
	}
	
	return str;
}



function formatUrl$1(urlObj, options)
{
	var url = "";
	
	url += formatScheme(urlObj, options);
	url += formatAuth(urlObj, options);
	url += formatHost(urlObj, options);
	url += formatPort(urlObj);
	url += formatPath(urlObj, options);
	url += formatResource(urlObj, options);
	url += formatQuery(urlObj, options);
	url += formatHash(urlObj);
	
	return url;
}



function getQuery(urlObj, options)
{
	var stripQuery = options.removeEmptyQueries && urlObj.extra.relation.minimumPort;
	
	return urlObj.query.string[ stripQuery ? "stripped" : "full" ];
}



function showQuery(urlObj, options)
{
	return !urlObj.extra.relation.minimumQuery || options.output===constants$4.ABSOLUTE || options.output===constants$4.ROOT_RELATIVE;
}



function showResource(urlObj, options)
{
	var removeIndex = options.removeDirectoryIndexes && urlObj.extra.resourceIsIndex;
	var removeMatchingResource = urlObj.extra.relation.minimumResource && options.output!==constants$4.ABSOLUTE && options.output!==constants$4.ROOT_RELATIVE;
	
	return !!urlObj.resource && !removeMatchingResource && !removeIndex;
}



var format = formatUrl$1;

/*
	Deep-clone an object.
*/
function clone$1(obj)
{
	if (obj instanceof Object)
	{
		var clonedObj = (obj instanceof Array) ? [] : {};
		
		for (var i in obj)
		{
			if ( obj.hasOwnProperty(i) )
			{
				clonedObj[i] = clone$1( obj[i] );
			}
		}
		
		return clonedObj;
	}
	
	return obj;
}



/*
	https://github.com/jonschlinkert/is-plain-object
*/
function isPlainObject(obj)
{
	return !!obj && typeof obj==="object" && obj.constructor===Object;
}



/*
	Shallow-merge two objects.
*/
function shallowMerge(target, source)
{
	if (target instanceof Object && source instanceof Object)
	{
		for (var i in source)
		{
			if ( source.hasOwnProperty(i) )
			{
				target[i] = source[i];
			}
		}
	}
	
	return target;
}



var object =
{
	clone: clone$1,
	isPlainObject: isPlainObject,
	shallowMerge: shallowMerge
};

var objUtils$2 = object;



function getOptions$2(options, defaults)
{
	if ( objUtils$2.isPlainObject(options) )
	{
		var newOptions = {};
		
		for (var i in defaults)
		{
			if ( defaults.hasOwnProperty(i) )
			{
				if (options[i] !== undefined)
				{
					newOptions[i] = mergeOption(options[i], defaults[i]);
				}
				else
				{
					newOptions[i] = defaults[i];
				}
			}
		}
		
		return newOptions;
	}
	else
	{
		return defaults;
	}
}



function mergeOption(newValues, defaultValues)
{
	if (defaultValues instanceof Object && newValues instanceof Object)
	{
		if (defaultValues instanceof Array && newValues instanceof Array)
		{
			return defaultValues.concat(newValues);
		}
		else
		{
			return objUtils$2.shallowMerge(newValues, defaultValues);
		}
	}
	
	return newValues;
}



var options$3 = getOptions$2;

function hrefInfo$1(urlObj)
{
	var minimumPathOnly     = (!urlObj.scheme && !urlObj.auth && !urlObj.host.full && !urlObj.port);
	var minimumResourceOnly = (minimumPathOnly && !urlObj.path.absolute.string);
	var minimumQueryOnly    = (minimumResourceOnly && !urlObj.resource);
	var minimumHashOnly     = (minimumQueryOnly && !urlObj.query.string.full.length);
	var empty               = (minimumHashOnly && !urlObj.hash);
	
	urlObj.extra.hrefInfo.minimumPathOnly     = minimumPathOnly;
	urlObj.extra.hrefInfo.minimumResourceOnly = minimumResourceOnly;
	urlObj.extra.hrefInfo.minimumQueryOnly    = minimumQueryOnly;
	urlObj.extra.hrefInfo.minimumHashOnly     = minimumHashOnly;
	urlObj.extra.hrefInfo.empty = empty;
}



var hrefInfo_1 = hrefInfo$1;

function parseHost$1(urlObj, options)
{
	// TWEAK :: condition only for speed optimization
	if (options.ignore_www)
	{
		var host = urlObj.host.full;
		
		if (host)
		{
			var stripped = host;
			
			if (host.indexOf("www.") === 0)
			{
				stripped = host.substr(4);
			}
			
			urlObj.host.stripped = stripped;
		}
	}
}



var host = parseHost$1;

function isDirectoryIndex(resource, options)
{
	var verdict = false;
	
	options.directoryIndexes.every( function(index)
	{
		if (index === resource)
		{
			verdict = true;
			return false;
		}
		
		return true;
	});
	
	return verdict;
}



function parsePath$1(urlObj, options)
{
	var path = urlObj.path.absolute.string;
	
	if (path)
	{
		var lastSlash = path.lastIndexOf("/");
		
		if (lastSlash > -1)
		{
			if (++lastSlash < path.length)
			{
				var resource = path.substr(lastSlash);
				
				if (resource!=="." && resource!=="..")
				{
					urlObj.resource = resource;
					path = path.substr(0, lastSlash);
				}
				else
				{
					path += "/";
				}
			}
			
			urlObj.path.absolute.string = path;
			urlObj.path.absolute.array = splitPath(path);
		}
		else if (path==="." || path==="..")
		{
			// "..?var", "..#anchor", etc ... not "..index.html"
			path += "/";
			
			urlObj.path.absolute.string = path;
			urlObj.path.absolute.array = splitPath(path);
		}
		else
		{
			// Resource-only
			urlObj.resource = path;
			urlObj.path.absolute.string = null;
		}
		
		urlObj.extra.resourceIsIndex = isDirectoryIndex(urlObj.resource, options);
	}
	// Else: query/hash-only or empty
}



function splitPath(path)
{
	// TWEAK :: condition only for speed optimization
	if (path !== "/")
	{
		var cleaned = [];
		
		path.split("/").forEach( function(dir)
		{
			// Cleanup -- splitting "/dir/" becomes ["","dir",""]
			if (dir !== "")
			{
				cleaned.push(dir);
			}
		});
		
		return cleaned;
	}
	else
	{
		// Faster to skip the above block and just create an array
		return [];
	}
}



var path$8 = parsePath$1;

function parsePort$1(urlObj, options)
{
	var defaultPort = -1;
	
	for (var i in options.defaultPorts)
	{
		if ( i===urlObj.scheme && options.defaultPorts.hasOwnProperty(i) )
		{
			defaultPort = options.defaultPorts[i];
			break;
		}
	}
	
	if (defaultPort > -1)
	{
		// Force same type as urlObj.port
		defaultPort = defaultPort.toString();
		
		if (urlObj.port === null)
		{
			urlObj.port = defaultPort;
		}
		
		urlObj.extra.portIsDefault = (urlObj.port === defaultPort);
	}
}



var port = parsePort$1;

var hasOwnProperty$3 = Object.prototype.hasOwnProperty;



function parseQuery$1(urlObj, options)
{
	urlObj.query.string.full = stringify(urlObj.query.object, false);
	
	// TWEAK :: condition only for speed optimization
	if (options.removeEmptyQueries)
	{
		urlObj.query.string.stripped = stringify(urlObj.query.object, true);
	}
}



function stringify(queryObj, removeEmptyQueries)
{
	var count = 0;
	var str = "";
	
	for (var i in queryObj)
	{
		if ( i!=="" && hasOwnProperty$3.call(queryObj, i)===true )
		{
			var value = queryObj[i];
			
			if (value !== "" || !removeEmptyQueries)
			{
				str += (++count===1) ? "?" : "&";
				
				i = encodeURIComponent(i);
				
				if (value !== "")
				{
					str += i +"="+ encodeURIComponent(value).replace(/%20/g,"+");
				}
				else
				{
					str += i;
				}
			}
		}
	}
	
	return str;
}



var query = parseQuery$1;

var _parseUrl = require$$1__default["default"].parse;



/*
	Customize the URL object that Node generates
	because:
	
	* necessary data for later
	* urlObj.host is useless
	* urlObj.hostname is too long
	* urlObj.path is useless
	* urlObj.pathname is too long
	* urlObj.protocol is inaccurate; should be called "scheme"
	* urlObj.search is mostly useless
*/
function clean(urlObj)
{
	var scheme = urlObj.protocol;
	
	if (scheme)
	{
		// Remove ":" suffix
		if (scheme.indexOf(":") === scheme.length-1)
		{
			scheme = scheme.substr(0, scheme.length-1);
		}
	}
	
	urlObj.host =
	{
		// TODO :: unescape(encodeURIComponent(s)) ? ... http://ecmanaut.blogspot.ca/2006/07/encoding-decoding-utf8-in-javascript.html
		full: urlObj.hostname,
		stripped: null
	};
	
	urlObj.path =
	{
		absolute:
		{
			array: null,
			string: urlObj.pathname
		},
		relative:
		{
			array: null,
			string: null
		}
	};
	
	urlObj.query =
	{
		object: urlObj.query,
		string:
		{
			full: null,
			stripped: null
		}
	};
	
	urlObj.extra =
	{
		hrefInfo:
		{
			minimumPathOnly: null,
			minimumResourceOnly: null,
			minimumQueryOnly: null,
			minimumHashOnly: null,
			empty: null,
			
			separatorOnlyQuery: urlObj.search==="?"
		},
		portIsDefault: null,
		relation:
		{
			maximumScheme: null,
			maximumAuth: null,
			maximumHost: null,
			maximumPort: null,
			maximumPath: null,
			maximumResource: null,
			maximumQuery: null,
			maximumHash: null,
			
			minimumScheme: null,
			minimumAuth: null,
			minimumHost: null,
			minimumPort: null,
			minimumPath: null,
			minimumResource: null,
			minimumQuery: null,
			minimumHash: null,
			
			overridesQuery: null
		},
		resourceIsIndex: null,
		slashes: urlObj.slashes
	};
	
	urlObj.resource = null;
	urlObj.scheme = scheme;
	delete urlObj.hostname;
	delete urlObj.pathname;
	delete urlObj.protocol;
	delete urlObj.search;
	delete urlObj.slashes;
	
	return urlObj;
}



function validScheme(url, options)
{
	var valid = true;
	
	options.rejectedSchemes.every( function(rejectedScheme)
	{
		valid = !(url.indexOf(rejectedScheme+":") === 0);
		
		// Break loop
		return valid;
	});
	
	return valid;
}



function parseUrlString$1(url, options)
{
	if ( validScheme(url,options) )
	{
		return clean( _parseUrl(url, true, options.slashesDenoteHost) );
	}
	else
	{
		return {href:url, valid:false};
	}
}



var urlstring = parseUrlString$1;

function joinPath(pathArray)
{
	if (pathArray.length > 0)
	{
		return pathArray.join("/") + "/";
	}
	else
	{
		return "";
	}
}



function resolveDotSegments(pathArray)
{
	var pathAbsolute = [];
	
	pathArray.forEach( function(dir)
	{
		if (dir !== "..")
		{
			if (dir !== ".")
			{
				pathAbsolute.push(dir);
			}
		}
		else
		{
			// Remove parent
			if (pathAbsolute.length > 0)
			{
				pathAbsolute.splice(pathAbsolute.length-1, 1);
			}
		}
	});
	
	return pathAbsolute;
}



var path$7 =
{
	join: joinPath,
	resolveDotSegments: resolveDotSegments
};

var hrefInfo   = hrefInfo_1;
var parseHost  = host;
var parsePath  = path$8;
var parsePort  = port;
var parseQuery = query;
var parseUrlString = urlstring;
var pathUtils$2      = path$7;



function parseFromUrl(url, options, fallback)
{
	if (url)
	{
		var urlObj = parseUrl$1(url, options);
		
		// Because the following occurs in the relate stage for "to" URLs,
		// such had to be mostly duplicated here
		
		var pathArray = pathUtils$2.resolveDotSegments(urlObj.path.absolute.array);
		
		urlObj.path.absolute.array  = pathArray;
		urlObj.path.absolute.string = "/" + pathUtils$2.join(pathArray);
		
		return urlObj;
	}
	else
	{
		return fallback;
	}
}



function parseUrl$1(url, options)
{
	var urlObj = parseUrlString(url, options);
	
	if (urlObj.valid===false) return urlObj;
	
	parseHost(urlObj, options);
	parsePort(urlObj, options);
	parsePath(urlObj, options);
	parseQuery(urlObj, options);
	hrefInfo(urlObj);
	
	return urlObj;
}



var parse$5 =
{
	from: parseFromUrl,
	to:   parseUrl$1
};

function findRelation_upToPath(urlObj, siteUrlObj, options)
{
	// Path- or root-relative URL
	var pathOnly = urlObj.extra.hrefInfo.minimumPathOnly;
	
	// Matching scheme, scheme-relative or path-only
	var minimumScheme = (urlObj.scheme===siteUrlObj.scheme || !urlObj.scheme);
	
	// Matching auth, ignoring auth or path-only
	var minimumAuth = minimumScheme && (urlObj.auth===siteUrlObj.auth || options.removeAuth || pathOnly);
	
	// Matching host or path-only
	var www = options.ignore_www ? "stripped" : "full";
	var minimumHost = minimumAuth && (urlObj.host[www]===siteUrlObj.host[www] || pathOnly);
	
	// Matching port or path-only
	var minimumPort = minimumHost && (urlObj.port===siteUrlObj.port || pathOnly);
	
	urlObj.extra.relation.minimumScheme = minimumScheme;
	urlObj.extra.relation.minimumAuth   = minimumAuth;
	urlObj.extra.relation.minimumHost   = minimumHost;
	urlObj.extra.relation.minimumPort   = minimumPort;
	
	urlObj.extra.relation.maximumScheme = !minimumScheme || minimumScheme && !minimumAuth;
	urlObj.extra.relation.maximumAuth   = !minimumScheme || minimumScheme && !minimumHost;
	urlObj.extra.relation.maximumHost   = !minimumScheme || minimumScheme && !minimumPort;
}



function findRelation_pathOn(urlObj, siteUrlObj, options)
{
	var queryOnly = urlObj.extra.hrefInfo.minimumQueryOnly;
	var hashOnly  = urlObj.extra.hrefInfo.minimumHashOnly;
	var empty     = urlObj.extra.hrefInfo.empty;	// not required, but self-documenting
	
	// From upToPath()
	var minimumPort   = urlObj.extra.relation.minimumPort;
	var minimumScheme = urlObj.extra.relation.minimumScheme;
	
	// Matching port and path
	var minimumPath = minimumPort && urlObj.path.absolute.string===siteUrlObj.path.absolute.string;
	
	// Matching resource or query/hash-only or empty
	var matchingResource = (urlObj.resource===siteUrlObj.resource || !urlObj.resource && siteUrlObj.extra.resourceIsIndex) || (options.removeDirectoryIndexes && urlObj.extra.resourceIsIndex && !siteUrlObj.resource);
	var minimumResource = minimumPath && (matchingResource || queryOnly || hashOnly || empty);
	
	// Matching query or hash-only/empty
	var query = options.removeEmptyQueries ? "stripped" : "full";
	var urlQuery = urlObj.query.string[query];
	var siteUrlQuery = siteUrlObj.query.string[query];
	var minimumQuery = (minimumResource && !!urlQuery && urlQuery===siteUrlQuery) || ((hashOnly || empty) && !urlObj.extra.hrefInfo.separatorOnlyQuery);
	
	var minimumHash = minimumQuery && urlObj.hash===siteUrlObj.hash;
	
	urlObj.extra.relation.minimumPath     = minimumPath;
	urlObj.extra.relation.minimumResource = minimumResource;
	urlObj.extra.relation.minimumQuery    = minimumQuery;
	urlObj.extra.relation.minimumHash     = minimumHash;
	
	urlObj.extra.relation.maximumPort     = !minimumScheme || minimumScheme && !minimumPath;
	urlObj.extra.relation.maximumPath     = !minimumScheme || minimumScheme && !minimumResource;
	urlObj.extra.relation.maximumResource = !minimumScheme || minimumScheme && !minimumQuery;
	urlObj.extra.relation.maximumQuery    = !minimumScheme || minimumScheme && !minimumHash;
	urlObj.extra.relation.maximumHash     = !minimumScheme || minimumScheme && !minimumHash;	// there's nothing after hash, so it's the same as maximumQuery
	
	// Matching path and/or resource with existing but non-matching site query
	urlObj.extra.relation.overridesQuery  = minimumPath && urlObj.extra.relation.maximumResource && !minimumQuery && !!siteUrlQuery;
}



var findRelation$1 =
{
	pathOn:   findRelation_pathOn,
	upToPath: findRelation_upToPath
};

var findRelation = findRelation$1;
var objUtils$1     = object;
var pathUtils$1    = path$7;



function absolutize$1(urlObj, siteUrlObj, options)
{
	findRelation.upToPath(urlObj, siteUrlObj, options);
	
	// Fill in relative URLs
	if (urlObj.extra.relation.minimumScheme) urlObj.scheme = siteUrlObj.scheme;
	if (urlObj.extra.relation.minimumAuth)   urlObj.auth   = siteUrlObj.auth;
	if (urlObj.extra.relation.minimumHost)   urlObj.host   = objUtils$1.clone(siteUrlObj.host);
	if (urlObj.extra.relation.minimumPort)   copyPort(urlObj, siteUrlObj);
	if (urlObj.extra.relation.minimumScheme) copyPath(urlObj, siteUrlObj);
	
	// Check remaining relativeness now that path has been copied and/or resolved
	findRelation.pathOn(urlObj, siteUrlObj, options);
	
	// Fill in relative URLs
	if (urlObj.extra.relation.minimumResource) copyResource(urlObj, siteUrlObj);
	if (urlObj.extra.relation.minimumQuery)    urlObj.query = objUtils$1.clone(siteUrlObj.query);
	if (urlObj.extra.relation.minimumHash)     urlObj.hash  = siteUrlObj.hash;
}



/*
	Get an absolute path that's relative to site url.
*/
function copyPath(urlObj, siteUrlObj)
{
	if (urlObj.extra.relation.maximumHost || !urlObj.extra.hrefInfo.minimumResourceOnly)
	{
		var pathArray = urlObj.path.absolute.array;
		var pathString = "/";
		
		// If not erroneous URL
		if (pathArray)
		{
			// If is relative path
			if (urlObj.extra.hrefInfo.minimumPathOnly && urlObj.path.absolute.string.indexOf("/")!==0)
			{
				// Append path to site path
				pathArray = siteUrlObj.path.absolute.array.concat(pathArray);
			}
			
			pathArray   = pathUtils$1.resolveDotSegments(pathArray);
			pathString += pathUtils$1.join(pathArray);
		}
		else
		{
			pathArray = [];
		}
		
		urlObj.path.absolute.array  = pathArray;
		urlObj.path.absolute.string = pathString;
	}
	else
	{
		// Resource-, query- or hash-only or empty
		urlObj.path = objUtils$1.clone(siteUrlObj.path);
	}
}



function copyPort(urlObj, siteUrlObj)
{
	urlObj.port = siteUrlObj.port;
	
	urlObj.extra.portIsDefault = siteUrlObj.extra.portIsDefault;
}



function copyResource(urlObj, siteUrlObj)
{
	urlObj.resource = siteUrlObj.resource;
	
	urlObj.extra.resourceIsIndex = siteUrlObj.extra.resourceIsIndex;
}



var absolutize_1 = absolutize$1;

var pathUtils = path$7;



/*
	Get a path relative to the site path.
*/
function relatePath(absolutePath, siteAbsolutePath)
{
	var relativePath = [];
	
	// At this point, it's related to the host/port
	var related = true;
	var parentIndex = -1;
	
	// Find parents
	siteAbsolutePath.forEach( function(siteAbsoluteDir, i)
	{
		if (related)
		{
			if (absolutePath[i] !== siteAbsoluteDir)
			{
				related = false;
			}
			else
			{
				parentIndex = i;
			}
		}
		
		if (!related)
		{
			// Up one level
			relativePath.push("..");
		}
	});
	
	// Form path
	absolutePath.forEach( function(dir, i)
	{
		if (i > parentIndex)
		{
			relativePath.push(dir);
		}
	});
	
	return relativePath;
}



function relativize$1(urlObj, siteUrlObj, options)
{
	if (urlObj.extra.relation.minimumScheme)
	{
		var pathArray = relatePath(urlObj.path.absolute.array, siteUrlObj.path.absolute.array);
		
		urlObj.path.relative.array  = pathArray;
		urlObj.path.relative.string = pathUtils.join(pathArray);
	}
}



var relativize_1 = relativize$1;

var absolutize = absolutize_1;
var relativize = relativize_1;



function relateUrl$1(siteUrlObj, urlObj, options)
{
	absolutize(urlObj, siteUrlObj, options);
	relativize(urlObj, siteUrlObj);
	
	return urlObj;
}



var relate = relateUrl$1;

var constants$3  = constants$5;
var formatUrl  = format;
var getOptions$1 = options$3;
var objUtils   = object;
var parseUrl   = parse$5;
var relateUrl  = relate;



function RelateUrl$1(from, options)
{
	this.options = getOptions$1(options,
	{
		defaultPorts: {ftp:21, http:80, https:443},
		directoryIndexes: ["index.html"],
		ignore_www: false,
		output: RelateUrl$1.SHORTEST,
		rejectedSchemes: ["data","javascript","mailto"],
		removeAuth: false,
		removeDirectoryIndexes: true,
		removeEmptyQueries: false,
		removeRootTrailingSlash: true,
		schemeRelative: true,
		site: undefined,
		slashesDenoteHost: true
	});
	
	this.from = parseUrl.from(from, this.options, null);
}



/*
	Usage: instance=new RelateUrl(); instance.relate();
*/
RelateUrl$1.prototype.relate = function(from, to, options)
{
	// relate(to,options)
	if ( objUtils.isPlainObject(to) )
	{
		options = to;
		to = from;
		from = null;
	}
	// relate(to)
	else if (!to)
	{
		to = from;
		from = null;
	}
	
	options = getOptions$1(options, this.options);
	from = from || options.site;
	from = parseUrl.from(from, options, this.from);
	
	if (!from || !from.href)
	{
		throw new Error("from value not defined.");
	}
	else if (from.extra.hrefInfo.minimumPathOnly)
	{
		throw new Error("from value supplied is not absolute: "+from.href);
	}
	
	to = parseUrl.to(to, options);
	
	if (to.valid===false) return to.href;
	
	to = relateUrl(from, to, options);
	to = formatUrl(to, options);
	
	return to;
};



/*
	Usage: RelateUrl.relate();
*/
RelateUrl$1.relate = function(from, to, options)
{
	return new RelateUrl$1().relate(from, to, options);
};



// Make constants accessible from API
objUtils.shallowMerge(RelateUrl$1, constants$3);



var lib$k = RelateUrl$1;

function Sorter() {
}

Sorter.prototype.sort = function(tokens, fromIndex) {
  fromIndex = fromIndex || 0;
  for (var i = 0, len = this.keys.length; i < len; i++) {
    var key = this.keys[i];
    var token = key.slice(1);
    var index = tokens.indexOf(token, fromIndex);
    if (index !== -1) {
      do {
        if (index !== fromIndex) {
          tokens.splice(index, 1);
          tokens.splice(fromIndex, 0, token);
        }
        fromIndex++;
      } while ((index = tokens.indexOf(token, fromIndex)) !== -1);
      return this[key].sort(tokens, fromIndex);
    }
  }
  return tokens;
};

function TokenChain$1() {
}

TokenChain$1.prototype = {
  add: function(tokens) {
    var self = this;
    tokens.forEach(function(token) {
      var key = '$' + token;
      if (!self[key]) {
        self[key] = [];
        self[key].processed = 0;
      }
      self[key].push(tokens);
    });
  },
  createSorter: function() {
    var self = this;
    var sorter = new Sorter();
    sorter.keys = Object.keys(self).sort(function(j, k) {
      var m = self[j].length;
      var n = self[k].length;
      return m < n ? 1 : m > n ? -1 : j < k ? -1 : j > k ? 1 : 0;
    }).filter(function(key) {
      if (self[key].processed < self[key].length) {
        var token = key.slice(1);
        var chain = new TokenChain$1();
        self[key].forEach(function(tokens) {
          var index;
          while ((index = tokens.indexOf(token)) !== -1) {
            tokens.splice(index, 1);
          }
          tokens.forEach(function(token) {
            self['$' + token].processed++;
          });
          chain.add(tokens.slice(0));
        });
        sorter[key] = chain.createSorter();
        return true;
      }
      return false;
    });
    return sorter;
  }
};

var tokenchain = TokenChain$1;

var bundle_min = {exports: {}};

var sourceMap$1 = {};

var traceMapping_umd = {exports: {}};

var sourcemapCodec_umd = {exports: {}};

sourcemapCodec_umd.exports;

var hasRequiredSourcemapCodec_umd;

function requireSourcemapCodec_umd () {
	if (hasRequiredSourcemapCodec_umd) return sourcemapCodec_umd.exports;
	hasRequiredSourcemapCodec_umd = 1;
	(function (module, exports) {
		(function (global, factory) {
		    factory(exports) ;
		})(commonjsGlobal, (function (exports) {
		    const comma = ','.charCodeAt(0);
		    const semicolon = ';'.charCodeAt(0);
		    const chars = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
		    const intToChar = new Uint8Array(64); // 64 possible chars.
		    const charToInt = new Uint8Array(128); // z is 122 in ASCII
		    for (let i = 0; i < chars.length; i++) {
		        const c = chars.charCodeAt(i);
		        intToChar[i] = c;
		        charToInt[c] = i;
		    }
		    // Provide a fallback for older environments.
		    const td = typeof TextDecoder !== 'undefined'
		        ? /* #__PURE__ */ new TextDecoder()
		        : typeof Buffer !== 'undefined'
		            ? {
		                decode(buf) {
		                    const out = Buffer.from(buf.buffer, buf.byteOffset, buf.byteLength);
		                    return out.toString();
		                },
		            }
		            : {
		                decode(buf) {
		                    let out = '';
		                    for (let i = 0; i < buf.length; i++) {
		                        out += String.fromCharCode(buf[i]);
		                    }
		                    return out;
		                },
		            };
		    function decode(mappings) {
		        const state = new Int32Array(5);
		        const decoded = [];
		        let index = 0;
		        do {
		            const semi = indexOf(mappings, index);
		            const line = [];
		            let sorted = true;
		            let lastCol = 0;
		            state[0] = 0;
		            for (let i = index; i < semi; i++) {
		                let seg;
		                i = decodeInteger(mappings, i, state, 0); // genColumn
		                const col = state[0];
		                if (col < lastCol)
		                    sorted = false;
		                lastCol = col;
		                if (hasMoreVlq(mappings, i, semi)) {
		                    i = decodeInteger(mappings, i, state, 1); // sourcesIndex
		                    i = decodeInteger(mappings, i, state, 2); // sourceLine
		                    i = decodeInteger(mappings, i, state, 3); // sourceColumn
		                    if (hasMoreVlq(mappings, i, semi)) {
		                        i = decodeInteger(mappings, i, state, 4); // namesIndex
		                        seg = [col, state[1], state[2], state[3], state[4]];
		                    }
		                    else {
		                        seg = [col, state[1], state[2], state[3]];
		                    }
		                }
		                else {
		                    seg = [col];
		                }
		                line.push(seg);
		            }
		            if (!sorted)
		                sort(line);
		            decoded.push(line);
		            index = semi + 1;
		        } while (index <= mappings.length);
		        return decoded;
		    }
		    function indexOf(mappings, index) {
		        const idx = mappings.indexOf(';', index);
		        return idx === -1 ? mappings.length : idx;
		    }
		    function decodeInteger(mappings, pos, state, j) {
		        let value = 0;
		        let shift = 0;
		        let integer = 0;
		        do {
		            const c = mappings.charCodeAt(pos++);
		            integer = charToInt[c];
		            value |= (integer & 31) << shift;
		            shift += 5;
		        } while (integer & 32);
		        const shouldNegate = value & 1;
		        value >>>= 1;
		        if (shouldNegate) {
		            value = -0x80000000 | -value;
		        }
		        state[j] += value;
		        return pos;
		    }
		    function hasMoreVlq(mappings, i, length) {
		        if (i >= length)
		            return false;
		        return mappings.charCodeAt(i) !== comma;
		    }
		    function sort(line) {
		        line.sort(sortComparator);
		    }
		    function sortComparator(a, b) {
		        return a[0] - b[0];
		    }
		    function encode(decoded) {
		        const state = new Int32Array(5);
		        const bufLength = 1024 * 16;
		        const subLength = bufLength - 36;
		        const buf = new Uint8Array(bufLength);
		        const sub = buf.subarray(0, subLength);
		        let pos = 0;
		        let out = '';
		        for (let i = 0; i < decoded.length; i++) {
		            const line = decoded[i];
		            if (i > 0) {
		                if (pos === bufLength) {
		                    out += td.decode(buf);
		                    pos = 0;
		                }
		                buf[pos++] = semicolon;
		            }
		            if (line.length === 0)
		                continue;
		            state[0] = 0;
		            for (let j = 0; j < line.length; j++) {
		                const segment = line[j];
		                // We can push up to 5 ints, each int can take at most 7 chars, and we
		                // may push a comma.
		                if (pos > subLength) {
		                    out += td.decode(sub);
		                    buf.copyWithin(0, subLength, pos);
		                    pos -= subLength;
		                }
		                if (j > 0)
		                    buf[pos++] = comma;
		                pos = encodeInteger(buf, pos, state, segment, 0); // genColumn
		                if (segment.length === 1)
		                    continue;
		                pos = encodeInteger(buf, pos, state, segment, 1); // sourcesIndex
		                pos = encodeInteger(buf, pos, state, segment, 2); // sourceLine
		                pos = encodeInteger(buf, pos, state, segment, 3); // sourceColumn
		                if (segment.length === 4)
		                    continue;
		                pos = encodeInteger(buf, pos, state, segment, 4); // namesIndex
		            }
		        }
		        return out + td.decode(buf.subarray(0, pos));
		    }
		    function encodeInteger(buf, pos, state, segment, j) {
		        const next = segment[j];
		        let num = next - state[j];
		        state[j] = next;
		        num = num < 0 ? (-num << 1) | 1 : num << 1;
		        do {
		            let clamped = num & 0b011111;
		            num >>>= 5;
		            if (num > 0)
		                clamped |= 0b100000;
		            buf[pos++] = intToChar[clamped];
		        } while (num > 0);
		        return pos;
		    }

		    exports.decode = decode;
		    exports.encode = encode;

		    Object.defineProperty(exports, '__esModule', { value: true });

		}));
		
	} (sourcemapCodec_umd, sourcemapCodec_umd.exports));
	return sourcemapCodec_umd.exports;
}

var resolveUri_umd = {exports: {}};

resolveUri_umd.exports;

var hasRequiredResolveUri_umd;

function requireResolveUri_umd () {
	if (hasRequiredResolveUri_umd) return resolveUri_umd.exports;
	hasRequiredResolveUri_umd = 1;
	(function (module, exports) {
		(function (global, factory) {
		    module.exports = factory() ;
		})(commonjsGlobal, (function () {
		    // Matches the scheme of a URL, eg "http://"
		    const schemeRegex = /^[\w+.-]+:\/\//;
		    /**
		     * Matches the parts of a URL:
		     * 1. Scheme, including ":", guaranteed.
		     * 2. User/password, including "@", optional.
		     * 3. Host, guaranteed.
		     * 4. Port, including ":", optional.
		     * 5. Path, including "/", optional.
		     * 6. Query, including "?", optional.
		     * 7. Hash, including "#", optional.
		     */
		    const urlRegex = /^([\w+.-]+:)\/\/([^@/#?]*@)?([^:/#?]*)(:\d+)?(\/[^#?]*)?(\?[^#]*)?(#.*)?/;
		    /**
		     * File URLs are weird. They dont' need the regular `//` in the scheme, they may or may not start
		     * with a leading `/`, they can have a domain (but only if they don't start with a Windows drive).
		     *
		     * 1. Host, optional.
		     * 2. Path, which may include "/", guaranteed.
		     * 3. Query, including "?", optional.
		     * 4. Hash, including "#", optional.
		     */
		    const fileRegex = /^file:(?:\/\/((?![a-z]:)[^/#?]*)?)?(\/?[^#?]*)(\?[^#]*)?(#.*)?/i;
		    function isAbsoluteUrl(input) {
		        return schemeRegex.test(input);
		    }
		    function isSchemeRelativeUrl(input) {
		        return input.startsWith('//');
		    }
		    function isAbsolutePath(input) {
		        return input.startsWith('/');
		    }
		    function isFileUrl(input) {
		        return input.startsWith('file:');
		    }
		    function isRelative(input) {
		        return /^[.?#]/.test(input);
		    }
		    function parseAbsoluteUrl(input) {
		        const match = urlRegex.exec(input);
		        return makeUrl(match[1], match[2] || '', match[3], match[4] || '', match[5] || '/', match[6] || '', match[7] || '');
		    }
		    function parseFileUrl(input) {
		        const match = fileRegex.exec(input);
		        const path = match[2];
		        return makeUrl('file:', '', match[1] || '', '', isAbsolutePath(path) ? path : '/' + path, match[3] || '', match[4] || '');
		    }
		    function makeUrl(scheme, user, host, port, path, query, hash) {
		        return {
		            scheme,
		            user,
		            host,
		            port,
		            path,
		            query,
		            hash,
		            type: 7 /* Absolute */,
		        };
		    }
		    function parseUrl(input) {
		        if (isSchemeRelativeUrl(input)) {
		            const url = parseAbsoluteUrl('http:' + input);
		            url.scheme = '';
		            url.type = 6 /* SchemeRelative */;
		            return url;
		        }
		        if (isAbsolutePath(input)) {
		            const url = parseAbsoluteUrl('http://foo.com' + input);
		            url.scheme = '';
		            url.host = '';
		            url.type = 5 /* AbsolutePath */;
		            return url;
		        }
		        if (isFileUrl(input))
		            return parseFileUrl(input);
		        if (isAbsoluteUrl(input))
		            return parseAbsoluteUrl(input);
		        const url = parseAbsoluteUrl('http://foo.com/' + input);
		        url.scheme = '';
		        url.host = '';
		        url.type = input
		            ? input.startsWith('?')
		                ? 3 /* Query */
		                : input.startsWith('#')
		                    ? 2 /* Hash */
		                    : 4 /* RelativePath */
		            : 1 /* Empty */;
		        return url;
		    }
		    function stripPathFilename(path) {
		        // If a path ends with a parent directory "..", then it's a relative path with excess parent
		        // paths. It's not a file, so we can't strip it.
		        if (path.endsWith('/..'))
		            return path;
		        const index = path.lastIndexOf('/');
		        return path.slice(0, index + 1);
		    }
		    function mergePaths(url, base) {
		        normalizePath(base, base.type);
		        // If the path is just a "/", then it was an empty path to begin with (remember, we're a relative
		        // path).
		        if (url.path === '/') {
		            url.path = base.path;
		        }
		        else {
		            // Resolution happens relative to the base path's directory, not the file.
		            url.path = stripPathFilename(base.path) + url.path;
		        }
		    }
		    /**
		     * The path can have empty directories "//", unneeded parents "foo/..", or current directory
		     * "foo/.". We need to normalize to a standard representation.
		     */
		    function normalizePath(url, type) {
		        const rel = type <= 4 /* RelativePath */;
		        const pieces = url.path.split('/');
		        // We need to preserve the first piece always, so that we output a leading slash. The item at
		        // pieces[0] is an empty string.
		        let pointer = 1;
		        // Positive is the number of real directories we've output, used for popping a parent directory.
		        // Eg, "foo/bar/.." will have a positive 2, and we can decrement to be left with just "foo".
		        let positive = 0;
		        // We need to keep a trailing slash if we encounter an empty directory (eg, splitting "foo/" will
		        // generate `["foo", ""]` pieces). And, if we pop a parent directory. But once we encounter a
		        // real directory, we won't need to append, unless the other conditions happen again.
		        let addTrailingSlash = false;
		        for (let i = 1; i < pieces.length; i++) {
		            const piece = pieces[i];
		            // An empty directory, could be a trailing slash, or just a double "//" in the path.
		            if (!piece) {
		                addTrailingSlash = true;
		                continue;
		            }
		            // If we encounter a real directory, then we don't need to append anymore.
		            addTrailingSlash = false;
		            // A current directory, which we can always drop.
		            if (piece === '.')
		                continue;
		            // A parent directory, we need to see if there are any real directories we can pop. Else, we
		            // have an excess of parents, and we'll need to keep the "..".
		            if (piece === '..') {
		                if (positive) {
		                    addTrailingSlash = true;
		                    positive--;
		                    pointer--;
		                }
		                else if (rel) {
		                    // If we're in a relativePath, then we need to keep the excess parents. Else, in an absolute
		                    // URL, protocol relative URL, or an absolute path, we don't need to keep excess.
		                    pieces[pointer++] = piece;
		                }
		                continue;
		            }
		            // We've encountered a real directory. Move it to the next insertion pointer, which accounts for
		            // any popped or dropped directories.
		            pieces[pointer++] = piece;
		            positive++;
		        }
		        let path = '';
		        for (let i = 1; i < pointer; i++) {
		            path += '/' + pieces[i];
		        }
		        if (!path || (addTrailingSlash && !path.endsWith('/..'))) {
		            path += '/';
		        }
		        url.path = path;
		    }
		    /**
		     * Attempts to resolve `input` URL/path relative to `base`.
		     */
		    function resolve(input, base) {
		        if (!input && !base)
		            return '';
		        const url = parseUrl(input);
		        let inputType = url.type;
		        if (base && inputType !== 7 /* Absolute */) {
		            const baseUrl = parseUrl(base);
		            const baseType = baseUrl.type;
		            switch (inputType) {
		                case 1 /* Empty */:
		                    url.hash = baseUrl.hash;
		                // fall through
		                case 2 /* Hash */:
		                    url.query = baseUrl.query;
		                // fall through
		                case 3 /* Query */:
		                case 4 /* RelativePath */:
		                    mergePaths(url, baseUrl);
		                // fall through
		                case 5 /* AbsolutePath */:
		                    // The host, user, and port are joined, you can't copy one without the others.
		                    url.user = baseUrl.user;
		                    url.host = baseUrl.host;
		                    url.port = baseUrl.port;
		                // fall through
		                case 6 /* SchemeRelative */:
		                    // The input doesn't have a schema at least, so we need to copy at least that over.
		                    url.scheme = baseUrl.scheme;
		            }
		            if (baseType > inputType)
		                inputType = baseType;
		        }
		        normalizePath(url, inputType);
		        const queryHash = url.query + url.hash;
		        switch (inputType) {
		            // This is impossible, because of the empty checks at the start of the function.
		            // case UrlType.Empty:
		            case 2 /* Hash */:
		            case 3 /* Query */:
		                return queryHash;
		            case 4 /* RelativePath */: {
		                // The first char is always a "/", and we need it to be relative.
		                const path = url.path.slice(1);
		                if (!path)
		                    return queryHash || '.';
		                if (isRelative(base || input) && !isRelative(path)) {
		                    // If base started with a leading ".", or there is no base and input started with a ".",
		                    // then we need to ensure that the relative path starts with a ".". We don't know if
		                    // relative starts with a "..", though, so check before prepending.
		                    return './' + path + queryHash;
		                }
		                return path + queryHash;
		            }
		            case 5 /* AbsolutePath */:
		                return url.path + queryHash;
		            default:
		                return url.scheme + '//' + url.user + url.host + url.port + url.path + queryHash;
		        }
		    }

		    return resolve;

		}));
		
	} (resolveUri_umd, resolveUri_umd.exports));
	return resolveUri_umd.exports;
}

traceMapping_umd.exports;

var hasRequiredTraceMapping_umd;

function requireTraceMapping_umd () {
	if (hasRequiredTraceMapping_umd) return traceMapping_umd.exports;
	hasRequiredTraceMapping_umd = 1;
	(function (module, exports) {
		(function (global, factory) {
		    factory(exports, requireSourcemapCodec_umd(), requireResolveUri_umd()) ;
		})(commonjsGlobal, (function (exports, sourcemapCodec, resolveUri) {
		    function resolve(input, base) {
		        // The base is always treated as a directory, if it's not empty.
		        // https://github.com/mozilla/source-map/blob/8cb3ee57/lib/util.js#L327
		        // https://github.com/chromium/chromium/blob/da4adbb3/third_party/blink/renderer/devtools/front_end/sdk/SourceMap.js#L400-L401
		        if (base && !base.endsWith('/'))
		            base += '/';
		        return resolveUri(input, base);
		    }

		    /**
		     * Removes everything after the last "/", but leaves the slash.
		     */
		    function stripFilename(path) {
		        if (!path)
		            return '';
		        const index = path.lastIndexOf('/');
		        return path.slice(0, index + 1);
		    }

		    const COLUMN = 0;
		    const SOURCES_INDEX = 1;
		    const SOURCE_LINE = 2;
		    const SOURCE_COLUMN = 3;
		    const NAMES_INDEX = 4;
		    const REV_GENERATED_LINE = 1;
		    const REV_GENERATED_COLUMN = 2;

		    function maybeSort(mappings, owned) {
		        const unsortedIndex = nextUnsortedSegmentLine(mappings, 0);
		        if (unsortedIndex === mappings.length)
		            return mappings;
		        // If we own the array (meaning we parsed it from JSON), then we're free to directly mutate it. If
		        // not, we do not want to modify the consumer's input array.
		        if (!owned)
		            mappings = mappings.slice();
		        for (let i = unsortedIndex; i < mappings.length; i = nextUnsortedSegmentLine(mappings, i + 1)) {
		            mappings[i] = sortSegments(mappings[i], owned);
		        }
		        return mappings;
		    }
		    function nextUnsortedSegmentLine(mappings, start) {
		        for (let i = start; i < mappings.length; i++) {
		            if (!isSorted(mappings[i]))
		                return i;
		        }
		        return mappings.length;
		    }
		    function isSorted(line) {
		        for (let j = 1; j < line.length; j++) {
		            if (line[j][COLUMN] < line[j - 1][COLUMN]) {
		                return false;
		            }
		        }
		        return true;
		    }
		    function sortSegments(line, owned) {
		        if (!owned)
		            line = line.slice();
		        return line.sort(sortComparator);
		    }
		    function sortComparator(a, b) {
		        return a[COLUMN] - b[COLUMN];
		    }

		    let found = false;
		    /**
		     * A binary search implementation that returns the index if a match is found.
		     * If no match is found, then the left-index (the index associated with the item that comes just
		     * before the desired index) is returned. To maintain proper sort order, a splice would happen at
		     * the next index:
		     *
		     * ```js
		     * const array = [1, 3];
		     * const needle = 2;
		     * const index = binarySearch(array, needle, (item, needle) => item - needle);
		     *
		     * assert.equal(index, 0);
		     * array.splice(index + 1, 0, needle);
		     * assert.deepEqual(array, [1, 2, 3]);
		     * ```
		     */
		    function binarySearch(haystack, needle, low, high) {
		        while (low <= high) {
		            const mid = low + ((high - low) >> 1);
		            const cmp = haystack[mid][COLUMN] - needle;
		            if (cmp === 0) {
		                found = true;
		                return mid;
		            }
		            if (cmp < 0) {
		                low = mid + 1;
		            }
		            else {
		                high = mid - 1;
		            }
		        }
		        found = false;
		        return low - 1;
		    }
		    function upperBound(haystack, needle, index) {
		        for (let i = index + 1; i < haystack.length; index = i++) {
		            if (haystack[i][COLUMN] !== needle)
		                break;
		        }
		        return index;
		    }
		    function lowerBound(haystack, needle, index) {
		        for (let i = index - 1; i >= 0; index = i--) {
		            if (haystack[i][COLUMN] !== needle)
		                break;
		        }
		        return index;
		    }
		    function memoizedState() {
		        return {
		            lastKey: -1,
		            lastNeedle: -1,
		            lastIndex: -1,
		        };
		    }
		    /**
		     * This overly complicated beast is just to record the last tested line/column and the resulting
		     * index, allowing us to skip a few tests if mappings are monotonically increasing.
		     */
		    function memoizedBinarySearch(haystack, needle, state, key) {
		        const { lastKey, lastNeedle, lastIndex } = state;
		        let low = 0;
		        let high = haystack.length - 1;
		        if (key === lastKey) {
		            if (needle === lastNeedle) {
		                found = lastIndex !== -1 && haystack[lastIndex][COLUMN] === needle;
		                return lastIndex;
		            }
		            if (needle >= lastNeedle) {
		                // lastIndex may be -1 if the previous needle was not found.
		                low = lastIndex === -1 ? 0 : lastIndex;
		            }
		            else {
		                high = lastIndex;
		            }
		        }
		        state.lastKey = key;
		        state.lastNeedle = needle;
		        return (state.lastIndex = binarySearch(haystack, needle, low, high));
		    }

		    // Rebuilds the original source files, with mappings that are ordered by source line/column instead
		    // of generated line/column.
		    function buildBySources(decoded, memos) {
		        const sources = memos.map(buildNullArray);
		        for (let i = 0; i < decoded.length; i++) {
		            const line = decoded[i];
		            for (let j = 0; j < line.length; j++) {
		                const seg = line[j];
		                if (seg.length === 1)
		                    continue;
		                const sourceIndex = seg[SOURCES_INDEX];
		                const sourceLine = seg[SOURCE_LINE];
		                const sourceColumn = seg[SOURCE_COLUMN];
		                const originalSource = sources[sourceIndex];
		                const originalLine = (originalSource[sourceLine] || (originalSource[sourceLine] = []));
		                const memo = memos[sourceIndex];
		                // The binary search either found a match, or it found the left-index just before where the
		                // segment should go. Either way, we want to insert after that. And there may be multiple
		                // generated segments associated with an original location, so there may need to move several
		                // indexes before we find where we need to insert.
		                let index = upperBound(originalLine, sourceColumn, memoizedBinarySearch(originalLine, sourceColumn, memo, sourceLine));
		                memo.lastIndex = ++index;
		                insert(originalLine, index, [sourceColumn, i, seg[COLUMN]]);
		            }
		        }
		        return sources;
		    }
		    function insert(array, index, value) {
		        for (let i = array.length; i > index; i--) {
		            array[i] = array[i - 1];
		        }
		        array[index] = value;
		    }
		    // Null arrays allow us to use ordered index keys without actually allocating contiguous memory like
		    // a real array. We use a null-prototype object to avoid prototype pollution and deoptimizations.
		    // Numeric properties on objects are magically sorted in ascending order by the engine regardless of
		    // the insertion order. So, by setting any numeric keys, even out of order, we'll get ascending
		    // order when iterating with for-in.
		    function buildNullArray() {
		        return { __proto__: null };
		    }

		    const AnyMap = function (map, mapUrl) {
		        const parsed = parse(map);
		        if (!('sections' in parsed)) {
		            return new TraceMap(parsed, mapUrl);
		        }
		        const mappings = [];
		        const sources = [];
		        const sourcesContent = [];
		        const names = [];
		        const ignoreList = [];
		        recurse(parsed, mapUrl, mappings, sources, sourcesContent, names, ignoreList, 0, 0, Infinity, Infinity);
		        const joined = {
		            version: 3,
		            file: parsed.file,
		            names,
		            sources,
		            sourcesContent,
		            mappings,
		            ignoreList,
		        };
		        return presortedDecodedMap(joined);
		    };
		    function parse(map) {
		        return typeof map === 'string' ? JSON.parse(map) : map;
		    }
		    function recurse(input, mapUrl, mappings, sources, sourcesContent, names, ignoreList, lineOffset, columnOffset, stopLine, stopColumn) {
		        const { sections } = input;
		        for (let i = 0; i < sections.length; i++) {
		            const { map, offset } = sections[i];
		            let sl = stopLine;
		            let sc = stopColumn;
		            if (i + 1 < sections.length) {
		                const nextOffset = sections[i + 1].offset;
		                sl = Math.min(stopLine, lineOffset + nextOffset.line);
		                if (sl === stopLine) {
		                    sc = Math.min(stopColumn, columnOffset + nextOffset.column);
		                }
		                else if (sl < stopLine) {
		                    sc = columnOffset + nextOffset.column;
		                }
		            }
		            addSection(map, mapUrl, mappings, sources, sourcesContent, names, ignoreList, lineOffset + offset.line, columnOffset + offset.column, sl, sc);
		        }
		    }
		    function addSection(input, mapUrl, mappings, sources, sourcesContent, names, ignoreList, lineOffset, columnOffset, stopLine, stopColumn) {
		        const parsed = parse(input);
		        if ('sections' in parsed)
		            return recurse(...arguments);
		        const map = new TraceMap(parsed, mapUrl);
		        const sourcesOffset = sources.length;
		        const namesOffset = names.length;
		        const decoded = decodedMappings(map);
		        const { resolvedSources, sourcesContent: contents, ignoreList: ignores } = map;
		        append(sources, resolvedSources);
		        append(names, map.names);
		        if (contents)
		            append(sourcesContent, contents);
		        else
		            for (let i = 0; i < resolvedSources.length; i++)
		                sourcesContent.push(null);
		        if (ignores)
		            for (let i = 0; i < ignores.length; i++)
		                ignoreList.push(ignores[i] + sourcesOffset);
		        for (let i = 0; i < decoded.length; i++) {
		            const lineI = lineOffset + i;
		            // We can only add so many lines before we step into the range that the next section's map
		            // controls. When we get to the last line, then we'll start checking the segments to see if
		            // they've crossed into the column range. But it may not have any columns that overstep, so we
		            // still need to check that we don't overstep lines, too.
		            if (lineI > stopLine)
		                return;
		            // The out line may already exist in mappings (if we're continuing the line started by a
		            // previous section). Or, we may have jumped ahead several lines to start this section.
		            const out = getLine(mappings, lineI);
		            // On the 0th loop, the section's column offset shifts us forward. On all other lines (since the
		            // map can be multiple lines), it doesn't.
		            const cOffset = i === 0 ? columnOffset : 0;
		            const line = decoded[i];
		            for (let j = 0; j < line.length; j++) {
		                const seg = line[j];
		                const column = cOffset + seg[COLUMN];
		                // If this segment steps into the column range that the next section's map controls, we need
		                // to stop early.
		                if (lineI === stopLine && column >= stopColumn)
		                    return;
		                if (seg.length === 1) {
		                    out.push([column]);
		                    continue;
		                }
		                const sourcesIndex = sourcesOffset + seg[SOURCES_INDEX];
		                const sourceLine = seg[SOURCE_LINE];
		                const sourceColumn = seg[SOURCE_COLUMN];
		                out.push(seg.length === 4
		                    ? [column, sourcesIndex, sourceLine, sourceColumn]
		                    : [column, sourcesIndex, sourceLine, sourceColumn, namesOffset + seg[NAMES_INDEX]]);
		            }
		        }
		    }
		    function append(arr, other) {
		        for (let i = 0; i < other.length; i++)
		            arr.push(other[i]);
		    }
		    function getLine(arr, index) {
		        for (let i = arr.length; i <= index; i++)
		            arr[i] = [];
		        return arr[index];
		    }

		    const LINE_GTR_ZERO = '`line` must be greater than 0 (lines start at line 1)';
		    const COL_GTR_EQ_ZERO = '`column` must be greater than or equal to 0 (columns start at column 0)';
		    const LEAST_UPPER_BOUND = -1;
		    const GREATEST_LOWER_BOUND = 1;
		    class TraceMap {
		        constructor(map, mapUrl) {
		            const isString = typeof map === 'string';
		            if (!isString && map._decodedMemo)
		                return map;
		            const parsed = (isString ? JSON.parse(map) : map);
		            const { version, file, names, sourceRoot, sources, sourcesContent } = parsed;
		            this.version = version;
		            this.file = file;
		            this.names = names || [];
		            this.sourceRoot = sourceRoot;
		            this.sources = sources;
		            this.sourcesContent = sourcesContent;
		            this.ignoreList = parsed.ignoreList || parsed.x_google_ignoreList || undefined;
		            const from = resolve(sourceRoot || '', stripFilename(mapUrl));
		            this.resolvedSources = sources.map((s) => resolve(s || '', from));
		            const { mappings } = parsed;
		            if (typeof mappings === 'string') {
		                this._encoded = mappings;
		                this._decoded = undefined;
		            }
		            else {
		                this._encoded = undefined;
		                this._decoded = maybeSort(mappings, isString);
		            }
		            this._decodedMemo = memoizedState();
		            this._bySources = undefined;
		            this._bySourceMemos = undefined;
		        }
		    }
		    /**
		     * Typescript doesn't allow friend access to private fields, so this just casts the map into a type
		     * with public access modifiers.
		     */
		    function cast(map) {
		        return map;
		    }
		    /**
		     * Returns the encoded (VLQ string) form of the SourceMap's mappings field.
		     */
		    function encodedMappings(map) {
		        var _a;
		        var _b;
		        return ((_a = (_b = cast(map))._encoded) !== null && _a !== void 0 ? _a : (_b._encoded = sourcemapCodec.encode(cast(map)._decoded)));
		    }
		    /**
		     * Returns the decoded (array of lines of segments) form of the SourceMap's mappings field.
		     */
		    function decodedMappings(map) {
		        var _a;
		        return ((_a = cast(map))._decoded || (_a._decoded = sourcemapCodec.decode(cast(map)._encoded)));
		    }
		    /**
		     * A low-level API to find the segment associated with a generated line/column (think, from a
		     * stack trace). Line and column here are 0-based, unlike `originalPositionFor`.
		     */
		    function traceSegment(map, line, column) {
		        const decoded = decodedMappings(map);
		        // It's common for parent source maps to have pointers to lines that have no
		        // mapping (like a "//# sourceMappingURL=") at the end of the child file.
		        if (line >= decoded.length)
		            return null;
		        const segments = decoded[line];
		        const index = traceSegmentInternal(segments, cast(map)._decodedMemo, line, column, GREATEST_LOWER_BOUND);
		        return index === -1 ? null : segments[index];
		    }
		    /**
		     * A higher-level API to find the source/line/column associated with a generated line/column
		     * (think, from a stack trace). Line is 1-based, but column is 0-based, due to legacy behavior in
		     * `source-map` library.
		     */
		    function originalPositionFor(map, needle) {
		        let { line, column, bias } = needle;
		        line--;
		        if (line < 0)
		            throw new Error(LINE_GTR_ZERO);
		        if (column < 0)
		            throw new Error(COL_GTR_EQ_ZERO);
		        const decoded = decodedMappings(map);
		        // It's common for parent source maps to have pointers to lines that have no
		        // mapping (like a "//# sourceMappingURL=") at the end of the child file.
		        if (line >= decoded.length)
		            return OMapping(null, null, null, null);
		        const segments = decoded[line];
		        const index = traceSegmentInternal(segments, cast(map)._decodedMemo, line, column, bias || GREATEST_LOWER_BOUND);
		        if (index === -1)
		            return OMapping(null, null, null, null);
		        const segment = segments[index];
		        if (segment.length === 1)
		            return OMapping(null, null, null, null);
		        const { names, resolvedSources } = map;
		        return OMapping(resolvedSources[segment[SOURCES_INDEX]], segment[SOURCE_LINE] + 1, segment[SOURCE_COLUMN], segment.length === 5 ? names[segment[NAMES_INDEX]] : null);
		    }
		    /**
		     * Finds the generated line/column position of the provided source/line/column source position.
		     */
		    function generatedPositionFor(map, needle) {
		        const { source, line, column, bias } = needle;
		        return generatedPosition(map, source, line, column, bias || GREATEST_LOWER_BOUND, false);
		    }
		    /**
		     * Finds all generated line/column positions of the provided source/line/column source position.
		     */
		    function allGeneratedPositionsFor(map, needle) {
		        const { source, line, column, bias } = needle;
		        // SourceMapConsumer uses LEAST_UPPER_BOUND for some reason, so we follow suit.
		        return generatedPosition(map, source, line, column, bias || LEAST_UPPER_BOUND, true);
		    }
		    /**
		     * Iterates each mapping in generated position order.
		     */
		    function eachMapping(map, cb) {
		        const decoded = decodedMappings(map);
		        const { names, resolvedSources } = map;
		        for (let i = 0; i < decoded.length; i++) {
		            const line = decoded[i];
		            for (let j = 0; j < line.length; j++) {
		                const seg = line[j];
		                const generatedLine = i + 1;
		                const generatedColumn = seg[0];
		                let source = null;
		                let originalLine = null;
		                let originalColumn = null;
		                let name = null;
		                if (seg.length !== 1) {
		                    source = resolvedSources[seg[1]];
		                    originalLine = seg[2] + 1;
		                    originalColumn = seg[3];
		                }
		                if (seg.length === 5)
		                    name = names[seg[4]];
		                cb({
		                    generatedLine,
		                    generatedColumn,
		                    source,
		                    originalLine,
		                    originalColumn,
		                    name,
		                });
		            }
		        }
		    }
		    function sourceIndex(map, source) {
		        const { sources, resolvedSources } = map;
		        let index = sources.indexOf(source);
		        if (index === -1)
		            index = resolvedSources.indexOf(source);
		        return index;
		    }
		    /**
		     * Retrieves the source content for a particular source, if its found. Returns null if not.
		     */
		    function sourceContentFor(map, source) {
		        const { sourcesContent } = map;
		        if (sourcesContent == null)
		            return null;
		        const index = sourceIndex(map, source);
		        return index === -1 ? null : sourcesContent[index];
		    }
		    /**
		     * Determines if the source is marked to ignore by the source map.
		     */
		    function isIgnored(map, source) {
		        const { ignoreList } = map;
		        if (ignoreList == null)
		            return false;
		        const index = sourceIndex(map, source);
		        return index === -1 ? false : ignoreList.includes(index);
		    }
		    /**
		     * A helper that skips sorting of the input map's mappings array, which can be expensive for larger
		     * maps.
		     */
		    function presortedDecodedMap(map, mapUrl) {
		        const tracer = new TraceMap(clone(map, []), mapUrl);
		        cast(tracer)._decoded = map.mappings;
		        return tracer;
		    }
		    /**
		     * Returns a sourcemap object (with decoded mappings) suitable for passing to a library that expects
		     * a sourcemap, or to JSON.stringify.
		     */
		    function decodedMap(map) {
		        return clone(map, decodedMappings(map));
		    }
		    /**
		     * Returns a sourcemap object (with encoded mappings) suitable for passing to a library that expects
		     * a sourcemap, or to JSON.stringify.
		     */
		    function encodedMap(map) {
		        return clone(map, encodedMappings(map));
		    }
		    function clone(map, mappings) {
		        return {
		            version: map.version,
		            file: map.file,
		            names: map.names,
		            sourceRoot: map.sourceRoot,
		            sources: map.sources,
		            sourcesContent: map.sourcesContent,
		            mappings,
		            ignoreList: map.ignoreList || map.x_google_ignoreList,
		        };
		    }
		    function OMapping(source, line, column, name) {
		        return { source, line, column, name };
		    }
		    function GMapping(line, column) {
		        return { line, column };
		    }
		    function traceSegmentInternal(segments, memo, line, column, bias) {
		        let index = memoizedBinarySearch(segments, column, memo, line);
		        if (found) {
		            index = (bias === LEAST_UPPER_BOUND ? upperBound : lowerBound)(segments, column, index);
		        }
		        else if (bias === LEAST_UPPER_BOUND)
		            index++;
		        if (index === -1 || index === segments.length)
		            return -1;
		        return index;
		    }
		    function sliceGeneratedPositions(segments, memo, line, column, bias) {
		        let min = traceSegmentInternal(segments, memo, line, column, GREATEST_LOWER_BOUND);
		        // We ignored the bias when tracing the segment so that we're guarnateed to find the first (in
		        // insertion order) segment that matched. Even if we did respect the bias when tracing, we would
		        // still need to call `lowerBound()` to find the first segment, which is slower than just looking
		        // for the GREATEST_LOWER_BOUND to begin with. The only difference that matters for us is when the
		        // binary search didn't match, in which case GREATEST_LOWER_BOUND just needs to increment to
		        // match LEAST_UPPER_BOUND.
		        if (!found && bias === LEAST_UPPER_BOUND)
		            min++;
		        if (min === -1 || min === segments.length)
		            return [];
		        // We may have found the segment that started at an earlier column. If this is the case, then we
		        // need to slice all generated segments that match _that_ column, because all such segments span
		        // to our desired column.
		        const matchedColumn = found ? column : segments[min][COLUMN];
		        // The binary search is not guaranteed to find the lower bound when a match wasn't found.
		        if (!found)
		            min = lowerBound(segments, matchedColumn, min);
		        const max = upperBound(segments, matchedColumn, min);
		        const result = [];
		        for (; min <= max; min++) {
		            const segment = segments[min];
		            result.push(GMapping(segment[REV_GENERATED_LINE] + 1, segment[REV_GENERATED_COLUMN]));
		        }
		        return result;
		    }
		    function generatedPosition(map, source, line, column, bias, all) {
		        var _a;
		        line--;
		        if (line < 0)
		            throw new Error(LINE_GTR_ZERO);
		        if (column < 0)
		            throw new Error(COL_GTR_EQ_ZERO);
		        const { sources, resolvedSources } = map;
		        let sourceIndex = sources.indexOf(source);
		        if (sourceIndex === -1)
		            sourceIndex = resolvedSources.indexOf(source);
		        if (sourceIndex === -1)
		            return all ? [] : GMapping(null, null);
		        const generated = ((_a = cast(map))._bySources || (_a._bySources = buildBySources(decodedMappings(map), (cast(map)._bySourceMemos = sources.map(memoizedState)))));
		        const segments = generated[sourceIndex][line];
		        if (segments == null)
		            return all ? [] : GMapping(null, null);
		        const memo = cast(map)._bySourceMemos[sourceIndex];
		        if (all)
		            return sliceGeneratedPositions(segments, memo, line, column, bias);
		        const index = traceSegmentInternal(segments, memo, line, column, bias);
		        if (index === -1)
		            return GMapping(null, null);
		        const segment = segments[index];
		        return GMapping(segment[REV_GENERATED_LINE] + 1, segment[REV_GENERATED_COLUMN]);
		    }

		    exports.AnyMap = AnyMap;
		    exports.GREATEST_LOWER_BOUND = GREATEST_LOWER_BOUND;
		    exports.LEAST_UPPER_BOUND = LEAST_UPPER_BOUND;
		    exports.TraceMap = TraceMap;
		    exports.allGeneratedPositionsFor = allGeneratedPositionsFor;
		    exports.decodedMap = decodedMap;
		    exports.decodedMappings = decodedMappings;
		    exports.eachMapping = eachMapping;
		    exports.encodedMap = encodedMap;
		    exports.encodedMappings = encodedMappings;
		    exports.generatedPositionFor = generatedPositionFor;
		    exports.isIgnored = isIgnored;
		    exports.originalPositionFor = originalPositionFor;
		    exports.presortedDecodedMap = presortedDecodedMap;
		    exports.sourceContentFor = sourceContentFor;
		    exports.traceSegment = traceSegment;

		}));
		
	} (traceMapping_umd, traceMapping_umd.exports));
	return traceMapping_umd.exports;
}

var genMapping_umd = {exports: {}};

var setArray_umd = {exports: {}};

setArray_umd.exports;

var hasRequiredSetArray_umd;

function requireSetArray_umd () {
	if (hasRequiredSetArray_umd) return setArray_umd.exports;
	hasRequiredSetArray_umd = 1;
	(function (module, exports) {
		(function (global, factory) {
		    factory(exports) ;
		})(commonjsGlobal, (function (exports) {
		    /**
		     * SetArray acts like a `Set` (allowing only one occurrence of a string `key`), but provides the
		     * index of the `key` in the backing array.
		     *
		     * This is designed to allow synchronizing a second array with the contents of the backing array,
		     * like how in a sourcemap `sourcesContent[i]` is the source content associated with `source[i]`,
		     * and there are never duplicates.
		     */
		    class SetArray {
		        constructor() {
		            this._indexes = { __proto__: null };
		            this.array = [];
		        }
		    }
		    /**
		     * Typescript doesn't allow friend access to private fields, so this just casts the set into a type
		     * with public access modifiers.
		     */
		    function cast(set) {
		        return set;
		    }
		    /**
		     * Gets the index associated with `key` in the backing array, if it is already present.
		     */
		    function get(setarr, key) {
		        return cast(setarr)._indexes[key];
		    }
		    /**
		     * Puts `key` into the backing array, if it is not already present. Returns
		     * the index of the `key` in the backing array.
		     */
		    function put(setarr, key) {
		        // The key may or may not be present. If it is present, it's a number.
		        const index = get(setarr, key);
		        if (index !== undefined)
		            return index;
		        const { array, _indexes: indexes } = cast(setarr);
		        const length = array.push(key);
		        return (indexes[key] = length - 1);
		    }
		    /**
		     * Pops the last added item out of the SetArray.
		     */
		    function pop(setarr) {
		        const { array, _indexes: indexes } = cast(setarr);
		        if (array.length === 0)
		            return;
		        const last = array.pop();
		        indexes[last] = undefined;
		    }
		    /**
		     * Removes the key, if it exists in the set.
		     */
		    function remove(setarr, key) {
		        const index = get(setarr, key);
		        if (index === undefined)
		            return;
		        const { array, _indexes: indexes } = cast(setarr);
		        for (let i = index + 1; i < array.length; i++) {
		            const k = array[i];
		            array[i - 1] = k;
		            indexes[k]--;
		        }
		        indexes[key] = undefined;
		        array.pop();
		    }

		    exports.SetArray = SetArray;
		    exports.get = get;
		    exports.pop = pop;
		    exports.put = put;
		    exports.remove = remove;

		    Object.defineProperty(exports, '__esModule', { value: true });

		}));
		
	} (setArray_umd, setArray_umd.exports));
	return setArray_umd.exports;
}

genMapping_umd.exports;

var hasRequiredGenMapping_umd;

function requireGenMapping_umd () {
	if (hasRequiredGenMapping_umd) return genMapping_umd.exports;
	hasRequiredGenMapping_umd = 1;
	(function (module, exports) {
		(function (global, factory) {
		    factory(exports, requireSetArray_umd(), requireSourcemapCodec_umd(), requireTraceMapping_umd()) ;
		})(commonjsGlobal, (function (exports, setArray, sourcemapCodec, traceMapping) {
		    const COLUMN = 0;
		    const SOURCES_INDEX = 1;
		    const SOURCE_LINE = 2;
		    const SOURCE_COLUMN = 3;
		    const NAMES_INDEX = 4;

		    const NO_NAME = -1;
		    /**
		     * Provides the state to generate a sourcemap.
		     */
		    class GenMapping {
		        constructor({ file, sourceRoot } = {}) {
		            this._names = new setArray.SetArray();
		            this._sources = new setArray.SetArray();
		            this._sourcesContent = [];
		            this._mappings = [];
		            this.file = file;
		            this.sourceRoot = sourceRoot;
		            this._ignoreList = new setArray.SetArray();
		        }
		    }
		    /**
		     * Typescript doesn't allow friend access to private fields, so this just casts the map into a type
		     * with public access modifiers.
		     */
		    function cast(map) {
		        return map;
		    }
		    function addSegment(map, genLine, genColumn, source, sourceLine, sourceColumn, name, content) {
		        return addSegmentInternal(false, map, genLine, genColumn, source, sourceLine, sourceColumn, name, content);
		    }
		    function addMapping(map, mapping) {
		        return addMappingInternal(false, map, mapping);
		    }
		    /**
		     * Same as `addSegment`, but will only add the segment if it generates useful information in the
		     * resulting map. This only works correctly if segments are added **in order**, meaning you should
		     * not add a segment with a lower generated line/column than one that came before.
		     */
		    const maybeAddSegment = (map, genLine, genColumn, source, sourceLine, sourceColumn, name, content) => {
		        return addSegmentInternal(true, map, genLine, genColumn, source, sourceLine, sourceColumn, name, content);
		    };
		    /**
		     * Same as `addMapping`, but will only add the mapping if it generates useful information in the
		     * resulting map. This only works correctly if mappings are added **in order**, meaning you should
		     * not add a mapping with a lower generated line/column than one that came before.
		     */
		    const maybeAddMapping = (map, mapping) => {
		        return addMappingInternal(true, map, mapping);
		    };
		    /**
		     * Adds/removes the content of the source file to the source map.
		     */
		    function setSourceContent(map, source, content) {
		        const { _sources: sources, _sourcesContent: sourcesContent } = cast(map);
		        const index = setArray.put(sources, source);
		        sourcesContent[index] = content;
		    }
		    function setIgnore(map, source, ignore = true) {
		        const { _sources: sources, _sourcesContent: sourcesContent, _ignoreList: ignoreList } = cast(map);
		        const index = setArray.put(sources, source);
		        if (index === sourcesContent.length)
		            sourcesContent[index] = null;
		        if (ignore)
		            setArray.put(ignoreList, index);
		        else
		            setArray.remove(ignoreList, index);
		    }
		    /**
		     * Returns a sourcemap object (with decoded mappings) suitable for passing to a library that expects
		     * a sourcemap, or to JSON.stringify.
		     */
		    function toDecodedMap(map) {
		        const { _mappings: mappings, _sources: sources, _sourcesContent: sourcesContent, _names: names, _ignoreList: ignoreList, } = cast(map);
		        removeEmptyFinalLines(mappings);
		        return {
		            version: 3,
		            file: map.file || undefined,
		            names: names.array,
		            sourceRoot: map.sourceRoot || undefined,
		            sources: sources.array,
		            sourcesContent,
		            mappings,
		            ignoreList: ignoreList.array,
		        };
		    }
		    /**
		     * Returns a sourcemap object (with encoded mappings) suitable for passing to a library that expects
		     * a sourcemap, or to JSON.stringify.
		     */
		    function toEncodedMap(map) {
		        const decoded = toDecodedMap(map);
		        return Object.assign(Object.assign({}, decoded), { mappings: sourcemapCodec.encode(decoded.mappings) });
		    }
		    /**
		     * Constructs a new GenMapping, using the already present mappings of the input.
		     */
		    function fromMap(input) {
		        const map = new traceMapping.TraceMap(input);
		        const gen = new GenMapping({ file: map.file, sourceRoot: map.sourceRoot });
		        putAll(cast(gen)._names, map.names);
		        putAll(cast(gen)._sources, map.sources);
		        cast(gen)._sourcesContent = map.sourcesContent || map.sources.map(() => null);
		        cast(gen)._mappings = traceMapping.decodedMappings(map);
		        if (map.ignoreList)
		            putAll(cast(gen)._ignoreList, map.ignoreList);
		        return gen;
		    }
		    /**
		     * Returns an array of high-level mapping objects for every recorded segment, which could then be
		     * passed to the `source-map` library.
		     */
		    function allMappings(map) {
		        const out = [];
		        const { _mappings: mappings, _sources: sources, _names: names } = cast(map);
		        for (let i = 0; i < mappings.length; i++) {
		            const line = mappings[i];
		            for (let j = 0; j < line.length; j++) {
		                const seg = line[j];
		                const generated = { line: i + 1, column: seg[COLUMN] };
		                let source = undefined;
		                let original = undefined;
		                let name = undefined;
		                if (seg.length !== 1) {
		                    source = sources.array[seg[SOURCES_INDEX]];
		                    original = { line: seg[SOURCE_LINE] + 1, column: seg[SOURCE_COLUMN] };
		                    if (seg.length === 5)
		                        name = names.array[seg[NAMES_INDEX]];
		                }
		                out.push({ generated, source, original, name });
		            }
		        }
		        return out;
		    }
		    // This split declaration is only so that terser can elminiate the static initialization block.
		    function addSegmentInternal(skipable, map, genLine, genColumn, source, sourceLine, sourceColumn, name, content) {
		        const { _mappings: mappings, _sources: sources, _sourcesContent: sourcesContent, _names: names, } = cast(map);
		        const line = getLine(mappings, genLine);
		        const index = getColumnIndex(line, genColumn);
		        if (!source) {
		            if (skipable && skipSourceless(line, index))
		                return;
		            return insert(line, index, [genColumn]);
		        }
		        const sourcesIndex = setArray.put(sources, source);
		        const namesIndex = name ? setArray.put(names, name) : NO_NAME;
		        if (sourcesIndex === sourcesContent.length)
		            sourcesContent[sourcesIndex] = content !== null && content !== void 0 ? content : null;
		        if (skipable && skipSource(line, index, sourcesIndex, sourceLine, sourceColumn, namesIndex)) {
		            return;
		        }
		        return insert(line, index, name
		            ? [genColumn, sourcesIndex, sourceLine, sourceColumn, namesIndex]
		            : [genColumn, sourcesIndex, sourceLine, sourceColumn]);
		    }
		    function getLine(mappings, index) {
		        for (let i = mappings.length; i <= index; i++) {
		            mappings[i] = [];
		        }
		        return mappings[index];
		    }
		    function getColumnIndex(line, genColumn) {
		        let index = line.length;
		        for (let i = index - 1; i >= 0; index = i--) {
		            const current = line[i];
		            if (genColumn >= current[COLUMN])
		                break;
		        }
		        return index;
		    }
		    function insert(array, index, value) {
		        for (let i = array.length; i > index; i--) {
		            array[i] = array[i - 1];
		        }
		        array[index] = value;
		    }
		    function removeEmptyFinalLines(mappings) {
		        const { length } = mappings;
		        let len = length;
		        for (let i = len - 1; i >= 0; len = i, i--) {
		            if (mappings[i].length > 0)
		                break;
		        }
		        if (len < length)
		            mappings.length = len;
		    }
		    function putAll(setarr, array) {
		        for (let i = 0; i < array.length; i++)
		            setArray.put(setarr, array[i]);
		    }
		    function skipSourceless(line, index) {
		        // The start of a line is already sourceless, so adding a sourceless segment to the beginning
		        // doesn't generate any useful information.
		        if (index === 0)
		            return true;
		        const prev = line[index - 1];
		        // If the previous segment is also sourceless, then adding another sourceless segment doesn't
		        // genrate any new information. Else, this segment will end the source/named segment and point to
		        // a sourceless position, which is useful.
		        return prev.length === 1;
		    }
		    function skipSource(line, index, sourcesIndex, sourceLine, sourceColumn, namesIndex) {
		        // A source/named segment at the start of a line gives position at that genColumn
		        if (index === 0)
		            return false;
		        const prev = line[index - 1];
		        // If the previous segment is sourceless, then we're transitioning to a source.
		        if (prev.length === 1)
		            return false;
		        // If the previous segment maps to the exact same source position, then this segment doesn't
		        // provide any new position information.
		        return (sourcesIndex === prev[SOURCES_INDEX] &&
		            sourceLine === prev[SOURCE_LINE] &&
		            sourceColumn === prev[SOURCE_COLUMN] &&
		            namesIndex === (prev.length === 5 ? prev[NAMES_INDEX] : NO_NAME));
		    }
		    function addMappingInternal(skipable, map, mapping) {
		        const { generated, source, original, name, content } = mapping;
		        if (!source) {
		            return addSegmentInternal(skipable, map, generated.line - 1, generated.column, null, null, null, null, null);
		        }
		        return addSegmentInternal(skipable, map, generated.line - 1, generated.column, source, original.line - 1, original.column, name, content);
		    }

		    exports.GenMapping = GenMapping;
		    exports.addMapping = addMapping;
		    exports.addSegment = addSegment;
		    exports.allMappings = allMappings;
		    exports.fromMap = fromMap;
		    exports.maybeAddMapping = maybeAddMapping;
		    exports.maybeAddSegment = maybeAddSegment;
		    exports.setIgnore = setIgnore;
		    exports.setSourceContent = setSourceContent;
		    exports.toDecodedMap = toDecodedMap;
		    exports.toEncodedMap = toEncodedMap;

		    Object.defineProperty(exports, '__esModule', { value: true });

		}));
		
	} (genMapping_umd, genMapping_umd.exports));
	return genMapping_umd.exports;
}

var hasRequiredSourceMap$1;

function requireSourceMap$1 () {
	if (hasRequiredSourceMap$1) return sourceMap$1;
	hasRequiredSourceMap$1 = 1;

	Object.defineProperty(sourceMap$1, '__esModule', { value: true });

	var traceMapping = requireTraceMapping_umd();
	var genMapping = requireGenMapping_umd();

	class SourceMapConsumer {
	    constructor(map, mapUrl) {
	        const trace = (this._map = new traceMapping.AnyMap(map, mapUrl));
	        this.file = trace.file;
	        this.names = trace.names;
	        this.sourceRoot = trace.sourceRoot;
	        this.sources = trace.resolvedSources;
	        this.sourcesContent = trace.sourcesContent;
	        this.version = trace.version;
	    }
	    static fromSourceMap(map, mapUrl) {
	        // This is more performant if we receive
	        // a @jridgewell/source-map SourceMapGenerator
	        if (map.toDecodedMap) {
	            return new SourceMapConsumer(map.toDecodedMap(), mapUrl);
	        }
	        // This is a fallback for `source-map` and `source-map-js`
	        return new SourceMapConsumer(map.toJSON(), mapUrl);
	    }
	    get mappings() {
	        return traceMapping.encodedMappings(this._map);
	    }
	    originalPositionFor(needle) {
	        return traceMapping.originalPositionFor(this._map, needle);
	    }
	    generatedPositionFor(originalPosition) {
	        return traceMapping.generatedPositionFor(this._map, originalPosition);
	    }
	    allGeneratedPositionsFor(originalPosition) {
	        return traceMapping.allGeneratedPositionsFor(this._map, originalPosition);
	    }
	    hasContentsOfAllSources() {
	        if (!this.sourcesContent || this.sourcesContent.length !== this.sources.length) {
	            return false;
	        }
	        for (const content of this.sourcesContent) {
	            if (content == null) {
	                return false;
	            }
	        }
	        return true;
	    }
	    sourceContentFor(source, nullOnMissing) {
	        const sourceContent = traceMapping.sourceContentFor(this._map, source);
	        if (sourceContent != null) {
	            return sourceContent;
	        }
	        if (nullOnMissing) {
	            return null;
	        }
	        throw new Error(`"${source}" is not in the SourceMap.`);
	    }
	    eachMapping(callback, context /*, order?: number*/) {
	        // order is ignored as @jridgewell/trace-map doesn't implement it
	        traceMapping.eachMapping(this._map, context ? callback.bind(context) : callback);
	    }
	    destroy() {
	        // noop.
	    }
	}
	class SourceMapGenerator {
	    constructor(opts) {
	        // TODO :: should this be duck-typed ?
	        this._map = opts instanceof genMapping.GenMapping ? opts : new genMapping.GenMapping(opts);
	    }
	    static fromSourceMap(consumer) {
	        return new SourceMapGenerator(genMapping.fromMap(consumer));
	    }
	    addMapping(mapping) {
	        genMapping.maybeAddMapping(this._map, mapping);
	    }
	    setSourceContent(source, content) {
	        genMapping.setSourceContent(this._map, source, content);
	    }
	    toJSON() {
	        return genMapping.toEncodedMap(this._map);
	    }
	    toString() {
	        return JSON.stringify(this.toJSON());
	    }
	    toDecodedMap() {
	        return genMapping.toDecodedMap(this._map);
	    }
	}

	sourceMap$1.SourceMapConsumer = SourceMapConsumer;
	sourceMap$1.SourceMapGenerator = SourceMapGenerator;
	
	return sourceMap$1;
}

var acorn = {exports: {}};

acorn.exports;

var hasRequiredAcorn;

function requireAcorn () {
	if (hasRequiredAcorn) return acorn.exports;
	hasRequiredAcorn = 1;
	(function (module, exports) {
		(function (global, factory) {
		  factory(exports) ;
		})(commonjsGlobal, (function (exports) {
		  // This file was generated. Do not modify manually!
		  var astralIdentifierCodes = [509, 0, 227, 0, 150, 4, 294, 9, 1368, 2, 2, 1, 6, 3, 41, 2, 5, 0, 166, 1, 574, 3, 9, 9, 370, 1, 81, 2, 71, 10, 50, 3, 123, 2, 54, 14, 32, 10, 3, 1, 11, 3, 46, 10, 8, 0, 46, 9, 7, 2, 37, 13, 2, 9, 6, 1, 45, 0, 13, 2, 49, 13, 9, 3, 2, 11, 83, 11, 7, 0, 3, 0, 158, 11, 6, 9, 7, 3, 56, 1, 2, 6, 3, 1, 3, 2, 10, 0, 11, 1, 3, 6, 4, 4, 193, 17, 10, 9, 5, 0, 82, 19, 13, 9, 214, 6, 3, 8, 28, 1, 83, 16, 16, 9, 82, 12, 9, 9, 84, 14, 5, 9, 243, 14, 166, 9, 71, 5, 2, 1, 3, 3, 2, 0, 2, 1, 13, 9, 120, 6, 3, 6, 4, 0, 29, 9, 41, 6, 2, 3, 9, 0, 10, 10, 47, 15, 406, 7, 2, 7, 17, 9, 57, 21, 2, 13, 123, 5, 4, 0, 2, 1, 2, 6, 2, 0, 9, 9, 49, 4, 2, 1, 2, 4, 9, 9, 330, 3, 10, 1, 2, 0, 49, 6, 4, 4, 14, 9, 5351, 0, 7, 14, 13835, 9, 87, 9, 39, 4, 60, 6, 26, 9, 1014, 0, 2, 54, 8, 3, 82, 0, 12, 1, 19628, 1, 4706, 45, 3, 22, 543, 4, 4, 5, 9, 7, 3, 6, 31, 3, 149, 2, 1418, 49, 513, 54, 5, 49, 9, 0, 15, 0, 23, 4, 2, 14, 1361, 6, 2, 16, 3, 6, 2, 1, 2, 4, 101, 0, 161, 6, 10, 9, 357, 0, 62, 13, 499, 13, 983, 6, 110, 6, 6, 9, 4759, 9, 787719, 239];

		  // This file was generated. Do not modify manually!
		  var astralIdentifierStartCodes = [0, 11, 2, 25, 2, 18, 2, 1, 2, 14, 3, 13, 35, 122, 70, 52, 268, 28, 4, 48, 48, 31, 14, 29, 6, 37, 11, 29, 3, 35, 5, 7, 2, 4, 43, 157, 19, 35, 5, 35, 5, 39, 9, 51, 13, 10, 2, 14, 2, 6, 2, 1, 2, 10, 2, 14, 2, 6, 2, 1, 68, 310, 10, 21, 11, 7, 25, 5, 2, 41, 2, 8, 70, 5, 3, 0, 2, 43, 2, 1, 4, 0, 3, 22, 11, 22, 10, 30, 66, 18, 2, 1, 11, 21, 11, 25, 71, 55, 7, 1, 65, 0, 16, 3, 2, 2, 2, 28, 43, 28, 4, 28, 36, 7, 2, 27, 28, 53, 11, 21, 11, 18, 14, 17, 111, 72, 56, 50, 14, 50, 14, 35, 349, 41, 7, 1, 79, 28, 11, 0, 9, 21, 43, 17, 47, 20, 28, 22, 13, 52, 58, 1, 3, 0, 14, 44, 33, 24, 27, 35, 30, 0, 3, 0, 9, 34, 4, 0, 13, 47, 15, 3, 22, 0, 2, 0, 36, 17, 2, 24, 20, 1, 64, 6, 2, 0, 2, 3, 2, 14, 2, 9, 8, 46, 39, 7, 3, 1, 3, 21, 2, 6, 2, 1, 2, 4, 4, 0, 19, 0, 13, 4, 159, 52, 19, 3, 21, 2, 31, 47, 21, 1, 2, 0, 185, 46, 42, 3, 37, 47, 21, 0, 60, 42, 14, 0, 72, 26, 38, 6, 186, 43, 117, 63, 32, 7, 3, 0, 3, 7, 2, 1, 2, 23, 16, 0, 2, 0, 95, 7, 3, 38, 17, 0, 2, 0, 29, 0, 11, 39, 8, 0, 22, 0, 12, 45, 20, 0, 19, 72, 264, 8, 2, 36, 18, 0, 50, 29, 113, 6, 2, 1, 2, 37, 22, 0, 26, 5, 2, 1, 2, 31, 15, 0, 328, 18, 16, 0, 2, 12, 2, 33, 125, 0, 80, 921, 103, 110, 18, 195, 2637, 96, 16, 1071, 18, 5, 4026, 582, 8634, 568, 8, 30, 18, 78, 18, 29, 19, 47, 17, 3, 32, 20, 6, 18, 689, 63, 129, 74, 6, 0, 67, 12, 65, 1, 2, 0, 29, 6135, 9, 1237, 43, 8, 8936, 3, 2, 6, 2, 1, 2, 290, 16, 0, 30, 2, 3, 0, 15, 3, 9, 395, 2309, 106, 6, 12, 4, 8, 8, 9, 5991, 84, 2, 70, 2, 1, 3, 0, 3, 1, 3, 3, 2, 11, 2, 0, 2, 6, 2, 64, 2, 3, 3, 7, 2, 6, 2, 27, 2, 3, 2, 4, 2, 0, 4, 6, 2, 339, 3, 24, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 7, 1845, 30, 7, 5, 262, 61, 147, 44, 11, 6, 17, 0, 322, 29, 19, 43, 485, 27, 757, 6, 2, 3, 2, 1, 2, 14, 2, 196, 60, 67, 8, 0, 1205, 3, 2, 26, 2, 1, 2, 0, 3, 0, 2, 9, 2, 3, 2, 0, 2, 0, 7, 0, 5, 0, 2, 0, 2, 0, 2, 2, 2, 1, 2, 0, 3, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 1, 2, 0, 3, 3, 2, 6, 2, 3, 2, 3, 2, 0, 2, 9, 2, 16, 6, 2, 2, 4, 2, 16, 4421, 42719, 33, 4153, 7, 221, 3, 5761, 15, 7472, 16, 621, 2467, 541, 1507, 4938, 6, 4191];

		  // This file was generated. Do not modify manually!
		  var nonASCIIidentifierChars = "\u200c\u200d\xb7\u0300-\u036f\u0387\u0483-\u0487\u0591-\u05bd\u05bf\u05c1\u05c2\u05c4\u05c5\u05c7\u0610-\u061a\u064b-\u0669\u0670\u06d6-\u06dc\u06df-\u06e4\u06e7\u06e8\u06ea-\u06ed\u06f0-\u06f9\u0711\u0730-\u074a\u07a6-\u07b0\u07c0-\u07c9\u07eb-\u07f3\u07fd\u0816-\u0819\u081b-\u0823\u0825-\u0827\u0829-\u082d\u0859-\u085b\u0898-\u089f\u08ca-\u08e1\u08e3-\u0903\u093a-\u093c\u093e-\u094f\u0951-\u0957\u0962\u0963\u0966-\u096f\u0981-\u0983\u09bc\u09be-\u09c4\u09c7\u09c8\u09cb-\u09cd\u09d7\u09e2\u09e3\u09e6-\u09ef\u09fe\u0a01-\u0a03\u0a3c\u0a3e-\u0a42\u0a47\u0a48\u0a4b-\u0a4d\u0a51\u0a66-\u0a71\u0a75\u0a81-\u0a83\u0abc\u0abe-\u0ac5\u0ac7-\u0ac9\u0acb-\u0acd\u0ae2\u0ae3\u0ae6-\u0aef\u0afa-\u0aff\u0b01-\u0b03\u0b3c\u0b3e-\u0b44\u0b47\u0b48\u0b4b-\u0b4d\u0b55-\u0b57\u0b62\u0b63\u0b66-\u0b6f\u0b82\u0bbe-\u0bc2\u0bc6-\u0bc8\u0bca-\u0bcd\u0bd7\u0be6-\u0bef\u0c00-\u0c04\u0c3c\u0c3e-\u0c44\u0c46-\u0c48\u0c4a-\u0c4d\u0c55\u0c56\u0c62\u0c63\u0c66-\u0c6f\u0c81-\u0c83\u0cbc\u0cbe-\u0cc4\u0cc6-\u0cc8\u0cca-\u0ccd\u0cd5\u0cd6\u0ce2\u0ce3\u0ce6-\u0cef\u0cf3\u0d00-\u0d03\u0d3b\u0d3c\u0d3e-\u0d44\u0d46-\u0d48\u0d4a-\u0d4d\u0d57\u0d62\u0d63\u0d66-\u0d6f\u0d81-\u0d83\u0dca\u0dcf-\u0dd4\u0dd6\u0dd8-\u0ddf\u0de6-\u0def\u0df2\u0df3\u0e31\u0e34-\u0e3a\u0e47-\u0e4e\u0e50-\u0e59\u0eb1\u0eb4-\u0ebc\u0ec8-\u0ece\u0ed0-\u0ed9\u0f18\u0f19\u0f20-\u0f29\u0f35\u0f37\u0f39\u0f3e\u0f3f\u0f71-\u0f84\u0f86\u0f87\u0f8d-\u0f97\u0f99-\u0fbc\u0fc6\u102b-\u103e\u1040-\u1049\u1056-\u1059\u105e-\u1060\u1062-\u1064\u1067-\u106d\u1071-\u1074\u1082-\u108d\u108f-\u109d\u135d-\u135f\u1369-\u1371\u1712-\u1715\u1732-\u1734\u1752\u1753\u1772\u1773\u17b4-\u17d3\u17dd\u17e0-\u17e9\u180b-\u180d\u180f-\u1819\u18a9\u1920-\u192b\u1930-\u193b\u1946-\u194f\u19d0-\u19da\u1a17-\u1a1b\u1a55-\u1a5e\u1a60-\u1a7c\u1a7f-\u1a89\u1a90-\u1a99\u1ab0-\u1abd\u1abf-\u1ace\u1b00-\u1b04\u1b34-\u1b44\u1b50-\u1b59\u1b6b-\u1b73\u1b80-\u1b82\u1ba1-\u1bad\u1bb0-\u1bb9\u1be6-\u1bf3\u1c24-\u1c37\u1c40-\u1c49\u1c50-\u1c59\u1cd0-\u1cd2\u1cd4-\u1ce8\u1ced\u1cf4\u1cf7-\u1cf9\u1dc0-\u1dff\u200c\u200d\u203f\u2040\u2054\u20d0-\u20dc\u20e1\u20e5-\u20f0\u2cef-\u2cf1\u2d7f\u2de0-\u2dff\u302a-\u302f\u3099\u309a\u30fb\ua620-\ua629\ua66f\ua674-\ua67d\ua69e\ua69f\ua6f0\ua6f1\ua802\ua806\ua80b\ua823-\ua827\ua82c\ua880\ua881\ua8b4-\ua8c5\ua8d0-\ua8d9\ua8e0-\ua8f1\ua8ff-\ua909\ua926-\ua92d\ua947-\ua953\ua980-\ua983\ua9b3-\ua9c0\ua9d0-\ua9d9\ua9e5\ua9f0-\ua9f9\uaa29-\uaa36\uaa43\uaa4c\uaa4d\uaa50-\uaa59\uaa7b-\uaa7d\uaab0\uaab2-\uaab4\uaab7\uaab8\uaabe\uaabf\uaac1\uaaeb-\uaaef\uaaf5\uaaf6\uabe3-\uabea\uabec\uabed\uabf0-\uabf9\ufb1e\ufe00-\ufe0f\ufe20-\ufe2f\ufe33\ufe34\ufe4d-\ufe4f\uff10-\uff19\uff3f\uff65";

		  // This file was generated. Do not modify manually!
		  var nonASCIIidentifierStartChars = "\xaa\xb5\xba\xc0-\xd6\xd8-\xf6\xf8-\u02c1\u02c6-\u02d1\u02e0-\u02e4\u02ec\u02ee\u0370-\u0374\u0376\u0377\u037a-\u037d\u037f\u0386\u0388-\u038a\u038c\u038e-\u03a1\u03a3-\u03f5\u03f7-\u0481\u048a-\u052f\u0531-\u0556\u0559\u0560-\u0588\u05d0-\u05ea\u05ef-\u05f2\u0620-\u064a\u066e\u066f\u0671-\u06d3\u06d5\u06e5\u06e6\u06ee\u06ef\u06fa-\u06fc\u06ff\u0710\u0712-\u072f\u074d-\u07a5\u07b1\u07ca-\u07ea\u07f4\u07f5\u07fa\u0800-\u0815\u081a\u0824\u0828\u0840-\u0858\u0860-\u086a\u0870-\u0887\u0889-\u088e\u08a0-\u08c9\u0904-\u0939\u093d\u0950\u0958-\u0961\u0971-\u0980\u0985-\u098c\u098f\u0990\u0993-\u09a8\u09aa-\u09b0\u09b2\u09b6-\u09b9\u09bd\u09ce\u09dc\u09dd\u09df-\u09e1\u09f0\u09f1\u09fc\u0a05-\u0a0a\u0a0f\u0a10\u0a13-\u0a28\u0a2a-\u0a30\u0a32\u0a33\u0a35\u0a36\u0a38\u0a39\u0a59-\u0a5c\u0a5e\u0a72-\u0a74\u0a85-\u0a8d\u0a8f-\u0a91\u0a93-\u0aa8\u0aaa-\u0ab0\u0ab2\u0ab3\u0ab5-\u0ab9\u0abd\u0ad0\u0ae0\u0ae1\u0af9\u0b05-\u0b0c\u0b0f\u0b10\u0b13-\u0b28\u0b2a-\u0b30\u0b32\u0b33\u0b35-\u0b39\u0b3d\u0b5c\u0b5d\u0b5f-\u0b61\u0b71\u0b83\u0b85-\u0b8a\u0b8e-\u0b90\u0b92-\u0b95\u0b99\u0b9a\u0b9c\u0b9e\u0b9f\u0ba3\u0ba4\u0ba8-\u0baa\u0bae-\u0bb9\u0bd0\u0c05-\u0c0c\u0c0e-\u0c10\u0c12-\u0c28\u0c2a-\u0c39\u0c3d\u0c58-\u0c5a\u0c5d\u0c60\u0c61\u0c80\u0c85-\u0c8c\u0c8e-\u0c90\u0c92-\u0ca8\u0caa-\u0cb3\u0cb5-\u0cb9\u0cbd\u0cdd\u0cde\u0ce0\u0ce1\u0cf1\u0cf2\u0d04-\u0d0c\u0d0e-\u0d10\u0d12-\u0d3a\u0d3d\u0d4e\u0d54-\u0d56\u0d5f-\u0d61\u0d7a-\u0d7f\u0d85-\u0d96\u0d9a-\u0db1\u0db3-\u0dbb\u0dbd\u0dc0-\u0dc6\u0e01-\u0e30\u0e32\u0e33\u0e40-\u0e46\u0e81\u0e82\u0e84\u0e86-\u0e8a\u0e8c-\u0ea3\u0ea5\u0ea7-\u0eb0\u0eb2\u0eb3\u0ebd\u0ec0-\u0ec4\u0ec6\u0edc-\u0edf\u0f00\u0f40-\u0f47\u0f49-\u0f6c\u0f88-\u0f8c\u1000-\u102a\u103f\u1050-\u1055\u105a-\u105d\u1061\u1065\u1066\u106e-\u1070\u1075-\u1081\u108e\u10a0-\u10c5\u10c7\u10cd\u10d0-\u10fa\u10fc-\u1248\u124a-\u124d\u1250-\u1256\u1258\u125a-\u125d\u1260-\u1288\u128a-\u128d\u1290-\u12b0\u12b2-\u12b5\u12b8-\u12be\u12c0\u12c2-\u12c5\u12c8-\u12d6\u12d8-\u1310\u1312-\u1315\u1318-\u135a\u1380-\u138f\u13a0-\u13f5\u13f8-\u13fd\u1401-\u166c\u166f-\u167f\u1681-\u169a\u16a0-\u16ea\u16ee-\u16f8\u1700-\u1711\u171f-\u1731\u1740-\u1751\u1760-\u176c\u176e-\u1770\u1780-\u17b3\u17d7\u17dc\u1820-\u1878\u1880-\u18a8\u18aa\u18b0-\u18f5\u1900-\u191e\u1950-\u196d\u1970-\u1974\u1980-\u19ab\u19b0-\u19c9\u1a00-\u1a16\u1a20-\u1a54\u1aa7\u1b05-\u1b33\u1b45-\u1b4c\u1b83-\u1ba0\u1bae\u1baf\u1bba-\u1be5\u1c00-\u1c23\u1c4d-\u1c4f\u1c5a-\u1c7d\u1c80-\u1c88\u1c90-\u1cba\u1cbd-\u1cbf\u1ce9-\u1cec\u1cee-\u1cf3\u1cf5\u1cf6\u1cfa\u1d00-\u1dbf\u1e00-\u1f15\u1f18-\u1f1d\u1f20-\u1f45\u1f48-\u1f4d\u1f50-\u1f57\u1f59\u1f5b\u1f5d\u1f5f-\u1f7d\u1f80-\u1fb4\u1fb6-\u1fbc\u1fbe\u1fc2-\u1fc4\u1fc6-\u1fcc\u1fd0-\u1fd3\u1fd6-\u1fdb\u1fe0-\u1fec\u1ff2-\u1ff4\u1ff6-\u1ffc\u2071\u207f\u2090-\u209c\u2102\u2107\u210a-\u2113\u2115\u2118-\u211d\u2124\u2126\u2128\u212a-\u2139\u213c-\u213f\u2145-\u2149\u214e\u2160-\u2188\u2c00-\u2ce4\u2ceb-\u2cee\u2cf2\u2cf3\u2d00-\u2d25\u2d27\u2d2d\u2d30-\u2d67\u2d6f\u2d80-\u2d96\u2da0-\u2da6\u2da8-\u2dae\u2db0-\u2db6\u2db8-\u2dbe\u2dc0-\u2dc6\u2dc8-\u2dce\u2dd0-\u2dd6\u2dd8-\u2dde\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303c\u3041-\u3096\u309b-\u309f\u30a1-\u30fa\u30fc-\u30ff\u3105-\u312f\u3131-\u318e\u31a0-\u31bf\u31f0-\u31ff\u3400-\u4dbf\u4e00-\ua48c\ua4d0-\ua4fd\ua500-\ua60c\ua610-\ua61f\ua62a\ua62b\ua640-\ua66e\ua67f-\ua69d\ua6a0-\ua6ef\ua717-\ua71f\ua722-\ua788\ua78b-\ua7ca\ua7d0\ua7d1\ua7d3\ua7d5-\ua7d9\ua7f2-\ua801\ua803-\ua805\ua807-\ua80a\ua80c-\ua822\ua840-\ua873\ua882-\ua8b3\ua8f2-\ua8f7\ua8fb\ua8fd\ua8fe\ua90a-\ua925\ua930-\ua946\ua960-\ua97c\ua984-\ua9b2\ua9cf\ua9e0-\ua9e4\ua9e6-\ua9ef\ua9fa-\ua9fe\uaa00-\uaa28\uaa40-\uaa42\uaa44-\uaa4b\uaa60-\uaa76\uaa7a\uaa7e-\uaaaf\uaab1\uaab5\uaab6\uaab9-\uaabd\uaac0\uaac2\uaadb-\uaadd\uaae0-\uaaea\uaaf2-\uaaf4\uab01-\uab06\uab09-\uab0e\uab11-\uab16\uab20-\uab26\uab28-\uab2e\uab30-\uab5a\uab5c-\uab69\uab70-\uabe2\uac00-\ud7a3\ud7b0-\ud7c6\ud7cb-\ud7fb\uf900-\ufa6d\ufa70-\ufad9\ufb00-\ufb06\ufb13-\ufb17\ufb1d\ufb1f-\ufb28\ufb2a-\ufb36\ufb38-\ufb3c\ufb3e\ufb40\ufb41\ufb43\ufb44\ufb46-\ufbb1\ufbd3-\ufd3d\ufd50-\ufd8f\ufd92-\ufdc7\ufdf0-\ufdfb\ufe70-\ufe74\ufe76-\ufefc\uff21-\uff3a\uff41-\uff5a\uff66-\uffbe\uffc2-\uffc7\uffca-\uffcf\uffd2-\uffd7\uffda-\uffdc";

		  // These are a run-length and offset encoded representation of the
		  // >0xffff code points that are a valid part of identifiers. The
		  // offset starts at 0x10000, and each pair of numbers represents an
		  // offset to the next range, and then a size of the range.

		  // Reserved word lists for various dialects of the language

		  var reservedWords = {
		    3: "abstract boolean byte char class double enum export extends final float goto implements import int interface long native package private protected public short static super synchronized throws transient volatile",
		    5: "class enum extends super const export import",
		    6: "enum",
		    strict: "implements interface let package private protected public static yield",
		    strictBind: "eval arguments"
		  };

		  // And the keywords

		  var ecma5AndLessKeywords = "break case catch continue debugger default do else finally for function if return switch throw try var while with null true false instanceof typeof void delete new in this";

		  var keywords$1 = {
		    5: ecma5AndLessKeywords,
		    "5module": ecma5AndLessKeywords + " export import",
		    6: ecma5AndLessKeywords + " const class extends export import super"
		  };

		  var keywordRelationalOperator = /^in(stanceof)?$/;

		  // ## Character categories

		  var nonASCIIidentifierStart = new RegExp("[" + nonASCIIidentifierStartChars + "]");
		  var nonASCIIidentifier = new RegExp("[" + nonASCIIidentifierStartChars + nonASCIIidentifierChars + "]");

		  // This has a complexity linear to the value of the code. The
		  // assumption is that looking up astral identifier characters is
		  // rare.
		  function isInAstralSet(code, set) {
		    var pos = 0x10000;
		    for (var i = 0; i < set.length; i += 2) {
		      pos += set[i];
		      if (pos > code) { return false }
		      pos += set[i + 1];
		      if (pos >= code) { return true }
		    }
		    return false
		  }

		  // Test whether a given character code starts an identifier.

		  function isIdentifierStart(code, astral) {
		    if (code < 65) { return code === 36 }
		    if (code < 91) { return true }
		    if (code < 97) { return code === 95 }
		    if (code < 123) { return true }
		    if (code <= 0xffff) { return code >= 0xaa && nonASCIIidentifierStart.test(String.fromCharCode(code)) }
		    if (astral === false) { return false }
		    return isInAstralSet(code, astralIdentifierStartCodes)
		  }

		  // Test whether a given character is part of an identifier.

		  function isIdentifierChar(code, astral) {
		    if (code < 48) { return code === 36 }
		    if (code < 58) { return true }
		    if (code < 65) { return false }
		    if (code < 91) { return true }
		    if (code < 97) { return code === 95 }
		    if (code < 123) { return true }
		    if (code <= 0xffff) { return code >= 0xaa && nonASCIIidentifier.test(String.fromCharCode(code)) }
		    if (astral === false) { return false }
		    return isInAstralSet(code, astralIdentifierStartCodes) || isInAstralSet(code, astralIdentifierCodes)
		  }

		  // ## Token types

		  // The assignment of fine-grained, information-carrying type objects
		  // allows the tokenizer to store the information it has about a
		  // token in a way that is very cheap for the parser to look up.

		  // All token type variables start with an underscore, to make them
		  // easy to recognize.

		  // The `beforeExpr` property is used to disambiguate between regular
		  // expressions and divisions. It is set on all token types that can
		  // be followed by an expression (thus, a slash after them would be a
		  // regular expression).
		  //
		  // The `startsExpr` property is used to check if the token ends a
		  // `yield` expression. It is set on all token types that either can
		  // directly start an expression (like a quotation mark) or can
		  // continue an expression (like the body of a string).
		  //
		  // `isLoop` marks a keyword as starting a loop, which is important
		  // to know when parsing a label, in order to allow or disallow
		  // continue jumps to that label.

		  var TokenType = function TokenType(label, conf) {
		    if ( conf === void 0 ) conf = {};

		    this.label = label;
		    this.keyword = conf.keyword;
		    this.beforeExpr = !!conf.beforeExpr;
		    this.startsExpr = !!conf.startsExpr;
		    this.isLoop = !!conf.isLoop;
		    this.isAssign = !!conf.isAssign;
		    this.prefix = !!conf.prefix;
		    this.postfix = !!conf.postfix;
		    this.binop = conf.binop || null;
		    this.updateContext = null;
		  };

		  function binop(name, prec) {
		    return new TokenType(name, {beforeExpr: true, binop: prec})
		  }
		  var beforeExpr = {beforeExpr: true}, startsExpr = {startsExpr: true};

		  // Map keyword names to token types.

		  var keywords = {};

		  // Succinct definitions of keyword token types
		  function kw(name, options) {
		    if ( options === void 0 ) options = {};

		    options.keyword = name;
		    return keywords[name] = new TokenType(name, options)
		  }

		  var types$1 = {
		    num: new TokenType("num", startsExpr),
		    regexp: new TokenType("regexp", startsExpr),
		    string: new TokenType("string", startsExpr),
		    name: new TokenType("name", startsExpr),
		    privateId: new TokenType("privateId", startsExpr),
		    eof: new TokenType("eof"),

		    // Punctuation token types.
		    bracketL: new TokenType("[", {beforeExpr: true, startsExpr: true}),
		    bracketR: new TokenType("]"),
		    braceL: new TokenType("{", {beforeExpr: true, startsExpr: true}),
		    braceR: new TokenType("}"),
		    parenL: new TokenType("(", {beforeExpr: true, startsExpr: true}),
		    parenR: new TokenType(")"),
		    comma: new TokenType(",", beforeExpr),
		    semi: new TokenType(";", beforeExpr),
		    colon: new TokenType(":", beforeExpr),
		    dot: new TokenType("."),
		    question: new TokenType("?", beforeExpr),
		    questionDot: new TokenType("?."),
		    arrow: new TokenType("=>", beforeExpr),
		    template: new TokenType("template"),
		    invalidTemplate: new TokenType("invalidTemplate"),
		    ellipsis: new TokenType("...", beforeExpr),
		    backQuote: new TokenType("`", startsExpr),
		    dollarBraceL: new TokenType("${", {beforeExpr: true, startsExpr: true}),

		    // Operators. These carry several kinds of properties to help the
		    // parser use them properly (the presence of these properties is
		    // what categorizes them as operators).
		    //
		    // `binop`, when present, specifies that this operator is a binary
		    // operator, and will refer to its precedence.
		    //
		    // `prefix` and `postfix` mark the operator as a prefix or postfix
		    // unary operator.
		    //
		    // `isAssign` marks all of `=`, `+=`, `-=` etcetera, which act as
		    // binary operators with a very low precedence, that should result
		    // in AssignmentExpression nodes.

		    eq: new TokenType("=", {beforeExpr: true, isAssign: true}),
		    assign: new TokenType("_=", {beforeExpr: true, isAssign: true}),
		    incDec: new TokenType("++/--", {prefix: true, postfix: true, startsExpr: true}),
		    prefix: new TokenType("!/~", {beforeExpr: true, prefix: true, startsExpr: true}),
		    logicalOR: binop("||", 1),
		    logicalAND: binop("&&", 2),
		    bitwiseOR: binop("|", 3),
		    bitwiseXOR: binop("^", 4),
		    bitwiseAND: binop("&", 5),
		    equality: binop("==/!=/===/!==", 6),
		    relational: binop("</>/<=/>=", 7),
		    bitShift: binop("<</>>/>>>", 8),
		    plusMin: new TokenType("+/-", {beforeExpr: true, binop: 9, prefix: true, startsExpr: true}),
		    modulo: binop("%", 10),
		    star: binop("*", 10),
		    slash: binop("/", 10),
		    starstar: new TokenType("**", {beforeExpr: true}),
		    coalesce: binop("??", 1),

		    // Keyword token types.
		    _break: kw("break"),
		    _case: kw("case", beforeExpr),
		    _catch: kw("catch"),
		    _continue: kw("continue"),
		    _debugger: kw("debugger"),
		    _default: kw("default", beforeExpr),
		    _do: kw("do", {isLoop: true, beforeExpr: true}),
		    _else: kw("else", beforeExpr),
		    _finally: kw("finally"),
		    _for: kw("for", {isLoop: true}),
		    _function: kw("function", startsExpr),
		    _if: kw("if"),
		    _return: kw("return", beforeExpr),
		    _switch: kw("switch"),
		    _throw: kw("throw", beforeExpr),
		    _try: kw("try"),
		    _var: kw("var"),
		    _const: kw("const"),
		    _while: kw("while", {isLoop: true}),
		    _with: kw("with"),
		    _new: kw("new", {beforeExpr: true, startsExpr: true}),
		    _this: kw("this", startsExpr),
		    _super: kw("super", startsExpr),
		    _class: kw("class", startsExpr),
		    _extends: kw("extends", beforeExpr),
		    _export: kw("export"),
		    _import: kw("import", startsExpr),
		    _null: kw("null", startsExpr),
		    _true: kw("true", startsExpr),
		    _false: kw("false", startsExpr),
		    _in: kw("in", {beforeExpr: true, binop: 7}),
		    _instanceof: kw("instanceof", {beforeExpr: true, binop: 7}),
		    _typeof: kw("typeof", {beforeExpr: true, prefix: true, startsExpr: true}),
		    _void: kw("void", {beforeExpr: true, prefix: true, startsExpr: true}),
		    _delete: kw("delete", {beforeExpr: true, prefix: true, startsExpr: true})
		  };

		  // Matches a whole line break (where CRLF is considered a single
		  // line break). Used to count lines.

		  var lineBreak = /\r\n?|\n|\u2028|\u2029/;
		  var lineBreakG = new RegExp(lineBreak.source, "g");

		  function isNewLine(code) {
		    return code === 10 || code === 13 || code === 0x2028 || code === 0x2029
		  }

		  function nextLineBreak(code, from, end) {
		    if ( end === void 0 ) end = code.length;

		    for (var i = from; i < end; i++) {
		      var next = code.charCodeAt(i);
		      if (isNewLine(next))
		        { return i < end - 1 && next === 13 && code.charCodeAt(i + 1) === 10 ? i + 2 : i + 1 }
		    }
		    return -1
		  }

		  var nonASCIIwhitespace = /[\u1680\u2000-\u200a\u202f\u205f\u3000\ufeff]/;

		  var skipWhiteSpace = /(?:\s|\/\/.*|\/\*[^]*?\*\/)*/g;

		  var ref = Object.prototype;
		  var hasOwnProperty = ref.hasOwnProperty;
		  var toString = ref.toString;

		  var hasOwn = Object.hasOwn || (function (obj, propName) { return (
		    hasOwnProperty.call(obj, propName)
		  ); });

		  var isArray = Array.isArray || (function (obj) { return (
		    toString.call(obj) === "[object Array]"
		  ); });

		  var regexpCache = Object.create(null);

		  function wordsRegexp(words) {
		    return regexpCache[words] || (regexpCache[words] = new RegExp("^(?:" + words.replace(/ /g, "|") + ")$"))
		  }

		  function codePointToString(code) {
		    // UTF-16 Decoding
		    if (code <= 0xFFFF) { return String.fromCharCode(code) }
		    code -= 0x10000;
		    return String.fromCharCode((code >> 10) + 0xD800, (code & 1023) + 0xDC00)
		  }

		  var loneSurrogate = /(?:[\uD800-\uDBFF](?![\uDC00-\uDFFF])|(?:[^\uD800-\uDBFF]|^)[\uDC00-\uDFFF])/;

		  // These are used when `options.locations` is on, for the
		  // `startLoc` and `endLoc` properties.

		  var Position = function Position(line, col) {
		    this.line = line;
		    this.column = col;
		  };

		  Position.prototype.offset = function offset (n) {
		    return new Position(this.line, this.column + n)
		  };

		  var SourceLocation = function SourceLocation(p, start, end) {
		    this.start = start;
		    this.end = end;
		    if (p.sourceFile !== null) { this.source = p.sourceFile; }
		  };

		  // The `getLineInfo` function is mostly useful when the
		  // `locations` option is off (for performance reasons) and you
		  // want to find the line/column position for a given character
		  // offset. `input` should be the code string that the offset refers
		  // into.

		  function getLineInfo(input, offset) {
		    for (var line = 1, cur = 0;;) {
		      var nextBreak = nextLineBreak(input, cur, offset);
		      if (nextBreak < 0) { return new Position(line, offset - cur) }
		      ++line;
		      cur = nextBreak;
		    }
		  }

		  // A second argument must be given to configure the parser process.
		  // These options are recognized (only `ecmaVersion` is required):

		  var defaultOptions = {
		    // `ecmaVersion` indicates the ECMAScript version to parse. Must be
		    // either 3, 5, 6 (or 2015), 7 (2016), 8 (2017), 9 (2018), 10
		    // (2019), 11 (2020), 12 (2021), 13 (2022), 14 (2023), or `"latest"`
		    // (the latest version the library supports). This influences
		    // support for strict mode, the set of reserved words, and support
		    // for new syntax features.
		    ecmaVersion: null,
		    // `sourceType` indicates the mode the code should be parsed in.
		    // Can be either `"script"` or `"module"`. This influences global
		    // strict mode and parsing of `import` and `export` declarations.
		    sourceType: "script",
		    // `onInsertedSemicolon` can be a callback that will be called when
		    // a semicolon is automatically inserted. It will be passed the
		    // position of the inserted semicolon as an offset, and if
		    // `locations` is enabled, it is given the location as a `{line,
		    // column}` object as second argument.
		    onInsertedSemicolon: null,
		    // `onTrailingComma` is similar to `onInsertedSemicolon`, but for
		    // trailing commas.
		    onTrailingComma: null,
		    // By default, reserved words are only enforced if ecmaVersion >= 5.
		    // Set `allowReserved` to a boolean value to explicitly turn this on
		    // an off. When this option has the value "never", reserved words
		    // and keywords can also not be used as property names.
		    allowReserved: null,
		    // When enabled, a return at the top level is not considered an
		    // error.
		    allowReturnOutsideFunction: false,
		    // When enabled, import/export statements are not constrained to
		    // appearing at the top of the program, and an import.meta expression
		    // in a script isn't considered an error.
		    allowImportExportEverywhere: false,
		    // By default, await identifiers are allowed to appear at the top-level scope only if ecmaVersion >= 2022.
		    // When enabled, await identifiers are allowed to appear at the top-level scope,
		    // but they are still not allowed in non-async functions.
		    allowAwaitOutsideFunction: null,
		    // When enabled, super identifiers are not constrained to
		    // appearing in methods and do not raise an error when they appear elsewhere.
		    allowSuperOutsideMethod: null,
		    // When enabled, hashbang directive in the beginning of file is
		    // allowed and treated as a line comment. Enabled by default when
		    // `ecmaVersion` >= 2023.
		    allowHashBang: false,
		    // By default, the parser will verify that private properties are
		    // only used in places where they are valid and have been declared.
		    // Set this to false to turn such checks off.
		    checkPrivateFields: true,
		    // When `locations` is on, `loc` properties holding objects with
		    // `start` and `end` properties in `{line, column}` form (with
		    // line being 1-based and column 0-based) will be attached to the
		    // nodes.
		    locations: false,
		    // A function can be passed as `onToken` option, which will
		    // cause Acorn to call that function with object in the same
		    // format as tokens returned from `tokenizer().getToken()`. Note
		    // that you are not allowed to call the parser from the
		    // callback—that will corrupt its internal state.
		    onToken: null,
		    // A function can be passed as `onComment` option, which will
		    // cause Acorn to call that function with `(block, text, start,
		    // end)` parameters whenever a comment is skipped. `block` is a
		    // boolean indicating whether this is a block (`/* */`) comment,
		    // `text` is the content of the comment, and `start` and `end` are
		    // character offsets that denote the start and end of the comment.
		    // When the `locations` option is on, two more parameters are
		    // passed, the full `{line, column}` locations of the start and
		    // end of the comments. Note that you are not allowed to call the
		    // parser from the callback—that will corrupt its internal state.
		    // When this option has an array as value, objects representing the
		    // comments are pushed to it.
		    onComment: null,
		    // Nodes have their start and end characters offsets recorded in
		    // `start` and `end` properties (directly on the node, rather than
		    // the `loc` object, which holds line/column data. To also add a
		    // [semi-standardized][range] `range` property holding a `[start,
		    // end]` array with the same numbers, set the `ranges` option to
		    // `true`.
		    //
		    // [range]: https://bugzilla.mozilla.org/show_bug.cgi?id=745678
		    ranges: false,
		    // It is possible to parse multiple files into a single AST by
		    // passing the tree produced by parsing the first file as
		    // `program` option in subsequent parses. This will add the
		    // toplevel forms of the parsed file to the `Program` (top) node
		    // of an existing parse tree.
		    program: null,
		    // When `locations` is on, you can pass this to record the source
		    // file in every node's `loc` object.
		    sourceFile: null,
		    // This value, if given, is stored in every node, whether
		    // `locations` is on or off.
		    directSourceFile: null,
		    // When enabled, parenthesized expressions are represented by
		    // (non-standard) ParenthesizedExpression nodes
		    preserveParens: false
		  };

		  // Interpret and default an options object

		  var warnedAboutEcmaVersion = false;

		  function getOptions(opts) {
		    var options = {};

		    for (var opt in defaultOptions)
		      { options[opt] = opts && hasOwn(opts, opt) ? opts[opt] : defaultOptions[opt]; }

		    if (options.ecmaVersion === "latest") {
		      options.ecmaVersion = 1e8;
		    } else if (options.ecmaVersion == null) {
		      if (!warnedAboutEcmaVersion && typeof console === "object" && console.warn) {
		        warnedAboutEcmaVersion = true;
		        console.warn("Since Acorn 8.0.0, options.ecmaVersion is required.\nDefaulting to 2020, but this will stop working in the future.");
		      }
		      options.ecmaVersion = 11;
		    } else if (options.ecmaVersion >= 2015) {
		      options.ecmaVersion -= 2009;
		    }

		    if (options.allowReserved == null)
		      { options.allowReserved = options.ecmaVersion < 5; }

		    if (!opts || opts.allowHashBang == null)
		      { options.allowHashBang = options.ecmaVersion >= 14; }

		    if (isArray(options.onToken)) {
		      var tokens = options.onToken;
		      options.onToken = function (token) { return tokens.push(token); };
		    }
		    if (isArray(options.onComment))
		      { options.onComment = pushComment(options, options.onComment); }

		    return options
		  }

		  function pushComment(options, array) {
		    return function(block, text, start, end, startLoc, endLoc) {
		      var comment = {
		        type: block ? "Block" : "Line",
		        value: text,
		        start: start,
		        end: end
		      };
		      if (options.locations)
		        { comment.loc = new SourceLocation(this, startLoc, endLoc); }
		      if (options.ranges)
		        { comment.range = [start, end]; }
		      array.push(comment);
		    }
		  }

		  // Each scope gets a bitset that may contain these flags
		  var
		      SCOPE_TOP = 1,
		      SCOPE_FUNCTION = 2,
		      SCOPE_ASYNC = 4,
		      SCOPE_GENERATOR = 8,
		      SCOPE_ARROW = 16,
		      SCOPE_SIMPLE_CATCH = 32,
		      SCOPE_SUPER = 64,
		      SCOPE_DIRECT_SUPER = 128,
		      SCOPE_CLASS_STATIC_BLOCK = 256,
		      SCOPE_VAR = SCOPE_TOP | SCOPE_FUNCTION | SCOPE_CLASS_STATIC_BLOCK;

		  function functionFlags(async, generator) {
		    return SCOPE_FUNCTION | (async ? SCOPE_ASYNC : 0) | (generator ? SCOPE_GENERATOR : 0)
		  }

		  // Used in checkLVal* and declareName to determine the type of a binding
		  var
		      BIND_NONE = 0, // Not a binding
		      BIND_VAR = 1, // Var-style binding
		      BIND_LEXICAL = 2, // Let- or const-style binding
		      BIND_FUNCTION = 3, // Function declaration
		      BIND_SIMPLE_CATCH = 4, // Simple (identifier pattern) catch binding
		      BIND_OUTSIDE = 5; // Special case for function names as bound inside the function

		  var Parser = function Parser(options, input, startPos) {
		    this.options = options = getOptions(options);
		    this.sourceFile = options.sourceFile;
		    this.keywords = wordsRegexp(keywords$1[options.ecmaVersion >= 6 ? 6 : options.sourceType === "module" ? "5module" : 5]);
		    var reserved = "";
		    if (options.allowReserved !== true) {
		      reserved = reservedWords[options.ecmaVersion >= 6 ? 6 : options.ecmaVersion === 5 ? 5 : 3];
		      if (options.sourceType === "module") { reserved += " await"; }
		    }
		    this.reservedWords = wordsRegexp(reserved);
		    var reservedStrict = (reserved ? reserved + " " : "") + reservedWords.strict;
		    this.reservedWordsStrict = wordsRegexp(reservedStrict);
		    this.reservedWordsStrictBind = wordsRegexp(reservedStrict + " " + reservedWords.strictBind);
		    this.input = String(input);

		    // Used to signal to callers of `readWord1` whether the word
		    // contained any escape sequences. This is needed because words with
		    // escape sequences must not be interpreted as keywords.
		    this.containsEsc = false;

		    // Set up token state

		    // The current position of the tokenizer in the input.
		    if (startPos) {
		      this.pos = startPos;
		      this.lineStart = this.input.lastIndexOf("\n", startPos - 1) + 1;
		      this.curLine = this.input.slice(0, this.lineStart).split(lineBreak).length;
		    } else {
		      this.pos = this.lineStart = 0;
		      this.curLine = 1;
		    }

		    // Properties of the current token:
		    // Its type
		    this.type = types$1.eof;
		    // For tokens that include more information than their type, the value
		    this.value = null;
		    // Its start and end offset
		    this.start = this.end = this.pos;
		    // And, if locations are used, the {line, column} object
		    // corresponding to those offsets
		    this.startLoc = this.endLoc = this.curPosition();

		    // Position information for the previous token
		    this.lastTokEndLoc = this.lastTokStartLoc = null;
		    this.lastTokStart = this.lastTokEnd = this.pos;

		    // The context stack is used to superficially track syntactic
		    // context to predict whether a regular expression is allowed in a
		    // given position.
		    this.context = this.initialContext();
		    this.exprAllowed = true;

		    // Figure out if it's a module code.
		    this.inModule = options.sourceType === "module";
		    this.strict = this.inModule || this.strictDirective(this.pos);

		    // Used to signify the start of a potential arrow function
		    this.potentialArrowAt = -1;
		    this.potentialArrowInForAwait = false;

		    // Positions to delayed-check that yield/await does not exist in default parameters.
		    this.yieldPos = this.awaitPos = this.awaitIdentPos = 0;
		    // Labels in scope.
		    this.labels = [];
		    // Thus-far undefined exports.
		    this.undefinedExports = Object.create(null);

		    // If enabled, skip leading hashbang line.
		    if (this.pos === 0 && options.allowHashBang && this.input.slice(0, 2) === "#!")
		      { this.skipLineComment(2); }

		    // Scope tracking for duplicate variable names (see scope.js)
		    this.scopeStack = [];
		    this.enterScope(SCOPE_TOP);

		    // For RegExp validation
		    this.regexpState = null;

		    // The stack of private names.
		    // Each element has two properties: 'declared' and 'used'.
		    // When it exited from the outermost class definition, all used private names must be declared.
		    this.privateNameStack = [];
		  };

		  var prototypeAccessors = { inFunction: { configurable: true },inGenerator: { configurable: true },inAsync: { configurable: true },canAwait: { configurable: true },allowSuper: { configurable: true },allowDirectSuper: { configurable: true },treatFunctionsAsVar: { configurable: true },allowNewDotTarget: { configurable: true },inClassStaticBlock: { configurable: true } };

		  Parser.prototype.parse = function parse () {
		    var node = this.options.program || this.startNode();
		    this.nextToken();
		    return this.parseTopLevel(node)
		  };

		  prototypeAccessors.inFunction.get = function () { return (this.currentVarScope().flags & SCOPE_FUNCTION) > 0 };

		  prototypeAccessors.inGenerator.get = function () { return (this.currentVarScope().flags & SCOPE_GENERATOR) > 0 && !this.currentVarScope().inClassFieldInit };

		  prototypeAccessors.inAsync.get = function () { return (this.currentVarScope().flags & SCOPE_ASYNC) > 0 && !this.currentVarScope().inClassFieldInit };

		  prototypeAccessors.canAwait.get = function () {
		    for (var i = this.scopeStack.length - 1; i >= 0; i--) {
		      var scope = this.scopeStack[i];
		      if (scope.inClassFieldInit || scope.flags & SCOPE_CLASS_STATIC_BLOCK) { return false }
		      if (scope.flags & SCOPE_FUNCTION) { return (scope.flags & SCOPE_ASYNC) > 0 }
		    }
		    return (this.inModule && this.options.ecmaVersion >= 13) || this.options.allowAwaitOutsideFunction
		  };

		  prototypeAccessors.allowSuper.get = function () {
		    var ref = this.currentThisScope();
		      var flags = ref.flags;
		      var inClassFieldInit = ref.inClassFieldInit;
		    return (flags & SCOPE_SUPER) > 0 || inClassFieldInit || this.options.allowSuperOutsideMethod
		  };

		  prototypeAccessors.allowDirectSuper.get = function () { return (this.currentThisScope().flags & SCOPE_DIRECT_SUPER) > 0 };

		  prototypeAccessors.treatFunctionsAsVar.get = function () { return this.treatFunctionsAsVarInScope(this.currentScope()) };

		  prototypeAccessors.allowNewDotTarget.get = function () {
		    var ref = this.currentThisScope();
		      var flags = ref.flags;
		      var inClassFieldInit = ref.inClassFieldInit;
		    return (flags & (SCOPE_FUNCTION | SCOPE_CLASS_STATIC_BLOCK)) > 0 || inClassFieldInit
		  };

		  prototypeAccessors.inClassStaticBlock.get = function () {
		    return (this.currentVarScope().flags & SCOPE_CLASS_STATIC_BLOCK) > 0
		  };

		  Parser.extend = function extend () {
		      var plugins = [], len = arguments.length;
		      while ( len-- ) plugins[ len ] = arguments[ len ];

		    var cls = this;
		    for (var i = 0; i < plugins.length; i++) { cls = plugins[i](cls); }
		    return cls
		  };

		  Parser.parse = function parse (input, options) {
		    return new this(options, input).parse()
		  };

		  Parser.parseExpressionAt = function parseExpressionAt (input, pos, options) {
		    var parser = new this(options, input, pos);
		    parser.nextToken();
		    return parser.parseExpression()
		  };

		  Parser.tokenizer = function tokenizer (input, options) {
		    return new this(options, input)
		  };

		  Object.defineProperties( Parser.prototype, prototypeAccessors );

		  var pp$9 = Parser.prototype;

		  // ## Parser utilities

		  var literal = /^(?:'((?:\\.|[^'\\])*?)'|"((?:\\.|[^"\\])*?)")/;
		  pp$9.strictDirective = function(start) {
		    if (this.options.ecmaVersion < 5) { return false }
		    for (;;) {
		      // Try to find string literal.
		      skipWhiteSpace.lastIndex = start;
		      start += skipWhiteSpace.exec(this.input)[0].length;
		      var match = literal.exec(this.input.slice(start));
		      if (!match) { return false }
		      if ((match[1] || match[2]) === "use strict") {
		        skipWhiteSpace.lastIndex = start + match[0].length;
		        var spaceAfter = skipWhiteSpace.exec(this.input), end = spaceAfter.index + spaceAfter[0].length;
		        var next = this.input.charAt(end);
		        return next === ";" || next === "}" ||
		          (lineBreak.test(spaceAfter[0]) &&
		           !(/[(`.[+\-/*%<>=,?^&]/.test(next) || next === "!" && this.input.charAt(end + 1) === "="))
		      }
		      start += match[0].length;

		      // Skip semicolon, if any.
		      skipWhiteSpace.lastIndex = start;
		      start += skipWhiteSpace.exec(this.input)[0].length;
		      if (this.input[start] === ";")
		        { start++; }
		    }
		  };

		  // Predicate that tests whether the next token is of the given
		  // type, and if yes, consumes it as a side effect.

		  pp$9.eat = function(type) {
		    if (this.type === type) {
		      this.next();
		      return true
		    } else {
		      return false
		    }
		  };

		  // Tests whether parsed token is a contextual keyword.

		  pp$9.isContextual = function(name) {
		    return this.type === types$1.name && this.value === name && !this.containsEsc
		  };

		  // Consumes contextual keyword if possible.

		  pp$9.eatContextual = function(name) {
		    if (!this.isContextual(name)) { return false }
		    this.next();
		    return true
		  };

		  // Asserts that following token is given contextual keyword.

		  pp$9.expectContextual = function(name) {
		    if (!this.eatContextual(name)) { this.unexpected(); }
		  };

		  // Test whether a semicolon can be inserted at the current position.

		  pp$9.canInsertSemicolon = function() {
		    return this.type === types$1.eof ||
		      this.type === types$1.braceR ||
		      lineBreak.test(this.input.slice(this.lastTokEnd, this.start))
		  };

		  pp$9.insertSemicolon = function() {
		    if (this.canInsertSemicolon()) {
		      if (this.options.onInsertedSemicolon)
		        { this.options.onInsertedSemicolon(this.lastTokEnd, this.lastTokEndLoc); }
		      return true
		    }
		  };

		  // Consume a semicolon, or, failing that, see if we are allowed to
		  // pretend that there is a semicolon at this position.

		  pp$9.semicolon = function() {
		    if (!this.eat(types$1.semi) && !this.insertSemicolon()) { this.unexpected(); }
		  };

		  pp$9.afterTrailingComma = function(tokType, notNext) {
		    if (this.type === tokType) {
		      if (this.options.onTrailingComma)
		        { this.options.onTrailingComma(this.lastTokStart, this.lastTokStartLoc); }
		      if (!notNext)
		        { this.next(); }
		      return true
		    }
		  };

		  // Expect a token of a given type. If found, consume it, otherwise,
		  // raise an unexpected token error.

		  pp$9.expect = function(type) {
		    this.eat(type) || this.unexpected();
		  };

		  // Raise an unexpected token error.

		  pp$9.unexpected = function(pos) {
		    this.raise(pos != null ? pos : this.start, "Unexpected token");
		  };

		  var DestructuringErrors = function DestructuringErrors() {
		    this.shorthandAssign =
		    this.trailingComma =
		    this.parenthesizedAssign =
		    this.parenthesizedBind =
		    this.doubleProto =
		      -1;
		  };

		  pp$9.checkPatternErrors = function(refDestructuringErrors, isAssign) {
		    if (!refDestructuringErrors) { return }
		    if (refDestructuringErrors.trailingComma > -1)
		      { this.raiseRecoverable(refDestructuringErrors.trailingComma, "Comma is not permitted after the rest element"); }
		    var parens = isAssign ? refDestructuringErrors.parenthesizedAssign : refDestructuringErrors.parenthesizedBind;
		    if (parens > -1) { this.raiseRecoverable(parens, isAssign ? "Assigning to rvalue" : "Parenthesized pattern"); }
		  };

		  pp$9.checkExpressionErrors = function(refDestructuringErrors, andThrow) {
		    if (!refDestructuringErrors) { return false }
		    var shorthandAssign = refDestructuringErrors.shorthandAssign;
		    var doubleProto = refDestructuringErrors.doubleProto;
		    if (!andThrow) { return shorthandAssign >= 0 || doubleProto >= 0 }
		    if (shorthandAssign >= 0)
		      { this.raise(shorthandAssign, "Shorthand property assignments are valid only in destructuring patterns"); }
		    if (doubleProto >= 0)
		      { this.raiseRecoverable(doubleProto, "Redefinition of __proto__ property"); }
		  };

		  pp$9.checkYieldAwaitInDefaultParams = function() {
		    if (this.yieldPos && (!this.awaitPos || this.yieldPos < this.awaitPos))
		      { this.raise(this.yieldPos, "Yield expression cannot be a default value"); }
		    if (this.awaitPos)
		      { this.raise(this.awaitPos, "Await expression cannot be a default value"); }
		  };

		  pp$9.isSimpleAssignTarget = function(expr) {
		    if (expr.type === "ParenthesizedExpression")
		      { return this.isSimpleAssignTarget(expr.expression) }
		    return expr.type === "Identifier" || expr.type === "MemberExpression"
		  };

		  var pp$8 = Parser.prototype;

		  // ### Statement parsing

		  // Parse a program. Initializes the parser, reads any number of
		  // statements, and wraps them in a Program node.  Optionally takes a
		  // `program` argument.  If present, the statements will be appended
		  // to its body instead of creating a new node.

		  pp$8.parseTopLevel = function(node) {
		    var exports = Object.create(null);
		    if (!node.body) { node.body = []; }
		    while (this.type !== types$1.eof) {
		      var stmt = this.parseStatement(null, true, exports);
		      node.body.push(stmt);
		    }
		    if (this.inModule)
		      { for (var i = 0, list = Object.keys(this.undefinedExports); i < list.length; i += 1)
		        {
		          var name = list[i];

		          this.raiseRecoverable(this.undefinedExports[name].start, ("Export '" + name + "' is not defined"));
		        } }
		    this.adaptDirectivePrologue(node.body);
		    this.next();
		    node.sourceType = this.options.sourceType;
		    return this.finishNode(node, "Program")
		  };

		  var loopLabel = {kind: "loop"}, switchLabel = {kind: "switch"};

		  pp$8.isLet = function(context) {
		    if (this.options.ecmaVersion < 6 || !this.isContextual("let")) { return false }
		    skipWhiteSpace.lastIndex = this.pos;
		    var skip = skipWhiteSpace.exec(this.input);
		    var next = this.pos + skip[0].length, nextCh = this.input.charCodeAt(next);
		    // For ambiguous cases, determine if a LexicalDeclaration (or only a
		    // Statement) is allowed here. If context is not empty then only a Statement
		    // is allowed. However, `let [` is an explicit negative lookahead for
		    // ExpressionStatement, so special-case it first.
		    if (nextCh === 91 || nextCh === 92) { return true } // '[', '/'
		    if (context) { return false }

		    if (nextCh === 123 || nextCh > 0xd7ff && nextCh < 0xdc00) { return true } // '{', astral
		    if (isIdentifierStart(nextCh, true)) {
		      var pos = next + 1;
		      while (isIdentifierChar(nextCh = this.input.charCodeAt(pos), true)) { ++pos; }
		      if (nextCh === 92 || nextCh > 0xd7ff && nextCh < 0xdc00) { return true }
		      var ident = this.input.slice(next, pos);
		      if (!keywordRelationalOperator.test(ident)) { return true }
		    }
		    return false
		  };

		  // check 'async [no LineTerminator here] function'
		  // - 'async /*foo*/ function' is OK.
		  // - 'async /*\n*/ function' is invalid.
		  pp$8.isAsyncFunction = function() {
		    if (this.options.ecmaVersion < 8 || !this.isContextual("async"))
		      { return false }

		    skipWhiteSpace.lastIndex = this.pos;
		    var skip = skipWhiteSpace.exec(this.input);
		    var next = this.pos + skip[0].length, after;
		    return !lineBreak.test(this.input.slice(this.pos, next)) &&
		      this.input.slice(next, next + 8) === "function" &&
		      (next + 8 === this.input.length ||
		       !(isIdentifierChar(after = this.input.charCodeAt(next + 8)) || after > 0xd7ff && after < 0xdc00))
		  };

		  // Parse a single statement.
		  //
		  // If expecting a statement and finding a slash operator, parse a
		  // regular expression literal. This is to handle cases like
		  // `if (foo) /blah/.exec(foo)`, where looking at the previous token
		  // does not help.

		  pp$8.parseStatement = function(context, topLevel, exports) {
		    var starttype = this.type, node = this.startNode(), kind;

		    if (this.isLet(context)) {
		      starttype = types$1._var;
		      kind = "let";
		    }

		    // Most types of statements are recognized by the keyword they
		    // start with. Many are trivial to parse, some require a bit of
		    // complexity.

		    switch (starttype) {
		    case types$1._break: case types$1._continue: return this.parseBreakContinueStatement(node, starttype.keyword)
		    case types$1._debugger: return this.parseDebuggerStatement(node)
		    case types$1._do: return this.parseDoStatement(node)
		    case types$1._for: return this.parseForStatement(node)
		    case types$1._function:
		      // Function as sole body of either an if statement or a labeled statement
		      // works, but not when it is part of a labeled statement that is the sole
		      // body of an if statement.
		      if ((context && (this.strict || context !== "if" && context !== "label")) && this.options.ecmaVersion >= 6) { this.unexpected(); }
		      return this.parseFunctionStatement(node, false, !context)
		    case types$1._class:
		      if (context) { this.unexpected(); }
		      return this.parseClass(node, true)
		    case types$1._if: return this.parseIfStatement(node)
		    case types$1._return: return this.parseReturnStatement(node)
		    case types$1._switch: return this.parseSwitchStatement(node)
		    case types$1._throw: return this.parseThrowStatement(node)
		    case types$1._try: return this.parseTryStatement(node)
		    case types$1._const: case types$1._var:
		      kind = kind || this.value;
		      if (context && kind !== "var") { this.unexpected(); }
		      return this.parseVarStatement(node, kind)
		    case types$1._while: return this.parseWhileStatement(node)
		    case types$1._with: return this.parseWithStatement(node)
		    case types$1.braceL: return this.parseBlock(true, node)
		    case types$1.semi: return this.parseEmptyStatement(node)
		    case types$1._export:
		    case types$1._import:
		      if (this.options.ecmaVersion > 10 && starttype === types$1._import) {
		        skipWhiteSpace.lastIndex = this.pos;
		        var skip = skipWhiteSpace.exec(this.input);
		        var next = this.pos + skip[0].length, nextCh = this.input.charCodeAt(next);
		        if (nextCh === 40 || nextCh === 46) // '(' or '.'
		          { return this.parseExpressionStatement(node, this.parseExpression()) }
		      }

		      if (!this.options.allowImportExportEverywhere) {
		        if (!topLevel)
		          { this.raise(this.start, "'import' and 'export' may only appear at the top level"); }
		        if (!this.inModule)
		          { this.raise(this.start, "'import' and 'export' may appear only with 'sourceType: module'"); }
		      }
		      return starttype === types$1._import ? this.parseImport(node) : this.parseExport(node, exports)

		      // If the statement does not start with a statement keyword or a
		      // brace, it's an ExpressionStatement or LabeledStatement. We
		      // simply start parsing an expression, and afterwards, if the
		      // next token is a colon and the expression was a simple
		      // Identifier node, we switch to interpreting it as a label.
		    default:
		      if (this.isAsyncFunction()) {
		        if (context) { this.unexpected(); }
		        this.next();
		        return this.parseFunctionStatement(node, true, !context)
		      }

		      var maybeName = this.value, expr = this.parseExpression();
		      if (starttype === types$1.name && expr.type === "Identifier" && this.eat(types$1.colon))
		        { return this.parseLabeledStatement(node, maybeName, expr, context) }
		      else { return this.parseExpressionStatement(node, expr) }
		    }
		  };

		  pp$8.parseBreakContinueStatement = function(node, keyword) {
		    var isBreak = keyword === "break";
		    this.next();
		    if (this.eat(types$1.semi) || this.insertSemicolon()) { node.label = null; }
		    else if (this.type !== types$1.name) { this.unexpected(); }
		    else {
		      node.label = this.parseIdent();
		      this.semicolon();
		    }

		    // Verify that there is an actual destination to break or
		    // continue to.
		    var i = 0;
		    for (; i < this.labels.length; ++i) {
		      var lab = this.labels[i];
		      if (node.label == null || lab.name === node.label.name) {
		        if (lab.kind != null && (isBreak || lab.kind === "loop")) { break }
		        if (node.label && isBreak) { break }
		      }
		    }
		    if (i === this.labels.length) { this.raise(node.start, "Unsyntactic " + keyword); }
		    return this.finishNode(node, isBreak ? "BreakStatement" : "ContinueStatement")
		  };

		  pp$8.parseDebuggerStatement = function(node) {
		    this.next();
		    this.semicolon();
		    return this.finishNode(node, "DebuggerStatement")
		  };

		  pp$8.parseDoStatement = function(node) {
		    this.next();
		    this.labels.push(loopLabel);
		    node.body = this.parseStatement("do");
		    this.labels.pop();
		    this.expect(types$1._while);
		    node.test = this.parseParenExpression();
		    if (this.options.ecmaVersion >= 6)
		      { this.eat(types$1.semi); }
		    else
		      { this.semicolon(); }
		    return this.finishNode(node, "DoWhileStatement")
		  };

		  // Disambiguating between a `for` and a `for`/`in` or `for`/`of`
		  // loop is non-trivial. Basically, we have to parse the init `var`
		  // statement or expression, disallowing the `in` operator (see
		  // the second parameter to `parseExpression`), and then check
		  // whether the next token is `in` or `of`. When there is no init
		  // part (semicolon immediately after the opening parenthesis), it
		  // is a regular `for` loop.

		  pp$8.parseForStatement = function(node) {
		    this.next();
		    var awaitAt = (this.options.ecmaVersion >= 9 && this.canAwait && this.eatContextual("await")) ? this.lastTokStart : -1;
		    this.labels.push(loopLabel);
		    this.enterScope(0);
		    this.expect(types$1.parenL);
		    if (this.type === types$1.semi) {
		      if (awaitAt > -1) { this.unexpected(awaitAt); }
		      return this.parseFor(node, null)
		    }
		    var isLet = this.isLet();
		    if (this.type === types$1._var || this.type === types$1._const || isLet) {
		      var init$1 = this.startNode(), kind = isLet ? "let" : this.value;
		      this.next();
		      this.parseVar(init$1, true, kind);
		      this.finishNode(init$1, "VariableDeclaration");
		      if ((this.type === types$1._in || (this.options.ecmaVersion >= 6 && this.isContextual("of"))) && init$1.declarations.length === 1) {
		        if (this.options.ecmaVersion >= 9) {
		          if (this.type === types$1._in) {
		            if (awaitAt > -1) { this.unexpected(awaitAt); }
		          } else { node.await = awaitAt > -1; }
		        }
		        return this.parseForIn(node, init$1)
		      }
		      if (awaitAt > -1) { this.unexpected(awaitAt); }
		      return this.parseFor(node, init$1)
		    }
		    var startsWithLet = this.isContextual("let"), isForOf = false;
		    var refDestructuringErrors = new DestructuringErrors;
		    var init = this.parseExpression(awaitAt > -1 ? "await" : true, refDestructuringErrors);
		    if (this.type === types$1._in || (isForOf = this.options.ecmaVersion >= 6 && this.isContextual("of"))) {
		      if (this.options.ecmaVersion >= 9) {
		        if (this.type === types$1._in) {
		          if (awaitAt > -1) { this.unexpected(awaitAt); }
		        } else { node.await = awaitAt > -1; }
		      }
		      if (startsWithLet && isForOf) { this.raise(init.start, "The left-hand side of a for-of loop may not start with 'let'."); }
		      this.toAssignable(init, false, refDestructuringErrors);
		      this.checkLValPattern(init);
		      return this.parseForIn(node, init)
		    } else {
		      this.checkExpressionErrors(refDestructuringErrors, true);
		    }
		    if (awaitAt > -1) { this.unexpected(awaitAt); }
		    return this.parseFor(node, init)
		  };

		  pp$8.parseFunctionStatement = function(node, isAsync, declarationPosition) {
		    this.next();
		    return this.parseFunction(node, FUNC_STATEMENT | (declarationPosition ? 0 : FUNC_HANGING_STATEMENT), false, isAsync)
		  };

		  pp$8.parseIfStatement = function(node) {
		    this.next();
		    node.test = this.parseParenExpression();
		    // allow function declarations in branches, but only in non-strict mode
		    node.consequent = this.parseStatement("if");
		    node.alternate = this.eat(types$1._else) ? this.parseStatement("if") : null;
		    return this.finishNode(node, "IfStatement")
		  };

		  pp$8.parseReturnStatement = function(node) {
		    if (!this.inFunction && !this.options.allowReturnOutsideFunction)
		      { this.raise(this.start, "'return' outside of function"); }
		    this.next();

		    // In `return` (and `break`/`continue`), the keywords with
		    // optional arguments, we eagerly look for a semicolon or the
		    // possibility to insert one.

		    if (this.eat(types$1.semi) || this.insertSemicolon()) { node.argument = null; }
		    else { node.argument = this.parseExpression(); this.semicolon(); }
		    return this.finishNode(node, "ReturnStatement")
		  };

		  pp$8.parseSwitchStatement = function(node) {
		    this.next();
		    node.discriminant = this.parseParenExpression();
		    node.cases = [];
		    this.expect(types$1.braceL);
		    this.labels.push(switchLabel);
		    this.enterScope(0);

		    // Statements under must be grouped (by label) in SwitchCase
		    // nodes. `cur` is used to keep the node that we are currently
		    // adding statements to.

		    var cur;
		    for (var sawDefault = false; this.type !== types$1.braceR;) {
		      if (this.type === types$1._case || this.type === types$1._default) {
		        var isCase = this.type === types$1._case;
		        if (cur) { this.finishNode(cur, "SwitchCase"); }
		        node.cases.push(cur = this.startNode());
		        cur.consequent = [];
		        this.next();
		        if (isCase) {
		          cur.test = this.parseExpression();
		        } else {
		          if (sawDefault) { this.raiseRecoverable(this.lastTokStart, "Multiple default clauses"); }
		          sawDefault = true;
		          cur.test = null;
		        }
		        this.expect(types$1.colon);
		      } else {
		        if (!cur) { this.unexpected(); }
		        cur.consequent.push(this.parseStatement(null));
		      }
		    }
		    this.exitScope();
		    if (cur) { this.finishNode(cur, "SwitchCase"); }
		    this.next(); // Closing brace
		    this.labels.pop();
		    return this.finishNode(node, "SwitchStatement")
		  };

		  pp$8.parseThrowStatement = function(node) {
		    this.next();
		    if (lineBreak.test(this.input.slice(this.lastTokEnd, this.start)))
		      { this.raise(this.lastTokEnd, "Illegal newline after throw"); }
		    node.argument = this.parseExpression();
		    this.semicolon();
		    return this.finishNode(node, "ThrowStatement")
		  };

		  // Reused empty array added for node fields that are always empty.

		  var empty$1 = [];

		  pp$8.parseCatchClauseParam = function() {
		    var param = this.parseBindingAtom();
		    var simple = param.type === "Identifier";
		    this.enterScope(simple ? SCOPE_SIMPLE_CATCH : 0);
		    this.checkLValPattern(param, simple ? BIND_SIMPLE_CATCH : BIND_LEXICAL);
		    this.expect(types$1.parenR);

		    return param
		  };

		  pp$8.parseTryStatement = function(node) {
		    this.next();
		    node.block = this.parseBlock();
		    node.handler = null;
		    if (this.type === types$1._catch) {
		      var clause = this.startNode();
		      this.next();
		      if (this.eat(types$1.parenL)) {
		        clause.param = this.parseCatchClauseParam();
		      } else {
		        if (this.options.ecmaVersion < 10) { this.unexpected(); }
		        clause.param = null;
		        this.enterScope(0);
		      }
		      clause.body = this.parseBlock(false);
		      this.exitScope();
		      node.handler = this.finishNode(clause, "CatchClause");
		    }
		    node.finalizer = this.eat(types$1._finally) ? this.parseBlock() : null;
		    if (!node.handler && !node.finalizer)
		      { this.raise(node.start, "Missing catch or finally clause"); }
		    return this.finishNode(node, "TryStatement")
		  };

		  pp$8.parseVarStatement = function(node, kind, allowMissingInitializer) {
		    this.next();
		    this.parseVar(node, false, kind, allowMissingInitializer);
		    this.semicolon();
		    return this.finishNode(node, "VariableDeclaration")
		  };

		  pp$8.parseWhileStatement = function(node) {
		    this.next();
		    node.test = this.parseParenExpression();
		    this.labels.push(loopLabel);
		    node.body = this.parseStatement("while");
		    this.labels.pop();
		    return this.finishNode(node, "WhileStatement")
		  };

		  pp$8.parseWithStatement = function(node) {
		    if (this.strict) { this.raise(this.start, "'with' in strict mode"); }
		    this.next();
		    node.object = this.parseParenExpression();
		    node.body = this.parseStatement("with");
		    return this.finishNode(node, "WithStatement")
		  };

		  pp$8.parseEmptyStatement = function(node) {
		    this.next();
		    return this.finishNode(node, "EmptyStatement")
		  };

		  pp$8.parseLabeledStatement = function(node, maybeName, expr, context) {
		    for (var i$1 = 0, list = this.labels; i$1 < list.length; i$1 += 1)
		      {
		      var label = list[i$1];

		      if (label.name === maybeName)
		        { this.raise(expr.start, "Label '" + maybeName + "' is already declared");
		    } }
		    var kind = this.type.isLoop ? "loop" : this.type === types$1._switch ? "switch" : null;
		    for (var i = this.labels.length - 1; i >= 0; i--) {
		      var label$1 = this.labels[i];
		      if (label$1.statementStart === node.start) {
		        // Update information about previous labels on this node
		        label$1.statementStart = this.start;
		        label$1.kind = kind;
		      } else { break }
		    }
		    this.labels.push({name: maybeName, kind: kind, statementStart: this.start});
		    node.body = this.parseStatement(context ? context.indexOf("label") === -1 ? context + "label" : context : "label");
		    this.labels.pop();
		    node.label = expr;
		    return this.finishNode(node, "LabeledStatement")
		  };

		  pp$8.parseExpressionStatement = function(node, expr) {
		    node.expression = expr;
		    this.semicolon();
		    return this.finishNode(node, "ExpressionStatement")
		  };

		  // Parse a semicolon-enclosed block of statements, handling `"use
		  // strict"` declarations when `allowStrict` is true (used for
		  // function bodies).

		  pp$8.parseBlock = function(createNewLexicalScope, node, exitStrict) {
		    if ( createNewLexicalScope === void 0 ) createNewLexicalScope = true;
		    if ( node === void 0 ) node = this.startNode();

		    node.body = [];
		    this.expect(types$1.braceL);
		    if (createNewLexicalScope) { this.enterScope(0); }
		    while (this.type !== types$1.braceR) {
		      var stmt = this.parseStatement(null);
		      node.body.push(stmt);
		    }
		    if (exitStrict) { this.strict = false; }
		    this.next();
		    if (createNewLexicalScope) { this.exitScope(); }
		    return this.finishNode(node, "BlockStatement")
		  };

		  // Parse a regular `for` loop. The disambiguation code in
		  // `parseStatement` will already have parsed the init statement or
		  // expression.

		  pp$8.parseFor = function(node, init) {
		    node.init = init;
		    this.expect(types$1.semi);
		    node.test = this.type === types$1.semi ? null : this.parseExpression();
		    this.expect(types$1.semi);
		    node.update = this.type === types$1.parenR ? null : this.parseExpression();
		    this.expect(types$1.parenR);
		    node.body = this.parseStatement("for");
		    this.exitScope();
		    this.labels.pop();
		    return this.finishNode(node, "ForStatement")
		  };

		  // Parse a `for`/`in` and `for`/`of` loop, which are almost
		  // same from parser's perspective.

		  pp$8.parseForIn = function(node, init) {
		    var isForIn = this.type === types$1._in;
		    this.next();

		    if (
		      init.type === "VariableDeclaration" &&
		      init.declarations[0].init != null &&
		      (
		        !isForIn ||
		        this.options.ecmaVersion < 8 ||
		        this.strict ||
		        init.kind !== "var" ||
		        init.declarations[0].id.type !== "Identifier"
		      )
		    ) {
		      this.raise(
		        init.start,
		        ((isForIn ? "for-in" : "for-of") + " loop variable declaration may not have an initializer")
		      );
		    }
		    node.left = init;
		    node.right = isForIn ? this.parseExpression() : this.parseMaybeAssign();
		    this.expect(types$1.parenR);
		    node.body = this.parseStatement("for");
		    this.exitScope();
		    this.labels.pop();
		    return this.finishNode(node, isForIn ? "ForInStatement" : "ForOfStatement")
		  };

		  // Parse a list of variable declarations.

		  pp$8.parseVar = function(node, isFor, kind, allowMissingInitializer) {
		    node.declarations = [];
		    node.kind = kind;
		    for (;;) {
		      var decl = this.startNode();
		      this.parseVarId(decl, kind);
		      if (this.eat(types$1.eq)) {
		        decl.init = this.parseMaybeAssign(isFor);
		      } else if (!allowMissingInitializer && kind === "const" && !(this.type === types$1._in || (this.options.ecmaVersion >= 6 && this.isContextual("of")))) {
		        this.unexpected();
		      } else if (!allowMissingInitializer && decl.id.type !== "Identifier" && !(isFor && (this.type === types$1._in || this.isContextual("of")))) {
		        this.raise(this.lastTokEnd, "Complex binding patterns require an initialization value");
		      } else {
		        decl.init = null;
		      }
		      node.declarations.push(this.finishNode(decl, "VariableDeclarator"));
		      if (!this.eat(types$1.comma)) { break }
		    }
		    return node
		  };

		  pp$8.parseVarId = function(decl, kind) {
		    decl.id = this.parseBindingAtom();
		    this.checkLValPattern(decl.id, kind === "var" ? BIND_VAR : BIND_LEXICAL, false);
		  };

		  var FUNC_STATEMENT = 1, FUNC_HANGING_STATEMENT = 2, FUNC_NULLABLE_ID = 4;

		  // Parse a function declaration or literal (depending on the
		  // `statement & FUNC_STATEMENT`).

		  // Remove `allowExpressionBody` for 7.0.0, as it is only called with false
		  pp$8.parseFunction = function(node, statement, allowExpressionBody, isAsync, forInit) {
		    this.initFunction(node);
		    if (this.options.ecmaVersion >= 9 || this.options.ecmaVersion >= 6 && !isAsync) {
		      if (this.type === types$1.star && (statement & FUNC_HANGING_STATEMENT))
		        { this.unexpected(); }
		      node.generator = this.eat(types$1.star);
		    }
		    if (this.options.ecmaVersion >= 8)
		      { node.async = !!isAsync; }

		    if (statement & FUNC_STATEMENT) {
		      node.id = (statement & FUNC_NULLABLE_ID) && this.type !== types$1.name ? null : this.parseIdent();
		      if (node.id && !(statement & FUNC_HANGING_STATEMENT))
		        // If it is a regular function declaration in sloppy mode, then it is
		        // subject to Annex B semantics (BIND_FUNCTION). Otherwise, the binding
		        // mode depends on properties of the current scope (see
		        // treatFunctionsAsVar).
		        { this.checkLValSimple(node.id, (this.strict || node.generator || node.async) ? this.treatFunctionsAsVar ? BIND_VAR : BIND_LEXICAL : BIND_FUNCTION); }
		    }

		    var oldYieldPos = this.yieldPos, oldAwaitPos = this.awaitPos, oldAwaitIdentPos = this.awaitIdentPos;
		    this.yieldPos = 0;
		    this.awaitPos = 0;
		    this.awaitIdentPos = 0;
		    this.enterScope(functionFlags(node.async, node.generator));

		    if (!(statement & FUNC_STATEMENT))
		      { node.id = this.type === types$1.name ? this.parseIdent() : null; }

		    this.parseFunctionParams(node);
		    this.parseFunctionBody(node, allowExpressionBody, false, forInit);

		    this.yieldPos = oldYieldPos;
		    this.awaitPos = oldAwaitPos;
		    this.awaitIdentPos = oldAwaitIdentPos;
		    return this.finishNode(node, (statement & FUNC_STATEMENT) ? "FunctionDeclaration" : "FunctionExpression")
		  };

		  pp$8.parseFunctionParams = function(node) {
		    this.expect(types$1.parenL);
		    node.params = this.parseBindingList(types$1.parenR, false, this.options.ecmaVersion >= 8);
		    this.checkYieldAwaitInDefaultParams();
		  };

		  // Parse a class declaration or literal (depending on the
		  // `isStatement` parameter).

		  pp$8.parseClass = function(node, isStatement) {
		    this.next();

		    // ecma-262 14.6 Class Definitions
		    // A class definition is always strict mode code.
		    var oldStrict = this.strict;
		    this.strict = true;

		    this.parseClassId(node, isStatement);
		    this.parseClassSuper(node);
		    var privateNameMap = this.enterClassBody();
		    var classBody = this.startNode();
		    var hadConstructor = false;
		    classBody.body = [];
		    this.expect(types$1.braceL);
		    while (this.type !== types$1.braceR) {
		      var element = this.parseClassElement(node.superClass !== null);
		      if (element) {
		        classBody.body.push(element);
		        if (element.type === "MethodDefinition" && element.kind === "constructor") {
		          if (hadConstructor) { this.raiseRecoverable(element.start, "Duplicate constructor in the same class"); }
		          hadConstructor = true;
		        } else if (element.key && element.key.type === "PrivateIdentifier" && isPrivateNameConflicted(privateNameMap, element)) {
		          this.raiseRecoverable(element.key.start, ("Identifier '#" + (element.key.name) + "' has already been declared"));
		        }
		      }
		    }
		    this.strict = oldStrict;
		    this.next();
		    node.body = this.finishNode(classBody, "ClassBody");
		    this.exitClassBody();
		    return this.finishNode(node, isStatement ? "ClassDeclaration" : "ClassExpression")
		  };

		  pp$8.parseClassElement = function(constructorAllowsSuper) {
		    if (this.eat(types$1.semi)) { return null }

		    var ecmaVersion = this.options.ecmaVersion;
		    var node = this.startNode();
		    var keyName = "";
		    var isGenerator = false;
		    var isAsync = false;
		    var kind = "method";
		    var isStatic = false;

		    if (this.eatContextual("static")) {
		      // Parse static init block
		      if (ecmaVersion >= 13 && this.eat(types$1.braceL)) {
		        this.parseClassStaticBlock(node);
		        return node
		      }
		      if (this.isClassElementNameStart() || this.type === types$1.star) {
		        isStatic = true;
		      } else {
		        keyName = "static";
		      }
		    }
		    node.static = isStatic;
		    if (!keyName && ecmaVersion >= 8 && this.eatContextual("async")) {
		      if ((this.isClassElementNameStart() || this.type === types$1.star) && !this.canInsertSemicolon()) {
		        isAsync = true;
		      } else {
		        keyName = "async";
		      }
		    }
		    if (!keyName && (ecmaVersion >= 9 || !isAsync) && this.eat(types$1.star)) {
		      isGenerator = true;
		    }
		    if (!keyName && !isAsync && !isGenerator) {
		      var lastValue = this.value;
		      if (this.eatContextual("get") || this.eatContextual("set")) {
		        if (this.isClassElementNameStart()) {
		          kind = lastValue;
		        } else {
		          keyName = lastValue;
		        }
		      }
		    }

		    // Parse element name
		    if (keyName) {
		      // 'async', 'get', 'set', or 'static' were not a keyword contextually.
		      // The last token is any of those. Make it the element name.
		      node.computed = false;
		      node.key = this.startNodeAt(this.lastTokStart, this.lastTokStartLoc);
		      node.key.name = keyName;
		      this.finishNode(node.key, "Identifier");
		    } else {
		      this.parseClassElementName(node);
		    }

		    // Parse element value
		    if (ecmaVersion < 13 || this.type === types$1.parenL || kind !== "method" || isGenerator || isAsync) {
		      var isConstructor = !node.static && checkKeyName(node, "constructor");
		      var allowsDirectSuper = isConstructor && constructorAllowsSuper;
		      // Couldn't move this check into the 'parseClassMethod' method for backward compatibility.
		      if (isConstructor && kind !== "method") { this.raise(node.key.start, "Constructor can't have get/set modifier"); }
		      node.kind = isConstructor ? "constructor" : kind;
		      this.parseClassMethod(node, isGenerator, isAsync, allowsDirectSuper);
		    } else {
		      this.parseClassField(node);
		    }

		    return node
		  };

		  pp$8.isClassElementNameStart = function() {
		    return (
		      this.type === types$1.name ||
		      this.type === types$1.privateId ||
		      this.type === types$1.num ||
		      this.type === types$1.string ||
		      this.type === types$1.bracketL ||
		      this.type.keyword
		    )
		  };

		  pp$8.parseClassElementName = function(element) {
		    if (this.type === types$1.privateId) {
		      if (this.value === "constructor") {
		        this.raise(this.start, "Classes can't have an element named '#constructor'");
		      }
		      element.computed = false;
		      element.key = this.parsePrivateIdent();
		    } else {
		      this.parsePropertyName(element);
		    }
		  };

		  pp$8.parseClassMethod = function(method, isGenerator, isAsync, allowsDirectSuper) {
		    // Check key and flags
		    var key = method.key;
		    if (method.kind === "constructor") {
		      if (isGenerator) { this.raise(key.start, "Constructor can't be a generator"); }
		      if (isAsync) { this.raise(key.start, "Constructor can't be an async method"); }
		    } else if (method.static && checkKeyName(method, "prototype")) {
		      this.raise(key.start, "Classes may not have a static property named prototype");
		    }

		    // Parse value
		    var value = method.value = this.parseMethod(isGenerator, isAsync, allowsDirectSuper);

		    // Check value
		    if (method.kind === "get" && value.params.length !== 0)
		      { this.raiseRecoverable(value.start, "getter should have no params"); }
		    if (method.kind === "set" && value.params.length !== 1)
		      { this.raiseRecoverable(value.start, "setter should have exactly one param"); }
		    if (method.kind === "set" && value.params[0].type === "RestElement")
		      { this.raiseRecoverable(value.params[0].start, "Setter cannot use rest params"); }

		    return this.finishNode(method, "MethodDefinition")
		  };

		  pp$8.parseClassField = function(field) {
		    if (checkKeyName(field, "constructor")) {
		      this.raise(field.key.start, "Classes can't have a field named 'constructor'");
		    } else if (field.static && checkKeyName(field, "prototype")) {
		      this.raise(field.key.start, "Classes can't have a static field named 'prototype'");
		    }

		    if (this.eat(types$1.eq)) {
		      // To raise SyntaxError if 'arguments' exists in the initializer.
		      var scope = this.currentThisScope();
		      var inClassFieldInit = scope.inClassFieldInit;
		      scope.inClassFieldInit = true;
		      field.value = this.parseMaybeAssign();
		      scope.inClassFieldInit = inClassFieldInit;
		    } else {
		      field.value = null;
		    }
		    this.semicolon();

		    return this.finishNode(field, "PropertyDefinition")
		  };

		  pp$8.parseClassStaticBlock = function(node) {
		    node.body = [];

		    var oldLabels = this.labels;
		    this.labels = [];
		    this.enterScope(SCOPE_CLASS_STATIC_BLOCK | SCOPE_SUPER);
		    while (this.type !== types$1.braceR) {
		      var stmt = this.parseStatement(null);
		      node.body.push(stmt);
		    }
		    this.next();
		    this.exitScope();
		    this.labels = oldLabels;

		    return this.finishNode(node, "StaticBlock")
		  };

		  pp$8.parseClassId = function(node, isStatement) {
		    if (this.type === types$1.name) {
		      node.id = this.parseIdent();
		      if (isStatement)
		        { this.checkLValSimple(node.id, BIND_LEXICAL, false); }
		    } else {
		      if (isStatement === true)
		        { this.unexpected(); }
		      node.id = null;
		    }
		  };

		  pp$8.parseClassSuper = function(node) {
		    node.superClass = this.eat(types$1._extends) ? this.parseExprSubscripts(null, false) : null;
		  };

		  pp$8.enterClassBody = function() {
		    var element = {declared: Object.create(null), used: []};
		    this.privateNameStack.push(element);
		    return element.declared
		  };

		  pp$8.exitClassBody = function() {
		    var ref = this.privateNameStack.pop();
		    var declared = ref.declared;
		    var used = ref.used;
		    if (!this.options.checkPrivateFields) { return }
		    var len = this.privateNameStack.length;
		    var parent = len === 0 ? null : this.privateNameStack[len - 1];
		    for (var i = 0; i < used.length; ++i) {
		      var id = used[i];
		      if (!hasOwn(declared, id.name)) {
		        if (parent) {
		          parent.used.push(id);
		        } else {
		          this.raiseRecoverable(id.start, ("Private field '#" + (id.name) + "' must be declared in an enclosing class"));
		        }
		      }
		    }
		  };

		  function isPrivateNameConflicted(privateNameMap, element) {
		    var name = element.key.name;
		    var curr = privateNameMap[name];

		    var next = "true";
		    if (element.type === "MethodDefinition" && (element.kind === "get" || element.kind === "set")) {
		      next = (element.static ? "s" : "i") + element.kind;
		    }

		    // `class { get #a(){}; static set #a(_){} }` is also conflict.
		    if (
		      curr === "iget" && next === "iset" ||
		      curr === "iset" && next === "iget" ||
		      curr === "sget" && next === "sset" ||
		      curr === "sset" && next === "sget"
		    ) {
		      privateNameMap[name] = "true";
		      return false
		    } else if (!curr) {
		      privateNameMap[name] = next;
		      return false
		    } else {
		      return true
		    }
		  }

		  function checkKeyName(node, name) {
		    var computed = node.computed;
		    var key = node.key;
		    return !computed && (
		      key.type === "Identifier" && key.name === name ||
		      key.type === "Literal" && key.value === name
		    )
		  }

		  // Parses module export declaration.

		  pp$8.parseExportAllDeclaration = function(node, exports) {
		    if (this.options.ecmaVersion >= 11) {
		      if (this.eatContextual("as")) {
		        node.exported = this.parseModuleExportName();
		        this.checkExport(exports, node.exported, this.lastTokStart);
		      } else {
		        node.exported = null;
		      }
		    }
		    this.expectContextual("from");
		    if (this.type !== types$1.string) { this.unexpected(); }
		    node.source = this.parseExprAtom();
		    this.semicolon();
		    return this.finishNode(node, "ExportAllDeclaration")
		  };

		  pp$8.parseExport = function(node, exports) {
		    this.next();
		    // export * from '...'
		    if (this.eat(types$1.star)) {
		      return this.parseExportAllDeclaration(node, exports)
		    }
		    if (this.eat(types$1._default)) { // export default ...
		      this.checkExport(exports, "default", this.lastTokStart);
		      node.declaration = this.parseExportDefaultDeclaration();
		      return this.finishNode(node, "ExportDefaultDeclaration")
		    }
		    // export var|const|let|function|class ...
		    if (this.shouldParseExportStatement()) {
		      node.declaration = this.parseExportDeclaration(node);
		      if (node.declaration.type === "VariableDeclaration")
		        { this.checkVariableExport(exports, node.declaration.declarations); }
		      else
		        { this.checkExport(exports, node.declaration.id, node.declaration.id.start); }
		      node.specifiers = [];
		      node.source = null;
		    } else { // export { x, y as z } [from '...']
		      node.declaration = null;
		      node.specifiers = this.parseExportSpecifiers(exports);
		      if (this.eatContextual("from")) {
		        if (this.type !== types$1.string) { this.unexpected(); }
		        node.source = this.parseExprAtom();
		      } else {
		        for (var i = 0, list = node.specifiers; i < list.length; i += 1) {
		          // check for keywords used as local names
		          var spec = list[i];

		          this.checkUnreserved(spec.local);
		          // check if export is defined
		          this.checkLocalExport(spec.local);

		          if (spec.local.type === "Literal") {
		            this.raise(spec.local.start, "A string literal cannot be used as an exported binding without `from`.");
		          }
		        }

		        node.source = null;
		      }
		      this.semicolon();
		    }
		    return this.finishNode(node, "ExportNamedDeclaration")
		  };

		  pp$8.parseExportDeclaration = function(node) {
		    return this.parseStatement(null)
		  };

		  pp$8.parseExportDefaultDeclaration = function() {
		    var isAsync;
		    if (this.type === types$1._function || (isAsync = this.isAsyncFunction())) {
		      var fNode = this.startNode();
		      this.next();
		      if (isAsync) { this.next(); }
		      return this.parseFunction(fNode, FUNC_STATEMENT | FUNC_NULLABLE_ID, false, isAsync)
		    } else if (this.type === types$1._class) {
		      var cNode = this.startNode();
		      return this.parseClass(cNode, "nullableID")
		    } else {
		      var declaration = this.parseMaybeAssign();
		      this.semicolon();
		      return declaration
		    }
		  };

		  pp$8.checkExport = function(exports, name, pos) {
		    if (!exports) { return }
		    if (typeof name !== "string")
		      { name = name.type === "Identifier" ? name.name : name.value; }
		    if (hasOwn(exports, name))
		      { this.raiseRecoverable(pos, "Duplicate export '" + name + "'"); }
		    exports[name] = true;
		  };

		  pp$8.checkPatternExport = function(exports, pat) {
		    var type = pat.type;
		    if (type === "Identifier")
		      { this.checkExport(exports, pat, pat.start); }
		    else if (type === "ObjectPattern")
		      { for (var i = 0, list = pat.properties; i < list.length; i += 1)
		        {
		          var prop = list[i];

		          this.checkPatternExport(exports, prop);
		        } }
		    else if (type === "ArrayPattern")
		      { for (var i$1 = 0, list$1 = pat.elements; i$1 < list$1.length; i$1 += 1) {
		        var elt = list$1[i$1];

		          if (elt) { this.checkPatternExport(exports, elt); }
		      } }
		    else if (type === "Property")
		      { this.checkPatternExport(exports, pat.value); }
		    else if (type === "AssignmentPattern")
		      { this.checkPatternExport(exports, pat.left); }
		    else if (type === "RestElement")
		      { this.checkPatternExport(exports, pat.argument); }
		  };

		  pp$8.checkVariableExport = function(exports, decls) {
		    if (!exports) { return }
		    for (var i = 0, list = decls; i < list.length; i += 1)
		      {
		      var decl = list[i];

		      this.checkPatternExport(exports, decl.id);
		    }
		  };

		  pp$8.shouldParseExportStatement = function() {
		    return this.type.keyword === "var" ||
		      this.type.keyword === "const" ||
		      this.type.keyword === "class" ||
		      this.type.keyword === "function" ||
		      this.isLet() ||
		      this.isAsyncFunction()
		  };

		  // Parses a comma-separated list of module exports.

		  pp$8.parseExportSpecifier = function(exports) {
		    var node = this.startNode();
		    node.local = this.parseModuleExportName();

		    node.exported = this.eatContextual("as") ? this.parseModuleExportName() : node.local;
		    this.checkExport(
		      exports,
		      node.exported,
		      node.exported.start
		    );

		    return this.finishNode(node, "ExportSpecifier")
		  };

		  pp$8.parseExportSpecifiers = function(exports) {
		    var nodes = [], first = true;
		    // export { x, y as z } [from '...']
		    this.expect(types$1.braceL);
		    while (!this.eat(types$1.braceR)) {
		      if (!first) {
		        this.expect(types$1.comma);
		        if (this.afterTrailingComma(types$1.braceR)) { break }
		      } else { first = false; }

		      nodes.push(this.parseExportSpecifier(exports));
		    }
		    return nodes
		  };

		  // Parses import declaration.

		  pp$8.parseImport = function(node) {
		    this.next();

		    // import '...'
		    if (this.type === types$1.string) {
		      node.specifiers = empty$1;
		      node.source = this.parseExprAtom();
		    } else {
		      node.specifiers = this.parseImportSpecifiers();
		      this.expectContextual("from");
		      node.source = this.type === types$1.string ? this.parseExprAtom() : this.unexpected();
		    }
		    this.semicolon();
		    return this.finishNode(node, "ImportDeclaration")
		  };

		  // Parses a comma-separated list of module imports.

		  pp$8.parseImportSpecifier = function() {
		    var node = this.startNode();
		    node.imported = this.parseModuleExportName();

		    if (this.eatContextual("as")) {
		      node.local = this.parseIdent();
		    } else {
		      this.checkUnreserved(node.imported);
		      node.local = node.imported;
		    }
		    this.checkLValSimple(node.local, BIND_LEXICAL);

		    return this.finishNode(node, "ImportSpecifier")
		  };

		  pp$8.parseImportDefaultSpecifier = function() {
		    // import defaultObj, { x, y as z } from '...'
		    var node = this.startNode();
		    node.local = this.parseIdent();
		    this.checkLValSimple(node.local, BIND_LEXICAL);
		    return this.finishNode(node, "ImportDefaultSpecifier")
		  };

		  pp$8.parseImportNamespaceSpecifier = function() {
		    var node = this.startNode();
		    this.next();
		    this.expectContextual("as");
		    node.local = this.parseIdent();
		    this.checkLValSimple(node.local, BIND_LEXICAL);
		    return this.finishNode(node, "ImportNamespaceSpecifier")
		  };

		  pp$8.parseImportSpecifiers = function() {
		    var nodes = [], first = true;
		    if (this.type === types$1.name) {
		      nodes.push(this.parseImportDefaultSpecifier());
		      if (!this.eat(types$1.comma)) { return nodes }
		    }
		    if (this.type === types$1.star) {
		      nodes.push(this.parseImportNamespaceSpecifier());
		      return nodes
		    }
		    this.expect(types$1.braceL);
		    while (!this.eat(types$1.braceR)) {
		      if (!first) {
		        this.expect(types$1.comma);
		        if (this.afterTrailingComma(types$1.braceR)) { break }
		      } else { first = false; }

		      nodes.push(this.parseImportSpecifier());
		    }
		    return nodes
		  };

		  pp$8.parseModuleExportName = function() {
		    if (this.options.ecmaVersion >= 13 && this.type === types$1.string) {
		      var stringLiteral = this.parseLiteral(this.value);
		      if (loneSurrogate.test(stringLiteral.value)) {
		        this.raise(stringLiteral.start, "An export name cannot include a lone surrogate.");
		      }
		      return stringLiteral
		    }
		    return this.parseIdent(true)
		  };

		  // Set `ExpressionStatement#directive` property for directive prologues.
		  pp$8.adaptDirectivePrologue = function(statements) {
		    for (var i = 0; i < statements.length && this.isDirectiveCandidate(statements[i]); ++i) {
		      statements[i].directive = statements[i].expression.raw.slice(1, -1);
		    }
		  };
		  pp$8.isDirectiveCandidate = function(statement) {
		    return (
		      this.options.ecmaVersion >= 5 &&
		      statement.type === "ExpressionStatement" &&
		      statement.expression.type === "Literal" &&
		      typeof statement.expression.value === "string" &&
		      // Reject parenthesized strings.
		      (this.input[statement.start] === "\"" || this.input[statement.start] === "'")
		    )
		  };

		  var pp$7 = Parser.prototype;

		  // Convert existing expression atom to assignable pattern
		  // if possible.

		  pp$7.toAssignable = function(node, isBinding, refDestructuringErrors) {
		    if (this.options.ecmaVersion >= 6 && node) {
		      switch (node.type) {
		      case "Identifier":
		        if (this.inAsync && node.name === "await")
		          { this.raise(node.start, "Cannot use 'await' as identifier inside an async function"); }
		        break

		      case "ObjectPattern":
		      case "ArrayPattern":
		      case "AssignmentPattern":
		      case "RestElement":
		        break

		      case "ObjectExpression":
		        node.type = "ObjectPattern";
		        if (refDestructuringErrors) { this.checkPatternErrors(refDestructuringErrors, true); }
		        for (var i = 0, list = node.properties; i < list.length; i += 1) {
		          var prop = list[i];

		        this.toAssignable(prop, isBinding);
		          // Early error:
		          //   AssignmentRestProperty[Yield, Await] :
		          //     `...` DestructuringAssignmentTarget[Yield, Await]
		          //
		          //   It is a Syntax Error if |DestructuringAssignmentTarget| is an |ArrayLiteral| or an |ObjectLiteral|.
		          if (
		            prop.type === "RestElement" &&
		            (prop.argument.type === "ArrayPattern" || prop.argument.type === "ObjectPattern")
		          ) {
		            this.raise(prop.argument.start, "Unexpected token");
		          }
		        }
		        break

		      case "Property":
		        // AssignmentProperty has type === "Property"
		        if (node.kind !== "init") { this.raise(node.key.start, "Object pattern can't contain getter or setter"); }
		        this.toAssignable(node.value, isBinding);
		        break

		      case "ArrayExpression":
		        node.type = "ArrayPattern";
		        if (refDestructuringErrors) { this.checkPatternErrors(refDestructuringErrors, true); }
		        this.toAssignableList(node.elements, isBinding);
		        break

		      case "SpreadElement":
		        node.type = "RestElement";
		        this.toAssignable(node.argument, isBinding);
		        if (node.argument.type === "AssignmentPattern")
		          { this.raise(node.argument.start, "Rest elements cannot have a default value"); }
		        break

		      case "AssignmentExpression":
		        if (node.operator !== "=") { this.raise(node.left.end, "Only '=' operator can be used for specifying default value."); }
		        node.type = "AssignmentPattern";
		        delete node.operator;
		        this.toAssignable(node.left, isBinding);
		        break

		      case "ParenthesizedExpression":
		        this.toAssignable(node.expression, isBinding, refDestructuringErrors);
		        break

		      case "ChainExpression":
		        this.raiseRecoverable(node.start, "Optional chaining cannot appear in left-hand side");
		        break

		      case "MemberExpression":
		        if (!isBinding) { break }

		      default:
		        this.raise(node.start, "Assigning to rvalue");
		      }
		    } else if (refDestructuringErrors) { this.checkPatternErrors(refDestructuringErrors, true); }
		    return node
		  };

		  // Convert list of expression atoms to binding list.

		  pp$7.toAssignableList = function(exprList, isBinding) {
		    var end = exprList.length;
		    for (var i = 0; i < end; i++) {
		      var elt = exprList[i];
		      if (elt) { this.toAssignable(elt, isBinding); }
		    }
		    if (end) {
		      var last = exprList[end - 1];
		      if (this.options.ecmaVersion === 6 && isBinding && last && last.type === "RestElement" && last.argument.type !== "Identifier")
		        { this.unexpected(last.argument.start); }
		    }
		    return exprList
		  };

		  // Parses spread element.

		  pp$7.parseSpread = function(refDestructuringErrors) {
		    var node = this.startNode();
		    this.next();
		    node.argument = this.parseMaybeAssign(false, refDestructuringErrors);
		    return this.finishNode(node, "SpreadElement")
		  };

		  pp$7.parseRestBinding = function() {
		    var node = this.startNode();
		    this.next();

		    // RestElement inside of a function parameter must be an identifier
		    if (this.options.ecmaVersion === 6 && this.type !== types$1.name)
		      { this.unexpected(); }

		    node.argument = this.parseBindingAtom();

		    return this.finishNode(node, "RestElement")
		  };

		  // Parses lvalue (assignable) atom.

		  pp$7.parseBindingAtom = function() {
		    if (this.options.ecmaVersion >= 6) {
		      switch (this.type) {
		      case types$1.bracketL:
		        var node = this.startNode();
		        this.next();
		        node.elements = this.parseBindingList(types$1.bracketR, true, true);
		        return this.finishNode(node, "ArrayPattern")

		      case types$1.braceL:
		        return this.parseObj(true)
		      }
		    }
		    return this.parseIdent()
		  };

		  pp$7.parseBindingList = function(close, allowEmpty, allowTrailingComma, allowModifiers) {
		    var elts = [], first = true;
		    while (!this.eat(close)) {
		      if (first) { first = false; }
		      else { this.expect(types$1.comma); }
		      if (allowEmpty && this.type === types$1.comma) {
		        elts.push(null);
		      } else if (allowTrailingComma && this.afterTrailingComma(close)) {
		        break
		      } else if (this.type === types$1.ellipsis) {
		        var rest = this.parseRestBinding();
		        this.parseBindingListItem(rest);
		        elts.push(rest);
		        if (this.type === types$1.comma) { this.raiseRecoverable(this.start, "Comma is not permitted after the rest element"); }
		        this.expect(close);
		        break
		      } else {
		        elts.push(this.parseAssignableListItem(allowModifiers));
		      }
		    }
		    return elts
		  };

		  pp$7.parseAssignableListItem = function(allowModifiers) {
		    var elem = this.parseMaybeDefault(this.start, this.startLoc);
		    this.parseBindingListItem(elem);
		    return elem
		  };

		  pp$7.parseBindingListItem = function(param) {
		    return param
		  };

		  // Parses assignment pattern around given atom if possible.

		  pp$7.parseMaybeDefault = function(startPos, startLoc, left) {
		    left = left || this.parseBindingAtom();
		    if (this.options.ecmaVersion < 6 || !this.eat(types$1.eq)) { return left }
		    var node = this.startNodeAt(startPos, startLoc);
		    node.left = left;
		    node.right = this.parseMaybeAssign();
		    return this.finishNode(node, "AssignmentPattern")
		  };

		  // The following three functions all verify that a node is an lvalue —
		  // something that can be bound, or assigned to. In order to do so, they perform
		  // a variety of checks:
		  //
		  // - Check that none of the bound/assigned-to identifiers are reserved words.
		  // - Record name declarations for bindings in the appropriate scope.
		  // - Check duplicate argument names, if checkClashes is set.
		  //
		  // If a complex binding pattern is encountered (e.g., object and array
		  // destructuring), the entire pattern is recursively checked.
		  //
		  // There are three versions of checkLVal*() appropriate for different
		  // circumstances:
		  //
		  // - checkLValSimple() shall be used if the syntactic construct supports
		  //   nothing other than identifiers and member expressions. Parenthesized
		  //   expressions are also correctly handled. This is generally appropriate for
		  //   constructs for which the spec says
		  //
		  //   > It is a Syntax Error if AssignmentTargetType of [the production] is not
		  //   > simple.
		  //
		  //   It is also appropriate for checking if an identifier is valid and not
		  //   defined elsewhere, like import declarations or function/class identifiers.
		  //
		  //   Examples where this is used include:
		  //     a += …;
		  //     import a from '…';
		  //   where a is the node to be checked.
		  //
		  // - checkLValPattern() shall be used if the syntactic construct supports
		  //   anything checkLValSimple() supports, as well as object and array
		  //   destructuring patterns. This is generally appropriate for constructs for
		  //   which the spec says
		  //
		  //   > It is a Syntax Error if [the production] is neither an ObjectLiteral nor
		  //   > an ArrayLiteral and AssignmentTargetType of [the production] is not
		  //   > simple.
		  //
		  //   Examples where this is used include:
		  //     (a = …);
		  //     const a = …;
		  //     try { … } catch (a) { … }
		  //   where a is the node to be checked.
		  //
		  // - checkLValInnerPattern() shall be used if the syntactic construct supports
		  //   anything checkLValPattern() supports, as well as default assignment
		  //   patterns, rest elements, and other constructs that may appear within an
		  //   object or array destructuring pattern.
		  //
		  //   As a special case, function parameters also use checkLValInnerPattern(),
		  //   as they also support defaults and rest constructs.
		  //
		  // These functions deliberately support both assignment and binding constructs,
		  // as the logic for both is exceedingly similar. If the node is the target of
		  // an assignment, then bindingType should be set to BIND_NONE. Otherwise, it
		  // should be set to the appropriate BIND_* constant, like BIND_VAR or
		  // BIND_LEXICAL.
		  //
		  // If the function is called with a non-BIND_NONE bindingType, then
		  // additionally a checkClashes object may be specified to allow checking for
		  // duplicate argument names. checkClashes is ignored if the provided construct
		  // is an assignment (i.e., bindingType is BIND_NONE).

		  pp$7.checkLValSimple = function(expr, bindingType, checkClashes) {
		    if ( bindingType === void 0 ) bindingType = BIND_NONE;

		    var isBind = bindingType !== BIND_NONE;

		    switch (expr.type) {
		    case "Identifier":
		      if (this.strict && this.reservedWordsStrictBind.test(expr.name))
		        { this.raiseRecoverable(expr.start, (isBind ? "Binding " : "Assigning to ") + expr.name + " in strict mode"); }
		      if (isBind) {
		        if (bindingType === BIND_LEXICAL && expr.name === "let")
		          { this.raiseRecoverable(expr.start, "let is disallowed as a lexically bound name"); }
		        if (checkClashes) {
		          if (hasOwn(checkClashes, expr.name))
		            { this.raiseRecoverable(expr.start, "Argument name clash"); }
		          checkClashes[expr.name] = true;
		        }
		        if (bindingType !== BIND_OUTSIDE) { this.declareName(expr.name, bindingType, expr.start); }
		      }
		      break

		    case "ChainExpression":
		      this.raiseRecoverable(expr.start, "Optional chaining cannot appear in left-hand side");
		      break

		    case "MemberExpression":
		      if (isBind) { this.raiseRecoverable(expr.start, "Binding member expression"); }
		      break

		    case "ParenthesizedExpression":
		      if (isBind) { this.raiseRecoverable(expr.start, "Binding parenthesized expression"); }
		      return this.checkLValSimple(expr.expression, bindingType, checkClashes)

		    default:
		      this.raise(expr.start, (isBind ? "Binding" : "Assigning to") + " rvalue");
		    }
		  };

		  pp$7.checkLValPattern = function(expr, bindingType, checkClashes) {
		    if ( bindingType === void 0 ) bindingType = BIND_NONE;

		    switch (expr.type) {
		    case "ObjectPattern":
		      for (var i = 0, list = expr.properties; i < list.length; i += 1) {
		        var prop = list[i];

		      this.checkLValInnerPattern(prop, bindingType, checkClashes);
		      }
		      break

		    case "ArrayPattern":
		      for (var i$1 = 0, list$1 = expr.elements; i$1 < list$1.length; i$1 += 1) {
		        var elem = list$1[i$1];

		      if (elem) { this.checkLValInnerPattern(elem, bindingType, checkClashes); }
		      }
		      break

		    default:
		      this.checkLValSimple(expr, bindingType, checkClashes);
		    }
		  };

		  pp$7.checkLValInnerPattern = function(expr, bindingType, checkClashes) {
		    if ( bindingType === void 0 ) bindingType = BIND_NONE;

		    switch (expr.type) {
		    case "Property":
		      // AssignmentProperty has type === "Property"
		      this.checkLValInnerPattern(expr.value, bindingType, checkClashes);
		      break

		    case "AssignmentPattern":
		      this.checkLValPattern(expr.left, bindingType, checkClashes);
		      break

		    case "RestElement":
		      this.checkLValPattern(expr.argument, bindingType, checkClashes);
		      break

		    default:
		      this.checkLValPattern(expr, bindingType, checkClashes);
		    }
		  };

		  // The algorithm used to determine whether a regexp can appear at a
		  // given point in the program is loosely based on sweet.js' approach.
		  // See https://github.com/mozilla/sweet.js/wiki/design


		  var TokContext = function TokContext(token, isExpr, preserveSpace, override, generator) {
		    this.token = token;
		    this.isExpr = !!isExpr;
		    this.preserveSpace = !!preserveSpace;
		    this.override = override;
		    this.generator = !!generator;
		  };

		  var types = {
		    b_stat: new TokContext("{", false),
		    b_expr: new TokContext("{", true),
		    b_tmpl: new TokContext("${", false),
		    p_stat: new TokContext("(", false),
		    p_expr: new TokContext("(", true),
		    q_tmpl: new TokContext("`", true, true, function (p) { return p.tryReadTemplateToken(); }),
		    f_stat: new TokContext("function", false),
		    f_expr: new TokContext("function", true),
		    f_expr_gen: new TokContext("function", true, false, null, true),
		    f_gen: new TokContext("function", false, false, null, true)
		  };

		  var pp$6 = Parser.prototype;

		  pp$6.initialContext = function() {
		    return [types.b_stat]
		  };

		  pp$6.curContext = function() {
		    return this.context[this.context.length - 1]
		  };

		  pp$6.braceIsBlock = function(prevType) {
		    var parent = this.curContext();
		    if (parent === types.f_expr || parent === types.f_stat)
		      { return true }
		    if (prevType === types$1.colon && (parent === types.b_stat || parent === types.b_expr))
		      { return !parent.isExpr }

		    // The check for `tt.name && exprAllowed` detects whether we are
		    // after a `yield` or `of` construct. See the `updateContext` for
		    // `tt.name`.
		    if (prevType === types$1._return || prevType === types$1.name && this.exprAllowed)
		      { return lineBreak.test(this.input.slice(this.lastTokEnd, this.start)) }
		    if (prevType === types$1._else || prevType === types$1.semi || prevType === types$1.eof || prevType === types$1.parenR || prevType === types$1.arrow)
		      { return true }
		    if (prevType === types$1.braceL)
		      { return parent === types.b_stat }
		    if (prevType === types$1._var || prevType === types$1._const || prevType === types$1.name)
		      { return false }
		    return !this.exprAllowed
		  };

		  pp$6.inGeneratorContext = function() {
		    for (var i = this.context.length - 1; i >= 1; i--) {
		      var context = this.context[i];
		      if (context.token === "function")
		        { return context.generator }
		    }
		    return false
		  };

		  pp$6.updateContext = function(prevType) {
		    var update, type = this.type;
		    if (type.keyword && prevType === types$1.dot)
		      { this.exprAllowed = false; }
		    else if (update = type.updateContext)
		      { update.call(this, prevType); }
		    else
		      { this.exprAllowed = type.beforeExpr; }
		  };

		  // Used to handle edge cases when token context could not be inferred correctly during tokenization phase

		  pp$6.overrideContext = function(tokenCtx) {
		    if (this.curContext() !== tokenCtx) {
		      this.context[this.context.length - 1] = tokenCtx;
		    }
		  };

		  // Token-specific context update code

		  types$1.parenR.updateContext = types$1.braceR.updateContext = function() {
		    if (this.context.length === 1) {
		      this.exprAllowed = true;
		      return
		    }
		    var out = this.context.pop();
		    if (out === types.b_stat && this.curContext().token === "function") {
		      out = this.context.pop();
		    }
		    this.exprAllowed = !out.isExpr;
		  };

		  types$1.braceL.updateContext = function(prevType) {
		    this.context.push(this.braceIsBlock(prevType) ? types.b_stat : types.b_expr);
		    this.exprAllowed = true;
		  };

		  types$1.dollarBraceL.updateContext = function() {
		    this.context.push(types.b_tmpl);
		    this.exprAllowed = true;
		  };

		  types$1.parenL.updateContext = function(prevType) {
		    var statementParens = prevType === types$1._if || prevType === types$1._for || prevType === types$1._with || prevType === types$1._while;
		    this.context.push(statementParens ? types.p_stat : types.p_expr);
		    this.exprAllowed = true;
		  };

		  types$1.incDec.updateContext = function() {
		    // tokExprAllowed stays unchanged
		  };

		  types$1._function.updateContext = types$1._class.updateContext = function(prevType) {
		    if (prevType.beforeExpr && prevType !== types$1._else &&
		        !(prevType === types$1.semi && this.curContext() !== types.p_stat) &&
		        !(prevType === types$1._return && lineBreak.test(this.input.slice(this.lastTokEnd, this.start))) &&
		        !((prevType === types$1.colon || prevType === types$1.braceL) && this.curContext() === types.b_stat))
		      { this.context.push(types.f_expr); }
		    else
		      { this.context.push(types.f_stat); }
		    this.exprAllowed = false;
		  };

		  types$1.colon.updateContext = function() {
		    if (this.curContext().token === "function") { this.context.pop(); }
		    this.exprAllowed = true;
		  };

		  types$1.backQuote.updateContext = function() {
		    if (this.curContext() === types.q_tmpl)
		      { this.context.pop(); }
		    else
		      { this.context.push(types.q_tmpl); }
		    this.exprAllowed = false;
		  };

		  types$1.star.updateContext = function(prevType) {
		    if (prevType === types$1._function) {
		      var index = this.context.length - 1;
		      if (this.context[index] === types.f_expr)
		        { this.context[index] = types.f_expr_gen; }
		      else
		        { this.context[index] = types.f_gen; }
		    }
		    this.exprAllowed = true;
		  };

		  types$1.name.updateContext = function(prevType) {
		    var allowed = false;
		    if (this.options.ecmaVersion >= 6 && prevType !== types$1.dot) {
		      if (this.value === "of" && !this.exprAllowed ||
		          this.value === "yield" && this.inGeneratorContext())
		        { allowed = true; }
		    }
		    this.exprAllowed = allowed;
		  };

		  // A recursive descent parser operates by defining functions for all
		  // syntactic elements, and recursively calling those, each function
		  // advancing the input stream and returning an AST node. Precedence
		  // of constructs (for example, the fact that `!x[1]` means `!(x[1])`
		  // instead of `(!x)[1]` is handled by the fact that the parser
		  // function that parses unary prefix operators is called first, and
		  // in turn calls the function that parses `[]` subscripts — that
		  // way, it'll receive the node for `x[1]` already parsed, and wraps
		  // *that* in the unary operator node.
		  //
		  // Acorn uses an [operator precedence parser][opp] to handle binary
		  // operator precedence, because it is much more compact than using
		  // the technique outlined above, which uses different, nesting
		  // functions to specify precedence, for all of the ten binary
		  // precedence levels that JavaScript defines.
		  //
		  // [opp]: http://en.wikipedia.org/wiki/Operator-precedence_parser


		  var pp$5 = Parser.prototype;

		  // Check if property name clashes with already added.
		  // Object/class getters and setters are not allowed to clash —
		  // either with each other or with an init property — and in
		  // strict mode, init properties are also not allowed to be repeated.

		  pp$5.checkPropClash = function(prop, propHash, refDestructuringErrors) {
		    if (this.options.ecmaVersion >= 9 && prop.type === "SpreadElement")
		      { return }
		    if (this.options.ecmaVersion >= 6 && (prop.computed || prop.method || prop.shorthand))
		      { return }
		    var key = prop.key;
		    var name;
		    switch (key.type) {
		    case "Identifier": name = key.name; break
		    case "Literal": name = String(key.value); break
		    default: return
		    }
		    var kind = prop.kind;
		    if (this.options.ecmaVersion >= 6) {
		      if (name === "__proto__" && kind === "init") {
		        if (propHash.proto) {
		          if (refDestructuringErrors) {
		            if (refDestructuringErrors.doubleProto < 0) {
		              refDestructuringErrors.doubleProto = key.start;
		            }
		          } else {
		            this.raiseRecoverable(key.start, "Redefinition of __proto__ property");
		          }
		        }
		        propHash.proto = true;
		      }
		      return
		    }
		    name = "$" + name;
		    var other = propHash[name];
		    if (other) {
		      var redefinition;
		      if (kind === "init") {
		        redefinition = this.strict && other.init || other.get || other.set;
		      } else {
		        redefinition = other.init || other[kind];
		      }
		      if (redefinition)
		        { this.raiseRecoverable(key.start, "Redefinition of property"); }
		    } else {
		      other = propHash[name] = {
		        init: false,
		        get: false,
		        set: false
		      };
		    }
		    other[kind] = true;
		  };

		  // ### Expression parsing

		  // These nest, from the most general expression type at the top to
		  // 'atomic', nondivisible expression types at the bottom. Most of
		  // the functions will simply let the function(s) below them parse,
		  // and, *if* the syntactic construct they handle is present, wrap
		  // the AST node that the inner parser gave them in another node.

		  // Parse a full expression. The optional arguments are used to
		  // forbid the `in` operator (in for loops initalization expressions)
		  // and provide reference for storing '=' operator inside shorthand
		  // property assignment in contexts where both object expression
		  // and object pattern might appear (so it's possible to raise
		  // delayed syntax error at correct position).

		  pp$5.parseExpression = function(forInit, refDestructuringErrors) {
		    var startPos = this.start, startLoc = this.startLoc;
		    var expr = this.parseMaybeAssign(forInit, refDestructuringErrors);
		    if (this.type === types$1.comma) {
		      var node = this.startNodeAt(startPos, startLoc);
		      node.expressions = [expr];
		      while (this.eat(types$1.comma)) { node.expressions.push(this.parseMaybeAssign(forInit, refDestructuringErrors)); }
		      return this.finishNode(node, "SequenceExpression")
		    }
		    return expr
		  };

		  // Parse an assignment expression. This includes applications of
		  // operators like `+=`.

		  pp$5.parseMaybeAssign = function(forInit, refDestructuringErrors, afterLeftParse) {
		    if (this.isContextual("yield")) {
		      if (this.inGenerator) { return this.parseYield(forInit) }
		      // The tokenizer will assume an expression is allowed after
		      // `yield`, but this isn't that kind of yield
		      else { this.exprAllowed = false; }
		    }

		    var ownDestructuringErrors = false, oldParenAssign = -1, oldTrailingComma = -1, oldDoubleProto = -1;
		    if (refDestructuringErrors) {
		      oldParenAssign = refDestructuringErrors.parenthesizedAssign;
		      oldTrailingComma = refDestructuringErrors.trailingComma;
		      oldDoubleProto = refDestructuringErrors.doubleProto;
		      refDestructuringErrors.parenthesizedAssign = refDestructuringErrors.trailingComma = -1;
		    } else {
		      refDestructuringErrors = new DestructuringErrors;
		      ownDestructuringErrors = true;
		    }

		    var startPos = this.start, startLoc = this.startLoc;
		    if (this.type === types$1.parenL || this.type === types$1.name) {
		      this.potentialArrowAt = this.start;
		      this.potentialArrowInForAwait = forInit === "await";
		    }
		    var left = this.parseMaybeConditional(forInit, refDestructuringErrors);
		    if (afterLeftParse) { left = afterLeftParse.call(this, left, startPos, startLoc); }
		    if (this.type.isAssign) {
		      var node = this.startNodeAt(startPos, startLoc);
		      node.operator = this.value;
		      if (this.type === types$1.eq)
		        { left = this.toAssignable(left, false, refDestructuringErrors); }
		      if (!ownDestructuringErrors) {
		        refDestructuringErrors.parenthesizedAssign = refDestructuringErrors.trailingComma = refDestructuringErrors.doubleProto = -1;
		      }
		      if (refDestructuringErrors.shorthandAssign >= left.start)
		        { refDestructuringErrors.shorthandAssign = -1; } // reset because shorthand default was used correctly
		      if (this.type === types$1.eq)
		        { this.checkLValPattern(left); }
		      else
		        { this.checkLValSimple(left); }
		      node.left = left;
		      this.next();
		      node.right = this.parseMaybeAssign(forInit);
		      if (oldDoubleProto > -1) { refDestructuringErrors.doubleProto = oldDoubleProto; }
		      return this.finishNode(node, "AssignmentExpression")
		    } else {
		      if (ownDestructuringErrors) { this.checkExpressionErrors(refDestructuringErrors, true); }
		    }
		    if (oldParenAssign > -1) { refDestructuringErrors.parenthesizedAssign = oldParenAssign; }
		    if (oldTrailingComma > -1) { refDestructuringErrors.trailingComma = oldTrailingComma; }
		    return left
		  };

		  // Parse a ternary conditional (`?:`) operator.

		  pp$5.parseMaybeConditional = function(forInit, refDestructuringErrors) {
		    var startPos = this.start, startLoc = this.startLoc;
		    var expr = this.parseExprOps(forInit, refDestructuringErrors);
		    if (this.checkExpressionErrors(refDestructuringErrors)) { return expr }
		    if (this.eat(types$1.question)) {
		      var node = this.startNodeAt(startPos, startLoc);
		      node.test = expr;
		      node.consequent = this.parseMaybeAssign();
		      this.expect(types$1.colon);
		      node.alternate = this.parseMaybeAssign(forInit);
		      return this.finishNode(node, "ConditionalExpression")
		    }
		    return expr
		  };

		  // Start the precedence parser.

		  pp$5.parseExprOps = function(forInit, refDestructuringErrors) {
		    var startPos = this.start, startLoc = this.startLoc;
		    var expr = this.parseMaybeUnary(refDestructuringErrors, false, false, forInit);
		    if (this.checkExpressionErrors(refDestructuringErrors)) { return expr }
		    return expr.start === startPos && expr.type === "ArrowFunctionExpression" ? expr : this.parseExprOp(expr, startPos, startLoc, -1, forInit)
		  };

		  // Parse binary operators with the operator precedence parsing
		  // algorithm. `left` is the left-hand side of the operator.
		  // `minPrec` provides context that allows the function to stop and
		  // defer further parser to one of its callers when it encounters an
		  // operator that has a lower precedence than the set it is parsing.

		  pp$5.parseExprOp = function(left, leftStartPos, leftStartLoc, minPrec, forInit) {
		    var prec = this.type.binop;
		    if (prec != null && (!forInit || this.type !== types$1._in)) {
		      if (prec > minPrec) {
		        var logical = this.type === types$1.logicalOR || this.type === types$1.logicalAND;
		        var coalesce = this.type === types$1.coalesce;
		        if (coalesce) {
		          // Handle the precedence of `tt.coalesce` as equal to the range of logical expressions.
		          // In other words, `node.right` shouldn't contain logical expressions in order to check the mixed error.
		          prec = types$1.logicalAND.binop;
		        }
		        var op = this.value;
		        this.next();
		        var startPos = this.start, startLoc = this.startLoc;
		        var right = this.parseExprOp(this.parseMaybeUnary(null, false, false, forInit), startPos, startLoc, prec, forInit);
		        var node = this.buildBinary(leftStartPos, leftStartLoc, left, right, op, logical || coalesce);
		        if ((logical && this.type === types$1.coalesce) || (coalesce && (this.type === types$1.logicalOR || this.type === types$1.logicalAND))) {
		          this.raiseRecoverable(this.start, "Logical expressions and coalesce expressions cannot be mixed. Wrap either by parentheses");
		        }
		        return this.parseExprOp(node, leftStartPos, leftStartLoc, minPrec, forInit)
		      }
		    }
		    return left
		  };

		  pp$5.buildBinary = function(startPos, startLoc, left, right, op, logical) {
		    if (right.type === "PrivateIdentifier") { this.raise(right.start, "Private identifier can only be left side of binary expression"); }
		    var node = this.startNodeAt(startPos, startLoc);
		    node.left = left;
		    node.operator = op;
		    node.right = right;
		    return this.finishNode(node, logical ? "LogicalExpression" : "BinaryExpression")
		  };

		  // Parse unary operators, both prefix and postfix.

		  pp$5.parseMaybeUnary = function(refDestructuringErrors, sawUnary, incDec, forInit) {
		    var startPos = this.start, startLoc = this.startLoc, expr;
		    if (this.isContextual("await") && this.canAwait) {
		      expr = this.parseAwait(forInit);
		      sawUnary = true;
		    } else if (this.type.prefix) {
		      var node = this.startNode(), update = this.type === types$1.incDec;
		      node.operator = this.value;
		      node.prefix = true;
		      this.next();
		      node.argument = this.parseMaybeUnary(null, true, update, forInit);
		      this.checkExpressionErrors(refDestructuringErrors, true);
		      if (update) { this.checkLValSimple(node.argument); }
		      else if (this.strict && node.operator === "delete" &&
		               node.argument.type === "Identifier")
		        { this.raiseRecoverable(node.start, "Deleting local variable in strict mode"); }
		      else if (node.operator === "delete" && isPrivateFieldAccess(node.argument))
		        { this.raiseRecoverable(node.start, "Private fields can not be deleted"); }
		      else { sawUnary = true; }
		      expr = this.finishNode(node, update ? "UpdateExpression" : "UnaryExpression");
		    } else if (!sawUnary && this.type === types$1.privateId) {
		      if ((forInit || this.privateNameStack.length === 0) && this.options.checkPrivateFields) { this.unexpected(); }
		      expr = this.parsePrivateIdent();
		      // only could be private fields in 'in', such as #x in obj
		      if (this.type !== types$1._in) { this.unexpected(); }
		    } else {
		      expr = this.parseExprSubscripts(refDestructuringErrors, forInit);
		      if (this.checkExpressionErrors(refDestructuringErrors)) { return expr }
		      while (this.type.postfix && !this.canInsertSemicolon()) {
		        var node$1 = this.startNodeAt(startPos, startLoc);
		        node$1.operator = this.value;
		        node$1.prefix = false;
		        node$1.argument = expr;
		        this.checkLValSimple(expr);
		        this.next();
		        expr = this.finishNode(node$1, "UpdateExpression");
		      }
		    }

		    if (!incDec && this.eat(types$1.starstar)) {
		      if (sawUnary)
		        { this.unexpected(this.lastTokStart); }
		      else
		        { return this.buildBinary(startPos, startLoc, expr, this.parseMaybeUnary(null, false, false, forInit), "**", false) }
		    } else {
		      return expr
		    }
		  };

		  function isPrivateFieldAccess(node) {
		    return (
		      node.type === "MemberExpression" && node.property.type === "PrivateIdentifier" ||
		      node.type === "ChainExpression" && isPrivateFieldAccess(node.expression)
		    )
		  }

		  // Parse call, dot, and `[]`-subscript expressions.

		  pp$5.parseExprSubscripts = function(refDestructuringErrors, forInit) {
		    var startPos = this.start, startLoc = this.startLoc;
		    var expr = this.parseExprAtom(refDestructuringErrors, forInit);
		    if (expr.type === "ArrowFunctionExpression" && this.input.slice(this.lastTokStart, this.lastTokEnd) !== ")")
		      { return expr }
		    var result = this.parseSubscripts(expr, startPos, startLoc, false, forInit);
		    if (refDestructuringErrors && result.type === "MemberExpression") {
		      if (refDestructuringErrors.parenthesizedAssign >= result.start) { refDestructuringErrors.parenthesizedAssign = -1; }
		      if (refDestructuringErrors.parenthesizedBind >= result.start) { refDestructuringErrors.parenthesizedBind = -1; }
		      if (refDestructuringErrors.trailingComma >= result.start) { refDestructuringErrors.trailingComma = -1; }
		    }
		    return result
		  };

		  pp$5.parseSubscripts = function(base, startPos, startLoc, noCalls, forInit) {
		    var maybeAsyncArrow = this.options.ecmaVersion >= 8 && base.type === "Identifier" && base.name === "async" &&
		        this.lastTokEnd === base.end && !this.canInsertSemicolon() && base.end - base.start === 5 &&
		        this.potentialArrowAt === base.start;
		    var optionalChained = false;

		    while (true) {
		      var element = this.parseSubscript(base, startPos, startLoc, noCalls, maybeAsyncArrow, optionalChained, forInit);

		      if (element.optional) { optionalChained = true; }
		      if (element === base || element.type === "ArrowFunctionExpression") {
		        if (optionalChained) {
		          var chainNode = this.startNodeAt(startPos, startLoc);
		          chainNode.expression = element;
		          element = this.finishNode(chainNode, "ChainExpression");
		        }
		        return element
		      }

		      base = element;
		    }
		  };

		  pp$5.shouldParseAsyncArrow = function() {
		    return !this.canInsertSemicolon() && this.eat(types$1.arrow)
		  };

		  pp$5.parseSubscriptAsyncArrow = function(startPos, startLoc, exprList, forInit) {
		    return this.parseArrowExpression(this.startNodeAt(startPos, startLoc), exprList, true, forInit)
		  };

		  pp$5.parseSubscript = function(base, startPos, startLoc, noCalls, maybeAsyncArrow, optionalChained, forInit) {
		    var optionalSupported = this.options.ecmaVersion >= 11;
		    var optional = optionalSupported && this.eat(types$1.questionDot);
		    if (noCalls && optional) { this.raise(this.lastTokStart, "Optional chaining cannot appear in the callee of new expressions"); }

		    var computed = this.eat(types$1.bracketL);
		    if (computed || (optional && this.type !== types$1.parenL && this.type !== types$1.backQuote) || this.eat(types$1.dot)) {
		      var node = this.startNodeAt(startPos, startLoc);
		      node.object = base;
		      if (computed) {
		        node.property = this.parseExpression();
		        this.expect(types$1.bracketR);
		      } else if (this.type === types$1.privateId && base.type !== "Super") {
		        node.property = this.parsePrivateIdent();
		      } else {
		        node.property = this.parseIdent(this.options.allowReserved !== "never");
		      }
		      node.computed = !!computed;
		      if (optionalSupported) {
		        node.optional = optional;
		      }
		      base = this.finishNode(node, "MemberExpression");
		    } else if (!noCalls && this.eat(types$1.parenL)) {
		      var refDestructuringErrors = new DestructuringErrors, oldYieldPos = this.yieldPos, oldAwaitPos = this.awaitPos, oldAwaitIdentPos = this.awaitIdentPos;
		      this.yieldPos = 0;
		      this.awaitPos = 0;
		      this.awaitIdentPos = 0;
		      var exprList = this.parseExprList(types$1.parenR, this.options.ecmaVersion >= 8, false, refDestructuringErrors);
		      if (maybeAsyncArrow && !optional && this.shouldParseAsyncArrow()) {
		        this.checkPatternErrors(refDestructuringErrors, false);
		        this.checkYieldAwaitInDefaultParams();
		        if (this.awaitIdentPos > 0)
		          { this.raise(this.awaitIdentPos, "Cannot use 'await' as identifier inside an async function"); }
		        this.yieldPos = oldYieldPos;
		        this.awaitPos = oldAwaitPos;
		        this.awaitIdentPos = oldAwaitIdentPos;
		        return this.parseSubscriptAsyncArrow(startPos, startLoc, exprList, forInit)
		      }
		      this.checkExpressionErrors(refDestructuringErrors, true);
		      this.yieldPos = oldYieldPos || this.yieldPos;
		      this.awaitPos = oldAwaitPos || this.awaitPos;
		      this.awaitIdentPos = oldAwaitIdentPos || this.awaitIdentPos;
		      var node$1 = this.startNodeAt(startPos, startLoc);
		      node$1.callee = base;
		      node$1.arguments = exprList;
		      if (optionalSupported) {
		        node$1.optional = optional;
		      }
		      base = this.finishNode(node$1, "CallExpression");
		    } else if (this.type === types$1.backQuote) {
		      if (optional || optionalChained) {
		        this.raise(this.start, "Optional chaining cannot appear in the tag of tagged template expressions");
		      }
		      var node$2 = this.startNodeAt(startPos, startLoc);
		      node$2.tag = base;
		      node$2.quasi = this.parseTemplate({isTagged: true});
		      base = this.finishNode(node$2, "TaggedTemplateExpression");
		    }
		    return base
		  };

		  // Parse an atomic expression — either a single token that is an
		  // expression, an expression started by a keyword like `function` or
		  // `new`, or an expression wrapped in punctuation like `()`, `[]`,
		  // or `{}`.

		  pp$5.parseExprAtom = function(refDestructuringErrors, forInit, forNew) {
		    // If a division operator appears in an expression position, the
		    // tokenizer got confused, and we force it to read a regexp instead.
		    if (this.type === types$1.slash) { this.readRegexp(); }

		    var node, canBeArrow = this.potentialArrowAt === this.start;
		    switch (this.type) {
		    case types$1._super:
		      if (!this.allowSuper)
		        { this.raise(this.start, "'super' keyword outside a method"); }
		      node = this.startNode();
		      this.next();
		      if (this.type === types$1.parenL && !this.allowDirectSuper)
		        { this.raise(node.start, "super() call outside constructor of a subclass"); }
		      // The `super` keyword can appear at below:
		      // SuperProperty:
		      //     super [ Expression ]
		      //     super . IdentifierName
		      // SuperCall:
		      //     super ( Arguments )
		      if (this.type !== types$1.dot && this.type !== types$1.bracketL && this.type !== types$1.parenL)
		        { this.unexpected(); }
		      return this.finishNode(node, "Super")

		    case types$1._this:
		      node = this.startNode();
		      this.next();
		      return this.finishNode(node, "ThisExpression")

		    case types$1.name:
		      var startPos = this.start, startLoc = this.startLoc, containsEsc = this.containsEsc;
		      var id = this.parseIdent(false);
		      if (this.options.ecmaVersion >= 8 && !containsEsc && id.name === "async" && !this.canInsertSemicolon() && this.eat(types$1._function)) {
		        this.overrideContext(types.f_expr);
		        return this.parseFunction(this.startNodeAt(startPos, startLoc), 0, false, true, forInit)
		      }
		      if (canBeArrow && !this.canInsertSemicolon()) {
		        if (this.eat(types$1.arrow))
		          { return this.parseArrowExpression(this.startNodeAt(startPos, startLoc), [id], false, forInit) }
		        if (this.options.ecmaVersion >= 8 && id.name === "async" && this.type === types$1.name && !containsEsc &&
		            (!this.potentialArrowInForAwait || this.value !== "of" || this.containsEsc)) {
		          id = this.parseIdent(false);
		          if (this.canInsertSemicolon() || !this.eat(types$1.arrow))
		            { this.unexpected(); }
		          return this.parseArrowExpression(this.startNodeAt(startPos, startLoc), [id], true, forInit)
		        }
		      }
		      return id

		    case types$1.regexp:
		      var value = this.value;
		      node = this.parseLiteral(value.value);
		      node.regex = {pattern: value.pattern, flags: value.flags};
		      return node

		    case types$1.num: case types$1.string:
		      return this.parseLiteral(this.value)

		    case types$1._null: case types$1._true: case types$1._false:
		      node = this.startNode();
		      node.value = this.type === types$1._null ? null : this.type === types$1._true;
		      node.raw = this.type.keyword;
		      this.next();
		      return this.finishNode(node, "Literal")

		    case types$1.parenL:
		      var start = this.start, expr = this.parseParenAndDistinguishExpression(canBeArrow, forInit);
		      if (refDestructuringErrors) {
		        if (refDestructuringErrors.parenthesizedAssign < 0 && !this.isSimpleAssignTarget(expr))
		          { refDestructuringErrors.parenthesizedAssign = start; }
		        if (refDestructuringErrors.parenthesizedBind < 0)
		          { refDestructuringErrors.parenthesizedBind = start; }
		      }
		      return expr

		    case types$1.bracketL:
		      node = this.startNode();
		      this.next();
		      node.elements = this.parseExprList(types$1.bracketR, true, true, refDestructuringErrors);
		      return this.finishNode(node, "ArrayExpression")

		    case types$1.braceL:
		      this.overrideContext(types.b_expr);
		      return this.parseObj(false, refDestructuringErrors)

		    case types$1._function:
		      node = this.startNode();
		      this.next();
		      return this.parseFunction(node, 0)

		    case types$1._class:
		      return this.parseClass(this.startNode(), false)

		    case types$1._new:
		      return this.parseNew()

		    case types$1.backQuote:
		      return this.parseTemplate()

		    case types$1._import:
		      if (this.options.ecmaVersion >= 11) {
		        return this.parseExprImport(forNew)
		      } else {
		        return this.unexpected()
		      }

		    default:
		      return this.parseExprAtomDefault()
		    }
		  };

		  pp$5.parseExprAtomDefault = function() {
		    this.unexpected();
		  };

		  pp$5.parseExprImport = function(forNew) {
		    var node = this.startNode();

		    // Consume `import` as an identifier for `import.meta`.
		    // Because `this.parseIdent(true)` doesn't check escape sequences, it needs the check of `this.containsEsc`.
		    if (this.containsEsc) { this.raiseRecoverable(this.start, "Escape sequence in keyword import"); }
		    this.next();

		    if (this.type === types$1.parenL && !forNew) {
		      return this.parseDynamicImport(node)
		    } else if (this.type === types$1.dot) {
		      var meta = this.startNodeAt(node.start, node.loc && node.loc.start);
		      meta.name = "import";
		      node.meta = this.finishNode(meta, "Identifier");
		      return this.parseImportMeta(node)
		    } else {
		      this.unexpected();
		    }
		  };

		  pp$5.parseDynamicImport = function(node) {
		    this.next(); // skip `(`

		    // Parse node.source.
		    node.source = this.parseMaybeAssign();

		    // Verify ending.
		    if (!this.eat(types$1.parenR)) {
		      var errorPos = this.start;
		      if (this.eat(types$1.comma) && this.eat(types$1.parenR)) {
		        this.raiseRecoverable(errorPos, "Trailing comma is not allowed in import()");
		      } else {
		        this.unexpected(errorPos);
		      }
		    }

		    return this.finishNode(node, "ImportExpression")
		  };

		  pp$5.parseImportMeta = function(node) {
		    this.next(); // skip `.`

		    var containsEsc = this.containsEsc;
		    node.property = this.parseIdent(true);

		    if (node.property.name !== "meta")
		      { this.raiseRecoverable(node.property.start, "The only valid meta property for import is 'import.meta'"); }
		    if (containsEsc)
		      { this.raiseRecoverable(node.start, "'import.meta' must not contain escaped characters"); }
		    if (this.options.sourceType !== "module" && !this.options.allowImportExportEverywhere)
		      { this.raiseRecoverable(node.start, "Cannot use 'import.meta' outside a module"); }

		    return this.finishNode(node, "MetaProperty")
		  };

		  pp$5.parseLiteral = function(value) {
		    var node = this.startNode();
		    node.value = value;
		    node.raw = this.input.slice(this.start, this.end);
		    if (node.raw.charCodeAt(node.raw.length - 1) === 110) { node.bigint = node.raw.slice(0, -1).replace(/_/g, ""); }
		    this.next();
		    return this.finishNode(node, "Literal")
		  };

		  pp$5.parseParenExpression = function() {
		    this.expect(types$1.parenL);
		    var val = this.parseExpression();
		    this.expect(types$1.parenR);
		    return val
		  };

		  pp$5.shouldParseArrow = function(exprList) {
		    return !this.canInsertSemicolon()
		  };

		  pp$5.parseParenAndDistinguishExpression = function(canBeArrow, forInit) {
		    var startPos = this.start, startLoc = this.startLoc, val, allowTrailingComma = this.options.ecmaVersion >= 8;
		    if (this.options.ecmaVersion >= 6) {
		      this.next();

		      var innerStartPos = this.start, innerStartLoc = this.startLoc;
		      var exprList = [], first = true, lastIsComma = false;
		      var refDestructuringErrors = new DestructuringErrors, oldYieldPos = this.yieldPos, oldAwaitPos = this.awaitPos, spreadStart;
		      this.yieldPos = 0;
		      this.awaitPos = 0;
		      // Do not save awaitIdentPos to allow checking awaits nested in parameters
		      while (this.type !== types$1.parenR) {
		        first ? first = false : this.expect(types$1.comma);
		        if (allowTrailingComma && this.afterTrailingComma(types$1.parenR, true)) {
		          lastIsComma = true;
		          break
		        } else if (this.type === types$1.ellipsis) {
		          spreadStart = this.start;
		          exprList.push(this.parseParenItem(this.parseRestBinding()));
		          if (this.type === types$1.comma) {
		            this.raiseRecoverable(
		              this.start,
		              "Comma is not permitted after the rest element"
		            );
		          }
		          break
		        } else {
		          exprList.push(this.parseMaybeAssign(false, refDestructuringErrors, this.parseParenItem));
		        }
		      }
		      var innerEndPos = this.lastTokEnd, innerEndLoc = this.lastTokEndLoc;
		      this.expect(types$1.parenR);

		      if (canBeArrow && this.shouldParseArrow(exprList) && this.eat(types$1.arrow)) {
		        this.checkPatternErrors(refDestructuringErrors, false);
		        this.checkYieldAwaitInDefaultParams();
		        this.yieldPos = oldYieldPos;
		        this.awaitPos = oldAwaitPos;
		        return this.parseParenArrowList(startPos, startLoc, exprList, forInit)
		      }

		      if (!exprList.length || lastIsComma) { this.unexpected(this.lastTokStart); }
		      if (spreadStart) { this.unexpected(spreadStart); }
		      this.checkExpressionErrors(refDestructuringErrors, true);
		      this.yieldPos = oldYieldPos || this.yieldPos;
		      this.awaitPos = oldAwaitPos || this.awaitPos;

		      if (exprList.length > 1) {
		        val = this.startNodeAt(innerStartPos, innerStartLoc);
		        val.expressions = exprList;
		        this.finishNodeAt(val, "SequenceExpression", innerEndPos, innerEndLoc);
		      } else {
		        val = exprList[0];
		      }
		    } else {
		      val = this.parseParenExpression();
		    }

		    if (this.options.preserveParens) {
		      var par = this.startNodeAt(startPos, startLoc);
		      par.expression = val;
		      return this.finishNode(par, "ParenthesizedExpression")
		    } else {
		      return val
		    }
		  };

		  pp$5.parseParenItem = function(item) {
		    return item
		  };

		  pp$5.parseParenArrowList = function(startPos, startLoc, exprList, forInit) {
		    return this.parseArrowExpression(this.startNodeAt(startPos, startLoc), exprList, false, forInit)
		  };

		  // New's precedence is slightly tricky. It must allow its argument to
		  // be a `[]` or dot subscript expression, but not a call — at least,
		  // not without wrapping it in parentheses. Thus, it uses the noCalls
		  // argument to parseSubscripts to prevent it from consuming the
		  // argument list.

		  var empty = [];

		  pp$5.parseNew = function() {
		    if (this.containsEsc) { this.raiseRecoverable(this.start, "Escape sequence in keyword new"); }
		    var node = this.startNode();
		    this.next();
		    if (this.options.ecmaVersion >= 6 && this.type === types$1.dot) {
		      var meta = this.startNodeAt(node.start, node.loc && node.loc.start);
		      meta.name = "new";
		      node.meta = this.finishNode(meta, "Identifier");
		      this.next();
		      var containsEsc = this.containsEsc;
		      node.property = this.parseIdent(true);
		      if (node.property.name !== "target")
		        { this.raiseRecoverable(node.property.start, "The only valid meta property for new is 'new.target'"); }
		      if (containsEsc)
		        { this.raiseRecoverable(node.start, "'new.target' must not contain escaped characters"); }
		      if (!this.allowNewDotTarget)
		        { this.raiseRecoverable(node.start, "'new.target' can only be used in functions and class static block"); }
		      return this.finishNode(node, "MetaProperty")
		    }
		    var startPos = this.start, startLoc = this.startLoc;
		    node.callee = this.parseSubscripts(this.parseExprAtom(null, false, true), startPos, startLoc, true, false);
		    if (this.eat(types$1.parenL)) { node.arguments = this.parseExprList(types$1.parenR, this.options.ecmaVersion >= 8, false); }
		    else { node.arguments = empty; }
		    return this.finishNode(node, "NewExpression")
		  };

		  // Parse template expression.

		  pp$5.parseTemplateElement = function(ref) {
		    var isTagged = ref.isTagged;

		    var elem = this.startNode();
		    if (this.type === types$1.invalidTemplate) {
		      if (!isTagged) {
		        this.raiseRecoverable(this.start, "Bad escape sequence in untagged template literal");
		      }
		      elem.value = {
		        raw: this.value,
		        cooked: null
		      };
		    } else {
		      elem.value = {
		        raw: this.input.slice(this.start, this.end).replace(/\r\n?/g, "\n"),
		        cooked: this.value
		      };
		    }
		    this.next();
		    elem.tail = this.type === types$1.backQuote;
		    return this.finishNode(elem, "TemplateElement")
		  };

		  pp$5.parseTemplate = function(ref) {
		    if ( ref === void 0 ) ref = {};
		    var isTagged = ref.isTagged; if ( isTagged === void 0 ) isTagged = false;

		    var node = this.startNode();
		    this.next();
		    node.expressions = [];
		    var curElt = this.parseTemplateElement({isTagged: isTagged});
		    node.quasis = [curElt];
		    while (!curElt.tail) {
		      if (this.type === types$1.eof) { this.raise(this.pos, "Unterminated template literal"); }
		      this.expect(types$1.dollarBraceL);
		      node.expressions.push(this.parseExpression());
		      this.expect(types$1.braceR);
		      node.quasis.push(curElt = this.parseTemplateElement({isTagged: isTagged}));
		    }
		    this.next();
		    return this.finishNode(node, "TemplateLiteral")
		  };

		  pp$5.isAsyncProp = function(prop) {
		    return !prop.computed && prop.key.type === "Identifier" && prop.key.name === "async" &&
		      (this.type === types$1.name || this.type === types$1.num || this.type === types$1.string || this.type === types$1.bracketL || this.type.keyword || (this.options.ecmaVersion >= 9 && this.type === types$1.star)) &&
		      !lineBreak.test(this.input.slice(this.lastTokEnd, this.start))
		  };

		  // Parse an object literal or binding pattern.

		  pp$5.parseObj = function(isPattern, refDestructuringErrors) {
		    var node = this.startNode(), first = true, propHash = {};
		    node.properties = [];
		    this.next();
		    while (!this.eat(types$1.braceR)) {
		      if (!first) {
		        this.expect(types$1.comma);
		        if (this.options.ecmaVersion >= 5 && this.afterTrailingComma(types$1.braceR)) { break }
		      } else { first = false; }

		      var prop = this.parseProperty(isPattern, refDestructuringErrors);
		      if (!isPattern) { this.checkPropClash(prop, propHash, refDestructuringErrors); }
		      node.properties.push(prop);
		    }
		    return this.finishNode(node, isPattern ? "ObjectPattern" : "ObjectExpression")
		  };

		  pp$5.parseProperty = function(isPattern, refDestructuringErrors) {
		    var prop = this.startNode(), isGenerator, isAsync, startPos, startLoc;
		    if (this.options.ecmaVersion >= 9 && this.eat(types$1.ellipsis)) {
		      if (isPattern) {
		        prop.argument = this.parseIdent(false);
		        if (this.type === types$1.comma) {
		          this.raiseRecoverable(this.start, "Comma is not permitted after the rest element");
		        }
		        return this.finishNode(prop, "RestElement")
		      }
		      // Parse argument.
		      prop.argument = this.parseMaybeAssign(false, refDestructuringErrors);
		      // To disallow trailing comma via `this.toAssignable()`.
		      if (this.type === types$1.comma && refDestructuringErrors && refDestructuringErrors.trailingComma < 0) {
		        refDestructuringErrors.trailingComma = this.start;
		      }
		      // Finish
		      return this.finishNode(prop, "SpreadElement")
		    }
		    if (this.options.ecmaVersion >= 6) {
		      prop.method = false;
		      prop.shorthand = false;
		      if (isPattern || refDestructuringErrors) {
		        startPos = this.start;
		        startLoc = this.startLoc;
		      }
		      if (!isPattern)
		        { isGenerator = this.eat(types$1.star); }
		    }
		    var containsEsc = this.containsEsc;
		    this.parsePropertyName(prop);
		    if (!isPattern && !containsEsc && this.options.ecmaVersion >= 8 && !isGenerator && this.isAsyncProp(prop)) {
		      isAsync = true;
		      isGenerator = this.options.ecmaVersion >= 9 && this.eat(types$1.star);
		      this.parsePropertyName(prop);
		    } else {
		      isAsync = false;
		    }
		    this.parsePropertyValue(prop, isPattern, isGenerator, isAsync, startPos, startLoc, refDestructuringErrors, containsEsc);
		    return this.finishNode(prop, "Property")
		  };

		  pp$5.parseGetterSetter = function(prop) {
		    prop.kind = prop.key.name;
		    this.parsePropertyName(prop);
		    prop.value = this.parseMethod(false);
		    var paramCount = prop.kind === "get" ? 0 : 1;
		    if (prop.value.params.length !== paramCount) {
		      var start = prop.value.start;
		      if (prop.kind === "get")
		        { this.raiseRecoverable(start, "getter should have no params"); }
		      else
		        { this.raiseRecoverable(start, "setter should have exactly one param"); }
		    } else {
		      if (prop.kind === "set" && prop.value.params[0].type === "RestElement")
		        { this.raiseRecoverable(prop.value.params[0].start, "Setter cannot use rest params"); }
		    }
		  };

		  pp$5.parsePropertyValue = function(prop, isPattern, isGenerator, isAsync, startPos, startLoc, refDestructuringErrors, containsEsc) {
		    if ((isGenerator || isAsync) && this.type === types$1.colon)
		      { this.unexpected(); }

		    if (this.eat(types$1.colon)) {
		      prop.value = isPattern ? this.parseMaybeDefault(this.start, this.startLoc) : this.parseMaybeAssign(false, refDestructuringErrors);
		      prop.kind = "init";
		    } else if (this.options.ecmaVersion >= 6 && this.type === types$1.parenL) {
		      if (isPattern) { this.unexpected(); }
		      prop.kind = "init";
		      prop.method = true;
		      prop.value = this.parseMethod(isGenerator, isAsync);
		    } else if (!isPattern && !containsEsc &&
		               this.options.ecmaVersion >= 5 && !prop.computed && prop.key.type === "Identifier" &&
		               (prop.key.name === "get" || prop.key.name === "set") &&
		               (this.type !== types$1.comma && this.type !== types$1.braceR && this.type !== types$1.eq)) {
		      if (isGenerator || isAsync) { this.unexpected(); }
		      this.parseGetterSetter(prop);
		    } else if (this.options.ecmaVersion >= 6 && !prop.computed && prop.key.type === "Identifier") {
		      if (isGenerator || isAsync) { this.unexpected(); }
		      this.checkUnreserved(prop.key);
		      if (prop.key.name === "await" && !this.awaitIdentPos)
		        { this.awaitIdentPos = startPos; }
		      prop.kind = "init";
		      if (isPattern) {
		        prop.value = this.parseMaybeDefault(startPos, startLoc, this.copyNode(prop.key));
		      } else if (this.type === types$1.eq && refDestructuringErrors) {
		        if (refDestructuringErrors.shorthandAssign < 0)
		          { refDestructuringErrors.shorthandAssign = this.start; }
		        prop.value = this.parseMaybeDefault(startPos, startLoc, this.copyNode(prop.key));
		      } else {
		        prop.value = this.copyNode(prop.key);
		      }
		      prop.shorthand = true;
		    } else { this.unexpected(); }
		  };

		  pp$5.parsePropertyName = function(prop) {
		    if (this.options.ecmaVersion >= 6) {
		      if (this.eat(types$1.bracketL)) {
		        prop.computed = true;
		        prop.key = this.parseMaybeAssign();
		        this.expect(types$1.bracketR);
		        return prop.key
		      } else {
		        prop.computed = false;
		      }
		    }
		    return prop.key = this.type === types$1.num || this.type === types$1.string ? this.parseExprAtom() : this.parseIdent(this.options.allowReserved !== "never")
		  };

		  // Initialize empty function node.

		  pp$5.initFunction = function(node) {
		    node.id = null;
		    if (this.options.ecmaVersion >= 6) { node.generator = node.expression = false; }
		    if (this.options.ecmaVersion >= 8) { node.async = false; }
		  };

		  // Parse object or class method.

		  pp$5.parseMethod = function(isGenerator, isAsync, allowDirectSuper) {
		    var node = this.startNode(), oldYieldPos = this.yieldPos, oldAwaitPos = this.awaitPos, oldAwaitIdentPos = this.awaitIdentPos;

		    this.initFunction(node);
		    if (this.options.ecmaVersion >= 6)
		      { node.generator = isGenerator; }
		    if (this.options.ecmaVersion >= 8)
		      { node.async = !!isAsync; }

		    this.yieldPos = 0;
		    this.awaitPos = 0;
		    this.awaitIdentPos = 0;
		    this.enterScope(functionFlags(isAsync, node.generator) | SCOPE_SUPER | (allowDirectSuper ? SCOPE_DIRECT_SUPER : 0));

		    this.expect(types$1.parenL);
		    node.params = this.parseBindingList(types$1.parenR, false, this.options.ecmaVersion >= 8);
		    this.checkYieldAwaitInDefaultParams();
		    this.parseFunctionBody(node, false, true, false);

		    this.yieldPos = oldYieldPos;
		    this.awaitPos = oldAwaitPos;
		    this.awaitIdentPos = oldAwaitIdentPos;
		    return this.finishNode(node, "FunctionExpression")
		  };

		  // Parse arrow function expression with given parameters.

		  pp$5.parseArrowExpression = function(node, params, isAsync, forInit) {
		    var oldYieldPos = this.yieldPos, oldAwaitPos = this.awaitPos, oldAwaitIdentPos = this.awaitIdentPos;

		    this.enterScope(functionFlags(isAsync, false) | SCOPE_ARROW);
		    this.initFunction(node);
		    if (this.options.ecmaVersion >= 8) { node.async = !!isAsync; }

		    this.yieldPos = 0;
		    this.awaitPos = 0;
		    this.awaitIdentPos = 0;

		    node.params = this.toAssignableList(params, true);
		    this.parseFunctionBody(node, true, false, forInit);

		    this.yieldPos = oldYieldPos;
		    this.awaitPos = oldAwaitPos;
		    this.awaitIdentPos = oldAwaitIdentPos;
		    return this.finishNode(node, "ArrowFunctionExpression")
		  };

		  // Parse function body and check parameters.

		  pp$5.parseFunctionBody = function(node, isArrowFunction, isMethod, forInit) {
		    var isExpression = isArrowFunction && this.type !== types$1.braceL;
		    var oldStrict = this.strict, useStrict = false;

		    if (isExpression) {
		      node.body = this.parseMaybeAssign(forInit);
		      node.expression = true;
		      this.checkParams(node, false);
		    } else {
		      var nonSimple = this.options.ecmaVersion >= 7 && !this.isSimpleParamList(node.params);
		      if (!oldStrict || nonSimple) {
		        useStrict = this.strictDirective(this.end);
		        // If this is a strict mode function, verify that argument names
		        // are not repeated, and it does not try to bind the words `eval`
		        // or `arguments`.
		        if (useStrict && nonSimple)
		          { this.raiseRecoverable(node.start, "Illegal 'use strict' directive in function with non-simple parameter list"); }
		      }
		      // Start a new scope with regard to labels and the `inFunction`
		      // flag (restore them to their old value afterwards).
		      var oldLabels = this.labels;
		      this.labels = [];
		      if (useStrict) { this.strict = true; }

		      // Add the params to varDeclaredNames to ensure that an error is thrown
		      // if a let/const declaration in the function clashes with one of the params.
		      this.checkParams(node, !oldStrict && !useStrict && !isArrowFunction && !isMethod && this.isSimpleParamList(node.params));
		      // Ensure the function name isn't a forbidden identifier in strict mode, e.g. 'eval'
		      if (this.strict && node.id) { this.checkLValSimple(node.id, BIND_OUTSIDE); }
		      node.body = this.parseBlock(false, undefined, useStrict && !oldStrict);
		      node.expression = false;
		      this.adaptDirectivePrologue(node.body.body);
		      this.labels = oldLabels;
		    }
		    this.exitScope();
		  };

		  pp$5.isSimpleParamList = function(params) {
		    for (var i = 0, list = params; i < list.length; i += 1)
		      {
		      var param = list[i];

		      if (param.type !== "Identifier") { return false
		    } }
		    return true
		  };

		  // Checks function params for various disallowed patterns such as using "eval"
		  // or "arguments" and duplicate parameters.

		  pp$5.checkParams = function(node, allowDuplicates) {
		    var nameHash = Object.create(null);
		    for (var i = 0, list = node.params; i < list.length; i += 1)
		      {
		      var param = list[i];

		      this.checkLValInnerPattern(param, BIND_VAR, allowDuplicates ? null : nameHash);
		    }
		  };

		  // Parses a comma-separated list of expressions, and returns them as
		  // an array. `close` is the token type that ends the list, and
		  // `allowEmpty` can be turned on to allow subsequent commas with
		  // nothing in between them to be parsed as `null` (which is needed
		  // for array literals).

		  pp$5.parseExprList = function(close, allowTrailingComma, allowEmpty, refDestructuringErrors) {
		    var elts = [], first = true;
		    while (!this.eat(close)) {
		      if (!first) {
		        this.expect(types$1.comma);
		        if (allowTrailingComma && this.afterTrailingComma(close)) { break }
		      } else { first = false; }

		      var elt = (void 0);
		      if (allowEmpty && this.type === types$1.comma)
		        { elt = null; }
		      else if (this.type === types$1.ellipsis) {
		        elt = this.parseSpread(refDestructuringErrors);
		        if (refDestructuringErrors && this.type === types$1.comma && refDestructuringErrors.trailingComma < 0)
		          { refDestructuringErrors.trailingComma = this.start; }
		      } else {
		        elt = this.parseMaybeAssign(false, refDestructuringErrors);
		      }
		      elts.push(elt);
		    }
		    return elts
		  };

		  pp$5.checkUnreserved = function(ref) {
		    var start = ref.start;
		    var end = ref.end;
		    var name = ref.name;

		    if (this.inGenerator && name === "yield")
		      { this.raiseRecoverable(start, "Cannot use 'yield' as identifier inside a generator"); }
		    if (this.inAsync && name === "await")
		      { this.raiseRecoverable(start, "Cannot use 'await' as identifier inside an async function"); }
		    if (this.currentThisScope().inClassFieldInit && name === "arguments")
		      { this.raiseRecoverable(start, "Cannot use 'arguments' in class field initializer"); }
		    if (this.inClassStaticBlock && (name === "arguments" || name === "await"))
		      { this.raise(start, ("Cannot use " + name + " in class static initialization block")); }
		    if (this.keywords.test(name))
		      { this.raise(start, ("Unexpected keyword '" + name + "'")); }
		    if (this.options.ecmaVersion < 6 &&
		      this.input.slice(start, end).indexOf("\\") !== -1) { return }
		    var re = this.strict ? this.reservedWordsStrict : this.reservedWords;
		    if (re.test(name)) {
		      if (!this.inAsync && name === "await")
		        { this.raiseRecoverable(start, "Cannot use keyword 'await' outside an async function"); }
		      this.raiseRecoverable(start, ("The keyword '" + name + "' is reserved"));
		    }
		  };

		  // Parse the next token as an identifier. If `liberal` is true (used
		  // when parsing properties), it will also convert keywords into
		  // identifiers.

		  pp$5.parseIdent = function(liberal) {
		    var node = this.parseIdentNode();
		    this.next(!!liberal);
		    this.finishNode(node, "Identifier");
		    if (!liberal) {
		      this.checkUnreserved(node);
		      if (node.name === "await" && !this.awaitIdentPos)
		        { this.awaitIdentPos = node.start; }
		    }
		    return node
		  };

		  pp$5.parseIdentNode = function() {
		    var node = this.startNode();
		    if (this.type === types$1.name) {
		      node.name = this.value;
		    } else if (this.type.keyword) {
		      node.name = this.type.keyword;

		      // To fix https://github.com/acornjs/acorn/issues/575
		      // `class` and `function` keywords push new context into this.context.
		      // But there is no chance to pop the context if the keyword is consumed as an identifier such as a property name.
		      // If the previous token is a dot, this does not apply because the context-managing code already ignored the keyword
		      if ((node.name === "class" || node.name === "function") &&
		        (this.lastTokEnd !== this.lastTokStart + 1 || this.input.charCodeAt(this.lastTokStart) !== 46)) {
		        this.context.pop();
		      }
		      this.type = types$1.name;
		    } else {
		      this.unexpected();
		    }
		    return node
		  };

		  pp$5.parsePrivateIdent = function() {
		    var node = this.startNode();
		    if (this.type === types$1.privateId) {
		      node.name = this.value;
		    } else {
		      this.unexpected();
		    }
		    this.next();
		    this.finishNode(node, "PrivateIdentifier");

		    // For validating existence
		    if (this.options.checkPrivateFields) {
		      if (this.privateNameStack.length === 0) {
		        this.raise(node.start, ("Private field '#" + (node.name) + "' must be declared in an enclosing class"));
		      } else {
		        this.privateNameStack[this.privateNameStack.length - 1].used.push(node);
		      }
		    }

		    return node
		  };

		  // Parses yield expression inside generator.

		  pp$5.parseYield = function(forInit) {
		    if (!this.yieldPos) { this.yieldPos = this.start; }

		    var node = this.startNode();
		    this.next();
		    if (this.type === types$1.semi || this.canInsertSemicolon() || (this.type !== types$1.star && !this.type.startsExpr)) {
		      node.delegate = false;
		      node.argument = null;
		    } else {
		      node.delegate = this.eat(types$1.star);
		      node.argument = this.parseMaybeAssign(forInit);
		    }
		    return this.finishNode(node, "YieldExpression")
		  };

		  pp$5.parseAwait = function(forInit) {
		    if (!this.awaitPos) { this.awaitPos = this.start; }

		    var node = this.startNode();
		    this.next();
		    node.argument = this.parseMaybeUnary(null, true, false, forInit);
		    return this.finishNode(node, "AwaitExpression")
		  };

		  var pp$4 = Parser.prototype;

		  // This function is used to raise exceptions on parse errors. It
		  // takes an offset integer (into the current `input`) to indicate
		  // the location of the error, attaches the position to the end
		  // of the error message, and then raises a `SyntaxError` with that
		  // message.

		  pp$4.raise = function(pos, message) {
		    var loc = getLineInfo(this.input, pos);
		    message += " (" + loc.line + ":" + loc.column + ")";
		    var err = new SyntaxError(message);
		    err.pos = pos; err.loc = loc; err.raisedAt = this.pos;
		    throw err
		  };

		  pp$4.raiseRecoverable = pp$4.raise;

		  pp$4.curPosition = function() {
		    if (this.options.locations) {
		      return new Position(this.curLine, this.pos - this.lineStart)
		    }
		  };

		  var pp$3 = Parser.prototype;

		  var Scope = function Scope(flags) {
		    this.flags = flags;
		    // A list of var-declared names in the current lexical scope
		    this.var = [];
		    // A list of lexically-declared names in the current lexical scope
		    this.lexical = [];
		    // A list of lexically-declared FunctionDeclaration names in the current lexical scope
		    this.functions = [];
		    // A switch to disallow the identifier reference 'arguments'
		    this.inClassFieldInit = false;
		  };

		  // The functions in this module keep track of declared variables in the current scope in order to detect duplicate variable names.

		  pp$3.enterScope = function(flags) {
		    this.scopeStack.push(new Scope(flags));
		  };

		  pp$3.exitScope = function() {
		    this.scopeStack.pop();
		  };

		  // The spec says:
		  // > At the top level of a function, or script, function declarations are
		  // > treated like var declarations rather than like lexical declarations.
		  pp$3.treatFunctionsAsVarInScope = function(scope) {
		    return (scope.flags & SCOPE_FUNCTION) || !this.inModule && (scope.flags & SCOPE_TOP)
		  };

		  pp$3.declareName = function(name, bindingType, pos) {
		    var redeclared = false;
		    if (bindingType === BIND_LEXICAL) {
		      var scope = this.currentScope();
		      redeclared = scope.lexical.indexOf(name) > -1 || scope.functions.indexOf(name) > -1 || scope.var.indexOf(name) > -1;
		      scope.lexical.push(name);
		      if (this.inModule && (scope.flags & SCOPE_TOP))
		        { delete this.undefinedExports[name]; }
		    } else if (bindingType === BIND_SIMPLE_CATCH) {
		      var scope$1 = this.currentScope();
		      scope$1.lexical.push(name);
		    } else if (bindingType === BIND_FUNCTION) {
		      var scope$2 = this.currentScope();
		      if (this.treatFunctionsAsVar)
		        { redeclared = scope$2.lexical.indexOf(name) > -1; }
		      else
		        { redeclared = scope$2.lexical.indexOf(name) > -1 || scope$2.var.indexOf(name) > -1; }
		      scope$2.functions.push(name);
		    } else {
		      for (var i = this.scopeStack.length - 1; i >= 0; --i) {
		        var scope$3 = this.scopeStack[i];
		        if (scope$3.lexical.indexOf(name) > -1 && !((scope$3.flags & SCOPE_SIMPLE_CATCH) && scope$3.lexical[0] === name) ||
		            !this.treatFunctionsAsVarInScope(scope$3) && scope$3.functions.indexOf(name) > -1) {
		          redeclared = true;
		          break
		        }
		        scope$3.var.push(name);
		        if (this.inModule && (scope$3.flags & SCOPE_TOP))
		          { delete this.undefinedExports[name]; }
		        if (scope$3.flags & SCOPE_VAR) { break }
		      }
		    }
		    if (redeclared) { this.raiseRecoverable(pos, ("Identifier '" + name + "' has already been declared")); }
		  };

		  pp$3.checkLocalExport = function(id) {
		    // scope.functions must be empty as Module code is always strict.
		    if (this.scopeStack[0].lexical.indexOf(id.name) === -1 &&
		        this.scopeStack[0].var.indexOf(id.name) === -1) {
		      this.undefinedExports[id.name] = id;
		    }
		  };

		  pp$3.currentScope = function() {
		    return this.scopeStack[this.scopeStack.length - 1]
		  };

		  pp$3.currentVarScope = function() {
		    for (var i = this.scopeStack.length - 1;; i--) {
		      var scope = this.scopeStack[i];
		      if (scope.flags & SCOPE_VAR) { return scope }
		    }
		  };

		  // Could be useful for `this`, `new.target`, `super()`, `super.property`, and `super[property]`.
		  pp$3.currentThisScope = function() {
		    for (var i = this.scopeStack.length - 1;; i--) {
		      var scope = this.scopeStack[i];
		      if (scope.flags & SCOPE_VAR && !(scope.flags & SCOPE_ARROW)) { return scope }
		    }
		  };

		  var Node = function Node(parser, pos, loc) {
		    this.type = "";
		    this.start = pos;
		    this.end = 0;
		    if (parser.options.locations)
		      { this.loc = new SourceLocation(parser, loc); }
		    if (parser.options.directSourceFile)
		      { this.sourceFile = parser.options.directSourceFile; }
		    if (parser.options.ranges)
		      { this.range = [pos, 0]; }
		  };

		  // Start an AST node, attaching a start offset.

		  var pp$2 = Parser.prototype;

		  pp$2.startNode = function() {
		    return new Node(this, this.start, this.startLoc)
		  };

		  pp$2.startNodeAt = function(pos, loc) {
		    return new Node(this, pos, loc)
		  };

		  // Finish an AST node, adding `type` and `end` properties.

		  function finishNodeAt(node, type, pos, loc) {
		    node.type = type;
		    node.end = pos;
		    if (this.options.locations)
		      { node.loc.end = loc; }
		    if (this.options.ranges)
		      { node.range[1] = pos; }
		    return node
		  }

		  pp$2.finishNode = function(node, type) {
		    return finishNodeAt.call(this, node, type, this.lastTokEnd, this.lastTokEndLoc)
		  };

		  // Finish node at given position

		  pp$2.finishNodeAt = function(node, type, pos, loc) {
		    return finishNodeAt.call(this, node, type, pos, loc)
		  };

		  pp$2.copyNode = function(node) {
		    var newNode = new Node(this, node.start, this.startLoc);
		    for (var prop in node) { newNode[prop] = node[prop]; }
		    return newNode
		  };

		  // This file contains Unicode properties extracted from the ECMAScript specification.
		  // The lists are extracted like so:
		  // $$('#table-binary-unicode-properties > figure > table > tbody > tr > td:nth-child(1) code').map(el => el.innerText)

		  // #table-binary-unicode-properties
		  var ecma9BinaryProperties = "ASCII ASCII_Hex_Digit AHex Alphabetic Alpha Any Assigned Bidi_Control Bidi_C Bidi_Mirrored Bidi_M Case_Ignorable CI Cased Changes_When_Casefolded CWCF Changes_When_Casemapped CWCM Changes_When_Lowercased CWL Changes_When_NFKC_Casefolded CWKCF Changes_When_Titlecased CWT Changes_When_Uppercased CWU Dash Default_Ignorable_Code_Point DI Deprecated Dep Diacritic Dia Emoji Emoji_Component Emoji_Modifier Emoji_Modifier_Base Emoji_Presentation Extender Ext Grapheme_Base Gr_Base Grapheme_Extend Gr_Ext Hex_Digit Hex IDS_Binary_Operator IDSB IDS_Trinary_Operator IDST ID_Continue IDC ID_Start IDS Ideographic Ideo Join_Control Join_C Logical_Order_Exception LOE Lowercase Lower Math Noncharacter_Code_Point NChar Pattern_Syntax Pat_Syn Pattern_White_Space Pat_WS Quotation_Mark QMark Radical Regional_Indicator RI Sentence_Terminal STerm Soft_Dotted SD Terminal_Punctuation Term Unified_Ideograph UIdeo Uppercase Upper Variation_Selector VS White_Space space XID_Continue XIDC XID_Start XIDS";
		  var ecma10BinaryProperties = ecma9BinaryProperties + " Extended_Pictographic";
		  var ecma11BinaryProperties = ecma10BinaryProperties;
		  var ecma12BinaryProperties = ecma11BinaryProperties + " EBase EComp EMod EPres ExtPict";
		  var ecma13BinaryProperties = ecma12BinaryProperties;
		  var ecma14BinaryProperties = ecma13BinaryProperties;

		  var unicodeBinaryProperties = {
		    9: ecma9BinaryProperties,
		    10: ecma10BinaryProperties,
		    11: ecma11BinaryProperties,
		    12: ecma12BinaryProperties,
		    13: ecma13BinaryProperties,
		    14: ecma14BinaryProperties
		  };

		  // #table-binary-unicode-properties-of-strings
		  var ecma14BinaryPropertiesOfStrings = "Basic_Emoji Emoji_Keycap_Sequence RGI_Emoji_Modifier_Sequence RGI_Emoji_Flag_Sequence RGI_Emoji_Tag_Sequence RGI_Emoji_ZWJ_Sequence RGI_Emoji";

		  var unicodeBinaryPropertiesOfStrings = {
		    9: "",
		    10: "",
		    11: "",
		    12: "",
		    13: "",
		    14: ecma14BinaryPropertiesOfStrings
		  };

		  // #table-unicode-general-category-values
		  var unicodeGeneralCategoryValues = "Cased_Letter LC Close_Punctuation Pe Connector_Punctuation Pc Control Cc cntrl Currency_Symbol Sc Dash_Punctuation Pd Decimal_Number Nd digit Enclosing_Mark Me Final_Punctuation Pf Format Cf Initial_Punctuation Pi Letter L Letter_Number Nl Line_Separator Zl Lowercase_Letter Ll Mark M Combining_Mark Math_Symbol Sm Modifier_Letter Lm Modifier_Symbol Sk Nonspacing_Mark Mn Number N Open_Punctuation Ps Other C Other_Letter Lo Other_Number No Other_Punctuation Po Other_Symbol So Paragraph_Separator Zp Private_Use Co Punctuation P punct Separator Z Space_Separator Zs Spacing_Mark Mc Surrogate Cs Symbol S Titlecase_Letter Lt Unassigned Cn Uppercase_Letter Lu";

		  // #table-unicode-script-values
		  var ecma9ScriptValues = "Adlam Adlm Ahom Anatolian_Hieroglyphs Hluw Arabic Arab Armenian Armn Avestan Avst Balinese Bali Bamum Bamu Bassa_Vah Bass Batak Batk Bengali Beng Bhaiksuki Bhks Bopomofo Bopo Brahmi Brah Braille Brai Buginese Bugi Buhid Buhd Canadian_Aboriginal Cans Carian Cari Caucasian_Albanian Aghb Chakma Cakm Cham Cham Cherokee Cher Common Zyyy Coptic Copt Qaac Cuneiform Xsux Cypriot Cprt Cyrillic Cyrl Deseret Dsrt Devanagari Deva Duployan Dupl Egyptian_Hieroglyphs Egyp Elbasan Elba Ethiopic Ethi Georgian Geor Glagolitic Glag Gothic Goth Grantha Gran Greek Grek Gujarati Gujr Gurmukhi Guru Han Hani Hangul Hang Hanunoo Hano Hatran Hatr Hebrew Hebr Hiragana Hira Imperial_Aramaic Armi Inherited Zinh Qaai Inscriptional_Pahlavi Phli Inscriptional_Parthian Prti Javanese Java Kaithi Kthi Kannada Knda Katakana Kana Kayah_Li Kali Kharoshthi Khar Khmer Khmr Khojki Khoj Khudawadi Sind Lao Laoo Latin Latn Lepcha Lepc Limbu Limb Linear_A Lina Linear_B Linb Lisu Lisu Lycian Lyci Lydian Lydi Mahajani Mahj Malayalam Mlym Mandaic Mand Manichaean Mani Marchen Marc Masaram_Gondi Gonm Meetei_Mayek Mtei Mende_Kikakui Mend Meroitic_Cursive Merc Meroitic_Hieroglyphs Mero Miao Plrd Modi Mongolian Mong Mro Mroo Multani Mult Myanmar Mymr Nabataean Nbat New_Tai_Lue Talu Newa Newa Nko Nkoo Nushu Nshu Ogham Ogam Ol_Chiki Olck Old_Hungarian Hung Old_Italic Ital Old_North_Arabian Narb Old_Permic Perm Old_Persian Xpeo Old_South_Arabian Sarb Old_Turkic Orkh Oriya Orya Osage Osge Osmanya Osma Pahawh_Hmong Hmng Palmyrene Palm Pau_Cin_Hau Pauc Phags_Pa Phag Phoenician Phnx Psalter_Pahlavi Phlp Rejang Rjng Runic Runr Samaritan Samr Saurashtra Saur Sharada Shrd Shavian Shaw Siddham Sidd SignWriting Sgnw Sinhala Sinh Sora_Sompeng Sora Soyombo Soyo Sundanese Sund Syloti_Nagri Sylo Syriac Syrc Tagalog Tglg Tagbanwa Tagb Tai_Le Tale Tai_Tham Lana Tai_Viet Tavt Takri Takr Tamil Taml Tangut Tang Telugu Telu Thaana Thaa Thai Thai Tibetan Tibt Tifinagh Tfng Tirhuta Tirh Ugaritic Ugar Vai Vaii Warang_Citi Wara Yi Yiii Zanabazar_Square Zanb";
		  var ecma10ScriptValues = ecma9ScriptValues + " Dogra Dogr Gunjala_Gondi Gong Hanifi_Rohingya Rohg Makasar Maka Medefaidrin Medf Old_Sogdian Sogo Sogdian Sogd";
		  var ecma11ScriptValues = ecma10ScriptValues + " Elymaic Elym Nandinagari Nand Nyiakeng_Puachue_Hmong Hmnp Wancho Wcho";
		  var ecma12ScriptValues = ecma11ScriptValues + " Chorasmian Chrs Diak Dives_Akuru Khitan_Small_Script Kits Yezi Yezidi";
		  var ecma13ScriptValues = ecma12ScriptValues + " Cypro_Minoan Cpmn Old_Uyghur Ougr Tangsa Tnsa Toto Vithkuqi Vith";
		  var ecma14ScriptValues = ecma13ScriptValues + " Hrkt Katakana_Or_Hiragana Kawi Nag_Mundari Nagm Unknown Zzzz";

		  var unicodeScriptValues = {
		    9: ecma9ScriptValues,
		    10: ecma10ScriptValues,
		    11: ecma11ScriptValues,
		    12: ecma12ScriptValues,
		    13: ecma13ScriptValues,
		    14: ecma14ScriptValues
		  };

		  var data = {};
		  function buildUnicodeData(ecmaVersion) {
		    var d = data[ecmaVersion] = {
		      binary: wordsRegexp(unicodeBinaryProperties[ecmaVersion] + " " + unicodeGeneralCategoryValues),
		      binaryOfStrings: wordsRegexp(unicodeBinaryPropertiesOfStrings[ecmaVersion]),
		      nonBinary: {
		        General_Category: wordsRegexp(unicodeGeneralCategoryValues),
		        Script: wordsRegexp(unicodeScriptValues[ecmaVersion])
		      }
		    };
		    d.nonBinary.Script_Extensions = d.nonBinary.Script;

		    d.nonBinary.gc = d.nonBinary.General_Category;
		    d.nonBinary.sc = d.nonBinary.Script;
		    d.nonBinary.scx = d.nonBinary.Script_Extensions;
		  }

		  for (var i = 0, list = [9, 10, 11, 12, 13, 14]; i < list.length; i += 1) {
		    var ecmaVersion = list[i];

		    buildUnicodeData(ecmaVersion);
		  }

		  var pp$1 = Parser.prototype;

		  var RegExpValidationState = function RegExpValidationState(parser) {
		    this.parser = parser;
		    this.validFlags = "gim" + (parser.options.ecmaVersion >= 6 ? "uy" : "") + (parser.options.ecmaVersion >= 9 ? "s" : "") + (parser.options.ecmaVersion >= 13 ? "d" : "") + (parser.options.ecmaVersion >= 15 ? "v" : "");
		    this.unicodeProperties = data[parser.options.ecmaVersion >= 14 ? 14 : parser.options.ecmaVersion];
		    this.source = "";
		    this.flags = "";
		    this.start = 0;
		    this.switchU = false;
		    this.switchV = false;
		    this.switchN = false;
		    this.pos = 0;
		    this.lastIntValue = 0;
		    this.lastStringValue = "";
		    this.lastAssertionIsQuantifiable = false;
		    this.numCapturingParens = 0;
		    this.maxBackReference = 0;
		    this.groupNames = [];
		    this.backReferenceNames = [];
		  };

		  RegExpValidationState.prototype.reset = function reset (start, pattern, flags) {
		    var unicodeSets = flags.indexOf("v") !== -1;
		    var unicode = flags.indexOf("u") !== -1;
		    this.start = start | 0;
		    this.source = pattern + "";
		    this.flags = flags;
		    if (unicodeSets && this.parser.options.ecmaVersion >= 15) {
		      this.switchU = true;
		      this.switchV = true;
		      this.switchN = true;
		    } else {
		      this.switchU = unicode && this.parser.options.ecmaVersion >= 6;
		      this.switchV = false;
		      this.switchN = unicode && this.parser.options.ecmaVersion >= 9;
		    }
		  };

		  RegExpValidationState.prototype.raise = function raise (message) {
		    this.parser.raiseRecoverable(this.start, ("Invalid regular expression: /" + (this.source) + "/: " + message));
		  };

		  // If u flag is given, this returns the code point at the index (it combines a surrogate pair).
		  // Otherwise, this returns the code unit of the index (can be a part of a surrogate pair).
		  RegExpValidationState.prototype.at = function at (i, forceU) {
		      if ( forceU === void 0 ) forceU = false;

		    var s = this.source;
		    var l = s.length;
		    if (i >= l) {
		      return -1
		    }
		    var c = s.charCodeAt(i);
		    if (!(forceU || this.switchU) || c <= 0xD7FF || c >= 0xE000 || i + 1 >= l) {
		      return c
		    }
		    var next = s.charCodeAt(i + 1);
		    return next >= 0xDC00 && next <= 0xDFFF ? (c << 10) + next - 0x35FDC00 : c
		  };

		  RegExpValidationState.prototype.nextIndex = function nextIndex (i, forceU) {
		      if ( forceU === void 0 ) forceU = false;

		    var s = this.source;
		    var l = s.length;
		    if (i >= l) {
		      return l
		    }
		    var c = s.charCodeAt(i), next;
		    if (!(forceU || this.switchU) || c <= 0xD7FF || c >= 0xE000 || i + 1 >= l ||
		        (next = s.charCodeAt(i + 1)) < 0xDC00 || next > 0xDFFF) {
		      return i + 1
		    }
		    return i + 2
		  };

		  RegExpValidationState.prototype.current = function current (forceU) {
		      if ( forceU === void 0 ) forceU = false;

		    return this.at(this.pos, forceU)
		  };

		  RegExpValidationState.prototype.lookahead = function lookahead (forceU) {
		      if ( forceU === void 0 ) forceU = false;

		    return this.at(this.nextIndex(this.pos, forceU), forceU)
		  };

		  RegExpValidationState.prototype.advance = function advance (forceU) {
		      if ( forceU === void 0 ) forceU = false;

		    this.pos = this.nextIndex(this.pos, forceU);
		  };

		  RegExpValidationState.prototype.eat = function eat (ch, forceU) {
		      if ( forceU === void 0 ) forceU = false;

		    if (this.current(forceU) === ch) {
		      this.advance(forceU);
		      return true
		    }
		    return false
		  };

		  RegExpValidationState.prototype.eatChars = function eatChars (chs, forceU) {
		      if ( forceU === void 0 ) forceU = false;

		    var pos = this.pos;
		    for (var i = 0, list = chs; i < list.length; i += 1) {
		      var ch = list[i];

		        var current = this.at(pos, forceU);
		      if (current === -1 || current !== ch) {
		        return false
		      }
		      pos = this.nextIndex(pos, forceU);
		    }
		    this.pos = pos;
		    return true
		  };

		  /**
		   * Validate the flags part of a given RegExpLiteral.
		   *
		   * @param {RegExpValidationState} state The state to validate RegExp.
		   * @returns {void}
		   */
		  pp$1.validateRegExpFlags = function(state) {
		    var validFlags = state.validFlags;
		    var flags = state.flags;

		    var u = false;
		    var v = false;

		    for (var i = 0; i < flags.length; i++) {
		      var flag = flags.charAt(i);
		      if (validFlags.indexOf(flag) === -1) {
		        this.raise(state.start, "Invalid regular expression flag");
		      }
		      if (flags.indexOf(flag, i + 1) > -1) {
		        this.raise(state.start, "Duplicate regular expression flag");
		      }
		      if (flag === "u") { u = true; }
		      if (flag === "v") { v = true; }
		    }
		    if (this.options.ecmaVersion >= 15 && u && v) {
		      this.raise(state.start, "Invalid regular expression flag");
		    }
		  };

		  /**
		   * Validate the pattern part of a given RegExpLiteral.
		   *
		   * @param {RegExpValidationState} state The state to validate RegExp.
		   * @returns {void}
		   */
		  pp$1.validateRegExpPattern = function(state) {
		    this.regexp_pattern(state);

		    // The goal symbol for the parse is |Pattern[~U, ~N]|. If the result of
		    // parsing contains a |GroupName|, reparse with the goal symbol
		    // |Pattern[~U, +N]| and use this result instead. Throw a *SyntaxError*
		    // exception if _P_ did not conform to the grammar, if any elements of _P_
		    // were not matched by the parse, or if any Early Error conditions exist.
		    if (!state.switchN && this.options.ecmaVersion >= 9 && state.groupNames.length > 0) {
		      state.switchN = true;
		      this.regexp_pattern(state);
		    }
		  };

		  // https://www.ecma-international.org/ecma-262/8.0/#prod-Pattern
		  pp$1.regexp_pattern = function(state) {
		    state.pos = 0;
		    state.lastIntValue = 0;
		    state.lastStringValue = "";
		    state.lastAssertionIsQuantifiable = false;
		    state.numCapturingParens = 0;
		    state.maxBackReference = 0;
		    state.groupNames.length = 0;
		    state.backReferenceNames.length = 0;

		    this.regexp_disjunction(state);

		    if (state.pos !== state.source.length) {
		      // Make the same messages as V8.
		      if (state.eat(0x29 /* ) */)) {
		        state.raise("Unmatched ')'");
		      }
		      if (state.eat(0x5D /* ] */) || state.eat(0x7D /* } */)) {
		        state.raise("Lone quantifier brackets");
		      }
		    }
		    if (state.maxBackReference > state.numCapturingParens) {
		      state.raise("Invalid escape");
		    }
		    for (var i = 0, list = state.backReferenceNames; i < list.length; i += 1) {
		      var name = list[i];

		      if (state.groupNames.indexOf(name) === -1) {
		        state.raise("Invalid named capture referenced");
		      }
		    }
		  };

		  // https://www.ecma-international.org/ecma-262/8.0/#prod-Disjunction
		  pp$1.regexp_disjunction = function(state) {
		    this.regexp_alternative(state);
		    while (state.eat(0x7C /* | */)) {
		      this.regexp_alternative(state);
		    }

		    // Make the same message as V8.
		    if (this.regexp_eatQuantifier(state, true)) {
		      state.raise("Nothing to repeat");
		    }
		    if (state.eat(0x7B /* { */)) {
		      state.raise("Lone quantifier brackets");
		    }
		  };

		  // https://www.ecma-international.org/ecma-262/8.0/#prod-Alternative
		  pp$1.regexp_alternative = function(state) {
		    while (state.pos < state.source.length && this.regexp_eatTerm(state))
		      { }
		  };

		  // https://www.ecma-international.org/ecma-262/8.0/#prod-annexB-Term
		  pp$1.regexp_eatTerm = function(state) {
		    if (this.regexp_eatAssertion(state)) {
		      // Handle `QuantifiableAssertion Quantifier` alternative.
		      // `state.lastAssertionIsQuantifiable` is true if the last eaten Assertion
		      // is a QuantifiableAssertion.
		      if (state.lastAssertionIsQuantifiable && this.regexp_eatQuantifier(state)) {
		        // Make the same message as V8.
		        if (state.switchU) {
		          state.raise("Invalid quantifier");
		        }
		      }
		      return true
		    }

		    if (state.switchU ? this.regexp_eatAtom(state) : this.regexp_eatExtendedAtom(state)) {
		      this.regexp_eatQuantifier(state);
		      return true
		    }

		    return false
		  };

		  // https://www.ecma-international.org/ecma-262/8.0/#prod-annexB-Assertion
		  pp$1.regexp_eatAssertion = function(state) {
		    var start = state.pos;
		    state.lastAssertionIsQuantifiable = false;

		    // ^, $
		    if (state.eat(0x5E /* ^ */) || state.eat(0x24 /* $ */)) {
		      return true
		    }

		    // \b \B
		    if (state.eat(0x5C /* \ */)) {
		      if (state.eat(0x42 /* B */) || state.eat(0x62 /* b */)) {
		        return true
		      }
		      state.pos = start;
		    }

		    // Lookahead / Lookbehind
		    if (state.eat(0x28 /* ( */) && state.eat(0x3F /* ? */)) {
		      var lookbehind = false;
		      if (this.options.ecmaVersion >= 9) {
		        lookbehind = state.eat(0x3C /* < */);
		      }
		      if (state.eat(0x3D /* = */) || state.eat(0x21 /* ! */)) {
		        this.regexp_disjunction(state);
		        if (!state.eat(0x29 /* ) */)) {
		          state.raise("Unterminated group");
		        }
		        state.lastAssertionIsQuantifiable = !lookbehind;
		        return true
		      }
		    }

		    state.pos = start;
		    return false
		  };

		  // https://www.ecma-international.org/ecma-262/8.0/#prod-Quantifier
		  pp$1.regexp_eatQuantifier = function(state, noError) {
		    if ( noError === void 0 ) noError = false;

		    if (this.regexp_eatQuantifierPrefix(state, noError)) {
		      state.eat(0x3F /* ? */);
		      return true
		    }
		    return false
		  };

		  // https://www.ecma-international.org/ecma-262/8.0/#prod-QuantifierPrefix
		  pp$1.regexp_eatQuantifierPrefix = function(state, noError) {
		    return (
		      state.eat(0x2A /* * */) ||
		      state.eat(0x2B /* + */) ||
		      state.eat(0x3F /* ? */) ||
		      this.regexp_eatBracedQuantifier(state, noError)
		    )
		  };
		  pp$1.regexp_eatBracedQuantifier = function(state, noError) {
		    var start = state.pos;
		    if (state.eat(0x7B /* { */)) {
		      var min = 0, max = -1;
		      if (this.regexp_eatDecimalDigits(state)) {
		        min = state.lastIntValue;
		        if (state.eat(0x2C /* , */) && this.regexp_eatDecimalDigits(state)) {
		          max = state.lastIntValue;
		        }
		        if (state.eat(0x7D /* } */)) {
		          // SyntaxError in https://www.ecma-international.org/ecma-262/8.0/#sec-term
		          if (max !== -1 && max < min && !noError) {
		            state.raise("numbers out of order in {} quantifier");
		          }
		          return true
		        }
		      }
		      if (state.switchU && !noError) {
		        state.raise("Incomplete quantifier");
		      }
		      state.pos = start;
		    }
		    return false
		  };

		  // https://www.ecma-international.org/ecma-262/8.0/#prod-Atom
		  pp$1.regexp_eatAtom = function(state) {
		    return (
		      this.regexp_eatPatternCharacters(state) ||
		      state.eat(0x2E /* . */) ||
		      this.regexp_eatReverseSolidusAtomEscape(state) ||
		      this.regexp_eatCharacterClass(state) ||
		      this.regexp_eatUncapturingGroup(state) ||
		      this.regexp_eatCapturingGroup(state)
		    )
		  };
		  pp$1.regexp_eatReverseSolidusAtomEscape = function(state) {
		    var start = state.pos;
		    if (state.eat(0x5C /* \ */)) {
		      if (this.regexp_eatAtomEscape(state)) {
		        return true
		      }
		      state.pos = start;
		    }
		    return false
		  };
		  pp$1.regexp_eatUncapturingGroup = function(state) {
		    var start = state.pos;
		    if (state.eat(0x28 /* ( */)) {
		      if (state.eat(0x3F /* ? */) && state.eat(0x3A /* : */)) {
		        this.regexp_disjunction(state);
		        if (state.eat(0x29 /* ) */)) {
		          return true
		        }
		        state.raise("Unterminated group");
		      }
		      state.pos = start;
		    }
		    return false
		  };
		  pp$1.regexp_eatCapturingGroup = function(state) {
		    if (state.eat(0x28 /* ( */)) {
		      if (this.options.ecmaVersion >= 9) {
		        this.regexp_groupSpecifier(state);
		      } else if (state.current() === 0x3F /* ? */) {
		        state.raise("Invalid group");
		      }
		      this.regexp_disjunction(state);
		      if (state.eat(0x29 /* ) */)) {
		        state.numCapturingParens += 1;
		        return true
		      }
		      state.raise("Unterminated group");
		    }
		    return false
		  };

		  // https://www.ecma-international.org/ecma-262/8.0/#prod-annexB-ExtendedAtom
		  pp$1.regexp_eatExtendedAtom = function(state) {
		    return (
		      state.eat(0x2E /* . */) ||
		      this.regexp_eatReverseSolidusAtomEscape(state) ||
		      this.regexp_eatCharacterClass(state) ||
		      this.regexp_eatUncapturingGroup(state) ||
		      this.regexp_eatCapturingGroup(state) ||
		      this.regexp_eatInvalidBracedQuantifier(state) ||
		      this.regexp_eatExtendedPatternCharacter(state)
		    )
		  };

		  // https://www.ecma-international.org/ecma-262/8.0/#prod-annexB-InvalidBracedQuantifier
		  pp$1.regexp_eatInvalidBracedQuantifier = function(state) {
		    if (this.regexp_eatBracedQuantifier(state, true)) {
		      state.raise("Nothing to repeat");
		    }
		    return false
		  };

		  // https://www.ecma-international.org/ecma-262/8.0/#prod-SyntaxCharacter
		  pp$1.regexp_eatSyntaxCharacter = function(state) {
		    var ch = state.current();
		    if (isSyntaxCharacter(ch)) {
		      state.lastIntValue = ch;
		      state.advance();
		      return true
		    }
		    return false
		  };
		  function isSyntaxCharacter(ch) {
		    return (
		      ch === 0x24 /* $ */ ||
		      ch >= 0x28 /* ( */ && ch <= 0x2B /* + */ ||
		      ch === 0x2E /* . */ ||
		      ch === 0x3F /* ? */ ||
		      ch >= 0x5B /* [ */ && ch <= 0x5E /* ^ */ ||
		      ch >= 0x7B /* { */ && ch <= 0x7D /* } */
		    )
		  }

		  // https://www.ecma-international.org/ecma-262/8.0/#prod-PatternCharacter
		  // But eat eager.
		  pp$1.regexp_eatPatternCharacters = function(state) {
		    var start = state.pos;
		    var ch = 0;
		    while ((ch = state.current()) !== -1 && !isSyntaxCharacter(ch)) {
		      state.advance();
		    }
		    return state.pos !== start
		  };

		  // https://www.ecma-international.org/ecma-262/8.0/#prod-annexB-ExtendedPatternCharacter
		  pp$1.regexp_eatExtendedPatternCharacter = function(state) {
		    var ch = state.current();
		    if (
		      ch !== -1 &&
		      ch !== 0x24 /* $ */ &&
		      !(ch >= 0x28 /* ( */ && ch <= 0x2B /* + */) &&
		      ch !== 0x2E /* . */ &&
		      ch !== 0x3F /* ? */ &&
		      ch !== 0x5B /* [ */ &&
		      ch !== 0x5E /* ^ */ &&
		      ch !== 0x7C /* | */
		    ) {
		      state.advance();
		      return true
		    }
		    return false
		  };

		  // GroupSpecifier ::
		  //   [empty]
		  //   `?` GroupName
		  pp$1.regexp_groupSpecifier = function(state) {
		    if (state.eat(0x3F /* ? */)) {
		      if (this.regexp_eatGroupName(state)) {
		        if (state.groupNames.indexOf(state.lastStringValue) !== -1) {
		          state.raise("Duplicate capture group name");
		        }
		        state.groupNames.push(state.lastStringValue);
		        return
		      }
		      state.raise("Invalid group");
		    }
		  };

		  // GroupName ::
		  //   `<` RegExpIdentifierName `>`
		  // Note: this updates `state.lastStringValue` property with the eaten name.
		  pp$1.regexp_eatGroupName = function(state) {
		    state.lastStringValue = "";
		    if (state.eat(0x3C /* < */)) {
		      if (this.regexp_eatRegExpIdentifierName(state) && state.eat(0x3E /* > */)) {
		        return true
		      }
		      state.raise("Invalid capture group name");
		    }
		    return false
		  };

		  // RegExpIdentifierName ::
		  //   RegExpIdentifierStart
		  //   RegExpIdentifierName RegExpIdentifierPart
		  // Note: this updates `state.lastStringValue` property with the eaten name.
		  pp$1.regexp_eatRegExpIdentifierName = function(state) {
		    state.lastStringValue = "";
		    if (this.regexp_eatRegExpIdentifierStart(state)) {
		      state.lastStringValue += codePointToString(state.lastIntValue);
		      while (this.regexp_eatRegExpIdentifierPart(state)) {
		        state.lastStringValue += codePointToString(state.lastIntValue);
		      }
		      return true
		    }
		    return false
		  };

		  // RegExpIdentifierStart ::
		  //   UnicodeIDStart
		  //   `$`
		  //   `_`
		  //   `\` RegExpUnicodeEscapeSequence[+U]
		  pp$1.regexp_eatRegExpIdentifierStart = function(state) {
		    var start = state.pos;
		    var forceU = this.options.ecmaVersion >= 11;
		    var ch = state.current(forceU);
		    state.advance(forceU);

		    if (ch === 0x5C /* \ */ && this.regexp_eatRegExpUnicodeEscapeSequence(state, forceU)) {
		      ch = state.lastIntValue;
		    }
		    if (isRegExpIdentifierStart(ch)) {
		      state.lastIntValue = ch;
		      return true
		    }

		    state.pos = start;
		    return false
		  };
		  function isRegExpIdentifierStart(ch) {
		    return isIdentifierStart(ch, true) || ch === 0x24 /* $ */ || ch === 0x5F /* _ */
		  }

		  // RegExpIdentifierPart ::
		  //   UnicodeIDContinue
		  //   `$`
		  //   `_`
		  //   `\` RegExpUnicodeEscapeSequence[+U]
		  //   <ZWNJ>
		  //   <ZWJ>
		  pp$1.regexp_eatRegExpIdentifierPart = function(state) {
		    var start = state.pos;
		    var forceU = this.options.ecmaVersion >= 11;
		    var ch = state.current(forceU);
		    state.advance(forceU);

		    if (ch === 0x5C /* \ */ && this.regexp_eatRegExpUnicodeEscapeSequence(state, forceU)) {
		      ch = state.lastIntValue;
		    }
		    if (isRegExpIdentifierPart(ch)) {
		      state.lastIntValue = ch;
		      return true
		    }

		    state.pos = start;
		    return false
		  };
		  function isRegExpIdentifierPart(ch) {
		    return isIdentifierChar(ch, true) || ch === 0x24 /* $ */ || ch === 0x5F /* _ */ || ch === 0x200C /* <ZWNJ> */ || ch === 0x200D /* <ZWJ> */
		  }

		  // https://www.ecma-international.org/ecma-262/8.0/#prod-annexB-AtomEscape
		  pp$1.regexp_eatAtomEscape = function(state) {
		    if (
		      this.regexp_eatBackReference(state) ||
		      this.regexp_eatCharacterClassEscape(state) ||
		      this.regexp_eatCharacterEscape(state) ||
		      (state.switchN && this.regexp_eatKGroupName(state))
		    ) {
		      return true
		    }
		    if (state.switchU) {
		      // Make the same message as V8.
		      if (state.current() === 0x63 /* c */) {
		        state.raise("Invalid unicode escape");
		      }
		      state.raise("Invalid escape");
		    }
		    return false
		  };
		  pp$1.regexp_eatBackReference = function(state) {
		    var start = state.pos;
		    if (this.regexp_eatDecimalEscape(state)) {
		      var n = state.lastIntValue;
		      if (state.switchU) {
		        // For SyntaxError in https://www.ecma-international.org/ecma-262/8.0/#sec-atomescape
		        if (n > state.maxBackReference) {
		          state.maxBackReference = n;
		        }
		        return true
		      }
		      if (n <= state.numCapturingParens) {
		        return true
		      }
		      state.pos = start;
		    }
		    return false
		  };
		  pp$1.regexp_eatKGroupName = function(state) {
		    if (state.eat(0x6B /* k */)) {
		      if (this.regexp_eatGroupName(state)) {
		        state.backReferenceNames.push(state.lastStringValue);
		        return true
		      }
		      state.raise("Invalid named reference");
		    }
		    return false
		  };

		  // https://www.ecma-international.org/ecma-262/8.0/#prod-annexB-CharacterEscape
		  pp$1.regexp_eatCharacterEscape = function(state) {
		    return (
		      this.regexp_eatControlEscape(state) ||
		      this.regexp_eatCControlLetter(state) ||
		      this.regexp_eatZero(state) ||
		      this.regexp_eatHexEscapeSequence(state) ||
		      this.regexp_eatRegExpUnicodeEscapeSequence(state, false) ||
		      (!state.switchU && this.regexp_eatLegacyOctalEscapeSequence(state)) ||
		      this.regexp_eatIdentityEscape(state)
		    )
		  };
		  pp$1.regexp_eatCControlLetter = function(state) {
		    var start = state.pos;
		    if (state.eat(0x63 /* c */)) {
		      if (this.regexp_eatControlLetter(state)) {
		        return true
		      }
		      state.pos = start;
		    }
		    return false
		  };
		  pp$1.regexp_eatZero = function(state) {
		    if (state.current() === 0x30 /* 0 */ && !isDecimalDigit(state.lookahead())) {
		      state.lastIntValue = 0;
		      state.advance();
		      return true
		    }
		    return false
		  };

		  // https://www.ecma-international.org/ecma-262/8.0/#prod-ControlEscape
		  pp$1.regexp_eatControlEscape = function(state) {
		    var ch = state.current();
		    if (ch === 0x74 /* t */) {
		      state.lastIntValue = 0x09; /* \t */
		      state.advance();
		      return true
		    }
		    if (ch === 0x6E /* n */) {
		      state.lastIntValue = 0x0A; /* \n */
		      state.advance();
		      return true
		    }
		    if (ch === 0x76 /* v */) {
		      state.lastIntValue = 0x0B; /* \v */
		      state.advance();
		      return true
		    }
		    if (ch === 0x66 /* f */) {
		      state.lastIntValue = 0x0C; /* \f */
		      state.advance();
		      return true
		    }
		    if (ch === 0x72 /* r */) {
		      state.lastIntValue = 0x0D; /* \r */
		      state.advance();
		      return true
		    }
		    return false
		  };

		  // https://www.ecma-international.org/ecma-262/8.0/#prod-ControlLetter
		  pp$1.regexp_eatControlLetter = function(state) {
		    var ch = state.current();
		    if (isControlLetter(ch)) {
		      state.lastIntValue = ch % 0x20;
		      state.advance();
		      return true
		    }
		    return false
		  };
		  function isControlLetter(ch) {
		    return (
		      (ch >= 0x41 /* A */ && ch <= 0x5A /* Z */) ||
		      (ch >= 0x61 /* a */ && ch <= 0x7A /* z */)
		    )
		  }

		  // https://www.ecma-international.org/ecma-262/8.0/#prod-RegExpUnicodeEscapeSequence
		  pp$1.regexp_eatRegExpUnicodeEscapeSequence = function(state, forceU) {
		    if ( forceU === void 0 ) forceU = false;

		    var start = state.pos;
		    var switchU = forceU || state.switchU;

		    if (state.eat(0x75 /* u */)) {
		      if (this.regexp_eatFixedHexDigits(state, 4)) {
		        var lead = state.lastIntValue;
		        if (switchU && lead >= 0xD800 && lead <= 0xDBFF) {
		          var leadSurrogateEnd = state.pos;
		          if (state.eat(0x5C /* \ */) && state.eat(0x75 /* u */) && this.regexp_eatFixedHexDigits(state, 4)) {
		            var trail = state.lastIntValue;
		            if (trail >= 0xDC00 && trail <= 0xDFFF) {
		              state.lastIntValue = (lead - 0xD800) * 0x400 + (trail - 0xDC00) + 0x10000;
		              return true
		            }
		          }
		          state.pos = leadSurrogateEnd;
		          state.lastIntValue = lead;
		        }
		        return true
		      }
		      if (
		        switchU &&
		        state.eat(0x7B /* { */) &&
		        this.regexp_eatHexDigits(state) &&
		        state.eat(0x7D /* } */) &&
		        isValidUnicode(state.lastIntValue)
		      ) {
		        return true
		      }
		      if (switchU) {
		        state.raise("Invalid unicode escape");
		      }
		      state.pos = start;
		    }

		    return false
		  };
		  function isValidUnicode(ch) {
		    return ch >= 0 && ch <= 0x10FFFF
		  }

		  // https://www.ecma-international.org/ecma-262/8.0/#prod-annexB-IdentityEscape
		  pp$1.regexp_eatIdentityEscape = function(state) {
		    if (state.switchU) {
		      if (this.regexp_eatSyntaxCharacter(state)) {
		        return true
		      }
		      if (state.eat(0x2F /* / */)) {
		        state.lastIntValue = 0x2F; /* / */
		        return true
		      }
		      return false
		    }

		    var ch = state.current();
		    if (ch !== 0x63 /* c */ && (!state.switchN || ch !== 0x6B /* k */)) {
		      state.lastIntValue = ch;
		      state.advance();
		      return true
		    }

		    return false
		  };

		  // https://www.ecma-international.org/ecma-262/8.0/#prod-DecimalEscape
		  pp$1.regexp_eatDecimalEscape = function(state) {
		    state.lastIntValue = 0;
		    var ch = state.current();
		    if (ch >= 0x31 /* 1 */ && ch <= 0x39 /* 9 */) {
		      do {
		        state.lastIntValue = 10 * state.lastIntValue + (ch - 0x30 /* 0 */);
		        state.advance();
		      } while ((ch = state.current()) >= 0x30 /* 0 */ && ch <= 0x39 /* 9 */)
		      return true
		    }
		    return false
		  };

		  // Return values used by character set parsing methods, needed to
		  // forbid negation of sets that can match strings.
		  var CharSetNone = 0; // Nothing parsed
		  var CharSetOk = 1; // Construct parsed, cannot contain strings
		  var CharSetString = 2; // Construct parsed, can contain strings

		  // https://www.ecma-international.org/ecma-262/8.0/#prod-CharacterClassEscape
		  pp$1.regexp_eatCharacterClassEscape = function(state) {
		    var ch = state.current();

		    if (isCharacterClassEscape(ch)) {
		      state.lastIntValue = -1;
		      state.advance();
		      return CharSetOk
		    }

		    var negate = false;
		    if (
		      state.switchU &&
		      this.options.ecmaVersion >= 9 &&
		      ((negate = ch === 0x50 /* P */) || ch === 0x70 /* p */)
		    ) {
		      state.lastIntValue = -1;
		      state.advance();
		      var result;
		      if (
		        state.eat(0x7B /* { */) &&
		        (result = this.regexp_eatUnicodePropertyValueExpression(state)) &&
		        state.eat(0x7D /* } */)
		      ) {
		        if (negate && result === CharSetString) { state.raise("Invalid property name"); }
		        return result
		      }
		      state.raise("Invalid property name");
		    }

		    return CharSetNone
		  };

		  function isCharacterClassEscape(ch) {
		    return (
		      ch === 0x64 /* d */ ||
		      ch === 0x44 /* D */ ||
		      ch === 0x73 /* s */ ||
		      ch === 0x53 /* S */ ||
		      ch === 0x77 /* w */ ||
		      ch === 0x57 /* W */
		    )
		  }

		  // UnicodePropertyValueExpression ::
		  //   UnicodePropertyName `=` UnicodePropertyValue
		  //   LoneUnicodePropertyNameOrValue
		  pp$1.regexp_eatUnicodePropertyValueExpression = function(state) {
		    var start = state.pos;

		    // UnicodePropertyName `=` UnicodePropertyValue
		    if (this.regexp_eatUnicodePropertyName(state) && state.eat(0x3D /* = */)) {
		      var name = state.lastStringValue;
		      if (this.regexp_eatUnicodePropertyValue(state)) {
		        var value = state.lastStringValue;
		        this.regexp_validateUnicodePropertyNameAndValue(state, name, value);
		        return CharSetOk
		      }
		    }
		    state.pos = start;

		    // LoneUnicodePropertyNameOrValue
		    if (this.regexp_eatLoneUnicodePropertyNameOrValue(state)) {
		      var nameOrValue = state.lastStringValue;
		      return this.regexp_validateUnicodePropertyNameOrValue(state, nameOrValue)
		    }
		    return CharSetNone
		  };

		  pp$1.regexp_validateUnicodePropertyNameAndValue = function(state, name, value) {
		    if (!hasOwn(state.unicodeProperties.nonBinary, name))
		      { state.raise("Invalid property name"); }
		    if (!state.unicodeProperties.nonBinary[name].test(value))
		      { state.raise("Invalid property value"); }
		  };

		  pp$1.regexp_validateUnicodePropertyNameOrValue = function(state, nameOrValue) {
		    if (state.unicodeProperties.binary.test(nameOrValue)) { return CharSetOk }
		    if (state.switchV && state.unicodeProperties.binaryOfStrings.test(nameOrValue)) { return CharSetString }
		    state.raise("Invalid property name");
		  };

		  // UnicodePropertyName ::
		  //   UnicodePropertyNameCharacters
		  pp$1.regexp_eatUnicodePropertyName = function(state) {
		    var ch = 0;
		    state.lastStringValue = "";
		    while (isUnicodePropertyNameCharacter(ch = state.current())) {
		      state.lastStringValue += codePointToString(ch);
		      state.advance();
		    }
		    return state.lastStringValue !== ""
		  };

		  function isUnicodePropertyNameCharacter(ch) {
		    return isControlLetter(ch) || ch === 0x5F /* _ */
		  }

		  // UnicodePropertyValue ::
		  //   UnicodePropertyValueCharacters
		  pp$1.regexp_eatUnicodePropertyValue = function(state) {
		    var ch = 0;
		    state.lastStringValue = "";
		    while (isUnicodePropertyValueCharacter(ch = state.current())) {
		      state.lastStringValue += codePointToString(ch);
		      state.advance();
		    }
		    return state.lastStringValue !== ""
		  };
		  function isUnicodePropertyValueCharacter(ch) {
		    return isUnicodePropertyNameCharacter(ch) || isDecimalDigit(ch)
		  }

		  // LoneUnicodePropertyNameOrValue ::
		  //   UnicodePropertyValueCharacters
		  pp$1.regexp_eatLoneUnicodePropertyNameOrValue = function(state) {
		    return this.regexp_eatUnicodePropertyValue(state)
		  };

		  // https://www.ecma-international.org/ecma-262/8.0/#prod-CharacterClass
		  pp$1.regexp_eatCharacterClass = function(state) {
		    if (state.eat(0x5B /* [ */)) {
		      var negate = state.eat(0x5E /* ^ */);
		      var result = this.regexp_classContents(state);
		      if (!state.eat(0x5D /* ] */))
		        { state.raise("Unterminated character class"); }
		      if (negate && result === CharSetString)
		        { state.raise("Negated character class may contain strings"); }
		      return true
		    }
		    return false
		  };

		  // https://tc39.es/ecma262/#prod-ClassContents
		  // https://www.ecma-international.org/ecma-262/8.0/#prod-ClassRanges
		  pp$1.regexp_classContents = function(state) {
		    if (state.current() === 0x5D /* ] */) { return CharSetOk }
		    if (state.switchV) { return this.regexp_classSetExpression(state) }
		    this.regexp_nonEmptyClassRanges(state);
		    return CharSetOk
		  };

		  // https://www.ecma-international.org/ecma-262/8.0/#prod-NonemptyClassRanges
		  // https://www.ecma-international.org/ecma-262/8.0/#prod-NonemptyClassRangesNoDash
		  pp$1.regexp_nonEmptyClassRanges = function(state) {
		    while (this.regexp_eatClassAtom(state)) {
		      var left = state.lastIntValue;
		      if (state.eat(0x2D /* - */) && this.regexp_eatClassAtom(state)) {
		        var right = state.lastIntValue;
		        if (state.switchU && (left === -1 || right === -1)) {
		          state.raise("Invalid character class");
		        }
		        if (left !== -1 && right !== -1 && left > right) {
		          state.raise("Range out of order in character class");
		        }
		      }
		    }
		  };

		  // https://www.ecma-international.org/ecma-262/8.0/#prod-ClassAtom
		  // https://www.ecma-international.org/ecma-262/8.0/#prod-ClassAtomNoDash
		  pp$1.regexp_eatClassAtom = function(state) {
		    var start = state.pos;

		    if (state.eat(0x5C /* \ */)) {
		      if (this.regexp_eatClassEscape(state)) {
		        return true
		      }
		      if (state.switchU) {
		        // Make the same message as V8.
		        var ch$1 = state.current();
		        if (ch$1 === 0x63 /* c */ || isOctalDigit(ch$1)) {
		          state.raise("Invalid class escape");
		        }
		        state.raise("Invalid escape");
		      }
		      state.pos = start;
		    }

		    var ch = state.current();
		    if (ch !== 0x5D /* ] */) {
		      state.lastIntValue = ch;
		      state.advance();
		      return true
		    }

		    return false
		  };

		  // https://www.ecma-international.org/ecma-262/8.0/#prod-annexB-ClassEscape
		  pp$1.regexp_eatClassEscape = function(state) {
		    var start = state.pos;

		    if (state.eat(0x62 /* b */)) {
		      state.lastIntValue = 0x08; /* <BS> */
		      return true
		    }

		    if (state.switchU && state.eat(0x2D /* - */)) {
		      state.lastIntValue = 0x2D; /* - */
		      return true
		    }

		    if (!state.switchU && state.eat(0x63 /* c */)) {
		      if (this.regexp_eatClassControlLetter(state)) {
		        return true
		      }
		      state.pos = start;
		    }

		    return (
		      this.regexp_eatCharacterClassEscape(state) ||
		      this.regexp_eatCharacterEscape(state)
		    )
		  };

		  // https://tc39.es/ecma262/#prod-ClassSetExpression
		  // https://tc39.es/ecma262/#prod-ClassUnion
		  // https://tc39.es/ecma262/#prod-ClassIntersection
		  // https://tc39.es/ecma262/#prod-ClassSubtraction
		  pp$1.regexp_classSetExpression = function(state) {
		    var result = CharSetOk, subResult;
		    if (this.regexp_eatClassSetRange(state)) ; else if (subResult = this.regexp_eatClassSetOperand(state)) {
		      if (subResult === CharSetString) { result = CharSetString; }
		      // https://tc39.es/ecma262/#prod-ClassIntersection
		      var start = state.pos;
		      while (state.eatChars([0x26, 0x26] /* && */)) {
		        if (
		          state.current() !== 0x26 /* & */ &&
		          (subResult = this.regexp_eatClassSetOperand(state))
		        ) {
		          if (subResult !== CharSetString) { result = CharSetOk; }
		          continue
		        }
		        state.raise("Invalid character in character class");
		      }
		      if (start !== state.pos) { return result }
		      // https://tc39.es/ecma262/#prod-ClassSubtraction
		      while (state.eatChars([0x2D, 0x2D] /* -- */)) {
		        if (this.regexp_eatClassSetOperand(state)) { continue }
		        state.raise("Invalid character in character class");
		      }
		      if (start !== state.pos) { return result }
		    } else {
		      state.raise("Invalid character in character class");
		    }
		    // https://tc39.es/ecma262/#prod-ClassUnion
		    for (;;) {
		      if (this.regexp_eatClassSetRange(state)) { continue }
		      subResult = this.regexp_eatClassSetOperand(state);
		      if (!subResult) { return result }
		      if (subResult === CharSetString) { result = CharSetString; }
		    }
		  };

		  // https://tc39.es/ecma262/#prod-ClassSetRange
		  pp$1.regexp_eatClassSetRange = function(state) {
		    var start = state.pos;
		    if (this.regexp_eatClassSetCharacter(state)) {
		      var left = state.lastIntValue;
		      if (state.eat(0x2D /* - */) && this.regexp_eatClassSetCharacter(state)) {
		        var right = state.lastIntValue;
		        if (left !== -1 && right !== -1 && left > right) {
		          state.raise("Range out of order in character class");
		        }
		        return true
		      }
		      state.pos = start;
		    }
		    return false
		  };

		  // https://tc39.es/ecma262/#prod-ClassSetOperand
		  pp$1.regexp_eatClassSetOperand = function(state) {
		    if (this.regexp_eatClassSetCharacter(state)) { return CharSetOk }
		    return this.regexp_eatClassStringDisjunction(state) || this.regexp_eatNestedClass(state)
		  };

		  // https://tc39.es/ecma262/#prod-NestedClass
		  pp$1.regexp_eatNestedClass = function(state) {
		    var start = state.pos;
		    if (state.eat(0x5B /* [ */)) {
		      var negate = state.eat(0x5E /* ^ */);
		      var result = this.regexp_classContents(state);
		      if (state.eat(0x5D /* ] */)) {
		        if (negate && result === CharSetString) {
		          state.raise("Negated character class may contain strings");
		        }
		        return result
		      }
		      state.pos = start;
		    }
		    if (state.eat(0x5C /* \ */)) {
		      var result$1 = this.regexp_eatCharacterClassEscape(state);
		      if (result$1) {
		        return result$1
		      }
		      state.pos = start;
		    }
		    return null
		  };

		  // https://tc39.es/ecma262/#prod-ClassStringDisjunction
		  pp$1.regexp_eatClassStringDisjunction = function(state) {
		    var start = state.pos;
		    if (state.eatChars([0x5C, 0x71] /* \q */)) {
		      if (state.eat(0x7B /* { */)) {
		        var result = this.regexp_classStringDisjunctionContents(state);
		        if (state.eat(0x7D /* } */)) {
		          return result
		        }
		      } else {
		        // Make the same message as V8.
		        state.raise("Invalid escape");
		      }
		      state.pos = start;
		    }
		    return null
		  };

		  // https://tc39.es/ecma262/#prod-ClassStringDisjunctionContents
		  pp$1.regexp_classStringDisjunctionContents = function(state) {
		    var result = this.regexp_classString(state);
		    while (state.eat(0x7C /* | */)) {
		      if (this.regexp_classString(state) === CharSetString) { result = CharSetString; }
		    }
		    return result
		  };

		  // https://tc39.es/ecma262/#prod-ClassString
		  // https://tc39.es/ecma262/#prod-NonEmptyClassString
		  pp$1.regexp_classString = function(state) {
		    var count = 0;
		    while (this.regexp_eatClassSetCharacter(state)) { count++; }
		    return count === 1 ? CharSetOk : CharSetString
		  };

		  // https://tc39.es/ecma262/#prod-ClassSetCharacter
		  pp$1.regexp_eatClassSetCharacter = function(state) {
		    var start = state.pos;
		    if (state.eat(0x5C /* \ */)) {
		      if (
		        this.regexp_eatCharacterEscape(state) ||
		        this.regexp_eatClassSetReservedPunctuator(state)
		      ) {
		        return true
		      }
		      if (state.eat(0x62 /* b */)) {
		        state.lastIntValue = 0x08; /* <BS> */
		        return true
		      }
		      state.pos = start;
		      return false
		    }
		    var ch = state.current();
		    if (ch < 0 || ch === state.lookahead() && isClassSetReservedDoublePunctuatorCharacter(ch)) { return false }
		    if (isClassSetSyntaxCharacter(ch)) { return false }
		    state.advance();
		    state.lastIntValue = ch;
		    return true
		  };

		  // https://tc39.es/ecma262/#prod-ClassSetReservedDoublePunctuator
		  function isClassSetReservedDoublePunctuatorCharacter(ch) {
		    return (
		      ch === 0x21 /* ! */ ||
		      ch >= 0x23 /* # */ && ch <= 0x26 /* & */ ||
		      ch >= 0x2A /* * */ && ch <= 0x2C /* , */ ||
		      ch === 0x2E /* . */ ||
		      ch >= 0x3A /* : */ && ch <= 0x40 /* @ */ ||
		      ch === 0x5E /* ^ */ ||
		      ch === 0x60 /* ` */ ||
		      ch === 0x7E /* ~ */
		    )
		  }

		  // https://tc39.es/ecma262/#prod-ClassSetSyntaxCharacter
		  function isClassSetSyntaxCharacter(ch) {
		    return (
		      ch === 0x28 /* ( */ ||
		      ch === 0x29 /* ) */ ||
		      ch === 0x2D /* - */ ||
		      ch === 0x2F /* / */ ||
		      ch >= 0x5B /* [ */ && ch <= 0x5D /* ] */ ||
		      ch >= 0x7B /* { */ && ch <= 0x7D /* } */
		    )
		  }

		  // https://tc39.es/ecma262/#prod-ClassSetReservedPunctuator
		  pp$1.regexp_eatClassSetReservedPunctuator = function(state) {
		    var ch = state.current();
		    if (isClassSetReservedPunctuator(ch)) {
		      state.lastIntValue = ch;
		      state.advance();
		      return true
		    }
		    return false
		  };

		  // https://tc39.es/ecma262/#prod-ClassSetReservedPunctuator
		  function isClassSetReservedPunctuator(ch) {
		    return (
		      ch === 0x21 /* ! */ ||
		      ch === 0x23 /* # */ ||
		      ch === 0x25 /* % */ ||
		      ch === 0x26 /* & */ ||
		      ch === 0x2C /* , */ ||
		      ch === 0x2D /* - */ ||
		      ch >= 0x3A /* : */ && ch <= 0x3E /* > */ ||
		      ch === 0x40 /* @ */ ||
		      ch === 0x60 /* ` */ ||
		      ch === 0x7E /* ~ */
		    )
		  }

		  // https://www.ecma-international.org/ecma-262/8.0/#prod-annexB-ClassControlLetter
		  pp$1.regexp_eatClassControlLetter = function(state) {
		    var ch = state.current();
		    if (isDecimalDigit(ch) || ch === 0x5F /* _ */) {
		      state.lastIntValue = ch % 0x20;
		      state.advance();
		      return true
		    }
		    return false
		  };

		  // https://www.ecma-international.org/ecma-262/8.0/#prod-HexEscapeSequence
		  pp$1.regexp_eatHexEscapeSequence = function(state) {
		    var start = state.pos;
		    if (state.eat(0x78 /* x */)) {
		      if (this.regexp_eatFixedHexDigits(state, 2)) {
		        return true
		      }
		      if (state.switchU) {
		        state.raise("Invalid escape");
		      }
		      state.pos = start;
		    }
		    return false
		  };

		  // https://www.ecma-international.org/ecma-262/8.0/#prod-DecimalDigits
		  pp$1.regexp_eatDecimalDigits = function(state) {
		    var start = state.pos;
		    var ch = 0;
		    state.lastIntValue = 0;
		    while (isDecimalDigit(ch = state.current())) {
		      state.lastIntValue = 10 * state.lastIntValue + (ch - 0x30 /* 0 */);
		      state.advance();
		    }
		    return state.pos !== start
		  };
		  function isDecimalDigit(ch) {
		    return ch >= 0x30 /* 0 */ && ch <= 0x39 /* 9 */
		  }

		  // https://www.ecma-international.org/ecma-262/8.0/#prod-HexDigits
		  pp$1.regexp_eatHexDigits = function(state) {
		    var start = state.pos;
		    var ch = 0;
		    state.lastIntValue = 0;
		    while (isHexDigit(ch = state.current())) {
		      state.lastIntValue = 16 * state.lastIntValue + hexToInt(ch);
		      state.advance();
		    }
		    return state.pos !== start
		  };
		  function isHexDigit(ch) {
		    return (
		      (ch >= 0x30 /* 0 */ && ch <= 0x39 /* 9 */) ||
		      (ch >= 0x41 /* A */ && ch <= 0x46 /* F */) ||
		      (ch >= 0x61 /* a */ && ch <= 0x66 /* f */)
		    )
		  }
		  function hexToInt(ch) {
		    if (ch >= 0x41 /* A */ && ch <= 0x46 /* F */) {
		      return 10 + (ch - 0x41 /* A */)
		    }
		    if (ch >= 0x61 /* a */ && ch <= 0x66 /* f */) {
		      return 10 + (ch - 0x61 /* a */)
		    }
		    return ch - 0x30 /* 0 */
		  }

		  // https://www.ecma-international.org/ecma-262/8.0/#prod-annexB-LegacyOctalEscapeSequence
		  // Allows only 0-377(octal) i.e. 0-255(decimal).
		  pp$1.regexp_eatLegacyOctalEscapeSequence = function(state) {
		    if (this.regexp_eatOctalDigit(state)) {
		      var n1 = state.lastIntValue;
		      if (this.regexp_eatOctalDigit(state)) {
		        var n2 = state.lastIntValue;
		        if (n1 <= 3 && this.regexp_eatOctalDigit(state)) {
		          state.lastIntValue = n1 * 64 + n2 * 8 + state.lastIntValue;
		        } else {
		          state.lastIntValue = n1 * 8 + n2;
		        }
		      } else {
		        state.lastIntValue = n1;
		      }
		      return true
		    }
		    return false
		  };

		  // https://www.ecma-international.org/ecma-262/8.0/#prod-OctalDigit
		  pp$1.regexp_eatOctalDigit = function(state) {
		    var ch = state.current();
		    if (isOctalDigit(ch)) {
		      state.lastIntValue = ch - 0x30; /* 0 */
		      state.advance();
		      return true
		    }
		    state.lastIntValue = 0;
		    return false
		  };
		  function isOctalDigit(ch) {
		    return ch >= 0x30 /* 0 */ && ch <= 0x37 /* 7 */
		  }

		  // https://www.ecma-international.org/ecma-262/8.0/#prod-Hex4Digits
		  // https://www.ecma-international.org/ecma-262/8.0/#prod-HexDigit
		  // And HexDigit HexDigit in https://www.ecma-international.org/ecma-262/8.0/#prod-HexEscapeSequence
		  pp$1.regexp_eatFixedHexDigits = function(state, length) {
		    var start = state.pos;
		    state.lastIntValue = 0;
		    for (var i = 0; i < length; ++i) {
		      var ch = state.current();
		      if (!isHexDigit(ch)) {
		        state.pos = start;
		        return false
		      }
		      state.lastIntValue = 16 * state.lastIntValue + hexToInt(ch);
		      state.advance();
		    }
		    return true
		  };

		  // Object type used to represent tokens. Note that normally, tokens
		  // simply exist as properties on the parser object. This is only
		  // used for the onToken callback and the external tokenizer.

		  var Token = function Token(p) {
		    this.type = p.type;
		    this.value = p.value;
		    this.start = p.start;
		    this.end = p.end;
		    if (p.options.locations)
		      { this.loc = new SourceLocation(p, p.startLoc, p.endLoc); }
		    if (p.options.ranges)
		      { this.range = [p.start, p.end]; }
		  };

		  // ## Tokenizer

		  var pp = Parser.prototype;

		  // Move to the next token

		  pp.next = function(ignoreEscapeSequenceInKeyword) {
		    if (!ignoreEscapeSequenceInKeyword && this.type.keyword && this.containsEsc)
		      { this.raiseRecoverable(this.start, "Escape sequence in keyword " + this.type.keyword); }
		    if (this.options.onToken)
		      { this.options.onToken(new Token(this)); }

		    this.lastTokEnd = this.end;
		    this.lastTokStart = this.start;
		    this.lastTokEndLoc = this.endLoc;
		    this.lastTokStartLoc = this.startLoc;
		    this.nextToken();
		  };

		  pp.getToken = function() {
		    this.next();
		    return new Token(this)
		  };

		  // If we're in an ES6 environment, make parsers iterable
		  if (typeof Symbol !== "undefined")
		    { pp[Symbol.iterator] = function() {
		      var this$1$1 = this;

		      return {
		        next: function () {
		          var token = this$1$1.getToken();
		          return {
		            done: token.type === types$1.eof,
		            value: token
		          }
		        }
		      }
		    }; }

		  // Toggle strict mode. Re-reads the next number or string to please
		  // pedantic tests (`"use strict"; 010;` should fail).

		  // Read a single token, updating the parser object's token-related
		  // properties.

		  pp.nextToken = function() {
		    var curContext = this.curContext();
		    if (!curContext || !curContext.preserveSpace) { this.skipSpace(); }

		    this.start = this.pos;
		    if (this.options.locations) { this.startLoc = this.curPosition(); }
		    if (this.pos >= this.input.length) { return this.finishToken(types$1.eof) }

		    if (curContext.override) { return curContext.override(this) }
		    else { this.readToken(this.fullCharCodeAtPos()); }
		  };

		  pp.readToken = function(code) {
		    // Identifier or keyword. '\uXXXX' sequences are allowed in
		    // identifiers, so '\' also dispatches to that.
		    if (isIdentifierStart(code, this.options.ecmaVersion >= 6) || code === 92 /* '\' */)
		      { return this.readWord() }

		    return this.getTokenFromCode(code)
		  };

		  pp.fullCharCodeAtPos = function() {
		    var code = this.input.charCodeAt(this.pos);
		    if (code <= 0xd7ff || code >= 0xdc00) { return code }
		    var next = this.input.charCodeAt(this.pos + 1);
		    return next <= 0xdbff || next >= 0xe000 ? code : (code << 10) + next - 0x35fdc00
		  };

		  pp.skipBlockComment = function() {
		    var startLoc = this.options.onComment && this.curPosition();
		    var start = this.pos, end = this.input.indexOf("*/", this.pos += 2);
		    if (end === -1) { this.raise(this.pos - 2, "Unterminated comment"); }
		    this.pos = end + 2;
		    if (this.options.locations) {
		      for (var nextBreak = (void 0), pos = start; (nextBreak = nextLineBreak(this.input, pos, this.pos)) > -1;) {
		        ++this.curLine;
		        pos = this.lineStart = nextBreak;
		      }
		    }
		    if (this.options.onComment)
		      { this.options.onComment(true, this.input.slice(start + 2, end), start, this.pos,
		                             startLoc, this.curPosition()); }
		  };

		  pp.skipLineComment = function(startSkip) {
		    var start = this.pos;
		    var startLoc = this.options.onComment && this.curPosition();
		    var ch = this.input.charCodeAt(this.pos += startSkip);
		    while (this.pos < this.input.length && !isNewLine(ch)) {
		      ch = this.input.charCodeAt(++this.pos);
		    }
		    if (this.options.onComment)
		      { this.options.onComment(false, this.input.slice(start + startSkip, this.pos), start, this.pos,
		                             startLoc, this.curPosition()); }
		  };

		  // Called at the start of the parse and after every token. Skips
		  // whitespace and comments, and.

		  pp.skipSpace = function() {
		    loop: while (this.pos < this.input.length) {
		      var ch = this.input.charCodeAt(this.pos);
		      switch (ch) {
		      case 32: case 160: // ' '
		        ++this.pos;
		        break
		      case 13:
		        if (this.input.charCodeAt(this.pos + 1) === 10) {
		          ++this.pos;
		        }
		      case 10: case 8232: case 8233:
		        ++this.pos;
		        if (this.options.locations) {
		          ++this.curLine;
		          this.lineStart = this.pos;
		        }
		        break
		      case 47: // '/'
		        switch (this.input.charCodeAt(this.pos + 1)) {
		        case 42: // '*'
		          this.skipBlockComment();
		          break
		        case 47:
		          this.skipLineComment(2);
		          break
		        default:
		          break loop
		        }
		        break
		      default:
		        if (ch > 8 && ch < 14 || ch >= 5760 && nonASCIIwhitespace.test(String.fromCharCode(ch))) {
		          ++this.pos;
		        } else {
		          break loop
		        }
		      }
		    }
		  };

		  // Called at the end of every token. Sets `end`, `val`, and
		  // maintains `context` and `exprAllowed`, and skips the space after
		  // the token, so that the next one's `start` will point at the
		  // right position.

		  pp.finishToken = function(type, val) {
		    this.end = this.pos;
		    if (this.options.locations) { this.endLoc = this.curPosition(); }
		    var prevType = this.type;
		    this.type = type;
		    this.value = val;

		    this.updateContext(prevType);
		  };

		  // ### Token reading

		  // This is the function that is called to fetch the next token. It
		  // is somewhat obscure, because it works in character codes rather
		  // than characters, and because operator parsing has been inlined
		  // into it.
		  //
		  // All in the name of speed.
		  //
		  pp.readToken_dot = function() {
		    var next = this.input.charCodeAt(this.pos + 1);
		    if (next >= 48 && next <= 57) { return this.readNumber(true) }
		    var next2 = this.input.charCodeAt(this.pos + 2);
		    if (this.options.ecmaVersion >= 6 && next === 46 && next2 === 46) { // 46 = dot '.'
		      this.pos += 3;
		      return this.finishToken(types$1.ellipsis)
		    } else {
		      ++this.pos;
		      return this.finishToken(types$1.dot)
		    }
		  };

		  pp.readToken_slash = function() { // '/'
		    var next = this.input.charCodeAt(this.pos + 1);
		    if (this.exprAllowed) { ++this.pos; return this.readRegexp() }
		    if (next === 61) { return this.finishOp(types$1.assign, 2) }
		    return this.finishOp(types$1.slash, 1)
		  };

		  pp.readToken_mult_modulo_exp = function(code) { // '%*'
		    var next = this.input.charCodeAt(this.pos + 1);
		    var size = 1;
		    var tokentype = code === 42 ? types$1.star : types$1.modulo;

		    // exponentiation operator ** and **=
		    if (this.options.ecmaVersion >= 7 && code === 42 && next === 42) {
		      ++size;
		      tokentype = types$1.starstar;
		      next = this.input.charCodeAt(this.pos + 2);
		    }

		    if (next === 61) { return this.finishOp(types$1.assign, size + 1) }
		    return this.finishOp(tokentype, size)
		  };

		  pp.readToken_pipe_amp = function(code) { // '|&'
		    var next = this.input.charCodeAt(this.pos + 1);
		    if (next === code) {
		      if (this.options.ecmaVersion >= 12) {
		        var next2 = this.input.charCodeAt(this.pos + 2);
		        if (next2 === 61) { return this.finishOp(types$1.assign, 3) }
		      }
		      return this.finishOp(code === 124 ? types$1.logicalOR : types$1.logicalAND, 2)
		    }
		    if (next === 61) { return this.finishOp(types$1.assign, 2) }
		    return this.finishOp(code === 124 ? types$1.bitwiseOR : types$1.bitwiseAND, 1)
		  };

		  pp.readToken_caret = function() { // '^'
		    var next = this.input.charCodeAt(this.pos + 1);
		    if (next === 61) { return this.finishOp(types$1.assign, 2) }
		    return this.finishOp(types$1.bitwiseXOR, 1)
		  };

		  pp.readToken_plus_min = function(code) { // '+-'
		    var next = this.input.charCodeAt(this.pos + 1);
		    if (next === code) {
		      if (next === 45 && !this.inModule && this.input.charCodeAt(this.pos + 2) === 62 &&
		          (this.lastTokEnd === 0 || lineBreak.test(this.input.slice(this.lastTokEnd, this.pos)))) {
		        // A `-->` line comment
		        this.skipLineComment(3);
		        this.skipSpace();
		        return this.nextToken()
		      }
		      return this.finishOp(types$1.incDec, 2)
		    }
		    if (next === 61) { return this.finishOp(types$1.assign, 2) }
		    return this.finishOp(types$1.plusMin, 1)
		  };

		  pp.readToken_lt_gt = function(code) { // '<>'
		    var next = this.input.charCodeAt(this.pos + 1);
		    var size = 1;
		    if (next === code) {
		      size = code === 62 && this.input.charCodeAt(this.pos + 2) === 62 ? 3 : 2;
		      if (this.input.charCodeAt(this.pos + size) === 61) { return this.finishOp(types$1.assign, size + 1) }
		      return this.finishOp(types$1.bitShift, size)
		    }
		    if (next === 33 && code === 60 && !this.inModule && this.input.charCodeAt(this.pos + 2) === 45 &&
		        this.input.charCodeAt(this.pos + 3) === 45) {
		      // `<!--`, an XML-style comment that should be interpreted as a line comment
		      this.skipLineComment(4);
		      this.skipSpace();
		      return this.nextToken()
		    }
		    if (next === 61) { size = 2; }
		    return this.finishOp(types$1.relational, size)
		  };

		  pp.readToken_eq_excl = function(code) { // '=!'
		    var next = this.input.charCodeAt(this.pos + 1);
		    if (next === 61) { return this.finishOp(types$1.equality, this.input.charCodeAt(this.pos + 2) === 61 ? 3 : 2) }
		    if (code === 61 && next === 62 && this.options.ecmaVersion >= 6) { // '=>'
		      this.pos += 2;
		      return this.finishToken(types$1.arrow)
		    }
		    return this.finishOp(code === 61 ? types$1.eq : types$1.prefix, 1)
		  };

		  pp.readToken_question = function() { // '?'
		    var ecmaVersion = this.options.ecmaVersion;
		    if (ecmaVersion >= 11) {
		      var next = this.input.charCodeAt(this.pos + 1);
		      if (next === 46) {
		        var next2 = this.input.charCodeAt(this.pos + 2);
		        if (next2 < 48 || next2 > 57) { return this.finishOp(types$1.questionDot, 2) }
		      }
		      if (next === 63) {
		        if (ecmaVersion >= 12) {
		          var next2$1 = this.input.charCodeAt(this.pos + 2);
		          if (next2$1 === 61) { return this.finishOp(types$1.assign, 3) }
		        }
		        return this.finishOp(types$1.coalesce, 2)
		      }
		    }
		    return this.finishOp(types$1.question, 1)
		  };

		  pp.readToken_numberSign = function() { // '#'
		    var ecmaVersion = this.options.ecmaVersion;
		    var code = 35; // '#'
		    if (ecmaVersion >= 13) {
		      ++this.pos;
		      code = this.fullCharCodeAtPos();
		      if (isIdentifierStart(code, true) || code === 92 /* '\' */) {
		        return this.finishToken(types$1.privateId, this.readWord1())
		      }
		    }

		    this.raise(this.pos, "Unexpected character '" + codePointToString(code) + "'");
		  };

		  pp.getTokenFromCode = function(code) {
		    switch (code) {
		    // The interpretation of a dot depends on whether it is followed
		    // by a digit or another two dots.
		    case 46: // '.'
		      return this.readToken_dot()

		    // Punctuation tokens.
		    case 40: ++this.pos; return this.finishToken(types$1.parenL)
		    case 41: ++this.pos; return this.finishToken(types$1.parenR)
		    case 59: ++this.pos; return this.finishToken(types$1.semi)
		    case 44: ++this.pos; return this.finishToken(types$1.comma)
		    case 91: ++this.pos; return this.finishToken(types$1.bracketL)
		    case 93: ++this.pos; return this.finishToken(types$1.bracketR)
		    case 123: ++this.pos; return this.finishToken(types$1.braceL)
		    case 125: ++this.pos; return this.finishToken(types$1.braceR)
		    case 58: ++this.pos; return this.finishToken(types$1.colon)

		    case 96: // '`'
		      if (this.options.ecmaVersion < 6) { break }
		      ++this.pos;
		      return this.finishToken(types$1.backQuote)

		    case 48: // '0'
		      var next = this.input.charCodeAt(this.pos + 1);
		      if (next === 120 || next === 88) { return this.readRadixNumber(16) } // '0x', '0X' - hex number
		      if (this.options.ecmaVersion >= 6) {
		        if (next === 111 || next === 79) { return this.readRadixNumber(8) } // '0o', '0O' - octal number
		        if (next === 98 || next === 66) { return this.readRadixNumber(2) } // '0b', '0B' - binary number
		      }

		    // Anything else beginning with a digit is an integer, octal
		    // number, or float.
		    case 49: case 50: case 51: case 52: case 53: case 54: case 55: case 56: case 57: // 1-9
		      return this.readNumber(false)

		    // Quotes produce strings.
		    case 34: case 39: // '"', "'"
		      return this.readString(code)

		    // Operators are parsed inline in tiny state machines. '=' (61) is
		    // often referred to. `finishOp` simply skips the amount of
		    // characters it is given as second argument, and returns a token
		    // of the type given by its first argument.
		    case 47: // '/'
		      return this.readToken_slash()

		    case 37: case 42: // '%*'
		      return this.readToken_mult_modulo_exp(code)

		    case 124: case 38: // '|&'
		      return this.readToken_pipe_amp(code)

		    case 94: // '^'
		      return this.readToken_caret()

		    case 43: case 45: // '+-'
		      return this.readToken_plus_min(code)

		    case 60: case 62: // '<>'
		      return this.readToken_lt_gt(code)

		    case 61: case 33: // '=!'
		      return this.readToken_eq_excl(code)

		    case 63: // '?'
		      return this.readToken_question()

		    case 126: // '~'
		      return this.finishOp(types$1.prefix, 1)

		    case 35: // '#'
		      return this.readToken_numberSign()
		    }

		    this.raise(this.pos, "Unexpected character '" + codePointToString(code) + "'");
		  };

		  pp.finishOp = function(type, size) {
		    var str = this.input.slice(this.pos, this.pos + size);
		    this.pos += size;
		    return this.finishToken(type, str)
		  };

		  pp.readRegexp = function() {
		    var escaped, inClass, start = this.pos;
		    for (;;) {
		      if (this.pos >= this.input.length) { this.raise(start, "Unterminated regular expression"); }
		      var ch = this.input.charAt(this.pos);
		      if (lineBreak.test(ch)) { this.raise(start, "Unterminated regular expression"); }
		      if (!escaped) {
		        if (ch === "[") { inClass = true; }
		        else if (ch === "]" && inClass) { inClass = false; }
		        else if (ch === "/" && !inClass) { break }
		        escaped = ch === "\\";
		      } else { escaped = false; }
		      ++this.pos;
		    }
		    var pattern = this.input.slice(start, this.pos);
		    ++this.pos;
		    var flagsStart = this.pos;
		    var flags = this.readWord1();
		    if (this.containsEsc) { this.unexpected(flagsStart); }

		    // Validate pattern
		    var state = this.regexpState || (this.regexpState = new RegExpValidationState(this));
		    state.reset(start, pattern, flags);
		    this.validateRegExpFlags(state);
		    this.validateRegExpPattern(state);

		    // Create Literal#value property value.
		    var value = null;
		    try {
		      value = new RegExp(pattern, flags);
		    } catch (e) {
		      // ESTree requires null if it failed to instantiate RegExp object.
		      // https://github.com/estree/estree/blob/a27003adf4fd7bfad44de9cef372a2eacd527b1c/es5.md#regexpliteral
		    }

		    return this.finishToken(types$1.regexp, {pattern: pattern, flags: flags, value: value})
		  };

		  // Read an integer in the given radix. Return null if zero digits
		  // were read, the integer value otherwise. When `len` is given, this
		  // will return `null` unless the integer has exactly `len` digits.

		  pp.readInt = function(radix, len, maybeLegacyOctalNumericLiteral) {
		    // `len` is used for character escape sequences. In that case, disallow separators.
		    var allowSeparators = this.options.ecmaVersion >= 12 && len === undefined;

		    // `maybeLegacyOctalNumericLiteral` is true if it doesn't have prefix (0x,0o,0b)
		    // and isn't fraction part nor exponent part. In that case, if the first digit
		    // is zero then disallow separators.
		    var isLegacyOctalNumericLiteral = maybeLegacyOctalNumericLiteral && this.input.charCodeAt(this.pos) === 48;

		    var start = this.pos, total = 0, lastCode = 0;
		    for (var i = 0, e = len == null ? Infinity : len; i < e; ++i, ++this.pos) {
		      var code = this.input.charCodeAt(this.pos), val = (void 0);

		      if (allowSeparators && code === 95) {
		        if (isLegacyOctalNumericLiteral) { this.raiseRecoverable(this.pos, "Numeric separator is not allowed in legacy octal numeric literals"); }
		        if (lastCode === 95) { this.raiseRecoverable(this.pos, "Numeric separator must be exactly one underscore"); }
		        if (i === 0) { this.raiseRecoverable(this.pos, "Numeric separator is not allowed at the first of digits"); }
		        lastCode = code;
		        continue
		      }

		      if (code >= 97) { val = code - 97 + 10; } // a
		      else if (code >= 65) { val = code - 65 + 10; } // A
		      else if (code >= 48 && code <= 57) { val = code - 48; } // 0-9
		      else { val = Infinity; }
		      if (val >= radix) { break }
		      lastCode = code;
		      total = total * radix + val;
		    }

		    if (allowSeparators && lastCode === 95) { this.raiseRecoverable(this.pos - 1, "Numeric separator is not allowed at the last of digits"); }
		    if (this.pos === start || len != null && this.pos - start !== len) { return null }

		    return total
		  };

		  function stringToNumber(str, isLegacyOctalNumericLiteral) {
		    if (isLegacyOctalNumericLiteral) {
		      return parseInt(str, 8)
		    }

		    // `parseFloat(value)` stops parsing at the first numeric separator then returns a wrong value.
		    return parseFloat(str.replace(/_/g, ""))
		  }

		  function stringToBigInt(str) {
		    if (typeof BigInt !== "function") {
		      return null
		    }

		    // `BigInt(value)` throws syntax error if the string contains numeric separators.
		    return BigInt(str.replace(/_/g, ""))
		  }

		  pp.readRadixNumber = function(radix) {
		    var start = this.pos;
		    this.pos += 2; // 0x
		    var val = this.readInt(radix);
		    if (val == null) { this.raise(this.start + 2, "Expected number in radix " + radix); }
		    if (this.options.ecmaVersion >= 11 && this.input.charCodeAt(this.pos) === 110) {
		      val = stringToBigInt(this.input.slice(start, this.pos));
		      ++this.pos;
		    } else if (isIdentifierStart(this.fullCharCodeAtPos())) { this.raise(this.pos, "Identifier directly after number"); }
		    return this.finishToken(types$1.num, val)
		  };

		  // Read an integer, octal integer, or floating-point number.

		  pp.readNumber = function(startsWithDot) {
		    var start = this.pos;
		    if (!startsWithDot && this.readInt(10, undefined, true) === null) { this.raise(start, "Invalid number"); }
		    var octal = this.pos - start >= 2 && this.input.charCodeAt(start) === 48;
		    if (octal && this.strict) { this.raise(start, "Invalid number"); }
		    var next = this.input.charCodeAt(this.pos);
		    if (!octal && !startsWithDot && this.options.ecmaVersion >= 11 && next === 110) {
		      var val$1 = stringToBigInt(this.input.slice(start, this.pos));
		      ++this.pos;
		      if (isIdentifierStart(this.fullCharCodeAtPos())) { this.raise(this.pos, "Identifier directly after number"); }
		      return this.finishToken(types$1.num, val$1)
		    }
		    if (octal && /[89]/.test(this.input.slice(start, this.pos))) { octal = false; }
		    if (next === 46 && !octal) { // '.'
		      ++this.pos;
		      this.readInt(10);
		      next = this.input.charCodeAt(this.pos);
		    }
		    if ((next === 69 || next === 101) && !octal) { // 'eE'
		      next = this.input.charCodeAt(++this.pos);
		      if (next === 43 || next === 45) { ++this.pos; } // '+-'
		      if (this.readInt(10) === null) { this.raise(start, "Invalid number"); }
		    }
		    if (isIdentifierStart(this.fullCharCodeAtPos())) { this.raise(this.pos, "Identifier directly after number"); }

		    var val = stringToNumber(this.input.slice(start, this.pos), octal);
		    return this.finishToken(types$1.num, val)
		  };

		  // Read a string value, interpreting backslash-escapes.

		  pp.readCodePoint = function() {
		    var ch = this.input.charCodeAt(this.pos), code;

		    if (ch === 123) { // '{'
		      if (this.options.ecmaVersion < 6) { this.unexpected(); }
		      var codePos = ++this.pos;
		      code = this.readHexChar(this.input.indexOf("}", this.pos) - this.pos);
		      ++this.pos;
		      if (code > 0x10FFFF) { this.invalidStringToken(codePos, "Code point out of bounds"); }
		    } else {
		      code = this.readHexChar(4);
		    }
		    return code
		  };

		  pp.readString = function(quote) {
		    var out = "", chunkStart = ++this.pos;
		    for (;;) {
		      if (this.pos >= this.input.length) { this.raise(this.start, "Unterminated string constant"); }
		      var ch = this.input.charCodeAt(this.pos);
		      if (ch === quote) { break }
		      if (ch === 92) { // '\'
		        out += this.input.slice(chunkStart, this.pos);
		        out += this.readEscapedChar(false);
		        chunkStart = this.pos;
		      } else if (ch === 0x2028 || ch === 0x2029) {
		        if (this.options.ecmaVersion < 10) { this.raise(this.start, "Unterminated string constant"); }
		        ++this.pos;
		        if (this.options.locations) {
		          this.curLine++;
		          this.lineStart = this.pos;
		        }
		      } else {
		        if (isNewLine(ch)) { this.raise(this.start, "Unterminated string constant"); }
		        ++this.pos;
		      }
		    }
		    out += this.input.slice(chunkStart, this.pos++);
		    return this.finishToken(types$1.string, out)
		  };

		  // Reads template string tokens.

		  var INVALID_TEMPLATE_ESCAPE_ERROR = {};

		  pp.tryReadTemplateToken = function() {
		    this.inTemplateElement = true;
		    try {
		      this.readTmplToken();
		    } catch (err) {
		      if (err === INVALID_TEMPLATE_ESCAPE_ERROR) {
		        this.readInvalidTemplateToken();
		      } else {
		        throw err
		      }
		    }

		    this.inTemplateElement = false;
		  };

		  pp.invalidStringToken = function(position, message) {
		    if (this.inTemplateElement && this.options.ecmaVersion >= 9) {
		      throw INVALID_TEMPLATE_ESCAPE_ERROR
		    } else {
		      this.raise(position, message);
		    }
		  };

		  pp.readTmplToken = function() {
		    var out = "", chunkStart = this.pos;
		    for (;;) {
		      if (this.pos >= this.input.length) { this.raise(this.start, "Unterminated template"); }
		      var ch = this.input.charCodeAt(this.pos);
		      if (ch === 96 || ch === 36 && this.input.charCodeAt(this.pos + 1) === 123) { // '`', '${'
		        if (this.pos === this.start && (this.type === types$1.template || this.type === types$1.invalidTemplate)) {
		          if (ch === 36) {
		            this.pos += 2;
		            return this.finishToken(types$1.dollarBraceL)
		          } else {
		            ++this.pos;
		            return this.finishToken(types$1.backQuote)
		          }
		        }
		        out += this.input.slice(chunkStart, this.pos);
		        return this.finishToken(types$1.template, out)
		      }
		      if (ch === 92) { // '\'
		        out += this.input.slice(chunkStart, this.pos);
		        out += this.readEscapedChar(true);
		        chunkStart = this.pos;
		      } else if (isNewLine(ch)) {
		        out += this.input.slice(chunkStart, this.pos);
		        ++this.pos;
		        switch (ch) {
		        case 13:
		          if (this.input.charCodeAt(this.pos) === 10) { ++this.pos; }
		        case 10:
		          out += "\n";
		          break
		        default:
		          out += String.fromCharCode(ch);
		          break
		        }
		        if (this.options.locations) {
		          ++this.curLine;
		          this.lineStart = this.pos;
		        }
		        chunkStart = this.pos;
		      } else {
		        ++this.pos;
		      }
		    }
		  };

		  // Reads a template token to search for the end, without validating any escape sequences
		  pp.readInvalidTemplateToken = function() {
		    for (; this.pos < this.input.length; this.pos++) {
		      switch (this.input[this.pos]) {
		      case "\\":
		        ++this.pos;
		        break

		      case "$":
		        if (this.input[this.pos + 1] !== "{") {
		          break
		        }

		      // falls through
		      case "`":
		        return this.finishToken(types$1.invalidTemplate, this.input.slice(this.start, this.pos))

		      // no default
		      }
		    }
		    this.raise(this.start, "Unterminated template");
		  };

		  // Used to read escaped characters

		  pp.readEscapedChar = function(inTemplate) {
		    var ch = this.input.charCodeAt(++this.pos);
		    ++this.pos;
		    switch (ch) {
		    case 110: return "\n" // 'n' -> '\n'
		    case 114: return "\r" // 'r' -> '\r'
		    case 120: return String.fromCharCode(this.readHexChar(2)) // 'x'
		    case 117: return codePointToString(this.readCodePoint()) // 'u'
		    case 116: return "\t" // 't' -> '\t'
		    case 98: return "\b" // 'b' -> '\b'
		    case 118: return "\u000b" // 'v' -> '\u000b'
		    case 102: return "\f" // 'f' -> '\f'
		    case 13: if (this.input.charCodeAt(this.pos) === 10) { ++this.pos; } // '\r\n'
		    case 10: // ' \n'
		      if (this.options.locations) { this.lineStart = this.pos; ++this.curLine; }
		      return ""
		    case 56:
		    case 57:
		      if (this.strict) {
		        this.invalidStringToken(
		          this.pos - 1,
		          "Invalid escape sequence"
		        );
		      }
		      if (inTemplate) {
		        var codePos = this.pos - 1;

		        this.invalidStringToken(
		          codePos,
		          "Invalid escape sequence in template string"
		        );
		      }
		    default:
		      if (ch >= 48 && ch <= 55) {
		        var octalStr = this.input.substr(this.pos - 1, 3).match(/^[0-7]+/)[0];
		        var octal = parseInt(octalStr, 8);
		        if (octal > 255) {
		          octalStr = octalStr.slice(0, -1);
		          octal = parseInt(octalStr, 8);
		        }
		        this.pos += octalStr.length - 1;
		        ch = this.input.charCodeAt(this.pos);
		        if ((octalStr !== "0" || ch === 56 || ch === 57) && (this.strict || inTemplate)) {
		          this.invalidStringToken(
		            this.pos - 1 - octalStr.length,
		            inTemplate
		              ? "Octal literal in template string"
		              : "Octal literal in strict mode"
		          );
		        }
		        return String.fromCharCode(octal)
		      }
		      if (isNewLine(ch)) {
		        // Unicode new line characters after \ get removed from output in both
		        // template literals and strings
		        return ""
		      }
		      return String.fromCharCode(ch)
		    }
		  };

		  // Used to read character escape sequences ('\x', '\u', '\U').

		  pp.readHexChar = function(len) {
		    var codePos = this.pos;
		    var n = this.readInt(16, len);
		    if (n === null) { this.invalidStringToken(codePos, "Bad character escape sequence"); }
		    return n
		  };

		  // Read an identifier, and return it as a string. Sets `this.containsEsc`
		  // to whether the word contained a '\u' escape.
		  //
		  // Incrementally adds only escaped chars, adding other chunks as-is
		  // as a micro-optimization.

		  pp.readWord1 = function() {
		    this.containsEsc = false;
		    var word = "", first = true, chunkStart = this.pos;
		    var astral = this.options.ecmaVersion >= 6;
		    while (this.pos < this.input.length) {
		      var ch = this.fullCharCodeAtPos();
		      if (isIdentifierChar(ch, astral)) {
		        this.pos += ch <= 0xffff ? 1 : 2;
		      } else if (ch === 92) { // "\"
		        this.containsEsc = true;
		        word += this.input.slice(chunkStart, this.pos);
		        var escStart = this.pos;
		        if (this.input.charCodeAt(++this.pos) !== 117) // "u"
		          { this.invalidStringToken(this.pos, "Expecting Unicode escape sequence \\uXXXX"); }
		        ++this.pos;
		        var esc = this.readCodePoint();
		        if (!(first ? isIdentifierStart : isIdentifierChar)(esc, astral))
		          { this.invalidStringToken(escStart, "Invalid Unicode escape"); }
		        word += codePointToString(esc);
		        chunkStart = this.pos;
		      } else {
		        break
		      }
		      first = false;
		    }
		    return word + this.input.slice(chunkStart, this.pos)
		  };

		  // Read an identifier or keyword token. Will check for reserved
		  // words when necessary.

		  pp.readWord = function() {
		    var word = this.readWord1();
		    var type = types$1.name;
		    if (this.keywords.test(word)) {
		      type = keywords[word];
		    }
		    return this.finishToken(type, word)
		  };

		  // Acorn is a tiny, fast JavaScript parser written in JavaScript.
		  //
		  // Acorn was written by Marijn Haverbeke, Ingvar Stepanyan, and
		  // various contributors and released under an MIT license.
		  //
		  // Git repositories for Acorn are available at
		  //
		  //     http://marijnhaverbeke.nl/git/acorn
		  //     https://github.com/acornjs/acorn.git
		  //
		  // Please use the [github bug tracker][ghbt] to report issues.
		  //
		  // [ghbt]: https://github.com/acornjs/acorn/issues
		  //
		  // [walk]: util/walk.js


		  var version = "8.11.3";

		  Parser.acorn = {
		    Parser: Parser,
		    version: version,
		    defaultOptions: defaultOptions,
		    Position: Position,
		    SourceLocation: SourceLocation,
		    getLineInfo: getLineInfo,
		    Node: Node,
		    TokenType: TokenType,
		    tokTypes: types$1,
		    keywordTypes: keywords,
		    TokContext: TokContext,
		    tokContexts: types,
		    isIdentifierChar: isIdentifierChar,
		    isIdentifierStart: isIdentifierStart,
		    Token: Token,
		    isNewLine: isNewLine,
		    lineBreak: lineBreak,
		    lineBreakG: lineBreakG,
		    nonASCIIwhitespace: nonASCIIwhitespace
		  };

		  // The main exported interface (under `self.acorn` when in the
		  // browser) is a `parse` function that takes a code string and returns
		  // an abstract syntax tree as specified by the [ESTree spec][estree].
		  //
		  // [estree]: https://github.com/estree/estree

		  function parse(input, options) {
		    return Parser.parse(input, options)
		  }

		  // This function tries to parse a single expression at a given
		  // offset in a string. Useful for parsing mixed-language formats
		  // that embed JavaScript expressions.

		  function parseExpressionAt(input, pos, options) {
		    return Parser.parseExpressionAt(input, pos, options)
		  }

		  // Acorn is organized as a tokenizer and a recursive-descent parser.
		  // The `tokenizer` export provides an interface to the tokenizer.

		  function tokenizer(input, options) {
		    return Parser.tokenizer(input, options)
		  }

		  exports.Node = Node;
		  exports.Parser = Parser;
		  exports.Position = Position;
		  exports.SourceLocation = SourceLocation;
		  exports.TokContext = TokContext;
		  exports.Token = Token;
		  exports.TokenType = TokenType;
		  exports.defaultOptions = defaultOptions;
		  exports.getLineInfo = getLineInfo;
		  exports.isIdentifierChar = isIdentifierChar;
		  exports.isIdentifierStart = isIdentifierStart;
		  exports.isNewLine = isNewLine;
		  exports.keywordTypes = keywords;
		  exports.lineBreak = lineBreak;
		  exports.lineBreakG = lineBreakG;
		  exports.nonASCIIwhitespace = nonASCIIwhitespace;
		  exports.parse = parse;
		  exports.parseExpressionAt = parseExpressionAt;
		  exports.tokContexts = types;
		  exports.tokTypes = types$1;
		  exports.tokenizer = tokenizer;
		  exports.version = version;

		})); 
	} (acorn, acorn.exports));
	return acorn.exports;
}

bundle_min.exports;

(function (module, exports) {
	(function (global, factory) {
	factory(exports, requireSourceMap$1()) ;
	})(commonjsGlobal, (function (exports, sourceMap) {
	/***********************************************************************

	  A JavaScript tokenizer / parser / beautifier / compressor.
	  https://github.com/mishoo/UglifyJS2

	  -------------------------------- (C) ---------------------------------

	                           Author: Mihai Bazon
	                         <mihai.bazon@gmail.com>
	                       http://mihai.bazon.net/blog

	  Distributed under the BSD license:

	    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

	    Redistribution and use in source and binary forms, with or without
	    modification, are permitted provided that the following conditions
	    are met:

	        * Redistributions of source code must retain the above
	          copyright notice, this list of conditions and the following
	          disclaimer.

	        * Redistributions in binary form must reproduce the above
	          copyright notice, this list of conditions and the following
	          disclaimer in the documentation and/or other materials
	          provided with the distribution.

	    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
	    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
	    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
	    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
	    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
	    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
	    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
	    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
	    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
	    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
	    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
	    SUCH DAMAGE.

	 ***********************************************************************/

	function characters(str) {
	    return str.split("");
	}

	function member(name, array) {
	    return array.includes(name);
	}

	class DefaultsError extends Error {
	    constructor(msg, defs) {
	        super();

	        this.name = "DefaultsError";
	        this.message = msg;
	        this.defs = defs;
	    }
	}

	function defaults(args, defs, croak) {
	    if (args === true) {
	        args = {};
	    } else if (args != null && typeof args === "object") {
	        args = {...args};
	    }

	    const ret = args || {};

	    if (croak) for (const i in ret) if (HOP(ret, i) && !HOP(defs, i)) {
	        throw new DefaultsError("`" + i + "` is not a supported option", defs);
	    }

	    for (const i in defs) if (HOP(defs, i)) {
	        if (!args || !HOP(args, i)) {
	            ret[i] = defs[i];
	        } else if (i === "ecma") {
	            let ecma = args[i] | 0;
	            if (ecma > 5 && ecma < 2015) ecma += 2009;
	            ret[i] = ecma;
	        } else {
	            ret[i] = (args && HOP(args, i)) ? args[i] : defs[i];
	        }
	    }

	    return ret;
	}

	function noop() {}
	function return_false() { return false; }
	function return_true() { return true; }
	function return_this() { return this; }
	function return_null() { return null; }

	var MAP = (function() {
	    function MAP(a, tw, allow_splicing = true) {
	        const new_a = [];

	        for (let i = 0; i < a.length; ++i) {
	            let item = a[i];
	            let ret = item.transform(tw, allow_splicing);

	            if (ret instanceof AST_Node) {
	                new_a.push(ret);
	            } else if (ret instanceof Splice) {
	                new_a.push(...ret.v);
	            }
	        }

	        return new_a;
	    }

	    MAP.splice = function(val) { return new Splice(val); };
	    MAP.skip = {};
	    function Splice(val) { this.v = val; }
	    return MAP;
	})();

	function make_node(ctor, orig, props) {
	    if (!props) props = {};
	    if (orig) {
	        if (!props.start) props.start = orig.start;
	        if (!props.end) props.end = orig.end;
	    }
	    return new ctor(props);
	}

	function push_uniq(array, el) {
	    if (!array.includes(el))
	        array.push(el);
	}

	function string_template(text, props) {
	    return text.replace(/{(.+?)}/g, function(str, p) {
	        return props && props[p];
	    });
	}

	function remove(array, el) {
	    for (var i = array.length; --i >= 0;) {
	        if (array[i] === el) array.splice(i, 1);
	    }
	}

	function mergeSort(array, cmp) {
	    if (array.length < 2) return array.slice();
	    function merge(a, b) {
	        var r = [], ai = 0, bi = 0, i = 0;
	        while (ai < a.length && bi < b.length) {
	            cmp(a[ai], b[bi]) <= 0
	                ? r[i++] = a[ai++]
	                : r[i++] = b[bi++];
	        }
	        if (ai < a.length) r.push.apply(r, a.slice(ai));
	        if (bi < b.length) r.push.apply(r, b.slice(bi));
	        return r;
	    }
	    function _ms(a) {
	        if (a.length <= 1)
	            return a;
	        var m = Math.floor(a.length / 2), left = a.slice(0, m), right = a.slice(m);
	        left = _ms(left);
	        right = _ms(right);
	        return merge(left, right);
	    }
	    return _ms(array);
	}

	function makePredicate(words) {
	    if (!Array.isArray(words)) words = words.split(" ");

	    return new Set(words.sort());
	}

	function map_add(map, key, value) {
	    if (map.has(key)) {
	        map.get(key).push(value);
	    } else {
	        map.set(key, [ value ]);
	    }
	}

	function map_from_object(obj) {
	    var map = new Map();
	    for (var key in obj) {
	        if (HOP(obj, key) && key.charAt(0) === "$") {
	            map.set(key.substr(1), obj[key]);
	        }
	    }
	    return map;
	}

	function map_to_object(map) {
	    var obj = Object.create(null);
	    map.forEach(function (value, key) {
	        obj["$" + key] = value;
	    });
	    return obj;
	}

	function HOP(obj, prop) {
	    return Object.prototype.hasOwnProperty.call(obj, prop);
	}

	function keep_name(keep_setting, name) {
	    return keep_setting === true
	        || (keep_setting instanceof RegExp && keep_setting.test(name));
	}

	var lineTerminatorEscape = {
	    "\0": "0",
	    "\n": "n",
	    "\r": "r",
	    "\u2028": "u2028",
	    "\u2029": "u2029",
	};
	function regexp_source_fix(source) {
	    // V8 does not escape line terminators in regexp patterns in node 12
	    // We'll also remove literal \0
	    return source.replace(/[\0\n\r\u2028\u2029]/g, function (match, offset) {
	        var escaped = source[offset - 1] == "\\"
	            && (source[offset - 2] != "\\"
	            || /(?:^|[^\\])(?:\\{2})*$/.test(source.slice(0, offset - 1)));
	        return (escaped ? "" : "\\") + lineTerminatorEscape[match];
	    });
	}

	// Subset of regexps that is not going to cause regexp based DDOS
	// https://owasp.org/www-community/attacks/Regular_expression_Denial_of_Service_-_ReDoS
	const re_safe_regexp = /^[\\/|\0\s\w^$.[\]()]*$/;

	/** Check if the regexp is safe for Terser to create without risking a RegExp DOS */
	const regexp_is_safe = (source) => re_safe_regexp.test(source);

	const all_flags = "dgimsuyv";
	function sort_regexp_flags(flags) {
	    const existing_flags = new Set(flags.split(""));
	    let out = "";
	    for (const flag of all_flags) {
	        if (existing_flags.has(flag)) {
	            out += flag;
	            existing_flags.delete(flag);
	        }
	    }
	    if (existing_flags.size) {
	        // Flags Terser doesn't know about
	        existing_flags.forEach(flag => { out += flag; });
	    }
	    return out;
	}

	function has_annotation(node, annotation) {
	    return node._annotations & annotation;
	}

	function set_annotation(node, annotation) {
	    node._annotations |= annotation;
	}

	function clear_annotation(node, annotation) {
	    node._annotations &= ~annotation;
	}

	/***********************************************************************

	  A JavaScript tokenizer / parser / beautifier / compressor.
	  https://github.com/mishoo/UglifyJS2

	  -------------------------------- (C) ---------------------------------

	                           Author: Mihai Bazon
	                         <mihai.bazon@gmail.com>
	                       http://mihai.bazon.net/blog

	  Distributed under the BSD license:

	    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>
	    Parser based on parse-js (http://marijn.haverbeke.nl/parse-js/).

	    Redistribution and use in source and binary forms, with or without
	    modification, are permitted provided that the following conditions
	    are met:

	        * Redistributions of source code must retain the above
	          copyright notice, this list of conditions and the following
	          disclaimer.

	        * Redistributions in binary form must reproduce the above
	          copyright notice, this list of conditions and the following
	          disclaimer in the documentation and/or other materials
	          provided with the distribution.

	    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
	    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
	    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
	    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
	    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
	    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
	    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
	    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
	    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
	    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
	    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
	    SUCH DAMAGE.

	 ***********************************************************************/

	var LATEST_RAW = "";  // Only used for numbers and template strings
	var TEMPLATE_RAWS = new Map();  // Raw template strings

	var KEYWORDS = "break case catch class const continue debugger default delete do else export extends finally for function if in instanceof let new return switch throw try typeof var void while with";
	var KEYWORDS_ATOM = "false null true";
	var RESERVED_WORDS = "enum import super this " + KEYWORDS_ATOM + " " + KEYWORDS;
	var ALL_RESERVED_WORDS = "implements interface package private protected public static " + RESERVED_WORDS;
	var KEYWORDS_BEFORE_EXPRESSION = "return new delete throw else case yield await";

	KEYWORDS = makePredicate(KEYWORDS);
	RESERVED_WORDS = makePredicate(RESERVED_WORDS);
	KEYWORDS_BEFORE_EXPRESSION = makePredicate(KEYWORDS_BEFORE_EXPRESSION);
	KEYWORDS_ATOM = makePredicate(KEYWORDS_ATOM);
	ALL_RESERVED_WORDS = makePredicate(ALL_RESERVED_WORDS);

	var OPERATOR_CHARS = makePredicate(characters("+-*&%=<>!?|~^"));

	var RE_NUM_LITERAL = /[0-9a-f]/i;
	var RE_HEX_NUMBER = /^0x[0-9a-f]+$/i;
	var RE_OCT_NUMBER = /^0[0-7]+$/;
	var RE_ES6_OCT_NUMBER = /^0o[0-7]+$/i;
	var RE_BIN_NUMBER = /^0b[01]+$/i;
	var RE_DEC_NUMBER = /^\d*\.?\d*(?:e[+-]?\d*(?:\d\.?|\.?\d)\d*)?$/i;
	var RE_BIG_INT = /^(0[xob])?[0-9a-f]+n$/i;

	var OPERATORS = makePredicate([
	    "in",
	    "instanceof",
	    "typeof",
	    "new",
	    "void",
	    "delete",
	    "++",
	    "--",
	    "+",
	    "-",
	    "!",
	    "~",
	    "&",
	    "|",
	    "^",
	    "*",
	    "**",
	    "/",
	    "%",
	    ">>",
	    "<<",
	    ">>>",
	    "<",
	    ">",
	    "<=",
	    ">=",
	    "==",
	    "===",
	    "!=",
	    "!==",
	    "?",
	    "=",
	    "+=",
	    "-=",
	    "||=",
	    "&&=",
	    "??=",
	    "/=",
	    "*=",
	    "**=",
	    "%=",
	    ">>=",
	    "<<=",
	    ">>>=",
	    "|=",
	    "^=",
	    "&=",
	    "&&",
	    "??",
	    "||",
	]);

	var WHITESPACE_CHARS = makePredicate(characters(" \u00a0\n\r\t\f\u000b\u200b\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200a\u2028\u2029\u202f\u205f\u3000\uFEFF"));

	var NEWLINE_CHARS = makePredicate(characters("\n\r\u2028\u2029"));

	var PUNC_AFTER_EXPRESSION = makePredicate(characters(";]),:"));

	var PUNC_BEFORE_EXPRESSION = makePredicate(characters("[{(,;:"));

	var PUNC_CHARS = makePredicate(characters("[]{}(),;:"));

	/* -----[ Tokenizer ]----- */

	// surrogate safe regexps adapted from https://github.com/mathiasbynens/unicode-8.0.0/tree/89b412d8a71ecca9ed593d9e9fa073ab64acfebe/Binary_Property
	var UNICODE = {
	    ID_Start: /[$A-Z_a-z\xAA\xB5\xBA\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0561-\u0587\u05D0-\u05EA\u05F0-\u05F2\u0620-\u064A\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07CA-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u08A0-\u08B4\u0904-\u0939\u093D\u0950\u0958-\u0961\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09F0\u09F1\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B71\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CF1\u0CF2\u0D05-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D5F-\u0D61\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E81\u0E82\u0E84\u0E87\u0E88\u0E8A\u0E8D\u0E94-\u0E97\u0E99-\u0E9F\u0EA1-\u0EA3\u0EA5\u0EA7\u0EAA\u0EAB\u0EAD-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0EDC-\u0EDF\u0F00\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u1820-\u1877\u1880-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1950-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u1A00-\u1A16\u1A20-\u1A54\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B83-\u1BA0\u1BAE\u1BAF\u1BBA-\u1BE5\u1C00-\u1C23\u1C4D-\u1C4F\u1C5A-\u1C7D\u1CE9-\u1CEC\u1CEE-\u1CF1\u1CF5\u1CF6\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2071\u207F\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2118-\u211D\u2124\u2126\u2128\u212A-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2160-\u2188\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309B-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312D\u3131-\u318E\u31A0-\u31BA\u31F0-\u31FF\u3400-\u4DB5\u4E00-\u9FD5\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA61F\uA62A\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7AD\uA7B0-\uA7B7\uA7F7-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA840-\uA873\uA882-\uA8B3\uA8F2-\uA8F7\uA8FB\uA8FD\uA90A-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF\uA9E0-\uA9E4\uA9E6-\uA9EF\uA9FA-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB65\uAB70-\uABE2\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD40-\uDD74\uDE80-\uDE9C\uDEA0-\uDED0\uDF00-\uDF1F\uDF30-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC60-\uDC76\uDC80-\uDC9E\uDCE0-\uDCF2\uDCF4\uDCF5\uDD00-\uDD15\uDD20-\uDD39\uDD80-\uDDB7\uDDBE\uDDBF\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE33\uDE60-\uDE7C\uDE80-\uDE9C\uDEC0-\uDEC7\uDEC9-\uDEE4\uDF00-\uDF35\uDF40-\uDF55\uDF60-\uDF72\uDF80-\uDF91]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2]|\uD804[\uDC03-\uDC37\uDC83-\uDCAF\uDCD0-\uDCE8\uDD03-\uDD26\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDDA\uDDDC\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE80-\uDEAA\uDF00-\uDF19]|\uD806[\uDCA0-\uDCDF\uDCFF\uDEC0-\uDEF8]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDF00-\uDF44\uDF50\uDF93-\uDF9F]|\uD82C[\uDC00\uDC01]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB]|\uD83A[\uDC00-\uDCC4]|\uD83B[\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD869[\uDC00-\uDED6\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1]|\uD87E[\uDC00-\uDE1D]/,
	    ID_Continue: /(?:[$0-9A-Z_a-z\xAA\xB5\xB7\xBA\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0300-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u0483-\u0487\u048A-\u052F\u0531-\u0556\u0559\u0561-\u0587\u0591-\u05BD\u05BF\u05C1\u05C2\u05C4\u05C5\u05C7\u05D0-\u05EA\u05F0-\u05F2\u0610-\u061A\u0620-\u0669\u066E-\u06D3\u06D5-\u06DC\u06DF-\u06E8\u06EA-\u06FC\u06FF\u0710-\u074A\u074D-\u07B1\u07C0-\u07F5\u07FA\u0800-\u082D\u0840-\u085B\u08A0-\u08B4\u08E3-\u0963\u0966-\u096F\u0971-\u0983\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BC-\u09C4\u09C7\u09C8\u09CB-\u09CE\u09D7\u09DC\u09DD\u09DF-\u09E3\u09E6-\u09F1\u0A01-\u0A03\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A3C\u0A3E-\u0A42\u0A47\u0A48\u0A4B-\u0A4D\u0A51\u0A59-\u0A5C\u0A5E\u0A66-\u0A75\u0A81-\u0A83\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABC-\u0AC5\u0AC7-\u0AC9\u0ACB-\u0ACD\u0AD0\u0AE0-\u0AE3\u0AE6-\u0AEF\u0AF9\u0B01-\u0B03\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3C-\u0B44\u0B47\u0B48\u0B4B-\u0B4D\u0B56\u0B57\u0B5C\u0B5D\u0B5F-\u0B63\u0B66-\u0B6F\u0B71\u0B82\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BBE-\u0BC2\u0BC6-\u0BC8\u0BCA-\u0BCD\u0BD0\u0BD7\u0BE6-\u0BEF\u0C00-\u0C03\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D-\u0C44\u0C46-\u0C48\u0C4A-\u0C4D\u0C55\u0C56\u0C58-\u0C5A\u0C60-\u0C63\u0C66-\u0C6F\u0C81-\u0C83\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBC-\u0CC4\u0CC6-\u0CC8\u0CCA-\u0CCD\u0CD5\u0CD6\u0CDE\u0CE0-\u0CE3\u0CE6-\u0CEF\u0CF1\u0CF2\u0D01-\u0D03\u0D05-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D-\u0D44\u0D46-\u0D48\u0D4A-\u0D4E\u0D57\u0D5F-\u0D63\u0D66-\u0D6F\u0D7A-\u0D7F\u0D82\u0D83\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DCA\u0DCF-\u0DD4\u0DD6\u0DD8-\u0DDF\u0DE6-\u0DEF\u0DF2\u0DF3\u0E01-\u0E3A\u0E40-\u0E4E\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E87\u0E88\u0E8A\u0E8D\u0E94-\u0E97\u0E99-\u0E9F\u0EA1-\u0EA3\u0EA5\u0EA7\u0EAA\u0EAB\u0EAD-\u0EB9\u0EBB-\u0EBD\u0EC0-\u0EC4\u0EC6\u0EC8-\u0ECD\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F18\u0F19\u0F20-\u0F29\u0F35\u0F37\u0F39\u0F3E-\u0F47\u0F49-\u0F6C\u0F71-\u0F84\u0F86-\u0F97\u0F99-\u0FBC\u0FC6\u1000-\u1049\u1050-\u109D\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u135D-\u135F\u1369-\u1371\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1714\u1720-\u1734\u1740-\u1753\u1760-\u176C\u176E-\u1770\u1772\u1773\u1780-\u17D3\u17D7\u17DC\u17DD\u17E0-\u17E9\u180B-\u180D\u1810-\u1819\u1820-\u1877\u1880-\u18AA\u18B0-\u18F5\u1900-\u191E\u1920-\u192B\u1930-\u193B\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A1B\u1A20-\u1A5E\u1A60-\u1A7C\u1A7F-\u1A89\u1A90-\u1A99\u1AA7\u1AB0-\u1ABD\u1B00-\u1B4B\u1B50-\u1B59\u1B6B-\u1B73\u1B80-\u1BF3\u1C00-\u1C37\u1C40-\u1C49\u1C4D-\u1C7D\u1CD0-\u1CD2\u1CD4-\u1CF6\u1CF8\u1CF9\u1D00-\u1DF5\u1DFC-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u200C\u200D\u203F\u2040\u2054\u2071\u207F\u2090-\u209C\u20D0-\u20DC\u20E1\u20E5-\u20F0\u2102\u2107\u210A-\u2113\u2115\u2118-\u211D\u2124\u2126\u2128\u212A-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2160-\u2188\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D7F-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2DE0-\u2DFF\u3005-\u3007\u3021-\u302F\u3031-\u3035\u3038-\u303C\u3041-\u3096\u3099-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312D\u3131-\u318E\u31A0-\u31BA\u31F0-\u31FF\u3400-\u4DB5\u4E00-\u9FD5\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66F\uA674-\uA67D\uA67F-\uA6F1\uA717-\uA71F\uA722-\uA788\uA78B-\uA7AD\uA7B0-\uA7B7\uA7F7-\uA827\uA840-\uA873\uA880-\uA8C4\uA8D0-\uA8D9\uA8E0-\uA8F7\uA8FB\uA8FD\uA900-\uA92D\uA930-\uA953\uA960-\uA97C\uA980-\uA9C0\uA9CF-\uA9D9\uA9E0-\uA9FE\uAA00-\uAA36\uAA40-\uAA4D\uAA50-\uAA59\uAA60-\uAA76\uAA7A-\uAAC2\uAADB-\uAADD\uAAE0-\uAAEF\uAAF2-\uAAF6\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB65\uAB70-\uABEA\uABEC\uABED\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE00-\uFE0F\uFE20-\uFE2F\uFE33\uFE34\uFE4D-\uFE4F\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF3F\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD40-\uDD74\uDDFD\uDE80-\uDE9C\uDEA0-\uDED0\uDEE0\uDF00-\uDF1F\uDF30-\uDF4A\uDF50-\uDF7A\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC60-\uDC76\uDC80-\uDC9E\uDCE0-\uDCF2\uDCF4\uDCF5\uDD00-\uDD15\uDD20-\uDD39\uDD80-\uDDB7\uDDBE\uDDBF\uDE00-\uDE03\uDE05\uDE06\uDE0C-\uDE13\uDE15-\uDE17\uDE19-\uDE33\uDE38-\uDE3A\uDE3F\uDE60-\uDE7C\uDE80-\uDE9C\uDEC0-\uDEC7\uDEC9-\uDEE6\uDF00-\uDF35\uDF40-\uDF55\uDF60-\uDF72\uDF80-\uDF91]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2]|\uD804[\uDC00-\uDC46\uDC66-\uDC6F\uDC7F-\uDCBA\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD00-\uDD34\uDD36-\uDD3F\uDD50-\uDD73\uDD76\uDD80-\uDDC4\uDDCA-\uDDCC\uDDD0-\uDDDA\uDDDC\uDE00-\uDE11\uDE13-\uDE37\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEEA\uDEF0-\uDEF9\uDF00-\uDF03\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3C-\uDF44\uDF47\uDF48\uDF4B-\uDF4D\uDF50\uDF57\uDF5D-\uDF63\uDF66-\uDF6C\uDF70-\uDF74]|\uD805[\uDC80-\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDB5\uDDB8-\uDDC0\uDDD8-\uDDDD\uDE00-\uDE40\uDE44\uDE50-\uDE59\uDE80-\uDEB7\uDEC0-\uDEC9\uDF00-\uDF19\uDF1D-\uDF2B\uDF30-\uDF39]|\uD806[\uDCA0-\uDCE9\uDCFF\uDEC0-\uDEF8]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDEF0-\uDEF4\uDF00-\uDF36\uDF40-\uDF43\uDF50-\uDF59\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDF00-\uDF44\uDF50-\uDF7E\uDF8F-\uDF9F]|\uD82C[\uDC00\uDC01]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99\uDC9D\uDC9E]|\uD834[\uDD65-\uDD69\uDD6D-\uDD72\uDD7B-\uDD82\uDD85-\uDD8B\uDDAA-\uDDAD\uDE42-\uDE44]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD836[\uDE00-\uDE36\uDE3B-\uDE6C\uDE75\uDE84\uDE9B-\uDE9F\uDEA1-\uDEAF]|\uD83A[\uDC00-\uDCC4\uDCD0-\uDCD6]|\uD83B[\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD869[\uDC00-\uDED6\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1]|\uD87E[\uDC00-\uDE1D]|\uDB40[\uDD00-\uDDEF])+/,
	};

	function get_full_char(str, pos) {
	    if (is_surrogate_pair_head(str.charCodeAt(pos))) {
	        if (is_surrogate_pair_tail(str.charCodeAt(pos + 1))) {
	            return str.charAt(pos) + str.charAt(pos + 1);
	        }
	    } else if (is_surrogate_pair_tail(str.charCodeAt(pos))) {
	        if (is_surrogate_pair_head(str.charCodeAt(pos - 1))) {
	            return str.charAt(pos - 1) + str.charAt(pos);
	        }
	    }
	    return str.charAt(pos);
	}

	function get_full_char_code(str, pos) {
	    // https://en.wikipedia.org/wiki/Universal_Character_Set_characters#Surrogates
	    if (is_surrogate_pair_head(str.charCodeAt(pos))) {
	        return 0x10000 + (str.charCodeAt(pos) - 0xd800 << 10) + str.charCodeAt(pos + 1) - 0xdc00;
	    }
	    return str.charCodeAt(pos);
	}

	function get_full_char_length(str) {
	    var surrogates = 0;

	    for (var i = 0; i < str.length; i++) {
	        if (is_surrogate_pair_head(str.charCodeAt(i)) && is_surrogate_pair_tail(str.charCodeAt(i + 1))) {
	            surrogates++;
	            i++;
	        }
	    }

	    return str.length - surrogates;
	}

	function from_char_code(code) {
	    // Based on https://github.com/mathiasbynens/String.fromCodePoint/blob/master/fromcodepoint.js
	    if (code > 0xFFFF) {
	        code -= 0x10000;
	        return (String.fromCharCode((code >> 10) + 0xD800) +
	            String.fromCharCode((code % 0x400) + 0xDC00));
	    }
	    return String.fromCharCode(code);
	}

	function is_surrogate_pair_head(code) {
	    return code >= 0xd800 && code <= 0xdbff;
	}

	function is_surrogate_pair_tail(code) {
	    return code >= 0xdc00 && code <= 0xdfff;
	}

	function is_digit(code) {
	    return code >= 48 && code <= 57;
	}

	function is_identifier_start(ch) {
	    return UNICODE.ID_Start.test(ch);
	}

	function is_identifier_char(ch) {
	    return UNICODE.ID_Continue.test(ch);
	}

	const BASIC_IDENT = /^[a-z_$][a-z0-9_$]*$/i;

	function is_basic_identifier_string(str) {
	    return BASIC_IDENT.test(str);
	}

	function is_identifier_string(str, allow_surrogates) {
	    if (BASIC_IDENT.test(str)) {
	        return true;
	    }
	    if (!allow_surrogates && /[\ud800-\udfff]/.test(str)) {
	        return false;
	    }
	    var match = UNICODE.ID_Start.exec(str);
	    if (!match || match.index !== 0) {
	        return false;
	    }

	    str = str.slice(match[0].length);
	    if (!str) {
	        return true;
	    }

	    match = UNICODE.ID_Continue.exec(str);
	    return !!match && match[0].length === str.length;
	}

	function parse_js_number(num, allow_e = true) {
	    if (!allow_e && num.includes("e")) {
	        return NaN;
	    }
	    if (RE_HEX_NUMBER.test(num)) {
	        return parseInt(num.substr(2), 16);
	    } else if (RE_OCT_NUMBER.test(num)) {
	        return parseInt(num.substr(1), 8);
	    } else if (RE_ES6_OCT_NUMBER.test(num)) {
	        return parseInt(num.substr(2), 8);
	    } else if (RE_BIN_NUMBER.test(num)) {
	        return parseInt(num.substr(2), 2);
	    } else if (RE_DEC_NUMBER.test(num)) {
	        return parseFloat(num);
	    } else {
	        var val = parseFloat(num);
	        if (val == num) return val;
	    }
	}

	class JS_Parse_Error extends Error {
	    constructor(message, filename, line, col, pos) {
	        super();

	        this.name = "SyntaxError";
	        this.message = message;
	        this.filename = filename;
	        this.line = line;
	        this.col = col;
	        this.pos = pos;
	    }
	}

	function js_error(message, filename, line, col, pos) {
	    throw new JS_Parse_Error(message, filename, line, col, pos);
	}

	function is_token(token, type, val) {
	    return token.type == type && (val == null || token.value == val);
	}

	var EX_EOF = {};

	function tokenizer($TEXT, filename, html5_comments, shebang) {
	    var S = {
	        text            : $TEXT,
	        filename        : filename,
	        pos             : 0,
	        tokpos          : 0,
	        line            : 1,
	        tokline         : 0,
	        col             : 0,
	        tokcol          : 0,
	        newline_before  : false,
	        regex_allowed   : false,
	        brace_counter   : 0,
	        template_braces : [],
	        comments_before : [],
	        directives      : {},
	        directive_stack : []
	    };

	    function peek() { return get_full_char(S.text, S.pos); }

	    // Used because parsing ?. involves a lookahead for a digit
	    function is_option_chain_op() {
	        const must_be_dot = S.text.charCodeAt(S.pos + 1) === 46;
	        if (!must_be_dot) return false;

	        const cannot_be_digit = S.text.charCodeAt(S.pos + 2);
	        return cannot_be_digit < 48 || cannot_be_digit > 57;
	    }

	    function next(signal_eof, in_string) {
	        var ch = get_full_char(S.text, S.pos++);
	        if (signal_eof && !ch)
	            throw EX_EOF;
	        if (NEWLINE_CHARS.has(ch)) {
	            S.newline_before = S.newline_before || !in_string;
	            ++S.line;
	            S.col = 0;
	            if (ch == "\r" && peek() == "\n") {
	                // treat a \r\n sequence as a single \n
	                ++S.pos;
	                ch = "\n";
	            }
	        } else {
	            if (ch.length > 1) {
	                ++S.pos;
	                ++S.col;
	            }
	            ++S.col;
	        }
	        return ch;
	    }

	    function forward(i) {
	        while (i--) next();
	    }

	    function looking_at(str) {
	        return S.text.substr(S.pos, str.length) == str;
	    }

	    function find_eol() {
	        var text = S.text;
	        for (var i = S.pos, n = S.text.length; i < n; ++i) {
	            var ch = text[i];
	            if (NEWLINE_CHARS.has(ch))
	                return i;
	        }
	        return -1;
	    }

	    function find(what, signal_eof) {
	        var pos = S.text.indexOf(what, S.pos);
	        if (signal_eof && pos == -1) throw EX_EOF;
	        return pos;
	    }

	    function start_token() {
	        S.tokline = S.line;
	        S.tokcol = S.col;
	        S.tokpos = S.pos;
	    }

	    var prev_was_dot = false;
	    var previous_token = null;
	    function token(type, value, is_comment) {
	        S.regex_allowed = ((type == "operator" && !UNARY_POSTFIX.has(value)) ||
	                           (type == "keyword" && KEYWORDS_BEFORE_EXPRESSION.has(value)) ||
	                           (type == "punc" && PUNC_BEFORE_EXPRESSION.has(value))) ||
	                           (type == "arrow");
	        if (type == "punc" && (value == "." || value == "?.")) {
	            prev_was_dot = true;
	        } else if (!is_comment) {
	            prev_was_dot = false;
	        }
	        const line     = S.tokline;
	        const col      = S.tokcol;
	        const pos      = S.tokpos;
	        const nlb      = S.newline_before;
	        const file     = filename;
	        let comments_before = [];
	        let comments_after  = [];

	        if (!is_comment) {
	            comments_before = S.comments_before;
	            comments_after = S.comments_before = [];
	        }
	        S.newline_before = false;
	        const tok = new AST_Token(type, value, line, col, pos, nlb, comments_before, comments_after, file);

	        if (!is_comment) previous_token = tok;
	        return tok;
	    }

	    function skip_whitespace() {
	        while (WHITESPACE_CHARS.has(peek()))
	            next();
	    }

	    function read_while(pred) {
	        var ret = "", ch, i = 0;
	        while ((ch = peek()) && pred(ch, i++))
	            ret += next();
	        return ret;
	    }

	    function parse_error(err) {
	        js_error(err, filename, S.tokline, S.tokcol, S.tokpos);
	    }

	    function read_num(prefix) {
	        var has_e = false, after_e = false, has_x = false, has_dot = prefix == ".", is_big_int = false, numeric_separator = false;
	        var num = read_while(function(ch, i) {
	            if (is_big_int) return false;

	            var code = ch.charCodeAt(0);
	            switch (code) {
	              case 95: // _
	                return (numeric_separator = true);
	              case 98: case 66: // bB
	                return (has_x = true); // Can occur in hex sequence, don't return false yet
	              case 111: case 79: // oO
	              case 120: case 88: // xX
	                return has_x ? false : (has_x = true);
	              case 101: case 69: // eE
	                return has_x ? true : has_e ? false : (has_e = after_e = true);
	              case 45: // -
	                return after_e || (i == 0 && !prefix);
	              case 43: // +
	                return after_e;
	              case (after_e = false, 46): // .
	                return (!has_dot && !has_x && !has_e) ? (has_dot = true) : false;
	            }

	            if (ch === "n") {
	                is_big_int = true;

	                return true;
	            }

	            return RE_NUM_LITERAL.test(ch);
	        });
	        if (prefix) num = prefix + num;

	        LATEST_RAW = num;

	        if (RE_OCT_NUMBER.test(num) && next_token.has_directive("use strict")) {
	            parse_error("Legacy octal literals are not allowed in strict mode");
	        }
	        if (numeric_separator) {
	            if (num.endsWith("_")) {
	                parse_error("Numeric separators are not allowed at the end of numeric literals");
	            } else if (num.includes("__")) {
	                parse_error("Only one underscore is allowed as numeric separator");
	            }
	            num = num.replace(/_/g, "");
	        }
	        if (num.endsWith("n")) {
	            const without_n = num.slice(0, -1);
	            const allow_e = RE_HEX_NUMBER.test(without_n);
	            const valid = parse_js_number(without_n, allow_e);
	            if (!has_dot && RE_BIG_INT.test(num) && !isNaN(valid))
	                return token("big_int", without_n);
	            parse_error("Invalid or unexpected token");
	        }
	        var valid = parse_js_number(num);
	        if (!isNaN(valid)) {
	            return token("num", valid);
	        } else {
	            parse_error("Invalid syntax: " + num);
	        }
	    }

	    function is_octal(ch) {
	        return ch >= "0" && ch <= "7";
	    }

	    function read_escaped_char(in_string, strict_hex, template_string) {
	        var ch = next(true, in_string);
	        switch (ch.charCodeAt(0)) {
	          case 110 : return "\n";
	          case 114 : return "\r";
	          case 116 : return "\t";
	          case 98  : return "\b";
	          case 118 : return "\u000b"; // \v
	          case 102 : return "\f";
	          case 120 : return String.fromCharCode(hex_bytes(2, strict_hex)); // \x
	          case 117 : // \u
	            if (peek() == "{") {
	                next(true);
	                if (peek() === "}")
	                    parse_error("Expecting hex-character between {}");
	                while (peek() == "0") next(true); // No significance
	                var result, length = find("}", true) - S.pos;
	                // Avoid 32 bit integer overflow (1 << 32 === 1)
	                // We know first character isn't 0 and thus out of range anyway
	                if (length > 6 || (result = hex_bytes(length, strict_hex)) > 0x10FFFF) {
	                    parse_error("Unicode reference out of bounds");
	                }
	                next(true);
	                return from_char_code(result);
	            }
	            return String.fromCharCode(hex_bytes(4, strict_hex));
	          case 10  : return ""; // newline
	          case 13  :            // \r
	            if (peek() == "\n") { // DOS newline
	                next(true, in_string);
	                return "";
	            }
	        }
	        if (is_octal(ch)) {
	            if (template_string && strict_hex) {
	                const represents_null_character = ch === "0" && !is_octal(peek());
	                if (!represents_null_character) {
	                    parse_error("Octal escape sequences are not allowed in template strings");
	                }
	            }
	            return read_octal_escape_sequence(ch, strict_hex);
	        }
	        return ch;
	    }

	    function read_octal_escape_sequence(ch, strict_octal) {
	        // Read
	        var p = peek();
	        if (p >= "0" && p <= "7") {
	            ch += next(true);
	            if (ch[0] <= "3" && (p = peek()) >= "0" && p <= "7")
	                ch += next(true);
	        }

	        // Parse
	        if (ch === "0") return "\0";
	        if (ch.length > 0 && next_token.has_directive("use strict") && strict_octal)
	            parse_error("Legacy octal escape sequences are not allowed in strict mode");
	        return String.fromCharCode(parseInt(ch, 8));
	    }

	    function hex_bytes(n, strict_hex) {
	        var num = 0;
	        for (; n > 0; --n) {
	            if (!strict_hex && isNaN(parseInt(peek(), 16))) {
	                return parseInt(num, 16) || "";
	            }
	            var digit = next(true);
	            if (isNaN(parseInt(digit, 16)))
	                parse_error("Invalid hex-character pattern in string");
	            num += digit;
	        }
	        return parseInt(num, 16);
	    }

	    var read_string = with_eof_error("Unterminated string constant", function() {
	        const start_pos = S.pos;
	        var quote = next(), ret = [];
	        for (;;) {
	            var ch = next(true, true);
	            if (ch == "\\") ch = read_escaped_char(true, true);
	            else if (ch == "\r" || ch == "\n") parse_error("Unterminated string constant");
	            else if (ch == quote) break;
	            ret.push(ch);
	        }
	        var tok = token("string", ret.join(""));
	        LATEST_RAW = S.text.slice(start_pos, S.pos);
	        tok.quote = quote;
	        return tok;
	    });

	    var read_template_characters = with_eof_error("Unterminated template", function(begin) {
	        if (begin) {
	            S.template_braces.push(S.brace_counter);
	        }
	        var content = "", raw = "", ch, tok;
	        next(true, true);
	        while ((ch = next(true, true)) != "`") {
	            if (ch == "\r") {
	                if (peek() == "\n") ++S.pos;
	                ch = "\n";
	            } else if (ch == "$" && peek() == "{") {
	                next(true, true);
	                S.brace_counter++;
	                tok = token(begin ? "template_head" : "template_substitution", content);
	                TEMPLATE_RAWS.set(tok, raw);
	                tok.template_end = false;
	                return tok;
	            }

	            raw += ch;
	            if (ch == "\\") {
	                var tmp = S.pos;
	                var prev_is_tag = previous_token && (previous_token.type === "name" || previous_token.type === "punc" && (previous_token.value === ")" || previous_token.value === "]"));
	                ch = read_escaped_char(true, !prev_is_tag, true);
	                raw += S.text.substr(tmp, S.pos - tmp);
	            }

	            content += ch;
	        }
	        S.template_braces.pop();
	        tok = token(begin ? "template_head" : "template_substitution", content);
	        TEMPLATE_RAWS.set(tok, raw);
	        tok.template_end = true;
	        return tok;
	    });

	    function skip_line_comment(type) {
	        var regex_allowed = S.regex_allowed;
	        var i = find_eol(), ret;
	        if (i == -1) {
	            ret = S.text.substr(S.pos);
	            S.pos = S.text.length;
	        } else {
	            ret = S.text.substring(S.pos, i);
	            S.pos = i;
	        }
	        S.col = S.tokcol + (S.pos - S.tokpos);
	        S.comments_before.push(token(type, ret, true));
	        S.regex_allowed = regex_allowed;
	        return next_token;
	    }

	    var skip_multiline_comment = with_eof_error("Unterminated multiline comment", function() {
	        var regex_allowed = S.regex_allowed;
	        var i = find("*/", true);
	        var text = S.text.substring(S.pos, i).replace(/\r\n|\r|\u2028|\u2029/g, "\n");
	        // update stream position
	        forward(get_full_char_length(text) /* text length doesn't count \r\n as 2 char while S.pos - i does */ + 2);
	        S.comments_before.push(token("comment2", text, true));
	        S.newline_before = S.newline_before || text.includes("\n");
	        S.regex_allowed = regex_allowed;
	        return next_token;
	    });

	    var read_name = with_eof_error("Unterminated identifier name", function() {
	        var name = [], ch, escaped = false;
	        var read_escaped_identifier_char = function() {
	            escaped = true;
	            next();
	            if (peek() !== "u") {
	                parse_error("Expecting UnicodeEscapeSequence -- uXXXX or u{XXXX}");
	            }
	            return read_escaped_char(false, true);
	        };

	        // Read first character (ID_Start)
	        if ((ch = peek()) === "\\") {
	            ch = read_escaped_identifier_char();
	            if (!is_identifier_start(ch)) {
	                parse_error("First identifier char is an invalid identifier char");
	            }
	        } else if (is_identifier_start(ch)) {
	            next();
	        } else {
	            return "";
	        }

	        name.push(ch);

	        // Read ID_Continue
	        while ((ch = peek()) != null) {
	            if ((ch = peek()) === "\\") {
	                ch = read_escaped_identifier_char();
	                if (!is_identifier_char(ch)) {
	                    parse_error("Invalid escaped identifier char");
	                }
	            } else {
	                if (!is_identifier_char(ch)) {
	                    break;
	                }
	                next();
	            }
	            name.push(ch);
	        }
	        const name_str = name.join("");
	        if (RESERVED_WORDS.has(name_str) && escaped) {
	            parse_error("Escaped characters are not allowed in keywords");
	        }
	        return name_str;
	    });

	    var read_regexp = with_eof_error("Unterminated regular expression", function(source) {
	        var prev_backslash = false, ch, in_class = false;
	        while ((ch = next(true))) if (NEWLINE_CHARS.has(ch)) {
	            parse_error("Unexpected line terminator");
	        } else if (prev_backslash) {
	            if (/^[\u0000-\u007F]$/.test(ch)) {
	                source += "\\" + ch;
	            } else {
	                // Remove the useless slash before the escape, but only for characters that won't be added to regexp syntax
	                source += ch;
	            }
	            prev_backslash = false;
	        } else if (ch == "[") {
	            in_class = true;
	            source += ch;
	        } else if (ch == "]" && in_class) {
	            in_class = false;
	            source += ch;
	        } else if (ch == "/" && !in_class) {
	            break;
	        } else if (ch == "\\") {
	            prev_backslash = true;
	        } else {
	            source += ch;
	        }
	        const flags = read_name();
	        return token("regexp", "/" + source + "/" + flags);
	    });

	    function read_operator(prefix) {
	        function grow(op) {
	            if (!peek()) return op;
	            var bigger = op + peek();
	            if (OPERATORS.has(bigger)) {
	                next();
	                return grow(bigger);
	            } else {
	                return op;
	            }
	        }
	        return token("operator", grow(prefix || next()));
	    }

	    function handle_slash() {
	        next();
	        switch (peek()) {
	          case "/":
	            next();
	            return skip_line_comment("comment1");
	          case "*":
	            next();
	            return skip_multiline_comment();
	        }
	        return S.regex_allowed ? read_regexp("") : read_operator("/");
	    }

	    function handle_eq_sign() {
	        next();
	        if (peek() === ">") {
	            next();
	            return token("arrow", "=>");
	        } else {
	            return read_operator("=");
	        }
	    }

	    function handle_dot() {
	        next();
	        if (is_digit(peek().charCodeAt(0))) {
	            return read_num(".");
	        }
	        if (peek() === ".") {
	            next();  // Consume second dot
	            next();  // Consume third dot
	            return token("expand", "...");
	        }

	        return token("punc", ".");
	    }

	    function read_word() {
	        var word = read_name();
	        if (prev_was_dot) return token("name", word);
	        return KEYWORDS_ATOM.has(word) ? token("atom", word)
	            : !KEYWORDS.has(word) ? token("name", word)
	            : OPERATORS.has(word) ? token("operator", word)
	            : token("keyword", word);
	    }

	    function read_private_word() {
	        next();
	        return token("privatename", read_name());
	    }

	    function with_eof_error(eof_error, cont) {
	        return function(x) {
	            try {
	                return cont(x);
	            } catch(ex) {
	                if (ex === EX_EOF) parse_error(eof_error);
	                else throw ex;
	            }
	        };
	    }

	    function next_token(force_regexp) {
	        if (force_regexp != null)
	            return read_regexp(force_regexp);
	        if (shebang && S.pos == 0 && looking_at("#!")) {
	            start_token();
	            forward(2);
	            skip_line_comment("comment5");
	        }
	        for (;;) {
	            skip_whitespace();
	            start_token();
	            if (html5_comments) {
	                if (looking_at("<!--")) {
	                    forward(4);
	                    skip_line_comment("comment3");
	                    continue;
	                }
	                if (looking_at("-->") && S.newline_before) {
	                    forward(3);
	                    skip_line_comment("comment4");
	                    continue;
	                }
	            }
	            var ch = peek();
	            if (!ch) return token("eof");
	            var code = ch.charCodeAt(0);
	            switch (code) {
	              case 34: case 39: return read_string();
	              case 46: return handle_dot();
	              case 47: {
	                  var tok = handle_slash();
	                  if (tok === next_token) continue;
	                  return tok;
	              }
	              case 61: return handle_eq_sign();
	              case 63: {
	                  if (!is_option_chain_op()) break;  // Handled below

	                  next(); // ?
	                  next(); // .

	                  return token("punc", "?.");
	              }
	              case 96: return read_template_characters(true);
	              case 123:
	                S.brace_counter++;
	                break;
	              case 125:
	                S.brace_counter--;
	                if (S.template_braces.length > 0
	                    && S.template_braces[S.template_braces.length - 1] === S.brace_counter)
	                    return read_template_characters(false);
	                break;
	            }
	            if (is_digit(code)) return read_num();
	            if (PUNC_CHARS.has(ch)) return token("punc", next());
	            if (OPERATOR_CHARS.has(ch)) return read_operator();
	            if (code == 92 || is_identifier_start(ch)) return read_word();
	            if (code == 35) return read_private_word();
	            break;
	        }
	        parse_error("Unexpected character '" + ch + "'");
	    }

	    next_token.next = next;
	    next_token.peek = peek;

	    next_token.context = function(nc) {
	        if (nc) S = nc;
	        return S;
	    };

	    next_token.add_directive = function(directive) {
	        S.directive_stack[S.directive_stack.length - 1].push(directive);

	        if (S.directives[directive] === undefined) {
	            S.directives[directive] = 1;
	        } else {
	            S.directives[directive]++;
	        }
	    };

	    next_token.push_directives_stack = function() {
	        S.directive_stack.push([]);
	    };

	    next_token.pop_directives_stack = function() {
	        var directives = S.directive_stack[S.directive_stack.length - 1];

	        for (var i = 0; i < directives.length; i++) {
	            S.directives[directives[i]]--;
	        }

	        S.directive_stack.pop();
	    };

	    next_token.has_directive = function(directive) {
	        return S.directives[directive] > 0;
	    };

	    return next_token;

	}

	/* -----[ Parser (constants) ]----- */

	var UNARY_PREFIX = makePredicate([
	    "typeof",
	    "void",
	    "delete",
	    "--",
	    "++",
	    "!",
	    "~",
	    "-",
	    "+"
	]);

	var UNARY_POSTFIX = makePredicate([ "--", "++" ]);

	var ASSIGNMENT = makePredicate([ "=", "+=", "-=", "??=", "&&=", "||=", "/=", "*=", "**=", "%=", ">>=", "<<=", ">>>=", "|=", "^=", "&=" ]);

	var LOGICAL_ASSIGNMENT = makePredicate([ "??=", "&&=", "||=" ]);

	var PRECEDENCE = (function(a, ret) {
	    for (var i = 0; i < a.length; ++i) {
	        for (const op of a[i]) {
	            ret[op] = i + 1;
	        }
	    }
	    return ret;
	})(
	    [
	        ["||"],
	        ["??"],
	        ["&&"],
	        ["|"],
	        ["^"],
	        ["&"],
	        ["==", "===", "!=", "!=="],
	        ["<", ">", "<=", ">=", "in", "instanceof"],
	        [">>", "<<", ">>>"],
	        ["+", "-"],
	        ["*", "/", "%"],
	        ["**"]
	    ],
	    {}
	);

	var ATOMIC_START_TOKEN = makePredicate([ "atom", "num", "big_int", "string", "regexp", "name"]);

	/* -----[ Parser ]----- */

	function parse($TEXT, options) {
	    // maps start tokens to count of comments found outside of their parens
	    // Example: /* I count */ ( /* I don't */ foo() )
	    // Useful because comments_before property of call with parens outside
	    // contains both comments inside and outside these parens. Used to find the
	    
	    const outer_comments_before_counts = new WeakMap();

	    options = defaults(options, {
	        bare_returns   : false,
	        ecma           : null,  // Legacy
	        expression     : false,
	        filename       : null,
	        html5_comments : true,
	        module         : false,
	        shebang        : true,
	        strict         : false,
	        toplevel       : null,
	    }, true);

	    var S = {
	        input         : (typeof $TEXT == "string"
	                         ? tokenizer($TEXT, options.filename,
	                                     options.html5_comments, options.shebang)
	                         : $TEXT),
	        token         : null,
	        prev          : null,
	        peeked        : null,
	        in_function   : 0,
	        in_async      : -1,
	        in_generator  : -1,
	        in_directives : true,
	        in_loop       : 0,
	        labels        : []
	    };

	    S.token = next();

	    function is(type, value) {
	        return is_token(S.token, type, value);
	    }

	    function peek() { return S.peeked || (S.peeked = S.input()); }

	    function next() {
	        S.prev = S.token;

	        if (!S.peeked) peek();
	        S.token = S.peeked;
	        S.peeked = null;
	        S.in_directives = S.in_directives && (
	            S.token.type == "string" || is("punc", ";")
	        );
	        return S.token;
	    }

	    function prev() {
	        return S.prev;
	    }

	    function croak(msg, line, col, pos) {
	        var ctx = S.input.context();
	        js_error(msg,
	                 ctx.filename,
	                 line != null ? line : ctx.tokline,
	                 col != null ? col : ctx.tokcol,
	                 pos != null ? pos : ctx.tokpos);
	    }

	    function token_error(token, msg) {
	        croak(msg, token.line, token.col);
	    }

	    function unexpected(token) {
	        if (token == null)
	            token = S.token;
	        token_error(token, "Unexpected token: " + token.type + " (" + token.value + ")");
	    }

	    function expect_token(type, val) {
	        if (is(type, val)) {
	            return next();
	        }
	        token_error(S.token, "Unexpected token " + S.token.type + " «" + S.token.value + "»" + ", expected " + type + " «" + val + "»");
	    }

	    function expect(punc) { return expect_token("punc", punc); }

	    function has_newline_before(token) {
	        return token.nlb || !token.comments_before.every((comment) => !comment.nlb);
	    }

	    function can_insert_semicolon() {
	        return !options.strict
	            && (is("eof") || is("punc", "}") || has_newline_before(S.token));
	    }

	    function is_in_generator() {
	        return S.in_generator === S.in_function;
	    }

	    function is_in_async() {
	        return S.in_async === S.in_function;
	    }

	    function can_await() {
	        return (
	            S.in_async === S.in_function
	            || S.in_function === 0 && S.input.has_directive("use strict")
	        );
	    }

	    function semicolon(optional) {
	        if (is("punc", ";")) next();
	        else if (!optional && !can_insert_semicolon()) unexpected();
	    }

	    function parenthesised() {
	        expect("(");
	        var exp = expression(true);
	        expect(")");
	        return exp;
	    }

	    function embed_tokens(parser) {
	        return function _embed_tokens_wrapper(...args) {
	            const start = S.token;
	            const expr = parser(...args);
	            expr.start = start;
	            expr.end = prev();
	            return expr;
	        };
	    }

	    function handle_regexp() {
	        if (is("operator", "/") || is("operator", "/=")) {
	            S.peeked = null;
	            S.token = S.input(S.token.value.substr(1)); // force regexp
	        }
	    }

	    var statement = embed_tokens(function statement(is_export_default, is_for_body, is_if_body) {
	        handle_regexp();
	        switch (S.token.type) {
	          case "string":
	            if (S.in_directives) {
	                var token = peek();
	                if (!LATEST_RAW.includes("\\")
	                    && (is_token(token, "punc", ";")
	                        || is_token(token, "punc", "}")
	                        || has_newline_before(token)
	                        || is_token(token, "eof"))) {
	                    S.input.add_directive(S.token.value);
	                } else {
	                    S.in_directives = false;
	                }
	            }
	            var dir = S.in_directives, stat = simple_statement();
	            return dir && stat.body instanceof AST_String ? new AST_Directive(stat.body) : stat;
	          case "template_head":
	          case "num":
	          case "big_int":
	          case "regexp":
	          case "operator":
	          case "atom":
	            return simple_statement();

	          case "name":
	          case "privatename":
	            if(is("privatename") && !S.in_class)
	                croak("Private field must be used in an enclosing class");

	            if (S.token.value == "async" && is_token(peek(), "keyword", "function")) {
	                next();
	                next();
	                if (is_for_body) {
	                    croak("functions are not allowed as the body of a loop");
	                }
	                return function_(AST_Defun, false, true, is_export_default);
	            }
	            if (S.token.value == "import" && !is_token(peek(), "punc", "(") && !is_token(peek(), "punc", ".")) {
	                next();
	                var node = import_statement();
	                semicolon();
	                return node;
	            }
	            return is_token(peek(), "punc", ":")
	                ? labeled_statement()
	                : simple_statement();

	          case "punc":
	            switch (S.token.value) {
	              case "{":
	                return new AST_BlockStatement({
	                    start : S.token,
	                    body  : block_(),
	                    end   : prev()
	                });
	              case "[":
	              case "(":
	                return simple_statement();
	              case ";":
	                S.in_directives = false;
	                next();
	                return new AST_EmptyStatement();
	              default:
	                unexpected();
	            }

	          case "keyword":
	            switch (S.token.value) {
	              case "break":
	                next();
	                return break_cont(AST_Break);

	              case "continue":
	                next();
	                return break_cont(AST_Continue);

	              case "debugger":
	                next();
	                semicolon();
	                return new AST_Debugger();

	              case "do":
	                next();
	                var body = in_loop(statement);
	                expect_token("keyword", "while");
	                var condition = parenthesised();
	                semicolon(true);
	                return new AST_Do({
	                    body      : body,
	                    condition : condition
	                });

	              case "while":
	                next();
	                return new AST_While({
	                    condition : parenthesised(),
	                    body      : in_loop(function() { return statement(false, true); })
	                });

	              case "for":
	                next();
	                return for_();

	              case "class":
	                next();
	                if (is_for_body) {
	                    croak("classes are not allowed as the body of a loop");
	                }
	                if (is_if_body) {
	                    croak("classes are not allowed as the body of an if");
	                }
	                return class_(AST_DefClass, is_export_default);

	              case "function":
	                next();
	                if (is_for_body) {
	                    croak("functions are not allowed as the body of a loop");
	                }
	                return function_(AST_Defun, false, false, is_export_default);

	              case "if":
	                next();
	                return if_();

	              case "return":
	                if (S.in_function == 0 && !options.bare_returns)
	                    croak("'return' outside of function");
	                next();
	                var value = null;
	                if (is("punc", ";")) {
	                    next();
	                } else if (!can_insert_semicolon()) {
	                    value = expression(true);
	                    semicolon();
	                }
	                return new AST_Return({
	                    value: value
	                });

	              case "switch":
	                next();
	                return new AST_Switch({
	                    expression : parenthesised(),
	                    body       : in_loop(switch_body_)
	                });

	              case "throw":
	                next();
	                if (has_newline_before(S.token))
	                    croak("Illegal newline after 'throw'");
	                var value = expression(true);
	                semicolon();
	                return new AST_Throw({
	                    value: value
	                });

	              case "try":
	                next();
	                return try_();

	              case "var":
	                next();
	                var node = var_();
	                semicolon();
	                return node;

	              case "let":
	                next();
	                var node = let_();
	                semicolon();
	                return node;

	              case "const":
	                next();
	                var node = const_();
	                semicolon();
	                return node;

	              case "with":
	                if (S.input.has_directive("use strict")) {
	                    croak("Strict mode may not include a with statement");
	                }
	                next();
	                return new AST_With({
	                    expression : parenthesised(),
	                    body       : statement()
	                });

	              case "export":
	                if (!is_token(peek(), "punc", "(")) {
	                    next();
	                    var node = export_statement();
	                    if (is("punc", ";")) semicolon();
	                    return node;
	                }
	            }
	        }
	        unexpected();
	    });

	    function labeled_statement() {
	        var label = as_symbol(AST_Label);
	        if (label.name === "await" && is_in_async()) {
	            token_error(S.prev, "await cannot be used as label inside async function");
	        }
	        if (S.labels.some((l) => l.name === label.name)) {
	            // ECMA-262, 12.12: An ECMAScript program is considered
	            // syntactically incorrect if it contains a
	            // LabelledStatement that is enclosed by a
	            // LabelledStatement with the same Identifier as label.
	            croak("Label " + label.name + " defined twice");
	        }
	        expect(":");
	        S.labels.push(label);
	        var stat = statement();
	        S.labels.pop();
	        if (!(stat instanceof AST_IterationStatement)) {
	            // check for `continue` that refers to this label.
	            // those should be reported as syntax errors.
	            // https://github.com/mishoo/UglifyJS2/issues/287
	            label.references.forEach(function(ref) {
	                if (ref instanceof AST_Continue) {
	                    ref = ref.label.start;
	                    croak("Continue label `" + label.name + "` refers to non-IterationStatement.",
	                          ref.line, ref.col, ref.pos);
	                }
	            });
	        }
	        return new AST_LabeledStatement({ body: stat, label: label });
	    }

	    function simple_statement(tmp) {
	        return new AST_SimpleStatement({ body: (tmp = expression(true), semicolon(), tmp) });
	    }

	    function break_cont(type) {
	        var label = null, ldef;
	        if (!can_insert_semicolon()) {
	            label = as_symbol(AST_LabelRef, true);
	        }
	        if (label != null) {
	            ldef = S.labels.find((l) => l.name === label.name);
	            if (!ldef)
	                croak("Undefined label " + label.name);
	            label.thedef = ldef;
	        } else if (S.in_loop == 0)
	            croak(type.TYPE + " not inside a loop or switch");
	        semicolon();
	        var stat = new type({ label: label });
	        if (ldef) ldef.references.push(stat);
	        return stat;
	    }

	    function for_() {
	        var for_await_error = "`for await` invalid in this context";
	        var await_tok = S.token;
	        if (await_tok.type == "name" && await_tok.value == "await") {
	            if (!can_await()) {
	                token_error(await_tok, for_await_error);
	            }
	            next();
	        } else {
	            await_tok = false;
	        }
	        expect("(");
	        var init = null;
	        if (!is("punc", ";")) {
	            init =
	                is("keyword", "var") ? (next(), var_(true)) :
	                is("keyword", "let") ? (next(), let_(true)) :
	                is("keyword", "const") ? (next(), const_(true)) :
	                                       expression(true, true);
	            var is_in = is("operator", "in");
	            var is_of = is("name", "of");
	            if (await_tok && !is_of) {
	                token_error(await_tok, for_await_error);
	            }
	            if (is_in || is_of) {
	                if (init instanceof AST_Definitions) {
	                    if (init.definitions.length > 1)
	                        token_error(init.start, "Only one variable declaration allowed in for..in loop");
	                } else if (!(is_assignable(init) || (init = to_destructuring(init)) instanceof AST_Destructuring)) {
	                    token_error(init.start, "Invalid left-hand side in for..in loop");
	                }
	                next();
	                if (is_in) {
	                    return for_in(init);
	                } else {
	                    return for_of(init, !!await_tok);
	                }
	            }
	        } else if (await_tok) {
	            token_error(await_tok, for_await_error);
	        }
	        return regular_for(init);
	    }

	    function regular_for(init) {
	        expect(";");
	        var test = is("punc", ";") ? null : expression(true);
	        expect(";");
	        var step = is("punc", ")") ? null : expression(true);
	        expect(")");
	        return new AST_For({
	            init      : init,
	            condition : test,
	            step      : step,
	            body      : in_loop(function() { return statement(false, true); })
	        });
	    }

	    function for_of(init, is_await) {
	        var lhs = init instanceof AST_Definitions ? init.definitions[0].name : null;
	        var obj = expression(true);
	        expect(")");
	        return new AST_ForOf({
	            await  : is_await,
	            init   : init,
	            name   : lhs,
	            object : obj,
	            body   : in_loop(function() { return statement(false, true); })
	        });
	    }

	    function for_in(init) {
	        var obj = expression(true);
	        expect(")");
	        return new AST_ForIn({
	            init   : init,
	            object : obj,
	            body   : in_loop(function() { return statement(false, true); })
	        });
	    }

	    var arrow_function = function(start, argnames, is_async) {
	        if (has_newline_before(S.token)) {
	            croak("Unexpected newline before arrow (=>)");
	        }

	        expect_token("arrow", "=>");

	        var body = _function_body(is("punc", "{"), false, is_async);

	        var end =
	            body instanceof Array && body.length ? body[body.length - 1].end :
	            body instanceof Array ? start :
	                body.end;

	        return new AST_Arrow({
	            start    : start,
	            end      : end,
	            async    : is_async,
	            argnames : argnames,
	            body     : body
	        });
	    };

	    var function_ = function(ctor, is_generator_property, is_async, is_export_default) {
	        var in_statement = ctor === AST_Defun;
	        var is_generator = is("operator", "*");
	        if (is_generator) {
	            next();
	        }

	        var name = is("name") ? as_symbol(in_statement ? AST_SymbolDefun : AST_SymbolLambda) : null;
	        if (in_statement && !name) {
	            if (is_export_default) {
	                ctor = AST_Function;
	            } else {
	                unexpected();
	            }
	        }

	        if (name && ctor !== AST_Accessor && !(name instanceof AST_SymbolDeclaration))
	            unexpected(prev());

	        var args = [];
	        var body = _function_body(true, is_generator || is_generator_property, is_async, name, args);
	        return new ctor({
	            start : args.start,
	            end   : body.end,
	            is_generator: is_generator,
	            async : is_async,
	            name  : name,
	            argnames: args,
	            body  : body
	        });
	    };

	    class UsedParametersTracker {
	        constructor(is_parameter, strict, duplicates_ok = false) {
	            this.is_parameter = is_parameter;
	            this.duplicates_ok = duplicates_ok;
	            this.parameters = new Set();
	            this.duplicate = null;
	            this.default_assignment = false;
	            this.spread = false;
	            this.strict_mode = !!strict;
	        }
	        add_parameter(token) {
	            if (this.parameters.has(token.value)) {
	                if (this.duplicate === null) {
	                    this.duplicate = token;
	                }
	                this.check_strict();
	            } else {
	                this.parameters.add(token.value);
	                if (this.is_parameter) {
	                    switch (token.value) {
	                      case "arguments":
	                      case "eval":
	                      case "yield":
	                        if (this.strict_mode) {
	                            token_error(token, "Unexpected " + token.value + " identifier as parameter inside strict mode");
	                        }
	                        break;
	                      default:
	                        if (RESERVED_WORDS.has(token.value)) {
	                            unexpected();
	                        }
	                    }
	                }
	            }
	        }
	        mark_default_assignment(token) {
	            if (this.default_assignment === false) {
	                this.default_assignment = token;
	            }
	        }
	        mark_spread(token) {
	            if (this.spread === false) {
	                this.spread = token;
	            }
	        }
	        mark_strict_mode() {
	            this.strict_mode = true;
	        }
	        is_strict() {
	            return this.default_assignment !== false || this.spread !== false || this.strict_mode;
	        }
	        check_strict() {
	            if (this.is_strict() && this.duplicate !== null && !this.duplicates_ok) {
	                token_error(this.duplicate, "Parameter " + this.duplicate.value + " was used already");
	            }
	        }
	    }

	    function parameters(params) {
	        var used_parameters = new UsedParametersTracker(true, S.input.has_directive("use strict"));

	        expect("(");

	        while (!is("punc", ")")) {
	            var param = parameter(used_parameters);
	            params.push(param);

	            if (!is("punc", ")")) {
	                expect(",");
	            }

	            if (param instanceof AST_Expansion) {
	                break;
	            }
	        }

	        next();
	    }

	    function parameter(used_parameters, symbol_type) {
	        var param;
	        var expand = false;
	        if (used_parameters === undefined) {
	            used_parameters = new UsedParametersTracker(true, S.input.has_directive("use strict"));
	        }
	        if (is("expand", "...")) {
	            expand = S.token;
	            used_parameters.mark_spread(S.token);
	            next();
	        }
	        param = binding_element(used_parameters, symbol_type);

	        if (is("operator", "=") && expand === false) {
	            used_parameters.mark_default_assignment(S.token);
	            next();
	            param = new AST_DefaultAssign({
	                start: param.start,
	                left: param,
	                operator: "=",
	                right: expression(false),
	                end: S.token
	            });
	        }

	        if (expand !== false) {
	            if (!is("punc", ")")) {
	                unexpected();
	            }
	            param = new AST_Expansion({
	                start: expand,
	                expression: param,
	                end: expand
	            });
	        }
	        used_parameters.check_strict();

	        return param;
	    }

	    function binding_element(used_parameters, symbol_type) {
	        var elements = [];
	        var first = true;
	        var is_expand = false;
	        var expand_token;
	        var first_token = S.token;
	        if (used_parameters === undefined) {
	            const strict = S.input.has_directive("use strict");
	            const duplicates_ok = symbol_type === AST_SymbolVar;
	            used_parameters = new UsedParametersTracker(false, strict, duplicates_ok);
	        }
	        symbol_type = symbol_type === undefined ? AST_SymbolFunarg : symbol_type;
	        if (is("punc", "[")) {
	            next();
	            while (!is("punc", "]")) {
	                if (first) {
	                    first = false;
	                } else {
	                    expect(",");
	                }

	                if (is("expand", "...")) {
	                    is_expand = true;
	                    expand_token = S.token;
	                    used_parameters.mark_spread(S.token);
	                    next();
	                }
	                if (is("punc")) {
	                    switch (S.token.value) {
	                      case ",":
	                        elements.push(new AST_Hole({
	                            start: S.token,
	                            end: S.token
	                        }));
	                        continue;
	                      case "]": // Trailing comma after last element
	                        break;
	                      case "[":
	                      case "{":
	                        elements.push(binding_element(used_parameters, symbol_type));
	                        break;
	                      default:
	                        unexpected();
	                    }
	                } else if (is("name")) {
	                    used_parameters.add_parameter(S.token);
	                    elements.push(as_symbol(symbol_type));
	                } else {
	                    croak("Invalid function parameter");
	                }
	                if (is("operator", "=") && is_expand === false) {
	                    used_parameters.mark_default_assignment(S.token);
	                    next();
	                    elements[elements.length - 1] = new AST_DefaultAssign({
	                        start: elements[elements.length - 1].start,
	                        left: elements[elements.length - 1],
	                        operator: "=",
	                        right: expression(false),
	                        end: S.token
	                    });
	                }
	                if (is_expand) {
	                    if (!is("punc", "]")) {
	                        croak("Rest element must be last element");
	                    }
	                    elements[elements.length - 1] = new AST_Expansion({
	                        start: expand_token,
	                        expression: elements[elements.length - 1],
	                        end: expand_token
	                    });
	                }
	            }
	            expect("]");
	            used_parameters.check_strict();
	            return new AST_Destructuring({
	                start: first_token,
	                names: elements,
	                is_array: true,
	                end: prev()
	            });
	        } else if (is("punc", "{")) {
	            next();
	            while (!is("punc", "}")) {
	                if (first) {
	                    first = false;
	                } else {
	                    expect(",");
	                }
	                if (is("expand", "...")) {
	                    is_expand = true;
	                    expand_token = S.token;
	                    used_parameters.mark_spread(S.token);
	                    next();
	                }
	                if (is("name") && (is_token(peek(), "punc") || is_token(peek(), "operator")) && [",", "}", "="].includes(peek().value)) {
	                    used_parameters.add_parameter(S.token);
	                    var start = prev();
	                    var value = as_symbol(symbol_type);
	                    if (is_expand) {
	                        elements.push(new AST_Expansion({
	                            start: expand_token,
	                            expression: value,
	                            end: value.end,
	                        }));
	                    } else {
	                        elements.push(new AST_ObjectKeyVal({
	                            start: start,
	                            key: value.name,
	                            value: value,
	                            end: value.end,
	                        }));
	                    }
	                } else if (is("punc", "}")) {
	                    continue; // Allow trailing hole
	                } else {
	                    var property_token = S.token;
	                    var property = as_property_name();
	                    if (property === null) {
	                        unexpected(prev());
	                    } else if (prev().type === "name" && !is("punc", ":")) {
	                        elements.push(new AST_ObjectKeyVal({
	                            start: prev(),
	                            key: property,
	                            value: new symbol_type({
	                                start: prev(),
	                                name: property,
	                                end: prev()
	                            }),
	                            end: prev()
	                        }));
	                    } else {
	                        expect(":");
	                        elements.push(new AST_ObjectKeyVal({
	                            start: property_token,
	                            quote: property_token.quote,
	                            key: property,
	                            value: binding_element(used_parameters, symbol_type),
	                            end: prev()
	                        }));
	                    }
	                }
	                if (is_expand) {
	                    if (!is("punc", "}")) {
	                        croak("Rest element must be last element");
	                    }
	                } else if (is("operator", "=")) {
	                    used_parameters.mark_default_assignment(S.token);
	                    next();
	                    elements[elements.length - 1].value = new AST_DefaultAssign({
	                        start: elements[elements.length - 1].value.start,
	                        left: elements[elements.length - 1].value,
	                        operator: "=",
	                        right: expression(false),
	                        end: S.token
	                    });
	                }
	            }
	            expect("}");
	            used_parameters.check_strict();
	            return new AST_Destructuring({
	                start: first_token,
	                names: elements,
	                is_array: false,
	                end: prev()
	            });
	        } else if (is("name")) {
	            used_parameters.add_parameter(S.token);
	            return as_symbol(symbol_type);
	        } else {
	            croak("Invalid function parameter");
	        }
	    }

	    function params_or_seq_(allow_arrows, maybe_sequence) {
	        var spread_token;
	        var invalid_sequence;
	        var trailing_comma;
	        var a = [];
	        expect("(");
	        while (!is("punc", ")")) {
	            if (spread_token) unexpected(spread_token);
	            if (is("expand", "...")) {
	                spread_token = S.token;
	                if (maybe_sequence) invalid_sequence = S.token;
	                next();
	                a.push(new AST_Expansion({
	                    start: prev(),
	                    expression: expression(),
	                    end: S.token,
	                }));
	            } else {
	                a.push(expression());
	            }
	            if (!is("punc", ")")) {
	                expect(",");
	                if (is("punc", ")")) {
	                    trailing_comma = prev();
	                    if (maybe_sequence) invalid_sequence = trailing_comma;
	                }
	            }
	        }
	        expect(")");
	        if (allow_arrows && is("arrow", "=>")) {
	            if (spread_token && trailing_comma) unexpected(trailing_comma);
	        } else if (invalid_sequence) {
	            unexpected(invalid_sequence);
	        }
	        return a;
	    }

	    function _function_body(block, generator, is_async, name, args) {
	        var loop = S.in_loop;
	        var labels = S.labels;
	        var current_generator = S.in_generator;
	        var current_async = S.in_async;
	        ++S.in_function;
	        if (generator)
	            S.in_generator = S.in_function;
	        if (is_async)
	            S.in_async = S.in_function;
	        if (args) parameters(args);
	        if (block)
	            S.in_directives = true;
	        S.in_loop = 0;
	        S.labels = [];
	        if (block) {
	            S.input.push_directives_stack();
	            var a = block_();
	            if (name) _verify_symbol(name);
	            if (args) args.forEach(_verify_symbol);
	            S.input.pop_directives_stack();
	        } else {
	            var a = [new AST_Return({
	                start: S.token,
	                value: expression(false),
	                end: S.token
	            })];
	        }
	        --S.in_function;
	        S.in_loop = loop;
	        S.labels = labels;
	        S.in_generator = current_generator;
	        S.in_async = current_async;
	        return a;
	    }

	    function _await_expression() {
	        // Previous token must be "await" and not be interpreted as an identifier
	        if (!can_await()) {
	            croak("Unexpected await expression outside async function",
	                S.prev.line, S.prev.col, S.prev.pos);
	        }
	        // the await expression is parsed as a unary expression in Babel
	        return new AST_Await({
	            start: prev(),
	            end: S.token,
	            expression : maybe_unary(true),
	        });
	    }

	    function _yield_expression() {
	        // Previous token must be keyword yield and not be interpret as an identifier
	        if (!is_in_generator()) {
	            croak("Unexpected yield expression outside generator function",
	                S.prev.line, S.prev.col, S.prev.pos);
	        }
	        var start = S.token;
	        var star = false;
	        var has_expression = true;

	        // Attempt to get expression or star (and then the mandatory expression)
	        // behind yield on the same line.
	        //
	        // If nothing follows on the same line of the yieldExpression,
	        // it should default to the value `undefined` for yield to return.
	        // In that case, the `undefined` stored as `null` in ast.
	        //
	        // Note 1: It isn't allowed for yield* to close without an expression
	        // Note 2: If there is a nlb between yield and star, it is interpret as
	        //         yield <explicit undefined> <inserted automatic semicolon> *
	        if (can_insert_semicolon() ||
	            (is("punc") && PUNC_AFTER_EXPRESSION.has(S.token.value))) {
	            has_expression = false;

	        } else if (is("operator", "*")) {
	            star = true;
	            next();
	        }

	        return new AST_Yield({
	            start      : start,
	            is_star    : star,
	            expression : has_expression ? expression() : null,
	            end        : prev()
	        });
	    }

	    function if_() {
	        var cond = parenthesised(), body = statement(false, false, true), belse = null;
	        if (is("keyword", "else")) {
	            next();
	            belse = statement(false, false, true);
	        }
	        return new AST_If({
	            condition   : cond,
	            body        : body,
	            alternative : belse
	        });
	    }

	    function block_() {
	        expect("{");
	        var a = [];
	        while (!is("punc", "}")) {
	            if (is("eof")) unexpected();
	            a.push(statement());
	        }
	        next();
	        return a;
	    }

	    function switch_body_() {
	        expect("{");
	        var a = [], cur = null, branch = null, tmp;
	        while (!is("punc", "}")) {
	            if (is("eof")) unexpected();
	            if (is("keyword", "case")) {
	                if (branch) branch.end = prev();
	                cur = [];
	                branch = new AST_Case({
	                    start      : (tmp = S.token, next(), tmp),
	                    expression : expression(true),
	                    body       : cur
	                });
	                a.push(branch);
	                expect(":");
	            } else if (is("keyword", "default")) {
	                if (branch) branch.end = prev();
	                cur = [];
	                branch = new AST_Default({
	                    start : (tmp = S.token, next(), expect(":"), tmp),
	                    body  : cur
	                });
	                a.push(branch);
	            } else {
	                if (!cur) unexpected();
	                cur.push(statement());
	            }
	        }
	        if (branch) branch.end = prev();
	        next();
	        return a;
	    }

	    function try_() {
	        var body, bcatch = null, bfinally = null;
	        body = new AST_TryBlock({
	            start : S.token,
	            body  : block_(),
	            end   : prev(),
	        });
	        if (is("keyword", "catch")) {
	            var start = S.token;
	            next();
	            if (is("punc", "{")) {
	                var name = null;
	            } else {
	                expect("(");
	                var name = parameter(undefined, AST_SymbolCatch);
	                expect(")");
	            }
	            bcatch = new AST_Catch({
	                start   : start,
	                argname : name,
	                body    : block_(),
	                end     : prev()
	            });
	        }
	        if (is("keyword", "finally")) {
	            var start = S.token;
	            next();
	            bfinally = new AST_Finally({
	                start : start,
	                body  : block_(),
	                end   : prev()
	            });
	        }
	        if (!bcatch && !bfinally)
	            croak("Missing catch/finally blocks");
	        return new AST_Try({
	            body     : body,
	            bcatch   : bcatch,
	            bfinally : bfinally
	        });
	    }

	    /**
	     * var
	     *   vardef1 = 2,
	     *   vardef2 = 3;
	     */
	    function vardefs(no_in, kind) {
	        var var_defs = [];
	        var def;
	        for (;;) {
	            var sym_type =
	                kind === "var" ? AST_SymbolVar :
	                kind === "const" ? AST_SymbolConst :
	                kind === "let" ? AST_SymbolLet : null;
	            // var { a } = b
	            if (is("punc", "{") || is("punc", "[")) {
	                def = new AST_VarDef({
	                    start: S.token,
	                    name: binding_element(undefined, sym_type),
	                    value: is("operator", "=") ? (expect_token("operator", "="), expression(false, no_in)) : null,
	                    end: prev()
	                });
	            } else {
	                def = new AST_VarDef({
	                    start : S.token,
	                    name  : as_symbol(sym_type),
	                    value : is("operator", "=")
	                        ? (next(), expression(false, no_in))
	                        : !no_in && kind === "const"
	                            ? croak("Missing initializer in const declaration") : null,
	                    end   : prev()
	                });
	                if (def.name.name == "import") croak("Unexpected token: import");
	            }
	            var_defs.push(def);
	            if (!is("punc", ","))
	                break;
	            next();
	        }
	        return var_defs;
	    }

	    var var_ = function(no_in) {
	        return new AST_Var({
	            start       : prev(),
	            definitions : vardefs(no_in, "var"),
	            end         : prev()
	        });
	    };

	    var let_ = function(no_in) {
	        return new AST_Let({
	            start       : prev(),
	            definitions : vardefs(no_in, "let"),
	            end         : prev()
	        });
	    };

	    var const_ = function(no_in) {
	        return new AST_Const({
	            start       : prev(),
	            definitions : vardefs(no_in, "const"),
	            end         : prev()
	        });
	    };

	    var new_ = function(allow_calls) {
	        var start = S.token;
	        expect_token("operator", "new");
	        if (is("punc", ".")) {
	            next();
	            expect_token("name", "target");
	            return subscripts(new AST_NewTarget({
	                start : start,
	                end   : prev()
	            }), allow_calls);
	        }
	        var newexp = expr_atom(false), args;
	        if (is("punc", "(")) {
	            next();
	            args = expr_list(")", true);
	        } else {
	            args = [];
	        }
	        var call = new AST_New({
	            start      : start,
	            expression : newexp,
	            args       : args,
	            end        : prev()
	        });
	        annotate(call);
	        return subscripts(call, allow_calls);
	    };

	    function as_atom_node() {
	        var tok = S.token, ret;
	        switch (tok.type) {
	          case "name":
	            ret = _make_symbol(AST_SymbolRef);
	            break;
	          case "num":
	            ret = new AST_Number({
	                start: tok,
	                end: tok,
	                value: tok.value,
	                raw: LATEST_RAW
	            });
	            break;
	          case "big_int":
	            ret = new AST_BigInt({ start: tok, end: tok, value: tok.value });
	            break;
	          case "string":
	            ret = new AST_String({
	                start : tok,
	                end   : tok,
	                value : tok.value,
	                quote : tok.quote
	            });
	            annotate(ret);
	            break;
	          case "regexp":
	            const [_, source, flags] = tok.value.match(/^\/(.*)\/(\w*)$/);

	            ret = new AST_RegExp({ start: tok, end: tok, value: { source, flags } });
	            break;
	          case "atom":
	            switch (tok.value) {
	              case "false":
	                ret = new AST_False({ start: tok, end: tok });
	                break;
	              case "true":
	                ret = new AST_True({ start: tok, end: tok });
	                break;
	              case "null":
	                ret = new AST_Null({ start: tok, end: tok });
	                break;
	            }
	            break;
	        }
	        next();
	        return ret;
	    }

	    function to_fun_args(ex, default_seen_above) {
	        var insert_default = function(ex, default_value) {
	            if (default_value) {
	                return new AST_DefaultAssign({
	                    start: ex.start,
	                    left: ex,
	                    operator: "=",
	                    right: default_value,
	                    end: default_value.end
	                });
	            }
	            return ex;
	        };
	        if (ex instanceof AST_Object) {
	            return insert_default(new AST_Destructuring({
	                start: ex.start,
	                end: ex.end,
	                is_array: false,
	                names: ex.properties.map(prop => to_fun_args(prop))
	            }), default_seen_above);
	        } else if (ex instanceof AST_ObjectKeyVal) {
	            ex.value = to_fun_args(ex.value);
	            return insert_default(ex, default_seen_above);
	        } else if (ex instanceof AST_Hole) {
	            return ex;
	        } else if (ex instanceof AST_Destructuring) {
	            ex.names = ex.names.map(name => to_fun_args(name));
	            return insert_default(ex, default_seen_above);
	        } else if (ex instanceof AST_SymbolRef) {
	            return insert_default(new AST_SymbolFunarg({
	                name: ex.name,
	                start: ex.start,
	                end: ex.end
	            }), default_seen_above);
	        } else if (ex instanceof AST_Expansion) {
	            ex.expression = to_fun_args(ex.expression);
	            return insert_default(ex, default_seen_above);
	        } else if (ex instanceof AST_Array) {
	            return insert_default(new AST_Destructuring({
	                start: ex.start,
	                end: ex.end,
	                is_array: true,
	                names: ex.elements.map(elm => to_fun_args(elm))
	            }), default_seen_above);
	        } else if (ex instanceof AST_Assign) {
	            return insert_default(to_fun_args(ex.left, ex.right), default_seen_above);
	        } else if (ex instanceof AST_DefaultAssign) {
	            ex.left = to_fun_args(ex.left);
	            return ex;
	        } else {
	            croak("Invalid function parameter", ex.start.line, ex.start.col);
	        }
	    }

	    var expr_atom = function(allow_calls, allow_arrows) {
	        if (is("operator", "new")) {
	            return new_(allow_calls);
	        }
	        if (is("name", "import") && is_token(peek(), "punc", ".")) {
	            return import_meta(allow_calls);
	        }
	        var start = S.token;
	        var peeked;
	        var async = is("name", "async")
	            && (peeked = peek()).value != "["
	            && peeked.type != "arrow"
	            && as_atom_node();
	        if (is("punc")) {
	            switch (S.token.value) {
	              case "(":
	                if (async && !allow_calls) break;
	                var exprs = params_or_seq_(allow_arrows, !async);
	                if (allow_arrows && is("arrow", "=>")) {
	                    return arrow_function(start, exprs.map(e => to_fun_args(e)), !!async);
	                }
	                var ex = async ? new AST_Call({
	                    expression: async,
	                    args: exprs
	                }) : to_expr_or_sequence(start, exprs);
	                if (ex.start) {
	                    const outer_comments_before = start.comments_before.length;
	                    outer_comments_before_counts.set(start, outer_comments_before);
	                    ex.start.comments_before.unshift(...start.comments_before);
	                    start.comments_before = ex.start.comments_before;
	                    if (outer_comments_before == 0 && start.comments_before.length > 0) {
	                        var comment = start.comments_before[0];
	                        if (!comment.nlb) {
	                            comment.nlb = start.nlb;
	                            start.nlb = false;
	                        }
	                    }
	                    start.comments_after = ex.start.comments_after;
	                }
	                ex.start = start;
	                var end = prev();
	                if (ex.end) {
	                    end.comments_before = ex.end.comments_before;
	                    ex.end.comments_after.push(...end.comments_after);
	                    end.comments_after = ex.end.comments_after;
	                }
	                ex.end = end;
	                if (ex instanceof AST_Call) annotate(ex);
	                return subscripts(ex, allow_calls);
	              case "[":
	                return subscripts(array_(), allow_calls);
	              case "{":
	                return subscripts(object_or_destructuring_(), allow_calls);
	            }
	            if (!async) unexpected();
	        }
	        if (allow_arrows && is("name") && is_token(peek(), "arrow")) {
	            var param = new AST_SymbolFunarg({
	                name: S.token.value,
	                start: start,
	                end: start,
	            });
	            next();
	            return arrow_function(start, [param], !!async);
	        }
	        if (is("keyword", "function")) {
	            next();
	            var func = function_(AST_Function, false, !!async);
	            func.start = start;
	            func.end = prev();
	            return subscripts(func, allow_calls);
	        }
	        if (async) return subscripts(async, allow_calls);
	        if (is("keyword", "class")) {
	            next();
	            var cls = class_(AST_ClassExpression);
	            cls.start = start;
	            cls.end = prev();
	            return subscripts(cls, allow_calls);
	        }
	        if (is("template_head")) {
	            return subscripts(template_string(), allow_calls);
	        }
	        if (ATOMIC_START_TOKEN.has(S.token.type)) {
	            return subscripts(as_atom_node(), allow_calls);
	        }
	        unexpected();
	    };

	    function template_string() {
	        var segments = [], start = S.token;

	        segments.push(new AST_TemplateSegment({
	            start: S.token,
	            raw: TEMPLATE_RAWS.get(S.token),
	            value: S.token.value,
	            end: S.token
	        }));

	        while (!S.token.template_end) {
	            next();
	            handle_regexp();
	            segments.push(expression(true));

	            segments.push(new AST_TemplateSegment({
	                start: S.token,
	                raw: TEMPLATE_RAWS.get(S.token),
	                value: S.token.value,
	                end: S.token
	            }));
	        }
	        next();

	        return new AST_TemplateString({
	            start: start,
	            segments: segments,
	            end: S.token
	        });
	    }

	    function expr_list(closing, allow_trailing_comma, allow_empty) {
	        var first = true, a = [];
	        while (!is("punc", closing)) {
	            if (first) first = false; else expect(",");
	            if (allow_trailing_comma && is("punc", closing)) break;
	            if (is("punc", ",") && allow_empty) {
	                a.push(new AST_Hole({ start: S.token, end: S.token }));
	            } else if (is("expand", "...")) {
	                next();
	                a.push(new AST_Expansion({start: prev(), expression: expression(),end: S.token}));
	            } else {
	                a.push(expression(false));
	            }
	        }
	        next();
	        return a;
	    }

	    var array_ = embed_tokens(function() {
	        expect("[");
	        return new AST_Array({
	            elements: expr_list("]", !options.strict, true)
	        });
	    });

	    var create_accessor = embed_tokens((is_generator, is_async) => {
	        return function_(AST_Accessor, is_generator, is_async);
	    });

	    var object_or_destructuring_ = embed_tokens(function object_or_destructuring_() {
	        var start = S.token, first = true, a = [];
	        expect("{");
	        while (!is("punc", "}")) {
	            if (first) first = false; else expect(",");
	            if (!options.strict && is("punc", "}"))
	                // allow trailing comma
	                break;

	            start = S.token;
	            if (start.type == "expand") {
	                next();
	                a.push(new AST_Expansion({
	                    start: start,
	                    expression: expression(false),
	                    end: prev(),
	                }));
	                continue;
	            }
	            if(is("privatename")) {
	                croak("private fields are not allowed in an object");
	            }
	            var name = as_property_name();
	            var value;

	            // Check property and fetch value
	            if (!is("punc", ":")) {
	                var concise = concise_method_or_getset(name, start);
	                if (concise) {
	                    a.push(concise);
	                    continue;
	                }

	                value = new AST_SymbolRef({
	                    start: prev(),
	                    name: name,
	                    end: prev()
	                });
	            } else if (name === null) {
	                unexpected(prev());
	            } else {
	                next(); // `:` - see first condition
	                value = expression(false);
	            }

	            // Check for default value and alter value accordingly if necessary
	            if (is("operator", "=")) {
	                next();
	                value = new AST_Assign({
	                    start: start,
	                    left: value,
	                    operator: "=",
	                    right: expression(false),
	                    logical: false,
	                    end: prev()
	                });
	            }

	            // Create property
	            const kv = new AST_ObjectKeyVal({
	                start: start,
	                quote: start.quote,
	                key: name instanceof AST_Node ? name : "" + name,
	                value: value,
	                end: prev()
	            });
	            a.push(annotate(kv));
	        }
	        next();
	        return new AST_Object({ properties: a });
	    });

	    function class_(KindOfClass, is_export_default) {
	        var start, method, class_name, extends_, a = [];

	        S.input.push_directives_stack(); // Push directive stack, but not scope stack
	        S.input.add_directive("use strict");

	        if (S.token.type == "name" && S.token.value != "extends") {
	            class_name = as_symbol(KindOfClass === AST_DefClass ? AST_SymbolDefClass : AST_SymbolClass);
	        }

	        if (KindOfClass === AST_DefClass && !class_name) {
	            if (is_export_default) {
	                KindOfClass = AST_ClassExpression;
	            } else {
	                unexpected();
	            }
	        }

	        if (S.token.value == "extends") {
	            next();
	            extends_ = expression(true);
	        }

	        expect("{");
	        // mark in class feild,
	        const save_in_class = S.in_class;
	        S.in_class = true;
	        while (is("punc", ";")) { next(); }  // Leading semicolons are okay in class bodies.
	        while (!is("punc", "}")) {
	            start = S.token;
	            method = concise_method_or_getset(as_property_name(), start, true);
	            if (!method) { unexpected(); }
	            a.push(method);
	            while (is("punc", ";")) { next(); }
	        }
	        // mark in class feild,
	        S.in_class = save_in_class;

	        S.input.pop_directives_stack();

	        next();

	        return new KindOfClass({
	            start: start,
	            name: class_name,
	            extends: extends_,
	            properties: a,
	            end: prev(),
	        });
	    }

	    function concise_method_or_getset(name, start, is_class) {
	        const get_symbol_ast = (name, SymbolClass = AST_SymbolMethod) => {
	            if (typeof name === "string" || typeof name === "number") {
	                return new SymbolClass({
	                    start,
	                    name: "" + name,
	                    end: prev()
	                });
	            } else if (name === null) {
	                unexpected();
	            }
	            return name;
	        };

	        const is_not_method_start = () =>
	            !is("punc", "(") && !is("punc", ",") && !is("punc", "}") && !is("punc", ";") && !is("operator", "=");

	        var is_async = false;
	        var is_static = false;
	        var is_generator = false;
	        var is_private = false;
	        var accessor_type = null;

	        if (is_class && name === "static" && is_not_method_start()) {
	            const static_block = class_static_block();
	            if (static_block != null) {
	                return static_block;
	            }
	            is_static = true;
	            name = as_property_name();
	        }
	        if (name === "async" && is_not_method_start()) {
	            is_async = true;
	            name = as_property_name();
	        }
	        if (prev().type === "operator" && prev().value === "*") {
	            is_generator = true;
	            name = as_property_name();
	        }
	        if ((name === "get" || name === "set") && is_not_method_start()) {
	            accessor_type = name;
	            name = as_property_name();
	        }
	        if (prev().type === "privatename") {
	            is_private = true;
	        }

	        const property_token = prev();

	        if (accessor_type != null) {
	            if (!is_private) {
	                const AccessorClass = accessor_type === "get"
	                    ? AST_ObjectGetter
	                    : AST_ObjectSetter;

	                name = get_symbol_ast(name);
	                return annotate(new AccessorClass({
	                    start,
	                    static: is_static,
	                    key: name,
	                    quote: name instanceof AST_SymbolMethod ? property_token.quote : undefined,
	                    value: create_accessor(),
	                    end: prev()
	                }));
	            } else {
	                const AccessorClass = accessor_type === "get"
	                    ? AST_PrivateGetter
	                    : AST_PrivateSetter;

	                return annotate(new AccessorClass({
	                    start,
	                    static: is_static,
	                    key: get_symbol_ast(name),
	                    value: create_accessor(),
	                    end: prev(),
	                }));
	            }
	        }

	        if (is("punc", "(")) {
	            name = get_symbol_ast(name);
	            const AST_MethodVariant = is_private
	                ? AST_PrivateMethod
	                : AST_ConciseMethod;
	            var node = new AST_MethodVariant({
	                start       : start,
	                static      : is_static,
	                is_generator: is_generator,
	                async       : is_async,
	                key         : name,
	                quote       : name instanceof AST_SymbolMethod ?
	                              property_token.quote : undefined,
	                value       : create_accessor(is_generator, is_async),
	                end         : prev()
	            });
	            return annotate(node);
	        }

	        if (is_class) {
	            const key = get_symbol_ast(name, AST_SymbolClassProperty);
	            const quote = key instanceof AST_SymbolClassProperty
	                ? property_token.quote
	                : undefined;
	            const AST_ClassPropertyVariant = is_private
	                ? AST_ClassPrivateProperty
	                : AST_ClassProperty;
	            if (is("operator", "=")) {
	                next();
	                return annotate(
	                    new AST_ClassPropertyVariant({
	                        start,
	                        static: is_static,
	                        quote,
	                        key,
	                        value: expression(false),
	                        end: prev()
	                    })
	                );
	            } else if (
	                is("name")
	                || is("privatename")
	                || is("operator", "*")
	                || is("punc", ";")
	                || is("punc", "}")
	            ) {
	                return annotate(
	                    new AST_ClassPropertyVariant({
	                        start,
	                        static: is_static,
	                        quote,
	                        key,
	                        end: prev()
	                    })
	                );
	            }
	        }
	    }

	    function class_static_block() {
	        if (!is("punc", "{")) {
	            return null;
	        }

	        const start = S.token;
	        const body = [];

	        next();

	        while (!is("punc", "}")) {
	            body.push(statement());
	        }

	        next();

	        return new AST_ClassStaticBlock({ start, body, end: prev() });
	    }

	    function maybe_import_assertion() {
	        if (is("name", "assert") && !has_newline_before(S.token)) {
	            next();
	            return object_or_destructuring_();
	        }
	        return null;
	    }

	    function import_statement() {
	        var start = prev();

	        var imported_name;
	        var imported_names;
	        if (is("name")) {
	            imported_name = as_symbol(AST_SymbolImport);
	        }

	        if (is("punc", ",")) {
	            next();
	        }

	        imported_names = map_names(true);

	        if (imported_names || imported_name) {
	            expect_token("name", "from");
	        }
	        var mod_str = S.token;
	        if (mod_str.type !== "string") {
	            unexpected();
	        }
	        next();

	        const assert_clause = maybe_import_assertion();

	        return new AST_Import({
	            start,
	            imported_name,
	            imported_names,
	            module_name: new AST_String({
	                start: mod_str,
	                value: mod_str.value,
	                quote: mod_str.quote,
	                end: mod_str,
	            }),
	            assert_clause,
	            end: S.token,
	        });
	    }

	    function import_meta(allow_calls) {
	        var start = S.token;
	        expect_token("name", "import");
	        expect_token("punc", ".");
	        expect_token("name", "meta");
	        return subscripts(new AST_ImportMeta({
	            start: start,
	            end: prev()
	        }), allow_calls);
	    }

	    function map_name(is_import) {
	        function make_symbol(type, quote) {
	            return new type({
	                name: as_property_name(),
	                quote: quote || undefined,
	                start: prev(),
	                end: prev()
	            });
	        }

	        var foreign_type = is_import ? AST_SymbolImportForeign : AST_SymbolExportForeign;
	        var type = is_import ? AST_SymbolImport : AST_SymbolExport;
	        var start = S.token;
	        var foreign_name;
	        var name;

	        if (is_import) {
	            foreign_name = make_symbol(foreign_type, start.quote);
	        } else {
	            name = make_symbol(type, start.quote);
	        }
	        if (is("name", "as")) {
	            next();  // The "as" word
	            if (is_import) {
	                name = make_symbol(type);
	            } else {
	                foreign_name = make_symbol(foreign_type, S.token.quote);
	            }
	        } else if (is_import) {
	            name = new type(foreign_name);
	        } else {
	            foreign_name = new foreign_type(name);
	        }

	        return new AST_NameMapping({
	            start: start,
	            foreign_name: foreign_name,
	            name: name,
	            end: prev(),
	        });
	    }

	    function map_nameAsterisk(is_import, import_or_export_foreign_name) {
	        var foreign_type = is_import ? AST_SymbolImportForeign : AST_SymbolExportForeign;
	        var type = is_import ? AST_SymbolImport : AST_SymbolExport;
	        var start = S.token;
	        var name, foreign_name;
	        var end = prev();

	        if (is_import) {
	            name = import_or_export_foreign_name;
	        } else {
	            foreign_name = import_or_export_foreign_name;
	        }

	        name = name || new type({
	            start: start,
	            name: "*",
	            end: end,
	        });

	        foreign_name = foreign_name || new foreign_type({
	            start: start,
	            name: "*",
	            end: end,
	        });

	        return new AST_NameMapping({
	            start: start,
	            foreign_name: foreign_name,
	            name: name,
	            end: end,
	        });
	    }

	    function map_names(is_import) {
	        var names;
	        if (is("punc", "{")) {
	            next();
	            names = [];
	            while (!is("punc", "}")) {
	                names.push(map_name(is_import));
	                if (is("punc", ",")) {
	                    next();
	                }
	            }
	            next();
	        } else if (is("operator", "*")) {
	            var name;
	            next();
	            if (is("name", "as")) {
	                next();  // The "as" word
	                name = is_import ? as_symbol(AST_SymbolImport) : as_symbol_or_string(AST_SymbolExportForeign);
	            }
	            names = [map_nameAsterisk(is_import, name)];
	        }
	        return names;
	    }

	    function export_statement() {
	        var start = S.token;
	        var is_default;
	        var exported_names;

	        if (is("keyword", "default")) {
	            is_default = true;
	            next();
	        } else if (exported_names = map_names(false)) {
	            if (is("name", "from")) {
	                next();

	                var mod_str = S.token;
	                if (mod_str.type !== "string") {
	                    unexpected();
	                }
	                next();

	                const assert_clause = maybe_import_assertion();

	                return new AST_Export({
	                    start: start,
	                    is_default: is_default,
	                    exported_names: exported_names,
	                    module_name: new AST_String({
	                        start: mod_str,
	                        value: mod_str.value,
	                        quote: mod_str.quote,
	                        end: mod_str,
	                    }),
	                    end: prev(),
	                    assert_clause
	                });
	            } else {
	                return new AST_Export({
	                    start: start,
	                    is_default: is_default,
	                    exported_names: exported_names,
	                    end: prev(),
	                });
	            }
	        }

	        var node;
	        var exported_value;
	        var exported_definition;
	        if (is("punc", "{")
	            || is_default
	                && (is("keyword", "class") || is("keyword", "function"))
	                && is_token(peek(), "punc")) {
	            exported_value = expression(false);
	            semicolon();
	        } else if ((node = statement(is_default)) instanceof AST_Definitions && is_default) {
	            unexpected(node.start);
	        } else if (
	            node instanceof AST_Definitions
	            || node instanceof AST_Defun
	            || node instanceof AST_DefClass
	        ) {
	            exported_definition = node;
	        } else if (
	            node instanceof AST_ClassExpression
	            || node instanceof AST_Function
	        ) {
	            exported_value = node;
	        } else if (node instanceof AST_SimpleStatement) {
	            exported_value = node.body;
	        } else {
	            unexpected(node.start);
	        }

	        return new AST_Export({
	            start: start,
	            is_default: is_default,
	            exported_value: exported_value,
	            exported_definition: exported_definition,
	            end: prev(),
	            assert_clause: null
	        });
	    }

	    function as_property_name() {
	        var tmp = S.token;
	        switch (tmp.type) {
	          case "punc":
	            if (tmp.value === "[") {
	                next();
	                var ex = expression(false);
	                expect("]");
	                return ex;
	            } else unexpected(tmp);
	          case "operator":
	            if (tmp.value === "*") {
	                next();
	                return null;
	            }
	            if (!["delete", "in", "instanceof", "new", "typeof", "void"].includes(tmp.value)) {
	                unexpected(tmp);
	            }
	            /* falls through */
	          case "name":
	          case "privatename":
	          case "string":
	          case "num":
	          case "big_int":
	          case "keyword":
	          case "atom":
	            next();
	            return tmp.value;
	          default:
	            unexpected(tmp);
	        }
	    }

	    function as_name() {
	        var tmp = S.token;
	        if (tmp.type != "name" && tmp.type != "privatename") unexpected();
	        next();
	        return tmp.value;
	    }

	    function _make_symbol(type) {
	        var name = S.token.value;
	        return new (name == "this" ? AST_This :
	                    name == "super" ? AST_Super :
	                    type)({
	            name  : String(name),
	            start : S.token,
	            end   : S.token
	        });
	    }

	    function _verify_symbol(sym) {
	        var name = sym.name;
	        if (is_in_generator() && name == "yield") {
	            token_error(sym.start, "Yield cannot be used as identifier inside generators");
	        }
	        if (S.input.has_directive("use strict")) {
	            if (name == "yield") {
	                token_error(sym.start, "Unexpected yield identifier inside strict mode");
	            }
	            if (sym instanceof AST_SymbolDeclaration && (name == "arguments" || name == "eval")) {
	                token_error(sym.start, "Unexpected " + name + " in strict mode");
	            }
	        }
	    }

	    function as_symbol(type, noerror) {
	        if (!is("name")) {
	            if (!noerror) croak("Name expected");
	            return null;
	        }
	        var sym = _make_symbol(type);
	        _verify_symbol(sym);
	        next();
	        return sym;
	    }

	    function as_symbol_or_string(type) {
	        if (!is("name")) {
	            if (!is("string")) {
	                croak("Name or string expected");
	            }
	            var tok = S.token;
	            var ret = new type({
	                start : tok,
	                end   : tok,
	                name : tok.value,
	                quote : tok.quote
	            });
	            next();
	            return ret;
	        }
	        var sym = _make_symbol(type);
	        _verify_symbol(sym);
	        next();
	        return sym;
	    }

	    // Annotate AST_Call, AST_Lambda or AST_New with the special comments
	    function annotate(node, before_token = node.start) {
	        var comments = before_token.comments_before;
	        const comments_outside_parens = outer_comments_before_counts.get(before_token);
	        var i = comments_outside_parens != null ? comments_outside_parens : comments.length;
	        while (--i >= 0) {
	            var comment = comments[i];
	            if (/[@#]__/.test(comment.value)) {
	                if (/[@#]__PURE__/.test(comment.value)) {
	                    set_annotation(node, _PURE);
	                    break;
	                }
	                if (/[@#]__INLINE__/.test(comment.value)) {
	                    set_annotation(node, _INLINE);
	                    break;
	                }
	                if (/[@#]__NOINLINE__/.test(comment.value)) {
	                    set_annotation(node, _NOINLINE);
	                    break;
	                }
	                if (/[@#]__KEY__/.test(comment.value)) {
	                    set_annotation(node, _KEY);
	                    break;
	                }
	                if (/[@#]__MANGLE_PROP__/.test(comment.value)) {
	                    set_annotation(node, _MANGLEPROP);
	                    break;
	                }
	            }
	        }
	        return node;
	    }

	    var subscripts = function(expr, allow_calls, is_chain) {
	        var start = expr.start;
	        if (is("punc", ".")) {
	            next();
	            if(is("privatename") && !S.in_class) 
	                croak("Private field must be used in an enclosing class");
	            const AST_DotVariant = is("privatename") ? AST_DotHash : AST_Dot;
	            return annotate(subscripts(new AST_DotVariant({
	                start      : start,
	                expression : expr,
	                optional   : false,
	                property   : as_name(),
	                end        : prev()
	            }), allow_calls, is_chain));
	        }
	        if (is("punc", "[")) {
	            next();
	            var prop = expression(true);
	            expect("]");
	            return annotate(subscripts(new AST_Sub({
	                start      : start,
	                expression : expr,
	                optional   : false,
	                property   : prop,
	                end        : prev()
	            }), allow_calls, is_chain));
	        }
	        if (allow_calls && is("punc", "(")) {
	            next();
	            var call = new AST_Call({
	                start      : start,
	                expression : expr,
	                optional   : false,
	                args       : call_args(),
	                end        : prev()
	            });
	            annotate(call);
	            return subscripts(call, true, is_chain);
	        }

	        if (is("punc", "?.")) {
	            next();

	            let chain_contents;

	            if (allow_calls && is("punc", "(")) {
	                next();

	                const call = new AST_Call({
	                    start,
	                    optional: true,
	                    expression: expr,
	                    args: call_args(),
	                    end: prev()
	                });
	                annotate(call);

	                chain_contents = subscripts(call, true, true);
	            } else if (is("name") || is("privatename")) {
	                if(is("privatename") && !S.in_class) 
	                    croak("Private field must be used in an enclosing class");
	                const AST_DotVariant = is("privatename") ? AST_DotHash : AST_Dot;
	                chain_contents = annotate(subscripts(new AST_DotVariant({
	                    start,
	                    expression: expr,
	                    optional: true,
	                    property: as_name(),
	                    end: prev()
	                }), allow_calls, true));
	            } else if (is("punc", "[")) {
	                next();
	                const property = expression(true);
	                expect("]");
	                chain_contents = annotate(subscripts(new AST_Sub({
	                    start,
	                    expression: expr,
	                    optional: true,
	                    property,
	                    end: prev()
	                }), allow_calls, true));
	            }

	            if (!chain_contents) unexpected();

	            if (chain_contents instanceof AST_Chain) return chain_contents;

	            return new AST_Chain({
	                start,
	                expression: chain_contents,
	                end: prev()
	            });
	        }

	        if (is("template_head")) {
	            if (is_chain) {
	                // a?.b`c` is a syntax error
	                unexpected();
	            }

	            return subscripts(new AST_PrefixedTemplateString({
	                start: start,
	                prefix: expr,
	                template_string: template_string(),
	                end: prev()
	            }), allow_calls);
	        }
	        return expr;
	    };

	    function call_args() {
	        var args = [];
	        while (!is("punc", ")")) {
	            if (is("expand", "...")) {
	                next();
	                args.push(new AST_Expansion({
	                    start: prev(),
	                    expression: expression(false),
	                    end: prev()
	                }));
	            } else {
	                args.push(expression(false));
	            }
	            if (!is("punc", ")")) {
	                expect(",");
	            }
	        }
	        next();
	        return args;
	    }

	    var maybe_unary = function(allow_calls, allow_arrows) {
	        var start = S.token;
	        if (start.type == "name" && start.value == "await" && can_await()) {
	            next();
	            return _await_expression();
	        }
	        if (is("operator") && UNARY_PREFIX.has(start.value)) {
	            next();
	            handle_regexp();
	            var ex = make_unary(AST_UnaryPrefix, start, maybe_unary(allow_calls));
	            ex.start = start;
	            ex.end = prev();
	            return ex;
	        }
	        var val = expr_atom(allow_calls, allow_arrows);
	        while (is("operator") && UNARY_POSTFIX.has(S.token.value) && !has_newline_before(S.token)) {
	            if (val instanceof AST_Arrow) unexpected();
	            val = make_unary(AST_UnaryPostfix, S.token, val);
	            val.start = start;
	            val.end = S.token;
	            next();
	        }
	        return val;
	    };

	    function make_unary(ctor, token, expr) {
	        var op = token.value;
	        switch (op) {
	          case "++":
	          case "--":
	            if (!is_assignable(expr))
	                croak("Invalid use of " + op + " operator", token.line, token.col, token.pos);
	            break;
	          case "delete":
	            if (expr instanceof AST_SymbolRef && S.input.has_directive("use strict"))
	                croak("Calling delete on expression not allowed in strict mode", expr.start.line, expr.start.col, expr.start.pos);
	            break;
	        }
	        return new ctor({ operator: op, expression: expr });
	    }

	    var expr_op = function(left, min_prec, no_in) {
	        var op = is("operator") ? S.token.value : null;
	        if (op == "in" && no_in) op = null;
	        if (op == "**" && left instanceof AST_UnaryPrefix
	            /* unary token in front not allowed - parenthesis required */
	            && !is_token(left.start, "punc", "(")
	            && left.operator !== "--" && left.operator !== "++")
	                unexpected(left.start);
	        var prec = op != null ? PRECEDENCE[op] : null;
	        if (prec != null && (prec > min_prec || (op === "**" && min_prec === prec))) {
	            next();
	            var right = expr_ops(no_in, prec, true);
	            return expr_op(new AST_Binary({
	                start    : left.start,
	                left     : left,
	                operator : op,
	                right    : right,
	                end      : right.end
	            }), min_prec, no_in);
	        }
	        return left;
	    };

	    function expr_ops(no_in, min_prec, allow_calls, allow_arrows) {
	        // maybe_unary won't return us a AST_SymbolPrivateProperty
	        if (!no_in && min_prec < PRECEDENCE["in"] && is("privatename")) {
	            if(!S.in_class) {
	                croak("Private field must be used in an enclosing class");
	            }

	            const start = S.token;
	            const key = new AST_SymbolPrivateProperty({
	                start,
	                name: start.value,
	                end: start
	            });
	            next();
	            expect_token("operator", "in");

	            const private_in = new AST_PrivateIn({
	                start,
	                key,
	                value: expr_ops(no_in, PRECEDENCE["in"], true),
	                end: prev()
	            });

	            return expr_op(private_in, 0, no_in);
	        } else {
	            return expr_op(maybe_unary(allow_calls, allow_arrows), min_prec, no_in);
	        }
	    }

	    var maybe_conditional = function(no_in) {
	        var start = S.token;
	        var expr = expr_ops(no_in, 0, true, true);
	        if (is("operator", "?")) {
	            next();
	            var yes = expression(false);
	            expect(":");
	            return new AST_Conditional({
	                start       : start,
	                condition   : expr,
	                consequent  : yes,
	                alternative : expression(false, no_in),
	                end         : prev()
	            });
	        }
	        return expr;
	    };

	    function is_assignable(expr) {
	        return expr instanceof AST_PropAccess || expr instanceof AST_SymbolRef;
	    }

	    function to_destructuring(node) {
	        if (node instanceof AST_Object) {
	            node = new AST_Destructuring({
	                start: node.start,
	                names: node.properties.map(to_destructuring),
	                is_array: false,
	                end: node.end
	            });
	        } else if (node instanceof AST_Array) {
	            var names = [];

	            for (var i = 0; i < node.elements.length; i++) {
	                // Only allow expansion as last element
	                if (node.elements[i] instanceof AST_Expansion) {
	                    if (i + 1 !== node.elements.length) {
	                        token_error(node.elements[i].start, "Spread must the be last element in destructuring array");
	                    }
	                    node.elements[i].expression = to_destructuring(node.elements[i].expression);
	                }

	                names.push(to_destructuring(node.elements[i]));
	            }

	            node = new AST_Destructuring({
	                start: node.start,
	                names: names,
	                is_array: true,
	                end: node.end
	            });
	        } else if (node instanceof AST_ObjectProperty) {
	            node.value = to_destructuring(node.value);
	        } else if (node instanceof AST_Assign) {
	            node = new AST_DefaultAssign({
	                start: node.start,
	                left: node.left,
	                operator: "=",
	                right: node.right,
	                end: node.end
	            });
	        }
	        return node;
	    }

	    // In ES6, AssignmentExpression can also be an ArrowFunction
	    var maybe_assign = function(no_in) {
	        handle_regexp();
	        var start = S.token;

	        if (start.type == "name" && start.value == "yield") {
	            if (is_in_generator()) {
	                next();
	                return _yield_expression();
	            } else if (S.input.has_directive("use strict")) {
	                token_error(S.token, "Unexpected yield identifier inside strict mode");
	            }
	        }

	        var left = maybe_conditional(no_in);
	        var val = S.token.value;

	        if (is("operator") && ASSIGNMENT.has(val)) {
	            if (is_assignable(left) || (left = to_destructuring(left)) instanceof AST_Destructuring) {
	                next();

	                return new AST_Assign({
	                    start    : start,
	                    left     : left,
	                    operator : val,
	                    right    : maybe_assign(no_in),
	                    logical  : LOGICAL_ASSIGNMENT.has(val),
	                    end      : prev()
	                });
	            }
	            croak("Invalid assignment");
	        }
	        return left;
	    };

	    var to_expr_or_sequence = function(start, exprs) {
	        if (exprs.length === 1) {
	            return exprs[0];
	        } else if (exprs.length > 1) {
	            return new AST_Sequence({ start, expressions: exprs, end: peek() });
	        } else {
	            croak("Invalid parenthesized expression");
	        }
	    };

	    var expression = function(commas, no_in) {
	        var start = S.token;
	        var exprs = [];
	        while (true) {
	            exprs.push(maybe_assign(no_in));
	            if (!commas || !is("punc", ",")) break;
	            next();
	            commas = true;
	        }
	        return to_expr_or_sequence(start, exprs);
	    };

	    function in_loop(cont) {
	        ++S.in_loop;
	        var ret = cont();
	        --S.in_loop;
	        return ret;
	    }

	    if (options.expression) {
	        return expression(true);
	    }

	    return (function parse_toplevel() {
	        var start = S.token;
	        var body = [];
	        S.input.push_directives_stack();
	        if (options.module) S.input.add_directive("use strict");
	        while (!is("eof")) {
	            body.push(statement());
	        }
	        S.input.pop_directives_stack();
	        var end = prev();
	        var toplevel = options.toplevel;
	        if (toplevel) {
	            toplevel.body = toplevel.body.concat(body);
	            toplevel.end = end;
	        } else {
	            toplevel = new AST_Toplevel({ start: start, body: body, end: end });
	        }
	        TEMPLATE_RAWS = new Map();
	        return toplevel;
	    })();

	}

	/***********************************************************************

	  A JavaScript tokenizer / parser / beautifier / compressor.
	  https://github.com/mishoo/UglifyJS2

	  -------------------------------- (C) ---------------------------------

	                           Author: Mihai Bazon
	                         <mihai.bazon@gmail.com>
	                       http://mihai.bazon.net/blog

	  Distributed under the BSD license:

	    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

	    Redistribution and use in source and binary forms, with or without
	    modification, are permitted provided that the following conditions
	    are met:

	        * Redistributions of source code must retain the above
	          copyright notice, this list of conditions and the following
	          disclaimer.

	        * Redistributions in binary form must reproduce the above
	          copyright notice, this list of conditions and the following
	          disclaimer in the documentation and/or other materials
	          provided with the distribution.

	    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
	    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
	    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
	    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
	    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
	    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
	    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
	    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
	    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
	    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
	    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
	    SUCH DAMAGE.

	 ***********************************************************************/

	function DEFNODE(type, props, ctor, methods, base = AST_Node) {
	    if (!props) props = [];
	    else props = props.split(/\s+/);
	    var self_props = props;
	    if (base && base.PROPS)
	        props = props.concat(base.PROPS);
	    const proto = base && Object.create(base.prototype);
	    if (proto) {
	        ctor.prototype = proto;
	        ctor.BASE = base;
	    }
	    if (base) base.SUBCLASSES.push(ctor);
	    ctor.prototype.CTOR = ctor;
	    ctor.prototype.constructor = ctor;
	    ctor.PROPS = props || null;
	    ctor.SELF_PROPS = self_props;
	    ctor.SUBCLASSES = [];
	    if (type) {
	        ctor.prototype.TYPE = ctor.TYPE = type;
	    }
	    if (methods) for (let i in methods) if (HOP(methods, i)) {
	        if (i[0] === "$") {
	            ctor[i.substr(1)] = methods[i];
	        } else {
	            ctor.prototype[i] = methods[i];
	        }
	    }
	    ctor.DEFMETHOD = function(name, method) {
	        this.prototype[name] = method;
	    };
	    return ctor;
	}

	const has_tok_flag = (tok, flag) => Boolean(tok.flags & flag);
	const set_tok_flag = (tok, flag, truth) => {
	    if (truth) {
	        tok.flags |= flag;
	    } else {
	        tok.flags &= ~flag;
	    }
	};

	const TOK_FLAG_NLB          = 0b0001;
	const TOK_FLAG_QUOTE_SINGLE = 0b0010;
	const TOK_FLAG_QUOTE_EXISTS = 0b0100;
	const TOK_FLAG_TEMPLATE_END = 0b1000;

	class AST_Token {
	    constructor(type, value, line, col, pos, nlb, comments_before, comments_after, file) {
	        this.flags = (nlb ? 1 : 0);

	        this.type = type;
	        this.value = value;
	        this.line = line;
	        this.col = col;
	        this.pos = pos;
	        this.comments_before = comments_before;
	        this.comments_after = comments_after;
	        this.file = file;

	        Object.seal(this);
	    }

	    // Return a string summary of the token for node.js console.log
	    [Symbol.for("nodejs.util.inspect.custom")](_depth, options) {
	        const special = str => options.stylize(str, "special");
	        const quote = typeof this.value === "string" && this.value.includes("`") ? "'" : "`";
	        const value = `${quote}${this.value}${quote}`;
	        return `${special("[AST_Token")} ${value} at ${this.line}:${this.col}${special("]")}`;
	    }

	    get nlb() {
	        return has_tok_flag(this, TOK_FLAG_NLB);
	    }

	    set nlb(new_nlb) {
	        set_tok_flag(this, TOK_FLAG_NLB, new_nlb);
	    }

	    get quote() {
	        return !has_tok_flag(this, TOK_FLAG_QUOTE_EXISTS)
	            ? ""
	            : (has_tok_flag(this, TOK_FLAG_QUOTE_SINGLE) ? "'" : '"');
	    }

	    set quote(quote_type) {
	        set_tok_flag(this, TOK_FLAG_QUOTE_SINGLE, quote_type === "'");
	        set_tok_flag(this, TOK_FLAG_QUOTE_EXISTS, !!quote_type);
	    }

	    get template_end() {
	        return has_tok_flag(this, TOK_FLAG_TEMPLATE_END);
	    }

	    set template_end(new_template_end) {
	        set_tok_flag(this, TOK_FLAG_TEMPLATE_END, new_template_end);
	    }
	}

	var AST_Node = DEFNODE("Node", "start end", function AST_Node(props) {
	    if (props) {
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    _clone: function(deep) {
	        if (deep) {
	            var self = this.clone();
	            return self.transform(new TreeTransformer(function(node) {
	                if (node !== self) {
	                    return node.clone(true);
	                }
	            }));
	        }
	        return new this.CTOR(this);
	    },
	    clone: function(deep) {
	        return this._clone(deep);
	    },
	    $documentation: "Base class of all AST nodes",
	    $propdoc: {
	        start: "[AST_Token] The first token of this node",
	        end: "[AST_Token] The last token of this node"
	    },
	    _walk: function(visitor) {
	        return visitor._visit(this);
	    },
	    walk: function(visitor) {
	        return this._walk(visitor); // not sure the indirection will be any help
	    },
	    _children_backwards: () => {}
	}, null);

	/* -----[ statements ]----- */

	var AST_Statement = DEFNODE("Statement", null, function AST_Statement(props) {
	    if (props) {
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "Base class of all statements",
	});

	var AST_Debugger = DEFNODE("Debugger", null, function AST_Debugger(props) {
	    if (props) {
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "Represents a debugger statement",
	}, AST_Statement);

	var AST_Directive = DEFNODE("Directive", "value quote", function AST_Directive(props) {
	    if (props) {
	        this.value = props.value;
	        this.quote = props.quote;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "Represents a directive, like \"use strict\";",
	    $propdoc: {
	        value: "[string] The value of this directive as a plain string (it's not an AST_String!)",
	        quote: "[string] the original quote character"
	    },
	}, AST_Statement);

	var AST_SimpleStatement = DEFNODE("SimpleStatement", "body", function AST_SimpleStatement(props) {
	    if (props) {
	        this.body = props.body;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "A statement consisting of an expression, i.e. a = 1 + 2",
	    $propdoc: {
	        body: "[AST_Node] an expression node (should not be instanceof AST_Statement)"
	    },
	    _walk: function(visitor) {
	        return visitor._visit(this, function() {
	            this.body._walk(visitor);
	        });
	    },
	    _children_backwards(push) {
	        push(this.body);
	    }
	}, AST_Statement);

	function walk_body(node, visitor) {
	    const body = node.body;
	    for (var i = 0, len = body.length; i < len; i++) {
	        body[i]._walk(visitor);
	    }
	}

	function clone_block_scope(deep) {
	    var clone = this._clone(deep);
	    if (this.block_scope) {
	        clone.block_scope = this.block_scope.clone();
	    }
	    return clone;
	}

	var AST_Block = DEFNODE("Block", "body block_scope", function AST_Block(props) {
	    if (props) {
	        this.body = props.body;
	        this.block_scope = props.block_scope;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "A body of statements (usually braced)",
	    $propdoc: {
	        body: "[AST_Statement*] an array of statements",
	        block_scope: "[AST_Scope] the block scope"
	    },
	    _walk: function(visitor) {
	        return visitor._visit(this, function() {
	            walk_body(this, visitor);
	        });
	    },
	    _children_backwards(push) {
	        let i = this.body.length;
	        while (i--) push(this.body[i]);
	    },
	    clone: clone_block_scope
	}, AST_Statement);

	var AST_BlockStatement = DEFNODE("BlockStatement", null, function AST_BlockStatement(props) {
	    if (props) {
	        this.body = props.body;
	        this.block_scope = props.block_scope;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "A block statement",
	}, AST_Block);

	var AST_EmptyStatement = DEFNODE("EmptyStatement", null, function AST_EmptyStatement(props) {
	    if (props) {
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "The empty statement (empty block or simply a semicolon)"
	}, AST_Statement);

	var AST_StatementWithBody = DEFNODE("StatementWithBody", "body", function AST_StatementWithBody(props) {
	    if (props) {
	        this.body = props.body;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "Base class for all statements that contain one nested body: `For`, `ForIn`, `Do`, `While`, `With`",
	    $propdoc: {
	        body: "[AST_Statement] the body; this should always be present, even if it's an AST_EmptyStatement"
	    }
	}, AST_Statement);

	var AST_LabeledStatement = DEFNODE("LabeledStatement", "label", function AST_LabeledStatement(props) {
	    if (props) {
	        this.label = props.label;
	        this.body = props.body;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "Statement with a label",
	    $propdoc: {
	        label: "[AST_Label] a label definition"
	    },
	    _walk: function(visitor) {
	        return visitor._visit(this, function() {
	            this.label._walk(visitor);
	            this.body._walk(visitor);
	        });
	    },
	    _children_backwards(push) {
	        push(this.body);
	        push(this.label);
	    },
	    clone: function(deep) {
	        var node = this._clone(deep);
	        if (deep) {
	            var label = node.label;
	            var def = this.label;
	            node.walk(new TreeWalker(function(node) {
	                if (node instanceof AST_LoopControl
	                    && node.label && node.label.thedef === def) {
	                    node.label.thedef = label;
	                    label.references.push(node);
	                }
	            }));
	        }
	        return node;
	    }
	}, AST_StatementWithBody);

	var AST_IterationStatement = DEFNODE(
	    "IterationStatement",
	    "block_scope",
	    function AST_IterationStatement(props) {
	        if (props) {
	            this.block_scope = props.block_scope;
	            this.body = props.body;
	            this.start = props.start;
	            this.end = props.end;
	        }

	        this.flags = 0;
	    },
	    {
	        $documentation: "Internal class.  All loops inherit from it.",
	        $propdoc: {
	            block_scope: "[AST_Scope] the block scope for this iteration statement."
	        },
	        clone: clone_block_scope
	    },
	    AST_StatementWithBody
	);

	var AST_DWLoop = DEFNODE("DWLoop", "condition", function AST_DWLoop(props) {
	    if (props) {
	        this.condition = props.condition;
	        this.block_scope = props.block_scope;
	        this.body = props.body;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "Base class for do/while statements",
	    $propdoc: {
	        condition: "[AST_Node] the loop condition.  Should not be instanceof AST_Statement"
	    }
	}, AST_IterationStatement);

	var AST_Do = DEFNODE("Do", null, function AST_Do(props) {
	    if (props) {
	        this.condition = props.condition;
	        this.block_scope = props.block_scope;
	        this.body = props.body;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "A `do` statement",
	    _walk: function(visitor) {
	        return visitor._visit(this, function() {
	            this.body._walk(visitor);
	            this.condition._walk(visitor);
	        });
	    },
	    _children_backwards(push) {
	        push(this.condition);
	        push(this.body);
	    }
	}, AST_DWLoop);

	var AST_While = DEFNODE("While", null, function AST_While(props) {
	    if (props) {
	        this.condition = props.condition;
	        this.block_scope = props.block_scope;
	        this.body = props.body;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "A `while` statement",
	    _walk: function(visitor) {
	        return visitor._visit(this, function() {
	            this.condition._walk(visitor);
	            this.body._walk(visitor);
	        });
	    },
	    _children_backwards(push) {
	        push(this.body);
	        push(this.condition);
	    },
	}, AST_DWLoop);

	var AST_For = DEFNODE("For", "init condition step", function AST_For(props) {
	    if (props) {
	        this.init = props.init;
	        this.condition = props.condition;
	        this.step = props.step;
	        this.block_scope = props.block_scope;
	        this.body = props.body;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "A `for` statement",
	    $propdoc: {
	        init: "[AST_Node?] the `for` initialization code, or null if empty",
	        condition: "[AST_Node?] the `for` termination clause, or null if empty",
	        step: "[AST_Node?] the `for` update clause, or null if empty"
	    },
	    _walk: function(visitor) {
	        return visitor._visit(this, function() {
	            if (this.init) this.init._walk(visitor);
	            if (this.condition) this.condition._walk(visitor);
	            if (this.step) this.step._walk(visitor);
	            this.body._walk(visitor);
	        });
	    },
	    _children_backwards(push) {
	        push(this.body);
	        if (this.step) push(this.step);
	        if (this.condition) push(this.condition);
	        if (this.init) push(this.init);
	    },
	}, AST_IterationStatement);

	var AST_ForIn = DEFNODE("ForIn", "init object", function AST_ForIn(props) {
	    if (props) {
	        this.init = props.init;
	        this.object = props.object;
	        this.block_scope = props.block_scope;
	        this.body = props.body;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "A `for ... in` statement",
	    $propdoc: {
	        init: "[AST_Node] the `for/in` initialization code",
	        object: "[AST_Node] the object that we're looping through"
	    },
	    _walk: function(visitor) {
	        return visitor._visit(this, function() {
	            this.init._walk(visitor);
	            this.object._walk(visitor);
	            this.body._walk(visitor);
	        });
	    },
	    _children_backwards(push) {
	        push(this.body);
	        if (this.object) push(this.object);
	        if (this.init) push(this.init);
	    },
	}, AST_IterationStatement);

	var AST_ForOf = DEFNODE("ForOf", "await", function AST_ForOf(props) {
	    if (props) {
	        this.await = props.await;
	        this.init = props.init;
	        this.object = props.object;
	        this.block_scope = props.block_scope;
	        this.body = props.body;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "A `for ... of` statement",
	}, AST_ForIn);

	var AST_With = DEFNODE("With", "expression", function AST_With(props) {
	    if (props) {
	        this.expression = props.expression;
	        this.body = props.body;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "A `with` statement",
	    $propdoc: {
	        expression: "[AST_Node] the `with` expression"
	    },
	    _walk: function(visitor) {
	        return visitor._visit(this, function() {
	            this.expression._walk(visitor);
	            this.body._walk(visitor);
	        });
	    },
	    _children_backwards(push) {
	        push(this.body);
	        push(this.expression);
	    },
	}, AST_StatementWithBody);

	/* -----[ scope and functions ]----- */

	var AST_Scope = DEFNODE(
	    "Scope",
	    "variables uses_with uses_eval parent_scope enclosed cname",
	    function AST_Scope(props) {
	        if (props) {
	            this.variables = props.variables;
	            this.uses_with = props.uses_with;
	            this.uses_eval = props.uses_eval;
	            this.parent_scope = props.parent_scope;
	            this.enclosed = props.enclosed;
	            this.cname = props.cname;
	            this.body = props.body;
	            this.block_scope = props.block_scope;
	            this.start = props.start;
	            this.end = props.end;
	        }

	        this.flags = 0;
	    },
	    {
	        $documentation: "Base class for all statements introducing a lexical scope",
	        $propdoc: {
	            variables: "[Map/S] a map of name -> SymbolDef for all variables/functions defined in this scope",
	            uses_with: "[boolean/S] tells whether this scope uses the `with` statement",
	            uses_eval: "[boolean/S] tells whether this scope contains a direct call to the global `eval`",
	            parent_scope: "[AST_Scope?/S] link to the parent scope",
	            enclosed: "[SymbolDef*/S] a list of all symbol definitions that are accessed from this scope or any subscopes",
	            cname: "[integer/S] current index for mangling variables (used internally by the mangler)",
	        },
	        get_defun_scope: function() {
	            var self = this;
	            while (self.is_block_scope()) {
	                self = self.parent_scope;
	            }
	            return self;
	        },
	        clone: function(deep, toplevel) {
	            var node = this._clone(deep);
	            if (deep && this.variables && toplevel && !this._block_scope) {
	                node.figure_out_scope({}, {
	                    toplevel: toplevel,
	                    parent_scope: this.parent_scope
	                });
	            } else {
	                if (this.variables) node.variables = new Map(this.variables);
	                if (this.enclosed) node.enclosed = this.enclosed.slice();
	                if (this._block_scope) node._block_scope = this._block_scope;
	            }
	            return node;
	        },
	        pinned: function() {
	            return this.uses_eval || this.uses_with;
	        }
	    },
	    AST_Block
	);

	var AST_Toplevel = DEFNODE("Toplevel", "globals", function AST_Toplevel(props) {
	    if (props) {
	        this.globals = props.globals;
	        this.variables = props.variables;
	        this.uses_with = props.uses_with;
	        this.uses_eval = props.uses_eval;
	        this.parent_scope = props.parent_scope;
	        this.enclosed = props.enclosed;
	        this.cname = props.cname;
	        this.body = props.body;
	        this.block_scope = props.block_scope;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "The toplevel scope",
	    $propdoc: {
	        globals: "[Map/S] a map of name -> SymbolDef for all undeclared names",
	    },
	    wrap_commonjs: function(name) {
	        var body = this.body;
	        var wrapped_tl = "(function(exports){'$ORIG';})(typeof " + name + "=='undefined'?(" + name + "={}):" + name + ");";
	        wrapped_tl = parse(wrapped_tl);
	        wrapped_tl = wrapped_tl.transform(new TreeTransformer(function(node) {
	            if (node instanceof AST_Directive && node.value == "$ORIG") {
	                return MAP.splice(body);
	            }
	        }));
	        return wrapped_tl;
	    },
	    wrap_enclose: function(args_values) {
	        if (typeof args_values != "string") args_values = "";
	        var index = args_values.indexOf(":");
	        if (index < 0) index = args_values.length;
	        var body = this.body;
	        return parse([
	            "(function(",
	            args_values.slice(0, index),
	            '){"$ORIG"})(',
	            args_values.slice(index + 1),
	            ")"
	        ].join("")).transform(new TreeTransformer(function(node) {
	            if (node instanceof AST_Directive && node.value == "$ORIG") {
	                return MAP.splice(body);
	            }
	        }));
	    }
	}, AST_Scope);

	var AST_Expansion = DEFNODE("Expansion", "expression", function AST_Expansion(props) {
	    if (props) {
	        this.expression = props.expression;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "An expandible argument, such as ...rest, a splat, such as [1,2,...all], or an expansion in a variable declaration, such as var [first, ...rest] = list",
	    $propdoc: {
	        expression: "[AST_Node] the thing to be expanded"
	    },
	    _walk: function(visitor) {
	        return visitor._visit(this, function() {
	            this.expression.walk(visitor);
	        });
	    },
	    _children_backwards(push) {
	        push(this.expression);
	    },
	});

	var AST_Lambda = DEFNODE(
	    "Lambda",
	    "name argnames uses_arguments is_generator async",
	    function AST_Lambda(props) {
	        if (props) {
	            this.name = props.name;
	            this.argnames = props.argnames;
	            this.uses_arguments = props.uses_arguments;
	            this.is_generator = props.is_generator;
	            this.async = props.async;
	            this.variables = props.variables;
	            this.uses_with = props.uses_with;
	            this.uses_eval = props.uses_eval;
	            this.parent_scope = props.parent_scope;
	            this.enclosed = props.enclosed;
	            this.cname = props.cname;
	            this.body = props.body;
	            this.block_scope = props.block_scope;
	            this.start = props.start;
	            this.end = props.end;
	        }

	        this.flags = 0;
	    },
	    {
	        $documentation: "Base class for functions",
	        $propdoc: {
	            name: "[AST_SymbolDeclaration?] the name of this function",
	            argnames: "[AST_SymbolFunarg|AST_Destructuring|AST_Expansion|AST_DefaultAssign*] array of function arguments, destructurings, or expanding arguments",
	            uses_arguments: "[boolean/S] tells whether this function accesses the arguments array",
	            is_generator: "[boolean] is this a generator method",
	            async: "[boolean] is this method async",
	        },
	        args_as_names: function () {
	            var out = [];
	            for (var i = 0; i < this.argnames.length; i++) {
	                if (this.argnames[i] instanceof AST_Destructuring) {
	                    out.push(...this.argnames[i].all_symbols());
	                } else {
	                    out.push(this.argnames[i]);
	                }
	            }
	            return out;
	        },
	        _walk: function(visitor) {
	            return visitor._visit(this, function() {
	                if (this.name) this.name._walk(visitor);
	                var argnames = this.argnames;
	                for (var i = 0, len = argnames.length; i < len; i++) {
	                    argnames[i]._walk(visitor);
	                }
	                walk_body(this, visitor);
	            });
	        },
	        _children_backwards(push) {
	            let i = this.body.length;
	            while (i--) push(this.body[i]);

	            i = this.argnames.length;
	            while (i--) push(this.argnames[i]);

	            if (this.name) push(this.name);
	        },
	        is_braceless() {
	            return this.body[0] instanceof AST_Return && this.body[0].value;
	        },
	        // Default args and expansion don't count, so .argnames.length doesn't cut it
	        length_property() {
	            let length = 0;

	            for (const arg of this.argnames) {
	                if (arg instanceof AST_SymbolFunarg || arg instanceof AST_Destructuring) {
	                    length++;
	                }
	            }

	            return length;
	        }
	    },
	    AST_Scope
	);

	var AST_Accessor = DEFNODE("Accessor", null, function AST_Accessor(props) {
	    if (props) {
	        this.name = props.name;
	        this.argnames = props.argnames;
	        this.uses_arguments = props.uses_arguments;
	        this.is_generator = props.is_generator;
	        this.async = props.async;
	        this.variables = props.variables;
	        this.uses_with = props.uses_with;
	        this.uses_eval = props.uses_eval;
	        this.parent_scope = props.parent_scope;
	        this.enclosed = props.enclosed;
	        this.cname = props.cname;
	        this.body = props.body;
	        this.block_scope = props.block_scope;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "A setter/getter function.  The `name` property is always null."
	}, AST_Lambda);

	var AST_Function = DEFNODE("Function", null, function AST_Function(props) {
	    if (props) {
	        this.name = props.name;
	        this.argnames = props.argnames;
	        this.uses_arguments = props.uses_arguments;
	        this.is_generator = props.is_generator;
	        this.async = props.async;
	        this.variables = props.variables;
	        this.uses_with = props.uses_with;
	        this.uses_eval = props.uses_eval;
	        this.parent_scope = props.parent_scope;
	        this.enclosed = props.enclosed;
	        this.cname = props.cname;
	        this.body = props.body;
	        this.block_scope = props.block_scope;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "A function expression"
	}, AST_Lambda);

	var AST_Arrow = DEFNODE("Arrow", null, function AST_Arrow(props) {
	    if (props) {
	        this.name = props.name;
	        this.argnames = props.argnames;
	        this.uses_arguments = props.uses_arguments;
	        this.is_generator = props.is_generator;
	        this.async = props.async;
	        this.variables = props.variables;
	        this.uses_with = props.uses_with;
	        this.uses_eval = props.uses_eval;
	        this.parent_scope = props.parent_scope;
	        this.enclosed = props.enclosed;
	        this.cname = props.cname;
	        this.body = props.body;
	        this.block_scope = props.block_scope;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "An ES6 Arrow function ((a) => b)"
	}, AST_Lambda);

	var AST_Defun = DEFNODE("Defun", null, function AST_Defun(props) {
	    if (props) {
	        this.name = props.name;
	        this.argnames = props.argnames;
	        this.uses_arguments = props.uses_arguments;
	        this.is_generator = props.is_generator;
	        this.async = props.async;
	        this.variables = props.variables;
	        this.uses_with = props.uses_with;
	        this.uses_eval = props.uses_eval;
	        this.parent_scope = props.parent_scope;
	        this.enclosed = props.enclosed;
	        this.cname = props.cname;
	        this.body = props.body;
	        this.block_scope = props.block_scope;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "A function definition"
	}, AST_Lambda);

	/* -----[ DESTRUCTURING ]----- */
	var AST_Destructuring = DEFNODE("Destructuring", "names is_array", function AST_Destructuring(props) {
	    if (props) {
	        this.names = props.names;
	        this.is_array = props.is_array;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "A destructuring of several names. Used in destructuring assignment and with destructuring function argument names",
	    $propdoc: {
	        "names": "[AST_Node*] Array of properties or elements",
	        "is_array": "[Boolean] Whether the destructuring represents an object or array"
	    },
	    _walk: function(visitor) {
	        return visitor._visit(this, function() {
	            this.names.forEach(function(name) {
	                name._walk(visitor);
	            });
	        });
	    },
	    _children_backwards(push) {
	        let i = this.names.length;
	        while (i--) push(this.names[i]);
	    },
	    all_symbols: function() {
	        var out = [];
	        walk(this, node => {
	            if (node instanceof AST_SymbolDeclaration) {
	                out.push(node);
	            }
	            if (node instanceof AST_Lambda) {
	                return true;
	            }
	        });
	        return out;
	    }
	});

	var AST_PrefixedTemplateString = DEFNODE(
	    "PrefixedTemplateString",
	    "template_string prefix",
	    function AST_PrefixedTemplateString(props) {
	        if (props) {
	            this.template_string = props.template_string;
	            this.prefix = props.prefix;
	            this.start = props.start;
	            this.end = props.end;
	        }

	        this.flags = 0;
	    },
	    {
	        $documentation: "A templatestring with a prefix, such as String.raw`foobarbaz`",
	        $propdoc: {
	            template_string: "[AST_TemplateString] The template string",
	            prefix: "[AST_Node] The prefix, which will get called."
	        },
	        _walk: function(visitor) {
	            return visitor._visit(this, function () {
	                this.prefix._walk(visitor);
	                this.template_string._walk(visitor);
	            });
	        },
	        _children_backwards(push) {
	            push(this.template_string);
	            push(this.prefix);
	        },
	    }
	);

	var AST_TemplateString = DEFNODE("TemplateString", "segments", function AST_TemplateString(props) {
	    if (props) {
	        this.segments = props.segments;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "A template string literal",
	    $propdoc: {
	        segments: "[AST_Node*] One or more segments, starting with AST_TemplateSegment. AST_Node may follow AST_TemplateSegment, but each AST_Node must be followed by AST_TemplateSegment."
	    },
	    _walk: function(visitor) {
	        return visitor._visit(this, function() {
	            this.segments.forEach(function(seg) {
	                seg._walk(visitor);
	            });
	        });
	    },
	    _children_backwards(push) {
	        let i = this.segments.length;
	        while (i--) push(this.segments[i]);
	    }
	});

	var AST_TemplateSegment = DEFNODE("TemplateSegment", "value raw", function AST_TemplateSegment(props) {
	    if (props) {
	        this.value = props.value;
	        this.raw = props.raw;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "A segment of a template string literal",
	    $propdoc: {
	        value: "Content of the segment",
	        raw: "Raw source of the segment",
	    }
	});

	/* -----[ JUMPS ]----- */

	var AST_Jump = DEFNODE("Jump", null, function AST_Jump(props) {
	    if (props) {
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "Base class for “jumps” (for now that's `return`, `throw`, `break` and `continue`)"
	}, AST_Statement);

	/** Base class for “exits” (`return` and `throw`) */
	var AST_Exit = DEFNODE("Exit", "value", function AST_Exit(props) {
	    if (props) {
	        this.value = props.value;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "Base class for “exits” (`return` and `throw`)",
	    $propdoc: {
	        value: "[AST_Node?] the value returned or thrown by this statement; could be null for AST_Return"
	    },
	    _walk: function(visitor) {
	        return visitor._visit(this, this.value && function() {
	            this.value._walk(visitor);
	        });
	    },
	    _children_backwards(push) {
	        if (this.value) push(this.value);
	    },
	}, AST_Jump);

	var AST_Return = DEFNODE("Return", null, function AST_Return(props) {
	    if (props) {
	        this.value = props.value;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "A `return` statement"
	}, AST_Exit);

	var AST_Throw = DEFNODE("Throw", null, function AST_Throw(props) {
	    if (props) {
	        this.value = props.value;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "A `throw` statement"
	}, AST_Exit);

	var AST_LoopControl = DEFNODE("LoopControl", "label", function AST_LoopControl(props) {
	    if (props) {
	        this.label = props.label;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "Base class for loop control statements (`break` and `continue`)",
	    $propdoc: {
	        label: "[AST_LabelRef?] the label, or null if none",
	    },
	    _walk: function(visitor) {
	        return visitor._visit(this, this.label && function() {
	            this.label._walk(visitor);
	        });
	    },
	    _children_backwards(push) {
	        if (this.label) push(this.label);
	    },
	}, AST_Jump);

	var AST_Break = DEFNODE("Break", null, function AST_Break(props) {
	    if (props) {
	        this.label = props.label;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "A `break` statement"
	}, AST_LoopControl);

	var AST_Continue = DEFNODE("Continue", null, function AST_Continue(props) {
	    if (props) {
	        this.label = props.label;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "A `continue` statement"
	}, AST_LoopControl);

	var AST_Await = DEFNODE("Await", "expression", function AST_Await(props) {
	    if (props) {
	        this.expression = props.expression;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "An `await` statement",
	    $propdoc: {
	        expression: "[AST_Node] the mandatory expression being awaited",
	    },
	    _walk: function(visitor) {
	        return visitor._visit(this, function() {
	            this.expression._walk(visitor);
	        });
	    },
	    _children_backwards(push) {
	        push(this.expression);
	    },
	});

	var AST_Yield = DEFNODE("Yield", "expression is_star", function AST_Yield(props) {
	    if (props) {
	        this.expression = props.expression;
	        this.is_star = props.is_star;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "A `yield` statement",
	    $propdoc: {
	        expression: "[AST_Node?] the value returned or thrown by this statement; could be null (representing undefined) but only when is_star is set to false",
	        is_star: "[Boolean] Whether this is a yield or yield* statement"
	    },
	    _walk: function(visitor) {
	        return visitor._visit(this, this.expression && function() {
	            this.expression._walk(visitor);
	        });
	    },
	    _children_backwards(push) {
	        if (this.expression) push(this.expression);
	    }
	});

	/* -----[ IF ]----- */

	var AST_If = DEFNODE("If", "condition alternative", function AST_If(props) {
	    if (props) {
	        this.condition = props.condition;
	        this.alternative = props.alternative;
	        this.body = props.body;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "A `if` statement",
	    $propdoc: {
	        condition: "[AST_Node] the `if` condition",
	        alternative: "[AST_Statement?] the `else` part, or null if not present"
	    },
	    _walk: function(visitor) {
	        return visitor._visit(this, function() {
	            this.condition._walk(visitor);
	            this.body._walk(visitor);
	            if (this.alternative) this.alternative._walk(visitor);
	        });
	    },
	    _children_backwards(push) {
	        if (this.alternative) {
	            push(this.alternative);
	        }
	        push(this.body);
	        push(this.condition);
	    }
	}, AST_StatementWithBody);

	/* -----[ SWITCH ]----- */

	var AST_Switch = DEFNODE("Switch", "expression", function AST_Switch(props) {
	    if (props) {
	        this.expression = props.expression;
	        this.body = props.body;
	        this.block_scope = props.block_scope;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "A `switch` statement",
	    $propdoc: {
	        expression: "[AST_Node] the `switch` “discriminant”"
	    },
	    _walk: function(visitor) {
	        return visitor._visit(this, function() {
	            this.expression._walk(visitor);
	            walk_body(this, visitor);
	        });
	    },
	    _children_backwards(push) {
	        let i = this.body.length;
	        while (i--) push(this.body[i]);
	        push(this.expression);
	    }
	}, AST_Block);

	var AST_SwitchBranch = DEFNODE("SwitchBranch", null, function AST_SwitchBranch(props) {
	    if (props) {
	        this.body = props.body;
	        this.block_scope = props.block_scope;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "Base class for `switch` branches",
	}, AST_Block);

	var AST_Default = DEFNODE("Default", null, function AST_Default(props) {
	    if (props) {
	        this.body = props.body;
	        this.block_scope = props.block_scope;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "A `default` switch branch",
	}, AST_SwitchBranch);

	var AST_Case = DEFNODE("Case", "expression", function AST_Case(props) {
	    if (props) {
	        this.expression = props.expression;
	        this.body = props.body;
	        this.block_scope = props.block_scope;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "A `case` switch branch",
	    $propdoc: {
	        expression: "[AST_Node] the `case` expression"
	    },
	    _walk: function(visitor) {
	        return visitor._visit(this, function() {
	            this.expression._walk(visitor);
	            walk_body(this, visitor);
	        });
	    },
	    _children_backwards(push) {
	        let i = this.body.length;
	        while (i--) push(this.body[i]);
	        push(this.expression);
	    },
	}, AST_SwitchBranch);

	/* -----[ EXCEPTIONS ]----- */

	var AST_Try = DEFNODE("Try", "body bcatch bfinally", function AST_Try(props) {
	    if (props) {
	        this.body = props.body;
	        this.bcatch = props.bcatch;
	        this.bfinally = props.bfinally;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "A `try` statement",
	    $propdoc: {
	        body: "[AST_TryBlock] the try block",
	        bcatch: "[AST_Catch?] the catch block, or null if not present",
	        bfinally: "[AST_Finally?] the finally block, or null if not present"
	    },
	    _walk: function(visitor) {
	        return visitor._visit(this, function() {
	            this.body._walk(visitor);
	            if (this.bcatch) this.bcatch._walk(visitor);
	            if (this.bfinally) this.bfinally._walk(visitor);
	        });
	    },
	    _children_backwards(push) {
	        if (this.bfinally) push(this.bfinally);
	        if (this.bcatch) push(this.bcatch);
	        push(this.body);
	    },
	}, AST_Statement);

	var AST_TryBlock = DEFNODE("TryBlock", null, function AST_TryBlock(props) {
	    if (props) {
	        this.body = props.body;
	        this.block_scope = props.block_scope;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "The `try` block of a try statement"
	}, AST_Block);

	var AST_Catch = DEFNODE("Catch", "argname", function AST_Catch(props) {
	    if (props) {
	        this.argname = props.argname;
	        this.body = props.body;
	        this.block_scope = props.block_scope;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "A `catch` node; only makes sense as part of a `try` statement",
	    $propdoc: {
	        argname: "[AST_SymbolCatch|AST_Destructuring|AST_Expansion|AST_DefaultAssign] symbol for the exception"
	    },
	    _walk: function(visitor) {
	        return visitor._visit(this, function() {
	            if (this.argname) this.argname._walk(visitor);
	            walk_body(this, visitor);
	        });
	    },
	    _children_backwards(push) {
	        let i = this.body.length;
	        while (i--) push(this.body[i]);
	        if (this.argname) push(this.argname);
	    },
	}, AST_Block);

	var AST_Finally = DEFNODE("Finally", null, function AST_Finally(props) {
	    if (props) {
	        this.body = props.body;
	        this.block_scope = props.block_scope;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "A `finally` node; only makes sense as part of a `try` statement"
	}, AST_Block);

	/* -----[ VAR/CONST ]----- */

	var AST_Definitions = DEFNODE("Definitions", "definitions", function AST_Definitions(props) {
	    if (props) {
	        this.definitions = props.definitions;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "Base class for `var` or `const` nodes (variable declarations/initializations)",
	    $propdoc: {
	        definitions: "[AST_VarDef*] array of variable definitions"
	    },
	    _walk: function(visitor) {
	        return visitor._visit(this, function() {
	            var definitions = this.definitions;
	            for (var i = 0, len = definitions.length; i < len; i++) {
	                definitions[i]._walk(visitor);
	            }
	        });
	    },
	    _children_backwards(push) {
	        let i = this.definitions.length;
	        while (i--) push(this.definitions[i]);
	    },
	}, AST_Statement);

	var AST_Var = DEFNODE("Var", null, function AST_Var(props) {
	    if (props) {
	        this.definitions = props.definitions;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "A `var` statement"
	}, AST_Definitions);

	var AST_Let = DEFNODE("Let", null, function AST_Let(props) {
	    if (props) {
	        this.definitions = props.definitions;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "A `let` statement"
	}, AST_Definitions);

	var AST_Const = DEFNODE("Const", null, function AST_Const(props) {
	    if (props) {
	        this.definitions = props.definitions;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "A `const` statement"
	}, AST_Definitions);

	var AST_VarDef = DEFNODE("VarDef", "name value", function AST_VarDef(props) {
	    if (props) {
	        this.name = props.name;
	        this.value = props.value;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "A variable declaration; only appears in a AST_Definitions node",
	    $propdoc: {
	        name: "[AST_Destructuring|AST_SymbolConst|AST_SymbolLet|AST_SymbolVar] name of the variable",
	        value: "[AST_Node?] initializer, or null of there's no initializer"
	    },
	    _walk: function(visitor) {
	        return visitor._visit(this, function() {
	            this.name._walk(visitor);
	            if (this.value) this.value._walk(visitor);
	        });
	    },
	    _children_backwards(push) {
	        if (this.value) push(this.value);
	        push(this.name);
	    },
	    declarations_as_names() {
	        if (this.name instanceof AST_SymbolDeclaration) {
	            return [this];
	        } else {
	            return this.name.all_symbols();
	        }
	    }
	});

	var AST_NameMapping = DEFNODE("NameMapping", "foreign_name name", function AST_NameMapping(props) {
	    if (props) {
	        this.foreign_name = props.foreign_name;
	        this.name = props.name;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "The part of the export/import statement that declare names from a module.",
	    $propdoc: {
	        foreign_name: "[AST_SymbolExportForeign|AST_SymbolImportForeign] The name being exported/imported (as specified in the module)",
	        name: "[AST_SymbolExport|AST_SymbolImport] The name as it is visible to this module."
	    },
	    _walk: function (visitor) {
	        return visitor._visit(this, function() {
	            this.foreign_name._walk(visitor);
	            this.name._walk(visitor);
	        });
	    },
	    _children_backwards(push) {
	        push(this.name);
	        push(this.foreign_name);
	    },
	});

	var AST_Import = DEFNODE(
	    "Import",
	    "imported_name imported_names module_name assert_clause",
	    function AST_Import(props) {
	        if (props) {
	            this.imported_name = props.imported_name;
	            this.imported_names = props.imported_names;
	            this.module_name = props.module_name;
	            this.assert_clause = props.assert_clause;
	            this.start = props.start;
	            this.end = props.end;
	        }

	        this.flags = 0;
	    },
	    {
	        $documentation: "An `import` statement",
	        $propdoc: {
	            imported_name: "[AST_SymbolImport] The name of the variable holding the module's default export.",
	            imported_names: "[AST_NameMapping*] The names of non-default imported variables",
	            module_name: "[AST_String] String literal describing where this module came from",
	            assert_clause: "[AST_Object?] The import assertion"
	        },
	        _walk: function(visitor) {
	            return visitor._visit(this, function() {
	                if (this.imported_name) {
	                    this.imported_name._walk(visitor);
	                }
	                if (this.imported_names) {
	                    this.imported_names.forEach(function(name_import) {
	                        name_import._walk(visitor);
	                    });
	                }
	                this.module_name._walk(visitor);
	            });
	        },
	        _children_backwards(push) {
	            push(this.module_name);
	            if (this.imported_names) {
	                let i = this.imported_names.length;
	                while (i--) push(this.imported_names[i]);
	            }
	            if (this.imported_name) push(this.imported_name);
	        },
	    }
	);

	var AST_ImportMeta = DEFNODE("ImportMeta", null, function AST_ImportMeta(props) {
	    if (props) {
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "A reference to import.meta",
	});

	var AST_Export = DEFNODE(
	    "Export",
	    "exported_definition exported_value is_default exported_names module_name assert_clause",
	    function AST_Export(props) {
	        if (props) {
	            this.exported_definition = props.exported_definition;
	            this.exported_value = props.exported_value;
	            this.is_default = props.is_default;
	            this.exported_names = props.exported_names;
	            this.module_name = props.module_name;
	            this.assert_clause = props.assert_clause;
	            this.start = props.start;
	            this.end = props.end;
	        }

	        this.flags = 0;
	    },
	    {
	        $documentation: "An `export` statement",
	        $propdoc: {
	            exported_definition: "[AST_Defun|AST_Definitions|AST_DefClass?] An exported definition",
	            exported_value: "[AST_Node?] An exported value",
	            exported_names: "[AST_NameMapping*?] List of exported names",
	            module_name: "[AST_String?] Name of the file to load exports from",
	            is_default: "[Boolean] Whether this is the default exported value of this module",
	            assert_clause: "[AST_Object?] The import assertion"
	        },
	        _walk: function (visitor) {
	            return visitor._visit(this, function () {
	                if (this.exported_definition) {
	                    this.exported_definition._walk(visitor);
	                }
	                if (this.exported_value) {
	                    this.exported_value._walk(visitor);
	                }
	                if (this.exported_names) {
	                    this.exported_names.forEach(function(name_export) {
	                        name_export._walk(visitor);
	                    });
	                }
	                if (this.module_name) {
	                    this.module_name._walk(visitor);
	                }
	            });
	        },
	        _children_backwards(push) {
	            if (this.module_name) push(this.module_name);
	            if (this.exported_names) {
	                let i = this.exported_names.length;
	                while (i--) push(this.exported_names[i]);
	            }
	            if (this.exported_value) push(this.exported_value);
	            if (this.exported_definition) push(this.exported_definition);
	        }
	    },
	    AST_Statement
	);

	/* -----[ OTHER ]----- */

	var AST_Call = DEFNODE(
	    "Call",
	    "expression args optional _annotations",
	    function AST_Call(props) {
	        if (props) {
	            this.expression = props.expression;
	            this.args = props.args;
	            this.optional = props.optional;
	            this._annotations = props._annotations;
	            this.start = props.start;
	            this.end = props.end;
	            this.initialize();
	        }

	        this.flags = 0;
	    },
	    {
	        $documentation: "A function call expression",
	        $propdoc: {
	            expression: "[AST_Node] expression to invoke as function",
	            args: "[AST_Node*] array of arguments",
	            optional: "[boolean] whether this is an optional call (IE ?.() )",
	            _annotations: "[number] bitfield containing information about the call"
	        },
	        initialize() {
	            if (this._annotations == null) this._annotations = 0;
	        },
	        _walk(visitor) {
	            return visitor._visit(this, function() {
	                var args = this.args;
	                for (var i = 0, len = args.length; i < len; i++) {
	                    args[i]._walk(visitor);
	                }
	                this.expression._walk(visitor);  // TODO why do we need to crawl this last?
	            });
	        },
	        _children_backwards(push) {
	            let i = this.args.length;
	            while (i--) push(this.args[i]);
	            push(this.expression);
	        },
	    }
	);

	var AST_New = DEFNODE("New", null, function AST_New(props) {
	    if (props) {
	        this.expression = props.expression;
	        this.args = props.args;
	        this.optional = props.optional;
	        this._annotations = props._annotations;
	        this.start = props.start;
	        this.end = props.end;
	        this.initialize();
	    }

	    this.flags = 0;
	}, {
	    $documentation: "An object instantiation.  Derives from a function call since it has exactly the same properties"
	}, AST_Call);

	var AST_Sequence = DEFNODE("Sequence", "expressions", function AST_Sequence(props) {
	    if (props) {
	        this.expressions = props.expressions;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "A sequence expression (comma-separated expressions)",
	    $propdoc: {
	        expressions: "[AST_Node*] array of expressions (at least two)"
	    },
	    _walk: function(visitor) {
	        return visitor._visit(this, function() {
	            this.expressions.forEach(function(node) {
	                node._walk(visitor);
	            });
	        });
	    },
	    _children_backwards(push) {
	        let i = this.expressions.length;
	        while (i--) push(this.expressions[i]);
	    },
	});

	var AST_PropAccess = DEFNODE(
	    "PropAccess",
	    "expression property optional",
	    function AST_PropAccess(props) {
	        if (props) {
	            this.expression = props.expression;
	            this.property = props.property;
	            this.optional = props.optional;
	            this.start = props.start;
	            this.end = props.end;
	        }

	        this.flags = 0;
	    },
	    {
	        $documentation: "Base class for property access expressions, i.e. `a.foo` or `a[\"foo\"]`",
	        $propdoc: {
	            expression: "[AST_Node] the “container” expression",
	            property: "[AST_Node|string] the property to access.  For AST_Dot & AST_DotHash this is always a plain string, while for AST_Sub it's an arbitrary AST_Node",

	            optional: "[boolean] whether this is an optional property access (IE ?.)"
	        }
	    }
	);

	var AST_Dot = DEFNODE("Dot", "quote", function AST_Dot(props) {
	    if (props) {
	        this.quote = props.quote;
	        this.expression = props.expression;
	        this.property = props.property;
	        this.optional = props.optional;
	        this._annotations = props._annotations;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "A dotted property access expression",
	    $propdoc: {
	        quote: "[string] the original quote character when transformed from AST_Sub",
	    },
	    _walk: function(visitor) {
	        return visitor._visit(this, function() {
	            this.expression._walk(visitor);
	        });
	    },
	    _children_backwards(push) {
	        push(this.expression);
	    },
	}, AST_PropAccess);

	var AST_DotHash = DEFNODE("DotHash", "", function AST_DotHash(props) {
	    if (props) {
	        this.expression = props.expression;
	        this.property = props.property;
	        this.optional = props.optional;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "A dotted property access to a private property",
	    _walk: function(visitor) {
	        return visitor._visit(this, function() {
	            this.expression._walk(visitor);
	        });
	    },
	    _children_backwards(push) {
	        push(this.expression);
	    },
	}, AST_PropAccess);

	var AST_Sub = DEFNODE("Sub", null, function AST_Sub(props) {
	    if (props) {
	        this.expression = props.expression;
	        this.property = props.property;
	        this.optional = props.optional;
	        this._annotations = props._annotations;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "Index-style property access, i.e. `a[\"foo\"]`",
	    _walk: function(visitor) {
	        return visitor._visit(this, function() {
	            this.expression._walk(visitor);
	            this.property._walk(visitor);
	        });
	    },
	    _children_backwards(push) {
	        push(this.property);
	        push(this.expression);
	    },
	}, AST_PropAccess);

	var AST_Chain = DEFNODE("Chain", "expression", function AST_Chain(props) {
	    if (props) {
	        this.expression = props.expression;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "A chain expression like a?.b?.(c)?.[d]",
	    $propdoc: {
	        expression: "[AST_Call|AST_Dot|AST_DotHash|AST_Sub] chain element."
	    },
	    _walk: function (visitor) {
	        return visitor._visit(this, function() {
	            this.expression._walk(visitor);
	        });
	    },
	    _children_backwards(push) {
	        push(this.expression);
	    },
	});

	var AST_Unary = DEFNODE("Unary", "operator expression", function AST_Unary(props) {
	    if (props) {
	        this.operator = props.operator;
	        this.expression = props.expression;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "Base class for unary expressions",
	    $propdoc: {
	        operator: "[string] the operator",
	        expression: "[AST_Node] expression that this unary operator applies to"
	    },
	    _walk: function(visitor) {
	        return visitor._visit(this, function() {
	            this.expression._walk(visitor);
	        });
	    },
	    _children_backwards(push) {
	        push(this.expression);
	    },
	});

	var AST_UnaryPrefix = DEFNODE("UnaryPrefix", null, function AST_UnaryPrefix(props) {
	    if (props) {
	        this.operator = props.operator;
	        this.expression = props.expression;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "Unary prefix expression, i.e. `typeof i` or `++i`"
	}, AST_Unary);

	var AST_UnaryPostfix = DEFNODE("UnaryPostfix", null, function AST_UnaryPostfix(props) {
	    if (props) {
	        this.operator = props.operator;
	        this.expression = props.expression;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "Unary postfix expression, i.e. `i++`"
	}, AST_Unary);

	var AST_Binary = DEFNODE("Binary", "operator left right", function AST_Binary(props) {
	    if (props) {
	        this.operator = props.operator;
	        this.left = props.left;
	        this.right = props.right;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "Binary expression, i.e. `a + b`",
	    $propdoc: {
	        left: "[AST_Node] left-hand side expression",
	        operator: "[string] the operator",
	        right: "[AST_Node] right-hand side expression"
	    },
	    _walk: function(visitor) {
	        return visitor._visit(this, function() {
	            this.left._walk(visitor);
	            this.right._walk(visitor);
	        });
	    },
	    _children_backwards(push) {
	        push(this.right);
	        push(this.left);
	    },
	});

	var AST_Conditional = DEFNODE(
	    "Conditional",
	    "condition consequent alternative",
	    function AST_Conditional(props) {
	        if (props) {
	            this.condition = props.condition;
	            this.consequent = props.consequent;
	            this.alternative = props.alternative;
	            this.start = props.start;
	            this.end = props.end;
	        }

	        this.flags = 0;
	    },
	    {
	        $documentation: "Conditional expression using the ternary operator, i.e. `a ? b : c`",
	        $propdoc: {
	            condition: "[AST_Node]",
	            consequent: "[AST_Node]",
	            alternative: "[AST_Node]"
	        },
	        _walk: function(visitor) {
	            return visitor._visit(this, function() {
	                this.condition._walk(visitor);
	                this.consequent._walk(visitor);
	                this.alternative._walk(visitor);
	            });
	        },
	        _children_backwards(push) {
	            push(this.alternative);
	            push(this.consequent);
	            push(this.condition);
	        },
	    }
	);

	var AST_Assign = DEFNODE("Assign", "logical", function AST_Assign(props) {
	    if (props) {
	        this.logical = props.logical;
	        this.operator = props.operator;
	        this.left = props.left;
	        this.right = props.right;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "An assignment expression — `a = b + 5`",
	    $propdoc: {
	        logical: "Whether it's a logical assignment"
	    }
	}, AST_Binary);

	var AST_DefaultAssign = DEFNODE("DefaultAssign", null, function AST_DefaultAssign(props) {
	    if (props) {
	        this.operator = props.operator;
	        this.left = props.left;
	        this.right = props.right;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "A default assignment expression like in `(a = 3) => a`"
	}, AST_Binary);

	/* -----[ LITERALS ]----- */

	var AST_Array = DEFNODE("Array", "elements", function AST_Array(props) {
	    if (props) {
	        this.elements = props.elements;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "An array literal",
	    $propdoc: {
	        elements: "[AST_Node*] array of elements"
	    },
	    _walk: function(visitor) {
	        return visitor._visit(this, function() {
	            var elements = this.elements;
	            for (var i = 0, len = elements.length; i < len; i++) {
	                elements[i]._walk(visitor);
	            }
	        });
	    },
	    _children_backwards(push) {
	        let i = this.elements.length;
	        while (i--) push(this.elements[i]);
	    },
	});

	var AST_Object = DEFNODE("Object", "properties", function AST_Object(props) {
	    if (props) {
	        this.properties = props.properties;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "An object literal",
	    $propdoc: {
	        properties: "[AST_ObjectProperty*] array of properties"
	    },
	    _walk: function(visitor) {
	        return visitor._visit(this, function() {
	            var properties = this.properties;
	            for (var i = 0, len = properties.length; i < len; i++) {
	                properties[i]._walk(visitor);
	            }
	        });
	    },
	    _children_backwards(push) {
	        let i = this.properties.length;
	        while (i--) push(this.properties[i]);
	    },
	});

	var AST_ObjectProperty = DEFNODE("ObjectProperty", "key value", function AST_ObjectProperty(props) {
	    if (props) {
	        this.key = props.key;
	        this.value = props.value;
	        this.start = props.start;
	        this.end = props.end;
	        this._annotations = props._annotations;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "Base class for literal object properties",
	    $propdoc: {
	        key: "[string|AST_Node] property name. For ObjectKeyVal this is a string. For getters, setters and computed property this is an AST_Node.",
	        value: "[AST_Node] property value.  For getters and setters this is an AST_Accessor."
	    },
	    _walk: function(visitor) {
	        return visitor._visit(this, function() {
	            if (this.key instanceof AST_Node)
	                this.key._walk(visitor);
	            this.value._walk(visitor);
	        });
	    },
	    _children_backwards(push) {
	        push(this.value);
	        if (this.key instanceof AST_Node) push(this.key);
	    }
	});

	var AST_ObjectKeyVal = DEFNODE("ObjectKeyVal", "quote", function AST_ObjectKeyVal(props) {
	    if (props) {
	        this.quote = props.quote;
	        this.key = props.key;
	        this.value = props.value;
	        this.start = props.start;
	        this.end = props.end;
	        this._annotations = props._annotations;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "A key: value object property",
	    $propdoc: {
	        quote: "[string] the original quote character"
	    },
	    computed_key() {
	        return this.key instanceof AST_Node;
	    }
	}, AST_ObjectProperty);

	var AST_PrivateSetter = DEFNODE("PrivateSetter", "static", function AST_PrivateSetter(props) {
	    if (props) {
	        this.static = props.static;
	        this.key = props.key;
	        this.value = props.value;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $propdoc: {
	        static: "[boolean] whether this is a static private setter"
	    },
	    $documentation: "A private setter property",
	    computed_key() {
	        return false;
	    }
	}, AST_ObjectProperty);

	var AST_PrivateGetter = DEFNODE("PrivateGetter", "static", function AST_PrivateGetter(props) {
	    if (props) {
	        this.static = props.static;
	        this.key = props.key;
	        this.value = props.value;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $propdoc: {
	        static: "[boolean] whether this is a static private getter"
	    },
	    $documentation: "A private getter property",
	    computed_key() {
	        return false;
	    }
	}, AST_ObjectProperty);

	var AST_ObjectSetter = DEFNODE("ObjectSetter", "quote static", function AST_ObjectSetter(props) {
	    if (props) {
	        this.quote = props.quote;
	        this.static = props.static;
	        this.key = props.key;
	        this.value = props.value;
	        this.start = props.start;
	        this.end = props.end;
	        this._annotations = props._annotations;
	    }

	    this.flags = 0;
	}, {
	    $propdoc: {
	        quote: "[string|undefined] the original quote character, if any",
	        static: "[boolean] whether this is a static setter (classes only)"
	    },
	    $documentation: "An object setter property",
	    computed_key() {
	        return !(this.key instanceof AST_SymbolMethod);
	    }
	}, AST_ObjectProperty);

	var AST_ObjectGetter = DEFNODE("ObjectGetter", "quote static", function AST_ObjectGetter(props) {
	    if (props) {
	        this.quote = props.quote;
	        this.static = props.static;
	        this.key = props.key;
	        this.value = props.value;
	        this.start = props.start;
	        this.end = props.end;
	        this._annotations = props._annotations;
	    }

	    this.flags = 0;
	}, {
	    $propdoc: {
	        quote: "[string|undefined] the original quote character, if any",
	        static: "[boolean] whether this is a static getter (classes only)"
	    },
	    $documentation: "An object getter property",
	    computed_key() {
	        return !(this.key instanceof AST_SymbolMethod);
	    }
	}, AST_ObjectProperty);

	var AST_ConciseMethod = DEFNODE(
	    "ConciseMethod",
	    "quote static is_generator async",
	    function AST_ConciseMethod(props) {
	        if (props) {
	            this.quote = props.quote;
	            this.static = props.static;
	            this.is_generator = props.is_generator;
	            this.async = props.async;
	            this.key = props.key;
	            this.value = props.value;
	            this.start = props.start;
	            this.end = props.end;
	            this._annotations = props._annotations;
	        }

	        this.flags = 0;
	    },
	    {
	        $propdoc: {
	            quote: "[string|undefined] the original quote character, if any",
	            static: "[boolean] is this method static (classes only)",
	            is_generator: "[boolean] is this a generator method",
	            async: "[boolean] is this method async",
	        },
	        $documentation: "An ES6 concise method inside an object or class",
	        computed_key() {
	            return !(this.key instanceof AST_SymbolMethod);
	        }
	    },
	    AST_ObjectProperty
	);

	var AST_PrivateMethod = DEFNODE("PrivateMethod", "", function AST_PrivateMethod(props) {
	    if (props) {
	        this.quote = props.quote;
	        this.static = props.static;
	        this.is_generator = props.is_generator;
	        this.async = props.async;
	        this.key = props.key;
	        this.value = props.value;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "A private class method inside a class",
	}, AST_ConciseMethod);

	var AST_Class = DEFNODE("Class", "name extends properties", function AST_Class(props) {
	    if (props) {
	        this.name = props.name;
	        this.extends = props.extends;
	        this.properties = props.properties;
	        this.variables = props.variables;
	        this.uses_with = props.uses_with;
	        this.uses_eval = props.uses_eval;
	        this.parent_scope = props.parent_scope;
	        this.enclosed = props.enclosed;
	        this.cname = props.cname;
	        this.body = props.body;
	        this.block_scope = props.block_scope;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $propdoc: {
	        name: "[AST_SymbolClass|AST_SymbolDefClass?] optional class name.",
	        extends: "[AST_Node]? optional parent class",
	        properties: "[AST_ObjectProperty*] array of properties"
	    },
	    $documentation: "An ES6 class",
	    _walk: function(visitor) {
	        return visitor._visit(this, function() {
	            if (this.name) {
	                this.name._walk(visitor);
	            }
	            if (this.extends) {
	                this.extends._walk(visitor);
	            }
	            this.properties.forEach((prop) => prop._walk(visitor));
	        });
	    },
	    _children_backwards(push) {
	        let i = this.properties.length;
	        while (i--) push(this.properties[i]);
	        if (this.extends) push(this.extends);
	        if (this.name) push(this.name);
	    },
	    /** go through the bits that are executed instantly, not when the class is `new`'d. Doesn't walk the name. */
	    visit_nondeferred_class_parts(visitor) {
	        if (this.extends) {
	            this.extends._walk(visitor);
	        }
	        this.properties.forEach((prop) => {
	            if (prop instanceof AST_ClassStaticBlock) {
	                prop._walk(visitor);
	                return;
	            }
	            if (prop.computed_key()) {
	                visitor.push(prop);
	                prop.key._walk(visitor);
	                visitor.pop();
	            }
	            if ((prop instanceof AST_ClassPrivateProperty || prop instanceof AST_ClassProperty) && prop.static && prop.value) {
	                visitor.push(prop);
	                prop.value._walk(visitor);
	                visitor.pop();
	            }
	        });
	    },
	    /** go through the bits that are executed later, when the class is `new`'d or a static method is called */
	    visit_deferred_class_parts(visitor) {
	        this.properties.forEach((prop) => {
	            if (prop instanceof AST_ConciseMethod) {
	                prop.walk(visitor);
	            } else if (prop instanceof AST_ClassProperty && !prop.static && prop.value) {
	                visitor.push(prop);
	                prop.value._walk(visitor);
	                visitor.pop();
	            }
	        });
	    },
	    is_self_referential: function() {
	        const this_id = this.name && this.name.definition().id;
	        let found = false;
	        let class_this = true;
	        this.visit_nondeferred_class_parts(new TreeWalker((node, descend) => {
	            if (found) return true;
	            if (node instanceof AST_This) return (found = class_this);
	            if (node instanceof AST_SymbolRef) return (found = node.definition().id === this_id);
	            if (node instanceof AST_Lambda && !(node instanceof AST_Arrow)) {
	                const class_this_save = class_this;
	                class_this = false;
	                descend();
	                class_this = class_this_save;
	                return true;
	            }
	        }));
	        return found;
	    },
	}, AST_Scope /* TODO a class might have a scope but it's not a scope */);

	var AST_ClassProperty = DEFNODE("ClassProperty", "static quote", function AST_ClassProperty(props) {
	    if (props) {
	        this.static = props.static;
	        this.quote = props.quote;
	        this.key = props.key;
	        this.value = props.value;
	        this.start = props.start;
	        this.end = props.end;
	        this._annotations = props._annotations;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "A class property",
	    $propdoc: {
	        static: "[boolean] whether this is a static key",
	        quote: "[string] which quote is being used"
	    },
	    _walk: function(visitor) {
	        return visitor._visit(this, function() {
	            if (this.key instanceof AST_Node)
	                this.key._walk(visitor);
	            if (this.value instanceof AST_Node)
	                this.value._walk(visitor);
	        });
	    },
	    _children_backwards(push) {
	        if (this.value instanceof AST_Node) push(this.value);
	        if (this.key instanceof AST_Node) push(this.key);
	    },
	    computed_key() {
	        return !(this.key instanceof AST_SymbolClassProperty);
	    }
	}, AST_ObjectProperty);

	var AST_ClassPrivateProperty = DEFNODE("ClassPrivateProperty", "", function AST_ClassPrivateProperty(props) {
	    if (props) {
	        this.static = props.static;
	        this.quote = props.quote;
	        this.key = props.key;
	        this.value = props.value;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "A class property for a private property",
	}, AST_ClassProperty);

	var AST_PrivateIn = DEFNODE("PrivateIn", "key value", function AST_PrivateIn(props) {
	    if (props) {
	        this.key = props.key;
	        this.value = props.value;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "An `in` binop when the key is private, eg #x in this",
	    _walk: function(visitor) {
	        return visitor._visit(this, function() {
	            this.key._walk(visitor);
	            this.value._walk(visitor);
	        });
	    },
	    _children_backwards(push) {
	        push(this.value);
	        push(this.key);
	    },
	});

	var AST_DefClass = DEFNODE("DefClass", null, function AST_DefClass(props) {
	    if (props) {
	        this.name = props.name;
	        this.extends = props.extends;
	        this.properties = props.properties;
	        this.variables = props.variables;
	        this.uses_with = props.uses_with;
	        this.uses_eval = props.uses_eval;
	        this.parent_scope = props.parent_scope;
	        this.enclosed = props.enclosed;
	        this.cname = props.cname;
	        this.body = props.body;
	        this.block_scope = props.block_scope;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "A class definition",
	}, AST_Class);

	var AST_ClassStaticBlock = DEFNODE("ClassStaticBlock", "body block_scope", function AST_ClassStaticBlock (props) {
	    this.body = props.body;
	    this.block_scope = props.block_scope;
	    this.start = props.start;
	    this.end = props.end;
	}, {
	    $documentation: "A block containing statements to be executed in the context of the class",
	    $propdoc: {
	        body: "[AST_Statement*] an array of statements",
	    },
	    _walk: function(visitor) {
	        return visitor._visit(this, function() {
	            walk_body(this, visitor);
	        });
	    },
	    _children_backwards(push) {
	        let i = this.body.length;
	        while (i--) push(this.body[i]);
	    },
	    clone: clone_block_scope,
	    computed_key: () => false
	}, AST_Scope);

	var AST_ClassExpression = DEFNODE("ClassExpression", null, function AST_ClassExpression(props) {
	    if (props) {
	        this.name = props.name;
	        this.extends = props.extends;
	        this.properties = props.properties;
	        this.variables = props.variables;
	        this.uses_with = props.uses_with;
	        this.uses_eval = props.uses_eval;
	        this.parent_scope = props.parent_scope;
	        this.enclosed = props.enclosed;
	        this.cname = props.cname;
	        this.body = props.body;
	        this.block_scope = props.block_scope;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "A class expression."
	}, AST_Class);

	var AST_Symbol = DEFNODE("Symbol", "scope name thedef", function AST_Symbol(props) {
	    if (props) {
	        this.scope = props.scope;
	        this.name = props.name;
	        this.thedef = props.thedef;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $propdoc: {
	        name: "[string] name of this symbol",
	        scope: "[AST_Scope/S] the current scope (not necessarily the definition scope)",
	        thedef: "[SymbolDef/S] the definition of this symbol"
	    },
	    $documentation: "Base class for all symbols"
	});

	var AST_NewTarget = DEFNODE("NewTarget", null, function AST_NewTarget(props) {
	    if (props) {
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "A reference to new.target"
	});

	var AST_SymbolDeclaration = DEFNODE("SymbolDeclaration", "init", function AST_SymbolDeclaration(props) {
	    if (props) {
	        this.init = props.init;
	        this.scope = props.scope;
	        this.name = props.name;
	        this.thedef = props.thedef;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "A declaration symbol (symbol in var/const, function name or argument, symbol in catch)",
	}, AST_Symbol);

	var AST_SymbolVar = DEFNODE("SymbolVar", null, function AST_SymbolVar(props) {
	    if (props) {
	        this.init = props.init;
	        this.scope = props.scope;
	        this.name = props.name;
	        this.thedef = props.thedef;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "Symbol defining a variable",
	}, AST_SymbolDeclaration);

	var AST_SymbolBlockDeclaration = DEFNODE(
	    "SymbolBlockDeclaration",
	    null,
	    function AST_SymbolBlockDeclaration(props) {
	        if (props) {
	            this.init = props.init;
	            this.scope = props.scope;
	            this.name = props.name;
	            this.thedef = props.thedef;
	            this.start = props.start;
	            this.end = props.end;
	        }

	        this.flags = 0;
	    },
	    {
	        $documentation: "Base class for block-scoped declaration symbols"
	    },
	    AST_SymbolDeclaration
	);

	var AST_SymbolConst = DEFNODE("SymbolConst", null, function AST_SymbolConst(props) {
	    if (props) {
	        this.init = props.init;
	        this.scope = props.scope;
	        this.name = props.name;
	        this.thedef = props.thedef;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "A constant declaration"
	}, AST_SymbolBlockDeclaration);

	var AST_SymbolLet = DEFNODE("SymbolLet", null, function AST_SymbolLet(props) {
	    if (props) {
	        this.init = props.init;
	        this.scope = props.scope;
	        this.name = props.name;
	        this.thedef = props.thedef;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "A block-scoped `let` declaration"
	}, AST_SymbolBlockDeclaration);

	var AST_SymbolFunarg = DEFNODE("SymbolFunarg", null, function AST_SymbolFunarg(props) {
	    if (props) {
	        this.init = props.init;
	        this.scope = props.scope;
	        this.name = props.name;
	        this.thedef = props.thedef;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "Symbol naming a function argument",
	}, AST_SymbolVar);

	var AST_SymbolDefun = DEFNODE("SymbolDefun", null, function AST_SymbolDefun(props) {
	    if (props) {
	        this.init = props.init;
	        this.scope = props.scope;
	        this.name = props.name;
	        this.thedef = props.thedef;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "Symbol defining a function",
	}, AST_SymbolDeclaration);

	var AST_SymbolMethod = DEFNODE("SymbolMethod", null, function AST_SymbolMethod(props) {
	    if (props) {
	        this.scope = props.scope;
	        this.name = props.name;
	        this.thedef = props.thedef;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "Symbol in an object defining a method",
	}, AST_Symbol);

	var AST_SymbolClassProperty = DEFNODE("SymbolClassProperty", null, function AST_SymbolClassProperty(props) {
	    if (props) {
	        this.scope = props.scope;
	        this.name = props.name;
	        this.thedef = props.thedef;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "Symbol for a class property",
	}, AST_Symbol);

	var AST_SymbolLambda = DEFNODE("SymbolLambda", null, function AST_SymbolLambda(props) {
	    if (props) {
	        this.init = props.init;
	        this.scope = props.scope;
	        this.name = props.name;
	        this.thedef = props.thedef;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "Symbol naming a function expression",
	}, AST_SymbolDeclaration);

	var AST_SymbolDefClass = DEFNODE("SymbolDefClass", null, function AST_SymbolDefClass(props) {
	    if (props) {
	        this.init = props.init;
	        this.scope = props.scope;
	        this.name = props.name;
	        this.thedef = props.thedef;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "Symbol naming a class's name in a class declaration. Lexically scoped to its containing scope, and accessible within the class."
	}, AST_SymbolBlockDeclaration);

	var AST_SymbolClass = DEFNODE("SymbolClass", null, function AST_SymbolClass(props) {
	    if (props) {
	        this.init = props.init;
	        this.scope = props.scope;
	        this.name = props.name;
	        this.thedef = props.thedef;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "Symbol naming a class's name. Lexically scoped to the class."
	}, AST_SymbolDeclaration);

	var AST_SymbolCatch = DEFNODE("SymbolCatch", null, function AST_SymbolCatch(props) {
	    if (props) {
	        this.init = props.init;
	        this.scope = props.scope;
	        this.name = props.name;
	        this.thedef = props.thedef;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "Symbol naming the exception in catch",
	}, AST_SymbolBlockDeclaration);

	var AST_SymbolImport = DEFNODE("SymbolImport", null, function AST_SymbolImport(props) {
	    if (props) {
	        this.init = props.init;
	        this.scope = props.scope;
	        this.name = props.name;
	        this.thedef = props.thedef;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "Symbol referring to an imported name",
	}, AST_SymbolBlockDeclaration);

	var AST_SymbolImportForeign = DEFNODE("SymbolImportForeign", null, function AST_SymbolImportForeign(props) {
	    if (props) {
	        this.scope = props.scope;
	        this.name = props.name;
	        this.thedef = props.thedef;
	        this.quote = props.quote;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "A symbol imported from a module, but it is defined in the other module, and its real name is irrelevant for this module's purposes",
	}, AST_Symbol);

	var AST_Label = DEFNODE("Label", "references", function AST_Label(props) {
	    if (props) {
	        this.references = props.references;
	        this.scope = props.scope;
	        this.name = props.name;
	        this.thedef = props.thedef;
	        this.start = props.start;
	        this.end = props.end;
	        this.initialize();
	    }

	    this.flags = 0;
	}, {
	    $documentation: "Symbol naming a label (declaration)",
	    $propdoc: {
	        references: "[AST_LoopControl*] a list of nodes referring to this label"
	    },
	    initialize: function() {
	        this.references = [];
	        this.thedef = this;
	    }
	}, AST_Symbol);

	var AST_SymbolRef = DEFNODE("SymbolRef", null, function AST_SymbolRef(props) {
	    if (props) {
	        this.scope = props.scope;
	        this.name = props.name;
	        this.thedef = props.thedef;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "Reference to some symbol (not definition/declaration)",
	}, AST_Symbol);

	var AST_SymbolExport = DEFNODE("SymbolExport", null, function AST_SymbolExport(props) {
	    if (props) {
	        this.scope = props.scope;
	        this.name = props.name;
	        this.thedef = props.thedef;
	        this.quote = props.quote;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "Symbol referring to a name to export",
	}, AST_SymbolRef);

	var AST_SymbolExportForeign = DEFNODE("SymbolExportForeign", null, function AST_SymbolExportForeign(props) {
	    if (props) {
	        this.scope = props.scope;
	        this.name = props.name;
	        this.thedef = props.thedef;
	        this.quote = props.quote;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "A symbol exported from this module, but it is used in the other module, and its real name is irrelevant for this module's purposes",
	}, AST_Symbol);

	var AST_LabelRef = DEFNODE("LabelRef", null, function AST_LabelRef(props) {
	    if (props) {
	        this.scope = props.scope;
	        this.name = props.name;
	        this.thedef = props.thedef;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "Reference to a label symbol",
	}, AST_Symbol);

	var AST_SymbolPrivateProperty = DEFNODE("SymbolPrivateProperty", null, function AST_SymbolPrivateProperty(props) {
	    if (props) {
	        this.scope = props.scope;
	        this.name = props.name;
	        this.thedef = props.thedef;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "A symbol that refers to a private property",
	}, AST_Symbol);

	var AST_This = DEFNODE("This", null, function AST_This(props) {
	    if (props) {
	        this.scope = props.scope;
	        this.name = props.name;
	        this.thedef = props.thedef;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "The `this` symbol",
	}, AST_Symbol);

	var AST_Super = DEFNODE("Super", null, function AST_Super(props) {
	    if (props) {
	        this.scope = props.scope;
	        this.name = props.name;
	        this.thedef = props.thedef;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "The `super` symbol",
	}, AST_This);

	var AST_Constant = DEFNODE("Constant", null, function AST_Constant(props) {
	    if (props) {
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "Base class for all constants",
	    getValue: function() {
	        return this.value;
	    }
	});

	var AST_String = DEFNODE("String", "value quote", function AST_String(props) {
	    if (props) {
	        this.value = props.value;
	        this.quote = props.quote;
	        this.start = props.start;
	        this.end = props.end;
	        this._annotations = props._annotations;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "A string literal",
	    $propdoc: {
	        value: "[string] the contents of this string",
	        quote: "[string] the original quote character"
	    }
	}, AST_Constant);

	var AST_Number = DEFNODE("Number", "value raw", function AST_Number(props) {
	    if (props) {
	        this.value = props.value;
	        this.raw = props.raw;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "A number literal",
	    $propdoc: {
	        value: "[number] the numeric value",
	        raw: "[string] numeric value as string"
	    }
	}, AST_Constant);

	var AST_BigInt = DEFNODE("BigInt", "value", function AST_BigInt(props) {
	    if (props) {
	        this.value = props.value;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "A big int literal",
	    $propdoc: {
	        value: "[string] big int value"
	    }
	}, AST_Constant);

	var AST_RegExp = DEFNODE("RegExp", "value", function AST_RegExp(props) {
	    if (props) {
	        this.value = props.value;
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "A regexp literal",
	    $propdoc: {
	        value: "[RegExp] the actual regexp",
	    }
	}, AST_Constant);

	var AST_Atom = DEFNODE("Atom", null, function AST_Atom(props) {
	    if (props) {
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "Base class for atoms",
	}, AST_Constant);

	var AST_Null = DEFNODE("Null", null, function AST_Null(props) {
	    if (props) {
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "The `null` atom",
	    value: null
	}, AST_Atom);

	var AST_NaN = DEFNODE("NaN", null, function AST_NaN(props) {
	    if (props) {
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "The impossible value",
	    value: 0/0
	}, AST_Atom);

	var AST_Undefined = DEFNODE("Undefined", null, function AST_Undefined(props) {
	    if (props) {
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "The `undefined` value",
	    value: (function() {}())
	}, AST_Atom);

	var AST_Hole = DEFNODE("Hole", null, function AST_Hole(props) {
	    if (props) {
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "A hole in an array",
	    value: (function() {}())
	}, AST_Atom);

	var AST_Infinity = DEFNODE("Infinity", null, function AST_Infinity(props) {
	    if (props) {
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "The `Infinity` value",
	    value: 1/0
	}, AST_Atom);

	var AST_Boolean = DEFNODE("Boolean", null, function AST_Boolean(props) {
	    if (props) {
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "Base class for booleans",
	}, AST_Atom);

	var AST_False = DEFNODE("False", null, function AST_False(props) {
	    if (props) {
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "The `false` atom",
	    value: false
	}, AST_Boolean);

	var AST_True = DEFNODE("True", null, function AST_True(props) {
	    if (props) {
	        this.start = props.start;
	        this.end = props.end;
	    }

	    this.flags = 0;
	}, {
	    $documentation: "The `true` atom",
	    value: true
	}, AST_Boolean);

	/* -----[ Walk function ]---- */

	/**
	 * Walk nodes in depth-first search fashion.
	 * Callback can return `walk_abort` symbol to stop iteration.
	 * It can also return `true` to stop iteration just for child nodes.
	 * Iteration can be stopped and continued by passing the `to_visit` argument,
	 * which is given to the callback in the second argument.
	 **/
	function walk(node, cb, to_visit = [node]) {
	    const push = to_visit.push.bind(to_visit);
	    while (to_visit.length) {
	        const node = to_visit.pop();
	        const ret = cb(node, to_visit);

	        if (ret) {
	            if (ret === walk_abort) return true;
	            continue;
	        }

	        node._children_backwards(push);
	    }
	    return false;
	}

	/**
	 * Walks an AST node and its children.
	 *
	 * {cb} can return `walk_abort` to interrupt the walk.
	 *
	 * @param node
	 * @param cb {(node, info: { parent: (nth) => any }) => (boolean | undefined)}
	 *
	 * @returns {boolean} whether the walk was aborted
	 *
	 * @example
	 * const found_some_cond = walk_parent(my_ast_node, (node, { parent }) => {
	 *   if (some_cond(node, parent())) return walk_abort
	 * });
	 */
	function walk_parent(node, cb, initial_stack) {
	    const to_visit = [node];
	    const push = to_visit.push.bind(to_visit);
	    const stack = initial_stack ? initial_stack.slice() : [];
	    const parent_pop_indices = [];

	    let current;

	    const info = {
	        parent: (n = 0) => {
	            if (n === -1) {
	                return current;
	            }

	            // [ p1 p0 ] [ 1 0 ]
	            if (initial_stack && n >= stack.length) {
	                n -= stack.length;
	                return initial_stack[
	                    initial_stack.length - (n + 1)
	                ];
	            }

	            return stack[stack.length - (1 + n)];
	        },
	    };

	    while (to_visit.length) {
	        current = to_visit.pop();

	        while (
	            parent_pop_indices.length &&
	            to_visit.length == parent_pop_indices[parent_pop_indices.length - 1]
	        ) {
	            stack.pop();
	            parent_pop_indices.pop();
	        }

	        const ret = cb(current, info);

	        if (ret) {
	            if (ret === walk_abort) return true;
	            continue;
	        }

	        const visit_length = to_visit.length;

	        current._children_backwards(push);

	        // Push only if we're going to traverse the children
	        if (to_visit.length > visit_length) {
	            stack.push(current);
	            parent_pop_indices.push(visit_length - 1);
	        }
	    }

	    return false;
	}

	const walk_abort = Symbol("abort walk");

	/* -----[ TreeWalker ]----- */

	class TreeWalker {
	    constructor(callback) {
	        this.visit = callback;
	        this.stack = [];
	        this.directives = Object.create(null);
	    }

	    _visit(node, descend) {
	        this.push(node);
	        var ret = this.visit(node, descend ? function() {
	            descend.call(node);
	        } : noop);
	        if (!ret && descend) {
	            descend.call(node);
	        }
	        this.pop();
	        return ret;
	    }

	    parent(n) {
	        return this.stack[this.stack.length - 2 - (n || 0)];
	    }

	    push(node) {
	        if (node instanceof AST_Lambda) {
	            this.directives = Object.create(this.directives);
	        } else if (node instanceof AST_Directive && !this.directives[node.value]) {
	            this.directives[node.value] = node;
	        } else if (node instanceof AST_Class) {
	            this.directives = Object.create(this.directives);
	            if (!this.directives["use strict"]) {
	                this.directives["use strict"] = node;
	            }
	        }
	        this.stack.push(node);
	    }

	    pop() {
	        var node = this.stack.pop();
	        if (node instanceof AST_Lambda || node instanceof AST_Class) {
	            this.directives = Object.getPrototypeOf(this.directives);
	        }
	    }

	    self() {
	        return this.stack[this.stack.length - 1];
	    }

	    find_parent(type) {
	        var stack = this.stack;
	        for (var i = stack.length; --i >= 0;) {
	            var x = stack[i];
	            if (x instanceof type) return x;
	        }
	    }

	    find_scope() {
	        var stack = this.stack;
	        for (var i = stack.length; --i >= 0;) {
	            const p = stack[i];
	            if (p instanceof AST_Toplevel) return p;
	            if (p instanceof AST_Lambda) return p;
	            if (p.block_scope) return p.block_scope;
	        }
	    }

	    has_directive(type) {
	        var dir = this.directives[type];
	        if (dir) return dir;
	        var node = this.stack[this.stack.length - 1];
	        if (node instanceof AST_Scope && node.body) {
	            for (var i = 0; i < node.body.length; ++i) {
	                var st = node.body[i];
	                if (!(st instanceof AST_Directive)) break;
	                if (st.value == type) return st;
	            }
	        }
	    }

	    loopcontrol_target(node) {
	        var stack = this.stack;
	        if (node.label) for (var i = stack.length; --i >= 0;) {
	            var x = stack[i];
	            if (x instanceof AST_LabeledStatement && x.label.name == node.label.name)
	                return x.body;
	        } else for (var i = stack.length; --i >= 0;) {
	            var x = stack[i];
	            if (x instanceof AST_IterationStatement
	                || node instanceof AST_Break && x instanceof AST_Switch)
	                return x;
	        }
	    }
	}

	// Tree transformer helpers.
	class TreeTransformer extends TreeWalker {
	    constructor(before, after) {
	        super();
	        this.before = before;
	        this.after = after;
	    }
	}

	const _PURE       = 0b00000001;
	const _INLINE     = 0b00000010;
	const _NOINLINE   = 0b00000100;
	const _KEY        = 0b00001000;
	const _MANGLEPROP = 0b00010000;

	/***********************************************************************

	  A JavaScript tokenizer / parser / beautifier / compressor.
	  https://github.com/mishoo/UglifyJS2

	  -------------------------------- (C) ---------------------------------

	                           Author: Mihai Bazon
	                         <mihai.bazon@gmail.com>
	                       http://mihai.bazon.net/blog

	  Distributed under the BSD license:

	    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

	    Redistribution and use in source and binary forms, with or without
	    modification, are permitted provided that the following conditions
	    are met:

	        * Redistributions of source code must retain the above
	          copyright notice, this list of conditions and the following
	          disclaimer.

	        * Redistributions in binary form must reproduce the above
	          copyright notice, this list of conditions and the following
	          disclaimer in the documentation and/or other materials
	          provided with the distribution.

	    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
	    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
	    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
	    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
	    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
	    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
	    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
	    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
	    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
	    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
	    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
	    SUCH DAMAGE.

	 ***********************************************************************/

	function def_transform(node, descend) {
	    node.DEFMETHOD("transform", function(tw, in_list) {
	        let transformed = undefined;
	        tw.push(this);
	        if (tw.before) transformed = tw.before(this, descend, in_list);
	        if (transformed === undefined) {
	            transformed = this;
	            descend(transformed, tw);
	            if (tw.after) {
	                const after_ret = tw.after(transformed, in_list);
	                if (after_ret !== undefined) transformed = after_ret;
	            }
	        }
	        tw.pop();
	        return transformed;
	    });
	}

	def_transform(AST_Node, noop);

	def_transform(AST_LabeledStatement, function(self, tw) {
	    self.label = self.label.transform(tw);
	    self.body = self.body.transform(tw);
	});

	def_transform(AST_SimpleStatement, function(self, tw) {
	    self.body = self.body.transform(tw);
	});

	def_transform(AST_Block, function(self, tw) {
	    self.body = MAP(self.body, tw);
	});

	def_transform(AST_Do, function(self, tw) {
	    self.body = self.body.transform(tw);
	    self.condition = self.condition.transform(tw);
	});

	def_transform(AST_While, function(self, tw) {
	    self.condition = self.condition.transform(tw);
	    self.body = self.body.transform(tw);
	});

	def_transform(AST_For, function(self, tw) {
	    if (self.init) self.init = self.init.transform(tw);
	    if (self.condition) self.condition = self.condition.transform(tw);
	    if (self.step) self.step = self.step.transform(tw);
	    self.body = self.body.transform(tw);
	});

	def_transform(AST_ForIn, function(self, tw) {
	    self.init = self.init.transform(tw);
	    self.object = self.object.transform(tw);
	    self.body = self.body.transform(tw);
	});

	def_transform(AST_With, function(self, tw) {
	    self.expression = self.expression.transform(tw);
	    self.body = self.body.transform(tw);
	});

	def_transform(AST_Exit, function(self, tw) {
	    if (self.value) self.value = self.value.transform(tw);
	});

	def_transform(AST_LoopControl, function(self, tw) {
	    if (self.label) self.label = self.label.transform(tw);
	});

	def_transform(AST_If, function(self, tw) {
	    self.condition = self.condition.transform(tw);
	    self.body = self.body.transform(tw);
	    if (self.alternative) self.alternative = self.alternative.transform(tw);
	});

	def_transform(AST_Switch, function(self, tw) {
	    self.expression = self.expression.transform(tw);
	    self.body = MAP(self.body, tw);
	});

	def_transform(AST_Case, function(self, tw) {
	    self.expression = self.expression.transform(tw);
	    self.body = MAP(self.body, tw);
	});

	def_transform(AST_Try, function(self, tw) {
	    self.body = self.body.transform(tw);
	    if (self.bcatch) self.bcatch = self.bcatch.transform(tw);
	    if (self.bfinally) self.bfinally = self.bfinally.transform(tw);
	});

	def_transform(AST_Catch, function(self, tw) {
	    if (self.argname) self.argname = self.argname.transform(tw);
	    self.body = MAP(self.body, tw);
	});

	def_transform(AST_Definitions, function(self, tw) {
	    self.definitions = MAP(self.definitions, tw);
	});

	def_transform(AST_VarDef, function(self, tw) {
	    self.name = self.name.transform(tw);
	    if (self.value) self.value = self.value.transform(tw);
	});

	def_transform(AST_Destructuring, function(self, tw) {
	    self.names = MAP(self.names, tw);
	});

	def_transform(AST_Lambda, function(self, tw) {
	    if (self.name) self.name = self.name.transform(tw);
	    self.argnames = MAP(self.argnames, tw, /* allow_splicing */ false);
	    if (self.body instanceof AST_Node) {
	        self.body = self.body.transform(tw);
	    } else {
	        self.body = MAP(self.body, tw);
	    }
	});

	def_transform(AST_Call, function(self, tw) {
	    self.expression = self.expression.transform(tw);
	    self.args = MAP(self.args, tw, /* allow_splicing */ false);
	});

	def_transform(AST_Sequence, function(self, tw) {
	    const result = MAP(self.expressions, tw);
	    self.expressions = result.length
	        ? result
	        : [new AST_Number({ value: 0 })];
	});

	def_transform(AST_PropAccess, function(self, tw) {
	    self.expression = self.expression.transform(tw);
	});

	def_transform(AST_Sub, function(self, tw) {
	    self.expression = self.expression.transform(tw);
	    self.property = self.property.transform(tw);
	});

	def_transform(AST_Chain, function(self, tw) {
	    self.expression = self.expression.transform(tw);
	});

	def_transform(AST_Yield, function(self, tw) {
	    if (self.expression) self.expression = self.expression.transform(tw);
	});

	def_transform(AST_Await, function(self, tw) {
	    self.expression = self.expression.transform(tw);
	});

	def_transform(AST_Unary, function(self, tw) {
	    self.expression = self.expression.transform(tw);
	});

	def_transform(AST_Binary, function(self, tw) {
	    self.left = self.left.transform(tw);
	    self.right = self.right.transform(tw);
	});

	def_transform(AST_PrivateIn, function(self, tw) {
	    self.key = self.key.transform(tw);
	    self.value = self.value.transform(tw);
	});

	def_transform(AST_Conditional, function(self, tw) {
	    self.condition = self.condition.transform(tw);
	    self.consequent = self.consequent.transform(tw);
	    self.alternative = self.alternative.transform(tw);
	});

	def_transform(AST_Array, function(self, tw) {
	    self.elements = MAP(self.elements, tw);
	});

	def_transform(AST_Object, function(self, tw) {
	    self.properties = MAP(self.properties, tw);
	});

	def_transform(AST_ObjectProperty, function(self, tw) {
	    if (self.key instanceof AST_Node) {
	        self.key = self.key.transform(tw);
	    }
	    if (self.value) self.value = self.value.transform(tw);
	});

	def_transform(AST_Class, function(self, tw) {
	    if (self.name) self.name = self.name.transform(tw);
	    if (self.extends) self.extends = self.extends.transform(tw);
	    self.properties = MAP(self.properties, tw);
	});

	def_transform(AST_ClassStaticBlock, function(self, tw) {
	    self.body = MAP(self.body, tw);
	});

	def_transform(AST_Expansion, function(self, tw) {
	    self.expression = self.expression.transform(tw);
	});

	def_transform(AST_NameMapping, function(self, tw) {
	    self.foreign_name = self.foreign_name.transform(tw);
	    self.name = self.name.transform(tw);
	});

	def_transform(AST_Import, function(self, tw) {
	    if (self.imported_name) self.imported_name = self.imported_name.transform(tw);
	    if (self.imported_names) MAP(self.imported_names, tw);
	    self.module_name = self.module_name.transform(tw);
	});

	def_transform(AST_Export, function(self, tw) {
	    if (self.exported_definition) self.exported_definition = self.exported_definition.transform(tw);
	    if (self.exported_value) self.exported_value = self.exported_value.transform(tw);
	    if (self.exported_names) MAP(self.exported_names, tw);
	    if (self.module_name) self.module_name = self.module_name.transform(tw);
	});

	def_transform(AST_TemplateString, function(self, tw) {
	    self.segments = MAP(self.segments, tw);
	});

	def_transform(AST_PrefixedTemplateString, function(self, tw) {
	    self.prefix = self.prefix.transform(tw);
	    self.template_string = self.template_string.transform(tw);
	});

	/***********************************************************************

	  A JavaScript tokenizer / parser / beautifier / compressor.
	  https://github.com/mishoo/UglifyJS2

	  -------------------------------- (C) ---------------------------------

	                           Author: Mihai Bazon
	                         <mihai.bazon@gmail.com>
	                       http://mihai.bazon.net/blog

	  Distributed under the BSD license:

	    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

	    Redistribution and use in source and binary forms, with or without
	    modification, are permitted provided that the following conditions
	    are met:

	        * Redistributions of source code must retain the above
	          copyright notice, this list of conditions and the following
	          disclaimer.

	        * Redistributions in binary form must reproduce the above
	          copyright notice, this list of conditions and the following
	          disclaimer in the documentation and/or other materials
	          provided with the distribution.

	    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
	    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
	    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
	    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
	    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
	    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
	    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
	    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
	    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
	    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
	    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
	    SUCH DAMAGE.

	 ***********************************************************************/

	(function() {

	    var normalize_directives = function(body) {
	        for (var i = 0; i < body.length; i++) {
	            if (body[i] instanceof AST_Statement && body[i].body instanceof AST_String) {
	                body[i] = new AST_Directive({
	                    start: body[i].start,
	                    end: body[i].end,
	                    value: body[i].body.value
	                });
	            } else {
	                return body;
	            }
	        }

	        return body;
	    };

	    const assert_clause_from_moz = (assertions) => {
	        if (assertions && assertions.length > 0) {
	            return new AST_Object({
	                start: my_start_token(assertions),
	                end: my_end_token(assertions),
	                properties: assertions.map((assertion_kv) =>
	                    new AST_ObjectKeyVal({
	                        start: my_start_token(assertion_kv),
	                        end: my_end_token(assertion_kv),
	                        key: assertion_kv.key.name || assertion_kv.key.value,
	                        value: from_moz(assertion_kv.value)
	                    })
	                )
	            });
	        }
	        return null;
	    };

	    var MOZ_TO_ME = {
	        Program: function(M) {
	            return new AST_Toplevel({
	                start: my_start_token(M),
	                end: my_end_token(M),
	                body: normalize_directives(M.body.map(from_moz))
	            });
	        },

	        ArrayPattern: function(M) {
	            return new AST_Destructuring({
	                start: my_start_token(M),
	                end: my_end_token(M),
	                names: M.elements.map(function(elm) {
	                    if (elm === null) {
	                        return new AST_Hole();
	                    }
	                    return from_moz(elm);
	                }),
	                is_array: true
	            });
	        },

	        ObjectPattern: function(M) {
	            return new AST_Destructuring({
	                start: my_start_token(M),
	                end: my_end_token(M),
	                names: M.properties.map(from_moz),
	                is_array: false
	            });
	        },

	        AssignmentPattern: function(M) {
	            return new AST_DefaultAssign({
	                start: my_start_token(M),
	                end: my_end_token(M),
	                left: from_moz(M.left),
	                operator: "=",
	                right: from_moz(M.right)
	            });
	        },

	        SpreadElement: function(M) {
	            return new AST_Expansion({
	                start: my_start_token(M),
	                end: my_end_token(M),
	                expression: from_moz(M.argument)
	            });
	        },

	        RestElement: function(M) {
	            return new AST_Expansion({
	                start: my_start_token(M),
	                end: my_end_token(M),
	                expression: from_moz(M.argument)
	            });
	        },

	        TemplateElement: function(M) {
	            return new AST_TemplateSegment({
	                start: my_start_token(M),
	                end: my_end_token(M),
	                value: M.value.cooked,
	                raw: M.value.raw
	            });
	        },

	        TemplateLiteral: function(M) {
	            var segments = [];
	            for (var i = 0; i < M.quasis.length; i++) {
	                segments.push(from_moz(M.quasis[i]));
	                if (M.expressions[i]) {
	                    segments.push(from_moz(M.expressions[i]));
	                }
	            }
	            return new AST_TemplateString({
	                start: my_start_token(M),
	                end: my_end_token(M),
	                segments: segments
	            });
	        },

	        TaggedTemplateExpression: function(M) {
	            return new AST_PrefixedTemplateString({
	                start: my_start_token(M),
	                end: my_end_token(M),
	                template_string: from_moz(M.quasi),
	                prefix: from_moz(M.tag)
	            });
	        },

	        FunctionDeclaration: function(M) {
	            return new AST_Defun({
	                start: my_start_token(M),
	                end: my_end_token(M),
	                name: from_moz(M.id),
	                argnames: M.params.map(from_moz),
	                is_generator: M.generator,
	                async: M.async,
	                body: normalize_directives(from_moz(M.body).body)
	            });
	        },

	        FunctionExpression: function(M) {
	            return new AST_Function({
	                start: my_start_token(M),
	                end: my_end_token(M),
	                name: from_moz(M.id),
	                argnames: M.params.map(from_moz),
	                is_generator: M.generator,
	                async: M.async,
	                body: normalize_directives(from_moz(M.body).body)
	            });
	        },

	        ArrowFunctionExpression: function(M) {
	            const body = M.body.type === "BlockStatement"
	                ? from_moz(M.body).body
	                : [make_node(AST_Return, {}, { value: from_moz(M.body) })];
	            return new AST_Arrow({
	                start: my_start_token(M),
	                end: my_end_token(M),
	                argnames: M.params.map(from_moz),
	                body,
	                async: M.async,
	            });
	        },

	        ExpressionStatement: function(M) {
	            return new AST_SimpleStatement({
	                start: my_start_token(M),
	                end: my_end_token(M),
	                body: from_moz(M.expression)
	            });
	        },

	        TryStatement: function(M) {
	            var handlers = M.handlers || [M.handler];
	            if (handlers.length > 1 || M.guardedHandlers && M.guardedHandlers.length) {
	                throw new Error("Multiple catch clauses are not supported.");
	            }
	            return new AST_Try({
	                start    : my_start_token(M),
	                end      : my_end_token(M),
	                body     : new AST_TryBlock(from_moz(M.block)),
	                bcatch   : from_moz(handlers[0]),
	                bfinally : M.finalizer ? new AST_Finally(from_moz(M.finalizer)) : null
	            });
	        },

	        Property: function(M) {
	            var key = M.key;
	            var args = {
	                start    : my_start_token(key || M.value),
	                end      : my_end_token(M.value),
	                key      : key.type == "Identifier" ? key.name : key.value,
	                value    : from_moz(M.value)
	            };
	            if (M.computed) {
	                args.key = from_moz(M.key);
	            }
	            if (M.method) {
	                args.is_generator = M.value.generator;
	                args.async = M.value.async;
	                if (!M.computed) {
	                    args.key = new AST_SymbolMethod({ name: args.key });
	                } else {
	                    args.key = from_moz(M.key);
	                }
	                return new AST_ConciseMethod(args);
	            }
	            if (M.kind == "init") {
	                if (key.type != "Identifier" && key.type != "Literal") {
	                    args.key = from_moz(key);
	                }
	                return new AST_ObjectKeyVal(args);
	            }
	            if (typeof args.key === "string" || typeof args.key === "number") {
	                args.key = new AST_SymbolMethod({
	                    name: args.key
	                });
	            }
	            args.value = new AST_Accessor(args.value);
	            if (M.kind == "get") return new AST_ObjectGetter(args);
	            if (M.kind == "set") return new AST_ObjectSetter(args);
	            if (M.kind == "method") {
	                args.async = M.value.async;
	                args.is_generator = M.value.generator;
	                args.quote = M.computed ? "\"" : null;
	                return new AST_ConciseMethod(args);
	            }
	        },

	        MethodDefinition: function(M) {
	            const is_private = M.key.type === "PrivateIdentifier";
	            const key = M.computed ? from_moz(M.key) : new AST_SymbolMethod({ name: M.key.name || M.key.value });

	            var args = {
	                start    : my_start_token(M),
	                end      : my_end_token(M),
	                key,
	                value    : from_moz(M.value),
	                static   : M.static,
	            };
	            if (M.kind == "get") {
	                return new (is_private ? AST_PrivateGetter : AST_ObjectGetter)(args);
	            }
	            if (M.kind == "set") {
	                return new (is_private ? AST_PrivateSetter : AST_ObjectSetter)(args);
	            }
	            args.is_generator = M.value.generator;
	            args.async = M.value.async;
	            return new (is_private ? AST_PrivateMethod : AST_ConciseMethod)(args);
	        },

	        FieldDefinition: function(M) {
	            let key;
	            if (M.computed) {
	                key = from_moz(M.key);
	            } else {
	                if (M.key.type !== "Identifier") throw new Error("Non-Identifier key in FieldDefinition");
	                key = from_moz(M.key);
	            }
	            return new AST_ClassProperty({
	                start    : my_start_token(M),
	                end      : my_end_token(M),
	                key,
	                value    : from_moz(M.value),
	                static   : M.static,
	            });
	        },

	        PropertyDefinition: function(M) {
	            let key;
	            if (M.computed) {
	                key = from_moz(M.key);
	            } else if (M.key.type === "PrivateIdentifier") {
	                return new AST_ClassPrivateProperty({
	                    start    : my_start_token(M),
	                    end      : my_end_token(M),
	                    key      : from_moz(M.key),
	                    value    : from_moz(M.value),
	                    static   : M.static,
	                });
	            } else {
	                if (M.key.type !== "Identifier") {
	                    throw new Error("Non-Identifier key in PropertyDefinition");
	                }
	                key = from_moz(M.key);
	            }

	            return new AST_ClassProperty({
	                start    : my_start_token(M),
	                end      : my_end_token(M),
	                key,
	                value    : from_moz(M.value),
	                static   : M.static,
	            });
	        },

	        PrivateIdentifier: function (M) {
	            return new AST_SymbolPrivateProperty({
	                start: my_start_token(M),
	                end: my_end_token(M),
	                name: M.name
	            });
	        },

	        StaticBlock: function(M) {
	            return new AST_ClassStaticBlock({
	                start : my_start_token(M),
	                end   : my_end_token(M),
	                body  : M.body.map(from_moz),
	            });
	        },

	        ArrayExpression: function(M) {
	            return new AST_Array({
	                start    : my_start_token(M),
	                end      : my_end_token(M),
	                elements : M.elements.map(function(elem) {
	                    return elem === null ? new AST_Hole() : from_moz(elem);
	                })
	            });
	        },

	        ObjectExpression: function(M) {
	            return new AST_Object({
	                start      : my_start_token(M),
	                end        : my_end_token(M),
	                properties : M.properties.map(function(prop) {
	                    if (prop.type === "SpreadElement") {
	                        return from_moz(prop);
	                    }
	                    prop.type = "Property";
	                    return from_moz(prop);
	                })
	            });
	        },

	        SequenceExpression: function(M) {
	            return new AST_Sequence({
	                start      : my_start_token(M),
	                end        : my_end_token(M),
	                expressions: M.expressions.map(from_moz)
	            });
	        },

	        MemberExpression: function(M) {
	            if (M.property.type === "PrivateIdentifier") {
	                return new AST_DotHash({
	                    start      : my_start_token(M),
	                    end        : my_end_token(M),
	                    property   : M.property.name,
	                    expression : from_moz(M.object),
	                    optional   : M.optional || false
	                });
	            }
	            return new (M.computed ? AST_Sub : AST_Dot)({
	                start      : my_start_token(M),
	                end        : my_end_token(M),
	                property   : M.computed ? from_moz(M.property) : M.property.name,
	                expression : from_moz(M.object),
	                optional   : M.optional || false
	            });
	        },

	        ChainExpression: function(M) {
	            return new AST_Chain({
	                start      : my_start_token(M),
	                end        : my_end_token(M),
	                expression : from_moz(M.expression)
	            });
	        },

	        SwitchCase: function(M) {
	            return new (M.test ? AST_Case : AST_Default)({
	                start      : my_start_token(M),
	                end        : my_end_token(M),
	                expression : from_moz(M.test),
	                body       : M.consequent.map(from_moz)
	            });
	        },

	        VariableDeclaration: function(M) {
	            return new (M.kind === "const" ? AST_Const :
	                        M.kind === "let" ? AST_Let : AST_Var)({
	                start       : my_start_token(M),
	                end         : my_end_token(M),
	                definitions : M.declarations.map(from_moz)
	            });
	        },

	        ImportDeclaration: function(M) {
	            var imported_name = null;
	            var imported_names = null;
	            M.specifiers.forEach(function (specifier) {
	                if (specifier.type === "ImportSpecifier" || specifier.type === "ImportNamespaceSpecifier") {
	                    if (!imported_names) { imported_names = []; }
	                    imported_names.push(from_moz(specifier));
	                } else if (specifier.type === "ImportDefaultSpecifier") {
	                    imported_name = from_moz(specifier);
	                }
	            });
	            return new AST_Import({
	                start       : my_start_token(M),
	                end         : my_end_token(M),
	                imported_name: imported_name,
	                imported_names : imported_names,
	                module_name : from_moz(M.source),
	                assert_clause: assert_clause_from_moz(M.assertions)
	            });
	        },

	        ImportSpecifier: function(M) {
	            return new AST_NameMapping({
	                start: my_start_token(M),
	                end: my_end_token(M),
	                foreign_name: from_moz(M.imported),
	                name: from_moz(M.local)
	            });
	        },

	        ImportDefaultSpecifier: function(M) {
	            return from_moz(M.local);
	        },

	        ImportNamespaceSpecifier: function(M) {
	            return new AST_NameMapping({
	                start: my_start_token(M),
	                end: my_end_token(M),
	                foreign_name: new AST_SymbolImportForeign({ name: "*" }),
	                name: from_moz(M.local)
	            });
	        },

	        ExportAllDeclaration: function(M) {
	            var foreign_name = M.exported == null ? 
	                new AST_SymbolExportForeign({ name: "*" }) :
	                from_moz(M.exported);
	            return new AST_Export({
	                start: my_start_token(M),
	                end: my_end_token(M),
	                exported_names: [
	                    new AST_NameMapping({
	                        name: new AST_SymbolExportForeign({ name: "*" }),
	                        foreign_name: foreign_name
	                    })
	                ],
	                module_name: from_moz(M.source),
	                assert_clause: assert_clause_from_moz(M.assertions)
	            });
	        },

	        ExportNamedDeclaration: function(M) {
	            return new AST_Export({
	                start: my_start_token(M),
	                end: my_end_token(M),
	                exported_definition: from_moz(M.declaration),
	                exported_names: M.specifiers && M.specifiers.length ? M.specifiers.map(from_moz) : null,
	                module_name: from_moz(M.source),
	                assert_clause: assert_clause_from_moz(M.assertions)
	            });
	        },

	        ExportDefaultDeclaration: function(M) {
	            return new AST_Export({
	                start: my_start_token(M),
	                end: my_end_token(M),
	                exported_value: from_moz(M.declaration),
	                is_default: true
	            });
	        },

	        ExportSpecifier: function(M) {
	            return new AST_NameMapping({
	                foreign_name: from_moz(M.exported),
	                name: from_moz(M.local)
	            });
	        },

	        Literal: function(M) {
	            var val = M.value, args = {
	                start  : my_start_token(M),
	                end    : my_end_token(M)
	            };
	            var rx = M.regex;
	            if (rx && rx.pattern) {
	                // RegExpLiteral as per ESTree AST spec
	                args.value = {
	                    source: rx.pattern,
	                    flags: rx.flags
	                };
	                return new AST_RegExp(args);
	            } else if (rx) {
	                // support legacy RegExp
	                const rx_source = M.raw || val;
	                const match = rx_source.match(/^\/(.*)\/(\w*)$/);
	                if (!match) throw new Error("Invalid regex source " + rx_source);
	                const [_, source, flags] = match;
	                args.value = { source, flags };
	                return new AST_RegExp(args);
	            }
	            if (val === null) return new AST_Null(args);
	            switch (typeof val) {
	              case "string":
	                args.quote = "\"";
	                var p = FROM_MOZ_STACK[FROM_MOZ_STACK.length - 2];
	                if (p.type == "ImportSpecifier") {
	                    args.name = val;
	                    return new AST_SymbolImportForeign(args);
	                } else if (p.type == "ExportSpecifier") {
	                    args.name = val;
	                    if (M == p.exported) {
	                        return new AST_SymbolExportForeign(args);
	                    } else {
	                        return new AST_SymbolExport(args);
	                    }
	                } else if (p.type == "ExportAllDeclaration" && M == p.exported) {
	                    args.name = val;
	                    return new AST_SymbolExportForeign(args);
	                }
	                args.value = val;
	                return new AST_String(args);
	              case "number":
	                args.value = val;
	                args.raw = M.raw || val.toString();
	                return new AST_Number(args);
	              case "boolean":
	                return new (val ? AST_True : AST_False)(args);
	            }
	        },

	        MetaProperty: function(M) {
	            if (M.meta.name === "new" && M.property.name === "target") {
	                return new AST_NewTarget({
	                    start: my_start_token(M),
	                    end: my_end_token(M)
	                });
	            } else if (M.meta.name === "import" && M.property.name === "meta") {
	                return new AST_ImportMeta({
	                    start: my_start_token(M),
	                    end: my_end_token(M)
	                });
	            }
	        },

	        Identifier: function(M) {
	            var p = FROM_MOZ_STACK[FROM_MOZ_STACK.length - 2];
	            return new (  p.type == "LabeledStatement" ? AST_Label
	                        : p.type == "VariableDeclarator" && p.id === M ? (p.kind == "const" ? AST_SymbolConst : p.kind == "let" ? AST_SymbolLet : AST_SymbolVar)
	                        : /Import.*Specifier/.test(p.type) ? (p.local === M ? AST_SymbolImport : AST_SymbolImportForeign)
	                        : p.type == "ExportSpecifier" ? (p.local === M ? AST_SymbolExport : AST_SymbolExportForeign)
	                        : p.type == "FunctionExpression" ? (p.id === M ? AST_SymbolLambda : AST_SymbolFunarg)
	                        : p.type == "FunctionDeclaration" ? (p.id === M ? AST_SymbolDefun : AST_SymbolFunarg)
	                        : p.type == "ArrowFunctionExpression" ? (p.params.includes(M)) ? AST_SymbolFunarg : AST_SymbolRef
	                        : p.type == "ClassExpression" ? (p.id === M ? AST_SymbolClass : AST_SymbolRef)
	                        : p.type == "Property" ? (p.key === M && p.computed || p.value === M ? AST_SymbolRef : AST_SymbolMethod)
	                        : p.type == "PropertyDefinition" || p.type === "FieldDefinition" ? (p.key === M && p.computed || p.value === M ? AST_SymbolRef : AST_SymbolClassProperty)
	                        : p.type == "ClassDeclaration" ? (p.id === M ? AST_SymbolDefClass : AST_SymbolRef)
	                        : p.type == "MethodDefinition" ? (p.computed ? AST_SymbolRef : AST_SymbolMethod)
	                        : p.type == "CatchClause" ? AST_SymbolCatch
	                        : p.type == "BreakStatement" || p.type == "ContinueStatement" ? AST_LabelRef
	                        : AST_SymbolRef)({
	                            start : my_start_token(M),
	                            end   : my_end_token(M),
	                            name  : M.name
	                        });
	        },

	        BigIntLiteral(M) {
	            return new AST_BigInt({
	                start : my_start_token(M),
	                end   : my_end_token(M),
	                value : M.value
	            });
	        },

	        EmptyStatement: function(M) {
	            return new AST_EmptyStatement({
	                start: my_start_token(M),
	                end: my_end_token(M)
	            });
	        },

	        BlockStatement: function(M) {
	            return new AST_BlockStatement({
	                start: my_start_token(M),
	                end: my_end_token(M),
	                body: M.body.map(from_moz)
	            });
	        },

	        IfStatement: function(M) {
	            return new AST_If({
	                start: my_start_token(M),
	                end: my_end_token(M),
	                condition: from_moz(M.test),
	                body: from_moz(M.consequent),
	                alternative: from_moz(M.alternate)
	            });
	        },

	        LabeledStatement: function(M) {
	            return new AST_LabeledStatement({
	                start: my_start_token(M),
	                end: my_end_token(M),
	                label: from_moz(M.label),
	                body: from_moz(M.body)
	            });
	        },

	        BreakStatement: function(M) {
	            return new AST_Break({
	                start: my_start_token(M),
	                end: my_end_token(M),
	                label: from_moz(M.label)
	            });
	        },

	        ContinueStatement: function(M) {
	            return new AST_Continue({
	                start: my_start_token(M),
	                end: my_end_token(M),
	                label: from_moz(M.label)
	            });
	        },

	        WithStatement: function(M) {
	            return new AST_With({
	                start: my_start_token(M),
	                end: my_end_token(M),
	                expression: from_moz(M.object),
	                body: from_moz(M.body)
	            });
	        },

	        SwitchStatement: function(M) {
	            return new AST_Switch({
	                start: my_start_token(M),
	                end: my_end_token(M),
	                expression: from_moz(M.discriminant),
	                body: M.cases.map(from_moz)
	            });
	        },

	        ReturnStatement: function(M) {
	            return new AST_Return({
	                start: my_start_token(M),
	                end: my_end_token(M),
	                value: from_moz(M.argument)
	            });
	        },

	        ThrowStatement: function(M) {
	            return new AST_Throw({
	                start: my_start_token(M),
	                end: my_end_token(M),
	                value: from_moz(M.argument)
	            });
	        },

	        WhileStatement: function(M) {
	            return new AST_While({
	                start: my_start_token(M),
	                end: my_end_token(M),
	                condition: from_moz(M.test),
	                body: from_moz(M.body)
	            });
	        },

	        DoWhileStatement: function(M) {
	            return new AST_Do({
	                start: my_start_token(M),
	                end: my_end_token(M),
	                condition: from_moz(M.test),
	                body: from_moz(M.body)
	            });
	        },

	        ForStatement: function(M) {
	            return new AST_For({
	                start: my_start_token(M),
	                end: my_end_token(M),
	                init: from_moz(M.init),
	                condition: from_moz(M.test),
	                step: from_moz(M.update),
	                body: from_moz(M.body)
	            });
	        },

	        ForInStatement: function(M) {
	            return new AST_ForIn({
	                start: my_start_token(M),
	                end: my_end_token(M),
	                init: from_moz(M.left),
	                object: from_moz(M.right),
	                body: from_moz(M.body)
	            });
	        },

	        ForOfStatement: function(M) {
	            return new AST_ForOf({
	                start: my_start_token(M),
	                end: my_end_token(M),
	                init: from_moz(M.left),
	                object: from_moz(M.right),
	                body: from_moz(M.body),
	                await: M.await
	            });
	        },

	        AwaitExpression: function(M) {
	            return new AST_Await({
	                start: my_start_token(M),
	                end: my_end_token(M),
	                expression: from_moz(M.argument)
	            });
	        },

	        YieldExpression: function(M) {
	            return new AST_Yield({
	                start: my_start_token(M),
	                end: my_end_token(M),
	                expression: from_moz(M.argument),
	                is_star: M.delegate
	            });
	        },

	        DebuggerStatement: function(M) {
	            return new AST_Debugger({
	                start: my_start_token(M),
	                end: my_end_token(M)
	            });
	        },

	        VariableDeclarator: function(M) {
	            return new AST_VarDef({
	                start: my_start_token(M),
	                end: my_end_token(M),
	                name: from_moz(M.id),
	                value: from_moz(M.init)
	            });
	        },

	        CatchClause: function(M) {
	            return new AST_Catch({
	                start: my_start_token(M),
	                end: my_end_token(M),
	                argname: from_moz(M.param),
	                body: from_moz(M.body).body
	            });
	        },

	        ThisExpression: function(M) {
	            return new AST_This({
	                start: my_start_token(M),
	                end: my_end_token(M)
	            });
	        },

	        Super: function(M) {
	            return new AST_Super({
	                start: my_start_token(M),
	                end: my_end_token(M)
	            });
	        },

	        BinaryExpression: function(M) {
	            if (M.left.type === "PrivateIdentifier") {
	                return new AST_PrivateIn({
	                    start: my_start_token(M),
	                    end: my_end_token(M),
	                    key: new AST_SymbolPrivateProperty({
	                        start: my_start_token(M.left),
	                        end: my_end_token(M.left),
	                        name: M.left.name
	                    }),
	                    value: from_moz(M.right),
	                });
	            }
	            return new AST_Binary({
	                start: my_start_token(M),
	                end: my_end_token(M),
	                operator: M.operator,
	                left: from_moz(M.left),
	                right: from_moz(M.right)
	            });
	        },

	        LogicalExpression: function(M) {
	            return new AST_Binary({
	                start: my_start_token(M),
	                end: my_end_token(M),
	                operator: M.operator,
	                left: from_moz(M.left),
	                right: from_moz(M.right)
	            });
	        },

	        AssignmentExpression: function(M) {
	            return new AST_Assign({
	                start: my_start_token(M),
	                end: my_end_token(M),
	                operator: M.operator,
	                left: from_moz(M.left),
	                right: from_moz(M.right)
	            });
	        },

	        ConditionalExpression: function(M) {
	            return new AST_Conditional({
	                start: my_start_token(M),
	                end: my_end_token(M),
	                condition: from_moz(M.test),
	                consequent: from_moz(M.consequent),
	                alternative: from_moz(M.alternate)
	            });
	        },

	        NewExpression: function(M) {
	            return new AST_New({
	                start: my_start_token(M),
	                end: my_end_token(M),
	                expression: from_moz(M.callee),
	                args: M.arguments.map(from_moz)
	            });
	        },

	        CallExpression: function(M) {
	            return new AST_Call({
	                start: my_start_token(M),
	                end: my_end_token(M),
	                expression: from_moz(M.callee),
	                optional: M.optional,
	                args: M.arguments.map(from_moz)
	            });
	        }
	    };

	    MOZ_TO_ME.UpdateExpression =
	    MOZ_TO_ME.UnaryExpression = function To_Moz_Unary(M) {
	        var prefix = "prefix" in M ? M.prefix
	            : M.type == "UnaryExpression" ? true : false;
	        return new (prefix ? AST_UnaryPrefix : AST_UnaryPostfix)({
	            start      : my_start_token(M),
	            end        : my_end_token(M),
	            operator   : M.operator,
	            expression : from_moz(M.argument)
	        });
	    };

	    MOZ_TO_ME.ClassDeclaration =
	    MOZ_TO_ME.ClassExpression = function From_Moz_Class(M) {
	        return new (M.type === "ClassDeclaration" ? AST_DefClass : AST_ClassExpression)({
	            start    : my_start_token(M),
	            end      : my_end_token(M),
	            name     : from_moz(M.id),
	            extends  : from_moz(M.superClass),
	            properties: M.body.body.map(from_moz)
	        });
	    };

	    def_to_moz(AST_EmptyStatement, function To_Moz_EmptyStatement() {
	        return {
	            type: "EmptyStatement"
	        };
	    });
	    def_to_moz(AST_BlockStatement, function To_Moz_BlockStatement(M) {
	        return {
	            type: "BlockStatement",
	            body: M.body.map(to_moz)
	        };
	    });
	    def_to_moz(AST_If, function To_Moz_IfStatement(M) {
	        return {
	            type: "IfStatement",
	            test: to_moz(M.condition),
	            consequent: to_moz(M.body),
	            alternate: to_moz(M.alternative)
	        };
	    });
	    def_to_moz(AST_LabeledStatement, function To_Moz_LabeledStatement(M) {
	        return {
	            type: "LabeledStatement",
	            label: to_moz(M.label),
	            body: to_moz(M.body)
	        };
	    });
	    def_to_moz(AST_Break, function To_Moz_BreakStatement(M) {
	        return {
	            type: "BreakStatement",
	            label: to_moz(M.label)
	        };
	    });
	    def_to_moz(AST_Continue, function To_Moz_ContinueStatement(M) {
	        return {
	            type: "ContinueStatement",
	            label: to_moz(M.label)
	        };
	    });
	    def_to_moz(AST_With, function To_Moz_WithStatement(M) {
	        return {
	            type: "WithStatement",
	            object: to_moz(M.expression),
	            body: to_moz(M.body)
	        };
	    });
	    def_to_moz(AST_Switch, function To_Moz_SwitchStatement(M) {
	        return {
	            type: "SwitchStatement",
	            discriminant: to_moz(M.expression),
	            cases: M.body.map(to_moz)
	        };
	    });
	    def_to_moz(AST_Return, function To_Moz_ReturnStatement(M) {
	        return {
	            type: "ReturnStatement",
	            argument: to_moz(M.value)
	        };
	    });
	    def_to_moz(AST_Throw, function To_Moz_ThrowStatement(M) {
	        return {
	            type: "ThrowStatement",
	            argument: to_moz(M.value)
	        };
	    });
	    def_to_moz(AST_While, function To_Moz_WhileStatement(M) {
	        return {
	            type: "WhileStatement",
	            test: to_moz(M.condition),
	            body: to_moz(M.body)
	        };
	    });
	    def_to_moz(AST_Do, function To_Moz_DoWhileStatement(M) {
	        return {
	            type: "DoWhileStatement",
	            test: to_moz(M.condition),
	            body: to_moz(M.body)
	        };
	    });
	    def_to_moz(AST_For, function To_Moz_ForStatement(M) {
	        return {
	            type: "ForStatement",
	            init: to_moz(M.init),
	            test: to_moz(M.condition),
	            update: to_moz(M.step),
	            body: to_moz(M.body)
	        };
	    });
	    def_to_moz(AST_ForIn, function To_Moz_ForInStatement(M) {
	        return {
	            type: "ForInStatement",
	            left: to_moz(M.init),
	            right: to_moz(M.object),
	            body: to_moz(M.body)
	        };
	    });
	    def_to_moz(AST_ForOf, function To_Moz_ForOfStatement(M) {
	        return {
	            type: "ForOfStatement",
	            left: to_moz(M.init),
	            right: to_moz(M.object),
	            body: to_moz(M.body),
	            await: M.await
	        };
	    });
	    def_to_moz(AST_Await, function To_Moz_AwaitExpression(M) {
	        return {
	            type: "AwaitExpression",
	            argument: to_moz(M.expression)
	        };
	    });
	    def_to_moz(AST_Yield, function To_Moz_YieldExpression(M) {
	        return {
	            type: "YieldExpression",
	            argument: to_moz(M.expression),
	            delegate: M.is_star
	        };
	    });
	    def_to_moz(AST_Debugger, function To_Moz_DebuggerStatement() {
	        return {
	            type: "DebuggerStatement"
	        };
	    });
	    def_to_moz(AST_VarDef, function To_Moz_VariableDeclarator(M) {
	        return {
	            type: "VariableDeclarator",
	            id: to_moz(M.name),
	            init: to_moz(M.value)
	        };
	    });
	    def_to_moz(AST_Catch, function To_Moz_CatchClause(M) {
	        return {
	            type: "CatchClause",
	            param: to_moz(M.argname),
	            body: to_moz_block(M)
	        };
	    });

	    def_to_moz(AST_This, function To_Moz_ThisExpression() {
	        return {
	            type: "ThisExpression"
	        };
	    });
	    def_to_moz(AST_Super, function To_Moz_Super() {
	        return {
	            type: "Super"
	        };
	    });
	    def_to_moz(AST_Binary, function To_Moz_BinaryExpression(M) {
	        return {
	            type: "BinaryExpression",
	            operator: M.operator,
	            left: to_moz(M.left),
	            right: to_moz(M.right)
	        };
	    });
	    def_to_moz(AST_Binary, function To_Moz_LogicalExpression(M) {
	        return {
	            type: "LogicalExpression",
	            operator: M.operator,
	            left: to_moz(M.left),
	            right: to_moz(M.right)
	        };
	    });
	    def_to_moz(AST_Assign, function To_Moz_AssignmentExpression(M) {
	        return {
	            type: "AssignmentExpression",
	            operator: M.operator,
	            left: to_moz(M.left),
	            right: to_moz(M.right)
	        };
	    });
	    def_to_moz(AST_Conditional, function To_Moz_ConditionalExpression(M) {
	        return {
	            type: "ConditionalExpression",
	            test: to_moz(M.condition),
	            consequent: to_moz(M.consequent),
	            alternate: to_moz(M.alternative)
	        };
	    });
	    def_to_moz(AST_New, function To_Moz_NewExpression(M) {
	        return {
	            type: "NewExpression",
	            callee: to_moz(M.expression),
	            arguments: M.args.map(to_moz)
	        };
	    });
	    def_to_moz(AST_Call, function To_Moz_CallExpression(M) {
	        return {
	            type: "CallExpression",
	            callee: to_moz(M.expression),
	            optional: M.optional,
	            arguments: M.args.map(to_moz)
	        };
	    });

	    def_to_moz(AST_Toplevel, function To_Moz_Program(M) {
	        return to_moz_scope("Program", M);
	    });

	    def_to_moz(AST_Expansion, function To_Moz_Spread(M) {
	        return {
	            type: to_moz_in_destructuring() ? "RestElement" : "SpreadElement",
	            argument: to_moz(M.expression)
	        };
	    });

	    def_to_moz(AST_PrefixedTemplateString, function To_Moz_TaggedTemplateExpression(M) {
	        return {
	            type: "TaggedTemplateExpression",
	            tag: to_moz(M.prefix),
	            quasi: to_moz(M.template_string)
	        };
	    });

	    def_to_moz(AST_TemplateString, function To_Moz_TemplateLiteral(M) {
	        var quasis = [];
	        var expressions = [];
	        for (var i = 0; i < M.segments.length; i++) {
	            if (i % 2 !== 0) {
	                expressions.push(to_moz(M.segments[i]));
	            } else {
	                quasis.push({
	                    type: "TemplateElement",
	                    value: {
	                        raw: M.segments[i].raw,
	                        cooked: M.segments[i].value
	                    },
	                    tail: i === M.segments.length - 1
	                });
	            }
	        }
	        return {
	            type: "TemplateLiteral",
	            quasis: quasis,
	            expressions: expressions
	        };
	    });

	    def_to_moz(AST_Defun, function To_Moz_FunctionDeclaration(M) {
	        return {
	            type: "FunctionDeclaration",
	            id: to_moz(M.name),
	            params: M.argnames.map(to_moz),
	            generator: M.is_generator,
	            async: M.async,
	            body: to_moz_scope("BlockStatement", M)
	        };
	    });

	    def_to_moz(AST_Function, function To_Moz_FunctionExpression(M, parent) {
	        var is_generator = parent.is_generator !== undefined ?
	            parent.is_generator : M.is_generator;
	        return {
	            type: "FunctionExpression",
	            id: to_moz(M.name),
	            params: M.argnames.map(to_moz),
	            generator: is_generator,
	            async: M.async,
	            body: to_moz_scope("BlockStatement", M)
	        };
	    });

	    def_to_moz(AST_Arrow, function To_Moz_ArrowFunctionExpression(M) {
	        var body = {
	            type: "BlockStatement",
	            body: M.body.map(to_moz)
	        };
	        return {
	            type: "ArrowFunctionExpression",
	            params: M.argnames.map(to_moz),
	            async: M.async,
	            body: body
	        };
	    });

	    def_to_moz(AST_Destructuring, function To_Moz_ObjectPattern(M) {
	        if (M.is_array) {
	            return {
	                type: "ArrayPattern",
	                elements: M.names.map(to_moz)
	            };
	        }
	        return {
	            type: "ObjectPattern",
	            properties: M.names.map(to_moz)
	        };
	    });

	    def_to_moz(AST_Directive, function To_Moz_Directive(M) {
	        return {
	            type: "ExpressionStatement",
	            expression: {
	                type: "Literal",
	                value: M.value,
	                raw: M.print_to_string()
	            },
	            directive: M.value
	        };
	    });

	    def_to_moz(AST_SimpleStatement, function To_Moz_ExpressionStatement(M) {
	        return {
	            type: "ExpressionStatement",
	            expression: to_moz(M.body)
	        };
	    });

	    def_to_moz(AST_SwitchBranch, function To_Moz_SwitchCase(M) {
	        return {
	            type: "SwitchCase",
	            test: to_moz(M.expression),
	            consequent: M.body.map(to_moz)
	        };
	    });

	    def_to_moz(AST_Try, function To_Moz_TryStatement(M) {
	        return {
	            type: "TryStatement",
	            block: to_moz_block(M.body),
	            handler: to_moz(M.bcatch),
	            guardedHandlers: [],
	            finalizer: to_moz(M.bfinally)
	        };
	    });

	    def_to_moz(AST_Catch, function To_Moz_CatchClause(M) {
	        return {
	            type: "CatchClause",
	            param: to_moz(M.argname),
	            guard: null,
	            body: to_moz_block(M)
	        };
	    });

	    def_to_moz(AST_Definitions, function To_Moz_VariableDeclaration(M) {
	        return {
	            type: "VariableDeclaration",
	            kind:
	                M instanceof AST_Const ? "const" :
	                M instanceof AST_Let ? "let" : "var",
	            declarations: M.definitions.map(to_moz)
	        };
	    });

	    const assert_clause_to_moz = assert_clause => {
	        const assertions = [];
	        if (assert_clause) {
	            for (const { key, value } of assert_clause.properties) {
	                const key_moz = is_basic_identifier_string(key)
	                    ? { type: "Identifier", name: key }
	                    : { type: "Literal", value: key, raw: JSON.stringify(key) };
	                assertions.push({
	                    type: "ImportAttribute",
	                    key: key_moz,
	                    value: to_moz(value)
	                });
	            }
	        }
	        return assertions;
	    };

	    def_to_moz(AST_Export, function To_Moz_ExportDeclaration(M) {
	        if (M.exported_names) {
	            var first_exported = M.exported_names[0];
	            var first_exported_name = first_exported.name;
	            if (first_exported_name.name === "*" && !first_exported_name.quote) {
	                var foreign_name = first_exported.foreign_name;
	                var exported = foreign_name.name === "*" && !foreign_name.quote
	                    ? null
	                    : to_moz(foreign_name);
	                return {
	                    type: "ExportAllDeclaration",
	                    source: to_moz(M.module_name),
	                    exported: exported,
	                    assertions: assert_clause_to_moz(M.assert_clause)
	                };
	            }
	            return {
	                type: "ExportNamedDeclaration",
	                specifiers: M.exported_names.map(function (name_mapping) {
	                    return {
	                        type: "ExportSpecifier",
	                        exported: to_moz(name_mapping.foreign_name),
	                        local: to_moz(name_mapping.name)
	                    };
	                }),
	                declaration: to_moz(M.exported_definition),
	                source: to_moz(M.module_name),
	                assertions: assert_clause_to_moz(M.assert_clause)
	            };
	        }
	        return {
	            type: M.is_default ? "ExportDefaultDeclaration" : "ExportNamedDeclaration",
	            declaration: to_moz(M.exported_value || M.exported_definition)
	        };
	    });

	    def_to_moz(AST_Import, function To_Moz_ImportDeclaration(M) {
	        var specifiers = [];
	        if (M.imported_name) {
	            specifiers.push({
	                type: "ImportDefaultSpecifier",
	                local: to_moz(M.imported_name)
	            });
	        }
	        if (M.imported_names) {
	            var first_imported_foreign_name = M.imported_names[0].foreign_name;
	            if (first_imported_foreign_name.name === "*" && !first_imported_foreign_name.quote) {
	                specifiers.push({
	                    type: "ImportNamespaceSpecifier",
	                    local: to_moz(M.imported_names[0].name)
	                });
	            } else {
	                M.imported_names.forEach(function(name_mapping) {
	                    specifiers.push({
	                        type: "ImportSpecifier",
	                        local: to_moz(name_mapping.name),
	                        imported: to_moz(name_mapping.foreign_name)
	                    });
	                });
	            }
	        }
	        return {
	            type: "ImportDeclaration",
	            specifiers: specifiers,
	            source: to_moz(M.module_name),
	            assertions: assert_clause_to_moz(M.assert_clause)
	        };
	    });

	    def_to_moz(AST_ImportMeta, function To_Moz_MetaProperty() {
	        return {
	            type: "MetaProperty",
	            meta: {
	                type: "Identifier",
	                name: "import"
	            },
	            property: {
	                type: "Identifier",
	                name: "meta"
	            }
	        };
	    });

	    def_to_moz(AST_Sequence, function To_Moz_SequenceExpression(M) {
	        return {
	            type: "SequenceExpression",
	            expressions: M.expressions.map(to_moz)
	        };
	    });

	    def_to_moz(AST_DotHash, function To_Moz_PrivateMemberExpression(M) {
	        return {
	            type: "MemberExpression",
	            object: to_moz(M.expression),
	            computed: false,
	            property: {
	                type: "PrivateIdentifier",
	                name: M.property
	            },
	            optional: M.optional
	        };
	    });

	    def_to_moz(AST_PropAccess, function To_Moz_MemberExpression(M) {
	        var isComputed = M instanceof AST_Sub;
	        return {
	            type: "MemberExpression",
	            object: to_moz(M.expression),
	            computed: isComputed,
	            property: isComputed ? to_moz(M.property) : {type: "Identifier", name: M.property},
	            optional: M.optional
	        };
	    });

	    def_to_moz(AST_Chain, function To_Moz_ChainExpression(M) {
	        return {
	            type: "ChainExpression",
	            expression: to_moz(M.expression)
	        };
	    });

	    def_to_moz(AST_Unary, function To_Moz_Unary(M) {
	        return {
	            type: M.operator == "++" || M.operator == "--" ? "UpdateExpression" : "UnaryExpression",
	            operator: M.operator,
	            prefix: M instanceof AST_UnaryPrefix,
	            argument: to_moz(M.expression)
	        };
	    });

	    def_to_moz(AST_Binary, function To_Moz_BinaryExpression(M) {
	        if (M.operator == "=" && to_moz_in_destructuring()) {
	            return {
	                type: "AssignmentPattern",
	                left: to_moz(M.left),
	                right: to_moz(M.right)
	            };
	        }

	        const type = M.operator == "&&" || M.operator == "||" || M.operator === "??"
	            ? "LogicalExpression"
	            : "BinaryExpression";

	        return {
	            type,
	            left: to_moz(M.left),
	            operator: M.operator,
	            right: to_moz(M.right)
	        };
	    });

	    def_to_moz(AST_PrivateIn, function To_Moz_BinaryExpression_PrivateIn(M) {
	        return {
	            type: "BinaryExpression",
	            left: { type: "PrivateIdentifier", name: M.key.name },
	            operator: "in",
	            right: to_moz(M.value),
	        };
	    });

	    def_to_moz(AST_Array, function To_Moz_ArrayExpression(M) {
	        return {
	            type: "ArrayExpression",
	            elements: M.elements.map(to_moz)
	        };
	    });

	    def_to_moz(AST_Object, function To_Moz_ObjectExpression(M) {
	        return {
	            type: "ObjectExpression",
	            properties: M.properties.map(to_moz)
	        };
	    });

	    def_to_moz(AST_ObjectProperty, function To_Moz_Property(M, parent) {
	        var key = M.key instanceof AST_Node ? to_moz(M.key) : {
	            type: "Identifier",
	            value: M.key
	        };
	        if (typeof M.key === "number") {
	            key = {
	                type: "Literal",
	                value: Number(M.key)
	            };
	        }
	        if (typeof M.key === "string") {
	            key = {
	                type: "Identifier",
	                name: M.key
	            };
	        }
	        var kind;
	        var string_or_num = typeof M.key === "string" || typeof M.key === "number";
	        var computed = string_or_num ? false : !(M.key instanceof AST_Symbol) || M.key instanceof AST_SymbolRef;
	        if (M instanceof AST_ObjectKeyVal) {
	            kind = "init";
	            computed = !string_or_num;
	        } else
	        if (M instanceof AST_ObjectGetter) {
	            kind = "get";
	        } else
	        if (M instanceof AST_ObjectSetter) {
	            kind = "set";
	        }
	        if (M instanceof AST_PrivateGetter || M instanceof AST_PrivateSetter) {
	            const kind = M instanceof AST_PrivateGetter ? "get" : "set";
	            return {
	                type: "MethodDefinition",
	                computed: false,
	                kind: kind,
	                static: M.static,
	                key: {
	                    type: "PrivateIdentifier",
	                    name: M.key.name
	                },
	                value: to_moz(M.value)
	            };
	        }
	        if (M instanceof AST_ClassPrivateProperty) {
	            return {
	                type: "PropertyDefinition",
	                key: {
	                    type: "PrivateIdentifier",
	                    name: M.key.name
	                },
	                value: to_moz(M.value),
	                computed: false,
	                static: M.static
	            };
	        }
	        if (M instanceof AST_ClassProperty) {
	            return {
	                type: "PropertyDefinition",
	                key,
	                value: to_moz(M.value),
	                computed,
	                static: M.static
	            };
	        }
	        if (parent instanceof AST_Class) {
	            return {
	                type: "MethodDefinition",
	                computed: computed,
	                kind: kind,
	                static: M.static,
	                key: to_moz(M.key),
	                value: to_moz(M.value)
	            };
	        }
	        return {
	            type: "Property",
	            computed: computed,
	            kind: kind,
	            key: key,
	            value: to_moz(M.value)
	        };
	    });

	    def_to_moz(AST_ConciseMethod, function To_Moz_MethodDefinition(M, parent) {
	        if (parent instanceof AST_Object) {
	            return {
	                type: "Property",
	                computed: !(M.key instanceof AST_Symbol) || M.key instanceof AST_SymbolRef,
	                kind: "init",
	                method: true,
	                shorthand: false,
	                key: to_moz(M.key),
	                value: to_moz(M.value)
	            };
	        }

	        const key = M instanceof AST_PrivateMethod
	            ? {
	                type: "PrivateIdentifier",
	                name: M.key.name
	            }
	            : to_moz(M.key);

	        return {
	            type: "MethodDefinition",
	            kind: M.key === "constructor" ? "constructor" : "method",
	            key,
	            value: to_moz(M.value),
	            computed: !(M.key instanceof AST_Symbol) || M.key instanceof AST_SymbolRef,
	            static: M.static,
	        };
	    });

	    def_to_moz(AST_Class, function To_Moz_Class(M) {
	        var type = M instanceof AST_ClassExpression ? "ClassExpression" : "ClassDeclaration";
	        return {
	            type: type,
	            superClass: to_moz(M.extends),
	            id: M.name ? to_moz(M.name) : null,
	            body: {
	                type: "ClassBody",
	                body: M.properties.map(to_moz)
	            }
	        };
	    });

	    def_to_moz(AST_ClassStaticBlock, function To_Moz_StaticBlock(M) {
	        return {
	            type: "StaticBlock",
	            body: M.body.map(to_moz),
	        };
	    });

	    def_to_moz(AST_NewTarget, function To_Moz_MetaProperty() {
	        return {
	            type: "MetaProperty",
	            meta: {
	                type: "Identifier",
	                name: "new"
	            },
	            property: {
	                type: "Identifier",
	                name: "target"
	            }
	        };
	    });

	    def_to_moz(AST_Symbol, function To_Moz_Identifier(M, parent) {
	        if (
	            (M instanceof AST_SymbolMethod && parent.quote) ||
	            ((
	                M instanceof AST_SymbolImportForeign ||
	                M instanceof AST_SymbolExportForeign ||
	                M instanceof AST_SymbolExport
	                ) && M.quote)
	         ) {
	            return {
	                type: "Literal",
	                value: M.name
	            };
	        }
	        var def = M.definition();
	        return {
	            type: "Identifier",
	            name: def ? def.mangled_name || def.name : M.name
	        };
	    });

	    def_to_moz(AST_RegExp, function To_Moz_RegExpLiteral(M) {
	        const pattern = M.value.source;
	        const flags = M.value.flags;
	        return {
	            type: "Literal",
	            value: null,
	            raw: M.print_to_string(),
	            regex: { pattern, flags }
	        };
	    });

	    def_to_moz(AST_Constant, function To_Moz_Literal(M) {
	        var value = M.value;
	        return {
	            type: "Literal",
	            value: value,
	            raw: M.raw || M.print_to_string()
	        };
	    });

	    def_to_moz(AST_Atom, function To_Moz_Atom(M) {
	        return {
	            type: "Identifier",
	            name: String(M.value)
	        };
	    });

	    def_to_moz(AST_BigInt, M => ({
	        type: "BigIntLiteral",
	        value: M.value
	    }));

	    AST_Boolean.DEFMETHOD("to_mozilla_ast", AST_Constant.prototype.to_mozilla_ast);
	    AST_Null.DEFMETHOD("to_mozilla_ast", AST_Constant.prototype.to_mozilla_ast);
	    AST_Hole.DEFMETHOD("to_mozilla_ast", function To_Moz_ArrayHole() { return null; });

	    AST_Block.DEFMETHOD("to_mozilla_ast", AST_BlockStatement.prototype.to_mozilla_ast);
	    AST_Lambda.DEFMETHOD("to_mozilla_ast", AST_Function.prototype.to_mozilla_ast);

	    /* -----[ tools ]----- */

	    function my_start_token(moznode) {
	        var loc = moznode.loc, start = loc && loc.start;
	        var range = moznode.range;
	        return new AST_Token(
	            "",
	            "",
	            start && start.line || 0,
	            start && start.column || 0,
	            range ? range [0] : moznode.start,
	            false,
	            [],
	            [],
	            loc && loc.source,
	        );
	    }

	    function my_end_token(moznode) {
	        var loc = moznode.loc, end = loc && loc.end;
	        var range = moznode.range;
	        return new AST_Token(
	            "",
	            "",
	            end && end.line || 0,
	            end && end.column || 0,
	            range ? range [0] : moznode.end,
	            false,
	            [],
	            [],
	            loc && loc.source,
	        );
	    }

	    var FROM_MOZ_STACK = null;

	    function from_moz(node) {
	        FROM_MOZ_STACK.push(node);
	        var ret = node != null ? MOZ_TO_ME[node.type](node) : null;
	        FROM_MOZ_STACK.pop();
	        return ret;
	    }

	    AST_Node.from_mozilla_ast = function(node) {
	        var save_stack = FROM_MOZ_STACK;
	        FROM_MOZ_STACK = [];
	        var ast = from_moz(node);
	        FROM_MOZ_STACK = save_stack;
	        return ast;
	    };

	    function set_moz_loc(mynode, moznode) {
	        var start = mynode.start;
	        var end = mynode.end;
	        if (!(start && end)) {
	            return moznode;
	        }
	        if (start.pos != null && end.endpos != null) {
	            moznode.range = [start.pos, end.endpos];
	        }
	        if (start.line) {
	            moznode.loc = {
	                start: {line: start.line, column: start.col},
	                end: end.endline ? {line: end.endline, column: end.endcol} : null
	            };
	            if (start.file) {
	                moznode.loc.source = start.file;
	            }
	        }
	        return moznode;
	    }

	    function def_to_moz(mytype, handler) {
	        mytype.DEFMETHOD("to_mozilla_ast", function(parent) {
	            return set_moz_loc(this, handler(this, parent));
	        });
	    }

	    var TO_MOZ_STACK = null;

	    function to_moz(node) {
	        if (TO_MOZ_STACK === null) { TO_MOZ_STACK = []; }
	        TO_MOZ_STACK.push(node);
	        var ast = node != null ? node.to_mozilla_ast(TO_MOZ_STACK[TO_MOZ_STACK.length - 2]) : null;
	        TO_MOZ_STACK.pop();
	        if (TO_MOZ_STACK.length === 0) { TO_MOZ_STACK = null; }
	        return ast;
	    }

	    function to_moz_in_destructuring() {
	        var i = TO_MOZ_STACK.length;
	        while (i--) {
	            if (TO_MOZ_STACK[i] instanceof AST_Destructuring) {
	                return true;
	            }
	        }
	        return false;
	    }

	    function to_moz_block(node) {
	        return {
	            type: "BlockStatement",
	            body: node.body.map(to_moz)
	        };
	    }

	    function to_moz_scope(type, node) {
	        var body = node.body.map(to_moz);
	        if (node.body[0] instanceof AST_SimpleStatement && node.body[0].body instanceof AST_String) {
	            body.unshift(to_moz(new AST_EmptyStatement(node.body[0])));
	        }
	        return {
	            type: type,
	            body: body
	        };
	    }
	})();

	// return true if the node at the top of the stack (that means the
	// innermost node in the current output) is lexically the first in
	// a statement.
	function first_in_statement(stack) {
	    let node = stack.parent(-1);
	    for (let i = 0, p; p = stack.parent(i); i++) {
	        if (p instanceof AST_Statement && p.body === node)
	            return true;
	        if ((p instanceof AST_Sequence && p.expressions[0] === node) ||
	            (p.TYPE === "Call" && p.expression === node) ||
	            (p instanceof AST_PrefixedTemplateString && p.prefix === node) ||
	            (p instanceof AST_Dot && p.expression === node) ||
	            (p instanceof AST_Sub && p.expression === node) ||
	            (p instanceof AST_Chain && p.expression === node) ||
	            (p instanceof AST_Conditional && p.condition === node) ||
	            (p instanceof AST_Binary && p.left === node) ||
	            (p instanceof AST_UnaryPostfix && p.expression === node)
	        ) {
	            node = p;
	        } else {
	            return false;
	        }
	    }
	}

	// Returns whether the leftmost item in the expression is an object
	function left_is_object(node) {
	    if (node instanceof AST_Object) return true;
	    if (node instanceof AST_Sequence) return left_is_object(node.expressions[0]);
	    if (node.TYPE === "Call") return left_is_object(node.expression);
	    if (node instanceof AST_PrefixedTemplateString) return left_is_object(node.prefix);
	    if (node instanceof AST_Dot || node instanceof AST_Sub) return left_is_object(node.expression);
	    if (node instanceof AST_Chain) return left_is_object(node.expression);
	    if (node instanceof AST_Conditional) return left_is_object(node.condition);
	    if (node instanceof AST_Binary) return left_is_object(node.left);
	    if (node instanceof AST_UnaryPostfix) return left_is_object(node.expression);
	    return false;
	}

	/***********************************************************************

	  A JavaScript tokenizer / parser / beautifier / compressor.
	  https://github.com/mishoo/UglifyJS2

	  -------------------------------- (C) ---------------------------------

	                           Author: Mihai Bazon
	                         <mihai.bazon@gmail.com>
	                       http://mihai.bazon.net/blog

	  Distributed under the BSD license:

	    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

	    Redistribution and use in source and binary forms, with or without
	    modification, are permitted provided that the following conditions
	    are met:

	        * Redistributions of source code must retain the above
	          copyright notice, this list of conditions and the following
	          disclaimer.

	        * Redistributions in binary form must reproduce the above
	          copyright notice, this list of conditions and the following
	          disclaimer in the documentation and/or other materials
	          provided with the distribution.

	    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
	    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
	    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
	    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
	    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
	    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
	    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
	    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
	    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
	    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
	    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
	    SUCH DAMAGE.

	 ***********************************************************************/

	const CODE_LINE_BREAK = 10;
	const CODE_SPACE = 32;

	const r_annotation = /[@#]__(PURE|INLINE|NOINLINE)__/;

	function is_some_comments(comment) {
	    // multiline comment
	    return (
	        (comment.type === "comment2" || comment.type === "comment1")
	        && /@preserve|@copyright|@lic|@cc_on|^\**!/i.test(comment.value)
	    );
	}

	const ROPE_COMMIT_WHEN = 8 * 1000;
	class Rope {
	    constructor() {
	        this.committed = "";
	        this.current = "";
	    }

	    append(str) {
	        /** When `this.current` is too long, commit it. */
	        if (this.current.length > ROPE_COMMIT_WHEN) {
	            this.committed += this.current + str;
	            this.current = "";
	        } else {
	            this.current += str;
	        }
	    }

	    insertAt(char, index) {
	        const { committed, current } = this;
	        if (index < committed.length) {
	            this.committed = committed.slice(0, index) + char + committed.slice(index);
	        } else if (index === committed.length) {
	            this.committed += char;
	        } else {
	            index -= committed.length;
	            this.committed += current.slice(0, index) + char;
	            this.current = current.slice(index);
	        }
	    }

	    charAt(index) {
	        const { committed } = this;
	        if (index < committed.length) return committed[index];
	        return this.current[index - committed.length];
	    }

	    charCodeAt(index) {
	        const { committed } = this;
	        if (index < committed.length) return committed.charCodeAt(index);
	        return this.current.charCodeAt(index - committed.length);
	    }

	    length() {
	        return this.committed.length + this.current.length;
	    }

	    expectDirective() {
	        // /^$|[;{][\s\n]*$/

	        let ch, n = this.length();

	        if (n <= 0) return true;

	        // Skip N whitespace from the end
	        while (
	            (ch = this.charCodeAt(--n))
	            && (ch == CODE_SPACE || ch == CODE_LINE_BREAK)
	        );

	        // either ";", or "{", or the string ended
	        return !ch || ch === 59 || ch === 123;
	    }

	    hasNLB() {
	        let n = this.length() - 1;
	        while (n >= 0) {
	            const code = this.charCodeAt(n--);

	            if (code === CODE_LINE_BREAK) return true;
	            if (code !== CODE_SPACE) return false;
	        }
	        return true;
	    }


	    toString() {
	        return this.committed + this.current;
	    }
	}

	function OutputStream(options) {

	    var readonly = !options;
	    options = defaults(options, {
	        ascii_only           : false,
	        beautify             : false,
	        braces               : false,
	        comments             : "some",
	        ecma                 : 5,
	        ie8                  : false,
	        indent_level         : 4,
	        indent_start         : 0,
	        inline_script        : true,
	        keep_numbers         : false,
	        keep_quoted_props    : false,
	        max_line_len         : false,
	        preamble             : null,
	        preserve_annotations : false,
	        quote_keys           : false,
	        quote_style          : 0,
	        safari10             : false,
	        semicolons           : true,
	        shebang              : true,
	        shorthand            : undefined,
	        source_map           : null,
	        webkit               : false,
	        width                : 80,
	        wrap_iife            : false,
	        wrap_func_args       : true,

	        _destroy_ast         : false
	    }, true);

	    if (options.shorthand === undefined)
	        options.shorthand = options.ecma > 5;

	    // Convert comment option to RegExp if necessary and set up comments filter
	    var comment_filter = return_false; // Default case, throw all comments away
	    if (options.comments) {
	        let comments = options.comments;
	        if (typeof options.comments === "string" && /^\/.*\/[a-zA-Z]*$/.test(options.comments)) {
	            var regex_pos = options.comments.lastIndexOf("/");
	            comments = new RegExp(
	                options.comments.substr(1, regex_pos - 1),
	                options.comments.substr(regex_pos + 1)
	            );
	        }
	        if (comments instanceof RegExp) {
	            comment_filter = function(comment) {
	                return comment.type != "comment5" && comments.test(comment.value);
	            };
	        } else if (typeof comments === "function") {
	            comment_filter = function(comment) {
	                return comment.type != "comment5" && comments(this, comment);
	            };
	        } else if (comments === "some") {
	            comment_filter = is_some_comments;
	        } else { // NOTE includes "all" option
	            comment_filter = return_true;
	        }
	    }

	    if (options.preserve_annotations) {
	        let prev_comment_filter = comment_filter;
	        comment_filter = function (comment) {
	            return r_annotation.test(comment.value) || prev_comment_filter.apply(this, arguments);
	        };
	    }

	    var indentation = 0;
	    var current_col = 0;
	    var current_line = 1;
	    var current_pos = 0;
	    var OUTPUT = new Rope();
	    let printed_comments = new Set();

	    var to_utf8 = options.ascii_only ? function(str, identifier = false, regexp = false) {
	        if (options.ecma >= 2015 && !options.safari10 && !regexp) {
	            str = str.replace(/[\ud800-\udbff][\udc00-\udfff]/g, function(ch) {
	                var code = get_full_char_code(ch, 0).toString(16);
	                return "\\u{" + code + "}";
	            });
	        }
	        return str.replace(/[\u0000-\u001f\u007f-\uffff]/g, function(ch) {
	            var code = ch.charCodeAt(0).toString(16);
	            if (code.length <= 2 && !identifier) {
	                while (code.length < 2) code = "0" + code;
	                return "\\x" + code;
	            } else {
	                while (code.length < 4) code = "0" + code;
	                return "\\u" + code;
	            }
	        });
	    } : function(str) {
	        return str.replace(/[\ud800-\udbff][\udc00-\udfff]|([\ud800-\udbff]|[\udc00-\udfff])/g, function(match, lone) {
	            if (lone) {
	                return "\\u" + lone.charCodeAt(0).toString(16);
	            }
	            return match;
	        });
	    };

	    function make_string(str, quote) {
	        var dq = 0, sq = 0;
	        str = str.replace(/[\\\b\f\n\r\v\t\x22\x27\u2028\u2029\0\ufeff]/g,
	          function(s, i) {
	            switch (s) {
	              case '"': ++dq; return '"';
	              case "'": ++sq; return "'";
	              case "\\": return "\\\\";
	              case "\n": return "\\n";
	              case "\r": return "\\r";
	              case "\t": return "\\t";
	              case "\b": return "\\b";
	              case "\f": return "\\f";
	              case "\x0B": return options.ie8 ? "\\x0B" : "\\v";
	              case "\u2028": return "\\u2028";
	              case "\u2029": return "\\u2029";
	              case "\ufeff": return "\\ufeff";
	              case "\0":
	                  return /[0-9]/.test(get_full_char(str, i+1)) ? "\\x00" : "\\0";
	            }
	            return s;
	        });
	        function quote_single() {
	            return "'" + str.replace(/\x27/g, "\\'") + "'";
	        }
	        function quote_double() {
	            return '"' + str.replace(/\x22/g, '\\"') + '"';
	        }
	        function quote_template() {
	            return "`" + str.replace(/`/g, "\\`") + "`";
	        }
	        str = to_utf8(str);
	        if (quote === "`") return quote_template();
	        switch (options.quote_style) {
	          case 1:
	            return quote_single();
	          case 2:
	            return quote_double();
	          case 3:
	            return quote == "'" ? quote_single() : quote_double();
	          default:
	            return dq > sq ? quote_single() : quote_double();
	        }
	    }

	    function encode_string(str, quote) {
	        var ret = make_string(str, quote);
	        if (options.inline_script) {
	            ret = ret.replace(/<\x2f(script)([>\/\t\n\f\r ])/gi, "<\\/$1$2");
	            ret = ret.replace(/\x3c!--/g, "\\x3c!--");
	            ret = ret.replace(/--\x3e/g, "--\\x3e");
	        }
	        return ret;
	    }

	    function make_name(name) {
	        name = name.toString();
	        name = to_utf8(name, true);
	        return name;
	    }

	    function make_indent(back) {
	        return " ".repeat(options.indent_start + indentation - back * options.indent_level);
	    }

	    /* -----[ beautification/minification ]----- */

	    var has_parens = false;
	    var might_need_space = false;
	    var might_need_semicolon = false;
	    var might_add_newline = 0;
	    var need_newline_indented = false;
	    var need_space = false;
	    var newline_insert = -1;
	    var last = "";
	    var mapping_token, mapping_name, mappings = options.source_map && [];

	    var do_add_mapping = mappings ? function() {
	        mappings.forEach(function(mapping) {
	            try {
	                let { name, token } = mapping;
	                if (name !== false) {
	                    if (token.type == "name" || token.type === "privatename") {
	                        name = token.value;
	                    } else if (name instanceof AST_Symbol) {
	                        name = token.type === "string" ? token.value : name.name;
	                    }
	                }
	                options.source_map.add(
	                    mapping.token.file,
	                    mapping.line, mapping.col,
	                    mapping.token.line, mapping.token.col,
	                    is_basic_identifier_string(name) ? name : undefined
	                );
	            } catch(ex) {
	                // Ignore bad mapping
	            }
	        });
	        mappings = [];
	    } : noop;

	    var ensure_line_len = options.max_line_len ? function() {
	        if (current_col > options.max_line_len) {
	            if (might_add_newline) {
	                OUTPUT.insertAt("\n", might_add_newline);
	                const len_after_newline = OUTPUT.length() - might_add_newline - 1;
	                if (mappings) {
	                    var delta = len_after_newline - current_col;
	                    mappings.forEach(function(mapping) {
	                        mapping.line++;
	                        mapping.col += delta;
	                    });
	                }
	                current_line++;
	                current_pos++;
	                current_col = len_after_newline;
	            }
	        }
	        if (might_add_newline) {
	            might_add_newline = 0;
	            do_add_mapping();
	        }
	    } : noop;

	    var requireSemicolonChars = makePredicate("( [ + * / - , . `");

	    function print(str) {
	        str = String(str);
	        var ch = get_full_char(str, 0);
	        if (need_newline_indented && ch) {
	            need_newline_indented = false;
	            if (ch !== "\n") {
	                print("\n");
	                indent();
	            }
	        }
	        if (need_space && ch) {
	            need_space = false;
	            if (!/[\s;})]/.test(ch)) {
	                space();
	            }
	        }
	        newline_insert = -1;
	        var prev = last.charAt(last.length - 1);
	        if (might_need_semicolon) {
	            might_need_semicolon = false;

	            if (prev === ":" && ch === "}" || (!ch || !";}".includes(ch)) && prev !== ";") {
	                if (options.semicolons || requireSemicolonChars.has(ch)) {
	                    OUTPUT.append(";");
	                    current_col++;
	                    current_pos++;
	                } else {
	                    ensure_line_len();
	                    if (current_col > 0) {
	                        OUTPUT.append("\n");
	                        current_pos++;
	                        current_line++;
	                        current_col = 0;
	                    }

	                    if (/^\s+$/.test(str)) {
	                        // reset the semicolon flag, since we didn't print one
	                        // now and might still have to later
	                        might_need_semicolon = true;
	                    }
	                }

	                if (!options.beautify)
	                    might_need_space = false;
	            }
	        }

	        if (might_need_space) {
	            if ((is_identifier_char(prev)
	                    && (is_identifier_char(ch) || ch == "\\"))
	                || (ch == "/" && ch == prev)
	                || ((ch == "+" || ch == "-") && ch == last)
	            ) {
	                OUTPUT.append(" ");
	                current_col++;
	                current_pos++;
	            }
	            might_need_space = false;
	        }

	        if (mapping_token) {
	            mappings.push({
	                token: mapping_token,
	                name: mapping_name,
	                line: current_line,
	                col: current_col
	            });
	            mapping_token = false;
	            if (!might_add_newline) do_add_mapping();
	        }

	        OUTPUT.append(str);
	        has_parens = str[str.length - 1] == "(";
	        current_pos += str.length;
	        var a = str.split(/\r?\n/), n = a.length - 1;
	        current_line += n;
	        current_col += a[0].length;
	        if (n > 0) {
	            ensure_line_len();
	            current_col = a[n].length;
	        }
	        last = str;
	    }

	    var star = function() {
	        print("*");
	    };

	    var space = options.beautify ? function() {
	        print(" ");
	    } : function() {
	        might_need_space = true;
	    };

	    var indent = options.beautify ? function(half) {
	        if (options.beautify) {
	            print(make_indent(half ? 0.5 : 0));
	        }
	    } : noop;

	    var with_indent = options.beautify ? function(col, cont) {
	        if (col === true) col = next_indent();
	        var save_indentation = indentation;
	        indentation = col;
	        var ret = cont();
	        indentation = save_indentation;
	        return ret;
	    } : function(col, cont) { return cont(); };

	    var newline = options.beautify ? function() {
	        if (newline_insert < 0) return print("\n");
	        if (OUTPUT.charAt(newline_insert) != "\n") {
	            OUTPUT.insertAt("\n", newline_insert);
	            current_pos++;
	            current_line++;
	        }
	        newline_insert++;
	    } : options.max_line_len ? function() {
	        ensure_line_len();
	        might_add_newline = OUTPUT.length();
	    } : noop;

	    var semicolon = options.beautify ? function() {
	        print(";");
	    } : function() {
	        might_need_semicolon = true;
	    };

	    function force_semicolon() {
	        might_need_semicolon = false;
	        print(";");
	    }

	    function next_indent() {
	        return indentation + options.indent_level;
	    }

	    function with_block(cont) {
	        var ret;
	        print("{");
	        newline();
	        with_indent(next_indent(), function() {
	            ret = cont();
	        });
	        indent();
	        print("}");
	        return ret;
	    }

	    function with_parens(cont) {
	        print("(");
	        //XXX: still nice to have that for argument lists
	        //var ret = with_indent(current_col, cont);
	        var ret = cont();
	        print(")");
	        return ret;
	    }

	    function with_square(cont) {
	        print("[");
	        //var ret = with_indent(current_col, cont);
	        var ret = cont();
	        print("]");
	        return ret;
	    }

	    function comma() {
	        print(",");
	        space();
	    }

	    function colon() {
	        print(":");
	        space();
	    }

	    var add_mapping = mappings ? function(token, name) {
	        mapping_token = token;
	        mapping_name = name;
	    } : noop;

	    function get() {
	        if (might_add_newline) {
	            ensure_line_len();
	        }
	        return OUTPUT.toString();
	    }

	    function filter_comment(comment) {
	        if (!options.preserve_annotations) {
	            comment = comment.replace(r_annotation, " ");
	        }
	        if (/^\s*$/.test(comment)) {
	            return "";
	        }
	        return comment.replace(/(<\s*\/\s*)(script)/i, "<\\/$2");
	    }

	    function prepend_comments(node) {
	        var self = this;
	        var start = node.start;
	        if (!start) return;
	        var printed_comments = self.printed_comments;

	        // There cannot be a newline between return/yield and its value.
	        const keyword_with_value = 
	            node instanceof AST_Exit && node.value
	            || (node instanceof AST_Await || node instanceof AST_Yield)
	                && node.expression;

	        if (
	            start.comments_before
	            && printed_comments.has(start.comments_before)
	        ) {
	            if (keyword_with_value) {
	                start.comments_before = [];
	            } else {
	                return;
	            }
	        }

	        var comments = start.comments_before;
	        if (!comments) {
	            comments = start.comments_before = [];
	        }
	        printed_comments.add(comments);

	        if (keyword_with_value) {
	            var tw = new TreeWalker(function(node) {
	                var parent = tw.parent();
	                if (parent instanceof AST_Exit
	                    || parent instanceof AST_Await
	                    || parent instanceof AST_Yield
	                    || parent instanceof AST_Binary && parent.left === node
	                    || parent.TYPE == "Call" && parent.expression === node
	                    || parent instanceof AST_Conditional && parent.condition === node
	                    || parent instanceof AST_Dot && parent.expression === node
	                    || parent instanceof AST_Sequence && parent.expressions[0] === node
	                    || parent instanceof AST_Sub && parent.expression === node
	                    || parent instanceof AST_UnaryPostfix) {
	                    if (!node.start) return;
	                    var text = node.start.comments_before;
	                    if (text && !printed_comments.has(text)) {
	                        printed_comments.add(text);
	                        comments = comments.concat(text);
	                    }
	                } else {
	                    return true;
	                }
	            });
	            tw.push(node);
	            keyword_with_value.walk(tw);
	        }

	        if (current_pos == 0) {
	            if (comments.length > 0 && options.shebang && comments[0].type === "comment5"
	                && !printed_comments.has(comments[0])) {
	                print("#!" + comments.shift().value + "\n");
	                indent();
	            }
	            var preamble = options.preamble;
	            if (preamble) {
	                print(preamble.replace(/\r\n?|[\n\u2028\u2029]|\s*$/g, "\n"));
	            }
	        }

	        comments = comments.filter(comment_filter, node).filter(c => !printed_comments.has(c));
	        if (comments.length == 0) return;
	        var last_nlb = OUTPUT.hasNLB();
	        comments.forEach(function(c, i) {
	            printed_comments.add(c);
	            if (!last_nlb) {
	                if (c.nlb) {
	                    print("\n");
	                    indent();
	                    last_nlb = true;
	                } else if (i > 0) {
	                    space();
	                }
	            }

	            if (/comment[134]/.test(c.type)) {
	                var value = filter_comment(c.value);
	                if (value) {
	                    print("//" + value + "\n");
	                    indent();
	                }
	                last_nlb = true;
	            } else if (c.type == "comment2") {
	                var value = filter_comment(c.value);
	                if (value) {
	                    print("/*" + value + "*/");
	                }
	                last_nlb = false;
	            }
	        });
	        if (!last_nlb) {
	            if (start.nlb) {
	                print("\n");
	                indent();
	            } else {
	                space();
	            }
	        }
	    }

	    function append_comments(node, tail) {
	        var self = this;
	        var token = node.end;
	        if (!token) return;
	        var printed_comments = self.printed_comments;
	        var comments = token[tail ? "comments_before" : "comments_after"];
	        if (!comments || printed_comments.has(comments)) return;
	        if (!(node instanceof AST_Statement || comments.every((c) =>
	            !/comment[134]/.test(c.type)
	        ))) return;
	        printed_comments.add(comments);
	        var insert = OUTPUT.length();
	        comments.filter(comment_filter, node).forEach(function(c, i) {
	            if (printed_comments.has(c)) return;
	            printed_comments.add(c);
	            need_space = false;
	            if (need_newline_indented) {
	                print("\n");
	                indent();
	                need_newline_indented = false;
	            } else if (c.nlb && (i > 0 || !OUTPUT.hasNLB())) {
	                print("\n");
	                indent();
	            } else if (i > 0 || !tail) {
	                space();
	            }
	            if (/comment[134]/.test(c.type)) {
	                const value = filter_comment(c.value);
	                if (value) {
	                    print("//" + value);
	                }
	                need_newline_indented = true;
	            } else if (c.type == "comment2") {
	                const value = filter_comment(c.value);
	                if (value) {
	                    print("/*" + value + "*/");
	                }
	                need_space = true;
	            }
	        });
	        if (OUTPUT.length() > insert) newline_insert = insert;
	    }

	    /**
	     * When output.option("_destroy_ast") is enabled, destroy the function.
	     * Call this after printing it.
	     */
	    const gc_scope =
	      options["_destroy_ast"]
	        ? function gc_scope(scope) {
	            scope.body.length = 0;
	            scope.argnames.length = 0;
	        }
	        : noop;

	    var stack = [];
	    return {
	        get             : get,
	        toString        : get,
	        indent          : indent,
	        in_directive    : false,
	        use_asm         : null,
	        active_scope    : null,
	        indentation     : function() { return indentation; },
	        current_width   : function() { return current_col - indentation; },
	        should_break    : function() { return options.width && this.current_width() >= options.width; },
	        has_parens      : function() { return has_parens; },
	        newline         : newline,
	        print           : print,
	        star            : star,
	        space           : space,
	        comma           : comma,
	        colon           : colon,
	        last            : function() { return last; },
	        semicolon       : semicolon,
	        force_semicolon : force_semicolon,
	        to_utf8         : to_utf8,
	        print_name      : function(name) { print(make_name(name)); },
	        print_string    : function(str, quote, escape_directive) {
	            var encoded = encode_string(str, quote);
	            if (escape_directive === true && !encoded.includes("\\")) {
	                // Insert semicolons to break directive prologue
	                if (!OUTPUT.expectDirective()) {
	                    force_semicolon();
	                }
	                force_semicolon();
	            }
	            print(encoded);
	        },
	        print_template_string_chars: function(str) {
	            var encoded = encode_string(str, "`").replace(/\${/g, "\\${");
	            return print(encoded.substr(1, encoded.length - 2));
	        },
	        encode_string   : encode_string,
	        next_indent     : next_indent,
	        with_indent     : with_indent,
	        with_block      : with_block,
	        with_parens     : with_parens,
	        with_square     : with_square,
	        add_mapping     : add_mapping,
	        option          : function(opt) { return options[opt]; },
	        gc_scope,
	        printed_comments: printed_comments,
	        prepend_comments: readonly ? noop : prepend_comments,
	        append_comments : readonly || comment_filter === return_false ? noop : append_comments,
	        line            : function() { return current_line; },
	        col             : function() { return current_col; },
	        pos             : function() { return current_pos; },
	        push_node       : function(node) { stack.push(node); },
	        pop_node        : function() { return stack.pop(); },
	        parent          : function(n) {
	            return stack[stack.length - 2 - (n || 0)];
	        }
	    };

	}

	/* -----[ code generators ]----- */

	(function() {

	    /* -----[ utils ]----- */

	    function DEFPRINT(nodetype, generator) {
	        nodetype.DEFMETHOD("_codegen", generator);
	    }

	    AST_Node.DEFMETHOD("print", function(output, force_parens) {
	        var self = this, generator = self._codegen;
	        if (self instanceof AST_Scope) {
	            output.active_scope = self;
	        } else if (!output.use_asm && self instanceof AST_Directive && self.value == "use asm") {
	            output.use_asm = output.active_scope;
	        }
	        function doit() {
	            output.prepend_comments(self);
	            self.add_source_map(output);
	            generator(self, output);
	            output.append_comments(self);
	        }
	        output.push_node(self);
	        if (force_parens || self.needs_parens(output)) {
	            output.with_parens(doit);
	        } else {
	            doit();
	        }
	        output.pop_node();
	        if (self === output.use_asm) {
	            output.use_asm = null;
	        }
	    });
	    AST_Node.DEFMETHOD("_print", AST_Node.prototype.print);

	    AST_Node.DEFMETHOD("print_to_string", function(options) {
	        var output = OutputStream(options);
	        this.print(output);
	        return output.get();
	    });

	    /* -----[ PARENTHESES ]----- */

	    function PARENS(nodetype, func) {
	        if (Array.isArray(nodetype)) {
	            nodetype.forEach(function(nodetype) {
	                PARENS(nodetype, func);
	            });
	        } else {
	            nodetype.DEFMETHOD("needs_parens", func);
	        }
	    }

	    PARENS(AST_Node, return_false);

	    // a function expression needs parens around it when it's provably
	    // the first token to appear in a statement.
	    PARENS(AST_Function, function(output) {
	        if (!output.has_parens() && first_in_statement(output)) {
	            return true;
	        }

	        if (output.option("webkit")) {
	            var p = output.parent();
	            if (p instanceof AST_PropAccess && p.expression === this) {
	                return true;
	            }
	        }

	        if (output.option("wrap_iife")) {
	            var p = output.parent();
	            if (p instanceof AST_Call && p.expression === this) {
	                return true;
	            }
	        }

	        if (output.option("wrap_func_args")) {
	            var p = output.parent();
	            if (p instanceof AST_Call && p.args.includes(this)) {
	                return true;
	            }
	        }

	        return false;
	    });

	    PARENS(AST_Arrow, function(output) {
	        var p = output.parent();

	        if (
	            output.option("wrap_func_args")
	            && p instanceof AST_Call
	            && p.args.includes(this)
	        ) {
	            return true;
	        }
	        return p instanceof AST_PropAccess && p.expression === this
	            || p instanceof AST_Conditional && p.condition === this;
	    });

	    // same goes for an object literal (as in AST_Function), because
	    // otherwise {...} would be interpreted as a block of code.
	    PARENS(AST_Object, function(output) {
	        return !output.has_parens() && first_in_statement(output);
	    });

	    PARENS(AST_ClassExpression, first_in_statement);

	    PARENS(AST_Unary, function(output) {
	        var p = output.parent();
	        return p instanceof AST_PropAccess && p.expression === this
	            || p instanceof AST_Call && p.expression === this
	            || p instanceof AST_Binary
	                && p.operator === "**"
	                && this instanceof AST_UnaryPrefix
	                && p.left === this
	                && this.operator !== "++"
	                && this.operator !== "--";
	    });

	    PARENS(AST_Await, function(output) {
	        var p = output.parent();
	        return p instanceof AST_PropAccess && p.expression === this
	            || p instanceof AST_Call && p.expression === this
	            || p instanceof AST_Binary && p.operator === "**" && p.left === this
	            || output.option("safari10") && p instanceof AST_UnaryPrefix;
	    });

	    PARENS(AST_Sequence, function(output) {
	        var p = output.parent();
	        return p instanceof AST_Call                          // (foo, bar)() or foo(1, (2, 3), 4)
	            || p instanceof AST_Unary                         // !(foo, bar, baz)
	            || p instanceof AST_Binary                        // 1 + (2, 3) + 4 ==> 8
	            || p instanceof AST_VarDef                        // var a = (1, 2), b = a + a; ==> b == 4
	            || p instanceof AST_PropAccess                    // (1, {foo:2}).foo or (1, {foo:2})["foo"] ==> 2
	            || p instanceof AST_Array                         // [ 1, (2, 3), 4 ] ==> [ 1, 3, 4 ]
	            || p instanceof AST_ObjectProperty                // { foo: (1, 2) }.foo ==> 2
	            || p instanceof AST_Conditional                   /* (false, true) ? (a = 10, b = 20) : (c = 30)
	                                                               * ==> 20 (side effect, set a := 10 and b := 20) */
	            || p instanceof AST_Arrow                         // x => (x, x)
	            || p instanceof AST_DefaultAssign                 // x => (x = (0, function(){}))
	            || p instanceof AST_Expansion                     // [...(a, b)]
	            || p instanceof AST_ForOf && this === p.object    // for (e of (foo, bar)) {}
	            || p instanceof AST_Yield                         // yield (foo, bar)
	            || p instanceof AST_Export                        // export default (foo, bar)
	        ;
	    });

	    PARENS(AST_Binary, function(output) {
	        var p = output.parent();
	        // (foo && bar)()
	        if (p instanceof AST_Call && p.expression === this)
	            return true;
	        // typeof (foo && bar)
	        if (p instanceof AST_Unary)
	            return true;
	        // (foo && bar)["prop"], (foo && bar).prop
	        if (p instanceof AST_PropAccess && p.expression === this)
	            return true;
	        // this deals with precedence: 3 * (2 + 1)
	        if (p instanceof AST_Binary) {
	            const parent_op = p.operator;
	            const op = this.operator;

	            // It is forbidden for ?? to be used with || or && without parens.
	            if (op === "??" && (parent_op === "||" || parent_op === "&&")) {
	                return true;
	            }
	            if (parent_op === "??" && (op === "||" || op === "&&")) {
	                return true;
	            }

	            const pp = PRECEDENCE[parent_op];
	            const sp = PRECEDENCE[op];
	            if (pp > sp
	                || (pp == sp
	                    && (this === p.right || parent_op == "**"))) {
	                return true;
	            }
	        }
	        if (p instanceof AST_PrivateIn) {
	            const op = this.operator;

	            const pp = PRECEDENCE["in"];
	            const sp = PRECEDENCE[op];
	            if (pp > sp || (pp == sp && this === p.value)) {
	                return true;
	            }
	        }
	    });

	    PARENS(AST_PrivateIn, function(output) {
	        var p = output.parent();
	        // (#x in this)()
	        if (p instanceof AST_Call && p.expression === this) {
	            return true;
	        }
	        // typeof (#x in this)
	        if (p instanceof AST_Unary) {
	            return true;
	        }
	        // (#x in this)["prop"], (#x in this).prop
	        if (p instanceof AST_PropAccess && p.expression === this) {
	            return true;
	        }
	        // same precedence as regular in operator
	        if (p instanceof AST_Binary) {
	            const parent_op = p.operator;

	            const pp = PRECEDENCE[parent_op];
	            const sp = PRECEDENCE["in"];
	            if (pp > sp
	                || (pp == sp
	                    && (this === p.right || parent_op == "**"))) {
	                return true;
	            }
	        }
	        // rules are the same as binary in, but the class differs
	        if (p instanceof AST_PrivateIn && this === p.value) {
	            return true;
	        }
	    });

	    PARENS(AST_Yield, function(output) {
	        var p = output.parent();
	        // (yield 1) + (yield 2)
	        // a = yield 3
	        if (p instanceof AST_Binary && p.operator !== "=")
	            return true;
	        // (yield 1)()
	        // new (yield 1)()
	        if (p instanceof AST_Call && p.expression === this)
	            return true;
	        // (yield 1) ? yield 2 : yield 3
	        if (p instanceof AST_Conditional && p.condition === this)
	            return true;
	        // -(yield 4)
	        if (p instanceof AST_Unary)
	            return true;
	        // (yield x).foo
	        // (yield x)['foo']
	        if (p instanceof AST_PropAccess && p.expression === this)
	            return true;
	    });

	    PARENS(AST_Chain, function(output) {
	        var p = output.parent();
	        if (!(p instanceof AST_Call || p instanceof AST_PropAccess)) return false;
	        return p.expression === this;
	    });

	    PARENS(AST_PropAccess, function(output) {
	        var p = output.parent();
	        if (p instanceof AST_New && p.expression === this) {
	            // i.e. new (foo.bar().baz)
	            //
	            // if there's one call into this subtree, then we need
	            // parens around it too, otherwise the call will be
	            // interpreted as passing the arguments to the upper New
	            // expression.
	            return walk(this, node => {
	                if (node instanceof AST_Scope) return true;
	                if (node instanceof AST_Call) {
	                    return walk_abort;  // makes walk() return true.
	                }
	            });
	        }
	    });

	    PARENS(AST_Call, function(output) {
	        var p = output.parent(), p1;
	        if (p instanceof AST_New && p.expression === this
	            || p instanceof AST_Export && p.is_default && this.expression instanceof AST_Function)
	            return true;

	        // workaround for Safari bug.
	        // https://bugs.webkit.org/show_bug.cgi?id=123506
	        return this.expression instanceof AST_Function
	            && p instanceof AST_PropAccess
	            && p.expression === this
	            && (p1 = output.parent(1)) instanceof AST_Assign
	            && p1.left === p;
	    });

	    PARENS(AST_New, function(output) {
	        var p = output.parent();
	        if (this.args.length === 0
	            && (p instanceof AST_PropAccess // (new Date).getTime(), (new Date)["getTime"]()
	                || p instanceof AST_Call && p.expression === this
	                || p instanceof AST_PrefixedTemplateString && p.prefix === this)) // (new foo)(bar)
	            return true;
	    });

	    PARENS(AST_Number, function(output) {
	        var p = output.parent();
	        if (p instanceof AST_PropAccess && p.expression === this) {
	            var value = this.getValue();
	            if (value < 0 || /^0/.test(make_num(value))) {
	                return true;
	            }
	        }
	    });

	    PARENS(AST_BigInt, function(output) {
	        var p = output.parent();
	        if (p instanceof AST_PropAccess && p.expression === this) {
	            var value = this.getValue();
	            if (value.startsWith("-")) {
	                return true;
	            }
	        }
	    });

	    PARENS([ AST_Assign, AST_Conditional ], function(output) {
	        var p = output.parent();
	        // !(a = false) → true
	        if (p instanceof AST_Unary)
	            return true;
	        // 1 + (a = 2) + 3 → 6, side effect setting a = 2
	        if (p instanceof AST_Binary && !(p instanceof AST_Assign))
	            return true;
	        // (a = func)() —or— new (a = Object)()
	        if (p instanceof AST_Call && p.expression === this)
	            return true;
	        // (a = foo) ? bar : baz
	        if (p instanceof AST_Conditional && p.condition === this)
	            return true;
	        // (a = foo)["prop"] —or— (a = foo).prop
	        if (p instanceof AST_PropAccess && p.expression === this)
	            return true;
	        // ({a, b} = {a: 1, b: 2}), a destructuring assignment
	        if (this instanceof AST_Assign && this.left instanceof AST_Destructuring && this.left.is_array === false)
	            return true;
	    });

	    /* -----[ PRINTERS ]----- */

	    DEFPRINT(AST_Directive, function(self, output) {
	        output.print_string(self.value, self.quote);
	        output.semicolon();
	    });

	    DEFPRINT(AST_Expansion, function (self, output) {
	        output.print("...");
	        self.expression.print(output);
	    });

	    DEFPRINT(AST_Destructuring, function (self, output) {
	        output.print(self.is_array ? "[" : "{");
	        var len = self.names.length;
	        self.names.forEach(function (name, i) {
	            if (i > 0) output.comma();
	            name.print(output);
	            // If the final element is a hole, we need to make sure it
	            // doesn't look like a trailing comma, by inserting an actual
	            // trailing comma.
	            if (i == len - 1 && name instanceof AST_Hole) output.comma();
	        });
	        output.print(self.is_array ? "]" : "}");
	    });

	    DEFPRINT(AST_Debugger, function(self, output) {
	        output.print("debugger");
	        output.semicolon();
	    });

	    /* -----[ statements ]----- */

	    function display_body(body, is_toplevel, output, allow_directives) {
	        var last = body.length - 1;
	        output.in_directive = allow_directives;
	        body.forEach(function(stmt, i) {
	            if (output.in_directive === true && !(stmt instanceof AST_Directive ||
	                stmt instanceof AST_EmptyStatement ||
	                (stmt instanceof AST_SimpleStatement && stmt.body instanceof AST_String)
	            )) {
	                output.in_directive = false;
	            }
	            if (!(stmt instanceof AST_EmptyStatement)) {
	                output.indent();
	                stmt.print(output);
	                if (!(i == last && is_toplevel)) {
	                    output.newline();
	                    if (is_toplevel) output.newline();
	                }
	            }
	            if (output.in_directive === true &&
	                stmt instanceof AST_SimpleStatement &&
	                stmt.body instanceof AST_String
	            ) {
	                output.in_directive = false;
	            }
	        });
	        output.in_directive = false;
	    }

	    AST_StatementWithBody.DEFMETHOD("_do_print_body", function(output) {
	        print_maybe_braced_body(this.body, output);
	    });

	    DEFPRINT(AST_Statement, function(self, output) {
	        self.body.print(output);
	        output.semicolon();
	    });
	    DEFPRINT(AST_Toplevel, function(self, output) {
	        display_body(self.body, true, output, true);
	        output.print("");
	    });
	    DEFPRINT(AST_LabeledStatement, function(self, output) {
	        self.label.print(output);
	        output.colon();
	        self.body.print(output);
	    });
	    DEFPRINT(AST_SimpleStatement, function(self, output) {
	        self.body.print(output);
	        output.semicolon();
	    });
	    function print_braced_empty(self, output) {
	        output.print("{");
	        output.with_indent(output.next_indent(), function() {
	            output.append_comments(self, true);
	        });
	        output.add_mapping(self.end);
	        output.print("}");
	    }
	    function print_braced(self, output, allow_directives) {
	        if (self.body.length > 0) {
	            output.with_block(function() {
	                display_body(self.body, false, output, allow_directives);
	                output.add_mapping(self.end);
	            });
	        } else print_braced_empty(self, output);
	    }
	    DEFPRINT(AST_BlockStatement, function(self, output) {
	        print_braced(self, output);
	    });
	    DEFPRINT(AST_EmptyStatement, function(self, output) {
	        output.semicolon();
	    });
	    DEFPRINT(AST_Do, function(self, output) {
	        output.print("do");
	        output.space();
	        make_block(self.body, output);
	        output.space();
	        output.print("while");
	        output.space();
	        output.with_parens(function() {
	            self.condition.print(output);
	        });
	        output.semicolon();
	    });
	    DEFPRINT(AST_While, function(self, output) {
	        output.print("while");
	        output.space();
	        output.with_parens(function() {
	            self.condition.print(output);
	        });
	        output.space();
	        self._do_print_body(output);
	    });
	    DEFPRINT(AST_For, function(self, output) {
	        output.print("for");
	        output.space();
	        output.with_parens(function() {
	            if (self.init) {
	                if (self.init instanceof AST_Definitions) {
	                    self.init.print(output);
	                } else {
	                    parenthesize_for_noin(self.init, output, true);
	                }
	                output.print(";");
	                output.space();
	            } else {
	                output.print(";");
	            }
	            if (self.condition) {
	                self.condition.print(output);
	                output.print(";");
	                output.space();
	            } else {
	                output.print(";");
	            }
	            if (self.step) {
	                self.step.print(output);
	            }
	        });
	        output.space();
	        self._do_print_body(output);
	    });
	    DEFPRINT(AST_ForIn, function(self, output) {
	        output.print("for");
	        if (self.await) {
	            output.space();
	            output.print("await");
	        }
	        output.space();
	        output.with_parens(function() {
	            self.init.print(output);
	            output.space();
	            output.print(self instanceof AST_ForOf ? "of" : "in");
	            output.space();
	            self.object.print(output);
	        });
	        output.space();
	        self._do_print_body(output);
	    });
	    DEFPRINT(AST_With, function(self, output) {
	        output.print("with");
	        output.space();
	        output.with_parens(function() {
	            self.expression.print(output);
	        });
	        output.space();
	        self._do_print_body(output);
	    });

	    /* -----[ functions ]----- */
	    AST_Lambda.DEFMETHOD("_do_print", function(output, nokeyword) {
	        var self = this;
	        if (!nokeyword) {
	            if (self.async) {
	                output.print("async");
	                output.space();
	            }
	            output.print("function");
	            if (self.is_generator) {
	                output.star();
	            }
	            if (self.name) {
	                output.space();
	            }
	        }
	        if (self.name instanceof AST_Symbol) {
	            self.name.print(output);
	        } else if (nokeyword && self.name instanceof AST_Node) {
	            output.with_square(function() {
	                self.name.print(output); // Computed method name
	            });
	        }
	        output.with_parens(function() {
	            self.argnames.forEach(function(arg, i) {
	                if (i) output.comma();
	                arg.print(output);
	            });
	        });
	        output.space();
	        print_braced(self, output, true);
	    });
	    DEFPRINT(AST_Lambda, function(self, output) {
	        self._do_print(output);
	        output.gc_scope(self);
	    });

	    DEFPRINT(AST_PrefixedTemplateString, function(self, output) {
	        var tag = self.prefix;
	        var parenthesize_tag = tag instanceof AST_Lambda
	            || tag instanceof AST_Binary
	            || tag instanceof AST_Conditional
	            || tag instanceof AST_Sequence
	            || tag instanceof AST_Unary
	            || tag instanceof AST_Dot && tag.expression instanceof AST_Object;
	        if (parenthesize_tag) output.print("(");
	        self.prefix.print(output);
	        if (parenthesize_tag) output.print(")");
	        self.template_string.print(output);
	    });
	    DEFPRINT(AST_TemplateString, function(self, output) {
	        var is_tagged = output.parent() instanceof AST_PrefixedTemplateString;

	        output.print("`");
	        for (var i = 0; i < self.segments.length; i++) {
	            if (!(self.segments[i] instanceof AST_TemplateSegment)) {
	                output.print("${");
	                self.segments[i].print(output);
	                output.print("}");
	            } else if (is_tagged) {
	                output.print(self.segments[i].raw);
	            } else {
	                output.print_template_string_chars(self.segments[i].value);
	            }
	        }
	        output.print("`");
	    });
	    DEFPRINT(AST_TemplateSegment, function(self, output) {
	        output.print_template_string_chars(self.value);
	    });

	    AST_Arrow.DEFMETHOD("_do_print", function(output) {
	        var self = this;
	        var parent = output.parent();
	        var needs_parens = (parent instanceof AST_Binary && !(parent instanceof AST_Assign)) ||
	            parent instanceof AST_Unary ||
	            (parent instanceof AST_Call && self === parent.expression);
	        if (needs_parens) { output.print("("); }
	        if (self.async) {
	            output.print("async");
	            output.space();
	        }
	        if (self.argnames.length === 1 && self.argnames[0] instanceof AST_Symbol) {
	            self.argnames[0].print(output);
	        } else {
	            output.with_parens(function() {
	                self.argnames.forEach(function(arg, i) {
	                    if (i) output.comma();
	                    arg.print(output);
	                });
	            });
	        }
	        output.space();
	        output.print("=>");
	        output.space();
	        const first_statement = self.body[0];
	        if (
	            self.body.length === 1
	            && first_statement instanceof AST_Return
	        ) {
	            const returned = first_statement.value;
	            if (!returned) {
	                output.print("{}");
	            } else if (left_is_object(returned)) {
	                output.print("(");
	                returned.print(output);
	                output.print(")");
	            } else {
	                returned.print(output);
	            }
	        } else {
	            print_braced(self, output);
	        }
	        if (needs_parens) { output.print(")"); }
	        output.gc_scope(self);
	    });

	    /* -----[ exits ]----- */
	    AST_Exit.DEFMETHOD("_do_print", function(output, kind) {
	        output.print(kind);
	        if (this.value) {
	            output.space();
	            const comments = this.value.start.comments_before;
	            if (comments && comments.length && !output.printed_comments.has(comments)) {
	                output.print("(");
	                this.value.print(output);
	                output.print(")");
	            } else {
	                this.value.print(output);
	            }
	        }
	        output.semicolon();
	    });
	    DEFPRINT(AST_Return, function(self, output) {
	        self._do_print(output, "return");
	    });
	    DEFPRINT(AST_Throw, function(self, output) {
	        self._do_print(output, "throw");
	    });

	    /* -----[ yield ]----- */

	    DEFPRINT(AST_Yield, function(self, output) {
	        var star = self.is_star ? "*" : "";
	        output.print("yield" + star);
	        if (self.expression) {
	            output.space();
	            self.expression.print(output);
	        }
	    });

	    DEFPRINT(AST_Await, function(self, output) {
	        output.print("await");
	        output.space();
	        var e = self.expression;
	        var parens = !(
	               e instanceof AST_Call
	            || e instanceof AST_SymbolRef
	            || e instanceof AST_PropAccess
	            || e instanceof AST_Unary
	            || e instanceof AST_Constant
	            || e instanceof AST_Await
	            || e instanceof AST_Object
	        );
	        if (parens) output.print("(");
	        self.expression.print(output);
	        if (parens) output.print(")");
	    });

	    /* -----[ loop control ]----- */
	    AST_LoopControl.DEFMETHOD("_do_print", function(output, kind) {
	        output.print(kind);
	        if (this.label) {
	            output.space();
	            this.label.print(output);
	        }
	        output.semicolon();
	    });
	    DEFPRINT(AST_Break, function(self, output) {
	        self._do_print(output, "break");
	    });
	    DEFPRINT(AST_Continue, function(self, output) {
	        self._do_print(output, "continue");
	    });

	    /* -----[ if ]----- */
	    function make_then(self, output) {
	        var b = self.body;
	        if (output.option("braces")
	            || output.option("ie8") && b instanceof AST_Do)
	            return make_block(b, output);
	        // The squeezer replaces "block"-s that contain only a single
	        // statement with the statement itself; technically, the AST
	        // is correct, but this can create problems when we output an
	        // IF having an ELSE clause where the THEN clause ends in an
	        // IF *without* an ELSE block (then the outer ELSE would refer
	        // to the inner IF).  This function checks for this case and
	        // adds the block braces if needed.
	        if (!b) return output.force_semicolon();
	        while (true) {
	            if (b instanceof AST_If) {
	                if (!b.alternative) {
	                    make_block(self.body, output);
	                    return;
	                }
	                b = b.alternative;
	            } else if (b instanceof AST_StatementWithBody) {
	                b = b.body;
	            } else break;
	        }
	        print_maybe_braced_body(self.body, output);
	    }
	    DEFPRINT(AST_If, function(self, output) {
	        output.print("if");
	        output.space();
	        output.with_parens(function() {
	            self.condition.print(output);
	        });
	        output.space();
	        if (self.alternative) {
	            make_then(self, output);
	            output.space();
	            output.print("else");
	            output.space();
	            if (self.alternative instanceof AST_If)
	                self.alternative.print(output);
	            else
	                print_maybe_braced_body(self.alternative, output);
	        } else {
	            self._do_print_body(output);
	        }
	    });

	    /* -----[ switch ]----- */
	    DEFPRINT(AST_Switch, function(self, output) {
	        output.print("switch");
	        output.space();
	        output.with_parens(function() {
	            self.expression.print(output);
	        });
	        output.space();
	        var last = self.body.length - 1;
	        if (last < 0) print_braced_empty(self, output);
	        else output.with_block(function() {
	            self.body.forEach(function(branch, i) {
	                output.indent(true);
	                branch.print(output);
	                if (i < last && branch.body.length > 0)
	                    output.newline();
	            });
	        });
	    });
	    AST_SwitchBranch.DEFMETHOD("_do_print_body", function(output) {
	        output.newline();
	        this.body.forEach(function(stmt) {
	            output.indent();
	            stmt.print(output);
	            output.newline();
	        });
	    });
	    DEFPRINT(AST_Default, function(self, output) {
	        output.print("default:");
	        self._do_print_body(output);
	    });
	    DEFPRINT(AST_Case, function(self, output) {
	        output.print("case");
	        output.space();
	        self.expression.print(output);
	        output.print(":");
	        self._do_print_body(output);
	    });

	    /* -----[ exceptions ]----- */
	    DEFPRINT(AST_Try, function(self, output) {
	        output.print("try");
	        output.space();
	        self.body.print(output);
	        if (self.bcatch) {
	            output.space();
	            self.bcatch.print(output);
	        }
	        if (self.bfinally) {
	            output.space();
	            self.bfinally.print(output);
	        }
	    });
	    DEFPRINT(AST_TryBlock, function(self, output) {
	        print_braced(self, output);
	    });
	    DEFPRINT(AST_Catch, function(self, output) {
	        output.print("catch");
	        if (self.argname) {
	            output.space();
	            output.with_parens(function() {
	                self.argname.print(output);
	            });
	        }
	        output.space();
	        print_braced(self, output);
	    });
	    DEFPRINT(AST_Finally, function(self, output) {
	        output.print("finally");
	        output.space();
	        print_braced(self, output);
	    });

	    /* -----[ var/const ]----- */
	    AST_Definitions.DEFMETHOD("_do_print", function(output, kind) {
	        output.print(kind);
	        output.space();
	        this.definitions.forEach(function(def, i) {
	            if (i) output.comma();
	            def.print(output);
	        });
	        var p = output.parent();
	        var in_for = p instanceof AST_For || p instanceof AST_ForIn;
	        var output_semicolon = !in_for || p && p.init !== this;
	        if (output_semicolon)
	            output.semicolon();
	    });
	    DEFPRINT(AST_Let, function(self, output) {
	        self._do_print(output, "let");
	    });
	    DEFPRINT(AST_Var, function(self, output) {
	        self._do_print(output, "var");
	    });
	    DEFPRINT(AST_Const, function(self, output) {
	        self._do_print(output, "const");
	    });
	    DEFPRINT(AST_Import, function(self, output) {
	        output.print("import");
	        output.space();
	        if (self.imported_name) {
	            self.imported_name.print(output);
	        }
	        if (self.imported_name && self.imported_names) {
	            output.print(",");
	            output.space();
	        }
	        if (self.imported_names) {
	            if (self.imported_names.length === 1 &&
	                self.imported_names[0].foreign_name.name === "*" &&
	                !self.imported_names[0].foreign_name.quote) {
	                self.imported_names[0].print(output);
	            } else {
	                output.print("{");
	                self.imported_names.forEach(function (name_import, i) {
	                    output.space();
	                    name_import.print(output);
	                    if (i < self.imported_names.length - 1) {
	                        output.print(",");
	                    }
	                });
	                output.space();
	                output.print("}");
	            }
	        }
	        if (self.imported_name || self.imported_names) {
	            output.space();
	            output.print("from");
	            output.space();
	        }
	        self.module_name.print(output);
	        if (self.assert_clause) {
	            output.print("assert");
	            self.assert_clause.print(output);
	        }
	        output.semicolon();
	    });
	    DEFPRINT(AST_ImportMeta, function(self, output) {
	        output.print("import.meta");
	    });

	    DEFPRINT(AST_NameMapping, function(self, output) {
	        var is_import = output.parent() instanceof AST_Import;
	        var definition = self.name.definition();
	        var foreign_name = self.foreign_name;
	        var names_are_different =
	            (definition && definition.mangled_name || self.name.name) !==
	            foreign_name.name;
	        if (!names_are_different &&
	            foreign_name.name === "*" &&
	            foreign_name.quote != self.name.quote) {
	                // export * as "*"
	            names_are_different = true;
	        }
	        var foreign_name_is_name = foreign_name.quote == null;
	        if (names_are_different) {
	            if (is_import) {
	                if (foreign_name_is_name) {
	                    output.print(foreign_name.name);
	                } else {
	                    output.print_string(foreign_name.name, foreign_name.quote);
	                }
	            } else {
	                if (self.name.quote == null) {
	                    self.name.print(output);
	                } else {
	                    output.print_string(self.name.name, self.name.quote);
	                }
	                
	            }
	            output.space();
	            output.print("as");
	            output.space();
	            if (is_import) {
	                self.name.print(output);
	            } else {
	                if (foreign_name_is_name) {
	                    output.print(foreign_name.name);
	                } else {
	                    output.print_string(foreign_name.name, foreign_name.quote);
	                }
	            }
	        } else {
	            if (self.name.quote == null) {
	                self.name.print(output);
	            } else {
	                output.print_string(self.name.name, self.name.quote);
	            }
	        }
	    });

	    DEFPRINT(AST_Export, function(self, output) {
	        output.print("export");
	        output.space();
	        if (self.is_default) {
	            output.print("default");
	            output.space();
	        }
	        if (self.exported_names) {
	            if (self.exported_names.length === 1 &&
	                self.exported_names[0].name.name === "*" &&
	                !self.exported_names[0].name.quote) {
	                    self.exported_names[0].print(output);
	            } else {
	                output.print("{");
	                self.exported_names.forEach(function(name_export, i) {
	                    output.space();
	                    name_export.print(output);
	                    if (i < self.exported_names.length - 1) {
	                        output.print(",");
	                    }
	                });
	                output.space();
	                output.print("}");
	            }
	        } else if (self.exported_value) {
	            self.exported_value.print(output);
	        } else if (self.exported_definition) {
	            self.exported_definition.print(output);
	            if (self.exported_definition instanceof AST_Definitions) return;
	        }
	        if (self.module_name) {
	            output.space();
	            output.print("from");
	            output.space();
	            self.module_name.print(output);
	        }
	        if (self.assert_clause) {
	            output.print("assert");
	            self.assert_clause.print(output);
	        }
	        if (self.exported_value
	                && !(self.exported_value instanceof AST_Defun ||
	                    self.exported_value instanceof AST_Function ||
	                    self.exported_value instanceof AST_Class)
	            || self.module_name
	            || self.exported_names
	        ) {
	            output.semicolon();
	        }
	    });

	    function parenthesize_for_noin(node, output, noin) {
	        var parens = false;
	        // need to take some precautions here:
	        //    https://github.com/mishoo/UglifyJS2/issues/60
	        if (noin) {
	            parens = walk(node, node => {
	                // Don't go into scopes -- except arrow functions:
	                // https://github.com/terser/terser/issues/1019#issuecomment-877642607
	                if (node instanceof AST_Scope && !(node instanceof AST_Arrow)) {
	                    return true;
	                }
	                if (
	                    node instanceof AST_Binary && node.operator == "in"
	                    || node instanceof AST_PrivateIn
	                ) {
	                    return walk_abort;  // makes walk() return true
	                }
	            });
	        }
	        node.print(output, parens);
	    }

	    DEFPRINT(AST_VarDef, function(self, output) {
	        self.name.print(output);
	        if (self.value) {
	            output.space();
	            output.print("=");
	            output.space();
	            var p = output.parent(1);
	            var noin = p instanceof AST_For || p instanceof AST_ForIn;
	            parenthesize_for_noin(self.value, output, noin);
	        }
	    });

	    /* -----[ other expressions ]----- */
	    DEFPRINT(AST_Call, function(self, output) {
	        self.expression.print(output);
	        if (self instanceof AST_New && self.args.length === 0)
	            return;
	        if (self.expression instanceof AST_Call || self.expression instanceof AST_Lambda) {
	            output.add_mapping(self.start);
	        }
	        if (self.optional) output.print("?.");
	        output.with_parens(function() {
	            self.args.forEach(function(expr, i) {
	                if (i) output.comma();
	                expr.print(output);
	            });
	        });
	    });
	    DEFPRINT(AST_New, function(self, output) {
	        output.print("new");
	        output.space();
	        AST_Call.prototype._codegen(self, output);
	    });

	    AST_Sequence.DEFMETHOD("_do_print", function(output) {
	        this.expressions.forEach(function(node, index) {
	            if (index > 0) {
	                output.comma();
	                if (output.should_break()) {
	                    output.newline();
	                    output.indent();
	                }
	            }
	            node.print(output);
	        });
	    });
	    DEFPRINT(AST_Sequence, function(self, output) {
	        self._do_print(output);
	        // var p = output.parent();
	        // if (p instanceof AST_Statement) {
	        //     output.with_indent(output.next_indent(), function(){
	        //         self._do_print(output);
	        //     });
	        // } else {
	        //     self._do_print(output);
	        // }
	    });
	    DEFPRINT(AST_Dot, function(self, output) {
	        var expr = self.expression;
	        expr.print(output);
	        var prop = self.property;
	        var print_computed = ALL_RESERVED_WORDS.has(prop)
	            ? output.option("ie8")
	            : !is_identifier_string(
	                prop,
	                output.option("ecma") >= 2015 && !output.option("safari10")
	            );

	        if (self.optional) output.print("?.");

	        if (print_computed) {
	            output.print("[");
	            output.add_mapping(self.end);
	            output.print_string(prop);
	            output.print("]");
	        } else {
	            if (expr instanceof AST_Number && expr.getValue() >= 0) {
	                if (!/[xa-f.)]/i.test(output.last())) {
	                    output.print(".");
	                }
	            }
	            if (!self.optional) output.print(".");
	            // the name after dot would be mapped about here.
	            output.add_mapping(self.end);
	            output.print_name(prop);
	        }
	    });
	    DEFPRINT(AST_DotHash, function(self, output) {
	        var expr = self.expression;
	        expr.print(output);
	        var prop = self.property;

	        if (self.optional) output.print("?");
	        output.print(".#");
	        output.add_mapping(self.end);
	        output.print_name(prop);
	    });
	    DEFPRINT(AST_Sub, function(self, output) {
	        self.expression.print(output);
	        if (self.optional) output.print("?.");
	        output.print("[");
	        self.property.print(output);
	        output.print("]");
	    });
	    DEFPRINT(AST_Chain, function(self, output) {
	        self.expression.print(output);
	    });
	    DEFPRINT(AST_UnaryPrefix, function(self, output) {
	        var op = self.operator;
	        if (op === "--" && output.last().endsWith("!")) {
	            // avoid printing "<!--"
	            output.print(" ");
	        }
	        output.print(op);
	        if (/^[a-z]/i.test(op)
	            || (/[+-]$/.test(op)
	                && self.expression instanceof AST_UnaryPrefix
	                && /^[+-]/.test(self.expression.operator))) {
	            output.space();
	        }
	        self.expression.print(output);
	    });
	    DEFPRINT(AST_UnaryPostfix, function(self, output) {
	        self.expression.print(output);
	        output.print(self.operator);
	    });
	    DEFPRINT(AST_Binary, function(self, output) {
	        var op = self.operator;
	        self.left.print(output);
	        if (op[0] == ">" /* ">>" ">>>" ">" ">=" */
	            && output.last().endsWith("--")) {
	            // space is mandatory to avoid outputting -->
	            output.print(" ");
	        } else {
	            // the space is optional depending on "beautify"
	            output.space();
	        }
	        output.print(op);
	        output.space();
	        self.right.print(output);
	    });
	    DEFPRINT(AST_Conditional, function(self, output) {
	        self.condition.print(output);
	        output.space();
	        output.print("?");
	        output.space();
	        self.consequent.print(output);
	        output.space();
	        output.colon();
	        self.alternative.print(output);
	    });

	    /* -----[ literals ]----- */
	    DEFPRINT(AST_Array, function(self, output) {
	        output.with_square(function() {
	            var a = self.elements, len = a.length;
	            if (len > 0) output.space();
	            a.forEach(function(exp, i) {
	                if (i) output.comma();
	                exp.print(output);
	                // If the final element is a hole, we need to make sure it
	                // doesn't look like a trailing comma, by inserting an actual
	                // trailing comma.
	                if (i === len - 1 && exp instanceof AST_Hole)
	                  output.comma();
	            });
	            if (len > 0) output.space();
	        });
	    });
	    DEFPRINT(AST_Object, function(self, output) {
	        if (self.properties.length > 0) output.with_block(function() {
	            self.properties.forEach(function(prop, i) {
	                if (i) {
	                    output.print(",");
	                    output.newline();
	                }
	                output.indent();
	                prop.print(output);
	            });
	            output.newline();
	        });
	        else print_braced_empty(self, output);
	    });
	    DEFPRINT(AST_Class, function(self, output) {
	        output.print("class");
	        output.space();
	        if (self.name) {
	            self.name.print(output);
	            output.space();
	        }
	        if (self.extends) {
	            var parens = (
	                   !(self.extends instanceof AST_SymbolRef)
	                && !(self.extends instanceof AST_PropAccess)
	                && !(self.extends instanceof AST_ClassExpression)
	                && !(self.extends instanceof AST_Function)
	            );
	            output.print("extends");
	            if (parens) {
	                output.print("(");
	            } else {
	                output.space();
	            }
	            self.extends.print(output);
	            if (parens) {
	                output.print(")");
	            } else {
	                output.space();
	            }
	        }
	        if (self.properties.length > 0) output.with_block(function() {
	            self.properties.forEach(function(prop, i) {
	                if (i) {
	                    output.newline();
	                }
	                output.indent();
	                prop.print(output);
	            });
	            output.newline();
	        });
	        else output.print("{}");
	    });
	    DEFPRINT(AST_NewTarget, function(self, output) {
	        output.print("new.target");
	    });

	    /** Prints a prop name. Returns whether it can be used as a shorthand. */
	    function print_property_name(key, quote, output) {
	        if (output.option("quote_keys")) {
	            output.print_string(key);
	            return false;
	        }
	        if ("" + +key == key && key >= 0) {
	            if (output.option("keep_numbers")) {
	                output.print(key);
	                return false;
	            }
	            output.print(make_num(key));
	            return false;
	        }
	        var print_string = ALL_RESERVED_WORDS.has(key)
	            ? output.option("ie8")
	            : (
	                output.option("ecma") < 2015 || output.option("safari10")
	                    ? !is_basic_identifier_string(key)
	                    : !is_identifier_string(key, true)
	            );
	        if (print_string || (quote && output.option("keep_quoted_props"))) {
	            output.print_string(key, quote);
	            return false;
	        }
	        output.print_name(key);
	        return true;
	    }

	    DEFPRINT(AST_ObjectKeyVal, function(self, output) {
	        function get_name(self) {
	            var def = self.definition();
	            return def ? def.mangled_name || def.name : self.name;
	        }

	        const try_shorthand = output.option("shorthand") && !(self.key instanceof AST_Node);
	        if (
	            try_shorthand
	            && self.value instanceof AST_Symbol
	            && get_name(self.value) === self.key
	            && !ALL_RESERVED_WORDS.has(self.key)
	        ) {
	            const was_shorthand = print_property_name(self.key, self.quote, output);
	            if (!was_shorthand) {
	                output.colon();
	                self.value.print(output);
	            }
	        } else if (
	            try_shorthand
	            && self.value instanceof AST_DefaultAssign
	            && self.value.left instanceof AST_Symbol
	            && get_name(self.value.left) === self.key
	        ) {
	            const was_shorthand = print_property_name(self.key, self.quote, output);
	            if (!was_shorthand) {
	                output.colon();
	                self.value.left.print(output);
	            }
	            output.space();
	            output.print("=");
	            output.space();
	            self.value.right.print(output);
	        } else {
	            if (!(self.key instanceof AST_Node)) {
	                print_property_name(self.key, self.quote, output);
	            } else {
	                output.with_square(function() {
	                    self.key.print(output);
	                });
	            }
	            output.colon();
	            self.value.print(output);
	        }
	    });
	    DEFPRINT(AST_ClassPrivateProperty, (self, output) => {
	        if (self.static) {
	            output.print("static");
	            output.space();
	        }

	        output.print("#");
	        
	        print_property_name(self.key.name, self.quote, output);

	        if (self.value) {
	            output.print("=");
	            self.value.print(output);
	        }

	        output.semicolon();
	    });
	    DEFPRINT(AST_ClassProperty, (self, output) => {
	        if (self.static) {
	            output.print("static");
	            output.space();
	        }

	        if (self.key instanceof AST_SymbolClassProperty) {
	            print_property_name(self.key.name, self.quote, output);
	        } else {
	            output.print("[");
	            self.key.print(output);
	            output.print("]");
	        }

	        if (self.value) {
	            output.print("=");
	            self.value.print(output);
	        }

	        output.semicolon();
	    });
	    AST_ObjectProperty.DEFMETHOD("_print_getter_setter", function(type, is_private, output) {
	        var self = this;
	        if (self.static) {
	            output.print("static");
	            output.space();
	        }
	        if (type) {
	            output.print(type);
	            output.space();
	        }
	        if (self.key instanceof AST_SymbolMethod) {
	            if (is_private) output.print("#");
	            print_property_name(self.key.name, self.quote, output);
	            self.key.add_source_map(output);
	        } else {
	            output.with_square(function() {
	                self.key.print(output);
	            });
	        }
	        self.value._do_print(output, true);
	    });
	    DEFPRINT(AST_ObjectSetter, function(self, output) {
	        self._print_getter_setter("set", false, output);
	    });
	    DEFPRINT(AST_ObjectGetter, function(self, output) {
	        self._print_getter_setter("get", false, output);
	    });
	    DEFPRINT(AST_PrivateSetter, function(self, output) {
	        self._print_getter_setter("set", true, output);
	    });
	    DEFPRINT(AST_PrivateGetter, function(self, output) {
	        self._print_getter_setter("get", true, output);
	    });
	    DEFPRINT(AST_PrivateMethod, function(self, output) {
	        var type;
	        if (self.is_generator && self.async) {
	            type = "async*";
	        } else if (self.is_generator) {
	            type = "*";
	        } else if (self.async) {
	            type = "async";
	        }
	        self._print_getter_setter(type, true, output);
	    });
	    DEFPRINT(AST_PrivateIn, function(self, output) {
	        self.key.print(output);
	        output.space();
	        output.print("in");
	        output.space();
	        self.value.print(output);
	    });
	    DEFPRINT(AST_SymbolPrivateProperty, function(self, output) {
	        output.print("#" + self.name);
	    });
	    DEFPRINT(AST_ConciseMethod, function(self, output) {
	        var type;
	        if (self.is_generator && self.async) {
	            type = "async*";
	        } else if (self.is_generator) {
	            type = "*";
	        } else if (self.async) {
	            type = "async";
	        }
	        self._print_getter_setter(type, false, output);
	    });
	    DEFPRINT(AST_ClassStaticBlock, function (self, output) {
	        output.print("static");
	        output.space();
	        print_braced(self, output);
	    });
	    AST_Symbol.DEFMETHOD("_do_print", function(output) {
	        var def = this.definition();
	        output.print_name(def ? def.mangled_name || def.name : this.name);
	    });
	    DEFPRINT(AST_Symbol, function (self, output) {
	        self._do_print(output);
	    });
	    DEFPRINT(AST_Hole, noop);
	    DEFPRINT(AST_This, function(self, output) {
	        output.print("this");
	    });
	    DEFPRINT(AST_Super, function(self, output) {
	        output.print("super");
	    });
	    DEFPRINT(AST_Constant, function(self, output) {
	        output.print(self.getValue());
	    });
	    DEFPRINT(AST_String, function(self, output) {
	        output.print_string(self.getValue(), self.quote, output.in_directive);
	    });
	    DEFPRINT(AST_Number, function(self, output) {
	        if ((output.option("keep_numbers") || output.use_asm) && self.raw) {
	            output.print(self.raw);
	        } else {
	            output.print(make_num(self.getValue()));
	        }
	    });
	    DEFPRINT(AST_BigInt, function(self, output) {
	        output.print(self.getValue() + "n");
	    });

	    const r_slash_script = /(<\s*\/\s*script)/i;
	    const r_starts_with_script = /^\s*script/i;
	    const slash_script_replace = (_, $1) => $1.replace("/", "\\/");
	    DEFPRINT(AST_RegExp, function(self, output) {
	        let { source, flags } = self.getValue();
	        source = regexp_source_fix(source);
	        flags = flags ? sort_regexp_flags(flags) : "";

	        // Avoid outputting end of script tag
	        source = source.replace(r_slash_script, slash_script_replace);
	        if (r_starts_with_script.test(source) && output.last().endsWith("<")) {
	            output.print(" ");
	        }

	        output.print(output.to_utf8(`/${source}/${flags}`, false, true));

	        const parent = output.parent();
	        if (
	            parent instanceof AST_Binary
	            && /^\w/.test(parent.operator)
	            && parent.left === self
	        ) {
	            output.print(" ");
	        }
	    });

	    /** if, for, while, may or may not have braces surrounding its body */
	    function print_maybe_braced_body(stat, output) {
	        if (output.option("braces")) {
	            make_block(stat, output);
	        } else {
	            if (!stat || stat instanceof AST_EmptyStatement)
	                output.force_semicolon();
	            else if (stat instanceof AST_Let || stat instanceof AST_Const || stat instanceof AST_Class)
	                make_block(stat, output);
	            else
	                stat.print(output);
	        }
	    }

	    function best_of(a) {
	        var best = a[0], len = best.length;
	        for (var i = 1; i < a.length; ++i) {
	            if (a[i].length < len) {
	                best = a[i];
	                len = best.length;
	            }
	        }
	        return best;
	    }

	    function make_num(num) {
	        var str = num.toString(10).replace(/^0\./, ".").replace("e+", "e");
	        var candidates = [ str ];
	        if (Math.floor(num) === num) {
	            if (num < 0) {
	                candidates.push("-0x" + (-num).toString(16).toLowerCase());
	            } else {
	                candidates.push("0x" + num.toString(16).toLowerCase());
	            }
	        }
	        var match, len, digits;
	        if (match = /^\.0+/.exec(str)) {
	            len = match[0].length;
	            digits = str.slice(len);
	            candidates.push(digits + "e-" + (digits.length + len - 1));
	        } else if (match = /0+$/.exec(str)) {
	            len = match[0].length;
	            candidates.push(str.slice(0, -len) + "e" + len);
	        } else if (match = /^(\d)\.(\d+)e(-?\d+)$/.exec(str)) {
	            candidates.push(match[1] + match[2] + "e" + (match[3] - match[2].length));
	        }
	        return best_of(candidates);
	    }

	    function make_block(stmt, output) {
	        if (!stmt || stmt instanceof AST_EmptyStatement)
	            output.print("{}");
	        else if (stmt instanceof AST_BlockStatement)
	            stmt.print(output);
	        else output.with_block(function() {
	            output.indent();
	            stmt.print(output);
	            output.newline();
	        });
	    }

	    /* -----[ source map generators ]----- */

	    function DEFMAP(nodetype, generator) {
	        nodetype.forEach(function(nodetype) {
	            nodetype.DEFMETHOD("add_source_map", generator);
	        });
	    }

	    DEFMAP([
	        // We could easily add info for ALL nodes, but it seems to me that
	        // would be quite wasteful, hence this noop in the base class.
	        AST_Node,
	        // since the label symbol will mark it
	        AST_LabeledStatement,
	        AST_Toplevel,
	    ], noop);

	    // XXX: I'm not exactly sure if we need it for all of these nodes,
	    // or if we should add even more.
	    DEFMAP([
	        AST_Array,
	        AST_BlockStatement,
	        AST_Catch,
	        AST_Class,
	        AST_Constant,
	        AST_Debugger,
	        AST_Definitions,
	        AST_Directive,
	        AST_Finally,
	        AST_Jump,
	        AST_Lambda,
	        AST_New,
	        AST_Object,
	        AST_StatementWithBody,
	        AST_Symbol,
	        AST_Switch,
	        AST_SwitchBranch,
	        AST_TemplateString,
	        AST_TemplateSegment,
	        AST_Try,
	    ], function(output) {
	        output.add_mapping(this.start);
	    });

	    DEFMAP([
	        AST_ObjectGetter,
	        AST_ObjectSetter,
	        AST_PrivateGetter,
	        AST_PrivateSetter,
	        AST_ConciseMethod,
	        AST_PrivateMethod,
	    ], function(output) {
	        output.add_mapping(this.start, false /*name handled below*/);
	    });

	    DEFMAP([
	        AST_SymbolMethod,
	        AST_SymbolPrivateProperty
	    ], function(output) {
	        const tok_type = this.end && this.end.type;
	        if (tok_type === "name" || tok_type === "privatename") {
	            output.add_mapping(this.end, this.name);
	        } else {
	            output.add_mapping(this.end);
	        }
	    });

	    DEFMAP([ AST_ObjectProperty ], function(output) {
	        output.add_mapping(this.start, this.key);
	    });
	})();

	const shallow_cmp = (node1, node2) => {
	    return (
	        node1 === null && node2 === null
	        || node1.TYPE === node2.TYPE && node1.shallow_cmp(node2)
	    );
	};

	const equivalent_to = (tree1, tree2) => {
	    if (!shallow_cmp(tree1, tree2)) return false;
	    const walk_1_state = [tree1];
	    const walk_2_state = [tree2];

	    const walk_1_push = walk_1_state.push.bind(walk_1_state);
	    const walk_2_push = walk_2_state.push.bind(walk_2_state);

	    while (walk_1_state.length && walk_2_state.length) {
	        const node_1 = walk_1_state.pop();
	        const node_2 = walk_2_state.pop();

	        if (!shallow_cmp(node_1, node_2)) return false;

	        node_1._children_backwards(walk_1_push);
	        node_2._children_backwards(walk_2_push);

	        if (walk_1_state.length !== walk_2_state.length) {
	            // Different number of children
	            return false;
	        }
	    }

	    return walk_1_state.length == 0 && walk_2_state.length == 0;
	};

	const pass_through = () => true;

	AST_Node.prototype.shallow_cmp = function () {
	    throw new Error("did not find a shallow_cmp function for " + this.constructor.name);
	};

	AST_Debugger.prototype.shallow_cmp = pass_through;

	AST_Directive.prototype.shallow_cmp = function(other) {
	    return this.value === other.value;
	};

	AST_SimpleStatement.prototype.shallow_cmp = pass_through;

	AST_Block.prototype.shallow_cmp = pass_through;

	AST_EmptyStatement.prototype.shallow_cmp = pass_through;

	AST_LabeledStatement.prototype.shallow_cmp = function(other) {
	    return this.label.name === other.label.name;
	};

	AST_Do.prototype.shallow_cmp = pass_through;

	AST_While.prototype.shallow_cmp = pass_through;

	AST_For.prototype.shallow_cmp = function(other) {
	    return (this.init == null ? other.init == null : this.init === other.init) && (this.condition == null ? other.condition == null : this.condition === other.condition) && (this.step == null ? other.step == null : this.step === other.step);
	};

	AST_ForIn.prototype.shallow_cmp = pass_through;

	AST_ForOf.prototype.shallow_cmp = pass_through;

	AST_With.prototype.shallow_cmp = pass_through;

	AST_Toplevel.prototype.shallow_cmp = pass_through;

	AST_Expansion.prototype.shallow_cmp = pass_through;

	AST_Lambda.prototype.shallow_cmp = function(other) {
	    return this.is_generator === other.is_generator && this.async === other.async;
	};

	AST_Destructuring.prototype.shallow_cmp = function(other) {
	    return this.is_array === other.is_array;
	};

	AST_PrefixedTemplateString.prototype.shallow_cmp = pass_through;

	AST_TemplateString.prototype.shallow_cmp = pass_through;

	AST_TemplateSegment.prototype.shallow_cmp = function(other) {
	    return this.value === other.value;
	};

	AST_Jump.prototype.shallow_cmp = pass_through;

	AST_LoopControl.prototype.shallow_cmp = pass_through;

	AST_Await.prototype.shallow_cmp = pass_through;

	AST_Yield.prototype.shallow_cmp = function(other) {
	    return this.is_star === other.is_star;
	};

	AST_If.prototype.shallow_cmp = function(other) {
	    return this.alternative == null ? other.alternative == null : this.alternative === other.alternative;
	};

	AST_Switch.prototype.shallow_cmp = pass_through;

	AST_SwitchBranch.prototype.shallow_cmp = pass_through;

	AST_Try.prototype.shallow_cmp = function(other) {
	    return (this.body === other.body) && (this.bcatch == null ? other.bcatch == null : this.bcatch === other.bcatch) && (this.bfinally == null ? other.bfinally == null : this.bfinally === other.bfinally);
	};

	AST_Catch.prototype.shallow_cmp = function(other) {
	    return this.argname == null ? other.argname == null : this.argname === other.argname;
	};

	AST_Finally.prototype.shallow_cmp = pass_through;

	AST_Definitions.prototype.shallow_cmp = pass_through;

	AST_VarDef.prototype.shallow_cmp = function(other) {
	    return this.value == null ? other.value == null : this.value === other.value;
	};

	AST_NameMapping.prototype.shallow_cmp = pass_through;

	AST_Import.prototype.shallow_cmp = function(other) {
	    return (this.imported_name == null ? other.imported_name == null : this.imported_name === other.imported_name) && (this.imported_names == null ? other.imported_names == null : this.imported_names === other.imported_names);
	};

	AST_ImportMeta.prototype.shallow_cmp = pass_through;

	AST_Export.prototype.shallow_cmp = function(other) {
	    return (this.exported_definition == null ? other.exported_definition == null : this.exported_definition === other.exported_definition) && (this.exported_value == null ? other.exported_value == null : this.exported_value === other.exported_value) && (this.exported_names == null ? other.exported_names == null : this.exported_names === other.exported_names) && this.module_name === other.module_name && this.is_default === other.is_default;
	};

	AST_Call.prototype.shallow_cmp = pass_through;

	AST_Sequence.prototype.shallow_cmp = pass_through;

	AST_PropAccess.prototype.shallow_cmp = pass_through;

	AST_Chain.prototype.shallow_cmp = pass_through;

	AST_Dot.prototype.shallow_cmp = function(other) {
	    return this.property === other.property;
	};

	AST_DotHash.prototype.shallow_cmp = function(other) {
	    return this.property === other.property;
	};

	AST_Unary.prototype.shallow_cmp = function(other) {
	    return this.operator === other.operator;
	};

	AST_Binary.prototype.shallow_cmp = function(other) {
	    return this.operator === other.operator;
	};

	AST_Conditional.prototype.shallow_cmp = pass_through;

	AST_Array.prototype.shallow_cmp = pass_through;

	AST_Object.prototype.shallow_cmp = pass_through;

	AST_ObjectProperty.prototype.shallow_cmp = pass_through;

	AST_ObjectKeyVal.prototype.shallow_cmp = function(other) {
	    return this.key === other.key;
	};

	AST_ObjectSetter.prototype.shallow_cmp = function(other) {
	    return this.static === other.static;
	};

	AST_ObjectGetter.prototype.shallow_cmp = function(other) {
	    return this.static === other.static;
	};

	AST_ConciseMethod.prototype.shallow_cmp = function(other) {
	    return this.static === other.static && this.is_generator === other.is_generator && this.async === other.async;
	};

	AST_Class.prototype.shallow_cmp = function(other) {
	    return (this.name == null ? other.name == null : this.name === other.name) && (this.extends == null ? other.extends == null : this.extends === other.extends);
	};

	AST_ClassProperty.prototype.shallow_cmp = function(other) {
	    return this.static === other.static;
	};

	AST_Symbol.prototype.shallow_cmp = function(other) {
	    return this.name === other.name;
	};

	AST_NewTarget.prototype.shallow_cmp = pass_through;

	AST_This.prototype.shallow_cmp = pass_through;

	AST_Super.prototype.shallow_cmp = pass_through;

	AST_String.prototype.shallow_cmp = function(other) {
	    return this.value === other.value;
	};

	AST_Number.prototype.shallow_cmp = function(other) {
	    return this.value === other.value;
	};

	AST_BigInt.prototype.shallow_cmp = function(other) {
	    return this.value === other.value;
	};

	AST_RegExp.prototype.shallow_cmp = function (other) {
	    return (
	        this.value.flags === other.value.flags
	        && this.value.source === other.value.source
	    );
	};

	AST_Atom.prototype.shallow_cmp = pass_through;

	/***********************************************************************

	  A JavaScript tokenizer / parser / beautifier / compressor.
	  https://github.com/mishoo/UglifyJS2

	  -------------------------------- (C) ---------------------------------

	                           Author: Mihai Bazon
	                         <mihai.bazon@gmail.com>
	                       http://mihai.bazon.net/blog

	  Distributed under the BSD license:

	    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

	    Redistribution and use in source and binary forms, with or without
	    modification, are permitted provided that the following conditions
	    are met:

	        * Redistributions of source code must retain the above
	          copyright notice, this list of conditions and the following
	          disclaimer.

	        * Redistributions in binary form must reproduce the above
	          copyright notice, this list of conditions and the following
	          disclaimer in the documentation and/or other materials
	          provided with the distribution.

	    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
	    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
	    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
	    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
	    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
	    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
	    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
	    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
	    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
	    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
	    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
	    SUCH DAMAGE.

	 ***********************************************************************/

	const MASK_EXPORT_DONT_MANGLE = 1 << 0;
	const MASK_EXPORT_WANT_MANGLE = 1 << 1;

	let function_defs = null;
	let unmangleable_names = null;
	/**
	 * When defined, there is a function declaration somewhere that's inside of a block.
	 * See https://tc39.es/ecma262/multipage/additional-ecmascript-features-for-web-browsers.html#sec-block-level-function-declarations-web-legacy-compatibility-semantics
	*/
	let scopes_with_block_defuns = null;

	class SymbolDef {
	    constructor(scope, orig, init) {
	        this.name = orig.name;
	        this.orig = [ orig ];
	        this.init = init;
	        this.eliminated = 0;
	        this.assignments = 0;
	        this.scope = scope;
	        this.replaced = 0;
	        this.global = false;
	        this.export = 0;
	        this.mangled_name = null;
	        this.undeclared = false;
	        this.id = SymbolDef.next_id++;
	        this.chained = false;
	        this.direct_access = false;
	        this.escaped = 0;
	        this.recursive_refs = 0;
	        this.references = [];
	        this.should_replace = undefined;
	        this.single_use = false;
	        this.fixed = false;
	        Object.seal(this);
	    }
	    fixed_value() {
	        if (!this.fixed || this.fixed instanceof AST_Node) return this.fixed;
	        return this.fixed();
	    }
	    unmangleable(options) {
	        if (!options) options = {};

	        if (
	            function_defs &&
	            function_defs.has(this.id) &&
	            keep_name(options.keep_fnames, this.orig[0].name)
	        ) return true;

	        return this.global && !options.toplevel
	            || (this.export & MASK_EXPORT_DONT_MANGLE)
	            || this.undeclared
	            || !options.eval && this.scope.pinned()
	            || (this.orig[0] instanceof AST_SymbolLambda
	                  || this.orig[0] instanceof AST_SymbolDefun) && keep_name(options.keep_fnames, this.orig[0].name)
	            || this.orig[0] instanceof AST_SymbolMethod
	            || (this.orig[0] instanceof AST_SymbolClass
	                  || this.orig[0] instanceof AST_SymbolDefClass) && keep_name(options.keep_classnames, this.orig[0].name);
	    }
	    mangle(options) {
	        const cache = options.cache && options.cache.props;
	        if (this.global && cache && cache.has(this.name)) {
	            this.mangled_name = cache.get(this.name);
	        } else if (!this.mangled_name && !this.unmangleable(options)) {
	            var s = this.scope;
	            var sym = this.orig[0];
	            if (options.ie8 && sym instanceof AST_SymbolLambda)
	                s = s.parent_scope;
	            const redefinition = redefined_catch_def(this);
	            this.mangled_name = redefinition
	                ? redefinition.mangled_name || redefinition.name
	                : s.next_mangled(options, this);
	            if (this.global && cache) {
	                cache.set(this.name, this.mangled_name);
	            }
	        }
	    }
	}

	SymbolDef.next_id = 1;

	function redefined_catch_def(def) {
	    if (def.orig[0] instanceof AST_SymbolCatch
	        && def.scope.is_block_scope()
	    ) {
	        return def.scope.get_defun_scope().variables.get(def.name);
	    }
	}

	AST_Scope.DEFMETHOD("figure_out_scope", function(options, { parent_scope = null, toplevel = this } = {}) {
	    options = defaults(options, {
	        cache: null,
	        ie8: false,
	        safari10: false,
	        module: false,
	    });

	    if (!(toplevel instanceof AST_Toplevel)) {
	        throw new Error("Invalid toplevel scope");
	    }

	    // pass 1: setup scope chaining and handle definitions
	    var scope = this.parent_scope = parent_scope;
	    var labels = new Map();
	    var defun = null;
	    var in_destructuring = null;
	    var for_scopes = [];
	    var tw = new TreeWalker((node, descend) => {
	        if (node.is_block_scope()) {
	            const save_scope = scope;
	            node.block_scope = scope = new AST_Scope(node);
	            scope._block_scope = true;
	            scope.init_scope_vars(save_scope);
	            scope.uses_with = save_scope.uses_with;
	            scope.uses_eval = save_scope.uses_eval;

	            if (options.safari10) {
	                if (node instanceof AST_For || node instanceof AST_ForIn || node instanceof AST_ForOf) {
	                    for_scopes.push(scope);
	                }
	            }

	            if (node instanceof AST_Switch) {
	                // XXX: HACK! Ensure the switch expression gets the correct scope (the parent scope) and the body gets the contained scope
	                // AST_Switch has a scope within the body, but it itself "is a block scope"
	                // This means the switched expression has to belong to the outer scope
	                // while the body inside belongs to the switch itself.
	                // This is pretty nasty and warrants an AST change
	                const the_block_scope = scope;
	                scope = save_scope;
	                node.expression.walk(tw);
	                scope = the_block_scope;
	                for (let i = 0; i < node.body.length; i++) {
	                    node.body[i].walk(tw);
	                }
	            } else {
	                descend();
	            }
	            scope = save_scope;
	            return true;
	        }
	        if (node instanceof AST_Destructuring) {
	            const save_destructuring = in_destructuring;
	            in_destructuring = node;
	            descend();
	            in_destructuring = save_destructuring;
	            return true;
	        }
	        if (node instanceof AST_Scope) {
	            node.init_scope_vars(scope);
	            var save_scope = scope;
	            var save_defun = defun;
	            var save_labels = labels;
	            defun = scope = node;
	            labels = new Map();
	            descend();
	            scope = save_scope;
	            defun = save_defun;
	            labels = save_labels;
	            return true;        // don't descend again in TreeWalker
	        }
	        if (node instanceof AST_LabeledStatement) {
	            var l = node.label;
	            if (labels.has(l.name)) {
	                throw new Error(string_template("Label {name} defined twice", l));
	            }
	            labels.set(l.name, l);
	            descend();
	            labels.delete(l.name);
	            return true;        // no descend again
	        }
	        if (node instanceof AST_With) {
	            for (var s = scope; s; s = s.parent_scope)
	                s.uses_with = true;
	            return;
	        }
	        if (node instanceof AST_Symbol) {
	            node.scope = scope;
	        }
	        if (node instanceof AST_Label) {
	            node.thedef = node;
	            node.references = [];
	        }
	        if (node instanceof AST_SymbolLambda) {
	            defun.def_function(node, node.name == "arguments" ? undefined : defun);
	        } else if (node instanceof AST_SymbolDefun) {
	            // Careful here, the scope where this should be defined is
	            // the parent scope.  The reason is that we enter a new
	            // scope when we encounter the AST_Defun node (which is
	            // instanceof AST_Scope) but we get to the symbol a bit
	            // later.
	            const closest_scope = defun.parent_scope;

	            // In strict mode, function definitions are block-scoped
	            node.scope = tw.directives["use strict"]
	                ? closest_scope
	                : closest_scope.get_defun_scope();

	            mark_export(node.scope.def_function(node, defun), 1);
	        } else if (node instanceof AST_SymbolClass) {
	            mark_export(defun.def_variable(node, defun), 1);
	        } else if (node instanceof AST_SymbolImport) {
	            scope.def_variable(node);
	        } else if (node instanceof AST_SymbolDefClass) {
	            // This deals with the name of the class being available
	            // inside the class.
	            mark_export((node.scope = defun.parent_scope).def_function(node, defun), 1);
	        } else if (
	            node instanceof AST_SymbolVar
	            || node instanceof AST_SymbolLet
	            || node instanceof AST_SymbolConst
	            || node instanceof AST_SymbolCatch
	        ) {
	            var def;
	            if (node instanceof AST_SymbolBlockDeclaration) {
	                def = scope.def_variable(node, null);
	            } else {
	                def = defun.def_variable(node, node.TYPE == "SymbolVar" ? null : undefined);
	            }
	            if (!def.orig.every((sym) => {
	                if (sym === node) return true;
	                if (node instanceof AST_SymbolBlockDeclaration) {
	                    return sym instanceof AST_SymbolLambda;
	                }
	                return !(sym instanceof AST_SymbolLet || sym instanceof AST_SymbolConst);
	            })) {
	                js_error(
	                    `"${node.name}" is redeclared`,
	                    node.start.file,
	                    node.start.line,
	                    node.start.col,
	                    node.start.pos
	                );
	            }
	            if (!(node instanceof AST_SymbolFunarg)) mark_export(def, 2);
	            if (defun !== scope) {
	                node.mark_enclosed();
	                var def = scope.find_variable(node);
	                if (node.thedef !== def) {
	                    node.thedef = def;
	                    node.reference();
	                }
	            }
	        } else if (node instanceof AST_LabelRef) {
	            var sym = labels.get(node.name);
	            if (!sym) throw new Error(string_template("Undefined label {name} [{line},{col}]", {
	                name: node.name,
	                line: node.start.line,
	                col: node.start.col
	            }));
	            node.thedef = sym;
	        }
	        if (!(scope instanceof AST_Toplevel) && (node instanceof AST_Export || node instanceof AST_Import)) {
	            js_error(
	                `"${node.TYPE}" statement may only appear at the top level`,
	                node.start.file,
	                node.start.line,
	                node.start.col,
	                node.start.pos
	            );
	        }
	    });

	    if (options.module) {
	        tw.directives["use strict"] = true;
	    }

	    this.walk(tw);

	    function mark_export(def, level) {
	        if (in_destructuring) {
	            var i = 0;
	            do {
	                level++;
	            } while (tw.parent(i++) !== in_destructuring);
	        }
	        var node = tw.parent(level);
	        if (def.export = node instanceof AST_Export ? MASK_EXPORT_DONT_MANGLE : 0) {
	            var exported = node.exported_definition;
	            if ((exported instanceof AST_Defun || exported instanceof AST_DefClass) && node.is_default) {
	                def.export = MASK_EXPORT_WANT_MANGLE;
	            }
	        }
	    }

	    // pass 2: find back references and eval
	    const is_toplevel = this instanceof AST_Toplevel;
	    if (is_toplevel) {
	        this.globals = new Map();
	    }

	    var tw = new TreeWalker(node => {
	        if (node instanceof AST_LoopControl && node.label) {
	            node.label.thedef.references.push(node);
	            return true;
	        }
	        if (node instanceof AST_SymbolRef) {
	            var name = node.name;
	            if (name == "eval" && tw.parent() instanceof AST_Call) {
	                for (var s = node.scope; s && !s.uses_eval; s = s.parent_scope) {
	                    s.uses_eval = true;
	                }
	            }
	            var sym;
	            if (tw.parent() instanceof AST_NameMapping && tw.parent(1).module_name
	                || !(sym = node.scope.find_variable(name))) {

	                sym = toplevel.def_global(node);
	                if (node instanceof AST_SymbolExport) sym.export = MASK_EXPORT_DONT_MANGLE;
	            } else if (sym.scope instanceof AST_Lambda && name == "arguments") {
	                sym.scope.get_defun_scope().uses_arguments = true;
	            }
	            node.thedef = sym;
	            node.reference();
	            if (node.scope.is_block_scope()
	                && !(sym.orig[0] instanceof AST_SymbolBlockDeclaration)) {
	                node.scope = node.scope.get_defun_scope();
	            }
	            return true;
	        }
	        // ensure mangling works if catch reuses a scope variable
	        var def;
	        if (node instanceof AST_SymbolCatch && (def = redefined_catch_def(node.definition()))) {
	            var s = node.scope;
	            while (s) {
	                push_uniq(s.enclosed, def);
	                if (s === def.scope) break;
	                s = s.parent_scope;
	            }
	        }
	    });
	    this.walk(tw);

	    // pass 3: work around IE8 and Safari catch scope bugs
	    if (options.ie8 || options.safari10) {
	        walk(this, node => {
	            if (node instanceof AST_SymbolCatch) {
	                var name = node.name;
	                var refs = node.thedef.references;
	                var scope = node.scope.get_defun_scope();
	                var def = scope.find_variable(name)
	                    || toplevel.globals.get(name)
	                    || scope.def_variable(node);
	                refs.forEach(function(ref) {
	                    ref.thedef = def;
	                    ref.reference();
	                });
	                node.thedef = def;
	                node.reference();
	                return true;
	            }
	        });
	    }

	    // pass 4: add symbol definitions to loop scopes
	    // Safari/Webkit bug workaround - loop init let variable shadowing argument.
	    // https://github.com/mishoo/UglifyJS2/issues/1753
	    // https://bugs.webkit.org/show_bug.cgi?id=171041
	    if (options.safari10) {
	        for (const scope of for_scopes) {
	            scope.parent_scope.variables.forEach(function(def) {
	                push_uniq(scope.enclosed, def);
	            });
	        }
	    }
	});

	AST_Toplevel.DEFMETHOD("def_global", function(node) {
	    var globals = this.globals, name = node.name;
	    if (globals.has(name)) {
	        return globals.get(name);
	    } else {
	        var g = new SymbolDef(this, node);
	        g.undeclared = true;
	        g.global = true;
	        globals.set(name, g);
	        return g;
	    }
	});

	AST_Scope.DEFMETHOD("init_scope_vars", function(parent_scope) {
	    this.variables = new Map();         // map name to AST_SymbolVar (variables defined in this scope; includes functions)
	    this.uses_with = false;             // will be set to true if this or some nested scope uses the `with` statement
	    this.uses_eval = false;             // will be set to true if this or nested scope uses the global `eval`
	    this.parent_scope = parent_scope;   // the parent scope
	    this.enclosed = [];                 // a list of variables from this or outer scope(s) that are referenced from this or inner scopes
	    this.cname = -1;                    // the current index for mangling functions/variables
	});

	AST_Scope.DEFMETHOD("conflicting_def", function (name) {
	    return (
	        this.enclosed.find(def => def.name === name)
	        || this.variables.has(name)
	        || (this.parent_scope && this.parent_scope.conflicting_def(name))
	    );
	});

	AST_Scope.DEFMETHOD("conflicting_def_shallow", function (name) {
	    return (
	        this.enclosed.find(def => def.name === name)
	        || this.variables.has(name)
	    );
	});

	AST_Scope.DEFMETHOD("add_child_scope", function (scope) {
	    // `scope` is going to be moved into `this` right now.
	    // Update the required scopes' information

	    if (scope.parent_scope === this) return;

	    scope.parent_scope = this;

	    // Propagate to this.uses_arguments from arrow functions
	    if ((scope instanceof AST_Arrow) && !this.uses_arguments) {
	        this.uses_arguments = walk(scope, node => {
	            if (
	                node instanceof AST_SymbolRef
	                && node.scope instanceof AST_Lambda
	                && node.name === "arguments"
	            ) {
	                return walk_abort;
	            }

	            if (node instanceof AST_Lambda && !(node instanceof AST_Arrow)) {
	                return true;
	            }
	        });
	    }

	    this.uses_with = this.uses_with || scope.uses_with;
	    this.uses_eval = this.uses_eval || scope.uses_eval;

	    const scope_ancestry = (() => {
	        const ancestry = [];
	        let cur = this;
	        do {
	            ancestry.push(cur);
	        } while ((cur = cur.parent_scope));
	        ancestry.reverse();
	        return ancestry;
	    })();

	    const new_scope_enclosed_set = new Set(scope.enclosed);
	    const to_enclose = [];
	    for (const scope_topdown of scope_ancestry) {
	        to_enclose.forEach(e => push_uniq(scope_topdown.enclosed, e));
	        for (const def of scope_topdown.variables.values()) {
	            if (new_scope_enclosed_set.has(def)) {
	                push_uniq(to_enclose, def);
	                push_uniq(scope_topdown.enclosed, def);
	            }
	        }
	    }
	});

	function find_scopes_visible_from(scopes) {
	    const found_scopes = new Set();

	    for (const scope of new Set(scopes)) {
	        (function bubble_up(scope) {
	            if (scope == null || found_scopes.has(scope)) return;

	            found_scopes.add(scope);

	            bubble_up(scope.parent_scope);
	        })(scope);
	    }

	    return [...found_scopes];
	}

	// Creates a symbol during compression
	AST_Scope.DEFMETHOD("create_symbol", function(SymClass, {
	    source,
	    tentative_name,
	    scope,
	    conflict_scopes = [scope],
	    init = null
	} = {}) {
	    let symbol_name;

	    conflict_scopes = find_scopes_visible_from(conflict_scopes);

	    if (tentative_name) {
	        // Implement hygiene (no new names are conflicting with existing names)
	        tentative_name =
	            symbol_name =
	            tentative_name.replace(/(?:^[^a-z_$]|[^a-z0-9_$])/ig, "_");

	        let i = 0;
	        while (conflict_scopes.find(s => s.conflicting_def_shallow(symbol_name))) {
	            symbol_name = tentative_name + "$" + i++;
	        }
	    }

	    if (!symbol_name) {
	        throw new Error("No symbol name could be generated in create_symbol()");
	    }

	    const symbol = make_node(SymClass, source, {
	        name: symbol_name,
	        scope
	    });

	    this.def_variable(symbol, init || null);

	    symbol.mark_enclosed();

	    return symbol;
	});


	AST_Node.DEFMETHOD("is_block_scope", return_false);
	AST_Class.DEFMETHOD("is_block_scope", return_false);
	AST_Lambda.DEFMETHOD("is_block_scope", return_false);
	AST_Toplevel.DEFMETHOD("is_block_scope", return_false);
	AST_SwitchBranch.DEFMETHOD("is_block_scope", return_false);
	AST_Block.DEFMETHOD("is_block_scope", return_true);
	AST_Scope.DEFMETHOD("is_block_scope", function () {
	    return this._block_scope || false;
	});
	AST_IterationStatement.DEFMETHOD("is_block_scope", return_true);

	AST_Lambda.DEFMETHOD("init_scope_vars", function() {
	    AST_Scope.prototype.init_scope_vars.apply(this, arguments);
	    this.uses_arguments = false;
	    this.def_variable(new AST_SymbolFunarg({
	        name: "arguments",
	        start: this.start,
	        end: this.end
	    }));
	});

	AST_Arrow.DEFMETHOD("init_scope_vars", function() {
	    AST_Scope.prototype.init_scope_vars.apply(this, arguments);
	    this.uses_arguments = false;
	});

	AST_Symbol.DEFMETHOD("mark_enclosed", function() {
	    var def = this.definition();
	    var s = this.scope;
	    while (s) {
	        push_uniq(s.enclosed, def);
	        if (s === def.scope) break;
	        s = s.parent_scope;
	    }
	});

	AST_Symbol.DEFMETHOD("reference", function() {
	    this.definition().references.push(this);
	    this.mark_enclosed();
	});

	AST_Scope.DEFMETHOD("find_variable", function(name) {
	    if (name instanceof AST_Symbol) name = name.name;
	    return this.variables.get(name)
	        || (this.parent_scope && this.parent_scope.find_variable(name));
	});

	AST_Scope.DEFMETHOD("def_function", function(symbol, init) {
	    var def = this.def_variable(symbol, init);
	    if (!def.init || def.init instanceof AST_Defun) def.init = init;
	    return def;
	});

	AST_Scope.DEFMETHOD("def_variable", function(symbol, init) {
	    var def = this.variables.get(symbol.name);
	    if (def) {
	        def.orig.push(symbol);
	        if (def.init && (def.scope !== symbol.scope || def.init instanceof AST_Function)) {
	            def.init = init;
	        }
	    } else {
	        def = new SymbolDef(this, symbol, init);
	        this.variables.set(symbol.name, def);
	        def.global = !this.parent_scope;
	    }
	    return symbol.thedef = def;
	});

	function next_mangled(scope, options) {
	    let defun_scope;
	    if (
	        scopes_with_block_defuns
	        && (defun_scope = scope.get_defun_scope())
	        && scopes_with_block_defuns.has(defun_scope)
	    ) {
	        scope = defun_scope;
	    }

	    var ext = scope.enclosed;
	    var nth_identifier = options.nth_identifier;
	    out: while (true) {
	        var m = nth_identifier.get(++scope.cname);
	        if (ALL_RESERVED_WORDS.has(m)) continue; // skip over "do"

	        // https://github.com/mishoo/UglifyJS2/issues/242 -- do not
	        // shadow a name reserved from mangling.
	        if (options.reserved.has(m)) continue;

	        // Functions with short names might collide with base54 output
	        // and therefore cause collisions when keep_fnames is true.
	        if (unmangleable_names && unmangleable_names.has(m)) continue out;

	        // we must ensure that the mangled name does not shadow a name
	        // from some parent scope that is referenced in this or in
	        // inner scopes.
	        for (let i = ext.length; --i >= 0;) {
	            const def = ext[i];
	            const name = def.mangled_name || (def.unmangleable(options) && def.name);
	            if (m == name) continue out;
	        }
	        return m;
	    }
	}

	AST_Scope.DEFMETHOD("next_mangled", function(options) {
	    return next_mangled(this, options);
	});

	AST_Toplevel.DEFMETHOD("next_mangled", function(options) {
	    let name;
	    const mangled_names = this.mangled_names;
	    do {
	        name = next_mangled(this, options);
	    } while (mangled_names.has(name));
	    return name;
	});

	AST_Function.DEFMETHOD("next_mangled", function(options, def) {
	    // #179, #326
	    // in Safari strict mode, something like (function x(x){...}) is a syntax error;
	    // a function expression's argument cannot shadow the function expression's name

	    var tricky_def = def.orig[0] instanceof AST_SymbolFunarg && this.name && this.name.definition();

	    // the function's mangled_name is null when keep_fnames is true
	    var tricky_name = tricky_def ? tricky_def.mangled_name || tricky_def.name : null;

	    while (true) {
	        var name = next_mangled(this, options);
	        if (!tricky_name || tricky_name != name)
	            return name;
	    }
	});

	AST_Symbol.DEFMETHOD("unmangleable", function(options) {
	    var def = this.definition();
	    return !def || def.unmangleable(options);
	});

	// labels are always mangleable
	AST_Label.DEFMETHOD("unmangleable", return_false);

	AST_Symbol.DEFMETHOD("unreferenced", function() {
	    return !this.definition().references.length && !this.scope.pinned();
	});

	AST_Symbol.DEFMETHOD("definition", function() {
	    return this.thedef;
	});

	AST_Symbol.DEFMETHOD("global", function() {
	    return this.thedef.global;
	});

	/**
	 * Format the mangler options (if any) into their appropriate types
	 */
	function format_mangler_options(options) {
	    options = defaults(options, {
	        eval        : false,
	        nth_identifier : base54,
	        ie8         : false,
	        keep_classnames: false,
	        keep_fnames : false,
	        module      : false,
	        reserved    : [],
	        toplevel    : false,
	    });
	    if (options.module) options.toplevel = true;
	    if (!Array.isArray(options.reserved)
	        && !(options.reserved instanceof Set)
	    ) {
	        options.reserved = [];
	    }
	    options.reserved = new Set(options.reserved);
	    // Never mangle arguments
	    options.reserved.add("arguments");
	    return options;
	}

	AST_Toplevel.DEFMETHOD("mangle_names", function(options) {
	    options = format_mangler_options(options);
	    var nth_identifier = options.nth_identifier;

	    // We only need to mangle declaration nodes.  Special logic wired
	    // into the code generator will display the mangled name if it's
	    // present (and for AST_SymbolRef-s it'll use the mangled name of
	    // the AST_SymbolDeclaration that it points to).
	    var lname = -1;
	    var to_mangle = [];

	    if (options.keep_fnames) {
	        function_defs = new Set();
	    }

	    const mangled_names = this.mangled_names = new Set();
	    unmangleable_names = new Set();

	    if (options.cache) {
	        this.globals.forEach(collect);
	        if (options.cache.props) {
	            options.cache.props.forEach(function(mangled_name) {
	                mangled_names.add(mangled_name);
	            });
	        }
	    }

	    var tw = new TreeWalker(function(node, descend) {
	        if (node instanceof AST_LabeledStatement) {
	            // lname is incremented when we get to the AST_Label
	            var save_nesting = lname;
	            descend();
	            lname = save_nesting;
	            return true;        // don't descend again in TreeWalker
	        }
	        if (
	            node instanceof AST_Defun
	            && !(tw.parent() instanceof AST_Scope)
	        ) {
	            scopes_with_block_defuns = scopes_with_block_defuns || new Set();
	            scopes_with_block_defuns.add(node.parent_scope.get_defun_scope());
	        }
	        if (node instanceof AST_Scope) {
	            node.variables.forEach(collect);
	            return;
	        }
	        if (node.is_block_scope()) {
	            node.block_scope.variables.forEach(collect);
	            return;
	        }
	        if (
	            function_defs
	            && node instanceof AST_VarDef
	            && node.value instanceof AST_Lambda
	            && !node.value.name
	            && keep_name(options.keep_fnames, node.name.name)
	        ) {
	            function_defs.add(node.name.definition().id);
	            return;
	        }
	        if (node instanceof AST_Label) {
	            let name;
	            do {
	                name = nth_identifier.get(++lname);
	            } while (ALL_RESERVED_WORDS.has(name));
	            node.mangled_name = name;
	            return true;
	        }
	        if (!(options.ie8 || options.safari10) && node instanceof AST_SymbolCatch) {
	            to_mangle.push(node.definition());
	            return;
	        }
	    });

	    this.walk(tw);

	    if (options.keep_fnames || options.keep_classnames) {
	        // Collect a set of short names which are unmangleable,
	        // for use in avoiding collisions in next_mangled.
	        to_mangle.forEach(def => {
	            if (def.name.length < 6 && def.unmangleable(options)) {
	                unmangleable_names.add(def.name);
	            }
	        });
	    }

	    to_mangle.forEach(def => { def.mangle(options); });

	    function_defs = null;
	    unmangleable_names = null;
	    scopes_with_block_defuns = null;

	    function collect(symbol) {
	        if (symbol.export & MASK_EXPORT_DONT_MANGLE) {
	            unmangleable_names.add(symbol.name);
	        } else if (!options.reserved.has(symbol.name)) {
	            to_mangle.push(symbol);
	        }
	    }
	});

	AST_Toplevel.DEFMETHOD("find_colliding_names", function(options) {
	    const cache = options.cache && options.cache.props;
	    const avoid = new Set();
	    options.reserved.forEach(to_avoid);
	    this.globals.forEach(add_def);
	    this.walk(new TreeWalker(function(node) {
	        if (node instanceof AST_Scope) node.variables.forEach(add_def);
	        if (node instanceof AST_SymbolCatch) add_def(node.definition());
	    }));
	    return avoid;

	    function to_avoid(name) {
	        avoid.add(name);
	    }

	    function add_def(def) {
	        var name = def.name;
	        if (def.global && cache && cache.has(name)) name = cache.get(name);
	        else if (!def.unmangleable(options)) return;
	        to_avoid(name);
	    }
	});

	AST_Toplevel.DEFMETHOD("expand_names", function(options) {
	    options = format_mangler_options(options);
	    var nth_identifier = options.nth_identifier;
	    if (nth_identifier.reset && nth_identifier.sort) {
	        nth_identifier.reset();
	        nth_identifier.sort();
	    }
	    var avoid = this.find_colliding_names(options);
	    var cname = 0;
	    this.globals.forEach(rename);
	    this.walk(new TreeWalker(function(node) {
	        if (node instanceof AST_Scope) node.variables.forEach(rename);
	        if (node instanceof AST_SymbolCatch) rename(node.definition());
	    }));

	    function next_name() {
	        var name;
	        do {
	            name = nth_identifier.get(cname++);
	        } while (avoid.has(name) || ALL_RESERVED_WORDS.has(name));
	        return name;
	    }

	    function rename(def) {
	        if (def.global && options.cache) return;
	        if (def.unmangleable(options)) return;
	        if (options.reserved.has(def.name)) return;
	        const redefinition = redefined_catch_def(def);
	        const name = def.name = redefinition ? redefinition.name : next_name();
	        def.orig.forEach(function(sym) {
	            sym.name = name;
	        });
	        def.references.forEach(function(sym) {
	            sym.name = name;
	        });
	    }
	});

	AST_Node.DEFMETHOD("tail_node", return_this);
	AST_Sequence.DEFMETHOD("tail_node", function() {
	    return this.expressions[this.expressions.length - 1];
	});

	AST_Toplevel.DEFMETHOD("compute_char_frequency", function(options) {
	    options = format_mangler_options(options);
	    var nth_identifier = options.nth_identifier;
	    if (!nth_identifier.reset || !nth_identifier.consider || !nth_identifier.sort) {
	        // If the identifier mangler is invariant, skip computing character frequency.
	        return;
	    }
	    nth_identifier.reset();

	    try {
	        AST_Node.prototype.print = function(stream, force_parens) {
	            this._print(stream, force_parens);
	            if (this instanceof AST_Symbol && !this.unmangleable(options)) {
	                nth_identifier.consider(this.name, -1);
	            } else if (options.properties) {
	                if (this instanceof AST_DotHash) {
	                    nth_identifier.consider("#" + this.property, -1);
	                } else if (this instanceof AST_Dot) {
	                    nth_identifier.consider(this.property, -1);
	                } else if (this instanceof AST_Sub) {
	                    skip_string(this.property);
	                }
	            }
	        };
	        nth_identifier.consider(this.print_to_string(), 1);
	    } finally {
	        AST_Node.prototype.print = AST_Node.prototype._print;
	    }
	    nth_identifier.sort();

	    function skip_string(node) {
	        if (node instanceof AST_String) {
	            nth_identifier.consider(node.value, -1);
	        } else if (node instanceof AST_Conditional) {
	            skip_string(node.consequent);
	            skip_string(node.alternative);
	        } else if (node instanceof AST_Sequence) {
	            skip_string(node.tail_node());
	        }
	    }
	});

	const base54 = (() => {
	    const leading = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ$_".split("");
	    const digits = "0123456789".split("");
	    let chars;
	    let frequency;
	    function reset() {
	        frequency = new Map();
	        leading.forEach(function(ch) {
	            frequency.set(ch, 0);
	        });
	        digits.forEach(function(ch) {
	            frequency.set(ch, 0);
	        });
	    }
	    function consider(str, delta) {
	        for (var i = str.length; --i >= 0;) {
	            frequency.set(str[i], frequency.get(str[i]) + delta);
	        }
	    }
	    function compare(a, b) {
	        return frequency.get(b) - frequency.get(a);
	    }
	    function sort() {
	        chars = mergeSort(leading, compare).concat(mergeSort(digits, compare));
	    }
	    // Ensure this is in a usable initial state.
	    reset();
	    sort();
	    function base54(num) {
	        var ret = "", base = 54;
	        num++;
	        do {
	            num--;
	            ret += chars[num % base];
	            num = Math.floor(num / base);
	            base = 64;
	        } while (num > 0);
	        return ret;
	    }

	    return {
	        get: base54,
	        consider,
	        reset,
	        sort
	    };
	})();

	let mangle_options = undefined;
	AST_Node.prototype.size = function (compressor, stack) {
	    mangle_options = compressor && compressor._mangle_options;

	    let size = 0;
	    walk_parent(this, (node, info) => {
	        size += node._size(info);

	        // Braceless arrow functions have fake "return" statements
	        if (node instanceof AST_Arrow && node.is_braceless()) {
	            size += node.body[0].value._size(info);
	            return true;
	        }
	    }, stack || (compressor && compressor.stack));

	    // just to save a bit of memory
	    mangle_options = undefined;

	    return size;
	};

	AST_Node.prototype._size = () => 0;

	AST_Debugger.prototype._size = () => 8;

	AST_Directive.prototype._size = function () {
	    // TODO string encoding stuff
	    return 2 + this.value.length;
	};

	/** Count commas/semicolons necessary to show a list of expressions/statements */
	const list_overhead = (array) => array.length && array.length - 1;

	AST_Block.prototype._size = function () {
	    return 2 + list_overhead(this.body);
	};

	AST_Toplevel.prototype._size = function() {
	    return list_overhead(this.body);
	};

	AST_EmptyStatement.prototype._size = () => 1;

	AST_LabeledStatement.prototype._size = () => 2;  // x:

	AST_Do.prototype._size = () => 9;

	AST_While.prototype._size = () => 7;

	AST_For.prototype._size = () => 8;

	AST_ForIn.prototype._size = () => 8;
	// AST_ForOf inherits ^

	AST_With.prototype._size = () => 6;

	AST_Expansion.prototype._size = () => 3;

	const lambda_modifiers = func =>
	    (func.is_generator ? 1 : 0) + (func.async ? 6 : 0);

	AST_Accessor.prototype._size = function () {
	    return lambda_modifiers(this) + 4 + list_overhead(this.argnames) + list_overhead(this.body);
	};

	AST_Function.prototype._size = function (info) {
	    const first = !!first_in_statement(info);
	    return (first * 2) + lambda_modifiers(this) + 12 + list_overhead(this.argnames) + list_overhead(this.body);
	};

	AST_Defun.prototype._size = function () {
	    return lambda_modifiers(this) + 13 + list_overhead(this.argnames) + list_overhead(this.body);
	};

	AST_Arrow.prototype._size = function () {
	    let args_and_arrow = 2 + list_overhead(this.argnames);

	    if (
	        !(
	            this.argnames.length === 1
	            && this.argnames[0] instanceof AST_Symbol
	        )
	    ) {
	        args_and_arrow += 2; // parens around the args
	    }

	    const body_overhead = this.is_braceless() ? 0 : list_overhead(this.body) + 2;

	    return lambda_modifiers(this) + args_and_arrow + body_overhead;
	};

	AST_Destructuring.prototype._size = () => 2;

	AST_TemplateString.prototype._size = function () {
	    return 2 + (Math.floor(this.segments.length / 2) * 3);  /* "${}" */
	};

	AST_TemplateSegment.prototype._size = function () {
	    return this.value.length;
	};

	AST_Return.prototype._size = function () {
	    return this.value ? 7 : 6;
	};

	AST_Throw.prototype._size = () => 6;

	AST_Break.prototype._size = function () {
	    return this.label ? 6 : 5;
	};

	AST_Continue.prototype._size = function () {
	    return this.label ? 9 : 8;
	};

	AST_If.prototype._size = () => 4;

	AST_Switch.prototype._size = function () {
	    return 8 + list_overhead(this.body);
	};

	AST_Case.prototype._size = function () {
	    return 5 + list_overhead(this.body);
	};

	AST_Default.prototype._size = function () {
	    return 8 + list_overhead(this.body);
	};

	AST_Try.prototype._size = () => 3;

	AST_Catch.prototype._size = function () {
	    let size = 7 + list_overhead(this.body);
	    if (this.argname) {
	        size += 2;
	    }
	    return size;
	};

	AST_Finally.prototype._size = function () {
	    return 7 + list_overhead(this.body);
	};

	AST_Var.prototype._size = function () {
	    return 4 + list_overhead(this.definitions);
	};

	AST_Let.prototype._size = function () {
	    return 4 + list_overhead(this.definitions);
	};

	AST_Const.prototype._size = function () {
	    return 6 + list_overhead(this.definitions);
	};

	AST_VarDef.prototype._size = function () {
	    return this.value ? 1 : 0;
	};

	AST_NameMapping.prototype._size = function () {
	    // foreign name isn't mangled
	    return this.name ? 4 : 0;
	};

	AST_Import.prototype._size = function () {
	    // import
	    let size = 6;

	    if (this.imported_name) size += 1;

	    // from
	    if (this.imported_name || this.imported_names) size += 5;

	    // braces, and the commas
	    if (this.imported_names) {
	        size += 2 + list_overhead(this.imported_names);
	    }

	    return size;
	};

	AST_ImportMeta.prototype._size = () => 11;

	AST_Export.prototype._size = function () {
	    let size = 7 + (this.is_default ? 8 : 0);

	    if (this.exported_value) {
	        size += this.exported_value._size();
	    }

	    if (this.exported_names) {
	        // Braces and commas
	        size += 2 + list_overhead(this.exported_names);
	    }

	    if (this.module_name) {
	        // "from "
	        size += 5;
	    }

	    return size;
	};

	AST_Call.prototype._size = function () {
	    if (this.optional) {
	        return 4 + list_overhead(this.args);
	    }
	    return 2 + list_overhead(this.args);
	};

	AST_New.prototype._size = function () {
	    return 6 + list_overhead(this.args);
	};

	AST_Sequence.prototype._size = function () {
	    return list_overhead(this.expressions);
	};

	AST_Dot.prototype._size = function () {
	    if (this.optional) {
	        return this.property.length + 2;
	    }
	    return this.property.length + 1;
	};

	AST_DotHash.prototype._size = function () {
	    if (this.optional) {
	        return this.property.length + 3;
	    }
	    return this.property.length + 2;
	};

	AST_Sub.prototype._size = function () {
	    return this.optional ? 4 : 2;
	};

	AST_Unary.prototype._size = function () {
	    if (this.operator === "typeof") return 7;
	    if (this.operator === "void") return 5;
	    return this.operator.length;
	};

	AST_Binary.prototype._size = function (info) {
	    if (this.operator === "in") return 4;

	    let size = this.operator.length;

	    if (
	        (this.operator === "+" || this.operator === "-")
	        && this.right instanceof AST_Unary && this.right.operator === this.operator
	    ) {
	        // 1+ +a > needs space between the +
	        size += 1;
	    }

	    if (this.needs_parens(info)) {
	        size += 2;
	    }

	    return size;
	};

	AST_Conditional.prototype._size = () => 3;

	AST_Array.prototype._size = function () {
	    return 2 + list_overhead(this.elements);
	};

	AST_Object.prototype._size = function (info) {
	    let base = 2;
	    if (first_in_statement(info)) {
	        base += 2; // parens
	    }
	    return base + list_overhead(this.properties);
	};

	/*#__INLINE__*/
	const key_size = key =>
	    typeof key === "string" ? key.length : 0;

	AST_ObjectKeyVal.prototype._size = function () {
	    return key_size(this.key) + 1;
	};

	/*#__INLINE__*/
	const static_size = is_static => is_static ? 7 : 0;

	AST_ObjectGetter.prototype._size = function () {
	    return 5 + static_size(this.static) + key_size(this.key);
	};

	AST_ObjectSetter.prototype._size = function () {
	    return 5 + static_size(this.static) + key_size(this.key);
	};

	AST_ConciseMethod.prototype._size = function () {
	    return static_size(this.static) + key_size(this.key) + lambda_modifiers(this);
	};

	AST_PrivateMethod.prototype._size = function () {
	    return AST_ConciseMethod.prototype._size.call(this) + 1;
	};

	AST_PrivateGetter.prototype._size = AST_PrivateSetter.prototype._size = function () {
	    return AST_ConciseMethod.prototype._size.call(this) + 4;
	};

	AST_PrivateIn.prototype._size = function () {
	    return 5; // "#", and " in "
	};

	AST_Class.prototype._size = function () {
	    return (
	        (this.name ? 8 : 7)
	        + (this.extends ? 8 : 0)
	    );
	};

	AST_ClassStaticBlock.prototype._size = function () {
	    // "static{}" + semicolons
	    return 8 + list_overhead(this.body);
	};

	AST_ClassProperty.prototype._size = function () {
	    return (
	        static_size(this.static)
	        + (typeof this.key === "string" ? this.key.length + 2 : 0)
	        + (this.value ? 1 : 0)
	    );
	};

	AST_ClassPrivateProperty.prototype._size = function () {
	    return AST_ClassProperty.prototype._size.call(this) + 1;
	};

	AST_Symbol.prototype._size = function () {
	    if (!(mangle_options && this.thedef && !this.thedef.unmangleable(mangle_options))) {
	        return this.name.length;
	    } else {
	        return 1;
	    }
	};

	// TODO take propmangle into account
	AST_SymbolClassProperty.prototype._size = function () {
	    return this.name.length;
	};

	AST_SymbolRef.prototype._size = AST_SymbolDeclaration.prototype._size = function () {
	    if (this.name === "arguments") return 9;

	    return AST_Symbol.prototype._size.call(this);
	};

	AST_NewTarget.prototype._size = () => 10;

	AST_SymbolImportForeign.prototype._size = function () {
	    return this.name.length;
	};

	AST_SymbolExportForeign.prototype._size = function () {
	    return this.name.length;
	};

	AST_This.prototype._size = () => 4;

	AST_Super.prototype._size = () => 5;

	AST_String.prototype._size = function () {
	    return this.value.length + 2;
	};

	AST_Number.prototype._size = function () {
	    const { value } = this;
	    if (value === 0) return 1;
	    if (value > 0 && Math.floor(value) === value) {
	        return Math.floor(Math.log10(value) + 1);
	    }
	    return value.toString().length;
	};

	AST_BigInt.prototype._size = function () {
	    return this.value.length;
	};

	AST_RegExp.prototype._size = function () {
	    return this.value.toString().length;
	};

	AST_Null.prototype._size = () => 4;

	AST_NaN.prototype._size = () => 3;

	AST_Undefined.prototype._size = () => 6; // "void 0"

	AST_Hole.prototype._size = () => 0;  // comma is taken into account by list_overhead()

	AST_Infinity.prototype._size = () => 8;

	AST_True.prototype._size = () => 4;

	AST_False.prototype._size = () => 5;

	AST_Await.prototype._size = () => 6;

	AST_Yield.prototype._size = () => 6;

	/***********************************************************************

	  A JavaScript tokenizer / parser / beautifier / compressor.
	  https://github.com/mishoo/UglifyJS2

	  -------------------------------- (C) ---------------------------------

	                           Author: Mihai Bazon
	                         <mihai.bazon@gmail.com>
	                       http://mihai.bazon.net/blog

	  Distributed under the BSD license:

	    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

	    Redistribution and use in source and binary forms, with or without
	    modification, are permitted provided that the following conditions
	    are met:

	        * Redistributions of source code must retain the above
	          copyright notice, this list of conditions and the following
	          disclaimer.

	        * Redistributions in binary form must reproduce the above
	          copyright notice, this list of conditions and the following
	          disclaimer in the documentation and/or other materials
	          provided with the distribution.

	    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
	    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
	    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
	    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
	    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
	    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
	    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
	    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
	    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
	    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
	    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
	    SUCH DAMAGE.

	 ***********************************************************************/

	// bitfield flags to be stored in node.flags.
	// These are set and unset during compression, and store information in the node without requiring multiple fields.
	const UNUSED = 0b00000001;
	const TRUTHY = 0b00000010;
	const FALSY = 0b00000100;
	const UNDEFINED = 0b00001000;
	const INLINED = 0b00010000;

	// Nodes to which values are ever written. Used when keep_assign is part of the unused option string.
	const WRITE_ONLY = 0b00100000;

	// information specific to a single compression pass
	const SQUEEZED = 0b0000000100000000;
	const OPTIMIZED = 0b0000001000000000;
	const TOP = 0b0000010000000000;
	const CLEAR_BETWEEN_PASSES = SQUEEZED | OPTIMIZED | TOP;

	const has_flag = (node, flag) => node.flags & flag;
	const set_flag = (node, flag) => { node.flags |= flag; };
	const clear_flag = (node, flag) => { node.flags &= ~flag; };

	/***********************************************************************

	  A JavaScript tokenizer / parser / beautifier / compressor.
	  https://github.com/mishoo/UglifyJS2

	  -------------------------------- (C) ---------------------------------

	                           Author: Mihai Bazon
	                         <mihai.bazon@gmail.com>
	                       http://mihai.bazon.net/blog

	  Distributed under the BSD license:

	    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

	    Redistribution and use in source and binary forms, with or without
	    modification, are permitted provided that the following conditions
	    are met:

	        * Redistributions of source code must retain the above
	          copyright notice, this list of conditions and the following
	          disclaimer.

	        * Redistributions in binary form must reproduce the above
	          copyright notice, this list of conditions and the following
	          disclaimer in the documentation and/or other materials
	          provided with the distribution.

	    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
	    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
	    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
	    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
	    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
	    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
	    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
	    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
	    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
	    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
	    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
	    SUCH DAMAGE.

	 ***********************************************************************/

	function merge_sequence(array, node) {
	    if (node instanceof AST_Sequence) {
	        array.push(...node.expressions);
	    } else {
	        array.push(node);
	    }
	    return array;
	}

	function make_sequence(orig, expressions) {
	    if (expressions.length == 1) return expressions[0];
	    if (expressions.length == 0) throw new Error("trying to create a sequence with length zero!");
	    return make_node(AST_Sequence, orig, {
	        expressions: expressions.reduce(merge_sequence, [])
	    });
	}

	function make_node_from_constant(val, orig) {
	    switch (typeof val) {
	      case "string":
	        return make_node(AST_String, orig, {
	            value: val
	        });
	      case "number":
	        if (isNaN(val)) return make_node(AST_NaN, orig);
	        if (isFinite(val)) {
	            return 1 / val < 0 ? make_node(AST_UnaryPrefix, orig, {
	                operator: "-",
	                expression: make_node(AST_Number, orig, { value: -val })
	            }) : make_node(AST_Number, orig, { value: val });
	        }
	        return val < 0 ? make_node(AST_UnaryPrefix, orig, {
	            operator: "-",
	            expression: make_node(AST_Infinity, orig)
	        }) : make_node(AST_Infinity, orig);
	      case "bigint":
	        return make_node(AST_BigInt, orig, { value: val.toString() });
	      case "boolean":
	        return make_node(val ? AST_True : AST_False, orig);
	      case "undefined":
	        return make_node(AST_Undefined, orig);
	      default:
	        if (val === null) {
	            return make_node(AST_Null, orig, { value: null });
	        }
	        if (val instanceof RegExp) {
	            return make_node(AST_RegExp, orig, {
	                value: {
	                    source: regexp_source_fix(val.source),
	                    flags: val.flags
	                }
	            });
	        }
	        throw new Error(string_template("Can't handle constant of type: {type}", {
	            type: typeof val
	        }));
	    }
	}

	function best_of_expression(ast1, ast2) {
	    return ast1.size() > ast2.size() ? ast2 : ast1;
	}

	function best_of_statement(ast1, ast2) {
	    return best_of_expression(
	        make_node(AST_SimpleStatement, ast1, {
	            body: ast1
	        }),
	        make_node(AST_SimpleStatement, ast2, {
	            body: ast2
	        })
	    ).body;
	}

	/** Find which node is smaller, and return that */
	function best_of(compressor, ast1, ast2) {
	    if (first_in_statement(compressor)) {
	        return best_of_statement(ast1, ast2);
	    } else {
	        return best_of_expression(ast1, ast2);
	    }
	}

	/** Simplify an object property's key, if possible */
	function get_simple_key(key) {
	    if (key instanceof AST_Constant) {
	        return key.getValue();
	    }
	    if (key instanceof AST_UnaryPrefix
	        && key.operator == "void"
	        && key.expression instanceof AST_Constant) {
	        return;
	    }
	    return key;
	}

	function read_property(obj, key) {
	    key = get_simple_key(key);
	    if (key instanceof AST_Node) return;

	    var value;
	    if (obj instanceof AST_Array) {
	        var elements = obj.elements;
	        if (key == "length") return make_node_from_constant(elements.length, obj);
	        if (typeof key == "number" && key in elements) value = elements[key];
	    } else if (obj instanceof AST_Object) {
	        key = "" + key;
	        var props = obj.properties;
	        for (var i = props.length; --i >= 0;) {
	            var prop = props[i];
	            if (!(prop instanceof AST_ObjectKeyVal)) return;
	            if (!value && props[i].key === key) value = props[i].value;
	        }
	    }

	    return value instanceof AST_SymbolRef && value.fixed_value() || value;
	}

	function has_break_or_continue(loop, parent) {
	    var found = false;
	    var tw = new TreeWalker(function(node) {
	        if (found || node instanceof AST_Scope) return true;
	        if (node instanceof AST_LoopControl && tw.loopcontrol_target(node) === loop) {
	            return found = true;
	        }
	    });
	    if (parent instanceof AST_LabeledStatement) tw.push(parent);
	    tw.push(loop);
	    loop.body.walk(tw);
	    return found;
	}

	// we shouldn't compress (1,func)(something) to
	// func(something) because that changes the meaning of
	// the func (becomes lexical instead of global).
	function maintain_this_binding(parent, orig, val) {
	    if (
	        parent instanceof AST_UnaryPrefix && parent.operator == "delete"
	        || parent instanceof AST_Call && parent.expression === orig
	            && (
	                val instanceof AST_Chain
	                || val instanceof AST_PropAccess
	                || val instanceof AST_SymbolRef && val.name == "eval"
	            )
	    ) {
	        const zero = make_node(AST_Number, orig, { value: 0 });
	        return make_sequence(orig, [ zero, val ]);
	    } else {
	        return val;
	    }
	}

	function is_func_expr(node) {
	    return node instanceof AST_Arrow || node instanceof AST_Function;
	}

	/**
	 * Used to determine whether the node can benefit from negation.
	 * Not the case with arrow functions (you need an extra set of parens). */
	function is_iife_call(node) {
	    if (node.TYPE != "Call") return false;
	    return node.expression instanceof AST_Function || is_iife_call(node.expression);
	}

	function is_empty(thing) {
	    if (thing === null) return true;
	    if (thing instanceof AST_EmptyStatement) return true;
	    if (thing instanceof AST_BlockStatement) return thing.body.length == 0;
	    return false;
	}

	const identifier_atom = makePredicate("Infinity NaN undefined");
	function is_identifier_atom(node) {
	    return node instanceof AST_Infinity
	        || node instanceof AST_NaN
	        || node instanceof AST_Undefined;
	}

	/** Check if this is a SymbolRef node which has one def of a certain AST type */
	function is_ref_of(ref, type) {
	    if (!(ref instanceof AST_SymbolRef)) return false;
	    var orig = ref.definition().orig;
	    for (var i = orig.length; --i >= 0;) {
	        if (orig[i] instanceof type) return true;
	    }
	}

	/**Can we turn { block contents... } into just the block contents ?
	 * Not if one of these is inside.
	 **/
	function can_be_evicted_from_block(node) {
	    return !(
	        node instanceof AST_DefClass ||
	        node instanceof AST_Defun ||
	        node instanceof AST_Let ||
	        node instanceof AST_Const ||
	        node instanceof AST_Export ||
	        node instanceof AST_Import
	    );
	}

	function as_statement_array(thing) {
	    if (thing === null) return [];
	    if (thing instanceof AST_BlockStatement) return thing.body;
	    if (thing instanceof AST_EmptyStatement) return [];
	    if (thing instanceof AST_Statement) return [ thing ];
	    throw new Error("Can't convert thing to statement array");
	}

	function is_reachable(scope_node, defs) {
	    const find_ref = node => {
	        if (node instanceof AST_SymbolRef && defs.includes(node.definition())) {
	            return walk_abort;
	        }
	    };

	    return walk_parent(scope_node, (node, info) => {
	        if (node instanceof AST_Scope && node !== scope_node) {
	            var parent = info.parent();

	            if (
	                parent instanceof AST_Call
	                && parent.expression === node
	                // Async/Generators aren't guaranteed to sync evaluate all of
	                // their body steps, so it's possible they close over the variable.
	                && !(node.async || node.is_generator)
	            ) {
	                return;
	            }

	            if (walk(node, find_ref)) return walk_abort;

	            return true;
	        }
	    });
	}

	/** Check if a ref refers to the name of a function/class it's defined within */
	function is_recursive_ref(compressor, def) {
	    var node;
	    for (var i = 0; node = compressor.parent(i); i++) {
	        if (node instanceof AST_Lambda || node instanceof AST_Class) {
	            var name = node.name;
	            if (name && name.definition() === def) {
	                return true;
	            }
	        }
	    }
	    return false;
	}

	// TODO this only works with AST_Defun, shouldn't it work for other ways of defining functions?
	function retain_top_func(fn, compressor) {
	    return compressor.top_retain
	        && fn instanceof AST_Defun
	        && has_flag(fn, TOP)
	        && fn.name
	        && compressor.top_retain(fn.name.definition());
	}

	/***********************************************************************

	  A JavaScript tokenizer / parser / beautifier / compressor.
	  https://github.com/mishoo/UglifyJS2

	  -------------------------------- (C) ---------------------------------

	                           Author: Mihai Bazon
	                         <mihai.bazon@gmail.com>
	                       http://mihai.bazon.net/blog

	  Distributed under the BSD license:

	    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

	    Redistribution and use in source and binary forms, with or without
	    modification, are permitted provided that the following conditions
	    are met:

	        * Redistributions of source code must retain the above
	          copyright notice, this list of conditions and the following
	          disclaimer.

	        * Redistributions in binary form must reproduce the above
	          copyright notice, this list of conditions and the following
	          disclaimer in the documentation and/or other materials
	          provided with the distribution.

	    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
	    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
	    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
	    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
	    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
	    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
	    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
	    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
	    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
	    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
	    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
	    SUCH DAMAGE.

	 ***********************************************************************/

	// Lists of native methods, useful for `unsafe` option which assumes they exist.
	// Note: Lots of methods and functions are missing here, in case they aren't pure
	// or not available in all JS environments.

	function make_nested_lookup(obj) {
	    const out = new Map();
	    for (var key of Object.keys(obj)) {
	        out.set(key, makePredicate(obj[key]));
	    }

	    const does_have = (global_name, fname) => {
	        const inner_map = out.get(global_name);
	        return inner_map != null && inner_map.has(fname);
	    };
	    return does_have;
	}

	// Objects which are safe to access without throwing or causing a side effect.
	// Usually we'd check the `unsafe` option first but these are way too common for that
	const pure_prop_access_globals = new Set([
	    "Number",
	    "String",
	    "Array",
	    "Object",
	    "Function",
	    "Promise",
	]);

	const object_methods = [
	    "constructor",
	    "toString",
	    "valueOf",
	];

	const is_pure_native_method = make_nested_lookup({
	    Array: [
	        "at",
	        "flat",
	        "includes",
	        "indexOf",
	        "join",
	        "lastIndexOf",
	        "slice",
	        ...object_methods,
	    ],
	    Boolean: object_methods,
	    Function: object_methods,
	    Number: [
	        "toExponential",
	        "toFixed",
	        "toPrecision",
	        ...object_methods,
	    ],
	    Object: object_methods,
	    RegExp: [
	        "test",
	        ...object_methods,
	    ],
	    String: [
	        "at",
	        "charAt",
	        "charCodeAt",
	        "charPointAt",
	        "concat",
	        "endsWith",
	        "fromCharCode",
	        "fromCodePoint",
	        "includes",
	        "indexOf",
	        "italics",
	        "lastIndexOf",
	        "localeCompare",
	        "match",
	        "matchAll",
	        "normalize",
	        "padStart",
	        "padEnd",
	        "repeat",
	        "replace",
	        "replaceAll",
	        "search",
	        "slice",
	        "split",
	        "startsWith",
	        "substr",
	        "substring",
	        "repeat",
	        "toLocaleLowerCase",
	        "toLocaleUpperCase",
	        "toLowerCase",
	        "toUpperCase",
	        "trim",
	        "trimEnd",
	        "trimStart",
	        ...object_methods,
	    ],
	});

	const is_pure_native_fn = make_nested_lookup({
	    Array: [
	        "isArray",
	    ],
	    Math: [
	        "abs",
	        "acos",
	        "asin",
	        "atan",
	        "ceil",
	        "cos",
	        "exp",
	        "floor",
	        "log",
	        "round",
	        "sin",
	        "sqrt",
	        "tan",
	        "atan2",
	        "pow",
	        "max",
	        "min",
	    ],
	    Number: [
	        "isFinite",
	        "isNaN",
	    ],
	    Object: [
	        "create",
	        "getOwnPropertyDescriptor",
	        "getOwnPropertyNames",
	        "getPrototypeOf",
	        "isExtensible",
	        "isFrozen",
	        "isSealed",
	        "hasOwn",
	        "keys",
	    ],
	    String: [
	        "fromCharCode",
	    ],
	});

	// Known numeric values which come with JS environments
	const is_pure_native_value = make_nested_lookup({
	    Math: [
	        "E",
	        "LN10",
	        "LN2",
	        "LOG2E",
	        "LOG10E",
	        "PI",
	        "SQRT1_2",
	        "SQRT2",
	    ],
	    Number: [
	        "MAX_VALUE",
	        "MIN_VALUE",
	        "NaN",
	        "NEGATIVE_INFINITY",
	        "POSITIVE_INFINITY",
	    ],
	});

	/***********************************************************************

	  A JavaScript tokenizer / parser / beautifier / compressor.
	  https://github.com/mishoo/UglifyJS2

	  -------------------------------- (C) ---------------------------------

	                           Author: Mihai Bazon
	                         <mihai.bazon@gmail.com>
	                       http://mihai.bazon.net/blog

	  Distributed under the BSD license:

	    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

	    Redistribution and use in source and binary forms, with or without
	    modification, are permitted provided that the following conditions
	    are met:

	        * Redistributions of source code must retain the above
	          copyright notice, this list of conditions and the following
	          disclaimer.

	        * Redistributions in binary form must reproduce the above
	          copyright notice, this list of conditions and the following
	          disclaimer in the documentation and/or other materials
	          provided with the distribution.

	    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
	    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
	    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
	    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
	    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
	    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
	    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
	    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
	    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
	    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
	    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
	    SUCH DAMAGE.

	 ***********************************************************************/

	// Functions and methods to infer certain facts about expressions
	// It's not always possible to be 100% sure about something just by static analysis,
	// so `true` means yes, and `false` means maybe

	const is_undeclared_ref = (node) =>
	    node instanceof AST_SymbolRef && node.definition().undeclared;

	const bitwise_binop = makePredicate("<<< >> << & | ^ ~");
	const lazy_op = makePredicate("&& || ??");
	const unary_side_effects = makePredicate("delete ++ --");

	// methods to determine whether an expression has a boolean result type
	(function(def_is_boolean) {
	    const unary_bool = makePredicate("! delete");
	    const binary_bool = makePredicate("in instanceof == != === !== < <= >= >");
	    def_is_boolean(AST_Node, return_false);
	    def_is_boolean(AST_UnaryPrefix, function() {
	        return unary_bool.has(this.operator);
	    });
	    def_is_boolean(AST_Binary, function() {
	        return binary_bool.has(this.operator)
	            || lazy_op.has(this.operator)
	                && this.left.is_boolean()
	                && this.right.is_boolean();
	    });
	    def_is_boolean(AST_Conditional, function() {
	        return this.consequent.is_boolean() && this.alternative.is_boolean();
	    });
	    def_is_boolean(AST_Assign, function() {
	        return this.operator == "=" && this.right.is_boolean();
	    });
	    def_is_boolean(AST_Sequence, function() {
	        return this.tail_node().is_boolean();
	    });
	    def_is_boolean(AST_True, return_true);
	    def_is_boolean(AST_False, return_true);
	})(function(node, func) {
	    node.DEFMETHOD("is_boolean", func);
	});

	// methods to determine if an expression has a numeric result type
	(function(def_is_number) {
	    def_is_number(AST_Node, return_false);
	    def_is_number(AST_Number, return_true);
	    const unary = makePredicate("+ - ~ ++ --");
	    def_is_number(AST_Unary, function() {
	        return unary.has(this.operator) && !(this.expression instanceof AST_BigInt);
	    });
	    const numeric_ops = makePredicate("- * / % & | ^ << >> >>>");
	    def_is_number(AST_Binary, function(compressor) {
	        return numeric_ops.has(this.operator) || this.operator == "+"
	            && this.left.is_number(compressor)
	            && this.right.is_number(compressor);
	    });
	    def_is_number(AST_Assign, function(compressor) {
	        return numeric_ops.has(this.operator.slice(0, -1))
	            || this.operator == "=" && this.right.is_number(compressor);
	    });
	    def_is_number(AST_Sequence, function(compressor) {
	        return this.tail_node().is_number(compressor);
	    });
	    def_is_number(AST_Conditional, function(compressor) {
	        return this.consequent.is_number(compressor) && this.alternative.is_number(compressor);
	    });
	})(function(node, func) {
	    node.DEFMETHOD("is_number", func);
	});

	// methods to determine if an expression is a 32 bit integer (IE results from bitwise ops, or is an integer constant fitting in that size
	(function(def_is_32_bit_integer) {
	    def_is_32_bit_integer(AST_Node, return_false);
	    def_is_32_bit_integer(AST_Number, function() {
	        return this.value === (this.value | 0);
	    });
	    def_is_32_bit_integer(AST_UnaryPrefix, function() {
	        return this.operator == "~" ? this.expression.is_number()
	            : this.operator === "+" ? this.expression.is_32_bit_integer()
	            : false;
	    });
	    def_is_32_bit_integer(AST_Binary, function() {
	        return bitwise_binop.has(this.operator);
	    });
	}(function (node, func) {
	    node.DEFMETHOD("is_32_bit_integer", func);
	}));

	// methods to determine if an expression has a string result type
	(function(def_is_string) {
	    def_is_string(AST_Node, return_false);
	    def_is_string(AST_String, return_true);
	    def_is_string(AST_TemplateString, return_true);
	    def_is_string(AST_UnaryPrefix, function() {
	        return this.operator == "typeof";
	    });
	    def_is_string(AST_Binary, function(compressor) {
	        return this.operator == "+" &&
	            (this.left.is_string(compressor) || this.right.is_string(compressor));
	    });
	    def_is_string(AST_Assign, function(compressor) {
	        return (this.operator == "=" || this.operator == "+=") && this.right.is_string(compressor);
	    });
	    def_is_string(AST_Sequence, function(compressor) {
	        return this.tail_node().is_string(compressor);
	    });
	    def_is_string(AST_Conditional, function(compressor) {
	        return this.consequent.is_string(compressor) && this.alternative.is_string(compressor);
	    });
	})(function(node, func) {
	    node.DEFMETHOD("is_string", func);
	});

	function is_undefined(node, compressor) {
	    return (
	        has_flag(node, UNDEFINED)
	        || node instanceof AST_Undefined
	        || node instanceof AST_UnaryPrefix
	            && node.operator == "void"
	            && !node.expression.has_side_effects(compressor)
	    );
	}

	// Is the node explicitly null or undefined.
	function is_null_or_undefined(node, compressor) {
	    let fixed;
	    return (
	        node instanceof AST_Null
	        || is_undefined(node, compressor)
	        || (
	            node instanceof AST_SymbolRef
	            && (fixed = node.definition().fixed) instanceof AST_Node
	            && is_nullish(fixed, compressor)
	        )
	    );
	}

	// Find out if this expression is optionally chained from a base-point that we
	// can statically analyze as null or undefined.
	function is_nullish_shortcircuited(node, compressor) {
	    if (node instanceof AST_PropAccess || node instanceof AST_Call) {
	        return (
	            (node.optional && is_null_or_undefined(node.expression, compressor))
	            || is_nullish_shortcircuited(node.expression, compressor)
	        );
	    }
	    if (node instanceof AST_Chain) return is_nullish_shortcircuited(node.expression, compressor);
	    return false;
	}

	// Find out if something is == null, or can short circuit into nullish.
	// Used to optimize ?. and ??
	function is_nullish(node, compressor) {
	    if (is_null_or_undefined(node, compressor)) return true;
	    return is_nullish_shortcircuited(node, compressor);
	}

	// Determine if expression might cause side effects
	// If there's a possibility that a node may change something when it's executed, this returns true
	(function(def_has_side_effects) {
	    def_has_side_effects(AST_Node, return_true);

	    def_has_side_effects(AST_EmptyStatement, return_false);
	    def_has_side_effects(AST_Constant, return_false);
	    def_has_side_effects(AST_This, return_false);

	    function any(list, compressor) {
	        for (var i = list.length; --i >= 0;)
	            if (list[i].has_side_effects(compressor))
	                return true;
	        return false;
	    }

	    def_has_side_effects(AST_Block, function(compressor) {
	        return any(this.body, compressor);
	    });
	    def_has_side_effects(AST_Call, function(compressor) {
	        if (
	            !this.is_callee_pure(compressor)
	            && (!this.expression.is_call_pure(compressor)
	                || this.expression.has_side_effects(compressor))
	        ) {
	            return true;
	        }
	        return any(this.args, compressor);
	    });
	    def_has_side_effects(AST_Switch, function(compressor) {
	        return this.expression.has_side_effects(compressor)
	            || any(this.body, compressor);
	    });
	    def_has_side_effects(AST_Case, function(compressor) {
	        return this.expression.has_side_effects(compressor)
	            || any(this.body, compressor);
	    });
	    def_has_side_effects(AST_Try, function(compressor) {
	        return this.body.has_side_effects(compressor)
	            || this.bcatch && this.bcatch.has_side_effects(compressor)
	            || this.bfinally && this.bfinally.has_side_effects(compressor);
	    });
	    def_has_side_effects(AST_If, function(compressor) {
	        return this.condition.has_side_effects(compressor)
	            || this.body && this.body.has_side_effects(compressor)
	            || this.alternative && this.alternative.has_side_effects(compressor);
	    });
	    def_has_side_effects(AST_ImportMeta, return_false);
	    def_has_side_effects(AST_LabeledStatement, function(compressor) {
	        return this.body.has_side_effects(compressor);
	    });
	    def_has_side_effects(AST_SimpleStatement, function(compressor) {
	        return this.body.has_side_effects(compressor);
	    });
	    def_has_side_effects(AST_Lambda, return_false);
	    def_has_side_effects(AST_Class, function (compressor) {
	        if (this.extends && this.extends.has_side_effects(compressor)) {
	            return true;
	        }
	        return any(this.properties, compressor);
	    });
	    def_has_side_effects(AST_ClassStaticBlock, function(compressor) {
	        return any(this.body, compressor);
	    });
	    def_has_side_effects(AST_Binary, function(compressor) {
	        return this.left.has_side_effects(compressor)
	            || this.right.has_side_effects(compressor);
	    });
	    def_has_side_effects(AST_Assign, return_true);
	    def_has_side_effects(AST_Conditional, function(compressor) {
	        return this.condition.has_side_effects(compressor)
	            || this.consequent.has_side_effects(compressor)
	            || this.alternative.has_side_effects(compressor);
	    });
	    def_has_side_effects(AST_Unary, function(compressor) {
	        return unary_side_effects.has(this.operator)
	            || this.expression.has_side_effects(compressor);
	    });
	    def_has_side_effects(AST_SymbolRef, function(compressor) {
	        return !this.is_declared(compressor) && !pure_prop_access_globals.has(this.name);
	    });
	    def_has_side_effects(AST_SymbolClassProperty, return_false);
	    def_has_side_effects(AST_SymbolDeclaration, return_false);
	    def_has_side_effects(AST_Object, function(compressor) {
	        return any(this.properties, compressor);
	    });
	    def_has_side_effects(AST_ObjectProperty, function(compressor) {
	        return (
	            this.computed_key() && this.key.has_side_effects(compressor)
	            || this.value && this.value.has_side_effects(compressor)
	        );
	    });
	    def_has_side_effects(AST_ClassProperty, function(compressor) {
	        return (
	            this.computed_key() && this.key.has_side_effects(compressor)
	            || this.static && this.value && this.value.has_side_effects(compressor)
	        );
	    });
	    def_has_side_effects(AST_ConciseMethod, function(compressor) {
	        return this.computed_key() && this.key.has_side_effects(compressor);
	    });
	    def_has_side_effects(AST_ObjectGetter, function(compressor) {
	        return this.computed_key() && this.key.has_side_effects(compressor);
	    });
	    def_has_side_effects(AST_ObjectSetter, function(compressor) {
	        return this.computed_key() && this.key.has_side_effects(compressor);
	    });
	    def_has_side_effects(AST_Array, function(compressor) {
	        return any(this.elements, compressor);
	    });
	    def_has_side_effects(AST_Dot, function(compressor) {
	        if (is_nullish(this, compressor)) {
	            return this.expression.has_side_effects(compressor);
	        }
	        if (!this.optional && this.expression.may_throw_on_access(compressor)) {
	            return true;
	        }

	        return this.expression.has_side_effects(compressor);
	    });
	    def_has_side_effects(AST_Sub, function(compressor) {
	        if (is_nullish(this, compressor)) {
	            return this.expression.has_side_effects(compressor);
	        }
	        if (!this.optional && this.expression.may_throw_on_access(compressor)) {
	            return true;
	        }

	        var property = this.property.has_side_effects(compressor);
	        if (property && this.optional) return true; // "?." is a condition

	        return property || this.expression.has_side_effects(compressor);
	    });
	    def_has_side_effects(AST_Chain, function (compressor) {
	        return this.expression.has_side_effects(compressor);
	    });
	    def_has_side_effects(AST_Sequence, function(compressor) {
	        return any(this.expressions, compressor);
	    });
	    def_has_side_effects(AST_Definitions, function(compressor) {
	        return any(this.definitions, compressor);
	    });
	    def_has_side_effects(AST_VarDef, function() {
	        return this.value;
	    });
	    def_has_side_effects(AST_TemplateSegment, return_false);
	    def_has_side_effects(AST_TemplateString, function(compressor) {
	        return any(this.segments, compressor);
	    });
	})(function(node, func) {
	    node.DEFMETHOD("has_side_effects", func);
	});

	// determine if expression may throw
	(function(def_may_throw) {
	    def_may_throw(AST_Node, return_true);

	    def_may_throw(AST_Constant, return_false);
	    def_may_throw(AST_EmptyStatement, return_false);
	    def_may_throw(AST_Lambda, return_false);
	    def_may_throw(AST_SymbolDeclaration, return_false);
	    def_may_throw(AST_This, return_false);
	    def_may_throw(AST_ImportMeta, return_false);

	    function any(list, compressor) {
	        for (var i = list.length; --i >= 0;)
	            if (list[i].may_throw(compressor))
	                return true;
	        return false;
	    }

	    def_may_throw(AST_Class, function(compressor) {
	        if (this.extends && this.extends.may_throw(compressor)) return true;
	        return any(this.properties, compressor);
	    });
	    def_may_throw(AST_ClassStaticBlock, function (compressor) {
	        return any(this.body, compressor);
	    });

	    def_may_throw(AST_Array, function(compressor) {
	        return any(this.elements, compressor);
	    });
	    def_may_throw(AST_Assign, function(compressor) {
	        if (this.right.may_throw(compressor)) return true;
	        if (!compressor.has_directive("use strict")
	            && this.operator == "="
	            && this.left instanceof AST_SymbolRef) {
	            return false;
	        }
	        return this.left.may_throw(compressor);
	    });
	    def_may_throw(AST_Binary, function(compressor) {
	        return this.left.may_throw(compressor)
	            || this.right.may_throw(compressor);
	    });
	    def_may_throw(AST_Block, function(compressor) {
	        return any(this.body, compressor);
	    });
	    def_may_throw(AST_Call, function(compressor) {
	        if (is_nullish(this, compressor)) return false;
	        if (any(this.args, compressor)) return true;
	        if (this.is_callee_pure(compressor)) return false;
	        if (this.expression.may_throw(compressor)) return true;
	        return !(this.expression instanceof AST_Lambda)
	            || any(this.expression.body, compressor);
	    });
	    def_may_throw(AST_Case, function(compressor) {
	        return this.expression.may_throw(compressor)
	            || any(this.body, compressor);
	    });
	    def_may_throw(AST_Conditional, function(compressor) {
	        return this.condition.may_throw(compressor)
	            || this.consequent.may_throw(compressor)
	            || this.alternative.may_throw(compressor);
	    });
	    def_may_throw(AST_Definitions, function(compressor) {
	        return any(this.definitions, compressor);
	    });
	    def_may_throw(AST_If, function(compressor) {
	        return this.condition.may_throw(compressor)
	            || this.body && this.body.may_throw(compressor)
	            || this.alternative && this.alternative.may_throw(compressor);
	    });
	    def_may_throw(AST_LabeledStatement, function(compressor) {
	        return this.body.may_throw(compressor);
	    });
	    def_may_throw(AST_Object, function(compressor) {
	        return any(this.properties, compressor);
	    });
	    def_may_throw(AST_ObjectProperty, function(compressor) {
	        // TODO key may throw too
	        return this.value ? this.value.may_throw(compressor) : false;
	    });
	    def_may_throw(AST_ClassProperty, function(compressor) {
	        return (
	            this.computed_key() && this.key.may_throw(compressor)
	            || this.static && this.value && this.value.may_throw(compressor)
	        );
	    });
	    def_may_throw(AST_ConciseMethod, function(compressor) {
	        return this.computed_key() && this.key.may_throw(compressor);
	    });
	    def_may_throw(AST_ObjectGetter, function(compressor) {
	        return this.computed_key() && this.key.may_throw(compressor);
	    });
	    def_may_throw(AST_ObjectSetter, function(compressor) {
	        return this.computed_key() && this.key.may_throw(compressor);
	    });
	    def_may_throw(AST_Return, function(compressor) {
	        return this.value && this.value.may_throw(compressor);
	    });
	    def_may_throw(AST_Sequence, function(compressor) {
	        return any(this.expressions, compressor);
	    });
	    def_may_throw(AST_SimpleStatement, function(compressor) {
	        return this.body.may_throw(compressor);
	    });
	    def_may_throw(AST_Dot, function(compressor) {
	        if (is_nullish(this, compressor)) return false;
	        return !this.optional && this.expression.may_throw_on_access(compressor)
	            || this.expression.may_throw(compressor);
	    });
	    def_may_throw(AST_Sub, function(compressor) {
	        if (is_nullish(this, compressor)) return false;
	        return !this.optional && this.expression.may_throw_on_access(compressor)
	            || this.expression.may_throw(compressor)
	            || this.property.may_throw(compressor);
	    });
	    def_may_throw(AST_Chain, function(compressor) {
	        return this.expression.may_throw(compressor);
	    });
	    def_may_throw(AST_Switch, function(compressor) {
	        return this.expression.may_throw(compressor)
	            || any(this.body, compressor);
	    });
	    def_may_throw(AST_SymbolRef, function(compressor) {
	        return !this.is_declared(compressor) && !pure_prop_access_globals.has(this.name);
	    });
	    def_may_throw(AST_SymbolClassProperty, return_false);
	    def_may_throw(AST_Try, function(compressor) {
	        return this.bcatch ? this.bcatch.may_throw(compressor) : this.body.may_throw(compressor)
	            || this.bfinally && this.bfinally.may_throw(compressor);
	    });
	    def_may_throw(AST_Unary, function(compressor) {
	        if (this.operator == "typeof" && this.expression instanceof AST_SymbolRef)
	            return false;
	        return this.expression.may_throw(compressor);
	    });
	    def_may_throw(AST_VarDef, function(compressor) {
	        if (!this.value) return false;
	        return this.value.may_throw(compressor);
	    });
	})(function(node, func) {
	    node.DEFMETHOD("may_throw", func);
	});

	// determine if expression is constant
	(function(def_is_constant_expression) {
	    function all_refs_local(scope) {
	        let result = true;
	        walk(this, node => {
	            if (node instanceof AST_SymbolRef) {
	                if (has_flag(this, INLINED)) {
	                    result = false;
	                    return walk_abort;
	                }
	                var def = node.definition();
	                if (
	                    member(def, this.enclosed)
	                    && !this.variables.has(def.name)
	                ) {
	                    if (scope) {
	                        var scope_def = scope.find_variable(node);
	                        if (def.undeclared ? !scope_def : scope_def === def) {
	                            result = "f";
	                            return true;
	                        }
	                    }
	                    result = false;
	                    return walk_abort;
	                }
	                return true;
	            }
	            if (node instanceof AST_This && this instanceof AST_Arrow) {
	                result = false;
	                return walk_abort;
	            }
	        });
	        return result;
	    }

	    def_is_constant_expression(AST_Node, return_false);
	    def_is_constant_expression(AST_Constant, return_true);
	    def_is_constant_expression(AST_Class, function(scope) {
	        if (this.extends && !this.extends.is_constant_expression(scope)) {
	            return false;
	        }

	        for (const prop of this.properties) {
	            if (prop.computed_key() && !prop.key.is_constant_expression(scope)) {
	                return false;
	            }
	            if (prop.static && prop.value && !prop.value.is_constant_expression(scope)) {
	                return false;
	            }
	            if (prop instanceof AST_ClassStaticBlock) {
	                return false;
	            }
	        }

	        return all_refs_local.call(this, scope);
	    });
	    def_is_constant_expression(AST_Lambda, all_refs_local);
	    def_is_constant_expression(AST_Unary, function() {
	        return this.expression.is_constant_expression();
	    });
	    def_is_constant_expression(AST_Binary, function() {
	        return this.left.is_constant_expression()
	            && this.right.is_constant_expression();
	    });
	    def_is_constant_expression(AST_Array, function() {
	        return this.elements.every((l) => l.is_constant_expression());
	    });
	    def_is_constant_expression(AST_Object, function() {
	        return this.properties.every((l) => l.is_constant_expression());
	    });
	    def_is_constant_expression(AST_ObjectProperty, function() {
	        return !!(!(this.key instanceof AST_Node) && this.value && this.value.is_constant_expression());
	    });
	})(function(node, func) {
	    node.DEFMETHOD("is_constant_expression", func);
	});


	// may_throw_on_access()
	// returns true if this node may be null, undefined or contain `AST_Accessor`
	(function(def_may_throw_on_access) {
	    AST_Node.DEFMETHOD("may_throw_on_access", function(compressor) {
	        return !compressor.option("pure_getters")
	            || this._dot_throw(compressor);
	    });

	    function is_strict(compressor) {
	        return /strict/.test(compressor.option("pure_getters"));
	    }

	    def_may_throw_on_access(AST_Node, is_strict);
	    def_may_throw_on_access(AST_Null, return_true);
	    def_may_throw_on_access(AST_Undefined, return_true);
	    def_may_throw_on_access(AST_Constant, return_false);
	    def_may_throw_on_access(AST_Array, return_false);
	    def_may_throw_on_access(AST_Object, function(compressor) {
	        if (!is_strict(compressor)) return false;
	        for (var i = this.properties.length; --i >=0;)
	            if (this.properties[i]._dot_throw(compressor)) return true;
	        return false;
	    });
	    // Do not be as strict with classes as we are with objects.
	    // Hopefully the community is not going to abuse static getters and setters.
	    // https://github.com/terser/terser/issues/724#issuecomment-643655656
	    def_may_throw_on_access(AST_Class, return_false);
	    def_may_throw_on_access(AST_ObjectProperty, return_false);
	    def_may_throw_on_access(AST_ObjectGetter, return_true);
	    def_may_throw_on_access(AST_Expansion, function(compressor) {
	        return this.expression._dot_throw(compressor);
	    });
	    def_may_throw_on_access(AST_Function, return_false);
	    def_may_throw_on_access(AST_Arrow, return_false);
	    def_may_throw_on_access(AST_UnaryPostfix, return_false);
	    def_may_throw_on_access(AST_UnaryPrefix, function() {
	        return this.operator == "void";
	    });
	    def_may_throw_on_access(AST_Binary, function(compressor) {
	        return (this.operator == "&&" || this.operator == "||" || this.operator == "??")
	            && (this.left._dot_throw(compressor) || this.right._dot_throw(compressor));
	    });
	    def_may_throw_on_access(AST_Assign, function(compressor) {
	        if (this.logical) return true;

	        return this.operator == "="
	            && this.right._dot_throw(compressor);
	    });
	    def_may_throw_on_access(AST_Conditional, function(compressor) {
	        return this.consequent._dot_throw(compressor)
	            || this.alternative._dot_throw(compressor);
	    });
	    def_may_throw_on_access(AST_Dot, function(compressor) {
	        if (!is_strict(compressor)) return false;

	        if (this.property == "prototype") {
	            return !(
	                this.expression instanceof AST_Function
	                || this.expression instanceof AST_Class
	            );
	        }
	        return true;
	    });
	    def_may_throw_on_access(AST_Chain, function(compressor) {
	        return this.expression._dot_throw(compressor);
	    });
	    def_may_throw_on_access(AST_Sequence, function(compressor) {
	        return this.tail_node()._dot_throw(compressor);
	    });
	    def_may_throw_on_access(AST_SymbolRef, function(compressor) {
	        if (this.name === "arguments" && this.scope instanceof AST_Lambda) return false;
	        if (has_flag(this, UNDEFINED)) return true;
	        if (!is_strict(compressor)) return false;
	        if (is_undeclared_ref(this) && this.is_declared(compressor)) return false;
	        if (this.is_immutable()) return false;
	        var fixed = this.fixed_value();
	        return !fixed || fixed._dot_throw(compressor);
	    });
	})(function(node, func) {
	    node.DEFMETHOD("_dot_throw", func);
	});

	function is_lhs(node, parent) {
	    if (parent instanceof AST_Unary && unary_side_effects.has(parent.operator)) return parent.expression;
	    if (parent instanceof AST_Assign && parent.left === node) return node;
	    if (parent instanceof AST_ForIn && parent.init === node) return node;
	}

	// method to negate an expression
	(function(def_negate) {
	    function basic_negation(exp) {
	        return make_node(AST_UnaryPrefix, exp, {
	            operator: "!",
	            expression: exp
	        });
	    }
	    function best(orig, alt, first_in_statement) {
	        var negated = basic_negation(orig);
	        if (first_in_statement) {
	            var stat = make_node(AST_SimpleStatement, alt, {
	                body: alt
	            });
	            return best_of_expression(negated, stat) === stat ? alt : negated;
	        }
	        return best_of_expression(negated, alt);
	    }
	    def_negate(AST_Node, function() {
	        return basic_negation(this);
	    });
	    def_negate(AST_Statement, function() {
	        throw new Error("Cannot negate a statement");
	    });
	    def_negate(AST_Function, function() {
	        return basic_negation(this);
	    });
	    def_negate(AST_Class, function() {
	        return basic_negation(this);
	    });
	    def_negate(AST_Arrow, function() {
	        return basic_negation(this);
	    });
	    def_negate(AST_UnaryPrefix, function() {
	        if (this.operator == "!")
	            return this.expression;
	        return basic_negation(this);
	    });
	    def_negate(AST_Sequence, function(compressor) {
	        var expressions = this.expressions.slice();
	        expressions.push(expressions.pop().negate(compressor));
	        return make_sequence(this, expressions);
	    });
	    def_negate(AST_Conditional, function(compressor, first_in_statement) {
	        var self = this.clone();
	        self.consequent = self.consequent.negate(compressor);
	        self.alternative = self.alternative.negate(compressor);
	        return best(this, self, first_in_statement);
	    });
	    def_negate(AST_Binary, function(compressor, first_in_statement) {
	        var self = this.clone(), op = this.operator;
	        if (compressor.option("unsafe_comps")) {
	            switch (op) {
	              case "<=" : self.operator = ">"  ; return self;
	              case "<"  : self.operator = ">=" ; return self;
	              case ">=" : self.operator = "<"  ; return self;
	              case ">"  : self.operator = "<=" ; return self;
	            }
	        }
	        switch (op) {
	          case "==" : self.operator = "!="; return self;
	          case "!=" : self.operator = "=="; return self;
	          case "===": self.operator = "!=="; return self;
	          case "!==": self.operator = "==="; return self;
	          case "&&":
	            self.operator = "||";
	            self.left = self.left.negate(compressor, first_in_statement);
	            self.right = self.right.negate(compressor);
	            return best(this, self, first_in_statement);
	          case "||":
	            self.operator = "&&";
	            self.left = self.left.negate(compressor, first_in_statement);
	            self.right = self.right.negate(compressor);
	            return best(this, self, first_in_statement);
	        }
	        return basic_negation(this);
	    });
	})(function(node, func) {
	    node.DEFMETHOD("negate", function(compressor, first_in_statement) {
	        return func.call(this, compressor, first_in_statement);
	    });
	});

	(function (def_bitwise_negate) {
	    function basic_negation(exp) {
	        return make_node(AST_UnaryPrefix, exp, {
	            operator: "~",
	            expression: exp
	        });
	    }

	    def_bitwise_negate(AST_Node, function() {
	        return basic_negation(this);
	    });

	    def_bitwise_negate(AST_Number, function() {
	        const neg = ~this.value;
	        if (neg.toString().length > this.value.toString().length) {
	            return basic_negation(this);
	        }
	        return make_node(AST_Number, this, { value: neg });
	    });

	    def_bitwise_negate(AST_UnaryPrefix, function(in_32_bit_context) {
	        if (this.operator == "~" && (in_32_bit_context || this.expression.is_32_bit_integer())) {
	            return this.expression;
	        } else {
	            return basic_negation(this);
	        }
	    });
	})(function (node, func) {
	    node.DEFMETHOD("bitwise_negate", func);
	});

	// Is the callee of this function pure?
	var global_pure_fns = makePredicate("Boolean decodeURI decodeURIComponent Date encodeURI encodeURIComponent Error escape EvalError isFinite isNaN Number Object parseFloat parseInt RangeError ReferenceError String SyntaxError TypeError unescape URIError");
	AST_Call.DEFMETHOD("is_callee_pure", function(compressor) {
	    if (compressor.option("unsafe")) {
	        var expr = this.expression;
	        var first_arg = (this.args && this.args[0] && this.args[0].evaluate(compressor));
	        if (
	            expr.expression && expr.expression.name === "hasOwnProperty" &&
	            (first_arg == null || first_arg.thedef && first_arg.thedef.undeclared)
	        ) {
	            return false;
	        }
	        if (is_undeclared_ref(expr) && global_pure_fns.has(expr.name)) return true;
	        if (
	            expr instanceof AST_Dot
	            && is_undeclared_ref(expr.expression)
	            && is_pure_native_fn(expr.expression.name, expr.property)
	        ) {
	            return true;
	        }
	    }
	    if ((this instanceof AST_New) && compressor.option("pure_new")) {
	        return true;
	    }
	    if (compressor.option("side_effects") && has_annotation(this, _PURE)) {
	        return true;
	    }
	    return !compressor.pure_funcs(this);
	});

	// If I call this, is it a pure function?
	AST_Node.DEFMETHOD("is_call_pure", return_false);
	AST_Dot.DEFMETHOD("is_call_pure", function(compressor) {
	    if (!compressor.option("unsafe")) return;
	    const expr = this.expression;

	    let native_obj;
	    if (expr instanceof AST_Array) {
	        native_obj = "Array";
	    } else if (expr.is_boolean()) {
	        native_obj = "Boolean";
	    } else if (expr.is_number(compressor)) {
	        native_obj = "Number";
	    } else if (expr instanceof AST_RegExp) {
	        native_obj = "RegExp";
	    } else if (expr.is_string(compressor)) {
	        native_obj = "String";
	    } else if (!this.may_throw_on_access(compressor)) {
	        native_obj = "Object";
	    }
	    return native_obj != null && is_pure_native_method(native_obj, this.property);
	});

	// tell me if a statement aborts
	const aborts = (thing) => thing && thing.aborts();

	(function(def_aborts) {
	    def_aborts(AST_Statement, return_null);
	    def_aborts(AST_Jump, return_this);
	    function block_aborts() {
	        for (var i = 0; i < this.body.length; i++) {
	            if (aborts(this.body[i])) {
	                return this.body[i];
	            }
	        }
	        return null;
	    }
	    def_aborts(AST_Import, return_null);
	    def_aborts(AST_BlockStatement, block_aborts);
	    def_aborts(AST_SwitchBranch, block_aborts);
	    def_aborts(AST_DefClass, function () {
	        for (const prop of this.properties) {
	            if (prop instanceof AST_ClassStaticBlock) {
	                if (prop.aborts()) return prop;
	            }
	        }
	        return null;
	    });
	    def_aborts(AST_ClassStaticBlock, block_aborts);
	    def_aborts(AST_If, function() {
	        return this.alternative && aborts(this.body) && aborts(this.alternative) && this;
	    });
	})(function(node, func) {
	    node.DEFMETHOD("aborts", func);
	});

	AST_Node.DEFMETHOD("contains_this", function() {
	    return walk(this, node => {
	        if (node instanceof AST_This) return walk_abort;
	        if (
	            node !== this
	            && node instanceof AST_Scope
	            && !(node instanceof AST_Arrow)
	        ) {
	            return true;
	        }
	    });
	});

	function is_modified(compressor, tw, node, value, level, immutable) {
	    var parent = tw.parent(level);
	    var lhs = is_lhs(node, parent);
	    if (lhs) return lhs;
	    if (!immutable
	        && parent instanceof AST_Call
	        && parent.expression === node
	        && !(value instanceof AST_Arrow)
	        && !(value instanceof AST_Class)
	        && !parent.is_callee_pure(compressor)
	        && (!(value instanceof AST_Function)
	            || !(parent instanceof AST_New) && value.contains_this())) {
	        return true;
	    }
	    if (parent instanceof AST_Array) {
	        return is_modified(compressor, tw, parent, parent, level + 1);
	    }
	    if (parent instanceof AST_ObjectKeyVal && node === parent.value) {
	        var obj = tw.parent(level + 1);
	        return is_modified(compressor, tw, obj, obj, level + 2);
	    }
	    if (parent instanceof AST_PropAccess && parent.expression === node) {
	        var prop = read_property(value, parent.property);
	        return !immutable && is_modified(compressor, tw, parent, prop, level + 1);
	    }
	}

	/***********************************************************************

	  A JavaScript tokenizer / parser / beautifier / compressor.
	  https://github.com/mishoo/UglifyJS2

	  -------------------------------- (C) ---------------------------------

	                           Author: Mihai Bazon
	                         <mihai.bazon@gmail.com>
	                       http://mihai.bazon.net/blog

	  Distributed under the BSD license:

	    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

	    Redistribution and use in source and binary forms, with or without
	    modification, are permitted provided that the following conditions
	    are met:

	        * Redistributions of source code must retain the above
	          copyright notice, this list of conditions and the following
	          disclaimer.

	        * Redistributions in binary form must reproduce the above
	          copyright notice, this list of conditions and the following
	          disclaimer in the documentation and/or other materials
	          provided with the distribution.

	    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
	    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
	    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
	    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
	    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
	    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
	    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
	    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
	    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
	    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
	    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
	    SUCH DAMAGE.

	 ***********************************************************************/

	// methods to evaluate a constant expression

	function def_eval(node, func) {
	    node.DEFMETHOD("_eval", func);
	}

	// Used to propagate a nullish short-circuit signal upwards through the chain.
	const nullish = Symbol("This AST_Chain is nullish");

	// If the node has been successfully reduced to a constant,
	// then its value is returned; otherwise the element itself
	// is returned.
	// They can be distinguished as constant value is never a
	// descendant of AST_Node.
	AST_Node.DEFMETHOD("evaluate", function (compressor) {
	    if (!compressor.option("evaluate"))
	        return this;
	    var val = this._eval(compressor, 1);
	    if (!val || val instanceof RegExp)
	        return val;
	    if (typeof val == "function" || typeof val == "object" || val == nullish)
	        return this;

	    // Evaluated strings can be larger than the original expression
	    if (typeof val === "string") {
	        const unevaluated_size = this.size(compressor);
	        if (val.length + 2 > unevaluated_size) return this;
	    }

	    return val;
	});

	var unaryPrefix = makePredicate("! ~ - + void");
	AST_Node.DEFMETHOD("is_constant", function () {
	    // Accomodate when compress option evaluate=false
	    // as well as the common constant expressions !0 and -1
	    if (this instanceof AST_Constant) {
	        return !(this instanceof AST_RegExp);
	    } else {
	        return this instanceof AST_UnaryPrefix
	            && this.expression instanceof AST_Constant
	            && unaryPrefix.has(this.operator);
	    }
	});

	def_eval(AST_Statement, function () {
	    throw new Error(string_template("Cannot evaluate a statement [{file}:{line},{col}]", this.start));
	});

	def_eval(AST_Lambda, return_this);
	def_eval(AST_Class, return_this);
	def_eval(AST_Node, return_this);
	def_eval(AST_Constant, function () {
	    return this.getValue();
	});

	const supports_bigint = typeof BigInt === "function";
	def_eval(AST_BigInt, function () {
	    if (supports_bigint) {
	        return BigInt(this.value);
	    } else {
	        return this;
	    }
	});

	def_eval(AST_RegExp, function (compressor) {
	    let evaluated = compressor.evaluated_regexps.get(this.value);
	    if (evaluated === undefined && regexp_is_safe(this.value.source)) {
	        try {
	            const { source, flags } = this.value;
	            evaluated = new RegExp(source, flags);
	        } catch (e) {
	            evaluated = null;
	        }
	        compressor.evaluated_regexps.set(this.value, evaluated);
	    }
	    return evaluated || this;
	});

	def_eval(AST_TemplateString, function () {
	    if (this.segments.length !== 1) return this;
	    return this.segments[0].value;
	});

	def_eval(AST_Function, function (compressor) {
	    if (compressor.option("unsafe")) {
	        var fn = function () { };
	        fn.node = this;
	        fn.toString = () => this.print_to_string();
	        return fn;
	    }
	    return this;
	});

	def_eval(AST_Array, function (compressor, depth) {
	    if (compressor.option("unsafe")) {
	        var elements = [];
	        for (var i = 0, len = this.elements.length; i < len; i++) {
	            var element = this.elements[i];
	            var value = element._eval(compressor, depth);
	            if (element === value)
	                return this;
	            elements.push(value);
	        }
	        return elements;
	    }
	    return this;
	});

	def_eval(AST_Object, function (compressor, depth) {
	    if (compressor.option("unsafe")) {
	        var val = {};
	        for (var i = 0, len = this.properties.length; i < len; i++) {
	            var prop = this.properties[i];
	            if (prop instanceof AST_Expansion)
	                return this;
	            var key = prop.key;
	            if (key instanceof AST_Symbol) {
	                key = key.name;
	            } else if (key instanceof AST_Node) {
	                key = key._eval(compressor, depth);
	                if (key === prop.key)
	                    return this;
	            }
	            if (typeof Object.prototype[key] === "function") {
	                return this;
	            }
	            if (prop.value instanceof AST_Function)
	                continue;
	            val[key] = prop.value._eval(compressor, depth);
	            if (val[key] === prop.value)
	                return this;
	        }
	        return val;
	    }
	    return this;
	});

	var non_converting_unary = makePredicate("! typeof void");
	def_eval(AST_UnaryPrefix, function (compressor, depth) {
	    var e = this.expression;
	    // Function would be evaluated to an array and so typeof would
	    // incorrectly return 'object'. Hence making is a special case.
	    if (compressor.option("typeofs")
	        && this.operator == "typeof"
	        && (e instanceof AST_Lambda
	            || e instanceof AST_SymbolRef
	            && e.fixed_value() instanceof AST_Lambda)) {
	        return typeof function () { };
	    }
	    if (!non_converting_unary.has(this.operator))
	        depth++;
	    e = e._eval(compressor, depth);
	    if (e === this.expression)
	        return this;
	    switch (this.operator) {
	        case "!": return !e;
	        case "typeof":
	            // typeof <RegExp> returns "object" or "function" on different platforms
	            // so cannot evaluate reliably
	            if (e instanceof RegExp)
	                return this;
	            return typeof e;
	        case "void": return void e;
	        case "~": return ~e;
	        case "-": return -e;
	        case "+": return +e;
	    }
	    return this;
	});

	var non_converting_binary = makePredicate("&& || ?? === !==");
	const identity_comparison = makePredicate("== != === !==");
	const has_identity = value => typeof value === "object"
	    || typeof value === "function"
	    || typeof value === "symbol";

	def_eval(AST_Binary, function (compressor, depth) {
	    if (!non_converting_binary.has(this.operator))
	        depth++;

	    var left = this.left._eval(compressor, depth);
	    if (left === this.left)
	        return this;
	    var right = this.right._eval(compressor, depth);
	    if (right === this.right)
	        return this;

	    if (left != null
	        && right != null
	        && identity_comparison.has(this.operator)
	        && has_identity(left)
	        && has_identity(right)
	        && typeof left === typeof right) {
	        // Do not compare by reference
	        return this;
	    }

	    // Do not mix BigInt and Number; Don't use `>>>` on BigInt or `/ 0n`
	    if (
	        (typeof left === "bigint") !== (typeof right === "bigint")
	        || typeof left === "bigint"
	            && (this.operator === ">>>"
	                || this.operator === "/" && Number(right) === 0)
	    ) {
	        return this;
	    }

	    var result;
	    switch (this.operator) {
	        case "&&": result = left && right; break;
	        case "||": result = left || right; break;
	        case "??": result = left != null ? left : right; break;
	        case "|": result = left | right; break;
	        case "&": result = left & right; break;
	        case "^": result = left ^ right; break;
	        case "+": result = left + right; break;
	        case "*": result = left * right; break;
	        case "**": result = left ** right; break;
	        case "/": result = left / right; break;
	        case "%": result = left % right; break;
	        case "-": result = left - right; break;
	        case "<<": result = left << right; break;
	        case ">>": result = left >> right; break;
	        case ">>>": result = left >>> right; break;
	        case "==": result = left == right; break;
	        case "===": result = left === right; break;
	        case "!=": result = left != right; break;
	        case "!==": result = left !== right; break;
	        case "<": result = left < right; break;
	        case "<=": result = left <= right; break;
	        case ">": result = left > right; break;
	        case ">=": result = left >= right; break;
	        default:
	            return this;
	    }
	    if (typeof result === "number" && isNaN(result) && compressor.find_parent(AST_With)) {
	        // leave original expression as is
	        return this;
	    }
	    return result;
	});

	def_eval(AST_Conditional, function (compressor, depth) {
	    var condition = this.condition._eval(compressor, depth);
	    if (condition === this.condition)
	        return this;
	    var node = condition ? this.consequent : this.alternative;
	    var value = node._eval(compressor, depth);
	    return value === node ? this : value;
	});

	// Set of AST_SymbolRef which are currently being evaluated.
	// Avoids infinite recursion of ._eval()
	const reentrant_ref_eval = new Set();
	def_eval(AST_SymbolRef, function (compressor, depth) {
	    if (reentrant_ref_eval.has(this))
	        return this;

	    var fixed = this.fixed_value();
	    if (!fixed)
	        return this;

	    reentrant_ref_eval.add(this);
	    const value = fixed._eval(compressor, depth);
	    reentrant_ref_eval.delete(this);

	    if (value === fixed)
	        return this;

	    if (value && typeof value == "object") {
	        var escaped = this.definition().escaped;
	        if (escaped && depth > escaped)
	            return this;
	    }
	    return value;
	});

	const global_objs = { Array, Math, Number, Object, String };

	const regexp_flags = new Set([
	    "dotAll",
	    "global",
	    "ignoreCase",
	    "multiline",
	    "sticky",
	    "unicode",
	]);

	def_eval(AST_PropAccess, function (compressor, depth) {
	    let obj = this.expression._eval(compressor, depth + 1);
	    if (obj === nullish || (this.optional && obj == null)) return nullish;

	    // `.length` of strings and arrays is always safe
	    if (this.property === "length") {
	        if (typeof obj === "string") {
	            return obj.length;
	        }

	        const is_spreadless_array =
	            obj instanceof AST_Array
	            && obj.elements.every(el => !(el instanceof AST_Expansion));

	        if (
	            is_spreadless_array
	            && obj.elements.every(el => !el.has_side_effects(compressor))
	        ) {
	            return obj.elements.length;
	        }
	    }

	    if (compressor.option("unsafe")) {
	        var key = this.property;
	        if (key instanceof AST_Node) {
	            key = key._eval(compressor, depth);
	            if (key === this.property)
	                return this;
	        }

	        var exp = this.expression;
	        if (is_undeclared_ref(exp)) {
	            var aa;
	            var first_arg = exp.name === "hasOwnProperty"
	                && key === "call"
	                && (aa = compressor.parent() && compressor.parent().args)
	                && (aa && aa[0]
	                    && aa[0].evaluate(compressor));

	            first_arg = first_arg instanceof AST_Dot ? first_arg.expression : first_arg;

	            if (first_arg == null || first_arg.thedef && first_arg.thedef.undeclared) {
	                return this.clone();
	            }
	            if (!is_pure_native_value(exp.name, key))
	                return this;
	            obj = global_objs[exp.name];
	        } else {
	            if (obj instanceof RegExp) {
	                if (key == "source") {
	                    return regexp_source_fix(obj.source);
	                } else if (key == "flags" || regexp_flags.has(key)) {
	                    return obj[key];
	                }
	            }
	            if (!obj || obj === exp || !HOP(obj, key))
	                return this;

	            if (typeof obj == "function")
	                switch (key) {
	                    case "name":
	                        return obj.node.name ? obj.node.name.name : "";
	                    case "length":
	                        return obj.node.length_property();
	                    default:
	                        return this;
	                }
	        }
	        return obj[key];
	    }
	    return this;
	});

	def_eval(AST_Chain, function (compressor, depth) {
	    const evaluated = this.expression._eval(compressor, depth);
	    return evaluated === nullish
	        ? undefined
	        : evaluated === this.expression
	          ? this
	          : evaluated;
	});

	def_eval(AST_Call, function (compressor, depth) {
	    var exp = this.expression;

	    const callee = exp._eval(compressor, depth);
	    if (callee === nullish || (this.optional && callee == null)) return nullish;

	    if (compressor.option("unsafe") && exp instanceof AST_PropAccess) {
	        var key = exp.property;
	        if (key instanceof AST_Node) {
	            key = key._eval(compressor, depth);
	            if (key === exp.property)
	                return this;
	        }
	        var val;
	        var e = exp.expression;
	        if (is_undeclared_ref(e)) {
	            var first_arg = e.name === "hasOwnProperty" &&
	                key === "call" &&
	                (this.args[0] && this.args[0].evaluate(compressor));

	            first_arg = first_arg instanceof AST_Dot ? first_arg.expression : first_arg;

	            if ((first_arg == null || first_arg.thedef && first_arg.thedef.undeclared)) {
	                return this.clone();
	            }
	            if (!is_pure_native_fn(e.name, key)) return this;
	            val = global_objs[e.name];
	        } else {
	            val = e._eval(compressor, depth + 1);
	            if (val === e || !val)
	                return this;
	            if (!is_pure_native_method(val.constructor.name, key))
	                return this;
	        }
	        var args = [];
	        for (var i = 0, len = this.args.length; i < len; i++) {
	            var arg = this.args[i];
	            var value = arg._eval(compressor, depth);
	            if (arg === value)
	                return this;
	            if (arg instanceof AST_Lambda)
	                return this;
	            args.push(value);
	        }
	        try {
	            return val[key].apply(val, args);
	        } catch (ex) {
	            // We don't really care
	        }
	    }
	    return this;
	});

	// Also a subclass of AST_Call
	def_eval(AST_New, return_this);

	/***********************************************************************

	  A JavaScript tokenizer / parser / beautifier / compressor.
	  https://github.com/mishoo/UglifyJS2

	  -------------------------------- (C) ---------------------------------

	                           Author: Mihai Bazon
	                         <mihai.bazon@gmail.com>
	                       http://mihai.bazon.net/blog

	  Distributed under the BSD license:

	    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

	    Redistribution and use in source and binary forms, with or without
	    modification, are permitted provided that the following conditions
	    are met:

	        * Redistributions of source code must retain the above
	          copyright notice, this list of conditions and the following
	          disclaimer.

	        * Redistributions in binary form must reproduce the above
	          copyright notice, this list of conditions and the following
	          disclaimer in the documentation and/or other materials
	          provided with the distribution.

	    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
	    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
	    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
	    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
	    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
	    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
	    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
	    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
	    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
	    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
	    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
	    SUCH DAMAGE.

	 ***********************************************************************/

	// AST_Node#drop_side_effect_free() gets called when we don't care about the value,
	// only about side effects. We'll be defining this method for each node type in this module
	//
	// Examples:
	// foo++ -> foo++
	// 1 + func() -> func()
	// 10 -> (nothing)
	// knownPureFunc(foo++) -> foo++

	function def_drop_side_effect_free(node, func) {
	    node.DEFMETHOD("drop_side_effect_free", func);
	}

	// Drop side-effect-free elements from an array of expressions.
	// Returns an array of expressions with side-effects or null
	// if all elements were dropped. Note: original array may be
	// returned if nothing changed.
	function trim(nodes, compressor, first_in_statement) {
	    var len = nodes.length;
	    if (!len)  return null;

	    var ret = [], changed = false;
	    for (var i = 0; i < len; i++) {
	        var node = nodes[i].drop_side_effect_free(compressor, first_in_statement);
	        changed |= node !== nodes[i];
	        if (node) {
	            ret.push(node);
	            first_in_statement = false;
	        }
	    }
	    return changed ? ret.length ? ret : null : nodes;
	}

	def_drop_side_effect_free(AST_Node, return_this);
	def_drop_side_effect_free(AST_Constant, return_null);
	def_drop_side_effect_free(AST_This, return_null);

	def_drop_side_effect_free(AST_Call, function (compressor, first_in_statement) {
	    if (is_nullish_shortcircuited(this, compressor)) {
	        return this.expression.drop_side_effect_free(compressor, first_in_statement);
	    }

	    if (!this.is_callee_pure(compressor)) {
	        if (this.expression.is_call_pure(compressor)) {
	            var exprs = this.args.slice();
	            exprs.unshift(this.expression.expression);
	            exprs = trim(exprs, compressor, first_in_statement);
	            return exprs && make_sequence(this, exprs);
	        }
	        if (is_func_expr(this.expression)
	            && (!this.expression.name || !this.expression.name.definition().references.length)) {
	            var node = this.clone();
	            node.expression.process_expression(false, compressor);
	            return node;
	        }
	        return this;
	    }

	    var args = trim(this.args, compressor, first_in_statement);
	    return args && make_sequence(this, args);
	});

	def_drop_side_effect_free(AST_Accessor, return_null);

	def_drop_side_effect_free(AST_Function, return_null);

	def_drop_side_effect_free(AST_Arrow, return_null);

	def_drop_side_effect_free(AST_Class, function (compressor) {
	    const with_effects = [];

	    if (this.is_self_referential() && this.has_side_effects(compressor)) {
	        return this;
	    }

	    const trimmed_extends = this.extends && this.extends.drop_side_effect_free(compressor);
	    if (trimmed_extends) with_effects.push(trimmed_extends);

	    for (const prop of this.properties) {
	        if (prop instanceof AST_ClassStaticBlock) {
	            if (prop.has_side_effects(compressor)) {
	                return this; // Be cautious about these
	            }
	        } else {
	            const trimmed_prop = prop.drop_side_effect_free(compressor);
	            if (trimmed_prop) with_effects.push(trimmed_prop);
	        }
	    }

	    if (!with_effects.length)
	        return null;

	    const exprs = make_sequence(this, with_effects);
	    if (this instanceof AST_DefClass) {
	        // We want a statement
	        return make_node(AST_SimpleStatement, this, { body: exprs });
	    } else {
	        return exprs;
	    }
	});

	def_drop_side_effect_free(AST_ClassProperty, function (compressor) {
	    const key = this.computed_key() && this.key.drop_side_effect_free(compressor);

	    const value = this.static && this.value
	        && this.value.drop_side_effect_free(compressor);

	    if (key && value)
	        return make_sequence(this, [key, value]);
	    return key || value || null;
	});

	def_drop_side_effect_free(AST_Binary, function (compressor, first_in_statement) {
	    var right = this.right.drop_side_effect_free(compressor);
	    if (!right)
	        return this.left.drop_side_effect_free(compressor, first_in_statement);
	    if (lazy_op.has(this.operator)) {
	        if (right === this.right)
	            return this;
	        var node = this.clone();
	        node.right = right;
	        return node;
	    } else {
	        var left = this.left.drop_side_effect_free(compressor, first_in_statement);
	        if (!left)
	            return this.right.drop_side_effect_free(compressor, first_in_statement);
	        return make_sequence(this, [left, right]);
	    }
	});

	def_drop_side_effect_free(AST_Assign, function (compressor) {
	    if (this.logical)
	        return this;

	    var left = this.left;
	    if (left.has_side_effects(compressor)
	        || compressor.has_directive("use strict")
	        && left instanceof AST_PropAccess
	        && left.expression.is_constant()) {
	        return this;
	    }
	    set_flag(this, WRITE_ONLY);
	    while (left instanceof AST_PropAccess) {
	        left = left.expression;
	    }
	    if (left.is_constant_expression(compressor.find_parent(AST_Scope))) {
	        return this.right.drop_side_effect_free(compressor);
	    }
	    return this;
	});

	def_drop_side_effect_free(AST_Conditional, function (compressor) {
	    var consequent = this.consequent.drop_side_effect_free(compressor);
	    var alternative = this.alternative.drop_side_effect_free(compressor);
	    if (consequent === this.consequent && alternative === this.alternative)
	        return this;
	    if (!consequent)
	        return alternative ? make_node(AST_Binary, this, {
	            operator: "||",
	            left: this.condition,
	            right: alternative
	        }) : this.condition.drop_side_effect_free(compressor);
	    if (!alternative)
	        return make_node(AST_Binary, this, {
	            operator: "&&",
	            left: this.condition,
	            right: consequent
	        });
	    var node = this.clone();
	    node.consequent = consequent;
	    node.alternative = alternative;
	    return node;
	});

	def_drop_side_effect_free(AST_Unary, function (compressor, first_in_statement) {
	    if (unary_side_effects.has(this.operator)) {
	        if (!this.expression.has_side_effects(compressor)) {
	            set_flag(this, WRITE_ONLY);
	        } else {
	            clear_flag(this, WRITE_ONLY);
	        }
	        return this;
	    }
	    if (this.operator == "typeof" && this.expression instanceof AST_SymbolRef)
	        return null;
	    var expression = this.expression.drop_side_effect_free(compressor, first_in_statement);
	    if (first_in_statement && expression && is_iife_call(expression)) {
	        if (expression === this.expression && this.operator == "!")
	            return this;
	        return expression.negate(compressor, first_in_statement);
	    }
	    return expression;
	});

	def_drop_side_effect_free(AST_SymbolRef, function (compressor) {
	    const safe_access = this.is_declared(compressor)
	        || pure_prop_access_globals.has(this.name);
	    return safe_access ? null : this;
	});

	def_drop_side_effect_free(AST_Object, function (compressor, first_in_statement) {
	    var values = trim(this.properties, compressor, first_in_statement);
	    return values && make_sequence(this, values);
	});

	def_drop_side_effect_free(AST_ObjectProperty, function (compressor, first_in_statement) {
	    const computed_key = this instanceof AST_ObjectKeyVal && this.key instanceof AST_Node;
	    const key = computed_key && this.key.drop_side_effect_free(compressor, first_in_statement);
	    const value = this.value && this.value.drop_side_effect_free(compressor, first_in_statement);
	    if (key && value) {
	        return make_sequence(this, [key, value]);
	    }
	    return key || value;
	});

	def_drop_side_effect_free(AST_ConciseMethod, function () {
	    return this.computed_key() ? this.key : null;
	});

	def_drop_side_effect_free(AST_ObjectGetter, function () {
	    return this.computed_key() ? this.key : null;
	});

	def_drop_side_effect_free(AST_ObjectSetter, function () {
	    return this.computed_key() ? this.key : null;
	});

	def_drop_side_effect_free(AST_Array, function (compressor, first_in_statement) {
	    var values = trim(this.elements, compressor, first_in_statement);
	    return values && make_sequence(this, values);
	});

	def_drop_side_effect_free(AST_Dot, function (compressor, first_in_statement) {
	    if (is_nullish_shortcircuited(this, compressor)) {
	        return this.expression.drop_side_effect_free(compressor, first_in_statement);
	    }
	    if (!this.optional && this.expression.may_throw_on_access(compressor)) {
	        return this;
	    }

	    return this.expression.drop_side_effect_free(compressor, first_in_statement);
	});

	def_drop_side_effect_free(AST_Sub, function (compressor, first_in_statement) {
	    if (is_nullish_shortcircuited(this, compressor)) {
	        return this.expression.drop_side_effect_free(compressor, first_in_statement);
	    }
	    if (!this.optional && this.expression.may_throw_on_access(compressor)) {
	        return this;
	    }

	    var property = this.property.drop_side_effect_free(compressor);
	    if (property && this.optional) return this;

	    var expression = this.expression.drop_side_effect_free(compressor, first_in_statement);

	    if (expression && property) return make_sequence(this, [expression, property]);
	    return expression || property;
	});

	def_drop_side_effect_free(AST_Chain, function (compressor, first_in_statement) {
	    return this.expression.drop_side_effect_free(compressor, first_in_statement);
	});

	def_drop_side_effect_free(AST_Sequence, function (compressor) {
	    var last = this.tail_node();
	    var expr = last.drop_side_effect_free(compressor);
	    if (expr === last)
	        return this;
	    var expressions = this.expressions.slice(0, -1);
	    if (expr)
	        expressions.push(expr);
	    if (!expressions.length) {
	        return make_node(AST_Number, this, { value: 0 });
	    }
	    return make_sequence(this, expressions);
	});

	def_drop_side_effect_free(AST_Expansion, function (compressor, first_in_statement) {
	    return this.expression.drop_side_effect_free(compressor, first_in_statement);
	});

	def_drop_side_effect_free(AST_TemplateSegment, return_null);

	def_drop_side_effect_free(AST_TemplateString, function (compressor) {
	    var values = trim(this.segments, compressor, first_in_statement);
	    return values && make_sequence(this, values);
	});

	/***********************************************************************

	  A JavaScript tokenizer / parser / beautifier / compressor.
	  https://github.com/mishoo/UglifyJS2

	  -------------------------------- (C) ---------------------------------

	                           Author: Mihai Bazon
	                         <mihai.bazon@gmail.com>
	                       http://mihai.bazon.net/blog

	  Distributed under the BSD license:

	    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

	    Redistribution and use in source and binary forms, with or without
	    modification, are permitted provided that the following conditions
	    are met:

	        * Redistributions of source code must retain the above
	          copyright notice, this list of conditions and the following
	          disclaimer.

	        * Redistributions in binary form must reproduce the above
	          copyright notice, this list of conditions and the following
	          disclaimer in the documentation and/or other materials
	          provided with the distribution.

	    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
	    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
	    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
	    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
	    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
	    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
	    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
	    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
	    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
	    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
	    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
	    SUCH DAMAGE.

	 ***********************************************************************/

	const r_keep_assign = /keep_assign/;

	/** Drop unused variables from this scope */
	AST_Scope.DEFMETHOD("drop_unused", function(compressor) {
	    if (!compressor.option("unused")) return;
	    if (compressor.has_directive("use asm")) return;
	    if (!this.variables) return; // not really a scope (eg: AST_Class)

	    var self = this;
	    if (self.pinned()) return;
	    var drop_funcs = !(self instanceof AST_Toplevel) || compressor.toplevel.funcs;
	    var drop_vars = !(self instanceof AST_Toplevel) || compressor.toplevel.vars;
	    const assign_as_unused = r_keep_assign.test(compressor.option("unused")) ? return_false : function(node) {
	        if (node instanceof AST_Assign
	            && !node.logical
	            && (has_flag(node, WRITE_ONLY) || node.operator == "=")
	        ) {
	            return node.left;
	        }
	        if (node instanceof AST_Unary && has_flag(node, WRITE_ONLY)) {
	            return node.expression;
	        }
	    };
	    var in_use_ids = new Map();
	    var fixed_ids = new Map();
	    if (self instanceof AST_Toplevel && compressor.top_retain) {
	        self.variables.forEach(function(def) {
	            if (compressor.top_retain(def)) {
	                in_use_ids.set(def.id, def);
	            }
	        });
	    }
	    var var_defs_by_id = new Map();
	    var initializations = new Map();
	    var self_referential_classes = new Set();

	    // pass 1: find out which symbols are directly used in
	    // this scope (not in nested scopes).
	    var scope = this;
	    var tw = new TreeWalker(function(node, descend) {
	        if (node instanceof AST_Lambda && node.uses_arguments && !tw.has_directive("use strict")) {
	            node.argnames.forEach(function(argname) {
	                if (!(argname instanceof AST_SymbolDeclaration)) return;
	                var def = argname.definition();
	                in_use_ids.set(def.id, def);
	            });
	        }
	        if (node === self) return;
	        if (node instanceof AST_Class && node.has_side_effects(compressor)) {
	            if (node.is_self_referential()) self_referential_classes.add(node);
	            node.visit_nondeferred_class_parts(tw);
	        }
	        if (node instanceof AST_Defun || node instanceof AST_DefClass) {
	            var node_def = node.name.definition();
	            const in_export = tw.parent() instanceof AST_Export;
	            if (in_export || !drop_funcs && scope === self) {
	                if (node_def.global) {
	                    in_use_ids.set(node_def.id, node_def);
	                }
	            }

	            map_add(initializations, node_def.id, node);
	            return true; // don't go in nested scopes
	        }
	        // In the root scope, we drop things. In inner scopes, we just check for uses.
	        const in_root_scope = scope === self;
	        if (node instanceof AST_SymbolFunarg && in_root_scope) {
	            map_add(var_defs_by_id, node.definition().id, node);
	        }
	        if (node instanceof AST_Definitions && in_root_scope) {
	            const in_export = tw.parent() instanceof AST_Export;
	            node.definitions.forEach(function(def) {
	                if (def.name instanceof AST_SymbolVar) {
	                    map_add(var_defs_by_id, def.name.definition().id, def);
	                }
	                if (in_export || !drop_vars) {
	                    walk(def.name, node => {
	                        if (node instanceof AST_SymbolDeclaration) {
	                            const def = node.definition();
	                            if (def.global) {
	                                in_use_ids.set(def.id, def);
	                            }
	                        }
	                    });
	                }
	                if (def.name instanceof AST_Destructuring) {
	                    def.walk(tw);
	                }
	                if (def.name instanceof AST_SymbolDeclaration && def.value) {
	                    var node_def = def.name.definition();
	                    map_add(initializations, node_def.id, def.value);
	                    if (!node_def.chained && def.name.fixed_value() === def.value) {
	                        fixed_ids.set(node_def.id, def);
	                    }
	                    if (def.value.has_side_effects(compressor)) {
	                        def.value.walk(tw);
	                    }
	                }
	            });
	            return true;
	        }
	        return scan_ref_scoped(node, descend);
	    });
	    self.walk(tw);
	    // pass 2: for every used symbol we need to walk its
	    // initialization code to figure out if it uses other
	    // symbols (that may not be in_use).
	    tw = new TreeWalker(scan_ref_scoped);
	    in_use_ids.forEach(function (def) {
	        var init = initializations.get(def.id);
	        if (init) init.forEach(function(init) {
	            init.walk(tw);
	        });
	    });
	    self_referential_classes.forEach(function (cls) {
	        cls.walk(tw);
	    });
	    // pass 3: we should drop declarations not in_use
	    var tt = new TreeTransformer(
	        function before(node, descend, in_list) {
	            var parent = tt.parent();
	            if (drop_vars) {
	                const sym = assign_as_unused(node);
	                if (sym instanceof AST_SymbolRef) {
	                    var def = sym.definition();
	                    var in_use = in_use_ids.has(def.id);
	                    if (node instanceof AST_Assign) {
	                        if (!in_use || fixed_ids.has(def.id) && fixed_ids.get(def.id) !== node) {
	                            return maintain_this_binding(parent, node, node.right.transform(tt));
	                        }
	                    } else if (!in_use) {
	                        return in_list ? MAP.skip : make_node(AST_Number, node, { value: 0 });
	                    }
	                }
	            }
	            if (scope !== self) return;
	            var def;
	            if (node.name
	                && (node instanceof AST_ClassExpression
	                    && !keep_name(compressor.option("keep_classnames"), (def = node.name.definition()).name)
	                || node instanceof AST_Function
	                    && !keep_name(compressor.option("keep_fnames"), (def = node.name.definition()).name))) {
	                // any declarations with same name will overshadow
	                // name of this anonymous function and can therefore
	                // never be used anywhere
	                if (!in_use_ids.has(def.id) || def.orig.length > 1) node.name = null;
	            }
	            if (node instanceof AST_Lambda && !(node instanceof AST_Accessor)) {
	                var trim = !compressor.option("keep_fargs");
	                for (var a = node.argnames, i = a.length; --i >= 0;) {
	                    var sym = a[i];
	                    if (sym instanceof AST_Expansion) {
	                        sym = sym.expression;
	                    }
	                    if (sym instanceof AST_DefaultAssign) {
	                        sym = sym.left;
	                    }
	                    // Do not drop destructuring arguments.
	                    // They constitute a type assertion of sorts
	                    if (
	                        !(sym instanceof AST_Destructuring)
	                        && !in_use_ids.has(sym.definition().id)
	                    ) {
	                        set_flag(sym, UNUSED);
	                        if (trim) {
	                            a.pop();
	                        }
	                    } else {
	                        trim = false;
	                    }
	                }
	            }
	            if (node instanceof AST_DefClass && node !== self) {
	                const def = node.name.definition();
	                descend(node, this);
	                const keep_class = def.global && !drop_funcs || in_use_ids.has(def.id);
	                if (!keep_class) {
	                    const kept = node.drop_side_effect_free(compressor);
	                    if (kept == null) {
	                        def.eliminated++;
	                        return in_list ? MAP.skip : make_node(AST_EmptyStatement, node);
	                    }
	                    return kept;
	                }
	                return node;
	            }
	            if (node instanceof AST_Defun && node !== self) {
	                const def = node.name.definition();
	                const keep = def.global && !drop_funcs || in_use_ids.has(def.id);
	                if (!keep) {
	                    def.eliminated++;
	                    return in_list ? MAP.skip : make_node(AST_EmptyStatement, node);
	                }
	            }
	            if (node instanceof AST_Definitions && !(parent instanceof AST_ForIn && parent.init === node)) {
	                var drop_block = !(parent instanceof AST_Toplevel) && !(node instanceof AST_Var);
	                // place uninitialized names at the start
	                var body = [], head = [], tail = [];
	                // for unused names whose initialization has
	                // side effects, we can cascade the init. code
	                // into the next one, or next statement.
	                var side_effects = [];
	                node.definitions.forEach(function(def) {
	                    if (def.value) def.value = def.value.transform(tt);
	                    var is_destructure = def.name instanceof AST_Destructuring;
	                    var sym = is_destructure
	                        ? new SymbolDef(null, { name: "<destructure>" }) /* fake SymbolDef */
	                        : def.name.definition();
	                    if (drop_block && sym.global) return tail.push(def);
	                    if (!(drop_vars || drop_block)
	                        || is_destructure
	                            && (def.name.names.length
	                                || def.name.is_array
	                                || compressor.option("pure_getters") != true)
	                        || in_use_ids.has(sym.id)
	                    ) {
	                        if (def.value && fixed_ids.has(sym.id) && fixed_ids.get(sym.id) !== def) {
	                            def.value = def.value.drop_side_effect_free(compressor);
	                        }
	                        if (def.name instanceof AST_SymbolVar) {
	                            var var_defs = var_defs_by_id.get(sym.id);
	                            if (var_defs.length > 1 && (!def.value || sym.orig.indexOf(def.name) > sym.eliminated)) {
	                                if (def.value) {
	                                    var ref = make_node(AST_SymbolRef, def.name, def.name);
	                                    sym.references.push(ref);
	                                    var assign = make_node(AST_Assign, def, {
	                                        operator: "=",
	                                        logical: false,
	                                        left: ref,
	                                        right: def.value
	                                    });
	                                    if (fixed_ids.get(sym.id) === def) {
	                                        fixed_ids.set(sym.id, assign);
	                                    }
	                                    side_effects.push(assign.transform(tt));
	                                }
	                                remove(var_defs, def);
	                                sym.eliminated++;
	                                return;
	                            }
	                        }
	                        if (def.value) {
	                            if (side_effects.length > 0) {
	                                if (tail.length > 0) {
	                                    side_effects.push(def.value);
	                                    def.value = make_sequence(def.value, side_effects);
	                                } else {
	                                    body.push(make_node(AST_SimpleStatement, node, {
	                                        body: make_sequence(node, side_effects)
	                                    }));
	                                }
	                                side_effects = [];
	                            }
	                            tail.push(def);
	                        } else {
	                            head.push(def);
	                        }
	                    } else if (sym.orig[0] instanceof AST_SymbolCatch) {
	                        var value = def.value && def.value.drop_side_effect_free(compressor);
	                        if (value) side_effects.push(value);
	                        def.value = null;
	                        head.push(def);
	                    } else {
	                        var value = def.value && def.value.drop_side_effect_free(compressor);
	                        if (value) {
	                            side_effects.push(value);
	                        }
	                        sym.eliminated++;
	                    }
	                });
	                if (head.length > 0 || tail.length > 0) {
	                    node.definitions = head.concat(tail);
	                    body.push(node);
	                }
	                if (side_effects.length > 0) {
	                    body.push(make_node(AST_SimpleStatement, node, {
	                        body: make_sequence(node, side_effects)
	                    }));
	                }
	                switch (body.length) {
	                  case 0:
	                    return in_list ? MAP.skip : make_node(AST_EmptyStatement, node);
	                  case 1:
	                    return body[0];
	                  default:
	                    return in_list ? MAP.splice(body) : make_node(AST_BlockStatement, node, { body });
	                }
	            }
	            // certain combination of unused name + side effect leads to:
	            //    https://github.com/mishoo/UglifyJS2/issues/44
	            //    https://github.com/mishoo/UglifyJS2/issues/1830
	            //    https://github.com/mishoo/UglifyJS2/issues/1838
	            // that's an invalid AST.
	            // We fix it at this stage by moving the `var` outside the `for`.
	            if (node instanceof AST_For) {
	                descend(node, this);
	                var block;
	                if (node.init instanceof AST_BlockStatement) {
	                    block = node.init;
	                    node.init = block.body.pop();
	                    block.body.push(node);
	                }
	                if (node.init instanceof AST_SimpleStatement) {
	                    node.init = node.init.body;
	                } else if (is_empty(node.init)) {
	                    node.init = null;
	                }
	                return !block ? node : in_list ? MAP.splice(block.body) : block;
	            }
	            if (node instanceof AST_LabeledStatement
	                && node.body instanceof AST_For
	            ) {
	                descend(node, this);
	                if (node.body instanceof AST_BlockStatement) {
	                    var block = node.body;
	                    node.body = block.body.pop();
	                    block.body.push(node);
	                    return in_list ? MAP.splice(block.body) : block;
	                }
	                return node;
	            }
	            if (node instanceof AST_BlockStatement) {
	                descend(node, this);
	                if (in_list && node.body.every(can_be_evicted_from_block)) {
	                    return MAP.splice(node.body);
	                }
	                return node;
	            }
	            if (node instanceof AST_Scope && !(node instanceof AST_ClassStaticBlock)) {
	                const save_scope = scope;
	                scope = node;
	                descend(node, this);
	                scope = save_scope;
	                return node;
	            }
	        }
	    );

	    self.transform(tt);

	    function scan_ref_scoped(node, descend) {
	        var node_def;
	        const sym = assign_as_unused(node);
	        if (sym instanceof AST_SymbolRef
	            && !is_ref_of(node.left, AST_SymbolBlockDeclaration)
	            && self.variables.get(sym.name) === (node_def = sym.definition())
	        ) {
	            if (node instanceof AST_Assign) {
	                node.right.walk(tw);
	                if (!node_def.chained && node.left.fixed_value() === node.right) {
	                    fixed_ids.set(node_def.id, node);
	                }
	            }
	            return true;
	        }
	        if (node instanceof AST_SymbolRef) {
	            node_def = node.definition();
	            if (!in_use_ids.has(node_def.id)) {
	                in_use_ids.set(node_def.id, node_def);
	                if (node_def.orig[0] instanceof AST_SymbolCatch) {
	                    const redef = node_def.scope.is_block_scope()
	                        && node_def.scope.get_defun_scope().variables.get(node_def.name);
	                    if (redef) in_use_ids.set(redef.id, redef);
	                }
	            }
	            return true;
	        }
	        if (node instanceof AST_Class) {
	            descend();
	            return true;
	        }
	        if (node instanceof AST_Scope && !(node instanceof AST_ClassStaticBlock)) {
	            var save_scope = scope;
	            scope = node;
	            descend();
	            scope = save_scope;
	            return true;
	        }
	    }
	});

	/***********************************************************************

	  A JavaScript tokenizer / parser / beautifier / compressor.
	  https://github.com/mishoo/UglifyJS2

	  -------------------------------- (C) ---------------------------------

	                           Author: Mihai Bazon
	                         <mihai.bazon@gmail.com>
	                       http://mihai.bazon.net/blog

	  Distributed under the BSD license:

	    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

	    Redistribution and use in source and binary forms, with or without
	    modification, are permitted provided that the following conditions
	    are met:

	        * Redistributions of source code must retain the above
	          copyright notice, this list of conditions and the following
	          disclaimer.

	        * Redistributions in binary form must reproduce the above
	          copyright notice, this list of conditions and the following
	          disclaimer in the documentation and/or other materials
	          provided with the distribution.

	    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
	    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
	    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
	    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
	    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
	    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
	    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
	    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
	    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
	    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
	    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
	    SUCH DAMAGE.

	 ***********************************************************************/

	/**
	 * Define the method AST_Node#reduce_vars, which goes through the AST in
	 * execution order to perform basic flow analysis
	 */
	function def_reduce_vars(node, func) {
	    node.DEFMETHOD("reduce_vars", func);
	}

	def_reduce_vars(AST_Node, noop);

	/** Clear definition properties */
	function reset_def(compressor, def) {
	    def.assignments = 0;
	    def.chained = false;
	    def.direct_access = false;
	    def.escaped = 0;
	    def.recursive_refs = 0;
	    def.references = [];
	    def.single_use = undefined;
	    if (
	        def.scope.pinned()
	        || (def.orig[0] instanceof AST_SymbolFunarg && def.scope.uses_arguments)
	    ) {
	        def.fixed = false;
	    } else if (def.orig[0] instanceof AST_SymbolConst || !compressor.exposed(def)) {
	        def.fixed = def.init;
	    } else {
	        def.fixed = false;
	    }
	}

	function reset_variables(tw, compressor, node) {
	    node.variables.forEach(function(def) {
	        reset_def(compressor, def);
	        if (def.fixed === null) {
	            tw.defs_to_safe_ids.set(def.id, tw.safe_ids);
	            mark(tw, def, true);
	        } else if (def.fixed) {
	            tw.loop_ids.set(def.id, tw.in_loop);
	            mark(tw, def, true);
	        }
	    });
	}

	function reset_block_variables(compressor, node) {
	    if (node.block_scope) node.block_scope.variables.forEach((def) => {
	        reset_def(compressor, def);
	    });
	}

	function push(tw) {
	    tw.safe_ids = Object.create(tw.safe_ids);
	}

	function pop(tw) {
	    tw.safe_ids = Object.getPrototypeOf(tw.safe_ids);
	}

	function mark(tw, def, safe) {
	    tw.safe_ids[def.id] = safe;
	}

	function safe_to_read(tw, def) {
	    if (def.single_use == "m") return false;
	    if (tw.safe_ids[def.id]) {
	        if (def.fixed == null) {
	            var orig = def.orig[0];
	            if (orig instanceof AST_SymbolFunarg || orig.name == "arguments") return false;
	            def.fixed = make_node(AST_Undefined, orig);
	        }
	        return true;
	    }
	    return def.fixed instanceof AST_Defun;
	}

	function safe_to_assign(tw, def, scope, value) {
	    if (def.fixed === undefined) return true;
	    let def_safe_ids;
	    if (def.fixed === null
	        && (def_safe_ids = tw.defs_to_safe_ids.get(def.id))
	    ) {
	        def_safe_ids[def.id] = false;
	        tw.defs_to_safe_ids.delete(def.id);
	        return true;
	    }
	    if (!HOP(tw.safe_ids, def.id)) return false;
	    if (!safe_to_read(tw, def)) return false;
	    if (def.fixed === false) return false;
	    if (def.fixed != null && (!value || def.references.length > def.assignments)) return false;
	    if (def.fixed instanceof AST_Defun) {
	        return value instanceof AST_Node && def.fixed.parent_scope === scope;
	    }
	    return def.orig.every((sym) => {
	        return !(sym instanceof AST_SymbolConst
	            || sym instanceof AST_SymbolDefun
	            || sym instanceof AST_SymbolLambda);
	    });
	}

	function ref_once(tw, compressor, def) {
	    return compressor.option("unused")
	        && !def.scope.pinned()
	        && def.references.length - def.recursive_refs == 1
	        && tw.loop_ids.get(def.id) === tw.in_loop;
	}

	function is_immutable(value) {
	    if (!value) return false;
	    return value.is_constant()
	        || value instanceof AST_Lambda
	        || value instanceof AST_This;
	}

	// A definition "escapes" when its value can leave the point of use.
	// Example: `a = b || c`
	// In this example, "b" and "c" are escaping, because they're going into "a"
	//
	// def.escaped is != 0 when it escapes.
	//
	// When greater than 1, it means that N chained properties will be read off
	// of that def before an escape occurs. This is useful for evaluating
	// property accesses, where you need to know when to stop.
	function mark_escaped(tw, d, scope, node, value, level = 0, depth = 1) {
	    var parent = tw.parent(level);
	    if (value) {
	        if (value.is_constant()) return;
	        if (value instanceof AST_ClassExpression) return;
	    }

	    if (
	        parent instanceof AST_Assign && (parent.operator === "=" || parent.logical) && node === parent.right
	        || parent instanceof AST_Call && (node !== parent.expression || parent instanceof AST_New)
	        || parent instanceof AST_Exit && node === parent.value && node.scope !== d.scope
	        || parent instanceof AST_VarDef && node === parent.value
	        || parent instanceof AST_Yield && node === parent.value && node.scope !== d.scope
	    ) {
	        if (depth > 1 && !(value && value.is_constant_expression(scope))) depth = 1;
	        if (!d.escaped || d.escaped > depth) d.escaped = depth;
	        return;
	    } else if (
	        parent instanceof AST_Array
	        || parent instanceof AST_Await
	        || parent instanceof AST_Binary && lazy_op.has(parent.operator)
	        || parent instanceof AST_Conditional && node !== parent.condition
	        || parent instanceof AST_Expansion
	        || parent instanceof AST_Sequence && node === parent.tail_node()
	    ) {
	        mark_escaped(tw, d, scope, parent, parent, level + 1, depth);
	    } else if (parent instanceof AST_ObjectKeyVal && node === parent.value) {
	        var obj = tw.parent(level + 1);

	        mark_escaped(tw, d, scope, obj, obj, level + 2, depth);
	    } else if (parent instanceof AST_PropAccess && node === parent.expression) {
	        value = read_property(value, parent.property);

	        mark_escaped(tw, d, scope, parent, value, level + 1, depth + 1);
	        if (value) return;
	    }

	    if (level > 0) return;
	    if (parent instanceof AST_Sequence && node !== parent.tail_node()) return;
	    if (parent instanceof AST_SimpleStatement) return;

	    d.direct_access = true;
	}

	const suppress = node => walk(node, node => {
	    if (!(node instanceof AST_Symbol)) return;
	    var d = node.definition();
	    if (!d) return;
	    if (node instanceof AST_SymbolRef) d.references.push(node);
	    d.fixed = false;
	});

	def_reduce_vars(AST_Accessor, function(tw, descend, compressor) {
	    push(tw);
	    reset_variables(tw, compressor, this);
	    descend();
	    pop(tw);
	    return true;
	});

	def_reduce_vars(AST_Assign, function(tw, descend, compressor) {
	    var node = this;
	    if (node.left instanceof AST_Destructuring) {
	        suppress(node.left);
	        return;
	    }

	    const finish_walk = () => {
	        if (node.logical) {
	            node.left.walk(tw);

	            push(tw);
	            node.right.walk(tw);
	            pop(tw);

	            return true;
	        }
	    };

	    var sym = node.left;
	    if (!(sym instanceof AST_SymbolRef)) return finish_walk();

	    var def = sym.definition();
	    var safe = safe_to_assign(tw, def, sym.scope, node.right);
	    def.assignments++;
	    if (!safe) return finish_walk();

	    var fixed = def.fixed;
	    if (!fixed && node.operator != "=" && !node.logical) return finish_walk();

	    var eq = node.operator == "=";
	    var value = eq ? node.right : node;
	    if (is_modified(compressor, tw, node, value, 0)) return finish_walk();

	    def.references.push(sym);

	    if (!node.logical) {
	        if (!eq) def.chained = true;

	        def.fixed = eq ? function() {
	            return node.right;
	        } : function() {
	            return make_node(AST_Binary, node, {
	                operator: node.operator.slice(0, -1),
	                left: fixed instanceof AST_Node ? fixed : fixed(),
	                right: node.right
	            });
	        };
	    }

	    if (node.logical) {
	        mark(tw, def, false);
	        push(tw);
	        node.right.walk(tw);
	        pop(tw);
	        return true;
	    }

	    mark(tw, def, false);
	    node.right.walk(tw);
	    mark(tw, def, true);

	    mark_escaped(tw, def, sym.scope, node, value, 0, 1);

	    return true;
	});

	def_reduce_vars(AST_Binary, function(tw) {
	    if (!lazy_op.has(this.operator)) return;
	    this.left.walk(tw);
	    push(tw);
	    this.right.walk(tw);
	    pop(tw);
	    return true;
	});

	def_reduce_vars(AST_Block, function(tw, descend, compressor) {
	    reset_block_variables(compressor, this);
	});

	def_reduce_vars(AST_Case, function(tw) {
	    push(tw);
	    this.expression.walk(tw);
	    pop(tw);
	    push(tw);
	    walk_body(this, tw);
	    pop(tw);
	    return true;
	});

	def_reduce_vars(AST_Class, function(tw, descend) {
	    clear_flag(this, INLINED);
	    push(tw);
	    descend();
	    pop(tw);
	    return true;
	});

	def_reduce_vars(AST_ClassStaticBlock, function(tw, descend, compressor) {
	    reset_block_variables(compressor, this);
	});

	def_reduce_vars(AST_Conditional, function(tw) {
	    this.condition.walk(tw);
	    push(tw);
	    this.consequent.walk(tw);
	    pop(tw);
	    push(tw);
	    this.alternative.walk(tw);
	    pop(tw);
	    return true;
	});

	def_reduce_vars(AST_Chain, function(tw, descend) {
	    // Chains' conditions apply left-to-right, cumulatively.
	    // If we walk normally we don't go in that order because we would pop before pushing again
	    // Solution: AST_PropAccess and AST_Call push when they are optional, and never pop.
	    // Then we pop everything when they are done being walked.
	    const safe_ids = tw.safe_ids;

	    descend();

	    // Unroll back to start
	    tw.safe_ids = safe_ids;
	    return true;
	});

	def_reduce_vars(AST_Call, function (tw) {
	    this.expression.walk(tw);

	    if (this.optional) {
	        // Never pop -- it's popped at AST_Chain above
	        push(tw);
	    }

	    for (const arg of this.args) arg.walk(tw);

	    return true;
	});

	def_reduce_vars(AST_PropAccess, function (tw) {
	    if (!this.optional) return;

	    this.expression.walk(tw);

	    // Never pop -- it's popped at AST_Chain above
	    push(tw);

	    if (this.property instanceof AST_Node) this.property.walk(tw);

	    return true;
	});

	def_reduce_vars(AST_Default, function(tw, descend) {
	    push(tw);
	    descend();
	    pop(tw);
	    return true;
	});

	function mark_lambda(tw, descend, compressor) {
	    clear_flag(this, INLINED);
	    push(tw);
	    reset_variables(tw, compressor, this);

	    var iife;
	    if (!this.name
	        && !this.uses_arguments
	        && !this.pinned()
	        && (iife = tw.parent()) instanceof AST_Call
	        && iife.expression === this
	        && !iife.args.some(arg => arg instanceof AST_Expansion)
	        && this.argnames.every(arg_name => arg_name instanceof AST_Symbol)
	    ) {
	        // Virtually turn IIFE parameters into variable definitions:
	        //   (function(a,b) {...})(c,d) => (function() {var a=c,b=d; ...})()
	        // So existing transformation rules can work on them.
	        this.argnames.forEach((arg, i) => {
	            if (!arg.definition) return;
	            var d = arg.definition();
	            // Avoid setting fixed when there's more than one origin for a variable value
	            if (d.orig.length > 1) return;
	            if (d.fixed === undefined && (!this.uses_arguments || tw.has_directive("use strict"))) {
	                d.fixed = function() {
	                    return iife.args[i] || make_node(AST_Undefined, iife);
	                };
	                tw.loop_ids.set(d.id, tw.in_loop);
	                mark(tw, d, true);
	            } else {
	                d.fixed = false;
	            }
	        });
	    }

	    descend();
	    pop(tw);

	    handle_defined_after_hoist(this);

	    return true;
	}

	/**
	 * It's possible for a hoisted function to use something that's not defined yet. Example:
	 *
	 * hoisted();
	 * var defined_after = true;
	 * function hoisted() {
	 *   // use defined_after
	 * }
	 *
	 * This function is called on the parent to handle this issue.
	 */
	function handle_defined_after_hoist(parent) {
	    const defuns = [];
	    walk(parent, node => {
	        if (node === parent) return;
	        if (node instanceof AST_Defun) defuns.push(node);
	        if (
	            node instanceof AST_Scope
	            || node instanceof AST_SimpleStatement
	        ) return true;
	    });

	    const symbols_of_interest = new Set();
	    const defuns_of_interest = new Set();
	    const potential_conflicts = [];

	    for (const defun of defuns) {
	        const fname_def = defun.name.definition();
	        const found_self_ref_in_other_defuns = defuns.some(
	            d => d !== defun && d.enclosed.indexOf(fname_def) !== -1
	        );

	        for (const def of defun.enclosed) {
	            if (
	                def.fixed === false
	                || def === fname_def
	                || def.scope.get_defun_scope() !== parent
	            ) {
	                continue;
	            }

	            // defun is hoisted, so always safe
	            if (
	                def.assignments === 0
	                && def.orig.length === 1
	                && def.orig[0] instanceof AST_SymbolDefun
	            ) {
	                continue;
	            }

	            if (found_self_ref_in_other_defuns) {
	                def.fixed = false;
	                continue;
	            }

	            // for the slower checks below this loop
	            potential_conflicts.push({ defun, def, fname_def });
	            symbols_of_interest.add(def.id);
	            symbols_of_interest.add(fname_def.id);
	            defuns_of_interest.add(defun);
	        }
	    }

	    // linearize all symbols, and locate defs that are read after the defun
	    if (potential_conflicts.length) {
	        // All "symbols of interest", that is, defuns or defs, that we found.
	        // These are placed in order so we can check which is after which.
	        const found_symbols = [];
	        // Indices of `found_symbols` which are writes
	        const found_symbol_writes = new Set();
	        // Defun ranges are recorded because we don't care if a function uses the def internally
	        const defun_ranges = new Map();

	        let tw;
	        parent.walk((tw = new TreeWalker((node, descend) => {
	            if (node instanceof AST_Defun && defuns_of_interest.has(node)) {
	                const start = found_symbols.length;
	                descend();
	                const end = found_symbols.length;

	                defun_ranges.set(node, { start, end });
	                return true;
	            }
	            // if we found a defun on the list, mark IN_DEFUN=id and descend

	            if (node instanceof AST_Symbol && node.thedef) {
	                const id = node.definition().id;
	                if (symbols_of_interest.has(id)) {
	                    if (node instanceof AST_SymbolDeclaration || is_lhs(node, tw)) {
	                        found_symbol_writes.add(found_symbols.length);
	                    }
	                    found_symbols.push(id);
	                }
	            }
	        })));

	        for (const { def, defun, fname_def } of potential_conflicts) {
	            const defun_range = defun_ranges.get(defun);

	            // find the index in `found_symbols`, with some special rules:
	            const find = (sym_id, starting_at = 0, must_be_write = false) => {
	                let index = starting_at;

	                for (;;) {
	                    index = found_symbols.indexOf(sym_id, index);

	                    if (index === -1) {
	                        break;
	                    } else if (index >= defun_range.start && index < defun_range.end) {
	                        index = defun_range.end;
	                        continue;
	                    } else if (must_be_write && !found_symbol_writes.has(index)) {
	                        index++;
	                        continue;
	                    } else {
	                        break;
	                    }
	                }

	                return index;
	            };

	            const read_defun_at = find(fname_def.id);
	            const wrote_def_at = find(def.id, read_defun_at + 1, true);

	            const wrote_def_after_reading_defun = read_defun_at != -1 && wrote_def_at != -1 && wrote_def_at > read_defun_at;

	            if (wrote_def_after_reading_defun) {
	                def.fixed = false;
	            }
	        }
	    }
	}

	def_reduce_vars(AST_Lambda, mark_lambda);

	def_reduce_vars(AST_Do, function(tw, descend, compressor) {
	    reset_block_variables(compressor, this);
	    const saved_loop = tw.in_loop;
	    tw.in_loop = this;
	    push(tw);
	    this.body.walk(tw);
	    if (has_break_or_continue(this)) {
	        pop(tw);
	        push(tw);
	    }
	    this.condition.walk(tw);
	    pop(tw);
	    tw.in_loop = saved_loop;
	    return true;
	});

	def_reduce_vars(AST_For, function(tw, descend, compressor) {
	    reset_block_variables(compressor, this);
	    if (this.init) this.init.walk(tw);
	    const saved_loop = tw.in_loop;
	    tw.in_loop = this;
	    push(tw);
	    if (this.condition) this.condition.walk(tw);
	    this.body.walk(tw);
	    if (this.step) {
	        if (has_break_or_continue(this)) {
	            pop(tw);
	            push(tw);
	        }
	        this.step.walk(tw);
	    }
	    pop(tw);
	    tw.in_loop = saved_loop;
	    return true;
	});

	def_reduce_vars(AST_ForIn, function(tw, descend, compressor) {
	    reset_block_variables(compressor, this);
	    suppress(this.init);
	    this.object.walk(tw);
	    const saved_loop = tw.in_loop;
	    tw.in_loop = this;
	    push(tw);
	    this.body.walk(tw);
	    pop(tw);
	    tw.in_loop = saved_loop;
	    return true;
	});

	def_reduce_vars(AST_If, function(tw) {
	    this.condition.walk(tw);
	    push(tw);
	    this.body.walk(tw);
	    pop(tw);
	    if (this.alternative) {
	        push(tw);
	        this.alternative.walk(tw);
	        pop(tw);
	    }
	    return true;
	});

	def_reduce_vars(AST_LabeledStatement, function(tw) {
	    push(tw);
	    this.body.walk(tw);
	    pop(tw);
	    return true;
	});

	def_reduce_vars(AST_SymbolCatch, function() {
	    this.definition().fixed = false;
	});

	def_reduce_vars(AST_SymbolRef, function(tw, descend, compressor) {
	    var d = this.definition();
	    d.references.push(this);
	    if (d.references.length == 1
	        && !d.fixed
	        && d.orig[0] instanceof AST_SymbolDefun) {
	        tw.loop_ids.set(d.id, tw.in_loop);
	    }
	    var fixed_value;
	    if (d.fixed === undefined || !safe_to_read(tw, d)) {
	        d.fixed = false;
	    } else if (d.fixed) {
	        fixed_value = this.fixed_value();
	        if (
	            fixed_value instanceof AST_Lambda
	            && is_recursive_ref(tw, d)
	        ) {
	            d.recursive_refs++;
	        } else if (fixed_value
	            && !compressor.exposed(d)
	            && ref_once(tw, compressor, d)
	        ) {
	            d.single_use =
	                fixed_value instanceof AST_Lambda && !fixed_value.pinned()
	                || fixed_value instanceof AST_Class
	                || d.scope === this.scope && fixed_value.is_constant_expression();
	        } else {
	            d.single_use = false;
	        }
	        if (is_modified(compressor, tw, this, fixed_value, 0, is_immutable(fixed_value))) {
	            if (d.single_use) {
	                d.single_use = "m";
	            } else {
	                d.fixed = false;
	            }
	        }
	    }
	    mark_escaped(tw, d, this.scope, this, fixed_value, 0, 1);
	});

	def_reduce_vars(AST_Toplevel, function(tw, descend, compressor) {
	    this.globals.forEach(function(def) {
	        reset_def(compressor, def);
	    });
	    reset_variables(tw, compressor, this);
	    descend();
	    handle_defined_after_hoist(this);
	    return true;
	});

	def_reduce_vars(AST_Try, function(tw, descend, compressor) {
	    reset_block_variables(compressor, this);
	    push(tw);
	    this.body.walk(tw);
	    pop(tw);
	    if (this.bcatch) {
	        push(tw);
	        this.bcatch.walk(tw);
	        pop(tw);
	    }
	    if (this.bfinally) this.bfinally.walk(tw);
	    return true;
	});

	def_reduce_vars(AST_Unary, function(tw) {
	    var node = this;
	    if (node.operator !== "++" && node.operator !== "--") return;
	    var exp = node.expression;
	    if (!(exp instanceof AST_SymbolRef)) return;
	    var def = exp.definition();
	    var safe = safe_to_assign(tw, def, exp.scope, true);
	    def.assignments++;
	    if (!safe) return;
	    var fixed = def.fixed;
	    if (!fixed) return;
	    def.references.push(exp);
	    def.chained = true;
	    def.fixed = function() {
	        return make_node(AST_Binary, node, {
	            operator: node.operator.slice(0, -1),
	            left: make_node(AST_UnaryPrefix, node, {
	                operator: "+",
	                expression: fixed instanceof AST_Node ? fixed : fixed()
	            }),
	            right: make_node(AST_Number, node, {
	                value: 1
	            })
	        });
	    };
	    mark(tw, def, true);
	    return true;
	});

	def_reduce_vars(AST_VarDef, function(tw, descend) {
	    var node = this;
	    if (node.name instanceof AST_Destructuring) {
	        suppress(node.name);
	        return;
	    }
	    var d = node.name.definition();
	    if (node.value) {
	        if (safe_to_assign(tw, d, node.name.scope, node.value)) {
	            d.fixed = function() {
	                return node.value;
	            };
	            tw.loop_ids.set(d.id, tw.in_loop);
	            mark(tw, d, false);
	            descend();
	            mark(tw, d, true);
	            return true;
	        } else {
	            d.fixed = false;
	        }
	    }
	});

	def_reduce_vars(AST_While, function(tw, descend, compressor) {
	    reset_block_variables(compressor, this);
	    const saved_loop = tw.in_loop;
	    tw.in_loop = this;
	    push(tw);
	    descend();
	    pop(tw);
	    tw.in_loop = saved_loop;
	    return true;
	});

	/***********************************************************************

	  A JavaScript tokenizer / parser / beautifier / compressor.
	  https://github.com/mishoo/UglifyJS2

	  -------------------------------- (C) ---------------------------------

	                           Author: Mihai Bazon
	                         <mihai.bazon@gmail.com>
	                       http://mihai.bazon.net/blog

	  Distributed under the BSD license:

	    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

	    Redistribution and use in source and binary forms, with or without
	    modification, are permitted provided that the following conditions
	    are met:

	        * Redistributions of source code must retain the above
	          copyright notice, this list of conditions and the following
	          disclaimer.

	        * Redistributions in binary form must reproduce the above
	          copyright notice, this list of conditions and the following
	          disclaimer in the documentation and/or other materials
	          provided with the distribution.

	    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
	    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
	    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
	    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
	    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
	    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
	    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
	    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
	    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
	    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
	    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
	    SUCH DAMAGE.

	 ***********************************************************************/

	function loop_body(x) {
	    if (x instanceof AST_IterationStatement) {
	        return x.body instanceof AST_BlockStatement ? x.body : x;
	    }
	    return x;
	}

	function is_lhs_read_only(lhs) {
	    if (lhs instanceof AST_This) return true;
	    if (lhs instanceof AST_SymbolRef) return lhs.definition().orig[0] instanceof AST_SymbolLambda;
	    if (lhs instanceof AST_PropAccess) {
	        lhs = lhs.expression;
	        if (lhs instanceof AST_SymbolRef) {
	            if (lhs.is_immutable()) return false;
	            lhs = lhs.fixed_value();
	        }
	        if (!lhs) return true;
	        if (lhs instanceof AST_RegExp) return false;
	        if (lhs instanceof AST_Constant) return true;
	        return is_lhs_read_only(lhs);
	    }
	    return false;
	}

	/** var a = 1 --> var a*/
	function remove_initializers(var_statement) {
	    var decls = [];
	    var_statement.definitions.forEach(function(def) {
	        if (def.name instanceof AST_SymbolDeclaration) {
	            def.value = null;
	            decls.push(def);
	        } else {
	            def.declarations_as_names().forEach(name => {
	                decls.push(make_node(AST_VarDef, def, {
	                    name,
	                    value: null
	                }));
	            });
	        }
	    });
	    return decls.length ? make_node(AST_Var, var_statement, { definitions: decls }) : null;
	}

	/** Called on code which we know is unreachable, to keep elements that affect outside of it. */
	function trim_unreachable_code(compressor, stat, target) {
	    walk(stat, node => {
	        if (node instanceof AST_Var) {
	            const no_initializers = remove_initializers(node);
	            if (no_initializers) target.push(no_initializers);
	            return true;
	        }
	        if (
	            node instanceof AST_Defun
	            && (node === stat || !compressor.has_directive("use strict"))
	        ) {
	            target.push(node === stat ? node : make_node(AST_Var, node, {
	                definitions: [
	                    make_node(AST_VarDef, node, {
	                        name: make_node(AST_SymbolVar, node.name, node.name),
	                        value: null
	                    })
	                ]
	            }));
	            return true;
	        }
	        if (node instanceof AST_Export || node instanceof AST_Import) {
	            target.push(node);
	            return true;
	        }
	        if (node instanceof AST_Scope) {
	            return true;
	        }
	    });
	}

	/** Tighten a bunch of statements together, and perform statement-level optimization. */
	function tighten_body(statements, compressor) {
	    const nearest_scope = compressor.find_scope();
	    const defun_scope = nearest_scope.get_defun_scope();
	    const { in_loop, in_try } = find_loop_scope_try();

	    var CHANGED, max_iter = 10;
	    do {
	        CHANGED = false;
	        eliminate_spurious_blocks(statements);
	        if (compressor.option("dead_code")) {
	            eliminate_dead_code(statements, compressor);
	        }
	        if (compressor.option("if_return")) {
	            handle_if_return(statements, compressor);
	        }
	        if (compressor.sequences_limit > 0) {
	            sequencesize(statements, compressor);
	            sequencesize_2(statements, compressor);
	        }
	        if (compressor.option("join_vars")) {
	            join_consecutive_vars(statements);
	        }
	        if (compressor.option("collapse_vars")) {
	            collapse(statements, compressor);
	        }
	    } while (CHANGED && max_iter-- > 0);

	    function find_loop_scope_try() {
	        var node = compressor.self(), level = 0, in_loop = false, in_try = false;
	        do {
	            if (node instanceof AST_IterationStatement) {
	                in_loop = true;
	            } else if (node instanceof AST_Scope) {
	                break;
	            } else if (node instanceof AST_TryBlock) {
	                in_try = true;
	            }
	        } while (node = compressor.parent(level++));

	        return { in_loop, in_try };
	    }

	    // Search from right to left for assignment-like expressions:
	    // - `var a = x;`
	    // - `a = x;`
	    // - `++a`
	    // For each candidate, scan from left to right for first usage, then try
	    // to fold assignment into the site for compression.
	    // Will not attempt to collapse assignments into or past code blocks
	    // which are not sequentially executed, e.g. loops and conditionals.
	    function collapse(statements, compressor) {
	        if (nearest_scope.pinned() || defun_scope.pinned())
	            return statements;
	        var args;
	        var candidates = [];
	        var stat_index = statements.length;
	        var scanner = new TreeTransformer(function (node) {
	            if (abort)
	                return node;
	            // Skip nodes before `candidate` as quickly as possible
	            if (!hit) {
	                if (node !== hit_stack[hit_index])
	                    return node;
	                hit_index++;
	                if (hit_index < hit_stack.length)
	                    return handle_custom_scan_order(node);
	                hit = true;
	                stop_after = find_stop(node, 0);
	                if (stop_after === node)
	                    abort = true;
	                return node;
	            }
	            // Stop immediately if these node types are encountered
	            var parent = scanner.parent();
	            if (node instanceof AST_Assign
	                    && (node.logical || node.operator != "=" && lhs.equivalent_to(node.left))
	                || node instanceof AST_Await
	                || node instanceof AST_Call && lhs instanceof AST_PropAccess && lhs.equivalent_to(node.expression)
	                ||
	                    (node instanceof AST_Call || node instanceof AST_PropAccess)
	                    && node.optional
	                || node instanceof AST_Debugger
	                || node instanceof AST_Destructuring
	                || node instanceof AST_Expansion
	                    && node.expression instanceof AST_Symbol
	                    && (
	                        node.expression instanceof AST_This
	                        || node.expression.definition().references.length > 1
	                    )
	                || node instanceof AST_IterationStatement && !(node instanceof AST_For)
	                || node instanceof AST_LoopControl
	                || node instanceof AST_Try
	                || node instanceof AST_With
	                || node instanceof AST_Yield
	                || node instanceof AST_Export
	                || node instanceof AST_Class
	                || parent instanceof AST_For && node !== parent.init
	                || !replace_all
	                    && (
	                        node instanceof AST_SymbolRef
	                        && !node.is_declared(compressor)
	                        && !pure_prop_access_globals.has(node)
	                    )
	                || node instanceof AST_SymbolRef
	                    && parent instanceof AST_Call
	                    && has_annotation(parent, _NOINLINE)
	                || node instanceof AST_ObjectProperty && node.key instanceof AST_Node
	            ) {
	                abort = true;
	                return node;
	            }
	            // Stop only if candidate is found within conditional branches
	            if (!stop_if_hit && (!lhs_local || !replace_all)
	                && (parent instanceof AST_Binary && lazy_op.has(parent.operator) && parent.left !== node
	                    || parent instanceof AST_Conditional && parent.condition !== node
	                    || parent instanceof AST_If && parent.condition !== node)) {
	                stop_if_hit = parent;
	            }
	            // Replace variable with assignment when found
	            if (
	                can_replace
	                && !(node instanceof AST_SymbolDeclaration)
	                && lhs.equivalent_to(node)
	                && !shadows(scanner.find_scope() || nearest_scope, lvalues)
	            ) {
	                if (stop_if_hit) {
	                    abort = true;
	                    return node;
	                }
	                if (is_lhs(node, parent)) {
	                    if (value_def)
	                        replaced++;
	                    return node;
	                } else {
	                    replaced++;
	                    if (value_def && candidate instanceof AST_VarDef)
	                        return node;
	                }
	                CHANGED = abort = true;
	                if (candidate instanceof AST_UnaryPostfix) {
	                    return make_node(AST_UnaryPrefix, candidate, candidate);
	                }
	                if (candidate instanceof AST_VarDef) {
	                    var def = candidate.name.definition();
	                    var value = candidate.value;
	                    if (def.references.length - def.replaced == 1 && !compressor.exposed(def)) {
	                        def.replaced++;
	                        if (funarg && is_identifier_atom(value)) {
	                            return value.transform(compressor);
	                        } else {
	                            return maintain_this_binding(parent, node, value);
	                        }
	                    }
	                    return make_node(AST_Assign, candidate, {
	                        operator: "=",
	                        logical: false,
	                        left: make_node(AST_SymbolRef, candidate.name, candidate.name),
	                        right: value
	                    });
	                }
	                clear_flag(candidate, WRITE_ONLY);
	                return candidate;
	            }
	            // These node types have child nodes that execute sequentially,
	            // but are otherwise not safe to scan into or beyond them.
	            var sym;
	            if (node instanceof AST_Call
	                || node instanceof AST_Exit
	                && (side_effects || lhs instanceof AST_PropAccess || may_modify(lhs))
	                || node instanceof AST_PropAccess
	                && (side_effects || node.expression.may_throw_on_access(compressor))
	                || node instanceof AST_SymbolRef
	                && ((lvalues.has(node.name) && lvalues.get(node.name).modified) || side_effects && may_modify(node))
	                || node instanceof AST_VarDef && node.value
	                && (lvalues.has(node.name.name) || side_effects && may_modify(node.name))
	                || (sym = is_lhs(node.left, node))
	                && (sym instanceof AST_PropAccess || lvalues.has(sym.name))
	                || may_throw
	                && (in_try ? node.has_side_effects(compressor) : side_effects_external(node))) {
	                stop_after = node;
	                if (node instanceof AST_Scope)
	                    abort = true;
	            }
	            return handle_custom_scan_order(node);
	        }, function (node) {
	            if (abort)
	                return;
	            if (stop_after === node)
	                abort = true;
	            if (stop_if_hit === node)
	                stop_if_hit = null;
	        });

	        var multi_replacer = new TreeTransformer(function (node) {
	            if (abort)
	                return node;
	            // Skip nodes before `candidate` as quickly as possible
	            if (!hit) {
	                if (node !== hit_stack[hit_index])
	                    return node;
	                hit_index++;
	                if (hit_index < hit_stack.length)
	                    return;
	                hit = true;
	                return node;
	            }
	            // Replace variable when found
	            if (node instanceof AST_SymbolRef
	                && node.name == def.name) {
	                if (!--replaced)
	                    abort = true;
	                if (is_lhs(node, multi_replacer.parent()))
	                    return node;
	                def.replaced++;
	                value_def.replaced--;
	                return candidate.value;
	            }
	            // Skip (non-executed) functions and (leading) default case in switch statements
	            if (node instanceof AST_Default || node instanceof AST_Scope)
	                return node;
	        });

	        while (--stat_index >= 0) {
	            // Treat parameters as collapsible in IIFE, i.e.
	            //   function(a, b){ ... }(x());
	            // would be translated into equivalent assignments:
	            //   var a = x(), b = undefined;
	            if (stat_index == 0 && compressor.option("unused"))
	                extract_args();
	            // Find collapsible assignments
	            var hit_stack = [];
	            extract_candidates(statements[stat_index]);
	            while (candidates.length > 0) {
	                hit_stack = candidates.pop();
	                var hit_index = 0;
	                var candidate = hit_stack[hit_stack.length - 1];
	                var value_def = null;
	                var stop_after = null;
	                var stop_if_hit = null;
	                var lhs = get_lhs(candidate);
	                if (!lhs || is_lhs_read_only(lhs) || lhs.has_side_effects(compressor))
	                    continue;
	                // Locate symbols which may execute code outside of scanning range
	                var lvalues = get_lvalues(candidate);
	                var lhs_local = is_lhs_local(lhs);
	                if (lhs instanceof AST_SymbolRef) {
	                    lvalues.set(lhs.name, { def: lhs.definition(), modified: false });
	                }
	                var side_effects = value_has_side_effects(candidate);
	                var replace_all = replace_all_symbols();
	                var may_throw = candidate.may_throw(compressor);
	                var funarg = candidate.name instanceof AST_SymbolFunarg;
	                var hit = funarg;
	                var abort = false, replaced = 0, can_replace = !args || !hit;
	                if (!can_replace) {
	                    for (
	                        let j = compressor.self().argnames.lastIndexOf(candidate.name) + 1;
	                        !abort && j < args.length;
	                        j++
	                    ) {
	                        args[j].transform(scanner);
	                    }
	                    can_replace = true;
	                }
	                for (var i = stat_index; !abort && i < statements.length; i++) {
	                    statements[i].transform(scanner);
	                }
	                if (value_def) {
	                    var def = candidate.name.definition();
	                    if (abort && def.references.length - def.replaced > replaced)
	                        replaced = false;
	                    else {
	                        abort = false;
	                        hit_index = 0;
	                        hit = funarg;
	                        for (var i = stat_index; !abort && i < statements.length; i++) {
	                            statements[i].transform(multi_replacer);
	                        }
	                        value_def.single_use = false;
	                    }
	                }
	                if (replaced && !remove_candidate(candidate))
	                    statements.splice(stat_index, 1);
	            }
	        }

	        function handle_custom_scan_order(node) {
	            // Skip (non-executed) functions
	            if (node instanceof AST_Scope)
	                return node;

	            // Scan case expressions first in a switch statement
	            if (node instanceof AST_Switch) {
	                node.expression = node.expression.transform(scanner);
	                for (var i = 0, len = node.body.length; !abort && i < len; i++) {
	                    var branch = node.body[i];
	                    if (branch instanceof AST_Case) {
	                        if (!hit) {
	                            if (branch !== hit_stack[hit_index])
	                                continue;
	                            hit_index++;
	                        }
	                        branch.expression = branch.expression.transform(scanner);
	                        if (!replace_all)
	                            break;
	                    }
	                }
	                abort = true;
	                return node;
	            }
	        }

	        function redefined_within_scope(def, scope) {
	            if (def.global)
	                return false;
	            let cur_scope = def.scope;
	            while (cur_scope && cur_scope !== scope) {
	                if (cur_scope.variables.has(def.name)) {
	                    return true;
	                }
	                cur_scope = cur_scope.parent_scope;
	            }
	            return false;
	        }

	        function has_overlapping_symbol(fn, arg, fn_strict) {
	            var found = false, scan_this = !(fn instanceof AST_Arrow);
	            arg.walk(new TreeWalker(function (node, descend) {
	                if (found)
	                    return true;
	                if (node instanceof AST_SymbolRef && (fn.variables.has(node.name) || redefined_within_scope(node.definition(), fn))) {
	                    var s = node.definition().scope;
	                    if (s !== defun_scope)
	                        while (s = s.parent_scope) {
	                            if (s === defun_scope)
	                                return true;
	                        }
	                    return found = true;
	                }
	                if ((fn_strict || scan_this) && node instanceof AST_This) {
	                    return found = true;
	                }
	                if (node instanceof AST_Scope && !(node instanceof AST_Arrow)) {
	                    var prev = scan_this;
	                    scan_this = false;
	                    descend();
	                    scan_this = prev;
	                    return true;
	                }
	            }));
	            return found;
	        }

	        function arg_is_injectable(arg) {
	            if (arg instanceof AST_Expansion) return false;
	            const contains_await = walk(arg, (node) => {
	                if (node instanceof AST_Await) return walk_abort;
	            });
	            if (contains_await) return false;
	            return true;
	        }
	        function extract_args() {
	            var iife, fn = compressor.self();
	            if (is_func_expr(fn)
	                && !fn.name
	                && !fn.uses_arguments
	                && !fn.pinned()
	                && (iife = compressor.parent()) instanceof AST_Call
	                && iife.expression === fn
	                && iife.args.every(arg_is_injectable)
	            ) {
	                var fn_strict = compressor.has_directive("use strict");
	                if (fn_strict && !member(fn_strict, fn.body))
	                    fn_strict = false;
	                var len = fn.argnames.length;
	                args = iife.args.slice(len);
	                var names = new Set();
	                for (var i = len; --i >= 0;) {
	                    var sym = fn.argnames[i];
	                    var arg = iife.args[i];
	                    // The following two line fix is a duplicate of the fix at
	                    // https://github.com/terser/terser/commit/011d3eb08cefe6922c7d1bdfa113fc4aeaca1b75
	                    // This might mean that these two pieces of code (one here in collapse_vars and another in reduce_vars
	                    // Might be doing the exact same thing.
	                    const def = sym.definition && sym.definition();
	                    const is_reassigned = def && def.orig.length > 1;
	                    if (is_reassigned)
	                        continue;
	                    args.unshift(make_node(AST_VarDef, sym, {
	                        name: sym,
	                        value: arg
	                    }));
	                    if (names.has(sym.name))
	                        continue;
	                    names.add(sym.name);
	                    if (sym instanceof AST_Expansion) {
	                        var elements = iife.args.slice(i);
	                        if (elements.every((arg) => !has_overlapping_symbol(fn, arg, fn_strict)
	                        )) {
	                            candidates.unshift([make_node(AST_VarDef, sym, {
	                                name: sym.expression,
	                                value: make_node(AST_Array, iife, {
	                                    elements: elements
	                                })
	                            })]);
	                        }
	                    } else {
	                        if (!arg) {
	                            arg = make_node(AST_Undefined, sym).transform(compressor);
	                        } else if (arg instanceof AST_Lambda && arg.pinned()
	                            || has_overlapping_symbol(fn, arg, fn_strict)) {
	                            arg = null;
	                        }
	                        if (arg)
	                            candidates.unshift([make_node(AST_VarDef, sym, {
	                                name: sym,
	                                value: arg
	                            })]);
	                    }
	                }
	            }
	        }

	        function extract_candidates(expr) {
	            hit_stack.push(expr);
	            if (expr instanceof AST_Assign) {
	                if (!expr.left.has_side_effects(compressor)
	                    && !(expr.right instanceof AST_Chain)) {
	                    candidates.push(hit_stack.slice());
	                }
	                extract_candidates(expr.right);
	            } else if (expr instanceof AST_Binary) {
	                extract_candidates(expr.left);
	                extract_candidates(expr.right);
	            } else if (expr instanceof AST_Call && !has_annotation(expr, _NOINLINE)) {
	                extract_candidates(expr.expression);
	                expr.args.forEach(extract_candidates);
	            } else if (expr instanceof AST_Case) {
	                extract_candidates(expr.expression);
	            } else if (expr instanceof AST_Conditional) {
	                extract_candidates(expr.condition);
	                extract_candidates(expr.consequent);
	                extract_candidates(expr.alternative);
	            } else if (expr instanceof AST_Definitions) {
	                var len = expr.definitions.length;
	                // limit number of trailing variable definitions for consideration
	                var i = len - 200;
	                if (i < 0)
	                    i = 0;
	                for (; i < len; i++) {
	                    extract_candidates(expr.definitions[i]);
	                }
	            } else if (expr instanceof AST_DWLoop) {
	                extract_candidates(expr.condition);
	                if (!(expr.body instanceof AST_Block)) {
	                    extract_candidates(expr.body);
	                }
	            } else if (expr instanceof AST_Exit) {
	                if (expr.value)
	                    extract_candidates(expr.value);
	            } else if (expr instanceof AST_For) {
	                if (expr.init)
	                    extract_candidates(expr.init);
	                if (expr.condition)
	                    extract_candidates(expr.condition);
	                if (expr.step)
	                    extract_candidates(expr.step);
	                if (!(expr.body instanceof AST_Block)) {
	                    extract_candidates(expr.body);
	                }
	            } else if (expr instanceof AST_ForIn) {
	                extract_candidates(expr.object);
	                if (!(expr.body instanceof AST_Block)) {
	                    extract_candidates(expr.body);
	                }
	            } else if (expr instanceof AST_If) {
	                extract_candidates(expr.condition);
	                if (!(expr.body instanceof AST_Block)) {
	                    extract_candidates(expr.body);
	                }
	                if (expr.alternative && !(expr.alternative instanceof AST_Block)) {
	                    extract_candidates(expr.alternative);
	                }
	            } else if (expr instanceof AST_Sequence) {
	                expr.expressions.forEach(extract_candidates);
	            } else if (expr instanceof AST_SimpleStatement) {
	                extract_candidates(expr.body);
	            } else if (expr instanceof AST_Switch) {
	                extract_candidates(expr.expression);
	                expr.body.forEach(extract_candidates);
	            } else if (expr instanceof AST_Unary) {
	                if (expr.operator == "++" || expr.operator == "--") {
	                    candidates.push(hit_stack.slice());
	                }
	            } else if (expr instanceof AST_VarDef) {
	                if (expr.value && !(expr.value instanceof AST_Chain)) {
	                    candidates.push(hit_stack.slice());
	                    extract_candidates(expr.value);
	                }
	            }
	            hit_stack.pop();
	        }

	        function find_stop(node, level, write_only) {
	            var parent = scanner.parent(level);
	            if (parent instanceof AST_Assign) {
	                if (write_only
	                    && !parent.logical
	                    && !(parent.left instanceof AST_PropAccess
	                        || lvalues.has(parent.left.name))) {
	                    return find_stop(parent, level + 1, write_only);
	                }
	                return node;
	            }
	            if (parent instanceof AST_Binary) {
	                if (write_only && (!lazy_op.has(parent.operator) || parent.left === node)) {
	                    return find_stop(parent, level + 1, write_only);
	                }
	                return node;
	            }
	            if (parent instanceof AST_Call)
	                return node;
	            if (parent instanceof AST_Case)
	                return node;
	            if (parent instanceof AST_Conditional) {
	                if (write_only && parent.condition === node) {
	                    return find_stop(parent, level + 1, write_only);
	                }
	                return node;
	            }
	            if (parent instanceof AST_Definitions) {
	                return find_stop(parent, level + 1, true);
	            }
	            if (parent instanceof AST_Exit) {
	                return write_only ? find_stop(parent, level + 1, write_only) : node;
	            }
	            if (parent instanceof AST_If) {
	                if (write_only && parent.condition === node) {
	                    return find_stop(parent, level + 1, write_only);
	                }
	                return node;
	            }
	            if (parent instanceof AST_IterationStatement)
	                return node;
	            if (parent instanceof AST_Sequence) {
	                return find_stop(parent, level + 1, parent.tail_node() !== node);
	            }
	            if (parent instanceof AST_SimpleStatement) {
	                return find_stop(parent, level + 1, true);
	            }
	            if (parent instanceof AST_Switch)
	                return node;
	            if (parent instanceof AST_VarDef)
	                return node;
	            return null;
	        }

	        function mangleable_var(var_def) {
	            var value = var_def.value;
	            if (!(value instanceof AST_SymbolRef))
	                return;
	            if (value.name == "arguments")
	                return;
	            var def = value.definition();
	            if (def.undeclared)
	                return;
	            return value_def = def;
	        }

	        function get_lhs(expr) {
	            if (expr instanceof AST_Assign && expr.logical) {
	                return false;
	            } else if (expr instanceof AST_VarDef && expr.name instanceof AST_SymbolDeclaration) {
	                var def = expr.name.definition();
	                if (!member(expr.name, def.orig))
	                    return;
	                var referenced = def.references.length - def.replaced;
	                if (!referenced)
	                    return;
	                var declared = def.orig.length - def.eliminated;
	                if (declared > 1 && !(expr.name instanceof AST_SymbolFunarg)
	                    || (referenced > 1 ? mangleable_var(expr) : !compressor.exposed(def))) {
	                    return make_node(AST_SymbolRef, expr.name, expr.name);
	                }
	            } else {
	                const lhs = expr instanceof AST_Assign
	                    ? expr.left
	                    : expr.expression;
	                return !is_ref_of(lhs, AST_SymbolConst)
	                    && !is_ref_of(lhs, AST_SymbolLet) && lhs;
	            }
	        }

	        function get_rvalue(expr) {
	            if (expr instanceof AST_Assign) {
	                return expr.right;
	            } else {
	                return expr.value;
	            }
	        }

	        function get_lvalues(expr) {
	            var lvalues = new Map();
	            if (expr instanceof AST_Unary)
	                return lvalues;
	            var tw = new TreeWalker(function (node) {
	                var sym = node;
	                while (sym instanceof AST_PropAccess)
	                    sym = sym.expression;
	                if (sym instanceof AST_SymbolRef) {
	                    const prev = lvalues.get(sym.name);
	                    if (!prev || !prev.modified) {
	                        lvalues.set(sym.name, {
	                            def: sym.definition(),
	                            modified: is_modified(compressor, tw, node, node, 0)
	                        });
	                    }
	                }
	            });
	            get_rvalue(expr).walk(tw);
	            return lvalues;
	        }

	        function remove_candidate(expr) {
	            if (expr.name instanceof AST_SymbolFunarg) {
	                var iife = compressor.parent(), argnames = compressor.self().argnames;
	                var index = argnames.indexOf(expr.name);
	                if (index < 0) {
	                    iife.args.length = Math.min(iife.args.length, argnames.length - 1);
	                } else {
	                    var args = iife.args;
	                    if (args[index])
	                        args[index] = make_node(AST_Number, args[index], {
	                            value: 0
	                        });
	                }
	                return true;
	            }
	            var found = false;
	            return statements[stat_index].transform(new TreeTransformer(function (node, descend, in_list) {
	                if (found)
	                    return node;
	                if (node === expr || node.body === expr) {
	                    found = true;
	                    if (node instanceof AST_VarDef) {
	                        node.value = node.name instanceof AST_SymbolConst
	                            ? make_node(AST_Undefined, node.value) // `const` always needs value.
	                            : null;
	                        return node;
	                    }
	                    return in_list ? MAP.skip : null;
	                }
	            }, function (node) {
	                if (node instanceof AST_Sequence)
	                    switch (node.expressions.length) {
	                        case 0: return null;
	                        case 1: return node.expressions[0];
	                    }
	            }));
	        }

	        function is_lhs_local(lhs) {
	            while (lhs instanceof AST_PropAccess)
	                lhs = lhs.expression;
	            return lhs instanceof AST_SymbolRef
	                && lhs.definition().scope.get_defun_scope() === defun_scope
	                && !(in_loop
	                    && (lvalues.has(lhs.name)
	                        || candidate instanceof AST_Unary
	                        || (candidate instanceof AST_Assign
	                            && !candidate.logical
	                            && candidate.operator != "=")));
	        }

	        function value_has_side_effects(expr) {
	            if (expr instanceof AST_Unary)
	                return unary_side_effects.has(expr.operator);
	            return get_rvalue(expr).has_side_effects(compressor);
	        }

	        function replace_all_symbols() {
	            if (side_effects)
	                return false;
	            if (value_def)
	                return true;
	            if (lhs instanceof AST_SymbolRef) {
	                var def = lhs.definition();
	                if (def.references.length - def.replaced == (candidate instanceof AST_VarDef ? 1 : 2)) {
	                    return true;
	                }
	            }
	            return false;
	        }

	        function may_modify(sym) {
	            if (!sym.definition)
	                return true; // AST_Destructuring
	            var def = sym.definition();
	            if (def.orig.length == 1 && def.orig[0] instanceof AST_SymbolDefun)
	                return false;
	            if (def.scope.get_defun_scope() !== defun_scope)
	                return true;
	            return def.references.some((ref) =>
	                ref.scope.get_defun_scope() !== defun_scope
	            );
	        }

	        function side_effects_external(node, lhs) {
	            if (node instanceof AST_Assign)
	                return side_effects_external(node.left, true);
	            if (node instanceof AST_Unary)
	                return side_effects_external(node.expression, true);
	            if (node instanceof AST_VarDef)
	                return node.value && side_effects_external(node.value);
	            if (lhs) {
	                if (node instanceof AST_Dot)
	                    return side_effects_external(node.expression, true);
	                if (node instanceof AST_Sub)
	                    return side_effects_external(node.expression, true);
	                if (node instanceof AST_SymbolRef)
	                    return node.definition().scope.get_defun_scope() !== defun_scope;
	            }
	            return false;
	        }

	        /**
	         * Will any of the pulled-in lvalues shadow a variable in newScope or parents?
	         * similar to scope_encloses_variables_in_this_scope */
	        function shadows(my_scope, lvalues) {
	            for (const { def } of lvalues.values()) {
	                const looked_up = my_scope.find_variable(def.name);
	                if (looked_up) {
	                    if (looked_up === def) continue;
	                    return true;
	                }
	            }
	            return false;
	        }
	    }

	    function eliminate_spurious_blocks(statements) {
	        var seen_dirs = [];
	        for (var i = 0; i < statements.length;) {
	            var stat = statements[i];
	            if (stat instanceof AST_BlockStatement && stat.body.every(can_be_evicted_from_block)) {
	                CHANGED = true;
	                eliminate_spurious_blocks(stat.body);
	                statements.splice(i, 1, ...stat.body);
	                i += stat.body.length;
	            } else if (stat instanceof AST_EmptyStatement) {
	                CHANGED = true;
	                statements.splice(i, 1);
	            } else if (stat instanceof AST_Directive) {
	                if (seen_dirs.indexOf(stat.value) < 0) {
	                    i++;
	                    seen_dirs.push(stat.value);
	                } else {
	                    CHANGED = true;
	                    statements.splice(i, 1);
	                }
	            } else
	                i++;
	        }
	    }

	    function handle_if_return(statements, compressor) {
	        var self = compressor.self();
	        var multiple_if_returns = has_multiple_if_returns(statements);
	        var in_lambda = self instanceof AST_Lambda;
	        // Prevent extremely deep nesting
	        // https://github.com/terser/terser/issues/1432
	        // https://github.com/webpack/webpack/issues/17548
	        const iteration_start = Math.min(statements.length, 500);
	        for (var i = iteration_start; --i >= 0;) {
	            var stat = statements[i];
	            var j = next_index(i);
	            var next = statements[j];

	            if (in_lambda && !next && stat instanceof AST_Return) {
	                if (!stat.value) {
	                    CHANGED = true;
	                    statements.splice(i, 1);
	                    continue;
	                }
	                if (stat.value instanceof AST_UnaryPrefix && stat.value.operator == "void") {
	                    CHANGED = true;
	                    statements[i] = make_node(AST_SimpleStatement, stat, {
	                        body: stat.value.expression
	                    });
	                    continue;
	                }
	            }

	            if (stat instanceof AST_If) {
	                let ab, new_else;

	                ab = aborts(stat.body);
	                if (
	                    can_merge_flow(ab)
	                    && (new_else = as_statement_array_with_return(stat.body, ab))
	                ) {
	                    if (ab.label) {
	                        remove(ab.label.thedef.references, ab);
	                    }
	                    CHANGED = true;
	                    stat = stat.clone();
	                    stat.condition = stat.condition.negate(compressor);
	                    stat.body = make_node(AST_BlockStatement, stat, {
	                        body: as_statement_array(stat.alternative).concat(extract_functions())
	                    });
	                    stat.alternative = make_node(AST_BlockStatement, stat, {
	                        body: new_else
	                    });
	                    statements[i] = stat.transform(compressor);
	                    continue;
	                }

	                ab = aborts(stat.alternative);
	                if (
	                    can_merge_flow(ab)
	                    && (new_else = as_statement_array_with_return(stat.alternative, ab))
	                ) {
	                    if (ab.label) {
	                        remove(ab.label.thedef.references, ab);
	                    }
	                    CHANGED = true;
	                    stat = stat.clone();
	                    stat.body = make_node(AST_BlockStatement, stat.body, {
	                        body: as_statement_array(stat.body).concat(extract_functions())
	                    });
	                    stat.alternative = make_node(AST_BlockStatement, stat.alternative, {
	                        body: new_else
	                    });
	                    statements[i] = stat.transform(compressor);
	                    continue;
	                }
	            }

	            if (stat instanceof AST_If && stat.body instanceof AST_Return) {
	                var value = stat.body.value;
	                //---
	                // pretty silly case, but:
	                // if (foo()) return; return; ==> foo(); return;
	                if (!value && !stat.alternative
	                    && (in_lambda && !next || next instanceof AST_Return && !next.value)) {
	                    CHANGED = true;
	                    statements[i] = make_node(AST_SimpleStatement, stat.condition, {
	                        body: stat.condition
	                    });
	                    continue;
	                }
	                //---
	                // if (foo()) return x; return y; ==> return foo() ? x : y;
	                if (value && !stat.alternative && next instanceof AST_Return && next.value) {
	                    CHANGED = true;
	                    stat = stat.clone();
	                    stat.alternative = next;
	                    statements[i] = stat.transform(compressor);
	                    statements.splice(j, 1);
	                    continue;
	                }
	                //---
	                // if (foo()) return x; [ return ; ] ==> return foo() ? x : undefined;
	                if (value && !stat.alternative
	                    && (!next && in_lambda && multiple_if_returns
	                        || next instanceof AST_Return)) {
	                    CHANGED = true;
	                    stat = stat.clone();
	                    stat.alternative = next || make_node(AST_Return, stat, {
	                        value: null
	                    });
	                    statements[i] = stat.transform(compressor);
	                    if (next)
	                        statements.splice(j, 1);
	                    continue;
	                }
	                //---
	                // if (a) return b; if (c) return d; e; ==> return a ? b : c ? d : void e;
	                //
	                // if sequences is not enabled, this can lead to an endless loop (issue #866).
	                // however, with sequences on this helps producing slightly better output for
	                // the example code.
	                var prev = statements[prev_index(i)];
	                if (compressor.option("sequences") && in_lambda && !stat.alternative
	                    && prev instanceof AST_If && prev.body instanceof AST_Return
	                    && next_index(j) == statements.length && next instanceof AST_SimpleStatement) {
	                    CHANGED = true;
	                    stat = stat.clone();
	                    stat.alternative = make_node(AST_BlockStatement, next, {
	                        body: [
	                            next,
	                            make_node(AST_Return, next, {
	                                value: null
	                            })
	                        ]
	                    });
	                    statements[i] = stat.transform(compressor);
	                    statements.splice(j, 1);
	                    continue;
	                }
	            }
	        }

	        function has_multiple_if_returns(statements) {
	            var n = 0;
	            for (var i = statements.length; --i >= 0;) {
	                var stat = statements[i];
	                if (stat instanceof AST_If && stat.body instanceof AST_Return) {
	                    if (++n > 1)
	                        return true;
	                }
	            }
	            return false;
	        }

	        function is_return_void(value) {
	            return !value || value instanceof AST_UnaryPrefix && value.operator == "void";
	        }

	        function can_merge_flow(ab) {
	            if (!ab)
	                return false;
	            for (var j = i + 1, len = statements.length; j < len; j++) {
	                var stat = statements[j];
	                if (stat instanceof AST_Const || stat instanceof AST_Let)
	                    return false;
	            }
	            var lct = ab instanceof AST_LoopControl ? compressor.loopcontrol_target(ab) : null;
	            return ab instanceof AST_Return && in_lambda && is_return_void(ab.value)
	                || ab instanceof AST_Continue && self === loop_body(lct)
	                || ab instanceof AST_Break && lct instanceof AST_BlockStatement && self === lct;
	        }

	        function extract_functions() {
	            var tail = statements.slice(i + 1);
	            statements.length = i + 1;
	            return tail.filter(function (stat) {
	                if (stat instanceof AST_Defun) {
	                    statements.push(stat);
	                    return false;
	                }
	                return true;
	            });
	        }

	        function as_statement_array_with_return(node, ab) {
	            var body = as_statement_array(node);
	            if (ab !== body[body.length - 1]) {
	                return undefined;
	            }
	            body = body.slice(0, -1);
	            if (ab.value) {
	                body.push(make_node(AST_SimpleStatement, ab.value, {
	                    body: ab.value.expression
	                }));
	            }
	            return body;
	        }

	        function next_index(i) {
	            for (var j = i + 1, len = statements.length; j < len; j++) {
	                var stat = statements[j];
	                if (!(stat instanceof AST_Var && declarations_only(stat))) {
	                    break;
	                }
	            }
	            return j;
	        }

	        function prev_index(i) {
	            for (var j = i; --j >= 0;) {
	                var stat = statements[j];
	                if (!(stat instanceof AST_Var && declarations_only(stat))) {
	                    break;
	                }
	            }
	            return j;
	        }
	    }

	    function eliminate_dead_code(statements, compressor) {
	        var has_quit;
	        var self = compressor.self();
	        for (var i = 0, n = 0, len = statements.length; i < len; i++) {
	            var stat = statements[i];
	            if (stat instanceof AST_LoopControl) {
	                var lct = compressor.loopcontrol_target(stat);
	                if (stat instanceof AST_Break
	                    && !(lct instanceof AST_IterationStatement)
	                    && loop_body(lct) === self
	                    || stat instanceof AST_Continue
	                    && loop_body(lct) === self) {
	                    if (stat.label) {
	                        remove(stat.label.thedef.references, stat);
	                    }
	                } else {
	                    statements[n++] = stat;
	                }
	            } else {
	                statements[n++] = stat;
	            }
	            if (aborts(stat)) {
	                has_quit = statements.slice(i + 1);
	                break;
	            }
	        }
	        statements.length = n;
	        CHANGED = n != len;
	        if (has_quit)
	            has_quit.forEach(function (stat) {
	                trim_unreachable_code(compressor, stat, statements);
	            });
	    }

	    function declarations_only(node) {
	        return node.definitions.every((var_def) => !var_def.value);
	    }

	    function sequencesize(statements, compressor) {
	        if (statements.length < 2)
	            return;
	        var seq = [], n = 0;
	        function push_seq() {
	            if (!seq.length)
	                return;
	            var body = make_sequence(seq[0], seq);
	            statements[n++] = make_node(AST_SimpleStatement, body, { body: body });
	            seq = [];
	        }
	        for (var i = 0, len = statements.length; i < len; i++) {
	            var stat = statements[i];
	            if (stat instanceof AST_SimpleStatement) {
	                if (seq.length >= compressor.sequences_limit)
	                    push_seq();
	                var body = stat.body;
	                if (seq.length > 0)
	                    body = body.drop_side_effect_free(compressor);
	                if (body)
	                    merge_sequence(seq, body);
	            } else if (stat instanceof AST_Definitions && declarations_only(stat)
	                || stat instanceof AST_Defun) {
	                statements[n++] = stat;
	            } else {
	                push_seq();
	                statements[n++] = stat;
	            }
	        }
	        push_seq();
	        statements.length = n;
	        if (n != len)
	            CHANGED = true;
	    }

	    function to_simple_statement(block, decls) {
	        if (!(block instanceof AST_BlockStatement))
	            return block;
	        var stat = null;
	        for (var i = 0, len = block.body.length; i < len; i++) {
	            var line = block.body[i];
	            if (line instanceof AST_Var && declarations_only(line)) {
	                decls.push(line);
	            } else if (stat || line instanceof AST_Const || line instanceof AST_Let) {
	                return false;
	            } else {
	                stat = line;
	            }
	        }
	        return stat;
	    }

	    function sequencesize_2(statements, compressor) {
	        function cons_seq(right) {
	            n--;
	            CHANGED = true;
	            var left = prev.body;
	            return make_sequence(left, [left, right]).transform(compressor);
	        }
	        var n = 0, prev;
	        for (var i = 0; i < statements.length; i++) {
	            var stat = statements[i];
	            if (prev) {
	                if (stat instanceof AST_Exit) {
	                    stat.value = cons_seq(stat.value || make_node(AST_Undefined, stat).transform(compressor));
	                } else if (stat instanceof AST_For) {
	                    if (!(stat.init instanceof AST_Definitions)) {
	                        const abort = walk(prev.body, node => {
	                            if (node instanceof AST_Scope)
	                                return true;
	                            if (node instanceof AST_Binary
	                                && node.operator === "in") {
	                                return walk_abort;
	                            }
	                        });
	                        if (!abort) {
	                            if (stat.init)
	                                stat.init = cons_seq(stat.init);
	                            else {
	                                stat.init = prev.body;
	                                n--;
	                                CHANGED = true;
	                            }
	                        }
	                    }
	                } else if (stat instanceof AST_ForIn) {
	                    if (!(stat.init instanceof AST_Const) && !(stat.init instanceof AST_Let)) {
	                        stat.object = cons_seq(stat.object);
	                    }
	                } else if (stat instanceof AST_If) {
	                    stat.condition = cons_seq(stat.condition);
	                } else if (stat instanceof AST_Switch) {
	                    stat.expression = cons_seq(stat.expression);
	                } else if (stat instanceof AST_With) {
	                    stat.expression = cons_seq(stat.expression);
	                }
	            }
	            if (compressor.option("conditionals") && stat instanceof AST_If) {
	                var decls = [];
	                var body = to_simple_statement(stat.body, decls);
	                var alt = to_simple_statement(stat.alternative, decls);
	                if (body !== false && alt !== false && decls.length > 0) {
	                    var len = decls.length;
	                    decls.push(make_node(AST_If, stat, {
	                        condition: stat.condition,
	                        body: body || make_node(AST_EmptyStatement, stat.body),
	                        alternative: alt
	                    }));
	                    decls.unshift(n, 1);
	                    [].splice.apply(statements, decls);
	                    i += len;
	                    n += len + 1;
	                    prev = null;
	                    CHANGED = true;
	                    continue;
	                }
	            }
	            statements[n++] = stat;
	            prev = stat instanceof AST_SimpleStatement ? stat : null;
	        }
	        statements.length = n;
	    }

	    function join_object_assignments(defn, body) {
	        if (!(defn instanceof AST_Definitions))
	            return;
	        var def = defn.definitions[defn.definitions.length - 1];
	        if (!(def.value instanceof AST_Object))
	            return;
	        var exprs;
	        if (body instanceof AST_Assign && !body.logical) {
	            exprs = [body];
	        } else if (body instanceof AST_Sequence) {
	            exprs = body.expressions.slice();
	        }
	        if (!exprs)
	            return;
	        var trimmed = false;
	        do {
	            var node = exprs[0];
	            if (!(node instanceof AST_Assign))
	                break;
	            if (node.operator != "=")
	                break;
	            if (!(node.left instanceof AST_PropAccess))
	                break;
	            var sym = node.left.expression;
	            if (!(sym instanceof AST_SymbolRef))
	                break;
	            if (def.name.name != sym.name)
	                break;
	            if (!node.right.is_constant_expression(nearest_scope))
	                break;
	            var prop = node.left.property;
	            if (prop instanceof AST_Node) {
	                prop = prop.evaluate(compressor);
	            }
	            if (prop instanceof AST_Node)
	                break;
	            prop = "" + prop;
	            var diff = compressor.option("ecma") < 2015
	                && compressor.has_directive("use strict") ? function (node) {
	                    return node.key != prop && (node.key && node.key.name != prop);
	                } : function (node) {
	                    return node.key && node.key.name != prop;
	                };
	            if (!def.value.properties.every(diff))
	                break;
	            var p = def.value.properties.filter(function (p) { return p.key === prop; })[0];
	            if (!p) {
	                def.value.properties.push(make_node(AST_ObjectKeyVal, node, {
	                    key: prop,
	                    value: node.right
	                }));
	            } else {
	                p.value = new AST_Sequence({
	                    start: p.start,
	                    expressions: [p.value.clone(), node.right.clone()],
	                    end: p.end
	                });
	            }
	            exprs.shift();
	            trimmed = true;
	        } while (exprs.length);
	        return trimmed && exprs;
	    }

	    function join_consecutive_vars(statements) {
	        var defs;
	        for (var i = 0, j = -1, len = statements.length; i < len; i++) {
	            var stat = statements[i];
	            var prev = statements[j];
	            if (stat instanceof AST_Definitions) {
	                if (prev && prev.TYPE == stat.TYPE) {
	                    prev.definitions = prev.definitions.concat(stat.definitions);
	                    CHANGED = true;
	                } else if (defs && defs.TYPE == stat.TYPE && declarations_only(stat)) {
	                    defs.definitions = defs.definitions.concat(stat.definitions);
	                    CHANGED = true;
	                } else {
	                    statements[++j] = stat;
	                    defs = stat;
	                }
	            } else if (stat instanceof AST_Exit) {
	                stat.value = extract_object_assignments(stat.value);
	            } else if (stat instanceof AST_For) {
	                var exprs = join_object_assignments(prev, stat.init);
	                if (exprs) {
	                    CHANGED = true;
	                    stat.init = exprs.length ? make_sequence(stat.init, exprs) : null;
	                    statements[++j] = stat;
	                } else if (
	                    prev instanceof AST_Var
	                    && (!stat.init || stat.init.TYPE == prev.TYPE)
	                ) {
	                    if (stat.init) {
	                        prev.definitions = prev.definitions.concat(stat.init.definitions);
	                    }
	                    stat.init = prev;
	                    statements[j] = stat;
	                    CHANGED = true;
	                } else if (
	                    defs instanceof AST_Var
	                    && stat.init instanceof AST_Var
	                    && declarations_only(stat.init)
	                ) {
	                    defs.definitions = defs.definitions.concat(stat.init.definitions);
	                    stat.init = null;
	                    statements[++j] = stat;
	                    CHANGED = true;
	                } else {
	                    statements[++j] = stat;
	                }
	            } else if (stat instanceof AST_ForIn) {
	                stat.object = extract_object_assignments(stat.object);
	            } else if (stat instanceof AST_If) {
	                stat.condition = extract_object_assignments(stat.condition);
	            } else if (stat instanceof AST_SimpleStatement) {
	                var exprs = join_object_assignments(prev, stat.body);
	                if (exprs) {
	                    CHANGED = true;
	                    if (!exprs.length)
	                        continue;
	                    stat.body = make_sequence(stat.body, exprs);
	                }
	                statements[++j] = stat;
	            } else if (stat instanceof AST_Switch) {
	                stat.expression = extract_object_assignments(stat.expression);
	            } else if (stat instanceof AST_With) {
	                stat.expression = extract_object_assignments(stat.expression);
	            } else {
	                statements[++j] = stat;
	            }
	        }
	        statements.length = j + 1;

	        function extract_object_assignments(value) {
	            statements[++j] = stat;
	            var exprs = join_object_assignments(prev, value);
	            if (exprs) {
	                CHANGED = true;
	                if (exprs.length) {
	                    return make_sequence(value, exprs);
	                } else if (value instanceof AST_Sequence) {
	                    return value.tail_node().left;
	                } else {
	                    return value.left;
	                }
	            }
	            return value;
	        }
	    }
	}

	/***********************************************************************

	  A JavaScript tokenizer / parser / beautifier / compressor.
	  https://github.com/mishoo/UglifyJS2

	  -------------------------------- (C) ---------------------------------

	                           Author: Mihai Bazon
	                         <mihai.bazon@gmail.com>
	                       http://mihai.bazon.net/blog

	  Distributed under the BSD license:

	    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

	    Redistribution and use in source and binary forms, with or without
	    modification, are permitted provided that the following conditions
	    are met:

	        * Redistributions of source code must retain the above
	          copyright notice, this list of conditions and the following
	          disclaimer.

	        * Redistributions in binary form must reproduce the above
	          copyright notice, this list of conditions and the following
	          disclaimer in the documentation and/or other materials
	          provided with the distribution.

	    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
	    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
	    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
	    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
	    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
	    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
	    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
	    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
	    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
	    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
	    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
	    SUCH DAMAGE.

	 ***********************************************************************/

	/**
	 * Module that contains the inlining logic.
	 *
	 * @module
	 *
	 * The stars of the show are `inline_into_symbolref` and `inline_into_call`.
	 */

	function within_array_or_object_literal(compressor) {
	    var node, level = 0;
	    while (node = compressor.parent(level++)) {
	        if (node instanceof AST_Statement) return false;
	        if (node instanceof AST_Array
	            || node instanceof AST_ObjectKeyVal
	            || node instanceof AST_Object) {
	            return true;
	        }
	    }
	    return false;
	}

	function scope_encloses_variables_in_this_scope(scope, pulled_scope) {
	    for (const enclosed of pulled_scope.enclosed) {
	        if (pulled_scope.variables.has(enclosed.name)) {
	            continue;
	        }
	        const looked_up = scope.find_variable(enclosed.name);
	        if (looked_up) {
	            if (looked_up === enclosed) continue;
	            return true;
	        }
	    }
	    return false;
	}

	/**
	 * An extra check function for `top_retain` option, compare the length of const identifier
	 * and init value length and return true if init value is longer than identifier. for example:
	 * ```
	 * // top_retain: ["example"]
	 * const example = 100
	 * ```
	 * it will return false because length of "100" is short than identifier "example".
	 */
	function is_const_symbol_short_than_init_value(def, fixed_value) {
	    if (def.orig.length === 1 && fixed_value) {
	        const init_value_length = fixed_value.size();
	        const identifer_length = def.name.length;
	        return init_value_length > identifer_length;
	    }
	    return true;
	}

	function inline_into_symbolref(self, compressor) {
	    if (compressor.in_computed_key()) return self;

	    const parent = compressor.parent();
	    const def = self.definition();
	    const nearest_scope = compressor.find_scope();
	    let fixed = self.fixed_value();
	    if (
	        compressor.top_retain &&
	        def.global && 
	        compressor.top_retain(def) && 
	        // when identifier is in top_retain option dose not mean we can always inline it.
	        // if identifier name is longer then init value, we can replace it.
	        is_const_symbol_short_than_init_value(def, fixed)
	    ) {
	        // keep it
	        def.fixed = false;
	        def.single_use = false;
	        return self;
	    }

	    let single_use = def.single_use
	        && !(parent instanceof AST_Call
	            && (parent.is_callee_pure(compressor))
	                || has_annotation(parent, _NOINLINE))
	        && !(parent instanceof AST_Export
	            && fixed instanceof AST_Lambda
	            && fixed.name);

	    if (single_use && fixed instanceof AST_Node) {
	        single_use =
	            !fixed.has_side_effects(compressor)
	            && !fixed.may_throw(compressor);
	    }

	    if (fixed instanceof AST_Class && def.scope !== self.scope) {
	        return self;
	    }

	    if (single_use && (fixed instanceof AST_Lambda || fixed instanceof AST_Class)) {
	        if (retain_top_func(fixed, compressor)) {
	            single_use = false;
	        } else if (def.scope !== self.scope
	            && (def.escaped == 1
	                || has_flag(fixed, INLINED)
	                || within_array_or_object_literal(compressor)
	                || !compressor.option("reduce_funcs"))) {
	            single_use = false;
	        } else if (is_recursive_ref(compressor, def)) {
	            single_use = false;
	        } else if (def.scope !== self.scope || def.orig[0] instanceof AST_SymbolFunarg) {
	            single_use = fixed.is_constant_expression(self.scope);
	            if (single_use == "f") {
	                var scope = self.scope;
	                do {
	                    if (scope instanceof AST_Defun || is_func_expr(scope)) {
	                        set_flag(scope, INLINED);
	                    }
	                } while (scope = scope.parent_scope);
	            }
	        }
	    }

	    if (single_use && (fixed instanceof AST_Lambda || fixed instanceof AST_Class)) {
	        single_use =
	            def.scope === self.scope
	                && !scope_encloses_variables_in_this_scope(nearest_scope, fixed)
	            || parent instanceof AST_Call
	                && parent.expression === self
	                && !scope_encloses_variables_in_this_scope(nearest_scope, fixed)
	                && !(fixed.name && fixed.name.definition().recursive_refs > 0);
	    }

	    if (single_use && fixed) {
	        if (fixed instanceof AST_DefClass) {
	            set_flag(fixed, SQUEEZED);
	            fixed = make_node(AST_ClassExpression, fixed, fixed);
	        }
	        if (fixed instanceof AST_Defun) {
	            set_flag(fixed, SQUEEZED);
	            fixed = make_node(AST_Function, fixed, fixed);
	        }
	        if (def.recursive_refs > 0 && fixed.name instanceof AST_SymbolDefun) {
	            const defun_def = fixed.name.definition();
	            let lambda_def = fixed.variables.get(fixed.name.name);
	            let name = lambda_def && lambda_def.orig[0];
	            if (!(name instanceof AST_SymbolLambda)) {
	                name = make_node(AST_SymbolLambda, fixed.name, fixed.name);
	                name.scope = fixed;
	                fixed.name = name;
	                lambda_def = fixed.def_function(name);
	            }
	            walk(fixed, node => {
	                if (node instanceof AST_SymbolRef && node.definition() === defun_def) {
	                    node.thedef = lambda_def;
	                    lambda_def.references.push(node);
	                }
	            });
	        }
	        if (
	            (fixed instanceof AST_Lambda || fixed instanceof AST_Class)
	            && fixed.parent_scope !== nearest_scope
	        ) {
	            fixed = fixed.clone(true, compressor.get_toplevel());

	            nearest_scope.add_child_scope(fixed);
	        }
	        return fixed.optimize(compressor);
	    }

	    // multiple uses
	    if (fixed) {
	        let replace;

	        if (fixed instanceof AST_This) {
	            if (!(def.orig[0] instanceof AST_SymbolFunarg)
	                && def.references.every((ref) =>
	                    def.scope === ref.scope
	                )) {
	                replace = fixed;
	            }
	        } else {
	            var ev = fixed.evaluate(compressor);
	            if (
	                ev !== fixed
	                && (compressor.option("unsafe_regexp") || !(ev instanceof RegExp))
	            ) {
	                replace = make_node_from_constant(ev, fixed);
	            }
	        }

	        if (replace) {
	            const name_length = self.size(compressor);
	            const replace_size = replace.size(compressor);

	            let overhead = 0;
	            if (compressor.option("unused") && !compressor.exposed(def)) {
	                overhead =
	                    (name_length + 2 + fixed.size(compressor)) /
	                    (def.references.length - def.assignments);
	            }

	            if (replace_size <= name_length + overhead) {
	                return replace;
	            }
	        }
	    }

	    return self;
	}

	function inline_into_call(self, compressor) {
	    if (compressor.in_computed_key()) return self;

	    var exp = self.expression;
	    var fn = exp;
	    var simple_args = self.args.every((arg) => !(arg instanceof AST_Expansion));

	    if (compressor.option("reduce_vars")
	        && fn instanceof AST_SymbolRef
	        && !has_annotation(self, _NOINLINE)
	    ) {
	        const fixed = fn.fixed_value();

	        if (
	            retain_top_func(fixed, compressor)
	            || !compressor.toplevel.funcs && exp.definition().global
	        ) {
	            return self;
	        }

	        fn = fixed;
	    }

	    var is_func = fn instanceof AST_Lambda;

	    var stat = is_func && fn.body[0];
	    var is_regular_func = is_func && !fn.is_generator && !fn.async;
	    var can_inline = is_regular_func && compressor.option("inline") && !self.is_callee_pure(compressor);
	    if (can_inline && stat instanceof AST_Return) {
	        let returned = stat.value;
	        if (!returned || returned.is_constant_expression()) {
	            if (returned) {
	                returned = returned.clone(true);
	            } else {
	                returned = make_node(AST_Undefined, self);
	            }
	            const args = self.args.concat(returned);
	            return make_sequence(self, args).optimize(compressor);
	        }

	        // optimize identity function
	        if (
	            fn.argnames.length === 1
	            && (fn.argnames[0] instanceof AST_SymbolFunarg)
	            && self.args.length < 2
	            && !(self.args[0] instanceof AST_Expansion)
	            && returned instanceof AST_SymbolRef
	            && returned.name === fn.argnames[0].name
	        ) {
	            const replacement =
	                (self.args[0] || make_node(AST_Undefined)).optimize(compressor);

	            let parent;
	            if (
	                replacement instanceof AST_PropAccess
	                && (parent = compressor.parent()) instanceof AST_Call
	                && parent.expression === self
	            ) {
	                // identity function was being used to remove `this`, like in
	                //
	                // id(bag.no_this)(...)
	                //
	                // Replace with a larger but more effish (0, bag.no_this) wrapper.

	                return make_sequence(self, [
	                    make_node(AST_Number, self, { value: 0 }),
	                    replacement
	                ]);
	            }
	            // replace call with first argument or undefined if none passed
	            return replacement;
	        }
	    }

	    if (can_inline) {
	        var scope, in_loop, level = -1;
	        let def;
	        let returned_value;
	        let nearest_scope;
	        if (simple_args
	            && !fn.uses_arguments
	            && !(compressor.parent() instanceof AST_Class)
	            && !(fn.name && fn instanceof AST_Function)
	            && (returned_value = can_flatten_body(stat))
	            && (exp === fn
	                || has_annotation(self, _INLINE)
	                || compressor.option("unused")
	                    && (def = exp.definition()).references.length == 1
	                    && !is_recursive_ref(compressor, def)
	                    && fn.is_constant_expression(exp.scope))
	            && !has_annotation(self, _PURE | _NOINLINE)
	            && !fn.contains_this()
	            && can_inject_symbols()
	            && (nearest_scope = compressor.find_scope())
	            && !scope_encloses_variables_in_this_scope(nearest_scope, fn)
	            && !(function in_default_assign() {
	                    // Due to the fact function parameters have their own scope
	                    // which can't use `var something` in the function body within,
	                    // we simply don't inline into DefaultAssign.
	                    let i = 0;
	                    let p;
	                    while ((p = compressor.parent(i++))) {
	                        if (p instanceof AST_DefaultAssign) return true;
	                        if (p instanceof AST_Block) break;
	                    }
	                    return false;
	                })()
	            && !(scope instanceof AST_Class)
	        ) {
	            set_flag(fn, SQUEEZED);
	            nearest_scope.add_child_scope(fn);
	            return make_sequence(self, flatten_fn(returned_value)).optimize(compressor);
	        }
	    }

	    if (can_inline && has_annotation(self, _INLINE)) {
	        set_flag(fn, SQUEEZED);
	        fn = make_node(fn.CTOR === AST_Defun ? AST_Function : fn.CTOR, fn, fn);
	        fn = fn.clone(true);
	        fn.figure_out_scope({}, {
	            parent_scope: compressor.find_scope(),
	            toplevel: compressor.get_toplevel()
	        });

	        return make_node(AST_Call, self, {
	            expression: fn,
	            args: self.args,
	        }).optimize(compressor);
	    }

	    const can_drop_this_call = is_regular_func && compressor.option("side_effects") && fn.body.every(is_empty);
	    if (can_drop_this_call) {
	        var args = self.args.concat(make_node(AST_Undefined, self));
	        return make_sequence(self, args).optimize(compressor);
	    }

	    if (compressor.option("negate_iife")
	        && compressor.parent() instanceof AST_SimpleStatement
	        && is_iife_call(self)) {
	        return self.negate(compressor, true);
	    }

	    var ev = self.evaluate(compressor);
	    if (ev !== self) {
	        ev = make_node_from_constant(ev, self).optimize(compressor);
	        return best_of(compressor, ev, self);
	    }

	    return self;

	    function return_value(stat) {
	        if (!stat) return make_node(AST_Undefined, self);
	        if (stat instanceof AST_Return) {
	            if (!stat.value) return make_node(AST_Undefined, self);
	            return stat.value.clone(true);
	        }
	        if (stat instanceof AST_SimpleStatement) {
	            return make_node(AST_UnaryPrefix, stat, {
	                operator: "void",
	                expression: stat.body.clone(true)
	            });
	        }
	    }

	    function can_flatten_body(stat) {
	        var body = fn.body;
	        var len = body.length;
	        if (compressor.option("inline") < 3) {
	            return len == 1 && return_value(stat);
	        }
	        stat = null;
	        for (var i = 0; i < len; i++) {
	            var line = body[i];
	            if (line instanceof AST_Var) {
	                if (stat && !line.definitions.every((var_def) =>
	                    !var_def.value
	                )) {
	                    return false;
	                }
	            } else if (stat) {
	                return false;
	            } else if (!(line instanceof AST_EmptyStatement)) {
	                stat = line;
	            }
	        }
	        return return_value(stat);
	    }

	    function can_inject_args(block_scoped, safe_to_inject) {
	        for (var i = 0, len = fn.argnames.length; i < len; i++) {
	            var arg = fn.argnames[i];
	            if (arg instanceof AST_DefaultAssign) {
	                if (has_flag(arg.left, UNUSED)) continue;
	                return false;
	            }
	            if (arg instanceof AST_Destructuring) return false;
	            if (arg instanceof AST_Expansion) {
	                if (has_flag(arg.expression, UNUSED)) continue;
	                return false;
	            }
	            if (has_flag(arg, UNUSED)) continue;
	            if (!safe_to_inject
	                || block_scoped.has(arg.name)
	                || identifier_atom.has(arg.name)
	                || scope.conflicting_def(arg.name)) {
	                return false;
	            }
	            if (in_loop) in_loop.push(arg.definition());
	        }
	        return true;
	    }

	    function can_inject_vars(block_scoped, safe_to_inject) {
	        var len = fn.body.length;
	        for (var i = 0; i < len; i++) {
	            var stat = fn.body[i];
	            if (!(stat instanceof AST_Var)) continue;
	            if (!safe_to_inject) return false;
	            for (var j = stat.definitions.length; --j >= 0;) {
	                var name = stat.definitions[j].name;
	                if (name instanceof AST_Destructuring
	                    || block_scoped.has(name.name)
	                    || identifier_atom.has(name.name)
	                    || scope.conflicting_def(name.name)) {
	                    return false;
	                }
	                if (in_loop) in_loop.push(name.definition());
	            }
	        }
	        return true;
	    }

	    function can_inject_symbols() {
	        var block_scoped = new Set();
	        do {
	            scope = compressor.parent(++level);
	            if (scope.is_block_scope() && scope.block_scope) {
	                // TODO this is sometimes undefined during compression.
	                // But it should always have a value!
	                scope.block_scope.variables.forEach(function (variable) {
	                    block_scoped.add(variable.name);
	                });
	            }
	            if (scope instanceof AST_Catch) {
	                // TODO can we delete? AST_Catch is a block scope.
	                if (scope.argname) {
	                    block_scoped.add(scope.argname.name);
	                }
	            } else if (scope instanceof AST_IterationStatement) {
	                in_loop = [];
	            } else if (scope instanceof AST_SymbolRef) {
	                if (scope.fixed_value() instanceof AST_Scope) return false;
	            }
	        } while (!(scope instanceof AST_Scope));

	        var safe_to_inject = !(scope instanceof AST_Toplevel) || compressor.toplevel.vars;
	        var inline = compressor.option("inline");
	        if (!can_inject_vars(block_scoped, inline >= 3 && safe_to_inject)) return false;
	        if (!can_inject_args(block_scoped, inline >= 2 && safe_to_inject)) return false;
	        return !in_loop || in_loop.length == 0 || !is_reachable(fn, in_loop);
	    }

	    function append_var(decls, expressions, name, value) {
	        var def = name.definition();

	        // Name already exists, only when a function argument had the same name
	        const already_appended = scope.variables.has(name.name);
	        if (!already_appended) {
	            scope.variables.set(name.name, def);
	            scope.enclosed.push(def);
	            decls.push(make_node(AST_VarDef, name, {
	                name: name,
	                value: null
	            }));
	        }

	        var sym = make_node(AST_SymbolRef, name, name);
	        def.references.push(sym);
	        if (value) expressions.push(make_node(AST_Assign, self, {
	            operator: "=",
	            logical: false,
	            left: sym,
	            right: value.clone()
	        }));
	    }

	    function flatten_args(decls, expressions) {
	        var len = fn.argnames.length;
	        for (var i = self.args.length; --i >= len;) {
	            expressions.push(self.args[i]);
	        }
	        for (i = len; --i >= 0;) {
	            var name = fn.argnames[i];
	            var value = self.args[i];
	            if (has_flag(name, UNUSED) || !name.name || scope.conflicting_def(name.name)) {
	                if (value) expressions.push(value);
	            } else {
	                var symbol = make_node(AST_SymbolVar, name, name);
	                name.definition().orig.push(symbol);
	                if (!value && in_loop) value = make_node(AST_Undefined, self);
	                append_var(decls, expressions, symbol, value);
	            }
	        }
	        decls.reverse();
	        expressions.reverse();
	    }

	    function flatten_vars(decls, expressions) {
	        var pos = expressions.length;
	        for (var i = 0, lines = fn.body.length; i < lines; i++) {
	            var stat = fn.body[i];
	            if (!(stat instanceof AST_Var)) continue;
	            for (var j = 0, defs = stat.definitions.length; j < defs; j++) {
	                var var_def = stat.definitions[j];
	                var name = var_def.name;
	                append_var(decls, expressions, name, var_def.value);
	                if (in_loop && fn.argnames.every((argname) =>
	                    argname.name != name.name
	                )) {
	                    var def = fn.variables.get(name.name);
	                    var sym = make_node(AST_SymbolRef, name, name);
	                    def.references.push(sym);
	                    expressions.splice(pos++, 0, make_node(AST_Assign, var_def, {
	                        operator: "=",
	                        logical: false,
	                        left: sym,
	                        right: make_node(AST_Undefined, name)
	                    }));
	                }
	            }
	        }
	    }

	    function flatten_fn(returned_value) {
	        var decls = [];
	        var expressions = [];
	        flatten_args(decls, expressions);
	        flatten_vars(decls, expressions);
	        expressions.push(returned_value);

	        if (decls.length) {
	            const i = scope.body.indexOf(compressor.parent(level - 1)) + 1;
	            scope.body.splice(i, 0, make_node(AST_Var, fn, {
	                definitions: decls
	            }));
	        }

	        return expressions.map(exp => exp.clone(true));
	    }
	}

	(function(def_find_defs) {
	    function to_node(value, orig) {
	        if (value instanceof AST_Node) {
	            if (!(value instanceof AST_Constant)) {
	                // Value may be a function, an array including functions and even a complex assign / block expression,
	                // so it should never be shared in different places.
	                // Otherwise wrong information may be used in the compression phase
	                value = value.clone(true);
	            }
	            return make_node(value.CTOR, orig, value);
	        }
	        if (Array.isArray(value)) return make_node(AST_Array, orig, {
	            elements: value.map(function(value) {
	                return to_node(value, orig);
	            })
	        });
	        if (value && typeof value == "object") {
	            var props = [];
	            for (var key in value) if (HOP(value, key)) {
	                props.push(make_node(AST_ObjectKeyVal, orig, {
	                    key: key,
	                    value: to_node(value[key], orig)
	                }));
	            }
	            return make_node(AST_Object, orig, {
	                properties: props
	            });
	        }
	        return make_node_from_constant(value, orig);
	    }

	    AST_Toplevel.DEFMETHOD("resolve_defines", function(compressor) {
	        if (!compressor.option("global_defs")) return this;
	        this.figure_out_scope({ ie8: compressor.option("ie8") });
	        return this.transform(new TreeTransformer(function(node) {
	            var def = node._find_defs(compressor, "");
	            if (!def) return;
	            var level = 0, child = node, parent;
	            while (parent = this.parent(level++)) {
	                if (!(parent instanceof AST_PropAccess)) break;
	                if (parent.expression !== child) break;
	                child = parent;
	            }
	            if (is_lhs(child, parent)) {
	                return;
	            }
	            return def;
	        }));
	    });
	    def_find_defs(AST_Node, noop);
	    def_find_defs(AST_Chain, function(compressor, suffix) {
	        return this.expression._find_defs(compressor, suffix);
	    });
	    def_find_defs(AST_Dot, function(compressor, suffix) {
	        return this.expression._find_defs(compressor, "." + this.property + suffix);
	    });
	    def_find_defs(AST_SymbolDeclaration, function() {
	        if (!this.global()) return;
	    });
	    def_find_defs(AST_SymbolRef, function(compressor, suffix) {
	        if (!this.global()) return;
	        var defines = compressor.option("global_defs");
	        var name = this.name + suffix;
	        if (HOP(defines, name)) return to_node(defines[name], this);
	    });
	    def_find_defs(AST_ImportMeta, function(compressor, suffix) {
	        var defines = compressor.option("global_defs");
	        var name = "import.meta" + suffix;
	        if (HOP(defines, name)) return to_node(defines[name], this);
	    });
	})(function(node, func) {
	    node.DEFMETHOD("_find_defs", func);
	});

	/***********************************************************************

	  A JavaScript tokenizer / parser / beautifier / compressor.
	  https://github.com/mishoo/UglifyJS2

	  -------------------------------- (C) ---------------------------------

	                           Author: Mihai Bazon
	                         <mihai.bazon@gmail.com>
	                       http://mihai.bazon.net/blog

	  Distributed under the BSD license:

	    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

	    Redistribution and use in source and binary forms, with or without
	    modification, are permitted provided that the following conditions
	    are met:

	        * Redistributions of source code must retain the above
	          copyright notice, this list of conditions and the following
	          disclaimer.

	        * Redistributions in binary form must reproduce the above
	          copyright notice, this list of conditions and the following
	          disclaimer in the documentation and/or other materials
	          provided with the distribution.

	    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
	    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
	    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
	    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
	    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
	    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
	    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
	    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
	    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
	    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
	    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
	    SUCH DAMAGE.

	 ***********************************************************************/

	class Compressor extends TreeWalker {
	    constructor(options, { false_by_default = false, mangle_options = false }) {
	        super();
	        if (options.defaults !== undefined && !options.defaults) false_by_default = true;
	        this.options = defaults(options, {
	            arguments     : false,
	            arrows        : !false_by_default,
	            booleans      : !false_by_default,
	            booleans_as_integers : false,
	            collapse_vars : !false_by_default,
	            comparisons   : !false_by_default,
	            computed_props: !false_by_default,
	            conditionals  : !false_by_default,
	            dead_code     : !false_by_default,
	            defaults      : true,
	            directives    : !false_by_default,
	            drop_console  : false,
	            drop_debugger : !false_by_default,
	            ecma          : 5,
	            evaluate      : !false_by_default,
	            expression    : false,
	            global_defs   : false,
	            hoist_funs    : false,
	            hoist_props   : !false_by_default,
	            hoist_vars    : false,
	            ie8           : false,
	            if_return     : !false_by_default,
	            inline        : !false_by_default,
	            join_vars     : !false_by_default,
	            keep_classnames: false,
	            keep_fargs    : true,
	            keep_fnames   : false,
	            keep_infinity : false,
	            lhs_constants : !false_by_default,
	            loops         : !false_by_default,
	            module        : false,
	            negate_iife   : !false_by_default,
	            passes        : 1,
	            properties    : !false_by_default,
	            pure_getters  : !false_by_default && "strict",
	            pure_funcs    : null,
	            pure_new      : false,
	            reduce_funcs  : !false_by_default,
	            reduce_vars   : !false_by_default,
	            sequences     : !false_by_default,
	            side_effects  : !false_by_default,
	            switches      : !false_by_default,
	            top_retain    : null,
	            toplevel      : !!(options && options["top_retain"]),
	            typeofs       : !false_by_default,
	            unsafe        : false,
	            unsafe_arrows : false,
	            unsafe_comps  : false,
	            unsafe_Function: false,
	            unsafe_math   : false,
	            unsafe_symbols: false,
	            unsafe_methods: false,
	            unsafe_proto  : false,
	            unsafe_regexp : false,
	            unsafe_undefined: false,
	            unused        : !false_by_default,
	            warnings      : false  // legacy
	        }, true);
	        var global_defs = this.options["global_defs"];
	        if (typeof global_defs == "object") for (var key in global_defs) {
	            if (key[0] === "@" && HOP(global_defs, key)) {
	                global_defs[key.slice(1)] = parse(global_defs[key], {
	                    expression: true
	                });
	            }
	        }
	        if (this.options["inline"] === true) this.options["inline"] = 3;
	        var pure_funcs = this.options["pure_funcs"];
	        if (typeof pure_funcs == "function") {
	            this.pure_funcs = pure_funcs;
	        } else {
	            this.pure_funcs = pure_funcs ? function(node) {
	                return !pure_funcs.includes(node.expression.print_to_string());
	            } : return_true;
	        }
	        var top_retain = this.options["top_retain"];
	        if (top_retain instanceof RegExp) {
	            this.top_retain = function(def) {
	                return top_retain.test(def.name);
	            };
	        } else if (typeof top_retain == "function") {
	            this.top_retain = top_retain;
	        } else if (top_retain) {
	            if (typeof top_retain == "string") {
	                top_retain = top_retain.split(/,/);
	            }
	            this.top_retain = function(def) {
	                return top_retain.includes(def.name);
	            };
	        }
	        if (this.options["module"]) {
	            this.directives["use strict"] = true;
	            this.options["toplevel"] = true;
	        }
	        var toplevel = this.options["toplevel"];
	        this.toplevel = typeof toplevel == "string" ? {
	            funcs: /funcs/.test(toplevel),
	            vars: /vars/.test(toplevel)
	        } : {
	            funcs: toplevel,
	            vars: toplevel
	        };
	        var sequences = this.options["sequences"];
	        this.sequences_limit = sequences == 1 ? 800 : sequences | 0;
	        this.evaluated_regexps = new Map();
	        this._toplevel = undefined;
	        this._mangle_options = mangle_options
	            ? format_mangler_options(mangle_options)
	            : mangle_options;
	    }

	    mangle_options() {
	        var nth_identifier = this._mangle_options && this._mangle_options.nth_identifier || base54;
	        var module = this._mangle_options && this._mangle_options.module || this.option("module");
	        return { ie8: this.option("ie8"), nth_identifier, module };
	    }

	    option(key) {
	        return this.options[key];
	    }

	    exposed(def) {
	        if (def.export) return true;
	        if (def.global) for (var i = 0, len = def.orig.length; i < len; i++)
	            if (!this.toplevel[def.orig[i] instanceof AST_SymbolDefun ? "funcs" : "vars"])
	                return true;
	        return false;
	    }

	    in_boolean_context() {
	        if (!this.option("booleans")) return false;
	        var self = this.self();
	        for (var i = 0, p; p = this.parent(i); i++) {
	            if (p instanceof AST_SimpleStatement
	                || p instanceof AST_Conditional && p.condition === self
	                || p instanceof AST_DWLoop && p.condition === self
	                || p instanceof AST_For && p.condition === self
	                || p instanceof AST_If && p.condition === self
	                || p instanceof AST_UnaryPrefix && p.operator == "!" && p.expression === self) {
	                return true;
	            }
	            if (
	                p instanceof AST_Binary
	                    && (
	                        p.operator == "&&"
	                        || p.operator == "||"
	                        || p.operator == "??"
	                    )
	                || p instanceof AST_Conditional
	                || p.tail_node() === self
	            ) {
	                self = p;
	            } else {
	                return false;
	            }
	        }
	    }

	    in_32_bit_context() {
	        if (!this.option("evaluate")) return false;
	        var self = this.self();
	        for (var i = 0, p; p = this.parent(i); i++) {
	            if (p instanceof AST_Binary && bitwise_binop.has(p.operator)) {
	                return true;
	            }
	            if (p instanceof AST_UnaryPrefix) {
	                return p.operator === "~";
	            }
	            if (
	                p instanceof AST_Binary
	                    && (
	                        p.operator == "&&"
	                        || p.operator == "||"
	                        || p.operator == "??"
	                    )
	                || p instanceof AST_Conditional && p.condition !== self
	                || p.tail_node() === self
	            ) {
	                self = p;
	            } else {
	                return false;
	            }
	        }
	    }

	    in_computed_key() {
	        if (!this.option("evaluate")) return false;
	        var self = this.self();
	        for (var i = 0, p; p = this.parent(i); i++) {
	            if (p instanceof AST_ObjectProperty && p.key === self) {
	                return true;
	            }
	        }
	        return false;
	    }

	    get_toplevel() {
	        return this._toplevel;
	    }

	    compress(toplevel) {
	        toplevel = toplevel.resolve_defines(this);
	        this._toplevel = toplevel;
	        if (this.option("expression")) {
	            this._toplevel.process_expression(true);
	        }
	        var passes = +this.options.passes || 1;
	        var min_count = 1 / 0;
	        var stopping = false;
	        var mangle = this.mangle_options();
	        for (var pass = 0; pass < passes; pass++) {
	            this._toplevel.figure_out_scope(mangle);
	            if (pass === 0 && this.option("drop_console")) {
	                // must be run before reduce_vars and compress pass
	                this._toplevel = this._toplevel.drop_console(this.option("drop_console"));
	            }
	            if (pass > 0 || this.option("reduce_vars")) {
	                this._toplevel.reset_opt_flags(this);
	            }
	            this._toplevel = this._toplevel.transform(this);
	            if (passes > 1) {
	                let count = 0;
	                walk(this._toplevel, () => { count++; });
	                if (count < min_count) {
	                    min_count = count;
	                    stopping = false;
	                } else if (stopping) {
	                    break;
	                } else {
	                    stopping = true;
	                }
	            }
	        }
	        if (this.option("expression")) {
	            this._toplevel.process_expression(false);
	        }
	        toplevel = this._toplevel;
	        this._toplevel = undefined;
	        return toplevel;
	    }

	    before(node, descend) {
	        if (has_flag(node, SQUEEZED)) return node;
	        var was_scope = false;
	        if (node instanceof AST_Scope) {
	            node = node.hoist_properties(this);
	            node = node.hoist_declarations(this);
	            was_scope = true;
	        }
	        // Before https://github.com/mishoo/UglifyJS2/pull/1602 AST_Node.optimize()
	        // would call AST_Node.transform() if a different instance of AST_Node is
	        // produced after def_optimize().
	        // This corrupts TreeWalker.stack, which cause AST look-ups to malfunction.
	        // Migrate and defer all children's AST_Node.transform() to below, which
	        // will now happen after this parent AST_Node has been properly substituted
	        // thus gives a consistent AST snapshot.
	        descend(node, this);
	        // Existing code relies on how AST_Node.optimize() worked, and omitting the
	        // following replacement call would result in degraded efficiency of both
	        // output and performance.
	        descend(node, this);
	        var opt = node.optimize(this);
	        if (was_scope && opt instanceof AST_Scope) {
	            opt.drop_unused(this);
	            descend(opt, this);
	        }
	        if (opt === node) set_flag(opt, SQUEEZED);
	        return opt;
	    }

	    /** Alternative to plain is_lhs() which doesn't work within .optimize() */
	    is_lhs() {
	        const self = this.stack[this.stack.length - 1];
	        const parent = this.stack[this.stack.length - 2];
	        return is_lhs(self, parent);
	    }
	}

	function def_optimize(node, optimizer) {
	    node.DEFMETHOD("optimize", function(compressor) {
	        var self = this;
	        if (has_flag(self, OPTIMIZED)) return self;
	        if (compressor.has_directive("use asm")) return self;
	        var opt = optimizer(self, compressor);
	        set_flag(opt, OPTIMIZED);
	        return opt;
	    });
	}

	def_optimize(AST_Node, function(self) {
	    return self;
	});

	AST_Toplevel.DEFMETHOD("drop_console", function(options) {
	    var isArray = Array.isArray(options);

	    return this.transform(new TreeTransformer(function(self) {
	        if (self.TYPE !== "Call") {
	            return;
	        }

	        var exp = self.expression;

	        if (!(exp instanceof AST_PropAccess)) {
	            return;
	        }

	        if (isArray && options.indexOf(exp.property) === -1) {
	            return;
	        }

	        var name = exp.expression;
	        while (name.expression) {
	            name = name.expression;
	        }
	        if (is_undeclared_ref(name) && name.name == "console") {
	            return make_node(AST_Undefined, self);
	        }
	    }));
	});

	AST_Node.DEFMETHOD("equivalent_to", function(node) {
	    return equivalent_to(this, node);
	});

	AST_Scope.DEFMETHOD("process_expression", function(insert, compressor) {
	    var self = this;
	    var tt = new TreeTransformer(function(node) {
	        if (insert && node instanceof AST_SimpleStatement) {
	            return make_node(AST_Return, node, {
	                value: node.body
	            });
	        }
	        if (!insert && node instanceof AST_Return) {
	            if (compressor) {
	                var value = node.value && node.value.drop_side_effect_free(compressor, true);
	                return value
	                    ? make_node(AST_SimpleStatement, node, { body: value })
	                    : make_node(AST_EmptyStatement, node);
	            }
	            return make_node(AST_SimpleStatement, node, {
	                body: node.value || make_node(AST_UnaryPrefix, node, {
	                    operator: "void",
	                    expression: make_node(AST_Number, node, {
	                        value: 0
	                    })
	                })
	            });
	        }
	        if (node instanceof AST_Class || node instanceof AST_Lambda && node !== self) {
	            return node;
	        }
	        if (node instanceof AST_Block) {
	            var index = node.body.length - 1;
	            if (index >= 0) {
	                node.body[index] = node.body[index].transform(tt);
	            }
	        } else if (node instanceof AST_If) {
	            node.body = node.body.transform(tt);
	            if (node.alternative) {
	                node.alternative = node.alternative.transform(tt);
	            }
	        } else if (node instanceof AST_With) {
	            node.body = node.body.transform(tt);
	        }
	        return node;
	    });
	    self.transform(tt);
	});

	AST_Toplevel.DEFMETHOD("reset_opt_flags", function(compressor) {
	    const self = this;
	    const reduce_vars = compressor.option("reduce_vars");

	    const preparation = new TreeWalker(function(node, descend) {
	        clear_flag(node, CLEAR_BETWEEN_PASSES);
	        if (reduce_vars) {
	            if (compressor.top_retain
	                && node instanceof AST_Defun  // Only functions are retained
	                && preparation.parent() === self
	            ) {
	                set_flag(node, TOP);
	            }
	            return node.reduce_vars(preparation, descend, compressor);
	        }
	    });
	    // Stack of look-up tables to keep track of whether a `SymbolDef` has been
	    // properly assigned before use:
	    // - `push()` & `pop()` when visiting conditional branches
	    preparation.safe_ids = Object.create(null);
	    preparation.in_loop = null;
	    preparation.loop_ids = new Map();
	    preparation.defs_to_safe_ids = new Map();
	    self.walk(preparation);
	});

	AST_Symbol.DEFMETHOD("fixed_value", function() {
	    var fixed = this.thedef.fixed;
	    if (!fixed || fixed instanceof AST_Node) return fixed;
	    return fixed();
	});

	AST_SymbolRef.DEFMETHOD("is_immutable", function() {
	    var orig = this.definition().orig;
	    return orig.length == 1 && orig[0] instanceof AST_SymbolLambda;
	});

	function find_variable(compressor, name) {
	    var scope, i = 0;
	    while (scope = compressor.parent(i++)) {
	        if (scope instanceof AST_Scope) break;
	        if (scope instanceof AST_Catch && scope.argname) {
	            scope = scope.argname.definition().scope;
	            break;
	        }
	    }
	    return scope.find_variable(name);
	}

	var global_names = makePredicate("Array Boolean clearInterval clearTimeout console Date decodeURI decodeURIComponent encodeURI encodeURIComponent Error escape eval EvalError Function isFinite isNaN JSON Math Number parseFloat parseInt RangeError ReferenceError RegExp Object setInterval setTimeout String SyntaxError TypeError unescape URIError");
	AST_SymbolRef.DEFMETHOD("is_declared", function(compressor) {
	    return !this.definition().undeclared
	        || compressor.option("unsafe") && global_names.has(this.name);
	});

	/* -----[ optimizers ]----- */

	var directives = new Set(["use asm", "use strict"]);
	def_optimize(AST_Directive, function(self, compressor) {
	    if (compressor.option("directives")
	        && (!directives.has(self.value) || compressor.has_directive(self.value) !== self)) {
	        return make_node(AST_EmptyStatement, self);
	    }
	    return self;
	});

	def_optimize(AST_Debugger, function(self, compressor) {
	    if (compressor.option("drop_debugger"))
	        return make_node(AST_EmptyStatement, self);
	    return self;
	});

	def_optimize(AST_LabeledStatement, function(self, compressor) {
	    if (self.body instanceof AST_Break
	        && compressor.loopcontrol_target(self.body) === self.body) {
	        return make_node(AST_EmptyStatement, self);
	    }
	    return self.label.references.length == 0 ? self.body : self;
	});

	def_optimize(AST_Block, function(self, compressor) {
	    tighten_body(self.body, compressor);
	    return self;
	});

	function can_be_extracted_from_if_block(node) {
	    return !(
	        node instanceof AST_Const
	        || node instanceof AST_Let
	        || node instanceof AST_Class
	    );
	}

	def_optimize(AST_BlockStatement, function(self, compressor) {
	    tighten_body(self.body, compressor);
	    switch (self.body.length) {
	      case 1:
	        if (!compressor.has_directive("use strict")
	            && compressor.parent() instanceof AST_If
	            && can_be_extracted_from_if_block(self.body[0])
	            || can_be_evicted_from_block(self.body[0])) {
	            return self.body[0];
	        }
	        break;
	      case 0: return make_node(AST_EmptyStatement, self);
	    }
	    return self;
	});

	function opt_AST_Lambda(self, compressor) {
	    tighten_body(self.body, compressor);
	    if (compressor.option("side_effects")
	        && self.body.length == 1
	        && self.body[0] === compressor.has_directive("use strict")) {
	        self.body.length = 0;
	    }
	    return self;
	}
	def_optimize(AST_Lambda, opt_AST_Lambda);

	AST_Scope.DEFMETHOD("hoist_declarations", function(compressor) {
	    var self = this;
	    if (compressor.has_directive("use asm")) return self;

	    var hoist_funs = compressor.option("hoist_funs");
	    var hoist_vars = compressor.option("hoist_vars");

	    if (hoist_funs || hoist_vars) {
	        var dirs = [];
	        var hoisted = [];
	        var vars = new Map(), vars_found = 0, var_decl = 0;
	        // let's count var_decl first, we seem to waste a lot of
	        // space if we hoist `var` when there's only one.
	        walk(self, node => {
	            if (node instanceof AST_Scope && node !== self)
	                return true;
	            if (node instanceof AST_Var) {
	                ++var_decl;
	                return true;
	            }
	        });
	        hoist_vars = hoist_vars && var_decl > 1;
	        var tt = new TreeTransformer(
	            function before(node) {
	                if (node !== self) {
	                    if (node instanceof AST_Directive) {
	                        dirs.push(node);
	                        return make_node(AST_EmptyStatement, node);
	                    }
	                    if (hoist_funs && node instanceof AST_Defun
	                        && !(tt.parent() instanceof AST_Export)
	                        && tt.parent() === self) {
	                        hoisted.push(node);
	                        return make_node(AST_EmptyStatement, node);
	                    }
	                    if (
	                        hoist_vars
	                        && node instanceof AST_Var
	                        && !node.definitions.some(def => def.name instanceof AST_Destructuring)
	                    ) {
	                        node.definitions.forEach(function(def) {
	                            vars.set(def.name.name, def);
	                            ++vars_found;
	                        });
	                        var seq = node.to_assignments(compressor);
	                        var p = tt.parent();
	                        if (p instanceof AST_ForIn && p.init === node) {
	                            if (seq == null) {
	                                var def = node.definitions[0].name;
	                                return make_node(AST_SymbolRef, def, def);
	                            }
	                            return seq;
	                        }
	                        if (p instanceof AST_For && p.init === node) {
	                            return seq;
	                        }
	                        if (!seq) return make_node(AST_EmptyStatement, node);
	                        return make_node(AST_SimpleStatement, node, {
	                            body: seq
	                        });
	                    }
	                    if (node instanceof AST_Scope)
	                        return node; // to avoid descending in nested scopes
	                }
	            }
	        );
	        self = self.transform(tt);
	        if (vars_found > 0) {
	            // collect only vars which don't show up in self's arguments list
	            var defs = [];
	            const is_lambda = self instanceof AST_Lambda;
	            const args_as_names = is_lambda ? self.args_as_names() : null;
	            vars.forEach((def, name) => {
	                if (is_lambda && args_as_names.some((x) => x.name === def.name.name)) {
	                    vars.delete(name);
	                } else {
	                    def = def.clone();
	                    def.value = null;
	                    defs.push(def);
	                    vars.set(name, def);
	                }
	            });
	            if (defs.length > 0) {
	                // try to merge in assignments
	                for (var i = 0; i < self.body.length;) {
	                    if (self.body[i] instanceof AST_SimpleStatement) {
	                        var expr = self.body[i].body, sym, assign;
	                        if (expr instanceof AST_Assign
	                            && expr.operator == "="
	                            && (sym = expr.left) instanceof AST_Symbol
	                            && vars.has(sym.name)
	                        ) {
	                            var def = vars.get(sym.name);
	                            if (def.value) break;
	                            def.value = expr.right;
	                            remove(defs, def);
	                            defs.push(def);
	                            self.body.splice(i, 1);
	                            continue;
	                        }
	                        if (expr instanceof AST_Sequence
	                            && (assign = expr.expressions[0]) instanceof AST_Assign
	                            && assign.operator == "="
	                            && (sym = assign.left) instanceof AST_Symbol
	                            && vars.has(sym.name)
	                        ) {
	                            var def = vars.get(sym.name);
	                            if (def.value) break;
	                            def.value = assign.right;
	                            remove(defs, def);
	                            defs.push(def);
	                            self.body[i].body = make_sequence(expr, expr.expressions.slice(1));
	                            continue;
	                        }
	                    }
	                    if (self.body[i] instanceof AST_EmptyStatement) {
	                        self.body.splice(i, 1);
	                        continue;
	                    }
	                    if (self.body[i] instanceof AST_BlockStatement) {
	                        self.body.splice(i, 1, ...self.body[i].body);
	                        continue;
	                    }
	                    break;
	                }
	                defs = make_node(AST_Var, self, {
	                    definitions: defs
	                });
	                hoisted.push(defs);
	            }
	        }
	        self.body = dirs.concat(hoisted, self.body);
	    }
	    return self;
	});

	AST_Scope.DEFMETHOD("hoist_properties", function(compressor) {
	    var self = this;
	    if (!compressor.option("hoist_props") || compressor.has_directive("use asm")) return self;
	    var top_retain = self instanceof AST_Toplevel && compressor.top_retain || return_false;
	    var defs_by_id = new Map();
	    var hoister = new TreeTransformer(function(node, descend) {
	        if (node instanceof AST_VarDef) {
	            const sym = node.name;
	            let def;
	            let value;
	            if (sym.scope === self
	                && (def = sym.definition()).escaped != 1
	                && !def.assignments
	                && !def.direct_access
	                && !def.single_use
	                && !compressor.exposed(def)
	                && !top_retain(def)
	                && (value = sym.fixed_value()) === node.value
	                && value instanceof AST_Object
	                && !value.properties.some(prop =>
	                    prop instanceof AST_Expansion || prop.computed_key()
	                )
	            ) {
	                descend(node, this);
	                const defs = new Map();
	                const assignments = [];
	                value.properties.forEach(({ key, value }) => {
	                    const scope = hoister.find_scope();
	                    const symbol = self.create_symbol(sym.CTOR, {
	                        source: sym,
	                        scope,
	                        conflict_scopes: new Set([
	                            scope,
	                            ...sym.definition().references.map(ref => ref.scope)
	                        ]),
	                        tentative_name: sym.name + "_" + key
	                    });

	                    defs.set(String(key), symbol.definition());

	                    assignments.push(make_node(AST_VarDef, node, {
	                        name: symbol,
	                        value
	                    }));
	                });
	                defs_by_id.set(def.id, defs);
	                return MAP.splice(assignments);
	            }
	        } else if (node instanceof AST_PropAccess
	            && node.expression instanceof AST_SymbolRef
	        ) {
	            const defs = defs_by_id.get(node.expression.definition().id);
	            if (defs) {
	                const def = defs.get(String(get_simple_key(node.property)));
	                const sym = make_node(AST_SymbolRef, node, {
	                    name: def.name,
	                    scope: node.expression.scope,
	                    thedef: def
	                });
	                sym.reference({});
	                return sym;
	            }
	        }
	    });
	    return self.transform(hoister);
	});

	def_optimize(AST_SimpleStatement, function(self, compressor) {
	    if (compressor.option("side_effects")) {
	        var body = self.body;
	        var node = body.drop_side_effect_free(compressor, true);
	        if (!node) {
	            return make_node(AST_EmptyStatement, self);
	        }
	        if (node !== body) {
	            return make_node(AST_SimpleStatement, self, { body: node });
	        }
	    }
	    return self;
	});

	def_optimize(AST_While, function(self, compressor) {
	    return compressor.option("loops") ? make_node(AST_For, self, self).optimize(compressor) : self;
	});

	def_optimize(AST_Do, function(self, compressor) {
	    if (!compressor.option("loops")) return self;
	    var cond = self.condition.tail_node().evaluate(compressor);
	    if (!(cond instanceof AST_Node)) {
	        if (cond) return make_node(AST_For, self, {
	            body: make_node(AST_BlockStatement, self.body, {
	                body: [
	                    self.body,
	                    make_node(AST_SimpleStatement, self.condition, {
	                        body: self.condition
	                    })
	                ]
	            })
	        }).optimize(compressor);
	        if (!has_break_or_continue(self, compressor.parent())) {
	            return make_node(AST_BlockStatement, self.body, {
	                body: [
	                    self.body,
	                    make_node(AST_SimpleStatement, self.condition, {
	                        body: self.condition
	                    })
	                ]
	            }).optimize(compressor);
	        }
	    }
	    return self;
	});

	function if_break_in_loop(self, compressor) {
	    var first = self.body instanceof AST_BlockStatement ? self.body.body[0] : self.body;
	    if (compressor.option("dead_code") && is_break(first)) {
	        var body = [];
	        if (self.init instanceof AST_Statement) {
	            body.push(self.init);
	        } else if (self.init) {
	            body.push(make_node(AST_SimpleStatement, self.init, {
	                body: self.init
	            }));
	        }
	        if (self.condition) {
	            body.push(make_node(AST_SimpleStatement, self.condition, {
	                body: self.condition
	            }));
	        }
	        trim_unreachable_code(compressor, self.body, body);
	        return make_node(AST_BlockStatement, self, {
	            body: body
	        });
	    }
	    if (first instanceof AST_If) {
	        if (is_break(first.body)) {
	            if (self.condition) {
	                self.condition = make_node(AST_Binary, self.condition, {
	                    left: self.condition,
	                    operator: "&&",
	                    right: first.condition.negate(compressor),
	                });
	            } else {
	                self.condition = first.condition.negate(compressor);
	            }
	            drop_it(first.alternative);
	        } else if (is_break(first.alternative)) {
	            if (self.condition) {
	                self.condition = make_node(AST_Binary, self.condition, {
	                    left: self.condition,
	                    operator: "&&",
	                    right: first.condition,
	                });
	            } else {
	                self.condition = first.condition;
	            }
	            drop_it(first.body);
	        }
	    }
	    return self;

	    function is_break(node) {
	        return node instanceof AST_Break
	            && compressor.loopcontrol_target(node) === compressor.self();
	    }

	    function drop_it(rest) {
	        rest = as_statement_array(rest);
	        if (self.body instanceof AST_BlockStatement) {
	            self.body = self.body.clone();
	            self.body.body = rest.concat(self.body.body.slice(1));
	            self.body = self.body.transform(compressor);
	        } else {
	            self.body = make_node(AST_BlockStatement, self.body, {
	                body: rest
	            }).transform(compressor);
	        }
	        self = if_break_in_loop(self, compressor);
	    }
	}

	def_optimize(AST_For, function(self, compressor) {
	    if (!compressor.option("loops")) return self;
	    if (compressor.option("side_effects") && self.init) {
	        self.init = self.init.drop_side_effect_free(compressor);
	    }
	    if (self.condition) {
	        var cond = self.condition.evaluate(compressor);
	        if (!(cond instanceof AST_Node)) {
	            if (cond) self.condition = null;
	            else if (!compressor.option("dead_code")) {
	                var orig = self.condition;
	                self.condition = make_node_from_constant(cond, self.condition);
	                self.condition = best_of_expression(self.condition.transform(compressor), orig);
	            }
	        }
	        if (compressor.option("dead_code")) {
	            if (cond instanceof AST_Node) cond = self.condition.tail_node().evaluate(compressor);
	            if (!cond) {
	                var body = [];
	                trim_unreachable_code(compressor, self.body, body);
	                if (self.init instanceof AST_Statement) {
	                    body.push(self.init);
	                } else if (self.init) {
	                    body.push(make_node(AST_SimpleStatement, self.init, {
	                        body: self.init
	                    }));
	                }
	                body.push(make_node(AST_SimpleStatement, self.condition, {
	                    body: self.condition
	                }));
	                return make_node(AST_BlockStatement, self, { body: body }).optimize(compressor);
	            }
	        }
	    }
	    return if_break_in_loop(self, compressor);
	});

	def_optimize(AST_If, function(self, compressor) {
	    if (is_empty(self.alternative)) self.alternative = null;

	    if (!compressor.option("conditionals")) return self;
	    // if condition can be statically determined, drop
	    // one of the blocks.  note, statically determined implies
	    // “has no side effects”; also it doesn't work for cases like
	    // `x && true`, though it probably should.
	    var cond = self.condition.evaluate(compressor);
	    if (!compressor.option("dead_code") && !(cond instanceof AST_Node)) {
	        var orig = self.condition;
	        self.condition = make_node_from_constant(cond, orig);
	        self.condition = best_of_expression(self.condition.transform(compressor), orig);
	    }
	    if (compressor.option("dead_code")) {
	        if (cond instanceof AST_Node) cond = self.condition.tail_node().evaluate(compressor);
	        if (!cond) {
	            var body = [];
	            trim_unreachable_code(compressor, self.body, body);
	            body.push(make_node(AST_SimpleStatement, self.condition, {
	                body: self.condition
	            }));
	            if (self.alternative) body.push(self.alternative);
	            return make_node(AST_BlockStatement, self, { body: body }).optimize(compressor);
	        } else if (!(cond instanceof AST_Node)) {
	            var body = [];
	            body.push(make_node(AST_SimpleStatement, self.condition, {
	                body: self.condition
	            }));
	            body.push(self.body);
	            if (self.alternative) {
	                trim_unreachable_code(compressor, self.alternative, body);
	            }
	            return make_node(AST_BlockStatement, self, { body: body }).optimize(compressor);
	        }
	    }
	    var negated = self.condition.negate(compressor);
	    var self_condition_length = self.condition.size();
	    var negated_length = negated.size();
	    var negated_is_best = negated_length < self_condition_length;
	    if (self.alternative && negated_is_best) {
	        negated_is_best = false; // because we already do the switch here.
	        // no need to swap values of self_condition_length and negated_length
	        // here because they are only used in an equality comparison later on.
	        self.condition = negated;
	        var tmp = self.body;
	        self.body = self.alternative || make_node(AST_EmptyStatement, self);
	        self.alternative = tmp;
	    }
	    if (is_empty(self.body) && is_empty(self.alternative)) {
	        return make_node(AST_SimpleStatement, self.condition, {
	            body: self.condition.clone()
	        }).optimize(compressor);
	    }
	    if (self.body instanceof AST_SimpleStatement
	        && self.alternative instanceof AST_SimpleStatement) {
	        return make_node(AST_SimpleStatement, self, {
	            body: make_node(AST_Conditional, self, {
	                condition   : self.condition,
	                consequent  : self.body.body,
	                alternative : self.alternative.body
	            })
	        }).optimize(compressor);
	    }
	    if (is_empty(self.alternative) && self.body instanceof AST_SimpleStatement) {
	        if (self_condition_length === negated_length && !negated_is_best
	            && self.condition instanceof AST_Binary && self.condition.operator == "||") {
	            // although the code length of self.condition and negated are the same,
	            // negated does not require additional surrounding parentheses.
	            // see https://github.com/mishoo/UglifyJS2/issues/979
	            negated_is_best = true;
	        }
	        if (negated_is_best) return make_node(AST_SimpleStatement, self, {
	            body: make_node(AST_Binary, self, {
	                operator : "||",
	                left     : negated,
	                right    : self.body.body
	            })
	        }).optimize(compressor);
	        return make_node(AST_SimpleStatement, self, {
	            body: make_node(AST_Binary, self, {
	                operator : "&&",
	                left     : self.condition,
	                right    : self.body.body
	            })
	        }).optimize(compressor);
	    }
	    if (self.body instanceof AST_EmptyStatement
	        && self.alternative instanceof AST_SimpleStatement) {
	        return make_node(AST_SimpleStatement, self, {
	            body: make_node(AST_Binary, self, {
	                operator : "||",
	                left     : self.condition,
	                right    : self.alternative.body
	            })
	        }).optimize(compressor);
	    }
	    if (self.body instanceof AST_Exit
	        && self.alternative instanceof AST_Exit
	        && self.body.TYPE == self.alternative.TYPE) {
	        return make_node(self.body.CTOR, self, {
	            value: make_node(AST_Conditional, self, {
	                condition   : self.condition,
	                consequent  : self.body.value || make_node(AST_Undefined, self.body),
	                alternative : self.alternative.value || make_node(AST_Undefined, self.alternative)
	            }).transform(compressor)
	        }).optimize(compressor);
	    }
	    if (self.body instanceof AST_If
	        && !self.body.alternative
	        && !self.alternative) {
	        self = make_node(AST_If, self, {
	            condition: make_node(AST_Binary, self.condition, {
	                operator: "&&",
	                left: self.condition,
	                right: self.body.condition
	            }),
	            body: self.body.body,
	            alternative: null
	        });
	    }
	    if (aborts(self.body)) {
	        if (self.alternative) {
	            var alt = self.alternative;
	            self.alternative = null;
	            return make_node(AST_BlockStatement, self, {
	                body: [ self, alt ]
	            }).optimize(compressor);
	        }
	    }
	    if (aborts(self.alternative)) {
	        var body = self.body;
	        self.body = self.alternative;
	        self.condition = negated_is_best ? negated : self.condition.negate(compressor);
	        self.alternative = null;
	        return make_node(AST_BlockStatement, self, {
	            body: [ self, body ]
	        }).optimize(compressor);
	    }
	    return self;
	});

	def_optimize(AST_Switch, function(self, compressor) {
	    if (!compressor.option("switches")) return self;
	    var branch;
	    var value = self.expression.evaluate(compressor);
	    if (!(value instanceof AST_Node)) {
	        var orig = self.expression;
	        self.expression = make_node_from_constant(value, orig);
	        self.expression = best_of_expression(self.expression.transform(compressor), orig);
	    }
	    if (!compressor.option("dead_code")) return self;
	    if (value instanceof AST_Node) {
	        value = self.expression.tail_node().evaluate(compressor);
	    }
	    var decl = [];
	    var body = [];
	    var default_branch;
	    var exact_match;
	    for (var i = 0, len = self.body.length; i < len && !exact_match; i++) {
	        branch = self.body[i];
	        if (branch instanceof AST_Default) {
	            if (!default_branch) {
	                default_branch = branch;
	            } else {
	                eliminate_branch(branch, body[body.length - 1]);
	            }
	        } else if (!(value instanceof AST_Node)) {
	            var exp = branch.expression.evaluate(compressor);
	            if (!(exp instanceof AST_Node) && exp !== value) {
	                eliminate_branch(branch, body[body.length - 1]);
	                continue;
	            }
	            if (exp instanceof AST_Node) exp = branch.expression.tail_node().evaluate(compressor);
	            if (exp === value) {
	                exact_match = branch;
	                if (default_branch) {
	                    var default_index = body.indexOf(default_branch);
	                    body.splice(default_index, 1);
	                    eliminate_branch(default_branch, body[default_index - 1]);
	                    default_branch = null;
	                }
	            }
	        }
	        body.push(branch);
	    }
	    while (i < len) eliminate_branch(self.body[i++], body[body.length - 1]);
	    self.body = body;

	    let default_or_exact = default_branch || exact_match;
	    default_branch = null;
	    exact_match = null;

	    // group equivalent branches so they will be located next to each other,
	    // that way the next micro-optimization will merge them.
	    // ** bail micro-optimization if not a simple switch case with breaks
	    if (body.every((branch, i) =>
	        (branch === default_or_exact || branch.expression instanceof AST_Constant)
	        && (branch.body.length === 0 || aborts(branch) || body.length - 1 === i))
	    ) {
	        for (let i = 0; i < body.length; i++) {
	            const branch = body[i];
	            for (let j = i + 1; j < body.length; j++) {
	                const next = body[j];
	                if (next.body.length === 0) continue;
	                const last_branch = j === (body.length - 1);
	                const equivalentBranch = branches_equivalent(next, branch, false);
	                if (equivalentBranch || (last_branch && branches_equivalent(next, branch, true))) {
	                    if (!equivalentBranch && last_branch) {
	                        next.body.push(make_node(AST_Break));
	                    }

	                    // let's find previous siblings with inert fallthrough...
	                    let x = j - 1;
	                    let fallthroughDepth = 0;
	                    while (x > i) {
	                        if (is_inert_body(body[x--])) {
	                            fallthroughDepth++;
	                        } else {
	                            break;
	                        }
	                    }

	                    const plucked = body.splice(j - fallthroughDepth, 1 + fallthroughDepth);
	                    body.splice(i + 1, 0, ...plucked);
	                    i += plucked.length;
	                }
	            }
	        }
	    }

	    // merge equivalent branches in a row
	    for (let i = 0; i < body.length; i++) {
	        let branch = body[i];
	        if (branch.body.length === 0) continue;
	        if (!aborts(branch)) continue;

	        for (let j = i + 1; j < body.length; i++, j++) {
	            let next = body[j];
	            if (next.body.length === 0) continue;
	            if (
	                branches_equivalent(next, branch, false)
	                || (j === body.length - 1 && branches_equivalent(next, branch, true))
	            ) {
	                branch.body = [];
	                branch = next;
	                continue;
	            }
	            break;
	        }
	    }

	    // Prune any empty branches at the end of the switch statement.
	    {
	        let i = body.length - 1;
	        for (; i >= 0; i--) {
	            let bbody = body[i].body;
	            if (is_break(bbody[bbody.length - 1], compressor)) bbody.pop();
	            if (!is_inert_body(body[i])) break;
	        }
	        // i now points to the index of a branch that contains a body. By incrementing, it's
	        // pointing to the first branch that's empty.
	        i++;
	        if (!default_or_exact || body.indexOf(default_or_exact) >= i) {
	            // The default behavior is to do nothing. We can take advantage of that to
	            // remove all case expressions that are side-effect free that also do
	            // nothing, since they'll default to doing nothing. But we can't remove any
	            // case expressions before one that would side-effect, since they may cause
	            // the side-effect to be skipped.
	            for (let j = body.length - 1; j >= i; j--) {
	                let branch = body[j];
	                if (branch === default_or_exact) {
	                    default_or_exact = null;
	                    body.pop();
	                } else if (!branch.expression.has_side_effects(compressor)) {
	                    body.pop();
	                } else {
	                    break;
	                }
	            }
	        }
	    }


	    // Prune side-effect free branches that fall into default.
	    DEFAULT: if (default_or_exact) {
	        let default_index = body.indexOf(default_or_exact);
	        let default_body_index = default_index;
	        for (; default_body_index < body.length - 1; default_body_index++) {
	            if (!is_inert_body(body[default_body_index])) break;
	        }
	        if (default_body_index < body.length - 1) {
	            break DEFAULT;
	        }

	        let side_effect_index = body.length - 1;
	        for (; side_effect_index >= 0; side_effect_index--) {
	            let branch = body[side_effect_index];
	            if (branch === default_or_exact) continue;
	            if (branch.expression.has_side_effects(compressor)) break;
	        }
	        // If the default behavior comes after any side-effect case expressions,
	        // then we can fold all side-effect free cases into the default branch.
	        // If the side-effect case is after the default, then any side-effect
	        // free cases could prevent the side-effect from occurring.
	        if (default_body_index > side_effect_index) {
	            let prev_body_index = default_index - 1;
	            for (; prev_body_index >= 0; prev_body_index--) {
	                if (!is_inert_body(body[prev_body_index])) break;
	            }
	            let before = Math.max(side_effect_index, prev_body_index) + 1;
	            let after = default_index;
	            if (side_effect_index > default_index) {
	                // If the default falls into the same body as a side-effect
	                // case, then we need preserve that case and only prune the
	                // cases after it.
	                after = side_effect_index;
	                body[side_effect_index].body = body[default_body_index].body;
	            } else {
	                // The default will be the last branch.
	                default_or_exact.body = body[default_body_index].body;
	            }

	            // Prune everything after the default (or last side-effect case)
	            // until the next case with a body.
	            body.splice(after + 1, default_body_index - after);
	            // Prune everything before the default that falls into it.
	            body.splice(before, default_index - before);
	        }
	    }

	    // See if we can remove the switch entirely if all cases (the default) fall into the same case body.
	    DEFAULT: if (default_or_exact) {
	        let i = body.findIndex(branch => !is_inert_body(branch));
	        let caseBody;
	        // `i` is equal to one of the following:
	        // - `-1`, there is no body in the switch statement.
	        // - `body.length - 1`, all cases fall into the same body.
	        // - anything else, there are multiple bodies in the switch.
	        if (i === body.length - 1) {
	            // All cases fall into the case body.
	            let branch = body[i];
	            if (has_nested_break(self)) break DEFAULT;

	            // This is the last case body, and we've already pruned any breaks, so it's
	            // safe to hoist.
	            caseBody = make_node(AST_BlockStatement, branch, {
	                body: branch.body
	            });
	            branch.body = [];
	        } else if (i !== -1) {
	            // If there are multiple bodies, then we cannot optimize anything.
	            break DEFAULT;
	        }

	        let sideEffect = body.find(branch => {
	            return (
	                branch !== default_or_exact
	                && branch.expression.has_side_effects(compressor)
	            );
	        });
	        // If no cases cause a side-effect, we can eliminate the switch entirely.
	        if (!sideEffect) {
	            return make_node(AST_BlockStatement, self, {
	                body: decl.concat(
	                    statement(self.expression),
	                    default_or_exact.expression ? statement(default_or_exact.expression) : [],
	                    caseBody || []
	                )
	            }).optimize(compressor);
	        }

	        // If we're this far, either there was no body or all cases fell into the same body.
	        // If there was no body, then we don't need a default branch (because the default is
	        // do nothing). If there was a body, we'll extract it to after the switch, so the
	        // switch's new default is to do nothing and we can still prune it.
	        const default_index = body.indexOf(default_or_exact);
	        body.splice(default_index, 1);
	        default_or_exact = null;

	        if (caseBody) {
	            // Recurse into switch statement one more time so that we can append the case body
	            // outside of the switch. This recursion will only happen once since we've pruned
	            // the default case.
	            return make_node(AST_BlockStatement, self, {
	                body: decl.concat(self, caseBody)
	            }).optimize(compressor);
	        }
	        // If we fall here, there is a default branch somewhere, there are no case bodies,
	        // and there's a side-effect somewhere. Just let the below paths take care of it.
	    }

	    if (body.length > 0) {
	        body[0].body = decl.concat(body[0].body);
	    }

	    if (body.length == 0) {
	        return make_node(AST_BlockStatement, self, {
	            body: decl.concat(statement(self.expression))
	        }).optimize(compressor);
	    }
	    if (body.length == 1 && !has_nested_break(self)) {
	        // This is the last case body, and we've already pruned any breaks, so it's
	        // safe to hoist.
	        let branch = body[0];
	        return make_node(AST_If, self, {
	            condition: make_node(AST_Binary, self, {
	                operator: "===",
	                left: self.expression,
	                right: branch.expression,
	            }),
	            body: make_node(AST_BlockStatement, branch, {
	                body: branch.body
	            }),
	            alternative: null
	        }).optimize(compressor);
	    }
	    if (body.length === 2 && default_or_exact && !has_nested_break(self)) {
	        let branch = body[0] === default_or_exact ? body[1] : body[0];
	        let exact_exp = default_or_exact.expression && statement(default_or_exact.expression);
	        if (aborts(body[0])) {
	            // Only the first branch body could have a break (at the last statement)
	            let first = body[0];
	            if (is_break(first.body[first.body.length - 1], compressor)) {
	                first.body.pop();
	            }
	            return make_node(AST_If, self, {
	                condition: make_node(AST_Binary, self, {
	                    operator: "===",
	                    left: self.expression,
	                    right: branch.expression,
	                }),
	                body: make_node(AST_BlockStatement, branch, {
	                    body: branch.body
	                }),
	                alternative: make_node(AST_BlockStatement, default_or_exact, {
	                    body: [].concat(
	                        exact_exp || [],
	                        default_or_exact.body
	                    )
	                })
	            }).optimize(compressor);
	        }
	        let operator = "===";
	        let consequent = make_node(AST_BlockStatement, branch, {
	            body: branch.body,
	        });
	        let always = make_node(AST_BlockStatement, default_or_exact, {
	            body: [].concat(
	                exact_exp || [],
	                default_or_exact.body
	            )
	        });
	        if (body[0] === default_or_exact) {
	            operator = "!==";
	            let tmp = always;
	            always = consequent;
	            consequent = tmp;
	        }
	        return make_node(AST_BlockStatement, self, {
	            body: [
	                make_node(AST_If, self, {
	                    condition: make_node(AST_Binary, self, {
	                        operator: operator,
	                        left: self.expression,
	                        right: branch.expression,
	                    }),
	                    body: consequent,
	                    alternative: null
	                })
	            ].concat(always)
	        }).optimize(compressor);
	    }
	    return self;

	    function eliminate_branch(branch, prev) {
	        if (prev && !aborts(prev)) {
	            prev.body = prev.body.concat(branch.body);
	        } else {
	            trim_unreachable_code(compressor, branch, decl);
	        }
	    }
	    function branches_equivalent(branch, prev, insertBreak) {
	        let bbody = branch.body;
	        let pbody = prev.body;
	        if (insertBreak) {
	            bbody = bbody.concat(make_node(AST_Break));
	        }
	        if (bbody.length !== pbody.length) return false;
	        let bblock = make_node(AST_BlockStatement, branch, { body: bbody });
	        let pblock = make_node(AST_BlockStatement, prev, { body: pbody });
	        return bblock.equivalent_to(pblock);
	    }
	    function statement(expression) {
	        return make_node(AST_SimpleStatement, expression, {
	            body: expression
	        });
	    }
	    function has_nested_break(root) {
	        let has_break = false;
	        let tw = new TreeWalker(node => {
	            if (has_break) return true;
	            if (node instanceof AST_Lambda) return true;
	            if (node instanceof AST_SimpleStatement) return true;
	            if (!is_break(node, tw)) return;
	            let parent = tw.parent();
	            if (
	                parent instanceof AST_SwitchBranch
	                && parent.body[parent.body.length - 1] === node
	            ) {
	                return;
	            }
	            has_break = true;
	        });
	        root.walk(tw);
	        return has_break;
	    }
	    function is_break(node, stack) {
	        return node instanceof AST_Break
	            && stack.loopcontrol_target(node) === self;
	    }
	    function is_inert_body(branch) {
	        return !aborts(branch) && !make_node(AST_BlockStatement, branch, {
	            body: branch.body
	        }).has_side_effects(compressor);
	    }
	});

	def_optimize(AST_Try, function(self, compressor) {
	    if (self.bcatch && self.bfinally && self.bfinally.body.every(is_empty)) self.bfinally = null;

	    if (compressor.option("dead_code") && self.body.body.every(is_empty)) {
	        var body = [];
	        if (self.bcatch) {
	            trim_unreachable_code(compressor, self.bcatch, body);
	        }
	        if (self.bfinally) body.push(...self.bfinally.body);
	        return make_node(AST_BlockStatement, self, {
	            body: body
	        }).optimize(compressor);
	    }
	    return self;
	});

	AST_Definitions.DEFMETHOD("to_assignments", function(compressor) {
	    var reduce_vars = compressor.option("reduce_vars");
	    var assignments = [];

	    for (const def of this.definitions) {
	        if (def.value) {
	            var name = make_node(AST_SymbolRef, def.name, def.name);
	            assignments.push(make_node(AST_Assign, def, {
	                operator : "=",
	                logical: false,
	                left     : name,
	                right    : def.value
	            }));
	            if (reduce_vars) name.definition().fixed = false;
	        }
	        const thedef = def.name.definition();
	        thedef.eliminated++;
	        thedef.replaced--;
	    }

	    if (assignments.length == 0) return null;
	    return make_sequence(this, assignments);
	});

	def_optimize(AST_Definitions, function(self) {
	    if (self.definitions.length == 0) {
	        return make_node(AST_EmptyStatement, self);
	    }
	    return self;
	});

	def_optimize(AST_VarDef, function(self, compressor) {
	    if (
	        self.name instanceof AST_SymbolLet
	        && self.value != null
	        && is_undefined(self.value, compressor)
	    ) {
	        self.value = null;
	    }
	    return self;
	});

	def_optimize(AST_Import, function(self) {
	    return self;
	});

	def_optimize(AST_Call, function(self, compressor) {
	    var exp = self.expression;
	    var fn = exp;
	    inline_array_like_spread(self.args);
	    var simple_args = self.args.every((arg) => !(arg instanceof AST_Expansion));

	    if (compressor.option("reduce_vars") && fn instanceof AST_SymbolRef) {
	        fn = fn.fixed_value();
	    }

	    var is_func = fn instanceof AST_Lambda;

	    if (is_func && fn.pinned()) return self;

	    if (compressor.option("unused")
	        && simple_args
	        && is_func
	        && !fn.uses_arguments) {
	        var pos = 0, last = 0;
	        for (var i = 0, len = self.args.length; i < len; i++) {
	            if (fn.argnames[i] instanceof AST_Expansion) {
	                if (has_flag(fn.argnames[i].expression, UNUSED)) while (i < len) {
	                    var node = self.args[i++].drop_side_effect_free(compressor);
	                    if (node) {
	                        self.args[pos++] = node;
	                    }
	                } else while (i < len) {
	                    self.args[pos++] = self.args[i++];
	                }
	                last = pos;
	                break;
	            }
	            var trim = i >= fn.argnames.length;
	            if (trim || has_flag(fn.argnames[i], UNUSED)) {
	                var node = self.args[i].drop_side_effect_free(compressor);
	                if (node) {
	                    self.args[pos++] = node;
	                } else if (!trim) {
	                    self.args[pos++] = make_node(AST_Number, self.args[i], {
	                        value: 0
	                    });
	                    continue;
	                }
	            } else {
	                self.args[pos++] = self.args[i];
	            }
	            last = pos;
	        }
	        self.args.length = last;
	    }

	    if (compressor.option("unsafe") && !exp.contains_optional()) {
	        if (exp instanceof AST_Dot && exp.start.value === "Array" && exp.property === "from" && self.args.length === 1) {
	            const [argument] = self.args;
	            if (argument instanceof AST_Array) {
	                return make_node(AST_Array, argument, {
	                    elements: argument.elements
	                }).optimize(compressor);
	            }
	        }
	        if (is_undeclared_ref(exp)) switch (exp.name) {
	          case "Array":
	            if (self.args.length != 1) {
	                return make_node(AST_Array, self, {
	                    elements: self.args
	                }).optimize(compressor);
	            } else if (self.args[0] instanceof AST_Number && self.args[0].value <= 11) {
	                const elements = [];
	                for (let i = 0; i < self.args[0].value; i++) elements.push(new AST_Hole);
	                return new AST_Array({ elements });
	            }
	            break;
	          case "Object":
	            if (self.args.length == 0) {
	                return make_node(AST_Object, self, {
	                    properties: []
	                });
	            }
	            break;
	          case "String":
	            if (self.args.length == 0) return make_node(AST_String, self, {
	                value: ""
	            });
	            if (self.args.length <= 1) return make_node(AST_Binary, self, {
	                left: self.args[0],
	                operator: "+",
	                right: make_node(AST_String, self, { value: "" })
	            }).optimize(compressor);
	            break;
	          case "Number":
	            if (self.args.length == 0) return make_node(AST_Number, self, {
	                value: 0
	            });
	            if (self.args.length == 1 && compressor.option("unsafe_math")) {
	                return make_node(AST_UnaryPrefix, self, {
	                    expression: self.args[0],
	                    operator: "+"
	                }).optimize(compressor);
	            }
	            break;
	          case "Symbol":
	            if (self.args.length == 1 && self.args[0] instanceof AST_String && compressor.option("unsafe_symbols"))
	                self.args.length = 0;
	                break;
	          case "Boolean":
	            if (self.args.length == 0) return make_node(AST_False, self);
	            if (self.args.length == 1) return make_node(AST_UnaryPrefix, self, {
	                expression: make_node(AST_UnaryPrefix, self, {
	                    expression: self.args[0],
	                    operator: "!"
	                }),
	                operator: "!"
	            }).optimize(compressor);
	            break;
	          case "RegExp":
	            var params = [];
	            if (self.args.length >= 1
	                && self.args.length <= 2
	                && self.args.every((arg) => {
	                    var value = arg.evaluate(compressor);
	                    params.push(value);
	                    return arg !== value;
	                })
	                && regexp_is_safe(params[0])
	            ) {
	                let [ source, flags ] = params;
	                source = regexp_source_fix(new RegExp(source).source);
	                const rx = make_node(AST_RegExp, self, {
	                    value: { source, flags }
	                });
	                if (rx._eval(compressor) !== rx) {
	                    return rx;
	                }
	            }
	            break;
	        } else if (exp instanceof AST_Dot) switch(exp.property) {
	          case "toString":
	            if (self.args.length == 0 && !exp.expression.may_throw_on_access(compressor)) {
	                return make_node(AST_Binary, self, {
	                    left: make_node(AST_String, self, { value: "" }),
	                    operator: "+",
	                    right: exp.expression
	                }).optimize(compressor);
	            }
	            break;
	          case "join":
	            if (exp.expression instanceof AST_Array) EXIT: {
	                var separator;
	                if (self.args.length > 0) {
	                    separator = self.args[0].evaluate(compressor);
	                    if (separator === self.args[0]) break EXIT; // not a constant
	                }
	                var elements = [];
	                var consts = [];
	                for (var i = 0, len = exp.expression.elements.length; i < len; i++) {
	                    var el = exp.expression.elements[i];
	                    if (el instanceof AST_Expansion) break EXIT;
	                    var value = el.evaluate(compressor);
	                    if (value !== el) {
	                        consts.push(value);
	                    } else {
	                        if (consts.length > 0) {
	                            elements.push(make_node(AST_String, self, {
	                                value: consts.join(separator)
	                            }));
	                            consts.length = 0;
	                        }
	                        elements.push(el);
	                    }
	                }
	                if (consts.length > 0) {
	                    elements.push(make_node(AST_String, self, {
	                        value: consts.join(separator)
	                    }));
	                }
	                if (elements.length == 0) return make_node(AST_String, self, { value: "" });
	                if (elements.length == 1) {
	                    if (elements[0].is_string(compressor)) {
	                        return elements[0];
	                    }
	                    return make_node(AST_Binary, elements[0], {
	                        operator : "+",
	                        left     : make_node(AST_String, self, { value: "" }),
	                        right    : elements[0]
	                    });
	                }
	                if (separator == "") {
	                    var first;
	                    if (elements[0].is_string(compressor)
	                        || elements[1].is_string(compressor)) {
	                        first = elements.shift();
	                    } else {
	                        first = make_node(AST_String, self, { value: "" });
	                    }
	                    return elements.reduce(function(prev, el) {
	                        return make_node(AST_Binary, el, {
	                            operator : "+",
	                            left     : prev,
	                            right    : el
	                        });
	                    }, first).optimize(compressor);
	                }
	                // need this awkward cloning to not affect original element
	                // best_of will decide which one to get through.
	                var node = self.clone();
	                node.expression = node.expression.clone();
	                node.expression.expression = node.expression.expression.clone();
	                node.expression.expression.elements = elements;
	                return best_of(compressor, self, node);
	            }
	            break;
	          case "charAt":
	            if (exp.expression.is_string(compressor)) {
	                var arg = self.args[0];
	                var index = arg ? arg.evaluate(compressor) : 0;
	                if (index !== arg) {
	                    return make_node(AST_Sub, exp, {
	                        expression: exp.expression,
	                        property: make_node_from_constant(index | 0, arg || exp)
	                    }).optimize(compressor);
	                }
	            }
	            break;
	          case "apply":
	            if (self.args.length == 2 && self.args[1] instanceof AST_Array) {
	                var args = self.args[1].elements.slice();
	                args.unshift(self.args[0]);
	                return make_node(AST_Call, self, {
	                    expression: make_node(AST_Dot, exp, {
	                        expression: exp.expression,
	                        optional: false,
	                        property: "call"
	                    }),
	                    args: args
	                }).optimize(compressor);
	            }
	            break;
	          case "call":
	            var func = exp.expression;
	            if (func instanceof AST_SymbolRef) {
	                func = func.fixed_value();
	            }
	            if (func instanceof AST_Lambda && !func.contains_this()) {
	                return (self.args.length ? make_sequence(this, [
	                    self.args[0],
	                    make_node(AST_Call, self, {
	                        expression: exp.expression,
	                        args: self.args.slice(1)
	                    })
	                ]) : make_node(AST_Call, self, {
	                    expression: exp.expression,
	                    args: []
	                })).optimize(compressor);
	            }
	            break;
	        }
	    }

	    if (compressor.option("unsafe_Function")
	        && is_undeclared_ref(exp)
	        && exp.name == "Function") {
	        // new Function() => function(){}
	        if (self.args.length == 0) return make_node(AST_Function, self, {
	            argnames: [],
	            body: []
	        }).optimize(compressor);
	        if (self.args.every((x) => x instanceof AST_String)) {
	            // quite a corner-case, but we can handle it:
	            //   https://github.com/mishoo/UglifyJS2/issues/203
	            // if the code argument is a constant, then we can minify it.
	            try {
	                var code = "n(function(" + self.args.slice(0, -1).map(function(arg) {
	                    return arg.value;
	                }).join(",") + "){" + self.args[self.args.length - 1].value + "})";
	                var ast = parse(code);
	                var mangle = compressor.mangle_options();
	                ast.figure_out_scope(mangle);
	                var comp = new Compressor(compressor.options, {
	                    mangle_options: compressor._mangle_options
	                });
	                ast = ast.transform(comp);
	                ast.figure_out_scope(mangle);
	                ast.compute_char_frequency(mangle);
	                ast.mangle_names(mangle);
	                var fun;
	                walk(ast, node => {
	                    if (is_func_expr(node)) {
	                        fun = node;
	                        return walk_abort;
	                    }
	                });
	                var code = OutputStream();
	                AST_BlockStatement.prototype._codegen.call(fun, fun, code);
	                self.args = [
	                    make_node(AST_String, self, {
	                        value: fun.argnames.map(function(arg) {
	                            return arg.print_to_string();
	                        }).join(",")
	                    }),
	                    make_node(AST_String, self.args[self.args.length - 1], {
	                        value: code.get().replace(/^{|}$/g, "")
	                    })
	                ];
	                return self;
	            } catch (ex) {
	                if (!(ex instanceof JS_Parse_Error)) {
	                    throw ex;
	                }

	                // Otherwise, it crashes at runtime. Or maybe it's nonstandard syntax.
	            }
	        }
	    }

	    return inline_into_call(self, compressor);
	});

	/** Does this node contain optional property access or optional call? */
	AST_Node.DEFMETHOD("contains_optional", function() {
	    if (
	        this instanceof AST_PropAccess
	        || this instanceof AST_Call
	        || this instanceof AST_Chain
	    ) {
	        if (this.optional) {
	            return true;
	        } else {
	            return this.expression.contains_optional();
	        }
	    } else {
	        return false;
	    }
	});

	def_optimize(AST_New, function(self, compressor) {
	    if (
	        compressor.option("unsafe") &&
	        is_undeclared_ref(self.expression) &&
	        ["Object", "RegExp", "Function", "Error", "Array"].includes(self.expression.name)
	    ) return make_node(AST_Call, self, self).transform(compressor);
	    return self;
	});

	def_optimize(AST_Sequence, function(self, compressor) {
	    if (!compressor.option("side_effects")) return self;
	    var expressions = [];
	    filter_for_side_effects();
	    var end = expressions.length - 1;
	    trim_right_for_undefined();
	    if (end == 0) {
	        self = maintain_this_binding(compressor.parent(), compressor.self(), expressions[0]);
	        if (!(self instanceof AST_Sequence)) self = self.optimize(compressor);
	        return self;
	    }
	    self.expressions = expressions;
	    return self;

	    function filter_for_side_effects() {
	        var first = first_in_statement(compressor);
	        var last = self.expressions.length - 1;
	        self.expressions.forEach(function(expr, index) {
	            if (index < last) expr = expr.drop_side_effect_free(compressor, first);
	            if (expr) {
	                merge_sequence(expressions, expr);
	                first = false;
	            }
	        });
	    }

	    function trim_right_for_undefined() {
	        while (end > 0 && is_undefined(expressions[end], compressor)) end--;
	        if (end < expressions.length - 1) {
	            expressions[end] = make_node(AST_UnaryPrefix, self, {
	                operator   : "void",
	                expression : expressions[end]
	            });
	            expressions.length = end + 1;
	        }
	    }
	});

	AST_Unary.DEFMETHOD("lift_sequences", function(compressor) {
	    if (compressor.option("sequences")) {
	        if (this.expression instanceof AST_Sequence) {
	            var x = this.expression.expressions.slice();
	            var e = this.clone();
	            e.expression = x.pop();
	            x.push(e);
	            return make_sequence(this, x).optimize(compressor);
	        }
	    }
	    return this;
	});

	def_optimize(AST_UnaryPostfix, function(self, compressor) {
	    return self.lift_sequences(compressor);
	});

	def_optimize(AST_UnaryPrefix, function(self, compressor) {
	    var e = self.expression;
	    if (
	        self.operator == "delete" &&
	        !(
	            e instanceof AST_SymbolRef ||
	            e instanceof AST_PropAccess ||
	            e instanceof AST_Chain ||
	            is_identifier_atom(e)
	        )
	    ) {
	        return make_sequence(self, [e, make_node(AST_True, self)]).optimize(compressor);
	    }
	    var seq = self.lift_sequences(compressor);
	    if (seq !== self) {
	        return seq;
	    }
	    if (compressor.option("side_effects") && self.operator == "void") {
	        e = e.drop_side_effect_free(compressor);
	        if (e) {
	            self.expression = e;
	            return self;
	        } else {
	            return make_node(AST_Undefined, self).optimize(compressor);
	        }
	    }
	    if (compressor.in_boolean_context()) {
	        switch (self.operator) {
	          case "!":
	            if (e instanceof AST_UnaryPrefix && e.operator == "!") {
	                // !!foo ==> foo, if we're in boolean context
	                return e.expression;
	            }
	            if (e instanceof AST_Binary) {
	                self = best_of(compressor, self, e.negate(compressor, first_in_statement(compressor)));
	            }
	            break;
	          case "typeof":
	            // typeof always returns a non-empty string, thus it's
	            // always true in booleans
	            // And we don't need to check if it's undeclared, because in typeof, that's OK
	            return (e instanceof AST_SymbolRef ? make_node(AST_True, self) : make_sequence(self, [
	                e,
	                make_node(AST_True, self)
	            ])).optimize(compressor);
	        }
	    }
	    if (self.operator == "-" && e instanceof AST_Infinity) {
	        e = e.transform(compressor);
	    }
	    if (e instanceof AST_Binary
	        && (self.operator == "+" || self.operator == "-")
	        && (e.operator == "*" || e.operator == "/" || e.operator == "%")) {
	        return make_node(AST_Binary, self, {
	            operator: e.operator,
	            left: make_node(AST_UnaryPrefix, e.left, {
	                operator: self.operator,
	                expression: e.left
	            }),
	            right: e.right
	        });
	    }

	    if (compressor.option("evaluate")) {
	        // ~~x => x (in 32-bit context)
	        // ~~{32 bit integer} => {32 bit integer}
	        if (
	            self.operator === "~"
	            && self.expression instanceof AST_UnaryPrefix
	            && self.expression.operator === "~"
	            && (compressor.in_32_bit_context() || self.expression.expression.is_32_bit_integer())
	        ) {
	            return self.expression.expression;
	        }

	        // ~(x ^ y) => x ^ ~y
	        if (
	            self.operator === "~"
	            && e instanceof AST_Binary
	            && e.operator === "^"
	        ) {
	            if (e.left instanceof AST_UnaryPrefix && e.left.operator === "~") {
	                // ~(~x ^ y) => x ^ y
	                e.left = e.left.bitwise_negate(true);
	            } else {
	                e.right = e.right.bitwise_negate(true);
	            }
	            return e;
	        }
	    }

	    if (
	        self.operator != "-"
	        // avoid infinite recursion of numerals
	        || !(e instanceof AST_Number || e instanceof AST_Infinity || e instanceof AST_BigInt)
	    ) {
	        var ev = self.evaluate(compressor);
	        if (ev !== self) {
	            ev = make_node_from_constant(ev, self).optimize(compressor);
	            return best_of(compressor, ev, self);
	        }
	    }
	    return self;
	});

	AST_Binary.DEFMETHOD("lift_sequences", function(compressor) {
	    if (compressor.option("sequences")) {
	        if (this.left instanceof AST_Sequence) {
	            var x = this.left.expressions.slice();
	            var e = this.clone();
	            e.left = x.pop();
	            x.push(e);
	            return make_sequence(this, x).optimize(compressor);
	        }
	        if (this.right instanceof AST_Sequence && !this.left.has_side_effects(compressor)) {
	            var assign = this.operator == "=" && this.left instanceof AST_SymbolRef;
	            var x = this.right.expressions;
	            var last = x.length - 1;
	            for (var i = 0; i < last; i++) {
	                if (!assign && x[i].has_side_effects(compressor)) break;
	            }
	            if (i == last) {
	                x = x.slice();
	                var e = this.clone();
	                e.right = x.pop();
	                x.push(e);
	                return make_sequence(this, x).optimize(compressor);
	            } else if (i > 0) {
	                var e = this.clone();
	                e.right = make_sequence(this.right, x.slice(i));
	                x = x.slice(0, i);
	                x.push(e);
	                return make_sequence(this, x).optimize(compressor);
	            }
	        }
	    }
	    return this;
	});

	var commutativeOperators = makePredicate("== === != !== * & | ^");
	function is_object(node) {
	    return node instanceof AST_Array
	        || node instanceof AST_Lambda
	        || node instanceof AST_Object
	        || node instanceof AST_Class;
	}

	def_optimize(AST_Binary, function(self, compressor) {
	    function reversible() {
	        return self.left.is_constant()
	            || self.right.is_constant()
	            || !self.left.has_side_effects(compressor)
	                && !self.right.has_side_effects(compressor);
	    }
	    function reverse(op) {
	        if (reversible()) {
	            if (op) self.operator = op;
	            var tmp = self.left;
	            self.left = self.right;
	            self.right = tmp;
	        }
	    }
	    if (compressor.option("lhs_constants") && commutativeOperators.has(self.operator)) {
	        if (self.right.is_constant()
	            && !self.left.is_constant()) {
	            // if right is a constant, whatever side effects the
	            // left side might have could not influence the
	            // result.  hence, force switch.

	            if (!(self.left instanceof AST_Binary
	                  && PRECEDENCE[self.left.operator] >= PRECEDENCE[self.operator])) {
	                reverse();
	            }
	        }
	    }
	    self = self.lift_sequences(compressor);
	    if (compressor.option("comparisons")) switch (self.operator) {
	      case "===":
	      case "!==":
	        var is_strict_comparison = true;
	        if ((self.left.is_string(compressor) && self.right.is_string(compressor)) ||
	            (self.left.is_number(compressor) && self.right.is_number(compressor)) ||
	            (self.left.is_boolean() && self.right.is_boolean()) ||
	            self.left.equivalent_to(self.right)) {
	            self.operator = self.operator.substr(0, 2);
	        }

	        // XXX: intentionally falling down to the next case
	      case "==":
	      case "!=":
	        // void 0 == x => null == x
	        if (!is_strict_comparison && is_undefined(self.left, compressor)) {
	            self.left = make_node(AST_Null, self.left);
	        // x == void 0 => x == null
	        } else if (!is_strict_comparison && is_undefined(self.right, compressor)) {
	            self.right = make_node(AST_Null, self.right);
	        } else if (compressor.option("typeofs")
	            // "undefined" == typeof x => undefined === x
	            && self.left instanceof AST_String
	            && self.left.value == "undefined"
	            && self.right instanceof AST_UnaryPrefix
	            && self.right.operator == "typeof") {
	            var expr = self.right.expression;
	            if (expr instanceof AST_SymbolRef ? expr.is_declared(compressor)
	                : !(expr instanceof AST_PropAccess && compressor.option("ie8"))) {
	                self.right = expr;
	                self.left = make_node(AST_Undefined, self.left).optimize(compressor);
	                if (self.operator.length == 2) self.operator += "=";
	            }
	        } else if (compressor.option("typeofs")
	            // typeof x === "undefined" => x === undefined
	            && self.left instanceof AST_UnaryPrefix
	            && self.left.operator == "typeof"
	            && self.right instanceof AST_String
	            && self.right.value == "undefined") {
	            var expr = self.left.expression;
	            if (expr instanceof AST_SymbolRef ? expr.is_declared(compressor)
	                : !(expr instanceof AST_PropAccess && compressor.option("ie8"))) {
	                self.left = expr;
	                self.right = make_node(AST_Undefined, self.right).optimize(compressor);
	                if (self.operator.length == 2) self.operator += "=";
	            }
	        } else if (self.left instanceof AST_SymbolRef
	            // obj !== obj => false
	            && self.right instanceof AST_SymbolRef
	            && self.left.definition() === self.right.definition()
	            && is_object(self.left.fixed_value())) {
	            return make_node(self.operator[0] == "=" ? AST_True : AST_False, self);
	        } else if (self.left.is_32_bit_integer() && self.right.is_32_bit_integer()) {
	            const not = node => make_node(AST_UnaryPrefix, node, {
	                operator: "!",
	                expression: node
	            });
	            const booleanify = (node, truthy) => {
	                if (truthy) {
	                    return compressor.in_boolean_context()
	                        ? node
	                        : not(not(node));
	                } else {
	                    return not(node);
	                }
	            };

	            // The only falsy 32-bit integer is 0
	            if (self.left instanceof AST_Number && self.left.value === 0) {
	                return booleanify(self.right, self.operator[0] === "!");
	            }
	            if (self.right instanceof AST_Number && self.right.value === 0) {
	                return booleanify(self.left, self.operator[0] === "!");
	            }

	            // Mask all-bits check
	            // (x & 0xFF) != 0xFF => !(~x & 0xFF)
	            let and_op, x, mask;
	            if (
	                (and_op =
	                    self.left instanceof AST_Binary ? self.left
	                    : self.right instanceof AST_Binary ? self.right : null)
	                && (mask = and_op === self.left ? self.right : self.left)
	                && and_op.operator === "&"
	                && mask instanceof AST_Number
	                && mask.is_32_bit_integer()
	                && (x =
	                    and_op.left.equivalent_to(mask) ? and_op.right
	                    : and_op.right.equivalent_to(mask) ? and_op.left : null)
	            ) {
	                let optimized = booleanify(make_node(AST_Binary, self, {
	                    operator: "&",
	                    left: mask,
	                    right: make_node(AST_UnaryPrefix, self, {
	                        operator: "~",
	                        expression: x
	                    })
	                }), self.operator[0] === "!");

	                return best_of(compressor, optimized, self);
	            }
	        }
	        break;
	      case "&&":
	      case "||":
	        var lhs = self.left;
	        if (lhs.operator == self.operator) {
	            lhs = lhs.right;
	        }
	        if (lhs instanceof AST_Binary
	            && lhs.operator == (self.operator == "&&" ? "!==" : "===")
	            && self.right instanceof AST_Binary
	            && lhs.operator == self.right.operator
	            && (is_undefined(lhs.left, compressor) && self.right.left instanceof AST_Null
	                || lhs.left instanceof AST_Null && is_undefined(self.right.left, compressor))
	            && !lhs.right.has_side_effects(compressor)
	            && lhs.right.equivalent_to(self.right.right)) {
	            var combined = make_node(AST_Binary, self, {
	                operator: lhs.operator.slice(0, -1),
	                left: make_node(AST_Null, self),
	                right: lhs.right
	            });
	            if (lhs !== self.left) {
	                combined = make_node(AST_Binary, self, {
	                    operator: self.operator,
	                    left: self.left.left,
	                    right: combined
	                });
	            }
	            return combined;
	        }
	        break;
	    }
	    if (self.operator == "+" && compressor.in_boolean_context()) {
	        var ll = self.left.evaluate(compressor);
	        var rr = self.right.evaluate(compressor);
	        if (ll && typeof ll == "string") {
	            return make_sequence(self, [
	                self.right,
	                make_node(AST_True, self)
	            ]).optimize(compressor);
	        }
	        if (rr && typeof rr == "string") {
	            return make_sequence(self, [
	                self.left,
	                make_node(AST_True, self)
	            ]).optimize(compressor);
	        }
	    }
	    if (compressor.option("comparisons") && self.is_boolean()) {
	        if (!(compressor.parent() instanceof AST_Binary)
	            || compressor.parent() instanceof AST_Assign) {
	            var negated = make_node(AST_UnaryPrefix, self, {
	                operator: "!",
	                expression: self.negate(compressor, first_in_statement(compressor))
	            });
	            self = best_of(compressor, self, negated);
	        }
	        if (compressor.option("unsafe_comps")) {
	            switch (self.operator) {
	              case "<": reverse(">"); break;
	              case "<=": reverse(">="); break;
	            }
	        }
	    }
	    if (self.operator == "+") {
	        if (self.right instanceof AST_String
	            && self.right.getValue() == ""
	            && self.left.is_string(compressor)) {
	            return self.left;
	        }
	        if (self.left instanceof AST_String
	            && self.left.getValue() == ""
	            && self.right.is_string(compressor)) {
	            return self.right;
	        }
	        if (self.left instanceof AST_Binary
	            && self.left.operator == "+"
	            && self.left.left instanceof AST_String
	            && self.left.left.getValue() == ""
	            && self.right.is_string(compressor)) {
	            self.left = self.left.right;
	            return self;
	        }
	    }
	    if (compressor.option("evaluate")) {
	        switch (self.operator) {
	          case "&&":
	            var ll = has_flag(self.left, TRUTHY)
	                ? true
	                : has_flag(self.left, FALSY)
	                    ? false
	                    : self.left.evaluate(compressor);
	            if (!ll) {
	                return maintain_this_binding(compressor.parent(), compressor.self(), self.left).optimize(compressor);
	            } else if (!(ll instanceof AST_Node)) {
	                return make_sequence(self, [ self.left, self.right ]).optimize(compressor);
	            }
	            var rr = self.right.evaluate(compressor);
	            if (!rr) {
	                if (compressor.in_boolean_context()) {
	                    return make_sequence(self, [
	                        self.left,
	                        make_node(AST_False, self)
	                    ]).optimize(compressor);
	                } else {
	                    set_flag(self, FALSY);
	                }
	            } else if (!(rr instanceof AST_Node)) {
	                var parent = compressor.parent();
	                if (parent.operator == "&&" && parent.left === compressor.self() || compressor.in_boolean_context()) {
	                    return self.left.optimize(compressor);
	                }
	            }
	            // x || false && y ---> x ? y : false
	            if (self.left.operator == "||") {
	                var lr = self.left.right.evaluate(compressor);
	                if (!lr) return make_node(AST_Conditional, self, {
	                    condition: self.left.left,
	                    consequent: self.right,
	                    alternative: self.left.right
	                }).optimize(compressor);
	            }
	            break;
	          case "||":
	            var ll = has_flag(self.left, TRUTHY)
	              ? true
	              : has_flag(self.left, FALSY)
	                ? false
	                : self.left.evaluate(compressor);
	            if (!ll) {
	                return make_sequence(self, [ self.left, self.right ]).optimize(compressor);
	            } else if (!(ll instanceof AST_Node)) {
	                return maintain_this_binding(compressor.parent(), compressor.self(), self.left).optimize(compressor);
	            }
	            var rr = self.right.evaluate(compressor);
	            if (!rr) {
	                var parent = compressor.parent();
	                if (parent.operator == "||" && parent.left === compressor.self() || compressor.in_boolean_context()) {
	                    return self.left.optimize(compressor);
	                }
	            } else if (!(rr instanceof AST_Node)) {
	                if (compressor.in_boolean_context()) {
	                    return make_sequence(self, [
	                        self.left,
	                        make_node(AST_True, self)
	                    ]).optimize(compressor);
	                } else {
	                    set_flag(self, TRUTHY);
	                }
	            }
	            if (self.left.operator == "&&") {
	                var lr = self.left.right.evaluate(compressor);
	                if (lr && !(lr instanceof AST_Node)) return make_node(AST_Conditional, self, {
	                    condition: self.left.left,
	                    consequent: self.left.right,
	                    alternative: self.right
	                }).optimize(compressor);
	            }
	            break;
	          case "??":
	            if (is_nullish(self.left, compressor)) {
	                return self.right;
	            }

	            var ll = self.left.evaluate(compressor);
	            if (!(ll instanceof AST_Node)) {
	                // if we know the value for sure we can simply compute right away.
	                return ll == null ? self.right : self.left;
	            }

	            if (compressor.in_boolean_context()) {
	                const rr = self.right.evaluate(compressor);
	                if (!(rr instanceof AST_Node) && !rr) {
	                    return self.left;
	                }
	            }
	        }
	        var associative = true;
	        switch (self.operator) {
	          case "+":
	            // (x + "foo") + "bar" => x + "foobar"
	            if (self.right instanceof AST_Constant
	                && self.left instanceof AST_Binary
	                && self.left.operator == "+"
	                && self.left.is_string(compressor)) {
	                var binary = make_node(AST_Binary, self, {
	                    operator: "+",
	                    left: self.left.right,
	                    right: self.right,
	                });
	                var r = binary.optimize(compressor);
	                if (binary !== r) {
	                    self = make_node(AST_Binary, self, {
	                        operator: "+",
	                        left: self.left.left,
	                        right: r
	                    });
	                }
	            }
	            // (x + "foo") + ("bar" + y) => (x + "foobar") + y
	            if (self.left instanceof AST_Binary
	                && self.left.operator == "+"
	                && self.left.is_string(compressor)
	                && self.right instanceof AST_Binary
	                && self.right.operator == "+"
	                && self.right.is_string(compressor)) {
	                var binary = make_node(AST_Binary, self, {
	                    operator: "+",
	                    left: self.left.right,
	                    right: self.right.left,
	                });
	                var m = binary.optimize(compressor);
	                if (binary !== m) {
	                    self = make_node(AST_Binary, self, {
	                        operator: "+",
	                        left: make_node(AST_Binary, self.left, {
	                            operator: "+",
	                            left: self.left.left,
	                            right: m
	                        }),
	                        right: self.right.right
	                    });
	                }
	            }
	            // a + -b => a - b
	            if (self.right instanceof AST_UnaryPrefix
	                && self.right.operator == "-"
	                && self.left.is_number(compressor)) {
	                self = make_node(AST_Binary, self, {
	                    operator: "-",
	                    left: self.left,
	                    right: self.right.expression
	                });
	                break;
	            }
	            // -a + b => b - a
	            if (self.left instanceof AST_UnaryPrefix
	                && self.left.operator == "-"
	                && reversible()
	                && self.right.is_number(compressor)) {
	                self = make_node(AST_Binary, self, {
	                    operator: "-",
	                    left: self.right,
	                    right: self.left.expression
	                });
	                break;
	            }
	            // `foo${bar}baz` + 1 => `foo${bar}baz1`
	            if (self.left instanceof AST_TemplateString) {
	                var l = self.left;
	                var r = self.right.evaluate(compressor);
	                if (r != self.right) {
	                    l.segments[l.segments.length - 1].value += String(r);
	                    return l;
	                }
	            }
	            // 1 + `foo${bar}baz` => `1foo${bar}baz`
	            if (self.right instanceof AST_TemplateString) {
	                var r = self.right;
	                var l = self.left.evaluate(compressor);
	                if (l != self.left) {
	                    r.segments[0].value = String(l) + r.segments[0].value;
	                    return r;
	                }
	            }
	            // `1${bar}2` + `foo${bar}baz` => `1${bar}2foo${bar}baz`
	            if (self.left instanceof AST_TemplateString
	                && self.right instanceof AST_TemplateString) {
	                var l = self.left;
	                var segments = l.segments;
	                var r = self.right;
	                segments[segments.length - 1].value += r.segments[0].value;
	                for (var i = 1; i < r.segments.length; i++) {
	                    segments.push(r.segments[i]);
	                }
	                return l;
	            }
	          case "*":
	            associative = compressor.option("unsafe_math");
	          case "&":
	          case "|":
	          case "^":
	            // a + +b => +b + a
	            if (self.left.is_number(compressor)
	                && self.right.is_number(compressor)
	                && reversible()
	                && !(self.left instanceof AST_Binary
	                    && self.left.operator != self.operator
	                    && PRECEDENCE[self.left.operator] >= PRECEDENCE[self.operator])) {
	                var reversed = make_node(AST_Binary, self, {
	                    operator: self.operator,
	                    left: self.right,
	                    right: self.left
	                });
	                if (self.right instanceof AST_Constant
	                    && !(self.left instanceof AST_Constant)) {
	                    self = best_of(compressor, reversed, self);
	                } else {
	                    self = best_of(compressor, self, reversed);
	                }
	            }
	            if (associative && self.is_number(compressor)) {
	                // a + (b + c) => (a + b) + c
	                if (self.right instanceof AST_Binary
	                    && self.right.operator == self.operator) {
	                    self = make_node(AST_Binary, self, {
	                        operator: self.operator,
	                        left: make_node(AST_Binary, self.left, {
	                            operator: self.operator,
	                            left: self.left,
	                            right: self.right.left,
	                            start: self.left.start,
	                            end: self.right.left.end
	                        }),
	                        right: self.right.right
	                    });
	                }
	                // (n + 2) + 3 => 5 + n
	                // (2 * n) * 3 => 6 + n
	                if (self.right instanceof AST_Constant
	                    && self.left instanceof AST_Binary
	                    && self.left.operator == self.operator) {
	                    if (self.left.left instanceof AST_Constant) {
	                        self = make_node(AST_Binary, self, {
	                            operator: self.operator,
	                            left: make_node(AST_Binary, self.left, {
	                                operator: self.operator,
	                                left: self.left.left,
	                                right: self.right,
	                                start: self.left.left.start,
	                                end: self.right.end
	                            }),
	                            right: self.left.right
	                        });
	                    } else if (self.left.right instanceof AST_Constant) {
	                        self = make_node(AST_Binary, self, {
	                            operator: self.operator,
	                            left: make_node(AST_Binary, self.left, {
	                                operator: self.operator,
	                                left: self.left.right,
	                                right: self.right,
	                                start: self.left.right.start,
	                                end: self.right.end
	                            }),
	                            right: self.left.left
	                        });
	                    }
	                }
	                // (a | 1) | (2 | d) => (3 | a) | b
	                if (self.left instanceof AST_Binary
	                    && self.left.operator == self.operator
	                    && self.left.right instanceof AST_Constant
	                    && self.right instanceof AST_Binary
	                    && self.right.operator == self.operator
	                    && self.right.left instanceof AST_Constant) {
	                    self = make_node(AST_Binary, self, {
	                        operator: self.operator,
	                        left: make_node(AST_Binary, self.left, {
	                            operator: self.operator,
	                            left: make_node(AST_Binary, self.left.left, {
	                                operator: self.operator,
	                                left: self.left.right,
	                                right: self.right.left,
	                                start: self.left.right.start,
	                                end: self.right.left.end
	                            }),
	                            right: self.left.left
	                        }),
	                        right: self.right.right
	                    });
	                }
	            }
	        }

	        // bitwise ops
	        if (bitwise_binop.has(self.operator)) {
	            // Use De Morgan's laws
	            // z & (X | y)
	            // => z & X (given y & z === 0)
	            // => z & X | {y & z} (given y & z !== 0)
	            let y, z, x_node, y_node, z_node = self.left;
	            if (
	                self.operator === "&"
	                && self.right instanceof AST_Binary
	                && self.right.operator === "|"
	                && typeof (z = self.left.evaluate(compressor)) === "number"
	            ) {
	                if (typeof (y = self.right.right.evaluate(compressor)) === "number") {
	                    // z & (X | y)
	                    x_node = self.right.left;
	                    y_node = self.right.right;
	                } else if (typeof (y = self.right.left.evaluate(compressor)) === "number") {
	                    // z & (y | X)
	                    x_node = self.right.right;
	                    y_node = self.right.left;
	                }

	                if (x_node && y_node) {
	                    if ((y & z) === 0) {
	                        self = make_node(AST_Binary, self, {
	                            operator: self.operator,
	                            left: z_node,
	                            right: x_node
	                        });
	                    } else {
	                        const reordered_ops = make_node(AST_Binary, self, {
	                            operator: "|",
	                            left: make_node(AST_Binary, self, {
	                                operator: "&",
	                                left: x_node,
	                                right: z_node
	                            }),
	                            right: make_node_from_constant(y & z, y_node),
	                        });

	                        self = best_of(compressor, self, reordered_ops);
	                    }
	                }
	            }

	            // x ^ x => 0
	            // x | x => 0 | x
	            // x & x => 0 | x
	            const same_operands = self.left.equivalent_to(self.right) && !self.left.has_side_effects(compressor);
	            if (same_operands) {
	                if (self.operator === "^") {
	                    return make_node(AST_Number, self, { value: 0 });
	                }
	                if (self.operator === "|" || self.operator === "&") {
	                    self.left = make_node(AST_Number, self, { value: 0 });
	                    self.operator = "|";
	                }
	            }


	            // Shifts that do nothing
	            // {anything} >> 0 => {anything} | 0
	            // {anything} << 0 => {anything} | 0
	            if (
	                (self.operator === "<<" || self.operator === ">>")
	                && self.right instanceof AST_Number && self.right.value === 0
	            ) {
	                self.operator = "|";
	            }

	            // Find useless to-bitwise conversions
	            // {32 bit integer} | 0 => {32 bit integer}
	            // {32 bit integer} ^ 0 => {32 bit integer}
	            const zero_side = self.right instanceof AST_Number && self.right.value === 0 ? self.right
	                : self.left instanceof AST_Number && self.left.value === 0 ? self.left
	                : null;
	            const non_zero_side = zero_side && (zero_side === self.right ? self.left : self.right);
	            if (
	                zero_side
	                && (self.operator === "|" || self.operator === "^")
	                && (non_zero_side.is_32_bit_integer() || compressor.in_32_bit_context())
	            ) {
	                return non_zero_side;
	            }

	            // {anything} & 0 => 0
	            if (
	                zero_side
	                && self.operator === "&"
	                && !non_zero_side.has_side_effects(compressor)
	            ) {
	                return zero_side;
	            }

	            const is_full_mask = (node) =>
	                node instanceof AST_Number && node.value === -1
	                ||
	                    node instanceof AST_UnaryPrefix && (
	                        node.operator === "-"
	                            && node.expression instanceof AST_Number
	                            && node.expression.value === 1
	                        || node.operator === "~"
	                            && node.expression instanceof AST_Number
	                            && node.expression.value === 0);

	            const full_mask = is_full_mask(self.right) ? self.right
	                : is_full_mask(self.left) ? self.left
	                : null;
	            const non_full_mask_side = full_mask && (full_mask === self.right ? self.left : self.right);

	            switch (self.operator) {
	              case "|":
	                // {anything} | -1 => -1
	                if (full_mask && !non_full_mask_side.has_side_effects(compressor)) {
	                    return full_mask;
	                }

	                break;
	              case "&":
	                // {32 bit integer} & -1 => {32 bit integer}
	                if (
	                    full_mask
	                    && (non_full_mask_side.is_32_bit_integer() || compressor.in_32_bit_context())
	                ) {
	                    return non_full_mask_side;
	                }

	                break;
	              case "^":
	                // {anything} ^ -1 => ~{anything}
	                if (full_mask) {
	                    return non_full_mask_side.bitwise_negate(compressor.in_32_bit_context());
	                }

	                // ~x ^ ~y => x ^ y
	                if (
	                    self.left instanceof AST_UnaryPrefix
	                    && self.left.operator === "~"
	                    && self.right instanceof AST_UnaryPrefix
	                    && self.right.operator === "~"
	                ) {
	                    self = make_node(AST_Binary, self, {
	                        operator: "^",
	                        left: self.left.expression,
	                        right: self.right.expression
	                    });
	                }

	                break;
	            }
	        }
	    }
	    // x && (y && z)  ==>  x && y && z
	    // x || (y || z)  ==>  x || y || z
	    // x + ("y" + z)  ==>  x + "y" + z
	    // "x" + (y + "z")==>  "x" + y + "z"
	    if (self.right instanceof AST_Binary
	        && self.right.operator == self.operator
	        && (lazy_op.has(self.operator)
	            || (self.operator == "+"
	                && (self.right.left.is_string(compressor)
	                    || (self.left.is_string(compressor)
	                        && self.right.right.is_string(compressor)))))
	    ) {
	        self.left = make_node(AST_Binary, self.left, {
	            operator : self.operator,
	            left     : self.left.transform(compressor),
	            right    : self.right.left.transform(compressor)
	        });
	        self.right = self.right.right.transform(compressor);
	        return self.transform(compressor);
	    }
	    var ev = self.evaluate(compressor);
	    if (ev !== self) {
	        ev = make_node_from_constant(ev, self).optimize(compressor);
	        return best_of(compressor, ev, self);
	    }
	    return self;
	});

	def_optimize(AST_SymbolExport, function(self) {
	    return self;
	});

	def_optimize(AST_SymbolRef, function(self, compressor) {
	    if (
	        !compressor.option("ie8")
	        && is_undeclared_ref(self)
	        && !compressor.find_parent(AST_With)
	    ) {
	        switch (self.name) {
	          case "undefined":
	            return make_node(AST_Undefined, self).optimize(compressor);
	          case "NaN":
	            return make_node(AST_NaN, self).optimize(compressor);
	          case "Infinity":
	            return make_node(AST_Infinity, self).optimize(compressor);
	        }
	    }

	    if (compressor.option("reduce_vars") && !compressor.is_lhs()) {
	        return inline_into_symbolref(self, compressor);
	    } else {
	        return self;
	    }
	});

	function is_atomic(lhs, self) {
	    return lhs instanceof AST_SymbolRef || lhs.TYPE === self.TYPE;
	}

	def_optimize(AST_Undefined, function(self, compressor) {
	    if (compressor.option("unsafe_undefined")) {
	        var undef = find_variable(compressor, "undefined");
	        if (undef) {
	            var ref = make_node(AST_SymbolRef, self, {
	                name   : "undefined",
	                scope  : undef.scope,
	                thedef : undef
	            });
	            set_flag(ref, UNDEFINED);
	            return ref;
	        }
	    }
	    var lhs = compressor.is_lhs();
	    if (lhs && is_atomic(lhs, self)) return self;
	    return make_node(AST_UnaryPrefix, self, {
	        operator: "void",
	        expression: make_node(AST_Number, self, {
	            value: 0
	        })
	    });
	});

	def_optimize(AST_Infinity, function(self, compressor) {
	    var lhs = compressor.is_lhs();
	    if (lhs && is_atomic(lhs, self)) return self;
	    if (
	        compressor.option("keep_infinity")
	        && !(lhs && !is_atomic(lhs, self))
	        && !find_variable(compressor, "Infinity")
	    ) {
	        return self;
	    }
	    return make_node(AST_Binary, self, {
	        operator: "/",
	        left: make_node(AST_Number, self, {
	            value: 1
	        }),
	        right: make_node(AST_Number, self, {
	            value: 0
	        })
	    });
	});

	def_optimize(AST_NaN, function(self, compressor) {
	    var lhs = compressor.is_lhs();
	    if (lhs && !is_atomic(lhs, self)
	        || find_variable(compressor, "NaN")) {
	        return make_node(AST_Binary, self, {
	            operator: "/",
	            left: make_node(AST_Number, self, {
	                value: 0
	            }),
	            right: make_node(AST_Number, self, {
	                value: 0
	            })
	        });
	    }
	    return self;
	});

	const ASSIGN_OPS = makePredicate("+ - / * % >> << >>> | ^ &");
	const ASSIGN_OPS_COMMUTATIVE = makePredicate("* | ^ &");
	def_optimize(AST_Assign, function(self, compressor) {
	    if (self.logical) {
	        return self.lift_sequences(compressor);
	    }

	    var def;
	    // x = x ---> x
	    if (
	        self.operator === "="
	        && self.left instanceof AST_SymbolRef
	        && self.left.name !== "arguments"
	        && !(def = self.left.definition()).undeclared
	        && self.right.equivalent_to(self.left)
	    ) {
	        return self.right;
	    }

	    if (compressor.option("dead_code")
	        && self.left instanceof AST_SymbolRef
	        && (def = self.left.definition()).scope === compressor.find_parent(AST_Lambda)) {
	        var level = 0, node, parent = self;
	        do {
	            node = parent;
	            parent = compressor.parent(level++);
	            if (parent instanceof AST_Exit) {
	                if (in_try(level, parent)) break;
	                if (is_reachable(def.scope, [ def ])) break;
	                if (self.operator == "=") return self.right;
	                def.fixed = false;
	                return make_node(AST_Binary, self, {
	                    operator: self.operator.slice(0, -1),
	                    left: self.left,
	                    right: self.right
	                }).optimize(compressor);
	            }
	        } while (parent instanceof AST_Binary && parent.right === node
	            || parent instanceof AST_Sequence && parent.tail_node() === node);
	    }
	    self = self.lift_sequences(compressor);

	    if (self.operator == "=" && self.left instanceof AST_SymbolRef && self.right instanceof AST_Binary) {
	        // x = expr1 OP expr2
	        if (self.right.left instanceof AST_SymbolRef
	            && self.right.left.name == self.left.name
	            && ASSIGN_OPS.has(self.right.operator)) {
	            // x = x - 2  --->  x -= 2
	            self.operator = self.right.operator + "=";
	            self.right = self.right.right;
	        } else if (self.right.right instanceof AST_SymbolRef
	            && self.right.right.name == self.left.name
	            && ASSIGN_OPS_COMMUTATIVE.has(self.right.operator)
	            && !self.right.left.has_side_effects(compressor)) {
	            // x = 2 & x  --->  x &= 2
	            self.operator = self.right.operator + "=";
	            self.right = self.right.left;
	        }
	    }
	    return self;

	    function in_try(level, node) {
	        function may_assignment_throw() {
	            const right = self.right;
	            self.right = make_node(AST_Null, right);
	            const may_throw = node.may_throw(compressor);
	            self.right = right;

	            return may_throw;
	        }

	        var stop_at = self.left.definition().scope.get_defun_scope();
	        var parent;
	        while ((parent = compressor.parent(level++)) !== stop_at) {
	            if (parent instanceof AST_Try) {
	                if (parent.bfinally) return true;
	                if (parent.bcatch && may_assignment_throw()) return true;
	            }
	        }
	    }
	});

	def_optimize(AST_DefaultAssign, function(self, compressor) {
	    if (!compressor.option("evaluate")) {
	        return self;
	    }
	    var evaluateRight = self.right.evaluate(compressor);

	    // `[x = undefined] = foo` ---> `[x] = foo`
	    // `(arg = undefined) => ...` ---> `(arg) => ...` (unless `keep_fargs`)
	    // `((arg = undefined) => ...)()` ---> `((arg) => ...)()`
	    let lambda, iife;
	    if (evaluateRight === undefined) {
	        if (
	            (lambda = compressor.parent()) instanceof AST_Lambda
	                ? (
	                    compressor.option("keep_fargs") === false
	                    || (iife = compressor.parent(1)).TYPE === "Call"
	                        && iife.expression === lambda
	                )
	                : true
	        ) {
	            self = self.left;
	        }
	    } else if (evaluateRight !== self.right) {
	        evaluateRight = make_node_from_constant(evaluateRight, self.right);
	        self.right = best_of_expression(evaluateRight, self.right);
	    }

	    return self;
	});

	function is_nullish_check(check, check_subject, compressor) {
	    if (check_subject.may_throw(compressor)) return false;

	    let nullish_side;

	    // foo == null
	    if (
	        check instanceof AST_Binary
	        && check.operator === "=="
	        // which side is nullish?
	        && (
	            (nullish_side = is_nullish(check.left, compressor) && check.left)
	            || (nullish_side = is_nullish(check.right, compressor) && check.right)
	        )
	        // is the other side the same as the check_subject
	        && (
	            nullish_side === check.left
	                ? check.right
	                : check.left
	        ).equivalent_to(check_subject)
	    ) {
	        return true;
	    }

	    // foo === null || foo === undefined
	    if (check instanceof AST_Binary && check.operator === "||") {
	        let null_cmp;
	        let undefined_cmp;

	        const find_comparison = cmp => {
	            if (!(
	                cmp instanceof AST_Binary
	                && (cmp.operator === "===" || cmp.operator === "==")
	            )) {
	                return false;
	            }

	            let found = 0;
	            let defined_side;

	            if (cmp.left instanceof AST_Null) {
	                found++;
	                null_cmp = cmp;
	                defined_side = cmp.right;
	            }
	            if (cmp.right instanceof AST_Null) {
	                found++;
	                null_cmp = cmp;
	                defined_side = cmp.left;
	            }
	            if (is_undefined(cmp.left, compressor)) {
	                found++;
	                undefined_cmp = cmp;
	                defined_side = cmp.right;
	            }
	            if (is_undefined(cmp.right, compressor)) {
	                found++;
	                undefined_cmp = cmp;
	                defined_side = cmp.left;
	            }

	            if (found !== 1) {
	                return false;
	            }

	            if (!defined_side.equivalent_to(check_subject)) {
	                return false;
	            }

	            return true;
	        };

	        if (!find_comparison(check.left)) return false;
	        if (!find_comparison(check.right)) return false;

	        if (null_cmp && undefined_cmp && null_cmp !== undefined_cmp) {
	            return true;
	        }
	    }

	    return false;
	}

	def_optimize(AST_Conditional, function(self, compressor) {
	    if (!compressor.option("conditionals")) return self;
	    // This looks like lift_sequences(), should probably be under "sequences"
	    if (self.condition instanceof AST_Sequence) {
	        var expressions = self.condition.expressions.slice();
	        self.condition = expressions.pop();
	        expressions.push(self);
	        return make_sequence(self, expressions);
	    }
	    var cond = self.condition.evaluate(compressor);
	    if (cond !== self.condition) {
	        if (cond) {
	            return maintain_this_binding(compressor.parent(), compressor.self(), self.consequent);
	        } else {
	            return maintain_this_binding(compressor.parent(), compressor.self(), self.alternative);
	        }
	    }
	    var negated = cond.negate(compressor, first_in_statement(compressor));
	    if (best_of(compressor, cond, negated) === negated) {
	        self = make_node(AST_Conditional, self, {
	            condition: negated,
	            consequent: self.alternative,
	            alternative: self.consequent
	        });
	    }
	    var condition = self.condition;
	    var consequent = self.consequent;
	    var alternative = self.alternative;
	    // x?x:y --> x||y
	    if (condition instanceof AST_SymbolRef
	        && consequent instanceof AST_SymbolRef
	        && condition.definition() === consequent.definition()) {
	        return make_node(AST_Binary, self, {
	            operator: "||",
	            left: condition,
	            right: alternative
	        });
	    }
	    // if (foo) exp = something; else exp = something_else;
	    //                   |
	    //                   v
	    // exp = foo ? something : something_else;
	    if (
	        consequent instanceof AST_Assign
	        && alternative instanceof AST_Assign
	        && consequent.operator === alternative.operator
	        && consequent.logical === alternative.logical
	        && consequent.left.equivalent_to(alternative.left)
	        && (!self.condition.has_side_effects(compressor)
	            || consequent.operator == "="
	                && !consequent.left.has_side_effects(compressor))
	    ) {
	        return make_node(AST_Assign, self, {
	            operator: consequent.operator,
	            left: consequent.left,
	            logical: consequent.logical,
	            right: make_node(AST_Conditional, self, {
	                condition: self.condition,
	                consequent: consequent.right,
	                alternative: alternative.right
	            })
	        });
	    }
	    // x ? y(a) : y(b) --> y(x ? a : b)
	    var arg_index;
	    if (consequent instanceof AST_Call
	        && alternative.TYPE === consequent.TYPE
	        && consequent.args.length > 0
	        && consequent.args.length == alternative.args.length
	        && consequent.expression.equivalent_to(alternative.expression)
	        && !self.condition.has_side_effects(compressor)
	        && !consequent.expression.has_side_effects(compressor)
	        && typeof (arg_index = single_arg_diff()) == "number") {
	        var node = consequent.clone();
	        node.args[arg_index] = make_node(AST_Conditional, self, {
	            condition: self.condition,
	            consequent: consequent.args[arg_index],
	            alternative: alternative.args[arg_index]
	        });
	        return node;
	    }
	    // a ? b : c ? b : d --> (a || c) ? b : d
	    if (alternative instanceof AST_Conditional
	        && consequent.equivalent_to(alternative.consequent)) {
	        return make_node(AST_Conditional, self, {
	            condition: make_node(AST_Binary, self, {
	                operator: "||",
	                left: condition,
	                right: alternative.condition
	            }),
	            consequent: consequent,
	            alternative: alternative.alternative
	        }).optimize(compressor);
	    }

	    // a == null ? b : a -> a ?? b
	    if (
	        compressor.option("ecma") >= 2020 &&
	        is_nullish_check(condition, alternative, compressor)
	    ) {
	        return make_node(AST_Binary, self, {
	            operator: "??",
	            left: alternative,
	            right: consequent
	        }).optimize(compressor);
	    }

	    // a ? b : (c, b) --> (a || c), b
	    if (alternative instanceof AST_Sequence
	        && consequent.equivalent_to(alternative.expressions[alternative.expressions.length - 1])) {
	        return make_sequence(self, [
	            make_node(AST_Binary, self, {
	                operator: "||",
	                left: condition,
	                right: make_sequence(self, alternative.expressions.slice(0, -1))
	            }),
	            consequent
	        ]).optimize(compressor);
	    }
	    // a ? b : (c && b) --> (a || c) && b
	    if (alternative instanceof AST_Binary
	        && alternative.operator == "&&"
	        && consequent.equivalent_to(alternative.right)) {
	        return make_node(AST_Binary, self, {
	            operator: "&&",
	            left: make_node(AST_Binary, self, {
	                operator: "||",
	                left: condition,
	                right: alternative.left
	            }),
	            right: consequent
	        }).optimize(compressor);
	    }
	    // x?y?z:a:a --> x&&y?z:a
	    if (consequent instanceof AST_Conditional
	        && consequent.alternative.equivalent_to(alternative)) {
	        return make_node(AST_Conditional, self, {
	            condition: make_node(AST_Binary, self, {
	                left: self.condition,
	                operator: "&&",
	                right: consequent.condition
	            }),
	            consequent: consequent.consequent,
	            alternative: alternative
	        });
	    }
	    // x ? y : y --> x, y
	    if (consequent.equivalent_to(alternative)) {
	        return make_sequence(self, [
	            self.condition,
	            consequent
	        ]).optimize(compressor);
	    }
	    // x ? y || z : z --> x && y || z
	    if (consequent instanceof AST_Binary
	        && consequent.operator == "||"
	        && consequent.right.equivalent_to(alternative)) {
	        return make_node(AST_Binary, self, {
	            operator: "||",
	            left: make_node(AST_Binary, self, {
	                operator: "&&",
	                left: self.condition,
	                right: consequent.left
	            }),
	            right: alternative
	        }).optimize(compressor);
	    }

	    const in_bool = compressor.in_boolean_context();
	    if (is_true(self.consequent)) {
	        if (is_false(self.alternative)) {
	            // c ? true : false ---> !!c
	            return booleanize(self.condition);
	        }
	        // c ? true : x ---> !!c || x
	        return make_node(AST_Binary, self, {
	            operator: "||",
	            left: booleanize(self.condition),
	            right: self.alternative
	        });
	    }
	    if (is_false(self.consequent)) {
	        if (is_true(self.alternative)) {
	            // c ? false : true ---> !c
	            return booleanize(self.condition.negate(compressor));
	        }
	        // c ? false : x ---> !c && x
	        return make_node(AST_Binary, self, {
	            operator: "&&",
	            left: booleanize(self.condition.negate(compressor)),
	            right: self.alternative
	        });
	    }
	    if (is_true(self.alternative)) {
	        // c ? x : true ---> !c || x
	        return make_node(AST_Binary, self, {
	            operator: "||",
	            left: booleanize(self.condition.negate(compressor)),
	            right: self.consequent
	        });
	    }
	    if (is_false(self.alternative)) {
	        // c ? x : false ---> !!c && x
	        return make_node(AST_Binary, self, {
	            operator: "&&",
	            left: booleanize(self.condition),
	            right: self.consequent
	        });
	    }

	    return self;

	    function booleanize(node) {
	        if (node.is_boolean()) return node;
	        // !!expression
	        return make_node(AST_UnaryPrefix, node, {
	            operator: "!",
	            expression: node.negate(compressor)
	        });
	    }

	    // AST_True or !0
	    function is_true(node) {
	        return node instanceof AST_True
	            || in_bool
	                && node instanceof AST_Constant
	                && node.getValue()
	            || (node instanceof AST_UnaryPrefix
	                && node.operator == "!"
	                && node.expression instanceof AST_Constant
	                && !node.expression.getValue());
	    }
	    // AST_False or !1
	    function is_false(node) {
	        return node instanceof AST_False
	            || in_bool
	                && node instanceof AST_Constant
	                && !node.getValue()
	            || (node instanceof AST_UnaryPrefix
	                && node.operator == "!"
	                && node.expression instanceof AST_Constant
	                && node.expression.getValue());
	    }

	    function single_arg_diff() {
	        var a = consequent.args;
	        var b = alternative.args;
	        for (var i = 0, len = a.length; i < len; i++) {
	            if (a[i] instanceof AST_Expansion) return;
	            if (!a[i].equivalent_to(b[i])) {
	                if (b[i] instanceof AST_Expansion) return;
	                for (var j = i + 1; j < len; j++) {
	                    if (a[j] instanceof AST_Expansion) return;
	                    if (!a[j].equivalent_to(b[j])) return;
	                }
	                return i;
	            }
	        }
	    }
	});

	def_optimize(AST_Boolean, function(self, compressor) {
	    if (compressor.in_boolean_context()) return make_node(AST_Number, self, {
	        value: +self.value
	    });
	    var p = compressor.parent();
	    if (compressor.option("booleans_as_integers")) {
	        if (p instanceof AST_Binary && (p.operator == "===" || p.operator == "!==")) {
	            p.operator = p.operator.replace(/=$/, "");
	        }
	        return make_node(AST_Number, self, {
	            value: +self.value
	        });
	    }
	    if (compressor.option("booleans")) {
	        if (p instanceof AST_Binary && (p.operator == "=="
	                                        || p.operator == "!=")) {
	            return make_node(AST_Number, self, {
	                value: +self.value
	            });
	        }
	        return make_node(AST_UnaryPrefix, self, {
	            operator: "!",
	            expression: make_node(AST_Number, self, {
	                value: 1 - self.value
	            })
	        });
	    }
	    return self;
	});

	function safe_to_flatten(value, compressor) {
	    if (value instanceof AST_SymbolRef) {
	        value = value.fixed_value();
	    }
	    if (!value) return false;
	    if (!(value instanceof AST_Lambda || value instanceof AST_Class)) return true;
	    if (!(value instanceof AST_Lambda && value.contains_this())) return true;
	    return compressor.parent() instanceof AST_New;
	}

	AST_PropAccess.DEFMETHOD("flatten_object", function(key, compressor) {
	    if (!compressor.option("properties")) return;
	    if (key === "__proto__") return;

	    var arrows = compressor.option("unsafe_arrows") && compressor.option("ecma") >= 2015;
	    var expr = this.expression;
	    if (expr instanceof AST_Object) {
	        var props = expr.properties;

	        for (var i = props.length; --i >= 0;) {
	            var prop = props[i];

	            if ("" + (prop instanceof AST_ConciseMethod ? prop.key.name : prop.key) == key) {
	                const all_props_flattenable = props.every((p) =>
	                    (p instanceof AST_ObjectKeyVal
	                        || arrows && p instanceof AST_ConciseMethod && !p.is_generator
	                    )
	                    && !p.computed_key()
	                );

	                if (!all_props_flattenable) return;
	                if (!safe_to_flatten(prop.value, compressor)) return;

	                return make_node(AST_Sub, this, {
	                    expression: make_node(AST_Array, expr, {
	                        elements: props.map(function(prop) {
	                            var v = prop.value;
	                            if (v instanceof AST_Accessor) {
	                                v = make_node(AST_Function, v, v);
	                            }

	                            var k = prop.key;
	                            if (k instanceof AST_Node && !(k instanceof AST_SymbolMethod)) {
	                                return make_sequence(prop, [ k, v ]);
	                            }

	                            return v;
	                        })
	                    }),
	                    property: make_node(AST_Number, this, {
	                        value: i
	                    })
	                });
	            }
	        }
	    }
	});

	def_optimize(AST_Sub, function(self, compressor) {
	    var expr = self.expression;
	    var prop = self.property;
	    if (compressor.option("properties")) {
	        var key = prop.evaluate(compressor);
	        if (key !== prop) {
	            if (typeof key == "string") {
	                if (key == "undefined") {
	                    key = undefined;
	                } else {
	                    var value = parseFloat(key);
	                    if (value.toString() == key) {
	                        key = value;
	                    }
	                }
	            }
	            prop = self.property = best_of_expression(
	                prop,
	                make_node_from_constant(key, prop).transform(compressor)
	            );
	            var property = "" + key;
	            if (is_basic_identifier_string(property)
	                && property.length <= prop.size() + 1) {
	                return make_node(AST_Dot, self, {
	                    expression: expr,
	                    optional: self.optional,
	                    property: property,
	                    quote: prop.quote,
	                }).optimize(compressor);
	            }
	        }
	    }
	    var fn;
	    OPT_ARGUMENTS: if (compressor.option("arguments")
	        && expr instanceof AST_SymbolRef
	        && expr.name == "arguments"
	        && expr.definition().orig.length == 1
	        && (fn = expr.scope) instanceof AST_Lambda
	        && fn.uses_arguments
	        && !(fn instanceof AST_Arrow)
	        && prop instanceof AST_Number) {
	        var index = prop.getValue();
	        var params = new Set();
	        var argnames = fn.argnames;
	        for (var n = 0; n < argnames.length; n++) {
	            if (!(argnames[n] instanceof AST_SymbolFunarg)) {
	                break OPT_ARGUMENTS; // destructuring parameter - bail
	            }
	            var param = argnames[n].name;
	            if (params.has(param)) {
	                break OPT_ARGUMENTS; // duplicate parameter - bail
	            }
	            params.add(param);
	        }
	        var argname = fn.argnames[index];
	        if (argname && compressor.has_directive("use strict")) {
	            var def = argname.definition();
	            if (!compressor.option("reduce_vars") || def.assignments || def.orig.length > 1) {
	                argname = null;
	            }
	        } else if (!argname && !compressor.option("keep_fargs") && index < fn.argnames.length + 5) {
	            while (index >= fn.argnames.length) {
	                argname = fn.create_symbol(AST_SymbolFunarg, {
	                    source: fn,
	                    scope: fn,
	                    tentative_name: "argument_" + fn.argnames.length,
	                });
	                fn.argnames.push(argname);
	            }
	        }
	        if (argname) {
	            var sym = make_node(AST_SymbolRef, self, argname);
	            sym.reference({});
	            clear_flag(argname, UNUSED);
	            return sym;
	        }
	    }
	    if (compressor.is_lhs()) return self;
	    if (key !== prop) {
	        var sub = self.flatten_object(property, compressor);
	        if (sub) {
	            expr = self.expression = sub.expression;
	            prop = self.property = sub.property;
	        }
	    }
	    if (compressor.option("properties") && compressor.option("side_effects")
	        && prop instanceof AST_Number && expr instanceof AST_Array) {
	        var index = prop.getValue();
	        var elements = expr.elements;
	        var retValue = elements[index];
	        FLATTEN: if (safe_to_flatten(retValue, compressor)) {
	            var flatten = true;
	            var values = [];
	            for (var i = elements.length; --i > index;) {
	                var value = elements[i].drop_side_effect_free(compressor);
	                if (value) {
	                    values.unshift(value);
	                    if (flatten && value.has_side_effects(compressor)) flatten = false;
	                }
	            }
	            if (retValue instanceof AST_Expansion) break FLATTEN;
	            retValue = retValue instanceof AST_Hole ? make_node(AST_Undefined, retValue) : retValue;
	            if (!flatten) values.unshift(retValue);
	            while (--i >= 0) {
	                var value = elements[i];
	                if (value instanceof AST_Expansion) break FLATTEN;
	                value = value.drop_side_effect_free(compressor);
	                if (value) values.unshift(value);
	                else index--;
	            }
	            if (flatten) {
	                values.push(retValue);
	                return make_sequence(self, values).optimize(compressor);
	            } else return make_node(AST_Sub, self, {
	                expression: make_node(AST_Array, expr, {
	                    elements: values
	                }),
	                property: make_node(AST_Number, prop, {
	                    value: index
	                })
	            });
	        }
	    }
	    var ev = self.evaluate(compressor);
	    if (ev !== self) {
	        ev = make_node_from_constant(ev, self).optimize(compressor);
	        return best_of(compressor, ev, self);
	    }
	    return self;
	});

	def_optimize(AST_Chain, function (self, compressor) {
	    if (is_nullish(self.expression, compressor)) {
	        let parent = compressor.parent();
	        // It's valid to delete a nullish optional chain, but if we optimized
	        // this to `delete undefined` then it would appear to be a syntax error
	        // when we try to optimize the delete. Thankfully, `delete 0` is fine.
	        if (parent instanceof AST_UnaryPrefix && parent.operator === "delete") {
	            return make_node_from_constant(0, self);
	        }
	        return make_node(AST_Undefined, self);
	    }
	    return self;
	});

	def_optimize(AST_Dot, function(self, compressor) {
	    const parent = compressor.parent();
	    if (compressor.is_lhs()) return self;
	    if (compressor.option("unsafe_proto")
	        && self.expression instanceof AST_Dot
	        && self.expression.property == "prototype") {
	        var exp = self.expression.expression;
	        if (is_undeclared_ref(exp)) switch (exp.name) {
	          case "Array":
	            self.expression = make_node(AST_Array, self.expression, {
	                elements: []
	            });
	            break;
	          case "Function":
	            self.expression = make_node(AST_Function, self.expression, {
	                argnames: [],
	                body: []
	            });
	            break;
	          case "Number":
	            self.expression = make_node(AST_Number, self.expression, {
	                value: 0
	            });
	            break;
	          case "Object":
	            self.expression = make_node(AST_Object, self.expression, {
	                properties: []
	            });
	            break;
	          case "RegExp":
	            self.expression = make_node(AST_RegExp, self.expression, {
	                value: { source: "t", flags: "" }
	            });
	            break;
	          case "String":
	            self.expression = make_node(AST_String, self.expression, {
	                value: ""
	            });
	            break;
	        }
	    }
	    if (!(parent instanceof AST_Call) || !has_annotation(parent, _NOINLINE)) {
	        const sub = self.flatten_object(self.property, compressor);
	        if (sub) return sub.optimize(compressor);
	    }

	    if (self.expression instanceof AST_PropAccess
	        && parent instanceof AST_PropAccess) {
	        return self;
	    }

	    let ev = self.evaluate(compressor);
	    if (ev !== self) {
	        ev = make_node_from_constant(ev, self).optimize(compressor);
	        return best_of(compressor, ev, self);
	    }
	    return self;
	});

	function literals_in_boolean_context(self, compressor) {
	    if (compressor.in_boolean_context()) {
	        return best_of(compressor, self, make_sequence(self, [
	            self,
	            make_node(AST_True, self)
	        ]).optimize(compressor));
	    }
	    return self;
	}

	function inline_array_like_spread(elements) {
	    for (var i = 0; i < elements.length; i++) {
	        var el = elements[i];
	        if (el instanceof AST_Expansion) {
	            var expr = el.expression;
	            if (
	                expr instanceof AST_Array
	                && !expr.elements.some(elm => elm instanceof AST_Hole)
	            ) {
	                elements.splice(i, 1, ...expr.elements);
	                // Step back one, as the element at i is now new.
	                i--;
	            }
	            // In array-like spread, spreading a non-iterable value is TypeError.
	            // We therefore can’t optimize anything else, unlike with object spread.
	        }
	    }
	}

	def_optimize(AST_Array, function(self, compressor) {
	    var optimized = literals_in_boolean_context(self, compressor);
	    if (optimized !== self) {
	        return optimized;
	    }
	    inline_array_like_spread(self.elements);
	    return self;
	});

	function inline_object_prop_spread(props) {
	    for (var i = 0; i < props.length; i++) {
	        var prop = props[i];
	        if (prop instanceof AST_Expansion) {
	            const expr = prop.expression;
	            if (
	                expr instanceof AST_Object
	                && expr.properties.every(prop => prop instanceof AST_ObjectKeyVal)
	            ) {
	                props.splice(i, 1, ...expr.properties);
	                // Step back one, as the property at i is now new.
	                i--;
	            } else if ((
	                    // `expr.is_constant()` returns `false` for `AST_RegExp`, so need both.
	                    expr instanceof AST_Constant
	                    || expr.is_constant()
	                ) && !(expr instanceof AST_String)) {
	                // Unlike array-like spread, in object spread, spreading a
	                // non-iterable value silently does nothing; it is thus safe
	                // to remove. AST_String is the only iterable constant.
	                props.splice(i, 1);
	                i--;
	            }
	        }
	    }
	}

	def_optimize(AST_Object, function(self, compressor) {
	    var optimized = literals_in_boolean_context(self, compressor);
	    if (optimized !== self) {
	        return optimized;
	    }
	    inline_object_prop_spread(self.properties);
	    return self;
	});

	def_optimize(AST_RegExp, literals_in_boolean_context);

	def_optimize(AST_Return, function(self, compressor) {
	    if (self.value && is_undefined(self.value, compressor)) {
	        self.value = null;
	    }
	    return self;
	});

	def_optimize(AST_Arrow, opt_AST_Lambda);

	def_optimize(AST_Function, function(self, compressor) {
	    self = opt_AST_Lambda(self, compressor);
	    if (compressor.option("unsafe_arrows")
	        && compressor.option("ecma") >= 2015
	        && !self.name
	        && !self.is_generator
	        && !self.uses_arguments
	        && !self.pinned()) {
	        const uses_this = walk(self, node => {
	            if (node instanceof AST_This) return walk_abort;
	        });
	        if (!uses_this) return make_node(AST_Arrow, self, self).optimize(compressor);
	    }
	    return self;
	});

	def_optimize(AST_Class, function(self) {
	    for (let i = 0; i < self.properties.length; i++) {
	        const prop = self.properties[i];
	        if (prop instanceof AST_ClassStaticBlock && prop.body.length == 0) {
	            self.properties.splice(i, 1);
	            i--;
	        }
	    }

	    return self;
	});

	def_optimize(AST_ClassStaticBlock, function(self, compressor) {
	    tighten_body(self.body, compressor);
	    return self;
	});

	def_optimize(AST_Yield, function(self, compressor) {
	    if (self.expression && !self.is_star && is_undefined(self.expression, compressor)) {
	        self.expression = null;
	    }
	    return self;
	});

	def_optimize(AST_TemplateString, function(self, compressor) {
	    if (
	        !compressor.option("evaluate")
	        || compressor.parent() instanceof AST_PrefixedTemplateString
	    ) {
	        return self;
	    }

	    var segments = [];
	    for (var i = 0; i < self.segments.length; i++) {
	        var segment = self.segments[i];
	        if (segment instanceof AST_Node) {
	            var result = segment.evaluate(compressor);
	            // Evaluate to constant value
	            // Constant value shorter than ${segment}
	            if (result !== segment && (result + "").length <= segment.size() + "${}".length) {
	                // There should always be a previous and next segment if segment is a node
	                segments[segments.length - 1].value = segments[segments.length - 1].value + result + self.segments[++i].value;
	                continue;
	            }
	            // `before ${`innerBefore ${any} innerAfter`} after` => `before innerBefore ${any} innerAfter after`
	            // TODO:
	            // `before ${'test' + foo} after` => `before innerBefore ${any} innerAfter after`
	            // `before ${foo + 'test} after` => `before innerBefore ${any} innerAfter after`
	            if (segment instanceof AST_TemplateString) {
	                var inners = segment.segments;
	                segments[segments.length - 1].value += inners[0].value;
	                for (var j = 1; j < inners.length; j++) {
	                    segment = inners[j];
	                    segments.push(segment);
	                }
	                continue;
	            }
	        }
	        segments.push(segment);
	    }
	    self.segments = segments;

	    // `foo` => "foo"
	    if (segments.length == 1) {
	        return make_node(AST_String, self, segments[0]);
	    }

	    if (
	        segments.length === 3
	        && segments[1] instanceof AST_Node
	        && (
	            segments[1].is_string(compressor)
	            || segments[1].is_number(compressor)
	            || is_nullish(segments[1], compressor)
	            || compressor.option("unsafe")
	        )
	    ) {
	        // `foo${bar}` => "foo" + bar
	        if (segments[2].value === "") {
	            return make_node(AST_Binary, self, {
	                operator: "+",
	                left: make_node(AST_String, self, {
	                    value: segments[0].value,
	                }),
	                right: segments[1],
	            });
	        }
	        // `${bar}baz` => bar + "baz"
	        if (segments[0].value === "") {
	            return make_node(AST_Binary, self, {
	                operator: "+",
	                left: segments[1],
	                right: make_node(AST_String, self, {
	                    value: segments[2].value,
	                }),
	            });
	        }
	    }
	    return self;
	});

	def_optimize(AST_PrefixedTemplateString, function(self) {
	    return self;
	});

	// ["p"]:1 ---> p:1
	// [42]:1 ---> 42:1
	function lift_key(self, compressor) {
	    if (!compressor.option("computed_props")) return self;
	    // save a comparison in the typical case
	    if (!(self.key instanceof AST_Constant)) return self;
	    // allow certain acceptable props as not all AST_Constants are true constants
	    if (self.key instanceof AST_String || self.key instanceof AST_Number) {
	        const key = self.key.value.toString();

	        if (key === "__proto__") return self;
	        if (key == "constructor"
	            && compressor.parent() instanceof AST_Class) return self;
	        if (self instanceof AST_ObjectKeyVal) {
	            self.quote = self.key.quote;
	            self.key = key;
	        } else if (self instanceof AST_ClassProperty) {
	            self.quote = self.key.quote;
	            self.key = make_node(AST_SymbolClassProperty, self.key, {
	                name: key,
	            });
	        } else {
	            self.quote = self.key.quote;
	            self.key = make_node(AST_SymbolMethod, self.key, {
	                name: key,
	            });
	        }
	    }
	    return self;
	}

	def_optimize(AST_ObjectProperty, lift_key);

	def_optimize(AST_ConciseMethod, function(self, compressor) {
	    lift_key(self, compressor);
	    // p(){return x;} ---> p:()=>x
	    if (compressor.option("arrows")
	        && compressor.parent() instanceof AST_Object
	        && !self.is_generator
	        && !self.value.uses_arguments
	        && !self.value.pinned()
	        && self.value.body.length == 1
	        && self.value.body[0] instanceof AST_Return
	        && self.value.body[0].value
	        && !self.value.contains_this()) {
	        var arrow = make_node(AST_Arrow, self.value, self.value);
	        arrow.async = self.async;
	        arrow.is_generator = self.is_generator;
	        return make_node(AST_ObjectKeyVal, self, {
	            key: self.key instanceof AST_SymbolMethod ? self.key.name : self.key,
	            value: arrow,
	            quote: self.quote,
	        });
	    }
	    return self;
	});

	def_optimize(AST_ObjectKeyVal, function(self, compressor) {
	    lift_key(self, compressor);
	    // p:function(){} ---> p(){}
	    // p:function*(){} ---> *p(){}
	    // p:async function(){} ---> async p(){}
	    // p:()=>{} ---> p(){}
	    // p:async()=>{} ---> async p(){}
	    var unsafe_methods = compressor.option("unsafe_methods");
	    if (unsafe_methods
	        && compressor.option("ecma") >= 2015
	        && (!(unsafe_methods instanceof RegExp) || unsafe_methods.test(self.key + ""))) {
	        var key = self.key;
	        var value = self.value;
	        var is_arrow_with_block = value instanceof AST_Arrow
	            && Array.isArray(value.body)
	            && !value.contains_this();
	        if ((is_arrow_with_block || value instanceof AST_Function) && !value.name) {
	            return make_node(AST_ConciseMethod, self, {
	                async: value.async,
	                is_generator: value.is_generator,
	                key: key instanceof AST_Node ? key : make_node(AST_SymbolMethod, self, {
	                    name: key,
	                }),
	                value: make_node(AST_Accessor, value, value),
	                quote: self.quote,
	            });
	        }
	    }
	    return self;
	});

	def_optimize(AST_Destructuring, function(self, compressor) {
	    if (compressor.option("pure_getters") == true
	        && compressor.option("unused")
	        && !self.is_array
	        && Array.isArray(self.names)
	        && !is_destructuring_export_decl(compressor)
	        && !(self.names[self.names.length - 1] instanceof AST_Expansion)) {
	        var keep = [];
	        for (var i = 0; i < self.names.length; i++) {
	            var elem = self.names[i];
	            if (!(elem instanceof AST_ObjectKeyVal
	                && typeof elem.key == "string"
	                && elem.value instanceof AST_SymbolDeclaration
	                && !should_retain(compressor, elem.value.definition()))) {
	                keep.push(elem);
	            }
	        }
	        if (keep.length != self.names.length) {
	            self.names = keep;
	        }
	    }
	    return self;

	    function is_destructuring_export_decl(compressor) {
	        var ancestors = [/^VarDef$/, /^(Const|Let|Var)$/, /^Export$/];
	        for (var a = 0, p = 0, len = ancestors.length; a < len; p++) {
	            var parent = compressor.parent(p);
	            if (!parent) return false;
	            if (a === 0 && parent.TYPE == "Destructuring") continue;
	            if (!ancestors[a].test(parent.TYPE)) {
	                return false;
	            }
	            a++;
	        }
	        return true;
	    }

	    function should_retain(compressor, def) {
	        if (def.references.length) return true;
	        if (!def.global) return false;
	        if (compressor.toplevel.vars) {
	            if (compressor.top_retain) {
	                return compressor.top_retain(def);
	            }
	            return false;
	        }
	        return true;
	    }
	});

	/***********************************************************************

	  A JavaScript tokenizer / parser / beautifier / compressor.
	  https://github.com/mishoo/UglifyJS2

	  -------------------------------- (C) ---------------------------------

	                           Author: Mihai Bazon
	                         <mihai.bazon@gmail.com>
	                       http://mihai.bazon.net/blog

	  Distributed under the BSD license:

	    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

	    Redistribution and use in source and binary forms, with or without
	    modification, are permitted provided that the following conditions
	    are met:

	        * Redistributions of source code must retain the above
	          copyright notice, this list of conditions and the following
	          disclaimer.

	        * Redistributions in binary form must reproduce the above
	          copyright notice, this list of conditions and the following
	          disclaimer in the documentation and/or other materials
	          provided with the distribution.

	    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
	    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
	    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
	    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
	    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
	    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
	    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
	    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
	    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
	    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
	    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
	    SUCH DAMAGE.

	 ***********************************************************************/

	// a small wrapper around source-map and @jridgewell/source-map
	function* SourceMap(options) {
	    options = defaults(options, {
	        file : null,
	        root : null,
	        orig : null,
	        files: {},
	    });

	    var orig_map;
	    var generator = new sourceMap.SourceMapGenerator({
	        file       : options.file,
	        sourceRoot : options.root
	    });

	    let sourcesContent = {__proto__: null};
	    let files = options.files;
	    for (var name in files) if (HOP(files, name)) {
	        sourcesContent[name] = files[name];
	    }
	    if (options.orig) {
	        // We support both @jridgewell/source-map (which has a sync
	        // SourceMapConsumer) and source-map (which has an async
	        // SourceMapConsumer).
	        orig_map = yield new sourceMap.SourceMapConsumer(options.orig);
	        if (orig_map.sourcesContent) {
	            orig_map.sources.forEach(function(source, i) {
	                var content = orig_map.sourcesContent[i];
	                if (content) {
	                    sourcesContent[source] = content;
	                }
	            });
	        }
	    }

	    function add(source, gen_line, gen_col, orig_line, orig_col, name) {
	        let generatedPos = { line: gen_line, column: gen_col };

	        if (orig_map) {
	            var info = orig_map.originalPositionFor({
	                line: orig_line,
	                column: orig_col
	            });
	            if (info.source === null) {
	                generator.addMapping({
	                    generated: generatedPos,
	                    original: null,
	                    source: null,
	                    name: null
	                });
	                return;
	            }
	            source = info.source;
	            orig_line = info.line;
	            orig_col = info.column;
	            name = info.name || name;
	        }
	        generator.addMapping({
	            generated : generatedPos,
	            original  : { line: orig_line, column: orig_col },
	            source    : source,
	            name      : name
	        });
	        generator.setSourceContent(source, sourcesContent[source]);
	    }

	    function clean(map) {
	        const allNull = map.sourcesContent && map.sourcesContent.every(c => c == null);
	        if (allNull) delete map.sourcesContent;
	        if (map.file === undefined) delete map.file;
	        if (map.sourceRoot === undefined) delete map.sourceRoot;
	        return map;
	    }

	    function getDecoded() {
	        if (!generator.toDecodedMap) return null;
	        return clean(generator.toDecodedMap());
	    }

	    function getEncoded() {
	        return clean(generator.toJSON());
	    }

	    function destroy() {
	        // @jridgewell/source-map's SourceMapConsumer does not need to be
	        // manually freed.
	        if (orig_map && orig_map.destroy) orig_map.destroy();
	    }

	    return {
	        add,
	        getDecoded,
	        getEncoded,
	        destroy,
	    };
	}

	var domprops = [
	    "$&",
	    "$'",
	    "$*",
	    "$+",
	    "$1",
	    "$2",
	    "$3",
	    "$4",
	    "$5",
	    "$6",
	    "$7",
	    "$8",
	    "$9",
	    "$_",
	    "$`",
	    "$input",
	    "-moz-animation",
	    "-moz-animation-delay",
	    "-moz-animation-direction",
	    "-moz-animation-duration",
	    "-moz-animation-fill-mode",
	    "-moz-animation-iteration-count",
	    "-moz-animation-name",
	    "-moz-animation-play-state",
	    "-moz-animation-timing-function",
	    "-moz-appearance",
	    "-moz-backface-visibility",
	    "-moz-border-end",
	    "-moz-border-end-color",
	    "-moz-border-end-style",
	    "-moz-border-end-width",
	    "-moz-border-image",
	    "-moz-border-start",
	    "-moz-border-start-color",
	    "-moz-border-start-style",
	    "-moz-border-start-width",
	    "-moz-box-align",
	    "-moz-box-direction",
	    "-moz-box-flex",
	    "-moz-box-ordinal-group",
	    "-moz-box-orient",
	    "-moz-box-pack",
	    "-moz-box-sizing",
	    "-moz-float-edge",
	    "-moz-font-feature-settings",
	    "-moz-font-language-override",
	    "-moz-force-broken-image-icon",
	    "-moz-hyphens",
	    "-moz-image-region",
	    "-moz-margin-end",
	    "-moz-margin-start",
	    "-moz-orient",
	    "-moz-osx-font-smoothing",
	    "-moz-outline-radius",
	    "-moz-outline-radius-bottomleft",
	    "-moz-outline-radius-bottomright",
	    "-moz-outline-radius-topleft",
	    "-moz-outline-radius-topright",
	    "-moz-padding-end",
	    "-moz-padding-start",
	    "-moz-perspective",
	    "-moz-perspective-origin",
	    "-moz-tab-size",
	    "-moz-text-size-adjust",
	    "-moz-transform",
	    "-moz-transform-origin",
	    "-moz-transform-style",
	    "-moz-transition",
	    "-moz-transition-delay",
	    "-moz-transition-duration",
	    "-moz-transition-property",
	    "-moz-transition-timing-function",
	    "-moz-user-focus",
	    "-moz-user-input",
	    "-moz-user-modify",
	    "-moz-user-select",
	    "-moz-window-dragging",
	    "-webkit-align-content",
	    "-webkit-align-items",
	    "-webkit-align-self",
	    "-webkit-animation",
	    "-webkit-animation-delay",
	    "-webkit-animation-direction",
	    "-webkit-animation-duration",
	    "-webkit-animation-fill-mode",
	    "-webkit-animation-iteration-count",
	    "-webkit-animation-name",
	    "-webkit-animation-play-state",
	    "-webkit-animation-timing-function",
	    "-webkit-appearance",
	    "-webkit-backface-visibility",
	    "-webkit-background-clip",
	    "-webkit-background-origin",
	    "-webkit-background-size",
	    "-webkit-border-bottom-left-radius",
	    "-webkit-border-bottom-right-radius",
	    "-webkit-border-image",
	    "-webkit-border-radius",
	    "-webkit-border-top-left-radius",
	    "-webkit-border-top-right-radius",
	    "-webkit-box-align",
	    "-webkit-box-direction",
	    "-webkit-box-flex",
	    "-webkit-box-ordinal-group",
	    "-webkit-box-orient",
	    "-webkit-box-pack",
	    "-webkit-box-shadow",
	    "-webkit-box-sizing",
	    "-webkit-clip-path",
	    "-webkit-filter",
	    "-webkit-flex",
	    "-webkit-flex-basis",
	    "-webkit-flex-direction",
	    "-webkit-flex-flow",
	    "-webkit-flex-grow",
	    "-webkit-flex-shrink",
	    "-webkit-flex-wrap",
	    "-webkit-justify-content",
	    "-webkit-line-clamp",
	    "-webkit-mask",
	    "-webkit-mask-clip",
	    "-webkit-mask-composite",
	    "-webkit-mask-image",
	    "-webkit-mask-origin",
	    "-webkit-mask-position",
	    "-webkit-mask-position-x",
	    "-webkit-mask-position-y",
	    "-webkit-mask-repeat",
	    "-webkit-mask-size",
	    "-webkit-order",
	    "-webkit-perspective",
	    "-webkit-perspective-origin",
	    "-webkit-text-fill-color",
	    "-webkit-text-security",
	    "-webkit-text-size-adjust",
	    "-webkit-text-stroke",
	    "-webkit-text-stroke-color",
	    "-webkit-text-stroke-width",
	    "-webkit-transform",
	    "-webkit-transform-origin",
	    "-webkit-transform-style",
	    "-webkit-transition",
	    "-webkit-transition-delay",
	    "-webkit-transition-duration",
	    "-webkit-transition-property",
	    "-webkit-transition-timing-function",
	    "-webkit-user-select",
	    "0",
	    "1",
	    "10",
	    "11",
	    "12",
	    "13",
	    "14",
	    "15",
	    "16",
	    "17",
	    "18",
	    "19",
	    "2",
	    "20",
	    "3",
	    "4",
	    "5",
	    "6",
	    "7",
	    "8",
	    "9",
	    "@@iterator",
	    "ABORT_ERR",
	    "ACTIVE",
	    "ACTIVE_ATTRIBUTES",
	    "ACTIVE_TEXTURE",
	    "ACTIVE_UNIFORMS",
	    "ACTIVE_UNIFORM_BLOCKS",
	    "ADDITION",
	    "ALIASED_LINE_WIDTH_RANGE",
	    "ALIASED_POINT_SIZE_RANGE",
	    "ALL",
	    "ALLOW_KEYBOARD_INPUT",
	    "ALLPASS",
	    "ALPHA",
	    "ALPHA_BITS",
	    "ALREADY_SIGNALED",
	    "ALT_MASK",
	    "ALWAYS",
	    "ANY_SAMPLES_PASSED",
	    "ANY_SAMPLES_PASSED_CONSERVATIVE",
	    "ANY_TYPE",
	    "ANY_UNORDERED_NODE_TYPE",
	    "ARRAY_BUFFER",
	    "ARRAY_BUFFER_BINDING",
	    "ATTACHED_SHADERS",
	    "ATTRIBUTE_NODE",
	    "AT_TARGET",
	    "AbortController",
	    "AbortSignal",
	    "AbsoluteOrientationSensor",
	    "AbstractRange",
	    "Accelerometer",
	    "AddSearchProvider",
	    "AggregateError",
	    "AnalyserNode",
	    "Animation",
	    "AnimationEffect",
	    "AnimationEvent",
	    "AnimationPlaybackEvent",
	    "AnimationTimeline",
	    "AnonXMLHttpRequest",
	    "Any",
	    "ApplicationCache",
	    "ApplicationCacheErrorEvent",
	    "Array",
	    "ArrayBuffer",
	    "ArrayType",
	    "Atomics",
	    "Attr",
	    "Audio",
	    "AudioBuffer",
	    "AudioBufferSourceNode",
	    "AudioContext",
	    "AudioData",
	    "AudioDecoder",
	    "AudioDestinationNode",
	    "AudioEncoder",
	    "AudioListener",
	    "AudioNode",
	    "AudioParam",
	    "AudioParamMap",
	    "AudioProcessingEvent",
	    "AudioScheduledSourceNode",
	    "AudioSinkInfo",
	    "AudioStreamTrack",
	    "AudioWorklet",
	    "AudioWorkletNode",
	    "AuthenticatorAssertionResponse",
	    "AuthenticatorAttestationResponse",
	    "AuthenticatorResponse",
	    "AutocompleteErrorEvent",
	    "BACK",
	    "BAD_BOUNDARYPOINTS_ERR",
	    "BAD_REQUEST",
	    "BANDPASS",
	    "BLEND",
	    "BLEND_COLOR",
	    "BLEND_DST_ALPHA",
	    "BLEND_DST_RGB",
	    "BLEND_EQUATION",
	    "BLEND_EQUATION_ALPHA",
	    "BLEND_EQUATION_RGB",
	    "BLEND_SRC_ALPHA",
	    "BLEND_SRC_RGB",
	    "BLUE",
	    "BLUE_BITS",
	    "BLUR",
	    "BOOL",
	    "BOOLEAN_TYPE",
	    "BOOL_VEC2",
	    "BOOL_VEC3",
	    "BOOL_VEC4",
	    "BOTH",
	    "BROWSER_DEFAULT_WEBGL",
	    "BUBBLING_PHASE",
	    "BUFFER_SIZE",
	    "BUFFER_USAGE",
	    "BYTE",
	    "BYTES_PER_ELEMENT",
	    "BackgroundFetchManager",
	    "BackgroundFetchRecord",
	    "BackgroundFetchRegistration",
	    "BarProp",
	    "BarcodeDetector",
	    "BaseAudioContext",
	    "BaseHref",
	    "BatteryManager",
	    "BeforeInstallPromptEvent",
	    "BeforeLoadEvent",
	    "BeforeUnloadEvent",
	    "BigInt",
	    "BigInt64Array",
	    "BigUint64Array",
	    "BiquadFilterNode",
	    "Blob",
	    "BlobEvent",
	    "Bluetooth",
	    "BluetoothCharacteristicProperties",
	    "BluetoothDevice",
	    "BluetoothRemoteGATTCharacteristic",
	    "BluetoothRemoteGATTDescriptor",
	    "BluetoothRemoteGATTServer",
	    "BluetoothRemoteGATTService",
	    "BluetoothUUID",
	    "Boolean",
	    "BroadcastChannel",
	    "BrowserCaptureMediaStreamTrack",
	    "ByteLengthQueuingStrategy",
	    "CAPTURING_PHASE",
	    "CCW",
	    "CDATASection",
	    "CDATA_SECTION_NODE",
	    "CHANGE",
	    "CHARSET_RULE",
	    "CHECKING",
	    "CLAMP_TO_EDGE",
	    "CLICK",
	    "CLOSED",
	    "CLOSING",
	    "COLOR",
	    "COLOR_ATTACHMENT0",
	    "COLOR_ATTACHMENT1",
	    "COLOR_ATTACHMENT10",
	    "COLOR_ATTACHMENT11",
	    "COLOR_ATTACHMENT12",
	    "COLOR_ATTACHMENT13",
	    "COLOR_ATTACHMENT14",
	    "COLOR_ATTACHMENT15",
	    "COLOR_ATTACHMENT2",
	    "COLOR_ATTACHMENT3",
	    "COLOR_ATTACHMENT4",
	    "COLOR_ATTACHMENT5",
	    "COLOR_ATTACHMENT6",
	    "COLOR_ATTACHMENT7",
	    "COLOR_ATTACHMENT8",
	    "COLOR_ATTACHMENT9",
	    "COLOR_BUFFER_BIT",
	    "COLOR_CLEAR_VALUE",
	    "COLOR_WRITEMASK",
	    "COMMENT_NODE",
	    "COMPARE_REF_TO_TEXTURE",
	    "COMPILE_STATUS",
	    "COMPLETION_STATUS_KHR",
	    "COMPRESSED_RGBA_S3TC_DXT1_EXT",
	    "COMPRESSED_RGBA_S3TC_DXT3_EXT",
	    "COMPRESSED_RGBA_S3TC_DXT5_EXT",
	    "COMPRESSED_RGB_S3TC_DXT1_EXT",
	    "COMPRESSED_TEXTURE_FORMATS",
	    "COMPUTE",
	    "CONDITION_SATISFIED",
	    "CONFIGURATION_UNSUPPORTED",
	    "CONNECTING",
	    "CONSTANT_ALPHA",
	    "CONSTANT_COLOR",
	    "CONSTRAINT_ERR",
	    "CONTEXT_LOST_WEBGL",
	    "CONTROL_MASK",
	    "COPY_DST",
	    "COPY_READ_BUFFER",
	    "COPY_READ_BUFFER_BINDING",
	    "COPY_SRC",
	    "COPY_WRITE_BUFFER",
	    "COPY_WRITE_BUFFER_BINDING",
	    "COUNTER_STYLE_RULE",
	    "CSS",
	    "CSS2Properties",
	    "CSSAnimation",
	    "CSSCharsetRule",
	    "CSSConditionRule",
	    "CSSContainerRule",
	    "CSSCounterStyleRule",
	    "CSSFontFaceRule",
	    "CSSFontFeatureValuesRule",
	    "CSSFontPaletteValuesRule",
	    "CSSGroupingRule",
	    "CSSImageValue",
	    "CSSImportRule",
	    "CSSKeyframeRule",
	    "CSSKeyframesRule",
	    "CSSKeywordValue",
	    "CSSLayerBlockRule",
	    "CSSLayerStatementRule",
	    "CSSMathClamp",
	    "CSSMathInvert",
	    "CSSMathMax",
	    "CSSMathMin",
	    "CSSMathNegate",
	    "CSSMathProduct",
	    "CSSMathSum",
	    "CSSMathValue",
	    "CSSMatrixComponent",
	    "CSSMediaRule",
	    "CSSMozDocumentRule",
	    "CSSNameSpaceRule",
	    "CSSNamespaceRule",
	    "CSSNumericArray",
	    "CSSNumericValue",
	    "CSSPageRule",
	    "CSSPerspective",
	    "CSSPositionValue",
	    "CSSPrimitiveValue",
	    "CSSPropertyRule",
	    "CSSRotate",
	    "CSSRule",
	    "CSSRuleList",
	    "CSSScale",
	    "CSSScopeRule",
	    "CSSSkew",
	    "CSSSkewX",
	    "CSSSkewY",
	    "CSSStartingStyleRule",
	    "CSSStyleDeclaration",
	    "CSSStyleRule",
	    "CSSStyleSheet",
	    "CSSStyleValue",
	    "CSSSupportsRule",
	    "CSSTransformComponent",
	    "CSSTransformValue",
	    "CSSTransition",
	    "CSSTranslate",
	    "CSSUnitValue",
	    "CSSUnknownRule",
	    "CSSUnparsedValue",
	    "CSSValue",
	    "CSSValueList",
	    "CSSVariableReferenceValue",
	    "CSSVariablesDeclaration",
	    "CSSVariablesRule",
	    "CSSViewportRule",
	    "CSS_ATTR",
	    "CSS_CM",
	    "CSS_COUNTER",
	    "CSS_CUSTOM",
	    "CSS_DEG",
	    "CSS_DIMENSION",
	    "CSS_EMS",
	    "CSS_EXS",
	    "CSS_FILTER_BLUR",
	    "CSS_FILTER_BRIGHTNESS",
	    "CSS_FILTER_CONTRAST",
	    "CSS_FILTER_CUSTOM",
	    "CSS_FILTER_DROP_SHADOW",
	    "CSS_FILTER_GRAYSCALE",
	    "CSS_FILTER_HUE_ROTATE",
	    "CSS_FILTER_INVERT",
	    "CSS_FILTER_OPACITY",
	    "CSS_FILTER_REFERENCE",
	    "CSS_FILTER_SATURATE",
	    "CSS_FILTER_SEPIA",
	    "CSS_GRAD",
	    "CSS_HZ",
	    "CSS_IDENT",
	    "CSS_IN",
	    "CSS_INHERIT",
	    "CSS_KHZ",
	    "CSS_MATRIX",
	    "CSS_MATRIX3D",
	    "CSS_MM",
	    "CSS_MS",
	    "CSS_NUMBER",
	    "CSS_PC",
	    "CSS_PERCENTAGE",
	    "CSS_PERSPECTIVE",
	    "CSS_PRIMITIVE_VALUE",
	    "CSS_PT",
	    "CSS_PX",
	    "CSS_RAD",
	    "CSS_RECT",
	    "CSS_RGBCOLOR",
	    "CSS_ROTATE",
	    "CSS_ROTATE3D",
	    "CSS_ROTATEX",
	    "CSS_ROTATEY",
	    "CSS_ROTATEZ",
	    "CSS_S",
	    "CSS_SCALE",
	    "CSS_SCALE3D",
	    "CSS_SCALEX",
	    "CSS_SCALEY",
	    "CSS_SCALEZ",
	    "CSS_SKEW",
	    "CSS_SKEWX",
	    "CSS_SKEWY",
	    "CSS_STRING",
	    "CSS_TRANSLATE",
	    "CSS_TRANSLATE3D",
	    "CSS_TRANSLATEX",
	    "CSS_TRANSLATEY",
	    "CSS_TRANSLATEZ",
	    "CSS_UNKNOWN",
	    "CSS_URI",
	    "CSS_VALUE_LIST",
	    "CSS_VH",
	    "CSS_VMAX",
	    "CSS_VMIN",
	    "CSS_VW",
	    "CULL_FACE",
	    "CULL_FACE_MODE",
	    "CURRENT_PROGRAM",
	    "CURRENT_QUERY",
	    "CURRENT_VERTEX_ATTRIB",
	    "CUSTOM",
	    "CW",
	    "Cache",
	    "CacheStorage",
	    "CanvasCaptureMediaStream",
	    "CanvasCaptureMediaStreamTrack",
	    "CanvasGradient",
	    "CanvasPattern",
	    "CanvasRenderingContext2D",
	    "CaptureController",
	    "CaretPosition",
	    "ChannelMergerNode",
	    "ChannelSplitterNode",
	    "CharacterBoundsUpdateEvent",
	    "CharacterData",
	    "ClientRect",
	    "ClientRectList",
	    "Clipboard",
	    "ClipboardEvent",
	    "ClipboardItem",
	    "CloseEvent",
	    "Collator",
	    "CommandEvent",
	    "Comment",
	    "CompileError",
	    "CompositionEvent",
	    "CompressionStream",
	    "Console",
	    "ConstantSourceNode",
	    "ContentVisibilityAutoStateChangeEvent",
	    "Controllers",
	    "ConvolverNode",
	    "CookieChangeEvent",
	    "CookieStore",
	    "CookieStoreManager",
	    "CountQueuingStrategy",
	    "Counter",
	    "Credential",
	    "CredentialsContainer",
	    "CropTarget",
	    "Crypto",
	    "CryptoKey",
	    "CustomElementRegistry",
	    "CustomEvent",
	    "CustomStateSet",
	    "DATABASE_ERR",
	    "DATA_CLONE_ERR",
	    "DATA_ERR",
	    "DBLCLICK",
	    "DECR",
	    "DECR_WRAP",
	    "DELETE_STATUS",
	    "DEPTH",
	    "DEPTH24_STENCIL8",
	    "DEPTH32F_STENCIL8",
	    "DEPTH_ATTACHMENT",
	    "DEPTH_BITS",
	    "DEPTH_BUFFER_BIT",
	    "DEPTH_CLEAR_VALUE",
	    "DEPTH_COMPONENT",
	    "DEPTH_COMPONENT16",
	    "DEPTH_COMPONENT24",
	    "DEPTH_COMPONENT32F",
	    "DEPTH_FUNC",
	    "DEPTH_RANGE",
	    "DEPTH_STENCIL",
	    "DEPTH_STENCIL_ATTACHMENT",
	    "DEPTH_TEST",
	    "DEPTH_WRITEMASK",
	    "DEVICE_INELIGIBLE",
	    "DIRECTION_DOWN",
	    "DIRECTION_LEFT",
	    "DIRECTION_RIGHT",
	    "DIRECTION_UP",
	    "DISABLED",
	    "DISPATCH_REQUEST_ERR",
	    "DITHER",
	    "DOCUMENT_FRAGMENT_NODE",
	    "DOCUMENT_NODE",
	    "DOCUMENT_POSITION_CONTAINED_BY",
	    "DOCUMENT_POSITION_CONTAINS",
	    "DOCUMENT_POSITION_DISCONNECTED",
	    "DOCUMENT_POSITION_FOLLOWING",
	    "DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC",
	    "DOCUMENT_POSITION_PRECEDING",
	    "DOCUMENT_TYPE_NODE",
	    "DOMCursor",
	    "DOMError",
	    "DOMException",
	    "DOMImplementation",
	    "DOMImplementationLS",
	    "DOMMatrix",
	    "DOMMatrixReadOnly",
	    "DOMParser",
	    "DOMPoint",
	    "DOMPointReadOnly",
	    "DOMQuad",
	    "DOMRect",
	    "DOMRectList",
	    "DOMRectReadOnly",
	    "DOMRequest",
	    "DOMSTRING_SIZE_ERR",
	    "DOMSettableTokenList",
	    "DOMStringList",
	    "DOMStringMap",
	    "DOMTokenList",
	    "DOMTransactionEvent",
	    "DOM_DELTA_LINE",
	    "DOM_DELTA_PAGE",
	    "DOM_DELTA_PIXEL",
	    "DOM_INPUT_METHOD_DROP",
	    "DOM_INPUT_METHOD_HANDWRITING",
	    "DOM_INPUT_METHOD_IME",
	    "DOM_INPUT_METHOD_KEYBOARD",
	    "DOM_INPUT_METHOD_MULTIMODAL",
	    "DOM_INPUT_METHOD_OPTION",
	    "DOM_INPUT_METHOD_PASTE",
	    "DOM_INPUT_METHOD_SCRIPT",
	    "DOM_INPUT_METHOD_UNKNOWN",
	    "DOM_INPUT_METHOD_VOICE",
	    "DOM_KEY_LOCATION_JOYSTICK",
	    "DOM_KEY_LOCATION_LEFT",
	    "DOM_KEY_LOCATION_MOBILE",
	    "DOM_KEY_LOCATION_NUMPAD",
	    "DOM_KEY_LOCATION_RIGHT",
	    "DOM_KEY_LOCATION_STANDARD",
	    "DOM_VK_0",
	    "DOM_VK_1",
	    "DOM_VK_2",
	    "DOM_VK_3",
	    "DOM_VK_4",
	    "DOM_VK_5",
	    "DOM_VK_6",
	    "DOM_VK_7",
	    "DOM_VK_8",
	    "DOM_VK_9",
	    "DOM_VK_A",
	    "DOM_VK_ACCEPT",
	    "DOM_VK_ADD",
	    "DOM_VK_ALT",
	    "DOM_VK_ALTGR",
	    "DOM_VK_AMPERSAND",
	    "DOM_VK_ASTERISK",
	    "DOM_VK_AT",
	    "DOM_VK_ATTN",
	    "DOM_VK_B",
	    "DOM_VK_BACKSPACE",
	    "DOM_VK_BACK_QUOTE",
	    "DOM_VK_BACK_SLASH",
	    "DOM_VK_BACK_SPACE",
	    "DOM_VK_C",
	    "DOM_VK_CANCEL",
	    "DOM_VK_CAPS_LOCK",
	    "DOM_VK_CIRCUMFLEX",
	    "DOM_VK_CLEAR",
	    "DOM_VK_CLOSE_BRACKET",
	    "DOM_VK_CLOSE_CURLY_BRACKET",
	    "DOM_VK_CLOSE_PAREN",
	    "DOM_VK_COLON",
	    "DOM_VK_COMMA",
	    "DOM_VK_CONTEXT_MENU",
	    "DOM_VK_CONTROL",
	    "DOM_VK_CONVERT",
	    "DOM_VK_CRSEL",
	    "DOM_VK_CTRL",
	    "DOM_VK_D",
	    "DOM_VK_DECIMAL",
	    "DOM_VK_DELETE",
	    "DOM_VK_DIVIDE",
	    "DOM_VK_DOLLAR",
	    "DOM_VK_DOUBLE_QUOTE",
	    "DOM_VK_DOWN",
	    "DOM_VK_E",
	    "DOM_VK_EISU",
	    "DOM_VK_END",
	    "DOM_VK_ENTER",
	    "DOM_VK_EQUALS",
	    "DOM_VK_EREOF",
	    "DOM_VK_ESCAPE",
	    "DOM_VK_EXCLAMATION",
	    "DOM_VK_EXECUTE",
	    "DOM_VK_EXSEL",
	    "DOM_VK_F",
	    "DOM_VK_F1",
	    "DOM_VK_F10",
	    "DOM_VK_F11",
	    "DOM_VK_F12",
	    "DOM_VK_F13",
	    "DOM_VK_F14",
	    "DOM_VK_F15",
	    "DOM_VK_F16",
	    "DOM_VK_F17",
	    "DOM_VK_F18",
	    "DOM_VK_F19",
	    "DOM_VK_F2",
	    "DOM_VK_F20",
	    "DOM_VK_F21",
	    "DOM_VK_F22",
	    "DOM_VK_F23",
	    "DOM_VK_F24",
	    "DOM_VK_F25",
	    "DOM_VK_F26",
	    "DOM_VK_F27",
	    "DOM_VK_F28",
	    "DOM_VK_F29",
	    "DOM_VK_F3",
	    "DOM_VK_F30",
	    "DOM_VK_F31",
	    "DOM_VK_F32",
	    "DOM_VK_F33",
	    "DOM_VK_F34",
	    "DOM_VK_F35",
	    "DOM_VK_F36",
	    "DOM_VK_F4",
	    "DOM_VK_F5",
	    "DOM_VK_F6",
	    "DOM_VK_F7",
	    "DOM_VK_F8",
	    "DOM_VK_F9",
	    "DOM_VK_FINAL",
	    "DOM_VK_FRONT",
	    "DOM_VK_G",
	    "DOM_VK_GREATER_THAN",
	    "DOM_VK_H",
	    "DOM_VK_HANGUL",
	    "DOM_VK_HANJA",
	    "DOM_VK_HASH",
	    "DOM_VK_HELP",
	    "DOM_VK_HK_TOGGLE",
	    "DOM_VK_HOME",
	    "DOM_VK_HYPHEN_MINUS",
	    "DOM_VK_I",
	    "DOM_VK_INSERT",
	    "DOM_VK_J",
	    "DOM_VK_JUNJA",
	    "DOM_VK_K",
	    "DOM_VK_KANA",
	    "DOM_VK_KANJI",
	    "DOM_VK_L",
	    "DOM_VK_LEFT",
	    "DOM_VK_LEFT_TAB",
	    "DOM_VK_LESS_THAN",
	    "DOM_VK_M",
	    "DOM_VK_META",
	    "DOM_VK_MODECHANGE",
	    "DOM_VK_MULTIPLY",
	    "DOM_VK_N",
	    "DOM_VK_NONCONVERT",
	    "DOM_VK_NUMPAD0",
	    "DOM_VK_NUMPAD1",
	    "DOM_VK_NUMPAD2",
	    "DOM_VK_NUMPAD3",
	    "DOM_VK_NUMPAD4",
	    "DOM_VK_NUMPAD5",
	    "DOM_VK_NUMPAD6",
	    "DOM_VK_NUMPAD7",
	    "DOM_VK_NUMPAD8",
	    "DOM_VK_NUMPAD9",
	    "DOM_VK_NUM_LOCK",
	    "DOM_VK_O",
	    "DOM_VK_OEM_1",
	    "DOM_VK_OEM_102",
	    "DOM_VK_OEM_2",
	    "DOM_VK_OEM_3",
	    "DOM_VK_OEM_4",
	    "DOM_VK_OEM_5",
	    "DOM_VK_OEM_6",
	    "DOM_VK_OEM_7",
	    "DOM_VK_OEM_8",
	    "DOM_VK_OEM_COMMA",
	    "DOM_VK_OEM_MINUS",
	    "DOM_VK_OEM_PERIOD",
	    "DOM_VK_OEM_PLUS",
	    "DOM_VK_OPEN_BRACKET",
	    "DOM_VK_OPEN_CURLY_BRACKET",
	    "DOM_VK_OPEN_PAREN",
	    "DOM_VK_P",
	    "DOM_VK_PA1",
	    "DOM_VK_PAGEDOWN",
	    "DOM_VK_PAGEUP",
	    "DOM_VK_PAGE_DOWN",
	    "DOM_VK_PAGE_UP",
	    "DOM_VK_PAUSE",
	    "DOM_VK_PERCENT",
	    "DOM_VK_PERIOD",
	    "DOM_VK_PIPE",
	    "DOM_VK_PLAY",
	    "DOM_VK_PLUS",
	    "DOM_VK_PRINT",
	    "DOM_VK_PRINTSCREEN",
	    "DOM_VK_PROCESSKEY",
	    "DOM_VK_PROPERITES",
	    "DOM_VK_Q",
	    "DOM_VK_QUESTION_MARK",
	    "DOM_VK_QUOTE",
	    "DOM_VK_R",
	    "DOM_VK_REDO",
	    "DOM_VK_RETURN",
	    "DOM_VK_RIGHT",
	    "DOM_VK_S",
	    "DOM_VK_SCROLL_LOCK",
	    "DOM_VK_SELECT",
	    "DOM_VK_SEMICOLON",
	    "DOM_VK_SEPARATOR",
	    "DOM_VK_SHIFT",
	    "DOM_VK_SLASH",
	    "DOM_VK_SLEEP",
	    "DOM_VK_SPACE",
	    "DOM_VK_SUBTRACT",
	    "DOM_VK_T",
	    "DOM_VK_TAB",
	    "DOM_VK_TILDE",
	    "DOM_VK_U",
	    "DOM_VK_UNDERSCORE",
	    "DOM_VK_UNDO",
	    "DOM_VK_UNICODE",
	    "DOM_VK_UP",
	    "DOM_VK_V",
	    "DOM_VK_VOLUME_DOWN",
	    "DOM_VK_VOLUME_MUTE",
	    "DOM_VK_VOLUME_UP",
	    "DOM_VK_W",
	    "DOM_VK_WIN",
	    "DOM_VK_WINDOW",
	    "DOM_VK_WIN_ICO_00",
	    "DOM_VK_WIN_ICO_CLEAR",
	    "DOM_VK_WIN_ICO_HELP",
	    "DOM_VK_WIN_OEM_ATTN",
	    "DOM_VK_WIN_OEM_AUTO",
	    "DOM_VK_WIN_OEM_BACKTAB",
	    "DOM_VK_WIN_OEM_CLEAR",
	    "DOM_VK_WIN_OEM_COPY",
	    "DOM_VK_WIN_OEM_CUSEL",
	    "DOM_VK_WIN_OEM_ENLW",
	    "DOM_VK_WIN_OEM_FINISH",
	    "DOM_VK_WIN_OEM_FJ_JISHO",
	    "DOM_VK_WIN_OEM_FJ_LOYA",
	    "DOM_VK_WIN_OEM_FJ_MASSHOU",
	    "DOM_VK_WIN_OEM_FJ_ROYA",
	    "DOM_VK_WIN_OEM_FJ_TOUROKU",
	    "DOM_VK_WIN_OEM_JUMP",
	    "DOM_VK_WIN_OEM_PA1",
	    "DOM_VK_WIN_OEM_PA2",
	    "DOM_VK_WIN_OEM_PA3",
	    "DOM_VK_WIN_OEM_RESET",
	    "DOM_VK_WIN_OEM_WSCTRL",
	    "DOM_VK_X",
	    "DOM_VK_XF86XK_ADD_FAVORITE",
	    "DOM_VK_XF86XK_APPLICATION_LEFT",
	    "DOM_VK_XF86XK_APPLICATION_RIGHT",
	    "DOM_VK_XF86XK_AUDIO_CYCLE_TRACK",
	    "DOM_VK_XF86XK_AUDIO_FORWARD",
	    "DOM_VK_XF86XK_AUDIO_LOWER_VOLUME",
	    "DOM_VK_XF86XK_AUDIO_MEDIA",
	    "DOM_VK_XF86XK_AUDIO_MUTE",
	    "DOM_VK_XF86XK_AUDIO_NEXT",
	    "DOM_VK_XF86XK_AUDIO_PAUSE",
	    "DOM_VK_XF86XK_AUDIO_PLAY",
	    "DOM_VK_XF86XK_AUDIO_PREV",
	    "DOM_VK_XF86XK_AUDIO_RAISE_VOLUME",
	    "DOM_VK_XF86XK_AUDIO_RANDOM_PLAY",
	    "DOM_VK_XF86XK_AUDIO_RECORD",
	    "DOM_VK_XF86XK_AUDIO_REPEAT",
	    "DOM_VK_XF86XK_AUDIO_REWIND",
	    "DOM_VK_XF86XK_AUDIO_STOP",
	    "DOM_VK_XF86XK_AWAY",
	    "DOM_VK_XF86XK_BACK",
	    "DOM_VK_XF86XK_BACK_FORWARD",
	    "DOM_VK_XF86XK_BATTERY",
	    "DOM_VK_XF86XK_BLUE",
	    "DOM_VK_XF86XK_BLUETOOTH",
	    "DOM_VK_XF86XK_BOOK",
	    "DOM_VK_XF86XK_BRIGHTNESS_ADJUST",
	    "DOM_VK_XF86XK_CALCULATOR",
	    "DOM_VK_XF86XK_CALENDAR",
	    "DOM_VK_XF86XK_CD",
	    "DOM_VK_XF86XK_CLOSE",
	    "DOM_VK_XF86XK_COMMUNITY",
	    "DOM_VK_XF86XK_CONTRAST_ADJUST",
	    "DOM_VK_XF86XK_COPY",
	    "DOM_VK_XF86XK_CUT",
	    "DOM_VK_XF86XK_CYCLE_ANGLE",
	    "DOM_VK_XF86XK_DISPLAY",
	    "DOM_VK_XF86XK_DOCUMENTS",
	    "DOM_VK_XF86XK_DOS",
	    "DOM_VK_XF86XK_EJECT",
	    "DOM_VK_XF86XK_EXCEL",
	    "DOM_VK_XF86XK_EXPLORER",
	    "DOM_VK_XF86XK_FAVORITES",
	    "DOM_VK_XF86XK_FINANCE",
	    "DOM_VK_XF86XK_FORWARD",
	    "DOM_VK_XF86XK_FRAME_BACK",
	    "DOM_VK_XF86XK_FRAME_FORWARD",
	    "DOM_VK_XF86XK_GAME",
	    "DOM_VK_XF86XK_GO",
	    "DOM_VK_XF86XK_GREEN",
	    "DOM_VK_XF86XK_HIBERNATE",
	    "DOM_VK_XF86XK_HISTORY",
	    "DOM_VK_XF86XK_HOME_PAGE",
	    "DOM_VK_XF86XK_HOT_LINKS",
	    "DOM_VK_XF86XK_I_TOUCH",
	    "DOM_VK_XF86XK_KBD_BRIGHTNESS_DOWN",
	    "DOM_VK_XF86XK_KBD_BRIGHTNESS_UP",
	    "DOM_VK_XF86XK_KBD_LIGHT_ON_OFF",
	    "DOM_VK_XF86XK_LAUNCH0",
	    "DOM_VK_XF86XK_LAUNCH1",
	    "DOM_VK_XF86XK_LAUNCH2",
	    "DOM_VK_XF86XK_LAUNCH3",
	    "DOM_VK_XF86XK_LAUNCH4",
	    "DOM_VK_XF86XK_LAUNCH5",
	    "DOM_VK_XF86XK_LAUNCH6",
	    "DOM_VK_XF86XK_LAUNCH7",
	    "DOM_VK_XF86XK_LAUNCH8",
	    "DOM_VK_XF86XK_LAUNCH9",
	    "DOM_VK_XF86XK_LAUNCH_A",
	    "DOM_VK_XF86XK_LAUNCH_B",
	    "DOM_VK_XF86XK_LAUNCH_C",
	    "DOM_VK_XF86XK_LAUNCH_D",
	    "DOM_VK_XF86XK_LAUNCH_E",
	    "DOM_VK_XF86XK_LAUNCH_F",
	    "DOM_VK_XF86XK_LIGHT_BULB",
	    "DOM_VK_XF86XK_LOG_OFF",
	    "DOM_VK_XF86XK_MAIL",
	    "DOM_VK_XF86XK_MAIL_FORWARD",
	    "DOM_VK_XF86XK_MARKET",
	    "DOM_VK_XF86XK_MEETING",
	    "DOM_VK_XF86XK_MEMO",
	    "DOM_VK_XF86XK_MENU_KB",
	    "DOM_VK_XF86XK_MENU_PB",
	    "DOM_VK_XF86XK_MESSENGER",
	    "DOM_VK_XF86XK_MON_BRIGHTNESS_DOWN",
	    "DOM_VK_XF86XK_MON_BRIGHTNESS_UP",
	    "DOM_VK_XF86XK_MUSIC",
	    "DOM_VK_XF86XK_MY_COMPUTER",
	    "DOM_VK_XF86XK_MY_SITES",
	    "DOM_VK_XF86XK_NEW",
	    "DOM_VK_XF86XK_NEWS",
	    "DOM_VK_XF86XK_OFFICE_HOME",
	    "DOM_VK_XF86XK_OPEN",
	    "DOM_VK_XF86XK_OPEN_URL",
	    "DOM_VK_XF86XK_OPTION",
	    "DOM_VK_XF86XK_PASTE",
	    "DOM_VK_XF86XK_PHONE",
	    "DOM_VK_XF86XK_PICTURES",
	    "DOM_VK_XF86XK_POWER_DOWN",
	    "DOM_VK_XF86XK_POWER_OFF",
	    "DOM_VK_XF86XK_RED",
	    "DOM_VK_XF86XK_REFRESH",
	    "DOM_VK_XF86XK_RELOAD",
	    "DOM_VK_XF86XK_REPLY",
	    "DOM_VK_XF86XK_ROCKER_DOWN",
	    "DOM_VK_XF86XK_ROCKER_ENTER",
	    "DOM_VK_XF86XK_ROCKER_UP",
	    "DOM_VK_XF86XK_ROTATE_WINDOWS",
	    "DOM_VK_XF86XK_ROTATION_KB",
	    "DOM_VK_XF86XK_ROTATION_PB",
	    "DOM_VK_XF86XK_SAVE",
	    "DOM_VK_XF86XK_SCREEN_SAVER",
	    "DOM_VK_XF86XK_SCROLL_CLICK",
	    "DOM_VK_XF86XK_SCROLL_DOWN",
	    "DOM_VK_XF86XK_SCROLL_UP",
	    "DOM_VK_XF86XK_SEARCH",
	    "DOM_VK_XF86XK_SEND",
	    "DOM_VK_XF86XK_SHOP",
	    "DOM_VK_XF86XK_SPELL",
	    "DOM_VK_XF86XK_SPLIT_SCREEN",
	    "DOM_VK_XF86XK_STANDBY",
	    "DOM_VK_XF86XK_START",
	    "DOM_VK_XF86XK_STOP",
	    "DOM_VK_XF86XK_SUBTITLE",
	    "DOM_VK_XF86XK_SUPPORT",
	    "DOM_VK_XF86XK_SUSPEND",
	    "DOM_VK_XF86XK_TASK_PANE",
	    "DOM_VK_XF86XK_TERMINAL",
	    "DOM_VK_XF86XK_TIME",
	    "DOM_VK_XF86XK_TOOLS",
	    "DOM_VK_XF86XK_TOP_MENU",
	    "DOM_VK_XF86XK_TO_DO_LIST",
	    "DOM_VK_XF86XK_TRAVEL",
	    "DOM_VK_XF86XK_USER1KB",
	    "DOM_VK_XF86XK_USER2KB",
	    "DOM_VK_XF86XK_USER_PB",
	    "DOM_VK_XF86XK_UWB",
	    "DOM_VK_XF86XK_VENDOR_HOME",
	    "DOM_VK_XF86XK_VIDEO",
	    "DOM_VK_XF86XK_VIEW",
	    "DOM_VK_XF86XK_WAKE_UP",
	    "DOM_VK_XF86XK_WEB_CAM",
	    "DOM_VK_XF86XK_WHEEL_BUTTON",
	    "DOM_VK_XF86XK_WLAN",
	    "DOM_VK_XF86XK_WORD",
	    "DOM_VK_XF86XK_WWW",
	    "DOM_VK_XF86XK_XFER",
	    "DOM_VK_XF86XK_YELLOW",
	    "DOM_VK_XF86XK_ZOOM_IN",
	    "DOM_VK_XF86XK_ZOOM_OUT",
	    "DOM_VK_Y",
	    "DOM_VK_Z",
	    "DOM_VK_ZOOM",
	    "DONE",
	    "DONT_CARE",
	    "DOWNLOADING",
	    "DRAGDROP",
	    "DRAW_BUFFER0",
	    "DRAW_BUFFER1",
	    "DRAW_BUFFER10",
	    "DRAW_BUFFER11",
	    "DRAW_BUFFER12",
	    "DRAW_BUFFER13",
	    "DRAW_BUFFER14",
	    "DRAW_BUFFER15",
	    "DRAW_BUFFER2",
	    "DRAW_BUFFER3",
	    "DRAW_BUFFER4",
	    "DRAW_BUFFER5",
	    "DRAW_BUFFER6",
	    "DRAW_BUFFER7",
	    "DRAW_BUFFER8",
	    "DRAW_BUFFER9",
	    "DRAW_FRAMEBUFFER",
	    "DRAW_FRAMEBUFFER_BINDING",
	    "DST_ALPHA",
	    "DST_COLOR",
	    "DYNAMIC_COPY",
	    "DYNAMIC_DRAW",
	    "DYNAMIC_READ",
	    "DataChannel",
	    "DataTransfer",
	    "DataTransferItem",
	    "DataTransferItemList",
	    "DataView",
	    "Date",
	    "DateTimeFormat",
	    "DecompressionStream",
	    "DelayNode",
	    "DelegatedInkTrailPresenter",
	    "DeprecationReportBody",
	    "DesktopNotification",
	    "DesktopNotificationCenter",
	    "DeviceLightEvent",
	    "DeviceMotionEvent",
	    "DeviceMotionEventAcceleration",
	    "DeviceMotionEventRotationRate",
	    "DeviceOrientationEvent",
	    "DeviceProximityEvent",
	    "DeviceStorage",
	    "DeviceStorageChangeEvent",
	    "Directory",
	    "DisplayNames",
	    "Document",
	    "DocumentFragment",
	    "DocumentPictureInPicture",
	    "DocumentPictureInPictureEvent",
	    "DocumentTimeline",
	    "DocumentType",
	    "DragEvent",
	    "DynamicsCompressorNode",
	    "E",
	    "ELEMENT_ARRAY_BUFFER",
	    "ELEMENT_ARRAY_BUFFER_BINDING",
	    "ELEMENT_NODE",
	    "EMPTY",
	    "ENCODING_ERR",
	    "ENDED",
	    "END_TO_END",
	    "END_TO_START",
	    "ENTITY_NODE",
	    "ENTITY_REFERENCE_NODE",
	    "EPSILON",
	    "EQUAL",
	    "EQUALPOWER",
	    "ERROR",
	    "EXPONENTIAL_DISTANCE",
	    "EditContext",
	    "Element",
	    "ElementInternals",
	    "ElementQuery",
	    "EncodedAudioChunk",
	    "EncodedVideoChunk",
	    "EnterPictureInPictureEvent",
	    "Entity",
	    "EntityReference",
	    "Error",
	    "ErrorEvent",
	    "EvalError",
	    "Event",
	    "EventCounts",
	    "EventException",
	    "EventSource",
	    "EventTarget",
	    "Exception",
	    "External",
	    "EyeDropper",
	    "FASTEST",
	    "FIDOSDK",
	    "FILTER_ACCEPT",
	    "FILTER_INTERRUPT",
	    "FILTER_REJECT",
	    "FILTER_SKIP",
	    "FINISHED_STATE",
	    "FIRST_ORDERED_NODE_TYPE",
	    "FLOAT",
	    "FLOAT_32_UNSIGNED_INT_24_8_REV",
	    "FLOAT_MAT2",
	    "FLOAT_MAT2x3",
	    "FLOAT_MAT2x4",
	    "FLOAT_MAT3",
	    "FLOAT_MAT3x2",
	    "FLOAT_MAT3x4",
	    "FLOAT_MAT4",
	    "FLOAT_MAT4x2",
	    "FLOAT_MAT4x3",
	    "FLOAT_VEC2",
	    "FLOAT_VEC3",
	    "FLOAT_VEC4",
	    "FOCUS",
	    "FONT_FACE_RULE",
	    "FONT_FEATURE_VALUES_RULE",
	    "FRAGMENT",
	    "FRAGMENT_SHADER",
	    "FRAGMENT_SHADER_DERIVATIVE_HINT",
	    "FRAGMENT_SHADER_DERIVATIVE_HINT_OES",
	    "FRAMEBUFFER",
	    "FRAMEBUFFER_ATTACHMENT_ALPHA_SIZE",
	    "FRAMEBUFFER_ATTACHMENT_BLUE_SIZE",
	    "FRAMEBUFFER_ATTACHMENT_COLOR_ENCODING",
	    "FRAMEBUFFER_ATTACHMENT_COMPONENT_TYPE",
	    "FRAMEBUFFER_ATTACHMENT_DEPTH_SIZE",
	    "FRAMEBUFFER_ATTACHMENT_GREEN_SIZE",
	    "FRAMEBUFFER_ATTACHMENT_OBJECT_NAME",
	    "FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE",
	    "FRAMEBUFFER_ATTACHMENT_RED_SIZE",
	    "FRAMEBUFFER_ATTACHMENT_STENCIL_SIZE",
	    "FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE",
	    "FRAMEBUFFER_ATTACHMENT_TEXTURE_LAYER",
	    "FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL",
	    "FRAMEBUFFER_BINDING",
	    "FRAMEBUFFER_COMPLETE",
	    "FRAMEBUFFER_DEFAULT",
	    "FRAMEBUFFER_INCOMPLETE_ATTACHMENT",
	    "FRAMEBUFFER_INCOMPLETE_DIMENSIONS",
	    "FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT",
	    "FRAMEBUFFER_INCOMPLETE_MULTISAMPLE",
	    "FRAMEBUFFER_UNSUPPORTED",
	    "FRONT",
	    "FRONT_AND_BACK",
	    "FRONT_FACE",
	    "FUNC_ADD",
	    "FUNC_REVERSE_SUBTRACT",
	    "FUNC_SUBTRACT",
	    "FeaturePolicy",
	    "FeaturePolicyViolationReportBody",
	    "FederatedCredential",
	    "Feed",
	    "FeedEntry",
	    "Fence",
	    "FencedFrameConfig",
	    "File",
	    "FileError",
	    "FileList",
	    "FileReader",
	    "FileSystem",
	    "FileSystemDirectoryEntry",
	    "FileSystemDirectoryHandle",
	    "FileSystemDirectoryReader",
	    "FileSystemEntry",
	    "FileSystemFileEntry",
	    "FileSystemFileHandle",
	    "FileSystemHandle",
	    "FileSystemWritableFileStream",
	    "FinalizationRegistry",
	    "FindInPage",
	    "Float32Array",
	    "Float64Array",
	    "FocusEvent",
	    "FontData",
	    "FontFace",
	    "FontFaceSet",
	    "FontFaceSetLoadEvent",
	    "FormData",
	    "FormDataEvent",
	    "FragmentDirective",
	    "Function",
	    "GENERATE_MIPMAP_HINT",
	    "GEQUAL",
	    "GPU",
	    "GPUAdapter",
	    "GPUAdapterInfo",
	    "GPUBindGroup",
	    "GPUBindGroupLayout",
	    "GPUBuffer",
	    "GPUBufferUsage",
	    "GPUCanvasContext",
	    "GPUColorWrite",
	    "GPUCommandBuffer",
	    "GPUCommandEncoder",
	    "GPUCompilationInfo",
	    "GPUCompilationMessage",
	    "GPUComputePassEncoder",
	    "GPUComputePipeline",
	    "GPUDevice",
	    "GPUDeviceLostInfo",
	    "GPUError",
	    "GPUExternalTexture",
	    "GPUInternalError",
	    "GPUMapMode",
	    "GPUOutOfMemoryError",
	    "GPUPipelineError",
	    "GPUPipelineLayout",
	    "GPUQuerySet",
	    "GPUQueue",
	    "GPURenderBundle",
	    "GPURenderBundleEncoder",
	    "GPURenderPassEncoder",
	    "GPURenderPipeline",
	    "GPUSampler",
	    "GPUShaderModule",
	    "GPUShaderStage",
	    "GPUSupportedFeatures",
	    "GPUSupportedLimits",
	    "GPUTexture",
	    "GPUTextureUsage",
	    "GPUTextureView",
	    "GPUUncapturedErrorEvent",
	    "GPUValidationError",
	    "GREATER",
	    "GREEN",
	    "GREEN_BITS",
	    "GainNode",
	    "Gamepad",
	    "GamepadAxisMoveEvent",
	    "GamepadButton",
	    "GamepadButtonEvent",
	    "GamepadEvent",
	    "GamepadHapticActuator",
	    "GamepadPose",
	    "Geolocation",
	    "GeolocationCoordinates",
	    "GeolocationPosition",
	    "GeolocationPositionError",
	    "GestureEvent",
	    "Global",
	    "GravitySensor",
	    "Gyroscope",
	    "HALF_FLOAT",
	    "HAVE_CURRENT_DATA",
	    "HAVE_ENOUGH_DATA",
	    "HAVE_FUTURE_DATA",
	    "HAVE_METADATA",
	    "HAVE_NOTHING",
	    "HEADERS_RECEIVED",
	    "HID",
	    "HIDConnectionEvent",
	    "HIDDEN",
	    "HIDDevice",
	    "HIDInputReportEvent",
	    "HIERARCHY_REQUEST_ERR",
	    "HIGHPASS",
	    "HIGHSHELF",
	    "HIGH_FLOAT",
	    "HIGH_INT",
	    "HORIZONTAL",
	    "HORIZONTAL_AXIS",
	    "HRTF",
	    "HTMLAllCollection",
	    "HTMLAnchorElement",
	    "HTMLAppletElement",
	    "HTMLAreaElement",
	    "HTMLAudioElement",
	    "HTMLBRElement",
	    "HTMLBaseElement",
	    "HTMLBaseFontElement",
	    "HTMLBlockquoteElement",
	    "HTMLBodyElement",
	    "HTMLButtonElement",
	    "HTMLCanvasElement",
	    "HTMLCollection",
	    "HTMLCommandElement",
	    "HTMLContentElement",
	    "HTMLDListElement",
	    "HTMLDataElement",
	    "HTMLDataListElement",
	    "HTMLDetailsElement",
	    "HTMLDialogElement",
	    "HTMLDirectoryElement",
	    "HTMLDivElement",
	    "HTMLDocument",
	    "HTMLElement",
	    "HTMLEmbedElement",
	    "HTMLFencedFrameElement",
	    "HTMLFieldSetElement",
	    "HTMLFontElement",
	    "HTMLFormControlsCollection",
	    "HTMLFormElement",
	    "HTMLFrameElement",
	    "HTMLFrameSetElement",
	    "HTMLHRElement",
	    "HTMLHeadElement",
	    "HTMLHeadingElement",
	    "HTMLHtmlElement",
	    "HTMLIFrameElement",
	    "HTMLImageElement",
	    "HTMLInputElement",
	    "HTMLIsIndexElement",
	    "HTMLKeygenElement",
	    "HTMLLIElement",
	    "HTMLLabelElement",
	    "HTMLLegendElement",
	    "HTMLLinkElement",
	    "HTMLMapElement",
	    "HTMLMarqueeElement",
	    "HTMLMediaElement",
	    "HTMLMenuElement",
	    "HTMLMenuItemElement",
	    "HTMLMetaElement",
	    "HTMLMeterElement",
	    "HTMLModElement",
	    "HTMLOListElement",
	    "HTMLObjectElement",
	    "HTMLOptGroupElement",
	    "HTMLOptionElement",
	    "HTMLOptionsCollection",
	    "HTMLOutputElement",
	    "HTMLParagraphElement",
	    "HTMLParamElement",
	    "HTMLPictureElement",
	    "HTMLPreElement",
	    "HTMLProgressElement",
	    "HTMLPropertiesCollection",
	    "HTMLQuoteElement",
	    "HTMLScriptElement",
	    "HTMLSelectElement",
	    "HTMLShadowElement",
	    "HTMLSlotElement",
	    "HTMLSourceElement",
	    "HTMLSpanElement",
	    "HTMLStyleElement",
	    "HTMLTableCaptionElement",
	    "HTMLTableCellElement",
	    "HTMLTableColElement",
	    "HTMLTableElement",
	    "HTMLTableRowElement",
	    "HTMLTableSectionElement",
	    "HTMLTemplateElement",
	    "HTMLTextAreaElement",
	    "HTMLTimeElement",
	    "HTMLTitleElement",
	    "HTMLTrackElement",
	    "HTMLUListElement",
	    "HTMLUnknownElement",
	    "HTMLVideoElement",
	    "HashChangeEvent",
	    "Headers",
	    "Highlight",
	    "HighlightRegistry",
	    "History",
	    "Hz",
	    "ICE_CHECKING",
	    "ICE_CLOSED",
	    "ICE_COMPLETED",
	    "ICE_CONNECTED",
	    "ICE_FAILED",
	    "ICE_GATHERING",
	    "ICE_WAITING",
	    "IDBCursor",
	    "IDBCursorWithValue",
	    "IDBDatabase",
	    "IDBDatabaseException",
	    "IDBFactory",
	    "IDBFileHandle",
	    "IDBFileRequest",
	    "IDBIndex",
	    "IDBKeyRange",
	    "IDBMutableFile",
	    "IDBObjectStore",
	    "IDBOpenDBRequest",
	    "IDBRequest",
	    "IDBTransaction",
	    "IDBVersionChangeEvent",
	    "IDLE",
	    "IIRFilterNode",
	    "IMPLEMENTATION_COLOR_READ_FORMAT",
	    "IMPLEMENTATION_COLOR_READ_TYPE",
	    "IMPORT_RULE",
	    "INCR",
	    "INCR_WRAP",
	    "INDEX",
	    "INDEX_SIZE_ERR",
	    "INDIRECT",
	    "INT",
	    "INTERLEAVED_ATTRIBS",
	    "INT_2_10_10_10_REV",
	    "INT_SAMPLER_2D",
	    "INT_SAMPLER_2D_ARRAY",
	    "INT_SAMPLER_3D",
	    "INT_SAMPLER_CUBE",
	    "INT_VEC2",
	    "INT_VEC3",
	    "INT_VEC4",
	    "INUSE_ATTRIBUTE_ERR",
	    "INVALID_ACCESS_ERR",
	    "INVALID_CHARACTER_ERR",
	    "INVALID_ENUM",
	    "INVALID_EXPRESSION_ERR",
	    "INVALID_FRAMEBUFFER_OPERATION",
	    "INVALID_INDEX",
	    "INVALID_MODIFICATION_ERR",
	    "INVALID_NODE_TYPE_ERR",
	    "INVALID_OPERATION",
	    "INVALID_STATE_ERR",
	    "INVALID_VALUE",
	    "INVERSE_DISTANCE",
	    "INVERT",
	    "IceCandidate",
	    "IdentityCredential",
	    "IdentityCredentialError",
	    "IdentityProvider",
	    "IdleDeadline",
	    "IdleDetector",
	    "Image",
	    "ImageBitmap",
	    "ImageBitmapRenderingContext",
	    "ImageCapture",
	    "ImageData",
	    "ImageDecoder",
	    "ImageTrack",
	    "ImageTrackList",
	    "Infinity",
	    "Ink",
	    "InputDeviceCapabilities",
	    "InputDeviceInfo",
	    "InputEvent",
	    "InputMethodContext",
	    "InstallTrigger",
	    "InstallTriggerImpl",
	    "Instance",
	    "Int16Array",
	    "Int32Array",
	    "Int8Array",
	    "Intent",
	    "InternalError",
	    "IntersectionObserver",
	    "IntersectionObserverEntry",
	    "Intl",
	    "IsSearchProviderInstalled",
	    "Iterator",
	    "JSON",
	    "JSTag",
	    "KEEP",
	    "KEYDOWN",
	    "KEYFRAMES_RULE",
	    "KEYFRAME_RULE",
	    "KEYPRESS",
	    "KEYUP",
	    "KeyEvent",
	    "Keyboard",
	    "KeyboardEvent",
	    "KeyboardLayoutMap",
	    "KeyframeEffect",
	    "LENGTHADJUST_SPACING",
	    "LENGTHADJUST_SPACINGANDGLYPHS",
	    "LENGTHADJUST_UNKNOWN",
	    "LEQUAL",
	    "LESS",
	    "LINEAR",
	    "LINEAR_DISTANCE",
	    "LINEAR_MIPMAP_LINEAR",
	    "LINEAR_MIPMAP_NEAREST",
	    "LINES",
	    "LINE_LOOP",
	    "LINE_STRIP",
	    "LINE_WIDTH",
	    "LINK_STATUS",
	    "LIVE",
	    "LN10",
	    "LN2",
	    "LOADED",
	    "LOADING",
	    "LOG10E",
	    "LOG2E",
	    "LOWPASS",
	    "LOWSHELF",
	    "LOW_FLOAT",
	    "LOW_INT",
	    "LSException",
	    "LSParserFilter",
	    "LUMINANCE",
	    "LUMINANCE_ALPHA",
	    "LargestContentfulPaint",
	    "LaunchParams",
	    "LaunchQueue",
	    "LayoutShift",
	    "LayoutShiftAttribution",
	    "LinearAccelerationSensor",
	    "LinkError",
	    "ListFormat",
	    "LocalMediaStream",
	    "Locale",
	    "Location",
	    "Lock",
	    "LockManager",
	    "MAP_READ",
	    "MAP_WRITE",
	    "MAX",
	    "MAX_3D_TEXTURE_SIZE",
	    "MAX_ARRAY_TEXTURE_LAYERS",
	    "MAX_CLIENT_WAIT_TIMEOUT_WEBGL",
	    "MAX_COLOR_ATTACHMENTS",
	    "MAX_COMBINED_FRAGMENT_UNIFORM_COMPONENTS",
	    "MAX_COMBINED_TEXTURE_IMAGE_UNITS",
	    "MAX_COMBINED_UNIFORM_BLOCKS",
	    "MAX_COMBINED_VERTEX_UNIFORM_COMPONENTS",
	    "MAX_CUBE_MAP_TEXTURE_SIZE",
	    "MAX_DRAW_BUFFERS",
	    "MAX_ELEMENTS_INDICES",
	    "MAX_ELEMENTS_VERTICES",
	    "MAX_ELEMENT_INDEX",
	    "MAX_FRAGMENT_INPUT_COMPONENTS",
	    "MAX_FRAGMENT_UNIFORM_BLOCKS",
	    "MAX_FRAGMENT_UNIFORM_COMPONENTS",
	    "MAX_FRAGMENT_UNIFORM_VECTORS",
	    "MAX_PROGRAM_TEXEL_OFFSET",
	    "MAX_RENDERBUFFER_SIZE",
	    "MAX_SAFE_INTEGER",
	    "MAX_SAMPLES",
	    "MAX_SERVER_WAIT_TIMEOUT",
	    "MAX_TEXTURE_IMAGE_UNITS",
	    "MAX_TEXTURE_LOD_BIAS",
	    "MAX_TEXTURE_MAX_ANISOTROPY_EXT",
	    "MAX_TEXTURE_SIZE",
	    "MAX_TRANSFORM_FEEDBACK_INTERLEAVED_COMPONENTS",
	    "MAX_TRANSFORM_FEEDBACK_SEPARATE_ATTRIBS",
	    "MAX_TRANSFORM_FEEDBACK_SEPARATE_COMPONENTS",
	    "MAX_UNIFORM_BLOCK_SIZE",
	    "MAX_UNIFORM_BUFFER_BINDINGS",
	    "MAX_VALUE",
	    "MAX_VARYING_COMPONENTS",
	    "MAX_VARYING_VECTORS",
	    "MAX_VERTEX_ATTRIBS",
	    "MAX_VERTEX_OUTPUT_COMPONENTS",
	    "MAX_VERTEX_TEXTURE_IMAGE_UNITS",
	    "MAX_VERTEX_UNIFORM_BLOCKS",
	    "MAX_VERTEX_UNIFORM_COMPONENTS",
	    "MAX_VERTEX_UNIFORM_VECTORS",
	    "MAX_VIEWPORT_DIMS",
	    "MEDIA_ERR_ABORTED",
	    "MEDIA_ERR_DECODE",
	    "MEDIA_ERR_ENCRYPTED",
	    "MEDIA_ERR_NETWORK",
	    "MEDIA_ERR_SRC_NOT_SUPPORTED",
	    "MEDIA_KEYERR_CLIENT",
	    "MEDIA_KEYERR_DOMAIN",
	    "MEDIA_KEYERR_HARDWARECHANGE",
	    "MEDIA_KEYERR_OUTPUT",
	    "MEDIA_KEYERR_SERVICE",
	    "MEDIA_KEYERR_UNKNOWN",
	    "MEDIA_RULE",
	    "MEDIUM_FLOAT",
	    "MEDIUM_INT",
	    "META_MASK",
	    "MIDIAccess",
	    "MIDIConnectionEvent",
	    "MIDIInput",
	    "MIDIInputMap",
	    "MIDIMessageEvent",
	    "MIDIOutput",
	    "MIDIOutputMap",
	    "MIDIPort",
	    "MIN",
	    "MIN_PROGRAM_TEXEL_OFFSET",
	    "MIN_SAFE_INTEGER",
	    "MIN_VALUE",
	    "MIRRORED_REPEAT",
	    "MODE_ASYNCHRONOUS",
	    "MODE_SYNCHRONOUS",
	    "MODIFICATION",
	    "MOUSEDOWN",
	    "MOUSEDRAG",
	    "MOUSEMOVE",
	    "MOUSEOUT",
	    "MOUSEOVER",
	    "MOUSEUP",
	    "MOZ_KEYFRAMES_RULE",
	    "MOZ_KEYFRAME_RULE",
	    "MOZ_SOURCE_CURSOR",
	    "MOZ_SOURCE_ERASER",
	    "MOZ_SOURCE_KEYBOARD",
	    "MOZ_SOURCE_MOUSE",
	    "MOZ_SOURCE_PEN",
	    "MOZ_SOURCE_TOUCH",
	    "MOZ_SOURCE_UNKNOWN",
	    "MSGESTURE_FLAG_BEGIN",
	    "MSGESTURE_FLAG_CANCEL",
	    "MSGESTURE_FLAG_END",
	    "MSGESTURE_FLAG_INERTIA",
	    "MSGESTURE_FLAG_NONE",
	    "MSPOINTER_TYPE_MOUSE",
	    "MSPOINTER_TYPE_PEN",
	    "MSPOINTER_TYPE_TOUCH",
	    "MS_ASYNC_CALLBACK_STATUS_ASSIGN_DELEGATE",
	    "MS_ASYNC_CALLBACK_STATUS_CANCEL",
	    "MS_ASYNC_CALLBACK_STATUS_CHOOSEANY",
	    "MS_ASYNC_CALLBACK_STATUS_ERROR",
	    "MS_ASYNC_CALLBACK_STATUS_JOIN",
	    "MS_ASYNC_OP_STATUS_CANCELED",
	    "MS_ASYNC_OP_STATUS_ERROR",
	    "MS_ASYNC_OP_STATUS_SUCCESS",
	    "MS_MANIPULATION_STATE_ACTIVE",
	    "MS_MANIPULATION_STATE_CANCELLED",
	    "MS_MANIPULATION_STATE_COMMITTED",
	    "MS_MANIPULATION_STATE_DRAGGING",
	    "MS_MANIPULATION_STATE_INERTIA",
	    "MS_MANIPULATION_STATE_PRESELECT",
	    "MS_MANIPULATION_STATE_SELECTING",
	    "MS_MANIPULATION_STATE_STOPPED",
	    "MS_MEDIA_ERR_ENCRYPTED",
	    "MS_MEDIA_KEYERR_CLIENT",
	    "MS_MEDIA_KEYERR_DOMAIN",
	    "MS_MEDIA_KEYERR_HARDWARECHANGE",
	    "MS_MEDIA_KEYERR_OUTPUT",
	    "MS_MEDIA_KEYERR_SERVICE",
	    "MS_MEDIA_KEYERR_UNKNOWN",
	    "Map",
	    "Math",
	    "MathMLElement",
	    "MediaCapabilities",
	    "MediaCapabilitiesInfo",
	    "MediaController",
	    "MediaDeviceInfo",
	    "MediaDevices",
	    "MediaElementAudioSourceNode",
	    "MediaEncryptedEvent",
	    "MediaError",
	    "MediaKeyError",
	    "MediaKeyEvent",
	    "MediaKeyMessageEvent",
	    "MediaKeyNeededEvent",
	    "MediaKeySession",
	    "MediaKeyStatusMap",
	    "MediaKeySystemAccess",
	    "MediaKeys",
	    "MediaList",
	    "MediaMetadata",
	    "MediaQueryList",
	    "MediaQueryListEvent",
	    "MediaRecorder",
	    "MediaRecorderErrorEvent",
	    "MediaSession",
	    "MediaSettingsRange",
	    "MediaSource",
	    "MediaSourceHandle",
	    "MediaStream",
	    "MediaStreamAudioDestinationNode",
	    "MediaStreamAudioSourceNode",
	    "MediaStreamEvent",
	    "MediaStreamTrack",
	    "MediaStreamTrackAudioSourceNode",
	    "MediaStreamTrackEvent",
	    "MediaStreamTrackGenerator",
	    "MediaStreamTrackProcessor",
	    "MediaStreamTrackVideoStats",
	    "Memory",
	    "MessageChannel",
	    "MessageEvent",
	    "MessagePort",
	    "Methods",
	    "MimeType",
	    "MimeTypeArray",
	    "Module",
	    "MouseEvent",
	    "MouseScrollEvent",
	    "MozAnimation",
	    "MozAnimationDelay",
	    "MozAnimationDirection",
	    "MozAnimationDuration",
	    "MozAnimationFillMode",
	    "MozAnimationIterationCount",
	    "MozAnimationName",
	    "MozAnimationPlayState",
	    "MozAnimationTimingFunction",
	    "MozAppearance",
	    "MozBackfaceVisibility",
	    "MozBinding",
	    "MozBorderBottomColors",
	    "MozBorderEnd",
	    "MozBorderEndColor",
	    "MozBorderEndStyle",
	    "MozBorderEndWidth",
	    "MozBorderImage",
	    "MozBorderLeftColors",
	    "MozBorderRightColors",
	    "MozBorderStart",
	    "MozBorderStartColor",
	    "MozBorderStartStyle",
	    "MozBorderStartWidth",
	    "MozBorderTopColors",
	    "MozBoxAlign",
	    "MozBoxDirection",
	    "MozBoxFlex",
	    "MozBoxOrdinalGroup",
	    "MozBoxOrient",
	    "MozBoxPack",
	    "MozBoxSizing",
	    "MozCSSKeyframeRule",
	    "MozCSSKeyframesRule",
	    "MozColumnCount",
	    "MozColumnFill",
	    "MozColumnGap",
	    "MozColumnRule",
	    "MozColumnRuleColor",
	    "MozColumnRuleStyle",
	    "MozColumnRuleWidth",
	    "MozColumnWidth",
	    "MozColumns",
	    "MozContactChangeEvent",
	    "MozFloatEdge",
	    "MozFontFeatureSettings",
	    "MozFontLanguageOverride",
	    "MozForceBrokenImageIcon",
	    "MozHyphens",
	    "MozImageRegion",
	    "MozMarginEnd",
	    "MozMarginStart",
	    "MozMmsEvent",
	    "MozMmsMessage",
	    "MozMobileMessageThread",
	    "MozOSXFontSmoothing",
	    "MozOrient",
	    "MozOsxFontSmoothing",
	    "MozOutlineRadius",
	    "MozOutlineRadiusBottomleft",
	    "MozOutlineRadiusBottomright",
	    "MozOutlineRadiusTopleft",
	    "MozOutlineRadiusTopright",
	    "MozPaddingEnd",
	    "MozPaddingStart",
	    "MozPerspective",
	    "MozPerspectiveOrigin",
	    "MozPowerManager",
	    "MozSettingsEvent",
	    "MozSmsEvent",
	    "MozSmsMessage",
	    "MozStackSizing",
	    "MozTabSize",
	    "MozTextAlignLast",
	    "MozTextDecorationColor",
	    "MozTextDecorationLine",
	    "MozTextDecorationStyle",
	    "MozTextSizeAdjust",
	    "MozTransform",
	    "MozTransformOrigin",
	    "MozTransformStyle",
	    "MozTransition",
	    "MozTransitionDelay",
	    "MozTransitionDuration",
	    "MozTransitionProperty",
	    "MozTransitionTimingFunction",
	    "MozUserFocus",
	    "MozUserInput",
	    "MozUserModify",
	    "MozUserSelect",
	    "MozWindowDragging",
	    "MozWindowShadow",
	    "MutationEvent",
	    "MutationObserver",
	    "MutationRecord",
	    "NAMESPACE_ERR",
	    "NAMESPACE_RULE",
	    "NEAREST",
	    "NEAREST_MIPMAP_LINEAR",
	    "NEAREST_MIPMAP_NEAREST",
	    "NEGATIVE_INFINITY",
	    "NETWORK_EMPTY",
	    "NETWORK_ERR",
	    "NETWORK_IDLE",
	    "NETWORK_LOADED",
	    "NETWORK_LOADING",
	    "NETWORK_NO_SOURCE",
	    "NEVER",
	    "NEW",
	    "NEXT",
	    "NEXT_NO_DUPLICATE",
	    "NICEST",
	    "NODE_AFTER",
	    "NODE_BEFORE",
	    "NODE_BEFORE_AND_AFTER",
	    "NODE_INSIDE",
	    "NONE",
	    "NON_TRANSIENT_ERR",
	    "NOTATION_NODE",
	    "NOTCH",
	    "NOTEQUAL",
	    "NOT_ALLOWED_ERR",
	    "NOT_FOUND_ERR",
	    "NOT_READABLE_ERR",
	    "NOT_SUPPORTED_ERR",
	    "NO_DATA_ALLOWED_ERR",
	    "NO_ERR",
	    "NO_ERROR",
	    "NO_MODIFICATION_ALLOWED_ERR",
	    "NUMBER_TYPE",
	    "NUM_COMPRESSED_TEXTURE_FORMATS",
	    "NaN",
	    "NamedNodeMap",
	    "NavigateEvent",
	    "Navigation",
	    "NavigationActivation",
	    "NavigationCurrentEntryChangeEvent",
	    "NavigationDestination",
	    "NavigationHistoryEntry",
	    "NavigationPreloadManager",
	    "NavigationTransition",
	    "Navigator",
	    "NavigatorLogin",
	    "NavigatorManagedData",
	    "NavigatorUAData",
	    "NearbyLinks",
	    "NetworkInformation",
	    "Node",
	    "NodeFilter",
	    "NodeIterator",
	    "NodeList",
	    "NotRestoredReasonDetails",
	    "NotRestoredReasons",
	    "Notation",
	    "Notification",
	    "NotifyPaintEvent",
	    "Number",
	    "NumberFormat",
	    "OBJECT_TYPE",
	    "OBSOLETE",
	    "OK",
	    "ONE",
	    "ONE_MINUS_CONSTANT_ALPHA",
	    "ONE_MINUS_CONSTANT_COLOR",
	    "ONE_MINUS_DST_ALPHA",
	    "ONE_MINUS_DST_COLOR",
	    "ONE_MINUS_SRC_ALPHA",
	    "ONE_MINUS_SRC_COLOR",
	    "OPEN",
	    "OPENED",
	    "OPENING",
	    "ORDERED_NODE_ITERATOR_TYPE",
	    "ORDERED_NODE_SNAPSHOT_TYPE",
	    "OTHER_ERROR",
	    "OTPCredential",
	    "OUT_OF_MEMORY",
	    "Object",
	    "OfflineAudioCompletionEvent",
	    "OfflineAudioContext",
	    "OfflineResourceList",
	    "OffscreenCanvas",
	    "OffscreenCanvasRenderingContext2D",
	    "Option",
	    "OrientationSensor",
	    "OscillatorNode",
	    "OverconstrainedError",
	    "OverflowEvent",
	    "PACK_ALIGNMENT",
	    "PACK_ROW_LENGTH",
	    "PACK_SKIP_PIXELS",
	    "PACK_SKIP_ROWS",
	    "PAGE_RULE",
	    "PARSE_ERR",
	    "PATHSEG_ARC_ABS",
	    "PATHSEG_ARC_REL",
	    "PATHSEG_CLOSEPATH",
	    "PATHSEG_CURVETO_CUBIC_ABS",
	    "PATHSEG_CURVETO_CUBIC_REL",
	    "PATHSEG_CURVETO_CUBIC_SMOOTH_ABS",
	    "PATHSEG_CURVETO_CUBIC_SMOOTH_REL",
	    "PATHSEG_CURVETO_QUADRATIC_ABS",
	    "PATHSEG_CURVETO_QUADRATIC_REL",
	    "PATHSEG_CURVETO_QUADRATIC_SMOOTH_ABS",
	    "PATHSEG_CURVETO_QUADRATIC_SMOOTH_REL",
	    "PATHSEG_LINETO_ABS",
	    "PATHSEG_LINETO_HORIZONTAL_ABS",
	    "PATHSEG_LINETO_HORIZONTAL_REL",
	    "PATHSEG_LINETO_REL",
	    "PATHSEG_LINETO_VERTICAL_ABS",
	    "PATHSEG_LINETO_VERTICAL_REL",
	    "PATHSEG_MOVETO_ABS",
	    "PATHSEG_MOVETO_REL",
	    "PATHSEG_UNKNOWN",
	    "PATH_EXISTS_ERR",
	    "PEAKING",
	    "PERMISSION_DENIED",
	    "PERSISTENT",
	    "PI",
	    "PIXEL_PACK_BUFFER",
	    "PIXEL_PACK_BUFFER_BINDING",
	    "PIXEL_UNPACK_BUFFER",
	    "PIXEL_UNPACK_BUFFER_BINDING",
	    "PLAYING_STATE",
	    "POINTS",
	    "POLYGON_OFFSET_FACTOR",
	    "POLYGON_OFFSET_FILL",
	    "POLYGON_OFFSET_UNITS",
	    "POSITION_UNAVAILABLE",
	    "POSITIVE_INFINITY",
	    "PREV",
	    "PREV_NO_DUPLICATE",
	    "PROCESSING_INSTRUCTION_NODE",
	    "PageChangeEvent",
	    "PageRevealEvent",
	    "PageSwapEvent",
	    "PageTransitionEvent",
	    "PaintRequest",
	    "PaintRequestList",
	    "PannerNode",
	    "PasswordCredential",
	    "Path2D",
	    "PaymentAddress",
	    "PaymentInstruments",
	    "PaymentManager",
	    "PaymentMethodChangeEvent",
	    "PaymentRequest",
	    "PaymentRequestUpdateEvent",
	    "PaymentResponse",
	    "Performance",
	    "PerformanceElementTiming",
	    "PerformanceEntry",
	    "PerformanceEventTiming",
	    "PerformanceLongAnimationFrameTiming",
	    "PerformanceLongTaskTiming",
	    "PerformanceMark",
	    "PerformanceMeasure",
	    "PerformanceNavigation",
	    "PerformanceNavigationTiming",
	    "PerformanceObserver",
	    "PerformanceObserverEntryList",
	    "PerformancePaintTiming",
	    "PerformanceResourceTiming",
	    "PerformanceScriptTiming",
	    "PerformanceServerTiming",
	    "PerformanceTiming",
	    "PeriodicSyncManager",
	    "PeriodicWave",
	    "PermissionStatus",
	    "Permissions",
	    "PhotoCapabilities",
	    "PictureInPictureEvent",
	    "PictureInPictureWindow",
	    "Plugin",
	    "PluginArray",
	    "PluralRules",
	    "PointerEvent",
	    "PopStateEvent",
	    "PopupBlockedEvent",
	    "Presentation",
	    "PresentationAvailability",
	    "PresentationConnection",
	    "PresentationConnectionAvailableEvent",
	    "PresentationConnectionCloseEvent",
	    "PresentationConnectionList",
	    "PresentationReceiver",
	    "PresentationRequest",
	    "ProcessingInstruction",
	    "Profiler",
	    "ProgressEvent",
	    "Promise",
	    "PromiseRejectionEvent",
	    "PropertyNodeList",
	    "Proxy",
	    "PublicKeyCredential",
	    "PushManager",
	    "PushSubscription",
	    "PushSubscriptionOptions",
	    "Q",
	    "QUERY_RESOLVE",
	    "QUERY_RESULT",
	    "QUERY_RESULT_AVAILABLE",
	    "QUOTA_ERR",
	    "QUOTA_EXCEEDED_ERR",
	    "QueryInterface",
	    "R11F_G11F_B10F",
	    "R16F",
	    "R16I",
	    "R16UI",
	    "R32F",
	    "R32I",
	    "R32UI",
	    "R8",
	    "R8I",
	    "R8UI",
	    "R8_SNORM",
	    "RASTERIZER_DISCARD",
	    "READ",
	    "READ_BUFFER",
	    "READ_FRAMEBUFFER",
	    "READ_FRAMEBUFFER_BINDING",
	    "READ_ONLY",
	    "READ_ONLY_ERR",
	    "READ_WRITE",
	    "RED",
	    "RED_BITS",
	    "RED_INTEGER",
	    "REMOVAL",
	    "RENDERBUFFER",
	    "RENDERBUFFER_ALPHA_SIZE",
	    "RENDERBUFFER_BINDING",
	    "RENDERBUFFER_BLUE_SIZE",
	    "RENDERBUFFER_DEPTH_SIZE",
	    "RENDERBUFFER_GREEN_SIZE",
	    "RENDERBUFFER_HEIGHT",
	    "RENDERBUFFER_INTERNAL_FORMAT",
	    "RENDERBUFFER_RED_SIZE",
	    "RENDERBUFFER_SAMPLES",
	    "RENDERBUFFER_STENCIL_SIZE",
	    "RENDERBUFFER_WIDTH",
	    "RENDERER",
	    "RENDERING_INTENT_ABSOLUTE_COLORIMETRIC",
	    "RENDERING_INTENT_AUTO",
	    "RENDERING_INTENT_PERCEPTUAL",
	    "RENDERING_INTENT_RELATIVE_COLORIMETRIC",
	    "RENDERING_INTENT_SATURATION",
	    "RENDERING_INTENT_UNKNOWN",
	    "RENDER_ATTACHMENT",
	    "REPEAT",
	    "REPLACE",
	    "RG",
	    "RG16F",
	    "RG16I",
	    "RG16UI",
	    "RG32F",
	    "RG32I",
	    "RG32UI",
	    "RG8",
	    "RG8I",
	    "RG8UI",
	    "RG8_SNORM",
	    "RGB",
	    "RGB10_A2",
	    "RGB10_A2UI",
	    "RGB16F",
	    "RGB16I",
	    "RGB16UI",
	    "RGB32F",
	    "RGB32I",
	    "RGB32UI",
	    "RGB565",
	    "RGB5_A1",
	    "RGB8",
	    "RGB8I",
	    "RGB8UI",
	    "RGB8_SNORM",
	    "RGB9_E5",
	    "RGBA",
	    "RGBA16F",
	    "RGBA16I",
	    "RGBA16UI",
	    "RGBA32F",
	    "RGBA32I",
	    "RGBA32UI",
	    "RGBA4",
	    "RGBA8",
	    "RGBA8I",
	    "RGBA8UI",
	    "RGBA8_SNORM",
	    "RGBA_INTEGER",
	    "RGBColor",
	    "RGB_INTEGER",
	    "RG_INTEGER",
	    "ROTATION_CLOCKWISE",
	    "ROTATION_COUNTERCLOCKWISE",
	    "RTCCertificate",
	    "RTCDTMFSender",
	    "RTCDTMFToneChangeEvent",
	    "RTCDataChannel",
	    "RTCDataChannelEvent",
	    "RTCDtlsTransport",
	    "RTCEncodedAudioFrame",
	    "RTCEncodedVideoFrame",
	    "RTCError",
	    "RTCErrorEvent",
	    "RTCIceCandidate",
	    "RTCIceTransport",
	    "RTCPeerConnection",
	    "RTCPeerConnectionIceErrorEvent",
	    "RTCPeerConnectionIceEvent",
	    "RTCRtpReceiver",
	    "RTCRtpScriptTransform",
	    "RTCRtpSender",
	    "RTCRtpTransceiver",
	    "RTCSctpTransport",
	    "RTCSessionDescription",
	    "RTCStatsReport",
	    "RTCTrackEvent",
	    "RadioNodeList",
	    "Range",
	    "RangeError",
	    "RangeException",
	    "ReadableByteStreamController",
	    "ReadableStream",
	    "ReadableStreamBYOBReader",
	    "ReadableStreamBYOBRequest",
	    "ReadableStreamDefaultController",
	    "ReadableStreamDefaultReader",
	    "RecordErrorEvent",
	    "Rect",
	    "ReferenceError",
	    "Reflect",
	    "RegExp",
	    "RelativeOrientationSensor",
	    "RelativeTimeFormat",
	    "RemotePlayback",
	    "Report",
	    "ReportBody",
	    "ReportingObserver",
	    "Request",
	    "ResizeObserver",
	    "ResizeObserverEntry",
	    "ResizeObserverSize",
	    "Response",
	    "RuntimeError",
	    "SAMPLER_2D",
	    "SAMPLER_2D_ARRAY",
	    "SAMPLER_2D_ARRAY_SHADOW",
	    "SAMPLER_2D_SHADOW",
	    "SAMPLER_3D",
	    "SAMPLER_BINDING",
	    "SAMPLER_CUBE",
	    "SAMPLER_CUBE_SHADOW",
	    "SAMPLES",
	    "SAMPLE_ALPHA_TO_COVERAGE",
	    "SAMPLE_BUFFERS",
	    "SAMPLE_COVERAGE",
	    "SAMPLE_COVERAGE_INVERT",
	    "SAMPLE_COVERAGE_VALUE",
	    "SAWTOOTH",
	    "SCHEDULED_STATE",
	    "SCISSOR_BOX",
	    "SCISSOR_TEST",
	    "SCROLL_PAGE_DOWN",
	    "SCROLL_PAGE_UP",
	    "SDP_ANSWER",
	    "SDP_OFFER",
	    "SDP_PRANSWER",
	    "SECURITY_ERR",
	    "SELECT",
	    "SEPARATE_ATTRIBS",
	    "SERIALIZE_ERR",
	    "SEVERITY_ERROR",
	    "SEVERITY_FATAL_ERROR",
	    "SEVERITY_WARNING",
	    "SHADER_COMPILER",
	    "SHADER_TYPE",
	    "SHADING_LANGUAGE_VERSION",
	    "SHIFT_MASK",
	    "SHORT",
	    "SHOWING",
	    "SHOW_ALL",
	    "SHOW_ATTRIBUTE",
	    "SHOW_CDATA_SECTION",
	    "SHOW_COMMENT",
	    "SHOW_DOCUMENT",
	    "SHOW_DOCUMENT_FRAGMENT",
	    "SHOW_DOCUMENT_TYPE",
	    "SHOW_ELEMENT",
	    "SHOW_ENTITY",
	    "SHOW_ENTITY_REFERENCE",
	    "SHOW_NOTATION",
	    "SHOW_PROCESSING_INSTRUCTION",
	    "SHOW_TEXT",
	    "SIGNALED",
	    "SIGNED_NORMALIZED",
	    "SINE",
	    "SOUNDFIELD",
	    "SQLException",
	    "SQRT1_2",
	    "SQRT2",
	    "SQUARE",
	    "SRC_ALPHA",
	    "SRC_ALPHA_SATURATE",
	    "SRC_COLOR",
	    "SRGB",
	    "SRGB8",
	    "SRGB8_ALPHA8",
	    "START_TO_END",
	    "START_TO_START",
	    "STATIC_COPY",
	    "STATIC_DRAW",
	    "STATIC_READ",
	    "STENCIL",
	    "STENCIL_ATTACHMENT",
	    "STENCIL_BACK_FAIL",
	    "STENCIL_BACK_FUNC",
	    "STENCIL_BACK_PASS_DEPTH_FAIL",
	    "STENCIL_BACK_PASS_DEPTH_PASS",
	    "STENCIL_BACK_REF",
	    "STENCIL_BACK_VALUE_MASK",
	    "STENCIL_BACK_WRITEMASK",
	    "STENCIL_BITS",
	    "STENCIL_BUFFER_BIT",
	    "STENCIL_CLEAR_VALUE",
	    "STENCIL_FAIL",
	    "STENCIL_FUNC",
	    "STENCIL_INDEX",
	    "STENCIL_INDEX8",
	    "STENCIL_PASS_DEPTH_FAIL",
	    "STENCIL_PASS_DEPTH_PASS",
	    "STENCIL_REF",
	    "STENCIL_TEST",
	    "STENCIL_VALUE_MASK",
	    "STENCIL_WRITEMASK",
	    "STORAGE",
	    "STORAGE_BINDING",
	    "STREAM_COPY",
	    "STREAM_DRAW",
	    "STREAM_READ",
	    "STRING_TYPE",
	    "STYLE_RULE",
	    "SUBPIXEL_BITS",
	    "SUPPORTS_RULE",
	    "SVGAElement",
	    "SVGAltGlyphDefElement",
	    "SVGAltGlyphElement",
	    "SVGAltGlyphItemElement",
	    "SVGAngle",
	    "SVGAnimateColorElement",
	    "SVGAnimateElement",
	    "SVGAnimateMotionElement",
	    "SVGAnimateTransformElement",
	    "SVGAnimatedAngle",
	    "SVGAnimatedBoolean",
	    "SVGAnimatedEnumeration",
	    "SVGAnimatedInteger",
	    "SVGAnimatedLength",
	    "SVGAnimatedLengthList",
	    "SVGAnimatedNumber",
	    "SVGAnimatedNumberList",
	    "SVGAnimatedPreserveAspectRatio",
	    "SVGAnimatedRect",
	    "SVGAnimatedString",
	    "SVGAnimatedTransformList",
	    "SVGAnimationElement",
	    "SVGCircleElement",
	    "SVGClipPathElement",
	    "SVGColor",
	    "SVGComponentTransferFunctionElement",
	    "SVGCursorElement",
	    "SVGDefsElement",
	    "SVGDescElement",
	    "SVGDiscardElement",
	    "SVGDocument",
	    "SVGElement",
	    "SVGElementInstance",
	    "SVGElementInstanceList",
	    "SVGEllipseElement",
	    "SVGException",
	    "SVGFEBlendElement",
	    "SVGFEColorMatrixElement",
	    "SVGFEComponentTransferElement",
	    "SVGFECompositeElement",
	    "SVGFEConvolveMatrixElement",
	    "SVGFEDiffuseLightingElement",
	    "SVGFEDisplacementMapElement",
	    "SVGFEDistantLightElement",
	    "SVGFEDropShadowElement",
	    "SVGFEFloodElement",
	    "SVGFEFuncAElement",
	    "SVGFEFuncBElement",
	    "SVGFEFuncGElement",
	    "SVGFEFuncRElement",
	    "SVGFEGaussianBlurElement",
	    "SVGFEImageElement",
	    "SVGFEMergeElement",
	    "SVGFEMergeNodeElement",
	    "SVGFEMorphologyElement",
	    "SVGFEOffsetElement",
	    "SVGFEPointLightElement",
	    "SVGFESpecularLightingElement",
	    "SVGFESpotLightElement",
	    "SVGFETileElement",
	    "SVGFETurbulenceElement",
	    "SVGFilterElement",
	    "SVGFontElement",
	    "SVGFontFaceElement",
	    "SVGFontFaceFormatElement",
	    "SVGFontFaceNameElement",
	    "SVGFontFaceSrcElement",
	    "SVGFontFaceUriElement",
	    "SVGForeignObjectElement",
	    "SVGGElement",
	    "SVGGeometryElement",
	    "SVGGlyphElement",
	    "SVGGlyphRefElement",
	    "SVGGradientElement",
	    "SVGGraphicsElement",
	    "SVGHKernElement",
	    "SVGImageElement",
	    "SVGLength",
	    "SVGLengthList",
	    "SVGLineElement",
	    "SVGLinearGradientElement",
	    "SVGMPathElement",
	    "SVGMarkerElement",
	    "SVGMaskElement",
	    "SVGMatrix",
	    "SVGMetadataElement",
	    "SVGMissingGlyphElement",
	    "SVGNumber",
	    "SVGNumberList",
	    "SVGPaint",
	    "SVGPathElement",
	    "SVGPathSeg",
	    "SVGPathSegArcAbs",
	    "SVGPathSegArcRel",
	    "SVGPathSegClosePath",
	    "SVGPathSegCurvetoCubicAbs",
	    "SVGPathSegCurvetoCubicRel",
	    "SVGPathSegCurvetoCubicSmoothAbs",
	    "SVGPathSegCurvetoCubicSmoothRel",
	    "SVGPathSegCurvetoQuadraticAbs",
	    "SVGPathSegCurvetoQuadraticRel",
	    "SVGPathSegCurvetoQuadraticSmoothAbs",
	    "SVGPathSegCurvetoQuadraticSmoothRel",
	    "SVGPathSegLinetoAbs",
	    "SVGPathSegLinetoHorizontalAbs",
	    "SVGPathSegLinetoHorizontalRel",
	    "SVGPathSegLinetoRel",
	    "SVGPathSegLinetoVerticalAbs",
	    "SVGPathSegLinetoVerticalRel",
	    "SVGPathSegList",
	    "SVGPathSegMovetoAbs",
	    "SVGPathSegMovetoRel",
	    "SVGPatternElement",
	    "SVGPoint",
	    "SVGPointList",
	    "SVGPolygonElement",
	    "SVGPolylineElement",
	    "SVGPreserveAspectRatio",
	    "SVGRadialGradientElement",
	    "SVGRect",
	    "SVGRectElement",
	    "SVGRenderingIntent",
	    "SVGSVGElement",
	    "SVGScriptElement",
	    "SVGSetElement",
	    "SVGStopElement",
	    "SVGStringList",
	    "SVGStyleElement",
	    "SVGSwitchElement",
	    "SVGSymbolElement",
	    "SVGTRefElement",
	    "SVGTSpanElement",
	    "SVGTextContentElement",
	    "SVGTextElement",
	    "SVGTextPathElement",
	    "SVGTextPositioningElement",
	    "SVGTitleElement",
	    "SVGTransform",
	    "SVGTransformList",
	    "SVGUnitTypes",
	    "SVGUseElement",
	    "SVGVKernElement",
	    "SVGViewElement",
	    "SVGViewSpec",
	    "SVGZoomAndPan",
	    "SVGZoomEvent",
	    "SVG_ANGLETYPE_DEG",
	    "SVG_ANGLETYPE_GRAD",
	    "SVG_ANGLETYPE_RAD",
	    "SVG_ANGLETYPE_UNKNOWN",
	    "SVG_ANGLETYPE_UNSPECIFIED",
	    "SVG_CHANNEL_A",
	    "SVG_CHANNEL_B",
	    "SVG_CHANNEL_G",
	    "SVG_CHANNEL_R",
	    "SVG_CHANNEL_UNKNOWN",
	    "SVG_COLORTYPE_CURRENTCOLOR",
	    "SVG_COLORTYPE_RGBCOLOR",
	    "SVG_COLORTYPE_RGBCOLOR_ICCCOLOR",
	    "SVG_COLORTYPE_UNKNOWN",
	    "SVG_EDGEMODE_DUPLICATE",
	    "SVG_EDGEMODE_NONE",
	    "SVG_EDGEMODE_UNKNOWN",
	    "SVG_EDGEMODE_WRAP",
	    "SVG_FEBLEND_MODE_COLOR",
	    "SVG_FEBLEND_MODE_COLOR_BURN",
	    "SVG_FEBLEND_MODE_COLOR_DODGE",
	    "SVG_FEBLEND_MODE_DARKEN",
	    "SVG_FEBLEND_MODE_DIFFERENCE",
	    "SVG_FEBLEND_MODE_EXCLUSION",
	    "SVG_FEBLEND_MODE_HARD_LIGHT",
	    "SVG_FEBLEND_MODE_HUE",
	    "SVG_FEBLEND_MODE_LIGHTEN",
	    "SVG_FEBLEND_MODE_LUMINOSITY",
	    "SVG_FEBLEND_MODE_MULTIPLY",
	    "SVG_FEBLEND_MODE_NORMAL",
	    "SVG_FEBLEND_MODE_OVERLAY",
	    "SVG_FEBLEND_MODE_SATURATION",
	    "SVG_FEBLEND_MODE_SCREEN",
	    "SVG_FEBLEND_MODE_SOFT_LIGHT",
	    "SVG_FEBLEND_MODE_UNKNOWN",
	    "SVG_FECOLORMATRIX_TYPE_HUEROTATE",
	    "SVG_FECOLORMATRIX_TYPE_LUMINANCETOALPHA",
	    "SVG_FECOLORMATRIX_TYPE_MATRIX",
	    "SVG_FECOLORMATRIX_TYPE_SATURATE",
	    "SVG_FECOLORMATRIX_TYPE_UNKNOWN",
	    "SVG_FECOMPONENTTRANSFER_TYPE_DISCRETE",
	    "SVG_FECOMPONENTTRANSFER_TYPE_GAMMA",
	    "SVG_FECOMPONENTTRANSFER_TYPE_IDENTITY",
	    "SVG_FECOMPONENTTRANSFER_TYPE_LINEAR",
	    "SVG_FECOMPONENTTRANSFER_TYPE_TABLE",
	    "SVG_FECOMPONENTTRANSFER_TYPE_UNKNOWN",
	    "SVG_FECOMPOSITE_OPERATOR_ARITHMETIC",
	    "SVG_FECOMPOSITE_OPERATOR_ATOP",
	    "SVG_FECOMPOSITE_OPERATOR_IN",
	    "SVG_FECOMPOSITE_OPERATOR_LIGHTER",
	    "SVG_FECOMPOSITE_OPERATOR_OUT",
	    "SVG_FECOMPOSITE_OPERATOR_OVER",
	    "SVG_FECOMPOSITE_OPERATOR_UNKNOWN",
	    "SVG_FECOMPOSITE_OPERATOR_XOR",
	    "SVG_INVALID_VALUE_ERR",
	    "SVG_LENGTHTYPE_CM",
	    "SVG_LENGTHTYPE_EMS",
	    "SVG_LENGTHTYPE_EXS",
	    "SVG_LENGTHTYPE_IN",
	    "SVG_LENGTHTYPE_MM",
	    "SVG_LENGTHTYPE_NUMBER",
	    "SVG_LENGTHTYPE_PC",
	    "SVG_LENGTHTYPE_PERCENTAGE",
	    "SVG_LENGTHTYPE_PT",
	    "SVG_LENGTHTYPE_PX",
	    "SVG_LENGTHTYPE_UNKNOWN",
	    "SVG_MARKERUNITS_STROKEWIDTH",
	    "SVG_MARKERUNITS_UNKNOWN",
	    "SVG_MARKERUNITS_USERSPACEONUSE",
	    "SVG_MARKER_ORIENT_ANGLE",
	    "SVG_MARKER_ORIENT_AUTO",
	    "SVG_MARKER_ORIENT_AUTO_START_REVERSE",
	    "SVG_MARKER_ORIENT_UNKNOWN",
	    "SVG_MASKTYPE_ALPHA",
	    "SVG_MASKTYPE_LUMINANCE",
	    "SVG_MATRIX_NOT_INVERTABLE",
	    "SVG_MEETORSLICE_MEET",
	    "SVG_MEETORSLICE_SLICE",
	    "SVG_MEETORSLICE_UNKNOWN",
	    "SVG_MORPHOLOGY_OPERATOR_DILATE",
	    "SVG_MORPHOLOGY_OPERATOR_ERODE",
	    "SVG_MORPHOLOGY_OPERATOR_UNKNOWN",
	    "SVG_PAINTTYPE_CURRENTCOLOR",
	    "SVG_PAINTTYPE_NONE",
	    "SVG_PAINTTYPE_RGBCOLOR",
	    "SVG_PAINTTYPE_RGBCOLOR_ICCCOLOR",
	    "SVG_PAINTTYPE_UNKNOWN",
	    "SVG_PAINTTYPE_URI",
	    "SVG_PAINTTYPE_URI_CURRENTCOLOR",
	    "SVG_PAINTTYPE_URI_NONE",
	    "SVG_PAINTTYPE_URI_RGBCOLOR",
	    "SVG_PAINTTYPE_URI_RGBCOLOR_ICCCOLOR",
	    "SVG_PRESERVEASPECTRATIO_NONE",
	    "SVG_PRESERVEASPECTRATIO_UNKNOWN",
	    "SVG_PRESERVEASPECTRATIO_XMAXYMAX",
	    "SVG_PRESERVEASPECTRATIO_XMAXYMID",
	    "SVG_PRESERVEASPECTRATIO_XMAXYMIN",
	    "SVG_PRESERVEASPECTRATIO_XMIDYMAX",
	    "SVG_PRESERVEASPECTRATIO_XMIDYMID",
	    "SVG_PRESERVEASPECTRATIO_XMIDYMIN",
	    "SVG_PRESERVEASPECTRATIO_XMINYMAX",
	    "SVG_PRESERVEASPECTRATIO_XMINYMID",
	    "SVG_PRESERVEASPECTRATIO_XMINYMIN",
	    "SVG_SPREADMETHOD_PAD",
	    "SVG_SPREADMETHOD_REFLECT",
	    "SVG_SPREADMETHOD_REPEAT",
	    "SVG_SPREADMETHOD_UNKNOWN",
	    "SVG_STITCHTYPE_NOSTITCH",
	    "SVG_STITCHTYPE_STITCH",
	    "SVG_STITCHTYPE_UNKNOWN",
	    "SVG_TRANSFORM_MATRIX",
	    "SVG_TRANSFORM_ROTATE",
	    "SVG_TRANSFORM_SCALE",
	    "SVG_TRANSFORM_SKEWX",
	    "SVG_TRANSFORM_SKEWY",
	    "SVG_TRANSFORM_TRANSLATE",
	    "SVG_TRANSFORM_UNKNOWN",
	    "SVG_TURBULENCE_TYPE_FRACTALNOISE",
	    "SVG_TURBULENCE_TYPE_TURBULENCE",
	    "SVG_TURBULENCE_TYPE_UNKNOWN",
	    "SVG_UNIT_TYPE_OBJECTBOUNDINGBOX",
	    "SVG_UNIT_TYPE_UNKNOWN",
	    "SVG_UNIT_TYPE_USERSPACEONUSE",
	    "SVG_WRONG_TYPE_ERR",
	    "SVG_ZOOMANDPAN_DISABLE",
	    "SVG_ZOOMANDPAN_MAGNIFY",
	    "SVG_ZOOMANDPAN_UNKNOWN",
	    "SYNC_CONDITION",
	    "SYNC_FENCE",
	    "SYNC_FLAGS",
	    "SYNC_FLUSH_COMMANDS_BIT",
	    "SYNC_GPU_COMMANDS_COMPLETE",
	    "SYNC_STATUS",
	    "SYNTAX_ERR",
	    "SavedPages",
	    "Scheduler",
	    "Scheduling",
	    "Screen",
	    "ScreenDetailed",
	    "ScreenDetails",
	    "ScreenOrientation",
	    "Script",
	    "ScriptProcessorNode",
	    "ScrollAreaEvent",
	    "ScrollTimeline",
	    "SecurityPolicyViolationEvent",
	    "Segmenter",
	    "Selection",
	    "Sensor",
	    "SensorErrorEvent",
	    "Serial",
	    "SerialPort",
	    "ServiceWorker",
	    "ServiceWorkerContainer",
	    "ServiceWorkerRegistration",
	    "SessionDescription",
	    "Set",
	    "ShadowRoot",
	    "SharedArrayBuffer",
	    "SharedStorage",
	    "SharedStorageWorklet",
	    "SharedWorker",
	    "SimpleGestureEvent",
	    "SourceBuffer",
	    "SourceBufferList",
	    "SpeechSynthesis",
	    "SpeechSynthesisErrorEvent",
	    "SpeechSynthesisEvent",
	    "SpeechSynthesisUtterance",
	    "SpeechSynthesisVoice",
	    "StaticRange",
	    "StereoPannerNode",
	    "StopIteration",
	    "Storage",
	    "StorageBucket",
	    "StorageBucketManager",
	    "StorageEvent",
	    "StorageManager",
	    "String",
	    "StructType",
	    "StylePropertyMap",
	    "StylePropertyMapReadOnly",
	    "StyleSheet",
	    "StyleSheetList",
	    "SubmitEvent",
	    "SubtleCrypto",
	    "Symbol",
	    "SyncManager",
	    "SyntaxError",
	    "TEMPORARY",
	    "TEXTPATH_METHODTYPE_ALIGN",
	    "TEXTPATH_METHODTYPE_STRETCH",
	    "TEXTPATH_METHODTYPE_UNKNOWN",
	    "TEXTPATH_SPACINGTYPE_AUTO",
	    "TEXTPATH_SPACINGTYPE_EXACT",
	    "TEXTPATH_SPACINGTYPE_UNKNOWN",
	    "TEXTURE",
	    "TEXTURE0",
	    "TEXTURE1",
	    "TEXTURE10",
	    "TEXTURE11",
	    "TEXTURE12",
	    "TEXTURE13",
	    "TEXTURE14",
	    "TEXTURE15",
	    "TEXTURE16",
	    "TEXTURE17",
	    "TEXTURE18",
	    "TEXTURE19",
	    "TEXTURE2",
	    "TEXTURE20",
	    "TEXTURE21",
	    "TEXTURE22",
	    "TEXTURE23",
	    "TEXTURE24",
	    "TEXTURE25",
	    "TEXTURE26",
	    "TEXTURE27",
	    "TEXTURE28",
	    "TEXTURE29",
	    "TEXTURE3",
	    "TEXTURE30",
	    "TEXTURE31",
	    "TEXTURE4",
	    "TEXTURE5",
	    "TEXTURE6",
	    "TEXTURE7",
	    "TEXTURE8",
	    "TEXTURE9",
	    "TEXTURE_2D",
	    "TEXTURE_2D_ARRAY",
	    "TEXTURE_3D",
	    "TEXTURE_BASE_LEVEL",
	    "TEXTURE_BINDING",
	    "TEXTURE_BINDING_2D",
	    "TEXTURE_BINDING_2D_ARRAY",
	    "TEXTURE_BINDING_3D",
	    "TEXTURE_BINDING_CUBE_MAP",
	    "TEXTURE_COMPARE_FUNC",
	    "TEXTURE_COMPARE_MODE",
	    "TEXTURE_CUBE_MAP",
	    "TEXTURE_CUBE_MAP_NEGATIVE_X",
	    "TEXTURE_CUBE_MAP_NEGATIVE_Y",
	    "TEXTURE_CUBE_MAP_NEGATIVE_Z",
	    "TEXTURE_CUBE_MAP_POSITIVE_X",
	    "TEXTURE_CUBE_MAP_POSITIVE_Y",
	    "TEXTURE_CUBE_MAP_POSITIVE_Z",
	    "TEXTURE_IMMUTABLE_FORMAT",
	    "TEXTURE_IMMUTABLE_LEVELS",
	    "TEXTURE_MAG_FILTER",
	    "TEXTURE_MAX_ANISOTROPY_EXT",
	    "TEXTURE_MAX_LEVEL",
	    "TEXTURE_MAX_LOD",
	    "TEXTURE_MIN_FILTER",
	    "TEXTURE_MIN_LOD",
	    "TEXTURE_WRAP_R",
	    "TEXTURE_WRAP_S",
	    "TEXTURE_WRAP_T",
	    "TEXT_NODE",
	    "TIMEOUT",
	    "TIMEOUT_ERR",
	    "TIMEOUT_EXPIRED",
	    "TIMEOUT_IGNORED",
	    "TOO_LARGE_ERR",
	    "TRANSACTION_INACTIVE_ERR",
	    "TRANSFORM_FEEDBACK",
	    "TRANSFORM_FEEDBACK_ACTIVE",
	    "TRANSFORM_FEEDBACK_BINDING",
	    "TRANSFORM_FEEDBACK_BUFFER",
	    "TRANSFORM_FEEDBACK_BUFFER_BINDING",
	    "TRANSFORM_FEEDBACK_BUFFER_MODE",
	    "TRANSFORM_FEEDBACK_BUFFER_SIZE",
	    "TRANSFORM_FEEDBACK_BUFFER_START",
	    "TRANSFORM_FEEDBACK_PAUSED",
	    "TRANSFORM_FEEDBACK_PRIMITIVES_WRITTEN",
	    "TRANSFORM_FEEDBACK_VARYINGS",
	    "TRIANGLE",
	    "TRIANGLES",
	    "TRIANGLE_FAN",
	    "TRIANGLE_STRIP",
	    "TYPE_BACK_FORWARD",
	    "TYPE_ERR",
	    "TYPE_MISMATCH_ERR",
	    "TYPE_NAVIGATE",
	    "TYPE_RELOAD",
	    "TYPE_RESERVED",
	    "Table",
	    "Tag",
	    "TaskAttributionTiming",
	    "TaskController",
	    "TaskPriorityChangeEvent",
	    "TaskSignal",
	    "Text",
	    "TextDecoder",
	    "TextDecoderStream",
	    "TextEncoder",
	    "TextEncoderStream",
	    "TextEvent",
	    "TextFormat",
	    "TextFormatUpdateEvent",
	    "TextMetrics",
	    "TextTrack",
	    "TextTrackCue",
	    "TextTrackCueList",
	    "TextTrackList",
	    "TextUpdateEvent",
	    "TimeEvent",
	    "TimeRanges",
	    "ToggleEvent",
	    "Touch",
	    "TouchEvent",
	    "TouchList",
	    "TrackEvent",
	    "TransformStream",
	    "TransformStreamDefaultController",
	    "TransitionEvent",
	    "TreeWalker",
	    "TrustedHTML",
	    "TrustedScript",
	    "TrustedScriptURL",
	    "TrustedTypePolicy",
	    "TrustedTypePolicyFactory",
	    "TypeError",
	    "TypedObject",
	    "U2F",
	    "UIEvent",
	    "UNCACHED",
	    "UNIFORM",
	    "UNIFORM_ARRAY_STRIDE",
	    "UNIFORM_BLOCK_ACTIVE_UNIFORMS",
	    "UNIFORM_BLOCK_ACTIVE_UNIFORM_INDICES",
	    "UNIFORM_BLOCK_BINDING",
	    "UNIFORM_BLOCK_DATA_SIZE",
	    "UNIFORM_BLOCK_INDEX",
	    "UNIFORM_BLOCK_REFERENCED_BY_FRAGMENT_SHADER",
	    "UNIFORM_BLOCK_REFERENCED_BY_VERTEX_SHADER",
	    "UNIFORM_BUFFER",
	    "UNIFORM_BUFFER_BINDING",
	    "UNIFORM_BUFFER_OFFSET_ALIGNMENT",
	    "UNIFORM_BUFFER_SIZE",
	    "UNIFORM_BUFFER_START",
	    "UNIFORM_IS_ROW_MAJOR",
	    "UNIFORM_MATRIX_STRIDE",
	    "UNIFORM_OFFSET",
	    "UNIFORM_SIZE",
	    "UNIFORM_TYPE",
	    "UNKNOWN_ERR",
	    "UNKNOWN_RULE",
	    "UNMASKED_RENDERER_WEBGL",
	    "UNMASKED_VENDOR_WEBGL",
	    "UNORDERED_NODE_ITERATOR_TYPE",
	    "UNORDERED_NODE_SNAPSHOT_TYPE",
	    "UNPACK_ALIGNMENT",
	    "UNPACK_COLORSPACE_CONVERSION_WEBGL",
	    "UNPACK_FLIP_Y_WEBGL",
	    "UNPACK_IMAGE_HEIGHT",
	    "UNPACK_PREMULTIPLY_ALPHA_WEBGL",
	    "UNPACK_ROW_LENGTH",
	    "UNPACK_SKIP_IMAGES",
	    "UNPACK_SKIP_PIXELS",
	    "UNPACK_SKIP_ROWS",
	    "UNSCHEDULED_STATE",
	    "UNSENT",
	    "UNSIGNALED",
	    "UNSIGNED_BYTE",
	    "UNSIGNED_INT",
	    "UNSIGNED_INT_10F_11F_11F_REV",
	    "UNSIGNED_INT_24_8",
	    "UNSIGNED_INT_2_10_10_10_REV",
	    "UNSIGNED_INT_5_9_9_9_REV",
	    "UNSIGNED_INT_SAMPLER_2D",
	    "UNSIGNED_INT_SAMPLER_2D_ARRAY",
	    "UNSIGNED_INT_SAMPLER_3D",
	    "UNSIGNED_INT_SAMPLER_CUBE",
	    "UNSIGNED_INT_VEC2",
	    "UNSIGNED_INT_VEC3",
	    "UNSIGNED_INT_VEC4",
	    "UNSIGNED_NORMALIZED",
	    "UNSIGNED_SHORT",
	    "UNSIGNED_SHORT_4_4_4_4",
	    "UNSIGNED_SHORT_5_5_5_1",
	    "UNSIGNED_SHORT_5_6_5",
	    "UNSPECIFIED_EVENT_TYPE_ERR",
	    "UPDATEREADY",
	    "URIError",
	    "URL",
	    "URLPattern",
	    "URLSearchParams",
	    "URLUnencoded",
	    "URL_MISMATCH_ERR",
	    "USB",
	    "USBAlternateInterface",
	    "USBConfiguration",
	    "USBConnectionEvent",
	    "USBDevice",
	    "USBEndpoint",
	    "USBInTransferResult",
	    "USBInterface",
	    "USBIsochronousInTransferPacket",
	    "USBIsochronousInTransferResult",
	    "USBIsochronousOutTransferPacket",
	    "USBIsochronousOutTransferResult",
	    "USBOutTransferResult",
	    "UTC",
	    "Uint16Array",
	    "Uint32Array",
	    "Uint8Array",
	    "Uint8ClampedArray",
	    "UserActivation",
	    "UserMessageHandler",
	    "UserMessageHandlersNamespace",
	    "UserProximityEvent",
	    "VALIDATE_STATUS",
	    "VALIDATION_ERR",
	    "VARIABLES_RULE",
	    "VENDOR",
	    "VERSION",
	    "VERSION_CHANGE",
	    "VERSION_ERR",
	    "VERTEX",
	    "VERTEX_ARRAY_BINDING",
	    "VERTEX_ATTRIB_ARRAY_BUFFER_BINDING",
	    "VERTEX_ATTRIB_ARRAY_DIVISOR",
	    "VERTEX_ATTRIB_ARRAY_DIVISOR_ANGLE",
	    "VERTEX_ATTRIB_ARRAY_ENABLED",
	    "VERTEX_ATTRIB_ARRAY_INTEGER",
	    "VERTEX_ATTRIB_ARRAY_NORMALIZED",
	    "VERTEX_ATTRIB_ARRAY_POINTER",
	    "VERTEX_ATTRIB_ARRAY_SIZE",
	    "VERTEX_ATTRIB_ARRAY_STRIDE",
	    "VERTEX_ATTRIB_ARRAY_TYPE",
	    "VERTEX_SHADER",
	    "VERTICAL",
	    "VERTICAL_AXIS",
	    "VER_ERR",
	    "VIEWPORT",
	    "VIEWPORT_RULE",
	    "VRDisplay",
	    "VRDisplayCapabilities",
	    "VRDisplayEvent",
	    "VREyeParameters",
	    "VRFieldOfView",
	    "VRFrameData",
	    "VRPose",
	    "VRStageParameters",
	    "VTTCue",
	    "VTTRegion",
	    "ValidityState",
	    "VideoColorSpace",
	    "VideoDecoder",
	    "VideoEncoder",
	    "VideoFrame",
	    "VideoPlaybackQuality",
	    "VideoStreamTrack",
	    "ViewTimeline",
	    "ViewTransition",
	    "VirtualKeyboard",
	    "VirtualKeyboardGeometryChangeEvent",
	    "VisibilityStateEntry",
	    "VisualViewport",
	    "WAIT_FAILED",
	    "WEBKIT_FILTER_RULE",
	    "WEBKIT_KEYFRAMES_RULE",
	    "WEBKIT_KEYFRAME_RULE",
	    "WEBKIT_REGION_RULE",
	    "WGSLLanguageFeatures",
	    "WRITE",
	    "WRONG_DOCUMENT_ERR",
	    "WakeLock",
	    "WakeLockSentinel",
	    "WasmAnyRef",
	    "WaveShaperNode",
	    "WeakMap",
	    "WeakRef",
	    "WeakSet",
	    "WebAssembly",
	    "WebGL2RenderingContext",
	    "WebGLActiveInfo",
	    "WebGLBuffer",
	    "WebGLContextEvent",
	    "WebGLFramebuffer",
	    "WebGLProgram",
	    "WebGLQuery",
	    "WebGLRenderbuffer",
	    "WebGLRenderingContext",
	    "WebGLSampler",
	    "WebGLShader",
	    "WebGLShaderPrecisionFormat",
	    "WebGLSync",
	    "WebGLTexture",
	    "WebGLTransformFeedback",
	    "WebGLUniformLocation",
	    "WebGLVertexArray",
	    "WebGLVertexArrayObject",
	    "WebKitAnimationEvent",
	    "WebKitBlobBuilder",
	    "WebKitCSSFilterRule",
	    "WebKitCSSFilterValue",
	    "WebKitCSSKeyframeRule",
	    "WebKitCSSKeyframesRule",
	    "WebKitCSSMatrix",
	    "WebKitCSSRegionRule",
	    "WebKitCSSTransformValue",
	    "WebKitDataCue",
	    "WebKitGamepad",
	    "WebKitMediaKeyError",
	    "WebKitMediaKeyMessageEvent",
	    "WebKitMediaKeySession",
	    "WebKitMediaKeys",
	    "WebKitMediaSource",
	    "WebKitMutationObserver",
	    "WebKitNamespace",
	    "WebKitPlaybackTargetAvailabilityEvent",
	    "WebKitPoint",
	    "WebKitShadowRoot",
	    "WebKitSourceBuffer",
	    "WebKitSourceBufferList",
	    "WebKitTransitionEvent",
	    "WebSocket",
	    "WebSocketError",
	    "WebSocketStream",
	    "WebTransport",
	    "WebTransportBidirectionalStream",
	    "WebTransportDatagramDuplexStream",
	    "WebTransportError",
	    "WebTransportReceiveStream",
	    "WebTransportSendStream",
	    "WebkitAlignContent",
	    "WebkitAlignItems",
	    "WebkitAlignSelf",
	    "WebkitAnimation",
	    "WebkitAnimationDelay",
	    "WebkitAnimationDirection",
	    "WebkitAnimationDuration",
	    "WebkitAnimationFillMode",
	    "WebkitAnimationIterationCount",
	    "WebkitAnimationName",
	    "WebkitAnimationPlayState",
	    "WebkitAnimationTimingFunction",
	    "WebkitAppearance",
	    "WebkitBackfaceVisibility",
	    "WebkitBackgroundClip",
	    "WebkitBackgroundOrigin",
	    "WebkitBackgroundSize",
	    "WebkitBorderBottomLeftRadius",
	    "WebkitBorderBottomRightRadius",
	    "WebkitBorderImage",
	    "WebkitBorderRadius",
	    "WebkitBorderTopLeftRadius",
	    "WebkitBorderTopRightRadius",
	    "WebkitBoxAlign",
	    "WebkitBoxDirection",
	    "WebkitBoxFlex",
	    "WebkitBoxOrdinalGroup",
	    "WebkitBoxOrient",
	    "WebkitBoxPack",
	    "WebkitBoxShadow",
	    "WebkitBoxSizing",
	    "WebkitClipPath",
	    "WebkitFilter",
	    "WebkitFlex",
	    "WebkitFlexBasis",
	    "WebkitFlexDirection",
	    "WebkitFlexFlow",
	    "WebkitFlexGrow",
	    "WebkitFlexShrink",
	    "WebkitFlexWrap",
	    "WebkitJustifyContent",
	    "WebkitLineClamp",
	    "WebkitMask",
	    "WebkitMaskClip",
	    "WebkitMaskComposite",
	    "WebkitMaskImage",
	    "WebkitMaskOrigin",
	    "WebkitMaskPosition",
	    "WebkitMaskPositionX",
	    "WebkitMaskPositionY",
	    "WebkitMaskRepeat",
	    "WebkitMaskSize",
	    "WebkitOrder",
	    "WebkitPerspective",
	    "WebkitPerspectiveOrigin",
	    "WebkitTextFillColor",
	    "WebkitTextSecurity",
	    "WebkitTextSizeAdjust",
	    "WebkitTextStroke",
	    "WebkitTextStrokeColor",
	    "WebkitTextStrokeWidth",
	    "WebkitTransform",
	    "WebkitTransformOrigin",
	    "WebkitTransformStyle",
	    "WebkitTransition",
	    "WebkitTransitionDelay",
	    "WebkitTransitionDuration",
	    "WebkitTransitionProperty",
	    "WebkitTransitionTimingFunction",
	    "WebkitUserSelect",
	    "WheelEvent",
	    "Window",
	    "WindowControlsOverlay",
	    "WindowControlsOverlayGeometryChangeEvent",
	    "Worker",
	    "Worklet",
	    "WritableStream",
	    "WritableStreamDefaultController",
	    "WritableStreamDefaultWriter",
	    "XMLDocument",
	    "XMLHttpRequest",
	    "XMLHttpRequestEventTarget",
	    "XMLHttpRequestException",
	    "XMLHttpRequestProgressEvent",
	    "XMLHttpRequestUpload",
	    "XMLSerializer",
	    "XMLStylesheetProcessingInstruction",
	    "XPathEvaluator",
	    "XPathException",
	    "XPathExpression",
	    "XPathNSResolver",
	    "XPathResult",
	    "XRAnchor",
	    "XRAnchorSet",
	    "XRBoundedReferenceSpace",
	    "XRCPUDepthInformation",
	    "XRCamera",
	    "XRDOMOverlayState",
	    "XRDepthInformation",
	    "XRFrame",
	    "XRHitTestResult",
	    "XRHitTestSource",
	    "XRInputSource",
	    "XRInputSourceArray",
	    "XRInputSourceEvent",
	    "XRInputSourcesChangeEvent",
	    "XRLayer",
	    "XRLightEstimate",
	    "XRLightProbe",
	    "XRPose",
	    "XRRay",
	    "XRReferenceSpace",
	    "XRReferenceSpaceEvent",
	    "XRRenderState",
	    "XRRigidTransform",
	    "XRSession",
	    "XRSessionEvent",
	    "XRSpace",
	    "XRSystem",
	    "XRTransientInputHitTestResult",
	    "XRTransientInputHitTestSource",
	    "XRView",
	    "XRViewerPose",
	    "XRViewport",
	    "XRWebGLBinding",
	    "XRWebGLDepthInformation",
	    "XRWebGLLayer",
	    "XSLTProcessor",
	    "ZERO",
	    "_XD0M_",
	    "_YD0M_",
	    "__REACT_DEVTOOLS_GLOBAL_HOOK__",
	    "__brand",
	    "__defineGetter__",
	    "__defineSetter__",
	    "__lookupGetter__",
	    "__lookupSetter__",
	    "__opera",
	    "__proto__",
	    "_browserjsran",
	    "a",
	    "aLink",
	    "abbr",
	    "abort",
	    "aborted",
	    "abs",
	    "absolute",
	    "acceleration",
	    "accelerationIncludingGravity",
	    "accelerator",
	    "accent-color",
	    "accentColor",
	    "accept",
	    "acceptCharset",
	    "acceptNode",
	    "access",
	    "accessKey",
	    "accessKeyLabel",
	    "accuracy",
	    "acos",
	    "acosh",
	    "action",
	    "actionURL",
	    "actions",
	    "activated",
	    "activation",
	    "activationStart",
	    "active",
	    "activeCues",
	    "activeElement",
	    "activeSourceBuffers",
	    "activeSourceCount",
	    "activeTexture",
	    "activeVRDisplays",
	    "actualBoundingBoxAscent",
	    "actualBoundingBoxDescent",
	    "actualBoundingBoxLeft",
	    "actualBoundingBoxRight",
	    "adAuctionComponents",
	    "adAuctionHeaders",
	    "add",
	    "addAll",
	    "addBehavior",
	    "addCandidate",
	    "addColorStop",
	    "addCue",
	    "addElement",
	    "addEventListener",
	    "addFilter",
	    "addFromString",
	    "addFromUri",
	    "addIceCandidate",
	    "addImport",
	    "addListener",
	    "addModule",
	    "addNamed",
	    "addPageRule",
	    "addPath",
	    "addPointer",
	    "addRange",
	    "addRegion",
	    "addRule",
	    "addSearchEngine",
	    "addSourceBuffer",
	    "addStream",
	    "addTextTrack",
	    "addTrack",
	    "addTransceiver",
	    "addWakeLockListener",
	    "added",
	    "addedNodes",
	    "additionalName",
	    "additiveSymbols",
	    "addons",
	    "address",
	    "addressLine",
	    "addressModeU",
	    "addressModeV",
	    "addressModeW",
	    "adoptNode",
	    "adoptedCallback",
	    "adoptedStyleSheets",
	    "adr",
	    "advance",
	    "after",
	    "album",
	    "alert",
	    "algorithm",
	    "align",
	    "align-content",
	    "align-items",
	    "align-self",
	    "alignContent",
	    "alignItems",
	    "alignSelf",
	    "alignmentBaseline",
	    "alinkColor",
	    "all",
	    "allSettled",
	    "allocationSize",
	    "allow",
	    "allowFullscreen",
	    "allowPaymentRequest",
	    "allowedDirections",
	    "allowedFeatures",
	    "allowedToPlay",
	    "allowsFeature",
	    "alpha",
	    "alphaMode",
	    "alphaToCoverageEnabled",
	    "alphabeticBaseline",
	    "alt",
	    "altGraphKey",
	    "altHtml",
	    "altKey",
	    "altLeft",
	    "alternate",
	    "alternateSetting",
	    "alternates",
	    "altitude",
	    "altitudeAccuracy",
	    "altitudeAngle",
	    "amplitude",
	    "ancestorOrigins",
	    "anchor",
	    "anchorNode",
	    "anchorOffset",
	    "anchorSpace",
	    "anchors",
	    "and",
	    "angle",
	    "angularAcceleration",
	    "angularVelocity",
	    "animVal",
	    "animate",
	    "animated",
	    "animatedInstanceRoot",
	    "animatedNormalizedPathSegList",
	    "animatedPathSegList",
	    "animatedPoints",
	    "animation",
	    "animation-composition",
	    "animation-delay",
	    "animation-direction",
	    "animation-duration",
	    "animation-fill-mode",
	    "animation-iteration-count",
	    "animation-name",
	    "animation-play-state",
	    "animation-timing-function",
	    "animationComposition",
	    "animationDelay",
	    "animationDirection",
	    "animationDuration",
	    "animationFillMode",
	    "animationIterationCount",
	    "animationName",
	    "animationPlayState",
	    "animationStartTime",
	    "animationTimingFunction",
	    "animationsPaused",
	    "anniversary",
	    "antialias",
	    "anticipatedRemoval",
	    "any",
	    "app",
	    "appCodeName",
	    "appMinorVersion",
	    "appName",
	    "appNotifications",
	    "appVersion",
	    "appearance",
	    "append",
	    "appendBuffer",
	    "appendChild",
	    "appendData",
	    "appendItem",
	    "appendMedium",
	    "appendNamed",
	    "appendRule",
	    "appendStream",
	    "appendWindowEnd",
	    "appendWindowStart",
	    "applets",
	    "applicationCache",
	    "applicationServerKey",
	    "apply",
	    "applyConstraints",
	    "applyElement",
	    "arc",
	    "arcTo",
	    "architecture",
	    "archive",
	    "areas",
	    "arguments",
	    "ariaAtomic",
	    "ariaAutoComplete",
	    "ariaBrailleLabel",
	    "ariaBrailleRoleDescription",
	    "ariaBusy",
	    "ariaChecked",
	    "ariaColCount",
	    "ariaColIndex",
	    "ariaColIndexText",
	    "ariaColSpan",
	    "ariaCurrent",
	    "ariaDescription",
	    "ariaDisabled",
	    "ariaExpanded",
	    "ariaHasPopup",
	    "ariaHidden",
	    "ariaInvalid",
	    "ariaKeyShortcuts",
	    "ariaLabel",
	    "ariaLevel",
	    "ariaLive",
	    "ariaModal",
	    "ariaMultiLine",
	    "ariaMultiSelectable",
	    "ariaOrientation",
	    "ariaPlaceholder",
	    "ariaPosInSet",
	    "ariaPressed",
	    "ariaReadOnly",
	    "ariaRelevant",
	    "ariaRequired",
	    "ariaRoleDescription",
	    "ariaRowCount",
	    "ariaRowIndex",
	    "ariaRowIndexText",
	    "ariaRowSpan",
	    "ariaSelected",
	    "ariaSetSize",
	    "ariaSort",
	    "ariaValueMax",
	    "ariaValueMin",
	    "ariaValueNow",
	    "ariaValueText",
	    "arrayBuffer",
	    "arrayLayerCount",
	    "arrayStride",
	    "artist",
	    "artwork",
	    "as",
	    "asIntN",
	    "asUintN",
	    "ascentOverride",
	    "asin",
	    "asinh",
	    "aspect",
	    "aspect-ratio",
	    "aspectRatio",
	    "assert",
	    "assign",
	    "assignedElements",
	    "assignedNodes",
	    "assignedSlot",
	    "async",
	    "asyncIterator",
	    "at",
	    "atEnd",
	    "atan",
	    "atan2",
	    "atanh",
	    "atob",
	    "attachEvent",
	    "attachInternals",
	    "attachShader",
	    "attachShadow",
	    "attachedElements",
	    "attachments",
	    "attack",
	    "attestationObject",
	    "attrChange",
	    "attrName",
	    "attributeChangedCallback",
	    "attributeFilter",
	    "attributeName",
	    "attributeNamespace",
	    "attributeOldValue",
	    "attributeStyleMap",
	    "attributes",
	    "attribution",
	    "attributionSrc",
	    "audioBitrateMode",
	    "audioBitsPerSecond",
	    "audioTracks",
	    "audioWorklet",
	    "authenticatedSignedWrites",
	    "authenticatorAttachment",
	    "authenticatorData",
	    "autoIncrement",
	    "autobuffer",
	    "autocapitalize",
	    "autocomplete",
	    "autocorrect",
	    "autofocus",
	    "automationRate",
	    "autoplay",
	    "availHeight",
	    "availLeft",
	    "availTop",
	    "availWidth",
	    "availability",
	    "available",
	    "aversion",
	    "ax",
	    "axes",
	    "axis",
	    "ay",
	    "azimuth",
	    "azimuthAngle",
	    "b",
	    "back",
	    "backdrop-filter",
	    "backdropFilter",
	    "backends",
	    "backface-visibility",
	    "backfaceVisibility",
	    "background",
	    "background-attachment",
	    "background-blend-mode",
	    "background-clip",
	    "background-color",
	    "background-image",
	    "background-origin",
	    "background-position",
	    "background-position-x",
	    "background-position-y",
	    "background-repeat",
	    "background-size",
	    "backgroundAttachment",
	    "backgroundBlendMode",
	    "backgroundClip",
	    "backgroundColor",
	    "backgroundFetch",
	    "backgroundImage",
	    "backgroundOrigin",
	    "backgroundPosition",
	    "backgroundPositionX",
	    "backgroundPositionY",
	    "backgroundRepeat",
	    "backgroundSize",
	    "badInput",
	    "badge",
	    "balance",
	    "baseArrayLayer",
	    "baseFrequencyX",
	    "baseFrequencyY",
	    "baseLatency",
	    "baseLayer",
	    "baseMipLevel",
	    "baseNode",
	    "baseOffset",
	    "basePalette",
	    "baseURI",
	    "baseVal",
	    "baseline-source",
	    "baselineShift",
	    "baselineSource",
	    "battery",
	    "bday",
	    "before",
	    "beginComputePass",
	    "beginElement",
	    "beginElementAt",
	    "beginOcclusionQuery",
	    "beginPath",
	    "beginQuery",
	    "beginRenderPass",
	    "beginTransformFeedback",
	    "beginningOfPassWriteIndex",
	    "behavior",
	    "behaviorCookie",
	    "behaviorPart",
	    "behaviorUrns",
	    "beta",
	    "bezierCurveTo",
	    "bgColor",
	    "bgProperties",
	    "bias",
	    "big",
	    "bigint64",
	    "biguint64",
	    "binaryType",
	    "bind",
	    "bindAttribLocation",
	    "bindBuffer",
	    "bindBufferBase",
	    "bindBufferRange",
	    "bindFramebuffer",
	    "bindGroupLayouts",
	    "bindRenderbuffer",
	    "bindSampler",
	    "bindTexture",
	    "bindTransformFeedback",
	    "bindVertexArray",
	    "binding",
	    "bitness",
	    "blend",
	    "blendColor",
	    "blendEquation",
	    "blendEquationSeparate",
	    "blendFunc",
	    "blendFuncSeparate",
	    "blink",
	    "blitFramebuffer",
	    "blob",
	    "block-size",
	    "blockDirection",
	    "blockSize",
	    "blockedURI",
	    "blocking",
	    "blockingDuration",
	    "blue",
	    "bluetooth",
	    "blur",
	    "body",
	    "bodyUsed",
	    "bold",
	    "bookmarks",
	    "booleanValue",
	    "border",
	    "border-block",
	    "border-block-color",
	    "border-block-end",
	    "border-block-end-color",
	    "border-block-end-style",
	    "border-block-end-width",
	    "border-block-start",
	    "border-block-start-color",
	    "border-block-start-style",
	    "border-block-start-width",
	    "border-block-style",
	    "border-block-width",
	    "border-bottom",
	    "border-bottom-color",
	    "border-bottom-left-radius",
	    "border-bottom-right-radius",
	    "border-bottom-style",
	    "border-bottom-width",
	    "border-collapse",
	    "border-color",
	    "border-end-end-radius",
	    "border-end-start-radius",
	    "border-image",
	    "border-image-outset",
	    "border-image-repeat",
	    "border-image-slice",
	    "border-image-source",
	    "border-image-width",
	    "border-inline",
	    "border-inline-color",
	    "border-inline-end",
	    "border-inline-end-color",
	    "border-inline-end-style",
	    "border-inline-end-width",
	    "border-inline-start",
	    "border-inline-start-color",
	    "border-inline-start-style",
	    "border-inline-start-width",
	    "border-inline-style",
	    "border-inline-width",
	    "border-left",
	    "border-left-color",
	    "border-left-style",
	    "border-left-width",
	    "border-radius",
	    "border-right",
	    "border-right-color",
	    "border-right-style",
	    "border-right-width",
	    "border-spacing",
	    "border-start-end-radius",
	    "border-start-start-radius",
	    "border-style",
	    "border-top",
	    "border-top-color",
	    "border-top-left-radius",
	    "border-top-right-radius",
	    "border-top-style",
	    "border-top-width",
	    "border-width",
	    "borderBlock",
	    "borderBlockColor",
	    "borderBlockEnd",
	    "borderBlockEndColor",
	    "borderBlockEndStyle",
	    "borderBlockEndWidth",
	    "borderBlockStart",
	    "borderBlockStartColor",
	    "borderBlockStartStyle",
	    "borderBlockStartWidth",
	    "borderBlockStyle",
	    "borderBlockWidth",
	    "borderBottom",
	    "borderBottomColor",
	    "borderBottomLeftRadius",
	    "borderBottomRightRadius",
	    "borderBottomStyle",
	    "borderBottomWidth",
	    "borderBoxSize",
	    "borderCollapse",
	    "borderColor",
	    "borderColorDark",
	    "borderColorLight",
	    "borderEndEndRadius",
	    "borderEndStartRadius",
	    "borderImage",
	    "borderImageOutset",
	    "borderImageRepeat",
	    "borderImageSlice",
	    "borderImageSource",
	    "borderImageWidth",
	    "borderInline",
	    "borderInlineColor",
	    "borderInlineEnd",
	    "borderInlineEndColor",
	    "borderInlineEndStyle",
	    "borderInlineEndWidth",
	    "borderInlineStart",
	    "borderInlineStartColor",
	    "borderInlineStartStyle",
	    "borderInlineStartWidth",
	    "borderInlineStyle",
	    "borderInlineWidth",
	    "borderLeft",
	    "borderLeftColor",
	    "borderLeftStyle",
	    "borderLeftWidth",
	    "borderRadius",
	    "borderRight",
	    "borderRightColor",
	    "borderRightStyle",
	    "borderRightWidth",
	    "borderSpacing",
	    "borderStartEndRadius",
	    "borderStartStartRadius",
	    "borderStyle",
	    "borderTop",
	    "borderTopColor",
	    "borderTopLeftRadius",
	    "borderTopRightRadius",
	    "borderTopStyle",
	    "borderTopWidth",
	    "borderWidth",
	    "bottom",
	    "bottomMargin",
	    "bound",
	    "boundElements",
	    "boundingClientRect",
	    "boundingHeight",
	    "boundingLeft",
	    "boundingRect",
	    "boundingTop",
	    "boundingWidth",
	    "bounds",
	    "boundsGeometry",
	    "box-decoration-break",
	    "box-shadow",
	    "box-sizing",
	    "boxDecorationBreak",
	    "boxShadow",
	    "boxSizing",
	    "brand",
	    "brands",
	    "break-after",
	    "break-before",
	    "break-inside",
	    "breakAfter",
	    "breakBefore",
	    "breakInside",
	    "broadcast",
	    "browserLanguage",
	    "browsingTopics",
	    "btoa",
	    "bubbles",
	    "buffer",
	    "bufferData",
	    "bufferDepth",
	    "bufferSize",
	    "bufferSubData",
	    "buffered",
	    "bufferedAmount",
	    "bufferedAmountLowThreshold",
	    "buffers",
	    "buildID",
	    "buildNumber",
	    "button",
	    "buttonID",
	    "buttons",
	    "byobRequest",
	    "byteLength",
	    "byteOffset",
	    "bytesPerRow",
	    "bytesWritten",
	    "c",
	    "cache",
	    "caches",
	    "call",
	    "caller",
	    "camera",
	    "canBeFormatted",
	    "canBeMounted",
	    "canBeShared",
	    "canConstructInDedicatedWorker",
	    "canGoBack",
	    "canGoForward",
	    "canHaveChildren",
	    "canHaveHTML",
	    "canInsertDTMF",
	    "canIntercept",
	    "canLoadAdAuctionFencedFrame",
	    "canLoadOpaqueURL",
	    "canMakePayment",
	    "canParse",
	    "canPlayType",
	    "canPresent",
	    "canShare",
	    "canTransition",
	    "canTrickleIceCandidates",
	    "cancel",
	    "cancelAndHoldAtTime",
	    "cancelAnimationFrame",
	    "cancelBubble",
	    "cancelIdleCallback",
	    "cancelScheduledValues",
	    "cancelVideoFrameCallback",
	    "cancelWatchAvailability",
	    "cancelable",
	    "candidate",
	    "canonicalUUID",
	    "canvas",
	    "cap",
	    "capabilities",
	    "caption",
	    "caption-side",
	    "captionSide",
	    "capture",
	    "captureEvents",
	    "captureStackTrace",
	    "captureStream",
	    "caret-color",
	    "caretBidiLevel",
	    "caretColor",
	    "caretPositionFromPoint",
	    "caretRangeFromPoint",
	    "cast",
	    "catch",
	    "category",
	    "cbrt",
	    "cd",
	    "ceil",
	    "cellIndex",
	    "cellPadding",
	    "cellSpacing",
	    "cells",
	    "ch",
	    "chOff",
	    "chain",
	    "challenge",
	    "changeType",
	    "changed",
	    "changedTouches",
	    "channel",
	    "channelCount",
	    "channelCountMode",
	    "channelInterpretation",
	    "char",
	    "charAt",
	    "charCode",
	    "charCodeAt",
	    "charIndex",
	    "charLength",
	    "characterBounds",
	    "characterBoundsRangeStart",
	    "characterData",
	    "characterDataOldValue",
	    "characterSet",
	    "characteristic",
	    "charging",
	    "chargingTime",
	    "charset",
	    "check",
	    "checkDCE",
	    "checkEnclosure",
	    "checkFramebufferStatus",
	    "checkIntersection",
	    "checkValidity",
	    "checkVisibility",
	    "checked",
	    "childElementCount",
	    "childList",
	    "childNodes",
	    "children",
	    "chrome",
	    "ciphertext",
	    "cite",
	    "city",
	    "claimInterface",
	    "claimed",
	    "classList",
	    "className",
	    "classid",
	    "clear",
	    "clearAppBadge",
	    "clearAttributes",
	    "clearBuffer",
	    "clearBufferfi",
	    "clearBufferfv",
	    "clearBufferiv",
	    "clearBufferuiv",
	    "clearColor",
	    "clearData",
	    "clearDepth",
	    "clearHalt",
	    "clearImmediate",
	    "clearInterval",
	    "clearLiveSeekableRange",
	    "clearMarks",
	    "clearMaxGCPauseAccumulator",
	    "clearMeasures",
	    "clearOriginJoinedAdInterestGroups",
	    "clearParameters",
	    "clearRect",
	    "clearResourceTimings",
	    "clearShadow",
	    "clearStencil",
	    "clearTimeout",
	    "clearValue",
	    "clearWatch",
	    "click",
	    "clickCount",
	    "clientDataJSON",
	    "clientHeight",
	    "clientInformation",
	    "clientLeft",
	    "clientRect",
	    "clientRects",
	    "clientTop",
	    "clientWaitSync",
	    "clientWidth",
	    "clientX",
	    "clientY",
	    "clip",
	    "clip-path",
	    "clip-rule",
	    "clipBottom",
	    "clipLeft",
	    "clipPath",
	    "clipPathUnits",
	    "clipRight",
	    "clipRule",
	    "clipTop",
	    "clipboard",
	    "clipboardData",
	    "clonable",
	    "clone",
	    "cloneContents",
	    "cloneNode",
	    "cloneRange",
	    "close",
	    "closeCode",
	    "closePath",
	    "closed",
	    "closest",
	    "clz",
	    "clz32",
	    "cm",
	    "cmp",
	    "code",
	    "codeBase",
	    "codePointAt",
	    "codeType",
	    "codedHeight",
	    "codedRect",
	    "codedWidth",
	    "colSpan",
	    "collapse",
	    "collapseToEnd",
	    "collapseToStart",
	    "collapsed",
	    "collect",
	    "collections",
	    "colno",
	    "color",
	    "color-adjust",
	    "color-interpolation",
	    "color-interpolation-filters",
	    "color-scheme",
	    "colorAdjust",
	    "colorAttachments",
	    "colorDepth",
	    "colorFormats",
	    "colorInterpolation",
	    "colorInterpolationFilters",
	    "colorMask",
	    "colorScheme",
	    "colorSpace",
	    "colorType",
	    "cols",
	    "column-count",
	    "column-fill",
	    "column-gap",
	    "column-rule",
	    "column-rule-color",
	    "column-rule-style",
	    "column-rule-width",
	    "column-span",
	    "column-width",
	    "columnCount",
	    "columnFill",
	    "columnGap",
	    "columnNumber",
	    "columnRule",
	    "columnRuleColor",
	    "columnRuleStyle",
	    "columnRuleWidth",
	    "columnSpan",
	    "columnWidth",
	    "columns",
	    "command",
	    "commit",
	    "commitPreferences",
	    "commitStyles",
	    "commonAncestorContainer",
	    "compact",
	    "compare",
	    "compareBoundaryPoints",
	    "compareDocumentPosition",
	    "compareEndPoints",
	    "compareExchange",
	    "compareNode",
	    "comparePoint",
	    "compatMode",
	    "compatible",
	    "compile",
	    "compileShader",
	    "compileStreaming",
	    "complete",
	    "completed",
	    "component",
	    "componentFromPoint",
	    "composed",
	    "composedPath",
	    "composite",
	    "compositionEndOffset",
	    "compositionStartOffset",
	    "compressedTexImage2D",
	    "compressedTexImage3D",
	    "compressedTexSubImage2D",
	    "compressedTexSubImage3D",
	    "compute",
	    "computedStyleMap",
	    "concat",
	    "conditionText",
	    "coneInnerAngle",
	    "coneOuterAngle",
	    "coneOuterGain",
	    "config",
	    "configurable",
	    "configuration",
	    "configurationName",
	    "configurationValue",
	    "configurations",
	    "configure",
	    "confirm",
	    "confirmComposition",
	    "confirmSiteSpecificTrackingException",
	    "confirmWebWideTrackingException",
	    "congestionControl",
	    "connect",
	    "connectEnd",
	    "connectShark",
	    "connectStart",
	    "connected",
	    "connectedCallback",
	    "connection",
	    "connectionList",
	    "connectionSpeed",
	    "connectionState",
	    "connections",
	    "console",
	    "consolidate",
	    "constants",
	    "constraint",
	    "constrictionActive",
	    "construct",
	    "constructor",
	    "contactID",
	    "contain",
	    "contain-intrinsic-block-size",
	    "contain-intrinsic-height",
	    "contain-intrinsic-inline-size",
	    "contain-intrinsic-size",
	    "contain-intrinsic-width",
	    "containIntrinsicBlockSize",
	    "containIntrinsicHeight",
	    "containIntrinsicInlineSize",
	    "containIntrinsicSize",
	    "containIntrinsicWidth",
	    "container",
	    "container-name",
	    "container-type",
	    "containerId",
	    "containerName",
	    "containerQuery",
	    "containerSrc",
	    "containerType",
	    "contains",
	    "containsNode",
	    "content",
	    "content-visibility",
	    "contentBoxSize",
	    "contentDocument",
	    "contentEditable",
	    "contentHint",
	    "contentOverflow",
	    "contentRect",
	    "contentScriptType",
	    "contentStyleType",
	    "contentType",
	    "contentVisibility",
	    "contentWindow",
	    "context",
	    "contextMenu",
	    "contextmenu",
	    "continue",
	    "continuePrimaryKey",
	    "continuous",
	    "control",
	    "controlTransferIn",
	    "controlTransferOut",
	    "controller",
	    "controls",
	    "controlsList",
	    "convertPointFromNode",
	    "convertQuadFromNode",
	    "convertRectFromNode",
	    "convertToBlob",
	    "convertToSpecifiedUnits",
	    "cookie",
	    "cookieEnabled",
	    "cookieStore",
	    "cookies",
	    "coords",
	    "copyBufferSubData",
	    "copyBufferToBuffer",
	    "copyBufferToTexture",
	    "copyExternalImageToTexture",
	    "copyFromChannel",
	    "copyTexImage2D",
	    "copyTexSubImage2D",
	    "copyTexSubImage3D",
	    "copyTextureToBuffer",
	    "copyTextureToTexture",
	    "copyTo",
	    "copyToChannel",
	    "copyWithin",
	    "correspondingElement",
	    "correspondingUseElement",
	    "corruptedVideoFrames",
	    "cos",
	    "cosh",
	    "count",
	    "countReset",
	    "counter-increment",
	    "counter-reset",
	    "counter-set",
	    "counterIncrement",
	    "counterReset",
	    "counterSet",
	    "country",
	    "cpuClass",
	    "cpuSleepAllowed",
	    "cqb",
	    "cqh",
	    "cqi",
	    "cqmax",
	    "cqmin",
	    "cqw",
	    "create",
	    "createAnalyser",
	    "createAnchor",
	    "createAnswer",
	    "createAttribute",
	    "createAttributeNS",
	    "createAuctionNonce",
	    "createBidirectionalStream",
	    "createBindGroup",
	    "createBindGroupLayout",
	    "createBiquadFilter",
	    "createBuffer",
	    "createBufferSource",
	    "createCDATASection",
	    "createCSSStyleSheet",
	    "createCaption",
	    "createChannelMerger",
	    "createChannelSplitter",
	    "createCommandEncoder",
	    "createComment",
	    "createComputePipeline",
	    "createComputePipelineAsync",
	    "createConicGradient",
	    "createConstantSource",
	    "createContextualFragment",
	    "createControlRange",
	    "createConvolver",
	    "createDTMFSender",
	    "createDataChannel",
	    "createDelay",
	    "createDelayNode",
	    "createDocument",
	    "createDocumentFragment",
	    "createDocumentType",
	    "createDynamicsCompressor",
	    "createElement",
	    "createElementNS",
	    "createEncodedStreams",
	    "createEntityReference",
	    "createEvent",
	    "createEventObject",
	    "createExpression",
	    "createFramebuffer",
	    "createFunction",
	    "createGain",
	    "createGainNode",
	    "createHTML",
	    "createHTMLDocument",
	    "createIIRFilter",
	    "createImageBitmap",
	    "createImageData",
	    "createIndex",
	    "createJavaScriptNode",
	    "createLinearGradient",
	    "createMediaElementSource",
	    "createMediaKeys",
	    "createMediaStreamDestination",
	    "createMediaStreamSource",
	    "createMediaStreamTrackSource",
	    "createMutableFile",
	    "createNSResolver",
	    "createNodeIterator",
	    "createNotification",
	    "createObjectStore",
	    "createObjectURL",
	    "createOffer",
	    "createOscillator",
	    "createPanner",
	    "createPattern",
	    "createPeriodicWave",
	    "createPipelineLayout",
	    "createPolicy",
	    "createPopup",
	    "createProcessingInstruction",
	    "createProgram",
	    "createQuery",
	    "createQuerySet",
	    "createRadialGradient",
	    "createRange",
	    "createRangeCollection",
	    "createReader",
	    "createRenderBundleEncoder",
	    "createRenderPipeline",
	    "createRenderPipelineAsync",
	    "createRenderbuffer",
	    "createSVGAngle",
	    "createSVGLength",
	    "createSVGMatrix",
	    "createSVGNumber",
	    "createSVGPathSegArcAbs",
	    "createSVGPathSegArcRel",
	    "createSVGPathSegClosePath",
	    "createSVGPathSegCurvetoCubicAbs",
	    "createSVGPathSegCurvetoCubicRel",
	    "createSVGPathSegCurvetoCubicSmoothAbs",
	    "createSVGPathSegCurvetoCubicSmoothRel",
	    "createSVGPathSegCurvetoQuadraticAbs",
	    "createSVGPathSegCurvetoQuadraticRel",
	    "createSVGPathSegCurvetoQuadraticSmoothAbs",
	    "createSVGPathSegCurvetoQuadraticSmoothRel",
	    "createSVGPathSegLinetoAbs",
	    "createSVGPathSegLinetoHorizontalAbs",
	    "createSVGPathSegLinetoHorizontalRel",
	    "createSVGPathSegLinetoRel",
	    "createSVGPathSegLinetoVerticalAbs",
	    "createSVGPathSegLinetoVerticalRel",
	    "createSVGPathSegMovetoAbs",
	    "createSVGPathSegMovetoRel",
	    "createSVGPoint",
	    "createSVGRect",
	    "createSVGTransform",
	    "createSVGTransformFromMatrix",
	    "createSampler",
	    "createScript",
	    "createScriptProcessor",
	    "createScriptURL",
	    "createSession",
	    "createShader",
	    "createShaderModule",
	    "createShadowRoot",
	    "createStereoPanner",
	    "createStyleSheet",
	    "createTBody",
	    "createTFoot",
	    "createTHead",
	    "createTask",
	    "createTextNode",
	    "createTextRange",
	    "createTexture",
	    "createTouch",
	    "createTouchList",
	    "createTransformFeedback",
	    "createTreeWalker",
	    "createUnidirectionalStream",
	    "createVertexArray",
	    "createView",
	    "createWaveShaper",
	    "createWritable",
	    "creationTime",
	    "credentialless",
	    "credentials",
	    "criticalCHRestart",
	    "cropTo",
	    "crossOrigin",
	    "crossOriginIsolated",
	    "crypto",
	    "csi",
	    "csp",
	    "cssFloat",
	    "cssRules",
	    "cssText",
	    "cssValueType",
	    "ctrlKey",
	    "ctrlLeft",
	    "cues",
	    "cullFace",
	    "cullMode",
	    "currentDirection",
	    "currentEntry",
	    "currentLocalDescription",
	    "currentNode",
	    "currentPage",
	    "currentRect",
	    "currentRemoteDescription",
	    "currentScale",
	    "currentScreen",
	    "currentScript",
	    "currentSrc",
	    "currentState",
	    "currentStyle",
	    "currentTarget",
	    "currentTime",
	    "currentTranslate",
	    "currentView",
	    "cursor",
	    "curve",
	    "customElements",
	    "customError",
	    "cx",
	    "cy",
	    "d",
	    "data",
	    "dataFld",
	    "dataFormatAs",
	    "dataLoss",
	    "dataLossMessage",
	    "dataPageSize",
	    "dataSrc",
	    "dataTransfer",
	    "database",
	    "databases",
	    "datagrams",
	    "dataset",
	    "dateTime",
	    "db",
	    "debug",
	    "debuggerEnabled",
	    "declare",
	    "decode",
	    "decodeAudioData",
	    "decodeQueueSize",
	    "decodeURI",
	    "decodeURIComponent",
	    "decodedBodySize",
	    "decoding",
	    "decodingInfo",
	    "decrypt",
	    "default",
	    "defaultCharset",
	    "defaultChecked",
	    "defaultMuted",
	    "defaultPlaybackRate",
	    "defaultPolicy",
	    "defaultPrevented",
	    "defaultQueue",
	    "defaultRequest",
	    "defaultSelected",
	    "defaultStatus",
	    "defaultURL",
	    "defaultValue",
	    "defaultView",
	    "defaultstatus",
	    "defer",
	    "define",
	    "defineMagicFunction",
	    "defineMagicVariable",
	    "defineProperties",
	    "defineProperty",
	    "deg",
	    "delay",
	    "delayTime",
	    "delegatesFocus",
	    "delete",
	    "deleteBuffer",
	    "deleteCaption",
	    "deleteCell",
	    "deleteContents",
	    "deleteData",
	    "deleteDatabase",
	    "deleteFramebuffer",
	    "deleteFromDocument",
	    "deleteIndex",
	    "deleteMedium",
	    "deleteObjectStore",
	    "deleteProgram",
	    "deleteProperty",
	    "deleteQuery",
	    "deleteRenderbuffer",
	    "deleteRow",
	    "deleteRule",
	    "deleteSampler",
	    "deleteShader",
	    "deleteSync",
	    "deleteTFoot",
	    "deleteTHead",
	    "deleteTexture",
	    "deleteTransformFeedback",
	    "deleteVertexArray",
	    "deleted",
	    "deliverChangeRecords",
	    "deliveredFrames",
	    "delivery",
	    "deliveryInfo",
	    "deliveryStatus",
	    "deliveryTimestamp",
	    "deliveryType",
	    "delta",
	    "deltaMode",
	    "deltaX",
	    "deltaY",
	    "deltaZ",
	    "dependentLocality",
	    "deprecatedReplaceInURN",
	    "deprecatedRunAdAuctionEnforcesKAnonymity",
	    "deprecatedURNToURL",
	    "depthBias",
	    "depthBiasClamp",
	    "depthBiasSlopeScale",
	    "depthClearValue",
	    "depthCompare",
	    "depthDataFormat",
	    "depthFailOp",
	    "depthFar",
	    "depthFunc",
	    "depthLoadOp",
	    "depthMask",
	    "depthNear",
	    "depthOrArrayLayers",
	    "depthRange",
	    "depthReadOnly",
	    "depthStencil",
	    "depthStencilAttachment",
	    "depthStencilFormat",
	    "depthStoreOp",
	    "depthUsage",
	    "depthWriteEnabled",
	    "deref",
	    "deriveBits",
	    "deriveKey",
	    "descentOverride",
	    "description",
	    "deselectAll",
	    "designMode",
	    "desiredSize",
	    "destination",
	    "destinationURL",
	    "destroy",
	    "detach",
	    "detachEvent",
	    "detachShader",
	    "detached",
	    "detail",
	    "details",
	    "detect",
	    "detune",
	    "device",
	    "deviceClass",
	    "deviceId",
	    "deviceMemory",
	    "devicePixelContentBoxSize",
	    "devicePixelRatio",
	    "deviceProtocol",
	    "deviceSubclass",
	    "deviceVersionMajor",
	    "deviceVersionMinor",
	    "deviceVersionSubminor",
	    "deviceXDPI",
	    "deviceYDPI",
	    "didTimeout",
	    "difference",
	    "diffuseConstant",
	    "digest",
	    "dimension",
	    "dimensions",
	    "dir",
	    "dirName",
	    "direction",
	    "dirxml",
	    "disable",
	    "disablePictureInPicture",
	    "disableRemotePlayback",
	    "disableVertexAttribArray",
	    "disabled",
	    "discardedFrames",
	    "dischargingTime",
	    "disconnect",
	    "disconnectShark",
	    "disconnectedCallback",
	    "dispatchEvent",
	    "dispatchWorkgroups",
	    "dispatchWorkgroupsIndirect",
	    "display",
	    "displayHeight",
	    "displayId",
	    "displayName",
	    "displayWidth",
	    "disposition",
	    "distanceModel",
	    "div",
	    "divisor",
	    "djsapi",
	    "djsproxy",
	    "doImport",
	    "doNotTrack",
	    "doScroll",
	    "doctype",
	    "document",
	    "documentElement",
	    "documentMode",
	    "documentPictureInPicture",
	    "documentURI",
	    "dolphin",
	    "dolphinGameCenter",
	    "dolphininfo",
	    "dolphinmeta",
	    "domComplete",
	    "domContentLoadedEventEnd",
	    "domContentLoadedEventStart",
	    "domInteractive",
	    "domLoading",
	    "domOverlayState",
	    "domain",
	    "domainLookupEnd",
	    "domainLookupStart",
	    "dominant-baseline",
	    "dominantBaseline",
	    "done",
	    "dopplerFactor",
	    "dotAll",
	    "downDegrees",
	    "downlink",
	    "download",
	    "downloadRequest",
	    "downloadTotal",
	    "downloaded",
	    "dpcm",
	    "dpi",
	    "dppx",
	    "dragDrop",
	    "draggable",
	    "draw",
	    "drawArrays",
	    "drawArraysInstanced",
	    "drawArraysInstancedANGLE",
	    "drawBuffers",
	    "drawCustomFocusRing",
	    "drawElements",
	    "drawElementsInstanced",
	    "drawElementsInstancedANGLE",
	    "drawFocusIfNeeded",
	    "drawImage",
	    "drawImageFromRect",
	    "drawIndexed",
	    "drawIndexedIndirect",
	    "drawIndirect",
	    "drawRangeElements",
	    "drawSystemFocusRing",
	    "drawingBufferColorSpace",
	    "drawingBufferFormat",
	    "drawingBufferHeight",
	    "drawingBufferStorage",
	    "drawingBufferWidth",
	    "drop",
	    "dropEffect",
	    "droppedVideoFrames",
	    "dropzone",
	    "dstFactor",
	    "dtmf",
	    "dump",
	    "dumpProfile",
	    "duplicate",
	    "durability",
	    "duration",
	    "dvb",
	    "dvh",
	    "dvi",
	    "dvmax",
	    "dvmin",
	    "dvname",
	    "dvnum",
	    "dvw",
	    "dx",
	    "dy",
	    "dynsrc",
	    "e",
	    "edgeMode",
	    "editContext",
	    "effect",
	    "effectAllowed",
	    "effectiveDirective",
	    "effectiveType",
	    "elapsedTime",
	    "element",
	    "elementFromPoint",
	    "elementTiming",
	    "elements",
	    "elementsFromPoint",
	    "elevation",
	    "ellipse",
	    "em",
	    "emHeightAscent",
	    "emHeightDescent",
	    "email",
	    "embeds",
	    "emit",
	    "emma",
	    "empty",
	    "empty-cells",
	    "emptyCells",
	    "emptyHTML",
	    "emptyScript",
	    "emulatedPosition",
	    "enable",
	    "enableBackground",
	    "enableDelegations",
	    "enableStyleSheetsForSet",
	    "enableVertexAttribArray",
	    "enabled",
	    "enabledFeatures",
	    "enabledPlugin",
	    "encode",
	    "encodeInto",
	    "encodeQueueSize",
	    "encodeURI",
	    "encodeURIComponent",
	    "encodedBodySize",
	    "encoding",
	    "encodingInfo",
	    "encrypt",
	    "enctype",
	    "end",
	    "endContainer",
	    "endElement",
	    "endElementAt",
	    "endOcclusionQuery",
	    "endOfPassWriteIndex",
	    "endOfStream",
	    "endOffset",
	    "endQuery",
	    "endTime",
	    "endTransformFeedback",
	    "ended",
	    "endpoint",
	    "endpointNumber",
	    "endpoints",
	    "endsWith",
	    "enqueue",
	    "enterKeyHint",
	    "entities",
	    "entries",
	    "entry",
	    "entryPoint",
	    "entryType",
	    "enumerable",
	    "enumerate",
	    "enumerateDevices",
	    "enumerateEditable",
	    "environmentBlendMode",
	    "equals",
	    "error",
	    "errorCode",
	    "errorDetail",
	    "errorText",
	    "escape",
	    "estimate",
	    "eval",
	    "evaluate",
	    "event",
	    "eventCounts",
	    "eventPhase",
	    "every",
	    "ex",
	    "exception",
	    "exchange",
	    "exec",
	    "execCommand",
	    "execCommandShowHelp",
	    "execScript",
	    "executeBundles",
	    "executionStart",
	    "exitFullscreen",
	    "exitPictureInPicture",
	    "exitPointerLock",
	    "exitPresent",
	    "exp",
	    "expand",
	    "expandEntityReferences",
	    "expando",
	    "expansion",
	    "expectedImprovement",
	    "expiration",
	    "expirationTime",
	    "expires",
	    "expiryDate",
	    "explicitOriginalTarget",
	    "expm1",
	    "exponent",
	    "exponentialRampToValueAtTime",
	    "exportKey",
	    "exports",
	    "extend",
	    "extensions",
	    "extentNode",
	    "extentOffset",
	    "external",
	    "externalResourcesRequired",
	    "externalTexture",
	    "extractContents",
	    "extractable",
	    "eye",
	    "f",
	    "face",
	    "factoryReset",
	    "failOp",
	    "failureReason",
	    "fallback",
	    "family",
	    "familyName",
	    "farthestViewportElement",
	    "fastSeek",
	    "fatal",
	    "featureId",
	    "featurePolicy",
	    "featureSettings",
	    "features",
	    "fence",
	    "fenceSync",
	    "fetch",
	    "fetchPriority",
	    "fetchStart",
	    "fftSize",
	    "fgColor",
	    "fieldOfView",
	    "file",
	    "fileCreatedDate",
	    "fileHandle",
	    "fileModifiedDate",
	    "fileName",
	    "fileSize",
	    "fileUpdatedDate",
	    "filename",
	    "files",
	    "filesystem",
	    "fill",
	    "fill-opacity",
	    "fill-rule",
	    "fillLightMode",
	    "fillOpacity",
	    "fillRect",
	    "fillRule",
	    "fillStyle",
	    "fillText",
	    "filter",
	    "filterResX",
	    "filterResY",
	    "filterUnits",
	    "filters",
	    "finally",
	    "find",
	    "findIndex",
	    "findLast",
	    "findLastIndex",
	    "findRule",
	    "findText",
	    "finish",
	    "finished",
	    "fireEvent",
	    "firesTouchEvents",
	    "firstChild",
	    "firstElementChild",
	    "firstInterimResponseStart",
	    "firstPage",
	    "firstUIEventTimestamp",
	    "fixed",
	    "flags",
	    "flat",
	    "flatMap",
	    "flex",
	    "flex-basis",
	    "flex-direction",
	    "flex-flow",
	    "flex-grow",
	    "flex-shrink",
	    "flex-wrap",
	    "flexBasis",
	    "flexDirection",
	    "flexFlow",
	    "flexGrow",
	    "flexShrink",
	    "flexWrap",
	    "flipX",
	    "flipY",
	    "float",
	    "float32",
	    "float64",
	    "flood-color",
	    "flood-opacity",
	    "floodColor",
	    "floodOpacity",
	    "floor",
	    "flush",
	    "focus",
	    "focusNode",
	    "focusOffset",
	    "font",
	    "font-family",
	    "font-feature-settings",
	    "font-kerning",
	    "font-language-override",
	    "font-optical-sizing",
	    "font-palette",
	    "font-size",
	    "font-size-adjust",
	    "font-stretch",
	    "font-style",
	    "font-synthesis",
	    "font-synthesis-position",
	    "font-synthesis-small-caps",
	    "font-synthesis-style",
	    "font-synthesis-weight",
	    "font-variant",
	    "font-variant-alternates",
	    "font-variant-caps",
	    "font-variant-east-asian",
	    "font-variant-ligatures",
	    "font-variant-numeric",
	    "font-variant-position",
	    "font-variation-settings",
	    "font-weight",
	    "fontBoundingBoxAscent",
	    "fontBoundingBoxDescent",
	    "fontFamily",
	    "fontFeatureSettings",
	    "fontKerning",
	    "fontLanguageOverride",
	    "fontOpticalSizing",
	    "fontPalette",
	    "fontSize",
	    "fontSizeAdjust",
	    "fontSmoothingEnabled",
	    "fontStretch",
	    "fontStyle",
	    "fontSynthesis",
	    "fontSynthesisPosition",
	    "fontSynthesisSmallCaps",
	    "fontSynthesisStyle",
	    "fontSynthesisWeight",
	    "fontVariant",
	    "fontVariantAlternates",
	    "fontVariantCaps",
	    "fontVariantEastAsian",
	    "fontVariantLigatures",
	    "fontVariantNumeric",
	    "fontVariantPosition",
	    "fontVariationSettings",
	    "fontWeight",
	    "fontcolor",
	    "fontfaces",
	    "fonts",
	    "fontsize",
	    "for",
	    "forEach",
	    "force",
	    "forceFallbackAdapter",
	    "forceRedraw",
	    "forced-color-adjust",
	    "forcedColorAdjust",
	    "forcedStyleAndLayoutDuration",
	    "forget",
	    "form",
	    "formAction",
	    "formData",
	    "formEnctype",
	    "formMethod",
	    "formNoValidate",
	    "formTarget",
	    "format",
	    "formatToParts",
	    "forms",
	    "forward",
	    "forwardX",
	    "forwardY",
	    "forwardZ",
	    "foundation",
	    "fr",
	    "fragment",
	    "fragmentDirective",
	    "frame",
	    "frameBorder",
	    "frameCount",
	    "frameElement",
	    "frameSpacing",
	    "framebuffer",
	    "framebufferHeight",
	    "framebufferRenderbuffer",
	    "framebufferTexture2D",
	    "framebufferTextureLayer",
	    "framebufferWidth",
	    "frames",
	    "freeSpace",
	    "freeze",
	    "frequency",
	    "frequencyBinCount",
	    "from",
	    "fromAsync",
	    "fromCharCode",
	    "fromCodePoint",
	    "fromElement",
	    "fromEntries",
	    "fromFloat32Array",
	    "fromFloat64Array",
	    "fromMatrix",
	    "fromPoint",
	    "fromQuad",
	    "fromRect",
	    "frontFace",
	    "fround",
	    "fullName",
	    "fullPath",
	    "fullRange",
	    "fullScreen",
	    "fullVersionList",
	    "fullscreen",
	    "fullscreenElement",
	    "fullscreenEnabled",
	    "fx",
	    "fy",
	    "g",
	    "gain",
	    "gamepad",
	    "gamma",
	    "gap",
	    "gatheringState",
	    "gatt",
	    "genderIdentity",
	    "generateCertificate",
	    "generateKey",
	    "generateMipmap",
	    "generateRequest",
	    "geolocation",
	    "gestureObject",
	    "get",
	    "getActiveAttrib",
	    "getActiveUniform",
	    "getActiveUniformBlockName",
	    "getActiveUniformBlockParameter",
	    "getActiveUniforms",
	    "getAdjacentText",
	    "getAll",
	    "getAllKeys",
	    "getAllResponseHeaders",
	    "getAllowlistForFeature",
	    "getAnimations",
	    "getAsFile",
	    "getAsFileSystemHandle",
	    "getAsString",
	    "getAttachedShaders",
	    "getAttribLocation",
	    "getAttribute",
	    "getAttributeNS",
	    "getAttributeNames",
	    "getAttributeNode",
	    "getAttributeNodeNS",
	    "getAttributeType",
	    "getAudioTracks",
	    "getAuthenticatorData",
	    "getAutoplayPolicy",
	    "getAvailability",
	    "getBBox",
	    "getBattery",
	    "getBigInt64",
	    "getBigUint64",
	    "getBindGroupLayout",
	    "getBlob",
	    "getBookmark",
	    "getBoundingClientRect",
	    "getBounds",
	    "getBoxQuads",
	    "getBufferParameter",
	    "getBufferSubData",
	    "getByteFrequencyData",
	    "getByteTimeDomainData",
	    "getCSSCanvasContext",
	    "getCTM",
	    "getCameraImage",
	    "getCandidateWindowClientRect",
	    "getCanonicalLocales",
	    "getCapabilities",
	    "getCaptureHandle",
	    "getChannelData",
	    "getCharNumAtPosition",
	    "getCharacteristic",
	    "getCharacteristics",
	    "getClientExtensionResults",
	    "getClientRect",
	    "getClientRects",
	    "getCoalescedEvents",
	    "getCompilationInfo",
	    "getCompositionAlternatives",
	    "getComputedStyle",
	    "getComputedTextLength",
	    "getComputedTiming",
	    "getConfiguration",
	    "getConstraints",
	    "getContext",
	    "getContextAttributes",
	    "getContributingSources",
	    "getCounterValue",
	    "getCueAsHTML",
	    "getCueById",
	    "getCurrentPosition",
	    "getCurrentTexture",
	    "getCurrentTime",
	    "getData",
	    "getDatabaseNames",
	    "getDate",
	    "getDay",
	    "getDefaultComputedStyle",
	    "getDepthInMeters",
	    "getDepthInformation",
	    "getDescriptor",
	    "getDescriptors",
	    "getDestinationInsertionPoints",
	    "getDevices",
	    "getDirectory",
	    "getDirectoryHandle",
	    "getDisplayMedia",
	    "getDistributedNodes",
	    "getEditable",
	    "getElementById",
	    "getElementsByClassName",
	    "getElementsByName",
	    "getElementsByTagName",
	    "getElementsByTagNameNS",
	    "getEnclosureList",
	    "getEndPositionOfChar",
	    "getEntries",
	    "getEntriesByName",
	    "getEntriesByType",
	    "getError",
	    "getExtension",
	    "getExtentOfChar",
	    "getEyeParameters",
	    "getFeature",
	    "getFiberRoots",
	    "getFile",
	    "getFileHandle",
	    "getFiles",
	    "getFilesAndDirectories",
	    "getFingerprints",
	    "getFloat32",
	    "getFloat64",
	    "getFloatFrequencyData",
	    "getFloatTimeDomainData",
	    "getFloatValue",
	    "getFragDataLocation",
	    "getFrameData",
	    "getFramebufferAttachmentParameter",
	    "getFrequencyResponse",
	    "getFullYear",
	    "getGamepads",
	    "getHeaderExtensionsToNegotiate",
	    "getHighEntropyValues",
	    "getHitTestResults",
	    "getHitTestResultsForTransientInput",
	    "getHours",
	    "getIdentityAssertion",
	    "getIds",
	    "getImageData",
	    "getIndexedParameter",
	    "getInfo",
	    "getInnerHTML",
	    "getInstalledRelatedApps",
	    "getInt16",
	    "getInt32",
	    "getInt8",
	    "getInternalModuleRanges",
	    "getInternalformatParameter",
	    "getIntersectionList",
	    "getItem",
	    "getItems",
	    "getKey",
	    "getKeyframes",
	    "getLayers",
	    "getLayoutMap",
	    "getLightEstimate",
	    "getLineDash",
	    "getLocalCandidates",
	    "getLocalParameters",
	    "getLocalStreams",
	    "getManagedConfiguration",
	    "getMappedRange",
	    "getMarks",
	    "getMatchedCSSRules",
	    "getMaxGCPauseSinceClear",
	    "getMeasures",
	    "getMetadata",
	    "getMilliseconds",
	    "getMinutes",
	    "getModifierState",
	    "getMonth",
	    "getName",
	    "getNamedItem",
	    "getNamedItemNS",
	    "getNativeFramebufferScaleFactor",
	    "getNegotiatedHeaderExtensions",
	    "getNestedConfigs",
	    "getNotifications",
	    "getNotifier",
	    "getNumberOfChars",
	    "getOffsetReferenceSpace",
	    "getOutputTimestamp",
	    "getOverrideHistoryNavigationMode",
	    "getOverrideStyle",
	    "getOwnPropertyDescriptor",
	    "getOwnPropertyDescriptors",
	    "getOwnPropertyNames",
	    "getOwnPropertySymbols",
	    "getParameter",
	    "getParameters",
	    "getParent",
	    "getPathSegAtLength",
	    "getPhotoCapabilities",
	    "getPhotoSettings",
	    "getPointAtLength",
	    "getPorts",
	    "getPose",
	    "getPredictedEvents",
	    "getPreference",
	    "getPreferenceDefault",
	    "getPreferredCanvasFormat",
	    "getPresentationAttribute",
	    "getPreventDefault",
	    "getPrimaryService",
	    "getPrimaryServices",
	    "getProgramInfoLog",
	    "getProgramParameter",
	    "getPropertyCSSValue",
	    "getPropertyPriority",
	    "getPropertyShorthand",
	    "getPropertyType",
	    "getPropertyValue",
	    "getPrototypeOf",
	    "getPublicKey",
	    "getPublicKeyAlgorithm",
	    "getQuery",
	    "getQueryParameter",
	    "getRGBColorValue",
	    "getRandomValues",
	    "getRangeAt",
	    "getReader",
	    "getReceivers",
	    "getRectValue",
	    "getReflectionCubeMap",
	    "getRegistration",
	    "getRegistrations",
	    "getRemoteCandidates",
	    "getRemoteCertificates",
	    "getRemoteParameters",
	    "getRemoteStreams",
	    "getRenderbufferParameter",
	    "getResponseHeader",
	    "getRoot",
	    "getRootNode",
	    "getRotationOfChar",
	    "getSVGDocument",
	    "getSamplerParameter",
	    "getScreenCTM",
	    "getScreenDetails",
	    "getSeconds",
	    "getSelectedCandidatePair",
	    "getSelection",
	    "getSenders",
	    "getService",
	    "getSetCookie",
	    "getSettings",
	    "getShaderInfoLog",
	    "getShaderParameter",
	    "getShaderPrecisionFormat",
	    "getShaderSource",
	    "getSignals",
	    "getSimpleDuration",
	    "getSiteIcons",
	    "getSources",
	    "getSpeculativeParserUrls",
	    "getStartPositionOfChar",
	    "getStartTime",
	    "getState",
	    "getStats",
	    "getStatusForPolicy",
	    "getStorageUpdates",
	    "getStreamById",
	    "getStringValue",
	    "getSubStringLength",
	    "getSubscription",
	    "getSubscriptions",
	    "getSupportedConstraints",
	    "getSupportedExtensions",
	    "getSupportedFormats",
	    "getSyncParameter",
	    "getSynchronizationSources",
	    "getTags",
	    "getTargetRanges",
	    "getTexParameter",
	    "getTextFormats",
	    "getTime",
	    "getTimezoneOffset",
	    "getTiming",
	    "getTitlebarAreaRect",
	    "getTotalLength",
	    "getTrackById",
	    "getTracks",
	    "getTransceivers",
	    "getTransform",
	    "getTransformFeedbackVarying",
	    "getTransformToElement",
	    "getTransports",
	    "getType",
	    "getTypeMapping",
	    "getUTCDate",
	    "getUTCDay",
	    "getUTCFullYear",
	    "getUTCHours",
	    "getUTCMilliseconds",
	    "getUTCMinutes",
	    "getUTCMonth",
	    "getUTCSeconds",
	    "getUint16",
	    "getUint32",
	    "getUint8",
	    "getUniform",
	    "getUniformBlockIndex",
	    "getUniformIndices",
	    "getUniformLocation",
	    "getUserInfo",
	    "getUserMedia",
	    "getVRDisplays",
	    "getValues",
	    "getVarDate",
	    "getVariableValue",
	    "getVertexAttrib",
	    "getVertexAttribOffset",
	    "getVideoPlaybackQuality",
	    "getVideoTracks",
	    "getViewerPose",
	    "getViewport",
	    "getVoices",
	    "getWakeLockState",
	    "getWriter",
	    "getYear",
	    "givenName",
	    "global",
	    "globalAlpha",
	    "globalCompositeOperation",
	    "globalPrivacyControl",
	    "globalThis",
	    "glyphOrientationHorizontal",
	    "glyphOrientationVertical",
	    "glyphRef",
	    "go",
	    "gpu",
	    "grabFrame",
	    "grad",
	    "gradientTransform",
	    "gradientUnits",
	    "grammars",
	    "green",
	    "grid",
	    "grid-area",
	    "grid-auto-columns",
	    "grid-auto-flow",
	    "grid-auto-rows",
	    "grid-column",
	    "grid-column-end",
	    "grid-column-gap",
	    "grid-column-start",
	    "grid-gap",
	    "grid-row",
	    "grid-row-end",
	    "grid-row-gap",
	    "grid-row-start",
	    "grid-template",
	    "grid-template-areas",
	    "grid-template-columns",
	    "grid-template-rows",
	    "gridArea",
	    "gridAutoColumns",
	    "gridAutoFlow",
	    "gridAutoRows",
	    "gridColumn",
	    "gridColumnEnd",
	    "gridColumnGap",
	    "gridColumnStart",
	    "gridGap",
	    "gridRow",
	    "gridRowEnd",
	    "gridRowGap",
	    "gridRowStart",
	    "gridTemplate",
	    "gridTemplateAreas",
	    "gridTemplateColumns",
	    "gridTemplateRows",
	    "gripSpace",
	    "group",
	    "groupBy",
	    "groupCollapsed",
	    "groupEnd",
	    "groupId",
	    "groups",
	    "hadRecentInput",
	    "hand",
	    "handedness",
	    "hangingBaseline",
	    "hapticActuators",
	    "hardwareConcurrency",
	    "has",
	    "hasAttribute",
	    "hasAttributeNS",
	    "hasAttributes",
	    "hasBeenActive",
	    "hasChildNodes",
	    "hasComposition",
	    "hasDynamicOffset",
	    "hasEnrolledInstrument",
	    "hasExtension",
	    "hasExternalDisplay",
	    "hasFeature",
	    "hasFocus",
	    "hasIndices",
	    "hasInstance",
	    "hasLayout",
	    "hasOrientation",
	    "hasOwn",
	    "hasOwnProperty",
	    "hasPointerCapture",
	    "hasPosition",
	    "hasPrivateToken",
	    "hasReading",
	    "hasRedemptionRecord",
	    "hasRegExpGroups",
	    "hasStorageAccess",
	    "hasUAVisualTransition",
	    "hash",
	    "hashChange",
	    "head",
	    "headers",
	    "heading",
	    "height",
	    "hid",
	    "hidden",
	    "hide",
	    "hideFocus",
	    "hidePopover",
	    "high",
	    "highWaterMark",
	    "highlights",
	    "hint",
	    "hints",
	    "history",
	    "honorificPrefix",
	    "honorificSuffix",
	    "horizontalOverflow",
	    "host",
	    "hostCandidate",
	    "hostname",
	    "href",
	    "hrefTranslate",
	    "hreflang",
	    "hspace",
	    "html5TagCheckInerface",
	    "htmlFor",
	    "htmlText",
	    "httpEquiv",
	    "httpRequestStatusCode",
	    "hwTimestamp",
	    "hyphenate-character",
	    "hyphenateCharacter",
	    "hyphens",
	    "hypot",
	    "ic",
	    "iccId",
	    "iceConnectionState",
	    "iceGatheringState",
	    "iceTransport",
	    "icon",
	    "iconURL",
	    "id",
	    "identifier",
	    "identity",
	    "ideographicBaseline",
	    "idpLoginUrl",
	    "ignoreBOM",
	    "ignoreCase",
	    "ignoreDepthValues",
	    "image",
	    "image-orientation",
	    "image-rendering",
	    "imageHeight",
	    "imageOrientation",
	    "imageRendering",
	    "imageSizes",
	    "imageSmoothingEnabled",
	    "imageSmoothingQuality",
	    "imageSrcset",
	    "imageWidth",
	    "images",
	    "ime-mode",
	    "imeMode",
	    "implementation",
	    "importExternalTexture",
	    "importKey",
	    "importNode",
	    "importStylesheet",
	    "imports",
	    "impp",
	    "imul",
	    "in",
	    "in1",
	    "in2",
	    "inBandMetadataTrackDispatchType",
	    "inRange",
	    "includes",
	    "incomingBidirectionalStreams",
	    "incomingHighWaterMark",
	    "incomingMaxAge",
	    "incomingUnidirectionalStreams",
	    "incremental",
	    "indeterminate",
	    "index",
	    "indexNames",
	    "indexOf",
	    "indexedDB",
	    "indicate",
	    "indices",
	    "inert",
	    "inertiaDestinationX",
	    "inertiaDestinationY",
	    "info",
	    "inherits",
	    "init",
	    "initAnimationEvent",
	    "initBeforeLoadEvent",
	    "initClipboardEvent",
	    "initCloseEvent",
	    "initCommandEvent",
	    "initCompositionEvent",
	    "initCustomEvent",
	    "initData",
	    "initDataType",
	    "initDeviceMotionEvent",
	    "initDeviceOrientationEvent",
	    "initDragEvent",
	    "initErrorEvent",
	    "initEvent",
	    "initFocusEvent",
	    "initGestureEvent",
	    "initHashChangeEvent",
	    "initKeyEvent",
	    "initKeyboardEvent",
	    "initMSManipulationEvent",
	    "initMessageEvent",
	    "initMouseEvent",
	    "initMouseScrollEvent",
	    "initMouseWheelEvent",
	    "initMutationEvent",
	    "initNSMouseEvent",
	    "initOverflowEvent",
	    "initPageEvent",
	    "initPageTransitionEvent",
	    "initPointerEvent",
	    "initPopStateEvent",
	    "initProgressEvent",
	    "initScrollAreaEvent",
	    "initSimpleGestureEvent",
	    "initStorageEvent",
	    "initTextEvent",
	    "initTimeEvent",
	    "initTouchEvent",
	    "initTransitionEvent",
	    "initUIEvent",
	    "initWebKitAnimationEvent",
	    "initWebKitTransitionEvent",
	    "initWebKitWheelEvent",
	    "initWheelEvent",
	    "initialTime",
	    "initialValue",
	    "initialize",
	    "initiatorType",
	    "inject",
	    "ink",
	    "inline-size",
	    "inlineSize",
	    "inlineVerticalFieldOfView",
	    "inner",
	    "innerHTML",
	    "innerHeight",
	    "innerText",
	    "innerWidth",
	    "input",
	    "inputBuffer",
	    "inputEncoding",
	    "inputMethod",
	    "inputMode",
	    "inputSource",
	    "inputSources",
	    "inputType",
	    "inputs",
	    "insertAdjacentElement",
	    "insertAdjacentHTML",
	    "insertAdjacentText",
	    "insertBefore",
	    "insertCell",
	    "insertDTMF",
	    "insertData",
	    "insertDebugMarker",
	    "insertItemBefore",
	    "insertNode",
	    "insertRow",
	    "insertRule",
	    "inset",
	    "inset-block",
	    "inset-block-end",
	    "inset-block-start",
	    "inset-inline",
	    "inset-inline-end",
	    "inset-inline-start",
	    "insetBlock",
	    "insetBlockEnd",
	    "insetBlockStart",
	    "insetInline",
	    "insetInlineEnd",
	    "insetInlineStart",
	    "installing",
	    "instanceRoot",
	    "instantiate",
	    "instantiateStreaming",
	    "instruments",
	    "int16",
	    "int32",
	    "int8",
	    "integrity",
	    "interactionId",
	    "interactionMode",
	    "intercept",
	    "interfaceClass",
	    "interfaceName",
	    "interfaceNumber",
	    "interfaceProtocol",
	    "interfaceSubclass",
	    "interfaces",
	    "interimResults",
	    "internalSubset",
	    "interpretation",
	    "intersection",
	    "intersectionRatio",
	    "intersectionRect",
	    "intersectsNode",
	    "interval",
	    "invalidIteratorState",
	    "invalidateFramebuffer",
	    "invalidateSubFramebuffer",
	    "inverse",
	    "invertSelf",
	    "invoker",
	    "invokerType",
	    "is",
	    "is2D",
	    "isActive",
	    "isAlternate",
	    "isArray",
	    "isAutoSelected",
	    "isBingCurrentSearchDefault",
	    "isBuffer",
	    "isCandidateWindowVisible",
	    "isChar",
	    "isCollapsed",
	    "isComposing",
	    "isConcatSpreadable",
	    "isConditionalMediationAvailable",
	    "isConfigSupported",
	    "isConnected",
	    "isContentEditable",
	    "isContentHandlerRegistered",
	    "isContextLost",
	    "isDefaultNamespace",
	    "isDirectory",
	    "isDisabled",
	    "isDisjointFrom",
	    "isEnabled",
	    "isEqual",
	    "isEqualNode",
	    "isExtended",
	    "isExtensible",
	    "isExternalCTAP2SecurityKeySupported",
	    "isFallbackAdapter",
	    "isFile",
	    "isFinite",
	    "isFirstPersonObserver",
	    "isFramebuffer",
	    "isFrozen",
	    "isGenerator",
	    "isHTML",
	    "isHistoryNavigation",
	    "isId",
	    "isIdentity",
	    "isInjected",
	    "isInputPending",
	    "isInteger",
	    "isInternal",
	    "isIntersecting",
	    "isLockFree",
	    "isMap",
	    "isMultiLine",
	    "isNaN",
	    "isOpen",
	    "isPointInFill",
	    "isPointInPath",
	    "isPointInRange",
	    "isPointInStroke",
	    "isPrefAlternate",
	    "isPresenting",
	    "isPrimary",
	    "isProgram",
	    "isPropertyImplicit",
	    "isProtocolHandlerRegistered",
	    "isPrototypeOf",
	    "isQuery",
	    "isRawJSON",
	    "isRenderbuffer",
	    "isSafeInteger",
	    "isSameEntry",
	    "isSameNode",
	    "isSampler",
	    "isScript",
	    "isScriptURL",
	    "isSealed",
	    "isSecureContext",
	    "isSessionSupported",
	    "isShader",
	    "isSubsetOf",
	    "isSupersetOf",
	    "isSupported",
	    "isSync",
	    "isTextEdit",
	    "isTexture",
	    "isTransformFeedback",
	    "isTrusted",
	    "isTypeSupported",
	    "isUserVerifyingPlatformAuthenticatorAvailable",
	    "isVertexArray",
	    "isView",
	    "isVisible",
	    "isWellFormed",
	    "isochronousTransferIn",
	    "isochronousTransferOut",
	    "isolation",
	    "italics",
	    "item",
	    "itemId",
	    "itemProp",
	    "itemRef",
	    "itemScope",
	    "itemType",
	    "itemValue",
	    "items",
	    "iterateNext",
	    "iterationComposite",
	    "iterator",
	    "javaEnabled",
	    "jitterBufferTarget",
	    "jobTitle",
	    "join",
	    "joinAdInterestGroup",
	    "json",
	    "justify-content",
	    "justify-items",
	    "justify-self",
	    "justifyContent",
	    "justifyItems",
	    "justifySelf",
	    "k1",
	    "k2",
	    "k3",
	    "k4",
	    "kHz",
	    "keepalive",
	    "kernelMatrix",
	    "kernelUnitLengthX",
	    "kernelUnitLengthY",
	    "kerning",
	    "key",
	    "keyCode",
	    "keyFor",
	    "keyIdentifier",
	    "keyLightEnabled",
	    "keyLocation",
	    "keyPath",
	    "keyStatuses",
	    "keySystem",
	    "keyText",
	    "keyUsage",
	    "keyboard",
	    "keys",
	    "keytype",
	    "kind",
	    "knee",
	    "label",
	    "labels",
	    "lang",
	    "language",
	    "languages",
	    "largeArcFlag",
	    "lastChild",
	    "lastElementChild",
	    "lastEventId",
	    "lastIndex",
	    "lastIndexOf",
	    "lastInputTime",
	    "lastMatch",
	    "lastMessageSubject",
	    "lastMessageType",
	    "lastModified",
	    "lastModifiedDate",
	    "lastPage",
	    "lastParen",
	    "lastState",
	    "lastStyleSheetSet",
	    "latitude",
	    "launchQueue",
	    "layerName",
	    "layerX",
	    "layerY",
	    "layout",
	    "layoutFlow",
	    "layoutGrid",
	    "layoutGridChar",
	    "layoutGridLine",
	    "layoutGridMode",
	    "layoutGridType",
	    "lbound",
	    "leaveAdInterestGroup",
	    "left",
	    "leftContext",
	    "leftDegrees",
	    "leftMargin",
	    "leftProjectionMatrix",
	    "leftViewMatrix",
	    "length",
	    "lengthAdjust",
	    "lengthComputable",
	    "letter-spacing",
	    "letterSpacing",
	    "level",
	    "lh",
	    "lighting-color",
	    "lightingColor",
	    "limitingConeAngle",
	    "limits",
	    "line",
	    "line-break",
	    "line-height",
	    "lineAlign",
	    "lineBreak",
	    "lineCap",
	    "lineDashOffset",
	    "lineGapOverride",
	    "lineHeight",
	    "lineJoin",
	    "lineNum",
	    "lineNumber",
	    "linePos",
	    "lineTo",
	    "lineWidth",
	    "linearAcceleration",
	    "linearRampToValueAtTime",
	    "linearVelocity",
	    "lineno",
	    "lines",
	    "link",
	    "linkColor",
	    "linkProgram",
	    "links",
	    "list",
	    "list-style",
	    "list-style-image",
	    "list-style-position",
	    "list-style-type",
	    "listStyle",
	    "listStyleImage",
	    "listStylePosition",
	    "listStyleType",
	    "listener",
	    "listeners",
	    "load",
	    "loadEventEnd",
	    "loadEventStart",
	    "loadOp",
	    "loadTime",
	    "loadTimes",
	    "loaded",
	    "loading",
	    "localDescription",
	    "localName",
	    "localService",
	    "localStorage",
	    "locale",
	    "localeCompare",
	    "location",
	    "locationbar",
	    "lock",
	    "locked",
	    "lockedFile",
	    "locks",
	    "lodMaxClamp",
	    "lodMinClamp",
	    "log",
	    "log10",
	    "log1p",
	    "log2",
	    "logicalXDPI",
	    "logicalYDPI",
	    "login",
	    "loglevel",
	    "longDesc",
	    "longitude",
	    "lookupNamespaceURI",
	    "lookupPrefix",
	    "loop",
	    "loopEnd",
	    "loopStart",
	    "looping",
	    "lost",
	    "low",
	    "lower",
	    "lowerBound",
	    "lowerOpen",
	    "lowsrc",
	    "lvb",
	    "lvh",
	    "lvi",
	    "lvmax",
	    "lvmin",
	    "lvw",
	    "m11",
	    "m12",
	    "m13",
	    "m14",
	    "m21",
	    "m22",
	    "m23",
	    "m24",
	    "m31",
	    "m32",
	    "m33",
	    "m34",
	    "m41",
	    "m42",
	    "m43",
	    "m44",
	    "magFilter",
	    "makeXRCompatible",
	    "managed",
	    "manifest",
	    "manufacturer",
	    "manufacturerName",
	    "map",
	    "mapAsync",
	    "mapState",
	    "mappedAtCreation",
	    "mapping",
	    "margin",
	    "margin-block",
	    "margin-block-end",
	    "margin-block-start",
	    "margin-bottom",
	    "margin-inline",
	    "margin-inline-end",
	    "margin-inline-start",
	    "margin-left",
	    "margin-right",
	    "margin-top",
	    "marginBlock",
	    "marginBlockEnd",
	    "marginBlockStart",
	    "marginBottom",
	    "marginHeight",
	    "marginInline",
	    "marginInlineEnd",
	    "marginInlineStart",
	    "marginLeft",
	    "marginRight",
	    "marginTop",
	    "marginWidth",
	    "mark",
	    "marker",
	    "marker-end",
	    "marker-mid",
	    "marker-offset",
	    "marker-start",
	    "markerEnd",
	    "markerHeight",
	    "markerMid",
	    "markerOffset",
	    "markerStart",
	    "markerUnits",
	    "markerWidth",
	    "marks",
	    "mask",
	    "mask-clip",
	    "mask-composite",
	    "mask-image",
	    "mask-mode",
	    "mask-origin",
	    "mask-position",
	    "mask-position-x",
	    "mask-position-y",
	    "mask-repeat",
	    "mask-size",
	    "mask-type",
	    "maskClip",
	    "maskComposite",
	    "maskContentUnits",
	    "maskImage",
	    "maskMode",
	    "maskOrigin",
	    "maskPosition",
	    "maskPositionX",
	    "maskPositionY",
	    "maskRepeat",
	    "maskSize",
	    "maskType",
	    "maskUnits",
	    "match",
	    "matchAll",
	    "matchMedia",
	    "matchMedium",
	    "matches",
	    "math-depth",
	    "math-style",
	    "mathDepth",
	    "mathStyle",
	    "matrix",
	    "matrixTransform",
	    "max",
	    "max-block-size",
	    "max-height",
	    "max-inline-size",
	    "max-width",
	    "maxActions",
	    "maxAlternatives",
	    "maxAnisotropy",
	    "maxBindGroups",
	    "maxBindGroupsPlusVertexBuffers",
	    "maxBindingsPerBindGroup",
	    "maxBlockSize",
	    "maxBufferSize",
	    "maxByteLength",
	    "maxChannelCount",
	    "maxChannels",
	    "maxColorAttachmentBytesPerSample",
	    "maxColorAttachments",
	    "maxComputeInvocationsPerWorkgroup",
	    "maxComputeWorkgroupSizeX",
	    "maxComputeWorkgroupSizeY",
	    "maxComputeWorkgroupSizeZ",
	    "maxComputeWorkgroupStorageSize",
	    "maxComputeWorkgroupsPerDimension",
	    "maxConnectionsPerServer",
	    "maxDatagramSize",
	    "maxDecibels",
	    "maxDistance",
	    "maxDrawCount",
	    "maxDynamicStorageBuffersPerPipelineLayout",
	    "maxDynamicUniformBuffersPerPipelineLayout",
	    "maxHeight",
	    "maxInlineSize",
	    "maxInterStageShaderComponents",
	    "maxInterStageShaderVariables",
	    "maxLayers",
	    "maxLength",
	    "maxMessageSize",
	    "maxPacketLifeTime",
	    "maxRetransmits",
	    "maxSampledTexturesPerShaderStage",
	    "maxSamplersPerShaderStage",
	    "maxStorageBufferBindingSize",
	    "maxStorageBuffersPerShaderStage",
	    "maxStorageTexturesPerShaderStage",
	    "maxTextureArrayLayers",
	    "maxTextureDimension1D",
	    "maxTextureDimension2D",
	    "maxTextureDimension3D",
	    "maxTouchPoints",
	    "maxUniformBufferBindingSize",
	    "maxUniformBuffersPerShaderStage",
	    "maxValue",
	    "maxVertexAttributes",
	    "maxVertexBufferArrayStride",
	    "maxVertexBuffers",
	    "maxWidth",
	    "measure",
	    "measureText",
	    "media",
	    "mediaCapabilities",
	    "mediaDevices",
	    "mediaElement",
	    "mediaGroup",
	    "mediaKeys",
	    "mediaSession",
	    "mediaStream",
	    "mediaText",
	    "meetOrSlice",
	    "memory",
	    "menubar",
	    "mergeAttributes",
	    "message",
	    "messageClass",
	    "messageHandlers",
	    "messageType",
	    "messages",
	    "metaKey",
	    "metadata",
	    "method",
	    "methodDetails",
	    "methodName",
	    "mid",
	    "mimeType",
	    "mimeTypes",
	    "min",
	    "min-block-size",
	    "min-height",
	    "min-inline-size",
	    "min-width",
	    "minBindingSize",
	    "minBlockSize",
	    "minDecibels",
	    "minFilter",
	    "minHeight",
	    "minInlineSize",
	    "minLength",
	    "minStorageBufferOffsetAlignment",
	    "minUniformBufferOffsetAlignment",
	    "minValue",
	    "minWidth",
	    "mipLevel",
	    "mipLevelCount",
	    "mipmapFilter",
	    "miterLimit",
	    "mix-blend-mode",
	    "mixBlendMode",
	    "mm",
	    "mobile",
	    "mode",
	    "model",
	    "modify",
	    "module",
	    "mount",
	    "move",
	    "moveBy",
	    "moveEnd",
	    "moveFirst",
	    "moveFocusDown",
	    "moveFocusLeft",
	    "moveFocusRight",
	    "moveFocusUp",
	    "moveNext",
	    "moveRow",
	    "moveStart",
	    "moveTo",
	    "moveToBookmark",
	    "moveToElementText",
	    "moveToPoint",
	    "movementX",
	    "movementY",
	    "mozAdd",
	    "mozAnimationStartTime",
	    "mozAnon",
	    "mozApps",
	    "mozAudioCaptured",
	    "mozAudioChannelType",
	    "mozAutoplayEnabled",
	    "mozCancelAnimationFrame",
	    "mozCancelFullScreen",
	    "mozCancelRequestAnimationFrame",
	    "mozCaptureStream",
	    "mozCaptureStreamUntilEnded",
	    "mozClearDataAt",
	    "mozContact",
	    "mozContacts",
	    "mozCreateFileHandle",
	    "mozCurrentTransform",
	    "mozCurrentTransformInverse",
	    "mozCursor",
	    "mozDash",
	    "mozDashOffset",
	    "mozDecodedFrames",
	    "mozExitPointerLock",
	    "mozFillRule",
	    "mozFragmentEnd",
	    "mozFrameDelay",
	    "mozFullScreen",
	    "mozFullScreenElement",
	    "mozFullScreenEnabled",
	    "mozGetAll",
	    "mozGetAllKeys",
	    "mozGetAsFile",
	    "mozGetDataAt",
	    "mozGetMetadata",
	    "mozGetUserMedia",
	    "mozHasAudio",
	    "mozHasItem",
	    "mozHidden",
	    "mozImageSmoothingEnabled",
	    "mozIndexedDB",
	    "mozInnerScreenX",
	    "mozInnerScreenY",
	    "mozInputSource",
	    "mozIsTextField",
	    "mozItem",
	    "mozItemCount",
	    "mozItems",
	    "mozLength",
	    "mozLockOrientation",
	    "mozMatchesSelector",
	    "mozMovementX",
	    "mozMovementY",
	    "mozOpaque",
	    "mozOrientation",
	    "mozPaintCount",
	    "mozPaintedFrames",
	    "mozParsedFrames",
	    "mozPay",
	    "mozPointerLockElement",
	    "mozPresentedFrames",
	    "mozPreservesPitch",
	    "mozPressure",
	    "mozPrintCallback",
	    "mozRTCIceCandidate",
	    "mozRTCPeerConnection",
	    "mozRTCSessionDescription",
	    "mozRemove",
	    "mozRequestAnimationFrame",
	    "mozRequestFullScreen",
	    "mozRequestPointerLock",
	    "mozSetDataAt",
	    "mozSetImageElement",
	    "mozSourceNode",
	    "mozSrcObject",
	    "mozSystem",
	    "mozTCPSocket",
	    "mozTextStyle",
	    "mozTypesAt",
	    "mozUnlockOrientation",
	    "mozUserCancelled",
	    "mozVisibilityState",
	    "ms",
	    "msAnimation",
	    "msAnimationDelay",
	    "msAnimationDirection",
	    "msAnimationDuration",
	    "msAnimationFillMode",
	    "msAnimationIterationCount",
	    "msAnimationName",
	    "msAnimationPlayState",
	    "msAnimationStartTime",
	    "msAnimationTimingFunction",
	    "msBackfaceVisibility",
	    "msBlockProgression",
	    "msCSSOMElementFloatMetrics",
	    "msCaching",
	    "msCachingEnabled",
	    "msCancelRequestAnimationFrame",
	    "msCapsLockWarningOff",
	    "msClearImmediate",
	    "msClose",
	    "msContentZoomChaining",
	    "msContentZoomFactor",
	    "msContentZoomLimit",
	    "msContentZoomLimitMax",
	    "msContentZoomLimitMin",
	    "msContentZoomSnap",
	    "msContentZoomSnapPoints",
	    "msContentZoomSnapType",
	    "msContentZooming",
	    "msConvertURL",
	    "msCrypto",
	    "msDoNotTrack",
	    "msElementsFromPoint",
	    "msElementsFromRect",
	    "msExitFullscreen",
	    "msExtendedCode",
	    "msFillRule",
	    "msFirstPaint",
	    "msFlex",
	    "msFlexAlign",
	    "msFlexDirection",
	    "msFlexFlow",
	    "msFlexItemAlign",
	    "msFlexLinePack",
	    "msFlexNegative",
	    "msFlexOrder",
	    "msFlexPack",
	    "msFlexPositive",
	    "msFlexPreferredSize",
	    "msFlexWrap",
	    "msFlowFrom",
	    "msFlowInto",
	    "msFontFeatureSettings",
	    "msFullscreenElement",
	    "msFullscreenEnabled",
	    "msGetInputContext",
	    "msGetRegionContent",
	    "msGetUntransformedBounds",
	    "msGraphicsTrustStatus",
	    "msGridColumn",
	    "msGridColumnAlign",
	    "msGridColumnSpan",
	    "msGridColumns",
	    "msGridRow",
	    "msGridRowAlign",
	    "msGridRowSpan",
	    "msGridRows",
	    "msHidden",
	    "msHighContrastAdjust",
	    "msHyphenateLimitChars",
	    "msHyphenateLimitLines",
	    "msHyphenateLimitZone",
	    "msHyphens",
	    "msImageSmoothingEnabled",
	    "msImeAlign",
	    "msIndexedDB",
	    "msInterpolationMode",
	    "msIsStaticHTML",
	    "msKeySystem",
	    "msKeys",
	    "msLaunchUri",
	    "msLockOrientation",
	    "msManipulationViewsEnabled",
	    "msMatchMedia",
	    "msMatchesSelector",
	    "msMaxTouchPoints",
	    "msOrientation",
	    "msOverflowStyle",
	    "msPerspective",
	    "msPerspectiveOrigin",
	    "msPlayToDisabled",
	    "msPlayToPreferredSourceUri",
	    "msPlayToPrimary",
	    "msPointerEnabled",
	    "msRegionOverflow",
	    "msReleasePointerCapture",
	    "msRequestAnimationFrame",
	    "msRequestFullscreen",
	    "msSaveBlob",
	    "msSaveOrOpenBlob",
	    "msScrollChaining",
	    "msScrollLimit",
	    "msScrollLimitXMax",
	    "msScrollLimitXMin",
	    "msScrollLimitYMax",
	    "msScrollLimitYMin",
	    "msScrollRails",
	    "msScrollSnapPointsX",
	    "msScrollSnapPointsY",
	    "msScrollSnapType",
	    "msScrollSnapX",
	    "msScrollSnapY",
	    "msScrollTranslation",
	    "msSetImmediate",
	    "msSetMediaKeys",
	    "msSetPointerCapture",
	    "msTextCombineHorizontal",
	    "msTextSizeAdjust",
	    "msToBlob",
	    "msTouchAction",
	    "msTouchSelect",
	    "msTraceAsyncCallbackCompleted",
	    "msTraceAsyncCallbackStarting",
	    "msTraceAsyncOperationCompleted",
	    "msTraceAsyncOperationStarting",
	    "msTransform",
	    "msTransformOrigin",
	    "msTransformStyle",
	    "msTransition",
	    "msTransitionDelay",
	    "msTransitionDuration",
	    "msTransitionProperty",
	    "msTransitionTimingFunction",
	    "msUnlockOrientation",
	    "msUpdateAsyncCallbackRelation",
	    "msUserSelect",
	    "msVisibilityState",
	    "msWrapFlow",
	    "msWrapMargin",
	    "msWrapThrough",
	    "msWriteProfilerMark",
	    "msZoom",
	    "msZoomTo",
	    "mt",
	    "mul",
	    "multiEntry",
	    "multiSelectionObj",
	    "multiline",
	    "multiple",
	    "multiply",
	    "multiplySelf",
	    "multisample",
	    "multisampled",
	    "mutableFile",
	    "muted",
	    "n",
	    "name",
	    "nameList",
	    "nameProp",
	    "namedItem",
	    "namedRecordset",
	    "names",
	    "namespaceURI",
	    "namespaces",
	    "nativeMap",
	    "nativeObjectCreate",
	    "nativeSet",
	    "nativeWeakMap",
	    "naturalHeight",
	    "naturalWidth",
	    "navigate",
	    "navigation",
	    "navigationMode",
	    "navigationPreload",
	    "navigationStart",
	    "navigationType",
	    "navigator",
	    "near",
	    "nearestViewportElement",
	    "negative",
	    "negotiated",
	    "netscape",
	    "networkState",
	    "newScale",
	    "newState",
	    "newTranslate",
	    "newURL",
	    "newValue",
	    "newValueSpecifiedUnits",
	    "newVersion",
	    "newhome",
	    "next",
	    "nextElementSibling",
	    "nextHopProtocol",
	    "nextNode",
	    "nextPage",
	    "nextSibling",
	    "nickname",
	    "noHref",
	    "noModule",
	    "noResize",
	    "noShade",
	    "noValidate",
	    "noWrap",
	    "node",
	    "nodeName",
	    "nodeType",
	    "nodeValue",
	    "nonce",
	    "normDepthBufferFromNormView",
	    "normalize",
	    "normalizedPathSegList",
	    "notRestoredReasons",
	    "notationName",
	    "notations",
	    "note",
	    "noteGrainOn",
	    "noteOff",
	    "noteOn",
	    "notify",
	    "now",
	    "numOctaves",
	    "number",
	    "numberOfChannels",
	    "numberOfFrames",
	    "numberOfInputs",
	    "numberOfItems",
	    "numberOfOutputs",
	    "numberValue",
	    "oMatchesSelector",
	    "object",
	    "object-fit",
	    "object-position",
	    "objectFit",
	    "objectPosition",
	    "objectStore",
	    "objectStoreNames",
	    "objectType",
	    "observe",
	    "occlusionQuerySet",
	    "of",
	    "off",
	    "offscreenBuffering",
	    "offset",
	    "offset-anchor",
	    "offset-distance",
	    "offset-path",
	    "offset-position",
	    "offset-rotate",
	    "offsetAnchor",
	    "offsetDistance",
	    "offsetHeight",
	    "offsetLeft",
	    "offsetNode",
	    "offsetParent",
	    "offsetPath",
	    "offsetPosition",
	    "offsetRotate",
	    "offsetTop",
	    "offsetWidth",
	    "offsetX",
	    "offsetY",
	    "ok",
	    "oldState",
	    "oldURL",
	    "oldValue",
	    "oldVersion",
	    "olderShadowRoot",
	    "on",
	    "onCommitFiberRoot",
	    "onCommitFiberUnmount",
	    "onLine",
	    "onPostCommitFiberRoot",
	    "onSubmittedWorkDone",
	    "onabort",
	    "onabsolutedeviceorientation",
	    "onactivate",
	    "onactive",
	    "onaddsourcebuffer",
	    "onaddstream",
	    "onaddtrack",
	    "onafterprint",
	    "onafterscriptexecute",
	    "onafterupdate",
	    "onanimationcancel",
	    "onanimationend",
	    "onanimationiteration",
	    "onanimationstart",
	    "onappinstalled",
	    "onaudioend",
	    "onaudioprocess",
	    "onaudiostart",
	    "onautocomplete",
	    "onautocompleteerror",
	    "onauxclick",
	    "onbeforeactivate",
	    "onbeforecopy",
	    "onbeforecut",
	    "onbeforedeactivate",
	    "onbeforeeditfocus",
	    "onbeforeinput",
	    "onbeforeinstallprompt",
	    "onbeforematch",
	    "onbeforepaste",
	    "onbeforeprint",
	    "onbeforescriptexecute",
	    "onbeforetoggle",
	    "onbeforeunload",
	    "onbeforeupdate",
	    "onbeforexrselect",
	    "onbegin",
	    "onblocked",
	    "onblur",
	    "onbounce",
	    "onboundary",
	    "onbufferedamountlow",
	    "oncached",
	    "oncancel",
	    "oncandidatewindowhide",
	    "oncandidatewindowshow",
	    "oncandidatewindowupdate",
	    "oncanplay",
	    "oncanplaythrough",
	    "oncapturehandlechange",
	    "once",
	    "oncellchange",
	    "onchange",
	    "oncharacterboundsupdate",
	    "oncharacteristicvaluechanged",
	    "onchargingchange",
	    "onchargingtimechange",
	    "onchecking",
	    "onclick",
	    "onclose",
	    "onclosing",
	    "oncompassneedscalibration",
	    "oncomplete",
	    "oncompositionend",
	    "oncompositionstart",
	    "onconnect",
	    "onconnecting",
	    "onconnectionavailable",
	    "onconnectionstatechange",
	    "oncontentvisibilityautostatechange",
	    "oncontextlost",
	    "oncontextmenu",
	    "oncontextrestored",
	    "oncontrollerchange",
	    "oncontrolselect",
	    "oncopy",
	    "oncuechange",
	    "oncurrententrychange",
	    "oncurrentscreenchange",
	    "oncut",
	    "ondataavailable",
	    "ondatachannel",
	    "ondatasetchanged",
	    "ondatasetcomplete",
	    "ondblclick",
	    "ondeactivate",
	    "ondequeue",
	    "ondevicechange",
	    "ondevicelight",
	    "ondevicemotion",
	    "ondeviceorientation",
	    "ondeviceorientationabsolute",
	    "ondeviceproximity",
	    "ondischargingtimechange",
	    "ondisconnect",
	    "ondisplay",
	    "ondispose",
	    "ondownloading",
	    "ondrag",
	    "ondragend",
	    "ondragenter",
	    "ondragexit",
	    "ondragleave",
	    "ondragover",
	    "ondragstart",
	    "ondrop",
	    "ondurationchange",
	    "onemptied",
	    "onencrypted",
	    "onend",
	    "onended",
	    "onenter",
	    "onenterpictureinpicture",
	    "onerror",
	    "onerrorupdate",
	    "onexit",
	    "onfencedtreeclick",
	    "onfilterchange",
	    "onfinish",
	    "onfocus",
	    "onfocusin",
	    "onfocusout",
	    "onformdata",
	    "onfreeze",
	    "onfullscreenchange",
	    "onfullscreenerror",
	    "ongamepadconnected",
	    "ongamepaddisconnected",
	    "ongatheringstatechange",
	    "ongattserverdisconnected",
	    "ongeometrychange",
	    "ongesturechange",
	    "ongestureend",
	    "ongesturestart",
	    "ongotpointercapture",
	    "onhashchange",
	    "onhelp",
	    "onicecandidate",
	    "onicecandidateerror",
	    "oniceconnectionstatechange",
	    "onicegatheringstatechange",
	    "oninactive",
	    "oninput",
	    "oninputreport",
	    "oninputsourceschange",
	    "oninvalid",
	    "onkeydown",
	    "onkeypress",
	    "onkeystatuseschange",
	    "onkeyup",
	    "onlanguagechange",
	    "onlayoutcomplete",
	    "onleavepictureinpicture",
	    "onlevelchange",
	    "onload",
	    "onloadeddata",
	    "onloadedmetadata",
	    "onloadend",
	    "onloading",
	    "onloadingdone",
	    "onloadingerror",
	    "onloadstart",
	    "onlosecapture",
	    "onlostpointercapture",
	    "only",
	    "onmanagedconfigurationchange",
	    "onmark",
	    "onmessage",
	    "onmessageerror",
	    "onmidimessage",
	    "onmousedown",
	    "onmouseenter",
	    "onmouseleave",
	    "onmousemove",
	    "onmouseout",
	    "onmouseover",
	    "onmouseup",
	    "onmousewheel",
	    "onmove",
	    "onmoveend",
	    "onmovestart",
	    "onmozfullscreenchange",
	    "onmozfullscreenerror",
	    "onmozorientationchange",
	    "onmozpointerlockchange",
	    "onmozpointerlockerror",
	    "onmscontentzoom",
	    "onmsfullscreenchange",
	    "onmsfullscreenerror",
	    "onmsgesturechange",
	    "onmsgesturedoubletap",
	    "onmsgestureend",
	    "onmsgesturehold",
	    "onmsgesturestart",
	    "onmsgesturetap",
	    "onmsgotpointercapture",
	    "onmsinertiastart",
	    "onmslostpointercapture",
	    "onmsmanipulationstatechanged",
	    "onmsneedkey",
	    "onmsorientationchange",
	    "onmspointercancel",
	    "onmspointerdown",
	    "onmspointerenter",
	    "onmspointerhover",
	    "onmspointerleave",
	    "onmspointermove",
	    "onmspointerout",
	    "onmspointerover",
	    "onmspointerup",
	    "onmssitemodejumplistitemremoved",
	    "onmsthumbnailclick",
	    "onmute",
	    "onnavigate",
	    "onnavigateerror",
	    "onnavigatesuccess",
	    "onnegotiationneeded",
	    "onnomatch",
	    "onnoupdate",
	    "onobsolete",
	    "onoffline",
	    "ononline",
	    "onopen",
	    "onorientationchange",
	    "onpagechange",
	    "onpagehide",
	    "onpagereveal",
	    "onpageshow",
	    "onpageswap",
	    "onpaste",
	    "onpause",
	    "onpayerdetailchange",
	    "onpaymentmethodchange",
	    "onplay",
	    "onplaying",
	    "onpluginstreamstart",
	    "onpointercancel",
	    "onpointerdown",
	    "onpointerenter",
	    "onpointerleave",
	    "onpointerlockchange",
	    "onpointerlockerror",
	    "onpointermove",
	    "onpointerout",
	    "onpointerover",
	    "onpointerrawupdate",
	    "onpointerup",
	    "onpopstate",
	    "onprerenderingchange",
	    "onprioritychange",
	    "onprocessorerror",
	    "onprogress",
	    "onpropertychange",
	    "onratechange",
	    "onreading",
	    "onreadystatechange",
	    "onreflectionchange",
	    "onrejectionhandled",
	    "onrelease",
	    "onremove",
	    "onremovesourcebuffer",
	    "onremovestream",
	    "onremovetrack",
	    "onrepeat",
	    "onreset",
	    "onresize",
	    "onresizeend",
	    "onresizestart",
	    "onresourcetimingbufferfull",
	    "onresult",
	    "onresume",
	    "onrowenter",
	    "onrowexit",
	    "onrowsdelete",
	    "onrowsinserted",
	    "onscreenschange",
	    "onscroll",
	    "onscrollend",
	    "onsearch",
	    "onsecuritypolicyviolation",
	    "onseeked",
	    "onseeking",
	    "onselect",
	    "onselectedcandidatepairchange",
	    "onselectend",
	    "onselectionchange",
	    "onselectstart",
	    "onshippingaddresschange",
	    "onshippingoptionchange",
	    "onshow",
	    "onsignalingstatechange",
	    "onsinkchange",
	    "onslotchange",
	    "onsoundend",
	    "onsoundstart",
	    "onsourceclose",
	    "onsourceclosed",
	    "onsourceended",
	    "onsourceopen",
	    "onspeechend",
	    "onspeechstart",
	    "onsqueeze",
	    "onsqueezeend",
	    "onsqueezestart",
	    "onstalled",
	    "onstart",
	    "onstatechange",
	    "onstop",
	    "onstorage",
	    "onstoragecommit",
	    "onsubmit",
	    "onsuccess",
	    "onsuspend",
	    "onterminate",
	    "ontextformatupdate",
	    "ontextinput",
	    "ontextupdate",
	    "ontimeout",
	    "ontimeupdate",
	    "ontoggle",
	    "ontonechange",
	    "ontouchcancel",
	    "ontouchend",
	    "ontouchmove",
	    "ontouchstart",
	    "ontrack",
	    "ontransitioncancel",
	    "ontransitionend",
	    "ontransitionrun",
	    "ontransitionstart",
	    "onuncapturederror",
	    "onunhandledrejection",
	    "onunload",
	    "onunmute",
	    "onupdate",
	    "onupdateend",
	    "onupdatefound",
	    "onupdateready",
	    "onupdatestart",
	    "onupgradeneeded",
	    "onuserproximity",
	    "onversionchange",
	    "onvisibilitychange",
	    "onvoiceschanged",
	    "onvolumechange",
	    "onvrdisplayactivate",
	    "onvrdisplayconnect",
	    "onvrdisplaydeactivate",
	    "onvrdisplaydisconnect",
	    "onvrdisplaypresentchange",
	    "onwaiting",
	    "onwaitingforkey",
	    "onwarning",
	    "onwebkitanimationend",
	    "onwebkitanimationiteration",
	    "onwebkitanimationstart",
	    "onwebkitcurrentplaybacktargetiswirelesschanged",
	    "onwebkitfullscreenchange",
	    "onwebkitfullscreenerror",
	    "onwebkitkeyadded",
	    "onwebkitkeyerror",
	    "onwebkitkeymessage",
	    "onwebkitneedkey",
	    "onwebkitorientationchange",
	    "onwebkitplaybacktargetavailabilitychanged",
	    "onwebkitpointerlockchange",
	    "onwebkitpointerlockerror",
	    "onwebkitresourcetimingbufferfull",
	    "onwebkittransitionend",
	    "onwheel",
	    "onzoom",
	    "opacity",
	    "open",
	    "openCursor",
	    "openDatabase",
	    "openKeyCursor",
	    "opened",
	    "opener",
	    "opera",
	    "operation",
	    "operationType",
	    "operator",
	    "opr",
	    "optimum",
	    "options",
	    "or",
	    "order",
	    "orderX",
	    "orderY",
	    "ordered",
	    "org",
	    "organization",
	    "orient",
	    "orientAngle",
	    "orientType",
	    "orientation",
	    "orientationX",
	    "orientationY",
	    "orientationZ",
	    "origin",
	    "originAgentCluster",
	    "originalPolicy",
	    "originalTarget",
	    "orphans",
	    "oscpu",
	    "outerHTML",
	    "outerHeight",
	    "outerText",
	    "outerWidth",
	    "outgoingHighWaterMark",
	    "outgoingMaxAge",
	    "outline",
	    "outline-color",
	    "outline-offset",
	    "outline-style",
	    "outline-width",
	    "outlineColor",
	    "outlineOffset",
	    "outlineStyle",
	    "outlineWidth",
	    "outputBuffer",
	    "outputChannelCount",
	    "outputLatency",
	    "outputs",
	    "overflow",
	    "overflow-anchor",
	    "overflow-block",
	    "overflow-clip-margin",
	    "overflow-inline",
	    "overflow-wrap",
	    "overflow-x",
	    "overflow-y",
	    "overflowAnchor",
	    "overflowBlock",
	    "overflowClipMargin",
	    "overflowInline",
	    "overflowWrap",
	    "overflowX",
	    "overflowY",
	    "overlaysContent",
	    "overrideColors",
	    "overrideMimeType",
	    "oversample",
	    "overscroll-behavior",
	    "overscroll-behavior-block",
	    "overscroll-behavior-inline",
	    "overscroll-behavior-x",
	    "overscroll-behavior-y",
	    "overscrollBehavior",
	    "overscrollBehaviorBlock",
	    "overscrollBehaviorInline",
	    "overscrollBehaviorX",
	    "overscrollBehaviorY",
	    "ownKeys",
	    "ownerDocument",
	    "ownerElement",
	    "ownerNode",
	    "ownerRule",
	    "ownerSVGElement",
	    "owningElement",
	    "p1",
	    "p2",
	    "p3",
	    "p4",
	    "packetSize",
	    "packets",
	    "pad",
	    "padEnd",
	    "padStart",
	    "padding",
	    "padding-block",
	    "padding-block-end",
	    "padding-block-start",
	    "padding-bottom",
	    "padding-inline",
	    "padding-inline-end",
	    "padding-inline-start",
	    "padding-left",
	    "padding-right",
	    "padding-top",
	    "paddingBlock",
	    "paddingBlockEnd",
	    "paddingBlockStart",
	    "paddingBottom",
	    "paddingInline",
	    "paddingInlineEnd",
	    "paddingInlineStart",
	    "paddingLeft",
	    "paddingRight",
	    "paddingTop",
	    "page",
	    "page-break-after",
	    "page-break-before",
	    "page-break-inside",
	    "pageBreakAfter",
	    "pageBreakBefore",
	    "pageBreakInside",
	    "pageCount",
	    "pageLeft",
	    "pageTop",
	    "pageX",
	    "pageXOffset",
	    "pageY",
	    "pageYOffset",
	    "pages",
	    "paint-order",
	    "paintOrder",
	    "paintRequests",
	    "paintType",
	    "paintWorklet",
	    "palette",
	    "pan",
	    "panningModel",
	    "parameterData",
	    "parameters",
	    "parent",
	    "parentElement",
	    "parentNode",
	    "parentRule",
	    "parentStyleSheet",
	    "parentTextEdit",
	    "parentWindow",
	    "parse",
	    "parseAll",
	    "parseCreationOptionsFromJSON",
	    "parseFloat",
	    "parseFromString",
	    "parseHTMLUnsafe",
	    "parseInt",
	    "parseRequestOptionsFromJSON",
	    "part",
	    "participants",
	    "passOp",
	    "passive",
	    "password",
	    "pasteHTML",
	    "path",
	    "pathLength",
	    "pathSegList",
	    "pathSegType",
	    "pathSegTypeAsLetter",
	    "pathname",
	    "pattern",
	    "patternContentUnits",
	    "patternMismatch",
	    "patternTransform",
	    "patternUnits",
	    "pause",
	    "pauseAnimations",
	    "pauseDuration",
	    "pauseOnExit",
	    "pauseProfilers",
	    "pauseTransformFeedback",
	    "paused",
	    "payerEmail",
	    "payerName",
	    "payerPhone",
	    "paymentManager",
	    "pc",
	    "pdfViewerEnabled",
	    "peerIdentity",
	    "pending",
	    "pendingLocalDescription",
	    "pendingRemoteDescription",
	    "percent",
	    "performance",
	    "periodicSync",
	    "permission",
	    "permissionState",
	    "permissions",
	    "persist",
	    "persisted",
	    "personalbar",
	    "perspective",
	    "perspective-origin",
	    "perspectiveOrigin",
	    "phone",
	    "phoneticFamilyName",
	    "phoneticGivenName",
	    "photo",
	    "pictureInPictureElement",
	    "pictureInPictureEnabled",
	    "pictureInPictureWindow",
	    "ping",
	    "pipeThrough",
	    "pipeTo",
	    "pitch",
	    "pixelBottom",
	    "pixelDepth",
	    "pixelHeight",
	    "pixelLeft",
	    "pixelRight",
	    "pixelStorei",
	    "pixelTop",
	    "pixelUnitToMillimeterX",
	    "pixelUnitToMillimeterY",
	    "pixelWidth",
	    "place-content",
	    "place-items",
	    "place-self",
	    "placeContent",
	    "placeItems",
	    "placeSelf",
	    "placeholder",
	    "platform",
	    "platformVersion",
	    "platforms",
	    "play",
	    "playEffect",
	    "playState",
	    "playbackRate",
	    "playbackState",
	    "playbackTime",
	    "played",
	    "playoutDelayHint",
	    "playsInline",
	    "plugins",
	    "pluginspage",
	    "pname",
	    "pointer-events",
	    "pointerBeforeReferenceNode",
	    "pointerEnabled",
	    "pointerEvents",
	    "pointerId",
	    "pointerLockElement",
	    "pointerType",
	    "points",
	    "pointsAtX",
	    "pointsAtY",
	    "pointsAtZ",
	    "polygonOffset",
	    "pop",
	    "popDebugGroup",
	    "popErrorScope",
	    "popover",
	    "popoverTargetAction",
	    "popoverTargetElement",
	    "populateMatrix",
	    "popupWindowFeatures",
	    "popupWindowName",
	    "popupWindowURI",
	    "port",
	    "port1",
	    "port2",
	    "ports",
	    "posBottom",
	    "posHeight",
	    "posLeft",
	    "posRight",
	    "posTop",
	    "posWidth",
	    "pose",
	    "position",
	    "positionAlign",
	    "positionX",
	    "positionY",
	    "positionZ",
	    "postError",
	    "postMessage",
	    "postTask",
	    "postalCode",
	    "poster",
	    "postscriptName",
	    "pow",
	    "powerEfficient",
	    "powerOff",
	    "powerPreference",
	    "preMultiplySelf",
	    "precision",
	    "preferredReflectionFormat",
	    "preferredStyleSheetSet",
	    "preferredStylesheetSet",
	    "prefix",
	    "preload",
	    "premultipliedAlpha",
	    "prepend",
	    "prerendering",
	    "presentation",
	    "presentationArea",
	    "preserveAlpha",
	    "preserveAspectRatio",
	    "preserveAspectRatioString",
	    "preservesPitch",
	    "pressed",
	    "pressure",
	    "prevValue",
	    "preventDefault",
	    "preventExtensions",
	    "preventSilentAccess",
	    "previousElementSibling",
	    "previousNode",
	    "previousPage",
	    "previousPriority",
	    "previousRect",
	    "previousScale",
	    "previousSibling",
	    "previousTranslate",
	    "primaries",
	    "primaryKey",
	    "primaryLightDirection",
	    "primaryLightIntensity",
	    "primitive",
	    "primitiveType",
	    "primitiveUnits",
	    "principals",
	    "print",
	    "print-color-adjust",
	    "printColorAdjust",
	    "priority",
	    "privateKey",
	    "privateToken",
	    "probablySupportsContext",
	    "probeSpace",
	    "process",
	    "processIceMessage",
	    "processingEnd",
	    "processingStart",
	    "processorOptions",
	    "product",
	    "productId",
	    "productName",
	    "productSub",
	    "profile",
	    "profileEnd",
	    "profiles",
	    "projectionMatrix",
	    "promise",
	    "prompt",
	    "properties",
	    "propertyIsEnumerable",
	    "propertyName",
	    "protocol",
	    "protocolLong",
	    "prototype",
	    "provider",
	    "pseudoClass",
	    "pseudoElement",
	    "pt",
	    "publicId",
	    "publicKey",
	    "published",
	    "pulse",
	    "push",
	    "pushDebugGroup",
	    "pushErrorScope",
	    "pushManager",
	    "pushNotification",
	    "pushState",
	    "put",
	    "putImageData",
	    "px",
	    "quadraticCurveTo",
	    "qualifier",
	    "quaternion",
	    "query",
	    "queryCommandEnabled",
	    "queryCommandIndeterm",
	    "queryCommandState",
	    "queryCommandSupported",
	    "queryCommandText",
	    "queryCommandValue",
	    "queryLocalFonts",
	    "queryPermission",
	    "querySelector",
	    "querySelectorAll",
	    "querySet",
	    "queue",
	    "queueMicrotask",
	    "quote",
	    "quotes",
	    "r",
	    "r1",
	    "r2",
	    "race",
	    "rad",
	    "radiogroup",
	    "radiusX",
	    "radiusY",
	    "random",
	    "randomUUID",
	    "range",
	    "rangeCount",
	    "rangeEnd",
	    "rangeMax",
	    "rangeMin",
	    "rangeOffset",
	    "rangeOverflow",
	    "rangeParent",
	    "rangeStart",
	    "rangeUnderflow",
	    "rate",
	    "ratio",
	    "raw",
	    "rawId",
	    "rawJSON",
	    "rawValueToMeters",
	    "rcap",
	    "rch",
	    "read",
	    "readAsArrayBuffer",
	    "readAsBinaryString",
	    "readAsBlob",
	    "readAsDataURL",
	    "readAsText",
	    "readBuffer",
	    "readEntries",
	    "readOnly",
	    "readPixels",
	    "readReportRequested",
	    "readText",
	    "readValue",
	    "readable",
	    "ready",
	    "readyState",
	    "reason",
	    "reasons",
	    "reboot",
	    "receiveFeatureReport",
	    "receivedAlert",
	    "receiver",
	    "receivers",
	    "recipient",
	    "recommendedViewportScale",
	    "reconnect",
	    "recordNumber",
	    "recordsAvailable",
	    "recordset",
	    "rect",
	    "red",
	    "redEyeReduction",
	    "redirect",
	    "redirectCount",
	    "redirectEnd",
	    "redirectStart",
	    "redirected",
	    "reduce",
	    "reduceRight",
	    "reduction",
	    "refDistance",
	    "refX",
	    "refY",
	    "referenceNode",
	    "referenceSpace",
	    "referrer",
	    "referrerPolicy",
	    "refresh",
	    "region",
	    "regionAnchorX",
	    "regionAnchorY",
	    "regionId",
	    "regions",
	    "register",
	    "registerContentHandler",
	    "registerElement",
	    "registerInternalModuleStart",
	    "registerInternalModuleStop",
	    "registerProperty",
	    "registerProtocolHandler",
	    "reject",
	    "rel",
	    "relList",
	    "relatedAddress",
	    "relatedNode",
	    "relatedPort",
	    "relatedTarget",
	    "relayProtocol",
	    "release",
	    "releaseCapture",
	    "releaseEvents",
	    "releaseInterface",
	    "releaseLock",
	    "releasePointerCapture",
	    "releaseShaderCompiler",
	    "released",
	    "reliability",
	    "reliable",
	    "reliableWrite",
	    "reload",
	    "rem",
	    "remainingSpace",
	    "remote",
	    "remoteDescription",
	    "remove",
	    "removeAllRanges",
	    "removeAttribute",
	    "removeAttributeNS",
	    "removeAttributeNode",
	    "removeBehavior",
	    "removeChild",
	    "removeCue",
	    "removeEntry",
	    "removeEventListener",
	    "removeFilter",
	    "removeImport",
	    "removeItem",
	    "removeListener",
	    "removeNamedItem",
	    "removeNamedItemNS",
	    "removeNode",
	    "removeParameter",
	    "removeProperty",
	    "removeRange",
	    "removeRegion",
	    "removeRule",
	    "removeSiteSpecificTrackingException",
	    "removeSourceBuffer",
	    "removeStream",
	    "removeTrack",
	    "removeVariable",
	    "removeWakeLockListener",
	    "removeWebWideTrackingException",
	    "removed",
	    "removedNodes",
	    "renderBlockingStatus",
	    "renderHeight",
	    "renderStart",
	    "renderState",
	    "renderTime",
	    "renderWidth",
	    "renderbufferStorage",
	    "renderbufferStorageMultisample",
	    "renderedBuffer",
	    "rendererInterfaces",
	    "renderers",
	    "renderingMode",
	    "renotify",
	    "repeat",
	    "repetitionCount",
	    "replace",
	    "replaceAdjacentText",
	    "replaceAll",
	    "replaceChild",
	    "replaceChildren",
	    "replaceData",
	    "replaceId",
	    "replaceItem",
	    "replaceNode",
	    "replaceState",
	    "replaceSync",
	    "replaceTrack",
	    "replaceWholeText",
	    "replaceWith",
	    "reportError",
	    "reportEvent",
	    "reportId",
	    "reportValidity",
	    "request",
	    "requestAdapter",
	    "requestAdapterInfo",
	    "requestAnimationFrame",
	    "requestAutocomplete",
	    "requestData",
	    "requestDevice",
	    "requestFrame",
	    "requestFullscreen",
	    "requestHitTestSource",
	    "requestHitTestSourceForTransientInput",
	    "requestId",
	    "requestIdleCallback",
	    "requestLightProbe",
	    "requestMIDIAccess",
	    "requestMediaKeySystemAccess",
	    "requestPermission",
	    "requestPictureInPicture",
	    "requestPointerLock",
	    "requestPort",
	    "requestPresent",
	    "requestPresenter",
	    "requestReferenceSpace",
	    "requestSession",
	    "requestStart",
	    "requestStorageAccess",
	    "requestStorageAccessFor",
	    "requestSubmit",
	    "requestVideoFrameCallback",
	    "requestViewportScale",
	    "requestWindow",
	    "requestingWindow",
	    "requireInteraction",
	    "required",
	    "requiredExtensions",
	    "requiredFeatures",
	    "requiredLimits",
	    "reset",
	    "resetPose",
	    "resetTransform",
	    "resizable",
	    "resize",
	    "resizeBy",
	    "resizeTo",
	    "resolve",
	    "resolveQuerySet",
	    "resolveTarget",
	    "resource",
	    "respond",
	    "respondWithNewView",
	    "response",
	    "responseBody",
	    "responseEnd",
	    "responseReady",
	    "responseStart",
	    "responseStatus",
	    "responseText",
	    "responseType",
	    "responseURL",
	    "responseXML",
	    "restartIce",
	    "restore",
	    "result",
	    "resultIndex",
	    "resultType",
	    "results",
	    "resume",
	    "resumeProfilers",
	    "resumeTransformFeedback",
	    "retry",
	    "returnValue",
	    "rev",
	    "reverse",
	    "reversed",
	    "revocable",
	    "revokeObjectURL",
	    "rex",
	    "rgbColor",
	    "ric",
	    "right",
	    "rightContext",
	    "rightDegrees",
	    "rightMargin",
	    "rightProjectionMatrix",
	    "rightViewMatrix",
	    "rlh",
	    "role",
	    "rolloffFactor",
	    "root",
	    "rootBounds",
	    "rootElement",
	    "rootMargin",
	    "rotate",
	    "rotateAxisAngle",
	    "rotateAxisAngleSelf",
	    "rotateFromVector",
	    "rotateFromVectorSelf",
	    "rotateSelf",
	    "rotation",
	    "rotationAngle",
	    "rotationRate",
	    "round",
	    "roundRect",
	    "row-gap",
	    "rowGap",
	    "rowIndex",
	    "rowSpan",
	    "rows",
	    "rowsPerImage",
	    "rtcpTransport",
	    "rtt",
	    "ruby-align",
	    "ruby-position",
	    "rubyAlign",
	    "rubyOverhang",
	    "rubyPosition",
	    "rules",
	    "run",
	    "runAdAuction",
	    "runtime",
	    "runtimeStyle",
	    "rx",
	    "ry",
	    "s",
	    "safari",
	    "sameDocument",
	    "sample",
	    "sampleCount",
	    "sampleCoverage",
	    "sampleInterval",
	    "sampleRate",
	    "sampleType",
	    "sampler",
	    "samplerParameterf",
	    "samplerParameteri",
	    "sandbox",
	    "save",
	    "saveData",
	    "scale",
	    "scale3d",
	    "scale3dSelf",
	    "scaleNonUniform",
	    "scaleNonUniformSelf",
	    "scaleSelf",
	    "scheduler",
	    "scheduling",
	    "scheme",
	    "scissor",
	    "scope",
	    "scopeName",
	    "scoped",
	    "screen",
	    "screenBrightness",
	    "screenEnabled",
	    "screenLeft",
	    "screenPixelToMillimeterX",
	    "screenPixelToMillimeterY",
	    "screenState",
	    "screenTop",
	    "screenX",
	    "screenY",
	    "screens",
	    "scriptURL",
	    "scripts",
	    "scroll",
	    "scroll-behavior",
	    "scroll-margin",
	    "scroll-margin-block",
	    "scroll-margin-block-end",
	    "scroll-margin-block-start",
	    "scroll-margin-bottom",
	    "scroll-margin-inline",
	    "scroll-margin-inline-end",
	    "scroll-margin-inline-start",
	    "scroll-margin-left",
	    "scroll-margin-right",
	    "scroll-margin-top",
	    "scroll-padding",
	    "scroll-padding-block",
	    "scroll-padding-block-end",
	    "scroll-padding-block-start",
	    "scroll-padding-bottom",
	    "scroll-padding-inline",
	    "scroll-padding-inline-end",
	    "scroll-padding-inline-start",
	    "scroll-padding-left",
	    "scroll-padding-right",
	    "scroll-padding-top",
	    "scroll-snap-align",
	    "scroll-snap-stop",
	    "scroll-snap-type",
	    "scrollAmount",
	    "scrollBehavior",
	    "scrollBy",
	    "scrollByLines",
	    "scrollByPages",
	    "scrollDelay",
	    "scrollHeight",
	    "scrollIntoView",
	    "scrollIntoViewIfNeeded",
	    "scrollLeft",
	    "scrollLeftMax",
	    "scrollMargin",
	    "scrollMarginBlock",
	    "scrollMarginBlockEnd",
	    "scrollMarginBlockStart",
	    "scrollMarginBottom",
	    "scrollMarginInline",
	    "scrollMarginInlineEnd",
	    "scrollMarginInlineStart",
	    "scrollMarginLeft",
	    "scrollMarginRight",
	    "scrollMarginTop",
	    "scrollMaxX",
	    "scrollMaxY",
	    "scrollPadding",
	    "scrollPaddingBlock",
	    "scrollPaddingBlockEnd",
	    "scrollPaddingBlockStart",
	    "scrollPaddingBottom",
	    "scrollPaddingInline",
	    "scrollPaddingInlineEnd",
	    "scrollPaddingInlineStart",
	    "scrollPaddingLeft",
	    "scrollPaddingRight",
	    "scrollPaddingTop",
	    "scrollRestoration",
	    "scrollSnapAlign",
	    "scrollSnapStop",
	    "scrollSnapType",
	    "scrollTo",
	    "scrollTop",
	    "scrollTopMax",
	    "scrollWidth",
	    "scrollX",
	    "scrollY",
	    "scrollbar-color",
	    "scrollbar-gutter",
	    "scrollbar-width",
	    "scrollbar3dLightColor",
	    "scrollbarArrowColor",
	    "scrollbarBaseColor",
	    "scrollbarColor",
	    "scrollbarDarkShadowColor",
	    "scrollbarFaceColor",
	    "scrollbarGutter",
	    "scrollbarHighlightColor",
	    "scrollbarShadowColor",
	    "scrollbarTrackColor",
	    "scrollbarWidth",
	    "scrollbars",
	    "scrolling",
	    "scrollingElement",
	    "sctp",
	    "sctpCauseCode",
	    "sdp",
	    "sdpLineNumber",
	    "sdpMLineIndex",
	    "sdpMid",
	    "seal",
	    "search",
	    "searchBox",
	    "searchBoxJavaBridge_",
	    "searchParams",
	    "sectionRowIndex",
	    "secureConnectionStart",
	    "security",
	    "seed",
	    "seek",
	    "seekToNextFrame",
	    "seekable",
	    "seeking",
	    "select",
	    "selectAllChildren",
	    "selectAlternateInterface",
	    "selectAudioOutput",
	    "selectConfiguration",
	    "selectNode",
	    "selectNodeContents",
	    "selectNodes",
	    "selectSingleNode",
	    "selectSubString",
	    "selectURL",
	    "selected",
	    "selectedIndex",
	    "selectedOptions",
	    "selectedStyleSheetSet",
	    "selectedStylesheetSet",
	    "selectedTrack",
	    "selection",
	    "selectionDirection",
	    "selectionEnd",
	    "selectionStart",
	    "selector",
	    "selectorText",
	    "self",
	    "send",
	    "sendAsBinary",
	    "sendBeacon",
	    "sendFeatureReport",
	    "sendOrder",
	    "sendReport",
	    "sender",
	    "sentAlert",
	    "sentTimestamp",
	    "separator",
	    "serial",
	    "serialNumber",
	    "serializeToString",
	    "serverTiming",
	    "service",
	    "serviceWorker",
	    "session",
	    "sessionId",
	    "sessionStorage",
	    "set",
	    "setActionHandler",
	    "setActive",
	    "setAlpha",
	    "setAppBadge",
	    "setAttribute",
	    "setAttributeNS",
	    "setAttributeNode",
	    "setAttributeNodeNS",
	    "setAttributionReporting",
	    "setBaseAndExtent",
	    "setBigInt64",
	    "setBigUint64",
	    "setBindGroup",
	    "setBingCurrentSearchDefault",
	    "setBlendConstant",
	    "setCameraActive",
	    "setCapture",
	    "setCaptureHandleConfig",
	    "setCodecPreferences",
	    "setColor",
	    "setCompositeOperation",
	    "setConfiguration",
	    "setConsumer",
	    "setCurrentTime",
	    "setCustomValidity",
	    "setData",
	    "setDate",
	    "setDragImage",
	    "setEnd",
	    "setEndAfter",
	    "setEndBefore",
	    "setEndPoint",
	    "setExpires",
	    "setFillColor",
	    "setFilterRes",
	    "setFloat32",
	    "setFloat64",
	    "setFloatValue",
	    "setFocusBehavior",
	    "setFormValue",
	    "setFullYear",
	    "setHTMLUnsafe",
	    "setHeaderExtensionsToNegotiate",
	    "setHeaderValue",
	    "setHours",
	    "setIdentityProvider",
	    "setImmediate",
	    "setIndexBuffer",
	    "setInt16",
	    "setInt32",
	    "setInt8",
	    "setInterval",
	    "setItem",
	    "setKeyframes",
	    "setLineCap",
	    "setLineDash",
	    "setLineJoin",
	    "setLineWidth",
	    "setLiveSeekableRange",
	    "setLocalDescription",
	    "setMatrix",
	    "setMatrixValue",
	    "setMediaKeys",
	    "setMicrophoneActive",
	    "setMilliseconds",
	    "setMinutes",
	    "setMiterLimit",
	    "setMonth",
	    "setNamedItem",
	    "setNamedItemNS",
	    "setNonUserCodeExceptions",
	    "setOrientToAngle",
	    "setOrientToAuto",
	    "setOrientation",
	    "setOverrideHistoryNavigationMode",
	    "setPaint",
	    "setParameter",
	    "setParameters",
	    "setPeriodicWave",
	    "setPipeline",
	    "setPointerCapture",
	    "setPosition",
	    "setPositionState",
	    "setPreference",
	    "setPriority",
	    "setPrivateToken",
	    "setProperty",
	    "setPrototypeOf",
	    "setRGBColor",
	    "setRGBColorICCColor",
	    "setRadius",
	    "setRangeText",
	    "setRemoteDescription",
	    "setReportEventDataForAutomaticBeacons",
	    "setRequestHeader",
	    "setResizable",
	    "setResourceTimingBufferSize",
	    "setRotate",
	    "setScale",
	    "setScissorRect",
	    "setSeconds",
	    "setSelectionRange",
	    "setServerCertificate",
	    "setShadow",
	    "setSharedStorageContext",
	    "setSignals",
	    "setSinkId",
	    "setSkewX",
	    "setSkewY",
	    "setStart",
	    "setStartAfter",
	    "setStartBefore",
	    "setStatus",
	    "setStdDeviation",
	    "setStencilReference",
	    "setStreams",
	    "setStrictMode",
	    "setStringValue",
	    "setStrokeColor",
	    "setSuggestResult",
	    "setTargetAtTime",
	    "setTargetValueAtTime",
	    "setTime",
	    "setTimeout",
	    "setTransform",
	    "setTranslate",
	    "setUTCDate",
	    "setUTCFullYear",
	    "setUTCHours",
	    "setUTCMilliseconds",
	    "setUTCMinutes",
	    "setUTCMonth",
	    "setUTCSeconds",
	    "setUint16",
	    "setUint32",
	    "setUint8",
	    "setUri",
	    "setValidity",
	    "setValueAtTime",
	    "setValueCurveAtTime",
	    "setVariable",
	    "setVelocity",
	    "setVersion",
	    "setVertexBuffer",
	    "setViewport",
	    "setYear",
	    "settingName",
	    "settingValue",
	    "sex",
	    "shaderLocation",
	    "shaderSource",
	    "shadowBlur",
	    "shadowColor",
	    "shadowOffsetX",
	    "shadowOffsetY",
	    "shadowRoot",
	    "shadowRootClonable",
	    "shadowRootDelegatesFocus",
	    "shadowRootMode",
	    "shape",
	    "shape-image-threshold",
	    "shape-margin",
	    "shape-outside",
	    "shape-rendering",
	    "shapeImageThreshold",
	    "shapeMargin",
	    "shapeOutside",
	    "shapeRendering",
	    "share",
	    "sharedStorage",
	    "sharedStorageWritable",
	    "sheet",
	    "shift",
	    "shiftKey",
	    "shiftLeft",
	    "shippingAddress",
	    "shippingOption",
	    "shippingType",
	    "show",
	    "showDirectoryPicker",
	    "showHelp",
	    "showModal",
	    "showModalDialog",
	    "showModelessDialog",
	    "showNotification",
	    "showOpenFilePicker",
	    "showPicker",
	    "showPopover",
	    "showSaveFilePicker",
	    "sidebar",
	    "sign",
	    "signal",
	    "signalingState",
	    "signature",
	    "silent",
	    "sin",
	    "singleNodeValue",
	    "sinh",
	    "sinkId",
	    "sittingToStandingTransform",
	    "size",
	    "sizeAdjust",
	    "sizeToContent",
	    "sizeX",
	    "sizeZ",
	    "sizes",
	    "skewX",
	    "skewXSelf",
	    "skewY",
	    "skewYSelf",
	    "skipTransition",
	    "skipped",
	    "slice",
	    "slope",
	    "slot",
	    "slotAssignment",
	    "small",
	    "smil",
	    "smooth",
	    "smoothingTimeConstant",
	    "snapToLines",
	    "snapshotItem",
	    "snapshotLength",
	    "some",
	    "sort",
	    "sortingCode",
	    "source",
	    "sourceBuffer",
	    "sourceBuffers",
	    "sourceCapabilities",
	    "sourceCharPosition",
	    "sourceFile",
	    "sourceFunctionName",
	    "sourceIndex",
	    "sourceMap",
	    "sourceURL",
	    "sources",
	    "spacing",
	    "span",
	    "speak",
	    "speakAs",
	    "speaking",
	    "species",
	    "specified",
	    "specularConstant",
	    "specularExponent",
	    "speechSynthesis",
	    "speed",
	    "speedOfSound",
	    "spellcheck",
	    "sphericalHarmonicsCoefficients",
	    "splice",
	    "split",
	    "splitText",
	    "spreadMethod",
	    "sqrt",
	    "src",
	    "srcElement",
	    "srcFactor",
	    "srcFilter",
	    "srcObject",
	    "srcUrn",
	    "srcdoc",
	    "srclang",
	    "srcset",
	    "stack",
	    "stackTraceLimit",
	    "stacktrace",
	    "stageParameters",
	    "standalone",
	    "standby",
	    "start",
	    "startContainer",
	    "startIce",
	    "startMessages",
	    "startNotifications",
	    "startOffset",
	    "startProfiling",
	    "startRendering",
	    "startShark",
	    "startTime",
	    "startViewTransition",
	    "startsWith",
	    "state",
	    "states",
	    "stats",
	    "status",
	    "statusCode",
	    "statusMessage",
	    "statusText",
	    "statusbar",
	    "stdDeviationX",
	    "stdDeviationY",
	    "stencilBack",
	    "stencilClearValue",
	    "stencilFront",
	    "stencilFunc",
	    "stencilFuncSeparate",
	    "stencilLoadOp",
	    "stencilMask",
	    "stencilMaskSeparate",
	    "stencilOp",
	    "stencilOpSeparate",
	    "stencilReadMask",
	    "stencilReadOnly",
	    "stencilStoreOp",
	    "stencilWriteMask",
	    "step",
	    "stepDown",
	    "stepMismatch",
	    "stepMode",
	    "stepUp",
	    "sticky",
	    "stitchTiles",
	    "stop",
	    "stop-color",
	    "stop-opacity",
	    "stopColor",
	    "stopImmediatePropagation",
	    "stopNotifications",
	    "stopOpacity",
	    "stopProfiling",
	    "stopPropagation",
	    "stopShark",
	    "stopped",
	    "storage",
	    "storageArea",
	    "storageBuckets",
	    "storageName",
	    "storageStatus",
	    "storageTexture",
	    "store",
	    "storeOp",
	    "storeSiteSpecificTrackingException",
	    "storeWebWideTrackingException",
	    "stpVersion",
	    "stream",
	    "streamErrorCode",
	    "streams",
	    "stretch",
	    "strike",
	    "string",
	    "stringValue",
	    "stringify",
	    "stripIndexFormat",
	    "stroke",
	    "stroke-dasharray",
	    "stroke-dashoffset",
	    "stroke-linecap",
	    "stroke-linejoin",
	    "stroke-miterlimit",
	    "stroke-opacity",
	    "stroke-width",
	    "strokeDasharray",
	    "strokeDashoffset",
	    "strokeLinecap",
	    "strokeLinejoin",
	    "strokeMiterlimit",
	    "strokeOpacity",
	    "strokeRect",
	    "strokeStyle",
	    "strokeText",
	    "strokeWidth",
	    "structuredClone",
	    "style",
	    "styleAndLayoutStart",
	    "styleFloat",
	    "styleMap",
	    "styleMedia",
	    "styleSheet",
	    "styleSheetSets",
	    "styleSheets",
	    "sub",
	    "subarray",
	    "subject",
	    "submit",
	    "submitFrame",
	    "submitter",
	    "subscribe",
	    "substr",
	    "substring",
	    "substringData",
	    "subtle",
	    "subtree",
	    "suffix",
	    "suffixes",
	    "summary",
	    "sup",
	    "supported",
	    "supportedContentEncodings",
	    "supportedEntryTypes",
	    "supportedValuesOf",
	    "supports",
	    "supportsFiber",
	    "supportsSession",
	    "supportsText",
	    "surfaceScale",
	    "surroundContents",
	    "suspend",
	    "suspendRedraw",
	    "svb",
	    "svh",
	    "svi",
	    "svmax",
	    "svmin",
	    "svw",
	    "swapCache",
	    "swapNode",
	    "sweepFlag",
	    "symbols",
	    "symmetricDifference",
	    "sync",
	    "syntax",
	    "sysexEnabled",
	    "system",
	    "systemCode",
	    "systemId",
	    "systemLanguage",
	    "systemXDPI",
	    "systemYDPI",
	    "tBodies",
	    "tFoot",
	    "tHead",
	    "tab-size",
	    "tabIndex",
	    "tabSize",
	    "table",
	    "table-layout",
	    "tableLayout",
	    "tableValues",
	    "tag",
	    "tagName",
	    "tagUrn",
	    "tags",
	    "taintEnabled",
	    "take",
	    "takePhoto",
	    "takeRecords",
	    "tan",
	    "tangentialPressure",
	    "tanh",
	    "target",
	    "targetAddressSpace",
	    "targetElement",
	    "targetRayMode",
	    "targetRaySpace",
	    "targetTouches",
	    "targetURL",
	    "targetX",
	    "targetY",
	    "targets",
	    "tcpType",
	    "tee",
	    "tel",
	    "terminate",
	    "test",
	    "texImage2D",
	    "texImage3D",
	    "texParameterf",
	    "texParameteri",
	    "texStorage2D",
	    "texStorage3D",
	    "texSubImage2D",
	    "texSubImage3D",
	    "text",
	    "text-align",
	    "text-align-last",
	    "text-anchor",
	    "text-combine-upright",
	    "text-decoration",
	    "text-decoration-color",
	    "text-decoration-line",
	    "text-decoration-skip-ink",
	    "text-decoration-style",
	    "text-decoration-thickness",
	    "text-emphasis",
	    "text-emphasis-color",
	    "text-emphasis-position",
	    "text-emphasis-style",
	    "text-indent",
	    "text-justify",
	    "text-orientation",
	    "text-overflow",
	    "text-rendering",
	    "text-shadow",
	    "text-transform",
	    "text-underline-offset",
	    "text-underline-position",
	    "text-wrap",
	    "text-wrap-mode",
	    "text-wrap-style",
	    "textAlign",
	    "textAlignLast",
	    "textAnchor",
	    "textAutospace",
	    "textBaseline",
	    "textCombineUpright",
	    "textContent",
	    "textDecoration",
	    "textDecorationBlink",
	    "textDecorationColor",
	    "textDecorationLine",
	    "textDecorationLineThrough",
	    "textDecorationNone",
	    "textDecorationOverline",
	    "textDecorationSkipInk",
	    "textDecorationStyle",
	    "textDecorationThickness",
	    "textDecorationUnderline",
	    "textEmphasis",
	    "textEmphasisColor",
	    "textEmphasisPosition",
	    "textEmphasisStyle",
	    "textIndent",
	    "textJustify",
	    "textJustifyTrim",
	    "textKashida",
	    "textKashidaSpace",
	    "textLength",
	    "textOrientation",
	    "textOverflow",
	    "textRendering",
	    "textShadow",
	    "textTracks",
	    "textTransform",
	    "textUnderlineOffset",
	    "textUnderlinePosition",
	    "textWrap",
	    "textWrapMode",
	    "textWrapStyle",
	    "texture",
	    "then",
	    "threadId",
	    "threshold",
	    "thresholds",
	    "throwIfAborted",
	    "tiltX",
	    "tiltY",
	    "time",
	    "timeEnd",
	    "timeLog",
	    "timeOrigin",
	    "timeRemaining",
	    "timeStamp",
	    "timecode",
	    "timeline",
	    "timelineTime",
	    "timeout",
	    "timestamp",
	    "timestampOffset",
	    "timestampWrites",
	    "timing",
	    "title",
	    "titlebarAreaRect",
	    "to",
	    "toArray",
	    "toBlob",
	    "toDataURL",
	    "toDateString",
	    "toElement",
	    "toExponential",
	    "toFixed",
	    "toFloat32Array",
	    "toFloat64Array",
	    "toGMTString",
	    "toISOString",
	    "toJSON",
	    "toLocaleDateString",
	    "toLocaleFormat",
	    "toLocaleLowerCase",
	    "toLocaleString",
	    "toLocaleTimeString",
	    "toLocaleUpperCase",
	    "toLowerCase",
	    "toMatrix",
	    "toMethod",
	    "toPrecision",
	    "toPrimitive",
	    "toReversed",
	    "toSdp",
	    "toSorted",
	    "toSource",
	    "toSpliced",
	    "toStaticHTML",
	    "toString",
	    "toStringTag",
	    "toSum",
	    "toTimeString",
	    "toUTCString",
	    "toUpperCase",
	    "toWellFormed",
	    "toggle",
	    "toggleAttribute",
	    "toggleLongPressEnabled",
	    "togglePopover",
	    "token",
	    "tone",
	    "toneBuffer",
	    "tooLong",
	    "tooShort",
	    "toolbar",
	    "top",
	    "topMargin",
	    "topology",
	    "total",
	    "totalFrameDelay",
	    "totalFrames",
	    "totalVideoFrames",
	    "touch-action",
	    "touchAction",
	    "touched",
	    "touches",
	    "trace",
	    "track",
	    "trackVisibility",
	    "trackedAnchors",
	    "tracks",
	    "transaction",
	    "transactions",
	    "transceiver",
	    "transfer",
	    "transferControlToOffscreen",
	    "transferFromImageBitmap",
	    "transferImageBitmap",
	    "transferIn",
	    "transferOut",
	    "transferSize",
	    "transferToFixedLength",
	    "transferToImageBitmap",
	    "transform",
	    "transform-box",
	    "transform-origin",
	    "transform-style",
	    "transformBox",
	    "transformFeedbackVaryings",
	    "transformOrigin",
	    "transformPoint",
	    "transformString",
	    "transformStyle",
	    "transformToDocument",
	    "transformToFragment",
	    "transition",
	    "transition-delay",
	    "transition-duration",
	    "transition-property",
	    "transition-timing-function",
	    "transitionDelay",
	    "transitionDuration",
	    "transitionProperty",
	    "transitionTimingFunction",
	    "translate",
	    "translateSelf",
	    "translationX",
	    "translationY",
	    "transport",
	    "traverseTo",
	    "trim",
	    "trimEnd",
	    "trimLeft",
	    "trimRight",
	    "trimStart",
	    "trueSpeed",
	    "trunc",
	    "truncate",
	    "trustedTypes",
	    "turn",
	    "twist",
	    "type",
	    "typeDetail",
	    "typeMismatch",
	    "typeMustMatch",
	    "types",
	    "u2f",
	    "ubound",
	    "uint16",
	    "uint32",
	    "uint8",
	    "uint8Clamped",
	    "unclippedDepth",
	    "unconfigure",
	    "undefined",
	    "underlineStyle",
	    "underlineThickness",
	    "unescape",
	    "uneval",
	    "unicode",
	    "unicode-bidi",
	    "unicodeBidi",
	    "unicodeRange",
	    "unicodeSets",
	    "uniform1f",
	    "uniform1fv",
	    "uniform1i",
	    "uniform1iv",
	    "uniform1ui",
	    "uniform1uiv",
	    "uniform2f",
	    "uniform2fv",
	    "uniform2i",
	    "uniform2iv",
	    "uniform2ui",
	    "uniform2uiv",
	    "uniform3f",
	    "uniform3fv",
	    "uniform3i",
	    "uniform3iv",
	    "uniform3ui",
	    "uniform3uiv",
	    "uniform4f",
	    "uniform4fv",
	    "uniform4i",
	    "uniform4iv",
	    "uniform4ui",
	    "uniform4uiv",
	    "uniformBlockBinding",
	    "uniformMatrix2fv",
	    "uniformMatrix2x3fv",
	    "uniformMatrix2x4fv",
	    "uniformMatrix3fv",
	    "uniformMatrix3x2fv",
	    "uniformMatrix3x4fv",
	    "uniformMatrix4fv",
	    "uniformMatrix4x2fv",
	    "uniformMatrix4x3fv",
	    "union",
	    "unique",
	    "uniqueID",
	    "uniqueNumber",
	    "unit",
	    "unitType",
	    "units",
	    "unloadEventEnd",
	    "unloadEventStart",
	    "unlock",
	    "unmap",
	    "unmount",
	    "unobserve",
	    "unpackColorSpace",
	    "unpause",
	    "unpauseAnimations",
	    "unreadCount",
	    "unregister",
	    "unregisterContentHandler",
	    "unregisterProtocolHandler",
	    "unscopables",
	    "unselectable",
	    "unshift",
	    "unsubscribe",
	    "unsuspendRedraw",
	    "unsuspendRedrawAll",
	    "unwatch",
	    "unwrapKey",
	    "upDegrees",
	    "upX",
	    "upY",
	    "upZ",
	    "update",
	    "updateAdInterestGroups",
	    "updateCallbackDone",
	    "updateCharacterBounds",
	    "updateCommands",
	    "updateControlBounds",
	    "updateCurrentEntry",
	    "updateIce",
	    "updateInkTrailStartPoint",
	    "updateInterval",
	    "updatePlaybackRate",
	    "updateRangeEnd",
	    "updateRangeStart",
	    "updateRenderState",
	    "updateSelection",
	    "updateSelectionBounds",
	    "updateSettings",
	    "updateText",
	    "updateTiming",
	    "updateViaCache",
	    "updateWith",
	    "updated",
	    "updating",
	    "upgrade",
	    "upload",
	    "uploadTotal",
	    "uploaded",
	    "upper",
	    "upperBound",
	    "upperOpen",
	    "uri",
	    "url",
	    "urn",
	    "urns",
	    "usage",
	    "usages",
	    "usb",
	    "usbVersionMajor",
	    "usbVersionMinor",
	    "usbVersionSubminor",
	    "useCurrentView",
	    "useMap",
	    "useProgram",
	    "usedSpace",
	    "user-select",
	    "userActivation",
	    "userAgent",
	    "userAgentData",
	    "userChoice",
	    "userHandle",
	    "userHint",
	    "userInitiated",
	    "userLanguage",
	    "userSelect",
	    "userState",
	    "userVisibleOnly",
	    "username",
	    "usernameFragment",
	    "utterance",
	    "uuid",
	    "v8BreakIterator",
	    "vAlign",
	    "vLink",
	    "valid",
	    "validate",
	    "validateProgram",
	    "validationMessage",
	    "validity",
	    "value",
	    "valueAsDate",
	    "valueAsNumber",
	    "valueAsString",
	    "valueInSpecifiedUnits",
	    "valueMissing",
	    "valueOf",
	    "valueText",
	    "valueType",
	    "values",
	    "variable",
	    "variant",
	    "variationSettings",
	    "vb",
	    "vector-effect",
	    "vectorEffect",
	    "velocityAngular",
	    "velocityExpansion",
	    "velocityX",
	    "velocityY",
	    "vendor",
	    "vendorId",
	    "vendorSub",
	    "verify",
	    "version",
	    "vertex",
	    "vertexAttrib1f",
	    "vertexAttrib1fv",
	    "vertexAttrib2f",
	    "vertexAttrib2fv",
	    "vertexAttrib3f",
	    "vertexAttrib3fv",
	    "vertexAttrib4f",
	    "vertexAttrib4fv",
	    "vertexAttribDivisor",
	    "vertexAttribDivisorANGLE",
	    "vertexAttribI4i",
	    "vertexAttribI4iv",
	    "vertexAttribI4ui",
	    "vertexAttribI4uiv",
	    "vertexAttribIPointer",
	    "vertexAttribPointer",
	    "vertical",
	    "vertical-align",
	    "verticalAlign",
	    "verticalOverflow",
	    "vh",
	    "vi",
	    "vibrate",
	    "vibrationActuator",
	    "videoBitsPerSecond",
	    "videoHeight",
	    "videoTracks",
	    "videoWidth",
	    "view",
	    "viewBox",
	    "viewBoxString",
	    "viewDimension",
	    "viewFormats",
	    "viewTarget",
	    "viewTargetString",
	    "viewport",
	    "viewportAnchorX",
	    "viewportAnchorY",
	    "viewportElement",
	    "views",
	    "violatedDirective",
	    "virtualKeyboard",
	    "virtualKeyboardPolicy",
	    "visibility",
	    "visibilityState",
	    "visible",
	    "visibleRect",
	    "visualViewport",
	    "vlinkColor",
	    "vmax",
	    "vmin",
	    "voice",
	    "voiceURI",
	    "volume",
	    "vrml",
	    "vspace",
	    "vw",
	    "w",
	    "wait",
	    "waitAsync",
	    "waitSync",
	    "waiting",
	    "wake",
	    "wakeLock",
	    "wand",
	    "warn",
	    "wasClean",
	    "wasDiscarded",
	    "watch",
	    "watchAvailability",
	    "watchPosition",
	    "webdriver",
	    "webkitAddKey",
	    "webkitAlignContent",
	    "webkitAlignItems",
	    "webkitAlignSelf",
	    "webkitAnimation",
	    "webkitAnimationDelay",
	    "webkitAnimationDirection",
	    "webkitAnimationDuration",
	    "webkitAnimationFillMode",
	    "webkitAnimationIterationCount",
	    "webkitAnimationName",
	    "webkitAnimationPlayState",
	    "webkitAnimationTimingFunction",
	    "webkitAppearance",
	    "webkitAudioContext",
	    "webkitAudioDecodedByteCount",
	    "webkitAudioPannerNode",
	    "webkitBackfaceVisibility",
	    "webkitBackground",
	    "webkitBackgroundAttachment",
	    "webkitBackgroundClip",
	    "webkitBackgroundColor",
	    "webkitBackgroundImage",
	    "webkitBackgroundOrigin",
	    "webkitBackgroundPosition",
	    "webkitBackgroundPositionX",
	    "webkitBackgroundPositionY",
	    "webkitBackgroundRepeat",
	    "webkitBackgroundSize",
	    "webkitBackingStorePixelRatio",
	    "webkitBorderBottomLeftRadius",
	    "webkitBorderBottomRightRadius",
	    "webkitBorderImage",
	    "webkitBorderImageOutset",
	    "webkitBorderImageRepeat",
	    "webkitBorderImageSlice",
	    "webkitBorderImageSource",
	    "webkitBorderImageWidth",
	    "webkitBorderRadius",
	    "webkitBorderTopLeftRadius",
	    "webkitBorderTopRightRadius",
	    "webkitBoxAlign",
	    "webkitBoxDirection",
	    "webkitBoxFlex",
	    "webkitBoxOrdinalGroup",
	    "webkitBoxOrient",
	    "webkitBoxPack",
	    "webkitBoxShadow",
	    "webkitBoxSizing",
	    "webkitCancelAnimationFrame",
	    "webkitCancelFullScreen",
	    "webkitCancelKeyRequest",
	    "webkitCancelRequestAnimationFrame",
	    "webkitClearResourceTimings",
	    "webkitClipPath",
	    "webkitClosedCaptionsVisible",
	    "webkitConvertPointFromNodeToPage",
	    "webkitConvertPointFromPageToNode",
	    "webkitCreateShadowRoot",
	    "webkitCurrentFullScreenElement",
	    "webkitCurrentPlaybackTargetIsWireless",
	    "webkitDecodedFrameCount",
	    "webkitDirectionInvertedFromDevice",
	    "webkitDisplayingFullscreen",
	    "webkitDroppedFrameCount",
	    "webkitEnterFullScreen",
	    "webkitEnterFullscreen",
	    "webkitEntries",
	    "webkitExitFullScreen",
	    "webkitExitFullscreen",
	    "webkitExitPointerLock",
	    "webkitFilter",
	    "webkitFlex",
	    "webkitFlexBasis",
	    "webkitFlexDirection",
	    "webkitFlexFlow",
	    "webkitFlexGrow",
	    "webkitFlexShrink",
	    "webkitFlexWrap",
	    "webkitFullScreenKeyboardInputAllowed",
	    "webkitFullscreenElement",
	    "webkitFullscreenEnabled",
	    "webkitGenerateKeyRequest",
	    "webkitGetAsEntry",
	    "webkitGetDatabaseNames",
	    "webkitGetEntries",
	    "webkitGetEntriesByName",
	    "webkitGetEntriesByType",
	    "webkitGetFlowByName",
	    "webkitGetGamepads",
	    "webkitGetImageDataHD",
	    "webkitGetNamedFlows",
	    "webkitGetRegionFlowRanges",
	    "webkitGetUserMedia",
	    "webkitHasClosedCaptions",
	    "webkitHidden",
	    "webkitIDBCursor",
	    "webkitIDBDatabase",
	    "webkitIDBDatabaseError",
	    "webkitIDBDatabaseException",
	    "webkitIDBFactory",
	    "webkitIDBIndex",
	    "webkitIDBKeyRange",
	    "webkitIDBObjectStore",
	    "webkitIDBRequest",
	    "webkitIDBTransaction",
	    "webkitImageSmoothingEnabled",
	    "webkitIndexedDB",
	    "webkitInitMessageEvent",
	    "webkitIsFullScreen",
	    "webkitJustifyContent",
	    "webkitKeys",
	    "webkitLineClamp",
	    "webkitLineDashOffset",
	    "webkitLockOrientation",
	    "webkitMask",
	    "webkitMaskClip",
	    "webkitMaskComposite",
	    "webkitMaskImage",
	    "webkitMaskOrigin",
	    "webkitMaskPosition",
	    "webkitMaskPositionX",
	    "webkitMaskPositionY",
	    "webkitMaskRepeat",
	    "webkitMaskSize",
	    "webkitMatchesSelector",
	    "webkitMediaStream",
	    "webkitNotifications",
	    "webkitOfflineAudioContext",
	    "webkitOrder",
	    "webkitOrientation",
	    "webkitPeerConnection00",
	    "webkitPersistentStorage",
	    "webkitPerspective",
	    "webkitPerspectiveOrigin",
	    "webkitPointerLockElement",
	    "webkitPostMessage",
	    "webkitPreservesPitch",
	    "webkitPutImageDataHD",
	    "webkitRTCPeerConnection",
	    "webkitRegionOverset",
	    "webkitRelativePath",
	    "webkitRequestAnimationFrame",
	    "webkitRequestFileSystem",
	    "webkitRequestFullScreen",
	    "webkitRequestFullscreen",
	    "webkitRequestPointerLock",
	    "webkitResolveLocalFileSystemURL",
	    "webkitSetMediaKeys",
	    "webkitSetResourceTimingBufferSize",
	    "webkitShadowRoot",
	    "webkitShowPlaybackTargetPicker",
	    "webkitSlice",
	    "webkitSpeechGrammar",
	    "webkitSpeechGrammarList",
	    "webkitSpeechRecognition",
	    "webkitSpeechRecognitionError",
	    "webkitSpeechRecognitionEvent",
	    "webkitStorageInfo",
	    "webkitSupportsFullscreen",
	    "webkitTemporaryStorage",
	    "webkitTextFillColor",
	    "webkitTextSecurity",
	    "webkitTextSizeAdjust",
	    "webkitTextStroke",
	    "webkitTextStrokeColor",
	    "webkitTextStrokeWidth",
	    "webkitTransform",
	    "webkitTransformOrigin",
	    "webkitTransformStyle",
	    "webkitTransition",
	    "webkitTransitionDelay",
	    "webkitTransitionDuration",
	    "webkitTransitionProperty",
	    "webkitTransitionTimingFunction",
	    "webkitURL",
	    "webkitUnlockOrientation",
	    "webkitUserSelect",
	    "webkitVideoDecodedByteCount",
	    "webkitVisibilityState",
	    "webkitWirelessVideoPlaybackDisabled",
	    "webkitdirectory",
	    "webkitdropzone",
	    "webstore",
	    "weight",
	    "wgslLanguageFeatures",
	    "whatToShow",
	    "wheelDelta",
	    "wheelDeltaX",
	    "wheelDeltaY",
	    "whenDefined",
	    "which",
	    "white-space",
	    "white-space-collapse",
	    "whiteSpace",
	    "whiteSpaceCollapse",
	    "wholeText",
	    "widows",
	    "width",
	    "will-change",
	    "willChange",
	    "willValidate",
	    "window",
	    "windowAttribution",
	    "windowControlsOverlay",
	    "with",
	    "withCredentials",
	    "withResolvers",
	    "word-break",
	    "word-spacing",
	    "word-wrap",
	    "wordBreak",
	    "wordSpacing",
	    "wordWrap",
	    "workerStart",
	    "worklet",
	    "wow64",
	    "wrap",
	    "wrapKey",
	    "writable",
	    "writableAuxiliaries",
	    "write",
	    "writeBuffer",
	    "writeMask",
	    "writeText",
	    "writeTexture",
	    "writeTimestamp",
	    "writeValue",
	    "writeValueWithResponse",
	    "writeValueWithoutResponse",
	    "writeWithoutResponse",
	    "writeln",
	    "writing-mode",
	    "writingMode",
	    "writingSuggestions",
	    "x",
	    "x1",
	    "x2",
	    "xChannelSelector",
	    "xmlEncoding",
	    "xmlStandalone",
	    "xmlVersion",
	    "xmlbase",
	    "xmllang",
	    "xmlspace",
	    "xor",
	    "xr",
	    "y",
	    "y1",
	    "y2",
	    "yChannelSelector",
	    "yandex",
	    "z",
	    "z-index",
	    "zIndex",
	    "zoom",
	    "zoomAndPan",
	    "zoomRectScreen",
	];

	/***********************************************************************

	  A JavaScript tokenizer / parser / beautifier / compressor.
	  https://github.com/mishoo/UglifyJS2

	  -------------------------------- (C) ---------------------------------

	                           Author: Mihai Bazon
	                         <mihai.bazon@gmail.com>
	                       http://mihai.bazon.net/blog

	  Distributed under the BSD license:

	    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

	    Redistribution and use in source and binary forms, with or without
	    modification, are permitted provided that the following conditions
	    are met:

	        * Redistributions of source code must retain the above
	          copyright notice, this list of conditions and the following
	          disclaimer.

	        * Redistributions in binary form must reproduce the above
	          copyright notice, this list of conditions and the following
	          disclaimer in the documentation and/or other materials
	          provided with the distribution.

	    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
	    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
	    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
	    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
	    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
	    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
	    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
	    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
	    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
	    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
	    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
	    SUCH DAMAGE.

	 ***********************************************************************/

	function find_builtins(reserved) {
	    domprops.forEach(add);

	    // Compatibility fix for some standard defined globals not defined on every js environment
	    var new_globals = ["Symbol", "Map", "Promise", "Proxy", "Reflect", "Set", "WeakMap", "WeakSet"];
	    var objects = {};
	    var global_ref = typeof commonjsGlobal === "object" ? commonjsGlobal : self;

	    new_globals.forEach(function (new_global) {
	        objects[new_global] = global_ref[new_global] || function() {};
	    });

	    [
	        "null",
	        "true",
	        "false",
	        "NaN",
	        "Infinity",
	        "-Infinity",
	        "undefined",
	    ].forEach(add);
	    [ Object, Array, Function, Number,
	      String, Boolean, Error, Math,
	      Date, RegExp, objects.Symbol, ArrayBuffer,
	      DataView, decodeURI, decodeURIComponent,
	      encodeURI, encodeURIComponent, eval, EvalError,
	      Float32Array, Float64Array, Int8Array, Int16Array,
	      Int32Array, isFinite, isNaN, JSON, objects.Map, parseFloat,
	      parseInt, objects.Promise, objects.Proxy, RangeError, ReferenceError,
	      objects.Reflect, objects.Set, SyntaxError, TypeError, Uint8Array,
	      Uint8ClampedArray, Uint16Array, Uint32Array, URIError,
	      objects.WeakMap, objects.WeakSet
	    ].forEach(function(ctor) {
	        Object.getOwnPropertyNames(ctor).map(add);
	        if (ctor.prototype) {
	            Object.getOwnPropertyNames(ctor.prototype).map(add);
	        }
	    });
	    function add(name) {
	        reserved.add(name);
	    }
	}

	function reserve_quoted_keys(ast, reserved) {
	    function add(name) {
	        push_uniq(reserved, name);
	    }

	    ast.walk(new TreeWalker(function(node) {
	        if (node instanceof AST_ObjectKeyVal && node.quote) {
	            add(node.key);
	        } else if (node instanceof AST_ObjectProperty && node.quote) {
	            add(node.key.name);
	        } else if (node instanceof AST_Sub) {
	            addStrings(node.property, add);
	        }
	    }));
	}

	function addStrings(node, add) {
	    node.walk(new TreeWalker(function(node) {
	        if (node instanceof AST_Sequence) {
	            addStrings(node.tail_node(), add);
	        } else if (node instanceof AST_String) {
	            add(node.value);
	        } else if (node instanceof AST_Conditional) {
	            addStrings(node.consequent, add);
	            addStrings(node.alternative, add);
	        }
	        return true;
	    }));
	}

	function mangle_private_properties(ast, options) {
	    var cprivate = -1;
	    var private_cache = new Map();
	    var nth_identifier = options.nth_identifier || base54;

	    ast =  ast.transform(new TreeTransformer(function(node) {
	        if (
	            node instanceof AST_ClassPrivateProperty
	            || node instanceof AST_PrivateMethod
	            || node instanceof AST_PrivateGetter
	            || node instanceof AST_PrivateSetter
	            || node instanceof AST_PrivateIn
	        ) {
	            node.key.name = mangle_private(node.key.name);
	        } else if (node instanceof AST_DotHash) {
	            node.property = mangle_private(node.property);
	        }
	    }));
	    return ast;

	    function mangle_private(name) {
	        let mangled = private_cache.get(name);
	        if (!mangled) {
	            mangled = nth_identifier.get(++cprivate);
	            private_cache.set(name, mangled);
	        }

	        return mangled;
	    }
	}

	function find_annotated_props(ast) {
	    var annotated_props = new Set();
	    walk(ast, node => {
	        if (
	            node instanceof AST_ClassPrivateProperty
	            || node instanceof AST_PrivateMethod
	            || node instanceof AST_PrivateGetter
	            || node instanceof AST_PrivateSetter
	            || node instanceof AST_DotHash
	        ) ; else if (node instanceof AST_ObjectKeyVal) {
	            if (typeof node.key == "string" && has_annotation(node, _MANGLEPROP)) {
	                annotated_props.add(node.key);
	            }
	        } else if (node instanceof AST_ObjectProperty) {
	            // setter or getter, since KeyVal is handled above
	            if (has_annotation(node, _MANGLEPROP)) {
	                annotated_props.add(node.key.name);
	            }
	        } else if (node instanceof AST_Dot) {
	            if (has_annotation(node, _MANGLEPROP)) {
	                annotated_props.add(node.property);
	            }
	        } else if (node instanceof AST_Sub) {
	            if (node.property instanceof AST_String && has_annotation(node, _MANGLEPROP)) {
	                annotated_props.add(node.property.value);
	            }
	        }
	    });
	    return annotated_props;
	}

	function mangle_properties(ast, options, annotated_props = find_annotated_props(ast)) {
	    options = defaults(options, {
	        builtins: false,
	        cache: null,
	        debug: false,
	        keep_quoted: false,
	        nth_identifier: base54,
	        only_cache: false,
	        regex: null,
	        reserved: null,
	        undeclared: false,
	        only_annotated: false,
	    }, true);

	    var nth_identifier = options.nth_identifier;

	    var reserved_option = options.reserved;
	    if (!Array.isArray(reserved_option)) reserved_option = [reserved_option];
	    var reserved = new Set(reserved_option);
	    if (!options.builtins) find_builtins(reserved);

	    var cname = -1;

	    var cache;
	    if (options.cache) {
	        cache = options.cache.props;
	    } else {
	        cache = new Map();
	    }

	    var only_annotated = options.only_annotated;
	    var regex = options.regex && new RegExp(options.regex);

	    // note debug is either false (disabled), or a string of the debug suffix to use (enabled).
	    // note debug may be enabled as an empty string, which is falsey. Also treat passing 'true'
	    // the same as passing an empty string.
	    var debug = options.debug !== false;
	    var debug_name_suffix;
	    if (debug) {
	        debug_name_suffix = (options.debug === true ? "" : options.debug);
	    }

	    var names_to_mangle = new Set();
	    var unmangleable = new Set();
	    // Track each already-mangled name to prevent nth_identifier from generating
	    // the same name.
	    cache.forEach((mangled_name) => unmangleable.add(mangled_name));

	    var keep_quoted = !!options.keep_quoted;

	    // step 1: find candidates to mangle
	    ast.walk(new TreeWalker(function(node) {
	        if (
	            node instanceof AST_ClassPrivateProperty
	            || node instanceof AST_PrivateMethod
	            || node instanceof AST_PrivateGetter
	            || node instanceof AST_PrivateSetter
	            || node instanceof AST_DotHash
	        ) ; else if (node instanceof AST_ObjectKeyVal) {
	            if (typeof node.key == "string" && (!keep_quoted || !node.quote)) {
	                add(node.key);
	            }
	        } else if (node instanceof AST_ObjectProperty) {
	            // setter or getter, since KeyVal is handled above
	            if (!keep_quoted || !node.quote) {
	                add(node.key.name);
	            }
	        } else if (node instanceof AST_Dot) {
	            var declared = !!options.undeclared;
	            if (!declared) {
	                var root = node;
	                while (root.expression) {
	                    root = root.expression;
	                }
	                declared = !(root.thedef && root.thedef.undeclared);
	            }
	            if (declared &&
	                (!keep_quoted || !node.quote)) {
	                add(node.property);
	            }
	        } else if (node instanceof AST_Sub) {
	            if (!keep_quoted) {
	                addStrings(node.property, add);
	            }
	        } else if (node instanceof AST_Call
	            && node.expression.print_to_string() == "Object.defineProperty") {
	            addStrings(node.args[1], add);
	        } else if (node instanceof AST_Binary && node.operator === "in") {
	            addStrings(node.left, add);
	        } else if (node instanceof AST_String && has_annotation(node, _KEY)) {
	            add(node.value);
	        }
	    }));

	    // step 2: transform the tree, renaming properties
	    return ast.transform(new TreeTransformer(function(node) {
	        if (
	            node instanceof AST_ClassPrivateProperty
	            || node instanceof AST_PrivateMethod
	            || node instanceof AST_PrivateGetter
	            || node instanceof AST_PrivateSetter
	            || node instanceof AST_DotHash
	        ) ; else if (node instanceof AST_ObjectKeyVal) {
	            if (typeof node.key == "string" && (!keep_quoted || !node.quote)) {
	                node.key = mangle(node.key);
	            }
	        } else if (node instanceof AST_ObjectProperty) {
	            // setter, getter, method or class field
	            if (!keep_quoted || !node.quote) {
	                node.key.name = mangle(node.key.name);
	            }
	        } else if (node instanceof AST_Dot) {
	            if (!keep_quoted || !node.quote) {
	                node.property = mangle(node.property);
	            }
	        } else if (!keep_quoted && node instanceof AST_Sub) {
	            node.property = mangleStrings(node.property);
	        } else if (node instanceof AST_Call
	            && node.expression.print_to_string() == "Object.defineProperty") {
	            node.args[1] = mangleStrings(node.args[1]);
	        } else if (node instanceof AST_Binary && node.operator === "in") {
	            node.left = mangleStrings(node.left);
	        } else if (node instanceof AST_String && has_annotation(node, _KEY)) {
	            // Clear _KEY annotation to prevent double mangling
	            clear_annotation(node, _KEY);
	            node.value = mangle(node.value);
	        }
	    }));

	    // only function declarations after this line

	    function can_mangle(name) {
	        if (unmangleable.has(name)) return false;
	        if (reserved.has(name)) return false;
	        if (options.only_cache) {
	            return cache.has(name);
	        }
	        if (/^-?[0-9]+(\.[0-9]+)?(e[+-][0-9]+)?$/.test(name)) return false;
	        return true;
	    }

	    function should_mangle(name) {
	        if (only_annotated && !annotated_props.has(name)) return false;
	        if (regex && !regex.test(name)) {
	            return annotated_props.has(name);
	        }
	        if (reserved.has(name)) return false;
	        return cache.has(name)
	            || names_to_mangle.has(name);
	    }

	    function add(name) {
	        if (can_mangle(name)) {
	            names_to_mangle.add(name);
	        }

	        if (!should_mangle(name)) {
	            unmangleable.add(name);
	        }
	    }

	    function mangle(name) {
	        if (!should_mangle(name)) {
	            return name;
	        }

	        var mangled = cache.get(name);
	        if (!mangled) {
	            if (debug) {
	                // debug mode: use a prefix and suffix to preserve readability, e.g. o.foo -> o._$foo$NNN_.
	                var debug_mangled = "_$" + name + "$" + debug_name_suffix + "_";

	                if (can_mangle(debug_mangled)) {
	                    mangled = debug_mangled;
	                }
	            }

	            // either debug mode is off, or it is on and we could not use the mangled name
	            if (!mangled) {
	                do {
	                    mangled = nth_identifier.get(++cname);
	                } while (!can_mangle(mangled));
	            }

	            cache.set(name, mangled);
	        }
	        return mangled;
	    }

	    function mangleStrings(node) {
	        return node.transform(new TreeTransformer(function(node) {
	            if (node instanceof AST_Sequence) {
	                var last = node.expressions.length - 1;
	                node.expressions[last] = mangleStrings(node.expressions[last]);
	            } else if (node instanceof AST_String) {
	                // Clear _KEY annotation to prevent double mangling
	                clear_annotation(node, _KEY);
	                node.value = mangle(node.value);
	            } else if (node instanceof AST_Conditional) {
	                node.consequent = mangleStrings(node.consequent);
	                node.alternative = mangleStrings(node.alternative);
	            }
	            return node;
	        }));
	    }
	}

	// to/from base64 functions
	// Prefer built-in Buffer, if available, then use hack
	// https://developer.mozilla.org/en-US/docs/Glossary/Base64#The_Unicode_Problem
	var to_ascii = typeof Buffer !== "undefined"
	    ? (b64) => Buffer.from(b64, "base64").toString()
	    : (b64) => decodeURIComponent(escape(atob(b64)));
	var to_base64 = typeof Buffer !== "undefined"
	    ? (str) => Buffer.from(str).toString("base64")
	    : (str) => btoa(unescape(encodeURIComponent(str)));

	function read_source_map(code) {
	    var match = /(?:^|[^.])\/\/# sourceMappingURL=data:application\/json(;[\w=-]*)?;base64,([+/0-9A-Za-z]*=*)\s*$/.exec(code);
	    if (!match) {
	        console.warn("inline source map not found");
	        return null;
	    }
	    return to_ascii(match[2]);
	}

	function set_shorthand(name, options, keys) {
	    if (options[name]) {
	        keys.forEach(function(key) {
	            if (options[key]) {
	                if (typeof options[key] != "object") options[key] = {};
	                if (!(name in options[key])) options[key][name] = options[name];
	            }
	        });
	    }
	}

	function init_cache(cache) {
	    if (!cache) return;
	    if (!("props" in cache)) {
	        cache.props = new Map();
	    } else if (!(cache.props instanceof Map)) {
	        cache.props = map_from_object(cache.props);
	    }
	}

	function cache_to_json(cache) {
	    return {
	        props: map_to_object(cache.props)
	    };
	}

	function log_input(files, options, fs, debug_folder) {
	    if (!(fs && fs.writeFileSync && fs.mkdirSync)) {
	        return;
	    }

	    try {
	        fs.mkdirSync(debug_folder);
	    } catch (e) {
	        if (e.code !== "EEXIST") throw e;
	    }

	    const log_path = `${debug_folder}/terser-debug-${(Math.random() * 9999999) | 0}.log`;

	    options = options || {};

	    const options_str = JSON.stringify(options, (_key, thing) => {
	        if (typeof thing === "function") return "[Function " + thing.toString() + "]";
	        if (thing instanceof RegExp) return "[RegExp " + thing.toString() + "]";
	        return thing;
	    }, 4);

	    const files_str = (file) => {
	        if (typeof file === "object" && options.parse && options.parse.spidermonkey) {
	            return JSON.stringify(file, null, 2);
	        } else if (typeof file === "object") {
	            return Object.keys(file)
	                .map((key) => key + ": " + files_str(file[key]))
	                .join("\n\n");
	        } else if (typeof file === "string") {
	            return "```\n" + file + "\n```";
	        } else {
	            return file; // What do?
	        }
	    };

	    fs.writeFileSync(log_path, "Options: \n" + options_str + "\n\nInput files:\n\n" + files_str(files) + "\n");
	}

	function* minify_sync_or_async(files, options, _fs_module) {
	    if (
	        _fs_module
	        && typeof process === "object"
	        && process.env
	        && typeof process.env.TERSER_DEBUG_DIR === "string"
	    ) {
	        log_input(files, options, _fs_module, process.env.TERSER_DEBUG_DIR);
	    }

	    options = defaults(options, {
	        compress: {},
	        ecma: undefined,
	        enclose: false,
	        ie8: false,
	        keep_classnames: undefined,
	        keep_fnames: false,
	        mangle: {},
	        module: false,
	        nameCache: null,
	        output: null,
	        format: null,
	        parse: {},
	        rename: undefined,
	        safari10: false,
	        sourceMap: false,
	        spidermonkey: false,
	        timings: false,
	        toplevel: false,
	        warnings: false,
	        wrap: false,
	    }, true);

	    var timings = options.timings && {
	        start: Date.now()
	    };
	    if (options.keep_classnames === undefined) {
	        options.keep_classnames = options.keep_fnames;
	    }
	    if (options.rename === undefined) {
	        options.rename = options.compress && options.mangle;
	    }
	    if (options.output && options.format) {
	        throw new Error("Please only specify either output or format option, preferrably format.");
	    }
	    options.format = options.format || options.output || {};
	    set_shorthand("ecma", options, [ "parse", "compress", "format" ]);
	    set_shorthand("ie8", options, [ "compress", "mangle", "format" ]);
	    set_shorthand("keep_classnames", options, [ "compress", "mangle" ]);
	    set_shorthand("keep_fnames", options, [ "compress", "mangle" ]);
	    set_shorthand("module", options, [ "parse", "compress", "mangle" ]);
	    set_shorthand("safari10", options, [ "mangle", "format" ]);
	    set_shorthand("toplevel", options, [ "compress", "mangle" ]);
	    set_shorthand("warnings", options, [ "compress" ]); // legacy
	    var quoted_props;
	    if (options.mangle) {
	        options.mangle = defaults(options.mangle, {
	            cache: options.nameCache && (options.nameCache.vars || {}),
	            eval: false,
	            ie8: false,
	            keep_classnames: false,
	            keep_fnames: false,
	            module: false,
	            nth_identifier: base54,
	            properties: false,
	            reserved: [],
	            safari10: false,
	            toplevel: false,
	        }, true);
	        if (options.mangle.properties) {
	            if (typeof options.mangle.properties != "object") {
	                options.mangle.properties = {};
	            }
	            if (options.mangle.properties.keep_quoted) {
	                quoted_props = options.mangle.properties.reserved;
	                if (!Array.isArray(quoted_props)) quoted_props = [];
	                options.mangle.properties.reserved = quoted_props;
	            }
	            if (options.nameCache && !("cache" in options.mangle.properties)) {
	                options.mangle.properties.cache = options.nameCache.props || {};
	            }
	        }
	        init_cache(options.mangle.cache);
	        init_cache(options.mangle.properties.cache);
	    }
	    if (options.sourceMap) {
	        options.sourceMap = defaults(options.sourceMap, {
	            asObject: false,
	            content: null,
	            filename: null,
	            includeSources: false,
	            root: null,
	            url: null,
	        }, true);
	    }

	    // -- Parse phase --
	    if (timings) timings.parse = Date.now();
	    var toplevel;
	    if (files instanceof AST_Toplevel) {
	        toplevel = files;
	    } else {
	        if (typeof files == "string" || (options.parse.spidermonkey && !Array.isArray(files))) {
	            files = [ files ];
	        }
	        options.parse = options.parse || {};
	        options.parse.toplevel = null;

	        if (options.parse.spidermonkey) {
	            options.parse.toplevel = AST_Node.from_mozilla_ast(Object.keys(files).reduce(function(toplevel, name) {
	                if (!toplevel) return files[name];
	                toplevel.body = toplevel.body.concat(files[name].body);
	                return toplevel;
	            }, null));
	        } else {
	            delete options.parse.spidermonkey;

	            for (var name in files) if (HOP(files, name)) {
	                options.parse.filename = name;
	                options.parse.toplevel = parse(files[name], options.parse);
	                if (options.sourceMap && options.sourceMap.content == "inline") {
	                    if (Object.keys(files).length > 1)
	                        throw new Error("inline source map only works with singular input");
	                    options.sourceMap.content = read_source_map(files[name]);
	                }
	            }
	        }
	        if (options.parse.toplevel === null) {
	            throw new Error("no source file given");
	        }

	        toplevel = options.parse.toplevel;
	    }
	    if (quoted_props && options.mangle.properties.keep_quoted !== "strict") {
	        reserve_quoted_keys(toplevel, quoted_props);
	    }
	    var annotated_props;
	    if (options.mangle && options.mangle.properties) {
	        annotated_props = find_annotated_props(toplevel);
	    }
	    if (options.wrap) {
	        toplevel = toplevel.wrap_commonjs(options.wrap);
	    }
	    if (options.enclose) {
	        toplevel = toplevel.wrap_enclose(options.enclose);
	    }
	    if (timings) timings.rename = Date.now();

	    // -- Compress phase --
	    if (timings) timings.compress = Date.now();
	    if (options.compress) {
	        toplevel = new Compressor(options.compress, {
	            mangle_options: options.mangle
	        }).compress(toplevel);
	    }

	    // -- Mangle phase --
	    if (timings) timings.scope = Date.now();
	    if (options.mangle) toplevel.figure_out_scope(options.mangle);
	    if (timings) timings.mangle = Date.now();
	    if (options.mangle) {
	        toplevel.compute_char_frequency(options.mangle);
	        toplevel.mangle_names(options.mangle);
	        toplevel = mangle_private_properties(toplevel, options.mangle);
	    }
	    if (timings) timings.properties = Date.now();
	    if (options.mangle && options.mangle.properties) {
	        toplevel = mangle_properties(toplevel, options.mangle.properties, annotated_props);
	    }

	    // Format phase
	    if (timings) timings.format = Date.now();
	    var result = {};
	    if (options.format.ast) {
	        result.ast = toplevel;
	    }
	    if (options.format.spidermonkey) {
	        result.ast = toplevel.to_mozilla_ast();
	    }
	    let format_options;
	    if (!HOP(options.format, "code") || options.format.code) {
	        // Make a shallow copy so that we can modify without mutating the user's input.
	        format_options = {...options.format};
	        if (!format_options.ast) {
	            // Destroy stuff to save RAM. (unless the deprecated `ast` option is on)
	            format_options._destroy_ast = true;

	            walk(toplevel, node => {
	                if (node instanceof AST_Scope) {
	                    node.variables = undefined;
	                    node.enclosed = undefined;
	                    node.parent_scope = undefined;
	                }
	                if (node.block_scope) {
	                    node.block_scope.variables = undefined;
	                    node.block_scope.enclosed = undefined;
	                    node.parent_scope = undefined;
	                }
	            });
	        }

	        if (options.sourceMap) {
	            if (options.sourceMap.includeSources && files instanceof AST_Toplevel) {
	                throw new Error("original source content unavailable");
	            }
	            format_options.source_map = yield* SourceMap({
	                file: options.sourceMap.filename,
	                orig: options.sourceMap.content,
	                root: options.sourceMap.root,
	                files: options.sourceMap.includeSources ? files : null,
	            });
	        }
	        delete format_options.ast;
	        delete format_options.code;
	        delete format_options.spidermonkey;
	        var stream = OutputStream(format_options);
	        toplevel.print(stream);
	        result.code = stream.get();
	        if (options.sourceMap) {
	            Object.defineProperty(result, "map", {
	                configurable: true,
	                enumerable: true,
	                get() {
	                    const map = format_options.source_map.getEncoded();
	                    return (result.map = options.sourceMap.asObject ? map : JSON.stringify(map));
	                },
	                set(value) {
	                    Object.defineProperty(result, "map", {
	                        value,
	                        writable: true,
	                    });
	                }
	            });
	            result.decoded_map = format_options.source_map.getDecoded();
	            if (options.sourceMap.url == "inline") {
	                var sourceMap = typeof result.map === "object" ? JSON.stringify(result.map) : result.map;
	                result.code += "\n//# sourceMappingURL=data:application/json;charset=utf-8;base64," + to_base64(sourceMap);
	            } else if (options.sourceMap.url) {
	                result.code += "\n//# sourceMappingURL=" + options.sourceMap.url;
	            }
	        }
	    }
	    if (options.nameCache && options.mangle) {
	        if (options.mangle.cache) options.nameCache.vars = cache_to_json(options.mangle.cache);
	        if (options.mangle.properties && options.mangle.properties.cache) {
	            options.nameCache.props = cache_to_json(options.mangle.properties.cache);
	        }
	    }
	    if (format_options && format_options.source_map) {
	        format_options.source_map.destroy();
	    }
	    if (timings) {
	        timings.end = Date.now();
	        result.timings = {
	            parse: 1e-3 * (timings.rename - timings.parse),
	            rename: 1e-3 * (timings.compress - timings.rename),
	            compress: 1e-3 * (timings.scope - timings.compress),
	            scope: 1e-3 * (timings.mangle - timings.scope),
	            mangle: 1e-3 * (timings.properties - timings.mangle),
	            properties: 1e-3 * (timings.format - timings.properties),
	            format: 1e-3 * (timings.end - timings.format),
	            total: 1e-3 * (timings.end - timings.start)
	        };
	    }
	    return result;
	}

	async function minify(files, options, _fs_module) {
	    const gen = minify_sync_or_async(files, options, _fs_module);

	    let yielded;
	    let val;
	    do {
	        val = gen.next(await yielded);
	        yielded = val.value;
	    } while (!val.done);

	    return val.value;
	}

	function minify_sync(files, options, _fs_module) {
	    const gen = minify_sync_or_async(files, options, _fs_module);

	    let yielded;
	    let val;
	    do {
	        if (yielded && typeof yielded.then === "function") {
	            throw new Error("minify_sync cannot be used with the legacy source-map module");
	        }
	        val = gen.next(yielded);
	        yielded = val.value;
	    } while (!val.done);

	    return val.value;
	}

	async function run_cli({ program, packageJson, fs, path }) {
	    const skip_keys = new Set([ "cname", "parent_scope", "scope", "uses_eval", "uses_with" ]);
	    var files = {};
	    var options = {
	        compress: false,
	        mangle: false
	    };
	    const default_options = await _default_options();
	    program.version(packageJson.name + " " + packageJson.version);
	    program.parseArgv = program.parse;
	    program.parse = undefined;

	    if (process.argv.includes("ast")) program.helpInformation = describe_ast;
	    else if (process.argv.includes("options")) program.helpInformation = function() {
	        var text = [];
	        for (var option in default_options) {
	            text.push("--" + (option === "sourceMap" ? "source-map" : option) + " options:");
	            text.push(format_object(default_options[option]));
	            text.push("");
	        }
	        return text.join("\n");
	    };

	    program.option("-p, --parse <options>", "Specify parser options.", parse_js());
	    program.option("-c, --compress [options]", "Enable compressor/specify compressor options.", parse_js());
	    program.option("-m, --mangle [options]", "Mangle names/specify mangler options.", parse_js());
	    program.option("--mangle-props [options]", "Mangle properties/specify mangler options.", parse_js());
	    program.option("-f, --format [options]", "Format options.", parse_js());
	    program.option("-b, --beautify [options]", "Alias for --format.", parse_js());
	    program.option("-o, --output <file>", "Output file (default STDOUT).");
	    program.option("--comments [filter]", "Preserve copyright comments in the output.");
	    program.option("--config-file <file>", "Read minify() options from JSON file.");
	    program.option("-d, --define <expr>[=value]", "Global definitions.", parse_js("define"));
	    program.option("--ecma <version>", "Specify ECMAScript release: 5, 2015, 2016 or 2017...");
	    program.option("-e, --enclose [arg[,...][:value[,...]]]", "Embed output in a big function with configurable arguments and values.");
	    program.option("--ie8", "Support non-standard Internet Explorer 8.");
	    program.option("--keep-classnames", "Do not mangle/drop class names.");
	    program.option("--keep-fnames", "Do not mangle/drop function names. Useful for code relying on Function.prototype.name.");
	    program.option("--module", "Input is an ES6 module");
	    program.option("--name-cache <file>", "File to hold mangled name mappings.");
	    program.option("--rename", "Force symbol expansion.");
	    program.option("--no-rename", "Disable symbol expansion.");
	    program.option("--safari10", "Support non-standard Safari 10.");
	    program.option("--source-map [options]", "Enable source map/specify source map options.", parse_js());
	    program.option("--timings", "Display operations run time on STDERR.");
	    program.option("--toplevel", "Compress and/or mangle variables in toplevel scope.");
	    program.option("--wrap <name>", "Embed everything as a function with “exports” corresponding to “name” globally.");
	    program.arguments("[files...]").parseArgv(process.argv);
	    if (program.configFile) {
	        options = JSON.parse(read_file(program.configFile));
	    }
	    if (!program.output && program.sourceMap && program.sourceMap.url != "inline") {
	        fatal("ERROR: cannot write source map to STDOUT");
	    }

	    [
	        "compress",
	        "enclose",
	        "ie8",
	        "mangle",
	        "module",
	        "safari10",
	        "sourceMap",
	        "toplevel",
	        "wrap"
	    ].forEach(function(name) {
	        if (name in program) {
	            options[name] = program[name];
	        }
	    });

	    if ("ecma" in program) {
	        if (program.ecma != (program.ecma | 0)) fatal("ERROR: ecma must be an integer");
	        const ecma = program.ecma | 0;
	        if (ecma > 5 && ecma < 2015)
	            options.ecma = ecma + 2009;
	        else
	            options.ecma = ecma;
	    }
	    if (program.format || program.beautify) {
	        const chosenOption = program.format || program.beautify;
	        options.format = typeof chosenOption === "object" ? chosenOption : {};
	    }
	    if (program.comments) {
	        if (typeof options.format != "object") options.format = {};
	        options.format.comments = typeof program.comments == "string" ? (program.comments == "false" ? false : program.comments) : "some";
	    }
	    if (program.define) {
	        if (typeof options.compress != "object") options.compress = {};
	        if (typeof options.compress.global_defs != "object") options.compress.global_defs = {};
	        for (var expr in program.define) {
	            options.compress.global_defs[expr] = program.define[expr];
	        }
	    }
	    if (program.keepClassnames) {
	        options.keep_classnames = true;
	    }
	    if (program.keepFnames) {
	        options.keep_fnames = true;
	    }
	    if (program.mangleProps) {
	        if (program.mangleProps.domprops) {
	            delete program.mangleProps.domprops;
	        } else {
	            if (typeof program.mangleProps != "object") program.mangleProps = {};
	            if (!Array.isArray(program.mangleProps.reserved)) program.mangleProps.reserved = [];
	        }
	        if (typeof options.mangle != "object") options.mangle = {};
	        options.mangle.properties = program.mangleProps;
	    }
	    if (program.nameCache) {
	        options.nameCache = JSON.parse(read_file(program.nameCache, "{}"));
	    }
	    if (program.output == "ast") {
	        options.format = {
	            ast: true,
	            code: false
	        };
	    }
	    if (program.parse) {
	        if (!program.parse.acorn && !program.parse.spidermonkey) {
	            options.parse = program.parse;
	        } else if (program.sourceMap && program.sourceMap.content == "inline") {
	            fatal("ERROR: inline source map only works with built-in parser");
	        }
	    }
	    if (~program.rawArgs.indexOf("--rename")) {
	        options.rename = true;
	    } else if (!program.rename) {
	        options.rename = false;
	    }

	    let convert_path = name => name;
	    if (typeof program.sourceMap == "object" && "base" in program.sourceMap) {
	        convert_path = function() {
	            var base = program.sourceMap.base;
	            delete options.sourceMap.base;
	            return function(name) {
	                return path.relative(base, name);
	            };
	        }();
	    }

	    let filesList;
	    if (options.files && options.files.length) {
	        filesList = options.files;

	        delete options.files;
	    } else if (program.args.length) {
	        filesList = program.args;
	    }

	    if (filesList) {
	        simple_glob(filesList).forEach(function(name) {
	            files[convert_path(name)] = read_file(name);
	        });
	    } else {
	        await new Promise((resolve) => {
	            var chunks = [];
	            process.stdin.setEncoding("utf8");
	            process.stdin.on("data", function(chunk) {
	                chunks.push(chunk);
	            }).on("end", function() {
	                files = [ chunks.join("") ];
	                resolve();
	            });
	            process.stdin.resume();
	        });
	    }

	    await run_cli();

	    function convert_ast(fn) {
	        return AST_Node.from_mozilla_ast(Object.keys(files).reduce(fn, null));
	    }

	    async function run_cli() {
	        var content = program.sourceMap && program.sourceMap.content;
	        if (content && content !== "inline") {
	            options.sourceMap.content = read_file(content, content);
	        }
	        if (program.timings) options.timings = true;

	        try {
	            if (program.parse) {
	                if (program.parse.acorn) {
	                    files = convert_ast(function(toplevel, name) {
	                        return requireAcorn().parse(files[name], {
	                            ecmaVersion: 2018,
	                            locations: true,
	                            program: toplevel,
	                            sourceFile: name,
	                            sourceType: options.module || program.parse.module ? "module" : "script"
	                        });
	                    });
	                } else if (program.parse.spidermonkey) {
	                    files = convert_ast(function(toplevel, name) {
	                        var obj = JSON.parse(files[name]);
	                        if (!toplevel) return obj;
	                        toplevel.body = toplevel.body.concat(obj.body);
	                        return toplevel;
	                    });
	                }
	            }
	        } catch (ex) {
	            fatal(ex);
	        }

	        let result;
	        try {
	            result = await minify(files, options, fs);
	        } catch (ex) {
	            if (ex.name == "SyntaxError") {
	                print_error("Parse error at " + ex.filename + ":" + ex.line + "," + ex.col);
	                var col = ex.col;
	                var lines = files[ex.filename].split(/\r?\n/);
	                var line = lines[ex.line - 1];
	                if (!line && !col) {
	                    line = lines[ex.line - 2];
	                    col = line.length;
	                }
	                if (line) {
	                    var limit = 70;
	                    if (col > limit) {
	                        line = line.slice(col - limit);
	                        col = limit;
	                    }
	                    print_error(line.slice(0, 80));
	                    print_error(line.slice(0, col).replace(/\S/g, " ") + "^");
	                }
	            }
	            if (ex.defs) {
	                print_error("Supported options:");
	                print_error(format_object(ex.defs));
	            }
	            fatal(ex);
	            return;
	        }

	        if (program.output == "ast") {
	            if (!options.compress && !options.mangle) {
	                result.ast.figure_out_scope({});
	            }
	            console.log(JSON.stringify(result.ast, function(key, value) {
	                if (value) switch (key) {
	                  case "thedef":
	                    return symdef(value);
	                  case "enclosed":
	                    return value.length ? value.map(symdef) : undefined;
	                  case "variables":
	                  case "globals":
	                    return value.size ? collect_from_map(value, symdef) : undefined;
	                }
	                if (skip_keys.has(key)) return;
	                if (value instanceof AST_Token) return;
	                if (value instanceof Map) return;
	                if (value instanceof AST_Node) {
	                    var result = {
	                        _class: "AST_" + value.TYPE
	                    };
	                    if (value.block_scope) {
	                        result.variables = value.block_scope.variables;
	                        result.enclosed = value.block_scope.enclosed;
	                    }
	                    value.CTOR.PROPS.forEach(function(prop) {
	                        if (prop !== "block_scope") {
	                            result[prop] = value[prop];
	                        }
	                    });
	                    return result;
	                }
	                return value;
	            }, 2));
	        } else if (program.output == "spidermonkey") {
	            try {
	                const minified = await minify(
	                    result.code,
	                    {
	                        compress: false,
	                        mangle: false,
	                        format: {
	                            ast: true,
	                            code: false
	                        }
	                    },
	                    fs
	                );
	                console.log(JSON.stringify(minified.ast.to_mozilla_ast(), null, 2));
	            } catch (ex) {
	                fatal(ex);
	                return;
	            }
	        } else if (program.output) {
	            fs.writeFileSync(program.output, result.code);
	            if (options.sourceMap && options.sourceMap.url !== "inline" && result.map) {
	                fs.writeFileSync(program.output + ".map", result.map);
	            }
	        } else {
	            console.log(result.code);
	        }
	        if (program.nameCache) {
	            fs.writeFileSync(program.nameCache, JSON.stringify(options.nameCache));
	        }
	        if (result.timings) for (var phase in result.timings) {
	            print_error("- " + phase + ": " + result.timings[phase].toFixed(3) + "s");
	        }
	    }

	    function fatal(message) {
	        if (message instanceof Error) message = message.stack.replace(/^\S*?Error:/, "ERROR:");
	        print_error(message);
	        process.exit(1);
	    }

	    // A file glob function that only supports "*" and "?" wildcards in the basename.
	    // Example: "foo/bar/*baz??.*.js"
	    // Argument `glob` may be a string or an array of strings.
	    // Returns an array of strings. Garbage in, garbage out.
	    function simple_glob(glob) {
	        if (Array.isArray(glob)) {
	            return [].concat.apply([], glob.map(simple_glob));
	        }
	        if (glob && glob.match(/[*?]/)) {
	            var dir = path.dirname(glob);
	            try {
	                var entries = fs.readdirSync(dir);
	            } catch (ex) {}
	            if (entries) {
	                var pattern = "^" + path.basename(glob)
	                    .replace(/[.+^$[\]\\(){}]/g, "\\$&")
	                    .replace(/\*/g, "[^/\\\\]*")
	                    .replace(/\?/g, "[^/\\\\]") + "$";
	                var mod = process.platform === "win32" ? "i" : "";
	                var rx = new RegExp(pattern, mod);
	                var results = entries.filter(function(name) {
	                    return rx.test(name);
	                }).map(function(name) {
	                    return path.join(dir, name);
	                });
	                if (results.length) return results;
	            }
	        }
	        return [ glob ];
	    }

	    function read_file(path, default_value) {
	        try {
	            return fs.readFileSync(path, "utf8");
	        } catch (ex) {
	            if ((ex.code == "ENOENT" || ex.code == "ENAMETOOLONG") && default_value != null) return default_value;
	            fatal(ex);
	        }
	    }

	    function parse_js(flag) {
	        return function(value, options) {
	            options = options || {};
	            try {
	                walk(parse(value, { expression: true }), node => {
	                    if (node instanceof AST_Assign) {
	                        var name = node.left.print_to_string();
	                        var value = node.right;
	                        if (flag) {
	                            options[name] = value;
	                        } else if (value instanceof AST_Array) {
	                            options[name] = value.elements.map(to_string);
	                        } else if (value instanceof AST_RegExp) {
	                            value = value.value;
	                            options[name] = new RegExp(value.source, value.flags);
	                        } else {
	                            options[name] = to_string(value);
	                        }
	                        return true;
	                    }
	                    if (node instanceof AST_Symbol || node instanceof AST_PropAccess) {
	                        var name = node.print_to_string();
	                        options[name] = true;
	                        return true;
	                    }
	                    if (!(node instanceof AST_Sequence)) throw node;

	                    function to_string(value) {
	                        return value instanceof AST_Constant ? value.getValue() : value.print_to_string({
	                            quote_keys: true
	                        });
	                    }
	                });
	            } catch(ex) {
	                if (flag) {
	                    fatal("Error parsing arguments for '" + flag + "': " + value);
	                } else {
	                    options[value] = null;
	                }
	            }
	            return options;
	        };
	    }

	    function symdef(def) {
	        var ret = (1e6 + def.id) + " " + def.name;
	        if (def.mangled_name) ret += " " + def.mangled_name;
	        return ret;
	    }

	    function collect_from_map(map, callback) {
	        var result = [];
	        map.forEach(function (def) {
	            result.push(callback(def));
	        });
	        return result;
	    }

	    function format_object(obj) {
	        var lines = [];
	        var padding = "";
	        Object.keys(obj).map(function(name) {
	            if (padding.length < name.length) padding = Array(name.length + 1).join(" ");
	            return [ name, JSON.stringify(obj[name]) ];
	        }).forEach(function(tokens) {
	            lines.push("  " + tokens[0] + padding.slice(tokens[0].length - 2) + tokens[1]);
	        });
	        return lines.join("\n");
	    }

	    function print_error(msg) {
	        process.stderr.write(msg);
	        process.stderr.write("\n");
	    }

	    function describe_ast() {
	        var out = OutputStream({ beautify: true });
	        function doitem(ctor) {
	            out.print("AST_" + ctor.TYPE);
	            const props = ctor.SELF_PROPS.filter(prop => !/^\$/.test(prop));

	            if (props.length > 0) {
	                out.space();
	                out.with_parens(function() {
	                    props.forEach(function(prop, i) {
	                        if (i) out.space();
	                        out.print(prop);
	                    });
	                });
	            }

	            if (ctor.documentation) {
	                out.space();
	                out.print_string(ctor.documentation);
	            }

	            if (ctor.SUBCLASSES.length > 0) {
	                out.space();
	                out.with_block(function() {
	                    ctor.SUBCLASSES.forEach(function(ctor) {
	                        out.indent();
	                        doitem(ctor);
	                        out.newline();
	                    });
	                });
	            }
	        }
	        doitem(AST_Node);
	        return out + "\n";
	    }
	}

	async function _default_options() {
	    const defs = {};

	    Object.keys(infer_options({ 0: 0 })).forEach((component) => {
	        const options = infer_options({
	            [component]: {0: 0}
	        });

	        if (options) defs[component] = options;
	    });
	    return defs;
	}

	async function infer_options(options) {
	    try {
	        await minify("", options);
	    } catch (error) {
	        return error.defs;
	    }
	}

	exports._default_options = _default_options;
	exports._run_cli = run_cli;
	exports.minify = minify;
	exports.minify_sync = minify_sync;

	})); 
} (bundle_min, bundle_min.exports));

var bundle_minExports = bundle_min.exports;

var CleanCSS = cleanCss;
var decode$1 = heExports.decode;
var HTMLParser = htmlparser.HTMLParser;
var endTag = htmlparser.endTag;
var RelateUrl = lib$k;
var TokenChain = tokenchain;
var Terser = bundle_minExports;
var utils$3 = utils$4;

function trimWhitespace(str) {
  return str && str.replace(/^[ \n\r\t\f]+/, '').replace(/[ \n\r\t\f]+$/, '');
}

function collapseWhitespaceAll(str) {
  // Non-breaking space is specifically handled inside the replacer function here:
  return str && str.replace(/[ \n\r\t\f\xA0]+/g, function(spaces) {
    return spaces === '\t' ? '\t' : spaces.replace(/(^|\xA0+)[^\xA0]+/g, '$1 ');
  });
}

function collapseWhitespace(str, options, trimLeft, trimRight, collapseAll) {
  var lineBreakBefore = '', lineBreakAfter = '';

  if (options.preserveLineBreaks) {
    str = str.replace(/^[ \n\r\t\f]*?[\n\r][ \n\r\t\f]*/, function() {
      lineBreakBefore = '\n';
      return '';
    }).replace(/[ \n\r\t\f]*?[\n\r][ \n\r\t\f]*$/, function() {
      lineBreakAfter = '\n';
      return '';
    });
  }

  if (trimLeft) {
    // Non-breaking space is specifically handled inside the replacer function here:
    str = str.replace(/^[ \n\r\t\f\xA0]+/, function(spaces) {
      var conservative = !lineBreakBefore && options.conservativeCollapse;
      if (conservative && spaces === '\t') {
        return '\t';
      }
      return spaces.replace(/^[^\xA0]+/, '').replace(/(\xA0+)[^\xA0]+/g, '$1 ') || (conservative ? ' ' : '');
    });
  }

  if (trimRight) {
    // Non-breaking space is specifically handled inside the replacer function here:
    str = str.replace(/[ \n\r\t\f\xA0]+$/, function(spaces) {
      var conservative = !lineBreakAfter && options.conservativeCollapse;
      if (conservative && spaces === '\t') {
        return '\t';
      }
      return spaces.replace(/[^\xA0]+(\xA0+)/g, ' $1').replace(/[^\xA0]+$/, '') || (conservative ? ' ' : '');
    });
  }

  if (collapseAll) {
    // strip non space whitespace then compress spaces to one
    str = collapseWhitespaceAll(str);
  }

  return lineBreakBefore + str + lineBreakAfter;
}

var createMapFromString = utils$3.createMapFromString;
// non-empty tags that will maintain whitespace around them
var inlineTags = createMapFromString('a,abbr,acronym,b,bdi,bdo,big,button,cite,code,del,dfn,em,font,i,ins,kbd,label,mark,math,nobr,object,q,rp,rt,rtc,ruby,s,samp,select,small,span,strike,strong,sub,sup,svg,textarea,time,tt,u,var');
// non-empty tags that will maintain whitespace within them
var inlineTextTags = createMapFromString('a,abbr,acronym,b,big,del,em,font,i,ins,kbd,mark,nobr,rp,s,samp,small,span,strike,strong,sub,sup,time,tt,u,var');
// self-closing tags that will maintain whitespace around them
var selfClosingInlineTags = createMapFromString('comment,img,input,wbr');

function collapseWhitespaceSmart(str, prevTag, nextTag, options) {
  var trimLeft = prevTag && !selfClosingInlineTags(prevTag);
  if (trimLeft && !options.collapseInlineTagWhitespace) {
    trimLeft = prevTag.charAt(0) === '/' ? !inlineTags(prevTag.slice(1)) : !inlineTextTags(prevTag);
  }
  var trimRight = nextTag && !selfClosingInlineTags(nextTag);
  if (trimRight && !options.collapseInlineTagWhitespace) {
    trimRight = nextTag.charAt(0) === '/' ? !inlineTextTags(nextTag.slice(1)) : !inlineTags(nextTag);
  }
  return collapseWhitespace(str, options, trimLeft, trimRight, prevTag && nextTag);
}

function isConditionalComment(text) {
  return /^\[if\s[^\]]+]|\[endif]$/.test(text);
}

function isIgnoredComment(text, options) {
  for (var i = 0, len = options.ignoreCustomComments.length; i < len; i++) {
    if (options.ignoreCustomComments[i].test(text)) {
      return true;
    }
  }
  return false;
}

function isEventAttribute(attrName, options) {
  var patterns = options.customEventAttributes;
  if (patterns) {
    for (var i = patterns.length; i--;) {
      if (patterns[i].test(attrName)) {
        return true;
      }
    }
    return false;
  }
  return /^on[a-z]{3,}$/.test(attrName);
}

function canRemoveAttributeQuotes(value) {
  // https://mathiasbynens.be/notes/unquoted-attribute-values
  return /^[^ \t\n\f\r"'`=<>]+$/.test(value);
}

function attributesInclude(attributes, attribute) {
  for (var i = attributes.length; i--;) {
    if (attributes[i].name.toLowerCase() === attribute) {
      return true;
    }
  }
  return false;
}

function isAttributeRedundant(tag, attrName, attrValue, attrs) {
  attrValue = attrValue ? trimWhitespace(attrValue.toLowerCase()) : '';

  return (
    tag === 'script' &&
    attrName === 'language' &&
    attrValue === 'javascript' ||

    tag === 'form' &&
    attrName === 'method' &&
    attrValue === 'get' ||

    tag === 'input' &&
    attrName === 'type' &&
    attrValue === 'text' ||

    tag === 'script' &&
    attrName === 'charset' &&
    !attributesInclude(attrs, 'src') ||

    tag === 'a' &&
    attrName === 'name' &&
    attributesInclude(attrs, 'id') ||

    tag === 'area' &&
    attrName === 'shape' &&
    attrValue === 'rect'
  );
}

// https://mathiasbynens.be/demo/javascript-mime-type
// https://developer.mozilla.org/en/docs/Web/HTML/Element/script#attr-type
var executableScriptsMimetypes = utils$3.createMap([
  'text/javascript',
  'text/ecmascript',
  'text/jscript',
  'application/javascript',
  'application/x-javascript',
  'application/ecmascript',
  'module'
]);

var keepScriptsMimetypes = utils$3.createMap([
  'module'
]);

function isScriptTypeAttribute(attrValue) {
  attrValue = trimWhitespace(attrValue.split(/;/, 2)[0]).toLowerCase();
  return attrValue === '' || executableScriptsMimetypes(attrValue);
}

function keepScriptTypeAttribute(attrValue) {
  attrValue = trimWhitespace(attrValue.split(/;/, 2)[0]).toLowerCase();
  return keepScriptsMimetypes(attrValue);
}

function isExecutableScript(tag, attrs) {
  if (tag !== 'script') {
    return false;
  }
  for (var i = 0, len = attrs.length; i < len; i++) {
    var attrName = attrs[i].name.toLowerCase();
    if (attrName === 'type') {
      return isScriptTypeAttribute(attrs[i].value);
    }
  }
  return true;
}

function isStyleLinkTypeAttribute(attrValue) {
  attrValue = trimWhitespace(attrValue).toLowerCase();
  return attrValue === '' || attrValue === 'text/css';
}

function isStyleSheet(tag, attrs) {
  if (tag !== 'style') {
    return false;
  }
  for (var i = 0, len = attrs.length; i < len; i++) {
    var attrName = attrs[i].name.toLowerCase();
    if (attrName === 'type') {
      return isStyleLinkTypeAttribute(attrs[i].value);
    }
  }
  return true;
}

var isSimpleBoolean = createMapFromString('allowfullscreen,async,autofocus,autoplay,checked,compact,controls,declare,default,defaultchecked,defaultmuted,defaultselected,defer,disabled,enabled,formnovalidate,hidden,indeterminate,inert,ismap,itemscope,loop,multiple,muted,nohref,noresize,noshade,novalidate,nowrap,open,pauseonexit,readonly,required,reversed,scoped,seamless,selected,sortable,truespeed,typemustmatch,visible');
var isBooleanValue = createMapFromString('true,false');

function isBooleanAttribute(attrName, attrValue) {
  return isSimpleBoolean(attrName) || attrName === 'draggable' && !isBooleanValue(attrValue);
}

function isUriTypeAttribute(attrName, tag) {
  return (
    /^(?:a|area|link|base)$/.test(tag) && attrName === 'href' ||
    tag === 'img' && /^(?:src|longdesc|usemap)$/.test(attrName) ||
    tag === 'object' && /^(?:classid|codebase|data|usemap)$/.test(attrName) ||
    tag === 'q' && attrName === 'cite' ||
    tag === 'blockquote' && attrName === 'cite' ||
    (tag === 'ins' || tag === 'del') && attrName === 'cite' ||
    tag === 'form' && attrName === 'action' ||
    tag === 'input' && (attrName === 'src' || attrName === 'usemap') ||
    tag === 'head' && attrName === 'profile' ||
    tag === 'script' && (attrName === 'src' || attrName === 'for')
  );
}

function isNumberTypeAttribute(attrName, tag) {
  return (
    /^(?:a|area|object|button)$/.test(tag) && attrName === 'tabindex' ||
    tag === 'input' && (attrName === 'maxlength' || attrName === 'tabindex') ||
    tag === 'select' && (attrName === 'size' || attrName === 'tabindex') ||
    tag === 'textarea' && /^(?:rows|cols|tabindex)$/.test(attrName) ||
    tag === 'colgroup' && attrName === 'span' ||
    tag === 'col' && attrName === 'span' ||
    (tag === 'th' || tag === 'td') && (attrName === 'rowspan' || attrName === 'colspan')
  );
}

function isLinkType(tag, attrs, value) {
  if (tag !== 'link') {
    return false;
  }
  for (var i = 0, len = attrs.length; i < len; i++) {
    if (attrs[i].name === 'rel' && attrs[i].value === value) {
      return true;
    }
  }
}

function isMediaQuery(tag, attrs, attrName) {
  return attrName === 'media' && (isLinkType(tag, attrs, 'stylesheet') || isStyleSheet(tag, attrs));
}

var srcsetTags = createMapFromString('img,source');

function isSrcset(attrName, tag) {
  return attrName === 'srcset' && srcsetTags(tag);
}

async function cleanAttributeValue(tag, attrName, attrValue, options, attrs) {
  if (isEventAttribute(attrName, options)) {
    attrValue = trimWhitespace(attrValue).replace(/^javascript:\s*/i, '');
    return await options.minifyJS(attrValue, true);
  }
  else if (attrName === 'class') {
    attrValue = trimWhitespace(attrValue);
    if (options.sortClassName) {
      attrValue = options.sortClassName(attrValue);
    }
    else {
      attrValue = collapseWhitespaceAll(attrValue);
    }
    return attrValue;
  }
  else if (isUriTypeAttribute(attrName, tag)) {
    attrValue = trimWhitespace(attrValue);
    return isLinkType(tag, attrs, 'canonical') ? attrValue : options.minifyURLs(attrValue);
  }
  else if (isNumberTypeAttribute(attrName, tag)) {
    return trimWhitespace(attrValue);
  }
  else if (attrName === 'style') {
    attrValue = trimWhitespace(attrValue);
    if (attrValue) {
      if (/;$/.test(attrValue) && !/&#?[0-9a-zA-Z]+;$/.test(attrValue)) {
        attrValue = attrValue.replace(/\s*;$/, ';');
      }
      attrValue = options.minifyCSS(attrValue, 'inline');
    }
    return attrValue;
  }
  else if (isSrcset(attrName, tag)) {
    // https://html.spec.whatwg.org/multipage/embedded-content.html#attr-img-srcset
    attrValue = trimWhitespace(attrValue).split(/\s+,\s*|\s*,\s+/).map(function(candidate) {
      var url = candidate;
      var descriptor = '';
      var match = candidate.match(/\s+([1-9][0-9]*w|[0-9]+(?:\.[0-9]+)?x)$/);
      if (match) {
        url = url.slice(0, -match[0].length);
        var num = +match[1].slice(0, -1);
        var suffix = match[1].slice(-1);
        if (num !== 1 || suffix !== 'x') {
          descriptor = ' ' + num + suffix;
        }
      }
      return options.minifyURLs(url) + descriptor;
    }).join(', ');
  }
  else if (isMetaViewport(tag, attrs) && attrName === 'content') {
    attrValue = attrValue.replace(/\s+/g, '').replace(/[0-9]+\.[0-9]+/g, function(numString) {
      // "0.90000" -> "0.9"
      // "1.0" -> "1"
      // "1.0001" -> "1.0001" (unchanged)
      return (+numString).toString();
    });
  }
  else if (isContentSecurityPolicy(tag, attrs) && attrName.toLowerCase() === 'content') {
    return collapseWhitespaceAll(attrValue);
  }
  else if (options.customAttrCollapse && options.customAttrCollapse.test(attrName)) {
    attrValue = trimWhitespace(attrValue.replace(/ ?[\n\r]+ ?/g, '').replace(/\s{2,}/g, options.conservativeCollapse ? ' ' : ''));
  }
  else if (tag === 'script' && attrName === 'type') {
    attrValue = trimWhitespace(attrValue.replace(/\s*;\s*/g, ';'));
  }
  else if (isMediaQuery(tag, attrs, attrName)) {
    attrValue = trimWhitespace(attrValue);
    return options.minifyCSS(attrValue, 'media');
  }
  return attrValue;
}

function isMetaViewport(tag, attrs) {
  if (tag !== 'meta') {
    return false;
  }
  for (var i = 0, len = attrs.length; i < len; i++) {
    if (attrs[i].name === 'name' && attrs[i].value === 'viewport') {
      return true;
    }
  }
}

function isContentSecurityPolicy(tag, attrs) {
  if (tag !== 'meta') {
    return false;
  }
  for (var i = 0, len = attrs.length; i < len; i++) {
    if (attrs[i].name.toLowerCase() === 'http-equiv' && attrs[i].value.toLowerCase() === 'content-security-policy') {
      return true;
    }
  }
}

function ignoreCSS(id) {
  return '/* clean-css ignore:start */' + id + '/* clean-css ignore:end */';
}

// Wrap CSS declarations for CleanCSS > 3.x
// See https://github.com/jakubpawlowicz/clean-css/issues/418
function wrapCSS(text, type) {
  switch (type) {
    case 'inline':
      return '*{' + text + '}';
    case 'media':
      return '@media ' + text + '{a{top:0}}';
    default:
      return text;
  }
}

function unwrapCSS(text, type) {
  var matches;
  switch (type) {
    case 'inline':
      matches = text.match(/^\*\{([\s\S]*)\}$/);
      break;
    case 'media':
      matches = text.match(/^@media ([\s\S]*?)\s*{[\s\S]*}$/);
      break;
  }
  return matches ? matches[1] : text;
}

async function cleanConditionalComment(comment, options) {
  return options.processConditionalComments ? await utils$3.replaceAsync(comment, /^(\[if\s[^\]]+]>)([\s\S]*?)(<!\[endif])$/, async function(match, prefix, text, suffix) {
    return prefix + await minify(text, options, true) + suffix;
  }) : comment;
}

async function processScript(text, options, currentAttrs) {
  for (var i = 0, len = currentAttrs.length; i < len; i++) {
    if (currentAttrs[i].name.toLowerCase() === 'type' &&
        options.processScripts.indexOf(currentAttrs[i].value) > -1) {
      return await minify(text, options);
    }
  }
  return text;
}

// Tag omission rules from https://html.spec.whatwg.org/multipage/syntax.html#optional-tags
// with the following deviations:
// - retain <body> if followed by <noscript>
// - </rb>, </rt>, </rtc>, </rp> & </tfoot> follow https://www.w3.org/TR/html5/syntax.html#optional-tags
// - retain all tags which are adjacent to non-standard HTML tags
var optionalStartTags = createMapFromString('html,head,body,colgroup,tbody');
var optionalEndTags = createMapFromString('html,head,body,li,dt,dd,p,rb,rt,rtc,rp,optgroup,option,colgroup,caption,thead,tbody,tfoot,tr,td,th');
var headerTags = createMapFromString('meta,link,script,style,template,noscript');
var descriptionTags = createMapFromString('dt,dd');
var pBlockTags = createMapFromString('address,article,aside,blockquote,details,div,dl,fieldset,figcaption,figure,footer,form,h1,h2,h3,h4,h5,h6,header,hgroup,hr,main,menu,nav,ol,p,pre,section,table,ul');
var pInlineTags = createMapFromString('a,audio,del,ins,map,noscript,video');
var rubyTags = createMapFromString('rb,rt,rtc,rp');
var rtcTag = createMapFromString('rb,rtc,rp');
var optionTag = createMapFromString('option,optgroup');
var tableContentTags = createMapFromString('tbody,tfoot');
var tableSectionTags = createMapFromString('thead,tbody,tfoot');
var cellTags = createMapFromString('td,th');
var topLevelTags = createMapFromString('html,head,body');
var compactTags = createMapFromString('html,body');
var looseTags = createMapFromString('head,colgroup,caption');
var trailingTags = createMapFromString('dt,thead');
var htmlTags = createMapFromString('a,abbr,acronym,address,applet,area,article,aside,audio,b,base,basefont,bdi,bdo,bgsound,big,blink,blockquote,body,br,button,canvas,caption,center,cite,code,col,colgroup,command,content,data,datalist,dd,del,details,dfn,dialog,dir,div,dl,dt,element,em,embed,fieldset,figcaption,figure,font,footer,form,frame,frameset,h1,h2,h3,h4,h5,h6,head,header,hgroup,hr,html,i,iframe,image,img,input,ins,isindex,kbd,keygen,label,legend,li,link,listing,main,map,mark,marquee,menu,menuitem,meta,meter,multicol,nav,nobr,noembed,noframes,noscript,object,ol,optgroup,option,output,p,param,picture,plaintext,pre,progress,q,rb,rp,rt,rtc,ruby,s,samp,script,section,select,shadow,small,source,spacer,span,strike,strong,style,sub,summary,sup,table,tbody,td,template,textarea,tfoot,th,thead,time,title,tr,track,tt,u,ul,var,video,wbr,xmp');

function canRemoveParentTag(optionalStartTag, tag) {
  switch (optionalStartTag) {
    case 'html':
    case 'head':
      return true;
    case 'body':
      return !headerTags(tag);
    case 'colgroup':
      return tag === 'col';
    case 'tbody':
      return tag === 'tr';
  }
  return false;
}

function isStartTagMandatory(optionalEndTag, tag) {
  switch (tag) {
    case 'colgroup':
      return optionalEndTag === 'colgroup';
    case 'tbody':
      return tableSectionTags(optionalEndTag);
  }
  return false;
}

function canRemovePrecedingTag(optionalEndTag, tag) {
  switch (optionalEndTag) {
    case 'html':
    case 'head':
    case 'body':
    case 'colgroup':
    case 'caption':
      return true;
    case 'li':
    case 'optgroup':
    case 'tr':
      return tag === optionalEndTag;
    case 'dt':
    case 'dd':
      return descriptionTags(tag);
    case 'p':
      return pBlockTags(tag);
    case 'rb':
    case 'rt':
    case 'rp':
      return rubyTags(tag);
    case 'rtc':
      return rtcTag(tag);
    case 'option':
      return optionTag(tag);
    case 'thead':
    case 'tbody':
      return tableContentTags(tag);
    case 'tfoot':
      return tag === 'tbody';
    case 'td':
    case 'th':
      return cellTags(tag);
  }
  return false;
}

var reEmptyAttribute = new RegExp(
  '^(?:class|id|style|title|lang|dir|on(?:focus|blur|change|click|dblclick|mouse(' +
    '?:down|up|over|move|out)|key(?:press|down|up)))$');

function canDeleteEmptyAttribute(tag, attrName, attrValue, options) {
  var isValueEmpty = !attrValue || /^\s*$/.test(attrValue);
  if (!isValueEmpty) {
    return false;
  }
  if (typeof options.removeEmptyAttributes === 'function') {
    return options.removeEmptyAttributes(attrName, tag);
  }
  return tag === 'input' && attrName === 'value' || reEmptyAttribute.test(attrName);
}

function hasAttrName(name, attrs) {
  for (var i = attrs.length - 1; i >= 0; i--) {
    if (attrs[i].name === name) {
      return true;
    }
  }
  return false;
}

function canRemoveElement(tag, attrs) {
  switch (tag) {
    case 'textarea':
      return false;
    case 'audio':
    case 'script':
    case 'video':
      if (hasAttrName('src', attrs)) {
        return false;
      }
      break;
    case 'iframe':
      if (hasAttrName('src', attrs) || hasAttrName('srcdoc', attrs)) {
        return false;
      }
      break;
    case 'object':
      if (hasAttrName('data', attrs)) {
        return false;
      }
      break;
    case 'applet':
      if (hasAttrName('code', attrs)) {
        return false;
      }
      break;
  }
  return true;
}

function canCollapseWhitespace(tag) {
  return !/^(?:script|style|pre|textarea)$/.test(tag);
}

function canTrimWhitespace(tag) {
  return !/^(?:pre|textarea)$/.test(tag);
}

async function normalizeAttr(attr, attrs, tag, options) {
  var attrName = options.name(attr.name),
      attrValue = attr.value;

  if (options.decodeEntities && attrValue) {
    attrValue = decode$1(attrValue, { isAttributeValue: true });
  }

  if (options.removeRedundantAttributes &&
    isAttributeRedundant(tag, attrName, attrValue, attrs) ||
    options.removeScriptTypeAttributes && tag === 'script' &&
    attrName === 'type' && isScriptTypeAttribute(attrValue) && !keepScriptTypeAttribute(attrValue) ||
    options.removeStyleLinkTypeAttributes && (tag === 'style' || tag === 'link') &&
    attrName === 'type' && isStyleLinkTypeAttribute(attrValue)) {
    return;
  }

  if (attrValue) {
    attrValue = await cleanAttributeValue(tag, attrName, attrValue, options, attrs);
  }

  if (options.removeEmptyAttributes &&
      canDeleteEmptyAttribute(tag, attrName, attrValue, options)) {
    return;
  }

  if (options.decodeEntities && attrValue) {
    attrValue = attrValue.replace(/&(#?[0-9a-zA-Z]+;)/g, '&amp;$1');
  }

  return {
    attr: attr,
    name: attrName,
    value: attrValue
  };
}

function buildAttr(normalized, hasUnarySlash, options, isLast, uidAttr) {
  var attrName = normalized.name,
      attrValue = normalized.value,
      attr = normalized.attr,
      attrQuote = attr.quote,
      attrFragment,
      emittedAttrValue;

  if (typeof attrValue !== 'undefined' && (!options.removeAttributeQuotes ||
      ~attrValue.indexOf(uidAttr) || !canRemoveAttributeQuotes(attrValue))) {
    if (!options.preventAttributesEscaping) {
      if (typeof options.quoteCharacter === 'undefined') {
        var apos = (attrValue.match(/'/g) || []).length;
        var quot = (attrValue.match(/"/g) || []).length;
        attrQuote = apos < quot ? '\'' : '"';
      }
      else {
        attrQuote = options.quoteCharacter === '\'' ? '\'' : '"';
      }
      if (attrQuote === '"') {
        attrValue = attrValue.replace(/"/g, '&#34;');
      }
      else {
        attrValue = attrValue.replace(/'/g, '&#39;');
      }
    }
    emittedAttrValue = attrQuote + attrValue + attrQuote;
    if (!isLast && !options.removeTagWhitespace) {
      emittedAttrValue += ' ';
    }
  }
  // make sure trailing slash is not interpreted as HTML self-closing tag
  else if (isLast && !hasUnarySlash && !/\/$/.test(attrValue)) {
    emittedAttrValue = attrValue;
  }
  else {
    emittedAttrValue = attrValue + ' ';
  }

  if (typeof attrValue === 'undefined' || options.collapseBooleanAttributes &&
      isBooleanAttribute(attrName.toLowerCase(), attrValue.toLowerCase())) {
    attrFragment = attrName;
    if (!isLast) {
      attrFragment += ' ';
    }
  }
  else {
    attrFragment = attrName + attr.customAssign + emittedAttrValue;
  }

  return attr.customOpen + attrFragment + attr.customClose;
}

function identity(value) {
  return value;
}

function processOptions(values) {
  var options = {
    name: function(name) {
      return name.toLowerCase();
    },
    canCollapseWhitespace: canCollapseWhitespace,
    canTrimWhitespace: canTrimWhitespace,
    html5: true,
    ignoreCustomComments: [
      /^!/,
      /^\s*#/
    ],
    ignoreCustomFragments: [
      /<%[\s\S]*?%>/,
      /<\?[\s\S]*?\?>/
    ],
    includeAutoGeneratedTags: true,
    log: identity,
    minifyCSS: identity,
    minifyJS: identity,
    minifyURLs: identity
  };
  Object.keys(values).forEach(function(key) {
    var value = values[key];
    if (key === 'caseSensitive') {
      if (value) {
        options.name = identity;
      }
    }
    else if (key === 'log') {
      if (typeof value === 'function') {
        options.log = value;
      }
    }
    else if (key === 'minifyCSS' && typeof value !== 'function') {
      if (!value) {
        return;
      }
      if (typeof value !== 'object') {
        value = {};
      }
      options.minifyCSS = function(text, type) {
        text = text.replace(/(url\s*\(\s*)("|'|)(.*?)\2(\s*\))/ig, function(match, prefix, quote, url, suffix) {
          return prefix + quote + options.minifyURLs(url) + quote + suffix;
        });
        var cleanCssOutput = new CleanCSS(value).minify(wrapCSS(text, type));
        if (cleanCssOutput.errors.length > 0) {
          cleanCssOutput.errors.forEach(options.log);
          return text;
        }
        return unwrapCSS(cleanCssOutput.styles, type);
      };
    }
    else if (key === 'minifyJS' && typeof value !== 'function') {
      if (!value) {
        return;
      }
      if (typeof value !== 'object') {
        value = {};
      }
      (value.parse || (value.parse = {})).bare_returns = false;
      options.minifyJS = async function(text, inline) {
        var start = text.match(/^\s*<!--.*/);
        var code = start ? text.slice(start[0].length).replace(/\n\s*-->\s*$/, '') : text;
        value.parse.bare_returns = inline;
        try {
          const result = await Terser.minify(code, value);
          return result.code.replace(/;$/, '');
        }
        catch (error) {
          options.log(error);
          return text;
        }
      };
    }
    else if (key === 'minifyURLs' && typeof value !== 'function') {
      if (!value) {
        return;
      }
      if (typeof value === 'string') {
        value = { site: value };
      }
      else if (typeof value !== 'object') {
        value = {};
      }
      options.minifyURLs = function(text) {
        try {
          return RelateUrl.relate(text, value);
        }
        catch (err) {
          options.log(err);
          return text;
        }
      };
    }
    else {
      options[key] = value;
    }
  });
  return options;
}

function uniqueId(value) {
  var id;
  do {
    id = Math.random().toString(36).replace(/^0\.[0-9]*/, '');
  } while (~value.indexOf(id));
  return id;
}

var specialContentTags = createMapFromString('script,style');

async function createSortFns(value, options, uidIgnore, uidAttr) {
  var attrChains = options.sortAttributes && Object.create(null);
  var classChain = options.sortClassName && new TokenChain();

  function attrNames(attrs) {
    return attrs.map(function(attr) {
      return options.name(attr.name);
    });
  }

  function shouldSkipUID(token, uid) {
    return !uid || token.indexOf(uid) === -1;
  }

  function shouldSkipUIDs(token) {
    return shouldSkipUID(token, uidIgnore) && shouldSkipUID(token, uidAttr);
  }

  async function scan(input) {
    var currentTag, currentType;
    const parser = new HTMLParser(input, {
      start: function(tag, attrs) {
        if (attrChains) {
          if (!attrChains[tag]) {
            attrChains[tag] = new TokenChain();
          }
          attrChains[tag].add(attrNames(attrs).filter(shouldSkipUIDs));
        }
        for (var i = 0, len = attrs.length; i < len; i++) {
          var attr = attrs[i];
          if (classChain && attr.value && options.name(attr.name) === 'class') {
            classChain.add(trimWhitespace(attr.value).split(/[ \t\n\f\r]+/).filter(shouldSkipUIDs));
          }
          else if (options.processScripts && attr.name.toLowerCase() === 'type') {
            currentTag = tag;
            currentType = attr.value;
          }
        }
      },
      end: function() {
        currentTag = '';
      },
      chars: async function(text) {
        if (options.processScripts && specialContentTags(currentTag) &&
            options.processScripts.indexOf(currentType) > -1) {
          await scan(text);
        }
      }
    });

    await parser.parse();
  }

  var log = options.log;
  options.log = identity;
  options.sortAttributes = false;
  options.sortClassName = false;
  await scan(await minify(value, options));
  options.log = log;
  if (attrChains) {
    var attrSorters = Object.create(null);
    for (var tag in attrChains) {
      attrSorters[tag] = attrChains[tag].createSorter();
    }
    options.sortAttributes = function(tag, attrs) {
      var sorter = attrSorters[tag];
      if (sorter) {
        var attrMap = Object.create(null);
        var names = attrNames(attrs);
        names.forEach(function(name, index) {
          (attrMap[name] || (attrMap[name] = [])).push(attrs[index]);
        });
        sorter.sort(names).forEach(function(name, index) {
          attrs[index] = attrMap[name].shift();
        });
      }
    };
  }
  if (classChain) {
    var sorter = classChain.createSorter();
    options.sortClassName = function(value) {
      return sorter.sort(value.split(/[ \n\f\r]+/)).join(' ');
    };
  }
}

async function minify(value, options, partialMarkup) {
  if (options.collapseWhitespace) {
    value = collapseWhitespace(value, options, true, true);
  }

  var buffer = [],
      charsPrevTag,
      currentChars = '',
      hasChars,
      currentTag = '',
      currentAttrs = [],
      stackNoTrimWhitespace = [],
      stackNoCollapseWhitespace = [],
      optionalStartTag = '',
      optionalEndTag = '',
      ignoredMarkupChunks = [],
      ignoredCustomMarkupChunks = [],
      uidIgnore,
      uidAttr,
      uidPattern;

  // temporarily replace ignored chunks with comments,
  // so that we don't have to worry what's there.
  // for all we care there might be
  // completely-horribly-broken-alien-non-html-emoj-cthulhu-filled content
  value = value.replace(/<!-- htmlmin:ignore -->([\s\S]*?)<!-- htmlmin:ignore -->/g, function(match, group1) {
    if (!uidIgnore) {
      uidIgnore = uniqueId(value);
      var pattern = new RegExp('^' + uidIgnore + '([0-9]+)$');
      if (options.ignoreCustomComments) {
        options.ignoreCustomComments = options.ignoreCustomComments.slice();
      }
      else {
        options.ignoreCustomComments = [];
      }
      options.ignoreCustomComments.push(pattern);
    }
    var token = '<!--' + uidIgnore + ignoredMarkupChunks.length + '-->';
    ignoredMarkupChunks.push(group1);
    return token;
  });

  var customFragments = options.ignoreCustomFragments.map(function(re) {
    return re.source;
  });
  if (customFragments.length) {
    var reCustomIgnore = new RegExp('\\s*(?:' + customFragments.join('|') + ')+\\s*', 'g');
    // temporarily replace custom ignored fragments with unique attributes
    value = value.replace(reCustomIgnore, function(match) {
      if (!uidAttr) {
        uidAttr = uniqueId(value);
        uidPattern = new RegExp('(\\s*)' + uidAttr + '([0-9]+)' + uidAttr + '(\\s*)', 'g');
        if (options.minifyCSS) {
          options.minifyCSS = (function(fn) {
            return function(text, type) {
              text = text.replace(uidPattern, function(match, prefix, index) {
                var chunks = ignoredCustomMarkupChunks[+index];
                return chunks[1] + uidAttr + index + uidAttr + chunks[2];
              });
              var ids = [];
              new CleanCSS().minify(wrapCSS(text, type)).warnings.forEach(function(warning) {
                var match = uidPattern.exec(warning);
                if (match) {
                  var id = uidAttr + match[2] + uidAttr;
                  text = text.replace(id, ignoreCSS(id));
                  ids.push(id);
                }
              });
              text = fn(text, type);
              ids.forEach(function(id) {
                text = text.replace(ignoreCSS(id), id);
              });
              return text;
            };
          })(options.minifyCSS);
        }
        if (options.minifyJS) {
          options.minifyJS = (function(fn) {
            return function(text, type) {
              return fn(text.replace(uidPattern, function(match, prefix, index) {
                var chunks = ignoredCustomMarkupChunks[+index];
                return chunks[1] + uidAttr + index + uidAttr + chunks[2];
              }), type);
            };
          })(options.minifyJS);
        }
      }
      var token = uidAttr + ignoredCustomMarkupChunks.length + uidAttr;
      ignoredCustomMarkupChunks.push(/^(\s*)[\s\S]*?(\s*)$/.exec(match));
      return '\t' + token + '\t';
    });
  }

  if (options.sortAttributes && typeof options.sortAttributes !== 'function' ||
      options.sortClassName && typeof options.sortClassName !== 'function') {
    await createSortFns(value, options, uidIgnore, uidAttr);
  }

  function _canCollapseWhitespace(tag, attrs) {
    return options.canCollapseWhitespace(tag, attrs, canCollapseWhitespace);
  }

  function _canTrimWhitespace(tag, attrs) {
    return options.canTrimWhitespace(tag, attrs, canTrimWhitespace);
  }

  function removeStartTag() {
    var index = buffer.length - 1;
    while (index > 0 && !/^<[^/!]/.test(buffer[index])) {
      index--;
    }
    buffer.length = Math.max(0, index);
  }

  function removeEndTag() {
    var index = buffer.length - 1;
    while (index > 0 && !/^<\//.test(buffer[index])) {
      index--;
    }
    buffer.length = Math.max(0, index);
  }

  // look for trailing whitespaces, bypass any inline tags
  function trimTrailingWhitespace(index, nextTag) {
    for (var endTag = null; index >= 0 && _canTrimWhitespace(endTag); index--) {
      var str = buffer[index];
      var match = str.match(/^<\/([\w:-]+)>$/);
      if (match) {
        endTag = match[1];
      }
      else if (/>$/.test(str) || (buffer[index] = collapseWhitespaceSmart(str, null, nextTag, options))) {
        break;
      }
    }
  }

  // look for trailing whitespaces from previously processed text
  // which may not be trimmed due to a following comment or an empty
  // element which has now been removed
  function squashTrailingWhitespace(nextTag) {
    var charsIndex = buffer.length - 1;
    if (buffer.length > 1) {
      var item = buffer[buffer.length - 1];
      if (/^(?:<!|$)/.test(item) && item.indexOf(uidIgnore) === -1) {
        charsIndex--;
      }
    }
    trimTrailingWhitespace(charsIndex, nextTag);
  }

  const parser = new HTMLParser(value, {
    partialMarkup: partialMarkup,
    continueOnParseError: options.continueOnParseError,
    customAttrAssign: options.customAttrAssign,
    customAttrSurround: options.customAttrSurround,
    html5: options.html5,

    start: async function(tag, attrs, unary, unarySlash, autoGenerated) {
      if (tag.toLowerCase() === 'svg') {
        options = Object.create(options);
        options.caseSensitive = true;
        options.keepClosingSlash = true;
        options.name = identity;
      }
      tag = options.name(tag);
      currentTag = tag;
      charsPrevTag = tag;
      if (!inlineTextTags(tag)) {
        currentChars = '';
      }
      hasChars = false;
      currentAttrs = attrs;

      var optional = options.removeOptionalTags;
      if (optional) {
        var htmlTag = htmlTags(tag);
        // <html> may be omitted if first thing inside is not comment
        // <head> may be omitted if first thing inside is an element
        // <body> may be omitted if first thing inside is not space, comment, <meta>, <link>, <script>, <style> or <template>
        // <colgroup> may be omitted if first thing inside is <col>
        // <tbody> may be omitted if first thing inside is <tr>
        if (htmlTag && canRemoveParentTag(optionalStartTag, tag)) {
          removeStartTag();
        }
        optionalStartTag = '';
        // end-tag-followed-by-start-tag omission rules
        if (htmlTag && canRemovePrecedingTag(optionalEndTag, tag)) {
          removeEndTag();
          // <colgroup> cannot be omitted if preceding </colgroup> is omitted
          // <tbody> cannot be omitted if preceding </tbody>, </thead> or </tfoot> is omitted
          optional = !isStartTagMandatory(optionalEndTag, tag);
        }
        optionalEndTag = '';
      }

      // set whitespace flags for nested tags (eg. <code> within a <pre>)
      if (options.collapseWhitespace) {
        if (!stackNoTrimWhitespace.length) {
          squashTrailingWhitespace(tag);
        }
        if (!unary) {
          if (!_canTrimWhitespace(tag, attrs) || stackNoTrimWhitespace.length) {
            stackNoTrimWhitespace.push(tag);
          }
          if (!_canCollapseWhitespace(tag, attrs) || stackNoCollapseWhitespace.length) {
            stackNoCollapseWhitespace.push(tag);
          }
        }
      }

      var openTag = '<' + tag;
      var hasUnarySlash = unarySlash && options.keepClosingSlash;

      buffer.push(openTag);

      if (options.sortAttributes) {
        options.sortAttributes(tag, attrs);
      }

      var parts = [];
      for (var i = attrs.length, isLast = true; --i >= 0;) {
        var normalized = await normalizeAttr(attrs[i], attrs, tag, options);
        if (normalized) {
          parts.unshift(buildAttr(normalized, hasUnarySlash, options, isLast, uidAttr));
          isLast = false;
        }
      }
      if (parts.length > 0) {
        buffer.push(' ');
        buffer.push.apply(buffer, parts);
      }
      // start tag must never be omitted if it has any attributes
      else if (optional && optionalStartTags(tag)) {
        optionalStartTag = tag;
      }

      buffer.push(buffer.pop() + (hasUnarySlash ? '/' : '') + '>');

      if (autoGenerated && !options.includeAutoGeneratedTags) {
        removeStartTag();
        optionalStartTag = '';
      }
    },
    end: function(tag, attrs, autoGenerated) {
      if (tag.toLowerCase() === 'svg') {
        options = Object.getPrototypeOf(options);
      }
      tag = options.name(tag);

      // check if current tag is in a whitespace stack
      if (options.collapseWhitespace) {
        if (stackNoTrimWhitespace.length) {
          if (tag === stackNoTrimWhitespace[stackNoTrimWhitespace.length - 1]) {
            stackNoTrimWhitespace.pop();
          }
        }
        else {
          squashTrailingWhitespace('/' + tag);
        }
        if (stackNoCollapseWhitespace.length &&
          tag === stackNoCollapseWhitespace[stackNoCollapseWhitespace.length - 1]) {
          stackNoCollapseWhitespace.pop();
        }
      }

      var isElementEmpty = false;
      if (tag === currentTag) {
        currentTag = '';
        isElementEmpty = !hasChars;
      }

      if (options.removeOptionalTags) {
        // <html>, <head> or <body> may be omitted if the element is empty
        if (isElementEmpty && topLevelTags(optionalStartTag)) {
          removeStartTag();
        }
        optionalStartTag = '';
        // </html> or </body> may be omitted if not followed by comment
        // </head> may be omitted if not followed by space or comment
        // </p> may be omitted if no more content in non-</a> parent
        // except for </dt> or </thead>, end tags may be omitted if no more content in parent element
        if (htmlTags(tag) && optionalEndTag && !trailingTags(optionalEndTag) && (optionalEndTag !== 'p' || !pInlineTags(tag))) {
          removeEndTag();
        }
        optionalEndTag = optionalEndTags(tag) ? tag : '';
      }

      if (options.removeEmptyElements && isElementEmpty && canRemoveElement(tag, attrs)) {
        // remove last "element" from buffer
        removeStartTag();
        optionalStartTag = '';
        optionalEndTag = '';
      }
      else {
        if (autoGenerated && !options.includeAutoGeneratedTags) {
          optionalEndTag = '';
        }
        else {
          buffer.push('</' + tag + '>');
        }
        charsPrevTag = '/' + tag;
        if (!inlineTags(tag)) {
          currentChars = '';
        }
        else if (isElementEmpty) {
          currentChars += '|';
        }
      }
    },
    chars: async function(text, prevTag, nextTag) {
      prevTag = prevTag === '' ? 'comment' : prevTag;
      nextTag = nextTag === '' ? 'comment' : nextTag;
      if (options.decodeEntities && text && !specialContentTags(currentTag)) {
        text = decode$1(text);
      }
      if (options.collapseWhitespace) {
        if (!stackNoTrimWhitespace.length) {
          if (prevTag === 'comment') {
            var prevComment = buffer[buffer.length - 1];
            if (prevComment.indexOf(uidIgnore) === -1) {
              if (!prevComment) {
                prevTag = charsPrevTag;
              }
              if (buffer.length > 1 && (!prevComment || !options.conservativeCollapse && / $/.test(currentChars))) {
                var charsIndex = buffer.length - 2;
                buffer[charsIndex] = buffer[charsIndex].replace(/\s+$/, function(trailingSpaces) {
                  text = trailingSpaces + text;
                  return '';
                });
              }
            }
          }
          if (prevTag) {
            if (prevTag === '/nobr' || prevTag === 'wbr') {
              if (/^\s/.test(text)) {
                var tagIndex = buffer.length - 1;
                while (tagIndex > 0 && buffer[tagIndex].lastIndexOf('<' + prevTag) !== 0) {
                  tagIndex--;
                }
                trimTrailingWhitespace(tagIndex - 1, 'br');
              }
            }
            else if (inlineTextTags(prevTag.charAt(0) === '/' ? prevTag.slice(1) : prevTag)) {
              text = collapseWhitespace(text, options, /(?:^|\s)$/.test(currentChars));
            }
          }
          if (prevTag || nextTag) {
            text = collapseWhitespaceSmart(text, prevTag, nextTag, options);
          }
          else {
            text = collapseWhitespace(text, options, true, true);
          }
          if (!text && /\s$/.test(currentChars) && prevTag && prevTag.charAt(0) === '/') {
            trimTrailingWhitespace(buffer.length - 1, nextTag);
          }
        }
        if (!stackNoCollapseWhitespace.length && nextTag !== 'html' && !(prevTag && nextTag)) {
          text = collapseWhitespace(text, options, false, false, true);
        }
      }
      if (options.processScripts && specialContentTags(currentTag)) {
        text = await processScript(text, options, currentAttrs);
      }
      if (isExecutableScript(currentTag, currentAttrs)) {
        text = await options.minifyJS(text);
      }
      if (isStyleSheet(currentTag, currentAttrs)) {
        text = options.minifyCSS(text);
      }
      if (options.removeOptionalTags && text) {
        // <html> may be omitted if first thing inside is not comment
        // <body> may be omitted if first thing inside is not space, comment, <meta>, <link>, <script>, <style> or <template>
        if (optionalStartTag === 'html' || optionalStartTag === 'body' && !/^\s/.test(text)) {
          removeStartTag();
        }
        optionalStartTag = '';
        // </html> or </body> may be omitted if not followed by comment
        // </head>, </colgroup> or </caption> may be omitted if not followed by space or comment
        if (compactTags(optionalEndTag) || looseTags(optionalEndTag) && !/^\s/.test(text)) {
          removeEndTag();
        }
        optionalEndTag = '';
      }
      charsPrevTag = /^\s*$/.test(text) ? prevTag : 'comment';
      if (options.decodeEntities && text && !specialContentTags(currentTag)) {
        // Escape any `&` symbols that start either:
        // 1) a legacy named character reference (i.e. one that doesn't end with `;`)
        // 2) or any other character reference (i.e. one that does end with `;`)
        // Note that `&` can be escaped as `&amp`, without the semi-colon.
        // https://mathiasbynens.be/notes/ambiguous-ampersands
        text = text.replace(/&((?:Iacute|aacute|uacute|plusmn|Otilde|otilde|agrave|Agrave|Yacute|yacute|Oslash|oslash|atilde|Atilde|brvbar|ccedil|Ccedil|Ograve|curren|divide|eacute|Eacute|ograve|Oacute|egrave|Egrave|Ugrave|frac12|frac14|frac34|ugrave|oacute|iacute|Ntilde|ntilde|Uacute|middot|igrave|Igrave|iquest|Aacute|cedil|laquo|micro|iexcl|Icirc|icirc|acirc|Ucirc|Ecirc|ocirc|Ocirc|ecirc|ucirc|Aring|aring|AElig|aelig|acute|pound|raquo|Acirc|times|THORN|szlig|thorn|COPY|auml|ordf|ordm|Uuml|macr|uuml|Auml|ouml|Ouml|para|nbsp|euml|quot|QUOT|Euml|yuml|cent|sect|copy|sup1|sup2|sup3|iuml|Iuml|ETH|shy|reg|not|yen|amp|AMP|REG|uml|eth|deg|gt|GT|LT|lt)(?!;)|(?:#?[0-9a-zA-Z]+;))/g, '&amp$1').replace(/</g, '&lt;');
      }
      if (uidPattern && options.collapseWhitespace && stackNoTrimWhitespace.length) {
        text = text.replace(uidPattern, function(match, prefix, index) {
          return ignoredCustomMarkupChunks[+index][0];
        });
      }
      currentChars += text;
      if (text) {
        hasChars = true;
      }
      buffer.push(text);
    },
    comment: async function(text, nonStandard) {
      var prefix = nonStandard ? '<!' : '<!--';
      var suffix = nonStandard ? '>' : '-->';
      if (isConditionalComment(text)) {
        text = prefix + await cleanConditionalComment(text, options) + suffix;
      }
      else if (options.removeComments) {
        if (isIgnoredComment(text, options)) {
          text = '<!--' + text + '-->';
        }
        else {
          text = '';
        }
      }
      else {
        text = prefix + text + suffix;
      }
      if (options.removeOptionalTags && text) {
        // preceding comments suppress tag omissions
        optionalStartTag = '';
        optionalEndTag = '';
      }
      buffer.push(text);
    },
    doctype: function(doctype) {
      buffer.push(options.useShortDoctype ? '<!doctype' +
        (options.removeTagWhitespace ? '' : ' ') + 'html>' :
        collapseWhitespaceAll(doctype));
    }
  });

  await parser.parse();

  if (options.removeOptionalTags) {
    // <html> may be omitted if first thing inside is not comment
    // <head> or <body> may be omitted if empty
    if (topLevelTags(optionalStartTag)) {
      removeStartTag();
    }
    // except for </dt> or </thead>, end tags may be omitted if no more content in parent element
    if (optionalEndTag && !trailingTags(optionalEndTag)) {
      removeEndTag();
    }
  }
  if (options.collapseWhitespace) {
    squashTrailingWhitespace('br');
  }

  return joinResultSegments(buffer, options, uidPattern ? function(str) {
    return str.replace(uidPattern, function(match, prefix, index, suffix) {
      var chunk = ignoredCustomMarkupChunks[+index][0];
      if (options.collapseWhitespace) {
        if (prefix !== '\t') {
          chunk = prefix + chunk;
        }
        if (suffix !== '\t') {
          chunk += suffix;
        }
        return collapseWhitespace(chunk, {
          preserveLineBreaks: options.preserveLineBreaks,
          conservativeCollapse: !options.trimCustomFragments
        }, /^[ \n\r\t\f]/.test(chunk), /[ \n\r\t\f]$/.test(chunk));
      }
      return chunk;
    });
  } : identity, uidIgnore ? function(str) {
    return str.replace(new RegExp('<!--' + uidIgnore + '([0-9]+)-->', 'g'), function(match, index) {
      return ignoredMarkupChunks[+index];
    });
  } : identity);
}

function joinResultSegments(results, options, restoreCustom, restoreIgnore) {
  var str;
  var maxLineLength = options.maxLineLength;
  var noNewlinesBeforeTagClose = options.noNewlinesBeforeTagClose;

  if (maxLineLength) {
    var line = '', lines = [];
    while (results.length) {
      var len = line.length;
      var end = results[0].indexOf('\n');
      var isClosingTag = Boolean(results[0].match(endTag));
      var shouldKeepSameLine = noNewlinesBeforeTagClose && isClosingTag;
      if (end < 0) {
        line += restoreIgnore(restoreCustom(results.shift()));
      }
      else {
        line += restoreIgnore(restoreCustom(results[0].slice(0, end)));
        results[0] = results[0].slice(end + 1);
      }
      if (len > 0 && line.length > maxLineLength && !shouldKeepSameLine) {
        lines.push(line.slice(0, len));
        line = line.slice(len);
      }
      else if (end >= 0) {
        lines.push(line);
        line = '';
      }
    }
    if (line) {
      lines.push(line);
    }
    str = lines.join('\n');
  }
  else {
    str = restoreIgnore(restoreCustom(results.join('')));
  }
  return options.collapseWhitespace ? collapseWhitespace(str, options, true, true) : str;
}

var minify_1 = async function(value, options) {
  var start = Date.now();
  options = processOptions(options || {});
  var result = await minify(value, options);
  options.log('minified in: ' + (Date.now() - start) + 'ms');
  return result;
};

function loadEnv$1(mode, envDir, prefix = "") {
  if (mode === "local") {
    throw new Error(`"local" cannot be used as a mode name because it conflicts with the .local postfix for .env files.`);
  }
  const env = {};
  const envFiles = [
    `.env.${mode}.local`,
    `.env.${mode}`,
    `.env.local`,
    `.env`
  ];
  for (const file of envFiles) {
    const path = lookupFile$1(envDir, [file], true);
    if (path) {
      const parsed = dotenv.parse(fse.readFileSync(path));
      expand_1$1({
        parsed,
        ignoreProcessEnv: true
      });
      for (const [key, value] of Object.entries(parsed)) {
        if (key.startsWith(prefix) && env[key] === void 0) {
          env[key] = value;
        } else if (key === "NODE_ENV") {
          process.env.VITE_USER_NODE_ENV = value;
        }
      }
    }
  }
  return env;
}
function lookupFile$1(dir, formats, pathOnly = false) {
  for (const format of formats) {
    const fullPath = join(dir, format);
    if (fse.pathExistsSync(fullPath) && fse.statSync(fullPath).isFile()) {
      return pathOnly ? fullPath : fse.readFileSync(fullPath, "utf-8");
    }
  }
  const parentDir = dirname(dir);
  if (parentDir !== dir) {
    return lookupFile$1(parentDir, formats, pathOnly);
  }
}
async function isDirEmpty(dir) {
  return fse.readdir(dir).then((files) => {
    return files.length === 0;
  });
}

const DEFAULT_TEMPLATE = "index.html";
const ignoreDirs = [".", "", "/"];
const bodyInjectRE = /<\/body>/;
function createPlugin(userOptions = {}) {
  const {
    entry,
    template = DEFAULT_TEMPLATE,
    pages = [],
    verbose = false
  } = userOptions;
  let viteConfig;
  let env = {};
  return {
    name: "vite:html",
    enforce: "pre",
    configResolved(resolvedConfig) {
      viteConfig = resolvedConfig;
      env = loadEnv$1(viteConfig.mode, viteConfig.root, "");
    },
    config(conf) {
      const input = createInput(userOptions, conf);
      if (input) {
        return {
          build: {
            rollupOptions: {
              input
            }
          }
        };
      }
    },
    configureServer(server) {
      let _pages = [];
      const rewrites = [];
      if (!isMpa(viteConfig)) {
        const template2 = userOptions.template || DEFAULT_TEMPLATE;
        const filename = DEFAULT_TEMPLATE;
        _pages.push({
          filename,
          template: template2
        });
      } else {
        _pages = pages.map((page) => {
          return {
            filename: page.filename || DEFAULT_TEMPLATE,
            template: page.template || DEFAULT_TEMPLATE
          };
        });
      }
      const proxy = viteConfig.server?.proxy ?? {};
      const baseUrl = viteConfig.base ?? "/";
      const keys = Object.keys(proxy);
      let indexPage = null;
      for (const page of _pages) {
        if (page.filename !== "index.html") {
          rewrites.push(createRewire(page.template, page, baseUrl, keys));
        } else {
          indexPage = page;
        }
      }
      if (indexPage) {
        rewrites.push(createRewire("", indexPage, baseUrl, keys));
      }
      server.middlewares.use(history({
        disableDotRule: void 0,
        htmlAcceptHeaders: ["text/html", "application/xhtml+xml"],
        rewrites
      }));
    },
    transformIndexHtml: {
      enforce: "pre",
      async transform(html, ctx) {
        const url = ctx.filename;
        const base = viteConfig.base;
        const excludeBaseUrl = url.replace(base, "/");
        const htmlName = index.relative(process.cwd(), excludeBaseUrl);
        const page = getPage(userOptions, htmlName, viteConfig);
        const { injectOptions = {} } = page;
        const _html = await renderHtml(html, {
          injectOptions,
          viteConfig,
          env,
          entry: page.entry || entry,
          verbose
        });
        const { tags = [] } = injectOptions;
        return {
          html: _html,
          tags
        };
      }
    },
    async closeBundle() {
      const outputDirs = [];
      if (isMpa(viteConfig) || pages.length) {
        for (const page of pages) {
          const dir = index.dirname(page.template);
          if (!ignoreDirs.includes(dir)) {
            outputDirs.push(dir);
          }
        }
      } else {
        const dir = index.dirname(template);
        if (!ignoreDirs.includes(dir)) {
          outputDirs.push(dir);
        }
      }
      const cwd = index.resolve(viteConfig.root, viteConfig.build.outDir);
      const htmlFiles = await fg(outputDirs.map((dir) => `${dir}/*.html`), { cwd: index.resolve(cwd), absolute: true });
      await Promise.all(htmlFiles.map((file) => fse.move(file, index.resolve(cwd, index.basename(file)), {
        overwrite: true
      })));
      const htmlDirs = await fg(outputDirs.map((dir) => dir), { cwd: index.resolve(cwd), onlyDirectories: true, absolute: true });
      await Promise.all(htmlDirs.map(async (item) => {
        const isEmpty = await isDirEmpty(item);
        if (isEmpty) {
          return fse.remove(item);
        }
      }));
    }
  };
}
function createInput({ pages = [], template = DEFAULT_TEMPLATE }, viteConfig) {
  const input = {};
  if (isMpa(viteConfig) || pages?.length) {
    const templates = pages.map((page) => page.template);
    templates.forEach((temp) => {
      let dirName = index.dirname(temp);
      const file = index.basename(temp);
      dirName = dirName.replace(/\s+/g, "").replace(/\//g, "-");
      const key = dirName === "." || dirName === "public" || !dirName ? file.replace(/\.html/, "") : dirName;
      input[key] = index.resolve(viteConfig.root, temp);
    });
    return input;
  } else {
    const dir = index.dirname(template);
    if (ignoreDirs.includes(dir)) {
      return void 0;
    } else {
      const file = index.basename(template);
      const key = file.replace(/\.html/, "");
      return {
        [key]: index.resolve(viteConfig.root, template)
      };
    }
  }
}
async function renderHtml(html, config) {
  const { injectOptions, viteConfig, env, entry, verbose } = config;
  const { data, ejsOptions } = injectOptions;
  const ejsData = {
    ...viteConfig?.env ?? {},
    ...viteConfig?.define ?? {},
    ...env || {},
    ...data
  };
  let result = await ejs.render(html, ejsData, ejsOptions);
  if (entry) {
    result = removeEntryScript(result, verbose);
    result = result.replace(bodyInjectRE, `<script type="module" src="${require$$2$1.normalizePath(`${entry}`)}"><\/script>
</body>`);
  }
  return result;
}
function getPage({ pages = [], entry, template = DEFAULT_TEMPLATE, inject = {} }, name, viteConfig) {
  let page;
  if (isMpa(viteConfig) || pages?.length) {
    page = getPageConfig(name, pages, DEFAULT_TEMPLATE);
  } else {
    page = createSpaPage(entry, template, inject);
  }
  return page;
}
function isMpa(viteConfig) {
  const input = viteConfig?.build?.rollupOptions?.input ?? void 0;
  return typeof input !== "string" && Object.keys(input || {}).length > 1;
}
function removeEntryScript(html, verbose = false) {
  if (!html) {
    return html;
  }
  const root = parse_2(html);
  const scriptNodes = root.querySelectorAll("script[type=module]") || [];
  const removedNode = [];
  scriptNodes.forEach((item) => {
    removedNode.push(item.toString());
    item.parentNode.removeChild(item);
  });
  verbose && removedNode.length && consola$1.warn(`vite-plugin-html: Since you have already configured entry, ${dim(removedNode.toString())} is deleted. You may also delete it from the index.html.
        `);
  return root.toString();
}
function createSpaPage(entry, template, inject = {}) {
  return {
    entry,
    filename: "index.html",
    template,
    injectOptions: inject
  };
}
function getPageConfig(htmlName, pages, defaultPage) {
  const defaultPageOption = {
    filename: defaultPage,
    template: `./${defaultPage}`
  };
  const page = pages.filter((page2) => {
    return index.resolve("/" + page2.template) === index.resolve("/" + htmlName);
  })?.[0];
  return page ?? defaultPageOption ?? void 0;
}
function createRewire(reg, page, baseUrl, proxyUrlKeys) {
  return {
    from: new RegExp(`^/${reg}*`),
    to({ parsedUrl }) {
      const pathname = parsedUrl.pathname;
      const excludeBaseUrl = pathname.replace(baseUrl, "/");
      const template = index.resolve(baseUrl, page.template);
      if (excludeBaseUrl === "/") {
        return template;
      }
      const isApiUrl = proxyUrlKeys.some((item) => pathname.startsWith(index.resolve(baseUrl, item)));
      return isApiUrl ? excludeBaseUrl : template;
    }
  };
}

const htmlFilter = createFilter$1(["**/*.html"]);

function getOptions(minify) {
  return {
    collapseWhitespace: minify,
    keepClosingSlash: minify,
    removeComments: minify,
    removeRedundantAttributes: minify,
    removeScriptTypeAttributes: minify,
    removeStyleLinkTypeAttributes: minify,
    useShortDoctype: minify,
    minifyCSS: minify
  };
}
async function minifyHtml(html, minify$1) {
  if (typeof minify$1 === "boolean" && !minify$1) {
    return html;
  }
  let minifyOptions = minify$1;
  if (typeof minify$1 === "boolean" && minify$1) {
    minifyOptions = getOptions(minify$1);
  }
  return await minify_1(html, minifyOptions);
}
function createMinifyHtmlPlugin({
  minify = true
} = {}) {
  return {
    name: "vite:minify-html",
    enforce: "post",
    async generateBundle(_, outBundle) {
      if (minify) {
        for (const bundle of Object.values(outBundle)) {
          if (bundle.type === "asset" && htmlFilter(bundle.fileName) && typeof bundle.source === "string") {
            bundle.source = await minifyHtml(bundle.source, minify);
          }
        }
      }
    }
  };
}

consola$1.wrapConsole();
function createHtmlPlugin(userOptions = {}) {
  return [createPlugin(userOptions), createMinifyHtmlPlugin(userOptions)];
}

var lib$j = {};

var file = {};

var lib$i = {};

var lib$h = {};

var visitors = {};

var virtualTypes = {};

var hasRequiredVirtualTypes;

function requireVirtualTypes () {
	if (hasRequiredVirtualTypes) return virtualTypes;
	hasRequiredVirtualTypes = 1;

	Object.defineProperty(virtualTypes, "__esModule", {
	  value: true
	});
	virtualTypes.Var = virtualTypes.User = virtualTypes.Statement = virtualTypes.SpreadProperty = virtualTypes.Scope = virtualTypes.RestProperty = virtualTypes.ReferencedMemberExpression = virtualTypes.ReferencedIdentifier = virtualTypes.Referenced = virtualTypes.Pure = virtualTypes.NumericLiteralTypeAnnotation = virtualTypes.Generated = virtualTypes.ForAwaitStatement = virtualTypes.Flow = virtualTypes.Expression = virtualTypes.ExistentialTypeParam = virtualTypes.BlockScoped = virtualTypes.BindingIdentifier = void 0;
	virtualTypes.ReferencedIdentifier = ["Identifier", "JSXIdentifier"];
	virtualTypes.ReferencedMemberExpression = ["MemberExpression"];
	virtualTypes.BindingIdentifier = ["Identifier"];
	virtualTypes.Statement = ["Statement"];
	virtualTypes.Expression = ["Expression"];
	virtualTypes.Scope = ["Scopable", "Pattern"];
	virtualTypes.Referenced = null;
	virtualTypes.BlockScoped = null;
	virtualTypes.Var = ["VariableDeclaration"];
	virtualTypes.User = null;
	virtualTypes.Generated = null;
	virtualTypes.Pure = null;
	virtualTypes.Flow = ["Flow", "ImportDeclaration", "ExportDeclaration", "ImportSpecifier"];
	virtualTypes.RestProperty = ["RestElement"];
	virtualTypes.SpreadProperty = ["RestElement"];
	virtualTypes.ExistentialTypeParam = ["ExistsTypeAnnotation"];
	virtualTypes.NumericLiteralTypeAnnotation = ["NumberLiteralTypeAnnotation"];
	virtualTypes.ForAwaitStatement = ["ForOfStatement"];

	
	return virtualTypes;
}

var virtualTypesValidator = {};

var lib$g = {};

var isReactComponent = {};

var buildMatchMemberExpression = {};

var matchesPattern = {};

var generated$3 = {};

var shallowEqual = {};

var hasRequiredShallowEqual;

function requireShallowEqual () {
	if (hasRequiredShallowEqual) return shallowEqual;
	hasRequiredShallowEqual = 1;

	Object.defineProperty(shallowEqual, "__esModule", {
	  value: true
	});
	shallowEqual.default = shallowEqual$1;
	function shallowEqual$1(actual, expected) {
	  const keys = Object.keys(expected);
	  for (const key of keys) {
	    if (actual[key] !== expected[key]) {
	      return false;
	    }
	  }
	  return true;
	}

	
	return shallowEqual;
}

var deprecationWarning = {};

var hasRequiredDeprecationWarning;

function requireDeprecationWarning () {
	if (hasRequiredDeprecationWarning) return deprecationWarning;
	hasRequiredDeprecationWarning = 1;

	Object.defineProperty(deprecationWarning, "__esModule", {
	  value: true
	});
	deprecationWarning.default = deprecationWarning$1;
	const warnings = new Set();
	function deprecationWarning$1(oldName, newName, prefix = "") {
	  if (warnings.has(oldName)) return;
	  warnings.add(oldName);
	  const {
	    internal,
	    trace
	  } = captureShortStackTrace(1, 2);
	  if (internal) {
	    return;
	  }
	  console.warn(`${prefix}\`${oldName}\` has been deprecated, please migrate to \`${newName}\`\n${trace}`);
	}
	function captureShortStackTrace(skip, length) {
	  const {
	    stackTraceLimit,
	    prepareStackTrace
	  } = Error;
	  let stackTrace;
	  Error.stackTraceLimit = 1 + skip + length;
	  Error.prepareStackTrace = function (err, stack) {
	    stackTrace = stack;
	  };
	  new Error().stack;
	  Error.stackTraceLimit = stackTraceLimit;
	  Error.prepareStackTrace = prepareStackTrace;
	  if (!stackTrace) return {
	    internal: false,
	    trace: ""
	  };
	  const shortStackTrace = stackTrace.slice(1 + skip, 1 + skip + length);
	  return {
	    internal: /[\\/]@babel[\\/]/.test(shortStackTrace[1].getFileName()),
	    trace: shortStackTrace.map(frame => `    at ${frame}`).join("\n")
	  };
	}

	
	return deprecationWarning;
}

var hasRequiredGenerated$3;

function requireGenerated$3 () {
	if (hasRequiredGenerated$3) return generated$3;
	hasRequiredGenerated$3 = 1;

	Object.defineProperty(generated$3, "__esModule", {
	  value: true
	});
	generated$3.isAccessor = isAccessor;
	generated$3.isAnyTypeAnnotation = isAnyTypeAnnotation;
	generated$3.isArgumentPlaceholder = isArgumentPlaceholder;
	generated$3.isArrayExpression = isArrayExpression;
	generated$3.isArrayPattern = isArrayPattern;
	generated$3.isArrayTypeAnnotation = isArrayTypeAnnotation;
	generated$3.isArrowFunctionExpression = isArrowFunctionExpression;
	generated$3.isAssignmentExpression = isAssignmentExpression;
	generated$3.isAssignmentPattern = isAssignmentPattern;
	generated$3.isAwaitExpression = isAwaitExpression;
	generated$3.isBigIntLiteral = isBigIntLiteral;
	generated$3.isBinary = isBinary;
	generated$3.isBinaryExpression = isBinaryExpression;
	generated$3.isBindExpression = isBindExpression;
	generated$3.isBlock = isBlock;
	generated$3.isBlockParent = isBlockParent;
	generated$3.isBlockStatement = isBlockStatement;
	generated$3.isBooleanLiteral = isBooleanLiteral;
	generated$3.isBooleanLiteralTypeAnnotation = isBooleanLiteralTypeAnnotation;
	generated$3.isBooleanTypeAnnotation = isBooleanTypeAnnotation;
	generated$3.isBreakStatement = isBreakStatement;
	generated$3.isCallExpression = isCallExpression;
	generated$3.isCatchClause = isCatchClause;
	generated$3.isClass = isClass;
	generated$3.isClassAccessorProperty = isClassAccessorProperty;
	generated$3.isClassBody = isClassBody;
	generated$3.isClassDeclaration = isClassDeclaration;
	generated$3.isClassExpression = isClassExpression;
	generated$3.isClassImplements = isClassImplements;
	generated$3.isClassMethod = isClassMethod;
	generated$3.isClassPrivateMethod = isClassPrivateMethod;
	generated$3.isClassPrivateProperty = isClassPrivateProperty;
	generated$3.isClassProperty = isClassProperty;
	generated$3.isCompletionStatement = isCompletionStatement;
	generated$3.isConditional = isConditional;
	generated$3.isConditionalExpression = isConditionalExpression;
	generated$3.isContinueStatement = isContinueStatement;
	generated$3.isDebuggerStatement = isDebuggerStatement;
	generated$3.isDecimalLiteral = isDecimalLiteral;
	generated$3.isDeclaration = isDeclaration;
	generated$3.isDeclareClass = isDeclareClass;
	generated$3.isDeclareExportAllDeclaration = isDeclareExportAllDeclaration;
	generated$3.isDeclareExportDeclaration = isDeclareExportDeclaration;
	generated$3.isDeclareFunction = isDeclareFunction;
	generated$3.isDeclareInterface = isDeclareInterface;
	generated$3.isDeclareModule = isDeclareModule;
	generated$3.isDeclareModuleExports = isDeclareModuleExports;
	generated$3.isDeclareOpaqueType = isDeclareOpaqueType;
	generated$3.isDeclareTypeAlias = isDeclareTypeAlias;
	generated$3.isDeclareVariable = isDeclareVariable;
	generated$3.isDeclaredPredicate = isDeclaredPredicate;
	generated$3.isDecorator = isDecorator;
	generated$3.isDirective = isDirective;
	generated$3.isDirectiveLiteral = isDirectiveLiteral;
	generated$3.isDoExpression = isDoExpression;
	generated$3.isDoWhileStatement = isDoWhileStatement;
	generated$3.isEmptyStatement = isEmptyStatement;
	generated$3.isEmptyTypeAnnotation = isEmptyTypeAnnotation;
	generated$3.isEnumBody = isEnumBody;
	generated$3.isEnumBooleanBody = isEnumBooleanBody;
	generated$3.isEnumBooleanMember = isEnumBooleanMember;
	generated$3.isEnumDeclaration = isEnumDeclaration;
	generated$3.isEnumDefaultedMember = isEnumDefaultedMember;
	generated$3.isEnumMember = isEnumMember;
	generated$3.isEnumNumberBody = isEnumNumberBody;
	generated$3.isEnumNumberMember = isEnumNumberMember;
	generated$3.isEnumStringBody = isEnumStringBody;
	generated$3.isEnumStringMember = isEnumStringMember;
	generated$3.isEnumSymbolBody = isEnumSymbolBody;
	generated$3.isExistsTypeAnnotation = isExistsTypeAnnotation;
	generated$3.isExportAllDeclaration = isExportAllDeclaration;
	generated$3.isExportDeclaration = isExportDeclaration;
	generated$3.isExportDefaultDeclaration = isExportDefaultDeclaration;
	generated$3.isExportDefaultSpecifier = isExportDefaultSpecifier;
	generated$3.isExportNamedDeclaration = isExportNamedDeclaration;
	generated$3.isExportNamespaceSpecifier = isExportNamespaceSpecifier;
	generated$3.isExportSpecifier = isExportSpecifier;
	generated$3.isExpression = isExpression;
	generated$3.isExpressionStatement = isExpressionStatement;
	generated$3.isExpressionWrapper = isExpressionWrapper;
	generated$3.isFile = isFile;
	generated$3.isFlow = isFlow;
	generated$3.isFlowBaseAnnotation = isFlowBaseAnnotation;
	generated$3.isFlowDeclaration = isFlowDeclaration;
	generated$3.isFlowPredicate = isFlowPredicate;
	generated$3.isFlowType = isFlowType;
	generated$3.isFor = isFor;
	generated$3.isForInStatement = isForInStatement;
	generated$3.isForOfStatement = isForOfStatement;
	generated$3.isForStatement = isForStatement;
	generated$3.isForXStatement = isForXStatement;
	generated$3.isFunction = isFunction;
	generated$3.isFunctionDeclaration = isFunctionDeclaration;
	generated$3.isFunctionExpression = isFunctionExpression;
	generated$3.isFunctionParent = isFunctionParent;
	generated$3.isFunctionTypeAnnotation = isFunctionTypeAnnotation;
	generated$3.isFunctionTypeParam = isFunctionTypeParam;
	generated$3.isGenericTypeAnnotation = isGenericTypeAnnotation;
	generated$3.isIdentifier = isIdentifier;
	generated$3.isIfStatement = isIfStatement;
	generated$3.isImmutable = isImmutable;
	generated$3.isImport = isImport;
	generated$3.isImportAttribute = isImportAttribute;
	generated$3.isImportDeclaration = isImportDeclaration;
	generated$3.isImportDefaultSpecifier = isImportDefaultSpecifier;
	generated$3.isImportExpression = isImportExpression;
	generated$3.isImportNamespaceSpecifier = isImportNamespaceSpecifier;
	generated$3.isImportOrExportDeclaration = isImportOrExportDeclaration;
	generated$3.isImportSpecifier = isImportSpecifier;
	generated$3.isIndexedAccessType = isIndexedAccessType;
	generated$3.isInferredPredicate = isInferredPredicate;
	generated$3.isInterfaceDeclaration = isInterfaceDeclaration;
	generated$3.isInterfaceExtends = isInterfaceExtends;
	generated$3.isInterfaceTypeAnnotation = isInterfaceTypeAnnotation;
	generated$3.isInterpreterDirective = isInterpreterDirective;
	generated$3.isIntersectionTypeAnnotation = isIntersectionTypeAnnotation;
	generated$3.isJSX = isJSX;
	generated$3.isJSXAttribute = isJSXAttribute;
	generated$3.isJSXClosingElement = isJSXClosingElement;
	generated$3.isJSXClosingFragment = isJSXClosingFragment;
	generated$3.isJSXElement = isJSXElement;
	generated$3.isJSXEmptyExpression = isJSXEmptyExpression;
	generated$3.isJSXExpressionContainer = isJSXExpressionContainer;
	generated$3.isJSXFragment = isJSXFragment;
	generated$3.isJSXIdentifier = isJSXIdentifier;
	generated$3.isJSXMemberExpression = isJSXMemberExpression;
	generated$3.isJSXNamespacedName = isJSXNamespacedName;
	generated$3.isJSXOpeningElement = isJSXOpeningElement;
	generated$3.isJSXOpeningFragment = isJSXOpeningFragment;
	generated$3.isJSXSpreadAttribute = isJSXSpreadAttribute;
	generated$3.isJSXSpreadChild = isJSXSpreadChild;
	generated$3.isJSXText = isJSXText;
	generated$3.isLVal = isLVal;
	generated$3.isLabeledStatement = isLabeledStatement;
	generated$3.isLiteral = isLiteral;
	generated$3.isLogicalExpression = isLogicalExpression;
	generated$3.isLoop = isLoop;
	generated$3.isMemberExpression = isMemberExpression;
	generated$3.isMetaProperty = isMetaProperty;
	generated$3.isMethod = isMethod;
	generated$3.isMiscellaneous = isMiscellaneous;
	generated$3.isMixedTypeAnnotation = isMixedTypeAnnotation;
	generated$3.isModuleDeclaration = isModuleDeclaration;
	generated$3.isModuleExpression = isModuleExpression;
	generated$3.isModuleSpecifier = isModuleSpecifier;
	generated$3.isNewExpression = isNewExpression;
	generated$3.isNoop = isNoop;
	generated$3.isNullLiteral = isNullLiteral;
	generated$3.isNullLiteralTypeAnnotation = isNullLiteralTypeAnnotation;
	generated$3.isNullableTypeAnnotation = isNullableTypeAnnotation;
	generated$3.isNumberLiteral = isNumberLiteral;
	generated$3.isNumberLiteralTypeAnnotation = isNumberLiteralTypeAnnotation;
	generated$3.isNumberTypeAnnotation = isNumberTypeAnnotation;
	generated$3.isNumericLiteral = isNumericLiteral;
	generated$3.isObjectExpression = isObjectExpression;
	generated$3.isObjectMember = isObjectMember;
	generated$3.isObjectMethod = isObjectMethod;
	generated$3.isObjectPattern = isObjectPattern;
	generated$3.isObjectProperty = isObjectProperty;
	generated$3.isObjectTypeAnnotation = isObjectTypeAnnotation;
	generated$3.isObjectTypeCallProperty = isObjectTypeCallProperty;
	generated$3.isObjectTypeIndexer = isObjectTypeIndexer;
	generated$3.isObjectTypeInternalSlot = isObjectTypeInternalSlot;
	generated$3.isObjectTypeProperty = isObjectTypeProperty;
	generated$3.isObjectTypeSpreadProperty = isObjectTypeSpreadProperty;
	generated$3.isOpaqueType = isOpaqueType;
	generated$3.isOptionalCallExpression = isOptionalCallExpression;
	generated$3.isOptionalIndexedAccessType = isOptionalIndexedAccessType;
	generated$3.isOptionalMemberExpression = isOptionalMemberExpression;
	generated$3.isParenthesizedExpression = isParenthesizedExpression;
	generated$3.isPattern = isPattern;
	generated$3.isPatternLike = isPatternLike;
	generated$3.isPipelineBareFunction = isPipelineBareFunction;
	generated$3.isPipelinePrimaryTopicReference = isPipelinePrimaryTopicReference;
	generated$3.isPipelineTopicExpression = isPipelineTopicExpression;
	generated$3.isPlaceholder = isPlaceholder;
	generated$3.isPrivate = isPrivate;
	generated$3.isPrivateName = isPrivateName;
	generated$3.isProgram = isProgram;
	generated$3.isProperty = isProperty;
	generated$3.isPureish = isPureish;
	generated$3.isQualifiedTypeIdentifier = isQualifiedTypeIdentifier;
	generated$3.isRecordExpression = isRecordExpression;
	generated$3.isRegExpLiteral = isRegExpLiteral;
	generated$3.isRegexLiteral = isRegexLiteral;
	generated$3.isRestElement = isRestElement;
	generated$3.isRestProperty = isRestProperty;
	generated$3.isReturnStatement = isReturnStatement;
	generated$3.isScopable = isScopable;
	generated$3.isSequenceExpression = isSequenceExpression;
	generated$3.isSpreadElement = isSpreadElement;
	generated$3.isSpreadProperty = isSpreadProperty;
	generated$3.isStandardized = isStandardized;
	generated$3.isStatement = isStatement;
	generated$3.isStaticBlock = isStaticBlock;
	generated$3.isStringLiteral = isStringLiteral;
	generated$3.isStringLiteralTypeAnnotation = isStringLiteralTypeAnnotation;
	generated$3.isStringTypeAnnotation = isStringTypeAnnotation;
	generated$3.isSuper = isSuper;
	generated$3.isSwitchCase = isSwitchCase;
	generated$3.isSwitchStatement = isSwitchStatement;
	generated$3.isSymbolTypeAnnotation = isSymbolTypeAnnotation;
	generated$3.isTSAnyKeyword = isTSAnyKeyword;
	generated$3.isTSArrayType = isTSArrayType;
	generated$3.isTSAsExpression = isTSAsExpression;
	generated$3.isTSBaseType = isTSBaseType;
	generated$3.isTSBigIntKeyword = isTSBigIntKeyword;
	generated$3.isTSBooleanKeyword = isTSBooleanKeyword;
	generated$3.isTSCallSignatureDeclaration = isTSCallSignatureDeclaration;
	generated$3.isTSConditionalType = isTSConditionalType;
	generated$3.isTSConstructSignatureDeclaration = isTSConstructSignatureDeclaration;
	generated$3.isTSConstructorType = isTSConstructorType;
	generated$3.isTSDeclareFunction = isTSDeclareFunction;
	generated$3.isTSDeclareMethod = isTSDeclareMethod;
	generated$3.isTSEntityName = isTSEntityName;
	generated$3.isTSEnumDeclaration = isTSEnumDeclaration;
	generated$3.isTSEnumMember = isTSEnumMember;
	generated$3.isTSExportAssignment = isTSExportAssignment;
	generated$3.isTSExpressionWithTypeArguments = isTSExpressionWithTypeArguments;
	generated$3.isTSExternalModuleReference = isTSExternalModuleReference;
	generated$3.isTSFunctionType = isTSFunctionType;
	generated$3.isTSImportEqualsDeclaration = isTSImportEqualsDeclaration;
	generated$3.isTSImportType = isTSImportType;
	generated$3.isTSIndexSignature = isTSIndexSignature;
	generated$3.isTSIndexedAccessType = isTSIndexedAccessType;
	generated$3.isTSInferType = isTSInferType;
	generated$3.isTSInstantiationExpression = isTSInstantiationExpression;
	generated$3.isTSInterfaceBody = isTSInterfaceBody;
	generated$3.isTSInterfaceDeclaration = isTSInterfaceDeclaration;
	generated$3.isTSIntersectionType = isTSIntersectionType;
	generated$3.isTSIntrinsicKeyword = isTSIntrinsicKeyword;
	generated$3.isTSLiteralType = isTSLiteralType;
	generated$3.isTSMappedType = isTSMappedType;
	generated$3.isTSMethodSignature = isTSMethodSignature;
	generated$3.isTSModuleBlock = isTSModuleBlock;
	generated$3.isTSModuleDeclaration = isTSModuleDeclaration;
	generated$3.isTSNamedTupleMember = isTSNamedTupleMember;
	generated$3.isTSNamespaceExportDeclaration = isTSNamespaceExportDeclaration;
	generated$3.isTSNeverKeyword = isTSNeverKeyword;
	generated$3.isTSNonNullExpression = isTSNonNullExpression;
	generated$3.isTSNullKeyword = isTSNullKeyword;
	generated$3.isTSNumberKeyword = isTSNumberKeyword;
	generated$3.isTSObjectKeyword = isTSObjectKeyword;
	generated$3.isTSOptionalType = isTSOptionalType;
	generated$3.isTSParameterProperty = isTSParameterProperty;
	generated$3.isTSParenthesizedType = isTSParenthesizedType;
	generated$3.isTSPropertySignature = isTSPropertySignature;
	generated$3.isTSQualifiedName = isTSQualifiedName;
	generated$3.isTSRestType = isTSRestType;
	generated$3.isTSSatisfiesExpression = isTSSatisfiesExpression;
	generated$3.isTSStringKeyword = isTSStringKeyword;
	generated$3.isTSSymbolKeyword = isTSSymbolKeyword;
	generated$3.isTSThisType = isTSThisType;
	generated$3.isTSTupleType = isTSTupleType;
	generated$3.isTSType = isTSType;
	generated$3.isTSTypeAliasDeclaration = isTSTypeAliasDeclaration;
	generated$3.isTSTypeAnnotation = isTSTypeAnnotation;
	generated$3.isTSTypeAssertion = isTSTypeAssertion;
	generated$3.isTSTypeElement = isTSTypeElement;
	generated$3.isTSTypeLiteral = isTSTypeLiteral;
	generated$3.isTSTypeOperator = isTSTypeOperator;
	generated$3.isTSTypeParameter = isTSTypeParameter;
	generated$3.isTSTypeParameterDeclaration = isTSTypeParameterDeclaration;
	generated$3.isTSTypeParameterInstantiation = isTSTypeParameterInstantiation;
	generated$3.isTSTypePredicate = isTSTypePredicate;
	generated$3.isTSTypeQuery = isTSTypeQuery;
	generated$3.isTSTypeReference = isTSTypeReference;
	generated$3.isTSUndefinedKeyword = isTSUndefinedKeyword;
	generated$3.isTSUnionType = isTSUnionType;
	generated$3.isTSUnknownKeyword = isTSUnknownKeyword;
	generated$3.isTSVoidKeyword = isTSVoidKeyword;
	generated$3.isTaggedTemplateExpression = isTaggedTemplateExpression;
	generated$3.isTemplateElement = isTemplateElement;
	generated$3.isTemplateLiteral = isTemplateLiteral;
	generated$3.isTerminatorless = isTerminatorless;
	generated$3.isThisExpression = isThisExpression;
	generated$3.isThisTypeAnnotation = isThisTypeAnnotation;
	generated$3.isThrowStatement = isThrowStatement;
	generated$3.isTopicReference = isTopicReference;
	generated$3.isTryStatement = isTryStatement;
	generated$3.isTupleExpression = isTupleExpression;
	generated$3.isTupleTypeAnnotation = isTupleTypeAnnotation;
	generated$3.isTypeAlias = isTypeAlias;
	generated$3.isTypeAnnotation = isTypeAnnotation;
	generated$3.isTypeCastExpression = isTypeCastExpression;
	generated$3.isTypeParameter = isTypeParameter;
	generated$3.isTypeParameterDeclaration = isTypeParameterDeclaration;
	generated$3.isTypeParameterInstantiation = isTypeParameterInstantiation;
	generated$3.isTypeScript = isTypeScript;
	generated$3.isTypeofTypeAnnotation = isTypeofTypeAnnotation;
	generated$3.isUnaryExpression = isUnaryExpression;
	generated$3.isUnaryLike = isUnaryLike;
	generated$3.isUnionTypeAnnotation = isUnionTypeAnnotation;
	generated$3.isUpdateExpression = isUpdateExpression;
	generated$3.isUserWhitespacable = isUserWhitespacable;
	generated$3.isV8IntrinsicIdentifier = isV8IntrinsicIdentifier;
	generated$3.isVariableDeclaration = isVariableDeclaration;
	generated$3.isVariableDeclarator = isVariableDeclarator;
	generated$3.isVariance = isVariance;
	generated$3.isVoidTypeAnnotation = isVoidTypeAnnotation;
	generated$3.isWhile = isWhile;
	generated$3.isWhileStatement = isWhileStatement;
	generated$3.isWithStatement = isWithStatement;
	generated$3.isYieldExpression = isYieldExpression;
	var _shallowEqual = requireShallowEqual();
	var _deprecationWarning = requireDeprecationWarning();
	function isArrayExpression(node, opts) {
	  if (!node) return false;
	  if (node.type !== "ArrayExpression") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isAssignmentExpression(node, opts) {
	  if (!node) return false;
	  if (node.type !== "AssignmentExpression") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isBinaryExpression(node, opts) {
	  if (!node) return false;
	  if (node.type !== "BinaryExpression") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isInterpreterDirective(node, opts) {
	  if (!node) return false;
	  if (node.type !== "InterpreterDirective") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isDirective(node, opts) {
	  if (!node) return false;
	  if (node.type !== "Directive") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isDirectiveLiteral(node, opts) {
	  if (!node) return false;
	  if (node.type !== "DirectiveLiteral") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isBlockStatement(node, opts) {
	  if (!node) return false;
	  if (node.type !== "BlockStatement") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isBreakStatement(node, opts) {
	  if (!node) return false;
	  if (node.type !== "BreakStatement") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isCallExpression(node, opts) {
	  if (!node) return false;
	  if (node.type !== "CallExpression") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isCatchClause(node, opts) {
	  if (!node) return false;
	  if (node.type !== "CatchClause") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isConditionalExpression(node, opts) {
	  if (!node) return false;
	  if (node.type !== "ConditionalExpression") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isContinueStatement(node, opts) {
	  if (!node) return false;
	  if (node.type !== "ContinueStatement") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isDebuggerStatement(node, opts) {
	  if (!node) return false;
	  if (node.type !== "DebuggerStatement") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isDoWhileStatement(node, opts) {
	  if (!node) return false;
	  if (node.type !== "DoWhileStatement") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isEmptyStatement(node, opts) {
	  if (!node) return false;
	  if (node.type !== "EmptyStatement") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isExpressionStatement(node, opts) {
	  if (!node) return false;
	  if (node.type !== "ExpressionStatement") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isFile(node, opts) {
	  if (!node) return false;
	  if (node.type !== "File") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isForInStatement(node, opts) {
	  if (!node) return false;
	  if (node.type !== "ForInStatement") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isForStatement(node, opts) {
	  if (!node) return false;
	  if (node.type !== "ForStatement") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isFunctionDeclaration(node, opts) {
	  if (!node) return false;
	  if (node.type !== "FunctionDeclaration") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isFunctionExpression(node, opts) {
	  if (!node) return false;
	  if (node.type !== "FunctionExpression") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isIdentifier(node, opts) {
	  if (!node) return false;
	  if (node.type !== "Identifier") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isIfStatement(node, opts) {
	  if (!node) return false;
	  if (node.type !== "IfStatement") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isLabeledStatement(node, opts) {
	  if (!node) return false;
	  if (node.type !== "LabeledStatement") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isStringLiteral(node, opts) {
	  if (!node) return false;
	  if (node.type !== "StringLiteral") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isNumericLiteral(node, opts) {
	  if (!node) return false;
	  if (node.type !== "NumericLiteral") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isNullLiteral(node, opts) {
	  if (!node) return false;
	  if (node.type !== "NullLiteral") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isBooleanLiteral(node, opts) {
	  if (!node) return false;
	  if (node.type !== "BooleanLiteral") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isRegExpLiteral(node, opts) {
	  if (!node) return false;
	  if (node.type !== "RegExpLiteral") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isLogicalExpression(node, opts) {
	  if (!node) return false;
	  if (node.type !== "LogicalExpression") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isMemberExpression(node, opts) {
	  if (!node) return false;
	  if (node.type !== "MemberExpression") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isNewExpression(node, opts) {
	  if (!node) return false;
	  if (node.type !== "NewExpression") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isProgram(node, opts) {
	  if (!node) return false;
	  if (node.type !== "Program") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isObjectExpression(node, opts) {
	  if (!node) return false;
	  if (node.type !== "ObjectExpression") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isObjectMethod(node, opts) {
	  if (!node) return false;
	  if (node.type !== "ObjectMethod") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isObjectProperty(node, opts) {
	  if (!node) return false;
	  if (node.type !== "ObjectProperty") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isRestElement(node, opts) {
	  if (!node) return false;
	  if (node.type !== "RestElement") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isReturnStatement(node, opts) {
	  if (!node) return false;
	  if (node.type !== "ReturnStatement") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isSequenceExpression(node, opts) {
	  if (!node) return false;
	  if (node.type !== "SequenceExpression") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isParenthesizedExpression(node, opts) {
	  if (!node) return false;
	  if (node.type !== "ParenthesizedExpression") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isSwitchCase(node, opts) {
	  if (!node) return false;
	  if (node.type !== "SwitchCase") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isSwitchStatement(node, opts) {
	  if (!node) return false;
	  if (node.type !== "SwitchStatement") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isThisExpression(node, opts) {
	  if (!node) return false;
	  if (node.type !== "ThisExpression") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isThrowStatement(node, opts) {
	  if (!node) return false;
	  if (node.type !== "ThrowStatement") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTryStatement(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TryStatement") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isUnaryExpression(node, opts) {
	  if (!node) return false;
	  if (node.type !== "UnaryExpression") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isUpdateExpression(node, opts) {
	  if (!node) return false;
	  if (node.type !== "UpdateExpression") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isVariableDeclaration(node, opts) {
	  if (!node) return false;
	  if (node.type !== "VariableDeclaration") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isVariableDeclarator(node, opts) {
	  if (!node) return false;
	  if (node.type !== "VariableDeclarator") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isWhileStatement(node, opts) {
	  if (!node) return false;
	  if (node.type !== "WhileStatement") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isWithStatement(node, opts) {
	  if (!node) return false;
	  if (node.type !== "WithStatement") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isAssignmentPattern(node, opts) {
	  if (!node) return false;
	  if (node.type !== "AssignmentPattern") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isArrayPattern(node, opts) {
	  if (!node) return false;
	  if (node.type !== "ArrayPattern") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isArrowFunctionExpression(node, opts) {
	  if (!node) return false;
	  if (node.type !== "ArrowFunctionExpression") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isClassBody(node, opts) {
	  if (!node) return false;
	  if (node.type !== "ClassBody") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isClassExpression(node, opts) {
	  if (!node) return false;
	  if (node.type !== "ClassExpression") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isClassDeclaration(node, opts) {
	  if (!node) return false;
	  if (node.type !== "ClassDeclaration") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isExportAllDeclaration(node, opts) {
	  if (!node) return false;
	  if (node.type !== "ExportAllDeclaration") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isExportDefaultDeclaration(node, opts) {
	  if (!node) return false;
	  if (node.type !== "ExportDefaultDeclaration") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isExportNamedDeclaration(node, opts) {
	  if (!node) return false;
	  if (node.type !== "ExportNamedDeclaration") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isExportSpecifier(node, opts) {
	  if (!node) return false;
	  if (node.type !== "ExportSpecifier") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isForOfStatement(node, opts) {
	  if (!node) return false;
	  if (node.type !== "ForOfStatement") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isImportDeclaration(node, opts) {
	  if (!node) return false;
	  if (node.type !== "ImportDeclaration") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isImportDefaultSpecifier(node, opts) {
	  if (!node) return false;
	  if (node.type !== "ImportDefaultSpecifier") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isImportNamespaceSpecifier(node, opts) {
	  if (!node) return false;
	  if (node.type !== "ImportNamespaceSpecifier") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isImportSpecifier(node, opts) {
	  if (!node) return false;
	  if (node.type !== "ImportSpecifier") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isImportExpression(node, opts) {
	  if (!node) return false;
	  if (node.type !== "ImportExpression") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isMetaProperty(node, opts) {
	  if (!node) return false;
	  if (node.type !== "MetaProperty") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isClassMethod(node, opts) {
	  if (!node) return false;
	  if (node.type !== "ClassMethod") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isObjectPattern(node, opts) {
	  if (!node) return false;
	  if (node.type !== "ObjectPattern") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isSpreadElement(node, opts) {
	  if (!node) return false;
	  if (node.type !== "SpreadElement") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isSuper(node, opts) {
	  if (!node) return false;
	  if (node.type !== "Super") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTaggedTemplateExpression(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TaggedTemplateExpression") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTemplateElement(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TemplateElement") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTemplateLiteral(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TemplateLiteral") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isYieldExpression(node, opts) {
	  if (!node) return false;
	  if (node.type !== "YieldExpression") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isAwaitExpression(node, opts) {
	  if (!node) return false;
	  if (node.type !== "AwaitExpression") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isImport(node, opts) {
	  if (!node) return false;
	  if (node.type !== "Import") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isBigIntLiteral(node, opts) {
	  if (!node) return false;
	  if (node.type !== "BigIntLiteral") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isExportNamespaceSpecifier(node, opts) {
	  if (!node) return false;
	  if (node.type !== "ExportNamespaceSpecifier") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isOptionalMemberExpression(node, opts) {
	  if (!node) return false;
	  if (node.type !== "OptionalMemberExpression") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isOptionalCallExpression(node, opts) {
	  if (!node) return false;
	  if (node.type !== "OptionalCallExpression") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isClassProperty(node, opts) {
	  if (!node) return false;
	  if (node.type !== "ClassProperty") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isClassAccessorProperty(node, opts) {
	  if (!node) return false;
	  if (node.type !== "ClassAccessorProperty") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isClassPrivateProperty(node, opts) {
	  if (!node) return false;
	  if (node.type !== "ClassPrivateProperty") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isClassPrivateMethod(node, opts) {
	  if (!node) return false;
	  if (node.type !== "ClassPrivateMethod") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isPrivateName(node, opts) {
	  if (!node) return false;
	  if (node.type !== "PrivateName") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isStaticBlock(node, opts) {
	  if (!node) return false;
	  if (node.type !== "StaticBlock") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isAnyTypeAnnotation(node, opts) {
	  if (!node) return false;
	  if (node.type !== "AnyTypeAnnotation") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isArrayTypeAnnotation(node, opts) {
	  if (!node) return false;
	  if (node.type !== "ArrayTypeAnnotation") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isBooleanTypeAnnotation(node, opts) {
	  if (!node) return false;
	  if (node.type !== "BooleanTypeAnnotation") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isBooleanLiteralTypeAnnotation(node, opts) {
	  if (!node) return false;
	  if (node.type !== "BooleanLiteralTypeAnnotation") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isNullLiteralTypeAnnotation(node, opts) {
	  if (!node) return false;
	  if (node.type !== "NullLiteralTypeAnnotation") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isClassImplements(node, opts) {
	  if (!node) return false;
	  if (node.type !== "ClassImplements") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isDeclareClass(node, opts) {
	  if (!node) return false;
	  if (node.type !== "DeclareClass") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isDeclareFunction(node, opts) {
	  if (!node) return false;
	  if (node.type !== "DeclareFunction") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isDeclareInterface(node, opts) {
	  if (!node) return false;
	  if (node.type !== "DeclareInterface") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isDeclareModule(node, opts) {
	  if (!node) return false;
	  if (node.type !== "DeclareModule") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isDeclareModuleExports(node, opts) {
	  if (!node) return false;
	  if (node.type !== "DeclareModuleExports") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isDeclareTypeAlias(node, opts) {
	  if (!node) return false;
	  if (node.type !== "DeclareTypeAlias") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isDeclareOpaqueType(node, opts) {
	  if (!node) return false;
	  if (node.type !== "DeclareOpaqueType") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isDeclareVariable(node, opts) {
	  if (!node) return false;
	  if (node.type !== "DeclareVariable") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isDeclareExportDeclaration(node, opts) {
	  if (!node) return false;
	  if (node.type !== "DeclareExportDeclaration") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isDeclareExportAllDeclaration(node, opts) {
	  if (!node) return false;
	  if (node.type !== "DeclareExportAllDeclaration") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isDeclaredPredicate(node, opts) {
	  if (!node) return false;
	  if (node.type !== "DeclaredPredicate") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isExistsTypeAnnotation(node, opts) {
	  if (!node) return false;
	  if (node.type !== "ExistsTypeAnnotation") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isFunctionTypeAnnotation(node, opts) {
	  if (!node) return false;
	  if (node.type !== "FunctionTypeAnnotation") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isFunctionTypeParam(node, opts) {
	  if (!node) return false;
	  if (node.type !== "FunctionTypeParam") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isGenericTypeAnnotation(node, opts) {
	  if (!node) return false;
	  if (node.type !== "GenericTypeAnnotation") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isInferredPredicate(node, opts) {
	  if (!node) return false;
	  if (node.type !== "InferredPredicate") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isInterfaceExtends(node, opts) {
	  if (!node) return false;
	  if (node.type !== "InterfaceExtends") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isInterfaceDeclaration(node, opts) {
	  if (!node) return false;
	  if (node.type !== "InterfaceDeclaration") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isInterfaceTypeAnnotation(node, opts) {
	  if (!node) return false;
	  if (node.type !== "InterfaceTypeAnnotation") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isIntersectionTypeAnnotation(node, opts) {
	  if (!node) return false;
	  if (node.type !== "IntersectionTypeAnnotation") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isMixedTypeAnnotation(node, opts) {
	  if (!node) return false;
	  if (node.type !== "MixedTypeAnnotation") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isEmptyTypeAnnotation(node, opts) {
	  if (!node) return false;
	  if (node.type !== "EmptyTypeAnnotation") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isNullableTypeAnnotation(node, opts) {
	  if (!node) return false;
	  if (node.type !== "NullableTypeAnnotation") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isNumberLiteralTypeAnnotation(node, opts) {
	  if (!node) return false;
	  if (node.type !== "NumberLiteralTypeAnnotation") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isNumberTypeAnnotation(node, opts) {
	  if (!node) return false;
	  if (node.type !== "NumberTypeAnnotation") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isObjectTypeAnnotation(node, opts) {
	  if (!node) return false;
	  if (node.type !== "ObjectTypeAnnotation") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isObjectTypeInternalSlot(node, opts) {
	  if (!node) return false;
	  if (node.type !== "ObjectTypeInternalSlot") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isObjectTypeCallProperty(node, opts) {
	  if (!node) return false;
	  if (node.type !== "ObjectTypeCallProperty") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isObjectTypeIndexer(node, opts) {
	  if (!node) return false;
	  if (node.type !== "ObjectTypeIndexer") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isObjectTypeProperty(node, opts) {
	  if (!node) return false;
	  if (node.type !== "ObjectTypeProperty") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isObjectTypeSpreadProperty(node, opts) {
	  if (!node) return false;
	  if (node.type !== "ObjectTypeSpreadProperty") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isOpaqueType(node, opts) {
	  if (!node) return false;
	  if (node.type !== "OpaqueType") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isQualifiedTypeIdentifier(node, opts) {
	  if (!node) return false;
	  if (node.type !== "QualifiedTypeIdentifier") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isStringLiteralTypeAnnotation(node, opts) {
	  if (!node) return false;
	  if (node.type !== "StringLiteralTypeAnnotation") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isStringTypeAnnotation(node, opts) {
	  if (!node) return false;
	  if (node.type !== "StringTypeAnnotation") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isSymbolTypeAnnotation(node, opts) {
	  if (!node) return false;
	  if (node.type !== "SymbolTypeAnnotation") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isThisTypeAnnotation(node, opts) {
	  if (!node) return false;
	  if (node.type !== "ThisTypeAnnotation") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTupleTypeAnnotation(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TupleTypeAnnotation") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTypeofTypeAnnotation(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TypeofTypeAnnotation") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTypeAlias(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TypeAlias") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTypeAnnotation(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TypeAnnotation") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTypeCastExpression(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TypeCastExpression") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTypeParameter(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TypeParameter") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTypeParameterDeclaration(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TypeParameterDeclaration") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTypeParameterInstantiation(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TypeParameterInstantiation") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isUnionTypeAnnotation(node, opts) {
	  if (!node) return false;
	  if (node.type !== "UnionTypeAnnotation") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isVariance(node, opts) {
	  if (!node) return false;
	  if (node.type !== "Variance") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isVoidTypeAnnotation(node, opts) {
	  if (!node) return false;
	  if (node.type !== "VoidTypeAnnotation") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isEnumDeclaration(node, opts) {
	  if (!node) return false;
	  if (node.type !== "EnumDeclaration") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isEnumBooleanBody(node, opts) {
	  if (!node) return false;
	  if (node.type !== "EnumBooleanBody") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isEnumNumberBody(node, opts) {
	  if (!node) return false;
	  if (node.type !== "EnumNumberBody") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isEnumStringBody(node, opts) {
	  if (!node) return false;
	  if (node.type !== "EnumStringBody") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isEnumSymbolBody(node, opts) {
	  if (!node) return false;
	  if (node.type !== "EnumSymbolBody") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isEnumBooleanMember(node, opts) {
	  if (!node) return false;
	  if (node.type !== "EnumBooleanMember") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isEnumNumberMember(node, opts) {
	  if (!node) return false;
	  if (node.type !== "EnumNumberMember") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isEnumStringMember(node, opts) {
	  if (!node) return false;
	  if (node.type !== "EnumStringMember") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isEnumDefaultedMember(node, opts) {
	  if (!node) return false;
	  if (node.type !== "EnumDefaultedMember") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isIndexedAccessType(node, opts) {
	  if (!node) return false;
	  if (node.type !== "IndexedAccessType") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isOptionalIndexedAccessType(node, opts) {
	  if (!node) return false;
	  if (node.type !== "OptionalIndexedAccessType") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isJSXAttribute(node, opts) {
	  if (!node) return false;
	  if (node.type !== "JSXAttribute") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isJSXClosingElement(node, opts) {
	  if (!node) return false;
	  if (node.type !== "JSXClosingElement") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isJSXElement(node, opts) {
	  if (!node) return false;
	  if (node.type !== "JSXElement") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isJSXEmptyExpression(node, opts) {
	  if (!node) return false;
	  if (node.type !== "JSXEmptyExpression") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isJSXExpressionContainer(node, opts) {
	  if (!node) return false;
	  if (node.type !== "JSXExpressionContainer") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isJSXSpreadChild(node, opts) {
	  if (!node) return false;
	  if (node.type !== "JSXSpreadChild") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isJSXIdentifier(node, opts) {
	  if (!node) return false;
	  if (node.type !== "JSXIdentifier") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isJSXMemberExpression(node, opts) {
	  if (!node) return false;
	  if (node.type !== "JSXMemberExpression") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isJSXNamespacedName(node, opts) {
	  if (!node) return false;
	  if (node.type !== "JSXNamespacedName") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isJSXOpeningElement(node, opts) {
	  if (!node) return false;
	  if (node.type !== "JSXOpeningElement") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isJSXSpreadAttribute(node, opts) {
	  if (!node) return false;
	  if (node.type !== "JSXSpreadAttribute") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isJSXText(node, opts) {
	  if (!node) return false;
	  if (node.type !== "JSXText") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isJSXFragment(node, opts) {
	  if (!node) return false;
	  if (node.type !== "JSXFragment") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isJSXOpeningFragment(node, opts) {
	  if (!node) return false;
	  if (node.type !== "JSXOpeningFragment") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isJSXClosingFragment(node, opts) {
	  if (!node) return false;
	  if (node.type !== "JSXClosingFragment") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isNoop(node, opts) {
	  if (!node) return false;
	  if (node.type !== "Noop") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isPlaceholder(node, opts) {
	  if (!node) return false;
	  if (node.type !== "Placeholder") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isV8IntrinsicIdentifier(node, opts) {
	  if (!node) return false;
	  if (node.type !== "V8IntrinsicIdentifier") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isArgumentPlaceholder(node, opts) {
	  if (!node) return false;
	  if (node.type !== "ArgumentPlaceholder") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isBindExpression(node, opts) {
	  if (!node) return false;
	  if (node.type !== "BindExpression") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isImportAttribute(node, opts) {
	  if (!node) return false;
	  if (node.type !== "ImportAttribute") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isDecorator(node, opts) {
	  if (!node) return false;
	  if (node.type !== "Decorator") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isDoExpression(node, opts) {
	  if (!node) return false;
	  if (node.type !== "DoExpression") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isExportDefaultSpecifier(node, opts) {
	  if (!node) return false;
	  if (node.type !== "ExportDefaultSpecifier") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isRecordExpression(node, opts) {
	  if (!node) return false;
	  if (node.type !== "RecordExpression") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTupleExpression(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TupleExpression") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isDecimalLiteral(node, opts) {
	  if (!node) return false;
	  if (node.type !== "DecimalLiteral") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isModuleExpression(node, opts) {
	  if (!node) return false;
	  if (node.type !== "ModuleExpression") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTopicReference(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TopicReference") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isPipelineTopicExpression(node, opts) {
	  if (!node) return false;
	  if (node.type !== "PipelineTopicExpression") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isPipelineBareFunction(node, opts) {
	  if (!node) return false;
	  if (node.type !== "PipelineBareFunction") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isPipelinePrimaryTopicReference(node, opts) {
	  if (!node) return false;
	  if (node.type !== "PipelinePrimaryTopicReference") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSParameterProperty(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TSParameterProperty") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSDeclareFunction(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TSDeclareFunction") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSDeclareMethod(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TSDeclareMethod") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSQualifiedName(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TSQualifiedName") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSCallSignatureDeclaration(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TSCallSignatureDeclaration") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSConstructSignatureDeclaration(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TSConstructSignatureDeclaration") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSPropertySignature(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TSPropertySignature") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSMethodSignature(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TSMethodSignature") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSIndexSignature(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TSIndexSignature") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSAnyKeyword(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TSAnyKeyword") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSBooleanKeyword(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TSBooleanKeyword") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSBigIntKeyword(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TSBigIntKeyword") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSIntrinsicKeyword(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TSIntrinsicKeyword") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSNeverKeyword(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TSNeverKeyword") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSNullKeyword(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TSNullKeyword") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSNumberKeyword(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TSNumberKeyword") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSObjectKeyword(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TSObjectKeyword") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSStringKeyword(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TSStringKeyword") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSSymbolKeyword(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TSSymbolKeyword") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSUndefinedKeyword(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TSUndefinedKeyword") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSUnknownKeyword(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TSUnknownKeyword") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSVoidKeyword(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TSVoidKeyword") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSThisType(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TSThisType") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSFunctionType(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TSFunctionType") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSConstructorType(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TSConstructorType") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSTypeReference(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TSTypeReference") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSTypePredicate(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TSTypePredicate") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSTypeQuery(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TSTypeQuery") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSTypeLiteral(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TSTypeLiteral") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSArrayType(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TSArrayType") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSTupleType(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TSTupleType") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSOptionalType(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TSOptionalType") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSRestType(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TSRestType") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSNamedTupleMember(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TSNamedTupleMember") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSUnionType(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TSUnionType") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSIntersectionType(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TSIntersectionType") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSConditionalType(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TSConditionalType") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSInferType(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TSInferType") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSParenthesizedType(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TSParenthesizedType") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSTypeOperator(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TSTypeOperator") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSIndexedAccessType(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TSIndexedAccessType") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSMappedType(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TSMappedType") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSLiteralType(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TSLiteralType") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSExpressionWithTypeArguments(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TSExpressionWithTypeArguments") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSInterfaceDeclaration(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TSInterfaceDeclaration") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSInterfaceBody(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TSInterfaceBody") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSTypeAliasDeclaration(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TSTypeAliasDeclaration") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSInstantiationExpression(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TSInstantiationExpression") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSAsExpression(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TSAsExpression") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSSatisfiesExpression(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TSSatisfiesExpression") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSTypeAssertion(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TSTypeAssertion") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSEnumDeclaration(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TSEnumDeclaration") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSEnumMember(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TSEnumMember") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSModuleDeclaration(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TSModuleDeclaration") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSModuleBlock(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TSModuleBlock") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSImportType(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TSImportType") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSImportEqualsDeclaration(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TSImportEqualsDeclaration") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSExternalModuleReference(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TSExternalModuleReference") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSNonNullExpression(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TSNonNullExpression") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSExportAssignment(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TSExportAssignment") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSNamespaceExportDeclaration(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TSNamespaceExportDeclaration") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSTypeAnnotation(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TSTypeAnnotation") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSTypeParameterInstantiation(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TSTypeParameterInstantiation") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSTypeParameterDeclaration(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TSTypeParameterDeclaration") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSTypeParameter(node, opts) {
	  if (!node) return false;
	  if (node.type !== "TSTypeParameter") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isStandardized(node, opts) {
	  if (!node) return false;
	  switch (node.type) {
	    case "ArrayExpression":
	    case "AssignmentExpression":
	    case "BinaryExpression":
	    case "InterpreterDirective":
	    case "Directive":
	    case "DirectiveLiteral":
	    case "BlockStatement":
	    case "BreakStatement":
	    case "CallExpression":
	    case "CatchClause":
	    case "ConditionalExpression":
	    case "ContinueStatement":
	    case "DebuggerStatement":
	    case "DoWhileStatement":
	    case "EmptyStatement":
	    case "ExpressionStatement":
	    case "File":
	    case "ForInStatement":
	    case "ForStatement":
	    case "FunctionDeclaration":
	    case "FunctionExpression":
	    case "Identifier":
	    case "IfStatement":
	    case "LabeledStatement":
	    case "StringLiteral":
	    case "NumericLiteral":
	    case "NullLiteral":
	    case "BooleanLiteral":
	    case "RegExpLiteral":
	    case "LogicalExpression":
	    case "MemberExpression":
	    case "NewExpression":
	    case "Program":
	    case "ObjectExpression":
	    case "ObjectMethod":
	    case "ObjectProperty":
	    case "RestElement":
	    case "ReturnStatement":
	    case "SequenceExpression":
	    case "ParenthesizedExpression":
	    case "SwitchCase":
	    case "SwitchStatement":
	    case "ThisExpression":
	    case "ThrowStatement":
	    case "TryStatement":
	    case "UnaryExpression":
	    case "UpdateExpression":
	    case "VariableDeclaration":
	    case "VariableDeclarator":
	    case "WhileStatement":
	    case "WithStatement":
	    case "AssignmentPattern":
	    case "ArrayPattern":
	    case "ArrowFunctionExpression":
	    case "ClassBody":
	    case "ClassExpression":
	    case "ClassDeclaration":
	    case "ExportAllDeclaration":
	    case "ExportDefaultDeclaration":
	    case "ExportNamedDeclaration":
	    case "ExportSpecifier":
	    case "ForOfStatement":
	    case "ImportDeclaration":
	    case "ImportDefaultSpecifier":
	    case "ImportNamespaceSpecifier":
	    case "ImportSpecifier":
	    case "ImportExpression":
	    case "MetaProperty":
	    case "ClassMethod":
	    case "ObjectPattern":
	    case "SpreadElement":
	    case "Super":
	    case "TaggedTemplateExpression":
	    case "TemplateElement":
	    case "TemplateLiteral":
	    case "YieldExpression":
	    case "AwaitExpression":
	    case "Import":
	    case "BigIntLiteral":
	    case "ExportNamespaceSpecifier":
	    case "OptionalMemberExpression":
	    case "OptionalCallExpression":
	    case "ClassProperty":
	    case "ClassAccessorProperty":
	    case "ClassPrivateProperty":
	    case "ClassPrivateMethod":
	    case "PrivateName":
	    case "StaticBlock":
	      break;
	    case "Placeholder":
	      switch (node.expectedNode) {
	        case "Identifier":
	        case "StringLiteral":
	        case "BlockStatement":
	        case "ClassBody":
	          break;
	        default:
	          return false;
	      }
	      break;
	    default:
	      return false;
	  }
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isExpression(node, opts) {
	  if (!node) return false;
	  switch (node.type) {
	    case "ArrayExpression":
	    case "AssignmentExpression":
	    case "BinaryExpression":
	    case "CallExpression":
	    case "ConditionalExpression":
	    case "FunctionExpression":
	    case "Identifier":
	    case "StringLiteral":
	    case "NumericLiteral":
	    case "NullLiteral":
	    case "BooleanLiteral":
	    case "RegExpLiteral":
	    case "LogicalExpression":
	    case "MemberExpression":
	    case "NewExpression":
	    case "ObjectExpression":
	    case "SequenceExpression":
	    case "ParenthesizedExpression":
	    case "ThisExpression":
	    case "UnaryExpression":
	    case "UpdateExpression":
	    case "ArrowFunctionExpression":
	    case "ClassExpression":
	    case "ImportExpression":
	    case "MetaProperty":
	    case "Super":
	    case "TaggedTemplateExpression":
	    case "TemplateLiteral":
	    case "YieldExpression":
	    case "AwaitExpression":
	    case "Import":
	    case "BigIntLiteral":
	    case "OptionalMemberExpression":
	    case "OptionalCallExpression":
	    case "TypeCastExpression":
	    case "JSXElement":
	    case "JSXFragment":
	    case "BindExpression":
	    case "DoExpression":
	    case "RecordExpression":
	    case "TupleExpression":
	    case "DecimalLiteral":
	    case "ModuleExpression":
	    case "TopicReference":
	    case "PipelineTopicExpression":
	    case "PipelineBareFunction":
	    case "PipelinePrimaryTopicReference":
	    case "TSInstantiationExpression":
	    case "TSAsExpression":
	    case "TSSatisfiesExpression":
	    case "TSTypeAssertion":
	    case "TSNonNullExpression":
	      break;
	    case "Placeholder":
	      switch (node.expectedNode) {
	        case "Expression":
	        case "Identifier":
	        case "StringLiteral":
	          break;
	        default:
	          return false;
	      }
	      break;
	    default:
	      return false;
	  }
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isBinary(node, opts) {
	  if (!node) return false;
	  switch (node.type) {
	    case "BinaryExpression":
	    case "LogicalExpression":
	      break;
	    default:
	      return false;
	  }
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isScopable(node, opts) {
	  if (!node) return false;
	  switch (node.type) {
	    case "BlockStatement":
	    case "CatchClause":
	    case "DoWhileStatement":
	    case "ForInStatement":
	    case "ForStatement":
	    case "FunctionDeclaration":
	    case "FunctionExpression":
	    case "Program":
	    case "ObjectMethod":
	    case "SwitchStatement":
	    case "WhileStatement":
	    case "ArrowFunctionExpression":
	    case "ClassExpression":
	    case "ClassDeclaration":
	    case "ForOfStatement":
	    case "ClassMethod":
	    case "ClassPrivateMethod":
	    case "StaticBlock":
	    case "TSModuleBlock":
	      break;
	    case "Placeholder":
	      if (node.expectedNode === "BlockStatement") break;
	    default:
	      return false;
	  }
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isBlockParent(node, opts) {
	  if (!node) return false;
	  switch (node.type) {
	    case "BlockStatement":
	    case "CatchClause":
	    case "DoWhileStatement":
	    case "ForInStatement":
	    case "ForStatement":
	    case "FunctionDeclaration":
	    case "FunctionExpression":
	    case "Program":
	    case "ObjectMethod":
	    case "SwitchStatement":
	    case "WhileStatement":
	    case "ArrowFunctionExpression":
	    case "ForOfStatement":
	    case "ClassMethod":
	    case "ClassPrivateMethod":
	    case "StaticBlock":
	    case "TSModuleBlock":
	      break;
	    case "Placeholder":
	      if (node.expectedNode === "BlockStatement") break;
	    default:
	      return false;
	  }
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isBlock(node, opts) {
	  if (!node) return false;
	  switch (node.type) {
	    case "BlockStatement":
	    case "Program":
	    case "TSModuleBlock":
	      break;
	    case "Placeholder":
	      if (node.expectedNode === "BlockStatement") break;
	    default:
	      return false;
	  }
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isStatement(node, opts) {
	  if (!node) return false;
	  switch (node.type) {
	    case "BlockStatement":
	    case "BreakStatement":
	    case "ContinueStatement":
	    case "DebuggerStatement":
	    case "DoWhileStatement":
	    case "EmptyStatement":
	    case "ExpressionStatement":
	    case "ForInStatement":
	    case "ForStatement":
	    case "FunctionDeclaration":
	    case "IfStatement":
	    case "LabeledStatement":
	    case "ReturnStatement":
	    case "SwitchStatement":
	    case "ThrowStatement":
	    case "TryStatement":
	    case "VariableDeclaration":
	    case "WhileStatement":
	    case "WithStatement":
	    case "ClassDeclaration":
	    case "ExportAllDeclaration":
	    case "ExportDefaultDeclaration":
	    case "ExportNamedDeclaration":
	    case "ForOfStatement":
	    case "ImportDeclaration":
	    case "DeclareClass":
	    case "DeclareFunction":
	    case "DeclareInterface":
	    case "DeclareModule":
	    case "DeclareModuleExports":
	    case "DeclareTypeAlias":
	    case "DeclareOpaqueType":
	    case "DeclareVariable":
	    case "DeclareExportDeclaration":
	    case "DeclareExportAllDeclaration":
	    case "InterfaceDeclaration":
	    case "OpaqueType":
	    case "TypeAlias":
	    case "EnumDeclaration":
	    case "TSDeclareFunction":
	    case "TSInterfaceDeclaration":
	    case "TSTypeAliasDeclaration":
	    case "TSEnumDeclaration":
	    case "TSModuleDeclaration":
	    case "TSImportEqualsDeclaration":
	    case "TSExportAssignment":
	    case "TSNamespaceExportDeclaration":
	      break;
	    case "Placeholder":
	      switch (node.expectedNode) {
	        case "Statement":
	        case "Declaration":
	        case "BlockStatement":
	          break;
	        default:
	          return false;
	      }
	      break;
	    default:
	      return false;
	  }
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTerminatorless(node, opts) {
	  if (!node) return false;
	  switch (node.type) {
	    case "BreakStatement":
	    case "ContinueStatement":
	    case "ReturnStatement":
	    case "ThrowStatement":
	    case "YieldExpression":
	    case "AwaitExpression":
	      break;
	    default:
	      return false;
	  }
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isCompletionStatement(node, opts) {
	  if (!node) return false;
	  switch (node.type) {
	    case "BreakStatement":
	    case "ContinueStatement":
	    case "ReturnStatement":
	    case "ThrowStatement":
	      break;
	    default:
	      return false;
	  }
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isConditional(node, opts) {
	  if (!node) return false;
	  switch (node.type) {
	    case "ConditionalExpression":
	    case "IfStatement":
	      break;
	    default:
	      return false;
	  }
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isLoop(node, opts) {
	  if (!node) return false;
	  switch (node.type) {
	    case "DoWhileStatement":
	    case "ForInStatement":
	    case "ForStatement":
	    case "WhileStatement":
	    case "ForOfStatement":
	      break;
	    default:
	      return false;
	  }
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isWhile(node, opts) {
	  if (!node) return false;
	  switch (node.type) {
	    case "DoWhileStatement":
	    case "WhileStatement":
	      break;
	    default:
	      return false;
	  }
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isExpressionWrapper(node, opts) {
	  if (!node) return false;
	  switch (node.type) {
	    case "ExpressionStatement":
	    case "ParenthesizedExpression":
	    case "TypeCastExpression":
	      break;
	    default:
	      return false;
	  }
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isFor(node, opts) {
	  if (!node) return false;
	  switch (node.type) {
	    case "ForInStatement":
	    case "ForStatement":
	    case "ForOfStatement":
	      break;
	    default:
	      return false;
	  }
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isForXStatement(node, opts) {
	  if (!node) return false;
	  switch (node.type) {
	    case "ForInStatement":
	    case "ForOfStatement":
	      break;
	    default:
	      return false;
	  }
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isFunction(node, opts) {
	  if (!node) return false;
	  switch (node.type) {
	    case "FunctionDeclaration":
	    case "FunctionExpression":
	    case "ObjectMethod":
	    case "ArrowFunctionExpression":
	    case "ClassMethod":
	    case "ClassPrivateMethod":
	      break;
	    default:
	      return false;
	  }
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isFunctionParent(node, opts) {
	  if (!node) return false;
	  switch (node.type) {
	    case "FunctionDeclaration":
	    case "FunctionExpression":
	    case "ObjectMethod":
	    case "ArrowFunctionExpression":
	    case "ClassMethod":
	    case "ClassPrivateMethod":
	    case "StaticBlock":
	    case "TSModuleBlock":
	      break;
	    default:
	      return false;
	  }
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isPureish(node, opts) {
	  if (!node) return false;
	  switch (node.type) {
	    case "FunctionDeclaration":
	    case "FunctionExpression":
	    case "StringLiteral":
	    case "NumericLiteral":
	    case "NullLiteral":
	    case "BooleanLiteral":
	    case "RegExpLiteral":
	    case "ArrowFunctionExpression":
	    case "BigIntLiteral":
	    case "DecimalLiteral":
	      break;
	    case "Placeholder":
	      if (node.expectedNode === "StringLiteral") break;
	    default:
	      return false;
	  }
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isDeclaration(node, opts) {
	  if (!node) return false;
	  switch (node.type) {
	    case "FunctionDeclaration":
	    case "VariableDeclaration":
	    case "ClassDeclaration":
	    case "ExportAllDeclaration":
	    case "ExportDefaultDeclaration":
	    case "ExportNamedDeclaration":
	    case "ImportDeclaration":
	    case "DeclareClass":
	    case "DeclareFunction":
	    case "DeclareInterface":
	    case "DeclareModule":
	    case "DeclareModuleExports":
	    case "DeclareTypeAlias":
	    case "DeclareOpaqueType":
	    case "DeclareVariable":
	    case "DeclareExportDeclaration":
	    case "DeclareExportAllDeclaration":
	    case "InterfaceDeclaration":
	    case "OpaqueType":
	    case "TypeAlias":
	    case "EnumDeclaration":
	    case "TSDeclareFunction":
	    case "TSInterfaceDeclaration":
	    case "TSTypeAliasDeclaration":
	    case "TSEnumDeclaration":
	    case "TSModuleDeclaration":
	      break;
	    case "Placeholder":
	      if (node.expectedNode === "Declaration") break;
	    default:
	      return false;
	  }
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isPatternLike(node, opts) {
	  if (!node) return false;
	  switch (node.type) {
	    case "Identifier":
	    case "RestElement":
	    case "AssignmentPattern":
	    case "ArrayPattern":
	    case "ObjectPattern":
	    case "TSAsExpression":
	    case "TSSatisfiesExpression":
	    case "TSTypeAssertion":
	    case "TSNonNullExpression":
	      break;
	    case "Placeholder":
	      switch (node.expectedNode) {
	        case "Pattern":
	        case "Identifier":
	          break;
	        default:
	          return false;
	      }
	      break;
	    default:
	      return false;
	  }
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isLVal(node, opts) {
	  if (!node) return false;
	  switch (node.type) {
	    case "Identifier":
	    case "MemberExpression":
	    case "RestElement":
	    case "AssignmentPattern":
	    case "ArrayPattern":
	    case "ObjectPattern":
	    case "TSParameterProperty":
	    case "TSAsExpression":
	    case "TSSatisfiesExpression":
	    case "TSTypeAssertion":
	    case "TSNonNullExpression":
	      break;
	    case "Placeholder":
	      switch (node.expectedNode) {
	        case "Pattern":
	        case "Identifier":
	          break;
	        default:
	          return false;
	      }
	      break;
	    default:
	      return false;
	  }
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSEntityName(node, opts) {
	  if (!node) return false;
	  switch (node.type) {
	    case "Identifier":
	    case "TSQualifiedName":
	      break;
	    case "Placeholder":
	      if (node.expectedNode === "Identifier") break;
	    default:
	      return false;
	  }
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isLiteral(node, opts) {
	  if (!node) return false;
	  switch (node.type) {
	    case "StringLiteral":
	    case "NumericLiteral":
	    case "NullLiteral":
	    case "BooleanLiteral":
	    case "RegExpLiteral":
	    case "TemplateLiteral":
	    case "BigIntLiteral":
	    case "DecimalLiteral":
	      break;
	    case "Placeholder":
	      if (node.expectedNode === "StringLiteral") break;
	    default:
	      return false;
	  }
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isImmutable(node, opts) {
	  if (!node) return false;
	  switch (node.type) {
	    case "StringLiteral":
	    case "NumericLiteral":
	    case "NullLiteral":
	    case "BooleanLiteral":
	    case "BigIntLiteral":
	    case "JSXAttribute":
	    case "JSXClosingElement":
	    case "JSXElement":
	    case "JSXExpressionContainer":
	    case "JSXSpreadChild":
	    case "JSXOpeningElement":
	    case "JSXText":
	    case "JSXFragment":
	    case "JSXOpeningFragment":
	    case "JSXClosingFragment":
	    case "DecimalLiteral":
	      break;
	    case "Placeholder":
	      if (node.expectedNode === "StringLiteral") break;
	    default:
	      return false;
	  }
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isUserWhitespacable(node, opts) {
	  if (!node) return false;
	  switch (node.type) {
	    case "ObjectMethod":
	    case "ObjectProperty":
	    case "ObjectTypeInternalSlot":
	    case "ObjectTypeCallProperty":
	    case "ObjectTypeIndexer":
	    case "ObjectTypeProperty":
	    case "ObjectTypeSpreadProperty":
	      break;
	    default:
	      return false;
	  }
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isMethod(node, opts) {
	  if (!node) return false;
	  switch (node.type) {
	    case "ObjectMethod":
	    case "ClassMethod":
	    case "ClassPrivateMethod":
	      break;
	    default:
	      return false;
	  }
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isObjectMember(node, opts) {
	  if (!node) return false;
	  switch (node.type) {
	    case "ObjectMethod":
	    case "ObjectProperty":
	      break;
	    default:
	      return false;
	  }
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isProperty(node, opts) {
	  if (!node) return false;
	  switch (node.type) {
	    case "ObjectProperty":
	    case "ClassProperty":
	    case "ClassAccessorProperty":
	    case "ClassPrivateProperty":
	      break;
	    default:
	      return false;
	  }
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isUnaryLike(node, opts) {
	  if (!node) return false;
	  switch (node.type) {
	    case "UnaryExpression":
	    case "SpreadElement":
	      break;
	    default:
	      return false;
	  }
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isPattern(node, opts) {
	  if (!node) return false;
	  switch (node.type) {
	    case "AssignmentPattern":
	    case "ArrayPattern":
	    case "ObjectPattern":
	      break;
	    case "Placeholder":
	      if (node.expectedNode === "Pattern") break;
	    default:
	      return false;
	  }
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isClass(node, opts) {
	  if (!node) return false;
	  switch (node.type) {
	    case "ClassExpression":
	    case "ClassDeclaration":
	      break;
	    default:
	      return false;
	  }
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isImportOrExportDeclaration(node, opts) {
	  if (!node) return false;
	  switch (node.type) {
	    case "ExportAllDeclaration":
	    case "ExportDefaultDeclaration":
	    case "ExportNamedDeclaration":
	    case "ImportDeclaration":
	      break;
	    default:
	      return false;
	  }
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isExportDeclaration(node, opts) {
	  if (!node) return false;
	  switch (node.type) {
	    case "ExportAllDeclaration":
	    case "ExportDefaultDeclaration":
	    case "ExportNamedDeclaration":
	      break;
	    default:
	      return false;
	  }
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isModuleSpecifier(node, opts) {
	  if (!node) return false;
	  switch (node.type) {
	    case "ExportSpecifier":
	    case "ImportDefaultSpecifier":
	    case "ImportNamespaceSpecifier":
	    case "ImportSpecifier":
	    case "ExportNamespaceSpecifier":
	    case "ExportDefaultSpecifier":
	      break;
	    default:
	      return false;
	  }
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isAccessor(node, opts) {
	  if (!node) return false;
	  switch (node.type) {
	    case "ClassAccessorProperty":
	      break;
	    default:
	      return false;
	  }
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isPrivate(node, opts) {
	  if (!node) return false;
	  switch (node.type) {
	    case "ClassPrivateProperty":
	    case "ClassPrivateMethod":
	    case "PrivateName":
	      break;
	    default:
	      return false;
	  }
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isFlow(node, opts) {
	  if (!node) return false;
	  switch (node.type) {
	    case "AnyTypeAnnotation":
	    case "ArrayTypeAnnotation":
	    case "BooleanTypeAnnotation":
	    case "BooleanLiteralTypeAnnotation":
	    case "NullLiteralTypeAnnotation":
	    case "ClassImplements":
	    case "DeclareClass":
	    case "DeclareFunction":
	    case "DeclareInterface":
	    case "DeclareModule":
	    case "DeclareModuleExports":
	    case "DeclareTypeAlias":
	    case "DeclareOpaqueType":
	    case "DeclareVariable":
	    case "DeclareExportDeclaration":
	    case "DeclareExportAllDeclaration":
	    case "DeclaredPredicate":
	    case "ExistsTypeAnnotation":
	    case "FunctionTypeAnnotation":
	    case "FunctionTypeParam":
	    case "GenericTypeAnnotation":
	    case "InferredPredicate":
	    case "InterfaceExtends":
	    case "InterfaceDeclaration":
	    case "InterfaceTypeAnnotation":
	    case "IntersectionTypeAnnotation":
	    case "MixedTypeAnnotation":
	    case "EmptyTypeAnnotation":
	    case "NullableTypeAnnotation":
	    case "NumberLiteralTypeAnnotation":
	    case "NumberTypeAnnotation":
	    case "ObjectTypeAnnotation":
	    case "ObjectTypeInternalSlot":
	    case "ObjectTypeCallProperty":
	    case "ObjectTypeIndexer":
	    case "ObjectTypeProperty":
	    case "ObjectTypeSpreadProperty":
	    case "OpaqueType":
	    case "QualifiedTypeIdentifier":
	    case "StringLiteralTypeAnnotation":
	    case "StringTypeAnnotation":
	    case "SymbolTypeAnnotation":
	    case "ThisTypeAnnotation":
	    case "TupleTypeAnnotation":
	    case "TypeofTypeAnnotation":
	    case "TypeAlias":
	    case "TypeAnnotation":
	    case "TypeCastExpression":
	    case "TypeParameter":
	    case "TypeParameterDeclaration":
	    case "TypeParameterInstantiation":
	    case "UnionTypeAnnotation":
	    case "Variance":
	    case "VoidTypeAnnotation":
	    case "EnumDeclaration":
	    case "EnumBooleanBody":
	    case "EnumNumberBody":
	    case "EnumStringBody":
	    case "EnumSymbolBody":
	    case "EnumBooleanMember":
	    case "EnumNumberMember":
	    case "EnumStringMember":
	    case "EnumDefaultedMember":
	    case "IndexedAccessType":
	    case "OptionalIndexedAccessType":
	      break;
	    default:
	      return false;
	  }
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isFlowType(node, opts) {
	  if (!node) return false;
	  switch (node.type) {
	    case "AnyTypeAnnotation":
	    case "ArrayTypeAnnotation":
	    case "BooleanTypeAnnotation":
	    case "BooleanLiteralTypeAnnotation":
	    case "NullLiteralTypeAnnotation":
	    case "ExistsTypeAnnotation":
	    case "FunctionTypeAnnotation":
	    case "GenericTypeAnnotation":
	    case "InterfaceTypeAnnotation":
	    case "IntersectionTypeAnnotation":
	    case "MixedTypeAnnotation":
	    case "EmptyTypeAnnotation":
	    case "NullableTypeAnnotation":
	    case "NumberLiteralTypeAnnotation":
	    case "NumberTypeAnnotation":
	    case "ObjectTypeAnnotation":
	    case "StringLiteralTypeAnnotation":
	    case "StringTypeAnnotation":
	    case "SymbolTypeAnnotation":
	    case "ThisTypeAnnotation":
	    case "TupleTypeAnnotation":
	    case "TypeofTypeAnnotation":
	    case "UnionTypeAnnotation":
	    case "VoidTypeAnnotation":
	    case "IndexedAccessType":
	    case "OptionalIndexedAccessType":
	      break;
	    default:
	      return false;
	  }
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isFlowBaseAnnotation(node, opts) {
	  if (!node) return false;
	  switch (node.type) {
	    case "AnyTypeAnnotation":
	    case "BooleanTypeAnnotation":
	    case "NullLiteralTypeAnnotation":
	    case "MixedTypeAnnotation":
	    case "EmptyTypeAnnotation":
	    case "NumberTypeAnnotation":
	    case "StringTypeAnnotation":
	    case "SymbolTypeAnnotation":
	    case "ThisTypeAnnotation":
	    case "VoidTypeAnnotation":
	      break;
	    default:
	      return false;
	  }
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isFlowDeclaration(node, opts) {
	  if (!node) return false;
	  switch (node.type) {
	    case "DeclareClass":
	    case "DeclareFunction":
	    case "DeclareInterface":
	    case "DeclareModule":
	    case "DeclareModuleExports":
	    case "DeclareTypeAlias":
	    case "DeclareOpaqueType":
	    case "DeclareVariable":
	    case "DeclareExportDeclaration":
	    case "DeclareExportAllDeclaration":
	    case "InterfaceDeclaration":
	    case "OpaqueType":
	    case "TypeAlias":
	      break;
	    default:
	      return false;
	  }
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isFlowPredicate(node, opts) {
	  if (!node) return false;
	  switch (node.type) {
	    case "DeclaredPredicate":
	    case "InferredPredicate":
	      break;
	    default:
	      return false;
	  }
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isEnumBody(node, opts) {
	  if (!node) return false;
	  switch (node.type) {
	    case "EnumBooleanBody":
	    case "EnumNumberBody":
	    case "EnumStringBody":
	    case "EnumSymbolBody":
	      break;
	    default:
	      return false;
	  }
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isEnumMember(node, opts) {
	  if (!node) return false;
	  switch (node.type) {
	    case "EnumBooleanMember":
	    case "EnumNumberMember":
	    case "EnumStringMember":
	    case "EnumDefaultedMember":
	      break;
	    default:
	      return false;
	  }
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isJSX(node, opts) {
	  if (!node) return false;
	  switch (node.type) {
	    case "JSXAttribute":
	    case "JSXClosingElement":
	    case "JSXElement":
	    case "JSXEmptyExpression":
	    case "JSXExpressionContainer":
	    case "JSXSpreadChild":
	    case "JSXIdentifier":
	    case "JSXMemberExpression":
	    case "JSXNamespacedName":
	    case "JSXOpeningElement":
	    case "JSXSpreadAttribute":
	    case "JSXText":
	    case "JSXFragment":
	    case "JSXOpeningFragment":
	    case "JSXClosingFragment":
	      break;
	    default:
	      return false;
	  }
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isMiscellaneous(node, opts) {
	  if (!node) return false;
	  switch (node.type) {
	    case "Noop":
	    case "Placeholder":
	    case "V8IntrinsicIdentifier":
	      break;
	    default:
	      return false;
	  }
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTypeScript(node, opts) {
	  if (!node) return false;
	  switch (node.type) {
	    case "TSParameterProperty":
	    case "TSDeclareFunction":
	    case "TSDeclareMethod":
	    case "TSQualifiedName":
	    case "TSCallSignatureDeclaration":
	    case "TSConstructSignatureDeclaration":
	    case "TSPropertySignature":
	    case "TSMethodSignature":
	    case "TSIndexSignature":
	    case "TSAnyKeyword":
	    case "TSBooleanKeyword":
	    case "TSBigIntKeyword":
	    case "TSIntrinsicKeyword":
	    case "TSNeverKeyword":
	    case "TSNullKeyword":
	    case "TSNumberKeyword":
	    case "TSObjectKeyword":
	    case "TSStringKeyword":
	    case "TSSymbolKeyword":
	    case "TSUndefinedKeyword":
	    case "TSUnknownKeyword":
	    case "TSVoidKeyword":
	    case "TSThisType":
	    case "TSFunctionType":
	    case "TSConstructorType":
	    case "TSTypeReference":
	    case "TSTypePredicate":
	    case "TSTypeQuery":
	    case "TSTypeLiteral":
	    case "TSArrayType":
	    case "TSTupleType":
	    case "TSOptionalType":
	    case "TSRestType":
	    case "TSNamedTupleMember":
	    case "TSUnionType":
	    case "TSIntersectionType":
	    case "TSConditionalType":
	    case "TSInferType":
	    case "TSParenthesizedType":
	    case "TSTypeOperator":
	    case "TSIndexedAccessType":
	    case "TSMappedType":
	    case "TSLiteralType":
	    case "TSExpressionWithTypeArguments":
	    case "TSInterfaceDeclaration":
	    case "TSInterfaceBody":
	    case "TSTypeAliasDeclaration":
	    case "TSInstantiationExpression":
	    case "TSAsExpression":
	    case "TSSatisfiesExpression":
	    case "TSTypeAssertion":
	    case "TSEnumDeclaration":
	    case "TSEnumMember":
	    case "TSModuleDeclaration":
	    case "TSModuleBlock":
	    case "TSImportType":
	    case "TSImportEqualsDeclaration":
	    case "TSExternalModuleReference":
	    case "TSNonNullExpression":
	    case "TSExportAssignment":
	    case "TSNamespaceExportDeclaration":
	    case "TSTypeAnnotation":
	    case "TSTypeParameterInstantiation":
	    case "TSTypeParameterDeclaration":
	    case "TSTypeParameter":
	      break;
	    default:
	      return false;
	  }
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSTypeElement(node, opts) {
	  if (!node) return false;
	  switch (node.type) {
	    case "TSCallSignatureDeclaration":
	    case "TSConstructSignatureDeclaration":
	    case "TSPropertySignature":
	    case "TSMethodSignature":
	    case "TSIndexSignature":
	      break;
	    default:
	      return false;
	  }
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSType(node, opts) {
	  if (!node) return false;
	  switch (node.type) {
	    case "TSAnyKeyword":
	    case "TSBooleanKeyword":
	    case "TSBigIntKeyword":
	    case "TSIntrinsicKeyword":
	    case "TSNeverKeyword":
	    case "TSNullKeyword":
	    case "TSNumberKeyword":
	    case "TSObjectKeyword":
	    case "TSStringKeyword":
	    case "TSSymbolKeyword":
	    case "TSUndefinedKeyword":
	    case "TSUnknownKeyword":
	    case "TSVoidKeyword":
	    case "TSThisType":
	    case "TSFunctionType":
	    case "TSConstructorType":
	    case "TSTypeReference":
	    case "TSTypePredicate":
	    case "TSTypeQuery":
	    case "TSTypeLiteral":
	    case "TSArrayType":
	    case "TSTupleType":
	    case "TSOptionalType":
	    case "TSRestType":
	    case "TSUnionType":
	    case "TSIntersectionType":
	    case "TSConditionalType":
	    case "TSInferType":
	    case "TSParenthesizedType":
	    case "TSTypeOperator":
	    case "TSIndexedAccessType":
	    case "TSMappedType":
	    case "TSLiteralType":
	    case "TSExpressionWithTypeArguments":
	    case "TSImportType":
	      break;
	    default:
	      return false;
	  }
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isTSBaseType(node, opts) {
	  if (!node) return false;
	  switch (node.type) {
	    case "TSAnyKeyword":
	    case "TSBooleanKeyword":
	    case "TSBigIntKeyword":
	    case "TSIntrinsicKeyword":
	    case "TSNeverKeyword":
	    case "TSNullKeyword":
	    case "TSNumberKeyword":
	    case "TSObjectKeyword":
	    case "TSStringKeyword":
	    case "TSSymbolKeyword":
	    case "TSUndefinedKeyword":
	    case "TSUnknownKeyword":
	    case "TSVoidKeyword":
	    case "TSThisType":
	    case "TSLiteralType":
	      break;
	    default:
	      return false;
	  }
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isNumberLiteral(node, opts) {
	  (0, _deprecationWarning.default)("isNumberLiteral", "isNumericLiteral");
	  if (!node) return false;
	  if (node.type !== "NumberLiteral") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isRegexLiteral(node, opts) {
	  (0, _deprecationWarning.default)("isRegexLiteral", "isRegExpLiteral");
	  if (!node) return false;
	  if (node.type !== "RegexLiteral") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isRestProperty(node, opts) {
	  (0, _deprecationWarning.default)("isRestProperty", "isRestElement");
	  if (!node) return false;
	  if (node.type !== "RestProperty") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isSpreadProperty(node, opts) {
	  (0, _deprecationWarning.default)("isSpreadProperty", "isSpreadElement");
	  if (!node) return false;
	  if (node.type !== "SpreadProperty") return false;
	  return opts == null || (0, _shallowEqual.default)(node, opts);
	}
	function isModuleDeclaration(node, opts) {
	  (0, _deprecationWarning.default)("isModuleDeclaration", "isImportOrExportDeclaration");
	  return isImportOrExportDeclaration(node, opts);
	}

	
	return generated$3;
}

var hasRequiredMatchesPattern;

function requireMatchesPattern () {
	if (hasRequiredMatchesPattern) return matchesPattern;
	hasRequiredMatchesPattern = 1;

	Object.defineProperty(matchesPattern, "__esModule", {
	  value: true
	});
	matchesPattern.default = matchesPattern$1;
	var _index = requireGenerated$3();
	function matchesPattern$1(member, match, allowPartial) {
	  if (!(0, _index.isMemberExpression)(member)) return false;
	  const parts = Array.isArray(match) ? match : match.split(".");
	  const nodes = [];
	  let node;
	  for (node = member; (0, _index.isMemberExpression)(node); node = node.object) {
	    nodes.push(node.property);
	  }
	  nodes.push(node);
	  if (nodes.length < parts.length) return false;
	  if (!allowPartial && nodes.length > parts.length) return false;
	  for (let i = 0, j = nodes.length - 1; i < parts.length; i++, j--) {
	    const node = nodes[j];
	    let value;
	    if ((0, _index.isIdentifier)(node)) {
	      value = node.name;
	    } else if ((0, _index.isStringLiteral)(node)) {
	      value = node.value;
	    } else if ((0, _index.isThisExpression)(node)) {
	      value = "this";
	    } else {
	      return false;
	    }
	    if (parts[i] !== value) return false;
	  }
	  return true;
	}

	
	return matchesPattern;
}

var hasRequiredBuildMatchMemberExpression;

function requireBuildMatchMemberExpression () {
	if (hasRequiredBuildMatchMemberExpression) return buildMatchMemberExpression;
	hasRequiredBuildMatchMemberExpression = 1;

	Object.defineProperty(buildMatchMemberExpression, "__esModule", {
	  value: true
	});
	buildMatchMemberExpression.default = buildMatchMemberExpression$1;
	var _matchesPattern = requireMatchesPattern();
	function buildMatchMemberExpression$1(match, allowPartial) {
	  const parts = match.split(".");
	  return member => (0, _matchesPattern.default)(member, parts, allowPartial);
	}

	
	return buildMatchMemberExpression;
}

var hasRequiredIsReactComponent;

function requireIsReactComponent () {
	if (hasRequiredIsReactComponent) return isReactComponent;
	hasRequiredIsReactComponent = 1;

	Object.defineProperty(isReactComponent, "__esModule", {
	  value: true
	});
	isReactComponent.default = void 0;
	var _buildMatchMemberExpression = requireBuildMatchMemberExpression();
	const isReactComponent$1 = (0, _buildMatchMemberExpression.default)("React.Component");
	isReactComponent.default = isReactComponent$1;

	
	return isReactComponent;
}

var isCompatTag = {};

var hasRequiredIsCompatTag;

function requireIsCompatTag () {
	if (hasRequiredIsCompatTag) return isCompatTag;
	hasRequiredIsCompatTag = 1;

	Object.defineProperty(isCompatTag, "__esModule", {
	  value: true
	});
	isCompatTag.default = isCompatTag$1;
	function isCompatTag$1(tagName) {
	  return !!tagName && /^[a-z]/.test(tagName);
	}

	
	return isCompatTag;
}

var buildChildren = {};

var cleanJSXElementLiteralChild = {};

var generated$2 = {};

var validateNode = {};

var validate = {};

var definitions = {};

var toFastProperties;
var hasRequiredToFastProperties;

function requireToFastProperties () {
	if (hasRequiredToFastProperties) return toFastProperties;
	hasRequiredToFastProperties = 1;

	let fastProto = null;

	// Creates an object with permanently fast properties in V8. See Toon Verwaest's
	// post https://medium.com/@tverwaes/setting-up-prototypes-in-v8-ec9c9491dfe2#5f62
	// for more details. Use %HasFastProperties(object) and the Node.js flag
	// --allow-natives-syntax to check whether an object has fast properties.
	function FastObject(o) {
		// A prototype object will have "fast properties" enabled once it is checked
		// against the inline property cache of a function, e.g. fastProto.property:
		// https://github.com/v8/v8/blob/6.0.122/test/mjsunit/fast-prototype.js#L48-L63
		if (fastProto !== null && typeof fastProto.property) {
			const result = fastProto;
			fastProto = FastObject.prototype = null;
			return result;
		}
		fastProto = FastObject.prototype = o == null ? Object.create(null) : o;
		return new FastObject;
	}

	// Initialize the inline property cache of FastObject
	FastObject();

	toFastProperties = function toFastproperties(o) {
		return FastObject(o);
	};
	return toFastProperties;
}

var core$1 = {};

var is = {};

var isType = {};

var hasRequiredIsType;

function requireIsType () {
	if (hasRequiredIsType) return isType;
	hasRequiredIsType = 1;

	Object.defineProperty(isType, "__esModule", {
	  value: true
	});
	isType.default = isType$1;
	var _index = requireDefinitions();
	function isType$1(nodeType, targetType) {
	  if (nodeType === targetType) return true;
	  if (nodeType == null) return false;
	  if (_index.ALIAS_KEYS[targetType]) return false;
	  const aliases = _index.FLIPPED_ALIAS_KEYS[targetType];
	  if (aliases) {
	    if (aliases[0] === nodeType) return true;
	    for (const alias of aliases) {
	      if (nodeType === alias) return true;
	    }
	  }
	  return false;
	}

	
	return isType;
}

var isPlaceholderType = {};

var hasRequiredIsPlaceholderType;

function requireIsPlaceholderType () {
	if (hasRequiredIsPlaceholderType) return isPlaceholderType;
	hasRequiredIsPlaceholderType = 1;

	Object.defineProperty(isPlaceholderType, "__esModule", {
	  value: true
	});
	isPlaceholderType.default = isPlaceholderType$1;
	var _index = requireDefinitions();
	function isPlaceholderType$1(placeholderType, targetType) {
	  if (placeholderType === targetType) return true;
	  const aliases = _index.PLACEHOLDERS_ALIAS[placeholderType];
	  if (aliases) {
	    for (const alias of aliases) {
	      if (targetType === alias) return true;
	    }
	  }
	  return false;
	}

	
	return isPlaceholderType;
}

var hasRequiredIs;

function requireIs () {
	if (hasRequiredIs) return is;
	hasRequiredIs = 1;

	Object.defineProperty(is, "__esModule", {
	  value: true
	});
	is.default = is$1;
	var _shallowEqual = requireShallowEqual();
	var _isType = requireIsType();
	var _isPlaceholderType = requireIsPlaceholderType();
	var _index = requireDefinitions();
	function is$1(type, node, opts) {
	  if (!node) return false;
	  const matches = (0, _isType.default)(node.type, type);
	  if (!matches) {
	    if (!opts && node.type === "Placeholder" && type in _index.FLIPPED_ALIAS_KEYS) {
	      return (0, _isPlaceholderType.default)(node.expectedNode, type);
	    }
	    return false;
	  }
	  if (typeof opts === "undefined") {
	    return true;
	  } else {
	    return (0, _shallowEqual.default)(node, opts);
	  }
	}

	
	return is;
}

var isValidIdentifier = {};

var lib$f = {};

var identifier = {};

var hasRequiredIdentifier;

function requireIdentifier () {
	if (hasRequiredIdentifier) return identifier;
	hasRequiredIdentifier = 1;

	Object.defineProperty(identifier, "__esModule", {
	  value: true
	});
	identifier.isIdentifierChar = isIdentifierChar;
	identifier.isIdentifierName = isIdentifierName;
	identifier.isIdentifierStart = isIdentifierStart;
	let nonASCIIidentifierStartChars = "\xaa\xb5\xba\xc0-\xd6\xd8-\xf6\xf8-\u02c1\u02c6-\u02d1\u02e0-\u02e4\u02ec\u02ee\u0370-\u0374\u0376\u0377\u037a-\u037d\u037f\u0386\u0388-\u038a\u038c\u038e-\u03a1\u03a3-\u03f5\u03f7-\u0481\u048a-\u052f\u0531-\u0556\u0559\u0560-\u0588\u05d0-\u05ea\u05ef-\u05f2\u0620-\u064a\u066e\u066f\u0671-\u06d3\u06d5\u06e5\u06e6\u06ee\u06ef\u06fa-\u06fc\u06ff\u0710\u0712-\u072f\u074d-\u07a5\u07b1\u07ca-\u07ea\u07f4\u07f5\u07fa\u0800-\u0815\u081a\u0824\u0828\u0840-\u0858\u0860-\u086a\u0870-\u0887\u0889-\u088e\u08a0-\u08c9\u0904-\u0939\u093d\u0950\u0958-\u0961\u0971-\u0980\u0985-\u098c\u098f\u0990\u0993-\u09a8\u09aa-\u09b0\u09b2\u09b6-\u09b9\u09bd\u09ce\u09dc\u09dd\u09df-\u09e1\u09f0\u09f1\u09fc\u0a05-\u0a0a\u0a0f\u0a10\u0a13-\u0a28\u0a2a-\u0a30\u0a32\u0a33\u0a35\u0a36\u0a38\u0a39\u0a59-\u0a5c\u0a5e\u0a72-\u0a74\u0a85-\u0a8d\u0a8f-\u0a91\u0a93-\u0aa8\u0aaa-\u0ab0\u0ab2\u0ab3\u0ab5-\u0ab9\u0abd\u0ad0\u0ae0\u0ae1\u0af9\u0b05-\u0b0c\u0b0f\u0b10\u0b13-\u0b28\u0b2a-\u0b30\u0b32\u0b33\u0b35-\u0b39\u0b3d\u0b5c\u0b5d\u0b5f-\u0b61\u0b71\u0b83\u0b85-\u0b8a\u0b8e-\u0b90\u0b92-\u0b95\u0b99\u0b9a\u0b9c\u0b9e\u0b9f\u0ba3\u0ba4\u0ba8-\u0baa\u0bae-\u0bb9\u0bd0\u0c05-\u0c0c\u0c0e-\u0c10\u0c12-\u0c28\u0c2a-\u0c39\u0c3d\u0c58-\u0c5a\u0c5d\u0c60\u0c61\u0c80\u0c85-\u0c8c\u0c8e-\u0c90\u0c92-\u0ca8\u0caa-\u0cb3\u0cb5-\u0cb9\u0cbd\u0cdd\u0cde\u0ce0\u0ce1\u0cf1\u0cf2\u0d04-\u0d0c\u0d0e-\u0d10\u0d12-\u0d3a\u0d3d\u0d4e\u0d54-\u0d56\u0d5f-\u0d61\u0d7a-\u0d7f\u0d85-\u0d96\u0d9a-\u0db1\u0db3-\u0dbb\u0dbd\u0dc0-\u0dc6\u0e01-\u0e30\u0e32\u0e33\u0e40-\u0e46\u0e81\u0e82\u0e84\u0e86-\u0e8a\u0e8c-\u0ea3\u0ea5\u0ea7-\u0eb0\u0eb2\u0eb3\u0ebd\u0ec0-\u0ec4\u0ec6\u0edc-\u0edf\u0f00\u0f40-\u0f47\u0f49-\u0f6c\u0f88-\u0f8c\u1000-\u102a\u103f\u1050-\u1055\u105a-\u105d\u1061\u1065\u1066\u106e-\u1070\u1075-\u1081\u108e\u10a0-\u10c5\u10c7\u10cd\u10d0-\u10fa\u10fc-\u1248\u124a-\u124d\u1250-\u1256\u1258\u125a-\u125d\u1260-\u1288\u128a-\u128d\u1290-\u12b0\u12b2-\u12b5\u12b8-\u12be\u12c0\u12c2-\u12c5\u12c8-\u12d6\u12d8-\u1310\u1312-\u1315\u1318-\u135a\u1380-\u138f\u13a0-\u13f5\u13f8-\u13fd\u1401-\u166c\u166f-\u167f\u1681-\u169a\u16a0-\u16ea\u16ee-\u16f8\u1700-\u1711\u171f-\u1731\u1740-\u1751\u1760-\u176c\u176e-\u1770\u1780-\u17b3\u17d7\u17dc\u1820-\u1878\u1880-\u18a8\u18aa\u18b0-\u18f5\u1900-\u191e\u1950-\u196d\u1970-\u1974\u1980-\u19ab\u19b0-\u19c9\u1a00-\u1a16\u1a20-\u1a54\u1aa7\u1b05-\u1b33\u1b45-\u1b4c\u1b83-\u1ba0\u1bae\u1baf\u1bba-\u1be5\u1c00-\u1c23\u1c4d-\u1c4f\u1c5a-\u1c7d\u1c80-\u1c88\u1c90-\u1cba\u1cbd-\u1cbf\u1ce9-\u1cec\u1cee-\u1cf3\u1cf5\u1cf6\u1cfa\u1d00-\u1dbf\u1e00-\u1f15\u1f18-\u1f1d\u1f20-\u1f45\u1f48-\u1f4d\u1f50-\u1f57\u1f59\u1f5b\u1f5d\u1f5f-\u1f7d\u1f80-\u1fb4\u1fb6-\u1fbc\u1fbe\u1fc2-\u1fc4\u1fc6-\u1fcc\u1fd0-\u1fd3\u1fd6-\u1fdb\u1fe0-\u1fec\u1ff2-\u1ff4\u1ff6-\u1ffc\u2071\u207f\u2090-\u209c\u2102\u2107\u210a-\u2113\u2115\u2118-\u211d\u2124\u2126\u2128\u212a-\u2139\u213c-\u213f\u2145-\u2149\u214e\u2160-\u2188\u2c00-\u2ce4\u2ceb-\u2cee\u2cf2\u2cf3\u2d00-\u2d25\u2d27\u2d2d\u2d30-\u2d67\u2d6f\u2d80-\u2d96\u2da0-\u2da6\u2da8-\u2dae\u2db0-\u2db6\u2db8-\u2dbe\u2dc0-\u2dc6\u2dc8-\u2dce\u2dd0-\u2dd6\u2dd8-\u2dde\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303c\u3041-\u3096\u309b-\u309f\u30a1-\u30fa\u30fc-\u30ff\u3105-\u312f\u3131-\u318e\u31a0-\u31bf\u31f0-\u31ff\u3400-\u4dbf\u4e00-\ua48c\ua4d0-\ua4fd\ua500-\ua60c\ua610-\ua61f\ua62a\ua62b\ua640-\ua66e\ua67f-\ua69d\ua6a0-\ua6ef\ua717-\ua71f\ua722-\ua788\ua78b-\ua7ca\ua7d0\ua7d1\ua7d3\ua7d5-\ua7d9\ua7f2-\ua801\ua803-\ua805\ua807-\ua80a\ua80c-\ua822\ua840-\ua873\ua882-\ua8b3\ua8f2-\ua8f7\ua8fb\ua8fd\ua8fe\ua90a-\ua925\ua930-\ua946\ua960-\ua97c\ua984-\ua9b2\ua9cf\ua9e0-\ua9e4\ua9e6-\ua9ef\ua9fa-\ua9fe\uaa00-\uaa28\uaa40-\uaa42\uaa44-\uaa4b\uaa60-\uaa76\uaa7a\uaa7e-\uaaaf\uaab1\uaab5\uaab6\uaab9-\uaabd\uaac0\uaac2\uaadb-\uaadd\uaae0-\uaaea\uaaf2-\uaaf4\uab01-\uab06\uab09-\uab0e\uab11-\uab16\uab20-\uab26\uab28-\uab2e\uab30-\uab5a\uab5c-\uab69\uab70-\uabe2\uac00-\ud7a3\ud7b0-\ud7c6\ud7cb-\ud7fb\uf900-\ufa6d\ufa70-\ufad9\ufb00-\ufb06\ufb13-\ufb17\ufb1d\ufb1f-\ufb28\ufb2a-\ufb36\ufb38-\ufb3c\ufb3e\ufb40\ufb41\ufb43\ufb44\ufb46-\ufbb1\ufbd3-\ufd3d\ufd50-\ufd8f\ufd92-\ufdc7\ufdf0-\ufdfb\ufe70-\ufe74\ufe76-\ufefc\uff21-\uff3a\uff41-\uff5a\uff66-\uffbe\uffc2-\uffc7\uffca-\uffcf\uffd2-\uffd7\uffda-\uffdc";
	let nonASCIIidentifierChars = "\u200c\u200d\xb7\u0300-\u036f\u0387\u0483-\u0487\u0591-\u05bd\u05bf\u05c1\u05c2\u05c4\u05c5\u05c7\u0610-\u061a\u064b-\u0669\u0670\u06d6-\u06dc\u06df-\u06e4\u06e7\u06e8\u06ea-\u06ed\u06f0-\u06f9\u0711\u0730-\u074a\u07a6-\u07b0\u07c0-\u07c9\u07eb-\u07f3\u07fd\u0816-\u0819\u081b-\u0823\u0825-\u0827\u0829-\u082d\u0859-\u085b\u0898-\u089f\u08ca-\u08e1\u08e3-\u0903\u093a-\u093c\u093e-\u094f\u0951-\u0957\u0962\u0963\u0966-\u096f\u0981-\u0983\u09bc\u09be-\u09c4\u09c7\u09c8\u09cb-\u09cd\u09d7\u09e2\u09e3\u09e6-\u09ef\u09fe\u0a01-\u0a03\u0a3c\u0a3e-\u0a42\u0a47\u0a48\u0a4b-\u0a4d\u0a51\u0a66-\u0a71\u0a75\u0a81-\u0a83\u0abc\u0abe-\u0ac5\u0ac7-\u0ac9\u0acb-\u0acd\u0ae2\u0ae3\u0ae6-\u0aef\u0afa-\u0aff\u0b01-\u0b03\u0b3c\u0b3e-\u0b44\u0b47\u0b48\u0b4b-\u0b4d\u0b55-\u0b57\u0b62\u0b63\u0b66-\u0b6f\u0b82\u0bbe-\u0bc2\u0bc6-\u0bc8\u0bca-\u0bcd\u0bd7\u0be6-\u0bef\u0c00-\u0c04\u0c3c\u0c3e-\u0c44\u0c46-\u0c48\u0c4a-\u0c4d\u0c55\u0c56\u0c62\u0c63\u0c66-\u0c6f\u0c81-\u0c83\u0cbc\u0cbe-\u0cc4\u0cc6-\u0cc8\u0cca-\u0ccd\u0cd5\u0cd6\u0ce2\u0ce3\u0ce6-\u0cef\u0cf3\u0d00-\u0d03\u0d3b\u0d3c\u0d3e-\u0d44\u0d46-\u0d48\u0d4a-\u0d4d\u0d57\u0d62\u0d63\u0d66-\u0d6f\u0d81-\u0d83\u0dca\u0dcf-\u0dd4\u0dd6\u0dd8-\u0ddf\u0de6-\u0def\u0df2\u0df3\u0e31\u0e34-\u0e3a\u0e47-\u0e4e\u0e50-\u0e59\u0eb1\u0eb4-\u0ebc\u0ec8-\u0ece\u0ed0-\u0ed9\u0f18\u0f19\u0f20-\u0f29\u0f35\u0f37\u0f39\u0f3e\u0f3f\u0f71-\u0f84\u0f86\u0f87\u0f8d-\u0f97\u0f99-\u0fbc\u0fc6\u102b-\u103e\u1040-\u1049\u1056-\u1059\u105e-\u1060\u1062-\u1064\u1067-\u106d\u1071-\u1074\u1082-\u108d\u108f-\u109d\u135d-\u135f\u1369-\u1371\u1712-\u1715\u1732-\u1734\u1752\u1753\u1772\u1773\u17b4-\u17d3\u17dd\u17e0-\u17e9\u180b-\u180d\u180f-\u1819\u18a9\u1920-\u192b\u1930-\u193b\u1946-\u194f\u19d0-\u19da\u1a17-\u1a1b\u1a55-\u1a5e\u1a60-\u1a7c\u1a7f-\u1a89\u1a90-\u1a99\u1ab0-\u1abd\u1abf-\u1ace\u1b00-\u1b04\u1b34-\u1b44\u1b50-\u1b59\u1b6b-\u1b73\u1b80-\u1b82\u1ba1-\u1bad\u1bb0-\u1bb9\u1be6-\u1bf3\u1c24-\u1c37\u1c40-\u1c49\u1c50-\u1c59\u1cd0-\u1cd2\u1cd4-\u1ce8\u1ced\u1cf4\u1cf7-\u1cf9\u1dc0-\u1dff\u200c\u200d\u203f\u2040\u2054\u20d0-\u20dc\u20e1\u20e5-\u20f0\u2cef-\u2cf1\u2d7f\u2de0-\u2dff\u302a-\u302f\u3099\u309a\u30fb\ua620-\ua629\ua66f\ua674-\ua67d\ua69e\ua69f\ua6f0\ua6f1\ua802\ua806\ua80b\ua823-\ua827\ua82c\ua880\ua881\ua8b4-\ua8c5\ua8d0-\ua8d9\ua8e0-\ua8f1\ua8ff-\ua909\ua926-\ua92d\ua947-\ua953\ua980-\ua983\ua9b3-\ua9c0\ua9d0-\ua9d9\ua9e5\ua9f0-\ua9f9\uaa29-\uaa36\uaa43\uaa4c\uaa4d\uaa50-\uaa59\uaa7b-\uaa7d\uaab0\uaab2-\uaab4\uaab7\uaab8\uaabe\uaabf\uaac1\uaaeb-\uaaef\uaaf5\uaaf6\uabe3-\uabea\uabec\uabed\uabf0-\uabf9\ufb1e\ufe00-\ufe0f\ufe20-\ufe2f\ufe33\ufe34\ufe4d-\ufe4f\uff10-\uff19\uff3f\uff65";
	const nonASCIIidentifierStart = new RegExp("[" + nonASCIIidentifierStartChars + "]");
	const nonASCIIidentifier = new RegExp("[" + nonASCIIidentifierStartChars + nonASCIIidentifierChars + "]");
	nonASCIIidentifierStartChars = nonASCIIidentifierChars = null;
	const astralIdentifierStartCodes = [0, 11, 2, 25, 2, 18, 2, 1, 2, 14, 3, 13, 35, 122, 70, 52, 268, 28, 4, 48, 48, 31, 14, 29, 6, 37, 11, 29, 3, 35, 5, 7, 2, 4, 43, 157, 19, 35, 5, 35, 5, 39, 9, 51, 13, 10, 2, 14, 2, 6, 2, 1, 2, 10, 2, 14, 2, 6, 2, 1, 68, 310, 10, 21, 11, 7, 25, 5, 2, 41, 2, 8, 70, 5, 3, 0, 2, 43, 2, 1, 4, 0, 3, 22, 11, 22, 10, 30, 66, 18, 2, 1, 11, 21, 11, 25, 71, 55, 7, 1, 65, 0, 16, 3, 2, 2, 2, 28, 43, 28, 4, 28, 36, 7, 2, 27, 28, 53, 11, 21, 11, 18, 14, 17, 111, 72, 56, 50, 14, 50, 14, 35, 349, 41, 7, 1, 79, 28, 11, 0, 9, 21, 43, 17, 47, 20, 28, 22, 13, 52, 58, 1, 3, 0, 14, 44, 33, 24, 27, 35, 30, 0, 3, 0, 9, 34, 4, 0, 13, 47, 15, 3, 22, 0, 2, 0, 36, 17, 2, 24, 20, 1, 64, 6, 2, 0, 2, 3, 2, 14, 2, 9, 8, 46, 39, 7, 3, 1, 3, 21, 2, 6, 2, 1, 2, 4, 4, 0, 19, 0, 13, 4, 159, 52, 19, 3, 21, 2, 31, 47, 21, 1, 2, 0, 185, 46, 42, 3, 37, 47, 21, 0, 60, 42, 14, 0, 72, 26, 38, 6, 186, 43, 117, 63, 32, 7, 3, 0, 3, 7, 2, 1, 2, 23, 16, 0, 2, 0, 95, 7, 3, 38, 17, 0, 2, 0, 29, 0, 11, 39, 8, 0, 22, 0, 12, 45, 20, 0, 19, 72, 264, 8, 2, 36, 18, 0, 50, 29, 113, 6, 2, 1, 2, 37, 22, 0, 26, 5, 2, 1, 2, 31, 15, 0, 328, 18, 16, 0, 2, 12, 2, 33, 125, 0, 80, 921, 103, 110, 18, 195, 2637, 96, 16, 1071, 18, 5, 4026, 582, 8634, 568, 8, 30, 18, 78, 18, 29, 19, 47, 17, 3, 32, 20, 6, 18, 689, 63, 129, 74, 6, 0, 67, 12, 65, 1, 2, 0, 29, 6135, 9, 1237, 43, 8, 8936, 3, 2, 6, 2, 1, 2, 290, 16, 0, 30, 2, 3, 0, 15, 3, 9, 395, 2309, 106, 6, 12, 4, 8, 8, 9, 5991, 84, 2, 70, 2, 1, 3, 0, 3, 1, 3, 3, 2, 11, 2, 0, 2, 6, 2, 64, 2, 3, 3, 7, 2, 6, 2, 27, 2, 3, 2, 4, 2, 0, 4, 6, 2, 339, 3, 24, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 7, 1845, 30, 7, 5, 262, 61, 147, 44, 11, 6, 17, 0, 322, 29, 19, 43, 485, 27, 757, 6, 2, 3, 2, 1, 2, 14, 2, 196, 60, 67, 8, 0, 1205, 3, 2, 26, 2, 1, 2, 0, 3, 0, 2, 9, 2, 3, 2, 0, 2, 0, 7, 0, 5, 0, 2, 0, 2, 0, 2, 2, 2, 1, 2, 0, 3, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 1, 2, 0, 3, 3, 2, 6, 2, 3, 2, 3, 2, 0, 2, 9, 2, 16, 6, 2, 2, 4, 2, 16, 4421, 42719, 33, 4153, 7, 221, 3, 5761, 15, 7472, 16, 621, 2467, 541, 1507, 4938, 6, 4191];
	const astralIdentifierCodes = [509, 0, 227, 0, 150, 4, 294, 9, 1368, 2, 2, 1, 6, 3, 41, 2, 5, 0, 166, 1, 574, 3, 9, 9, 370, 1, 81, 2, 71, 10, 50, 3, 123, 2, 54, 14, 32, 10, 3, 1, 11, 3, 46, 10, 8, 0, 46, 9, 7, 2, 37, 13, 2, 9, 6, 1, 45, 0, 13, 2, 49, 13, 9, 3, 2, 11, 83, 11, 7, 0, 3, 0, 158, 11, 6, 9, 7, 3, 56, 1, 2, 6, 3, 1, 3, 2, 10, 0, 11, 1, 3, 6, 4, 4, 193, 17, 10, 9, 5, 0, 82, 19, 13, 9, 214, 6, 3, 8, 28, 1, 83, 16, 16, 9, 82, 12, 9, 9, 84, 14, 5, 9, 243, 14, 166, 9, 71, 5, 2, 1, 3, 3, 2, 0, 2, 1, 13, 9, 120, 6, 3, 6, 4, 0, 29, 9, 41, 6, 2, 3, 9, 0, 10, 10, 47, 15, 406, 7, 2, 7, 17, 9, 57, 21, 2, 13, 123, 5, 4, 0, 2, 1, 2, 6, 2, 0, 9, 9, 49, 4, 2, 1, 2, 4, 9, 9, 330, 3, 10, 1, 2, 0, 49, 6, 4, 4, 14, 9, 5351, 0, 7, 14, 13835, 9, 87, 9, 39, 4, 60, 6, 26, 9, 1014, 0, 2, 54, 8, 3, 82, 0, 12, 1, 19628, 1, 4706, 45, 3, 22, 543, 4, 4, 5, 9, 7, 3, 6, 31, 3, 149, 2, 1418, 49, 513, 54, 5, 49, 9, 0, 15, 0, 23, 4, 2, 14, 1361, 6, 2, 16, 3, 6, 2, 1, 2, 4, 101, 0, 161, 6, 10, 9, 357, 0, 62, 13, 499, 13, 983, 6, 110, 6, 6, 9, 4759, 9, 787719, 239];
	function isInAstralSet(code, set) {
	  let pos = 0x10000;
	  for (let i = 0, length = set.length; i < length; i += 2) {
	    pos += set[i];
	    if (pos > code) return false;
	    pos += set[i + 1];
	    if (pos >= code) return true;
	  }
	  return false;
	}
	function isIdentifierStart(code) {
	  if (code < 65) return code === 36;
	  if (code <= 90) return true;
	  if (code < 97) return code === 95;
	  if (code <= 122) return true;
	  if (code <= 0xffff) {
	    return code >= 0xaa && nonASCIIidentifierStart.test(String.fromCharCode(code));
	  }
	  return isInAstralSet(code, astralIdentifierStartCodes);
	}
	function isIdentifierChar(code) {
	  if (code < 48) return code === 36;
	  if (code < 58) return true;
	  if (code < 65) return false;
	  if (code <= 90) return true;
	  if (code < 97) return code === 95;
	  if (code <= 122) return true;
	  if (code <= 0xffff) {
	    return code >= 0xaa && nonASCIIidentifier.test(String.fromCharCode(code));
	  }
	  return isInAstralSet(code, astralIdentifierStartCodes) || isInAstralSet(code, astralIdentifierCodes);
	}
	function isIdentifierName(name) {
	  let isFirst = true;
	  for (let i = 0; i < name.length; i++) {
	    let cp = name.charCodeAt(i);
	    if ((cp & 0xfc00) === 0xd800 && i + 1 < name.length) {
	      const trail = name.charCodeAt(++i);
	      if ((trail & 0xfc00) === 0xdc00) {
	        cp = 0x10000 + ((cp & 0x3ff) << 10) + (trail & 0x3ff);
	      }
	    }
	    if (isFirst) {
	      isFirst = false;
	      if (!isIdentifierStart(cp)) {
	        return false;
	      }
	    } else if (!isIdentifierChar(cp)) {
	      return false;
	    }
	  }
	  return !isFirst;
	}

	
	return identifier;
}

var keyword = {};

var hasRequiredKeyword;

function requireKeyword () {
	if (hasRequiredKeyword) return keyword;
	hasRequiredKeyword = 1;

	Object.defineProperty(keyword, "__esModule", {
	  value: true
	});
	keyword.isKeyword = isKeyword;
	keyword.isReservedWord = isReservedWord;
	keyword.isStrictBindOnlyReservedWord = isStrictBindOnlyReservedWord;
	keyword.isStrictBindReservedWord = isStrictBindReservedWord;
	keyword.isStrictReservedWord = isStrictReservedWord;
	const reservedWords = {
	  keyword: ["break", "case", "catch", "continue", "debugger", "default", "do", "else", "finally", "for", "function", "if", "return", "switch", "throw", "try", "var", "const", "while", "with", "new", "this", "super", "class", "extends", "export", "import", "null", "true", "false", "in", "instanceof", "typeof", "void", "delete"],
	  strict: ["implements", "interface", "let", "package", "private", "protected", "public", "static", "yield"],
	  strictBind: ["eval", "arguments"]
	};
	const keywords = new Set(reservedWords.keyword);
	const reservedWordsStrictSet = new Set(reservedWords.strict);
	const reservedWordsStrictBindSet = new Set(reservedWords.strictBind);
	function isReservedWord(word, inModule) {
	  return inModule && word === "await" || word === "enum";
	}
	function isStrictReservedWord(word, inModule) {
	  return isReservedWord(word, inModule) || reservedWordsStrictSet.has(word);
	}
	function isStrictBindOnlyReservedWord(word) {
	  return reservedWordsStrictBindSet.has(word);
	}
	function isStrictBindReservedWord(word, inModule) {
	  return isStrictReservedWord(word, inModule) || isStrictBindOnlyReservedWord(word);
	}
	function isKeyword(word) {
	  return keywords.has(word);
	}

	
	return keyword;
}

var hasRequiredLib$j;

function requireLib$j () {
	if (hasRequiredLib$j) return lib$f;
	hasRequiredLib$j = 1;
	(function (exports) {

		Object.defineProperty(exports, "__esModule", {
		  value: true
		});
		Object.defineProperty(exports, "isIdentifierChar", {
		  enumerable: true,
		  get: function () {
		    return _identifier.isIdentifierChar;
		  }
		});
		Object.defineProperty(exports, "isIdentifierName", {
		  enumerable: true,
		  get: function () {
		    return _identifier.isIdentifierName;
		  }
		});
		Object.defineProperty(exports, "isIdentifierStart", {
		  enumerable: true,
		  get: function () {
		    return _identifier.isIdentifierStart;
		  }
		});
		Object.defineProperty(exports, "isKeyword", {
		  enumerable: true,
		  get: function () {
		    return _keyword.isKeyword;
		  }
		});
		Object.defineProperty(exports, "isReservedWord", {
		  enumerable: true,
		  get: function () {
		    return _keyword.isReservedWord;
		  }
		});
		Object.defineProperty(exports, "isStrictBindOnlyReservedWord", {
		  enumerable: true,
		  get: function () {
		    return _keyword.isStrictBindOnlyReservedWord;
		  }
		});
		Object.defineProperty(exports, "isStrictBindReservedWord", {
		  enumerable: true,
		  get: function () {
		    return _keyword.isStrictBindReservedWord;
		  }
		});
		Object.defineProperty(exports, "isStrictReservedWord", {
		  enumerable: true,
		  get: function () {
		    return _keyword.isStrictReservedWord;
		  }
		});
		var _identifier = requireIdentifier();
		var _keyword = requireKeyword();

		
	} (lib$f));
	return lib$f;
}

var hasRequiredIsValidIdentifier;

function requireIsValidIdentifier () {
	if (hasRequiredIsValidIdentifier) return isValidIdentifier;
	hasRequiredIsValidIdentifier = 1;

	Object.defineProperty(isValidIdentifier, "__esModule", {
	  value: true
	});
	isValidIdentifier.default = isValidIdentifier$1;
	var _helperValidatorIdentifier = requireLib$j();
	function isValidIdentifier$1(name, reserved = true) {
	  if (typeof name !== "string") return false;
	  if (reserved) {
	    if ((0, _helperValidatorIdentifier.isKeyword)(name) || (0, _helperValidatorIdentifier.isStrictReservedWord)(name, true)) {
	      return false;
	    }
	  }
	  return (0, _helperValidatorIdentifier.isIdentifierName)(name);
	}

	
	return isValidIdentifier;
}

var lib$e = {};

var hasRequiredLib$i;

function requireLib$i () {
	if (hasRequiredLib$i) return lib$e;
	hasRequiredLib$i = 1;

	Object.defineProperty(lib$e, "__esModule", {
	  value: true
	});
	lib$e.readCodePoint = readCodePoint;
	lib$e.readInt = readInt;
	lib$e.readStringContents = readStringContents;
	var _isDigit = function isDigit(code) {
	  return code >= 48 && code <= 57;
	};
	const forbiddenNumericSeparatorSiblings = {
	  decBinOct: new Set([46, 66, 69, 79, 95, 98, 101, 111]),
	  hex: new Set([46, 88, 95, 120])
	};
	const isAllowedNumericSeparatorSibling = {
	  bin: ch => ch === 48 || ch === 49,
	  oct: ch => ch >= 48 && ch <= 55,
	  dec: ch => ch >= 48 && ch <= 57,
	  hex: ch => ch >= 48 && ch <= 57 || ch >= 65 && ch <= 70 || ch >= 97 && ch <= 102
	};
	function readStringContents(type, input, pos, lineStart, curLine, errors) {
	  const initialPos = pos;
	  const initialLineStart = lineStart;
	  const initialCurLine = curLine;
	  let out = "";
	  let firstInvalidLoc = null;
	  let chunkStart = pos;
	  const {
	    length
	  } = input;
	  for (;;) {
	    if (pos >= length) {
	      errors.unterminated(initialPos, initialLineStart, initialCurLine);
	      out += input.slice(chunkStart, pos);
	      break;
	    }
	    const ch = input.charCodeAt(pos);
	    if (isStringEnd(type, ch, input, pos)) {
	      out += input.slice(chunkStart, pos);
	      break;
	    }
	    if (ch === 92) {
	      out += input.slice(chunkStart, pos);
	      const res = readEscapedChar(input, pos, lineStart, curLine, type === "template", errors);
	      if (res.ch === null && !firstInvalidLoc) {
	        firstInvalidLoc = {
	          pos,
	          lineStart,
	          curLine
	        };
	      } else {
	        out += res.ch;
	      }
	      ({
	        pos,
	        lineStart,
	        curLine
	      } = res);
	      chunkStart = pos;
	    } else if (ch === 8232 || ch === 8233) {
	      ++pos;
	      ++curLine;
	      lineStart = pos;
	    } else if (ch === 10 || ch === 13) {
	      if (type === "template") {
	        out += input.slice(chunkStart, pos) + "\n";
	        ++pos;
	        if (ch === 13 && input.charCodeAt(pos) === 10) {
	          ++pos;
	        }
	        ++curLine;
	        chunkStart = lineStart = pos;
	      } else {
	        errors.unterminated(initialPos, initialLineStart, initialCurLine);
	      }
	    } else {
	      ++pos;
	    }
	  }
	  return {
	    pos,
	    str: out,
	    firstInvalidLoc,
	    lineStart,
	    curLine,
	    containsInvalid: !!firstInvalidLoc
	  };
	}
	function isStringEnd(type, ch, input, pos) {
	  if (type === "template") {
	    return ch === 96 || ch === 36 && input.charCodeAt(pos + 1) === 123;
	  }
	  return ch === (type === "double" ? 34 : 39);
	}
	function readEscapedChar(input, pos, lineStart, curLine, inTemplate, errors) {
	  const throwOnInvalid = !inTemplate;
	  pos++;
	  const res = ch => ({
	    pos,
	    ch,
	    lineStart,
	    curLine
	  });
	  const ch = input.charCodeAt(pos++);
	  switch (ch) {
	    case 110:
	      return res("\n");
	    case 114:
	      return res("\r");
	    case 120:
	      {
	        let code;
	        ({
	          code,
	          pos
	        } = readHexChar(input, pos, lineStart, curLine, 2, false, throwOnInvalid, errors));
	        return res(code === null ? null : String.fromCharCode(code));
	      }
	    case 117:
	      {
	        let code;
	        ({
	          code,
	          pos
	        } = readCodePoint(input, pos, lineStart, curLine, throwOnInvalid, errors));
	        return res(code === null ? null : String.fromCodePoint(code));
	      }
	    case 116:
	      return res("\t");
	    case 98:
	      return res("\b");
	    case 118:
	      return res("\u000b");
	    case 102:
	      return res("\f");
	    case 13:
	      if (input.charCodeAt(pos) === 10) {
	        ++pos;
	      }
	    case 10:
	      lineStart = pos;
	      ++curLine;
	    case 8232:
	    case 8233:
	      return res("");
	    case 56:
	    case 57:
	      if (inTemplate) {
	        return res(null);
	      } else {
	        errors.strictNumericEscape(pos - 1, lineStart, curLine);
	      }
	    default:
	      if (ch >= 48 && ch <= 55) {
	        const startPos = pos - 1;
	        const match = input.slice(startPos, pos + 2).match(/^[0-7]+/);
	        let octalStr = match[0];
	        let octal = parseInt(octalStr, 8);
	        if (octal > 255) {
	          octalStr = octalStr.slice(0, -1);
	          octal = parseInt(octalStr, 8);
	        }
	        pos += octalStr.length - 1;
	        const next = input.charCodeAt(pos);
	        if (octalStr !== "0" || next === 56 || next === 57) {
	          if (inTemplate) {
	            return res(null);
	          } else {
	            errors.strictNumericEscape(startPos, lineStart, curLine);
	          }
	        }
	        return res(String.fromCharCode(octal));
	      }
	      return res(String.fromCharCode(ch));
	  }
	}
	function readHexChar(input, pos, lineStart, curLine, len, forceLen, throwOnInvalid, errors) {
	  const initialPos = pos;
	  let n;
	  ({
	    n,
	    pos
	  } = readInt(input, pos, lineStart, curLine, 16, len, forceLen, false, errors, !throwOnInvalid));
	  if (n === null) {
	    if (throwOnInvalid) {
	      errors.invalidEscapeSequence(initialPos, lineStart, curLine);
	    } else {
	      pos = initialPos - 1;
	    }
	  }
	  return {
	    code: n,
	    pos
	  };
	}
	function readInt(input, pos, lineStart, curLine, radix, len, forceLen, allowNumSeparator, errors, bailOnError) {
	  const start = pos;
	  const forbiddenSiblings = radix === 16 ? forbiddenNumericSeparatorSiblings.hex : forbiddenNumericSeparatorSiblings.decBinOct;
	  const isAllowedSibling = radix === 16 ? isAllowedNumericSeparatorSibling.hex : radix === 10 ? isAllowedNumericSeparatorSibling.dec : radix === 8 ? isAllowedNumericSeparatorSibling.oct : isAllowedNumericSeparatorSibling.bin;
	  let invalid = false;
	  let total = 0;
	  for (let i = 0, e = len == null ? Infinity : len; i < e; ++i) {
	    const code = input.charCodeAt(pos);
	    let val;
	    if (code === 95 && allowNumSeparator !== "bail") {
	      const prev = input.charCodeAt(pos - 1);
	      const next = input.charCodeAt(pos + 1);
	      if (!allowNumSeparator) {
	        if (bailOnError) return {
	          n: null,
	          pos
	        };
	        errors.numericSeparatorInEscapeSequence(pos, lineStart, curLine);
	      } else if (Number.isNaN(next) || !isAllowedSibling(next) || forbiddenSiblings.has(prev) || forbiddenSiblings.has(next)) {
	        if (bailOnError) return {
	          n: null,
	          pos
	        };
	        errors.unexpectedNumericSeparator(pos, lineStart, curLine);
	      }
	      ++pos;
	      continue;
	    }
	    if (code >= 97) {
	      val = code - 97 + 10;
	    } else if (code >= 65) {
	      val = code - 65 + 10;
	    } else if (_isDigit(code)) {
	      val = code - 48;
	    } else {
	      val = Infinity;
	    }
	    if (val >= radix) {
	      if (val <= 9 && bailOnError) {
	        return {
	          n: null,
	          pos
	        };
	      } else if (val <= 9 && errors.invalidDigit(pos, lineStart, curLine, radix)) {
	        val = 0;
	      } else if (forceLen) {
	        val = 0;
	        invalid = true;
	      } else {
	        break;
	      }
	    }
	    ++pos;
	    total = total * radix + val;
	  }
	  if (pos === start || len != null && pos - start !== len || invalid) {
	    return {
	      n: null,
	      pos
	    };
	  }
	  return {
	    n: total,
	    pos
	  };
	}
	function readCodePoint(input, pos, lineStart, curLine, throwOnInvalid, errors) {
	  const ch = input.charCodeAt(pos);
	  let code;
	  if (ch === 123) {
	    ++pos;
	    ({
	      code,
	      pos
	    } = readHexChar(input, pos, lineStart, curLine, input.indexOf("}", pos) - pos, true, throwOnInvalid, errors));
	    ++pos;
	    if (code !== null && code > 0x10ffff) {
	      if (throwOnInvalid) {
	        errors.invalidCodePoint(pos, lineStart, curLine);
	      } else {
	        return {
	          code: null,
	          pos
	        };
	      }
	    }
	  } else {
	    ({
	      code,
	      pos
	    } = readHexChar(input, pos, lineStart, curLine, 4, false, throwOnInvalid, errors));
	  }
	  return {
	    code,
	    pos
	  };
	}

	
	return lib$e;
}

var constants$2 = {};

var hasRequiredConstants;

function requireConstants () {
	if (hasRequiredConstants) return constants$2;
	hasRequiredConstants = 1;

	Object.defineProperty(constants$2, "__esModule", {
	  value: true
	});
	constants$2.UPDATE_OPERATORS = constants$2.UNARY_OPERATORS = constants$2.STRING_UNARY_OPERATORS = constants$2.STATEMENT_OR_BLOCK_KEYS = constants$2.NUMBER_UNARY_OPERATORS = constants$2.NUMBER_BINARY_OPERATORS = constants$2.NOT_LOCAL_BINDING = constants$2.LOGICAL_OPERATORS = constants$2.INHERIT_KEYS = constants$2.FOR_INIT_KEYS = constants$2.FLATTENABLE_KEYS = constants$2.EQUALITY_BINARY_OPERATORS = constants$2.COMPARISON_BINARY_OPERATORS = constants$2.COMMENT_KEYS = constants$2.BOOLEAN_UNARY_OPERATORS = constants$2.BOOLEAN_NUMBER_BINARY_OPERATORS = constants$2.BOOLEAN_BINARY_OPERATORS = constants$2.BLOCK_SCOPED_SYMBOL = constants$2.BINARY_OPERATORS = constants$2.ASSIGNMENT_OPERATORS = void 0;
	constants$2.STATEMENT_OR_BLOCK_KEYS = ["consequent", "body", "alternate"];
	constants$2.FLATTENABLE_KEYS = ["body", "expressions"];
	constants$2.FOR_INIT_KEYS = ["left", "init"];
	constants$2.COMMENT_KEYS = ["leadingComments", "trailingComments", "innerComments"];
	const LOGICAL_OPERATORS = constants$2.LOGICAL_OPERATORS = ["||", "&&", "??"];
	constants$2.UPDATE_OPERATORS = ["++", "--"];
	const BOOLEAN_NUMBER_BINARY_OPERATORS = constants$2.BOOLEAN_NUMBER_BINARY_OPERATORS = [">", "<", ">=", "<="];
	const EQUALITY_BINARY_OPERATORS = constants$2.EQUALITY_BINARY_OPERATORS = ["==", "===", "!=", "!=="];
	const COMPARISON_BINARY_OPERATORS = constants$2.COMPARISON_BINARY_OPERATORS = [...EQUALITY_BINARY_OPERATORS, "in", "instanceof"];
	const BOOLEAN_BINARY_OPERATORS = constants$2.BOOLEAN_BINARY_OPERATORS = [...COMPARISON_BINARY_OPERATORS, ...BOOLEAN_NUMBER_BINARY_OPERATORS];
	const NUMBER_BINARY_OPERATORS = constants$2.NUMBER_BINARY_OPERATORS = ["-", "/", "%", "*", "**", "&", "|", ">>", ">>>", "<<", "^"];
	constants$2.BINARY_OPERATORS = ["+", ...NUMBER_BINARY_OPERATORS, ...BOOLEAN_BINARY_OPERATORS, "|>"];
	constants$2.ASSIGNMENT_OPERATORS = ["=", "+=", ...NUMBER_BINARY_OPERATORS.map(op => op + "="), ...LOGICAL_OPERATORS.map(op => op + "=")];
	const BOOLEAN_UNARY_OPERATORS = constants$2.BOOLEAN_UNARY_OPERATORS = ["delete", "!"];
	const NUMBER_UNARY_OPERATORS = constants$2.NUMBER_UNARY_OPERATORS = ["+", "-", "~"];
	const STRING_UNARY_OPERATORS = constants$2.STRING_UNARY_OPERATORS = ["typeof"];
	constants$2.UNARY_OPERATORS = ["void", "throw", ...BOOLEAN_UNARY_OPERATORS, ...NUMBER_UNARY_OPERATORS, ...STRING_UNARY_OPERATORS];
	constants$2.INHERIT_KEYS = {
	  optional: ["typeAnnotation", "typeParameters", "returnType"],
	  force: ["start", "loc", "end"]
	};
	constants$2.BLOCK_SCOPED_SYMBOL = Symbol.for("var used to be block scoped");
	constants$2.NOT_LOCAL_BINDING = Symbol.for("should not be considered a local binding");

	
	return constants$2;
}

var utils$2 = {};

var hasRequiredUtils$1;

function requireUtils$1 () {
	if (hasRequiredUtils$1) return utils$2;
	hasRequiredUtils$1 = 1;

	Object.defineProperty(utils$2, "__esModule", {
	  value: true
	});
	utils$2.VISITOR_KEYS = utils$2.NODE_PARENT_VALIDATIONS = utils$2.NODE_FIELDS = utils$2.FLIPPED_ALIAS_KEYS = utils$2.DEPRECATED_KEYS = utils$2.BUILDER_KEYS = utils$2.ALIAS_KEYS = void 0;
	utils$2.arrayOf = arrayOf;
	utils$2.arrayOfType = arrayOfType;
	utils$2.assertEach = assertEach;
	utils$2.assertNodeOrValueType = assertNodeOrValueType;
	utils$2.assertNodeType = assertNodeType;
	utils$2.assertOneOf = assertOneOf;
	utils$2.assertOptionalChainStart = assertOptionalChainStart;
	utils$2.assertShape = assertShape;
	utils$2.assertValueType = assertValueType;
	utils$2.chain = chain;
	utils$2.default = defineType;
	utils$2.defineAliasedType = defineAliasedType;
	utils$2.typeIs = typeIs;
	utils$2.validate = validate;
	utils$2.validateArrayOfType = validateArrayOfType;
	utils$2.validateOptional = validateOptional;
	utils$2.validateOptionalType = validateOptionalType;
	utils$2.validateType = validateType;
	var _is = requireIs();
	var _validate = requireValidate();
	const VISITOR_KEYS = utils$2.VISITOR_KEYS = {};
	const ALIAS_KEYS = utils$2.ALIAS_KEYS = {};
	const FLIPPED_ALIAS_KEYS = utils$2.FLIPPED_ALIAS_KEYS = {};
	const NODE_FIELDS = utils$2.NODE_FIELDS = {};
	const BUILDER_KEYS = utils$2.BUILDER_KEYS = {};
	const DEPRECATED_KEYS = utils$2.DEPRECATED_KEYS = {};
	const NODE_PARENT_VALIDATIONS = utils$2.NODE_PARENT_VALIDATIONS = {};
	function getType(val) {
	  if (Array.isArray(val)) {
	    return "array";
	  } else if (val === null) {
	    return "null";
	  } else {
	    return typeof val;
	  }
	}
	function validate(validate) {
	  return {
	    validate
	  };
	}
	function typeIs(typeName) {
	  return typeof typeName === "string" ? assertNodeType(typeName) : assertNodeType(...typeName);
	}
	function validateType(typeName) {
	  return validate(typeIs(typeName));
	}
	function validateOptional(validate) {
	  return {
	    validate,
	    optional: true
	  };
	}
	function validateOptionalType(typeName) {
	  return {
	    validate: typeIs(typeName),
	    optional: true
	  };
	}
	function arrayOf(elementType) {
	  return chain(assertValueType("array"), assertEach(elementType));
	}
	function arrayOfType(typeName) {
	  return arrayOf(typeIs(typeName));
	}
	function validateArrayOfType(typeName) {
	  return validate(arrayOfType(typeName));
	}
	function assertEach(callback) {
	  function validator(node, key, val) {
	    if (!Array.isArray(val)) return;
	    for (let i = 0; i < val.length; i++) {
	      const subkey = `${key}[${i}]`;
	      const v = val[i];
	      callback(node, subkey, v);
	      if (process.env.BABEL_TYPES_8_BREAKING) (0, _validate.validateChild)(node, subkey, v);
	    }
	  }
	  validator.each = callback;
	  return validator;
	}
	function assertOneOf(...values) {
	  function validate(node, key, val) {
	    if (values.indexOf(val) < 0) {
	      throw new TypeError(`Property ${key} expected value to be one of ${JSON.stringify(values)} but got ${JSON.stringify(val)}`);
	    }
	  }
	  validate.oneOf = values;
	  return validate;
	}
	function assertNodeType(...types) {
	  function validate(node, key, val) {
	    for (const type of types) {
	      if ((0, _is.default)(type, val)) {
	        (0, _validate.validateChild)(node, key, val);
	        return;
	      }
	    }
	    throw new TypeError(`Property ${key} of ${node.type} expected node to be of a type ${JSON.stringify(types)} but instead got ${JSON.stringify(val == null ? void 0 : val.type)}`);
	  }
	  validate.oneOfNodeTypes = types;
	  return validate;
	}
	function assertNodeOrValueType(...types) {
	  function validate(node, key, val) {
	    for (const type of types) {
	      if (getType(val) === type || (0, _is.default)(type, val)) {
	        (0, _validate.validateChild)(node, key, val);
	        return;
	      }
	    }
	    throw new TypeError(`Property ${key} of ${node.type} expected node to be of a type ${JSON.stringify(types)} but instead got ${JSON.stringify(val == null ? void 0 : val.type)}`);
	  }
	  validate.oneOfNodeOrValueTypes = types;
	  return validate;
	}
	function assertValueType(type) {
	  function validate(node, key, val) {
	    const valid = getType(val) === type;
	    if (!valid) {
	      throw new TypeError(`Property ${key} expected type of ${type} but got ${getType(val)}`);
	    }
	  }
	  validate.type = type;
	  return validate;
	}
	function assertShape(shape) {
	  function validate(node, key, val) {
	    const errors = [];
	    for (const property of Object.keys(shape)) {
	      try {
	        (0, _validate.validateField)(node, property, val[property], shape[property]);
	      } catch (error) {
	        if (error instanceof TypeError) {
	          errors.push(error.message);
	          continue;
	        }
	        throw error;
	      }
	    }
	    if (errors.length) {
	      throw new TypeError(`Property ${key} of ${node.type} expected to have the following:\n${errors.join("\n")}`);
	    }
	  }
	  validate.shapeOf = shape;
	  return validate;
	}
	function assertOptionalChainStart() {
	  function validate(node) {
	    var _current;
	    let current = node;
	    while (node) {
	      const {
	        type
	      } = current;
	      if (type === "OptionalCallExpression") {
	        if (current.optional) return;
	        current = current.callee;
	        continue;
	      }
	      if (type === "OptionalMemberExpression") {
	        if (current.optional) return;
	        current = current.object;
	        continue;
	      }
	      break;
	    }
	    throw new TypeError(`Non-optional ${node.type} must chain from an optional OptionalMemberExpression or OptionalCallExpression. Found chain from ${(_current = current) == null ? void 0 : _current.type}`);
	  }
	  return validate;
	}
	function chain(...fns) {
	  function validate(...args) {
	    for (const fn of fns) {
	      fn(...args);
	    }
	  }
	  validate.chainOf = fns;
	  if (fns.length >= 2 && "type" in fns[0] && fns[0].type === "array" && !("each" in fns[1])) {
	    throw new Error(`An assertValueType("array") validator can only be followed by an assertEach(...) validator.`);
	  }
	  return validate;
	}
	const validTypeOpts = ["aliases", "builder", "deprecatedAlias", "fields", "inherits", "visitor", "validate"];
	const validFieldKeys = ["default", "optional", "deprecated", "validate"];
	const store = {};
	function defineAliasedType(...aliases) {
	  return (type, opts = {}) => {
	    let defined = opts.aliases;
	    if (!defined) {
	      var _store$opts$inherits$, _defined;
	      if (opts.inherits) defined = (_store$opts$inherits$ = store[opts.inherits].aliases) == null ? void 0 : _store$opts$inherits$.slice();
	      (_defined = defined) != null ? _defined : defined = [];
	      opts.aliases = defined;
	    }
	    const additional = aliases.filter(a => !defined.includes(a));
	    defined.unshift(...additional);
	    defineType(type, opts);
	  };
	}
	function defineType(type, opts = {}) {
	  const inherits = opts.inherits && store[opts.inherits] || {};
	  let fields = opts.fields;
	  if (!fields) {
	    fields = {};
	    if (inherits.fields) {
	      const keys = Object.getOwnPropertyNames(inherits.fields);
	      for (const key of keys) {
	        const field = inherits.fields[key];
	        const def = field.default;
	        if (Array.isArray(def) ? def.length > 0 : def && typeof def === "object") {
	          throw new Error("field defaults can only be primitives or empty arrays currently");
	        }
	        fields[key] = {
	          default: Array.isArray(def) ? [] : def,
	          optional: field.optional,
	          deprecated: field.deprecated,
	          validate: field.validate
	        };
	      }
	    }
	  }
	  const visitor = opts.visitor || inherits.visitor || [];
	  const aliases = opts.aliases || inherits.aliases || [];
	  const builder = opts.builder || inherits.builder || opts.visitor || [];
	  for (const k of Object.keys(opts)) {
	    if (validTypeOpts.indexOf(k) === -1) {
	      throw new Error(`Unknown type option "${k}" on ${type}`);
	    }
	  }
	  if (opts.deprecatedAlias) {
	    DEPRECATED_KEYS[opts.deprecatedAlias] = type;
	  }
	  for (const key of visitor.concat(builder)) {
	    fields[key] = fields[key] || {};
	  }
	  for (const key of Object.keys(fields)) {
	    const field = fields[key];
	    if (field.default !== undefined && builder.indexOf(key) === -1) {
	      field.optional = true;
	    }
	    if (field.default === undefined) {
	      field.default = null;
	    } else if (!field.validate && field.default != null) {
	      field.validate = assertValueType(getType(field.default));
	    }
	    for (const k of Object.keys(field)) {
	      if (validFieldKeys.indexOf(k) === -1) {
	        throw new Error(`Unknown field key "${k}" on ${type}.${key}`);
	      }
	    }
	  }
	  VISITOR_KEYS[type] = opts.visitor = visitor;
	  BUILDER_KEYS[type] = opts.builder = builder;
	  NODE_FIELDS[type] = opts.fields = fields;
	  ALIAS_KEYS[type] = opts.aliases = aliases;
	  aliases.forEach(alias => {
	    FLIPPED_ALIAS_KEYS[alias] = FLIPPED_ALIAS_KEYS[alias] || [];
	    FLIPPED_ALIAS_KEYS[alias].push(type);
	  });
	  if (opts.validate) {
	    NODE_PARENT_VALIDATIONS[type] = opts.validate;
	  }
	  store[type] = opts;
	}

	
	return utils$2;
}

var hasRequiredCore;

function requireCore () {
	if (hasRequiredCore) return core$1;
	hasRequiredCore = 1;

	Object.defineProperty(core$1, "__esModule", {
	  value: true
	});
	core$1.patternLikeCommon = core$1.functionTypeAnnotationCommon = core$1.functionDeclarationCommon = core$1.functionCommon = core$1.classMethodOrPropertyCommon = core$1.classMethodOrDeclareMethodCommon = void 0;
	var _is = requireIs();
	var _isValidIdentifier = requireIsValidIdentifier();
	var _helperValidatorIdentifier = requireLib$j();
	var _helperStringParser = requireLib$i();
	var _index = requireConstants();
	var _utils = requireUtils$1();
	const defineType = (0, _utils.defineAliasedType)("Standardized");
	defineType("ArrayExpression", {
	  fields: {
	    elements: {
	      validate: (0, _utils.chain)((0, _utils.assertValueType)("array"), (0, _utils.assertEach)((0, _utils.assertNodeOrValueType)("null", "Expression", "SpreadElement"))),
	      default: !process.env.BABEL_TYPES_8_BREAKING ? [] : undefined
	    }
	  },
	  visitor: ["elements"],
	  aliases: ["Expression"]
	});
	defineType("AssignmentExpression", {
	  fields: {
	    operator: {
	      validate: function () {
	        if (!process.env.BABEL_TYPES_8_BREAKING) {
	          return (0, _utils.assertValueType)("string");
	        }
	        const identifier = (0, _utils.assertOneOf)(..._index.ASSIGNMENT_OPERATORS);
	        const pattern = (0, _utils.assertOneOf)("=");
	        return function (node, key, val) {
	          const validator = (0, _is.default)("Pattern", node.left) ? pattern : identifier;
	          validator(node, key, val);
	        };
	      }()
	    },
	    left: {
	      validate: !process.env.BABEL_TYPES_8_BREAKING ? (0, _utils.assertNodeType)("LVal", "OptionalMemberExpression") : (0, _utils.assertNodeType)("Identifier", "MemberExpression", "OptionalMemberExpression", "ArrayPattern", "ObjectPattern", "TSAsExpression", "TSSatisfiesExpression", "TSTypeAssertion", "TSNonNullExpression")
	    },
	    right: {
	      validate: (0, _utils.assertNodeType)("Expression")
	    }
	  },
	  builder: ["operator", "left", "right"],
	  visitor: ["left", "right"],
	  aliases: ["Expression"]
	});
	defineType("BinaryExpression", {
	  builder: ["operator", "left", "right"],
	  fields: {
	    operator: {
	      validate: (0, _utils.assertOneOf)(..._index.BINARY_OPERATORS)
	    },
	    left: {
	      validate: function () {
	        const expression = (0, _utils.assertNodeType)("Expression");
	        const inOp = (0, _utils.assertNodeType)("Expression", "PrivateName");
	        const validator = Object.assign(function (node, key, val) {
	          const validator = node.operator === "in" ? inOp : expression;
	          validator(node, key, val);
	        }, {
	          oneOfNodeTypes: ["Expression", "PrivateName"]
	        });
	        return validator;
	      }()
	    },
	    right: {
	      validate: (0, _utils.assertNodeType)("Expression")
	    }
	  },
	  visitor: ["left", "right"],
	  aliases: ["Binary", "Expression"]
	});
	defineType("InterpreterDirective", {
	  builder: ["value"],
	  fields: {
	    value: {
	      validate: (0, _utils.assertValueType)("string")
	    }
	  }
	});
	defineType("Directive", {
	  visitor: ["value"],
	  fields: {
	    value: {
	      validate: (0, _utils.assertNodeType)("DirectiveLiteral")
	    }
	  }
	});
	defineType("DirectiveLiteral", {
	  builder: ["value"],
	  fields: {
	    value: {
	      validate: (0, _utils.assertValueType)("string")
	    }
	  }
	});
	defineType("BlockStatement", {
	  builder: ["body", "directives"],
	  visitor: ["directives", "body"],
	  fields: {
	    directives: {
	      validate: (0, _utils.chain)((0, _utils.assertValueType)("array"), (0, _utils.assertEach)((0, _utils.assertNodeType)("Directive"))),
	      default: []
	    },
	    body: {
	      validate: (0, _utils.chain)((0, _utils.assertValueType)("array"), (0, _utils.assertEach)((0, _utils.assertNodeType)("Statement")))
	    }
	  },
	  aliases: ["Scopable", "BlockParent", "Block", "Statement"]
	});
	defineType("BreakStatement", {
	  visitor: ["label"],
	  fields: {
	    label: {
	      validate: (0, _utils.assertNodeType)("Identifier"),
	      optional: true
	    }
	  },
	  aliases: ["Statement", "Terminatorless", "CompletionStatement"]
	});
	defineType("CallExpression", {
	  visitor: ["callee", "arguments", "typeParameters", "typeArguments"],
	  builder: ["callee", "arguments"],
	  aliases: ["Expression"],
	  fields: Object.assign({
	    callee: {
	      validate: (0, _utils.assertNodeType)("Expression", "Super", "V8IntrinsicIdentifier")
	    },
	    arguments: {
	      validate: (0, _utils.chain)((0, _utils.assertValueType)("array"), (0, _utils.assertEach)((0, _utils.assertNodeType)("Expression", "SpreadElement", "ArgumentPlaceholder")))
	    }
	  }, !process.env.BABEL_TYPES_8_BREAKING ? {
	    optional: {
	      validate: (0, _utils.assertOneOf)(true, false),
	      optional: true
	    }
	  } : {}, {
	    typeArguments: {
	      validate: (0, _utils.assertNodeType)("TypeParameterInstantiation"),
	      optional: true
	    },
	    typeParameters: {
	      validate: (0, _utils.assertNodeType)("TSTypeParameterInstantiation"),
	      optional: true
	    }
	  })
	});
	defineType("CatchClause", {
	  visitor: ["param", "body"],
	  fields: {
	    param: {
	      validate: (0, _utils.assertNodeType)("Identifier", "ArrayPattern", "ObjectPattern"),
	      optional: true
	    },
	    body: {
	      validate: (0, _utils.assertNodeType)("BlockStatement")
	    }
	  },
	  aliases: ["Scopable", "BlockParent"]
	});
	defineType("ConditionalExpression", {
	  visitor: ["test", "consequent", "alternate"],
	  fields: {
	    test: {
	      validate: (0, _utils.assertNodeType)("Expression")
	    },
	    consequent: {
	      validate: (0, _utils.assertNodeType)("Expression")
	    },
	    alternate: {
	      validate: (0, _utils.assertNodeType)("Expression")
	    }
	  },
	  aliases: ["Expression", "Conditional"]
	});
	defineType("ContinueStatement", {
	  visitor: ["label"],
	  fields: {
	    label: {
	      validate: (0, _utils.assertNodeType)("Identifier"),
	      optional: true
	    }
	  },
	  aliases: ["Statement", "Terminatorless", "CompletionStatement"]
	});
	defineType("DebuggerStatement", {
	  aliases: ["Statement"]
	});
	defineType("DoWhileStatement", {
	  visitor: ["test", "body"],
	  fields: {
	    test: {
	      validate: (0, _utils.assertNodeType)("Expression")
	    },
	    body: {
	      validate: (0, _utils.assertNodeType)("Statement")
	    }
	  },
	  aliases: ["Statement", "BlockParent", "Loop", "While", "Scopable"]
	});
	defineType("EmptyStatement", {
	  aliases: ["Statement"]
	});
	defineType("ExpressionStatement", {
	  visitor: ["expression"],
	  fields: {
	    expression: {
	      validate: (0, _utils.assertNodeType)("Expression")
	    }
	  },
	  aliases: ["Statement", "ExpressionWrapper"]
	});
	defineType("File", {
	  builder: ["program", "comments", "tokens"],
	  visitor: ["program"],
	  fields: {
	    program: {
	      validate: (0, _utils.assertNodeType)("Program")
	    },
	    comments: {
	      validate: !process.env.BABEL_TYPES_8_BREAKING ? Object.assign(() => {}, {
	        each: {
	          oneOfNodeTypes: ["CommentBlock", "CommentLine"]
	        }
	      }) : (0, _utils.assertEach)((0, _utils.assertNodeType)("CommentBlock", "CommentLine")),
	      optional: true
	    },
	    tokens: {
	      validate: (0, _utils.assertEach)(Object.assign(() => {}, {
	        type: "any"
	      })),
	      optional: true
	    }
	  }
	});
	defineType("ForInStatement", {
	  visitor: ["left", "right", "body"],
	  aliases: ["Scopable", "Statement", "For", "BlockParent", "Loop", "ForXStatement"],
	  fields: {
	    left: {
	      validate: !process.env.BABEL_TYPES_8_BREAKING ? (0, _utils.assertNodeType)("VariableDeclaration", "LVal") : (0, _utils.assertNodeType)("VariableDeclaration", "Identifier", "MemberExpression", "ArrayPattern", "ObjectPattern", "TSAsExpression", "TSSatisfiesExpression", "TSTypeAssertion", "TSNonNullExpression")
	    },
	    right: {
	      validate: (0, _utils.assertNodeType)("Expression")
	    },
	    body: {
	      validate: (0, _utils.assertNodeType)("Statement")
	    }
	  }
	});
	defineType("ForStatement", {
	  visitor: ["init", "test", "update", "body"],
	  aliases: ["Scopable", "Statement", "For", "BlockParent", "Loop"],
	  fields: {
	    init: {
	      validate: (0, _utils.assertNodeType)("VariableDeclaration", "Expression"),
	      optional: true
	    },
	    test: {
	      validate: (0, _utils.assertNodeType)("Expression"),
	      optional: true
	    },
	    update: {
	      validate: (0, _utils.assertNodeType)("Expression"),
	      optional: true
	    },
	    body: {
	      validate: (0, _utils.assertNodeType)("Statement")
	    }
	  }
	});
	const functionCommon = () => ({
	  params: {
	    validate: (0, _utils.chain)((0, _utils.assertValueType)("array"), (0, _utils.assertEach)((0, _utils.assertNodeType)("Identifier", "Pattern", "RestElement")))
	  },
	  generator: {
	    default: false
	  },
	  async: {
	    default: false
	  }
	});
	core$1.functionCommon = functionCommon;
	const functionTypeAnnotationCommon = () => ({
	  returnType: {
	    validate: (0, _utils.assertNodeType)("TypeAnnotation", "TSTypeAnnotation", "Noop"),
	    optional: true
	  },
	  typeParameters: {
	    validate: (0, _utils.assertNodeType)("TypeParameterDeclaration", "TSTypeParameterDeclaration", "Noop"),
	    optional: true
	  }
	});
	core$1.functionTypeAnnotationCommon = functionTypeAnnotationCommon;
	const functionDeclarationCommon = () => Object.assign({}, functionCommon(), {
	  declare: {
	    validate: (0, _utils.assertValueType)("boolean"),
	    optional: true
	  },
	  id: {
	    validate: (0, _utils.assertNodeType)("Identifier"),
	    optional: true
	  }
	});
	core$1.functionDeclarationCommon = functionDeclarationCommon;
	defineType("FunctionDeclaration", {
	  builder: ["id", "params", "body", "generator", "async"],
	  visitor: ["id", "params", "body", "returnType", "typeParameters"],
	  fields: Object.assign({}, functionDeclarationCommon(), functionTypeAnnotationCommon(), {
	    body: {
	      validate: (0, _utils.assertNodeType)("BlockStatement")
	    },
	    predicate: {
	      validate: (0, _utils.assertNodeType)("DeclaredPredicate", "InferredPredicate"),
	      optional: true
	    }
	  }),
	  aliases: ["Scopable", "Function", "BlockParent", "FunctionParent", "Statement", "Pureish", "Declaration"],
	  validate: function () {
	    if (!process.env.BABEL_TYPES_8_BREAKING) return () => {};
	    const identifier = (0, _utils.assertNodeType)("Identifier");
	    return function (parent, key, node) {
	      if (!(0, _is.default)("ExportDefaultDeclaration", parent)) {
	        identifier(node, "id", node.id);
	      }
	    };
	  }()
	});
	defineType("FunctionExpression", {
	  inherits: "FunctionDeclaration",
	  aliases: ["Scopable", "Function", "BlockParent", "FunctionParent", "Expression", "Pureish"],
	  fields: Object.assign({}, functionCommon(), functionTypeAnnotationCommon(), {
	    id: {
	      validate: (0, _utils.assertNodeType)("Identifier"),
	      optional: true
	    },
	    body: {
	      validate: (0, _utils.assertNodeType)("BlockStatement")
	    },
	    predicate: {
	      validate: (0, _utils.assertNodeType)("DeclaredPredicate", "InferredPredicate"),
	      optional: true
	    }
	  })
	});
	const patternLikeCommon = () => ({
	  typeAnnotation: {
	    validate: (0, _utils.assertNodeType)("TypeAnnotation", "TSTypeAnnotation", "Noop"),
	    optional: true
	  },
	  optional: {
	    validate: (0, _utils.assertValueType)("boolean"),
	    optional: true
	  },
	  decorators: {
	    validate: (0, _utils.chain)((0, _utils.assertValueType)("array"), (0, _utils.assertEach)((0, _utils.assertNodeType)("Decorator"))),
	    optional: true
	  }
	});
	core$1.patternLikeCommon = patternLikeCommon;
	defineType("Identifier", {
	  builder: ["name"],
	  visitor: ["typeAnnotation", "decorators"],
	  aliases: ["Expression", "PatternLike", "LVal", "TSEntityName"],
	  fields: Object.assign({}, patternLikeCommon(), {
	    name: {
	      validate: (0, _utils.chain)((0, _utils.assertValueType)("string"), Object.assign(function (node, key, val) {
	        if (!process.env.BABEL_TYPES_8_BREAKING) return;
	        if (!(0, _isValidIdentifier.default)(val, false)) {
	          throw new TypeError(`"${val}" is not a valid identifier name`);
	        }
	      }, {
	        type: "string"
	      }))
	    }
	  }),
	  validate(parent, key, node) {
	    if (!process.env.BABEL_TYPES_8_BREAKING) return;
	    const match = /\.(\w+)$/.exec(key);
	    if (!match) return;
	    const [, parentKey] = match;
	    const nonComp = {
	      computed: false
	    };
	    if (parentKey === "property") {
	      if ((0, _is.default)("MemberExpression", parent, nonComp)) return;
	      if ((0, _is.default)("OptionalMemberExpression", parent, nonComp)) return;
	    } else if (parentKey === "key") {
	      if ((0, _is.default)("Property", parent, nonComp)) return;
	      if ((0, _is.default)("Method", parent, nonComp)) return;
	    } else if (parentKey === "exported") {
	      if ((0, _is.default)("ExportSpecifier", parent)) return;
	    } else if (parentKey === "imported") {
	      if ((0, _is.default)("ImportSpecifier", parent, {
	        imported: node
	      })) return;
	    } else if (parentKey === "meta") {
	      if ((0, _is.default)("MetaProperty", parent, {
	        meta: node
	      })) return;
	    }
	    if (((0, _helperValidatorIdentifier.isKeyword)(node.name) || (0, _helperValidatorIdentifier.isReservedWord)(node.name, false)) && node.name !== "this") {
	      throw new TypeError(`"${node.name}" is not a valid identifier`);
	    }
	  }
	});
	defineType("IfStatement", {
	  visitor: ["test", "consequent", "alternate"],
	  aliases: ["Statement", "Conditional"],
	  fields: {
	    test: {
	      validate: (0, _utils.assertNodeType)("Expression")
	    },
	    consequent: {
	      validate: (0, _utils.assertNodeType)("Statement")
	    },
	    alternate: {
	      optional: true,
	      validate: (0, _utils.assertNodeType)("Statement")
	    }
	  }
	});
	defineType("LabeledStatement", {
	  visitor: ["label", "body"],
	  aliases: ["Statement"],
	  fields: {
	    label: {
	      validate: (0, _utils.assertNodeType)("Identifier")
	    },
	    body: {
	      validate: (0, _utils.assertNodeType)("Statement")
	    }
	  }
	});
	defineType("StringLiteral", {
	  builder: ["value"],
	  fields: {
	    value: {
	      validate: (0, _utils.assertValueType)("string")
	    }
	  },
	  aliases: ["Expression", "Pureish", "Literal", "Immutable"]
	});
	defineType("NumericLiteral", {
	  builder: ["value"],
	  deprecatedAlias: "NumberLiteral",
	  fields: {
	    value: {
	      validate: (0, _utils.chain)((0, _utils.assertValueType)("number"), Object.assign(function (node, key, val) {
	      }, {
	        type: "number"
	      }))
	    }
	  },
	  aliases: ["Expression", "Pureish", "Literal", "Immutable"]
	});
	defineType("NullLiteral", {
	  aliases: ["Expression", "Pureish", "Literal", "Immutable"]
	});
	defineType("BooleanLiteral", {
	  builder: ["value"],
	  fields: {
	    value: {
	      validate: (0, _utils.assertValueType)("boolean")
	    }
	  },
	  aliases: ["Expression", "Pureish", "Literal", "Immutable"]
	});
	defineType("RegExpLiteral", {
	  builder: ["pattern", "flags"],
	  deprecatedAlias: "RegexLiteral",
	  aliases: ["Expression", "Pureish", "Literal"],
	  fields: {
	    pattern: {
	      validate: (0, _utils.assertValueType)("string")
	    },
	    flags: {
	      validate: (0, _utils.chain)((0, _utils.assertValueType)("string"), Object.assign(function (node, key, val) {
	        if (!process.env.BABEL_TYPES_8_BREAKING) return;
	        const invalid = /[^gimsuy]/.exec(val);
	        if (invalid) {
	          throw new TypeError(`"${invalid[0]}" is not a valid RegExp flag`);
	        }
	      }, {
	        type: "string"
	      })),
	      default: ""
	    }
	  }
	});
	defineType("LogicalExpression", {
	  builder: ["operator", "left", "right"],
	  visitor: ["left", "right"],
	  aliases: ["Binary", "Expression"],
	  fields: {
	    operator: {
	      validate: (0, _utils.assertOneOf)(..._index.LOGICAL_OPERATORS)
	    },
	    left: {
	      validate: (0, _utils.assertNodeType)("Expression")
	    },
	    right: {
	      validate: (0, _utils.assertNodeType)("Expression")
	    }
	  }
	});
	defineType("MemberExpression", {
	  builder: ["object", "property", "computed", ...(!process.env.BABEL_TYPES_8_BREAKING ? ["optional"] : [])],
	  visitor: ["object", "property"],
	  aliases: ["Expression", "LVal"],
	  fields: Object.assign({
	    object: {
	      validate: (0, _utils.assertNodeType)("Expression", "Super")
	    },
	    property: {
	      validate: function () {
	        const normal = (0, _utils.assertNodeType)("Identifier", "PrivateName");
	        const computed = (0, _utils.assertNodeType)("Expression");
	        const validator = function (node, key, val) {
	          const validator = node.computed ? computed : normal;
	          validator(node, key, val);
	        };
	        validator.oneOfNodeTypes = ["Expression", "Identifier", "PrivateName"];
	        return validator;
	      }()
	    },
	    computed: {
	      default: false
	    }
	  }, !process.env.BABEL_TYPES_8_BREAKING ? {
	    optional: {
	      validate: (0, _utils.assertOneOf)(true, false),
	      optional: true
	    }
	  } : {})
	});
	defineType("NewExpression", {
	  inherits: "CallExpression"
	});
	defineType("Program", {
	  visitor: ["directives", "body"],
	  builder: ["body", "directives", "sourceType", "interpreter"],
	  fields: {
	    sourceType: {
	      validate: (0, _utils.assertOneOf)("script", "module"),
	      default: "script"
	    },
	    interpreter: {
	      validate: (0, _utils.assertNodeType)("InterpreterDirective"),
	      default: null,
	      optional: true
	    },
	    directives: {
	      validate: (0, _utils.chain)((0, _utils.assertValueType)("array"), (0, _utils.assertEach)((0, _utils.assertNodeType)("Directive"))),
	      default: []
	    },
	    body: {
	      validate: (0, _utils.chain)((0, _utils.assertValueType)("array"), (0, _utils.assertEach)((0, _utils.assertNodeType)("Statement")))
	    }
	  },
	  aliases: ["Scopable", "BlockParent", "Block"]
	});
	defineType("ObjectExpression", {
	  visitor: ["properties"],
	  aliases: ["Expression"],
	  fields: {
	    properties: {
	      validate: (0, _utils.chain)((0, _utils.assertValueType)("array"), (0, _utils.assertEach)((0, _utils.assertNodeType)("ObjectMethod", "ObjectProperty", "SpreadElement")))
	    }
	  }
	});
	defineType("ObjectMethod", {
	  builder: ["kind", "key", "params", "body", "computed", "generator", "async"],
	  fields: Object.assign({}, functionCommon(), functionTypeAnnotationCommon(), {
	    kind: Object.assign({
	      validate: (0, _utils.assertOneOf)("method", "get", "set")
	    }, !process.env.BABEL_TYPES_8_BREAKING ? {
	      default: "method"
	    } : {}),
	    computed: {
	      default: false
	    },
	    key: {
	      validate: function () {
	        const normal = (0, _utils.assertNodeType)("Identifier", "StringLiteral", "NumericLiteral", "BigIntLiteral");
	        const computed = (0, _utils.assertNodeType)("Expression");
	        const validator = function (node, key, val) {
	          const validator = node.computed ? computed : normal;
	          validator(node, key, val);
	        };
	        validator.oneOfNodeTypes = ["Expression", "Identifier", "StringLiteral", "NumericLiteral", "BigIntLiteral"];
	        return validator;
	      }()
	    },
	    decorators: {
	      validate: (0, _utils.chain)((0, _utils.assertValueType)("array"), (0, _utils.assertEach)((0, _utils.assertNodeType)("Decorator"))),
	      optional: true
	    },
	    body: {
	      validate: (0, _utils.assertNodeType)("BlockStatement")
	    }
	  }),
	  visitor: ["key", "params", "body", "decorators", "returnType", "typeParameters"],
	  aliases: ["UserWhitespacable", "Function", "Scopable", "BlockParent", "FunctionParent", "Method", "ObjectMember"]
	});
	defineType("ObjectProperty", {
	  builder: ["key", "value", "computed", "shorthand", ...(!process.env.BABEL_TYPES_8_BREAKING ? ["decorators"] : [])],
	  fields: {
	    computed: {
	      default: false
	    },
	    key: {
	      validate: function () {
	        const normal = (0, _utils.assertNodeType)("Identifier", "StringLiteral", "NumericLiteral", "BigIntLiteral", "DecimalLiteral", "PrivateName");
	        const computed = (0, _utils.assertNodeType)("Expression");
	        const validator = Object.assign(function (node, key, val) {
	          const validator = node.computed ? computed : normal;
	          validator(node, key, val);
	        }, {
	          oneOfNodeTypes: ["Expression", "Identifier", "StringLiteral", "NumericLiteral", "BigIntLiteral", "DecimalLiteral", "PrivateName"]
	        });
	        return validator;
	      }()
	    },
	    value: {
	      validate: (0, _utils.assertNodeType)("Expression", "PatternLike")
	    },
	    shorthand: {
	      validate: (0, _utils.chain)((0, _utils.assertValueType)("boolean"), Object.assign(function (node, key, val) {
	        if (!process.env.BABEL_TYPES_8_BREAKING) return;
	        if (val && node.computed) {
	          throw new TypeError("Property shorthand of ObjectProperty cannot be true if computed is true");
	        }
	      }, {
	        type: "boolean"
	      }), function (node, key, val) {
	        if (!process.env.BABEL_TYPES_8_BREAKING) return;
	        if (val && !(0, _is.default)("Identifier", node.key)) {
	          throw new TypeError("Property shorthand of ObjectProperty cannot be true if key is not an Identifier");
	        }
	      }),
	      default: false
	    },
	    decorators: {
	      validate: (0, _utils.chain)((0, _utils.assertValueType)("array"), (0, _utils.assertEach)((0, _utils.assertNodeType)("Decorator"))),
	      optional: true
	    }
	  },
	  visitor: ["key", "value", "decorators"],
	  aliases: ["UserWhitespacable", "Property", "ObjectMember"],
	  validate: function () {
	    const pattern = (0, _utils.assertNodeType)("Identifier", "Pattern", "TSAsExpression", "TSSatisfiesExpression", "TSNonNullExpression", "TSTypeAssertion");
	    const expression = (0, _utils.assertNodeType)("Expression");
	    return function (parent, key, node) {
	      if (!process.env.BABEL_TYPES_8_BREAKING) return;
	      const validator = (0, _is.default)("ObjectPattern", parent) ? pattern : expression;
	      validator(node, "value", node.value);
	    };
	  }()
	});
	defineType("RestElement", {
	  visitor: ["argument", "typeAnnotation"],
	  builder: ["argument"],
	  aliases: ["LVal", "PatternLike"],
	  deprecatedAlias: "RestProperty",
	  fields: Object.assign({}, patternLikeCommon(), {
	    argument: {
	      validate: !process.env.BABEL_TYPES_8_BREAKING ? (0, _utils.assertNodeType)("LVal") : (0, _utils.assertNodeType)("Identifier", "ArrayPattern", "ObjectPattern", "MemberExpression", "TSAsExpression", "TSSatisfiesExpression", "TSTypeAssertion", "TSNonNullExpression")
	    }
	  }),
	  validate(parent, key) {
	    if (!process.env.BABEL_TYPES_8_BREAKING) return;
	    const match = /(\w+)\[(\d+)\]/.exec(key);
	    if (!match) throw new Error("Internal Babel error: malformed key.");
	    const [, listKey, index] = match;
	    if (parent[listKey].length > +index + 1) {
	      throw new TypeError(`RestElement must be last element of ${listKey}`);
	    }
	  }
	});
	defineType("ReturnStatement", {
	  visitor: ["argument"],
	  aliases: ["Statement", "Terminatorless", "CompletionStatement"],
	  fields: {
	    argument: {
	      validate: (0, _utils.assertNodeType)("Expression"),
	      optional: true
	    }
	  }
	});
	defineType("SequenceExpression", {
	  visitor: ["expressions"],
	  fields: {
	    expressions: {
	      validate: (0, _utils.chain)((0, _utils.assertValueType)("array"), (0, _utils.assertEach)((0, _utils.assertNodeType)("Expression")))
	    }
	  },
	  aliases: ["Expression"]
	});
	defineType("ParenthesizedExpression", {
	  visitor: ["expression"],
	  aliases: ["Expression", "ExpressionWrapper"],
	  fields: {
	    expression: {
	      validate: (0, _utils.assertNodeType)("Expression")
	    }
	  }
	});
	defineType("SwitchCase", {
	  visitor: ["test", "consequent"],
	  fields: {
	    test: {
	      validate: (0, _utils.assertNodeType)("Expression"),
	      optional: true
	    },
	    consequent: {
	      validate: (0, _utils.chain)((0, _utils.assertValueType)("array"), (0, _utils.assertEach)((0, _utils.assertNodeType)("Statement")))
	    }
	  }
	});
	defineType("SwitchStatement", {
	  visitor: ["discriminant", "cases"],
	  aliases: ["Statement", "BlockParent", "Scopable"],
	  fields: {
	    discriminant: {
	      validate: (0, _utils.assertNodeType)("Expression")
	    },
	    cases: {
	      validate: (0, _utils.chain)((0, _utils.assertValueType)("array"), (0, _utils.assertEach)((0, _utils.assertNodeType)("SwitchCase")))
	    }
	  }
	});
	defineType("ThisExpression", {
	  aliases: ["Expression"]
	});
	defineType("ThrowStatement", {
	  visitor: ["argument"],
	  aliases: ["Statement", "Terminatorless", "CompletionStatement"],
	  fields: {
	    argument: {
	      validate: (0, _utils.assertNodeType)("Expression")
	    }
	  }
	});
	defineType("TryStatement", {
	  visitor: ["block", "handler", "finalizer"],
	  aliases: ["Statement"],
	  fields: {
	    block: {
	      validate: (0, _utils.chain)((0, _utils.assertNodeType)("BlockStatement"), Object.assign(function (node) {
	        if (!process.env.BABEL_TYPES_8_BREAKING) return;
	        if (!node.handler && !node.finalizer) {
	          throw new TypeError("TryStatement expects either a handler or finalizer, or both");
	        }
	      }, {
	        oneOfNodeTypes: ["BlockStatement"]
	      }))
	    },
	    handler: {
	      optional: true,
	      validate: (0, _utils.assertNodeType)("CatchClause")
	    },
	    finalizer: {
	      optional: true,
	      validate: (0, _utils.assertNodeType)("BlockStatement")
	    }
	  }
	});
	defineType("UnaryExpression", {
	  builder: ["operator", "argument", "prefix"],
	  fields: {
	    prefix: {
	      default: true
	    },
	    argument: {
	      validate: (0, _utils.assertNodeType)("Expression")
	    },
	    operator: {
	      validate: (0, _utils.assertOneOf)(..._index.UNARY_OPERATORS)
	    }
	  },
	  visitor: ["argument"],
	  aliases: ["UnaryLike", "Expression"]
	});
	defineType("UpdateExpression", {
	  builder: ["operator", "argument", "prefix"],
	  fields: {
	    prefix: {
	      default: false
	    },
	    argument: {
	      validate: !process.env.BABEL_TYPES_8_BREAKING ? (0, _utils.assertNodeType)("Expression") : (0, _utils.assertNodeType)("Identifier", "MemberExpression")
	    },
	    operator: {
	      validate: (0, _utils.assertOneOf)(..._index.UPDATE_OPERATORS)
	    }
	  },
	  visitor: ["argument"],
	  aliases: ["Expression"]
	});
	defineType("VariableDeclaration", {
	  builder: ["kind", "declarations"],
	  visitor: ["declarations"],
	  aliases: ["Statement", "Declaration"],
	  fields: {
	    declare: {
	      validate: (0, _utils.assertValueType)("boolean"),
	      optional: true
	    },
	    kind: {
	      validate: (0, _utils.assertOneOf)("var", "let", "const", "using", "await using")
	    },
	    declarations: {
	      validate: (0, _utils.chain)((0, _utils.assertValueType)("array"), (0, _utils.assertEach)((0, _utils.assertNodeType)("VariableDeclarator")))
	    }
	  },
	  validate(parent, key, node) {
	    if (!process.env.BABEL_TYPES_8_BREAKING) return;
	    if (!(0, _is.default)("ForXStatement", parent, {
	      left: node
	    })) return;
	    if (node.declarations.length !== 1) {
	      throw new TypeError(`Exactly one VariableDeclarator is required in the VariableDeclaration of a ${parent.type}`);
	    }
	  }
	});
	defineType("VariableDeclarator", {
	  visitor: ["id", "init"],
	  fields: {
	    id: {
	      validate: function () {
	        if (!process.env.BABEL_TYPES_8_BREAKING) {
	          return (0, _utils.assertNodeType)("LVal");
	        }
	        const normal = (0, _utils.assertNodeType)("Identifier", "ArrayPattern", "ObjectPattern");
	        const without = (0, _utils.assertNodeType)("Identifier");
	        return function (node, key, val) {
	          const validator = node.init ? normal : without;
	          validator(node, key, val);
	        };
	      }()
	    },
	    definite: {
	      optional: true,
	      validate: (0, _utils.assertValueType)("boolean")
	    },
	    init: {
	      optional: true,
	      validate: (0, _utils.assertNodeType)("Expression")
	    }
	  }
	});
	defineType("WhileStatement", {
	  visitor: ["test", "body"],
	  aliases: ["Statement", "BlockParent", "Loop", "While", "Scopable"],
	  fields: {
	    test: {
	      validate: (0, _utils.assertNodeType)("Expression")
	    },
	    body: {
	      validate: (0, _utils.assertNodeType)("Statement")
	    }
	  }
	});
	defineType("WithStatement", {
	  visitor: ["object", "body"],
	  aliases: ["Statement"],
	  fields: {
	    object: {
	      validate: (0, _utils.assertNodeType)("Expression")
	    },
	    body: {
	      validate: (0, _utils.assertNodeType)("Statement")
	    }
	  }
	});
	defineType("AssignmentPattern", {
	  visitor: ["left", "right", "decorators"],
	  builder: ["left", "right"],
	  aliases: ["Pattern", "PatternLike", "LVal"],
	  fields: Object.assign({}, patternLikeCommon(), {
	    left: {
	      validate: (0, _utils.assertNodeType)("Identifier", "ObjectPattern", "ArrayPattern", "MemberExpression", "TSAsExpression", "TSSatisfiesExpression", "TSTypeAssertion", "TSNonNullExpression")
	    },
	    right: {
	      validate: (0, _utils.assertNodeType)("Expression")
	    },
	    decorators: {
	      validate: (0, _utils.chain)((0, _utils.assertValueType)("array"), (0, _utils.assertEach)((0, _utils.assertNodeType)("Decorator"))),
	      optional: true
	    }
	  })
	});
	defineType("ArrayPattern", {
	  visitor: ["elements", "typeAnnotation"],
	  builder: ["elements"],
	  aliases: ["Pattern", "PatternLike", "LVal"],
	  fields: Object.assign({}, patternLikeCommon(), {
	    elements: {
	      validate: (0, _utils.chain)((0, _utils.assertValueType)("array"), (0, _utils.assertEach)((0, _utils.assertNodeOrValueType)("null", "PatternLike", "LVal")))
	    }
	  })
	});
	defineType("ArrowFunctionExpression", {
	  builder: ["params", "body", "async"],
	  visitor: ["params", "body", "returnType", "typeParameters"],
	  aliases: ["Scopable", "Function", "BlockParent", "FunctionParent", "Expression", "Pureish"],
	  fields: Object.assign({}, functionCommon(), functionTypeAnnotationCommon(), {
	    expression: {
	      validate: (0, _utils.assertValueType)("boolean")
	    },
	    body: {
	      validate: (0, _utils.assertNodeType)("BlockStatement", "Expression")
	    },
	    predicate: {
	      validate: (0, _utils.assertNodeType)("DeclaredPredicate", "InferredPredicate"),
	      optional: true
	    }
	  })
	});
	defineType("ClassBody", {
	  visitor: ["body"],
	  fields: {
	    body: {
	      validate: (0, _utils.chain)((0, _utils.assertValueType)("array"), (0, _utils.assertEach)((0, _utils.assertNodeType)("ClassMethod", "ClassPrivateMethod", "ClassProperty", "ClassPrivateProperty", "ClassAccessorProperty", "TSDeclareMethod", "TSIndexSignature", "StaticBlock")))
	    }
	  }
	});
	defineType("ClassExpression", {
	  builder: ["id", "superClass", "body", "decorators"],
	  visitor: ["id", "body", "superClass", "mixins", "typeParameters", "superTypeParameters", "implements", "decorators"],
	  aliases: ["Scopable", "Class", "Expression"],
	  fields: {
	    id: {
	      validate: (0, _utils.assertNodeType)("Identifier"),
	      optional: true
	    },
	    typeParameters: {
	      validate: (0, _utils.assertNodeType)("TypeParameterDeclaration", "TSTypeParameterDeclaration", "Noop"),
	      optional: true
	    },
	    body: {
	      validate: (0, _utils.assertNodeType)("ClassBody")
	    },
	    superClass: {
	      optional: true,
	      validate: (0, _utils.assertNodeType)("Expression")
	    },
	    superTypeParameters: {
	      validate: (0, _utils.assertNodeType)("TypeParameterInstantiation", "TSTypeParameterInstantiation"),
	      optional: true
	    },
	    implements: {
	      validate: (0, _utils.chain)((0, _utils.assertValueType)("array"), (0, _utils.assertEach)((0, _utils.assertNodeType)("TSExpressionWithTypeArguments", "ClassImplements"))),
	      optional: true
	    },
	    decorators: {
	      validate: (0, _utils.chain)((0, _utils.assertValueType)("array"), (0, _utils.assertEach)((0, _utils.assertNodeType)("Decorator"))),
	      optional: true
	    },
	    mixins: {
	      validate: (0, _utils.assertNodeType)("InterfaceExtends"),
	      optional: true
	    }
	  }
	});
	defineType("ClassDeclaration", {
	  inherits: "ClassExpression",
	  aliases: ["Scopable", "Class", "Statement", "Declaration"],
	  fields: {
	    id: {
	      validate: (0, _utils.assertNodeType)("Identifier"),
	      optional: true
	    },
	    typeParameters: {
	      validate: (0, _utils.assertNodeType)("TypeParameterDeclaration", "TSTypeParameterDeclaration", "Noop"),
	      optional: true
	    },
	    body: {
	      validate: (0, _utils.assertNodeType)("ClassBody")
	    },
	    superClass: {
	      optional: true,
	      validate: (0, _utils.assertNodeType)("Expression")
	    },
	    superTypeParameters: {
	      validate: (0, _utils.assertNodeType)("TypeParameterInstantiation", "TSTypeParameterInstantiation"),
	      optional: true
	    },
	    implements: {
	      validate: (0, _utils.chain)((0, _utils.assertValueType)("array"), (0, _utils.assertEach)((0, _utils.assertNodeType)("TSExpressionWithTypeArguments", "ClassImplements"))),
	      optional: true
	    },
	    decorators: {
	      validate: (0, _utils.chain)((0, _utils.assertValueType)("array"), (0, _utils.assertEach)((0, _utils.assertNodeType)("Decorator"))),
	      optional: true
	    },
	    mixins: {
	      validate: (0, _utils.assertNodeType)("InterfaceExtends"),
	      optional: true
	    },
	    declare: {
	      validate: (0, _utils.assertValueType)("boolean"),
	      optional: true
	    },
	    abstract: {
	      validate: (0, _utils.assertValueType)("boolean"),
	      optional: true
	    }
	  },
	  validate: function () {
	    const identifier = (0, _utils.assertNodeType)("Identifier");
	    return function (parent, key, node) {
	      if (!process.env.BABEL_TYPES_8_BREAKING) return;
	      if (!(0, _is.default)("ExportDefaultDeclaration", parent)) {
	        identifier(node, "id", node.id);
	      }
	    };
	  }()
	});
	defineType("ExportAllDeclaration", {
	  builder: ["source"],
	  visitor: ["source", "attributes", "assertions"],
	  aliases: ["Statement", "Declaration", "ImportOrExportDeclaration", "ExportDeclaration"],
	  fields: {
	    source: {
	      validate: (0, _utils.assertNodeType)("StringLiteral")
	    },
	    exportKind: (0, _utils.validateOptional)((0, _utils.assertOneOf)("type", "value")),
	    attributes: {
	      optional: true,
	      validate: (0, _utils.chain)((0, _utils.assertValueType)("array"), (0, _utils.assertEach)((0, _utils.assertNodeType)("ImportAttribute")))
	    },
	    assertions: {
	      optional: true,
	      validate: (0, _utils.chain)((0, _utils.assertValueType)("array"), (0, _utils.assertEach)((0, _utils.assertNodeType)("ImportAttribute")))
	    }
	  }
	});
	defineType("ExportDefaultDeclaration", {
	  visitor: ["declaration"],
	  aliases: ["Statement", "Declaration", "ImportOrExportDeclaration", "ExportDeclaration"],
	  fields: {
	    declaration: {
	      validate: (0, _utils.assertNodeType)("TSDeclareFunction", "FunctionDeclaration", "ClassDeclaration", "Expression")
	    },
	    exportKind: (0, _utils.validateOptional)((0, _utils.assertOneOf)("value"))
	  }
	});
	defineType("ExportNamedDeclaration", {
	  builder: ["declaration", "specifiers", "source"],
	  visitor: ["declaration", "specifiers", "source", "attributes", "assertions"],
	  aliases: ["Statement", "Declaration", "ImportOrExportDeclaration", "ExportDeclaration"],
	  fields: {
	    declaration: {
	      optional: true,
	      validate: (0, _utils.chain)((0, _utils.assertNodeType)("Declaration"), Object.assign(function (node, key, val) {
	        if (!process.env.BABEL_TYPES_8_BREAKING) return;
	        if (val && node.specifiers.length) {
	          throw new TypeError("Only declaration or specifiers is allowed on ExportNamedDeclaration");
	        }
	      }, {
	        oneOfNodeTypes: ["Declaration"]
	      }), function (node, key, val) {
	        if (!process.env.BABEL_TYPES_8_BREAKING) return;
	        if (val && node.source) {
	          throw new TypeError("Cannot export a declaration from a source");
	        }
	      })
	    },
	    attributes: {
	      optional: true,
	      validate: (0, _utils.chain)((0, _utils.assertValueType)("array"), (0, _utils.assertEach)((0, _utils.assertNodeType)("ImportAttribute")))
	    },
	    assertions: {
	      optional: true,
	      validate: (0, _utils.chain)((0, _utils.assertValueType)("array"), (0, _utils.assertEach)((0, _utils.assertNodeType)("ImportAttribute")))
	    },
	    specifiers: {
	      default: [],
	      validate: (0, _utils.chain)((0, _utils.assertValueType)("array"), (0, _utils.assertEach)(function () {
	        const sourced = (0, _utils.assertNodeType)("ExportSpecifier", "ExportDefaultSpecifier", "ExportNamespaceSpecifier");
	        const sourceless = (0, _utils.assertNodeType)("ExportSpecifier");
	        if (!process.env.BABEL_TYPES_8_BREAKING) return sourced;
	        return function (node, key, val) {
	          const validator = node.source ? sourced : sourceless;
	          validator(node, key, val);
	        };
	      }()))
	    },
	    source: {
	      validate: (0, _utils.assertNodeType)("StringLiteral"),
	      optional: true
	    },
	    exportKind: (0, _utils.validateOptional)((0, _utils.assertOneOf)("type", "value"))
	  }
	});
	defineType("ExportSpecifier", {
	  visitor: ["local", "exported"],
	  aliases: ["ModuleSpecifier"],
	  fields: {
	    local: {
	      validate: (0, _utils.assertNodeType)("Identifier")
	    },
	    exported: {
	      validate: (0, _utils.assertNodeType)("Identifier", "StringLiteral")
	    },
	    exportKind: {
	      validate: (0, _utils.assertOneOf)("type", "value"),
	      optional: true
	    }
	  }
	});
	defineType("ForOfStatement", {
	  visitor: ["left", "right", "body"],
	  builder: ["left", "right", "body", "await"],
	  aliases: ["Scopable", "Statement", "For", "BlockParent", "Loop", "ForXStatement"],
	  fields: {
	    left: {
	      validate: function () {
	        if (!process.env.BABEL_TYPES_8_BREAKING) {
	          return (0, _utils.assertNodeType)("VariableDeclaration", "LVal");
	        }
	        const declaration = (0, _utils.assertNodeType)("VariableDeclaration");
	        const lval = (0, _utils.assertNodeType)("Identifier", "MemberExpression", "ArrayPattern", "ObjectPattern", "TSAsExpression", "TSSatisfiesExpression", "TSTypeAssertion", "TSNonNullExpression");
	        return function (node, key, val) {
	          if ((0, _is.default)("VariableDeclaration", val)) {
	            declaration(node, key, val);
	          } else {
	            lval(node, key, val);
	          }
	        };
	      }()
	    },
	    right: {
	      validate: (0, _utils.assertNodeType)("Expression")
	    },
	    body: {
	      validate: (0, _utils.assertNodeType)("Statement")
	    },
	    await: {
	      default: false
	    }
	  }
	});
	defineType("ImportDeclaration", {
	  builder: ["specifiers", "source"],
	  visitor: ["specifiers", "source", "attributes", "assertions"],
	  aliases: ["Statement", "Declaration", "ImportOrExportDeclaration"],
	  fields: {
	    attributes: {
	      optional: true,
	      validate: (0, _utils.chain)((0, _utils.assertValueType)("array"), (0, _utils.assertEach)((0, _utils.assertNodeType)("ImportAttribute")))
	    },
	    assertions: {
	      optional: true,
	      validate: (0, _utils.chain)((0, _utils.assertValueType)("array"), (0, _utils.assertEach)((0, _utils.assertNodeType)("ImportAttribute")))
	    },
	    module: {
	      optional: true,
	      validate: (0, _utils.assertValueType)("boolean")
	    },
	    phase: {
	      default: null,
	      validate: (0, _utils.assertOneOf)("source", "defer")
	    },
	    specifiers: {
	      validate: (0, _utils.chain)((0, _utils.assertValueType)("array"), (0, _utils.assertEach)((0, _utils.assertNodeType)("ImportSpecifier", "ImportDefaultSpecifier", "ImportNamespaceSpecifier")))
	    },
	    source: {
	      validate: (0, _utils.assertNodeType)("StringLiteral")
	    },
	    importKind: {
	      validate: (0, _utils.assertOneOf)("type", "typeof", "value"),
	      optional: true
	    }
	  }
	});
	defineType("ImportDefaultSpecifier", {
	  visitor: ["local"],
	  aliases: ["ModuleSpecifier"],
	  fields: {
	    local: {
	      validate: (0, _utils.assertNodeType)("Identifier")
	    }
	  }
	});
	defineType("ImportNamespaceSpecifier", {
	  visitor: ["local"],
	  aliases: ["ModuleSpecifier"],
	  fields: {
	    local: {
	      validate: (0, _utils.assertNodeType)("Identifier")
	    }
	  }
	});
	defineType("ImportSpecifier", {
	  visitor: ["local", "imported"],
	  aliases: ["ModuleSpecifier"],
	  fields: {
	    local: {
	      validate: (0, _utils.assertNodeType)("Identifier")
	    },
	    imported: {
	      validate: (0, _utils.assertNodeType)("Identifier", "StringLiteral")
	    },
	    importKind: {
	      validate: (0, _utils.assertOneOf)("type", "typeof", "value"),
	      optional: true
	    }
	  }
	});
	defineType("ImportExpression", {
	  visitor: ["source", "options"],
	  aliases: ["Expression"],
	  fields: {
	    phase: {
	      default: null,
	      validate: (0, _utils.assertOneOf)("source", "defer")
	    },
	    source: {
	      validate: (0, _utils.assertNodeType)("Expression")
	    },
	    options: {
	      validate: (0, _utils.assertNodeType)("Expression"),
	      optional: true
	    }
	  }
	});
	defineType("MetaProperty", {
	  visitor: ["meta", "property"],
	  aliases: ["Expression"],
	  fields: {
	    meta: {
	      validate: (0, _utils.chain)((0, _utils.assertNodeType)("Identifier"), Object.assign(function (node, key, val) {
	        if (!process.env.BABEL_TYPES_8_BREAKING) return;
	        let property;
	        switch (val.name) {
	          case "function":
	            property = "sent";
	            break;
	          case "new":
	            property = "target";
	            break;
	          case "import":
	            property = "meta";
	            break;
	        }
	        if (!(0, _is.default)("Identifier", node.property, {
	          name: property
	        })) {
	          throw new TypeError("Unrecognised MetaProperty");
	        }
	      }, {
	        oneOfNodeTypes: ["Identifier"]
	      }))
	    },
	    property: {
	      validate: (0, _utils.assertNodeType)("Identifier")
	    }
	  }
	});
	const classMethodOrPropertyCommon = () => ({
	  abstract: {
	    validate: (0, _utils.assertValueType)("boolean"),
	    optional: true
	  },
	  accessibility: {
	    validate: (0, _utils.assertOneOf)("public", "private", "protected"),
	    optional: true
	  },
	  static: {
	    default: false
	  },
	  override: {
	    default: false
	  },
	  computed: {
	    default: false
	  },
	  optional: {
	    validate: (0, _utils.assertValueType)("boolean"),
	    optional: true
	  },
	  key: {
	    validate: (0, _utils.chain)(function () {
	      const normal = (0, _utils.assertNodeType)("Identifier", "StringLiteral", "NumericLiteral", "BigIntLiteral");
	      const computed = (0, _utils.assertNodeType)("Expression");
	      return function (node, key, val) {
	        const validator = node.computed ? computed : normal;
	        validator(node, key, val);
	      };
	    }(), (0, _utils.assertNodeType)("Identifier", "StringLiteral", "NumericLiteral", "BigIntLiteral", "Expression"))
	  }
	});
	core$1.classMethodOrPropertyCommon = classMethodOrPropertyCommon;
	const classMethodOrDeclareMethodCommon = () => Object.assign({}, functionCommon(), classMethodOrPropertyCommon(), {
	  params: {
	    validate: (0, _utils.chain)((0, _utils.assertValueType)("array"), (0, _utils.assertEach)((0, _utils.assertNodeType)("Identifier", "Pattern", "RestElement", "TSParameterProperty")))
	  },
	  kind: {
	    validate: (0, _utils.assertOneOf)("get", "set", "method", "constructor"),
	    default: "method"
	  },
	  access: {
	    validate: (0, _utils.chain)((0, _utils.assertValueType)("string"), (0, _utils.assertOneOf)("public", "private", "protected")),
	    optional: true
	  },
	  decorators: {
	    validate: (0, _utils.chain)((0, _utils.assertValueType)("array"), (0, _utils.assertEach)((0, _utils.assertNodeType)("Decorator"))),
	    optional: true
	  }
	});
	core$1.classMethodOrDeclareMethodCommon = classMethodOrDeclareMethodCommon;
	defineType("ClassMethod", {
	  aliases: ["Function", "Scopable", "BlockParent", "FunctionParent", "Method"],
	  builder: ["kind", "key", "params", "body", "computed", "static", "generator", "async"],
	  visitor: ["key", "params", "body", "decorators", "returnType", "typeParameters"],
	  fields: Object.assign({}, classMethodOrDeclareMethodCommon(), functionTypeAnnotationCommon(), {
	    body: {
	      validate: (0, _utils.assertNodeType)("BlockStatement")
	    }
	  })
	});
	defineType("ObjectPattern", {
	  visitor: ["properties", "typeAnnotation", "decorators"],
	  builder: ["properties"],
	  aliases: ["Pattern", "PatternLike", "LVal"],
	  fields: Object.assign({}, patternLikeCommon(), {
	    properties: {
	      validate: (0, _utils.chain)((0, _utils.assertValueType)("array"), (0, _utils.assertEach)((0, _utils.assertNodeType)("RestElement", "ObjectProperty")))
	    }
	  })
	});
	defineType("SpreadElement", {
	  visitor: ["argument"],
	  aliases: ["UnaryLike"],
	  deprecatedAlias: "SpreadProperty",
	  fields: {
	    argument: {
	      validate: (0, _utils.assertNodeType)("Expression")
	    }
	  }
	});
	defineType("Super", {
	  aliases: ["Expression"]
	});
	defineType("TaggedTemplateExpression", {
	  visitor: ["tag", "quasi", "typeParameters"],
	  builder: ["tag", "quasi"],
	  aliases: ["Expression"],
	  fields: {
	    tag: {
	      validate: (0, _utils.assertNodeType)("Expression")
	    },
	    quasi: {
	      validate: (0, _utils.assertNodeType)("TemplateLiteral")
	    },
	    typeParameters: {
	      validate: (0, _utils.assertNodeType)("TypeParameterInstantiation", "TSTypeParameterInstantiation"),
	      optional: true
	    }
	  }
	});
	defineType("TemplateElement", {
	  builder: ["value", "tail"],
	  fields: {
	    value: {
	      validate: (0, _utils.chain)((0, _utils.assertShape)({
	        raw: {
	          validate: (0, _utils.assertValueType)("string")
	        },
	        cooked: {
	          validate: (0, _utils.assertValueType)("string"),
	          optional: true
	        }
	      }), function templateElementCookedValidator(node) {
	        const raw = node.value.raw;
	        let unterminatedCalled = false;
	        const error = () => {
	          throw new Error("Internal @babel/types error.");
	        };
	        const {
	          str,
	          firstInvalidLoc
	        } = (0, _helperStringParser.readStringContents)("template", raw, 0, 0, 0, {
	          unterminated() {
	            unterminatedCalled = true;
	          },
	          strictNumericEscape: error,
	          invalidEscapeSequence: error,
	          numericSeparatorInEscapeSequence: error,
	          unexpectedNumericSeparator: error,
	          invalidDigit: error,
	          invalidCodePoint: error
	        });
	        if (!unterminatedCalled) throw new Error("Invalid raw");
	        node.value.cooked = firstInvalidLoc ? null : str;
	      })
	    },
	    tail: {
	      default: false
	    }
	  }
	});
	defineType("TemplateLiteral", {
	  visitor: ["quasis", "expressions"],
	  aliases: ["Expression", "Literal"],
	  fields: {
	    quasis: {
	      validate: (0, _utils.chain)((0, _utils.assertValueType)("array"), (0, _utils.assertEach)((0, _utils.assertNodeType)("TemplateElement")))
	    },
	    expressions: {
	      validate: (0, _utils.chain)((0, _utils.assertValueType)("array"), (0, _utils.assertEach)((0, _utils.assertNodeType)("Expression", "TSType")), function (node, key, val) {
	        if (node.quasis.length !== val.length + 1) {
	          throw new TypeError(`Number of ${node.type} quasis should be exactly one more than the number of expressions.\nExpected ${val.length + 1} quasis but got ${node.quasis.length}`);
	        }
	      })
	    }
	  }
	});
	defineType("YieldExpression", {
	  builder: ["argument", "delegate"],
	  visitor: ["argument"],
	  aliases: ["Expression", "Terminatorless"],
	  fields: {
	    delegate: {
	      validate: (0, _utils.chain)((0, _utils.assertValueType)("boolean"), Object.assign(function (node, key, val) {
	        if (!process.env.BABEL_TYPES_8_BREAKING) return;
	        if (val && !node.argument) {
	          throw new TypeError("Property delegate of YieldExpression cannot be true if there is no argument");
	        }
	      }, {
	        type: "boolean"
	      })),
	      default: false
	    },
	    argument: {
	      optional: true,
	      validate: (0, _utils.assertNodeType)("Expression")
	    }
	  }
	});
	defineType("AwaitExpression", {
	  builder: ["argument"],
	  visitor: ["argument"],
	  aliases: ["Expression", "Terminatorless"],
	  fields: {
	    argument: {
	      validate: (0, _utils.assertNodeType)("Expression")
	    }
	  }
	});
	defineType("Import", {
	  aliases: ["Expression"]
	});
	defineType("BigIntLiteral", {
	  builder: ["value"],
	  fields: {
	    value: {
	      validate: (0, _utils.assertValueType)("string")
	    }
	  },
	  aliases: ["Expression", "Pureish", "Literal", "Immutable"]
	});
	defineType("ExportNamespaceSpecifier", {
	  visitor: ["exported"],
	  aliases: ["ModuleSpecifier"],
	  fields: {
	    exported: {
	      validate: (0, _utils.assertNodeType)("Identifier")
	    }
	  }
	});
	defineType("OptionalMemberExpression", {
	  builder: ["object", "property", "computed", "optional"],
	  visitor: ["object", "property"],
	  aliases: ["Expression"],
	  fields: {
	    object: {
	      validate: (0, _utils.assertNodeType)("Expression")
	    },
	    property: {
	      validate: function () {
	        const normal = (0, _utils.assertNodeType)("Identifier");
	        const computed = (0, _utils.assertNodeType)("Expression");
	        const validator = Object.assign(function (node, key, val) {
	          const validator = node.computed ? computed : normal;
	          validator(node, key, val);
	        }, {
	          oneOfNodeTypes: ["Expression", "Identifier"]
	        });
	        return validator;
	      }()
	    },
	    computed: {
	      default: false
	    },
	    optional: {
	      validate: !process.env.BABEL_TYPES_8_BREAKING ? (0, _utils.assertValueType)("boolean") : (0, _utils.chain)((0, _utils.assertValueType)("boolean"), (0, _utils.assertOptionalChainStart)())
	    }
	  }
	});
	defineType("OptionalCallExpression", {
	  visitor: ["callee", "arguments", "typeParameters", "typeArguments"],
	  builder: ["callee", "arguments", "optional"],
	  aliases: ["Expression"],
	  fields: {
	    callee: {
	      validate: (0, _utils.assertNodeType)("Expression")
	    },
	    arguments: {
	      validate: (0, _utils.chain)((0, _utils.assertValueType)("array"), (0, _utils.assertEach)((0, _utils.assertNodeType)("Expression", "SpreadElement", "ArgumentPlaceholder")))
	    },
	    optional: {
	      validate: !process.env.BABEL_TYPES_8_BREAKING ? (0, _utils.assertValueType)("boolean") : (0, _utils.chain)((0, _utils.assertValueType)("boolean"), (0, _utils.assertOptionalChainStart)())
	    },
	    typeArguments: {
	      validate: (0, _utils.assertNodeType)("TypeParameterInstantiation"),
	      optional: true
	    },
	    typeParameters: {
	      validate: (0, _utils.assertNodeType)("TSTypeParameterInstantiation"),
	      optional: true
	    }
	  }
	});
	defineType("ClassProperty", {
	  visitor: ["key", "value", "typeAnnotation", "decorators"],
	  builder: ["key", "value", "typeAnnotation", "decorators", "computed", "static"],
	  aliases: ["Property"],
	  fields: Object.assign({}, classMethodOrPropertyCommon(), {
	    value: {
	      validate: (0, _utils.assertNodeType)("Expression"),
	      optional: true
	    },
	    definite: {
	      validate: (0, _utils.assertValueType)("boolean"),
	      optional: true
	    },
	    typeAnnotation: {
	      validate: (0, _utils.assertNodeType)("TypeAnnotation", "TSTypeAnnotation", "Noop"),
	      optional: true
	    },
	    decorators: {
	      validate: (0, _utils.chain)((0, _utils.assertValueType)("array"), (0, _utils.assertEach)((0, _utils.assertNodeType)("Decorator"))),
	      optional: true
	    },
	    readonly: {
	      validate: (0, _utils.assertValueType)("boolean"),
	      optional: true
	    },
	    declare: {
	      validate: (0, _utils.assertValueType)("boolean"),
	      optional: true
	    },
	    variance: {
	      validate: (0, _utils.assertNodeType)("Variance"),
	      optional: true
	    }
	  })
	});
	defineType("ClassAccessorProperty", {
	  visitor: ["key", "value", "typeAnnotation", "decorators"],
	  builder: ["key", "value", "typeAnnotation", "decorators", "computed", "static"],
	  aliases: ["Property", "Accessor"],
	  fields: Object.assign({}, classMethodOrPropertyCommon(), {
	    key: {
	      validate: (0, _utils.chain)(function () {
	        const normal = (0, _utils.assertNodeType)("Identifier", "StringLiteral", "NumericLiteral", "BigIntLiteral", "PrivateName");
	        const computed = (0, _utils.assertNodeType)("Expression");
	        return function (node, key, val) {
	          const validator = node.computed ? computed : normal;
	          validator(node, key, val);
	        };
	      }(), (0, _utils.assertNodeType)("Identifier", "StringLiteral", "NumericLiteral", "BigIntLiteral", "Expression", "PrivateName"))
	    },
	    value: {
	      validate: (0, _utils.assertNodeType)("Expression"),
	      optional: true
	    },
	    definite: {
	      validate: (0, _utils.assertValueType)("boolean"),
	      optional: true
	    },
	    typeAnnotation: {
	      validate: (0, _utils.assertNodeType)("TypeAnnotation", "TSTypeAnnotation", "Noop"),
	      optional: true
	    },
	    decorators: {
	      validate: (0, _utils.chain)((0, _utils.assertValueType)("array"), (0, _utils.assertEach)((0, _utils.assertNodeType)("Decorator"))),
	      optional: true
	    },
	    readonly: {
	      validate: (0, _utils.assertValueType)("boolean"),
	      optional: true
	    },
	    declare: {
	      validate: (0, _utils.assertValueType)("boolean"),
	      optional: true
	    },
	    variance: {
	      validate: (0, _utils.assertNodeType)("Variance"),
	      optional: true
	    }
	  })
	});
	defineType("ClassPrivateProperty", {
	  visitor: ["key", "value", "decorators", "typeAnnotation"],
	  builder: ["key", "value", "decorators", "static"],
	  aliases: ["Property", "Private"],
	  fields: {
	    key: {
	      validate: (0, _utils.assertNodeType)("PrivateName")
	    },
	    value: {
	      validate: (0, _utils.assertNodeType)("Expression"),
	      optional: true
	    },
	    typeAnnotation: {
	      validate: (0, _utils.assertNodeType)("TypeAnnotation", "TSTypeAnnotation", "Noop"),
	      optional: true
	    },
	    decorators: {
	      validate: (0, _utils.chain)((0, _utils.assertValueType)("array"), (0, _utils.assertEach)((0, _utils.assertNodeType)("Decorator"))),
	      optional: true
	    },
	    static: {
	      validate: (0, _utils.assertValueType)("boolean"),
	      default: false
	    },
	    readonly: {
	      validate: (0, _utils.assertValueType)("boolean"),
	      optional: true
	    },
	    definite: {
	      validate: (0, _utils.assertValueType)("boolean"),
	      optional: true
	    },
	    variance: {
	      validate: (0, _utils.assertNodeType)("Variance"),
	      optional: true
	    }
	  }
	});
	defineType("ClassPrivateMethod", {
	  builder: ["kind", "key", "params", "body", "static"],
	  visitor: ["key", "params", "body", "decorators", "returnType", "typeParameters"],
	  aliases: ["Function", "Scopable", "BlockParent", "FunctionParent", "Method", "Private"],
	  fields: Object.assign({}, classMethodOrDeclareMethodCommon(), functionTypeAnnotationCommon(), {
	    kind: {
	      validate: (0, _utils.assertOneOf)("get", "set", "method"),
	      default: "method"
	    },
	    key: {
	      validate: (0, _utils.assertNodeType)("PrivateName")
	    },
	    body: {
	      validate: (0, _utils.assertNodeType)("BlockStatement")
	    }
	  })
	});
	defineType("PrivateName", {
	  visitor: ["id"],
	  aliases: ["Private"],
	  fields: {
	    id: {
	      validate: (0, _utils.assertNodeType)("Identifier")
	    }
	  }
	});
	defineType("StaticBlock", {
	  visitor: ["body"],
	  fields: {
	    body: {
	      validate: (0, _utils.chain)((0, _utils.assertValueType)("array"), (0, _utils.assertEach)((0, _utils.assertNodeType)("Statement")))
	    }
	  },
	  aliases: ["Scopable", "BlockParent", "FunctionParent"]
	});

	
	return core$1;
}

var flow$1 = {};

var hasRequiredFlow$1;

function requireFlow$1 () {
	if (hasRequiredFlow$1) return flow$1;
	hasRequiredFlow$1 = 1;

	var _utils = requireUtils$1();
	const defineType = (0, _utils.defineAliasedType)("Flow");
	const defineInterfaceishType = name => {
	  const isDeclareClass = name === "DeclareClass";
	  defineType(name, {
	    builder: ["id", "typeParameters", "extends", "body"],
	    visitor: ["id", "typeParameters", "extends", ...(isDeclareClass ? ["mixins", "implements"] : []), "body"],
	    aliases: ["FlowDeclaration", "Statement", "Declaration"],
	    fields: Object.assign({
	      id: (0, _utils.validateType)("Identifier"),
	      typeParameters: (0, _utils.validateOptionalType)("TypeParameterDeclaration"),
	      extends: (0, _utils.validateOptional)((0, _utils.arrayOfType)("InterfaceExtends"))
	    }, isDeclareClass ? {
	      mixins: (0, _utils.validateOptional)((0, _utils.arrayOfType)("InterfaceExtends")),
	      implements: (0, _utils.validateOptional)((0, _utils.arrayOfType)("ClassImplements"))
	    } : {}, {
	      body: (0, _utils.validateType)("ObjectTypeAnnotation")
	    })
	  });
	};
	defineType("AnyTypeAnnotation", {
	  aliases: ["FlowType", "FlowBaseAnnotation"]
	});
	defineType("ArrayTypeAnnotation", {
	  visitor: ["elementType"],
	  aliases: ["FlowType"],
	  fields: {
	    elementType: (0, _utils.validateType)("FlowType")
	  }
	});
	defineType("BooleanTypeAnnotation", {
	  aliases: ["FlowType", "FlowBaseAnnotation"]
	});
	defineType("BooleanLiteralTypeAnnotation", {
	  builder: ["value"],
	  aliases: ["FlowType"],
	  fields: {
	    value: (0, _utils.validate)((0, _utils.assertValueType)("boolean"))
	  }
	});
	defineType("NullLiteralTypeAnnotation", {
	  aliases: ["FlowType", "FlowBaseAnnotation"]
	});
	defineType("ClassImplements", {
	  visitor: ["id", "typeParameters"],
	  fields: {
	    id: (0, _utils.validateType)("Identifier"),
	    typeParameters: (0, _utils.validateOptionalType)("TypeParameterInstantiation")
	  }
	});
	defineInterfaceishType("DeclareClass");
	defineType("DeclareFunction", {
	  visitor: ["id"],
	  aliases: ["FlowDeclaration", "Statement", "Declaration"],
	  fields: {
	    id: (0, _utils.validateType)("Identifier"),
	    predicate: (0, _utils.validateOptionalType)("DeclaredPredicate")
	  }
	});
	defineInterfaceishType("DeclareInterface");
	defineType("DeclareModule", {
	  builder: ["id", "body", "kind"],
	  visitor: ["id", "body"],
	  aliases: ["FlowDeclaration", "Statement", "Declaration"],
	  fields: {
	    id: (0, _utils.validateType)(["Identifier", "StringLiteral"]),
	    body: (0, _utils.validateType)("BlockStatement"),
	    kind: (0, _utils.validateOptional)((0, _utils.assertOneOf)("CommonJS", "ES"))
	  }
	});
	defineType("DeclareModuleExports", {
	  visitor: ["typeAnnotation"],
	  aliases: ["FlowDeclaration", "Statement", "Declaration"],
	  fields: {
	    typeAnnotation: (0, _utils.validateType)("TypeAnnotation")
	  }
	});
	defineType("DeclareTypeAlias", {
	  visitor: ["id", "typeParameters", "right"],
	  aliases: ["FlowDeclaration", "Statement", "Declaration"],
	  fields: {
	    id: (0, _utils.validateType)("Identifier"),
	    typeParameters: (0, _utils.validateOptionalType)("TypeParameterDeclaration"),
	    right: (0, _utils.validateType)("FlowType")
	  }
	});
	defineType("DeclareOpaqueType", {
	  visitor: ["id", "typeParameters", "supertype"],
	  aliases: ["FlowDeclaration", "Statement", "Declaration"],
	  fields: {
	    id: (0, _utils.validateType)("Identifier"),
	    typeParameters: (0, _utils.validateOptionalType)("TypeParameterDeclaration"),
	    supertype: (0, _utils.validateOptionalType)("FlowType"),
	    impltype: (0, _utils.validateOptionalType)("FlowType")
	  }
	});
	defineType("DeclareVariable", {
	  visitor: ["id"],
	  aliases: ["FlowDeclaration", "Statement", "Declaration"],
	  fields: {
	    id: (0, _utils.validateType)("Identifier")
	  }
	});
	defineType("DeclareExportDeclaration", {
	  visitor: ["declaration", "specifiers", "source"],
	  aliases: ["FlowDeclaration", "Statement", "Declaration"],
	  fields: {
	    declaration: (0, _utils.validateOptionalType)("Flow"),
	    specifiers: (0, _utils.validateOptional)((0, _utils.arrayOfType)(["ExportSpecifier", "ExportNamespaceSpecifier"])),
	    source: (0, _utils.validateOptionalType)("StringLiteral"),
	    default: (0, _utils.validateOptional)((0, _utils.assertValueType)("boolean"))
	  }
	});
	defineType("DeclareExportAllDeclaration", {
	  visitor: ["source"],
	  aliases: ["FlowDeclaration", "Statement", "Declaration"],
	  fields: {
	    source: (0, _utils.validateType)("StringLiteral"),
	    exportKind: (0, _utils.validateOptional)((0, _utils.assertOneOf)("type", "value"))
	  }
	});
	defineType("DeclaredPredicate", {
	  visitor: ["value"],
	  aliases: ["FlowPredicate"],
	  fields: {
	    value: (0, _utils.validateType)("Flow")
	  }
	});
	defineType("ExistsTypeAnnotation", {
	  aliases: ["FlowType"]
	});
	defineType("FunctionTypeAnnotation", {
	  visitor: ["typeParameters", "params", "rest", "returnType"],
	  aliases: ["FlowType"],
	  fields: {
	    typeParameters: (0, _utils.validateOptionalType)("TypeParameterDeclaration"),
	    params: (0, _utils.validate)((0, _utils.arrayOfType)("FunctionTypeParam")),
	    rest: (0, _utils.validateOptionalType)("FunctionTypeParam"),
	    this: (0, _utils.validateOptionalType)("FunctionTypeParam"),
	    returnType: (0, _utils.validateType)("FlowType")
	  }
	});
	defineType("FunctionTypeParam", {
	  visitor: ["name", "typeAnnotation"],
	  fields: {
	    name: (0, _utils.validateOptionalType)("Identifier"),
	    typeAnnotation: (0, _utils.validateType)("FlowType"),
	    optional: (0, _utils.validateOptional)((0, _utils.assertValueType)("boolean"))
	  }
	});
	defineType("GenericTypeAnnotation", {
	  visitor: ["id", "typeParameters"],
	  aliases: ["FlowType"],
	  fields: {
	    id: (0, _utils.validateType)(["Identifier", "QualifiedTypeIdentifier"]),
	    typeParameters: (0, _utils.validateOptionalType)("TypeParameterInstantiation")
	  }
	});
	defineType("InferredPredicate", {
	  aliases: ["FlowPredicate"]
	});
	defineType("InterfaceExtends", {
	  visitor: ["id", "typeParameters"],
	  fields: {
	    id: (0, _utils.validateType)(["Identifier", "QualifiedTypeIdentifier"]),
	    typeParameters: (0, _utils.validateOptionalType)("TypeParameterInstantiation")
	  }
	});
	defineInterfaceishType("InterfaceDeclaration");
	defineType("InterfaceTypeAnnotation", {
	  visitor: ["extends", "body"],
	  aliases: ["FlowType"],
	  fields: {
	    extends: (0, _utils.validateOptional)((0, _utils.arrayOfType)("InterfaceExtends")),
	    body: (0, _utils.validateType)("ObjectTypeAnnotation")
	  }
	});
	defineType("IntersectionTypeAnnotation", {
	  visitor: ["types"],
	  aliases: ["FlowType"],
	  fields: {
	    types: (0, _utils.validate)((0, _utils.arrayOfType)("FlowType"))
	  }
	});
	defineType("MixedTypeAnnotation", {
	  aliases: ["FlowType", "FlowBaseAnnotation"]
	});
	defineType("EmptyTypeAnnotation", {
	  aliases: ["FlowType", "FlowBaseAnnotation"]
	});
	defineType("NullableTypeAnnotation", {
	  visitor: ["typeAnnotation"],
	  aliases: ["FlowType"],
	  fields: {
	    typeAnnotation: (0, _utils.validateType)("FlowType")
	  }
	});
	defineType("NumberLiteralTypeAnnotation", {
	  builder: ["value"],
	  aliases: ["FlowType"],
	  fields: {
	    value: (0, _utils.validate)((0, _utils.assertValueType)("number"))
	  }
	});
	defineType("NumberTypeAnnotation", {
	  aliases: ["FlowType", "FlowBaseAnnotation"]
	});
	defineType("ObjectTypeAnnotation", {
	  visitor: ["properties", "indexers", "callProperties", "internalSlots"],
	  aliases: ["FlowType"],
	  builder: ["properties", "indexers", "callProperties", "internalSlots", "exact"],
	  fields: {
	    properties: (0, _utils.validate)((0, _utils.arrayOfType)(["ObjectTypeProperty", "ObjectTypeSpreadProperty"])),
	    indexers: {
	      validate: (0, _utils.arrayOfType)("ObjectTypeIndexer"),
	      optional: true,
	      default: []
	    },
	    callProperties: {
	      validate: (0, _utils.arrayOfType)("ObjectTypeCallProperty"),
	      optional: true,
	      default: []
	    },
	    internalSlots: {
	      validate: (0, _utils.arrayOfType)("ObjectTypeInternalSlot"),
	      optional: true,
	      default: []
	    },
	    exact: {
	      validate: (0, _utils.assertValueType)("boolean"),
	      default: false
	    },
	    inexact: (0, _utils.validateOptional)((0, _utils.assertValueType)("boolean"))
	  }
	});
	defineType("ObjectTypeInternalSlot", {
	  visitor: ["id", "value", "optional", "static", "method"],
	  aliases: ["UserWhitespacable"],
	  fields: {
	    id: (0, _utils.validateType)("Identifier"),
	    value: (0, _utils.validateType)("FlowType"),
	    optional: (0, _utils.validate)((0, _utils.assertValueType)("boolean")),
	    static: (0, _utils.validate)((0, _utils.assertValueType)("boolean")),
	    method: (0, _utils.validate)((0, _utils.assertValueType)("boolean"))
	  }
	});
	defineType("ObjectTypeCallProperty", {
	  visitor: ["value"],
	  aliases: ["UserWhitespacable"],
	  fields: {
	    value: (0, _utils.validateType)("FlowType"),
	    static: (0, _utils.validate)((0, _utils.assertValueType)("boolean"))
	  }
	});
	defineType("ObjectTypeIndexer", {
	  visitor: ["id", "key", "value", "variance"],
	  aliases: ["UserWhitespacable"],
	  fields: {
	    id: (0, _utils.validateOptionalType)("Identifier"),
	    key: (0, _utils.validateType)("FlowType"),
	    value: (0, _utils.validateType)("FlowType"),
	    static: (0, _utils.validate)((0, _utils.assertValueType)("boolean")),
	    variance: (0, _utils.validateOptionalType)("Variance")
	  }
	});
	defineType("ObjectTypeProperty", {
	  visitor: ["key", "value", "variance"],
	  aliases: ["UserWhitespacable"],
	  fields: {
	    key: (0, _utils.validateType)(["Identifier", "StringLiteral"]),
	    value: (0, _utils.validateType)("FlowType"),
	    kind: (0, _utils.validate)((0, _utils.assertOneOf)("init", "get", "set")),
	    static: (0, _utils.validate)((0, _utils.assertValueType)("boolean")),
	    proto: (0, _utils.validate)((0, _utils.assertValueType)("boolean")),
	    optional: (0, _utils.validate)((0, _utils.assertValueType)("boolean")),
	    variance: (0, _utils.validateOptionalType)("Variance"),
	    method: (0, _utils.validate)((0, _utils.assertValueType)("boolean"))
	  }
	});
	defineType("ObjectTypeSpreadProperty", {
	  visitor: ["argument"],
	  aliases: ["UserWhitespacable"],
	  fields: {
	    argument: (0, _utils.validateType)("FlowType")
	  }
	});
	defineType("OpaqueType", {
	  visitor: ["id", "typeParameters", "supertype", "impltype"],
	  aliases: ["FlowDeclaration", "Statement", "Declaration"],
	  fields: {
	    id: (0, _utils.validateType)("Identifier"),
	    typeParameters: (0, _utils.validateOptionalType)("TypeParameterDeclaration"),
	    supertype: (0, _utils.validateOptionalType)("FlowType"),
	    impltype: (0, _utils.validateType)("FlowType")
	  }
	});
	defineType("QualifiedTypeIdentifier", {
	  visitor: ["id", "qualification"],
	  fields: {
	    id: (0, _utils.validateType)("Identifier"),
	    qualification: (0, _utils.validateType)(["Identifier", "QualifiedTypeIdentifier"])
	  }
	});
	defineType("StringLiteralTypeAnnotation", {
	  builder: ["value"],
	  aliases: ["FlowType"],
	  fields: {
	    value: (0, _utils.validate)((0, _utils.assertValueType)("string"))
	  }
	});
	defineType("StringTypeAnnotation", {
	  aliases: ["FlowType", "FlowBaseAnnotation"]
	});
	defineType("SymbolTypeAnnotation", {
	  aliases: ["FlowType", "FlowBaseAnnotation"]
	});
	defineType("ThisTypeAnnotation", {
	  aliases: ["FlowType", "FlowBaseAnnotation"]
	});
	defineType("TupleTypeAnnotation", {
	  visitor: ["types"],
	  aliases: ["FlowType"],
	  fields: {
	    types: (0, _utils.validate)((0, _utils.arrayOfType)("FlowType"))
	  }
	});
	defineType("TypeofTypeAnnotation", {
	  visitor: ["argument"],
	  aliases: ["FlowType"],
	  fields: {
	    argument: (0, _utils.validateType)("FlowType")
	  }
	});
	defineType("TypeAlias", {
	  visitor: ["id", "typeParameters", "right"],
	  aliases: ["FlowDeclaration", "Statement", "Declaration"],
	  fields: {
	    id: (0, _utils.validateType)("Identifier"),
	    typeParameters: (0, _utils.validateOptionalType)("TypeParameterDeclaration"),
	    right: (0, _utils.validateType)("FlowType")
	  }
	});
	defineType("TypeAnnotation", {
	  visitor: ["typeAnnotation"],
	  fields: {
	    typeAnnotation: (0, _utils.validateType)("FlowType")
	  }
	});
	defineType("TypeCastExpression", {
	  visitor: ["expression", "typeAnnotation"],
	  aliases: ["ExpressionWrapper", "Expression"],
	  fields: {
	    expression: (0, _utils.validateType)("Expression"),
	    typeAnnotation: (0, _utils.validateType)("TypeAnnotation")
	  }
	});
	defineType("TypeParameter", {
	  visitor: ["bound", "default", "variance"],
	  fields: {
	    name: (0, _utils.validate)((0, _utils.assertValueType)("string")),
	    bound: (0, _utils.validateOptionalType)("TypeAnnotation"),
	    default: (0, _utils.validateOptionalType)("FlowType"),
	    variance: (0, _utils.validateOptionalType)("Variance")
	  }
	});
	defineType("TypeParameterDeclaration", {
	  visitor: ["params"],
	  fields: {
	    params: (0, _utils.validate)((0, _utils.arrayOfType)("TypeParameter"))
	  }
	});
	defineType("TypeParameterInstantiation", {
	  visitor: ["params"],
	  fields: {
	    params: (0, _utils.validate)((0, _utils.arrayOfType)("FlowType"))
	  }
	});
	defineType("UnionTypeAnnotation", {
	  visitor: ["types"],
	  aliases: ["FlowType"],
	  fields: {
	    types: (0, _utils.validate)((0, _utils.arrayOfType)("FlowType"))
	  }
	});
	defineType("Variance", {
	  builder: ["kind"],
	  fields: {
	    kind: (0, _utils.validate)((0, _utils.assertOneOf)("minus", "plus"))
	  }
	});
	defineType("VoidTypeAnnotation", {
	  aliases: ["FlowType", "FlowBaseAnnotation"]
	});
	defineType("EnumDeclaration", {
	  aliases: ["Statement", "Declaration"],
	  visitor: ["id", "body"],
	  fields: {
	    id: (0, _utils.validateType)("Identifier"),
	    body: (0, _utils.validateType)(["EnumBooleanBody", "EnumNumberBody", "EnumStringBody", "EnumSymbolBody"])
	  }
	});
	defineType("EnumBooleanBody", {
	  aliases: ["EnumBody"],
	  visitor: ["members"],
	  fields: {
	    explicitType: (0, _utils.validate)((0, _utils.assertValueType)("boolean")),
	    members: (0, _utils.validateArrayOfType)("EnumBooleanMember"),
	    hasUnknownMembers: (0, _utils.validate)((0, _utils.assertValueType)("boolean"))
	  }
	});
	defineType("EnumNumberBody", {
	  aliases: ["EnumBody"],
	  visitor: ["members"],
	  fields: {
	    explicitType: (0, _utils.validate)((0, _utils.assertValueType)("boolean")),
	    members: (0, _utils.validateArrayOfType)("EnumNumberMember"),
	    hasUnknownMembers: (0, _utils.validate)((0, _utils.assertValueType)("boolean"))
	  }
	});
	defineType("EnumStringBody", {
	  aliases: ["EnumBody"],
	  visitor: ["members"],
	  fields: {
	    explicitType: (0, _utils.validate)((0, _utils.assertValueType)("boolean")),
	    members: (0, _utils.validateArrayOfType)(["EnumStringMember", "EnumDefaultedMember"]),
	    hasUnknownMembers: (0, _utils.validate)((0, _utils.assertValueType)("boolean"))
	  }
	});
	defineType("EnumSymbolBody", {
	  aliases: ["EnumBody"],
	  visitor: ["members"],
	  fields: {
	    members: (0, _utils.validateArrayOfType)("EnumDefaultedMember"),
	    hasUnknownMembers: (0, _utils.validate)((0, _utils.assertValueType)("boolean"))
	  }
	});
	defineType("EnumBooleanMember", {
	  aliases: ["EnumMember"],
	  visitor: ["id"],
	  fields: {
	    id: (0, _utils.validateType)("Identifier"),
	    init: (0, _utils.validateType)("BooleanLiteral")
	  }
	});
	defineType("EnumNumberMember", {
	  aliases: ["EnumMember"],
	  visitor: ["id", "init"],
	  fields: {
	    id: (0, _utils.validateType)("Identifier"),
	    init: (0, _utils.validateType)("NumericLiteral")
	  }
	});
	defineType("EnumStringMember", {
	  aliases: ["EnumMember"],
	  visitor: ["id", "init"],
	  fields: {
	    id: (0, _utils.validateType)("Identifier"),
	    init: (0, _utils.validateType)("StringLiteral")
	  }
	});
	defineType("EnumDefaultedMember", {
	  aliases: ["EnumMember"],
	  visitor: ["id"],
	  fields: {
	    id: (0, _utils.validateType)("Identifier")
	  }
	});
	defineType("IndexedAccessType", {
	  visitor: ["objectType", "indexType"],
	  aliases: ["FlowType"],
	  fields: {
	    objectType: (0, _utils.validateType)("FlowType"),
	    indexType: (0, _utils.validateType)("FlowType")
	  }
	});
	defineType("OptionalIndexedAccessType", {
	  visitor: ["objectType", "indexType"],
	  aliases: ["FlowType"],
	  fields: {
	    objectType: (0, _utils.validateType)("FlowType"),
	    indexType: (0, _utils.validateType)("FlowType"),
	    optional: (0, _utils.validate)((0, _utils.assertValueType)("boolean"))
	  }
	});

	
	return flow$1;
}

var jsx$1 = {};

var hasRequiredJsx$1;

function requireJsx$1 () {
	if (hasRequiredJsx$1) return jsx$1;
	hasRequiredJsx$1 = 1;

	var _utils = requireUtils$1();
	const defineType = (0, _utils.defineAliasedType)("JSX");
	defineType("JSXAttribute", {
	  visitor: ["name", "value"],
	  aliases: ["Immutable"],
	  fields: {
	    name: {
	      validate: (0, _utils.assertNodeType)("JSXIdentifier", "JSXNamespacedName")
	    },
	    value: {
	      optional: true,
	      validate: (0, _utils.assertNodeType)("JSXElement", "JSXFragment", "StringLiteral", "JSXExpressionContainer")
	    }
	  }
	});
	defineType("JSXClosingElement", {
	  visitor: ["name"],
	  aliases: ["Immutable"],
	  fields: {
	    name: {
	      validate: (0, _utils.assertNodeType)("JSXIdentifier", "JSXMemberExpression", "JSXNamespacedName")
	    }
	  }
	});
	defineType("JSXElement", {
	  builder: ["openingElement", "closingElement", "children", "selfClosing"],
	  visitor: ["openingElement", "children", "closingElement"],
	  aliases: ["Immutable", "Expression"],
	  fields: Object.assign({
	    openingElement: {
	      validate: (0, _utils.assertNodeType)("JSXOpeningElement")
	    },
	    closingElement: {
	      optional: true,
	      validate: (0, _utils.assertNodeType)("JSXClosingElement")
	    },
	    children: {
	      validate: (0, _utils.chain)((0, _utils.assertValueType)("array"), (0, _utils.assertEach)((0, _utils.assertNodeType)("JSXText", "JSXExpressionContainer", "JSXSpreadChild", "JSXElement", "JSXFragment")))
	    }
	  }, {
	    selfClosing: {
	      validate: (0, _utils.assertValueType)("boolean"),
	      optional: true
	    }
	  })
	});
	defineType("JSXEmptyExpression", {});
	defineType("JSXExpressionContainer", {
	  visitor: ["expression"],
	  aliases: ["Immutable"],
	  fields: {
	    expression: {
	      validate: (0, _utils.assertNodeType)("Expression", "JSXEmptyExpression")
	    }
	  }
	});
	defineType("JSXSpreadChild", {
	  visitor: ["expression"],
	  aliases: ["Immutable"],
	  fields: {
	    expression: {
	      validate: (0, _utils.assertNodeType)("Expression")
	    }
	  }
	});
	defineType("JSXIdentifier", {
	  builder: ["name"],
	  fields: {
	    name: {
	      validate: (0, _utils.assertValueType)("string")
	    }
	  }
	});
	defineType("JSXMemberExpression", {
	  visitor: ["object", "property"],
	  fields: {
	    object: {
	      validate: (0, _utils.assertNodeType)("JSXMemberExpression", "JSXIdentifier")
	    },
	    property: {
	      validate: (0, _utils.assertNodeType)("JSXIdentifier")
	    }
	  }
	});
	defineType("JSXNamespacedName", {
	  visitor: ["namespace", "name"],
	  fields: {
	    namespace: {
	      validate: (0, _utils.assertNodeType)("JSXIdentifier")
	    },
	    name: {
	      validate: (0, _utils.assertNodeType)("JSXIdentifier")
	    }
	  }
	});
	defineType("JSXOpeningElement", {
	  builder: ["name", "attributes", "selfClosing"],
	  visitor: ["name", "attributes"],
	  aliases: ["Immutable"],
	  fields: {
	    name: {
	      validate: (0, _utils.assertNodeType)("JSXIdentifier", "JSXMemberExpression", "JSXNamespacedName")
	    },
	    selfClosing: {
	      default: false
	    },
	    attributes: {
	      validate: (0, _utils.chain)((0, _utils.assertValueType)("array"), (0, _utils.assertEach)((0, _utils.assertNodeType)("JSXAttribute", "JSXSpreadAttribute")))
	    },
	    typeParameters: {
	      validate: (0, _utils.assertNodeType)("TypeParameterInstantiation", "TSTypeParameterInstantiation"),
	      optional: true
	    }
	  }
	});
	defineType("JSXSpreadAttribute", {
	  visitor: ["argument"],
	  fields: {
	    argument: {
	      validate: (0, _utils.assertNodeType)("Expression")
	    }
	  }
	});
	defineType("JSXText", {
	  aliases: ["Immutable"],
	  builder: ["value"],
	  fields: {
	    value: {
	      validate: (0, _utils.assertValueType)("string")
	    }
	  }
	});
	defineType("JSXFragment", {
	  builder: ["openingFragment", "closingFragment", "children"],
	  visitor: ["openingFragment", "children", "closingFragment"],
	  aliases: ["Immutable", "Expression"],
	  fields: {
	    openingFragment: {
	      validate: (0, _utils.assertNodeType)("JSXOpeningFragment")
	    },
	    closingFragment: {
	      validate: (0, _utils.assertNodeType)("JSXClosingFragment")
	    },
	    children: {
	      validate: (0, _utils.chain)((0, _utils.assertValueType)("array"), (0, _utils.assertEach)((0, _utils.assertNodeType)("JSXText", "JSXExpressionContainer", "JSXSpreadChild", "JSXElement", "JSXFragment")))
	    }
	  }
	});
	defineType("JSXOpeningFragment", {
	  aliases: ["Immutable"]
	});
	defineType("JSXClosingFragment", {
	  aliases: ["Immutable"]
	});

	
	return jsx$1;
}

var misc = {};

var placeholders = {};

var hasRequiredPlaceholders;

function requirePlaceholders () {
	if (hasRequiredPlaceholders) return placeholders;
	hasRequiredPlaceholders = 1;

	Object.defineProperty(placeholders, "__esModule", {
	  value: true
	});
	placeholders.PLACEHOLDERS_FLIPPED_ALIAS = placeholders.PLACEHOLDERS_ALIAS = placeholders.PLACEHOLDERS = void 0;
	var _utils = requireUtils$1();
	const PLACEHOLDERS = placeholders.PLACEHOLDERS = ["Identifier", "StringLiteral", "Expression", "Statement", "Declaration", "BlockStatement", "ClassBody", "Pattern"];
	const PLACEHOLDERS_ALIAS = placeholders.PLACEHOLDERS_ALIAS = {
	  Declaration: ["Statement"],
	  Pattern: ["PatternLike", "LVal"]
	};
	for (const type of PLACEHOLDERS) {
	  const alias = _utils.ALIAS_KEYS[type];
	  if (alias != null && alias.length) PLACEHOLDERS_ALIAS[type] = alias;
	}
	const PLACEHOLDERS_FLIPPED_ALIAS = placeholders.PLACEHOLDERS_FLIPPED_ALIAS = {};
	Object.keys(PLACEHOLDERS_ALIAS).forEach(type => {
	  PLACEHOLDERS_ALIAS[type].forEach(alias => {
	    if (!hasOwnProperty.call(PLACEHOLDERS_FLIPPED_ALIAS, alias)) {
	      PLACEHOLDERS_FLIPPED_ALIAS[alias] = [];
	    }
	    PLACEHOLDERS_FLIPPED_ALIAS[alias].push(type);
	  });
	});

	
	return placeholders;
}

var hasRequiredMisc;

function requireMisc () {
	if (hasRequiredMisc) return misc;
	hasRequiredMisc = 1;

	var _utils = requireUtils$1();
	var _placeholders = requirePlaceholders();
	const defineType = (0, _utils.defineAliasedType)("Miscellaneous");
	{
	  defineType("Noop", {
	    visitor: []
	  });
	}
	defineType("Placeholder", {
	  visitor: [],
	  builder: ["expectedNode", "name"],
	  fields: {
	    name: {
	      validate: (0, _utils.assertNodeType)("Identifier")
	    },
	    expectedNode: {
	      validate: (0, _utils.assertOneOf)(..._placeholders.PLACEHOLDERS)
	    }
	  }
	});
	defineType("V8IntrinsicIdentifier", {
	  builder: ["name"],
	  fields: {
	    name: {
	      validate: (0, _utils.assertValueType)("string")
	    }
	  }
	});

	
	return misc;
}

var experimental = {};

var hasRequiredExperimental;

function requireExperimental () {
	if (hasRequiredExperimental) return experimental;
	hasRequiredExperimental = 1;

	var _utils = requireUtils$1();
	(0, _utils.default)("ArgumentPlaceholder", {});
	(0, _utils.default)("BindExpression", {
	  visitor: ["object", "callee"],
	  aliases: ["Expression"],
	  fields: !process.env.BABEL_TYPES_8_BREAKING ? {
	    object: {
	      validate: Object.assign(() => {}, {
	        oneOfNodeTypes: ["Expression"]
	      })
	    },
	    callee: {
	      validate: Object.assign(() => {}, {
	        oneOfNodeTypes: ["Expression"]
	      })
	    }
	  } : {
	    object: {
	      validate: (0, _utils.assertNodeType)("Expression")
	    },
	    callee: {
	      validate: (0, _utils.assertNodeType)("Expression")
	    }
	  }
	});
	(0, _utils.default)("ImportAttribute", {
	  visitor: ["key", "value"],
	  fields: {
	    key: {
	      validate: (0, _utils.assertNodeType)("Identifier", "StringLiteral")
	    },
	    value: {
	      validate: (0, _utils.assertNodeType)("StringLiteral")
	    }
	  }
	});
	(0, _utils.default)("Decorator", {
	  visitor: ["expression"],
	  fields: {
	    expression: {
	      validate: (0, _utils.assertNodeType)("Expression")
	    }
	  }
	});
	(0, _utils.default)("DoExpression", {
	  visitor: ["body"],
	  builder: ["body", "async"],
	  aliases: ["Expression"],
	  fields: {
	    body: {
	      validate: (0, _utils.assertNodeType)("BlockStatement")
	    },
	    async: {
	      validate: (0, _utils.assertValueType)("boolean"),
	      default: false
	    }
	  }
	});
	(0, _utils.default)("ExportDefaultSpecifier", {
	  visitor: ["exported"],
	  aliases: ["ModuleSpecifier"],
	  fields: {
	    exported: {
	      validate: (0, _utils.assertNodeType)("Identifier")
	    }
	  }
	});
	(0, _utils.default)("RecordExpression", {
	  visitor: ["properties"],
	  aliases: ["Expression"],
	  fields: {
	    properties: {
	      validate: (0, _utils.chain)((0, _utils.assertValueType)("array"), (0, _utils.assertEach)((0, _utils.assertNodeType)("ObjectProperty", "SpreadElement")))
	    }
	  }
	});
	(0, _utils.default)("TupleExpression", {
	  fields: {
	    elements: {
	      validate: (0, _utils.chain)((0, _utils.assertValueType)("array"), (0, _utils.assertEach)((0, _utils.assertNodeType)("Expression", "SpreadElement"))),
	      default: []
	    }
	  },
	  visitor: ["elements"],
	  aliases: ["Expression"]
	});
	(0, _utils.default)("DecimalLiteral", {
	  builder: ["value"],
	  fields: {
	    value: {
	      validate: (0, _utils.assertValueType)("string")
	    }
	  },
	  aliases: ["Expression", "Pureish", "Literal", "Immutable"]
	});
	(0, _utils.default)("ModuleExpression", {
	  visitor: ["body"],
	  fields: {
	    body: {
	      validate: (0, _utils.assertNodeType)("Program")
	    }
	  },
	  aliases: ["Expression"]
	});
	(0, _utils.default)("TopicReference", {
	  aliases: ["Expression"]
	});
	(0, _utils.default)("PipelineTopicExpression", {
	  builder: ["expression"],
	  visitor: ["expression"],
	  fields: {
	    expression: {
	      validate: (0, _utils.assertNodeType)("Expression")
	    }
	  },
	  aliases: ["Expression"]
	});
	(0, _utils.default)("PipelineBareFunction", {
	  builder: ["callee"],
	  visitor: ["callee"],
	  fields: {
	    callee: {
	      validate: (0, _utils.assertNodeType)("Expression")
	    }
	  },
	  aliases: ["Expression"]
	});
	(0, _utils.default)("PipelinePrimaryTopicReference", {
	  aliases: ["Expression"]
	});

	
	return experimental;
}

var typescript$4 = {};

var hasRequiredTypescript$1;

function requireTypescript$1 () {
	if (hasRequiredTypescript$1) return typescript$4;
	hasRequiredTypescript$1 = 1;

	var _utils = requireUtils$1();
	var _core = requireCore();
	var _is = requireIs();
	const defineType = (0, _utils.defineAliasedType)("TypeScript");
	const bool = (0, _utils.assertValueType)("boolean");
	const tSFunctionTypeAnnotationCommon = () => ({
	  returnType: {
	    validate: (0, _utils.assertNodeType)("TSTypeAnnotation", "Noop"),
	    optional: true
	  },
	  typeParameters: {
	    validate: (0, _utils.assertNodeType)("TSTypeParameterDeclaration", "Noop"),
	    optional: true
	  }
	});
	defineType("TSParameterProperty", {
	  aliases: ["LVal"],
	  visitor: ["parameter"],
	  fields: {
	    accessibility: {
	      validate: (0, _utils.assertOneOf)("public", "private", "protected"),
	      optional: true
	    },
	    readonly: {
	      validate: (0, _utils.assertValueType)("boolean"),
	      optional: true
	    },
	    parameter: {
	      validate: (0, _utils.assertNodeType)("Identifier", "AssignmentPattern")
	    },
	    override: {
	      validate: (0, _utils.assertValueType)("boolean"),
	      optional: true
	    },
	    decorators: {
	      validate: (0, _utils.chain)((0, _utils.assertValueType)("array"), (0, _utils.assertEach)((0, _utils.assertNodeType)("Decorator"))),
	      optional: true
	    }
	  }
	});
	defineType("TSDeclareFunction", {
	  aliases: ["Statement", "Declaration"],
	  visitor: ["id", "typeParameters", "params", "returnType"],
	  fields: Object.assign({}, (0, _core.functionDeclarationCommon)(), tSFunctionTypeAnnotationCommon())
	});
	defineType("TSDeclareMethod", {
	  visitor: ["decorators", "key", "typeParameters", "params", "returnType"],
	  fields: Object.assign({}, (0, _core.classMethodOrDeclareMethodCommon)(), tSFunctionTypeAnnotationCommon())
	});
	defineType("TSQualifiedName", {
	  aliases: ["TSEntityName"],
	  visitor: ["left", "right"],
	  fields: {
	    left: (0, _utils.validateType)("TSEntityName"),
	    right: (0, _utils.validateType)("Identifier")
	  }
	});
	const signatureDeclarationCommon = () => ({
	  typeParameters: (0, _utils.validateOptionalType)("TSTypeParameterDeclaration"),
	  ["parameters"]: (0, _utils.validateArrayOfType)(["ArrayPattern", "Identifier", "ObjectPattern", "RestElement"]),
	  ["typeAnnotation"]: (0, _utils.validateOptionalType)("TSTypeAnnotation")
	});
	const callConstructSignatureDeclaration = {
	  aliases: ["TSTypeElement"],
	  visitor: ["typeParameters", "parameters", "typeAnnotation"],
	  fields: signatureDeclarationCommon()
	};
	defineType("TSCallSignatureDeclaration", callConstructSignatureDeclaration);
	defineType("TSConstructSignatureDeclaration", callConstructSignatureDeclaration);
	const namedTypeElementCommon = () => ({
	  key: (0, _utils.validateType)("Expression"),
	  computed: {
	    default: false
	  },
	  optional: (0, _utils.validateOptional)(bool)
	});
	defineType("TSPropertySignature", {
	  aliases: ["TSTypeElement"],
	  visitor: ["key", "typeAnnotation"],
	  fields: Object.assign({}, namedTypeElementCommon(), {
	    readonly: (0, _utils.validateOptional)(bool),
	    typeAnnotation: (0, _utils.validateOptionalType)("TSTypeAnnotation"),
	    kind: {
	      validate: (0, _utils.assertOneOf)("get", "set")
	    }
	  })
	});
	defineType("TSMethodSignature", {
	  aliases: ["TSTypeElement"],
	  visitor: ["key", "typeParameters", "parameters", "typeAnnotation"],
	  fields: Object.assign({}, signatureDeclarationCommon(), namedTypeElementCommon(), {
	    kind: {
	      validate: (0, _utils.assertOneOf)("method", "get", "set")
	    }
	  })
	});
	defineType("TSIndexSignature", {
	  aliases: ["TSTypeElement"],
	  visitor: ["parameters", "typeAnnotation"],
	  fields: {
	    readonly: (0, _utils.validateOptional)(bool),
	    static: (0, _utils.validateOptional)(bool),
	    parameters: (0, _utils.validateArrayOfType)("Identifier"),
	    typeAnnotation: (0, _utils.validateOptionalType)("TSTypeAnnotation")
	  }
	});
	const tsKeywordTypes = ["TSAnyKeyword", "TSBooleanKeyword", "TSBigIntKeyword", "TSIntrinsicKeyword", "TSNeverKeyword", "TSNullKeyword", "TSNumberKeyword", "TSObjectKeyword", "TSStringKeyword", "TSSymbolKeyword", "TSUndefinedKeyword", "TSUnknownKeyword", "TSVoidKeyword"];
	for (const type of tsKeywordTypes) {
	  defineType(type, {
	    aliases: ["TSType", "TSBaseType"],
	    visitor: [],
	    fields: {}
	  });
	}
	defineType("TSThisType", {
	  aliases: ["TSType", "TSBaseType"],
	  visitor: [],
	  fields: {}
	});
	const fnOrCtrBase = {
	  aliases: ["TSType"],
	  visitor: ["typeParameters", "parameters", "typeAnnotation"]
	};
	defineType("TSFunctionType", Object.assign({}, fnOrCtrBase, {
	  fields: signatureDeclarationCommon()
	}));
	defineType("TSConstructorType", Object.assign({}, fnOrCtrBase, {
	  fields: Object.assign({}, signatureDeclarationCommon(), {
	    abstract: (0, _utils.validateOptional)(bool)
	  })
	}));
	defineType("TSTypeReference", {
	  aliases: ["TSType"],
	  visitor: ["typeName", "typeParameters"],
	  fields: {
	    typeName: (0, _utils.validateType)("TSEntityName"),
	    typeParameters: (0, _utils.validateOptionalType)("TSTypeParameterInstantiation")
	  }
	});
	defineType("TSTypePredicate", {
	  aliases: ["TSType"],
	  visitor: ["parameterName", "typeAnnotation"],
	  builder: ["parameterName", "typeAnnotation", "asserts"],
	  fields: {
	    parameterName: (0, _utils.validateType)(["Identifier", "TSThisType"]),
	    typeAnnotation: (0, _utils.validateOptionalType)("TSTypeAnnotation"),
	    asserts: (0, _utils.validateOptional)(bool)
	  }
	});
	defineType("TSTypeQuery", {
	  aliases: ["TSType"],
	  visitor: ["exprName", "typeParameters"],
	  fields: {
	    exprName: (0, _utils.validateType)(["TSEntityName", "TSImportType"]),
	    typeParameters: (0, _utils.validateOptionalType)("TSTypeParameterInstantiation")
	  }
	});
	defineType("TSTypeLiteral", {
	  aliases: ["TSType"],
	  visitor: ["members"],
	  fields: {
	    members: (0, _utils.validateArrayOfType)("TSTypeElement")
	  }
	});
	defineType("TSArrayType", {
	  aliases: ["TSType"],
	  visitor: ["elementType"],
	  fields: {
	    elementType: (0, _utils.validateType)("TSType")
	  }
	});
	defineType("TSTupleType", {
	  aliases: ["TSType"],
	  visitor: ["elementTypes"],
	  fields: {
	    elementTypes: (0, _utils.validateArrayOfType)(["TSType", "TSNamedTupleMember"])
	  }
	});
	defineType("TSOptionalType", {
	  aliases: ["TSType"],
	  visitor: ["typeAnnotation"],
	  fields: {
	    typeAnnotation: (0, _utils.validateType)("TSType")
	  }
	});
	defineType("TSRestType", {
	  aliases: ["TSType"],
	  visitor: ["typeAnnotation"],
	  fields: {
	    typeAnnotation: (0, _utils.validateType)("TSType")
	  }
	});
	defineType("TSNamedTupleMember", {
	  visitor: ["label", "elementType"],
	  builder: ["label", "elementType", "optional"],
	  fields: {
	    label: (0, _utils.validateType)("Identifier"),
	    optional: {
	      validate: bool,
	      default: false
	    },
	    elementType: (0, _utils.validateType)("TSType")
	  }
	});
	const unionOrIntersection = {
	  aliases: ["TSType"],
	  visitor: ["types"],
	  fields: {
	    types: (0, _utils.validateArrayOfType)("TSType")
	  }
	};
	defineType("TSUnionType", unionOrIntersection);
	defineType("TSIntersectionType", unionOrIntersection);
	defineType("TSConditionalType", {
	  aliases: ["TSType"],
	  visitor: ["checkType", "extendsType", "trueType", "falseType"],
	  fields: {
	    checkType: (0, _utils.validateType)("TSType"),
	    extendsType: (0, _utils.validateType)("TSType"),
	    trueType: (0, _utils.validateType)("TSType"),
	    falseType: (0, _utils.validateType)("TSType")
	  }
	});
	defineType("TSInferType", {
	  aliases: ["TSType"],
	  visitor: ["typeParameter"],
	  fields: {
	    typeParameter: (0, _utils.validateType)("TSTypeParameter")
	  }
	});
	defineType("TSParenthesizedType", {
	  aliases: ["TSType"],
	  visitor: ["typeAnnotation"],
	  fields: {
	    typeAnnotation: (0, _utils.validateType)("TSType")
	  }
	});
	defineType("TSTypeOperator", {
	  aliases: ["TSType"],
	  visitor: ["typeAnnotation"],
	  fields: {
	    operator: (0, _utils.validate)((0, _utils.assertValueType)("string")),
	    typeAnnotation: (0, _utils.validateType)("TSType")
	  }
	});
	defineType("TSIndexedAccessType", {
	  aliases: ["TSType"],
	  visitor: ["objectType", "indexType"],
	  fields: {
	    objectType: (0, _utils.validateType)("TSType"),
	    indexType: (0, _utils.validateType)("TSType")
	  }
	});
	defineType("TSMappedType", {
	  aliases: ["TSType"],
	  visitor: ["typeParameter", "typeAnnotation", "nameType"],
	  fields: {
	    readonly: (0, _utils.validateOptional)((0, _utils.assertOneOf)(true, false, "+", "-")),
	    typeParameter: (0, _utils.validateType)("TSTypeParameter"),
	    optional: (0, _utils.validateOptional)((0, _utils.assertOneOf)(true, false, "+", "-")),
	    typeAnnotation: (0, _utils.validateOptionalType)("TSType"),
	    nameType: (0, _utils.validateOptionalType)("TSType")
	  }
	});
	defineType("TSLiteralType", {
	  aliases: ["TSType", "TSBaseType"],
	  visitor: ["literal"],
	  fields: {
	    literal: {
	      validate: function () {
	        const unaryExpression = (0, _utils.assertNodeType)("NumericLiteral", "BigIntLiteral");
	        const unaryOperator = (0, _utils.assertOneOf)("-");
	        const literal = (0, _utils.assertNodeType)("NumericLiteral", "StringLiteral", "BooleanLiteral", "BigIntLiteral", "TemplateLiteral");
	        function validator(parent, key, node) {
	          if ((0, _is.default)("UnaryExpression", node)) {
	            unaryOperator(node, "operator", node.operator);
	            unaryExpression(node, "argument", node.argument);
	          } else {
	            literal(parent, key, node);
	          }
	        }
	        validator.oneOfNodeTypes = ["NumericLiteral", "StringLiteral", "BooleanLiteral", "BigIntLiteral", "TemplateLiteral", "UnaryExpression"];
	        return validator;
	      }()
	    }
	  }
	});
	defineType("TSExpressionWithTypeArguments", {
	  aliases: ["TSType"],
	  visitor: ["expression", "typeParameters"],
	  fields: {
	    expression: (0, _utils.validateType)("TSEntityName"),
	    typeParameters: (0, _utils.validateOptionalType)("TSTypeParameterInstantiation")
	  }
	});
	defineType("TSInterfaceDeclaration", {
	  aliases: ["Statement", "Declaration"],
	  visitor: ["id", "typeParameters", "extends", "body"],
	  fields: {
	    declare: (0, _utils.validateOptional)(bool),
	    id: (0, _utils.validateType)("Identifier"),
	    typeParameters: (0, _utils.validateOptionalType)("TSTypeParameterDeclaration"),
	    extends: (0, _utils.validateOptional)((0, _utils.arrayOfType)("TSExpressionWithTypeArguments")),
	    body: (0, _utils.validateType)("TSInterfaceBody")
	  }
	});
	defineType("TSInterfaceBody", {
	  visitor: ["body"],
	  fields: {
	    body: (0, _utils.validateArrayOfType)("TSTypeElement")
	  }
	});
	defineType("TSTypeAliasDeclaration", {
	  aliases: ["Statement", "Declaration"],
	  visitor: ["id", "typeParameters", "typeAnnotation"],
	  fields: {
	    declare: (0, _utils.validateOptional)(bool),
	    id: (0, _utils.validateType)("Identifier"),
	    typeParameters: (0, _utils.validateOptionalType)("TSTypeParameterDeclaration"),
	    typeAnnotation: (0, _utils.validateType)("TSType")
	  }
	});
	defineType("TSInstantiationExpression", {
	  aliases: ["Expression"],
	  visitor: ["expression", "typeParameters"],
	  fields: {
	    expression: (0, _utils.validateType)("Expression"),
	    typeParameters: (0, _utils.validateOptionalType)("TSTypeParameterInstantiation")
	  }
	});
	const TSTypeExpression = {
	  aliases: ["Expression", "LVal", "PatternLike"],
	  visitor: ["expression", "typeAnnotation"],
	  fields: {
	    expression: (0, _utils.validateType)("Expression"),
	    typeAnnotation: (0, _utils.validateType)("TSType")
	  }
	};
	defineType("TSAsExpression", TSTypeExpression);
	defineType("TSSatisfiesExpression", TSTypeExpression);
	defineType("TSTypeAssertion", {
	  aliases: ["Expression", "LVal", "PatternLike"],
	  visitor: ["typeAnnotation", "expression"],
	  fields: {
	    typeAnnotation: (0, _utils.validateType)("TSType"),
	    expression: (0, _utils.validateType)("Expression")
	  }
	});
	defineType("TSEnumDeclaration", {
	  aliases: ["Statement", "Declaration"],
	  visitor: ["id", "members"],
	  fields: {
	    declare: (0, _utils.validateOptional)(bool),
	    const: (0, _utils.validateOptional)(bool),
	    id: (0, _utils.validateType)("Identifier"),
	    members: (0, _utils.validateArrayOfType)("TSEnumMember"),
	    initializer: (0, _utils.validateOptionalType)("Expression")
	  }
	});
	defineType("TSEnumMember", {
	  visitor: ["id", "initializer"],
	  fields: {
	    id: (0, _utils.validateType)(["Identifier", "StringLiteral"]),
	    initializer: (0, _utils.validateOptionalType)("Expression")
	  }
	});
	defineType("TSModuleDeclaration", {
	  aliases: ["Statement", "Declaration"],
	  visitor: ["id", "body"],
	  fields: {
	    declare: (0, _utils.validateOptional)(bool),
	    global: (0, _utils.validateOptional)(bool),
	    id: (0, _utils.validateType)(["Identifier", "StringLiteral"]),
	    body: (0, _utils.validateType)(["TSModuleBlock", "TSModuleDeclaration"])
	  }
	});
	defineType("TSModuleBlock", {
	  aliases: ["Scopable", "Block", "BlockParent", "FunctionParent"],
	  visitor: ["body"],
	  fields: {
	    body: (0, _utils.validateArrayOfType)("Statement")
	  }
	});
	defineType("TSImportType", {
	  aliases: ["TSType"],
	  visitor: ["argument", "qualifier", "typeParameters"],
	  fields: {
	    argument: (0, _utils.validateType)("StringLiteral"),
	    qualifier: (0, _utils.validateOptionalType)("TSEntityName"),
	    typeParameters: (0, _utils.validateOptionalType)("TSTypeParameterInstantiation"),
	    options: {
	      validate: (0, _utils.assertNodeType)("Expression"),
	      optional: true
	    }
	  }
	});
	defineType("TSImportEqualsDeclaration", {
	  aliases: ["Statement"],
	  visitor: ["id", "moduleReference"],
	  fields: {
	    isExport: (0, _utils.validate)(bool),
	    id: (0, _utils.validateType)("Identifier"),
	    moduleReference: (0, _utils.validateType)(["TSEntityName", "TSExternalModuleReference"]),
	    importKind: {
	      validate: (0, _utils.assertOneOf)("type", "value"),
	      optional: true
	    }
	  }
	});
	defineType("TSExternalModuleReference", {
	  visitor: ["expression"],
	  fields: {
	    expression: (0, _utils.validateType)("StringLiteral")
	  }
	});
	defineType("TSNonNullExpression", {
	  aliases: ["Expression", "LVal", "PatternLike"],
	  visitor: ["expression"],
	  fields: {
	    expression: (0, _utils.validateType)("Expression")
	  }
	});
	defineType("TSExportAssignment", {
	  aliases: ["Statement"],
	  visitor: ["expression"],
	  fields: {
	    expression: (0, _utils.validateType)("Expression")
	  }
	});
	defineType("TSNamespaceExportDeclaration", {
	  aliases: ["Statement"],
	  visitor: ["id"],
	  fields: {
	    id: (0, _utils.validateType)("Identifier")
	  }
	});
	defineType("TSTypeAnnotation", {
	  visitor: ["typeAnnotation"],
	  fields: {
	    typeAnnotation: {
	      validate: (0, _utils.assertNodeType)("TSType")
	    }
	  }
	});
	defineType("TSTypeParameterInstantiation", {
	  visitor: ["params"],
	  fields: {
	    params: {
	      validate: (0, _utils.chain)((0, _utils.assertValueType)("array"), (0, _utils.assertEach)((0, _utils.assertNodeType)("TSType")))
	    }
	  }
	});
	defineType("TSTypeParameterDeclaration", {
	  visitor: ["params"],
	  fields: {
	    params: {
	      validate: (0, _utils.chain)((0, _utils.assertValueType)("array"), (0, _utils.assertEach)((0, _utils.assertNodeType)("TSTypeParameter")))
	    }
	  }
	});
	defineType("TSTypeParameter", {
	  builder: ["constraint", "default", "name"],
	  visitor: ["constraint", "default"],
	  fields: {
	    name: {
	      validate: (0, _utils.assertValueType)("string")
	    },
	    in: {
	      validate: (0, _utils.assertValueType)("boolean"),
	      optional: true
	    },
	    out: {
	      validate: (0, _utils.assertValueType)("boolean"),
	      optional: true
	    },
	    const: {
	      validate: (0, _utils.assertValueType)("boolean"),
	      optional: true
	    },
	    constraint: {
	      validate: (0, _utils.assertNodeType)("TSType"),
	      optional: true
	    },
	    default: {
	      validate: (0, _utils.assertNodeType)("TSType"),
	      optional: true
	    }
	  }
	});

	
	return typescript$4;
}

var deprecatedAliases = {};

var hasRequiredDeprecatedAliases;

function requireDeprecatedAliases () {
	if (hasRequiredDeprecatedAliases) return deprecatedAliases;
	hasRequiredDeprecatedAliases = 1;

	Object.defineProperty(deprecatedAliases, "__esModule", {
	  value: true
	});
	deprecatedAliases.DEPRECATED_ALIASES = void 0;
	deprecatedAliases.DEPRECATED_ALIASES = {
	  ModuleDeclaration: "ImportOrExportDeclaration"
	};

	
	return deprecatedAliases;
}

var hasRequiredDefinitions;

function requireDefinitions () {
	if (hasRequiredDefinitions) return definitions;
	hasRequiredDefinitions = 1;
	(function (exports) {

		Object.defineProperty(exports, "__esModule", {
		  value: true
		});
		Object.defineProperty(exports, "ALIAS_KEYS", {
		  enumerable: true,
		  get: function () {
		    return _utils.ALIAS_KEYS;
		  }
		});
		Object.defineProperty(exports, "BUILDER_KEYS", {
		  enumerable: true,
		  get: function () {
		    return _utils.BUILDER_KEYS;
		  }
		});
		Object.defineProperty(exports, "DEPRECATED_ALIASES", {
		  enumerable: true,
		  get: function () {
		    return _deprecatedAliases.DEPRECATED_ALIASES;
		  }
		});
		Object.defineProperty(exports, "DEPRECATED_KEYS", {
		  enumerable: true,
		  get: function () {
		    return _utils.DEPRECATED_KEYS;
		  }
		});
		Object.defineProperty(exports, "FLIPPED_ALIAS_KEYS", {
		  enumerable: true,
		  get: function () {
		    return _utils.FLIPPED_ALIAS_KEYS;
		  }
		});
		Object.defineProperty(exports, "NODE_FIELDS", {
		  enumerable: true,
		  get: function () {
		    return _utils.NODE_FIELDS;
		  }
		});
		Object.defineProperty(exports, "NODE_PARENT_VALIDATIONS", {
		  enumerable: true,
		  get: function () {
		    return _utils.NODE_PARENT_VALIDATIONS;
		  }
		});
		Object.defineProperty(exports, "PLACEHOLDERS", {
		  enumerable: true,
		  get: function () {
		    return _placeholders.PLACEHOLDERS;
		  }
		});
		Object.defineProperty(exports, "PLACEHOLDERS_ALIAS", {
		  enumerable: true,
		  get: function () {
		    return _placeholders.PLACEHOLDERS_ALIAS;
		  }
		});
		Object.defineProperty(exports, "PLACEHOLDERS_FLIPPED_ALIAS", {
		  enumerable: true,
		  get: function () {
		    return _placeholders.PLACEHOLDERS_FLIPPED_ALIAS;
		  }
		});
		exports.TYPES = void 0;
		Object.defineProperty(exports, "VISITOR_KEYS", {
		  enumerable: true,
		  get: function () {
		    return _utils.VISITOR_KEYS;
		  }
		});
		var _toFastProperties = requireToFastProperties();
		requireCore();
		requireFlow$1();
		requireJsx$1();
		requireMisc();
		requireExperimental();
		requireTypescript$1();
		var _utils = requireUtils$1();
		var _placeholders = requirePlaceholders();
		var _deprecatedAliases = requireDeprecatedAliases();
		Object.keys(_deprecatedAliases.DEPRECATED_ALIASES).forEach(deprecatedAlias => {
		  _utils.FLIPPED_ALIAS_KEYS[deprecatedAlias] = _utils.FLIPPED_ALIAS_KEYS[_deprecatedAliases.DEPRECATED_ALIASES[deprecatedAlias]];
		});
		_toFastProperties(_utils.VISITOR_KEYS);
		_toFastProperties(_utils.ALIAS_KEYS);
		_toFastProperties(_utils.FLIPPED_ALIAS_KEYS);
		_toFastProperties(_utils.NODE_FIELDS);
		_toFastProperties(_utils.BUILDER_KEYS);
		_toFastProperties(_utils.DEPRECATED_KEYS);
		_toFastProperties(_placeholders.PLACEHOLDERS_ALIAS);
		_toFastProperties(_placeholders.PLACEHOLDERS_FLIPPED_ALIAS);
		exports.TYPES = [].concat(Object.keys(_utils.VISITOR_KEYS), Object.keys(_utils.FLIPPED_ALIAS_KEYS), Object.keys(_utils.DEPRECATED_KEYS));

		
	} (definitions));
	return definitions;
}

var hasRequiredValidate;

function requireValidate () {
	if (hasRequiredValidate) return validate;
	hasRequiredValidate = 1;

	Object.defineProperty(validate, "__esModule", {
	  value: true
	});
	validate.default = validate$1;
	validate.validateChild = validateChild;
	validate.validateField = validateField;
	var _index = requireDefinitions();
	function validate$1(node, key, val) {
	  if (!node) return;
	  const fields = _index.NODE_FIELDS[node.type];
	  if (!fields) return;
	  const field = fields[key];
	  validateField(node, key, val, field);
	  validateChild(node, key, val);
	}
	function validateField(node, key, val, field) {
	  if (!(field != null && field.validate)) return;
	  if (field.optional && val == null) return;
	  field.validate(node, key, val);
	}
	function validateChild(node, key, val) {
	  if (val == null) return;
	  const validate = _index.NODE_PARENT_VALIDATIONS[val.type];
	  if (!validate) return;
	  validate(node, key, val);
	}

	
	return validate;
}

var hasRequiredValidateNode;

function requireValidateNode () {
	if (hasRequiredValidateNode) return validateNode;
	hasRequiredValidateNode = 1;

	Object.defineProperty(validateNode, "__esModule", {
	  value: true
	});
	validateNode.default = validateNode$1;
	var _validate = requireValidate();
	var _index = requireLib$h();
	function validateNode$1(node) {
	  const keys = _index.BUILDER_KEYS[node.type];
	  for (const key of keys) {
	    (0, _validate.default)(node, key, node[key]);
	  }
	  return node;
	}

	
	return validateNode;
}

var hasRequiredGenerated$2;

function requireGenerated$2 () {
	if (hasRequiredGenerated$2) return generated$2;
	hasRequiredGenerated$2 = 1;

	Object.defineProperty(generated$2, "__esModule", {
	  value: true
	});
	generated$2.anyTypeAnnotation = anyTypeAnnotation;
	generated$2.argumentPlaceholder = argumentPlaceholder;
	generated$2.arrayExpression = arrayExpression;
	generated$2.arrayPattern = arrayPattern;
	generated$2.arrayTypeAnnotation = arrayTypeAnnotation;
	generated$2.arrowFunctionExpression = arrowFunctionExpression;
	generated$2.assignmentExpression = assignmentExpression;
	generated$2.assignmentPattern = assignmentPattern;
	generated$2.awaitExpression = awaitExpression;
	generated$2.bigIntLiteral = bigIntLiteral;
	generated$2.binaryExpression = binaryExpression;
	generated$2.bindExpression = bindExpression;
	generated$2.blockStatement = blockStatement;
	generated$2.booleanLiteral = booleanLiteral;
	generated$2.booleanLiteralTypeAnnotation = booleanLiteralTypeAnnotation;
	generated$2.booleanTypeAnnotation = booleanTypeAnnotation;
	generated$2.breakStatement = breakStatement;
	generated$2.callExpression = callExpression;
	generated$2.catchClause = catchClause;
	generated$2.classAccessorProperty = classAccessorProperty;
	generated$2.classBody = classBody;
	generated$2.classDeclaration = classDeclaration;
	generated$2.classExpression = classExpression;
	generated$2.classImplements = classImplements;
	generated$2.classMethod = classMethod;
	generated$2.classPrivateMethod = classPrivateMethod;
	generated$2.classPrivateProperty = classPrivateProperty;
	generated$2.classProperty = classProperty;
	generated$2.conditionalExpression = conditionalExpression;
	generated$2.continueStatement = continueStatement;
	generated$2.debuggerStatement = debuggerStatement;
	generated$2.decimalLiteral = decimalLiteral;
	generated$2.declareClass = declareClass;
	generated$2.declareExportAllDeclaration = declareExportAllDeclaration;
	generated$2.declareExportDeclaration = declareExportDeclaration;
	generated$2.declareFunction = declareFunction;
	generated$2.declareInterface = declareInterface;
	generated$2.declareModule = declareModule;
	generated$2.declareModuleExports = declareModuleExports;
	generated$2.declareOpaqueType = declareOpaqueType;
	generated$2.declareTypeAlias = declareTypeAlias;
	generated$2.declareVariable = declareVariable;
	generated$2.declaredPredicate = declaredPredicate;
	generated$2.decorator = decorator;
	generated$2.directive = directive;
	generated$2.directiveLiteral = directiveLiteral;
	generated$2.doExpression = doExpression;
	generated$2.doWhileStatement = doWhileStatement;
	generated$2.emptyStatement = emptyStatement;
	generated$2.emptyTypeAnnotation = emptyTypeAnnotation;
	generated$2.enumBooleanBody = enumBooleanBody;
	generated$2.enumBooleanMember = enumBooleanMember;
	generated$2.enumDeclaration = enumDeclaration;
	generated$2.enumDefaultedMember = enumDefaultedMember;
	generated$2.enumNumberBody = enumNumberBody;
	generated$2.enumNumberMember = enumNumberMember;
	generated$2.enumStringBody = enumStringBody;
	generated$2.enumStringMember = enumStringMember;
	generated$2.enumSymbolBody = enumSymbolBody;
	generated$2.existsTypeAnnotation = existsTypeAnnotation;
	generated$2.exportAllDeclaration = exportAllDeclaration;
	generated$2.exportDefaultDeclaration = exportDefaultDeclaration;
	generated$2.exportDefaultSpecifier = exportDefaultSpecifier;
	generated$2.exportNamedDeclaration = exportNamedDeclaration;
	generated$2.exportNamespaceSpecifier = exportNamespaceSpecifier;
	generated$2.exportSpecifier = exportSpecifier;
	generated$2.expressionStatement = expressionStatement;
	generated$2.file = file;
	generated$2.forInStatement = forInStatement;
	generated$2.forOfStatement = forOfStatement;
	generated$2.forStatement = forStatement;
	generated$2.functionDeclaration = functionDeclaration;
	generated$2.functionExpression = functionExpression;
	generated$2.functionTypeAnnotation = functionTypeAnnotation;
	generated$2.functionTypeParam = functionTypeParam;
	generated$2.genericTypeAnnotation = genericTypeAnnotation;
	generated$2.identifier = identifier;
	generated$2.ifStatement = ifStatement;
	generated$2.import = _import;
	generated$2.importAttribute = importAttribute;
	generated$2.importDeclaration = importDeclaration;
	generated$2.importDefaultSpecifier = importDefaultSpecifier;
	generated$2.importExpression = importExpression;
	generated$2.importNamespaceSpecifier = importNamespaceSpecifier;
	generated$2.importSpecifier = importSpecifier;
	generated$2.indexedAccessType = indexedAccessType;
	generated$2.inferredPredicate = inferredPredicate;
	generated$2.interfaceDeclaration = interfaceDeclaration;
	generated$2.interfaceExtends = interfaceExtends;
	generated$2.interfaceTypeAnnotation = interfaceTypeAnnotation;
	generated$2.interpreterDirective = interpreterDirective;
	generated$2.intersectionTypeAnnotation = intersectionTypeAnnotation;
	generated$2.jSXAttribute = generated$2.jsxAttribute = jsxAttribute;
	generated$2.jSXClosingElement = generated$2.jsxClosingElement = jsxClosingElement;
	generated$2.jSXClosingFragment = generated$2.jsxClosingFragment = jsxClosingFragment;
	generated$2.jSXElement = generated$2.jsxElement = jsxElement;
	generated$2.jSXEmptyExpression = generated$2.jsxEmptyExpression = jsxEmptyExpression;
	generated$2.jSXExpressionContainer = generated$2.jsxExpressionContainer = jsxExpressionContainer;
	generated$2.jSXFragment = generated$2.jsxFragment = jsxFragment;
	generated$2.jSXIdentifier = generated$2.jsxIdentifier = jsxIdentifier;
	generated$2.jSXMemberExpression = generated$2.jsxMemberExpression = jsxMemberExpression;
	generated$2.jSXNamespacedName = generated$2.jsxNamespacedName = jsxNamespacedName;
	generated$2.jSXOpeningElement = generated$2.jsxOpeningElement = jsxOpeningElement;
	generated$2.jSXOpeningFragment = generated$2.jsxOpeningFragment = jsxOpeningFragment;
	generated$2.jSXSpreadAttribute = generated$2.jsxSpreadAttribute = jsxSpreadAttribute;
	generated$2.jSXSpreadChild = generated$2.jsxSpreadChild = jsxSpreadChild;
	generated$2.jSXText = generated$2.jsxText = jsxText;
	generated$2.labeledStatement = labeledStatement;
	generated$2.logicalExpression = logicalExpression;
	generated$2.memberExpression = memberExpression;
	generated$2.metaProperty = metaProperty;
	generated$2.mixedTypeAnnotation = mixedTypeAnnotation;
	generated$2.moduleExpression = moduleExpression;
	generated$2.newExpression = newExpression;
	generated$2.noop = noop;
	generated$2.nullLiteral = nullLiteral;
	generated$2.nullLiteralTypeAnnotation = nullLiteralTypeAnnotation;
	generated$2.nullableTypeAnnotation = nullableTypeAnnotation;
	generated$2.numberLiteral = NumberLiteral;
	generated$2.numberLiteralTypeAnnotation = numberLiteralTypeAnnotation;
	generated$2.numberTypeAnnotation = numberTypeAnnotation;
	generated$2.numericLiteral = numericLiteral;
	generated$2.objectExpression = objectExpression;
	generated$2.objectMethod = objectMethod;
	generated$2.objectPattern = objectPattern;
	generated$2.objectProperty = objectProperty;
	generated$2.objectTypeAnnotation = objectTypeAnnotation;
	generated$2.objectTypeCallProperty = objectTypeCallProperty;
	generated$2.objectTypeIndexer = objectTypeIndexer;
	generated$2.objectTypeInternalSlot = objectTypeInternalSlot;
	generated$2.objectTypeProperty = objectTypeProperty;
	generated$2.objectTypeSpreadProperty = objectTypeSpreadProperty;
	generated$2.opaqueType = opaqueType;
	generated$2.optionalCallExpression = optionalCallExpression;
	generated$2.optionalIndexedAccessType = optionalIndexedAccessType;
	generated$2.optionalMemberExpression = optionalMemberExpression;
	generated$2.parenthesizedExpression = parenthesizedExpression;
	generated$2.pipelineBareFunction = pipelineBareFunction;
	generated$2.pipelinePrimaryTopicReference = pipelinePrimaryTopicReference;
	generated$2.pipelineTopicExpression = pipelineTopicExpression;
	generated$2.placeholder = placeholder;
	generated$2.privateName = privateName;
	generated$2.program = program;
	generated$2.qualifiedTypeIdentifier = qualifiedTypeIdentifier;
	generated$2.recordExpression = recordExpression;
	generated$2.regExpLiteral = regExpLiteral;
	generated$2.regexLiteral = RegexLiteral;
	generated$2.restElement = restElement;
	generated$2.restProperty = RestProperty;
	generated$2.returnStatement = returnStatement;
	generated$2.sequenceExpression = sequenceExpression;
	generated$2.spreadElement = spreadElement;
	generated$2.spreadProperty = SpreadProperty;
	generated$2.staticBlock = staticBlock;
	generated$2.stringLiteral = stringLiteral;
	generated$2.stringLiteralTypeAnnotation = stringLiteralTypeAnnotation;
	generated$2.stringTypeAnnotation = stringTypeAnnotation;
	generated$2.super = _super;
	generated$2.switchCase = switchCase;
	generated$2.switchStatement = switchStatement;
	generated$2.symbolTypeAnnotation = symbolTypeAnnotation;
	generated$2.taggedTemplateExpression = taggedTemplateExpression;
	generated$2.templateElement = templateElement;
	generated$2.templateLiteral = templateLiteral;
	generated$2.thisExpression = thisExpression;
	generated$2.thisTypeAnnotation = thisTypeAnnotation;
	generated$2.throwStatement = throwStatement;
	generated$2.topicReference = topicReference;
	generated$2.tryStatement = tryStatement;
	generated$2.tSAnyKeyword = generated$2.tsAnyKeyword = tsAnyKeyword;
	generated$2.tSArrayType = generated$2.tsArrayType = tsArrayType;
	generated$2.tSAsExpression = generated$2.tsAsExpression = tsAsExpression;
	generated$2.tSBigIntKeyword = generated$2.tsBigIntKeyword = tsBigIntKeyword;
	generated$2.tSBooleanKeyword = generated$2.tsBooleanKeyword = tsBooleanKeyword;
	generated$2.tSCallSignatureDeclaration = generated$2.tsCallSignatureDeclaration = tsCallSignatureDeclaration;
	generated$2.tSConditionalType = generated$2.tsConditionalType = tsConditionalType;
	generated$2.tSConstructSignatureDeclaration = generated$2.tsConstructSignatureDeclaration = tsConstructSignatureDeclaration;
	generated$2.tSConstructorType = generated$2.tsConstructorType = tsConstructorType;
	generated$2.tSDeclareFunction = generated$2.tsDeclareFunction = tsDeclareFunction;
	generated$2.tSDeclareMethod = generated$2.tsDeclareMethod = tsDeclareMethod;
	generated$2.tSEnumDeclaration = generated$2.tsEnumDeclaration = tsEnumDeclaration;
	generated$2.tSEnumMember = generated$2.tsEnumMember = tsEnumMember;
	generated$2.tSExportAssignment = generated$2.tsExportAssignment = tsExportAssignment;
	generated$2.tSExpressionWithTypeArguments = generated$2.tsExpressionWithTypeArguments = tsExpressionWithTypeArguments;
	generated$2.tSExternalModuleReference = generated$2.tsExternalModuleReference = tsExternalModuleReference;
	generated$2.tSFunctionType = generated$2.tsFunctionType = tsFunctionType;
	generated$2.tSImportEqualsDeclaration = generated$2.tsImportEqualsDeclaration = tsImportEqualsDeclaration;
	generated$2.tSImportType = generated$2.tsImportType = tsImportType;
	generated$2.tSIndexSignature = generated$2.tsIndexSignature = tsIndexSignature;
	generated$2.tSIndexedAccessType = generated$2.tsIndexedAccessType = tsIndexedAccessType;
	generated$2.tSInferType = generated$2.tsInferType = tsInferType;
	generated$2.tSInstantiationExpression = generated$2.tsInstantiationExpression = tsInstantiationExpression;
	generated$2.tSInterfaceBody = generated$2.tsInterfaceBody = tsInterfaceBody;
	generated$2.tSInterfaceDeclaration = generated$2.tsInterfaceDeclaration = tsInterfaceDeclaration;
	generated$2.tSIntersectionType = generated$2.tsIntersectionType = tsIntersectionType;
	generated$2.tSIntrinsicKeyword = generated$2.tsIntrinsicKeyword = tsIntrinsicKeyword;
	generated$2.tSLiteralType = generated$2.tsLiteralType = tsLiteralType;
	generated$2.tSMappedType = generated$2.tsMappedType = tsMappedType;
	generated$2.tSMethodSignature = generated$2.tsMethodSignature = tsMethodSignature;
	generated$2.tSModuleBlock = generated$2.tsModuleBlock = tsModuleBlock;
	generated$2.tSModuleDeclaration = generated$2.tsModuleDeclaration = tsModuleDeclaration;
	generated$2.tSNamedTupleMember = generated$2.tsNamedTupleMember = tsNamedTupleMember;
	generated$2.tSNamespaceExportDeclaration = generated$2.tsNamespaceExportDeclaration = tsNamespaceExportDeclaration;
	generated$2.tSNeverKeyword = generated$2.tsNeverKeyword = tsNeverKeyword;
	generated$2.tSNonNullExpression = generated$2.tsNonNullExpression = tsNonNullExpression;
	generated$2.tSNullKeyword = generated$2.tsNullKeyword = tsNullKeyword;
	generated$2.tSNumberKeyword = generated$2.tsNumberKeyword = tsNumberKeyword;
	generated$2.tSObjectKeyword = generated$2.tsObjectKeyword = tsObjectKeyword;
	generated$2.tSOptionalType = generated$2.tsOptionalType = tsOptionalType;
	generated$2.tSParameterProperty = generated$2.tsParameterProperty = tsParameterProperty;
	generated$2.tSParenthesizedType = generated$2.tsParenthesizedType = tsParenthesizedType;
	generated$2.tSPropertySignature = generated$2.tsPropertySignature = tsPropertySignature;
	generated$2.tSQualifiedName = generated$2.tsQualifiedName = tsQualifiedName;
	generated$2.tSRestType = generated$2.tsRestType = tsRestType;
	generated$2.tSSatisfiesExpression = generated$2.tsSatisfiesExpression = tsSatisfiesExpression;
	generated$2.tSStringKeyword = generated$2.tsStringKeyword = tsStringKeyword;
	generated$2.tSSymbolKeyword = generated$2.tsSymbolKeyword = tsSymbolKeyword;
	generated$2.tSThisType = generated$2.tsThisType = tsThisType;
	generated$2.tSTupleType = generated$2.tsTupleType = tsTupleType;
	generated$2.tSTypeAliasDeclaration = generated$2.tsTypeAliasDeclaration = tsTypeAliasDeclaration;
	generated$2.tSTypeAnnotation = generated$2.tsTypeAnnotation = tsTypeAnnotation;
	generated$2.tSTypeAssertion = generated$2.tsTypeAssertion = tsTypeAssertion;
	generated$2.tSTypeLiteral = generated$2.tsTypeLiteral = tsTypeLiteral;
	generated$2.tSTypeOperator = generated$2.tsTypeOperator = tsTypeOperator;
	generated$2.tSTypeParameter = generated$2.tsTypeParameter = tsTypeParameter;
	generated$2.tSTypeParameterDeclaration = generated$2.tsTypeParameterDeclaration = tsTypeParameterDeclaration;
	generated$2.tSTypeParameterInstantiation = generated$2.tsTypeParameterInstantiation = tsTypeParameterInstantiation;
	generated$2.tSTypePredicate = generated$2.tsTypePredicate = tsTypePredicate;
	generated$2.tSTypeQuery = generated$2.tsTypeQuery = tsTypeQuery;
	generated$2.tSTypeReference = generated$2.tsTypeReference = tsTypeReference;
	generated$2.tSUndefinedKeyword = generated$2.tsUndefinedKeyword = tsUndefinedKeyword;
	generated$2.tSUnionType = generated$2.tsUnionType = tsUnionType;
	generated$2.tSUnknownKeyword = generated$2.tsUnknownKeyword = tsUnknownKeyword;
	generated$2.tSVoidKeyword = generated$2.tsVoidKeyword = tsVoidKeyword;
	generated$2.tupleExpression = tupleExpression;
	generated$2.tupleTypeAnnotation = tupleTypeAnnotation;
	generated$2.typeAlias = typeAlias;
	generated$2.typeAnnotation = typeAnnotation;
	generated$2.typeCastExpression = typeCastExpression;
	generated$2.typeParameter = typeParameter;
	generated$2.typeParameterDeclaration = typeParameterDeclaration;
	generated$2.typeParameterInstantiation = typeParameterInstantiation;
	generated$2.typeofTypeAnnotation = typeofTypeAnnotation;
	generated$2.unaryExpression = unaryExpression;
	generated$2.unionTypeAnnotation = unionTypeAnnotation;
	generated$2.updateExpression = updateExpression;
	generated$2.v8IntrinsicIdentifier = v8IntrinsicIdentifier;
	generated$2.variableDeclaration = variableDeclaration;
	generated$2.variableDeclarator = variableDeclarator;
	generated$2.variance = variance;
	generated$2.voidTypeAnnotation = voidTypeAnnotation;
	generated$2.whileStatement = whileStatement;
	generated$2.withStatement = withStatement;
	generated$2.yieldExpression = yieldExpression;
	var _validateNode = requireValidateNode();
	var _deprecationWarning = requireDeprecationWarning();
	function arrayExpression(elements = []) {
	  return (0, _validateNode.default)({
	    type: "ArrayExpression",
	    elements
	  });
	}
	function assignmentExpression(operator, left, right) {
	  return (0, _validateNode.default)({
	    type: "AssignmentExpression",
	    operator,
	    left,
	    right
	  });
	}
	function binaryExpression(operator, left, right) {
	  return (0, _validateNode.default)({
	    type: "BinaryExpression",
	    operator,
	    left,
	    right
	  });
	}
	function interpreterDirective(value) {
	  return (0, _validateNode.default)({
	    type: "InterpreterDirective",
	    value
	  });
	}
	function directive(value) {
	  return (0, _validateNode.default)({
	    type: "Directive",
	    value
	  });
	}
	function directiveLiteral(value) {
	  return (0, _validateNode.default)({
	    type: "DirectiveLiteral",
	    value
	  });
	}
	function blockStatement(body, directives = []) {
	  return (0, _validateNode.default)({
	    type: "BlockStatement",
	    body,
	    directives
	  });
	}
	function breakStatement(label = null) {
	  return (0, _validateNode.default)({
	    type: "BreakStatement",
	    label
	  });
	}
	function callExpression(callee, _arguments) {
	  return (0, _validateNode.default)({
	    type: "CallExpression",
	    callee,
	    arguments: _arguments
	  });
	}
	function catchClause(param = null, body) {
	  return (0, _validateNode.default)({
	    type: "CatchClause",
	    param,
	    body
	  });
	}
	function conditionalExpression(test, consequent, alternate) {
	  return (0, _validateNode.default)({
	    type: "ConditionalExpression",
	    test,
	    consequent,
	    alternate
	  });
	}
	function continueStatement(label = null) {
	  return (0, _validateNode.default)({
	    type: "ContinueStatement",
	    label
	  });
	}
	function debuggerStatement() {
	  return {
	    type: "DebuggerStatement"
	  };
	}
	function doWhileStatement(test, body) {
	  return (0, _validateNode.default)({
	    type: "DoWhileStatement",
	    test,
	    body
	  });
	}
	function emptyStatement() {
	  return {
	    type: "EmptyStatement"
	  };
	}
	function expressionStatement(expression) {
	  return (0, _validateNode.default)({
	    type: "ExpressionStatement",
	    expression
	  });
	}
	function file(program, comments = null, tokens = null) {
	  return (0, _validateNode.default)({
	    type: "File",
	    program,
	    comments,
	    tokens
	  });
	}
	function forInStatement(left, right, body) {
	  return (0, _validateNode.default)({
	    type: "ForInStatement",
	    left,
	    right,
	    body
	  });
	}
	function forStatement(init = null, test = null, update = null, body) {
	  return (0, _validateNode.default)({
	    type: "ForStatement",
	    init,
	    test,
	    update,
	    body
	  });
	}
	function functionDeclaration(id = null, params, body, generator = false, async = false) {
	  return (0, _validateNode.default)({
	    type: "FunctionDeclaration",
	    id,
	    params,
	    body,
	    generator,
	    async
	  });
	}
	function functionExpression(id = null, params, body, generator = false, async = false) {
	  return (0, _validateNode.default)({
	    type: "FunctionExpression",
	    id,
	    params,
	    body,
	    generator,
	    async
	  });
	}
	function identifier(name) {
	  return (0, _validateNode.default)({
	    type: "Identifier",
	    name
	  });
	}
	function ifStatement(test, consequent, alternate = null) {
	  return (0, _validateNode.default)({
	    type: "IfStatement",
	    test,
	    consequent,
	    alternate
	  });
	}
	function labeledStatement(label, body) {
	  return (0, _validateNode.default)({
	    type: "LabeledStatement",
	    label,
	    body
	  });
	}
	function stringLiteral(value) {
	  return (0, _validateNode.default)({
	    type: "StringLiteral",
	    value
	  });
	}
	function numericLiteral(value) {
	  return (0, _validateNode.default)({
	    type: "NumericLiteral",
	    value
	  });
	}
	function nullLiteral() {
	  return {
	    type: "NullLiteral"
	  };
	}
	function booleanLiteral(value) {
	  return (0, _validateNode.default)({
	    type: "BooleanLiteral",
	    value
	  });
	}
	function regExpLiteral(pattern, flags = "") {
	  return (0, _validateNode.default)({
	    type: "RegExpLiteral",
	    pattern,
	    flags
	  });
	}
	function logicalExpression(operator, left, right) {
	  return (0, _validateNode.default)({
	    type: "LogicalExpression",
	    operator,
	    left,
	    right
	  });
	}
	function memberExpression(object, property, computed = false, optional = null) {
	  return (0, _validateNode.default)({
	    type: "MemberExpression",
	    object,
	    property,
	    computed,
	    optional
	  });
	}
	function newExpression(callee, _arguments) {
	  return (0, _validateNode.default)({
	    type: "NewExpression",
	    callee,
	    arguments: _arguments
	  });
	}
	function program(body, directives = [], sourceType = "script", interpreter = null) {
	  return (0, _validateNode.default)({
	    type: "Program",
	    body,
	    directives,
	    sourceType,
	    interpreter
	  });
	}
	function objectExpression(properties) {
	  return (0, _validateNode.default)({
	    type: "ObjectExpression",
	    properties
	  });
	}
	function objectMethod(kind = "method", key, params, body, computed = false, generator = false, async = false) {
	  return (0, _validateNode.default)({
	    type: "ObjectMethod",
	    kind,
	    key,
	    params,
	    body,
	    computed,
	    generator,
	    async
	  });
	}
	function objectProperty(key, value, computed = false, shorthand = false, decorators = null) {
	  return (0, _validateNode.default)({
	    type: "ObjectProperty",
	    key,
	    value,
	    computed,
	    shorthand,
	    decorators
	  });
	}
	function restElement(argument) {
	  return (0, _validateNode.default)({
	    type: "RestElement",
	    argument
	  });
	}
	function returnStatement(argument = null) {
	  return (0, _validateNode.default)({
	    type: "ReturnStatement",
	    argument
	  });
	}
	function sequenceExpression(expressions) {
	  return (0, _validateNode.default)({
	    type: "SequenceExpression",
	    expressions
	  });
	}
	function parenthesizedExpression(expression) {
	  return (0, _validateNode.default)({
	    type: "ParenthesizedExpression",
	    expression
	  });
	}
	function switchCase(test = null, consequent) {
	  return (0, _validateNode.default)({
	    type: "SwitchCase",
	    test,
	    consequent
	  });
	}
	function switchStatement(discriminant, cases) {
	  return (0, _validateNode.default)({
	    type: "SwitchStatement",
	    discriminant,
	    cases
	  });
	}
	function thisExpression() {
	  return {
	    type: "ThisExpression"
	  };
	}
	function throwStatement(argument) {
	  return (0, _validateNode.default)({
	    type: "ThrowStatement",
	    argument
	  });
	}
	function tryStatement(block, handler = null, finalizer = null) {
	  return (0, _validateNode.default)({
	    type: "TryStatement",
	    block,
	    handler,
	    finalizer
	  });
	}
	function unaryExpression(operator, argument, prefix = true) {
	  return (0, _validateNode.default)({
	    type: "UnaryExpression",
	    operator,
	    argument,
	    prefix
	  });
	}
	function updateExpression(operator, argument, prefix = false) {
	  return (0, _validateNode.default)({
	    type: "UpdateExpression",
	    operator,
	    argument,
	    prefix
	  });
	}
	function variableDeclaration(kind, declarations) {
	  return (0, _validateNode.default)({
	    type: "VariableDeclaration",
	    kind,
	    declarations
	  });
	}
	function variableDeclarator(id, init = null) {
	  return (0, _validateNode.default)({
	    type: "VariableDeclarator",
	    id,
	    init
	  });
	}
	function whileStatement(test, body) {
	  return (0, _validateNode.default)({
	    type: "WhileStatement",
	    test,
	    body
	  });
	}
	function withStatement(object, body) {
	  return (0, _validateNode.default)({
	    type: "WithStatement",
	    object,
	    body
	  });
	}
	function assignmentPattern(left, right) {
	  return (0, _validateNode.default)({
	    type: "AssignmentPattern",
	    left,
	    right
	  });
	}
	function arrayPattern(elements) {
	  return (0, _validateNode.default)({
	    type: "ArrayPattern",
	    elements
	  });
	}
	function arrowFunctionExpression(params, body, async = false) {
	  return (0, _validateNode.default)({
	    type: "ArrowFunctionExpression",
	    params,
	    body,
	    async,
	    expression: null
	  });
	}
	function classBody(body) {
	  return (0, _validateNode.default)({
	    type: "ClassBody",
	    body
	  });
	}
	function classExpression(id = null, superClass = null, body, decorators = null) {
	  return (0, _validateNode.default)({
	    type: "ClassExpression",
	    id,
	    superClass,
	    body,
	    decorators
	  });
	}
	function classDeclaration(id = null, superClass = null, body, decorators = null) {
	  return (0, _validateNode.default)({
	    type: "ClassDeclaration",
	    id,
	    superClass,
	    body,
	    decorators
	  });
	}
	function exportAllDeclaration(source) {
	  return (0, _validateNode.default)({
	    type: "ExportAllDeclaration",
	    source
	  });
	}
	function exportDefaultDeclaration(declaration) {
	  return (0, _validateNode.default)({
	    type: "ExportDefaultDeclaration",
	    declaration
	  });
	}
	function exportNamedDeclaration(declaration = null, specifiers = [], source = null) {
	  return (0, _validateNode.default)({
	    type: "ExportNamedDeclaration",
	    declaration,
	    specifiers,
	    source
	  });
	}
	function exportSpecifier(local, exported) {
	  return (0, _validateNode.default)({
	    type: "ExportSpecifier",
	    local,
	    exported
	  });
	}
	function forOfStatement(left, right, body, _await = false) {
	  return (0, _validateNode.default)({
	    type: "ForOfStatement",
	    left,
	    right,
	    body,
	    await: _await
	  });
	}
	function importDeclaration(specifiers, source) {
	  return (0, _validateNode.default)({
	    type: "ImportDeclaration",
	    specifiers,
	    source
	  });
	}
	function importDefaultSpecifier(local) {
	  return (0, _validateNode.default)({
	    type: "ImportDefaultSpecifier",
	    local
	  });
	}
	function importNamespaceSpecifier(local) {
	  return (0, _validateNode.default)({
	    type: "ImportNamespaceSpecifier",
	    local
	  });
	}
	function importSpecifier(local, imported) {
	  return (0, _validateNode.default)({
	    type: "ImportSpecifier",
	    local,
	    imported
	  });
	}
	function importExpression(source, options = null) {
	  return (0, _validateNode.default)({
	    type: "ImportExpression",
	    source,
	    options
	  });
	}
	function metaProperty(meta, property) {
	  return (0, _validateNode.default)({
	    type: "MetaProperty",
	    meta,
	    property
	  });
	}
	function classMethod(kind = "method", key, params, body, computed = false, _static = false, generator = false, async = false) {
	  return (0, _validateNode.default)({
	    type: "ClassMethod",
	    kind,
	    key,
	    params,
	    body,
	    computed,
	    static: _static,
	    generator,
	    async
	  });
	}
	function objectPattern(properties) {
	  return (0, _validateNode.default)({
	    type: "ObjectPattern",
	    properties
	  });
	}
	function spreadElement(argument) {
	  return (0, _validateNode.default)({
	    type: "SpreadElement",
	    argument
	  });
	}
	function _super() {
	  return {
	    type: "Super"
	  };
	}
	function taggedTemplateExpression(tag, quasi) {
	  return (0, _validateNode.default)({
	    type: "TaggedTemplateExpression",
	    tag,
	    quasi
	  });
	}
	function templateElement(value, tail = false) {
	  return (0, _validateNode.default)({
	    type: "TemplateElement",
	    value,
	    tail
	  });
	}
	function templateLiteral(quasis, expressions) {
	  return (0, _validateNode.default)({
	    type: "TemplateLiteral",
	    quasis,
	    expressions
	  });
	}
	function yieldExpression(argument = null, delegate = false) {
	  return (0, _validateNode.default)({
	    type: "YieldExpression",
	    argument,
	    delegate
	  });
	}
	function awaitExpression(argument) {
	  return (0, _validateNode.default)({
	    type: "AwaitExpression",
	    argument
	  });
	}
	function _import() {
	  return {
	    type: "Import"
	  };
	}
	function bigIntLiteral(value) {
	  return (0, _validateNode.default)({
	    type: "BigIntLiteral",
	    value
	  });
	}
	function exportNamespaceSpecifier(exported) {
	  return (0, _validateNode.default)({
	    type: "ExportNamespaceSpecifier",
	    exported
	  });
	}
	function optionalMemberExpression(object, property, computed = false, optional) {
	  return (0, _validateNode.default)({
	    type: "OptionalMemberExpression",
	    object,
	    property,
	    computed,
	    optional
	  });
	}
	function optionalCallExpression(callee, _arguments, optional) {
	  return (0, _validateNode.default)({
	    type: "OptionalCallExpression",
	    callee,
	    arguments: _arguments,
	    optional
	  });
	}
	function classProperty(key, value = null, typeAnnotation = null, decorators = null, computed = false, _static = false) {
	  return (0, _validateNode.default)({
	    type: "ClassProperty",
	    key,
	    value,
	    typeAnnotation,
	    decorators,
	    computed,
	    static: _static
	  });
	}
	function classAccessorProperty(key, value = null, typeAnnotation = null, decorators = null, computed = false, _static = false) {
	  return (0, _validateNode.default)({
	    type: "ClassAccessorProperty",
	    key,
	    value,
	    typeAnnotation,
	    decorators,
	    computed,
	    static: _static
	  });
	}
	function classPrivateProperty(key, value = null, decorators = null, _static = false) {
	  return (0, _validateNode.default)({
	    type: "ClassPrivateProperty",
	    key,
	    value,
	    decorators,
	    static: _static
	  });
	}
	function classPrivateMethod(kind = "method", key, params, body, _static = false) {
	  return (0, _validateNode.default)({
	    type: "ClassPrivateMethod",
	    kind,
	    key,
	    params,
	    body,
	    static: _static
	  });
	}
	function privateName(id) {
	  return (0, _validateNode.default)({
	    type: "PrivateName",
	    id
	  });
	}
	function staticBlock(body) {
	  return (0, _validateNode.default)({
	    type: "StaticBlock",
	    body
	  });
	}
	function anyTypeAnnotation() {
	  return {
	    type: "AnyTypeAnnotation"
	  };
	}
	function arrayTypeAnnotation(elementType) {
	  return (0, _validateNode.default)({
	    type: "ArrayTypeAnnotation",
	    elementType
	  });
	}
	function booleanTypeAnnotation() {
	  return {
	    type: "BooleanTypeAnnotation"
	  };
	}
	function booleanLiteralTypeAnnotation(value) {
	  return (0, _validateNode.default)({
	    type: "BooleanLiteralTypeAnnotation",
	    value
	  });
	}
	function nullLiteralTypeAnnotation() {
	  return {
	    type: "NullLiteralTypeAnnotation"
	  };
	}
	function classImplements(id, typeParameters = null) {
	  return (0, _validateNode.default)({
	    type: "ClassImplements",
	    id,
	    typeParameters
	  });
	}
	function declareClass(id, typeParameters = null, _extends = null, body) {
	  return (0, _validateNode.default)({
	    type: "DeclareClass",
	    id,
	    typeParameters,
	    extends: _extends,
	    body
	  });
	}
	function declareFunction(id) {
	  return (0, _validateNode.default)({
	    type: "DeclareFunction",
	    id
	  });
	}
	function declareInterface(id, typeParameters = null, _extends = null, body) {
	  return (0, _validateNode.default)({
	    type: "DeclareInterface",
	    id,
	    typeParameters,
	    extends: _extends,
	    body
	  });
	}
	function declareModule(id, body, kind = null) {
	  return (0, _validateNode.default)({
	    type: "DeclareModule",
	    id,
	    body,
	    kind
	  });
	}
	function declareModuleExports(typeAnnotation) {
	  return (0, _validateNode.default)({
	    type: "DeclareModuleExports",
	    typeAnnotation
	  });
	}
	function declareTypeAlias(id, typeParameters = null, right) {
	  return (0, _validateNode.default)({
	    type: "DeclareTypeAlias",
	    id,
	    typeParameters,
	    right
	  });
	}
	function declareOpaqueType(id, typeParameters = null, supertype = null) {
	  return (0, _validateNode.default)({
	    type: "DeclareOpaqueType",
	    id,
	    typeParameters,
	    supertype
	  });
	}
	function declareVariable(id) {
	  return (0, _validateNode.default)({
	    type: "DeclareVariable",
	    id
	  });
	}
	function declareExportDeclaration(declaration = null, specifiers = null, source = null) {
	  return (0, _validateNode.default)({
	    type: "DeclareExportDeclaration",
	    declaration,
	    specifiers,
	    source
	  });
	}
	function declareExportAllDeclaration(source) {
	  return (0, _validateNode.default)({
	    type: "DeclareExportAllDeclaration",
	    source
	  });
	}
	function declaredPredicate(value) {
	  return (0, _validateNode.default)({
	    type: "DeclaredPredicate",
	    value
	  });
	}
	function existsTypeAnnotation() {
	  return {
	    type: "ExistsTypeAnnotation"
	  };
	}
	function functionTypeAnnotation(typeParameters = null, params, rest = null, returnType) {
	  return (0, _validateNode.default)({
	    type: "FunctionTypeAnnotation",
	    typeParameters,
	    params,
	    rest,
	    returnType
	  });
	}
	function functionTypeParam(name = null, typeAnnotation) {
	  return (0, _validateNode.default)({
	    type: "FunctionTypeParam",
	    name,
	    typeAnnotation
	  });
	}
	function genericTypeAnnotation(id, typeParameters = null) {
	  return (0, _validateNode.default)({
	    type: "GenericTypeAnnotation",
	    id,
	    typeParameters
	  });
	}
	function inferredPredicate() {
	  return {
	    type: "InferredPredicate"
	  };
	}
	function interfaceExtends(id, typeParameters = null) {
	  return (0, _validateNode.default)({
	    type: "InterfaceExtends",
	    id,
	    typeParameters
	  });
	}
	function interfaceDeclaration(id, typeParameters = null, _extends = null, body) {
	  return (0, _validateNode.default)({
	    type: "InterfaceDeclaration",
	    id,
	    typeParameters,
	    extends: _extends,
	    body
	  });
	}
	function interfaceTypeAnnotation(_extends = null, body) {
	  return (0, _validateNode.default)({
	    type: "InterfaceTypeAnnotation",
	    extends: _extends,
	    body
	  });
	}
	function intersectionTypeAnnotation(types) {
	  return (0, _validateNode.default)({
	    type: "IntersectionTypeAnnotation",
	    types
	  });
	}
	function mixedTypeAnnotation() {
	  return {
	    type: "MixedTypeAnnotation"
	  };
	}
	function emptyTypeAnnotation() {
	  return {
	    type: "EmptyTypeAnnotation"
	  };
	}
	function nullableTypeAnnotation(typeAnnotation) {
	  return (0, _validateNode.default)({
	    type: "NullableTypeAnnotation",
	    typeAnnotation
	  });
	}
	function numberLiteralTypeAnnotation(value) {
	  return (0, _validateNode.default)({
	    type: "NumberLiteralTypeAnnotation",
	    value
	  });
	}
	function numberTypeAnnotation() {
	  return {
	    type: "NumberTypeAnnotation"
	  };
	}
	function objectTypeAnnotation(properties, indexers = [], callProperties = [], internalSlots = [], exact = false) {
	  return (0, _validateNode.default)({
	    type: "ObjectTypeAnnotation",
	    properties,
	    indexers,
	    callProperties,
	    internalSlots,
	    exact
	  });
	}
	function objectTypeInternalSlot(id, value, optional, _static, method) {
	  return (0, _validateNode.default)({
	    type: "ObjectTypeInternalSlot",
	    id,
	    value,
	    optional,
	    static: _static,
	    method
	  });
	}
	function objectTypeCallProperty(value) {
	  return (0, _validateNode.default)({
	    type: "ObjectTypeCallProperty",
	    value,
	    static: null
	  });
	}
	function objectTypeIndexer(id = null, key, value, variance = null) {
	  return (0, _validateNode.default)({
	    type: "ObjectTypeIndexer",
	    id,
	    key,
	    value,
	    variance,
	    static: null
	  });
	}
	function objectTypeProperty(key, value, variance = null) {
	  return (0, _validateNode.default)({
	    type: "ObjectTypeProperty",
	    key,
	    value,
	    variance,
	    kind: null,
	    method: null,
	    optional: null,
	    proto: null,
	    static: null
	  });
	}
	function objectTypeSpreadProperty(argument) {
	  return (0, _validateNode.default)({
	    type: "ObjectTypeSpreadProperty",
	    argument
	  });
	}
	function opaqueType(id, typeParameters = null, supertype = null, impltype) {
	  return (0, _validateNode.default)({
	    type: "OpaqueType",
	    id,
	    typeParameters,
	    supertype,
	    impltype
	  });
	}
	function qualifiedTypeIdentifier(id, qualification) {
	  return (0, _validateNode.default)({
	    type: "QualifiedTypeIdentifier",
	    id,
	    qualification
	  });
	}
	function stringLiteralTypeAnnotation(value) {
	  return (0, _validateNode.default)({
	    type: "StringLiteralTypeAnnotation",
	    value
	  });
	}
	function stringTypeAnnotation() {
	  return {
	    type: "StringTypeAnnotation"
	  };
	}
	function symbolTypeAnnotation() {
	  return {
	    type: "SymbolTypeAnnotation"
	  };
	}
	function thisTypeAnnotation() {
	  return {
	    type: "ThisTypeAnnotation"
	  };
	}
	function tupleTypeAnnotation(types) {
	  return (0, _validateNode.default)({
	    type: "TupleTypeAnnotation",
	    types
	  });
	}
	function typeofTypeAnnotation(argument) {
	  return (0, _validateNode.default)({
	    type: "TypeofTypeAnnotation",
	    argument
	  });
	}
	function typeAlias(id, typeParameters = null, right) {
	  return (0, _validateNode.default)({
	    type: "TypeAlias",
	    id,
	    typeParameters,
	    right
	  });
	}
	function typeAnnotation(typeAnnotation) {
	  return (0, _validateNode.default)({
	    type: "TypeAnnotation",
	    typeAnnotation
	  });
	}
	function typeCastExpression(expression, typeAnnotation) {
	  return (0, _validateNode.default)({
	    type: "TypeCastExpression",
	    expression,
	    typeAnnotation
	  });
	}
	function typeParameter(bound = null, _default = null, variance = null) {
	  return (0, _validateNode.default)({
	    type: "TypeParameter",
	    bound,
	    default: _default,
	    variance,
	    name: null
	  });
	}
	function typeParameterDeclaration(params) {
	  return (0, _validateNode.default)({
	    type: "TypeParameterDeclaration",
	    params
	  });
	}
	function typeParameterInstantiation(params) {
	  return (0, _validateNode.default)({
	    type: "TypeParameterInstantiation",
	    params
	  });
	}
	function unionTypeAnnotation(types) {
	  return (0, _validateNode.default)({
	    type: "UnionTypeAnnotation",
	    types
	  });
	}
	function variance(kind) {
	  return (0, _validateNode.default)({
	    type: "Variance",
	    kind
	  });
	}
	function voidTypeAnnotation() {
	  return {
	    type: "VoidTypeAnnotation"
	  };
	}
	function enumDeclaration(id, body) {
	  return (0, _validateNode.default)({
	    type: "EnumDeclaration",
	    id,
	    body
	  });
	}
	function enumBooleanBody(members) {
	  return (0, _validateNode.default)({
	    type: "EnumBooleanBody",
	    members,
	    explicitType: null,
	    hasUnknownMembers: null
	  });
	}
	function enumNumberBody(members) {
	  return (0, _validateNode.default)({
	    type: "EnumNumberBody",
	    members,
	    explicitType: null,
	    hasUnknownMembers: null
	  });
	}
	function enumStringBody(members) {
	  return (0, _validateNode.default)({
	    type: "EnumStringBody",
	    members,
	    explicitType: null,
	    hasUnknownMembers: null
	  });
	}
	function enumSymbolBody(members) {
	  return (0, _validateNode.default)({
	    type: "EnumSymbolBody",
	    members,
	    hasUnknownMembers: null
	  });
	}
	function enumBooleanMember(id) {
	  return (0, _validateNode.default)({
	    type: "EnumBooleanMember",
	    id,
	    init: null
	  });
	}
	function enumNumberMember(id, init) {
	  return (0, _validateNode.default)({
	    type: "EnumNumberMember",
	    id,
	    init
	  });
	}
	function enumStringMember(id, init) {
	  return (0, _validateNode.default)({
	    type: "EnumStringMember",
	    id,
	    init
	  });
	}
	function enumDefaultedMember(id) {
	  return (0, _validateNode.default)({
	    type: "EnumDefaultedMember",
	    id
	  });
	}
	function indexedAccessType(objectType, indexType) {
	  return (0, _validateNode.default)({
	    type: "IndexedAccessType",
	    objectType,
	    indexType
	  });
	}
	function optionalIndexedAccessType(objectType, indexType) {
	  return (0, _validateNode.default)({
	    type: "OptionalIndexedAccessType",
	    objectType,
	    indexType,
	    optional: null
	  });
	}
	function jsxAttribute(name, value = null) {
	  return (0, _validateNode.default)({
	    type: "JSXAttribute",
	    name,
	    value
	  });
	}
	function jsxClosingElement(name) {
	  return (0, _validateNode.default)({
	    type: "JSXClosingElement",
	    name
	  });
	}
	function jsxElement(openingElement, closingElement = null, children, selfClosing = null) {
	  return (0, _validateNode.default)({
	    type: "JSXElement",
	    openingElement,
	    closingElement,
	    children,
	    selfClosing
	  });
	}
	function jsxEmptyExpression() {
	  return {
	    type: "JSXEmptyExpression"
	  };
	}
	function jsxExpressionContainer(expression) {
	  return (0, _validateNode.default)({
	    type: "JSXExpressionContainer",
	    expression
	  });
	}
	function jsxSpreadChild(expression) {
	  return (0, _validateNode.default)({
	    type: "JSXSpreadChild",
	    expression
	  });
	}
	function jsxIdentifier(name) {
	  return (0, _validateNode.default)({
	    type: "JSXIdentifier",
	    name
	  });
	}
	function jsxMemberExpression(object, property) {
	  return (0, _validateNode.default)({
	    type: "JSXMemberExpression",
	    object,
	    property
	  });
	}
	function jsxNamespacedName(namespace, name) {
	  return (0, _validateNode.default)({
	    type: "JSXNamespacedName",
	    namespace,
	    name
	  });
	}
	function jsxOpeningElement(name, attributes, selfClosing = false) {
	  return (0, _validateNode.default)({
	    type: "JSXOpeningElement",
	    name,
	    attributes,
	    selfClosing
	  });
	}
	function jsxSpreadAttribute(argument) {
	  return (0, _validateNode.default)({
	    type: "JSXSpreadAttribute",
	    argument
	  });
	}
	function jsxText(value) {
	  return (0, _validateNode.default)({
	    type: "JSXText",
	    value
	  });
	}
	function jsxFragment(openingFragment, closingFragment, children) {
	  return (0, _validateNode.default)({
	    type: "JSXFragment",
	    openingFragment,
	    closingFragment,
	    children
	  });
	}
	function jsxOpeningFragment() {
	  return {
	    type: "JSXOpeningFragment"
	  };
	}
	function jsxClosingFragment() {
	  return {
	    type: "JSXClosingFragment"
	  };
	}
	function noop() {
	  return {
	    type: "Noop"
	  };
	}
	function placeholder(expectedNode, name) {
	  return (0, _validateNode.default)({
	    type: "Placeholder",
	    expectedNode,
	    name
	  });
	}
	function v8IntrinsicIdentifier(name) {
	  return (0, _validateNode.default)({
	    type: "V8IntrinsicIdentifier",
	    name
	  });
	}
	function argumentPlaceholder() {
	  return {
	    type: "ArgumentPlaceholder"
	  };
	}
	function bindExpression(object, callee) {
	  return (0, _validateNode.default)({
	    type: "BindExpression",
	    object,
	    callee
	  });
	}
	function importAttribute(key, value) {
	  return (0, _validateNode.default)({
	    type: "ImportAttribute",
	    key,
	    value
	  });
	}
	function decorator(expression) {
	  return (0, _validateNode.default)({
	    type: "Decorator",
	    expression
	  });
	}
	function doExpression(body, async = false) {
	  return (0, _validateNode.default)({
	    type: "DoExpression",
	    body,
	    async
	  });
	}
	function exportDefaultSpecifier(exported) {
	  return (0, _validateNode.default)({
	    type: "ExportDefaultSpecifier",
	    exported
	  });
	}
	function recordExpression(properties) {
	  return (0, _validateNode.default)({
	    type: "RecordExpression",
	    properties
	  });
	}
	function tupleExpression(elements = []) {
	  return (0, _validateNode.default)({
	    type: "TupleExpression",
	    elements
	  });
	}
	function decimalLiteral(value) {
	  return (0, _validateNode.default)({
	    type: "DecimalLiteral",
	    value
	  });
	}
	function moduleExpression(body) {
	  return (0, _validateNode.default)({
	    type: "ModuleExpression",
	    body
	  });
	}
	function topicReference() {
	  return {
	    type: "TopicReference"
	  };
	}
	function pipelineTopicExpression(expression) {
	  return (0, _validateNode.default)({
	    type: "PipelineTopicExpression",
	    expression
	  });
	}
	function pipelineBareFunction(callee) {
	  return (0, _validateNode.default)({
	    type: "PipelineBareFunction",
	    callee
	  });
	}
	function pipelinePrimaryTopicReference() {
	  return {
	    type: "PipelinePrimaryTopicReference"
	  };
	}
	function tsParameterProperty(parameter) {
	  return (0, _validateNode.default)({
	    type: "TSParameterProperty",
	    parameter
	  });
	}
	function tsDeclareFunction(id = null, typeParameters = null, params, returnType = null) {
	  return (0, _validateNode.default)({
	    type: "TSDeclareFunction",
	    id,
	    typeParameters,
	    params,
	    returnType
	  });
	}
	function tsDeclareMethod(decorators = null, key, typeParameters = null, params, returnType = null) {
	  return (0, _validateNode.default)({
	    type: "TSDeclareMethod",
	    decorators,
	    key,
	    typeParameters,
	    params,
	    returnType
	  });
	}
	function tsQualifiedName(left, right) {
	  return (0, _validateNode.default)({
	    type: "TSQualifiedName",
	    left,
	    right
	  });
	}
	function tsCallSignatureDeclaration(typeParameters = null, parameters, typeAnnotation = null) {
	  return (0, _validateNode.default)({
	    type: "TSCallSignatureDeclaration",
	    typeParameters,
	    parameters,
	    typeAnnotation
	  });
	}
	function tsConstructSignatureDeclaration(typeParameters = null, parameters, typeAnnotation = null) {
	  return (0, _validateNode.default)({
	    type: "TSConstructSignatureDeclaration",
	    typeParameters,
	    parameters,
	    typeAnnotation
	  });
	}
	function tsPropertySignature(key, typeAnnotation = null) {
	  return (0, _validateNode.default)({
	    type: "TSPropertySignature",
	    key,
	    typeAnnotation,
	    kind: null
	  });
	}
	function tsMethodSignature(key, typeParameters = null, parameters, typeAnnotation = null) {
	  return (0, _validateNode.default)({
	    type: "TSMethodSignature",
	    key,
	    typeParameters,
	    parameters,
	    typeAnnotation,
	    kind: null
	  });
	}
	function tsIndexSignature(parameters, typeAnnotation = null) {
	  return (0, _validateNode.default)({
	    type: "TSIndexSignature",
	    parameters,
	    typeAnnotation
	  });
	}
	function tsAnyKeyword() {
	  return {
	    type: "TSAnyKeyword"
	  };
	}
	function tsBooleanKeyword() {
	  return {
	    type: "TSBooleanKeyword"
	  };
	}
	function tsBigIntKeyword() {
	  return {
	    type: "TSBigIntKeyword"
	  };
	}
	function tsIntrinsicKeyword() {
	  return {
	    type: "TSIntrinsicKeyword"
	  };
	}
	function tsNeverKeyword() {
	  return {
	    type: "TSNeverKeyword"
	  };
	}
	function tsNullKeyword() {
	  return {
	    type: "TSNullKeyword"
	  };
	}
	function tsNumberKeyword() {
	  return {
	    type: "TSNumberKeyword"
	  };
	}
	function tsObjectKeyword() {
	  return {
	    type: "TSObjectKeyword"
	  };
	}
	function tsStringKeyword() {
	  return {
	    type: "TSStringKeyword"
	  };
	}
	function tsSymbolKeyword() {
	  return {
	    type: "TSSymbolKeyword"
	  };
	}
	function tsUndefinedKeyword() {
	  return {
	    type: "TSUndefinedKeyword"
	  };
	}
	function tsUnknownKeyword() {
	  return {
	    type: "TSUnknownKeyword"
	  };
	}
	function tsVoidKeyword() {
	  return {
	    type: "TSVoidKeyword"
	  };
	}
	function tsThisType() {
	  return {
	    type: "TSThisType"
	  };
	}
	function tsFunctionType(typeParameters = null, parameters, typeAnnotation = null) {
	  return (0, _validateNode.default)({
	    type: "TSFunctionType",
	    typeParameters,
	    parameters,
	    typeAnnotation
	  });
	}
	function tsConstructorType(typeParameters = null, parameters, typeAnnotation = null) {
	  return (0, _validateNode.default)({
	    type: "TSConstructorType",
	    typeParameters,
	    parameters,
	    typeAnnotation
	  });
	}
	function tsTypeReference(typeName, typeParameters = null) {
	  return (0, _validateNode.default)({
	    type: "TSTypeReference",
	    typeName,
	    typeParameters
	  });
	}
	function tsTypePredicate(parameterName, typeAnnotation = null, asserts = null) {
	  return (0, _validateNode.default)({
	    type: "TSTypePredicate",
	    parameterName,
	    typeAnnotation,
	    asserts
	  });
	}
	function tsTypeQuery(exprName, typeParameters = null) {
	  return (0, _validateNode.default)({
	    type: "TSTypeQuery",
	    exprName,
	    typeParameters
	  });
	}
	function tsTypeLiteral(members) {
	  return (0, _validateNode.default)({
	    type: "TSTypeLiteral",
	    members
	  });
	}
	function tsArrayType(elementType) {
	  return (0, _validateNode.default)({
	    type: "TSArrayType",
	    elementType
	  });
	}
	function tsTupleType(elementTypes) {
	  return (0, _validateNode.default)({
	    type: "TSTupleType",
	    elementTypes
	  });
	}
	function tsOptionalType(typeAnnotation) {
	  return (0, _validateNode.default)({
	    type: "TSOptionalType",
	    typeAnnotation
	  });
	}
	function tsRestType(typeAnnotation) {
	  return (0, _validateNode.default)({
	    type: "TSRestType",
	    typeAnnotation
	  });
	}
	function tsNamedTupleMember(label, elementType, optional = false) {
	  return (0, _validateNode.default)({
	    type: "TSNamedTupleMember",
	    label,
	    elementType,
	    optional
	  });
	}
	function tsUnionType(types) {
	  return (0, _validateNode.default)({
	    type: "TSUnionType",
	    types
	  });
	}
	function tsIntersectionType(types) {
	  return (0, _validateNode.default)({
	    type: "TSIntersectionType",
	    types
	  });
	}
	function tsConditionalType(checkType, extendsType, trueType, falseType) {
	  return (0, _validateNode.default)({
	    type: "TSConditionalType",
	    checkType,
	    extendsType,
	    trueType,
	    falseType
	  });
	}
	function tsInferType(typeParameter) {
	  return (0, _validateNode.default)({
	    type: "TSInferType",
	    typeParameter
	  });
	}
	function tsParenthesizedType(typeAnnotation) {
	  return (0, _validateNode.default)({
	    type: "TSParenthesizedType",
	    typeAnnotation
	  });
	}
	function tsTypeOperator(typeAnnotation) {
	  return (0, _validateNode.default)({
	    type: "TSTypeOperator",
	    typeAnnotation,
	    operator: null
	  });
	}
	function tsIndexedAccessType(objectType, indexType) {
	  return (0, _validateNode.default)({
	    type: "TSIndexedAccessType",
	    objectType,
	    indexType
	  });
	}
	function tsMappedType(typeParameter, typeAnnotation = null, nameType = null) {
	  return (0, _validateNode.default)({
	    type: "TSMappedType",
	    typeParameter,
	    typeAnnotation,
	    nameType
	  });
	}
	function tsLiteralType(literal) {
	  return (0, _validateNode.default)({
	    type: "TSLiteralType",
	    literal
	  });
	}
	function tsExpressionWithTypeArguments(expression, typeParameters = null) {
	  return (0, _validateNode.default)({
	    type: "TSExpressionWithTypeArguments",
	    expression,
	    typeParameters
	  });
	}
	function tsInterfaceDeclaration(id, typeParameters = null, _extends = null, body) {
	  return (0, _validateNode.default)({
	    type: "TSInterfaceDeclaration",
	    id,
	    typeParameters,
	    extends: _extends,
	    body
	  });
	}
	function tsInterfaceBody(body) {
	  return (0, _validateNode.default)({
	    type: "TSInterfaceBody",
	    body
	  });
	}
	function tsTypeAliasDeclaration(id, typeParameters = null, typeAnnotation) {
	  return (0, _validateNode.default)({
	    type: "TSTypeAliasDeclaration",
	    id,
	    typeParameters,
	    typeAnnotation
	  });
	}
	function tsInstantiationExpression(expression, typeParameters = null) {
	  return (0, _validateNode.default)({
	    type: "TSInstantiationExpression",
	    expression,
	    typeParameters
	  });
	}
	function tsAsExpression(expression, typeAnnotation) {
	  return (0, _validateNode.default)({
	    type: "TSAsExpression",
	    expression,
	    typeAnnotation
	  });
	}
	function tsSatisfiesExpression(expression, typeAnnotation) {
	  return (0, _validateNode.default)({
	    type: "TSSatisfiesExpression",
	    expression,
	    typeAnnotation
	  });
	}
	function tsTypeAssertion(typeAnnotation, expression) {
	  return (0, _validateNode.default)({
	    type: "TSTypeAssertion",
	    typeAnnotation,
	    expression
	  });
	}
	function tsEnumDeclaration(id, members) {
	  return (0, _validateNode.default)({
	    type: "TSEnumDeclaration",
	    id,
	    members
	  });
	}
	function tsEnumMember(id, initializer = null) {
	  return (0, _validateNode.default)({
	    type: "TSEnumMember",
	    id,
	    initializer
	  });
	}
	function tsModuleDeclaration(id, body) {
	  return (0, _validateNode.default)({
	    type: "TSModuleDeclaration",
	    id,
	    body
	  });
	}
	function tsModuleBlock(body) {
	  return (0, _validateNode.default)({
	    type: "TSModuleBlock",
	    body
	  });
	}
	function tsImportType(argument, qualifier = null, typeParameters = null) {
	  return (0, _validateNode.default)({
	    type: "TSImportType",
	    argument,
	    qualifier,
	    typeParameters
	  });
	}
	function tsImportEqualsDeclaration(id, moduleReference) {
	  return (0, _validateNode.default)({
	    type: "TSImportEqualsDeclaration",
	    id,
	    moduleReference,
	    isExport: null
	  });
	}
	function tsExternalModuleReference(expression) {
	  return (0, _validateNode.default)({
	    type: "TSExternalModuleReference",
	    expression
	  });
	}
	function tsNonNullExpression(expression) {
	  return (0, _validateNode.default)({
	    type: "TSNonNullExpression",
	    expression
	  });
	}
	function tsExportAssignment(expression) {
	  return (0, _validateNode.default)({
	    type: "TSExportAssignment",
	    expression
	  });
	}
	function tsNamespaceExportDeclaration(id) {
	  return (0, _validateNode.default)({
	    type: "TSNamespaceExportDeclaration",
	    id
	  });
	}
	function tsTypeAnnotation(typeAnnotation) {
	  return (0, _validateNode.default)({
	    type: "TSTypeAnnotation",
	    typeAnnotation
	  });
	}
	function tsTypeParameterInstantiation(params) {
	  return (0, _validateNode.default)({
	    type: "TSTypeParameterInstantiation",
	    params
	  });
	}
	function tsTypeParameterDeclaration(params) {
	  return (0, _validateNode.default)({
	    type: "TSTypeParameterDeclaration",
	    params
	  });
	}
	function tsTypeParameter(constraint = null, _default = null, name) {
	  return (0, _validateNode.default)({
	    type: "TSTypeParameter",
	    constraint,
	    default: _default,
	    name
	  });
	}
	function NumberLiteral(value) {
	  (0, _deprecationWarning.default)("NumberLiteral", "NumericLiteral", "The node type ");
	  return numericLiteral(value);
	}
	function RegexLiteral(pattern, flags = "") {
	  (0, _deprecationWarning.default)("RegexLiteral", "RegExpLiteral", "The node type ");
	  return regExpLiteral(pattern, flags);
	}
	function RestProperty(argument) {
	  (0, _deprecationWarning.default)("RestProperty", "RestElement", "The node type ");
	  return restElement(argument);
	}
	function SpreadProperty(argument) {
	  (0, _deprecationWarning.default)("SpreadProperty", "SpreadElement", "The node type ");
	  return spreadElement(argument);
	}

	
	return generated$2;
}

var hasRequiredCleanJSXElementLiteralChild;

function requireCleanJSXElementLiteralChild () {
	if (hasRequiredCleanJSXElementLiteralChild) return cleanJSXElementLiteralChild;
	hasRequiredCleanJSXElementLiteralChild = 1;

	Object.defineProperty(cleanJSXElementLiteralChild, "__esModule", {
	  value: true
	});
	cleanJSXElementLiteralChild.default = cleanJSXElementLiteralChild$1;
	var _index = requireGenerated$2();
	var _index2 = requireLib$h();
	function cleanJSXElementLiteralChild$1(child, args) {
	  const lines = child.value.split(/\r\n|\n|\r/);
	  let lastNonEmptyLine = 0;
	  for (let i = 0; i < lines.length; i++) {
	    if (lines[i].match(/[^ \t]/)) {
	      lastNonEmptyLine = i;
	    }
	  }
	  let str = "";
	  for (let i = 0; i < lines.length; i++) {
	    const line = lines[i];
	    const isFirstLine = i === 0;
	    const isLastLine = i === lines.length - 1;
	    const isLastNonEmptyLine = i === lastNonEmptyLine;
	    let trimmedLine = line.replace(/\t/g, " ");
	    if (!isFirstLine) {
	      trimmedLine = trimmedLine.replace(/^[ ]+/, "");
	    }
	    if (!isLastLine) {
	      trimmedLine = trimmedLine.replace(/[ ]+$/, "");
	    }
	    if (trimmedLine) {
	      if (!isLastNonEmptyLine) {
	        trimmedLine += " ";
	      }
	      str += trimmedLine;
	    }
	  }
	  if (str) args.push((0, _index2.inherits)((0, _index.stringLiteral)(str), child));
	}

	
	return cleanJSXElementLiteralChild;
}

var hasRequiredBuildChildren;

function requireBuildChildren () {
	if (hasRequiredBuildChildren) return buildChildren;
	hasRequiredBuildChildren = 1;

	Object.defineProperty(buildChildren, "__esModule", {
	  value: true
	});
	buildChildren.default = buildChildren$1;
	var _index = requireGenerated$3();
	var _cleanJSXElementLiteralChild = requireCleanJSXElementLiteralChild();
	function buildChildren$1(node) {
	  const elements = [];
	  for (let i = 0; i < node.children.length; i++) {
	    let child = node.children[i];
	    if ((0, _index.isJSXText)(child)) {
	      (0, _cleanJSXElementLiteralChild.default)(child, elements);
	      continue;
	    }
	    if ((0, _index.isJSXExpressionContainer)(child)) child = child.expression;
	    if ((0, _index.isJSXEmptyExpression)(child)) continue;
	    elements.push(child);
	  }
	  return elements;
	}

	
	return buildChildren;
}

var assertNode = {};

var isNode = {};

var hasRequiredIsNode;

function requireIsNode () {
	if (hasRequiredIsNode) return isNode;
	hasRequiredIsNode = 1;

	Object.defineProperty(isNode, "__esModule", {
	  value: true
	});
	isNode.default = isNode$1;
	var _index = requireDefinitions();
	function isNode$1(node) {
	  return !!(node && _index.VISITOR_KEYS[node.type]);
	}

	
	return isNode;
}

var hasRequiredAssertNode;

function requireAssertNode () {
	if (hasRequiredAssertNode) return assertNode;
	hasRequiredAssertNode = 1;

	Object.defineProperty(assertNode, "__esModule", {
	  value: true
	});
	assertNode.default = assertNode$1;
	var _isNode = requireIsNode();
	function assertNode$1(node) {
	  if (!(0, _isNode.default)(node)) {
	    var _node$type;
	    const type = (_node$type = node == null ? void 0 : node.type) != null ? _node$type : JSON.stringify(node);
	    throw new TypeError(`Not a valid node of type "${type}"`);
	  }
	}

	
	return assertNode;
}

var generated$1 = {};

var hasRequiredGenerated$1;

function requireGenerated$1 () {
	if (hasRequiredGenerated$1) return generated$1;
	hasRequiredGenerated$1 = 1;

	Object.defineProperty(generated$1, "__esModule", {
	  value: true
	});
	generated$1.assertAccessor = assertAccessor;
	generated$1.assertAnyTypeAnnotation = assertAnyTypeAnnotation;
	generated$1.assertArgumentPlaceholder = assertArgumentPlaceholder;
	generated$1.assertArrayExpression = assertArrayExpression;
	generated$1.assertArrayPattern = assertArrayPattern;
	generated$1.assertArrayTypeAnnotation = assertArrayTypeAnnotation;
	generated$1.assertArrowFunctionExpression = assertArrowFunctionExpression;
	generated$1.assertAssignmentExpression = assertAssignmentExpression;
	generated$1.assertAssignmentPattern = assertAssignmentPattern;
	generated$1.assertAwaitExpression = assertAwaitExpression;
	generated$1.assertBigIntLiteral = assertBigIntLiteral;
	generated$1.assertBinary = assertBinary;
	generated$1.assertBinaryExpression = assertBinaryExpression;
	generated$1.assertBindExpression = assertBindExpression;
	generated$1.assertBlock = assertBlock;
	generated$1.assertBlockParent = assertBlockParent;
	generated$1.assertBlockStatement = assertBlockStatement;
	generated$1.assertBooleanLiteral = assertBooleanLiteral;
	generated$1.assertBooleanLiteralTypeAnnotation = assertBooleanLiteralTypeAnnotation;
	generated$1.assertBooleanTypeAnnotation = assertBooleanTypeAnnotation;
	generated$1.assertBreakStatement = assertBreakStatement;
	generated$1.assertCallExpression = assertCallExpression;
	generated$1.assertCatchClause = assertCatchClause;
	generated$1.assertClass = assertClass;
	generated$1.assertClassAccessorProperty = assertClassAccessorProperty;
	generated$1.assertClassBody = assertClassBody;
	generated$1.assertClassDeclaration = assertClassDeclaration;
	generated$1.assertClassExpression = assertClassExpression;
	generated$1.assertClassImplements = assertClassImplements;
	generated$1.assertClassMethod = assertClassMethod;
	generated$1.assertClassPrivateMethod = assertClassPrivateMethod;
	generated$1.assertClassPrivateProperty = assertClassPrivateProperty;
	generated$1.assertClassProperty = assertClassProperty;
	generated$1.assertCompletionStatement = assertCompletionStatement;
	generated$1.assertConditional = assertConditional;
	generated$1.assertConditionalExpression = assertConditionalExpression;
	generated$1.assertContinueStatement = assertContinueStatement;
	generated$1.assertDebuggerStatement = assertDebuggerStatement;
	generated$1.assertDecimalLiteral = assertDecimalLiteral;
	generated$1.assertDeclaration = assertDeclaration;
	generated$1.assertDeclareClass = assertDeclareClass;
	generated$1.assertDeclareExportAllDeclaration = assertDeclareExportAllDeclaration;
	generated$1.assertDeclareExportDeclaration = assertDeclareExportDeclaration;
	generated$1.assertDeclareFunction = assertDeclareFunction;
	generated$1.assertDeclareInterface = assertDeclareInterface;
	generated$1.assertDeclareModule = assertDeclareModule;
	generated$1.assertDeclareModuleExports = assertDeclareModuleExports;
	generated$1.assertDeclareOpaqueType = assertDeclareOpaqueType;
	generated$1.assertDeclareTypeAlias = assertDeclareTypeAlias;
	generated$1.assertDeclareVariable = assertDeclareVariable;
	generated$1.assertDeclaredPredicate = assertDeclaredPredicate;
	generated$1.assertDecorator = assertDecorator;
	generated$1.assertDirective = assertDirective;
	generated$1.assertDirectiveLiteral = assertDirectiveLiteral;
	generated$1.assertDoExpression = assertDoExpression;
	generated$1.assertDoWhileStatement = assertDoWhileStatement;
	generated$1.assertEmptyStatement = assertEmptyStatement;
	generated$1.assertEmptyTypeAnnotation = assertEmptyTypeAnnotation;
	generated$1.assertEnumBody = assertEnumBody;
	generated$1.assertEnumBooleanBody = assertEnumBooleanBody;
	generated$1.assertEnumBooleanMember = assertEnumBooleanMember;
	generated$1.assertEnumDeclaration = assertEnumDeclaration;
	generated$1.assertEnumDefaultedMember = assertEnumDefaultedMember;
	generated$1.assertEnumMember = assertEnumMember;
	generated$1.assertEnumNumberBody = assertEnumNumberBody;
	generated$1.assertEnumNumberMember = assertEnumNumberMember;
	generated$1.assertEnumStringBody = assertEnumStringBody;
	generated$1.assertEnumStringMember = assertEnumStringMember;
	generated$1.assertEnumSymbolBody = assertEnumSymbolBody;
	generated$1.assertExistsTypeAnnotation = assertExistsTypeAnnotation;
	generated$1.assertExportAllDeclaration = assertExportAllDeclaration;
	generated$1.assertExportDeclaration = assertExportDeclaration;
	generated$1.assertExportDefaultDeclaration = assertExportDefaultDeclaration;
	generated$1.assertExportDefaultSpecifier = assertExportDefaultSpecifier;
	generated$1.assertExportNamedDeclaration = assertExportNamedDeclaration;
	generated$1.assertExportNamespaceSpecifier = assertExportNamespaceSpecifier;
	generated$1.assertExportSpecifier = assertExportSpecifier;
	generated$1.assertExpression = assertExpression;
	generated$1.assertExpressionStatement = assertExpressionStatement;
	generated$1.assertExpressionWrapper = assertExpressionWrapper;
	generated$1.assertFile = assertFile;
	generated$1.assertFlow = assertFlow;
	generated$1.assertFlowBaseAnnotation = assertFlowBaseAnnotation;
	generated$1.assertFlowDeclaration = assertFlowDeclaration;
	generated$1.assertFlowPredicate = assertFlowPredicate;
	generated$1.assertFlowType = assertFlowType;
	generated$1.assertFor = assertFor;
	generated$1.assertForInStatement = assertForInStatement;
	generated$1.assertForOfStatement = assertForOfStatement;
	generated$1.assertForStatement = assertForStatement;
	generated$1.assertForXStatement = assertForXStatement;
	generated$1.assertFunction = assertFunction;
	generated$1.assertFunctionDeclaration = assertFunctionDeclaration;
	generated$1.assertFunctionExpression = assertFunctionExpression;
	generated$1.assertFunctionParent = assertFunctionParent;
	generated$1.assertFunctionTypeAnnotation = assertFunctionTypeAnnotation;
	generated$1.assertFunctionTypeParam = assertFunctionTypeParam;
	generated$1.assertGenericTypeAnnotation = assertGenericTypeAnnotation;
	generated$1.assertIdentifier = assertIdentifier;
	generated$1.assertIfStatement = assertIfStatement;
	generated$1.assertImmutable = assertImmutable;
	generated$1.assertImport = assertImport;
	generated$1.assertImportAttribute = assertImportAttribute;
	generated$1.assertImportDeclaration = assertImportDeclaration;
	generated$1.assertImportDefaultSpecifier = assertImportDefaultSpecifier;
	generated$1.assertImportExpression = assertImportExpression;
	generated$1.assertImportNamespaceSpecifier = assertImportNamespaceSpecifier;
	generated$1.assertImportOrExportDeclaration = assertImportOrExportDeclaration;
	generated$1.assertImportSpecifier = assertImportSpecifier;
	generated$1.assertIndexedAccessType = assertIndexedAccessType;
	generated$1.assertInferredPredicate = assertInferredPredicate;
	generated$1.assertInterfaceDeclaration = assertInterfaceDeclaration;
	generated$1.assertInterfaceExtends = assertInterfaceExtends;
	generated$1.assertInterfaceTypeAnnotation = assertInterfaceTypeAnnotation;
	generated$1.assertInterpreterDirective = assertInterpreterDirective;
	generated$1.assertIntersectionTypeAnnotation = assertIntersectionTypeAnnotation;
	generated$1.assertJSX = assertJSX;
	generated$1.assertJSXAttribute = assertJSXAttribute;
	generated$1.assertJSXClosingElement = assertJSXClosingElement;
	generated$1.assertJSXClosingFragment = assertJSXClosingFragment;
	generated$1.assertJSXElement = assertJSXElement;
	generated$1.assertJSXEmptyExpression = assertJSXEmptyExpression;
	generated$1.assertJSXExpressionContainer = assertJSXExpressionContainer;
	generated$1.assertJSXFragment = assertJSXFragment;
	generated$1.assertJSXIdentifier = assertJSXIdentifier;
	generated$1.assertJSXMemberExpression = assertJSXMemberExpression;
	generated$1.assertJSXNamespacedName = assertJSXNamespacedName;
	generated$1.assertJSXOpeningElement = assertJSXOpeningElement;
	generated$1.assertJSXOpeningFragment = assertJSXOpeningFragment;
	generated$1.assertJSXSpreadAttribute = assertJSXSpreadAttribute;
	generated$1.assertJSXSpreadChild = assertJSXSpreadChild;
	generated$1.assertJSXText = assertJSXText;
	generated$1.assertLVal = assertLVal;
	generated$1.assertLabeledStatement = assertLabeledStatement;
	generated$1.assertLiteral = assertLiteral;
	generated$1.assertLogicalExpression = assertLogicalExpression;
	generated$1.assertLoop = assertLoop;
	generated$1.assertMemberExpression = assertMemberExpression;
	generated$1.assertMetaProperty = assertMetaProperty;
	generated$1.assertMethod = assertMethod;
	generated$1.assertMiscellaneous = assertMiscellaneous;
	generated$1.assertMixedTypeAnnotation = assertMixedTypeAnnotation;
	generated$1.assertModuleDeclaration = assertModuleDeclaration;
	generated$1.assertModuleExpression = assertModuleExpression;
	generated$1.assertModuleSpecifier = assertModuleSpecifier;
	generated$1.assertNewExpression = assertNewExpression;
	generated$1.assertNoop = assertNoop;
	generated$1.assertNullLiteral = assertNullLiteral;
	generated$1.assertNullLiteralTypeAnnotation = assertNullLiteralTypeAnnotation;
	generated$1.assertNullableTypeAnnotation = assertNullableTypeAnnotation;
	generated$1.assertNumberLiteral = assertNumberLiteral;
	generated$1.assertNumberLiteralTypeAnnotation = assertNumberLiteralTypeAnnotation;
	generated$1.assertNumberTypeAnnotation = assertNumberTypeAnnotation;
	generated$1.assertNumericLiteral = assertNumericLiteral;
	generated$1.assertObjectExpression = assertObjectExpression;
	generated$1.assertObjectMember = assertObjectMember;
	generated$1.assertObjectMethod = assertObjectMethod;
	generated$1.assertObjectPattern = assertObjectPattern;
	generated$1.assertObjectProperty = assertObjectProperty;
	generated$1.assertObjectTypeAnnotation = assertObjectTypeAnnotation;
	generated$1.assertObjectTypeCallProperty = assertObjectTypeCallProperty;
	generated$1.assertObjectTypeIndexer = assertObjectTypeIndexer;
	generated$1.assertObjectTypeInternalSlot = assertObjectTypeInternalSlot;
	generated$1.assertObjectTypeProperty = assertObjectTypeProperty;
	generated$1.assertObjectTypeSpreadProperty = assertObjectTypeSpreadProperty;
	generated$1.assertOpaqueType = assertOpaqueType;
	generated$1.assertOptionalCallExpression = assertOptionalCallExpression;
	generated$1.assertOptionalIndexedAccessType = assertOptionalIndexedAccessType;
	generated$1.assertOptionalMemberExpression = assertOptionalMemberExpression;
	generated$1.assertParenthesizedExpression = assertParenthesizedExpression;
	generated$1.assertPattern = assertPattern;
	generated$1.assertPatternLike = assertPatternLike;
	generated$1.assertPipelineBareFunction = assertPipelineBareFunction;
	generated$1.assertPipelinePrimaryTopicReference = assertPipelinePrimaryTopicReference;
	generated$1.assertPipelineTopicExpression = assertPipelineTopicExpression;
	generated$1.assertPlaceholder = assertPlaceholder;
	generated$1.assertPrivate = assertPrivate;
	generated$1.assertPrivateName = assertPrivateName;
	generated$1.assertProgram = assertProgram;
	generated$1.assertProperty = assertProperty;
	generated$1.assertPureish = assertPureish;
	generated$1.assertQualifiedTypeIdentifier = assertQualifiedTypeIdentifier;
	generated$1.assertRecordExpression = assertRecordExpression;
	generated$1.assertRegExpLiteral = assertRegExpLiteral;
	generated$1.assertRegexLiteral = assertRegexLiteral;
	generated$1.assertRestElement = assertRestElement;
	generated$1.assertRestProperty = assertRestProperty;
	generated$1.assertReturnStatement = assertReturnStatement;
	generated$1.assertScopable = assertScopable;
	generated$1.assertSequenceExpression = assertSequenceExpression;
	generated$1.assertSpreadElement = assertSpreadElement;
	generated$1.assertSpreadProperty = assertSpreadProperty;
	generated$1.assertStandardized = assertStandardized;
	generated$1.assertStatement = assertStatement;
	generated$1.assertStaticBlock = assertStaticBlock;
	generated$1.assertStringLiteral = assertStringLiteral;
	generated$1.assertStringLiteralTypeAnnotation = assertStringLiteralTypeAnnotation;
	generated$1.assertStringTypeAnnotation = assertStringTypeAnnotation;
	generated$1.assertSuper = assertSuper;
	generated$1.assertSwitchCase = assertSwitchCase;
	generated$1.assertSwitchStatement = assertSwitchStatement;
	generated$1.assertSymbolTypeAnnotation = assertSymbolTypeAnnotation;
	generated$1.assertTSAnyKeyword = assertTSAnyKeyword;
	generated$1.assertTSArrayType = assertTSArrayType;
	generated$1.assertTSAsExpression = assertTSAsExpression;
	generated$1.assertTSBaseType = assertTSBaseType;
	generated$1.assertTSBigIntKeyword = assertTSBigIntKeyword;
	generated$1.assertTSBooleanKeyword = assertTSBooleanKeyword;
	generated$1.assertTSCallSignatureDeclaration = assertTSCallSignatureDeclaration;
	generated$1.assertTSConditionalType = assertTSConditionalType;
	generated$1.assertTSConstructSignatureDeclaration = assertTSConstructSignatureDeclaration;
	generated$1.assertTSConstructorType = assertTSConstructorType;
	generated$1.assertTSDeclareFunction = assertTSDeclareFunction;
	generated$1.assertTSDeclareMethod = assertTSDeclareMethod;
	generated$1.assertTSEntityName = assertTSEntityName;
	generated$1.assertTSEnumDeclaration = assertTSEnumDeclaration;
	generated$1.assertTSEnumMember = assertTSEnumMember;
	generated$1.assertTSExportAssignment = assertTSExportAssignment;
	generated$1.assertTSExpressionWithTypeArguments = assertTSExpressionWithTypeArguments;
	generated$1.assertTSExternalModuleReference = assertTSExternalModuleReference;
	generated$1.assertTSFunctionType = assertTSFunctionType;
	generated$1.assertTSImportEqualsDeclaration = assertTSImportEqualsDeclaration;
	generated$1.assertTSImportType = assertTSImportType;
	generated$1.assertTSIndexSignature = assertTSIndexSignature;
	generated$1.assertTSIndexedAccessType = assertTSIndexedAccessType;
	generated$1.assertTSInferType = assertTSInferType;
	generated$1.assertTSInstantiationExpression = assertTSInstantiationExpression;
	generated$1.assertTSInterfaceBody = assertTSInterfaceBody;
	generated$1.assertTSInterfaceDeclaration = assertTSInterfaceDeclaration;
	generated$1.assertTSIntersectionType = assertTSIntersectionType;
	generated$1.assertTSIntrinsicKeyword = assertTSIntrinsicKeyword;
	generated$1.assertTSLiteralType = assertTSLiteralType;
	generated$1.assertTSMappedType = assertTSMappedType;
	generated$1.assertTSMethodSignature = assertTSMethodSignature;
	generated$1.assertTSModuleBlock = assertTSModuleBlock;
	generated$1.assertTSModuleDeclaration = assertTSModuleDeclaration;
	generated$1.assertTSNamedTupleMember = assertTSNamedTupleMember;
	generated$1.assertTSNamespaceExportDeclaration = assertTSNamespaceExportDeclaration;
	generated$1.assertTSNeverKeyword = assertTSNeverKeyword;
	generated$1.assertTSNonNullExpression = assertTSNonNullExpression;
	generated$1.assertTSNullKeyword = assertTSNullKeyword;
	generated$1.assertTSNumberKeyword = assertTSNumberKeyword;
	generated$1.assertTSObjectKeyword = assertTSObjectKeyword;
	generated$1.assertTSOptionalType = assertTSOptionalType;
	generated$1.assertTSParameterProperty = assertTSParameterProperty;
	generated$1.assertTSParenthesizedType = assertTSParenthesizedType;
	generated$1.assertTSPropertySignature = assertTSPropertySignature;
	generated$1.assertTSQualifiedName = assertTSQualifiedName;
	generated$1.assertTSRestType = assertTSRestType;
	generated$1.assertTSSatisfiesExpression = assertTSSatisfiesExpression;
	generated$1.assertTSStringKeyword = assertTSStringKeyword;
	generated$1.assertTSSymbolKeyword = assertTSSymbolKeyword;
	generated$1.assertTSThisType = assertTSThisType;
	generated$1.assertTSTupleType = assertTSTupleType;
	generated$1.assertTSType = assertTSType;
	generated$1.assertTSTypeAliasDeclaration = assertTSTypeAliasDeclaration;
	generated$1.assertTSTypeAnnotation = assertTSTypeAnnotation;
	generated$1.assertTSTypeAssertion = assertTSTypeAssertion;
	generated$1.assertTSTypeElement = assertTSTypeElement;
	generated$1.assertTSTypeLiteral = assertTSTypeLiteral;
	generated$1.assertTSTypeOperator = assertTSTypeOperator;
	generated$1.assertTSTypeParameter = assertTSTypeParameter;
	generated$1.assertTSTypeParameterDeclaration = assertTSTypeParameterDeclaration;
	generated$1.assertTSTypeParameterInstantiation = assertTSTypeParameterInstantiation;
	generated$1.assertTSTypePredicate = assertTSTypePredicate;
	generated$1.assertTSTypeQuery = assertTSTypeQuery;
	generated$1.assertTSTypeReference = assertTSTypeReference;
	generated$1.assertTSUndefinedKeyword = assertTSUndefinedKeyword;
	generated$1.assertTSUnionType = assertTSUnionType;
	generated$1.assertTSUnknownKeyword = assertTSUnknownKeyword;
	generated$1.assertTSVoidKeyword = assertTSVoidKeyword;
	generated$1.assertTaggedTemplateExpression = assertTaggedTemplateExpression;
	generated$1.assertTemplateElement = assertTemplateElement;
	generated$1.assertTemplateLiteral = assertTemplateLiteral;
	generated$1.assertTerminatorless = assertTerminatorless;
	generated$1.assertThisExpression = assertThisExpression;
	generated$1.assertThisTypeAnnotation = assertThisTypeAnnotation;
	generated$1.assertThrowStatement = assertThrowStatement;
	generated$1.assertTopicReference = assertTopicReference;
	generated$1.assertTryStatement = assertTryStatement;
	generated$1.assertTupleExpression = assertTupleExpression;
	generated$1.assertTupleTypeAnnotation = assertTupleTypeAnnotation;
	generated$1.assertTypeAlias = assertTypeAlias;
	generated$1.assertTypeAnnotation = assertTypeAnnotation;
	generated$1.assertTypeCastExpression = assertTypeCastExpression;
	generated$1.assertTypeParameter = assertTypeParameter;
	generated$1.assertTypeParameterDeclaration = assertTypeParameterDeclaration;
	generated$1.assertTypeParameterInstantiation = assertTypeParameterInstantiation;
	generated$1.assertTypeScript = assertTypeScript;
	generated$1.assertTypeofTypeAnnotation = assertTypeofTypeAnnotation;
	generated$1.assertUnaryExpression = assertUnaryExpression;
	generated$1.assertUnaryLike = assertUnaryLike;
	generated$1.assertUnionTypeAnnotation = assertUnionTypeAnnotation;
	generated$1.assertUpdateExpression = assertUpdateExpression;
	generated$1.assertUserWhitespacable = assertUserWhitespacable;
	generated$1.assertV8IntrinsicIdentifier = assertV8IntrinsicIdentifier;
	generated$1.assertVariableDeclaration = assertVariableDeclaration;
	generated$1.assertVariableDeclarator = assertVariableDeclarator;
	generated$1.assertVariance = assertVariance;
	generated$1.assertVoidTypeAnnotation = assertVoidTypeAnnotation;
	generated$1.assertWhile = assertWhile;
	generated$1.assertWhileStatement = assertWhileStatement;
	generated$1.assertWithStatement = assertWithStatement;
	generated$1.assertYieldExpression = assertYieldExpression;
	var _is = requireIs();
	var _deprecationWarning = requireDeprecationWarning();
	function assert(type, node, opts) {
	  if (!(0, _is.default)(type, node, opts)) {
	    throw new Error(`Expected type "${type}" with option ${JSON.stringify(opts)}, ` + `but instead got "${node.type}".`);
	  }
	}
	function assertArrayExpression(node, opts) {
	  assert("ArrayExpression", node, opts);
	}
	function assertAssignmentExpression(node, opts) {
	  assert("AssignmentExpression", node, opts);
	}
	function assertBinaryExpression(node, opts) {
	  assert("BinaryExpression", node, opts);
	}
	function assertInterpreterDirective(node, opts) {
	  assert("InterpreterDirective", node, opts);
	}
	function assertDirective(node, opts) {
	  assert("Directive", node, opts);
	}
	function assertDirectiveLiteral(node, opts) {
	  assert("DirectiveLiteral", node, opts);
	}
	function assertBlockStatement(node, opts) {
	  assert("BlockStatement", node, opts);
	}
	function assertBreakStatement(node, opts) {
	  assert("BreakStatement", node, opts);
	}
	function assertCallExpression(node, opts) {
	  assert("CallExpression", node, opts);
	}
	function assertCatchClause(node, opts) {
	  assert("CatchClause", node, opts);
	}
	function assertConditionalExpression(node, opts) {
	  assert("ConditionalExpression", node, opts);
	}
	function assertContinueStatement(node, opts) {
	  assert("ContinueStatement", node, opts);
	}
	function assertDebuggerStatement(node, opts) {
	  assert("DebuggerStatement", node, opts);
	}
	function assertDoWhileStatement(node, opts) {
	  assert("DoWhileStatement", node, opts);
	}
	function assertEmptyStatement(node, opts) {
	  assert("EmptyStatement", node, opts);
	}
	function assertExpressionStatement(node, opts) {
	  assert("ExpressionStatement", node, opts);
	}
	function assertFile(node, opts) {
	  assert("File", node, opts);
	}
	function assertForInStatement(node, opts) {
	  assert("ForInStatement", node, opts);
	}
	function assertForStatement(node, opts) {
	  assert("ForStatement", node, opts);
	}
	function assertFunctionDeclaration(node, opts) {
	  assert("FunctionDeclaration", node, opts);
	}
	function assertFunctionExpression(node, opts) {
	  assert("FunctionExpression", node, opts);
	}
	function assertIdentifier(node, opts) {
	  assert("Identifier", node, opts);
	}
	function assertIfStatement(node, opts) {
	  assert("IfStatement", node, opts);
	}
	function assertLabeledStatement(node, opts) {
	  assert("LabeledStatement", node, opts);
	}
	function assertStringLiteral(node, opts) {
	  assert("StringLiteral", node, opts);
	}
	function assertNumericLiteral(node, opts) {
	  assert("NumericLiteral", node, opts);
	}
	function assertNullLiteral(node, opts) {
	  assert("NullLiteral", node, opts);
	}
	function assertBooleanLiteral(node, opts) {
	  assert("BooleanLiteral", node, opts);
	}
	function assertRegExpLiteral(node, opts) {
	  assert("RegExpLiteral", node, opts);
	}
	function assertLogicalExpression(node, opts) {
	  assert("LogicalExpression", node, opts);
	}
	function assertMemberExpression(node, opts) {
	  assert("MemberExpression", node, opts);
	}
	function assertNewExpression(node, opts) {
	  assert("NewExpression", node, opts);
	}
	function assertProgram(node, opts) {
	  assert("Program", node, opts);
	}
	function assertObjectExpression(node, opts) {
	  assert("ObjectExpression", node, opts);
	}
	function assertObjectMethod(node, opts) {
	  assert("ObjectMethod", node, opts);
	}
	function assertObjectProperty(node, opts) {
	  assert("ObjectProperty", node, opts);
	}
	function assertRestElement(node, opts) {
	  assert("RestElement", node, opts);
	}
	function assertReturnStatement(node, opts) {
	  assert("ReturnStatement", node, opts);
	}
	function assertSequenceExpression(node, opts) {
	  assert("SequenceExpression", node, opts);
	}
	function assertParenthesizedExpression(node, opts) {
	  assert("ParenthesizedExpression", node, opts);
	}
	function assertSwitchCase(node, opts) {
	  assert("SwitchCase", node, opts);
	}
	function assertSwitchStatement(node, opts) {
	  assert("SwitchStatement", node, opts);
	}
	function assertThisExpression(node, opts) {
	  assert("ThisExpression", node, opts);
	}
	function assertThrowStatement(node, opts) {
	  assert("ThrowStatement", node, opts);
	}
	function assertTryStatement(node, opts) {
	  assert("TryStatement", node, opts);
	}
	function assertUnaryExpression(node, opts) {
	  assert("UnaryExpression", node, opts);
	}
	function assertUpdateExpression(node, opts) {
	  assert("UpdateExpression", node, opts);
	}
	function assertVariableDeclaration(node, opts) {
	  assert("VariableDeclaration", node, opts);
	}
	function assertVariableDeclarator(node, opts) {
	  assert("VariableDeclarator", node, opts);
	}
	function assertWhileStatement(node, opts) {
	  assert("WhileStatement", node, opts);
	}
	function assertWithStatement(node, opts) {
	  assert("WithStatement", node, opts);
	}
	function assertAssignmentPattern(node, opts) {
	  assert("AssignmentPattern", node, opts);
	}
	function assertArrayPattern(node, opts) {
	  assert("ArrayPattern", node, opts);
	}
	function assertArrowFunctionExpression(node, opts) {
	  assert("ArrowFunctionExpression", node, opts);
	}
	function assertClassBody(node, opts) {
	  assert("ClassBody", node, opts);
	}
	function assertClassExpression(node, opts) {
	  assert("ClassExpression", node, opts);
	}
	function assertClassDeclaration(node, opts) {
	  assert("ClassDeclaration", node, opts);
	}
	function assertExportAllDeclaration(node, opts) {
	  assert("ExportAllDeclaration", node, opts);
	}
	function assertExportDefaultDeclaration(node, opts) {
	  assert("ExportDefaultDeclaration", node, opts);
	}
	function assertExportNamedDeclaration(node, opts) {
	  assert("ExportNamedDeclaration", node, opts);
	}
	function assertExportSpecifier(node, opts) {
	  assert("ExportSpecifier", node, opts);
	}
	function assertForOfStatement(node, opts) {
	  assert("ForOfStatement", node, opts);
	}
	function assertImportDeclaration(node, opts) {
	  assert("ImportDeclaration", node, opts);
	}
	function assertImportDefaultSpecifier(node, opts) {
	  assert("ImportDefaultSpecifier", node, opts);
	}
	function assertImportNamespaceSpecifier(node, opts) {
	  assert("ImportNamespaceSpecifier", node, opts);
	}
	function assertImportSpecifier(node, opts) {
	  assert("ImportSpecifier", node, opts);
	}
	function assertImportExpression(node, opts) {
	  assert("ImportExpression", node, opts);
	}
	function assertMetaProperty(node, opts) {
	  assert("MetaProperty", node, opts);
	}
	function assertClassMethod(node, opts) {
	  assert("ClassMethod", node, opts);
	}
	function assertObjectPattern(node, opts) {
	  assert("ObjectPattern", node, opts);
	}
	function assertSpreadElement(node, opts) {
	  assert("SpreadElement", node, opts);
	}
	function assertSuper(node, opts) {
	  assert("Super", node, opts);
	}
	function assertTaggedTemplateExpression(node, opts) {
	  assert("TaggedTemplateExpression", node, opts);
	}
	function assertTemplateElement(node, opts) {
	  assert("TemplateElement", node, opts);
	}
	function assertTemplateLiteral(node, opts) {
	  assert("TemplateLiteral", node, opts);
	}
	function assertYieldExpression(node, opts) {
	  assert("YieldExpression", node, opts);
	}
	function assertAwaitExpression(node, opts) {
	  assert("AwaitExpression", node, opts);
	}
	function assertImport(node, opts) {
	  assert("Import", node, opts);
	}
	function assertBigIntLiteral(node, opts) {
	  assert("BigIntLiteral", node, opts);
	}
	function assertExportNamespaceSpecifier(node, opts) {
	  assert("ExportNamespaceSpecifier", node, opts);
	}
	function assertOptionalMemberExpression(node, opts) {
	  assert("OptionalMemberExpression", node, opts);
	}
	function assertOptionalCallExpression(node, opts) {
	  assert("OptionalCallExpression", node, opts);
	}
	function assertClassProperty(node, opts) {
	  assert("ClassProperty", node, opts);
	}
	function assertClassAccessorProperty(node, opts) {
	  assert("ClassAccessorProperty", node, opts);
	}
	function assertClassPrivateProperty(node, opts) {
	  assert("ClassPrivateProperty", node, opts);
	}
	function assertClassPrivateMethod(node, opts) {
	  assert("ClassPrivateMethod", node, opts);
	}
	function assertPrivateName(node, opts) {
	  assert("PrivateName", node, opts);
	}
	function assertStaticBlock(node, opts) {
	  assert("StaticBlock", node, opts);
	}
	function assertAnyTypeAnnotation(node, opts) {
	  assert("AnyTypeAnnotation", node, opts);
	}
	function assertArrayTypeAnnotation(node, opts) {
	  assert("ArrayTypeAnnotation", node, opts);
	}
	function assertBooleanTypeAnnotation(node, opts) {
	  assert("BooleanTypeAnnotation", node, opts);
	}
	function assertBooleanLiteralTypeAnnotation(node, opts) {
	  assert("BooleanLiteralTypeAnnotation", node, opts);
	}
	function assertNullLiteralTypeAnnotation(node, opts) {
	  assert("NullLiteralTypeAnnotation", node, opts);
	}
	function assertClassImplements(node, opts) {
	  assert("ClassImplements", node, opts);
	}
	function assertDeclareClass(node, opts) {
	  assert("DeclareClass", node, opts);
	}
	function assertDeclareFunction(node, opts) {
	  assert("DeclareFunction", node, opts);
	}
	function assertDeclareInterface(node, opts) {
	  assert("DeclareInterface", node, opts);
	}
	function assertDeclareModule(node, opts) {
	  assert("DeclareModule", node, opts);
	}
	function assertDeclareModuleExports(node, opts) {
	  assert("DeclareModuleExports", node, opts);
	}
	function assertDeclareTypeAlias(node, opts) {
	  assert("DeclareTypeAlias", node, opts);
	}
	function assertDeclareOpaqueType(node, opts) {
	  assert("DeclareOpaqueType", node, opts);
	}
	function assertDeclareVariable(node, opts) {
	  assert("DeclareVariable", node, opts);
	}
	function assertDeclareExportDeclaration(node, opts) {
	  assert("DeclareExportDeclaration", node, opts);
	}
	function assertDeclareExportAllDeclaration(node, opts) {
	  assert("DeclareExportAllDeclaration", node, opts);
	}
	function assertDeclaredPredicate(node, opts) {
	  assert("DeclaredPredicate", node, opts);
	}
	function assertExistsTypeAnnotation(node, opts) {
	  assert("ExistsTypeAnnotation", node, opts);
	}
	function assertFunctionTypeAnnotation(node, opts) {
	  assert("FunctionTypeAnnotation", node, opts);
	}
	function assertFunctionTypeParam(node, opts) {
	  assert("FunctionTypeParam", node, opts);
	}
	function assertGenericTypeAnnotation(node, opts) {
	  assert("GenericTypeAnnotation", node, opts);
	}
	function assertInferredPredicate(node, opts) {
	  assert("InferredPredicate", node, opts);
	}
	function assertInterfaceExtends(node, opts) {
	  assert("InterfaceExtends", node, opts);
	}
	function assertInterfaceDeclaration(node, opts) {
	  assert("InterfaceDeclaration", node, opts);
	}
	function assertInterfaceTypeAnnotation(node, opts) {
	  assert("InterfaceTypeAnnotation", node, opts);
	}
	function assertIntersectionTypeAnnotation(node, opts) {
	  assert("IntersectionTypeAnnotation", node, opts);
	}
	function assertMixedTypeAnnotation(node, opts) {
	  assert("MixedTypeAnnotation", node, opts);
	}
	function assertEmptyTypeAnnotation(node, opts) {
	  assert("EmptyTypeAnnotation", node, opts);
	}
	function assertNullableTypeAnnotation(node, opts) {
	  assert("NullableTypeAnnotation", node, opts);
	}
	function assertNumberLiteralTypeAnnotation(node, opts) {
	  assert("NumberLiteralTypeAnnotation", node, opts);
	}
	function assertNumberTypeAnnotation(node, opts) {
	  assert("NumberTypeAnnotation", node, opts);
	}
	function assertObjectTypeAnnotation(node, opts) {
	  assert("ObjectTypeAnnotation", node, opts);
	}
	function assertObjectTypeInternalSlot(node, opts) {
	  assert("ObjectTypeInternalSlot", node, opts);
	}
	function assertObjectTypeCallProperty(node, opts) {
	  assert("ObjectTypeCallProperty", node, opts);
	}
	function assertObjectTypeIndexer(node, opts) {
	  assert("ObjectTypeIndexer", node, opts);
	}
	function assertObjectTypeProperty(node, opts) {
	  assert("ObjectTypeProperty", node, opts);
	}
	function assertObjectTypeSpreadProperty(node, opts) {
	  assert("ObjectTypeSpreadProperty", node, opts);
	}
	function assertOpaqueType(node, opts) {
	  assert("OpaqueType", node, opts);
	}
	function assertQualifiedTypeIdentifier(node, opts) {
	  assert("QualifiedTypeIdentifier", node, opts);
	}
	function assertStringLiteralTypeAnnotation(node, opts) {
	  assert("StringLiteralTypeAnnotation", node, opts);
	}
	function assertStringTypeAnnotation(node, opts) {
	  assert("StringTypeAnnotation", node, opts);
	}
	function assertSymbolTypeAnnotation(node, opts) {
	  assert("SymbolTypeAnnotation", node, opts);
	}
	function assertThisTypeAnnotation(node, opts) {
	  assert("ThisTypeAnnotation", node, opts);
	}
	function assertTupleTypeAnnotation(node, opts) {
	  assert("TupleTypeAnnotation", node, opts);
	}
	function assertTypeofTypeAnnotation(node, opts) {
	  assert("TypeofTypeAnnotation", node, opts);
	}
	function assertTypeAlias(node, opts) {
	  assert("TypeAlias", node, opts);
	}
	function assertTypeAnnotation(node, opts) {
	  assert("TypeAnnotation", node, opts);
	}
	function assertTypeCastExpression(node, opts) {
	  assert("TypeCastExpression", node, opts);
	}
	function assertTypeParameter(node, opts) {
	  assert("TypeParameter", node, opts);
	}
	function assertTypeParameterDeclaration(node, opts) {
	  assert("TypeParameterDeclaration", node, opts);
	}
	function assertTypeParameterInstantiation(node, opts) {
	  assert("TypeParameterInstantiation", node, opts);
	}
	function assertUnionTypeAnnotation(node, opts) {
	  assert("UnionTypeAnnotation", node, opts);
	}
	function assertVariance(node, opts) {
	  assert("Variance", node, opts);
	}
	function assertVoidTypeAnnotation(node, opts) {
	  assert("VoidTypeAnnotation", node, opts);
	}
	function assertEnumDeclaration(node, opts) {
	  assert("EnumDeclaration", node, opts);
	}
	function assertEnumBooleanBody(node, opts) {
	  assert("EnumBooleanBody", node, opts);
	}
	function assertEnumNumberBody(node, opts) {
	  assert("EnumNumberBody", node, opts);
	}
	function assertEnumStringBody(node, opts) {
	  assert("EnumStringBody", node, opts);
	}
	function assertEnumSymbolBody(node, opts) {
	  assert("EnumSymbolBody", node, opts);
	}
	function assertEnumBooleanMember(node, opts) {
	  assert("EnumBooleanMember", node, opts);
	}
	function assertEnumNumberMember(node, opts) {
	  assert("EnumNumberMember", node, opts);
	}
	function assertEnumStringMember(node, opts) {
	  assert("EnumStringMember", node, opts);
	}
	function assertEnumDefaultedMember(node, opts) {
	  assert("EnumDefaultedMember", node, opts);
	}
	function assertIndexedAccessType(node, opts) {
	  assert("IndexedAccessType", node, opts);
	}
	function assertOptionalIndexedAccessType(node, opts) {
	  assert("OptionalIndexedAccessType", node, opts);
	}
	function assertJSXAttribute(node, opts) {
	  assert("JSXAttribute", node, opts);
	}
	function assertJSXClosingElement(node, opts) {
	  assert("JSXClosingElement", node, opts);
	}
	function assertJSXElement(node, opts) {
	  assert("JSXElement", node, opts);
	}
	function assertJSXEmptyExpression(node, opts) {
	  assert("JSXEmptyExpression", node, opts);
	}
	function assertJSXExpressionContainer(node, opts) {
	  assert("JSXExpressionContainer", node, opts);
	}
	function assertJSXSpreadChild(node, opts) {
	  assert("JSXSpreadChild", node, opts);
	}
	function assertJSXIdentifier(node, opts) {
	  assert("JSXIdentifier", node, opts);
	}
	function assertJSXMemberExpression(node, opts) {
	  assert("JSXMemberExpression", node, opts);
	}
	function assertJSXNamespacedName(node, opts) {
	  assert("JSXNamespacedName", node, opts);
	}
	function assertJSXOpeningElement(node, opts) {
	  assert("JSXOpeningElement", node, opts);
	}
	function assertJSXSpreadAttribute(node, opts) {
	  assert("JSXSpreadAttribute", node, opts);
	}
	function assertJSXText(node, opts) {
	  assert("JSXText", node, opts);
	}
	function assertJSXFragment(node, opts) {
	  assert("JSXFragment", node, opts);
	}
	function assertJSXOpeningFragment(node, opts) {
	  assert("JSXOpeningFragment", node, opts);
	}
	function assertJSXClosingFragment(node, opts) {
	  assert("JSXClosingFragment", node, opts);
	}
	function assertNoop(node, opts) {
	  assert("Noop", node, opts);
	}
	function assertPlaceholder(node, opts) {
	  assert("Placeholder", node, opts);
	}
	function assertV8IntrinsicIdentifier(node, opts) {
	  assert("V8IntrinsicIdentifier", node, opts);
	}
	function assertArgumentPlaceholder(node, opts) {
	  assert("ArgumentPlaceholder", node, opts);
	}
	function assertBindExpression(node, opts) {
	  assert("BindExpression", node, opts);
	}
	function assertImportAttribute(node, opts) {
	  assert("ImportAttribute", node, opts);
	}
	function assertDecorator(node, opts) {
	  assert("Decorator", node, opts);
	}
	function assertDoExpression(node, opts) {
	  assert("DoExpression", node, opts);
	}
	function assertExportDefaultSpecifier(node, opts) {
	  assert("ExportDefaultSpecifier", node, opts);
	}
	function assertRecordExpression(node, opts) {
	  assert("RecordExpression", node, opts);
	}
	function assertTupleExpression(node, opts) {
	  assert("TupleExpression", node, opts);
	}
	function assertDecimalLiteral(node, opts) {
	  assert("DecimalLiteral", node, opts);
	}
	function assertModuleExpression(node, opts) {
	  assert("ModuleExpression", node, opts);
	}
	function assertTopicReference(node, opts) {
	  assert("TopicReference", node, opts);
	}
	function assertPipelineTopicExpression(node, opts) {
	  assert("PipelineTopicExpression", node, opts);
	}
	function assertPipelineBareFunction(node, opts) {
	  assert("PipelineBareFunction", node, opts);
	}
	function assertPipelinePrimaryTopicReference(node, opts) {
	  assert("PipelinePrimaryTopicReference", node, opts);
	}
	function assertTSParameterProperty(node, opts) {
	  assert("TSParameterProperty", node, opts);
	}
	function assertTSDeclareFunction(node, opts) {
	  assert("TSDeclareFunction", node, opts);
	}
	function assertTSDeclareMethod(node, opts) {
	  assert("TSDeclareMethod", node, opts);
	}
	function assertTSQualifiedName(node, opts) {
	  assert("TSQualifiedName", node, opts);
	}
	function assertTSCallSignatureDeclaration(node, opts) {
	  assert("TSCallSignatureDeclaration", node, opts);
	}
	function assertTSConstructSignatureDeclaration(node, opts) {
	  assert("TSConstructSignatureDeclaration", node, opts);
	}
	function assertTSPropertySignature(node, opts) {
	  assert("TSPropertySignature", node, opts);
	}
	function assertTSMethodSignature(node, opts) {
	  assert("TSMethodSignature", node, opts);
	}
	function assertTSIndexSignature(node, opts) {
	  assert("TSIndexSignature", node, opts);
	}
	function assertTSAnyKeyword(node, opts) {
	  assert("TSAnyKeyword", node, opts);
	}
	function assertTSBooleanKeyword(node, opts) {
	  assert("TSBooleanKeyword", node, opts);
	}
	function assertTSBigIntKeyword(node, opts) {
	  assert("TSBigIntKeyword", node, opts);
	}
	function assertTSIntrinsicKeyword(node, opts) {
	  assert("TSIntrinsicKeyword", node, opts);
	}
	function assertTSNeverKeyword(node, opts) {
	  assert("TSNeverKeyword", node, opts);
	}
	function assertTSNullKeyword(node, opts) {
	  assert("TSNullKeyword", node, opts);
	}
	function assertTSNumberKeyword(node, opts) {
	  assert("TSNumberKeyword", node, opts);
	}
	function assertTSObjectKeyword(node, opts) {
	  assert("TSObjectKeyword", node, opts);
	}
	function assertTSStringKeyword(node, opts) {
	  assert("TSStringKeyword", node, opts);
	}
	function assertTSSymbolKeyword(node, opts) {
	  assert("TSSymbolKeyword", node, opts);
	}
	function assertTSUndefinedKeyword(node, opts) {
	  assert("TSUndefinedKeyword", node, opts);
	}
	function assertTSUnknownKeyword(node, opts) {
	  assert("TSUnknownKeyword", node, opts);
	}
	function assertTSVoidKeyword(node, opts) {
	  assert("TSVoidKeyword", node, opts);
	}
	function assertTSThisType(node, opts) {
	  assert("TSThisType", node, opts);
	}
	function assertTSFunctionType(node, opts) {
	  assert("TSFunctionType", node, opts);
	}
	function assertTSConstructorType(node, opts) {
	  assert("TSConstructorType", node, opts);
	}
	function assertTSTypeReference(node, opts) {
	  assert("TSTypeReference", node, opts);
	}
	function assertTSTypePredicate(node, opts) {
	  assert("TSTypePredicate", node, opts);
	}
	function assertTSTypeQuery(node, opts) {
	  assert("TSTypeQuery", node, opts);
	}
	function assertTSTypeLiteral(node, opts) {
	  assert("TSTypeLiteral", node, opts);
	}
	function assertTSArrayType(node, opts) {
	  assert("TSArrayType", node, opts);
	}
	function assertTSTupleType(node, opts) {
	  assert("TSTupleType", node, opts);
	}
	function assertTSOptionalType(node, opts) {
	  assert("TSOptionalType", node, opts);
	}
	function assertTSRestType(node, opts) {
	  assert("TSRestType", node, opts);
	}
	function assertTSNamedTupleMember(node, opts) {
	  assert("TSNamedTupleMember", node, opts);
	}
	function assertTSUnionType(node, opts) {
	  assert("TSUnionType", node, opts);
	}
	function assertTSIntersectionType(node, opts) {
	  assert("TSIntersectionType", node, opts);
	}
	function assertTSConditionalType(node, opts) {
	  assert("TSConditionalType", node, opts);
	}
	function assertTSInferType(node, opts) {
	  assert("TSInferType", node, opts);
	}
	function assertTSParenthesizedType(node, opts) {
	  assert("TSParenthesizedType", node, opts);
	}
	function assertTSTypeOperator(node, opts) {
	  assert("TSTypeOperator", node, opts);
	}
	function assertTSIndexedAccessType(node, opts) {
	  assert("TSIndexedAccessType", node, opts);
	}
	function assertTSMappedType(node, opts) {
	  assert("TSMappedType", node, opts);
	}
	function assertTSLiteralType(node, opts) {
	  assert("TSLiteralType", node, opts);
	}
	function assertTSExpressionWithTypeArguments(node, opts) {
	  assert("TSExpressionWithTypeArguments", node, opts);
	}
	function assertTSInterfaceDeclaration(node, opts) {
	  assert("TSInterfaceDeclaration", node, opts);
	}
	function assertTSInterfaceBody(node, opts) {
	  assert("TSInterfaceBody", node, opts);
	}
	function assertTSTypeAliasDeclaration(node, opts) {
	  assert("TSTypeAliasDeclaration", node, opts);
	}
	function assertTSInstantiationExpression(node, opts) {
	  assert("TSInstantiationExpression", node, opts);
	}
	function assertTSAsExpression(node, opts) {
	  assert("TSAsExpression", node, opts);
	}
	function assertTSSatisfiesExpression(node, opts) {
	  assert("TSSatisfiesExpression", node, opts);
	}
	function assertTSTypeAssertion(node, opts) {
	  assert("TSTypeAssertion", node, opts);
	}
	function assertTSEnumDeclaration(node, opts) {
	  assert("TSEnumDeclaration", node, opts);
	}
	function assertTSEnumMember(node, opts) {
	  assert("TSEnumMember", node, opts);
	}
	function assertTSModuleDeclaration(node, opts) {
	  assert("TSModuleDeclaration", node, opts);
	}
	function assertTSModuleBlock(node, opts) {
	  assert("TSModuleBlock", node, opts);
	}
	function assertTSImportType(node, opts) {
	  assert("TSImportType", node, opts);
	}
	function assertTSImportEqualsDeclaration(node, opts) {
	  assert("TSImportEqualsDeclaration", node, opts);
	}
	function assertTSExternalModuleReference(node, opts) {
	  assert("TSExternalModuleReference", node, opts);
	}
	function assertTSNonNullExpression(node, opts) {
	  assert("TSNonNullExpression", node, opts);
	}
	function assertTSExportAssignment(node, opts) {
	  assert("TSExportAssignment", node, opts);
	}
	function assertTSNamespaceExportDeclaration(node, opts) {
	  assert("TSNamespaceExportDeclaration", node, opts);
	}
	function assertTSTypeAnnotation(node, opts) {
	  assert("TSTypeAnnotation", node, opts);
	}
	function assertTSTypeParameterInstantiation(node, opts) {
	  assert("TSTypeParameterInstantiation", node, opts);
	}
	function assertTSTypeParameterDeclaration(node, opts) {
	  assert("TSTypeParameterDeclaration", node, opts);
	}
	function assertTSTypeParameter(node, opts) {
	  assert("TSTypeParameter", node, opts);
	}
	function assertStandardized(node, opts) {
	  assert("Standardized", node, opts);
	}
	function assertExpression(node, opts) {
	  assert("Expression", node, opts);
	}
	function assertBinary(node, opts) {
	  assert("Binary", node, opts);
	}
	function assertScopable(node, opts) {
	  assert("Scopable", node, opts);
	}
	function assertBlockParent(node, opts) {
	  assert("BlockParent", node, opts);
	}
	function assertBlock(node, opts) {
	  assert("Block", node, opts);
	}
	function assertStatement(node, opts) {
	  assert("Statement", node, opts);
	}
	function assertTerminatorless(node, opts) {
	  assert("Terminatorless", node, opts);
	}
	function assertCompletionStatement(node, opts) {
	  assert("CompletionStatement", node, opts);
	}
	function assertConditional(node, opts) {
	  assert("Conditional", node, opts);
	}
	function assertLoop(node, opts) {
	  assert("Loop", node, opts);
	}
	function assertWhile(node, opts) {
	  assert("While", node, opts);
	}
	function assertExpressionWrapper(node, opts) {
	  assert("ExpressionWrapper", node, opts);
	}
	function assertFor(node, opts) {
	  assert("For", node, opts);
	}
	function assertForXStatement(node, opts) {
	  assert("ForXStatement", node, opts);
	}
	function assertFunction(node, opts) {
	  assert("Function", node, opts);
	}
	function assertFunctionParent(node, opts) {
	  assert("FunctionParent", node, opts);
	}
	function assertPureish(node, opts) {
	  assert("Pureish", node, opts);
	}
	function assertDeclaration(node, opts) {
	  assert("Declaration", node, opts);
	}
	function assertPatternLike(node, opts) {
	  assert("PatternLike", node, opts);
	}
	function assertLVal(node, opts) {
	  assert("LVal", node, opts);
	}
	function assertTSEntityName(node, opts) {
	  assert("TSEntityName", node, opts);
	}
	function assertLiteral(node, opts) {
	  assert("Literal", node, opts);
	}
	function assertImmutable(node, opts) {
	  assert("Immutable", node, opts);
	}
	function assertUserWhitespacable(node, opts) {
	  assert("UserWhitespacable", node, opts);
	}
	function assertMethod(node, opts) {
	  assert("Method", node, opts);
	}
	function assertObjectMember(node, opts) {
	  assert("ObjectMember", node, opts);
	}
	function assertProperty(node, opts) {
	  assert("Property", node, opts);
	}
	function assertUnaryLike(node, opts) {
	  assert("UnaryLike", node, opts);
	}
	function assertPattern(node, opts) {
	  assert("Pattern", node, opts);
	}
	function assertClass(node, opts) {
	  assert("Class", node, opts);
	}
	function assertImportOrExportDeclaration(node, opts) {
	  assert("ImportOrExportDeclaration", node, opts);
	}
	function assertExportDeclaration(node, opts) {
	  assert("ExportDeclaration", node, opts);
	}
	function assertModuleSpecifier(node, opts) {
	  assert("ModuleSpecifier", node, opts);
	}
	function assertAccessor(node, opts) {
	  assert("Accessor", node, opts);
	}
	function assertPrivate(node, opts) {
	  assert("Private", node, opts);
	}
	function assertFlow(node, opts) {
	  assert("Flow", node, opts);
	}
	function assertFlowType(node, opts) {
	  assert("FlowType", node, opts);
	}
	function assertFlowBaseAnnotation(node, opts) {
	  assert("FlowBaseAnnotation", node, opts);
	}
	function assertFlowDeclaration(node, opts) {
	  assert("FlowDeclaration", node, opts);
	}
	function assertFlowPredicate(node, opts) {
	  assert("FlowPredicate", node, opts);
	}
	function assertEnumBody(node, opts) {
	  assert("EnumBody", node, opts);
	}
	function assertEnumMember(node, opts) {
	  assert("EnumMember", node, opts);
	}
	function assertJSX(node, opts) {
	  assert("JSX", node, opts);
	}
	function assertMiscellaneous(node, opts) {
	  assert("Miscellaneous", node, opts);
	}
	function assertTypeScript(node, opts) {
	  assert("TypeScript", node, opts);
	}
	function assertTSTypeElement(node, opts) {
	  assert("TSTypeElement", node, opts);
	}
	function assertTSType(node, opts) {
	  assert("TSType", node, opts);
	}
	function assertTSBaseType(node, opts) {
	  assert("TSBaseType", node, opts);
	}
	function assertNumberLiteral(node, opts) {
	  (0, _deprecationWarning.default)("assertNumberLiteral", "assertNumericLiteral");
	  assert("NumberLiteral", node, opts);
	}
	function assertRegexLiteral(node, opts) {
	  (0, _deprecationWarning.default)("assertRegexLiteral", "assertRegExpLiteral");
	  assert("RegexLiteral", node, opts);
	}
	function assertRestProperty(node, opts) {
	  (0, _deprecationWarning.default)("assertRestProperty", "assertRestElement");
	  assert("RestProperty", node, opts);
	}
	function assertSpreadProperty(node, opts) {
	  (0, _deprecationWarning.default)("assertSpreadProperty", "assertSpreadElement");
	  assert("SpreadProperty", node, opts);
	}
	function assertModuleDeclaration(node, opts) {
	  (0, _deprecationWarning.default)("assertModuleDeclaration", "assertImportOrExportDeclaration");
	  assert("ModuleDeclaration", node, opts);
	}

	
	return generated$1;
}

var createTypeAnnotationBasedOnTypeof = {};

var hasRequiredCreateTypeAnnotationBasedOnTypeof;

function requireCreateTypeAnnotationBasedOnTypeof () {
	if (hasRequiredCreateTypeAnnotationBasedOnTypeof) return createTypeAnnotationBasedOnTypeof;
	hasRequiredCreateTypeAnnotationBasedOnTypeof = 1;

	Object.defineProperty(createTypeAnnotationBasedOnTypeof, "__esModule", {
	  value: true
	});
	createTypeAnnotationBasedOnTypeof.default = void 0;
	var _index = requireGenerated$2();
	createTypeAnnotationBasedOnTypeof.default = createTypeAnnotationBasedOnTypeof$1;
	function createTypeAnnotationBasedOnTypeof$1(type) {
	  switch (type) {
	    case "string":
	      return (0, _index.stringTypeAnnotation)();
	    case "number":
	      return (0, _index.numberTypeAnnotation)();
	    case "undefined":
	      return (0, _index.voidTypeAnnotation)();
	    case "boolean":
	      return (0, _index.booleanTypeAnnotation)();
	    case "function":
	      return (0, _index.genericTypeAnnotation)((0, _index.identifier)("Function"));
	    case "object":
	      return (0, _index.genericTypeAnnotation)((0, _index.identifier)("Object"));
	    case "symbol":
	      return (0, _index.genericTypeAnnotation)((0, _index.identifier)("Symbol"));
	    case "bigint":
	      return (0, _index.anyTypeAnnotation)();
	  }
	  throw new Error("Invalid typeof value: " + type);
	}

	
	return createTypeAnnotationBasedOnTypeof;
}

var createFlowUnionType = {};

var removeTypeDuplicates$1 = {};

var hasRequiredRemoveTypeDuplicates$1;

function requireRemoveTypeDuplicates$1 () {
	if (hasRequiredRemoveTypeDuplicates$1) return removeTypeDuplicates$1;
	hasRequiredRemoveTypeDuplicates$1 = 1;

	Object.defineProperty(removeTypeDuplicates$1, "__esModule", {
	  value: true
	});
	removeTypeDuplicates$1.default = removeTypeDuplicates;
	var _index = requireGenerated$3();
	function getQualifiedName(node) {
	  return (0, _index.isIdentifier)(node) ? node.name : `${node.id.name}.${getQualifiedName(node.qualification)}`;
	}
	function removeTypeDuplicates(nodesIn) {
	  const nodes = Array.from(nodesIn);
	  const generics = new Map();
	  const bases = new Map();
	  const typeGroups = new Set();
	  const types = [];
	  for (let i = 0; i < nodes.length; i++) {
	    const node = nodes[i];
	    if (!node) continue;
	    if (types.indexOf(node) >= 0) {
	      continue;
	    }
	    if ((0, _index.isAnyTypeAnnotation)(node)) {
	      return [node];
	    }
	    if ((0, _index.isFlowBaseAnnotation)(node)) {
	      bases.set(node.type, node);
	      continue;
	    }
	    if ((0, _index.isUnionTypeAnnotation)(node)) {
	      if (!typeGroups.has(node.types)) {
	        nodes.push(...node.types);
	        typeGroups.add(node.types);
	      }
	      continue;
	    }
	    if ((0, _index.isGenericTypeAnnotation)(node)) {
	      const name = getQualifiedName(node.id);
	      if (generics.has(name)) {
	        let existing = generics.get(name);
	        if (existing.typeParameters) {
	          if (node.typeParameters) {
	            existing.typeParameters.params.push(...node.typeParameters.params);
	            existing.typeParameters.params = removeTypeDuplicates(existing.typeParameters.params);
	          }
	        } else {
	          existing = node.typeParameters;
	        }
	      } else {
	        generics.set(name, node);
	      }
	      continue;
	    }
	    types.push(node);
	  }
	  for (const [, baseType] of bases) {
	    types.push(baseType);
	  }
	  for (const [, genericName] of generics) {
	    types.push(genericName);
	  }
	  return types;
	}

	
	return removeTypeDuplicates$1;
}

var hasRequiredCreateFlowUnionType;

function requireCreateFlowUnionType () {
	if (hasRequiredCreateFlowUnionType) return createFlowUnionType;
	hasRequiredCreateFlowUnionType = 1;

	Object.defineProperty(createFlowUnionType, "__esModule", {
	  value: true
	});
	createFlowUnionType.default = createFlowUnionType$1;
	var _index = requireGenerated$2();
	var _removeTypeDuplicates = requireRemoveTypeDuplicates$1();
	function createFlowUnionType$1(types) {
	  const flattened = (0, _removeTypeDuplicates.default)(types);
	  if (flattened.length === 1) {
	    return flattened[0];
	  } else {
	    return (0, _index.unionTypeAnnotation)(flattened);
	  }
	}

	
	return createFlowUnionType;
}

var createTSUnionType = {};

var removeTypeDuplicates = {};

var hasRequiredRemoveTypeDuplicates;

function requireRemoveTypeDuplicates () {
	if (hasRequiredRemoveTypeDuplicates) return removeTypeDuplicates;
	hasRequiredRemoveTypeDuplicates = 1;

	Object.defineProperty(removeTypeDuplicates, "__esModule", {
	  value: true
	});
	removeTypeDuplicates.default = removeTypeDuplicates$1;
	var _index = requireGenerated$3();
	function getQualifiedName(node) {
	  return (0, _index.isIdentifier)(node) ? node.name : `${node.right.name}.${getQualifiedName(node.left)}`;
	}
	function removeTypeDuplicates$1(nodesIn) {
	  const nodes = Array.from(nodesIn);
	  const generics = new Map();
	  const bases = new Map();
	  const typeGroups = new Set();
	  const types = [];
	  for (let i = 0; i < nodes.length; i++) {
	    const node = nodes[i];
	    if (!node) continue;
	    if (types.indexOf(node) >= 0) {
	      continue;
	    }
	    if ((0, _index.isTSAnyKeyword)(node)) {
	      return [node];
	    }
	    if ((0, _index.isTSBaseType)(node)) {
	      bases.set(node.type, node);
	      continue;
	    }
	    if ((0, _index.isTSUnionType)(node)) {
	      if (!typeGroups.has(node.types)) {
	        nodes.push(...node.types);
	        typeGroups.add(node.types);
	      }
	      continue;
	    }
	    if ((0, _index.isTSTypeReference)(node) && node.typeParameters) {
	      const name = getQualifiedName(node.typeName);
	      if (generics.has(name)) {
	        let existing = generics.get(name);
	        if (existing.typeParameters) {
	          if (node.typeParameters) {
	            existing.typeParameters.params.push(...node.typeParameters.params);
	            existing.typeParameters.params = removeTypeDuplicates$1(existing.typeParameters.params);
	          }
	        } else {
	          existing = node.typeParameters;
	        }
	      } else {
	        generics.set(name, node);
	      }
	      continue;
	    }
	    types.push(node);
	  }
	  for (const [, baseType] of bases) {
	    types.push(baseType);
	  }
	  for (const [, genericName] of generics) {
	    types.push(genericName);
	  }
	  return types;
	}

	
	return removeTypeDuplicates;
}

var hasRequiredCreateTSUnionType;

function requireCreateTSUnionType () {
	if (hasRequiredCreateTSUnionType) return createTSUnionType;
	hasRequiredCreateTSUnionType = 1;

	Object.defineProperty(createTSUnionType, "__esModule", {
	  value: true
	});
	createTSUnionType.default = createTSUnionType$1;
	var _index = requireGenerated$2();
	var _removeTypeDuplicates = requireRemoveTypeDuplicates();
	var _index2 = requireGenerated$3();
	function createTSUnionType$1(typeAnnotations) {
	  const types = typeAnnotations.map(type => {
	    return (0, _index2.isTSTypeAnnotation)(type) ? type.typeAnnotation : type;
	  });
	  const flattened = (0, _removeTypeDuplicates.default)(types);
	  if (flattened.length === 1) {
	    return flattened[0];
	  } else {
	    return (0, _index.tsUnionType)(flattened);
	  }
	}

	
	return createTSUnionType;
}

var uppercase = {};

var hasRequiredUppercase;

function requireUppercase () {
	if (hasRequiredUppercase) return uppercase;
	hasRequiredUppercase = 1;
	(function (exports) {

		Object.defineProperty(exports, "__esModule", {
		  value: true
		});
		Object.defineProperty(exports, "AnyTypeAnnotation", {
		  enumerable: true,
		  get: function () {
		    return _index.anyTypeAnnotation;
		  }
		});
		Object.defineProperty(exports, "ArgumentPlaceholder", {
		  enumerable: true,
		  get: function () {
		    return _index.argumentPlaceholder;
		  }
		});
		Object.defineProperty(exports, "ArrayExpression", {
		  enumerable: true,
		  get: function () {
		    return _index.arrayExpression;
		  }
		});
		Object.defineProperty(exports, "ArrayPattern", {
		  enumerable: true,
		  get: function () {
		    return _index.arrayPattern;
		  }
		});
		Object.defineProperty(exports, "ArrayTypeAnnotation", {
		  enumerable: true,
		  get: function () {
		    return _index.arrayTypeAnnotation;
		  }
		});
		Object.defineProperty(exports, "ArrowFunctionExpression", {
		  enumerable: true,
		  get: function () {
		    return _index.arrowFunctionExpression;
		  }
		});
		Object.defineProperty(exports, "AssignmentExpression", {
		  enumerable: true,
		  get: function () {
		    return _index.assignmentExpression;
		  }
		});
		Object.defineProperty(exports, "AssignmentPattern", {
		  enumerable: true,
		  get: function () {
		    return _index.assignmentPattern;
		  }
		});
		Object.defineProperty(exports, "AwaitExpression", {
		  enumerable: true,
		  get: function () {
		    return _index.awaitExpression;
		  }
		});
		Object.defineProperty(exports, "BigIntLiteral", {
		  enumerable: true,
		  get: function () {
		    return _index.bigIntLiteral;
		  }
		});
		Object.defineProperty(exports, "BinaryExpression", {
		  enumerable: true,
		  get: function () {
		    return _index.binaryExpression;
		  }
		});
		Object.defineProperty(exports, "BindExpression", {
		  enumerable: true,
		  get: function () {
		    return _index.bindExpression;
		  }
		});
		Object.defineProperty(exports, "BlockStatement", {
		  enumerable: true,
		  get: function () {
		    return _index.blockStatement;
		  }
		});
		Object.defineProperty(exports, "BooleanLiteral", {
		  enumerable: true,
		  get: function () {
		    return _index.booleanLiteral;
		  }
		});
		Object.defineProperty(exports, "BooleanLiteralTypeAnnotation", {
		  enumerable: true,
		  get: function () {
		    return _index.booleanLiteralTypeAnnotation;
		  }
		});
		Object.defineProperty(exports, "BooleanTypeAnnotation", {
		  enumerable: true,
		  get: function () {
		    return _index.booleanTypeAnnotation;
		  }
		});
		Object.defineProperty(exports, "BreakStatement", {
		  enumerable: true,
		  get: function () {
		    return _index.breakStatement;
		  }
		});
		Object.defineProperty(exports, "CallExpression", {
		  enumerable: true,
		  get: function () {
		    return _index.callExpression;
		  }
		});
		Object.defineProperty(exports, "CatchClause", {
		  enumerable: true,
		  get: function () {
		    return _index.catchClause;
		  }
		});
		Object.defineProperty(exports, "ClassAccessorProperty", {
		  enumerable: true,
		  get: function () {
		    return _index.classAccessorProperty;
		  }
		});
		Object.defineProperty(exports, "ClassBody", {
		  enumerable: true,
		  get: function () {
		    return _index.classBody;
		  }
		});
		Object.defineProperty(exports, "ClassDeclaration", {
		  enumerable: true,
		  get: function () {
		    return _index.classDeclaration;
		  }
		});
		Object.defineProperty(exports, "ClassExpression", {
		  enumerable: true,
		  get: function () {
		    return _index.classExpression;
		  }
		});
		Object.defineProperty(exports, "ClassImplements", {
		  enumerable: true,
		  get: function () {
		    return _index.classImplements;
		  }
		});
		Object.defineProperty(exports, "ClassMethod", {
		  enumerable: true,
		  get: function () {
		    return _index.classMethod;
		  }
		});
		Object.defineProperty(exports, "ClassPrivateMethod", {
		  enumerable: true,
		  get: function () {
		    return _index.classPrivateMethod;
		  }
		});
		Object.defineProperty(exports, "ClassPrivateProperty", {
		  enumerable: true,
		  get: function () {
		    return _index.classPrivateProperty;
		  }
		});
		Object.defineProperty(exports, "ClassProperty", {
		  enumerable: true,
		  get: function () {
		    return _index.classProperty;
		  }
		});
		Object.defineProperty(exports, "ConditionalExpression", {
		  enumerable: true,
		  get: function () {
		    return _index.conditionalExpression;
		  }
		});
		Object.defineProperty(exports, "ContinueStatement", {
		  enumerable: true,
		  get: function () {
		    return _index.continueStatement;
		  }
		});
		Object.defineProperty(exports, "DebuggerStatement", {
		  enumerable: true,
		  get: function () {
		    return _index.debuggerStatement;
		  }
		});
		Object.defineProperty(exports, "DecimalLiteral", {
		  enumerable: true,
		  get: function () {
		    return _index.decimalLiteral;
		  }
		});
		Object.defineProperty(exports, "DeclareClass", {
		  enumerable: true,
		  get: function () {
		    return _index.declareClass;
		  }
		});
		Object.defineProperty(exports, "DeclareExportAllDeclaration", {
		  enumerable: true,
		  get: function () {
		    return _index.declareExportAllDeclaration;
		  }
		});
		Object.defineProperty(exports, "DeclareExportDeclaration", {
		  enumerable: true,
		  get: function () {
		    return _index.declareExportDeclaration;
		  }
		});
		Object.defineProperty(exports, "DeclareFunction", {
		  enumerable: true,
		  get: function () {
		    return _index.declareFunction;
		  }
		});
		Object.defineProperty(exports, "DeclareInterface", {
		  enumerable: true,
		  get: function () {
		    return _index.declareInterface;
		  }
		});
		Object.defineProperty(exports, "DeclareModule", {
		  enumerable: true,
		  get: function () {
		    return _index.declareModule;
		  }
		});
		Object.defineProperty(exports, "DeclareModuleExports", {
		  enumerable: true,
		  get: function () {
		    return _index.declareModuleExports;
		  }
		});
		Object.defineProperty(exports, "DeclareOpaqueType", {
		  enumerable: true,
		  get: function () {
		    return _index.declareOpaqueType;
		  }
		});
		Object.defineProperty(exports, "DeclareTypeAlias", {
		  enumerable: true,
		  get: function () {
		    return _index.declareTypeAlias;
		  }
		});
		Object.defineProperty(exports, "DeclareVariable", {
		  enumerable: true,
		  get: function () {
		    return _index.declareVariable;
		  }
		});
		Object.defineProperty(exports, "DeclaredPredicate", {
		  enumerable: true,
		  get: function () {
		    return _index.declaredPredicate;
		  }
		});
		Object.defineProperty(exports, "Decorator", {
		  enumerable: true,
		  get: function () {
		    return _index.decorator;
		  }
		});
		Object.defineProperty(exports, "Directive", {
		  enumerable: true,
		  get: function () {
		    return _index.directive;
		  }
		});
		Object.defineProperty(exports, "DirectiveLiteral", {
		  enumerable: true,
		  get: function () {
		    return _index.directiveLiteral;
		  }
		});
		Object.defineProperty(exports, "DoExpression", {
		  enumerable: true,
		  get: function () {
		    return _index.doExpression;
		  }
		});
		Object.defineProperty(exports, "DoWhileStatement", {
		  enumerable: true,
		  get: function () {
		    return _index.doWhileStatement;
		  }
		});
		Object.defineProperty(exports, "EmptyStatement", {
		  enumerable: true,
		  get: function () {
		    return _index.emptyStatement;
		  }
		});
		Object.defineProperty(exports, "EmptyTypeAnnotation", {
		  enumerable: true,
		  get: function () {
		    return _index.emptyTypeAnnotation;
		  }
		});
		Object.defineProperty(exports, "EnumBooleanBody", {
		  enumerable: true,
		  get: function () {
		    return _index.enumBooleanBody;
		  }
		});
		Object.defineProperty(exports, "EnumBooleanMember", {
		  enumerable: true,
		  get: function () {
		    return _index.enumBooleanMember;
		  }
		});
		Object.defineProperty(exports, "EnumDeclaration", {
		  enumerable: true,
		  get: function () {
		    return _index.enumDeclaration;
		  }
		});
		Object.defineProperty(exports, "EnumDefaultedMember", {
		  enumerable: true,
		  get: function () {
		    return _index.enumDefaultedMember;
		  }
		});
		Object.defineProperty(exports, "EnumNumberBody", {
		  enumerable: true,
		  get: function () {
		    return _index.enumNumberBody;
		  }
		});
		Object.defineProperty(exports, "EnumNumberMember", {
		  enumerable: true,
		  get: function () {
		    return _index.enumNumberMember;
		  }
		});
		Object.defineProperty(exports, "EnumStringBody", {
		  enumerable: true,
		  get: function () {
		    return _index.enumStringBody;
		  }
		});
		Object.defineProperty(exports, "EnumStringMember", {
		  enumerable: true,
		  get: function () {
		    return _index.enumStringMember;
		  }
		});
		Object.defineProperty(exports, "EnumSymbolBody", {
		  enumerable: true,
		  get: function () {
		    return _index.enumSymbolBody;
		  }
		});
		Object.defineProperty(exports, "ExistsTypeAnnotation", {
		  enumerable: true,
		  get: function () {
		    return _index.existsTypeAnnotation;
		  }
		});
		Object.defineProperty(exports, "ExportAllDeclaration", {
		  enumerable: true,
		  get: function () {
		    return _index.exportAllDeclaration;
		  }
		});
		Object.defineProperty(exports, "ExportDefaultDeclaration", {
		  enumerable: true,
		  get: function () {
		    return _index.exportDefaultDeclaration;
		  }
		});
		Object.defineProperty(exports, "ExportDefaultSpecifier", {
		  enumerable: true,
		  get: function () {
		    return _index.exportDefaultSpecifier;
		  }
		});
		Object.defineProperty(exports, "ExportNamedDeclaration", {
		  enumerable: true,
		  get: function () {
		    return _index.exportNamedDeclaration;
		  }
		});
		Object.defineProperty(exports, "ExportNamespaceSpecifier", {
		  enumerable: true,
		  get: function () {
		    return _index.exportNamespaceSpecifier;
		  }
		});
		Object.defineProperty(exports, "ExportSpecifier", {
		  enumerable: true,
		  get: function () {
		    return _index.exportSpecifier;
		  }
		});
		Object.defineProperty(exports, "ExpressionStatement", {
		  enumerable: true,
		  get: function () {
		    return _index.expressionStatement;
		  }
		});
		Object.defineProperty(exports, "File", {
		  enumerable: true,
		  get: function () {
		    return _index.file;
		  }
		});
		Object.defineProperty(exports, "ForInStatement", {
		  enumerable: true,
		  get: function () {
		    return _index.forInStatement;
		  }
		});
		Object.defineProperty(exports, "ForOfStatement", {
		  enumerable: true,
		  get: function () {
		    return _index.forOfStatement;
		  }
		});
		Object.defineProperty(exports, "ForStatement", {
		  enumerable: true,
		  get: function () {
		    return _index.forStatement;
		  }
		});
		Object.defineProperty(exports, "FunctionDeclaration", {
		  enumerable: true,
		  get: function () {
		    return _index.functionDeclaration;
		  }
		});
		Object.defineProperty(exports, "FunctionExpression", {
		  enumerable: true,
		  get: function () {
		    return _index.functionExpression;
		  }
		});
		Object.defineProperty(exports, "FunctionTypeAnnotation", {
		  enumerable: true,
		  get: function () {
		    return _index.functionTypeAnnotation;
		  }
		});
		Object.defineProperty(exports, "FunctionTypeParam", {
		  enumerable: true,
		  get: function () {
		    return _index.functionTypeParam;
		  }
		});
		Object.defineProperty(exports, "GenericTypeAnnotation", {
		  enumerable: true,
		  get: function () {
		    return _index.genericTypeAnnotation;
		  }
		});
		Object.defineProperty(exports, "Identifier", {
		  enumerable: true,
		  get: function () {
		    return _index.identifier;
		  }
		});
		Object.defineProperty(exports, "IfStatement", {
		  enumerable: true,
		  get: function () {
		    return _index.ifStatement;
		  }
		});
		Object.defineProperty(exports, "Import", {
		  enumerable: true,
		  get: function () {
		    return _index.import;
		  }
		});
		Object.defineProperty(exports, "ImportAttribute", {
		  enumerable: true,
		  get: function () {
		    return _index.importAttribute;
		  }
		});
		Object.defineProperty(exports, "ImportDeclaration", {
		  enumerable: true,
		  get: function () {
		    return _index.importDeclaration;
		  }
		});
		Object.defineProperty(exports, "ImportDefaultSpecifier", {
		  enumerable: true,
		  get: function () {
		    return _index.importDefaultSpecifier;
		  }
		});
		Object.defineProperty(exports, "ImportExpression", {
		  enumerable: true,
		  get: function () {
		    return _index.importExpression;
		  }
		});
		Object.defineProperty(exports, "ImportNamespaceSpecifier", {
		  enumerable: true,
		  get: function () {
		    return _index.importNamespaceSpecifier;
		  }
		});
		Object.defineProperty(exports, "ImportSpecifier", {
		  enumerable: true,
		  get: function () {
		    return _index.importSpecifier;
		  }
		});
		Object.defineProperty(exports, "IndexedAccessType", {
		  enumerable: true,
		  get: function () {
		    return _index.indexedAccessType;
		  }
		});
		Object.defineProperty(exports, "InferredPredicate", {
		  enumerable: true,
		  get: function () {
		    return _index.inferredPredicate;
		  }
		});
		Object.defineProperty(exports, "InterfaceDeclaration", {
		  enumerable: true,
		  get: function () {
		    return _index.interfaceDeclaration;
		  }
		});
		Object.defineProperty(exports, "InterfaceExtends", {
		  enumerable: true,
		  get: function () {
		    return _index.interfaceExtends;
		  }
		});
		Object.defineProperty(exports, "InterfaceTypeAnnotation", {
		  enumerable: true,
		  get: function () {
		    return _index.interfaceTypeAnnotation;
		  }
		});
		Object.defineProperty(exports, "InterpreterDirective", {
		  enumerable: true,
		  get: function () {
		    return _index.interpreterDirective;
		  }
		});
		Object.defineProperty(exports, "IntersectionTypeAnnotation", {
		  enumerable: true,
		  get: function () {
		    return _index.intersectionTypeAnnotation;
		  }
		});
		Object.defineProperty(exports, "JSXAttribute", {
		  enumerable: true,
		  get: function () {
		    return _index.jsxAttribute;
		  }
		});
		Object.defineProperty(exports, "JSXClosingElement", {
		  enumerable: true,
		  get: function () {
		    return _index.jsxClosingElement;
		  }
		});
		Object.defineProperty(exports, "JSXClosingFragment", {
		  enumerable: true,
		  get: function () {
		    return _index.jsxClosingFragment;
		  }
		});
		Object.defineProperty(exports, "JSXElement", {
		  enumerable: true,
		  get: function () {
		    return _index.jsxElement;
		  }
		});
		Object.defineProperty(exports, "JSXEmptyExpression", {
		  enumerable: true,
		  get: function () {
		    return _index.jsxEmptyExpression;
		  }
		});
		Object.defineProperty(exports, "JSXExpressionContainer", {
		  enumerable: true,
		  get: function () {
		    return _index.jsxExpressionContainer;
		  }
		});
		Object.defineProperty(exports, "JSXFragment", {
		  enumerable: true,
		  get: function () {
		    return _index.jsxFragment;
		  }
		});
		Object.defineProperty(exports, "JSXIdentifier", {
		  enumerable: true,
		  get: function () {
		    return _index.jsxIdentifier;
		  }
		});
		Object.defineProperty(exports, "JSXMemberExpression", {
		  enumerable: true,
		  get: function () {
		    return _index.jsxMemberExpression;
		  }
		});
		Object.defineProperty(exports, "JSXNamespacedName", {
		  enumerable: true,
		  get: function () {
		    return _index.jsxNamespacedName;
		  }
		});
		Object.defineProperty(exports, "JSXOpeningElement", {
		  enumerable: true,
		  get: function () {
		    return _index.jsxOpeningElement;
		  }
		});
		Object.defineProperty(exports, "JSXOpeningFragment", {
		  enumerable: true,
		  get: function () {
		    return _index.jsxOpeningFragment;
		  }
		});
		Object.defineProperty(exports, "JSXSpreadAttribute", {
		  enumerable: true,
		  get: function () {
		    return _index.jsxSpreadAttribute;
		  }
		});
		Object.defineProperty(exports, "JSXSpreadChild", {
		  enumerable: true,
		  get: function () {
		    return _index.jsxSpreadChild;
		  }
		});
		Object.defineProperty(exports, "JSXText", {
		  enumerable: true,
		  get: function () {
		    return _index.jsxText;
		  }
		});
		Object.defineProperty(exports, "LabeledStatement", {
		  enumerable: true,
		  get: function () {
		    return _index.labeledStatement;
		  }
		});
		Object.defineProperty(exports, "LogicalExpression", {
		  enumerable: true,
		  get: function () {
		    return _index.logicalExpression;
		  }
		});
		Object.defineProperty(exports, "MemberExpression", {
		  enumerable: true,
		  get: function () {
		    return _index.memberExpression;
		  }
		});
		Object.defineProperty(exports, "MetaProperty", {
		  enumerable: true,
		  get: function () {
		    return _index.metaProperty;
		  }
		});
		Object.defineProperty(exports, "MixedTypeAnnotation", {
		  enumerable: true,
		  get: function () {
		    return _index.mixedTypeAnnotation;
		  }
		});
		Object.defineProperty(exports, "ModuleExpression", {
		  enumerable: true,
		  get: function () {
		    return _index.moduleExpression;
		  }
		});
		Object.defineProperty(exports, "NewExpression", {
		  enumerable: true,
		  get: function () {
		    return _index.newExpression;
		  }
		});
		Object.defineProperty(exports, "Noop", {
		  enumerable: true,
		  get: function () {
		    return _index.noop;
		  }
		});
		Object.defineProperty(exports, "NullLiteral", {
		  enumerable: true,
		  get: function () {
		    return _index.nullLiteral;
		  }
		});
		Object.defineProperty(exports, "NullLiteralTypeAnnotation", {
		  enumerable: true,
		  get: function () {
		    return _index.nullLiteralTypeAnnotation;
		  }
		});
		Object.defineProperty(exports, "NullableTypeAnnotation", {
		  enumerable: true,
		  get: function () {
		    return _index.nullableTypeAnnotation;
		  }
		});
		Object.defineProperty(exports, "NumberLiteral", {
		  enumerable: true,
		  get: function () {
		    return _index.numberLiteral;
		  }
		});
		Object.defineProperty(exports, "NumberLiteralTypeAnnotation", {
		  enumerable: true,
		  get: function () {
		    return _index.numberLiteralTypeAnnotation;
		  }
		});
		Object.defineProperty(exports, "NumberTypeAnnotation", {
		  enumerable: true,
		  get: function () {
		    return _index.numberTypeAnnotation;
		  }
		});
		Object.defineProperty(exports, "NumericLiteral", {
		  enumerable: true,
		  get: function () {
		    return _index.numericLiteral;
		  }
		});
		Object.defineProperty(exports, "ObjectExpression", {
		  enumerable: true,
		  get: function () {
		    return _index.objectExpression;
		  }
		});
		Object.defineProperty(exports, "ObjectMethod", {
		  enumerable: true,
		  get: function () {
		    return _index.objectMethod;
		  }
		});
		Object.defineProperty(exports, "ObjectPattern", {
		  enumerable: true,
		  get: function () {
		    return _index.objectPattern;
		  }
		});
		Object.defineProperty(exports, "ObjectProperty", {
		  enumerable: true,
		  get: function () {
		    return _index.objectProperty;
		  }
		});
		Object.defineProperty(exports, "ObjectTypeAnnotation", {
		  enumerable: true,
		  get: function () {
		    return _index.objectTypeAnnotation;
		  }
		});
		Object.defineProperty(exports, "ObjectTypeCallProperty", {
		  enumerable: true,
		  get: function () {
		    return _index.objectTypeCallProperty;
		  }
		});
		Object.defineProperty(exports, "ObjectTypeIndexer", {
		  enumerable: true,
		  get: function () {
		    return _index.objectTypeIndexer;
		  }
		});
		Object.defineProperty(exports, "ObjectTypeInternalSlot", {
		  enumerable: true,
		  get: function () {
		    return _index.objectTypeInternalSlot;
		  }
		});
		Object.defineProperty(exports, "ObjectTypeProperty", {
		  enumerable: true,
		  get: function () {
		    return _index.objectTypeProperty;
		  }
		});
		Object.defineProperty(exports, "ObjectTypeSpreadProperty", {
		  enumerable: true,
		  get: function () {
		    return _index.objectTypeSpreadProperty;
		  }
		});
		Object.defineProperty(exports, "OpaqueType", {
		  enumerable: true,
		  get: function () {
		    return _index.opaqueType;
		  }
		});
		Object.defineProperty(exports, "OptionalCallExpression", {
		  enumerable: true,
		  get: function () {
		    return _index.optionalCallExpression;
		  }
		});
		Object.defineProperty(exports, "OptionalIndexedAccessType", {
		  enumerable: true,
		  get: function () {
		    return _index.optionalIndexedAccessType;
		  }
		});
		Object.defineProperty(exports, "OptionalMemberExpression", {
		  enumerable: true,
		  get: function () {
		    return _index.optionalMemberExpression;
		  }
		});
		Object.defineProperty(exports, "ParenthesizedExpression", {
		  enumerable: true,
		  get: function () {
		    return _index.parenthesizedExpression;
		  }
		});
		Object.defineProperty(exports, "PipelineBareFunction", {
		  enumerable: true,
		  get: function () {
		    return _index.pipelineBareFunction;
		  }
		});
		Object.defineProperty(exports, "PipelinePrimaryTopicReference", {
		  enumerable: true,
		  get: function () {
		    return _index.pipelinePrimaryTopicReference;
		  }
		});
		Object.defineProperty(exports, "PipelineTopicExpression", {
		  enumerable: true,
		  get: function () {
		    return _index.pipelineTopicExpression;
		  }
		});
		Object.defineProperty(exports, "Placeholder", {
		  enumerable: true,
		  get: function () {
		    return _index.placeholder;
		  }
		});
		Object.defineProperty(exports, "PrivateName", {
		  enumerable: true,
		  get: function () {
		    return _index.privateName;
		  }
		});
		Object.defineProperty(exports, "Program", {
		  enumerable: true,
		  get: function () {
		    return _index.program;
		  }
		});
		Object.defineProperty(exports, "QualifiedTypeIdentifier", {
		  enumerable: true,
		  get: function () {
		    return _index.qualifiedTypeIdentifier;
		  }
		});
		Object.defineProperty(exports, "RecordExpression", {
		  enumerable: true,
		  get: function () {
		    return _index.recordExpression;
		  }
		});
		Object.defineProperty(exports, "RegExpLiteral", {
		  enumerable: true,
		  get: function () {
		    return _index.regExpLiteral;
		  }
		});
		Object.defineProperty(exports, "RegexLiteral", {
		  enumerable: true,
		  get: function () {
		    return _index.regexLiteral;
		  }
		});
		Object.defineProperty(exports, "RestElement", {
		  enumerable: true,
		  get: function () {
		    return _index.restElement;
		  }
		});
		Object.defineProperty(exports, "RestProperty", {
		  enumerable: true,
		  get: function () {
		    return _index.restProperty;
		  }
		});
		Object.defineProperty(exports, "ReturnStatement", {
		  enumerable: true,
		  get: function () {
		    return _index.returnStatement;
		  }
		});
		Object.defineProperty(exports, "SequenceExpression", {
		  enumerable: true,
		  get: function () {
		    return _index.sequenceExpression;
		  }
		});
		Object.defineProperty(exports, "SpreadElement", {
		  enumerable: true,
		  get: function () {
		    return _index.spreadElement;
		  }
		});
		Object.defineProperty(exports, "SpreadProperty", {
		  enumerable: true,
		  get: function () {
		    return _index.spreadProperty;
		  }
		});
		Object.defineProperty(exports, "StaticBlock", {
		  enumerable: true,
		  get: function () {
		    return _index.staticBlock;
		  }
		});
		Object.defineProperty(exports, "StringLiteral", {
		  enumerable: true,
		  get: function () {
		    return _index.stringLiteral;
		  }
		});
		Object.defineProperty(exports, "StringLiteralTypeAnnotation", {
		  enumerable: true,
		  get: function () {
		    return _index.stringLiteralTypeAnnotation;
		  }
		});
		Object.defineProperty(exports, "StringTypeAnnotation", {
		  enumerable: true,
		  get: function () {
		    return _index.stringTypeAnnotation;
		  }
		});
		Object.defineProperty(exports, "Super", {
		  enumerable: true,
		  get: function () {
		    return _index.super;
		  }
		});
		Object.defineProperty(exports, "SwitchCase", {
		  enumerable: true,
		  get: function () {
		    return _index.switchCase;
		  }
		});
		Object.defineProperty(exports, "SwitchStatement", {
		  enumerable: true,
		  get: function () {
		    return _index.switchStatement;
		  }
		});
		Object.defineProperty(exports, "SymbolTypeAnnotation", {
		  enumerable: true,
		  get: function () {
		    return _index.symbolTypeAnnotation;
		  }
		});
		Object.defineProperty(exports, "TSAnyKeyword", {
		  enumerable: true,
		  get: function () {
		    return _index.tsAnyKeyword;
		  }
		});
		Object.defineProperty(exports, "TSArrayType", {
		  enumerable: true,
		  get: function () {
		    return _index.tsArrayType;
		  }
		});
		Object.defineProperty(exports, "TSAsExpression", {
		  enumerable: true,
		  get: function () {
		    return _index.tsAsExpression;
		  }
		});
		Object.defineProperty(exports, "TSBigIntKeyword", {
		  enumerable: true,
		  get: function () {
		    return _index.tsBigIntKeyword;
		  }
		});
		Object.defineProperty(exports, "TSBooleanKeyword", {
		  enumerable: true,
		  get: function () {
		    return _index.tsBooleanKeyword;
		  }
		});
		Object.defineProperty(exports, "TSCallSignatureDeclaration", {
		  enumerable: true,
		  get: function () {
		    return _index.tsCallSignatureDeclaration;
		  }
		});
		Object.defineProperty(exports, "TSConditionalType", {
		  enumerable: true,
		  get: function () {
		    return _index.tsConditionalType;
		  }
		});
		Object.defineProperty(exports, "TSConstructSignatureDeclaration", {
		  enumerable: true,
		  get: function () {
		    return _index.tsConstructSignatureDeclaration;
		  }
		});
		Object.defineProperty(exports, "TSConstructorType", {
		  enumerable: true,
		  get: function () {
		    return _index.tsConstructorType;
		  }
		});
		Object.defineProperty(exports, "TSDeclareFunction", {
		  enumerable: true,
		  get: function () {
		    return _index.tsDeclareFunction;
		  }
		});
		Object.defineProperty(exports, "TSDeclareMethod", {
		  enumerable: true,
		  get: function () {
		    return _index.tsDeclareMethod;
		  }
		});
		Object.defineProperty(exports, "TSEnumDeclaration", {
		  enumerable: true,
		  get: function () {
		    return _index.tsEnumDeclaration;
		  }
		});
		Object.defineProperty(exports, "TSEnumMember", {
		  enumerable: true,
		  get: function () {
		    return _index.tsEnumMember;
		  }
		});
		Object.defineProperty(exports, "TSExportAssignment", {
		  enumerable: true,
		  get: function () {
		    return _index.tsExportAssignment;
		  }
		});
		Object.defineProperty(exports, "TSExpressionWithTypeArguments", {
		  enumerable: true,
		  get: function () {
		    return _index.tsExpressionWithTypeArguments;
		  }
		});
		Object.defineProperty(exports, "TSExternalModuleReference", {
		  enumerable: true,
		  get: function () {
		    return _index.tsExternalModuleReference;
		  }
		});
		Object.defineProperty(exports, "TSFunctionType", {
		  enumerable: true,
		  get: function () {
		    return _index.tsFunctionType;
		  }
		});
		Object.defineProperty(exports, "TSImportEqualsDeclaration", {
		  enumerable: true,
		  get: function () {
		    return _index.tsImportEqualsDeclaration;
		  }
		});
		Object.defineProperty(exports, "TSImportType", {
		  enumerable: true,
		  get: function () {
		    return _index.tsImportType;
		  }
		});
		Object.defineProperty(exports, "TSIndexSignature", {
		  enumerable: true,
		  get: function () {
		    return _index.tsIndexSignature;
		  }
		});
		Object.defineProperty(exports, "TSIndexedAccessType", {
		  enumerable: true,
		  get: function () {
		    return _index.tsIndexedAccessType;
		  }
		});
		Object.defineProperty(exports, "TSInferType", {
		  enumerable: true,
		  get: function () {
		    return _index.tsInferType;
		  }
		});
		Object.defineProperty(exports, "TSInstantiationExpression", {
		  enumerable: true,
		  get: function () {
		    return _index.tsInstantiationExpression;
		  }
		});
		Object.defineProperty(exports, "TSInterfaceBody", {
		  enumerable: true,
		  get: function () {
		    return _index.tsInterfaceBody;
		  }
		});
		Object.defineProperty(exports, "TSInterfaceDeclaration", {
		  enumerable: true,
		  get: function () {
		    return _index.tsInterfaceDeclaration;
		  }
		});
		Object.defineProperty(exports, "TSIntersectionType", {
		  enumerable: true,
		  get: function () {
		    return _index.tsIntersectionType;
		  }
		});
		Object.defineProperty(exports, "TSIntrinsicKeyword", {
		  enumerable: true,
		  get: function () {
		    return _index.tsIntrinsicKeyword;
		  }
		});
		Object.defineProperty(exports, "TSLiteralType", {
		  enumerable: true,
		  get: function () {
		    return _index.tsLiteralType;
		  }
		});
		Object.defineProperty(exports, "TSMappedType", {
		  enumerable: true,
		  get: function () {
		    return _index.tsMappedType;
		  }
		});
		Object.defineProperty(exports, "TSMethodSignature", {
		  enumerable: true,
		  get: function () {
		    return _index.tsMethodSignature;
		  }
		});
		Object.defineProperty(exports, "TSModuleBlock", {
		  enumerable: true,
		  get: function () {
		    return _index.tsModuleBlock;
		  }
		});
		Object.defineProperty(exports, "TSModuleDeclaration", {
		  enumerable: true,
		  get: function () {
		    return _index.tsModuleDeclaration;
		  }
		});
		Object.defineProperty(exports, "TSNamedTupleMember", {
		  enumerable: true,
		  get: function () {
		    return _index.tsNamedTupleMember;
		  }
		});
		Object.defineProperty(exports, "TSNamespaceExportDeclaration", {
		  enumerable: true,
		  get: function () {
		    return _index.tsNamespaceExportDeclaration;
		  }
		});
		Object.defineProperty(exports, "TSNeverKeyword", {
		  enumerable: true,
		  get: function () {
		    return _index.tsNeverKeyword;
		  }
		});
		Object.defineProperty(exports, "TSNonNullExpression", {
		  enumerable: true,
		  get: function () {
		    return _index.tsNonNullExpression;
		  }
		});
		Object.defineProperty(exports, "TSNullKeyword", {
		  enumerable: true,
		  get: function () {
		    return _index.tsNullKeyword;
		  }
		});
		Object.defineProperty(exports, "TSNumberKeyword", {
		  enumerable: true,
		  get: function () {
		    return _index.tsNumberKeyword;
		  }
		});
		Object.defineProperty(exports, "TSObjectKeyword", {
		  enumerable: true,
		  get: function () {
		    return _index.tsObjectKeyword;
		  }
		});
		Object.defineProperty(exports, "TSOptionalType", {
		  enumerable: true,
		  get: function () {
		    return _index.tsOptionalType;
		  }
		});
		Object.defineProperty(exports, "TSParameterProperty", {
		  enumerable: true,
		  get: function () {
		    return _index.tsParameterProperty;
		  }
		});
		Object.defineProperty(exports, "TSParenthesizedType", {
		  enumerable: true,
		  get: function () {
		    return _index.tsParenthesizedType;
		  }
		});
		Object.defineProperty(exports, "TSPropertySignature", {
		  enumerable: true,
		  get: function () {
		    return _index.tsPropertySignature;
		  }
		});
		Object.defineProperty(exports, "TSQualifiedName", {
		  enumerable: true,
		  get: function () {
		    return _index.tsQualifiedName;
		  }
		});
		Object.defineProperty(exports, "TSRestType", {
		  enumerable: true,
		  get: function () {
		    return _index.tsRestType;
		  }
		});
		Object.defineProperty(exports, "TSSatisfiesExpression", {
		  enumerable: true,
		  get: function () {
		    return _index.tsSatisfiesExpression;
		  }
		});
		Object.defineProperty(exports, "TSStringKeyword", {
		  enumerable: true,
		  get: function () {
		    return _index.tsStringKeyword;
		  }
		});
		Object.defineProperty(exports, "TSSymbolKeyword", {
		  enumerable: true,
		  get: function () {
		    return _index.tsSymbolKeyword;
		  }
		});
		Object.defineProperty(exports, "TSThisType", {
		  enumerable: true,
		  get: function () {
		    return _index.tsThisType;
		  }
		});
		Object.defineProperty(exports, "TSTupleType", {
		  enumerable: true,
		  get: function () {
		    return _index.tsTupleType;
		  }
		});
		Object.defineProperty(exports, "TSTypeAliasDeclaration", {
		  enumerable: true,
		  get: function () {
		    return _index.tsTypeAliasDeclaration;
		  }
		});
		Object.defineProperty(exports, "TSTypeAnnotation", {
		  enumerable: true,
		  get: function () {
		    return _index.tsTypeAnnotation;
		  }
		});
		Object.defineProperty(exports, "TSTypeAssertion", {
		  enumerable: true,
		  get: function () {
		    return _index.tsTypeAssertion;
		  }
		});
		Object.defineProperty(exports, "TSTypeLiteral", {
		  enumerable: true,
		  get: function () {
		    return _index.tsTypeLiteral;
		  }
		});
		Object.defineProperty(exports, "TSTypeOperator", {
		  enumerable: true,
		  get: function () {
		    return _index.tsTypeOperator;
		  }
		});
		Object.defineProperty(exports, "TSTypeParameter", {
		  enumerable: true,
		  get: function () {
		    return _index.tsTypeParameter;
		  }
		});
		Object.defineProperty(exports, "TSTypeParameterDeclaration", {
		  enumerable: true,
		  get: function () {
		    return _index.tsTypeParameterDeclaration;
		  }
		});
		Object.defineProperty(exports, "TSTypeParameterInstantiation", {
		  enumerable: true,
		  get: function () {
		    return _index.tsTypeParameterInstantiation;
		  }
		});
		Object.defineProperty(exports, "TSTypePredicate", {
		  enumerable: true,
		  get: function () {
		    return _index.tsTypePredicate;
		  }
		});
		Object.defineProperty(exports, "TSTypeQuery", {
		  enumerable: true,
		  get: function () {
		    return _index.tsTypeQuery;
		  }
		});
		Object.defineProperty(exports, "TSTypeReference", {
		  enumerable: true,
		  get: function () {
		    return _index.tsTypeReference;
		  }
		});
		Object.defineProperty(exports, "TSUndefinedKeyword", {
		  enumerable: true,
		  get: function () {
		    return _index.tsUndefinedKeyword;
		  }
		});
		Object.defineProperty(exports, "TSUnionType", {
		  enumerable: true,
		  get: function () {
		    return _index.tsUnionType;
		  }
		});
		Object.defineProperty(exports, "TSUnknownKeyword", {
		  enumerable: true,
		  get: function () {
		    return _index.tsUnknownKeyword;
		  }
		});
		Object.defineProperty(exports, "TSVoidKeyword", {
		  enumerable: true,
		  get: function () {
		    return _index.tsVoidKeyword;
		  }
		});
		Object.defineProperty(exports, "TaggedTemplateExpression", {
		  enumerable: true,
		  get: function () {
		    return _index.taggedTemplateExpression;
		  }
		});
		Object.defineProperty(exports, "TemplateElement", {
		  enumerable: true,
		  get: function () {
		    return _index.templateElement;
		  }
		});
		Object.defineProperty(exports, "TemplateLiteral", {
		  enumerable: true,
		  get: function () {
		    return _index.templateLiteral;
		  }
		});
		Object.defineProperty(exports, "ThisExpression", {
		  enumerable: true,
		  get: function () {
		    return _index.thisExpression;
		  }
		});
		Object.defineProperty(exports, "ThisTypeAnnotation", {
		  enumerable: true,
		  get: function () {
		    return _index.thisTypeAnnotation;
		  }
		});
		Object.defineProperty(exports, "ThrowStatement", {
		  enumerable: true,
		  get: function () {
		    return _index.throwStatement;
		  }
		});
		Object.defineProperty(exports, "TopicReference", {
		  enumerable: true,
		  get: function () {
		    return _index.topicReference;
		  }
		});
		Object.defineProperty(exports, "TryStatement", {
		  enumerable: true,
		  get: function () {
		    return _index.tryStatement;
		  }
		});
		Object.defineProperty(exports, "TupleExpression", {
		  enumerable: true,
		  get: function () {
		    return _index.tupleExpression;
		  }
		});
		Object.defineProperty(exports, "TupleTypeAnnotation", {
		  enumerable: true,
		  get: function () {
		    return _index.tupleTypeAnnotation;
		  }
		});
		Object.defineProperty(exports, "TypeAlias", {
		  enumerable: true,
		  get: function () {
		    return _index.typeAlias;
		  }
		});
		Object.defineProperty(exports, "TypeAnnotation", {
		  enumerable: true,
		  get: function () {
		    return _index.typeAnnotation;
		  }
		});
		Object.defineProperty(exports, "TypeCastExpression", {
		  enumerable: true,
		  get: function () {
		    return _index.typeCastExpression;
		  }
		});
		Object.defineProperty(exports, "TypeParameter", {
		  enumerable: true,
		  get: function () {
		    return _index.typeParameter;
		  }
		});
		Object.defineProperty(exports, "TypeParameterDeclaration", {
		  enumerable: true,
		  get: function () {
		    return _index.typeParameterDeclaration;
		  }
		});
		Object.defineProperty(exports, "TypeParameterInstantiation", {
		  enumerable: true,
		  get: function () {
		    return _index.typeParameterInstantiation;
		  }
		});
		Object.defineProperty(exports, "TypeofTypeAnnotation", {
		  enumerable: true,
		  get: function () {
		    return _index.typeofTypeAnnotation;
		  }
		});
		Object.defineProperty(exports, "UnaryExpression", {
		  enumerable: true,
		  get: function () {
		    return _index.unaryExpression;
		  }
		});
		Object.defineProperty(exports, "UnionTypeAnnotation", {
		  enumerable: true,
		  get: function () {
		    return _index.unionTypeAnnotation;
		  }
		});
		Object.defineProperty(exports, "UpdateExpression", {
		  enumerable: true,
		  get: function () {
		    return _index.updateExpression;
		  }
		});
		Object.defineProperty(exports, "V8IntrinsicIdentifier", {
		  enumerable: true,
		  get: function () {
		    return _index.v8IntrinsicIdentifier;
		  }
		});
		Object.defineProperty(exports, "VariableDeclaration", {
		  enumerable: true,
		  get: function () {
		    return _index.variableDeclaration;
		  }
		});
		Object.defineProperty(exports, "VariableDeclarator", {
		  enumerable: true,
		  get: function () {
		    return _index.variableDeclarator;
		  }
		});
		Object.defineProperty(exports, "Variance", {
		  enumerable: true,
		  get: function () {
		    return _index.variance;
		  }
		});
		Object.defineProperty(exports, "VoidTypeAnnotation", {
		  enumerable: true,
		  get: function () {
		    return _index.voidTypeAnnotation;
		  }
		});
		Object.defineProperty(exports, "WhileStatement", {
		  enumerable: true,
		  get: function () {
		    return _index.whileStatement;
		  }
		});
		Object.defineProperty(exports, "WithStatement", {
		  enumerable: true,
		  get: function () {
		    return _index.withStatement;
		  }
		});
		Object.defineProperty(exports, "YieldExpression", {
		  enumerable: true,
		  get: function () {
		    return _index.yieldExpression;
		  }
		});
		var _index = requireGenerated$2();

		
	} (uppercase));
	return uppercase;
}

var productions = {};

var hasRequiredProductions;

function requireProductions () {
	if (hasRequiredProductions) return productions;
	hasRequiredProductions = 1;

	Object.defineProperty(productions, "__esModule", {
	  value: true
	});
	productions.buildUndefinedNode = buildUndefinedNode;
	var _index = requireGenerated$2();
	function buildUndefinedNode() {
	  return (0, _index.unaryExpression)("void", (0, _index.numericLiteral)(0), true);
	}

	
	return productions;
}

var cloneNode = {};

var hasRequiredCloneNode;

function requireCloneNode () {
	if (hasRequiredCloneNode) return cloneNode;
	hasRequiredCloneNode = 1;

	Object.defineProperty(cloneNode, "__esModule", {
	  value: true
	});
	cloneNode.default = cloneNode$1;
	var _index = requireDefinitions();
	var _index2 = requireGenerated$3();
	const {
	  hasOwn
	} = {
	  hasOwn: Function.call.bind(Object.prototype.hasOwnProperty)
	};
	function cloneIfNode(obj, deep, withoutLoc, commentsCache) {
	  if (obj && typeof obj.type === "string") {
	    return cloneNodeInternal(obj, deep, withoutLoc, commentsCache);
	  }
	  return obj;
	}
	function cloneIfNodeOrArray(obj, deep, withoutLoc, commentsCache) {
	  if (Array.isArray(obj)) {
	    return obj.map(node => cloneIfNode(node, deep, withoutLoc, commentsCache));
	  }
	  return cloneIfNode(obj, deep, withoutLoc, commentsCache);
	}
	function cloneNode$1(node, deep = true, withoutLoc = false) {
	  return cloneNodeInternal(node, deep, withoutLoc, new Map());
	}
	function cloneNodeInternal(node, deep = true, withoutLoc = false, commentsCache) {
	  if (!node) return node;
	  const {
	    type
	  } = node;
	  const newNode = {
	    type: node.type
	  };
	  if ((0, _index2.isIdentifier)(node)) {
	    newNode.name = node.name;
	    if (hasOwn(node, "optional") && typeof node.optional === "boolean") {
	      newNode.optional = node.optional;
	    }
	    if (hasOwn(node, "typeAnnotation")) {
	      newNode.typeAnnotation = deep ? cloneIfNodeOrArray(node.typeAnnotation, true, withoutLoc, commentsCache) : node.typeAnnotation;
	    }
	  } else if (!hasOwn(_index.NODE_FIELDS, type)) {
	    throw new Error(`Unknown node type: "${type}"`);
	  } else {
	    for (const field of Object.keys(_index.NODE_FIELDS[type])) {
	      if (hasOwn(node, field)) {
	        if (deep) {
	          newNode[field] = (0, _index2.isFile)(node) && field === "comments" ? maybeCloneComments(node.comments, deep, withoutLoc, commentsCache) : cloneIfNodeOrArray(node[field], true, withoutLoc, commentsCache);
	        } else {
	          newNode[field] = node[field];
	        }
	      }
	    }
	  }
	  if (hasOwn(node, "loc")) {
	    if (withoutLoc) {
	      newNode.loc = null;
	    } else {
	      newNode.loc = node.loc;
	    }
	  }
	  if (hasOwn(node, "leadingComments")) {
	    newNode.leadingComments = maybeCloneComments(node.leadingComments, deep, withoutLoc, commentsCache);
	  }
	  if (hasOwn(node, "innerComments")) {
	    newNode.innerComments = maybeCloneComments(node.innerComments, deep, withoutLoc, commentsCache);
	  }
	  if (hasOwn(node, "trailingComments")) {
	    newNode.trailingComments = maybeCloneComments(node.trailingComments, deep, withoutLoc, commentsCache);
	  }
	  if (hasOwn(node, "extra")) {
	    newNode.extra = Object.assign({}, node.extra);
	  }
	  return newNode;
	}
	function maybeCloneComments(comments, deep, withoutLoc, commentsCache) {
	  if (!comments || !deep) {
	    return comments;
	  }
	  return comments.map(comment => {
	    const cache = commentsCache.get(comment);
	    if (cache) return cache;
	    const {
	      type,
	      value,
	      loc
	    } = comment;
	    const ret = {
	      type,
	      value,
	      loc
	    };
	    if (withoutLoc) {
	      ret.loc = null;
	    }
	    commentsCache.set(comment, ret);
	    return ret;
	  });
	}

	
	return cloneNode;
}

var clone = {};

var hasRequiredClone;

function requireClone () {
	if (hasRequiredClone) return clone;
	hasRequiredClone = 1;

	Object.defineProperty(clone, "__esModule", {
	  value: true
	});
	clone.default = clone$1;
	var _cloneNode = requireCloneNode();
	function clone$1(node) {
	  return (0, _cloneNode.default)(node, false);
	}

	
	return clone;
}

var cloneDeep$1 = {};

var hasRequiredCloneDeep;

function requireCloneDeep () {
	if (hasRequiredCloneDeep) return cloneDeep$1;
	hasRequiredCloneDeep = 1;

	Object.defineProperty(cloneDeep$1, "__esModule", {
	  value: true
	});
	cloneDeep$1.default = cloneDeep;
	var _cloneNode = requireCloneNode();
	function cloneDeep(node) {
	  return (0, _cloneNode.default)(node);
	}

	
	return cloneDeep$1;
}

var cloneDeepWithoutLoc = {};

var hasRequiredCloneDeepWithoutLoc;

function requireCloneDeepWithoutLoc () {
	if (hasRequiredCloneDeepWithoutLoc) return cloneDeepWithoutLoc;
	hasRequiredCloneDeepWithoutLoc = 1;

	Object.defineProperty(cloneDeepWithoutLoc, "__esModule", {
	  value: true
	});
	cloneDeepWithoutLoc.default = cloneDeepWithoutLoc$1;
	var _cloneNode = requireCloneNode();
	function cloneDeepWithoutLoc$1(node) {
	  return (0, _cloneNode.default)(node, true, true);
	}

	
	return cloneDeepWithoutLoc;
}

var cloneWithoutLoc = {};

var hasRequiredCloneWithoutLoc;

function requireCloneWithoutLoc () {
	if (hasRequiredCloneWithoutLoc) return cloneWithoutLoc;
	hasRequiredCloneWithoutLoc = 1;

	Object.defineProperty(cloneWithoutLoc, "__esModule", {
	  value: true
	});
	cloneWithoutLoc.default = cloneWithoutLoc$1;
	var _cloneNode = requireCloneNode();
	function cloneWithoutLoc$1(node) {
	  return (0, _cloneNode.default)(node, false, true);
	}

	
	return cloneWithoutLoc;
}

var addComment = {};

var addComments = {};

var hasRequiredAddComments;

function requireAddComments () {
	if (hasRequiredAddComments) return addComments;
	hasRequiredAddComments = 1;

	Object.defineProperty(addComments, "__esModule", {
	  value: true
	});
	addComments.default = addComments$1;
	function addComments$1(node, type, comments) {
	  if (!comments || !node) return node;
	  const key = `${type}Comments`;
	  if (node[key]) {
	    if (type === "leading") {
	      node[key] = comments.concat(node[key]);
	    } else {
	      node[key].push(...comments);
	    }
	  } else {
	    node[key] = comments;
	  }
	  return node;
	}

	
	return addComments;
}

var hasRequiredAddComment;

function requireAddComment () {
	if (hasRequiredAddComment) return addComment;
	hasRequiredAddComment = 1;

	Object.defineProperty(addComment, "__esModule", {
	  value: true
	});
	addComment.default = addComment$1;
	var _addComments = requireAddComments();
	function addComment$1(node, type, content, line) {
	  return (0, _addComments.default)(node, type, [{
	    type: line ? "CommentLine" : "CommentBlock",
	    value: content
	  }]);
	}

	
	return addComment;
}

var inheritInnerComments = {};

var inherit = {};

var hasRequiredInherit;

function requireInherit () {
	if (hasRequiredInherit) return inherit;
	hasRequiredInherit = 1;

	Object.defineProperty(inherit, "__esModule", {
	  value: true
	});
	inherit.default = inherit$1;
	function inherit$1(key, child, parent) {
	  if (child && parent) {
	    child[key] = Array.from(new Set([].concat(child[key], parent[key]).filter(Boolean)));
	  }
	}

	
	return inherit;
}

var hasRequiredInheritInnerComments;

function requireInheritInnerComments () {
	if (hasRequiredInheritInnerComments) return inheritInnerComments;
	hasRequiredInheritInnerComments = 1;

	Object.defineProperty(inheritInnerComments, "__esModule", {
	  value: true
	});
	inheritInnerComments.default = inheritInnerComments$1;
	var _inherit = requireInherit();
	function inheritInnerComments$1(child, parent) {
	  (0, _inherit.default)("innerComments", child, parent);
	}

	
	return inheritInnerComments;
}

var inheritLeadingComments = {};

var hasRequiredInheritLeadingComments;

function requireInheritLeadingComments () {
	if (hasRequiredInheritLeadingComments) return inheritLeadingComments;
	hasRequiredInheritLeadingComments = 1;

	Object.defineProperty(inheritLeadingComments, "__esModule", {
	  value: true
	});
	inheritLeadingComments.default = inheritLeadingComments$1;
	var _inherit = requireInherit();
	function inheritLeadingComments$1(child, parent) {
	  (0, _inherit.default)("leadingComments", child, parent);
	}

	
	return inheritLeadingComments;
}

var inheritsComments = {};

var inheritTrailingComments = {};

var hasRequiredInheritTrailingComments;

function requireInheritTrailingComments () {
	if (hasRequiredInheritTrailingComments) return inheritTrailingComments;
	hasRequiredInheritTrailingComments = 1;

	Object.defineProperty(inheritTrailingComments, "__esModule", {
	  value: true
	});
	inheritTrailingComments.default = inheritTrailingComments$1;
	var _inherit = requireInherit();
	function inheritTrailingComments$1(child, parent) {
	  (0, _inherit.default)("trailingComments", child, parent);
	}

	
	return inheritTrailingComments;
}

var hasRequiredInheritsComments;

function requireInheritsComments () {
	if (hasRequiredInheritsComments) return inheritsComments;
	hasRequiredInheritsComments = 1;

	Object.defineProperty(inheritsComments, "__esModule", {
	  value: true
	});
	inheritsComments.default = inheritsComments$1;
	var _inheritTrailingComments = requireInheritTrailingComments();
	var _inheritLeadingComments = requireInheritLeadingComments();
	var _inheritInnerComments = requireInheritInnerComments();
	function inheritsComments$1(child, parent) {
	  (0, _inheritTrailingComments.default)(child, parent);
	  (0, _inheritLeadingComments.default)(child, parent);
	  (0, _inheritInnerComments.default)(child, parent);
	  return child;
	}

	
	return inheritsComments;
}

var removeComments = {};

var hasRequiredRemoveComments;

function requireRemoveComments () {
	if (hasRequiredRemoveComments) return removeComments;
	hasRequiredRemoveComments = 1;

	Object.defineProperty(removeComments, "__esModule", {
	  value: true
	});
	removeComments.default = removeComments$1;
	var _index = requireConstants();
	function removeComments$1(node) {
	  _index.COMMENT_KEYS.forEach(key => {
	    node[key] = null;
	  });
	  return node;
	}

	
	return removeComments;
}

var generated = {};

var hasRequiredGenerated;

function requireGenerated () {
	if (hasRequiredGenerated) return generated;
	hasRequiredGenerated = 1;

	Object.defineProperty(generated, "__esModule", {
	  value: true
	});
	generated.WHILE_TYPES = generated.USERWHITESPACABLE_TYPES = generated.UNARYLIKE_TYPES = generated.TYPESCRIPT_TYPES = generated.TSTYPE_TYPES = generated.TSTYPEELEMENT_TYPES = generated.TSENTITYNAME_TYPES = generated.TSBASETYPE_TYPES = generated.TERMINATORLESS_TYPES = generated.STATEMENT_TYPES = generated.STANDARDIZED_TYPES = generated.SCOPABLE_TYPES = generated.PUREISH_TYPES = generated.PROPERTY_TYPES = generated.PRIVATE_TYPES = generated.PATTERN_TYPES = generated.PATTERNLIKE_TYPES = generated.OBJECTMEMBER_TYPES = generated.MODULESPECIFIER_TYPES = generated.MODULEDECLARATION_TYPES = generated.MISCELLANEOUS_TYPES = generated.METHOD_TYPES = generated.LVAL_TYPES = generated.LOOP_TYPES = generated.LITERAL_TYPES = generated.JSX_TYPES = generated.IMPORTOREXPORTDECLARATION_TYPES = generated.IMMUTABLE_TYPES = generated.FUNCTION_TYPES = generated.FUNCTIONPARENT_TYPES = generated.FOR_TYPES = generated.FORXSTATEMENT_TYPES = generated.FLOW_TYPES = generated.FLOWTYPE_TYPES = generated.FLOWPREDICATE_TYPES = generated.FLOWDECLARATION_TYPES = generated.FLOWBASEANNOTATION_TYPES = generated.EXPRESSION_TYPES = generated.EXPRESSIONWRAPPER_TYPES = generated.EXPORTDECLARATION_TYPES = generated.ENUMMEMBER_TYPES = generated.ENUMBODY_TYPES = generated.DECLARATION_TYPES = generated.CONDITIONAL_TYPES = generated.COMPLETIONSTATEMENT_TYPES = generated.CLASS_TYPES = generated.BLOCK_TYPES = generated.BLOCKPARENT_TYPES = generated.BINARY_TYPES = generated.ACCESSOR_TYPES = void 0;
	var _index = requireDefinitions();
	generated.STANDARDIZED_TYPES = _index.FLIPPED_ALIAS_KEYS["Standardized"];
	generated.EXPRESSION_TYPES = _index.FLIPPED_ALIAS_KEYS["Expression"];
	generated.BINARY_TYPES = _index.FLIPPED_ALIAS_KEYS["Binary"];
	generated.SCOPABLE_TYPES = _index.FLIPPED_ALIAS_KEYS["Scopable"];
	generated.BLOCKPARENT_TYPES = _index.FLIPPED_ALIAS_KEYS["BlockParent"];
	generated.BLOCK_TYPES = _index.FLIPPED_ALIAS_KEYS["Block"];
	generated.STATEMENT_TYPES = _index.FLIPPED_ALIAS_KEYS["Statement"];
	generated.TERMINATORLESS_TYPES = _index.FLIPPED_ALIAS_KEYS["Terminatorless"];
	generated.COMPLETIONSTATEMENT_TYPES = _index.FLIPPED_ALIAS_KEYS["CompletionStatement"];
	generated.CONDITIONAL_TYPES = _index.FLIPPED_ALIAS_KEYS["Conditional"];
	generated.LOOP_TYPES = _index.FLIPPED_ALIAS_KEYS["Loop"];
	generated.WHILE_TYPES = _index.FLIPPED_ALIAS_KEYS["While"];
	generated.EXPRESSIONWRAPPER_TYPES = _index.FLIPPED_ALIAS_KEYS["ExpressionWrapper"];
	generated.FOR_TYPES = _index.FLIPPED_ALIAS_KEYS["For"];
	generated.FORXSTATEMENT_TYPES = _index.FLIPPED_ALIAS_KEYS["ForXStatement"];
	generated.FUNCTION_TYPES = _index.FLIPPED_ALIAS_KEYS["Function"];
	generated.FUNCTIONPARENT_TYPES = _index.FLIPPED_ALIAS_KEYS["FunctionParent"];
	generated.PUREISH_TYPES = _index.FLIPPED_ALIAS_KEYS["Pureish"];
	generated.DECLARATION_TYPES = _index.FLIPPED_ALIAS_KEYS["Declaration"];
	generated.PATTERNLIKE_TYPES = _index.FLIPPED_ALIAS_KEYS["PatternLike"];
	generated.LVAL_TYPES = _index.FLIPPED_ALIAS_KEYS["LVal"];
	generated.TSENTITYNAME_TYPES = _index.FLIPPED_ALIAS_KEYS["TSEntityName"];
	generated.LITERAL_TYPES = _index.FLIPPED_ALIAS_KEYS["Literal"];
	generated.IMMUTABLE_TYPES = _index.FLIPPED_ALIAS_KEYS["Immutable"];
	generated.USERWHITESPACABLE_TYPES = _index.FLIPPED_ALIAS_KEYS["UserWhitespacable"];
	generated.METHOD_TYPES = _index.FLIPPED_ALIAS_KEYS["Method"];
	generated.OBJECTMEMBER_TYPES = _index.FLIPPED_ALIAS_KEYS["ObjectMember"];
	generated.PROPERTY_TYPES = _index.FLIPPED_ALIAS_KEYS["Property"];
	generated.UNARYLIKE_TYPES = _index.FLIPPED_ALIAS_KEYS["UnaryLike"];
	generated.PATTERN_TYPES = _index.FLIPPED_ALIAS_KEYS["Pattern"];
	generated.CLASS_TYPES = _index.FLIPPED_ALIAS_KEYS["Class"];
	const IMPORTOREXPORTDECLARATION_TYPES = generated.IMPORTOREXPORTDECLARATION_TYPES = _index.FLIPPED_ALIAS_KEYS["ImportOrExportDeclaration"];
	generated.EXPORTDECLARATION_TYPES = _index.FLIPPED_ALIAS_KEYS["ExportDeclaration"];
	generated.MODULESPECIFIER_TYPES = _index.FLIPPED_ALIAS_KEYS["ModuleSpecifier"];
	generated.ACCESSOR_TYPES = _index.FLIPPED_ALIAS_KEYS["Accessor"];
	generated.PRIVATE_TYPES = _index.FLIPPED_ALIAS_KEYS["Private"];
	generated.FLOW_TYPES = _index.FLIPPED_ALIAS_KEYS["Flow"];
	generated.FLOWTYPE_TYPES = _index.FLIPPED_ALIAS_KEYS["FlowType"];
	generated.FLOWBASEANNOTATION_TYPES = _index.FLIPPED_ALIAS_KEYS["FlowBaseAnnotation"];
	generated.FLOWDECLARATION_TYPES = _index.FLIPPED_ALIAS_KEYS["FlowDeclaration"];
	generated.FLOWPREDICATE_TYPES = _index.FLIPPED_ALIAS_KEYS["FlowPredicate"];
	generated.ENUMBODY_TYPES = _index.FLIPPED_ALIAS_KEYS["EnumBody"];
	generated.ENUMMEMBER_TYPES = _index.FLIPPED_ALIAS_KEYS["EnumMember"];
	generated.JSX_TYPES = _index.FLIPPED_ALIAS_KEYS["JSX"];
	generated.MISCELLANEOUS_TYPES = _index.FLIPPED_ALIAS_KEYS["Miscellaneous"];
	generated.TYPESCRIPT_TYPES = _index.FLIPPED_ALIAS_KEYS["TypeScript"];
	generated.TSTYPEELEMENT_TYPES = _index.FLIPPED_ALIAS_KEYS["TSTypeElement"];
	generated.TSTYPE_TYPES = _index.FLIPPED_ALIAS_KEYS["TSType"];
	generated.TSBASETYPE_TYPES = _index.FLIPPED_ALIAS_KEYS["TSBaseType"];
	generated.MODULEDECLARATION_TYPES = IMPORTOREXPORTDECLARATION_TYPES;

	
	return generated;
}

var ensureBlock = {};

var toBlock = {};

var hasRequiredToBlock;

function requireToBlock () {
	if (hasRequiredToBlock) return toBlock;
	hasRequiredToBlock = 1;

	Object.defineProperty(toBlock, "__esModule", {
	  value: true
	});
	toBlock.default = toBlock$1;
	var _index = requireGenerated$3();
	var _index2 = requireGenerated$2();
	function toBlock$1(node, parent) {
	  if ((0, _index.isBlockStatement)(node)) {
	    return node;
	  }
	  let blockNodes = [];
	  if ((0, _index.isEmptyStatement)(node)) {
	    blockNodes = [];
	  } else {
	    if (!(0, _index.isStatement)(node)) {
	      if ((0, _index.isFunction)(parent)) {
	        node = (0, _index2.returnStatement)(node);
	      } else {
	        node = (0, _index2.expressionStatement)(node);
	      }
	    }
	    blockNodes = [node];
	  }
	  return (0, _index2.blockStatement)(blockNodes);
	}

	
	return toBlock;
}

var hasRequiredEnsureBlock;

function requireEnsureBlock () {
	if (hasRequiredEnsureBlock) return ensureBlock;
	hasRequiredEnsureBlock = 1;

	Object.defineProperty(ensureBlock, "__esModule", {
	  value: true
	});
	ensureBlock.default = ensureBlock$1;
	var _toBlock = requireToBlock();
	function ensureBlock$1(node, key = "body") {
	  const result = (0, _toBlock.default)(node[key], node);
	  node[key] = result;
	  return result;
	}

	
	return ensureBlock;
}

var toBindingIdentifierName = {};

var toIdentifier = {};

var hasRequiredToIdentifier;

function requireToIdentifier () {
	if (hasRequiredToIdentifier) return toIdentifier;
	hasRequiredToIdentifier = 1;

	Object.defineProperty(toIdentifier, "__esModule", {
	  value: true
	});
	toIdentifier.default = toIdentifier$1;
	var _isValidIdentifier = requireIsValidIdentifier();
	var _helperValidatorIdentifier = requireLib$j();
	function toIdentifier$1(input) {
	  input = input + "";
	  let name = "";
	  for (const c of input) {
	    name += (0, _helperValidatorIdentifier.isIdentifierChar)(c.codePointAt(0)) ? c : "-";
	  }
	  name = name.replace(/^[-0-9]+/, "");
	  name = name.replace(/[-\s]+(.)?/g, function (match, c) {
	    return c ? c.toUpperCase() : "";
	  });
	  if (!(0, _isValidIdentifier.default)(name)) {
	    name = `_${name}`;
	  }
	  return name || "_";
	}

	
	return toIdentifier;
}

var hasRequiredToBindingIdentifierName;

function requireToBindingIdentifierName () {
	if (hasRequiredToBindingIdentifierName) return toBindingIdentifierName;
	hasRequiredToBindingIdentifierName = 1;

	Object.defineProperty(toBindingIdentifierName, "__esModule", {
	  value: true
	});
	toBindingIdentifierName.default = toBindingIdentifierName$1;
	var _toIdentifier = requireToIdentifier();
	function toBindingIdentifierName$1(name) {
	  name = (0, _toIdentifier.default)(name);
	  if (name === "eval" || name === "arguments") name = "_" + name;
	  return name;
	}

	
	return toBindingIdentifierName;
}

var toComputedKey = {};

var hasRequiredToComputedKey;

function requireToComputedKey () {
	if (hasRequiredToComputedKey) return toComputedKey;
	hasRequiredToComputedKey = 1;

	Object.defineProperty(toComputedKey, "__esModule", {
	  value: true
	});
	toComputedKey.default = toComputedKey$1;
	var _index = requireGenerated$3();
	var _index2 = requireGenerated$2();
	function toComputedKey$1(node, key = node.key || node.property) {
	  if (!node.computed && (0, _index.isIdentifier)(key)) key = (0, _index2.stringLiteral)(key.name);
	  return key;
	}

	
	return toComputedKey;
}

var toExpression = {};

var hasRequiredToExpression;

function requireToExpression () {
	if (hasRequiredToExpression) return toExpression;
	hasRequiredToExpression = 1;

	Object.defineProperty(toExpression, "__esModule", {
	  value: true
	});
	toExpression.default = void 0;
	var _index = requireGenerated$3();
	toExpression.default = toExpression$1;
	function toExpression$1(node) {
	  if ((0, _index.isExpressionStatement)(node)) {
	    node = node.expression;
	  }
	  if ((0, _index.isExpression)(node)) {
	    return node;
	  }
	  if ((0, _index.isClass)(node)) {
	    node.type = "ClassExpression";
	  } else if ((0, _index.isFunction)(node)) {
	    node.type = "FunctionExpression";
	  }
	  if (!(0, _index.isExpression)(node)) {
	    throw new Error(`cannot turn ${node.type} to an expression`);
	  }
	  return node;
	}

	
	return toExpression;
}

var toKeyAlias = {};

var removePropertiesDeep = {};

var traverseFast = {};

var hasRequiredTraverseFast;

function requireTraverseFast () {
	if (hasRequiredTraverseFast) return traverseFast;
	hasRequiredTraverseFast = 1;

	Object.defineProperty(traverseFast, "__esModule", {
	  value: true
	});
	traverseFast.default = traverseFast$1;
	var _index = requireDefinitions();
	function traverseFast$1(node, enter, opts) {
	  if (!node) return;
	  const keys = _index.VISITOR_KEYS[node.type];
	  if (!keys) return;
	  opts = opts || {};
	  enter(node, opts);
	  for (const key of keys) {
	    const subNode = node[key];
	    if (Array.isArray(subNode)) {
	      for (const node of subNode) {
	        traverseFast$1(node, enter, opts);
	      }
	    } else {
	      traverseFast$1(subNode, enter, opts);
	    }
	  }
	}

	
	return traverseFast;
}

var removeProperties = {};

var hasRequiredRemoveProperties;

function requireRemoveProperties () {
	if (hasRequiredRemoveProperties) return removeProperties;
	hasRequiredRemoveProperties = 1;

	Object.defineProperty(removeProperties, "__esModule", {
	  value: true
	});
	removeProperties.default = removeProperties$1;
	var _index = requireConstants();
	const CLEAR_KEYS = ["tokens", "start", "end", "loc", "raw", "rawValue"];
	const CLEAR_KEYS_PLUS_COMMENTS = [..._index.COMMENT_KEYS, "comments", ...CLEAR_KEYS];
	function removeProperties$1(node, opts = {}) {
	  const map = opts.preserveComments ? CLEAR_KEYS : CLEAR_KEYS_PLUS_COMMENTS;
	  for (const key of map) {
	    if (node[key] != null) node[key] = undefined;
	  }
	  for (const key of Object.keys(node)) {
	    if (key[0] === "_" && node[key] != null) node[key] = undefined;
	  }
	  const symbols = Object.getOwnPropertySymbols(node);
	  for (const sym of symbols) {
	    node[sym] = null;
	  }
	}

	
	return removeProperties;
}

var hasRequiredRemovePropertiesDeep;

function requireRemovePropertiesDeep () {
	if (hasRequiredRemovePropertiesDeep) return removePropertiesDeep;
	hasRequiredRemovePropertiesDeep = 1;

	Object.defineProperty(removePropertiesDeep, "__esModule", {
	  value: true
	});
	removePropertiesDeep.default = removePropertiesDeep$1;
	var _traverseFast = requireTraverseFast();
	var _removeProperties = requireRemoveProperties();
	function removePropertiesDeep$1(tree, opts) {
	  (0, _traverseFast.default)(tree, _removeProperties.default, opts);
	  return tree;
	}

	
	return removePropertiesDeep;
}

var hasRequiredToKeyAlias;

function requireToKeyAlias () {
	if (hasRequiredToKeyAlias) return toKeyAlias;
	hasRequiredToKeyAlias = 1;

	Object.defineProperty(toKeyAlias, "__esModule", {
	  value: true
	});
	toKeyAlias.default = toKeyAlias$1;
	var _index = requireGenerated$3();
	var _cloneNode = requireCloneNode();
	var _removePropertiesDeep = requireRemovePropertiesDeep();
	function toKeyAlias$1(node, key = node.key) {
	  let alias;
	  if (node.kind === "method") {
	    return toKeyAlias$1.increment() + "";
	  } else if ((0, _index.isIdentifier)(key)) {
	    alias = key.name;
	  } else if ((0, _index.isStringLiteral)(key)) {
	    alias = JSON.stringify(key.value);
	  } else {
	    alias = JSON.stringify((0, _removePropertiesDeep.default)((0, _cloneNode.default)(key)));
	  }
	  if (node.computed) {
	    alias = `[${alias}]`;
	  }
	  if (node.static) {
	    alias = `static:${alias}`;
	  }
	  return alias;
	}
	toKeyAlias$1.uid = 0;
	toKeyAlias$1.increment = function () {
	  if (toKeyAlias$1.uid >= Number.MAX_SAFE_INTEGER) {
	    return toKeyAlias$1.uid = 0;
	  } else {
	    return toKeyAlias$1.uid++;
	  }
	};

	
	return toKeyAlias;
}

var toStatement = {};

var hasRequiredToStatement;

function requireToStatement () {
	if (hasRequiredToStatement) return toStatement;
	hasRequiredToStatement = 1;

	Object.defineProperty(toStatement, "__esModule", {
	  value: true
	});
	toStatement.default = void 0;
	var _index = requireGenerated$3();
	var _index2 = requireGenerated$2();
	toStatement.default = toStatement$1;
	function toStatement$1(node, ignore) {
	  if ((0, _index.isStatement)(node)) {
	    return node;
	  }
	  let mustHaveId = false;
	  let newType;
	  if ((0, _index.isClass)(node)) {
	    mustHaveId = true;
	    newType = "ClassDeclaration";
	  } else if ((0, _index.isFunction)(node)) {
	    mustHaveId = true;
	    newType = "FunctionDeclaration";
	  } else if ((0, _index.isAssignmentExpression)(node)) {
	    return (0, _index2.expressionStatement)(node);
	  }
	  if (mustHaveId && !node.id) {
	    newType = false;
	  }
	  if (!newType) {
	    if (ignore) {
	      return false;
	    } else {
	      throw new Error(`cannot turn ${node.type} to a statement`);
	    }
	  }
	  node.type = newType;
	  return node;
	}

	
	return toStatement;
}

var valueToNode = {};

var hasRequiredValueToNode;

function requireValueToNode () {
	if (hasRequiredValueToNode) return valueToNode;
	hasRequiredValueToNode = 1;

	Object.defineProperty(valueToNode, "__esModule", {
	  value: true
	});
	valueToNode.default = void 0;
	var _isValidIdentifier = requireIsValidIdentifier();
	var _index = requireGenerated$2();
	valueToNode.default = valueToNode$1;
	const objectToString = Function.call.bind(Object.prototype.toString);
	function isRegExp(value) {
	  return objectToString(value) === "[object RegExp]";
	}
	function isPlainObject(value) {
	  if (typeof value !== "object" || value === null || Object.prototype.toString.call(value) !== "[object Object]") {
	    return false;
	  }
	  const proto = Object.getPrototypeOf(value);
	  return proto === null || Object.getPrototypeOf(proto) === null;
	}
	function valueToNode$1(value) {
	  if (value === undefined) {
	    return (0, _index.identifier)("undefined");
	  }
	  if (value === true || value === false) {
	    return (0, _index.booleanLiteral)(value);
	  }
	  if (value === null) {
	    return (0, _index.nullLiteral)();
	  }
	  if (typeof value === "string") {
	    return (0, _index.stringLiteral)(value);
	  }
	  if (typeof value === "number") {
	    let result;
	    if (Number.isFinite(value)) {
	      result = (0, _index.numericLiteral)(Math.abs(value));
	    } else {
	      let numerator;
	      if (Number.isNaN(value)) {
	        numerator = (0, _index.numericLiteral)(0);
	      } else {
	        numerator = (0, _index.numericLiteral)(1);
	      }
	      result = (0, _index.binaryExpression)("/", numerator, (0, _index.numericLiteral)(0));
	    }
	    if (value < 0 || Object.is(value, -0)) {
	      result = (0, _index.unaryExpression)("-", result);
	    }
	    return result;
	  }
	  if (isRegExp(value)) {
	    const pattern = value.source;
	    const flags = value.toString().match(/\/([a-z]+|)$/)[1];
	    return (0, _index.regExpLiteral)(pattern, flags);
	  }
	  if (Array.isArray(value)) {
	    return (0, _index.arrayExpression)(value.map(valueToNode$1));
	  }
	  if (isPlainObject(value)) {
	    const props = [];
	    for (const key of Object.keys(value)) {
	      let nodeKey;
	      if ((0, _isValidIdentifier.default)(key)) {
	        nodeKey = (0, _index.identifier)(key);
	      } else {
	        nodeKey = (0, _index.stringLiteral)(key);
	      }
	      props.push((0, _index.objectProperty)(nodeKey, valueToNode$1(value[key])));
	    }
	    return (0, _index.objectExpression)(props);
	  }
	  throw new Error("don't know how to turn this value into a node");
	}

	
	return valueToNode;
}

var appendToMemberExpression = {};

var hasRequiredAppendToMemberExpression;

function requireAppendToMemberExpression () {
	if (hasRequiredAppendToMemberExpression) return appendToMemberExpression;
	hasRequiredAppendToMemberExpression = 1;

	Object.defineProperty(appendToMemberExpression, "__esModule", {
	  value: true
	});
	appendToMemberExpression.default = appendToMemberExpression$1;
	var _index = requireGenerated$2();
	function appendToMemberExpression$1(member, append, computed = false) {
	  member.object = (0, _index.memberExpression)(member.object, member.property, member.computed);
	  member.property = append;
	  member.computed = !!computed;
	  return member;
	}

	
	return appendToMemberExpression;
}

var inherits = {};

var hasRequiredInherits;

function requireInherits () {
	if (hasRequiredInherits) return inherits;
	hasRequiredInherits = 1;

	Object.defineProperty(inherits, "__esModule", {
	  value: true
	});
	inherits.default = inherits$1;
	var _index = requireConstants();
	var _inheritsComments = requireInheritsComments();
	function inherits$1(child, parent) {
	  if (!child || !parent) return child;
	  for (const key of _index.INHERIT_KEYS.optional) {
	    if (child[key] == null) {
	      child[key] = parent[key];
	    }
	  }
	  for (const key of Object.keys(parent)) {
	    if (key[0] === "_" && key !== "__clone") {
	      child[key] = parent[key];
	    }
	  }
	  for (const key of _index.INHERIT_KEYS.force) {
	    child[key] = parent[key];
	  }
	  (0, _inheritsComments.default)(child, parent);
	  return child;
	}

	
	return inherits;
}

var prependToMemberExpression = {};

var hasRequiredPrependToMemberExpression;

function requirePrependToMemberExpression () {
	if (hasRequiredPrependToMemberExpression) return prependToMemberExpression;
	hasRequiredPrependToMemberExpression = 1;

	Object.defineProperty(prependToMemberExpression, "__esModule", {
	  value: true
	});
	prependToMemberExpression.default = prependToMemberExpression$1;
	var _index = requireGenerated$2();
	var _index2 = requireLib$h();
	function prependToMemberExpression$1(member, prepend) {
	  if ((0, _index2.isSuper)(member.object)) {
	    throw new Error("Cannot prepend node to super property access (`super.foo`).");
	  }
	  member.object = (0, _index.memberExpression)(prepend, member.object);
	  return member;
	}

	
	return prependToMemberExpression;
}

var getBindingIdentifiers = {};

var hasRequiredGetBindingIdentifiers;

function requireGetBindingIdentifiers () {
	if (hasRequiredGetBindingIdentifiers) return getBindingIdentifiers;
	hasRequiredGetBindingIdentifiers = 1;

	Object.defineProperty(getBindingIdentifiers, "__esModule", {
	  value: true
	});
	getBindingIdentifiers.default = getBindingIdentifiers$1;
	var _index = requireGenerated$3();
	function getBindingIdentifiers$1(node, duplicates, outerOnly, newBindingsOnly) {
	  const search = [].concat(node);
	  const ids = Object.create(null);
	  while (search.length) {
	    const id = search.shift();
	    if (!id) continue;
	    if (newBindingsOnly && ((0, _index.isAssignmentExpression)(id) || (0, _index.isUnaryExpression)(id))) {
	      continue;
	    }
	    const keys = getBindingIdentifiers$1.keys[id.type];
	    if ((0, _index.isIdentifier)(id)) {
	      if (duplicates) {
	        const _ids = ids[id.name] = ids[id.name] || [];
	        _ids.push(id);
	      } else {
	        ids[id.name] = id;
	      }
	      continue;
	    }
	    if ((0, _index.isExportDeclaration)(id) && !(0, _index.isExportAllDeclaration)(id)) {
	      if ((0, _index.isDeclaration)(id.declaration)) {
	        search.push(id.declaration);
	      }
	      continue;
	    }
	    if (outerOnly) {
	      if ((0, _index.isFunctionDeclaration)(id)) {
	        search.push(id.id);
	        continue;
	      }
	      if ((0, _index.isFunctionExpression)(id)) {
	        continue;
	      }
	    }
	    if (keys) {
	      for (let i = 0; i < keys.length; i++) {
	        const key = keys[i];
	        const nodes = id[key];
	        if (nodes) {
	          Array.isArray(nodes) ? search.push(...nodes) : search.push(nodes);
	        }
	      }
	    }
	  }
	  return ids;
	}
	getBindingIdentifiers$1.keys = {
	  DeclareClass: ["id"],
	  DeclareFunction: ["id"],
	  DeclareModule: ["id"],
	  DeclareVariable: ["id"],
	  DeclareInterface: ["id"],
	  DeclareTypeAlias: ["id"],
	  DeclareOpaqueType: ["id"],
	  InterfaceDeclaration: ["id"],
	  TypeAlias: ["id"],
	  OpaqueType: ["id"],
	  CatchClause: ["param"],
	  LabeledStatement: ["label"],
	  UnaryExpression: ["argument"],
	  AssignmentExpression: ["left"],
	  ImportSpecifier: ["local"],
	  ImportNamespaceSpecifier: ["local"],
	  ImportDefaultSpecifier: ["local"],
	  ImportDeclaration: ["specifiers"],
	  ExportSpecifier: ["exported"],
	  ExportNamespaceSpecifier: ["exported"],
	  ExportDefaultSpecifier: ["exported"],
	  FunctionDeclaration: ["id", "params"],
	  FunctionExpression: ["id", "params"],
	  ArrowFunctionExpression: ["params"],
	  ObjectMethod: ["params"],
	  ClassMethod: ["params"],
	  ClassPrivateMethod: ["params"],
	  ForInStatement: ["left"],
	  ForOfStatement: ["left"],
	  ClassDeclaration: ["id"],
	  ClassExpression: ["id"],
	  RestElement: ["argument"],
	  UpdateExpression: ["argument"],
	  ObjectProperty: ["value"],
	  AssignmentPattern: ["left"],
	  ArrayPattern: ["elements"],
	  ObjectPattern: ["properties"],
	  VariableDeclaration: ["declarations"],
	  VariableDeclarator: ["id"]
	};

	
	return getBindingIdentifiers;
}

var getOuterBindingIdentifiers = {};

var hasRequiredGetOuterBindingIdentifiers;

function requireGetOuterBindingIdentifiers () {
	if (hasRequiredGetOuterBindingIdentifiers) return getOuterBindingIdentifiers;
	hasRequiredGetOuterBindingIdentifiers = 1;

	Object.defineProperty(getOuterBindingIdentifiers, "__esModule", {
	  value: true
	});
	getOuterBindingIdentifiers.default = void 0;
	var _getBindingIdentifiers = requireGetBindingIdentifiers();
	getOuterBindingIdentifiers.default = getOuterBindingIdentifiers$1;
	function getOuterBindingIdentifiers$1(node, duplicates) {
	  return (0, _getBindingIdentifiers.default)(node, duplicates, true);
	}

	
	return getOuterBindingIdentifiers;
}

var traverse = {};

var hasRequiredTraverse;

function requireTraverse () {
	if (hasRequiredTraverse) return traverse;
	hasRequiredTraverse = 1;

	Object.defineProperty(traverse, "__esModule", {
	  value: true
	});
	traverse.default = traverse$1;
	var _index = requireDefinitions();
	function traverse$1(node, handlers, state) {
	  if (typeof handlers === "function") {
	    handlers = {
	      enter: handlers
	    };
	  }
	  const {
	    enter,
	    exit
	  } = handlers;
	  traverseSimpleImpl(node, enter, exit, state, []);
	}
	function traverseSimpleImpl(node, enter, exit, state, ancestors) {
	  const keys = _index.VISITOR_KEYS[node.type];
	  if (!keys) return;
	  if (enter) enter(node, ancestors, state);
	  for (const key of keys) {
	    const subNode = node[key];
	    if (Array.isArray(subNode)) {
	      for (let i = 0; i < subNode.length; i++) {
	        const child = subNode[i];
	        if (!child) continue;
	        ancestors.push({
	          node,
	          key,
	          index: i
	        });
	        traverseSimpleImpl(child, enter, exit, state, ancestors);
	        ancestors.pop();
	      }
	    } else if (subNode) {
	      ancestors.push({
	        node,
	        key
	      });
	      traverseSimpleImpl(subNode, enter, exit, state, ancestors);
	      ancestors.pop();
	    }
	  }
	  if (exit) exit(node, ancestors, state);
	}

	
	return traverse;
}

var isBinding = {};

var hasRequiredIsBinding;

function requireIsBinding () {
	if (hasRequiredIsBinding) return isBinding;
	hasRequiredIsBinding = 1;

	Object.defineProperty(isBinding, "__esModule", {
	  value: true
	});
	isBinding.default = isBinding$1;
	var _getBindingIdentifiers = requireGetBindingIdentifiers();
	function isBinding$1(node, parent, grandparent) {
	  if (grandparent && node.type === "Identifier" && parent.type === "ObjectProperty" && grandparent.type === "ObjectExpression") {
	    return false;
	  }
	  const keys = _getBindingIdentifiers.default.keys[parent.type];
	  if (keys) {
	    for (let i = 0; i < keys.length; i++) {
	      const key = keys[i];
	      const val = parent[key];
	      if (Array.isArray(val)) {
	        if (val.indexOf(node) >= 0) return true;
	      } else {
	        if (val === node) return true;
	      }
	    }
	  }
	  return false;
	}

	
	return isBinding;
}

var isBlockScoped = {};

var isLet = {};

var hasRequiredIsLet;

function requireIsLet () {
	if (hasRequiredIsLet) return isLet;
	hasRequiredIsLet = 1;

	Object.defineProperty(isLet, "__esModule", {
	  value: true
	});
	isLet.default = isLet$1;
	var _index = requireGenerated$3();
	var _index2 = requireConstants();
	function isLet$1(node) {
	  return (0, _index.isVariableDeclaration)(node) && (node.kind !== "var" || node[_index2.BLOCK_SCOPED_SYMBOL]);
	}

	
	return isLet;
}

var hasRequiredIsBlockScoped;

function requireIsBlockScoped () {
	if (hasRequiredIsBlockScoped) return isBlockScoped;
	hasRequiredIsBlockScoped = 1;

	Object.defineProperty(isBlockScoped, "__esModule", {
	  value: true
	});
	isBlockScoped.default = isBlockScoped$1;
	var _index = requireGenerated$3();
	var _isLet = requireIsLet();
	function isBlockScoped$1(node) {
	  return (0, _index.isFunctionDeclaration)(node) || (0, _index.isClassDeclaration)(node) || (0, _isLet.default)(node);
	}

	
	return isBlockScoped;
}

var isImmutable = {};

var hasRequiredIsImmutable;

function requireIsImmutable () {
	if (hasRequiredIsImmutable) return isImmutable;
	hasRequiredIsImmutable = 1;

	Object.defineProperty(isImmutable, "__esModule", {
	  value: true
	});
	isImmutable.default = isImmutable$1;
	var _isType = requireIsType();
	var _index = requireGenerated$3();
	function isImmutable$1(node) {
	  if ((0, _isType.default)(node.type, "Immutable")) return true;
	  if ((0, _index.isIdentifier)(node)) {
	    if (node.name === "undefined") {
	      return true;
	    } else {
	      return false;
	    }
	  }
	  return false;
	}

	
	return isImmutable;
}

var isNodesEquivalent = {};

var hasRequiredIsNodesEquivalent;

function requireIsNodesEquivalent () {
	if (hasRequiredIsNodesEquivalent) return isNodesEquivalent;
	hasRequiredIsNodesEquivalent = 1;

	Object.defineProperty(isNodesEquivalent, "__esModule", {
	  value: true
	});
	isNodesEquivalent.default = isNodesEquivalent$1;
	var _index = requireDefinitions();
	function isNodesEquivalent$1(a, b) {
	  if (typeof a !== "object" || typeof b !== "object" || a == null || b == null) {
	    return a === b;
	  }
	  if (a.type !== b.type) {
	    return false;
	  }
	  const fields = Object.keys(_index.NODE_FIELDS[a.type] || a.type);
	  const visitorKeys = _index.VISITOR_KEYS[a.type];
	  for (const field of fields) {
	    const val_a = a[field];
	    const val_b = b[field];
	    if (typeof val_a !== typeof val_b) {
	      return false;
	    }
	    if (val_a == null && val_b == null) {
	      continue;
	    } else if (val_a == null || val_b == null) {
	      return false;
	    }
	    if (Array.isArray(val_a)) {
	      if (!Array.isArray(val_b)) {
	        return false;
	      }
	      if (val_a.length !== val_b.length) {
	        return false;
	      }
	      for (let i = 0; i < val_a.length; i++) {
	        if (!isNodesEquivalent$1(val_a[i], val_b[i])) {
	          return false;
	        }
	      }
	      continue;
	    }
	    if (typeof val_a === "object" && !(visitorKeys != null && visitorKeys.includes(field))) {
	      for (const key of Object.keys(val_a)) {
	        if (val_a[key] !== val_b[key]) {
	          return false;
	        }
	      }
	      continue;
	    }
	    if (!isNodesEquivalent$1(val_a, val_b)) {
	      return false;
	    }
	  }
	  return true;
	}

	
	return isNodesEquivalent;
}

var isReferenced = {};

var hasRequiredIsReferenced;

function requireIsReferenced () {
	if (hasRequiredIsReferenced) return isReferenced;
	hasRequiredIsReferenced = 1;

	Object.defineProperty(isReferenced, "__esModule", {
	  value: true
	});
	isReferenced.default = isReferenced$1;
	function isReferenced$1(node, parent, grandparent) {
	  switch (parent.type) {
	    case "MemberExpression":
	    case "OptionalMemberExpression":
	      if (parent.property === node) {
	        return !!parent.computed;
	      }
	      return parent.object === node;
	    case "JSXMemberExpression":
	      return parent.object === node;
	    case "VariableDeclarator":
	      return parent.init === node;
	    case "ArrowFunctionExpression":
	      return parent.body === node;
	    case "PrivateName":
	      return false;
	    case "ClassMethod":
	    case "ClassPrivateMethod":
	    case "ObjectMethod":
	      if (parent.key === node) {
	        return !!parent.computed;
	      }
	      return false;
	    case "ObjectProperty":
	      if (parent.key === node) {
	        return !!parent.computed;
	      }
	      return !grandparent || grandparent.type !== "ObjectPattern";
	    case "ClassProperty":
	    case "ClassAccessorProperty":
	      if (parent.key === node) {
	        return !!parent.computed;
	      }
	      return true;
	    case "ClassPrivateProperty":
	      return parent.key !== node;
	    case "ClassDeclaration":
	    case "ClassExpression":
	      return parent.superClass === node;
	    case "AssignmentExpression":
	      return parent.right === node;
	    case "AssignmentPattern":
	      return parent.right === node;
	    case "LabeledStatement":
	      return false;
	    case "CatchClause":
	      return false;
	    case "RestElement":
	      return false;
	    case "BreakStatement":
	    case "ContinueStatement":
	      return false;
	    case "FunctionDeclaration":
	    case "FunctionExpression":
	      return false;
	    case "ExportNamespaceSpecifier":
	    case "ExportDefaultSpecifier":
	      return false;
	    case "ExportSpecifier":
	      if (grandparent != null && grandparent.source) {
	        return false;
	      }
	      return parent.local === node;
	    case "ImportDefaultSpecifier":
	    case "ImportNamespaceSpecifier":
	    case "ImportSpecifier":
	      return false;
	    case "ImportAttribute":
	      return false;
	    case "JSXAttribute":
	      return false;
	    case "ObjectPattern":
	    case "ArrayPattern":
	      return false;
	    case "MetaProperty":
	      return false;
	    case "ObjectTypeProperty":
	      return parent.key !== node;
	    case "TSEnumMember":
	      return parent.id !== node;
	    case "TSPropertySignature":
	      if (parent.key === node) {
	        return !!parent.computed;
	      }
	      return true;
	  }
	  return true;
	}

	
	return isReferenced;
}

var isScope = {};

var hasRequiredIsScope;

function requireIsScope () {
	if (hasRequiredIsScope) return isScope;
	hasRequiredIsScope = 1;

	Object.defineProperty(isScope, "__esModule", {
	  value: true
	});
	isScope.default = isScope$1;
	var _index = requireGenerated$3();
	function isScope$1(node, parent) {
	  if ((0, _index.isBlockStatement)(node) && ((0, _index.isFunction)(parent) || (0, _index.isCatchClause)(parent))) {
	    return false;
	  }
	  if ((0, _index.isPattern)(node) && ((0, _index.isFunction)(parent) || (0, _index.isCatchClause)(parent))) {
	    return true;
	  }
	  return (0, _index.isScopable)(node);
	}

	
	return isScope;
}

var isSpecifierDefault = {};

var hasRequiredIsSpecifierDefault;

function requireIsSpecifierDefault () {
	if (hasRequiredIsSpecifierDefault) return isSpecifierDefault;
	hasRequiredIsSpecifierDefault = 1;

	Object.defineProperty(isSpecifierDefault, "__esModule", {
	  value: true
	});
	isSpecifierDefault.default = isSpecifierDefault$1;
	var _index = requireGenerated$3();
	function isSpecifierDefault$1(specifier) {
	  return (0, _index.isImportDefaultSpecifier)(specifier) || (0, _index.isIdentifier)(specifier.imported || specifier.exported, {
	    name: "default"
	  });
	}

	
	return isSpecifierDefault;
}

var isValidES3Identifier = {};

var hasRequiredIsValidES3Identifier;

function requireIsValidES3Identifier () {
	if (hasRequiredIsValidES3Identifier) return isValidES3Identifier;
	hasRequiredIsValidES3Identifier = 1;

	Object.defineProperty(isValidES3Identifier, "__esModule", {
	  value: true
	});
	isValidES3Identifier.default = isValidES3Identifier$1;
	var _isValidIdentifier = requireIsValidIdentifier();
	const RESERVED_WORDS_ES3_ONLY = new Set(["abstract", "boolean", "byte", "char", "double", "enum", "final", "float", "goto", "implements", "int", "interface", "long", "native", "package", "private", "protected", "public", "short", "static", "synchronized", "throws", "transient", "volatile"]);
	function isValidES3Identifier$1(name) {
	  return (0, _isValidIdentifier.default)(name) && !RESERVED_WORDS_ES3_ONLY.has(name);
	}

	
	return isValidES3Identifier;
}

var isVar = {};

var hasRequiredIsVar;

function requireIsVar () {
	if (hasRequiredIsVar) return isVar;
	hasRequiredIsVar = 1;

	Object.defineProperty(isVar, "__esModule", {
	  value: true
	});
	isVar.default = isVar$1;
	var _index = requireGenerated$3();
	var _index2 = requireConstants();
	function isVar$1(node) {
	  return (0, _index.isVariableDeclaration)(node, {
	    kind: "var"
	  }) && !node[_index2.BLOCK_SCOPED_SYMBOL];
	}

	
	return isVar;
}

var toSequenceExpression = {};

var gatherSequenceExpressions = {};

var hasRequiredGatherSequenceExpressions;

function requireGatherSequenceExpressions () {
	if (hasRequiredGatherSequenceExpressions) return gatherSequenceExpressions;
	hasRequiredGatherSequenceExpressions = 1;

	Object.defineProperty(gatherSequenceExpressions, "__esModule", {
	  value: true
	});
	gatherSequenceExpressions.default = gatherSequenceExpressions$1;
	var _getBindingIdentifiers = requireGetBindingIdentifiers();
	var _index = requireGenerated$3();
	var _index2 = requireGenerated$2();
	var _cloneNode = requireCloneNode();
	function gatherSequenceExpressions$1(nodes, scope, declars) {
	  const exprs = [];
	  let ensureLastUndefined = true;
	  for (const node of nodes) {
	    if (!(0, _index.isEmptyStatement)(node)) {
	      ensureLastUndefined = false;
	    }
	    if ((0, _index.isExpression)(node)) {
	      exprs.push(node);
	    } else if ((0, _index.isExpressionStatement)(node)) {
	      exprs.push(node.expression);
	    } else if ((0, _index.isVariableDeclaration)(node)) {
	      if (node.kind !== "var") return;
	      for (const declar of node.declarations) {
	        const bindings = (0, _getBindingIdentifiers.default)(declar);
	        for (const key of Object.keys(bindings)) {
	          declars.push({
	            kind: node.kind,
	            id: (0, _cloneNode.default)(bindings[key])
	          });
	        }
	        if (declar.init) {
	          exprs.push((0, _index2.assignmentExpression)("=", declar.id, declar.init));
	        }
	      }
	      ensureLastUndefined = true;
	    } else if ((0, _index.isIfStatement)(node)) {
	      const consequent = node.consequent ? gatherSequenceExpressions$1([node.consequent], scope, declars) : scope.buildUndefinedNode();
	      const alternate = node.alternate ? gatherSequenceExpressions$1([node.alternate], scope, declars) : scope.buildUndefinedNode();
	      if (!consequent || !alternate) return;
	      exprs.push((0, _index2.conditionalExpression)(node.test, consequent, alternate));
	    } else if ((0, _index.isBlockStatement)(node)) {
	      const body = gatherSequenceExpressions$1(node.body, scope, declars);
	      if (!body) return;
	      exprs.push(body);
	    } else if ((0, _index.isEmptyStatement)(node)) {
	      if (nodes.indexOf(node) === 0) {
	        ensureLastUndefined = true;
	      }
	    } else {
	      return;
	    }
	  }
	  if (ensureLastUndefined) {
	    exprs.push(scope.buildUndefinedNode());
	  }
	  if (exprs.length === 1) {
	    return exprs[0];
	  } else {
	    return (0, _index2.sequenceExpression)(exprs);
	  }
	}

	
	return gatherSequenceExpressions;
}

var hasRequiredToSequenceExpression;

function requireToSequenceExpression () {
	if (hasRequiredToSequenceExpression) return toSequenceExpression;
	hasRequiredToSequenceExpression = 1;

	Object.defineProperty(toSequenceExpression, "__esModule", {
	  value: true
	});
	toSequenceExpression.default = toSequenceExpression$1;
	var _gatherSequenceExpressions = requireGatherSequenceExpressions();
	function toSequenceExpression$1(nodes, scope) {
	  if (!(nodes != null && nodes.length)) return;
	  const declars = [];
	  const result = (0, _gatherSequenceExpressions.default)(nodes, scope, declars);
	  if (!result) return;
	  for (const declar of declars) {
	    scope.push(declar);
	  }
	  return result;
	}

	
	return toSequenceExpression;
}

var hasRequiredLib$h;

function requireLib$h () {
	if (hasRequiredLib$h) return lib$g;
	hasRequiredLib$h = 1;
	(function (exports) {

		Object.defineProperty(exports, "__esModule", {
		  value: true
		});
		var _exportNames = {
		  react: true,
		  assertNode: true,
		  createTypeAnnotationBasedOnTypeof: true,
		  createUnionTypeAnnotation: true,
		  createFlowUnionType: true,
		  createTSUnionType: true,
		  cloneNode: true,
		  clone: true,
		  cloneDeep: true,
		  cloneDeepWithoutLoc: true,
		  cloneWithoutLoc: true,
		  addComment: true,
		  addComments: true,
		  inheritInnerComments: true,
		  inheritLeadingComments: true,
		  inheritsComments: true,
		  inheritTrailingComments: true,
		  removeComments: true,
		  ensureBlock: true,
		  toBindingIdentifierName: true,
		  toBlock: true,
		  toComputedKey: true,
		  toExpression: true,
		  toIdentifier: true,
		  toKeyAlias: true,
		  toStatement: true,
		  valueToNode: true,
		  appendToMemberExpression: true,
		  inherits: true,
		  prependToMemberExpression: true,
		  removeProperties: true,
		  removePropertiesDeep: true,
		  removeTypeDuplicates: true,
		  getBindingIdentifiers: true,
		  getOuterBindingIdentifiers: true,
		  traverse: true,
		  traverseFast: true,
		  shallowEqual: true,
		  is: true,
		  isBinding: true,
		  isBlockScoped: true,
		  isImmutable: true,
		  isLet: true,
		  isNode: true,
		  isNodesEquivalent: true,
		  isPlaceholderType: true,
		  isReferenced: true,
		  isScope: true,
		  isSpecifierDefault: true,
		  isType: true,
		  isValidES3Identifier: true,
		  isValidIdentifier: true,
		  isVar: true,
		  matchesPattern: true,
		  validate: true,
		  buildMatchMemberExpression: true,
		  __internal__deprecationWarning: true
		};
		Object.defineProperty(exports, "__internal__deprecationWarning", {
		  enumerable: true,
		  get: function () {
		    return _deprecationWarning.default;
		  }
		});
		Object.defineProperty(exports, "addComment", {
		  enumerable: true,
		  get: function () {
		    return _addComment.default;
		  }
		});
		Object.defineProperty(exports, "addComments", {
		  enumerable: true,
		  get: function () {
		    return _addComments.default;
		  }
		});
		Object.defineProperty(exports, "appendToMemberExpression", {
		  enumerable: true,
		  get: function () {
		    return _appendToMemberExpression.default;
		  }
		});
		Object.defineProperty(exports, "assertNode", {
		  enumerable: true,
		  get: function () {
		    return _assertNode.default;
		  }
		});
		Object.defineProperty(exports, "buildMatchMemberExpression", {
		  enumerable: true,
		  get: function () {
		    return _buildMatchMemberExpression.default;
		  }
		});
		Object.defineProperty(exports, "clone", {
		  enumerable: true,
		  get: function () {
		    return _clone.default;
		  }
		});
		Object.defineProperty(exports, "cloneDeep", {
		  enumerable: true,
		  get: function () {
		    return _cloneDeep.default;
		  }
		});
		Object.defineProperty(exports, "cloneDeepWithoutLoc", {
		  enumerable: true,
		  get: function () {
		    return _cloneDeepWithoutLoc.default;
		  }
		});
		Object.defineProperty(exports, "cloneNode", {
		  enumerable: true,
		  get: function () {
		    return _cloneNode.default;
		  }
		});
		Object.defineProperty(exports, "cloneWithoutLoc", {
		  enumerable: true,
		  get: function () {
		    return _cloneWithoutLoc.default;
		  }
		});
		Object.defineProperty(exports, "createFlowUnionType", {
		  enumerable: true,
		  get: function () {
		    return _createFlowUnionType.default;
		  }
		});
		Object.defineProperty(exports, "createTSUnionType", {
		  enumerable: true,
		  get: function () {
		    return _createTSUnionType.default;
		  }
		});
		Object.defineProperty(exports, "createTypeAnnotationBasedOnTypeof", {
		  enumerable: true,
		  get: function () {
		    return _createTypeAnnotationBasedOnTypeof.default;
		  }
		});
		Object.defineProperty(exports, "createUnionTypeAnnotation", {
		  enumerable: true,
		  get: function () {
		    return _createFlowUnionType.default;
		  }
		});
		Object.defineProperty(exports, "ensureBlock", {
		  enumerable: true,
		  get: function () {
		    return _ensureBlock.default;
		  }
		});
		Object.defineProperty(exports, "getBindingIdentifiers", {
		  enumerable: true,
		  get: function () {
		    return _getBindingIdentifiers.default;
		  }
		});
		Object.defineProperty(exports, "getOuterBindingIdentifiers", {
		  enumerable: true,
		  get: function () {
		    return _getOuterBindingIdentifiers.default;
		  }
		});
		Object.defineProperty(exports, "inheritInnerComments", {
		  enumerable: true,
		  get: function () {
		    return _inheritInnerComments.default;
		  }
		});
		Object.defineProperty(exports, "inheritLeadingComments", {
		  enumerable: true,
		  get: function () {
		    return _inheritLeadingComments.default;
		  }
		});
		Object.defineProperty(exports, "inheritTrailingComments", {
		  enumerable: true,
		  get: function () {
		    return _inheritTrailingComments.default;
		  }
		});
		Object.defineProperty(exports, "inherits", {
		  enumerable: true,
		  get: function () {
		    return _inherits.default;
		  }
		});
		Object.defineProperty(exports, "inheritsComments", {
		  enumerable: true,
		  get: function () {
		    return _inheritsComments.default;
		  }
		});
		Object.defineProperty(exports, "is", {
		  enumerable: true,
		  get: function () {
		    return _is.default;
		  }
		});
		Object.defineProperty(exports, "isBinding", {
		  enumerable: true,
		  get: function () {
		    return _isBinding.default;
		  }
		});
		Object.defineProperty(exports, "isBlockScoped", {
		  enumerable: true,
		  get: function () {
		    return _isBlockScoped.default;
		  }
		});
		Object.defineProperty(exports, "isImmutable", {
		  enumerable: true,
		  get: function () {
		    return _isImmutable.default;
		  }
		});
		Object.defineProperty(exports, "isLet", {
		  enumerable: true,
		  get: function () {
		    return _isLet.default;
		  }
		});
		Object.defineProperty(exports, "isNode", {
		  enumerable: true,
		  get: function () {
		    return _isNode.default;
		  }
		});
		Object.defineProperty(exports, "isNodesEquivalent", {
		  enumerable: true,
		  get: function () {
		    return _isNodesEquivalent.default;
		  }
		});
		Object.defineProperty(exports, "isPlaceholderType", {
		  enumerable: true,
		  get: function () {
		    return _isPlaceholderType.default;
		  }
		});
		Object.defineProperty(exports, "isReferenced", {
		  enumerable: true,
		  get: function () {
		    return _isReferenced.default;
		  }
		});
		Object.defineProperty(exports, "isScope", {
		  enumerable: true,
		  get: function () {
		    return _isScope.default;
		  }
		});
		Object.defineProperty(exports, "isSpecifierDefault", {
		  enumerable: true,
		  get: function () {
		    return _isSpecifierDefault.default;
		  }
		});
		Object.defineProperty(exports, "isType", {
		  enumerable: true,
		  get: function () {
		    return _isType.default;
		  }
		});
		Object.defineProperty(exports, "isValidES3Identifier", {
		  enumerable: true,
		  get: function () {
		    return _isValidES3Identifier.default;
		  }
		});
		Object.defineProperty(exports, "isValidIdentifier", {
		  enumerable: true,
		  get: function () {
		    return _isValidIdentifier.default;
		  }
		});
		Object.defineProperty(exports, "isVar", {
		  enumerable: true,
		  get: function () {
		    return _isVar.default;
		  }
		});
		Object.defineProperty(exports, "matchesPattern", {
		  enumerable: true,
		  get: function () {
		    return _matchesPattern.default;
		  }
		});
		Object.defineProperty(exports, "prependToMemberExpression", {
		  enumerable: true,
		  get: function () {
		    return _prependToMemberExpression.default;
		  }
		});
		exports.react = void 0;
		Object.defineProperty(exports, "removeComments", {
		  enumerable: true,
		  get: function () {
		    return _removeComments.default;
		  }
		});
		Object.defineProperty(exports, "removeProperties", {
		  enumerable: true,
		  get: function () {
		    return _removeProperties.default;
		  }
		});
		Object.defineProperty(exports, "removePropertiesDeep", {
		  enumerable: true,
		  get: function () {
		    return _removePropertiesDeep.default;
		  }
		});
		Object.defineProperty(exports, "removeTypeDuplicates", {
		  enumerable: true,
		  get: function () {
		    return _removeTypeDuplicates.default;
		  }
		});
		Object.defineProperty(exports, "shallowEqual", {
		  enumerable: true,
		  get: function () {
		    return _shallowEqual.default;
		  }
		});
		Object.defineProperty(exports, "toBindingIdentifierName", {
		  enumerable: true,
		  get: function () {
		    return _toBindingIdentifierName.default;
		  }
		});
		Object.defineProperty(exports, "toBlock", {
		  enumerable: true,
		  get: function () {
		    return _toBlock.default;
		  }
		});
		Object.defineProperty(exports, "toComputedKey", {
		  enumerable: true,
		  get: function () {
		    return _toComputedKey.default;
		  }
		});
		Object.defineProperty(exports, "toExpression", {
		  enumerable: true,
		  get: function () {
		    return _toExpression.default;
		  }
		});
		Object.defineProperty(exports, "toIdentifier", {
		  enumerable: true,
		  get: function () {
		    return _toIdentifier.default;
		  }
		});
		Object.defineProperty(exports, "toKeyAlias", {
		  enumerable: true,
		  get: function () {
		    return _toKeyAlias.default;
		  }
		});
		Object.defineProperty(exports, "toStatement", {
		  enumerable: true,
		  get: function () {
		    return _toStatement.default;
		  }
		});
		Object.defineProperty(exports, "traverse", {
		  enumerable: true,
		  get: function () {
		    return _traverse.default;
		  }
		});
		Object.defineProperty(exports, "traverseFast", {
		  enumerable: true,
		  get: function () {
		    return _traverseFast.default;
		  }
		});
		Object.defineProperty(exports, "validate", {
		  enumerable: true,
		  get: function () {
		    return _validate.default;
		  }
		});
		Object.defineProperty(exports, "valueToNode", {
		  enumerable: true,
		  get: function () {
		    return _valueToNode.default;
		  }
		});
		var _isReactComponent = requireIsReactComponent();
		var _isCompatTag = requireIsCompatTag();
		var _buildChildren = requireBuildChildren();
		var _assertNode = requireAssertNode();
		var _index = requireGenerated$1();
		Object.keys(_index).forEach(function (key) {
		  if (key === "default" || key === "__esModule") return;
		  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
		  if (key in exports && exports[key] === _index[key]) return;
		  Object.defineProperty(exports, key, {
		    enumerable: true,
		    get: function () {
		      return _index[key];
		    }
		  });
		});
		var _createTypeAnnotationBasedOnTypeof = requireCreateTypeAnnotationBasedOnTypeof();
		var _createFlowUnionType = requireCreateFlowUnionType();
		var _createTSUnionType = requireCreateTSUnionType();
		var _index2 = requireGenerated$2();
		Object.keys(_index2).forEach(function (key) {
		  if (key === "default" || key === "__esModule") return;
		  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
		  if (key in exports && exports[key] === _index2[key]) return;
		  Object.defineProperty(exports, key, {
		    enumerable: true,
		    get: function () {
		      return _index2[key];
		    }
		  });
		});
		var _uppercase = requireUppercase();
		Object.keys(_uppercase).forEach(function (key) {
		  if (key === "default" || key === "__esModule") return;
		  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
		  if (key in exports && exports[key] === _uppercase[key]) return;
		  Object.defineProperty(exports, key, {
		    enumerable: true,
		    get: function () {
		      return _uppercase[key];
		    }
		  });
		});
		var _productions = requireProductions();
		Object.keys(_productions).forEach(function (key) {
		  if (key === "default" || key === "__esModule") return;
		  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
		  if (key in exports && exports[key] === _productions[key]) return;
		  Object.defineProperty(exports, key, {
		    enumerable: true,
		    get: function () {
		      return _productions[key];
		    }
		  });
		});
		var _cloneNode = requireCloneNode();
		var _clone = requireClone();
		var _cloneDeep = requireCloneDeep();
		var _cloneDeepWithoutLoc = requireCloneDeepWithoutLoc();
		var _cloneWithoutLoc = requireCloneWithoutLoc();
		var _addComment = requireAddComment();
		var _addComments = requireAddComments();
		var _inheritInnerComments = requireInheritInnerComments();
		var _inheritLeadingComments = requireInheritLeadingComments();
		var _inheritsComments = requireInheritsComments();
		var _inheritTrailingComments = requireInheritTrailingComments();
		var _removeComments = requireRemoveComments();
		var _index3 = requireGenerated();
		Object.keys(_index3).forEach(function (key) {
		  if (key === "default" || key === "__esModule") return;
		  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
		  if (key in exports && exports[key] === _index3[key]) return;
		  Object.defineProperty(exports, key, {
		    enumerable: true,
		    get: function () {
		      return _index3[key];
		    }
		  });
		});
		var _index4 = requireConstants();
		Object.keys(_index4).forEach(function (key) {
		  if (key === "default" || key === "__esModule") return;
		  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
		  if (key in exports && exports[key] === _index4[key]) return;
		  Object.defineProperty(exports, key, {
		    enumerable: true,
		    get: function () {
		      return _index4[key];
		    }
		  });
		});
		var _ensureBlock = requireEnsureBlock();
		var _toBindingIdentifierName = requireToBindingIdentifierName();
		var _toBlock = requireToBlock();
		var _toComputedKey = requireToComputedKey();
		var _toExpression = requireToExpression();
		var _toIdentifier = requireToIdentifier();
		var _toKeyAlias = requireToKeyAlias();
		var _toStatement = requireToStatement();
		var _valueToNode = requireValueToNode();
		var _index5 = requireDefinitions();
		Object.keys(_index5).forEach(function (key) {
		  if (key === "default" || key === "__esModule") return;
		  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
		  if (key in exports && exports[key] === _index5[key]) return;
		  Object.defineProperty(exports, key, {
		    enumerable: true,
		    get: function () {
		      return _index5[key];
		    }
		  });
		});
		var _appendToMemberExpression = requireAppendToMemberExpression();
		var _inherits = requireInherits();
		var _prependToMemberExpression = requirePrependToMemberExpression();
		var _removeProperties = requireRemoveProperties();
		var _removePropertiesDeep = requireRemovePropertiesDeep();
		var _removeTypeDuplicates = requireRemoveTypeDuplicates$1();
		var _getBindingIdentifiers = requireGetBindingIdentifiers();
		var _getOuterBindingIdentifiers = requireGetOuterBindingIdentifiers();
		var _traverse = requireTraverse();
		Object.keys(_traverse).forEach(function (key) {
		  if (key === "default" || key === "__esModule") return;
		  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
		  if (key in exports && exports[key] === _traverse[key]) return;
		  Object.defineProperty(exports, key, {
		    enumerable: true,
		    get: function () {
		      return _traverse[key];
		    }
		  });
		});
		var _traverseFast = requireTraverseFast();
		var _shallowEqual = requireShallowEqual();
		var _is = requireIs();
		var _isBinding = requireIsBinding();
		var _isBlockScoped = requireIsBlockScoped();
		var _isImmutable = requireIsImmutable();
		var _isLet = requireIsLet();
		var _isNode = requireIsNode();
		var _isNodesEquivalent = requireIsNodesEquivalent();
		var _isPlaceholderType = requireIsPlaceholderType();
		var _isReferenced = requireIsReferenced();
		var _isScope = requireIsScope();
		var _isSpecifierDefault = requireIsSpecifierDefault();
		var _isType = requireIsType();
		var _isValidES3Identifier = requireIsValidES3Identifier();
		var _isValidIdentifier = requireIsValidIdentifier();
		var _isVar = requireIsVar();
		var _matchesPattern = requireMatchesPattern();
		var _validate = requireValidate();
		var _buildMatchMemberExpression = requireBuildMatchMemberExpression();
		var _index6 = requireGenerated$3();
		Object.keys(_index6).forEach(function (key) {
		  if (key === "default" || key === "__esModule") return;
		  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
		  if (key in exports && exports[key] === _index6[key]) return;
		  Object.defineProperty(exports, key, {
		    enumerable: true,
		    get: function () {
		      return _index6[key];
		    }
		  });
		});
		var _deprecationWarning = requireDeprecationWarning();
		exports.react = {
		  isReactComponent: _isReactComponent.default,
		  isCompatTag: _isCompatTag.default,
		  buildChildren: _buildChildren.default
		};
		{
		  exports.toSequenceExpression = requireToSequenceExpression().default;
		}

		
	} (lib$g));
	return lib$g;
}

var hasRequiredVirtualTypesValidator;

function requireVirtualTypesValidator () {
	if (hasRequiredVirtualTypesValidator) return virtualTypesValidator;
	hasRequiredVirtualTypesValidator = 1;

	Object.defineProperty(virtualTypesValidator, "__esModule", {
	  value: true
	});
	virtualTypesValidator.isBindingIdentifier = isBindingIdentifier;
	virtualTypesValidator.isBlockScoped = isBlockScoped;
	virtualTypesValidator.isExpression = isExpression;
	virtualTypesValidator.isFlow = isFlow;
	virtualTypesValidator.isForAwaitStatement = isForAwaitStatement;
	virtualTypesValidator.isGenerated = isGenerated;
	virtualTypesValidator.isPure = isPure;
	virtualTypesValidator.isReferenced = isReferenced;
	virtualTypesValidator.isReferencedIdentifier = isReferencedIdentifier;
	virtualTypesValidator.isReferencedMemberExpression = isReferencedMemberExpression;
	virtualTypesValidator.isRestProperty = isRestProperty;
	virtualTypesValidator.isScope = isScope;
	virtualTypesValidator.isSpreadProperty = isSpreadProperty;
	virtualTypesValidator.isStatement = isStatement;
	virtualTypesValidator.isUser = isUser;
	virtualTypesValidator.isVar = isVar;
	var _t = requireLib$h();
	const {
	  isBinding,
	  isBlockScoped: nodeIsBlockScoped,
	  isExportDeclaration,
	  isExpression: nodeIsExpression,
	  isFlow: nodeIsFlow,
	  isForStatement,
	  isForXStatement,
	  isIdentifier,
	  isImportDeclaration,
	  isImportSpecifier,
	  isJSXIdentifier,
	  isJSXMemberExpression,
	  isMemberExpression,
	  isRestElement: nodeIsRestElement,
	  isReferenced: nodeIsReferenced,
	  isScope: nodeIsScope,
	  isStatement: nodeIsStatement,
	  isVar: nodeIsVar,
	  isVariableDeclaration,
	  react,
	  isForOfStatement
	} = _t;
	const {
	  isCompatTag
	} = react;
	function isReferencedIdentifier(opts) {
	  const {
	    node,
	    parent
	  } = this;
	  if (!isIdentifier(node, opts) && !isJSXMemberExpression(parent, opts)) {
	    if (isJSXIdentifier(node, opts)) {
	      if (isCompatTag(node.name)) return false;
	    } else {
	      return false;
	    }
	  }
	  return nodeIsReferenced(node, parent, this.parentPath.parent);
	}
	function isReferencedMemberExpression() {
	  const {
	    node,
	    parent
	  } = this;
	  return isMemberExpression(node) && nodeIsReferenced(node, parent);
	}
	function isBindingIdentifier() {
	  const {
	    node,
	    parent
	  } = this;
	  const grandparent = this.parentPath.parent;
	  return isIdentifier(node) && isBinding(node, parent, grandparent);
	}
	function isStatement() {
	  const {
	    node,
	    parent
	  } = this;
	  if (nodeIsStatement(node)) {
	    if (isVariableDeclaration(node)) {
	      if (isForXStatement(parent, {
	        left: node
	      })) return false;
	      if (isForStatement(parent, {
	        init: node
	      })) return false;
	    }
	    return true;
	  } else {
	    return false;
	  }
	}
	function isExpression() {
	  if (this.isIdentifier()) {
	    return this.isReferencedIdentifier();
	  } else {
	    return nodeIsExpression(this.node);
	  }
	}
	function isScope() {
	  return nodeIsScope(this.node, this.parent);
	}
	function isReferenced() {
	  return nodeIsReferenced(this.node, this.parent);
	}
	function isBlockScoped() {
	  return nodeIsBlockScoped(this.node);
	}
	function isVar() {
	  return nodeIsVar(this.node);
	}
	function isUser() {
	  return this.node && !!this.node.loc;
	}
	function isGenerated() {
	  return !this.isUser();
	}
	function isPure(constantsOnly) {
	  return this.scope.isPure(this.node, constantsOnly);
	}
	function isFlow() {
	  const {
	    node
	  } = this;
	  if (nodeIsFlow(node)) {
	    return true;
	  } else if (isImportDeclaration(node)) {
	    return node.importKind === "type" || node.importKind === "typeof";
	  } else if (isExportDeclaration(node)) {
	    return node.exportKind === "type";
	  } else if (isImportSpecifier(node)) {
	    return node.importKind === "type" || node.importKind === "typeof";
	  } else {
	    return false;
	  }
	}
	function isRestProperty() {
	  var _this$parentPath;
	  return nodeIsRestElement(this.node) && ((_this$parentPath = this.parentPath) == null ? void 0 : _this$parentPath.isObjectPattern());
	}
	function isSpreadProperty() {
	  var _this$parentPath2;
	  return nodeIsRestElement(this.node) && ((_this$parentPath2 = this.parentPath) == null ? void 0 : _this$parentPath2.isObjectExpression());
	}
	function isForAwaitStatement() {
	  return isForOfStatement(this.node, {
	    await: true
	  });
	}
	{
	  virtualTypesValidator.isExistentialTypeParam = function isExistentialTypeParam() {
	    throw new Error("`path.isExistentialTypeParam` has been renamed to `path.isExistsTypeAnnotation()` in Babel 7.");
	  };
	  virtualTypesValidator.isNumericLiteralTypeAnnotation = function isNumericLiteralTypeAnnotation() {
	    throw new Error("`path.isNumericLiteralTypeAnnotation()` has been renamed to `path.isNumberLiteralTypeAnnotation()` in Babel 7.");
	  };
	}

	
	return virtualTypesValidator;
}

var hasRequiredVisitors;

function requireVisitors () {
	if (hasRequiredVisitors) return visitors;
	hasRequiredVisitors = 1;

	Object.defineProperty(visitors, "__esModule", {
	  value: true
	});
	visitors.explode = explode;
	visitors.isExplodedVisitor = isExplodedVisitor;
	visitors.merge = merge;
	visitors.verify = verify;
	var virtualTypes = requireVirtualTypes();
	var virtualTypesValidators = requireVirtualTypesValidator();
	var _t = requireLib$h();
	const {
	  DEPRECATED_KEYS,
	  DEPRECATED_ALIASES,
	  FLIPPED_ALIAS_KEYS,
	  TYPES,
	  __internal__deprecationWarning: deprecationWarning
	} = _t;
	function isVirtualType(type) {
	  return type in virtualTypes;
	}
	function isExplodedVisitor(visitor) {
	  return visitor == null ? void 0 : visitor._exploded;
	}
	function explode(visitor) {
	  if (isExplodedVisitor(visitor)) return visitor;
	  visitor._exploded = true;
	  for (const nodeType of Object.keys(visitor)) {
	    if (shouldIgnoreKey(nodeType)) continue;
	    const parts = nodeType.split("|");
	    if (parts.length === 1) continue;
	    const fns = visitor[nodeType];
	    delete visitor[nodeType];
	    for (const part of parts) {
	      visitor[part] = fns;
	    }
	  }
	  verify(visitor);
	  delete visitor.__esModule;
	  ensureEntranceObjects(visitor);
	  ensureCallbackArrays(visitor);
	  for (const nodeType of Object.keys(visitor)) {
	    if (shouldIgnoreKey(nodeType)) continue;
	    if (!isVirtualType(nodeType)) continue;
	    const fns = visitor[nodeType];
	    for (const type of Object.keys(fns)) {
	      fns[type] = wrapCheck(nodeType, fns[type]);
	    }
	    delete visitor[nodeType];
	    const types = virtualTypes[nodeType];
	    if (types !== null) {
	      for (const type of types) {
	        if (visitor[type]) {
	          mergePair(visitor[type], fns);
	        } else {
	          visitor[type] = fns;
	        }
	      }
	    } else {
	      mergePair(visitor, fns);
	    }
	  }
	  for (const nodeType of Object.keys(visitor)) {
	    if (shouldIgnoreKey(nodeType)) continue;
	    let aliases = FLIPPED_ALIAS_KEYS[nodeType];
	    if (nodeType in DEPRECATED_KEYS) {
	      const deprecatedKey = DEPRECATED_KEYS[nodeType];
	      deprecationWarning(nodeType, deprecatedKey, "Visitor ");
	      aliases = [deprecatedKey];
	    } else if (nodeType in DEPRECATED_ALIASES) {
	      const deprecatedAlias = DEPRECATED_ALIASES[nodeType];
	      deprecationWarning(nodeType, deprecatedAlias, "Visitor ");
	      aliases = FLIPPED_ALIAS_KEYS[deprecatedAlias];
	    }
	    if (!aliases) continue;
	    const fns = visitor[nodeType];
	    delete visitor[nodeType];
	    for (const alias of aliases) {
	      const existing = visitor[alias];
	      if (existing) {
	        mergePair(existing, fns);
	      } else {
	        visitor[alias] = Object.assign({}, fns);
	      }
	    }
	  }
	  for (const nodeType of Object.keys(visitor)) {
	    if (shouldIgnoreKey(nodeType)) continue;
	    ensureCallbackArrays(visitor[nodeType]);
	  }
	  return visitor;
	}
	function verify(visitor) {
	  if (visitor._verified) return;
	  if (typeof visitor === "function") {
	    throw new Error("You passed `traverse()` a function when it expected a visitor object, " + "are you sure you didn't mean `{ enter: Function }`?");
	  }
	  for (const nodeType of Object.keys(visitor)) {
	    if (nodeType === "enter" || nodeType === "exit") {
	      validateVisitorMethods(nodeType, visitor[nodeType]);
	    }
	    if (shouldIgnoreKey(nodeType)) continue;
	    if (TYPES.indexOf(nodeType) < 0) {
	      throw new Error(`You gave us a visitor for the node type ${nodeType} but it's not a valid type`);
	    }
	    const visitors = visitor[nodeType];
	    if (typeof visitors === "object") {
	      for (const visitorKey of Object.keys(visitors)) {
	        if (visitorKey === "enter" || visitorKey === "exit") {
	          validateVisitorMethods(`${nodeType}.${visitorKey}`, visitors[visitorKey]);
	        } else {
	          throw new Error("You passed `traverse()` a visitor object with the property " + `${nodeType} that has the invalid property ${visitorKey}`);
	        }
	      }
	    }
	  }
	  visitor._verified = true;
	}
	function validateVisitorMethods(path, val) {
	  const fns = [].concat(val);
	  for (const fn of fns) {
	    if (typeof fn !== "function") {
	      throw new TypeError(`Non-function found defined in ${path} with type ${typeof fn}`);
	    }
	  }
	}
	function merge(visitors, states = [], wrapper) {
	  const mergedVisitor = {};
	  for (let i = 0; i < visitors.length; i++) {
	    const visitor = explode(visitors[i]);
	    const state = states[i];
	    let topVisitor = visitor;
	    if (state || wrapper) {
	      topVisitor = wrapWithStateOrWrapper(topVisitor, state, wrapper);
	    }
	    mergePair(mergedVisitor, topVisitor);
	    for (const key of Object.keys(visitor)) {
	      if (shouldIgnoreKey(key)) continue;
	      let typeVisitor = visitor[key];
	      if (state || wrapper) {
	        typeVisitor = wrapWithStateOrWrapper(typeVisitor, state, wrapper);
	      }
	      const nodeVisitor = mergedVisitor[key] || (mergedVisitor[key] = {});
	      mergePair(nodeVisitor, typeVisitor);
	    }
	  }
	  return mergedVisitor;
	}
	function wrapWithStateOrWrapper(oldVisitor, state, wrapper) {
	  const newVisitor = {};
	  for (const phase of ["enter", "exit"]) {
	    let fns = oldVisitor[phase];
	    if (!Array.isArray(fns)) continue;
	    fns = fns.map(function (fn) {
	      let newFn = fn;
	      if (state) {
	        newFn = function (path) {
	          fn.call(state, path, state);
	        };
	      }
	      if (wrapper) {
	        newFn = wrapper(state == null ? void 0 : state.key, phase, newFn);
	      }
	      if (newFn !== fn) {
	        newFn.toString = () => fn.toString();
	      }
	      return newFn;
	    });
	    newVisitor[phase] = fns;
	  }
	  return newVisitor;
	}
	function ensureEntranceObjects(obj) {
	  for (const key of Object.keys(obj)) {
	    if (shouldIgnoreKey(key)) continue;
	    const fns = obj[key];
	    if (typeof fns === "function") {
	      obj[key] = {
	        enter: fns
	      };
	    }
	  }
	}
	function ensureCallbackArrays(obj) {
	  if (obj.enter && !Array.isArray(obj.enter)) obj.enter = [obj.enter];
	  if (obj.exit && !Array.isArray(obj.exit)) obj.exit = [obj.exit];
	}
	function wrapCheck(nodeType, fn) {
	  const fnKey = `is${nodeType}`;
	  const validator = virtualTypesValidators[fnKey];
	  const newFn = function (path) {
	    if (validator.call(path)) {
	      return fn.apply(this, arguments);
	    }
	  };
	  newFn.toString = () => fn.toString();
	  return newFn;
	}
	function shouldIgnoreKey(key) {
	  if (key[0] === "_") return true;
	  if (key === "enter" || key === "exit" || key === "shouldSkip") return true;
	  if (key === "denylist" || key === "noScope" || key === "skipKeys") {
	    return true;
	  }
	  {
	    if (key === "blacklist") {
	      return true;
	    }
	  }
	  return false;
	}
	function mergePair(dest, src) {
	  for (const phase of ["enter", "exit"]) {
	    if (!src[phase]) continue;
	    dest[phase] = [].concat(dest[phase] || [], src[phase]);
	  }
	}

	
	return visitors;
}

var cache$1 = {};

var hasRequiredCache;

function requireCache () {
	if (hasRequiredCache) return cache$1;
	hasRequiredCache = 1;

	Object.defineProperty(cache$1, "__esModule", {
	  value: true
	});
	cache$1.clear = clear;
	cache$1.clearPath = clearPath;
	cache$1.clearScope = clearScope;
	cache$1.getCachedPaths = getCachedPaths;
	cache$1.getOrCreateCachedPaths = getOrCreateCachedPaths;
	cache$1.scope = cache$1.path = void 0;
	let pathsCache = cache$1.path = new WeakMap();
	cache$1.scope = new WeakMap();
	function clear() {
	  clearPath();
	  clearScope();
	}
	function clearPath() {
	  cache$1.path = pathsCache = new WeakMap();
	}
	function clearScope() {
	  cache$1.scope = new WeakMap();
	}
	const nullHub = Object.freeze({});
	function getCachedPaths(hub, parent) {
	  var _pathsCache$get, _hub;
	  {
	    hub = null;
	  }
	  return (_pathsCache$get = pathsCache.get((_hub = hub) != null ? _hub : nullHub)) == null ? void 0 : _pathsCache$get.get(parent);
	}
	function getOrCreateCachedPaths(hub, parent) {
	  var _hub2, _hub3;
	  {
	    hub = null;
	  }
	  let parents = pathsCache.get((_hub2 = hub) != null ? _hub2 : nullHub);
	  if (!parents) pathsCache.set((_hub3 = hub) != null ? _hub3 : nullHub, parents = new WeakMap());
	  let paths = parents.get(parent);
	  if (!paths) parents.set(parent, paths = new Map());
	  return paths;
	}

	
	return cache$1;
}

var traverseNode = {};

var context$1 = {};

var path$6 = {};

var scope = {};

var renamer = {};

var lib$d = {};

var hasRequiredLib$g;

function requireLib$g () {
	if (hasRequiredLib$g) return lib$d;
	hasRequiredLib$g = 1;

	Object.defineProperty(lib$d, "__esModule", {
	  value: true
	});
	lib$d.default = splitExportDeclaration;
	var _t = requireLib$h();
	const {
	  cloneNode,
	  exportNamedDeclaration,
	  exportSpecifier,
	  identifier,
	  variableDeclaration,
	  variableDeclarator
	} = _t;
	function splitExportDeclaration(exportDeclaration) {
	  if (!exportDeclaration.isExportDeclaration() || exportDeclaration.isExportAllDeclaration()) {
	    throw new Error("Only default and named export declarations can be split.");
	  }
	  if (exportDeclaration.isExportDefaultDeclaration()) {
	    const declaration = exportDeclaration.get("declaration");
	    const standaloneDeclaration = declaration.isFunctionDeclaration() || declaration.isClassDeclaration();
	    const exportExpr = declaration.isFunctionExpression() || declaration.isClassExpression();
	    const scope = declaration.isScope() ? declaration.scope.parent : declaration.scope;
	    let id = declaration.node.id;
	    let needBindingRegistration = false;
	    if (!id) {
	      needBindingRegistration = true;
	      id = scope.generateUidIdentifier("default");
	      if (standaloneDeclaration || exportExpr) {
	        declaration.node.id = cloneNode(id);
	      }
	    } else if (exportExpr && scope.hasBinding(id.name)) {
	      needBindingRegistration = true;
	      id = scope.generateUidIdentifier(id.name);
	    }
	    const updatedDeclaration = standaloneDeclaration ? declaration.node : variableDeclaration("var", [variableDeclarator(cloneNode(id), declaration.node)]);
	    const updatedExportDeclaration = exportNamedDeclaration(null, [exportSpecifier(cloneNode(id), identifier("default"))]);
	    exportDeclaration.insertAfter(updatedExportDeclaration);
	    exportDeclaration.replaceWith(updatedDeclaration);
	    if (needBindingRegistration) {
	      scope.registerDeclaration(exportDeclaration);
	    }
	    return exportDeclaration;
	  } else if (exportDeclaration.get("specifiers").length > 0) {
	    throw new Error("It doesn't make sense to split exported specifiers.");
	  }
	  const declaration = exportDeclaration.get("declaration");
	  const bindingIdentifiers = declaration.getOuterBindingIdentifiers();
	  const specifiers = Object.keys(bindingIdentifiers).map(name => {
	    return exportSpecifier(identifier(name), identifier(name));
	  });
	  const aliasDeclar = exportNamedDeclaration(null, specifiers);
	  exportDeclaration.insertAfter(aliasDeclar);
	  exportDeclaration.replaceWith(declaration.node);
	  return exportDeclaration;
	}

	
	return lib$d;
}

var lib$c = {};

var hasRequiredLib$f;

function requireLib$f () {
	if (hasRequiredLib$f) return lib$c;
	hasRequiredLib$f = 1;

	Object.defineProperty(lib$c, "__esModule", {
	  value: true
	});
	lib$c.default = void 0;
	lib$c.requeueComputedKeyAndDecorators = requeueComputedKeyAndDecorators;
	{
	  lib$c.skipAllButComputedKey = function skipAllButComputedKey(path) {
	    path.skip();
	    if (path.node.computed) {
	      path.context.maybeQueue(path.get("key"));
	    }
	  };
	}
	function requeueComputedKeyAndDecorators(path) {
	  const {
	    context,
	    node
	  } = path;
	  if (node.computed) {
	    context.maybeQueue(path.get("key"));
	  }
	  if (node.decorators) {
	    for (const decorator of path.get("decorators")) {
	      context.maybeQueue(decorator);
	    }
	  }
	}
	const visitor = {
	  FunctionParent(path) {
	    if (path.isArrowFunctionExpression()) {
	      return;
	    } else {
	      path.skip();
	      if (path.isMethod()) {
	        requeueComputedKeyAndDecorators(path);
	      }
	    }
	  },
	  Property(path) {
	    if (path.isObjectProperty()) {
	      return;
	    }
	    path.skip();
	    requeueComputedKeyAndDecorators(path);
	  }
	};
	var _default = visitor;
	lib$c.default = _default;

	
	return lib$c;
}

var hasRequiredRenamer;

function requireRenamer () {
	if (hasRequiredRenamer) return renamer;
	hasRequiredRenamer = 1;

	Object.defineProperty(renamer, "__esModule", {
	  value: true
	});
	renamer.default = void 0;
	var _helperSplitExportDeclaration = requireLib$g();
	var t = requireLib$h();
	var _helperEnvironmentVisitor = requireLib$f();
	var _traverseNode = requireTraverseNode();
	var _visitors = requireVisitors();
	const renameVisitor = {
	  ReferencedIdentifier({
	    node
	  }, state) {
	    if (node.name === state.oldName) {
	      node.name = state.newName;
	    }
	  },
	  Scope(path, state) {
	    if (!path.scope.bindingIdentifierEquals(state.oldName, state.binding.identifier)) {
	      path.skip();
	      if (path.isMethod()) {
	        (0, _helperEnvironmentVisitor.requeueComputedKeyAndDecorators)(path);
	      }
	    }
	  },
	  ObjectProperty({
	    node,
	    scope
	  }, state) {
	    const {
	      name
	    } = node.key;
	    if (node.shorthand && (name === state.oldName || name === state.newName) && scope.getBindingIdentifier(name) === state.binding.identifier) {
	      var _node$extra;
	      node.shorthand = false;
	      if ((_node$extra = node.extra) != null && _node$extra.shorthand) node.extra.shorthand = false;
	    }
	  },
	  "AssignmentExpression|Declaration|VariableDeclarator"(path, state) {
	    if (path.isVariableDeclaration()) return;
	    const ids = path.getOuterBindingIdentifiers();
	    for (const name in ids) {
	      if (name === state.oldName) ids[name].name = state.newName;
	    }
	  }
	};
	class Renamer {
	  constructor(binding, oldName, newName) {
	    this.newName = newName;
	    this.oldName = oldName;
	    this.binding = binding;
	  }
	  maybeConvertFromExportDeclaration(parentDeclar) {
	    const maybeExportDeclar = parentDeclar.parentPath;
	    if (!maybeExportDeclar.isExportDeclaration()) {
	      return;
	    }
	    if (maybeExportDeclar.isExportDefaultDeclaration()) {
	      const {
	        declaration
	      } = maybeExportDeclar.node;
	      if (t.isDeclaration(declaration) && !declaration.id) {
	        return;
	      }
	    }
	    if (maybeExportDeclar.isExportAllDeclaration()) {
	      return;
	    }
	    (0, _helperSplitExportDeclaration.default)(maybeExportDeclar);
	  }
	  maybeConvertFromClassFunctionDeclaration(path) {
	    return path;
	  }
	  maybeConvertFromClassFunctionExpression(path) {
	    return path;
	  }
	  rename() {
	    const {
	      binding,
	      oldName,
	      newName
	    } = this;
	    const {
	      scope,
	      path
	    } = binding;
	    const parentDeclar = path.find(path => path.isDeclaration() || path.isFunctionExpression() || path.isClassExpression());
	    if (parentDeclar) {
	      const bindingIds = parentDeclar.getOuterBindingIdentifiers();
	      if (bindingIds[oldName] === binding.identifier) {
	        this.maybeConvertFromExportDeclaration(parentDeclar);
	      }
	    }
	    const blockToTraverse = arguments[0] || scope.block;
	    (0, _traverseNode.traverseNode)(blockToTraverse, (0, _visitors.explode)(renameVisitor), scope, this, scope.path, {
	      discriminant: true
	    });
	    if (!arguments[0]) {
	      scope.removeOwnBinding(oldName);
	      scope.bindings[newName] = binding;
	      this.binding.identifier.name = newName;
	    }
	    if (parentDeclar) {
	      this.maybeConvertFromClassFunctionDeclaration(path);
	      this.maybeConvertFromClassFunctionExpression(path);
	    }
	  }
	}
	renamer.default = Renamer;

	
	return renamer;
}

var binding = {};

var hasRequiredBinding;

function requireBinding () {
	if (hasRequiredBinding) return binding;
	hasRequiredBinding = 1;

	Object.defineProperty(binding, "__esModule", {
	  value: true
	});
	binding.default = void 0;
	class Binding {
	  constructor({
	    identifier,
	    scope,
	    path,
	    kind
	  }) {
	    this.identifier = void 0;
	    this.scope = void 0;
	    this.path = void 0;
	    this.kind = void 0;
	    this.constantViolations = [];
	    this.constant = true;
	    this.referencePaths = [];
	    this.referenced = false;
	    this.references = 0;
	    this.identifier = identifier;
	    this.scope = scope;
	    this.path = path;
	    this.kind = kind;
	    if ((kind === "var" || kind === "hoisted") && isDeclaredInLoop()) {
	      this.reassign(path);
	    }
	    this.clearValue();
	  }
	  deoptValue() {
	    this.clearValue();
	    this.hasDeoptedValue = true;
	  }
	  setValue(value) {
	    if (this.hasDeoptedValue) return;
	    this.hasValue = true;
	    this.value = value;
	  }
	  clearValue() {
	    this.hasDeoptedValue = false;
	    this.hasValue = false;
	    this.value = null;
	  }
	  reassign(path) {
	    this.constant = false;
	    if (this.constantViolations.indexOf(path) !== -1) {
	      return;
	    }
	    this.constantViolations.push(path);
	  }
	  reference(path) {
	    if (this.referencePaths.indexOf(path) !== -1) {
	      return;
	    }
	    this.referenced = true;
	    this.references++;
	    this.referencePaths.push(path);
	  }
	  dereference() {
	    this.references--;
	    this.referenced = !!this.references;
	  }
	}
	binding.default = Binding;
	function isDeclaredInLoop(path) {
	  for (let {
	    parentPath,
	    key
	  } = path; parentPath; ({
	    parentPath,
	    key
	  } = parentPath)) {
	    if (parentPath.isFunctionParent()) return false;
	    if (parentPath.isWhile() || parentPath.isForXStatement() || parentPath.isForStatement() && key === "body") {
	      return true;
	    }
	  }
	  return false;
	}

	
	return binding;
}

var builtin = {
	"Array": false,
	"ArrayBuffer": false,
	Atomics: false,
	BigInt: false,
	BigInt64Array: false,
	BigUint64Array: false,
	"Boolean": false,
	constructor: false,
	"DataView": false,
	"Date": false,
	"decodeURI": false,
	"decodeURIComponent": false,
	"encodeURI": false,
	"encodeURIComponent": false,
	"Error": false,
	"escape": false,
	"eval": false,
	"EvalError": false,
	"Float32Array": false,
	"Float64Array": false,
	"Function": false,
	globalThis: false,
	hasOwnProperty: false,
	"Infinity": false,
	"Int16Array": false,
	"Int32Array": false,
	"Int8Array": false,
	"isFinite": false,
	"isNaN": false,
	isPrototypeOf: false,
	"JSON": false,
	"Map": false,
	"Math": false,
	"NaN": false,
	"Number": false,
	"Object": false,
	"parseFloat": false,
	"parseInt": false,
	"Promise": false,
	propertyIsEnumerable: false,
	"Proxy": false,
	"RangeError": false,
	"ReferenceError": false,
	"Reflect": false,
	"RegExp": false,
	"Set": false,
	SharedArrayBuffer: false,
	"String": false,
	"Symbol": false,
	"SyntaxError": false,
	toLocaleString: false,
	toString: false,
	"TypeError": false,
	"Uint16Array": false,
	"Uint32Array": false,
	"Uint8Array": false,
	"Uint8ClampedArray": false,
	"undefined": false,
	"unescape": false,
	"URIError": false,
	valueOf: false,
	"WeakMap": false,
	"WeakSet": false
};
var es5 = {
	"Array": false,
	"Boolean": false,
	constructor: false,
	"Date": false,
	"decodeURI": false,
	"decodeURIComponent": false,
	"encodeURI": false,
	"encodeURIComponent": false,
	"Error": false,
	"escape": false,
	"eval": false,
	"EvalError": false,
	"Function": false,
	hasOwnProperty: false,
	"Infinity": false,
	"isFinite": false,
	"isNaN": false,
	isPrototypeOf: false,
	"JSON": false,
	"Math": false,
	"NaN": false,
	"Number": false,
	"Object": false,
	"parseFloat": false,
	"parseInt": false,
	propertyIsEnumerable: false,
	"RangeError": false,
	"ReferenceError": false,
	"RegExp": false,
	"String": false,
	"SyntaxError": false,
	toLocaleString: false,
	toString: false,
	"TypeError": false,
	"undefined": false,
	"unescape": false,
	"URIError": false,
	valueOf: false
};
var es2015 = {
	"Array": false,
	"ArrayBuffer": false,
	"Boolean": false,
	constructor: false,
	"DataView": false,
	"Date": false,
	"decodeURI": false,
	"decodeURIComponent": false,
	"encodeURI": false,
	"encodeURIComponent": false,
	"Error": false,
	"escape": false,
	"eval": false,
	"EvalError": false,
	"Float32Array": false,
	"Float64Array": false,
	"Function": false,
	hasOwnProperty: false,
	"Infinity": false,
	"Int16Array": false,
	"Int32Array": false,
	"Int8Array": false,
	"isFinite": false,
	"isNaN": false,
	isPrototypeOf: false,
	"JSON": false,
	"Map": false,
	"Math": false,
	"NaN": false,
	"Number": false,
	"Object": false,
	"parseFloat": false,
	"parseInt": false,
	"Promise": false,
	propertyIsEnumerable: false,
	"Proxy": false,
	"RangeError": false,
	"ReferenceError": false,
	"Reflect": false,
	"RegExp": false,
	"Set": false,
	"String": false,
	"Symbol": false,
	"SyntaxError": false,
	toLocaleString: false,
	toString: false,
	"TypeError": false,
	"Uint16Array": false,
	"Uint32Array": false,
	"Uint8Array": false,
	"Uint8ClampedArray": false,
	"undefined": false,
	"unescape": false,
	"URIError": false,
	valueOf: false,
	"WeakMap": false,
	"WeakSet": false
};
var es2017 = {
	"Array": false,
	"ArrayBuffer": false,
	Atomics: false,
	"Boolean": false,
	constructor: false,
	"DataView": false,
	"Date": false,
	"decodeURI": false,
	"decodeURIComponent": false,
	"encodeURI": false,
	"encodeURIComponent": false,
	"Error": false,
	"escape": false,
	"eval": false,
	"EvalError": false,
	"Float32Array": false,
	"Float64Array": false,
	"Function": false,
	hasOwnProperty: false,
	"Infinity": false,
	"Int16Array": false,
	"Int32Array": false,
	"Int8Array": false,
	"isFinite": false,
	"isNaN": false,
	isPrototypeOf: false,
	"JSON": false,
	"Map": false,
	"Math": false,
	"NaN": false,
	"Number": false,
	"Object": false,
	"parseFloat": false,
	"parseInt": false,
	"Promise": false,
	propertyIsEnumerable: false,
	"Proxy": false,
	"RangeError": false,
	"ReferenceError": false,
	"Reflect": false,
	"RegExp": false,
	"Set": false,
	SharedArrayBuffer: false,
	"String": false,
	"Symbol": false,
	"SyntaxError": false,
	toLocaleString: false,
	toString: false,
	"TypeError": false,
	"Uint16Array": false,
	"Uint32Array": false,
	"Uint8Array": false,
	"Uint8ClampedArray": false,
	"undefined": false,
	"unescape": false,
	"URIError": false,
	valueOf: false,
	"WeakMap": false,
	"WeakSet": false
};
var browser = {
	AbortController: false,
	AbortSignal: false,
	addEventListener: false,
	alert: false,
	AnalyserNode: false,
	Animation: false,
	AnimationEffectReadOnly: false,
	AnimationEffectTiming: false,
	AnimationEffectTimingReadOnly: false,
	AnimationEvent: false,
	AnimationPlaybackEvent: false,
	AnimationTimeline: false,
	applicationCache: false,
	ApplicationCache: false,
	ApplicationCacheErrorEvent: false,
	atob: false,
	Attr: false,
	Audio: false,
	AudioBuffer: false,
	AudioBufferSourceNode: false,
	AudioContext: false,
	AudioDestinationNode: false,
	AudioListener: false,
	AudioNode: false,
	AudioParam: false,
	AudioProcessingEvent: false,
	AudioScheduledSourceNode: false,
	"AudioWorkletGlobalScope ": false,
	AudioWorkletNode: false,
	AudioWorkletProcessor: false,
	BarProp: false,
	BaseAudioContext: false,
	BatteryManager: false,
	BeforeUnloadEvent: false,
	BiquadFilterNode: false,
	Blob: false,
	BlobEvent: false,
	blur: false,
	BroadcastChannel: false,
	btoa: false,
	BudgetService: false,
	ByteLengthQueuingStrategy: false,
	Cache: false,
	caches: false,
	CacheStorage: false,
	cancelAnimationFrame: false,
	cancelIdleCallback: false,
	CanvasCaptureMediaStreamTrack: false,
	CanvasGradient: false,
	CanvasPattern: false,
	CanvasRenderingContext2D: false,
	ChannelMergerNode: false,
	ChannelSplitterNode: false,
	CharacterData: false,
	clearInterval: false,
	clearTimeout: false,
	clientInformation: false,
	ClipboardEvent: false,
	close: false,
	closed: false,
	CloseEvent: false,
	Comment: false,
	CompositionEvent: false,
	confirm: false,
	console: false,
	ConstantSourceNode: false,
	ConvolverNode: false,
	CountQueuingStrategy: false,
	createImageBitmap: false,
	Credential: false,
	CredentialsContainer: false,
	crypto: false,
	Crypto: false,
	CryptoKey: false,
	CSS: false,
	CSSConditionRule: false,
	CSSFontFaceRule: false,
	CSSGroupingRule: false,
	CSSImportRule: false,
	CSSKeyframeRule: false,
	CSSKeyframesRule: false,
	CSSMediaRule: false,
	CSSNamespaceRule: false,
	CSSPageRule: false,
	CSSRule: false,
	CSSRuleList: false,
	CSSStyleDeclaration: false,
	CSSStyleRule: false,
	CSSStyleSheet: false,
	CSSSupportsRule: false,
	CustomElementRegistry: false,
	customElements: false,
	CustomEvent: false,
	DataTransfer: false,
	DataTransferItem: false,
	DataTransferItemList: false,
	defaultstatus: false,
	defaultStatus: false,
	DelayNode: false,
	DeviceMotionEvent: false,
	DeviceOrientationEvent: false,
	devicePixelRatio: false,
	dispatchEvent: false,
	document: false,
	Document: false,
	DocumentFragment: false,
	DocumentType: false,
	DOMError: false,
	DOMException: false,
	DOMImplementation: false,
	DOMMatrix: false,
	DOMMatrixReadOnly: false,
	DOMParser: false,
	DOMPoint: false,
	DOMPointReadOnly: false,
	DOMQuad: false,
	DOMRect: false,
	DOMRectReadOnly: false,
	DOMStringList: false,
	DOMStringMap: false,
	DOMTokenList: false,
	DragEvent: false,
	DynamicsCompressorNode: false,
	Element: false,
	ErrorEvent: false,
	event: false,
	Event: false,
	EventSource: false,
	EventTarget: false,
	external: false,
	fetch: false,
	File: false,
	FileList: false,
	FileReader: false,
	find: false,
	focus: false,
	FocusEvent: false,
	FontFace: false,
	FontFaceSetLoadEvent: false,
	FormData: false,
	frameElement: false,
	frames: false,
	GainNode: false,
	Gamepad: false,
	GamepadButton: false,
	GamepadEvent: false,
	getComputedStyle: false,
	getSelection: false,
	HashChangeEvent: false,
	Headers: false,
	history: false,
	History: false,
	HTMLAllCollection: false,
	HTMLAnchorElement: false,
	HTMLAreaElement: false,
	HTMLAudioElement: false,
	HTMLBaseElement: false,
	HTMLBodyElement: false,
	HTMLBRElement: false,
	HTMLButtonElement: false,
	HTMLCanvasElement: false,
	HTMLCollection: false,
	HTMLContentElement: false,
	HTMLDataElement: false,
	HTMLDataListElement: false,
	HTMLDetailsElement: false,
	HTMLDialogElement: false,
	HTMLDirectoryElement: false,
	HTMLDivElement: false,
	HTMLDListElement: false,
	HTMLDocument: false,
	HTMLElement: false,
	HTMLEmbedElement: false,
	HTMLFieldSetElement: false,
	HTMLFontElement: false,
	HTMLFormControlsCollection: false,
	HTMLFormElement: false,
	HTMLFrameElement: false,
	HTMLFrameSetElement: false,
	HTMLHeadElement: false,
	HTMLHeadingElement: false,
	HTMLHRElement: false,
	HTMLHtmlElement: false,
	HTMLIFrameElement: false,
	HTMLImageElement: false,
	HTMLInputElement: false,
	HTMLLabelElement: false,
	HTMLLegendElement: false,
	HTMLLIElement: false,
	HTMLLinkElement: false,
	HTMLMapElement: false,
	HTMLMarqueeElement: false,
	HTMLMediaElement: false,
	HTMLMenuElement: false,
	HTMLMetaElement: false,
	HTMLMeterElement: false,
	HTMLModElement: false,
	HTMLObjectElement: false,
	HTMLOListElement: false,
	HTMLOptGroupElement: false,
	HTMLOptionElement: false,
	HTMLOptionsCollection: false,
	HTMLOutputElement: false,
	HTMLParagraphElement: false,
	HTMLParamElement: false,
	HTMLPictureElement: false,
	HTMLPreElement: false,
	HTMLProgressElement: false,
	HTMLQuoteElement: false,
	HTMLScriptElement: false,
	HTMLSelectElement: false,
	HTMLShadowElement: false,
	HTMLSlotElement: false,
	HTMLSourceElement: false,
	HTMLSpanElement: false,
	HTMLStyleElement: false,
	HTMLTableCaptionElement: false,
	HTMLTableCellElement: false,
	HTMLTableColElement: false,
	HTMLTableElement: false,
	HTMLTableRowElement: false,
	HTMLTableSectionElement: false,
	HTMLTemplateElement: false,
	HTMLTextAreaElement: false,
	HTMLTimeElement: false,
	HTMLTitleElement: false,
	HTMLTrackElement: false,
	HTMLUListElement: false,
	HTMLUnknownElement: false,
	HTMLVideoElement: false,
	IDBCursor: false,
	IDBCursorWithValue: false,
	IDBDatabase: false,
	IDBFactory: false,
	IDBIndex: false,
	IDBKeyRange: false,
	IDBObjectStore: false,
	IDBOpenDBRequest: false,
	IDBRequest: false,
	IDBTransaction: false,
	IDBVersionChangeEvent: false,
	IdleDeadline: false,
	IIRFilterNode: false,
	Image: false,
	ImageBitmap: false,
	ImageBitmapRenderingContext: false,
	ImageCapture: false,
	ImageData: false,
	indexedDB: false,
	innerHeight: false,
	innerWidth: false,
	InputEvent: false,
	IntersectionObserver: false,
	IntersectionObserverEntry: false,
	"Intl": false,
	isSecureContext: false,
	KeyboardEvent: false,
	KeyframeEffect: false,
	KeyframeEffectReadOnly: false,
	length: false,
	localStorage: false,
	location: true,
	Location: false,
	locationbar: false,
	matchMedia: false,
	MediaDeviceInfo: false,
	MediaDevices: false,
	MediaElementAudioSourceNode: false,
	MediaEncryptedEvent: false,
	MediaError: false,
	MediaKeyMessageEvent: false,
	MediaKeySession: false,
	MediaKeyStatusMap: false,
	MediaKeySystemAccess: false,
	MediaList: false,
	MediaQueryList: false,
	MediaQueryListEvent: false,
	MediaRecorder: false,
	MediaSettingsRange: false,
	MediaSource: false,
	MediaStream: false,
	MediaStreamAudioDestinationNode: false,
	MediaStreamAudioSourceNode: false,
	MediaStreamEvent: false,
	MediaStreamTrack: false,
	MediaStreamTrackEvent: false,
	menubar: false,
	MessageChannel: false,
	MessageEvent: false,
	MessagePort: false,
	MIDIAccess: false,
	MIDIConnectionEvent: false,
	MIDIInput: false,
	MIDIInputMap: false,
	MIDIMessageEvent: false,
	MIDIOutput: false,
	MIDIOutputMap: false,
	MIDIPort: false,
	MimeType: false,
	MimeTypeArray: false,
	MouseEvent: false,
	moveBy: false,
	moveTo: false,
	MutationEvent: false,
	MutationObserver: false,
	MutationRecord: false,
	name: false,
	NamedNodeMap: false,
	NavigationPreloadManager: false,
	navigator: false,
	Navigator: false,
	NetworkInformation: false,
	Node: false,
	NodeFilter: false,
	NodeIterator: false,
	NodeList: false,
	Notification: false,
	OfflineAudioCompletionEvent: false,
	OfflineAudioContext: false,
	offscreenBuffering: false,
	OffscreenCanvas: true,
	onabort: true,
	onafterprint: true,
	onanimationend: true,
	onanimationiteration: true,
	onanimationstart: true,
	onappinstalled: true,
	onauxclick: true,
	onbeforeinstallprompt: true,
	onbeforeprint: true,
	onbeforeunload: true,
	onblur: true,
	oncancel: true,
	oncanplay: true,
	oncanplaythrough: true,
	onchange: true,
	onclick: true,
	onclose: true,
	oncontextmenu: true,
	oncuechange: true,
	ondblclick: true,
	ondevicemotion: true,
	ondeviceorientation: true,
	ondeviceorientationabsolute: true,
	ondrag: true,
	ondragend: true,
	ondragenter: true,
	ondragleave: true,
	ondragover: true,
	ondragstart: true,
	ondrop: true,
	ondurationchange: true,
	onemptied: true,
	onended: true,
	onerror: true,
	onfocus: true,
	ongotpointercapture: true,
	onhashchange: true,
	oninput: true,
	oninvalid: true,
	onkeydown: true,
	onkeypress: true,
	onkeyup: true,
	onlanguagechange: true,
	onload: true,
	onloadeddata: true,
	onloadedmetadata: true,
	onloadstart: true,
	onlostpointercapture: true,
	onmessage: true,
	onmessageerror: true,
	onmousedown: true,
	onmouseenter: true,
	onmouseleave: true,
	onmousemove: true,
	onmouseout: true,
	onmouseover: true,
	onmouseup: true,
	onmousewheel: true,
	onoffline: true,
	ononline: true,
	onpagehide: true,
	onpageshow: true,
	onpause: true,
	onplay: true,
	onplaying: true,
	onpointercancel: true,
	onpointerdown: true,
	onpointerenter: true,
	onpointerleave: true,
	onpointermove: true,
	onpointerout: true,
	onpointerover: true,
	onpointerup: true,
	onpopstate: true,
	onprogress: true,
	onratechange: true,
	onrejectionhandled: true,
	onreset: true,
	onresize: true,
	onscroll: true,
	onsearch: true,
	onseeked: true,
	onseeking: true,
	onselect: true,
	onstalled: true,
	onstorage: true,
	onsubmit: true,
	onsuspend: true,
	ontimeupdate: true,
	ontoggle: true,
	ontransitionend: true,
	onunhandledrejection: true,
	onunload: true,
	onvolumechange: true,
	onwaiting: true,
	onwheel: true,
	open: false,
	openDatabase: false,
	opener: false,
	Option: false,
	origin: false,
	OscillatorNode: false,
	outerHeight: false,
	outerWidth: false,
	PageTransitionEvent: false,
	pageXOffset: false,
	pageYOffset: false,
	PannerNode: false,
	parent: false,
	Path2D: false,
	PaymentAddress: false,
	PaymentRequest: false,
	PaymentRequestUpdateEvent: false,
	PaymentResponse: false,
	performance: false,
	Performance: false,
	PerformanceEntry: false,
	PerformanceLongTaskTiming: false,
	PerformanceMark: false,
	PerformanceMeasure: false,
	PerformanceNavigation: false,
	PerformanceNavigationTiming: false,
	PerformanceObserver: false,
	PerformanceObserverEntryList: false,
	PerformancePaintTiming: false,
	PerformanceResourceTiming: false,
	PerformanceTiming: false,
	PeriodicWave: false,
	Permissions: false,
	PermissionStatus: false,
	personalbar: false,
	PhotoCapabilities: false,
	Plugin: false,
	PluginArray: false,
	PointerEvent: false,
	PopStateEvent: false,
	postMessage: false,
	Presentation: false,
	PresentationAvailability: false,
	PresentationConnection: false,
	PresentationConnectionAvailableEvent: false,
	PresentationConnectionCloseEvent: false,
	PresentationConnectionList: false,
	PresentationReceiver: false,
	PresentationRequest: false,
	print: false,
	ProcessingInstruction: false,
	ProgressEvent: false,
	PromiseRejectionEvent: false,
	prompt: false,
	PushManager: false,
	PushSubscription: false,
	PushSubscriptionOptions: false,
	queueMicrotask: false,
	RadioNodeList: false,
	Range: false,
	ReadableStream: false,
	registerProcessor: false,
	RemotePlayback: false,
	removeEventListener: false,
	Request: false,
	requestAnimationFrame: false,
	requestIdleCallback: false,
	resizeBy: false,
	ResizeObserver: false,
	ResizeObserverEntry: false,
	resizeTo: false,
	Response: false,
	RTCCertificate: false,
	RTCDataChannel: false,
	RTCDataChannelEvent: false,
	RTCDtlsTransport: false,
	RTCIceCandidate: false,
	RTCIceGatherer: false,
	RTCIceTransport: false,
	RTCPeerConnection: false,
	RTCPeerConnectionIceEvent: false,
	RTCRtpContributingSource: false,
	RTCRtpReceiver: false,
	RTCRtpSender: false,
	RTCSctpTransport: false,
	RTCSessionDescription: false,
	RTCStatsReport: false,
	RTCTrackEvent: false,
	screen: false,
	Screen: false,
	screenLeft: false,
	ScreenOrientation: false,
	screenTop: false,
	screenX: false,
	screenY: false,
	ScriptProcessorNode: false,
	scroll: false,
	scrollbars: false,
	scrollBy: false,
	scrollTo: false,
	scrollX: false,
	scrollY: false,
	SecurityPolicyViolationEvent: false,
	Selection: false,
	self: false,
	ServiceWorker: false,
	ServiceWorkerContainer: false,
	ServiceWorkerRegistration: false,
	sessionStorage: false,
	setInterval: false,
	setTimeout: false,
	ShadowRoot: false,
	SharedWorker: false,
	SourceBuffer: false,
	SourceBufferList: false,
	speechSynthesis: false,
	SpeechSynthesisEvent: false,
	SpeechSynthesisUtterance: false,
	StaticRange: false,
	status: false,
	statusbar: false,
	StereoPannerNode: false,
	stop: false,
	Storage: false,
	StorageEvent: false,
	StorageManager: false,
	styleMedia: false,
	StyleSheet: false,
	StyleSheetList: false,
	SubtleCrypto: false,
	SVGAElement: false,
	SVGAngle: false,
	SVGAnimatedAngle: false,
	SVGAnimatedBoolean: false,
	SVGAnimatedEnumeration: false,
	SVGAnimatedInteger: false,
	SVGAnimatedLength: false,
	SVGAnimatedLengthList: false,
	SVGAnimatedNumber: false,
	SVGAnimatedNumberList: false,
	SVGAnimatedPreserveAspectRatio: false,
	SVGAnimatedRect: false,
	SVGAnimatedString: false,
	SVGAnimatedTransformList: false,
	SVGAnimateElement: false,
	SVGAnimateMotionElement: false,
	SVGAnimateTransformElement: false,
	SVGAnimationElement: false,
	SVGCircleElement: false,
	SVGClipPathElement: false,
	SVGComponentTransferFunctionElement: false,
	SVGDefsElement: false,
	SVGDescElement: false,
	SVGDiscardElement: false,
	SVGElement: false,
	SVGEllipseElement: false,
	SVGFEBlendElement: false,
	SVGFEColorMatrixElement: false,
	SVGFEComponentTransferElement: false,
	SVGFECompositeElement: false,
	SVGFEConvolveMatrixElement: false,
	SVGFEDiffuseLightingElement: false,
	SVGFEDisplacementMapElement: false,
	SVGFEDistantLightElement: false,
	SVGFEDropShadowElement: false,
	SVGFEFloodElement: false,
	SVGFEFuncAElement: false,
	SVGFEFuncBElement: false,
	SVGFEFuncGElement: false,
	SVGFEFuncRElement: false,
	SVGFEGaussianBlurElement: false,
	SVGFEImageElement: false,
	SVGFEMergeElement: false,
	SVGFEMergeNodeElement: false,
	SVGFEMorphologyElement: false,
	SVGFEOffsetElement: false,
	SVGFEPointLightElement: false,
	SVGFESpecularLightingElement: false,
	SVGFESpotLightElement: false,
	SVGFETileElement: false,
	SVGFETurbulenceElement: false,
	SVGFilterElement: false,
	SVGForeignObjectElement: false,
	SVGGElement: false,
	SVGGeometryElement: false,
	SVGGradientElement: false,
	SVGGraphicsElement: false,
	SVGImageElement: false,
	SVGLength: false,
	SVGLengthList: false,
	SVGLinearGradientElement: false,
	SVGLineElement: false,
	SVGMarkerElement: false,
	SVGMaskElement: false,
	SVGMatrix: false,
	SVGMetadataElement: false,
	SVGMPathElement: false,
	SVGNumber: false,
	SVGNumberList: false,
	SVGPathElement: false,
	SVGPatternElement: false,
	SVGPoint: false,
	SVGPointList: false,
	SVGPolygonElement: false,
	SVGPolylineElement: false,
	SVGPreserveAspectRatio: false,
	SVGRadialGradientElement: false,
	SVGRect: false,
	SVGRectElement: false,
	SVGScriptElement: false,
	SVGSetElement: false,
	SVGStopElement: false,
	SVGStringList: false,
	SVGStyleElement: false,
	SVGSVGElement: false,
	SVGSwitchElement: false,
	SVGSymbolElement: false,
	SVGTextContentElement: false,
	SVGTextElement: false,
	SVGTextPathElement: false,
	SVGTextPositioningElement: false,
	SVGTitleElement: false,
	SVGTransform: false,
	SVGTransformList: false,
	SVGTSpanElement: false,
	SVGUnitTypes: false,
	SVGUseElement: false,
	SVGViewElement: false,
	TaskAttributionTiming: false,
	Text: false,
	TextDecoder: false,
	TextEncoder: false,
	TextEvent: false,
	TextMetrics: false,
	TextTrack: false,
	TextTrackCue: false,
	TextTrackCueList: false,
	TextTrackList: false,
	TimeRanges: false,
	toolbar: false,
	top: false,
	Touch: false,
	TouchEvent: false,
	TouchList: false,
	TrackEvent: false,
	TransitionEvent: false,
	TreeWalker: false,
	UIEvent: false,
	URL: false,
	URLSearchParams: false,
	ValidityState: false,
	visualViewport: false,
	VisualViewport: false,
	VTTCue: false,
	WaveShaperNode: false,
	WebAssembly: false,
	WebGL2RenderingContext: false,
	WebGLActiveInfo: false,
	WebGLBuffer: false,
	WebGLContextEvent: false,
	WebGLFramebuffer: false,
	WebGLProgram: false,
	WebGLQuery: false,
	WebGLRenderbuffer: false,
	WebGLRenderingContext: false,
	WebGLSampler: false,
	WebGLShader: false,
	WebGLShaderPrecisionFormat: false,
	WebGLSync: false,
	WebGLTexture: false,
	WebGLTransformFeedback: false,
	WebGLUniformLocation: false,
	WebGLVertexArrayObject: false,
	WebSocket: false,
	WheelEvent: false,
	window: false,
	Window: false,
	Worker: false,
	WritableStream: false,
	XMLDocument: false,
	XMLHttpRequest: false,
	XMLHttpRequestEventTarget: false,
	XMLHttpRequestUpload: false,
	XMLSerializer: false,
	XPathEvaluator: false,
	XPathExpression: false,
	XPathResult: false,
	XSLTProcessor: false
};
var worker = {
	addEventListener: false,
	applicationCache: false,
	atob: false,
	Blob: false,
	BroadcastChannel: false,
	btoa: false,
	Cache: false,
	caches: false,
	clearInterval: false,
	clearTimeout: false,
	close: true,
	console: false,
	fetch: false,
	FileReaderSync: false,
	FormData: false,
	Headers: false,
	IDBCursor: false,
	IDBCursorWithValue: false,
	IDBDatabase: false,
	IDBFactory: false,
	IDBIndex: false,
	IDBKeyRange: false,
	IDBObjectStore: false,
	IDBOpenDBRequest: false,
	IDBRequest: false,
	IDBTransaction: false,
	IDBVersionChangeEvent: false,
	ImageData: false,
	importScripts: true,
	indexedDB: false,
	location: false,
	MessageChannel: false,
	MessagePort: false,
	name: false,
	navigator: false,
	Notification: false,
	onclose: true,
	onconnect: true,
	onerror: true,
	onlanguagechange: true,
	onmessage: true,
	onoffline: true,
	ononline: true,
	onrejectionhandled: true,
	onunhandledrejection: true,
	performance: false,
	Performance: false,
	PerformanceEntry: false,
	PerformanceMark: false,
	PerformanceMeasure: false,
	PerformanceNavigation: false,
	PerformanceResourceTiming: false,
	PerformanceTiming: false,
	postMessage: true,
	"Promise": false,
	queueMicrotask: false,
	removeEventListener: false,
	Request: false,
	Response: false,
	self: true,
	ServiceWorkerRegistration: false,
	setInterval: false,
	setTimeout: false,
	TextDecoder: false,
	TextEncoder: false,
	URL: false,
	URLSearchParams: false,
	WebSocket: false,
	Worker: false,
	WorkerGlobalScope: false,
	XMLHttpRequest: false
};
var node$2 = {
	__dirname: false,
	__filename: false,
	Buffer: false,
	clearImmediate: false,
	clearInterval: false,
	clearTimeout: false,
	console: false,
	exports: true,
	global: false,
	"Intl": false,
	module: false,
	process: false,
	queueMicrotask: false,
	require: false,
	setImmediate: false,
	setInterval: false,
	setTimeout: false,
	TextDecoder: false,
	TextEncoder: false,
	URL: false,
	URLSearchParams: false
};
var commonjs = {
	exports: true,
	global: false,
	module: false,
	require: false
};
var amd = {
	define: false,
	require: false
};
var mocha = {
	after: false,
	afterEach: false,
	before: false,
	beforeEach: false,
	context: false,
	describe: false,
	it: false,
	mocha: false,
	run: false,
	setup: false,
	specify: false,
	suite: false,
	suiteSetup: false,
	suiteTeardown: false,
	teardown: false,
	test: false,
	xcontext: false,
	xdescribe: false,
	xit: false,
	xspecify: false
};
var jasmine = {
	afterAll: false,
	afterEach: false,
	beforeAll: false,
	beforeEach: false,
	describe: false,
	expect: false,
	fail: false,
	fdescribe: false,
	fit: false,
	it: false,
	jasmine: false,
	pending: false,
	runs: false,
	spyOn: false,
	spyOnProperty: false,
	waits: false,
	waitsFor: false,
	xdescribe: false,
	xit: false
};
var jest = {
	afterAll: false,
	afterEach: false,
	beforeAll: false,
	beforeEach: false,
	describe: false,
	expect: false,
	fdescribe: false,
	fit: false,
	it: false,
	jest: false,
	pit: false,
	require: false,
	test: false,
	xdescribe: false,
	xit: false,
	xtest: false
};
var qunit = {
	asyncTest: false,
	deepEqual: false,
	equal: false,
	expect: false,
	module: false,
	notDeepEqual: false,
	notEqual: false,
	notOk: false,
	notPropEqual: false,
	notStrictEqual: false,
	ok: false,
	propEqual: false,
	QUnit: false,
	raises: false,
	start: false,
	stop: false,
	strictEqual: false,
	test: false,
	throws: false
};
var phantomjs = {
	console: true,
	exports: true,
	phantom: true,
	require: true,
	WebPage: true
};
var couch = {
	emit: false,
	exports: false,
	getRow: false,
	log: false,
	module: false,
	provides: false,
	require: false,
	respond: false,
	send: false,
	start: false,
	sum: false
};
var rhino = {
	defineClass: false,
	deserialize: false,
	gc: false,
	help: false,
	importClass: false,
	importPackage: false,
	java: false,
	load: false,
	loadClass: false,
	Packages: false,
	print: false,
	quit: false,
	readFile: false,
	readUrl: false,
	runCommand: false,
	seal: false,
	serialize: false,
	spawn: false,
	sync: false,
	toint32: false,
	version: false
};
var nashorn = {
	__DIR__: false,
	__FILE__: false,
	__LINE__: false,
	com: false,
	edu: false,
	exit: false,
	java: false,
	Java: false,
	javafx: false,
	JavaImporter: false,
	javax: false,
	JSAdapter: false,
	load: false,
	loadWithNewGlobal: false,
	org: false,
	Packages: false,
	print: false,
	quit: false
};
var wsh = {
	ActiveXObject: true,
	Enumerator: true,
	GetObject: true,
	ScriptEngine: true,
	ScriptEngineBuildVersion: true,
	ScriptEngineMajorVersion: true,
	ScriptEngineMinorVersion: true,
	VBArray: true,
	WScript: true,
	WSH: true,
	XDomainRequest: true
};
var jquery = {
	$: false,
	jQuery: false
};
var yui = {
	YAHOO: false,
	YAHOO_config: false,
	YUI: false,
	YUI_config: false
};
var shelljs = {
	cat: false,
	cd: false,
	chmod: false,
	config: false,
	cp: false,
	dirs: false,
	echo: false,
	env: false,
	error: false,
	exec: false,
	exit: false,
	find: false,
	grep: false,
	ln: false,
	ls: false,
	mkdir: false,
	mv: false,
	popd: false,
	pushd: false,
	pwd: false,
	rm: false,
	sed: false,
	set: false,
	target: false,
	tempdir: false,
	test: false,
	touch: false,
	which: false
};
var prototypejs = {
	$: false,
	$$: false,
	$A: false,
	$break: false,
	$continue: false,
	$F: false,
	$H: false,
	$R: false,
	$w: false,
	Abstract: false,
	Ajax: false,
	Autocompleter: false,
	Builder: false,
	Class: false,
	Control: false,
	Draggable: false,
	Draggables: false,
	Droppables: false,
	Effect: false,
	Element: false,
	Enumerable: false,
	Event: false,
	Field: false,
	Form: false,
	Hash: false,
	Insertion: false,
	ObjectRange: false,
	PeriodicalExecuter: false,
	Position: false,
	Prototype: false,
	Scriptaculous: false,
	Selector: false,
	Sortable: false,
	SortableObserver: false,
	Sound: false,
	Template: false,
	Toggle: false,
	Try: false
};
var meteor = {
	_: false,
	$: false,
	Accounts: false,
	AccountsClient: false,
	AccountsCommon: false,
	AccountsServer: false,
	App: false,
	Assets: false,
	Blaze: false,
	check: false,
	Cordova: false,
	DDP: false,
	DDPRateLimiter: false,
	DDPServer: false,
	Deps: false,
	EJSON: false,
	Email: false,
	HTTP: false,
	Log: false,
	Match: false,
	Meteor: false,
	Mongo: false,
	MongoInternals: false,
	Npm: false,
	Package: false,
	Plugin: false,
	process: false,
	Random: false,
	ReactiveDict: false,
	ReactiveVar: false,
	Router: false,
	ServiceConfiguration: false,
	Session: false,
	share: false,
	Spacebars: false,
	Template: false,
	Tinytest: false,
	Tracker: false,
	UI: false,
	Utils: false,
	WebApp: false,
	WebAppInternals: false
};
var mongo = {
	_isWindows: false,
	_rand: false,
	BulkWriteResult: false,
	cat: false,
	cd: false,
	connect: false,
	db: false,
	getHostName: false,
	getMemInfo: false,
	hostname: false,
	ISODate: false,
	listFiles: false,
	load: false,
	ls: false,
	md5sumFile: false,
	mkdir: false,
	Mongo: false,
	NumberInt: false,
	NumberLong: false,
	ObjectId: false,
	PlanCache: false,
	print: false,
	printjson: false,
	pwd: false,
	quit: false,
	removeFile: false,
	rs: false,
	sh: false,
	UUID: false,
	version: false,
	WriteResult: false
};
var applescript = {
	$: false,
	Application: false,
	Automation: false,
	console: false,
	delay: false,
	Library: false,
	ObjC: false,
	ObjectSpecifier: false,
	Path: false,
	Progress: false,
	Ref: false
};
var serviceworker = {
	addEventListener: false,
	applicationCache: false,
	atob: false,
	Blob: false,
	BroadcastChannel: false,
	btoa: false,
	Cache: false,
	caches: false,
	CacheStorage: false,
	clearInterval: false,
	clearTimeout: false,
	Client: false,
	clients: false,
	Clients: false,
	close: true,
	console: false,
	ExtendableEvent: false,
	ExtendableMessageEvent: false,
	fetch: false,
	FetchEvent: false,
	FileReaderSync: false,
	FormData: false,
	Headers: false,
	IDBCursor: false,
	IDBCursorWithValue: false,
	IDBDatabase: false,
	IDBFactory: false,
	IDBIndex: false,
	IDBKeyRange: false,
	IDBObjectStore: false,
	IDBOpenDBRequest: false,
	IDBRequest: false,
	IDBTransaction: false,
	IDBVersionChangeEvent: false,
	ImageData: false,
	importScripts: false,
	indexedDB: false,
	location: false,
	MessageChannel: false,
	MessagePort: false,
	name: false,
	navigator: false,
	Notification: false,
	onclose: true,
	onconnect: true,
	onerror: true,
	onfetch: true,
	oninstall: true,
	onlanguagechange: true,
	onmessage: true,
	onmessageerror: true,
	onnotificationclick: true,
	onnotificationclose: true,
	onoffline: true,
	ononline: true,
	onpush: true,
	onpushsubscriptionchange: true,
	onrejectionhandled: true,
	onsync: true,
	onunhandledrejection: true,
	performance: false,
	Performance: false,
	PerformanceEntry: false,
	PerformanceMark: false,
	PerformanceMeasure: false,
	PerformanceNavigation: false,
	PerformanceResourceTiming: false,
	PerformanceTiming: false,
	postMessage: true,
	"Promise": false,
	queueMicrotask: false,
	registration: false,
	removeEventListener: false,
	Request: false,
	Response: false,
	self: false,
	ServiceWorker: false,
	ServiceWorkerContainer: false,
	ServiceWorkerGlobalScope: false,
	ServiceWorkerMessageEvent: false,
	ServiceWorkerRegistration: false,
	setInterval: false,
	setTimeout: false,
	skipWaiting: false,
	TextDecoder: false,
	TextEncoder: false,
	URL: false,
	URLSearchParams: false,
	WebSocket: false,
	WindowClient: false,
	Worker: false,
	WorkerGlobalScope: false,
	XMLHttpRequest: false
};
var atomtest = {
	advanceClock: false,
	fakeClearInterval: false,
	fakeClearTimeout: false,
	fakeSetInterval: false,
	fakeSetTimeout: false,
	resetTimeouts: false,
	waitsForPromise: false
};
var embertest = {
	andThen: false,
	click: false,
	currentPath: false,
	currentRouteName: false,
	currentURL: false,
	fillIn: false,
	find: false,
	findAll: false,
	findWithAssert: false,
	keyEvent: false,
	pauseTest: false,
	resumeTest: false,
	triggerEvent: false,
	visit: false,
	wait: false
};
var protractor = {
	$: false,
	$$: false,
	browser: false,
	by: false,
	By: false,
	DartObject: false,
	element: false,
	protractor: false
};
var webextensions = {
	browser: false,
	chrome: false,
	opr: false
};
var greasemonkey = {
	cloneInto: false,
	createObjectIn: false,
	exportFunction: false,
	GM: false,
	GM_addStyle: false,
	GM_deleteValue: false,
	GM_getResourceText: false,
	GM_getResourceURL: false,
	GM_getValue: false,
	GM_info: false,
	GM_listValues: false,
	GM_log: false,
	GM_openInTab: false,
	GM_registerMenuCommand: false,
	GM_setClipboard: false,
	GM_setValue: false,
	GM_xmlhttpRequest: false,
	unsafeWindow: false
};
var devtools = {
	$: false,
	$_: false,
	$$: false,
	$0: false,
	$1: false,
	$2: false,
	$3: false,
	$4: false,
	$x: false,
	chrome: false,
	clear: false,
	copy: false,
	debug: false,
	dir: false,
	dirxml: false,
	getEventListeners: false,
	inspect: false,
	keys: false,
	monitor: false,
	monitorEvents: false,
	profile: false,
	profileEnd: false,
	queryObjects: false,
	table: false,
	undebug: false,
	unmonitor: false,
	unmonitorEvents: false,
	values: false
};
var require$$0$4 = {
	builtin: builtin,
	es5: es5,
	es2015: es2015,
	es2017: es2017,
	browser: browser,
	worker: worker,
	node: node$2,
	commonjs: commonjs,
	amd: amd,
	mocha: mocha,
	jasmine: jasmine,
	jest: jest,
	qunit: qunit,
	phantomjs: phantomjs,
	couch: couch,
	rhino: rhino,
	nashorn: nashorn,
	wsh: wsh,
	jquery: jquery,
	yui: yui,
	shelljs: shelljs,
	prototypejs: prototypejs,
	meteor: meteor,
	mongo: mongo,
	applescript: applescript,
	serviceworker: serviceworker,
	atomtest: atomtest,
	embertest: embertest,
	protractor: protractor,
	"shared-node-browser": {
	clearInterval: false,
	clearTimeout: false,
	console: false,
	setInterval: false,
	setTimeout: false,
	URL: false,
	URLSearchParams: false
},
	webextensions: webextensions,
	greasemonkey: greasemonkey,
	devtools: devtools
};

var globals;
var hasRequiredGlobals;

function requireGlobals () {
	if (hasRequiredGlobals) return globals;
	hasRequiredGlobals = 1;
	globals = require$$0$4;
	return globals;
}

var hasRequiredScope;

function requireScope () {
	if (hasRequiredScope) return scope;
	hasRequiredScope = 1;

	Object.defineProperty(scope, "__esModule", {
	  value: true
	});
	scope.default = void 0;
	var _renamer = requireRenamer();
	var _index = requireLib$7();
	var _binding = requireBinding();
	var _globals = requireGlobals();
	var _t = requireLib$h();
	var t = _t;
	var _cache = requireCache();
	var _visitors = requireVisitors();
	const {
	  NOT_LOCAL_BINDING,
	  callExpression,
	  cloneNode,
	  getBindingIdentifiers,
	  identifier,
	  isArrayExpression,
	  isBinary,
	  isCallExpression,
	  isClass,
	  isClassBody,
	  isClassDeclaration,
	  isExportAllDeclaration,
	  isExportDefaultDeclaration,
	  isExportNamedDeclaration,
	  isFunctionDeclaration,
	  isIdentifier,
	  isImportDeclaration,
	  isLiteral,
	  isMemberExpression,
	  isMethod,
	  isModuleSpecifier,
	  isNullLiteral,
	  isObjectExpression,
	  isProperty,
	  isPureish,
	  isRegExpLiteral,
	  isSuper,
	  isTaggedTemplateExpression,
	  isTemplateLiteral,
	  isThisExpression,
	  isUnaryExpression,
	  isVariableDeclaration,
	  matchesPattern,
	  memberExpression,
	  numericLiteral,
	  toIdentifier,
	  variableDeclaration,
	  variableDeclarator,
	  isRecordExpression,
	  isTupleExpression,
	  isObjectProperty,
	  isTopicReference,
	  isMetaProperty,
	  isPrivateName,
	  isExportDeclaration,
	  buildUndefinedNode
	} = _t;
	function gatherNodeParts(node, parts) {
	  switch (node == null ? void 0 : node.type) {
	    default:
	      if (isImportDeclaration(node) || isExportDeclaration(node)) {
	        var _node$specifiers;
	        if ((isExportAllDeclaration(node) || isExportNamedDeclaration(node) || isImportDeclaration(node)) && node.source) {
	          gatherNodeParts(node.source, parts);
	        } else if ((isExportNamedDeclaration(node) || isImportDeclaration(node)) && (_node$specifiers = node.specifiers) != null && _node$specifiers.length) {
	          for (const e of node.specifiers) gatherNodeParts(e, parts);
	        } else if ((isExportDefaultDeclaration(node) || isExportNamedDeclaration(node)) && node.declaration) {
	          gatherNodeParts(node.declaration, parts);
	        }
	      } else if (isModuleSpecifier(node)) {
	        gatherNodeParts(node.local, parts);
	      } else if (isLiteral(node) && !isNullLiteral(node) && !isRegExpLiteral(node) && !isTemplateLiteral(node)) {
	        parts.push(node.value);
	      }
	      break;
	    case "MemberExpression":
	    case "OptionalMemberExpression":
	    case "JSXMemberExpression":
	      gatherNodeParts(node.object, parts);
	      gatherNodeParts(node.property, parts);
	      break;
	    case "Identifier":
	    case "JSXIdentifier":
	      parts.push(node.name);
	      break;
	    case "CallExpression":
	    case "OptionalCallExpression":
	    case "NewExpression":
	      gatherNodeParts(node.callee, parts);
	      break;
	    case "ObjectExpression":
	    case "ObjectPattern":
	      for (const e of node.properties) {
	        gatherNodeParts(e, parts);
	      }
	      break;
	    case "SpreadElement":
	    case "RestElement":
	      gatherNodeParts(node.argument, parts);
	      break;
	    case "ObjectProperty":
	    case "ObjectMethod":
	    case "ClassProperty":
	    case "ClassMethod":
	    case "ClassPrivateProperty":
	    case "ClassPrivateMethod":
	      gatherNodeParts(node.key, parts);
	      break;
	    case "ThisExpression":
	      parts.push("this");
	      break;
	    case "Super":
	      parts.push("super");
	      break;
	    case "Import":
	      parts.push("import");
	      break;
	    case "DoExpression":
	      parts.push("do");
	      break;
	    case "YieldExpression":
	      parts.push("yield");
	      gatherNodeParts(node.argument, parts);
	      break;
	    case "AwaitExpression":
	      parts.push("await");
	      gatherNodeParts(node.argument, parts);
	      break;
	    case "AssignmentExpression":
	      gatherNodeParts(node.left, parts);
	      break;
	    case "VariableDeclarator":
	      gatherNodeParts(node.id, parts);
	      break;
	    case "FunctionExpression":
	    case "FunctionDeclaration":
	    case "ClassExpression":
	    case "ClassDeclaration":
	      gatherNodeParts(node.id, parts);
	      break;
	    case "PrivateName":
	      gatherNodeParts(node.id, parts);
	      break;
	    case "ParenthesizedExpression":
	      gatherNodeParts(node.expression, parts);
	      break;
	    case "UnaryExpression":
	    case "UpdateExpression":
	      gatherNodeParts(node.argument, parts);
	      break;
	    case "MetaProperty":
	      gatherNodeParts(node.meta, parts);
	      gatherNodeParts(node.property, parts);
	      break;
	    case "JSXElement":
	      gatherNodeParts(node.openingElement, parts);
	      break;
	    case "JSXOpeningElement":
	      gatherNodeParts(node.name, parts);
	      break;
	    case "JSXFragment":
	      gatherNodeParts(node.openingFragment, parts);
	      break;
	    case "JSXOpeningFragment":
	      parts.push("Fragment");
	      break;
	    case "JSXNamespacedName":
	      gatherNodeParts(node.namespace, parts);
	      gatherNodeParts(node.name, parts);
	      break;
	  }
	}
	const collectorVisitor = {
	  ForStatement(path) {
	    const declar = path.get("init");
	    if (declar.isVar()) {
	      const {
	        scope
	      } = path;
	      const parentScope = scope.getFunctionParent() || scope.getProgramParent();
	      parentScope.registerBinding("var", declar);
	    }
	  },
	  Declaration(path) {
	    if (path.isBlockScoped()) return;
	    if (path.isImportDeclaration()) return;
	    if (path.isExportDeclaration()) return;
	    const parent = path.scope.getFunctionParent() || path.scope.getProgramParent();
	    parent.registerDeclaration(path);
	  },
	  ImportDeclaration(path) {
	    const parent = path.scope.getBlockParent();
	    parent.registerDeclaration(path);
	  },
	  ReferencedIdentifier(path, state) {
	    state.references.push(path);
	  },
	  ForXStatement(path, state) {
	    const left = path.get("left");
	    if (left.isPattern() || left.isIdentifier()) {
	      state.constantViolations.push(path);
	    } else if (left.isVar()) {
	      const {
	        scope
	      } = path;
	      const parentScope = scope.getFunctionParent() || scope.getProgramParent();
	      parentScope.registerBinding("var", left);
	    }
	  },
	  ExportDeclaration: {
	    exit(path) {
	      const {
	        node,
	        scope
	      } = path;
	      if (isExportAllDeclaration(node)) return;
	      const declar = node.declaration;
	      if (isClassDeclaration(declar) || isFunctionDeclaration(declar)) {
	        const id = declar.id;
	        if (!id) return;
	        const binding = scope.getBinding(id.name);
	        binding == null || binding.reference(path);
	      } else if (isVariableDeclaration(declar)) {
	        for (const decl of declar.declarations) {
	          for (const name of Object.keys(getBindingIdentifiers(decl))) {
	            const binding = scope.getBinding(name);
	            binding == null || binding.reference(path);
	          }
	        }
	      }
	    }
	  },
	  LabeledStatement(path) {
	    path.scope.getBlockParent().registerDeclaration(path);
	  },
	  AssignmentExpression(path, state) {
	    state.assignments.push(path);
	  },
	  UpdateExpression(path, state) {
	    state.constantViolations.push(path);
	  },
	  UnaryExpression(path, state) {
	    if (path.node.operator === "delete") {
	      state.constantViolations.push(path);
	    }
	  },
	  BlockScoped(path) {
	    let scope = path.scope;
	    if (scope.path === path) scope = scope.parent;
	    const parent = scope.getBlockParent();
	    parent.registerDeclaration(path);
	    if (path.isClassDeclaration() && path.node.id) {
	      const id = path.node.id;
	      const name = id.name;
	      path.scope.bindings[name] = path.scope.parent.getBinding(name);
	    }
	  },
	  CatchClause(path) {
	    path.scope.registerBinding("let", path);
	  },
	  Function(path) {
	    const params = path.get("params");
	    for (const param of params) {
	      path.scope.registerBinding("param", param);
	    }
	    if (path.isFunctionExpression() && path.has("id") && !path.get("id").node[NOT_LOCAL_BINDING]) {
	      path.scope.registerBinding("local", path.get("id"), path);
	    }
	  },
	  ClassExpression(path) {
	    if (path.has("id") && !path.get("id").node[NOT_LOCAL_BINDING]) {
	      path.scope.registerBinding("local", path);
	    }
	  },
	  TSTypeAnnotation(path) {
	    path.skip();
	  }
	};
	let uid = 0;
	class Scope {
	  constructor(path) {
	    this.uid = void 0;
	    this.path = void 0;
	    this.block = void 0;
	    this.labels = void 0;
	    this.inited = void 0;
	    this.bindings = void 0;
	    this.references = void 0;
	    this.globals = void 0;
	    this.uids = void 0;
	    this.data = void 0;
	    this.crawling = void 0;
	    const {
	      node
	    } = path;
	    const cached = _cache.scope.get(node);
	    if ((cached == null ? void 0 : cached.path) === path) {
	      return cached;
	    }
	    _cache.scope.set(node, this);
	    this.uid = uid++;
	    this.block = node;
	    this.path = path;
	    this.labels = new Map();
	    this.inited = false;
	  }
	  get parent() {
	    var _parent;
	    let parent,
	      path = this.path;
	    do {
	      const shouldSkip = path.key === "key" || path.listKey === "decorators";
	      path = path.parentPath;
	      if (shouldSkip && path.isMethod()) path = path.parentPath;
	      if (path && path.isScope()) parent = path;
	    } while (path && !parent);
	    return (_parent = parent) == null ? void 0 : _parent.scope;
	  }
	  get parentBlock() {
	    return this.path.parent;
	  }
	  get hub() {
	    return this.path.hub;
	  }
	  traverse(node, opts, state) {
	    (0, _index.default)(node, opts, this, state, this.path);
	  }
	  generateDeclaredUidIdentifier(name) {
	    const id = this.generateUidIdentifier(name);
	    this.push({
	      id
	    });
	    return cloneNode(id);
	  }
	  generateUidIdentifier(name) {
	    return identifier(this.generateUid(name));
	  }
	  generateUid(name = "temp") {
	    name = toIdentifier(name).replace(/^_+/, "").replace(/[0-9]+$/g, "");
	    let uid;
	    let i = 1;
	    do {
	      uid = this._generateUid(name, i);
	      i++;
	    } while (this.hasLabel(uid) || this.hasBinding(uid) || this.hasGlobal(uid) || this.hasReference(uid));
	    const program = this.getProgramParent();
	    program.references[uid] = true;
	    program.uids[uid] = true;
	    return uid;
	  }
	  _generateUid(name, i) {
	    let id = name;
	    if (i > 1) id += i;
	    return `_${id}`;
	  }
	  generateUidBasedOnNode(node, defaultName) {
	    const parts = [];
	    gatherNodeParts(node, parts);
	    let id = parts.join("$");
	    id = id.replace(/^_/, "") || defaultName || "ref";
	    return this.generateUid(id.slice(0, 20));
	  }
	  generateUidIdentifierBasedOnNode(node, defaultName) {
	    return identifier(this.generateUidBasedOnNode(node, defaultName));
	  }
	  isStatic(node) {
	    if (isThisExpression(node) || isSuper(node) || isTopicReference(node)) {
	      return true;
	    }
	    if (isIdentifier(node)) {
	      const binding = this.getBinding(node.name);
	      if (binding) {
	        return binding.constant;
	      } else {
	        return this.hasBinding(node.name);
	      }
	    }
	    return false;
	  }
	  maybeGenerateMemoised(node, dontPush) {
	    if (this.isStatic(node)) {
	      return null;
	    } else {
	      const id = this.generateUidIdentifierBasedOnNode(node);
	      if (!dontPush) {
	        this.push({
	          id
	        });
	        return cloneNode(id);
	      }
	      return id;
	    }
	  }
	  checkBlockScopedCollisions(local, kind, name, id) {
	    if (kind === "param") return;
	    if (local.kind === "local") return;
	    const duplicate = kind === "let" || local.kind === "let" || local.kind === "const" || local.kind === "module" || local.kind === "param" && kind === "const";
	    if (duplicate) {
	      throw this.hub.buildError(id, `Duplicate declaration "${name}"`, TypeError);
	    }
	  }
	  rename(oldName, newName) {
	    const binding = this.getBinding(oldName);
	    if (binding) {
	      newName || (newName = this.generateUidIdentifier(oldName).name);
	      const renamer = new _renamer.default(binding, oldName, newName);
	      {
	        renamer.rename(arguments[2]);
	      }
	    }
	  }
	  _renameFromMap(map, oldName, newName, value) {
	    if (map[oldName]) {
	      map[newName] = value;
	      map[oldName] = null;
	    }
	  }
	  dump() {
	    const sep = "-".repeat(60);
	    console.log(sep);
	    let scope = this;
	    do {
	      console.log("#", scope.block.type);
	      for (const name of Object.keys(scope.bindings)) {
	        const binding = scope.bindings[name];
	        console.log(" -", name, {
	          constant: binding.constant,
	          references: binding.references,
	          violations: binding.constantViolations.length,
	          kind: binding.kind
	        });
	      }
	    } while (scope = scope.parent);
	    console.log(sep);
	  }
	  toArray(node, i, arrayLikeIsIterable) {
	    if (isIdentifier(node)) {
	      const binding = this.getBinding(node.name);
	      if (binding != null && binding.constant && binding.path.isGenericType("Array")) {
	        return node;
	      }
	    }
	    if (isArrayExpression(node)) {
	      return node;
	    }
	    if (isIdentifier(node, {
	      name: "arguments"
	    })) {
	      return callExpression(memberExpression(memberExpression(memberExpression(identifier("Array"), identifier("prototype")), identifier("slice")), identifier("call")), [node]);
	    }
	    let helperName;
	    const args = [node];
	    if (i === true) {
	      helperName = "toConsumableArray";
	    } else if (typeof i === "number") {
	      args.push(numericLiteral(i));
	      helperName = "slicedToArray";
	    } else {
	      helperName = "toArray";
	    }
	    if (arrayLikeIsIterable) {
	      args.unshift(this.hub.addHelper(helperName));
	      helperName = "maybeArrayLike";
	    }
	    return callExpression(this.hub.addHelper(helperName), args);
	  }
	  hasLabel(name) {
	    return !!this.getLabel(name);
	  }
	  getLabel(name) {
	    return this.labels.get(name);
	  }
	  registerLabel(path) {
	    this.labels.set(path.node.label.name, path);
	  }
	  registerDeclaration(path) {
	    if (path.isLabeledStatement()) {
	      this.registerLabel(path);
	    } else if (path.isFunctionDeclaration()) {
	      this.registerBinding("hoisted", path.get("id"), path);
	    } else if (path.isVariableDeclaration()) {
	      const declarations = path.get("declarations");
	      const {
	        kind
	      } = path.node;
	      for (const declar of declarations) {
	        this.registerBinding(kind === "using" || kind === "await using" ? "const" : kind, declar);
	      }
	    } else if (path.isClassDeclaration()) {
	      if (path.node.declare) return;
	      this.registerBinding("let", path);
	    } else if (path.isImportDeclaration()) {
	      const isTypeDeclaration = path.node.importKind === "type" || path.node.importKind === "typeof";
	      const specifiers = path.get("specifiers");
	      for (const specifier of specifiers) {
	        const isTypeSpecifier = isTypeDeclaration || specifier.isImportSpecifier() && (specifier.node.importKind === "type" || specifier.node.importKind === "typeof");
	        this.registerBinding(isTypeSpecifier ? "unknown" : "module", specifier);
	      }
	    } else if (path.isExportDeclaration()) {
	      const declar = path.get("declaration");
	      if (declar.isClassDeclaration() || declar.isFunctionDeclaration() || declar.isVariableDeclaration()) {
	        this.registerDeclaration(declar);
	      }
	    } else {
	      this.registerBinding("unknown", path);
	    }
	  }
	  buildUndefinedNode() {
	    return buildUndefinedNode();
	  }
	  registerConstantViolation(path) {
	    const ids = path.getBindingIdentifiers();
	    for (const name of Object.keys(ids)) {
	      var _this$getBinding;
	      (_this$getBinding = this.getBinding(name)) == null || _this$getBinding.reassign(path);
	    }
	  }
	  registerBinding(kind, path, bindingPath = path) {
	    if (!kind) throw new ReferenceError("no `kind`");
	    if (path.isVariableDeclaration()) {
	      const declarators = path.get("declarations");
	      for (const declar of declarators) {
	        this.registerBinding(kind, declar);
	      }
	      return;
	    }
	    const parent = this.getProgramParent();
	    const ids = path.getOuterBindingIdentifiers(true);
	    for (const name of Object.keys(ids)) {
	      parent.references[name] = true;
	      for (const id of ids[name]) {
	        const local = this.getOwnBinding(name);
	        if (local) {
	          if (local.identifier === id) continue;
	          this.checkBlockScopedCollisions(local, kind, name, id);
	        }
	        if (local) {
	          this.registerConstantViolation(bindingPath);
	        } else {
	          this.bindings[name] = new _binding.default({
	            identifier: id,
	            scope: this,
	            path: bindingPath,
	            kind: kind
	          });
	        }
	      }
	    }
	  }
	  addGlobal(node) {
	    this.globals[node.name] = node;
	  }
	  hasUid(name) {
	    let scope = this;
	    do {
	      if (scope.uids[name]) return true;
	    } while (scope = scope.parent);
	    return false;
	  }
	  hasGlobal(name) {
	    let scope = this;
	    do {
	      if (scope.globals[name]) return true;
	    } while (scope = scope.parent);
	    return false;
	  }
	  hasReference(name) {
	    return !!this.getProgramParent().references[name];
	  }
	  isPure(node, constantsOnly) {
	    if (isIdentifier(node)) {
	      const binding = this.getBinding(node.name);
	      if (!binding) return false;
	      if (constantsOnly) return binding.constant;
	      return true;
	    } else if (isThisExpression(node) || isMetaProperty(node) || isTopicReference(node) || isPrivateName(node)) {
	      return true;
	    } else if (isClass(node)) {
	      var _node$decorators;
	      if (node.superClass && !this.isPure(node.superClass, constantsOnly)) {
	        return false;
	      }
	      if (((_node$decorators = node.decorators) == null ? void 0 : _node$decorators.length) > 0) {
	        return false;
	      }
	      return this.isPure(node.body, constantsOnly);
	    } else if (isClassBody(node)) {
	      for (const method of node.body) {
	        if (!this.isPure(method, constantsOnly)) return false;
	      }
	      return true;
	    } else if (isBinary(node)) {
	      return this.isPure(node.left, constantsOnly) && this.isPure(node.right, constantsOnly);
	    } else if (isArrayExpression(node) || isTupleExpression(node)) {
	      for (const elem of node.elements) {
	        if (elem !== null && !this.isPure(elem, constantsOnly)) return false;
	      }
	      return true;
	    } else if (isObjectExpression(node) || isRecordExpression(node)) {
	      for (const prop of node.properties) {
	        if (!this.isPure(prop, constantsOnly)) return false;
	      }
	      return true;
	    } else if (isMethod(node)) {
	      var _node$decorators2;
	      if (node.computed && !this.isPure(node.key, constantsOnly)) return false;
	      if (((_node$decorators2 = node.decorators) == null ? void 0 : _node$decorators2.length) > 0) {
	        return false;
	      }
	      return true;
	    } else if (isProperty(node)) {
	      var _node$decorators3;
	      if (node.computed && !this.isPure(node.key, constantsOnly)) return false;
	      if (((_node$decorators3 = node.decorators) == null ? void 0 : _node$decorators3.length) > 0) {
	        return false;
	      }
	      if (isObjectProperty(node) || node.static) {
	        if (node.value !== null && !this.isPure(node.value, constantsOnly)) {
	          return false;
	        }
	      }
	      return true;
	    } else if (isUnaryExpression(node)) {
	      return this.isPure(node.argument, constantsOnly);
	    } else if (isTemplateLiteral(node)) {
	      for (const expression of node.expressions) {
	        if (!this.isPure(expression, constantsOnly)) return false;
	      }
	      return true;
	    } else if (isTaggedTemplateExpression(node)) {
	      return matchesPattern(node.tag, "String.raw") && !this.hasBinding("String", {
	        noGlobals: true
	      }) && this.isPure(node.quasi, constantsOnly);
	    } else if (isMemberExpression(node)) {
	      return !node.computed && isIdentifier(node.object) && node.object.name === "Symbol" && isIdentifier(node.property) && node.property.name !== "for" && !this.hasBinding("Symbol", {
	        noGlobals: true
	      });
	    } else if (isCallExpression(node)) {
	      return matchesPattern(node.callee, "Symbol.for") && !this.hasBinding("Symbol", {
	        noGlobals: true
	      }) && node.arguments.length === 1 && t.isStringLiteral(node.arguments[0]);
	    } else {
	      return isPureish(node);
	    }
	  }
	  setData(key, val) {
	    return this.data[key] = val;
	  }
	  getData(key) {
	    let scope = this;
	    do {
	      const data = scope.data[key];
	      if (data != null) return data;
	    } while (scope = scope.parent);
	  }
	  removeData(key) {
	    let scope = this;
	    do {
	      const data = scope.data[key];
	      if (data != null) scope.data[key] = null;
	    } while (scope = scope.parent);
	  }
	  init() {
	    if (!this.inited) {
	      this.inited = true;
	      this.crawl();
	    }
	  }
	  crawl() {
	    const path = this.path;
	    this.references = Object.create(null);
	    this.bindings = Object.create(null);
	    this.globals = Object.create(null);
	    this.uids = Object.create(null);
	    this.data = Object.create(null);
	    const programParent = this.getProgramParent();
	    if (programParent.crawling) return;
	    const state = {
	      references: [],
	      constantViolations: [],
	      assignments: []
	    };
	    this.crawling = true;
	    if (path.type !== "Program" && (0, _visitors.isExplodedVisitor)(collectorVisitor)) {
	      for (const visit of collectorVisitor.enter) {
	        visit.call(state, path, state);
	      }
	      const typeVisitors = collectorVisitor[path.type];
	      if (typeVisitors) {
	        for (const visit of typeVisitors.enter) {
	          visit.call(state, path, state);
	        }
	      }
	    }
	    path.traverse(collectorVisitor, state);
	    this.crawling = false;
	    for (const path of state.assignments) {
	      const ids = path.getBindingIdentifiers();
	      for (const name of Object.keys(ids)) {
	        if (path.scope.getBinding(name)) continue;
	        programParent.addGlobal(ids[name]);
	      }
	      path.scope.registerConstantViolation(path);
	    }
	    for (const ref of state.references) {
	      const binding = ref.scope.getBinding(ref.node.name);
	      if (binding) {
	        binding.reference(ref);
	      } else {
	        programParent.addGlobal(ref.node);
	      }
	    }
	    for (const path of state.constantViolations) {
	      path.scope.registerConstantViolation(path);
	    }
	  }
	  push(opts) {
	    let path = this.path;
	    if (path.isPattern()) {
	      path = this.getPatternParent().path;
	    } else if (!path.isBlockStatement() && !path.isProgram()) {
	      path = this.getBlockParent().path;
	    }
	    if (path.isSwitchStatement()) {
	      path = (this.getFunctionParent() || this.getProgramParent()).path;
	    }
	    const {
	      init,
	      unique,
	      kind = "var",
	      id
	    } = opts;
	    if (!init && !unique && (kind === "var" || kind === "let") && path.isFunction() && !path.node.name && isCallExpression(path.parent, {
	      callee: path.node
	    }) && path.parent.arguments.length <= path.node.params.length && isIdentifier(id)) {
	      path.pushContainer("params", id);
	      path.scope.registerBinding("param", path.get("params")[path.node.params.length - 1]);
	      return;
	    }
	    if (path.isLoop() || path.isCatchClause() || path.isFunction()) {
	      path.ensureBlock();
	      path = path.get("body");
	    }
	    const blockHoist = opts._blockHoist == null ? 2 : opts._blockHoist;
	    const dataKey = `declaration:${kind}:${blockHoist}`;
	    let declarPath = !unique && path.getData(dataKey);
	    if (!declarPath) {
	      const declar = variableDeclaration(kind, []);
	      declar._blockHoist = blockHoist;
	      [declarPath] = path.unshiftContainer("body", [declar]);
	      if (!unique) path.setData(dataKey, declarPath);
	    }
	    const declarator = variableDeclarator(id, init);
	    const len = declarPath.node.declarations.push(declarator);
	    path.scope.registerBinding(kind, declarPath.get("declarations")[len - 1]);
	  }
	  getProgramParent() {
	    let scope = this;
	    do {
	      if (scope.path.isProgram()) {
	        return scope;
	      }
	    } while (scope = scope.parent);
	    throw new Error("Couldn't find a Program");
	  }
	  getFunctionParent() {
	    let scope = this;
	    do {
	      if (scope.path.isFunctionParent()) {
	        return scope;
	      }
	    } while (scope = scope.parent);
	    return null;
	  }
	  getBlockParent() {
	    let scope = this;
	    do {
	      if (scope.path.isBlockParent()) {
	        return scope;
	      }
	    } while (scope = scope.parent);
	    throw new Error("We couldn't find a BlockStatement, For, Switch, Function, Loop or Program...");
	  }
	  getPatternParent() {
	    let scope = this;
	    do {
	      if (!scope.path.isPattern()) {
	        return scope.getBlockParent();
	      }
	    } while (scope = scope.parent.parent);
	    throw new Error("We couldn't find a BlockStatement, For, Switch, Function, Loop or Program...");
	  }
	  getAllBindings() {
	    const ids = Object.create(null);
	    let scope = this;
	    do {
	      for (const key of Object.keys(scope.bindings)) {
	        if (key in ids === false) {
	          ids[key] = scope.bindings[key];
	        }
	      }
	      scope = scope.parent;
	    } while (scope);
	    return ids;
	  }
	  getAllBindingsOfKind(...kinds) {
	    const ids = Object.create(null);
	    for (const kind of kinds) {
	      let scope = this;
	      do {
	        for (const name of Object.keys(scope.bindings)) {
	          const binding = scope.bindings[name];
	          if (binding.kind === kind) ids[name] = binding;
	        }
	        scope = scope.parent;
	      } while (scope);
	    }
	    return ids;
	  }
	  bindingIdentifierEquals(name, node) {
	    return this.getBindingIdentifier(name) === node;
	  }
	  getBinding(name) {
	    let scope = this;
	    let previousPath;
	    do {
	      const binding = scope.getOwnBinding(name);
	      if (binding) {
	        var _previousPath;
	        if ((_previousPath = previousPath) != null && _previousPath.isPattern() && binding.kind !== "param" && binding.kind !== "local") ; else {
	          return binding;
	        }
	      } else if (!binding && name === "arguments" && scope.path.isFunction() && !scope.path.isArrowFunctionExpression()) {
	        break;
	      }
	      previousPath = scope.path;
	    } while (scope = scope.parent);
	  }
	  getOwnBinding(name) {
	    return this.bindings[name];
	  }
	  getBindingIdentifier(name) {
	    var _this$getBinding2;
	    return (_this$getBinding2 = this.getBinding(name)) == null ? void 0 : _this$getBinding2.identifier;
	  }
	  getOwnBindingIdentifier(name) {
	    const binding = this.bindings[name];
	    return binding == null ? void 0 : binding.identifier;
	  }
	  hasOwnBinding(name) {
	    return !!this.getOwnBinding(name);
	  }
	  hasBinding(name, opts) {
	    var _opts, _opts2, _opts3;
	    if (!name) return false;
	    if (this.hasOwnBinding(name)) return true;
	    {
	      if (typeof opts === "boolean") opts = {
	        noGlobals: opts
	      };
	    }
	    if (this.parentHasBinding(name, opts)) return true;
	    if (!((_opts = opts) != null && _opts.noUids) && this.hasUid(name)) return true;
	    if (!((_opts2 = opts) != null && _opts2.noGlobals) && Scope.globals.includes(name)) return true;
	    if (!((_opts3 = opts) != null && _opts3.noGlobals) && Scope.contextVariables.includes(name)) return true;
	    return false;
	  }
	  parentHasBinding(name, opts) {
	    var _this$parent;
	    return (_this$parent = this.parent) == null ? void 0 : _this$parent.hasBinding(name, opts);
	  }
	  moveBindingTo(name, scope) {
	    const info = this.getBinding(name);
	    if (info) {
	      info.scope.removeOwnBinding(name);
	      info.scope = scope;
	      scope.bindings[name] = info;
	    }
	  }
	  removeOwnBinding(name) {
	    delete this.bindings[name];
	  }
	  removeBinding(name) {
	    var _this$getBinding3;
	    (_this$getBinding3 = this.getBinding(name)) == null || _this$getBinding3.scope.removeOwnBinding(name);
	    let scope = this;
	    do {
	      if (scope.uids[name]) {
	        scope.uids[name] = false;
	      }
	    } while (scope = scope.parent);
	  }
	}
	scope.default = Scope;
	Scope.globals = Object.keys(_globals.builtin);
	Scope.contextVariables = ["arguments", "undefined", "Infinity", "NaN"];

	
	return scope;
}

var lib$b = {};

var sourceMap = {};

var hasRequiredSourceMap;

function requireSourceMap () {
	if (hasRequiredSourceMap) return sourceMap;
	hasRequiredSourceMap = 1;

	Object.defineProperty(sourceMap, "__esModule", {
	  value: true
	});
	sourceMap.default = void 0;
	var _genMapping = requireGenMapping_umd();
	var _traceMapping = requireTraceMapping_umd();
	class SourceMap {
	  constructor(opts, code) {
	    var _opts$sourceFileName;
	    this._map = void 0;
	    this._rawMappings = void 0;
	    this._sourceFileName = void 0;
	    this._lastGenLine = 0;
	    this._lastSourceLine = 0;
	    this._lastSourceColumn = 0;
	    this._inputMap = void 0;
	    const map = this._map = new _genMapping.GenMapping({
	      sourceRoot: opts.sourceRoot
	    });
	    this._sourceFileName = (_opts$sourceFileName = opts.sourceFileName) == null ? void 0 : _opts$sourceFileName.replace(/\\/g, "/");
	    this._rawMappings = undefined;
	    if (opts.inputSourceMap) {
	      this._inputMap = new _traceMapping.TraceMap(opts.inputSourceMap);
	      const resolvedSources = this._inputMap.resolvedSources;
	      if (resolvedSources.length) {
	        for (let i = 0; i < resolvedSources.length; i++) {
	          var _this$_inputMap$sourc;
	          (0, _genMapping.setSourceContent)(map, resolvedSources[i], (_this$_inputMap$sourc = this._inputMap.sourcesContent) == null ? void 0 : _this$_inputMap$sourc[i]);
	        }
	      }
	    }
	    if (typeof code === "string" && !opts.inputSourceMap) {
	      (0, _genMapping.setSourceContent)(map, this._sourceFileName, code);
	    } else if (typeof code === "object") {
	      for (const sourceFileName of Object.keys(code)) {
	        (0, _genMapping.setSourceContent)(map, sourceFileName.replace(/\\/g, "/"), code[sourceFileName]);
	      }
	    }
	  }
	  get() {
	    return (0, _genMapping.toEncodedMap)(this._map);
	  }
	  getDecoded() {
	    return (0, _genMapping.toDecodedMap)(this._map);
	  }
	  getRawMappings() {
	    return this._rawMappings || (this._rawMappings = (0, _genMapping.allMappings)(this._map));
	  }
	  mark(generated, line, column, identifierName, identifierNamePos, filename) {
	    var _originalMapping;
	    this._rawMappings = undefined;
	    let originalMapping;
	    if (line != null) {
	      if (this._inputMap) {
	        originalMapping = (0, _traceMapping.originalPositionFor)(this._inputMap, {
	          line,
	          column
	        });
	        if (!originalMapping.name && identifierNamePos) {
	          const originalIdentifierMapping = (0, _traceMapping.originalPositionFor)(this._inputMap, identifierNamePos);
	          if (originalIdentifierMapping.name) {
	            identifierName = originalIdentifierMapping.name;
	          }
	        }
	      } else {
	        originalMapping = {
	          source: (filename == null ? void 0 : filename.replace(/\\/g, "/")) || this._sourceFileName,
	          line: line,
	          column: column
	        };
	      }
	    }
	    (0, _genMapping.maybeAddMapping)(this._map, {
	      name: identifierName,
	      generated,
	      source: (_originalMapping = originalMapping) == null ? void 0 : _originalMapping.source,
	      original: originalMapping
	    });
	  }
	}
	sourceMap.default = SourceMap;

	
	return sourceMap;
}

var printer$1 = {};

var buffer$2 = {};

var hasRequiredBuffer;

function requireBuffer () {
	if (hasRequiredBuffer) return buffer$2;
	hasRequiredBuffer = 1;

	Object.defineProperty(buffer$2, "__esModule", {
	  value: true
	});
	buffer$2.default = void 0;
	class Buffer {
	  constructor(map, indentChar) {
	    this._map = null;
	    this._buf = "";
	    this._str = "";
	    this._appendCount = 0;
	    this._last = 0;
	    this._queue = [];
	    this._queueCursor = 0;
	    this._canMarkIdName = true;
	    this._indentChar = "";
	    this._fastIndentations = [];
	    this._position = {
	      line: 1,
	      column: 0
	    };
	    this._sourcePosition = {
	      identifierName: undefined,
	      identifierNamePos: undefined,
	      line: undefined,
	      column: undefined,
	      filename: undefined
	    };
	    this._map = map;
	    this._indentChar = indentChar;
	    for (let i = 0; i < 64; i++) {
	      this._fastIndentations.push(indentChar.repeat(i));
	    }
	    this._allocQueue();
	  }
	  _allocQueue() {
	    const queue = this._queue;
	    for (let i = 0; i < 16; i++) {
	      queue.push({
	        char: 0,
	        repeat: 1,
	        line: undefined,
	        column: undefined,
	        identifierName: undefined,
	        identifierNamePos: undefined,
	        filename: ""
	      });
	    }
	  }
	  _pushQueue(char, repeat, line, column, filename) {
	    const cursor = this._queueCursor;
	    if (cursor === this._queue.length) {
	      this._allocQueue();
	    }
	    const item = this._queue[cursor];
	    item.char = char;
	    item.repeat = repeat;
	    item.line = line;
	    item.column = column;
	    item.filename = filename;
	    this._queueCursor++;
	  }
	  _popQueue() {
	    if (this._queueCursor === 0) {
	      throw new Error("Cannot pop from empty queue");
	    }
	    return this._queue[--this._queueCursor];
	  }
	  get() {
	    this._flush();
	    const map = this._map;
	    const result = {
	      code: (this._buf + this._str).trimRight(),
	      decodedMap: map == null ? void 0 : map.getDecoded(),
	      get __mergedMap() {
	        return this.map;
	      },
	      get map() {
	        const resultMap = map ? map.get() : null;
	        result.map = resultMap;
	        return resultMap;
	      },
	      set map(value) {
	        Object.defineProperty(result, "map", {
	          value,
	          writable: true
	        });
	      },
	      get rawMappings() {
	        const mappings = map == null ? void 0 : map.getRawMappings();
	        result.rawMappings = mappings;
	        return mappings;
	      },
	      set rawMappings(value) {
	        Object.defineProperty(result, "rawMappings", {
	          value,
	          writable: true
	        });
	      }
	    };
	    return result;
	  }
	  append(str, maybeNewline) {
	    this._flush();
	    this._append(str, this._sourcePosition, maybeNewline);
	  }
	  appendChar(char) {
	    this._flush();
	    this._appendChar(char, 1, this._sourcePosition);
	  }
	  queue(char) {
	    if (char === 10) {
	      while (this._queueCursor !== 0) {
	        const char = this._queue[this._queueCursor - 1].char;
	        if (char !== 32 && char !== 9) {
	          break;
	        }
	        this._queueCursor--;
	      }
	    }
	    const sourcePosition = this._sourcePosition;
	    this._pushQueue(char, 1, sourcePosition.line, sourcePosition.column, sourcePosition.filename);
	  }
	  queueIndentation(repeat) {
	    if (repeat === 0) return;
	    this._pushQueue(-1, repeat, undefined, undefined, undefined);
	  }
	  _flush() {
	    const queueCursor = this._queueCursor;
	    const queue = this._queue;
	    for (let i = 0; i < queueCursor; i++) {
	      const item = queue[i];
	      this._appendChar(item.char, item.repeat, item);
	    }
	    this._queueCursor = 0;
	  }
	  _appendChar(char, repeat, sourcePos) {
	    this._last = char;
	    if (char === -1) {
	      const fastIndentation = this._fastIndentations[repeat];
	      if (fastIndentation !== undefined) {
	        this._str += fastIndentation;
	      } else {
	        this._str += repeat > 1 ? this._indentChar.repeat(repeat) : this._indentChar;
	      }
	    } else {
	      this._str += repeat > 1 ? String.fromCharCode(char).repeat(repeat) : String.fromCharCode(char);
	    }
	    if (char !== 10) {
	      this._mark(sourcePos.line, sourcePos.column, sourcePos.identifierName, sourcePos.identifierNamePos, sourcePos.filename);
	      this._position.column += repeat;
	    } else {
	      this._position.line++;
	      this._position.column = 0;
	    }
	    if (this._canMarkIdName) {
	      sourcePos.identifierName = undefined;
	      sourcePos.identifierNamePos = undefined;
	    }
	  }
	  _append(str, sourcePos, maybeNewline) {
	    const len = str.length;
	    const position = this._position;
	    this._last = str.charCodeAt(len - 1);
	    if (++this._appendCount > 4096) {
	      +this._str;
	      this._buf += this._str;
	      this._str = str;
	      this._appendCount = 0;
	    } else {
	      this._str += str;
	    }
	    if (!maybeNewline && !this._map) {
	      position.column += len;
	      return;
	    }
	    const {
	      column,
	      identifierName,
	      identifierNamePos,
	      filename
	    } = sourcePos;
	    let line = sourcePos.line;
	    if ((identifierName != null || identifierNamePos != null) && this._canMarkIdName) {
	      sourcePos.identifierName = undefined;
	      sourcePos.identifierNamePos = undefined;
	    }
	    let i = str.indexOf("\n");
	    let last = 0;
	    if (i !== 0) {
	      this._mark(line, column, identifierName, identifierNamePos, filename);
	    }
	    while (i !== -1) {
	      position.line++;
	      position.column = 0;
	      last = i + 1;
	      if (last < len && line !== undefined) {
	        this._mark(++line, 0, null, null, filename);
	      }
	      i = str.indexOf("\n", last);
	    }
	    position.column += len - last;
	  }
	  _mark(line, column, identifierName, identifierNamePos, filename) {
	    var _this$_map;
	    (_this$_map = this._map) == null || _this$_map.mark(this._position, line, column, identifierName, identifierNamePos, filename);
	  }
	  removeTrailingNewline() {
	    const queueCursor = this._queueCursor;
	    if (queueCursor !== 0 && this._queue[queueCursor - 1].char === 10) {
	      this._queueCursor--;
	    }
	  }
	  removeLastSemicolon() {
	    const queueCursor = this._queueCursor;
	    if (queueCursor !== 0 && this._queue[queueCursor - 1].char === 59) {
	      this._queueCursor--;
	    }
	  }
	  getLastChar() {
	    const queueCursor = this._queueCursor;
	    return queueCursor !== 0 ? this._queue[queueCursor - 1].char : this._last;
	  }
	  getNewlineCount() {
	    const queueCursor = this._queueCursor;
	    let count = 0;
	    if (queueCursor === 0) return this._last === 10 ? 1 : 0;
	    for (let i = queueCursor - 1; i >= 0; i--) {
	      if (this._queue[i].char !== 10) {
	        break;
	      }
	      count++;
	    }
	    return count === queueCursor && this._last === 10 ? count + 1 : count;
	  }
	  endsWithCharAndNewline() {
	    const queue = this._queue;
	    const queueCursor = this._queueCursor;
	    if (queueCursor !== 0) {
	      const lastCp = queue[queueCursor - 1].char;
	      if (lastCp !== 10) return;
	      if (queueCursor > 1) {
	        return queue[queueCursor - 2].char;
	      } else {
	        return this._last;
	      }
	    }
	  }
	  hasContent() {
	    return this._queueCursor !== 0 || !!this._last;
	  }
	  exactSource(loc, cb) {
	    if (!this._map) {
	      cb();
	      return;
	    }
	    this.source("start", loc);
	    const identifierName = loc.identifierName;
	    const sourcePos = this._sourcePosition;
	    if (identifierName) {
	      this._canMarkIdName = false;
	      sourcePos.identifierName = identifierName;
	    }
	    cb();
	    if (identifierName) {
	      this._canMarkIdName = true;
	      sourcePos.identifierName = undefined;
	      sourcePos.identifierNamePos = undefined;
	    }
	    this.source("end", loc);
	  }
	  source(prop, loc) {
	    if (!this._map) return;
	    this._normalizePosition(prop, loc, 0);
	  }
	  sourceWithOffset(prop, loc, columnOffset) {
	    if (!this._map) return;
	    this._normalizePosition(prop, loc, columnOffset);
	  }
	  withSource(prop, loc, cb) {
	    if (this._map) {
	      this.source(prop, loc);
	    }
	    cb();
	  }
	  _normalizePosition(prop, loc, columnOffset) {
	    const pos = loc[prop];
	    const target = this._sourcePosition;
	    if (pos) {
	      target.line = pos.line;
	      target.column = Math.max(pos.column + columnOffset, 0);
	      target.filename = loc.filename;
	    }
	  }
	  getCurrentColumn() {
	    const queue = this._queue;
	    const queueCursor = this._queueCursor;
	    let lastIndex = -1;
	    let len = 0;
	    for (let i = 0; i < queueCursor; i++) {
	      const item = queue[i];
	      if (item.char === 10) {
	        lastIndex = len;
	      }
	      len += item.repeat;
	    }
	    return lastIndex === -1 ? this._position.column + len : len - 1 - lastIndex;
	  }
	  getCurrentLine() {
	    let count = 0;
	    const queue = this._queue;
	    for (let i = 0; i < this._queueCursor; i++) {
	      if (queue[i].char === 10) {
	        count++;
	      }
	    }
	    return this._position.line + count;
	  }
	}
	buffer$2.default = Buffer;

	
	return buffer$2;
}

var node$1 = {};

var whitespace = {};

var hasRequiredWhitespace;

function requireWhitespace () {
	if (hasRequiredWhitespace) return whitespace;
	hasRequiredWhitespace = 1;

	Object.defineProperty(whitespace, "__esModule", {
	  value: true
	});
	whitespace.nodes = void 0;
	var _t = requireLib$h();
	const {
	  FLIPPED_ALIAS_KEYS,
	  isArrayExpression,
	  isAssignmentExpression,
	  isBinary,
	  isBlockStatement,
	  isCallExpression,
	  isFunction,
	  isIdentifier,
	  isLiteral,
	  isMemberExpression,
	  isObjectExpression,
	  isOptionalCallExpression,
	  isOptionalMemberExpression,
	  isStringLiteral
	} = _t;
	function crawlInternal(node, state) {
	  if (!node) return state;
	  if (isMemberExpression(node) || isOptionalMemberExpression(node)) {
	    crawlInternal(node.object, state);
	    if (node.computed) crawlInternal(node.property, state);
	  } else if (isBinary(node) || isAssignmentExpression(node)) {
	    crawlInternal(node.left, state);
	    crawlInternal(node.right, state);
	  } else if (isCallExpression(node) || isOptionalCallExpression(node)) {
	    state.hasCall = true;
	    crawlInternal(node.callee, state);
	  } else if (isFunction(node)) {
	    state.hasFunction = true;
	  } else if (isIdentifier(node)) {
	    state.hasHelper = state.hasHelper || node.callee && isHelper(node.callee);
	  }
	  return state;
	}
	function crawl(node) {
	  return crawlInternal(node, {
	    hasCall: false,
	    hasFunction: false,
	    hasHelper: false
	  });
	}
	function isHelper(node) {
	  if (!node) return false;
	  if (isMemberExpression(node)) {
	    return isHelper(node.object) || isHelper(node.property);
	  } else if (isIdentifier(node)) {
	    return node.name === "require" || node.name.charCodeAt(0) === 95;
	  } else if (isCallExpression(node)) {
	    return isHelper(node.callee);
	  } else if (isBinary(node) || isAssignmentExpression(node)) {
	    return isIdentifier(node.left) && isHelper(node.left) || isHelper(node.right);
	  } else {
	    return false;
	  }
	}
	function isType(node) {
	  return isLiteral(node) || isObjectExpression(node) || isArrayExpression(node) || isIdentifier(node) || isMemberExpression(node);
	}
	const nodes = whitespace.nodes = {
	  AssignmentExpression(node) {
	    const state = crawl(node.right);
	    if (state.hasCall && state.hasHelper || state.hasFunction) {
	      return state.hasFunction ? 1 | 2 : 2;
	    }
	  },
	  SwitchCase(node, parent) {
	    return (!!node.consequent.length || parent.cases[0] === node ? 1 : 0) | (!node.consequent.length && parent.cases[parent.cases.length - 1] === node ? 2 : 0);
	  },
	  LogicalExpression(node) {
	    if (isFunction(node.left) || isFunction(node.right)) {
	      return 2;
	    }
	  },
	  Literal(node) {
	    if (isStringLiteral(node) && node.value === "use strict") {
	      return 2;
	    }
	  },
	  CallExpression(node) {
	    if (isFunction(node.callee) || isHelper(node)) {
	      return 1 | 2;
	    }
	  },
	  OptionalCallExpression(node) {
	    if (isFunction(node.callee)) {
	      return 1 | 2;
	    }
	  },
	  VariableDeclaration(node) {
	    for (let i = 0; i < node.declarations.length; i++) {
	      const declar = node.declarations[i];
	      let enabled = isHelper(declar.id) && !isType(declar.init);
	      if (!enabled && declar.init) {
	        const state = crawl(declar.init);
	        enabled = isHelper(declar.init) && state.hasCall || state.hasFunction;
	      }
	      if (enabled) {
	        return 1 | 2;
	      }
	    }
	  },
	  IfStatement(node) {
	    if (isBlockStatement(node.consequent)) {
	      return 1 | 2;
	    }
	  }
	};
	nodes.ObjectProperty = nodes.ObjectTypeProperty = nodes.ObjectMethod = function (node, parent) {
	  if (parent.properties[0] === node) {
	    return 1;
	  }
	};
	nodes.ObjectTypeCallProperty = function (node, parent) {
	  var _parent$properties;
	  if (parent.callProperties[0] === node && !((_parent$properties = parent.properties) != null && _parent$properties.length)) {
	    return 1;
	  }
	};
	nodes.ObjectTypeIndexer = function (node, parent) {
	  var _parent$properties2, _parent$callPropertie;
	  if (parent.indexers[0] === node && !((_parent$properties2 = parent.properties) != null && _parent$properties2.length) && !((_parent$callPropertie = parent.callProperties) != null && _parent$callPropertie.length)) {
	    return 1;
	  }
	};
	nodes.ObjectTypeInternalSlot = function (node, parent) {
	  var _parent$properties3, _parent$callPropertie2, _parent$indexers;
	  if (parent.internalSlots[0] === node && !((_parent$properties3 = parent.properties) != null && _parent$properties3.length) && !((_parent$callPropertie2 = parent.callProperties) != null && _parent$callPropertie2.length) && !((_parent$indexers = parent.indexers) != null && _parent$indexers.length)) {
	    return 1;
	  }
	};
	[["Function", true], ["Class", true], ["Loop", true], ["LabeledStatement", true], ["SwitchStatement", true], ["TryStatement", true]].forEach(function ([type, amounts]) {
	  [type].concat(FLIPPED_ALIAS_KEYS[type] || []).forEach(function (type) {
	    const ret = amounts ? 1 | 2 : 0;
	    nodes[type] = () => ret;
	  });
	});

	
	return whitespace;
}

var parentheses = {};

var hasRequiredParentheses;

function requireParentheses () {
	if (hasRequiredParentheses) return parentheses;
	hasRequiredParentheses = 1;

	Object.defineProperty(parentheses, "__esModule", {
	  value: true
	});
	parentheses.ArrowFunctionExpression = ArrowFunctionExpression;
	parentheses.AssignmentExpression = AssignmentExpression;
	parentheses.Binary = Binary;
	parentheses.BinaryExpression = BinaryExpression;
	parentheses.ClassExpression = ClassExpression;
	parentheses.ConditionalExpression = ConditionalExpression;
	parentheses.DoExpression = DoExpression;
	parentheses.FunctionExpression = FunctionExpression;
	parentheses.FunctionTypeAnnotation = FunctionTypeAnnotation;
	parentheses.Identifier = Identifier;
	parentheses.LogicalExpression = LogicalExpression;
	parentheses.NullableTypeAnnotation = NullableTypeAnnotation;
	parentheses.ObjectExpression = ObjectExpression;
	parentheses.OptionalIndexedAccessType = OptionalIndexedAccessType;
	parentheses.OptionalCallExpression = parentheses.OptionalMemberExpression = OptionalMemberExpression;
	parentheses.SequenceExpression = SequenceExpression;
	parentheses.TSTypeAssertion = parentheses.TSSatisfiesExpression = parentheses.TSAsExpression = TSAsExpression;
	parentheses.TSInferType = TSInferType;
	parentheses.TSInstantiationExpression = TSInstantiationExpression;
	parentheses.TSIntersectionType = parentheses.TSUnionType = TSUnionType;
	parentheses.UnaryLike = UnaryLike;
	parentheses.IntersectionTypeAnnotation = parentheses.UnionTypeAnnotation = UnionTypeAnnotation;
	parentheses.UpdateExpression = UpdateExpression;
	parentheses.AwaitExpression = parentheses.YieldExpression = YieldExpression;
	var _t = requireLib$h();
	const {
	  isArrayTypeAnnotation,
	  isArrowFunctionExpression,
	  isBinaryExpression,
	  isCallExpression,
	  isExportDeclaration,
	  isForOfStatement,
	  isIndexedAccessType,
	  isMemberExpression,
	  isObjectPattern,
	  isOptionalMemberExpression,
	  isYieldExpression
	} = _t;
	const PRECEDENCE = new Map([["||", 0], ["??", 0], ["|>", 0], ["&&", 1], ["|", 2], ["^", 3], ["&", 4], ["==", 5], ["===", 5], ["!=", 5], ["!==", 5], ["<", 6], [">", 6], ["<=", 6], [">=", 6], ["in", 6], ["instanceof", 6], [">>", 7], ["<<", 7], [">>>", 7], ["+", 8], ["-", 8], ["*", 9], ["/", 9], ["%", 9], ["**", 10]]);
	function isTSTypeExpression(nodeType) {
	  return nodeType === "TSAsExpression" || nodeType === "TSSatisfiesExpression" || nodeType === "TSTypeAssertion";
	}
	const isClassExtendsClause = (node, parent) => {
	  const parentType = parent.type;
	  return (parentType === "ClassDeclaration" || parentType === "ClassExpression") && parent.superClass === node;
	};
	const hasPostfixPart = (node, parent) => {
	  const parentType = parent.type;
	  return (parentType === "MemberExpression" || parentType === "OptionalMemberExpression") && parent.object === node || (parentType === "CallExpression" || parentType === "OptionalCallExpression" || parentType === "NewExpression") && parent.callee === node || parentType === "TaggedTemplateExpression" && parent.tag === node || parentType === "TSNonNullExpression";
	};
	function NullableTypeAnnotation(node, parent) {
	  return isArrayTypeAnnotation(parent);
	}
	function FunctionTypeAnnotation(node, parent, printStack) {
	  if (printStack.length < 3) return;
	  const parentType = parent.type;
	  return parentType === "UnionTypeAnnotation" || parentType === "IntersectionTypeAnnotation" || parentType === "ArrayTypeAnnotation" || parentType === "TypeAnnotation" && isArrowFunctionExpression(printStack[printStack.length - 3]);
	}
	function UpdateExpression(node, parent) {
	  return hasPostfixPart(node, parent) || isClassExtendsClause(node, parent);
	}
	function ObjectExpression(node, parent, printStack) {
	  return isFirstInContext(printStack, 1 | 2);
	}
	function DoExpression(node, parent, printStack) {
	  return !node.async && isFirstInContext(printStack, 1);
	}
	function Binary(node, parent) {
	  const parentType = parent.type;
	  if (node.operator === "**" && parentType === "BinaryExpression" && parent.operator === "**") {
	    return parent.left === node;
	  }
	  if (isClassExtendsClause(node, parent)) {
	    return true;
	  }
	  if (hasPostfixPart(node, parent) || parentType === "UnaryExpression" || parentType === "SpreadElement" || parentType === "AwaitExpression") {
	    return true;
	  }
	  if (parentType === "BinaryExpression" || parentType === "LogicalExpression") {
	    const parentPos = PRECEDENCE.get(parent.operator);
	    const nodePos = PRECEDENCE.get(node.operator);
	    if (parentPos === nodePos && parent.right === node && parentType !== "LogicalExpression" || parentPos > nodePos) {
	      return true;
	    }
	  }
	  return undefined;
	}
	function UnionTypeAnnotation(node, parent) {
	  const parentType = parent.type;
	  return parentType === "ArrayTypeAnnotation" || parentType === "NullableTypeAnnotation" || parentType === "IntersectionTypeAnnotation" || parentType === "UnionTypeAnnotation";
	}
	function OptionalIndexedAccessType(node, parent) {
	  return isIndexedAccessType(parent) && parent.objectType === node;
	}
	function TSAsExpression() {
	  return true;
	}
	function TSUnionType(node, parent) {
	  const parentType = parent.type;
	  return parentType === "TSArrayType" || parentType === "TSOptionalType" || parentType === "TSIntersectionType" || parentType === "TSUnionType" || parentType === "TSRestType";
	}
	function TSInferType(node, parent) {
	  const parentType = parent.type;
	  return parentType === "TSArrayType" || parentType === "TSOptionalType";
	}
	function TSInstantiationExpression(node, parent) {
	  const parentType = parent.type;
	  return (parentType === "CallExpression" || parentType === "OptionalCallExpression" || parentType === "NewExpression" || parentType === "TSInstantiationExpression") && !!parent.typeParameters;
	}
	function BinaryExpression(node, parent) {
	  if (node.operator === "in") {
	    const parentType = parent.type;
	    return parentType === "VariableDeclarator" || parentType === "ForStatement" || parentType === "ForInStatement" || parentType === "ForOfStatement";
	  }
	  return false;
	}
	function SequenceExpression(node, parent) {
	  const parentType = parent.type;
	  if (parentType === "ForStatement" || parentType === "ThrowStatement" || parentType === "ReturnStatement" || parentType === "IfStatement" && parent.test === node || parentType === "WhileStatement" && parent.test === node || parentType === "ForInStatement" && parent.right === node || parentType === "SwitchStatement" && parent.discriminant === node || parentType === "ExpressionStatement" && parent.expression === node) {
	    return false;
	  }
	  return true;
	}
	function YieldExpression(node, parent) {
	  const parentType = parent.type;
	  return parentType === "BinaryExpression" || parentType === "LogicalExpression" || parentType === "UnaryExpression" || parentType === "SpreadElement" || hasPostfixPart(node, parent) || parentType === "AwaitExpression" && isYieldExpression(node) || parentType === "ConditionalExpression" && node === parent.test || isClassExtendsClause(node, parent);
	}
	function ClassExpression(node, parent, printStack) {
	  return isFirstInContext(printStack, 1 | 4);
	}
	function UnaryLike(node, parent) {
	  return hasPostfixPart(node, parent) || isBinaryExpression(parent) && parent.operator === "**" && parent.left === node || isClassExtendsClause(node, parent);
	}
	function FunctionExpression(node, parent, printStack) {
	  return isFirstInContext(printStack, 1 | 4);
	}
	function ArrowFunctionExpression(node, parent) {
	  return isExportDeclaration(parent) || ConditionalExpression(node, parent);
	}
	function ConditionalExpression(node, parent) {
	  const parentType = parent.type;
	  if (parentType === "UnaryExpression" || parentType === "SpreadElement" || parentType === "BinaryExpression" || parentType === "LogicalExpression" || parentType === "ConditionalExpression" && parent.test === node || parentType === "AwaitExpression" || isTSTypeExpression(parentType)) {
	    return true;
	  }
	  return UnaryLike(node, parent);
	}
	function OptionalMemberExpression(node, parent) {
	  return isCallExpression(parent) && parent.callee === node || isMemberExpression(parent) && parent.object === node;
	}
	function AssignmentExpression(node, parent) {
	  if (isObjectPattern(node.left)) {
	    return true;
	  } else {
	    return ConditionalExpression(node, parent);
	  }
	}
	function LogicalExpression(node, parent) {
	  const parentType = parent.type;
	  if (isTSTypeExpression(parentType)) return true;
	  if (parentType !== "LogicalExpression") return false;
	  switch (node.operator) {
	    case "||":
	      return parent.operator === "??" || parent.operator === "&&";
	    case "&&":
	      return parent.operator === "??";
	    case "??":
	      return parent.operator !== "??";
	  }
	}
	function Identifier(node, parent, printStack) {
	  var _node$extra;
	  const parentType = parent.type;
	  if ((_node$extra = node.extra) != null && _node$extra.parenthesized && parentType === "AssignmentExpression" && parent.left === node) {
	    const rightType = parent.right.type;
	    if ((rightType === "FunctionExpression" || rightType === "ClassExpression") && parent.right.id == null) {
	      return true;
	    }
	  }
	  if (node.name === "let") {
	    const isFollowedByBracket = isMemberExpression(parent, {
	      object: node,
	      computed: true
	    }) || isOptionalMemberExpression(parent, {
	      object: node,
	      computed: true,
	      optional: false
	    });
	    return isFirstInContext(printStack, isFollowedByBracket ? 1 | 8 | 16 | 32 : 32);
	  }
	  return node.name === "async" && isForOfStatement(parent) && node === parent.left;
	}
	function isFirstInContext(printStack, checkParam) {
	  const expressionStatement = checkParam & 1;
	  const arrowBody = checkParam & 2;
	  const exportDefault = checkParam & 4;
	  const forHead = checkParam & 8;
	  const forInHead = checkParam & 16;
	  const forOfHead = checkParam & 32;
	  let i = printStack.length - 1;
	  if (i <= 0) return;
	  let node = printStack[i];
	  i--;
	  let parent = printStack[i];
	  while (i >= 0) {
	    const parentType = parent.type;
	    if (expressionStatement && parentType === "ExpressionStatement" && parent.expression === node || exportDefault && parentType === "ExportDefaultDeclaration" && node === parent.declaration || arrowBody && parentType === "ArrowFunctionExpression" && parent.body === node || forHead && parentType === "ForStatement" && parent.init === node || forInHead && parentType === "ForInStatement" && parent.left === node || forOfHead && parentType === "ForOfStatement" && parent.left === node) {
	      return true;
	    }
	    if (i > 0 && (hasPostfixPart(node, parent) && parentType !== "NewExpression" || parentType === "SequenceExpression" && parent.expressions[0] === node || parentType === "UpdateExpression" && !parent.prefix || parentType === "ConditionalExpression" && parent.test === node || (parentType === "BinaryExpression" || parentType === "LogicalExpression") && parent.left === node || parentType === "AssignmentExpression" && parent.left === node)) {
	      node = parent;
	      i--;
	      parent = printStack[i];
	    } else {
	      return false;
	    }
	  }
	  return false;
	}

	
	return parentheses;
}

var hasRequiredNode$1;

function requireNode$1 () {
	if (hasRequiredNode$1) return node$1;
	hasRequiredNode$1 = 1;

	Object.defineProperty(node$1, "__esModule", {
	  value: true
	});
	node$1.needsParens = needsParens;
	node$1.needsWhitespace = needsWhitespace;
	node$1.needsWhitespaceAfter = needsWhitespaceAfter;
	node$1.needsWhitespaceBefore = needsWhitespaceBefore;
	var whitespace = requireWhitespace();
	var parens = requireParentheses();
	var _t = requireLib$h();
	const {
	  FLIPPED_ALIAS_KEYS,
	  isCallExpression,
	  isExpressionStatement,
	  isMemberExpression,
	  isNewExpression
	} = _t;
	function expandAliases(obj) {
	  const map = new Map();
	  function add(type, func) {
	    const fn = map.get(type);
	    map.set(type, fn ? function (node, parent, stack) {
	      var _fn;
	      return (_fn = fn(node, parent, stack)) != null ? _fn : func(node, parent, stack);
	    } : func);
	  }
	  for (const type of Object.keys(obj)) {
	    const aliases = FLIPPED_ALIAS_KEYS[type];
	    if (aliases) {
	      for (const alias of aliases) {
	        add(alias, obj[type]);
	      }
	    } else {
	      add(type, obj[type]);
	    }
	  }
	  return map;
	}
	const expandedParens = expandAliases(parens);
	const expandedWhitespaceNodes = expandAliases(whitespace.nodes);
	function isOrHasCallExpression(node) {
	  if (isCallExpression(node)) {
	    return true;
	  }
	  return isMemberExpression(node) && isOrHasCallExpression(node.object);
	}
	function needsWhitespace(node, parent, type) {
	  var _expandedWhitespaceNo;
	  if (!node) return false;
	  if (isExpressionStatement(node)) {
	    node = node.expression;
	  }
	  const flag = (_expandedWhitespaceNo = expandedWhitespaceNodes.get(node.type)) == null ? void 0 : _expandedWhitespaceNo(node, parent);
	  if (typeof flag === "number") {
	    return (flag & type) !== 0;
	  }
	  return false;
	}
	function needsWhitespaceBefore(node, parent) {
	  return needsWhitespace(node, parent, 1);
	}
	function needsWhitespaceAfter(node, parent) {
	  return needsWhitespace(node, parent, 2);
	}
	function needsParens(node, parent, printStack) {
	  var _expandedParens$get;
	  if (!parent) return false;
	  if (isNewExpression(parent) && parent.callee === node) {
	    if (isOrHasCallExpression(node)) return true;
	  }
	  return (_expandedParens$get = expandedParens.get(node.type)) == null ? void 0 : _expandedParens$get(node, parent, printStack);
	}

	
	return node$1;
}

var generators = {};

var templateLiterals = {};

var hasRequiredTemplateLiterals;

function requireTemplateLiterals () {
	if (hasRequiredTemplateLiterals) return templateLiterals;
	hasRequiredTemplateLiterals = 1;

	Object.defineProperty(templateLiterals, "__esModule", {
	  value: true
	});
	templateLiterals.TaggedTemplateExpression = TaggedTemplateExpression;
	templateLiterals.TemplateElement = TemplateElement;
	templateLiterals.TemplateLiteral = TemplateLiteral;
	function TaggedTemplateExpression(node) {
	  this.print(node.tag, node);
	  this.print(node.typeParameters, node);
	  this.print(node.quasi, node);
	}
	function TemplateElement(node, parent) {
	  const isFirst = parent.quasis[0] === node;
	  const isLast = parent.quasis[parent.quasis.length - 1] === node;
	  const value = (isFirst ? "`" : "}") + node.value.raw + (isLast ? "`" : "${");
	  this.token(value, true);
	}
	function TemplateLiteral(node) {
	  const quasis = node.quasis;
	  for (let i = 0; i < quasis.length; i++) {
	    this.print(quasis[i], node);
	    if (i + 1 < quasis.length) {
	      this.print(node.expressions[i], node);
	    }
	  }
	}

	
	return templateLiterals;
}

var expressions = {};

var hasRequiredExpressions;

function requireExpressions () {
	if (hasRequiredExpressions) return expressions;
	hasRequiredExpressions = 1;

	Object.defineProperty(expressions, "__esModule", {
	  value: true
	});
	expressions.LogicalExpression = expressions.BinaryExpression = expressions.AssignmentExpression = AssignmentExpression;
	expressions.AssignmentPattern = AssignmentPattern;
	expressions.AwaitExpression = AwaitExpression;
	expressions.BindExpression = BindExpression;
	expressions.CallExpression = CallExpression;
	expressions.ConditionalExpression = ConditionalExpression;
	expressions.Decorator = Decorator;
	expressions.DoExpression = DoExpression;
	expressions.EmptyStatement = EmptyStatement;
	expressions.ExpressionStatement = ExpressionStatement;
	expressions.Import = Import;
	expressions.MemberExpression = MemberExpression;
	expressions.MetaProperty = MetaProperty;
	expressions.ModuleExpression = ModuleExpression;
	expressions.NewExpression = NewExpression;
	expressions.OptionalCallExpression = OptionalCallExpression;
	expressions.OptionalMemberExpression = OptionalMemberExpression;
	expressions.ParenthesizedExpression = ParenthesizedExpression;
	expressions.PrivateName = PrivateName;
	expressions.SequenceExpression = SequenceExpression;
	expressions.Super = Super;
	expressions.ThisExpression = ThisExpression;
	expressions.UnaryExpression = UnaryExpression;
	expressions.UpdateExpression = UpdateExpression;
	expressions.V8IntrinsicIdentifier = V8IntrinsicIdentifier;
	expressions.YieldExpression = YieldExpression;
	expressions._shouldPrintDecoratorsBeforeExport = _shouldPrintDecoratorsBeforeExport;
	var _t = requireLib$h();
	var n = requireNode$1();
	const {
	  isCallExpression,
	  isLiteral,
	  isMemberExpression,
	  isNewExpression
	} = _t;
	function UnaryExpression(node) {
	  const {
	    operator
	  } = node;
	  if (operator === "void" || operator === "delete" || operator === "typeof" || operator === "throw") {
	    this.word(operator);
	    this.space();
	  } else {
	    this.token(operator);
	  }
	  this.print(node.argument, node);
	}
	function DoExpression(node) {
	  if (node.async) {
	    this.word("async", true);
	    this.space();
	  }
	  this.word("do");
	  this.space();
	  this.print(node.body, node);
	}
	function ParenthesizedExpression(node) {
	  this.tokenChar(40);
	  this.print(node.expression, node);
	  this.rightParens(node);
	}
	function UpdateExpression(node) {
	  if (node.prefix) {
	    this.token(node.operator);
	    this.print(node.argument, node);
	  } else {
	    this.printTerminatorless(node.argument, node, true);
	    this.token(node.operator);
	  }
	}
	function ConditionalExpression(node) {
	  this.print(node.test, node);
	  this.space();
	  this.tokenChar(63);
	  this.space();
	  this.print(node.consequent, node);
	  this.space();
	  this.tokenChar(58);
	  this.space();
	  this.print(node.alternate, node);
	}
	function NewExpression(node, parent) {
	  this.word("new");
	  this.space();
	  this.print(node.callee, node);
	  if (this.format.minified && node.arguments.length === 0 && !node.optional && !isCallExpression(parent, {
	    callee: node
	  }) && !isMemberExpression(parent) && !isNewExpression(parent)) {
	    return;
	  }
	  this.print(node.typeArguments, node);
	  this.print(node.typeParameters, node);
	  if (node.optional) {
	    this.token("?.");
	  }
	  this.tokenChar(40);
	  this.printList(node.arguments, node);
	  this.rightParens(node);
	}
	function SequenceExpression(node) {
	  this.printList(node.expressions, node);
	}
	function ThisExpression() {
	  this.word("this");
	}
	function Super() {
	  this.word("super");
	}
	function isDecoratorMemberExpression(node) {
	  switch (node.type) {
	    case "Identifier":
	      return true;
	    case "MemberExpression":
	      return !node.computed && node.property.type === "Identifier" && isDecoratorMemberExpression(node.object);
	    default:
	      return false;
	  }
	}
	function shouldParenthesizeDecoratorExpression(node) {
	  if (node.type === "ParenthesizedExpression") {
	    return false;
	  }
	  return !isDecoratorMemberExpression(node.type === "CallExpression" ? node.callee : node);
	}
	function _shouldPrintDecoratorsBeforeExport(node) {
	  if (typeof this.format.decoratorsBeforeExport === "boolean") {
	    return this.format.decoratorsBeforeExport;
	  }
	  return typeof node.start === "number" && node.start === node.declaration.start;
	}
	function Decorator(node) {
	  this.tokenChar(64);
	  const {
	    expression
	  } = node;
	  if (shouldParenthesizeDecoratorExpression(expression)) {
	    this.tokenChar(40);
	    this.print(expression, node);
	    this.tokenChar(41);
	  } else {
	    this.print(expression, node);
	  }
	  this.newline();
	}
	function OptionalMemberExpression(node) {
	  let {
	    computed
	  } = node;
	  const {
	    optional,
	    property
	  } = node;
	  this.print(node.object, node);
	  if (!computed && isMemberExpression(property)) {
	    throw new TypeError("Got a MemberExpression for MemberExpression property");
	  }
	  if (isLiteral(property) && typeof property.value === "number") {
	    computed = true;
	  }
	  if (optional) {
	    this.token("?.");
	  }
	  if (computed) {
	    this.tokenChar(91);
	    this.print(property, node);
	    this.tokenChar(93);
	  } else {
	    if (!optional) {
	      this.tokenChar(46);
	    }
	    this.print(property, node);
	  }
	}
	function OptionalCallExpression(node) {
	  this.print(node.callee, node);
	  this.print(node.typeParameters, node);
	  if (node.optional) {
	    this.token("?.");
	  }
	  this.print(node.typeArguments, node);
	  this.tokenChar(40);
	  this.printList(node.arguments, node);
	  this.rightParens(node);
	}
	function CallExpression(node) {
	  this.print(node.callee, node);
	  this.print(node.typeArguments, node);
	  this.print(node.typeParameters, node);
	  this.tokenChar(40);
	  this.printList(node.arguments, node);
	  this.rightParens(node);
	}
	function Import() {
	  this.word("import");
	}
	function AwaitExpression(node) {
	  this.word("await");
	  if (node.argument) {
	    this.space();
	    this.printTerminatorless(node.argument, node, false);
	  }
	}
	function YieldExpression(node) {
	  this.word("yield", true);
	  if (node.delegate) {
	    this.tokenChar(42);
	    if (node.argument) {
	      this.space();
	      this.print(node.argument, node);
	    }
	  } else {
	    if (node.argument) {
	      this.space();
	      this.printTerminatorless(node.argument, node, false);
	    }
	  }
	}
	function EmptyStatement() {
	  this.semicolon(true);
	}
	function ExpressionStatement(node) {
	  this.print(node.expression, node);
	  this.semicolon();
	}
	function AssignmentPattern(node) {
	  this.print(node.left, node);
	  if (node.left.optional) this.tokenChar(63);
	  this.print(node.left.typeAnnotation, node);
	  this.space();
	  this.tokenChar(61);
	  this.space();
	  this.print(node.right, node);
	}
	function AssignmentExpression(node, parent) {
	  const parens = this.inForStatementInitCounter && node.operator === "in" && !n.needsParens(node, parent);
	  if (parens) {
	    this.tokenChar(40);
	  }
	  this.print(node.left, node);
	  this.space();
	  if (node.operator === "in" || node.operator === "instanceof") {
	    this.word(node.operator);
	  } else {
	    this.token(node.operator);
	  }
	  this.space();
	  this.print(node.right, node);
	  if (parens) {
	    this.tokenChar(41);
	  }
	}
	function BindExpression(node) {
	  this.print(node.object, node);
	  this.token("::");
	  this.print(node.callee, node);
	}
	function MemberExpression(node) {
	  this.print(node.object, node);
	  if (!node.computed && isMemberExpression(node.property)) {
	    throw new TypeError("Got a MemberExpression for MemberExpression property");
	  }
	  let computed = node.computed;
	  if (isLiteral(node.property) && typeof node.property.value === "number") {
	    computed = true;
	  }
	  if (computed) {
	    this.tokenChar(91);
	    this.print(node.property, node);
	    this.tokenChar(93);
	  } else {
	    this.tokenChar(46);
	    this.print(node.property, node);
	  }
	}
	function MetaProperty(node) {
	  this.print(node.meta, node);
	  this.tokenChar(46);
	  this.print(node.property, node);
	}
	function PrivateName(node) {
	  this.tokenChar(35);
	  this.print(node.id, node);
	}
	function V8IntrinsicIdentifier(node) {
	  this.tokenChar(37);
	  this.word(node.name);
	}
	function ModuleExpression(node) {
	  this.word("module", true);
	  this.space();
	  this.tokenChar(123);
	  this.indent();
	  const {
	    body
	  } = node;
	  if (body.body.length || body.directives.length) {
	    this.newline();
	  }
	  this.print(body, node);
	  this.dedent();
	  this.rightBrace(node);
	}

	
	return expressions;
}

var statements = {};

var hasRequiredStatements;

function requireStatements () {
	if (hasRequiredStatements) return statements;
	hasRequiredStatements = 1;

	Object.defineProperty(statements, "__esModule", {
	  value: true
	});
	statements.BreakStatement = BreakStatement;
	statements.CatchClause = CatchClause;
	statements.ContinueStatement = ContinueStatement;
	statements.DebuggerStatement = DebuggerStatement;
	statements.DoWhileStatement = DoWhileStatement;
	statements.ForOfStatement = statements.ForInStatement = void 0;
	statements.ForStatement = ForStatement;
	statements.IfStatement = IfStatement;
	statements.LabeledStatement = LabeledStatement;
	statements.ReturnStatement = ReturnStatement;
	statements.SwitchCase = SwitchCase;
	statements.SwitchStatement = SwitchStatement;
	statements.ThrowStatement = ThrowStatement;
	statements.TryStatement = TryStatement;
	statements.VariableDeclaration = VariableDeclaration;
	statements.VariableDeclarator = VariableDeclarator;
	statements.WhileStatement = WhileStatement;
	statements.WithStatement = WithStatement;
	var _t = requireLib$h();
	const {
	  isFor,
	  isForStatement,
	  isIfStatement,
	  isStatement
	} = _t;
	function WithStatement(node) {
	  this.word("with");
	  this.space();
	  this.tokenChar(40);
	  this.print(node.object, node);
	  this.tokenChar(41);
	  this.printBlock(node);
	}
	function IfStatement(node) {
	  this.word("if");
	  this.space();
	  this.tokenChar(40);
	  this.print(node.test, node);
	  this.tokenChar(41);
	  this.space();
	  const needsBlock = node.alternate && isIfStatement(getLastStatement(node.consequent));
	  if (needsBlock) {
	    this.tokenChar(123);
	    this.newline();
	    this.indent();
	  }
	  this.printAndIndentOnComments(node.consequent, node);
	  if (needsBlock) {
	    this.dedent();
	    this.newline();
	    this.tokenChar(125);
	  }
	  if (node.alternate) {
	    if (this.endsWith(125)) this.space();
	    this.word("else");
	    this.space();
	    this.printAndIndentOnComments(node.alternate, node);
	  }
	}
	function getLastStatement(statement) {
	  const {
	    body
	  } = statement;
	  if (isStatement(body) === false) {
	    return statement;
	  }
	  return getLastStatement(body);
	}
	function ForStatement(node) {
	  this.word("for");
	  this.space();
	  this.tokenChar(40);
	  this.inForStatementInitCounter++;
	  this.print(node.init, node);
	  this.inForStatementInitCounter--;
	  this.tokenChar(59);
	  if (node.test) {
	    this.space();
	    this.print(node.test, node);
	  }
	  this.tokenChar(59);
	  if (node.update) {
	    this.space();
	    this.print(node.update, node);
	  }
	  this.tokenChar(41);
	  this.printBlock(node);
	}
	function WhileStatement(node) {
	  this.word("while");
	  this.space();
	  this.tokenChar(40);
	  this.print(node.test, node);
	  this.tokenChar(41);
	  this.printBlock(node);
	}
	function ForXStatement(node) {
	  this.word("for");
	  this.space();
	  const isForOf = node.type === "ForOfStatement";
	  if (isForOf && node.await) {
	    this.word("await");
	    this.space();
	  }
	  this.noIndentInnerCommentsHere();
	  this.tokenChar(40);
	  this.print(node.left, node);
	  this.space();
	  this.word(isForOf ? "of" : "in");
	  this.space();
	  this.print(node.right, node);
	  this.tokenChar(41);
	  this.printBlock(node);
	}
	statements.ForInStatement = ForXStatement;
	statements.ForOfStatement = ForXStatement;
	function DoWhileStatement(node) {
	  this.word("do");
	  this.space();
	  this.print(node.body, node);
	  this.space();
	  this.word("while");
	  this.space();
	  this.tokenChar(40);
	  this.print(node.test, node);
	  this.tokenChar(41);
	  this.semicolon();
	}
	function printStatementAfterKeyword(printer, node, parent, isLabel) {
	  if (node) {
	    printer.space();
	    printer.printTerminatorless(node, parent, isLabel);
	  }
	  printer.semicolon();
	}
	function BreakStatement(node) {
	  this.word("break");
	  printStatementAfterKeyword(this, node.label, node, true);
	}
	function ContinueStatement(node) {
	  this.word("continue");
	  printStatementAfterKeyword(this, node.label, node, true);
	}
	function ReturnStatement(node) {
	  this.word("return");
	  printStatementAfterKeyword(this, node.argument, node, false);
	}
	function ThrowStatement(node) {
	  this.word("throw");
	  printStatementAfterKeyword(this, node.argument, node, false);
	}
	function LabeledStatement(node) {
	  this.print(node.label, node);
	  this.tokenChar(58);
	  this.space();
	  this.print(node.body, node);
	}
	function TryStatement(node) {
	  this.word("try");
	  this.space();
	  this.print(node.block, node);
	  this.space();
	  if (node.handlers) {
	    this.print(node.handlers[0], node);
	  } else {
	    this.print(node.handler, node);
	  }
	  if (node.finalizer) {
	    this.space();
	    this.word("finally");
	    this.space();
	    this.print(node.finalizer, node);
	  }
	}
	function CatchClause(node) {
	  this.word("catch");
	  this.space();
	  if (node.param) {
	    this.tokenChar(40);
	    this.print(node.param, node);
	    this.print(node.param.typeAnnotation, node);
	    this.tokenChar(41);
	    this.space();
	  }
	  this.print(node.body, node);
	}
	function SwitchStatement(node) {
	  this.word("switch");
	  this.space();
	  this.tokenChar(40);
	  this.print(node.discriminant, node);
	  this.tokenChar(41);
	  this.space();
	  this.tokenChar(123);
	  this.printSequence(node.cases, node, {
	    indent: true,
	    addNewlines(leading, cas) {
	      if (!leading && node.cases[node.cases.length - 1] === cas) return -1;
	    }
	  });
	  this.rightBrace(node);
	}
	function SwitchCase(node) {
	  if (node.test) {
	    this.word("case");
	    this.space();
	    this.print(node.test, node);
	    this.tokenChar(58);
	  } else {
	    this.word("default");
	    this.tokenChar(58);
	  }
	  if (node.consequent.length) {
	    this.newline();
	    this.printSequence(node.consequent, node, {
	      indent: true
	    });
	  }
	}
	function DebuggerStatement() {
	  this.word("debugger");
	  this.semicolon();
	}
	function VariableDeclaration(node, parent) {
	  if (node.declare) {
	    this.word("declare");
	    this.space();
	  }
	  const {
	    kind
	  } = node;
	  this.word(kind, kind === "using" || kind === "await using");
	  this.space();
	  let hasInits = false;
	  if (!isFor(parent)) {
	    for (const declar of node.declarations) {
	      if (declar.init) {
	        hasInits = true;
	      }
	    }
	  }
	  this.printList(node.declarations, node, {
	    separator: hasInits ? function () {
	      this.tokenChar(44);
	      this.newline();
	    } : undefined,
	    indent: node.declarations.length > 1 ? true : false
	  });
	  if (isFor(parent)) {
	    if (isForStatement(parent)) {
	      if (parent.init === node) return;
	    } else {
	      if (parent.left === node) return;
	    }
	  }
	  this.semicolon();
	}
	function VariableDeclarator(node) {
	  this.print(node.id, node);
	  if (node.definite) this.tokenChar(33);
	  this.print(node.id.typeAnnotation, node);
	  if (node.init) {
	    this.space();
	    this.tokenChar(61);
	    this.space();
	    this.print(node.init, node);
	  }
	}

	
	return statements;
}

var classes = {};

var hasRequiredClasses;

function requireClasses () {
	if (hasRequiredClasses) return classes;
	hasRequiredClasses = 1;

	Object.defineProperty(classes, "__esModule", {
	  value: true
	});
	classes.ClassAccessorProperty = ClassAccessorProperty;
	classes.ClassBody = ClassBody;
	classes.ClassExpression = classes.ClassDeclaration = ClassDeclaration;
	classes.ClassMethod = ClassMethod;
	classes.ClassPrivateMethod = ClassPrivateMethod;
	classes.ClassPrivateProperty = ClassPrivateProperty;
	classes.ClassProperty = ClassProperty;
	classes.StaticBlock = StaticBlock;
	classes._classMethodHead = _classMethodHead;
	var _t = requireLib$h();
	const {
	  isExportDefaultDeclaration,
	  isExportNamedDeclaration
	} = _t;
	function ClassDeclaration(node, parent) {
	  const inExport = isExportDefaultDeclaration(parent) || isExportNamedDeclaration(parent);
	  if (!inExport || !this._shouldPrintDecoratorsBeforeExport(parent)) {
	    this.printJoin(node.decorators, node);
	  }
	  if (node.declare) {
	    this.word("declare");
	    this.space();
	  }
	  if (node.abstract) {
	    this.word("abstract");
	    this.space();
	  }
	  this.word("class");
	  if (node.id) {
	    this.space();
	    this.print(node.id, node);
	  }
	  this.print(node.typeParameters, node);
	  if (node.superClass) {
	    this.space();
	    this.word("extends");
	    this.space();
	    this.print(node.superClass, node);
	    this.print(node.superTypeParameters, node);
	  }
	  if (node.implements) {
	    this.space();
	    this.word("implements");
	    this.space();
	    this.printList(node.implements, node);
	  }
	  this.space();
	  this.print(node.body, node);
	}
	function ClassBody(node) {
	  this.tokenChar(123);
	  if (node.body.length === 0) {
	    this.tokenChar(125);
	  } else {
	    this.newline();
	    this.printSequence(node.body, node, {
	      indent: true
	    });
	    if (!this.endsWith(10)) this.newline();
	    this.rightBrace(node);
	  }
	}
	function ClassProperty(node) {
	  var _node$key$loc;
	  this.printJoin(node.decorators, node);
	  const endLine = (_node$key$loc = node.key.loc) == null || (_node$key$loc = _node$key$loc.end) == null ? void 0 : _node$key$loc.line;
	  if (endLine) this.catchUp(endLine);
	  this.tsPrintClassMemberModifiers(node);
	  if (node.computed) {
	    this.tokenChar(91);
	    this.print(node.key, node);
	    this.tokenChar(93);
	  } else {
	    this._variance(node);
	    this.print(node.key, node);
	  }
	  if (node.optional) {
	    this.tokenChar(63);
	  }
	  if (node.definite) {
	    this.tokenChar(33);
	  }
	  this.print(node.typeAnnotation, node);
	  if (node.value) {
	    this.space();
	    this.tokenChar(61);
	    this.space();
	    this.print(node.value, node);
	  }
	  this.semicolon();
	}
	function ClassAccessorProperty(node) {
	  var _node$key$loc2;
	  this.printJoin(node.decorators, node);
	  const endLine = (_node$key$loc2 = node.key.loc) == null || (_node$key$loc2 = _node$key$loc2.end) == null ? void 0 : _node$key$loc2.line;
	  if (endLine) this.catchUp(endLine);
	  this.tsPrintClassMemberModifiers(node);
	  this.word("accessor", true);
	  this.space();
	  if (node.computed) {
	    this.tokenChar(91);
	    this.print(node.key, node);
	    this.tokenChar(93);
	  } else {
	    this._variance(node);
	    this.print(node.key, node);
	  }
	  if (node.optional) {
	    this.tokenChar(63);
	  }
	  if (node.definite) {
	    this.tokenChar(33);
	  }
	  this.print(node.typeAnnotation, node);
	  if (node.value) {
	    this.space();
	    this.tokenChar(61);
	    this.space();
	    this.print(node.value, node);
	  }
	  this.semicolon();
	}
	function ClassPrivateProperty(node) {
	  this.printJoin(node.decorators, node);
	  if (node.static) {
	    this.word("static");
	    this.space();
	  }
	  this.print(node.key, node);
	  this.print(node.typeAnnotation, node);
	  if (node.value) {
	    this.space();
	    this.tokenChar(61);
	    this.space();
	    this.print(node.value, node);
	  }
	  this.semicolon();
	}
	function ClassMethod(node) {
	  this._classMethodHead(node);
	  this.space();
	  this.print(node.body, node);
	}
	function ClassPrivateMethod(node) {
	  this._classMethodHead(node);
	  this.space();
	  this.print(node.body, node);
	}
	function _classMethodHead(node) {
	  var _node$key$loc3;
	  this.printJoin(node.decorators, node);
	  const endLine = (_node$key$loc3 = node.key.loc) == null || (_node$key$loc3 = _node$key$loc3.end) == null ? void 0 : _node$key$loc3.line;
	  if (endLine) this.catchUp(endLine);
	  this.tsPrintClassMemberModifiers(node);
	  this._methodHead(node);
	}
	function StaticBlock(node) {
	  this.word("static");
	  this.space();
	  this.tokenChar(123);
	  if (node.body.length === 0) {
	    this.tokenChar(125);
	  } else {
	    this.newline();
	    this.printSequence(node.body, node, {
	      indent: true
	    });
	    this.rightBrace(node);
	  }
	}

	
	return classes;
}

var methods = {};

var hasRequiredMethods;

function requireMethods () {
	if (hasRequiredMethods) return methods;
	hasRequiredMethods = 1;

	Object.defineProperty(methods, "__esModule", {
	  value: true
	});
	methods.ArrowFunctionExpression = ArrowFunctionExpression;
	methods.FunctionDeclaration = methods.FunctionExpression = FunctionExpression;
	methods._functionHead = _functionHead;
	methods._methodHead = _methodHead;
	methods._param = _param;
	methods._parameters = _parameters;
	methods._params = _params;
	methods._predicate = _predicate;
	var _t = requireLib$h();
	const {
	  isIdentifier
	} = _t;
	function _params(node, idNode, parentNode) {
	  this.print(node.typeParameters, node);
	  const nameInfo = _getFuncIdName.call(this, idNode, parentNode);
	  if (nameInfo) {
	    this.sourceIdentifierName(nameInfo.name, nameInfo.pos);
	  }
	  this.tokenChar(40);
	  this._parameters(node.params, node);
	  this.tokenChar(41);
	  const noLineTerminator = node.type === "ArrowFunctionExpression";
	  this.print(node.returnType, node, noLineTerminator);
	  this._noLineTerminator = noLineTerminator;
	}
	function _parameters(parameters, parent) {
	  const paramLength = parameters.length;
	  for (let i = 0; i < paramLength; i++) {
	    this._param(parameters[i], parent);
	    if (i < parameters.length - 1) {
	      this.tokenChar(44);
	      this.space();
	    }
	  }
	}
	function _param(parameter, parent) {
	  this.printJoin(parameter.decorators, parameter);
	  this.print(parameter, parent);
	  if (parameter.optional) {
	    this.tokenChar(63);
	  }
	  this.print(parameter.typeAnnotation, parameter);
	}
	function _methodHead(node) {
	  const kind = node.kind;
	  const key = node.key;
	  if (kind === "get" || kind === "set") {
	    this.word(kind);
	    this.space();
	  }
	  if (node.async) {
	    this.word("async", true);
	    this.space();
	  }
	  if (kind === "method" || kind === "init") {
	    if (node.generator) {
	      this.tokenChar(42);
	    }
	  }
	  if (node.computed) {
	    this.tokenChar(91);
	    this.print(key, node);
	    this.tokenChar(93);
	  } else {
	    this.print(key, node);
	  }
	  if (node.optional) {
	    this.tokenChar(63);
	  }
	  this._params(node, node.computed && node.key.type !== "StringLiteral" ? undefined : node.key, undefined);
	}
	function _predicate(node, noLineTerminatorAfter) {
	  if (node.predicate) {
	    if (!node.returnType) {
	      this.tokenChar(58);
	    }
	    this.space();
	    this.print(node.predicate, node, noLineTerminatorAfter);
	  }
	}
	function _functionHead(node, parent) {
	  if (node.async) {
	    this.word("async");
	    this._endsWithInnerRaw = false;
	    this.space();
	  }
	  this.word("function");
	  if (node.generator) {
	    this._endsWithInnerRaw = false;
	    this.tokenChar(42);
	  }
	  this.space();
	  if (node.id) {
	    this.print(node.id, node);
	  }
	  this._params(node, node.id, parent);
	  if (node.type !== "TSDeclareFunction") {
	    this._predicate(node);
	  }
	}
	function FunctionExpression(node, parent) {
	  this._functionHead(node, parent);
	  this.space();
	  this.print(node.body, node);
	}
	function ArrowFunctionExpression(node, parent) {
	  if (node.async) {
	    this.word("async", true);
	    this.space();
	  }
	  let firstParam;
	  if (!this.format.retainLines && node.params.length === 1 && isIdentifier(firstParam = node.params[0]) && !hasTypesOrComments(node, firstParam)) {
	    this.print(firstParam, node, true);
	  } else {
	    this._params(node, undefined, parent);
	  }
	  this._predicate(node, true);
	  this.space();
	  this.printInnerComments();
	  this.token("=>");
	  this.space();
	  this.print(node.body, node);
	}
	function hasTypesOrComments(node, param) {
	  var _param$leadingComment, _param$trailingCommen;
	  return !!(node.typeParameters || node.returnType || node.predicate || param.typeAnnotation || param.optional || (_param$leadingComment = param.leadingComments) != null && _param$leadingComment.length || (_param$trailingCommen = param.trailingComments) != null && _param$trailingCommen.length);
	}
	function _getFuncIdName(idNode, parent) {
	  let id = idNode;
	  if (!id && parent) {
	    const parentType = parent.type;
	    if (parentType === "VariableDeclarator") {
	      id = parent.id;
	    } else if (parentType === "AssignmentExpression" || parentType === "AssignmentPattern") {
	      id = parent.left;
	    } else if (parentType === "ObjectProperty" || parentType === "ClassProperty") {
	      if (!parent.computed || parent.key.type === "StringLiteral") {
	        id = parent.key;
	      }
	    } else if (parentType === "ClassPrivateProperty" || parentType === "ClassAccessorProperty") {
	      id = parent.key;
	    }
	  }
	  if (!id) return;
	  let nameInfo;
	  if (id.type === "Identifier") {
	    var _id$loc, _id$loc2;
	    nameInfo = {
	      pos: (_id$loc = id.loc) == null ? void 0 : _id$loc.start,
	      name: ((_id$loc2 = id.loc) == null ? void 0 : _id$loc2.identifierName) || id.name
	    };
	  } else if (id.type === "PrivateName") {
	    var _id$loc3;
	    nameInfo = {
	      pos: (_id$loc3 = id.loc) == null ? void 0 : _id$loc3.start,
	      name: "#" + id.id.name
	    };
	  } else if (id.type === "StringLiteral") {
	    var _id$loc4;
	    nameInfo = {
	      pos: (_id$loc4 = id.loc) == null ? void 0 : _id$loc4.start,
	      name: id.value
	    };
	  }
	  return nameInfo;
	}

	
	return methods;
}

var modules = {};

var hasRequiredModules;

function requireModules () {
	if (hasRequiredModules) return modules;
	hasRequiredModules = 1;

	Object.defineProperty(modules, "__esModule", {
	  value: true
	});
	modules.ExportAllDeclaration = ExportAllDeclaration;
	modules.ExportDefaultDeclaration = ExportDefaultDeclaration;
	modules.ExportDefaultSpecifier = ExportDefaultSpecifier;
	modules.ExportNamedDeclaration = ExportNamedDeclaration;
	modules.ExportNamespaceSpecifier = ExportNamespaceSpecifier;
	modules.ExportSpecifier = ExportSpecifier;
	modules.ImportAttribute = ImportAttribute;
	modules.ImportDeclaration = ImportDeclaration;
	modules.ImportDefaultSpecifier = ImportDefaultSpecifier;
	modules.ImportExpression = ImportExpression;
	modules.ImportNamespaceSpecifier = ImportNamespaceSpecifier;
	modules.ImportSpecifier = ImportSpecifier;
	modules._printAttributes = _printAttributes;
	var _t = requireLib$h();
	const {
	  isClassDeclaration,
	  isExportDefaultSpecifier,
	  isExportNamespaceSpecifier,
	  isImportDefaultSpecifier,
	  isImportNamespaceSpecifier,
	  isStatement
	} = _t;
	function ImportSpecifier(node) {
	  if (node.importKind === "type" || node.importKind === "typeof") {
	    this.word(node.importKind);
	    this.space();
	  }
	  this.print(node.imported, node);
	  if (node.local && node.local.name !== node.imported.name) {
	    this.space();
	    this.word("as");
	    this.space();
	    this.print(node.local, node);
	  }
	}
	function ImportDefaultSpecifier(node) {
	  this.print(node.local, node);
	}
	function ExportDefaultSpecifier(node) {
	  this.print(node.exported, node);
	}
	function ExportSpecifier(node) {
	  if (node.exportKind === "type") {
	    this.word("type");
	    this.space();
	  }
	  this.print(node.local, node);
	  if (node.exported && node.local.name !== node.exported.name) {
	    this.space();
	    this.word("as");
	    this.space();
	    this.print(node.exported, node);
	  }
	}
	function ExportNamespaceSpecifier(node) {
	  this.tokenChar(42);
	  this.space();
	  this.word("as");
	  this.space();
	  this.print(node.exported, node);
	}
	let warningShown = false;
	function _printAttributes(node) {
	  const {
	    importAttributesKeyword
	  } = this.format;
	  const {
	    attributes,
	    assertions
	  } = node;
	  if (attributes && !importAttributesKeyword && !warningShown) {
	    warningShown = true;
	    console.warn(`\
You are using import attributes, without specifying the desired output syntax.
Please specify the "importAttributesKeyword" generator option, whose value can be one of:
 - "with"        : \`import { a } from "b" with { type: "json" };\`
 - "assert"      : \`import { a } from "b" assert { type: "json" };\`
 - "with-legacy" : \`import { a } from "b" with type: "json";\`
`);
	  }
	  const useAssertKeyword = importAttributesKeyword === "assert" || !importAttributesKeyword && assertions;
	  this.word(useAssertKeyword ? "assert" : "with");
	  this.space();
	  if (!useAssertKeyword && importAttributesKeyword !== "with") {
	    this.printList(attributes || assertions, node);
	    return;
	  }
	  this.tokenChar(123);
	  this.space();
	  this.printList(attributes || assertions, node);
	  this.space();
	  this.tokenChar(125);
	}
	function ExportAllDeclaration(node) {
	  var _node$attributes, _node$assertions;
	  this.word("export");
	  this.space();
	  if (node.exportKind === "type") {
	    this.word("type");
	    this.space();
	  }
	  this.tokenChar(42);
	  this.space();
	  this.word("from");
	  this.space();
	  if ((_node$attributes = node.attributes) != null && _node$attributes.length || (_node$assertions = node.assertions) != null && _node$assertions.length) {
	    this.print(node.source, node, true);
	    this.space();
	    this._printAttributes(node);
	  } else {
	    this.print(node.source, node);
	  }
	  this.semicolon();
	}
	function maybePrintDecoratorsBeforeExport(printer, node) {
	  if (isClassDeclaration(node.declaration) && printer._shouldPrintDecoratorsBeforeExport(node)) {
	    printer.printJoin(node.declaration.decorators, node);
	  }
	}
	function ExportNamedDeclaration(node) {
	  maybePrintDecoratorsBeforeExport(this, node);
	  this.word("export");
	  this.space();
	  if (node.declaration) {
	    const declar = node.declaration;
	    this.print(declar, node);
	    if (!isStatement(declar)) this.semicolon();
	  } else {
	    if (node.exportKind === "type") {
	      this.word("type");
	      this.space();
	    }
	    const specifiers = node.specifiers.slice(0);
	    let hasSpecial = false;
	    for (;;) {
	      const first = specifiers[0];
	      if (isExportDefaultSpecifier(first) || isExportNamespaceSpecifier(first)) {
	        hasSpecial = true;
	        this.print(specifiers.shift(), node);
	        if (specifiers.length) {
	          this.tokenChar(44);
	          this.space();
	        }
	      } else {
	        break;
	      }
	    }
	    if (specifiers.length || !specifiers.length && !hasSpecial) {
	      this.tokenChar(123);
	      if (specifiers.length) {
	        this.space();
	        this.printList(specifiers, node);
	        this.space();
	      }
	      this.tokenChar(125);
	    }
	    if (node.source) {
	      var _node$attributes2, _node$assertions2;
	      this.space();
	      this.word("from");
	      this.space();
	      if ((_node$attributes2 = node.attributes) != null && _node$attributes2.length || (_node$assertions2 = node.assertions) != null && _node$assertions2.length) {
	        this.print(node.source, node, true);
	        this.space();
	        this._printAttributes(node);
	      } else {
	        this.print(node.source, node);
	      }
	    }
	    this.semicolon();
	  }
	}
	function ExportDefaultDeclaration(node) {
	  maybePrintDecoratorsBeforeExport(this, node);
	  this.word("export");
	  this.noIndentInnerCommentsHere();
	  this.space();
	  this.word("default");
	  this.space();
	  const declar = node.declaration;
	  this.print(declar, node);
	  if (!isStatement(declar)) this.semicolon();
	}
	function ImportDeclaration(node) {
	  var _node$attributes3, _node$assertions3;
	  this.word("import");
	  this.space();
	  const isTypeKind = node.importKind === "type" || node.importKind === "typeof";
	  if (isTypeKind) {
	    this.noIndentInnerCommentsHere();
	    this.word(node.importKind);
	    this.space();
	  } else if (node.module) {
	    this.noIndentInnerCommentsHere();
	    this.word("module");
	    this.space();
	  } else if (node.phase) {
	    this.noIndentInnerCommentsHere();
	    this.word(node.phase);
	    this.space();
	  }
	  const specifiers = node.specifiers.slice(0);
	  const hasSpecifiers = !!specifiers.length;
	  while (hasSpecifiers) {
	    const first = specifiers[0];
	    if (isImportDefaultSpecifier(first) || isImportNamespaceSpecifier(first)) {
	      this.print(specifiers.shift(), node);
	      if (specifiers.length) {
	        this.tokenChar(44);
	        this.space();
	      }
	    } else {
	      break;
	    }
	  }
	  if (specifiers.length) {
	    this.tokenChar(123);
	    this.space();
	    this.printList(specifiers, node);
	    this.space();
	    this.tokenChar(125);
	  } else if (isTypeKind && !hasSpecifiers) {
	    this.tokenChar(123);
	    this.tokenChar(125);
	  }
	  if (hasSpecifiers || isTypeKind) {
	    this.space();
	    this.word("from");
	    this.space();
	  }
	  if ((_node$attributes3 = node.attributes) != null && _node$attributes3.length || (_node$assertions3 = node.assertions) != null && _node$assertions3.length) {
	    this.print(node.source, node, true);
	    this.space();
	    this._printAttributes(node);
	  } else {
	    this.print(node.source, node);
	  }
	  this.semicolon();
	}
	function ImportAttribute(node) {
	  this.print(node.key);
	  this.tokenChar(58);
	  this.space();
	  this.print(node.value);
	}
	function ImportNamespaceSpecifier(node) {
	  this.tokenChar(42);
	  this.space();
	  this.word("as");
	  this.space();
	  this.print(node.local, node);
	}
	function ImportExpression(node) {
	  this.word("import");
	  if (node.phase) {
	    this.tokenChar(46);
	    this.word(node.phase);
	  }
	  this.tokenChar(40);
	  this.print(node.source, node);
	  if (node.options != null) {
	    this.tokenChar(44);
	    this.space();
	    this.print(node.options, node);
	  }
	  this.tokenChar(41);
	}

	
	return modules;
}

var types = {};

var jsesc_1;
var hasRequiredJsesc;

function requireJsesc () {
	if (hasRequiredJsesc) return jsesc_1;
	hasRequiredJsesc = 1;

	const object = {};
	const hasOwnProperty = object.hasOwnProperty;
	const forOwn = (object, callback) => {
		for (const key in object) {
			if (hasOwnProperty.call(object, key)) {
				callback(key, object[key]);
			}
		}
	};

	const extend = (destination, source) => {
		if (!source) {
			return destination;
		}
		forOwn(source, (key, value) => {
			destination[key] = value;
		});
		return destination;
	};

	const forEach = (array, callback) => {
		const length = array.length;
		let index = -1;
		while (++index < length) {
			callback(array[index]);
		}
	};

	const toString = object.toString;
	const isArray = Array.isArray;
	const isBuffer = Buffer.isBuffer;
	const isObject = (value) => {
		// This is a very simple check, but it’s good enough for what we need.
		return toString.call(value) == '[object Object]';
	};
	const isString = (value) => {
		return typeof value == 'string' ||
			toString.call(value) == '[object String]';
	};
	const isNumber = (value) => {
		return typeof value == 'number' ||
			toString.call(value) == '[object Number]';
	};
	const isFunction = (value) => {
		return typeof value == 'function';
	};
	const isMap = (value) => {
		return toString.call(value) == '[object Map]';
	};
	const isSet = (value) => {
		return toString.call(value) == '[object Set]';
	};

	/*--------------------------------------------------------------------------*/

	// https://mathiasbynens.be/notes/javascript-escapes#single
	const singleEscapes = {
		'"': '\\"',
		'\'': '\\\'',
		'\\': '\\\\',
		'\b': '\\b',
		'\f': '\\f',
		'\n': '\\n',
		'\r': '\\r',
		'\t': '\\t'
		// `\v` is omitted intentionally, because in IE < 9, '\v' == 'v'.
		// '\v': '\\x0B'
	};
	const regexSingleEscape = /["'\\\b\f\n\r\t]/;

	const regexDigit = /[0-9]/;
	const regexWhitelist = /[ !#-&\(-\[\]-_a-~]/;

	const jsesc = (argument, options) => {
		const increaseIndentation = () => {
			oldIndent = indent;
			++options.indentLevel;
			indent = options.indent.repeat(options.indentLevel);
		};
		// Handle options
		const defaults = {
			'escapeEverything': false,
			'minimal': false,
			'isScriptContext': false,
			'quotes': 'single',
			'wrap': false,
			'es6': false,
			'json': false,
			'compact': true,
			'lowercaseHex': false,
			'numbers': 'decimal',
			'indent': '\t',
			'indentLevel': 0,
			'__inline1__': false,
			'__inline2__': false
		};
		const json = options && options.json;
		if (json) {
			defaults.quotes = 'double';
			defaults.wrap = true;
		}
		options = extend(defaults, options);
		if (
			options.quotes != 'single' &&
			options.quotes != 'double' &&
			options.quotes != 'backtick'
		) {
			options.quotes = 'single';
		}
		const quote = options.quotes == 'double' ?
			'"' :
			(options.quotes == 'backtick' ?
				'`' :
				'\''
			);
		const compact = options.compact;
		const lowercaseHex = options.lowercaseHex;
		let indent = options.indent.repeat(options.indentLevel);
		let oldIndent = '';
		const inline1 = options.__inline1__;
		const inline2 = options.__inline2__;
		const newLine = compact ? '' : '\n';
		let result;
		let isEmpty = true;
		const useBinNumbers = options.numbers == 'binary';
		const useOctNumbers = options.numbers == 'octal';
		const useDecNumbers = options.numbers == 'decimal';
		const useHexNumbers = options.numbers == 'hexadecimal';

		if (json && argument && isFunction(argument.toJSON)) {
			argument = argument.toJSON();
		}

		if (!isString(argument)) {
			if (isMap(argument)) {
				if (argument.size == 0) {
					return 'new Map()';
				}
				if (!compact) {
					options.__inline1__ = true;
					options.__inline2__ = false;
				}
				return 'new Map(' + jsesc(Array.from(argument), options) + ')';
			}
			if (isSet(argument)) {
				if (argument.size == 0) {
					return 'new Set()';
				}
				return 'new Set(' + jsesc(Array.from(argument), options) + ')';
			}
			if (isBuffer(argument)) {
				if (argument.length == 0) {
					return 'Buffer.from([])';
				}
				return 'Buffer.from(' + jsesc(Array.from(argument), options) + ')';
			}
			if (isArray(argument)) {
				result = [];
				options.wrap = true;
				if (inline1) {
					options.__inline1__ = false;
					options.__inline2__ = true;
				}
				if (!inline2) {
					increaseIndentation();
				}
				forEach(argument, (value) => {
					isEmpty = false;
					if (inline2) {
						options.__inline2__ = false;
					}
					result.push(
						(compact || inline2 ? '' : indent) +
						jsesc(value, options)
					);
				});
				if (isEmpty) {
					return '[]';
				}
				if (inline2) {
					return '[' + result.join(', ') + ']';
				}
				return '[' + newLine + result.join(',' + newLine) + newLine +
					(compact ? '' : oldIndent) + ']';
			} else if (isNumber(argument)) {
				if (json) {
					// Some number values (e.g. `Infinity`) cannot be represented in JSON.
					return JSON.stringify(argument);
				}
				if (useDecNumbers) {
					return String(argument);
				}
				if (useHexNumbers) {
					let hexadecimal = argument.toString(16);
					if (!lowercaseHex) {
						hexadecimal = hexadecimal.toUpperCase();
					}
					return '0x' + hexadecimal;
				}
				if (useBinNumbers) {
					return '0b' + argument.toString(2);
				}
				if (useOctNumbers) {
					return '0o' + argument.toString(8);
				}
			} else if (!isObject(argument)) {
				if (json) {
					// For some values (e.g. `undefined`, `function` objects),
					// `JSON.stringify(value)` returns `undefined` (which isn’t valid
					// JSON) instead of `'null'`.
					return JSON.stringify(argument) || 'null';
				}
				return String(argument);
			} else { // it’s an object
				result = [];
				options.wrap = true;
				increaseIndentation();
				forOwn(argument, (key, value) => {
					isEmpty = false;
					result.push(
						(compact ? '' : indent) +
						jsesc(key, options) + ':' +
						(compact ? '' : ' ') +
						jsesc(value, options)
					);
				});
				if (isEmpty) {
					return '{}';
				}
				return '{' + newLine + result.join(',' + newLine) + newLine +
					(compact ? '' : oldIndent) + '}';
			}
		}

		const string = argument;
		// Loop over each code unit in the string and escape it
		let index = -1;
		const length = string.length;
		result = '';
		while (++index < length) {
			const character = string.charAt(index);
			if (options.es6) {
				const first = string.charCodeAt(index);
				if ( // check if it’s the start of a surrogate pair
					first >= 0xD800 && first <= 0xDBFF && // high surrogate
					length > index + 1 // there is a next code unit
				) {
					const second = string.charCodeAt(index + 1);
					if (second >= 0xDC00 && second <= 0xDFFF) { // low surrogate
						// https://mathiasbynens.be/notes/javascript-encoding#surrogate-formulae
						const codePoint = (first - 0xD800) * 0x400 + second - 0xDC00 + 0x10000;
						let hexadecimal = codePoint.toString(16);
						if (!lowercaseHex) {
							hexadecimal = hexadecimal.toUpperCase();
						}
						result += '\\u{' + hexadecimal + '}';
						++index;
						continue;
					}
				}
			}
			if (!options.escapeEverything) {
				if (regexWhitelist.test(character)) {
					// It’s a printable ASCII character that is not `"`, `'` or `\`,
					// so don’t escape it.
					result += character;
					continue;
				}
				if (character == '"') {
					result += quote == character ? '\\"' : character;
					continue;
				}
				if (character == '`') {
					result += quote == character ? '\\`' : character;
					continue;
				}
				if (character == '\'') {
					result += quote == character ? '\\\'' : character;
					continue;
				}
			}
			if (
				character == '\0' &&
				!json &&
				!regexDigit.test(string.charAt(index + 1))
			) {
				result += '\\0';
				continue;
			}
			if (regexSingleEscape.test(character)) {
				// no need for a `hasOwnProperty` check here
				result += singleEscapes[character];
				continue;
			}
			const charCode = character.charCodeAt(0);
			if (options.minimal && charCode != 0x2028 && charCode != 0x2029) {
				result += character;
				continue;
			}
			let hexadecimal = charCode.toString(16);
			if (!lowercaseHex) {
				hexadecimal = hexadecimal.toUpperCase();
			}
			const longhand = hexadecimal.length > 2 || json;
			const escaped = '\\' + (longhand ? 'u' : 'x') +
				('0000' + hexadecimal).slice(longhand ? -4 : -2);
			result += escaped;
			continue;
		}
		if (options.wrap) {
			result = quote + result + quote;
		}
		if (quote == '`') {
			result = result.replace(/\$\{/g, '\\\$\{');
		}
		if (options.isScriptContext) {
			// https://mathiasbynens.be/notes/etago
			return result
				.replace(/<\/(script|style)/gi, '<\\/$1')
				.replace(/<!--/g, json ? '\\u003C!--' : '\\x3C!--');
		}
		return result;
	};

	jsesc.version = '2.5.2';

	jsesc_1 = jsesc;
	return jsesc_1;
}

var hasRequiredTypes;

function requireTypes () {
	if (hasRequiredTypes) return types;
	hasRequiredTypes = 1;

	Object.defineProperty(types, "__esModule", {
	  value: true
	});
	types.ArgumentPlaceholder = ArgumentPlaceholder;
	types.ArrayPattern = types.ArrayExpression = ArrayExpression;
	types.BigIntLiteral = BigIntLiteral;
	types.BooleanLiteral = BooleanLiteral;
	types.DecimalLiteral = DecimalLiteral;
	types.Identifier = Identifier;
	types.NullLiteral = NullLiteral;
	types.NumericLiteral = NumericLiteral;
	types.ObjectPattern = types.ObjectExpression = ObjectExpression;
	types.ObjectMethod = ObjectMethod;
	types.ObjectProperty = ObjectProperty;
	types.PipelineBareFunction = PipelineBareFunction;
	types.PipelinePrimaryTopicReference = PipelinePrimaryTopicReference;
	types.PipelineTopicExpression = PipelineTopicExpression;
	types.RecordExpression = RecordExpression;
	types.RegExpLiteral = RegExpLiteral;
	types.SpreadElement = types.RestElement = RestElement;
	types.StringLiteral = StringLiteral;
	types.TopicReference = TopicReference;
	types.TupleExpression = TupleExpression;
	var _t = requireLib$h();
	var _jsesc = requireJsesc();
	const {
	  isAssignmentPattern,
	  isIdentifier
	} = _t;
	function Identifier(node) {
	  var _node$loc;
	  this.sourceIdentifierName(((_node$loc = node.loc) == null ? void 0 : _node$loc.identifierName) || node.name);
	  this.word(node.name);
	}
	function ArgumentPlaceholder() {
	  this.tokenChar(63);
	}
	function RestElement(node) {
	  this.token("...");
	  this.print(node.argument, node);
	}
	function ObjectExpression(node) {
	  const props = node.properties;
	  this.tokenChar(123);
	  if (props.length) {
	    this.space();
	    this.printList(props, node, {
	      indent: true,
	      statement: true
	    });
	    this.space();
	  }
	  this.sourceWithOffset("end", node.loc, -1);
	  this.tokenChar(125);
	}
	function ObjectMethod(node) {
	  this.printJoin(node.decorators, node);
	  this._methodHead(node);
	  this.space();
	  this.print(node.body, node);
	}
	function ObjectProperty(node) {
	  this.printJoin(node.decorators, node);
	  if (node.computed) {
	    this.tokenChar(91);
	    this.print(node.key, node);
	    this.tokenChar(93);
	  } else {
	    if (isAssignmentPattern(node.value) && isIdentifier(node.key) && node.key.name === node.value.left.name) {
	      this.print(node.value, node);
	      return;
	    }
	    this.print(node.key, node);
	    if (node.shorthand && isIdentifier(node.key) && isIdentifier(node.value) && node.key.name === node.value.name) {
	      return;
	    }
	  }
	  this.tokenChar(58);
	  this.space();
	  this.print(node.value, node);
	}
	function ArrayExpression(node) {
	  const elems = node.elements;
	  const len = elems.length;
	  this.tokenChar(91);
	  for (let i = 0; i < elems.length; i++) {
	    const elem = elems[i];
	    if (elem) {
	      if (i > 0) this.space();
	      this.print(elem, node);
	      if (i < len - 1) this.tokenChar(44);
	    } else {
	      this.tokenChar(44);
	    }
	  }
	  this.tokenChar(93);
	}
	function RecordExpression(node) {
	  const props = node.properties;
	  let startToken;
	  let endToken;
	  if (this.format.recordAndTupleSyntaxType === "bar") {
	    startToken = "{|";
	    endToken = "|}";
	  } else if (this.format.recordAndTupleSyntaxType !== "hash" && this.format.recordAndTupleSyntaxType != null) {
	    throw new Error(`The "recordAndTupleSyntaxType" generator option must be "bar" or "hash" (${JSON.stringify(this.format.recordAndTupleSyntaxType)} received).`);
	  } else {
	    startToken = "#{";
	    endToken = "}";
	  }
	  this.token(startToken);
	  if (props.length) {
	    this.space();
	    this.printList(props, node, {
	      indent: true,
	      statement: true
	    });
	    this.space();
	  }
	  this.token(endToken);
	}
	function TupleExpression(node) {
	  const elems = node.elements;
	  const len = elems.length;
	  let startToken;
	  let endToken;
	  if (this.format.recordAndTupleSyntaxType === "bar") {
	    startToken = "[|";
	    endToken = "|]";
	  } else if (this.format.recordAndTupleSyntaxType === "hash") {
	    startToken = "#[";
	    endToken = "]";
	  } else {
	    throw new Error(`${this.format.recordAndTupleSyntaxType} is not a valid recordAndTuple syntax type`);
	  }
	  this.token(startToken);
	  for (let i = 0; i < elems.length; i++) {
	    const elem = elems[i];
	    if (elem) {
	      if (i > 0) this.space();
	      this.print(elem, node);
	      if (i < len - 1) this.tokenChar(44);
	    }
	  }
	  this.token(endToken);
	}
	function RegExpLiteral(node) {
	  this.word(`/${node.pattern}/${node.flags}`);
	}
	function BooleanLiteral(node) {
	  this.word(node.value ? "true" : "false");
	}
	function NullLiteral() {
	  this.word("null");
	}
	function NumericLiteral(node) {
	  const raw = this.getPossibleRaw(node);
	  const opts = this.format.jsescOption;
	  const value = node.value;
	  const str = value + "";
	  if (opts.numbers) {
	    this.number(_jsesc(value, opts), value);
	  } else if (raw == null) {
	    this.number(str, value);
	  } else if (this.format.minified) {
	    this.number(raw.length < str.length ? raw : str, value);
	  } else {
	    this.number(raw, value);
	  }
	}
	function StringLiteral(node) {
	  const raw = this.getPossibleRaw(node);
	  if (!this.format.minified && raw !== undefined) {
	    this.token(raw);
	    return;
	  }
	  const val = _jsesc(node.value, this.format.jsescOption);
	  this.token(val);
	}
	function BigIntLiteral(node) {
	  const raw = this.getPossibleRaw(node);
	  if (!this.format.minified && raw !== undefined) {
	    this.word(raw);
	    return;
	  }
	  this.word(node.value + "n");
	}
	function DecimalLiteral(node) {
	  const raw = this.getPossibleRaw(node);
	  if (!this.format.minified && raw !== undefined) {
	    this.word(raw);
	    return;
	  }
	  this.word(node.value + "m");
	}
	const validTopicTokenSet = new Set(["^^", "@@", "^", "%", "#"]);
	function TopicReference() {
	  const {
	    topicToken
	  } = this.format;
	  if (validTopicTokenSet.has(topicToken)) {
	    this.token(topicToken);
	  } else {
	    const givenTopicTokenJSON = JSON.stringify(topicToken);
	    const validTopics = Array.from(validTopicTokenSet, v => JSON.stringify(v));
	    throw new Error(`The "topicToken" generator option must be one of ` + `${validTopics.join(", ")} (${givenTopicTokenJSON} received instead).`);
	  }
	}
	function PipelineTopicExpression(node) {
	  this.print(node.expression, node);
	}
	function PipelineBareFunction(node) {
	  this.print(node.callee, node);
	}
	function PipelinePrimaryTopicReference() {
	  this.tokenChar(35);
	}

	
	return types;
}

var flow = {};

var hasRequiredFlow;

function requireFlow () {
	if (hasRequiredFlow) return flow;
	hasRequiredFlow = 1;
	(function (exports) {

		Object.defineProperty(exports, "__esModule", {
		  value: true
		});
		exports.AnyTypeAnnotation = AnyTypeAnnotation;
		exports.ArrayTypeAnnotation = ArrayTypeAnnotation;
		exports.BooleanLiteralTypeAnnotation = BooleanLiteralTypeAnnotation;
		exports.BooleanTypeAnnotation = BooleanTypeAnnotation;
		exports.DeclareClass = DeclareClass;
		exports.DeclareExportAllDeclaration = DeclareExportAllDeclaration;
		exports.DeclareExportDeclaration = DeclareExportDeclaration;
		exports.DeclareFunction = DeclareFunction;
		exports.DeclareInterface = DeclareInterface;
		exports.DeclareModule = DeclareModule;
		exports.DeclareModuleExports = DeclareModuleExports;
		exports.DeclareOpaqueType = DeclareOpaqueType;
		exports.DeclareTypeAlias = DeclareTypeAlias;
		exports.DeclareVariable = DeclareVariable;
		exports.DeclaredPredicate = DeclaredPredicate;
		exports.EmptyTypeAnnotation = EmptyTypeAnnotation;
		exports.EnumBooleanBody = EnumBooleanBody;
		exports.EnumBooleanMember = EnumBooleanMember;
		exports.EnumDeclaration = EnumDeclaration;
		exports.EnumDefaultedMember = EnumDefaultedMember;
		exports.EnumNumberBody = EnumNumberBody;
		exports.EnumNumberMember = EnumNumberMember;
		exports.EnumStringBody = EnumStringBody;
		exports.EnumStringMember = EnumStringMember;
		exports.EnumSymbolBody = EnumSymbolBody;
		exports.ExistsTypeAnnotation = ExistsTypeAnnotation;
		exports.FunctionTypeAnnotation = FunctionTypeAnnotation;
		exports.FunctionTypeParam = FunctionTypeParam;
		exports.IndexedAccessType = IndexedAccessType;
		exports.InferredPredicate = InferredPredicate;
		exports.InterfaceDeclaration = InterfaceDeclaration;
		exports.GenericTypeAnnotation = exports.ClassImplements = exports.InterfaceExtends = InterfaceExtends;
		exports.InterfaceTypeAnnotation = InterfaceTypeAnnotation;
		exports.IntersectionTypeAnnotation = IntersectionTypeAnnotation;
		exports.MixedTypeAnnotation = MixedTypeAnnotation;
		exports.NullLiteralTypeAnnotation = NullLiteralTypeAnnotation;
		exports.NullableTypeAnnotation = NullableTypeAnnotation;
		Object.defineProperty(exports, "NumberLiteralTypeAnnotation", {
		  enumerable: true,
		  get: function () {
		    return _types2.NumericLiteral;
		  }
		});
		exports.NumberTypeAnnotation = NumberTypeAnnotation;
		exports.ObjectTypeAnnotation = ObjectTypeAnnotation;
		exports.ObjectTypeCallProperty = ObjectTypeCallProperty;
		exports.ObjectTypeIndexer = ObjectTypeIndexer;
		exports.ObjectTypeInternalSlot = ObjectTypeInternalSlot;
		exports.ObjectTypeProperty = ObjectTypeProperty;
		exports.ObjectTypeSpreadProperty = ObjectTypeSpreadProperty;
		exports.OpaqueType = OpaqueType;
		exports.OptionalIndexedAccessType = OptionalIndexedAccessType;
		exports.QualifiedTypeIdentifier = QualifiedTypeIdentifier;
		Object.defineProperty(exports, "StringLiteralTypeAnnotation", {
		  enumerable: true,
		  get: function () {
		    return _types2.StringLiteral;
		  }
		});
		exports.StringTypeAnnotation = StringTypeAnnotation;
		exports.SymbolTypeAnnotation = SymbolTypeAnnotation;
		exports.ThisTypeAnnotation = ThisTypeAnnotation;
		exports.TupleTypeAnnotation = TupleTypeAnnotation;
		exports.TypeAlias = TypeAlias;
		exports.TypeAnnotation = TypeAnnotation;
		exports.TypeCastExpression = TypeCastExpression;
		exports.TypeParameter = TypeParameter;
		exports.TypeParameterDeclaration = exports.TypeParameterInstantiation = TypeParameterInstantiation;
		exports.TypeofTypeAnnotation = TypeofTypeAnnotation;
		exports.UnionTypeAnnotation = UnionTypeAnnotation;
		exports.Variance = Variance;
		exports.VoidTypeAnnotation = VoidTypeAnnotation;
		exports._interfaceish = _interfaceish;
		exports._variance = _variance;
		var _t = requireLib$h();
		var _modules = requireModules();
		var _types2 = requireTypes();
		const {
		  isDeclareExportDeclaration,
		  isStatement
		} = _t;
		function AnyTypeAnnotation() {
		  this.word("any");
		}
		function ArrayTypeAnnotation(node) {
		  this.print(node.elementType, node, true);
		  this.tokenChar(91);
		  this.tokenChar(93);
		}
		function BooleanTypeAnnotation() {
		  this.word("boolean");
		}
		function BooleanLiteralTypeAnnotation(node) {
		  this.word(node.value ? "true" : "false");
		}
		function NullLiteralTypeAnnotation() {
		  this.word("null");
		}
		function DeclareClass(node, parent) {
		  if (!isDeclareExportDeclaration(parent)) {
		    this.word("declare");
		    this.space();
		  }
		  this.word("class");
		  this.space();
		  this._interfaceish(node);
		}
		function DeclareFunction(node, parent) {
		  if (!isDeclareExportDeclaration(parent)) {
		    this.word("declare");
		    this.space();
		  }
		  this.word("function");
		  this.space();
		  this.print(node.id, node);
		  this.print(node.id.typeAnnotation.typeAnnotation, node);
		  if (node.predicate) {
		    this.space();
		    this.print(node.predicate, node);
		  }
		  this.semicolon();
		}
		function InferredPredicate() {
		  this.tokenChar(37);
		  this.word("checks");
		}
		function DeclaredPredicate(node) {
		  this.tokenChar(37);
		  this.word("checks");
		  this.tokenChar(40);
		  this.print(node.value, node);
		  this.tokenChar(41);
		}
		function DeclareInterface(node) {
		  this.word("declare");
		  this.space();
		  this.InterfaceDeclaration(node);
		}
		function DeclareModule(node) {
		  this.word("declare");
		  this.space();
		  this.word("module");
		  this.space();
		  this.print(node.id, node);
		  this.space();
		  this.print(node.body, node);
		}
		function DeclareModuleExports(node) {
		  this.word("declare");
		  this.space();
		  this.word("module");
		  this.tokenChar(46);
		  this.word("exports");
		  this.print(node.typeAnnotation, node);
		}
		function DeclareTypeAlias(node) {
		  this.word("declare");
		  this.space();
		  this.TypeAlias(node);
		}
		function DeclareOpaqueType(node, parent) {
		  if (!isDeclareExportDeclaration(parent)) {
		    this.word("declare");
		    this.space();
		  }
		  this.OpaqueType(node);
		}
		function DeclareVariable(node, parent) {
		  if (!isDeclareExportDeclaration(parent)) {
		    this.word("declare");
		    this.space();
		  }
		  this.word("var");
		  this.space();
		  this.print(node.id, node);
		  this.print(node.id.typeAnnotation, node);
		  this.semicolon();
		}
		function DeclareExportDeclaration(node) {
		  this.word("declare");
		  this.space();
		  this.word("export");
		  this.space();
		  if (node.default) {
		    this.word("default");
		    this.space();
		  }
		  FlowExportDeclaration.call(this, node);
		}
		function DeclareExportAllDeclaration(node) {
		  this.word("declare");
		  this.space();
		  _modules.ExportAllDeclaration.call(this, node);
		}
		function EnumDeclaration(node) {
		  const {
		    id,
		    body
		  } = node;
		  this.word("enum");
		  this.space();
		  this.print(id, node);
		  this.print(body, node);
		}
		function enumExplicitType(context, name, hasExplicitType) {
		  if (hasExplicitType) {
		    context.space();
		    context.word("of");
		    context.space();
		    context.word(name);
		  }
		  context.space();
		}
		function enumBody(context, node) {
		  const {
		    members
		  } = node;
		  context.token("{");
		  context.indent();
		  context.newline();
		  for (const member of members) {
		    context.print(member, node);
		    context.newline();
		  }
		  if (node.hasUnknownMembers) {
		    context.token("...");
		    context.newline();
		  }
		  context.dedent();
		  context.token("}");
		}
		function EnumBooleanBody(node) {
		  const {
		    explicitType
		  } = node;
		  enumExplicitType(this, "boolean", explicitType);
		  enumBody(this, node);
		}
		function EnumNumberBody(node) {
		  const {
		    explicitType
		  } = node;
		  enumExplicitType(this, "number", explicitType);
		  enumBody(this, node);
		}
		function EnumStringBody(node) {
		  const {
		    explicitType
		  } = node;
		  enumExplicitType(this, "string", explicitType);
		  enumBody(this, node);
		}
		function EnumSymbolBody(node) {
		  enumExplicitType(this, "symbol", true);
		  enumBody(this, node);
		}
		function EnumDefaultedMember(node) {
		  const {
		    id
		  } = node;
		  this.print(id, node);
		  this.tokenChar(44);
		}
		function enumInitializedMember(context, node) {
		  const {
		    id,
		    init
		  } = node;
		  context.print(id, node);
		  context.space();
		  context.token("=");
		  context.space();
		  context.print(init, node);
		  context.token(",");
		}
		function EnumBooleanMember(node) {
		  enumInitializedMember(this, node);
		}
		function EnumNumberMember(node) {
		  enumInitializedMember(this, node);
		}
		function EnumStringMember(node) {
		  enumInitializedMember(this, node);
		}
		function FlowExportDeclaration(node) {
		  if (node.declaration) {
		    const declar = node.declaration;
		    this.print(declar, node);
		    if (!isStatement(declar)) this.semicolon();
		  } else {
		    this.tokenChar(123);
		    if (node.specifiers.length) {
		      this.space();
		      this.printList(node.specifiers, node);
		      this.space();
		    }
		    this.tokenChar(125);
		    if (node.source) {
		      this.space();
		      this.word("from");
		      this.space();
		      this.print(node.source, node);
		    }
		    this.semicolon();
		  }
		}
		function ExistsTypeAnnotation() {
		  this.tokenChar(42);
		}
		function FunctionTypeAnnotation(node, parent) {
		  this.print(node.typeParameters, node);
		  this.tokenChar(40);
		  if (node.this) {
		    this.word("this");
		    this.tokenChar(58);
		    this.space();
		    this.print(node.this.typeAnnotation, node);
		    if (node.params.length || node.rest) {
		      this.tokenChar(44);
		      this.space();
		    }
		  }
		  this.printList(node.params, node);
		  if (node.rest) {
		    if (node.params.length) {
		      this.tokenChar(44);
		      this.space();
		    }
		    this.token("...");
		    this.print(node.rest, node);
		  }
		  this.tokenChar(41);
		  const type = parent == null ? void 0 : parent.type;
		  if (type != null && (type === "ObjectTypeCallProperty" || type === "ObjectTypeInternalSlot" || type === "DeclareFunction" || type === "ObjectTypeProperty" && parent.method)) {
		    this.tokenChar(58);
		  } else {
		    this.space();
		    this.token("=>");
		  }
		  this.space();
		  this.print(node.returnType, node);
		}
		function FunctionTypeParam(node) {
		  this.print(node.name, node);
		  if (node.optional) this.tokenChar(63);
		  if (node.name) {
		    this.tokenChar(58);
		    this.space();
		  }
		  this.print(node.typeAnnotation, node);
		}
		function InterfaceExtends(node) {
		  this.print(node.id, node);
		  this.print(node.typeParameters, node, true);
		}
		function _interfaceish(node) {
		  var _node$extends;
		  this.print(node.id, node);
		  this.print(node.typeParameters, node);
		  if ((_node$extends = node.extends) != null && _node$extends.length) {
		    this.space();
		    this.word("extends");
		    this.space();
		    this.printList(node.extends, node);
		  }
		  if (node.type === "DeclareClass") {
		    var _node$mixins, _node$implements;
		    if ((_node$mixins = node.mixins) != null && _node$mixins.length) {
		      this.space();
		      this.word("mixins");
		      this.space();
		      this.printList(node.mixins, node);
		    }
		    if ((_node$implements = node.implements) != null && _node$implements.length) {
		      this.space();
		      this.word("implements");
		      this.space();
		      this.printList(node.implements, node);
		    }
		  }
		  this.space();
		  this.print(node.body, node);
		}
		function _variance(node) {
		  var _node$variance;
		  const kind = (_node$variance = node.variance) == null ? void 0 : _node$variance.kind;
		  if (kind != null) {
		    if (kind === "plus") {
		      this.tokenChar(43);
		    } else if (kind === "minus") {
		      this.tokenChar(45);
		    }
		  }
		}
		function InterfaceDeclaration(node) {
		  this.word("interface");
		  this.space();
		  this._interfaceish(node);
		}
		function andSeparator() {
		  this.space();
		  this.tokenChar(38);
		  this.space();
		}
		function InterfaceTypeAnnotation(node) {
		  var _node$extends2;
		  this.word("interface");
		  if ((_node$extends2 = node.extends) != null && _node$extends2.length) {
		    this.space();
		    this.word("extends");
		    this.space();
		    this.printList(node.extends, node);
		  }
		  this.space();
		  this.print(node.body, node);
		}
		function IntersectionTypeAnnotation(node) {
		  this.printJoin(node.types, node, {
		    separator: andSeparator
		  });
		}
		function MixedTypeAnnotation() {
		  this.word("mixed");
		}
		function EmptyTypeAnnotation() {
		  this.word("empty");
		}
		function NullableTypeAnnotation(node) {
		  this.tokenChar(63);
		  this.print(node.typeAnnotation, node);
		}
		function NumberTypeAnnotation() {
		  this.word("number");
		}
		function StringTypeAnnotation() {
		  this.word("string");
		}
		function ThisTypeAnnotation() {
		  this.word("this");
		}
		function TupleTypeAnnotation(node) {
		  this.tokenChar(91);
		  this.printList(node.types, node);
		  this.tokenChar(93);
		}
		function TypeofTypeAnnotation(node) {
		  this.word("typeof");
		  this.space();
		  this.print(node.argument, node);
		}
		function TypeAlias(node) {
		  this.word("type");
		  this.space();
		  this.print(node.id, node);
		  this.print(node.typeParameters, node);
		  this.space();
		  this.tokenChar(61);
		  this.space();
		  this.print(node.right, node);
		  this.semicolon();
		}
		function TypeAnnotation(node) {
		  this.tokenChar(58);
		  this.space();
		  if (node.optional) this.tokenChar(63);
		  this.print(node.typeAnnotation, node);
		}
		function TypeParameterInstantiation(node) {
		  this.tokenChar(60);
		  this.printList(node.params, node, {});
		  this.tokenChar(62);
		}
		function TypeParameter(node) {
		  this._variance(node);
		  this.word(node.name);
		  if (node.bound) {
		    this.print(node.bound, node);
		  }
		  if (node.default) {
		    this.space();
		    this.tokenChar(61);
		    this.space();
		    this.print(node.default, node);
		  }
		}
		function OpaqueType(node) {
		  this.word("opaque");
		  this.space();
		  this.word("type");
		  this.space();
		  this.print(node.id, node);
		  this.print(node.typeParameters, node);
		  if (node.supertype) {
		    this.tokenChar(58);
		    this.space();
		    this.print(node.supertype, node);
		  }
		  if (node.impltype) {
		    this.space();
		    this.tokenChar(61);
		    this.space();
		    this.print(node.impltype, node);
		  }
		  this.semicolon();
		}
		function ObjectTypeAnnotation(node) {
		  if (node.exact) {
		    this.token("{|");
		  } else {
		    this.tokenChar(123);
		  }
		  const props = [...node.properties, ...(node.callProperties || []), ...(node.indexers || []), ...(node.internalSlots || [])];
		  if (props.length) {
		    this.newline();
		    this.space();
		    this.printJoin(props, node, {
		      addNewlines(leading) {
		        if (leading && !props[0]) return 1;
		      },
		      indent: true,
		      statement: true,
		      iterator: () => {
		        if (props.length !== 1 || node.inexact) {
		          this.tokenChar(44);
		          this.space();
		        }
		      }
		    });
		    this.space();
		  }
		  if (node.inexact) {
		    this.indent();
		    this.token("...");
		    if (props.length) {
		      this.newline();
		    }
		    this.dedent();
		  }
		  if (node.exact) {
		    this.token("|}");
		  } else {
		    this.tokenChar(125);
		  }
		}
		function ObjectTypeInternalSlot(node) {
		  if (node.static) {
		    this.word("static");
		    this.space();
		  }
		  this.tokenChar(91);
		  this.tokenChar(91);
		  this.print(node.id, node);
		  this.tokenChar(93);
		  this.tokenChar(93);
		  if (node.optional) this.tokenChar(63);
		  if (!node.method) {
		    this.tokenChar(58);
		    this.space();
		  }
		  this.print(node.value, node);
		}
		function ObjectTypeCallProperty(node) {
		  if (node.static) {
		    this.word("static");
		    this.space();
		  }
		  this.print(node.value, node);
		}
		function ObjectTypeIndexer(node) {
		  if (node.static) {
		    this.word("static");
		    this.space();
		  }
		  this._variance(node);
		  this.tokenChar(91);
		  if (node.id) {
		    this.print(node.id, node);
		    this.tokenChar(58);
		    this.space();
		  }
		  this.print(node.key, node);
		  this.tokenChar(93);
		  this.tokenChar(58);
		  this.space();
		  this.print(node.value, node);
		}
		function ObjectTypeProperty(node) {
		  if (node.proto) {
		    this.word("proto");
		    this.space();
		  }
		  if (node.static) {
		    this.word("static");
		    this.space();
		  }
		  if (node.kind === "get" || node.kind === "set") {
		    this.word(node.kind);
		    this.space();
		  }
		  this._variance(node);
		  this.print(node.key, node);
		  if (node.optional) this.tokenChar(63);
		  if (!node.method) {
		    this.tokenChar(58);
		    this.space();
		  }
		  this.print(node.value, node);
		}
		function ObjectTypeSpreadProperty(node) {
		  this.token("...");
		  this.print(node.argument, node);
		}
		function QualifiedTypeIdentifier(node) {
		  this.print(node.qualification, node);
		  this.tokenChar(46);
		  this.print(node.id, node);
		}
		function SymbolTypeAnnotation() {
		  this.word("symbol");
		}
		function orSeparator() {
		  this.space();
		  this.tokenChar(124);
		  this.space();
		}
		function UnionTypeAnnotation(node) {
		  this.printJoin(node.types, node, {
		    separator: orSeparator
		  });
		}
		function TypeCastExpression(node) {
		  this.tokenChar(40);
		  this.print(node.expression, node);
		  this.print(node.typeAnnotation, node);
		  this.tokenChar(41);
		}
		function Variance(node) {
		  if (node.kind === "plus") {
		    this.tokenChar(43);
		  } else {
		    this.tokenChar(45);
		  }
		}
		function VoidTypeAnnotation() {
		  this.word("void");
		}
		function IndexedAccessType(node) {
		  this.print(node.objectType, node, true);
		  this.tokenChar(91);
		  this.print(node.indexType, node);
		  this.tokenChar(93);
		}
		function OptionalIndexedAccessType(node) {
		  this.print(node.objectType, node);
		  if (node.optional) {
		    this.token("?.");
		  }
		  this.tokenChar(91);
		  this.print(node.indexType, node);
		  this.tokenChar(93);
		}

		
	} (flow));
	return flow;
}

var base = {};

var hasRequiredBase;

function requireBase () {
	if (hasRequiredBase) return base;
	hasRequiredBase = 1;

	Object.defineProperty(base, "__esModule", {
	  value: true
	});
	base.BlockStatement = BlockStatement;
	base.Directive = Directive;
	base.DirectiveLiteral = DirectiveLiteral;
	base.File = File;
	base.InterpreterDirective = InterpreterDirective;
	base.Placeholder = Placeholder;
	base.Program = Program;
	function File(node) {
	  if (node.program) {
	    this.print(node.program.interpreter, node);
	  }
	  this.print(node.program, node);
	}
	function Program(node) {
	  var _node$directives;
	  this.noIndentInnerCommentsHere();
	  this.printInnerComments();
	  const directivesLen = (_node$directives = node.directives) == null ? void 0 : _node$directives.length;
	  if (directivesLen) {
	    var _node$directives$trai;
	    const newline = node.body.length ? 2 : 1;
	    this.printSequence(node.directives, node, {
	      trailingCommentsLineOffset: newline
	    });
	    if (!((_node$directives$trai = node.directives[directivesLen - 1].trailingComments) != null && _node$directives$trai.length)) {
	      this.newline(newline);
	    }
	  }
	  this.printSequence(node.body, node);
	}
	function BlockStatement(node) {
	  var _node$directives2;
	  this.tokenChar(123);
	  const directivesLen = (_node$directives2 = node.directives) == null ? void 0 : _node$directives2.length;
	  if (directivesLen) {
	    var _node$directives$trai2;
	    const newline = node.body.length ? 2 : 1;
	    this.printSequence(node.directives, node, {
	      indent: true,
	      trailingCommentsLineOffset: newline
	    });
	    if (!((_node$directives$trai2 = node.directives[directivesLen - 1].trailingComments) != null && _node$directives$trai2.length)) {
	      this.newline(newline);
	    }
	  }
	  this.printSequence(node.body, node, {
	    indent: true
	  });
	  this.rightBrace(node);
	}
	function Directive(node) {
	  this.print(node.value, node);
	  this.semicolon();
	}
	const unescapedSingleQuoteRE = /(?:^|[^\\])(?:\\\\)*'/;
	const unescapedDoubleQuoteRE = /(?:^|[^\\])(?:\\\\)*"/;
	function DirectiveLiteral(node) {
	  const raw = this.getPossibleRaw(node);
	  if (!this.format.minified && raw !== undefined) {
	    this.token(raw);
	    return;
	  }
	  const {
	    value
	  } = node;
	  if (!unescapedDoubleQuoteRE.test(value)) {
	    this.token(`"${value}"`);
	  } else if (!unescapedSingleQuoteRE.test(value)) {
	    this.token(`'${value}'`);
	  } else {
	    throw new Error("Malformed AST: it is not possible to print a directive containing" + " both unescaped single and double quotes.");
	  }
	}
	function InterpreterDirective(node) {
	  this.token(`#!${node.value}`);
	  this.newline(1, true);
	}
	function Placeholder(node) {
	  this.token("%%");
	  this.print(node.name);
	  this.token("%%");
	  if (node.expectedNode === "Statement") {
	    this.semicolon();
	  }
	}

	
	return base;
}

var jsx = {};

var hasRequiredJsx;

function requireJsx () {
	if (hasRequiredJsx) return jsx;
	hasRequiredJsx = 1;

	Object.defineProperty(jsx, "__esModule", {
	  value: true
	});
	jsx.JSXAttribute = JSXAttribute;
	jsx.JSXClosingElement = JSXClosingElement;
	jsx.JSXClosingFragment = JSXClosingFragment;
	jsx.JSXElement = JSXElement;
	jsx.JSXEmptyExpression = JSXEmptyExpression;
	jsx.JSXExpressionContainer = JSXExpressionContainer;
	jsx.JSXFragment = JSXFragment;
	jsx.JSXIdentifier = JSXIdentifier;
	jsx.JSXMemberExpression = JSXMemberExpression;
	jsx.JSXNamespacedName = JSXNamespacedName;
	jsx.JSXOpeningElement = JSXOpeningElement;
	jsx.JSXOpeningFragment = JSXOpeningFragment;
	jsx.JSXSpreadAttribute = JSXSpreadAttribute;
	jsx.JSXSpreadChild = JSXSpreadChild;
	jsx.JSXText = JSXText;
	function JSXAttribute(node) {
	  this.print(node.name, node);
	  if (node.value) {
	    this.tokenChar(61);
	    this.print(node.value, node);
	  }
	}
	function JSXIdentifier(node) {
	  this.word(node.name);
	}
	function JSXNamespacedName(node) {
	  this.print(node.namespace, node);
	  this.tokenChar(58);
	  this.print(node.name, node);
	}
	function JSXMemberExpression(node) {
	  this.print(node.object, node);
	  this.tokenChar(46);
	  this.print(node.property, node);
	}
	function JSXSpreadAttribute(node) {
	  this.tokenChar(123);
	  this.token("...");
	  this.print(node.argument, node);
	  this.tokenChar(125);
	}
	function JSXExpressionContainer(node) {
	  this.tokenChar(123);
	  this.print(node.expression, node);
	  this.tokenChar(125);
	}
	function JSXSpreadChild(node) {
	  this.tokenChar(123);
	  this.token("...");
	  this.print(node.expression, node);
	  this.tokenChar(125);
	}
	function JSXText(node) {
	  const raw = this.getPossibleRaw(node);
	  if (raw !== undefined) {
	    this.token(raw, true);
	  } else {
	    this.token(node.value, true);
	  }
	}
	function JSXElement(node) {
	  const open = node.openingElement;
	  this.print(open, node);
	  if (open.selfClosing) return;
	  this.indent();
	  for (const child of node.children) {
	    this.print(child, node);
	  }
	  this.dedent();
	  this.print(node.closingElement, node);
	}
	function spaceSeparator() {
	  this.space();
	}
	function JSXOpeningElement(node) {
	  this.tokenChar(60);
	  this.print(node.name, node);
	  this.print(node.typeParameters, node);
	  if (node.attributes.length > 0) {
	    this.space();
	    this.printJoin(node.attributes, node, {
	      separator: spaceSeparator
	    });
	  }
	  if (node.selfClosing) {
	    this.space();
	    this.token("/>");
	  } else {
	    this.tokenChar(62);
	  }
	}
	function JSXClosingElement(node) {
	  this.token("</");
	  this.print(node.name, node);
	  this.tokenChar(62);
	}
	function JSXEmptyExpression() {
	  this.printInnerComments();
	}
	function JSXFragment(node) {
	  this.print(node.openingFragment, node);
	  this.indent();
	  for (const child of node.children) {
	    this.print(child, node);
	  }
	  this.dedent();
	  this.print(node.closingFragment, node);
	}
	function JSXOpeningFragment() {
	  this.tokenChar(60);
	  this.tokenChar(62);
	}
	function JSXClosingFragment() {
	  this.token("</");
	  this.tokenChar(62);
	}

	
	return jsx;
}

var typescript$3 = {};

var hasRequiredTypescript;

function requireTypescript () {
	if (hasRequiredTypescript) return typescript$3;
	hasRequiredTypescript = 1;

	Object.defineProperty(typescript$3, "__esModule", {
	  value: true
	});
	typescript$3.TSAnyKeyword = TSAnyKeyword;
	typescript$3.TSArrayType = TSArrayType;
	typescript$3.TSSatisfiesExpression = typescript$3.TSAsExpression = TSTypeExpression;
	typescript$3.TSBigIntKeyword = TSBigIntKeyword;
	typescript$3.TSBooleanKeyword = TSBooleanKeyword;
	typescript$3.TSCallSignatureDeclaration = TSCallSignatureDeclaration;
	typescript$3.TSConditionalType = TSConditionalType;
	typescript$3.TSConstructSignatureDeclaration = TSConstructSignatureDeclaration;
	typescript$3.TSConstructorType = TSConstructorType;
	typescript$3.TSDeclareFunction = TSDeclareFunction;
	typescript$3.TSDeclareMethod = TSDeclareMethod;
	typescript$3.TSEnumDeclaration = TSEnumDeclaration;
	typescript$3.TSEnumMember = TSEnumMember;
	typescript$3.TSExportAssignment = TSExportAssignment;
	typescript$3.TSExpressionWithTypeArguments = TSExpressionWithTypeArguments;
	typescript$3.TSExternalModuleReference = TSExternalModuleReference;
	typescript$3.TSFunctionType = TSFunctionType;
	typescript$3.TSImportEqualsDeclaration = TSImportEqualsDeclaration;
	typescript$3.TSImportType = TSImportType;
	typescript$3.TSIndexSignature = TSIndexSignature;
	typescript$3.TSIndexedAccessType = TSIndexedAccessType;
	typescript$3.TSInferType = TSInferType;
	typescript$3.TSInstantiationExpression = TSInstantiationExpression;
	typescript$3.TSInterfaceBody = TSInterfaceBody;
	typescript$3.TSInterfaceDeclaration = TSInterfaceDeclaration;
	typescript$3.TSIntersectionType = TSIntersectionType;
	typescript$3.TSIntrinsicKeyword = TSIntrinsicKeyword;
	typescript$3.TSLiteralType = TSLiteralType;
	typescript$3.TSMappedType = TSMappedType;
	typescript$3.TSMethodSignature = TSMethodSignature;
	typescript$3.TSModuleBlock = TSModuleBlock;
	typescript$3.TSModuleDeclaration = TSModuleDeclaration;
	typescript$3.TSNamedTupleMember = TSNamedTupleMember;
	typescript$3.TSNamespaceExportDeclaration = TSNamespaceExportDeclaration;
	typescript$3.TSNeverKeyword = TSNeverKeyword;
	typescript$3.TSNonNullExpression = TSNonNullExpression;
	typescript$3.TSNullKeyword = TSNullKeyword;
	typescript$3.TSNumberKeyword = TSNumberKeyword;
	typescript$3.TSObjectKeyword = TSObjectKeyword;
	typescript$3.TSOptionalType = TSOptionalType;
	typescript$3.TSParameterProperty = TSParameterProperty;
	typescript$3.TSParenthesizedType = TSParenthesizedType;
	typescript$3.TSPropertySignature = TSPropertySignature;
	typescript$3.TSQualifiedName = TSQualifiedName;
	typescript$3.TSRestType = TSRestType;
	typescript$3.TSStringKeyword = TSStringKeyword;
	typescript$3.TSSymbolKeyword = TSSymbolKeyword;
	typescript$3.TSThisType = TSThisType;
	typescript$3.TSTupleType = TSTupleType;
	typescript$3.TSTypeAliasDeclaration = TSTypeAliasDeclaration;
	typescript$3.TSTypeAnnotation = TSTypeAnnotation;
	typescript$3.TSTypeAssertion = TSTypeAssertion;
	typescript$3.TSTypeLiteral = TSTypeLiteral;
	typescript$3.TSTypeOperator = TSTypeOperator;
	typescript$3.TSTypeParameter = TSTypeParameter;
	typescript$3.TSTypeParameterDeclaration = typescript$3.TSTypeParameterInstantiation = TSTypeParameterInstantiation;
	typescript$3.TSTypePredicate = TSTypePredicate;
	typescript$3.TSTypeQuery = TSTypeQuery;
	typescript$3.TSTypeReference = TSTypeReference;
	typescript$3.TSUndefinedKeyword = TSUndefinedKeyword;
	typescript$3.TSUnionType = TSUnionType;
	typescript$3.TSUnknownKeyword = TSUnknownKeyword;
	typescript$3.TSVoidKeyword = TSVoidKeyword;
	typescript$3.tsPrintClassMemberModifiers = tsPrintClassMemberModifiers;
	typescript$3.tsPrintFunctionOrConstructorType = tsPrintFunctionOrConstructorType;
	typescript$3.tsPrintPropertyOrMethodName = tsPrintPropertyOrMethodName;
	typescript$3.tsPrintSignatureDeclarationBase = tsPrintSignatureDeclarationBase;
	typescript$3.tsPrintTypeLiteralOrInterfaceBody = tsPrintTypeLiteralOrInterfaceBody;
	function TSTypeAnnotation(node) {
	  this.tokenChar(58);
	  this.space();
	  if (node.optional) this.tokenChar(63);
	  this.print(node.typeAnnotation, node);
	}
	function TSTypeParameterInstantiation(node, parent) {
	  this.tokenChar(60);
	  this.printList(node.params, node, {});
	  if (parent.type === "ArrowFunctionExpression" && node.params.length === 1) {
	    this.tokenChar(44);
	  }
	  this.tokenChar(62);
	}
	function TSTypeParameter(node) {
	  if (node.in) {
	    this.word("in");
	    this.space();
	  }
	  if (node.out) {
	    this.word("out");
	    this.space();
	  }
	  this.word(node.name);
	  if (node.constraint) {
	    this.space();
	    this.word("extends");
	    this.space();
	    this.print(node.constraint, node);
	  }
	  if (node.default) {
	    this.space();
	    this.tokenChar(61);
	    this.space();
	    this.print(node.default, node);
	  }
	}
	function TSParameterProperty(node) {
	  if (node.accessibility) {
	    this.word(node.accessibility);
	    this.space();
	  }
	  if (node.readonly) {
	    this.word("readonly");
	    this.space();
	  }
	  this._param(node.parameter);
	}
	function TSDeclareFunction(node, parent) {
	  if (node.declare) {
	    this.word("declare");
	    this.space();
	  }
	  this._functionHead(node, parent);
	  this.tokenChar(59);
	}
	function TSDeclareMethod(node) {
	  this._classMethodHead(node);
	  this.tokenChar(59);
	}
	function TSQualifiedName(node) {
	  this.print(node.left, node);
	  this.tokenChar(46);
	  this.print(node.right, node);
	}
	function TSCallSignatureDeclaration(node) {
	  this.tsPrintSignatureDeclarationBase(node);
	  this.tokenChar(59);
	}
	function TSConstructSignatureDeclaration(node) {
	  this.word("new");
	  this.space();
	  this.tsPrintSignatureDeclarationBase(node);
	  this.tokenChar(59);
	}
	function TSPropertySignature(node) {
	  const {
	    readonly
	  } = node;
	  if (readonly) {
	    this.word("readonly");
	    this.space();
	  }
	  this.tsPrintPropertyOrMethodName(node);
	  this.print(node.typeAnnotation, node);
	  this.tokenChar(59);
	}
	function tsPrintPropertyOrMethodName(node) {
	  if (node.computed) {
	    this.tokenChar(91);
	  }
	  this.print(node.key, node);
	  if (node.computed) {
	    this.tokenChar(93);
	  }
	  if (node.optional) {
	    this.tokenChar(63);
	  }
	}
	function TSMethodSignature(node) {
	  const {
	    kind
	  } = node;
	  if (kind === "set" || kind === "get") {
	    this.word(kind);
	    this.space();
	  }
	  this.tsPrintPropertyOrMethodName(node);
	  this.tsPrintSignatureDeclarationBase(node);
	  this.tokenChar(59);
	}
	function TSIndexSignature(node) {
	  const {
	    readonly,
	    static: isStatic
	  } = node;
	  if (isStatic) {
	    this.word("static");
	    this.space();
	  }
	  if (readonly) {
	    this.word("readonly");
	    this.space();
	  }
	  this.tokenChar(91);
	  this._parameters(node.parameters, node);
	  this.tokenChar(93);
	  this.print(node.typeAnnotation, node);
	  this.tokenChar(59);
	}
	function TSAnyKeyword() {
	  this.word("any");
	}
	function TSBigIntKeyword() {
	  this.word("bigint");
	}
	function TSUnknownKeyword() {
	  this.word("unknown");
	}
	function TSNumberKeyword() {
	  this.word("number");
	}
	function TSObjectKeyword() {
	  this.word("object");
	}
	function TSBooleanKeyword() {
	  this.word("boolean");
	}
	function TSStringKeyword() {
	  this.word("string");
	}
	function TSSymbolKeyword() {
	  this.word("symbol");
	}
	function TSVoidKeyword() {
	  this.word("void");
	}
	function TSUndefinedKeyword() {
	  this.word("undefined");
	}
	function TSNullKeyword() {
	  this.word("null");
	}
	function TSNeverKeyword() {
	  this.word("never");
	}
	function TSIntrinsicKeyword() {
	  this.word("intrinsic");
	}
	function TSThisType() {
	  this.word("this");
	}
	function TSFunctionType(node) {
	  this.tsPrintFunctionOrConstructorType(node);
	}
	function TSConstructorType(node) {
	  if (node.abstract) {
	    this.word("abstract");
	    this.space();
	  }
	  this.word("new");
	  this.space();
	  this.tsPrintFunctionOrConstructorType(node);
	}
	function tsPrintFunctionOrConstructorType(node) {
	  const {
	    typeParameters
	  } = node;
	  const parameters = node.parameters;
	  this.print(typeParameters, node);
	  this.tokenChar(40);
	  this._parameters(parameters, node);
	  this.tokenChar(41);
	  this.space();
	  this.token("=>");
	  this.space();
	  const returnType = node.typeAnnotation;
	  this.print(returnType.typeAnnotation, node);
	}
	function TSTypeReference(node) {
	  this.print(node.typeName, node, true);
	  this.print(node.typeParameters, node, true);
	}
	function TSTypePredicate(node) {
	  if (node.asserts) {
	    this.word("asserts");
	    this.space();
	  }
	  this.print(node.parameterName);
	  if (node.typeAnnotation) {
	    this.space();
	    this.word("is");
	    this.space();
	    this.print(node.typeAnnotation.typeAnnotation);
	  }
	}
	function TSTypeQuery(node) {
	  this.word("typeof");
	  this.space();
	  this.print(node.exprName);
	  if (node.typeParameters) {
	    this.print(node.typeParameters, node);
	  }
	}
	function TSTypeLiteral(node) {
	  this.tsPrintTypeLiteralOrInterfaceBody(node.members, node);
	}
	function tsPrintTypeLiteralOrInterfaceBody(members, node) {
	  tsPrintBraced(this, members, node);
	}
	function tsPrintBraced(printer, members, node) {
	  printer.token("{");
	  if (members.length) {
	    printer.indent();
	    printer.newline();
	    for (const member of members) {
	      printer.print(member, node);
	      printer.newline();
	    }
	    printer.dedent();
	  }
	  printer.rightBrace(node);
	}
	function TSArrayType(node) {
	  this.print(node.elementType, node, true);
	  this.token("[]");
	}
	function TSTupleType(node) {
	  this.tokenChar(91);
	  this.printList(node.elementTypes, node);
	  this.tokenChar(93);
	}
	function TSOptionalType(node) {
	  this.print(node.typeAnnotation, node);
	  this.tokenChar(63);
	}
	function TSRestType(node) {
	  this.token("...");
	  this.print(node.typeAnnotation, node);
	}
	function TSNamedTupleMember(node) {
	  this.print(node.label, node);
	  if (node.optional) this.tokenChar(63);
	  this.tokenChar(58);
	  this.space();
	  this.print(node.elementType, node);
	}
	function TSUnionType(node) {
	  tsPrintUnionOrIntersectionType(this, node, "|");
	}
	function TSIntersectionType(node) {
	  tsPrintUnionOrIntersectionType(this, node, "&");
	}
	function tsPrintUnionOrIntersectionType(printer, node, sep) {
	  printer.printJoin(node.types, node, {
	    separator() {
	      this.space();
	      this.token(sep);
	      this.space();
	    }
	  });
	}
	function TSConditionalType(node) {
	  this.print(node.checkType);
	  this.space();
	  this.word("extends");
	  this.space();
	  this.print(node.extendsType);
	  this.space();
	  this.tokenChar(63);
	  this.space();
	  this.print(node.trueType);
	  this.space();
	  this.tokenChar(58);
	  this.space();
	  this.print(node.falseType);
	}
	function TSInferType(node) {
	  this.token("infer");
	  this.space();
	  this.print(node.typeParameter);
	}
	function TSParenthesizedType(node) {
	  this.tokenChar(40);
	  this.print(node.typeAnnotation, node);
	  this.tokenChar(41);
	}
	function TSTypeOperator(node) {
	  this.word(node.operator);
	  this.space();
	  this.print(node.typeAnnotation, node);
	}
	function TSIndexedAccessType(node) {
	  this.print(node.objectType, node, true);
	  this.tokenChar(91);
	  this.print(node.indexType, node);
	  this.tokenChar(93);
	}
	function TSMappedType(node) {
	  const {
	    nameType,
	    optional,
	    readonly,
	    typeParameter,
	    typeAnnotation
	  } = node;
	  this.tokenChar(123);
	  this.space();
	  if (readonly) {
	    tokenIfPlusMinus(this, readonly);
	    this.word("readonly");
	    this.space();
	  }
	  this.tokenChar(91);
	  this.word(typeParameter.name);
	  this.space();
	  this.word("in");
	  this.space();
	  this.print(typeParameter.constraint, typeParameter);
	  if (nameType) {
	    this.space();
	    this.word("as");
	    this.space();
	    this.print(nameType, node);
	  }
	  this.tokenChar(93);
	  if (optional) {
	    tokenIfPlusMinus(this, optional);
	    this.tokenChar(63);
	  }
	  if (typeAnnotation) {
	    this.tokenChar(58);
	    this.space();
	    this.print(typeAnnotation, node);
	  }
	  this.space();
	  this.tokenChar(125);
	}
	function tokenIfPlusMinus(self, tok) {
	  if (tok !== true) {
	    self.token(tok);
	  }
	}
	function TSLiteralType(node) {
	  this.print(node.literal, node);
	}
	function TSExpressionWithTypeArguments(node) {
	  this.print(node.expression, node);
	  this.print(node.typeParameters, node);
	}
	function TSInterfaceDeclaration(node) {
	  const {
	    declare,
	    id,
	    typeParameters,
	    extends: extendz,
	    body
	  } = node;
	  if (declare) {
	    this.word("declare");
	    this.space();
	  }
	  this.word("interface");
	  this.space();
	  this.print(id, node);
	  this.print(typeParameters, node);
	  if (extendz != null && extendz.length) {
	    this.space();
	    this.word("extends");
	    this.space();
	    this.printList(extendz, node);
	  }
	  this.space();
	  this.print(body, node);
	}
	function TSInterfaceBody(node) {
	  this.tsPrintTypeLiteralOrInterfaceBody(node.body, node);
	}
	function TSTypeAliasDeclaration(node) {
	  const {
	    declare,
	    id,
	    typeParameters,
	    typeAnnotation
	  } = node;
	  if (declare) {
	    this.word("declare");
	    this.space();
	  }
	  this.word("type");
	  this.space();
	  this.print(id, node);
	  this.print(typeParameters, node);
	  this.space();
	  this.tokenChar(61);
	  this.space();
	  this.print(typeAnnotation, node);
	  this.tokenChar(59);
	}
	function TSTypeExpression(node) {
	  var _expression$trailingC;
	  const {
	    type,
	    expression,
	    typeAnnotation
	  } = node;
	  const forceParens = !!((_expression$trailingC = expression.trailingComments) != null && _expression$trailingC.length);
	  this.print(expression, node, true, undefined, forceParens);
	  this.space();
	  this.word(type === "TSAsExpression" ? "as" : "satisfies");
	  this.space();
	  this.print(typeAnnotation, node);
	}
	function TSTypeAssertion(node) {
	  const {
	    typeAnnotation,
	    expression
	  } = node;
	  this.tokenChar(60);
	  this.print(typeAnnotation, node);
	  this.tokenChar(62);
	  this.space();
	  this.print(expression, node);
	}
	function TSInstantiationExpression(node) {
	  this.print(node.expression, node);
	  this.print(node.typeParameters, node);
	}
	function TSEnumDeclaration(node) {
	  const {
	    declare,
	    const: isConst,
	    id,
	    members
	  } = node;
	  if (declare) {
	    this.word("declare");
	    this.space();
	  }
	  if (isConst) {
	    this.word("const");
	    this.space();
	  }
	  this.word("enum");
	  this.space();
	  this.print(id, node);
	  this.space();
	  tsPrintBraced(this, members, node);
	}
	function TSEnumMember(node) {
	  const {
	    id,
	    initializer
	  } = node;
	  this.print(id, node);
	  if (initializer) {
	    this.space();
	    this.tokenChar(61);
	    this.space();
	    this.print(initializer, node);
	  }
	  this.tokenChar(44);
	}
	function TSModuleDeclaration(node) {
	  const {
	    declare,
	    id
	  } = node;
	  if (declare) {
	    this.word("declare");
	    this.space();
	  }
	  if (!node.global) {
	    this.word(id.type === "Identifier" ? "namespace" : "module");
	    this.space();
	  }
	  this.print(id, node);
	  if (!node.body) {
	    this.tokenChar(59);
	    return;
	  }
	  let body = node.body;
	  while (body.type === "TSModuleDeclaration") {
	    this.tokenChar(46);
	    this.print(body.id, body);
	    body = body.body;
	  }
	  this.space();
	  this.print(body, node);
	}
	function TSModuleBlock(node) {
	  tsPrintBraced(this, node.body, node);
	}
	function TSImportType(node) {
	  const {
	    argument,
	    qualifier,
	    typeParameters
	  } = node;
	  this.word("import");
	  this.tokenChar(40);
	  this.print(argument, node);
	  this.tokenChar(41);
	  if (qualifier) {
	    this.tokenChar(46);
	    this.print(qualifier, node);
	  }
	  if (typeParameters) {
	    this.print(typeParameters, node);
	  }
	}
	function TSImportEqualsDeclaration(node) {
	  const {
	    isExport,
	    id,
	    moduleReference
	  } = node;
	  if (isExport) {
	    this.word("export");
	    this.space();
	  }
	  this.word("import");
	  this.space();
	  this.print(id, node);
	  this.space();
	  this.tokenChar(61);
	  this.space();
	  this.print(moduleReference, node);
	  this.tokenChar(59);
	}
	function TSExternalModuleReference(node) {
	  this.token("require(");
	  this.print(node.expression, node);
	  this.tokenChar(41);
	}
	function TSNonNullExpression(node) {
	  this.print(node.expression, node);
	  this.tokenChar(33);
	}
	function TSExportAssignment(node) {
	  this.word("export");
	  this.space();
	  this.tokenChar(61);
	  this.space();
	  this.print(node.expression, node);
	  this.tokenChar(59);
	}
	function TSNamespaceExportDeclaration(node) {
	  this.word("export");
	  this.space();
	  this.word("as");
	  this.space();
	  this.word("namespace");
	  this.space();
	  this.print(node.id, node);
	}
	function tsPrintSignatureDeclarationBase(node) {
	  const {
	    typeParameters
	  } = node;
	  const parameters = node.parameters;
	  this.print(typeParameters, node);
	  this.tokenChar(40);
	  this._parameters(parameters, node);
	  this.tokenChar(41);
	  const returnType = node.typeAnnotation;
	  this.print(returnType, node);
	}
	function tsPrintClassMemberModifiers(node) {
	  const isField = node.type === "ClassAccessorProperty" || node.type === "ClassProperty";
	  if (isField && node.declare) {
	    this.word("declare");
	    this.space();
	  }
	  if (node.accessibility) {
	    this.word(node.accessibility);
	    this.space();
	  }
	  if (node.static) {
	    this.word("static");
	    this.space();
	  }
	  if (node.override) {
	    this.word("override");
	    this.space();
	  }
	  if (node.abstract) {
	    this.word("abstract");
	    this.space();
	  }
	  if (isField && node.readonly) {
	    this.word("readonly");
	    this.space();
	  }
	}

	
	return typescript$3;
}

var hasRequiredGenerators;

function requireGenerators () {
	if (hasRequiredGenerators) return generators;
	hasRequiredGenerators = 1;
	(function (exports) {

		Object.defineProperty(exports, "__esModule", {
		  value: true
		});
		var _templateLiterals = requireTemplateLiterals();
		Object.keys(_templateLiterals).forEach(function (key) {
		  if (key === "default" || key === "__esModule") return;
		  if (key in exports && exports[key] === _templateLiterals[key]) return;
		  Object.defineProperty(exports, key, {
		    enumerable: true,
		    get: function () {
		      return _templateLiterals[key];
		    }
		  });
		});
		var _expressions = requireExpressions();
		Object.keys(_expressions).forEach(function (key) {
		  if (key === "default" || key === "__esModule") return;
		  if (key in exports && exports[key] === _expressions[key]) return;
		  Object.defineProperty(exports, key, {
		    enumerable: true,
		    get: function () {
		      return _expressions[key];
		    }
		  });
		});
		var _statements = requireStatements();
		Object.keys(_statements).forEach(function (key) {
		  if (key === "default" || key === "__esModule") return;
		  if (key in exports && exports[key] === _statements[key]) return;
		  Object.defineProperty(exports, key, {
		    enumerable: true,
		    get: function () {
		      return _statements[key];
		    }
		  });
		});
		var _classes = requireClasses();
		Object.keys(_classes).forEach(function (key) {
		  if (key === "default" || key === "__esModule") return;
		  if (key in exports && exports[key] === _classes[key]) return;
		  Object.defineProperty(exports, key, {
		    enumerable: true,
		    get: function () {
		      return _classes[key];
		    }
		  });
		});
		var _methods = requireMethods();
		Object.keys(_methods).forEach(function (key) {
		  if (key === "default" || key === "__esModule") return;
		  if (key in exports && exports[key] === _methods[key]) return;
		  Object.defineProperty(exports, key, {
		    enumerable: true,
		    get: function () {
		      return _methods[key];
		    }
		  });
		});
		var _modules = requireModules();
		Object.keys(_modules).forEach(function (key) {
		  if (key === "default" || key === "__esModule") return;
		  if (key in exports && exports[key] === _modules[key]) return;
		  Object.defineProperty(exports, key, {
		    enumerable: true,
		    get: function () {
		      return _modules[key];
		    }
		  });
		});
		var _types = requireTypes();
		Object.keys(_types).forEach(function (key) {
		  if (key === "default" || key === "__esModule") return;
		  if (key in exports && exports[key] === _types[key]) return;
		  Object.defineProperty(exports, key, {
		    enumerable: true,
		    get: function () {
		      return _types[key];
		    }
		  });
		});
		var _flow = requireFlow();
		Object.keys(_flow).forEach(function (key) {
		  if (key === "default" || key === "__esModule") return;
		  if (key in exports && exports[key] === _flow[key]) return;
		  Object.defineProperty(exports, key, {
		    enumerable: true,
		    get: function () {
		      return _flow[key];
		    }
		  });
		});
		var _base = requireBase();
		Object.keys(_base).forEach(function (key) {
		  if (key === "default" || key === "__esModule") return;
		  if (key in exports && exports[key] === _base[key]) return;
		  Object.defineProperty(exports, key, {
		    enumerable: true,
		    get: function () {
		      return _base[key];
		    }
		  });
		});
		var _jsx = requireJsx();
		Object.keys(_jsx).forEach(function (key) {
		  if (key === "default" || key === "__esModule") return;
		  if (key in exports && exports[key] === _jsx[key]) return;
		  Object.defineProperty(exports, key, {
		    enumerable: true,
		    get: function () {
		      return _jsx[key];
		    }
		  });
		});
		var _typescript = requireTypescript();
		Object.keys(_typescript).forEach(function (key) {
		  if (key === "default" || key === "__esModule") return;
		  if (key in exports && exports[key] === _typescript[key]) return;
		  Object.defineProperty(exports, key, {
		    enumerable: true,
		    get: function () {
		      return _typescript[key];
		    }
		  });
		});

		
	} (generators));
	return generators;
}

var hasRequiredPrinter;

function requirePrinter () {
	if (hasRequiredPrinter) return printer$1;
	hasRequiredPrinter = 1;

	Object.defineProperty(printer$1, "__esModule", {
	  value: true
	});
	printer$1.default = void 0;
	var _buffer = requireBuffer();
	var n = requireNode$1();
	var _t = requireLib$h();
	var generatorFunctions = requireGenerators();
	const {
	  isFunction,
	  isStatement,
	  isClassBody,
	  isTSInterfaceBody,
	  isTSEnumDeclaration
	} = _t;
	const SCIENTIFIC_NOTATION = /e/i;
	const ZERO_DECIMAL_INTEGER = /\.0+$/;
	const HAS_NEWLINE = /[\n\r\u2028\u2029]/;
	const HAS_NEWLINE_OR_BlOCK_COMMENT_END = /[\n\r\u2028\u2029]|\*\//;
	const {
	  needsParens
	} = n;
	class Printer {
	  constructor(format, map) {
	    this.inForStatementInitCounter = 0;
	    this._printStack = [];
	    this._indent = 0;
	    this._indentRepeat = 0;
	    this._insideAux = false;
	    this._parenPushNewlineState = null;
	    this._noLineTerminator = false;
	    this._printAuxAfterOnNextUserNode = false;
	    this._printedComments = new Set();
	    this._endsWithInteger = false;
	    this._endsWithWord = false;
	    this._lastCommentLine = 0;
	    this._endsWithInnerRaw = false;
	    this._indentInnerComments = true;
	    this.format = format;
	    this._indentRepeat = format.indent.style.length;
	    this._inputMap = map == null ? void 0 : map._inputMap;
	    this._buf = new _buffer.default(map, format.indent.style[0]);
	  }
	  generate(ast) {
	    this.print(ast);
	    this._maybeAddAuxComment();
	    return this._buf.get();
	  }
	  indent() {
	    if (this.format.compact || this.format.concise) return;
	    this._indent++;
	  }
	  dedent() {
	    if (this.format.compact || this.format.concise) return;
	    this._indent--;
	  }
	  semicolon(force = false) {
	    this._maybeAddAuxComment();
	    if (force) {
	      this._appendChar(59);
	    } else {
	      this._queue(59);
	    }
	    this._noLineTerminator = false;
	  }
	  rightBrace(node) {
	    if (this.format.minified) {
	      this._buf.removeLastSemicolon();
	    }
	    this.sourceWithOffset("end", node.loc, -1);
	    this.tokenChar(125);
	  }
	  rightParens(node) {
	    this.sourceWithOffset("end", node.loc, -1);
	    this.tokenChar(41);
	  }
	  space(force = false) {
	    if (this.format.compact) return;
	    if (force) {
	      this._space();
	    } else if (this._buf.hasContent()) {
	      const lastCp = this.getLastChar();
	      if (lastCp !== 32 && lastCp !== 10) {
	        this._space();
	      }
	    }
	  }
	  word(str, noLineTerminatorAfter = false) {
	    this._maybePrintInnerComments();
	    if (this._endsWithWord || str.charCodeAt(0) === 47 && this.endsWith(47)) {
	      this._space();
	    }
	    this._maybeAddAuxComment();
	    this._append(str, false);
	    this._endsWithWord = true;
	    this._noLineTerminator = noLineTerminatorAfter;
	  }
	  number(str, number) {
	    function isNonDecimalLiteral(str) {
	      if (str.length > 2 && str.charCodeAt(0) === 48) {
	        const secondChar = str.charCodeAt(1);
	        return secondChar === 98 || secondChar === 111 || secondChar === 120;
	      }
	      return false;
	    }
	    this.word(str);
	    this._endsWithInteger = Number.isInteger(number) && !isNonDecimalLiteral(str) && !SCIENTIFIC_NOTATION.test(str) && !ZERO_DECIMAL_INTEGER.test(str) && str.charCodeAt(str.length - 1) !== 46;
	  }
	  token(str, maybeNewline = false) {
	    this._maybePrintInnerComments();
	    const lastChar = this.getLastChar();
	    const strFirst = str.charCodeAt(0);
	    if (lastChar === 33 && (str === "--" || strFirst === 61) || strFirst === 43 && lastChar === 43 || strFirst === 45 && lastChar === 45 || strFirst === 46 && this._endsWithInteger) {
	      this._space();
	    }
	    this._maybeAddAuxComment();
	    this._append(str, maybeNewline);
	    this._noLineTerminator = false;
	  }
	  tokenChar(char) {
	    this._maybePrintInnerComments();
	    const lastChar = this.getLastChar();
	    if (char === 43 && lastChar === 43 || char === 45 && lastChar === 45 || char === 46 && this._endsWithInteger) {
	      this._space();
	    }
	    this._maybeAddAuxComment();
	    this._appendChar(char);
	    this._noLineTerminator = false;
	  }
	  newline(i = 1, force) {
	    if (i <= 0) return;
	    if (!force) {
	      if (this.format.retainLines || this.format.compact) return;
	      if (this.format.concise) {
	        this.space();
	        return;
	      }
	    }
	    if (i > 2) i = 2;
	    i -= this._buf.getNewlineCount();
	    for (let j = 0; j < i; j++) {
	      this._newline();
	    }
	    return;
	  }
	  endsWith(char) {
	    return this.getLastChar() === char;
	  }
	  getLastChar() {
	    return this._buf.getLastChar();
	  }
	  endsWithCharAndNewline() {
	    return this._buf.endsWithCharAndNewline();
	  }
	  removeTrailingNewline() {
	    this._buf.removeTrailingNewline();
	  }
	  exactSource(loc, cb) {
	    if (!loc) {
	      cb();
	      return;
	    }
	    this._catchUp("start", loc);
	    this._buf.exactSource(loc, cb);
	  }
	  source(prop, loc) {
	    if (!loc) return;
	    this._catchUp(prop, loc);
	    this._buf.source(prop, loc);
	  }
	  sourceWithOffset(prop, loc, columnOffset) {
	    if (!loc) return;
	    this._catchUp(prop, loc);
	    this._buf.sourceWithOffset(prop, loc, columnOffset);
	  }
	  withSource(prop, loc, cb) {
	    if (!loc) {
	      cb();
	      return;
	    }
	    this._catchUp(prop, loc);
	    this._buf.withSource(prop, loc, cb);
	  }
	  sourceIdentifierName(identifierName, pos) {
	    if (!this._buf._canMarkIdName) return;
	    const sourcePosition = this._buf._sourcePosition;
	    sourcePosition.identifierNamePos = pos;
	    sourcePosition.identifierName = identifierName;
	  }
	  _space() {
	    this._queue(32);
	  }
	  _newline() {
	    this._queue(10);
	  }
	  _append(str, maybeNewline) {
	    this._maybeAddParen(str);
	    this._maybeIndent(str.charCodeAt(0));
	    this._buf.append(str, maybeNewline);
	    this._endsWithWord = false;
	    this._endsWithInteger = false;
	  }
	  _appendChar(char) {
	    this._maybeAddParenChar(char);
	    this._maybeIndent(char);
	    this._buf.appendChar(char);
	    this._endsWithWord = false;
	    this._endsWithInteger = false;
	  }
	  _queue(char) {
	    this._maybeAddParenChar(char);
	    this._maybeIndent(char);
	    this._buf.queue(char);
	    this._endsWithWord = false;
	    this._endsWithInteger = false;
	  }
	  _maybeIndent(firstChar) {
	    if (this._indent && firstChar !== 10 && this.endsWith(10)) {
	      this._buf.queueIndentation(this._getIndent());
	    }
	  }
	  _shouldIndent(firstChar) {
	    if (this._indent && firstChar !== 10 && this.endsWith(10)) {
	      return true;
	    }
	  }
	  _maybeAddParenChar(char) {
	    const parenPushNewlineState = this._parenPushNewlineState;
	    if (!parenPushNewlineState) return;
	    if (char === 32) {
	      return;
	    }
	    if (char !== 10) {
	      this._parenPushNewlineState = null;
	      return;
	    }
	    this.tokenChar(40);
	    this.indent();
	    parenPushNewlineState.printed = true;
	  }
	  _maybeAddParen(str) {
	    const parenPushNewlineState = this._parenPushNewlineState;
	    if (!parenPushNewlineState) return;
	    const len = str.length;
	    let i;
	    for (i = 0; i < len && str.charCodeAt(i) === 32; i++) continue;
	    if (i === len) {
	      return;
	    }
	    const cha = str.charCodeAt(i);
	    if (cha !== 10) {
	      if (cha !== 47 || i + 1 === len) {
	        this._parenPushNewlineState = null;
	        return;
	      }
	      const chaPost = str.charCodeAt(i + 1);
	      if (chaPost === 42) {
	        return;
	      } else if (chaPost !== 47) {
	        this._parenPushNewlineState = null;
	        return;
	      }
	    }
	    this.tokenChar(40);
	    this.indent();
	    parenPushNewlineState.printed = true;
	  }
	  catchUp(line) {
	    if (!this.format.retainLines) return;
	    const count = line - this._buf.getCurrentLine();
	    for (let i = 0; i < count; i++) {
	      this._newline();
	    }
	  }
	  _catchUp(prop, loc) {
	    var _loc$prop;
	    if (!this.format.retainLines) return;
	    const line = loc == null || (_loc$prop = loc[prop]) == null ? void 0 : _loc$prop.line;
	    if (line != null) {
	      const count = line - this._buf.getCurrentLine();
	      for (let i = 0; i < count; i++) {
	        this._newline();
	      }
	    }
	  }
	  _getIndent() {
	    return this._indentRepeat * this._indent;
	  }
	  printTerminatorless(node, parent, isLabel) {
	    if (isLabel) {
	      this._noLineTerminator = true;
	      this.print(node, parent);
	    } else {
	      const terminatorState = {
	        printed: false
	      };
	      this._parenPushNewlineState = terminatorState;
	      this.print(node, parent);
	      if (terminatorState.printed) {
	        this.dedent();
	        this.newline();
	        this.tokenChar(41);
	      }
	    }
	  }
	  print(node, parent, noLineTerminatorAfter, trailingCommentsLineOffset, forceParens) {
	    var _node$extra, _node$leadingComments;
	    if (!node) return;
	    this._endsWithInnerRaw = false;
	    const nodeType = node.type;
	    const format = this.format;
	    const oldConcise = format.concise;
	    if (node._compact) {
	      format.concise = true;
	    }
	    const printMethod = this[nodeType];
	    if (printMethod === undefined) {
	      throw new ReferenceError(`unknown node of type ${JSON.stringify(nodeType)} with constructor ${JSON.stringify(node.constructor.name)}`);
	    }
	    this._printStack.push(node);
	    const oldInAux = this._insideAux;
	    this._insideAux = node.loc == null;
	    this._maybeAddAuxComment(this._insideAux && !oldInAux);
	    const parenthesized = (_node$extra = node.extra) == null ? void 0 : _node$extra.parenthesized;
	    let shouldPrintParens = forceParens || parenthesized && format.retainFunctionParens && nodeType === "FunctionExpression" || needsParens(node, parent, this._printStack);
	    if (!shouldPrintParens && parenthesized && (_node$leadingComments = node.leadingComments) != null && _node$leadingComments.length && node.leadingComments[0].type === "CommentBlock") {
	      const parentType = parent == null ? void 0 : parent.type;
	      switch (parentType) {
	        case "ExpressionStatement":
	        case "VariableDeclarator":
	        case "AssignmentExpression":
	        case "ReturnStatement":
	          break;
	        case "CallExpression":
	        case "OptionalCallExpression":
	        case "NewExpression":
	          if (parent.callee !== node) break;
	        default:
	          shouldPrintParens = true;
	      }
	    }
	    if (shouldPrintParens) {
	      this.tokenChar(40);
	      this._endsWithInnerRaw = false;
	    }
	    this._lastCommentLine = 0;
	    this._printLeadingComments(node, parent);
	    const loc = nodeType === "Program" || nodeType === "File" ? null : node.loc;
	    this.exactSource(loc, printMethod.bind(this, node, parent));
	    if (shouldPrintParens) {
	      this._printTrailingComments(node, parent);
	      this.tokenChar(41);
	      this._noLineTerminator = noLineTerminatorAfter;
	    } else if (noLineTerminatorAfter && !this._noLineTerminator) {
	      this._noLineTerminator = true;
	      this._printTrailingComments(node, parent);
	    } else {
	      this._printTrailingComments(node, parent, trailingCommentsLineOffset);
	    }
	    this._printStack.pop();
	    format.concise = oldConcise;
	    this._insideAux = oldInAux;
	    this._endsWithInnerRaw = false;
	  }
	  _maybeAddAuxComment(enteredPositionlessNode) {
	    if (enteredPositionlessNode) this._printAuxBeforeComment();
	    if (!this._insideAux) this._printAuxAfterComment();
	  }
	  _printAuxBeforeComment() {
	    if (this._printAuxAfterOnNextUserNode) return;
	    this._printAuxAfterOnNextUserNode = true;
	    const comment = this.format.auxiliaryCommentBefore;
	    if (comment) {
	      this._printComment({
	        type: "CommentBlock",
	        value: comment
	      }, 0);
	    }
	  }
	  _printAuxAfterComment() {
	    if (!this._printAuxAfterOnNextUserNode) return;
	    this._printAuxAfterOnNextUserNode = false;
	    const comment = this.format.auxiliaryCommentAfter;
	    if (comment) {
	      this._printComment({
	        type: "CommentBlock",
	        value: comment
	      }, 0);
	    }
	  }
	  getPossibleRaw(node) {
	    const extra = node.extra;
	    if ((extra == null ? void 0 : extra.raw) != null && extra.rawValue != null && node.value === extra.rawValue) {
	      return extra.raw;
	    }
	  }
	  printJoin(nodes, parent, opts = {}) {
	    if (!(nodes != null && nodes.length)) return;
	    let {
	      indent
	    } = opts;
	    if (indent == null && this.format.retainLines) {
	      var _nodes$0$loc;
	      const startLine = (_nodes$0$loc = nodes[0].loc) == null ? void 0 : _nodes$0$loc.start.line;
	      if (startLine != null && startLine !== this._buf.getCurrentLine()) {
	        indent = true;
	      }
	    }
	    if (indent) this.indent();
	    const newlineOpts = {
	      addNewlines: opts.addNewlines,
	      nextNodeStartLine: 0
	    };
	    const separator = opts.separator ? opts.separator.bind(this) : null;
	    const len = nodes.length;
	    for (let i = 0; i < len; i++) {
	      const node = nodes[i];
	      if (!node) continue;
	      if (opts.statement) this._printNewline(i === 0, newlineOpts);
	      this.print(node, parent, undefined, opts.trailingCommentsLineOffset || 0);
	      opts.iterator == null || opts.iterator(node, i);
	      if (i < len - 1) separator == null || separator();
	      if (opts.statement) {
	        var _node$trailingComment;
	        if (!((_node$trailingComment = node.trailingComments) != null && _node$trailingComment.length)) {
	          this._lastCommentLine = 0;
	        }
	        if (i + 1 === len) {
	          this.newline(1);
	        } else {
	          var _nextNode$loc;
	          const nextNode = nodes[i + 1];
	          newlineOpts.nextNodeStartLine = ((_nextNode$loc = nextNode.loc) == null ? void 0 : _nextNode$loc.start.line) || 0;
	          this._printNewline(true, newlineOpts);
	        }
	      }
	    }
	    if (indent) this.dedent();
	  }
	  printAndIndentOnComments(node, parent) {
	    const indent = node.leadingComments && node.leadingComments.length > 0;
	    if (indent) this.indent();
	    this.print(node, parent);
	    if (indent) this.dedent();
	  }
	  printBlock(parent) {
	    const node = parent.body;
	    if (node.type !== "EmptyStatement") {
	      this.space();
	    }
	    this.print(node, parent);
	  }
	  _printTrailingComments(node, parent, lineOffset) {
	    const {
	      innerComments,
	      trailingComments
	    } = node;
	    if (innerComments != null && innerComments.length) {
	      this._printComments(2, innerComments, node, parent, lineOffset);
	    }
	    if (trailingComments != null && trailingComments.length) {
	      this._printComments(2, trailingComments, node, parent, lineOffset);
	    }
	  }
	  _printLeadingComments(node, parent) {
	    const comments = node.leadingComments;
	    if (!(comments != null && comments.length)) return;
	    this._printComments(0, comments, node, parent);
	  }
	  _maybePrintInnerComments() {
	    if (this._endsWithInnerRaw) this.printInnerComments();
	    this._endsWithInnerRaw = true;
	    this._indentInnerComments = true;
	  }
	  printInnerComments() {
	    const node = this._printStack[this._printStack.length - 1];
	    const comments = node.innerComments;
	    if (!(comments != null && comments.length)) return;
	    const hasSpace = this.endsWith(32);
	    const indent = this._indentInnerComments;
	    const printedCommentsCount = this._printedComments.size;
	    if (indent) this.indent();
	    this._printComments(1, comments, node);
	    if (hasSpace && printedCommentsCount !== this._printedComments.size) {
	      this.space();
	    }
	    if (indent) this.dedent();
	  }
	  noIndentInnerCommentsHere() {
	    this._indentInnerComments = false;
	  }
	  printSequence(nodes, parent, opts = {}) {
	    var _opts$indent;
	    opts.statement = true;
	    (_opts$indent = opts.indent) != null ? _opts$indent : opts.indent = false;
	    this.printJoin(nodes, parent, opts);
	  }
	  printList(items, parent, opts = {}) {
	    if (opts.separator == null) {
	      opts.separator = commaSeparator;
	    }
	    this.printJoin(items, parent, opts);
	  }
	  _printNewline(newLine, opts) {
	    const format = this.format;
	    if (format.retainLines || format.compact) return;
	    if (format.concise) {
	      this.space();
	      return;
	    }
	    if (!newLine) {
	      return;
	    }
	    const startLine = opts.nextNodeStartLine;
	    const lastCommentLine = this._lastCommentLine;
	    if (startLine > 0 && lastCommentLine > 0) {
	      const offset = startLine - lastCommentLine;
	      if (offset >= 0) {
	        this.newline(offset || 1);
	        return;
	      }
	    }
	    if (this._buf.hasContent()) {
	      this.newline(1);
	    }
	  }
	  _shouldPrintComment(comment) {
	    if (comment.ignore) return 0;
	    if (this._printedComments.has(comment)) return 0;
	    if (this._noLineTerminator && HAS_NEWLINE_OR_BlOCK_COMMENT_END.test(comment.value)) {
	      return 2;
	    }
	    this._printedComments.add(comment);
	    if (!this.format.shouldPrintComment(comment.value)) {
	      return 0;
	    }
	    return 1;
	  }
	  _printComment(comment, skipNewLines) {
	    const noLineTerminator = this._noLineTerminator;
	    const isBlockComment = comment.type === "CommentBlock";
	    const printNewLines = isBlockComment && skipNewLines !== 1 && !this._noLineTerminator;
	    if (printNewLines && this._buf.hasContent() && skipNewLines !== 2) {
	      this.newline(1);
	    }
	    const lastCharCode = this.getLastChar();
	    if (lastCharCode !== 91 && lastCharCode !== 123) {
	      this.space();
	    }
	    let val;
	    if (isBlockComment) {
	      const {
	        _parenPushNewlineState
	      } = this;
	      if ((_parenPushNewlineState == null ? void 0 : _parenPushNewlineState.printed) === false && HAS_NEWLINE.test(comment.value)) {
	        this.tokenChar(40);
	        this.indent();
	        _parenPushNewlineState.printed = true;
	      }
	      val = `/*${comment.value}*/`;
	      if (this.format.indent.adjustMultilineComment) {
	        var _comment$loc;
	        const offset = (_comment$loc = comment.loc) == null ? void 0 : _comment$loc.start.column;
	        if (offset) {
	          const newlineRegex = new RegExp("\\n\\s{1," + offset + "}", "g");
	          val = val.replace(newlineRegex, "\n");
	        }
	        if (this.format.concise) {
	          val = val.replace(/\n(?!$)/g, `\n`);
	        } else {
	          let indentSize = this.format.retainLines ? 0 : this._buf.getCurrentColumn();
	          if (this._shouldIndent(47) || this.format.retainLines) {
	            indentSize += this._getIndent();
	          }
	          val = val.replace(/\n(?!$)/g, `\n${" ".repeat(indentSize)}`);
	        }
	      }
	    } else if (!noLineTerminator) {
	      val = `//${comment.value}`;
	    } else {
	      val = `/*${comment.value}*/`;
	    }
	    if (this.endsWith(47)) this._space();
	    this.source("start", comment.loc);
	    this._append(val, isBlockComment);
	    if (!isBlockComment && !noLineTerminator) {
	      this.newline(1, true);
	    }
	    if (printNewLines && skipNewLines !== 3) {
	      this.newline(1);
	    }
	  }
	  _printComments(type, comments, node, parent, lineOffset = 0) {
	    const nodeLoc = node.loc;
	    const len = comments.length;
	    let hasLoc = !!nodeLoc;
	    const nodeStartLine = hasLoc ? nodeLoc.start.line : 0;
	    const nodeEndLine = hasLoc ? nodeLoc.end.line : 0;
	    let lastLine = 0;
	    let leadingCommentNewline = 0;
	    const maybeNewline = this._noLineTerminator ? function () {} : this.newline.bind(this);
	    for (let i = 0; i < len; i++) {
	      const comment = comments[i];
	      const shouldPrint = this._shouldPrintComment(comment);
	      if (shouldPrint === 2) {
	        hasLoc = false;
	        break;
	      }
	      if (hasLoc && comment.loc && shouldPrint === 1) {
	        const commentStartLine = comment.loc.start.line;
	        const commentEndLine = comment.loc.end.line;
	        if (type === 0) {
	          let offset = 0;
	          if (i === 0) {
	            if (this._buf.hasContent() && (comment.type === "CommentLine" || commentStartLine !== commentEndLine)) {
	              offset = leadingCommentNewline = 1;
	            }
	          } else {
	            offset = commentStartLine - lastLine;
	          }
	          lastLine = commentEndLine;
	          maybeNewline(offset);
	          this._printComment(comment, 1);
	          if (i + 1 === len) {
	            maybeNewline(Math.max(nodeStartLine - lastLine, leadingCommentNewline));
	            lastLine = nodeStartLine;
	          }
	        } else if (type === 1) {
	          const offset = commentStartLine - (i === 0 ? nodeStartLine : lastLine);
	          lastLine = commentEndLine;
	          maybeNewline(offset);
	          this._printComment(comment, 1);
	          if (i + 1 === len) {
	            maybeNewline(Math.min(1, nodeEndLine - lastLine));
	            lastLine = nodeEndLine;
	          }
	        } else {
	          const offset = commentStartLine - (i === 0 ? nodeEndLine - lineOffset : lastLine);
	          lastLine = commentEndLine;
	          maybeNewline(offset);
	          this._printComment(comment, 1);
	        }
	      } else {
	        hasLoc = false;
	        if (shouldPrint !== 1) {
	          continue;
	        }
	        if (len === 1) {
	          const singleLine = comment.loc ? comment.loc.start.line === comment.loc.end.line : !HAS_NEWLINE.test(comment.value);
	          const shouldSkipNewline = singleLine && !isStatement(node) && !isClassBody(parent) && !isTSInterfaceBody(parent) && !isTSEnumDeclaration(parent);
	          if (type === 0) {
	            this._printComment(comment, shouldSkipNewline && node.type !== "ObjectExpression" || singleLine && isFunction(parent, {
	              body: node
	            }) ? 1 : 0);
	          } else if (shouldSkipNewline && type === 2) {
	            this._printComment(comment, 1);
	          } else {
	            this._printComment(comment, 0);
	          }
	        } else if (type === 1 && !(node.type === "ObjectExpression" && node.properties.length > 1) && node.type !== "ClassBody" && node.type !== "TSInterfaceBody") {
	          this._printComment(comment, i === 0 ? 2 : i === len - 1 ? 3 : 0);
	        } else {
	          this._printComment(comment, 0);
	        }
	      }
	    }
	    if (type === 2 && hasLoc && lastLine) {
	      this._lastCommentLine = lastLine;
	    }
	  }
	}
	Object.assign(Printer.prototype, generatorFunctions);
	{
	  Printer.prototype.Noop = function Noop() {};
	}
	printer$1.default = Printer;
	function commaSeparator() {
	  this.tokenChar(44);
	  this.space();
	}

	
	return printer$1;
}

var hasRequiredLib$e;

function requireLib$e () {
	if (hasRequiredLib$e) return lib$b;
	hasRequiredLib$e = 1;

	Object.defineProperty(lib$b, "__esModule", {
	  value: true
	});
	lib$b.default = generate;
	var _sourceMap = requireSourceMap();
	var _printer = requirePrinter();
	function normalizeOptions(code, opts) {
	  var _opts$recordAndTupleS;
	  const format = {
	    auxiliaryCommentBefore: opts.auxiliaryCommentBefore,
	    auxiliaryCommentAfter: opts.auxiliaryCommentAfter,
	    shouldPrintComment: opts.shouldPrintComment,
	    retainLines: opts.retainLines,
	    retainFunctionParens: opts.retainFunctionParens,
	    comments: opts.comments == null || opts.comments,
	    compact: opts.compact,
	    minified: opts.minified,
	    concise: opts.concise,
	    indent: {
	      adjustMultilineComment: true,
	      style: "  "
	    },
	    jsescOption: Object.assign({
	      quotes: "double",
	      wrap: true,
	      minimal: false
	    }, opts.jsescOption),
	    recordAndTupleSyntaxType: (_opts$recordAndTupleS = opts.recordAndTupleSyntaxType) != null ? _opts$recordAndTupleS : "hash",
	    topicToken: opts.topicToken,
	    importAttributesKeyword: opts.importAttributesKeyword
	  };
	  {
	    format.decoratorsBeforeExport = opts.decoratorsBeforeExport;
	    format.jsescOption.json = opts.jsonCompatibleStrings;
	  }
	  if (format.minified) {
	    format.compact = true;
	    format.shouldPrintComment = format.shouldPrintComment || (() => format.comments);
	  } else {
	    format.shouldPrintComment = format.shouldPrintComment || (value => format.comments || value.includes("@license") || value.includes("@preserve"));
	  }
	  if (format.compact === "auto") {
	    format.compact = typeof code === "string" && code.length > 500000;
	    if (format.compact) {
	      console.error("[BABEL] Note: The code generator has deoptimised the styling of " + `${opts.filename} as it exceeds the max of ${"500KB"}.`);
	    }
	  }
	  if (format.compact) {
	    format.indent.adjustMultilineComment = false;
	  }
	  const {
	    auxiliaryCommentBefore,
	    auxiliaryCommentAfter,
	    shouldPrintComment
	  } = format;
	  if (auxiliaryCommentBefore && !shouldPrintComment(auxiliaryCommentBefore)) {
	    format.auxiliaryCommentBefore = undefined;
	  }
	  if (auxiliaryCommentAfter && !shouldPrintComment(auxiliaryCommentAfter)) {
	    format.auxiliaryCommentAfter = undefined;
	  }
	  return format;
	}
	{
	  lib$b.CodeGenerator = class CodeGenerator {
	    constructor(ast, opts = {}, code) {
	      this._ast = void 0;
	      this._format = void 0;
	      this._map = void 0;
	      this._ast = ast;
	      this._format = normalizeOptions(code, opts);
	      this._map = opts.sourceMaps ? new _sourceMap.default(opts, code) : null;
	    }
	    generate() {
	      const printer = new _printer.default(this._format, this._map);
	      return printer.generate(this._ast);
	    }
	  };
	}
	function generate(ast, opts = {}, code) {
	  const format = normalizeOptions(code, opts);
	  const map = opts.sourceMaps ? new _sourceMap.default(opts, code) : null;
	  const printer = new _printer.default(format, map);
	  return printer.generate(ast);
	}

	
	return lib$b;
}

var ancestry = {};

var hasRequiredAncestry;

function requireAncestry () {
	if (hasRequiredAncestry) return ancestry;
	hasRequiredAncestry = 1;

	Object.defineProperty(ancestry, "__esModule", {
	  value: true
	});
	ancestry.find = find;
	ancestry.findParent = findParent;
	ancestry.getAncestry = getAncestry;
	ancestry.getDeepestCommonAncestorFrom = getDeepestCommonAncestorFrom;
	ancestry.getEarliestCommonAncestorFrom = getEarliestCommonAncestorFrom;
	ancestry.getFunctionParent = getFunctionParent;
	ancestry.getStatementParent = getStatementParent;
	ancestry.inType = inType;
	ancestry.isAncestor = isAncestor;
	ancestry.isDescendant = isDescendant;
	var _t = requireLib$h();
	const {
	  VISITOR_KEYS
	} = _t;
	function findParent(callback) {
	  let path = this;
	  while (path = path.parentPath) {
	    if (callback(path)) return path;
	  }
	  return null;
	}
	function find(callback) {
	  let path = this;
	  do {
	    if (callback(path)) return path;
	  } while (path = path.parentPath);
	  return null;
	}
	function getFunctionParent() {
	  return this.findParent(p => p.isFunction());
	}
	function getStatementParent() {
	  let path = this;
	  do {
	    if (!path.parentPath || Array.isArray(path.container) && path.isStatement()) {
	      break;
	    } else {
	      path = path.parentPath;
	    }
	  } while (path);
	  if (path && (path.isProgram() || path.isFile())) {
	    throw new Error("File/Program node, we can't possibly find a statement parent to this");
	  }
	  return path;
	}
	function getEarliestCommonAncestorFrom(paths) {
	  return this.getDeepestCommonAncestorFrom(paths, function (deepest, i, ancestries) {
	    let earliest;
	    const keys = VISITOR_KEYS[deepest.type];
	    for (const ancestry of ancestries) {
	      const path = ancestry[i + 1];
	      if (!earliest) {
	        earliest = path;
	        continue;
	      }
	      if (path.listKey && earliest.listKey === path.listKey) {
	        if (path.key < earliest.key) {
	          earliest = path;
	          continue;
	        }
	      }
	      const earliestKeyIndex = keys.indexOf(earliest.parentKey);
	      const currentKeyIndex = keys.indexOf(path.parentKey);
	      if (earliestKeyIndex > currentKeyIndex) {
	        earliest = path;
	      }
	    }
	    return earliest;
	  });
	}
	function getDeepestCommonAncestorFrom(paths, filter) {
	  if (!paths.length) {
	    return this;
	  }
	  if (paths.length === 1) {
	    return paths[0];
	  }
	  let minDepth = Infinity;
	  let lastCommonIndex, lastCommon;
	  const ancestries = paths.map(path => {
	    const ancestry = [];
	    do {
	      ancestry.unshift(path);
	    } while ((path = path.parentPath) && path !== this);
	    if (ancestry.length < minDepth) {
	      minDepth = ancestry.length;
	    }
	    return ancestry;
	  });
	  const first = ancestries[0];
	  depthLoop: for (let i = 0; i < minDepth; i++) {
	    const shouldMatch = first[i];
	    for (const ancestry of ancestries) {
	      if (ancestry[i] !== shouldMatch) {
	        break depthLoop;
	      }
	    }
	    lastCommonIndex = i;
	    lastCommon = shouldMatch;
	  }
	  if (lastCommon) {
	    if (filter) {
	      return filter(lastCommon, lastCommonIndex, ancestries);
	    } else {
	      return lastCommon;
	    }
	  } else {
	    throw new Error("Couldn't find intersection");
	  }
	}
	function getAncestry() {
	  let path = this;
	  const paths = [];
	  do {
	    paths.push(path);
	  } while (path = path.parentPath);
	  return paths;
	}
	function isAncestor(maybeDescendant) {
	  return maybeDescendant.isDescendant(this);
	}
	function isDescendant(maybeAncestor) {
	  return !!this.findParent(parent => parent === maybeAncestor);
	}
	function inType(...candidateTypes) {
	  let path = this;
	  while (path) {
	    for (const type of candidateTypes) {
	      if (path.node.type === type) return true;
	    }
	    path = path.parentPath;
	  }
	  return false;
	}

	
	return ancestry;
}

var inference = {};

var inferers = {};

var infererReference = {};

var util$3 = {};

var hasRequiredUtil;

function requireUtil () {
	if (hasRequiredUtil) return util$3;
	hasRequiredUtil = 1;

	Object.defineProperty(util$3, "__esModule", {
	  value: true
	});
	util$3.createUnionType = createUnionType;
	var _t = requireLib$h();
	const {
	  createFlowUnionType,
	  createTSUnionType,
	  createUnionTypeAnnotation,
	  isFlowType,
	  isTSType
	} = _t;
	function createUnionType(types) {
	  {
	    if (types.every(v => isFlowType(v))) {
	      if (createFlowUnionType) {
	        return createFlowUnionType(types);
	      }
	      return createUnionTypeAnnotation(types);
	    } else if (types.every(v => isTSType(v))) {
	      if (createTSUnionType) {
	        return createTSUnionType(types);
	      }
	    }
	  }
	}

	
	return util$3;
}

var hasRequiredInfererReference;

function requireInfererReference () {
	if (hasRequiredInfererReference) return infererReference;
	hasRequiredInfererReference = 1;

	Object.defineProperty(infererReference, "__esModule", {
	  value: true
	});
	infererReference.default = _default;
	var _t = requireLib$h();
	var _util = requireUtil();
	const {
	  BOOLEAN_NUMBER_BINARY_OPERATORS,
	  createTypeAnnotationBasedOnTypeof,
	  numberTypeAnnotation,
	  voidTypeAnnotation
	} = _t;
	function _default(node) {
	  if (!this.isReferenced()) return;
	  const binding = this.scope.getBinding(node.name);
	  if (binding) {
	    if (binding.identifier.typeAnnotation) {
	      return binding.identifier.typeAnnotation;
	    } else {
	      return getTypeAnnotationBindingConstantViolations(binding, this, node.name);
	    }
	  }
	  if (node.name === "undefined") {
	    return voidTypeAnnotation();
	  } else if (node.name === "NaN" || node.name === "Infinity") {
	    return numberTypeAnnotation();
	  } else if (node.name === "arguments") ;
	}
	function getTypeAnnotationBindingConstantViolations(binding, path, name) {
	  const types = [];
	  const functionConstantViolations = [];
	  let constantViolations = getConstantViolationsBefore(binding, path, functionConstantViolations);
	  const testType = getConditionalAnnotation(binding, path, name);
	  if (testType) {
	    const testConstantViolations = getConstantViolationsBefore(binding, testType.ifStatement);
	    constantViolations = constantViolations.filter(path => testConstantViolations.indexOf(path) < 0);
	    types.push(testType.typeAnnotation);
	  }
	  if (constantViolations.length) {
	    constantViolations.push(...functionConstantViolations);
	    for (const violation of constantViolations) {
	      types.push(violation.getTypeAnnotation());
	    }
	  }
	  if (!types.length) {
	    return;
	  }
	  return (0, _util.createUnionType)(types);
	}
	function getConstantViolationsBefore(binding, path, functions) {
	  const violations = binding.constantViolations.slice();
	  violations.unshift(binding.path);
	  return violations.filter(violation => {
	    violation = violation.resolve();
	    const status = violation._guessExecutionStatusRelativeTo(path);
	    if (functions && status === "unknown") functions.push(violation);
	    return status === "before";
	  });
	}
	function inferAnnotationFromBinaryExpression(name, path) {
	  const operator = path.node.operator;
	  const right = path.get("right").resolve();
	  const left = path.get("left").resolve();
	  let target;
	  if (left.isIdentifier({
	    name
	  })) {
	    target = right;
	  } else if (right.isIdentifier({
	    name
	  })) {
	    target = left;
	  }
	  if (target) {
	    if (operator === "===") {
	      return target.getTypeAnnotation();
	    }
	    if (BOOLEAN_NUMBER_BINARY_OPERATORS.indexOf(operator) >= 0) {
	      return numberTypeAnnotation();
	    }
	    return;
	  }
	  if (operator !== "===" && operator !== "==") return;
	  let typeofPath;
	  let typePath;
	  if (left.isUnaryExpression({
	    operator: "typeof"
	  })) {
	    typeofPath = left;
	    typePath = right;
	  } else if (right.isUnaryExpression({
	    operator: "typeof"
	  })) {
	    typeofPath = right;
	    typePath = left;
	  }
	  if (!typeofPath) return;
	  if (!typeofPath.get("argument").isIdentifier({
	    name
	  })) return;
	  typePath = typePath.resolve();
	  if (!typePath.isLiteral()) return;
	  const typeValue = typePath.node.value;
	  if (typeof typeValue !== "string") return;
	  return createTypeAnnotationBasedOnTypeof(typeValue);
	}
	function getParentConditionalPath(binding, path, name) {
	  let parentPath;
	  while (parentPath = path.parentPath) {
	    if (parentPath.isIfStatement() || parentPath.isConditionalExpression()) {
	      if (path.key === "test") {
	        return;
	      }
	      return parentPath;
	    }
	    if (parentPath.isFunction()) {
	      if (parentPath.parentPath.scope.getBinding(name) !== binding) return;
	    }
	    path = parentPath;
	  }
	}
	function getConditionalAnnotation(binding, path, name) {
	  const ifStatement = getParentConditionalPath(binding, path, name);
	  if (!ifStatement) return;
	  const test = ifStatement.get("test");
	  const paths = [test];
	  const types = [];
	  for (let i = 0; i < paths.length; i++) {
	    const path = paths[i];
	    if (path.isLogicalExpression()) {
	      if (path.node.operator === "&&") {
	        paths.push(path.get("left"));
	        paths.push(path.get("right"));
	      }
	    } else if (path.isBinaryExpression()) {
	      const type = inferAnnotationFromBinaryExpression(name, path);
	      if (type) types.push(type);
	    }
	  }
	  if (types.length) {
	    return {
	      typeAnnotation: (0, _util.createUnionType)(types),
	      ifStatement
	    };
	  }
	  return getConditionalAnnotation(binding, ifStatement, name);
	}

	
	return infererReference;
}

var hasRequiredInferers;

function requireInferers () {
	if (hasRequiredInferers) return inferers;
	hasRequiredInferers = 1;
	(function (exports) {

		Object.defineProperty(exports, "__esModule", {
		  value: true
		});
		exports.ArrayExpression = ArrayExpression;
		exports.AssignmentExpression = AssignmentExpression;
		exports.BinaryExpression = BinaryExpression;
		exports.BooleanLiteral = BooleanLiteral;
		exports.CallExpression = CallExpression;
		exports.ConditionalExpression = ConditionalExpression;
		exports.ClassDeclaration = exports.ClassExpression = exports.FunctionDeclaration = exports.ArrowFunctionExpression = exports.FunctionExpression = Func;
		Object.defineProperty(exports, "Identifier", {
		  enumerable: true,
		  get: function () {
		    return _infererReference.default;
		  }
		});
		exports.LogicalExpression = LogicalExpression;
		exports.NewExpression = NewExpression;
		exports.NullLiteral = NullLiteral;
		exports.NumericLiteral = NumericLiteral;
		exports.ObjectExpression = ObjectExpression;
		exports.ParenthesizedExpression = ParenthesizedExpression;
		exports.RegExpLiteral = RegExpLiteral;
		exports.RestElement = RestElement;
		exports.SequenceExpression = SequenceExpression;
		exports.StringLiteral = StringLiteral;
		exports.TSAsExpression = TSAsExpression;
		exports.TSNonNullExpression = TSNonNullExpression;
		exports.TaggedTemplateExpression = TaggedTemplateExpression;
		exports.TemplateLiteral = TemplateLiteral;
		exports.TypeCastExpression = TypeCastExpression;
		exports.UnaryExpression = UnaryExpression;
		exports.UpdateExpression = UpdateExpression;
		exports.VariableDeclarator = VariableDeclarator;
		var _t = requireLib$h();
		var _infererReference = requireInfererReference();
		var _util = requireUtil();
		const {
		  BOOLEAN_BINARY_OPERATORS,
		  BOOLEAN_UNARY_OPERATORS,
		  NUMBER_BINARY_OPERATORS,
		  NUMBER_UNARY_OPERATORS,
		  STRING_UNARY_OPERATORS,
		  anyTypeAnnotation,
		  arrayTypeAnnotation,
		  booleanTypeAnnotation,
		  buildMatchMemberExpression,
		  genericTypeAnnotation,
		  identifier,
		  nullLiteralTypeAnnotation,
		  numberTypeAnnotation,
		  stringTypeAnnotation,
		  tupleTypeAnnotation,
		  unionTypeAnnotation,
		  voidTypeAnnotation,
		  isIdentifier
		} = _t;
		function VariableDeclarator() {
		  if (!this.get("id").isIdentifier()) return;
		  return this.get("init").getTypeAnnotation();
		}
		function TypeCastExpression(node) {
		  return node.typeAnnotation;
		}
		TypeCastExpression.validParent = true;
		function TSAsExpression(node) {
		  return node.typeAnnotation;
		}
		TSAsExpression.validParent = true;
		function TSNonNullExpression() {
		  return this.get("expression").getTypeAnnotation();
		}
		function NewExpression(node) {
		  if (node.callee.type === "Identifier") {
		    return genericTypeAnnotation(node.callee);
		  }
		}
		function TemplateLiteral() {
		  return stringTypeAnnotation();
		}
		function UnaryExpression(node) {
		  const operator = node.operator;
		  if (operator === "void") {
		    return voidTypeAnnotation();
		  } else if (NUMBER_UNARY_OPERATORS.indexOf(operator) >= 0) {
		    return numberTypeAnnotation();
		  } else if (STRING_UNARY_OPERATORS.indexOf(operator) >= 0) {
		    return stringTypeAnnotation();
		  } else if (BOOLEAN_UNARY_OPERATORS.indexOf(operator) >= 0) {
		    return booleanTypeAnnotation();
		  }
		}
		function BinaryExpression(node) {
		  const operator = node.operator;
		  if (NUMBER_BINARY_OPERATORS.indexOf(operator) >= 0) {
		    return numberTypeAnnotation();
		  } else if (BOOLEAN_BINARY_OPERATORS.indexOf(operator) >= 0) {
		    return booleanTypeAnnotation();
		  } else if (operator === "+") {
		    const right = this.get("right");
		    const left = this.get("left");
		    if (left.isBaseType("number") && right.isBaseType("number")) {
		      return numberTypeAnnotation();
		    } else if (left.isBaseType("string") || right.isBaseType("string")) {
		      return stringTypeAnnotation();
		    }
		    return unionTypeAnnotation([stringTypeAnnotation(), numberTypeAnnotation()]);
		  }
		}
		function LogicalExpression() {
		  const argumentTypes = [this.get("left").getTypeAnnotation(), this.get("right").getTypeAnnotation()];
		  return (0, _util.createUnionType)(argumentTypes);
		}
		function ConditionalExpression() {
		  const argumentTypes = [this.get("consequent").getTypeAnnotation(), this.get("alternate").getTypeAnnotation()];
		  return (0, _util.createUnionType)(argumentTypes);
		}
		function SequenceExpression() {
		  return this.get("expressions").pop().getTypeAnnotation();
		}
		function ParenthesizedExpression() {
		  return this.get("expression").getTypeAnnotation();
		}
		function AssignmentExpression() {
		  return this.get("right").getTypeAnnotation();
		}
		function UpdateExpression(node) {
		  const operator = node.operator;
		  if (operator === "++" || operator === "--") {
		    return numberTypeAnnotation();
		  }
		}
		function StringLiteral() {
		  return stringTypeAnnotation();
		}
		function NumericLiteral() {
		  return numberTypeAnnotation();
		}
		function BooleanLiteral() {
		  return booleanTypeAnnotation();
		}
		function NullLiteral() {
		  return nullLiteralTypeAnnotation();
		}
		function RegExpLiteral() {
		  return genericTypeAnnotation(identifier("RegExp"));
		}
		function ObjectExpression() {
		  return genericTypeAnnotation(identifier("Object"));
		}
		function ArrayExpression() {
		  return genericTypeAnnotation(identifier("Array"));
		}
		function RestElement() {
		  return ArrayExpression();
		}
		RestElement.validParent = true;
		function Func() {
		  return genericTypeAnnotation(identifier("Function"));
		}
		const isArrayFrom = buildMatchMemberExpression("Array.from");
		const isObjectKeys = buildMatchMemberExpression("Object.keys");
		const isObjectValues = buildMatchMemberExpression("Object.values");
		const isObjectEntries = buildMatchMemberExpression("Object.entries");
		function CallExpression() {
		  const {
		    callee
		  } = this.node;
		  if (isObjectKeys(callee)) {
		    return arrayTypeAnnotation(stringTypeAnnotation());
		  } else if (isArrayFrom(callee) || isObjectValues(callee) || isIdentifier(callee, {
		    name: "Array"
		  })) {
		    return arrayTypeAnnotation(anyTypeAnnotation());
		  } else if (isObjectEntries(callee)) {
		    return arrayTypeAnnotation(tupleTypeAnnotation([stringTypeAnnotation(), anyTypeAnnotation()]));
		  }
		  return resolveCall(this.get("callee"));
		}
		function TaggedTemplateExpression() {
		  return resolveCall(this.get("tag"));
		}
		function resolveCall(callee) {
		  callee = callee.resolve();
		  if (callee.isFunction()) {
		    const {
		      node
		    } = callee;
		    if (node.async) {
		      if (node.generator) {
		        return genericTypeAnnotation(identifier("AsyncIterator"));
		      } else {
		        return genericTypeAnnotation(identifier("Promise"));
		      }
		    } else {
		      if (node.generator) {
		        return genericTypeAnnotation(identifier("Iterator"));
		      } else if (callee.node.returnType) {
		        return callee.node.returnType;
		      } else ;
		    }
		  }
		}

		
	} (inferers));
	return inferers;
}

var hasRequiredInference;

function requireInference () {
	if (hasRequiredInference) return inference;
	hasRequiredInference = 1;

	Object.defineProperty(inference, "__esModule", {
	  value: true
	});
	inference._getTypeAnnotation = _getTypeAnnotation;
	inference.baseTypeStrictlyMatches = baseTypeStrictlyMatches;
	inference.couldBeBaseType = couldBeBaseType;
	inference.getTypeAnnotation = getTypeAnnotation;
	inference.isBaseType = isBaseType;
	inference.isGenericType = isGenericType;
	var inferers = requireInferers();
	var _t = requireLib$h();
	const {
	  anyTypeAnnotation,
	  isAnyTypeAnnotation,
	  isArrayTypeAnnotation,
	  isBooleanTypeAnnotation,
	  isEmptyTypeAnnotation,
	  isFlowBaseAnnotation,
	  isGenericTypeAnnotation,
	  isIdentifier,
	  isMixedTypeAnnotation,
	  isNumberTypeAnnotation,
	  isStringTypeAnnotation,
	  isTSArrayType,
	  isTSTypeAnnotation,
	  isTSTypeReference,
	  isTupleTypeAnnotation,
	  isTypeAnnotation,
	  isUnionTypeAnnotation,
	  isVoidTypeAnnotation,
	  stringTypeAnnotation,
	  voidTypeAnnotation
	} = _t;
	function getTypeAnnotation() {
	  let type = this.getData("typeAnnotation");
	  if (type != null) {
	    return type;
	  }
	  type = this._getTypeAnnotation() || anyTypeAnnotation();
	  if (isTypeAnnotation(type) || isTSTypeAnnotation(type)) {
	    type = type.typeAnnotation;
	  }
	  this.setData("typeAnnotation", type);
	  return type;
	}
	const typeAnnotationInferringNodes = new WeakSet();
	function _getTypeAnnotation() {
	  const node = this.node;
	  if (!node) {
	    if (this.key === "init" && this.parentPath.isVariableDeclarator()) {
	      const declar = this.parentPath.parentPath;
	      const declarParent = declar.parentPath;
	      if (declar.key === "left" && declarParent.isForInStatement()) {
	        return stringTypeAnnotation();
	      }
	      if (declar.key === "left" && declarParent.isForOfStatement()) {
	        return anyTypeAnnotation();
	      }
	      return voidTypeAnnotation();
	    } else {
	      return;
	    }
	  }
	  if (node.typeAnnotation) {
	    return node.typeAnnotation;
	  }
	  if (typeAnnotationInferringNodes.has(node)) {
	    return;
	  }
	  typeAnnotationInferringNodes.add(node);
	  try {
	    var _inferer;
	    let inferer = inferers[node.type];
	    if (inferer) {
	      return inferer.call(this, node);
	    }
	    inferer = inferers[this.parentPath.type];
	    if ((_inferer = inferer) != null && _inferer.validParent) {
	      return this.parentPath.getTypeAnnotation();
	    }
	  } finally {
	    typeAnnotationInferringNodes.delete(node);
	  }
	}
	function isBaseType(baseName, soft) {
	  return _isBaseType(baseName, this.getTypeAnnotation(), soft);
	}
	function _isBaseType(baseName, type, soft) {
	  if (baseName === "string") {
	    return isStringTypeAnnotation(type);
	  } else if (baseName === "number") {
	    return isNumberTypeAnnotation(type);
	  } else if (baseName === "boolean") {
	    return isBooleanTypeAnnotation(type);
	  } else if (baseName === "any") {
	    return isAnyTypeAnnotation(type);
	  } else if (baseName === "mixed") {
	    return isMixedTypeAnnotation(type);
	  } else if (baseName === "empty") {
	    return isEmptyTypeAnnotation(type);
	  } else if (baseName === "void") {
	    return isVoidTypeAnnotation(type);
	  } else {
	    if (soft) {
	      return false;
	    } else {
	      throw new Error(`Unknown base type ${baseName}`);
	    }
	  }
	}
	function couldBeBaseType(name) {
	  const type = this.getTypeAnnotation();
	  if (isAnyTypeAnnotation(type)) return true;
	  if (isUnionTypeAnnotation(type)) {
	    for (const type2 of type.types) {
	      if (isAnyTypeAnnotation(type2) || _isBaseType(name, type2, true)) {
	        return true;
	      }
	    }
	    return false;
	  } else {
	    return _isBaseType(name, type, true);
	  }
	}
	function baseTypeStrictlyMatches(rightArg) {
	  const left = this.getTypeAnnotation();
	  const right = rightArg.getTypeAnnotation();
	  if (!isAnyTypeAnnotation(left) && isFlowBaseAnnotation(left)) {
	    return right.type === left.type;
	  }
	  return false;
	}
	function isGenericType(genericName) {
	  const type = this.getTypeAnnotation();
	  if (genericName === "Array") {
	    if (isTSArrayType(type) || isArrayTypeAnnotation(type) || isTupleTypeAnnotation(type)) {
	      return true;
	    }
	  }
	  return isGenericTypeAnnotation(type) && isIdentifier(type.id, {
	    name: genericName
	  }) || isTSTypeReference(type) && isIdentifier(type.typeName, {
	    name: genericName
	  });
	}

	
	return inference;
}

var replacement = {};

var lib$a = {};

var lib$9 = {};

var jsTokens = {};

var hasRequiredJsTokens;

function requireJsTokens () {
	if (hasRequiredJsTokens) return jsTokens;
	hasRequiredJsTokens = 1;
	// Copyright 2014, 2015, 2016, 2017, 2018 Simon Lydell
	// License: MIT. (See LICENSE.)

	Object.defineProperty(jsTokens, "__esModule", {
	  value: true
	});

	// This regex comes from regex.coffee, and is inserted here by generate-index.js
	// (run `npm run build`).
	jsTokens.default = /((['"])(?:(?!\2|\\).|\\(?:\r\n|[\s\S]))*(\2)?|`(?:[^`\\$]|\\[\s\S]|\$(?!\{)|\$\{(?:[^{}]|\{[^}]*\}?)*\}?)*(`)?)|(\/\/.*)|(\/\*(?:[^*]|\*(?!\/))*(\*\/)?)|(\/(?!\*)(?:\[(?:(?![\]\\]).|\\.)*\]|(?![\/\]\\]).|\\.)+\/(?:(?!\s*(?:\b|[\u0080-\uFFFF$\\'"~({]|[+\-!](?!=)|\.?\d))|[gmiyus]{1,6}\b(?![\u0080-\uFFFF$\\]|\s*(?:[+\-*%&|^<>!=?({]|\/(?![\/*])))))|(0[xX][\da-fA-F]+|0[oO][0-7]+|0[bB][01]+|(?:\d*\.\d+|\d+\.?)(?:[eE][+-]?\d+)?)|((?!\d)(?:(?!\s)[$\w\u0080-\uFFFF]|\\u[\da-fA-F]{4}|\\u\{[\da-fA-F]+\})+)|(--|\+\+|&&|\|\||=>|\.{3}|(?:[+\-\/%&|^]|\*{1,2}|<{1,2}|>{1,3}|!=?|={1,2})=?|[?~.,:;[\](){}])|(\s+)|(^$|[\s\S])/g;

	jsTokens.matchToToken = function(match) {
	  var token = {type: "invalid", value: match[0], closed: undefined};
	       if (match[ 1]) token.type = "string" , token.closed = !!(match[3] || match[4]);
	  else if (match[ 5]) token.type = "comment";
	  else if (match[ 6]) token.type = "comment", token.closed = !!match[7];
	  else if (match[ 8]) token.type = "regex";
	  else if (match[ 9]) token.type = "number";
	  else if (match[10]) token.type = "name";
	  else if (match[11]) token.type = "punctuator";
	  else if (match[12]) token.type = "whitespace";
	  return token
	};
	return jsTokens;
}

var picocolors = {exports: {}};

var hasRequiredPicocolors;

function requirePicocolors () {
	if (hasRequiredPicocolors) return picocolors.exports;
	hasRequiredPicocolors = 1;
	let tty = tty__default["default"];

	let isColorSupported =
		!("NO_COLOR" in process.env || process.argv.includes("--no-color")) &&
		("FORCE_COLOR" in process.env ||
			process.argv.includes("--color") ||
			process.platform === "win32" ||
			(tty.isatty(1) && process.env.TERM !== "dumb") ||
			"CI" in process.env);

	let formatter =
		(open, close, replace = open) =>
		input => {
			let string = "" + input;
			let index = string.indexOf(close, open.length);
			return ~index
				? open + replaceClose(string, close, replace, index) + close
				: open + string + close
		};

	let replaceClose = (string, close, replace, index) => {
		let start = string.substring(0, index) + replace;
		let end = string.substring(index + close.length);
		let nextIndex = end.indexOf(close);
		return ~nextIndex ? start + replaceClose(end, close, replace, nextIndex) : start + end
	};

	let createColors = (enabled = isColorSupported) => ({
		isColorSupported: enabled,
		reset: enabled ? s => `\x1b[0m${s}\x1b[0m` : String,
		bold: enabled ? formatter("\x1b[1m", "\x1b[22m", "\x1b[22m\x1b[1m") : String,
		dim: enabled ? formatter("\x1b[2m", "\x1b[22m", "\x1b[22m\x1b[2m") : String,
		italic: enabled ? formatter("\x1b[3m", "\x1b[23m") : String,
		underline: enabled ? formatter("\x1b[4m", "\x1b[24m") : String,
		inverse: enabled ? formatter("\x1b[7m", "\x1b[27m") : String,
		hidden: enabled ? formatter("\x1b[8m", "\x1b[28m") : String,
		strikethrough: enabled ? formatter("\x1b[9m", "\x1b[29m") : String,
		black: enabled ? formatter("\x1b[30m", "\x1b[39m") : String,
		red: enabled ? formatter("\x1b[31m", "\x1b[39m") : String,
		green: enabled ? formatter("\x1b[32m", "\x1b[39m") : String,
		yellow: enabled ? formatter("\x1b[33m", "\x1b[39m") : String,
		blue: enabled ? formatter("\x1b[34m", "\x1b[39m") : String,
		magenta: enabled ? formatter("\x1b[35m", "\x1b[39m") : String,
		cyan: enabled ? formatter("\x1b[36m", "\x1b[39m") : String,
		white: enabled ? formatter("\x1b[37m", "\x1b[39m") : String,
		gray: enabled ? formatter("\x1b[90m", "\x1b[39m") : String,
		bgBlack: enabled ? formatter("\x1b[40m", "\x1b[49m") : String,
		bgRed: enabled ? formatter("\x1b[41m", "\x1b[49m") : String,
		bgGreen: enabled ? formatter("\x1b[42m", "\x1b[49m") : String,
		bgYellow: enabled ? formatter("\x1b[43m", "\x1b[49m") : String,
		bgBlue: enabled ? formatter("\x1b[44m", "\x1b[49m") : String,
		bgMagenta: enabled ? formatter("\x1b[45m", "\x1b[49m") : String,
		bgCyan: enabled ? formatter("\x1b[46m", "\x1b[49m") : String,
		bgWhite: enabled ? formatter("\x1b[47m", "\x1b[49m") : String,
	});

	picocolors.exports = createColors();
	picocolors.exports.createColors = createColors;
	return picocolors.exports;
}

var chalk = {exports: {}};

var escapeStringRegexp;
var hasRequiredEscapeStringRegexp;

function requireEscapeStringRegexp () {
	if (hasRequiredEscapeStringRegexp) return escapeStringRegexp;
	hasRequiredEscapeStringRegexp = 1;

	var matchOperatorsRe = /[|\\{}()[\]^$+*?.]/g;

	escapeStringRegexp = function (str) {
		if (typeof str !== 'string') {
			throw new TypeError('Expected a string');
		}

		return str.replace(matchOperatorsRe, '\\$&');
	};
	return escapeStringRegexp;
}

var ansiStyles = {exports: {}};

var conversions = {exports: {}};

var colorName;
var hasRequiredColorName;

function requireColorName () {
	if (hasRequiredColorName) return colorName;
	hasRequiredColorName = 1;

	colorName = {
		"aliceblue": [240, 248, 255],
		"antiquewhite": [250, 235, 215],
		"aqua": [0, 255, 255],
		"aquamarine": [127, 255, 212],
		"azure": [240, 255, 255],
		"beige": [245, 245, 220],
		"bisque": [255, 228, 196],
		"black": [0, 0, 0],
		"blanchedalmond": [255, 235, 205],
		"blue": [0, 0, 255],
		"blueviolet": [138, 43, 226],
		"brown": [165, 42, 42],
		"burlywood": [222, 184, 135],
		"cadetblue": [95, 158, 160],
		"chartreuse": [127, 255, 0],
		"chocolate": [210, 105, 30],
		"coral": [255, 127, 80],
		"cornflowerblue": [100, 149, 237],
		"cornsilk": [255, 248, 220],
		"crimson": [220, 20, 60],
		"cyan": [0, 255, 255],
		"darkblue": [0, 0, 139],
		"darkcyan": [0, 139, 139],
		"darkgoldenrod": [184, 134, 11],
		"darkgray": [169, 169, 169],
		"darkgreen": [0, 100, 0],
		"darkgrey": [169, 169, 169],
		"darkkhaki": [189, 183, 107],
		"darkmagenta": [139, 0, 139],
		"darkolivegreen": [85, 107, 47],
		"darkorange": [255, 140, 0],
		"darkorchid": [153, 50, 204],
		"darkred": [139, 0, 0],
		"darksalmon": [233, 150, 122],
		"darkseagreen": [143, 188, 143],
		"darkslateblue": [72, 61, 139],
		"darkslategray": [47, 79, 79],
		"darkslategrey": [47, 79, 79],
		"darkturquoise": [0, 206, 209],
		"darkviolet": [148, 0, 211],
		"deeppink": [255, 20, 147],
		"deepskyblue": [0, 191, 255],
		"dimgray": [105, 105, 105],
		"dimgrey": [105, 105, 105],
		"dodgerblue": [30, 144, 255],
		"firebrick": [178, 34, 34],
		"floralwhite": [255, 250, 240],
		"forestgreen": [34, 139, 34],
		"fuchsia": [255, 0, 255],
		"gainsboro": [220, 220, 220],
		"ghostwhite": [248, 248, 255],
		"gold": [255, 215, 0],
		"goldenrod": [218, 165, 32],
		"gray": [128, 128, 128],
		"green": [0, 128, 0],
		"greenyellow": [173, 255, 47],
		"grey": [128, 128, 128],
		"honeydew": [240, 255, 240],
		"hotpink": [255, 105, 180],
		"indianred": [205, 92, 92],
		"indigo": [75, 0, 130],
		"ivory": [255, 255, 240],
		"khaki": [240, 230, 140],
		"lavender": [230, 230, 250],
		"lavenderblush": [255, 240, 245],
		"lawngreen": [124, 252, 0],
		"lemonchiffon": [255, 250, 205],
		"lightblue": [173, 216, 230],
		"lightcoral": [240, 128, 128],
		"lightcyan": [224, 255, 255],
		"lightgoldenrodyellow": [250, 250, 210],
		"lightgray": [211, 211, 211],
		"lightgreen": [144, 238, 144],
		"lightgrey": [211, 211, 211],
		"lightpink": [255, 182, 193],
		"lightsalmon": [255, 160, 122],
		"lightseagreen": [32, 178, 170],
		"lightskyblue": [135, 206, 250],
		"lightslategray": [119, 136, 153],
		"lightslategrey": [119, 136, 153],
		"lightsteelblue": [176, 196, 222],
		"lightyellow": [255, 255, 224],
		"lime": [0, 255, 0],
		"limegreen": [50, 205, 50],
		"linen": [250, 240, 230],
		"magenta": [255, 0, 255],
		"maroon": [128, 0, 0],
		"mediumaquamarine": [102, 205, 170],
		"mediumblue": [0, 0, 205],
		"mediumorchid": [186, 85, 211],
		"mediumpurple": [147, 112, 219],
		"mediumseagreen": [60, 179, 113],
		"mediumslateblue": [123, 104, 238],
		"mediumspringgreen": [0, 250, 154],
		"mediumturquoise": [72, 209, 204],
		"mediumvioletred": [199, 21, 133],
		"midnightblue": [25, 25, 112],
		"mintcream": [245, 255, 250],
		"mistyrose": [255, 228, 225],
		"moccasin": [255, 228, 181],
		"navajowhite": [255, 222, 173],
		"navy": [0, 0, 128],
		"oldlace": [253, 245, 230],
		"olive": [128, 128, 0],
		"olivedrab": [107, 142, 35],
		"orange": [255, 165, 0],
		"orangered": [255, 69, 0],
		"orchid": [218, 112, 214],
		"palegoldenrod": [238, 232, 170],
		"palegreen": [152, 251, 152],
		"paleturquoise": [175, 238, 238],
		"palevioletred": [219, 112, 147],
		"papayawhip": [255, 239, 213],
		"peachpuff": [255, 218, 185],
		"peru": [205, 133, 63],
		"pink": [255, 192, 203],
		"plum": [221, 160, 221],
		"powderblue": [176, 224, 230],
		"purple": [128, 0, 128],
		"rebeccapurple": [102, 51, 153],
		"red": [255, 0, 0],
		"rosybrown": [188, 143, 143],
		"royalblue": [65, 105, 225],
		"saddlebrown": [139, 69, 19],
		"salmon": [250, 128, 114],
		"sandybrown": [244, 164, 96],
		"seagreen": [46, 139, 87],
		"seashell": [255, 245, 238],
		"sienna": [160, 82, 45],
		"silver": [192, 192, 192],
		"skyblue": [135, 206, 235],
		"slateblue": [106, 90, 205],
		"slategray": [112, 128, 144],
		"slategrey": [112, 128, 144],
		"snow": [255, 250, 250],
		"springgreen": [0, 255, 127],
		"steelblue": [70, 130, 180],
		"tan": [210, 180, 140],
		"teal": [0, 128, 128],
		"thistle": [216, 191, 216],
		"tomato": [255, 99, 71],
		"turquoise": [64, 224, 208],
		"violet": [238, 130, 238],
		"wheat": [245, 222, 179],
		"white": [255, 255, 255],
		"whitesmoke": [245, 245, 245],
		"yellow": [255, 255, 0],
		"yellowgreen": [154, 205, 50]
	};
	return colorName;
}

/* MIT license */

var hasRequiredConversions;

function requireConversions () {
	if (hasRequiredConversions) return conversions.exports;
	hasRequiredConversions = 1;
	var cssKeywords = requireColorName();

	// NOTE: conversions should only return primitive values (i.e. arrays, or
	//       values that give correct `typeof` results).
	//       do not use box values types (i.e. Number(), String(), etc.)

	var reverseKeywords = {};
	for (var key in cssKeywords) {
		if (cssKeywords.hasOwnProperty(key)) {
			reverseKeywords[cssKeywords[key]] = key;
		}
	}

	var convert = conversions.exports = {
		rgb: {channels: 3, labels: 'rgb'},
		hsl: {channels: 3, labels: 'hsl'},
		hsv: {channels: 3, labels: 'hsv'},
		hwb: {channels: 3, labels: 'hwb'},
		cmyk: {channels: 4, labels: 'cmyk'},
		xyz: {channels: 3, labels: 'xyz'},
		lab: {channels: 3, labels: 'lab'},
		lch: {channels: 3, labels: 'lch'},
		hex: {channels: 1, labels: ['hex']},
		keyword: {channels: 1, labels: ['keyword']},
		ansi16: {channels: 1, labels: ['ansi16']},
		ansi256: {channels: 1, labels: ['ansi256']},
		hcg: {channels: 3, labels: ['h', 'c', 'g']},
		apple: {channels: 3, labels: ['r16', 'g16', 'b16']},
		gray: {channels: 1, labels: ['gray']}
	};

	// hide .channels and .labels properties
	for (var model in convert) {
		if (convert.hasOwnProperty(model)) {
			if (!('channels' in convert[model])) {
				throw new Error('missing channels property: ' + model);
			}

			if (!('labels' in convert[model])) {
				throw new Error('missing channel labels property: ' + model);
			}

			if (convert[model].labels.length !== convert[model].channels) {
				throw new Error('channel and label counts mismatch: ' + model);
			}

			var channels = convert[model].channels;
			var labels = convert[model].labels;
			delete convert[model].channels;
			delete convert[model].labels;
			Object.defineProperty(convert[model], 'channels', {value: channels});
			Object.defineProperty(convert[model], 'labels', {value: labels});
		}
	}

	convert.rgb.hsl = function (rgb) {
		var r = rgb[0] / 255;
		var g = rgb[1] / 255;
		var b = rgb[2] / 255;
		var min = Math.min(r, g, b);
		var max = Math.max(r, g, b);
		var delta = max - min;
		var h;
		var s;
		var l;

		if (max === min) {
			h = 0;
		} else if (r === max) {
			h = (g - b) / delta;
		} else if (g === max) {
			h = 2 + (b - r) / delta;
		} else if (b === max) {
			h = 4 + (r - g) / delta;
		}

		h = Math.min(h * 60, 360);

		if (h < 0) {
			h += 360;
		}

		l = (min + max) / 2;

		if (max === min) {
			s = 0;
		} else if (l <= 0.5) {
			s = delta / (max + min);
		} else {
			s = delta / (2 - max - min);
		}

		return [h, s * 100, l * 100];
	};

	convert.rgb.hsv = function (rgb) {
		var rdif;
		var gdif;
		var bdif;
		var h;
		var s;

		var r = rgb[0] / 255;
		var g = rgb[1] / 255;
		var b = rgb[2] / 255;
		var v = Math.max(r, g, b);
		var diff = v - Math.min(r, g, b);
		var diffc = function (c) {
			return (v - c) / 6 / diff + 1 / 2;
		};

		if (diff === 0) {
			h = s = 0;
		} else {
			s = diff / v;
			rdif = diffc(r);
			gdif = diffc(g);
			bdif = diffc(b);

			if (r === v) {
				h = bdif - gdif;
			} else if (g === v) {
				h = (1 / 3) + rdif - bdif;
			} else if (b === v) {
				h = (2 / 3) + gdif - rdif;
			}
			if (h < 0) {
				h += 1;
			} else if (h > 1) {
				h -= 1;
			}
		}

		return [
			h * 360,
			s * 100,
			v * 100
		];
	};

	convert.rgb.hwb = function (rgb) {
		var r = rgb[0];
		var g = rgb[1];
		var b = rgb[2];
		var h = convert.rgb.hsl(rgb)[0];
		var w = 1 / 255 * Math.min(r, Math.min(g, b));

		b = 1 - 1 / 255 * Math.max(r, Math.max(g, b));

		return [h, w * 100, b * 100];
	};

	convert.rgb.cmyk = function (rgb) {
		var r = rgb[0] / 255;
		var g = rgb[1] / 255;
		var b = rgb[2] / 255;
		var c;
		var m;
		var y;
		var k;

		k = Math.min(1 - r, 1 - g, 1 - b);
		c = (1 - r - k) / (1 - k) || 0;
		m = (1 - g - k) / (1 - k) || 0;
		y = (1 - b - k) / (1 - k) || 0;

		return [c * 100, m * 100, y * 100, k * 100];
	};

	/**
	 * See https://en.m.wikipedia.org/wiki/Euclidean_distance#Squared_Euclidean_distance
	 * */
	function comparativeDistance(x, y) {
		return (
			Math.pow(x[0] - y[0], 2) +
			Math.pow(x[1] - y[1], 2) +
			Math.pow(x[2] - y[2], 2)
		);
	}

	convert.rgb.keyword = function (rgb) {
		var reversed = reverseKeywords[rgb];
		if (reversed) {
			return reversed;
		}

		var currentClosestDistance = Infinity;
		var currentClosestKeyword;

		for (var keyword in cssKeywords) {
			if (cssKeywords.hasOwnProperty(keyword)) {
				var value = cssKeywords[keyword];

				// Compute comparative distance
				var distance = comparativeDistance(rgb, value);

				// Check if its less, if so set as closest
				if (distance < currentClosestDistance) {
					currentClosestDistance = distance;
					currentClosestKeyword = keyword;
				}
			}
		}

		return currentClosestKeyword;
	};

	convert.keyword.rgb = function (keyword) {
		return cssKeywords[keyword];
	};

	convert.rgb.xyz = function (rgb) {
		var r = rgb[0] / 255;
		var g = rgb[1] / 255;
		var b = rgb[2] / 255;

		// assume sRGB
		r = r > 0.04045 ? Math.pow(((r + 0.055) / 1.055), 2.4) : (r / 12.92);
		g = g > 0.04045 ? Math.pow(((g + 0.055) / 1.055), 2.4) : (g / 12.92);
		b = b > 0.04045 ? Math.pow(((b + 0.055) / 1.055), 2.4) : (b / 12.92);

		var x = (r * 0.4124) + (g * 0.3576) + (b * 0.1805);
		var y = (r * 0.2126) + (g * 0.7152) + (b * 0.0722);
		var z = (r * 0.0193) + (g * 0.1192) + (b * 0.9505);

		return [x * 100, y * 100, z * 100];
	};

	convert.rgb.lab = function (rgb) {
		var xyz = convert.rgb.xyz(rgb);
		var x = xyz[0];
		var y = xyz[1];
		var z = xyz[2];
		var l;
		var a;
		var b;

		x /= 95.047;
		y /= 100;
		z /= 108.883;

		x = x > 0.008856 ? Math.pow(x, 1 / 3) : (7.787 * x) + (16 / 116);
		y = y > 0.008856 ? Math.pow(y, 1 / 3) : (7.787 * y) + (16 / 116);
		z = z > 0.008856 ? Math.pow(z, 1 / 3) : (7.787 * z) + (16 / 116);

		l = (116 * y) - 16;
		a = 500 * (x - y);
		b = 200 * (y - z);

		return [l, a, b];
	};

	convert.hsl.rgb = function (hsl) {
		var h = hsl[0] / 360;
		var s = hsl[1] / 100;
		var l = hsl[2] / 100;
		var t1;
		var t2;
		var t3;
		var rgb;
		var val;

		if (s === 0) {
			val = l * 255;
			return [val, val, val];
		}

		if (l < 0.5) {
			t2 = l * (1 + s);
		} else {
			t2 = l + s - l * s;
		}

		t1 = 2 * l - t2;

		rgb = [0, 0, 0];
		for (var i = 0; i < 3; i++) {
			t3 = h + 1 / 3 * -(i - 1);
			if (t3 < 0) {
				t3++;
			}
			if (t3 > 1) {
				t3--;
			}

			if (6 * t3 < 1) {
				val = t1 + (t2 - t1) * 6 * t3;
			} else if (2 * t3 < 1) {
				val = t2;
			} else if (3 * t3 < 2) {
				val = t1 + (t2 - t1) * (2 / 3 - t3) * 6;
			} else {
				val = t1;
			}

			rgb[i] = val * 255;
		}

		return rgb;
	};

	convert.hsl.hsv = function (hsl) {
		var h = hsl[0];
		var s = hsl[1] / 100;
		var l = hsl[2] / 100;
		var smin = s;
		var lmin = Math.max(l, 0.01);
		var sv;
		var v;

		l *= 2;
		s *= (l <= 1) ? l : 2 - l;
		smin *= lmin <= 1 ? lmin : 2 - lmin;
		v = (l + s) / 2;
		sv = l === 0 ? (2 * smin) / (lmin + smin) : (2 * s) / (l + s);

		return [h, sv * 100, v * 100];
	};

	convert.hsv.rgb = function (hsv) {
		var h = hsv[0] / 60;
		var s = hsv[1] / 100;
		var v = hsv[2] / 100;
		var hi = Math.floor(h) % 6;

		var f = h - Math.floor(h);
		var p = 255 * v * (1 - s);
		var q = 255 * v * (1 - (s * f));
		var t = 255 * v * (1 - (s * (1 - f)));
		v *= 255;

		switch (hi) {
			case 0:
				return [v, t, p];
			case 1:
				return [q, v, p];
			case 2:
				return [p, v, t];
			case 3:
				return [p, q, v];
			case 4:
				return [t, p, v];
			case 5:
				return [v, p, q];
		}
	};

	convert.hsv.hsl = function (hsv) {
		var h = hsv[0];
		var s = hsv[1] / 100;
		var v = hsv[2] / 100;
		var vmin = Math.max(v, 0.01);
		var lmin;
		var sl;
		var l;

		l = (2 - s) * v;
		lmin = (2 - s) * vmin;
		sl = s * vmin;
		sl /= (lmin <= 1) ? lmin : 2 - lmin;
		sl = sl || 0;
		l /= 2;

		return [h, sl * 100, l * 100];
	};

	// http://dev.w3.org/csswg/css-color/#hwb-to-rgb
	convert.hwb.rgb = function (hwb) {
		var h = hwb[0] / 360;
		var wh = hwb[1] / 100;
		var bl = hwb[2] / 100;
		var ratio = wh + bl;
		var i;
		var v;
		var f;
		var n;

		// wh + bl cant be > 1
		if (ratio > 1) {
			wh /= ratio;
			bl /= ratio;
		}

		i = Math.floor(6 * h);
		v = 1 - bl;
		f = 6 * h - i;

		if ((i & 0x01) !== 0) {
			f = 1 - f;
		}

		n = wh + f * (v - wh); // linear interpolation

		var r;
		var g;
		var b;
		switch (i) {
			default:
			case 6:
			case 0: r = v; g = n; b = wh; break;
			case 1: r = n; g = v; b = wh; break;
			case 2: r = wh; g = v; b = n; break;
			case 3: r = wh; g = n; b = v; break;
			case 4: r = n; g = wh; b = v; break;
			case 5: r = v; g = wh; b = n; break;
		}

		return [r * 255, g * 255, b * 255];
	};

	convert.cmyk.rgb = function (cmyk) {
		var c = cmyk[0] / 100;
		var m = cmyk[1] / 100;
		var y = cmyk[2] / 100;
		var k = cmyk[3] / 100;
		var r;
		var g;
		var b;

		r = 1 - Math.min(1, c * (1 - k) + k);
		g = 1 - Math.min(1, m * (1 - k) + k);
		b = 1 - Math.min(1, y * (1 - k) + k);

		return [r * 255, g * 255, b * 255];
	};

	convert.xyz.rgb = function (xyz) {
		var x = xyz[0] / 100;
		var y = xyz[1] / 100;
		var z = xyz[2] / 100;
		var r;
		var g;
		var b;

		r = (x * 3.2406) + (y * -1.5372) + (z * -0.4986);
		g = (x * -0.9689) + (y * 1.8758) + (z * 0.0415);
		b = (x * 0.0557) + (y * -0.2040) + (z * 1.0570);

		// assume sRGB
		r = r > 0.0031308
			? ((1.055 * Math.pow(r, 1.0 / 2.4)) - 0.055)
			: r * 12.92;

		g = g > 0.0031308
			? ((1.055 * Math.pow(g, 1.0 / 2.4)) - 0.055)
			: g * 12.92;

		b = b > 0.0031308
			? ((1.055 * Math.pow(b, 1.0 / 2.4)) - 0.055)
			: b * 12.92;

		r = Math.min(Math.max(0, r), 1);
		g = Math.min(Math.max(0, g), 1);
		b = Math.min(Math.max(0, b), 1);

		return [r * 255, g * 255, b * 255];
	};

	convert.xyz.lab = function (xyz) {
		var x = xyz[0];
		var y = xyz[1];
		var z = xyz[2];
		var l;
		var a;
		var b;

		x /= 95.047;
		y /= 100;
		z /= 108.883;

		x = x > 0.008856 ? Math.pow(x, 1 / 3) : (7.787 * x) + (16 / 116);
		y = y > 0.008856 ? Math.pow(y, 1 / 3) : (7.787 * y) + (16 / 116);
		z = z > 0.008856 ? Math.pow(z, 1 / 3) : (7.787 * z) + (16 / 116);

		l = (116 * y) - 16;
		a = 500 * (x - y);
		b = 200 * (y - z);

		return [l, a, b];
	};

	convert.lab.xyz = function (lab) {
		var l = lab[0];
		var a = lab[1];
		var b = lab[2];
		var x;
		var y;
		var z;

		y = (l + 16) / 116;
		x = a / 500 + y;
		z = y - b / 200;

		var y2 = Math.pow(y, 3);
		var x2 = Math.pow(x, 3);
		var z2 = Math.pow(z, 3);
		y = y2 > 0.008856 ? y2 : (y - 16 / 116) / 7.787;
		x = x2 > 0.008856 ? x2 : (x - 16 / 116) / 7.787;
		z = z2 > 0.008856 ? z2 : (z - 16 / 116) / 7.787;

		x *= 95.047;
		y *= 100;
		z *= 108.883;

		return [x, y, z];
	};

	convert.lab.lch = function (lab) {
		var l = lab[0];
		var a = lab[1];
		var b = lab[2];
		var hr;
		var h;
		var c;

		hr = Math.atan2(b, a);
		h = hr * 360 / 2 / Math.PI;

		if (h < 0) {
			h += 360;
		}

		c = Math.sqrt(a * a + b * b);

		return [l, c, h];
	};

	convert.lch.lab = function (lch) {
		var l = lch[0];
		var c = lch[1];
		var h = lch[2];
		var a;
		var b;
		var hr;

		hr = h / 360 * 2 * Math.PI;
		a = c * Math.cos(hr);
		b = c * Math.sin(hr);

		return [l, a, b];
	};

	convert.rgb.ansi16 = function (args) {
		var r = args[0];
		var g = args[1];
		var b = args[2];
		var value = 1 in arguments ? arguments[1] : convert.rgb.hsv(args)[2]; // hsv -> ansi16 optimization

		value = Math.round(value / 50);

		if (value === 0) {
			return 30;
		}

		var ansi = 30
			+ ((Math.round(b / 255) << 2)
			| (Math.round(g / 255) << 1)
			| Math.round(r / 255));

		if (value === 2) {
			ansi += 60;
		}

		return ansi;
	};

	convert.hsv.ansi16 = function (args) {
		// optimization here; we already know the value and don't need to get
		// it converted for us.
		return convert.rgb.ansi16(convert.hsv.rgb(args), args[2]);
	};

	convert.rgb.ansi256 = function (args) {
		var r = args[0];
		var g = args[1];
		var b = args[2];

		// we use the extended greyscale palette here, with the exception of
		// black and white. normal palette only has 4 greyscale shades.
		if (r === g && g === b) {
			if (r < 8) {
				return 16;
			}

			if (r > 248) {
				return 231;
			}

			return Math.round(((r - 8) / 247) * 24) + 232;
		}

		var ansi = 16
			+ (36 * Math.round(r / 255 * 5))
			+ (6 * Math.round(g / 255 * 5))
			+ Math.round(b / 255 * 5);

		return ansi;
	};

	convert.ansi16.rgb = function (args) {
		var color = args % 10;

		// handle greyscale
		if (color === 0 || color === 7) {
			if (args > 50) {
				color += 3.5;
			}

			color = color / 10.5 * 255;

			return [color, color, color];
		}

		var mult = (~~(args > 50) + 1) * 0.5;
		var r = ((color & 1) * mult) * 255;
		var g = (((color >> 1) & 1) * mult) * 255;
		var b = (((color >> 2) & 1) * mult) * 255;

		return [r, g, b];
	};

	convert.ansi256.rgb = function (args) {
		// handle greyscale
		if (args >= 232) {
			var c = (args - 232) * 10 + 8;
			return [c, c, c];
		}

		args -= 16;

		var rem;
		var r = Math.floor(args / 36) / 5 * 255;
		var g = Math.floor((rem = args % 36) / 6) / 5 * 255;
		var b = (rem % 6) / 5 * 255;

		return [r, g, b];
	};

	convert.rgb.hex = function (args) {
		var integer = ((Math.round(args[0]) & 0xFF) << 16)
			+ ((Math.round(args[1]) & 0xFF) << 8)
			+ (Math.round(args[2]) & 0xFF);

		var string = integer.toString(16).toUpperCase();
		return '000000'.substring(string.length) + string;
	};

	convert.hex.rgb = function (args) {
		var match = args.toString(16).match(/[a-f0-9]{6}|[a-f0-9]{3}/i);
		if (!match) {
			return [0, 0, 0];
		}

		var colorString = match[0];

		if (match[0].length === 3) {
			colorString = colorString.split('').map(function (char) {
				return char + char;
			}).join('');
		}

		var integer = parseInt(colorString, 16);
		var r = (integer >> 16) & 0xFF;
		var g = (integer >> 8) & 0xFF;
		var b = integer & 0xFF;

		return [r, g, b];
	};

	convert.rgb.hcg = function (rgb) {
		var r = rgb[0] / 255;
		var g = rgb[1] / 255;
		var b = rgb[2] / 255;
		var max = Math.max(Math.max(r, g), b);
		var min = Math.min(Math.min(r, g), b);
		var chroma = (max - min);
		var grayscale;
		var hue;

		if (chroma < 1) {
			grayscale = min / (1 - chroma);
		} else {
			grayscale = 0;
		}

		if (chroma <= 0) {
			hue = 0;
		} else
		if (max === r) {
			hue = ((g - b) / chroma) % 6;
		} else
		if (max === g) {
			hue = 2 + (b - r) / chroma;
		} else {
			hue = 4 + (r - g) / chroma + 4;
		}

		hue /= 6;
		hue %= 1;

		return [hue * 360, chroma * 100, grayscale * 100];
	};

	convert.hsl.hcg = function (hsl) {
		var s = hsl[1] / 100;
		var l = hsl[2] / 100;
		var c = 1;
		var f = 0;

		if (l < 0.5) {
			c = 2.0 * s * l;
		} else {
			c = 2.0 * s * (1.0 - l);
		}

		if (c < 1.0) {
			f = (l - 0.5 * c) / (1.0 - c);
		}

		return [hsl[0], c * 100, f * 100];
	};

	convert.hsv.hcg = function (hsv) {
		var s = hsv[1] / 100;
		var v = hsv[2] / 100;

		var c = s * v;
		var f = 0;

		if (c < 1.0) {
			f = (v - c) / (1 - c);
		}

		return [hsv[0], c * 100, f * 100];
	};

	convert.hcg.rgb = function (hcg) {
		var h = hcg[0] / 360;
		var c = hcg[1] / 100;
		var g = hcg[2] / 100;

		if (c === 0.0) {
			return [g * 255, g * 255, g * 255];
		}

		var pure = [0, 0, 0];
		var hi = (h % 1) * 6;
		var v = hi % 1;
		var w = 1 - v;
		var mg = 0;

		switch (Math.floor(hi)) {
			case 0:
				pure[0] = 1; pure[1] = v; pure[2] = 0; break;
			case 1:
				pure[0] = w; pure[1] = 1; pure[2] = 0; break;
			case 2:
				pure[0] = 0; pure[1] = 1; pure[2] = v; break;
			case 3:
				pure[0] = 0; pure[1] = w; pure[2] = 1; break;
			case 4:
				pure[0] = v; pure[1] = 0; pure[2] = 1; break;
			default:
				pure[0] = 1; pure[1] = 0; pure[2] = w;
		}

		mg = (1.0 - c) * g;

		return [
			(c * pure[0] + mg) * 255,
			(c * pure[1] + mg) * 255,
			(c * pure[2] + mg) * 255
		];
	};

	convert.hcg.hsv = function (hcg) {
		var c = hcg[1] / 100;
		var g = hcg[2] / 100;

		var v = c + g * (1.0 - c);
		var f = 0;

		if (v > 0.0) {
			f = c / v;
		}

		return [hcg[0], f * 100, v * 100];
	};

	convert.hcg.hsl = function (hcg) {
		var c = hcg[1] / 100;
		var g = hcg[2] / 100;

		var l = g * (1.0 - c) + 0.5 * c;
		var s = 0;

		if (l > 0.0 && l < 0.5) {
			s = c / (2 * l);
		} else
		if (l >= 0.5 && l < 1.0) {
			s = c / (2 * (1 - l));
		}

		return [hcg[0], s * 100, l * 100];
	};

	convert.hcg.hwb = function (hcg) {
		var c = hcg[1] / 100;
		var g = hcg[2] / 100;
		var v = c + g * (1.0 - c);
		return [hcg[0], (v - c) * 100, (1 - v) * 100];
	};

	convert.hwb.hcg = function (hwb) {
		var w = hwb[1] / 100;
		var b = hwb[2] / 100;
		var v = 1 - b;
		var c = v - w;
		var g = 0;

		if (c < 1) {
			g = (v - c) / (1 - c);
		}

		return [hwb[0], c * 100, g * 100];
	};

	convert.apple.rgb = function (apple) {
		return [(apple[0] / 65535) * 255, (apple[1] / 65535) * 255, (apple[2] / 65535) * 255];
	};

	convert.rgb.apple = function (rgb) {
		return [(rgb[0] / 255) * 65535, (rgb[1] / 255) * 65535, (rgb[2] / 255) * 65535];
	};

	convert.gray.rgb = function (args) {
		return [args[0] / 100 * 255, args[0] / 100 * 255, args[0] / 100 * 255];
	};

	convert.gray.hsl = convert.gray.hsv = function (args) {
		return [0, 0, args[0]];
	};

	convert.gray.hwb = function (gray) {
		return [0, 100, gray[0]];
	};

	convert.gray.cmyk = function (gray) {
		return [0, 0, 0, gray[0]];
	};

	convert.gray.lab = function (gray) {
		return [gray[0], 0, 0];
	};

	convert.gray.hex = function (gray) {
		var val = Math.round(gray[0] / 100 * 255) & 0xFF;
		var integer = (val << 16) + (val << 8) + val;

		var string = integer.toString(16).toUpperCase();
		return '000000'.substring(string.length) + string;
	};

	convert.rgb.gray = function (rgb) {
		var val = (rgb[0] + rgb[1] + rgb[2]) / 3;
		return [val / 255 * 100];
	};
	return conversions.exports;
}

var route;
var hasRequiredRoute;

function requireRoute () {
	if (hasRequiredRoute) return route;
	hasRequiredRoute = 1;
	var conversions = requireConversions();

	/*
		this function routes a model to all other models.

		all functions that are routed have a property `.conversion` attached
		to the returned synthetic function. This property is an array
		of strings, each with the steps in between the 'from' and 'to'
		color models (inclusive).

		conversions that are not possible simply are not included.
	*/

	function buildGraph() {
		var graph = {};
		// https://jsperf.com/object-keys-vs-for-in-with-closure/3
		var models = Object.keys(conversions);

		for (var len = models.length, i = 0; i < len; i++) {
			graph[models[i]] = {
				// http://jsperf.com/1-vs-infinity
				// micro-opt, but this is simple.
				distance: -1,
				parent: null
			};
		}

		return graph;
	}

	// https://en.wikipedia.org/wiki/Breadth-first_search
	function deriveBFS(fromModel) {
		var graph = buildGraph();
		var queue = [fromModel]; // unshift -> queue -> pop

		graph[fromModel].distance = 0;

		while (queue.length) {
			var current = queue.pop();
			var adjacents = Object.keys(conversions[current]);

			for (var len = adjacents.length, i = 0; i < len; i++) {
				var adjacent = adjacents[i];
				var node = graph[adjacent];

				if (node.distance === -1) {
					node.distance = graph[current].distance + 1;
					node.parent = current;
					queue.unshift(adjacent);
				}
			}
		}

		return graph;
	}

	function link(from, to) {
		return function (args) {
			return to(from(args));
		};
	}

	function wrapConversion(toModel, graph) {
		var path = [graph[toModel].parent, toModel];
		var fn = conversions[graph[toModel].parent][toModel];

		var cur = graph[toModel].parent;
		while (graph[cur].parent) {
			path.unshift(graph[cur].parent);
			fn = link(conversions[graph[cur].parent][cur], fn);
			cur = graph[cur].parent;
		}

		fn.conversion = path;
		return fn;
	}

	route = function (fromModel) {
		var graph = deriveBFS(fromModel);
		var conversion = {};

		var models = Object.keys(graph);
		for (var len = models.length, i = 0; i < len; i++) {
			var toModel = models[i];
			var node = graph[toModel];

			if (node.parent === null) {
				// no possible conversion, or this node is the source model.
				continue;
			}

			conversion[toModel] = wrapConversion(toModel, graph);
		}

		return conversion;
	};
	return route;
}

var colorConvert;
var hasRequiredColorConvert;

function requireColorConvert () {
	if (hasRequiredColorConvert) return colorConvert;
	hasRequiredColorConvert = 1;
	var conversions = requireConversions();
	var route = requireRoute();

	var convert = {};

	var models = Object.keys(conversions);

	function wrapRaw(fn) {
		var wrappedFn = function (args) {
			if (args === undefined || args === null) {
				return args;
			}

			if (arguments.length > 1) {
				args = Array.prototype.slice.call(arguments);
			}

			return fn(args);
		};

		// preserve .conversion property if there is one
		if ('conversion' in fn) {
			wrappedFn.conversion = fn.conversion;
		}

		return wrappedFn;
	}

	function wrapRounded(fn) {
		var wrappedFn = function (args) {
			if (args === undefined || args === null) {
				return args;
			}

			if (arguments.length > 1) {
				args = Array.prototype.slice.call(arguments);
			}

			var result = fn(args);

			// we're assuming the result is an array here.
			// see notice in conversions.js; don't use box types
			// in conversion functions.
			if (typeof result === 'object') {
				for (var len = result.length, i = 0; i < len; i++) {
					result[i] = Math.round(result[i]);
				}
			}

			return result;
		};

		// preserve .conversion property if there is one
		if ('conversion' in fn) {
			wrappedFn.conversion = fn.conversion;
		}

		return wrappedFn;
	}

	models.forEach(function (fromModel) {
		convert[fromModel] = {};

		Object.defineProperty(convert[fromModel], 'channels', {value: conversions[fromModel].channels});
		Object.defineProperty(convert[fromModel], 'labels', {value: conversions[fromModel].labels});

		var routes = route(fromModel);
		var routeModels = Object.keys(routes);

		routeModels.forEach(function (toModel) {
			var fn = routes[toModel];

			convert[fromModel][toModel] = wrapRounded(fn);
			convert[fromModel][toModel].raw = wrapRaw(fn);
		});
	});

	colorConvert = convert;
	return colorConvert;
}

ansiStyles.exports;

var hasRequiredAnsiStyles;

function requireAnsiStyles () {
	if (hasRequiredAnsiStyles) return ansiStyles.exports;
	hasRequiredAnsiStyles = 1;
	(function (module) {
		const colorConvert = requireColorConvert();

		const wrapAnsi16 = (fn, offset) => function () {
			const code = fn.apply(colorConvert, arguments);
			return `\u001B[${code + offset}m`;
		};

		const wrapAnsi256 = (fn, offset) => function () {
			const code = fn.apply(colorConvert, arguments);
			return `\u001B[${38 + offset};5;${code}m`;
		};

		const wrapAnsi16m = (fn, offset) => function () {
			const rgb = fn.apply(colorConvert, arguments);
			return `\u001B[${38 + offset};2;${rgb[0]};${rgb[1]};${rgb[2]}m`;
		};

		function assembleStyles() {
			const codes = new Map();
			const styles = {
				modifier: {
					reset: [0, 0],
					// 21 isn't widely supported and 22 does the same thing
					bold: [1, 22],
					dim: [2, 22],
					italic: [3, 23],
					underline: [4, 24],
					inverse: [7, 27],
					hidden: [8, 28],
					strikethrough: [9, 29]
				},
				color: {
					black: [30, 39],
					red: [31, 39],
					green: [32, 39],
					yellow: [33, 39],
					blue: [34, 39],
					magenta: [35, 39],
					cyan: [36, 39],
					white: [37, 39],
					gray: [90, 39],

					// Bright color
					redBright: [91, 39],
					greenBright: [92, 39],
					yellowBright: [93, 39],
					blueBright: [94, 39],
					magentaBright: [95, 39],
					cyanBright: [96, 39],
					whiteBright: [97, 39]
				},
				bgColor: {
					bgBlack: [40, 49],
					bgRed: [41, 49],
					bgGreen: [42, 49],
					bgYellow: [43, 49],
					bgBlue: [44, 49],
					bgMagenta: [45, 49],
					bgCyan: [46, 49],
					bgWhite: [47, 49],

					// Bright color
					bgBlackBright: [100, 49],
					bgRedBright: [101, 49],
					bgGreenBright: [102, 49],
					bgYellowBright: [103, 49],
					bgBlueBright: [104, 49],
					bgMagentaBright: [105, 49],
					bgCyanBright: [106, 49],
					bgWhiteBright: [107, 49]
				}
			};

			// Fix humans
			styles.color.grey = styles.color.gray;

			for (const groupName of Object.keys(styles)) {
				const group = styles[groupName];

				for (const styleName of Object.keys(group)) {
					const style = group[styleName];

					styles[styleName] = {
						open: `\u001B[${style[0]}m`,
						close: `\u001B[${style[1]}m`
					};

					group[styleName] = styles[styleName];

					codes.set(style[0], style[1]);
				}

				Object.defineProperty(styles, groupName, {
					value: group,
					enumerable: false
				});

				Object.defineProperty(styles, 'codes', {
					value: codes,
					enumerable: false
				});
			}

			const ansi2ansi = n => n;
			const rgb2rgb = (r, g, b) => [r, g, b];

			styles.color.close = '\u001B[39m';
			styles.bgColor.close = '\u001B[49m';

			styles.color.ansi = {
				ansi: wrapAnsi16(ansi2ansi, 0)
			};
			styles.color.ansi256 = {
				ansi256: wrapAnsi256(ansi2ansi, 0)
			};
			styles.color.ansi16m = {
				rgb: wrapAnsi16m(rgb2rgb, 0)
			};

			styles.bgColor.ansi = {
				ansi: wrapAnsi16(ansi2ansi, 10)
			};
			styles.bgColor.ansi256 = {
				ansi256: wrapAnsi256(ansi2ansi, 10)
			};
			styles.bgColor.ansi16m = {
				rgb: wrapAnsi16m(rgb2rgb, 10)
			};

			for (let key of Object.keys(colorConvert)) {
				if (typeof colorConvert[key] !== 'object') {
					continue;
				}

				const suite = colorConvert[key];

				if (key === 'ansi16') {
					key = 'ansi';
				}

				if ('ansi16' in suite) {
					styles.color.ansi[key] = wrapAnsi16(suite.ansi16, 0);
					styles.bgColor.ansi[key] = wrapAnsi16(suite.ansi16, 10);
				}

				if ('ansi256' in suite) {
					styles.color.ansi256[key] = wrapAnsi256(suite.ansi256, 0);
					styles.bgColor.ansi256[key] = wrapAnsi256(suite.ansi256, 10);
				}

				if ('rgb' in suite) {
					styles.color.ansi16m[key] = wrapAnsi16m(suite.rgb, 0);
					styles.bgColor.ansi16m[key] = wrapAnsi16m(suite.rgb, 10);
				}
			}

			return styles;
		}

		// Make the export immutable
		Object.defineProperty(module, 'exports', {
			enumerable: true,
			get: assembleStyles
		}); 
	} (ansiStyles));
	return ansiStyles.exports;
}

var hasFlag;
var hasRequiredHasFlag;

function requireHasFlag () {
	if (hasRequiredHasFlag) return hasFlag;
	hasRequiredHasFlag = 1;
	hasFlag = (flag, argv) => {
		argv = argv || process.argv;
		const prefix = flag.startsWith('-') ? '' : (flag.length === 1 ? '-' : '--');
		const pos = argv.indexOf(prefix + flag);
		const terminatorPos = argv.indexOf('--');
		return pos !== -1 && (terminatorPos === -1 ? true : pos < terminatorPos);
	};
	return hasFlag;
}

var supportsColor_1;
var hasRequiredSupportsColor;

function requireSupportsColor () {
	if (hasRequiredSupportsColor) return supportsColor_1;
	hasRequiredSupportsColor = 1;
	const os = require$$0__default$1["default"];
	const hasFlag = requireHasFlag();

	const env = process.env;

	let forceColor;
	if (hasFlag('no-color') ||
		hasFlag('no-colors') ||
		hasFlag('color=false')) {
		forceColor = false;
	} else if (hasFlag('color') ||
		hasFlag('colors') ||
		hasFlag('color=true') ||
		hasFlag('color=always')) {
		forceColor = true;
	}
	if ('FORCE_COLOR' in env) {
		forceColor = env.FORCE_COLOR.length === 0 || parseInt(env.FORCE_COLOR, 10) !== 0;
	}

	function translateLevel(level) {
		if (level === 0) {
			return false;
		}

		return {
			level,
			hasBasic: true,
			has256: level >= 2,
			has16m: level >= 3
		};
	}

	function supportsColor(stream) {
		if (forceColor === false) {
			return 0;
		}

		if (hasFlag('color=16m') ||
			hasFlag('color=full') ||
			hasFlag('color=truecolor')) {
			return 3;
		}

		if (hasFlag('color=256')) {
			return 2;
		}

		if (stream && !stream.isTTY && forceColor !== true) {
			return 0;
		}

		const min = forceColor ? 1 : 0;

		if (process.platform === 'win32') {
			// Node.js 7.5.0 is the first version of Node.js to include a patch to
			// libuv that enables 256 color output on Windows. Anything earlier and it
			// won't work. However, here we target Node.js 8 at minimum as it is an LTS
			// release, and Node.js 7 is not. Windows 10 build 10586 is the first Windows
			// release that supports 256 colors. Windows 10 build 14931 is the first release
			// that supports 16m/TrueColor.
			const osRelease = os.release().split('.');
			if (
				Number(process.versions.node.split('.')[0]) >= 8 &&
				Number(osRelease[0]) >= 10 &&
				Number(osRelease[2]) >= 10586
			) {
				return Number(osRelease[2]) >= 14931 ? 3 : 2;
			}

			return 1;
		}

		if ('CI' in env) {
			if (['TRAVIS', 'CIRCLECI', 'APPVEYOR', 'GITLAB_CI'].some(sign => sign in env) || env.CI_NAME === 'codeship') {
				return 1;
			}

			return min;
		}

		if ('TEAMCITY_VERSION' in env) {
			return /^(9\.(0*[1-9]\d*)\.|\d{2,}\.)/.test(env.TEAMCITY_VERSION) ? 1 : 0;
		}

		if (env.COLORTERM === 'truecolor') {
			return 3;
		}

		if ('TERM_PROGRAM' in env) {
			const version = parseInt((env.TERM_PROGRAM_VERSION || '').split('.')[0], 10);

			switch (env.TERM_PROGRAM) {
				case 'iTerm.app':
					return version >= 3 ? 3 : 2;
				case 'Apple_Terminal':
					return 2;
				// No default
			}
		}

		if (/-256(color)?$/i.test(env.TERM)) {
			return 2;
		}

		if (/^screen|^xterm|^vt100|^vt220|^rxvt|color|ansi|cygwin|linux/i.test(env.TERM)) {
			return 1;
		}

		if ('COLORTERM' in env) {
			return 1;
		}

		if (env.TERM === 'dumb') {
			return min;
		}

		return min;
	}

	function getSupportLevel(stream) {
		const level = supportsColor(stream);
		return translateLevel(level);
	}

	supportsColor_1 = {
		supportsColor: getSupportLevel,
		stdout: getSupportLevel(process.stdout),
		stderr: getSupportLevel(process.stderr)
	};
	return supportsColor_1;
}

var templates;
var hasRequiredTemplates;

function requireTemplates () {
	if (hasRequiredTemplates) return templates;
	hasRequiredTemplates = 1;
	const TEMPLATE_REGEX = /(?:\\(u[a-f\d]{4}|x[a-f\d]{2}|.))|(?:\{(~)?(\w+(?:\([^)]*\))?(?:\.\w+(?:\([^)]*\))?)*)(?:[ \t]|(?=\r?\n)))|(\})|((?:.|[\r\n\f])+?)/gi;
	const STYLE_REGEX = /(?:^|\.)(\w+)(?:\(([^)]*)\))?/g;
	const STRING_REGEX = /^(['"])((?:\\.|(?!\1)[^\\])*)\1$/;
	const ESCAPE_REGEX = /\\(u[a-f\d]{4}|x[a-f\d]{2}|.)|([^\\])/gi;

	const ESCAPES = new Map([
		['n', '\n'],
		['r', '\r'],
		['t', '\t'],
		['b', '\b'],
		['f', '\f'],
		['v', '\v'],
		['0', '\0'],
		['\\', '\\'],
		['e', '\u001B'],
		['a', '\u0007']
	]);

	function unescape(c) {
		if ((c[0] === 'u' && c.length === 5) || (c[0] === 'x' && c.length === 3)) {
			return String.fromCharCode(parseInt(c.slice(1), 16));
		}

		return ESCAPES.get(c) || c;
	}

	function parseArguments(name, args) {
		const results = [];
		const chunks = args.trim().split(/\s*,\s*/g);
		let matches;

		for (const chunk of chunks) {
			if (!isNaN(chunk)) {
				results.push(Number(chunk));
			} else if ((matches = chunk.match(STRING_REGEX))) {
				results.push(matches[2].replace(ESCAPE_REGEX, (m, escape, chr) => escape ? unescape(escape) : chr));
			} else {
				throw new Error(`Invalid Chalk template style argument: ${chunk} (in style '${name}')`);
			}
		}

		return results;
	}

	function parseStyle(style) {
		STYLE_REGEX.lastIndex = 0;

		const results = [];
		let matches;

		while ((matches = STYLE_REGEX.exec(style)) !== null) {
			const name = matches[1];

			if (matches[2]) {
				const args = parseArguments(name, matches[2]);
				results.push([name].concat(args));
			} else {
				results.push([name]);
			}
		}

		return results;
	}

	function buildStyle(chalk, styles) {
		const enabled = {};

		for (const layer of styles) {
			for (const style of layer.styles) {
				enabled[style[0]] = layer.inverse ? null : style.slice(1);
			}
		}

		let current = chalk;
		for (const styleName of Object.keys(enabled)) {
			if (Array.isArray(enabled[styleName])) {
				if (!(styleName in current)) {
					throw new Error(`Unknown Chalk style: ${styleName}`);
				}

				if (enabled[styleName].length > 0) {
					current = current[styleName].apply(current, enabled[styleName]);
				} else {
					current = current[styleName];
				}
			}
		}

		return current;
	}

	templates = (chalk, tmp) => {
		const styles = [];
		const chunks = [];
		let chunk = [];

		// eslint-disable-next-line max-params
		tmp.replace(TEMPLATE_REGEX, (m, escapeChar, inverse, style, close, chr) => {
			if (escapeChar) {
				chunk.push(unescape(escapeChar));
			} else if (style) {
				const str = chunk.join('');
				chunk = [];
				chunks.push(styles.length === 0 ? str : buildStyle(chalk, styles)(str));
				styles.push({inverse, styles: parseStyle(style)});
			} else if (close) {
				if (styles.length === 0) {
					throw new Error('Found extraneous } in Chalk template literal');
				}

				chunks.push(buildStyle(chalk, styles)(chunk.join('')));
				chunk = [];
				styles.pop();
			} else {
				chunk.push(chr);
			}
		});

		chunks.push(chunk.join(''));

		if (styles.length > 0) {
			const errMsg = `Chalk template literal is missing ${styles.length} closing bracket${styles.length === 1 ? '' : 's'} (\`}\`)`;
			throw new Error(errMsg);
		}

		return chunks.join('');
	};
	return templates;
}

chalk.exports;

var hasRequiredChalk;

function requireChalk () {
	if (hasRequiredChalk) return chalk.exports;
	hasRequiredChalk = 1;
	(function (module) {
		const escapeStringRegexp = requireEscapeStringRegexp();
		const ansiStyles = requireAnsiStyles();
		const stdoutColor = requireSupportsColor().stdout;

		const template = requireTemplates();

		const isSimpleWindowsTerm = process.platform === 'win32' && !(process.env.TERM || '').toLowerCase().startsWith('xterm');

		// `supportsColor.level` → `ansiStyles.color[name]` mapping
		const levelMapping = ['ansi', 'ansi', 'ansi256', 'ansi16m'];

		// `color-convert` models to exclude from the Chalk API due to conflicts and such
		const skipModels = new Set(['gray']);

		const styles = Object.create(null);

		function applyOptions(obj, options) {
			options = options || {};

			// Detect level if not set manually
			const scLevel = stdoutColor ? stdoutColor.level : 0;
			obj.level = options.level === undefined ? scLevel : options.level;
			obj.enabled = 'enabled' in options ? options.enabled : obj.level > 0;
		}

		function Chalk(options) {
			// We check for this.template here since calling `chalk.constructor()`
			// by itself will have a `this` of a previously constructed chalk object
			if (!this || !(this instanceof Chalk) || this.template) {
				const chalk = {};
				applyOptions(chalk, options);

				chalk.template = function () {
					const args = [].slice.call(arguments);
					return chalkTag.apply(null, [chalk.template].concat(args));
				};

				Object.setPrototypeOf(chalk, Chalk.prototype);
				Object.setPrototypeOf(chalk.template, chalk);

				chalk.template.constructor = Chalk;

				return chalk.template;
			}

			applyOptions(this, options);
		}

		// Use bright blue on Windows as the normal blue color is illegible
		if (isSimpleWindowsTerm) {
			ansiStyles.blue.open = '\u001B[94m';
		}

		for (const key of Object.keys(ansiStyles)) {
			ansiStyles[key].closeRe = new RegExp(escapeStringRegexp(ansiStyles[key].close), 'g');

			styles[key] = {
				get() {
					const codes = ansiStyles[key];
					return build.call(this, this._styles ? this._styles.concat(codes) : [codes], this._empty, key);
				}
			};
		}

		styles.visible = {
			get() {
				return build.call(this, this._styles || [], true, 'visible');
			}
		};

		ansiStyles.color.closeRe = new RegExp(escapeStringRegexp(ansiStyles.color.close), 'g');
		for (const model of Object.keys(ansiStyles.color.ansi)) {
			if (skipModels.has(model)) {
				continue;
			}

			styles[model] = {
				get() {
					const level = this.level;
					return function () {
						const open = ansiStyles.color[levelMapping[level]][model].apply(null, arguments);
						const codes = {
							open,
							close: ansiStyles.color.close,
							closeRe: ansiStyles.color.closeRe
						};
						return build.call(this, this._styles ? this._styles.concat(codes) : [codes], this._empty, model);
					};
				}
			};
		}

		ansiStyles.bgColor.closeRe = new RegExp(escapeStringRegexp(ansiStyles.bgColor.close), 'g');
		for (const model of Object.keys(ansiStyles.bgColor.ansi)) {
			if (skipModels.has(model)) {
				continue;
			}

			const bgModel = 'bg' + model[0].toUpperCase() + model.slice(1);
			styles[bgModel] = {
				get() {
					const level = this.level;
					return function () {
						const open = ansiStyles.bgColor[levelMapping[level]][model].apply(null, arguments);
						const codes = {
							open,
							close: ansiStyles.bgColor.close,
							closeRe: ansiStyles.bgColor.closeRe
						};
						return build.call(this, this._styles ? this._styles.concat(codes) : [codes], this._empty, model);
					};
				}
			};
		}

		const proto = Object.defineProperties(() => {}, styles);

		function build(_styles, _empty, key) {
			const builder = function () {
				return applyStyle.apply(builder, arguments);
			};

			builder._styles = _styles;
			builder._empty = _empty;

			const self = this;

			Object.defineProperty(builder, 'level', {
				enumerable: true,
				get() {
					return self.level;
				},
				set(level) {
					self.level = level;
				}
			});

			Object.defineProperty(builder, 'enabled', {
				enumerable: true,
				get() {
					return self.enabled;
				},
				set(enabled) {
					self.enabled = enabled;
				}
			});

			// See below for fix regarding invisible grey/dim combination on Windows
			builder.hasGrey = this.hasGrey || key === 'gray' || key === 'grey';

			// `__proto__` is used because we must return a function, but there is
			// no way to create a function with a different prototype
			builder.__proto__ = proto; // eslint-disable-line no-proto

			return builder;
		}

		function applyStyle() {
			// Support varags, but simply cast to string in case there's only one arg
			const args = arguments;
			const argsLen = args.length;
			let str = String(arguments[0]);

			if (argsLen === 0) {
				return '';
			}

			if (argsLen > 1) {
				// Don't slice `arguments`, it prevents V8 optimizations
				for (let a = 1; a < argsLen; a++) {
					str += ' ' + args[a];
				}
			}

			if (!this.enabled || this.level <= 0 || !str) {
				return this._empty ? '' : str;
			}

			// Turns out that on Windows dimmed gray text becomes invisible in cmd.exe,
			// see https://github.com/chalk/chalk/issues/58
			// If we're on Windows and we're dealing with a gray color, temporarily make 'dim' a noop.
			const originalDim = ansiStyles.dim.open;
			if (isSimpleWindowsTerm && this.hasGrey) {
				ansiStyles.dim.open = '';
			}

			for (const code of this._styles.slice().reverse()) {
				// Replace any instances already present with a re-opening code
				// otherwise only the part of the string until said closing code
				// will be colored, and the rest will simply be 'plain'.
				str = code.open + str.replace(code.closeRe, code.open) + code.close;

				// Close the styling before a linebreak and reopen
				// after next line to fix a bleed issue on macOS
				// https://github.com/chalk/chalk/pull/92
				str = str.replace(/\r?\n/g, `${code.close}$&${code.open}`);
			}

			// Reset the original `dim` if we changed it to work around the Windows dimmed gray issue
			ansiStyles.dim.open = originalDim;

			return str;
		}

		function chalkTag(chalk, strings) {
			if (!Array.isArray(strings)) {
				// If chalk() was called by itself or with a string,
				// return the string itself as a string.
				return [].slice.call(arguments, 1).join(' ');
			}

			const args = [].slice.call(arguments, 2);
			const parts = [strings.raw[0]];

			for (let i = 1; i < strings.length; i++) {
				parts.push(String(args[i - 1]).replace(/[{}\\]/g, '\\$&'));
				parts.push(String(strings.raw[i]));
			}

			return template(chalk, parts.join(''));
		}

		Object.defineProperties(Chalk.prototype, styles);

		module.exports = Chalk(); // eslint-disable-line new-cap
		module.exports.supportsColor = stdoutColor;
		module.exports.default = module.exports; // For TypeScript 
	} (chalk));
	return chalk.exports;
}

var hasRequiredLib$d;

function requireLib$d () {
	if (hasRequiredLib$d) return lib$9;
	hasRequiredLib$d = 1;

	Object.defineProperty(lib$9, "__esModule", {
	  value: true
	});
	lib$9.default = highlight;
	lib$9.shouldHighlight = shouldHighlight;
	var _jsTokens = requireJsTokens();
	var _helperValidatorIdentifier = requireLib$j();
	var _picocolors = _interopRequireWildcard(requirePicocolors(), true);
	function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
	function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
	const colors = typeof process === "object" && (process.env.FORCE_COLOR === "0" || process.env.FORCE_COLOR === "false") ? (0, _picocolors.createColors)(false) : _picocolors.default;
	const compose = (f, g) => v => f(g(v));
	const sometimesKeywords = new Set(["as", "async", "from", "get", "of", "set"]);
	function getDefs(colors) {
	  return {
	    keyword: colors.cyan,
	    capitalized: colors.yellow,
	    jsxIdentifier: colors.yellow,
	    punctuator: colors.yellow,
	    number: colors.magenta,
	    string: colors.green,
	    regex: colors.magenta,
	    comment: colors.gray,
	    invalid: compose(compose(colors.white, colors.bgRed), colors.bold)
	  };
	}
	const NEWLINE = /\r\n|[\n\r\u2028\u2029]/;
	const BRACKET = /^[()[\]{}]$/;
	let tokenize;
	{
	  const JSX_TAG = /^[a-z][\w-]*$/i;
	  const getTokenType = function (token, offset, text) {
	    if (token.type === "name") {
	      if ((0, _helperValidatorIdentifier.isKeyword)(token.value) || (0, _helperValidatorIdentifier.isStrictReservedWord)(token.value, true) || sometimesKeywords.has(token.value)) {
	        return "keyword";
	      }
	      if (JSX_TAG.test(token.value) && (text[offset - 1] === "<" || text.slice(offset - 2, offset) === "</")) {
	        return "jsxIdentifier";
	      }
	      if (token.value[0] !== token.value[0].toLowerCase()) {
	        return "capitalized";
	      }
	    }
	    if (token.type === "punctuator" && BRACKET.test(token.value)) {
	      return "bracket";
	    }
	    if (token.type === "invalid" && (token.value === "@" || token.value === "#")) {
	      return "punctuator";
	    }
	    return token.type;
	  };
	  tokenize = function* (text) {
	    let match;
	    while (match = _jsTokens.default.exec(text)) {
	      const token = _jsTokens.matchToToken(match);
	      yield {
	        type: getTokenType(token, match.index, text),
	        value: token.value
	      };
	    }
	  };
	}
	function highlightTokens(defs, text) {
	  let highlighted = "";
	  for (const {
	    type,
	    value
	  } of tokenize(text)) {
	    const colorize = defs[type];
	    if (colorize) {
	      highlighted += value.split(NEWLINE).map(str => colorize(str)).join("\n");
	    } else {
	      highlighted += value;
	    }
	  }
	  return highlighted;
	}
	function shouldHighlight(options) {
	  return colors.isColorSupported || options.forceColor;
	}
	let pcWithForcedColor = undefined;
	function getColors(forceColor) {
	  if (forceColor) {
	    var _pcWithForcedColor;
	    (_pcWithForcedColor = pcWithForcedColor) != null ? _pcWithForcedColor : pcWithForcedColor = (0, _picocolors.createColors)(true);
	    return pcWithForcedColor;
	  }
	  return colors;
	}
	function highlight(code, options = {}) {
	  if (code !== "" && shouldHighlight(options)) {
	    const defs = getDefs(getColors(options.forceColor));
	    return highlightTokens(defs, code);
	  } else {
	    return code;
	  }
	}
	{
	  let chalk, chalkWithForcedColor;
	  lib$9.getChalk = ({
	    forceColor
	  }) => {
	    var _chalk;
	    (_chalk = chalk) != null ? _chalk : chalk = requireChalk();
	    if (forceColor) {
	      var _chalkWithForcedColor;
	      (_chalkWithForcedColor = chalkWithForcedColor) != null ? _chalkWithForcedColor : chalkWithForcedColor = new chalk.constructor({
	        enabled: true,
	        level: 1
	      });
	      return chalkWithForcedColor;
	    }
	    return chalk;
	  };
	}

	
	return lib$9;
}

var hasRequiredLib$c;

function requireLib$c () {
	if (hasRequiredLib$c) return lib$a;
	hasRequiredLib$c = 1;

	Object.defineProperty(lib$a, "__esModule", {
	  value: true
	});
	lib$a.codeFrameColumns = codeFrameColumns;
	lib$a.default = _default;
	var _highlight = requireLib$d();
	var _picocolors = _interopRequireWildcard(requirePicocolors(), true);
	function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
	function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
	const colors = typeof process === "object" && (process.env.FORCE_COLOR === "0" || process.env.FORCE_COLOR === "false") ? (0, _picocolors.createColors)(false) : _picocolors.default;
	const compose = (f, g) => v => f(g(v));
	let pcWithForcedColor = undefined;
	function getColors(forceColor) {
	  if (forceColor) {
	    var _pcWithForcedColor;
	    (_pcWithForcedColor = pcWithForcedColor) != null ? _pcWithForcedColor : pcWithForcedColor = (0, _picocolors.createColors)(true);
	    return pcWithForcedColor;
	  }
	  return colors;
	}
	let deprecationWarningShown = false;
	function getDefs(colors) {
	  return {
	    gutter: colors.gray,
	    marker: compose(colors.red, colors.bold),
	    message: compose(colors.red, colors.bold)
	  };
	}
	const NEWLINE = /\r\n|[\n\r\u2028\u2029]/;
	function getMarkerLines(loc, source, opts) {
	  const startLoc = Object.assign({
	    column: 0,
	    line: -1
	  }, loc.start);
	  const endLoc = Object.assign({}, startLoc, loc.end);
	  const {
	    linesAbove = 2,
	    linesBelow = 3
	  } = opts || {};
	  const startLine = startLoc.line;
	  const startColumn = startLoc.column;
	  const endLine = endLoc.line;
	  const endColumn = endLoc.column;
	  let start = Math.max(startLine - (linesAbove + 1), 0);
	  let end = Math.min(source.length, endLine + linesBelow);
	  if (startLine === -1) {
	    start = 0;
	  }
	  if (endLine === -1) {
	    end = source.length;
	  }
	  const lineDiff = endLine - startLine;
	  const markerLines = {};
	  if (lineDiff) {
	    for (let i = 0; i <= lineDiff; i++) {
	      const lineNumber = i + startLine;
	      if (!startColumn) {
	        markerLines[lineNumber] = true;
	      } else if (i === 0) {
	        const sourceLength = source[lineNumber - 1].length;
	        markerLines[lineNumber] = [startColumn, sourceLength - startColumn + 1];
	      } else if (i === lineDiff) {
	        markerLines[lineNumber] = [0, endColumn];
	      } else {
	        const sourceLength = source[lineNumber - i].length;
	        markerLines[lineNumber] = [0, sourceLength];
	      }
	    }
	  } else {
	    if (startColumn === endColumn) {
	      if (startColumn) {
	        markerLines[startLine] = [startColumn, 0];
	      } else {
	        markerLines[startLine] = true;
	      }
	    } else {
	      markerLines[startLine] = [startColumn, endColumn - startColumn];
	    }
	  }
	  return {
	    start,
	    end,
	    markerLines
	  };
	}
	function codeFrameColumns(rawLines, loc, opts = {}) {
	  const highlighted = (opts.highlightCode || opts.forceColor) && (0, _highlight.shouldHighlight)(opts);
	  const colors = getColors(opts.forceColor);
	  const defs = getDefs(colors);
	  const maybeHighlight = (fmt, string) => {
	    return highlighted ? fmt(string) : string;
	  };
	  const lines = rawLines.split(NEWLINE);
	  const {
	    start,
	    end,
	    markerLines
	  } = getMarkerLines(loc, lines, opts);
	  const hasColumns = loc.start && typeof loc.start.column === "number";
	  const numberMaxWidth = String(end).length;
	  const highlightedLines = highlighted ? (0, _highlight.default)(rawLines, opts) : rawLines;
	  let frame = highlightedLines.split(NEWLINE, end).slice(start, end).map((line, index) => {
	    const number = start + 1 + index;
	    const paddedNumber = ` ${number}`.slice(-numberMaxWidth);
	    const gutter = ` ${paddedNumber} |`;
	    const hasMarker = markerLines[number];
	    const lastMarkerLine = !markerLines[number + 1];
	    if (hasMarker) {
	      let markerLine = "";
	      if (Array.isArray(hasMarker)) {
	        const markerSpacing = line.slice(0, Math.max(hasMarker[0] - 1, 0)).replace(/[^\t]/g, " ");
	        const numberOfMarkers = hasMarker[1] || 1;
	        markerLine = ["\n ", maybeHighlight(defs.gutter, gutter.replace(/\d/g, " ")), " ", markerSpacing, maybeHighlight(defs.marker, "^").repeat(numberOfMarkers)].join("");
	        if (lastMarkerLine && opts.message) {
	          markerLine += " " + maybeHighlight(defs.message, opts.message);
	        }
	      }
	      return [maybeHighlight(defs.marker, ">"), maybeHighlight(defs.gutter, gutter), line.length > 0 ? ` ${line}` : "", markerLine].join("");
	    } else {
	      return ` ${maybeHighlight(defs.gutter, gutter)}${line.length > 0 ? ` ${line}` : ""}`;
	    }
	  }).join("\n");
	  if (opts.message && !hasColumns) {
	    frame = `${" ".repeat(numberMaxWidth + 1)}${opts.message}\n${frame}`;
	  }
	  if (highlighted) {
	    return colors.reset(frame);
	  } else {
	    return frame;
	  }
	}
	function _default(rawLines, lineNumber, colNumber, opts = {}) {
	  if (!deprecationWarningShown) {
	    deprecationWarningShown = true;
	    const message = "Passing lineNumber and colNumber is deprecated to @babel/code-frame. Please use `codeFrameColumns`.";
	    if (process.emitWarning) {
	      process.emitWarning(message, "DeprecationWarning");
	    } else {
	      const deprecationError = new Error(message);
	      deprecationError.name = "DeprecationWarning";
	      console.warn(new Error(message));
	    }
	  }
	  colNumber = Math.max(colNumber, 0);
	  const location = {
	    start: {
	      column: colNumber,
	      line: lineNumber
	    }
	  };
	  return codeFrameColumns(rawLines, location, opts);
	}

	
	return lib$a;
}

var lib$8 = {};

var hasRequiredLib$b;

function requireLib$b () {
	if (hasRequiredLib$b) return lib$8;
	hasRequiredLib$b = 1;

	Object.defineProperty(lib$8, '__esModule', {
	  value: true
	});
	function _objectWithoutPropertiesLoose(source, excluded) {
	  if (source == null) return {};
	  var target = {};
	  var sourceKeys = Object.keys(source);
	  var key, i;
	  for (i = 0; i < sourceKeys.length; i++) {
	    key = sourceKeys[i];
	    if (excluded.indexOf(key) >= 0) continue;
	    target[key] = source[key];
	  }
	  return target;
	}
	class Position {
	  constructor(line, col, index) {
	    this.line = void 0;
	    this.column = void 0;
	    this.index = void 0;
	    this.line = line;
	    this.column = col;
	    this.index = index;
	  }
	}
	class SourceLocation {
	  constructor(start, end) {
	    this.start = void 0;
	    this.end = void 0;
	    this.filename = void 0;
	    this.identifierName = void 0;
	    this.start = start;
	    this.end = end;
	  }
	}
	function createPositionWithColumnOffset(position, columnOffset) {
	  const {
	    line,
	    column,
	    index
	  } = position;
	  return new Position(line, column + columnOffset, index + columnOffset);
	}
	const code = "BABEL_PARSER_SOURCETYPE_MODULE_REQUIRED";
	var ModuleErrors = {
	  ImportMetaOutsideModule: {
	    message: `import.meta may appear only with 'sourceType: "module"'`,
	    code
	  },
	  ImportOutsideModule: {
	    message: `'import' and 'export' may appear only with 'sourceType: "module"'`,
	    code
	  }
	};
	const NodeDescriptions = {
	  ArrayPattern: "array destructuring pattern",
	  AssignmentExpression: "assignment expression",
	  AssignmentPattern: "assignment expression",
	  ArrowFunctionExpression: "arrow function expression",
	  ConditionalExpression: "conditional expression",
	  CatchClause: "catch clause",
	  ForOfStatement: "for-of statement",
	  ForInStatement: "for-in statement",
	  ForStatement: "for-loop",
	  FormalParameters: "function parameter list",
	  Identifier: "identifier",
	  ImportSpecifier: "import specifier",
	  ImportDefaultSpecifier: "import default specifier",
	  ImportNamespaceSpecifier: "import namespace specifier",
	  ObjectPattern: "object destructuring pattern",
	  ParenthesizedExpression: "parenthesized expression",
	  RestElement: "rest element",
	  UpdateExpression: {
	    true: "prefix operation",
	    false: "postfix operation"
	  },
	  VariableDeclarator: "variable declaration",
	  YieldExpression: "yield expression"
	};
	const toNodeDescription = node => node.type === "UpdateExpression" ? NodeDescriptions.UpdateExpression[`${node.prefix}`] : NodeDescriptions[node.type];
	var StandardErrors = {
	  AccessorIsGenerator: ({
	    kind
	  }) => `A ${kind}ter cannot be a generator.`,
	  ArgumentsInClass: "'arguments' is only allowed in functions and class methods.",
	  AsyncFunctionInSingleStatementContext: "Async functions can only be declared at the top level or inside a block.",
	  AwaitBindingIdentifier: "Can not use 'await' as identifier inside an async function.",
	  AwaitBindingIdentifierInStaticBlock: "Can not use 'await' as identifier inside a static block.",
	  AwaitExpressionFormalParameter: "'await' is not allowed in async function parameters.",
	  AwaitUsingNotInAsyncContext: "'await using' is only allowed within async functions and at the top levels of modules.",
	  AwaitNotInAsyncContext: "'await' is only allowed within async functions and at the top levels of modules.",
	  AwaitNotInAsyncFunction: "'await' is only allowed within async functions.",
	  BadGetterArity: "A 'get' accessor must not have any formal parameters.",
	  BadSetterArity: "A 'set' accessor must have exactly one formal parameter.",
	  BadSetterRestParameter: "A 'set' accessor function argument must not be a rest parameter.",
	  ConstructorClassField: "Classes may not have a field named 'constructor'.",
	  ConstructorClassPrivateField: "Classes may not have a private field named '#constructor'.",
	  ConstructorIsAccessor: "Class constructor may not be an accessor.",
	  ConstructorIsAsync: "Constructor can't be an async function.",
	  ConstructorIsGenerator: "Constructor can't be a generator.",
	  DeclarationMissingInitializer: ({
	    kind
	  }) => `Missing initializer in ${kind} declaration.`,
	  DecoratorArgumentsOutsideParentheses: "Decorator arguments must be moved inside parentheses: use '@(decorator(args))' instead of '@(decorator)(args)'.",
	  DecoratorBeforeExport: "Decorators must be placed *before* the 'export' keyword. Remove the 'decoratorsBeforeExport: true' option to use the 'export @decorator class {}' syntax.",
	  DecoratorsBeforeAfterExport: "Decorators can be placed *either* before or after the 'export' keyword, but not in both locations at the same time.",
	  DecoratorConstructor: "Decorators can't be used with a constructor. Did you mean '@dec class { ... }'?",
	  DecoratorExportClass: "Decorators must be placed *after* the 'export' keyword. Remove the 'decoratorsBeforeExport: false' option to use the '@decorator export class {}' syntax.",
	  DecoratorSemicolon: "Decorators must not be followed by a semicolon.",
	  DecoratorStaticBlock: "Decorators can't be used with a static block.",
	  DeferImportRequiresNamespace: 'Only `import defer * as x from "./module"` is valid.',
	  DeletePrivateField: "Deleting a private field is not allowed.",
	  DestructureNamedImport: "ES2015 named imports do not destructure. Use another statement for destructuring after the import.",
	  DuplicateConstructor: "Duplicate constructor in the same class.",
	  DuplicateDefaultExport: "Only one default export allowed per module.",
	  DuplicateExport: ({
	    exportName
	  }) => `\`${exportName}\` has already been exported. Exported identifiers must be unique.`,
	  DuplicateProto: "Redefinition of __proto__ property.",
	  DuplicateRegExpFlags: "Duplicate regular expression flag.",
	  DynamicImportPhaseRequiresImportExpressions: ({
	    phase
	  }) => `'import.${phase}(...)' can only be parsed when using the 'createImportExpressions' option.`,
	  ElementAfterRest: "Rest element must be last element.",
	  EscapedCharNotAnIdentifier: "Invalid Unicode escape.",
	  ExportBindingIsString: ({
	    localName,
	    exportName
	  }) => `A string literal cannot be used as an exported binding without \`from\`.\n- Did you mean \`export { '${localName}' as '${exportName}' } from 'some-module'\`?`,
	  ExportDefaultFromAsIdentifier: "'from' is not allowed as an identifier after 'export default'.",
	  ForInOfLoopInitializer: ({
	    type
	  }) => `'${type === "ForInStatement" ? "for-in" : "for-of"}' loop variable declaration may not have an initializer.`,
	  ForInUsing: "For-in loop may not start with 'using' declaration.",
	  ForOfAsync: "The left-hand side of a for-of loop may not be 'async'.",
	  ForOfLet: "The left-hand side of a for-of loop may not start with 'let'.",
	  GeneratorInSingleStatementContext: "Generators can only be declared at the top level or inside a block.",
	  IllegalBreakContinue: ({
	    type
	  }) => `Unsyntactic ${type === "BreakStatement" ? "break" : "continue"}.`,
	  IllegalLanguageModeDirective: "Illegal 'use strict' directive in function with non-simple parameter list.",
	  IllegalReturn: "'return' outside of function.",
	  ImportAttributesUseAssert: "The `assert` keyword in import attributes is deprecated and it has been replaced by the `with` keyword. You can enable the `deprecatedAssertSyntax: true` option in the import attributes plugin to suppress this error.",
	  ImportBindingIsString: ({
	    importName
	  }) => `A string literal cannot be used as an imported binding.\n- Did you mean \`import { "${importName}" as foo }\`?`,
	  ImportCallArgumentTrailingComma: "Trailing comma is disallowed inside import(...) arguments.",
	  ImportCallArity: ({
	    maxArgumentCount
	  }) => `\`import()\` requires exactly ${maxArgumentCount === 1 ? "one argument" : "one or two arguments"}.`,
	  ImportCallNotNewExpression: "Cannot use new with import(...).",
	  ImportCallSpreadArgument: "`...` is not allowed in `import()`.",
	  ImportJSONBindingNotDefault: "A JSON module can only be imported with `default`.",
	  ImportReflectionHasAssertion: "`import module x` cannot have assertions.",
	  ImportReflectionNotBinding: 'Only `import module x from "./module"` is valid.',
	  IncompatibleRegExpUVFlags: "The 'u' and 'v' regular expression flags cannot be enabled at the same time.",
	  InvalidBigIntLiteral: "Invalid BigIntLiteral.",
	  InvalidCodePoint: "Code point out of bounds.",
	  InvalidCoverInitializedName: "Invalid shorthand property initializer.",
	  InvalidDecimal: "Invalid decimal.",
	  InvalidDigit: ({
	    radix
	  }) => `Expected number in radix ${radix}.`,
	  InvalidEscapeSequence: "Bad character escape sequence.",
	  InvalidEscapeSequenceTemplate: "Invalid escape sequence in template.",
	  InvalidEscapedReservedWord: ({
	    reservedWord
	  }) => `Escape sequence in keyword ${reservedWord}.`,
	  InvalidIdentifier: ({
	    identifierName
	  }) => `Invalid identifier ${identifierName}.`,
	  InvalidLhs: ({
	    ancestor
	  }) => `Invalid left-hand side in ${toNodeDescription(ancestor)}.`,
	  InvalidLhsBinding: ({
	    ancestor
	  }) => `Binding invalid left-hand side in ${toNodeDescription(ancestor)}.`,
	  InvalidLhsOptionalChaining: ({
	    ancestor
	  }) => `Invalid optional chaining in the left-hand side of ${toNodeDescription(ancestor)}.`,
	  InvalidNumber: "Invalid number.",
	  InvalidOrMissingExponent: "Floating-point numbers require a valid exponent after the 'e'.",
	  InvalidOrUnexpectedToken: ({
	    unexpected
	  }) => `Unexpected character '${unexpected}'.`,
	  InvalidParenthesizedAssignment: "Invalid parenthesized assignment pattern.",
	  InvalidPrivateFieldResolution: ({
	    identifierName
	  }) => `Private name #${identifierName} is not defined.`,
	  InvalidPropertyBindingPattern: "Binding member expression.",
	  InvalidRecordProperty: "Only properties and spread elements are allowed in record definitions.",
	  InvalidRestAssignmentPattern: "Invalid rest operator's argument.",
	  LabelRedeclaration: ({
	    labelName
	  }) => `Label '${labelName}' is already declared.`,
	  LetInLexicalBinding: "'let' is disallowed as a lexically bound name.",
	  LineTerminatorBeforeArrow: "No line break is allowed before '=>'.",
	  MalformedRegExpFlags: "Invalid regular expression flag.",
	  MissingClassName: "A class name is required.",
	  MissingEqInAssignment: "Only '=' operator can be used for specifying default value.",
	  MissingSemicolon: "Missing semicolon.",
	  MissingPlugin: ({
	    missingPlugin
	  }) => `This experimental syntax requires enabling the parser plugin: ${missingPlugin.map(name => JSON.stringify(name)).join(", ")}.`,
	  MissingOneOfPlugins: ({
	    missingPlugin
	  }) => `This experimental syntax requires enabling one of the following parser plugin(s): ${missingPlugin.map(name => JSON.stringify(name)).join(", ")}.`,
	  MissingUnicodeEscape: "Expecting Unicode escape sequence \\uXXXX.",
	  MixingCoalesceWithLogical: "Nullish coalescing operator(??) requires parens when mixing with logical operators.",
	  ModuleAttributeDifferentFromType: "The only accepted module attribute is `type`.",
	  ModuleAttributeInvalidValue: "Only string literals are allowed as module attribute values.",
	  ModuleAttributesWithDuplicateKeys: ({
	    key
	  }) => `Duplicate key "${key}" is not allowed in module attributes.`,
	  ModuleExportNameHasLoneSurrogate: ({
	    surrogateCharCode
	  }) => `An export name cannot include a lone surrogate, found '\\u${surrogateCharCode.toString(16)}'.`,
	  ModuleExportUndefined: ({
	    localName
	  }) => `Export '${localName}' is not defined.`,
	  MultipleDefaultsInSwitch: "Multiple default clauses.",
	  NewlineAfterThrow: "Illegal newline after throw.",
	  NoCatchOrFinally: "Missing catch or finally clause.",
	  NumberIdentifier: "Identifier directly after number.",
	  NumericSeparatorInEscapeSequence: "Numeric separators are not allowed inside unicode escape sequences or hex escape sequences.",
	  ObsoleteAwaitStar: "'await*' has been removed from the async functions proposal. Use Promise.all() instead.",
	  OptionalChainingNoNew: "Constructors in/after an Optional Chain are not allowed.",
	  OptionalChainingNoTemplate: "Tagged Template Literals are not allowed in optionalChain.",
	  OverrideOnConstructor: "'override' modifier cannot appear on a constructor declaration.",
	  ParamDupe: "Argument name clash.",
	  PatternHasAccessor: "Object pattern can't contain getter or setter.",
	  PatternHasMethod: "Object pattern can't contain methods.",
	  PrivateInExpectedIn: ({
	    identifierName
	  }) => `Private names are only allowed in property accesses (\`obj.#${identifierName}\`) or in \`in\` expressions (\`#${identifierName} in obj\`).`,
	  PrivateNameRedeclaration: ({
	    identifierName
	  }) => `Duplicate private name #${identifierName}.`,
	  RecordExpressionBarIncorrectEndSyntaxType: "Record expressions ending with '|}' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'bar'.",
	  RecordExpressionBarIncorrectStartSyntaxType: "Record expressions starting with '{|' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'bar'.",
	  RecordExpressionHashIncorrectStartSyntaxType: "Record expressions starting with '#{' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'hash'.",
	  RecordNoProto: "'__proto__' is not allowed in Record expressions.",
	  RestTrailingComma: "Unexpected trailing comma after rest element.",
	  SloppyFunction: "In non-strict mode code, functions can only be declared at top level or inside a block.",
	  SloppyFunctionAnnexB: "In non-strict mode code, functions can only be declared at top level, inside a block, or as the body of an if statement.",
	  SourcePhaseImportRequiresDefault: 'Only `import source x from "./module"` is valid.',
	  StaticPrototype: "Classes may not have static property named prototype.",
	  SuperNotAllowed: "`super()` is only valid inside a class constructor of a subclass. Maybe a typo in the method name ('constructor') or not extending another class?",
	  SuperPrivateField: "Private fields can't be accessed on super.",
	  TrailingDecorator: "Decorators must be attached to a class element.",
	  TupleExpressionBarIncorrectEndSyntaxType: "Tuple expressions ending with '|]' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'bar'.",
	  TupleExpressionBarIncorrectStartSyntaxType: "Tuple expressions starting with '[|' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'bar'.",
	  TupleExpressionHashIncorrectStartSyntaxType: "Tuple expressions starting with '#[' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'hash'.",
	  UnexpectedArgumentPlaceholder: "Unexpected argument placeholder.",
	  UnexpectedAwaitAfterPipelineBody: 'Unexpected "await" after pipeline body; await must have parentheses in minimal proposal.',
	  UnexpectedDigitAfterHash: "Unexpected digit after hash token.",
	  UnexpectedImportExport: "'import' and 'export' may only appear at the top level.",
	  UnexpectedKeyword: ({
	    keyword
	  }) => `Unexpected keyword '${keyword}'.`,
	  UnexpectedLeadingDecorator: "Leading decorators must be attached to a class declaration.",
	  UnexpectedLexicalDeclaration: "Lexical declaration cannot appear in a single-statement context.",
	  UnexpectedNewTarget: "`new.target` can only be used in functions or class properties.",
	  UnexpectedNumericSeparator: "A numeric separator is only allowed between two digits.",
	  UnexpectedPrivateField: "Unexpected private name.",
	  UnexpectedReservedWord: ({
	    reservedWord
	  }) => `Unexpected reserved word '${reservedWord}'.`,
	  UnexpectedSuper: "'super' is only allowed in object methods and classes.",
	  UnexpectedToken: ({
	    expected,
	    unexpected
	  }) => `Unexpected token${unexpected ? ` '${unexpected}'.` : ""}${expected ? `, expected "${expected}"` : ""}`,
	  UnexpectedTokenUnaryExponentiation: "Illegal expression. Wrap left hand side or entire exponentiation in parentheses.",
	  UnexpectedUsingDeclaration: "Using declaration cannot appear in the top level when source type is `script`.",
	  UnsupportedBind: "Binding should be performed on object property.",
	  UnsupportedDecoratorExport: "A decorated export must export a class declaration.",
	  UnsupportedDefaultExport: "Only expressions, functions or classes are allowed as the `default` export.",
	  UnsupportedImport: "`import` can only be used in `import()` or `import.meta`.",
	  UnsupportedMetaProperty: ({
	    target,
	    onlyValidPropertyName
	  }) => `The only valid meta property for ${target} is ${target}.${onlyValidPropertyName}.`,
	  UnsupportedParameterDecorator: "Decorators cannot be used to decorate parameters.",
	  UnsupportedPropertyDecorator: "Decorators cannot be used to decorate object literal properties.",
	  UnsupportedSuper: "'super' can only be used with function calls (i.e. super()) or in property accesses (i.e. super.prop or super[prop]).",
	  UnterminatedComment: "Unterminated comment.",
	  UnterminatedRegExp: "Unterminated regular expression.",
	  UnterminatedString: "Unterminated string constant.",
	  UnterminatedTemplate: "Unterminated template.",
	  UsingDeclarationExport: "Using declaration cannot be exported.",
	  UsingDeclarationHasBindingPattern: "Using declaration cannot have destructuring patterns.",
	  VarRedeclaration: ({
	    identifierName
	  }) => `Identifier '${identifierName}' has already been declared.`,
	  YieldBindingIdentifier: "Can not use 'yield' as identifier inside a generator.",
	  YieldInParameter: "Yield expression is not allowed in formal parameters.",
	  ZeroDigitNumericSeparator: "Numeric separator can not be used after leading 0."
	};
	var StrictModeErrors = {
	  StrictDelete: "Deleting local variable in strict mode.",
	  StrictEvalArguments: ({
	    referenceName
	  }) => `Assigning to '${referenceName}' in strict mode.`,
	  StrictEvalArgumentsBinding: ({
	    bindingName
	  }) => `Binding '${bindingName}' in strict mode.`,
	  StrictFunction: "In strict mode code, functions can only be declared at top level or inside a block.",
	  StrictNumericEscape: "The only valid numeric escape in strict mode is '\\0'.",
	  StrictOctalLiteral: "Legacy octal literals are not allowed in strict mode.",
	  StrictWith: "'with' in strict mode."
	};
	const UnparenthesizedPipeBodyDescriptions = new Set(["ArrowFunctionExpression", "AssignmentExpression", "ConditionalExpression", "YieldExpression"]);
	var PipelineOperatorErrors = {
	  PipeBodyIsTighter: "Unexpected yield after pipeline body; any yield expression acting as Hack-style pipe body must be parenthesized due to its loose operator precedence.",
	  PipeTopicRequiresHackPipes: 'Topic reference is used, but the pipelineOperator plugin was not passed a "proposal": "hack" or "smart" option.',
	  PipeTopicUnbound: "Topic reference is unbound; it must be inside a pipe body.",
	  PipeTopicUnconfiguredToken: ({
	    token
	  }) => `Invalid topic token ${token}. In order to use ${token} as a topic reference, the pipelineOperator plugin must be configured with { "proposal": "hack", "topicToken": "${token}" }.`,
	  PipeTopicUnused: "Hack-style pipe body does not contain a topic reference; Hack-style pipes must use topic at least once.",
	  PipeUnparenthesizedBody: ({
	    type
	  }) => `Hack-style pipe body cannot be an unparenthesized ${toNodeDescription({
	    type
	  })}; please wrap it in parentheses.`,
	  PipelineBodyNoArrow: 'Unexpected arrow "=>" after pipeline body; arrow function in pipeline body must be parenthesized.',
	  PipelineBodySequenceExpression: "Pipeline body may not be a comma-separated sequence expression.",
	  PipelineHeadSequenceExpression: "Pipeline head should not be a comma-separated sequence expression.",
	  PipelineTopicUnused: "Pipeline is in topic style but does not use topic reference.",
	  PrimaryTopicNotAllowed: "Topic reference was used in a lexical context without topic binding.",
	  PrimaryTopicRequiresSmartPipeline: 'Topic reference is used, but the pipelineOperator plugin was not passed a "proposal": "hack" or "smart" option.'
	};
	const _excluded = ["toMessage"],
	  _excluded2 = ["message"];
	function defineHidden(obj, key, value) {
	  Object.defineProperty(obj, key, {
	    enumerable: false,
	    configurable: true,
	    value
	  });
	}
	function toParseErrorConstructor(_ref) {
	  let {
	      toMessage
	    } = _ref,
	    properties = _objectWithoutPropertiesLoose(_ref, _excluded);
	  return function constructor(loc, details) {
	    const error = new SyntaxError();
	    Object.assign(error, properties, {
	      loc,
	      pos: loc.index
	    });
	    if ("missingPlugin" in details) {
	      Object.assign(error, {
	        missingPlugin: details.missingPlugin
	      });
	    }
	    defineHidden(error, "clone", function clone(overrides = {}) {
	      var _overrides$loc;
	      const {
	        line,
	        column,
	        index
	      } = (_overrides$loc = overrides.loc) != null ? _overrides$loc : loc;
	      return constructor(new Position(line, column, index), Object.assign({}, details, overrides.details));
	    });
	    defineHidden(error, "details", details);
	    Object.defineProperty(error, "message", {
	      configurable: true,
	      get() {
	        const message = `${toMessage(details)} (${loc.line}:${loc.column})`;
	        this.message = message;
	        return message;
	      },
	      set(value) {
	        Object.defineProperty(this, "message", {
	          value,
	          writable: true
	        });
	      }
	    });
	    return error;
	  };
	}
	function ParseErrorEnum(argument, syntaxPlugin) {
	  if (Array.isArray(argument)) {
	    return parseErrorTemplates => ParseErrorEnum(parseErrorTemplates, argument[0]);
	  }
	  const ParseErrorConstructors = {};
	  for (const reasonCode of Object.keys(argument)) {
	    const template = argument[reasonCode];
	    const _ref2 = typeof template === "string" ? {
	        message: () => template
	      } : typeof template === "function" ? {
	        message: template
	      } : template,
	      {
	        message
	      } = _ref2,
	      rest = _objectWithoutPropertiesLoose(_ref2, _excluded2);
	    const toMessage = typeof message === "string" ? () => message : message;
	    ParseErrorConstructors[reasonCode] = toParseErrorConstructor(Object.assign({
	      code: "BABEL_PARSER_SYNTAX_ERROR",
	      reasonCode,
	      toMessage
	    }, syntaxPlugin ? {
	      syntaxPlugin
	    } : {}, rest));
	  }
	  return ParseErrorConstructors;
	}
	const Errors = Object.assign({}, ParseErrorEnum(ModuleErrors), ParseErrorEnum(StandardErrors), ParseErrorEnum(StrictModeErrors), ParseErrorEnum`pipelineOperator`(PipelineOperatorErrors));
	const {
	  defineProperty
	} = Object;
	const toUnenumerable = (object, key) => defineProperty(object, key, {
	  enumerable: false,
	  value: object[key]
	});
	function toESTreeLocation(node) {
	  node.loc.start && toUnenumerable(node.loc.start, "index");
	  node.loc.end && toUnenumerable(node.loc.end, "index");
	  return node;
	}
	var estree = superClass => class ESTreeParserMixin extends superClass {
	  parse() {
	    const file = toESTreeLocation(super.parse());
	    if (this.options.tokens) {
	      file.tokens = file.tokens.map(toESTreeLocation);
	    }
	    return file;
	  }
	  parseRegExpLiteral({
	    pattern,
	    flags
	  }) {
	    let regex = null;
	    try {
	      regex = new RegExp(pattern, flags);
	    } catch (e) {}
	    const node = this.estreeParseLiteral(regex);
	    node.regex = {
	      pattern,
	      flags
	    };
	    return node;
	  }
	  parseBigIntLiteral(value) {
	    let bigInt;
	    try {
	      bigInt = BigInt(value);
	    } catch (_unused) {
	      bigInt = null;
	    }
	    const node = this.estreeParseLiteral(bigInt);
	    node.bigint = String(node.value || value);
	    return node;
	  }
	  parseDecimalLiteral(value) {
	    const decimal = null;
	    const node = this.estreeParseLiteral(decimal);
	    node.decimal = String(node.value || value);
	    return node;
	  }
	  estreeParseLiteral(value) {
	    return this.parseLiteral(value, "Literal");
	  }
	  parseStringLiteral(value) {
	    return this.estreeParseLiteral(value);
	  }
	  parseNumericLiteral(value) {
	    return this.estreeParseLiteral(value);
	  }
	  parseNullLiteral() {
	    return this.estreeParseLiteral(null);
	  }
	  parseBooleanLiteral(value) {
	    return this.estreeParseLiteral(value);
	  }
	  directiveToStmt(directive) {
	    const expression = directive.value;
	    delete directive.value;
	    expression.type = "Literal";
	    expression.raw = expression.extra.raw;
	    expression.value = expression.extra.expressionValue;
	    const stmt = directive;
	    stmt.type = "ExpressionStatement";
	    stmt.expression = expression;
	    stmt.directive = expression.extra.rawValue;
	    delete expression.extra;
	    return stmt;
	  }
	  initFunction(node, isAsync) {
	    super.initFunction(node, isAsync);
	    node.expression = false;
	  }
	  checkDeclaration(node) {
	    if (node != null && this.isObjectProperty(node)) {
	      this.checkDeclaration(node.value);
	    } else {
	      super.checkDeclaration(node);
	    }
	  }
	  getObjectOrClassMethodParams(method) {
	    return method.value.params;
	  }
	  isValidDirective(stmt) {
	    var _stmt$expression$extr;
	    return stmt.type === "ExpressionStatement" && stmt.expression.type === "Literal" && typeof stmt.expression.value === "string" && !((_stmt$expression$extr = stmt.expression.extra) != null && _stmt$expression$extr.parenthesized);
	  }
	  parseBlockBody(node, allowDirectives, topLevel, end, afterBlockParse) {
	    super.parseBlockBody(node, allowDirectives, topLevel, end, afterBlockParse);
	    const directiveStatements = node.directives.map(d => this.directiveToStmt(d));
	    node.body = directiveStatements.concat(node.body);
	    delete node.directives;
	  }
	  pushClassMethod(classBody, method, isGenerator, isAsync, isConstructor, allowsDirectSuper) {
	    this.parseMethod(method, isGenerator, isAsync, isConstructor, allowsDirectSuper, "ClassMethod", true);
	    if (method.typeParameters) {
	      method.value.typeParameters = method.typeParameters;
	      delete method.typeParameters;
	    }
	    classBody.body.push(method);
	  }
	  parsePrivateName() {
	    const node = super.parsePrivateName();
	    {
	      if (!this.getPluginOption("estree", "classFeatures")) {
	        return node;
	      }
	    }
	    return this.convertPrivateNameToPrivateIdentifier(node);
	  }
	  convertPrivateNameToPrivateIdentifier(node) {
	    const name = super.getPrivateNameSV(node);
	    node = node;
	    delete node.id;
	    node.name = name;
	    node.type = "PrivateIdentifier";
	    return node;
	  }
	  isPrivateName(node) {
	    {
	      if (!this.getPluginOption("estree", "classFeatures")) {
	        return super.isPrivateName(node);
	      }
	    }
	    return node.type === "PrivateIdentifier";
	  }
	  getPrivateNameSV(node) {
	    {
	      if (!this.getPluginOption("estree", "classFeatures")) {
	        return super.getPrivateNameSV(node);
	      }
	    }
	    return node.name;
	  }
	  parseLiteral(value, type) {
	    const node = super.parseLiteral(value, type);
	    node.raw = node.extra.raw;
	    delete node.extra;
	    return node;
	  }
	  parseFunctionBody(node, allowExpression, isMethod = false) {
	    super.parseFunctionBody(node, allowExpression, isMethod);
	    node.expression = node.body.type !== "BlockStatement";
	  }
	  parseMethod(node, isGenerator, isAsync, isConstructor, allowDirectSuper, type, inClassScope = false) {
	    let funcNode = this.startNode();
	    funcNode.kind = node.kind;
	    funcNode = super.parseMethod(funcNode, isGenerator, isAsync, isConstructor, allowDirectSuper, type, inClassScope);
	    funcNode.type = "FunctionExpression";
	    delete funcNode.kind;
	    node.value = funcNode;
	    if (type === "ClassPrivateMethod") {
	      node.computed = false;
	    }
	    return this.finishNode(node, "MethodDefinition");
	  }
	  nameIsConstructor(key) {
	    if (key.type === "Literal") return key.value === "constructor";
	    return super.nameIsConstructor(key);
	  }
	  parseClassProperty(...args) {
	    const propertyNode = super.parseClassProperty(...args);
	    {
	      if (!this.getPluginOption("estree", "classFeatures")) {
	        return propertyNode;
	      }
	    }
	    propertyNode.type = "PropertyDefinition";
	    return propertyNode;
	  }
	  parseClassPrivateProperty(...args) {
	    const propertyNode = super.parseClassPrivateProperty(...args);
	    {
	      if (!this.getPluginOption("estree", "classFeatures")) {
	        return propertyNode;
	      }
	    }
	    propertyNode.type = "PropertyDefinition";
	    propertyNode.computed = false;
	    return propertyNode;
	  }
	  parseObjectMethod(prop, isGenerator, isAsync, isPattern, isAccessor) {
	    const node = super.parseObjectMethod(prop, isGenerator, isAsync, isPattern, isAccessor);
	    if (node) {
	      node.type = "Property";
	      if (node.kind === "method") {
	        node.kind = "init";
	      }
	      node.shorthand = false;
	    }
	    return node;
	  }
	  parseObjectProperty(prop, startLoc, isPattern, refExpressionErrors) {
	    const node = super.parseObjectProperty(prop, startLoc, isPattern, refExpressionErrors);
	    if (node) {
	      node.kind = "init";
	      node.type = "Property";
	    }
	    return node;
	  }
	  isValidLVal(type, isUnparenthesizedInAssign, binding) {
	    return type === "Property" ? "value" : super.isValidLVal(type, isUnparenthesizedInAssign, binding);
	  }
	  isAssignable(node, isBinding) {
	    if (node != null && this.isObjectProperty(node)) {
	      return this.isAssignable(node.value, isBinding);
	    }
	    return super.isAssignable(node, isBinding);
	  }
	  toAssignable(node, isLHS = false) {
	    if (node != null && this.isObjectProperty(node)) {
	      const {
	        key,
	        value
	      } = node;
	      if (this.isPrivateName(key)) {
	        this.classScope.usePrivateName(this.getPrivateNameSV(key), key.loc.start);
	      }
	      this.toAssignable(value, isLHS);
	    } else {
	      super.toAssignable(node, isLHS);
	    }
	  }
	  toAssignableObjectExpressionProp(prop, isLast, isLHS) {
	    if (prop.type === "Property" && (prop.kind === "get" || prop.kind === "set")) {
	      this.raise(Errors.PatternHasAccessor, prop.key);
	    } else if (prop.type === "Property" && prop.method) {
	      this.raise(Errors.PatternHasMethod, prop.key);
	    } else {
	      super.toAssignableObjectExpressionProp(prop, isLast, isLHS);
	    }
	  }
	  finishCallExpression(unfinished, optional) {
	    const node = super.finishCallExpression(unfinished, optional);
	    if (node.callee.type === "Import") {
	      node.type = "ImportExpression";
	      node.source = node.arguments[0];
	      if (this.hasPlugin("importAttributes") || this.hasPlugin("importAssertions")) {
	        var _ref, _ref2;
	        node.options = (_ref = node.arguments[1]) != null ? _ref : null;
	        node.attributes = (_ref2 = node.arguments[1]) != null ? _ref2 : null;
	      }
	      delete node.arguments;
	      delete node.callee;
	    }
	    return node;
	  }
	  toReferencedArguments(node) {
	    if (node.type === "ImportExpression") {
	      return;
	    }
	    super.toReferencedArguments(node);
	  }
	  parseExport(unfinished, decorators) {
	    const exportStartLoc = this.state.lastTokStartLoc;
	    const node = super.parseExport(unfinished, decorators);
	    switch (node.type) {
	      case "ExportAllDeclaration":
	        node.exported = null;
	        break;
	      case "ExportNamedDeclaration":
	        if (node.specifiers.length === 1 && node.specifiers[0].type === "ExportNamespaceSpecifier") {
	          node.type = "ExportAllDeclaration";
	          node.exported = node.specifiers[0].exported;
	          delete node.specifiers;
	        }
	      case "ExportDefaultDeclaration":
	        {
	          var _declaration$decorato;
	          const {
	            declaration
	          } = node;
	          if ((declaration == null ? void 0 : declaration.type) === "ClassDeclaration" && ((_declaration$decorato = declaration.decorators) == null ? void 0 : _declaration$decorato.length) > 0 && declaration.start === node.start) {
	            this.resetStartLocation(node, exportStartLoc);
	          }
	        }
	        break;
	    }
	    return node;
	  }
	  parseSubscript(base, startLoc, noCalls, state) {
	    const node = super.parseSubscript(base, startLoc, noCalls, state);
	    if (state.optionalChainMember) {
	      if (node.type === "OptionalMemberExpression" || node.type === "OptionalCallExpression") {
	        node.type = node.type.substring(8);
	      }
	      if (state.stop) {
	        const chain = this.startNodeAtNode(node);
	        chain.expression = node;
	        return this.finishNode(chain, "ChainExpression");
	      }
	    } else if (node.type === "MemberExpression" || node.type === "CallExpression") {
	      node.optional = false;
	    }
	    return node;
	  }
	  isOptionalMemberExpression(node) {
	    if (node.type === "ChainExpression") {
	      return node.expression.type === "MemberExpression";
	    }
	    return super.isOptionalMemberExpression(node);
	  }
	  hasPropertyAsPrivateName(node) {
	    if (node.type === "ChainExpression") {
	      node = node.expression;
	    }
	    return super.hasPropertyAsPrivateName(node);
	  }
	  isObjectProperty(node) {
	    return node.type === "Property" && node.kind === "init" && !node.method;
	  }
	  isObjectMethod(node) {
	    return node.type === "Property" && (node.method || node.kind === "get" || node.kind === "set");
	  }
	  finishNodeAt(node, type, endLoc) {
	    return toESTreeLocation(super.finishNodeAt(node, type, endLoc));
	  }
	  resetStartLocation(node, startLoc) {
	    super.resetStartLocation(node, startLoc);
	    toESTreeLocation(node);
	  }
	  resetEndLocation(node, endLoc = this.state.lastTokEndLoc) {
	    super.resetEndLocation(node, endLoc);
	    toESTreeLocation(node);
	  }
	};
	class TokContext {
	  constructor(token, preserveSpace) {
	    this.token = void 0;
	    this.preserveSpace = void 0;
	    this.token = token;
	    this.preserveSpace = !!preserveSpace;
	  }
	}
	const types = {
	  brace: new TokContext("{"),
	  j_oTag: new TokContext("<tag"),
	  j_cTag: new TokContext("</tag"),
	  j_expr: new TokContext("<tag>...</tag>", true)
	};
	{
	  types.template = new TokContext("`", true);
	}
	const beforeExpr = true;
	const startsExpr = true;
	const isLoop = true;
	const isAssign = true;
	const prefix = true;
	const postfix = true;
	class ExportedTokenType {
	  constructor(label, conf = {}) {
	    this.label = void 0;
	    this.keyword = void 0;
	    this.beforeExpr = void 0;
	    this.startsExpr = void 0;
	    this.rightAssociative = void 0;
	    this.isLoop = void 0;
	    this.isAssign = void 0;
	    this.prefix = void 0;
	    this.postfix = void 0;
	    this.binop = void 0;
	    this.label = label;
	    this.keyword = conf.keyword;
	    this.beforeExpr = !!conf.beforeExpr;
	    this.startsExpr = !!conf.startsExpr;
	    this.rightAssociative = !!conf.rightAssociative;
	    this.isLoop = !!conf.isLoop;
	    this.isAssign = !!conf.isAssign;
	    this.prefix = !!conf.prefix;
	    this.postfix = !!conf.postfix;
	    this.binop = conf.binop != null ? conf.binop : null;
	    {
	      this.updateContext = null;
	    }
	  }
	}
	const keywords$1 = new Map();
	function createKeyword(name, options = {}) {
	  options.keyword = name;
	  const token = createToken(name, options);
	  keywords$1.set(name, token);
	  return token;
	}
	function createBinop(name, binop) {
	  return createToken(name, {
	    beforeExpr,
	    binop
	  });
	}
	let tokenTypeCounter = -1;
	const tokenTypes = [];
	const tokenLabels = [];
	const tokenBinops = [];
	const tokenBeforeExprs = [];
	const tokenStartsExprs = [];
	const tokenPrefixes = [];
	function createToken(name, options = {}) {
	  var _options$binop, _options$beforeExpr, _options$startsExpr, _options$prefix;
	  ++tokenTypeCounter;
	  tokenLabels.push(name);
	  tokenBinops.push((_options$binop = options.binop) != null ? _options$binop : -1);
	  tokenBeforeExprs.push((_options$beforeExpr = options.beforeExpr) != null ? _options$beforeExpr : false);
	  tokenStartsExprs.push((_options$startsExpr = options.startsExpr) != null ? _options$startsExpr : false);
	  tokenPrefixes.push((_options$prefix = options.prefix) != null ? _options$prefix : false);
	  tokenTypes.push(new ExportedTokenType(name, options));
	  return tokenTypeCounter;
	}
	function createKeywordLike(name, options = {}) {
	  var _options$binop2, _options$beforeExpr2, _options$startsExpr2, _options$prefix2;
	  ++tokenTypeCounter;
	  keywords$1.set(name, tokenTypeCounter);
	  tokenLabels.push(name);
	  tokenBinops.push((_options$binop2 = options.binop) != null ? _options$binop2 : -1);
	  tokenBeforeExprs.push((_options$beforeExpr2 = options.beforeExpr) != null ? _options$beforeExpr2 : false);
	  tokenStartsExprs.push((_options$startsExpr2 = options.startsExpr) != null ? _options$startsExpr2 : false);
	  tokenPrefixes.push((_options$prefix2 = options.prefix) != null ? _options$prefix2 : false);
	  tokenTypes.push(new ExportedTokenType("name", options));
	  return tokenTypeCounter;
	}
	const tt = {
	  bracketL: createToken("[", {
	    beforeExpr,
	    startsExpr
	  }),
	  bracketHashL: createToken("#[", {
	    beforeExpr,
	    startsExpr
	  }),
	  bracketBarL: createToken("[|", {
	    beforeExpr,
	    startsExpr
	  }),
	  bracketR: createToken("]"),
	  bracketBarR: createToken("|]"),
	  braceL: createToken("{", {
	    beforeExpr,
	    startsExpr
	  }),
	  braceBarL: createToken("{|", {
	    beforeExpr,
	    startsExpr
	  }),
	  braceHashL: createToken("#{", {
	    beforeExpr,
	    startsExpr
	  }),
	  braceR: createToken("}"),
	  braceBarR: createToken("|}"),
	  parenL: createToken("(", {
	    beforeExpr,
	    startsExpr
	  }),
	  parenR: createToken(")"),
	  comma: createToken(",", {
	    beforeExpr
	  }),
	  semi: createToken(";", {
	    beforeExpr
	  }),
	  colon: createToken(":", {
	    beforeExpr
	  }),
	  doubleColon: createToken("::", {
	    beforeExpr
	  }),
	  dot: createToken("."),
	  question: createToken("?", {
	    beforeExpr
	  }),
	  questionDot: createToken("?."),
	  arrow: createToken("=>", {
	    beforeExpr
	  }),
	  template: createToken("template"),
	  ellipsis: createToken("...", {
	    beforeExpr
	  }),
	  backQuote: createToken("`", {
	    startsExpr
	  }),
	  dollarBraceL: createToken("${", {
	    beforeExpr,
	    startsExpr
	  }),
	  templateTail: createToken("...`", {
	    startsExpr
	  }),
	  templateNonTail: createToken("...${", {
	    beforeExpr,
	    startsExpr
	  }),
	  at: createToken("@"),
	  hash: createToken("#", {
	    startsExpr
	  }),
	  interpreterDirective: createToken("#!..."),
	  eq: createToken("=", {
	    beforeExpr,
	    isAssign
	  }),
	  assign: createToken("_=", {
	    beforeExpr,
	    isAssign
	  }),
	  slashAssign: createToken("_=", {
	    beforeExpr,
	    isAssign
	  }),
	  xorAssign: createToken("_=", {
	    beforeExpr,
	    isAssign
	  }),
	  moduloAssign: createToken("_=", {
	    beforeExpr,
	    isAssign
	  }),
	  incDec: createToken("++/--", {
	    prefix,
	    postfix,
	    startsExpr
	  }),
	  bang: createToken("!", {
	    beforeExpr,
	    prefix,
	    startsExpr
	  }),
	  tilde: createToken("~", {
	    beforeExpr,
	    prefix,
	    startsExpr
	  }),
	  doubleCaret: createToken("^^", {
	    startsExpr
	  }),
	  doubleAt: createToken("@@", {
	    startsExpr
	  }),
	  pipeline: createBinop("|>", 0),
	  nullishCoalescing: createBinop("??", 1),
	  logicalOR: createBinop("||", 1),
	  logicalAND: createBinop("&&", 2),
	  bitwiseOR: createBinop("|", 3),
	  bitwiseXOR: createBinop("^", 4),
	  bitwiseAND: createBinop("&", 5),
	  equality: createBinop("==/!=/===/!==", 6),
	  lt: createBinop("</>/<=/>=", 7),
	  gt: createBinop("</>/<=/>=", 7),
	  relational: createBinop("</>/<=/>=", 7),
	  bitShift: createBinop("<</>>/>>>", 8),
	  bitShiftL: createBinop("<</>>/>>>", 8),
	  bitShiftR: createBinop("<</>>/>>>", 8),
	  plusMin: createToken("+/-", {
	    beforeExpr,
	    binop: 9,
	    prefix,
	    startsExpr
	  }),
	  modulo: createToken("%", {
	    binop: 10,
	    startsExpr
	  }),
	  star: createToken("*", {
	    binop: 10
	  }),
	  slash: createBinop("/", 10),
	  exponent: createToken("**", {
	    beforeExpr,
	    binop: 11,
	    rightAssociative: true
	  }),
	  _in: createKeyword("in", {
	    beforeExpr,
	    binop: 7
	  }),
	  _instanceof: createKeyword("instanceof", {
	    beforeExpr,
	    binop: 7
	  }),
	  _break: createKeyword("break"),
	  _case: createKeyword("case", {
	    beforeExpr
	  }),
	  _catch: createKeyword("catch"),
	  _continue: createKeyword("continue"),
	  _debugger: createKeyword("debugger"),
	  _default: createKeyword("default", {
	    beforeExpr
	  }),
	  _else: createKeyword("else", {
	    beforeExpr
	  }),
	  _finally: createKeyword("finally"),
	  _function: createKeyword("function", {
	    startsExpr
	  }),
	  _if: createKeyword("if"),
	  _return: createKeyword("return", {
	    beforeExpr
	  }),
	  _switch: createKeyword("switch"),
	  _throw: createKeyword("throw", {
	    beforeExpr,
	    prefix,
	    startsExpr
	  }),
	  _try: createKeyword("try"),
	  _var: createKeyword("var"),
	  _const: createKeyword("const"),
	  _with: createKeyword("with"),
	  _new: createKeyword("new", {
	    beforeExpr,
	    startsExpr
	  }),
	  _this: createKeyword("this", {
	    startsExpr
	  }),
	  _super: createKeyword("super", {
	    startsExpr
	  }),
	  _class: createKeyword("class", {
	    startsExpr
	  }),
	  _extends: createKeyword("extends", {
	    beforeExpr
	  }),
	  _export: createKeyword("export"),
	  _import: createKeyword("import", {
	    startsExpr
	  }),
	  _null: createKeyword("null", {
	    startsExpr
	  }),
	  _true: createKeyword("true", {
	    startsExpr
	  }),
	  _false: createKeyword("false", {
	    startsExpr
	  }),
	  _typeof: createKeyword("typeof", {
	    beforeExpr,
	    prefix,
	    startsExpr
	  }),
	  _void: createKeyword("void", {
	    beforeExpr,
	    prefix,
	    startsExpr
	  }),
	  _delete: createKeyword("delete", {
	    beforeExpr,
	    prefix,
	    startsExpr
	  }),
	  _do: createKeyword("do", {
	    isLoop,
	    beforeExpr
	  }),
	  _for: createKeyword("for", {
	    isLoop
	  }),
	  _while: createKeyword("while", {
	    isLoop
	  }),
	  _as: createKeywordLike("as", {
	    startsExpr
	  }),
	  _assert: createKeywordLike("assert", {
	    startsExpr
	  }),
	  _async: createKeywordLike("async", {
	    startsExpr
	  }),
	  _await: createKeywordLike("await", {
	    startsExpr
	  }),
	  _defer: createKeywordLike("defer", {
	    startsExpr
	  }),
	  _from: createKeywordLike("from", {
	    startsExpr
	  }),
	  _get: createKeywordLike("get", {
	    startsExpr
	  }),
	  _let: createKeywordLike("let", {
	    startsExpr
	  }),
	  _meta: createKeywordLike("meta", {
	    startsExpr
	  }),
	  _of: createKeywordLike("of", {
	    startsExpr
	  }),
	  _sent: createKeywordLike("sent", {
	    startsExpr
	  }),
	  _set: createKeywordLike("set", {
	    startsExpr
	  }),
	  _source: createKeywordLike("source", {
	    startsExpr
	  }),
	  _static: createKeywordLike("static", {
	    startsExpr
	  }),
	  _using: createKeywordLike("using", {
	    startsExpr
	  }),
	  _yield: createKeywordLike("yield", {
	    startsExpr
	  }),
	  _asserts: createKeywordLike("asserts", {
	    startsExpr
	  }),
	  _checks: createKeywordLike("checks", {
	    startsExpr
	  }),
	  _exports: createKeywordLike("exports", {
	    startsExpr
	  }),
	  _global: createKeywordLike("global", {
	    startsExpr
	  }),
	  _implements: createKeywordLike("implements", {
	    startsExpr
	  }),
	  _intrinsic: createKeywordLike("intrinsic", {
	    startsExpr
	  }),
	  _infer: createKeywordLike("infer", {
	    startsExpr
	  }),
	  _is: createKeywordLike("is", {
	    startsExpr
	  }),
	  _mixins: createKeywordLike("mixins", {
	    startsExpr
	  }),
	  _proto: createKeywordLike("proto", {
	    startsExpr
	  }),
	  _require: createKeywordLike("require", {
	    startsExpr
	  }),
	  _satisfies: createKeywordLike("satisfies", {
	    startsExpr
	  }),
	  _keyof: createKeywordLike("keyof", {
	    startsExpr
	  }),
	  _readonly: createKeywordLike("readonly", {
	    startsExpr
	  }),
	  _unique: createKeywordLike("unique", {
	    startsExpr
	  }),
	  _abstract: createKeywordLike("abstract", {
	    startsExpr
	  }),
	  _declare: createKeywordLike("declare", {
	    startsExpr
	  }),
	  _enum: createKeywordLike("enum", {
	    startsExpr
	  }),
	  _module: createKeywordLike("module", {
	    startsExpr
	  }),
	  _namespace: createKeywordLike("namespace", {
	    startsExpr
	  }),
	  _interface: createKeywordLike("interface", {
	    startsExpr
	  }),
	  _type: createKeywordLike("type", {
	    startsExpr
	  }),
	  _opaque: createKeywordLike("opaque", {
	    startsExpr
	  }),
	  name: createToken("name", {
	    startsExpr
	  }),
	  string: createToken("string", {
	    startsExpr
	  }),
	  num: createToken("num", {
	    startsExpr
	  }),
	  bigint: createToken("bigint", {
	    startsExpr
	  }),
	  decimal: createToken("decimal", {
	    startsExpr
	  }),
	  regexp: createToken("regexp", {
	    startsExpr
	  }),
	  privateName: createToken("#name", {
	    startsExpr
	  }),
	  eof: createToken("eof"),
	  jsxName: createToken("jsxName"),
	  jsxText: createToken("jsxText", {
	    beforeExpr: true
	  }),
	  jsxTagStart: createToken("jsxTagStart", {
	    startsExpr: true
	  }),
	  jsxTagEnd: createToken("jsxTagEnd"),
	  placeholder: createToken("%%", {
	    startsExpr: true
	  })
	};
	function tokenIsIdentifier(token) {
	  return token >= 93 && token <= 132;
	}
	function tokenKeywordOrIdentifierIsKeyword(token) {
	  return token <= 92;
	}
	function tokenIsKeywordOrIdentifier(token) {
	  return token >= 58 && token <= 132;
	}
	function tokenIsLiteralPropertyName(token) {
	  return token >= 58 && token <= 136;
	}
	function tokenComesBeforeExpression(token) {
	  return tokenBeforeExprs[token];
	}
	function tokenCanStartExpression(token) {
	  return tokenStartsExprs[token];
	}
	function tokenIsAssignment(token) {
	  return token >= 29 && token <= 33;
	}
	function tokenIsFlowInterfaceOrTypeOrOpaque(token) {
	  return token >= 129 && token <= 131;
	}
	function tokenIsLoop(token) {
	  return token >= 90 && token <= 92;
	}
	function tokenIsKeyword(token) {
	  return token >= 58 && token <= 92;
	}
	function tokenIsOperator(token) {
	  return token >= 39 && token <= 59;
	}
	function tokenIsPostfix(token) {
	  return token === 34;
	}
	function tokenIsPrefix(token) {
	  return tokenPrefixes[token];
	}
	function tokenIsTSTypeOperator(token) {
	  return token >= 121 && token <= 123;
	}
	function tokenIsTSDeclarationStart(token) {
	  return token >= 124 && token <= 130;
	}
	function tokenLabelName(token) {
	  return tokenLabels[token];
	}
	function tokenOperatorPrecedence(token) {
	  return tokenBinops[token];
	}
	function tokenIsRightAssociative(token) {
	  return token === 57;
	}
	function tokenIsTemplate(token) {
	  return token >= 24 && token <= 25;
	}
	function getExportedToken(token) {
	  return tokenTypes[token];
	}
	{
	  tokenTypes[8].updateContext = context => {
	    context.pop();
	  };
	  tokenTypes[5].updateContext = tokenTypes[7].updateContext = tokenTypes[23].updateContext = context => {
	    context.push(types.brace);
	  };
	  tokenTypes[22].updateContext = context => {
	    if (context[context.length - 1] === types.template) {
	      context.pop();
	    } else {
	      context.push(types.template);
	    }
	  };
	  tokenTypes[142].updateContext = context => {
	    context.push(types.j_expr, types.j_oTag);
	  };
	}
	let nonASCIIidentifierStartChars = "\xaa\xb5\xba\xc0-\xd6\xd8-\xf6\xf8-\u02c1\u02c6-\u02d1\u02e0-\u02e4\u02ec\u02ee\u0370-\u0374\u0376\u0377\u037a-\u037d\u037f\u0386\u0388-\u038a\u038c\u038e-\u03a1\u03a3-\u03f5\u03f7-\u0481\u048a-\u052f\u0531-\u0556\u0559\u0560-\u0588\u05d0-\u05ea\u05ef-\u05f2\u0620-\u064a\u066e\u066f\u0671-\u06d3\u06d5\u06e5\u06e6\u06ee\u06ef\u06fa-\u06fc\u06ff\u0710\u0712-\u072f\u074d-\u07a5\u07b1\u07ca-\u07ea\u07f4\u07f5\u07fa\u0800-\u0815\u081a\u0824\u0828\u0840-\u0858\u0860-\u086a\u0870-\u0887\u0889-\u088e\u08a0-\u08c9\u0904-\u0939\u093d\u0950\u0958-\u0961\u0971-\u0980\u0985-\u098c\u098f\u0990\u0993-\u09a8\u09aa-\u09b0\u09b2\u09b6-\u09b9\u09bd\u09ce\u09dc\u09dd\u09df-\u09e1\u09f0\u09f1\u09fc\u0a05-\u0a0a\u0a0f\u0a10\u0a13-\u0a28\u0a2a-\u0a30\u0a32\u0a33\u0a35\u0a36\u0a38\u0a39\u0a59-\u0a5c\u0a5e\u0a72-\u0a74\u0a85-\u0a8d\u0a8f-\u0a91\u0a93-\u0aa8\u0aaa-\u0ab0\u0ab2\u0ab3\u0ab5-\u0ab9\u0abd\u0ad0\u0ae0\u0ae1\u0af9\u0b05-\u0b0c\u0b0f\u0b10\u0b13-\u0b28\u0b2a-\u0b30\u0b32\u0b33\u0b35-\u0b39\u0b3d\u0b5c\u0b5d\u0b5f-\u0b61\u0b71\u0b83\u0b85-\u0b8a\u0b8e-\u0b90\u0b92-\u0b95\u0b99\u0b9a\u0b9c\u0b9e\u0b9f\u0ba3\u0ba4\u0ba8-\u0baa\u0bae-\u0bb9\u0bd0\u0c05-\u0c0c\u0c0e-\u0c10\u0c12-\u0c28\u0c2a-\u0c39\u0c3d\u0c58-\u0c5a\u0c5d\u0c60\u0c61\u0c80\u0c85-\u0c8c\u0c8e-\u0c90\u0c92-\u0ca8\u0caa-\u0cb3\u0cb5-\u0cb9\u0cbd\u0cdd\u0cde\u0ce0\u0ce1\u0cf1\u0cf2\u0d04-\u0d0c\u0d0e-\u0d10\u0d12-\u0d3a\u0d3d\u0d4e\u0d54-\u0d56\u0d5f-\u0d61\u0d7a-\u0d7f\u0d85-\u0d96\u0d9a-\u0db1\u0db3-\u0dbb\u0dbd\u0dc0-\u0dc6\u0e01-\u0e30\u0e32\u0e33\u0e40-\u0e46\u0e81\u0e82\u0e84\u0e86-\u0e8a\u0e8c-\u0ea3\u0ea5\u0ea7-\u0eb0\u0eb2\u0eb3\u0ebd\u0ec0-\u0ec4\u0ec6\u0edc-\u0edf\u0f00\u0f40-\u0f47\u0f49-\u0f6c\u0f88-\u0f8c\u1000-\u102a\u103f\u1050-\u1055\u105a-\u105d\u1061\u1065\u1066\u106e-\u1070\u1075-\u1081\u108e\u10a0-\u10c5\u10c7\u10cd\u10d0-\u10fa\u10fc-\u1248\u124a-\u124d\u1250-\u1256\u1258\u125a-\u125d\u1260-\u1288\u128a-\u128d\u1290-\u12b0\u12b2-\u12b5\u12b8-\u12be\u12c0\u12c2-\u12c5\u12c8-\u12d6\u12d8-\u1310\u1312-\u1315\u1318-\u135a\u1380-\u138f\u13a0-\u13f5\u13f8-\u13fd\u1401-\u166c\u166f-\u167f\u1681-\u169a\u16a0-\u16ea\u16ee-\u16f8\u1700-\u1711\u171f-\u1731\u1740-\u1751\u1760-\u176c\u176e-\u1770\u1780-\u17b3\u17d7\u17dc\u1820-\u1878\u1880-\u18a8\u18aa\u18b0-\u18f5\u1900-\u191e\u1950-\u196d\u1970-\u1974\u1980-\u19ab\u19b0-\u19c9\u1a00-\u1a16\u1a20-\u1a54\u1aa7\u1b05-\u1b33\u1b45-\u1b4c\u1b83-\u1ba0\u1bae\u1baf\u1bba-\u1be5\u1c00-\u1c23\u1c4d-\u1c4f\u1c5a-\u1c7d\u1c80-\u1c88\u1c90-\u1cba\u1cbd-\u1cbf\u1ce9-\u1cec\u1cee-\u1cf3\u1cf5\u1cf6\u1cfa\u1d00-\u1dbf\u1e00-\u1f15\u1f18-\u1f1d\u1f20-\u1f45\u1f48-\u1f4d\u1f50-\u1f57\u1f59\u1f5b\u1f5d\u1f5f-\u1f7d\u1f80-\u1fb4\u1fb6-\u1fbc\u1fbe\u1fc2-\u1fc4\u1fc6-\u1fcc\u1fd0-\u1fd3\u1fd6-\u1fdb\u1fe0-\u1fec\u1ff2-\u1ff4\u1ff6-\u1ffc\u2071\u207f\u2090-\u209c\u2102\u2107\u210a-\u2113\u2115\u2118-\u211d\u2124\u2126\u2128\u212a-\u2139\u213c-\u213f\u2145-\u2149\u214e\u2160-\u2188\u2c00-\u2ce4\u2ceb-\u2cee\u2cf2\u2cf3\u2d00-\u2d25\u2d27\u2d2d\u2d30-\u2d67\u2d6f\u2d80-\u2d96\u2da0-\u2da6\u2da8-\u2dae\u2db0-\u2db6\u2db8-\u2dbe\u2dc0-\u2dc6\u2dc8-\u2dce\u2dd0-\u2dd6\u2dd8-\u2dde\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303c\u3041-\u3096\u309b-\u309f\u30a1-\u30fa\u30fc-\u30ff\u3105-\u312f\u3131-\u318e\u31a0-\u31bf\u31f0-\u31ff\u3400-\u4dbf\u4e00-\ua48c\ua4d0-\ua4fd\ua500-\ua60c\ua610-\ua61f\ua62a\ua62b\ua640-\ua66e\ua67f-\ua69d\ua6a0-\ua6ef\ua717-\ua71f\ua722-\ua788\ua78b-\ua7ca\ua7d0\ua7d1\ua7d3\ua7d5-\ua7d9\ua7f2-\ua801\ua803-\ua805\ua807-\ua80a\ua80c-\ua822\ua840-\ua873\ua882-\ua8b3\ua8f2-\ua8f7\ua8fb\ua8fd\ua8fe\ua90a-\ua925\ua930-\ua946\ua960-\ua97c\ua984-\ua9b2\ua9cf\ua9e0-\ua9e4\ua9e6-\ua9ef\ua9fa-\ua9fe\uaa00-\uaa28\uaa40-\uaa42\uaa44-\uaa4b\uaa60-\uaa76\uaa7a\uaa7e-\uaaaf\uaab1\uaab5\uaab6\uaab9-\uaabd\uaac0\uaac2\uaadb-\uaadd\uaae0-\uaaea\uaaf2-\uaaf4\uab01-\uab06\uab09-\uab0e\uab11-\uab16\uab20-\uab26\uab28-\uab2e\uab30-\uab5a\uab5c-\uab69\uab70-\uabe2\uac00-\ud7a3\ud7b0-\ud7c6\ud7cb-\ud7fb\uf900-\ufa6d\ufa70-\ufad9\ufb00-\ufb06\ufb13-\ufb17\ufb1d\ufb1f-\ufb28\ufb2a-\ufb36\ufb38-\ufb3c\ufb3e\ufb40\ufb41\ufb43\ufb44\ufb46-\ufbb1\ufbd3-\ufd3d\ufd50-\ufd8f\ufd92-\ufdc7\ufdf0-\ufdfb\ufe70-\ufe74\ufe76-\ufefc\uff21-\uff3a\uff41-\uff5a\uff66-\uffbe\uffc2-\uffc7\uffca-\uffcf\uffd2-\uffd7\uffda-\uffdc";
	let nonASCIIidentifierChars = "\u200c\u200d\xb7\u0300-\u036f\u0387\u0483-\u0487\u0591-\u05bd\u05bf\u05c1\u05c2\u05c4\u05c5\u05c7\u0610-\u061a\u064b-\u0669\u0670\u06d6-\u06dc\u06df-\u06e4\u06e7\u06e8\u06ea-\u06ed\u06f0-\u06f9\u0711\u0730-\u074a\u07a6-\u07b0\u07c0-\u07c9\u07eb-\u07f3\u07fd\u0816-\u0819\u081b-\u0823\u0825-\u0827\u0829-\u082d\u0859-\u085b\u0898-\u089f\u08ca-\u08e1\u08e3-\u0903\u093a-\u093c\u093e-\u094f\u0951-\u0957\u0962\u0963\u0966-\u096f\u0981-\u0983\u09bc\u09be-\u09c4\u09c7\u09c8\u09cb-\u09cd\u09d7\u09e2\u09e3\u09e6-\u09ef\u09fe\u0a01-\u0a03\u0a3c\u0a3e-\u0a42\u0a47\u0a48\u0a4b-\u0a4d\u0a51\u0a66-\u0a71\u0a75\u0a81-\u0a83\u0abc\u0abe-\u0ac5\u0ac7-\u0ac9\u0acb-\u0acd\u0ae2\u0ae3\u0ae6-\u0aef\u0afa-\u0aff\u0b01-\u0b03\u0b3c\u0b3e-\u0b44\u0b47\u0b48\u0b4b-\u0b4d\u0b55-\u0b57\u0b62\u0b63\u0b66-\u0b6f\u0b82\u0bbe-\u0bc2\u0bc6-\u0bc8\u0bca-\u0bcd\u0bd7\u0be6-\u0bef\u0c00-\u0c04\u0c3c\u0c3e-\u0c44\u0c46-\u0c48\u0c4a-\u0c4d\u0c55\u0c56\u0c62\u0c63\u0c66-\u0c6f\u0c81-\u0c83\u0cbc\u0cbe-\u0cc4\u0cc6-\u0cc8\u0cca-\u0ccd\u0cd5\u0cd6\u0ce2\u0ce3\u0ce6-\u0cef\u0cf3\u0d00-\u0d03\u0d3b\u0d3c\u0d3e-\u0d44\u0d46-\u0d48\u0d4a-\u0d4d\u0d57\u0d62\u0d63\u0d66-\u0d6f\u0d81-\u0d83\u0dca\u0dcf-\u0dd4\u0dd6\u0dd8-\u0ddf\u0de6-\u0def\u0df2\u0df3\u0e31\u0e34-\u0e3a\u0e47-\u0e4e\u0e50-\u0e59\u0eb1\u0eb4-\u0ebc\u0ec8-\u0ece\u0ed0-\u0ed9\u0f18\u0f19\u0f20-\u0f29\u0f35\u0f37\u0f39\u0f3e\u0f3f\u0f71-\u0f84\u0f86\u0f87\u0f8d-\u0f97\u0f99-\u0fbc\u0fc6\u102b-\u103e\u1040-\u1049\u1056-\u1059\u105e-\u1060\u1062-\u1064\u1067-\u106d\u1071-\u1074\u1082-\u108d\u108f-\u109d\u135d-\u135f\u1369-\u1371\u1712-\u1715\u1732-\u1734\u1752\u1753\u1772\u1773\u17b4-\u17d3\u17dd\u17e0-\u17e9\u180b-\u180d\u180f-\u1819\u18a9\u1920-\u192b\u1930-\u193b\u1946-\u194f\u19d0-\u19da\u1a17-\u1a1b\u1a55-\u1a5e\u1a60-\u1a7c\u1a7f-\u1a89\u1a90-\u1a99\u1ab0-\u1abd\u1abf-\u1ace\u1b00-\u1b04\u1b34-\u1b44\u1b50-\u1b59\u1b6b-\u1b73\u1b80-\u1b82\u1ba1-\u1bad\u1bb0-\u1bb9\u1be6-\u1bf3\u1c24-\u1c37\u1c40-\u1c49\u1c50-\u1c59\u1cd0-\u1cd2\u1cd4-\u1ce8\u1ced\u1cf4\u1cf7-\u1cf9\u1dc0-\u1dff\u200c\u200d\u203f\u2040\u2054\u20d0-\u20dc\u20e1\u20e5-\u20f0\u2cef-\u2cf1\u2d7f\u2de0-\u2dff\u302a-\u302f\u3099\u309a\u30fb\ua620-\ua629\ua66f\ua674-\ua67d\ua69e\ua69f\ua6f0\ua6f1\ua802\ua806\ua80b\ua823-\ua827\ua82c\ua880\ua881\ua8b4-\ua8c5\ua8d0-\ua8d9\ua8e0-\ua8f1\ua8ff-\ua909\ua926-\ua92d\ua947-\ua953\ua980-\ua983\ua9b3-\ua9c0\ua9d0-\ua9d9\ua9e5\ua9f0-\ua9f9\uaa29-\uaa36\uaa43\uaa4c\uaa4d\uaa50-\uaa59\uaa7b-\uaa7d\uaab0\uaab2-\uaab4\uaab7\uaab8\uaabe\uaabf\uaac1\uaaeb-\uaaef\uaaf5\uaaf6\uabe3-\uabea\uabec\uabed\uabf0-\uabf9\ufb1e\ufe00-\ufe0f\ufe20-\ufe2f\ufe33\ufe34\ufe4d-\ufe4f\uff10-\uff19\uff3f\uff65";
	const nonASCIIidentifierStart = new RegExp("[" + nonASCIIidentifierStartChars + "]");
	const nonASCIIidentifier = new RegExp("[" + nonASCIIidentifierStartChars + nonASCIIidentifierChars + "]");
	nonASCIIidentifierStartChars = nonASCIIidentifierChars = null;
	const astralIdentifierStartCodes = [0, 11, 2, 25, 2, 18, 2, 1, 2, 14, 3, 13, 35, 122, 70, 52, 268, 28, 4, 48, 48, 31, 14, 29, 6, 37, 11, 29, 3, 35, 5, 7, 2, 4, 43, 157, 19, 35, 5, 35, 5, 39, 9, 51, 13, 10, 2, 14, 2, 6, 2, 1, 2, 10, 2, 14, 2, 6, 2, 1, 68, 310, 10, 21, 11, 7, 25, 5, 2, 41, 2, 8, 70, 5, 3, 0, 2, 43, 2, 1, 4, 0, 3, 22, 11, 22, 10, 30, 66, 18, 2, 1, 11, 21, 11, 25, 71, 55, 7, 1, 65, 0, 16, 3, 2, 2, 2, 28, 43, 28, 4, 28, 36, 7, 2, 27, 28, 53, 11, 21, 11, 18, 14, 17, 111, 72, 56, 50, 14, 50, 14, 35, 349, 41, 7, 1, 79, 28, 11, 0, 9, 21, 43, 17, 47, 20, 28, 22, 13, 52, 58, 1, 3, 0, 14, 44, 33, 24, 27, 35, 30, 0, 3, 0, 9, 34, 4, 0, 13, 47, 15, 3, 22, 0, 2, 0, 36, 17, 2, 24, 20, 1, 64, 6, 2, 0, 2, 3, 2, 14, 2, 9, 8, 46, 39, 7, 3, 1, 3, 21, 2, 6, 2, 1, 2, 4, 4, 0, 19, 0, 13, 4, 159, 52, 19, 3, 21, 2, 31, 47, 21, 1, 2, 0, 185, 46, 42, 3, 37, 47, 21, 0, 60, 42, 14, 0, 72, 26, 38, 6, 186, 43, 117, 63, 32, 7, 3, 0, 3, 7, 2, 1, 2, 23, 16, 0, 2, 0, 95, 7, 3, 38, 17, 0, 2, 0, 29, 0, 11, 39, 8, 0, 22, 0, 12, 45, 20, 0, 19, 72, 264, 8, 2, 36, 18, 0, 50, 29, 113, 6, 2, 1, 2, 37, 22, 0, 26, 5, 2, 1, 2, 31, 15, 0, 328, 18, 16, 0, 2, 12, 2, 33, 125, 0, 80, 921, 103, 110, 18, 195, 2637, 96, 16, 1071, 18, 5, 4026, 582, 8634, 568, 8, 30, 18, 78, 18, 29, 19, 47, 17, 3, 32, 20, 6, 18, 689, 63, 129, 74, 6, 0, 67, 12, 65, 1, 2, 0, 29, 6135, 9, 1237, 43, 8, 8936, 3, 2, 6, 2, 1, 2, 290, 16, 0, 30, 2, 3, 0, 15, 3, 9, 395, 2309, 106, 6, 12, 4, 8, 8, 9, 5991, 84, 2, 70, 2, 1, 3, 0, 3, 1, 3, 3, 2, 11, 2, 0, 2, 6, 2, 64, 2, 3, 3, 7, 2, 6, 2, 27, 2, 3, 2, 4, 2, 0, 4, 6, 2, 339, 3, 24, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 7, 1845, 30, 7, 5, 262, 61, 147, 44, 11, 6, 17, 0, 322, 29, 19, 43, 485, 27, 757, 6, 2, 3, 2, 1, 2, 14, 2, 196, 60, 67, 8, 0, 1205, 3, 2, 26, 2, 1, 2, 0, 3, 0, 2, 9, 2, 3, 2, 0, 2, 0, 7, 0, 5, 0, 2, 0, 2, 0, 2, 2, 2, 1, 2, 0, 3, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 1, 2, 0, 3, 3, 2, 6, 2, 3, 2, 3, 2, 0, 2, 9, 2, 16, 6, 2, 2, 4, 2, 16, 4421, 42719, 33, 4153, 7, 221, 3, 5761, 15, 7472, 16, 621, 2467, 541, 1507, 4938, 6, 4191];
	const astralIdentifierCodes = [509, 0, 227, 0, 150, 4, 294, 9, 1368, 2, 2, 1, 6, 3, 41, 2, 5, 0, 166, 1, 574, 3, 9, 9, 370, 1, 81, 2, 71, 10, 50, 3, 123, 2, 54, 14, 32, 10, 3, 1, 11, 3, 46, 10, 8, 0, 46, 9, 7, 2, 37, 13, 2, 9, 6, 1, 45, 0, 13, 2, 49, 13, 9, 3, 2, 11, 83, 11, 7, 0, 3, 0, 158, 11, 6, 9, 7, 3, 56, 1, 2, 6, 3, 1, 3, 2, 10, 0, 11, 1, 3, 6, 4, 4, 193, 17, 10, 9, 5, 0, 82, 19, 13, 9, 214, 6, 3, 8, 28, 1, 83, 16, 16, 9, 82, 12, 9, 9, 84, 14, 5, 9, 243, 14, 166, 9, 71, 5, 2, 1, 3, 3, 2, 0, 2, 1, 13, 9, 120, 6, 3, 6, 4, 0, 29, 9, 41, 6, 2, 3, 9, 0, 10, 10, 47, 15, 406, 7, 2, 7, 17, 9, 57, 21, 2, 13, 123, 5, 4, 0, 2, 1, 2, 6, 2, 0, 9, 9, 49, 4, 2, 1, 2, 4, 9, 9, 330, 3, 10, 1, 2, 0, 49, 6, 4, 4, 14, 9, 5351, 0, 7, 14, 13835, 9, 87, 9, 39, 4, 60, 6, 26, 9, 1014, 0, 2, 54, 8, 3, 82, 0, 12, 1, 19628, 1, 4706, 45, 3, 22, 543, 4, 4, 5, 9, 7, 3, 6, 31, 3, 149, 2, 1418, 49, 513, 54, 5, 49, 9, 0, 15, 0, 23, 4, 2, 14, 1361, 6, 2, 16, 3, 6, 2, 1, 2, 4, 101, 0, 161, 6, 10, 9, 357, 0, 62, 13, 499, 13, 983, 6, 110, 6, 6, 9, 4759, 9, 787719, 239];
	function isInAstralSet(code, set) {
	  let pos = 0x10000;
	  for (let i = 0, length = set.length; i < length; i += 2) {
	    pos += set[i];
	    if (pos > code) return false;
	    pos += set[i + 1];
	    if (pos >= code) return true;
	  }
	  return false;
	}
	function isIdentifierStart(code) {
	  if (code < 65) return code === 36;
	  if (code <= 90) return true;
	  if (code < 97) return code === 95;
	  if (code <= 122) return true;
	  if (code <= 0xffff) {
	    return code >= 0xaa && nonASCIIidentifierStart.test(String.fromCharCode(code));
	  }
	  return isInAstralSet(code, astralIdentifierStartCodes);
	}
	function isIdentifierChar(code) {
	  if (code < 48) return code === 36;
	  if (code < 58) return true;
	  if (code < 65) return false;
	  if (code <= 90) return true;
	  if (code < 97) return code === 95;
	  if (code <= 122) return true;
	  if (code <= 0xffff) {
	    return code >= 0xaa && nonASCIIidentifier.test(String.fromCharCode(code));
	  }
	  return isInAstralSet(code, astralIdentifierStartCodes) || isInAstralSet(code, astralIdentifierCodes);
	}
	const reservedWords = {
	  keyword: ["break", "case", "catch", "continue", "debugger", "default", "do", "else", "finally", "for", "function", "if", "return", "switch", "throw", "try", "var", "const", "while", "with", "new", "this", "super", "class", "extends", "export", "import", "null", "true", "false", "in", "instanceof", "typeof", "void", "delete"],
	  strict: ["implements", "interface", "let", "package", "private", "protected", "public", "static", "yield"],
	  strictBind: ["eval", "arguments"]
	};
	const keywords = new Set(reservedWords.keyword);
	const reservedWordsStrictSet = new Set(reservedWords.strict);
	const reservedWordsStrictBindSet = new Set(reservedWords.strictBind);
	function isReservedWord(word, inModule) {
	  return inModule && word === "await" || word === "enum";
	}
	function isStrictReservedWord(word, inModule) {
	  return isReservedWord(word, inModule) || reservedWordsStrictSet.has(word);
	}
	function isStrictBindOnlyReservedWord(word) {
	  return reservedWordsStrictBindSet.has(word);
	}
	function isStrictBindReservedWord(word, inModule) {
	  return isStrictReservedWord(word, inModule) || isStrictBindOnlyReservedWord(word);
	}
	function isKeyword(word) {
	  return keywords.has(word);
	}
	function isIteratorStart(current, next, next2) {
	  return current === 64 && next === 64 && isIdentifierStart(next2);
	}
	const reservedWordLikeSet = new Set(["break", "case", "catch", "continue", "debugger", "default", "do", "else", "finally", "for", "function", "if", "return", "switch", "throw", "try", "var", "const", "while", "with", "new", "this", "super", "class", "extends", "export", "import", "null", "true", "false", "in", "instanceof", "typeof", "void", "delete", "implements", "interface", "let", "package", "private", "protected", "public", "static", "yield", "eval", "arguments", "enum", "await"]);
	function canBeReservedWord(word) {
	  return reservedWordLikeSet.has(word);
	}
	class Scope {
	  constructor(flags) {
	    this.flags = 0;
	    this.names = new Map();
	    this.firstLexicalName = "";
	    this.flags = flags;
	  }
	}
	class ScopeHandler {
	  constructor(parser, inModule) {
	    this.parser = void 0;
	    this.scopeStack = [];
	    this.inModule = void 0;
	    this.undefinedExports = new Map();
	    this.parser = parser;
	    this.inModule = inModule;
	  }
	  get inTopLevel() {
	    return (this.currentScope().flags & 1) > 0;
	  }
	  get inFunction() {
	    return (this.currentVarScopeFlags() & 2) > 0;
	  }
	  get allowSuper() {
	    return (this.currentThisScopeFlags() & 16) > 0;
	  }
	  get allowDirectSuper() {
	    return (this.currentThisScopeFlags() & 32) > 0;
	  }
	  get inClass() {
	    return (this.currentThisScopeFlags() & 64) > 0;
	  }
	  get inClassAndNotInNonArrowFunction() {
	    const flags = this.currentThisScopeFlags();
	    return (flags & 64) > 0 && (flags & 2) === 0;
	  }
	  get inStaticBlock() {
	    for (let i = this.scopeStack.length - 1;; i--) {
	      const {
	        flags
	      } = this.scopeStack[i];
	      if (flags & 128) {
	        return true;
	      }
	      if (flags & (387 | 64)) {
	        return false;
	      }
	    }
	  }
	  get inNonArrowFunction() {
	    return (this.currentThisScopeFlags() & 2) > 0;
	  }
	  get treatFunctionsAsVar() {
	    return this.treatFunctionsAsVarInScope(this.currentScope());
	  }
	  createScope(flags) {
	    return new Scope(flags);
	  }
	  enter(flags) {
	    this.scopeStack.push(this.createScope(flags));
	  }
	  exit() {
	    const scope = this.scopeStack.pop();
	    return scope.flags;
	  }
	  treatFunctionsAsVarInScope(scope) {
	    return !!(scope.flags & (2 | 128) || !this.parser.inModule && scope.flags & 1);
	  }
	  declareName(name, bindingType, loc) {
	    let scope = this.currentScope();
	    if (bindingType & 8 || bindingType & 16) {
	      this.checkRedeclarationInScope(scope, name, bindingType, loc);
	      let type = scope.names.get(name) || 0;
	      if (bindingType & 16) {
	        type = type | 4;
	      } else {
	        if (!scope.firstLexicalName) {
	          scope.firstLexicalName = name;
	        }
	        type = type | 2;
	      }
	      scope.names.set(name, type);
	      if (bindingType & 8) {
	        this.maybeExportDefined(scope, name);
	      }
	    } else if (bindingType & 4) {
	      for (let i = this.scopeStack.length - 1; i >= 0; --i) {
	        scope = this.scopeStack[i];
	        this.checkRedeclarationInScope(scope, name, bindingType, loc);
	        scope.names.set(name, (scope.names.get(name) || 0) | 1);
	        this.maybeExportDefined(scope, name);
	        if (scope.flags & 387) break;
	      }
	    }
	    if (this.parser.inModule && scope.flags & 1) {
	      this.undefinedExports.delete(name);
	    }
	  }
	  maybeExportDefined(scope, name) {
	    if (this.parser.inModule && scope.flags & 1) {
	      this.undefinedExports.delete(name);
	    }
	  }
	  checkRedeclarationInScope(scope, name, bindingType, loc) {
	    if (this.isRedeclaredInScope(scope, name, bindingType)) {
	      this.parser.raise(Errors.VarRedeclaration, loc, {
	        identifierName: name
	      });
	    }
	  }
	  isRedeclaredInScope(scope, name, bindingType) {
	    if (!(bindingType & 1)) return false;
	    if (bindingType & 8) {
	      return scope.names.has(name);
	    }
	    const type = scope.names.get(name);
	    if (bindingType & 16) {
	      return (type & 2) > 0 || !this.treatFunctionsAsVarInScope(scope) && (type & 1) > 0;
	    }
	    return (type & 2) > 0 && !(scope.flags & 8 && scope.firstLexicalName === name) || !this.treatFunctionsAsVarInScope(scope) && (type & 4) > 0;
	  }
	  checkLocalExport(id) {
	    const {
	      name
	    } = id;
	    const topLevelScope = this.scopeStack[0];
	    if (!topLevelScope.names.has(name)) {
	      this.undefinedExports.set(name, id.loc.start);
	    }
	  }
	  currentScope() {
	    return this.scopeStack[this.scopeStack.length - 1];
	  }
	  currentVarScopeFlags() {
	    for (let i = this.scopeStack.length - 1;; i--) {
	      const {
	        flags
	      } = this.scopeStack[i];
	      if (flags & 387) {
	        return flags;
	      }
	    }
	  }
	  currentThisScopeFlags() {
	    for (let i = this.scopeStack.length - 1;; i--) {
	      const {
	        flags
	      } = this.scopeStack[i];
	      if (flags & (387 | 64) && !(flags & 4)) {
	        return flags;
	      }
	    }
	  }
	}
	class FlowScope extends Scope {
	  constructor(...args) {
	    super(...args);
	    this.declareFunctions = new Set();
	  }
	}
	class FlowScopeHandler extends ScopeHandler {
	  createScope(flags) {
	    return new FlowScope(flags);
	  }
	  declareName(name, bindingType, loc) {
	    const scope = this.currentScope();
	    if (bindingType & 2048) {
	      this.checkRedeclarationInScope(scope, name, bindingType, loc);
	      this.maybeExportDefined(scope, name);
	      scope.declareFunctions.add(name);
	      return;
	    }
	    super.declareName(name, bindingType, loc);
	  }
	  isRedeclaredInScope(scope, name, bindingType) {
	    if (super.isRedeclaredInScope(scope, name, bindingType)) return true;
	    if (bindingType & 2048 && !scope.declareFunctions.has(name)) {
	      const type = scope.names.get(name);
	      return (type & 4) > 0 || (type & 2) > 0;
	    }
	    return false;
	  }
	  checkLocalExport(id) {
	    if (!this.scopeStack[0].declareFunctions.has(id.name)) {
	      super.checkLocalExport(id);
	    }
	  }
	}
	class BaseParser {
	  constructor() {
	    this.sawUnambiguousESM = false;
	    this.ambiguousScriptDifferentAst = false;
	  }
	  hasPlugin(pluginConfig) {
	    if (typeof pluginConfig === "string") {
	      return this.plugins.has(pluginConfig);
	    } else {
	      const [pluginName, pluginOptions] = pluginConfig;
	      if (!this.hasPlugin(pluginName)) {
	        return false;
	      }
	      const actualOptions = this.plugins.get(pluginName);
	      for (const key of Object.keys(pluginOptions)) {
	        if ((actualOptions == null ? void 0 : actualOptions[key]) !== pluginOptions[key]) {
	          return false;
	        }
	      }
	      return true;
	    }
	  }
	  getPluginOption(plugin, name) {
	    var _this$plugins$get;
	    return (_this$plugins$get = this.plugins.get(plugin)) == null ? void 0 : _this$plugins$get[name];
	  }
	}
	function setTrailingComments(node, comments) {
	  if (node.trailingComments === undefined) {
	    node.trailingComments = comments;
	  } else {
	    node.trailingComments.unshift(...comments);
	  }
	}
	function setLeadingComments(node, comments) {
	  if (node.leadingComments === undefined) {
	    node.leadingComments = comments;
	  } else {
	    node.leadingComments.unshift(...comments);
	  }
	}
	function setInnerComments(node, comments) {
	  if (node.innerComments === undefined) {
	    node.innerComments = comments;
	  } else {
	    node.innerComments.unshift(...comments);
	  }
	}
	function adjustInnerComments(node, elements, commentWS) {
	  let lastElement = null;
	  let i = elements.length;
	  while (lastElement === null && i > 0) {
	    lastElement = elements[--i];
	  }
	  if (lastElement === null || lastElement.start > commentWS.start) {
	    setInnerComments(node, commentWS.comments);
	  } else {
	    setTrailingComments(lastElement, commentWS.comments);
	  }
	}
	class CommentsParser extends BaseParser {
	  addComment(comment) {
	    if (this.filename) comment.loc.filename = this.filename;
	    const {
	      commentsLen
	    } = this.state;
	    if (this.comments.length !== commentsLen) {
	      this.comments.length = commentsLen;
	    }
	    this.comments.push(comment);
	    this.state.commentsLen++;
	  }
	  processComment(node) {
	    const {
	      commentStack
	    } = this.state;
	    const commentStackLength = commentStack.length;
	    if (commentStackLength === 0) return;
	    let i = commentStackLength - 1;
	    const lastCommentWS = commentStack[i];
	    if (lastCommentWS.start === node.end) {
	      lastCommentWS.leadingNode = node;
	      i--;
	    }
	    const {
	      start: nodeStart
	    } = node;
	    for (; i >= 0; i--) {
	      const commentWS = commentStack[i];
	      const commentEnd = commentWS.end;
	      if (commentEnd > nodeStart) {
	        commentWS.containingNode = node;
	        this.finalizeComment(commentWS);
	        commentStack.splice(i, 1);
	      } else {
	        if (commentEnd === nodeStart) {
	          commentWS.trailingNode = node;
	        }
	        break;
	      }
	    }
	  }
	  finalizeComment(commentWS) {
	    const {
	      comments
	    } = commentWS;
	    if (commentWS.leadingNode !== null || commentWS.trailingNode !== null) {
	      if (commentWS.leadingNode !== null) {
	        setTrailingComments(commentWS.leadingNode, comments);
	      }
	      if (commentWS.trailingNode !== null) {
	        setLeadingComments(commentWS.trailingNode, comments);
	      }
	    } else {
	      const {
	        containingNode: node,
	        start: commentStart
	      } = commentWS;
	      if (this.input.charCodeAt(commentStart - 1) === 44) {
	        switch (node.type) {
	          case "ObjectExpression":
	          case "ObjectPattern":
	          case "RecordExpression":
	            adjustInnerComments(node, node.properties, commentWS);
	            break;
	          case "CallExpression":
	          case "OptionalCallExpression":
	            adjustInnerComments(node, node.arguments, commentWS);
	            break;
	          case "FunctionDeclaration":
	          case "FunctionExpression":
	          case "ArrowFunctionExpression":
	          case "ObjectMethod":
	          case "ClassMethod":
	          case "ClassPrivateMethod":
	            adjustInnerComments(node, node.params, commentWS);
	            break;
	          case "ArrayExpression":
	          case "ArrayPattern":
	          case "TupleExpression":
	            adjustInnerComments(node, node.elements, commentWS);
	            break;
	          case "ExportNamedDeclaration":
	          case "ImportDeclaration":
	            adjustInnerComments(node, node.specifiers, commentWS);
	            break;
	          default:
	            {
	              setInnerComments(node, comments);
	            }
	        }
	      } else {
	        setInnerComments(node, comments);
	      }
	    }
	  }
	  finalizeRemainingComments() {
	    const {
	      commentStack
	    } = this.state;
	    for (let i = commentStack.length - 1; i >= 0; i--) {
	      this.finalizeComment(commentStack[i]);
	    }
	    this.state.commentStack = [];
	  }
	  resetPreviousNodeTrailingComments(node) {
	    const {
	      commentStack
	    } = this.state;
	    const {
	      length
	    } = commentStack;
	    if (length === 0) return;
	    const commentWS = commentStack[length - 1];
	    if (commentWS.leadingNode === node) {
	      commentWS.leadingNode = null;
	    }
	  }
	  resetPreviousIdentifierLeadingComments(node) {
	    const {
	      commentStack
	    } = this.state;
	    const {
	      length
	    } = commentStack;
	    if (length === 0) return;
	    if (commentStack[length - 1].trailingNode === node) {
	      commentStack[length - 1].trailingNode = null;
	    } else if (length >= 2 && commentStack[length - 2].trailingNode === node) {
	      commentStack[length - 2].trailingNode = null;
	    }
	  }
	  takeSurroundingComments(node, start, end) {
	    const {
	      commentStack
	    } = this.state;
	    const commentStackLength = commentStack.length;
	    if (commentStackLength === 0) return;
	    let i = commentStackLength - 1;
	    for (; i >= 0; i--) {
	      const commentWS = commentStack[i];
	      const commentEnd = commentWS.end;
	      const commentStart = commentWS.start;
	      if (commentStart === end) {
	        commentWS.leadingNode = node;
	      } else if (commentEnd === start) {
	        commentWS.trailingNode = node;
	      } else if (commentEnd < start) {
	        break;
	      }
	    }
	  }
	}
	const lineBreak = /\r\n?|[\n\u2028\u2029]/;
	const lineBreakG = new RegExp(lineBreak.source, "g");
	function isNewLine(code) {
	  switch (code) {
	    case 10:
	    case 13:
	    case 8232:
	    case 8233:
	      return true;
	    default:
	      return false;
	  }
	}
	const skipWhiteSpace = /(?:\s|\/\/.*|\/\*[^]*?\*\/)*/g;
	const skipWhiteSpaceInLine = /(?:[^\S\n\r\u2028\u2029]|\/\/.*|\/\*.*?\*\/)*/g;
	const skipWhiteSpaceToLineBreak = new RegExp("(?=(" + skipWhiteSpaceInLine.source + "))\\1" + /(?=[\n\r\u2028\u2029]|\/\*(?!.*?\*\/)|$)/.source, "y");
	function isWhitespace(code) {
	  switch (code) {
	    case 0x0009:
	    case 0x000b:
	    case 0x000c:
	    case 32:
	    case 160:
	    case 5760:
	    case 0x2000:
	    case 0x2001:
	    case 0x2002:
	    case 0x2003:
	    case 0x2004:
	    case 0x2005:
	    case 0x2006:
	    case 0x2007:
	    case 0x2008:
	    case 0x2009:
	    case 0x200a:
	    case 0x202f:
	    case 0x205f:
	    case 0x3000:
	    case 0xfeff:
	      return true;
	    default:
	      return false;
	  }
	}
	class State {
	  constructor() {
	    this.flags = 1024;
	    this.curLine = void 0;
	    this.lineStart = void 0;
	    this.startLoc = void 0;
	    this.endLoc = void 0;
	    this.errors = [];
	    this.potentialArrowAt = -1;
	    this.noArrowAt = [];
	    this.noArrowParamsConversionAt = [];
	    this.topicContext = {
	      maxNumOfResolvableTopics: 0,
	      maxTopicIndex: null
	    };
	    this.labels = [];
	    this.commentsLen = 0;
	    this.commentStack = [];
	    this.pos = 0;
	    this.type = 139;
	    this.value = null;
	    this.start = 0;
	    this.end = 0;
	    this.lastTokEndLoc = null;
	    this.lastTokStartLoc = null;
	    this.context = [types.brace];
	    this.firstInvalidTemplateEscapePos = null;
	    this.strictErrors = new Map();
	    this.tokensLength = 0;
	  }
	  get strict() {
	    return (this.flags & 1) > 0;
	  }
	  set strict(value) {
	    if (value) {
	      this.flags |= 1;
	    } else {
	      this.flags &= ~1;
	    }
	  }
	  init({
	    strictMode,
	    sourceType,
	    startLine,
	    startColumn
	  }) {
	    this.strict = strictMode === false ? false : strictMode === true ? true : sourceType === "module";
	    this.curLine = startLine;
	    this.lineStart = -startColumn;
	    this.startLoc = this.endLoc = new Position(startLine, startColumn, 0);
	  }
	  get maybeInArrowParameters() {
	    return (this.flags & 2) > 0;
	  }
	  set maybeInArrowParameters(value) {
	    if (value) {
	      this.flags |= 2;
	    } else {
	      this.flags &= ~2;
	    }
	  }
	  get inType() {
	    return (this.flags & 4) > 0;
	  }
	  set inType(value) {
	    if (value) {
	      this.flags |= 4;
	    } else {
	      this.flags &= ~4;
	    }
	  }
	  get noAnonFunctionType() {
	    return (this.flags & 8) > 0;
	  }
	  set noAnonFunctionType(value) {
	    if (value) {
	      this.flags |= 8;
	    } else {
	      this.flags &= ~8;
	    }
	  }
	  get hasFlowComment() {
	    return (this.flags & 16) > 0;
	  }
	  set hasFlowComment(value) {
	    if (value) {
	      this.flags |= 16;
	    } else {
	      this.flags &= ~16;
	    }
	  }
	  get isAmbientContext() {
	    return (this.flags & 32) > 0;
	  }
	  set isAmbientContext(value) {
	    if (value) {
	      this.flags |= 32;
	    } else {
	      this.flags &= ~32;
	    }
	  }
	  get inAbstractClass() {
	    return (this.flags & 64) > 0;
	  }
	  set inAbstractClass(value) {
	    if (value) {
	      this.flags |= 64;
	    } else {
	      this.flags &= ~64;
	    }
	  }
	  get inDisallowConditionalTypesContext() {
	    return (this.flags & 128) > 0;
	  }
	  set inDisallowConditionalTypesContext(value) {
	    if (value) {
	      this.flags |= 128;
	    } else {
	      this.flags &= ~128;
	    }
	  }
	  get soloAwait() {
	    return (this.flags & 256) > 0;
	  }
	  set soloAwait(value) {
	    if (value) {
	      this.flags |= 256;
	    } else {
	      this.flags &= ~256;
	    }
	  }
	  get inFSharpPipelineDirectBody() {
	    return (this.flags & 512) > 0;
	  }
	  set inFSharpPipelineDirectBody(value) {
	    if (value) {
	      this.flags |= 512;
	    } else {
	      this.flags &= ~512;
	    }
	  }
	  get canStartJSXElement() {
	    return (this.flags & 1024) > 0;
	  }
	  set canStartJSXElement(value) {
	    if (value) {
	      this.flags |= 1024;
	    } else {
	      this.flags &= ~1024;
	    }
	  }
	  get containsEsc() {
	    return (this.flags & 2048) > 0;
	  }
	  set containsEsc(value) {
	    if (value) {
	      this.flags |= 2048;
	    } else {
	      this.flags &= ~2048;
	    }
	  }
	  curPosition() {
	    return new Position(this.curLine, this.pos - this.lineStart, this.pos);
	  }
	  clone() {
	    const state = new State();
	    state.flags = this.flags;
	    state.curLine = this.curLine;
	    state.lineStart = this.lineStart;
	    state.startLoc = this.startLoc;
	    state.endLoc = this.endLoc;
	    state.errors = this.errors.slice();
	    state.potentialArrowAt = this.potentialArrowAt;
	    state.noArrowAt = this.noArrowAt.slice();
	    state.noArrowParamsConversionAt = this.noArrowParamsConversionAt.slice();
	    state.topicContext = this.topicContext;
	    state.labels = this.labels.slice();
	    state.commentsLen = this.commentsLen;
	    state.commentStack = this.commentStack.slice();
	    state.pos = this.pos;
	    state.type = this.type;
	    state.value = this.value;
	    state.start = this.start;
	    state.end = this.end;
	    state.lastTokEndLoc = this.lastTokEndLoc;
	    state.lastTokStartLoc = this.lastTokStartLoc;
	    state.context = this.context.slice();
	    state.firstInvalidTemplateEscapePos = this.firstInvalidTemplateEscapePos;
	    state.strictErrors = this.strictErrors;
	    state.tokensLength = this.tokensLength;
	    return state;
	  }
	}
	var _isDigit = function isDigit(code) {
	  return code >= 48 && code <= 57;
	};
	const forbiddenNumericSeparatorSiblings = {
	  decBinOct: new Set([46, 66, 69, 79, 95, 98, 101, 111]),
	  hex: new Set([46, 88, 95, 120])
	};
	const isAllowedNumericSeparatorSibling = {
	  bin: ch => ch === 48 || ch === 49,
	  oct: ch => ch >= 48 && ch <= 55,
	  dec: ch => ch >= 48 && ch <= 57,
	  hex: ch => ch >= 48 && ch <= 57 || ch >= 65 && ch <= 70 || ch >= 97 && ch <= 102
	};
	function readStringContents(type, input, pos, lineStart, curLine, errors) {
	  const initialPos = pos;
	  const initialLineStart = lineStart;
	  const initialCurLine = curLine;
	  let out = "";
	  let firstInvalidLoc = null;
	  let chunkStart = pos;
	  const {
	    length
	  } = input;
	  for (;;) {
	    if (pos >= length) {
	      errors.unterminated(initialPos, initialLineStart, initialCurLine);
	      out += input.slice(chunkStart, pos);
	      break;
	    }
	    const ch = input.charCodeAt(pos);
	    if (isStringEnd(type, ch, input, pos)) {
	      out += input.slice(chunkStart, pos);
	      break;
	    }
	    if (ch === 92) {
	      out += input.slice(chunkStart, pos);
	      const res = readEscapedChar(input, pos, lineStart, curLine, type === "template", errors);
	      if (res.ch === null && !firstInvalidLoc) {
	        firstInvalidLoc = {
	          pos,
	          lineStart,
	          curLine
	        };
	      } else {
	        out += res.ch;
	      }
	      ({
	        pos,
	        lineStart,
	        curLine
	      } = res);
	      chunkStart = pos;
	    } else if (ch === 8232 || ch === 8233) {
	      ++pos;
	      ++curLine;
	      lineStart = pos;
	    } else if (ch === 10 || ch === 13) {
	      if (type === "template") {
	        out += input.slice(chunkStart, pos) + "\n";
	        ++pos;
	        if (ch === 13 && input.charCodeAt(pos) === 10) {
	          ++pos;
	        }
	        ++curLine;
	        chunkStart = lineStart = pos;
	      } else {
	        errors.unterminated(initialPos, initialLineStart, initialCurLine);
	      }
	    } else {
	      ++pos;
	    }
	  }
	  return {
	    pos,
	    str: out,
	    firstInvalidLoc,
	    lineStart,
	    curLine,
	    containsInvalid: !!firstInvalidLoc
	  };
	}
	function isStringEnd(type, ch, input, pos) {
	  if (type === "template") {
	    return ch === 96 || ch === 36 && input.charCodeAt(pos + 1) === 123;
	  }
	  return ch === (type === "double" ? 34 : 39);
	}
	function readEscapedChar(input, pos, lineStart, curLine, inTemplate, errors) {
	  const throwOnInvalid = !inTemplate;
	  pos++;
	  const res = ch => ({
	    pos,
	    ch,
	    lineStart,
	    curLine
	  });
	  const ch = input.charCodeAt(pos++);
	  switch (ch) {
	    case 110:
	      return res("\n");
	    case 114:
	      return res("\r");
	    case 120:
	      {
	        let code;
	        ({
	          code,
	          pos
	        } = readHexChar(input, pos, lineStart, curLine, 2, false, throwOnInvalid, errors));
	        return res(code === null ? null : String.fromCharCode(code));
	      }
	    case 117:
	      {
	        let code;
	        ({
	          code,
	          pos
	        } = readCodePoint(input, pos, lineStart, curLine, throwOnInvalid, errors));
	        return res(code === null ? null : String.fromCodePoint(code));
	      }
	    case 116:
	      return res("\t");
	    case 98:
	      return res("\b");
	    case 118:
	      return res("\u000b");
	    case 102:
	      return res("\f");
	    case 13:
	      if (input.charCodeAt(pos) === 10) {
	        ++pos;
	      }
	    case 10:
	      lineStart = pos;
	      ++curLine;
	    case 8232:
	    case 8233:
	      return res("");
	    case 56:
	    case 57:
	      if (inTemplate) {
	        return res(null);
	      } else {
	        errors.strictNumericEscape(pos - 1, lineStart, curLine);
	      }
	    default:
	      if (ch >= 48 && ch <= 55) {
	        const startPos = pos - 1;
	        const match = input.slice(startPos, pos + 2).match(/^[0-7]+/);
	        let octalStr = match[0];
	        let octal = parseInt(octalStr, 8);
	        if (octal > 255) {
	          octalStr = octalStr.slice(0, -1);
	          octal = parseInt(octalStr, 8);
	        }
	        pos += octalStr.length - 1;
	        const next = input.charCodeAt(pos);
	        if (octalStr !== "0" || next === 56 || next === 57) {
	          if (inTemplate) {
	            return res(null);
	          } else {
	            errors.strictNumericEscape(startPos, lineStart, curLine);
	          }
	        }
	        return res(String.fromCharCode(octal));
	      }
	      return res(String.fromCharCode(ch));
	  }
	}
	function readHexChar(input, pos, lineStart, curLine, len, forceLen, throwOnInvalid, errors) {
	  const initialPos = pos;
	  let n;
	  ({
	    n,
	    pos
	  } = readInt(input, pos, lineStart, curLine, 16, len, forceLen, false, errors, !throwOnInvalid));
	  if (n === null) {
	    if (throwOnInvalid) {
	      errors.invalidEscapeSequence(initialPos, lineStart, curLine);
	    } else {
	      pos = initialPos - 1;
	    }
	  }
	  return {
	    code: n,
	    pos
	  };
	}
	function readInt(input, pos, lineStart, curLine, radix, len, forceLen, allowNumSeparator, errors, bailOnError) {
	  const start = pos;
	  const forbiddenSiblings = radix === 16 ? forbiddenNumericSeparatorSiblings.hex : forbiddenNumericSeparatorSiblings.decBinOct;
	  const isAllowedSibling = radix === 16 ? isAllowedNumericSeparatorSibling.hex : radix === 10 ? isAllowedNumericSeparatorSibling.dec : radix === 8 ? isAllowedNumericSeparatorSibling.oct : isAllowedNumericSeparatorSibling.bin;
	  let invalid = false;
	  let total = 0;
	  for (let i = 0, e = len == null ? Infinity : len; i < e; ++i) {
	    const code = input.charCodeAt(pos);
	    let val;
	    if (code === 95 && allowNumSeparator !== "bail") {
	      const prev = input.charCodeAt(pos - 1);
	      const next = input.charCodeAt(pos + 1);
	      if (!allowNumSeparator) {
	        if (bailOnError) return {
	          n: null,
	          pos
	        };
	        errors.numericSeparatorInEscapeSequence(pos, lineStart, curLine);
	      } else if (Number.isNaN(next) || !isAllowedSibling(next) || forbiddenSiblings.has(prev) || forbiddenSiblings.has(next)) {
	        if (bailOnError) return {
	          n: null,
	          pos
	        };
	        errors.unexpectedNumericSeparator(pos, lineStart, curLine);
	      }
	      ++pos;
	      continue;
	    }
	    if (code >= 97) {
	      val = code - 97 + 10;
	    } else if (code >= 65) {
	      val = code - 65 + 10;
	    } else if (_isDigit(code)) {
	      val = code - 48;
	    } else {
	      val = Infinity;
	    }
	    if (val >= radix) {
	      if (val <= 9 && bailOnError) {
	        return {
	          n: null,
	          pos
	        };
	      } else if (val <= 9 && errors.invalidDigit(pos, lineStart, curLine, radix)) {
	        val = 0;
	      } else if (forceLen) {
	        val = 0;
	        invalid = true;
	      } else {
	        break;
	      }
	    }
	    ++pos;
	    total = total * radix + val;
	  }
	  if (pos === start || len != null && pos - start !== len || invalid) {
	    return {
	      n: null,
	      pos
	    };
	  }
	  return {
	    n: total,
	    pos
	  };
	}
	function readCodePoint(input, pos, lineStart, curLine, throwOnInvalid, errors) {
	  const ch = input.charCodeAt(pos);
	  let code;
	  if (ch === 123) {
	    ++pos;
	    ({
	      code,
	      pos
	    } = readHexChar(input, pos, lineStart, curLine, input.indexOf("}", pos) - pos, true, throwOnInvalid, errors));
	    ++pos;
	    if (code !== null && code > 0x10ffff) {
	      if (throwOnInvalid) {
	        errors.invalidCodePoint(pos, lineStart, curLine);
	      } else {
	        return {
	          code: null,
	          pos
	        };
	      }
	    }
	  } else {
	    ({
	      code,
	      pos
	    } = readHexChar(input, pos, lineStart, curLine, 4, false, throwOnInvalid, errors));
	  }
	  return {
	    code,
	    pos
	  };
	}
	function buildPosition(pos, lineStart, curLine) {
	  return new Position(curLine, pos - lineStart, pos);
	}
	const VALID_REGEX_FLAGS = new Set([103, 109, 115, 105, 121, 117, 100, 118]);
	class Token {
	  constructor(state) {
	    this.type = state.type;
	    this.value = state.value;
	    this.start = state.start;
	    this.end = state.end;
	    this.loc = new SourceLocation(state.startLoc, state.endLoc);
	  }
	}
	class Tokenizer extends CommentsParser {
	  constructor(options, input) {
	    super();
	    this.isLookahead = void 0;
	    this.tokens = [];
	    this.errorHandlers_readInt = {
	      invalidDigit: (pos, lineStart, curLine, radix) => {
	        if (!this.options.errorRecovery) return false;
	        this.raise(Errors.InvalidDigit, buildPosition(pos, lineStart, curLine), {
	          radix
	        });
	        return true;
	      },
	      numericSeparatorInEscapeSequence: this.errorBuilder(Errors.NumericSeparatorInEscapeSequence),
	      unexpectedNumericSeparator: this.errorBuilder(Errors.UnexpectedNumericSeparator)
	    };
	    this.errorHandlers_readCodePoint = Object.assign({}, this.errorHandlers_readInt, {
	      invalidEscapeSequence: this.errorBuilder(Errors.InvalidEscapeSequence),
	      invalidCodePoint: this.errorBuilder(Errors.InvalidCodePoint)
	    });
	    this.errorHandlers_readStringContents_string = Object.assign({}, this.errorHandlers_readCodePoint, {
	      strictNumericEscape: (pos, lineStart, curLine) => {
	        this.recordStrictModeErrors(Errors.StrictNumericEscape, buildPosition(pos, lineStart, curLine));
	      },
	      unterminated: (pos, lineStart, curLine) => {
	        throw this.raise(Errors.UnterminatedString, buildPosition(pos - 1, lineStart, curLine));
	      }
	    });
	    this.errorHandlers_readStringContents_template = Object.assign({}, this.errorHandlers_readCodePoint, {
	      strictNumericEscape: this.errorBuilder(Errors.StrictNumericEscape),
	      unterminated: (pos, lineStart, curLine) => {
	        throw this.raise(Errors.UnterminatedTemplate, buildPosition(pos, lineStart, curLine));
	      }
	    });
	    this.state = new State();
	    this.state.init(options);
	    this.input = input;
	    this.length = input.length;
	    this.comments = [];
	    this.isLookahead = false;
	  }
	  pushToken(token) {
	    this.tokens.length = this.state.tokensLength;
	    this.tokens.push(token);
	    ++this.state.tokensLength;
	  }
	  next() {
	    this.checkKeywordEscapes();
	    if (this.options.tokens) {
	      this.pushToken(new Token(this.state));
	    }
	    this.state.lastTokEndLoc = this.state.endLoc;
	    this.state.lastTokStartLoc = this.state.startLoc;
	    this.nextToken();
	  }
	  eat(type) {
	    if (this.match(type)) {
	      this.next();
	      return true;
	    } else {
	      return false;
	    }
	  }
	  match(type) {
	    return this.state.type === type;
	  }
	  createLookaheadState(state) {
	    return {
	      pos: state.pos,
	      value: null,
	      type: state.type,
	      start: state.start,
	      end: state.end,
	      context: [this.curContext()],
	      inType: state.inType,
	      startLoc: state.startLoc,
	      lastTokEndLoc: state.lastTokEndLoc,
	      curLine: state.curLine,
	      lineStart: state.lineStart,
	      curPosition: state.curPosition
	    };
	  }
	  lookahead() {
	    const old = this.state;
	    this.state = this.createLookaheadState(old);
	    this.isLookahead = true;
	    this.nextToken();
	    this.isLookahead = false;
	    const curr = this.state;
	    this.state = old;
	    return curr;
	  }
	  nextTokenStart() {
	    return this.nextTokenStartSince(this.state.pos);
	  }
	  nextTokenStartSince(pos) {
	    skipWhiteSpace.lastIndex = pos;
	    return skipWhiteSpace.test(this.input) ? skipWhiteSpace.lastIndex : pos;
	  }
	  lookaheadCharCode() {
	    return this.input.charCodeAt(this.nextTokenStart());
	  }
	  nextTokenInLineStart() {
	    return this.nextTokenInLineStartSince(this.state.pos);
	  }
	  nextTokenInLineStartSince(pos) {
	    skipWhiteSpaceInLine.lastIndex = pos;
	    return skipWhiteSpaceInLine.test(this.input) ? skipWhiteSpaceInLine.lastIndex : pos;
	  }
	  lookaheadInLineCharCode() {
	    return this.input.charCodeAt(this.nextTokenInLineStart());
	  }
	  codePointAtPos(pos) {
	    let cp = this.input.charCodeAt(pos);
	    if ((cp & 0xfc00) === 0xd800 && ++pos < this.input.length) {
	      const trail = this.input.charCodeAt(pos);
	      if ((trail & 0xfc00) === 0xdc00) {
	        cp = 0x10000 + ((cp & 0x3ff) << 10) + (trail & 0x3ff);
	      }
	    }
	    return cp;
	  }
	  setStrict(strict) {
	    this.state.strict = strict;
	    if (strict) {
	      this.state.strictErrors.forEach(([toParseError, at]) => this.raise(toParseError, at));
	      this.state.strictErrors.clear();
	    }
	  }
	  curContext() {
	    return this.state.context[this.state.context.length - 1];
	  }
	  nextToken() {
	    this.skipSpace();
	    this.state.start = this.state.pos;
	    if (!this.isLookahead) this.state.startLoc = this.state.curPosition();
	    if (this.state.pos >= this.length) {
	      this.finishToken(139);
	      return;
	    }
	    this.getTokenFromCode(this.codePointAtPos(this.state.pos));
	  }
	  skipBlockComment(commentEnd) {
	    let startLoc;
	    if (!this.isLookahead) startLoc = this.state.curPosition();
	    const start = this.state.pos;
	    const end = this.input.indexOf(commentEnd, start + 2);
	    if (end === -1) {
	      throw this.raise(Errors.UnterminatedComment, this.state.curPosition());
	    }
	    this.state.pos = end + commentEnd.length;
	    lineBreakG.lastIndex = start + 2;
	    while (lineBreakG.test(this.input) && lineBreakG.lastIndex <= end) {
	      ++this.state.curLine;
	      this.state.lineStart = lineBreakG.lastIndex;
	    }
	    if (this.isLookahead) return;
	    const comment = {
	      type: "CommentBlock",
	      value: this.input.slice(start + 2, end),
	      start,
	      end: end + commentEnd.length,
	      loc: new SourceLocation(startLoc, this.state.curPosition())
	    };
	    if (this.options.tokens) this.pushToken(comment);
	    return comment;
	  }
	  skipLineComment(startSkip) {
	    const start = this.state.pos;
	    let startLoc;
	    if (!this.isLookahead) startLoc = this.state.curPosition();
	    let ch = this.input.charCodeAt(this.state.pos += startSkip);
	    if (this.state.pos < this.length) {
	      while (!isNewLine(ch) && ++this.state.pos < this.length) {
	        ch = this.input.charCodeAt(this.state.pos);
	      }
	    }
	    if (this.isLookahead) return;
	    const end = this.state.pos;
	    const value = this.input.slice(start + startSkip, end);
	    const comment = {
	      type: "CommentLine",
	      value,
	      start,
	      end,
	      loc: new SourceLocation(startLoc, this.state.curPosition())
	    };
	    if (this.options.tokens) this.pushToken(comment);
	    return comment;
	  }
	  skipSpace() {
	    const spaceStart = this.state.pos;
	    const comments = [];
	    loop: while (this.state.pos < this.length) {
	      const ch = this.input.charCodeAt(this.state.pos);
	      switch (ch) {
	        case 32:
	        case 160:
	        case 9:
	          ++this.state.pos;
	          break;
	        case 13:
	          if (this.input.charCodeAt(this.state.pos + 1) === 10) {
	            ++this.state.pos;
	          }
	        case 10:
	        case 8232:
	        case 8233:
	          ++this.state.pos;
	          ++this.state.curLine;
	          this.state.lineStart = this.state.pos;
	          break;
	        case 47:
	          switch (this.input.charCodeAt(this.state.pos + 1)) {
	            case 42:
	              {
	                const comment = this.skipBlockComment("*/");
	                if (comment !== undefined) {
	                  this.addComment(comment);
	                  if (this.options.attachComment) comments.push(comment);
	                }
	                break;
	              }
	            case 47:
	              {
	                const comment = this.skipLineComment(2);
	                if (comment !== undefined) {
	                  this.addComment(comment);
	                  if (this.options.attachComment) comments.push(comment);
	                }
	                break;
	              }
	            default:
	              break loop;
	          }
	          break;
	        default:
	          if (isWhitespace(ch)) {
	            ++this.state.pos;
	          } else if (ch === 45 && !this.inModule && this.options.annexB) {
	            const pos = this.state.pos;
	            if (this.input.charCodeAt(pos + 1) === 45 && this.input.charCodeAt(pos + 2) === 62 && (spaceStart === 0 || this.state.lineStart > spaceStart)) {
	              const comment = this.skipLineComment(3);
	              if (comment !== undefined) {
	                this.addComment(comment);
	                if (this.options.attachComment) comments.push(comment);
	              }
	            } else {
	              break loop;
	            }
	          } else if (ch === 60 && !this.inModule && this.options.annexB) {
	            const pos = this.state.pos;
	            if (this.input.charCodeAt(pos + 1) === 33 && this.input.charCodeAt(pos + 2) === 45 && this.input.charCodeAt(pos + 3) === 45) {
	              const comment = this.skipLineComment(4);
	              if (comment !== undefined) {
	                this.addComment(comment);
	                if (this.options.attachComment) comments.push(comment);
	              }
	            } else {
	              break loop;
	            }
	          } else {
	            break loop;
	          }
	      }
	    }
	    if (comments.length > 0) {
	      const end = this.state.pos;
	      const commentWhitespace = {
	        start: spaceStart,
	        end,
	        comments,
	        leadingNode: null,
	        trailingNode: null,
	        containingNode: null
	      };
	      this.state.commentStack.push(commentWhitespace);
	    }
	  }
	  finishToken(type, val) {
	    this.state.end = this.state.pos;
	    this.state.endLoc = this.state.curPosition();
	    const prevType = this.state.type;
	    this.state.type = type;
	    this.state.value = val;
	    if (!this.isLookahead) {
	      this.updateContext(prevType);
	    }
	  }
	  replaceToken(type) {
	    this.state.type = type;
	    this.updateContext();
	  }
	  readToken_numberSign() {
	    if (this.state.pos === 0 && this.readToken_interpreter()) {
	      return;
	    }
	    const nextPos = this.state.pos + 1;
	    const next = this.codePointAtPos(nextPos);
	    if (next >= 48 && next <= 57) {
	      throw this.raise(Errors.UnexpectedDigitAfterHash, this.state.curPosition());
	    }
	    if (next === 123 || next === 91 && this.hasPlugin("recordAndTuple")) {
	      this.expectPlugin("recordAndTuple");
	      if (this.getPluginOption("recordAndTuple", "syntaxType") === "bar") {
	        throw this.raise(next === 123 ? Errors.RecordExpressionHashIncorrectStartSyntaxType : Errors.TupleExpressionHashIncorrectStartSyntaxType, this.state.curPosition());
	      }
	      this.state.pos += 2;
	      if (next === 123) {
	        this.finishToken(7);
	      } else {
	        this.finishToken(1);
	      }
	    } else if (isIdentifierStart(next)) {
	      ++this.state.pos;
	      this.finishToken(138, this.readWord1(next));
	    } else if (next === 92) {
	      ++this.state.pos;
	      this.finishToken(138, this.readWord1());
	    } else {
	      this.finishOp(27, 1);
	    }
	  }
	  readToken_dot() {
	    const next = this.input.charCodeAt(this.state.pos + 1);
	    if (next >= 48 && next <= 57) {
	      this.readNumber(true);
	      return;
	    }
	    if (next === 46 && this.input.charCodeAt(this.state.pos + 2) === 46) {
	      this.state.pos += 3;
	      this.finishToken(21);
	    } else {
	      ++this.state.pos;
	      this.finishToken(16);
	    }
	  }
	  readToken_slash() {
	    const next = this.input.charCodeAt(this.state.pos + 1);
	    if (next === 61) {
	      this.finishOp(31, 2);
	    } else {
	      this.finishOp(56, 1);
	    }
	  }
	  readToken_interpreter() {
	    if (this.state.pos !== 0 || this.length < 2) return false;
	    let ch = this.input.charCodeAt(this.state.pos + 1);
	    if (ch !== 33) return false;
	    const start = this.state.pos;
	    this.state.pos += 1;
	    while (!isNewLine(ch) && ++this.state.pos < this.length) {
	      ch = this.input.charCodeAt(this.state.pos);
	    }
	    const value = this.input.slice(start + 2, this.state.pos);
	    this.finishToken(28, value);
	    return true;
	  }
	  readToken_mult_modulo(code) {
	    let type = code === 42 ? 55 : 54;
	    let width = 1;
	    let next = this.input.charCodeAt(this.state.pos + 1);
	    if (code === 42 && next === 42) {
	      width++;
	      next = this.input.charCodeAt(this.state.pos + 2);
	      type = 57;
	    }
	    if (next === 61 && !this.state.inType) {
	      width++;
	      type = code === 37 ? 33 : 30;
	    }
	    this.finishOp(type, width);
	  }
	  readToken_pipe_amp(code) {
	    const next = this.input.charCodeAt(this.state.pos + 1);
	    if (next === code) {
	      if (this.input.charCodeAt(this.state.pos + 2) === 61) {
	        this.finishOp(30, 3);
	      } else {
	        this.finishOp(code === 124 ? 41 : 42, 2);
	      }
	      return;
	    }
	    if (code === 124) {
	      if (next === 62) {
	        this.finishOp(39, 2);
	        return;
	      }
	      if (this.hasPlugin("recordAndTuple") && next === 125) {
	        if (this.getPluginOption("recordAndTuple", "syntaxType") !== "bar") {
	          throw this.raise(Errors.RecordExpressionBarIncorrectEndSyntaxType, this.state.curPosition());
	        }
	        this.state.pos += 2;
	        this.finishToken(9);
	        return;
	      }
	      if (this.hasPlugin("recordAndTuple") && next === 93) {
	        if (this.getPluginOption("recordAndTuple", "syntaxType") !== "bar") {
	          throw this.raise(Errors.TupleExpressionBarIncorrectEndSyntaxType, this.state.curPosition());
	        }
	        this.state.pos += 2;
	        this.finishToken(4);
	        return;
	      }
	    }
	    if (next === 61) {
	      this.finishOp(30, 2);
	      return;
	    }
	    this.finishOp(code === 124 ? 43 : 45, 1);
	  }
	  readToken_caret() {
	    const next = this.input.charCodeAt(this.state.pos + 1);
	    if (next === 61 && !this.state.inType) {
	      this.finishOp(32, 2);
	    } else if (next === 94 && this.hasPlugin(["pipelineOperator", {
	      proposal: "hack",
	      topicToken: "^^"
	    }])) {
	      this.finishOp(37, 2);
	      const lookaheadCh = this.input.codePointAt(this.state.pos);
	      if (lookaheadCh === 94) {
	        this.unexpected();
	      }
	    } else {
	      this.finishOp(44, 1);
	    }
	  }
	  readToken_atSign() {
	    const next = this.input.charCodeAt(this.state.pos + 1);
	    if (next === 64 && this.hasPlugin(["pipelineOperator", {
	      proposal: "hack",
	      topicToken: "@@"
	    }])) {
	      this.finishOp(38, 2);
	    } else {
	      this.finishOp(26, 1);
	    }
	  }
	  readToken_plus_min(code) {
	    const next = this.input.charCodeAt(this.state.pos + 1);
	    if (next === code) {
	      this.finishOp(34, 2);
	      return;
	    }
	    if (next === 61) {
	      this.finishOp(30, 2);
	    } else {
	      this.finishOp(53, 1);
	    }
	  }
	  readToken_lt() {
	    const {
	      pos
	    } = this.state;
	    const next = this.input.charCodeAt(pos + 1);
	    if (next === 60) {
	      if (this.input.charCodeAt(pos + 2) === 61) {
	        this.finishOp(30, 3);
	        return;
	      }
	      this.finishOp(51, 2);
	      return;
	    }
	    if (next === 61) {
	      this.finishOp(49, 2);
	      return;
	    }
	    this.finishOp(47, 1);
	  }
	  readToken_gt() {
	    const {
	      pos
	    } = this.state;
	    const next = this.input.charCodeAt(pos + 1);
	    if (next === 62) {
	      const size = this.input.charCodeAt(pos + 2) === 62 ? 3 : 2;
	      if (this.input.charCodeAt(pos + size) === 61) {
	        this.finishOp(30, size + 1);
	        return;
	      }
	      this.finishOp(52, size);
	      return;
	    }
	    if (next === 61) {
	      this.finishOp(49, 2);
	      return;
	    }
	    this.finishOp(48, 1);
	  }
	  readToken_eq_excl(code) {
	    const next = this.input.charCodeAt(this.state.pos + 1);
	    if (next === 61) {
	      this.finishOp(46, this.input.charCodeAt(this.state.pos + 2) === 61 ? 3 : 2);
	      return;
	    }
	    if (code === 61 && next === 62) {
	      this.state.pos += 2;
	      this.finishToken(19);
	      return;
	    }
	    this.finishOp(code === 61 ? 29 : 35, 1);
	  }
	  readToken_question() {
	    const next = this.input.charCodeAt(this.state.pos + 1);
	    const next2 = this.input.charCodeAt(this.state.pos + 2);
	    if (next === 63) {
	      if (next2 === 61) {
	        this.finishOp(30, 3);
	      } else {
	        this.finishOp(40, 2);
	      }
	    } else if (next === 46 && !(next2 >= 48 && next2 <= 57)) {
	      this.state.pos += 2;
	      this.finishToken(18);
	    } else {
	      ++this.state.pos;
	      this.finishToken(17);
	    }
	  }
	  getTokenFromCode(code) {
	    switch (code) {
	      case 46:
	        this.readToken_dot();
	        return;
	      case 40:
	        ++this.state.pos;
	        this.finishToken(10);
	        return;
	      case 41:
	        ++this.state.pos;
	        this.finishToken(11);
	        return;
	      case 59:
	        ++this.state.pos;
	        this.finishToken(13);
	        return;
	      case 44:
	        ++this.state.pos;
	        this.finishToken(12);
	        return;
	      case 91:
	        if (this.hasPlugin("recordAndTuple") && this.input.charCodeAt(this.state.pos + 1) === 124) {
	          if (this.getPluginOption("recordAndTuple", "syntaxType") !== "bar") {
	            throw this.raise(Errors.TupleExpressionBarIncorrectStartSyntaxType, this.state.curPosition());
	          }
	          this.state.pos += 2;
	          this.finishToken(2);
	        } else {
	          ++this.state.pos;
	          this.finishToken(0);
	        }
	        return;
	      case 93:
	        ++this.state.pos;
	        this.finishToken(3);
	        return;
	      case 123:
	        if (this.hasPlugin("recordAndTuple") && this.input.charCodeAt(this.state.pos + 1) === 124) {
	          if (this.getPluginOption("recordAndTuple", "syntaxType") !== "bar") {
	            throw this.raise(Errors.RecordExpressionBarIncorrectStartSyntaxType, this.state.curPosition());
	          }
	          this.state.pos += 2;
	          this.finishToken(6);
	        } else {
	          ++this.state.pos;
	          this.finishToken(5);
	        }
	        return;
	      case 125:
	        ++this.state.pos;
	        this.finishToken(8);
	        return;
	      case 58:
	        if (this.hasPlugin("functionBind") && this.input.charCodeAt(this.state.pos + 1) === 58) {
	          this.finishOp(15, 2);
	        } else {
	          ++this.state.pos;
	          this.finishToken(14);
	        }
	        return;
	      case 63:
	        this.readToken_question();
	        return;
	      case 96:
	        this.readTemplateToken();
	        return;
	      case 48:
	        {
	          const next = this.input.charCodeAt(this.state.pos + 1);
	          if (next === 120 || next === 88) {
	            this.readRadixNumber(16);
	            return;
	          }
	          if (next === 111 || next === 79) {
	            this.readRadixNumber(8);
	            return;
	          }
	          if (next === 98 || next === 66) {
	            this.readRadixNumber(2);
	            return;
	          }
	        }
	      case 49:
	      case 50:
	      case 51:
	      case 52:
	      case 53:
	      case 54:
	      case 55:
	      case 56:
	      case 57:
	        this.readNumber(false);
	        return;
	      case 34:
	      case 39:
	        this.readString(code);
	        return;
	      case 47:
	        this.readToken_slash();
	        return;
	      case 37:
	      case 42:
	        this.readToken_mult_modulo(code);
	        return;
	      case 124:
	      case 38:
	        this.readToken_pipe_amp(code);
	        return;
	      case 94:
	        this.readToken_caret();
	        return;
	      case 43:
	      case 45:
	        this.readToken_plus_min(code);
	        return;
	      case 60:
	        this.readToken_lt();
	        return;
	      case 62:
	        this.readToken_gt();
	        return;
	      case 61:
	      case 33:
	        this.readToken_eq_excl(code);
	        return;
	      case 126:
	        this.finishOp(36, 1);
	        return;
	      case 64:
	        this.readToken_atSign();
	        return;
	      case 35:
	        this.readToken_numberSign();
	        return;
	      case 92:
	        this.readWord();
	        return;
	      default:
	        if (isIdentifierStart(code)) {
	          this.readWord(code);
	          return;
	        }
	    }
	    throw this.raise(Errors.InvalidOrUnexpectedToken, this.state.curPosition(), {
	      unexpected: String.fromCodePoint(code)
	    });
	  }
	  finishOp(type, size) {
	    const str = this.input.slice(this.state.pos, this.state.pos + size);
	    this.state.pos += size;
	    this.finishToken(type, str);
	  }
	  readRegexp() {
	    const startLoc = this.state.startLoc;
	    const start = this.state.start + 1;
	    let escaped, inClass;
	    let {
	      pos
	    } = this.state;
	    for (;; ++pos) {
	      if (pos >= this.length) {
	        throw this.raise(Errors.UnterminatedRegExp, createPositionWithColumnOffset(startLoc, 1));
	      }
	      const ch = this.input.charCodeAt(pos);
	      if (isNewLine(ch)) {
	        throw this.raise(Errors.UnterminatedRegExp, createPositionWithColumnOffset(startLoc, 1));
	      }
	      if (escaped) {
	        escaped = false;
	      } else {
	        if (ch === 91) {
	          inClass = true;
	        } else if (ch === 93 && inClass) {
	          inClass = false;
	        } else if (ch === 47 && !inClass) {
	          break;
	        }
	        escaped = ch === 92;
	      }
	    }
	    const content = this.input.slice(start, pos);
	    ++pos;
	    let mods = "";
	    const nextPos = () => createPositionWithColumnOffset(startLoc, pos + 2 - start);
	    while (pos < this.length) {
	      const cp = this.codePointAtPos(pos);
	      const char = String.fromCharCode(cp);
	      if (VALID_REGEX_FLAGS.has(cp)) {
	        if (cp === 118) {
	          if (mods.includes("u")) {
	            this.raise(Errors.IncompatibleRegExpUVFlags, nextPos());
	          }
	        } else if (cp === 117) {
	          if (mods.includes("v")) {
	            this.raise(Errors.IncompatibleRegExpUVFlags, nextPos());
	          }
	        }
	        if (mods.includes(char)) {
	          this.raise(Errors.DuplicateRegExpFlags, nextPos());
	        }
	      } else if (isIdentifierChar(cp) || cp === 92) {
	        this.raise(Errors.MalformedRegExpFlags, nextPos());
	      } else {
	        break;
	      }
	      ++pos;
	      mods += char;
	    }
	    this.state.pos = pos;
	    this.finishToken(137, {
	      pattern: content,
	      flags: mods
	    });
	  }
	  readInt(radix, len, forceLen = false, allowNumSeparator = true) {
	    const {
	      n,
	      pos
	    } = readInt(this.input, this.state.pos, this.state.lineStart, this.state.curLine, radix, len, forceLen, allowNumSeparator, this.errorHandlers_readInt, false);
	    this.state.pos = pos;
	    return n;
	  }
	  readRadixNumber(radix) {
	    const startLoc = this.state.curPosition();
	    let isBigInt = false;
	    this.state.pos += 2;
	    const val = this.readInt(radix);
	    if (val == null) {
	      this.raise(Errors.InvalidDigit, createPositionWithColumnOffset(startLoc, 2), {
	        radix
	      });
	    }
	    const next = this.input.charCodeAt(this.state.pos);
	    if (next === 110) {
	      ++this.state.pos;
	      isBigInt = true;
	    } else if (next === 109) {
	      throw this.raise(Errors.InvalidDecimal, startLoc);
	    }
	    if (isIdentifierStart(this.codePointAtPos(this.state.pos))) {
	      throw this.raise(Errors.NumberIdentifier, this.state.curPosition());
	    }
	    if (isBigInt) {
	      const str = this.input.slice(startLoc.index, this.state.pos).replace(/[_n]/g, "");
	      this.finishToken(135, str);
	      return;
	    }
	    this.finishToken(134, val);
	  }
	  readNumber(startsWithDot) {
	    const start = this.state.pos;
	    const startLoc = this.state.curPosition();
	    let isFloat = false;
	    let isBigInt = false;
	    let isDecimal = false;
	    let hasExponent = false;
	    let isOctal = false;
	    if (!startsWithDot && this.readInt(10) === null) {
	      this.raise(Errors.InvalidNumber, this.state.curPosition());
	    }
	    const hasLeadingZero = this.state.pos - start >= 2 && this.input.charCodeAt(start) === 48;
	    if (hasLeadingZero) {
	      const integer = this.input.slice(start, this.state.pos);
	      this.recordStrictModeErrors(Errors.StrictOctalLiteral, startLoc);
	      if (!this.state.strict) {
	        const underscorePos = integer.indexOf("_");
	        if (underscorePos > 0) {
	          this.raise(Errors.ZeroDigitNumericSeparator, createPositionWithColumnOffset(startLoc, underscorePos));
	        }
	      }
	      isOctal = hasLeadingZero && !/[89]/.test(integer);
	    }
	    let next = this.input.charCodeAt(this.state.pos);
	    if (next === 46 && !isOctal) {
	      ++this.state.pos;
	      this.readInt(10);
	      isFloat = true;
	      next = this.input.charCodeAt(this.state.pos);
	    }
	    if ((next === 69 || next === 101) && !isOctal) {
	      next = this.input.charCodeAt(++this.state.pos);
	      if (next === 43 || next === 45) {
	        ++this.state.pos;
	      }
	      if (this.readInt(10) === null) {
	        this.raise(Errors.InvalidOrMissingExponent, startLoc);
	      }
	      isFloat = true;
	      hasExponent = true;
	      next = this.input.charCodeAt(this.state.pos);
	    }
	    if (next === 110) {
	      if (isFloat || hasLeadingZero) {
	        this.raise(Errors.InvalidBigIntLiteral, startLoc);
	      }
	      ++this.state.pos;
	      isBigInt = true;
	    }
	    if (next === 109) {
	      this.expectPlugin("decimal", this.state.curPosition());
	      if (hasExponent || hasLeadingZero) {
	        this.raise(Errors.InvalidDecimal, startLoc);
	      }
	      ++this.state.pos;
	      isDecimal = true;
	    }
	    if (isIdentifierStart(this.codePointAtPos(this.state.pos))) {
	      throw this.raise(Errors.NumberIdentifier, this.state.curPosition());
	    }
	    const str = this.input.slice(start, this.state.pos).replace(/[_mn]/g, "");
	    if (isBigInt) {
	      this.finishToken(135, str);
	      return;
	    }
	    if (isDecimal) {
	      this.finishToken(136, str);
	      return;
	    }
	    const val = isOctal ? parseInt(str, 8) : parseFloat(str);
	    this.finishToken(134, val);
	  }
	  readCodePoint(throwOnInvalid) {
	    const {
	      code,
	      pos
	    } = readCodePoint(this.input, this.state.pos, this.state.lineStart, this.state.curLine, throwOnInvalid, this.errorHandlers_readCodePoint);
	    this.state.pos = pos;
	    return code;
	  }
	  readString(quote) {
	    const {
	      str,
	      pos,
	      curLine,
	      lineStart
	    } = readStringContents(quote === 34 ? "double" : "single", this.input, this.state.pos + 1, this.state.lineStart, this.state.curLine, this.errorHandlers_readStringContents_string);
	    this.state.pos = pos + 1;
	    this.state.lineStart = lineStart;
	    this.state.curLine = curLine;
	    this.finishToken(133, str);
	  }
	  readTemplateContinuation() {
	    if (!this.match(8)) {
	      this.unexpected(null, 8);
	    }
	    this.state.pos--;
	    this.readTemplateToken();
	  }
	  readTemplateToken() {
	    const opening = this.input[this.state.pos];
	    const {
	      str,
	      firstInvalidLoc,
	      pos,
	      curLine,
	      lineStart
	    } = readStringContents("template", this.input, this.state.pos + 1, this.state.lineStart, this.state.curLine, this.errorHandlers_readStringContents_template);
	    this.state.pos = pos + 1;
	    this.state.lineStart = lineStart;
	    this.state.curLine = curLine;
	    if (firstInvalidLoc) {
	      this.state.firstInvalidTemplateEscapePos = new Position(firstInvalidLoc.curLine, firstInvalidLoc.pos - firstInvalidLoc.lineStart, firstInvalidLoc.pos);
	    }
	    if (this.input.codePointAt(pos) === 96) {
	      this.finishToken(24, firstInvalidLoc ? null : opening + str + "`");
	    } else {
	      this.state.pos++;
	      this.finishToken(25, firstInvalidLoc ? null : opening + str + "${");
	    }
	  }
	  recordStrictModeErrors(toParseError, at) {
	    const index = at.index;
	    if (this.state.strict && !this.state.strictErrors.has(index)) {
	      this.raise(toParseError, at);
	    } else {
	      this.state.strictErrors.set(index, [toParseError, at]);
	    }
	  }
	  readWord1(firstCode) {
	    this.state.containsEsc = false;
	    let word = "";
	    const start = this.state.pos;
	    let chunkStart = this.state.pos;
	    if (firstCode !== undefined) {
	      this.state.pos += firstCode <= 0xffff ? 1 : 2;
	    }
	    while (this.state.pos < this.length) {
	      const ch = this.codePointAtPos(this.state.pos);
	      if (isIdentifierChar(ch)) {
	        this.state.pos += ch <= 0xffff ? 1 : 2;
	      } else if (ch === 92) {
	        this.state.containsEsc = true;
	        word += this.input.slice(chunkStart, this.state.pos);
	        const escStart = this.state.curPosition();
	        const identifierCheck = this.state.pos === start ? isIdentifierStart : isIdentifierChar;
	        if (this.input.charCodeAt(++this.state.pos) !== 117) {
	          this.raise(Errors.MissingUnicodeEscape, this.state.curPosition());
	          chunkStart = this.state.pos - 1;
	          continue;
	        }
	        ++this.state.pos;
	        const esc = this.readCodePoint(true);
	        if (esc !== null) {
	          if (!identifierCheck(esc)) {
	            this.raise(Errors.EscapedCharNotAnIdentifier, escStart);
	          }
	          word += String.fromCodePoint(esc);
	        }
	        chunkStart = this.state.pos;
	      } else {
	        break;
	      }
	    }
	    return word + this.input.slice(chunkStart, this.state.pos);
	  }
	  readWord(firstCode) {
	    const word = this.readWord1(firstCode);
	    const type = keywords$1.get(word);
	    if (type !== undefined) {
	      this.finishToken(type, tokenLabelName(type));
	    } else {
	      this.finishToken(132, word);
	    }
	  }
	  checkKeywordEscapes() {
	    const {
	      type
	    } = this.state;
	    if (tokenIsKeyword(type) && this.state.containsEsc) {
	      this.raise(Errors.InvalidEscapedReservedWord, this.state.startLoc, {
	        reservedWord: tokenLabelName(type)
	      });
	    }
	  }
	  raise(toParseError, at, details = {}) {
	    const loc = at instanceof Position ? at : at.loc.start;
	    const error = toParseError(loc, details);
	    if (!this.options.errorRecovery) throw error;
	    if (!this.isLookahead) this.state.errors.push(error);
	    return error;
	  }
	  raiseOverwrite(toParseError, at, details = {}) {
	    const loc = at instanceof Position ? at : at.loc.start;
	    const pos = loc.index;
	    const errors = this.state.errors;
	    for (let i = errors.length - 1; i >= 0; i--) {
	      const error = errors[i];
	      if (error.loc.index === pos) {
	        return errors[i] = toParseError(loc, details);
	      }
	      if (error.loc.index < pos) break;
	    }
	    return this.raise(toParseError, at, details);
	  }
	  updateContext(prevType) {}
	  unexpected(loc, type) {
	    throw this.raise(Errors.UnexpectedToken, loc != null ? loc : this.state.startLoc, {
	      expected: type ? tokenLabelName(type) : null
	    });
	  }
	  expectPlugin(pluginName, loc) {
	    if (this.hasPlugin(pluginName)) {
	      return true;
	    }
	    throw this.raise(Errors.MissingPlugin, loc != null ? loc : this.state.startLoc, {
	      missingPlugin: [pluginName]
	    });
	  }
	  expectOnePlugin(pluginNames) {
	    if (!pluginNames.some(name => this.hasPlugin(name))) {
	      throw this.raise(Errors.MissingOneOfPlugins, this.state.startLoc, {
	        missingPlugin: pluginNames
	      });
	    }
	  }
	  errorBuilder(error) {
	    return (pos, lineStart, curLine) => {
	      this.raise(error, buildPosition(pos, lineStart, curLine));
	    };
	  }
	}
	class ClassScope {
	  constructor() {
	    this.privateNames = new Set();
	    this.loneAccessors = new Map();
	    this.undefinedPrivateNames = new Map();
	  }
	}
	class ClassScopeHandler {
	  constructor(parser) {
	    this.parser = void 0;
	    this.stack = [];
	    this.undefinedPrivateNames = new Map();
	    this.parser = parser;
	  }
	  current() {
	    return this.stack[this.stack.length - 1];
	  }
	  enter() {
	    this.stack.push(new ClassScope());
	  }
	  exit() {
	    const oldClassScope = this.stack.pop();
	    const current = this.current();
	    for (const [name, loc] of Array.from(oldClassScope.undefinedPrivateNames)) {
	      if (current) {
	        if (!current.undefinedPrivateNames.has(name)) {
	          current.undefinedPrivateNames.set(name, loc);
	        }
	      } else {
	        this.parser.raise(Errors.InvalidPrivateFieldResolution, loc, {
	          identifierName: name
	        });
	      }
	    }
	  }
	  declarePrivateName(name, elementType, loc) {
	    const {
	      privateNames,
	      loneAccessors,
	      undefinedPrivateNames
	    } = this.current();
	    let redefined = privateNames.has(name);
	    if (elementType & 3) {
	      const accessor = redefined && loneAccessors.get(name);
	      if (accessor) {
	        const oldStatic = accessor & 4;
	        const newStatic = elementType & 4;
	        const oldKind = accessor & 3;
	        const newKind = elementType & 3;
	        redefined = oldKind === newKind || oldStatic !== newStatic;
	        if (!redefined) loneAccessors.delete(name);
	      } else if (!redefined) {
	        loneAccessors.set(name, elementType);
	      }
	    }
	    if (redefined) {
	      this.parser.raise(Errors.PrivateNameRedeclaration, loc, {
	        identifierName: name
	      });
	    }
	    privateNames.add(name);
	    undefinedPrivateNames.delete(name);
	  }
	  usePrivateName(name, loc) {
	    let classScope;
	    for (classScope of this.stack) {
	      if (classScope.privateNames.has(name)) return;
	    }
	    if (classScope) {
	      classScope.undefinedPrivateNames.set(name, loc);
	    } else {
	      this.parser.raise(Errors.InvalidPrivateFieldResolution, loc, {
	        identifierName: name
	      });
	    }
	  }
	}
	class ExpressionScope {
	  constructor(type = 0) {
	    this.type = type;
	  }
	  canBeArrowParameterDeclaration() {
	    return this.type === 2 || this.type === 1;
	  }
	  isCertainlyParameterDeclaration() {
	    return this.type === 3;
	  }
	}
	class ArrowHeadParsingScope extends ExpressionScope {
	  constructor(type) {
	    super(type);
	    this.declarationErrors = new Map();
	  }
	  recordDeclarationError(ParsingErrorClass, at) {
	    const index = at.index;
	    this.declarationErrors.set(index, [ParsingErrorClass, at]);
	  }
	  clearDeclarationError(index) {
	    this.declarationErrors.delete(index);
	  }
	  iterateErrors(iterator) {
	    this.declarationErrors.forEach(iterator);
	  }
	}
	class ExpressionScopeHandler {
	  constructor(parser) {
	    this.parser = void 0;
	    this.stack = [new ExpressionScope()];
	    this.parser = parser;
	  }
	  enter(scope) {
	    this.stack.push(scope);
	  }
	  exit() {
	    this.stack.pop();
	  }
	  recordParameterInitializerError(toParseError, node) {
	    const origin = node.loc.start;
	    const {
	      stack
	    } = this;
	    let i = stack.length - 1;
	    let scope = stack[i];
	    while (!scope.isCertainlyParameterDeclaration()) {
	      if (scope.canBeArrowParameterDeclaration()) {
	        scope.recordDeclarationError(toParseError, origin);
	      } else {
	        return;
	      }
	      scope = stack[--i];
	    }
	    this.parser.raise(toParseError, origin);
	  }
	  recordArrowParameterBindingError(error, node) {
	    const {
	      stack
	    } = this;
	    const scope = stack[stack.length - 1];
	    const origin = node.loc.start;
	    if (scope.isCertainlyParameterDeclaration()) {
	      this.parser.raise(error, origin);
	    } else if (scope.canBeArrowParameterDeclaration()) {
	      scope.recordDeclarationError(error, origin);
	    } else {
	      return;
	    }
	  }
	  recordAsyncArrowParametersError(at) {
	    const {
	      stack
	    } = this;
	    let i = stack.length - 1;
	    let scope = stack[i];
	    while (scope.canBeArrowParameterDeclaration()) {
	      if (scope.type === 2) {
	        scope.recordDeclarationError(Errors.AwaitBindingIdentifier, at);
	      }
	      scope = stack[--i];
	    }
	  }
	  validateAsPattern() {
	    const {
	      stack
	    } = this;
	    const currentScope = stack[stack.length - 1];
	    if (!currentScope.canBeArrowParameterDeclaration()) return;
	    currentScope.iterateErrors(([toParseError, loc]) => {
	      this.parser.raise(toParseError, loc);
	      let i = stack.length - 2;
	      let scope = stack[i];
	      while (scope.canBeArrowParameterDeclaration()) {
	        scope.clearDeclarationError(loc.index);
	        scope = stack[--i];
	      }
	    });
	  }
	}
	function newParameterDeclarationScope() {
	  return new ExpressionScope(3);
	}
	function newArrowHeadScope() {
	  return new ArrowHeadParsingScope(1);
	}
	function newAsyncArrowScope() {
	  return new ArrowHeadParsingScope(2);
	}
	function newExpressionScope() {
	  return new ExpressionScope();
	}
	class ProductionParameterHandler {
	  constructor() {
	    this.stacks = [];
	  }
	  enter(flags) {
	    this.stacks.push(flags);
	  }
	  exit() {
	    this.stacks.pop();
	  }
	  currentFlags() {
	    return this.stacks[this.stacks.length - 1];
	  }
	  get hasAwait() {
	    return (this.currentFlags() & 2) > 0;
	  }
	  get hasYield() {
	    return (this.currentFlags() & 1) > 0;
	  }
	  get hasReturn() {
	    return (this.currentFlags() & 4) > 0;
	  }
	  get hasIn() {
	    return (this.currentFlags() & 8) > 0;
	  }
	}
	function functionFlags(isAsync, isGenerator) {
	  return (isAsync ? 2 : 0) | (isGenerator ? 1 : 0);
	}
	class UtilParser extends Tokenizer {
	  addExtra(node, key, value, enumerable = true) {
	    if (!node) return;
	    const extra = node.extra = node.extra || {};
	    if (enumerable) {
	      extra[key] = value;
	    } else {
	      Object.defineProperty(extra, key, {
	        enumerable,
	        value
	      });
	    }
	  }
	  isContextual(token) {
	    return this.state.type === token && !this.state.containsEsc;
	  }
	  isUnparsedContextual(nameStart, name) {
	    const nameEnd = nameStart + name.length;
	    if (this.input.slice(nameStart, nameEnd) === name) {
	      const nextCh = this.input.charCodeAt(nameEnd);
	      return !(isIdentifierChar(nextCh) || (nextCh & 0xfc00) === 0xd800);
	    }
	    return false;
	  }
	  isLookaheadContextual(name) {
	    const next = this.nextTokenStart();
	    return this.isUnparsedContextual(next, name);
	  }
	  eatContextual(token) {
	    if (this.isContextual(token)) {
	      this.next();
	      return true;
	    }
	    return false;
	  }
	  expectContextual(token, toParseError) {
	    if (!this.eatContextual(token)) {
	      if (toParseError != null) {
	        throw this.raise(toParseError, this.state.startLoc);
	      }
	      this.unexpected(null, token);
	    }
	  }
	  canInsertSemicolon() {
	    return this.match(139) || this.match(8) || this.hasPrecedingLineBreak();
	  }
	  hasPrecedingLineBreak() {
	    return lineBreak.test(this.input.slice(this.state.lastTokEndLoc.index, this.state.start));
	  }
	  hasFollowingLineBreak() {
	    skipWhiteSpaceToLineBreak.lastIndex = this.state.end;
	    return skipWhiteSpaceToLineBreak.test(this.input);
	  }
	  isLineTerminator() {
	    return this.eat(13) || this.canInsertSemicolon();
	  }
	  semicolon(allowAsi = true) {
	    if (allowAsi ? this.isLineTerminator() : this.eat(13)) return;
	    this.raise(Errors.MissingSemicolon, this.state.lastTokEndLoc);
	  }
	  expect(type, loc) {
	    this.eat(type) || this.unexpected(loc, type);
	  }
	  tryParse(fn, oldState = this.state.clone()) {
	    const abortSignal = {
	      node: null
	    };
	    try {
	      const node = fn((node = null) => {
	        abortSignal.node = node;
	        throw abortSignal;
	      });
	      if (this.state.errors.length > oldState.errors.length) {
	        const failState = this.state;
	        this.state = oldState;
	        this.state.tokensLength = failState.tokensLength;
	        return {
	          node,
	          error: failState.errors[oldState.errors.length],
	          thrown: false,
	          aborted: false,
	          failState
	        };
	      }
	      return {
	        node,
	        error: null,
	        thrown: false,
	        aborted: false,
	        failState: null
	      };
	    } catch (error) {
	      const failState = this.state;
	      this.state = oldState;
	      if (error instanceof SyntaxError) {
	        return {
	          node: null,
	          error,
	          thrown: true,
	          aborted: false,
	          failState
	        };
	      }
	      if (error === abortSignal) {
	        return {
	          node: abortSignal.node,
	          error: null,
	          thrown: false,
	          aborted: true,
	          failState
	        };
	      }
	      throw error;
	    }
	  }
	  checkExpressionErrors(refExpressionErrors, andThrow) {
	    if (!refExpressionErrors) return false;
	    const {
	      shorthandAssignLoc,
	      doubleProtoLoc,
	      privateKeyLoc,
	      optionalParametersLoc
	    } = refExpressionErrors;
	    const hasErrors = !!shorthandAssignLoc || !!doubleProtoLoc || !!optionalParametersLoc || !!privateKeyLoc;
	    if (!andThrow) {
	      return hasErrors;
	    }
	    if (shorthandAssignLoc != null) {
	      this.raise(Errors.InvalidCoverInitializedName, shorthandAssignLoc);
	    }
	    if (doubleProtoLoc != null) {
	      this.raise(Errors.DuplicateProto, doubleProtoLoc);
	    }
	    if (privateKeyLoc != null) {
	      this.raise(Errors.UnexpectedPrivateField, privateKeyLoc);
	    }
	    if (optionalParametersLoc != null) {
	      this.unexpected(optionalParametersLoc);
	    }
	  }
	  isLiteralPropertyName() {
	    return tokenIsLiteralPropertyName(this.state.type);
	  }
	  isPrivateName(node) {
	    return node.type === "PrivateName";
	  }
	  getPrivateNameSV(node) {
	    return node.id.name;
	  }
	  hasPropertyAsPrivateName(node) {
	    return (node.type === "MemberExpression" || node.type === "OptionalMemberExpression") && this.isPrivateName(node.property);
	  }
	  isObjectProperty(node) {
	    return node.type === "ObjectProperty";
	  }
	  isObjectMethod(node) {
	    return node.type === "ObjectMethod";
	  }
	  initializeScopes(inModule = this.options.sourceType === "module") {
	    const oldLabels = this.state.labels;
	    this.state.labels = [];
	    const oldExportedIdentifiers = this.exportedIdentifiers;
	    this.exportedIdentifiers = new Set();
	    const oldInModule = this.inModule;
	    this.inModule = inModule;
	    const oldScope = this.scope;
	    const ScopeHandler = this.getScopeHandler();
	    this.scope = new ScopeHandler(this, inModule);
	    const oldProdParam = this.prodParam;
	    this.prodParam = new ProductionParameterHandler();
	    const oldClassScope = this.classScope;
	    this.classScope = new ClassScopeHandler(this);
	    const oldExpressionScope = this.expressionScope;
	    this.expressionScope = new ExpressionScopeHandler(this);
	    return () => {
	      this.state.labels = oldLabels;
	      this.exportedIdentifiers = oldExportedIdentifiers;
	      this.inModule = oldInModule;
	      this.scope = oldScope;
	      this.prodParam = oldProdParam;
	      this.classScope = oldClassScope;
	      this.expressionScope = oldExpressionScope;
	    };
	  }
	  enterInitialScopes() {
	    let paramFlags = 0;
	    if (this.inModule) {
	      paramFlags |= 2;
	    }
	    this.scope.enter(1);
	    this.prodParam.enter(paramFlags);
	  }
	  checkDestructuringPrivate(refExpressionErrors) {
	    const {
	      privateKeyLoc
	    } = refExpressionErrors;
	    if (privateKeyLoc !== null) {
	      this.expectPlugin("destructuringPrivate", privateKeyLoc);
	    }
	  }
	}
	class ExpressionErrors {
	  constructor() {
	    this.shorthandAssignLoc = null;
	    this.doubleProtoLoc = null;
	    this.privateKeyLoc = null;
	    this.optionalParametersLoc = null;
	  }
	}
	class Node {
	  constructor(parser, pos, loc) {
	    this.type = "";
	    this.start = pos;
	    this.end = 0;
	    this.loc = new SourceLocation(loc);
	    if (parser != null && parser.options.ranges) this.range = [pos, 0];
	    if (parser != null && parser.filename) this.loc.filename = parser.filename;
	  }
	}
	const NodePrototype = Node.prototype;
	{
	  NodePrototype.__clone = function () {
	    const newNode = new Node(undefined, this.start, this.loc.start);
	    const keys = Object.keys(this);
	    for (let i = 0, length = keys.length; i < length; i++) {
	      const key = keys[i];
	      if (key !== "leadingComments" && key !== "trailingComments" && key !== "innerComments") {
	        newNode[key] = this[key];
	      }
	    }
	    return newNode;
	  };
	}
	function clonePlaceholder(node) {
	  return cloneIdentifier(node);
	}
	function cloneIdentifier(node) {
	  const {
	    type,
	    start,
	    end,
	    loc,
	    range,
	    extra,
	    name
	  } = node;
	  const cloned = Object.create(NodePrototype);
	  cloned.type = type;
	  cloned.start = start;
	  cloned.end = end;
	  cloned.loc = loc;
	  cloned.range = range;
	  cloned.extra = extra;
	  cloned.name = name;
	  if (type === "Placeholder") {
	    cloned.expectedNode = node.expectedNode;
	  }
	  return cloned;
	}
	function cloneStringLiteral(node) {
	  const {
	    type,
	    start,
	    end,
	    loc,
	    range,
	    extra
	  } = node;
	  if (type === "Placeholder") {
	    return clonePlaceholder(node);
	  }
	  const cloned = Object.create(NodePrototype);
	  cloned.type = type;
	  cloned.start = start;
	  cloned.end = end;
	  cloned.loc = loc;
	  cloned.range = range;
	  if (node.raw !== undefined) {
	    cloned.raw = node.raw;
	  } else {
	    cloned.extra = extra;
	  }
	  cloned.value = node.value;
	  return cloned;
	}
	class NodeUtils extends UtilParser {
	  startNode() {
	    const loc = this.state.startLoc;
	    return new Node(this, loc.index, loc);
	  }
	  startNodeAt(loc) {
	    return new Node(this, loc.index, loc);
	  }
	  startNodeAtNode(type) {
	    return this.startNodeAt(type.loc.start);
	  }
	  finishNode(node, type) {
	    return this.finishNodeAt(node, type, this.state.lastTokEndLoc);
	  }
	  finishNodeAt(node, type, endLoc) {
	    node.type = type;
	    node.end = endLoc.index;
	    node.loc.end = endLoc;
	    if (this.options.ranges) node.range[1] = endLoc.index;
	    if (this.options.attachComment) this.processComment(node);
	    return node;
	  }
	  resetStartLocation(node, startLoc) {
	    node.start = startLoc.index;
	    node.loc.start = startLoc;
	    if (this.options.ranges) node.range[0] = startLoc.index;
	  }
	  resetEndLocation(node, endLoc = this.state.lastTokEndLoc) {
	    node.end = endLoc.index;
	    node.loc.end = endLoc;
	    if (this.options.ranges) node.range[1] = endLoc.index;
	  }
	  resetStartLocationFromNode(node, locationNode) {
	    this.resetStartLocation(node, locationNode.loc.start);
	  }
	}
	const reservedTypes = new Set(["_", "any", "bool", "boolean", "empty", "extends", "false", "interface", "mixed", "null", "number", "static", "string", "true", "typeof", "void"]);
	const FlowErrors = ParseErrorEnum`flow`({
	  AmbiguousConditionalArrow: "Ambiguous expression: wrap the arrow functions in parentheses to disambiguate.",
	  AmbiguousDeclareModuleKind: "Found both `declare module.exports` and `declare export` in the same module. Modules can only have 1 since they are either an ES module or they are a CommonJS module.",
	  AssignReservedType: ({
	    reservedType
	  }) => `Cannot overwrite reserved type ${reservedType}.`,
	  DeclareClassElement: "The `declare` modifier can only appear on class fields.",
	  DeclareClassFieldInitializer: "Initializers are not allowed in fields with the `declare` modifier.",
	  DuplicateDeclareModuleExports: "Duplicate `declare module.exports` statement.",
	  EnumBooleanMemberNotInitialized: ({
	    memberName,
	    enumName
	  }) => `Boolean enum members need to be initialized. Use either \`${memberName} = true,\` or \`${memberName} = false,\` in enum \`${enumName}\`.`,
	  EnumDuplicateMemberName: ({
	    memberName,
	    enumName
	  }) => `Enum member names need to be unique, but the name \`${memberName}\` has already been used before in enum \`${enumName}\`.`,
	  EnumInconsistentMemberValues: ({
	    enumName
	  }) => `Enum \`${enumName}\` has inconsistent member initializers. Either use no initializers, or consistently use literals (either booleans, numbers, or strings) for all member initializers.`,
	  EnumInvalidExplicitType: ({
	    invalidEnumType,
	    enumName
	  }) => `Enum type \`${invalidEnumType}\` is not valid. Use one of \`boolean\`, \`number\`, \`string\`, or \`symbol\` in enum \`${enumName}\`.`,
	  EnumInvalidExplicitTypeUnknownSupplied: ({
	    enumName
	  }) => `Supplied enum type is not valid. Use one of \`boolean\`, \`number\`, \`string\`, or \`symbol\` in enum \`${enumName}\`.`,
	  EnumInvalidMemberInitializerPrimaryType: ({
	    enumName,
	    memberName,
	    explicitType
	  }) => `Enum \`${enumName}\` has type \`${explicitType}\`, so the initializer of \`${memberName}\` needs to be a ${explicitType} literal.`,
	  EnumInvalidMemberInitializerSymbolType: ({
	    enumName,
	    memberName
	  }) => `Symbol enum members cannot be initialized. Use \`${memberName},\` in enum \`${enumName}\`.`,
	  EnumInvalidMemberInitializerUnknownType: ({
	    enumName,
	    memberName
	  }) => `The enum member initializer for \`${memberName}\` needs to be a literal (either a boolean, number, or string) in enum \`${enumName}\`.`,
	  EnumInvalidMemberName: ({
	    enumName,
	    memberName,
	    suggestion
	  }) => `Enum member names cannot start with lowercase 'a' through 'z'. Instead of using \`${memberName}\`, consider using \`${suggestion}\`, in enum \`${enumName}\`.`,
	  EnumNumberMemberNotInitialized: ({
	    enumName,
	    memberName
	  }) => `Number enum members need to be initialized, e.g. \`${memberName} = 1\` in enum \`${enumName}\`.`,
	  EnumStringMemberInconsistentlyInitialized: ({
	    enumName
	  }) => `String enum members need to consistently either all use initializers, or use no initializers, in enum \`${enumName}\`.`,
	  GetterMayNotHaveThisParam: "A getter cannot have a `this` parameter.",
	  ImportReflectionHasImportType: "An `import module` declaration can not use `type` or `typeof` keyword.",
	  ImportTypeShorthandOnlyInPureImport: "The `type` and `typeof` keywords on named imports can only be used on regular `import` statements. It cannot be used with `import type` or `import typeof` statements.",
	  InexactInsideExact: "Explicit inexact syntax cannot appear inside an explicit exact object type.",
	  InexactInsideNonObject: "Explicit inexact syntax cannot appear in class or interface definitions.",
	  InexactVariance: "Explicit inexact syntax cannot have variance.",
	  InvalidNonTypeImportInDeclareModule: "Imports within a `declare module` body must always be `import type` or `import typeof`.",
	  MissingTypeParamDefault: "Type parameter declaration needs a default, since a preceding type parameter declaration has a default.",
	  NestedDeclareModule: "`declare module` cannot be used inside another `declare module`.",
	  NestedFlowComment: "Cannot have a flow comment inside another flow comment.",
	  PatternIsOptional: Object.assign({
	    message: "A binding pattern parameter cannot be optional in an implementation signature."
	  }, {
	    reasonCode: "OptionalBindingPattern"
	  }),
	  SetterMayNotHaveThisParam: "A setter cannot have a `this` parameter.",
	  SpreadVariance: "Spread properties cannot have variance.",
	  ThisParamAnnotationRequired: "A type annotation is required for the `this` parameter.",
	  ThisParamBannedInConstructor: "Constructors cannot have a `this` parameter; constructors don't bind `this` like other functions.",
	  ThisParamMayNotBeOptional: "The `this` parameter cannot be optional.",
	  ThisParamMustBeFirst: "The `this` parameter must be the first function parameter.",
	  ThisParamNoDefault: "The `this` parameter may not have a default value.",
	  TypeBeforeInitializer: "Type annotations must come before default assignments, e.g. instead of `age = 25: number` use `age: number = 25`.",
	  TypeCastInPattern: "The type cast expression is expected to be wrapped with parenthesis.",
	  UnexpectedExplicitInexactInObject: "Explicit inexact syntax must appear at the end of an inexact object.",
	  UnexpectedReservedType: ({
	    reservedType
	  }) => `Unexpected reserved type ${reservedType}.`,
	  UnexpectedReservedUnderscore: "`_` is only allowed as a type argument to call or new.",
	  UnexpectedSpaceBetweenModuloChecks: "Spaces between `%` and `checks` are not allowed here.",
	  UnexpectedSpreadType: "Spread operator cannot appear in class or interface definitions.",
	  UnexpectedSubtractionOperand: 'Unexpected token, expected "number" or "bigint".',
	  UnexpectedTokenAfterTypeParameter: "Expected an arrow function after this type parameter declaration.",
	  UnexpectedTypeParameterBeforeAsyncArrowFunction: "Type parameters must come after the async keyword, e.g. instead of `<T> async () => {}`, use `async <T>() => {}`.",
	  UnsupportedDeclareExportKind: ({
	    unsupportedExportKind,
	    suggestion
	  }) => `\`declare export ${unsupportedExportKind}\` is not supported. Use \`${suggestion}\` instead.`,
	  UnsupportedStatementInDeclareModule: "Only declares and type imports are allowed inside declare module.",
	  UnterminatedFlowComment: "Unterminated flow-comment."
	});
	function isEsModuleType(bodyElement) {
	  return bodyElement.type === "DeclareExportAllDeclaration" || bodyElement.type === "DeclareExportDeclaration" && (!bodyElement.declaration || bodyElement.declaration.type !== "TypeAlias" && bodyElement.declaration.type !== "InterfaceDeclaration");
	}
	function hasTypeImportKind(node) {
	  return node.importKind === "type" || node.importKind === "typeof";
	}
	const exportSuggestions = {
	  const: "declare export var",
	  let: "declare export var",
	  type: "export type",
	  interface: "export interface"
	};
	function partition(list, test) {
	  const list1 = [];
	  const list2 = [];
	  for (let i = 0; i < list.length; i++) {
	    (test(list[i], i, list) ? list1 : list2).push(list[i]);
	  }
	  return [list1, list2];
	}
	const FLOW_PRAGMA_REGEX = /\*?\s*@((?:no)?flow)\b/;
	var flow = superClass => class FlowParserMixin extends superClass {
	  constructor(...args) {
	    super(...args);
	    this.flowPragma = undefined;
	  }
	  getScopeHandler() {
	    return FlowScopeHandler;
	  }
	  shouldParseTypes() {
	    return this.getPluginOption("flow", "all") || this.flowPragma === "flow";
	  }
	  shouldParseEnums() {
	    return !!this.getPluginOption("flow", "enums");
	  }
	  finishToken(type, val) {
	    if (type !== 133 && type !== 13 && type !== 28) {
	      if (this.flowPragma === undefined) {
	        this.flowPragma = null;
	      }
	    }
	    super.finishToken(type, val);
	  }
	  addComment(comment) {
	    if (this.flowPragma === undefined) {
	      const matches = FLOW_PRAGMA_REGEX.exec(comment.value);
	      if (!matches) ;else if (matches[1] === "flow") {
	        this.flowPragma = "flow";
	      } else if (matches[1] === "noflow") {
	        this.flowPragma = "noflow";
	      } else {
	        throw new Error("Unexpected flow pragma");
	      }
	    }
	    super.addComment(comment);
	  }
	  flowParseTypeInitialiser(tok) {
	    const oldInType = this.state.inType;
	    this.state.inType = true;
	    this.expect(tok || 14);
	    const type = this.flowParseType();
	    this.state.inType = oldInType;
	    return type;
	  }
	  flowParsePredicate() {
	    const node = this.startNode();
	    const moduloLoc = this.state.startLoc;
	    this.next();
	    this.expectContextual(110);
	    if (this.state.lastTokStartLoc.index > moduloLoc.index + 1) {
	      this.raise(FlowErrors.UnexpectedSpaceBetweenModuloChecks, moduloLoc);
	    }
	    if (this.eat(10)) {
	      node.value = super.parseExpression();
	      this.expect(11);
	      return this.finishNode(node, "DeclaredPredicate");
	    } else {
	      return this.finishNode(node, "InferredPredicate");
	    }
	  }
	  flowParseTypeAndPredicateInitialiser() {
	    const oldInType = this.state.inType;
	    this.state.inType = true;
	    this.expect(14);
	    let type = null;
	    let predicate = null;
	    if (this.match(54)) {
	      this.state.inType = oldInType;
	      predicate = this.flowParsePredicate();
	    } else {
	      type = this.flowParseType();
	      this.state.inType = oldInType;
	      if (this.match(54)) {
	        predicate = this.flowParsePredicate();
	      }
	    }
	    return [type, predicate];
	  }
	  flowParseDeclareClass(node) {
	    this.next();
	    this.flowParseInterfaceish(node, true);
	    return this.finishNode(node, "DeclareClass");
	  }
	  flowParseDeclareFunction(node) {
	    this.next();
	    const id = node.id = this.parseIdentifier();
	    const typeNode = this.startNode();
	    const typeContainer = this.startNode();
	    if (this.match(47)) {
	      typeNode.typeParameters = this.flowParseTypeParameterDeclaration();
	    } else {
	      typeNode.typeParameters = null;
	    }
	    this.expect(10);
	    const tmp = this.flowParseFunctionTypeParams();
	    typeNode.params = tmp.params;
	    typeNode.rest = tmp.rest;
	    typeNode.this = tmp._this;
	    this.expect(11);
	    [typeNode.returnType, node.predicate] = this.flowParseTypeAndPredicateInitialiser();
	    typeContainer.typeAnnotation = this.finishNode(typeNode, "FunctionTypeAnnotation");
	    id.typeAnnotation = this.finishNode(typeContainer, "TypeAnnotation");
	    this.resetEndLocation(id);
	    this.semicolon();
	    this.scope.declareName(node.id.name, 2048, node.id.loc.start);
	    return this.finishNode(node, "DeclareFunction");
	  }
	  flowParseDeclare(node, insideModule) {
	    if (this.match(80)) {
	      return this.flowParseDeclareClass(node);
	    } else if (this.match(68)) {
	      return this.flowParseDeclareFunction(node);
	    } else if (this.match(74)) {
	      return this.flowParseDeclareVariable(node);
	    } else if (this.eatContextual(127)) {
	      if (this.match(16)) {
	        return this.flowParseDeclareModuleExports(node);
	      } else {
	        if (insideModule) {
	          this.raise(FlowErrors.NestedDeclareModule, this.state.lastTokStartLoc);
	        }
	        return this.flowParseDeclareModule(node);
	      }
	    } else if (this.isContextual(130)) {
	      return this.flowParseDeclareTypeAlias(node);
	    } else if (this.isContextual(131)) {
	      return this.flowParseDeclareOpaqueType(node);
	    } else if (this.isContextual(129)) {
	      return this.flowParseDeclareInterface(node);
	    } else if (this.match(82)) {
	      return this.flowParseDeclareExportDeclaration(node, insideModule);
	    } else {
	      this.unexpected();
	    }
	  }
	  flowParseDeclareVariable(node) {
	    this.next();
	    node.id = this.flowParseTypeAnnotatableIdentifier(true);
	    this.scope.declareName(node.id.name, 5, node.id.loc.start);
	    this.semicolon();
	    return this.finishNode(node, "DeclareVariable");
	  }
	  flowParseDeclareModule(node) {
	    this.scope.enter(0);
	    if (this.match(133)) {
	      node.id = super.parseExprAtom();
	    } else {
	      node.id = this.parseIdentifier();
	    }
	    const bodyNode = node.body = this.startNode();
	    const body = bodyNode.body = [];
	    this.expect(5);
	    while (!this.match(8)) {
	      let bodyNode = this.startNode();
	      if (this.match(83)) {
	        this.next();
	        if (!this.isContextual(130) && !this.match(87)) {
	          this.raise(FlowErrors.InvalidNonTypeImportInDeclareModule, this.state.lastTokStartLoc);
	        }
	        super.parseImport(bodyNode);
	      } else {
	        this.expectContextual(125, FlowErrors.UnsupportedStatementInDeclareModule);
	        bodyNode = this.flowParseDeclare(bodyNode, true);
	      }
	      body.push(bodyNode);
	    }
	    this.scope.exit();
	    this.expect(8);
	    this.finishNode(bodyNode, "BlockStatement");
	    let kind = null;
	    let hasModuleExport = false;
	    body.forEach(bodyElement => {
	      if (isEsModuleType(bodyElement)) {
	        if (kind === "CommonJS") {
	          this.raise(FlowErrors.AmbiguousDeclareModuleKind, bodyElement);
	        }
	        kind = "ES";
	      } else if (bodyElement.type === "DeclareModuleExports") {
	        if (hasModuleExport) {
	          this.raise(FlowErrors.DuplicateDeclareModuleExports, bodyElement);
	        }
	        if (kind === "ES") {
	          this.raise(FlowErrors.AmbiguousDeclareModuleKind, bodyElement);
	        }
	        kind = "CommonJS";
	        hasModuleExport = true;
	      }
	    });
	    node.kind = kind || "CommonJS";
	    return this.finishNode(node, "DeclareModule");
	  }
	  flowParseDeclareExportDeclaration(node, insideModule) {
	    this.expect(82);
	    if (this.eat(65)) {
	      if (this.match(68) || this.match(80)) {
	        node.declaration = this.flowParseDeclare(this.startNode());
	      } else {
	        node.declaration = this.flowParseType();
	        this.semicolon();
	      }
	      node.default = true;
	      return this.finishNode(node, "DeclareExportDeclaration");
	    } else {
	      if (this.match(75) || this.isLet() || (this.isContextual(130) || this.isContextual(129)) && !insideModule) {
	        const label = this.state.value;
	        throw this.raise(FlowErrors.UnsupportedDeclareExportKind, this.state.startLoc, {
	          unsupportedExportKind: label,
	          suggestion: exportSuggestions[label]
	        });
	      }
	      if (this.match(74) || this.match(68) || this.match(80) || this.isContextual(131)) {
	        node.declaration = this.flowParseDeclare(this.startNode());
	        node.default = false;
	        return this.finishNode(node, "DeclareExportDeclaration");
	      } else if (this.match(55) || this.match(5) || this.isContextual(129) || this.isContextual(130) || this.isContextual(131)) {
	        node = this.parseExport(node, null);
	        if (node.type === "ExportNamedDeclaration") {
	          node.type = "ExportDeclaration";
	          node.default = false;
	          delete node.exportKind;
	        }
	        node.type = "Declare" + node.type;
	        return node;
	      }
	    }
	    this.unexpected();
	  }
	  flowParseDeclareModuleExports(node) {
	    this.next();
	    this.expectContextual(111);
	    node.typeAnnotation = this.flowParseTypeAnnotation();
	    this.semicolon();
	    return this.finishNode(node, "DeclareModuleExports");
	  }
	  flowParseDeclareTypeAlias(node) {
	    this.next();
	    const finished = this.flowParseTypeAlias(node);
	    finished.type = "DeclareTypeAlias";
	    return finished;
	  }
	  flowParseDeclareOpaqueType(node) {
	    this.next();
	    const finished = this.flowParseOpaqueType(node, true);
	    finished.type = "DeclareOpaqueType";
	    return finished;
	  }
	  flowParseDeclareInterface(node) {
	    this.next();
	    this.flowParseInterfaceish(node, false);
	    return this.finishNode(node, "DeclareInterface");
	  }
	  flowParseInterfaceish(node, isClass) {
	    node.id = this.flowParseRestrictedIdentifier(!isClass, true);
	    this.scope.declareName(node.id.name, isClass ? 17 : 8201, node.id.loc.start);
	    if (this.match(47)) {
	      node.typeParameters = this.flowParseTypeParameterDeclaration();
	    } else {
	      node.typeParameters = null;
	    }
	    node.extends = [];
	    if (this.eat(81)) {
	      do {
	        node.extends.push(this.flowParseInterfaceExtends());
	      } while (!isClass && this.eat(12));
	    }
	    if (isClass) {
	      node.implements = [];
	      node.mixins = [];
	      if (this.eatContextual(117)) {
	        do {
	          node.mixins.push(this.flowParseInterfaceExtends());
	        } while (this.eat(12));
	      }
	      if (this.eatContextual(113)) {
	        do {
	          node.implements.push(this.flowParseInterfaceExtends());
	        } while (this.eat(12));
	      }
	    }
	    node.body = this.flowParseObjectType({
	      allowStatic: isClass,
	      allowExact: false,
	      allowSpread: false,
	      allowProto: isClass,
	      allowInexact: false
	    });
	  }
	  flowParseInterfaceExtends() {
	    const node = this.startNode();
	    node.id = this.flowParseQualifiedTypeIdentifier();
	    if (this.match(47)) {
	      node.typeParameters = this.flowParseTypeParameterInstantiation();
	    } else {
	      node.typeParameters = null;
	    }
	    return this.finishNode(node, "InterfaceExtends");
	  }
	  flowParseInterface(node) {
	    this.flowParseInterfaceish(node, false);
	    return this.finishNode(node, "InterfaceDeclaration");
	  }
	  checkNotUnderscore(word) {
	    if (word === "_") {
	      this.raise(FlowErrors.UnexpectedReservedUnderscore, this.state.startLoc);
	    }
	  }
	  checkReservedType(word, startLoc, declaration) {
	    if (!reservedTypes.has(word)) return;
	    this.raise(declaration ? FlowErrors.AssignReservedType : FlowErrors.UnexpectedReservedType, startLoc, {
	      reservedType: word
	    });
	  }
	  flowParseRestrictedIdentifier(liberal, declaration) {
	    this.checkReservedType(this.state.value, this.state.startLoc, declaration);
	    return this.parseIdentifier(liberal);
	  }
	  flowParseTypeAlias(node) {
	    node.id = this.flowParseRestrictedIdentifier(false, true);
	    this.scope.declareName(node.id.name, 8201, node.id.loc.start);
	    if (this.match(47)) {
	      node.typeParameters = this.flowParseTypeParameterDeclaration();
	    } else {
	      node.typeParameters = null;
	    }
	    node.right = this.flowParseTypeInitialiser(29);
	    this.semicolon();
	    return this.finishNode(node, "TypeAlias");
	  }
	  flowParseOpaqueType(node, declare) {
	    this.expectContextual(130);
	    node.id = this.flowParseRestrictedIdentifier(true, true);
	    this.scope.declareName(node.id.name, 8201, node.id.loc.start);
	    if (this.match(47)) {
	      node.typeParameters = this.flowParseTypeParameterDeclaration();
	    } else {
	      node.typeParameters = null;
	    }
	    node.supertype = null;
	    if (this.match(14)) {
	      node.supertype = this.flowParseTypeInitialiser(14);
	    }
	    node.impltype = null;
	    if (!declare) {
	      node.impltype = this.flowParseTypeInitialiser(29);
	    }
	    this.semicolon();
	    return this.finishNode(node, "OpaqueType");
	  }
	  flowParseTypeParameter(requireDefault = false) {
	    const nodeStartLoc = this.state.startLoc;
	    const node = this.startNode();
	    const variance = this.flowParseVariance();
	    const ident = this.flowParseTypeAnnotatableIdentifier();
	    node.name = ident.name;
	    node.variance = variance;
	    node.bound = ident.typeAnnotation;
	    if (this.match(29)) {
	      this.eat(29);
	      node.default = this.flowParseType();
	    } else {
	      if (requireDefault) {
	        this.raise(FlowErrors.MissingTypeParamDefault, nodeStartLoc);
	      }
	    }
	    return this.finishNode(node, "TypeParameter");
	  }
	  flowParseTypeParameterDeclaration() {
	    const oldInType = this.state.inType;
	    const node = this.startNode();
	    node.params = [];
	    this.state.inType = true;
	    if (this.match(47) || this.match(142)) {
	      this.next();
	    } else {
	      this.unexpected();
	    }
	    let defaultRequired = false;
	    do {
	      const typeParameter = this.flowParseTypeParameter(defaultRequired);
	      node.params.push(typeParameter);
	      if (typeParameter.default) {
	        defaultRequired = true;
	      }
	      if (!this.match(48)) {
	        this.expect(12);
	      }
	    } while (!this.match(48));
	    this.expect(48);
	    this.state.inType = oldInType;
	    return this.finishNode(node, "TypeParameterDeclaration");
	  }
	  flowParseTypeParameterInstantiation() {
	    const node = this.startNode();
	    const oldInType = this.state.inType;
	    node.params = [];
	    this.state.inType = true;
	    this.expect(47);
	    const oldNoAnonFunctionType = this.state.noAnonFunctionType;
	    this.state.noAnonFunctionType = false;
	    while (!this.match(48)) {
	      node.params.push(this.flowParseType());
	      if (!this.match(48)) {
	        this.expect(12);
	      }
	    }
	    this.state.noAnonFunctionType = oldNoAnonFunctionType;
	    this.expect(48);
	    this.state.inType = oldInType;
	    return this.finishNode(node, "TypeParameterInstantiation");
	  }
	  flowParseTypeParameterInstantiationCallOrNew() {
	    const node = this.startNode();
	    const oldInType = this.state.inType;
	    node.params = [];
	    this.state.inType = true;
	    this.expect(47);
	    while (!this.match(48)) {
	      node.params.push(this.flowParseTypeOrImplicitInstantiation());
	      if (!this.match(48)) {
	        this.expect(12);
	      }
	    }
	    this.expect(48);
	    this.state.inType = oldInType;
	    return this.finishNode(node, "TypeParameterInstantiation");
	  }
	  flowParseInterfaceType() {
	    const node = this.startNode();
	    this.expectContextual(129);
	    node.extends = [];
	    if (this.eat(81)) {
	      do {
	        node.extends.push(this.flowParseInterfaceExtends());
	      } while (this.eat(12));
	    }
	    node.body = this.flowParseObjectType({
	      allowStatic: false,
	      allowExact: false,
	      allowSpread: false,
	      allowProto: false,
	      allowInexact: false
	    });
	    return this.finishNode(node, "InterfaceTypeAnnotation");
	  }
	  flowParseObjectPropertyKey() {
	    return this.match(134) || this.match(133) ? super.parseExprAtom() : this.parseIdentifier(true);
	  }
	  flowParseObjectTypeIndexer(node, isStatic, variance) {
	    node.static = isStatic;
	    if (this.lookahead().type === 14) {
	      node.id = this.flowParseObjectPropertyKey();
	      node.key = this.flowParseTypeInitialiser();
	    } else {
	      node.id = null;
	      node.key = this.flowParseType();
	    }
	    this.expect(3);
	    node.value = this.flowParseTypeInitialiser();
	    node.variance = variance;
	    return this.finishNode(node, "ObjectTypeIndexer");
	  }
	  flowParseObjectTypeInternalSlot(node, isStatic) {
	    node.static = isStatic;
	    node.id = this.flowParseObjectPropertyKey();
	    this.expect(3);
	    this.expect(3);
	    if (this.match(47) || this.match(10)) {
	      node.method = true;
	      node.optional = false;
	      node.value = this.flowParseObjectTypeMethodish(this.startNodeAt(node.loc.start));
	    } else {
	      node.method = false;
	      if (this.eat(17)) {
	        node.optional = true;
	      }
	      node.value = this.flowParseTypeInitialiser();
	    }
	    return this.finishNode(node, "ObjectTypeInternalSlot");
	  }
	  flowParseObjectTypeMethodish(node) {
	    node.params = [];
	    node.rest = null;
	    node.typeParameters = null;
	    node.this = null;
	    if (this.match(47)) {
	      node.typeParameters = this.flowParseTypeParameterDeclaration();
	    }
	    this.expect(10);
	    if (this.match(78)) {
	      node.this = this.flowParseFunctionTypeParam(true);
	      node.this.name = null;
	      if (!this.match(11)) {
	        this.expect(12);
	      }
	    }
	    while (!this.match(11) && !this.match(21)) {
	      node.params.push(this.flowParseFunctionTypeParam(false));
	      if (!this.match(11)) {
	        this.expect(12);
	      }
	    }
	    if (this.eat(21)) {
	      node.rest = this.flowParseFunctionTypeParam(false);
	    }
	    this.expect(11);
	    node.returnType = this.flowParseTypeInitialiser();
	    return this.finishNode(node, "FunctionTypeAnnotation");
	  }
	  flowParseObjectTypeCallProperty(node, isStatic) {
	    const valueNode = this.startNode();
	    node.static = isStatic;
	    node.value = this.flowParseObjectTypeMethodish(valueNode);
	    return this.finishNode(node, "ObjectTypeCallProperty");
	  }
	  flowParseObjectType({
	    allowStatic,
	    allowExact,
	    allowSpread,
	    allowProto,
	    allowInexact
	  }) {
	    const oldInType = this.state.inType;
	    this.state.inType = true;
	    const nodeStart = this.startNode();
	    nodeStart.callProperties = [];
	    nodeStart.properties = [];
	    nodeStart.indexers = [];
	    nodeStart.internalSlots = [];
	    let endDelim;
	    let exact;
	    let inexact = false;
	    if (allowExact && this.match(6)) {
	      this.expect(6);
	      endDelim = 9;
	      exact = true;
	    } else {
	      this.expect(5);
	      endDelim = 8;
	      exact = false;
	    }
	    nodeStart.exact = exact;
	    while (!this.match(endDelim)) {
	      let isStatic = false;
	      let protoStartLoc = null;
	      let inexactStartLoc = null;
	      const node = this.startNode();
	      if (allowProto && this.isContextual(118)) {
	        const lookahead = this.lookahead();
	        if (lookahead.type !== 14 && lookahead.type !== 17) {
	          this.next();
	          protoStartLoc = this.state.startLoc;
	          allowStatic = false;
	        }
	      }
	      if (allowStatic && this.isContextual(106)) {
	        const lookahead = this.lookahead();
	        if (lookahead.type !== 14 && lookahead.type !== 17) {
	          this.next();
	          isStatic = true;
	        }
	      }
	      const variance = this.flowParseVariance();
	      if (this.eat(0)) {
	        if (protoStartLoc != null) {
	          this.unexpected(protoStartLoc);
	        }
	        if (this.eat(0)) {
	          if (variance) {
	            this.unexpected(variance.loc.start);
	          }
	          nodeStart.internalSlots.push(this.flowParseObjectTypeInternalSlot(node, isStatic));
	        } else {
	          nodeStart.indexers.push(this.flowParseObjectTypeIndexer(node, isStatic, variance));
	        }
	      } else if (this.match(10) || this.match(47)) {
	        if (protoStartLoc != null) {
	          this.unexpected(protoStartLoc);
	        }
	        if (variance) {
	          this.unexpected(variance.loc.start);
	        }
	        nodeStart.callProperties.push(this.flowParseObjectTypeCallProperty(node, isStatic));
	      } else {
	        let kind = "init";
	        if (this.isContextual(99) || this.isContextual(104)) {
	          const lookahead = this.lookahead();
	          if (tokenIsLiteralPropertyName(lookahead.type)) {
	            kind = this.state.value;
	            this.next();
	          }
	        }
	        const propOrInexact = this.flowParseObjectTypeProperty(node, isStatic, protoStartLoc, variance, kind, allowSpread, allowInexact != null ? allowInexact : !exact);
	        if (propOrInexact === null) {
	          inexact = true;
	          inexactStartLoc = this.state.lastTokStartLoc;
	        } else {
	          nodeStart.properties.push(propOrInexact);
	        }
	      }
	      this.flowObjectTypeSemicolon();
	      if (inexactStartLoc && !this.match(8) && !this.match(9)) {
	        this.raise(FlowErrors.UnexpectedExplicitInexactInObject, inexactStartLoc);
	      }
	    }
	    this.expect(endDelim);
	    if (allowSpread) {
	      nodeStart.inexact = inexact;
	    }
	    const out = this.finishNode(nodeStart, "ObjectTypeAnnotation");
	    this.state.inType = oldInType;
	    return out;
	  }
	  flowParseObjectTypeProperty(node, isStatic, protoStartLoc, variance, kind, allowSpread, allowInexact) {
	    if (this.eat(21)) {
	      const isInexactToken = this.match(12) || this.match(13) || this.match(8) || this.match(9);
	      if (isInexactToken) {
	        if (!allowSpread) {
	          this.raise(FlowErrors.InexactInsideNonObject, this.state.lastTokStartLoc);
	        } else if (!allowInexact) {
	          this.raise(FlowErrors.InexactInsideExact, this.state.lastTokStartLoc);
	        }
	        if (variance) {
	          this.raise(FlowErrors.InexactVariance, variance);
	        }
	        return null;
	      }
	      if (!allowSpread) {
	        this.raise(FlowErrors.UnexpectedSpreadType, this.state.lastTokStartLoc);
	      }
	      if (protoStartLoc != null) {
	        this.unexpected(protoStartLoc);
	      }
	      if (variance) {
	        this.raise(FlowErrors.SpreadVariance, variance);
	      }
	      node.argument = this.flowParseType();
	      return this.finishNode(node, "ObjectTypeSpreadProperty");
	    } else {
	      node.key = this.flowParseObjectPropertyKey();
	      node.static = isStatic;
	      node.proto = protoStartLoc != null;
	      node.kind = kind;
	      let optional = false;
	      if (this.match(47) || this.match(10)) {
	        node.method = true;
	        if (protoStartLoc != null) {
	          this.unexpected(protoStartLoc);
	        }
	        if (variance) {
	          this.unexpected(variance.loc.start);
	        }
	        node.value = this.flowParseObjectTypeMethodish(this.startNodeAt(node.loc.start));
	        if (kind === "get" || kind === "set") {
	          this.flowCheckGetterSetterParams(node);
	        }
	        if (!allowSpread && node.key.name === "constructor" && node.value.this) {
	          this.raise(FlowErrors.ThisParamBannedInConstructor, node.value.this);
	        }
	      } else {
	        if (kind !== "init") this.unexpected();
	        node.method = false;
	        if (this.eat(17)) {
	          optional = true;
	        }
	        node.value = this.flowParseTypeInitialiser();
	        node.variance = variance;
	      }
	      node.optional = optional;
	      return this.finishNode(node, "ObjectTypeProperty");
	    }
	  }
	  flowCheckGetterSetterParams(property) {
	    const paramCount = property.kind === "get" ? 0 : 1;
	    const length = property.value.params.length + (property.value.rest ? 1 : 0);
	    if (property.value.this) {
	      this.raise(property.kind === "get" ? FlowErrors.GetterMayNotHaveThisParam : FlowErrors.SetterMayNotHaveThisParam, property.value.this);
	    }
	    if (length !== paramCount) {
	      this.raise(property.kind === "get" ? Errors.BadGetterArity : Errors.BadSetterArity, property);
	    }
	    if (property.kind === "set" && property.value.rest) {
	      this.raise(Errors.BadSetterRestParameter, property);
	    }
	  }
	  flowObjectTypeSemicolon() {
	    if (!this.eat(13) && !this.eat(12) && !this.match(8) && !this.match(9)) {
	      this.unexpected();
	    }
	  }
	  flowParseQualifiedTypeIdentifier(startLoc, id) {
	    var _startLoc;
	    (_startLoc = startLoc) != null ? _startLoc : startLoc = this.state.startLoc;
	    let node = id || this.flowParseRestrictedIdentifier(true);
	    while (this.eat(16)) {
	      const node2 = this.startNodeAt(startLoc);
	      node2.qualification = node;
	      node2.id = this.flowParseRestrictedIdentifier(true);
	      node = this.finishNode(node2, "QualifiedTypeIdentifier");
	    }
	    return node;
	  }
	  flowParseGenericType(startLoc, id) {
	    const node = this.startNodeAt(startLoc);
	    node.typeParameters = null;
	    node.id = this.flowParseQualifiedTypeIdentifier(startLoc, id);
	    if (this.match(47)) {
	      node.typeParameters = this.flowParseTypeParameterInstantiation();
	    }
	    return this.finishNode(node, "GenericTypeAnnotation");
	  }
	  flowParseTypeofType() {
	    const node = this.startNode();
	    this.expect(87);
	    node.argument = this.flowParsePrimaryType();
	    return this.finishNode(node, "TypeofTypeAnnotation");
	  }
	  flowParseTupleType() {
	    const node = this.startNode();
	    node.types = [];
	    this.expect(0);
	    while (this.state.pos < this.length && !this.match(3)) {
	      node.types.push(this.flowParseType());
	      if (this.match(3)) break;
	      this.expect(12);
	    }
	    this.expect(3);
	    return this.finishNode(node, "TupleTypeAnnotation");
	  }
	  flowParseFunctionTypeParam(first) {
	    let name = null;
	    let optional = false;
	    let typeAnnotation = null;
	    const node = this.startNode();
	    const lh = this.lookahead();
	    const isThis = this.state.type === 78;
	    if (lh.type === 14 || lh.type === 17) {
	      if (isThis && !first) {
	        this.raise(FlowErrors.ThisParamMustBeFirst, node);
	      }
	      name = this.parseIdentifier(isThis);
	      if (this.eat(17)) {
	        optional = true;
	        if (isThis) {
	          this.raise(FlowErrors.ThisParamMayNotBeOptional, node);
	        }
	      }
	      typeAnnotation = this.flowParseTypeInitialiser();
	    } else {
	      typeAnnotation = this.flowParseType();
	    }
	    node.name = name;
	    node.optional = optional;
	    node.typeAnnotation = typeAnnotation;
	    return this.finishNode(node, "FunctionTypeParam");
	  }
	  reinterpretTypeAsFunctionTypeParam(type) {
	    const node = this.startNodeAt(type.loc.start);
	    node.name = null;
	    node.optional = false;
	    node.typeAnnotation = type;
	    return this.finishNode(node, "FunctionTypeParam");
	  }
	  flowParseFunctionTypeParams(params = []) {
	    let rest = null;
	    let _this = null;
	    if (this.match(78)) {
	      _this = this.flowParseFunctionTypeParam(true);
	      _this.name = null;
	      if (!this.match(11)) {
	        this.expect(12);
	      }
	    }
	    while (!this.match(11) && !this.match(21)) {
	      params.push(this.flowParseFunctionTypeParam(false));
	      if (!this.match(11)) {
	        this.expect(12);
	      }
	    }
	    if (this.eat(21)) {
	      rest = this.flowParseFunctionTypeParam(false);
	    }
	    return {
	      params,
	      rest,
	      _this
	    };
	  }
	  flowIdentToTypeAnnotation(startLoc, node, id) {
	    switch (id.name) {
	      case "any":
	        return this.finishNode(node, "AnyTypeAnnotation");
	      case "bool":
	      case "boolean":
	        return this.finishNode(node, "BooleanTypeAnnotation");
	      case "mixed":
	        return this.finishNode(node, "MixedTypeAnnotation");
	      case "empty":
	        return this.finishNode(node, "EmptyTypeAnnotation");
	      case "number":
	        return this.finishNode(node, "NumberTypeAnnotation");
	      case "string":
	        return this.finishNode(node, "StringTypeAnnotation");
	      case "symbol":
	        return this.finishNode(node, "SymbolTypeAnnotation");
	      default:
	        this.checkNotUnderscore(id.name);
	        return this.flowParseGenericType(startLoc, id);
	    }
	  }
	  flowParsePrimaryType() {
	    const startLoc = this.state.startLoc;
	    const node = this.startNode();
	    let tmp;
	    let type;
	    let isGroupedType = false;
	    const oldNoAnonFunctionType = this.state.noAnonFunctionType;
	    switch (this.state.type) {
	      case 5:
	        return this.flowParseObjectType({
	          allowStatic: false,
	          allowExact: false,
	          allowSpread: true,
	          allowProto: false,
	          allowInexact: true
	        });
	      case 6:
	        return this.flowParseObjectType({
	          allowStatic: false,
	          allowExact: true,
	          allowSpread: true,
	          allowProto: false,
	          allowInexact: false
	        });
	      case 0:
	        this.state.noAnonFunctionType = false;
	        type = this.flowParseTupleType();
	        this.state.noAnonFunctionType = oldNoAnonFunctionType;
	        return type;
	      case 47:
	        {
	          const node = this.startNode();
	          node.typeParameters = this.flowParseTypeParameterDeclaration();
	          this.expect(10);
	          tmp = this.flowParseFunctionTypeParams();
	          node.params = tmp.params;
	          node.rest = tmp.rest;
	          node.this = tmp._this;
	          this.expect(11);
	          this.expect(19);
	          node.returnType = this.flowParseType();
	          return this.finishNode(node, "FunctionTypeAnnotation");
	        }
	      case 10:
	        {
	          const node = this.startNode();
	          this.next();
	          if (!this.match(11) && !this.match(21)) {
	            if (tokenIsIdentifier(this.state.type) || this.match(78)) {
	              const token = this.lookahead().type;
	              isGroupedType = token !== 17 && token !== 14;
	            } else {
	              isGroupedType = true;
	            }
	          }
	          if (isGroupedType) {
	            this.state.noAnonFunctionType = false;
	            type = this.flowParseType();
	            this.state.noAnonFunctionType = oldNoAnonFunctionType;
	            if (this.state.noAnonFunctionType || !(this.match(12) || this.match(11) && this.lookahead().type === 19)) {
	              this.expect(11);
	              return type;
	            } else {
	              this.eat(12);
	            }
	          }
	          if (type) {
	            tmp = this.flowParseFunctionTypeParams([this.reinterpretTypeAsFunctionTypeParam(type)]);
	          } else {
	            tmp = this.flowParseFunctionTypeParams();
	          }
	          node.params = tmp.params;
	          node.rest = tmp.rest;
	          node.this = tmp._this;
	          this.expect(11);
	          this.expect(19);
	          node.returnType = this.flowParseType();
	          node.typeParameters = null;
	          return this.finishNode(node, "FunctionTypeAnnotation");
	        }
	      case 133:
	        return this.parseLiteral(this.state.value, "StringLiteralTypeAnnotation");
	      case 85:
	      case 86:
	        node.value = this.match(85);
	        this.next();
	        return this.finishNode(node, "BooleanLiteralTypeAnnotation");
	      case 53:
	        if (this.state.value === "-") {
	          this.next();
	          if (this.match(134)) {
	            return this.parseLiteralAtNode(-this.state.value, "NumberLiteralTypeAnnotation", node);
	          }
	          if (this.match(135)) {
	            return this.parseLiteralAtNode(-this.state.value, "BigIntLiteralTypeAnnotation", node);
	          }
	          throw this.raise(FlowErrors.UnexpectedSubtractionOperand, this.state.startLoc);
	        }
	        this.unexpected();
	        return;
	      case 134:
	        return this.parseLiteral(this.state.value, "NumberLiteralTypeAnnotation");
	      case 135:
	        return this.parseLiteral(this.state.value, "BigIntLiteralTypeAnnotation");
	      case 88:
	        this.next();
	        return this.finishNode(node, "VoidTypeAnnotation");
	      case 84:
	        this.next();
	        return this.finishNode(node, "NullLiteralTypeAnnotation");
	      case 78:
	        this.next();
	        return this.finishNode(node, "ThisTypeAnnotation");
	      case 55:
	        this.next();
	        return this.finishNode(node, "ExistsTypeAnnotation");
	      case 87:
	        return this.flowParseTypeofType();
	      default:
	        if (tokenIsKeyword(this.state.type)) {
	          const label = tokenLabelName(this.state.type);
	          this.next();
	          return super.createIdentifier(node, label);
	        } else if (tokenIsIdentifier(this.state.type)) {
	          if (this.isContextual(129)) {
	            return this.flowParseInterfaceType();
	          }
	          return this.flowIdentToTypeAnnotation(startLoc, node, this.parseIdentifier());
	        }
	    }
	    this.unexpected();
	  }
	  flowParsePostfixType() {
	    const startLoc = this.state.startLoc;
	    let type = this.flowParsePrimaryType();
	    let seenOptionalIndexedAccess = false;
	    while ((this.match(0) || this.match(18)) && !this.canInsertSemicolon()) {
	      const node = this.startNodeAt(startLoc);
	      const optional = this.eat(18);
	      seenOptionalIndexedAccess = seenOptionalIndexedAccess || optional;
	      this.expect(0);
	      if (!optional && this.match(3)) {
	        node.elementType = type;
	        this.next();
	        type = this.finishNode(node, "ArrayTypeAnnotation");
	      } else {
	        node.objectType = type;
	        node.indexType = this.flowParseType();
	        this.expect(3);
	        if (seenOptionalIndexedAccess) {
	          node.optional = optional;
	          type = this.finishNode(node, "OptionalIndexedAccessType");
	        } else {
	          type = this.finishNode(node, "IndexedAccessType");
	        }
	      }
	    }
	    return type;
	  }
	  flowParsePrefixType() {
	    const node = this.startNode();
	    if (this.eat(17)) {
	      node.typeAnnotation = this.flowParsePrefixType();
	      return this.finishNode(node, "NullableTypeAnnotation");
	    } else {
	      return this.flowParsePostfixType();
	    }
	  }
	  flowParseAnonFunctionWithoutParens() {
	    const param = this.flowParsePrefixType();
	    if (!this.state.noAnonFunctionType && this.eat(19)) {
	      const node = this.startNodeAt(param.loc.start);
	      node.params = [this.reinterpretTypeAsFunctionTypeParam(param)];
	      node.rest = null;
	      node.this = null;
	      node.returnType = this.flowParseType();
	      node.typeParameters = null;
	      return this.finishNode(node, "FunctionTypeAnnotation");
	    }
	    return param;
	  }
	  flowParseIntersectionType() {
	    const node = this.startNode();
	    this.eat(45);
	    const type = this.flowParseAnonFunctionWithoutParens();
	    node.types = [type];
	    while (this.eat(45)) {
	      node.types.push(this.flowParseAnonFunctionWithoutParens());
	    }
	    return node.types.length === 1 ? type : this.finishNode(node, "IntersectionTypeAnnotation");
	  }
	  flowParseUnionType() {
	    const node = this.startNode();
	    this.eat(43);
	    const type = this.flowParseIntersectionType();
	    node.types = [type];
	    while (this.eat(43)) {
	      node.types.push(this.flowParseIntersectionType());
	    }
	    return node.types.length === 1 ? type : this.finishNode(node, "UnionTypeAnnotation");
	  }
	  flowParseType() {
	    const oldInType = this.state.inType;
	    this.state.inType = true;
	    const type = this.flowParseUnionType();
	    this.state.inType = oldInType;
	    return type;
	  }
	  flowParseTypeOrImplicitInstantiation() {
	    if (this.state.type === 132 && this.state.value === "_") {
	      const startLoc = this.state.startLoc;
	      const node = this.parseIdentifier();
	      return this.flowParseGenericType(startLoc, node);
	    } else {
	      return this.flowParseType();
	    }
	  }
	  flowParseTypeAnnotation() {
	    const node = this.startNode();
	    node.typeAnnotation = this.flowParseTypeInitialiser();
	    return this.finishNode(node, "TypeAnnotation");
	  }
	  flowParseTypeAnnotatableIdentifier(allowPrimitiveOverride) {
	    const ident = allowPrimitiveOverride ? this.parseIdentifier() : this.flowParseRestrictedIdentifier();
	    if (this.match(14)) {
	      ident.typeAnnotation = this.flowParseTypeAnnotation();
	      this.resetEndLocation(ident);
	    }
	    return ident;
	  }
	  typeCastToParameter(node) {
	    node.expression.typeAnnotation = node.typeAnnotation;
	    this.resetEndLocation(node.expression, node.typeAnnotation.loc.end);
	    return node.expression;
	  }
	  flowParseVariance() {
	    let variance = null;
	    if (this.match(53)) {
	      variance = this.startNode();
	      if (this.state.value === "+") {
	        variance.kind = "plus";
	      } else {
	        variance.kind = "minus";
	      }
	      this.next();
	      return this.finishNode(variance, "Variance");
	    }
	    return variance;
	  }
	  parseFunctionBody(node, allowExpressionBody, isMethod = false) {
	    if (allowExpressionBody) {
	      this.forwardNoArrowParamsConversionAt(node, () => super.parseFunctionBody(node, true, isMethod));
	      return;
	    }
	    super.parseFunctionBody(node, false, isMethod);
	  }
	  parseFunctionBodyAndFinish(node, type, isMethod = false) {
	    if (this.match(14)) {
	      const typeNode = this.startNode();
	      [typeNode.typeAnnotation, node.predicate] = this.flowParseTypeAndPredicateInitialiser();
	      node.returnType = typeNode.typeAnnotation ? this.finishNode(typeNode, "TypeAnnotation") : null;
	    }
	    return super.parseFunctionBodyAndFinish(node, type, isMethod);
	  }
	  parseStatementLike(flags) {
	    if (this.state.strict && this.isContextual(129)) {
	      const lookahead = this.lookahead();
	      if (tokenIsKeywordOrIdentifier(lookahead.type)) {
	        const node = this.startNode();
	        this.next();
	        return this.flowParseInterface(node);
	      }
	    } else if (this.shouldParseEnums() && this.isContextual(126)) {
	      const node = this.startNode();
	      this.next();
	      return this.flowParseEnumDeclaration(node);
	    }
	    const stmt = super.parseStatementLike(flags);
	    if (this.flowPragma === undefined && !this.isValidDirective(stmt)) {
	      this.flowPragma = null;
	    }
	    return stmt;
	  }
	  parseExpressionStatement(node, expr, decorators) {
	    if (expr.type === "Identifier") {
	      if (expr.name === "declare") {
	        if (this.match(80) || tokenIsIdentifier(this.state.type) || this.match(68) || this.match(74) || this.match(82)) {
	          return this.flowParseDeclare(node);
	        }
	      } else if (tokenIsIdentifier(this.state.type)) {
	        if (expr.name === "interface") {
	          return this.flowParseInterface(node);
	        } else if (expr.name === "type") {
	          return this.flowParseTypeAlias(node);
	        } else if (expr.name === "opaque") {
	          return this.flowParseOpaqueType(node, false);
	        }
	      }
	    }
	    return super.parseExpressionStatement(node, expr, decorators);
	  }
	  shouldParseExportDeclaration() {
	    const {
	      type
	    } = this.state;
	    if (tokenIsFlowInterfaceOrTypeOrOpaque(type) || this.shouldParseEnums() && type === 126) {
	      return !this.state.containsEsc;
	    }
	    return super.shouldParseExportDeclaration();
	  }
	  isExportDefaultSpecifier() {
	    const {
	      type
	    } = this.state;
	    if (tokenIsFlowInterfaceOrTypeOrOpaque(type) || this.shouldParseEnums() && type === 126) {
	      return this.state.containsEsc;
	    }
	    return super.isExportDefaultSpecifier();
	  }
	  parseExportDefaultExpression() {
	    if (this.shouldParseEnums() && this.isContextual(126)) {
	      const node = this.startNode();
	      this.next();
	      return this.flowParseEnumDeclaration(node);
	    }
	    return super.parseExportDefaultExpression();
	  }
	  parseConditional(expr, startLoc, refExpressionErrors) {
	    if (!this.match(17)) return expr;
	    if (this.state.maybeInArrowParameters) {
	      const nextCh = this.lookaheadCharCode();
	      if (nextCh === 44 || nextCh === 61 || nextCh === 58 || nextCh === 41) {
	        this.setOptionalParametersError(refExpressionErrors);
	        return expr;
	      }
	    }
	    this.expect(17);
	    const state = this.state.clone();
	    const originalNoArrowAt = this.state.noArrowAt;
	    const node = this.startNodeAt(startLoc);
	    let {
	      consequent,
	      failed
	    } = this.tryParseConditionalConsequent();
	    let [valid, invalid] = this.getArrowLikeExpressions(consequent);
	    if (failed || invalid.length > 0) {
	      const noArrowAt = [...originalNoArrowAt];
	      if (invalid.length > 0) {
	        this.state = state;
	        this.state.noArrowAt = noArrowAt;
	        for (let i = 0; i < invalid.length; i++) {
	          noArrowAt.push(invalid[i].start);
	        }
	        ({
	          consequent,
	          failed
	        } = this.tryParseConditionalConsequent());
	        [valid, invalid] = this.getArrowLikeExpressions(consequent);
	      }
	      if (failed && valid.length > 1) {
	        this.raise(FlowErrors.AmbiguousConditionalArrow, state.startLoc);
	      }
	      if (failed && valid.length === 1) {
	        this.state = state;
	        noArrowAt.push(valid[0].start);
	        this.state.noArrowAt = noArrowAt;
	        ({
	          consequent,
	          failed
	        } = this.tryParseConditionalConsequent());
	      }
	    }
	    this.getArrowLikeExpressions(consequent, true);
	    this.state.noArrowAt = originalNoArrowAt;
	    this.expect(14);
	    node.test = expr;
	    node.consequent = consequent;
	    node.alternate = this.forwardNoArrowParamsConversionAt(node, () => this.parseMaybeAssign(undefined, undefined));
	    return this.finishNode(node, "ConditionalExpression");
	  }
	  tryParseConditionalConsequent() {
	    this.state.noArrowParamsConversionAt.push(this.state.start);
	    const consequent = this.parseMaybeAssignAllowIn();
	    const failed = !this.match(14);
	    this.state.noArrowParamsConversionAt.pop();
	    return {
	      consequent,
	      failed
	    };
	  }
	  getArrowLikeExpressions(node, disallowInvalid) {
	    const stack = [node];
	    const arrows = [];
	    while (stack.length !== 0) {
	      const node = stack.pop();
	      if (node.type === "ArrowFunctionExpression" && node.body.type !== "BlockStatement") {
	        if (node.typeParameters || !node.returnType) {
	          this.finishArrowValidation(node);
	        } else {
	          arrows.push(node);
	        }
	        stack.push(node.body);
	      } else if (node.type === "ConditionalExpression") {
	        stack.push(node.consequent);
	        stack.push(node.alternate);
	      }
	    }
	    if (disallowInvalid) {
	      arrows.forEach(node => this.finishArrowValidation(node));
	      return [arrows, []];
	    }
	    return partition(arrows, node => node.params.every(param => this.isAssignable(param, true)));
	  }
	  finishArrowValidation(node) {
	    var _node$extra;
	    this.toAssignableList(node.params, (_node$extra = node.extra) == null ? void 0 : _node$extra.trailingCommaLoc, false);
	    this.scope.enter(2 | 4);
	    super.checkParams(node, false, true);
	    this.scope.exit();
	  }
	  forwardNoArrowParamsConversionAt(node, parse) {
	    let result;
	    if (this.state.noArrowParamsConversionAt.indexOf(node.start) !== -1) {
	      this.state.noArrowParamsConversionAt.push(this.state.start);
	      result = parse();
	      this.state.noArrowParamsConversionAt.pop();
	    } else {
	      result = parse();
	    }
	    return result;
	  }
	  parseParenItem(node, startLoc) {
	    const newNode = super.parseParenItem(node, startLoc);
	    if (this.eat(17)) {
	      newNode.optional = true;
	      this.resetEndLocation(node);
	    }
	    if (this.match(14)) {
	      const typeCastNode = this.startNodeAt(startLoc);
	      typeCastNode.expression = newNode;
	      typeCastNode.typeAnnotation = this.flowParseTypeAnnotation();
	      return this.finishNode(typeCastNode, "TypeCastExpression");
	    }
	    return newNode;
	  }
	  assertModuleNodeAllowed(node) {
	    if (node.type === "ImportDeclaration" && (node.importKind === "type" || node.importKind === "typeof") || node.type === "ExportNamedDeclaration" && node.exportKind === "type" || node.type === "ExportAllDeclaration" && node.exportKind === "type") {
	      return;
	    }
	    super.assertModuleNodeAllowed(node);
	  }
	  parseExportDeclaration(node) {
	    if (this.isContextual(130)) {
	      node.exportKind = "type";
	      const declarationNode = this.startNode();
	      this.next();
	      if (this.match(5)) {
	        node.specifiers = this.parseExportSpecifiers(true);
	        super.parseExportFrom(node);
	        return null;
	      } else {
	        return this.flowParseTypeAlias(declarationNode);
	      }
	    } else if (this.isContextual(131)) {
	      node.exportKind = "type";
	      const declarationNode = this.startNode();
	      this.next();
	      return this.flowParseOpaqueType(declarationNode, false);
	    } else if (this.isContextual(129)) {
	      node.exportKind = "type";
	      const declarationNode = this.startNode();
	      this.next();
	      return this.flowParseInterface(declarationNode);
	    } else if (this.shouldParseEnums() && this.isContextual(126)) {
	      node.exportKind = "value";
	      const declarationNode = this.startNode();
	      this.next();
	      return this.flowParseEnumDeclaration(declarationNode);
	    } else {
	      return super.parseExportDeclaration(node);
	    }
	  }
	  eatExportStar(node) {
	    if (super.eatExportStar(node)) return true;
	    if (this.isContextual(130) && this.lookahead().type === 55) {
	      node.exportKind = "type";
	      this.next();
	      this.next();
	      return true;
	    }
	    return false;
	  }
	  maybeParseExportNamespaceSpecifier(node) {
	    const {
	      startLoc
	    } = this.state;
	    const hasNamespace = super.maybeParseExportNamespaceSpecifier(node);
	    if (hasNamespace && node.exportKind === "type") {
	      this.unexpected(startLoc);
	    }
	    return hasNamespace;
	  }
	  parseClassId(node, isStatement, optionalId) {
	    super.parseClassId(node, isStatement, optionalId);
	    if (this.match(47)) {
	      node.typeParameters = this.flowParseTypeParameterDeclaration();
	    }
	  }
	  parseClassMember(classBody, member, state) {
	    const {
	      startLoc
	    } = this.state;
	    if (this.isContextual(125)) {
	      if (super.parseClassMemberFromModifier(classBody, member)) {
	        return;
	      }
	      member.declare = true;
	    }
	    super.parseClassMember(classBody, member, state);
	    if (member.declare) {
	      if (member.type !== "ClassProperty" && member.type !== "ClassPrivateProperty" && member.type !== "PropertyDefinition") {
	        this.raise(FlowErrors.DeclareClassElement, startLoc);
	      } else if (member.value) {
	        this.raise(FlowErrors.DeclareClassFieldInitializer, member.value);
	      }
	    }
	  }
	  isIterator(word) {
	    return word === "iterator" || word === "asyncIterator";
	  }
	  readIterator() {
	    const word = super.readWord1();
	    const fullWord = "@@" + word;
	    if (!this.isIterator(word) || !this.state.inType) {
	      this.raise(Errors.InvalidIdentifier, this.state.curPosition(), {
	        identifierName: fullWord
	      });
	    }
	    this.finishToken(132, fullWord);
	  }
	  getTokenFromCode(code) {
	    const next = this.input.charCodeAt(this.state.pos + 1);
	    if (code === 123 && next === 124) {
	      this.finishOp(6, 2);
	    } else if (this.state.inType && (code === 62 || code === 60)) {
	      this.finishOp(code === 62 ? 48 : 47, 1);
	    } else if (this.state.inType && code === 63) {
	      if (next === 46) {
	        this.finishOp(18, 2);
	      } else {
	        this.finishOp(17, 1);
	      }
	    } else if (isIteratorStart(code, next, this.input.charCodeAt(this.state.pos + 2))) {
	      this.state.pos += 2;
	      this.readIterator();
	    } else {
	      super.getTokenFromCode(code);
	    }
	  }
	  isAssignable(node, isBinding) {
	    if (node.type === "TypeCastExpression") {
	      return this.isAssignable(node.expression, isBinding);
	    } else {
	      return super.isAssignable(node, isBinding);
	    }
	  }
	  toAssignable(node, isLHS = false) {
	    if (!isLHS && node.type === "AssignmentExpression" && node.left.type === "TypeCastExpression") {
	      node.left = this.typeCastToParameter(node.left);
	    }
	    super.toAssignable(node, isLHS);
	  }
	  toAssignableList(exprList, trailingCommaLoc, isLHS) {
	    for (let i = 0; i < exprList.length; i++) {
	      const expr = exprList[i];
	      if ((expr == null ? void 0 : expr.type) === "TypeCastExpression") {
	        exprList[i] = this.typeCastToParameter(expr);
	      }
	    }
	    super.toAssignableList(exprList, trailingCommaLoc, isLHS);
	  }
	  toReferencedList(exprList, isParenthesizedExpr) {
	    for (let i = 0; i < exprList.length; i++) {
	      var _expr$extra;
	      const expr = exprList[i];
	      if (expr && expr.type === "TypeCastExpression" && !((_expr$extra = expr.extra) != null && _expr$extra.parenthesized) && (exprList.length > 1 || !isParenthesizedExpr)) {
	        this.raise(FlowErrors.TypeCastInPattern, expr.typeAnnotation);
	      }
	    }
	    return exprList;
	  }
	  parseArrayLike(close, canBePattern, isTuple, refExpressionErrors) {
	    const node = super.parseArrayLike(close, canBePattern, isTuple, refExpressionErrors);
	    if (canBePattern && !this.state.maybeInArrowParameters) {
	      this.toReferencedList(node.elements);
	    }
	    return node;
	  }
	  isValidLVal(type, isParenthesized, binding) {
	    return type === "TypeCastExpression" || super.isValidLVal(type, isParenthesized, binding);
	  }
	  parseClassProperty(node) {
	    if (this.match(14)) {
	      node.typeAnnotation = this.flowParseTypeAnnotation();
	    }
	    return super.parseClassProperty(node);
	  }
	  parseClassPrivateProperty(node) {
	    if (this.match(14)) {
	      node.typeAnnotation = this.flowParseTypeAnnotation();
	    }
	    return super.parseClassPrivateProperty(node);
	  }
	  isClassMethod() {
	    return this.match(47) || super.isClassMethod();
	  }
	  isClassProperty() {
	    return this.match(14) || super.isClassProperty();
	  }
	  isNonstaticConstructor(method) {
	    return !this.match(14) && super.isNonstaticConstructor(method);
	  }
	  pushClassMethod(classBody, method, isGenerator, isAsync, isConstructor, allowsDirectSuper) {
	    if (method.variance) {
	      this.unexpected(method.variance.loc.start);
	    }
	    delete method.variance;
	    if (this.match(47)) {
	      method.typeParameters = this.flowParseTypeParameterDeclaration();
	    }
	    super.pushClassMethod(classBody, method, isGenerator, isAsync, isConstructor, allowsDirectSuper);
	    if (method.params && isConstructor) {
	      const params = method.params;
	      if (params.length > 0 && this.isThisParam(params[0])) {
	        this.raise(FlowErrors.ThisParamBannedInConstructor, method);
	      }
	    } else if (method.type === "MethodDefinition" && isConstructor && method.value.params) {
	      const params = method.value.params;
	      if (params.length > 0 && this.isThisParam(params[0])) {
	        this.raise(FlowErrors.ThisParamBannedInConstructor, method);
	      }
	    }
	  }
	  pushClassPrivateMethod(classBody, method, isGenerator, isAsync) {
	    if (method.variance) {
	      this.unexpected(method.variance.loc.start);
	    }
	    delete method.variance;
	    if (this.match(47)) {
	      method.typeParameters = this.flowParseTypeParameterDeclaration();
	    }
	    super.pushClassPrivateMethod(classBody, method, isGenerator, isAsync);
	  }
	  parseClassSuper(node) {
	    super.parseClassSuper(node);
	    if (node.superClass && this.match(47)) {
	      node.superTypeParameters = this.flowParseTypeParameterInstantiation();
	    }
	    if (this.isContextual(113)) {
	      this.next();
	      const implemented = node.implements = [];
	      do {
	        const node = this.startNode();
	        node.id = this.flowParseRestrictedIdentifier(true);
	        if (this.match(47)) {
	          node.typeParameters = this.flowParseTypeParameterInstantiation();
	        } else {
	          node.typeParameters = null;
	        }
	        implemented.push(this.finishNode(node, "ClassImplements"));
	      } while (this.eat(12));
	    }
	  }
	  checkGetterSetterParams(method) {
	    super.checkGetterSetterParams(method);
	    const params = this.getObjectOrClassMethodParams(method);
	    if (params.length > 0) {
	      const param = params[0];
	      if (this.isThisParam(param) && method.kind === "get") {
	        this.raise(FlowErrors.GetterMayNotHaveThisParam, param);
	      } else if (this.isThisParam(param)) {
	        this.raise(FlowErrors.SetterMayNotHaveThisParam, param);
	      }
	    }
	  }
	  parsePropertyNamePrefixOperator(node) {
	    node.variance = this.flowParseVariance();
	  }
	  parseObjPropValue(prop, startLoc, isGenerator, isAsync, isPattern, isAccessor, refExpressionErrors) {
	    if (prop.variance) {
	      this.unexpected(prop.variance.loc.start);
	    }
	    delete prop.variance;
	    let typeParameters;
	    if (this.match(47) && !isAccessor) {
	      typeParameters = this.flowParseTypeParameterDeclaration();
	      if (!this.match(10)) this.unexpected();
	    }
	    const result = super.parseObjPropValue(prop, startLoc, isGenerator, isAsync, isPattern, isAccessor, refExpressionErrors);
	    if (typeParameters) {
	      (result.value || result).typeParameters = typeParameters;
	    }
	    return result;
	  }
	  parseAssignableListItemTypes(param) {
	    if (this.eat(17)) {
	      if (param.type !== "Identifier") {
	        this.raise(FlowErrors.PatternIsOptional, param);
	      }
	      if (this.isThisParam(param)) {
	        this.raise(FlowErrors.ThisParamMayNotBeOptional, param);
	      }
	      param.optional = true;
	    }
	    if (this.match(14)) {
	      param.typeAnnotation = this.flowParseTypeAnnotation();
	    } else if (this.isThisParam(param)) {
	      this.raise(FlowErrors.ThisParamAnnotationRequired, param);
	    }
	    if (this.match(29) && this.isThisParam(param)) {
	      this.raise(FlowErrors.ThisParamNoDefault, param);
	    }
	    this.resetEndLocation(param);
	    return param;
	  }
	  parseMaybeDefault(startLoc, left) {
	    const node = super.parseMaybeDefault(startLoc, left);
	    if (node.type === "AssignmentPattern" && node.typeAnnotation && node.right.start < node.typeAnnotation.start) {
	      this.raise(FlowErrors.TypeBeforeInitializer, node.typeAnnotation);
	    }
	    return node;
	  }
	  checkImportReflection(node) {
	    super.checkImportReflection(node);
	    if (node.module && node.importKind !== "value") {
	      this.raise(FlowErrors.ImportReflectionHasImportType, node.specifiers[0].loc.start);
	    }
	  }
	  parseImportSpecifierLocal(node, specifier, type) {
	    specifier.local = hasTypeImportKind(node) ? this.flowParseRestrictedIdentifier(true, true) : this.parseIdentifier();
	    node.specifiers.push(this.finishImportSpecifier(specifier, type));
	  }
	  isPotentialImportPhase(isExport) {
	    if (super.isPotentialImportPhase(isExport)) return true;
	    if (this.isContextual(130)) {
	      if (!isExport) return true;
	      const ch = this.lookaheadCharCode();
	      return ch === 123 || ch === 42;
	    }
	    return !isExport && this.isContextual(87);
	  }
	  applyImportPhase(node, isExport, phase, loc) {
	    super.applyImportPhase(node, isExport, phase, loc);
	    if (isExport) {
	      if (!phase && this.match(65)) {
	        return;
	      }
	      node.exportKind = phase === "type" ? phase : "value";
	    } else {
	      if (phase === "type" && this.match(55)) this.unexpected();
	      node.importKind = phase === "type" || phase === "typeof" ? phase : "value";
	    }
	  }
	  parseImportSpecifier(specifier, importedIsString, isInTypeOnlyImport, isMaybeTypeOnly, bindingType) {
	    const firstIdent = specifier.imported;
	    let specifierTypeKind = null;
	    if (firstIdent.type === "Identifier") {
	      if (firstIdent.name === "type") {
	        specifierTypeKind = "type";
	      } else if (firstIdent.name === "typeof") {
	        specifierTypeKind = "typeof";
	      }
	    }
	    let isBinding = false;
	    if (this.isContextual(93) && !this.isLookaheadContextual("as")) {
	      const as_ident = this.parseIdentifier(true);
	      if (specifierTypeKind !== null && !tokenIsKeywordOrIdentifier(this.state.type)) {
	        specifier.imported = as_ident;
	        specifier.importKind = specifierTypeKind;
	        specifier.local = cloneIdentifier(as_ident);
	      } else {
	        specifier.imported = firstIdent;
	        specifier.importKind = null;
	        specifier.local = this.parseIdentifier();
	      }
	    } else {
	      if (specifierTypeKind !== null && tokenIsKeywordOrIdentifier(this.state.type)) {
	        specifier.imported = this.parseIdentifier(true);
	        specifier.importKind = specifierTypeKind;
	      } else {
	        if (importedIsString) {
	          throw this.raise(Errors.ImportBindingIsString, specifier, {
	            importName: firstIdent.value
	          });
	        }
	        specifier.imported = firstIdent;
	        specifier.importKind = null;
	      }
	      if (this.eatContextual(93)) {
	        specifier.local = this.parseIdentifier();
	      } else {
	        isBinding = true;
	        specifier.local = cloneIdentifier(specifier.imported);
	      }
	    }
	    const specifierIsTypeImport = hasTypeImportKind(specifier);
	    if (isInTypeOnlyImport && specifierIsTypeImport) {
	      this.raise(FlowErrors.ImportTypeShorthandOnlyInPureImport, specifier);
	    }
	    if (isInTypeOnlyImport || specifierIsTypeImport) {
	      this.checkReservedType(specifier.local.name, specifier.local.loc.start, true);
	    }
	    if (isBinding && !isInTypeOnlyImport && !specifierIsTypeImport) {
	      this.checkReservedWord(specifier.local.name, specifier.loc.start, true, true);
	    }
	    return this.finishImportSpecifier(specifier, "ImportSpecifier");
	  }
	  parseBindingAtom() {
	    switch (this.state.type) {
	      case 78:
	        return this.parseIdentifier(true);
	      default:
	        return super.parseBindingAtom();
	    }
	  }
	  parseFunctionParams(node, isConstructor) {
	    const kind = node.kind;
	    if (kind !== "get" && kind !== "set" && this.match(47)) {
	      node.typeParameters = this.flowParseTypeParameterDeclaration();
	    }
	    super.parseFunctionParams(node, isConstructor);
	  }
	  parseVarId(decl, kind) {
	    super.parseVarId(decl, kind);
	    if (this.match(14)) {
	      decl.id.typeAnnotation = this.flowParseTypeAnnotation();
	      this.resetEndLocation(decl.id);
	    }
	  }
	  parseAsyncArrowFromCallExpression(node, call) {
	    if (this.match(14)) {
	      const oldNoAnonFunctionType = this.state.noAnonFunctionType;
	      this.state.noAnonFunctionType = true;
	      node.returnType = this.flowParseTypeAnnotation();
	      this.state.noAnonFunctionType = oldNoAnonFunctionType;
	    }
	    return super.parseAsyncArrowFromCallExpression(node, call);
	  }
	  shouldParseAsyncArrow() {
	    return this.match(14) || super.shouldParseAsyncArrow();
	  }
	  parseMaybeAssign(refExpressionErrors, afterLeftParse) {
	    var _jsx;
	    let state = null;
	    let jsx;
	    if (this.hasPlugin("jsx") && (this.match(142) || this.match(47))) {
	      state = this.state.clone();
	      jsx = this.tryParse(() => super.parseMaybeAssign(refExpressionErrors, afterLeftParse), state);
	      if (!jsx.error) return jsx.node;
	      const {
	        context
	      } = this.state;
	      const currentContext = context[context.length - 1];
	      if (currentContext === types.j_oTag || currentContext === types.j_expr) {
	        context.pop();
	      }
	    }
	    if ((_jsx = jsx) != null && _jsx.error || this.match(47)) {
	      var _jsx2, _jsx3;
	      state = state || this.state.clone();
	      let typeParameters;
	      const arrow = this.tryParse(abort => {
	        var _arrowExpression$extr;
	        typeParameters = this.flowParseTypeParameterDeclaration();
	        const arrowExpression = this.forwardNoArrowParamsConversionAt(typeParameters, () => {
	          const result = super.parseMaybeAssign(refExpressionErrors, afterLeftParse);
	          this.resetStartLocationFromNode(result, typeParameters);
	          return result;
	        });
	        if ((_arrowExpression$extr = arrowExpression.extra) != null && _arrowExpression$extr.parenthesized) abort();
	        const expr = this.maybeUnwrapTypeCastExpression(arrowExpression);
	        if (expr.type !== "ArrowFunctionExpression") abort();
	        expr.typeParameters = typeParameters;
	        this.resetStartLocationFromNode(expr, typeParameters);
	        return arrowExpression;
	      }, state);
	      let arrowExpression = null;
	      if (arrow.node && this.maybeUnwrapTypeCastExpression(arrow.node).type === "ArrowFunctionExpression") {
	        if (!arrow.error && !arrow.aborted) {
	          if (arrow.node.async) {
	            this.raise(FlowErrors.UnexpectedTypeParameterBeforeAsyncArrowFunction, typeParameters);
	          }
	          return arrow.node;
	        }
	        arrowExpression = arrow.node;
	      }
	      if ((_jsx2 = jsx) != null && _jsx2.node) {
	        this.state = jsx.failState;
	        return jsx.node;
	      }
	      if (arrowExpression) {
	        this.state = arrow.failState;
	        return arrowExpression;
	      }
	      if ((_jsx3 = jsx) != null && _jsx3.thrown) throw jsx.error;
	      if (arrow.thrown) throw arrow.error;
	      throw this.raise(FlowErrors.UnexpectedTokenAfterTypeParameter, typeParameters);
	    }
	    return super.parseMaybeAssign(refExpressionErrors, afterLeftParse);
	  }
	  parseArrow(node) {
	    if (this.match(14)) {
	      const result = this.tryParse(() => {
	        const oldNoAnonFunctionType = this.state.noAnonFunctionType;
	        this.state.noAnonFunctionType = true;
	        const typeNode = this.startNode();
	        [typeNode.typeAnnotation, node.predicate] = this.flowParseTypeAndPredicateInitialiser();
	        this.state.noAnonFunctionType = oldNoAnonFunctionType;
	        if (this.canInsertSemicolon()) this.unexpected();
	        if (!this.match(19)) this.unexpected();
	        return typeNode;
	      });
	      if (result.thrown) return null;
	      if (result.error) this.state = result.failState;
	      node.returnType = result.node.typeAnnotation ? this.finishNode(result.node, "TypeAnnotation") : null;
	    }
	    return super.parseArrow(node);
	  }
	  shouldParseArrow(params) {
	    return this.match(14) || super.shouldParseArrow(params);
	  }
	  setArrowFunctionParameters(node, params) {
	    if (this.state.noArrowParamsConversionAt.indexOf(node.start) !== -1) {
	      node.params = params;
	    } else {
	      super.setArrowFunctionParameters(node, params);
	    }
	  }
	  checkParams(node, allowDuplicates, isArrowFunction, strictModeChanged = true) {
	    if (isArrowFunction && this.state.noArrowParamsConversionAt.indexOf(node.start) !== -1) {
	      return;
	    }
	    for (let i = 0; i < node.params.length; i++) {
	      if (this.isThisParam(node.params[i]) && i > 0) {
	        this.raise(FlowErrors.ThisParamMustBeFirst, node.params[i]);
	      }
	    }
	    super.checkParams(node, allowDuplicates, isArrowFunction, strictModeChanged);
	  }
	  parseParenAndDistinguishExpression(canBeArrow) {
	    return super.parseParenAndDistinguishExpression(canBeArrow && this.state.noArrowAt.indexOf(this.state.start) === -1);
	  }
	  parseSubscripts(base, startLoc, noCalls) {
	    if (base.type === "Identifier" && base.name === "async" && this.state.noArrowAt.indexOf(startLoc.index) !== -1) {
	      this.next();
	      const node = this.startNodeAt(startLoc);
	      node.callee = base;
	      node.arguments = super.parseCallExpressionArguments(11, false);
	      base = this.finishNode(node, "CallExpression");
	    } else if (base.type === "Identifier" && base.name === "async" && this.match(47)) {
	      const state = this.state.clone();
	      const arrow = this.tryParse(abort => this.parseAsyncArrowWithTypeParameters(startLoc) || abort(), state);
	      if (!arrow.error && !arrow.aborted) return arrow.node;
	      const result = this.tryParse(() => super.parseSubscripts(base, startLoc, noCalls), state);
	      if (result.node && !result.error) return result.node;
	      if (arrow.node) {
	        this.state = arrow.failState;
	        return arrow.node;
	      }
	      if (result.node) {
	        this.state = result.failState;
	        return result.node;
	      }
	      throw arrow.error || result.error;
	    }
	    return super.parseSubscripts(base, startLoc, noCalls);
	  }
	  parseSubscript(base, startLoc, noCalls, subscriptState) {
	    if (this.match(18) && this.isLookaheadToken_lt()) {
	      subscriptState.optionalChainMember = true;
	      if (noCalls) {
	        subscriptState.stop = true;
	        return base;
	      }
	      this.next();
	      const node = this.startNodeAt(startLoc);
	      node.callee = base;
	      node.typeArguments = this.flowParseTypeParameterInstantiation();
	      this.expect(10);
	      node.arguments = this.parseCallExpressionArguments(11, false);
	      node.optional = true;
	      return this.finishCallExpression(node, true);
	    } else if (!noCalls && this.shouldParseTypes() && this.match(47)) {
	      const node = this.startNodeAt(startLoc);
	      node.callee = base;
	      const result = this.tryParse(() => {
	        node.typeArguments = this.flowParseTypeParameterInstantiationCallOrNew();
	        this.expect(10);
	        node.arguments = super.parseCallExpressionArguments(11, false);
	        if (subscriptState.optionalChainMember) {
	          node.optional = false;
	        }
	        return this.finishCallExpression(node, subscriptState.optionalChainMember);
	      });
	      if (result.node) {
	        if (result.error) this.state = result.failState;
	        return result.node;
	      }
	    }
	    return super.parseSubscript(base, startLoc, noCalls, subscriptState);
	  }
	  parseNewCallee(node) {
	    super.parseNewCallee(node);
	    let targs = null;
	    if (this.shouldParseTypes() && this.match(47)) {
	      targs = this.tryParse(() => this.flowParseTypeParameterInstantiationCallOrNew()).node;
	    }
	    node.typeArguments = targs;
	  }
	  parseAsyncArrowWithTypeParameters(startLoc) {
	    const node = this.startNodeAt(startLoc);
	    this.parseFunctionParams(node, false);
	    if (!this.parseArrow(node)) return;
	    return super.parseArrowExpression(node, undefined, true);
	  }
	  readToken_mult_modulo(code) {
	    const next = this.input.charCodeAt(this.state.pos + 1);
	    if (code === 42 && next === 47 && this.state.hasFlowComment) {
	      this.state.hasFlowComment = false;
	      this.state.pos += 2;
	      this.nextToken();
	      return;
	    }
	    super.readToken_mult_modulo(code);
	  }
	  readToken_pipe_amp(code) {
	    const next = this.input.charCodeAt(this.state.pos + 1);
	    if (code === 124 && next === 125) {
	      this.finishOp(9, 2);
	      return;
	    }
	    super.readToken_pipe_amp(code);
	  }
	  parseTopLevel(file, program) {
	    const fileNode = super.parseTopLevel(file, program);
	    if (this.state.hasFlowComment) {
	      this.raise(FlowErrors.UnterminatedFlowComment, this.state.curPosition());
	    }
	    return fileNode;
	  }
	  skipBlockComment() {
	    if (this.hasPlugin("flowComments") && this.skipFlowComment()) {
	      if (this.state.hasFlowComment) {
	        throw this.raise(FlowErrors.NestedFlowComment, this.state.startLoc);
	      }
	      this.hasFlowCommentCompletion();
	      const commentSkip = this.skipFlowComment();
	      if (commentSkip) {
	        this.state.pos += commentSkip;
	        this.state.hasFlowComment = true;
	      }
	      return;
	    }
	    return super.skipBlockComment(this.state.hasFlowComment ? "*-/" : "*/");
	  }
	  skipFlowComment() {
	    const {
	      pos
	    } = this.state;
	    let shiftToFirstNonWhiteSpace = 2;
	    while ([32, 9].includes(this.input.charCodeAt(pos + shiftToFirstNonWhiteSpace))) {
	      shiftToFirstNonWhiteSpace++;
	    }
	    const ch2 = this.input.charCodeAt(shiftToFirstNonWhiteSpace + pos);
	    const ch3 = this.input.charCodeAt(shiftToFirstNonWhiteSpace + pos + 1);
	    if (ch2 === 58 && ch3 === 58) {
	      return shiftToFirstNonWhiteSpace + 2;
	    }
	    if (this.input.slice(shiftToFirstNonWhiteSpace + pos, shiftToFirstNonWhiteSpace + pos + 12) === "flow-include") {
	      return shiftToFirstNonWhiteSpace + 12;
	    }
	    if (ch2 === 58 && ch3 !== 58) {
	      return shiftToFirstNonWhiteSpace;
	    }
	    return false;
	  }
	  hasFlowCommentCompletion() {
	    const end = this.input.indexOf("*/", this.state.pos);
	    if (end === -1) {
	      throw this.raise(Errors.UnterminatedComment, this.state.curPosition());
	    }
	  }
	  flowEnumErrorBooleanMemberNotInitialized(loc, {
	    enumName,
	    memberName
	  }) {
	    this.raise(FlowErrors.EnumBooleanMemberNotInitialized, loc, {
	      memberName,
	      enumName
	    });
	  }
	  flowEnumErrorInvalidMemberInitializer(loc, enumContext) {
	    return this.raise(!enumContext.explicitType ? FlowErrors.EnumInvalidMemberInitializerUnknownType : enumContext.explicitType === "symbol" ? FlowErrors.EnumInvalidMemberInitializerSymbolType : FlowErrors.EnumInvalidMemberInitializerPrimaryType, loc, enumContext);
	  }
	  flowEnumErrorNumberMemberNotInitialized(loc, details) {
	    this.raise(FlowErrors.EnumNumberMemberNotInitialized, loc, details);
	  }
	  flowEnumErrorStringMemberInconsistentlyInitialized(node, details) {
	    this.raise(FlowErrors.EnumStringMemberInconsistentlyInitialized, node, details);
	  }
	  flowEnumMemberInit() {
	    const startLoc = this.state.startLoc;
	    const endOfInit = () => this.match(12) || this.match(8);
	    switch (this.state.type) {
	      case 134:
	        {
	          const literal = this.parseNumericLiteral(this.state.value);
	          if (endOfInit()) {
	            return {
	              type: "number",
	              loc: literal.loc.start,
	              value: literal
	            };
	          }
	          return {
	            type: "invalid",
	            loc: startLoc
	          };
	        }
	      case 133:
	        {
	          const literal = this.parseStringLiteral(this.state.value);
	          if (endOfInit()) {
	            return {
	              type: "string",
	              loc: literal.loc.start,
	              value: literal
	            };
	          }
	          return {
	            type: "invalid",
	            loc: startLoc
	          };
	        }
	      case 85:
	      case 86:
	        {
	          const literal = this.parseBooleanLiteral(this.match(85));
	          if (endOfInit()) {
	            return {
	              type: "boolean",
	              loc: literal.loc.start,
	              value: literal
	            };
	          }
	          return {
	            type: "invalid",
	            loc: startLoc
	          };
	        }
	      default:
	        return {
	          type: "invalid",
	          loc: startLoc
	        };
	    }
	  }
	  flowEnumMemberRaw() {
	    const loc = this.state.startLoc;
	    const id = this.parseIdentifier(true);
	    const init = this.eat(29) ? this.flowEnumMemberInit() : {
	      type: "none",
	      loc
	    };
	    return {
	      id,
	      init
	    };
	  }
	  flowEnumCheckExplicitTypeMismatch(loc, context, expectedType) {
	    const {
	      explicitType
	    } = context;
	    if (explicitType === null) {
	      return;
	    }
	    if (explicitType !== expectedType) {
	      this.flowEnumErrorInvalidMemberInitializer(loc, context);
	    }
	  }
	  flowEnumMembers({
	    enumName,
	    explicitType
	  }) {
	    const seenNames = new Set();
	    const members = {
	      booleanMembers: [],
	      numberMembers: [],
	      stringMembers: [],
	      defaultedMembers: []
	    };
	    let hasUnknownMembers = false;
	    while (!this.match(8)) {
	      if (this.eat(21)) {
	        hasUnknownMembers = true;
	        break;
	      }
	      const memberNode = this.startNode();
	      const {
	        id,
	        init
	      } = this.flowEnumMemberRaw();
	      const memberName = id.name;
	      if (memberName === "") {
	        continue;
	      }
	      if (/^[a-z]/.test(memberName)) {
	        this.raise(FlowErrors.EnumInvalidMemberName, id, {
	          memberName,
	          suggestion: memberName[0].toUpperCase() + memberName.slice(1),
	          enumName
	        });
	      }
	      if (seenNames.has(memberName)) {
	        this.raise(FlowErrors.EnumDuplicateMemberName, id, {
	          memberName,
	          enumName
	        });
	      }
	      seenNames.add(memberName);
	      const context = {
	        enumName,
	        explicitType,
	        memberName
	      };
	      memberNode.id = id;
	      switch (init.type) {
	        case "boolean":
	          {
	            this.flowEnumCheckExplicitTypeMismatch(init.loc, context, "boolean");
	            memberNode.init = init.value;
	            members.booleanMembers.push(this.finishNode(memberNode, "EnumBooleanMember"));
	            break;
	          }
	        case "number":
	          {
	            this.flowEnumCheckExplicitTypeMismatch(init.loc, context, "number");
	            memberNode.init = init.value;
	            members.numberMembers.push(this.finishNode(memberNode, "EnumNumberMember"));
	            break;
	          }
	        case "string":
	          {
	            this.flowEnumCheckExplicitTypeMismatch(init.loc, context, "string");
	            memberNode.init = init.value;
	            members.stringMembers.push(this.finishNode(memberNode, "EnumStringMember"));
	            break;
	          }
	        case "invalid":
	          {
	            throw this.flowEnumErrorInvalidMemberInitializer(init.loc, context);
	          }
	        case "none":
	          {
	            switch (explicitType) {
	              case "boolean":
	                this.flowEnumErrorBooleanMemberNotInitialized(init.loc, context);
	                break;
	              case "number":
	                this.flowEnumErrorNumberMemberNotInitialized(init.loc, context);
	                break;
	              default:
	                members.defaultedMembers.push(this.finishNode(memberNode, "EnumDefaultedMember"));
	            }
	          }
	      }
	      if (!this.match(8)) {
	        this.expect(12);
	      }
	    }
	    return {
	      members,
	      hasUnknownMembers
	    };
	  }
	  flowEnumStringMembers(initializedMembers, defaultedMembers, {
	    enumName
	  }) {
	    if (initializedMembers.length === 0) {
	      return defaultedMembers;
	    } else if (defaultedMembers.length === 0) {
	      return initializedMembers;
	    } else if (defaultedMembers.length > initializedMembers.length) {
	      for (const member of initializedMembers) {
	        this.flowEnumErrorStringMemberInconsistentlyInitialized(member, {
	          enumName
	        });
	      }
	      return defaultedMembers;
	    } else {
	      for (const member of defaultedMembers) {
	        this.flowEnumErrorStringMemberInconsistentlyInitialized(member, {
	          enumName
	        });
	      }
	      return initializedMembers;
	    }
	  }
	  flowEnumParseExplicitType({
	    enumName
	  }) {
	    if (!this.eatContextual(102)) return null;
	    if (!tokenIsIdentifier(this.state.type)) {
	      throw this.raise(FlowErrors.EnumInvalidExplicitTypeUnknownSupplied, this.state.startLoc, {
	        enumName
	      });
	    }
	    const {
	      value
	    } = this.state;
	    this.next();
	    if (value !== "boolean" && value !== "number" && value !== "string" && value !== "symbol") {
	      this.raise(FlowErrors.EnumInvalidExplicitType, this.state.startLoc, {
	        enumName,
	        invalidEnumType: value
	      });
	    }
	    return value;
	  }
	  flowEnumBody(node, id) {
	    const enumName = id.name;
	    const nameLoc = id.loc.start;
	    const explicitType = this.flowEnumParseExplicitType({
	      enumName
	    });
	    this.expect(5);
	    const {
	      members,
	      hasUnknownMembers
	    } = this.flowEnumMembers({
	      enumName,
	      explicitType
	    });
	    node.hasUnknownMembers = hasUnknownMembers;
	    switch (explicitType) {
	      case "boolean":
	        node.explicitType = true;
	        node.members = members.booleanMembers;
	        this.expect(8);
	        return this.finishNode(node, "EnumBooleanBody");
	      case "number":
	        node.explicitType = true;
	        node.members = members.numberMembers;
	        this.expect(8);
	        return this.finishNode(node, "EnumNumberBody");
	      case "string":
	        node.explicitType = true;
	        node.members = this.flowEnumStringMembers(members.stringMembers, members.defaultedMembers, {
	          enumName
	        });
	        this.expect(8);
	        return this.finishNode(node, "EnumStringBody");
	      case "symbol":
	        node.members = members.defaultedMembers;
	        this.expect(8);
	        return this.finishNode(node, "EnumSymbolBody");
	      default:
	        {
	          const empty = () => {
	            node.members = [];
	            this.expect(8);
	            return this.finishNode(node, "EnumStringBody");
	          };
	          node.explicitType = false;
	          const boolsLen = members.booleanMembers.length;
	          const numsLen = members.numberMembers.length;
	          const strsLen = members.stringMembers.length;
	          const defaultedLen = members.defaultedMembers.length;
	          if (!boolsLen && !numsLen && !strsLen && !defaultedLen) {
	            return empty();
	          } else if (!boolsLen && !numsLen) {
	            node.members = this.flowEnumStringMembers(members.stringMembers, members.defaultedMembers, {
	              enumName
	            });
	            this.expect(8);
	            return this.finishNode(node, "EnumStringBody");
	          } else if (!numsLen && !strsLen && boolsLen >= defaultedLen) {
	            for (const member of members.defaultedMembers) {
	              this.flowEnumErrorBooleanMemberNotInitialized(member.loc.start, {
	                enumName,
	                memberName: member.id.name
	              });
	            }
	            node.members = members.booleanMembers;
	            this.expect(8);
	            return this.finishNode(node, "EnumBooleanBody");
	          } else if (!boolsLen && !strsLen && numsLen >= defaultedLen) {
	            for (const member of members.defaultedMembers) {
	              this.flowEnumErrorNumberMemberNotInitialized(member.loc.start, {
	                enumName,
	                memberName: member.id.name
	              });
	            }
	            node.members = members.numberMembers;
	            this.expect(8);
	            return this.finishNode(node, "EnumNumberBody");
	          } else {
	            this.raise(FlowErrors.EnumInconsistentMemberValues, nameLoc, {
	              enumName
	            });
	            return empty();
	          }
	        }
	    }
	  }
	  flowParseEnumDeclaration(node) {
	    const id = this.parseIdentifier();
	    node.id = id;
	    node.body = this.flowEnumBody(this.startNode(), id);
	    return this.finishNode(node, "EnumDeclaration");
	  }
	  isLookaheadToken_lt() {
	    const next = this.nextTokenStart();
	    if (this.input.charCodeAt(next) === 60) {
	      const afterNext = this.input.charCodeAt(next + 1);
	      return afterNext !== 60 && afterNext !== 61;
	    }
	    return false;
	  }
	  maybeUnwrapTypeCastExpression(node) {
	    return node.type === "TypeCastExpression" ? node.expression : node;
	  }
	};
	const entities = {
	  __proto__: null,
	  quot: "\u0022",
	  amp: "&",
	  apos: "\u0027",
	  lt: "<",
	  gt: ">",
	  nbsp: "\u00A0",
	  iexcl: "\u00A1",
	  cent: "\u00A2",
	  pound: "\u00A3",
	  curren: "\u00A4",
	  yen: "\u00A5",
	  brvbar: "\u00A6",
	  sect: "\u00A7",
	  uml: "\u00A8",
	  copy: "\u00A9",
	  ordf: "\u00AA",
	  laquo: "\u00AB",
	  not: "\u00AC",
	  shy: "\u00AD",
	  reg: "\u00AE",
	  macr: "\u00AF",
	  deg: "\u00B0",
	  plusmn: "\u00B1",
	  sup2: "\u00B2",
	  sup3: "\u00B3",
	  acute: "\u00B4",
	  micro: "\u00B5",
	  para: "\u00B6",
	  middot: "\u00B7",
	  cedil: "\u00B8",
	  sup1: "\u00B9",
	  ordm: "\u00BA",
	  raquo: "\u00BB",
	  frac14: "\u00BC",
	  frac12: "\u00BD",
	  frac34: "\u00BE",
	  iquest: "\u00BF",
	  Agrave: "\u00C0",
	  Aacute: "\u00C1",
	  Acirc: "\u00C2",
	  Atilde: "\u00C3",
	  Auml: "\u00C4",
	  Aring: "\u00C5",
	  AElig: "\u00C6",
	  Ccedil: "\u00C7",
	  Egrave: "\u00C8",
	  Eacute: "\u00C9",
	  Ecirc: "\u00CA",
	  Euml: "\u00CB",
	  Igrave: "\u00CC",
	  Iacute: "\u00CD",
	  Icirc: "\u00CE",
	  Iuml: "\u00CF",
	  ETH: "\u00D0",
	  Ntilde: "\u00D1",
	  Ograve: "\u00D2",
	  Oacute: "\u00D3",
	  Ocirc: "\u00D4",
	  Otilde: "\u00D5",
	  Ouml: "\u00D6",
	  times: "\u00D7",
	  Oslash: "\u00D8",
	  Ugrave: "\u00D9",
	  Uacute: "\u00DA",
	  Ucirc: "\u00DB",
	  Uuml: "\u00DC",
	  Yacute: "\u00DD",
	  THORN: "\u00DE",
	  szlig: "\u00DF",
	  agrave: "\u00E0",
	  aacute: "\u00E1",
	  acirc: "\u00E2",
	  atilde: "\u00E3",
	  auml: "\u00E4",
	  aring: "\u00E5",
	  aelig: "\u00E6",
	  ccedil: "\u00E7",
	  egrave: "\u00E8",
	  eacute: "\u00E9",
	  ecirc: "\u00EA",
	  euml: "\u00EB",
	  igrave: "\u00EC",
	  iacute: "\u00ED",
	  icirc: "\u00EE",
	  iuml: "\u00EF",
	  eth: "\u00F0",
	  ntilde: "\u00F1",
	  ograve: "\u00F2",
	  oacute: "\u00F3",
	  ocirc: "\u00F4",
	  otilde: "\u00F5",
	  ouml: "\u00F6",
	  divide: "\u00F7",
	  oslash: "\u00F8",
	  ugrave: "\u00F9",
	  uacute: "\u00FA",
	  ucirc: "\u00FB",
	  uuml: "\u00FC",
	  yacute: "\u00FD",
	  thorn: "\u00FE",
	  yuml: "\u00FF",
	  OElig: "\u0152",
	  oelig: "\u0153",
	  Scaron: "\u0160",
	  scaron: "\u0161",
	  Yuml: "\u0178",
	  fnof: "\u0192",
	  circ: "\u02C6",
	  tilde: "\u02DC",
	  Alpha: "\u0391",
	  Beta: "\u0392",
	  Gamma: "\u0393",
	  Delta: "\u0394",
	  Epsilon: "\u0395",
	  Zeta: "\u0396",
	  Eta: "\u0397",
	  Theta: "\u0398",
	  Iota: "\u0399",
	  Kappa: "\u039A",
	  Lambda: "\u039B",
	  Mu: "\u039C",
	  Nu: "\u039D",
	  Xi: "\u039E",
	  Omicron: "\u039F",
	  Pi: "\u03A0",
	  Rho: "\u03A1",
	  Sigma: "\u03A3",
	  Tau: "\u03A4",
	  Upsilon: "\u03A5",
	  Phi: "\u03A6",
	  Chi: "\u03A7",
	  Psi: "\u03A8",
	  Omega: "\u03A9",
	  alpha: "\u03B1",
	  beta: "\u03B2",
	  gamma: "\u03B3",
	  delta: "\u03B4",
	  epsilon: "\u03B5",
	  zeta: "\u03B6",
	  eta: "\u03B7",
	  theta: "\u03B8",
	  iota: "\u03B9",
	  kappa: "\u03BA",
	  lambda: "\u03BB",
	  mu: "\u03BC",
	  nu: "\u03BD",
	  xi: "\u03BE",
	  omicron: "\u03BF",
	  pi: "\u03C0",
	  rho: "\u03C1",
	  sigmaf: "\u03C2",
	  sigma: "\u03C3",
	  tau: "\u03C4",
	  upsilon: "\u03C5",
	  phi: "\u03C6",
	  chi: "\u03C7",
	  psi: "\u03C8",
	  omega: "\u03C9",
	  thetasym: "\u03D1",
	  upsih: "\u03D2",
	  piv: "\u03D6",
	  ensp: "\u2002",
	  emsp: "\u2003",
	  thinsp: "\u2009",
	  zwnj: "\u200C",
	  zwj: "\u200D",
	  lrm: "\u200E",
	  rlm: "\u200F",
	  ndash: "\u2013",
	  mdash: "\u2014",
	  lsquo: "\u2018",
	  rsquo: "\u2019",
	  sbquo: "\u201A",
	  ldquo: "\u201C",
	  rdquo: "\u201D",
	  bdquo: "\u201E",
	  dagger: "\u2020",
	  Dagger: "\u2021",
	  bull: "\u2022",
	  hellip: "\u2026",
	  permil: "\u2030",
	  prime: "\u2032",
	  Prime: "\u2033",
	  lsaquo: "\u2039",
	  rsaquo: "\u203A",
	  oline: "\u203E",
	  frasl: "\u2044",
	  euro: "\u20AC",
	  image: "\u2111",
	  weierp: "\u2118",
	  real: "\u211C",
	  trade: "\u2122",
	  alefsym: "\u2135",
	  larr: "\u2190",
	  uarr: "\u2191",
	  rarr: "\u2192",
	  darr: "\u2193",
	  harr: "\u2194",
	  crarr: "\u21B5",
	  lArr: "\u21D0",
	  uArr: "\u21D1",
	  rArr: "\u21D2",
	  dArr: "\u21D3",
	  hArr: "\u21D4",
	  forall: "\u2200",
	  part: "\u2202",
	  exist: "\u2203",
	  empty: "\u2205",
	  nabla: "\u2207",
	  isin: "\u2208",
	  notin: "\u2209",
	  ni: "\u220B",
	  prod: "\u220F",
	  sum: "\u2211",
	  minus: "\u2212",
	  lowast: "\u2217",
	  radic: "\u221A",
	  prop: "\u221D",
	  infin: "\u221E",
	  ang: "\u2220",
	  and: "\u2227",
	  or: "\u2228",
	  cap: "\u2229",
	  cup: "\u222A",
	  int: "\u222B",
	  there4: "\u2234",
	  sim: "\u223C",
	  cong: "\u2245",
	  asymp: "\u2248",
	  ne: "\u2260",
	  equiv: "\u2261",
	  le: "\u2264",
	  ge: "\u2265",
	  sub: "\u2282",
	  sup: "\u2283",
	  nsub: "\u2284",
	  sube: "\u2286",
	  supe: "\u2287",
	  oplus: "\u2295",
	  otimes: "\u2297",
	  perp: "\u22A5",
	  sdot: "\u22C5",
	  lceil: "\u2308",
	  rceil: "\u2309",
	  lfloor: "\u230A",
	  rfloor: "\u230B",
	  lang: "\u2329",
	  rang: "\u232A",
	  loz: "\u25CA",
	  spades: "\u2660",
	  clubs: "\u2663",
	  hearts: "\u2665",
	  diams: "\u2666"
	};
	const JsxErrors = ParseErrorEnum`jsx`({
	  AttributeIsEmpty: "JSX attributes must only be assigned a non-empty expression.",
	  MissingClosingTagElement: ({
	    openingTagName
	  }) => `Expected corresponding JSX closing tag for <${openingTagName}>.`,
	  MissingClosingTagFragment: "Expected corresponding JSX closing tag for <>.",
	  UnexpectedSequenceExpression: "Sequence expressions cannot be directly nested inside JSX. Did you mean to wrap it in parentheses (...)?",
	  UnexpectedToken: ({
	    unexpected,
	    HTMLEntity
	  }) => `Unexpected token \`${unexpected}\`. Did you mean \`${HTMLEntity}\` or \`{'${unexpected}'}\`?`,
	  UnsupportedJsxValue: "JSX value should be either an expression or a quoted JSX text.",
	  UnterminatedJsxContent: "Unterminated JSX contents.",
	  UnwrappedAdjacentJSXElements: "Adjacent JSX elements must be wrapped in an enclosing tag. Did you want a JSX fragment <>...</>?"
	});
	function isFragment(object) {
	  return object ? object.type === "JSXOpeningFragment" || object.type === "JSXClosingFragment" : false;
	}
	function getQualifiedJSXName(object) {
	  if (object.type === "JSXIdentifier") {
	    return object.name;
	  }
	  if (object.type === "JSXNamespacedName") {
	    return object.namespace.name + ":" + object.name.name;
	  }
	  if (object.type === "JSXMemberExpression") {
	    return getQualifiedJSXName(object.object) + "." + getQualifiedJSXName(object.property);
	  }
	  throw new Error("Node had unexpected type: " + object.type);
	}
	var jsx = superClass => class JSXParserMixin extends superClass {
	  jsxReadToken() {
	    let out = "";
	    let chunkStart = this.state.pos;
	    for (;;) {
	      if (this.state.pos >= this.length) {
	        throw this.raise(JsxErrors.UnterminatedJsxContent, this.state.startLoc);
	      }
	      const ch = this.input.charCodeAt(this.state.pos);
	      switch (ch) {
	        case 60:
	        case 123:
	          if (this.state.pos === this.state.start) {
	            if (ch === 60 && this.state.canStartJSXElement) {
	              ++this.state.pos;
	              this.finishToken(142);
	            } else {
	              super.getTokenFromCode(ch);
	            }
	            return;
	          }
	          out += this.input.slice(chunkStart, this.state.pos);
	          this.finishToken(141, out);
	          return;
	        case 38:
	          out += this.input.slice(chunkStart, this.state.pos);
	          out += this.jsxReadEntity();
	          chunkStart = this.state.pos;
	          break;
	        case 62:
	        case 125:
	        default:
	          if (isNewLine(ch)) {
	            out += this.input.slice(chunkStart, this.state.pos);
	            out += this.jsxReadNewLine(true);
	            chunkStart = this.state.pos;
	          } else {
	            ++this.state.pos;
	          }
	      }
	    }
	  }
	  jsxReadNewLine(normalizeCRLF) {
	    const ch = this.input.charCodeAt(this.state.pos);
	    let out;
	    ++this.state.pos;
	    if (ch === 13 && this.input.charCodeAt(this.state.pos) === 10) {
	      ++this.state.pos;
	      out = normalizeCRLF ? "\n" : "\r\n";
	    } else {
	      out = String.fromCharCode(ch);
	    }
	    ++this.state.curLine;
	    this.state.lineStart = this.state.pos;
	    return out;
	  }
	  jsxReadString(quote) {
	    let out = "";
	    let chunkStart = ++this.state.pos;
	    for (;;) {
	      if (this.state.pos >= this.length) {
	        throw this.raise(Errors.UnterminatedString, this.state.startLoc);
	      }
	      const ch = this.input.charCodeAt(this.state.pos);
	      if (ch === quote) break;
	      if (ch === 38) {
	        out += this.input.slice(chunkStart, this.state.pos);
	        out += this.jsxReadEntity();
	        chunkStart = this.state.pos;
	      } else if (isNewLine(ch)) {
	        out += this.input.slice(chunkStart, this.state.pos);
	        out += this.jsxReadNewLine(false);
	        chunkStart = this.state.pos;
	      } else {
	        ++this.state.pos;
	      }
	    }
	    out += this.input.slice(chunkStart, this.state.pos++);
	    this.finishToken(133, out);
	  }
	  jsxReadEntity() {
	    const startPos = ++this.state.pos;
	    if (this.codePointAtPos(this.state.pos) === 35) {
	      ++this.state.pos;
	      let radix = 10;
	      if (this.codePointAtPos(this.state.pos) === 120) {
	        radix = 16;
	        ++this.state.pos;
	      }
	      const codePoint = this.readInt(radix, undefined, false, "bail");
	      if (codePoint !== null && this.codePointAtPos(this.state.pos) === 59) {
	        ++this.state.pos;
	        return String.fromCodePoint(codePoint);
	      }
	    } else {
	      let count = 0;
	      let semi = false;
	      while (count++ < 10 && this.state.pos < this.length && !(semi = this.codePointAtPos(this.state.pos) === 59)) {
	        ++this.state.pos;
	      }
	      if (semi) {
	        const desc = this.input.slice(startPos, this.state.pos);
	        const entity = entities[desc];
	        ++this.state.pos;
	        if (entity) {
	          return entity;
	        }
	      }
	    }
	    this.state.pos = startPos;
	    return "&";
	  }
	  jsxReadWord() {
	    let ch;
	    const start = this.state.pos;
	    do {
	      ch = this.input.charCodeAt(++this.state.pos);
	    } while (isIdentifierChar(ch) || ch === 45);
	    this.finishToken(140, this.input.slice(start, this.state.pos));
	  }
	  jsxParseIdentifier() {
	    const node = this.startNode();
	    if (this.match(140)) {
	      node.name = this.state.value;
	    } else if (tokenIsKeyword(this.state.type)) {
	      node.name = tokenLabelName(this.state.type);
	    } else {
	      this.unexpected();
	    }
	    this.next();
	    return this.finishNode(node, "JSXIdentifier");
	  }
	  jsxParseNamespacedName() {
	    const startLoc = this.state.startLoc;
	    const name = this.jsxParseIdentifier();
	    if (!this.eat(14)) return name;
	    const node = this.startNodeAt(startLoc);
	    node.namespace = name;
	    node.name = this.jsxParseIdentifier();
	    return this.finishNode(node, "JSXNamespacedName");
	  }
	  jsxParseElementName() {
	    const startLoc = this.state.startLoc;
	    let node = this.jsxParseNamespacedName();
	    if (node.type === "JSXNamespacedName") {
	      return node;
	    }
	    while (this.eat(16)) {
	      const newNode = this.startNodeAt(startLoc);
	      newNode.object = node;
	      newNode.property = this.jsxParseIdentifier();
	      node = this.finishNode(newNode, "JSXMemberExpression");
	    }
	    return node;
	  }
	  jsxParseAttributeValue() {
	    let node;
	    switch (this.state.type) {
	      case 5:
	        node = this.startNode();
	        this.setContext(types.brace);
	        this.next();
	        node = this.jsxParseExpressionContainer(node, types.j_oTag);
	        if (node.expression.type === "JSXEmptyExpression") {
	          this.raise(JsxErrors.AttributeIsEmpty, node);
	        }
	        return node;
	      case 142:
	      case 133:
	        return this.parseExprAtom();
	      default:
	        throw this.raise(JsxErrors.UnsupportedJsxValue, this.state.startLoc);
	    }
	  }
	  jsxParseEmptyExpression() {
	    const node = this.startNodeAt(this.state.lastTokEndLoc);
	    return this.finishNodeAt(node, "JSXEmptyExpression", this.state.startLoc);
	  }
	  jsxParseSpreadChild(node) {
	    this.next();
	    node.expression = this.parseExpression();
	    this.setContext(types.j_expr);
	    this.state.canStartJSXElement = true;
	    this.expect(8);
	    return this.finishNode(node, "JSXSpreadChild");
	  }
	  jsxParseExpressionContainer(node, previousContext) {
	    if (this.match(8)) {
	      node.expression = this.jsxParseEmptyExpression();
	    } else {
	      const expression = this.parseExpression();
	      node.expression = expression;
	    }
	    this.setContext(previousContext);
	    this.state.canStartJSXElement = true;
	    this.expect(8);
	    return this.finishNode(node, "JSXExpressionContainer");
	  }
	  jsxParseAttribute() {
	    const node = this.startNode();
	    if (this.match(5)) {
	      this.setContext(types.brace);
	      this.next();
	      this.expect(21);
	      node.argument = this.parseMaybeAssignAllowIn();
	      this.setContext(types.j_oTag);
	      this.state.canStartJSXElement = true;
	      this.expect(8);
	      return this.finishNode(node, "JSXSpreadAttribute");
	    }
	    node.name = this.jsxParseNamespacedName();
	    node.value = this.eat(29) ? this.jsxParseAttributeValue() : null;
	    return this.finishNode(node, "JSXAttribute");
	  }
	  jsxParseOpeningElementAt(startLoc) {
	    const node = this.startNodeAt(startLoc);
	    if (this.eat(143)) {
	      return this.finishNode(node, "JSXOpeningFragment");
	    }
	    node.name = this.jsxParseElementName();
	    return this.jsxParseOpeningElementAfterName(node);
	  }
	  jsxParseOpeningElementAfterName(node) {
	    const attributes = [];
	    while (!this.match(56) && !this.match(143)) {
	      attributes.push(this.jsxParseAttribute());
	    }
	    node.attributes = attributes;
	    node.selfClosing = this.eat(56);
	    this.expect(143);
	    return this.finishNode(node, "JSXOpeningElement");
	  }
	  jsxParseClosingElementAt(startLoc) {
	    const node = this.startNodeAt(startLoc);
	    if (this.eat(143)) {
	      return this.finishNode(node, "JSXClosingFragment");
	    }
	    node.name = this.jsxParseElementName();
	    this.expect(143);
	    return this.finishNode(node, "JSXClosingElement");
	  }
	  jsxParseElementAt(startLoc) {
	    const node = this.startNodeAt(startLoc);
	    const children = [];
	    const openingElement = this.jsxParseOpeningElementAt(startLoc);
	    let closingElement = null;
	    if (!openingElement.selfClosing) {
	      contents: for (;;) {
	        switch (this.state.type) {
	          case 142:
	            startLoc = this.state.startLoc;
	            this.next();
	            if (this.eat(56)) {
	              closingElement = this.jsxParseClosingElementAt(startLoc);
	              break contents;
	            }
	            children.push(this.jsxParseElementAt(startLoc));
	            break;
	          case 141:
	            children.push(this.parseLiteral(this.state.value, "JSXText"));
	            break;
	          case 5:
	            {
	              const node = this.startNode();
	              this.setContext(types.brace);
	              this.next();
	              if (this.match(21)) {
	                children.push(this.jsxParseSpreadChild(node));
	              } else {
	                children.push(this.jsxParseExpressionContainer(node, types.j_expr));
	              }
	              break;
	            }
	          default:
	            this.unexpected();
	        }
	      }
	      if (isFragment(openingElement) && !isFragment(closingElement) && closingElement !== null) {
	        this.raise(JsxErrors.MissingClosingTagFragment, closingElement);
	      } else if (!isFragment(openingElement) && isFragment(closingElement)) {
	        this.raise(JsxErrors.MissingClosingTagElement, closingElement, {
	          openingTagName: getQualifiedJSXName(openingElement.name)
	        });
	      } else if (!isFragment(openingElement) && !isFragment(closingElement)) {
	        if (getQualifiedJSXName(closingElement.name) !== getQualifiedJSXName(openingElement.name)) {
	          this.raise(JsxErrors.MissingClosingTagElement, closingElement, {
	            openingTagName: getQualifiedJSXName(openingElement.name)
	          });
	        }
	      }
	    }
	    if (isFragment(openingElement)) {
	      node.openingFragment = openingElement;
	      node.closingFragment = closingElement;
	    } else {
	      node.openingElement = openingElement;
	      node.closingElement = closingElement;
	    }
	    node.children = children;
	    if (this.match(47)) {
	      throw this.raise(JsxErrors.UnwrappedAdjacentJSXElements, this.state.startLoc);
	    }
	    return isFragment(openingElement) ? this.finishNode(node, "JSXFragment") : this.finishNode(node, "JSXElement");
	  }
	  jsxParseElement() {
	    const startLoc = this.state.startLoc;
	    this.next();
	    return this.jsxParseElementAt(startLoc);
	  }
	  setContext(newContext) {
	    const {
	      context
	    } = this.state;
	    context[context.length - 1] = newContext;
	  }
	  parseExprAtom(refExpressionErrors) {
	    if (this.match(142)) {
	      return this.jsxParseElement();
	    } else if (this.match(47) && this.input.charCodeAt(this.state.pos) !== 33) {
	      this.replaceToken(142);
	      return this.jsxParseElement();
	    } else {
	      return super.parseExprAtom(refExpressionErrors);
	    }
	  }
	  skipSpace() {
	    const curContext = this.curContext();
	    if (!curContext.preserveSpace) super.skipSpace();
	  }
	  getTokenFromCode(code) {
	    const context = this.curContext();
	    if (context === types.j_expr) {
	      this.jsxReadToken();
	      return;
	    }
	    if (context === types.j_oTag || context === types.j_cTag) {
	      if (isIdentifierStart(code)) {
	        this.jsxReadWord();
	        return;
	      }
	      if (code === 62) {
	        ++this.state.pos;
	        this.finishToken(143);
	        return;
	      }
	      if ((code === 34 || code === 39) && context === types.j_oTag) {
	        this.jsxReadString(code);
	        return;
	      }
	    }
	    if (code === 60 && this.state.canStartJSXElement && this.input.charCodeAt(this.state.pos + 1) !== 33) {
	      ++this.state.pos;
	      this.finishToken(142);
	      return;
	    }
	    super.getTokenFromCode(code);
	  }
	  updateContext(prevType) {
	    const {
	      context,
	      type
	    } = this.state;
	    if (type === 56 && prevType === 142) {
	      context.splice(-2, 2, types.j_cTag);
	      this.state.canStartJSXElement = false;
	    } else if (type === 142) {
	      context.push(types.j_oTag);
	    } else if (type === 143) {
	      const out = context[context.length - 1];
	      if (out === types.j_oTag && prevType === 56 || out === types.j_cTag) {
	        context.pop();
	        this.state.canStartJSXElement = context[context.length - 1] === types.j_expr;
	      } else {
	        this.setContext(types.j_expr);
	        this.state.canStartJSXElement = true;
	      }
	    } else {
	      this.state.canStartJSXElement = tokenComesBeforeExpression(type);
	    }
	  }
	};
	class TypeScriptScope extends Scope {
	  constructor(...args) {
	    super(...args);
	    this.tsNames = new Map();
	  }
	}
	class TypeScriptScopeHandler extends ScopeHandler {
	  constructor(...args) {
	    super(...args);
	    this.importsStack = [];
	  }
	  createScope(flags) {
	    this.importsStack.push(new Set());
	    return new TypeScriptScope(flags);
	  }
	  enter(flags) {
	    if (flags === 256) {
	      this.importsStack.push(new Set());
	    }
	    super.enter(flags);
	  }
	  exit() {
	    const flags = super.exit();
	    if (flags === 256) {
	      this.importsStack.pop();
	    }
	    return flags;
	  }
	  hasImport(name, allowShadow) {
	    const len = this.importsStack.length;
	    if (this.importsStack[len - 1].has(name)) {
	      return true;
	    }
	    if (!allowShadow && len > 1) {
	      for (let i = 0; i < len - 1; i++) {
	        if (this.importsStack[i].has(name)) return true;
	      }
	    }
	    return false;
	  }
	  declareName(name, bindingType, loc) {
	    if (bindingType & 4096) {
	      if (this.hasImport(name, true)) {
	        this.parser.raise(Errors.VarRedeclaration, loc, {
	          identifierName: name
	        });
	      }
	      this.importsStack[this.importsStack.length - 1].add(name);
	      return;
	    }
	    const scope = this.currentScope();
	    let type = scope.tsNames.get(name) || 0;
	    if (bindingType & 1024) {
	      this.maybeExportDefined(scope, name);
	      scope.tsNames.set(name, type | 16);
	      return;
	    }
	    super.declareName(name, bindingType, loc);
	    if (bindingType & 2) {
	      if (!(bindingType & 1)) {
	        this.checkRedeclarationInScope(scope, name, bindingType, loc);
	        this.maybeExportDefined(scope, name);
	      }
	      type = type | 1;
	    }
	    if (bindingType & 256) {
	      type = type | 2;
	    }
	    if (bindingType & 512) {
	      type = type | 4;
	    }
	    if (bindingType & 128) {
	      type = type | 8;
	    }
	    if (type) scope.tsNames.set(name, type);
	  }
	  isRedeclaredInScope(scope, name, bindingType) {
	    const type = scope.tsNames.get(name);
	    if ((type & 2) > 0) {
	      if (bindingType & 256) {
	        const isConst = !!(bindingType & 512);
	        const wasConst = (type & 4) > 0;
	        return isConst !== wasConst;
	      }
	      return true;
	    }
	    if (bindingType & 128 && (type & 8) > 0) {
	      if (scope.names.get(name) & 2) {
	        return !!(bindingType & 1);
	      } else {
	        return false;
	      }
	    }
	    if (bindingType & 2 && (type & 1) > 0) {
	      return true;
	    }
	    return super.isRedeclaredInScope(scope, name, bindingType);
	  }
	  checkLocalExport(id) {
	    const {
	      name
	    } = id;
	    if (this.hasImport(name)) return;
	    const len = this.scopeStack.length;
	    for (let i = len - 1; i >= 0; i--) {
	      const scope = this.scopeStack[i];
	      const type = scope.tsNames.get(name);
	      if ((type & 1) > 0 || (type & 16) > 0) {
	        return;
	      }
	    }
	    super.checkLocalExport(id);
	  }
	}
	const getOwn$1 = (object, key) => hasOwnProperty.call(object, key) && object[key];
	const unwrapParenthesizedExpression = node => {
	  return node.type === "ParenthesizedExpression" ? unwrapParenthesizedExpression(node.expression) : node;
	};
	class LValParser extends NodeUtils {
	  toAssignable(node, isLHS = false) {
	    var _node$extra, _node$extra3;
	    let parenthesized = undefined;
	    if (node.type === "ParenthesizedExpression" || (_node$extra = node.extra) != null && _node$extra.parenthesized) {
	      parenthesized = unwrapParenthesizedExpression(node);
	      if (isLHS) {
	        if (parenthesized.type === "Identifier") {
	          this.expressionScope.recordArrowParameterBindingError(Errors.InvalidParenthesizedAssignment, node);
	        } else if (parenthesized.type !== "MemberExpression" && !this.isOptionalMemberExpression(parenthesized)) {
	          this.raise(Errors.InvalidParenthesizedAssignment, node);
	        }
	      } else {
	        this.raise(Errors.InvalidParenthesizedAssignment, node);
	      }
	    }
	    switch (node.type) {
	      case "Identifier":
	      case "ObjectPattern":
	      case "ArrayPattern":
	      case "AssignmentPattern":
	      case "RestElement":
	        break;
	      case "ObjectExpression":
	        node.type = "ObjectPattern";
	        for (let i = 0, length = node.properties.length, last = length - 1; i < length; i++) {
	          var _node$extra2;
	          const prop = node.properties[i];
	          const isLast = i === last;
	          this.toAssignableObjectExpressionProp(prop, isLast, isLHS);
	          if (isLast && prop.type === "RestElement" && (_node$extra2 = node.extra) != null && _node$extra2.trailingCommaLoc) {
	            this.raise(Errors.RestTrailingComma, node.extra.trailingCommaLoc);
	          }
	        }
	        break;
	      case "ObjectProperty":
	        {
	          const {
	            key,
	            value
	          } = node;
	          if (this.isPrivateName(key)) {
	            this.classScope.usePrivateName(this.getPrivateNameSV(key), key.loc.start);
	          }
	          this.toAssignable(value, isLHS);
	          break;
	        }
	      case "SpreadElement":
	        {
	          throw new Error("Internal @babel/parser error (this is a bug, please report it)." + " SpreadElement should be converted by .toAssignable's caller.");
	        }
	      case "ArrayExpression":
	        node.type = "ArrayPattern";
	        this.toAssignableList(node.elements, (_node$extra3 = node.extra) == null ? void 0 : _node$extra3.trailingCommaLoc, isLHS);
	        break;
	      case "AssignmentExpression":
	        if (node.operator !== "=") {
	          this.raise(Errors.MissingEqInAssignment, node.left.loc.end);
	        }
	        node.type = "AssignmentPattern";
	        delete node.operator;
	        this.toAssignable(node.left, isLHS);
	        break;
	      case "ParenthesizedExpression":
	        this.toAssignable(parenthesized, isLHS);
	        break;
	    }
	  }
	  toAssignableObjectExpressionProp(prop, isLast, isLHS) {
	    if (prop.type === "ObjectMethod") {
	      this.raise(prop.kind === "get" || prop.kind === "set" ? Errors.PatternHasAccessor : Errors.PatternHasMethod, prop.key);
	    } else if (prop.type === "SpreadElement") {
	      prop.type = "RestElement";
	      const arg = prop.argument;
	      this.checkToRestConversion(arg, false);
	      this.toAssignable(arg, isLHS);
	      if (!isLast) {
	        this.raise(Errors.RestTrailingComma, prop);
	      }
	    } else {
	      this.toAssignable(prop, isLHS);
	    }
	  }
	  toAssignableList(exprList, trailingCommaLoc, isLHS) {
	    const end = exprList.length - 1;
	    for (let i = 0; i <= end; i++) {
	      const elt = exprList[i];
	      if (!elt) continue;
	      if (elt.type === "SpreadElement") {
	        elt.type = "RestElement";
	        const arg = elt.argument;
	        this.checkToRestConversion(arg, true);
	        this.toAssignable(arg, isLHS);
	      } else {
	        this.toAssignable(elt, isLHS);
	      }
	      if (elt.type === "RestElement") {
	        if (i < end) {
	          this.raise(Errors.RestTrailingComma, elt);
	        } else if (trailingCommaLoc) {
	          this.raise(Errors.RestTrailingComma, trailingCommaLoc);
	        }
	      }
	    }
	  }
	  isAssignable(node, isBinding) {
	    switch (node.type) {
	      case "Identifier":
	      case "ObjectPattern":
	      case "ArrayPattern":
	      case "AssignmentPattern":
	      case "RestElement":
	        return true;
	      case "ObjectExpression":
	        {
	          const last = node.properties.length - 1;
	          return node.properties.every((prop, i) => {
	            return prop.type !== "ObjectMethod" && (i === last || prop.type !== "SpreadElement") && this.isAssignable(prop);
	          });
	        }
	      case "ObjectProperty":
	        return this.isAssignable(node.value);
	      case "SpreadElement":
	        return this.isAssignable(node.argument);
	      case "ArrayExpression":
	        return node.elements.every(element => element === null || this.isAssignable(element));
	      case "AssignmentExpression":
	        return node.operator === "=";
	      case "ParenthesizedExpression":
	        return this.isAssignable(node.expression);
	      case "MemberExpression":
	      case "OptionalMemberExpression":
	        return !isBinding;
	      default:
	        return false;
	    }
	  }
	  toReferencedList(exprList, isParenthesizedExpr) {
	    return exprList;
	  }
	  toReferencedListDeep(exprList, isParenthesizedExpr) {
	    this.toReferencedList(exprList, isParenthesizedExpr);
	    for (const expr of exprList) {
	      if ((expr == null ? void 0 : expr.type) === "ArrayExpression") {
	        this.toReferencedListDeep(expr.elements);
	      }
	    }
	  }
	  parseSpread(refExpressionErrors) {
	    const node = this.startNode();
	    this.next();
	    node.argument = this.parseMaybeAssignAllowIn(refExpressionErrors, undefined);
	    return this.finishNode(node, "SpreadElement");
	  }
	  parseRestBinding() {
	    const node = this.startNode();
	    this.next();
	    node.argument = this.parseBindingAtom();
	    return this.finishNode(node, "RestElement");
	  }
	  parseBindingAtom() {
	    switch (this.state.type) {
	      case 0:
	        {
	          const node = this.startNode();
	          this.next();
	          node.elements = this.parseBindingList(3, 93, 1);
	          return this.finishNode(node, "ArrayPattern");
	        }
	      case 5:
	        return this.parseObjectLike(8, true);
	    }
	    return this.parseIdentifier();
	  }
	  parseBindingList(close, closeCharCode, flags) {
	    const allowEmpty = flags & 1;
	    const elts = [];
	    let first = true;
	    while (!this.eat(close)) {
	      if (first) {
	        first = false;
	      } else {
	        this.expect(12);
	      }
	      if (allowEmpty && this.match(12)) {
	        elts.push(null);
	      } else if (this.eat(close)) {
	        break;
	      } else if (this.match(21)) {
	        elts.push(this.parseAssignableListItemTypes(this.parseRestBinding(), flags));
	        if (!this.checkCommaAfterRest(closeCharCode)) {
	          this.expect(close);
	          break;
	        }
	      } else {
	        const decorators = [];
	        if (this.match(26) && this.hasPlugin("decorators")) {
	          this.raise(Errors.UnsupportedParameterDecorator, this.state.startLoc);
	        }
	        while (this.match(26)) {
	          decorators.push(this.parseDecorator());
	        }
	        elts.push(this.parseAssignableListItem(flags, decorators));
	      }
	    }
	    return elts;
	  }
	  parseBindingRestProperty(prop) {
	    this.next();
	    prop.argument = this.parseIdentifier();
	    this.checkCommaAfterRest(125);
	    return this.finishNode(prop, "RestElement");
	  }
	  parseBindingProperty() {
	    const {
	      type,
	      startLoc
	    } = this.state;
	    if (type === 21) {
	      return this.parseBindingRestProperty(this.startNode());
	    }
	    const prop = this.startNode();
	    if (type === 138) {
	      this.expectPlugin("destructuringPrivate", startLoc);
	      this.classScope.usePrivateName(this.state.value, startLoc);
	      prop.key = this.parsePrivateName();
	    } else {
	      this.parsePropertyName(prop);
	    }
	    prop.method = false;
	    return this.parseObjPropValue(prop, startLoc, false, false, true, false);
	  }
	  parseAssignableListItem(flags, decorators) {
	    const left = this.parseMaybeDefault();
	    this.parseAssignableListItemTypes(left, flags);
	    const elt = this.parseMaybeDefault(left.loc.start, left);
	    if (decorators.length) {
	      left.decorators = decorators;
	    }
	    return elt;
	  }
	  parseAssignableListItemTypes(param, flags) {
	    return param;
	  }
	  parseMaybeDefault(startLoc, left) {
	    var _startLoc, _left;
	    (_startLoc = startLoc) != null ? _startLoc : startLoc = this.state.startLoc;
	    left = (_left = left) != null ? _left : this.parseBindingAtom();
	    if (!this.eat(29)) return left;
	    const node = this.startNodeAt(startLoc);
	    node.left = left;
	    node.right = this.parseMaybeAssignAllowIn();
	    return this.finishNode(node, "AssignmentPattern");
	  }
	  isValidLVal(type, isUnparenthesizedInAssign, binding) {
	    return getOwn$1({
	      AssignmentPattern: "left",
	      RestElement: "argument",
	      ObjectProperty: "value",
	      ParenthesizedExpression: "expression",
	      ArrayPattern: "elements",
	      ObjectPattern: "properties"
	    }, type);
	  }
	  isOptionalMemberExpression(expression) {
	    return expression.type === "OptionalMemberExpression";
	  }
	  checkLVal(expression, {
	    in: ancestor,
	    binding = 64,
	    checkClashes = false,
	    strictModeChanged = false,
	    hasParenthesizedAncestor = false
	  }) {
	    var _expression$extra;
	    const type = expression.type;
	    if (this.isObjectMethod(expression)) return;
	    const isOptionalMemberExpression = this.isOptionalMemberExpression(expression);
	    if (isOptionalMemberExpression || type === "MemberExpression") {
	      if (isOptionalMemberExpression) {
	        this.expectPlugin("optionalChainingAssign", expression.loc.start);
	        if (ancestor.type !== "AssignmentExpression") {
	          this.raise(Errors.InvalidLhsOptionalChaining, expression, {
	            ancestor
	          });
	        }
	      }
	      if (binding !== 64) {
	        this.raise(Errors.InvalidPropertyBindingPattern, expression);
	      }
	      return;
	    }
	    if (type === "Identifier") {
	      this.checkIdentifier(expression, binding, strictModeChanged);
	      const {
	        name
	      } = expression;
	      if (checkClashes) {
	        if (checkClashes.has(name)) {
	          this.raise(Errors.ParamDupe, expression);
	        } else {
	          checkClashes.add(name);
	        }
	      }
	      return;
	    }
	    const validity = this.isValidLVal(type, !(hasParenthesizedAncestor || (_expression$extra = expression.extra) != null && _expression$extra.parenthesized) && ancestor.type === "AssignmentExpression", binding);
	    if (validity === true) return;
	    if (validity === false) {
	      const ParseErrorClass = binding === 64 ? Errors.InvalidLhs : Errors.InvalidLhsBinding;
	      this.raise(ParseErrorClass, expression, {
	        ancestor
	      });
	      return;
	    }
	    const [key, isParenthesizedExpression] = Array.isArray(validity) ? validity : [validity, type === "ParenthesizedExpression"];
	    const nextAncestor = type === "ArrayPattern" || type === "ObjectPattern" ? {
	      type
	    } : ancestor;
	    for (const child of [].concat(expression[key])) {
	      if (child) {
	        this.checkLVal(child, {
	          in: nextAncestor,
	          binding,
	          checkClashes,
	          strictModeChanged,
	          hasParenthesizedAncestor: isParenthesizedExpression
	        });
	      }
	    }
	  }
	  checkIdentifier(at, bindingType, strictModeChanged = false) {
	    if (this.state.strict && (strictModeChanged ? isStrictBindReservedWord(at.name, this.inModule) : isStrictBindOnlyReservedWord(at.name))) {
	      if (bindingType === 64) {
	        this.raise(Errors.StrictEvalArguments, at, {
	          referenceName: at.name
	        });
	      } else {
	        this.raise(Errors.StrictEvalArgumentsBinding, at, {
	          bindingName: at.name
	        });
	      }
	    }
	    if (bindingType & 8192 && at.name === "let") {
	      this.raise(Errors.LetInLexicalBinding, at);
	    }
	    if (!(bindingType & 64)) {
	      this.declareNameFromIdentifier(at, bindingType);
	    }
	  }
	  declareNameFromIdentifier(identifier, binding) {
	    this.scope.declareName(identifier.name, binding, identifier.loc.start);
	  }
	  checkToRestConversion(node, allowPattern) {
	    switch (node.type) {
	      case "ParenthesizedExpression":
	        this.checkToRestConversion(node.expression, allowPattern);
	        break;
	      case "Identifier":
	      case "MemberExpression":
	        break;
	      case "ArrayExpression":
	      case "ObjectExpression":
	        if (allowPattern) break;
	      default:
	        this.raise(Errors.InvalidRestAssignmentPattern, node);
	    }
	  }
	  checkCommaAfterRest(close) {
	    if (!this.match(12)) {
	      return false;
	    }
	    this.raise(this.lookaheadCharCode() === close ? Errors.RestTrailingComma : Errors.ElementAfterRest, this.state.startLoc);
	    return true;
	  }
	}
	const getOwn = (object, key) => hasOwnProperty.call(object, key) && object[key];
	function nonNull(x) {
	  if (x == null) {
	    throw new Error(`Unexpected ${x} value.`);
	  }
	  return x;
	}
	function assert(x) {
	  if (!x) {
	    throw new Error("Assert fail");
	  }
	}
	const TSErrors = ParseErrorEnum`typescript`({
	  AbstractMethodHasImplementation: ({
	    methodName
	  }) => `Method '${methodName}' cannot have an implementation because it is marked abstract.`,
	  AbstractPropertyHasInitializer: ({
	    propertyName
	  }) => `Property '${propertyName}' cannot have an initializer because it is marked abstract.`,
	  AccesorCannotDeclareThisParameter: "'get' and 'set' accessors cannot declare 'this' parameters.",
	  AccesorCannotHaveTypeParameters: "An accessor cannot have type parameters.",
	  AccessorCannotBeOptional: "An 'accessor' property cannot be declared optional.",
	  ClassMethodHasDeclare: "Class methods cannot have the 'declare' modifier.",
	  ClassMethodHasReadonly: "Class methods cannot have the 'readonly' modifier.",
	  ConstInitiailizerMustBeStringOrNumericLiteralOrLiteralEnumReference: "A 'const' initializer in an ambient context must be a string or numeric literal or literal enum reference.",
	  ConstructorHasTypeParameters: "Type parameters cannot appear on a constructor declaration.",
	  DeclareAccessor: ({
	    kind
	  }) => `'declare' is not allowed in ${kind}ters.`,
	  DeclareClassFieldHasInitializer: "Initializers are not allowed in ambient contexts.",
	  DeclareFunctionHasImplementation: "An implementation cannot be declared in ambient contexts.",
	  DuplicateAccessibilityModifier: ({
	    modifier
	  }) => `Accessibility modifier already seen.`,
	  DuplicateModifier: ({
	    modifier
	  }) => `Duplicate modifier: '${modifier}'.`,
	  EmptyHeritageClauseType: ({
	    token
	  }) => `'${token}' list cannot be empty.`,
	  EmptyTypeArguments: "Type argument list cannot be empty.",
	  EmptyTypeParameters: "Type parameter list cannot be empty.",
	  ExpectedAmbientAfterExportDeclare: "'export declare' must be followed by an ambient declaration.",
	  ImportAliasHasImportType: "An import alias can not use 'import type'.",
	  ImportReflectionHasImportType: "An `import module` declaration can not use `type` modifier",
	  IncompatibleModifiers: ({
	    modifiers
	  }) => `'${modifiers[0]}' modifier cannot be used with '${modifiers[1]}' modifier.`,
	  IndexSignatureHasAbstract: "Index signatures cannot have the 'abstract' modifier.",
	  IndexSignatureHasAccessibility: ({
	    modifier
	  }) => `Index signatures cannot have an accessibility modifier ('${modifier}').`,
	  IndexSignatureHasDeclare: "Index signatures cannot have the 'declare' modifier.",
	  IndexSignatureHasOverride: "'override' modifier cannot appear on an index signature.",
	  IndexSignatureHasStatic: "Index signatures cannot have the 'static' modifier.",
	  InitializerNotAllowedInAmbientContext: "Initializers are not allowed in ambient contexts.",
	  InvalidModifierOnTypeMember: ({
	    modifier
	  }) => `'${modifier}' modifier cannot appear on a type member.`,
	  InvalidModifierOnTypeParameter: ({
	    modifier
	  }) => `'${modifier}' modifier cannot appear on a type parameter.`,
	  InvalidModifierOnTypeParameterPositions: ({
	    modifier
	  }) => `'${modifier}' modifier can only appear on a type parameter of a class, interface or type alias.`,
	  InvalidModifiersOrder: ({
	    orderedModifiers
	  }) => `'${orderedModifiers[0]}' modifier must precede '${orderedModifiers[1]}' modifier.`,
	  InvalidPropertyAccessAfterInstantiationExpression: "Invalid property access after an instantiation expression. " + "You can either wrap the instantiation expression in parentheses, or delete the type arguments.",
	  InvalidTupleMemberLabel: "Tuple members must be labeled with a simple identifier.",
	  MissingInterfaceName: "'interface' declarations must be followed by an identifier.",
	  NonAbstractClassHasAbstractMethod: "Abstract methods can only appear within an abstract class.",
	  NonClassMethodPropertyHasAbstractModifer: "'abstract' modifier can only appear on a class, method, or property declaration.",
	  OptionalTypeBeforeRequired: "A required element cannot follow an optional element.",
	  OverrideNotInSubClass: "This member cannot have an 'override' modifier because its containing class does not extend another class.",
	  PatternIsOptional: "A binding pattern parameter cannot be optional in an implementation signature.",
	  PrivateElementHasAbstract: "Private elements cannot have the 'abstract' modifier.",
	  PrivateElementHasAccessibility: ({
	    modifier
	  }) => `Private elements cannot have an accessibility modifier ('${modifier}').`,
	  ReadonlyForMethodSignature: "'readonly' modifier can only appear on a property declaration or index signature.",
	  ReservedArrowTypeParam: "This syntax is reserved in files with the .mts or .cts extension. Add a trailing comma, as in `<T,>() => ...`.",
	  ReservedTypeAssertion: "This syntax is reserved in files with the .mts or .cts extension. Use an `as` expression instead.",
	  SetAccesorCannotHaveOptionalParameter: "A 'set' accessor cannot have an optional parameter.",
	  SetAccesorCannotHaveRestParameter: "A 'set' accessor cannot have rest parameter.",
	  SetAccesorCannotHaveReturnType: "A 'set' accessor cannot have a return type annotation.",
	  SingleTypeParameterWithoutTrailingComma: ({
	    typeParameterName
	  }) => `Single type parameter ${typeParameterName} should have a trailing comma. Example usage: <${typeParameterName},>.`,
	  StaticBlockCannotHaveModifier: "Static class blocks cannot have any modifier.",
	  TupleOptionalAfterType: "A labeled tuple optional element must be declared using a question mark after the name and before the colon (`name?: type`), rather than after the type (`name: type?`).",
	  TypeAnnotationAfterAssign: "Type annotations must come before default assignments, e.g. instead of `age = 25: number` use `age: number = 25`.",
	  TypeImportCannotSpecifyDefaultAndNamed: "A type-only import can specify a default import or named bindings, but not both.",
	  TypeModifierIsUsedInTypeExports: "The 'type' modifier cannot be used on a named export when 'export type' is used on its export statement.",
	  TypeModifierIsUsedInTypeImports: "The 'type' modifier cannot be used on a named import when 'import type' is used on its import statement.",
	  UnexpectedParameterModifier: "A parameter property is only allowed in a constructor implementation.",
	  UnexpectedReadonly: "'readonly' type modifier is only permitted on array and tuple literal types.",
	  UnexpectedTypeAnnotation: "Did not expect a type annotation here.",
	  UnexpectedTypeCastInParameter: "Unexpected type cast in parameter position.",
	  UnsupportedImportTypeArgument: "Argument in a type import must be a string literal.",
	  UnsupportedParameterPropertyKind: "A parameter property may not be declared using a binding pattern.",
	  UnsupportedSignatureParameterKind: ({
	    type
	  }) => `Name in a signature must be an Identifier, ObjectPattern or ArrayPattern, instead got ${type}.`
	});
	function keywordTypeFromName(value) {
	  switch (value) {
	    case "any":
	      return "TSAnyKeyword";
	    case "boolean":
	      return "TSBooleanKeyword";
	    case "bigint":
	      return "TSBigIntKeyword";
	    case "never":
	      return "TSNeverKeyword";
	    case "number":
	      return "TSNumberKeyword";
	    case "object":
	      return "TSObjectKeyword";
	    case "string":
	      return "TSStringKeyword";
	    case "symbol":
	      return "TSSymbolKeyword";
	    case "undefined":
	      return "TSUndefinedKeyword";
	    case "unknown":
	      return "TSUnknownKeyword";
	    default:
	      return undefined;
	  }
	}
	function tsIsAccessModifier(modifier) {
	  return modifier === "private" || modifier === "public" || modifier === "protected";
	}
	function tsIsVarianceAnnotations(modifier) {
	  return modifier === "in" || modifier === "out";
	}
	var typescript = superClass => class TypeScriptParserMixin extends superClass {
	  constructor(...args) {
	    super(...args);
	    this.tsParseInOutModifiers = this.tsParseModifiers.bind(this, {
	      allowedModifiers: ["in", "out"],
	      disallowedModifiers: ["const", "public", "private", "protected", "readonly", "declare", "abstract", "override"],
	      errorTemplate: TSErrors.InvalidModifierOnTypeParameter
	    });
	    this.tsParseConstModifier = this.tsParseModifiers.bind(this, {
	      allowedModifiers: ["const"],
	      disallowedModifiers: ["in", "out"],
	      errorTemplate: TSErrors.InvalidModifierOnTypeParameterPositions
	    });
	    this.tsParseInOutConstModifiers = this.tsParseModifiers.bind(this, {
	      allowedModifiers: ["in", "out", "const"],
	      disallowedModifiers: ["public", "private", "protected", "readonly", "declare", "abstract", "override"],
	      errorTemplate: TSErrors.InvalidModifierOnTypeParameter
	    });
	  }
	  getScopeHandler() {
	    return TypeScriptScopeHandler;
	  }
	  tsIsIdentifier() {
	    return tokenIsIdentifier(this.state.type);
	  }
	  tsTokenCanFollowModifier() {
	    return (this.match(0) || this.match(5) || this.match(55) || this.match(21) || this.match(138) || this.isLiteralPropertyName()) && !this.hasPrecedingLineBreak();
	  }
	  tsNextTokenCanFollowModifier() {
	    this.next();
	    return this.tsTokenCanFollowModifier();
	  }
	  tsParseModifier(allowedModifiers, stopOnStartOfClassStaticBlock) {
	    if (!tokenIsIdentifier(this.state.type) && this.state.type !== 58 && this.state.type !== 75) {
	      return undefined;
	    }
	    const modifier = this.state.value;
	    if (allowedModifiers.indexOf(modifier) !== -1) {
	      if (stopOnStartOfClassStaticBlock && this.tsIsStartOfStaticBlocks()) {
	        return undefined;
	      }
	      if (this.tsTryParse(this.tsNextTokenCanFollowModifier.bind(this))) {
	        return modifier;
	      }
	    }
	    return undefined;
	  }
	  tsParseModifiers({
	    allowedModifiers,
	    disallowedModifiers,
	    stopOnStartOfClassStaticBlock,
	    errorTemplate = TSErrors.InvalidModifierOnTypeMember
	  }, modified) {
	    const enforceOrder = (loc, modifier, before, after) => {
	      if (modifier === before && modified[after]) {
	        this.raise(TSErrors.InvalidModifiersOrder, loc, {
	          orderedModifiers: [before, after]
	        });
	      }
	    };
	    const incompatible = (loc, modifier, mod1, mod2) => {
	      if (modified[mod1] && modifier === mod2 || modified[mod2] && modifier === mod1) {
	        this.raise(TSErrors.IncompatibleModifiers, loc, {
	          modifiers: [mod1, mod2]
	        });
	      }
	    };
	    for (;;) {
	      const {
	        startLoc
	      } = this.state;
	      const modifier = this.tsParseModifier(allowedModifiers.concat(disallowedModifiers != null ? disallowedModifiers : []), stopOnStartOfClassStaticBlock);
	      if (!modifier) break;
	      if (tsIsAccessModifier(modifier)) {
	        if (modified.accessibility) {
	          this.raise(TSErrors.DuplicateAccessibilityModifier, startLoc, {
	            modifier
	          });
	        } else {
	          enforceOrder(startLoc, modifier, modifier, "override");
	          enforceOrder(startLoc, modifier, modifier, "static");
	          enforceOrder(startLoc, modifier, modifier, "readonly");
	          modified.accessibility = modifier;
	        }
	      } else if (tsIsVarianceAnnotations(modifier)) {
	        if (modified[modifier]) {
	          this.raise(TSErrors.DuplicateModifier, startLoc, {
	            modifier
	          });
	        }
	        modified[modifier] = true;
	        enforceOrder(startLoc, modifier, "in", "out");
	      } else {
	        if (hasOwnProperty.call(modified, modifier)) {
	          this.raise(TSErrors.DuplicateModifier, startLoc, {
	            modifier
	          });
	        } else {
	          enforceOrder(startLoc, modifier, "static", "readonly");
	          enforceOrder(startLoc, modifier, "static", "override");
	          enforceOrder(startLoc, modifier, "override", "readonly");
	          enforceOrder(startLoc, modifier, "abstract", "override");
	          incompatible(startLoc, modifier, "declare", "override");
	          incompatible(startLoc, modifier, "static", "abstract");
	        }
	        modified[modifier] = true;
	      }
	      if (disallowedModifiers != null && disallowedModifiers.includes(modifier)) {
	        this.raise(errorTemplate, startLoc, {
	          modifier
	        });
	      }
	    }
	  }
	  tsIsListTerminator(kind) {
	    switch (kind) {
	      case "EnumMembers":
	      case "TypeMembers":
	        return this.match(8);
	      case "HeritageClauseElement":
	        return this.match(5);
	      case "TupleElementTypes":
	        return this.match(3);
	      case "TypeParametersOrArguments":
	        return this.match(48);
	    }
	  }
	  tsParseList(kind, parseElement) {
	    const result = [];
	    while (!this.tsIsListTerminator(kind)) {
	      result.push(parseElement());
	    }
	    return result;
	  }
	  tsParseDelimitedList(kind, parseElement, refTrailingCommaPos) {
	    return nonNull(this.tsParseDelimitedListWorker(kind, parseElement, true, refTrailingCommaPos));
	  }
	  tsParseDelimitedListWorker(kind, parseElement, expectSuccess, refTrailingCommaPos) {
	    const result = [];
	    let trailingCommaPos = -1;
	    for (;;) {
	      if (this.tsIsListTerminator(kind)) {
	        break;
	      }
	      trailingCommaPos = -1;
	      const element = parseElement();
	      if (element == null) {
	        return undefined;
	      }
	      result.push(element);
	      if (this.eat(12)) {
	        trailingCommaPos = this.state.lastTokStartLoc.index;
	        continue;
	      }
	      if (this.tsIsListTerminator(kind)) {
	        break;
	      }
	      if (expectSuccess) {
	        this.expect(12);
	      }
	      return undefined;
	    }
	    if (refTrailingCommaPos) {
	      refTrailingCommaPos.value = trailingCommaPos;
	    }
	    return result;
	  }
	  tsParseBracketedList(kind, parseElement, bracket, skipFirstToken, refTrailingCommaPos) {
	    if (!skipFirstToken) {
	      if (bracket) {
	        this.expect(0);
	      } else {
	        this.expect(47);
	      }
	    }
	    const result = this.tsParseDelimitedList(kind, parseElement, refTrailingCommaPos);
	    if (bracket) {
	      this.expect(3);
	    } else {
	      this.expect(48);
	    }
	    return result;
	  }
	  tsParseImportType() {
	    const node = this.startNode();
	    this.expect(83);
	    this.expect(10);
	    if (!this.match(133)) {
	      this.raise(TSErrors.UnsupportedImportTypeArgument, this.state.startLoc);
	    }
	    node.argument = super.parseExprAtom();
	    if (this.hasPlugin("importAttributes") || this.hasPlugin("importAssertions")) {
	      node.options = null;
	    }
	    if (this.eat(12)) {
	      this.expectImportAttributesPlugin();
	      if (!this.match(11)) {
	        node.options = super.parseMaybeAssignAllowIn();
	        this.eat(12);
	      }
	    }
	    this.expect(11);
	    if (this.eat(16)) {
	      node.qualifier = this.tsParseEntityName();
	    }
	    if (this.match(47)) {
	      node.typeParameters = this.tsParseTypeArguments();
	    }
	    return this.finishNode(node, "TSImportType");
	  }
	  tsParseEntityName(allowReservedWords = true) {
	    let entity = this.parseIdentifier(allowReservedWords);
	    while (this.eat(16)) {
	      const node = this.startNodeAtNode(entity);
	      node.left = entity;
	      node.right = this.parseIdentifier(allowReservedWords);
	      entity = this.finishNode(node, "TSQualifiedName");
	    }
	    return entity;
	  }
	  tsParseTypeReference() {
	    const node = this.startNode();
	    node.typeName = this.tsParseEntityName();
	    if (!this.hasPrecedingLineBreak() && this.match(47)) {
	      node.typeParameters = this.tsParseTypeArguments();
	    }
	    return this.finishNode(node, "TSTypeReference");
	  }
	  tsParseThisTypePredicate(lhs) {
	    this.next();
	    const node = this.startNodeAtNode(lhs);
	    node.parameterName = lhs;
	    node.typeAnnotation = this.tsParseTypeAnnotation(false);
	    node.asserts = false;
	    return this.finishNode(node, "TSTypePredicate");
	  }
	  tsParseThisTypeNode() {
	    const node = this.startNode();
	    this.next();
	    return this.finishNode(node, "TSThisType");
	  }
	  tsParseTypeQuery() {
	    const node = this.startNode();
	    this.expect(87);
	    if (this.match(83)) {
	      node.exprName = this.tsParseImportType();
	    } else {
	      node.exprName = this.tsParseEntityName();
	    }
	    if (!this.hasPrecedingLineBreak() && this.match(47)) {
	      node.typeParameters = this.tsParseTypeArguments();
	    }
	    return this.finishNode(node, "TSTypeQuery");
	  }
	  tsParseTypeParameter(parseModifiers) {
	    const node = this.startNode();
	    parseModifiers(node);
	    node.name = this.tsParseTypeParameterName();
	    node.constraint = this.tsEatThenParseType(81);
	    node.default = this.tsEatThenParseType(29);
	    return this.finishNode(node, "TSTypeParameter");
	  }
	  tsTryParseTypeParameters(parseModifiers) {
	    if (this.match(47)) {
	      return this.tsParseTypeParameters(parseModifiers);
	    }
	  }
	  tsParseTypeParameters(parseModifiers) {
	    const node = this.startNode();
	    if (this.match(47) || this.match(142)) {
	      this.next();
	    } else {
	      this.unexpected();
	    }
	    const refTrailingCommaPos = {
	      value: -1
	    };
	    node.params = this.tsParseBracketedList("TypeParametersOrArguments", this.tsParseTypeParameter.bind(this, parseModifiers), false, true, refTrailingCommaPos);
	    if (node.params.length === 0) {
	      this.raise(TSErrors.EmptyTypeParameters, node);
	    }
	    if (refTrailingCommaPos.value !== -1) {
	      this.addExtra(node, "trailingComma", refTrailingCommaPos.value);
	    }
	    return this.finishNode(node, "TSTypeParameterDeclaration");
	  }
	  tsFillSignature(returnToken, signature) {
	    const returnTokenRequired = returnToken === 19;
	    const paramsKey = "parameters";
	    const returnTypeKey = "typeAnnotation";
	    signature.typeParameters = this.tsTryParseTypeParameters(this.tsParseConstModifier);
	    this.expect(10);
	    signature[paramsKey] = this.tsParseBindingListForSignature();
	    if (returnTokenRequired) {
	      signature[returnTypeKey] = this.tsParseTypeOrTypePredicateAnnotation(returnToken);
	    } else if (this.match(returnToken)) {
	      signature[returnTypeKey] = this.tsParseTypeOrTypePredicateAnnotation(returnToken);
	    }
	  }
	  tsParseBindingListForSignature() {
	    const list = super.parseBindingList(11, 41, 2);
	    for (const pattern of list) {
	      const {
	        type
	      } = pattern;
	      if (type === "AssignmentPattern" || type === "TSParameterProperty") {
	        this.raise(TSErrors.UnsupportedSignatureParameterKind, pattern, {
	          type
	        });
	      }
	    }
	    return list;
	  }
	  tsParseTypeMemberSemicolon() {
	    if (!this.eat(12) && !this.isLineTerminator()) {
	      this.expect(13);
	    }
	  }
	  tsParseSignatureMember(kind, node) {
	    this.tsFillSignature(14, node);
	    this.tsParseTypeMemberSemicolon();
	    return this.finishNode(node, kind);
	  }
	  tsIsUnambiguouslyIndexSignature() {
	    this.next();
	    if (tokenIsIdentifier(this.state.type)) {
	      this.next();
	      return this.match(14);
	    }
	    return false;
	  }
	  tsTryParseIndexSignature(node) {
	    if (!(this.match(0) && this.tsLookAhead(this.tsIsUnambiguouslyIndexSignature.bind(this)))) {
	      return;
	    }
	    this.expect(0);
	    const id = this.parseIdentifier();
	    id.typeAnnotation = this.tsParseTypeAnnotation();
	    this.resetEndLocation(id);
	    this.expect(3);
	    node.parameters = [id];
	    const type = this.tsTryParseTypeAnnotation();
	    if (type) node.typeAnnotation = type;
	    this.tsParseTypeMemberSemicolon();
	    return this.finishNode(node, "TSIndexSignature");
	  }
	  tsParsePropertyOrMethodSignature(node, readonly) {
	    if (this.eat(17)) node.optional = true;
	    const nodeAny = node;
	    if (this.match(10) || this.match(47)) {
	      if (readonly) {
	        this.raise(TSErrors.ReadonlyForMethodSignature, node);
	      }
	      const method = nodeAny;
	      if (method.kind && this.match(47)) {
	        this.raise(TSErrors.AccesorCannotHaveTypeParameters, this.state.curPosition());
	      }
	      this.tsFillSignature(14, method);
	      this.tsParseTypeMemberSemicolon();
	      const paramsKey = "parameters";
	      const returnTypeKey = "typeAnnotation";
	      if (method.kind === "get") {
	        if (method[paramsKey].length > 0) {
	          this.raise(Errors.BadGetterArity, this.state.curPosition());
	          if (this.isThisParam(method[paramsKey][0])) {
	            this.raise(TSErrors.AccesorCannotDeclareThisParameter, this.state.curPosition());
	          }
	        }
	      } else if (method.kind === "set") {
	        if (method[paramsKey].length !== 1) {
	          this.raise(Errors.BadSetterArity, this.state.curPosition());
	        } else {
	          const firstParameter = method[paramsKey][0];
	          if (this.isThisParam(firstParameter)) {
	            this.raise(TSErrors.AccesorCannotDeclareThisParameter, this.state.curPosition());
	          }
	          if (firstParameter.type === "Identifier" && firstParameter.optional) {
	            this.raise(TSErrors.SetAccesorCannotHaveOptionalParameter, this.state.curPosition());
	          }
	          if (firstParameter.type === "RestElement") {
	            this.raise(TSErrors.SetAccesorCannotHaveRestParameter, this.state.curPosition());
	          }
	        }
	        if (method[returnTypeKey]) {
	          this.raise(TSErrors.SetAccesorCannotHaveReturnType, method[returnTypeKey]);
	        }
	      } else {
	        method.kind = "method";
	      }
	      return this.finishNode(method, "TSMethodSignature");
	    } else {
	      const property = nodeAny;
	      if (readonly) property.readonly = true;
	      const type = this.tsTryParseTypeAnnotation();
	      if (type) property.typeAnnotation = type;
	      this.tsParseTypeMemberSemicolon();
	      return this.finishNode(property, "TSPropertySignature");
	    }
	  }
	  tsParseTypeMember() {
	    const node = this.startNode();
	    if (this.match(10) || this.match(47)) {
	      return this.tsParseSignatureMember("TSCallSignatureDeclaration", node);
	    }
	    if (this.match(77)) {
	      const id = this.startNode();
	      this.next();
	      if (this.match(10) || this.match(47)) {
	        return this.tsParseSignatureMember("TSConstructSignatureDeclaration", node);
	      } else {
	        node.key = this.createIdentifier(id, "new");
	        return this.tsParsePropertyOrMethodSignature(node, false);
	      }
	    }
	    this.tsParseModifiers({
	      allowedModifiers: ["readonly"],
	      disallowedModifiers: ["declare", "abstract", "private", "protected", "public", "static", "override"]
	    }, node);
	    const idx = this.tsTryParseIndexSignature(node);
	    if (idx) {
	      return idx;
	    }
	    super.parsePropertyName(node);
	    if (!node.computed && node.key.type === "Identifier" && (node.key.name === "get" || node.key.name === "set") && this.tsTokenCanFollowModifier()) {
	      node.kind = node.key.name;
	      super.parsePropertyName(node);
	    }
	    return this.tsParsePropertyOrMethodSignature(node, !!node.readonly);
	  }
	  tsParseTypeLiteral() {
	    const node = this.startNode();
	    node.members = this.tsParseObjectTypeMembers();
	    return this.finishNode(node, "TSTypeLiteral");
	  }
	  tsParseObjectTypeMembers() {
	    this.expect(5);
	    const members = this.tsParseList("TypeMembers", this.tsParseTypeMember.bind(this));
	    this.expect(8);
	    return members;
	  }
	  tsIsStartOfMappedType() {
	    this.next();
	    if (this.eat(53)) {
	      return this.isContextual(122);
	    }
	    if (this.isContextual(122)) {
	      this.next();
	    }
	    if (!this.match(0)) {
	      return false;
	    }
	    this.next();
	    if (!this.tsIsIdentifier()) {
	      return false;
	    }
	    this.next();
	    return this.match(58);
	  }
	  tsParseMappedTypeParameter() {
	    const node = this.startNode();
	    node.name = this.tsParseTypeParameterName();
	    node.constraint = this.tsExpectThenParseType(58);
	    return this.finishNode(node, "TSTypeParameter");
	  }
	  tsParseMappedType() {
	    const node = this.startNode();
	    this.expect(5);
	    if (this.match(53)) {
	      node.readonly = this.state.value;
	      this.next();
	      this.expectContextual(122);
	    } else if (this.eatContextual(122)) {
	      node.readonly = true;
	    }
	    this.expect(0);
	    node.typeParameter = this.tsParseMappedTypeParameter();
	    node.nameType = this.eatContextual(93) ? this.tsParseType() : null;
	    this.expect(3);
	    if (this.match(53)) {
	      node.optional = this.state.value;
	      this.next();
	      this.expect(17);
	    } else if (this.eat(17)) {
	      node.optional = true;
	    }
	    node.typeAnnotation = this.tsTryParseType();
	    this.semicolon();
	    this.expect(8);
	    return this.finishNode(node, "TSMappedType");
	  }
	  tsParseTupleType() {
	    const node = this.startNode();
	    node.elementTypes = this.tsParseBracketedList("TupleElementTypes", this.tsParseTupleElementType.bind(this), true, false);
	    let seenOptionalElement = false;
	    node.elementTypes.forEach(elementNode => {
	      const {
	        type
	      } = elementNode;
	      if (seenOptionalElement && type !== "TSRestType" && type !== "TSOptionalType" && !(type === "TSNamedTupleMember" && elementNode.optional)) {
	        this.raise(TSErrors.OptionalTypeBeforeRequired, elementNode);
	      }
	      seenOptionalElement || (seenOptionalElement = type === "TSNamedTupleMember" && elementNode.optional || type === "TSOptionalType");
	    });
	    return this.finishNode(node, "TSTupleType");
	  }
	  tsParseTupleElementType() {
	    const {
	      startLoc
	    } = this.state;
	    const rest = this.eat(21);
	    let labeled;
	    let label;
	    let optional;
	    let type;
	    const isWord = tokenIsKeywordOrIdentifier(this.state.type);
	    const chAfterWord = isWord ? this.lookaheadCharCode() : null;
	    if (chAfterWord === 58) {
	      labeled = true;
	      optional = false;
	      label = this.parseIdentifier(true);
	      this.expect(14);
	      type = this.tsParseType();
	    } else if (chAfterWord === 63) {
	      optional = true;
	      const startLoc = this.state.startLoc;
	      const wordName = this.state.value;
	      const typeOrLabel = this.tsParseNonArrayType();
	      if (this.lookaheadCharCode() === 58) {
	        labeled = true;
	        label = this.createIdentifier(this.startNodeAt(startLoc), wordName);
	        this.expect(17);
	        this.expect(14);
	        type = this.tsParseType();
	      } else {
	        labeled = false;
	        type = typeOrLabel;
	        this.expect(17);
	      }
	    } else {
	      type = this.tsParseType();
	      optional = this.eat(17);
	      labeled = this.eat(14);
	    }
	    if (labeled) {
	      let labeledNode;
	      if (label) {
	        labeledNode = this.startNodeAtNode(label);
	        labeledNode.optional = optional;
	        labeledNode.label = label;
	        labeledNode.elementType = type;
	        if (this.eat(17)) {
	          labeledNode.optional = true;
	          this.raise(TSErrors.TupleOptionalAfterType, this.state.lastTokStartLoc);
	        }
	      } else {
	        labeledNode = this.startNodeAtNode(type);
	        labeledNode.optional = optional;
	        this.raise(TSErrors.InvalidTupleMemberLabel, type);
	        labeledNode.label = type;
	        labeledNode.elementType = this.tsParseType();
	      }
	      type = this.finishNode(labeledNode, "TSNamedTupleMember");
	    } else if (optional) {
	      const optionalTypeNode = this.startNodeAtNode(type);
	      optionalTypeNode.typeAnnotation = type;
	      type = this.finishNode(optionalTypeNode, "TSOptionalType");
	    }
	    if (rest) {
	      const restNode = this.startNodeAt(startLoc);
	      restNode.typeAnnotation = type;
	      type = this.finishNode(restNode, "TSRestType");
	    }
	    return type;
	  }
	  tsParseParenthesizedType() {
	    const node = this.startNode();
	    this.expect(10);
	    node.typeAnnotation = this.tsParseType();
	    this.expect(11);
	    return this.finishNode(node, "TSParenthesizedType");
	  }
	  tsParseFunctionOrConstructorType(type, abstract) {
	    const node = this.startNode();
	    if (type === "TSConstructorType") {
	      node.abstract = !!abstract;
	      if (abstract) this.next();
	      this.next();
	    }
	    this.tsInAllowConditionalTypesContext(() => this.tsFillSignature(19, node));
	    return this.finishNode(node, type);
	  }
	  tsParseLiteralTypeNode() {
	    const node = this.startNode();
	    switch (this.state.type) {
	      case 134:
	      case 135:
	      case 133:
	      case 85:
	      case 86:
	        node.literal = super.parseExprAtom();
	        break;
	      default:
	        this.unexpected();
	    }
	    return this.finishNode(node, "TSLiteralType");
	  }
	  tsParseTemplateLiteralType() {
	    const node = this.startNode();
	    node.literal = super.parseTemplate(false);
	    return this.finishNode(node, "TSLiteralType");
	  }
	  parseTemplateSubstitution() {
	    if (this.state.inType) return this.tsParseType();
	    return super.parseTemplateSubstitution();
	  }
	  tsParseThisTypeOrThisTypePredicate() {
	    const thisKeyword = this.tsParseThisTypeNode();
	    if (this.isContextual(116) && !this.hasPrecedingLineBreak()) {
	      return this.tsParseThisTypePredicate(thisKeyword);
	    } else {
	      return thisKeyword;
	    }
	  }
	  tsParseNonArrayType() {
	    switch (this.state.type) {
	      case 133:
	      case 134:
	      case 135:
	      case 85:
	      case 86:
	        return this.tsParseLiteralTypeNode();
	      case 53:
	        if (this.state.value === "-") {
	          const node = this.startNode();
	          const nextToken = this.lookahead();
	          if (nextToken.type !== 134 && nextToken.type !== 135) {
	            this.unexpected();
	          }
	          node.literal = this.parseMaybeUnary();
	          return this.finishNode(node, "TSLiteralType");
	        }
	        break;
	      case 78:
	        return this.tsParseThisTypeOrThisTypePredicate();
	      case 87:
	        return this.tsParseTypeQuery();
	      case 83:
	        return this.tsParseImportType();
	      case 5:
	        return this.tsLookAhead(this.tsIsStartOfMappedType.bind(this)) ? this.tsParseMappedType() : this.tsParseTypeLiteral();
	      case 0:
	        return this.tsParseTupleType();
	      case 10:
	        return this.tsParseParenthesizedType();
	      case 25:
	      case 24:
	        return this.tsParseTemplateLiteralType();
	      default:
	        {
	          const {
	            type
	          } = this.state;
	          if (tokenIsIdentifier(type) || type === 88 || type === 84) {
	            const nodeType = type === 88 ? "TSVoidKeyword" : type === 84 ? "TSNullKeyword" : keywordTypeFromName(this.state.value);
	            if (nodeType !== undefined && this.lookaheadCharCode() !== 46) {
	              const node = this.startNode();
	              this.next();
	              return this.finishNode(node, nodeType);
	            }
	            return this.tsParseTypeReference();
	          }
	        }
	    }
	    this.unexpected();
	  }
	  tsParseArrayTypeOrHigher() {
	    let type = this.tsParseNonArrayType();
	    while (!this.hasPrecedingLineBreak() && this.eat(0)) {
	      if (this.match(3)) {
	        const node = this.startNodeAtNode(type);
	        node.elementType = type;
	        this.expect(3);
	        type = this.finishNode(node, "TSArrayType");
	      } else {
	        const node = this.startNodeAtNode(type);
	        node.objectType = type;
	        node.indexType = this.tsParseType();
	        this.expect(3);
	        type = this.finishNode(node, "TSIndexedAccessType");
	      }
	    }
	    return type;
	  }
	  tsParseTypeOperator() {
	    const node = this.startNode();
	    const operator = this.state.value;
	    this.next();
	    node.operator = operator;
	    node.typeAnnotation = this.tsParseTypeOperatorOrHigher();
	    if (operator === "readonly") {
	      this.tsCheckTypeAnnotationForReadOnly(node);
	    }
	    return this.finishNode(node, "TSTypeOperator");
	  }
	  tsCheckTypeAnnotationForReadOnly(node) {
	    switch (node.typeAnnotation.type) {
	      case "TSTupleType":
	      case "TSArrayType":
	        return;
	      default:
	        this.raise(TSErrors.UnexpectedReadonly, node);
	    }
	  }
	  tsParseInferType() {
	    const node = this.startNode();
	    this.expectContextual(115);
	    const typeParameter = this.startNode();
	    typeParameter.name = this.tsParseTypeParameterName();
	    typeParameter.constraint = this.tsTryParse(() => this.tsParseConstraintForInferType());
	    node.typeParameter = this.finishNode(typeParameter, "TSTypeParameter");
	    return this.finishNode(node, "TSInferType");
	  }
	  tsParseConstraintForInferType() {
	    if (this.eat(81)) {
	      const constraint = this.tsInDisallowConditionalTypesContext(() => this.tsParseType());
	      if (this.state.inDisallowConditionalTypesContext || !this.match(17)) {
	        return constraint;
	      }
	    }
	  }
	  tsParseTypeOperatorOrHigher() {
	    const isTypeOperator = tokenIsTSTypeOperator(this.state.type) && !this.state.containsEsc;
	    return isTypeOperator ? this.tsParseTypeOperator() : this.isContextual(115) ? this.tsParseInferType() : this.tsInAllowConditionalTypesContext(() => this.tsParseArrayTypeOrHigher());
	  }
	  tsParseUnionOrIntersectionType(kind, parseConstituentType, operator) {
	    const node = this.startNode();
	    const hasLeadingOperator = this.eat(operator);
	    const types = [];
	    do {
	      types.push(parseConstituentType());
	    } while (this.eat(operator));
	    if (types.length === 1 && !hasLeadingOperator) {
	      return types[0];
	    }
	    node.types = types;
	    return this.finishNode(node, kind);
	  }
	  tsParseIntersectionTypeOrHigher() {
	    return this.tsParseUnionOrIntersectionType("TSIntersectionType", this.tsParseTypeOperatorOrHigher.bind(this), 45);
	  }
	  tsParseUnionTypeOrHigher() {
	    return this.tsParseUnionOrIntersectionType("TSUnionType", this.tsParseIntersectionTypeOrHigher.bind(this), 43);
	  }
	  tsIsStartOfFunctionType() {
	    if (this.match(47)) {
	      return true;
	    }
	    return this.match(10) && this.tsLookAhead(this.tsIsUnambiguouslyStartOfFunctionType.bind(this));
	  }
	  tsSkipParameterStart() {
	    if (tokenIsIdentifier(this.state.type) || this.match(78)) {
	      this.next();
	      return true;
	    }
	    if (this.match(5)) {
	      const {
	        errors
	      } = this.state;
	      const previousErrorCount = errors.length;
	      try {
	        this.parseObjectLike(8, true);
	        return errors.length === previousErrorCount;
	      } catch (_unused) {
	        return false;
	      }
	    }
	    if (this.match(0)) {
	      this.next();
	      const {
	        errors
	      } = this.state;
	      const previousErrorCount = errors.length;
	      try {
	        super.parseBindingList(3, 93, 1);
	        return errors.length === previousErrorCount;
	      } catch (_unused2) {
	        return false;
	      }
	    }
	    return false;
	  }
	  tsIsUnambiguouslyStartOfFunctionType() {
	    this.next();
	    if (this.match(11) || this.match(21)) {
	      return true;
	    }
	    if (this.tsSkipParameterStart()) {
	      if (this.match(14) || this.match(12) || this.match(17) || this.match(29)) {
	        return true;
	      }
	      if (this.match(11)) {
	        this.next();
	        if (this.match(19)) {
	          return true;
	        }
	      }
	    }
	    return false;
	  }
	  tsParseTypeOrTypePredicateAnnotation(returnToken) {
	    return this.tsInType(() => {
	      const t = this.startNode();
	      this.expect(returnToken);
	      const node = this.startNode();
	      const asserts = !!this.tsTryParse(this.tsParseTypePredicateAsserts.bind(this));
	      if (asserts && this.match(78)) {
	        let thisTypePredicate = this.tsParseThisTypeOrThisTypePredicate();
	        if (thisTypePredicate.type === "TSThisType") {
	          node.parameterName = thisTypePredicate;
	          node.asserts = true;
	          node.typeAnnotation = null;
	          thisTypePredicate = this.finishNode(node, "TSTypePredicate");
	        } else {
	          this.resetStartLocationFromNode(thisTypePredicate, node);
	          thisTypePredicate.asserts = true;
	        }
	        t.typeAnnotation = thisTypePredicate;
	        return this.finishNode(t, "TSTypeAnnotation");
	      }
	      const typePredicateVariable = this.tsIsIdentifier() && this.tsTryParse(this.tsParseTypePredicatePrefix.bind(this));
	      if (!typePredicateVariable) {
	        if (!asserts) {
	          return this.tsParseTypeAnnotation(false, t);
	        }
	        node.parameterName = this.parseIdentifier();
	        node.asserts = asserts;
	        node.typeAnnotation = null;
	        t.typeAnnotation = this.finishNode(node, "TSTypePredicate");
	        return this.finishNode(t, "TSTypeAnnotation");
	      }
	      const type = this.tsParseTypeAnnotation(false);
	      node.parameterName = typePredicateVariable;
	      node.typeAnnotation = type;
	      node.asserts = asserts;
	      t.typeAnnotation = this.finishNode(node, "TSTypePredicate");
	      return this.finishNode(t, "TSTypeAnnotation");
	    });
	  }
	  tsTryParseTypeOrTypePredicateAnnotation() {
	    if (this.match(14)) {
	      return this.tsParseTypeOrTypePredicateAnnotation(14);
	    }
	  }
	  tsTryParseTypeAnnotation() {
	    if (this.match(14)) {
	      return this.tsParseTypeAnnotation();
	    }
	  }
	  tsTryParseType() {
	    return this.tsEatThenParseType(14);
	  }
	  tsParseTypePredicatePrefix() {
	    const id = this.parseIdentifier();
	    if (this.isContextual(116) && !this.hasPrecedingLineBreak()) {
	      this.next();
	      return id;
	    }
	  }
	  tsParseTypePredicateAsserts() {
	    if (this.state.type !== 109) {
	      return false;
	    }
	    const containsEsc = this.state.containsEsc;
	    this.next();
	    if (!tokenIsIdentifier(this.state.type) && !this.match(78)) {
	      return false;
	    }
	    if (containsEsc) {
	      this.raise(Errors.InvalidEscapedReservedWord, this.state.lastTokStartLoc, {
	        reservedWord: "asserts"
	      });
	    }
	    return true;
	  }
	  tsParseTypeAnnotation(eatColon = true, t = this.startNode()) {
	    this.tsInType(() => {
	      if (eatColon) this.expect(14);
	      t.typeAnnotation = this.tsParseType();
	    });
	    return this.finishNode(t, "TSTypeAnnotation");
	  }
	  tsParseType() {
	    assert(this.state.inType);
	    const type = this.tsParseNonConditionalType();
	    if (this.state.inDisallowConditionalTypesContext || this.hasPrecedingLineBreak() || !this.eat(81)) {
	      return type;
	    }
	    const node = this.startNodeAtNode(type);
	    node.checkType = type;
	    node.extendsType = this.tsInDisallowConditionalTypesContext(() => this.tsParseNonConditionalType());
	    this.expect(17);
	    node.trueType = this.tsInAllowConditionalTypesContext(() => this.tsParseType());
	    this.expect(14);
	    node.falseType = this.tsInAllowConditionalTypesContext(() => this.tsParseType());
	    return this.finishNode(node, "TSConditionalType");
	  }
	  isAbstractConstructorSignature() {
	    return this.isContextual(124) && this.lookahead().type === 77;
	  }
	  tsParseNonConditionalType() {
	    if (this.tsIsStartOfFunctionType()) {
	      return this.tsParseFunctionOrConstructorType("TSFunctionType");
	    }
	    if (this.match(77)) {
	      return this.tsParseFunctionOrConstructorType("TSConstructorType");
	    } else if (this.isAbstractConstructorSignature()) {
	      return this.tsParseFunctionOrConstructorType("TSConstructorType", true);
	    }
	    return this.tsParseUnionTypeOrHigher();
	  }
	  tsParseTypeAssertion() {
	    if (this.getPluginOption("typescript", "disallowAmbiguousJSXLike")) {
	      this.raise(TSErrors.ReservedTypeAssertion, this.state.startLoc);
	    }
	    const node = this.startNode();
	    node.typeAnnotation = this.tsInType(() => {
	      this.next();
	      return this.match(75) ? this.tsParseTypeReference() : this.tsParseType();
	    });
	    this.expect(48);
	    node.expression = this.parseMaybeUnary();
	    return this.finishNode(node, "TSTypeAssertion");
	  }
	  tsParseHeritageClause(token) {
	    const originalStartLoc = this.state.startLoc;
	    const delimitedList = this.tsParseDelimitedList("HeritageClauseElement", () => {
	      const node = this.startNode();
	      node.expression = this.tsParseEntityName();
	      if (this.match(47)) {
	        node.typeParameters = this.tsParseTypeArguments();
	      }
	      return this.finishNode(node, "TSExpressionWithTypeArguments");
	    });
	    if (!delimitedList.length) {
	      this.raise(TSErrors.EmptyHeritageClauseType, originalStartLoc, {
	        token
	      });
	    }
	    return delimitedList;
	  }
	  tsParseInterfaceDeclaration(node, properties = {}) {
	    if (this.hasFollowingLineBreak()) return null;
	    this.expectContextual(129);
	    if (properties.declare) node.declare = true;
	    if (tokenIsIdentifier(this.state.type)) {
	      node.id = this.parseIdentifier();
	      this.checkIdentifier(node.id, 130);
	    } else {
	      node.id = null;
	      this.raise(TSErrors.MissingInterfaceName, this.state.startLoc);
	    }
	    node.typeParameters = this.tsTryParseTypeParameters(this.tsParseInOutConstModifiers);
	    if (this.eat(81)) {
	      node.extends = this.tsParseHeritageClause("extends");
	    }
	    const body = this.startNode();
	    body.body = this.tsInType(this.tsParseObjectTypeMembers.bind(this));
	    node.body = this.finishNode(body, "TSInterfaceBody");
	    return this.finishNode(node, "TSInterfaceDeclaration");
	  }
	  tsParseTypeAliasDeclaration(node) {
	    node.id = this.parseIdentifier();
	    this.checkIdentifier(node.id, 2);
	    node.typeAnnotation = this.tsInType(() => {
	      node.typeParameters = this.tsTryParseTypeParameters(this.tsParseInOutModifiers);
	      this.expect(29);
	      if (this.isContextual(114) && this.lookahead().type !== 16) {
	        const node = this.startNode();
	        this.next();
	        return this.finishNode(node, "TSIntrinsicKeyword");
	      }
	      return this.tsParseType();
	    });
	    this.semicolon();
	    return this.finishNode(node, "TSTypeAliasDeclaration");
	  }
	  tsInNoContext(cb) {
	    const oldContext = this.state.context;
	    this.state.context = [oldContext[0]];
	    try {
	      return cb();
	    } finally {
	      this.state.context = oldContext;
	    }
	  }
	  tsInType(cb) {
	    const oldInType = this.state.inType;
	    this.state.inType = true;
	    try {
	      return cb();
	    } finally {
	      this.state.inType = oldInType;
	    }
	  }
	  tsInDisallowConditionalTypesContext(cb) {
	    const oldInDisallowConditionalTypesContext = this.state.inDisallowConditionalTypesContext;
	    this.state.inDisallowConditionalTypesContext = true;
	    try {
	      return cb();
	    } finally {
	      this.state.inDisallowConditionalTypesContext = oldInDisallowConditionalTypesContext;
	    }
	  }
	  tsInAllowConditionalTypesContext(cb) {
	    const oldInDisallowConditionalTypesContext = this.state.inDisallowConditionalTypesContext;
	    this.state.inDisallowConditionalTypesContext = false;
	    try {
	      return cb();
	    } finally {
	      this.state.inDisallowConditionalTypesContext = oldInDisallowConditionalTypesContext;
	    }
	  }
	  tsEatThenParseType(token) {
	    if (this.match(token)) {
	      return this.tsNextThenParseType();
	    }
	  }
	  tsExpectThenParseType(token) {
	    return this.tsInType(() => {
	      this.expect(token);
	      return this.tsParseType();
	    });
	  }
	  tsNextThenParseType() {
	    return this.tsInType(() => {
	      this.next();
	      return this.tsParseType();
	    });
	  }
	  tsParseEnumMember() {
	    const node = this.startNode();
	    node.id = this.match(133) ? super.parseStringLiteral(this.state.value) : this.parseIdentifier(true);
	    if (this.eat(29)) {
	      node.initializer = super.parseMaybeAssignAllowIn();
	    }
	    return this.finishNode(node, "TSEnumMember");
	  }
	  tsParseEnumDeclaration(node, properties = {}) {
	    if (properties.const) node.const = true;
	    if (properties.declare) node.declare = true;
	    this.expectContextual(126);
	    node.id = this.parseIdentifier();
	    this.checkIdentifier(node.id, node.const ? 8971 : 8459);
	    this.expect(5);
	    node.members = this.tsParseDelimitedList("EnumMembers", this.tsParseEnumMember.bind(this));
	    this.expect(8);
	    return this.finishNode(node, "TSEnumDeclaration");
	  }
	  tsParseModuleBlock() {
	    const node = this.startNode();
	    this.scope.enter(0);
	    this.expect(5);
	    super.parseBlockOrModuleBlockBody(node.body = [], undefined, true, 8);
	    this.scope.exit();
	    return this.finishNode(node, "TSModuleBlock");
	  }
	  tsParseModuleOrNamespaceDeclaration(node, nested = false) {
	    node.id = this.parseIdentifier();
	    if (!nested) {
	      this.checkIdentifier(node.id, 1024);
	    }
	    if (this.eat(16)) {
	      const inner = this.startNode();
	      this.tsParseModuleOrNamespaceDeclaration(inner, true);
	      node.body = inner;
	    } else {
	      this.scope.enter(256);
	      this.prodParam.enter(0);
	      node.body = this.tsParseModuleBlock();
	      this.prodParam.exit();
	      this.scope.exit();
	    }
	    return this.finishNode(node, "TSModuleDeclaration");
	  }
	  tsParseAmbientExternalModuleDeclaration(node) {
	    if (this.isContextual(112)) {
	      node.global = true;
	      node.id = this.parseIdentifier();
	    } else if (this.match(133)) {
	      node.id = super.parseStringLiteral(this.state.value);
	    } else {
	      this.unexpected();
	    }
	    if (this.match(5)) {
	      this.scope.enter(256);
	      this.prodParam.enter(0);
	      node.body = this.tsParseModuleBlock();
	      this.prodParam.exit();
	      this.scope.exit();
	    } else {
	      this.semicolon();
	    }
	    return this.finishNode(node, "TSModuleDeclaration");
	  }
	  tsParseImportEqualsDeclaration(node, maybeDefaultIdentifier, isExport) {
	    node.isExport = isExport || false;
	    node.id = maybeDefaultIdentifier || this.parseIdentifier();
	    this.checkIdentifier(node.id, 4096);
	    this.expect(29);
	    const moduleReference = this.tsParseModuleReference();
	    if (node.importKind === "type" && moduleReference.type !== "TSExternalModuleReference") {
	      this.raise(TSErrors.ImportAliasHasImportType, moduleReference);
	    }
	    node.moduleReference = moduleReference;
	    this.semicolon();
	    return this.finishNode(node, "TSImportEqualsDeclaration");
	  }
	  tsIsExternalModuleReference() {
	    return this.isContextual(119) && this.lookaheadCharCode() === 40;
	  }
	  tsParseModuleReference() {
	    return this.tsIsExternalModuleReference() ? this.tsParseExternalModuleReference() : this.tsParseEntityName(false);
	  }
	  tsParseExternalModuleReference() {
	    const node = this.startNode();
	    this.expectContextual(119);
	    this.expect(10);
	    if (!this.match(133)) {
	      this.unexpected();
	    }
	    node.expression = super.parseExprAtom();
	    this.expect(11);
	    this.sawUnambiguousESM = true;
	    return this.finishNode(node, "TSExternalModuleReference");
	  }
	  tsLookAhead(f) {
	    const state = this.state.clone();
	    const res = f();
	    this.state = state;
	    return res;
	  }
	  tsTryParseAndCatch(f) {
	    const result = this.tryParse(abort => f() || abort());
	    if (result.aborted || !result.node) return;
	    if (result.error) this.state = result.failState;
	    return result.node;
	  }
	  tsTryParse(f) {
	    const state = this.state.clone();
	    const result = f();
	    if (result !== undefined && result !== false) {
	      return result;
	    }
	    this.state = state;
	  }
	  tsTryParseDeclare(nany) {
	    if (this.isLineTerminator()) {
	      return;
	    }
	    let startType = this.state.type;
	    let kind;
	    if (this.isContextual(100)) {
	      startType = 74;
	      kind = "let";
	    }
	    return this.tsInAmbientContext(() => {
	      switch (startType) {
	        case 68:
	          nany.declare = true;
	          return super.parseFunctionStatement(nany, false, false);
	        case 80:
	          nany.declare = true;
	          return this.parseClass(nany, true, false);
	        case 126:
	          return this.tsParseEnumDeclaration(nany, {
	            declare: true
	          });
	        case 112:
	          return this.tsParseAmbientExternalModuleDeclaration(nany);
	        case 75:
	        case 74:
	          if (!this.match(75) || !this.isLookaheadContextual("enum")) {
	            nany.declare = true;
	            return this.parseVarStatement(nany, kind || this.state.value, true);
	          }
	          this.expect(75);
	          return this.tsParseEnumDeclaration(nany, {
	            const: true,
	            declare: true
	          });
	        case 129:
	          {
	            const result = this.tsParseInterfaceDeclaration(nany, {
	              declare: true
	            });
	            if (result) return result;
	          }
	        default:
	          if (tokenIsIdentifier(startType)) {
	            return this.tsParseDeclaration(nany, this.state.value, true, null);
	          }
	      }
	    });
	  }
	  tsTryParseExportDeclaration() {
	    return this.tsParseDeclaration(this.startNode(), this.state.value, true, null);
	  }
	  tsParseExpressionStatement(node, expr, decorators) {
	    switch (expr.name) {
	      case "declare":
	        {
	          const declaration = this.tsTryParseDeclare(node);
	          if (declaration) {
	            declaration.declare = true;
	          }
	          return declaration;
	        }
	      case "global":
	        if (this.match(5)) {
	          this.scope.enter(256);
	          this.prodParam.enter(0);
	          const mod = node;
	          mod.global = true;
	          mod.id = expr;
	          mod.body = this.tsParseModuleBlock();
	          this.scope.exit();
	          this.prodParam.exit();
	          return this.finishNode(mod, "TSModuleDeclaration");
	        }
	        break;
	      default:
	        return this.tsParseDeclaration(node, expr.name, false, decorators);
	    }
	  }
	  tsParseDeclaration(node, value, next, decorators) {
	    switch (value) {
	      case "abstract":
	        if (this.tsCheckLineTerminator(next) && (this.match(80) || tokenIsIdentifier(this.state.type))) {
	          return this.tsParseAbstractDeclaration(node, decorators);
	        }
	        break;
	      case "module":
	        if (this.tsCheckLineTerminator(next)) {
	          if (this.match(133)) {
	            return this.tsParseAmbientExternalModuleDeclaration(node);
	          } else if (tokenIsIdentifier(this.state.type)) {
	            return this.tsParseModuleOrNamespaceDeclaration(node);
	          }
	        }
	        break;
	      case "namespace":
	        if (this.tsCheckLineTerminator(next) && tokenIsIdentifier(this.state.type)) {
	          return this.tsParseModuleOrNamespaceDeclaration(node);
	        }
	        break;
	      case "type":
	        if (this.tsCheckLineTerminator(next) && tokenIsIdentifier(this.state.type)) {
	          return this.tsParseTypeAliasDeclaration(node);
	        }
	        break;
	    }
	  }
	  tsCheckLineTerminator(next) {
	    if (next) {
	      if (this.hasFollowingLineBreak()) return false;
	      this.next();
	      return true;
	    }
	    return !this.isLineTerminator();
	  }
	  tsTryParseGenericAsyncArrowFunction(startLoc) {
	    if (!this.match(47)) return;
	    const oldMaybeInArrowParameters = this.state.maybeInArrowParameters;
	    this.state.maybeInArrowParameters = true;
	    const res = this.tsTryParseAndCatch(() => {
	      const node = this.startNodeAt(startLoc);
	      node.typeParameters = this.tsParseTypeParameters(this.tsParseConstModifier);
	      super.parseFunctionParams(node);
	      node.returnType = this.tsTryParseTypeOrTypePredicateAnnotation();
	      this.expect(19);
	      return node;
	    });
	    this.state.maybeInArrowParameters = oldMaybeInArrowParameters;
	    if (!res) return;
	    return super.parseArrowExpression(res, null, true);
	  }
	  tsParseTypeArgumentsInExpression() {
	    if (this.reScan_lt() !== 47) return;
	    return this.tsParseTypeArguments();
	  }
	  tsParseTypeArguments() {
	    const node = this.startNode();
	    node.params = this.tsInType(() => this.tsInNoContext(() => {
	      this.expect(47);
	      return this.tsParseDelimitedList("TypeParametersOrArguments", this.tsParseType.bind(this));
	    }));
	    if (node.params.length === 0) {
	      this.raise(TSErrors.EmptyTypeArguments, node);
	    } else if (!this.state.inType && this.curContext() === types.brace) {
	      this.reScan_lt_gt();
	    }
	    this.expect(48);
	    return this.finishNode(node, "TSTypeParameterInstantiation");
	  }
	  tsIsDeclarationStart() {
	    return tokenIsTSDeclarationStart(this.state.type);
	  }
	  isExportDefaultSpecifier() {
	    if (this.tsIsDeclarationStart()) return false;
	    return super.isExportDefaultSpecifier();
	  }
	  parseAssignableListItem(flags, decorators) {
	    const startLoc = this.state.startLoc;
	    const modified = {};
	    this.tsParseModifiers({
	      allowedModifiers: ["public", "private", "protected", "override", "readonly"]
	    }, modified);
	    const accessibility = modified.accessibility;
	    const override = modified.override;
	    const readonly = modified.readonly;
	    if (!(flags & 4) && (accessibility || readonly || override)) {
	      this.raise(TSErrors.UnexpectedParameterModifier, startLoc);
	    }
	    const left = this.parseMaybeDefault();
	    this.parseAssignableListItemTypes(left, flags);
	    const elt = this.parseMaybeDefault(left.loc.start, left);
	    if (accessibility || readonly || override) {
	      const pp = this.startNodeAt(startLoc);
	      if (decorators.length) {
	        pp.decorators = decorators;
	      }
	      if (accessibility) pp.accessibility = accessibility;
	      if (readonly) pp.readonly = readonly;
	      if (override) pp.override = override;
	      if (elt.type !== "Identifier" && elt.type !== "AssignmentPattern") {
	        this.raise(TSErrors.UnsupportedParameterPropertyKind, pp);
	      }
	      pp.parameter = elt;
	      return this.finishNode(pp, "TSParameterProperty");
	    }
	    if (decorators.length) {
	      left.decorators = decorators;
	    }
	    return elt;
	  }
	  isSimpleParameter(node) {
	    return node.type === "TSParameterProperty" && super.isSimpleParameter(node.parameter) || super.isSimpleParameter(node);
	  }
	  tsDisallowOptionalPattern(node) {
	    for (const param of node.params) {
	      if (param.type !== "Identifier" && param.optional && !this.state.isAmbientContext) {
	        this.raise(TSErrors.PatternIsOptional, param);
	      }
	    }
	  }
	  setArrowFunctionParameters(node, params, trailingCommaLoc) {
	    super.setArrowFunctionParameters(node, params, trailingCommaLoc);
	    this.tsDisallowOptionalPattern(node);
	  }
	  parseFunctionBodyAndFinish(node, type, isMethod = false) {
	    if (this.match(14)) {
	      node.returnType = this.tsParseTypeOrTypePredicateAnnotation(14);
	    }
	    const bodilessType = type === "FunctionDeclaration" ? "TSDeclareFunction" : type === "ClassMethod" || type === "ClassPrivateMethod" ? "TSDeclareMethod" : undefined;
	    if (bodilessType && !this.match(5) && this.isLineTerminator()) {
	      return this.finishNode(node, bodilessType);
	    }
	    if (bodilessType === "TSDeclareFunction" && this.state.isAmbientContext) {
	      this.raise(TSErrors.DeclareFunctionHasImplementation, node);
	      if (node.declare) {
	        return super.parseFunctionBodyAndFinish(node, bodilessType, isMethod);
	      }
	    }
	    this.tsDisallowOptionalPattern(node);
	    return super.parseFunctionBodyAndFinish(node, type, isMethod);
	  }
	  registerFunctionStatementId(node) {
	    if (!node.body && node.id) {
	      this.checkIdentifier(node.id, 1024);
	    } else {
	      super.registerFunctionStatementId(node);
	    }
	  }
	  tsCheckForInvalidTypeCasts(items) {
	    items.forEach(node => {
	      if ((node == null ? void 0 : node.type) === "TSTypeCastExpression") {
	        this.raise(TSErrors.UnexpectedTypeAnnotation, node.typeAnnotation);
	      }
	    });
	  }
	  toReferencedList(exprList, isInParens) {
	    this.tsCheckForInvalidTypeCasts(exprList);
	    return exprList;
	  }
	  parseArrayLike(close, canBePattern, isTuple, refExpressionErrors) {
	    const node = super.parseArrayLike(close, canBePattern, isTuple, refExpressionErrors);
	    if (node.type === "ArrayExpression") {
	      this.tsCheckForInvalidTypeCasts(node.elements);
	    }
	    return node;
	  }
	  parseSubscript(base, startLoc, noCalls, state) {
	    if (!this.hasPrecedingLineBreak() && this.match(35)) {
	      this.state.canStartJSXElement = false;
	      this.next();
	      const nonNullExpression = this.startNodeAt(startLoc);
	      nonNullExpression.expression = base;
	      return this.finishNode(nonNullExpression, "TSNonNullExpression");
	    }
	    let isOptionalCall = false;
	    if (this.match(18) && this.lookaheadCharCode() === 60) {
	      if (noCalls) {
	        state.stop = true;
	        return base;
	      }
	      state.optionalChainMember = isOptionalCall = true;
	      this.next();
	    }
	    if (this.match(47) || this.match(51)) {
	      let missingParenErrorLoc;
	      const result = this.tsTryParseAndCatch(() => {
	        if (!noCalls && this.atPossibleAsyncArrow(base)) {
	          const asyncArrowFn = this.tsTryParseGenericAsyncArrowFunction(startLoc);
	          if (asyncArrowFn) {
	            return asyncArrowFn;
	          }
	        }
	        const typeArguments = this.tsParseTypeArgumentsInExpression();
	        if (!typeArguments) return;
	        if (isOptionalCall && !this.match(10)) {
	          missingParenErrorLoc = this.state.curPosition();
	          return;
	        }
	        if (tokenIsTemplate(this.state.type)) {
	          const result = super.parseTaggedTemplateExpression(base, startLoc, state);
	          result.typeParameters = typeArguments;
	          return result;
	        }
	        if (!noCalls && this.eat(10)) {
	          const node = this.startNodeAt(startLoc);
	          node.callee = base;
	          node.arguments = this.parseCallExpressionArguments(11, false);
	          this.tsCheckForInvalidTypeCasts(node.arguments);
	          node.typeParameters = typeArguments;
	          if (state.optionalChainMember) {
	            node.optional = isOptionalCall;
	          }
	          return this.finishCallExpression(node, state.optionalChainMember);
	        }
	        const tokenType = this.state.type;
	        if (tokenType === 48 || tokenType === 52 || tokenType !== 10 && tokenCanStartExpression(tokenType) && !this.hasPrecedingLineBreak()) {
	          return;
	        }
	        const node = this.startNodeAt(startLoc);
	        node.expression = base;
	        node.typeParameters = typeArguments;
	        return this.finishNode(node, "TSInstantiationExpression");
	      });
	      if (missingParenErrorLoc) {
	        this.unexpected(missingParenErrorLoc, 10);
	      }
	      if (result) {
	        if (result.type === "TSInstantiationExpression" && (this.match(16) || this.match(18) && this.lookaheadCharCode() !== 40)) {
	          this.raise(TSErrors.InvalidPropertyAccessAfterInstantiationExpression, this.state.startLoc);
	        }
	        return result;
	      }
	    }
	    return super.parseSubscript(base, startLoc, noCalls, state);
	  }
	  parseNewCallee(node) {
	    var _callee$extra;
	    super.parseNewCallee(node);
	    const {
	      callee
	    } = node;
	    if (callee.type === "TSInstantiationExpression" && !((_callee$extra = callee.extra) != null && _callee$extra.parenthesized)) {
	      node.typeParameters = callee.typeParameters;
	      node.callee = callee.expression;
	    }
	  }
	  parseExprOp(left, leftStartLoc, minPrec) {
	    let isSatisfies;
	    if (tokenOperatorPrecedence(58) > minPrec && !this.hasPrecedingLineBreak() && (this.isContextual(93) || (isSatisfies = this.isContextual(120)))) {
	      const node = this.startNodeAt(leftStartLoc);
	      node.expression = left;
	      node.typeAnnotation = this.tsInType(() => {
	        this.next();
	        if (this.match(75)) {
	          if (isSatisfies) {
	            this.raise(Errors.UnexpectedKeyword, this.state.startLoc, {
	              keyword: "const"
	            });
	          }
	          return this.tsParseTypeReference();
	        }
	        return this.tsParseType();
	      });
	      this.finishNode(node, isSatisfies ? "TSSatisfiesExpression" : "TSAsExpression");
	      this.reScan_lt_gt();
	      return this.parseExprOp(node, leftStartLoc, minPrec);
	    }
	    return super.parseExprOp(left, leftStartLoc, minPrec);
	  }
	  checkReservedWord(word, startLoc, checkKeywords, isBinding) {
	    if (!this.state.isAmbientContext) {
	      super.checkReservedWord(word, startLoc, checkKeywords, isBinding);
	    }
	  }
	  checkImportReflection(node) {
	    super.checkImportReflection(node);
	    if (node.module && node.importKind !== "value") {
	      this.raise(TSErrors.ImportReflectionHasImportType, node.specifiers[0].loc.start);
	    }
	  }
	  checkDuplicateExports() {}
	  isPotentialImportPhase(isExport) {
	    if (super.isPotentialImportPhase(isExport)) return true;
	    if (this.isContextual(130)) {
	      const ch = this.lookaheadCharCode();
	      return isExport ? ch === 123 || ch === 42 : ch !== 61;
	    }
	    return !isExport && this.isContextual(87);
	  }
	  applyImportPhase(node, isExport, phase, loc) {
	    super.applyImportPhase(node, isExport, phase, loc);
	    if (isExport) {
	      node.exportKind = phase === "type" ? "type" : "value";
	    } else {
	      node.importKind = phase === "type" || phase === "typeof" ? phase : "value";
	    }
	  }
	  parseImport(node) {
	    if (this.match(133)) {
	      node.importKind = "value";
	      return super.parseImport(node);
	    }
	    let importNode;
	    if (tokenIsIdentifier(this.state.type) && this.lookaheadCharCode() === 61) {
	      node.importKind = "value";
	      return this.tsParseImportEqualsDeclaration(node);
	    } else if (this.isContextual(130)) {
	      const maybeDefaultIdentifier = this.parseMaybeImportPhase(node, false);
	      if (this.lookaheadCharCode() === 61) {
	        return this.tsParseImportEqualsDeclaration(node, maybeDefaultIdentifier);
	      } else {
	        importNode = super.parseImportSpecifiersAndAfter(node, maybeDefaultIdentifier);
	      }
	    } else {
	      importNode = super.parseImport(node);
	    }
	    if (importNode.importKind === "type" && importNode.specifiers.length > 1 && importNode.specifiers[0].type === "ImportDefaultSpecifier") {
	      this.raise(TSErrors.TypeImportCannotSpecifyDefaultAndNamed, importNode);
	    }
	    return importNode;
	  }
	  parseExport(node, decorators) {
	    if (this.match(83)) {
	      this.next();
	      const nodeImportEquals = node;
	      let maybeDefaultIdentifier = null;
	      if (this.isContextual(130) && this.isPotentialImportPhase(false)) {
	        maybeDefaultIdentifier = this.parseMaybeImportPhase(nodeImportEquals, false);
	      } else {
	        nodeImportEquals.importKind = "value";
	      }
	      return this.tsParseImportEqualsDeclaration(nodeImportEquals, maybeDefaultIdentifier, true);
	    } else if (this.eat(29)) {
	      const assign = node;
	      assign.expression = super.parseExpression();
	      this.semicolon();
	      this.sawUnambiguousESM = true;
	      return this.finishNode(assign, "TSExportAssignment");
	    } else if (this.eatContextual(93)) {
	      const decl = node;
	      this.expectContextual(128);
	      decl.id = this.parseIdentifier();
	      this.semicolon();
	      return this.finishNode(decl, "TSNamespaceExportDeclaration");
	    } else {
	      return super.parseExport(node, decorators);
	    }
	  }
	  isAbstractClass() {
	    return this.isContextual(124) && this.lookahead().type === 80;
	  }
	  parseExportDefaultExpression() {
	    if (this.isAbstractClass()) {
	      const cls = this.startNode();
	      this.next();
	      cls.abstract = true;
	      return this.parseClass(cls, true, true);
	    }
	    if (this.match(129)) {
	      const result = this.tsParseInterfaceDeclaration(this.startNode());
	      if (result) return result;
	    }
	    return super.parseExportDefaultExpression();
	  }
	  parseVarStatement(node, kind, allowMissingInitializer = false) {
	    const {
	      isAmbientContext
	    } = this.state;
	    const declaration = super.parseVarStatement(node, kind, allowMissingInitializer || isAmbientContext);
	    if (!isAmbientContext) return declaration;
	    for (const {
	      id,
	      init
	    } of declaration.declarations) {
	      if (!init) continue;
	      if (kind !== "const" || !!id.typeAnnotation) {
	        this.raise(TSErrors.InitializerNotAllowedInAmbientContext, init);
	      } else if (!isValidAmbientConstInitializer(init, this.hasPlugin("estree"))) {
	        this.raise(TSErrors.ConstInitiailizerMustBeStringOrNumericLiteralOrLiteralEnumReference, init);
	      }
	    }
	    return declaration;
	  }
	  parseStatementContent(flags, decorators) {
	    if (this.match(75) && this.isLookaheadContextual("enum")) {
	      const node = this.startNode();
	      this.expect(75);
	      return this.tsParseEnumDeclaration(node, {
	        const: true
	      });
	    }
	    if (this.isContextual(126)) {
	      return this.tsParseEnumDeclaration(this.startNode());
	    }
	    if (this.isContextual(129)) {
	      const result = this.tsParseInterfaceDeclaration(this.startNode());
	      if (result) return result;
	    }
	    return super.parseStatementContent(flags, decorators);
	  }
	  parseAccessModifier() {
	    return this.tsParseModifier(["public", "protected", "private"]);
	  }
	  tsHasSomeModifiers(member, modifiers) {
	    return modifiers.some(modifier => {
	      if (tsIsAccessModifier(modifier)) {
	        return member.accessibility === modifier;
	      }
	      return !!member[modifier];
	    });
	  }
	  tsIsStartOfStaticBlocks() {
	    return this.isContextual(106) && this.lookaheadCharCode() === 123;
	  }
	  parseClassMember(classBody, member, state) {
	    const modifiers = ["declare", "private", "public", "protected", "override", "abstract", "readonly", "static"];
	    this.tsParseModifiers({
	      allowedModifiers: modifiers,
	      disallowedModifiers: ["in", "out"],
	      stopOnStartOfClassStaticBlock: true,
	      errorTemplate: TSErrors.InvalidModifierOnTypeParameterPositions
	    }, member);
	    const callParseClassMemberWithIsStatic = () => {
	      if (this.tsIsStartOfStaticBlocks()) {
	        this.next();
	        this.next();
	        if (this.tsHasSomeModifiers(member, modifiers)) {
	          this.raise(TSErrors.StaticBlockCannotHaveModifier, this.state.curPosition());
	        }
	        super.parseClassStaticBlock(classBody, member);
	      } else {
	        this.parseClassMemberWithIsStatic(classBody, member, state, !!member.static);
	      }
	    };
	    if (member.declare) {
	      this.tsInAmbientContext(callParseClassMemberWithIsStatic);
	    } else {
	      callParseClassMemberWithIsStatic();
	    }
	  }
	  parseClassMemberWithIsStatic(classBody, member, state, isStatic) {
	    const idx = this.tsTryParseIndexSignature(member);
	    if (idx) {
	      classBody.body.push(idx);
	      if (member.abstract) {
	        this.raise(TSErrors.IndexSignatureHasAbstract, member);
	      }
	      if (member.accessibility) {
	        this.raise(TSErrors.IndexSignatureHasAccessibility, member, {
	          modifier: member.accessibility
	        });
	      }
	      if (member.declare) {
	        this.raise(TSErrors.IndexSignatureHasDeclare, member);
	      }
	      if (member.override) {
	        this.raise(TSErrors.IndexSignatureHasOverride, member);
	      }
	      return;
	    }
	    if (!this.state.inAbstractClass && member.abstract) {
	      this.raise(TSErrors.NonAbstractClassHasAbstractMethod, member);
	    }
	    if (member.override) {
	      if (!state.hadSuperClass) {
	        this.raise(TSErrors.OverrideNotInSubClass, member);
	      }
	    }
	    super.parseClassMemberWithIsStatic(classBody, member, state, isStatic);
	  }
	  parsePostMemberNameModifiers(methodOrProp) {
	    const optional = this.eat(17);
	    if (optional) methodOrProp.optional = true;
	    if (methodOrProp.readonly && this.match(10)) {
	      this.raise(TSErrors.ClassMethodHasReadonly, methodOrProp);
	    }
	    if (methodOrProp.declare && this.match(10)) {
	      this.raise(TSErrors.ClassMethodHasDeclare, methodOrProp);
	    }
	  }
	  parseExpressionStatement(node, expr, decorators) {
	    const decl = expr.type === "Identifier" ? this.tsParseExpressionStatement(node, expr, decorators) : undefined;
	    return decl || super.parseExpressionStatement(node, expr, decorators);
	  }
	  shouldParseExportDeclaration() {
	    if (this.tsIsDeclarationStart()) return true;
	    return super.shouldParseExportDeclaration();
	  }
	  parseConditional(expr, startLoc, refExpressionErrors) {
	    if (!this.state.maybeInArrowParameters || !this.match(17)) {
	      return super.parseConditional(expr, startLoc, refExpressionErrors);
	    }
	    const result = this.tryParse(() => super.parseConditional(expr, startLoc));
	    if (!result.node) {
	      if (result.error) {
	        super.setOptionalParametersError(refExpressionErrors, result.error);
	      }
	      return expr;
	    }
	    if (result.error) this.state = result.failState;
	    return result.node;
	  }
	  parseParenItem(node, startLoc) {
	    const newNode = super.parseParenItem(node, startLoc);
	    if (this.eat(17)) {
	      newNode.optional = true;
	      this.resetEndLocation(node);
	    }
	    if (this.match(14)) {
	      const typeCastNode = this.startNodeAt(startLoc);
	      typeCastNode.expression = node;
	      typeCastNode.typeAnnotation = this.tsParseTypeAnnotation();
	      return this.finishNode(typeCastNode, "TSTypeCastExpression");
	    }
	    return node;
	  }
	  parseExportDeclaration(node) {
	    if (!this.state.isAmbientContext && this.isContextual(125)) {
	      return this.tsInAmbientContext(() => this.parseExportDeclaration(node));
	    }
	    const startLoc = this.state.startLoc;
	    const isDeclare = this.eatContextual(125);
	    if (isDeclare && (this.isContextual(125) || !this.shouldParseExportDeclaration())) {
	      throw this.raise(TSErrors.ExpectedAmbientAfterExportDeclare, this.state.startLoc);
	    }
	    const isIdentifier = tokenIsIdentifier(this.state.type);
	    const declaration = isIdentifier && this.tsTryParseExportDeclaration() || super.parseExportDeclaration(node);
	    if (!declaration) return null;
	    if (declaration.type === "TSInterfaceDeclaration" || declaration.type === "TSTypeAliasDeclaration" || isDeclare) {
	      node.exportKind = "type";
	    }
	    if (isDeclare) {
	      this.resetStartLocation(declaration, startLoc);
	      declaration.declare = true;
	    }
	    return declaration;
	  }
	  parseClassId(node, isStatement, optionalId, bindingType) {
	    if ((!isStatement || optionalId) && this.isContextual(113)) {
	      return;
	    }
	    super.parseClassId(node, isStatement, optionalId, node.declare ? 1024 : 8331);
	    const typeParameters = this.tsTryParseTypeParameters(this.tsParseInOutConstModifiers);
	    if (typeParameters) node.typeParameters = typeParameters;
	  }
	  parseClassPropertyAnnotation(node) {
	    if (!node.optional) {
	      if (this.eat(35)) {
	        node.definite = true;
	      } else if (this.eat(17)) {
	        node.optional = true;
	      }
	    }
	    const type = this.tsTryParseTypeAnnotation();
	    if (type) node.typeAnnotation = type;
	  }
	  parseClassProperty(node) {
	    this.parseClassPropertyAnnotation(node);
	    if (this.state.isAmbientContext && !(node.readonly && !node.typeAnnotation) && this.match(29)) {
	      this.raise(TSErrors.DeclareClassFieldHasInitializer, this.state.startLoc);
	    }
	    if (node.abstract && this.match(29)) {
	      const {
	        key
	      } = node;
	      this.raise(TSErrors.AbstractPropertyHasInitializer, this.state.startLoc, {
	        propertyName: key.type === "Identifier" && !node.computed ? key.name : `[${this.input.slice(key.start, key.end)}]`
	      });
	    }
	    return super.parseClassProperty(node);
	  }
	  parseClassPrivateProperty(node) {
	    if (node.abstract) {
	      this.raise(TSErrors.PrivateElementHasAbstract, node);
	    }
	    if (node.accessibility) {
	      this.raise(TSErrors.PrivateElementHasAccessibility, node, {
	        modifier: node.accessibility
	      });
	    }
	    this.parseClassPropertyAnnotation(node);
	    return super.parseClassPrivateProperty(node);
	  }
	  parseClassAccessorProperty(node) {
	    this.parseClassPropertyAnnotation(node);
	    if (node.optional) {
	      this.raise(TSErrors.AccessorCannotBeOptional, node);
	    }
	    return super.parseClassAccessorProperty(node);
	  }
	  pushClassMethod(classBody, method, isGenerator, isAsync, isConstructor, allowsDirectSuper) {
	    const typeParameters = this.tsTryParseTypeParameters(this.tsParseConstModifier);
	    if (typeParameters && isConstructor) {
	      this.raise(TSErrors.ConstructorHasTypeParameters, typeParameters);
	    }
	    const {
	      declare = false,
	      kind
	    } = method;
	    if (declare && (kind === "get" || kind === "set")) {
	      this.raise(TSErrors.DeclareAccessor, method, {
	        kind
	      });
	    }
	    if (typeParameters) method.typeParameters = typeParameters;
	    super.pushClassMethod(classBody, method, isGenerator, isAsync, isConstructor, allowsDirectSuper);
	  }
	  pushClassPrivateMethod(classBody, method, isGenerator, isAsync) {
	    const typeParameters = this.tsTryParseTypeParameters(this.tsParseConstModifier);
	    if (typeParameters) method.typeParameters = typeParameters;
	    super.pushClassPrivateMethod(classBody, method, isGenerator, isAsync);
	  }
	  declareClassPrivateMethodInScope(node, kind) {
	    if (node.type === "TSDeclareMethod") return;
	    if (node.type === "MethodDefinition" && !hasOwnProperty.call(node.value, "body")) {
	      return;
	    }
	    super.declareClassPrivateMethodInScope(node, kind);
	  }
	  parseClassSuper(node) {
	    super.parseClassSuper(node);
	    if (node.superClass && (this.match(47) || this.match(51))) {
	      node.superTypeParameters = this.tsParseTypeArgumentsInExpression();
	    }
	    if (this.eatContextual(113)) {
	      node.implements = this.tsParseHeritageClause("implements");
	    }
	  }
	  parseObjPropValue(prop, startLoc, isGenerator, isAsync, isPattern, isAccessor, refExpressionErrors) {
	    const typeParameters = this.tsTryParseTypeParameters(this.tsParseConstModifier);
	    if (typeParameters) prop.typeParameters = typeParameters;
	    return super.parseObjPropValue(prop, startLoc, isGenerator, isAsync, isPattern, isAccessor, refExpressionErrors);
	  }
	  parseFunctionParams(node, isConstructor) {
	    const typeParameters = this.tsTryParseTypeParameters(this.tsParseConstModifier);
	    if (typeParameters) node.typeParameters = typeParameters;
	    super.parseFunctionParams(node, isConstructor);
	  }
	  parseVarId(decl, kind) {
	    super.parseVarId(decl, kind);
	    if (decl.id.type === "Identifier" && !this.hasPrecedingLineBreak() && this.eat(35)) {
	      decl.definite = true;
	    }
	    const type = this.tsTryParseTypeAnnotation();
	    if (type) {
	      decl.id.typeAnnotation = type;
	      this.resetEndLocation(decl.id);
	    }
	  }
	  parseAsyncArrowFromCallExpression(node, call) {
	    if (this.match(14)) {
	      node.returnType = this.tsParseTypeAnnotation();
	    }
	    return super.parseAsyncArrowFromCallExpression(node, call);
	  }
	  parseMaybeAssign(refExpressionErrors, afterLeftParse) {
	    var _jsx, _jsx2, _typeCast, _jsx3, _typeCast2;
	    let state;
	    let jsx;
	    let typeCast;
	    if (this.hasPlugin("jsx") && (this.match(142) || this.match(47))) {
	      state = this.state.clone();
	      jsx = this.tryParse(() => super.parseMaybeAssign(refExpressionErrors, afterLeftParse), state);
	      if (!jsx.error) return jsx.node;
	      const {
	        context
	      } = this.state;
	      const currentContext = context[context.length - 1];
	      if (currentContext === types.j_oTag || currentContext === types.j_expr) {
	        context.pop();
	      }
	    }
	    if (!((_jsx = jsx) != null && _jsx.error) && !this.match(47)) {
	      return super.parseMaybeAssign(refExpressionErrors, afterLeftParse);
	    }
	    if (!state || state === this.state) state = this.state.clone();
	    let typeParameters;
	    const arrow = this.tryParse(abort => {
	      var _expr$extra, _typeParameters;
	      typeParameters = this.tsParseTypeParameters(this.tsParseConstModifier);
	      const expr = super.parseMaybeAssign(refExpressionErrors, afterLeftParse);
	      if (expr.type !== "ArrowFunctionExpression" || (_expr$extra = expr.extra) != null && _expr$extra.parenthesized) {
	        abort();
	      }
	      if (((_typeParameters = typeParameters) == null ? void 0 : _typeParameters.params.length) !== 0) {
	        this.resetStartLocationFromNode(expr, typeParameters);
	      }
	      expr.typeParameters = typeParameters;
	      return expr;
	    }, state);
	    if (!arrow.error && !arrow.aborted) {
	      if (typeParameters) this.reportReservedArrowTypeParam(typeParameters);
	      return arrow.node;
	    }
	    if (!jsx) {
	      assert(!this.hasPlugin("jsx"));
	      typeCast = this.tryParse(() => super.parseMaybeAssign(refExpressionErrors, afterLeftParse), state);
	      if (!typeCast.error) return typeCast.node;
	    }
	    if ((_jsx2 = jsx) != null && _jsx2.node) {
	      this.state = jsx.failState;
	      return jsx.node;
	    }
	    if (arrow.node) {
	      this.state = arrow.failState;
	      if (typeParameters) this.reportReservedArrowTypeParam(typeParameters);
	      return arrow.node;
	    }
	    if ((_typeCast = typeCast) != null && _typeCast.node) {
	      this.state = typeCast.failState;
	      return typeCast.node;
	    }
	    throw ((_jsx3 = jsx) == null ? void 0 : _jsx3.error) || arrow.error || ((_typeCast2 = typeCast) == null ? void 0 : _typeCast2.error);
	  }
	  reportReservedArrowTypeParam(node) {
	    var _node$extra;
	    if (node.params.length === 1 && !node.params[0].constraint && !((_node$extra = node.extra) != null && _node$extra.trailingComma) && this.getPluginOption("typescript", "disallowAmbiguousJSXLike")) {
	      this.raise(TSErrors.ReservedArrowTypeParam, node);
	    }
	  }
	  parseMaybeUnary(refExpressionErrors, sawUnary) {
	    if (!this.hasPlugin("jsx") && this.match(47)) {
	      return this.tsParseTypeAssertion();
	    }
	    return super.parseMaybeUnary(refExpressionErrors, sawUnary);
	  }
	  parseArrow(node) {
	    if (this.match(14)) {
	      const result = this.tryParse(abort => {
	        const returnType = this.tsParseTypeOrTypePredicateAnnotation(14);
	        if (this.canInsertSemicolon() || !this.match(19)) abort();
	        return returnType;
	      });
	      if (result.aborted) return;
	      if (!result.thrown) {
	        if (result.error) this.state = result.failState;
	        node.returnType = result.node;
	      }
	    }
	    return super.parseArrow(node);
	  }
	  parseAssignableListItemTypes(param, flags) {
	    if (!(flags & 2)) return param;
	    if (this.eat(17)) {
	      param.optional = true;
	    }
	    const type = this.tsTryParseTypeAnnotation();
	    if (type) param.typeAnnotation = type;
	    this.resetEndLocation(param);
	    return param;
	  }
	  isAssignable(node, isBinding) {
	    switch (node.type) {
	      case "TSTypeCastExpression":
	        return this.isAssignable(node.expression, isBinding);
	      case "TSParameterProperty":
	        return true;
	      default:
	        return super.isAssignable(node, isBinding);
	    }
	  }
	  toAssignable(node, isLHS = false) {
	    switch (node.type) {
	      case "ParenthesizedExpression":
	        this.toAssignableParenthesizedExpression(node, isLHS);
	        break;
	      case "TSAsExpression":
	      case "TSSatisfiesExpression":
	      case "TSNonNullExpression":
	      case "TSTypeAssertion":
	        if (isLHS) {
	          this.expressionScope.recordArrowParameterBindingError(TSErrors.UnexpectedTypeCastInParameter, node);
	        } else {
	          this.raise(TSErrors.UnexpectedTypeCastInParameter, node);
	        }
	        this.toAssignable(node.expression, isLHS);
	        break;
	      case "AssignmentExpression":
	        if (!isLHS && node.left.type === "TSTypeCastExpression") {
	          node.left = this.typeCastToParameter(node.left);
	        }
	      default:
	        super.toAssignable(node, isLHS);
	    }
	  }
	  toAssignableParenthesizedExpression(node, isLHS) {
	    switch (node.expression.type) {
	      case "TSAsExpression":
	      case "TSSatisfiesExpression":
	      case "TSNonNullExpression":
	      case "TSTypeAssertion":
	      case "ParenthesizedExpression":
	        this.toAssignable(node.expression, isLHS);
	        break;
	      default:
	        super.toAssignable(node, isLHS);
	    }
	  }
	  checkToRestConversion(node, allowPattern) {
	    switch (node.type) {
	      case "TSAsExpression":
	      case "TSSatisfiesExpression":
	      case "TSTypeAssertion":
	      case "TSNonNullExpression":
	        this.checkToRestConversion(node.expression, false);
	        break;
	      default:
	        super.checkToRestConversion(node, allowPattern);
	    }
	  }
	  isValidLVal(type, isUnparenthesizedInAssign, binding) {
	    return getOwn({
	      TSTypeCastExpression: true,
	      TSParameterProperty: "parameter",
	      TSNonNullExpression: "expression",
	      TSAsExpression: (binding !== 64 || !isUnparenthesizedInAssign) && ["expression", true],
	      TSSatisfiesExpression: (binding !== 64 || !isUnparenthesizedInAssign) && ["expression", true],
	      TSTypeAssertion: (binding !== 64 || !isUnparenthesizedInAssign) && ["expression", true]
	    }, type) || super.isValidLVal(type, isUnparenthesizedInAssign, binding);
	  }
	  parseBindingAtom() {
	    if (this.state.type === 78) {
	      return this.parseIdentifier(true);
	    }
	    return super.parseBindingAtom();
	  }
	  parseMaybeDecoratorArguments(expr) {
	    if (this.match(47) || this.match(51)) {
	      const typeArguments = this.tsParseTypeArgumentsInExpression();
	      if (this.match(10)) {
	        const call = super.parseMaybeDecoratorArguments(expr);
	        call.typeParameters = typeArguments;
	        return call;
	      }
	      this.unexpected(null, 10);
	    }
	    return super.parseMaybeDecoratorArguments(expr);
	  }
	  checkCommaAfterRest(close) {
	    if (this.state.isAmbientContext && this.match(12) && this.lookaheadCharCode() === close) {
	      this.next();
	      return false;
	    }
	    return super.checkCommaAfterRest(close);
	  }
	  isClassMethod() {
	    return this.match(47) || super.isClassMethod();
	  }
	  isClassProperty() {
	    return this.match(35) || this.match(14) || super.isClassProperty();
	  }
	  parseMaybeDefault(startLoc, left) {
	    const node = super.parseMaybeDefault(startLoc, left);
	    if (node.type === "AssignmentPattern" && node.typeAnnotation && node.right.start < node.typeAnnotation.start) {
	      this.raise(TSErrors.TypeAnnotationAfterAssign, node.typeAnnotation);
	    }
	    return node;
	  }
	  getTokenFromCode(code) {
	    if (this.state.inType) {
	      if (code === 62) {
	        this.finishOp(48, 1);
	        return;
	      }
	      if (code === 60) {
	        this.finishOp(47, 1);
	        return;
	      }
	    }
	    super.getTokenFromCode(code);
	  }
	  reScan_lt_gt() {
	    const {
	      type
	    } = this.state;
	    if (type === 47) {
	      this.state.pos -= 1;
	      this.readToken_lt();
	    } else if (type === 48) {
	      this.state.pos -= 1;
	      this.readToken_gt();
	    }
	  }
	  reScan_lt() {
	    const {
	      type
	    } = this.state;
	    if (type === 51) {
	      this.state.pos -= 2;
	      this.finishOp(47, 1);
	      return 47;
	    }
	    return type;
	  }
	  toAssignableList(exprList, trailingCommaLoc, isLHS) {
	    for (let i = 0; i < exprList.length; i++) {
	      const expr = exprList[i];
	      if ((expr == null ? void 0 : expr.type) === "TSTypeCastExpression") {
	        exprList[i] = this.typeCastToParameter(expr);
	      }
	    }
	    super.toAssignableList(exprList, trailingCommaLoc, isLHS);
	  }
	  typeCastToParameter(node) {
	    node.expression.typeAnnotation = node.typeAnnotation;
	    this.resetEndLocation(node.expression, node.typeAnnotation.loc.end);
	    return node.expression;
	  }
	  shouldParseArrow(params) {
	    if (this.match(14)) {
	      return params.every(expr => this.isAssignable(expr, true));
	    }
	    return super.shouldParseArrow(params);
	  }
	  shouldParseAsyncArrow() {
	    return this.match(14) || super.shouldParseAsyncArrow();
	  }
	  canHaveLeadingDecorator() {
	    return super.canHaveLeadingDecorator() || this.isAbstractClass();
	  }
	  jsxParseOpeningElementAfterName(node) {
	    if (this.match(47) || this.match(51)) {
	      const typeArguments = this.tsTryParseAndCatch(() => this.tsParseTypeArgumentsInExpression());
	      if (typeArguments) node.typeParameters = typeArguments;
	    }
	    return super.jsxParseOpeningElementAfterName(node);
	  }
	  getGetterSetterExpectedParamCount(method) {
	    const baseCount = super.getGetterSetterExpectedParamCount(method);
	    const params = this.getObjectOrClassMethodParams(method);
	    const firstParam = params[0];
	    const hasContextParam = firstParam && this.isThisParam(firstParam);
	    return hasContextParam ? baseCount + 1 : baseCount;
	  }
	  parseCatchClauseParam() {
	    const param = super.parseCatchClauseParam();
	    const type = this.tsTryParseTypeAnnotation();
	    if (type) {
	      param.typeAnnotation = type;
	      this.resetEndLocation(param);
	    }
	    return param;
	  }
	  tsInAmbientContext(cb) {
	    const oldIsAmbientContext = this.state.isAmbientContext;
	    this.state.isAmbientContext = true;
	    try {
	      return cb();
	    } finally {
	      this.state.isAmbientContext = oldIsAmbientContext;
	    }
	  }
	  parseClass(node, isStatement, optionalId) {
	    const oldInAbstractClass = this.state.inAbstractClass;
	    this.state.inAbstractClass = !!node.abstract;
	    try {
	      return super.parseClass(node, isStatement, optionalId);
	    } finally {
	      this.state.inAbstractClass = oldInAbstractClass;
	    }
	  }
	  tsParseAbstractDeclaration(node, decorators) {
	    if (this.match(80)) {
	      node.abstract = true;
	      return this.maybeTakeDecorators(decorators, this.parseClass(node, true, false));
	    } else if (this.isContextual(129)) {
	      if (!this.hasFollowingLineBreak()) {
	        node.abstract = true;
	        this.raise(TSErrors.NonClassMethodPropertyHasAbstractModifer, node);
	        return this.tsParseInterfaceDeclaration(node);
	      }
	    } else {
	      this.unexpected(null, 80);
	    }
	  }
	  parseMethod(node, isGenerator, isAsync, isConstructor, allowDirectSuper, type, inClassScope) {
	    const method = super.parseMethod(node, isGenerator, isAsync, isConstructor, allowDirectSuper, type, inClassScope);
	    if (method.abstract) {
	      const hasBody = this.hasPlugin("estree") ? !!method.value.body : !!method.body;
	      if (hasBody) {
	        const {
	          key
	        } = method;
	        this.raise(TSErrors.AbstractMethodHasImplementation, method, {
	          methodName: key.type === "Identifier" && !method.computed ? key.name : `[${this.input.slice(key.start, key.end)}]`
	        });
	      }
	    }
	    return method;
	  }
	  tsParseTypeParameterName() {
	    const typeName = this.parseIdentifier();
	    return typeName.name;
	  }
	  shouldParseAsAmbientContext() {
	    return !!this.getPluginOption("typescript", "dts");
	  }
	  parse() {
	    if (this.shouldParseAsAmbientContext()) {
	      this.state.isAmbientContext = true;
	    }
	    return super.parse();
	  }
	  getExpression() {
	    if (this.shouldParseAsAmbientContext()) {
	      this.state.isAmbientContext = true;
	    }
	    return super.getExpression();
	  }
	  parseExportSpecifier(node, isString, isInTypeExport, isMaybeTypeOnly) {
	    if (!isString && isMaybeTypeOnly) {
	      this.parseTypeOnlyImportExportSpecifier(node, false, isInTypeExport);
	      return this.finishNode(node, "ExportSpecifier");
	    }
	    node.exportKind = "value";
	    return super.parseExportSpecifier(node, isString, isInTypeExport, isMaybeTypeOnly);
	  }
	  parseImportSpecifier(specifier, importedIsString, isInTypeOnlyImport, isMaybeTypeOnly, bindingType) {
	    if (!importedIsString && isMaybeTypeOnly) {
	      this.parseTypeOnlyImportExportSpecifier(specifier, true, isInTypeOnlyImport);
	      return this.finishNode(specifier, "ImportSpecifier");
	    }
	    specifier.importKind = "value";
	    return super.parseImportSpecifier(specifier, importedIsString, isInTypeOnlyImport, isMaybeTypeOnly, isInTypeOnlyImport ? 4098 : 4096);
	  }
	  parseTypeOnlyImportExportSpecifier(node, isImport, isInTypeOnlyImportExport) {
	    const leftOfAsKey = isImport ? "imported" : "local";
	    const rightOfAsKey = isImport ? "local" : "exported";
	    let leftOfAs = node[leftOfAsKey];
	    let rightOfAs;
	    let hasTypeSpecifier = false;
	    let canParseAsKeyword = true;
	    const loc = leftOfAs.loc.start;
	    if (this.isContextual(93)) {
	      const firstAs = this.parseIdentifier();
	      if (this.isContextual(93)) {
	        const secondAs = this.parseIdentifier();
	        if (tokenIsKeywordOrIdentifier(this.state.type)) {
	          hasTypeSpecifier = true;
	          leftOfAs = firstAs;
	          rightOfAs = isImport ? this.parseIdentifier() : this.parseModuleExportName();
	          canParseAsKeyword = false;
	        } else {
	          rightOfAs = secondAs;
	          canParseAsKeyword = false;
	        }
	      } else if (tokenIsKeywordOrIdentifier(this.state.type)) {
	        canParseAsKeyword = false;
	        rightOfAs = isImport ? this.parseIdentifier() : this.parseModuleExportName();
	      } else {
	        hasTypeSpecifier = true;
	        leftOfAs = firstAs;
	      }
	    } else if (tokenIsKeywordOrIdentifier(this.state.type)) {
	      hasTypeSpecifier = true;
	      if (isImport) {
	        leftOfAs = this.parseIdentifier(true);
	        if (!this.isContextual(93)) {
	          this.checkReservedWord(leftOfAs.name, leftOfAs.loc.start, true, true);
	        }
	      } else {
	        leftOfAs = this.parseModuleExportName();
	      }
	    }
	    if (hasTypeSpecifier && isInTypeOnlyImportExport) {
	      this.raise(isImport ? TSErrors.TypeModifierIsUsedInTypeImports : TSErrors.TypeModifierIsUsedInTypeExports, loc);
	    }
	    node[leftOfAsKey] = leftOfAs;
	    node[rightOfAsKey] = rightOfAs;
	    const kindKey = isImport ? "importKind" : "exportKind";
	    node[kindKey] = hasTypeSpecifier ? "type" : "value";
	    if (canParseAsKeyword && this.eatContextual(93)) {
	      node[rightOfAsKey] = isImport ? this.parseIdentifier() : this.parseModuleExportName();
	    }
	    if (!node[rightOfAsKey]) {
	      node[rightOfAsKey] = cloneIdentifier(node[leftOfAsKey]);
	    }
	    if (isImport) {
	      this.checkIdentifier(node[rightOfAsKey], hasTypeSpecifier ? 4098 : 4096);
	    }
	  }
	};
	function isPossiblyLiteralEnum(expression) {
	  if (expression.type !== "MemberExpression") return false;
	  const {
	    computed,
	    property
	  } = expression;
	  if (computed && property.type !== "StringLiteral" && (property.type !== "TemplateLiteral" || property.expressions.length > 0)) {
	    return false;
	  }
	  return isUncomputedMemberExpressionChain(expression.object);
	}
	function isValidAmbientConstInitializer(expression, estree) {
	  var _expression$extra;
	  const {
	    type
	  } = expression;
	  if ((_expression$extra = expression.extra) != null && _expression$extra.parenthesized) {
	    return false;
	  }
	  if (estree) {
	    if (type === "Literal") {
	      const {
	        value
	      } = expression;
	      if (typeof value === "string" || typeof value === "boolean") {
	        return true;
	      }
	    }
	  } else {
	    if (type === "StringLiteral" || type === "BooleanLiteral") {
	      return true;
	    }
	  }
	  if (isNumber(expression, estree) || isNegativeNumber(expression, estree)) {
	    return true;
	  }
	  if (type === "TemplateLiteral" && expression.expressions.length === 0) {
	    return true;
	  }
	  if (isPossiblyLiteralEnum(expression)) {
	    return true;
	  }
	  return false;
	}
	function isNumber(expression, estree) {
	  if (estree) {
	    return expression.type === "Literal" && (typeof expression.value === "number" || "bigint" in expression);
	  }
	  return expression.type === "NumericLiteral" || expression.type === "BigIntLiteral";
	}
	function isNegativeNumber(expression, estree) {
	  if (expression.type === "UnaryExpression") {
	    const {
	      operator,
	      argument
	    } = expression;
	    if (operator === "-" && isNumber(argument, estree)) {
	      return true;
	    }
	  }
	  return false;
	}
	function isUncomputedMemberExpressionChain(expression) {
	  if (expression.type === "Identifier") return true;
	  if (expression.type !== "MemberExpression" || expression.computed) {
	    return false;
	  }
	  return isUncomputedMemberExpressionChain(expression.object);
	}
	const PlaceholderErrors = ParseErrorEnum`placeholders`({
	  ClassNameIsRequired: "A class name is required.",
	  UnexpectedSpace: "Unexpected space in placeholder."
	});
	var placeholders = superClass => class PlaceholdersParserMixin extends superClass {
	  parsePlaceholder(expectedNode) {
	    if (this.match(144)) {
	      const node = this.startNode();
	      this.next();
	      this.assertNoSpace();
	      node.name = super.parseIdentifier(true);
	      this.assertNoSpace();
	      this.expect(144);
	      return this.finishPlaceholder(node, expectedNode);
	    }
	  }
	  finishPlaceholder(node, expectedNode) {
	    let placeholder = node;
	    if (!placeholder.expectedNode || !placeholder.type) {
	      placeholder = this.finishNode(placeholder, "Placeholder");
	    }
	    placeholder.expectedNode = expectedNode;
	    return placeholder;
	  }
	  getTokenFromCode(code) {
	    if (code === 37 && this.input.charCodeAt(this.state.pos + 1) === 37) {
	      this.finishOp(144, 2);
	    } else {
	      super.getTokenFromCode(code);
	    }
	  }
	  parseExprAtom(refExpressionErrors) {
	    return this.parsePlaceholder("Expression") || super.parseExprAtom(refExpressionErrors);
	  }
	  parseIdentifier(liberal) {
	    return this.parsePlaceholder("Identifier") || super.parseIdentifier(liberal);
	  }
	  checkReservedWord(word, startLoc, checkKeywords, isBinding) {
	    if (word !== undefined) {
	      super.checkReservedWord(word, startLoc, checkKeywords, isBinding);
	    }
	  }
	  parseBindingAtom() {
	    return this.parsePlaceholder("Pattern") || super.parseBindingAtom();
	  }
	  isValidLVal(type, isParenthesized, binding) {
	    return type === "Placeholder" || super.isValidLVal(type, isParenthesized, binding);
	  }
	  toAssignable(node, isLHS) {
	    if (node && node.type === "Placeholder" && node.expectedNode === "Expression") {
	      node.expectedNode = "Pattern";
	    } else {
	      super.toAssignable(node, isLHS);
	    }
	  }
	  chStartsBindingIdentifier(ch, pos) {
	    if (super.chStartsBindingIdentifier(ch, pos)) {
	      return true;
	    }
	    const nextToken = this.lookahead();
	    if (nextToken.type === 144) {
	      return true;
	    }
	    return false;
	  }
	  verifyBreakContinue(node, isBreak) {
	    if (node.label && node.label.type === "Placeholder") return;
	    super.verifyBreakContinue(node, isBreak);
	  }
	  parseExpressionStatement(node, expr) {
	    var _expr$extra;
	    if (expr.type !== "Placeholder" || (_expr$extra = expr.extra) != null && _expr$extra.parenthesized) {
	      return super.parseExpressionStatement(node, expr);
	    }
	    if (this.match(14)) {
	      const stmt = node;
	      stmt.label = this.finishPlaceholder(expr, "Identifier");
	      this.next();
	      stmt.body = super.parseStatementOrSloppyAnnexBFunctionDeclaration();
	      return this.finishNode(stmt, "LabeledStatement");
	    }
	    this.semicolon();
	    const stmtPlaceholder = node;
	    stmtPlaceholder.name = expr.name;
	    return this.finishPlaceholder(stmtPlaceholder, "Statement");
	  }
	  parseBlock(allowDirectives, createNewLexicalScope, afterBlockParse) {
	    return this.parsePlaceholder("BlockStatement") || super.parseBlock(allowDirectives, createNewLexicalScope, afterBlockParse);
	  }
	  parseFunctionId(requireId) {
	    return this.parsePlaceholder("Identifier") || super.parseFunctionId(requireId);
	  }
	  parseClass(node, isStatement, optionalId) {
	    const type = isStatement ? "ClassDeclaration" : "ClassExpression";
	    this.next();
	    const oldStrict = this.state.strict;
	    const placeholder = this.parsePlaceholder("Identifier");
	    if (placeholder) {
	      if (this.match(81) || this.match(144) || this.match(5)) {
	        node.id = placeholder;
	      } else if (optionalId || !isStatement) {
	        node.id = null;
	        node.body = this.finishPlaceholder(placeholder, "ClassBody");
	        return this.finishNode(node, type);
	      } else {
	        throw this.raise(PlaceholderErrors.ClassNameIsRequired, this.state.startLoc);
	      }
	    } else {
	      this.parseClassId(node, isStatement, optionalId);
	    }
	    super.parseClassSuper(node);
	    node.body = this.parsePlaceholder("ClassBody") || super.parseClassBody(!!node.superClass, oldStrict);
	    return this.finishNode(node, type);
	  }
	  parseExport(node, decorators) {
	    const placeholder = this.parsePlaceholder("Identifier");
	    if (!placeholder) return super.parseExport(node, decorators);
	    const node2 = node;
	    if (!this.isContextual(98) && !this.match(12)) {
	      node2.specifiers = [];
	      node2.source = null;
	      node2.declaration = this.finishPlaceholder(placeholder, "Declaration");
	      return this.finishNode(node2, "ExportNamedDeclaration");
	    }
	    this.expectPlugin("exportDefaultFrom");
	    const specifier = this.startNode();
	    specifier.exported = placeholder;
	    node2.specifiers = [this.finishNode(specifier, "ExportDefaultSpecifier")];
	    return super.parseExport(node2, decorators);
	  }
	  isExportDefaultSpecifier() {
	    if (this.match(65)) {
	      const next = this.nextTokenStart();
	      if (this.isUnparsedContextual(next, "from")) {
	        if (this.input.startsWith(tokenLabelName(144), this.nextTokenStartSince(next + 4))) {
	          return true;
	        }
	      }
	    }
	    return super.isExportDefaultSpecifier();
	  }
	  maybeParseExportDefaultSpecifier(node, maybeDefaultIdentifier) {
	    var _specifiers;
	    if ((_specifiers = node.specifiers) != null && _specifiers.length) {
	      return true;
	    }
	    return super.maybeParseExportDefaultSpecifier(node, maybeDefaultIdentifier);
	  }
	  checkExport(node) {
	    const {
	      specifiers
	    } = node;
	    if (specifiers != null && specifiers.length) {
	      node.specifiers = specifiers.filter(node => node.exported.type === "Placeholder");
	    }
	    super.checkExport(node);
	    node.specifiers = specifiers;
	  }
	  parseImport(node) {
	    const placeholder = this.parsePlaceholder("Identifier");
	    if (!placeholder) return super.parseImport(node);
	    node.specifiers = [];
	    if (!this.isContextual(98) && !this.match(12)) {
	      node.source = this.finishPlaceholder(placeholder, "StringLiteral");
	      this.semicolon();
	      return this.finishNode(node, "ImportDeclaration");
	    }
	    const specifier = this.startNodeAtNode(placeholder);
	    specifier.local = placeholder;
	    node.specifiers.push(this.finishNode(specifier, "ImportDefaultSpecifier"));
	    if (this.eat(12)) {
	      const hasStarImport = this.maybeParseStarImportSpecifier(node);
	      if (!hasStarImport) this.parseNamedImportSpecifiers(node);
	    }
	    this.expectContextual(98);
	    node.source = this.parseImportSource();
	    this.semicolon();
	    return this.finishNode(node, "ImportDeclaration");
	  }
	  parseImportSource() {
	    return this.parsePlaceholder("StringLiteral") || super.parseImportSource();
	  }
	  assertNoSpace() {
	    if (this.state.start > this.state.lastTokEndLoc.index) {
	      this.raise(PlaceholderErrors.UnexpectedSpace, this.state.lastTokEndLoc);
	    }
	  }
	};
	var v8intrinsic = superClass => class V8IntrinsicMixin extends superClass {
	  parseV8Intrinsic() {
	    if (this.match(54)) {
	      const v8IntrinsicStartLoc = this.state.startLoc;
	      const node = this.startNode();
	      this.next();
	      if (tokenIsIdentifier(this.state.type)) {
	        const name = this.parseIdentifierName();
	        const identifier = this.createIdentifier(node, name);
	        identifier.type = "V8IntrinsicIdentifier";
	        if (this.match(10)) {
	          return identifier;
	        }
	      }
	      this.unexpected(v8IntrinsicStartLoc);
	    }
	  }
	  parseExprAtom(refExpressionErrors) {
	    return this.parseV8Intrinsic() || super.parseExprAtom(refExpressionErrors);
	  }
	};
	function hasPlugin(plugins, expectedConfig) {
	  const [expectedName, expectedOptions] = typeof expectedConfig === "string" ? [expectedConfig, {}] : expectedConfig;
	  const expectedKeys = Object.keys(expectedOptions);
	  const expectedOptionsIsEmpty = expectedKeys.length === 0;
	  return plugins.some(p => {
	    if (typeof p === "string") {
	      return expectedOptionsIsEmpty && p === expectedName;
	    } else {
	      const [pluginName, pluginOptions] = p;
	      if (pluginName !== expectedName) {
	        return false;
	      }
	      for (const key of expectedKeys) {
	        if (pluginOptions[key] !== expectedOptions[key]) {
	          return false;
	        }
	      }
	      return true;
	    }
	  });
	}
	function getPluginOption(plugins, name, option) {
	  const plugin = plugins.find(plugin => {
	    if (Array.isArray(plugin)) {
	      return plugin[0] === name;
	    } else {
	      return plugin === name;
	    }
	  });
	  if (plugin && Array.isArray(plugin) && plugin.length > 1) {
	    return plugin[1][option];
	  }
	  return null;
	}
	const PIPELINE_PROPOSALS = ["minimal", "fsharp", "hack", "smart"];
	const TOPIC_TOKENS = ["^^", "@@", "^", "%", "#"];
	const RECORD_AND_TUPLE_SYNTAX_TYPES = ["hash", "bar"];
	function validatePlugins(plugins) {
	  if (hasPlugin(plugins, "decorators")) {
	    if (hasPlugin(plugins, "decorators-legacy")) {
	      throw new Error("Cannot use the decorators and decorators-legacy plugin together");
	    }
	    const decoratorsBeforeExport = getPluginOption(plugins, "decorators", "decoratorsBeforeExport");
	    if (decoratorsBeforeExport != null && typeof decoratorsBeforeExport !== "boolean") {
	      throw new Error("'decoratorsBeforeExport' must be a boolean, if specified.");
	    }
	    const allowCallParenthesized = getPluginOption(plugins, "decorators", "allowCallParenthesized");
	    if (allowCallParenthesized != null && typeof allowCallParenthesized !== "boolean") {
	      throw new Error("'allowCallParenthesized' must be a boolean.");
	    }
	  }
	  if (hasPlugin(plugins, "flow") && hasPlugin(plugins, "typescript")) {
	    throw new Error("Cannot combine flow and typescript plugins.");
	  }
	  if (hasPlugin(plugins, "placeholders") && hasPlugin(plugins, "v8intrinsic")) {
	    throw new Error("Cannot combine placeholders and v8intrinsic plugins.");
	  }
	  if (hasPlugin(plugins, "pipelineOperator")) {
	    const proposal = getPluginOption(plugins, "pipelineOperator", "proposal");
	    if (!PIPELINE_PROPOSALS.includes(proposal)) {
	      const proposalList = PIPELINE_PROPOSALS.map(p => `"${p}"`).join(", ");
	      throw new Error(`"pipelineOperator" requires "proposal" option whose value must be one of: ${proposalList}.`);
	    }
	    const tupleSyntaxIsHash = hasPlugin(plugins, ["recordAndTuple", {
	      syntaxType: "hash"
	    }]);
	    if (proposal === "hack") {
	      if (hasPlugin(plugins, "placeholders")) {
	        throw new Error("Cannot combine placeholders plugin and Hack-style pipes.");
	      }
	      if (hasPlugin(plugins, "v8intrinsic")) {
	        throw new Error("Cannot combine v8intrinsic plugin and Hack-style pipes.");
	      }
	      const topicToken = getPluginOption(plugins, "pipelineOperator", "topicToken");
	      if (!TOPIC_TOKENS.includes(topicToken)) {
	        const tokenList = TOPIC_TOKENS.map(t => `"${t}"`).join(", ");
	        throw new Error(`"pipelineOperator" in "proposal": "hack" mode also requires a "topicToken" option whose value must be one of: ${tokenList}.`);
	      }
	      if (topicToken === "#" && tupleSyntaxIsHash) {
	        throw new Error('Plugin conflict between `["pipelineOperator", { proposal: "hack", topicToken: "#" }]` and `["recordAndtuple", { syntaxType: "hash"}]`.');
	      }
	    } else if (proposal === "smart" && tupleSyntaxIsHash) {
	      throw new Error('Plugin conflict between `["pipelineOperator", { proposal: "smart" }]` and `["recordAndtuple", { syntaxType: "hash"}]`.');
	    }
	  }
	  if (hasPlugin(plugins, "moduleAttributes")) {
	    {
	      if (hasPlugin(plugins, "importAssertions") || hasPlugin(plugins, "importAttributes")) {
	        throw new Error("Cannot combine importAssertions, importAttributes and moduleAttributes plugins.");
	      }
	      const moduleAttributesVersionPluginOption = getPluginOption(plugins, "moduleAttributes", "version");
	      if (moduleAttributesVersionPluginOption !== "may-2020") {
	        throw new Error("The 'moduleAttributes' plugin requires a 'version' option," + " representing the last proposal update. Currently, the" + " only supported value is 'may-2020'.");
	      }
	    }
	  }
	  if (hasPlugin(plugins, "importAssertions") && hasPlugin(plugins, "importAttributes")) {
	    throw new Error("Cannot combine importAssertions and importAttributes plugins.");
	  }
	  if (hasPlugin(plugins, "recordAndTuple") && getPluginOption(plugins, "recordAndTuple", "syntaxType") != null && !RECORD_AND_TUPLE_SYNTAX_TYPES.includes(getPluginOption(plugins, "recordAndTuple", "syntaxType"))) {
	    throw new Error("The 'syntaxType' option of the 'recordAndTuple' plugin must be one of: " + RECORD_AND_TUPLE_SYNTAX_TYPES.map(p => `'${p}'`).join(", "));
	  }
	  if (hasPlugin(plugins, "asyncDoExpressions") && !hasPlugin(plugins, "doExpressions")) {
	    const error = new Error("'asyncDoExpressions' requires 'doExpressions', please add 'doExpressions' to parser plugins.");
	    error.missingPlugins = "doExpressions";
	    throw error;
	  }
	  if (hasPlugin(plugins, "optionalChainingAssign") && getPluginOption(plugins, "optionalChainingAssign", "version") !== "2023-07") {
	    throw new Error("The 'optionalChainingAssign' plugin requires a 'version' option," + " representing the last proposal update. Currently, the" + " only supported value is '2023-07'.");
	  }
	}
	const mixinPlugins = {
	  estree,
	  jsx,
	  flow,
	  typescript,
	  v8intrinsic,
	  placeholders
	};
	const mixinPluginNames = Object.keys(mixinPlugins);
	const defaultOptions = {
	  sourceType: "script",
	  sourceFilename: undefined,
	  startColumn: 0,
	  startLine: 1,
	  allowAwaitOutsideFunction: false,
	  allowReturnOutsideFunction: false,
	  allowNewTargetOutsideFunction: false,
	  allowImportExportEverywhere: false,
	  allowSuperOutsideMethod: false,
	  allowUndeclaredExports: false,
	  plugins: [],
	  strictMode: null,
	  ranges: false,
	  tokens: false,
	  createImportExpressions: false,
	  createParenthesizedExpressions: false,
	  errorRecovery: false,
	  attachComment: true,
	  annexB: true
	};
	function getOptions(opts) {
	  if (opts == null) {
	    return Object.assign({}, defaultOptions);
	  }
	  if (opts.annexB != null && opts.annexB !== false) {
	    throw new Error("The `annexB` option can only be set to `false`.");
	  }
	  const options = {};
	  for (const key of Object.keys(defaultOptions)) {
	    var _opts$key;
	    options[key] = (_opts$key = opts[key]) != null ? _opts$key : defaultOptions[key];
	  }
	  return options;
	}
	class ExpressionParser extends LValParser {
	  checkProto(prop, isRecord, protoRef, refExpressionErrors) {
	    if (prop.type === "SpreadElement" || this.isObjectMethod(prop) || prop.computed || prop.shorthand) {
	      return;
	    }
	    const key = prop.key;
	    const name = key.type === "Identifier" ? key.name : key.value;
	    if (name === "__proto__") {
	      if (isRecord) {
	        this.raise(Errors.RecordNoProto, key);
	        return;
	      }
	      if (protoRef.used) {
	        if (refExpressionErrors) {
	          if (refExpressionErrors.doubleProtoLoc === null) {
	            refExpressionErrors.doubleProtoLoc = key.loc.start;
	          }
	        } else {
	          this.raise(Errors.DuplicateProto, key);
	        }
	      }
	      protoRef.used = true;
	    }
	  }
	  shouldExitDescending(expr, potentialArrowAt) {
	    return expr.type === "ArrowFunctionExpression" && expr.start === potentialArrowAt;
	  }
	  getExpression() {
	    this.enterInitialScopes();
	    this.nextToken();
	    const expr = this.parseExpression();
	    if (!this.match(139)) {
	      this.unexpected();
	    }
	    this.finalizeRemainingComments();
	    expr.comments = this.comments;
	    expr.errors = this.state.errors;
	    if (this.options.tokens) {
	      expr.tokens = this.tokens;
	    }
	    return expr;
	  }
	  parseExpression(disallowIn, refExpressionErrors) {
	    if (disallowIn) {
	      return this.disallowInAnd(() => this.parseExpressionBase(refExpressionErrors));
	    }
	    return this.allowInAnd(() => this.parseExpressionBase(refExpressionErrors));
	  }
	  parseExpressionBase(refExpressionErrors) {
	    const startLoc = this.state.startLoc;
	    const expr = this.parseMaybeAssign(refExpressionErrors);
	    if (this.match(12)) {
	      const node = this.startNodeAt(startLoc);
	      node.expressions = [expr];
	      while (this.eat(12)) {
	        node.expressions.push(this.parseMaybeAssign(refExpressionErrors));
	      }
	      this.toReferencedList(node.expressions);
	      return this.finishNode(node, "SequenceExpression");
	    }
	    return expr;
	  }
	  parseMaybeAssignDisallowIn(refExpressionErrors, afterLeftParse) {
	    return this.disallowInAnd(() => this.parseMaybeAssign(refExpressionErrors, afterLeftParse));
	  }
	  parseMaybeAssignAllowIn(refExpressionErrors, afterLeftParse) {
	    return this.allowInAnd(() => this.parseMaybeAssign(refExpressionErrors, afterLeftParse));
	  }
	  setOptionalParametersError(refExpressionErrors, resultError) {
	    var _resultError$loc;
	    refExpressionErrors.optionalParametersLoc = (_resultError$loc = resultError == null ? void 0 : resultError.loc) != null ? _resultError$loc : this.state.startLoc;
	  }
	  parseMaybeAssign(refExpressionErrors, afterLeftParse) {
	    const startLoc = this.state.startLoc;
	    if (this.isContextual(108)) {
	      if (this.prodParam.hasYield) {
	        let left = this.parseYield();
	        if (afterLeftParse) {
	          left = afterLeftParse.call(this, left, startLoc);
	        }
	        return left;
	      }
	    }
	    let ownExpressionErrors;
	    if (refExpressionErrors) {
	      ownExpressionErrors = false;
	    } else {
	      refExpressionErrors = new ExpressionErrors();
	      ownExpressionErrors = true;
	    }
	    const {
	      type
	    } = this.state;
	    if (type === 10 || tokenIsIdentifier(type)) {
	      this.state.potentialArrowAt = this.state.start;
	    }
	    let left = this.parseMaybeConditional(refExpressionErrors);
	    if (afterLeftParse) {
	      left = afterLeftParse.call(this, left, startLoc);
	    }
	    if (tokenIsAssignment(this.state.type)) {
	      const node = this.startNodeAt(startLoc);
	      const operator = this.state.value;
	      node.operator = operator;
	      if (this.match(29)) {
	        this.toAssignable(left, true);
	        node.left = left;
	        const startIndex = startLoc.index;
	        if (refExpressionErrors.doubleProtoLoc != null && refExpressionErrors.doubleProtoLoc.index >= startIndex) {
	          refExpressionErrors.doubleProtoLoc = null;
	        }
	        if (refExpressionErrors.shorthandAssignLoc != null && refExpressionErrors.shorthandAssignLoc.index >= startIndex) {
	          refExpressionErrors.shorthandAssignLoc = null;
	        }
	        if (refExpressionErrors.privateKeyLoc != null && refExpressionErrors.privateKeyLoc.index >= startIndex) {
	          this.checkDestructuringPrivate(refExpressionErrors);
	          refExpressionErrors.privateKeyLoc = null;
	        }
	      } else {
	        node.left = left;
	      }
	      this.next();
	      node.right = this.parseMaybeAssign();
	      this.checkLVal(left, {
	        in: this.finishNode(node, "AssignmentExpression")
	      });
	      return node;
	    } else if (ownExpressionErrors) {
	      this.checkExpressionErrors(refExpressionErrors, true);
	    }
	    return left;
	  }
	  parseMaybeConditional(refExpressionErrors) {
	    const startLoc = this.state.startLoc;
	    const potentialArrowAt = this.state.potentialArrowAt;
	    const expr = this.parseExprOps(refExpressionErrors);
	    if (this.shouldExitDescending(expr, potentialArrowAt)) {
	      return expr;
	    }
	    return this.parseConditional(expr, startLoc, refExpressionErrors);
	  }
	  parseConditional(expr, startLoc, refExpressionErrors) {
	    if (this.eat(17)) {
	      const node = this.startNodeAt(startLoc);
	      node.test = expr;
	      node.consequent = this.parseMaybeAssignAllowIn();
	      this.expect(14);
	      node.alternate = this.parseMaybeAssign();
	      return this.finishNode(node, "ConditionalExpression");
	    }
	    return expr;
	  }
	  parseMaybeUnaryOrPrivate(refExpressionErrors) {
	    return this.match(138) ? this.parsePrivateName() : this.parseMaybeUnary(refExpressionErrors);
	  }
	  parseExprOps(refExpressionErrors) {
	    const startLoc = this.state.startLoc;
	    const potentialArrowAt = this.state.potentialArrowAt;
	    const expr = this.parseMaybeUnaryOrPrivate(refExpressionErrors);
	    if (this.shouldExitDescending(expr, potentialArrowAt)) {
	      return expr;
	    }
	    return this.parseExprOp(expr, startLoc, -1);
	  }
	  parseExprOp(left, leftStartLoc, minPrec) {
	    if (this.isPrivateName(left)) {
	      const value = this.getPrivateNameSV(left);
	      if (minPrec >= tokenOperatorPrecedence(58) || !this.prodParam.hasIn || !this.match(58)) {
	        this.raise(Errors.PrivateInExpectedIn, left, {
	          identifierName: value
	        });
	      }
	      this.classScope.usePrivateName(value, left.loc.start);
	    }
	    const op = this.state.type;
	    if (tokenIsOperator(op) && (this.prodParam.hasIn || !this.match(58))) {
	      let prec = tokenOperatorPrecedence(op);
	      if (prec > minPrec) {
	        if (op === 39) {
	          this.expectPlugin("pipelineOperator");
	          if (this.state.inFSharpPipelineDirectBody) {
	            return left;
	          }
	          this.checkPipelineAtInfixOperator(left, leftStartLoc);
	        }
	        const node = this.startNodeAt(leftStartLoc);
	        node.left = left;
	        node.operator = this.state.value;
	        const logical = op === 41 || op === 42;
	        const coalesce = op === 40;
	        if (coalesce) {
	          prec = tokenOperatorPrecedence(42);
	        }
	        this.next();
	        if (op === 39 && this.hasPlugin(["pipelineOperator", {
	          proposal: "minimal"
	        }])) {
	          if (this.state.type === 96 && this.prodParam.hasAwait) {
	            throw this.raise(Errors.UnexpectedAwaitAfterPipelineBody, this.state.startLoc);
	          }
	        }
	        node.right = this.parseExprOpRightExpr(op, prec);
	        const finishedNode = this.finishNode(node, logical || coalesce ? "LogicalExpression" : "BinaryExpression");
	        const nextOp = this.state.type;
	        if (coalesce && (nextOp === 41 || nextOp === 42) || logical && nextOp === 40) {
	          throw this.raise(Errors.MixingCoalesceWithLogical, this.state.startLoc);
	        }
	        return this.parseExprOp(finishedNode, leftStartLoc, minPrec);
	      }
	    }
	    return left;
	  }
	  parseExprOpRightExpr(op, prec) {
	    const startLoc = this.state.startLoc;
	    switch (op) {
	      case 39:
	        switch (this.getPluginOption("pipelineOperator", "proposal")) {
	          case "hack":
	            return this.withTopicBindingContext(() => {
	              return this.parseHackPipeBody();
	            });
	          case "smart":
	            return this.withTopicBindingContext(() => {
	              if (this.prodParam.hasYield && this.isContextual(108)) {
	                throw this.raise(Errors.PipeBodyIsTighter, this.state.startLoc);
	              }
	              return this.parseSmartPipelineBodyInStyle(this.parseExprOpBaseRightExpr(op, prec), startLoc);
	            });
	          case "fsharp":
	            return this.withSoloAwaitPermittingContext(() => {
	              return this.parseFSharpPipelineBody(prec);
	            });
	        }
	      default:
	        return this.parseExprOpBaseRightExpr(op, prec);
	    }
	  }
	  parseExprOpBaseRightExpr(op, prec) {
	    const startLoc = this.state.startLoc;
	    return this.parseExprOp(this.parseMaybeUnaryOrPrivate(), startLoc, tokenIsRightAssociative(op) ? prec - 1 : prec);
	  }
	  parseHackPipeBody() {
	    var _body$extra;
	    const {
	      startLoc
	    } = this.state;
	    const body = this.parseMaybeAssign();
	    const requiredParentheses = UnparenthesizedPipeBodyDescriptions.has(body.type);
	    if (requiredParentheses && !((_body$extra = body.extra) != null && _body$extra.parenthesized)) {
	      this.raise(Errors.PipeUnparenthesizedBody, startLoc, {
	        type: body.type
	      });
	    }
	    if (!this.topicReferenceWasUsedInCurrentContext()) {
	      this.raise(Errors.PipeTopicUnused, startLoc);
	    }
	    return body;
	  }
	  checkExponentialAfterUnary(node) {
	    if (this.match(57)) {
	      this.raise(Errors.UnexpectedTokenUnaryExponentiation, node.argument);
	    }
	  }
	  parseMaybeUnary(refExpressionErrors, sawUnary) {
	    const startLoc = this.state.startLoc;
	    const isAwait = this.isContextual(96);
	    if (isAwait && this.isAwaitAllowed()) {
	      this.next();
	      const expr = this.parseAwait(startLoc);
	      if (!sawUnary) this.checkExponentialAfterUnary(expr);
	      return expr;
	    }
	    const update = this.match(34);
	    const node = this.startNode();
	    if (tokenIsPrefix(this.state.type)) {
	      node.operator = this.state.value;
	      node.prefix = true;
	      if (this.match(72)) {
	        this.expectPlugin("throwExpressions");
	      }
	      const isDelete = this.match(89);
	      this.next();
	      node.argument = this.parseMaybeUnary(null, true);
	      this.checkExpressionErrors(refExpressionErrors, true);
	      if (this.state.strict && isDelete) {
	        const arg = node.argument;
	        if (arg.type === "Identifier") {
	          this.raise(Errors.StrictDelete, node);
	        } else if (this.hasPropertyAsPrivateName(arg)) {
	          this.raise(Errors.DeletePrivateField, node);
	        }
	      }
	      if (!update) {
	        if (!sawUnary) {
	          this.checkExponentialAfterUnary(node);
	        }
	        return this.finishNode(node, "UnaryExpression");
	      }
	    }
	    const expr = this.parseUpdate(node, update, refExpressionErrors);
	    if (isAwait) {
	      const {
	        type
	      } = this.state;
	      const startsExpr = this.hasPlugin("v8intrinsic") ? tokenCanStartExpression(type) : tokenCanStartExpression(type) && !this.match(54);
	      if (startsExpr && !this.isAmbiguousAwait()) {
	        this.raiseOverwrite(Errors.AwaitNotInAsyncContext, startLoc);
	        return this.parseAwait(startLoc);
	      }
	    }
	    return expr;
	  }
	  parseUpdate(node, update, refExpressionErrors) {
	    if (update) {
	      const updateExpressionNode = node;
	      this.checkLVal(updateExpressionNode.argument, {
	        in: this.finishNode(updateExpressionNode, "UpdateExpression")
	      });
	      return node;
	    }
	    const startLoc = this.state.startLoc;
	    let expr = this.parseExprSubscripts(refExpressionErrors);
	    if (this.checkExpressionErrors(refExpressionErrors, false)) return expr;
	    while (tokenIsPostfix(this.state.type) && !this.canInsertSemicolon()) {
	      const node = this.startNodeAt(startLoc);
	      node.operator = this.state.value;
	      node.prefix = false;
	      node.argument = expr;
	      this.next();
	      this.checkLVal(expr, {
	        in: expr = this.finishNode(node, "UpdateExpression")
	      });
	    }
	    return expr;
	  }
	  parseExprSubscripts(refExpressionErrors) {
	    const startLoc = this.state.startLoc;
	    const potentialArrowAt = this.state.potentialArrowAt;
	    const expr = this.parseExprAtom(refExpressionErrors);
	    if (this.shouldExitDescending(expr, potentialArrowAt)) {
	      return expr;
	    }
	    return this.parseSubscripts(expr, startLoc);
	  }
	  parseSubscripts(base, startLoc, noCalls) {
	    const state = {
	      optionalChainMember: false,
	      maybeAsyncArrow: this.atPossibleAsyncArrow(base),
	      stop: false
	    };
	    do {
	      base = this.parseSubscript(base, startLoc, noCalls, state);
	      state.maybeAsyncArrow = false;
	    } while (!state.stop);
	    return base;
	  }
	  parseSubscript(base, startLoc, noCalls, state) {
	    const {
	      type
	    } = this.state;
	    if (!noCalls && type === 15) {
	      return this.parseBind(base, startLoc, noCalls, state);
	    } else if (tokenIsTemplate(type)) {
	      return this.parseTaggedTemplateExpression(base, startLoc, state);
	    }
	    let optional = false;
	    if (type === 18) {
	      if (noCalls) {
	        this.raise(Errors.OptionalChainingNoNew, this.state.startLoc);
	        if (this.lookaheadCharCode() === 40) {
	          state.stop = true;
	          return base;
	        }
	      }
	      state.optionalChainMember = optional = true;
	      this.next();
	    }
	    if (!noCalls && this.match(10)) {
	      return this.parseCoverCallAndAsyncArrowHead(base, startLoc, state, optional);
	    } else {
	      const computed = this.eat(0);
	      if (computed || optional || this.eat(16)) {
	        return this.parseMember(base, startLoc, state, computed, optional);
	      } else {
	        state.stop = true;
	        return base;
	      }
	    }
	  }
	  parseMember(base, startLoc, state, computed, optional) {
	    const node = this.startNodeAt(startLoc);
	    node.object = base;
	    node.computed = computed;
	    if (computed) {
	      node.property = this.parseExpression();
	      this.expect(3);
	    } else if (this.match(138)) {
	      if (base.type === "Super") {
	        this.raise(Errors.SuperPrivateField, startLoc);
	      }
	      this.classScope.usePrivateName(this.state.value, this.state.startLoc);
	      node.property = this.parsePrivateName();
	    } else {
	      node.property = this.parseIdentifier(true);
	    }
	    if (state.optionalChainMember) {
	      node.optional = optional;
	      return this.finishNode(node, "OptionalMemberExpression");
	    } else {
	      return this.finishNode(node, "MemberExpression");
	    }
	  }
	  parseBind(base, startLoc, noCalls, state) {
	    const node = this.startNodeAt(startLoc);
	    node.object = base;
	    this.next();
	    node.callee = this.parseNoCallExpr();
	    state.stop = true;
	    return this.parseSubscripts(this.finishNode(node, "BindExpression"), startLoc, noCalls);
	  }
	  parseCoverCallAndAsyncArrowHead(base, startLoc, state, optional) {
	    const oldMaybeInArrowParameters = this.state.maybeInArrowParameters;
	    let refExpressionErrors = null;
	    this.state.maybeInArrowParameters = true;
	    this.next();
	    const node = this.startNodeAt(startLoc);
	    node.callee = base;
	    const {
	      maybeAsyncArrow,
	      optionalChainMember
	    } = state;
	    if (maybeAsyncArrow) {
	      this.expressionScope.enter(newAsyncArrowScope());
	      refExpressionErrors = new ExpressionErrors();
	    }
	    if (optionalChainMember) {
	      node.optional = optional;
	    }
	    if (optional) {
	      node.arguments = this.parseCallExpressionArguments(11);
	    } else {
	      node.arguments = this.parseCallExpressionArguments(11, base.type === "Import", base.type !== "Super", node, refExpressionErrors);
	    }
	    let finishedNode = this.finishCallExpression(node, optionalChainMember);
	    if (maybeAsyncArrow && this.shouldParseAsyncArrow() && !optional) {
	      state.stop = true;
	      this.checkDestructuringPrivate(refExpressionErrors);
	      this.expressionScope.validateAsPattern();
	      this.expressionScope.exit();
	      finishedNode = this.parseAsyncArrowFromCallExpression(this.startNodeAt(startLoc), finishedNode);
	    } else {
	      if (maybeAsyncArrow) {
	        this.checkExpressionErrors(refExpressionErrors, true);
	        this.expressionScope.exit();
	      }
	      this.toReferencedArguments(finishedNode);
	    }
	    this.state.maybeInArrowParameters = oldMaybeInArrowParameters;
	    return finishedNode;
	  }
	  toReferencedArguments(node, isParenthesizedExpr) {
	    this.toReferencedListDeep(node.arguments, isParenthesizedExpr);
	  }
	  parseTaggedTemplateExpression(base, startLoc, state) {
	    const node = this.startNodeAt(startLoc);
	    node.tag = base;
	    node.quasi = this.parseTemplate(true);
	    if (state.optionalChainMember) {
	      this.raise(Errors.OptionalChainingNoTemplate, startLoc);
	    }
	    return this.finishNode(node, "TaggedTemplateExpression");
	  }
	  atPossibleAsyncArrow(base) {
	    return base.type === "Identifier" && base.name === "async" && this.state.lastTokEndLoc.index === base.end && !this.canInsertSemicolon() && base.end - base.start === 5 && base.start === this.state.potentialArrowAt;
	  }
	  expectImportAttributesPlugin() {
	    if (!this.hasPlugin("importAssertions")) {
	      this.expectPlugin("importAttributes");
	    }
	  }
	  finishCallExpression(node, optional) {
	    if (node.callee.type === "Import") {
	      if (node.arguments.length === 2) {
	        {
	          if (!this.hasPlugin("moduleAttributes")) {
	            this.expectImportAttributesPlugin();
	          }
	        }
	      }
	      if (node.arguments.length === 0 || node.arguments.length > 2) {
	        this.raise(Errors.ImportCallArity, node, {
	          maxArgumentCount: this.hasPlugin("importAttributes") || this.hasPlugin("importAssertions") || this.hasPlugin("moduleAttributes") ? 2 : 1
	        });
	      } else {
	        for (const arg of node.arguments) {
	          if (arg.type === "SpreadElement") {
	            this.raise(Errors.ImportCallSpreadArgument, arg);
	          }
	        }
	      }
	    }
	    return this.finishNode(node, optional ? "OptionalCallExpression" : "CallExpression");
	  }
	  parseCallExpressionArguments(close, dynamicImport, allowPlaceholder, nodeForExtra, refExpressionErrors) {
	    const elts = [];
	    let first = true;
	    const oldInFSharpPipelineDirectBody = this.state.inFSharpPipelineDirectBody;
	    this.state.inFSharpPipelineDirectBody = false;
	    while (!this.eat(close)) {
	      if (first) {
	        first = false;
	      } else {
	        this.expect(12);
	        if (this.match(close)) {
	          if (dynamicImport && !this.hasPlugin("importAttributes") && !this.hasPlugin("importAssertions") && !this.hasPlugin("moduleAttributes")) {
	            this.raise(Errors.ImportCallArgumentTrailingComma, this.state.lastTokStartLoc);
	          }
	          if (nodeForExtra) {
	            this.addTrailingCommaExtraToNode(nodeForExtra);
	          }
	          this.next();
	          break;
	        }
	      }
	      elts.push(this.parseExprListItem(false, refExpressionErrors, allowPlaceholder));
	    }
	    this.state.inFSharpPipelineDirectBody = oldInFSharpPipelineDirectBody;
	    return elts;
	  }
	  shouldParseAsyncArrow() {
	    return this.match(19) && !this.canInsertSemicolon();
	  }
	  parseAsyncArrowFromCallExpression(node, call) {
	    var _call$extra;
	    this.resetPreviousNodeTrailingComments(call);
	    this.expect(19);
	    this.parseArrowExpression(node, call.arguments, true, (_call$extra = call.extra) == null ? void 0 : _call$extra.trailingCommaLoc);
	    if (call.innerComments) {
	      setInnerComments(node, call.innerComments);
	    }
	    if (call.callee.trailingComments) {
	      setInnerComments(node, call.callee.trailingComments);
	    }
	    return node;
	  }
	  parseNoCallExpr() {
	    const startLoc = this.state.startLoc;
	    return this.parseSubscripts(this.parseExprAtom(), startLoc, true);
	  }
	  parseExprAtom(refExpressionErrors) {
	    let node;
	    let decorators = null;
	    const {
	      type
	    } = this.state;
	    switch (type) {
	      case 79:
	        return this.parseSuper();
	      case 83:
	        node = this.startNode();
	        this.next();
	        if (this.match(16)) {
	          return this.parseImportMetaProperty(node);
	        }
	        if (this.match(10)) {
	          if (this.options.createImportExpressions) {
	            return this.parseImportCall(node);
	          } else {
	            return this.finishNode(node, "Import");
	          }
	        } else {
	          this.raise(Errors.UnsupportedImport, this.state.lastTokStartLoc);
	          return this.finishNode(node, "Import");
	        }
	      case 78:
	        node = this.startNode();
	        this.next();
	        return this.finishNode(node, "ThisExpression");
	      case 90:
	        {
	          return this.parseDo(this.startNode(), false);
	        }
	      case 56:
	      case 31:
	        {
	          this.readRegexp();
	          return this.parseRegExpLiteral(this.state.value);
	        }
	      case 134:
	        return this.parseNumericLiteral(this.state.value);
	      case 135:
	        return this.parseBigIntLiteral(this.state.value);
	      case 136:
	        return this.parseDecimalLiteral(this.state.value);
	      case 133:
	        return this.parseStringLiteral(this.state.value);
	      case 84:
	        return this.parseNullLiteral();
	      case 85:
	        return this.parseBooleanLiteral(true);
	      case 86:
	        return this.parseBooleanLiteral(false);
	      case 10:
	        {
	          const canBeArrow = this.state.potentialArrowAt === this.state.start;
	          return this.parseParenAndDistinguishExpression(canBeArrow);
	        }
	      case 2:
	      case 1:
	        {
	          return this.parseArrayLike(this.state.type === 2 ? 4 : 3, false, true);
	        }
	      case 0:
	        {
	          return this.parseArrayLike(3, true, false, refExpressionErrors);
	        }
	      case 6:
	      case 7:
	        {
	          return this.parseObjectLike(this.state.type === 6 ? 9 : 8, false, true);
	        }
	      case 5:
	        {
	          return this.parseObjectLike(8, false, false, refExpressionErrors);
	        }
	      case 68:
	        return this.parseFunctionOrFunctionSent();
	      case 26:
	        decorators = this.parseDecorators();
	      case 80:
	        return this.parseClass(this.maybeTakeDecorators(decorators, this.startNode()), false);
	      case 77:
	        return this.parseNewOrNewTarget();
	      case 25:
	      case 24:
	        return this.parseTemplate(false);
	      case 15:
	        {
	          node = this.startNode();
	          this.next();
	          node.object = null;
	          const callee = node.callee = this.parseNoCallExpr();
	          if (callee.type === "MemberExpression") {
	            return this.finishNode(node, "BindExpression");
	          } else {
	            throw this.raise(Errors.UnsupportedBind, callee);
	          }
	        }
	      case 138:
	        {
	          this.raise(Errors.PrivateInExpectedIn, this.state.startLoc, {
	            identifierName: this.state.value
	          });
	          return this.parsePrivateName();
	        }
	      case 33:
	        {
	          return this.parseTopicReferenceThenEqualsSign(54, "%");
	        }
	      case 32:
	        {
	          return this.parseTopicReferenceThenEqualsSign(44, "^");
	        }
	      case 37:
	      case 38:
	        {
	          return this.parseTopicReference("hack");
	        }
	      case 44:
	      case 54:
	      case 27:
	        {
	          const pipeProposal = this.getPluginOption("pipelineOperator", "proposal");
	          if (pipeProposal) {
	            return this.parseTopicReference(pipeProposal);
	          }
	          this.unexpected();
	          break;
	        }
	      case 47:
	        {
	          const lookaheadCh = this.input.codePointAt(this.nextTokenStart());
	          if (isIdentifierStart(lookaheadCh) || lookaheadCh === 62) {
	            this.expectOnePlugin(["jsx", "flow", "typescript"]);
	          } else {
	            this.unexpected();
	          }
	          break;
	        }
	      default:
	        if (tokenIsIdentifier(type)) {
	          if (this.isContextual(127) && this.lookaheadInLineCharCode() === 123) {
	            return this.parseModuleExpression();
	          }
	          const canBeArrow = this.state.potentialArrowAt === this.state.start;
	          const containsEsc = this.state.containsEsc;
	          const id = this.parseIdentifier();
	          if (!containsEsc && id.name === "async" && !this.canInsertSemicolon()) {
	            const {
	              type
	            } = this.state;
	            if (type === 68) {
	              this.resetPreviousNodeTrailingComments(id);
	              this.next();
	              return this.parseAsyncFunctionExpression(this.startNodeAtNode(id));
	            } else if (tokenIsIdentifier(type)) {
	              if (this.lookaheadCharCode() === 61) {
	                return this.parseAsyncArrowUnaryFunction(this.startNodeAtNode(id));
	              } else {
	                return id;
	              }
	            } else if (type === 90) {
	              this.resetPreviousNodeTrailingComments(id);
	              return this.parseDo(this.startNodeAtNode(id), true);
	            }
	          }
	          if (canBeArrow && this.match(19) && !this.canInsertSemicolon()) {
	            this.next();
	            return this.parseArrowExpression(this.startNodeAtNode(id), [id], false);
	          }
	          return id;
	        } else {
	          this.unexpected();
	        }
	    }
	  }
	  parseTopicReferenceThenEqualsSign(topicTokenType, topicTokenValue) {
	    const pipeProposal = this.getPluginOption("pipelineOperator", "proposal");
	    if (pipeProposal) {
	      this.state.type = topicTokenType;
	      this.state.value = topicTokenValue;
	      this.state.pos--;
	      this.state.end--;
	      this.state.endLoc = createPositionWithColumnOffset(this.state.endLoc, -1);
	      return this.parseTopicReference(pipeProposal);
	    } else {
	      this.unexpected();
	    }
	  }
	  parseTopicReference(pipeProposal) {
	    const node = this.startNode();
	    const startLoc = this.state.startLoc;
	    const tokenType = this.state.type;
	    this.next();
	    return this.finishTopicReference(node, startLoc, pipeProposal, tokenType);
	  }
	  finishTopicReference(node, startLoc, pipeProposal, tokenType) {
	    if (this.testTopicReferenceConfiguration(pipeProposal, startLoc, tokenType)) {
	      const nodeType = pipeProposal === "smart" ? "PipelinePrimaryTopicReference" : "TopicReference";
	      if (!this.topicReferenceIsAllowedInCurrentContext()) {
	        this.raise(pipeProposal === "smart" ? Errors.PrimaryTopicNotAllowed : Errors.PipeTopicUnbound, startLoc);
	      }
	      this.registerTopicReference();
	      return this.finishNode(node, nodeType);
	    } else {
	      throw this.raise(Errors.PipeTopicUnconfiguredToken, startLoc, {
	        token: tokenLabelName(tokenType)
	      });
	    }
	  }
	  testTopicReferenceConfiguration(pipeProposal, startLoc, tokenType) {
	    switch (pipeProposal) {
	      case "hack":
	        {
	          return this.hasPlugin(["pipelineOperator", {
	            topicToken: tokenLabelName(tokenType)
	          }]);
	        }
	      case "smart":
	        return tokenType === 27;
	      default:
	        throw this.raise(Errors.PipeTopicRequiresHackPipes, startLoc);
	    }
	  }
	  parseAsyncArrowUnaryFunction(node) {
	    this.prodParam.enter(functionFlags(true, this.prodParam.hasYield));
	    const params = [this.parseIdentifier()];
	    this.prodParam.exit();
	    if (this.hasPrecedingLineBreak()) {
	      this.raise(Errors.LineTerminatorBeforeArrow, this.state.curPosition());
	    }
	    this.expect(19);
	    return this.parseArrowExpression(node, params, true);
	  }
	  parseDo(node, isAsync) {
	    this.expectPlugin("doExpressions");
	    if (isAsync) {
	      this.expectPlugin("asyncDoExpressions");
	    }
	    node.async = isAsync;
	    this.next();
	    const oldLabels = this.state.labels;
	    this.state.labels = [];
	    if (isAsync) {
	      this.prodParam.enter(2);
	      node.body = this.parseBlock();
	      this.prodParam.exit();
	    } else {
	      node.body = this.parseBlock();
	    }
	    this.state.labels = oldLabels;
	    return this.finishNode(node, "DoExpression");
	  }
	  parseSuper() {
	    const node = this.startNode();
	    this.next();
	    if (this.match(10) && !this.scope.allowDirectSuper && !this.options.allowSuperOutsideMethod) {
	      this.raise(Errors.SuperNotAllowed, node);
	    } else if (!this.scope.allowSuper && !this.options.allowSuperOutsideMethod) {
	      this.raise(Errors.UnexpectedSuper, node);
	    }
	    if (!this.match(10) && !this.match(0) && !this.match(16)) {
	      this.raise(Errors.UnsupportedSuper, node);
	    }
	    return this.finishNode(node, "Super");
	  }
	  parsePrivateName() {
	    const node = this.startNode();
	    const id = this.startNodeAt(createPositionWithColumnOffset(this.state.startLoc, 1));
	    const name = this.state.value;
	    this.next();
	    node.id = this.createIdentifier(id, name);
	    return this.finishNode(node, "PrivateName");
	  }
	  parseFunctionOrFunctionSent() {
	    const node = this.startNode();
	    this.next();
	    if (this.prodParam.hasYield && this.match(16)) {
	      const meta = this.createIdentifier(this.startNodeAtNode(node), "function");
	      this.next();
	      if (this.match(103)) {
	        this.expectPlugin("functionSent");
	      } else if (!this.hasPlugin("functionSent")) {
	        this.unexpected();
	      }
	      return this.parseMetaProperty(node, meta, "sent");
	    }
	    return this.parseFunction(node);
	  }
	  parseMetaProperty(node, meta, propertyName) {
	    node.meta = meta;
	    const containsEsc = this.state.containsEsc;
	    node.property = this.parseIdentifier(true);
	    if (node.property.name !== propertyName || containsEsc) {
	      this.raise(Errors.UnsupportedMetaProperty, node.property, {
	        target: meta.name,
	        onlyValidPropertyName: propertyName
	      });
	    }
	    return this.finishNode(node, "MetaProperty");
	  }
	  parseImportMetaProperty(node) {
	    const id = this.createIdentifier(this.startNodeAtNode(node), "import");
	    this.next();
	    if (this.isContextual(101)) {
	      if (!this.inModule) {
	        this.raise(Errors.ImportMetaOutsideModule, id);
	      }
	      this.sawUnambiguousESM = true;
	    } else if (this.isContextual(105) || this.isContextual(97)) {
	      const isSource = this.isContextual(105);
	      if (!isSource) this.unexpected();
	      this.expectPlugin(isSource ? "sourcePhaseImports" : "deferredImportEvaluation");
	      if (!this.options.createImportExpressions) {
	        throw this.raise(Errors.DynamicImportPhaseRequiresImportExpressions, this.state.startLoc, {
	          phase: this.state.value
	        });
	      }
	      this.next();
	      node.phase = isSource ? "source" : "defer";
	      return this.parseImportCall(node);
	    }
	    return this.parseMetaProperty(node, id, "meta");
	  }
	  parseLiteralAtNode(value, type, node) {
	    this.addExtra(node, "rawValue", value);
	    this.addExtra(node, "raw", this.input.slice(node.start, this.state.end));
	    node.value = value;
	    this.next();
	    return this.finishNode(node, type);
	  }
	  parseLiteral(value, type) {
	    const node = this.startNode();
	    return this.parseLiteralAtNode(value, type, node);
	  }
	  parseStringLiteral(value) {
	    return this.parseLiteral(value, "StringLiteral");
	  }
	  parseNumericLiteral(value) {
	    return this.parseLiteral(value, "NumericLiteral");
	  }
	  parseBigIntLiteral(value) {
	    return this.parseLiteral(value, "BigIntLiteral");
	  }
	  parseDecimalLiteral(value) {
	    return this.parseLiteral(value, "DecimalLiteral");
	  }
	  parseRegExpLiteral(value) {
	    const node = this.parseLiteral(value.value, "RegExpLiteral");
	    node.pattern = value.pattern;
	    node.flags = value.flags;
	    return node;
	  }
	  parseBooleanLiteral(value) {
	    const node = this.startNode();
	    node.value = value;
	    this.next();
	    return this.finishNode(node, "BooleanLiteral");
	  }
	  parseNullLiteral() {
	    const node = this.startNode();
	    this.next();
	    return this.finishNode(node, "NullLiteral");
	  }
	  parseParenAndDistinguishExpression(canBeArrow) {
	    const startLoc = this.state.startLoc;
	    let val;
	    this.next();
	    this.expressionScope.enter(newArrowHeadScope());
	    const oldMaybeInArrowParameters = this.state.maybeInArrowParameters;
	    const oldInFSharpPipelineDirectBody = this.state.inFSharpPipelineDirectBody;
	    this.state.maybeInArrowParameters = true;
	    this.state.inFSharpPipelineDirectBody = false;
	    const innerStartLoc = this.state.startLoc;
	    const exprList = [];
	    const refExpressionErrors = new ExpressionErrors();
	    let first = true;
	    let spreadStartLoc;
	    let optionalCommaStartLoc;
	    while (!this.match(11)) {
	      if (first) {
	        first = false;
	      } else {
	        this.expect(12, refExpressionErrors.optionalParametersLoc === null ? null : refExpressionErrors.optionalParametersLoc);
	        if (this.match(11)) {
	          optionalCommaStartLoc = this.state.startLoc;
	          break;
	        }
	      }
	      if (this.match(21)) {
	        const spreadNodeStartLoc = this.state.startLoc;
	        spreadStartLoc = this.state.startLoc;
	        exprList.push(this.parseParenItem(this.parseRestBinding(), spreadNodeStartLoc));
	        if (!this.checkCommaAfterRest(41)) {
	          break;
	        }
	      } else {
	        exprList.push(this.parseMaybeAssignAllowIn(refExpressionErrors, this.parseParenItem));
	      }
	    }
	    const innerEndLoc = this.state.lastTokEndLoc;
	    this.expect(11);
	    this.state.maybeInArrowParameters = oldMaybeInArrowParameters;
	    this.state.inFSharpPipelineDirectBody = oldInFSharpPipelineDirectBody;
	    let arrowNode = this.startNodeAt(startLoc);
	    if (canBeArrow && this.shouldParseArrow(exprList) && (arrowNode = this.parseArrow(arrowNode))) {
	      this.checkDestructuringPrivate(refExpressionErrors);
	      this.expressionScope.validateAsPattern();
	      this.expressionScope.exit();
	      this.parseArrowExpression(arrowNode, exprList, false);
	      return arrowNode;
	    }
	    this.expressionScope.exit();
	    if (!exprList.length) {
	      this.unexpected(this.state.lastTokStartLoc);
	    }
	    if (optionalCommaStartLoc) this.unexpected(optionalCommaStartLoc);
	    if (spreadStartLoc) this.unexpected(spreadStartLoc);
	    this.checkExpressionErrors(refExpressionErrors, true);
	    this.toReferencedListDeep(exprList, true);
	    if (exprList.length > 1) {
	      val = this.startNodeAt(innerStartLoc);
	      val.expressions = exprList;
	      this.finishNode(val, "SequenceExpression");
	      this.resetEndLocation(val, innerEndLoc);
	    } else {
	      val = exprList[0];
	    }
	    return this.wrapParenthesis(startLoc, val);
	  }
	  wrapParenthesis(startLoc, expression) {
	    if (!this.options.createParenthesizedExpressions) {
	      this.addExtra(expression, "parenthesized", true);
	      this.addExtra(expression, "parenStart", startLoc.index);
	      this.takeSurroundingComments(expression, startLoc.index, this.state.lastTokEndLoc.index);
	      return expression;
	    }
	    const parenExpression = this.startNodeAt(startLoc);
	    parenExpression.expression = expression;
	    return this.finishNode(parenExpression, "ParenthesizedExpression");
	  }
	  shouldParseArrow(params) {
	    return !this.canInsertSemicolon();
	  }
	  parseArrow(node) {
	    if (this.eat(19)) {
	      return node;
	    }
	  }
	  parseParenItem(node, startLoc) {
	    return node;
	  }
	  parseNewOrNewTarget() {
	    const node = this.startNode();
	    this.next();
	    if (this.match(16)) {
	      const meta = this.createIdentifier(this.startNodeAtNode(node), "new");
	      this.next();
	      const metaProp = this.parseMetaProperty(node, meta, "target");
	      if (!this.scope.inNonArrowFunction && !this.scope.inClass && !this.options.allowNewTargetOutsideFunction) {
	        this.raise(Errors.UnexpectedNewTarget, metaProp);
	      }
	      return metaProp;
	    }
	    return this.parseNew(node);
	  }
	  parseNew(node) {
	    this.parseNewCallee(node);
	    if (this.eat(10)) {
	      const args = this.parseExprList(11);
	      this.toReferencedList(args);
	      node.arguments = args;
	    } else {
	      node.arguments = [];
	    }
	    return this.finishNode(node, "NewExpression");
	  }
	  parseNewCallee(node) {
	    const isImport = this.match(83);
	    const callee = this.parseNoCallExpr();
	    node.callee = callee;
	    if (isImport && (callee.type === "Import" || callee.type === "ImportExpression")) {
	      this.raise(Errors.ImportCallNotNewExpression, callee);
	    }
	  }
	  parseTemplateElement(isTagged) {
	    const {
	      start,
	      startLoc,
	      end,
	      value
	    } = this.state;
	    const elemStart = start + 1;
	    const elem = this.startNodeAt(createPositionWithColumnOffset(startLoc, 1));
	    if (value === null) {
	      if (!isTagged) {
	        this.raise(Errors.InvalidEscapeSequenceTemplate, createPositionWithColumnOffset(this.state.firstInvalidTemplateEscapePos, 1));
	      }
	    }
	    const isTail = this.match(24);
	    const endOffset = isTail ? -1 : -2;
	    const elemEnd = end + endOffset;
	    elem.value = {
	      raw: this.input.slice(elemStart, elemEnd).replace(/\r\n?/g, "\n"),
	      cooked: value === null ? null : value.slice(1, endOffset)
	    };
	    elem.tail = isTail;
	    this.next();
	    const finishedNode = this.finishNode(elem, "TemplateElement");
	    this.resetEndLocation(finishedNode, createPositionWithColumnOffset(this.state.lastTokEndLoc, endOffset));
	    return finishedNode;
	  }
	  parseTemplate(isTagged) {
	    const node = this.startNode();
	    let curElt = this.parseTemplateElement(isTagged);
	    const quasis = [curElt];
	    const substitutions = [];
	    while (!curElt.tail) {
	      substitutions.push(this.parseTemplateSubstitution());
	      this.readTemplateContinuation();
	      quasis.push(curElt = this.parseTemplateElement(isTagged));
	    }
	    node.expressions = substitutions;
	    node.quasis = quasis;
	    return this.finishNode(node, "TemplateLiteral");
	  }
	  parseTemplateSubstitution() {
	    return this.parseExpression();
	  }
	  parseObjectLike(close, isPattern, isRecord, refExpressionErrors) {
	    if (isRecord) {
	      this.expectPlugin("recordAndTuple");
	    }
	    const oldInFSharpPipelineDirectBody = this.state.inFSharpPipelineDirectBody;
	    this.state.inFSharpPipelineDirectBody = false;
	    const propHash = Object.create(null);
	    let first = true;
	    const node = this.startNode();
	    node.properties = [];
	    this.next();
	    while (!this.match(close)) {
	      if (first) {
	        first = false;
	      } else {
	        this.expect(12);
	        if (this.match(close)) {
	          this.addTrailingCommaExtraToNode(node);
	          break;
	        }
	      }
	      let prop;
	      if (isPattern) {
	        prop = this.parseBindingProperty();
	      } else {
	        prop = this.parsePropertyDefinition(refExpressionErrors);
	        this.checkProto(prop, isRecord, propHash, refExpressionErrors);
	      }
	      if (isRecord && !this.isObjectProperty(prop) && prop.type !== "SpreadElement") {
	        this.raise(Errors.InvalidRecordProperty, prop);
	      }
	      if (prop.shorthand) {
	        this.addExtra(prop, "shorthand", true);
	      }
	      node.properties.push(prop);
	    }
	    this.next();
	    this.state.inFSharpPipelineDirectBody = oldInFSharpPipelineDirectBody;
	    let type = "ObjectExpression";
	    if (isPattern) {
	      type = "ObjectPattern";
	    } else if (isRecord) {
	      type = "RecordExpression";
	    }
	    return this.finishNode(node, type);
	  }
	  addTrailingCommaExtraToNode(node) {
	    this.addExtra(node, "trailingComma", this.state.lastTokStartLoc.index);
	    this.addExtra(node, "trailingCommaLoc", this.state.lastTokStartLoc, false);
	  }
	  maybeAsyncOrAccessorProp(prop) {
	    return !prop.computed && prop.key.type === "Identifier" && (this.isLiteralPropertyName() || this.match(0) || this.match(55));
	  }
	  parsePropertyDefinition(refExpressionErrors) {
	    let decorators = [];
	    if (this.match(26)) {
	      if (this.hasPlugin("decorators")) {
	        this.raise(Errors.UnsupportedPropertyDecorator, this.state.startLoc);
	      }
	      while (this.match(26)) {
	        decorators.push(this.parseDecorator());
	      }
	    }
	    const prop = this.startNode();
	    let isAsync = false;
	    let isAccessor = false;
	    let startLoc;
	    if (this.match(21)) {
	      if (decorators.length) this.unexpected();
	      return this.parseSpread();
	    }
	    if (decorators.length) {
	      prop.decorators = decorators;
	      decorators = [];
	    }
	    prop.method = false;
	    if (refExpressionErrors) {
	      startLoc = this.state.startLoc;
	    }
	    let isGenerator = this.eat(55);
	    this.parsePropertyNamePrefixOperator(prop);
	    const containsEsc = this.state.containsEsc;
	    this.parsePropertyName(prop, refExpressionErrors);
	    if (!isGenerator && !containsEsc && this.maybeAsyncOrAccessorProp(prop)) {
	      const {
	        key
	      } = prop;
	      const keyName = key.name;
	      if (keyName === "async" && !this.hasPrecedingLineBreak()) {
	        isAsync = true;
	        this.resetPreviousNodeTrailingComments(key);
	        isGenerator = this.eat(55);
	        this.parsePropertyName(prop);
	      }
	      if (keyName === "get" || keyName === "set") {
	        isAccessor = true;
	        this.resetPreviousNodeTrailingComments(key);
	        prop.kind = keyName;
	        if (this.match(55)) {
	          isGenerator = true;
	          this.raise(Errors.AccessorIsGenerator, this.state.curPosition(), {
	            kind: keyName
	          });
	          this.next();
	        }
	        this.parsePropertyName(prop);
	      }
	    }
	    return this.parseObjPropValue(prop, startLoc, isGenerator, isAsync, false, isAccessor, refExpressionErrors);
	  }
	  getGetterSetterExpectedParamCount(method) {
	    return method.kind === "get" ? 0 : 1;
	  }
	  getObjectOrClassMethodParams(method) {
	    return method.params;
	  }
	  checkGetterSetterParams(method) {
	    var _params;
	    const paramCount = this.getGetterSetterExpectedParamCount(method);
	    const params = this.getObjectOrClassMethodParams(method);
	    if (params.length !== paramCount) {
	      this.raise(method.kind === "get" ? Errors.BadGetterArity : Errors.BadSetterArity, method);
	    }
	    if (method.kind === "set" && ((_params = params[params.length - 1]) == null ? void 0 : _params.type) === "RestElement") {
	      this.raise(Errors.BadSetterRestParameter, method);
	    }
	  }
	  parseObjectMethod(prop, isGenerator, isAsync, isPattern, isAccessor) {
	    if (isAccessor) {
	      const finishedProp = this.parseMethod(prop, isGenerator, false, false, false, "ObjectMethod");
	      this.checkGetterSetterParams(finishedProp);
	      return finishedProp;
	    }
	    if (isAsync || isGenerator || this.match(10)) {
	      if (isPattern) this.unexpected();
	      prop.kind = "method";
	      prop.method = true;
	      return this.parseMethod(prop, isGenerator, isAsync, false, false, "ObjectMethod");
	    }
	  }
	  parseObjectProperty(prop, startLoc, isPattern, refExpressionErrors) {
	    prop.shorthand = false;
	    if (this.eat(14)) {
	      prop.value = isPattern ? this.parseMaybeDefault(this.state.startLoc) : this.parseMaybeAssignAllowIn(refExpressionErrors);
	      return this.finishNode(prop, "ObjectProperty");
	    }
	    if (!prop.computed && prop.key.type === "Identifier") {
	      this.checkReservedWord(prop.key.name, prop.key.loc.start, true, false);
	      if (isPattern) {
	        prop.value = this.parseMaybeDefault(startLoc, cloneIdentifier(prop.key));
	      } else if (this.match(29)) {
	        const shorthandAssignLoc = this.state.startLoc;
	        if (refExpressionErrors != null) {
	          if (refExpressionErrors.shorthandAssignLoc === null) {
	            refExpressionErrors.shorthandAssignLoc = shorthandAssignLoc;
	          }
	        } else {
	          this.raise(Errors.InvalidCoverInitializedName, shorthandAssignLoc);
	        }
	        prop.value = this.parseMaybeDefault(startLoc, cloneIdentifier(prop.key));
	      } else {
	        prop.value = cloneIdentifier(prop.key);
	      }
	      prop.shorthand = true;
	      return this.finishNode(prop, "ObjectProperty");
	    }
	  }
	  parseObjPropValue(prop, startLoc, isGenerator, isAsync, isPattern, isAccessor, refExpressionErrors) {
	    const node = this.parseObjectMethod(prop, isGenerator, isAsync, isPattern, isAccessor) || this.parseObjectProperty(prop, startLoc, isPattern, refExpressionErrors);
	    if (!node) this.unexpected();
	    return node;
	  }
	  parsePropertyName(prop, refExpressionErrors) {
	    if (this.eat(0)) {
	      prop.computed = true;
	      prop.key = this.parseMaybeAssignAllowIn();
	      this.expect(3);
	    } else {
	      const {
	        type,
	        value
	      } = this.state;
	      let key;
	      if (tokenIsKeywordOrIdentifier(type)) {
	        key = this.parseIdentifier(true);
	      } else {
	        switch (type) {
	          case 134:
	            key = this.parseNumericLiteral(value);
	            break;
	          case 133:
	            key = this.parseStringLiteral(value);
	            break;
	          case 135:
	            key = this.parseBigIntLiteral(value);
	            break;
	          case 136:
	            key = this.parseDecimalLiteral(value);
	            break;
	          case 138:
	            {
	              const privateKeyLoc = this.state.startLoc;
	              if (refExpressionErrors != null) {
	                if (refExpressionErrors.privateKeyLoc === null) {
	                  refExpressionErrors.privateKeyLoc = privateKeyLoc;
	                }
	              } else {
	                this.raise(Errors.UnexpectedPrivateField, privateKeyLoc);
	              }
	              key = this.parsePrivateName();
	              break;
	            }
	          default:
	            this.unexpected();
	        }
	      }
	      prop.key = key;
	      if (type !== 138) {
	        prop.computed = false;
	      }
	    }
	  }
	  initFunction(node, isAsync) {
	    node.id = null;
	    node.generator = false;
	    node.async = isAsync;
	  }
	  parseMethod(node, isGenerator, isAsync, isConstructor, allowDirectSuper, type, inClassScope = false) {
	    this.initFunction(node, isAsync);
	    node.generator = isGenerator;
	    this.scope.enter(2 | 16 | (inClassScope ? 64 : 0) | (allowDirectSuper ? 32 : 0));
	    this.prodParam.enter(functionFlags(isAsync, node.generator));
	    this.parseFunctionParams(node, isConstructor);
	    const finishedNode = this.parseFunctionBodyAndFinish(node, type, true);
	    this.prodParam.exit();
	    this.scope.exit();
	    return finishedNode;
	  }
	  parseArrayLike(close, canBePattern, isTuple, refExpressionErrors) {
	    if (isTuple) {
	      this.expectPlugin("recordAndTuple");
	    }
	    const oldInFSharpPipelineDirectBody = this.state.inFSharpPipelineDirectBody;
	    this.state.inFSharpPipelineDirectBody = false;
	    const node = this.startNode();
	    this.next();
	    node.elements = this.parseExprList(close, !isTuple, refExpressionErrors, node);
	    this.state.inFSharpPipelineDirectBody = oldInFSharpPipelineDirectBody;
	    return this.finishNode(node, isTuple ? "TupleExpression" : "ArrayExpression");
	  }
	  parseArrowExpression(node, params, isAsync, trailingCommaLoc) {
	    this.scope.enter(2 | 4);
	    let flags = functionFlags(isAsync, false);
	    if (!this.match(5) && this.prodParam.hasIn) {
	      flags |= 8;
	    }
	    this.prodParam.enter(flags);
	    this.initFunction(node, isAsync);
	    const oldMaybeInArrowParameters = this.state.maybeInArrowParameters;
	    if (params) {
	      this.state.maybeInArrowParameters = true;
	      this.setArrowFunctionParameters(node, params, trailingCommaLoc);
	    }
	    this.state.maybeInArrowParameters = false;
	    this.parseFunctionBody(node, true);
	    this.prodParam.exit();
	    this.scope.exit();
	    this.state.maybeInArrowParameters = oldMaybeInArrowParameters;
	    return this.finishNode(node, "ArrowFunctionExpression");
	  }
	  setArrowFunctionParameters(node, params, trailingCommaLoc) {
	    this.toAssignableList(params, trailingCommaLoc, false);
	    node.params = params;
	  }
	  parseFunctionBodyAndFinish(node, type, isMethod = false) {
	    this.parseFunctionBody(node, false, isMethod);
	    return this.finishNode(node, type);
	  }
	  parseFunctionBody(node, allowExpression, isMethod = false) {
	    const isExpression = allowExpression && !this.match(5);
	    this.expressionScope.enter(newExpressionScope());
	    if (isExpression) {
	      node.body = this.parseMaybeAssign();
	      this.checkParams(node, false, allowExpression, false);
	    } else {
	      const oldStrict = this.state.strict;
	      const oldLabels = this.state.labels;
	      this.state.labels = [];
	      this.prodParam.enter(this.prodParam.currentFlags() | 4);
	      node.body = this.parseBlock(true, false, hasStrictModeDirective => {
	        const nonSimple = !this.isSimpleParamList(node.params);
	        if (hasStrictModeDirective && nonSimple) {
	          this.raise(Errors.IllegalLanguageModeDirective, (node.kind === "method" || node.kind === "constructor") && !!node.key ? node.key.loc.end : node);
	        }
	        const strictModeChanged = !oldStrict && this.state.strict;
	        this.checkParams(node, !this.state.strict && !allowExpression && !isMethod && !nonSimple, allowExpression, strictModeChanged);
	        if (this.state.strict && node.id) {
	          this.checkIdentifier(node.id, 65, strictModeChanged);
	        }
	      });
	      this.prodParam.exit();
	      this.state.labels = oldLabels;
	    }
	    this.expressionScope.exit();
	  }
	  isSimpleParameter(node) {
	    return node.type === "Identifier";
	  }
	  isSimpleParamList(params) {
	    for (let i = 0, len = params.length; i < len; i++) {
	      if (!this.isSimpleParameter(params[i])) return false;
	    }
	    return true;
	  }
	  checkParams(node, allowDuplicates, isArrowFunction, strictModeChanged = true) {
	    const checkClashes = !allowDuplicates && new Set();
	    const formalParameters = {
	      type: "FormalParameters"
	    };
	    for (const param of node.params) {
	      this.checkLVal(param, {
	        in: formalParameters,
	        binding: 5,
	        checkClashes,
	        strictModeChanged
	      });
	    }
	  }
	  parseExprList(close, allowEmpty, refExpressionErrors, nodeForExtra) {
	    const elts = [];
	    let first = true;
	    while (!this.eat(close)) {
	      if (first) {
	        first = false;
	      } else {
	        this.expect(12);
	        if (this.match(close)) {
	          if (nodeForExtra) {
	            this.addTrailingCommaExtraToNode(nodeForExtra);
	          }
	          this.next();
	          break;
	        }
	      }
	      elts.push(this.parseExprListItem(allowEmpty, refExpressionErrors));
	    }
	    return elts;
	  }
	  parseExprListItem(allowEmpty, refExpressionErrors, allowPlaceholder) {
	    let elt;
	    if (this.match(12)) {
	      if (!allowEmpty) {
	        this.raise(Errors.UnexpectedToken, this.state.curPosition(), {
	          unexpected: ","
	        });
	      }
	      elt = null;
	    } else if (this.match(21)) {
	      const spreadNodeStartLoc = this.state.startLoc;
	      elt = this.parseParenItem(this.parseSpread(refExpressionErrors), spreadNodeStartLoc);
	    } else if (this.match(17)) {
	      this.expectPlugin("partialApplication");
	      if (!allowPlaceholder) {
	        this.raise(Errors.UnexpectedArgumentPlaceholder, this.state.startLoc);
	      }
	      const node = this.startNode();
	      this.next();
	      elt = this.finishNode(node, "ArgumentPlaceholder");
	    } else {
	      elt = this.parseMaybeAssignAllowIn(refExpressionErrors, this.parseParenItem);
	    }
	    return elt;
	  }
	  parseIdentifier(liberal) {
	    const node = this.startNode();
	    const name = this.parseIdentifierName(liberal);
	    return this.createIdentifier(node, name);
	  }
	  createIdentifier(node, name) {
	    node.name = name;
	    node.loc.identifierName = name;
	    return this.finishNode(node, "Identifier");
	  }
	  parseIdentifierName(liberal) {
	    let name;
	    const {
	      startLoc,
	      type
	    } = this.state;
	    if (tokenIsKeywordOrIdentifier(type)) {
	      name = this.state.value;
	    } else {
	      this.unexpected();
	    }
	    const tokenIsKeyword = tokenKeywordOrIdentifierIsKeyword(type);
	    if (liberal) {
	      if (tokenIsKeyword) {
	        this.replaceToken(132);
	      }
	    } else {
	      this.checkReservedWord(name, startLoc, tokenIsKeyword, false);
	    }
	    this.next();
	    return name;
	  }
	  checkReservedWord(word, startLoc, checkKeywords, isBinding) {
	    if (word.length > 10) {
	      return;
	    }
	    if (!canBeReservedWord(word)) {
	      return;
	    }
	    if (checkKeywords && isKeyword(word)) {
	      this.raise(Errors.UnexpectedKeyword, startLoc, {
	        keyword: word
	      });
	      return;
	    }
	    const reservedTest = !this.state.strict ? isReservedWord : isBinding ? isStrictBindReservedWord : isStrictReservedWord;
	    if (reservedTest(word, this.inModule)) {
	      this.raise(Errors.UnexpectedReservedWord, startLoc, {
	        reservedWord: word
	      });
	      return;
	    } else if (word === "yield") {
	      if (this.prodParam.hasYield) {
	        this.raise(Errors.YieldBindingIdentifier, startLoc);
	        return;
	      }
	    } else if (word === "await") {
	      if (this.prodParam.hasAwait) {
	        this.raise(Errors.AwaitBindingIdentifier, startLoc);
	        return;
	      }
	      if (this.scope.inStaticBlock) {
	        this.raise(Errors.AwaitBindingIdentifierInStaticBlock, startLoc);
	        return;
	      }
	      this.expressionScope.recordAsyncArrowParametersError(startLoc);
	    } else if (word === "arguments") {
	      if (this.scope.inClassAndNotInNonArrowFunction) {
	        this.raise(Errors.ArgumentsInClass, startLoc);
	        return;
	      }
	    }
	  }
	  isAwaitAllowed() {
	    if (this.prodParam.hasAwait) return true;
	    if (this.options.allowAwaitOutsideFunction && !this.scope.inFunction) {
	      return true;
	    }
	    return false;
	  }
	  parseAwait(startLoc) {
	    const node = this.startNodeAt(startLoc);
	    this.expressionScope.recordParameterInitializerError(Errors.AwaitExpressionFormalParameter, node);
	    if (this.eat(55)) {
	      this.raise(Errors.ObsoleteAwaitStar, node);
	    }
	    if (!this.scope.inFunction && !this.options.allowAwaitOutsideFunction) {
	      if (this.isAmbiguousAwait()) {
	        this.ambiguousScriptDifferentAst = true;
	      } else {
	        this.sawUnambiguousESM = true;
	      }
	    }
	    if (!this.state.soloAwait) {
	      node.argument = this.parseMaybeUnary(null, true);
	    }
	    return this.finishNode(node, "AwaitExpression");
	  }
	  isAmbiguousAwait() {
	    if (this.hasPrecedingLineBreak()) return true;
	    const {
	      type
	    } = this.state;
	    return type === 53 || type === 10 || type === 0 || tokenIsTemplate(type) || type === 102 && !this.state.containsEsc || type === 137 || type === 56 || this.hasPlugin("v8intrinsic") && type === 54;
	  }
	  parseYield() {
	    const node = this.startNode();
	    this.expressionScope.recordParameterInitializerError(Errors.YieldInParameter, node);
	    this.next();
	    let delegating = false;
	    let argument = null;
	    if (!this.hasPrecedingLineBreak()) {
	      delegating = this.eat(55);
	      switch (this.state.type) {
	        case 13:
	        case 139:
	        case 8:
	        case 11:
	        case 3:
	        case 9:
	        case 14:
	        case 12:
	          if (!delegating) break;
	        default:
	          argument = this.parseMaybeAssign();
	      }
	    }
	    node.delegate = delegating;
	    node.argument = argument;
	    return this.finishNode(node, "YieldExpression");
	  }
	  parseImportCall(node) {
	    this.next();
	    node.source = this.parseMaybeAssignAllowIn();
	    if (this.hasPlugin("importAttributes") || this.hasPlugin("importAssertions")) {
	      node.options = null;
	    }
	    if (this.eat(12)) {
	      this.expectImportAttributesPlugin();
	      if (!this.match(11)) {
	        node.options = this.parseMaybeAssignAllowIn();
	        this.eat(12);
	      }
	    }
	    this.expect(11);
	    return this.finishNode(node, "ImportExpression");
	  }
	  checkPipelineAtInfixOperator(left, leftStartLoc) {
	    if (this.hasPlugin(["pipelineOperator", {
	      proposal: "smart"
	    }])) {
	      if (left.type === "SequenceExpression") {
	        this.raise(Errors.PipelineHeadSequenceExpression, leftStartLoc);
	      }
	    }
	  }
	  parseSmartPipelineBodyInStyle(childExpr, startLoc) {
	    if (this.isSimpleReference(childExpr)) {
	      const bodyNode = this.startNodeAt(startLoc);
	      bodyNode.callee = childExpr;
	      return this.finishNode(bodyNode, "PipelineBareFunction");
	    } else {
	      const bodyNode = this.startNodeAt(startLoc);
	      this.checkSmartPipeTopicBodyEarlyErrors(startLoc);
	      bodyNode.expression = childExpr;
	      return this.finishNode(bodyNode, "PipelineTopicExpression");
	    }
	  }
	  isSimpleReference(expression) {
	    switch (expression.type) {
	      case "MemberExpression":
	        return !expression.computed && this.isSimpleReference(expression.object);
	      case "Identifier":
	        return true;
	      default:
	        return false;
	    }
	  }
	  checkSmartPipeTopicBodyEarlyErrors(startLoc) {
	    if (this.match(19)) {
	      throw this.raise(Errors.PipelineBodyNoArrow, this.state.startLoc);
	    }
	    if (!this.topicReferenceWasUsedInCurrentContext()) {
	      this.raise(Errors.PipelineTopicUnused, startLoc);
	    }
	  }
	  withTopicBindingContext(callback) {
	    const outerContextTopicState = this.state.topicContext;
	    this.state.topicContext = {
	      maxNumOfResolvableTopics: 1,
	      maxTopicIndex: null
	    };
	    try {
	      return callback();
	    } finally {
	      this.state.topicContext = outerContextTopicState;
	    }
	  }
	  withSmartMixTopicForbiddingContext(callback) {
	    if (this.hasPlugin(["pipelineOperator", {
	      proposal: "smart"
	    }])) {
	      const outerContextTopicState = this.state.topicContext;
	      this.state.topicContext = {
	        maxNumOfResolvableTopics: 0,
	        maxTopicIndex: null
	      };
	      try {
	        return callback();
	      } finally {
	        this.state.topicContext = outerContextTopicState;
	      }
	    } else {
	      return callback();
	    }
	  }
	  withSoloAwaitPermittingContext(callback) {
	    const outerContextSoloAwaitState = this.state.soloAwait;
	    this.state.soloAwait = true;
	    try {
	      return callback();
	    } finally {
	      this.state.soloAwait = outerContextSoloAwaitState;
	    }
	  }
	  allowInAnd(callback) {
	    const flags = this.prodParam.currentFlags();
	    const prodParamToSet = 8 & ~flags;
	    if (prodParamToSet) {
	      this.prodParam.enter(flags | 8);
	      try {
	        return callback();
	      } finally {
	        this.prodParam.exit();
	      }
	    }
	    return callback();
	  }
	  disallowInAnd(callback) {
	    const flags = this.prodParam.currentFlags();
	    const prodParamToClear = 8 & flags;
	    if (prodParamToClear) {
	      this.prodParam.enter(flags & ~8);
	      try {
	        return callback();
	      } finally {
	        this.prodParam.exit();
	      }
	    }
	    return callback();
	  }
	  registerTopicReference() {
	    this.state.topicContext.maxTopicIndex = 0;
	  }
	  topicReferenceIsAllowedInCurrentContext() {
	    return this.state.topicContext.maxNumOfResolvableTopics >= 1;
	  }
	  topicReferenceWasUsedInCurrentContext() {
	    return this.state.topicContext.maxTopicIndex != null && this.state.topicContext.maxTopicIndex >= 0;
	  }
	  parseFSharpPipelineBody(prec) {
	    const startLoc = this.state.startLoc;
	    this.state.potentialArrowAt = this.state.start;
	    const oldInFSharpPipelineDirectBody = this.state.inFSharpPipelineDirectBody;
	    this.state.inFSharpPipelineDirectBody = true;
	    const ret = this.parseExprOp(this.parseMaybeUnaryOrPrivate(), startLoc, prec);
	    this.state.inFSharpPipelineDirectBody = oldInFSharpPipelineDirectBody;
	    return ret;
	  }
	  parseModuleExpression() {
	    this.expectPlugin("moduleBlocks");
	    const node = this.startNode();
	    this.next();
	    if (!this.match(5)) {
	      this.unexpected(null, 5);
	    }
	    const program = this.startNodeAt(this.state.endLoc);
	    this.next();
	    const revertScopes = this.initializeScopes(true);
	    this.enterInitialScopes();
	    try {
	      node.body = this.parseProgram(program, 8, "module");
	    } finally {
	      revertScopes();
	    }
	    return this.finishNode(node, "ModuleExpression");
	  }
	  parsePropertyNamePrefixOperator(prop) {}
	}
	const loopLabel = {
	    kind: 1
	  },
	  switchLabel = {
	    kind: 2
	  };
	const loneSurrogate = /[\uD800-\uDFFF]/u;
	const keywordRelationalOperator = /in(?:stanceof)?/y;
	function babel7CompatTokens(tokens, input) {
	  for (let i = 0; i < tokens.length; i++) {
	    const token = tokens[i];
	    const {
	      type
	    } = token;
	    if (typeof type === "number") {
	      {
	        if (type === 138) {
	          const {
	            loc,
	            start,
	            value,
	            end
	          } = token;
	          const hashEndPos = start + 1;
	          const hashEndLoc = createPositionWithColumnOffset(loc.start, 1);
	          tokens.splice(i, 1, new Token({
	            type: getExportedToken(27),
	            value: "#",
	            start: start,
	            end: hashEndPos,
	            startLoc: loc.start,
	            endLoc: hashEndLoc
	          }), new Token({
	            type: getExportedToken(132),
	            value: value,
	            start: hashEndPos,
	            end: end,
	            startLoc: hashEndLoc,
	            endLoc: loc.end
	          }));
	          i++;
	          continue;
	        }
	        if (tokenIsTemplate(type)) {
	          const {
	            loc,
	            start,
	            value,
	            end
	          } = token;
	          const backquoteEnd = start + 1;
	          const backquoteEndLoc = createPositionWithColumnOffset(loc.start, 1);
	          let startToken;
	          if (input.charCodeAt(start) === 96) {
	            startToken = new Token({
	              type: getExportedToken(22),
	              value: "`",
	              start: start,
	              end: backquoteEnd,
	              startLoc: loc.start,
	              endLoc: backquoteEndLoc
	            });
	          } else {
	            startToken = new Token({
	              type: getExportedToken(8),
	              value: "}",
	              start: start,
	              end: backquoteEnd,
	              startLoc: loc.start,
	              endLoc: backquoteEndLoc
	            });
	          }
	          let templateValue, templateElementEnd, templateElementEndLoc, endToken;
	          if (type === 24) {
	            templateElementEnd = end - 1;
	            templateElementEndLoc = createPositionWithColumnOffset(loc.end, -1);
	            templateValue = value === null ? null : value.slice(1, -1);
	            endToken = new Token({
	              type: getExportedToken(22),
	              value: "`",
	              start: templateElementEnd,
	              end: end,
	              startLoc: templateElementEndLoc,
	              endLoc: loc.end
	            });
	          } else {
	            templateElementEnd = end - 2;
	            templateElementEndLoc = createPositionWithColumnOffset(loc.end, -2);
	            templateValue = value === null ? null : value.slice(1, -2);
	            endToken = new Token({
	              type: getExportedToken(23),
	              value: "${",
	              start: templateElementEnd,
	              end: end,
	              startLoc: templateElementEndLoc,
	              endLoc: loc.end
	            });
	          }
	          tokens.splice(i, 1, startToken, new Token({
	            type: getExportedToken(20),
	            value: templateValue,
	            start: backquoteEnd,
	            end: templateElementEnd,
	            startLoc: backquoteEndLoc,
	            endLoc: templateElementEndLoc
	          }), endToken);
	          i += 2;
	          continue;
	        }
	      }
	      token.type = getExportedToken(type);
	    }
	  }
	  return tokens;
	}
	class StatementParser extends ExpressionParser {
	  parseTopLevel(file, program) {
	    file.program = this.parseProgram(program);
	    file.comments = this.comments;
	    if (this.options.tokens) {
	      file.tokens = babel7CompatTokens(this.tokens, this.input);
	    }
	    return this.finishNode(file, "File");
	  }
	  parseProgram(program, end = 139, sourceType = this.options.sourceType) {
	    program.sourceType = sourceType;
	    program.interpreter = this.parseInterpreterDirective();
	    this.parseBlockBody(program, true, true, end);
	    if (this.inModule && !this.options.allowUndeclaredExports && this.scope.undefinedExports.size > 0) {
	      for (const [localName, at] of Array.from(this.scope.undefinedExports)) {
	        this.raise(Errors.ModuleExportUndefined, at, {
	          localName
	        });
	      }
	    }
	    let finishedProgram;
	    if (end === 139) {
	      finishedProgram = this.finishNode(program, "Program");
	    } else {
	      finishedProgram = this.finishNodeAt(program, "Program", createPositionWithColumnOffset(this.state.startLoc, -1));
	    }
	    return finishedProgram;
	  }
	  stmtToDirective(stmt) {
	    const directive = stmt;
	    directive.type = "Directive";
	    directive.value = directive.expression;
	    delete directive.expression;
	    const directiveLiteral = directive.value;
	    const expressionValue = directiveLiteral.value;
	    const raw = this.input.slice(directiveLiteral.start, directiveLiteral.end);
	    const val = directiveLiteral.value = raw.slice(1, -1);
	    this.addExtra(directiveLiteral, "raw", raw);
	    this.addExtra(directiveLiteral, "rawValue", val);
	    this.addExtra(directiveLiteral, "expressionValue", expressionValue);
	    directiveLiteral.type = "DirectiveLiteral";
	    return directive;
	  }
	  parseInterpreterDirective() {
	    if (!this.match(28)) {
	      return null;
	    }
	    const node = this.startNode();
	    node.value = this.state.value;
	    this.next();
	    return this.finishNode(node, "InterpreterDirective");
	  }
	  isLet() {
	    if (!this.isContextual(100)) {
	      return false;
	    }
	    return this.hasFollowingBindingAtom();
	  }
	  chStartsBindingIdentifier(ch, pos) {
	    if (isIdentifierStart(ch)) {
	      keywordRelationalOperator.lastIndex = pos;
	      if (keywordRelationalOperator.test(this.input)) {
	        const endCh = this.codePointAtPos(keywordRelationalOperator.lastIndex);
	        if (!isIdentifierChar(endCh) && endCh !== 92) {
	          return false;
	        }
	      }
	      return true;
	    } else if (ch === 92) {
	      return true;
	    } else {
	      return false;
	    }
	  }
	  chStartsBindingPattern(ch) {
	    return ch === 91 || ch === 123;
	  }
	  hasFollowingBindingAtom() {
	    const next = this.nextTokenStart();
	    const nextCh = this.codePointAtPos(next);
	    return this.chStartsBindingPattern(nextCh) || this.chStartsBindingIdentifier(nextCh, next);
	  }
	  hasInLineFollowingBindingIdentifier() {
	    const next = this.nextTokenInLineStart();
	    const nextCh = this.codePointAtPos(next);
	    return this.chStartsBindingIdentifier(nextCh, next);
	  }
	  startsUsingForOf() {
	    const {
	      type,
	      containsEsc
	    } = this.lookahead();
	    if (type === 102 && !containsEsc) {
	      return false;
	    } else if (tokenIsIdentifier(type) && !this.hasFollowingLineBreak()) {
	      this.expectPlugin("explicitResourceManagement");
	      return true;
	    }
	  }
	  startsAwaitUsing() {
	    let next = this.nextTokenInLineStart();
	    if (this.isUnparsedContextual(next, "using")) {
	      next = this.nextTokenInLineStartSince(next + 5);
	      const nextCh = this.codePointAtPos(next);
	      if (this.chStartsBindingIdentifier(nextCh, next)) {
	        this.expectPlugin("explicitResourceManagement");
	        return true;
	      }
	    }
	    return false;
	  }
	  parseModuleItem() {
	    return this.parseStatementLike(1 | 2 | 4 | 8);
	  }
	  parseStatementListItem() {
	    return this.parseStatementLike(2 | 4 | (!this.options.annexB || this.state.strict ? 0 : 8));
	  }
	  parseStatementOrSloppyAnnexBFunctionDeclaration(allowLabeledFunction = false) {
	    let flags = 0;
	    if (this.options.annexB && !this.state.strict) {
	      flags |= 4;
	      if (allowLabeledFunction) {
	        flags |= 8;
	      }
	    }
	    return this.parseStatementLike(flags);
	  }
	  parseStatement() {
	    return this.parseStatementLike(0);
	  }
	  parseStatementLike(flags) {
	    let decorators = null;
	    if (this.match(26)) {
	      decorators = this.parseDecorators(true);
	    }
	    return this.parseStatementContent(flags, decorators);
	  }
	  parseStatementContent(flags, decorators) {
	    const starttype = this.state.type;
	    const node = this.startNode();
	    const allowDeclaration = !!(flags & 2);
	    const allowFunctionDeclaration = !!(flags & 4);
	    const topLevel = flags & 1;
	    switch (starttype) {
	      case 60:
	        return this.parseBreakContinueStatement(node, true);
	      case 63:
	        return this.parseBreakContinueStatement(node, false);
	      case 64:
	        return this.parseDebuggerStatement(node);
	      case 90:
	        return this.parseDoWhileStatement(node);
	      case 91:
	        return this.parseForStatement(node);
	      case 68:
	        if (this.lookaheadCharCode() === 46) break;
	        if (!allowFunctionDeclaration) {
	          this.raise(this.state.strict ? Errors.StrictFunction : this.options.annexB ? Errors.SloppyFunctionAnnexB : Errors.SloppyFunction, this.state.startLoc);
	        }
	        return this.parseFunctionStatement(node, false, !allowDeclaration && allowFunctionDeclaration);
	      case 80:
	        if (!allowDeclaration) this.unexpected();
	        return this.parseClass(this.maybeTakeDecorators(decorators, node), true);
	      case 69:
	        return this.parseIfStatement(node);
	      case 70:
	        return this.parseReturnStatement(node);
	      case 71:
	        return this.parseSwitchStatement(node);
	      case 72:
	        return this.parseThrowStatement(node);
	      case 73:
	        return this.parseTryStatement(node);
	      case 96:
	        if (!this.state.containsEsc && this.startsAwaitUsing()) {
	          if (!this.isAwaitAllowed()) {
	            this.raise(Errors.AwaitUsingNotInAsyncContext, node);
	          } else if (!allowDeclaration) {
	            this.raise(Errors.UnexpectedLexicalDeclaration, node);
	          }
	          this.next();
	          return this.parseVarStatement(node, "await using");
	        }
	        break;
	      case 107:
	        if (this.state.containsEsc || !this.hasInLineFollowingBindingIdentifier()) {
	          break;
	        }
	        this.expectPlugin("explicitResourceManagement");
	        if (!this.scope.inModule && this.scope.inTopLevel) {
	          this.raise(Errors.UnexpectedUsingDeclaration, this.state.startLoc);
	        } else if (!allowDeclaration) {
	          this.raise(Errors.UnexpectedLexicalDeclaration, this.state.startLoc);
	        }
	        return this.parseVarStatement(node, "using");
	      case 100:
	        {
	          if (this.state.containsEsc) {
	            break;
	          }
	          const next = this.nextTokenStart();
	          const nextCh = this.codePointAtPos(next);
	          if (nextCh !== 91) {
	            if (!allowDeclaration && this.hasFollowingLineBreak()) break;
	            if (!this.chStartsBindingIdentifier(nextCh, next) && nextCh !== 123) {
	              break;
	            }
	          }
	        }
	      case 75:
	        {
	          if (!allowDeclaration) {
	            this.raise(Errors.UnexpectedLexicalDeclaration, this.state.startLoc);
	          }
	        }
	      case 74:
	        {
	          const kind = this.state.value;
	          return this.parseVarStatement(node, kind);
	        }
	      case 92:
	        return this.parseWhileStatement(node);
	      case 76:
	        return this.parseWithStatement(node);
	      case 5:
	        return this.parseBlock();
	      case 13:
	        return this.parseEmptyStatement(node);
	      case 83:
	        {
	          const nextTokenCharCode = this.lookaheadCharCode();
	          if (nextTokenCharCode === 40 || nextTokenCharCode === 46) {
	            break;
	          }
	        }
	      case 82:
	        {
	          if (!this.options.allowImportExportEverywhere && !topLevel) {
	            this.raise(Errors.UnexpectedImportExport, this.state.startLoc);
	          }
	          this.next();
	          let result;
	          if (starttype === 83) {
	            result = this.parseImport(node);
	            if (result.type === "ImportDeclaration" && (!result.importKind || result.importKind === "value")) {
	              this.sawUnambiguousESM = true;
	            }
	          } else {
	            result = this.parseExport(node, decorators);
	            if (result.type === "ExportNamedDeclaration" && (!result.exportKind || result.exportKind === "value") || result.type === "ExportAllDeclaration" && (!result.exportKind || result.exportKind === "value") || result.type === "ExportDefaultDeclaration") {
	              this.sawUnambiguousESM = true;
	            }
	          }
	          this.assertModuleNodeAllowed(result);
	          return result;
	        }
	      default:
	        {
	          if (this.isAsyncFunction()) {
	            if (!allowDeclaration) {
	              this.raise(Errors.AsyncFunctionInSingleStatementContext, this.state.startLoc);
	            }
	            this.next();
	            return this.parseFunctionStatement(node, true, !allowDeclaration && allowFunctionDeclaration);
	          }
	        }
	    }
	    const maybeName = this.state.value;
	    const expr = this.parseExpression();
	    if (tokenIsIdentifier(starttype) && expr.type === "Identifier" && this.eat(14)) {
	      return this.parseLabeledStatement(node, maybeName, expr, flags);
	    } else {
	      return this.parseExpressionStatement(node, expr, decorators);
	    }
	  }
	  assertModuleNodeAllowed(node) {
	    if (!this.options.allowImportExportEverywhere && !this.inModule) {
	      this.raise(Errors.ImportOutsideModule, node);
	    }
	  }
	  decoratorsEnabledBeforeExport() {
	    if (this.hasPlugin("decorators-legacy")) return true;
	    return this.hasPlugin("decorators") && this.getPluginOption("decorators", "decoratorsBeforeExport") !== false;
	  }
	  maybeTakeDecorators(maybeDecorators, classNode, exportNode) {
	    if (maybeDecorators) {
	      if (classNode.decorators && classNode.decorators.length > 0) {
	        if (typeof this.getPluginOption("decorators", "decoratorsBeforeExport") !== "boolean") {
	          this.raise(Errors.DecoratorsBeforeAfterExport, classNode.decorators[0]);
	        }
	        classNode.decorators.unshift(...maybeDecorators);
	      } else {
	        classNode.decorators = maybeDecorators;
	      }
	      this.resetStartLocationFromNode(classNode, maybeDecorators[0]);
	      if (exportNode) this.resetStartLocationFromNode(exportNode, classNode);
	    }
	    return classNode;
	  }
	  canHaveLeadingDecorator() {
	    return this.match(80);
	  }
	  parseDecorators(allowExport) {
	    const decorators = [];
	    do {
	      decorators.push(this.parseDecorator());
	    } while (this.match(26));
	    if (this.match(82)) {
	      if (!allowExport) {
	        this.unexpected();
	      }
	      if (!this.decoratorsEnabledBeforeExport()) {
	        this.raise(Errors.DecoratorExportClass, this.state.startLoc);
	      }
	    } else if (!this.canHaveLeadingDecorator()) {
	      throw this.raise(Errors.UnexpectedLeadingDecorator, this.state.startLoc);
	    }
	    return decorators;
	  }
	  parseDecorator() {
	    this.expectOnePlugin(["decorators", "decorators-legacy"]);
	    const node = this.startNode();
	    this.next();
	    if (this.hasPlugin("decorators")) {
	      const startLoc = this.state.startLoc;
	      let expr;
	      if (this.match(10)) {
	        const startLoc = this.state.startLoc;
	        this.next();
	        expr = this.parseExpression();
	        this.expect(11);
	        expr = this.wrapParenthesis(startLoc, expr);
	        const paramsStartLoc = this.state.startLoc;
	        node.expression = this.parseMaybeDecoratorArguments(expr);
	        if (this.getPluginOption("decorators", "allowCallParenthesized") === false && node.expression !== expr) {
	          this.raise(Errors.DecoratorArgumentsOutsideParentheses, paramsStartLoc);
	        }
	      } else {
	        expr = this.parseIdentifier(false);
	        while (this.eat(16)) {
	          const node = this.startNodeAt(startLoc);
	          node.object = expr;
	          if (this.match(138)) {
	            this.classScope.usePrivateName(this.state.value, this.state.startLoc);
	            node.property = this.parsePrivateName();
	          } else {
	            node.property = this.parseIdentifier(true);
	          }
	          node.computed = false;
	          expr = this.finishNode(node, "MemberExpression");
	        }
	        node.expression = this.parseMaybeDecoratorArguments(expr);
	      }
	    } else {
	      node.expression = this.parseExprSubscripts();
	    }
	    return this.finishNode(node, "Decorator");
	  }
	  parseMaybeDecoratorArguments(expr) {
	    if (this.eat(10)) {
	      const node = this.startNodeAtNode(expr);
	      node.callee = expr;
	      node.arguments = this.parseCallExpressionArguments(11, false);
	      this.toReferencedList(node.arguments);
	      return this.finishNode(node, "CallExpression");
	    }
	    return expr;
	  }
	  parseBreakContinueStatement(node, isBreak) {
	    this.next();
	    if (this.isLineTerminator()) {
	      node.label = null;
	    } else {
	      node.label = this.parseIdentifier();
	      this.semicolon();
	    }
	    this.verifyBreakContinue(node, isBreak);
	    return this.finishNode(node, isBreak ? "BreakStatement" : "ContinueStatement");
	  }
	  verifyBreakContinue(node, isBreak) {
	    let i;
	    for (i = 0; i < this.state.labels.length; ++i) {
	      const lab = this.state.labels[i];
	      if (node.label == null || lab.name === node.label.name) {
	        if (lab.kind != null && (isBreak || lab.kind === 1)) {
	          break;
	        }
	        if (node.label && isBreak) break;
	      }
	    }
	    if (i === this.state.labels.length) {
	      const type = isBreak ? "BreakStatement" : "ContinueStatement";
	      this.raise(Errors.IllegalBreakContinue, node, {
	        type
	      });
	    }
	  }
	  parseDebuggerStatement(node) {
	    this.next();
	    this.semicolon();
	    return this.finishNode(node, "DebuggerStatement");
	  }
	  parseHeaderExpression() {
	    this.expect(10);
	    const val = this.parseExpression();
	    this.expect(11);
	    return val;
	  }
	  parseDoWhileStatement(node) {
	    this.next();
	    this.state.labels.push(loopLabel);
	    node.body = this.withSmartMixTopicForbiddingContext(() => this.parseStatement());
	    this.state.labels.pop();
	    this.expect(92);
	    node.test = this.parseHeaderExpression();
	    this.eat(13);
	    return this.finishNode(node, "DoWhileStatement");
	  }
	  parseForStatement(node) {
	    this.next();
	    this.state.labels.push(loopLabel);
	    let awaitAt = null;
	    if (this.isAwaitAllowed() && this.eatContextual(96)) {
	      awaitAt = this.state.lastTokStartLoc;
	    }
	    this.scope.enter(0);
	    this.expect(10);
	    if (this.match(13)) {
	      if (awaitAt !== null) {
	        this.unexpected(awaitAt);
	      }
	      return this.parseFor(node, null);
	    }
	    const startsWithLet = this.isContextual(100);
	    {
	      const startsWithAwaitUsing = this.isContextual(96) && this.startsAwaitUsing();
	      const starsWithUsingDeclaration = startsWithAwaitUsing || this.isContextual(107) && this.startsUsingForOf();
	      const isLetOrUsing = startsWithLet && this.hasFollowingBindingAtom() || starsWithUsingDeclaration;
	      if (this.match(74) || this.match(75) || isLetOrUsing) {
	        const initNode = this.startNode();
	        let kind;
	        if (startsWithAwaitUsing) {
	          kind = "await using";
	          if (!this.isAwaitAllowed()) {
	            this.raise(Errors.AwaitUsingNotInAsyncContext, this.state.startLoc);
	          }
	          this.next();
	        } else {
	          kind = this.state.value;
	        }
	        this.next();
	        this.parseVar(initNode, true, kind);
	        const init = this.finishNode(initNode, "VariableDeclaration");
	        const isForIn = this.match(58);
	        if (isForIn && starsWithUsingDeclaration) {
	          this.raise(Errors.ForInUsing, init);
	        }
	        if ((isForIn || this.isContextual(102)) && init.declarations.length === 1) {
	          return this.parseForIn(node, init, awaitAt);
	        }
	        if (awaitAt !== null) {
	          this.unexpected(awaitAt);
	        }
	        return this.parseFor(node, init);
	      }
	    }
	    const startsWithAsync = this.isContextual(95);
	    const refExpressionErrors = new ExpressionErrors();
	    const init = this.parseExpression(true, refExpressionErrors);
	    const isForOf = this.isContextual(102);
	    if (isForOf) {
	      if (startsWithLet) {
	        this.raise(Errors.ForOfLet, init);
	      }
	      if (awaitAt === null && startsWithAsync && init.type === "Identifier") {
	        this.raise(Errors.ForOfAsync, init);
	      }
	    }
	    if (isForOf || this.match(58)) {
	      this.checkDestructuringPrivate(refExpressionErrors);
	      this.toAssignable(init, true);
	      const type = isForOf ? "ForOfStatement" : "ForInStatement";
	      this.checkLVal(init, {
	        in: {
	          type
	        }
	      });
	      return this.parseForIn(node, init, awaitAt);
	    } else {
	      this.checkExpressionErrors(refExpressionErrors, true);
	    }
	    if (awaitAt !== null) {
	      this.unexpected(awaitAt);
	    }
	    return this.parseFor(node, init);
	  }
	  parseFunctionStatement(node, isAsync, isHangingDeclaration) {
	    this.next();
	    return this.parseFunction(node, 1 | (isHangingDeclaration ? 2 : 0) | (isAsync ? 8 : 0));
	  }
	  parseIfStatement(node) {
	    this.next();
	    node.test = this.parseHeaderExpression();
	    node.consequent = this.parseStatementOrSloppyAnnexBFunctionDeclaration();
	    node.alternate = this.eat(66) ? this.parseStatementOrSloppyAnnexBFunctionDeclaration() : null;
	    return this.finishNode(node, "IfStatement");
	  }
	  parseReturnStatement(node) {
	    if (!this.prodParam.hasReturn && !this.options.allowReturnOutsideFunction) {
	      this.raise(Errors.IllegalReturn, this.state.startLoc);
	    }
	    this.next();
	    if (this.isLineTerminator()) {
	      node.argument = null;
	    } else {
	      node.argument = this.parseExpression();
	      this.semicolon();
	    }
	    return this.finishNode(node, "ReturnStatement");
	  }
	  parseSwitchStatement(node) {
	    this.next();
	    node.discriminant = this.parseHeaderExpression();
	    const cases = node.cases = [];
	    this.expect(5);
	    this.state.labels.push(switchLabel);
	    this.scope.enter(0);
	    let cur;
	    for (let sawDefault; !this.match(8);) {
	      if (this.match(61) || this.match(65)) {
	        const isCase = this.match(61);
	        if (cur) this.finishNode(cur, "SwitchCase");
	        cases.push(cur = this.startNode());
	        cur.consequent = [];
	        this.next();
	        if (isCase) {
	          cur.test = this.parseExpression();
	        } else {
	          if (sawDefault) {
	            this.raise(Errors.MultipleDefaultsInSwitch, this.state.lastTokStartLoc);
	          }
	          sawDefault = true;
	          cur.test = null;
	        }
	        this.expect(14);
	      } else {
	        if (cur) {
	          cur.consequent.push(this.parseStatementListItem());
	        } else {
	          this.unexpected();
	        }
	      }
	    }
	    this.scope.exit();
	    if (cur) this.finishNode(cur, "SwitchCase");
	    this.next();
	    this.state.labels.pop();
	    return this.finishNode(node, "SwitchStatement");
	  }
	  parseThrowStatement(node) {
	    this.next();
	    if (this.hasPrecedingLineBreak()) {
	      this.raise(Errors.NewlineAfterThrow, this.state.lastTokEndLoc);
	    }
	    node.argument = this.parseExpression();
	    this.semicolon();
	    return this.finishNode(node, "ThrowStatement");
	  }
	  parseCatchClauseParam() {
	    const param = this.parseBindingAtom();
	    this.scope.enter(this.options.annexB && param.type === "Identifier" ? 8 : 0);
	    this.checkLVal(param, {
	      in: {
	        type: "CatchClause"
	      },
	      binding: 9
	    });
	    return param;
	  }
	  parseTryStatement(node) {
	    this.next();
	    node.block = this.parseBlock();
	    node.handler = null;
	    if (this.match(62)) {
	      const clause = this.startNode();
	      this.next();
	      if (this.match(10)) {
	        this.expect(10);
	        clause.param = this.parseCatchClauseParam();
	        this.expect(11);
	      } else {
	        clause.param = null;
	        this.scope.enter(0);
	      }
	      clause.body = this.withSmartMixTopicForbiddingContext(() => this.parseBlock(false, false));
	      this.scope.exit();
	      node.handler = this.finishNode(clause, "CatchClause");
	    }
	    node.finalizer = this.eat(67) ? this.parseBlock() : null;
	    if (!node.handler && !node.finalizer) {
	      this.raise(Errors.NoCatchOrFinally, node);
	    }
	    return this.finishNode(node, "TryStatement");
	  }
	  parseVarStatement(node, kind, allowMissingInitializer = false) {
	    this.next();
	    this.parseVar(node, false, kind, allowMissingInitializer);
	    this.semicolon();
	    return this.finishNode(node, "VariableDeclaration");
	  }
	  parseWhileStatement(node) {
	    this.next();
	    node.test = this.parseHeaderExpression();
	    this.state.labels.push(loopLabel);
	    node.body = this.withSmartMixTopicForbiddingContext(() => this.parseStatement());
	    this.state.labels.pop();
	    return this.finishNode(node, "WhileStatement");
	  }
	  parseWithStatement(node) {
	    if (this.state.strict) {
	      this.raise(Errors.StrictWith, this.state.startLoc);
	    }
	    this.next();
	    node.object = this.parseHeaderExpression();
	    node.body = this.withSmartMixTopicForbiddingContext(() => this.parseStatement());
	    return this.finishNode(node, "WithStatement");
	  }
	  parseEmptyStatement(node) {
	    this.next();
	    return this.finishNode(node, "EmptyStatement");
	  }
	  parseLabeledStatement(node, maybeName, expr, flags) {
	    for (const label of this.state.labels) {
	      if (label.name === maybeName) {
	        this.raise(Errors.LabelRedeclaration, expr, {
	          labelName: maybeName
	        });
	      }
	    }
	    const kind = tokenIsLoop(this.state.type) ? 1 : this.match(71) ? 2 : null;
	    for (let i = this.state.labels.length - 1; i >= 0; i--) {
	      const label = this.state.labels[i];
	      if (label.statementStart === node.start) {
	        label.statementStart = this.state.start;
	        label.kind = kind;
	      } else {
	        break;
	      }
	    }
	    this.state.labels.push({
	      name: maybeName,
	      kind: kind,
	      statementStart: this.state.start
	    });
	    node.body = flags & 8 ? this.parseStatementOrSloppyAnnexBFunctionDeclaration(true) : this.parseStatement();
	    this.state.labels.pop();
	    node.label = expr;
	    return this.finishNode(node, "LabeledStatement");
	  }
	  parseExpressionStatement(node, expr, decorators) {
	    node.expression = expr;
	    this.semicolon();
	    return this.finishNode(node, "ExpressionStatement");
	  }
	  parseBlock(allowDirectives = false, createNewLexicalScope = true, afterBlockParse) {
	    const node = this.startNode();
	    if (allowDirectives) {
	      this.state.strictErrors.clear();
	    }
	    this.expect(5);
	    if (createNewLexicalScope) {
	      this.scope.enter(0);
	    }
	    this.parseBlockBody(node, allowDirectives, false, 8, afterBlockParse);
	    if (createNewLexicalScope) {
	      this.scope.exit();
	    }
	    return this.finishNode(node, "BlockStatement");
	  }
	  isValidDirective(stmt) {
	    return stmt.type === "ExpressionStatement" && stmt.expression.type === "StringLiteral" && !stmt.expression.extra.parenthesized;
	  }
	  parseBlockBody(node, allowDirectives, topLevel, end, afterBlockParse) {
	    const body = node.body = [];
	    const directives = node.directives = [];
	    this.parseBlockOrModuleBlockBody(body, allowDirectives ? directives : undefined, topLevel, end, afterBlockParse);
	  }
	  parseBlockOrModuleBlockBody(body, directives, topLevel, end, afterBlockParse) {
	    const oldStrict = this.state.strict;
	    let hasStrictModeDirective = false;
	    let parsedNonDirective = false;
	    while (!this.match(end)) {
	      const stmt = topLevel ? this.parseModuleItem() : this.parseStatementListItem();
	      if (directives && !parsedNonDirective) {
	        if (this.isValidDirective(stmt)) {
	          const directive = this.stmtToDirective(stmt);
	          directives.push(directive);
	          if (!hasStrictModeDirective && directive.value.value === "use strict") {
	            hasStrictModeDirective = true;
	            this.setStrict(true);
	          }
	          continue;
	        }
	        parsedNonDirective = true;
	        this.state.strictErrors.clear();
	      }
	      body.push(stmt);
	    }
	    afterBlockParse == null || afterBlockParse.call(this, hasStrictModeDirective);
	    if (!oldStrict) {
	      this.setStrict(false);
	    }
	    this.next();
	  }
	  parseFor(node, init) {
	    node.init = init;
	    this.semicolon(false);
	    node.test = this.match(13) ? null : this.parseExpression();
	    this.semicolon(false);
	    node.update = this.match(11) ? null : this.parseExpression();
	    this.expect(11);
	    node.body = this.withSmartMixTopicForbiddingContext(() => this.parseStatement());
	    this.scope.exit();
	    this.state.labels.pop();
	    return this.finishNode(node, "ForStatement");
	  }
	  parseForIn(node, init, awaitAt) {
	    const isForIn = this.match(58);
	    this.next();
	    if (isForIn) {
	      if (awaitAt !== null) this.unexpected(awaitAt);
	    } else {
	      node.await = awaitAt !== null;
	    }
	    if (init.type === "VariableDeclaration" && init.declarations[0].init != null && (!isForIn || !this.options.annexB || this.state.strict || init.kind !== "var" || init.declarations[0].id.type !== "Identifier")) {
	      this.raise(Errors.ForInOfLoopInitializer, init, {
	        type: isForIn ? "ForInStatement" : "ForOfStatement"
	      });
	    }
	    if (init.type === "AssignmentPattern") {
	      this.raise(Errors.InvalidLhs, init, {
	        ancestor: {
	          type: "ForStatement"
	        }
	      });
	    }
	    node.left = init;
	    node.right = isForIn ? this.parseExpression() : this.parseMaybeAssignAllowIn();
	    this.expect(11);
	    node.body = this.withSmartMixTopicForbiddingContext(() => this.parseStatement());
	    this.scope.exit();
	    this.state.labels.pop();
	    return this.finishNode(node, isForIn ? "ForInStatement" : "ForOfStatement");
	  }
	  parseVar(node, isFor, kind, allowMissingInitializer = false) {
	    const declarations = node.declarations = [];
	    node.kind = kind;
	    for (;;) {
	      const decl = this.startNode();
	      this.parseVarId(decl, kind);
	      decl.init = !this.eat(29) ? null : isFor ? this.parseMaybeAssignDisallowIn() : this.parseMaybeAssignAllowIn();
	      if (decl.init === null && !allowMissingInitializer) {
	        if (decl.id.type !== "Identifier" && !(isFor && (this.match(58) || this.isContextual(102)))) {
	          this.raise(Errors.DeclarationMissingInitializer, this.state.lastTokEndLoc, {
	            kind: "destructuring"
	          });
	        } else if ((kind === "const" || kind === "using" || kind === "await using") && !(this.match(58) || this.isContextual(102))) {
	          this.raise(Errors.DeclarationMissingInitializer, this.state.lastTokEndLoc, {
	            kind
	          });
	        }
	      }
	      declarations.push(this.finishNode(decl, "VariableDeclarator"));
	      if (!this.eat(12)) break;
	    }
	    return node;
	  }
	  parseVarId(decl, kind) {
	    const id = this.parseBindingAtom();
	    this.checkLVal(id, {
	      in: {
	        type: "VariableDeclarator"
	      },
	      binding: kind === "var" ? 5 : 8201
	    });
	    decl.id = id;
	  }
	  parseAsyncFunctionExpression(node) {
	    return this.parseFunction(node, 8);
	  }
	  parseFunction(node, flags = 0) {
	    const hangingDeclaration = flags & 2;
	    const isDeclaration = !!(flags & 1);
	    const requireId = isDeclaration && !(flags & 4);
	    const isAsync = !!(flags & 8);
	    this.initFunction(node, isAsync);
	    if (this.match(55)) {
	      if (hangingDeclaration) {
	        this.raise(Errors.GeneratorInSingleStatementContext, this.state.startLoc);
	      }
	      this.next();
	      node.generator = true;
	    }
	    if (isDeclaration) {
	      node.id = this.parseFunctionId(requireId);
	    }
	    const oldMaybeInArrowParameters = this.state.maybeInArrowParameters;
	    this.state.maybeInArrowParameters = false;
	    this.scope.enter(2);
	    this.prodParam.enter(functionFlags(isAsync, node.generator));
	    if (!isDeclaration) {
	      node.id = this.parseFunctionId();
	    }
	    this.parseFunctionParams(node, false);
	    this.withSmartMixTopicForbiddingContext(() => {
	      this.parseFunctionBodyAndFinish(node, isDeclaration ? "FunctionDeclaration" : "FunctionExpression");
	    });
	    this.prodParam.exit();
	    this.scope.exit();
	    if (isDeclaration && !hangingDeclaration) {
	      this.registerFunctionStatementId(node);
	    }
	    this.state.maybeInArrowParameters = oldMaybeInArrowParameters;
	    return node;
	  }
	  parseFunctionId(requireId) {
	    return requireId || tokenIsIdentifier(this.state.type) ? this.parseIdentifier() : null;
	  }
	  parseFunctionParams(node, isConstructor) {
	    this.expect(10);
	    this.expressionScope.enter(newParameterDeclarationScope());
	    node.params = this.parseBindingList(11, 41, 2 | (isConstructor ? 4 : 0));
	    this.expressionScope.exit();
	  }
	  registerFunctionStatementId(node) {
	    if (!node.id) return;
	    this.scope.declareName(node.id.name, !this.options.annexB || this.state.strict || node.generator || node.async ? this.scope.treatFunctionsAsVar ? 5 : 8201 : 17, node.id.loc.start);
	  }
	  parseClass(node, isStatement, optionalId) {
	    this.next();
	    const oldStrict = this.state.strict;
	    this.state.strict = true;
	    this.parseClassId(node, isStatement, optionalId);
	    this.parseClassSuper(node);
	    node.body = this.parseClassBody(!!node.superClass, oldStrict);
	    return this.finishNode(node, isStatement ? "ClassDeclaration" : "ClassExpression");
	  }
	  isClassProperty() {
	    return this.match(29) || this.match(13) || this.match(8);
	  }
	  isClassMethod() {
	    return this.match(10);
	  }
	  nameIsConstructor(key) {
	    return key.type === "Identifier" && key.name === "constructor" || key.type === "StringLiteral" && key.value === "constructor";
	  }
	  isNonstaticConstructor(method) {
	    return !method.computed && !method.static && this.nameIsConstructor(method.key);
	  }
	  parseClassBody(hadSuperClass, oldStrict) {
	    this.classScope.enter();
	    const state = {
	      hadConstructor: false,
	      hadSuperClass
	    };
	    let decorators = [];
	    const classBody = this.startNode();
	    classBody.body = [];
	    this.expect(5);
	    this.withSmartMixTopicForbiddingContext(() => {
	      while (!this.match(8)) {
	        if (this.eat(13)) {
	          if (decorators.length > 0) {
	            throw this.raise(Errors.DecoratorSemicolon, this.state.lastTokEndLoc);
	          }
	          continue;
	        }
	        if (this.match(26)) {
	          decorators.push(this.parseDecorator());
	          continue;
	        }
	        const member = this.startNode();
	        if (decorators.length) {
	          member.decorators = decorators;
	          this.resetStartLocationFromNode(member, decorators[0]);
	          decorators = [];
	        }
	        this.parseClassMember(classBody, member, state);
	        if (member.kind === "constructor" && member.decorators && member.decorators.length > 0) {
	          this.raise(Errors.DecoratorConstructor, member);
	        }
	      }
	    });
	    this.state.strict = oldStrict;
	    this.next();
	    if (decorators.length) {
	      throw this.raise(Errors.TrailingDecorator, this.state.startLoc);
	    }
	    this.classScope.exit();
	    return this.finishNode(classBody, "ClassBody");
	  }
	  parseClassMemberFromModifier(classBody, member) {
	    const key = this.parseIdentifier(true);
	    if (this.isClassMethod()) {
	      const method = member;
	      method.kind = "method";
	      method.computed = false;
	      method.key = key;
	      method.static = false;
	      this.pushClassMethod(classBody, method, false, false, false, false);
	      return true;
	    } else if (this.isClassProperty()) {
	      const prop = member;
	      prop.computed = false;
	      prop.key = key;
	      prop.static = false;
	      classBody.body.push(this.parseClassProperty(prop));
	      return true;
	    }
	    this.resetPreviousNodeTrailingComments(key);
	    return false;
	  }
	  parseClassMember(classBody, member, state) {
	    const isStatic = this.isContextual(106);
	    if (isStatic) {
	      if (this.parseClassMemberFromModifier(classBody, member)) {
	        return;
	      }
	      if (this.eat(5)) {
	        this.parseClassStaticBlock(classBody, member);
	        return;
	      }
	    }
	    this.parseClassMemberWithIsStatic(classBody, member, state, isStatic);
	  }
	  parseClassMemberWithIsStatic(classBody, member, state, isStatic) {
	    const publicMethod = member;
	    const privateMethod = member;
	    const publicProp = member;
	    const privateProp = member;
	    const accessorProp = member;
	    const method = publicMethod;
	    const publicMember = publicMethod;
	    member.static = isStatic;
	    this.parsePropertyNamePrefixOperator(member);
	    if (this.eat(55)) {
	      method.kind = "method";
	      const isPrivateName = this.match(138);
	      this.parseClassElementName(method);
	      if (isPrivateName) {
	        this.pushClassPrivateMethod(classBody, privateMethod, true, false);
	        return;
	      }
	      if (this.isNonstaticConstructor(publicMethod)) {
	        this.raise(Errors.ConstructorIsGenerator, publicMethod.key);
	      }
	      this.pushClassMethod(classBody, publicMethod, true, false, false, false);
	      return;
	    }
	    const isContextual = !this.state.containsEsc && tokenIsIdentifier(this.state.type);
	    const key = this.parseClassElementName(member);
	    const maybeContextualKw = isContextual ? key.name : null;
	    const isPrivate = this.isPrivateName(key);
	    const maybeQuestionTokenStartLoc = this.state.startLoc;
	    this.parsePostMemberNameModifiers(publicMember);
	    if (this.isClassMethod()) {
	      method.kind = "method";
	      if (isPrivate) {
	        this.pushClassPrivateMethod(classBody, privateMethod, false, false);
	        return;
	      }
	      const isConstructor = this.isNonstaticConstructor(publicMethod);
	      let allowsDirectSuper = false;
	      if (isConstructor) {
	        publicMethod.kind = "constructor";
	        if (state.hadConstructor && !this.hasPlugin("typescript")) {
	          this.raise(Errors.DuplicateConstructor, key);
	        }
	        if (isConstructor && this.hasPlugin("typescript") && member.override) {
	          this.raise(Errors.OverrideOnConstructor, key);
	        }
	        state.hadConstructor = true;
	        allowsDirectSuper = state.hadSuperClass;
	      }
	      this.pushClassMethod(classBody, publicMethod, false, false, isConstructor, allowsDirectSuper);
	    } else if (this.isClassProperty()) {
	      if (isPrivate) {
	        this.pushClassPrivateProperty(classBody, privateProp);
	      } else {
	        this.pushClassProperty(classBody, publicProp);
	      }
	    } else if (maybeContextualKw === "async" && !this.isLineTerminator()) {
	      this.resetPreviousNodeTrailingComments(key);
	      const isGenerator = this.eat(55);
	      if (publicMember.optional) {
	        this.unexpected(maybeQuestionTokenStartLoc);
	      }
	      method.kind = "method";
	      const isPrivate = this.match(138);
	      this.parseClassElementName(method);
	      this.parsePostMemberNameModifiers(publicMember);
	      if (isPrivate) {
	        this.pushClassPrivateMethod(classBody, privateMethod, isGenerator, true);
	      } else {
	        if (this.isNonstaticConstructor(publicMethod)) {
	          this.raise(Errors.ConstructorIsAsync, publicMethod.key);
	        }
	        this.pushClassMethod(classBody, publicMethod, isGenerator, true, false, false);
	      }
	    } else if ((maybeContextualKw === "get" || maybeContextualKw === "set") && !(this.match(55) && this.isLineTerminator())) {
	      this.resetPreviousNodeTrailingComments(key);
	      method.kind = maybeContextualKw;
	      const isPrivate = this.match(138);
	      this.parseClassElementName(publicMethod);
	      if (isPrivate) {
	        this.pushClassPrivateMethod(classBody, privateMethod, false, false);
	      } else {
	        if (this.isNonstaticConstructor(publicMethod)) {
	          this.raise(Errors.ConstructorIsAccessor, publicMethod.key);
	        }
	        this.pushClassMethod(classBody, publicMethod, false, false, false, false);
	      }
	      this.checkGetterSetterParams(publicMethod);
	    } else if (maybeContextualKw === "accessor" && !this.isLineTerminator()) {
	      this.expectPlugin("decoratorAutoAccessors");
	      this.resetPreviousNodeTrailingComments(key);
	      const isPrivate = this.match(138);
	      this.parseClassElementName(publicProp);
	      this.pushClassAccessorProperty(classBody, accessorProp, isPrivate);
	    } else if (this.isLineTerminator()) {
	      if (isPrivate) {
	        this.pushClassPrivateProperty(classBody, privateProp);
	      } else {
	        this.pushClassProperty(classBody, publicProp);
	      }
	    } else {
	      this.unexpected();
	    }
	  }
	  parseClassElementName(member) {
	    const {
	      type,
	      value
	    } = this.state;
	    if ((type === 132 || type === 133) && member.static && value === "prototype") {
	      this.raise(Errors.StaticPrototype, this.state.startLoc);
	    }
	    if (type === 138) {
	      if (value === "constructor") {
	        this.raise(Errors.ConstructorClassPrivateField, this.state.startLoc);
	      }
	      const key = this.parsePrivateName();
	      member.key = key;
	      return key;
	    }
	    this.parsePropertyName(member);
	    return member.key;
	  }
	  parseClassStaticBlock(classBody, member) {
	    var _member$decorators;
	    this.scope.enter(64 | 128 | 16);
	    const oldLabels = this.state.labels;
	    this.state.labels = [];
	    this.prodParam.enter(0);
	    const body = member.body = [];
	    this.parseBlockOrModuleBlockBody(body, undefined, false, 8);
	    this.prodParam.exit();
	    this.scope.exit();
	    this.state.labels = oldLabels;
	    classBody.body.push(this.finishNode(member, "StaticBlock"));
	    if ((_member$decorators = member.decorators) != null && _member$decorators.length) {
	      this.raise(Errors.DecoratorStaticBlock, member);
	    }
	  }
	  pushClassProperty(classBody, prop) {
	    if (!prop.computed && this.nameIsConstructor(prop.key)) {
	      this.raise(Errors.ConstructorClassField, prop.key);
	    }
	    classBody.body.push(this.parseClassProperty(prop));
	  }
	  pushClassPrivateProperty(classBody, prop) {
	    const node = this.parseClassPrivateProperty(prop);
	    classBody.body.push(node);
	    this.classScope.declarePrivateName(this.getPrivateNameSV(node.key), 0, node.key.loc.start);
	  }
	  pushClassAccessorProperty(classBody, prop, isPrivate) {
	    if (!isPrivate && !prop.computed && this.nameIsConstructor(prop.key)) {
	      this.raise(Errors.ConstructorClassField, prop.key);
	    }
	    const node = this.parseClassAccessorProperty(prop);
	    classBody.body.push(node);
	    if (isPrivate) {
	      this.classScope.declarePrivateName(this.getPrivateNameSV(node.key), 0, node.key.loc.start);
	    }
	  }
	  pushClassMethod(classBody, method, isGenerator, isAsync, isConstructor, allowsDirectSuper) {
	    classBody.body.push(this.parseMethod(method, isGenerator, isAsync, isConstructor, allowsDirectSuper, "ClassMethod", true));
	  }
	  pushClassPrivateMethod(classBody, method, isGenerator, isAsync) {
	    const node = this.parseMethod(method, isGenerator, isAsync, false, false, "ClassPrivateMethod", true);
	    classBody.body.push(node);
	    const kind = node.kind === "get" ? node.static ? 6 : 2 : node.kind === "set" ? node.static ? 5 : 1 : 0;
	    this.declareClassPrivateMethodInScope(node, kind);
	  }
	  declareClassPrivateMethodInScope(node, kind) {
	    this.classScope.declarePrivateName(this.getPrivateNameSV(node.key), kind, node.key.loc.start);
	  }
	  parsePostMemberNameModifiers(methodOrProp) {}
	  parseClassPrivateProperty(node) {
	    this.parseInitializer(node);
	    this.semicolon();
	    return this.finishNode(node, "ClassPrivateProperty");
	  }
	  parseClassProperty(node) {
	    this.parseInitializer(node);
	    this.semicolon();
	    return this.finishNode(node, "ClassProperty");
	  }
	  parseClassAccessorProperty(node) {
	    this.parseInitializer(node);
	    this.semicolon();
	    return this.finishNode(node, "ClassAccessorProperty");
	  }
	  parseInitializer(node) {
	    this.scope.enter(64 | 16);
	    this.expressionScope.enter(newExpressionScope());
	    this.prodParam.enter(0);
	    node.value = this.eat(29) ? this.parseMaybeAssignAllowIn() : null;
	    this.expressionScope.exit();
	    this.prodParam.exit();
	    this.scope.exit();
	  }
	  parseClassId(node, isStatement, optionalId, bindingType = 8331) {
	    if (tokenIsIdentifier(this.state.type)) {
	      node.id = this.parseIdentifier();
	      if (isStatement) {
	        this.declareNameFromIdentifier(node.id, bindingType);
	      }
	    } else {
	      if (optionalId || !isStatement) {
	        node.id = null;
	      } else {
	        throw this.raise(Errors.MissingClassName, this.state.startLoc);
	      }
	    }
	  }
	  parseClassSuper(node) {
	    node.superClass = this.eat(81) ? this.parseExprSubscripts() : null;
	  }
	  parseExport(node, decorators) {
	    const maybeDefaultIdentifier = this.parseMaybeImportPhase(node, true);
	    const hasDefault = this.maybeParseExportDefaultSpecifier(node, maybeDefaultIdentifier);
	    const parseAfterDefault = !hasDefault || this.eat(12);
	    const hasStar = parseAfterDefault && this.eatExportStar(node);
	    const hasNamespace = hasStar && this.maybeParseExportNamespaceSpecifier(node);
	    const parseAfterNamespace = parseAfterDefault && (!hasNamespace || this.eat(12));
	    const isFromRequired = hasDefault || hasStar;
	    if (hasStar && !hasNamespace) {
	      if (hasDefault) this.unexpected();
	      if (decorators) {
	        throw this.raise(Errors.UnsupportedDecoratorExport, node);
	      }
	      this.parseExportFrom(node, true);
	      return this.finishNode(node, "ExportAllDeclaration");
	    }
	    const hasSpecifiers = this.maybeParseExportNamedSpecifiers(node);
	    if (hasDefault && parseAfterDefault && !hasStar && !hasSpecifiers) {
	      this.unexpected(null, 5);
	    }
	    if (hasNamespace && parseAfterNamespace) {
	      this.unexpected(null, 98);
	    }
	    let hasDeclaration;
	    if (isFromRequired || hasSpecifiers) {
	      hasDeclaration = false;
	      if (decorators) {
	        throw this.raise(Errors.UnsupportedDecoratorExport, node);
	      }
	      this.parseExportFrom(node, isFromRequired);
	    } else {
	      hasDeclaration = this.maybeParseExportDeclaration(node);
	    }
	    if (isFromRequired || hasSpecifiers || hasDeclaration) {
	      var _node2$declaration;
	      const node2 = node;
	      this.checkExport(node2, true, false, !!node2.source);
	      if (((_node2$declaration = node2.declaration) == null ? void 0 : _node2$declaration.type) === "ClassDeclaration") {
	        this.maybeTakeDecorators(decorators, node2.declaration, node2);
	      } else if (decorators) {
	        throw this.raise(Errors.UnsupportedDecoratorExport, node);
	      }
	      return this.finishNode(node2, "ExportNamedDeclaration");
	    }
	    if (this.eat(65)) {
	      const node2 = node;
	      const decl = this.parseExportDefaultExpression();
	      node2.declaration = decl;
	      if (decl.type === "ClassDeclaration") {
	        this.maybeTakeDecorators(decorators, decl, node2);
	      } else if (decorators) {
	        throw this.raise(Errors.UnsupportedDecoratorExport, node);
	      }
	      this.checkExport(node2, true, true);
	      return this.finishNode(node2, "ExportDefaultDeclaration");
	    }
	    this.unexpected(null, 5);
	  }
	  eatExportStar(node) {
	    return this.eat(55);
	  }
	  maybeParseExportDefaultSpecifier(node, maybeDefaultIdentifier) {
	    if (maybeDefaultIdentifier || this.isExportDefaultSpecifier()) {
	      this.expectPlugin("exportDefaultFrom", maybeDefaultIdentifier == null ? void 0 : maybeDefaultIdentifier.loc.start);
	      const id = maybeDefaultIdentifier || this.parseIdentifier(true);
	      const specifier = this.startNodeAtNode(id);
	      specifier.exported = id;
	      node.specifiers = [this.finishNode(specifier, "ExportDefaultSpecifier")];
	      return true;
	    }
	    return false;
	  }
	  maybeParseExportNamespaceSpecifier(node) {
	    if (this.isContextual(93)) {
	      var _ref, _ref$specifiers;
	      (_ref$specifiers = (_ref = node).specifiers) != null ? _ref$specifiers : _ref.specifiers = [];
	      const specifier = this.startNodeAt(this.state.lastTokStartLoc);
	      this.next();
	      specifier.exported = this.parseModuleExportName();
	      node.specifiers.push(this.finishNode(specifier, "ExportNamespaceSpecifier"));
	      return true;
	    }
	    return false;
	  }
	  maybeParseExportNamedSpecifiers(node) {
	    if (this.match(5)) {
	      const node2 = node;
	      if (!node2.specifiers) node2.specifiers = [];
	      const isTypeExport = node2.exportKind === "type";
	      node2.specifiers.push(...this.parseExportSpecifiers(isTypeExport));
	      node2.source = null;
	      node2.declaration = null;
	      if (this.hasPlugin("importAssertions")) {
	        node2.assertions = [];
	      }
	      return true;
	    }
	    return false;
	  }
	  maybeParseExportDeclaration(node) {
	    if (this.shouldParseExportDeclaration()) {
	      node.specifiers = [];
	      node.source = null;
	      if (this.hasPlugin("importAssertions")) {
	        node.assertions = [];
	      }
	      node.declaration = this.parseExportDeclaration(node);
	      return true;
	    }
	    return false;
	  }
	  isAsyncFunction() {
	    if (!this.isContextual(95)) return false;
	    const next = this.nextTokenInLineStart();
	    return this.isUnparsedContextual(next, "function");
	  }
	  parseExportDefaultExpression() {
	    const expr = this.startNode();
	    if (this.match(68)) {
	      this.next();
	      return this.parseFunction(expr, 1 | 4);
	    } else if (this.isAsyncFunction()) {
	      this.next();
	      this.next();
	      return this.parseFunction(expr, 1 | 4 | 8);
	    }
	    if (this.match(80)) {
	      return this.parseClass(expr, true, true);
	    }
	    if (this.match(26)) {
	      if (this.hasPlugin("decorators") && this.getPluginOption("decorators", "decoratorsBeforeExport") === true) {
	        this.raise(Errors.DecoratorBeforeExport, this.state.startLoc);
	      }
	      return this.parseClass(this.maybeTakeDecorators(this.parseDecorators(false), this.startNode()), true, true);
	    }
	    if (this.match(75) || this.match(74) || this.isLet()) {
	      throw this.raise(Errors.UnsupportedDefaultExport, this.state.startLoc);
	    }
	    const res = this.parseMaybeAssignAllowIn();
	    this.semicolon();
	    return res;
	  }
	  parseExportDeclaration(node) {
	    if (this.match(80)) {
	      const node = this.parseClass(this.startNode(), true, false);
	      return node;
	    }
	    return this.parseStatementListItem();
	  }
	  isExportDefaultSpecifier() {
	    const {
	      type
	    } = this.state;
	    if (tokenIsIdentifier(type)) {
	      if (type === 95 && !this.state.containsEsc || type === 100) {
	        return false;
	      }
	      if ((type === 130 || type === 129) && !this.state.containsEsc) {
	        const {
	          type: nextType
	        } = this.lookahead();
	        if (tokenIsIdentifier(nextType) && nextType !== 98 || nextType === 5) {
	          this.expectOnePlugin(["flow", "typescript"]);
	          return false;
	        }
	      }
	    } else if (!this.match(65)) {
	      return false;
	    }
	    const next = this.nextTokenStart();
	    const hasFrom = this.isUnparsedContextual(next, "from");
	    if (this.input.charCodeAt(next) === 44 || tokenIsIdentifier(this.state.type) && hasFrom) {
	      return true;
	    }
	    if (this.match(65) && hasFrom) {
	      const nextAfterFrom = this.input.charCodeAt(this.nextTokenStartSince(next + 4));
	      return nextAfterFrom === 34 || nextAfterFrom === 39;
	    }
	    return false;
	  }
	  parseExportFrom(node, expect) {
	    if (this.eatContextual(98)) {
	      node.source = this.parseImportSource();
	      this.checkExport(node);
	      this.maybeParseImportAttributes(node);
	      this.checkJSONModuleImport(node);
	    } else if (expect) {
	      this.unexpected();
	    }
	    this.semicolon();
	  }
	  shouldParseExportDeclaration() {
	    const {
	      type
	    } = this.state;
	    if (type === 26) {
	      this.expectOnePlugin(["decorators", "decorators-legacy"]);
	      if (this.hasPlugin("decorators")) {
	        if (this.getPluginOption("decorators", "decoratorsBeforeExport") === true) {
	          this.raise(Errors.DecoratorBeforeExport, this.state.startLoc);
	        }
	        return true;
	      }
	    }
	    if (this.isContextual(107)) {
	      this.raise(Errors.UsingDeclarationExport, this.state.startLoc);
	      return true;
	    }
	    if (this.isContextual(96) && this.startsAwaitUsing()) {
	      this.raise(Errors.UsingDeclarationExport, this.state.startLoc);
	      return true;
	    }
	    return type === 74 || type === 75 || type === 68 || type === 80 || this.isLet() || this.isAsyncFunction();
	  }
	  checkExport(node, checkNames, isDefault, isFrom) {
	    if (checkNames) {
	      var _node$specifiers;
	      if (isDefault) {
	        this.checkDuplicateExports(node, "default");
	        if (this.hasPlugin("exportDefaultFrom")) {
	          var _declaration$extra;
	          const declaration = node.declaration;
	          if (declaration.type === "Identifier" && declaration.name === "from" && declaration.end - declaration.start === 4 && !((_declaration$extra = declaration.extra) != null && _declaration$extra.parenthesized)) {
	            this.raise(Errors.ExportDefaultFromAsIdentifier, declaration);
	          }
	        }
	      } else if ((_node$specifiers = node.specifiers) != null && _node$specifiers.length) {
	        for (const specifier of node.specifiers) {
	          const {
	            exported
	          } = specifier;
	          const exportName = exported.type === "Identifier" ? exported.name : exported.value;
	          this.checkDuplicateExports(specifier, exportName);
	          if (!isFrom && specifier.local) {
	            const {
	              local
	            } = specifier;
	            if (local.type !== "Identifier") {
	              this.raise(Errors.ExportBindingIsString, specifier, {
	                localName: local.value,
	                exportName
	              });
	            } else {
	              this.checkReservedWord(local.name, local.loc.start, true, false);
	              this.scope.checkLocalExport(local);
	            }
	          }
	        }
	      } else if (node.declaration) {
	        const decl = node.declaration;
	        if (decl.type === "FunctionDeclaration" || decl.type === "ClassDeclaration") {
	          const {
	            id
	          } = decl;
	          if (!id) throw new Error("Assertion failure");
	          this.checkDuplicateExports(node, id.name);
	        } else if (decl.type === "VariableDeclaration") {
	          for (const declaration of decl.declarations) {
	            this.checkDeclaration(declaration.id);
	          }
	        }
	      }
	    }
	  }
	  checkDeclaration(node) {
	    if (node.type === "Identifier") {
	      this.checkDuplicateExports(node, node.name);
	    } else if (node.type === "ObjectPattern") {
	      for (const prop of node.properties) {
	        this.checkDeclaration(prop);
	      }
	    } else if (node.type === "ArrayPattern") {
	      for (const elem of node.elements) {
	        if (elem) {
	          this.checkDeclaration(elem);
	        }
	      }
	    } else if (node.type === "ObjectProperty") {
	      this.checkDeclaration(node.value);
	    } else if (node.type === "RestElement") {
	      this.checkDeclaration(node.argument);
	    } else if (node.type === "AssignmentPattern") {
	      this.checkDeclaration(node.left);
	    }
	  }
	  checkDuplicateExports(node, exportName) {
	    if (this.exportedIdentifiers.has(exportName)) {
	      if (exportName === "default") {
	        this.raise(Errors.DuplicateDefaultExport, node);
	      } else {
	        this.raise(Errors.DuplicateExport, node, {
	          exportName
	        });
	      }
	    }
	    this.exportedIdentifiers.add(exportName);
	  }
	  parseExportSpecifiers(isInTypeExport) {
	    const nodes = [];
	    let first = true;
	    this.expect(5);
	    while (!this.eat(8)) {
	      if (first) {
	        first = false;
	      } else {
	        this.expect(12);
	        if (this.eat(8)) break;
	      }
	      const isMaybeTypeOnly = this.isContextual(130);
	      const isString = this.match(133);
	      const node = this.startNode();
	      node.local = this.parseModuleExportName();
	      nodes.push(this.parseExportSpecifier(node, isString, isInTypeExport, isMaybeTypeOnly));
	    }
	    return nodes;
	  }
	  parseExportSpecifier(node, isString, isInTypeExport, isMaybeTypeOnly) {
	    if (this.eatContextual(93)) {
	      node.exported = this.parseModuleExportName();
	    } else if (isString) {
	      node.exported = cloneStringLiteral(node.local);
	    } else if (!node.exported) {
	      node.exported = cloneIdentifier(node.local);
	    }
	    return this.finishNode(node, "ExportSpecifier");
	  }
	  parseModuleExportName() {
	    if (this.match(133)) {
	      const result = this.parseStringLiteral(this.state.value);
	      const surrogate = result.value.match(loneSurrogate);
	      if (surrogate) {
	        this.raise(Errors.ModuleExportNameHasLoneSurrogate, result, {
	          surrogateCharCode: surrogate[0].charCodeAt(0)
	        });
	      }
	      return result;
	    }
	    return this.parseIdentifier(true);
	  }
	  isJSONModuleImport(node) {
	    if (node.assertions != null) {
	      return node.assertions.some(({
	        key,
	        value
	      }) => {
	        return value.value === "json" && (key.type === "Identifier" ? key.name === "type" : key.value === "type");
	      });
	    }
	    return false;
	  }
	  checkImportReflection(node) {
	    const {
	      specifiers
	    } = node;
	    const singleBindingType = specifiers.length === 1 ? specifiers[0].type : null;
	    if (node.phase === "source") {
	      if (singleBindingType !== "ImportDefaultSpecifier") {
	        this.raise(Errors.SourcePhaseImportRequiresDefault, specifiers[0].loc.start);
	      }
	    } else if (node.phase === "defer") {
	      if (singleBindingType !== "ImportNamespaceSpecifier") {
	        this.raise(Errors.DeferImportRequiresNamespace, specifiers[0].loc.start);
	      }
	    } else if (node.module) {
	      var _node$assertions;
	      if (singleBindingType !== "ImportDefaultSpecifier") {
	        this.raise(Errors.ImportReflectionNotBinding, specifiers[0].loc.start);
	      }
	      if (((_node$assertions = node.assertions) == null ? void 0 : _node$assertions.length) > 0) {
	        this.raise(Errors.ImportReflectionHasAssertion, specifiers[0].loc.start);
	      }
	    }
	  }
	  checkJSONModuleImport(node) {
	    if (this.isJSONModuleImport(node) && node.type !== "ExportAllDeclaration") {
	      const {
	        specifiers
	      } = node;
	      if (specifiers != null) {
	        const nonDefaultNamedSpecifier = specifiers.find(specifier => {
	          let imported;
	          if (specifier.type === "ExportSpecifier") {
	            imported = specifier.local;
	          } else if (specifier.type === "ImportSpecifier") {
	            imported = specifier.imported;
	          }
	          if (imported !== undefined) {
	            return imported.type === "Identifier" ? imported.name !== "default" : imported.value !== "default";
	          }
	        });
	        if (nonDefaultNamedSpecifier !== undefined) {
	          this.raise(Errors.ImportJSONBindingNotDefault, nonDefaultNamedSpecifier.loc.start);
	        }
	      }
	    }
	  }
	  isPotentialImportPhase(isExport) {
	    if (isExport) return false;
	    return this.isContextual(105) || this.isContextual(97) || this.isContextual(127);
	  }
	  applyImportPhase(node, isExport, phase, loc) {
	    if (isExport) {
	      return;
	    }
	    if (phase === "module") {
	      this.expectPlugin("importReflection", loc);
	      node.module = true;
	    } else if (this.hasPlugin("importReflection")) {
	      node.module = false;
	    }
	    if (phase === "source") {
	      this.expectPlugin("sourcePhaseImports", loc);
	      node.phase = "source";
	    } else if (phase === "defer") {
	      this.expectPlugin("deferredImportEvaluation", loc);
	      node.phase = "defer";
	    } else if (this.hasPlugin("sourcePhaseImports")) {
	      node.phase = null;
	    }
	  }
	  parseMaybeImportPhase(node, isExport) {
	    if (!this.isPotentialImportPhase(isExport)) {
	      this.applyImportPhase(node, isExport, null);
	      return null;
	    }
	    const phaseIdentifier = this.parseIdentifier(true);
	    const {
	      type
	    } = this.state;
	    const isImportPhase = tokenIsKeywordOrIdentifier(type) ? type !== 98 || this.lookaheadCharCode() === 102 : type !== 12;
	    if (isImportPhase) {
	      this.resetPreviousIdentifierLeadingComments(phaseIdentifier);
	      this.applyImportPhase(node, isExport, phaseIdentifier.name, phaseIdentifier.loc.start);
	      return null;
	    } else {
	      this.applyImportPhase(node, isExport, null);
	      return phaseIdentifier;
	    }
	  }
	  isPrecedingIdImportPhase(phase) {
	    const {
	      type
	    } = this.state;
	    return tokenIsIdentifier(type) ? type !== 98 || this.lookaheadCharCode() === 102 : type !== 12;
	  }
	  parseImport(node) {
	    if (this.match(133)) {
	      return this.parseImportSourceAndAttributes(node);
	    }
	    return this.parseImportSpecifiersAndAfter(node, this.parseMaybeImportPhase(node, false));
	  }
	  parseImportSpecifiersAndAfter(node, maybeDefaultIdentifier) {
	    node.specifiers = [];
	    const hasDefault = this.maybeParseDefaultImportSpecifier(node, maybeDefaultIdentifier);
	    const parseNext = !hasDefault || this.eat(12);
	    const hasStar = parseNext && this.maybeParseStarImportSpecifier(node);
	    if (parseNext && !hasStar) this.parseNamedImportSpecifiers(node);
	    this.expectContextual(98);
	    return this.parseImportSourceAndAttributes(node);
	  }
	  parseImportSourceAndAttributes(node) {
	    var _node$specifiers2;
	    (_node$specifiers2 = node.specifiers) != null ? _node$specifiers2 : node.specifiers = [];
	    node.source = this.parseImportSource();
	    this.maybeParseImportAttributes(node);
	    this.checkImportReflection(node);
	    this.checkJSONModuleImport(node);
	    this.semicolon();
	    return this.finishNode(node, "ImportDeclaration");
	  }
	  parseImportSource() {
	    if (!this.match(133)) this.unexpected();
	    return this.parseExprAtom();
	  }
	  parseImportSpecifierLocal(node, specifier, type) {
	    specifier.local = this.parseIdentifier();
	    node.specifiers.push(this.finishImportSpecifier(specifier, type));
	  }
	  finishImportSpecifier(specifier, type, bindingType = 8201) {
	    this.checkLVal(specifier.local, {
	      in: {
	        type
	      },
	      binding: bindingType
	    });
	    return this.finishNode(specifier, type);
	  }
	  parseImportAttributes() {
	    this.expect(5);
	    const attrs = [];
	    const attrNames = new Set();
	    do {
	      if (this.match(8)) {
	        break;
	      }
	      const node = this.startNode();
	      const keyName = this.state.value;
	      if (attrNames.has(keyName)) {
	        this.raise(Errors.ModuleAttributesWithDuplicateKeys, this.state.startLoc, {
	          key: keyName
	        });
	      }
	      attrNames.add(keyName);
	      if (this.match(133)) {
	        node.key = this.parseStringLiteral(keyName);
	      } else {
	        node.key = this.parseIdentifier(true);
	      }
	      this.expect(14);
	      if (!this.match(133)) {
	        throw this.raise(Errors.ModuleAttributeInvalidValue, this.state.startLoc);
	      }
	      node.value = this.parseStringLiteral(this.state.value);
	      attrs.push(this.finishNode(node, "ImportAttribute"));
	    } while (this.eat(12));
	    this.expect(8);
	    return attrs;
	  }
	  parseModuleAttributes() {
	    const attrs = [];
	    const attributes = new Set();
	    do {
	      const node = this.startNode();
	      node.key = this.parseIdentifier(true);
	      if (node.key.name !== "type") {
	        this.raise(Errors.ModuleAttributeDifferentFromType, node.key);
	      }
	      if (attributes.has(node.key.name)) {
	        this.raise(Errors.ModuleAttributesWithDuplicateKeys, node.key, {
	          key: node.key.name
	        });
	      }
	      attributes.add(node.key.name);
	      this.expect(14);
	      if (!this.match(133)) {
	        throw this.raise(Errors.ModuleAttributeInvalidValue, this.state.startLoc);
	      }
	      node.value = this.parseStringLiteral(this.state.value);
	      attrs.push(this.finishNode(node, "ImportAttribute"));
	    } while (this.eat(12));
	    return attrs;
	  }
	  maybeParseImportAttributes(node) {
	    let attributes;
	    let useWith = false;
	    if (this.match(76)) {
	      if (this.hasPrecedingLineBreak() && this.lookaheadCharCode() === 40) {
	        return;
	      }
	      this.next();
	      {
	        if (this.hasPlugin("moduleAttributes")) {
	          attributes = this.parseModuleAttributes();
	        } else {
	          this.expectImportAttributesPlugin();
	          attributes = this.parseImportAttributes();
	        }
	      }
	      useWith = true;
	    } else if (this.isContextual(94) && !this.hasPrecedingLineBreak()) {
	      if (this.hasPlugin("importAttributes")) {
	        if (this.getPluginOption("importAttributes", "deprecatedAssertSyntax") !== true) {
	          this.raise(Errors.ImportAttributesUseAssert, this.state.startLoc);
	        }
	        this.addExtra(node, "deprecatedAssertSyntax", true);
	      } else {
	        this.expectOnePlugin(["importAttributes", "importAssertions"]);
	      }
	      this.next();
	      attributes = this.parseImportAttributes();
	    } else if (this.hasPlugin("importAttributes") || this.hasPlugin("importAssertions")) {
	      attributes = [];
	    } else {
	      if (this.hasPlugin("moduleAttributes")) {
	        attributes = [];
	      } else return;
	    }
	    if (!useWith && this.hasPlugin("importAssertions")) {
	      node.assertions = attributes;
	    } else {
	      node.attributes = attributes;
	    }
	  }
	  maybeParseDefaultImportSpecifier(node, maybeDefaultIdentifier) {
	    if (maybeDefaultIdentifier) {
	      const specifier = this.startNodeAtNode(maybeDefaultIdentifier);
	      specifier.local = maybeDefaultIdentifier;
	      node.specifiers.push(this.finishImportSpecifier(specifier, "ImportDefaultSpecifier"));
	      return true;
	    } else if (tokenIsKeywordOrIdentifier(this.state.type)) {
	      this.parseImportSpecifierLocal(node, this.startNode(), "ImportDefaultSpecifier");
	      return true;
	    }
	    return false;
	  }
	  maybeParseStarImportSpecifier(node) {
	    if (this.match(55)) {
	      const specifier = this.startNode();
	      this.next();
	      this.expectContextual(93);
	      this.parseImportSpecifierLocal(node, specifier, "ImportNamespaceSpecifier");
	      return true;
	    }
	    return false;
	  }
	  parseNamedImportSpecifiers(node) {
	    let first = true;
	    this.expect(5);
	    while (!this.eat(8)) {
	      if (first) {
	        first = false;
	      } else {
	        if (this.eat(14)) {
	          throw this.raise(Errors.DestructureNamedImport, this.state.startLoc);
	        }
	        this.expect(12);
	        if (this.eat(8)) break;
	      }
	      const specifier = this.startNode();
	      const importedIsString = this.match(133);
	      const isMaybeTypeOnly = this.isContextual(130);
	      specifier.imported = this.parseModuleExportName();
	      const importSpecifier = this.parseImportSpecifier(specifier, importedIsString, node.importKind === "type" || node.importKind === "typeof", isMaybeTypeOnly, undefined);
	      node.specifiers.push(importSpecifier);
	    }
	  }
	  parseImportSpecifier(specifier, importedIsString, isInTypeOnlyImport, isMaybeTypeOnly, bindingType) {
	    if (this.eatContextual(93)) {
	      specifier.local = this.parseIdentifier();
	    } else {
	      const {
	        imported
	      } = specifier;
	      if (importedIsString) {
	        throw this.raise(Errors.ImportBindingIsString, specifier, {
	          importName: imported.value
	        });
	      }
	      this.checkReservedWord(imported.name, specifier.loc.start, true, true);
	      if (!specifier.local) {
	        specifier.local = cloneIdentifier(imported);
	      }
	    }
	    return this.finishImportSpecifier(specifier, "ImportSpecifier", bindingType);
	  }
	  isThisParam(param) {
	    return param.type === "Identifier" && param.name === "this";
	  }
	}
	class Parser extends StatementParser {
	  constructor(options, input) {
	    options = getOptions(options);
	    super(options, input);
	    this.options = options;
	    this.initializeScopes();
	    this.plugins = pluginsMap(this.options.plugins);
	    this.filename = options.sourceFilename;
	  }
	  getScopeHandler() {
	    return ScopeHandler;
	  }
	  parse() {
	    this.enterInitialScopes();
	    const file = this.startNode();
	    const program = this.startNode();
	    this.nextToken();
	    file.errors = null;
	    this.parseTopLevel(file, program);
	    file.errors = this.state.errors;
	    file.comments.length = this.state.commentsLen;
	    return file;
	  }
	}
	function pluginsMap(plugins) {
	  const pluginMap = new Map();
	  for (const plugin of plugins) {
	    const [name, options] = Array.isArray(plugin) ? plugin : [plugin, {}];
	    if (!pluginMap.has(name)) pluginMap.set(name, options || {});
	  }
	  return pluginMap;
	}
	function parse(input, options) {
	  var _options;
	  if (((_options = options) == null ? void 0 : _options.sourceType) === "unambiguous") {
	    options = Object.assign({}, options);
	    try {
	      options.sourceType = "module";
	      const parser = getParser(options, input);
	      const ast = parser.parse();
	      if (parser.sawUnambiguousESM) {
	        return ast;
	      }
	      if (parser.ambiguousScriptDifferentAst) {
	        try {
	          options.sourceType = "script";
	          return getParser(options, input).parse();
	        } catch (_unused) {}
	      } else {
	        ast.program.sourceType = "script";
	      }
	      return ast;
	    } catch (moduleError) {
	      try {
	        options.sourceType = "script";
	        return getParser(options, input).parse();
	      } catch (_unused2) {}
	      throw moduleError;
	    }
	  } else {
	    return getParser(options, input).parse();
	  }
	}
	function parseExpression(input, options) {
	  const parser = getParser(options, input);
	  if (parser.options.strictMode) {
	    parser.state.strict = true;
	  }
	  return parser.getExpression();
	}
	function generateExportedTokenTypes(internalTokenTypes) {
	  const tokenTypes = {};
	  for (const typeName of Object.keys(internalTokenTypes)) {
	    tokenTypes[typeName] = getExportedToken(internalTokenTypes[typeName]);
	  }
	  return tokenTypes;
	}
	const tokTypes = generateExportedTokenTypes(tt);
	function getParser(options, input) {
	  let cls = Parser;
	  if (options != null && options.plugins) {
	    validatePlugins(options.plugins);
	    cls = getParserClass(options.plugins);
	  }
	  return new cls(options, input);
	}
	const parserClassCache = {};
	function getParserClass(pluginsFromOptions) {
	  const pluginList = mixinPluginNames.filter(name => hasPlugin(pluginsFromOptions, name));
	  const key = pluginList.join("/");
	  let cls = parserClassCache[key];
	  if (!cls) {
	    cls = Parser;
	    for (const plugin of pluginList) {
	      cls = mixinPlugins[plugin](cls);
	    }
	    parserClassCache[key] = cls;
	  }
	  return cls;
	}
	lib$8.parse = parse;
	lib$8.parseExpression = parseExpression;
	lib$8.tokTypes = tokTypes;
	
	return lib$8;
}

var lib$7 = {};

var hasRequiredLib$a;

function requireLib$a () {
	if (hasRequiredLib$a) return lib$7;
	hasRequiredLib$a = 1;

	Object.defineProperty(lib$7, "__esModule", {
	  value: true
	});
	lib$7.default = hoistVariables;
	var _t = requireLib$h();
	const {
	  assignmentExpression,
	  expressionStatement,
	  identifier
	} = _t;
	const visitor = {
	  Scope(path, state) {
	    if (state.kind === "let") path.skip();
	  },
	  FunctionParent(path) {
	    path.skip();
	  },
	  VariableDeclaration(path, state) {
	    if (state.kind && path.node.kind !== state.kind) return;
	    const nodes = [];
	    const declarations = path.get("declarations");
	    let firstId;
	    for (const declar of declarations) {
	      firstId = declar.node.id;
	      if (declar.node.init) {
	        nodes.push(expressionStatement(assignmentExpression("=", declar.node.id, declar.node.init)));
	      }
	      for (const name of Object.keys(declar.getBindingIdentifiers())) {
	        state.emit(identifier(name), name, declar.node.init !== null);
	      }
	    }
	    if (path.parentPath.isFor({
	      left: path.node
	    })) {
	      path.replaceWith(firstId);
	    } else {
	      path.replaceWithMultiple(nodes);
	    }
	  }
	};
	function hoistVariables(path, emit, kind = "var") {
	  path.traverse(visitor, {
	    kind,
	    emit
	  });
	}

	
	return lib$7;
}

var hasRequiredReplacement;

function requireReplacement () {
	if (hasRequiredReplacement) return replacement;
	hasRequiredReplacement = 1;

	Object.defineProperty(replacement, "__esModule", {
	  value: true
	});
	replacement._replaceWith = _replaceWith;
	replacement.replaceExpressionWithStatements = replaceExpressionWithStatements;
	replacement.replaceInline = replaceInline;
	replacement.replaceWith = replaceWith;
	replacement.replaceWithMultiple = replaceWithMultiple;
	replacement.replaceWithSourceString = replaceWithSourceString;
	var _codeFrame = requireLib$c();
	var _index = requireLib$7();
	var _index2 = requirePath();
	var _cache = requireCache();
	var _parser = requireLib$b();
	var _t = requireLib$h();
	var _helperHoistVariables = requireLib$a();
	const {
	  FUNCTION_TYPES,
	  arrowFunctionExpression,
	  assignmentExpression,
	  awaitExpression,
	  blockStatement,
	  buildUndefinedNode,
	  callExpression,
	  cloneNode,
	  conditionalExpression,
	  expressionStatement,
	  getBindingIdentifiers,
	  identifier,
	  inheritLeadingComments,
	  inheritTrailingComments,
	  inheritsComments,
	  isBlockStatement,
	  isEmptyStatement,
	  isExpression,
	  isExpressionStatement,
	  isIfStatement,
	  isProgram,
	  isStatement,
	  isVariableDeclaration,
	  removeComments,
	  returnStatement,
	  sequenceExpression,
	  validate,
	  yieldExpression
	} = _t;
	function replaceWithMultiple(nodes) {
	  var _getCachedPaths;
	  this.resync();
	  nodes = this._verifyNodeList(nodes);
	  inheritLeadingComments(nodes[0], this.node);
	  inheritTrailingComments(nodes[nodes.length - 1], this.node);
	  (_getCachedPaths = (0, _cache.getCachedPaths)(this.hub, this.parent)) == null || _getCachedPaths.delete(this.node);
	  this.node = this.container[this.key] = null;
	  const paths = this.insertAfter(nodes);
	  if (this.node) {
	    this.requeue();
	  } else {
	    this.remove();
	  }
	  return paths;
	}
	function replaceWithSourceString(replacement) {
	  this.resync();
	  let ast;
	  try {
	    replacement = `(${replacement})`;
	    ast = (0, _parser.parse)(replacement);
	  } catch (err) {
	    const loc = err.loc;
	    if (loc) {
	      err.message += " - make sure this is an expression.\n" + (0, _codeFrame.codeFrameColumns)(replacement, {
	        start: {
	          line: loc.line,
	          column: loc.column + 1
	        }
	      });
	      err.code = "BABEL_REPLACE_SOURCE_ERROR";
	    }
	    throw err;
	  }
	  const expressionAST = ast.program.body[0].expression;
	  _index.default.removeProperties(expressionAST);
	  return this.replaceWith(expressionAST);
	}
	function replaceWith(replacementPath) {
	  this.resync();
	  if (this.removed) {
	    throw new Error("You can't replace this node, we've already removed it");
	  }
	  let replacement = replacementPath instanceof _index2.default ? replacementPath.node : replacementPath;
	  if (!replacement) {
	    throw new Error("You passed `path.replaceWith()` a falsy node, use `path.remove()` instead");
	  }
	  if (this.node === replacement) {
	    return [this];
	  }
	  if (this.isProgram() && !isProgram(replacement)) {
	    throw new Error("You can only replace a Program root node with another Program node");
	  }
	  if (Array.isArray(replacement)) {
	    throw new Error("Don't use `path.replaceWith()` with an array of nodes, use `path.replaceWithMultiple()`");
	  }
	  if (typeof replacement === "string") {
	    throw new Error("Don't use `path.replaceWith()` with a source string, use `path.replaceWithSourceString()`");
	  }
	  let nodePath = "";
	  if (this.isNodeType("Statement") && isExpression(replacement)) {
	    if (!this.canHaveVariableDeclarationOrExpression() && !this.canSwapBetweenExpressionAndStatement(replacement) && !this.parentPath.isExportDefaultDeclaration()) {
	      replacement = expressionStatement(replacement);
	      nodePath = "expression";
	    }
	  }
	  if (this.isNodeType("Expression") && isStatement(replacement)) {
	    if (!this.canHaveVariableDeclarationOrExpression() && !this.canSwapBetweenExpressionAndStatement(replacement)) {
	      return this.replaceExpressionWithStatements([replacement]);
	    }
	  }
	  const oldNode = this.node;
	  if (oldNode) {
	    inheritsComments(replacement, oldNode);
	    removeComments(oldNode);
	  }
	  this._replaceWith(replacement);
	  this.type = replacement.type;
	  this.setScope();
	  this.requeue();
	  return [nodePath ? this.get(nodePath) : this];
	}
	function _replaceWith(node) {
	  var _getCachedPaths2;
	  if (!this.container) {
	    throw new ReferenceError("Container is falsy");
	  }
	  if (this.inList) {
	    validate(this.parent, this.key, [node]);
	  } else {
	    validate(this.parent, this.key, node);
	  }
	  this.debug(`Replace with ${node == null ? void 0 : node.type}`);
	  (_getCachedPaths2 = (0, _cache.getCachedPaths)(this.hub, this.parent)) == null || _getCachedPaths2.set(node, this).delete(this.node);
	  this.node = this.container[this.key] = node;
	}
	function replaceExpressionWithStatements(nodes) {
	  this.resync();
	  const declars = [];
	  const nodesAsSingleExpression = gatherSequenceExpressions(nodes, declars);
	  if (nodesAsSingleExpression) {
	    for (const id of declars) this.scope.push({
	      id
	    });
	    return this.replaceWith(nodesAsSingleExpression)[0].get("expressions");
	  }
	  const functionParent = this.getFunctionParent();
	  const isParentAsync = functionParent == null ? void 0 : functionParent.is("async");
	  const isParentGenerator = functionParent == null ? void 0 : functionParent.is("generator");
	  const container = arrowFunctionExpression([], blockStatement(nodes));
	  this.replaceWith(callExpression(container, []));
	  const callee = this.get("callee");
	  (0, _helperHoistVariables.default)(callee.get("body"), id => {
	    this.scope.push({
	      id
	    });
	  }, "var");
	  const completionRecords = this.get("callee").getCompletionRecords();
	  for (const path of completionRecords) {
	    if (!path.isExpressionStatement()) continue;
	    const loop = path.findParent(path => path.isLoop());
	    if (loop) {
	      let uid = loop.getData("expressionReplacementReturnUid");
	      if (!uid) {
	        uid = callee.scope.generateDeclaredUidIdentifier("ret");
	        callee.get("body").pushContainer("body", returnStatement(cloneNode(uid)));
	        loop.setData("expressionReplacementReturnUid", uid);
	      } else {
	        uid = identifier(uid.name);
	      }
	      path.get("expression").replaceWith(assignmentExpression("=", cloneNode(uid), path.node.expression));
	    } else {
	      path.replaceWith(returnStatement(path.node.expression));
	    }
	  }
	  callee.arrowFunctionToExpression();
	  const newCallee = callee;
	  const needToAwaitFunction = isParentAsync && _index.default.hasType(this.get("callee.body").node, "AwaitExpression", FUNCTION_TYPES);
	  const needToYieldFunction = isParentGenerator && _index.default.hasType(this.get("callee.body").node, "YieldExpression", FUNCTION_TYPES);
	  if (needToAwaitFunction) {
	    newCallee.set("async", true);
	    if (!needToYieldFunction) {
	      this.replaceWith(awaitExpression(this.node));
	    }
	  }
	  if (needToYieldFunction) {
	    newCallee.set("generator", true);
	    this.replaceWith(yieldExpression(this.node, true));
	  }
	  return newCallee.get("body.body");
	}
	function gatherSequenceExpressions(nodes, declars) {
	  const exprs = [];
	  let ensureLastUndefined = true;
	  for (const node of nodes) {
	    if (!isEmptyStatement(node)) {
	      ensureLastUndefined = false;
	    }
	    if (isExpression(node)) {
	      exprs.push(node);
	    } else if (isExpressionStatement(node)) {
	      exprs.push(node.expression);
	    } else if (isVariableDeclaration(node)) {
	      if (node.kind !== "var") return;
	      for (const declar of node.declarations) {
	        const bindings = getBindingIdentifiers(declar);
	        for (const key of Object.keys(bindings)) {
	          declars.push(cloneNode(bindings[key]));
	        }
	        if (declar.init) {
	          exprs.push(assignmentExpression("=", declar.id, declar.init));
	        }
	      }
	      ensureLastUndefined = true;
	    } else if (isIfStatement(node)) {
	      const consequent = node.consequent ? gatherSequenceExpressions([node.consequent], declars) : buildUndefinedNode();
	      const alternate = node.alternate ? gatherSequenceExpressions([node.alternate], declars) : buildUndefinedNode();
	      if (!consequent || !alternate) return;
	      exprs.push(conditionalExpression(node.test, consequent, alternate));
	    } else if (isBlockStatement(node)) {
	      const body = gatherSequenceExpressions(node.body, declars);
	      if (!body) return;
	      exprs.push(body);
	    } else if (isEmptyStatement(node)) {
	      if (nodes.indexOf(node) === 0) {
	        ensureLastUndefined = true;
	      }
	    } else {
	      return;
	    }
	  }
	  if (ensureLastUndefined) exprs.push(buildUndefinedNode());
	  if (exprs.length === 1) {
	    return exprs[0];
	  } else {
	    return sequenceExpression(exprs);
	  }
	}
	function replaceInline(nodes) {
	  this.resync();
	  if (Array.isArray(nodes)) {
	    if (Array.isArray(this.container)) {
	      nodes = this._verifyNodeList(nodes);
	      const paths = this._containerInsertAfter(nodes);
	      this.remove();
	      return paths;
	    } else {
	      return this.replaceWithMultiple(nodes);
	    }
	  } else {
	    return this.replaceWith(nodes);
	  }
	}

	
	return replacement;
}

var evaluation = {};

var hasRequiredEvaluation;

function requireEvaluation () {
	if (hasRequiredEvaluation) return evaluation;
	hasRequiredEvaluation = 1;

	Object.defineProperty(evaluation, "__esModule", {
	  value: true
	});
	evaluation.evaluate = evaluate;
	evaluation.evaluateTruthy = evaluateTruthy;
	const VALID_OBJECT_CALLEES = ["Number", "String", "Math"];
	const VALID_IDENTIFIER_CALLEES = ["isFinite", "isNaN", "parseFloat", "parseInt", "decodeURI", "decodeURIComponent", "encodeURI", "encodeURIComponent", null, null];
	const INVALID_METHODS = ["random"];
	function isValidObjectCallee(val) {
	  return VALID_OBJECT_CALLEES.includes(val);
	}
	function isValidIdentifierCallee(val) {
	  return VALID_IDENTIFIER_CALLEES.includes(val);
	}
	function isInvalidMethod(val) {
	  return INVALID_METHODS.includes(val);
	}
	function evaluateTruthy() {
	  const res = this.evaluate();
	  if (res.confident) return !!res.value;
	}
	function deopt(path, state) {
	  if (!state.confident) return;
	  state.deoptPath = path;
	  state.confident = false;
	}
	const Globals = new Map([["undefined", undefined], ["Infinity", Infinity], ["NaN", NaN]]);
	function evaluateCached(path, state) {
	  const {
	    node
	  } = path;
	  const {
	    seen
	  } = state;
	  if (seen.has(node)) {
	    const existing = seen.get(node);
	    if (existing.resolved) {
	      return existing.value;
	    } else {
	      deopt(path, state);
	      return;
	    }
	  } else {
	    const item = {
	      resolved: false
	    };
	    seen.set(node, item);
	    const val = _evaluate(path, state);
	    if (state.confident) {
	      item.resolved = true;
	      item.value = val;
	    }
	    return val;
	  }
	}
	function _evaluate(path, state) {
	  if (!state.confident) return;
	  if (path.isSequenceExpression()) {
	    const exprs = path.get("expressions");
	    return evaluateCached(exprs[exprs.length - 1], state);
	  }
	  if (path.isStringLiteral() || path.isNumericLiteral() || path.isBooleanLiteral()) {
	    return path.node.value;
	  }
	  if (path.isNullLiteral()) {
	    return null;
	  }
	  if (path.isTemplateLiteral()) {
	    return evaluateQuasis(path, path.node.quasis, state);
	  }
	  if (path.isTaggedTemplateExpression() && path.get("tag").isMemberExpression()) {
	    const object = path.get("tag.object");
	    const {
	      node: {
	        name
	      }
	    } = object;
	    const property = path.get("tag.property");
	    if (object.isIdentifier() && name === "String" && !path.scope.getBinding(name) && property.isIdentifier() && property.node.name === "raw") {
	      return evaluateQuasis(path, path.node.quasi.quasis, state, true);
	    }
	  }
	  if (path.isConditionalExpression()) {
	    const testResult = evaluateCached(path.get("test"), state);
	    if (!state.confident) return;
	    if (testResult) {
	      return evaluateCached(path.get("consequent"), state);
	    } else {
	      return evaluateCached(path.get("alternate"), state);
	    }
	  }
	  if (path.isExpressionWrapper()) {
	    return evaluateCached(path.get("expression"), state);
	  }
	  if (path.isMemberExpression() && !path.parentPath.isCallExpression({
	    callee: path.node
	  })) {
	    const property = path.get("property");
	    const object = path.get("object");
	    if (object.isLiteral()) {
	      const value = object.node.value;
	      const type = typeof value;
	      let key = null;
	      if (path.node.computed) {
	        key = evaluateCached(property, state);
	        if (!state.confident) return;
	      } else if (property.isIdentifier()) {
	        key = property.node.name;
	      }
	      if ((type === "number" || type === "string") && key != null && (typeof key === "number" || typeof key === "string")) {
	        return value[key];
	      }
	    }
	  }
	  if (path.isReferencedIdentifier()) {
	    const binding = path.scope.getBinding(path.node.name);
	    if (binding) {
	      if (binding.constantViolations.length > 0 || path.node.start < binding.path.node.end) {
	        deopt(binding.path, state);
	        return;
	      }
	      if (binding.hasValue) {
	        return binding.value;
	      }
	    }
	    const name = path.node.name;
	    if (Globals.has(name)) {
	      if (!binding) {
	        return Globals.get(name);
	      }
	      deopt(binding.path, state);
	      return;
	    }
	    const resolved = path.resolve();
	    if (resolved === path) {
	      deopt(path, state);
	      return;
	    } else {
	      return evaluateCached(resolved, state);
	    }
	  }
	  if (path.isUnaryExpression({
	    prefix: true
	  })) {
	    if (path.node.operator === "void") {
	      return undefined;
	    }
	    const argument = path.get("argument");
	    if (path.node.operator === "typeof" && (argument.isFunction() || argument.isClass())) {
	      return "function";
	    }
	    const arg = evaluateCached(argument, state);
	    if (!state.confident) return;
	    switch (path.node.operator) {
	      case "!":
	        return !arg;
	      case "+":
	        return +arg;
	      case "-":
	        return -arg;
	      case "~":
	        return ~arg;
	      case "typeof":
	        return typeof arg;
	    }
	  }
	  if (path.isArrayExpression()) {
	    const arr = [];
	    const elems = path.get("elements");
	    for (const elem of elems) {
	      const elemValue = elem.evaluate();
	      if (elemValue.confident) {
	        arr.push(elemValue.value);
	      } else {
	        deopt(elemValue.deopt, state);
	        return;
	      }
	    }
	    return arr;
	  }
	  if (path.isObjectExpression()) {
	    const obj = {};
	    const props = path.get("properties");
	    for (const prop of props) {
	      if (prop.isObjectMethod() || prop.isSpreadElement()) {
	        deopt(prop, state);
	        return;
	      }
	      const keyPath = prop.get("key");
	      let key;
	      if (prop.node.computed) {
	        key = keyPath.evaluate();
	        if (!key.confident) {
	          deopt(key.deopt, state);
	          return;
	        }
	        key = key.value;
	      } else if (keyPath.isIdentifier()) {
	        key = keyPath.node.name;
	      } else {
	        key = keyPath.node.value;
	      }
	      const valuePath = prop.get("value");
	      let value = valuePath.evaluate();
	      if (!value.confident) {
	        deopt(value.deopt, state);
	        return;
	      }
	      value = value.value;
	      obj[key] = value;
	    }
	    return obj;
	  }
	  if (path.isLogicalExpression()) {
	    const wasConfident = state.confident;
	    const left = evaluateCached(path.get("left"), state);
	    const leftConfident = state.confident;
	    state.confident = wasConfident;
	    const right = evaluateCached(path.get("right"), state);
	    const rightConfident = state.confident;
	    switch (path.node.operator) {
	      case "||":
	        state.confident = leftConfident && (!!left || rightConfident);
	        if (!state.confident) return;
	        return left || right;
	      case "&&":
	        state.confident = leftConfident && (!left || rightConfident);
	        if (!state.confident) return;
	        return left && right;
	      case "??":
	        state.confident = leftConfident && (left != null || rightConfident);
	        if (!state.confident) return;
	        return left != null ? left : right;
	    }
	  }
	  if (path.isBinaryExpression()) {
	    const left = evaluateCached(path.get("left"), state);
	    if (!state.confident) return;
	    const right = evaluateCached(path.get("right"), state);
	    if (!state.confident) return;
	    switch (path.node.operator) {
	      case "-":
	        return left - right;
	      case "+":
	        return left + right;
	      case "/":
	        return left / right;
	      case "*":
	        return left * right;
	      case "%":
	        return left % right;
	      case "**":
	        return Math.pow(left, right);
	      case "<":
	        return left < right;
	      case ">":
	        return left > right;
	      case "<=":
	        return left <= right;
	      case ">=":
	        return left >= right;
	      case "==":
	        return left == right;
	      case "!=":
	        return left != right;
	      case "===":
	        return left === right;
	      case "!==":
	        return left !== right;
	      case "|":
	        return left | right;
	      case "&":
	        return left & right;
	      case "^":
	        return left ^ right;
	      case "<<":
	        return left << right;
	      case ">>":
	        return left >> right;
	      case ">>>":
	        return left >>> right;
	    }
	  }
	  if (path.isCallExpression()) {
	    const callee = path.get("callee");
	    let context;
	    let func;
	    if (callee.isIdentifier() && !path.scope.getBinding(callee.node.name) && (isValidObjectCallee(callee.node.name) || isValidIdentifierCallee(callee.node.name))) {
	      func = commonjsGlobal[callee.node.name];
	    }
	    if (callee.isMemberExpression()) {
	      const object = callee.get("object");
	      const property = callee.get("property");
	      if (object.isIdentifier() && property.isIdentifier() && isValidObjectCallee(object.node.name) && !isInvalidMethod(property.node.name)) {
	        context = commonjsGlobal[object.node.name];
	        const key = property.node.name;
	        if (hasOwnProperty.call(context, key)) {
	          func = context[key];
	        }
	      }
	      if (object.isLiteral() && property.isIdentifier()) {
	        const type = typeof object.node.value;
	        if (type === "string" || type === "number") {
	          context = object.node.value;
	          func = context[property.node.name];
	        }
	      }
	    }
	    if (func) {
	      const args = path.get("arguments").map(arg => evaluateCached(arg, state));
	      if (!state.confident) return;
	      return func.apply(context, args);
	    }
	  }
	  deopt(path, state);
	}
	function evaluateQuasis(path, quasis, state, raw = false) {
	  let str = "";
	  let i = 0;
	  const exprs = path.isTemplateLiteral() ? path.get("expressions") : path.get("quasi.expressions");
	  for (const elem of quasis) {
	    if (!state.confident) break;
	    str += raw ? elem.value.raw : elem.value.cooked;
	    const expr = exprs[i++];
	    if (expr) str += String(evaluateCached(expr, state));
	  }
	  if (!state.confident) return;
	  return str;
	}
	function evaluate() {
	  const state = {
	    confident: true,
	    deoptPath: null,
	    seen: new Map()
	  };
	  let value = evaluateCached(this, state);
	  if (!state.confident) value = undefined;
	  return {
	    confident: state.confident,
	    deopt: state.deoptPath,
	    value: value
	  };
	}

	
	return evaluation;
}

var conversion = {};

var lib$6 = {};

var lib$5 = {};

var formatters = {};

var hasRequiredFormatters;

function requireFormatters () {
	if (hasRequiredFormatters) return formatters;
	hasRequiredFormatters = 1;

	Object.defineProperty(formatters, "__esModule", {
	  value: true
	});
	formatters.statements = formatters.statement = formatters.smart = formatters.program = formatters.expression = void 0;
	var _t = requireLib$h();
	const {
	  assertExpressionStatement
	} = _t;
	function makeStatementFormatter(fn) {
	  return {
	    code: str => `/* @babel/template */;\n${str}`,
	    validate: () => {},
	    unwrap: ast => {
	      return fn(ast.program.body.slice(1));
	    }
	  };
	}
	formatters.smart = makeStatementFormatter(body => {
	  if (body.length > 1) {
	    return body;
	  } else {
	    return body[0];
	  }
	});
	formatters.statements = makeStatementFormatter(body => body);
	formatters.statement = makeStatementFormatter(body => {
	  if (body.length === 0) {
	    throw new Error("Found nothing to return.");
	  }
	  if (body.length > 1) {
	    throw new Error("Found multiple statements but wanted one");
	  }
	  return body[0];
	});
	const expression = formatters.expression = {
	  code: str => `(\n${str}\n)`,
	  validate: ast => {
	    if (ast.program.body.length > 1) {
	      throw new Error("Found multiple statements but wanted one");
	    }
	    if (expression.unwrap(ast).start === 0) {
	      throw new Error("Parse result included parens.");
	    }
	  },
	  unwrap: ({
	    program
	  }) => {
	    const [stmt] = program.body;
	    assertExpressionStatement(stmt);
	    return stmt.expression;
	  }
	};
	formatters.program = {
	  code: str => str,
	  validate: () => {},
	  unwrap: ast => ast.program
	};

	
	return formatters;
}

var builder = {};

var options$2 = {};

var hasRequiredOptions$2;

function requireOptions$2 () {
	if (hasRequiredOptions$2) return options$2;
	hasRequiredOptions$2 = 1;

	Object.defineProperty(options$2, "__esModule", {
	  value: true
	});
	options$2.merge = merge;
	options$2.normalizeReplacements = normalizeReplacements;
	options$2.validate = validate;
	const _excluded = ["placeholderWhitelist", "placeholderPattern", "preserveComments", "syntacticPlaceholders"];
	function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
	function merge(a, b) {
	  const {
	    placeholderWhitelist = a.placeholderWhitelist,
	    placeholderPattern = a.placeholderPattern,
	    preserveComments = a.preserveComments,
	    syntacticPlaceholders = a.syntacticPlaceholders
	  } = b;
	  return {
	    parser: Object.assign({}, a.parser, b.parser),
	    placeholderWhitelist,
	    placeholderPattern,
	    preserveComments,
	    syntacticPlaceholders
	  };
	}
	function validate(opts) {
	  if (opts != null && typeof opts !== "object") {
	    throw new Error("Unknown template options.");
	  }
	  const _ref = opts || {},
	    {
	      placeholderWhitelist,
	      placeholderPattern,
	      preserveComments,
	      syntacticPlaceholders
	    } = _ref,
	    parser = _objectWithoutPropertiesLoose(_ref, _excluded);
	  if (placeholderWhitelist != null && !(placeholderWhitelist instanceof Set)) {
	    throw new Error("'.placeholderWhitelist' must be a Set, null, or undefined");
	  }
	  if (placeholderPattern != null && !(placeholderPattern instanceof RegExp) && placeholderPattern !== false) {
	    throw new Error("'.placeholderPattern' must be a RegExp, false, null, or undefined");
	  }
	  if (preserveComments != null && typeof preserveComments !== "boolean") {
	    throw new Error("'.preserveComments' must be a boolean, null, or undefined");
	  }
	  if (syntacticPlaceholders != null && typeof syntacticPlaceholders !== "boolean") {
	    throw new Error("'.syntacticPlaceholders' must be a boolean, null, or undefined");
	  }
	  if (syntacticPlaceholders === true && (placeholderWhitelist != null || placeholderPattern != null)) {
	    throw new Error("'.placeholderWhitelist' and '.placeholderPattern' aren't compatible" + " with '.syntacticPlaceholders: true'");
	  }
	  return {
	    parser,
	    placeholderWhitelist: placeholderWhitelist || undefined,
	    placeholderPattern: placeholderPattern == null ? undefined : placeholderPattern,
	    preserveComments: preserveComments == null ? undefined : preserveComments,
	    syntacticPlaceholders: syntacticPlaceholders == null ? undefined : syntacticPlaceholders
	  };
	}
	function normalizeReplacements(replacements) {
	  if (Array.isArray(replacements)) {
	    return replacements.reduce((acc, replacement, i) => {
	      acc["$" + i] = replacement;
	      return acc;
	    }, {});
	  } else if (typeof replacements === "object" || replacements == null) {
	    return replacements || undefined;
	  }
	  throw new Error("Template replacements must be an array, object, null, or undefined");
	}

	
	return options$2;
}

var string = {};

var parse$4 = {};

var hasRequiredParse$2;

function requireParse$2 () {
	if (hasRequiredParse$2) return parse$4;
	hasRequiredParse$2 = 1;

	Object.defineProperty(parse$4, "__esModule", {
	  value: true
	});
	parse$4.default = parseAndBuildMetadata;
	var _t = requireLib$h();
	var _parser = requireLib$b();
	var _codeFrame = requireLib$c();
	const {
	  isCallExpression,
	  isExpressionStatement,
	  isFunction,
	  isIdentifier,
	  isJSXIdentifier,
	  isNewExpression,
	  isPlaceholder,
	  isStatement,
	  isStringLiteral,
	  removePropertiesDeep,
	  traverse
	} = _t;
	const PATTERN = /^[_$A-Z0-9]+$/;
	function parseAndBuildMetadata(formatter, code, opts) {
	  const {
	    placeholderWhitelist,
	    placeholderPattern,
	    preserveComments,
	    syntacticPlaceholders
	  } = opts;
	  const ast = parseWithCodeFrame(code, opts.parser, syntacticPlaceholders);
	  removePropertiesDeep(ast, {
	    preserveComments
	  });
	  formatter.validate(ast);
	  const state = {
	    syntactic: {
	      placeholders: [],
	      placeholderNames: new Set()
	    },
	    legacy: {
	      placeholders: [],
	      placeholderNames: new Set()
	    },
	    placeholderWhitelist,
	    placeholderPattern,
	    syntacticPlaceholders
	  };
	  traverse(ast, placeholderVisitorHandler, state);
	  return Object.assign({
	    ast
	  }, state.syntactic.placeholders.length ? state.syntactic : state.legacy);
	}
	function placeholderVisitorHandler(node, ancestors, state) {
	  var _state$placeholderWhi;
	  let name;
	  let hasSyntacticPlaceholders = state.syntactic.placeholders.length > 0;
	  if (isPlaceholder(node)) {
	    if (state.syntacticPlaceholders === false) {
	      throw new Error("%%foo%%-style placeholders can't be used when " + "'.syntacticPlaceholders' is false.");
	    }
	    name = node.name.name;
	    hasSyntacticPlaceholders = true;
	  } else if (hasSyntacticPlaceholders || state.syntacticPlaceholders) {
	    return;
	  } else if (isIdentifier(node) || isJSXIdentifier(node)) {
	    name = node.name;
	  } else if (isStringLiteral(node)) {
	    name = node.value;
	  } else {
	    return;
	  }
	  if (hasSyntacticPlaceholders && (state.placeholderPattern != null || state.placeholderWhitelist != null)) {
	    throw new Error("'.placeholderWhitelist' and '.placeholderPattern' aren't compatible" + " with '.syntacticPlaceholders: true'");
	  }
	  if (!hasSyntacticPlaceholders && (state.placeholderPattern === false || !(state.placeholderPattern || PATTERN).test(name)) && !((_state$placeholderWhi = state.placeholderWhitelist) != null && _state$placeholderWhi.has(name))) {
	    return;
	  }
	  ancestors = ancestors.slice();
	  const {
	    node: parent,
	    key
	  } = ancestors[ancestors.length - 1];
	  let type;
	  if (isStringLiteral(node) || isPlaceholder(node, {
	    expectedNode: "StringLiteral"
	  })) {
	    type = "string";
	  } else if (isNewExpression(parent) && key === "arguments" || isCallExpression(parent) && key === "arguments" || isFunction(parent) && key === "params") {
	    type = "param";
	  } else if (isExpressionStatement(parent) && !isPlaceholder(node)) {
	    type = "statement";
	    ancestors = ancestors.slice(0, -1);
	  } else if (isStatement(node) && isPlaceholder(node)) {
	    type = "statement";
	  } else {
	    type = "other";
	  }
	  const {
	    placeholders,
	    placeholderNames
	  } = !hasSyntacticPlaceholders ? state.legacy : state.syntactic;
	  placeholders.push({
	    name,
	    type,
	    resolve: ast => resolveAncestors(ast, ancestors),
	    isDuplicate: placeholderNames.has(name)
	  });
	  placeholderNames.add(name);
	}
	function resolveAncestors(ast, ancestors) {
	  let parent = ast;
	  for (let i = 0; i < ancestors.length - 1; i++) {
	    const {
	      key,
	      index
	    } = ancestors[i];
	    if (index === undefined) {
	      parent = parent[key];
	    } else {
	      parent = parent[key][index];
	    }
	  }
	  const {
	    key,
	    index
	  } = ancestors[ancestors.length - 1];
	  return {
	    parent,
	    key,
	    index
	  };
	}
	function parseWithCodeFrame(code, parserOpts, syntacticPlaceholders) {
	  const plugins = (parserOpts.plugins || []).slice();
	  if (syntacticPlaceholders !== false) {
	    plugins.push("placeholders");
	  }
	  parserOpts = Object.assign({
	    allowReturnOutsideFunction: true,
	    allowSuperOutsideMethod: true,
	    sourceType: "module"
	  }, parserOpts, {
	    plugins
	  });
	  try {
	    return (0, _parser.parse)(code, parserOpts);
	  } catch (err) {
	    const loc = err.loc;
	    if (loc) {
	      err.message += "\n" + (0, _codeFrame.codeFrameColumns)(code, {
	        start: loc
	      });
	      err.code = "BABEL_TEMPLATE_PARSE_ERROR";
	    }
	    throw err;
	  }
	}

	
	return parse$4;
}

var populate = {};

var hasRequiredPopulate;

function requirePopulate () {
	if (hasRequiredPopulate) return populate;
	hasRequiredPopulate = 1;

	Object.defineProperty(populate, "__esModule", {
	  value: true
	});
	populate.default = populatePlaceholders;
	var _t = requireLib$h();
	const {
	  blockStatement,
	  cloneNode,
	  emptyStatement,
	  expressionStatement,
	  identifier,
	  isStatement,
	  isStringLiteral,
	  stringLiteral,
	  validate
	} = _t;
	function populatePlaceholders(metadata, replacements) {
	  const ast = cloneNode(metadata.ast);
	  if (replacements) {
	    metadata.placeholders.forEach(placeholder => {
	      if (!hasOwnProperty.call(replacements, placeholder.name)) {
	        const placeholderName = placeholder.name;
	        throw new Error(`Error: No substitution given for "${placeholderName}". If this is not meant to be a
            placeholder you may want to consider passing one of the following options to @babel/template:
            - { placeholderPattern: false, placeholderWhitelist: new Set(['${placeholderName}'])}
            - { placeholderPattern: /^${placeholderName}$/ }`);
	      }
	    });
	    Object.keys(replacements).forEach(key => {
	      if (!metadata.placeholderNames.has(key)) {
	        throw new Error(`Unknown substitution "${key}" given`);
	      }
	    });
	  }
	  metadata.placeholders.slice().reverse().forEach(placeholder => {
	    try {
	      applyReplacement(placeholder, ast, replacements && replacements[placeholder.name] || null);
	    } catch (e) {
	      e.message = `@babel/template placeholder "${placeholder.name}": ${e.message}`;
	      throw e;
	    }
	  });
	  return ast;
	}
	function applyReplacement(placeholder, ast, replacement) {
	  if (placeholder.isDuplicate) {
	    if (Array.isArray(replacement)) {
	      replacement = replacement.map(node => cloneNode(node));
	    } else if (typeof replacement === "object") {
	      replacement = cloneNode(replacement);
	    }
	  }
	  const {
	    parent,
	    key,
	    index
	  } = placeholder.resolve(ast);
	  if (placeholder.type === "string") {
	    if (typeof replacement === "string") {
	      replacement = stringLiteral(replacement);
	    }
	    if (!replacement || !isStringLiteral(replacement)) {
	      throw new Error("Expected string substitution");
	    }
	  } else if (placeholder.type === "statement") {
	    if (index === undefined) {
	      if (!replacement) {
	        replacement = emptyStatement();
	      } else if (Array.isArray(replacement)) {
	        replacement = blockStatement(replacement);
	      } else if (typeof replacement === "string") {
	        replacement = expressionStatement(identifier(replacement));
	      } else if (!isStatement(replacement)) {
	        replacement = expressionStatement(replacement);
	      }
	    } else {
	      if (replacement && !Array.isArray(replacement)) {
	        if (typeof replacement === "string") {
	          replacement = identifier(replacement);
	        }
	        if (!isStatement(replacement)) {
	          replacement = expressionStatement(replacement);
	        }
	      }
	    }
	  } else if (placeholder.type === "param") {
	    if (typeof replacement === "string") {
	      replacement = identifier(replacement);
	    }
	    if (index === undefined) throw new Error("Assertion failure.");
	  } else {
	    if (typeof replacement === "string") {
	      replacement = identifier(replacement);
	    }
	    if (Array.isArray(replacement)) {
	      throw new Error("Cannot replace single expression with an array.");
	    }
	  }
	  if (index === undefined) {
	    validate(parent, key, replacement);
	    parent[key] = replacement;
	  } else {
	    const items = parent[key].slice();
	    if (placeholder.type === "statement" || placeholder.type === "param") {
	      if (replacement == null) {
	        items.splice(index, 1);
	      } else if (Array.isArray(replacement)) {
	        items.splice(index, 1, ...replacement);
	      } else {
	        items[index] = replacement;
	      }
	    } else {
	      items[index] = replacement;
	    }
	    validate(parent, key, items);
	    parent[key] = items;
	  }
	}

	
	return populate;
}

var hasRequiredString;

function requireString () {
	if (hasRequiredString) return string;
	hasRequiredString = 1;

	Object.defineProperty(string, "__esModule", {
	  value: true
	});
	string.default = stringTemplate;
	var _options = requireOptions$2();
	var _parse = requireParse$2();
	var _populate = requirePopulate();
	function stringTemplate(formatter, code, opts) {
	  code = formatter.code(code);
	  let metadata;
	  return arg => {
	    const replacements = (0, _options.normalizeReplacements)(arg);
	    if (!metadata) metadata = (0, _parse.default)(formatter, code, opts);
	    return formatter.unwrap((0, _populate.default)(metadata, replacements));
	  };
	}

	
	return string;
}

var literal = {};

var hasRequiredLiteral;

function requireLiteral () {
	if (hasRequiredLiteral) return literal;
	hasRequiredLiteral = 1;

	Object.defineProperty(literal, "__esModule", {
	  value: true
	});
	literal.default = literalTemplate;
	var _options = requireOptions$2();
	var _parse = requireParse$2();
	var _populate = requirePopulate();
	function literalTemplate(formatter, tpl, opts) {
	  const {
	    metadata,
	    names
	  } = buildLiteralData(formatter, tpl, opts);
	  return arg => {
	    const defaultReplacements = {};
	    arg.forEach((replacement, i) => {
	      defaultReplacements[names[i]] = replacement;
	    });
	    return arg => {
	      const replacements = (0, _options.normalizeReplacements)(arg);
	      if (replacements) {
	        Object.keys(replacements).forEach(key => {
	          if (hasOwnProperty.call(defaultReplacements, key)) {
	            throw new Error("Unexpected replacement overlap.");
	          }
	        });
	      }
	      return formatter.unwrap((0, _populate.default)(metadata, replacements ? Object.assign(replacements, defaultReplacements) : defaultReplacements));
	    };
	  };
	}
	function buildLiteralData(formatter, tpl, opts) {
	  let prefix = "BABEL_TPL$";
	  const raw = tpl.join("");
	  do {
	    prefix = "$$" + prefix;
	  } while (raw.includes(prefix));
	  const {
	    names,
	    code
	  } = buildTemplateCode(tpl, prefix);
	  const metadata = (0, _parse.default)(formatter, formatter.code(code), {
	    parser: opts.parser,
	    placeholderWhitelist: new Set(names.concat(opts.placeholderWhitelist ? Array.from(opts.placeholderWhitelist) : [])),
	    placeholderPattern: opts.placeholderPattern,
	    preserveComments: opts.preserveComments,
	    syntacticPlaceholders: opts.syntacticPlaceholders
	  });
	  return {
	    metadata,
	    names
	  };
	}
	function buildTemplateCode(tpl, prefix) {
	  const names = [];
	  let code = tpl[0];
	  for (let i = 1; i < tpl.length; i++) {
	    const value = `${prefix}${i - 1}`;
	    names.push(value);
	    code += value + tpl[i];
	  }
	  return {
	    names,
	    code
	  };
	}

	
	return literal;
}

var hasRequiredBuilder;

function requireBuilder () {
	if (hasRequiredBuilder) return builder;
	hasRequiredBuilder = 1;

	Object.defineProperty(builder, "__esModule", {
	  value: true
	});
	builder.default = createTemplateBuilder;
	var _options = requireOptions$2();
	var _string = requireString();
	var _literal = requireLiteral();
	const NO_PLACEHOLDER = (0, _options.validate)({
	  placeholderPattern: false
	});
	function createTemplateBuilder(formatter, defaultOpts) {
	  const templateFnCache = new WeakMap();
	  const templateAstCache = new WeakMap();
	  const cachedOpts = defaultOpts || (0, _options.validate)(null);
	  return Object.assign((tpl, ...args) => {
	    if (typeof tpl === "string") {
	      if (args.length > 1) throw new Error("Unexpected extra params.");
	      return extendedTrace((0, _string.default)(formatter, tpl, (0, _options.merge)(cachedOpts, (0, _options.validate)(args[0]))));
	    } else if (Array.isArray(tpl)) {
	      let builder = templateFnCache.get(tpl);
	      if (!builder) {
	        builder = (0, _literal.default)(formatter, tpl, cachedOpts);
	        templateFnCache.set(tpl, builder);
	      }
	      return extendedTrace(builder(args));
	    } else if (typeof tpl === "object" && tpl) {
	      if (args.length > 0) throw new Error("Unexpected extra params.");
	      return createTemplateBuilder(formatter, (0, _options.merge)(cachedOpts, (0, _options.validate)(tpl)));
	    }
	    throw new Error(`Unexpected template param ${typeof tpl}`);
	  }, {
	    ast: (tpl, ...args) => {
	      if (typeof tpl === "string") {
	        if (args.length > 1) throw new Error("Unexpected extra params.");
	        return (0, _string.default)(formatter, tpl, (0, _options.merge)((0, _options.merge)(cachedOpts, (0, _options.validate)(args[0])), NO_PLACEHOLDER))();
	      } else if (Array.isArray(tpl)) {
	        let builder = templateAstCache.get(tpl);
	        if (!builder) {
	          builder = (0, _literal.default)(formatter, tpl, (0, _options.merge)(cachedOpts, NO_PLACEHOLDER));
	          templateAstCache.set(tpl, builder);
	        }
	        return builder(args)();
	      }
	      throw new Error(`Unexpected template param ${typeof tpl}`);
	    }
	  });
	}
	function extendedTrace(fn) {
	  let rootStack = "";
	  try {
	    throw new Error();
	  } catch (error) {
	    if (error.stack) {
	      rootStack = error.stack.split("\n").slice(3).join("\n");
	    }
	  }
	  return arg => {
	    try {
	      return fn(arg);
	    } catch (err) {
	      err.stack += `\n    =============\n${rootStack}`;
	      throw err;
	    }
	  };
	}

	
	return builder;
}

var hasRequiredLib$9;

function requireLib$9 () {
	if (hasRequiredLib$9) return lib$5;
	hasRequiredLib$9 = 1;

	Object.defineProperty(lib$5, "__esModule", {
	  value: true
	});
	lib$5.statements = lib$5.statement = lib$5.smart = lib$5.program = lib$5.expression = lib$5.default = void 0;
	var formatters = requireFormatters();
	var _builder = requireBuilder();
	const smart = lib$5.smart = (0, _builder.default)(formatters.smart);
	const statement = lib$5.statement = (0, _builder.default)(formatters.statement);
	const statements = lib$5.statements = (0, _builder.default)(formatters.statements);
	const expression = lib$5.expression = (0, _builder.default)(formatters.expression);
	const program = lib$5.program = (0, _builder.default)(formatters.program);
	lib$5.default = Object.assign(smart.bind(undefined), {
	  smart,
	  statement,
	  statements,
	  expression,
	  program,
	  ast: smart.ast
	});

	
	return lib$5;
}

var hasRequiredLib$8;

function requireLib$8 () {
	if (hasRequiredLib$8) return lib$6;
	hasRequiredLib$8 = 1;

	Object.defineProperty(lib$6, "__esModule", {
	  value: true
	});
	lib$6.default = _default;
	var _template = requireLib$9();
	var _t = requireLib$h();
	const {
	  NOT_LOCAL_BINDING,
	  cloneNode,
	  identifier,
	  isAssignmentExpression,
	  isAssignmentPattern,
	  isFunction,
	  isIdentifier,
	  isLiteral,
	  isNullLiteral,
	  isObjectMethod,
	  isObjectProperty,
	  isRegExpLiteral,
	  isRestElement,
	  isTemplateLiteral,
	  isVariableDeclarator,
	  toBindingIdentifierName
	} = _t;
	function getFunctionArity(node) {
	  const count = node.params.findIndex(param => isAssignmentPattern(param) || isRestElement(param));
	  return count === -1 ? node.params.length : count;
	}
	const buildPropertyMethodAssignmentWrapper = _template.default.statement(`
  (function (FUNCTION_KEY) {
    function FUNCTION_ID() {
      return FUNCTION_KEY.apply(this, arguments);
    }

    FUNCTION_ID.toString = function () {
      return FUNCTION_KEY.toString();
    }

    return FUNCTION_ID;
  })(FUNCTION)
`);
	const buildGeneratorPropertyMethodAssignmentWrapper = _template.default.statement(`
  (function (FUNCTION_KEY) {
    function* FUNCTION_ID() {
      return yield* FUNCTION_KEY.apply(this, arguments);
    }

    FUNCTION_ID.toString = function () {
      return FUNCTION_KEY.toString();
    };

    return FUNCTION_ID;
  })(FUNCTION)
`);
	const visitor = {
	  "ReferencedIdentifier|BindingIdentifier"(path, state) {
	    if (path.node.name !== state.name) return;
	    const localDeclar = path.scope.getBindingIdentifier(state.name);
	    if (localDeclar !== state.outerDeclar) return;
	    state.selfReference = true;
	    path.stop();
	  }
	};
	function getNameFromLiteralId(id) {
	  if (isNullLiteral(id)) {
	    return "null";
	  }
	  if (isRegExpLiteral(id)) {
	    return `_${id.pattern}_${id.flags}`;
	  }
	  if (isTemplateLiteral(id)) {
	    return id.quasis.map(quasi => quasi.value.raw).join("");
	  }
	  if (id.value !== undefined) {
	    return id.value + "";
	  }
	  return "";
	}
	function wrap(state, method, id, scope) {
	  if (state.selfReference) {
	    if (scope.hasBinding(id.name) && !scope.hasGlobal(id.name)) {
	      scope.rename(id.name);
	    } else {
	      if (!isFunction(method)) return;
	      let build = buildPropertyMethodAssignmentWrapper;
	      if (method.generator) {
	        build = buildGeneratorPropertyMethodAssignmentWrapper;
	      }
	      const template = build({
	        FUNCTION: method,
	        FUNCTION_ID: id,
	        FUNCTION_KEY: scope.generateUidIdentifier(id.name)
	      }).expression;
	      const params = template.callee.body.body[0].params;
	      for (let i = 0, len = getFunctionArity(method); i < len; i++) {
	        params.push(scope.generateUidIdentifier("x"));
	      }
	      return template;
	    }
	  }
	  method.id = id;
	  scope.getProgramParent().references[id.name] = true;
	}
	function visit(node, name, scope) {
	  const state = {
	    selfAssignment: false,
	    selfReference: false,
	    outerDeclar: scope.getBindingIdentifier(name),
	    name: name
	  };
	  const binding = scope.getOwnBinding(name);
	  if (binding) {
	    if (binding.kind === "param") {
	      state.selfReference = true;
	    }
	  } else if (state.outerDeclar || scope.hasGlobal(name)) {
	    scope.traverse(node, visitor, state);
	  }
	  return state;
	}
	function _default({
	  node,
	  parent,
	  scope,
	  id
	}, localBinding = false, supportUnicodeId = false) {
	  if (node.id) return;
	  if ((isObjectProperty(parent) || isObjectMethod(parent, {
	    kind: "method"
	  })) && (!parent.computed || isLiteral(parent.key))) {
	    id = parent.key;
	  } else if (isVariableDeclarator(parent)) {
	    id = parent.id;
	    if (isIdentifier(id) && !localBinding) {
	      const binding = scope.parent.getBinding(id.name);
	      if (binding && binding.constant && scope.getBinding(id.name) === binding) {
	        node.id = cloneNode(id);
	        node.id[NOT_LOCAL_BINDING] = true;
	        return;
	      }
	    }
	  } else if (isAssignmentExpression(parent, {
	    operator: "="
	  })) {
	    id = parent.left;
	  } else if (!id) {
	    return;
	  }
	  let name;
	  if (id && isLiteral(id)) {
	    name = getNameFromLiteralId(id);
	  } else if (id && isIdentifier(id)) {
	    name = id.name;
	  }
	  if (name === undefined) {
	    return;
	  }
	  if (!supportUnicodeId && isFunction(node) && /[\uD800-\uDFFF]/.test(name)) {
	    return;
	  }
	  name = toBindingIdentifierName(name);
	  const newId = identifier(name);
	  newId[NOT_LOCAL_BINDING] = true;
	  const state = visit(node, name, scope);
	  return wrap(state, node, newId, scope) || node;
	}

	
	return lib$6;
}

var hasRequiredConversion;

function requireConversion () {
	if (hasRequiredConversion) return conversion;
	hasRequiredConversion = 1;

	Object.defineProperty(conversion, "__esModule", {
	  value: true
	});
	conversion.arrowFunctionToExpression = arrowFunctionToExpression;
	conversion.ensureBlock = ensureBlock;
	conversion.toComputedKey = toComputedKey;
	conversion.unwrapFunctionEnvironment = unwrapFunctionEnvironment;
	var _t = requireLib$h();
	var _helperEnvironmentVisitor = requireLib$f();
	var _helperFunctionName = requireLib$8();
	var _visitors = requireVisitors();
	const {
	  arrowFunctionExpression,
	  assignmentExpression,
	  binaryExpression,
	  blockStatement,
	  callExpression,
	  conditionalExpression,
	  expressionStatement,
	  identifier,
	  isIdentifier,
	  jsxIdentifier,
	  logicalExpression,
	  LOGICAL_OPERATORS,
	  memberExpression,
	  metaProperty,
	  numericLiteral,
	  objectExpression,
	  restElement,
	  returnStatement,
	  sequenceExpression,
	  spreadElement,
	  stringLiteral,
	  super: _super,
	  thisExpression,
	  toExpression,
	  unaryExpression
	} = _t;
	function toComputedKey() {
	  let key;
	  if (this.isMemberExpression()) {
	    key = this.node.property;
	  } else if (this.isProperty() || this.isMethod()) {
	    key = this.node.key;
	  } else {
	    throw new ReferenceError("todo");
	  }
	  if (!this.node.computed) {
	    if (isIdentifier(key)) key = stringLiteral(key.name);
	  }
	  return key;
	}
	function ensureBlock() {
	  const body = this.get("body");
	  const bodyNode = body.node;
	  if (Array.isArray(body)) {
	    throw new Error("Can't convert array path to a block statement");
	  }
	  if (!bodyNode) {
	    throw new Error("Can't convert node without a body");
	  }
	  if (body.isBlockStatement()) {
	    return bodyNode;
	  }
	  const statements = [];
	  let stringPath = "body";
	  let key;
	  let listKey;
	  if (body.isStatement()) {
	    listKey = "body";
	    key = 0;
	    statements.push(body.node);
	  } else {
	    stringPath += ".body.0";
	    if (this.isFunction()) {
	      key = "argument";
	      statements.push(returnStatement(body.node));
	    } else {
	      key = "expression";
	      statements.push(expressionStatement(body.node));
	    }
	  }
	  this.node.body = blockStatement(statements);
	  const parentPath = this.get(stringPath);
	  body.setup(parentPath, listKey ? parentPath.node[listKey] : parentPath.node, listKey, key);
	  return this.node;
	}
	{
	  conversion.arrowFunctionToShadowed = function () {
	    if (!this.isArrowFunctionExpression()) return;
	    this.arrowFunctionToExpression();
	  };
	}
	function unwrapFunctionEnvironment() {
	  if (!this.isArrowFunctionExpression() && !this.isFunctionExpression() && !this.isFunctionDeclaration()) {
	    throw this.buildCodeFrameError("Can only unwrap the environment of a function.");
	  }
	  hoistFunctionEnvironment(this);
	}
	function setType(path, type) {
	  path.node.type = type;
	}
	function arrowFunctionToExpression({
	  allowInsertArrow = true,
	  allowInsertArrowWithRest = allowInsertArrow,
	  noNewArrows = !(_arguments$ => (_arguments$ = arguments[0]) == null ? void 0 : _arguments$.specCompliant)()
	} = {}) {
	  if (!this.isArrowFunctionExpression()) {
	    throw this.buildCodeFrameError("Cannot convert non-arrow function to a function expression.");
	  }
	  const {
	    thisBinding,
	    fnPath: fn
	  } = hoistFunctionEnvironment(this, noNewArrows, allowInsertArrow, allowInsertArrowWithRest);
	  fn.ensureBlock();
	  setType(fn, "FunctionExpression");
	  if (!noNewArrows) {
	    const checkBinding = thisBinding ? null : fn.scope.generateUidIdentifier("arrowCheckId");
	    if (checkBinding) {
	      fn.parentPath.scope.push({
	        id: checkBinding,
	        init: objectExpression([])
	      });
	    }
	    fn.get("body").unshiftContainer("body", expressionStatement(callExpression(this.hub.addHelper("newArrowCheck"), [thisExpression(), checkBinding ? identifier(checkBinding.name) : identifier(thisBinding)])));
	    fn.replaceWith(callExpression(memberExpression((0, _helperFunctionName.default)(this, true) || fn.node, identifier("bind")), [checkBinding ? identifier(checkBinding.name) : thisExpression()]));
	    return fn.get("callee.object");
	  }
	  return fn;
	}
	const getSuperCallsVisitor = (0, _visitors.merge)([{
	  CallExpression(child, {
	    allSuperCalls
	  }) {
	    if (!child.get("callee").isSuper()) return;
	    allSuperCalls.push(child);
	  }
	}, _helperEnvironmentVisitor.default]);
	function hoistFunctionEnvironment(fnPath, noNewArrows = true, allowInsertArrow = true, allowInsertArrowWithRest = true) {
	  let arrowParent;
	  let thisEnvFn = fnPath.findParent(p => {
	    if (p.isArrowFunctionExpression()) {
	      var _arrowParent;
	      (_arrowParent = arrowParent) != null ? _arrowParent : arrowParent = p;
	      return false;
	    }
	    return p.isFunction() || p.isProgram() || p.isClassProperty({
	      static: false
	    }) || p.isClassPrivateProperty({
	      static: false
	    });
	  });
	  const inConstructor = thisEnvFn.isClassMethod({
	    kind: "constructor"
	  });
	  if (thisEnvFn.isClassProperty() || thisEnvFn.isClassPrivateProperty()) {
	    if (arrowParent) {
	      thisEnvFn = arrowParent;
	    } else if (allowInsertArrow) {
	      fnPath.replaceWith(callExpression(arrowFunctionExpression([], toExpression(fnPath.node)), []));
	      thisEnvFn = fnPath.get("callee");
	      fnPath = thisEnvFn.get("body");
	    } else {
	      throw fnPath.buildCodeFrameError("Unable to transform arrow inside class property");
	    }
	  }
	  const {
	    thisPaths,
	    argumentsPaths,
	    newTargetPaths,
	    superProps,
	    superCalls
	  } = getScopeInformation(fnPath);
	  if (inConstructor && superCalls.length > 0) {
	    if (!allowInsertArrow) {
	      throw superCalls[0].buildCodeFrameError("When using '@babel/plugin-transform-arrow-functions', " + "it's not possible to compile `super()` in an arrow function without compiling classes.\n" + "Please add '@babel/plugin-transform-classes' to your Babel configuration.");
	    }
	    if (!allowInsertArrowWithRest) {
	      throw superCalls[0].buildCodeFrameError("When using '@babel/plugin-transform-parameters', " + "it's not possible to compile `super()` in an arrow function with default or rest parameters without compiling classes.\n" + "Please add '@babel/plugin-transform-classes' to your Babel configuration.");
	    }
	    const allSuperCalls = [];
	    thisEnvFn.traverse(getSuperCallsVisitor, {
	      allSuperCalls
	    });
	    const superBinding = getSuperBinding(thisEnvFn);
	    allSuperCalls.forEach(superCall => {
	      const callee = identifier(superBinding);
	      callee.loc = superCall.node.callee.loc;
	      superCall.get("callee").replaceWith(callee);
	    });
	  }
	  if (argumentsPaths.length > 0) {
	    const argumentsBinding = getBinding(thisEnvFn, "arguments", () => {
	      const args = () => identifier("arguments");
	      if (thisEnvFn.scope.path.isProgram()) {
	        return conditionalExpression(binaryExpression("===", unaryExpression("typeof", args()), stringLiteral("undefined")), thisEnvFn.scope.buildUndefinedNode(), args());
	      } else {
	        return args();
	      }
	    });
	    argumentsPaths.forEach(argumentsChild => {
	      const argsRef = identifier(argumentsBinding);
	      argsRef.loc = argumentsChild.node.loc;
	      argumentsChild.replaceWith(argsRef);
	    });
	  }
	  if (newTargetPaths.length > 0) {
	    const newTargetBinding = getBinding(thisEnvFn, "newtarget", () => metaProperty(identifier("new"), identifier("target")));
	    newTargetPaths.forEach(targetChild => {
	      const targetRef = identifier(newTargetBinding);
	      targetRef.loc = targetChild.node.loc;
	      targetChild.replaceWith(targetRef);
	    });
	  }
	  if (superProps.length > 0) {
	    if (!allowInsertArrow) {
	      throw superProps[0].buildCodeFrameError("When using '@babel/plugin-transform-arrow-functions', " + "it's not possible to compile `super.prop` in an arrow function without compiling classes.\n" + "Please add '@babel/plugin-transform-classes' to your Babel configuration.");
	    }
	    const flatSuperProps = superProps.reduce((acc, superProp) => acc.concat(standardizeSuperProperty(superProp)), []);
	    flatSuperProps.forEach(superProp => {
	      const key = superProp.node.computed ? "" : superProp.get("property").node.name;
	      const superParentPath = superProp.parentPath;
	      const isAssignment = superParentPath.isAssignmentExpression({
	        left: superProp.node
	      });
	      const isCall = superParentPath.isCallExpression({
	        callee: superProp.node
	      });
	      const isTaggedTemplate = superParentPath.isTaggedTemplateExpression({
	        tag: superProp.node
	      });
	      const superBinding = getSuperPropBinding(thisEnvFn, isAssignment, key);
	      const args = [];
	      if (superProp.node.computed) {
	        args.push(superProp.get("property").node);
	      }
	      if (isAssignment) {
	        const value = superParentPath.node.right;
	        args.push(value);
	      }
	      const call = callExpression(identifier(superBinding), args);
	      if (isCall) {
	        superParentPath.unshiftContainer("arguments", thisExpression());
	        superProp.replaceWith(memberExpression(call, identifier("call")));
	        thisPaths.push(superParentPath.get("arguments.0"));
	      } else if (isAssignment) {
	        superParentPath.replaceWith(call);
	      } else if (isTaggedTemplate) {
	        superProp.replaceWith(callExpression(memberExpression(call, identifier("bind"), false), [thisExpression()]));
	        thisPaths.push(superProp.get("arguments.0"));
	      } else {
	        superProp.replaceWith(call);
	      }
	    });
	  }
	  let thisBinding;
	  if (thisPaths.length > 0 || !noNewArrows) {
	    thisBinding = getThisBinding(thisEnvFn, inConstructor);
	    if (noNewArrows || inConstructor && hasSuperClass(thisEnvFn)) {
	      thisPaths.forEach(thisChild => {
	        const thisRef = thisChild.isJSX() ? jsxIdentifier(thisBinding) : identifier(thisBinding);
	        thisRef.loc = thisChild.node.loc;
	        thisChild.replaceWith(thisRef);
	      });
	      if (!noNewArrows) thisBinding = null;
	    }
	  }
	  return {
	    thisBinding,
	    fnPath
	  };
	}
	function isLogicalOp(op) {
	  return LOGICAL_OPERATORS.includes(op);
	}
	function standardizeSuperProperty(superProp) {
	  if (superProp.parentPath.isAssignmentExpression() && superProp.parentPath.node.operator !== "=") {
	    const assignmentPath = superProp.parentPath;
	    const op = assignmentPath.node.operator.slice(0, -1);
	    const value = assignmentPath.node.right;
	    const isLogicalAssignment = isLogicalOp(op);
	    if (superProp.node.computed) {
	      const tmp = superProp.scope.generateDeclaredUidIdentifier("tmp");
	      const object = superProp.node.object;
	      const property = superProp.node.property;
	      assignmentPath.get("left").replaceWith(memberExpression(object, assignmentExpression("=", tmp, property), true));
	      assignmentPath.get("right").replaceWith(rightExpression(isLogicalAssignment ? "=" : op, memberExpression(object, identifier(tmp.name), true), value));
	    } else {
	      const object = superProp.node.object;
	      const property = superProp.node.property;
	      assignmentPath.get("left").replaceWith(memberExpression(object, property));
	      assignmentPath.get("right").replaceWith(rightExpression(isLogicalAssignment ? "=" : op, memberExpression(object, identifier(property.name)), value));
	    }
	    if (isLogicalAssignment) {
	      assignmentPath.replaceWith(logicalExpression(op, assignmentPath.node.left, assignmentPath.node.right));
	    } else {
	      assignmentPath.node.operator = "=";
	    }
	    return [assignmentPath.get("left"), assignmentPath.get("right").get("left")];
	  } else if (superProp.parentPath.isUpdateExpression()) {
	    const updateExpr = superProp.parentPath;
	    const tmp = superProp.scope.generateDeclaredUidIdentifier("tmp");
	    const computedKey = superProp.node.computed ? superProp.scope.generateDeclaredUidIdentifier("prop") : null;
	    const parts = [assignmentExpression("=", tmp, memberExpression(superProp.node.object, computedKey ? assignmentExpression("=", computedKey, superProp.node.property) : superProp.node.property, superProp.node.computed)), assignmentExpression("=", memberExpression(superProp.node.object, computedKey ? identifier(computedKey.name) : superProp.node.property, superProp.node.computed), binaryExpression(superProp.parentPath.node.operator[0], identifier(tmp.name), numericLiteral(1)))];
	    if (!superProp.parentPath.node.prefix) {
	      parts.push(identifier(tmp.name));
	    }
	    updateExpr.replaceWith(sequenceExpression(parts));
	    const left = updateExpr.get("expressions.0.right");
	    const right = updateExpr.get("expressions.1.left");
	    return [left, right];
	  }
	  return [superProp];
	  function rightExpression(op, left, right) {
	    if (op === "=") {
	      return assignmentExpression("=", left, right);
	    } else {
	      return binaryExpression(op, left, right);
	    }
	  }
	}
	function hasSuperClass(thisEnvFn) {
	  return thisEnvFn.isClassMethod() && !!thisEnvFn.parentPath.parentPath.node.superClass;
	}
	const assignSuperThisVisitor = (0, _visitors.merge)([{
	  CallExpression(child, {
	    supers,
	    thisBinding
	  }) {
	    if (!child.get("callee").isSuper()) return;
	    if (supers.has(child.node)) return;
	    supers.add(child.node);
	    child.replaceWithMultiple([child.node, assignmentExpression("=", identifier(thisBinding), identifier("this"))]);
	  }
	}, _helperEnvironmentVisitor.default]);
	function getThisBinding(thisEnvFn, inConstructor) {
	  return getBinding(thisEnvFn, "this", thisBinding => {
	    if (!inConstructor || !hasSuperClass(thisEnvFn)) return thisExpression();
	    thisEnvFn.traverse(assignSuperThisVisitor, {
	      supers: new WeakSet(),
	      thisBinding
	    });
	  });
	}
	function getSuperBinding(thisEnvFn) {
	  return getBinding(thisEnvFn, "supercall", () => {
	    const argsBinding = thisEnvFn.scope.generateUidIdentifier("args");
	    return arrowFunctionExpression([restElement(argsBinding)], callExpression(_super(), [spreadElement(identifier(argsBinding.name))]));
	  });
	}
	function getSuperPropBinding(thisEnvFn, isAssignment, propName) {
	  const op = isAssignment ? "set" : "get";
	  return getBinding(thisEnvFn, `superprop_${op}:${propName || ""}`, () => {
	    const argsList = [];
	    let fnBody;
	    if (propName) {
	      fnBody = memberExpression(_super(), identifier(propName));
	    } else {
	      const method = thisEnvFn.scope.generateUidIdentifier("prop");
	      argsList.unshift(method);
	      fnBody = memberExpression(_super(), identifier(method.name), true);
	    }
	    if (isAssignment) {
	      const valueIdent = thisEnvFn.scope.generateUidIdentifier("value");
	      argsList.push(valueIdent);
	      fnBody = assignmentExpression("=", fnBody, identifier(valueIdent.name));
	    }
	    return arrowFunctionExpression(argsList, fnBody);
	  });
	}
	function getBinding(thisEnvFn, key, init) {
	  const cacheKey = "binding:" + key;
	  let data = thisEnvFn.getData(cacheKey);
	  if (!data) {
	    const id = thisEnvFn.scope.generateUidIdentifier(key);
	    data = id.name;
	    thisEnvFn.setData(cacheKey, data);
	    thisEnvFn.scope.push({
	      id: id,
	      init: init(data)
	    });
	  }
	  return data;
	}
	const getScopeInformationVisitor = (0, _visitors.merge)([{
	  ThisExpression(child, {
	    thisPaths
	  }) {
	    thisPaths.push(child);
	  },
	  JSXIdentifier(child, {
	    thisPaths
	  }) {
	    if (child.node.name !== "this") return;
	    if (!child.parentPath.isJSXMemberExpression({
	      object: child.node
	    }) && !child.parentPath.isJSXOpeningElement({
	      name: child.node
	    })) {
	      return;
	    }
	    thisPaths.push(child);
	  },
	  CallExpression(child, {
	    superCalls
	  }) {
	    if (child.get("callee").isSuper()) superCalls.push(child);
	  },
	  MemberExpression(child, {
	    superProps
	  }) {
	    if (child.get("object").isSuper()) superProps.push(child);
	  },
	  Identifier(child, {
	    argumentsPaths
	  }) {
	    if (!child.isReferencedIdentifier({
	      name: "arguments"
	    })) return;
	    let curr = child.scope;
	    do {
	      if (curr.hasOwnBinding("arguments")) {
	        curr.rename("arguments");
	        return;
	      }
	      if (curr.path.isFunction() && !curr.path.isArrowFunctionExpression()) {
	        break;
	      }
	    } while (curr = curr.parent);
	    argumentsPaths.push(child);
	  },
	  MetaProperty(child, {
	    newTargetPaths
	  }) {
	    if (!child.get("meta").isIdentifier({
	      name: "new"
	    })) return;
	    if (!child.get("property").isIdentifier({
	      name: "target"
	    })) return;
	    newTargetPaths.push(child);
	  }
	}, _helperEnvironmentVisitor.default]);
	function getScopeInformation(fnPath) {
	  const thisPaths = [];
	  const argumentsPaths = [];
	  const newTargetPaths = [];
	  const superProps = [];
	  const superCalls = [];
	  fnPath.traverse(getScopeInformationVisitor, {
	    thisPaths,
	    argumentsPaths,
	    newTargetPaths,
	    superProps,
	    superCalls
	  });
	  return {
	    thisPaths,
	    argumentsPaths,
	    newTargetPaths,
	    superProps,
	    superCalls
	  };
	}

	
	return conversion;
}

var introspection = {};

var hasRequiredIntrospection;

function requireIntrospection () {
	if (hasRequiredIntrospection) return introspection;
	hasRequiredIntrospection = 1;

	Object.defineProperty(introspection, "__esModule", {
	  value: true
	});
	introspection._guessExecutionStatusRelativeTo = _guessExecutionStatusRelativeTo;
	introspection._resolve = _resolve;
	introspection.canHaveVariableDeclarationOrExpression = canHaveVariableDeclarationOrExpression;
	introspection.canSwapBetweenExpressionAndStatement = canSwapBetweenExpressionAndStatement;
	introspection.equals = equals;
	introspection.getSource = getSource;
	introspection.has = has;
	introspection.is = void 0;
	introspection.isCompletionRecord = isCompletionRecord;
	introspection.isConstantExpression = isConstantExpression;
	introspection.isInStrictMode = isInStrictMode;
	introspection.isNodeType = isNodeType;
	introspection.isStatementOrBlock = isStatementOrBlock;
	introspection.isStatic = isStatic;
	introspection.isnt = isnt;
	introspection.matchesPattern = matchesPattern;
	introspection.referencesImport = referencesImport;
	introspection.resolve = resolve;
	introspection.willIMaybeExecuteBefore = willIMaybeExecuteBefore;
	var _t = requireLib$h();
	const {
	  STATEMENT_OR_BLOCK_KEYS,
	  VISITOR_KEYS,
	  isBlockStatement,
	  isExpression,
	  isIdentifier,
	  isLiteral,
	  isStringLiteral,
	  isType,
	  matchesPattern: _matchesPattern
	} = _t;
	function matchesPattern(pattern, allowPartial) {
	  return _matchesPattern(this.node, pattern, allowPartial);
	}
	function has(key) {
	  var _this$node;
	  const val = (_this$node = this.node) == null ? void 0 : _this$node[key];
	  if (val && Array.isArray(val)) {
	    return !!val.length;
	  } else {
	    return !!val;
	  }
	}
	function isStatic() {
	  return this.scope.isStatic(this.node);
	}
	introspection.is = has;
	function isnt(key) {
	  return !this.has(key);
	}
	function equals(key, value) {
	  return this.node[key] === value;
	}
	function isNodeType(type) {
	  return isType(this.type, type);
	}
	function canHaveVariableDeclarationOrExpression() {
	  return (this.key === "init" || this.key === "left") && this.parentPath.isFor();
	}
	function canSwapBetweenExpressionAndStatement(replacement) {
	  if (this.key !== "body" || !this.parentPath.isArrowFunctionExpression()) {
	    return false;
	  }
	  if (this.isExpression()) {
	    return isBlockStatement(replacement);
	  } else if (this.isBlockStatement()) {
	    return isExpression(replacement);
	  }
	  return false;
	}
	function isCompletionRecord(allowInsideFunction) {
	  let path = this;
	  let first = true;
	  do {
	    const {
	      type,
	      container
	    } = path;
	    if (!first && (path.isFunction() || type === "StaticBlock")) {
	      return !!allowInsideFunction;
	    }
	    first = false;
	    if (Array.isArray(container) && path.key !== container.length - 1) {
	      return false;
	    }
	  } while ((path = path.parentPath) && !path.isProgram() && !path.isDoExpression());
	  return true;
	}
	function isStatementOrBlock() {
	  if (this.parentPath.isLabeledStatement() || isBlockStatement(this.container)) {
	    return false;
	  } else {
	    return STATEMENT_OR_BLOCK_KEYS.includes(this.key);
	  }
	}
	function referencesImport(moduleSource, importName) {
	  if (!this.isReferencedIdentifier()) {
	    if (this.isJSXMemberExpression() && this.node.property.name === importName || (this.isMemberExpression() || this.isOptionalMemberExpression()) && (this.node.computed ? isStringLiteral(this.node.property, {
	      value: importName
	    }) : this.node.property.name === importName)) {
	      const object = this.get("object");
	      return object.isReferencedIdentifier() && object.referencesImport(moduleSource, "*");
	    }
	    return false;
	  }
	  const binding = this.scope.getBinding(this.node.name);
	  if (!binding || binding.kind !== "module") return false;
	  const path = binding.path;
	  const parent = path.parentPath;
	  if (!parent.isImportDeclaration()) return false;
	  if (parent.node.source.value === moduleSource) {
	    if (!importName) return true;
	  } else {
	    return false;
	  }
	  if (path.isImportDefaultSpecifier() && importName === "default") {
	    return true;
	  }
	  if (path.isImportNamespaceSpecifier() && importName === "*") {
	    return true;
	  }
	  if (path.isImportSpecifier() && isIdentifier(path.node.imported, {
	    name: importName
	  })) {
	    return true;
	  }
	  return false;
	}
	function getSource() {
	  const node = this.node;
	  if (node.end) {
	    const code = this.hub.getCode();
	    if (code) return code.slice(node.start, node.end);
	  }
	  return "";
	}
	function willIMaybeExecuteBefore(target) {
	  return this._guessExecutionStatusRelativeTo(target) !== "after";
	}
	function getOuterFunction(path) {
	  return path.isProgram() ? path : (path.parentPath.scope.getFunctionParent() || path.parentPath.scope.getProgramParent()).path;
	}
	function isExecutionUncertain(type, key) {
	  switch (type) {
	    case "LogicalExpression":
	      return key === "right";
	    case "ConditionalExpression":
	    case "IfStatement":
	      return key === "consequent" || key === "alternate";
	    case "WhileStatement":
	    case "DoWhileStatement":
	    case "ForInStatement":
	    case "ForOfStatement":
	      return key === "body";
	    case "ForStatement":
	      return key === "body" || key === "update";
	    case "SwitchStatement":
	      return key === "cases";
	    case "TryStatement":
	      return key === "handler";
	    case "AssignmentPattern":
	      return key === "right";
	    case "OptionalMemberExpression":
	      return key === "property";
	    case "OptionalCallExpression":
	      return key === "arguments";
	    default:
	      return false;
	  }
	}
	function isExecutionUncertainInList(paths, maxIndex) {
	  for (let i = 0; i < maxIndex; i++) {
	    const path = paths[i];
	    if (isExecutionUncertain(path.parent.type, path.parentKey)) {
	      return true;
	    }
	  }
	  return false;
	}
	const SYMBOL_CHECKING = Symbol();
	function _guessExecutionStatusRelativeTo(target) {
	  return _guessExecutionStatusRelativeToCached(this, target, new Map());
	}
	function _guessExecutionStatusRelativeToCached(base, target, cache) {
	  const funcParent = {
	    this: getOuterFunction(base),
	    target: getOuterFunction(target)
	  };
	  if (funcParent.target.node !== funcParent.this.node) {
	    return _guessExecutionStatusRelativeToDifferentFunctionsCached(base, funcParent.target, cache);
	  }
	  const paths = {
	    target: target.getAncestry(),
	    this: base.getAncestry()
	  };
	  if (paths.target.indexOf(base) >= 0) return "after";
	  if (paths.this.indexOf(target) >= 0) return "before";
	  let commonPath;
	  const commonIndex = {
	    target: 0,
	    this: 0
	  };
	  while (!commonPath && commonIndex.this < paths.this.length) {
	    const path = paths.this[commonIndex.this];
	    commonIndex.target = paths.target.indexOf(path);
	    if (commonIndex.target >= 0) {
	      commonPath = path;
	    } else {
	      commonIndex.this++;
	    }
	  }
	  if (!commonPath) {
	    throw new Error("Internal Babel error - The two compared nodes" + " don't appear to belong to the same program.");
	  }
	  if (isExecutionUncertainInList(paths.this, commonIndex.this - 1) || isExecutionUncertainInList(paths.target, commonIndex.target - 1)) {
	    return "unknown";
	  }
	  const divergence = {
	    this: paths.this[commonIndex.this - 1],
	    target: paths.target[commonIndex.target - 1]
	  };
	  if (divergence.target.listKey && divergence.this.listKey && divergence.target.container === divergence.this.container) {
	    return divergence.target.key > divergence.this.key ? "before" : "after";
	  }
	  const keys = VISITOR_KEYS[commonPath.type];
	  const keyPosition = {
	    this: keys.indexOf(divergence.this.parentKey),
	    target: keys.indexOf(divergence.target.parentKey)
	  };
	  return keyPosition.target > keyPosition.this ? "before" : "after";
	}
	function _guessExecutionStatusRelativeToDifferentFunctionsInternal(base, target, cache) {
	  if (!target.isFunctionDeclaration()) {
	    if (_guessExecutionStatusRelativeToCached(base, target, cache) === "before") {
	      return "before";
	    }
	    return "unknown";
	  } else if (target.parentPath.isExportDeclaration()) {
	    return "unknown";
	  }
	  const binding = target.scope.getBinding(target.node.id.name);
	  if (!binding.references) return "before";
	  const referencePaths = binding.referencePaths;
	  let allStatus;
	  for (const path of referencePaths) {
	    const childOfFunction = !!path.find(path => path.node === target.node);
	    if (childOfFunction) continue;
	    if (path.key !== "callee" || !path.parentPath.isCallExpression()) {
	      return "unknown";
	    }
	    const status = _guessExecutionStatusRelativeToCached(base, path, cache);
	    if (allStatus && allStatus !== status) {
	      return "unknown";
	    } else {
	      allStatus = status;
	    }
	  }
	  return allStatus;
	}
	function _guessExecutionStatusRelativeToDifferentFunctionsCached(base, target, cache) {
	  let nodeMap = cache.get(base.node);
	  let cached;
	  if (!nodeMap) {
	    cache.set(base.node, nodeMap = new Map());
	  } else if (cached = nodeMap.get(target.node)) {
	    if (cached === SYMBOL_CHECKING) {
	      return "unknown";
	    }
	    return cached;
	  }
	  nodeMap.set(target.node, SYMBOL_CHECKING);
	  const result = _guessExecutionStatusRelativeToDifferentFunctionsInternal(base, target, cache);
	  nodeMap.set(target.node, result);
	  return result;
	}
	function resolve(dangerous, resolved) {
	  return this._resolve(dangerous, resolved) || this;
	}
	function _resolve(dangerous, resolved) {
	  if (resolved && resolved.indexOf(this) >= 0) return;
	  resolved = resolved || [];
	  resolved.push(this);
	  if (this.isVariableDeclarator()) {
	    if (this.get("id").isIdentifier()) {
	      return this.get("init").resolve(dangerous, resolved);
	    }
	  } else if (this.isReferencedIdentifier()) {
	    const binding = this.scope.getBinding(this.node.name);
	    if (!binding) return;
	    if (!binding.constant) return;
	    if (binding.kind === "module") return;
	    if (binding.path !== this) {
	      const ret = binding.path.resolve(dangerous, resolved);
	      if (this.find(parent => parent.node === ret.node)) return;
	      return ret;
	    }
	  } else if (this.isTypeCastExpression()) {
	    return this.get("expression").resolve(dangerous, resolved);
	  } else if (dangerous && this.isMemberExpression()) {
	    const targetKey = this.toComputedKey();
	    if (!isLiteral(targetKey)) return;
	    const targetName = targetKey.value;
	    const target = this.get("object").resolve(dangerous, resolved);
	    if (target.isObjectExpression()) {
	      const props = target.get("properties");
	      for (const prop of props) {
	        if (!prop.isProperty()) continue;
	        const key = prop.get("key");
	        let match = prop.isnt("computed") && key.isIdentifier({
	          name: targetName
	        });
	        match = match || key.isLiteral({
	          value: targetName
	        });
	        if (match) return prop.get("value").resolve(dangerous, resolved);
	      }
	    } else if (target.isArrayExpression() && !isNaN(+targetName)) {
	      const elems = target.get("elements");
	      const elem = elems[targetName];
	      if (elem) return elem.resolve(dangerous, resolved);
	    }
	  }
	}
	function isConstantExpression() {
	  if (this.isIdentifier()) {
	    const binding = this.scope.getBinding(this.node.name);
	    if (!binding) return false;
	    return binding.constant;
	  }
	  if (this.isLiteral()) {
	    if (this.isRegExpLiteral()) {
	      return false;
	    }
	    if (this.isTemplateLiteral()) {
	      return this.get("expressions").every(expression => expression.isConstantExpression());
	    }
	    return true;
	  }
	  if (this.isUnaryExpression()) {
	    if (this.node.operator !== "void") {
	      return false;
	    }
	    return this.get("argument").isConstantExpression();
	  }
	  if (this.isBinaryExpression()) {
	    const {
	      operator
	    } = this.node;
	    return operator !== "in" && operator !== "instanceof" && this.get("left").isConstantExpression() && this.get("right").isConstantExpression();
	  }
	  if (this.isMemberExpression()) {
	    return !this.node.computed && this.get("object").isIdentifier({
	      name: "Symbol"
	    }) && !this.scope.hasBinding("Symbol", {
	      noGlobals: true
	    });
	  }
	  if (this.isCallExpression()) {
	    return this.node.arguments.length === 1 && this.get("callee").matchesPattern("Symbol.for") && !this.scope.hasBinding("Symbol", {
	      noGlobals: true
	    }) && this.get("arguments")[0].isStringLiteral();
	  }
	  return false;
	}
	function isInStrictMode() {
	  const start = this.isProgram() ? this : this.parentPath;
	  const strictParent = start.find(path => {
	    if (path.isProgram({
	      sourceType: "module"
	    })) return true;
	    if (path.isClass()) return true;
	    if (path.isArrowFunctionExpression() && !path.get("body").isBlockStatement()) {
	      return false;
	    }
	    let body;
	    if (path.isFunction()) {
	      body = path.node.body;
	    } else if (path.isProgram()) {
	      body = path.node;
	    } else {
	      return false;
	    }
	    for (const directive of body.directives) {
	      if (directive.value.value === "use strict") {
	        return true;
	      }
	    }
	  });
	  return !!strictParent;
	}

	
	return introspection;
}

var context = {};

var hasRequiredContext$1;

function requireContext$1 () {
	if (hasRequiredContext$1) return context;
	hasRequiredContext$1 = 1;

	Object.defineProperty(context, "__esModule", {
	  value: true
	});
	context._call = _call;
	context._getQueueContexts = _getQueueContexts;
	context._resyncKey = _resyncKey;
	context._resyncList = _resyncList;
	context._resyncParent = _resyncParent;
	context._resyncRemoved = _resyncRemoved;
	context.call = call;
	context.isBlacklisted = context.isDenylisted = isDenylisted;
	context.popContext = popContext;
	context.pushContext = pushContext;
	context.requeue = requeue;
	context.resync = resync;
	context.setContext = setContext;
	context.setKey = setKey;
	context.setScope = setScope;
	context.setup = setup;
	context.skip = skip;
	context.skipKey = skipKey;
	context.stop = stop;
	context.visit = visit;
	var _traverseNode = requireTraverseNode();
	var _index = requirePath();
	function call(key) {
	  const opts = this.opts;
	  this.debug(key);
	  if (this.node) {
	    if (this._call(opts[key])) return true;
	  }
	  if (this.node) {
	    var _opts$this$node$type;
	    return this._call((_opts$this$node$type = opts[this.node.type]) == null ? void 0 : _opts$this$node$type[key]);
	  }
	  return false;
	}
	function _call(fns) {
	  if (!fns) return false;
	  for (const fn of fns) {
	    if (!fn) continue;
	    const node = this.node;
	    if (!node) return true;
	    const ret = fn.call(this.state, this, this.state);
	    if (ret && typeof ret === "object" && typeof ret.then === "function") {
	      throw new Error(`You appear to be using a plugin with an async traversal visitor, ` + `which your current version of Babel does not support. ` + `If you're using a published plugin, you may need to upgrade ` + `your @babel/core version.`);
	    }
	    if (ret) {
	      throw new Error(`Unexpected return value from visitor method ${fn}`);
	    }
	    if (this.node !== node) return true;
	    if (this._traverseFlags > 0) return true;
	  }
	  return false;
	}
	function isDenylisted() {
	  var _this$opts$denylist;
	  const denylist = (_this$opts$denylist = this.opts.denylist) != null ? _this$opts$denylist : this.opts.blacklist;
	  return denylist && denylist.indexOf(this.node.type) > -1;
	}
	function restoreContext(path, context) {
	  if (path.context !== context) {
	    path.context = context;
	    path.state = context.state;
	    path.opts = context.opts;
	  }
	}
	function visit() {
	  var _this$opts$shouldSkip, _this$opts;
	  if (!this.node) {
	    return false;
	  }
	  if (this.isDenylisted()) {
	    return false;
	  }
	  if ((_this$opts$shouldSkip = (_this$opts = this.opts).shouldSkip) != null && _this$opts$shouldSkip.call(_this$opts, this)) {
	    return false;
	  }
	  const currentContext = this.context;
	  if (this.shouldSkip || this.call("enter")) {
	    this.debug("Skip...");
	    return this.shouldStop;
	  }
	  restoreContext(this, currentContext);
	  this.debug("Recursing into...");
	  this.shouldStop = (0, _traverseNode.traverseNode)(this.node, this.opts, this.scope, this.state, this, this.skipKeys);
	  restoreContext(this, currentContext);
	  this.call("exit");
	  return this.shouldStop;
	}
	function skip() {
	  this.shouldSkip = true;
	}
	function skipKey(key) {
	  if (this.skipKeys == null) {
	    this.skipKeys = {};
	  }
	  this.skipKeys[key] = true;
	}
	function stop() {
	  this._traverseFlags |= _index.SHOULD_SKIP | _index.SHOULD_STOP;
	}
	function setScope() {
	  var _this$opts2, _this$scope;
	  if ((_this$opts2 = this.opts) != null && _this$opts2.noScope) return;
	  let path = this.parentPath;
	  if ((this.key === "key" || this.listKey === "decorators") && path.isMethod() || this.key === "discriminant" && path.isSwitchStatement()) {
	    path = path.parentPath;
	  }
	  let target;
	  while (path && !target) {
	    var _path$opts;
	    if ((_path$opts = path.opts) != null && _path$opts.noScope) return;
	    target = path.scope;
	    path = path.parentPath;
	  }
	  this.scope = this.getScope(target);
	  (_this$scope = this.scope) == null || _this$scope.init();
	}
	function setContext(context) {
	  if (this.skipKeys != null) {
	    this.skipKeys = {};
	  }
	  this._traverseFlags = 0;
	  if (context) {
	    this.context = context;
	    this.state = context.state;
	    this.opts = context.opts;
	  }
	  this.setScope();
	  return this;
	}
	function resync() {
	  if (this.removed) return;
	  this._resyncParent();
	  this._resyncList();
	  this._resyncKey();
	}
	function _resyncParent() {
	  if (this.parentPath) {
	    this.parent = this.parentPath.node;
	  }
	}
	function _resyncKey() {
	  if (!this.container) return;
	  if (this.node === this.container[this.key]) {
	    return;
	  }
	  if (Array.isArray(this.container)) {
	    for (let i = 0; i < this.container.length; i++) {
	      if (this.container[i] === this.node) {
	        this.setKey(i);
	        return;
	      }
	    }
	  } else {
	    for (const key of Object.keys(this.container)) {
	      if (this.container[key] === this.node) {
	        this.setKey(key);
	        return;
	      }
	    }
	  }
	  this.key = null;
	}
	function _resyncList() {
	  if (!this.parent || !this.inList) return;
	  const newContainer = this.parent[this.listKey];
	  if (this.container === newContainer) return;
	  this.container = newContainer || null;
	}
	function _resyncRemoved() {
	  if (this.key == null || !this.container || this.container[this.key] !== this.node) {
	    this._markRemoved();
	  }
	}
	function popContext() {
	  this.contexts.pop();
	  if (this.contexts.length > 0) {
	    this.setContext(this.contexts[this.contexts.length - 1]);
	  } else {
	    this.setContext(undefined);
	  }
	}
	function pushContext(context) {
	  this.contexts.push(context);
	  this.setContext(context);
	}
	function setup(parentPath, container, listKey, key) {
	  this.listKey = listKey;
	  this.container = container;
	  this.parentPath = parentPath || this.parentPath;
	  this.setKey(key);
	}
	function setKey(key) {
	  var _this$node;
	  this.key = key;
	  this.node = this.container[this.key];
	  this.type = (_this$node = this.node) == null ? void 0 : _this$node.type;
	}
	function requeue(pathToQueue = this) {
	  if (pathToQueue.removed) return;
	  const contexts = this.contexts;
	  for (const context of contexts) {
	    context.maybeQueue(pathToQueue);
	  }
	}
	function _getQueueContexts() {
	  let path = this;
	  let contexts = this.contexts;
	  while (!contexts.length) {
	    path = path.parentPath;
	    if (!path) break;
	    contexts = path.contexts;
	  }
	  return contexts;
	}

	
	return context;
}

var removal = {};

var removalHooks = {};

var hasRequiredRemovalHooks;

function requireRemovalHooks () {
	if (hasRequiredRemovalHooks) return removalHooks;
	hasRequiredRemovalHooks = 1;

	Object.defineProperty(removalHooks, "__esModule", {
	  value: true
	});
	removalHooks.hooks = void 0;
	removalHooks.hooks = [function (self, parent) {
	  const removeParent = self.key === "test" && (parent.isWhile() || parent.isSwitchCase()) || self.key === "declaration" && parent.isExportDeclaration() || self.key === "body" && parent.isLabeledStatement() || self.listKey === "declarations" && parent.isVariableDeclaration() && parent.node.declarations.length === 1 || self.key === "expression" && parent.isExpressionStatement();
	  if (removeParent) {
	    parent.remove();
	    return true;
	  }
	}, function (self, parent) {
	  if (parent.isSequenceExpression() && parent.node.expressions.length === 1) {
	    parent.replaceWith(parent.node.expressions[0]);
	    return true;
	  }
	}, function (self, parent) {
	  if (parent.isBinary()) {
	    if (self.key === "left") {
	      parent.replaceWith(parent.node.right);
	    } else {
	      parent.replaceWith(parent.node.left);
	    }
	    return true;
	  }
	}, function (self, parent) {
	  if (parent.isIfStatement() && self.key === "consequent" || self.key === "body" && (parent.isLoop() || parent.isArrowFunctionExpression())) {
	    self.replaceWith({
	      type: "BlockStatement",
	      body: []
	    });
	    return true;
	  }
	}];

	
	return removalHooks;
}

var hasRequiredRemoval;

function requireRemoval () {
	if (hasRequiredRemoval) return removal;
	hasRequiredRemoval = 1;

	Object.defineProperty(removal, "__esModule", {
	  value: true
	});
	removal._assertUnremoved = _assertUnremoved;
	removal._callRemovalHooks = _callRemovalHooks;
	removal._markRemoved = _markRemoved;
	removal._remove = _remove;
	removal._removeFromScope = _removeFromScope;
	removal.remove = remove;
	var _removalHooks = requireRemovalHooks();
	var _cache = requireCache();
	var _index = requirePath();
	var _t = requireLib$h();
	const {
	  getBindingIdentifiers
	} = _t;
	function remove() {
	  var _this$opts;
	  this._assertUnremoved();
	  this.resync();
	  if (!((_this$opts = this.opts) != null && _this$opts.noScope)) {
	    this._removeFromScope();
	  }
	  if (this._callRemovalHooks()) {
	    this._markRemoved();
	    return;
	  }
	  this.shareCommentsWithSiblings();
	  this._remove();
	  this._markRemoved();
	}
	function _removeFromScope() {
	  const bindings = getBindingIdentifiers(this.node, false, false, true);
	  Object.keys(bindings).forEach(name => this.scope.removeBinding(name));
	}
	function _callRemovalHooks() {
	  if (this.parentPath) {
	    for (const fn of _removalHooks.hooks) {
	      if (fn(this, this.parentPath)) return true;
	    }
	  }
	}
	function _remove() {
	  if (Array.isArray(this.container)) {
	    this.container.splice(this.key, 1);
	    this.updateSiblingKeys(this.key, -1);
	  } else {
	    this._replaceWith(null);
	  }
	}
	function _markRemoved() {
	  this._traverseFlags |= _index.SHOULD_SKIP | _index.REMOVED;
	  if (this.parent) {
	    (0, _cache.getCachedPaths)(this.hub, this.parent).delete(this.node);
	  }
	  this.node = null;
	}
	function _assertUnremoved() {
	  if (this.removed) {
	    throw this.buildCodeFrameError("NodePath has been removed so is read-only.");
	  }
	}

	
	return removal;
}

var modification = {};

var hoister = {};

var hasRequiredHoister;

function requireHoister () {
	if (hasRequiredHoister) return hoister;
	hasRequiredHoister = 1;

	Object.defineProperty(hoister, "__esModule", {
	  value: true
	});
	hoister.default = void 0;
	var _t = requireLib$h();
	var _t2 = _t;
	const {
	  react
	} = _t;
	const {
	  cloneNode,
	  jsxExpressionContainer,
	  variableDeclaration,
	  variableDeclarator
	} = _t2;
	const referenceVisitor = {
	  ReferencedIdentifier(path, state) {
	    if (path.isJSXIdentifier() && react.isCompatTag(path.node.name) && !path.parentPath.isJSXMemberExpression()) {
	      return;
	    }
	    if (path.node.name === "this") {
	      let scope = path.scope;
	      do {
	        if (scope.path.isFunction() && !scope.path.isArrowFunctionExpression()) {
	          break;
	        }
	      } while (scope = scope.parent);
	      if (scope) state.breakOnScopePaths.push(scope.path);
	    }
	    const binding = path.scope.getBinding(path.node.name);
	    if (!binding) return;
	    for (const violation of binding.constantViolations) {
	      if (violation.scope !== binding.path.scope) {
	        state.mutableBinding = true;
	        path.stop();
	        return;
	      }
	    }
	    if (binding !== state.scope.getBinding(path.node.name)) return;
	    state.bindings[path.node.name] = binding;
	  }
	};
	class PathHoister {
	  constructor(path, scope) {
	    this.breakOnScopePaths = void 0;
	    this.bindings = void 0;
	    this.mutableBinding = void 0;
	    this.scopes = void 0;
	    this.scope = void 0;
	    this.path = void 0;
	    this.attachAfter = void 0;
	    this.breakOnScopePaths = [];
	    this.bindings = {};
	    this.mutableBinding = false;
	    this.scopes = [];
	    this.scope = scope;
	    this.path = path;
	    this.attachAfter = false;
	  }
	  isCompatibleScope(scope) {
	    for (const key of Object.keys(this.bindings)) {
	      const binding = this.bindings[key];
	      if (!scope.bindingIdentifierEquals(key, binding.identifier)) {
	        return false;
	      }
	    }
	    return true;
	  }
	  getCompatibleScopes() {
	    let scope = this.path.scope;
	    do {
	      if (this.isCompatibleScope(scope)) {
	        this.scopes.push(scope);
	      } else {
	        break;
	      }
	      if (this.breakOnScopePaths.indexOf(scope.path) >= 0) {
	        break;
	      }
	    } while (scope = scope.parent);
	  }
	  getAttachmentPath() {
	    let path = this._getAttachmentPath();
	    if (!path) return;
	    let targetScope = path.scope;
	    if (targetScope.path === path) {
	      targetScope = path.scope.parent;
	    }
	    if (targetScope.path.isProgram() || targetScope.path.isFunction()) {
	      for (const name of Object.keys(this.bindings)) {
	        if (!targetScope.hasOwnBinding(name)) continue;
	        const binding = this.bindings[name];
	        if (binding.kind === "param" || binding.path.parentKey === "params") {
	          continue;
	        }
	        const bindingParentPath = this.getAttachmentParentForPath(binding.path);
	        if (bindingParentPath.key >= path.key) {
	          this.attachAfter = true;
	          path = binding.path;
	          for (const violationPath of binding.constantViolations) {
	            if (this.getAttachmentParentForPath(violationPath).key > path.key) {
	              path = violationPath;
	            }
	          }
	        }
	      }
	    }
	    return path;
	  }
	  _getAttachmentPath() {
	    const scopes = this.scopes;
	    const scope = scopes.pop();
	    if (!scope) return;
	    if (scope.path.isFunction()) {
	      if (this.hasOwnParamBindings(scope)) {
	        if (this.scope === scope) return;
	        const bodies = scope.path.get("body").get("body");
	        for (let i = 0; i < bodies.length; i++) {
	          if (bodies[i].node._blockHoist) continue;
	          return bodies[i];
	        }
	      } else {
	        return this.getNextScopeAttachmentParent();
	      }
	    } else if (scope.path.isProgram()) {
	      return this.getNextScopeAttachmentParent();
	    }
	  }
	  getNextScopeAttachmentParent() {
	    const scope = this.scopes.pop();
	    if (scope) return this.getAttachmentParentForPath(scope.path);
	  }
	  getAttachmentParentForPath(path) {
	    do {
	      if (!path.parentPath || Array.isArray(path.container) && path.isStatement()) {
	        return path;
	      }
	    } while (path = path.parentPath);
	  }
	  hasOwnParamBindings(scope) {
	    for (const name of Object.keys(this.bindings)) {
	      if (!scope.hasOwnBinding(name)) continue;
	      const binding = this.bindings[name];
	      if (binding.kind === "param" && binding.constant) return true;
	    }
	    return false;
	  }
	  run() {
	    this.path.traverse(referenceVisitor, this);
	    if (this.mutableBinding) return;
	    this.getCompatibleScopes();
	    const attachTo = this.getAttachmentPath();
	    if (!attachTo) return;
	    if (attachTo.getFunctionParent() === this.path.getFunctionParent()) return;
	    let uid = attachTo.scope.generateUidIdentifier("ref");
	    const declarator = variableDeclarator(uid, this.path.node);
	    const insertFn = this.attachAfter ? "insertAfter" : "insertBefore";
	    const [attached] = attachTo[insertFn]([attachTo.isVariableDeclarator() ? declarator : variableDeclaration("var", [declarator])]);
	    const parent = this.path.parentPath;
	    if (parent.isJSXElement() && this.path.container === parent.node.children) {
	      uid = jsxExpressionContainer(uid);
	    }
	    this.path.replaceWith(cloneNode(uid));
	    return attachTo.isVariableDeclarator() ? attached.get("init") : attached.get("declarations.0.init");
	  }
	}
	hoister.default = PathHoister;

	
	return hoister;
}

var hasRequiredModification;

function requireModification () {
	if (hasRequiredModification) return modification;
	hasRequiredModification = 1;

	Object.defineProperty(modification, "__esModule", {
	  value: true
	});
	modification._containerInsert = _containerInsert;
	modification._containerInsertAfter = _containerInsertAfter;
	modification._containerInsertBefore = _containerInsertBefore;
	modification._verifyNodeList = _verifyNodeList;
	modification.hoist = hoist;
	modification.insertAfter = insertAfter;
	modification.insertBefore = insertBefore;
	modification.pushContainer = pushContainer;
	modification.unshiftContainer = unshiftContainer;
	modification.updateSiblingKeys = updateSiblingKeys;
	var _cache = requireCache();
	var _hoister = requireHoister();
	var _index = requirePath();
	var _t = requireLib$h();
	const {
	  arrowFunctionExpression,
	  assertExpression,
	  assignmentExpression,
	  blockStatement,
	  callExpression,
	  cloneNode,
	  expressionStatement,
	  isAssignmentExpression,
	  isCallExpression,
	  isExportNamedDeclaration,
	  isExpression,
	  isIdentifier,
	  isSequenceExpression,
	  isSuper,
	  thisExpression
	} = _t;
	function insertBefore(nodes_) {
	  this._assertUnremoved();
	  const nodes = this._verifyNodeList(nodes_);
	  const {
	    parentPath,
	    parent
	  } = this;
	  if (parentPath.isExpressionStatement() || parentPath.isLabeledStatement() || isExportNamedDeclaration(parent) || parentPath.isExportDefaultDeclaration() && this.isDeclaration()) {
	    return parentPath.insertBefore(nodes);
	  } else if (this.isNodeType("Expression") && !this.isJSXElement() || parentPath.isForStatement() && this.key === "init") {
	    if (this.node) nodes.push(this.node);
	    return this.replaceExpressionWithStatements(nodes);
	  } else if (Array.isArray(this.container)) {
	    return this._containerInsertBefore(nodes);
	  } else if (this.isStatementOrBlock()) {
	    const node = this.node;
	    const shouldInsertCurrentNode = node && (!this.isExpressionStatement() || node.expression != null);
	    this.replaceWith(blockStatement(shouldInsertCurrentNode ? [node] : []));
	    return this.unshiftContainer("body", nodes);
	  } else {
	    throw new Error("We don't know what to do with this node type. " + "We were previously a Statement but we can't fit in here?");
	  }
	}
	function _containerInsert(from, nodes) {
	  this.updateSiblingKeys(from, nodes.length);
	  const paths = [];
	  this.container.splice(from, 0, ...nodes);
	  for (let i = 0; i < nodes.length; i++) {
	    var _this$context;
	    const to = from + i;
	    const path = this.getSibling(to);
	    paths.push(path);
	    if ((_this$context = this.context) != null && _this$context.queue) {
	      path.pushContext(this.context);
	    }
	  }
	  const contexts = this._getQueueContexts();
	  for (const path of paths) {
	    path.setScope();
	    path.debug("Inserted.");
	    for (const context of contexts) {
	      context.maybeQueue(path, true);
	    }
	  }
	  return paths;
	}
	function _containerInsertBefore(nodes) {
	  return this._containerInsert(this.key, nodes);
	}
	function _containerInsertAfter(nodes) {
	  return this._containerInsert(this.key + 1, nodes);
	}
	const last = arr => arr[arr.length - 1];
	function isHiddenInSequenceExpression(path) {
	  return isSequenceExpression(path.parent) && (last(path.parent.expressions) !== path.node || isHiddenInSequenceExpression(path.parentPath));
	}
	function isAlmostConstantAssignment(node, scope) {
	  if (!isAssignmentExpression(node) || !isIdentifier(node.left)) {
	    return false;
	  }
	  const blockScope = scope.getBlockParent();
	  return blockScope.hasOwnBinding(node.left.name) && blockScope.getOwnBinding(node.left.name).constantViolations.length <= 1;
	}
	function insertAfter(nodes_) {
	  this._assertUnremoved();
	  if (this.isSequenceExpression()) {
	    return last(this.get("expressions")).insertAfter(nodes_);
	  }
	  const nodes = this._verifyNodeList(nodes_);
	  const {
	    parentPath,
	    parent
	  } = this;
	  if (parentPath.isExpressionStatement() || parentPath.isLabeledStatement() || isExportNamedDeclaration(parent) || parentPath.isExportDefaultDeclaration() && this.isDeclaration()) {
	    return parentPath.insertAfter(nodes.map(node => {
	      return isExpression(node) ? expressionStatement(node) : node;
	    }));
	  } else if (this.isNodeType("Expression") && !this.isJSXElement() && !parentPath.isJSXElement() || parentPath.isForStatement() && this.key === "init") {
	    const self = this;
	    if (self.node) {
	      const node = self.node;
	      let {
	        scope
	      } = this;
	      if (scope.path.isPattern()) {
	        assertExpression(node);
	        self.replaceWith(callExpression(arrowFunctionExpression([], node), []));
	        self.get("callee.body").insertAfter(nodes);
	        return [self];
	      }
	      if (isHiddenInSequenceExpression(self)) {
	        nodes.unshift(node);
	      } else if (isCallExpression(node) && isSuper(node.callee)) {
	        nodes.unshift(node);
	        nodes.push(thisExpression());
	      } else if (isAlmostConstantAssignment(node, scope)) {
	        nodes.unshift(node);
	        nodes.push(cloneNode(node.left));
	      } else if (scope.isPure(node, true)) {
	        nodes.push(node);
	      } else {
	        if (parentPath.isMethod({
	          computed: true,
	          key: node
	        })) {
	          scope = scope.parent;
	        }
	        const temp = scope.generateDeclaredUidIdentifier();
	        nodes.unshift(expressionStatement(assignmentExpression("=", cloneNode(temp), node)));
	        nodes.push(expressionStatement(cloneNode(temp)));
	      }
	    }
	    return this.replaceExpressionWithStatements(nodes);
	  } else if (Array.isArray(this.container)) {
	    return this._containerInsertAfter(nodes);
	  } else if (this.isStatementOrBlock()) {
	    const node = this.node;
	    const shouldInsertCurrentNode = node && (!this.isExpressionStatement() || node.expression != null);
	    this.replaceWith(blockStatement(shouldInsertCurrentNode ? [node] : []));
	    return this.pushContainer("body", nodes);
	  } else {
	    throw new Error("We don't know what to do with this node type. " + "We were previously a Statement but we can't fit in here?");
	  }
	}
	function updateSiblingKeys(fromIndex, incrementBy) {
	  if (!this.parent) return;
	  const paths = (0, _cache.getCachedPaths)(this.hub, this.parent) || [];
	  for (const [, path] of paths) {
	    if (typeof path.key === "number" && path.key >= fromIndex) {
	      path.key += incrementBy;
	    }
	  }
	}
	function _verifyNodeList(nodes) {
	  if (!nodes) {
	    return [];
	  }
	  if (!Array.isArray(nodes)) {
	    nodes = [nodes];
	  }
	  for (let i = 0; i < nodes.length; i++) {
	    const node = nodes[i];
	    let msg;
	    if (!node) {
	      msg = "has falsy node";
	    } else if (typeof node !== "object") {
	      msg = "contains a non-object node";
	    } else if (!node.type) {
	      msg = "without a type";
	    } else if (node instanceof _index.default) {
	      msg = "has a NodePath when it expected a raw object";
	    }
	    if (msg) {
	      const type = Array.isArray(node) ? "array" : typeof node;
	      throw new Error(`Node list ${msg} with the index of ${i} and type of ${type}`);
	    }
	  }
	  return nodes;
	}
	function unshiftContainer(listKey, nodes) {
	  this._assertUnremoved();
	  nodes = this._verifyNodeList(nodes);
	  const path = _index.default.get({
	    parentPath: this,
	    parent: this.node,
	    container: this.node[listKey],
	    listKey,
	    key: 0
	  }).setContext(this.context);
	  return path._containerInsertBefore(nodes);
	}
	function pushContainer(listKey, nodes) {
	  this._assertUnremoved();
	  const verifiedNodes = this._verifyNodeList(nodes);
	  const container = this.node[listKey];
	  const path = _index.default.get({
	    parentPath: this,
	    parent: this.node,
	    container: container,
	    listKey,
	    key: container.length
	  }).setContext(this.context);
	  return path.replaceWithMultiple(verifiedNodes);
	}
	function hoist(scope = this.scope) {
	  const hoister = new _hoister.default(this, scope);
	  return hoister.run();
	}

	
	return modification;
}

var family = {};

var hasRequiredFamily;

function requireFamily () {
	if (hasRequiredFamily) return family;
	hasRequiredFamily = 1;

	Object.defineProperty(family, "__esModule", {
	  value: true
	});
	family._getKey = _getKey;
	family._getPattern = _getPattern;
	family.get = get;
	family.getAllNextSiblings = getAllNextSiblings;
	family.getAllPrevSiblings = getAllPrevSiblings;
	family.getBindingIdentifierPaths = getBindingIdentifierPaths;
	family.getBindingIdentifiers = getBindingIdentifiers;
	family.getCompletionRecords = getCompletionRecords;
	family.getNextSibling = getNextSibling;
	family.getOpposite = getOpposite;
	family.getOuterBindingIdentifierPaths = getOuterBindingIdentifierPaths;
	family.getOuterBindingIdentifiers = getOuterBindingIdentifiers;
	family.getPrevSibling = getPrevSibling;
	family.getSibling = getSibling;
	var _index = requirePath();
	var _t = requireLib$h();
	const {
	  getBindingIdentifiers: _getBindingIdentifiers,
	  getOuterBindingIdentifiers: _getOuterBindingIdentifiers,
	  numericLiteral,
	  unaryExpression
	} = _t;
	const NORMAL_COMPLETION = 0;
	const BREAK_COMPLETION = 1;
	function NormalCompletion(path) {
	  return {
	    type: NORMAL_COMPLETION,
	    path
	  };
	}
	function BreakCompletion(path) {
	  return {
	    type: BREAK_COMPLETION,
	    path
	  };
	}
	function getOpposite() {
	  if (this.key === "left") {
	    return this.getSibling("right");
	  } else if (this.key === "right") {
	    return this.getSibling("left");
	  }
	  return null;
	}
	function addCompletionRecords(path, records, context) {
	  if (path) {
	    records.push(..._getCompletionRecords(path, context));
	  }
	  return records;
	}
	function completionRecordForSwitch(cases, records, context) {
	  let lastNormalCompletions = [];
	  for (let i = 0; i < cases.length; i++) {
	    const casePath = cases[i];
	    const caseCompletions = _getCompletionRecords(casePath, context);
	    const normalCompletions = [];
	    const breakCompletions = [];
	    for (const c of caseCompletions) {
	      if (c.type === NORMAL_COMPLETION) {
	        normalCompletions.push(c);
	      }
	      if (c.type === BREAK_COMPLETION) {
	        breakCompletions.push(c);
	      }
	    }
	    if (normalCompletions.length) {
	      lastNormalCompletions = normalCompletions;
	    }
	    records.push(...breakCompletions);
	  }
	  records.push(...lastNormalCompletions);
	  return records;
	}
	function normalCompletionToBreak(completions) {
	  completions.forEach(c => {
	    c.type = BREAK_COMPLETION;
	  });
	}
	function replaceBreakStatementInBreakCompletion(completions, reachable) {
	  completions.forEach(c => {
	    if (c.path.isBreakStatement({
	      label: null
	    })) {
	      if (reachable) {
	        c.path.replaceWith(unaryExpression("void", numericLiteral(0)));
	      } else {
	        c.path.remove();
	      }
	    }
	  });
	}
	function getStatementListCompletion(paths, context) {
	  const completions = [];
	  if (context.canHaveBreak) {
	    let lastNormalCompletions = [];
	    for (let i = 0; i < paths.length; i++) {
	      const path = paths[i];
	      const newContext = Object.assign({}, context, {
	        inCaseClause: false
	      });
	      if (path.isBlockStatement() && (context.inCaseClause || context.shouldPopulateBreak)) {
	        newContext.shouldPopulateBreak = true;
	      } else {
	        newContext.shouldPopulateBreak = false;
	      }
	      const statementCompletions = _getCompletionRecords(path, newContext);
	      if (statementCompletions.length > 0 && statementCompletions.every(c => c.type === BREAK_COMPLETION)) {
	        if (lastNormalCompletions.length > 0 && statementCompletions.every(c => c.path.isBreakStatement({
	          label: null
	        }))) {
	          normalCompletionToBreak(lastNormalCompletions);
	          completions.push(...lastNormalCompletions);
	          if (lastNormalCompletions.some(c => c.path.isDeclaration())) {
	            completions.push(...statementCompletions);
	            replaceBreakStatementInBreakCompletion(statementCompletions, true);
	          }
	          replaceBreakStatementInBreakCompletion(statementCompletions, false);
	        } else {
	          completions.push(...statementCompletions);
	          if (!context.shouldPopulateBreak) {
	            replaceBreakStatementInBreakCompletion(statementCompletions, true);
	          }
	        }
	        break;
	      }
	      if (i === paths.length - 1) {
	        completions.push(...statementCompletions);
	      } else {
	        lastNormalCompletions = [];
	        for (let i = 0; i < statementCompletions.length; i++) {
	          const c = statementCompletions[i];
	          if (c.type === BREAK_COMPLETION) {
	            completions.push(c);
	          }
	          if (c.type === NORMAL_COMPLETION) {
	            lastNormalCompletions.push(c);
	          }
	        }
	      }
	    }
	  } else if (paths.length) {
	    for (let i = paths.length - 1; i >= 0; i--) {
	      const pathCompletions = _getCompletionRecords(paths[i], context);
	      if (pathCompletions.length > 1 || pathCompletions.length === 1 && !pathCompletions[0].path.isVariableDeclaration()) {
	        completions.push(...pathCompletions);
	        break;
	      }
	    }
	  }
	  return completions;
	}
	function _getCompletionRecords(path, context) {
	  let records = [];
	  if (path.isIfStatement()) {
	    records = addCompletionRecords(path.get("consequent"), records, context);
	    records = addCompletionRecords(path.get("alternate"), records, context);
	  } else if (path.isDoExpression() || path.isFor() || path.isWhile() || path.isLabeledStatement()) {
	    return addCompletionRecords(path.get("body"), records, context);
	  } else if (path.isProgram() || path.isBlockStatement()) {
	    return getStatementListCompletion(path.get("body"), context);
	  } else if (path.isFunction()) {
	    return _getCompletionRecords(path.get("body"), context);
	  } else if (path.isTryStatement()) {
	    records = addCompletionRecords(path.get("block"), records, context);
	    records = addCompletionRecords(path.get("handler"), records, context);
	  } else if (path.isCatchClause()) {
	    return addCompletionRecords(path.get("body"), records, context);
	  } else if (path.isSwitchStatement()) {
	    return completionRecordForSwitch(path.get("cases"), records, context);
	  } else if (path.isSwitchCase()) {
	    return getStatementListCompletion(path.get("consequent"), {
	      canHaveBreak: true,
	      shouldPopulateBreak: false,
	      inCaseClause: true
	    });
	  } else if (path.isBreakStatement()) {
	    records.push(BreakCompletion(path));
	  } else {
	    records.push(NormalCompletion(path));
	  }
	  return records;
	}
	function getCompletionRecords() {
	  const records = _getCompletionRecords(this, {
	    canHaveBreak: false,
	    shouldPopulateBreak: false,
	    inCaseClause: false
	  });
	  return records.map(r => r.path);
	}
	function getSibling(key) {
	  return _index.default.get({
	    parentPath: this.parentPath,
	    parent: this.parent,
	    container: this.container,
	    listKey: this.listKey,
	    key: key
	  }).setContext(this.context);
	}
	function getPrevSibling() {
	  return this.getSibling(this.key - 1);
	}
	function getNextSibling() {
	  return this.getSibling(this.key + 1);
	}
	function getAllNextSiblings() {
	  let _key = this.key;
	  let sibling = this.getSibling(++_key);
	  const siblings = [];
	  while (sibling.node) {
	    siblings.push(sibling);
	    sibling = this.getSibling(++_key);
	  }
	  return siblings;
	}
	function getAllPrevSiblings() {
	  let _key = this.key;
	  let sibling = this.getSibling(--_key);
	  const siblings = [];
	  while (sibling.node) {
	    siblings.push(sibling);
	    sibling = this.getSibling(--_key);
	  }
	  return siblings;
	}
	function get(key, context = true) {
	  if (context === true) context = this.context;
	  const parts = key.split(".");
	  if (parts.length === 1) {
	    return this._getKey(key, context);
	  } else {
	    return this._getPattern(parts, context);
	  }
	}
	function _getKey(key, context) {
	  const node = this.node;
	  const container = node[key];
	  if (Array.isArray(container)) {
	    return container.map((_, i) => {
	      return _index.default.get({
	        listKey: key,
	        parentPath: this,
	        parent: node,
	        container: container,
	        key: i
	      }).setContext(context);
	    });
	  } else {
	    return _index.default.get({
	      parentPath: this,
	      parent: node,
	      container: node,
	      key: key
	    }).setContext(context);
	  }
	}
	function _getPattern(parts, context) {
	  let path = this;
	  for (const part of parts) {
	    if (part === ".") {
	      path = path.parentPath;
	    } else {
	      if (Array.isArray(path)) {
	        path = path[part];
	      } else {
	        path = path.get(part, context);
	      }
	    }
	  }
	  return path;
	}
	function getBindingIdentifiers(duplicates) {
	  return _getBindingIdentifiers(this.node, duplicates);
	}
	function getOuterBindingIdentifiers(duplicates) {
	  return _getOuterBindingIdentifiers(this.node, duplicates);
	}
	function getBindingIdentifierPaths(duplicates = false, outerOnly = false) {
	  const path = this;
	  const search = [path];
	  const ids = Object.create(null);
	  while (search.length) {
	    const id = search.shift();
	    if (!id) continue;
	    if (!id.node) continue;
	    const keys = _getBindingIdentifiers.keys[id.node.type];
	    if (id.isIdentifier()) {
	      if (duplicates) {
	        const _ids = ids[id.node.name] = ids[id.node.name] || [];
	        _ids.push(id);
	      } else {
	        ids[id.node.name] = id;
	      }
	      continue;
	    }
	    if (id.isExportDeclaration()) {
	      const declaration = id.get("declaration");
	      if (declaration.isDeclaration()) {
	        search.push(declaration);
	      }
	      continue;
	    }
	    if (outerOnly) {
	      if (id.isFunctionDeclaration()) {
	        search.push(id.get("id"));
	        continue;
	      }
	      if (id.isFunctionExpression()) {
	        continue;
	      }
	    }
	    if (keys) {
	      for (let i = 0; i < keys.length; i++) {
	        const key = keys[i];
	        const child = id.get(key);
	        if (Array.isArray(child)) {
	          search.push(...child);
	        } else if (child.node) {
	          search.push(child);
	        }
	      }
	    }
	  }
	  return ids;
	}
	function getOuterBindingIdentifierPaths(duplicates = false) {
	  return this.getBindingIdentifierPaths(duplicates, true);
	}

	
	return family;
}

var comments = {};

var hasRequiredComments;

function requireComments () {
	if (hasRequiredComments) return comments;
	hasRequiredComments = 1;

	Object.defineProperty(comments, "__esModule", {
	  value: true
	});
	comments.addComment = addComment;
	comments.addComments = addComments;
	comments.shareCommentsWithSiblings = shareCommentsWithSiblings;
	var _t = requireLib$h();
	const {
	  addComment: _addComment,
	  addComments: _addComments
	} = _t;
	function shareCommentsWithSiblings() {
	  if (typeof this.key === "string") return;
	  const node = this.node;
	  if (!node) return;
	  const trailing = node.trailingComments;
	  const leading = node.leadingComments;
	  if (!trailing && !leading) return;
	  const prev = this.getSibling(this.key - 1);
	  const next = this.getSibling(this.key + 1);
	  const hasPrev = Boolean(prev.node);
	  const hasNext = Boolean(next.node);
	  if (hasPrev) {
	    if (leading) {
	      prev.addComments("trailing", removeIfExisting(leading, prev.node.trailingComments));
	    }
	    if (trailing && !hasNext) prev.addComments("trailing", trailing);
	  }
	  if (hasNext) {
	    if (trailing) {
	      next.addComments("leading", removeIfExisting(trailing, next.node.leadingComments));
	    }
	    if (leading && !hasPrev) next.addComments("leading", leading);
	  }
	}
	function removeIfExisting(list, toRemove) {
	  if (!(toRemove != null && toRemove.length)) return list;
	  const set = new Set(toRemove);
	  return list.filter(el => {
	    return !set.has(el);
	  });
	}
	function addComment(type, content, line) {
	  _addComment(this.node, type, content, line);
	}
	function addComments(type, comments) {
	  _addComments(this.node, type, comments);
	}

	
	return comments;
}

var hasRequiredPath;

function requirePath () {
	if (hasRequiredPath) return path$6;
	hasRequiredPath = 1;

	Object.defineProperty(path$6, "__esModule", {
	  value: true
	});
	path$6.default = path$6.SHOULD_STOP = path$6.SHOULD_SKIP = path$6.REMOVED = void 0;
	var virtualTypes = requireVirtualTypes();
	var _debug = srcExports;
	var _index = requireLib$7();
	var _index2 = requireScope();
	var _t = requireLib$h();
	var t = _t;
	var cache = requireCache();
	var _generator = requireLib$e();
	var NodePath_ancestry = requireAncestry();
	var NodePath_inference = requireInference();
	var NodePath_replacement = requireReplacement();
	var NodePath_evaluation = requireEvaluation();
	var NodePath_conversion = requireConversion();
	var NodePath_introspection = requireIntrospection();
	var NodePath_context = requireContext$1();
	var NodePath_removal = requireRemoval();
	var NodePath_modification = requireModification();
	var NodePath_family = requireFamily();
	var NodePath_comments = requireComments();
	var NodePath_virtual_types_validator = requireVirtualTypesValidator();
	const {
	  validate
	} = _t;
	const debug = _debug("babel");
	const REMOVED = path$6.REMOVED = 1 << 0;
	const SHOULD_STOP = path$6.SHOULD_STOP = 1 << 1;
	const SHOULD_SKIP = path$6.SHOULD_SKIP = 1 << 2;
	const NodePath_Final = path$6.default = class NodePath {
	  constructor(hub, parent) {
	    this.contexts = [];
	    this.state = null;
	    this.opts = null;
	    this._traverseFlags = 0;
	    this.skipKeys = null;
	    this.parentPath = null;
	    this.container = null;
	    this.listKey = null;
	    this.key = null;
	    this.node = null;
	    this.type = null;
	    this.parent = parent;
	    this.hub = hub;
	    this.data = null;
	    this.context = null;
	    this.scope = null;
	  }
	  static get({
	    hub,
	    parentPath,
	    parent,
	    container,
	    listKey,
	    key
	  }) {
	    if (!hub && parentPath) {
	      hub = parentPath.hub;
	    }
	    if (!parent) {
	      throw new Error("To get a node path the parent needs to exist");
	    }
	    const targetNode = container[key];
	    const paths = cache.getOrCreateCachedPaths(hub, parent);
	    let path = paths.get(targetNode);
	    if (!path) {
	      path = new NodePath(hub, parent);
	      if (targetNode) paths.set(targetNode, path);
	    }
	    path.setup(parentPath, container, listKey, key);
	    return path;
	  }
	  getScope(scope) {
	    return this.isScope() ? new _index2.default(this) : scope;
	  }
	  setData(key, val) {
	    if (this.data == null) {
	      this.data = Object.create(null);
	    }
	    return this.data[key] = val;
	  }
	  getData(key, def) {
	    if (this.data == null) {
	      this.data = Object.create(null);
	    }
	    let val = this.data[key];
	    if (val === undefined && def !== undefined) val = this.data[key] = def;
	    return val;
	  }
	  hasNode() {
	    return this.node != null;
	  }
	  buildCodeFrameError(msg, Error = SyntaxError) {
	    return this.hub.buildError(this.node, msg, Error);
	  }
	  traverse(visitor, state) {
	    (0, _index.default)(this.node, visitor, this.scope, state, this);
	  }
	  set(key, node) {
	    validate(this.node, key, node);
	    this.node[key] = node;
	  }
	  getPathLocation() {
	    const parts = [];
	    let path = this;
	    do {
	      let key = path.key;
	      if (path.inList) key = `${path.listKey}[${key}]`;
	      parts.unshift(key);
	    } while (path = path.parentPath);
	    return parts.join(".");
	  }
	  debug(message) {
	    if (!debug.enabled) return;
	    debug(`${this.getPathLocation()} ${this.type}: ${message}`);
	  }
	  toString() {
	    return (0, _generator.default)(this.node).code;
	  }
	  get inList() {
	    return !!this.listKey;
	  }
	  set inList(inList) {
	    if (!inList) {
	      this.listKey = null;
	    }
	  }
	  get parentKey() {
	    return this.listKey || this.key;
	  }
	  get shouldSkip() {
	    return !!(this._traverseFlags & SHOULD_SKIP);
	  }
	  set shouldSkip(v) {
	    if (v) {
	      this._traverseFlags |= SHOULD_SKIP;
	    } else {
	      this._traverseFlags &= ~SHOULD_SKIP;
	    }
	  }
	  get shouldStop() {
	    return !!(this._traverseFlags & SHOULD_STOP);
	  }
	  set shouldStop(v) {
	    if (v) {
	      this._traverseFlags |= SHOULD_STOP;
	    } else {
	      this._traverseFlags &= ~SHOULD_STOP;
	    }
	  }
	  get removed() {
	    return !!(this._traverseFlags & REMOVED);
	  }
	  set removed(v) {
	    if (v) {
	      this._traverseFlags |= REMOVED;
	    } else {
	      this._traverseFlags &= ~REMOVED;
	    }
	  }
	};
	Object.assign(NodePath_Final.prototype, NodePath_ancestry, NodePath_inference, NodePath_replacement, NodePath_evaluation, NodePath_conversion, NodePath_introspection, NodePath_context, NodePath_removal, NodePath_modification, NodePath_family, NodePath_comments);
	{
	  NodePath_Final.prototype._guessExecutionStatusRelativeToDifferentFunctions = NodePath_introspection._guessExecutionStatusRelativeTo;
	}
	for (const type of t.TYPES) {
	  const typeKey = `is${type}`;
	  const fn = t[typeKey];
	  NodePath_Final.prototype[typeKey] = function (opts) {
	    return fn(this.node, opts);
	  };
	  NodePath_Final.prototype[`assert${type}`] = function (opts) {
	    if (!fn(this.node, opts)) {
	      throw new TypeError(`Expected node path of type ${type}`);
	    }
	  };
	}
	Object.assign(NodePath_Final.prototype, NodePath_virtual_types_validator);
	for (const type of Object.keys(virtualTypes)) {
	  if (type[0] === "_") continue;
	  if (!t.TYPES.includes(type)) t.TYPES.push(type);
	}

	
	return path$6;
}

var hasRequiredContext;

function requireContext () {
	if (hasRequiredContext) return context$1;
	hasRequiredContext = 1;

	Object.defineProperty(context$1, "__esModule", {
	  value: true
	});
	context$1.default = void 0;
	var _index = requirePath();
	var _t = requireLib$h();
	const {
	  VISITOR_KEYS
	} = _t;
	class TraversalContext {
	  constructor(scope, opts, state, parentPath) {
	    this.queue = null;
	    this.priorityQueue = null;
	    this.parentPath = parentPath;
	    this.scope = scope;
	    this.state = state;
	    this.opts = opts;
	  }
	  shouldVisit(node) {
	    const opts = this.opts;
	    if (opts.enter || opts.exit) return true;
	    if (opts[node.type]) return true;
	    const keys = VISITOR_KEYS[node.type];
	    if (!(keys != null && keys.length)) return false;
	    for (const key of keys) {
	      if (node[key]) {
	        return true;
	      }
	    }
	    return false;
	  }
	  create(node, container, key, listKey) {
	    return _index.default.get({
	      parentPath: this.parentPath,
	      parent: node,
	      container,
	      key: key,
	      listKey
	    });
	  }
	  maybeQueue(path, notPriority) {
	    if (this.queue) {
	      if (notPriority) {
	        this.queue.push(path);
	      } else {
	        this.priorityQueue.push(path);
	      }
	    }
	  }
	  visitMultiple(container, parent, listKey) {
	    if (container.length === 0) return false;
	    const queue = [];
	    for (let key = 0; key < container.length; key++) {
	      const node = container[key];
	      if (node && this.shouldVisit(node)) {
	        queue.push(this.create(parent, container, key, listKey));
	      }
	    }
	    return this.visitQueue(queue);
	  }
	  visitSingle(node, key) {
	    if (this.shouldVisit(node[key])) {
	      return this.visitQueue([this.create(node, node, key)]);
	    } else {
	      return false;
	    }
	  }
	  visitQueue(queue) {
	    this.queue = queue;
	    this.priorityQueue = [];
	    const visited = new WeakSet();
	    let stop = false;
	    let visitIndex = 0;
	    for (; visitIndex < queue.length;) {
	      const path = queue[visitIndex];
	      visitIndex++;
	      path.resync();
	      if (path.contexts.length === 0 || path.contexts[path.contexts.length - 1] !== this) {
	        path.pushContext(this);
	      }
	      if (path.key === null) continue;
	      const {
	        node
	      } = path;
	      if (visited.has(node)) continue;
	      if (node) visited.add(node);
	      if (path.visit()) {
	        stop = true;
	        break;
	      }
	      if (this.priorityQueue.length) {
	        stop = this.visitQueue(this.priorityQueue);
	        this.priorityQueue = [];
	        this.queue = queue;
	        if (stop) break;
	      }
	    }
	    for (let i = 0; i < visitIndex; i++) {
	      queue[i].popContext();
	    }
	    this.queue = null;
	    return stop;
	  }
	  visit(node, key) {
	    const nodes = node[key];
	    if (!nodes) return false;
	    if (Array.isArray(nodes)) {
	      return this.visitMultiple(nodes, node, key);
	    } else {
	      return this.visitSingle(node, key);
	    }
	  }
	}
	context$1.default = TraversalContext;

	
	return context$1;
}

var hasRequiredTraverseNode;

function requireTraverseNode () {
	if (hasRequiredTraverseNode) return traverseNode;
	hasRequiredTraverseNode = 1;

	Object.defineProperty(traverseNode, "__esModule", {
	  value: true
	});
	traverseNode.traverseNode = traverseNode$1;
	var _context = requireContext();
	var _t = requireLib$h();
	const {
	  VISITOR_KEYS
	} = _t;
	function traverseNode$1(node, opts, scope, state, path, skipKeys, visitSelf) {
	  const keys = VISITOR_KEYS[node.type];
	  if (!keys) return false;
	  const context = new _context.default(scope, opts, state, path);
	  if (visitSelf) {
	    if (skipKeys != null && skipKeys[path.parentKey]) return false;
	    return context.visitQueue([path]);
	  }
	  for (const key of keys) {
	    if (skipKeys != null && skipKeys[key]) continue;
	    if (context.visit(node, key)) {
	      return true;
	    }
	  }
	  return false;
	}

	
	return traverseNode;
}

var hub = {};

var hasRequiredHub;

function requireHub () {
	if (hasRequiredHub) return hub;
	hasRequiredHub = 1;

	Object.defineProperty(hub, "__esModule", {
	  value: true
	});
	hub.default = void 0;
	class Hub {
	  getCode() {}
	  getScope() {}
	  addHelper() {
	    throw new Error("Helpers are not supported by the default hub.");
	  }
	  buildError(node, msg, Error = TypeError) {
	    return new Error(msg);
	  }
	}
	hub.default = Hub;

	
	return hub;
}

var hasRequiredLib$7;

function requireLib$7 () {
	if (hasRequiredLib$7) return lib$h;
	hasRequiredLib$7 = 1;
	(function (exports) {

		Object.defineProperty(exports, "__esModule", {
		  value: true
		});
		Object.defineProperty(exports, "Hub", {
		  enumerable: true,
		  get: function () {
		    return _hub.default;
		  }
		});
		Object.defineProperty(exports, "NodePath", {
		  enumerable: true,
		  get: function () {
		    return _index.default;
		  }
		});
		Object.defineProperty(exports, "Scope", {
		  enumerable: true,
		  get: function () {
		    return _index2.default;
		  }
		});
		exports.visitors = exports.default = void 0;
		var visitors = requireVisitors();
		exports.visitors = visitors;
		var _t = requireLib$h();
		var cache = requireCache();
		var _traverseNode = requireTraverseNode();
		var _index = requirePath();
		var _index2 = requireScope();
		var _hub = requireHub();
		const {
		  VISITOR_KEYS,
		  removeProperties,
		  traverseFast
		} = _t;
		function traverse(parent, opts = {}, scope, state, parentPath, visitSelf) {
		  if (!parent) return;
		  if (!opts.noScope && !scope) {
		    if (parent.type !== "Program" && parent.type !== "File") {
		      throw new Error("You must pass a scope and parentPath unless traversing a Program/File. " + `Instead of that you tried to traverse a ${parent.type} node without ` + "passing scope and parentPath.");
		    }
		  }
		  if (!parentPath && visitSelf) {
		    throw new Error("visitSelf can only be used when providing a NodePath.");
		  }
		  if (!VISITOR_KEYS[parent.type]) {
		    return;
		  }
		  visitors.explode(opts);
		  (0, _traverseNode.traverseNode)(parent, opts, scope, state, parentPath, null, visitSelf);
		}
		exports.default = traverse;
		traverse.visitors = visitors;
		traverse.verify = visitors.verify;
		traverse.explode = visitors.explode;
		traverse.cheap = function (node, enter) {
		  traverseFast(node, enter);
		  return;
		};
		traverse.node = function (node, opts, scope, state, path, skipKeys) {
		  (0, _traverseNode.traverseNode)(node, opts, scope, state, path, skipKeys);
		};
		traverse.clearNode = function (node, opts) {
		  removeProperties(node, opts);
		};
		traverse.removeProperties = function (tree, opts) {
		  traverseFast(tree, traverse.clearNode, opts);
		  return tree;
		};
		function hasDenylistedType(path, state) {
		  if (path.node.type === state.type) {
		    state.has = true;
		    path.stop();
		  }
		}
		traverse.hasType = function (tree, type, denylistTypes) {
		  if (denylistTypes != null && denylistTypes.includes(tree.type)) return false;
		  if (tree.type === type) return true;
		  const state = {
		    has: false,
		    type: type
		  };
		  traverse(tree, {
		    noScope: true,
		    denylist: denylistTypes,
		    enter: hasDenylistedType
		  }, null, state);
		  return state.has;
		};
		traverse.cache = cache;

		
	} (lib$h));
	return lib$h;
}

var helpers = {};

var helpersGenerated = {};

var hasRequiredHelpersGenerated;

function requireHelpersGenerated () {
	if (hasRequiredHelpersGenerated) return helpersGenerated;
	hasRequiredHelpersGenerated = 1;

	Object.defineProperty(helpersGenerated, "__esModule", {
	  value: true
	});
	helpersGenerated.default = void 0;
	var _template = requireLib$9();
	function helper(minVersion, source) {
	  return Object.freeze({
	    minVersion,
	    ast: () => _template.default.program.ast(source, {
	      preserveComments: true
	    })
	  });
	}
	helpersGenerated.default = Object.freeze({
	  AsyncGenerator: helper("7.0.0-beta.0", 'import OverloadYield from"OverloadYield";export default function AsyncGenerator(e){var r,t;function resume(r,t){try{var n=e[r](t),o=n.value,u=o instanceof OverloadYield;Promise.resolve(u?o.v:o).then((function(t){if(u){var i="return"===r?"return":"next";if(!o.k||t.done)return resume(i,t);t=e[i](t).value}settle(n.done?"return":"normal",t)}),(function(e){resume("throw",e)}))}catch(e){settle("throw",e)}}function settle(e,n){switch(e){case"return":r.resolve({value:n,done:!0});break;case"throw":r.reject(n);break;default:r.resolve({value:n,done:!1})}(r=r.next)?resume(r.key,r.arg):t=null}this._invoke=function(e,n){return new Promise((function(o,u){var i={key:e,arg:n,resolve:o,reject:u,next:null};t?t=t.next=i:(r=t=i,resume(e,n))}))},"function"!=typeof e.return&&(this.return=void 0)}AsyncGenerator.prototype["function"==typeof Symbol&&Symbol.asyncIterator||"@@asyncIterator"]=function(){return this},AsyncGenerator.prototype.next=function(e){return this._invoke("next",e)},AsyncGenerator.prototype.throw=function(e){return this._invoke("throw",e)},AsyncGenerator.prototype.return=function(e){return this._invoke("return",e)};'),
	  OverloadYield: helper("7.18.14", "export default function _OverloadYield(t,e){this.v=t,this.k=e}"),
	  applyDecs: helper("7.17.8", 'import setFunctionName from"setFunctionName";import toPropertyKey from"toPropertyKey";function old_createMetadataMethodsForProperty(e,t,a,r){return{getMetadata:function(o){old_assertNotFinished(r,"getMetadata"),old_assertMetadataKey(o);var i=e[o];if(void 0!==i)if(1===t){var n=i.public;if(void 0!==n)return n[a]}else if(2===t){var l=i.private;if(void 0!==l)return l.get(a)}else if(Object.hasOwnProperty.call(i,"constructor"))return i.constructor},setMetadata:function(o,i){old_assertNotFinished(r,"setMetadata"),old_assertMetadataKey(o);var n=e[o];if(void 0===n&&(n=e[o]={}),1===t){var l=n.public;void 0===l&&(l=n.public={}),l[a]=i}else if(2===t){var s=n.priv;void 0===s&&(s=n.private=new Map),s.set(a,i)}else n.constructor=i}}}function old_convertMetadataMapToFinal(e,t){var a=e[Symbol.metadata||Symbol.for("Symbol.metadata")],r=Object.getOwnPropertySymbols(t);if(0!==r.length){for(var o=0;o<r.length;o++){var i=r[o],n=t[i],l=a?a[i]:null,s=n.public,c=l?l.public:null;s&&c&&Object.setPrototypeOf(s,c);var d=n.private;if(d){var u=Array.from(d.values()),f=l?l.private:null;f&&(u=u.concat(f)),n.private=u}l&&Object.setPrototypeOf(n,l)}a&&Object.setPrototypeOf(t,a),e[Symbol.metadata||Symbol.for("Symbol.metadata")]=t}}function old_createAddInitializerMethod(e,t){return function(a){old_assertNotFinished(t,"addInitializer"),old_assertCallable(a,"An initializer"),e.push(a)}}function old_memberDec(e,t,a,r,o,i,n,l,s){var c;switch(i){case 1:c="accessor";break;case 2:c="method";break;case 3:c="getter";break;case 4:c="setter";break;default:c="field"}var d,u,f={kind:c,name:l?"#"+t:toPropertyKey(t),isStatic:n,isPrivate:l},p={v:!1};if(0!==i&&(f.addInitializer=old_createAddInitializerMethod(o,p)),l){d=2,u=Symbol(t);var v={};0===i?(v.get=a.get,v.set=a.set):2===i?v.get=function(){return a.value}:(1!==i&&3!==i||(v.get=function(){return a.get.call(this)}),1!==i&&4!==i||(v.set=function(e){a.set.call(this,e)})),f.access=v}else d=1,u=t;try{return e(s,Object.assign(f,old_createMetadataMethodsForProperty(r,d,u,p)))}finally{p.v=!0}}function old_assertNotFinished(e,t){if(e.v)throw Error("attempted to call "+t+" after decoration was finished")}function old_assertMetadataKey(e){if("symbol"!=typeof e)throw new TypeError("Metadata keys must be symbols, received: "+e)}function old_assertCallable(e,t){if("function"!=typeof e)throw new TypeError(t+" must be a function")}function old_assertValidReturnValue(e,t){var a=typeof t;if(1===e){if("object"!==a||null===t)throw new TypeError("accessor decorators must return an object with get, set, or init properties or void 0");void 0!==t.get&&old_assertCallable(t.get,"accessor.get"),void 0!==t.set&&old_assertCallable(t.set,"accessor.set"),void 0!==t.init&&old_assertCallable(t.init,"accessor.init"),void 0!==t.initializer&&old_assertCallable(t.initializer,"accessor.initializer")}else if("function"!==a)throw new TypeError((0===e?"field":10===e?"class":"method")+" decorators must return a function or void 0")}function old_getInit(e){var t;return null==(t=e.init)&&(t=e.initializer)&&void 0!==console&&console.warn(".initializer has been renamed to .init as of March 2022"),t}function old_applyMemberDec(e,t,a,r,o,i,n,l,s){var c,d,u,f,p,v,y,h=a[0];if(n?(0===o||1===o?(c={get:a[3],set:a[4]},u="get"):3===o?(c={get:a[3]},u="get"):4===o?(c={set:a[3]},u="set"):c={value:a[3]},0!==o&&(1===o&&setFunctionName(a[4],"#"+r,"set"),setFunctionName(a[3],"#"+r,u))):0!==o&&(c=Object.getOwnPropertyDescriptor(t,r)),1===o?f={get:c.get,set:c.set}:2===o?f=c.value:3===o?f=c.get:4===o&&(f=c.set),"function"==typeof h)void 0!==(p=old_memberDec(h,r,c,l,s,o,i,n,f))&&(old_assertValidReturnValue(o,p),0===o?d=p:1===o?(d=old_getInit(p),v=p.get||f.get,y=p.set||f.set,f={get:v,set:y}):f=p);else for(var m=h.length-1;m>=0;m--){var b;void 0!==(p=old_memberDec(h[m],r,c,l,s,o,i,n,f))&&(old_assertValidReturnValue(o,p),0===o?b=p:1===o?(b=old_getInit(p),v=p.get||f.get,y=p.set||f.set,f={get:v,set:y}):f=p,void 0!==b&&(void 0===d?d=b:"function"==typeof d?d=[d,b]:d.push(b)))}if(0===o||1===o){if(void 0===d)d=function(e,t){return t};else if("function"!=typeof d){var g=d;d=function(e,t){for(var a=t,r=0;r<g.length;r++)a=g[r].call(e,a);return a}}else{var _=d;d=function(e,t){return _.call(e,t)}}e.push(d)}0!==o&&(1===o?(c.get=f.get,c.set=f.set):2===o?c.value=f:3===o?c.get=f:4===o&&(c.set=f),n?1===o?(e.push((function(e,t){return f.get.call(e,t)})),e.push((function(e,t){return f.set.call(e,t)}))):2===o?e.push(f):e.push((function(e,t){return f.call(e,t)})):Object.defineProperty(t,r,c))}function old_applyMemberDecs(e,t,a,r,o){for(var i,n,l=new Map,s=new Map,c=0;c<o.length;c++){var d=o[c];if(Array.isArray(d)){var u,f,p,v=d[1],y=d[2],h=d.length>3,m=v>=5;if(m?(u=t,f=r,0!=(v-=5)&&(p=n=n||[])):(u=t.prototype,f=a,0!==v&&(p=i=i||[])),0!==v&&!h){var b=m?s:l,g=b.get(y)||0;if(!0===g||3===g&&4!==v||4===g&&3!==v)throw Error("Attempted to decorate a public method/accessor that has the same name as a previously decorated public method/accessor. This is not currently supported by the decorators plugin. Property name was: "+y);!g&&v>2?b.set(y,v):b.set(y,!0)}old_applyMemberDec(e,u,d,y,v,m,h,f,p)}}old_pushInitializers(e,i),old_pushInitializers(e,n)}function old_pushInitializers(e,t){t&&e.push((function(e){for(var a=0;a<t.length;a++)t[a].call(e);return e}))}function old_applyClassDecs(e,t,a,r){if(r.length>0){for(var o=[],i=t,n=t.name,l=r.length-1;l>=0;l--){var s={v:!1};try{var c=Object.assign({kind:"class",name:n,addInitializer:old_createAddInitializerMethod(o,s)},old_createMetadataMethodsForProperty(a,0,n,s)),d=r[l](i,c)}finally{s.v=!0}void 0!==d&&(old_assertValidReturnValue(10,d),i=d)}e.push(i,(function(){for(var e=0;e<o.length;e++)o[e].call(i)}))}}export default function applyDecs(e,t,a){var r=[],o={},i={};return old_applyMemberDecs(r,e,i,o,t),old_convertMetadataMapToFinal(e.prototype,i),old_applyClassDecs(r,e,o,a),old_convertMetadataMapToFinal(e,o),r}'),
	  applyDecs2203: helper("7.19.0", 'function applyDecs2203Factory(){function createAddInitializerMethod(e,t){return function(r){!function(e,t){if(e.v)throw Error("attempted to call addInitializer after decoration was finished")}(t),assertCallable(r,"An initializer"),e.push(r)}}function memberDec(e,t,r,a,n,i,s,o){var c;switch(n){case 1:c="accessor";break;case 2:c="method";break;case 3:c="getter";break;case 4:c="setter";break;default:c="field"}var l,u,f={kind:c,name:s?"#"+t:t,static:i,private:s},p={v:!1};0!==n&&(f.addInitializer=createAddInitializerMethod(a,p)),0===n?s?(l=r.get,u=r.set):(l=function(){return this[t]},u=function(e){this[t]=e}):2===n?l=function(){return r.value}:(1!==n&&3!==n||(l=function(){return r.get.call(this)}),1!==n&&4!==n||(u=function(e){r.set.call(this,e)})),f.access=l&&u?{get:l,set:u}:l?{get:l}:{set:u};try{return e(o,f)}finally{p.v=!0}}function assertCallable(e,t){if("function"!=typeof e)throw new TypeError(t+" must be a function")}function assertValidReturnValue(e,t){var r=typeof t;if(1===e){if("object"!==r||null===t)throw new TypeError("accessor decorators must return an object with get, set, or init properties or void 0");void 0!==t.get&&assertCallable(t.get,"accessor.get"),void 0!==t.set&&assertCallable(t.set,"accessor.set"),void 0!==t.init&&assertCallable(t.init,"accessor.init")}else if("function"!==r)throw new TypeError((0===e?"field":10===e?"class":"method")+" decorators must return a function or void 0")}function applyMemberDec(e,t,r,a,n,i,s,o){var c,l,u,f,p,d,h=r[0];if(s?c=0===n||1===n?{get:r[3],set:r[4]}:3===n?{get:r[3]}:4===n?{set:r[3]}:{value:r[3]}:0!==n&&(c=Object.getOwnPropertyDescriptor(t,a)),1===n?u={get:c.get,set:c.set}:2===n?u=c.value:3===n?u=c.get:4===n&&(u=c.set),"function"==typeof h)void 0!==(f=memberDec(h,a,c,o,n,i,s,u))&&(assertValidReturnValue(n,f),0===n?l=f:1===n?(l=f.init,p=f.get||u.get,d=f.set||u.set,u={get:p,set:d}):u=f);else for(var v=h.length-1;v>=0;v--){var g;void 0!==(f=memberDec(h[v],a,c,o,n,i,s,u))&&(assertValidReturnValue(n,f),0===n?g=f:1===n?(g=f.init,p=f.get||u.get,d=f.set||u.set,u={get:p,set:d}):u=f,void 0!==g&&(void 0===l?l=g:"function"==typeof l?l=[l,g]:l.push(g)))}if(0===n||1===n){if(void 0===l)l=function(e,t){return t};else if("function"!=typeof l){var y=l;l=function(e,t){for(var r=t,a=0;a<y.length;a++)r=y[a].call(e,r);return r}}else{var m=l;l=function(e,t){return m.call(e,t)}}e.push(l)}0!==n&&(1===n?(c.get=u.get,c.set=u.set):2===n?c.value=u:3===n?c.get=u:4===n&&(c.set=u),s?1===n?(e.push((function(e,t){return u.get.call(e,t)})),e.push((function(e,t){return u.set.call(e,t)}))):2===n?e.push(u):e.push((function(e,t){return u.call(e,t)})):Object.defineProperty(t,a,c))}function pushInitializers(e,t){t&&e.push((function(e){for(var r=0;r<t.length;r++)t[r].call(e);return e}))}return function(e,t,r){var a=[];return function(e,t,r){for(var a,n,i=new Map,s=new Map,o=0;o<r.length;o++){var c=r[o];if(Array.isArray(c)){var l,u,f=c[1],p=c[2],d=c.length>3,h=f>=5;if(h?(l=t,0!=(f-=5)&&(u=n=n||[])):(l=t.prototype,0!==f&&(u=a=a||[])),0!==f&&!d){var v=h?s:i,g=v.get(p)||0;if(!0===g||3===g&&4!==f||4===g&&3!==f)throw Error("Attempted to decorate a public method/accessor that has the same name as a previously decorated public method/accessor. This is not currently supported by the decorators plugin. Property name was: "+p);!g&&f>2?v.set(p,f):v.set(p,!0)}applyMemberDec(e,l,c,p,f,h,d,u)}}pushInitializers(e,a),pushInitializers(e,n)}(a,e,t),function(e,t,r){if(r.length>0){for(var a=[],n=t,i=t.name,s=r.length-1;s>=0;s--){var o={v:!1};try{var c=r[s](n,{kind:"class",name:i,addInitializer:createAddInitializerMethod(a,o)})}finally{o.v=!0}void 0!==c&&(assertValidReturnValue(10,c),n=c)}e.push(n,(function(){for(var e=0;e<a.length;e++)a[e].call(n)}))}}(a,e,r),a}}var applyDecs2203Impl;export default function applyDecs2203(e,t,r){return(applyDecs2203Impl=applyDecs2203Impl||applyDecs2203Factory())(e,t,r)}'),
	  applyDecs2203R: helper("7.20.0", 'import setFunctionName from"setFunctionName";import toPropertyKey from"toPropertyKey";function applyDecs2203RFactory(){function createAddInitializerMethod(e,t){return function(r){!function(e,t){if(e.v)throw Error("attempted to call addInitializer after decoration was finished")}(t),assertCallable(r,"An initializer"),e.push(r)}}function memberDec(e,t,r,n,a,i,o,s){var c;switch(a){case 1:c="accessor";break;case 2:c="method";break;case 3:c="getter";break;case 4:c="setter";break;default:c="field"}var l,u,f={kind:c,name:o?"#"+t:toPropertyKey(t),static:i,private:o},p={v:!1};0!==a&&(f.addInitializer=createAddInitializerMethod(n,p)),0===a?o?(l=r.get,u=r.set):(l=function(){return this[t]},u=function(e){this[t]=e}):2===a?l=function(){return r.value}:(1!==a&&3!==a||(l=function(){return r.get.call(this)}),1!==a&&4!==a||(u=function(e){r.set.call(this,e)})),f.access=l&&u?{get:l,set:u}:l?{get:l}:{set:u};try{return e(s,f)}finally{p.v=!0}}function assertCallable(e,t){if("function"!=typeof e)throw new TypeError(t+" must be a function")}function assertValidReturnValue(e,t){var r=typeof t;if(1===e){if("object"!==r||null===t)throw new TypeError("accessor decorators must return an object with get, set, or init properties or void 0");void 0!==t.get&&assertCallable(t.get,"accessor.get"),void 0!==t.set&&assertCallable(t.set,"accessor.set"),void 0!==t.init&&assertCallable(t.init,"accessor.init")}else if("function"!==r)throw new TypeError((0===e?"field":10===e?"class":"method")+" decorators must return a function or void 0")}function applyMemberDec(e,t,r,n,a,i,o,s){var c,l,u,f,p,d,h,v=r[0];if(o?(0===a||1===a?(c={get:r[3],set:r[4]},u="get"):3===a?(c={get:r[3]},u="get"):4===a?(c={set:r[3]},u="set"):c={value:r[3]},0!==a&&(1===a&&setFunctionName(r[4],"#"+n,"set"),setFunctionName(r[3],"#"+n,u))):0!==a&&(c=Object.getOwnPropertyDescriptor(t,n)),1===a?f={get:c.get,set:c.set}:2===a?f=c.value:3===a?f=c.get:4===a&&(f=c.set),"function"==typeof v)void 0!==(p=memberDec(v,n,c,s,a,i,o,f))&&(assertValidReturnValue(a,p),0===a?l=p:1===a?(l=p.init,d=p.get||f.get,h=p.set||f.set,f={get:d,set:h}):f=p);else for(var g=v.length-1;g>=0;g--){var y;void 0!==(p=memberDec(v[g],n,c,s,a,i,o,f))&&(assertValidReturnValue(a,p),0===a?y=p:1===a?(y=p.init,d=p.get||f.get,h=p.set||f.set,f={get:d,set:h}):f=p,void 0!==y&&(void 0===l?l=y:"function"==typeof l?l=[l,y]:l.push(y)))}if(0===a||1===a){if(void 0===l)l=function(e,t){return t};else if("function"!=typeof l){var m=l;l=function(e,t){for(var r=t,n=0;n<m.length;n++)r=m[n].call(e,r);return r}}else{var b=l;l=function(e,t){return b.call(e,t)}}e.push(l)}0!==a&&(1===a?(c.get=f.get,c.set=f.set):2===a?c.value=f:3===a?c.get=f:4===a&&(c.set=f),o?1===a?(e.push((function(e,t){return f.get.call(e,t)})),e.push((function(e,t){return f.set.call(e,t)}))):2===a?e.push(f):e.push((function(e,t){return f.call(e,t)})):Object.defineProperty(t,n,c))}function applyMemberDecs(e,t){for(var r,n,a=[],i=new Map,o=new Map,s=0;s<t.length;s++){var c=t[s];if(Array.isArray(c)){var l,u,f=c[1],p=c[2],d=c.length>3,h=f>=5;if(h?(l=e,0!=(f-=5)&&(u=n=n||[])):(l=e.prototype,0!==f&&(u=r=r||[])),0!==f&&!d){var v=h?o:i,g=v.get(p)||0;if(!0===g||3===g&&4!==f||4===g&&3!==f)throw Error("Attempted to decorate a public method/accessor that has the same name as a previously decorated public method/accessor. This is not currently supported by the decorators plugin. Property name was: "+p);!g&&f>2?v.set(p,f):v.set(p,!0)}applyMemberDec(a,l,c,p,f,h,d,u)}}return pushInitializers(a,r),pushInitializers(a,n),a}function pushInitializers(e,t){t&&e.push((function(e){for(var r=0;r<t.length;r++)t[r].call(e);return e}))}return function(e,t,r){return{e:applyMemberDecs(e,t),get c(){return function(e,t){if(t.length>0){for(var r=[],n=e,a=e.name,i=t.length-1;i>=0;i--){var o={v:!1};try{var s=t[i](n,{kind:"class",name:a,addInitializer:createAddInitializerMethod(r,o)})}finally{o.v=!0}void 0!==s&&(assertValidReturnValue(10,s),n=s)}return[n,function(){for(var e=0;e<r.length;e++)r[e].call(n)}]}}(e,r)}}}}export default function applyDecs2203R(e,t,r){return(applyDecs2203R=applyDecs2203RFactory())(e,t,r)}'),
	  applyDecs2301: helper("7.21.0", 'import checkInRHS from"checkInRHS";import setFunctionName from"setFunctionName";import toPropertyKey from"toPropertyKey";function applyDecs2301Factory(){function createAddInitializerMethod(e,t){return function(r){!function(e,t){if(e.v)throw Error("attempted to call addInitializer after decoration was finished")}(t),assertCallable(r,"An initializer"),e.push(r)}}function assertInstanceIfPrivate(e,t){if(!e(t))throw new TypeError("Attempted to access private element on non-instance")}function memberDec(e,t,r,n,a,i,s,o,c){var u;switch(a){case 1:u="accessor";break;case 2:u="method";break;case 3:u="getter";break;case 4:u="setter";break;default:u="field"}var l,f,p={kind:u,name:s?"#"+t:toPropertyKey(t),static:i,private:s},d={v:!1};if(0!==a&&(p.addInitializer=createAddInitializerMethod(n,d)),s||0!==a&&2!==a)if(2===a)l=function(e){return assertInstanceIfPrivate(c,e),r.value};else{var h=0===a||1===a;(h||3===a)&&(l=s?function(e){return assertInstanceIfPrivate(c,e),r.get.call(e)}:function(e){return r.get.call(e)}),(h||4===a)&&(f=s?function(e,t){assertInstanceIfPrivate(c,e),r.set.call(e,t)}:function(e,t){r.set.call(e,t)})}else l=function(e){return e[t]},0===a&&(f=function(e,r){e[t]=r});var v=s?c.bind():function(e){return t in e};p.access=l&&f?{get:l,set:f,has:v}:l?{get:l,has:v}:{set:f,has:v};try{return e(o,p)}finally{d.v=!0}}function assertCallable(e,t){if("function"!=typeof e)throw new TypeError(t+" must be a function")}function assertValidReturnValue(e,t){var r=typeof t;if(1===e){if("object"!==r||null===t)throw new TypeError("accessor decorators must return an object with get, set, or init properties or void 0");void 0!==t.get&&assertCallable(t.get,"accessor.get"),void 0!==t.set&&assertCallable(t.set,"accessor.set"),void 0!==t.init&&assertCallable(t.init,"accessor.init")}else if("function"!==r)throw new TypeError((0===e?"field":10===e?"class":"method")+" decorators must return a function or void 0")}function curryThis2(e){return function(t){e(this,t)}}function applyMemberDec(e,t,r,n,a,i,s,o,c){var u,l,f,p,d,h,v,y,g=r[0];if(s?(0===a||1===a?(u={get:(d=r[3],function(){return d(this)}),set:curryThis2(r[4])},f="get"):3===a?(u={get:r[3]},f="get"):4===a?(u={set:r[3]},f="set"):u={value:r[3]},0!==a&&(1===a&&setFunctionName(u.set,"#"+n,"set"),setFunctionName(u[f||"value"],"#"+n,f))):0!==a&&(u=Object.getOwnPropertyDescriptor(t,n)),1===a?p={get:u.get,set:u.set}:2===a?p=u.value:3===a?p=u.get:4===a&&(p=u.set),"function"==typeof g)void 0!==(h=memberDec(g,n,u,o,a,i,s,p,c))&&(assertValidReturnValue(a,h),0===a?l=h:1===a?(l=h.init,v=h.get||p.get,y=h.set||p.set,p={get:v,set:y}):p=h);else for(var m=g.length-1;m>=0;m--){var b;void 0!==(h=memberDec(g[m],n,u,o,a,i,s,p,c))&&(assertValidReturnValue(a,h),0===a?b=h:1===a?(b=h.init,v=h.get||p.get,y=h.set||p.set,p={get:v,set:y}):p=h,void 0!==b&&(void 0===l?l=b:"function"==typeof l?l=[l,b]:l.push(b)))}if(0===a||1===a){if(void 0===l)l=function(e,t){return t};else if("function"!=typeof l){var I=l;l=function(e,t){for(var r=t,n=0;n<I.length;n++)r=I[n].call(e,r);return r}}else{var w=l;l=function(e,t){return w.call(e,t)}}e.push(l)}0!==a&&(1===a?(u.get=p.get,u.set=p.set):2===a?u.value=p:3===a?u.get=p:4===a&&(u.set=p),s?1===a?(e.push((function(e,t){return p.get.call(e,t)})),e.push((function(e,t){return p.set.call(e,t)}))):2===a?e.push(p):e.push((function(e,t){return p.call(e,t)})):Object.defineProperty(t,n,u))}function applyMemberDecs(e,t,r){for(var n,a,i,s=[],o=new Map,c=new Map,u=0;u<t.length;u++){var l=t[u];if(Array.isArray(l)){var f,p,d=l[1],h=l[2],v=l.length>3,y=d>=5,g=r;if(y?(f=e,0!=(d-=5)&&(p=a=a||[]),v&&!i&&(i=function(t){return checkInRHS(t)===e}),g=i):(f=e.prototype,0!==d&&(p=n=n||[])),0!==d&&!v){var m=y?c:o,b=m.get(h)||0;if(!0===b||3===b&&4!==d||4===b&&3!==d)throw Error("Attempted to decorate a public method/accessor that has the same name as a previously decorated public method/accessor. This is not currently supported by the decorators plugin. Property name was: "+h);!b&&d>2?m.set(h,d):m.set(h,!0)}applyMemberDec(s,f,l,h,d,y,v,p,g)}}return pushInitializers(s,n),pushInitializers(s,a),s}function pushInitializers(e,t){t&&e.push((function(e){for(var r=0;r<t.length;r++)t[r].call(e);return e}))}return function(e,t,r,n){return{e:applyMemberDecs(e,t,n),get c(){return function(e,t){if(t.length>0){for(var r=[],n=e,a=e.name,i=t.length-1;i>=0;i--){var s={v:!1};try{var o=t[i](n,{kind:"class",name:a,addInitializer:createAddInitializerMethod(r,s)})}finally{s.v=!0}void 0!==o&&(assertValidReturnValue(10,o),n=o)}return[n,function(){for(var e=0;e<r.length;e++)r[e].call(n)}]}}(e,r)}}}}export default function applyDecs2301(e,t,r,n){return(applyDecs2301=applyDecs2301Factory())(e,t,r,n)}'),
	  applyDecs2305: helper("7.21.0", 'import checkInRHS from"checkInRHS";import setFunctionName from"setFunctionName";import toPropertyKey from"toPropertyKey";export default function applyDecs2305(e,t,r,n,o,a){function i(e,t,r){return function(n,o){return r&&r(n),e[t].call(n,o)}}function c(e,t){for(var r=0;r<e.length;r++)e[r].call(t);return t}function s(e,t,r,n){if("function"!=typeof e&&(n||void 0!==e))throw new TypeError(t+" must "+(r||"be")+" a function"+(n?"":" or undefined"));return e}function applyDec(e,t,r,n,o,a,c,u,l,f,p,d,h){function m(e){if(!h(e))throw new TypeError("Attempted to access private element on non-instance")}var y,v=t[0],g=t[3],b=!u;if(!b){r||Array.isArray(v)||(v=[v]);var w={},S=[],A=3===o?"get":4===o||d?"set":"value";f?(p||d?w={get:setFunctionName((function(){return g(this)}),n,"get"),set:function(e){t[4](this,e)}}:w[A]=g,p||setFunctionName(w[A],n,2===o?"":A)):p||(w=Object.getOwnPropertyDescriptor(e,n))}for(var P=e,j=v.length-1;j>=0;j-=r?2:1){var D=v[j],E=r?v[j-1]:void 0,I={},O={kind:["field","accessor","method","getter","setter","class"][o],name:n,metadata:a,addInitializer:function(e,t){if(e.v)throw Error("attempted to call addInitializer after decoration was finished");s(t,"An initializer","be",!0),c.push(t)}.bind(null,I)};try{if(b)(y=s(D.call(E,P,O),"class decorators","return"))&&(P=y);else{var k,F;O.static=l,O.private=f,f?2===o?k=function(e){return m(e),w.value}:(o<4&&(k=i(w,"get",m)),3!==o&&(F=i(w,"set",m))):(k=function(e){return e[n]},(o<2||4===o)&&(F=function(e,t){e[n]=t}));var N=O.access={has:f?h.bind():function(e){return n in e}};if(k&&(N.get=k),F&&(N.set=F),P=D.call(E,d?{get:w.get,set:w.set}:w[A],O),d){if("object"==typeof P&&P)(y=s(P.get,"accessor.get"))&&(w.get=y),(y=s(P.set,"accessor.set"))&&(w.set=y),(y=s(P.init,"accessor.init"))&&S.push(y);else if(void 0!==P)throw new TypeError("accessor decorators must return an object with get, set, or init properties or void 0")}else s(P,(p?"field":"method")+" decorators","return")&&(p?S.push(P):w[A]=P)}}finally{I.v=!0}}return(p||d)&&u.push((function(e,t){for(var r=S.length-1;r>=0;r--)t=S[r].call(e,t);return t})),p||b||(f?d?u.push(i(w,"get"),i(w,"set")):u.push(2===o?w[A]:i.call.bind(w[A])):Object.defineProperty(e,n,w)),P}function u(e,t){return Object.defineProperty(e,Symbol.metadata||Symbol.for("Symbol.metadata"),{configurable:!0,enumerable:!0,value:t})}if(arguments.length>=6)var l=a[Symbol.metadata||Symbol.for("Symbol.metadata")];var f=Object.create(null==l?null:l),p=function(e,t,r,n){var o,a,i=[],s=function(t){return checkInRHS(t)===e},u=new Map;function l(e){e&&i.push(c.bind(null,e))}for(var f=0;f<t.length;f++){var p=t[f];if(Array.isArray(p)){var d=p[1],h=p[2],m=p.length>3,y=16&d,v=!!(8&d),g=0==(d&=7),b=h+"/"+v;if(!g&&!m){var w=u.get(b);if(!0===w||3===w&&4!==d||4===w&&3!==d)throw Error("Attempted to decorate a public method/accessor that has the same name as a previously decorated public method/accessor. This is not currently supported by the decorators plugin. Property name was: "+h);u.set(b,!(d>2)||d)}applyDec(v?e:e.prototype,p,y,m?"#"+h:toPropertyKey(h),d,n,v?a=a||[]:o=o||[],i,v,m,g,1===d,v&&m?s:r)}}return l(o),l(a),i}(e,t,o,f);return r.length||u(e,f),{e:p,get c(){var t=[];return r.length&&[u(applyDec(e,[r],n,e.name,5,f,t),f),c.bind(null,t,e)]}}}'),
	  applyDecs2311: helper("7.24.0", 'import checkInRHS from"checkInRHS";import setFunctionName from"setFunctionName";import toPropertyKey from"toPropertyKey";export default function applyDecs2311(e,t,n,r,o,i){var a,c,u,s,f,l,p,d=Symbol.metadata||Symbol.for("Symbol.metadata"),m=Object.defineProperty,h=Object.create,y=[h(null),h(null)],v=t.length;function g(t,n,r){return function(o,i){n&&(i=o,o=e);for(var a=0;a<t.length;a++)i=t[a].apply(o,r?[i]:[]);return r?i:o}}function b(e,t,n,r){if("function"!=typeof e&&(r||void 0!==e))throw new TypeError(t+" must "+(n||"be")+" a function"+(r?"":" or undefined"));return e}function applyDec(e,t,n,r,o,i,u,s,f,l,p){function d(e){if(!p(e))throw new TypeError("Attempted to access private element on non-instance")}var h=[].concat(t[0]),v=t[3],w=!u,D=1===o,S=3===o,j=4===o,E=2===o;function I(t,n,r){return function(o,i){return n&&(i=o,o=e),r&&r(o),P[t].call(o,i)}}if(!w){var P={},k=[],F=S?"get":j||D?"set":"value";if(f?(l||D?P={get:setFunctionName((function(){return v(this)}),r,"get"),set:function(e){t[4](this,e)}}:P[F]=v,l||setFunctionName(P[F],r,E?"":F)):l||(P=Object.getOwnPropertyDescriptor(e,r)),!l&&!f){if((c=y[+s][r])&&7!=(c^o))throw Error("Decorating two elements with the same name ("+P[F].name+") is not supported yet");y[+s][r]=o<3?1:o}}for(var N=e,O=h.length-1;O>=0;O-=n?2:1){var z=b(h[O],"A decorator","be",!0),A=n?h[O-1]:void 0,H={},K={kind:["field","accessor","method","getter","setter","class"][o],name:r,metadata:a,addInitializer:function(e,t){if(e.v)throw Error("attempted to call addInitializer after decoration was finished");b(t,"An initializer","be",!0),i.push(t)}.bind(null,H)};if(w)c=z.call(A,N,K),H.v=1,b(c,"class decorators","return")&&(N=c);else if(K.static=s,K.private=f,c=K.access={has:f?p.bind():function(e){return r in e}},j||(c.get=f?E?function(e){return d(e),P.value}:I("get",0,d):function(e){return e[r]}),E||S||(c.set=f?I("set",0,d):function(e,t){e[r]=t}),N=z.call(A,D?{get:P.get,set:P.set}:P[F],K),H.v=1,D){if("object"==typeof N&&N)(c=b(N.get,"accessor.get"))&&(P.get=c),(c=b(N.set,"accessor.set"))&&(P.set=c),(c=b(N.init,"accessor.init"))&&k.unshift(c);else if(void 0!==N)throw new TypeError("accessor decorators must return an object with get, set, or init properties or undefined")}else b(N,(l?"field":"method")+" decorators","return")&&(l?k.unshift(N):P[F]=N)}return o<2&&u.push(g(k,s,1),g(i,s,0)),l||w||(f?D?u.splice(-1,0,I("get",s),I("set",s)):u.push(E?P[F]:b.call.bind(P[F])):m(e,r,P)),N}function w(e){return m(e,d,{configurable:!0,enumerable:!0,value:a})}return void 0!==i&&(a=i[d]),a=h(null==a?null:a),f=[],l=function(e){e&&f.push(g(e))},p=function(t,r){for(var i=0;i<n.length;i++){var a=n[i],c=a[1],l=7&c;if((8&c)==t&&!l==r){var p=a[2],d=!!a[3],m=16&c;applyDec(t?e:e.prototype,a,m,d?"#"+p:toPropertyKey(p),l,l<2?[]:t?s=s||[]:u=u||[],f,!!t,d,r,t&&d?function(t){return checkInRHS(t)===e}:o)}}},p(8,0),p(0,0),p(8,1),p(0,1),l(u),l(s),c=f,v||w(e),{e:c,get c(){var n=[];return v&&[w(e=applyDec(e,[t],r,e.name,5,n)),g(n,1)]}}}'),
	  assertClassBrand: helper("7.24.0", 'export default function _assertClassBrand(e,t,n){if("function"==typeof e?e===t:e.has(t))return arguments.length<3?t:n;throw new TypeError("Private element is not present on this object")}'),
	  asyncGeneratorDelegate: helper("7.0.0-beta.0", 'import OverloadYield from"OverloadYield";export default function _asyncGeneratorDelegate(t){var e={},n=!1;function pump(e,r){return n=!0,r=new Promise((function(n){n(t[e](r))})),{done:!1,value:new OverloadYield(r,1)}}return e["undefined"!=typeof Symbol&&Symbol.iterator||"@@iterator"]=function(){return this},e.next=function(t){return n?(n=!1,t):pump("next",t)},"function"==typeof t.throw&&(e.throw=function(t){if(n)throw n=!1,t;return pump("throw",t)}),"function"==typeof t.return&&(e.return=function(t){return n?(n=!1,t):pump("return",t)}),e}'),
	  asyncIterator: helper("7.15.9", 'export default function _asyncIterator(r){var n,t,o,e=2;for("undefined"!=typeof Symbol&&(t=Symbol.asyncIterator,o=Symbol.iterator);e--;){if(t&&null!=(n=r[t]))return n.call(r);if(o&&null!=(n=r[o]))return new AsyncFromSyncIterator(n.call(r));t="@@asyncIterator",o="@@iterator"}throw new TypeError("Object is not async iterable")}function AsyncFromSyncIterator(r){function AsyncFromSyncIteratorContinuation(r){if(Object(r)!==r)return Promise.reject(new TypeError(r+" is not an object."));var n=r.done;return Promise.resolve(r.value).then((function(r){return{value:r,done:n}}))}return AsyncFromSyncIterator=function(r){this.s=r,this.n=r.next},AsyncFromSyncIterator.prototype={s:null,n:null,next:function(){return AsyncFromSyncIteratorContinuation(this.n.apply(this.s,arguments))},return:function(r){var n=this.s.return;return void 0===n?Promise.resolve({value:r,done:!0}):AsyncFromSyncIteratorContinuation(n.apply(this.s,arguments))},throw:function(r){var n=this.s.return;return void 0===n?Promise.reject(r):AsyncFromSyncIteratorContinuation(n.apply(this.s,arguments))}},new AsyncFromSyncIterator(r)}'),
	  awaitAsyncGenerator: helper("7.0.0-beta.0", 'import OverloadYield from"OverloadYield";export default function _awaitAsyncGenerator(e){return new OverloadYield(e,0)}'),
	  callSuper: helper("7.23.8", 'import getPrototypeOf from"getPrototypeOf";import isNativeReflectConstruct from"isNativeReflectConstruct";import possibleConstructorReturn from"possibleConstructorReturn";export default function _callSuper(t,o,e){return o=getPrototypeOf(o),possibleConstructorReturn(t,isNativeReflectConstruct()?Reflect.construct(o,e||[],getPrototypeOf(t).constructor):o.apply(t,e))}'),
	  checkInRHS: helper("7.20.5", 'export default function _checkInRHS(e){if(Object(e)!==e)throw TypeError("right-hand side of \'in\' should be an object, got "+(null!==e?typeof e:"null"));return e}'),
	  classPrivateFieldGet2: helper("7.24.0", 'import assertClassBrand from"assertClassBrand";export default function _classPrivateFieldGet2(s,a){return s.get(assertClassBrand(s,a))}'),
	  classPrivateFieldSet2: helper("7.24.0", 'import assertClassBrand from"assertClassBrand";export default function _classPrivateFieldSet2(s,a,r){return s.set(assertClassBrand(s,a),r),r}'),
	  classPrivateGetter: helper("7.24.0", 'import assertClassBrand from"assertClassBrand";export default function _classPrivateGetter(s,r,a){return a(assertClassBrand(s,r))}'),
	  classPrivateSetter: helper("7.24.0", 'import assertClassBrand from"assertClassBrand";export default function _classPrivateSetter(s,r,a,t){return r(assertClassBrand(s,a),t),t}'),
	  construct: helper("7.0.0-beta.0", 'import setPrototypeOf from"setPrototypeOf";import isNativeReflectConstruct from"isNativeReflectConstruct";export default function _construct(t,e,r){if(isNativeReflectConstruct())return Reflect.construct.apply(null,arguments);var o=[null];o.push.apply(o,e);var p=new(t.bind.apply(t,o));return r&&setPrototypeOf(p,r.prototype),p}'),
	  defineAccessor: helper("7.20.7", "export default function _defineAccessor(e,r,n,t){var c={configurable:!0,enumerable:!0};return c[e]=t,Object.defineProperty(r,n,c)}"),
	  dispose: helper("7.22.0", 'function dispose_SuppressedError(r,e){return"undefined"!=typeof SuppressedError?dispose_SuppressedError=SuppressedError:(dispose_SuppressedError=function(r,e){this.suppressed=e,this.error=r,this.stack=Error().stack},dispose_SuppressedError.prototype=Object.create(Error.prototype,{constructor:{value:dispose_SuppressedError,writable:!0,configurable:!0}})),new dispose_SuppressedError(r,e)}export default function _dispose(r,e,s){function next(){for(;r.length>0;)try{var o=r.pop(),p=o.d.call(o.v);if(o.a)return Promise.resolve(p).then(next,err)}catch(r){return err(r)}if(s)throw e}function err(r){return e=s?new dispose_SuppressedError(e,r):r,s=!0,next()}return next()}'),
	  importDeferProxy: helper("7.23.0", "export default function _importDeferProxy(e){var t=null,constValue=function(e){return function(){return e}},proxy=function(r){return function(n,o,f){return null===t&&(t=e()),r(t,o,f)}};return new Proxy({},{defineProperty:constValue(!1),deleteProperty:constValue(!1),get:proxy(Reflect.get),getOwnPropertyDescriptor:proxy(Reflect.getOwnPropertyDescriptor),getPrototypeOf:constValue(null),isExtensible:constValue(!1),has:proxy(Reflect.has),ownKeys:proxy(Reflect.ownKeys),preventExtensions:constValue(!0),set:constValue(!1),setPrototypeOf:constValue(!1)})}"),
	  interopRequireWildcard: helper("7.14.0", 'function _getRequireWildcardCache(e){if("function"!=typeof WeakMap)return null;var r=new WeakMap,t=new WeakMap;return(_getRequireWildcardCache=function(e){return e?t:r})(e)}export default function _interopRequireWildcard(e,r){if(!r&&e&&e.__esModule)return e;if(null===e||"object"!=typeof e&&"function"!=typeof e)return{default:e};var t=_getRequireWildcardCache(r);if(t&&t.has(e))return t.get(e);var n={__proto__:null},a=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var u in e)if("default"!==u&&{}.hasOwnProperty.call(e,u)){var i=a?Object.getOwnPropertyDescriptor(e,u):null;i&&(i.get||i.set)?Object.defineProperty(n,u,i):n[u]=e[u]}return n.default=e,t&&t.set(e,n),n}'),
	  isNativeReflectConstruct: helper("7.9.0", "export default function _isNativeReflectConstruct(){try{var t=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(t){}return(_isNativeReflectConstruct=function(){return!!t})()}"),
	  iterableToArrayLimit: helper("7.0.0-beta.0", 'export default function _iterableToArrayLimit(r,l){var t=null==r?null:"undefined"!=typeof Symbol&&r[Symbol.iterator]||r["@@iterator"];if(null!=t){var e,n,i,u,a=[],f=!0,o=!1;try{if(i=(t=t.call(r)).next,0===l){if(Object(t)!==t)return;f=!1}else for(;!(f=(e=i.call(t)).done)&&(a.push(e.value),a.length!==l);f=!0);}catch(r){o=!0,n=r}finally{try{if(!f&&null!=t.return&&(u=t.return(),Object(u)!==u))return}finally{if(o)throw n}}return a}}'),
	  iterableToArrayLimitLoose: helper("7.0.0-beta.0", 'export default function _iterableToArrayLimitLoose(e,r){var t=e&&("undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"]);if(null!=t){var o,l=[];for(t=t.call(e);e.length<r&&!(o=t.next()).done;)l.push(o.value);return l}}'),
	  jsx: helper("7.0.0-beta.0", 'var REACT_ELEMENT_TYPE;export default function _createRawReactElement(e,r,E,l){REACT_ELEMENT_TYPE||(REACT_ELEMENT_TYPE="function"==typeof Symbol&&Symbol.for&&Symbol.for("react.element")||60103);var o=e&&e.defaultProps,n=arguments.length-3;if(r||0===n||(r={children:void 0}),1===n)r.children=l;else if(n>1){for(var t=Array(n),f=0;f<n;f++)t[f]=arguments[f+3];r.children=t}if(r&&o)for(var i in o)void 0===r[i]&&(r[i]=o[i]);else r||(r=o||{});return{$$typeof:REACT_ELEMENT_TYPE,type:e,key:void 0===E?null:""+E,ref:null,props:r,_owner:null}}'),
	  objectSpread2: helper("7.5.0", 'import defineProperty from"defineProperty";function ownKeys(e,r){var t=Object.keys(e);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);r&&(o=o.filter((function(r){return Object.getOwnPropertyDescriptor(e,r).enumerable}))),t.push.apply(t,o)}return t}export default function _objectSpread2(e){for(var r=1;r<arguments.length;r++){var t=null!=arguments[r]?arguments[r]:{};r%2?ownKeys(Object(t),!0).forEach((function(r){defineProperty(e,r,t[r])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):ownKeys(Object(t)).forEach((function(r){Object.defineProperty(e,r,Object.getOwnPropertyDescriptor(t,r))}))}return e}'),
	  regeneratorRuntime: helper("7.18.0", 'export default function _regeneratorRuntime(){"use strict";\n/*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */_regeneratorRuntime=function(){return e};var t,e={},r=Object.prototype,n=r.hasOwnProperty,o=Object.defineProperty||function(t,e,r){t[e]=r.value},i="function"==typeof Symbol?Symbol:{},a=i.iterator||"@@iterator",c=i.asyncIterator||"@@asyncIterator",u=i.toStringTag||"@@toStringTag";function define(t,e,r){return Object.defineProperty(t,e,{value:r,enumerable:!0,configurable:!0,writable:!0}),t[e]}try{define({},"")}catch(t){define=function(t,e,r){return t[e]=r}}function wrap(t,e,r,n){var i=e&&e.prototype instanceof Generator?e:Generator,a=Object.create(i.prototype),c=new Context(n||[]);return o(a,"_invoke",{value:makeInvokeMethod(t,r,c)}),a}function tryCatch(t,e,r){try{return{type:"normal",arg:t.call(e,r)}}catch(t){return{type:"throw",arg:t}}}e.wrap=wrap;var h="suspendedStart",l="suspendedYield",f="executing",s="completed",y={};function Generator(){}function GeneratorFunction(){}function GeneratorFunctionPrototype(){}var p={};define(p,a,(function(){return this}));var d=Object.getPrototypeOf,v=d&&d(d(values([])));v&&v!==r&&n.call(v,a)&&(p=v);var g=GeneratorFunctionPrototype.prototype=Generator.prototype=Object.create(p);function defineIteratorMethods(t){["next","throw","return"].forEach((function(e){define(t,e,(function(t){return this._invoke(e,t)}))}))}function AsyncIterator(t,e){function invoke(r,o,i,a){var c=tryCatch(t[r],t,o);if("throw"!==c.type){var u=c.arg,h=u.value;return h&&"object"==typeof h&&n.call(h,"__await")?e.resolve(h.__await).then((function(t){invoke("next",t,i,a)}),(function(t){invoke("throw",t,i,a)})):e.resolve(h).then((function(t){u.value=t,i(u)}),(function(t){return invoke("throw",t,i,a)}))}a(c.arg)}var r;o(this,"_invoke",{value:function(t,n){function callInvokeWithMethodAndArg(){return new e((function(e,r){invoke(t,n,e,r)}))}return r=r?r.then(callInvokeWithMethodAndArg,callInvokeWithMethodAndArg):callInvokeWithMethodAndArg()}})}function makeInvokeMethod(e,r,n){var o=h;return function(i,a){if(o===f)throw Error("Generator is already running");if(o===s){if("throw"===i)throw a;return{value:t,done:!0}}for(n.method=i,n.arg=a;;){var c=n.delegate;if(c){var u=maybeInvokeDelegate(c,n);if(u){if(u===y)continue;return u}}if("next"===n.method)n.sent=n._sent=n.arg;else if("throw"===n.method){if(o===h)throw o=s,n.arg;n.dispatchException(n.arg)}else"return"===n.method&&n.abrupt("return",n.arg);o=f;var p=tryCatch(e,r,n);if("normal"===p.type){if(o=n.done?s:l,p.arg===y)continue;return{value:p.arg,done:n.done}}"throw"===p.type&&(o=s,n.method="throw",n.arg=p.arg)}}}function maybeInvokeDelegate(e,r){var n=r.method,o=e.iterator[n];if(o===t)return r.delegate=null,"throw"===n&&e.iterator.return&&(r.method="return",r.arg=t,maybeInvokeDelegate(e,r),"throw"===r.method)||"return"!==n&&(r.method="throw",r.arg=new TypeError("The iterator does not provide a \'"+n+"\' method")),y;var i=tryCatch(o,e.iterator,r.arg);if("throw"===i.type)return r.method="throw",r.arg=i.arg,r.delegate=null,y;var a=i.arg;return a?a.done?(r[e.resultName]=a.value,r.next=e.nextLoc,"return"!==r.method&&(r.method="next",r.arg=t),r.delegate=null,y):a:(r.method="throw",r.arg=new TypeError("iterator result is not an object"),r.delegate=null,y)}function pushTryEntry(t){var e={tryLoc:t[0]};1 in t&&(e.catchLoc=t[1]),2 in t&&(e.finallyLoc=t[2],e.afterLoc=t[3]),this.tryEntries.push(e)}function resetTryEntry(t){var e=t.completion||{};e.type="normal",delete e.arg,t.completion=e}function Context(t){this.tryEntries=[{tryLoc:"root"}],t.forEach(pushTryEntry,this),this.reset(!0)}function values(e){if(e||""===e){var r=e[a];if(r)return r.call(e);if("function"==typeof e.next)return e;if(!isNaN(e.length)){var o=-1,i=function next(){for(;++o<e.length;)if(n.call(e,o))return next.value=e[o],next.done=!1,next;return next.value=t,next.done=!0,next};return i.next=i}}throw new TypeError(typeof e+" is not iterable")}return GeneratorFunction.prototype=GeneratorFunctionPrototype,o(g,"constructor",{value:GeneratorFunctionPrototype,configurable:!0}),o(GeneratorFunctionPrototype,"constructor",{value:GeneratorFunction,configurable:!0}),GeneratorFunction.displayName=define(GeneratorFunctionPrototype,u,"GeneratorFunction"),e.isGeneratorFunction=function(t){var e="function"==typeof t&&t.constructor;return!!e&&(e===GeneratorFunction||"GeneratorFunction"===(e.displayName||e.name))},e.mark=function(t){return Object.setPrototypeOf?Object.setPrototypeOf(t,GeneratorFunctionPrototype):(t.__proto__=GeneratorFunctionPrototype,define(t,u,"GeneratorFunction")),t.prototype=Object.create(g),t},e.awrap=function(t){return{__await:t}},defineIteratorMethods(AsyncIterator.prototype),define(AsyncIterator.prototype,c,(function(){return this})),e.AsyncIterator=AsyncIterator,e.async=function(t,r,n,o,i){void 0===i&&(i=Promise);var a=new AsyncIterator(wrap(t,r,n,o),i);return e.isGeneratorFunction(r)?a:a.next().then((function(t){return t.done?t.value:a.next()}))},defineIteratorMethods(g),define(g,u,"Generator"),define(g,a,(function(){return this})),define(g,"toString",(function(){return"[object Generator]"})),e.keys=function(t){var e=Object(t),r=[];for(var n in e)r.push(n);return r.reverse(),function next(){for(;r.length;){var t=r.pop();if(t in e)return next.value=t,next.done=!1,next}return next.done=!0,next}},e.values=values,Context.prototype={constructor:Context,reset:function(e){if(this.prev=0,this.next=0,this.sent=this._sent=t,this.done=!1,this.delegate=null,this.method="next",this.arg=t,this.tryEntries.forEach(resetTryEntry),!e)for(var r in this)"t"===r.charAt(0)&&n.call(this,r)&&!isNaN(+r.slice(1))&&(this[r]=t)},stop:function(){this.done=!0;var t=this.tryEntries[0].completion;if("throw"===t.type)throw t.arg;return this.rval},dispatchException:function(e){if(this.done)throw e;var r=this;function handle(n,o){return a.type="throw",a.arg=e,r.next=n,o&&(r.method="next",r.arg=t),!!o}for(var o=this.tryEntries.length-1;o>=0;--o){var i=this.tryEntries[o],a=i.completion;if("root"===i.tryLoc)return handle("end");if(i.tryLoc<=this.prev){var c=n.call(i,"catchLoc"),u=n.call(i,"finallyLoc");if(c&&u){if(this.prev<i.catchLoc)return handle(i.catchLoc,!0);if(this.prev<i.finallyLoc)return handle(i.finallyLoc)}else if(c){if(this.prev<i.catchLoc)return handle(i.catchLoc,!0)}else{if(!u)throw Error("try statement without catch or finally");if(this.prev<i.finallyLoc)return handle(i.finallyLoc)}}}},abrupt:function(t,e){for(var r=this.tryEntries.length-1;r>=0;--r){var o=this.tryEntries[r];if(o.tryLoc<=this.prev&&n.call(o,"finallyLoc")&&this.prev<o.finallyLoc){var i=o;break}}i&&("break"===t||"continue"===t)&&i.tryLoc<=e&&e<=i.finallyLoc&&(i=null);var a=i?i.completion:{};return a.type=t,a.arg=e,i?(this.method="next",this.next=i.finallyLoc,y):this.complete(a)},complete:function(t,e){if("throw"===t.type)throw t.arg;return"break"===t.type||"continue"===t.type?this.next=t.arg:"return"===t.type?(this.rval=this.arg=t.arg,this.method="return",this.next="end"):"normal"===t.type&&e&&(this.next=e),y},finish:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var r=this.tryEntries[e];if(r.finallyLoc===t)return this.complete(r.completion,r.afterLoc),resetTryEntry(r),y}},catch:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var r=this.tryEntries[e];if(r.tryLoc===t){var n=r.completion;if("throw"===n.type){var o=n.arg;resetTryEntry(r)}return o}}throw Error("illegal catch attempt")},delegateYield:function(e,r,n){return this.delegate={iterator:values(e),resultName:r,nextLoc:n},"next"===this.method&&(this.arg=t),y}},e}'),
	  setFunctionName: helper("7.23.6", 'export default function setFunctionName(e,t,n){"symbol"==typeof t&&(t=(t=t.description)?"["+t+"]":"");try{Object.defineProperty(e,"name",{configurable:!0,value:n?n+" "+t:t})}catch(e){}return e}'),
	  toPrimitive: helper("7.1.5", 'export default function toPrimitive(t,r){if("object"!=typeof t||!t)return t;var e=t[Symbol.toPrimitive];if(void 0!==e){var i=e.call(t,r||"default");if("object"!=typeof i)return i;throw new TypeError("@@toPrimitive must return a primitive value.")}return("string"===r?String:Number)(t)}'),
	  toPropertyKey: helper("7.1.5", 'import toPrimitive from"toPrimitive";export default function toPropertyKey(t){var i=toPrimitive(t,"string");return"symbol"==typeof i?i:i+""}'),
	  toSetter: helper("7.24.0", 'export default function _toSetter(t,e,n){e||(e=[]);var r=e.length++;return Object.defineProperty({},"_",{set:function(o){e[r]=o,t.apply(n,e)}})}'),
	  typeof: helper("7.0.0-beta.0", 'export default function _typeof(o){"@babel/helpers - typeof";return _typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(o){return typeof o}:function(o){return o&&"function"==typeof Symbol&&o.constructor===Symbol&&o!==Symbol.prototype?"symbol":typeof o},_typeof(o)}'),
	  using: helper("7.22.0", 'export default function _using(o,n,e){if(null==n)return n;if(Object(n)!==n)throw new TypeError("using declarations can only be used with objects, functions, null, or undefined.");if(e)var r=n[Symbol.asyncDispose||Symbol.for("Symbol.asyncDispose")];if(null==r&&(r=n[Symbol.dispose||Symbol.for("Symbol.dispose")]),"function"!=typeof r)throw new TypeError("Property [Symbol.dispose] is not a function.");return o.push({v:n,d:r,a:e}),n}'),
	  usingCtx: helper("7.23.9", 'export default function _usingCtx(){var r="function"==typeof SuppressedError?SuppressedError:function(r,n){var e=Error();return e.name="SuppressedError",e.error=r,e.suppressed=n,e},n={},e=[];function using(r,n){if(null!=n){if(Object(n)!==n)throw new TypeError("using declarations can only be used with objects, functions, null, or undefined.");if(r)var o=n[Symbol.asyncDispose||Symbol.for("Symbol.asyncDispose")];if(null==o&&(o=n[Symbol.dispose||Symbol.for("Symbol.dispose")]),"function"!=typeof o)throw new TypeError("Property [Symbol.dispose] is not a function.");e.push({v:n,d:o,a:r})}else r&&e.push({d:n,a:r});return n}return{e:n,u:using.bind(null,!1),a:using.bind(null,!0),d:function(){var o=this.e;function next(){for(;r=e.pop();)try{var r,t=r.d&&r.d.call(r.v);if(r.a)return Promise.resolve(t).then(next,err)}catch(r){return err(r)}if(o!==n)throw o}function err(e){return o=o!==n?new r(e,o):e,next()}return next()}}}'),
	  wrapRegExp: helper("7.19.0", 'import setPrototypeOf from"setPrototypeOf";import inherits from"inherits";export default function _wrapRegExp(){_wrapRegExp=function(e,r){return new BabelRegExp(e,void 0,r)};var e=RegExp.prototype,r=new WeakMap;function BabelRegExp(e,t,p){var o=RegExp(e,t);return r.set(o,p||r.get(e)),setPrototypeOf(o,BabelRegExp.prototype)}function buildGroups(e,t){var p=r.get(t);return Object.keys(p).reduce((function(r,t){var o=p[t];if("number"==typeof o)r[t]=e[o];else{for(var i=0;void 0===e[o[i]]&&i+1<o.length;)i++;r[t]=e[o[i]]}return r}),Object.create(null))}return inherits(BabelRegExp,RegExp),BabelRegExp.prototype.exec=function(r){var t=e.exec.call(this,r);if(t){t.groups=buildGroups(t,this);var p=t.indices;p&&(p.groups=buildGroups(p,this))}return t},BabelRegExp.prototype[Symbol.replace]=function(t,p){if("string"==typeof p){var o=r.get(this);return e[Symbol.replace].call(this,t,p.replace(/\\$<([^>]+)>/g,(function(e,r){var t=o[r];return"$"+(Array.isArray(t)?t.join("$"):t)})))}if("function"==typeof p){var i=this;return e[Symbol.replace].call(this,t,(function(){var e=arguments;return"object"!=typeof e[e.length-1]&&(e=[].slice.call(e)).push(buildGroups(e,i)),p.apply(this,e)}))}return e[Symbol.replace].call(this,t,p)},_wrapRegExp.apply(this,arguments)}')
	});

	
	return helpersGenerated;
}

var hasRequiredHelpers;

function requireHelpers () {
	if (hasRequiredHelpers) return helpers;
	hasRequiredHelpers = 1;

	Object.defineProperty(helpers, "__esModule", {
	  value: true
	});
	helpers.default = void 0;
	var _template = requireLib$9();
	var _helpersGenerated = requireHelpersGenerated();
	const helpers$1 = Object.assign({
	  __proto__: null
	}, _helpersGenerated.default);
	helpers.default = helpers$1;
	const helper = minVersion => tpl => ({
	  minVersion,
	  ast: () => _template.default.program.ast(tpl)
	});
	{
	  helpers$1.AwaitValue = helper("7.0.0-beta.0")`
    export default function _AwaitValue(value) {
      this.wrapped = value;
    }
  `;
	}
	helpers$1.wrapAsyncGenerator = helper("7.0.0-beta.0")`
  import AsyncGenerator from "AsyncGenerator";

  export default function _wrapAsyncGenerator(fn) {
    return function () {
      return new AsyncGenerator(fn.apply(this, arguments));
    };
  }
`;
	helpers$1.asyncToGenerator = helper("7.0.0-beta.0")`
  function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
    try {
      var info = gen[key](arg);
      var value = info.value;
    } catch (error) {
      reject(error);
      return;
    }

    if (info.done) {
      resolve(value);
    } else {
      Promise.resolve(value).then(_next, _throw);
    }
  }

  export default function _asyncToGenerator(fn) {
    return function () {
      var self = this, args = arguments;
      return new Promise(function (resolve, reject) {
        var gen = fn.apply(self, args);
        function _next(value) {
          asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
        }
        function _throw(err) {
          asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
        }

        _next(undefined);
      });
    };
  }
`;
	helpers$1.classCallCheck = helper("7.0.0-beta.0")`
  export default function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }
`;
	helpers$1.createClass = helper("7.0.0-beta.0")`
  import toPropertyKey from "toPropertyKey";
  function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i ++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, toPropertyKey(descriptor.key), descriptor);
    }
  }

  export default function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);
    if (staticProps) _defineProperties(Constructor, staticProps);
    Object.defineProperty(Constructor, "prototype", { writable: false });
    return Constructor;
  }
`;
	{
	  helpers$1.defineEnumerableProperties = helper("7.0.0-beta.0")`
    export default function _defineEnumerableProperties(obj, descs) {
      for (var key in descs) {
        var desc = descs[key];
        desc.configurable = desc.enumerable = true;
        if ("value" in desc) desc.writable = true;
        Object.defineProperty(obj, key, desc);
      }

      // Symbols are not enumerated over by for-in loops. If native
      // Symbols are available, fetch all of the descs object's own
      // symbol properties and define them on our target object too.
      if (Object.getOwnPropertySymbols) {
        var objectSymbols = Object.getOwnPropertySymbols(descs);
        for (var i = 0; i < objectSymbols.length; i++) {
          var sym = objectSymbols[i];
          var desc = descs[sym];
          desc.configurable = desc.enumerable = true;
          if ("value" in desc) desc.writable = true;
          Object.defineProperty(obj, sym, desc);
        }
      }
      return obj;
    }
`;
	}
	helpers$1.defaults = helper("7.0.0-beta.0")`
  export default function _defaults(obj, defaults) {
    var keys = Object.getOwnPropertyNames(defaults);
    for (var i = 0; i < keys.length; i++) {
      var key = keys[i];
      var value = Object.getOwnPropertyDescriptor(defaults, key);
      if (value && value.configurable && obj[key] === undefined) {
        Object.defineProperty(obj, key, value);
      }
    }
    return obj;
  }
`;
	helpers$1.defineProperty = helper("7.0.0-beta.0")`
  import toPropertyKey from "toPropertyKey";
  export default function _defineProperty(obj, key, value) {
    key = toPropertyKey(key);
    // Shortcircuit the slow defineProperty path when possible.
    // We are trying to avoid issues where setters defined on the
    // prototype cause side effects under the fast path of simple
    // assignment. By checking for existence of the property with
    // the in operator, we can optimize most of this overhead away.
    if (key in obj) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
    } else {
      obj[key] = value;
    }
    return obj;
  }
`;
	helpers$1.extends = helper("7.0.0-beta.0")`
  export default function _extends() {
    _extends = Object.assign ? Object.assign.bind() : function (target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i];
        for (var key in source) {
          if (Object.prototype.hasOwnProperty.call(source, key)) {
            target[key] = source[key];
          }
        }
      }
      return target;
    };

    return _extends.apply(this, arguments);
  }
`;
	{
	  helpers$1.objectSpread = helper("7.0.0-beta.0")`
    import defineProperty from "defineProperty";

    export default function _objectSpread(target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = (arguments[i] != null) ? Object(arguments[i]) : {};
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === 'function') {
          ownKeys.push.apply(ownKeys, Object.getOwnPropertySymbols(source).filter(function(sym) {
            return Object.getOwnPropertyDescriptor(source, sym).enumerable;
          }));
        }
        ownKeys.forEach(function(key) {
          defineProperty(target, key, source[key]);
        });
      }
      return target;
    }
  `;
	}
	helpers$1.inherits = helper("7.0.0-beta.0")`
  import setPrototypeOf from "setPrototypeOf";

  export default function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }
    // We can't use defineProperty to set the prototype in a single step because it
    // doesn't work in Chrome <= 36. https://github.com/babel/babel/issues/14056
    // V8 bug: https://bugs.chromium.org/p/v8/issues/detail?id=3334
    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        writable: true,
        configurable: true
      }
    });
    Object.defineProperty(subClass, "prototype", { writable: false });
    if (superClass) setPrototypeOf(subClass, superClass);
  }
`;
	helpers$1.inheritsLoose = helper("7.0.0-beta.0")`
  import setPrototypeOf from "setPrototypeOf";

  export default function _inheritsLoose(subClass, superClass) {
    subClass.prototype = Object.create(superClass.prototype);
    subClass.prototype.constructor = subClass;
    setPrototypeOf(subClass, superClass);
  }
`;
	helpers$1.getPrototypeOf = helper("7.0.0-beta.0")`
  export default function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf
      ? Object.getPrototypeOf.bind()
      : function _getPrototypeOf(o) {
          return o.__proto__ || Object.getPrototypeOf(o);
        };
    return _getPrototypeOf(o);
  }
`;
	helpers$1.setPrototypeOf = helper("7.0.0-beta.0")`
  export default function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf
      ? Object.setPrototypeOf.bind()
      : function _setPrototypeOf(o, p) {
          o.__proto__ = p;
          return o;
        };
    return _setPrototypeOf(o, p);
  }
`;
	helpers$1.isNativeFunction = helper("7.0.0-beta.0")`
  export default function _isNativeFunction(fn) {
    // Note: This function returns "true" for core-js functions.
    try {
      return Function.toString.call(fn).indexOf("[native code]") !== -1;
    } catch (e) {
      // Firefox 31 throws when "toString" is applied to an HTMLElement
      return typeof fn === "function";
    }
  }
`;
	helpers$1.wrapNativeSuper = helper("7.0.0-beta.0")`
  import getPrototypeOf from "getPrototypeOf";
  import setPrototypeOf from "setPrototypeOf";
  import isNativeFunction from "isNativeFunction";
  import construct from "construct";

  export default function _wrapNativeSuper(Class) {
    var _cache = typeof Map === "function" ? new Map() : undefined;

    _wrapNativeSuper = function _wrapNativeSuper(Class) {
      if (Class === null || !isNativeFunction(Class)) return Class;
      if (typeof Class !== "function") {
        throw new TypeError("Super expression must either be null or a function");
      }
      if (typeof _cache !== "undefined") {
        if (_cache.has(Class)) return _cache.get(Class);
        _cache.set(Class, Wrapper);
      }
      function Wrapper() {
        return construct(Class, arguments, getPrototypeOf(this).constructor)
      }
      Wrapper.prototype = Object.create(Class.prototype, {
        constructor: {
          value: Wrapper,
          enumerable: false,
          writable: true,
          configurable: true,
        }
      });

      return setPrototypeOf(Wrapper, Class);
    }

    return _wrapNativeSuper(Class)
  }
`;
	helpers$1.instanceof = helper("7.0.0-beta.0")`
  export default function _instanceof(left, right) {
    if (right != null && typeof Symbol !== "undefined" && right[Symbol.hasInstance]) {
      return !!right[Symbol.hasInstance](left);
    } else {
      return left instanceof right;
    }
  }
`;
	helpers$1.interopRequireDefault = helper("7.0.0-beta.0")`
  export default function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { default: obj };
  }
`;
	helpers$1.newArrowCheck = helper("7.0.0-beta.0")`
  export default function _newArrowCheck(innerThis, boundThis) {
    if (innerThis !== boundThis) {
      throw new TypeError("Cannot instantiate an arrow function");
    }
  }
`;
	helpers$1.objectDestructuringEmpty = helper("7.0.0-beta.0")`
  export default function _objectDestructuringEmpty(obj) {
    if (obj == null) throw new TypeError("Cannot destructure " + obj);
  }
`;
	helpers$1.objectWithoutPropertiesLoose = helper("7.0.0-beta.0")`
  export default function _objectWithoutPropertiesLoose(source, excluded) {
    if (source == null) return {};

    var target = {};

    for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        if (excluded.indexOf(key) >= 0) continue;
        target[key] = source[key];
      }
    }

    return target;
  }
`;
	helpers$1.objectWithoutProperties = helper("7.0.0-beta.0")`
  import objectWithoutPropertiesLoose from "objectWithoutPropertiesLoose";

  export default function _objectWithoutProperties(source, excluded) {
    if (source == null) return {};

    var target = objectWithoutPropertiesLoose(source, excluded);
    var key, i;

    if (Object.getOwnPropertySymbols) {
      var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
      for (i = 0; i < sourceSymbolKeys.length; i++) {
        key = sourceSymbolKeys[i];
        if (excluded.indexOf(key) >= 0) continue;
        if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
        target[key] = source[key];
      }
    }

    return target;
  }
`;
	helpers$1.assertThisInitialized = helper("7.0.0-beta.0")`
  export default function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }
    return self;
  }
`;
	helpers$1.possibleConstructorReturn = helper("7.0.0-beta.0")`
  import assertThisInitialized from "assertThisInitialized";

  export default function _possibleConstructorReturn(self, call) {
    if (call && (typeof call === "object" || typeof call === "function")) {
      return call;
    } else if (call !== void 0) {
      throw new TypeError("Derived constructors may only return object or undefined");
    }

    return assertThisInitialized(self);
  }
`;
	{
	  helpers$1.createSuper = helper("7.9.0")`
    import getPrototypeOf from "getPrototypeOf";
    import isNativeReflectConstruct from "isNativeReflectConstruct";
    import possibleConstructorReturn from "possibleConstructorReturn";

    export default function _createSuper(Derived) {
      var hasNativeReflectConstruct = isNativeReflectConstruct();

      return function _createSuperInternal() {
        var Super = getPrototypeOf(Derived), result;
        if (hasNativeReflectConstruct) {
          // NOTE: This doesn't work if this.__proto__.constructor has been modified.
          var NewTarget = getPrototypeOf(this).constructor;
          result = Reflect.construct(Super, arguments, NewTarget);
        } else {
          result = Super.apply(this, arguments);
        }
        return possibleConstructorReturn(this, result);
      }
    }
`;
	}
	helpers$1.superPropBase = helper("7.0.0-beta.0")`
  import getPrototypeOf from "getPrototypeOf";

  export default function _superPropBase(object, property) {
    // Yes, this throws if object is null to being with, that's on purpose.
    while (!Object.prototype.hasOwnProperty.call(object, property)) {
      object = getPrototypeOf(object);
      if (object === null) break;
    }
    return object;
  }
`;
	helpers$1.get = helper("7.0.0-beta.0")`
  import superPropBase from "superPropBase";

  export default function _get() {
    if (typeof Reflect !== "undefined" && Reflect.get) {
      _get = Reflect.get.bind();
    } else {
      _get = function _get(target, property, receiver) {
        var base = superPropBase(target, property);

        if (!base) return;

        var desc = Object.getOwnPropertyDescriptor(base, property);
        if (desc.get) {
          // STEP 3. If receiver is not present, then set receiver to target.
          return desc.get.call(arguments.length < 3 ? target : receiver);
        }

        return desc.value;
      };
    }
    return _get.apply(this, arguments);
  }
`;
	helpers$1.set = helper("7.0.0-beta.0")`
  import superPropBase from "superPropBase";
  import defineProperty from "defineProperty";

  function set(target, property, value, receiver) {
    if (typeof Reflect !== "undefined" && Reflect.set) {
      set = Reflect.set;
    } else {
      set = function set(target, property, value, receiver) {
        var base = superPropBase(target, property);
        var desc;

        if (base) {
          desc = Object.getOwnPropertyDescriptor(base, property);
          if (desc.set) {
            desc.set.call(receiver, value);
            return true;
          } else if (!desc.writable) {
            // Both getter and non-writable fall into this.
            return false;
          }
        }

        // Without a super that defines the property, spec boils down to
        // "define on receiver" for some reason.
        desc = Object.getOwnPropertyDescriptor(receiver, property);
        if (desc) {
          if (!desc.writable) {
            // Setter, getter, and non-writable fall into this.
            return false;
          }

          desc.value = value;
          Object.defineProperty(receiver, property, desc);
        } else {
          // Avoid setters that may be defined on Sub's prototype, but not on
          // the instance.
          defineProperty(receiver, property, value);
        }

        return true;
      };
    }

    return set(target, property, value, receiver);
  }

  export default function _set(target, property, value, receiver, isStrict) {
    var s = set(target, property, value, receiver || target);
    if (!s && isStrict) {
      throw new TypeError('failed to set property');
    }

    return value;
  }
`;
	helpers$1.taggedTemplateLiteral = helper("7.0.0-beta.0")`
  export default function _taggedTemplateLiteral(strings, raw) {
    if (!raw) { raw = strings.slice(0); }
    return Object.freeze(Object.defineProperties(strings, {
        raw: { value: Object.freeze(raw) }
    }));
  }
`;
	helpers$1.taggedTemplateLiteralLoose = helper("7.0.0-beta.0")`
  export default function _taggedTemplateLiteralLoose(strings, raw) {
    if (!raw) { raw = strings.slice(0); }
    strings.raw = raw;
    return strings;
  }
`;
	helpers$1.readOnlyError = helper("7.0.0-beta.0")`
  export default function _readOnlyError(name) {
    throw new TypeError("\\"" + name + "\\" is read-only");
  }
`;
	helpers$1.writeOnlyError = helper("7.12.13")`
  export default function _writeOnlyError(name) {
    throw new TypeError("\\"" + name + "\\" is write-only");
  }
`;
	helpers$1.classNameTDZError = helper("7.0.0-beta.0")`
  export default function _classNameTDZError(name) {
    throw new ReferenceError("Class \\"" + name + "\\" cannot be referenced in computed property keys.");
  }
`;
	helpers$1.temporalUndefined = helper("7.0.0-beta.0")`
  // This function isn't mean to be called, but to be used as a reference.
  // We can't use a normal object because it isn't hoisted.
  export default function _temporalUndefined() {}
`;
	helpers$1.tdz = helper("7.5.5")`
  export default function _tdzError(name) {
    throw new ReferenceError(name + " is not defined - temporal dead zone");
  }
`;
	helpers$1.temporalRef = helper("7.0.0-beta.0")`
  import undef from "temporalUndefined";
  import err from "tdz";

  export default function _temporalRef(val, name) {
    return val === undef ? err(name) : val;
  }
`;
	helpers$1.slicedToArray = helper("7.0.0-beta.0")`
  import arrayWithHoles from "arrayWithHoles";
  import iterableToArrayLimit from "iterableToArrayLimit";
  import unsupportedIterableToArray from "unsupportedIterableToArray";
  import nonIterableRest from "nonIterableRest";

  export default function _slicedToArray(arr, i) {
    return (
      arrayWithHoles(arr) ||
      iterableToArrayLimit(arr, i) ||
      unsupportedIterableToArray(arr, i) ||
      nonIterableRest()
    );
  }
`;
	helpers$1.slicedToArrayLoose = helper("7.0.0-beta.0")`
  import arrayWithHoles from "arrayWithHoles";
  import iterableToArrayLimitLoose from "iterableToArrayLimitLoose";
  import unsupportedIterableToArray from "unsupportedIterableToArray";
  import nonIterableRest from "nonIterableRest";

  export default function _slicedToArrayLoose(arr, i) {
    return (
      arrayWithHoles(arr) ||
      iterableToArrayLimitLoose(arr, i) ||
      unsupportedIterableToArray(arr, i) ||
      nonIterableRest()
    );
  }
`;
	helpers$1.toArray = helper("7.0.0-beta.0")`
  import arrayWithHoles from "arrayWithHoles";
  import iterableToArray from "iterableToArray";
  import unsupportedIterableToArray from "unsupportedIterableToArray";
  import nonIterableRest from "nonIterableRest";

  export default function _toArray(arr) {
    return (
      arrayWithHoles(arr) ||
      iterableToArray(arr) ||
      unsupportedIterableToArray(arr) ||
      nonIterableRest()
    );
  }
`;
	helpers$1.toConsumableArray = helper("7.0.0-beta.0")`
  import arrayWithoutHoles from "arrayWithoutHoles";
  import iterableToArray from "iterableToArray";
  import unsupportedIterableToArray from "unsupportedIterableToArray";
  import nonIterableSpread from "nonIterableSpread";

  export default function _toConsumableArray(arr) {
    return (
      arrayWithoutHoles(arr) ||
      iterableToArray(arr) ||
      unsupportedIterableToArray(arr) ||
      nonIterableSpread()
    );
  }
`;
	helpers$1.arrayWithoutHoles = helper("7.0.0-beta.0")`
  import arrayLikeToArray from "arrayLikeToArray";

  export default function _arrayWithoutHoles(arr) {
    if (Array.isArray(arr)) return arrayLikeToArray(arr);
  }
`;
	helpers$1.arrayWithHoles = helper("7.0.0-beta.0")`
  export default function _arrayWithHoles(arr) {
    if (Array.isArray(arr)) return arr;
  }
`;
	helpers$1.maybeArrayLike = helper("7.9.0")`
  import arrayLikeToArray from "arrayLikeToArray";

  export default function _maybeArrayLike(next, arr, i) {
    if (arr && !Array.isArray(arr) && typeof arr.length === "number") {
      var len = arr.length;
      return arrayLikeToArray(arr, i !== void 0 && i < len ? i : len);
    }
    return next(arr, i);
  }
`;
	helpers$1.iterableToArray = helper("7.0.0-beta.0")`
  export default function _iterableToArray(iter) {
    if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter);
  }
`;
	helpers$1.unsupportedIterableToArray = helper("7.9.0")`
  import arrayLikeToArray from "arrayLikeToArray";

  export default function _unsupportedIterableToArray(o, minLen) {
    if (!o) return;
    if (typeof o === "string") return arrayLikeToArray(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor) n = o.constructor.name;
    if (n === "Map" || n === "Set") return Array.from(o);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))
      return arrayLikeToArray(o, minLen);
  }
`;
	helpers$1.arrayLikeToArray = helper("7.9.0")`
  export default function _arrayLikeToArray(arr, len) {
    if (len == null || len > arr.length) len = arr.length;
    for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];
    return arr2;
  }
`;
	helpers$1.nonIterableSpread = helper("7.0.0-beta.0")`
  export default function _nonIterableSpread() {
    throw new TypeError(
      "Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."
    );
  }
`;
	helpers$1.nonIterableRest = helper("7.0.0-beta.0")`
  export default function _nonIterableRest() {
    throw new TypeError(
      "Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."
    );
  }
`;
	helpers$1.createForOfIteratorHelper = helper("7.9.0")`
  import unsupportedIterableToArray from "unsupportedIterableToArray";

  // s: start (create the iterator)
  // n: next
  // e: error (called whenever something throws)
  // f: finish (always called at the end)

  export default function _createForOfIteratorHelper(o, allowArrayLike) {
    var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"];

    if (!it) {
      // Fallback for engines without symbol support
      if (
        Array.isArray(o) ||
        (it = unsupportedIterableToArray(o)) ||
        (allowArrayLike && o && typeof o.length === "number")
      ) {
        if (it) o = it;
        var i = 0;
        var F = function(){};
        return {
          s: F,
          n: function() {
            if (i >= o.length) return { done: true };
            return { done: false, value: o[i++] };
          },
          e: function(e) { throw e; },
          f: F,
        };
      }

      throw new TypeError("Invalid attempt to iterate non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
    }

    var normalCompletion = true, didErr = false, err;

    return {
      s: function() {
        it = it.call(o);
      },
      n: function() {
        var step = it.next();
        normalCompletion = step.done;
        return step;
      },
      e: function(e) {
        didErr = true;
        err = e;
      },
      f: function() {
        try {
          if (!normalCompletion && it.return != null) it.return();
        } finally {
          if (didErr) throw err;
        }
      }
    };
  }
`;
	helpers$1.createForOfIteratorHelperLoose = helper("7.9.0")`
  import unsupportedIterableToArray from "unsupportedIterableToArray";

  export default function _createForOfIteratorHelperLoose(o, allowArrayLike) {
    var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"];

    if (it) return (it = it.call(o)).next.bind(it);

    // Fallback for engines without symbol support
    if (
      Array.isArray(o) ||
      (it = unsupportedIterableToArray(o)) ||
      (allowArrayLike && o && typeof o.length === "number")
    ) {
      if (it) o = it;
      var i = 0;
      return function() {
        if (i >= o.length) return { done: true };
        return { done: false, value: o[i++] };
      }
    }

    throw new TypeError("Invalid attempt to iterate non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }
`;
	helpers$1.skipFirstGeneratorNext = helper("7.0.0-beta.0")`
  export default function _skipFirstGeneratorNext(fn) {
    return function () {
      var it = fn.apply(this, arguments);
      it.next();
      return it;
    }
  }
`;
	helpers$1.initializerWarningHelper = helper("7.0.0-beta.0")`
    export default function _initializerWarningHelper(descriptor, context){
        throw new Error(
          'Decorating class property failed. Please ensure that ' +
          'transform-class-properties is enabled and runs after the decorators transform.'
        );
    }
`;
	helpers$1.initializerDefineProperty = helper("7.0.0-beta.0")`
    export default function _initializerDefineProperty(target, property, descriptor, context){
        if (!descriptor) return;

        Object.defineProperty(target, property, {
            enumerable: descriptor.enumerable,
            configurable: descriptor.configurable,
            writable: descriptor.writable,
            value: descriptor.initializer ? descriptor.initializer.call(context) : void 0,
        });
    }
`;
	helpers$1.applyDecoratedDescriptor = helper("7.0.0-beta.0")`
    export default function _applyDecoratedDescriptor(target, property, decorators, descriptor, context){
        var desc = {};
        Object.keys(descriptor).forEach(function(key){
            desc[key] = descriptor[key];
        });
        desc.enumerable = !!desc.enumerable;
        desc.configurable = !!desc.configurable;
        if ('value' in desc || desc.initializer){
            desc.writable = true;
        }

        desc = decorators.slice().reverse().reduce(function(desc, decorator){
            return decorator(target, property, desc) || desc;
        }, desc);

        if (context && desc.initializer !== void 0){
            desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
            desc.initializer = undefined;
        }

        if (desc.initializer === void 0){
            Object.defineProperty(target, property, desc);
            desc = null;
        }

        return desc;
    }
`;
	helpers$1.classPrivateFieldLooseKey = helper("7.0.0-beta.0")`
  var id = 0;
  export default function _classPrivateFieldKey(name) {
    return "__private_" + (id++) + "_" + name;
  }
`;
	helpers$1.classPrivateFieldLooseBase = helper("7.0.0-beta.0")`
  export default function _classPrivateFieldBase(receiver, privateKey) {
    if (!Object.prototype.hasOwnProperty.call(receiver, privateKey)) {
      throw new TypeError("attempted to use private field on non-instance");
    }
    return receiver;
  }
`;
	helpers$1.classPrivateFieldGet = helper("7.0.0-beta.0")`
  import classApplyDescriptorGet from "classApplyDescriptorGet";
  import classPrivateFieldGet2 from "classPrivateFieldGet2";
  export default function _classPrivateFieldGet(receiver, privateMap) {
    var descriptor = classPrivateFieldGet2(privateMap, receiver);
    return classApplyDescriptorGet(receiver, descriptor);
  }
`;
	helpers$1.classPrivateFieldSet = helper("7.0.0-beta.0")`
  import classApplyDescriptorSet from "classApplyDescriptorSet";
  import classPrivateFieldGet2 from "classPrivateFieldGet2";
  export default function _classPrivateFieldSet(receiver, privateMap, value) {
    var descriptor = classPrivateFieldGet2(privateMap, receiver);
    classApplyDescriptorSet(receiver, descriptor, value);
    return value;
  }
`;
	helpers$1.classPrivateFieldDestructureSet = helper("7.4.4")`
  import classApplyDescriptorDestructureSet from "classApplyDescriptorDestructureSet";
  import classPrivateFieldGet2 from "classPrivateFieldGet2";
  export default function _classPrivateFieldDestructureSet(receiver, privateMap) {
    var descriptor = classPrivateFieldGet2(privateMap, receiver);
    return classApplyDescriptorDestructureSet(receiver, descriptor);
  }
`;
	helpers$1.classExtractFieldDescriptor = helper("7.13.10")`
  import classPrivateFieldGet2 from "classPrivateFieldGet2";

  export default function _classExtractFieldDescriptor(receiver, privateMap) {
    return classPrivateFieldGet2(privateMap, receiver);
  }
`;
	helpers$1.classStaticPrivateFieldSpecGet = helper("7.0.2")`
  import classApplyDescriptorGet from "classApplyDescriptorGet";
  import assertClassBrand from "assertClassBrand";
  import classCheckPrivateStaticFieldDescriptor from "classCheckPrivateStaticFieldDescriptor";
  export default function _classStaticPrivateFieldSpecGet(receiver, classConstructor, descriptor) {
    assertClassBrand(classConstructor, receiver);
    classCheckPrivateStaticFieldDescriptor(descriptor, "get");
    return classApplyDescriptorGet(receiver, descriptor);
  }
`;
	helpers$1.classStaticPrivateFieldSpecSet = helper("7.0.2")`
  import classApplyDescriptorSet from "classApplyDescriptorSet";
  import assertClassBrand from "assertClassBrand";
  import classCheckPrivateStaticFieldDescriptor from "classCheckPrivateStaticFieldDescriptor";
  export default function _classStaticPrivateFieldSpecSet(receiver, classConstructor, descriptor, value) {
    assertClassBrand(classConstructor, receiver);
    classCheckPrivateStaticFieldDescriptor(descriptor, "set");
    classApplyDescriptorSet(receiver, descriptor, value);
    return value;
  }
`;
	helpers$1.classStaticPrivateMethodGet = helper("7.3.2")`
  import assertClassBrand from "assertClassBrand";
  export default function _classStaticPrivateMethodGet(receiver, classConstructor, method) {
    assertClassBrand(classConstructor, receiver);
    return method;
  }
`;
	helpers$1.classStaticPrivateMethodSet = helper("7.3.2")`
  export default function _classStaticPrivateMethodSet() {
    throw new TypeError("attempted to set read only static private field");
  }
`;
	helpers$1.classApplyDescriptorGet = helper("7.13.10")`
  export default function _classApplyDescriptorGet(receiver, descriptor) {
    if (descriptor.get) {
      return descriptor.get.call(receiver);
    }
    return descriptor.value;
  }
`;
	helpers$1.classApplyDescriptorSet = helper("7.13.10")`
  export default function _classApplyDescriptorSet(receiver, descriptor, value) {
    if (descriptor.set) {
      descriptor.set.call(receiver, value);
    } else {
      if (!descriptor.writable) {
        // This should only throw in strict mode, but class bodies are
        // always strict and private fields can only be used inside
        // class bodies.
        throw new TypeError("attempted to set read only private field");
      }
      descriptor.value = value;
    }
  }
`;
	helpers$1.classApplyDescriptorDestructureSet = helper("7.13.10")`
  export default function _classApplyDescriptorDestructureSet(receiver, descriptor) {
    if (descriptor.set) {
      if (!("__destrObj" in descriptor)) {
        descriptor.__destrObj = {
          set value(v) {
            descriptor.set.call(receiver, v)
          },
        };
      }
      return descriptor.__destrObj;
    } else {
      if (!descriptor.writable) {
        // This should only throw in strict mode, but class bodies are
        // always strict and private fields can only be used inside
        // class bodies.
        throw new TypeError("attempted to set read only private field");
      }

      return descriptor;
    }
  }
`;
	helpers$1.classStaticPrivateFieldDestructureSet = helper("7.13.10")`
  import classApplyDescriptorDestructureSet from "classApplyDescriptorDestructureSet";
  import assertClassBrand from "assertClassBrand";
  import classCheckPrivateStaticFieldDescriptor from "classCheckPrivateStaticFieldDescriptor";
  export default function _classStaticPrivateFieldDestructureSet(receiver, classConstructor, descriptor) {
    assertClassBrand(classConstructor, receiver);
    classCheckPrivateStaticFieldDescriptor(descriptor, "set");
    return classApplyDescriptorDestructureSet(receiver, descriptor);
  }
`;
	helpers$1.classCheckPrivateStaticAccess = helper("7.13.10")`
  import assertClassBrand from "assertClassBrand";
  export default function _classCheckPrivateStaticAccess(receiver, classConstructor, returnValue) {
    return assertClassBrand(classConstructor, receiver, returnValue);
  }
`;
	helpers$1.classCheckPrivateStaticFieldDescriptor = helper("7.13.10")`
  export default function _classCheckPrivateStaticFieldDescriptor(descriptor, action) {
    if (descriptor === undefined) {
      throw new TypeError("attempted to " + action + " private static field before its declaration");
    }
  }
`;
	helpers$1.decorate = helper("7.1.5")`
  import toArray from "toArray";
  import toPropertyKey from "toPropertyKey";

  // These comments are stripped by @babel/template
  /*::
  type PropertyDescriptor =
    | {
        value: any,
        writable: boolean,
        configurable: boolean,
        enumerable: boolean,
      }
    | {
        get?: () => any,
        set?: (v: any) => void,
        configurable: boolean,
        enumerable: boolean,
      };

  type FieldDescriptor ={
    writable: boolean,
    configurable: boolean,
    enumerable: boolean,
  };

  type Placement = "static" | "prototype" | "own";
  type Key = string | symbol; // PrivateName is not supported yet.

  type ElementDescriptor =
    | {
        kind: "method",
        key: Key,
        placement: Placement,
        descriptor: PropertyDescriptor
      }
    | {
        kind: "field",
        key: Key,
        placement: Placement,
        descriptor: FieldDescriptor,
        initializer?: () => any,
      };

  // This is exposed to the user code
  type ElementObjectInput = ElementDescriptor & {
    [@@toStringTag]?: "Descriptor"
  };

  // This is exposed to the user code
  type ElementObjectOutput = ElementDescriptor & {
    [@@toStringTag]?: "Descriptor"
    extras?: ElementDescriptor[],
    finisher?: ClassFinisher,
  };

  // This is exposed to the user code
  type ClassObject = {
    [@@toStringTag]?: "Descriptor",
    kind: "class",
    elements: ElementDescriptor[],
  };

  type ElementDecorator = (descriptor: ElementObjectInput) => ?ElementObjectOutput;
  type ClassDecorator = (descriptor: ClassObject) => ?ClassObject;
  type ClassFinisher = <A, B>(cl: Class<A>) => Class<B>;

  // Only used by Babel in the transform output, not part of the spec.
  type ElementDefinition =
    | {
        kind: "method",
        value: any,
        key: Key,
        static?: boolean,
        decorators?: ElementDecorator[],
      }
    | {
        kind: "field",
        value: () => any,
        key: Key,
        static?: boolean,
        decorators?: ElementDecorator[],
    };

  declare function ClassFactory<C>(initialize: (instance: C) => void): {
    F: Class<C>,
    d: ElementDefinition[]
  }

  */

  /*::
  // Various combinations with/without extras and with one or many finishers

  type ElementFinisherExtras = {
    element: ElementDescriptor,
    finisher?: ClassFinisher,
    extras?: ElementDescriptor[],
  };

  type ElementFinishersExtras = {
    element: ElementDescriptor,
    finishers: ClassFinisher[],
    extras: ElementDescriptor[],
  };

  type ElementsFinisher = {
    elements: ElementDescriptor[],
    finisher?: ClassFinisher,
  };

  type ElementsFinishers = {
    elements: ElementDescriptor[],
    finishers: ClassFinisher[],
  };

  */

  /*::

  type Placements = {
    static: Key[],
    prototype: Key[],
    own: Key[],
  };

  */

  // ClassDefinitionEvaluation (Steps 26-*)
  export default function _decorate(
    decorators /*: ClassDecorator[] */,
    factory /*: ClassFactory */,
    superClass /*: ?Class<*> */,
    mixins /*: ?Array<Function> */,
  ) /*: Class<*> */ {
    var api = _getDecoratorsApi();
    if (mixins) {
      for (var i = 0; i < mixins.length; i++) {
        api = mixins[i](api);
      }
    }

    var r = factory(function initialize(O) {
      api.initializeInstanceElements(O, decorated.elements);
    }, superClass);
    var decorated = api.decorateClass(
      _coalesceClassElements(r.d.map(_createElementDescriptor)),
      decorators,
    );

    api.initializeClassElements(r.F, decorated.elements);

    return api.runClassFinishers(r.F, decorated.finishers);
  }

  function _getDecoratorsApi() {
    _getDecoratorsApi = function() {
      return api;
    };

    var api = {
      elementsDefinitionOrder: [["method"], ["field"]],

      // InitializeInstanceElements
      initializeInstanceElements: function(
        /*::<C>*/ O /*: C */,
        elements /*: ElementDescriptor[] */,
      ) {
        ["method", "field"].forEach(function(kind) {
          elements.forEach(function(element /*: ElementDescriptor */) {
            if (element.kind === kind && element.placement === "own") {
              this.defineClassElement(O, element);
            }
          }, this);
        }, this);
      },

      // InitializeClassElements
      initializeClassElements: function(
        /*::<C>*/ F /*: Class<C> */,
        elements /*: ElementDescriptor[] */,
      ) {
        var proto = F.prototype;

        ["method", "field"].forEach(function(kind) {
          elements.forEach(function(element /*: ElementDescriptor */) {
            var placement = element.placement;
            if (
              element.kind === kind &&
              (placement === "static" || placement === "prototype")
            ) {
              var receiver = placement === "static" ? F : proto;
              this.defineClassElement(receiver, element);
            }
          }, this);
        }, this);
      },

      // DefineClassElement
      defineClassElement: function(
        /*::<C>*/ receiver /*: C | Class<C> */,
        element /*: ElementDescriptor */,
      ) {
        var descriptor /*: PropertyDescriptor */ = element.descriptor;
        if (element.kind === "field") {
          var initializer = element.initializer;
          descriptor = {
            enumerable: descriptor.enumerable,
            writable: descriptor.writable,
            configurable: descriptor.configurable,
            value: initializer === void 0 ? void 0 : initializer.call(receiver),
          };
        }
        Object.defineProperty(receiver, element.key, descriptor);
      },

      // DecorateClass
      decorateClass: function(
        elements /*: ElementDescriptor[] */,
        decorators /*: ClassDecorator[] */,
      ) /*: ElementsFinishers */ {
        var newElements /*: ElementDescriptor[] */ = [];
        var finishers /*: ClassFinisher[] */ = [];
        var placements /*: Placements */ = {
          static: [],
          prototype: [],
          own: [],
        };

        elements.forEach(function(element /*: ElementDescriptor */) {
          this.addElementPlacement(element, placements);
        }, this);

        elements.forEach(function(element /*: ElementDescriptor */) {
          if (!_hasDecorators(element)) return newElements.push(element);

          var elementFinishersExtras /*: ElementFinishersExtras */ = this.decorateElement(
            element,
            placements,
          );
          newElements.push(elementFinishersExtras.element);
          newElements.push.apply(newElements, elementFinishersExtras.extras);
          finishers.push.apply(finishers, elementFinishersExtras.finishers);
        }, this);

        if (!decorators) {
          return { elements: newElements, finishers: finishers };
        }

        var result /*: ElementsFinishers */ = this.decorateConstructor(
          newElements,
          decorators,
        );
        finishers.push.apply(finishers, result.finishers);
        result.finishers = finishers;

        return result;
      },

      // AddElementPlacement
      addElementPlacement: function(
        element /*: ElementDescriptor */,
        placements /*: Placements */,
        silent /*: boolean */,
      ) {
        var keys = placements[element.placement];
        if (!silent && keys.indexOf(element.key) !== -1) {
          throw new TypeError("Duplicated element (" + element.key + ")");
        }
        keys.push(element.key);
      },

      // DecorateElement
      decorateElement: function(
        element /*: ElementDescriptor */,
        placements /*: Placements */,
      ) /*: ElementFinishersExtras */ {
        var extras /*: ElementDescriptor[] */ = [];
        var finishers /*: ClassFinisher[] */ = [];

        for (
          var decorators = element.decorators, i = decorators.length - 1;
          i >= 0;
          i--
        ) {
          // (inlined) RemoveElementPlacement
          var keys = placements[element.placement];
          keys.splice(keys.indexOf(element.key), 1);

          var elementObject /*: ElementObjectInput */ = this.fromElementDescriptor(
            element,
          );
          var elementFinisherExtras /*: ElementFinisherExtras */ = this.toElementFinisherExtras(
            (0, decorators[i])(elementObject) /*: ElementObjectOutput */ ||
              elementObject,
          );

          element = elementFinisherExtras.element;
          this.addElementPlacement(element, placements);

          if (elementFinisherExtras.finisher) {
            finishers.push(elementFinisherExtras.finisher);
          }

          var newExtras /*: ElementDescriptor[] | void */ =
            elementFinisherExtras.extras;
          if (newExtras) {
            for (var j = 0; j < newExtras.length; j++) {
              this.addElementPlacement(newExtras[j], placements);
            }
            extras.push.apply(extras, newExtras);
          }
        }

        return { element: element, finishers: finishers, extras: extras };
      },

      // DecorateConstructor
      decorateConstructor: function(
        elements /*: ElementDescriptor[] */,
        decorators /*: ClassDecorator[] */,
      ) /*: ElementsFinishers */ {
        var finishers /*: ClassFinisher[] */ = [];

        for (var i = decorators.length - 1; i >= 0; i--) {
          var obj /*: ClassObject */ = this.fromClassDescriptor(elements);
          var elementsAndFinisher /*: ElementsFinisher */ = this.toClassDescriptor(
            (0, decorators[i])(obj) /*: ClassObject */ || obj,
          );

          if (elementsAndFinisher.finisher !== undefined) {
            finishers.push(elementsAndFinisher.finisher);
          }

          if (elementsAndFinisher.elements !== undefined) {
            elements = elementsAndFinisher.elements;

            for (var j = 0; j < elements.length - 1; j++) {
              for (var k = j + 1; k < elements.length; k++) {
                if (
                  elements[j].key === elements[k].key &&
                  elements[j].placement === elements[k].placement
                ) {
                  throw new TypeError(
                    "Duplicated element (" + elements[j].key + ")",
                  );
                }
              }
            }
          }
        }

        return { elements: elements, finishers: finishers };
      },

      // FromElementDescriptor
      fromElementDescriptor: function(
        element /*: ElementDescriptor */,
      ) /*: ElementObject */ {
        var obj /*: ElementObject */ = {
          kind: element.kind,
          key: element.key,
          placement: element.placement,
          descriptor: element.descriptor,
        };

        var desc = {
          value: "Descriptor",
          configurable: true,
        };
        Object.defineProperty(obj, Symbol.toStringTag, desc);

        if (element.kind === "field") obj.initializer = element.initializer;

        return obj;
      },

      // ToElementDescriptors
      toElementDescriptors: function(
        elementObjects /*: ElementObject[] */,
      ) /*: ElementDescriptor[] */ {
        if (elementObjects === undefined) return;
        return toArray(elementObjects).map(function(elementObject) {
          var element = this.toElementDescriptor(elementObject);
          this.disallowProperty(elementObject, "finisher", "An element descriptor");
          this.disallowProperty(elementObject, "extras", "An element descriptor");
          return element;
        }, this);
      },

      // ToElementDescriptor
      toElementDescriptor: function(
        elementObject /*: ElementObject */,
      ) /*: ElementDescriptor */ {
        var kind = String(elementObject.kind);
        if (kind !== "method" && kind !== "field") {
          throw new TypeError(
            'An element descriptor\\'s .kind property must be either "method" or' +
              ' "field", but a decorator created an element descriptor with' +
              ' .kind "' +
              kind +
              '"',
          );
        }

        var key = toPropertyKey(elementObject.key);

        var placement = String(elementObject.placement);
        if (
          placement !== "static" &&
          placement !== "prototype" &&
          placement !== "own"
        ) {
          throw new TypeError(
            'An element descriptor\\'s .placement property must be one of "static",' +
              ' "prototype" or "own", but a decorator created an element descriptor' +
              ' with .placement "' +
              placement +
              '"',
          );
        }

        var descriptor /*: PropertyDescriptor */ = elementObject.descriptor;

        this.disallowProperty(elementObject, "elements", "An element descriptor");

        var element /*: ElementDescriptor */ = {
          kind: kind,
          key: key,
          placement: placement,
          descriptor: Object.assign({}, descriptor),
        };

        if (kind !== "field") {
          this.disallowProperty(elementObject, "initializer", "A method descriptor");
        } else {
          this.disallowProperty(
            descriptor,
            "get",
            "The property descriptor of a field descriptor",
          );
          this.disallowProperty(
            descriptor,
            "set",
            "The property descriptor of a field descriptor",
          );
          this.disallowProperty(
            descriptor,
            "value",
            "The property descriptor of a field descriptor",
          );

          element.initializer = elementObject.initializer;
        }

        return element;
      },

      toElementFinisherExtras: function(
        elementObject /*: ElementObject */,
      ) /*: ElementFinisherExtras */ {
        var element /*: ElementDescriptor */ = this.toElementDescriptor(
          elementObject,
        );
        var finisher /*: ClassFinisher */ = _optionalCallableProperty(
          elementObject,
          "finisher",
        );
        var extras /*: ElementDescriptors[] */ = this.toElementDescriptors(
          elementObject.extras,
        );

        return { element: element, finisher: finisher, extras: extras };
      },

      // FromClassDescriptor
      fromClassDescriptor: function(
        elements /*: ElementDescriptor[] */,
      ) /*: ClassObject */ {
        var obj = {
          kind: "class",
          elements: elements.map(this.fromElementDescriptor, this),
        };

        var desc = { value: "Descriptor", configurable: true };
        Object.defineProperty(obj, Symbol.toStringTag, desc);

        return obj;
      },

      // ToClassDescriptor
      toClassDescriptor: function(
        obj /*: ClassObject */,
      ) /*: ElementsFinisher */ {
        var kind = String(obj.kind);
        if (kind !== "class") {
          throw new TypeError(
            'A class descriptor\\'s .kind property must be "class", but a decorator' +
              ' created a class descriptor with .kind "' +
              kind +
              '"',
          );
        }

        this.disallowProperty(obj, "key", "A class descriptor");
        this.disallowProperty(obj, "placement", "A class descriptor");
        this.disallowProperty(obj, "descriptor", "A class descriptor");
        this.disallowProperty(obj, "initializer", "A class descriptor");
        this.disallowProperty(obj, "extras", "A class descriptor");

        var finisher = _optionalCallableProperty(obj, "finisher");
        var elements = this.toElementDescriptors(obj.elements);

        return { elements: elements, finisher: finisher };
      },

      // RunClassFinishers
      runClassFinishers: function(
        constructor /*: Class<*> */,
        finishers /*: ClassFinisher[] */,
      ) /*: Class<*> */ {
        for (var i = 0; i < finishers.length; i++) {
          var newConstructor /*: ?Class<*> */ = (0, finishers[i])(constructor);
          if (newConstructor !== undefined) {
            // NOTE: This should check if IsConstructor(newConstructor) is false.
            if (typeof newConstructor !== "function") {
              throw new TypeError("Finishers must return a constructor.");
            }
            constructor = newConstructor;
          }
        }
        return constructor;
      },

      disallowProperty: function(obj, name, objectType) {
        if (obj[name] !== undefined) {
          throw new TypeError(objectType + " can't have a ." + name + " property.");
        }
      }
    };

    return api;
  }

  // ClassElementEvaluation
  function _createElementDescriptor(
    def /*: ElementDefinition */,
  ) /*: ElementDescriptor */ {
    var key = toPropertyKey(def.key);

    var descriptor /*: PropertyDescriptor */;
    if (def.kind === "method") {
      descriptor = {
        value: def.value,
        writable: true,
        configurable: true,
        enumerable: false,
      };
    } else if (def.kind === "get") {
      descriptor = { get: def.value, configurable: true, enumerable: false };
    } else if (def.kind === "set") {
      descriptor = { set: def.value, configurable: true, enumerable: false };
    } else if (def.kind === "field") {
      descriptor = { configurable: true, writable: true, enumerable: true };
    }

    var element /*: ElementDescriptor */ = {
      kind: def.kind === "field" ? "field" : "method",
      key: key,
      placement: def.static
        ? "static"
        : def.kind === "field"
        ? "own"
        : "prototype",
      descriptor: descriptor,
    };
    if (def.decorators) element.decorators = def.decorators;
    if (def.kind === "field") element.initializer = def.value;

    return element;
  }

  // CoalesceGetterSetter
  function _coalesceGetterSetter(
    element /*: ElementDescriptor */,
    other /*: ElementDescriptor */,
  ) {
    if (element.descriptor.get !== undefined) {
      other.descriptor.get = element.descriptor.get;
    } else {
      other.descriptor.set = element.descriptor.set;
    }
  }

  // CoalesceClassElements
  function _coalesceClassElements(
    elements /*: ElementDescriptor[] */,
  ) /*: ElementDescriptor[] */ {
    var newElements /*: ElementDescriptor[] */ = [];

    var isSameElement = function(
      other /*: ElementDescriptor */,
    ) /*: boolean */ {
      return (
        other.kind === "method" &&
        other.key === element.key &&
        other.placement === element.placement
      );
    };

    for (var i = 0; i < elements.length; i++) {
      var element /*: ElementDescriptor */ = elements[i];
      var other /*: ElementDescriptor */;

      if (
        element.kind === "method" &&
        (other = newElements.find(isSameElement))
      ) {
        if (
          _isDataDescriptor(element.descriptor) ||
          _isDataDescriptor(other.descriptor)
        ) {
          if (_hasDecorators(element) || _hasDecorators(other)) {
            throw new ReferenceError(
              "Duplicated methods (" + element.key + ") can't be decorated.",
            );
          }
          other.descriptor = element.descriptor;
        } else {
          if (_hasDecorators(element)) {
            if (_hasDecorators(other)) {
              throw new ReferenceError(
                "Decorators can't be placed on different accessors with for " +
                  "the same property (" +
                  element.key +
                  ").",
              );
            }
            other.decorators = element.decorators;
          }
          _coalesceGetterSetter(element, other);
        }
      } else {
        newElements.push(element);
      }
    }

    return newElements;
  }

  function _hasDecorators(element /*: ElementDescriptor */) /*: boolean */ {
    return element.decorators && element.decorators.length;
  }

  function _isDataDescriptor(desc /*: PropertyDescriptor */) /*: boolean */ {
    return (
      desc !== undefined &&
      !(desc.value === undefined && desc.writable === undefined)
    );
  }

  function _optionalCallableProperty /*::<T>*/(
    obj /*: T */,
    name /*: $Keys<T> */,
  ) /*: ?Function */ {
    var value = obj[name];
    if (value !== undefined && typeof value !== "function") {
      throw new TypeError("Expected '" + name + "' to be a function");
    }
    return value;
  }

`;
	helpers$1.classPrivateMethodGet = helper("7.1.6")`
  import assertClassBrand from "assertClassBrand";
  export default function _classPrivateMethodGet(receiver, privateSet, fn) {
    assertClassBrand(privateSet, receiver);
    return fn;
  }
`;
	helpers$1.checkPrivateRedeclaration = helper("7.14.1")`
  export default function _checkPrivateRedeclaration(obj, privateCollection) {
    if (privateCollection.has(obj)) {
      throw new TypeError("Cannot initialize the same private elements twice on an object");
    }
  }
`;
	helpers$1.classPrivateFieldInitSpec = helper("7.14.1")`
  import checkPrivateRedeclaration from "checkPrivateRedeclaration";

  export default function _classPrivateFieldInitSpec(obj, privateMap, value) {
    checkPrivateRedeclaration(obj, privateMap);
    privateMap.set(obj, value);
  }
`;
	helpers$1.classPrivateMethodInitSpec = helper("7.14.1")`
  import checkPrivateRedeclaration from "checkPrivateRedeclaration";

  export default function _classPrivateMethodInitSpec(obj, privateSet) {
    checkPrivateRedeclaration(obj, privateSet);
    privateSet.add(obj);
  }
`;
	{
	  helpers$1.classPrivateMethodSet = helper("7.1.6")`
    export default function _classPrivateMethodSet() {
      throw new TypeError("attempted to reassign private method");
    }
  `;
	}
	helpers$1.identity = helper("7.17.0")`
  export default function _identity(x) {
    return x;
  }
`;
	helpers$1.nullishReceiverError = helper("7.22.6")`
  export default function _nullishReceiverError(r) {
    throw new TypeError("Cannot set property of null or undefined.");
  }
`;

	
	return helpers;
}

var hasRequiredLib$6;

function requireLib$6 () {
	if (hasRequiredLib$6) return lib$i;
	hasRequiredLib$6 = 1;

	Object.defineProperty(lib$i, "__esModule", {
	  value: true
	});
	lib$i.default = void 0;
	lib$i.ensure = ensure;
	lib$i.get = get;
	lib$i.getDependencies = getDependencies;
	lib$i.list = void 0;
	lib$i.minVersion = minVersion;
	var _traverse = requireLib$7();
	var _t = requireLib$h();
	var _helpers = requireHelpers();
	const {
	  assignmentExpression,
	  cloneNode,
	  expressionStatement,
	  file,
	  identifier
	} = _t;
	function makePath(path) {
	  const parts = [];
	  for (; path.parentPath; path = path.parentPath) {
	    parts.push(path.key);
	    if (path.inList) parts.push(path.listKey);
	  }
	  return parts.reverse().join(".");
	}
	let FileClass = undefined;
	function getHelperMetadata(file) {
	  const globals = new Set();
	  const localBindingNames = new Set();
	  const dependencies = new Map();
	  let exportName;
	  let exportPath;
	  const exportBindingAssignments = [];
	  const importPaths = [];
	  const importBindingsReferences = [];
	  const dependencyVisitor = {
	    ImportDeclaration(child) {
	      const name = child.node.source.value;
	      if (!_helpers.default[name]) {
	        throw child.buildCodeFrameError(`Unknown helper ${name}`);
	      }
	      if (child.get("specifiers").length !== 1 || !child.get("specifiers.0").isImportDefaultSpecifier()) {
	        throw child.buildCodeFrameError("Helpers can only import a default value");
	      }
	      const bindingIdentifier = child.node.specifiers[0].local;
	      dependencies.set(bindingIdentifier, name);
	      importPaths.push(makePath(child));
	    },
	    ExportDefaultDeclaration(child) {
	      const decl = child.get("declaration");
	      if (!decl.isFunctionDeclaration() || !decl.node.id) {
	        throw decl.buildCodeFrameError("Helpers can only export named function declarations");
	      }
	      exportName = decl.node.id.name;
	      exportPath = makePath(child);
	    },
	    ExportAllDeclaration(child) {
	      throw child.buildCodeFrameError("Helpers can only export default");
	    },
	    ExportNamedDeclaration(child) {
	      throw child.buildCodeFrameError("Helpers can only export default");
	    },
	    Statement(child) {
	      if (child.isImportDeclaration() || child.isExportDeclaration()) return;
	      child.skip();
	    }
	  };
	  const referenceVisitor = {
	    Program(path) {
	      const bindings = path.scope.getAllBindings();
	      Object.keys(bindings).forEach(name => {
	        if (name === exportName) return;
	        if (dependencies.has(bindings[name].identifier)) return;
	        localBindingNames.add(name);
	      });
	    },
	    ReferencedIdentifier(child) {
	      const name = child.node.name;
	      const binding = child.scope.getBinding(name);
	      if (!binding) {
	        if (name !== "arguments" || child.scope.path.isProgram()) {
	          globals.add(name);
	        }
	      } else if (dependencies.has(binding.identifier)) {
	        importBindingsReferences.push(makePath(child));
	      }
	    },
	    AssignmentExpression(child) {
	      const left = child.get("left");
	      if (!(exportName in left.getBindingIdentifiers())) return;
	      if (!left.isIdentifier()) {
	        throw left.buildCodeFrameError("Only simple assignments to exports are allowed in helpers");
	      }
	      const binding = child.scope.getBinding(exportName);
	      if (binding != null && binding.scope.path.isProgram()) {
	        exportBindingAssignments.push(makePath(child));
	      }
	    }
	  };
	  (0, _traverse.default)(file.ast, dependencyVisitor, file.scope);
	  (0, _traverse.default)(file.ast, referenceVisitor, file.scope);
	  if (!exportPath) throw new Error("Helpers must have a default export.");
	  exportBindingAssignments.reverse();
	  return {
	    globals: Array.from(globals),
	    localBindingNames: Array.from(localBindingNames),
	    dependencies,
	    exportBindingAssignments,
	    exportPath,
	    exportName,
	    importBindingsReferences,
	    importPaths
	  };
	}
	function permuteHelperAST(file, metadata, id, localBindings, getDependency) {
	  if (localBindings && !id) {
	    throw new Error("Unexpected local bindings for module-based helpers.");
	  }
	  if (!id) return;
	  const {
	    localBindingNames,
	    dependencies,
	    exportBindingAssignments,
	    exportPath,
	    exportName,
	    importBindingsReferences,
	    importPaths
	  } = metadata;
	  const dependenciesRefs = {};
	  dependencies.forEach((name, id) => {
	    dependenciesRefs[id.name] = typeof getDependency === "function" && getDependency(name) || id;
	  });
	  const toRename = {};
	  const bindings = new Set(localBindings || []);
	  if (id.type === "Identifier") bindings.add(id.name);
	  localBindingNames.forEach(name => {
	    let newName = name;
	    while (bindings.has(newName)) newName = "_" + newName;
	    if (newName !== name) toRename[name] = newName;
	  });
	  if (id.type === "Identifier" && exportName !== id.name) {
	    toRename[exportName] = id.name;
	  }
	  const {
	    path
	  } = file;
	  const exp = path.get(exportPath);
	  const imps = importPaths.map(p => path.get(p));
	  const impsBindingRefs = importBindingsReferences.map(p => path.get(p));
	  const decl = exp.get("declaration");
	  if (id.type === "Identifier") {
	    exp.replaceWith(decl);
	  } else if (id.type === "MemberExpression") {
	    exportBindingAssignments.forEach(assignPath => {
	      const assign = path.get(assignPath);
	      assign.replaceWith(assignmentExpression("=", id, assign.node));
	    });
	    exp.replaceWith(decl);
	    path.pushContainer("body", expressionStatement(assignmentExpression("=", id, identifier(exportName))));
	  } else {
	    throw new Error("Unexpected helper format.");
	  }
	  Object.keys(toRename).forEach(name => {
	    path.scope.rename(name, toRename[name]);
	  });
	  for (const path of imps) path.remove();
	  for (const path of impsBindingRefs) {
	    const node = cloneNode(dependenciesRefs[path.node.name]);
	    path.replaceWith(node);
	  }
	}
	const helperData = Object.create(null);
	function loadHelper(name) {
	  if (!helperData[name]) {
	    const helper = _helpers.default[name];
	    if (!helper) {
	      throw Object.assign(new ReferenceError(`Unknown helper ${name}`), {
	        code: "BABEL_HELPER_UNKNOWN",
	        helper: name
	      });
	    }
	    const fn = () => {
	      {
	        if (!FileClass) {
	          const fakeFile = {
	            ast: file(helper.ast()),
	            path: null
	          };
	          (0, _traverse.default)(fakeFile.ast, {
	            Program: path => (fakeFile.path = path).stop()
	          });
	          return fakeFile;
	        }
	      }
	      return new FileClass({
	        filename: `babel-helper://${name}`
	      }, {
	        ast: file(helper.ast()),
	        code: "[internal Babel helper code]",
	        inputMap: null
	      });
	    };
	    let metadata = null;
	    helperData[name] = {
	      minVersion: helper.minVersion,
	      build(getDependency, id, localBindings) {
	        const file = fn();
	        metadata || (metadata = getHelperMetadata(file));
	        permuteHelperAST(file, metadata, id, localBindings, getDependency);
	        return {
	          nodes: file.ast.program.body,
	          globals: metadata.globals
	        };
	      },
	      getDependencies() {
	        metadata || (metadata = getHelperMetadata(fn()));
	        return Array.from(metadata.dependencies.values());
	      }
	    };
	  }
	  return helperData[name];
	}
	function get(name, getDependency, id, localBindings) {
	  return loadHelper(name).build(getDependency, id, localBindings);
	}
	function minVersion(name) {
	  return loadHelper(name).minVersion;
	}
	function getDependencies(name) {
	  return loadHelper(name).getDependencies();
	}
	function ensure(name, newFileClass) {
	  FileClass || (FileClass = newFileClass);
	  loadHelper(name);
	}
	lib$i.list = Object.keys(_helpers.default).map(name => name.replace(/^_/, ""));
	lib$i.default = get;

	
	return lib$i;
}

var lib$4 = {};

var lib$3 = {};

var importInjector = {};

var importBuilder = {};

var hasRequiredImportBuilder;

function requireImportBuilder () {
	if (hasRequiredImportBuilder) return importBuilder;
	hasRequiredImportBuilder = 1;

	Object.defineProperty(importBuilder, "__esModule", {
	  value: true
	});
	importBuilder.default = void 0;
	var _assert = require$$0__default$5["default"];
	var _t = requireLib$h();
	const {
	  callExpression,
	  cloneNode,
	  expressionStatement,
	  identifier,
	  importDeclaration,
	  importDefaultSpecifier,
	  importNamespaceSpecifier,
	  importSpecifier,
	  memberExpression,
	  stringLiteral,
	  variableDeclaration,
	  variableDeclarator
	} = _t;
	class ImportBuilder {
	  constructor(importedSource, scope, hub) {
	    this._statements = [];
	    this._resultName = null;
	    this._importedSource = void 0;
	    this._scope = scope;
	    this._hub = hub;
	    this._importedSource = importedSource;
	  }
	  done() {
	    return {
	      statements: this._statements,
	      resultName: this._resultName
	    };
	  }
	  import() {
	    this._statements.push(importDeclaration([], stringLiteral(this._importedSource)));
	    return this;
	  }
	  require() {
	    this._statements.push(expressionStatement(callExpression(identifier("require"), [stringLiteral(this._importedSource)])));
	    return this;
	  }
	  namespace(name = "namespace") {
	    const local = this._scope.generateUidIdentifier(name);
	    const statement = this._statements[this._statements.length - 1];
	    _assert(statement.type === "ImportDeclaration");
	    _assert(statement.specifiers.length === 0);
	    statement.specifiers = [importNamespaceSpecifier(local)];
	    this._resultName = cloneNode(local);
	    return this;
	  }
	  default(name) {
	    const id = this._scope.generateUidIdentifier(name);
	    const statement = this._statements[this._statements.length - 1];
	    _assert(statement.type === "ImportDeclaration");
	    _assert(statement.specifiers.length === 0);
	    statement.specifiers = [importDefaultSpecifier(id)];
	    this._resultName = cloneNode(id);
	    return this;
	  }
	  named(name, importName) {
	    if (importName === "default") return this.default(name);
	    const id = this._scope.generateUidIdentifier(name);
	    const statement = this._statements[this._statements.length - 1];
	    _assert(statement.type === "ImportDeclaration");
	    _assert(statement.specifiers.length === 0);
	    statement.specifiers = [importSpecifier(id, identifier(importName))];
	    this._resultName = cloneNode(id);
	    return this;
	  }
	  var(name) {
	    const id = this._scope.generateUidIdentifier(name);
	    let statement = this._statements[this._statements.length - 1];
	    if (statement.type !== "ExpressionStatement") {
	      _assert(this._resultName);
	      statement = expressionStatement(this._resultName);
	      this._statements.push(statement);
	    }
	    this._statements[this._statements.length - 1] = variableDeclaration("var", [variableDeclarator(id, statement.expression)]);
	    this._resultName = cloneNode(id);
	    return this;
	  }
	  defaultInterop() {
	    return this._interop(this._hub.addHelper("interopRequireDefault"));
	  }
	  wildcardInterop() {
	    return this._interop(this._hub.addHelper("interopRequireWildcard"));
	  }
	  _interop(callee) {
	    const statement = this._statements[this._statements.length - 1];
	    if (statement.type === "ExpressionStatement") {
	      statement.expression = callExpression(callee, [statement.expression]);
	    } else if (statement.type === "VariableDeclaration") {
	      _assert(statement.declarations.length === 1);
	      statement.declarations[0].init = callExpression(callee, [statement.declarations[0].init]);
	    } else {
	      _assert.fail("Unexpected type.");
	    }
	    return this;
	  }
	  prop(name) {
	    const statement = this._statements[this._statements.length - 1];
	    if (statement.type === "ExpressionStatement") {
	      statement.expression = memberExpression(statement.expression, identifier(name));
	    } else if (statement.type === "VariableDeclaration") {
	      _assert(statement.declarations.length === 1);
	      statement.declarations[0].init = memberExpression(statement.declarations[0].init, identifier(name));
	    } else {
	      _assert.fail("Unexpected type:" + statement.type);
	    }
	    return this;
	  }
	  read(name) {
	    this._resultName = memberExpression(this._resultName, identifier(name));
	  }
	}
	importBuilder.default = ImportBuilder;

	
	return importBuilder;
}

var isModule = {};

var hasRequiredIsModule;

function requireIsModule () {
	if (hasRequiredIsModule) return isModule;
	hasRequiredIsModule = 1;

	Object.defineProperty(isModule, "__esModule", {
	  value: true
	});
	isModule.default = isModule$1;
	function isModule$1(path) {
	  return path.node.sourceType === "module";
	}

	
	return isModule;
}

var hasRequiredImportInjector;

function requireImportInjector () {
	if (hasRequiredImportInjector) return importInjector;
	hasRequiredImportInjector = 1;

	Object.defineProperty(importInjector, "__esModule", {
	  value: true
	});
	importInjector.default = void 0;
	var _assert = require$$0__default$5["default"];
	var _t = requireLib$h();
	var _importBuilder = requireImportBuilder();
	var _isModule = requireIsModule();
	const {
	  identifier,
	  importSpecifier,
	  numericLiteral,
	  sequenceExpression,
	  isImportDeclaration
	} = _t;
	class ImportInjector {
	  constructor(path, importedSource, opts) {
	    this._defaultOpts = {
	      importedSource: null,
	      importedType: "commonjs",
	      importedInterop: "babel",
	      importingInterop: "babel",
	      ensureLiveReference: false,
	      ensureNoContext: false,
	      importPosition: "before"
	    };
	    const programPath = path.find(p => p.isProgram());
	    this._programPath = programPath;
	    this._programScope = programPath.scope;
	    this._hub = programPath.hub;
	    this._defaultOpts = this._applyDefaults(importedSource, opts, true);
	  }
	  addDefault(importedSourceIn, opts) {
	    return this.addNamed("default", importedSourceIn, opts);
	  }
	  addNamed(importName, importedSourceIn, opts) {
	    _assert(typeof importName === "string");
	    return this._generateImport(this._applyDefaults(importedSourceIn, opts), importName);
	  }
	  addNamespace(importedSourceIn, opts) {
	    return this._generateImport(this._applyDefaults(importedSourceIn, opts), null);
	  }
	  addSideEffect(importedSourceIn, opts) {
	    return this._generateImport(this._applyDefaults(importedSourceIn, opts), void 0);
	  }
	  _applyDefaults(importedSource, opts, isInit = false) {
	    let newOpts;
	    if (typeof importedSource === "string") {
	      newOpts = Object.assign({}, this._defaultOpts, {
	        importedSource
	      }, opts);
	    } else {
	      _assert(!opts, "Unexpected secondary arguments.");
	      newOpts = Object.assign({}, this._defaultOpts, importedSource);
	    }
	    if (!isInit && opts) {
	      if (opts.nameHint !== undefined) newOpts.nameHint = opts.nameHint;
	      if (opts.blockHoist !== undefined) newOpts.blockHoist = opts.blockHoist;
	    }
	    return newOpts;
	  }
	  _generateImport(opts, importName) {
	    const isDefault = importName === "default";
	    const isNamed = !!importName && !isDefault;
	    const isNamespace = importName === null;
	    const {
	      importedSource,
	      importedType,
	      importedInterop,
	      importingInterop,
	      ensureLiveReference,
	      ensureNoContext,
	      nameHint,
	      importPosition,
	      blockHoist
	    } = opts;
	    let name = nameHint || importName;
	    const isMod = (0, _isModule.default)(this._programPath);
	    const isModuleForNode = isMod && importingInterop === "node";
	    const isModuleForBabel = isMod && importingInterop === "babel";
	    if (importPosition === "after" && !isMod) {
	      throw new Error(`"importPosition": "after" is only supported in modules`);
	    }
	    const builder = new _importBuilder.default(importedSource, this._programScope, this._hub);
	    if (importedType === "es6") {
	      if (!isModuleForNode && !isModuleForBabel) {
	        throw new Error("Cannot import an ES6 module from CommonJS");
	      }
	      builder.import();
	      if (isNamespace) {
	        builder.namespace(nameHint || importedSource);
	      } else if (isDefault || isNamed) {
	        builder.named(name, importName);
	      }
	    } else if (importedType !== "commonjs") {
	      throw new Error(`Unexpected interopType "${importedType}"`);
	    } else if (importedInterop === "babel") {
	      if (isModuleForNode) {
	        name = name !== "default" ? name : importedSource;
	        const es6Default = `${importedSource}$es6Default`;
	        builder.import();
	        if (isNamespace) {
	          builder.default(es6Default).var(name || importedSource).wildcardInterop();
	        } else if (isDefault) {
	          if (ensureLiveReference) {
	            builder.default(es6Default).var(name || importedSource).defaultInterop().read("default");
	          } else {
	            builder.default(es6Default).var(name).defaultInterop().prop(importName);
	          }
	        } else if (isNamed) {
	          builder.default(es6Default).read(importName);
	        }
	      } else if (isModuleForBabel) {
	        builder.import();
	        if (isNamespace) {
	          builder.namespace(name || importedSource);
	        } else if (isDefault || isNamed) {
	          builder.named(name, importName);
	        }
	      } else {
	        builder.require();
	        if (isNamespace) {
	          builder.var(name || importedSource).wildcardInterop();
	        } else if ((isDefault || isNamed) && ensureLiveReference) {
	          if (isDefault) {
	            name = name !== "default" ? name : importedSource;
	            builder.var(name).read(importName);
	            builder.defaultInterop();
	          } else {
	            builder.var(importedSource).read(importName);
	          }
	        } else if (isDefault) {
	          builder.var(name).defaultInterop().prop(importName);
	        } else if (isNamed) {
	          builder.var(name).prop(importName);
	        }
	      }
	    } else if (importedInterop === "compiled") {
	      if (isModuleForNode) {
	        builder.import();
	        if (isNamespace) {
	          builder.default(name || importedSource);
	        } else if (isDefault || isNamed) {
	          builder.default(importedSource).read(name);
	        }
	      } else if (isModuleForBabel) {
	        builder.import();
	        if (isNamespace) {
	          builder.namespace(name || importedSource);
	        } else if (isDefault || isNamed) {
	          builder.named(name, importName);
	        }
	      } else {
	        builder.require();
	        if (isNamespace) {
	          builder.var(name || importedSource);
	        } else if (isDefault || isNamed) {
	          if (ensureLiveReference) {
	            builder.var(importedSource).read(name);
	          } else {
	            builder.prop(importName).var(name);
	          }
	        }
	      }
	    } else if (importedInterop === "uncompiled") {
	      if (isDefault && ensureLiveReference) {
	        throw new Error("No live reference for commonjs default");
	      }
	      if (isModuleForNode) {
	        builder.import();
	        if (isNamespace) {
	          builder.default(name || importedSource);
	        } else if (isDefault) {
	          builder.default(name);
	        } else if (isNamed) {
	          builder.default(importedSource).read(name);
	        }
	      } else if (isModuleForBabel) {
	        builder.import();
	        if (isNamespace) {
	          builder.default(name || importedSource);
	        } else if (isDefault) {
	          builder.default(name);
	        } else if (isNamed) {
	          builder.named(name, importName);
	        }
	      } else {
	        builder.require();
	        if (isNamespace) {
	          builder.var(name || importedSource);
	        } else if (isDefault) {
	          builder.var(name);
	        } else if (isNamed) {
	          if (ensureLiveReference) {
	            builder.var(importedSource).read(name);
	          } else {
	            builder.var(name).prop(importName);
	          }
	        }
	      }
	    } else {
	      throw new Error(`Unknown importedInterop "${importedInterop}".`);
	    }
	    const {
	      statements,
	      resultName
	    } = builder.done();
	    this._insertStatements(statements, importPosition, blockHoist);
	    if ((isDefault || isNamed) && ensureNoContext && resultName.type !== "Identifier") {
	      return sequenceExpression([numericLiteral(0), resultName]);
	    }
	    return resultName;
	  }
	  _insertStatements(statements, importPosition = "before", blockHoist = 3) {
	    if (importPosition === "after") {
	      if (this._insertStatementsAfter(statements)) return;
	    } else {
	      if (this._insertStatementsBefore(statements, blockHoist)) return;
	    }
	    this._programPath.unshiftContainer("body", statements);
	  }
	  _insertStatementsBefore(statements, blockHoist) {
	    if (statements.length === 1 && isImportDeclaration(statements[0]) && isValueImport(statements[0])) {
	      const firstImportDecl = this._programPath.get("body").find(p => {
	        return p.isImportDeclaration() && isValueImport(p.node);
	      });
	      if ((firstImportDecl == null ? void 0 : firstImportDecl.node.source.value) === statements[0].source.value && maybeAppendImportSpecifiers(firstImportDecl.node, statements[0])) {
	        return true;
	      }
	    }
	    statements.forEach(node => {
	      node._blockHoist = blockHoist;
	    });
	    const targetPath = this._programPath.get("body").find(p => {
	      const val = p.node._blockHoist;
	      return Number.isFinite(val) && val < 4;
	    });
	    if (targetPath) {
	      targetPath.insertBefore(statements);
	      return true;
	    }
	    return false;
	  }
	  _insertStatementsAfter(statements) {
	    const statementsSet = new Set(statements);
	    const importDeclarations = new Map();
	    for (const statement of statements) {
	      if (isImportDeclaration(statement) && isValueImport(statement)) {
	        const source = statement.source.value;
	        if (!importDeclarations.has(source)) importDeclarations.set(source, []);
	        importDeclarations.get(source).push(statement);
	      }
	    }
	    let lastImportPath = null;
	    for (const bodyStmt of this._programPath.get("body")) {
	      if (bodyStmt.isImportDeclaration() && isValueImport(bodyStmt.node)) {
	        lastImportPath = bodyStmt;
	        const source = bodyStmt.node.source.value;
	        const newImports = importDeclarations.get(source);
	        if (!newImports) continue;
	        for (const decl of newImports) {
	          if (!statementsSet.has(decl)) continue;
	          if (maybeAppendImportSpecifiers(bodyStmt.node, decl)) {
	            statementsSet.delete(decl);
	          }
	        }
	      }
	    }
	    if (statementsSet.size === 0) return true;
	    if (lastImportPath) lastImportPath.insertAfter(Array.from(statementsSet));
	    return !!lastImportPath;
	  }
	}
	importInjector.default = ImportInjector;
	function isValueImport(node) {
	  return node.importKind !== "type" && node.importKind !== "typeof";
	}
	function hasNamespaceImport(node) {
	  return node.specifiers.length === 1 && node.specifiers[0].type === "ImportNamespaceSpecifier" || node.specifiers.length === 2 && node.specifiers[1].type === "ImportNamespaceSpecifier";
	}
	function hasDefaultImport(node) {
	  return node.specifiers.length > 0 && node.specifiers[0].type === "ImportDefaultSpecifier";
	}
	function maybeAppendImportSpecifiers(target, source) {
	  if (!target.specifiers.length) {
	    target.specifiers = source.specifiers;
	    return true;
	  }
	  if (!source.specifiers.length) return true;
	  if (hasNamespaceImport(target) || hasNamespaceImport(source)) return false;
	  if (hasDefaultImport(source)) {
	    if (hasDefaultImport(target)) {
	      source.specifiers[0] = importSpecifier(source.specifiers[0].local, identifier("default"));
	    } else {
	      target.specifiers.unshift(source.specifiers.shift());
	    }
	  }
	  target.specifiers.push(...source.specifiers);
	  return true;
	}

	
	return importInjector;
}

var hasRequiredLib$5;

function requireLib$5 () {
	if (hasRequiredLib$5) return lib$3;
	hasRequiredLib$5 = 1;
	(function (exports) {

		Object.defineProperty(exports, "__esModule", {
		  value: true
		});
		Object.defineProperty(exports, "ImportInjector", {
		  enumerable: true,
		  get: function () {
		    return _importInjector.default;
		  }
		});
		exports.addDefault = addDefault;
		exports.addNamed = addNamed;
		exports.addNamespace = addNamespace;
		exports.addSideEffect = addSideEffect;
		Object.defineProperty(exports, "isModule", {
		  enumerable: true,
		  get: function () {
		    return _isModule.default;
		  }
		});
		var _importInjector = requireImportInjector();
		var _isModule = requireIsModule();
		function addDefault(path, importedSource, opts) {
		  return new _importInjector.default(path).addDefault(importedSource, opts);
		}
		function addNamed(path, name, importedSource, opts) {
		  return new _importInjector.default(path).addNamed(name, importedSource, opts);
		}
		function addNamespace(path, importedSource, opts) {
		  return new _importInjector.default(path).addNamespace(importedSource, opts);
		}
		function addSideEffect(path, importedSource, opts) {
		  return new _importInjector.default(path).addSideEffect(importedSource, opts);
		}

		
	} (lib$3));
	return lib$3;
}

var rewriteThis = {};

var hasRequiredRewriteThis;

function requireRewriteThis () {
	if (hasRequiredRewriteThis) return rewriteThis;
	hasRequiredRewriteThis = 1;

	Object.defineProperty(rewriteThis, "__esModule", {
	  value: true
	});
	rewriteThis.default = rewriteThis$1;
	var _helperEnvironmentVisitor = requireLib$f();
	var _core = requireLib();
	const {
	  numericLiteral,
	  unaryExpression
	} = _core.types;
	const rewriteThisVisitor = _core.traverse.visitors.merge([_helperEnvironmentVisitor.default, {
	  ThisExpression(path) {
	    path.replaceWith(unaryExpression("void", numericLiteral(0), true));
	  }
	}]);
	function rewriteThis$1(programPath) {
	  (0, _core.traverse)(programPath.node, Object.assign({}, rewriteThisVisitor, {
	    noScope: true
	  }));
	}

	
	return rewriteThis;
}

var rewriteLiveReferences = {};

var lib$2 = {};

var hasRequiredLib$4;

function requireLib$4 () {
	if (hasRequiredLib$4) return lib$2;
	hasRequiredLib$4 = 1;

	Object.defineProperty(lib$2, "__esModule", {
	  value: true
	});
	lib$2.default = simplifyAccess;
	var _t = requireLib$h();
	const {
	  LOGICAL_OPERATORS,
	  assignmentExpression,
	  binaryExpression,
	  cloneNode,
	  identifier,
	  logicalExpression,
	  numericLiteral,
	  sequenceExpression,
	  unaryExpression
	} = _t;
	const simpleAssignmentVisitor = {
	  AssignmentExpression: {
	    exit(path) {
	      const {
	        scope,
	        seen,
	        bindingNames
	      } = this;
	      if (path.node.operator === "=") return;
	      if (seen.has(path.node)) return;
	      seen.add(path.node);
	      const left = path.get("left");
	      if (!left.isIdentifier()) return;
	      const localName = left.node.name;
	      if (!bindingNames.has(localName)) return;
	      if (scope.getBinding(localName) !== path.scope.getBinding(localName)) {
	        return;
	      }
	      const operator = path.node.operator.slice(0, -1);
	      if (LOGICAL_OPERATORS.includes(operator)) {
	        path.replaceWith(logicalExpression(operator, path.node.left, assignmentExpression("=", cloneNode(path.node.left), path.node.right)));
	      } else {
	        path.node.right = binaryExpression(operator, cloneNode(path.node.left), path.node.right);
	        path.node.operator = "=";
	      }
	    }
	  }
	};
	{
	  simpleAssignmentVisitor.UpdateExpression = {
	    exit(path) {
	      if (!this.includeUpdateExpression) return;
	      const {
	        scope,
	        bindingNames
	      } = this;
	      const arg = path.get("argument");
	      if (!arg.isIdentifier()) return;
	      const localName = arg.node.name;
	      if (!bindingNames.has(localName)) return;
	      if (scope.getBinding(localName) !== path.scope.getBinding(localName)) {
	        return;
	      }
	      if (path.parentPath.isExpressionStatement() && !path.isCompletionRecord()) {
	        const operator = path.node.operator === "++" ? "+=" : "-=";
	        path.replaceWith(assignmentExpression(operator, arg.node, numericLiteral(1)));
	      } else if (path.node.prefix) {
	        path.replaceWith(assignmentExpression("=", identifier(localName), binaryExpression(path.node.operator[0], unaryExpression("+", arg.node), numericLiteral(1))));
	      } else {
	        const old = path.scope.generateUidIdentifierBasedOnNode(arg.node, "old");
	        const varName = old.name;
	        path.scope.push({
	          id: old
	        });
	        const binary = binaryExpression(path.node.operator[0], identifier(varName), numericLiteral(1));
	        path.replaceWith(sequenceExpression([assignmentExpression("=", identifier(varName), unaryExpression("+", arg.node)), assignmentExpression("=", cloneNode(arg.node), binary), identifier(varName)]));
	      }
	    }
	  };
	}
	function simplifyAccess(path, bindingNames) {
	  {
	    var _arguments$;
	    path.traverse(simpleAssignmentVisitor, {
	      scope: path.scope,
	      bindingNames,
	      seen: new WeakSet(),
	      includeUpdateExpression: (_arguments$ = arguments[2]) != null ? _arguments$ : true
	    });
	  }
	}

	
	return lib$2;
}

var hasRequiredRewriteLiveReferences;

function requireRewriteLiveReferences () {
	if (hasRequiredRewriteLiveReferences) return rewriteLiveReferences;
	hasRequiredRewriteLiveReferences = 1;

	Object.defineProperty(rewriteLiveReferences, "__esModule", {
	  value: true
	});
	rewriteLiveReferences.default = rewriteLiveReferences$1;
	var _assert = require$$0__default$5["default"];
	var _core = requireLib();
	var _helperSimpleAccess = requireLib$4();
	const {
	  assignmentExpression,
	  cloneNode,
	  expressionStatement,
	  getOuterBindingIdentifiers,
	  identifier,
	  isArrowFunctionExpression,
	  isClassExpression,
	  isFunctionExpression,
	  isIdentifier,
	  isMemberExpression,
	  isVariableDeclaration,
	  jsxIdentifier,
	  jsxMemberExpression,
	  memberExpression,
	  numericLiteral,
	  sequenceExpression,
	  stringLiteral,
	  variableDeclaration,
	  variableDeclarator
	} = _core.types;
	function isInType(path) {
	  do {
	    switch (path.parent.type) {
	      case "TSTypeAnnotation":
	      case "TSTypeAliasDeclaration":
	      case "TSTypeReference":
	      case "TypeAnnotation":
	      case "TypeAlias":
	        return true;
	      case "ExportSpecifier":
	        return path.parentPath.parent.exportKind === "type";
	      default:
	        if (path.parentPath.isStatement() || path.parentPath.isExpression()) {
	          return false;
	        }
	    }
	  } while (path = path.parentPath);
	}
	function rewriteLiveReferences$1(programPath, metadata, wrapReference) {
	  const imported = new Map();
	  const exported = new Map();
	  const requeueInParent = path => {
	    programPath.requeue(path);
	  };
	  for (const [source, data] of metadata.source) {
	    for (const [localName, importName] of data.imports) {
	      imported.set(localName, [source, importName, null]);
	    }
	    for (const localName of data.importsNamespace) {
	      imported.set(localName, [source, null, localName]);
	    }
	  }
	  for (const [local, data] of metadata.local) {
	    let exportMeta = exported.get(local);
	    if (!exportMeta) {
	      exportMeta = [];
	      exported.set(local, exportMeta);
	    }
	    exportMeta.push(...data.names);
	  }
	  const rewriteBindingInitVisitorState = {
	    metadata,
	    requeueInParent,
	    scope: programPath.scope,
	    exported
	  };
	  programPath.traverse(rewriteBindingInitVisitor, rewriteBindingInitVisitorState);
	  const bindingNames = new Set([...Array.from(imported.keys()), ...Array.from(exported.keys())]);
	  {
	    (0, _helperSimpleAccess.default)(programPath, bindingNames, false);
	  }
	  const rewriteReferencesVisitorState = {
	    seen: new WeakSet(),
	    metadata,
	    requeueInParent,
	    scope: programPath.scope,
	    imported,
	    exported,
	    buildImportReference([source, importName, localName], identNode) {
	      const meta = metadata.source.get(source);
	      meta.referenced = true;
	      if (localName) {
	        if (meta.wrap) {
	          var _wrapReference;
	          identNode = (_wrapReference = wrapReference(identNode, meta.wrap)) != null ? _wrapReference : identNode;
	        }
	        return identNode;
	      }
	      let namespace = identifier(meta.name);
	      if (meta.wrap) {
	        var _wrapReference2;
	        namespace = (_wrapReference2 = wrapReference(namespace, meta.wrap)) != null ? _wrapReference2 : namespace;
	      }
	      if (importName === "default" && meta.interop === "node-default") {
	        return namespace;
	      }
	      const computed = metadata.stringSpecifiers.has(importName);
	      return memberExpression(namespace, computed ? stringLiteral(importName) : identifier(importName), computed);
	    }
	  };
	  programPath.traverse(rewriteReferencesVisitor, rewriteReferencesVisitorState);
	}
	const rewriteBindingInitVisitor = {
	  Scope(path) {
	    path.skip();
	  },
	  ClassDeclaration(path) {
	    const {
	      requeueInParent,
	      exported,
	      metadata
	    } = this;
	    const {
	      id
	    } = path.node;
	    if (!id) throw new Error("Expected class to have a name");
	    const localName = id.name;
	    const exportNames = exported.get(localName) || [];
	    if (exportNames.length > 0) {
	      const statement = expressionStatement(buildBindingExportAssignmentExpression(metadata, exportNames, identifier(localName), path.scope));
	      statement._blockHoist = path.node._blockHoist;
	      requeueInParent(path.insertAfter(statement)[0]);
	    }
	  },
	  VariableDeclaration(path) {
	    const {
	      requeueInParent,
	      exported,
	      metadata
	    } = this;
	    const isVar = path.node.kind === "var";
	    for (const decl of path.get("declarations")) {
	      const {
	        id
	      } = decl.node;
	      let {
	        init
	      } = decl.node;
	      if (isIdentifier(id) && exported.has(id.name) && !isArrowFunctionExpression(init) && (!isFunctionExpression(init) || init.id) && (!isClassExpression(init) || init.id)) {
	        if (!init) {
	          if (isVar) {
	            continue;
	          } else {
	            init = path.scope.buildUndefinedNode();
	          }
	        }
	        decl.node.init = buildBindingExportAssignmentExpression(metadata, exported.get(id.name), init, path.scope);
	        requeueInParent(decl.get("init"));
	      } else {
	        for (const localName of Object.keys(decl.getOuterBindingIdentifiers())) {
	          if (exported.has(localName)) {
	            const statement = expressionStatement(buildBindingExportAssignmentExpression(metadata, exported.get(localName), identifier(localName), path.scope));
	            statement._blockHoist = path.node._blockHoist;
	            requeueInParent(path.insertAfter(statement)[0]);
	          }
	        }
	      }
	    }
	  }
	};
	const buildBindingExportAssignmentExpression = (metadata, exportNames, localExpr, scope) => {
	  const exportsObjectName = metadata.exportName;
	  for (let currentScope = scope; currentScope != null; currentScope = currentScope.parent) {
	    if (currentScope.hasOwnBinding(exportsObjectName)) {
	      currentScope.rename(exportsObjectName);
	    }
	  }
	  return (exportNames || []).reduce((expr, exportName) => {
	    const {
	      stringSpecifiers
	    } = metadata;
	    const computed = stringSpecifiers.has(exportName);
	    return assignmentExpression("=", memberExpression(identifier(exportsObjectName), computed ? stringLiteral(exportName) : identifier(exportName), computed), expr);
	  }, localExpr);
	};
	const buildImportThrow = localName => {
	  return _core.template.expression.ast`
    (function() {
      throw new Error('"' + '${localName}' + '" is read-only.');
    })()
  `;
	};
	const rewriteReferencesVisitor = {
	  ReferencedIdentifier(path) {
	    const {
	      seen,
	      buildImportReference,
	      scope,
	      imported,
	      requeueInParent
	    } = this;
	    if (seen.has(path.node)) return;
	    seen.add(path.node);
	    const localName = path.node.name;
	    const importData = imported.get(localName);
	    if (importData) {
	      if (isInType(path)) {
	        throw path.buildCodeFrameError(`Cannot transform the imported binding "${localName}" since it's also used in a type annotation. ` + `Please strip type annotations using @babel/preset-typescript or @babel/preset-flow.`);
	      }
	      const localBinding = path.scope.getBinding(localName);
	      const rootBinding = scope.getBinding(localName);
	      if (rootBinding !== localBinding) return;
	      const ref = buildImportReference(importData, path.node);
	      ref.loc = path.node.loc;
	      if ((path.parentPath.isCallExpression({
	        callee: path.node
	      }) || path.parentPath.isOptionalCallExpression({
	        callee: path.node
	      }) || path.parentPath.isTaggedTemplateExpression({
	        tag: path.node
	      })) && isMemberExpression(ref)) {
	        path.replaceWith(sequenceExpression([numericLiteral(0), ref]));
	      } else if (path.isJSXIdentifier() && isMemberExpression(ref)) {
	        const {
	          object,
	          property
	        } = ref;
	        path.replaceWith(jsxMemberExpression(jsxIdentifier(object.name), jsxIdentifier(property.name)));
	      } else {
	        path.replaceWith(ref);
	      }
	      requeueInParent(path);
	      path.skip();
	    }
	  },
	  UpdateExpression(path) {
	    const {
	      scope,
	      seen,
	      imported,
	      exported,
	      requeueInParent,
	      buildImportReference
	    } = this;
	    if (seen.has(path.node)) return;
	    seen.add(path.node);
	    const arg = path.get("argument");
	    if (arg.isMemberExpression()) return;
	    const update = path.node;
	    if (arg.isIdentifier()) {
	      const localName = arg.node.name;
	      if (scope.getBinding(localName) !== path.scope.getBinding(localName)) {
	        return;
	      }
	      const exportedNames = exported.get(localName);
	      const importData = imported.get(localName);
	      if ((exportedNames == null ? void 0 : exportedNames.length) > 0 || importData) {
	        if (importData) {
	          path.replaceWith(assignmentExpression(update.operator[0] + "=", buildImportReference(importData, arg.node), buildImportThrow(localName)));
	        } else if (update.prefix) {
	          path.replaceWith(buildBindingExportAssignmentExpression(this.metadata, exportedNames, cloneNode(update), path.scope));
	        } else {
	          const ref = scope.generateDeclaredUidIdentifier(localName);
	          path.replaceWith(sequenceExpression([assignmentExpression("=", cloneNode(ref), cloneNode(update)), buildBindingExportAssignmentExpression(this.metadata, exportedNames, identifier(localName), path.scope), cloneNode(ref)]));
	        }
	      }
	    }
	    requeueInParent(path);
	    path.skip();
	  },
	  AssignmentExpression: {
	    exit(path) {
	      const {
	        scope,
	        seen,
	        imported,
	        exported,
	        requeueInParent,
	        buildImportReference
	      } = this;
	      if (seen.has(path.node)) return;
	      seen.add(path.node);
	      const left = path.get("left");
	      if (left.isMemberExpression()) return;
	      if (left.isIdentifier()) {
	        const localName = left.node.name;
	        if (scope.getBinding(localName) !== path.scope.getBinding(localName)) {
	          return;
	        }
	        const exportedNames = exported.get(localName);
	        const importData = imported.get(localName);
	        if ((exportedNames == null ? void 0 : exportedNames.length) > 0 || importData) {
	          _assert(path.node.operator === "=", "Path was not simplified");
	          const assignment = path.node;
	          if (importData) {
	            assignment.left = buildImportReference(importData, left.node);
	            assignment.right = sequenceExpression([assignment.right, buildImportThrow(localName)]);
	          }
	          path.replaceWith(buildBindingExportAssignmentExpression(this.metadata, exportedNames, assignment, path.scope));
	          requeueInParent(path);
	        }
	      } else {
	        const ids = left.getOuterBindingIdentifiers();
	        const programScopeIds = Object.keys(ids).filter(localName => scope.getBinding(localName) === path.scope.getBinding(localName));
	        const id = programScopeIds.find(localName => imported.has(localName));
	        if (id) {
	          path.node.right = sequenceExpression([path.node.right, buildImportThrow(id)]);
	        }
	        const items = [];
	        programScopeIds.forEach(localName => {
	          const exportedNames = exported.get(localName) || [];
	          if (exportedNames.length > 0) {
	            items.push(buildBindingExportAssignmentExpression(this.metadata, exportedNames, identifier(localName), path.scope));
	          }
	        });
	        if (items.length > 0) {
	          let node = sequenceExpression(items);
	          if (path.parentPath.isExpressionStatement()) {
	            node = expressionStatement(node);
	            node._blockHoist = path.parentPath.node._blockHoist;
	          }
	          const statement = path.insertAfter(node)[0];
	          requeueInParent(statement);
	        }
	      }
	    }
	  },
	  "ForOfStatement|ForInStatement"(path) {
	    const {
	      scope,
	      node
	    } = path;
	    const {
	      left
	    } = node;
	    const {
	      exported,
	      imported,
	      scope: programScope
	    } = this;
	    if (!isVariableDeclaration(left)) {
	      let didTransformExport = false,
	        importConstViolationName;
	      const loopBodyScope = path.get("body").scope;
	      for (const name of Object.keys(getOuterBindingIdentifiers(left))) {
	        if (programScope.getBinding(name) === scope.getBinding(name)) {
	          if (exported.has(name)) {
	            didTransformExport = true;
	            if (loopBodyScope.hasOwnBinding(name)) {
	              loopBodyScope.rename(name);
	            }
	          }
	          if (imported.has(name) && !importConstViolationName) {
	            importConstViolationName = name;
	          }
	        }
	      }
	      if (!didTransformExport && !importConstViolationName) {
	        return;
	      }
	      path.ensureBlock();
	      const bodyPath = path.get("body");
	      const newLoopId = scope.generateUidIdentifierBasedOnNode(left);
	      path.get("left").replaceWith(variableDeclaration("let", [variableDeclarator(cloneNode(newLoopId))]));
	      scope.registerDeclaration(path.get("left"));
	      if (didTransformExport) {
	        bodyPath.unshiftContainer("body", expressionStatement(assignmentExpression("=", left, newLoopId)));
	      }
	      if (importConstViolationName) {
	        bodyPath.unshiftContainer("body", expressionStatement(buildImportThrow(importConstViolationName)));
	      }
	    }
	  }
	};

	
	return rewriteLiveReferences;
}

var normalizeAndLoadMetadata = {};

var hasRequiredNormalizeAndLoadMetadata;

function requireNormalizeAndLoadMetadata () {
	if (hasRequiredNormalizeAndLoadMetadata) return normalizeAndLoadMetadata;
	hasRequiredNormalizeAndLoadMetadata = 1;

	Object.defineProperty(normalizeAndLoadMetadata, "__esModule", {
	  value: true
	});
	normalizeAndLoadMetadata.default = normalizeModuleAndLoadMetadata;
	normalizeAndLoadMetadata.hasExports = hasExports;
	normalizeAndLoadMetadata.isSideEffectImport = isSideEffectImport;
	normalizeAndLoadMetadata.validateImportInteropOption = validateImportInteropOption;
	var _path = path__default["default"];
	var _helperValidatorIdentifier = requireLib$j();
	var _helperSplitExportDeclaration = requireLib$g();
	function hasExports(metadata) {
	  return metadata.hasExports;
	}
	function isSideEffectImport(source) {
	  return source.imports.size === 0 && source.importsNamespace.size === 0 && source.reexports.size === 0 && source.reexportNamespace.size === 0 && !source.reexportAll;
	}
	function validateImportInteropOption(importInterop) {
	  if (typeof importInterop !== "function" && importInterop !== "none" && importInterop !== "babel" && importInterop !== "node") {
	    throw new Error(`.importInterop must be one of "none", "babel", "node", or a function returning one of those values (received ${importInterop}).`);
	  }
	  return importInterop;
	}
	function resolveImportInterop(importInterop, source, filename) {
	  if (typeof importInterop === "function") {
	    return validateImportInteropOption(importInterop(source, filename));
	  }
	  return importInterop;
	}
	function normalizeModuleAndLoadMetadata(programPath, exportName, {
	  importInterop,
	  initializeReexports = false,
	  getWrapperPayload,
	  esNamespaceOnly = false,
	  filename
	}) {
	  if (!exportName) {
	    exportName = programPath.scope.generateUidIdentifier("exports").name;
	  }
	  const stringSpecifiers = new Set();
	  nameAnonymousExports(programPath);
	  const {
	    local,
	    sources,
	    hasExports
	  } = getModuleMetadata(programPath, {
	    initializeReexports,
	    getWrapperPayload
	  }, stringSpecifiers);
	  removeImportExportDeclarations(programPath);
	  for (const [source, metadata] of sources) {
	    const {
	      importsNamespace,
	      imports
	    } = metadata;
	    if (importsNamespace.size > 0 && imports.size === 0) {
	      const [nameOfnamespace] = importsNamespace;
	      metadata.name = nameOfnamespace;
	    }
	    const resolvedInterop = resolveImportInterop(importInterop, source, filename);
	    if (resolvedInterop === "none") {
	      metadata.interop = "none";
	    } else if (resolvedInterop === "node" && metadata.interop === "namespace") {
	      metadata.interop = "node-namespace";
	    } else if (resolvedInterop === "node" && metadata.interop === "default") {
	      metadata.interop = "node-default";
	    } else if (esNamespaceOnly && metadata.interop === "namespace") {
	      metadata.interop = "default";
	    }
	  }
	  return {
	    exportName,
	    exportNameListName: null,
	    hasExports,
	    local,
	    source: sources,
	    stringSpecifiers
	  };
	}
	function getExportSpecifierName(path, stringSpecifiers) {
	  if (path.isIdentifier()) {
	    return path.node.name;
	  } else if (path.isStringLiteral()) {
	    const stringValue = path.node.value;
	    if (!(0, _helperValidatorIdentifier.isIdentifierName)(stringValue)) {
	      stringSpecifiers.add(stringValue);
	    }
	    return stringValue;
	  } else {
	    throw new Error(`Expected export specifier to be either Identifier or StringLiteral, got ${path.node.type}`);
	  }
	}
	function assertExportSpecifier(path) {
	  if (path.isExportSpecifier()) {
	    return;
	  } else if (path.isExportNamespaceSpecifier()) {
	    throw path.buildCodeFrameError("Export namespace should be first transformed by `@babel/plugin-transform-export-namespace-from`.");
	  } else {
	    throw path.buildCodeFrameError("Unexpected export specifier type");
	  }
	}
	function getModuleMetadata(programPath, {
	  getWrapperPayload,
	  initializeReexports
	}, stringSpecifiers) {
	  const localData = getLocalExportMetadata(programPath, initializeReexports, stringSpecifiers);
	  const importNodes = new Map();
	  const sourceData = new Map();
	  const getData = (sourceNode, node) => {
	    const source = sourceNode.value;
	    let data = sourceData.get(source);
	    if (!data) {
	      data = {
	        name: programPath.scope.generateUidIdentifier((0, _path.basename)(source, (0, _path.extname)(source))).name,
	        interop: "none",
	        loc: null,
	        imports: new Map(),
	        importsNamespace: new Set(),
	        reexports: new Map(),
	        reexportNamespace: new Set(),
	        reexportAll: null,
	        wrap: null,
	        get lazy() {
	          return this.wrap === "lazy";
	        },
	        referenced: false
	      };
	      sourceData.set(source, data);
	      importNodes.set(source, [node]);
	    } else {
	      importNodes.get(source).push(node);
	    }
	    return data;
	  };
	  let hasExports = false;
	  programPath.get("body").forEach(child => {
	    if (child.isImportDeclaration()) {
	      const data = getData(child.node.source, child.node);
	      if (!data.loc) data.loc = child.node.loc;
	      child.get("specifiers").forEach(spec => {
	        if (spec.isImportDefaultSpecifier()) {
	          const localName = spec.get("local").node.name;
	          data.imports.set(localName, "default");
	          const reexport = localData.get(localName);
	          if (reexport) {
	            localData.delete(localName);
	            reexport.names.forEach(name => {
	              data.reexports.set(name, "default");
	            });
	            data.referenced = true;
	          }
	        } else if (spec.isImportNamespaceSpecifier()) {
	          const localName = spec.get("local").node.name;
	          data.importsNamespace.add(localName);
	          const reexport = localData.get(localName);
	          if (reexport) {
	            localData.delete(localName);
	            reexport.names.forEach(name => {
	              data.reexportNamespace.add(name);
	            });
	            data.referenced = true;
	          }
	        } else if (spec.isImportSpecifier()) {
	          const importName = getExportSpecifierName(spec.get("imported"), stringSpecifiers);
	          const localName = spec.get("local").node.name;
	          data.imports.set(localName, importName);
	          const reexport = localData.get(localName);
	          if (reexport) {
	            localData.delete(localName);
	            reexport.names.forEach(name => {
	              data.reexports.set(name, importName);
	            });
	            data.referenced = true;
	          }
	        }
	      });
	    } else if (child.isExportAllDeclaration()) {
	      hasExports = true;
	      const data = getData(child.node.source, child.node);
	      if (!data.loc) data.loc = child.node.loc;
	      data.reexportAll = {
	        loc: child.node.loc
	      };
	      data.referenced = true;
	    } else if (child.isExportNamedDeclaration() && child.node.source) {
	      hasExports = true;
	      const data = getData(child.node.source, child.node);
	      if (!data.loc) data.loc = child.node.loc;
	      child.get("specifiers").forEach(spec => {
	        assertExportSpecifier(spec);
	        const importName = getExportSpecifierName(spec.get("local"), stringSpecifiers);
	        const exportName = getExportSpecifierName(spec.get("exported"), stringSpecifiers);
	        data.reexports.set(exportName, importName);
	        data.referenced = true;
	        if (exportName === "__esModule") {
	          throw spec.get("exported").buildCodeFrameError('Illegal export "__esModule".');
	        }
	      });
	    } else if (child.isExportNamedDeclaration() || child.isExportDefaultDeclaration()) {
	      hasExports = true;
	    }
	  });
	  for (const metadata of sourceData.values()) {
	    let needsDefault = false;
	    let needsNamed = false;
	    if (metadata.importsNamespace.size > 0) {
	      needsDefault = true;
	      needsNamed = true;
	    }
	    if (metadata.reexportAll) {
	      needsNamed = true;
	    }
	    for (const importName of metadata.imports.values()) {
	      if (importName === "default") needsDefault = true;else needsNamed = true;
	    }
	    for (const importName of metadata.reexports.values()) {
	      if (importName === "default") needsDefault = true;else needsNamed = true;
	    }
	    if (needsDefault && needsNamed) {
	      metadata.interop = "namespace";
	    } else if (needsDefault) {
	      metadata.interop = "default";
	    }
	  }
	  if (getWrapperPayload) {
	    for (const [source, metadata] of sourceData) {
	      metadata.wrap = getWrapperPayload(source, metadata, importNodes.get(source));
	    }
	  }
	  return {
	    hasExports,
	    local: localData,
	    sources: sourceData
	  };
	}
	function getLocalExportMetadata(programPath, initializeReexports, stringSpecifiers) {
	  const bindingKindLookup = new Map();
	  programPath.get("body").forEach(child => {
	    let kind;
	    if (child.isImportDeclaration()) {
	      kind = "import";
	    } else {
	      if (child.isExportDefaultDeclaration()) {
	        child = child.get("declaration");
	      }
	      if (child.isExportNamedDeclaration()) {
	        if (child.node.declaration) {
	          child = child.get("declaration");
	        } else if (initializeReexports && child.node.source && child.get("source").isStringLiteral()) {
	          child.get("specifiers").forEach(spec => {
	            assertExportSpecifier(spec);
	            bindingKindLookup.set(spec.get("local").node.name, "block");
	          });
	          return;
	        }
	      }
	      if (child.isFunctionDeclaration()) {
	        kind = "hoisted";
	      } else if (child.isClassDeclaration()) {
	        kind = "block";
	      } else if (child.isVariableDeclaration({
	        kind: "var"
	      })) {
	        kind = "var";
	      } else if (child.isVariableDeclaration()) {
	        kind = "block";
	      } else {
	        return;
	      }
	    }
	    Object.keys(child.getOuterBindingIdentifiers()).forEach(name => {
	      bindingKindLookup.set(name, kind);
	    });
	  });
	  const localMetadata = new Map();
	  const getLocalMetadata = idPath => {
	    const localName = idPath.node.name;
	    let metadata = localMetadata.get(localName);
	    if (!metadata) {
	      const kind = bindingKindLookup.get(localName);
	      if (kind === undefined) {
	        throw idPath.buildCodeFrameError(`Exporting local "${localName}", which is not declared.`);
	      }
	      metadata = {
	        names: [],
	        kind
	      };
	      localMetadata.set(localName, metadata);
	    }
	    return metadata;
	  };
	  programPath.get("body").forEach(child => {
	    if (child.isExportNamedDeclaration() && (initializeReexports || !child.node.source)) {
	      if (child.node.declaration) {
	        const declaration = child.get("declaration");
	        const ids = declaration.getOuterBindingIdentifierPaths();
	        Object.keys(ids).forEach(name => {
	          if (name === "__esModule") {
	            throw declaration.buildCodeFrameError('Illegal export "__esModule".');
	          }
	          getLocalMetadata(ids[name]).names.push(name);
	        });
	      } else {
	        child.get("specifiers").forEach(spec => {
	          const local = spec.get("local");
	          const exported = spec.get("exported");
	          const localMetadata = getLocalMetadata(local);
	          const exportName = getExportSpecifierName(exported, stringSpecifiers);
	          if (exportName === "__esModule") {
	            throw exported.buildCodeFrameError('Illegal export "__esModule".');
	          }
	          localMetadata.names.push(exportName);
	        });
	      }
	    } else if (child.isExportDefaultDeclaration()) {
	      const declaration = child.get("declaration");
	      if (declaration.isFunctionDeclaration() || declaration.isClassDeclaration()) {
	        getLocalMetadata(declaration.get("id")).names.push("default");
	      } else {
	        throw declaration.buildCodeFrameError("Unexpected default expression export.");
	      }
	    }
	  });
	  return localMetadata;
	}
	function nameAnonymousExports(programPath) {
	  programPath.get("body").forEach(child => {
	    if (!child.isExportDefaultDeclaration()) return;
	    (0, _helperSplitExportDeclaration.default)(child);
	  });
	}
	function removeImportExportDeclarations(programPath) {
	  programPath.get("body").forEach(child => {
	    if (child.isImportDeclaration()) {
	      child.remove();
	    } else if (child.isExportNamedDeclaration()) {
	      if (child.node.declaration) {
	        child.node.declaration._blockHoist = child.node._blockHoist;
	        child.replaceWith(child.node.declaration);
	      } else {
	        child.remove();
	      }
	    } else if (child.isExportDefaultDeclaration()) {
	      const declaration = child.get("declaration");
	      if (declaration.isFunctionDeclaration() || declaration.isClassDeclaration()) {
	        declaration._blockHoist = child.node._blockHoist;
	        child.replaceWith(declaration);
	      } else {
	        throw declaration.buildCodeFrameError("Unexpected default expression export.");
	      }
	    } else if (child.isExportAllDeclaration()) {
	      child.remove();
	    }
	  });
	}

	
	return normalizeAndLoadMetadata;
}

var lazyModules = {};

var hasRequiredLazyModules;

function requireLazyModules () {
	if (hasRequiredLazyModules) return lazyModules;
	hasRequiredLazyModules = 1;

	Object.defineProperty(lazyModules, "__esModule", {
	  value: true
	});
	lazyModules.toGetWrapperPayload = toGetWrapperPayload;
	lazyModules.wrapReference = wrapReference;
	var _core = requireLib();
	var _normalizeAndLoadMetadata = requireNormalizeAndLoadMetadata();
	function toGetWrapperPayload(lazy) {
	  return (source, metadata) => {
	    if (lazy === false) return null;
	    if ((0, _normalizeAndLoadMetadata.isSideEffectImport)(metadata) || metadata.reexportAll) return null;
	    if (lazy === true) {
	      return /\./.test(source) ? null : "lazy";
	    }
	    if (Array.isArray(lazy)) {
	      return lazy.indexOf(source) === -1 ? null : "lazy";
	    }
	    if (typeof lazy === "function") {
	      return lazy(source) ? "lazy" : null;
	    }
	    throw new Error(`.lazy must be a boolean, string array, or function`);
	  };
	}
	function wrapReference(ref, payload) {
	  if (payload === "lazy") return _core.types.callExpression(ref, []);
	  return null;
	}

	
	return lazyModules;
}

var dynamicImport = {};

var hasRequiredDynamicImport;

function requireDynamicImport () {
	if (hasRequiredDynamicImport) return dynamicImport;
	hasRequiredDynamicImport = 1;

	Object.defineProperty(dynamicImport, "__esModule", {
	  value: true
	});
	dynamicImport.buildDynamicImport = buildDynamicImport;
	var _core = requireLib();
	{
	  dynamicImport.getDynamicImportSource = function getDynamicImportSource(node) {
	    const [source] = node.arguments;
	    return _core.types.isStringLiteral(source) || _core.types.isTemplateLiteral(source) ? source : _core.template.expression.ast`\`\${${source}}\``;
	  };
	}
	function buildDynamicImport(node, deferToThen, wrapWithPromise, builder) {
	  const specifier = _core.types.isCallExpression(node) ? node.arguments[0] : node.source;
	  if (_core.types.isStringLiteral(specifier) || _core.types.isTemplateLiteral(specifier) && specifier.quasis.length === 0) {
	    if (deferToThen) {
	      return _core.template.expression.ast`
        Promise.resolve().then(() => ${builder(specifier)})
      `;
	    } else return builder(specifier);
	  }
	  const specifierToString = _core.types.isTemplateLiteral(specifier) ? _core.types.identifier("specifier") : _core.types.templateLiteral([_core.types.templateElement({
	    raw: ""
	  }), _core.types.templateElement({
	    raw: ""
	  })], [_core.types.identifier("specifier")]);
	  if (deferToThen) {
	    return _core.template.expression.ast`
      (specifier =>
        new Promise(r => r(${specifierToString}))
          .then(s => ${builder(_core.types.identifier("s"))})
      )(${specifier})
    `;
	  } else if (wrapWithPromise) {
	    return _core.template.expression.ast`
      (specifier =>
        new Promise(r => r(${builder(specifierToString)}))
      )(${specifier})
    `;
	  } else {
	    return _core.template.expression.ast`
      (specifier => ${builder(specifierToString)})(${specifier})
    `;
	  }
	}

	
	return dynamicImport;
}

var getModuleName = {};

var hasRequiredGetModuleName;

function requireGetModuleName () {
	if (hasRequiredGetModuleName) return getModuleName;
	hasRequiredGetModuleName = 1;

	Object.defineProperty(getModuleName, "__esModule", {
	  value: true
	});
	getModuleName.default = getModuleName$1;
	{
	  const originalGetModuleName = getModuleName$1;
	  getModuleName.default = getModuleName$1 = function getModuleName(rootOpts, pluginOpts) {
	    var _pluginOpts$moduleId, _pluginOpts$moduleIds, _pluginOpts$getModule, _pluginOpts$moduleRoo;
	    return originalGetModuleName(rootOpts, {
	      moduleId: (_pluginOpts$moduleId = pluginOpts.moduleId) != null ? _pluginOpts$moduleId : rootOpts.moduleId,
	      moduleIds: (_pluginOpts$moduleIds = pluginOpts.moduleIds) != null ? _pluginOpts$moduleIds : rootOpts.moduleIds,
	      getModuleId: (_pluginOpts$getModule = pluginOpts.getModuleId) != null ? _pluginOpts$getModule : rootOpts.getModuleId,
	      moduleRoot: (_pluginOpts$moduleRoo = pluginOpts.moduleRoot) != null ? _pluginOpts$moduleRoo : rootOpts.moduleRoot
	    });
	  };
	}
	function getModuleName$1(rootOpts, pluginOpts) {
	  const {
	    filename,
	    filenameRelative = filename,
	    sourceRoot = pluginOpts.moduleRoot
	  } = rootOpts;
	  const {
	    moduleId,
	    moduleIds = !!moduleId,
	    getModuleId,
	    moduleRoot = sourceRoot
	  } = pluginOpts;
	  if (!moduleIds) return null;
	  if (moduleId != null && !getModuleId) {
	    return moduleId;
	  }
	  let moduleName = moduleRoot != null ? moduleRoot + "/" : "";
	  if (filenameRelative) {
	    const sourceRootReplacer = sourceRoot != null ? new RegExp("^" + sourceRoot + "/?") : "";
	    moduleName += filenameRelative.replace(sourceRootReplacer, "").replace(/\.(\w*?)$/, "");
	  }
	  moduleName = moduleName.replace(/\\/g, "/");
	  if (getModuleId) {
	    return getModuleId(moduleName) || moduleName;
	  } else {
	    return moduleName;
	  }
	}

	
	return getModuleName;
}

var hasRequiredLib$3;

function requireLib$3 () {
	if (hasRequiredLib$3) return lib$4;
	hasRequiredLib$3 = 1;
	(function (exports) {

		Object.defineProperty(exports, "__esModule", {
		  value: true
		});
		Object.defineProperty(exports, "buildDynamicImport", {
		  enumerable: true,
		  get: function () {
		    return _dynamicImport.buildDynamicImport;
		  }
		});
		exports.buildNamespaceInitStatements = buildNamespaceInitStatements;
		exports.ensureStatementsHoisted = ensureStatementsHoisted;
		Object.defineProperty(exports, "getModuleName", {
		  enumerable: true,
		  get: function () {
		    return _getModuleName.default;
		  }
		});
		Object.defineProperty(exports, "hasExports", {
		  enumerable: true,
		  get: function () {
		    return _normalizeAndLoadMetadata.hasExports;
		  }
		});
		Object.defineProperty(exports, "isModule", {
		  enumerable: true,
		  get: function () {
		    return _helperModuleImports.isModule;
		  }
		});
		Object.defineProperty(exports, "isSideEffectImport", {
		  enumerable: true,
		  get: function () {
		    return _normalizeAndLoadMetadata.isSideEffectImport;
		  }
		});
		exports.rewriteModuleStatementsAndPrepareHeader = rewriteModuleStatementsAndPrepareHeader;
		Object.defineProperty(exports, "rewriteThis", {
		  enumerable: true,
		  get: function () {
		    return _rewriteThis.default;
		  }
		});
		exports.wrapInterop = wrapInterop;
		var _assert = require$$0__default$5["default"];
		var _core = requireLib();
		var _helperModuleImports = requireLib$5();
		var _rewriteThis = requireRewriteThis();
		var _rewriteLiveReferences = requireRewriteLiveReferences();
		var _normalizeAndLoadMetadata = requireNormalizeAndLoadMetadata();
		var Lazy = requireLazyModules();
		var _dynamicImport = requireDynamicImport();
		var _getModuleName = requireGetModuleName();
		const {
		  booleanLiteral,
		  callExpression,
		  cloneNode,
		  directive,
		  directiveLiteral,
		  expressionStatement,
		  identifier,
		  isIdentifier,
		  memberExpression,
		  stringLiteral,
		  valueToNode,
		  variableDeclaration,
		  variableDeclarator
		} = _core.types;
		{
		  exports.getDynamicImportSource = requireDynamicImport().getDynamicImportSource;
		}
		function rewriteModuleStatementsAndPrepareHeader(path, {
		  exportName,
		  strict,
		  allowTopLevelThis,
		  strictMode,
		  noInterop,
		  importInterop = noInterop ? "none" : "babel",
		  lazy,
		  getWrapperPayload = Lazy.toGetWrapperPayload(lazy != null ? lazy : false),
		  wrapReference = Lazy.wrapReference,
		  esNamespaceOnly,
		  filename,
		  constantReexports = arguments[1].loose,
		  enumerableModuleMeta = arguments[1].loose,
		  noIncompleteNsImportDetection
		}) {
		  (0, _normalizeAndLoadMetadata.validateImportInteropOption)(importInterop);
		  _assert((0, _helperModuleImports.isModule)(path), "Cannot process module statements in a script");
		  path.node.sourceType = "script";
		  const meta = (0, _normalizeAndLoadMetadata.default)(path, exportName, {
		    importInterop,
		    initializeReexports: constantReexports,
		    getWrapperPayload,
		    esNamespaceOnly,
		    filename
		  });
		  if (!allowTopLevelThis) {
		    (0, _rewriteThis.default)(path);
		  }
		  (0, _rewriteLiveReferences.default)(path, meta, wrapReference);
		  if (strictMode !== false) {
		    const hasStrict = path.node.directives.some(directive => {
		      return directive.value.value === "use strict";
		    });
		    if (!hasStrict) {
		      path.unshiftContainer("directives", directive(directiveLiteral("use strict")));
		    }
		  }
		  const headers = [];
		  if ((0, _normalizeAndLoadMetadata.hasExports)(meta) && !strict) {
		    headers.push(buildESModuleHeader(meta, enumerableModuleMeta));
		  }
		  const nameList = buildExportNameListDeclaration(path, meta);
		  if (nameList) {
		    meta.exportNameListName = nameList.name;
		    headers.push(nameList.statement);
		  }
		  headers.push(...buildExportInitializationStatements(path, meta, wrapReference, constantReexports, noIncompleteNsImportDetection));
		  return {
		    meta,
		    headers
		  };
		}
		function ensureStatementsHoisted(statements) {
		  statements.forEach(header => {
		    header._blockHoist = 3;
		  });
		}
		function wrapInterop(programPath, expr, type) {
		  if (type === "none") {
		    return null;
		  }
		  if (type === "node-namespace") {
		    return callExpression(programPath.hub.addHelper("interopRequireWildcard"), [expr, booleanLiteral(true)]);
		  } else if (type === "node-default") {
		    return null;
		  }
		  let helper;
		  if (type === "default") {
		    helper = "interopRequireDefault";
		  } else if (type === "namespace") {
		    helper = "interopRequireWildcard";
		  } else {
		    throw new Error(`Unknown interop: ${type}`);
		  }
		  return callExpression(programPath.hub.addHelper(helper), [expr]);
		}
		function buildNamespaceInitStatements(metadata, sourceMetadata, constantReexports = false, wrapReference = Lazy.wrapReference) {
		  var _wrapReference;
		  const statements = [];
		  const srcNamespaceId = identifier(sourceMetadata.name);
		  for (const localName of sourceMetadata.importsNamespace) {
		    if (localName === sourceMetadata.name) continue;
		    statements.push(_core.template.statement`var NAME = SOURCE;`({
		      NAME: localName,
		      SOURCE: cloneNode(srcNamespaceId)
		    }));
		  }
		  const srcNamespace = (_wrapReference = wrapReference(srcNamespaceId, sourceMetadata.wrap)) != null ? _wrapReference : srcNamespaceId;
		  if (constantReexports) {
		    statements.push(...buildReexportsFromMeta(metadata, sourceMetadata, true, wrapReference));
		  }
		  for (const exportName of sourceMetadata.reexportNamespace) {
		    statements.push((!_core.types.isIdentifier(srcNamespace) ? _core.template.statement`
            Object.defineProperty(EXPORTS, "NAME", {
              enumerable: true,
              get: function() {
                return NAMESPACE;
              }
            });
          ` : _core.template.statement`EXPORTS.NAME = NAMESPACE;`)({
		      EXPORTS: metadata.exportName,
		      NAME: exportName,
		      NAMESPACE: cloneNode(srcNamespace)
		    }));
		  }
		  if (sourceMetadata.reexportAll) {
		    const statement = buildNamespaceReexport(metadata, cloneNode(srcNamespace), constantReexports);
		    statement.loc = sourceMetadata.reexportAll.loc;
		    statements.push(statement);
		  }
		  return statements;
		}
		const ReexportTemplate = {
		  constant: _core.template.statement`EXPORTS.EXPORT_NAME = NAMESPACE_IMPORT;`,
		  constantComputed: _core.template.statement`EXPORTS["EXPORT_NAME"] = NAMESPACE_IMPORT;`,
		  spec: _core.template.statement`
    Object.defineProperty(EXPORTS, "EXPORT_NAME", {
      enumerable: true,
      get: function() {
        return NAMESPACE_IMPORT;
      },
    });
    `
		};
		function buildReexportsFromMeta(meta, metadata, constantReexports, wrapReference) {
		  var _wrapReference2;
		  let namespace = identifier(metadata.name);
		  namespace = (_wrapReference2 = wrapReference(namespace, metadata.wrap)) != null ? _wrapReference2 : namespace;
		  const {
		    stringSpecifiers
		  } = meta;
		  return Array.from(metadata.reexports, ([exportName, importName]) => {
		    let NAMESPACE_IMPORT = cloneNode(namespace);
		    if (importName === "default" && metadata.interop === "node-default") ; else if (stringSpecifiers.has(importName)) {
		      NAMESPACE_IMPORT = memberExpression(NAMESPACE_IMPORT, stringLiteral(importName), true);
		    } else {
		      NAMESPACE_IMPORT = memberExpression(NAMESPACE_IMPORT, identifier(importName));
		    }
		    const astNodes = {
		      EXPORTS: meta.exportName,
		      EXPORT_NAME: exportName,
		      NAMESPACE_IMPORT
		    };
		    if (constantReexports || isIdentifier(NAMESPACE_IMPORT)) {
		      if (stringSpecifiers.has(exportName)) {
		        return ReexportTemplate.constantComputed(astNodes);
		      } else {
		        return ReexportTemplate.constant(astNodes);
		      }
		    } else {
		      return ReexportTemplate.spec(astNodes);
		    }
		  });
		}
		function buildESModuleHeader(metadata, enumerableModuleMeta = false) {
		  return (enumerableModuleMeta ? _core.template.statement`
        EXPORTS.__esModule = true;
      ` : _core.template.statement`
        Object.defineProperty(EXPORTS, "__esModule", {
          value: true,
        });
      `)({
		    EXPORTS: metadata.exportName
		  });
		}
		function buildNamespaceReexport(metadata, namespace, constantReexports) {
		  return (constantReexports ? _core.template.statement`
        Object.keys(NAMESPACE).forEach(function(key) {
          if (key === "default" || key === "__esModule") return;
          VERIFY_NAME_LIST;
          if (key in EXPORTS && EXPORTS[key] === NAMESPACE[key]) return;

          EXPORTS[key] = NAMESPACE[key];
        });
      ` : _core.template.statement`
        Object.keys(NAMESPACE).forEach(function(key) {
          if (key === "default" || key === "__esModule") return;
          VERIFY_NAME_LIST;
          if (key in EXPORTS && EXPORTS[key] === NAMESPACE[key]) return;

          Object.defineProperty(EXPORTS, key, {
            enumerable: true,
            get: function() {
              return NAMESPACE[key];
            },
          });
        });
    `)({
		    NAMESPACE: namespace,
		    EXPORTS: metadata.exportName,
		    VERIFY_NAME_LIST: metadata.exportNameListName ? (0, _core.template)`
            if (Object.prototype.hasOwnProperty.call(EXPORTS_LIST, key)) return;
          `({
		      EXPORTS_LIST: metadata.exportNameListName
		    }) : null
		  });
		}
		function buildExportNameListDeclaration(programPath, metadata) {
		  const exportedVars = Object.create(null);
		  for (const data of metadata.local.values()) {
		    for (const name of data.names) {
		      exportedVars[name] = true;
		    }
		  }
		  let hasReexport = false;
		  for (const data of metadata.source.values()) {
		    for (const exportName of data.reexports.keys()) {
		      exportedVars[exportName] = true;
		    }
		    for (const exportName of data.reexportNamespace) {
		      exportedVars[exportName] = true;
		    }
		    hasReexport = hasReexport || !!data.reexportAll;
		  }
		  if (!hasReexport || Object.keys(exportedVars).length === 0) return null;
		  const name = programPath.scope.generateUidIdentifier("exportNames");
		  delete exportedVars.default;
		  return {
		    name: name.name,
		    statement: variableDeclaration("var", [variableDeclarator(name, valueToNode(exportedVars))])
		  };
		}
		function buildExportInitializationStatements(programPath, metadata, wrapReference, constantReexports = false, noIncompleteNsImportDetection = false) {
		  const initStatements = [];
		  for (const [localName, data] of metadata.local) {
		    if (data.kind === "import") ; else if (data.kind === "hoisted") {
		      initStatements.push([data.names[0], buildInitStatement(metadata, data.names, identifier(localName))]);
		    } else if (!noIncompleteNsImportDetection) {
		      for (const exportName of data.names) {
		        initStatements.push([exportName, null]);
		      }
		    }
		  }
		  for (const data of metadata.source.values()) {
		    if (!constantReexports) {
		      const reexportsStatements = buildReexportsFromMeta(metadata, data, false, wrapReference);
		      const reexports = [...data.reexports.keys()];
		      for (let i = 0; i < reexportsStatements.length; i++) {
		        initStatements.push([reexports[i], reexportsStatements[i]]);
		      }
		    }
		    if (!noIncompleteNsImportDetection) {
		      for (const exportName of data.reexportNamespace) {
		        initStatements.push([exportName, null]);
		      }
		    }
		  }
		  initStatements.sort(([a], [b]) => {
		    if (a < b) return -1;
		    if (b < a) return 1;
		    return 0;
		  });
		  const results = [];
		  if (noIncompleteNsImportDetection) {
		    for (const [, initStatement] of initStatements) {
		      results.push(initStatement);
		    }
		  } else {
		    const chunkSize = 100;
		    for (let i = 0; i < initStatements.length; i += chunkSize) {
		      let uninitializedExportNames = [];
		      for (let j = 0; j < chunkSize && i + j < initStatements.length; j++) {
		        const [exportName, initStatement] = initStatements[i + j];
		        if (initStatement !== null) {
		          if (uninitializedExportNames.length > 0) {
		            results.push(buildInitStatement(metadata, uninitializedExportNames, programPath.scope.buildUndefinedNode()));
		            uninitializedExportNames = [];
		          }
		          results.push(initStatement);
		        } else {
		          uninitializedExportNames.push(exportName);
		        }
		      }
		      if (uninitializedExportNames.length > 0) {
		        results.push(buildInitStatement(metadata, uninitializedExportNames, programPath.scope.buildUndefinedNode()));
		      }
		    }
		  }
		  return results;
		}
		const InitTemplate = {
		  computed: _core.template.expression`EXPORTS["NAME"] = VALUE`,
		  default: _core.template.expression`EXPORTS.NAME = VALUE`,
		  define: _core.template.expression`Object.defineProperty(EXPORTS, "NAME", { enumerable:true, value: void 0, writable: true })["NAME"] = VALUE`
		};
		function buildInitStatement(metadata, exportNames, initExpr) {
		  const {
		    stringSpecifiers,
		    exportName: EXPORTS
		  } = metadata;
		  return expressionStatement(exportNames.reduce((acc, exportName) => {
		    const params = {
		      EXPORTS,
		      NAME: exportName,
		      VALUE: acc
		    };
		    if (exportName === "__proto__") {
		      return InitTemplate.define(params);
		    }
		    if (stringSpecifiers.has(exportName)) {
		      return InitTemplate.computed(params);
		    }
		    return InitTemplate.default(params);
		  }, initExpr));
		}

		
	} (lib$4));
	return lib$4;
}

var semver$1 = {exports: {}};

semver$1.exports;

var hasRequiredSemver$1;

function requireSemver$1 () {
	if (hasRequiredSemver$1) return semver$1.exports;
	hasRequiredSemver$1 = 1;
	(function (module, exports) {
		exports = module.exports = SemVer;

		var debug;
		/* istanbul ignore next */
		if (typeof process === 'object' &&
		    process.env &&
		    process.env.NODE_DEBUG &&
		    /\bsemver\b/i.test(process.env.NODE_DEBUG)) {
		  debug = function () {
		    var args = Array.prototype.slice.call(arguments, 0);
		    args.unshift('SEMVER');
		    console.log.apply(console, args);
		  };
		} else {
		  debug = function () {};
		}

		// Note: this is the semver.org version of the spec that it implements
		// Not necessarily the package version of this code.
		exports.SEMVER_SPEC_VERSION = '2.0.0';

		var MAX_LENGTH = 256;
		var MAX_SAFE_INTEGER = Number.MAX_SAFE_INTEGER ||
		  /* istanbul ignore next */ 9007199254740991;

		// Max safe segment length for coercion.
		var MAX_SAFE_COMPONENT_LENGTH = 16;

		var MAX_SAFE_BUILD_LENGTH = MAX_LENGTH - 6;

		// The actual regexps go on exports.re
		var re = exports.re = [];
		var safeRe = exports.safeRe = [];
		var src = exports.src = [];
		var t = exports.tokens = {};
		var R = 0;

		function tok (n) {
		  t[n] = R++;
		}

		var LETTERDASHNUMBER = '[a-zA-Z0-9-]';

		// Replace some greedy regex tokens to prevent regex dos issues. These regex are
		// used internally via the safeRe object since all inputs in this library get
		// normalized first to trim and collapse all extra whitespace. The original
		// regexes are exported for userland consumption and lower level usage. A
		// future breaking change could export the safer regex only with a note that
		// all input should have extra whitespace removed.
		var safeRegexReplacements = [
		  ['\\s', 1],
		  ['\\d', MAX_LENGTH],
		  [LETTERDASHNUMBER, MAX_SAFE_BUILD_LENGTH],
		];

		function makeSafeRe (value) {
		  for (var i = 0; i < safeRegexReplacements.length; i++) {
		    var token = safeRegexReplacements[i][0];
		    var max = safeRegexReplacements[i][1];
		    value = value
		      .split(token + '*').join(token + '{0,' + max + '}')
		      .split(token + '+').join(token + '{1,' + max + '}');
		  }
		  return value
		}

		// The following Regular Expressions can be used for tokenizing,
		// validating, and parsing SemVer version strings.

		// ## Numeric Identifier
		// A single `0`, or a non-zero digit followed by zero or more digits.

		tok('NUMERICIDENTIFIER');
		src[t.NUMERICIDENTIFIER] = '0|[1-9]\\d*';
		tok('NUMERICIDENTIFIERLOOSE');
		src[t.NUMERICIDENTIFIERLOOSE] = '\\d+';

		// ## Non-numeric Identifier
		// Zero or more digits, followed by a letter or hyphen, and then zero or
		// more letters, digits, or hyphens.

		tok('NONNUMERICIDENTIFIER');
		src[t.NONNUMERICIDENTIFIER] = '\\d*[a-zA-Z-]' + LETTERDASHNUMBER + '*';

		// ## Main Version
		// Three dot-separated numeric identifiers.

		tok('MAINVERSION');
		src[t.MAINVERSION] = '(' + src[t.NUMERICIDENTIFIER] + ')\\.' +
		                   '(' + src[t.NUMERICIDENTIFIER] + ')\\.' +
		                   '(' + src[t.NUMERICIDENTIFIER] + ')';

		tok('MAINVERSIONLOOSE');
		src[t.MAINVERSIONLOOSE] = '(' + src[t.NUMERICIDENTIFIERLOOSE] + ')\\.' +
		                        '(' + src[t.NUMERICIDENTIFIERLOOSE] + ')\\.' +
		                        '(' + src[t.NUMERICIDENTIFIERLOOSE] + ')';

		// ## Pre-release Version Identifier
		// A numeric identifier, or a non-numeric identifier.

		tok('PRERELEASEIDENTIFIER');
		src[t.PRERELEASEIDENTIFIER] = '(?:' + src[t.NUMERICIDENTIFIER] +
		                            '|' + src[t.NONNUMERICIDENTIFIER] + ')';

		tok('PRERELEASEIDENTIFIERLOOSE');
		src[t.PRERELEASEIDENTIFIERLOOSE] = '(?:' + src[t.NUMERICIDENTIFIERLOOSE] +
		                                 '|' + src[t.NONNUMERICIDENTIFIER] + ')';

		// ## Pre-release Version
		// Hyphen, followed by one or more dot-separated pre-release version
		// identifiers.

		tok('PRERELEASE');
		src[t.PRERELEASE] = '(?:-(' + src[t.PRERELEASEIDENTIFIER] +
		                  '(?:\\.' + src[t.PRERELEASEIDENTIFIER] + ')*))';

		tok('PRERELEASELOOSE');
		src[t.PRERELEASELOOSE] = '(?:-?(' + src[t.PRERELEASEIDENTIFIERLOOSE] +
		                       '(?:\\.' + src[t.PRERELEASEIDENTIFIERLOOSE] + ')*))';

		// ## Build Metadata Identifier
		// Any combination of digits, letters, or hyphens.

		tok('BUILDIDENTIFIER');
		src[t.BUILDIDENTIFIER] = LETTERDASHNUMBER + '+';

		// ## Build Metadata
		// Plus sign, followed by one or more period-separated build metadata
		// identifiers.

		tok('BUILD');
		src[t.BUILD] = '(?:\\+(' + src[t.BUILDIDENTIFIER] +
		             '(?:\\.' + src[t.BUILDIDENTIFIER] + ')*))';

		// ## Full Version String
		// A main version, followed optionally by a pre-release version and
		// build metadata.

		// Note that the only major, minor, patch, and pre-release sections of
		// the version string are capturing groups.  The build metadata is not a
		// capturing group, because it should not ever be used in version
		// comparison.

		tok('FULL');
		tok('FULLPLAIN');
		src[t.FULLPLAIN] = 'v?' + src[t.MAINVERSION] +
		                  src[t.PRERELEASE] + '?' +
		                  src[t.BUILD] + '?';

		src[t.FULL] = '^' + src[t.FULLPLAIN] + '$';

		// like full, but allows v1.2.3 and =1.2.3, which people do sometimes.
		// also, 1.0.0alpha1 (prerelease without the hyphen) which is pretty
		// common in the npm registry.
		tok('LOOSEPLAIN');
		src[t.LOOSEPLAIN] = '[v=\\s]*' + src[t.MAINVERSIONLOOSE] +
		                  src[t.PRERELEASELOOSE] + '?' +
		                  src[t.BUILD] + '?';

		tok('LOOSE');
		src[t.LOOSE] = '^' + src[t.LOOSEPLAIN] + '$';

		tok('GTLT');
		src[t.GTLT] = '((?:<|>)?=?)';

		// Something like "2.*" or "1.2.x".
		// Note that "x.x" is a valid xRange identifer, meaning "any version"
		// Only the first item is strictly required.
		tok('XRANGEIDENTIFIERLOOSE');
		src[t.XRANGEIDENTIFIERLOOSE] = src[t.NUMERICIDENTIFIERLOOSE] + '|x|X|\\*';
		tok('XRANGEIDENTIFIER');
		src[t.XRANGEIDENTIFIER] = src[t.NUMERICIDENTIFIER] + '|x|X|\\*';

		tok('XRANGEPLAIN');
		src[t.XRANGEPLAIN] = '[v=\\s]*(' + src[t.XRANGEIDENTIFIER] + ')' +
		                   '(?:\\.(' + src[t.XRANGEIDENTIFIER] + ')' +
		                   '(?:\\.(' + src[t.XRANGEIDENTIFIER] + ')' +
		                   '(?:' + src[t.PRERELEASE] + ')?' +
		                   src[t.BUILD] + '?' +
		                   ')?)?';

		tok('XRANGEPLAINLOOSE');
		src[t.XRANGEPLAINLOOSE] = '[v=\\s]*(' + src[t.XRANGEIDENTIFIERLOOSE] + ')' +
		                        '(?:\\.(' + src[t.XRANGEIDENTIFIERLOOSE] + ')' +
		                        '(?:\\.(' + src[t.XRANGEIDENTIFIERLOOSE] + ')' +
		                        '(?:' + src[t.PRERELEASELOOSE] + ')?' +
		                        src[t.BUILD] + '?' +
		                        ')?)?';

		tok('XRANGE');
		src[t.XRANGE] = '^' + src[t.GTLT] + '\\s*' + src[t.XRANGEPLAIN] + '$';
		tok('XRANGELOOSE');
		src[t.XRANGELOOSE] = '^' + src[t.GTLT] + '\\s*' + src[t.XRANGEPLAINLOOSE] + '$';

		// Coercion.
		// Extract anything that could conceivably be a part of a valid semver
		tok('COERCE');
		src[t.COERCE] = '(^|[^\\d])' +
		              '(\\d{1,' + MAX_SAFE_COMPONENT_LENGTH + '})' +
		              '(?:\\.(\\d{1,' + MAX_SAFE_COMPONENT_LENGTH + '}))?' +
		              '(?:\\.(\\d{1,' + MAX_SAFE_COMPONENT_LENGTH + '}))?' +
		              '(?:$|[^\\d])';
		tok('COERCERTL');
		re[t.COERCERTL] = new RegExp(src[t.COERCE], 'g');
		safeRe[t.COERCERTL] = new RegExp(makeSafeRe(src[t.COERCE]), 'g');

		// Tilde ranges.
		// Meaning is "reasonably at or greater than"
		tok('LONETILDE');
		src[t.LONETILDE] = '(?:~>?)';

		tok('TILDETRIM');
		src[t.TILDETRIM] = '(\\s*)' + src[t.LONETILDE] + '\\s+';
		re[t.TILDETRIM] = new RegExp(src[t.TILDETRIM], 'g');
		safeRe[t.TILDETRIM] = new RegExp(makeSafeRe(src[t.TILDETRIM]), 'g');
		var tildeTrimReplace = '$1~';

		tok('TILDE');
		src[t.TILDE] = '^' + src[t.LONETILDE] + src[t.XRANGEPLAIN] + '$';
		tok('TILDELOOSE');
		src[t.TILDELOOSE] = '^' + src[t.LONETILDE] + src[t.XRANGEPLAINLOOSE] + '$';

		// Caret ranges.
		// Meaning is "at least and backwards compatible with"
		tok('LONECARET');
		src[t.LONECARET] = '(?:\\^)';

		tok('CARETTRIM');
		src[t.CARETTRIM] = '(\\s*)' + src[t.LONECARET] + '\\s+';
		re[t.CARETTRIM] = new RegExp(src[t.CARETTRIM], 'g');
		safeRe[t.CARETTRIM] = new RegExp(makeSafeRe(src[t.CARETTRIM]), 'g');
		var caretTrimReplace = '$1^';

		tok('CARET');
		src[t.CARET] = '^' + src[t.LONECARET] + src[t.XRANGEPLAIN] + '$';
		tok('CARETLOOSE');
		src[t.CARETLOOSE] = '^' + src[t.LONECARET] + src[t.XRANGEPLAINLOOSE] + '$';

		// A simple gt/lt/eq thing, or just "" to indicate "any version"
		tok('COMPARATORLOOSE');
		src[t.COMPARATORLOOSE] = '^' + src[t.GTLT] + '\\s*(' + src[t.LOOSEPLAIN] + ')$|^$';
		tok('COMPARATOR');
		src[t.COMPARATOR] = '^' + src[t.GTLT] + '\\s*(' + src[t.FULLPLAIN] + ')$|^$';

		// An expression to strip any whitespace between the gtlt and the thing
		// it modifies, so that `> 1.2.3` ==> `>1.2.3`
		tok('COMPARATORTRIM');
		src[t.COMPARATORTRIM] = '(\\s*)' + src[t.GTLT] +
		                      '\\s*(' + src[t.LOOSEPLAIN] + '|' + src[t.XRANGEPLAIN] + ')';

		// this one has to use the /g flag
		re[t.COMPARATORTRIM] = new RegExp(src[t.COMPARATORTRIM], 'g');
		safeRe[t.COMPARATORTRIM] = new RegExp(makeSafeRe(src[t.COMPARATORTRIM]), 'g');
		var comparatorTrimReplace = '$1$2$3';

		// Something like `1.2.3 - 1.2.4`
		// Note that these all use the loose form, because they'll be
		// checked against either the strict or loose comparator form
		// later.
		tok('HYPHENRANGE');
		src[t.HYPHENRANGE] = '^\\s*(' + src[t.XRANGEPLAIN] + ')' +
		                   '\\s+-\\s+' +
		                   '(' + src[t.XRANGEPLAIN] + ')' +
		                   '\\s*$';

		tok('HYPHENRANGELOOSE');
		src[t.HYPHENRANGELOOSE] = '^\\s*(' + src[t.XRANGEPLAINLOOSE] + ')' +
		                        '\\s+-\\s+' +
		                        '(' + src[t.XRANGEPLAINLOOSE] + ')' +
		                        '\\s*$';

		// Star ranges basically just allow anything at all.
		tok('STAR');
		src[t.STAR] = '(<|>)?=?\\s*\\*';

		// Compile to actual regexp objects.
		// All are flag-free, unless they were created above with a flag.
		for (var i = 0; i < R; i++) {
		  debug(i, src[i]);
		  if (!re[i]) {
		    re[i] = new RegExp(src[i]);

		    // Replace all greedy whitespace to prevent regex dos issues. These regex are
		    // used internally via the safeRe object since all inputs in this library get
		    // normalized first to trim and collapse all extra whitespace. The original
		    // regexes are exported for userland consumption and lower level usage. A
		    // future breaking change could export the safer regex only with a note that
		    // all input should have extra whitespace removed.
		    safeRe[i] = new RegExp(makeSafeRe(src[i]));
		  }
		}

		exports.parse = parse;
		function parse (version, options) {
		  if (!options || typeof options !== 'object') {
		    options = {
		      loose: !!options,
		      includePrerelease: false
		    };
		  }

		  if (version instanceof SemVer) {
		    return version
		  }

		  if (typeof version !== 'string') {
		    return null
		  }

		  if (version.length > MAX_LENGTH) {
		    return null
		  }

		  var r = options.loose ? safeRe[t.LOOSE] : safeRe[t.FULL];
		  if (!r.test(version)) {
		    return null
		  }

		  try {
		    return new SemVer(version, options)
		  } catch (er) {
		    return null
		  }
		}

		exports.valid = valid;
		function valid (version, options) {
		  var v = parse(version, options);
		  return v ? v.version : null
		}

		exports.clean = clean;
		function clean (version, options) {
		  var s = parse(version.trim().replace(/^[=v]+/, ''), options);
		  return s ? s.version : null
		}

		exports.SemVer = SemVer;

		function SemVer (version, options) {
		  if (!options || typeof options !== 'object') {
		    options = {
		      loose: !!options,
		      includePrerelease: false
		    };
		  }
		  if (version instanceof SemVer) {
		    if (version.loose === options.loose) {
		      return version
		    } else {
		      version = version.version;
		    }
		  } else if (typeof version !== 'string') {
		    throw new TypeError('Invalid Version: ' + version)
		  }

		  if (version.length > MAX_LENGTH) {
		    throw new TypeError('version is longer than ' + MAX_LENGTH + ' characters')
		  }

		  if (!(this instanceof SemVer)) {
		    return new SemVer(version, options)
		  }

		  debug('SemVer', version, options);
		  this.options = options;
		  this.loose = !!options.loose;

		  var m = version.trim().match(options.loose ? safeRe[t.LOOSE] : safeRe[t.FULL]);

		  if (!m) {
		    throw new TypeError('Invalid Version: ' + version)
		  }

		  this.raw = version;

		  // these are actually numbers
		  this.major = +m[1];
		  this.minor = +m[2];
		  this.patch = +m[3];

		  if (this.major > MAX_SAFE_INTEGER || this.major < 0) {
		    throw new TypeError('Invalid major version')
		  }

		  if (this.minor > MAX_SAFE_INTEGER || this.minor < 0) {
		    throw new TypeError('Invalid minor version')
		  }

		  if (this.patch > MAX_SAFE_INTEGER || this.patch < 0) {
		    throw new TypeError('Invalid patch version')
		  }

		  // numberify any prerelease numeric ids
		  if (!m[4]) {
		    this.prerelease = [];
		  } else {
		    this.prerelease = m[4].split('.').map(function (id) {
		      if (/^[0-9]+$/.test(id)) {
		        var num = +id;
		        if (num >= 0 && num < MAX_SAFE_INTEGER) {
		          return num
		        }
		      }
		      return id
		    });
		  }

		  this.build = m[5] ? m[5].split('.') : [];
		  this.format();
		}

		SemVer.prototype.format = function () {
		  this.version = this.major + '.' + this.minor + '.' + this.patch;
		  if (this.prerelease.length) {
		    this.version += '-' + this.prerelease.join('.');
		  }
		  return this.version
		};

		SemVer.prototype.toString = function () {
		  return this.version
		};

		SemVer.prototype.compare = function (other) {
		  debug('SemVer.compare', this.version, this.options, other);
		  if (!(other instanceof SemVer)) {
		    other = new SemVer(other, this.options);
		  }

		  return this.compareMain(other) || this.comparePre(other)
		};

		SemVer.prototype.compareMain = function (other) {
		  if (!(other instanceof SemVer)) {
		    other = new SemVer(other, this.options);
		  }

		  return compareIdentifiers(this.major, other.major) ||
		         compareIdentifiers(this.minor, other.minor) ||
		         compareIdentifiers(this.patch, other.patch)
		};

		SemVer.prototype.comparePre = function (other) {
		  if (!(other instanceof SemVer)) {
		    other = new SemVer(other, this.options);
		  }

		  // NOT having a prerelease is > having one
		  if (this.prerelease.length && !other.prerelease.length) {
		    return -1
		  } else if (!this.prerelease.length && other.prerelease.length) {
		    return 1
		  } else if (!this.prerelease.length && !other.prerelease.length) {
		    return 0
		  }

		  var i = 0;
		  do {
		    var a = this.prerelease[i];
		    var b = other.prerelease[i];
		    debug('prerelease compare', i, a, b);
		    if (a === undefined && b === undefined) {
		      return 0
		    } else if (b === undefined) {
		      return 1
		    } else if (a === undefined) {
		      return -1
		    } else if (a === b) {
		      continue
		    } else {
		      return compareIdentifiers(a, b)
		    }
		  } while (++i)
		};

		SemVer.prototype.compareBuild = function (other) {
		  if (!(other instanceof SemVer)) {
		    other = new SemVer(other, this.options);
		  }

		  var i = 0;
		  do {
		    var a = this.build[i];
		    var b = other.build[i];
		    debug('prerelease compare', i, a, b);
		    if (a === undefined && b === undefined) {
		      return 0
		    } else if (b === undefined) {
		      return 1
		    } else if (a === undefined) {
		      return -1
		    } else if (a === b) {
		      continue
		    } else {
		      return compareIdentifiers(a, b)
		    }
		  } while (++i)
		};

		// preminor will bump the version up to the next minor release, and immediately
		// down to pre-release. premajor and prepatch work the same way.
		SemVer.prototype.inc = function (release, identifier) {
		  switch (release) {
		    case 'premajor':
		      this.prerelease.length = 0;
		      this.patch = 0;
		      this.minor = 0;
		      this.major++;
		      this.inc('pre', identifier);
		      break
		    case 'preminor':
		      this.prerelease.length = 0;
		      this.patch = 0;
		      this.minor++;
		      this.inc('pre', identifier);
		      break
		    case 'prepatch':
		      // If this is already a prerelease, it will bump to the next version
		      // drop any prereleases that might already exist, since they are not
		      // relevant at this point.
		      this.prerelease.length = 0;
		      this.inc('patch', identifier);
		      this.inc('pre', identifier);
		      break
		    // If the input is a non-prerelease version, this acts the same as
		    // prepatch.
		    case 'prerelease':
		      if (this.prerelease.length === 0) {
		        this.inc('patch', identifier);
		      }
		      this.inc('pre', identifier);
		      break

		    case 'major':
		      // If this is a pre-major version, bump up to the same major version.
		      // Otherwise increment major.
		      // 1.0.0-5 bumps to 1.0.0
		      // 1.1.0 bumps to 2.0.0
		      if (this.minor !== 0 ||
		          this.patch !== 0 ||
		          this.prerelease.length === 0) {
		        this.major++;
		      }
		      this.minor = 0;
		      this.patch = 0;
		      this.prerelease = [];
		      break
		    case 'minor':
		      // If this is a pre-minor version, bump up to the same minor version.
		      // Otherwise increment minor.
		      // 1.2.0-5 bumps to 1.2.0
		      // 1.2.1 bumps to 1.3.0
		      if (this.patch !== 0 || this.prerelease.length === 0) {
		        this.minor++;
		      }
		      this.patch = 0;
		      this.prerelease = [];
		      break
		    case 'patch':
		      // If this is not a pre-release version, it will increment the patch.
		      // If it is a pre-release it will bump up to the same patch version.
		      // 1.2.0-5 patches to 1.2.0
		      // 1.2.0 patches to 1.2.1
		      if (this.prerelease.length === 0) {
		        this.patch++;
		      }
		      this.prerelease = [];
		      break
		    // This probably shouldn't be used publicly.
		    // 1.0.0 "pre" would become 1.0.0-0 which is the wrong direction.
		    case 'pre':
		      if (this.prerelease.length === 0) {
		        this.prerelease = [0];
		      } else {
		        var i = this.prerelease.length;
		        while (--i >= 0) {
		          if (typeof this.prerelease[i] === 'number') {
		            this.prerelease[i]++;
		            i = -2;
		          }
		        }
		        if (i === -1) {
		          // didn't increment anything
		          this.prerelease.push(0);
		        }
		      }
		      if (identifier) {
		        // 1.2.0-beta.1 bumps to 1.2.0-beta.2,
		        // 1.2.0-beta.fooblz or 1.2.0-beta bumps to 1.2.0-beta.0
		        if (this.prerelease[0] === identifier) {
		          if (isNaN(this.prerelease[1])) {
		            this.prerelease = [identifier, 0];
		          }
		        } else {
		          this.prerelease = [identifier, 0];
		        }
		      }
		      break

		    default:
		      throw new Error('invalid increment argument: ' + release)
		  }
		  this.format();
		  this.raw = this.version;
		  return this
		};

		exports.inc = inc;
		function inc (version, release, loose, identifier) {
		  if (typeof (loose) === 'string') {
		    identifier = loose;
		    loose = undefined;
		  }

		  try {
		    return new SemVer(version, loose).inc(release, identifier).version
		  } catch (er) {
		    return null
		  }
		}

		exports.diff = diff;
		function diff (version1, version2) {
		  if (eq(version1, version2)) {
		    return null
		  } else {
		    var v1 = parse(version1);
		    var v2 = parse(version2);
		    var prefix = '';
		    if (v1.prerelease.length || v2.prerelease.length) {
		      prefix = 'pre';
		      var defaultResult = 'prerelease';
		    }
		    for (var key in v1) {
		      if (key === 'major' || key === 'minor' || key === 'patch') {
		        if (v1[key] !== v2[key]) {
		          return prefix + key
		        }
		      }
		    }
		    return defaultResult // may be undefined
		  }
		}

		exports.compareIdentifiers = compareIdentifiers;

		var numeric = /^[0-9]+$/;
		function compareIdentifiers (a, b) {
		  var anum = numeric.test(a);
		  var bnum = numeric.test(b);

		  if (anum && bnum) {
		    a = +a;
		    b = +b;
		  }

		  return a === b ? 0
		    : (anum && !bnum) ? -1
		    : (bnum && !anum) ? 1
		    : a < b ? -1
		    : 1
		}

		exports.rcompareIdentifiers = rcompareIdentifiers;
		function rcompareIdentifiers (a, b) {
		  return compareIdentifiers(b, a)
		}

		exports.major = major;
		function major (a, loose) {
		  return new SemVer(a, loose).major
		}

		exports.minor = minor;
		function minor (a, loose) {
		  return new SemVer(a, loose).minor
		}

		exports.patch = patch;
		function patch (a, loose) {
		  return new SemVer(a, loose).patch
		}

		exports.compare = compare;
		function compare (a, b, loose) {
		  return new SemVer(a, loose).compare(new SemVer(b, loose))
		}

		exports.compareLoose = compareLoose;
		function compareLoose (a, b) {
		  return compare(a, b, true)
		}

		exports.compareBuild = compareBuild;
		function compareBuild (a, b, loose) {
		  var versionA = new SemVer(a, loose);
		  var versionB = new SemVer(b, loose);
		  return versionA.compare(versionB) || versionA.compareBuild(versionB)
		}

		exports.rcompare = rcompare;
		function rcompare (a, b, loose) {
		  return compare(b, a, loose)
		}

		exports.sort = sort;
		function sort (list, loose) {
		  return list.sort(function (a, b) {
		    return exports.compareBuild(a, b, loose)
		  })
		}

		exports.rsort = rsort;
		function rsort (list, loose) {
		  return list.sort(function (a, b) {
		    return exports.compareBuild(b, a, loose)
		  })
		}

		exports.gt = gt;
		function gt (a, b, loose) {
		  return compare(a, b, loose) > 0
		}

		exports.lt = lt;
		function lt (a, b, loose) {
		  return compare(a, b, loose) < 0
		}

		exports.eq = eq;
		function eq (a, b, loose) {
		  return compare(a, b, loose) === 0
		}

		exports.neq = neq;
		function neq (a, b, loose) {
		  return compare(a, b, loose) !== 0
		}

		exports.gte = gte;
		function gte (a, b, loose) {
		  return compare(a, b, loose) >= 0
		}

		exports.lte = lte;
		function lte (a, b, loose) {
		  return compare(a, b, loose) <= 0
		}

		exports.cmp = cmp;
		function cmp (a, op, b, loose) {
		  switch (op) {
		    case '===':
		      if (typeof a === 'object')
		        a = a.version;
		      if (typeof b === 'object')
		        b = b.version;
		      return a === b

		    case '!==':
		      if (typeof a === 'object')
		        a = a.version;
		      if (typeof b === 'object')
		        b = b.version;
		      return a !== b

		    case '':
		    case '=':
		    case '==':
		      return eq(a, b, loose)

		    case '!=':
		      return neq(a, b, loose)

		    case '>':
		      return gt(a, b, loose)

		    case '>=':
		      return gte(a, b, loose)

		    case '<':
		      return lt(a, b, loose)

		    case '<=':
		      return lte(a, b, loose)

		    default:
		      throw new TypeError('Invalid operator: ' + op)
		  }
		}

		exports.Comparator = Comparator;
		function Comparator (comp, options) {
		  if (!options || typeof options !== 'object') {
		    options = {
		      loose: !!options,
		      includePrerelease: false
		    };
		  }

		  if (comp instanceof Comparator) {
		    if (comp.loose === !!options.loose) {
		      return comp
		    } else {
		      comp = comp.value;
		    }
		  }

		  if (!(this instanceof Comparator)) {
		    return new Comparator(comp, options)
		  }

		  comp = comp.trim().split(/\s+/).join(' ');
		  debug('comparator', comp, options);
		  this.options = options;
		  this.loose = !!options.loose;
		  this.parse(comp);

		  if (this.semver === ANY) {
		    this.value = '';
		  } else {
		    this.value = this.operator + this.semver.version;
		  }

		  debug('comp', this);
		}

		var ANY = {};
		Comparator.prototype.parse = function (comp) {
		  var r = this.options.loose ? safeRe[t.COMPARATORLOOSE] : safeRe[t.COMPARATOR];
		  var m = comp.match(r);

		  if (!m) {
		    throw new TypeError('Invalid comparator: ' + comp)
		  }

		  this.operator = m[1] !== undefined ? m[1] : '';
		  if (this.operator === '=') {
		    this.operator = '';
		  }

		  // if it literally is just '>' or '' then allow anything.
		  if (!m[2]) {
		    this.semver = ANY;
		  } else {
		    this.semver = new SemVer(m[2], this.options.loose);
		  }
		};

		Comparator.prototype.toString = function () {
		  return this.value
		};

		Comparator.prototype.test = function (version) {
		  debug('Comparator.test', version, this.options.loose);

		  if (this.semver === ANY || version === ANY) {
		    return true
		  }

		  if (typeof version === 'string') {
		    try {
		      version = new SemVer(version, this.options);
		    } catch (er) {
		      return false
		    }
		  }

		  return cmp(version, this.operator, this.semver, this.options)
		};

		Comparator.prototype.intersects = function (comp, options) {
		  if (!(comp instanceof Comparator)) {
		    throw new TypeError('a Comparator is required')
		  }

		  if (!options || typeof options !== 'object') {
		    options = {
		      loose: !!options,
		      includePrerelease: false
		    };
		  }

		  var rangeTmp;

		  if (this.operator === '') {
		    if (this.value === '') {
		      return true
		    }
		    rangeTmp = new Range(comp.value, options);
		    return satisfies(this.value, rangeTmp, options)
		  } else if (comp.operator === '') {
		    if (comp.value === '') {
		      return true
		    }
		    rangeTmp = new Range(this.value, options);
		    return satisfies(comp.semver, rangeTmp, options)
		  }

		  var sameDirectionIncreasing =
		    (this.operator === '>=' || this.operator === '>') &&
		    (comp.operator === '>=' || comp.operator === '>');
		  var sameDirectionDecreasing =
		    (this.operator === '<=' || this.operator === '<') &&
		    (comp.operator === '<=' || comp.operator === '<');
		  var sameSemVer = this.semver.version === comp.semver.version;
		  var differentDirectionsInclusive =
		    (this.operator === '>=' || this.operator === '<=') &&
		    (comp.operator === '>=' || comp.operator === '<=');
		  var oppositeDirectionsLessThan =
		    cmp(this.semver, '<', comp.semver, options) &&
		    ((this.operator === '>=' || this.operator === '>') &&
		    (comp.operator === '<=' || comp.operator === '<'));
		  var oppositeDirectionsGreaterThan =
		    cmp(this.semver, '>', comp.semver, options) &&
		    ((this.operator === '<=' || this.operator === '<') &&
		    (comp.operator === '>=' || comp.operator === '>'));

		  return sameDirectionIncreasing || sameDirectionDecreasing ||
		    (sameSemVer && differentDirectionsInclusive) ||
		    oppositeDirectionsLessThan || oppositeDirectionsGreaterThan
		};

		exports.Range = Range;
		function Range (range, options) {
		  if (!options || typeof options !== 'object') {
		    options = {
		      loose: !!options,
		      includePrerelease: false
		    };
		  }

		  if (range instanceof Range) {
		    if (range.loose === !!options.loose &&
		        range.includePrerelease === !!options.includePrerelease) {
		      return range
		    } else {
		      return new Range(range.raw, options)
		    }
		  }

		  if (range instanceof Comparator) {
		    return new Range(range.value, options)
		  }

		  if (!(this instanceof Range)) {
		    return new Range(range, options)
		  }

		  this.options = options;
		  this.loose = !!options.loose;
		  this.includePrerelease = !!options.includePrerelease;

		  // First reduce all whitespace as much as possible so we do not have to rely
		  // on potentially slow regexes like \s*. This is then stored and used for
		  // future error messages as well.
		  this.raw = range
		    .trim()
		    .split(/\s+/)
		    .join(' ');

		  // First, split based on boolean or ||
		  this.set = this.raw.split('||').map(function (range) {
		    return this.parseRange(range.trim())
		  }, this).filter(function (c) {
		    // throw out any that are not relevant for whatever reason
		    return c.length
		  });

		  if (!this.set.length) {
		    throw new TypeError('Invalid SemVer Range: ' + this.raw)
		  }

		  this.format();
		}

		Range.prototype.format = function () {
		  this.range = this.set.map(function (comps) {
		    return comps.join(' ').trim()
		  }).join('||').trim();
		  return this.range
		};

		Range.prototype.toString = function () {
		  return this.range
		};

		Range.prototype.parseRange = function (range) {
		  var loose = this.options.loose;
		  // `1.2.3 - 1.2.4` => `>=1.2.3 <=1.2.4`
		  var hr = loose ? safeRe[t.HYPHENRANGELOOSE] : safeRe[t.HYPHENRANGE];
		  range = range.replace(hr, hyphenReplace);
		  debug('hyphen replace', range);
		  // `> 1.2.3 < 1.2.5` => `>1.2.3 <1.2.5`
		  range = range.replace(safeRe[t.COMPARATORTRIM], comparatorTrimReplace);
		  debug('comparator trim', range, safeRe[t.COMPARATORTRIM]);

		  // `~ 1.2.3` => `~1.2.3`
		  range = range.replace(safeRe[t.TILDETRIM], tildeTrimReplace);

		  // `^ 1.2.3` => `^1.2.3`
		  range = range.replace(safeRe[t.CARETTRIM], caretTrimReplace);

		  // normalize spaces
		  range = range.split(/\s+/).join(' ');

		  // At this point, the range is completely trimmed and
		  // ready to be split into comparators.

		  var compRe = loose ? safeRe[t.COMPARATORLOOSE] : safeRe[t.COMPARATOR];
		  var set = range.split(' ').map(function (comp) {
		    return parseComparator(comp, this.options)
		  }, this).join(' ').split(/\s+/);
		  if (this.options.loose) {
		    // in loose mode, throw out any that are not valid comparators
		    set = set.filter(function (comp) {
		      return !!comp.match(compRe)
		    });
		  }
		  set = set.map(function (comp) {
		    return new Comparator(comp, this.options)
		  }, this);

		  return set
		};

		Range.prototype.intersects = function (range, options) {
		  if (!(range instanceof Range)) {
		    throw new TypeError('a Range is required')
		  }

		  return this.set.some(function (thisComparators) {
		    return (
		      isSatisfiable(thisComparators, options) &&
		      range.set.some(function (rangeComparators) {
		        return (
		          isSatisfiable(rangeComparators, options) &&
		          thisComparators.every(function (thisComparator) {
		            return rangeComparators.every(function (rangeComparator) {
		              return thisComparator.intersects(rangeComparator, options)
		            })
		          })
		        )
		      })
		    )
		  })
		};

		// take a set of comparators and determine whether there
		// exists a version which can satisfy it
		function isSatisfiable (comparators, options) {
		  var result = true;
		  var remainingComparators = comparators.slice();
		  var testComparator = remainingComparators.pop();

		  while (result && remainingComparators.length) {
		    result = remainingComparators.every(function (otherComparator) {
		      return testComparator.intersects(otherComparator, options)
		    });

		    testComparator = remainingComparators.pop();
		  }

		  return result
		}

		// Mostly just for testing and legacy API reasons
		exports.toComparators = toComparators;
		function toComparators (range, options) {
		  return new Range(range, options).set.map(function (comp) {
		    return comp.map(function (c) {
		      return c.value
		    }).join(' ').trim().split(' ')
		  })
		}

		// comprised of xranges, tildes, stars, and gtlt's at this point.
		// already replaced the hyphen ranges
		// turn into a set of JUST comparators.
		function parseComparator (comp, options) {
		  debug('comp', comp, options);
		  comp = replaceCarets(comp, options);
		  debug('caret', comp);
		  comp = replaceTildes(comp, options);
		  debug('tildes', comp);
		  comp = replaceXRanges(comp, options);
		  debug('xrange', comp);
		  comp = replaceStars(comp, options);
		  debug('stars', comp);
		  return comp
		}

		function isX (id) {
		  return !id || id.toLowerCase() === 'x' || id === '*'
		}

		// ~, ~> --> * (any, kinda silly)
		// ~2, ~2.x, ~2.x.x, ~>2, ~>2.x ~>2.x.x --> >=2.0.0 <3.0.0
		// ~2.0, ~2.0.x, ~>2.0, ~>2.0.x --> >=2.0.0 <2.1.0
		// ~1.2, ~1.2.x, ~>1.2, ~>1.2.x --> >=1.2.0 <1.3.0
		// ~1.2.3, ~>1.2.3 --> >=1.2.3 <1.3.0
		// ~1.2.0, ~>1.2.0 --> >=1.2.0 <1.3.0
		function replaceTildes (comp, options) {
		  return comp.trim().split(/\s+/).map(function (comp) {
		    return replaceTilde(comp, options)
		  }).join(' ')
		}

		function replaceTilde (comp, options) {
		  var r = options.loose ? safeRe[t.TILDELOOSE] : safeRe[t.TILDE];
		  return comp.replace(r, function (_, M, m, p, pr) {
		    debug('tilde', comp, _, M, m, p, pr);
		    var ret;

		    if (isX(M)) {
		      ret = '';
		    } else if (isX(m)) {
		      ret = '>=' + M + '.0.0 <' + (+M + 1) + '.0.0';
		    } else if (isX(p)) {
		      // ~1.2 == >=1.2.0 <1.3.0
		      ret = '>=' + M + '.' + m + '.0 <' + M + '.' + (+m + 1) + '.0';
		    } else if (pr) {
		      debug('replaceTilde pr', pr);
		      ret = '>=' + M + '.' + m + '.' + p + '-' + pr +
		            ' <' + M + '.' + (+m + 1) + '.0';
		    } else {
		      // ~1.2.3 == >=1.2.3 <1.3.0
		      ret = '>=' + M + '.' + m + '.' + p +
		            ' <' + M + '.' + (+m + 1) + '.0';
		    }

		    debug('tilde return', ret);
		    return ret
		  })
		}

		// ^ --> * (any, kinda silly)
		// ^2, ^2.x, ^2.x.x --> >=2.0.0 <3.0.0
		// ^2.0, ^2.0.x --> >=2.0.0 <3.0.0
		// ^1.2, ^1.2.x --> >=1.2.0 <2.0.0
		// ^1.2.3 --> >=1.2.3 <2.0.0
		// ^1.2.0 --> >=1.2.0 <2.0.0
		function replaceCarets (comp, options) {
		  return comp.trim().split(/\s+/).map(function (comp) {
		    return replaceCaret(comp, options)
		  }).join(' ')
		}

		function replaceCaret (comp, options) {
		  debug('caret', comp, options);
		  var r = options.loose ? safeRe[t.CARETLOOSE] : safeRe[t.CARET];
		  return comp.replace(r, function (_, M, m, p, pr) {
		    debug('caret', comp, _, M, m, p, pr);
		    var ret;

		    if (isX(M)) {
		      ret = '';
		    } else if (isX(m)) {
		      ret = '>=' + M + '.0.0 <' + (+M + 1) + '.0.0';
		    } else if (isX(p)) {
		      if (M === '0') {
		        ret = '>=' + M + '.' + m + '.0 <' + M + '.' + (+m + 1) + '.0';
		      } else {
		        ret = '>=' + M + '.' + m + '.0 <' + (+M + 1) + '.0.0';
		      }
		    } else if (pr) {
		      debug('replaceCaret pr', pr);
		      if (M === '0') {
		        if (m === '0') {
		          ret = '>=' + M + '.' + m + '.' + p + '-' + pr +
		                ' <' + M + '.' + m + '.' + (+p + 1);
		        } else {
		          ret = '>=' + M + '.' + m + '.' + p + '-' + pr +
		                ' <' + M + '.' + (+m + 1) + '.0';
		        }
		      } else {
		        ret = '>=' + M + '.' + m + '.' + p + '-' + pr +
		              ' <' + (+M + 1) + '.0.0';
		      }
		    } else {
		      debug('no pr');
		      if (M === '0') {
		        if (m === '0') {
		          ret = '>=' + M + '.' + m + '.' + p +
		                ' <' + M + '.' + m + '.' + (+p + 1);
		        } else {
		          ret = '>=' + M + '.' + m + '.' + p +
		                ' <' + M + '.' + (+m + 1) + '.0';
		        }
		      } else {
		        ret = '>=' + M + '.' + m + '.' + p +
		              ' <' + (+M + 1) + '.0.0';
		      }
		    }

		    debug('caret return', ret);
		    return ret
		  })
		}

		function replaceXRanges (comp, options) {
		  debug('replaceXRanges', comp, options);
		  return comp.split(/\s+/).map(function (comp) {
		    return replaceXRange(comp, options)
		  }).join(' ')
		}

		function replaceXRange (comp, options) {
		  comp = comp.trim();
		  var r = options.loose ? safeRe[t.XRANGELOOSE] : safeRe[t.XRANGE];
		  return comp.replace(r, function (ret, gtlt, M, m, p, pr) {
		    debug('xRange', comp, ret, gtlt, M, m, p, pr);
		    var xM = isX(M);
		    var xm = xM || isX(m);
		    var xp = xm || isX(p);
		    var anyX = xp;

		    if (gtlt === '=' && anyX) {
		      gtlt = '';
		    }

		    // if we're including prereleases in the match, then we need
		    // to fix this to -0, the lowest possible prerelease value
		    pr = options.includePrerelease ? '-0' : '';

		    if (xM) {
		      if (gtlt === '>' || gtlt === '<') {
		        // nothing is allowed
		        ret = '<0.0.0-0';
		      } else {
		        // nothing is forbidden
		        ret = '*';
		      }
		    } else if (gtlt && anyX) {
		      // we know patch is an x, because we have any x at all.
		      // replace X with 0
		      if (xm) {
		        m = 0;
		      }
		      p = 0;

		      if (gtlt === '>') {
		        // >1 => >=2.0.0
		        // >1.2 => >=1.3.0
		        // >1.2.3 => >= 1.2.4
		        gtlt = '>=';
		        if (xm) {
		          M = +M + 1;
		          m = 0;
		          p = 0;
		        } else {
		          m = +m + 1;
		          p = 0;
		        }
		      } else if (gtlt === '<=') {
		        // <=0.7.x is actually <0.8.0, since any 0.7.x should
		        // pass.  Similarly, <=7.x is actually <8.0.0, etc.
		        gtlt = '<';
		        if (xm) {
		          M = +M + 1;
		        } else {
		          m = +m + 1;
		        }
		      }

		      ret = gtlt + M + '.' + m + '.' + p + pr;
		    } else if (xm) {
		      ret = '>=' + M + '.0.0' + pr + ' <' + (+M + 1) + '.0.0' + pr;
		    } else if (xp) {
		      ret = '>=' + M + '.' + m + '.0' + pr +
		        ' <' + M + '.' + (+m + 1) + '.0' + pr;
		    }

		    debug('xRange return', ret);

		    return ret
		  })
		}

		// Because * is AND-ed with everything else in the comparator,
		// and '' means "any version", just remove the *s entirely.
		function replaceStars (comp, options) {
		  debug('replaceStars', comp, options);
		  // Looseness is ignored here.  star is always as loose as it gets!
		  return comp.trim().replace(safeRe[t.STAR], '')
		}

		// This function is passed to string.replace(re[t.HYPHENRANGE])
		// M, m, patch, prerelease, build
		// 1.2 - 3.4.5 => >=1.2.0 <=3.4.5
		// 1.2.3 - 3.4 => >=1.2.0 <3.5.0 Any 3.4.x will do
		// 1.2 - 3.4 => >=1.2.0 <3.5.0
		function hyphenReplace ($0,
		  from, fM, fm, fp, fpr, fb,
		  to, tM, tm, tp, tpr, tb) {
		  if (isX(fM)) {
		    from = '';
		  } else if (isX(fm)) {
		    from = '>=' + fM + '.0.0';
		  } else if (isX(fp)) {
		    from = '>=' + fM + '.' + fm + '.0';
		  } else {
		    from = '>=' + from;
		  }

		  if (isX(tM)) {
		    to = '';
		  } else if (isX(tm)) {
		    to = '<' + (+tM + 1) + '.0.0';
		  } else if (isX(tp)) {
		    to = '<' + tM + '.' + (+tm + 1) + '.0';
		  } else if (tpr) {
		    to = '<=' + tM + '.' + tm + '.' + tp + '-' + tpr;
		  } else {
		    to = '<=' + to;
		  }

		  return (from + ' ' + to).trim()
		}

		// if ANY of the sets match ALL of its comparators, then pass
		Range.prototype.test = function (version) {
		  if (!version) {
		    return false
		  }

		  if (typeof version === 'string') {
		    try {
		      version = new SemVer(version, this.options);
		    } catch (er) {
		      return false
		    }
		  }

		  for (var i = 0; i < this.set.length; i++) {
		    if (testSet(this.set[i], version, this.options)) {
		      return true
		    }
		  }
		  return false
		};

		function testSet (set, version, options) {
		  for (var i = 0; i < set.length; i++) {
		    if (!set[i].test(version)) {
		      return false
		    }
		  }

		  if (version.prerelease.length && !options.includePrerelease) {
		    // Find the set of versions that are allowed to have prereleases
		    // For example, ^1.2.3-pr.1 desugars to >=1.2.3-pr.1 <2.0.0
		    // That should allow `1.2.3-pr.2` to pass.
		    // However, `1.2.4-alpha.notready` should NOT be allowed,
		    // even though it's within the range set by the comparators.
		    for (i = 0; i < set.length; i++) {
		      debug(set[i].semver);
		      if (set[i].semver === ANY) {
		        continue
		      }

		      if (set[i].semver.prerelease.length > 0) {
		        var allowed = set[i].semver;
		        if (allowed.major === version.major &&
		            allowed.minor === version.minor &&
		            allowed.patch === version.patch) {
		          return true
		        }
		      }
		    }

		    // Version has a -pre, but it's not one of the ones we like.
		    return false
		  }

		  return true
		}

		exports.satisfies = satisfies;
		function satisfies (version, range, options) {
		  try {
		    range = new Range(range, options);
		  } catch (er) {
		    return false
		  }
		  return range.test(version)
		}

		exports.maxSatisfying = maxSatisfying;
		function maxSatisfying (versions, range, options) {
		  var max = null;
		  var maxSV = null;
		  try {
		    var rangeObj = new Range(range, options);
		  } catch (er) {
		    return null
		  }
		  versions.forEach(function (v) {
		    if (rangeObj.test(v)) {
		      // satisfies(v, range, options)
		      if (!max || maxSV.compare(v) === -1) {
		        // compare(max, v, true)
		        max = v;
		        maxSV = new SemVer(max, options);
		      }
		    }
		  });
		  return max
		}

		exports.minSatisfying = minSatisfying;
		function minSatisfying (versions, range, options) {
		  var min = null;
		  var minSV = null;
		  try {
		    var rangeObj = new Range(range, options);
		  } catch (er) {
		    return null
		  }
		  versions.forEach(function (v) {
		    if (rangeObj.test(v)) {
		      // satisfies(v, range, options)
		      if (!min || minSV.compare(v) === 1) {
		        // compare(min, v, true)
		        min = v;
		        minSV = new SemVer(min, options);
		      }
		    }
		  });
		  return min
		}

		exports.minVersion = minVersion;
		function minVersion (range, loose) {
		  range = new Range(range, loose);

		  var minver = new SemVer('0.0.0');
		  if (range.test(minver)) {
		    return minver
		  }

		  minver = new SemVer('0.0.0-0');
		  if (range.test(minver)) {
		    return minver
		  }

		  minver = null;
		  for (var i = 0; i < range.set.length; ++i) {
		    var comparators = range.set[i];

		    comparators.forEach(function (comparator) {
		      // Clone to avoid manipulating the comparator's semver object.
		      var compver = new SemVer(comparator.semver.version);
		      switch (comparator.operator) {
		        case '>':
		          if (compver.prerelease.length === 0) {
		            compver.patch++;
		          } else {
		            compver.prerelease.push(0);
		          }
		          compver.raw = compver.format();
		          /* fallthrough */
		        case '':
		        case '>=':
		          if (!minver || gt(minver, compver)) {
		            minver = compver;
		          }
		          break
		        case '<':
		        case '<=':
		          /* Ignore maximum versions */
		          break
		        /* istanbul ignore next */
		        default:
		          throw new Error('Unexpected operation: ' + comparator.operator)
		      }
		    });
		  }

		  if (minver && range.test(minver)) {
		    return minver
		  }

		  return null
		}

		exports.validRange = validRange;
		function validRange (range, options) {
		  try {
		    // Return '*' instead of '' so that truthiness works.
		    // This will throw if it's invalid anyway
		    return new Range(range, options).range || '*'
		  } catch (er) {
		    return null
		  }
		}

		// Determine if version is less than all the versions possible in the range
		exports.ltr = ltr;
		function ltr (version, range, options) {
		  return outside(version, range, '<', options)
		}

		// Determine if version is greater than all the versions possible in the range.
		exports.gtr = gtr;
		function gtr (version, range, options) {
		  return outside(version, range, '>', options)
		}

		exports.outside = outside;
		function outside (version, range, hilo, options) {
		  version = new SemVer(version, options);
		  range = new Range(range, options);

		  var gtfn, ltefn, ltfn, comp, ecomp;
		  switch (hilo) {
		    case '>':
		      gtfn = gt;
		      ltefn = lte;
		      ltfn = lt;
		      comp = '>';
		      ecomp = '>=';
		      break
		    case '<':
		      gtfn = lt;
		      ltefn = gte;
		      ltfn = gt;
		      comp = '<';
		      ecomp = '<=';
		      break
		    default:
		      throw new TypeError('Must provide a hilo val of "<" or ">"')
		  }

		  // If it satisifes the range it is not outside
		  if (satisfies(version, range, options)) {
		    return false
		  }

		  // From now on, variable terms are as if we're in "gtr" mode.
		  // but note that everything is flipped for the "ltr" function.

		  for (var i = 0; i < range.set.length; ++i) {
		    var comparators = range.set[i];

		    var high = null;
		    var low = null;

		    comparators.forEach(function (comparator) {
		      if (comparator.semver === ANY) {
		        comparator = new Comparator('>=0.0.0');
		      }
		      high = high || comparator;
		      low = low || comparator;
		      if (gtfn(comparator.semver, high.semver, options)) {
		        high = comparator;
		      } else if (ltfn(comparator.semver, low.semver, options)) {
		        low = comparator;
		      }
		    });

		    // If the edge version comparator has a operator then our version
		    // isn't outside it
		    if (high.operator === comp || high.operator === ecomp) {
		      return false
		    }

		    // If the lowest version comparator has an operator and our version
		    // is less than it then it isn't higher than the range
		    if ((!low.operator || low.operator === comp) &&
		        ltefn(version, low.semver)) {
		      return false
		    } else if (low.operator === ecomp && ltfn(version, low.semver)) {
		      return false
		    }
		  }
		  return true
		}

		exports.prerelease = prerelease;
		function prerelease (version, options) {
		  var parsed = parse(version, options);
		  return (parsed && parsed.prerelease.length) ? parsed.prerelease : null
		}

		exports.intersects = intersects;
		function intersects (r1, r2, options) {
		  r1 = new Range(r1, options);
		  r2 = new Range(r2, options);
		  return r1.intersects(r2)
		}

		exports.coerce = coerce;
		function coerce (version, options) {
		  if (version instanceof SemVer) {
		    return version
		  }

		  if (typeof version === 'number') {
		    version = String(version);
		  }

		  if (typeof version !== 'string') {
		    return null
		  }

		  options = options || {};

		  var match = null;
		  if (!options.rtl) {
		    match = version.match(safeRe[t.COERCE]);
		  } else {
		    // Find the right-most coercible string that does not share
		    // a terminus with a more left-ward coercible string.
		    // Eg, '1.2.3.4' wants to coerce '2.3.4', not '3.4' or '4'
		    //
		    // Walk through the string checking with a /g regexp
		    // Manually set the index so as to pick up overlapping matches.
		    // Stop when we get a match that ends at the string end, since no
		    // coercible string can be more right-ward without the same terminus.
		    var next;
		    while ((next = safeRe[t.COERCERTL].exec(version)) &&
		      (!match || match.index + match[0].length !== version.length)
		    ) {
		      if (!match ||
		          next.index + next[0].length !== match.index + match[0].length) {
		        match = next;
		      }
		      safeRe[t.COERCERTL].lastIndex = next.index + next[1].length + next[2].length;
		    }
		    // leave it in a clean state
		    safeRe[t.COERCERTL].lastIndex = -1;
		  }

		  if (match === null) {
		    return null
		  }

		  return parse(match[2] +
		    '.' + (match[3] || '0') +
		    '.' + (match[4] || '0'), options)
		} 
	} (semver$1, semver$1.exports));
	return semver$1.exports;
}

var hasRequiredFile;

function requireFile () {
	if (hasRequiredFile) return file;
	hasRequiredFile = 1;

	Object.defineProperty(file, "__esModule", {
	  value: true
	});
	file.default = void 0;
	function helpers() {
	  const data = requireLib$6();
	  helpers = function () {
	    return data;
	  };
	  return data;
	}
	function _traverse() {
	  const data = requireLib$7();
	  _traverse = function () {
	    return data;
	  };
	  return data;
	}
	function _codeFrame() {
	  const data = requireLib$c();
	  _codeFrame = function () {
	    return data;
	  };
	  return data;
	}
	function _t() {
	  const data = requireLib$h();
	  _t = function () {
	    return data;
	  };
	  return data;
	}
	function _helperModuleTransforms() {
	  const data = requireLib$3();
	  _helperModuleTransforms = function () {
	    return data;
	  };
	  return data;
	}
	function _semver() {
	  const data = requireSemver$1();
	  _semver = function () {
	    return data;
	  };
	  return data;
	}
	const {
	  cloneNode,
	  interpreterDirective
	} = _t();
	const errorVisitor = {
	  enter(path, state) {
	    const loc = path.node.loc;
	    if (loc) {
	      state.loc = loc;
	      path.stop();
	    }
	  }
	};
	class File {
	  constructor(options, {
	    code,
	    ast,
	    inputMap
	  }) {
	    this._map = new Map();
	    this.opts = void 0;
	    this.declarations = {};
	    this.path = void 0;
	    this.ast = void 0;
	    this.scope = void 0;
	    this.metadata = {};
	    this.code = "";
	    this.inputMap = void 0;
	    this.hub = {
	      file: this,
	      getCode: () => this.code,
	      getScope: () => this.scope,
	      addHelper: this.addHelper.bind(this),
	      buildError: this.buildCodeFrameError.bind(this)
	    };
	    this.opts = options;
	    this.code = code;
	    this.ast = ast;
	    this.inputMap = inputMap;
	    this.path = _traverse().NodePath.get({
	      hub: this.hub,
	      parentPath: null,
	      parent: this.ast,
	      container: this.ast,
	      key: "program"
	    }).setContext();
	    this.scope = this.path.scope;
	  }
	  get shebang() {
	    const {
	      interpreter
	    } = this.path.node;
	    return interpreter ? interpreter.value : "";
	  }
	  set shebang(value) {
	    if (value) {
	      this.path.get("interpreter").replaceWith(interpreterDirective(value));
	    } else {
	      this.path.get("interpreter").remove();
	    }
	  }
	  set(key, val) {
	    {
	      if (key === "helpersNamespace") {
	        throw new Error("Babel 7.0.0-beta.56 has dropped support for the 'helpersNamespace' utility." + "If you are using @babel/plugin-external-helpers you will need to use a newer " + "version than the one you currently have installed. " + "If you have your own implementation, you'll want to explore using 'helperGenerator' " + "alongside 'file.availableHelper()'.");
	      }
	    }
	    this._map.set(key, val);
	  }
	  get(key) {
	    return this._map.get(key);
	  }
	  has(key) {
	    return this._map.has(key);
	  }
	  getModuleName() {
	    return (0, _helperModuleTransforms().getModuleName)(this.opts, this.opts);
	  }
	  availableHelper(name, versionRange) {
	    let minVersion;
	    try {
	      minVersion = helpers().minVersion(name);
	    } catch (err) {
	      if (err.code !== "BABEL_HELPER_UNKNOWN") throw err;
	      return false;
	    }
	    if (typeof versionRange !== "string") return true;
	    if (_semver().valid(versionRange)) versionRange = `^${versionRange}`;
	    {
	      return !_semver().intersects(`<${minVersion}`, versionRange) && !_semver().intersects(`>=8.0.0`, versionRange);
	    }
	  }
	  addHelper(name) {
	    const declar = this.declarations[name];
	    if (declar) return cloneNode(declar);
	    const generator = this.get("helperGenerator");
	    if (generator) {
	      const res = generator(name);
	      if (res) return res;
	    }
	    helpers().ensure(name, File);
	    const uid = this.declarations[name] = this.scope.generateUidIdentifier(name);
	    const dependencies = {};
	    for (const dep of helpers().getDependencies(name)) {
	      dependencies[dep] = this.addHelper(dep);
	    }
	    const {
	      nodes,
	      globals
	    } = helpers().get(name, dep => dependencies[dep], uid, Object.keys(this.scope.getAllBindings()));
	    globals.forEach(name => {
	      if (this.path.scope.hasBinding(name, true)) {
	        this.path.scope.rename(name);
	      }
	    });
	    nodes.forEach(node => {
	      node._compact = true;
	    });
	    const added = this.path.unshiftContainer("body", nodes);
	    for (const path of added) {
	      if (path.isVariableDeclaration()) this.scope.registerDeclaration(path);
	    }
	    return uid;
	  }
	  buildCodeFrameError(node, msg, _Error = SyntaxError) {
	    let loc = node == null ? void 0 : node.loc;
	    if (!loc && node) {
	      const state = {
	        loc: null
	      };
	      (0, _traverse().default)(node, errorVisitor, this.scope, state);
	      loc = state.loc;
	      let txt = "This is an error on an internal node. Probably an internal error.";
	      if (loc) txt += " Location has been estimated.";
	      msg += ` (${txt})`;
	    }
	    if (loc) {
	      const {
	        highlightCode = true
	      } = this.opts;
	      msg += "\n" + (0, _codeFrame().codeFrameColumns)(this.code, {
	        start: {
	          line: loc.start.line,
	          column: loc.start.column + 1
	        },
	        end: loc.end && loc.start.line === loc.end.line ? {
	          line: loc.end.line,
	          column: loc.end.column + 1
	        } : undefined
	      }, {
	        highlightCode
	      });
	    }
	    return new _Error(msg);
	  }
	}
	file.default = File;
	{
	  File.prototype.addImport = function addImport() {
	    throw new Error("This API has been removed. If you're looking for this " + "functionality in Babel 7, you should import the " + "'@babel/helper-module-imports' module and use the functions exposed " + " from that module, such as 'addNamed' or 'addDefault'.");
	  };
	  File.prototype.addTemplateObject = function addTemplateObject() {
	    throw new Error("This function has been moved into the template literal transform itself.");
	  };
	}

	
	return file;
}

var buildExternalHelpers = {};

var hasRequiredBuildExternalHelpers;

function requireBuildExternalHelpers () {
	if (hasRequiredBuildExternalHelpers) return buildExternalHelpers;
	hasRequiredBuildExternalHelpers = 1;

	Object.defineProperty(buildExternalHelpers, "__esModule", {
	  value: true
	});
	buildExternalHelpers.default = _default;
	function helpers() {
	  const data = requireLib$6();
	  helpers = function () {
	    return data;
	  };
	  return data;
	}
	function _generator() {
	  const data = requireLib$e();
	  _generator = function () {
	    return data;
	  };
	  return data;
	}
	function _template() {
	  const data = requireLib$9();
	  _template = function () {
	    return data;
	  };
	  return data;
	}
	function _t() {
	  const data = requireLib$h();
	  _t = function () {
	    return data;
	  };
	  return data;
	}
	var _file = requireFile();
	const {
	  arrayExpression,
	  assignmentExpression,
	  binaryExpression,
	  blockStatement,
	  callExpression,
	  cloneNode,
	  conditionalExpression,
	  exportNamedDeclaration,
	  exportSpecifier,
	  expressionStatement,
	  functionExpression,
	  identifier,
	  memberExpression,
	  objectExpression,
	  program,
	  stringLiteral,
	  unaryExpression,
	  variableDeclaration,
	  variableDeclarator
	} = _t();
	const buildUmdWrapper = replacements => _template().default.statement`
    (function (root, factory) {
      if (typeof define === "function" && define.amd) {
        define(AMD_ARGUMENTS, factory);
      } else if (typeof exports === "object") {
        factory(COMMON_ARGUMENTS);
      } else {
        factory(BROWSER_ARGUMENTS);
      }
    })(UMD_ROOT, function (FACTORY_PARAMETERS) {
      FACTORY_BODY
    });
  `(replacements);
	function buildGlobal(allowlist) {
	  const namespace = identifier("babelHelpers");
	  const body = [];
	  const container = functionExpression(null, [identifier("global")], blockStatement(body));
	  const tree = program([expressionStatement(callExpression(container, [conditionalExpression(binaryExpression("===", unaryExpression("typeof", identifier("global")), stringLiteral("undefined")), identifier("self"), identifier("global"))]))]);
	  body.push(variableDeclaration("var", [variableDeclarator(namespace, assignmentExpression("=", memberExpression(identifier("global"), namespace), objectExpression([])))]));
	  buildHelpers(body, namespace, allowlist);
	  return tree;
	}
	function buildModule(allowlist) {
	  const body = [];
	  const refs = buildHelpers(body, null, allowlist);
	  body.unshift(exportNamedDeclaration(null, Object.keys(refs).map(name => {
	    return exportSpecifier(cloneNode(refs[name]), identifier(name));
	  })));
	  return program(body, [], "module");
	}
	function buildUmd(allowlist) {
	  const namespace = identifier("babelHelpers");
	  const body = [];
	  body.push(variableDeclaration("var", [variableDeclarator(namespace, identifier("global"))]));
	  buildHelpers(body, namespace, allowlist);
	  return program([buildUmdWrapper({
	    FACTORY_PARAMETERS: identifier("global"),
	    BROWSER_ARGUMENTS: assignmentExpression("=", memberExpression(identifier("root"), namespace), objectExpression([])),
	    COMMON_ARGUMENTS: identifier("exports"),
	    AMD_ARGUMENTS: arrayExpression([stringLiteral("exports")]),
	    FACTORY_BODY: body,
	    UMD_ROOT: identifier("this")
	  })]);
	}
	function buildVar(allowlist) {
	  const namespace = identifier("babelHelpers");
	  const body = [];
	  body.push(variableDeclaration("var", [variableDeclarator(namespace, objectExpression([]))]));
	  const tree = program(body);
	  buildHelpers(body, namespace, allowlist);
	  body.push(expressionStatement(namespace));
	  return tree;
	}
	function buildHelpers(body, namespace, allowlist) {
	  const getHelperReference = name => {
	    return namespace ? memberExpression(namespace, identifier(name)) : identifier(`_${name}`);
	  };
	  const refs = {};
	  helpers().list.forEach(function (name) {
	    if (allowlist && allowlist.indexOf(name) < 0) return;
	    const ref = refs[name] = getHelperReference(name);
	    helpers().ensure(name, _file.default);
	    const {
	      nodes
	    } = helpers().get(name, getHelperReference, ref);
	    body.push(...nodes);
	  });
	  return refs;
	}
	function _default(allowlist, outputType = "global") {
	  let tree;
	  const build = {
	    global: buildGlobal,
	    module: buildModule,
	    umd: buildUmd,
	    var: buildVar
	  }[outputType];
	  if (build) {
	    tree = build(allowlist);
	  } else {
	    throw new Error(`Unsupported output type ${outputType}`);
	  }
	  return (0, _generator().default)(tree).code;
	}

	
	return buildExternalHelpers;
}

var files = {};

var _package = {};

var utils$1 = {};

var caching = {};

var gensync;
var hasRequiredGensync;

function requireGensync () {
	if (hasRequiredGensync) return gensync;
	hasRequiredGensync = 1;

	// These use the global symbol registry so that multiple copies of this
	// library can work together in case they are not deduped.
	const GENSYNC_START = Symbol.for("gensync:v1:start");
	const GENSYNC_SUSPEND = Symbol.for("gensync:v1:suspend");

	const GENSYNC_EXPECTED_START = "GENSYNC_EXPECTED_START";
	const GENSYNC_EXPECTED_SUSPEND = "GENSYNC_EXPECTED_SUSPEND";
	const GENSYNC_OPTIONS_ERROR = "GENSYNC_OPTIONS_ERROR";
	const GENSYNC_RACE_NONEMPTY = "GENSYNC_RACE_NONEMPTY";
	const GENSYNC_ERRBACK_NO_CALLBACK = "GENSYNC_ERRBACK_NO_CALLBACK";

	gensync = Object.assign(
	  function gensync(optsOrFn) {
	    let genFn = optsOrFn;
	    if (typeof optsOrFn !== "function") {
	      genFn = newGenerator(optsOrFn);
	    } else {
	      genFn = wrapGenerator(optsOrFn);
	    }

	    return Object.assign(genFn, makeFunctionAPI(genFn));
	  },
	  {
	    all: buildOperation({
	      name: "all",
	      arity: 1,
	      sync: function(args) {
	        const items = Array.from(args[0]);
	        return items.map(item => evaluateSync(item));
	      },
	      async: function(args, resolve, reject) {
	        const items = Array.from(args[0]);

	        if (items.length === 0) {
	          Promise.resolve().then(() => resolve([]));
	          return;
	        }

	        let count = 0;
	        const results = items.map(() => undefined);
	        items.forEach((item, i) => {
	          evaluateAsync(
	            item,
	            val => {
	              results[i] = val;
	              count += 1;

	              if (count === results.length) resolve(results);
	            },
	            reject
	          );
	        });
	      },
	    }),
	    race: buildOperation({
	      name: "race",
	      arity: 1,
	      sync: function(args) {
	        const items = Array.from(args[0]);
	        if (items.length === 0) {
	          throw makeError("Must race at least 1 item", GENSYNC_RACE_NONEMPTY);
	        }

	        return evaluateSync(items[0]);
	      },
	      async: function(args, resolve, reject) {
	        const items = Array.from(args[0]);
	        if (items.length === 0) {
	          throw makeError("Must race at least 1 item", GENSYNC_RACE_NONEMPTY);
	        }

	        for (const item of items) {
	          evaluateAsync(item, resolve, reject);
	        }
	      },
	    }),
	  }
	);

	/**
	 * Given a generator function, return the standard API object that executes
	 * the generator and calls the callbacks.
	 */
	function makeFunctionAPI(genFn) {
	  const fns = {
	    sync: function(...args) {
	      return evaluateSync(genFn.apply(this, args));
	    },
	    async: function(...args) {
	      return new Promise((resolve, reject) => {
	        evaluateAsync(genFn.apply(this, args), resolve, reject);
	      });
	    },
	    errback: function(...args) {
	      const cb = args.pop();
	      if (typeof cb !== "function") {
	        throw makeError(
	          "Asynchronous function called without callback",
	          GENSYNC_ERRBACK_NO_CALLBACK
	        );
	      }

	      let gen;
	      try {
	        gen = genFn.apply(this, args);
	      } catch (err) {
	        cb(err);
	        return;
	      }

	      evaluateAsync(gen, val => cb(undefined, val), err => cb(err));
	    },
	  };
	  return fns;
	}

	function assertTypeof(type, name, value, allowUndefined) {
	  if (
	    typeof value === type ||
	    (allowUndefined && typeof value === "undefined")
	  ) {
	    return;
	  }

	  let msg;
	  if (allowUndefined) {
	    msg = `Expected opts.${name} to be either a ${type}, or undefined.`;
	  } else {
	    msg = `Expected opts.${name} to be a ${type}.`;
	  }

	  throw makeError(msg, GENSYNC_OPTIONS_ERROR);
	}
	function makeError(msg, code) {
	  return Object.assign(new Error(msg), { code });
	}

	/**
	 * Given an options object, return a new generator that dispatches the
	 * correct handler based on sync or async execution.
	 */
	function newGenerator({ name, arity, sync, async, errback }) {
	  assertTypeof("string", "name", name, true /* allowUndefined */);
	  assertTypeof("number", "arity", arity, true /* allowUndefined */);
	  assertTypeof("function", "sync", sync);
	  assertTypeof("function", "async", async, true /* allowUndefined */);
	  assertTypeof("function", "errback", errback, true /* allowUndefined */);
	  if (async && errback) {
	    throw makeError(
	      "Expected one of either opts.async or opts.errback, but got _both_.",
	      GENSYNC_OPTIONS_ERROR
	    );
	  }

	  if (typeof name !== "string") {
	    let fnName;
	    if (errback && errback.name && errback.name !== "errback") {
	      fnName = errback.name;
	    }
	    if (async && async.name && async.name !== "async") {
	      fnName = async.name.replace(/Async$/, "");
	    }
	    if (sync && sync.name && sync.name !== "sync") {
	      fnName = sync.name.replace(/Sync$/, "");
	    }

	    if (typeof fnName === "string") {
	      name = fnName;
	    }
	  }

	  if (typeof arity !== "number") {
	    arity = sync.length;
	  }

	  return buildOperation({
	    name,
	    arity,
	    sync: function(args) {
	      return sync.apply(this, args);
	    },
	    async: function(args, resolve, reject) {
	      if (async) {
	        async.apply(this, args).then(resolve, reject);
	      } else if (errback) {
	        errback.call(this, ...args, (err, value) => {
	          if (err == null) resolve(value);
	          else reject(err);
	        });
	      } else {
	        resolve(sync.apply(this, args));
	      }
	    },
	  });
	}

	function wrapGenerator(genFn) {
	  return setFunctionMetadata(genFn.name, genFn.length, function(...args) {
	    return genFn.apply(this, args);
	  });
	}

	function buildOperation({ name, arity, sync, async }) {
	  return setFunctionMetadata(name, arity, function*(...args) {
	    const resume = yield GENSYNC_START;
	    if (!resume) {
	      // Break the tail call to avoid a bug in V8 v6.X with --harmony enabled.
	      const res = sync.call(this, args);
	      return res;
	    }

	    let result;
	    try {
	      async.call(
	        this,
	        args,
	        value => {
	          if (result) return;

	          result = { value };
	          resume();
	        },
	        err => {
	          if (result) return;

	          result = { err };
	          resume();
	        }
	      );
	    } catch (err) {
	      result = { err };
	      resume();
	    }

	    // Suspend until the callbacks run. Will resume synchronously if the
	    // callback was already called.
	    yield GENSYNC_SUSPEND;

	    if (result.hasOwnProperty("err")) {
	      throw result.err;
	    }

	    return result.value;
	  });
	}

	function evaluateSync(gen) {
	  let value;
	  while (!({ value } = gen.next()).done) {
	    assertStart(value, gen);
	  }
	  return value;
	}

	function evaluateAsync(gen, resolve, reject) {
	  (function step() {
	    try {
	      let value;
	      while (!({ value } = gen.next()).done) {
	        assertStart(value, gen);

	        // If this throws, it is considered to have broken the contract
	        // established for async handlers. If these handlers are called
	        // synchronously, it is also considered bad behavior.
	        let sync = true;
	        let didSyncResume = false;
	        const out = gen.next(() => {
	          if (sync) {
	            didSyncResume = true;
	          } else {
	            step();
	          }
	        });
	        sync = false;

	        assertSuspend(out, gen);

	        if (!didSyncResume) {
	          // Callback wasn't called synchronously, so break out of the loop
	          // and let it call 'step' later.
	          return;
	        }
	      }

	      return resolve(value);
	    } catch (err) {
	      return reject(err);
	    }
	  })();
	}

	function assertStart(value, gen) {
	  if (value === GENSYNC_START) return;

	  throwError(
	    gen,
	    makeError(
	      `Got unexpected yielded value in gensync generator: ${JSON.stringify(
	        value
	      )}. Did you perhaps mean to use 'yield*' instead of 'yield'?`,
	      GENSYNC_EXPECTED_START
	    )
	  );
	}
	function assertSuspend({ value, done }, gen) {
	  if (!done && value === GENSYNC_SUSPEND) return;

	  throwError(
	    gen,
	    makeError(
	      done
	        ? "Unexpected generator completion. If you get this, it is probably a gensync bug."
	        : `Expected GENSYNC_SUSPEND, got ${JSON.stringify(
	            value
	          )}. If you get this, it is probably a gensync bug.`,
	      GENSYNC_EXPECTED_SUSPEND
	    )
	  );
	}

	function throwError(gen, err) {
	  // Call `.throw` so that users can step in a debugger to easily see which
	  // 'yield' passed an unexpected value. If the `.throw` call didn't throw
	  // back to the generator, we explicitly do it to stop the error
	  // from being swallowed by user code try/catches.
	  if (gen.throw) gen.throw(err);
	  throw err;
	}

	function setFunctionMetadata(name, arity, fn) {
	  if (typeof name === "string") {
	    // This should always work on the supported Node versions, but for the
	    // sake of users that are compiling to older versions, we check for
	    // configurability so we don't throw.
	    const nameDesc = Object.getOwnPropertyDescriptor(fn, "name");
	    if (!nameDesc || nameDesc.configurable) {
	      Object.defineProperty(
	        fn,
	        "name",
	        Object.assign(nameDesc || {}, {
	          configurable: true,
	          value: name,
	        })
	      );
	    }
	  }

	  if (typeof arity === "number") {
	    const lengthDesc = Object.getOwnPropertyDescriptor(fn, "length");
	    if (!lengthDesc || lengthDesc.configurable) {
	      Object.defineProperty(
	        fn,
	        "length",
	        Object.assign(lengthDesc || {}, {
	          configurable: true,
	          value: arity,
	        })
	      );
	    }
	  }

	  return fn;
	}
	return gensync;
}

var async$2 = {};

Object.defineProperty(async$2, "__esModule", {
  value: true
});
async$2.forwardAsync = forwardAsync;
async$2.isAsync = void 0;
async$2.isThenable = isThenable;
async$2.maybeAsync = maybeAsync;
async$2.waitFor = async$2.onFirstPause = void 0;
function _gensync$3() {
  const data = requireGensync();
  _gensync$3 = function () {
    return data;
  };
  return data;
}
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
const runGenerator = _gensync$3()(function* (item) {
  return yield* item;
});
async$2.isAsync = _gensync$3()({
  sync: () => false,
  errback: cb => cb(null, true)
});
function maybeAsync(fn, message) {
  return _gensync$3()({
    sync(...args) {
      const result = fn.apply(this, args);
      if (isThenable(result)) throw new Error(message);
      return result;
    },
    async(...args) {
      return Promise.resolve(fn.apply(this, args));
    }
  });
}
const withKind = _gensync$3()({
  sync: cb => cb("sync"),
  async: function () {
    var _ref = _asyncToGenerator(function* (cb) {
      return cb("async");
    });
    return function async(_x) {
      return _ref.apply(this, arguments);
    };
  }()
});
function forwardAsync(action, cb) {
  const g = _gensync$3()(action);
  return withKind(kind => {
    const adapted = g[kind];
    return cb(adapted);
  });
}
async$2.onFirstPause = _gensync$3()({
  name: "onFirstPause",
  arity: 2,
  sync: function (item) {
    return runGenerator.sync(item);
  },
  errback: function (item, firstPause, cb) {
    let completed = false;
    runGenerator.errback(item, (err, value) => {
      completed = true;
      cb(err, value);
    });
    if (!completed) {
      firstPause();
    }
  }
});
async$2.waitFor = _gensync$3()({
  sync: x => x,
  async: function () {
    var _ref2 = _asyncToGenerator(function* (x) {
      return x;
    });
    return function async(_x2) {
      return _ref2.apply(this, arguments);
    };
  }()
});
function isThenable(val) {
  return !!val && (typeof val === "object" || typeof val === "function") && !!val.then && typeof val.then === "function";
}

var util$2 = {};

Object.defineProperty(util$2, "__esModule", {
  value: true
});
util$2.isIterableIterator = isIterableIterator;
util$2.mergeOptions = mergeOptions;
function mergeOptions(target, source) {
  for (const k of Object.keys(source)) {
    if ((k === "parserOpts" || k === "generatorOpts" || k === "assumptions") && source[k]) {
      const parserOpts = source[k];
      const targetObj = target[k] || (target[k] = {});
      mergeDefaultFields(targetObj, parserOpts);
    } else {
      const val = source[k];
      if (val !== undefined) target[k] = val;
    }
  }
}
function mergeDefaultFields(target, source) {
  for (const k of Object.keys(source)) {
    const val = source[k];
    if (val !== undefined) target[k] = val;
  }
}
function isIterableIterator(value) {
  return !!value && typeof value.next === "function" && typeof value[Symbol.iterator] === "function";
}

Object.defineProperty(caching, "__esModule", {
  value: true
});
caching.assertSimpleType = assertSimpleType;
caching.makeStrongCache = makeStrongCache;
caching.makeStrongCacheSync = makeStrongCacheSync;
caching.makeWeakCache = makeWeakCache;
caching.makeWeakCacheSync = makeWeakCacheSync;
function _gensync$2() {
  const data = requireGensync();
  _gensync$2 = function () {
    return data;
  };
  return data;
}
var _async$1 = async$2;
var _util$1 = util$2;
const synchronize = gen => {
  return _gensync$2()(gen).sync;
};
function* genTrue() {
  return true;
}
function makeWeakCache(handler) {
  return makeCachedFunction(WeakMap, handler);
}
function makeWeakCacheSync(handler) {
  return synchronize(makeWeakCache(handler));
}
function makeStrongCache(handler) {
  return makeCachedFunction(Map, handler);
}
function makeStrongCacheSync(handler) {
  return synchronize(makeStrongCache(handler));
}
function makeCachedFunction(CallCache, handler) {
  const callCacheSync = new CallCache();
  const callCacheAsync = new CallCache();
  const futureCache = new CallCache();
  return function* cachedFunction(arg, data) {
    const asyncContext = yield* (0, _async$1.isAsync)();
    const callCache = asyncContext ? callCacheAsync : callCacheSync;
    const cached = yield* getCachedValueOrWait(asyncContext, callCache, futureCache, arg, data);
    if (cached.valid) return cached.value;
    const cache = new CacheConfigurator(data);
    const handlerResult = handler(arg, cache);
    let finishLock;
    let value;
    if ((0, _util$1.isIterableIterator)(handlerResult)) {
      value = yield* (0, _async$1.onFirstPause)(handlerResult, () => {
        finishLock = setupAsyncLocks(cache, futureCache, arg);
      });
    } else {
      value = handlerResult;
    }
    updateFunctionCache(callCache, cache, arg, value);
    if (finishLock) {
      futureCache.delete(arg);
      finishLock.release(value);
    }
    return value;
  };
}
function* getCachedValue(cache, arg, data) {
  const cachedValue = cache.get(arg);
  if (cachedValue) {
    for (const {
      value,
      valid
    } of cachedValue) {
      if (yield* valid(data)) return {
        valid: true,
        value
      };
    }
  }
  return {
    valid: false,
    value: null
  };
}
function* getCachedValueOrWait(asyncContext, callCache, futureCache, arg, data) {
  const cached = yield* getCachedValue(callCache, arg, data);
  if (cached.valid) {
    return cached;
  }
  if (asyncContext) {
    const cached = yield* getCachedValue(futureCache, arg, data);
    if (cached.valid) {
      const value = yield* (0, _async$1.waitFor)(cached.value.promise);
      return {
        valid: true,
        value
      };
    }
  }
  return {
    valid: false,
    value: null
  };
}
function setupAsyncLocks(config, futureCache, arg) {
  const finishLock = new Lock();
  updateFunctionCache(futureCache, config, arg, finishLock);
  return finishLock;
}
function updateFunctionCache(cache, config, arg, value) {
  if (!config.configured()) config.forever();
  let cachedValue = cache.get(arg);
  config.deactivate();
  switch (config.mode()) {
    case "forever":
      cachedValue = [{
        value,
        valid: genTrue
      }];
      cache.set(arg, cachedValue);
      break;
    case "invalidate":
      cachedValue = [{
        value,
        valid: config.validator()
      }];
      cache.set(arg, cachedValue);
      break;
    case "valid":
      if (cachedValue) {
        cachedValue.push({
          value,
          valid: config.validator()
        });
      } else {
        cachedValue = [{
          value,
          valid: config.validator()
        }];
        cache.set(arg, cachedValue);
      }
  }
}
class CacheConfigurator {
  constructor(data) {
    this._active = true;
    this._never = false;
    this._forever = false;
    this._invalidate = false;
    this._configured = false;
    this._pairs = [];
    this._data = void 0;
    this._data = data;
  }
  simple() {
    return makeSimpleConfigurator(this);
  }
  mode() {
    if (this._never) return "never";
    if (this._forever) return "forever";
    if (this._invalidate) return "invalidate";
    return "valid";
  }
  forever() {
    if (!this._active) {
      throw new Error("Cannot change caching after evaluation has completed.");
    }
    if (this._never) {
      throw new Error("Caching has already been configured with .never()");
    }
    this._forever = true;
    this._configured = true;
  }
  never() {
    if (!this._active) {
      throw new Error("Cannot change caching after evaluation has completed.");
    }
    if (this._forever) {
      throw new Error("Caching has already been configured with .forever()");
    }
    this._never = true;
    this._configured = true;
  }
  using(handler) {
    if (!this._active) {
      throw new Error("Cannot change caching after evaluation has completed.");
    }
    if (this._never || this._forever) {
      throw new Error("Caching has already been configured with .never or .forever()");
    }
    this._configured = true;
    const key = handler(this._data);
    const fn = (0, _async$1.maybeAsync)(handler, `You appear to be using an async cache handler, but Babel has been called synchronously`);
    if ((0, _async$1.isThenable)(key)) {
      return key.then(key => {
        this._pairs.push([key, fn]);
        return key;
      });
    }
    this._pairs.push([key, fn]);
    return key;
  }
  invalidate(handler) {
    this._invalidate = true;
    return this.using(handler);
  }
  validator() {
    const pairs = this._pairs;
    return function* (data) {
      for (const [key, fn] of pairs) {
        if (key !== (yield* fn(data))) return false;
      }
      return true;
    };
  }
  deactivate() {
    this._active = false;
  }
  configured() {
    return this._configured;
  }
}
function makeSimpleConfigurator(cache) {
  function cacheFn(val) {
    if (typeof val === "boolean") {
      if (val) cache.forever();else cache.never();
      return;
    }
    return cache.using(() => assertSimpleType(val()));
  }
  cacheFn.forever = () => cache.forever();
  cacheFn.never = () => cache.never();
  cacheFn.using = cb => cache.using(() => assertSimpleType(cb()));
  cacheFn.invalidate = cb => cache.invalidate(() => assertSimpleType(cb()));
  return cacheFn;
}
function assertSimpleType(value) {
  if ((0, _async$1.isThenable)(value)) {
    throw new Error(`You appear to be using an async cache handler, ` + `which your current version of Babel does not support. ` + `We may add support for this in the future, ` + `but if you're on the most recent version of @babel/core and still ` + `seeing this error, then you'll need to synchronously handle your caching logic.`);
  }
  if (value != null && typeof value !== "string" && typeof value !== "boolean" && typeof value !== "number") {
    throw new Error("Cache keys must be either string, boolean, number, null, or undefined.");
  }
  return value;
}
class Lock {
  constructor() {
    this.released = false;
    this.promise = void 0;
    this._resolve = void 0;
    this.promise = new Promise(resolve => {
      this._resolve = resolve;
    });
  }
  release(value) {
    this.released = true;
    this._resolve(value);
  }
}

var fs$7 = {};

Object.defineProperty(fs$7, "__esModule", {
  value: true
});
fs$7.stat = fs$7.readFile = void 0;
function _fs$1() {
  const data = require$$0__default["default"];
  _fs$1 = function () {
    return data;
  };
  return data;
}
function _gensync$1() {
  const data = requireGensync();
  _gensync$1 = function () {
    return data;
  };
  return data;
}
fs$7.readFile = _gensync$1()({
  sync: _fs$1().readFileSync,
  errback: _fs$1().readFile
});
fs$7.stat = _gensync$1()({
  sync: _fs$1().statSync,
  errback: _fs$1().stat
});

Object.defineProperty(utils$1, "__esModule", {
  value: true
});
utils$1.makeStaticFileCache = makeStaticFileCache;
var _caching = caching;
var fs$6 = fs$7;
function _fs2() {
  const data = require$$0__default["default"];
  _fs2 = function () {
    return data;
  };
  return data;
}
function makeStaticFileCache(fn) {
  return (0, _caching.makeStrongCache)(function* (filepath, cache) {
    const cached = cache.invalidate(() => fileMtime(filepath));
    if (cached === null) {
      return null;
    }
    return fn(filepath, yield* fs$6.readFile(filepath, "utf8"));
  });
}
function fileMtime(filepath) {
  if (!_fs2().existsSync(filepath)) return null;
  try {
    return +_fs2().statSync(filepath).mtime;
  } catch (e) {
    if (e.code !== "ENOENT" && e.code !== "ENOTDIR") throw e;
  }
  return null;
}

var configError = {};

var rewriteStackTrace = {};

Object.defineProperty(rewriteStackTrace, "__esModule", {
  value: true
});
rewriteStackTrace.beginHiddenCallStack = beginHiddenCallStack;
rewriteStackTrace.endHiddenCallStack = endHiddenCallStack;
rewriteStackTrace.expectedError = expectedError;
rewriteStackTrace.injectVirtualStackFrame = injectVirtualStackFrame;
var _Object$getOwnPropert;
const ErrorToString = Function.call.bind(Error.prototype.toString);
const SUPPORTED = !!Error.captureStackTrace && ((_Object$getOwnPropert = Object.getOwnPropertyDescriptor(Error, "stackTraceLimit")) == null ? void 0 : _Object$getOwnPropert.writable) === true;
const START_HIDING = "startHiding - secret - don't use this - v1";
const STOP_HIDING = "stopHiding - secret - don't use this - v1";
const expectedErrors = new WeakSet();
const virtualFrames = new WeakMap();
function CallSite(filename) {
  return Object.create({
    isNative: () => false,
    isConstructor: () => false,
    isToplevel: () => true,
    getFileName: () => filename,
    getLineNumber: () => undefined,
    getColumnNumber: () => undefined,
    getFunctionName: () => undefined,
    getMethodName: () => undefined,
    getTypeName: () => undefined,
    toString: () => filename
  });
}
function injectVirtualStackFrame(error, filename) {
  if (!SUPPORTED) return;
  let frames = virtualFrames.get(error);
  if (!frames) virtualFrames.set(error, frames = []);
  frames.push(CallSite(filename));
  return error;
}
function expectedError(error) {
  if (!SUPPORTED) return;
  expectedErrors.add(error);
  return error;
}
function beginHiddenCallStack(fn) {
  if (!SUPPORTED) return fn;
  return Object.defineProperty(function (...args) {
    setupPrepareStackTrace();
    return fn(...args);
  }, "name", {
    value: STOP_HIDING
  });
}
function endHiddenCallStack(fn) {
  if (!SUPPORTED) return fn;
  return Object.defineProperty(function (...args) {
    return fn(...args);
  }, "name", {
    value: START_HIDING
  });
}
function setupPrepareStackTrace() {
  setupPrepareStackTrace = () => {};
  const {
    prepareStackTrace = defaultPrepareStackTrace
  } = Error;
  const MIN_STACK_TRACE_LIMIT = 50;
  Error.stackTraceLimit && (Error.stackTraceLimit = Math.max(Error.stackTraceLimit, MIN_STACK_TRACE_LIMIT));
  Error.prepareStackTrace = function stackTraceRewriter(err, trace) {
    let newTrace = [];
    const isExpected = expectedErrors.has(err);
    let status = isExpected ? "hiding" : "unknown";
    for (let i = 0; i < trace.length; i++) {
      const name = trace[i].getFunctionName();
      if (name === START_HIDING) {
        status = "hiding";
      } else if (name === STOP_HIDING) {
        if (status === "hiding") {
          status = "showing";
          if (virtualFrames.has(err)) {
            newTrace.unshift(...virtualFrames.get(err));
          }
        } else if (status === "unknown") {
          newTrace = trace;
          break;
        }
      } else if (status !== "hiding") {
        newTrace.push(trace[i]);
      }
    }
    return prepareStackTrace(err, newTrace);
  };
}
function defaultPrepareStackTrace(err, trace) {
  if (trace.length === 0) return ErrorToString(err);
  return `${ErrorToString(err)}\n    at ${trace.join("\n    at ")}`;
}

Object.defineProperty(configError, "__esModule", {
  value: true
});
configError.default = void 0;
var _rewriteStackTrace = rewriteStackTrace;
class ConfigError extends Error {
  constructor(message, filename) {
    super(message);
    (0, _rewriteStackTrace.expectedError)(this);
    if (filename) (0, _rewriteStackTrace.injectVirtualStackFrame)(this, filename);
  }
}
configError.default = ConfigError;

Object.defineProperty(_package, "__esModule", {
  value: true
});
_package.findPackageData = findPackageData;
function _path$4() {
  const data = path__default["default"];
  _path$4 = function () {
    return data;
  };
  return data;
}
var _utils = utils$1;
var _configError = configError;
const PACKAGE_FILENAME = "package.json";
const readConfigPackage = (0, _utils.makeStaticFileCache)((filepath, content) => {
  let options;
  try {
    options = JSON.parse(content);
  } catch (err) {
    throw new _configError.default(`Error while parsing JSON - ${err.message}`, filepath);
  }
  if (!options) throw new Error(`${filepath}: No config detected`);
  if (typeof options !== "object") {
    throw new _configError.default(`Config returned typeof ${typeof options}`, filepath);
  }
  if (Array.isArray(options)) {
    throw new _configError.default(`Expected config object but found array`, filepath);
  }
  return {
    filepath,
    dirname: _path$4().dirname(filepath),
    options
  };
});
function* findPackageData(filepath) {
  let pkg = null;
  const directories = [];
  let isPackage = true;
  let dirname = _path$4().dirname(filepath);
  while (!pkg && _path$4().basename(dirname) !== "node_modules") {
    directories.push(dirname);
    pkg = yield* readConfigPackage(_path$4().join(dirname, PACKAGE_FILENAME));
    const nextLoc = _path$4().dirname(dirname);
    if (dirname === nextLoc) {
      isPackage = false;
      break;
    }
    dirname = nextLoc;
  }
  return {
    filepath,
    directories,
    pkg,
    isPackage
  };
}

var configuration = {};

var configApi = {};

var hasRequiredConfigApi;

function requireConfigApi () {
	if (hasRequiredConfigApi) return configApi;
	hasRequiredConfigApi = 1;

	Object.defineProperty(configApi, "__esModule", {
	  value: true
	});
	configApi.makeConfigAPI = makeConfigAPI;
	configApi.makePluginAPI = makePluginAPI;
	configApi.makePresetAPI = makePresetAPI;
	function _semver() {
	  const data = requireSemver$1();
	  _semver = function () {
	    return data;
	  };
	  return data;
	}
	var _index = requireLib();
	var _caching = caching;
	function makeConfigAPI(cache) {
	  const env = value => cache.using(data => {
	    if (typeof value === "undefined") return data.envName;
	    if (typeof value === "function") {
	      return (0, _caching.assertSimpleType)(value(data.envName));
	    }
	    return (Array.isArray(value) ? value : [value]).some(entry => {
	      if (typeof entry !== "string") {
	        throw new Error("Unexpected non-string value");
	      }
	      return entry === data.envName;
	    });
	  });
	  const caller = cb => cache.using(data => (0, _caching.assertSimpleType)(cb(data.caller)));
	  return {
	    version: _index.version,
	    cache: cache.simple(),
	    env,
	    async: () => false,
	    caller,
	    assertVersion
	  };
	}
	function makePresetAPI(cache, externalDependencies) {
	  const targets = () => JSON.parse(cache.using(data => JSON.stringify(data.targets)));
	  const addExternalDependency = ref => {
	    externalDependencies.push(ref);
	  };
	  return Object.assign({}, makeConfigAPI(cache), {
	    targets,
	    addExternalDependency
	  });
	}
	function makePluginAPI(cache, externalDependencies) {
	  const assumption = name => cache.using(data => data.assumptions[name]);
	  return Object.assign({}, makePresetAPI(cache, externalDependencies), {
	    assumption
	  });
	}
	function assertVersion(range) {
	  if (typeof range === "number") {
	    if (!Number.isInteger(range)) {
	      throw new Error("Expected string or integer value.");
	    }
	    range = `^${range}.0.0-0`;
	  }
	  if (typeof range !== "string") {
	    throw new Error("Expected string or integer value.");
	  }
	  if (range === "*" || _semver().satisfies(_index.version, range)) return;
	  const limit = Error.stackTraceLimit;
	  if (typeof limit === "number" && limit < 25) {
	    Error.stackTraceLimit = 25;
	  }
	  const err = new Error(`Requires Babel "${range}", but was loaded with "${_index.version}". ` + `If you are sure you have a compatible version of @babel/core, ` + `it is likely that something in your build process is loading the ` + `wrong version. Inspect the stack trace of this error to look for ` + `the first entry that doesn't mention "@babel/core" or "babel-core" ` + `to see what is calling Babel.`);
	  if (typeof limit === "number") {
	    Error.stackTraceLimit = limit;
	  }
	  throw Object.assign(err, {
	    code: "BABEL_VERSION_UNSUPPORTED",
	    version: _index.version,
	    range
	  });
	}

	
	return configApi;
}

var moduleTypes = {};

var transformFile = {};

var config$1 = {};

var full = {};

var plugin = {};

var deepArray = {};

Object.defineProperty(deepArray, "__esModule", {
  value: true
});
deepArray.finalize = finalize;
deepArray.flattenToSet = flattenToSet;
function finalize(deepArr) {
  return Object.freeze(deepArr);
}
function flattenToSet(arr) {
  const result = new Set();
  const stack = [arr];
  while (stack.length > 0) {
    for (const el of stack.pop()) {
      if (Array.isArray(el)) stack.push(el);else result.add(el);
    }
  }
  return result;
}

Object.defineProperty(plugin, "__esModule", {
  value: true
});
plugin.default = void 0;
var _deepArray = deepArray;
class Plugin {
  constructor(plugin, options, key, externalDependencies = (0, _deepArray.finalize)([])) {
    this.key = void 0;
    this.manipulateOptions = void 0;
    this.post = void 0;
    this.pre = void 0;
    this.visitor = void 0;
    this.parserOverride = void 0;
    this.generatorOverride = void 0;
    this.options = void 0;
    this.externalDependencies = void 0;
    this.key = plugin.name || key;
    this.manipulateOptions = plugin.manipulateOptions;
    this.post = plugin.post;
    this.pre = plugin.pre;
    this.visitor = plugin.visitor || {};
    this.parserOverride = plugin.parserOverride;
    this.generatorOverride = plugin.generatorOverride;
    this.options = options;
    this.externalDependencies = externalDependencies;
  }
}
plugin.default = Plugin;

var item = {};

var configDescriptors = {};

var functional = {};

Object.defineProperty(functional, "__esModule", {
  value: true
});
functional.once = once;
var _async = async$2;
function once(fn) {
  let result;
  let resultP;
  let promiseReferenced = false;
  return function* () {
    if (!result) {
      if (resultP) {
        promiseReferenced = true;
        return yield* (0, _async.waitFor)(resultP);
      }
      if (!(yield* (0, _async.isAsync)())) {
        try {
          result = {
            ok: true,
            value: yield* fn()
          };
        } catch (error) {
          result = {
            ok: false,
            value: error
          };
        }
      } else {
        let resolve, reject;
        resultP = new Promise((res, rej) => {
          resolve = res;
          reject = rej;
        });
        try {
          result = {
            ok: true,
            value: yield* fn()
          };
          resultP = null;
          if (promiseReferenced) resolve(result.value);
        } catch (error) {
          result = {
            ok: false,
            value: error
          };
          resultP = null;
          if (promiseReferenced) reject(error);
        }
      }
    }
    if (result.ok) return result.value;else throw result.value;
  };
}

var resolveTargets$1 = {};

var lib$1 = {};

var require$$0$3 = [
	{
		name: "nodejs",
		version: "0.2.0",
		date: "2011-08-26",
		lts: false,
		security: false,
		v8: "2.3.8.0"
	},
	{
		name: "nodejs",
		version: "0.3.0",
		date: "2011-08-26",
		lts: false,
		security: false,
		v8: "2.5.1.0"
	},
	{
		name: "nodejs",
		version: "0.4.0",
		date: "2011-08-26",
		lts: false,
		security: false,
		v8: "3.1.2.0"
	},
	{
		name: "nodejs",
		version: "0.5.0",
		date: "2011-08-26",
		lts: false,
		security: false,
		v8: "3.1.8.25"
	},
	{
		name: "nodejs",
		version: "0.6.0",
		date: "2011-11-04",
		lts: false,
		security: false,
		v8: "3.6.6.6"
	},
	{
		name: "nodejs",
		version: "0.7.0",
		date: "2012-01-17",
		lts: false,
		security: false,
		v8: "3.8.6.0"
	},
	{
		name: "nodejs",
		version: "0.8.0",
		date: "2012-06-22",
		lts: false,
		security: false,
		v8: "3.11.10.10"
	},
	{
		name: "nodejs",
		version: "0.9.0",
		date: "2012-07-20",
		lts: false,
		security: false,
		v8: "3.11.10.15"
	},
	{
		name: "nodejs",
		version: "0.10.0",
		date: "2013-03-11",
		lts: false,
		security: false,
		v8: "3.14.5.8"
	},
	{
		name: "nodejs",
		version: "0.11.0",
		date: "2013-03-28",
		lts: false,
		security: false,
		v8: "3.17.13.0"
	},
	{
		name: "nodejs",
		version: "0.12.0",
		date: "2015-02-06",
		lts: false,
		security: false,
		v8: "3.28.73.0"
	},
	{
		name: "nodejs",
		version: "4.0.0",
		date: "2015-09-08",
		lts: false,
		security: false,
		v8: "4.5.103.30"
	},
	{
		name: "nodejs",
		version: "4.1.0",
		date: "2015-09-17",
		lts: false,
		security: false,
		v8: "4.5.103.33"
	},
	{
		name: "nodejs",
		version: "4.2.0",
		date: "2015-10-12",
		lts: "Argon",
		security: false,
		v8: "4.5.103.35"
	},
	{
		name: "nodejs",
		version: "4.3.0",
		date: "2016-02-09",
		lts: "Argon",
		security: false,
		v8: "4.5.103.35"
	},
	{
		name: "nodejs",
		version: "4.4.0",
		date: "2016-03-08",
		lts: "Argon",
		security: false,
		v8: "4.5.103.35"
	},
	{
		name: "nodejs",
		version: "4.5.0",
		date: "2016-08-16",
		lts: "Argon",
		security: false,
		v8: "4.5.103.37"
	},
	{
		name: "nodejs",
		version: "4.6.0",
		date: "2016-09-27",
		lts: "Argon",
		security: true,
		v8: "4.5.103.37"
	},
	{
		name: "nodejs",
		version: "4.7.0",
		date: "2016-12-06",
		lts: "Argon",
		security: false,
		v8: "4.5.103.43"
	},
	{
		name: "nodejs",
		version: "4.8.0",
		date: "2017-02-21",
		lts: "Argon",
		security: false,
		v8: "4.5.103.45"
	},
	{
		name: "nodejs",
		version: "4.9.0",
		date: "2018-03-28",
		lts: "Argon",
		security: true,
		v8: "4.5.103.53"
	},
	{
		name: "nodejs",
		version: "5.0.0",
		date: "2015-10-29",
		lts: false,
		security: false,
		v8: "4.6.85.28"
	},
	{
		name: "nodejs",
		version: "5.1.0",
		date: "2015-11-17",
		lts: false,
		security: false,
		v8: "4.6.85.31"
	},
	{
		name: "nodejs",
		version: "5.2.0",
		date: "2015-12-09",
		lts: false,
		security: false,
		v8: "4.6.85.31"
	},
	{
		name: "nodejs",
		version: "5.3.0",
		date: "2015-12-15",
		lts: false,
		security: false,
		v8: "4.6.85.31"
	},
	{
		name: "nodejs",
		version: "5.4.0",
		date: "2016-01-06",
		lts: false,
		security: false,
		v8: "4.6.85.31"
	},
	{
		name: "nodejs",
		version: "5.5.0",
		date: "2016-01-21",
		lts: false,
		security: false,
		v8: "4.6.85.31"
	},
	{
		name: "nodejs",
		version: "5.6.0",
		date: "2016-02-09",
		lts: false,
		security: false,
		v8: "4.6.85.31"
	},
	{
		name: "nodejs",
		version: "5.7.0",
		date: "2016-02-23",
		lts: false,
		security: false,
		v8: "4.6.85.31"
	},
	{
		name: "nodejs",
		version: "5.8.0",
		date: "2016-03-09",
		lts: false,
		security: false,
		v8: "4.6.85.31"
	},
	{
		name: "nodejs",
		version: "5.9.0",
		date: "2016-03-16",
		lts: false,
		security: false,
		v8: "4.6.85.31"
	},
	{
		name: "nodejs",
		version: "5.10.0",
		date: "2016-04-01",
		lts: false,
		security: false,
		v8: "4.6.85.31"
	},
	{
		name: "nodejs",
		version: "5.11.0",
		date: "2016-04-21",
		lts: false,
		security: false,
		v8: "4.6.85.31"
	},
	{
		name: "nodejs",
		version: "5.12.0",
		date: "2016-06-23",
		lts: false,
		security: false,
		v8: "4.6.85.32"
	},
	{
		name: "nodejs",
		version: "6.0.0",
		date: "2016-04-26",
		lts: false,
		security: false,
		v8: "5.0.71.35"
	},
	{
		name: "nodejs",
		version: "6.1.0",
		date: "2016-05-05",
		lts: false,
		security: false,
		v8: "5.0.71.35"
	},
	{
		name: "nodejs",
		version: "6.2.0",
		date: "2016-05-17",
		lts: false,
		security: false,
		v8: "5.0.71.47"
	},
	{
		name: "nodejs",
		version: "6.3.0",
		date: "2016-07-06",
		lts: false,
		security: false,
		v8: "5.0.71.52"
	},
	{
		name: "nodejs",
		version: "6.4.0",
		date: "2016-08-12",
		lts: false,
		security: false,
		v8: "5.0.71.60"
	},
	{
		name: "nodejs",
		version: "6.5.0",
		date: "2016-08-26",
		lts: false,
		security: false,
		v8: "5.1.281.81"
	},
	{
		name: "nodejs",
		version: "6.6.0",
		date: "2016-09-14",
		lts: false,
		security: false,
		v8: "5.1.281.83"
	},
	{
		name: "nodejs",
		version: "6.7.0",
		date: "2016-09-27",
		lts: false,
		security: true,
		v8: "5.1.281.83"
	},
	{
		name: "nodejs",
		version: "6.8.0",
		date: "2016-10-12",
		lts: false,
		security: false,
		v8: "5.1.281.84"
	},
	{
		name: "nodejs",
		version: "6.9.0",
		date: "2016-10-18",
		lts: "Boron",
		security: false,
		v8: "5.1.281.84"
	},
	{
		name: "nodejs",
		version: "6.10.0",
		date: "2017-02-21",
		lts: "Boron",
		security: false,
		v8: "5.1.281.93"
	},
	{
		name: "nodejs",
		version: "6.11.0",
		date: "2017-06-06",
		lts: "Boron",
		security: false,
		v8: "5.1.281.102"
	},
	{
		name: "nodejs",
		version: "6.12.0",
		date: "2017-11-06",
		lts: "Boron",
		security: false,
		v8: "5.1.281.108"
	},
	{
		name: "nodejs",
		version: "6.13.0",
		date: "2018-02-10",
		lts: "Boron",
		security: false,
		v8: "5.1.281.111"
	},
	{
		name: "nodejs",
		version: "6.14.0",
		date: "2018-03-28",
		lts: "Boron",
		security: true,
		v8: "5.1.281.111"
	},
	{
		name: "nodejs",
		version: "6.15.0",
		date: "2018-11-27",
		lts: "Boron",
		security: true,
		v8: "5.1.281.111"
	},
	{
		name: "nodejs",
		version: "6.16.0",
		date: "2018-12-26",
		lts: "Boron",
		security: false,
		v8: "5.1.281.111"
	},
	{
		name: "nodejs",
		version: "6.17.0",
		date: "2019-02-28",
		lts: "Boron",
		security: true,
		v8: "5.1.281.111"
	},
	{
		name: "nodejs",
		version: "7.0.0",
		date: "2016-10-25",
		lts: false,
		security: false,
		v8: "5.4.500.36"
	},
	{
		name: "nodejs",
		version: "7.1.0",
		date: "2016-11-08",
		lts: false,
		security: false,
		v8: "5.4.500.36"
	},
	{
		name: "nodejs",
		version: "7.2.0",
		date: "2016-11-22",
		lts: false,
		security: false,
		v8: "5.4.500.43"
	},
	{
		name: "nodejs",
		version: "7.3.0",
		date: "2016-12-20",
		lts: false,
		security: false,
		v8: "5.4.500.45"
	},
	{
		name: "nodejs",
		version: "7.4.0",
		date: "2017-01-04",
		lts: false,
		security: false,
		v8: "5.4.500.45"
	},
	{
		name: "nodejs",
		version: "7.5.0",
		date: "2017-01-31",
		lts: false,
		security: false,
		v8: "5.4.500.48"
	},
	{
		name: "nodejs",
		version: "7.6.0",
		date: "2017-02-21",
		lts: false,
		security: false,
		v8: "5.5.372.40"
	},
	{
		name: "nodejs",
		version: "7.7.0",
		date: "2017-02-28",
		lts: false,
		security: false,
		v8: "5.5.372.41"
	},
	{
		name: "nodejs",
		version: "7.8.0",
		date: "2017-03-29",
		lts: false,
		security: false,
		v8: "5.5.372.43"
	},
	{
		name: "nodejs",
		version: "7.9.0",
		date: "2017-04-11",
		lts: false,
		security: false,
		v8: "5.5.372.43"
	},
	{
		name: "nodejs",
		version: "7.10.0",
		date: "2017-05-02",
		lts: false,
		security: false,
		v8: "5.5.372.43"
	},
	{
		name: "nodejs",
		version: "8.0.0",
		date: "2017-05-30",
		lts: false,
		security: false,
		v8: "5.8.283.41"
	},
	{
		name: "nodejs",
		version: "8.1.0",
		date: "2017-06-08",
		lts: false,
		security: false,
		v8: "5.8.283.41"
	},
	{
		name: "nodejs",
		version: "8.2.0",
		date: "2017-07-19",
		lts: false,
		security: false,
		v8: "5.8.283.41"
	},
	{
		name: "nodejs",
		version: "8.3.0",
		date: "2017-08-08",
		lts: false,
		security: false,
		v8: "6.0.286.52"
	},
	{
		name: "nodejs",
		version: "8.4.0",
		date: "2017-08-15",
		lts: false,
		security: false,
		v8: "6.0.286.52"
	},
	{
		name: "nodejs",
		version: "8.5.0",
		date: "2017-09-12",
		lts: false,
		security: false,
		v8: "6.0.287.53"
	},
	{
		name: "nodejs",
		version: "8.6.0",
		date: "2017-09-26",
		lts: false,
		security: false,
		v8: "6.0.287.53"
	},
	{
		name: "nodejs",
		version: "8.7.0",
		date: "2017-10-11",
		lts: false,
		security: false,
		v8: "6.1.534.42"
	},
	{
		name: "nodejs",
		version: "8.8.0",
		date: "2017-10-24",
		lts: false,
		security: false,
		v8: "6.1.534.42"
	},
	{
		name: "nodejs",
		version: "8.9.0",
		date: "2017-10-31",
		lts: "Carbon",
		security: false,
		v8: "6.1.534.46"
	},
	{
		name: "nodejs",
		version: "8.10.0",
		date: "2018-03-06",
		lts: "Carbon",
		security: false,
		v8: "6.2.414.50"
	},
	{
		name: "nodejs",
		version: "8.11.0",
		date: "2018-03-28",
		lts: "Carbon",
		security: true,
		v8: "6.2.414.50"
	},
	{
		name: "nodejs",
		version: "8.12.0",
		date: "2018-09-10",
		lts: "Carbon",
		security: false,
		v8: "6.2.414.66"
	},
	{
		name: "nodejs",
		version: "8.13.0",
		date: "2018-11-20",
		lts: "Carbon",
		security: false,
		v8: "6.2.414.72"
	},
	{
		name: "nodejs",
		version: "8.14.0",
		date: "2018-11-27",
		lts: "Carbon",
		security: true,
		v8: "6.2.414.72"
	},
	{
		name: "nodejs",
		version: "8.15.0",
		date: "2018-12-26",
		lts: "Carbon",
		security: false,
		v8: "6.2.414.75"
	},
	{
		name: "nodejs",
		version: "8.16.0",
		date: "2019-04-16",
		lts: "Carbon",
		security: false,
		v8: "6.2.414.77"
	},
	{
		name: "nodejs",
		version: "8.17.0",
		date: "2019-12-17",
		lts: "Carbon",
		security: true,
		v8: "6.2.414.78"
	},
	{
		name: "nodejs",
		version: "9.0.0",
		date: "2017-10-31",
		lts: false,
		security: false,
		v8: "6.2.414.32"
	},
	{
		name: "nodejs",
		version: "9.1.0",
		date: "2017-11-07",
		lts: false,
		security: false,
		v8: "6.2.414.32"
	},
	{
		name: "nodejs",
		version: "9.2.0",
		date: "2017-11-14",
		lts: false,
		security: false,
		v8: "6.2.414.44"
	},
	{
		name: "nodejs",
		version: "9.3.0",
		date: "2017-12-12",
		lts: false,
		security: false,
		v8: "6.2.414.46"
	},
	{
		name: "nodejs",
		version: "9.4.0",
		date: "2018-01-10",
		lts: false,
		security: false,
		v8: "6.2.414.46"
	},
	{
		name: "nodejs",
		version: "9.5.0",
		date: "2018-01-31",
		lts: false,
		security: false,
		v8: "6.2.414.46"
	},
	{
		name: "nodejs",
		version: "9.6.0",
		date: "2018-02-21",
		lts: false,
		security: false,
		v8: "6.2.414.46"
	},
	{
		name: "nodejs",
		version: "9.7.0",
		date: "2018-03-01",
		lts: false,
		security: false,
		v8: "6.2.414.46"
	},
	{
		name: "nodejs",
		version: "9.8.0",
		date: "2018-03-07",
		lts: false,
		security: false,
		v8: "6.2.414.46"
	},
	{
		name: "nodejs",
		version: "9.9.0",
		date: "2018-03-21",
		lts: false,
		security: false,
		v8: "6.2.414.46"
	},
	{
		name: "nodejs",
		version: "9.10.0",
		date: "2018-03-28",
		lts: false,
		security: true,
		v8: "6.2.414.46"
	},
	{
		name: "nodejs",
		version: "9.11.0",
		date: "2018-04-04",
		lts: false,
		security: false,
		v8: "6.2.414.46"
	},
	{
		name: "nodejs",
		version: "10.0.0",
		date: "2018-04-24",
		lts: false,
		security: false,
		v8: "6.6.346.24"
	},
	{
		name: "nodejs",
		version: "10.1.0",
		date: "2018-05-08",
		lts: false,
		security: false,
		v8: "6.6.346.27"
	},
	{
		name: "nodejs",
		version: "10.2.0",
		date: "2018-05-23",
		lts: false,
		security: false,
		v8: "6.6.346.32"
	},
	{
		name: "nodejs",
		version: "10.3.0",
		date: "2018-05-29",
		lts: false,
		security: false,
		v8: "6.6.346.32"
	},
	{
		name: "nodejs",
		version: "10.4.0",
		date: "2018-06-06",
		lts: false,
		security: false,
		v8: "6.7.288.43"
	},
	{
		name: "nodejs",
		version: "10.5.0",
		date: "2018-06-20",
		lts: false,
		security: false,
		v8: "6.7.288.46"
	},
	{
		name: "nodejs",
		version: "10.6.0",
		date: "2018-07-04",
		lts: false,
		security: false,
		v8: "6.7.288.46"
	},
	{
		name: "nodejs",
		version: "10.7.0",
		date: "2018-07-18",
		lts: false,
		security: false,
		v8: "6.7.288.49"
	},
	{
		name: "nodejs",
		version: "10.8.0",
		date: "2018-08-01",
		lts: false,
		security: false,
		v8: "6.7.288.49"
	},
	{
		name: "nodejs",
		version: "10.9.0",
		date: "2018-08-15",
		lts: false,
		security: false,
		v8: "6.8.275.24"
	},
	{
		name: "nodejs",
		version: "10.10.0",
		date: "2018-09-06",
		lts: false,
		security: false,
		v8: "6.8.275.30"
	},
	{
		name: "nodejs",
		version: "10.11.0",
		date: "2018-09-19",
		lts: false,
		security: false,
		v8: "6.8.275.32"
	},
	{
		name: "nodejs",
		version: "10.12.0",
		date: "2018-10-10",
		lts: false,
		security: false,
		v8: "6.8.275.32"
	},
	{
		name: "nodejs",
		version: "10.13.0",
		date: "2018-10-30",
		lts: "Dubnium",
		security: false,
		v8: "6.8.275.32"
	},
	{
		name: "nodejs",
		version: "10.14.0",
		date: "2018-11-27",
		lts: "Dubnium",
		security: true,
		v8: "6.8.275.32"
	},
	{
		name: "nodejs",
		version: "10.15.0",
		date: "2018-12-26",
		lts: "Dubnium",
		security: false,
		v8: "6.8.275.32"
	},
	{
		name: "nodejs",
		version: "10.16.0",
		date: "2019-05-28",
		lts: "Dubnium",
		security: false,
		v8: "6.8.275.32"
	},
	{
		name: "nodejs",
		version: "10.17.0",
		date: "2019-10-22",
		lts: "Dubnium",
		security: false,
		v8: "6.8.275.32"
	},
	{
		name: "nodejs",
		version: "10.18.0",
		date: "2019-12-17",
		lts: "Dubnium",
		security: true,
		v8: "6.8.275.32"
	},
	{
		name: "nodejs",
		version: "10.19.0",
		date: "2020-02-05",
		lts: "Dubnium",
		security: true,
		v8: "6.8.275.32"
	},
	{
		name: "nodejs",
		version: "10.20.0",
		date: "2020-03-26",
		lts: "Dubnium",
		security: false,
		v8: "6.8.275.32"
	},
	{
		name: "nodejs",
		version: "10.21.0",
		date: "2020-06-02",
		lts: "Dubnium",
		security: true,
		v8: "6.8.275.32"
	},
	{
		name: "nodejs",
		version: "10.22.0",
		date: "2020-07-21",
		lts: "Dubnium",
		security: false,
		v8: "6.8.275.32"
	},
	{
		name: "nodejs",
		version: "10.23.0",
		date: "2020-10-27",
		lts: "Dubnium",
		security: false,
		v8: "6.8.275.32"
	},
	{
		name: "nodejs",
		version: "10.24.0",
		date: "2021-02-23",
		lts: "Dubnium",
		security: true,
		v8: "6.8.275.32"
	},
	{
		name: "nodejs",
		version: "11.0.0",
		date: "2018-10-23",
		lts: false,
		security: false,
		v8: "7.0.276.28"
	},
	{
		name: "nodejs",
		version: "11.1.0",
		date: "2018-10-30",
		lts: false,
		security: false,
		v8: "7.0.276.32"
	},
	{
		name: "nodejs",
		version: "11.2.0",
		date: "2018-11-15",
		lts: false,
		security: false,
		v8: "7.0.276.38"
	},
	{
		name: "nodejs",
		version: "11.3.0",
		date: "2018-11-27",
		lts: false,
		security: true,
		v8: "7.0.276.38"
	},
	{
		name: "nodejs",
		version: "11.4.0",
		date: "2018-12-07",
		lts: false,
		security: false,
		v8: "7.0.276.38"
	},
	{
		name: "nodejs",
		version: "11.5.0",
		date: "2018-12-18",
		lts: false,
		security: false,
		v8: "7.0.276.38"
	},
	{
		name: "nodejs",
		version: "11.6.0",
		date: "2018-12-26",
		lts: false,
		security: false,
		v8: "7.0.276.38"
	},
	{
		name: "nodejs",
		version: "11.7.0",
		date: "2019-01-17",
		lts: false,
		security: false,
		v8: "7.0.276.38"
	},
	{
		name: "nodejs",
		version: "11.8.0",
		date: "2019-01-24",
		lts: false,
		security: false,
		v8: "7.0.276.38"
	},
	{
		name: "nodejs",
		version: "11.9.0",
		date: "2019-01-30",
		lts: false,
		security: false,
		v8: "7.0.276.38"
	},
	{
		name: "nodejs",
		version: "11.10.0",
		date: "2019-02-14",
		lts: false,
		security: false,
		v8: "7.0.276.38"
	},
	{
		name: "nodejs",
		version: "11.11.0",
		date: "2019-03-05",
		lts: false,
		security: false,
		v8: "7.0.276.38"
	},
	{
		name: "nodejs",
		version: "11.12.0",
		date: "2019-03-14",
		lts: false,
		security: false,
		v8: "7.0.276.38"
	},
	{
		name: "nodejs",
		version: "11.13.0",
		date: "2019-03-28",
		lts: false,
		security: false,
		v8: "7.0.276.38"
	},
	{
		name: "nodejs",
		version: "11.14.0",
		date: "2019-04-10",
		lts: false,
		security: false,
		v8: "7.0.276.38"
	},
	{
		name: "nodejs",
		version: "11.15.0",
		date: "2019-04-30",
		lts: false,
		security: false,
		v8: "7.0.276.38"
	},
	{
		name: "nodejs",
		version: "12.0.0",
		date: "2019-04-23",
		lts: false,
		security: false,
		v8: "7.4.288.21"
	},
	{
		name: "nodejs",
		version: "12.1.0",
		date: "2019-04-29",
		lts: false,
		security: false,
		v8: "7.4.288.21"
	},
	{
		name: "nodejs",
		version: "12.2.0",
		date: "2019-05-07",
		lts: false,
		security: false,
		v8: "7.4.288.21"
	},
	{
		name: "nodejs",
		version: "12.3.0",
		date: "2019-05-21",
		lts: false,
		security: false,
		v8: "7.4.288.27"
	},
	{
		name: "nodejs",
		version: "12.4.0",
		date: "2019-06-04",
		lts: false,
		security: false,
		v8: "7.4.288.27"
	},
	{
		name: "nodejs",
		version: "12.5.0",
		date: "2019-06-26",
		lts: false,
		security: false,
		v8: "7.5.288.22"
	},
	{
		name: "nodejs",
		version: "12.6.0",
		date: "2019-07-03",
		lts: false,
		security: false,
		v8: "7.5.288.22"
	},
	{
		name: "nodejs",
		version: "12.7.0",
		date: "2019-07-23",
		lts: false,
		security: false,
		v8: "7.5.288.22"
	},
	{
		name: "nodejs",
		version: "12.8.0",
		date: "2019-08-06",
		lts: false,
		security: false,
		v8: "7.5.288.22"
	},
	{
		name: "nodejs",
		version: "12.9.0",
		date: "2019-08-20",
		lts: false,
		security: false,
		v8: "7.6.303.29"
	},
	{
		name: "nodejs",
		version: "12.10.0",
		date: "2019-09-04",
		lts: false,
		security: false,
		v8: "7.6.303.29"
	},
	{
		name: "nodejs",
		version: "12.11.0",
		date: "2019-09-25",
		lts: false,
		security: false,
		v8: "7.7.299.11"
	},
	{
		name: "nodejs",
		version: "12.12.0",
		date: "2019-10-11",
		lts: false,
		security: false,
		v8: "7.7.299.13"
	},
	{
		name: "nodejs",
		version: "12.13.0",
		date: "2019-10-21",
		lts: "Erbium",
		security: false,
		v8: "7.7.299.13"
	},
	{
		name: "nodejs",
		version: "12.14.0",
		date: "2019-12-17",
		lts: "Erbium",
		security: true,
		v8: "7.7.299.13"
	},
	{
		name: "nodejs",
		version: "12.15.0",
		date: "2020-02-05",
		lts: "Erbium",
		security: true,
		v8: "7.7.299.13"
	},
	{
		name: "nodejs",
		version: "12.16.0",
		date: "2020-02-11",
		lts: "Erbium",
		security: false,
		v8: "7.8.279.23"
	},
	{
		name: "nodejs",
		version: "12.17.0",
		date: "2020-05-26",
		lts: "Erbium",
		security: false,
		v8: "7.8.279.23"
	},
	{
		name: "nodejs",
		version: "12.18.0",
		date: "2020-06-02",
		lts: "Erbium",
		security: true,
		v8: "7.8.279.23"
	},
	{
		name: "nodejs",
		version: "12.19.0",
		date: "2020-10-06",
		lts: "Erbium",
		security: false,
		v8: "7.8.279.23"
	},
	{
		name: "nodejs",
		version: "12.20.0",
		date: "2020-11-24",
		lts: "Erbium",
		security: false,
		v8: "7.8.279.23"
	},
	{
		name: "nodejs",
		version: "12.21.0",
		date: "2021-02-23",
		lts: "Erbium",
		security: true,
		v8: "7.8.279.23"
	},
	{
		name: "nodejs",
		version: "12.22.0",
		date: "2021-03-30",
		lts: "Erbium",
		security: false,
		v8: "7.8.279.23"
	},
	{
		name: "nodejs",
		version: "13.0.0",
		date: "2019-10-22",
		lts: false,
		security: false,
		v8: "7.8.279.17"
	},
	{
		name: "nodejs",
		version: "13.1.0",
		date: "2019-11-05",
		lts: false,
		security: false,
		v8: "7.8.279.17"
	},
	{
		name: "nodejs",
		version: "13.2.0",
		date: "2019-11-21",
		lts: false,
		security: false,
		v8: "7.9.317.23"
	},
	{
		name: "nodejs",
		version: "13.3.0",
		date: "2019-12-03",
		lts: false,
		security: false,
		v8: "7.9.317.25"
	},
	{
		name: "nodejs",
		version: "13.4.0",
		date: "2019-12-17",
		lts: false,
		security: true,
		v8: "7.9.317.25"
	},
	{
		name: "nodejs",
		version: "13.5.0",
		date: "2019-12-18",
		lts: false,
		security: false,
		v8: "7.9.317.25"
	},
	{
		name: "nodejs",
		version: "13.6.0",
		date: "2020-01-07",
		lts: false,
		security: false,
		v8: "7.9.317.25"
	},
	{
		name: "nodejs",
		version: "13.7.0",
		date: "2020-01-21",
		lts: false,
		security: false,
		v8: "7.9.317.25"
	},
	{
		name: "nodejs",
		version: "13.8.0",
		date: "2020-02-05",
		lts: false,
		security: true,
		v8: "7.9.317.25"
	},
	{
		name: "nodejs",
		version: "13.9.0",
		date: "2020-02-18",
		lts: false,
		security: false,
		v8: "7.9.317.25"
	},
	{
		name: "nodejs",
		version: "13.10.0",
		date: "2020-03-04",
		lts: false,
		security: false,
		v8: "7.9.317.25"
	},
	{
		name: "nodejs",
		version: "13.11.0",
		date: "2020-03-12",
		lts: false,
		security: false,
		v8: "7.9.317.25"
	},
	{
		name: "nodejs",
		version: "13.12.0",
		date: "2020-03-26",
		lts: false,
		security: false,
		v8: "7.9.317.25"
	},
	{
		name: "nodejs",
		version: "13.13.0",
		date: "2020-04-14",
		lts: false,
		security: false,
		v8: "7.9.317.25"
	},
	{
		name: "nodejs",
		version: "13.14.0",
		date: "2020-04-29",
		lts: false,
		security: false,
		v8: "7.9.317.25"
	},
	{
		name: "nodejs",
		version: "14.0.0",
		date: "2020-04-21",
		lts: false,
		security: false,
		v8: "8.1.307.30"
	},
	{
		name: "nodejs",
		version: "14.1.0",
		date: "2020-04-29",
		lts: false,
		security: false,
		v8: "8.1.307.31"
	},
	{
		name: "nodejs",
		version: "14.2.0",
		date: "2020-05-05",
		lts: false,
		security: false,
		v8: "8.1.307.31"
	},
	{
		name: "nodejs",
		version: "14.3.0",
		date: "2020-05-19",
		lts: false,
		security: false,
		v8: "8.1.307.31"
	},
	{
		name: "nodejs",
		version: "14.4.0",
		date: "2020-06-02",
		lts: false,
		security: true,
		v8: "8.1.307.31"
	},
	{
		name: "nodejs",
		version: "14.5.0",
		date: "2020-06-30",
		lts: false,
		security: false,
		v8: "8.3.110.9"
	},
	{
		name: "nodejs",
		version: "14.6.0",
		date: "2020-07-20",
		lts: false,
		security: false,
		v8: "8.4.371.19"
	},
	{
		name: "nodejs",
		version: "14.7.0",
		date: "2020-07-29",
		lts: false,
		security: false,
		v8: "8.4.371.19"
	},
	{
		name: "nodejs",
		version: "14.8.0",
		date: "2020-08-11",
		lts: false,
		security: false,
		v8: "8.4.371.19"
	},
	{
		name: "nodejs",
		version: "14.9.0",
		date: "2020-08-27",
		lts: false,
		security: false,
		v8: "8.4.371.19"
	},
	{
		name: "nodejs",
		version: "14.10.0",
		date: "2020-09-08",
		lts: false,
		security: false,
		v8: "8.4.371.19"
	},
	{
		name: "nodejs",
		version: "14.11.0",
		date: "2020-09-15",
		lts: false,
		security: true,
		v8: "8.4.371.19"
	},
	{
		name: "nodejs",
		version: "14.12.0",
		date: "2020-09-22",
		lts: false,
		security: false,
		v8: "8.4.371.19"
	},
	{
		name: "nodejs",
		version: "14.13.0",
		date: "2020-09-29",
		lts: false,
		security: false,
		v8: "8.4.371.19"
	},
	{
		name: "nodejs",
		version: "14.14.0",
		date: "2020-10-15",
		lts: false,
		security: false,
		v8: "8.4.371.19"
	},
	{
		name: "nodejs",
		version: "14.15.0",
		date: "2020-10-27",
		lts: "Fermium",
		security: false,
		v8: "8.4.371.19"
	},
	{
		name: "nodejs",
		version: "14.16.0",
		date: "2021-02-23",
		lts: "Fermium",
		security: true,
		v8: "8.4.371.19"
	},
	{
		name: "nodejs",
		version: "14.17.0",
		date: "2021-05-11",
		lts: "Fermium",
		security: false,
		v8: "8.4.371.23"
	},
	{
		name: "nodejs",
		version: "14.18.0",
		date: "2021-09-28",
		lts: "Fermium",
		security: false,
		v8: "8.4.371.23"
	},
	{
		name: "nodejs",
		version: "14.19.0",
		date: "2022-02-01",
		lts: "Fermium",
		security: false,
		v8: "8.4.371.23"
	},
	{
		name: "nodejs",
		version: "14.20.0",
		date: "2022-07-07",
		lts: "Fermium",
		security: true,
		v8: "8.4.371.23"
	},
	{
		name: "nodejs",
		version: "14.21.0",
		date: "2022-11-01",
		lts: "Fermium",
		security: false,
		v8: "8.4.371.23"
	},
	{
		name: "nodejs",
		version: "15.0.0",
		date: "2020-10-20",
		lts: false,
		security: false,
		v8: "8.6.395.16"
	},
	{
		name: "nodejs",
		version: "15.1.0",
		date: "2020-11-04",
		lts: false,
		security: false,
		v8: "8.6.395.17"
	},
	{
		name: "nodejs",
		version: "15.2.0",
		date: "2020-11-10",
		lts: false,
		security: false,
		v8: "8.6.395.17"
	},
	{
		name: "nodejs",
		version: "15.3.0",
		date: "2020-11-24",
		lts: false,
		security: false,
		v8: "8.6.395.17"
	},
	{
		name: "nodejs",
		version: "15.4.0",
		date: "2020-12-09",
		lts: false,
		security: false,
		v8: "8.6.395.17"
	},
	{
		name: "nodejs",
		version: "15.5.0",
		date: "2020-12-22",
		lts: false,
		security: false,
		v8: "8.6.395.17"
	},
	{
		name: "nodejs",
		version: "15.6.0",
		date: "2021-01-14",
		lts: false,
		security: false,
		v8: "8.6.395.17"
	},
	{
		name: "nodejs",
		version: "15.7.0",
		date: "2021-01-25",
		lts: false,
		security: false,
		v8: "8.6.395.17"
	},
	{
		name: "nodejs",
		version: "15.8.0",
		date: "2021-02-02",
		lts: false,
		security: false,
		v8: "8.6.395.17"
	},
	{
		name: "nodejs",
		version: "15.9.0",
		date: "2021-02-18",
		lts: false,
		security: false,
		v8: "8.6.395.17"
	},
	{
		name: "nodejs",
		version: "15.10.0",
		date: "2021-02-23",
		lts: false,
		security: true,
		v8: "8.6.395.17"
	},
	{
		name: "nodejs",
		version: "15.11.0",
		date: "2021-03-03",
		lts: false,
		security: false,
		v8: "8.6.395.17"
	},
	{
		name: "nodejs",
		version: "15.12.0",
		date: "2021-03-17",
		lts: false,
		security: false,
		v8: "8.6.395.17"
	},
	{
		name: "nodejs",
		version: "15.13.0",
		date: "2021-03-31",
		lts: false,
		security: false,
		v8: "8.6.395.17"
	},
	{
		name: "nodejs",
		version: "15.14.0",
		date: "2021-04-06",
		lts: false,
		security: false,
		v8: "8.6.395.17"
	},
	{
		name: "nodejs",
		version: "16.0.0",
		date: "2021-04-20",
		lts: false,
		security: false,
		v8: "9.0.257.17"
	},
	{
		name: "nodejs",
		version: "16.1.0",
		date: "2021-05-04",
		lts: false,
		security: false,
		v8: "9.0.257.24"
	},
	{
		name: "nodejs",
		version: "16.2.0",
		date: "2021-05-19",
		lts: false,
		security: false,
		v8: "9.0.257.25"
	},
	{
		name: "nodejs",
		version: "16.3.0",
		date: "2021-06-03",
		lts: false,
		security: false,
		v8: "9.0.257.25"
	},
	{
		name: "nodejs",
		version: "16.4.0",
		date: "2021-06-23",
		lts: false,
		security: false,
		v8: "9.1.269.36"
	},
	{
		name: "nodejs",
		version: "16.5.0",
		date: "2021-07-14",
		lts: false,
		security: false,
		v8: "9.1.269.38"
	},
	{
		name: "nodejs",
		version: "16.6.0",
		date: "2021-07-29",
		lts: false,
		security: true,
		v8: "9.2.230.21"
	},
	{
		name: "nodejs",
		version: "16.7.0",
		date: "2021-08-18",
		lts: false,
		security: false,
		v8: "9.2.230.21"
	},
	{
		name: "nodejs",
		version: "16.8.0",
		date: "2021-08-25",
		lts: false,
		security: false,
		v8: "9.2.230.21"
	},
	{
		name: "nodejs",
		version: "16.9.0",
		date: "2021-09-07",
		lts: false,
		security: false,
		v8: "9.3.345.16"
	},
	{
		name: "nodejs",
		version: "16.10.0",
		date: "2021-09-22",
		lts: false,
		security: false,
		v8: "9.3.345.19"
	},
	{
		name: "nodejs",
		version: "16.11.0",
		date: "2021-10-08",
		lts: false,
		security: false,
		v8: "9.4.146.19"
	},
	{
		name: "nodejs",
		version: "16.12.0",
		date: "2021-10-20",
		lts: false,
		security: false,
		v8: "9.4.146.19"
	},
	{
		name: "nodejs",
		version: "16.13.0",
		date: "2021-10-26",
		lts: "Gallium",
		security: false,
		v8: "9.4.146.19"
	},
	{
		name: "nodejs",
		version: "16.14.0",
		date: "2022-02-08",
		lts: "Gallium",
		security: false,
		v8: "9.4.146.24"
	},
	{
		name: "nodejs",
		version: "16.15.0",
		date: "2022-04-26",
		lts: "Gallium",
		security: false,
		v8: "9.4.146.24"
	},
	{
		name: "nodejs",
		version: "16.16.0",
		date: "2022-07-07",
		lts: "Gallium",
		security: true,
		v8: "9.4.146.24"
	},
	{
		name: "nodejs",
		version: "16.17.0",
		date: "2022-08-16",
		lts: "Gallium",
		security: false,
		v8: "9.4.146.26"
	},
	{
		name: "nodejs",
		version: "16.18.0",
		date: "2022-10-12",
		lts: "Gallium",
		security: false,
		v8: "9.4.146.26"
	},
	{
		name: "nodejs",
		version: "16.19.0",
		date: "2022-12-13",
		lts: "Gallium",
		security: false,
		v8: "9.4.146.26"
	},
	{
		name: "nodejs",
		version: "16.20.0",
		date: "2023-03-28",
		lts: "Gallium",
		security: false,
		v8: "9.4.146.26"
	},
	{
		name: "nodejs",
		version: "17.0.0",
		date: "2021-10-19",
		lts: false,
		security: false,
		v8: "9.5.172.21"
	},
	{
		name: "nodejs",
		version: "17.1.0",
		date: "2021-11-09",
		lts: false,
		security: false,
		v8: "9.5.172.25"
	},
	{
		name: "nodejs",
		version: "17.2.0",
		date: "2021-11-30",
		lts: false,
		security: false,
		v8: "9.6.180.14"
	},
	{
		name: "nodejs",
		version: "17.3.0",
		date: "2021-12-17",
		lts: false,
		security: false,
		v8: "9.6.180.15"
	},
	{
		name: "nodejs",
		version: "17.4.0",
		date: "2022-01-18",
		lts: false,
		security: false,
		v8: "9.6.180.15"
	},
	{
		name: "nodejs",
		version: "17.5.0",
		date: "2022-02-10",
		lts: false,
		security: false,
		v8: "9.6.180.15"
	},
	{
		name: "nodejs",
		version: "17.6.0",
		date: "2022-02-22",
		lts: false,
		security: false,
		v8: "9.6.180.15"
	},
	{
		name: "nodejs",
		version: "17.7.0",
		date: "2022-03-09",
		lts: false,
		security: false,
		v8: "9.6.180.15"
	},
	{
		name: "nodejs",
		version: "17.8.0",
		date: "2022-03-22",
		lts: false,
		security: false,
		v8: "9.6.180.15"
	},
	{
		name: "nodejs",
		version: "17.9.0",
		date: "2022-04-07",
		lts: false,
		security: false,
		v8: "9.6.180.15"
	},
	{
		name: "nodejs",
		version: "18.0.0",
		date: "2022-04-18",
		lts: false,
		security: false,
		v8: "10.1.124.8"
	},
	{
		name: "nodejs",
		version: "18.1.0",
		date: "2022-05-03",
		lts: false,
		security: false,
		v8: "10.1.124.8"
	},
	{
		name: "nodejs",
		version: "18.2.0",
		date: "2022-05-17",
		lts: false,
		security: false,
		v8: "10.1.124.8"
	},
	{
		name: "nodejs",
		version: "18.3.0",
		date: "2022-06-02",
		lts: false,
		security: false,
		v8: "10.2.154.4"
	},
	{
		name: "nodejs",
		version: "18.4.0",
		date: "2022-06-16",
		lts: false,
		security: false,
		v8: "10.2.154.4"
	},
	{
		name: "nodejs",
		version: "18.5.0",
		date: "2022-07-06",
		lts: false,
		security: true,
		v8: "10.2.154.4"
	},
	{
		name: "nodejs",
		version: "18.6.0",
		date: "2022-07-13",
		lts: false,
		security: false,
		v8: "10.2.154.13"
	},
	{
		name: "nodejs",
		version: "18.7.0",
		date: "2022-07-26",
		lts: false,
		security: false,
		v8: "10.2.154.13"
	},
	{
		name: "nodejs",
		version: "18.8.0",
		date: "2022-08-24",
		lts: false,
		security: false,
		v8: "10.2.154.13"
	},
	{
		name: "nodejs",
		version: "18.9.0",
		date: "2022-09-07",
		lts: false,
		security: false,
		v8: "10.2.154.15"
	},
	{
		name: "nodejs",
		version: "18.10.0",
		date: "2022-09-28",
		lts: false,
		security: false,
		v8: "10.2.154.15"
	},
	{
		name: "nodejs",
		version: "18.11.0",
		date: "2022-10-13",
		lts: false,
		security: false,
		v8: "10.2.154.15"
	},
	{
		name: "nodejs",
		version: "18.12.0",
		date: "2022-10-25",
		lts: "Hydrogen",
		security: false,
		v8: "10.2.154.15"
	},
	{
		name: "nodejs",
		version: "18.13.0",
		date: "2023-01-05",
		lts: "Hydrogen",
		security: false,
		v8: "10.2.154.23"
	},
	{
		name: "nodejs",
		version: "18.14.0",
		date: "2023-02-01",
		lts: "Hydrogen",
		security: false,
		v8: "10.2.154.23"
	},
	{
		name: "nodejs",
		version: "18.15.0",
		date: "2023-03-05",
		lts: "Hydrogen",
		security: false,
		v8: "10.2.154.26"
	},
	{
		name: "nodejs",
		version: "18.16.0",
		date: "2023-04-12",
		lts: "Hydrogen",
		security: false,
		v8: "10.2.154.26"
	},
	{
		name: "nodejs",
		version: "18.17.0",
		date: "2023-07-18",
		lts: "Hydrogen",
		security: false,
		v8: "10.2.154.26"
	},
	{
		name: "nodejs",
		version: "18.18.0",
		date: "2023-09-18",
		lts: "Hydrogen",
		security: false,
		v8: "10.2.154.26"
	},
	{
		name: "nodejs",
		version: "18.19.0",
		date: "2023-11-29",
		lts: "Hydrogen",
		security: false,
		v8: "10.2.154.26"
	},
	{
		name: "nodejs",
		version: "19.0.0",
		date: "2022-10-17",
		lts: false,
		security: false,
		v8: "10.7.193.13"
	},
	{
		name: "nodejs",
		version: "19.1.0",
		date: "2022-11-14",
		lts: false,
		security: false,
		v8: "10.7.193.20"
	},
	{
		name: "nodejs",
		version: "19.2.0",
		date: "2022-11-29",
		lts: false,
		security: false,
		v8: "10.8.168.20"
	},
	{
		name: "nodejs",
		version: "19.3.0",
		date: "2022-12-14",
		lts: false,
		security: false,
		v8: "10.8.168.21"
	},
	{
		name: "nodejs",
		version: "19.4.0",
		date: "2023-01-05",
		lts: false,
		security: false,
		v8: "10.8.168.25"
	},
	{
		name: "nodejs",
		version: "19.5.0",
		date: "2023-01-24",
		lts: false,
		security: false,
		v8: "10.8.168.25"
	},
	{
		name: "nodejs",
		version: "19.6.0",
		date: "2023-02-01",
		lts: false,
		security: false,
		v8: "10.8.168.25"
	},
	{
		name: "nodejs",
		version: "19.7.0",
		date: "2023-02-21",
		lts: false,
		security: false,
		v8: "10.8.168.25"
	},
	{
		name: "nodejs",
		version: "19.8.0",
		date: "2023-03-14",
		lts: false,
		security: false,
		v8: "10.8.168.25"
	},
	{
		name: "nodejs",
		version: "19.9.0",
		date: "2023-04-10",
		lts: false,
		security: false,
		v8: "10.8.168.25"
	},
	{
		name: "nodejs",
		version: "20.0.0",
		date: "2023-04-17",
		lts: false,
		security: false,
		v8: "11.3.244.4"
	},
	{
		name: "nodejs",
		version: "20.1.0",
		date: "2023-05-03",
		lts: false,
		security: false,
		v8: "11.3.244.8"
	},
	{
		name: "nodejs",
		version: "20.2.0",
		date: "2023-05-16",
		lts: false,
		security: false,
		v8: "11.3.244.8"
	},
	{
		name: "nodejs",
		version: "20.3.0",
		date: "2023-06-08",
		lts: false,
		security: false,
		v8: "11.3.244.8"
	},
	{
		name: "nodejs",
		version: "20.4.0",
		date: "2023-07-04",
		lts: false,
		security: false,
		v8: "11.3.244.8"
	},
	{
		name: "nodejs",
		version: "20.5.0",
		date: "2023-07-19",
		lts: false,
		security: false,
		v8: "11.3.244.8"
	},
	{
		name: "nodejs",
		version: "20.6.0",
		date: "2023-08-23",
		lts: false,
		security: false,
		v8: "11.3.244.8"
	},
	{
		name: "nodejs",
		version: "20.7.0",
		date: "2023-09-18",
		lts: false,
		security: false,
		v8: "11.3.244.8"
	},
	{
		name: "nodejs",
		version: "20.8.0",
		date: "2023-09-28",
		lts: false,
		security: false,
		v8: "11.3.244.8"
	},
	{
		name: "nodejs",
		version: "20.9.0",
		date: "2023-10-24",
		lts: "Iron",
		security: false,
		v8: "11.3.244.8"
	},
	{
		name: "nodejs",
		version: "20.10.0",
		date: "2023-11-22",
		lts: "Iron",
		security: false,
		v8: "11.3.244.8"
	},
	{
		name: "nodejs",
		version: "21.0.0",
		date: "2023-10-17",
		lts: false,
		security: false,
		v8: "11.8.172.13"
	},
	{
		name: "nodejs",
		version: "21.1.0",
		date: "2023-10-24",
		lts: false,
		security: false,
		v8: "11.8.172.15"
	},
	{
		name: "nodejs",
		version: "21.2.0",
		date: "2023-11-14",
		lts: false,
		security: false,
		v8: "11.8.172.17"
	},
	{
		name: "nodejs",
		version: "21.3.0",
		date: "2023-11-30",
		lts: false,
		security: false,
		v8: "11.8.172.17"
	}
];

var agents$1 = {};

var browsers$1 = {};

var browsers;
var hasRequiredBrowsers$1;

function requireBrowsers$1 () {
	if (hasRequiredBrowsers$1) return browsers;
	hasRequiredBrowsers$1 = 1;
	browsers={A:"ie",B:"edge",C:"firefox",D:"chrome",E:"safari",F:"opera",G:"ios_saf",H:"op_mini",I:"android",J:"bb",K:"op_mob",L:"and_chr",M:"and_ff",N:"ie_mob",O:"and_uc",P:"samsung",Q:"and_qq",R:"baidu",S:"kaios"};
	return browsers;
}

var hasRequiredBrowsers;

function requireBrowsers () {
	if (hasRequiredBrowsers) return browsers$1;
	hasRequiredBrowsers = 1;
	browsers$1.browsers = requireBrowsers$1();
	return browsers$1;
}

var browserVersions$1 = {};

var browserVersions;
var hasRequiredBrowserVersions$1;

function requireBrowserVersions$1 () {
	if (hasRequiredBrowserVersions$1) return browserVersions;
	hasRequiredBrowserVersions$1 = 1;
	browserVersions={"0":"112","1":"113","2":"114","3":"115","4":"116","5":"117","6":"118","7":"119","8":"120","9":"121",A:"10",B:"11",C:"12",D:"7",E:"8",F:"9",G:"15",H:"80",I:"124",J:"4",K:"6",L:"13",M:"14",N:"16",O:"17",P:"18",Q:"79",R:"81",S:"83",T:"84",U:"85",V:"86",W:"87",X:"88",Y:"89",Z:"90",a:"91",b:"92",c:"93",d:"94",e:"95",f:"96",g:"97",h:"98",i:"99",j:"100",k:"101",l:"102",m:"103",n:"104",o:"105",p:"106",q:"107",r:"108",s:"109",t:"20",u:"21",v:"22",w:"23",x:"24",y:"110",z:"111",AB:"122",BB:"123",CB:"5",DB:"19",EB:"25",FB:"26",GB:"27",HB:"28",IB:"29",JB:"30",KB:"31",LB:"32",MB:"33",NB:"34",OB:"35",PB:"36",QB:"37",RB:"38",SB:"39",TB:"40",UB:"41",VB:"42",WB:"43",XB:"44",YB:"45",ZB:"46",aB:"47",bB:"48",cB:"49",dB:"50",eB:"51",fB:"52",gB:"53",hB:"54",iB:"55",jB:"56",kB:"57",lB:"58",mB:"60",nB:"62",oB:"63",pB:"64",qB:"65",rB:"66",sB:"67",tB:"68",uB:"69",vB:"70",wB:"71",xB:"72",yB:"73",zB:"74","0B":"75","1B":"76","2B":"77","3B":"78","4B":"125","5B":"11.1","6B":"12.1","7B":"15.5","8B":"16.0","9B":"17.0",AC:"3",BC:"59",CC:"61",DC:"82",EC:"126",FC:"127",GC:"3.2",HC:"10.1",IC:"15.2-15.3",JC:"15.4",KC:"16.1",LC:"16.2",MC:"16.3",NC:"16.4",OC:"16.5",PC:"17.1",QC:"17.2",RC:"17.3",SC:"17.4",TC:"17.5",UC:"11.5",VC:"4.2-4.3",WC:"5.5",XC:"2",YC:"128",ZC:"3.5",aC:"3.6",bC:"3.1",cC:"5.1",dC:"6.1",eC:"7.1",fC:"9.1",gC:"13.1",hC:"14.1",iC:"15.1",jC:"15.6",kC:"16.6",lC:"TP",mC:"9.5-9.6",nC:"10.0-10.1",oC:"10.5",pC:"10.6",qC:"11.6",rC:"4.0-4.1",sC:"5.0-5.1",tC:"6.0-6.1",uC:"7.0-7.1",vC:"8.1-8.4",wC:"9.0-9.2",xC:"9.3",yC:"10.0-10.2",zC:"10.3","0C":"11.0-11.2","1C":"11.3-11.4","2C":"12.0-12.1","3C":"12.2-12.5","4C":"13.0-13.1","5C":"13.2","6C":"13.3","7C":"13.4-13.7","8C":"14.0-14.4","9C":"14.5-14.8",AD:"15.0-15.1",BD:"15.6-15.8",CD:"16.6-16.7",DD:"all",ED:"2.1",FD:"2.2",GD:"2.3",HD:"4.1",ID:"4.4",JD:"4.4.3-4.4.4",KD:"5.0-5.4",LD:"6.2-6.4",MD:"7.2-7.4",ND:"8.2",OD:"9.2",PD:"11.1-11.2",QD:"12.0",RD:"13.0",SD:"14.0",TD:"15.0",UD:"18.0",VD:"19.0",WD:"14.9",XD:"13.52",YD:"2.5",ZD:"3.0-3.1"};
	return browserVersions;
}

var hasRequiredBrowserVersions;

function requireBrowserVersions () {
	if (hasRequiredBrowserVersions) return browserVersions$1;
	hasRequiredBrowserVersions = 1;
	browserVersions$1.browserVersions = requireBrowserVersions$1();
	return browserVersions$1;
}

var agents;
var hasRequiredAgents$1;

function requireAgents$1 () {
	if (hasRequiredAgents$1) return agents;
	hasRequiredAgents$1 = 1;
	agents={A:{A:{K:0,D:0,E:0.0239157,F:0.0597892,A:0,B:0.55006,WC:0},B:"ms",C:["","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","WC","K","D","E","F","A","B","","",""],E:"IE",F:{WC:962323200,K:998870400,D:1161129600,E:1237420800,F:1300060800,A:1346716800,B:1381968000}},B:{A:{"0":0.007682,"1":0.015364,"2":0.015364,"3":0.007682,"4":0.007682,"5":0.011523,"6":0.011523,"7":0.019205,"8":0.042251,"9":0.042251,C:0,L:0,M:0,G:0,N:0,O:0.003841,P:0.034569,Q:0,H:0,R:0,S:0,T:0,U:0,V:0,W:0,X:0,Y:0,Z:0,a:0,b:0.011523,c:0,d:0,e:0,f:0,g:0,h:0,i:0,j:0,k:0,l:0,m:0,n:0,o:0,p:0,q:0.003841,r:0.007682,s:0.069138,y:0.007682,z:0.007682,AB:0.280393,BB:3.02671,I:1.35587},B:"webkit",C:["","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","C","L","M","G","N","O","P","Q","H","R","S","T","U","V","W","X","Y","Z","a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","y","z","0","1","2","3","4","5","6","7","8","9","AB","BB","I","","",""],E:"Edge",F:{"0":1680825600,"1":1683158400,"2":1685664000,"3":1689897600,"4":1692576000,"5":1694649600,"6":1697155200,"7":1698969600,"8":1701993600,"9":1706227200,C:1438128000,L:1447286400,M:1470096000,G:1491868800,N:1508198400,O:1525046400,P:1542067200,Q:1579046400,H:1581033600,R:1586736000,S:1590019200,T:1594857600,U:1598486400,V:1602201600,W:1605830400,X:1611360000,Y:1614816000,Z:1618358400,a:1622073600,b:1626912000,c:1630627200,d:1632441600,e:1634774400,f:1637539200,g:1641427200,h:1643932800,i:1646265600,j:1649635200,k:1651190400,l:1653955200,m:1655942400,n:1659657600,o:1661990400,p:1664755200,q:1666915200,r:1670198400,s:1673481600,y:1675900800,z:1678665600,AB:1708732800,BB:1711152000,I:1713398400},D:{C:"ms",L:"ms",M:"ms",G:"ms",N:"ms",O:"ms",P:"ms"}},C:{A:{"0":0,"1":0.007682,"2":0,"3":0.372577,"4":0,"5":0.007682,"6":0.099866,"7":0.003841,"8":0.011523,"9":0.011523,XC:0,AC:0,J:0.007682,CB:0,K:0,D:0,E:0,F:0,A:0,B:0.011523,C:0,L:0,M:0,G:0,N:0,O:0,P:0,DB:0,t:0,u:0,v:0,w:0,x:0,EB:0,FB:0,GB:0,HB:0,IB:0,JB:0,KB:0,LB:0,MB:0,NB:0,OB:0,PB:0,QB:0,RB:0,SB:0,TB:0,UB:0,VB:0,WB:0.007682,XB:0.007682,YB:0.007682,ZB:0,aB:0,bB:0,cB:0,dB:0.007682,eB:0,fB:0.049933,gB:0.007682,hB:0.007682,iB:0,jB:0.019205,kB:0,lB:0,BC:0.003841,mB:0,CC:0,nB:0,oB:0,pB:0,qB:0,rB:0,sB:0,tB:0,uB:0,vB:0,wB:0,xB:0,yB:0,zB:0,"0B":0,"1B":0,"2B":0,"3B":0.015364,Q:0,H:0,R:0,DC:0,S:0,T:0,U:0,V:0,W:0,X:0.007682,Y:0,Z:0,a:0,b:0,c:0,d:0.003841,e:0,f:0,g:0,h:0,i:0,j:0,k:0,l:0.026887,m:0.107548,n:0.007682,o:0,p:0,q:0,r:0.003841,s:0.007682,y:0,z:0,AB:0.019205,BB:0.049933,I:1.04475,"4B":0.530058,EC:0.003841,FC:0,YC:0,ZC:0,aC:0},B:"moz",C:["XC","AC","ZC","aC","J","CB","K","D","E","F","A","B","C","L","M","G","N","O","P","DB","t","u","v","w","x","EB","FB","GB","HB","IB","JB","KB","LB","MB","NB","OB","PB","QB","RB","SB","TB","UB","VB","WB","XB","YB","ZB","aB","bB","cB","dB","eB","fB","gB","hB","iB","jB","kB","lB","BC","mB","CC","nB","oB","pB","qB","rB","sB","tB","uB","vB","wB","xB","yB","zB","0B","1B","2B","3B","Q","H","R","DC","S","T","U","V","W","X","Y","Z","a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","y","z","0","1","2","3","4","5","6","7","8","9","AB","BB","I","4B","EC","FC","YC"],E:"Firefox",F:{"0":1681171200,"1":1683590400,"2":1686009600,"3":1688428800,"4":1690848000,"5":1693267200,"6":1695686400,"7":1698105600,"8":1700524800,"9":1702944000,XC:1161648000,AC:1213660800,ZC:1246320000,aC:1264032000,J:1300752000,CB:1308614400,K:1313452800,D:1317081600,E:1317081600,F:1320710400,A:1324339200,B:1327968000,C:1331596800,L:1335225600,M:1338854400,G:1342483200,N:1346112000,O:1349740800,P:1353628800,DB:1357603200,t:1361232000,u:1364860800,v:1368489600,w:1372118400,x:1375747200,EB:1379376000,FB:1386633600,GB:1391472000,HB:1395100800,IB:1398729600,JB:1402358400,KB:1405987200,LB:1409616000,MB:1413244800,NB:1417392000,OB:1421107200,PB:1424736000,QB:1428278400,RB:1431475200,SB:1435881600,TB:1439251200,UB:1442880000,VB:1446508800,WB:1450137600,XB:1453852800,YB:1457395200,ZB:1461628800,aB:1465257600,bB:1470096000,cB:1474329600,dB:1479168000,eB:1485216000,fB:1488844800,gB:1492560000,hB:1497312000,iB:1502150400,jB:1506556800,kB:1510617600,lB:1516665600,BC:1520985600,mB:1525824000,CC:1529971200,nB:1536105600,oB:1540252800,pB:1544486400,qB:1548720000,rB:1552953600,sB:1558396800,tB:1562630400,uB:1567468800,vB:1571788800,wB:1575331200,xB:1578355200,yB:1581379200,zB:1583798400,"0B":1586304000,"1B":1588636800,"2B":1591056000,"3B":1593475200,Q:1595894400,H:1598313600,R:1600732800,DC:1603152000,S:1605571200,T:1607990400,U:1611619200,V:1614038400,W:1616457600,X:1618790400,Y:1622505600,Z:1626134400,a:1628553600,b:1630972800,c:1633392000,d:1635811200,e:1638835200,f:1641859200,g:1644364800,h:1646697600,i:1649116800,j:1651536000,k:1653955200,l:1656374400,m:1658793600,n:1661212800,o:1663632000,p:1666051200,q:1668470400,r:1670889600,s:1673913600,y:1676332800,z:1678752000,AB:1705968000,BB:1708387200,I:1710806400,"4B":1713225600,EC:null,FC:null,YC:null}},D:{A:{"0":0.03841,"1":0.07682,"2":0.092184,"3":0.053774,"4":0.203573,"5":0.119071,"6":0.103707,"7":0.134435,"8":0.257347,"9":0.472443,J:0,CB:0,K:0,D:0,E:0,F:0,A:0,B:0,C:0,L:0,M:0,G:0,N:0,O:0,P:0,DB:0,t:0,u:0,v:0,w:0,x:0,EB:0,FB:0,GB:0,HB:0,IB:0,JB:0,KB:0,LB:0,MB:0,NB:0.007682,OB:0,PB:0,QB:0,RB:0.019205,SB:0,TB:0,UB:0,VB:0,WB:0,XB:0,YB:0,ZB:0,aB:0.007682,bB:0.023046,cB:0.026887,dB:0.007682,eB:0,fB:0,gB:0.007682,hB:0,iB:0,jB:0.011523,kB:0,lB:0.007682,BC:0,mB:0,CC:0.003841,nB:0,oB:0.003841,pB:0,qB:0,rB:0.026887,sB:0.003841,tB:0,uB:0.030728,vB:0.061456,wB:0.003841,xB:0.003841,yB:0.011523,zB:0.007682,"0B":0.007682,"1B":0.007682,"2B":0.015364,"3B":0.015364,Q:0.122912,H:0.011523,R:0.023046,S:0.03841,T:0.007682,U:0.023046,V:0.149799,W:0.072979,X:0.019205,Y:0.011523,Z:0.011523,a:0.042251,b:0.015364,c:0.026887,d:0.042251,e:0.011523,f:0.011523,g:0.015364,h:0.072979,i:0.030728,j:0.145958,k:0.26887,l:0.145958,m:0.284234,n:0.184368,o:0.03841,p:0.03841,q:0.026887,r:0.046092,s:1.52488,y:0.026887,z:0.03841,AB:1.27905,BB:12.1606,I:4.72443,"4B":0.030728,EC:0.007682,FC:0},B:"webkit",C:["","","","","","","J","CB","K","D","E","F","A","B","C","L","M","G","N","O","P","DB","t","u","v","w","x","EB","FB","GB","HB","IB","JB","KB","LB","MB","NB","OB","PB","QB","RB","SB","TB","UB","VB","WB","XB","YB","ZB","aB","bB","cB","dB","eB","fB","gB","hB","iB","jB","kB","lB","BC","mB","CC","nB","oB","pB","qB","rB","sB","tB","uB","vB","wB","xB","yB","zB","0B","1B","2B","3B","Q","H","R","S","T","U","V","W","X","Y","Z","a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","y","z","0","1","2","3","4","5","6","7","8","9","AB","BB","I","4B","EC","FC"],E:"Chrome",F:{"0":1680566400,"1":1682985600,"2":1685404800,"3":1689724800,"4":1692057600,"5":1694476800,"6":1696896000,"7":1698710400,"8":1701993600,"9":1705968000,J:1264377600,CB:1274745600,K:1283385600,D:1287619200,E:1291248000,F:1296777600,A:1299542400,B:1303862400,C:1307404800,L:1312243200,M:1316131200,G:1316131200,N:1319500800,O:1323734400,P:1328659200,DB:1332892800,t:1337040000,u:1340668800,v:1343692800,w:1348531200,x:1352246400,EB:1357862400,FB:1361404800,GB:1364428800,HB:1369094400,IB:1374105600,JB:1376956800,KB:1384214400,LB:1389657600,MB:1392940800,NB:1397001600,OB:1400544000,PB:1405468800,QB:1409011200,RB:1412640000,SB:1416268800,TB:1421798400,UB:1425513600,VB:1429401600,WB:1432080000,XB:1437523200,YB:1441152000,ZB:1444780800,aB:1449014400,bB:1453248000,cB:1456963200,dB:1460592000,eB:1464134400,fB:1469059200,gB:1472601600,hB:1476230400,iB:1480550400,jB:1485302400,kB:1489017600,lB:1492560000,BC:1496707200,mB:1500940800,CC:1504569600,nB:1508198400,oB:1512518400,pB:1516752000,qB:1520294400,rB:1523923200,sB:1527552000,tB:1532390400,uB:1536019200,vB:1539648000,wB:1543968000,xB:1548720000,yB:1552348800,zB:1555977600,"0B":1559606400,"1B":1564444800,"2B":1568073600,"3B":1571702400,Q:1575936000,H:1580860800,R:1586304000,S:1589846400,T:1594684800,U:1598313600,V:1601942400,W:1605571200,X:1611014400,Y:1614556800,Z:1618272000,a:1621987200,b:1626739200,c:1630368000,d:1632268800,e:1634601600,f:1637020800,g:1641340800,h:1643673600,i:1646092800,j:1648512000,k:1650931200,l:1653350400,m:1655769600,n:1659398400,o:1661817600,p:1664236800,q:1666656000,r:1669680000,s:1673308800,y:1675728000,z:1678147200,AB:1708387200,BB:1710806400,I:1713225600,"4B":null,EC:null,FC:null}},E:{A:{J:0,CB:0,K:0,D:0,E:0.007682,F:0.003841,A:0,B:0,C:0,L:0.007682,M:0.03841,G:0.007682,bC:0,GC:0,cC:0,dC:0,eC:0,fC:0.007682,HC:0,"5B":0.007682,"6B":0.015364,gC:0.065297,hC:0.096025,iC:0.034569,IC:0.011523,JC:0.026887,"7B":0.034569,jC:0.245824,"8B":0.030728,KC:0.049933,LC:0.046092,MC:0.107548,NC:0.034569,OC:0.065297,kC:0.361054,"9B":0.042251,PC:0.092184,QC:0.142117,RC:0.418669,SC:1.15614,TC:0.007682,lC:0},B:"webkit",C:["","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","bC","GC","J","CB","cC","K","dC","D","eC","E","F","fC","A","HC","B","5B","C","6B","L","gC","M","hC","G","iC","IC","JC","7B","jC","8B","KC","LC","MC","NC","OC","kC","9B","PC","QC","RC","SC","TC","lC",""],E:"Safari",F:{bC:1205798400,GC:1226534400,J:1244419200,CB:1275868800,cC:1311120000,K:1343174400,dC:1382400000,D:1382400000,eC:1410998400,E:1413417600,F:1443657600,fC:1458518400,A:1474329600,HC:1490572800,B:1505779200,"5B":1522281600,C:1537142400,"6B":1553472000,L:1568851200,gC:1585008000,M:1600214400,hC:1619395200,G:1632096000,iC:1635292800,IC:1639353600,JC:1647216000,"7B":1652745600,jC:1658275200,"8B":1662940800,KC:1666569600,LC:1670889600,MC:1674432000,NC:1679875200,OC:1684368000,kC:1690156800,"9B":1695686400,PC:1698192000,QC:1702252800,RC:1705881600,SC:1709596800,TC:null,lC:null}},F:{A:{F:0,B:0,C:0,G:0,N:0,O:0,P:0,DB:0,t:0,u:0,v:0,w:0,x:0,EB:0,FB:0,GB:0,HB:0,IB:0,JB:0,KB:0,LB:0,MB:0,NB:0,OB:0,PB:0,QB:0,RB:0,SB:0,TB:0.003841,UB:0,VB:0,WB:0,XB:0,YB:0,ZB:0.015364,aB:0,bB:0,cB:0,dB:0,eB:0,fB:0,gB:0,hB:0,iB:0,jB:0,kB:0,lB:0,mB:0,nB:0,oB:0,pB:0,qB:0,rB:0,sB:0,tB:0,uB:0,vB:0,wB:0,xB:0,yB:0,zB:0,"0B":0,"1B":0,"2B":0,"3B":0,Q:0,H:0,R:0,DC:0,S:0,T:0,U:0,V:0,W:0,X:0,Y:0,Z:0,a:0,b:0,c:0,d:0,e:0.046092,f:0,g:0,h:0,i:0,j:0,k:0,l:0.03841,m:0,n:0,o:0,p:0.007682,q:0.564627,r:0.291916,s:0.11523,mC:0,nC:0,oC:0,pC:0,"5B":0,UC:0,qC:0,"6B":0},B:"webkit",C:["","","","","","","","","","","","","","","","","","","","","","","F","mC","nC","oC","pC","B","5B","UC","qC","C","6B","G","N","O","P","DB","t","u","v","w","x","EB","FB","GB","HB","IB","JB","KB","LB","MB","NB","OB","PB","QB","RB","SB","TB","UB","VB","WB","XB","YB","ZB","aB","bB","cB","dB","eB","fB","gB","hB","iB","jB","kB","lB","mB","nB","oB","pB","qB","rB","sB","tB","uB","vB","wB","xB","yB","zB","0B","1B","2B","3B","Q","H","R","DC","S","T","U","V","W","X","Y","Z","a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","","",""],E:"Opera",F:{F:1150761600,mC:1223424000,nC:1251763200,oC:1267488000,pC:1277942400,B:1292457600,"5B":1302566400,UC:1309219200,qC:1323129600,C:1323129600,"6B":1352073600,G:1372723200,N:1377561600,O:1381104000,P:1386288000,DB:1390867200,t:1393891200,u:1399334400,v:1401753600,w:1405987200,x:1409616000,EB:1413331200,FB:1417132800,GB:1422316800,HB:1425945600,IB:1430179200,JB:1433808000,KB:1438646400,LB:1442448000,MB:1445904000,NB:1449100800,OB:1454371200,PB:1457308800,QB:1462320000,RB:1465344000,SB:1470096000,TB:1474329600,UB:1477267200,VB:1481587200,WB:1486425600,XB:1490054400,YB:1494374400,ZB:1498003200,aB:1502236800,bB:1506470400,cB:1510099200,dB:1515024000,eB:1517961600,fB:1521676800,gB:1525910400,hB:1530144000,iB:1534982400,jB:1537833600,kB:1543363200,lB:1548201600,mB:1554768000,nB:1561593600,oB:1566259200,pB:1570406400,qB:1573689600,rB:1578441600,sB:1583971200,tB:1587513600,uB:1592956800,vB:1595894400,wB:1600128000,xB:1603238400,yB:1613520000,zB:1612224000,"0B":1616544000,"1B":1619568000,"2B":1623715200,"3B":1627948800,Q:1631577600,H:1633392000,R:1635984000,DC:1638403200,S:1642550400,T:1644969600,U:1647993600,V:1650412800,W:1652745600,X:1654646400,Y:1657152000,Z:1660780800,a:1663113600,b:1668816000,c:1668643200,d:1671062400,e:1675209600,f:1677024000,g:1679529600,h:1681948800,i:1684195200,j:1687219200,k:1690329600,l:1692748800,m:1696204800,n:1699920000,o:1699920000,p:1702944000,q:1707264000,r:1710115200,s:1711497600},D:{F:"o",B:"o",C:"o",mC:"o",nC:"o",oC:"o",pC:"o","5B":"o",UC:"o",qC:"o","6B":"o"}},G:{A:{E:0,GC:0,rC:0,VC:0.00291444,sC:0.00291444,tC:0.0072861,uC:0.0116578,vC:0.00291444,wC:0.0072861,xC:0.0364305,yC:0.0072861,zC:0.0582888,"0C":0.0495455,"1C":0.0145722,"2C":0.0116578,"3C":0.237527,"4C":0.00437166,"5C":0.0480882,"6C":0.0116578,"7C":0.0451738,"8C":0.112206,"9C":0.135521,AD:0.0626604,IC:0.0714037,JC:0.0816043,"7B":0.102005,BD:0.902019,"8B":0.211297,KC:0.44008,LC:0.20984,MC:0.371591,NC:0.0772326,OC:0.161751,CD:1.27652,"9B":0.153008,PC:0.282701,QC:0.378877,RC:2.74249,SC:6.17424,TC:0.0568316},B:"webkit",C:["","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","GC","rC","VC","sC","tC","uC","E","vC","wC","xC","yC","zC","0C","1C","2C","3C","4C","5C","6C","7C","8C","9C","AD","IC","JC","7B","BD","8B","KC","LC","MC","NC","OC","CD","9B","PC","QC","RC","SC","TC","",""],E:"Safari on iOS",F:{GC:1270252800,rC:1283904000,VC:1299628800,sC:1331078400,tC:1359331200,uC:1394409600,E:1410912000,vC:1413763200,wC:1442361600,xC:1458518400,yC:1473724800,zC:1490572800,"0C":1505779200,"1C":1522281600,"2C":1537142400,"3C":1553472000,"4C":1568851200,"5C":1572220800,"6C":1580169600,"7C":1585008000,"8C":1600214400,"9C":1619395200,AD:1632096000,IC:1639353600,JC:1647216000,"7B":1652659200,BD:1658275200,"8B":1662940800,KC:1666569600,LC:1670889600,MC:1674432000,NC:1679875200,OC:1684368000,CD:1690156800,"9B":1694995200,PC:1698192000,QC:1702252800,RC:1705881600,SC:1709596800,TC:null}},H:{A:{DD:0.09},B:"o",C:["","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","DD","","",""],E:"Opera Mini",F:{DD:1426464000}},I:{A:{AC:0,J:0.0000566628,I:0.564305,ED:0,FD:0,GD:0,HD:0.000113326,VC:0.000339977,ID:0,JD:0.00141657},B:"webkit",C:["","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","ED","FD","GD","AC","J","HD","VC","ID","JD","I","","",""],E:"Android Browser",F:{ED:1256515200,FD:1274313600,GD:1291593600,AC:1298332800,J:1318896000,HD:1341792000,VC:1374624000,ID:1386547200,JD:1401667200,I:1713225600}},J:{A:{D:0,A:0},B:"webkit",C:["","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","D","A","","",""],E:"Blackberry Browser",F:{D:1325376000,A:1359504000}},K:{A:{A:0,B:0,C:0,H:1.23418,"5B":0,UC:0,"6B":0},B:"o",C:["","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","A","B","5B","UC","C","6B","H","","",""],E:"Opera Mobile",F:{A:1287100800,B:1300752000,"5B":1314835200,UC:1318291200,C:1330300800,"6B":1349740800,H:1709769600},D:{H:"webkit"}},L:{A:{I:41.8185},B:"webkit",C:["","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","I","","",""],E:"Chrome for Android",F:{I:1713225600}},M:{A:{"4B":0.301791},B:"moz",C:["","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","4B","","",""],E:"Firefox for Android",F:{"4B":1713225600}},N:{A:{A:0,B:0},B:"ms",C:["","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","A","B","","",""],E:"IE Mobile",F:{A:1340150400,B:1353456000}},O:{A:{"7B":0.886896},B:"webkit",C:["","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","7B","","",""],E:"UC Browser for Android",F:{"7B":1710115200},D:{"7B":"webkit"}},P:{A:{J:0.140685,t:0.0216438,u:0.0649313,v:0.0649313,w:0.216438,x:1.88301,KD:0.0108219,LD:0,MD:0.0432875,ND:0,OD:0,HC:0,PD:0.0108219,QD:0,RD:0.0108219,SD:0,TD:0,"8B":0,"9B":0.0216438,UD:0.0108219,VD:0.0324657},B:"webkit",C:["","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","J","KD","LD","MD","ND","OD","HC","PD","QD","RD","SD","TD","8B","9B","UD","VD","t","u","v","w","x","","",""],E:"Samsung Internet",F:{J:1461024000,KD:1481846400,LD:1509408000,MD:1528329600,ND:1546128000,OD:1554163200,HC:1567900800,PD:1582588800,QD:1593475200,RD:1605657600,SD:1618531200,TD:1629072000,"8B":1640736000,"9B":1651708800,UD:1659657600,VD:1667260800,t:1677369600,u:1684454400,v:1689292800,w:1697587200,x:1711497600}},Q:{A:{WD:0.283314},B:"webkit",C:["","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","WD","","",""],E:"QQ Browser",F:{WD:1710288000}},R:{A:{XD:0},B:"webkit",C:["","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","XD","","",""],E:"Baidu Browser",F:{XD:1710201600}},S:{A:{YD:0.073908,ZD:0},B:"moz",C:["","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","YD","ZD","","",""],E:"KaiOS Browser",F:{YD:1527811200,ZD:1631664000}}};
	return agents;
}

var hasRequiredAgents;

function requireAgents () {
	if (hasRequiredAgents) return agents$1;
	hasRequiredAgents = 1;

	const browsers = requireBrowsers().browsers;
	const versions = requireBrowserVersions().browserVersions;
	const agentsData = requireAgents$1();

	function unpackBrowserVersions(versionsData) {
	  return Object.keys(versionsData).reduce((usage, version) => {
	    usage[versions[version]] = versionsData[version];
	    return usage
	  }, {})
	}

	agents$1.agents = Object.keys(agentsData).reduce((map, key) => {
	  let versionsData = agentsData[key];
	  map[browsers[key]] = Object.keys(versionsData).reduce((data, entry) => {
	    if (entry === 'A') {
	      data.usage_global = unpackBrowserVersions(versionsData[entry]);
	    } else if (entry === 'C') {
	      data.versions = versionsData[entry].reduce((list, version) => {
	        if (version === '') {
	          list.push(null);
	        } else {
	          list.push(versions[version]);
	        }
	        return list
	      }, []);
	    } else if (entry === 'D') {
	      data.prefix_exceptions = unpackBrowserVersions(versionsData[entry]);
	    } else if (entry === 'E') {
	      data.browser = versionsData[entry];
	    } else if (entry === 'F') {
	      data.release_date = Object.keys(versionsData[entry]).reduce(
	        (map2, key2) => {
	          map2[versions[key2]] = versionsData[entry][key2];
	          return map2
	        },
	        {}
	      );
	    } else {
	      // entry is B
	      data.prefix = versionsData[entry];
	    }
	    return data
	  }, {});
	  return map
	}, {});
	return agents$1;
}

var v4 = {
	start: "2015-09-08",
	lts: "2015-10-12",
	maintenance: "2017-04-01",
	end: "2018-04-30",
	codename: "Argon"
};
var v5 = {
	start: "2015-10-29",
	maintenance: "2016-04-30",
	end: "2016-06-30"
};
var v6 = {
	start: "2016-04-26",
	lts: "2016-10-18",
	maintenance: "2018-04-30",
	end: "2019-04-30",
	codename: "Boron"
};
var v7 = {
	start: "2016-10-25",
	maintenance: "2017-04-30",
	end: "2017-06-30"
};
var v8$2 = {
	start: "2017-05-30",
	lts: "2017-10-31",
	maintenance: "2019-01-01",
	end: "2019-12-31",
	codename: "Carbon"
};
var v9 = {
	start: "2017-10-01",
	maintenance: "2018-04-01",
	end: "2018-06-30"
};
var v10 = {
	start: "2018-04-24",
	lts: "2018-10-30",
	maintenance: "2020-05-19",
	end: "2021-04-30",
	codename: "Dubnium"
};
var v11 = {
	start: "2018-10-23",
	maintenance: "2019-04-22",
	end: "2019-06-01"
};
var v12 = {
	start: "2019-04-23",
	lts: "2019-10-21",
	maintenance: "2020-11-30",
	end: "2022-04-30",
	codename: "Erbium"
};
var v13 = {
	start: "2019-10-22",
	maintenance: "2020-04-01",
	end: "2020-06-01"
};
var v14 = {
	start: "2020-04-21",
	lts: "2020-10-27",
	maintenance: "2021-10-19",
	end: "2023-04-30",
	codename: "Fermium"
};
var v15 = {
	start: "2020-10-20",
	maintenance: "2021-04-01",
	end: "2021-06-01"
};
var v16 = {
	start: "2021-04-20",
	lts: "2021-10-26",
	maintenance: "2022-10-18",
	end: "2023-09-11",
	codename: "Gallium"
};
var v17 = {
	start: "2021-10-19",
	maintenance: "2022-04-01",
	end: "2022-06-01"
};
var v18 = {
	start: "2022-04-19",
	lts: "2022-10-25",
	maintenance: "2023-10-18",
	end: "2025-04-30",
	codename: "Hydrogen"
};
var v19 = {
	start: "2022-10-18",
	maintenance: "2023-04-01",
	end: "2023-06-01"
};
var v20 = {
	start: "2023-04-18",
	lts: "2023-10-24",
	maintenance: "2024-10-22",
	end: "2026-04-30",
	codename: "Iron"
};
var v21 = {
	start: "2023-10-17",
	maintenance: "2024-04-01",
	end: "2024-06-01"
};
var v22 = {
	start: "2024-04-23",
	lts: "2024-10-29",
	maintenance: "2025-10-21",
	end: "2027-04-30",
	codename: ""
};
var v23 = {
	start: "2024-10-15",
	maintenance: "2025-04-01",
	end: "2025-06-01"
};
var v24 = {
	start: "2025-04-22",
	lts: "2025-10-28",
	maintenance: "2026-10-20",
	end: "2028-04-30",
	codename: ""
};
var require$$2 = {
	"v0.8": {
	start: "2012-06-25",
	end: "2014-07-31"
},
	"v0.10": {
	start: "2013-03-11",
	end: "2016-10-31"
},
	"v0.12": {
	start: "2015-02-06",
	end: "2016-12-31"
},
	v4: v4,
	v5: v5,
	v6: v6,
	v7: v7,
	v8: v8$2,
	v9: v9,
	v10: v10,
	v11: v11,
	v12: v12,
	v13: v13,
	v14: v14,
	v15: v15,
	v16: v16,
	v17: v17,
	v18: v18,
	v19: v19,
	v20: v20,
	v21: v21,
	v22: v22,
	v23: v23,
	v24: v24
};

var versions;
var hasRequiredVersions;

function requireVersions () {
	if (hasRequiredVersions) return versions;
	hasRequiredVersions = 1;
	versions = {
		"0.20": "39",
		"0.21": "41",
		"0.22": "41",
		"0.23": "41",
		"0.24": "41",
		"0.25": "42",
		"0.26": "42",
		"0.27": "43",
		"0.28": "43",
		"0.29": "43",
		"0.30": "44",
		"0.31": "45",
		"0.32": "45",
		"0.33": "45",
		"0.34": "45",
		"0.35": "45",
		"0.36": "47",
		"0.37": "49",
		"1.0": "49",
		"1.1": "50",
		"1.2": "51",
		"1.3": "52",
		"1.4": "53",
		"1.5": "54",
		"1.6": "56",
		"1.7": "58",
		"1.8": "59",
		"2.0": "61",
		"2.1": "61",
		"3.0": "66",
		"3.1": "66",
		"4.0": "69",
		"4.1": "69",
		"4.2": "69",
		"5.0": "73",
		"6.0": "76",
		"6.1": "76",
		"7.0": "78",
		"7.1": "78",
		"7.2": "78",
		"7.3": "78",
		"8.0": "80",
		"8.1": "80",
		"8.2": "80",
		"8.3": "80",
		"8.4": "80",
		"8.5": "80",
		"9.0": "83",
		"9.1": "83",
		"9.2": "83",
		"9.3": "83",
		"9.4": "83",
		"10.0": "85",
		"10.1": "85",
		"10.2": "85",
		"10.3": "85",
		"10.4": "85",
		"11.0": "87",
		"11.1": "87",
		"11.2": "87",
		"11.3": "87",
		"11.4": "87",
		"11.5": "87",
		"12.0": "89",
		"12.1": "89",
		"12.2": "89",
		"13.0": "91",
		"13.1": "91",
		"13.2": "91",
		"13.3": "91",
		"13.4": "91",
		"13.5": "91",
		"13.6": "91",
		"14.0": "93",
		"14.1": "93",
		"14.2": "93",
		"15.0": "94",
		"15.1": "94",
		"15.2": "94",
		"15.3": "94",
		"15.4": "94",
		"15.5": "94",
		"16.0": "96",
		"16.1": "96",
		"16.2": "96",
		"17.0": "98",
		"17.1": "98",
		"17.2": "98",
		"17.3": "98",
		"17.4": "98",
		"18.0": "100",
		"18.1": "100",
		"18.2": "100",
		"18.3": "100",
		"19.0": "102",
		"19.1": "102",
		"20.0": "104",
		"20.1": "104",
		"20.2": "104",
		"20.3": "104",
		"21.0": "106",
		"21.1": "106",
		"21.2": "106",
		"21.3": "106",
		"21.4": "106",
		"22.0": "108",
		"22.1": "108",
		"22.2": "108",
		"22.3": "108",
		"23.0": "110",
		"23.1": "110",
		"23.2": "110",
		"23.3": "110",
		"24.0": "112",
		"24.1": "112",
		"24.2": "112",
		"24.3": "112",
		"24.4": "112",
		"24.5": "112",
		"24.6": "112",
		"24.7": "112",
		"24.8": "112",
		"25.0": "114",
		"25.1": "114",
		"25.2": "114",
		"25.3": "114",
		"25.4": "114",
		"25.5": "114",
		"25.6": "114",
		"25.7": "114",
		"25.8": "114",
		"25.9": "114",
		"26.0": "116",
		"26.1": "116",
		"26.2": "116",
		"26.3": "116",
		"26.4": "116",
		"26.5": "116",
		"26.6": "116",
		"27.0": "118",
		"27.1": "118",
		"27.2": "118",
		"27.3": "118",
		"28.0": "120",
		"28.1": "120",
		"28.2": "120",
		"28.3": "120",
		"29.0": "122",
		"29.1": "122",
		"29.2": "122",
		"29.3": "122",
		"30.0": "124",
		"31.0": "125"
	};
	return versions;
}

var error;
var hasRequiredError;

function requireError () {
	if (hasRequiredError) return error;
	hasRequiredError = 1;
	function BrowserslistError(message) {
	  this.name = 'BrowserslistError';
	  this.message = message;
	  this.browserslist = true;
	  if (Error.captureStackTrace) {
	    Error.captureStackTrace(this, BrowserslistError);
	  }
	}

	BrowserslistError.prototype = Error.prototype;

	error = BrowserslistError;
	return error;
}

var parse$3;
var hasRequiredParse$1;

function requireParse$1 () {
	if (hasRequiredParse$1) return parse$3;
	hasRequiredParse$1 = 1;
	var AND_REGEXP = /^\s+and\s+(.*)/i;
	var OR_REGEXP = /^(?:,\s*|\s+or\s+)(.*)/i;

	function flatten(array) {
	  if (!Array.isArray(array)) return [array]
	  return array.reduce(function (a, b) {
	    return a.concat(flatten(b))
	  }, [])
	}

	function find(string, predicate) {
	  for (var n = 1, max = string.length; n <= max; n++) {
	    var parsed = string.substr(-n, n);
	    if (predicate(parsed, n, max)) {
	      return string.slice(0, -n)
	    }
	  }
	  return ''
	}

	function matchQuery(all, query) {
	  var node = { query: query };
	  if (query.indexOf('not ') === 0) {
	    node.not = true;
	    query = query.slice(4);
	  }

	  for (var name in all) {
	    var type = all[name];
	    var match = query.match(type.regexp);
	    if (match) {
	      node.type = name;
	      for (var i = 0; i < type.matches.length; i++) {
	        node[type.matches[i]] = match[i + 1];
	      }
	      return node
	    }
	  }

	  node.type = 'unknown';
	  return node
	}

	function matchBlock(all, string, qs) {
	  var node;
	  return find(string, function (parsed, n, max) {
	    if (AND_REGEXP.test(parsed)) {
	      node = matchQuery(all, parsed.match(AND_REGEXP)[1]);
	      node.compose = 'and';
	      qs.unshift(node);
	      return true
	    } else if (OR_REGEXP.test(parsed)) {
	      node = matchQuery(all, parsed.match(OR_REGEXP)[1]);
	      node.compose = 'or';
	      qs.unshift(node);
	      return true
	    } else if (n === max) {
	      node = matchQuery(all, parsed.trim());
	      node.compose = 'or';
	      qs.unshift(node);
	      return true
	    }
	    return false
	  })
	}

	parse$3 = function parse(all, queries) {
	  if (!Array.isArray(queries)) queries = [queries];
	  return flatten(
	    queries.map(function (block) {
	      var qs = [];
	      do {
	        block = matchBlock(all, block, qs);
	      } while (block)
	      return qs
	    })
	  )
	};
	return parse$3;
}

var node = {exports: {}};

var feature = {exports: {}};

var statuses;
var hasRequiredStatuses;

function requireStatuses () {
	if (hasRequiredStatuses) return statuses;
	hasRequiredStatuses = 1;
	statuses = {
	  1: 'ls', // WHATWG Living Standard
	  2: 'rec', // W3C Recommendation
	  3: 'pr', // W3C Proposed Recommendation
	  4: 'cr', // W3C Candidate Recommendation
	  5: 'wd', // W3C Working Draft
	  6: 'other', // Non-W3C, but reputable
	  7: 'unoff' // Unofficial, Editor's Draft or W3C "Note"
	};
	return statuses;
}

var supported;
var hasRequiredSupported;

function requireSupported () {
	if (hasRequiredSupported) return supported;
	hasRequiredSupported = 1;
	supported = {
	  y: 1 << 0,
	  n: 1 << 1,
	  a: 1 << 2,
	  p: 1 << 3,
	  u: 1 << 4,
	  x: 1 << 5,
	  d: 1 << 6
	};
	return supported;
}

var hasRequiredFeature;

function requireFeature () {
	if (hasRequiredFeature) return feature.exports;
	hasRequiredFeature = 1;

	const statuses = requireStatuses();
	const supported = requireSupported();
	const browsers = requireBrowsers().browsers;
	const versions = requireBrowserVersions().browserVersions;

	const MATH2LOG = Math.log(2);

	function unpackSupport(cipher) {
	  // bit flags
	  let stats = Object.keys(supported).reduce((list, support) => {
	    if (cipher & supported[support]) list.push(support);
	    return list
	  }, []);

	  // notes
	  let notes = cipher >> 7;
	  let notesArray = [];
	  while (notes) {
	    let note = Math.floor(Math.log(notes) / MATH2LOG) + 1;
	    notesArray.unshift(`#${note}`);
	    notes -= Math.pow(2, note - 1);
	  }

	  return stats.concat(notesArray).join(' ')
	}

	function unpackFeature(packed) {
	  let unpacked = {
	    status: statuses[packed.B],
	    title: packed.C,
	    shown: packed.D
	  };
	  unpacked.stats = Object.keys(packed.A).reduce((browserStats, key) => {
	    let browser = packed.A[key];
	    browserStats[browsers[key]] = Object.keys(browser).reduce(
	      (stats, support) => {
	        let packedVersions = browser[support].split(' ');
	        let unpacked2 = unpackSupport(support);
	        packedVersions.forEach(v => (stats[versions[v]] = unpacked2));
	        return stats
	      },
	      {}
	    );
	    return browserStats
	  }, {});
	  return unpacked
	}

	feature.exports = unpackFeature;
	feature.exports.default = unpackFeature;
	return feature.exports;
}

var region = {exports: {}};

var hasRequiredRegion;

function requireRegion () {
	if (hasRequiredRegion) return region.exports;
	hasRequiredRegion = 1;

	const browsers = requireBrowsers().browsers;

	function unpackRegion(packed) {
	  return Object.keys(packed).reduce((list, browser) => {
	    let data = packed[browser];
	    list[browsers[browser]] = Object.keys(data).reduce((memo, key) => {
	      let stats = data[key];
	      if (key === '_') {
	        stats.split(' ').forEach(version => (memo[version] = null));
	      } else {
	        memo[key] = stats;
	      }
	      return memo
	    }, {});
	    return list
	  }, {})
	}

	region.exports = unpackRegion;
	region.exports.default = unpackRegion;
	return region.exports;
}

node.exports;

var hasRequiredNode;

function requireNode () {
	if (hasRequiredNode) return node.exports;
	hasRequiredNode = 1;
	(function (module) {
		var feature = requireFeature().default;
		var region = requireRegion().default;
		var path = path__default["default"];
		var fs = require$$0__default["default"];

		var BrowserslistError = requireError();

		var IS_SECTION = /^\s*\[(.+)]\s*$/;
		var CONFIG_PATTERN = /^browserslist-config-/;
		var SCOPED_CONFIG__PATTERN = /@[^/]+(?:\/[^/]+)?\/browserslist-config(?:-|$|\/)/;
		var TIME_TO_UPDATE_CANIUSE = 6 * 30 * 24 * 60 * 60 * 1000;
		var FORMAT =
		  'Browserslist config should be a string or an array ' +
		  'of strings with browser queries';

		var dataTimeChecked = false;
		var filenessCache = {};
		var configCache = {};
		function checkExtend(name) {
		  var use = ' Use `dangerousExtend` option to disable.';
		  if (!CONFIG_PATTERN.test(name) && !SCOPED_CONFIG__PATTERN.test(name)) {
		    throw new BrowserslistError(
		      'Browserslist config needs `browserslist-config-` prefix. ' + use
		    )
		  }
		  if (name.replace(/^@[^/]+\//, '').indexOf('.') !== -1) {
		    throw new BrowserslistError(
		      '`.` not allowed in Browserslist config name. ' + use
		    )
		  }
		  if (name.indexOf('node_modules') !== -1) {
		    throw new BrowserslistError(
		      '`node_modules` not allowed in Browserslist config.' + use
		    )
		  }
		}

		function isFile(file) {
		  if (file in filenessCache) {
		    return filenessCache[file]
		  }
		  var result = fs.existsSync(file) && fs.statSync(file).isFile();
		  if (!process.env.BROWSERSLIST_DISABLE_CACHE) {
		    filenessCache[file] = result;
		  }
		  return result
		}

		function eachParent(file, callback) {
		  var dir = isFile(file) ? path.dirname(file) : file;
		  var loc = path.resolve(dir);
		  do {
		    if (!pathInRoot(loc)) break;
		    var result = callback(loc);
		    if (typeof result !== 'undefined') return result
		  } while (loc !== (loc = path.dirname(loc)))
		  return undefined
		}

		function pathInRoot(p) {
		  if (!process.env.BROWSERSLIST_ROOT_PATH) return true
		  var rootPath = path.resolve(process.env.BROWSERSLIST_ROOT_PATH);
		  if (path.relative(rootPath, p).substring(0,2) === '..') {
		    return false;
		  }
		  return true
		}

		function check(section) {
		  if (Array.isArray(section)) {
		    for (var i = 0; i < section.length; i++) {
		      if (typeof section[i] !== 'string') {
		        throw new BrowserslistError(FORMAT)
		      }
		    }
		  } else if (typeof section !== 'string') {
		    throw new BrowserslistError(FORMAT)
		  }
		}

		function pickEnv(config, opts) {
		  if (typeof config !== 'object') return config

		  var name;
		  if (typeof opts.env === 'string') {
		    name = opts.env;
		  } else if (process.env.BROWSERSLIST_ENV) {
		    name = process.env.BROWSERSLIST_ENV;
		  } else if (process.env.NODE_ENV) {
		    name = process.env.NODE_ENV;
		  } else {
		    name = 'production';
		  }

		  if (opts.throwOnMissing) {
		    if (name && name !== 'defaults' && !config[name]) {
		      throw new BrowserslistError(
		        'Missing config for Browserslist environment `' + name + '`'
		      )
		    }
		  }

		  return config[name] || config.defaults
		}

		function parsePackage(file) {
		  var config = JSON.parse(
		    fs
		      .readFileSync(file)
		      .toString()
		      .replace(/^\uFEFF/m, '')
		  );
		  if (config.browserlist && !config.browserslist) {
		    throw new BrowserslistError(
		      '`browserlist` key instead of `browserslist` in ' + file
		    )
		  }
		  var list = config.browserslist;
		  if (Array.isArray(list) || typeof list === 'string') {
		    list = { defaults: list };
		  }
		  for (var i in list) {
		    check(list[i]);
		  }

		  return list
		}

		function latestReleaseTime(agents) {
		  var latest = 0;
		  for (var name in agents) {
		    var dates = agents[name].releaseDate || {};
		    for (var key in dates) {
		      if (latest < dates[key]) {
		        latest = dates[key];
		      }
		    }
		  }
		  return latest * 1000
		}

		function normalizeStats(data, stats) {
		  if (!data) {
		    data = {};
		  }
		  if (stats && 'dataByBrowser' in stats) {
		    stats = stats.dataByBrowser;
		  }

		  if (typeof stats !== 'object') return undefined

		  var normalized = {};
		  for (var i in stats) {
		    var versions = Object.keys(stats[i]);
		    if (versions.length === 1 && data[i] && data[i].versions.length === 1) {
		      var normal = data[i].versions[0];
		      normalized[i] = {};
		      normalized[i][normal] = stats[i][versions[0]];
		    } else {
		      normalized[i] = stats[i];
		    }
		  }

		  return normalized
		}

		function normalizeUsageData(usageData, data) {
		  for (var browser in usageData) {
		    var browserUsage = usageData[browser];
		    // eslint-disable-next-line max-len
		    // https://github.com/browserslist/browserslist/issues/431#issuecomment-565230615
		    // caniuse-db returns { 0: "percentage" } for `and_*` regional stats
		    if ('0' in browserUsage) {
		      var versions = data[browser].versions;
		      browserUsage[versions[versions.length - 1]] = browserUsage[0];
		      delete browserUsage[0];
		    }
		  }
		}

		module.exports = {
		  loadQueries: function loadQueries(ctx, name) {
		    if (!ctx.dangerousExtend && !process.env.BROWSERSLIST_DANGEROUS_EXTEND) {
		      checkExtend(name);
		    }
		    var queries = commonjsRequire(require.resolve(name, { paths: ['.', ctx.path] }));
		    if (queries) {
		      if (Array.isArray(queries)) {
		        return queries
		      } else if (typeof queries === 'object') {
		        if (!queries.defaults) queries.defaults = [];
		        return pickEnv(queries, ctx)
		      }
		    }
		    throw new BrowserslistError(
		      '`' +
		        name +
		        '` config exports not an array of queries' +
		        ' or an object of envs'
		    )
		  },

		  loadStat: function loadStat(ctx, name, data) {
		    if (!ctx.dangerousExtend && !process.env.BROWSERSLIST_DANGEROUS_EXTEND) {
		      checkExtend(name);
		    }
		    var stats = commonjsRequire(require.resolve(
		      path.join(name, 'browserslist-stats.json'),
		      { paths: ['.'] }
		    ));
		    return normalizeStats(data, stats)
		  },

		  getStat: function getStat(opts, data) {
		    var stats;
		    if (opts.stats) {
		      stats = opts.stats;
		    } else if (process.env.BROWSERSLIST_STATS) {
		      stats = process.env.BROWSERSLIST_STATS;
		    } else if (opts.path && path.resolve && fs.existsSync) {
		      stats = eachParent(opts.path, function (dir) {
		        var file = path.join(dir, 'browserslist-stats.json');
		        return isFile(file) ? file : undefined
		      });
		    }
		    if (typeof stats === 'string') {
		      try {
		        stats = JSON.parse(fs.readFileSync(stats));
		      } catch (e) {
		        throw new BrowserslistError("Can't read " + stats)
		      }
		    }
		    return normalizeStats(data, stats)
		  },

		  loadConfig: function loadConfig(opts) {
		    if (process.env.BROWSERSLIST) {
		      return process.env.BROWSERSLIST
		    } else if (opts.config || process.env.BROWSERSLIST_CONFIG) {
		      var file = opts.config || process.env.BROWSERSLIST_CONFIG;
		      if (path.basename(file) === 'package.json') {
		        return pickEnv(parsePackage(file), opts)
		      } else {
		        return pickEnv(module.exports.readConfig(file), opts)
		      }
		    } else if (opts.path) {
		      return pickEnv(module.exports.findConfig(opts.path), opts)
		    } else {
		      return undefined
		    }
		  },

		  loadCountry: function loadCountry(usage, country, data) {
		    var code = country.replace(/[^\w-]/g, '');
		    if (!usage[code]) {
		      var compressed;
		      try {
		        compressed = commonjsRequire('caniuse-lite/data/regions/' + code + '.js');
		      } catch (e) {
		        throw new BrowserslistError('Unknown region name `' + code + '`.')
		      }
		      var usageData = region(compressed);
		      normalizeUsageData(usageData, data);
		      usage[country] = {};
		      for (var i in usageData) {
		        for (var j in usageData[i]) {
		          usage[country][i + ' ' + j] = usageData[i][j];
		        }
		      }
		    }
		  },

		  loadFeature: function loadFeature(features, name) {
		    name = name.replace(/[^\w-]/g, '');
		    if (features[name]) return
		    var compressed;
		    try {
		      compressed = commonjsRequire('caniuse-lite/data/features/' + name + '.js');
		    } catch (e) {
		      throw new BrowserslistError('Unknown feature name `' + name + '`.')
		    }
		    var stats = feature(compressed).stats;
		    features[name] = {};
		    for (var i in stats) {
		      features[name][i] = {};
		      for (var j in stats[i]) {
		        features[name][i][j] = stats[i][j];
		      }
		    }
		  },

		  parseConfig: function parseConfig(string) {
		    var result = { defaults: [] };
		    var sections = ['defaults'];

		    string
		      .toString()
		      .replace(/#[^\n]*/g, '')
		      .split(/\n|,/)
		      .map(function (line) {
		        return line.trim()
		      })
		      .filter(function (line) {
		        return line !== ''
		      })
		      .forEach(function (line) {
		        if (IS_SECTION.test(line)) {
		          sections = line.match(IS_SECTION)[1].trim().split(' ');
		          sections.forEach(function (section) {
		            if (result[section]) {
		              throw new BrowserslistError(
		                'Duplicate section ' + section + ' in Browserslist config'
		              )
		            }
		            result[section] = [];
		          });
		        } else {
		          sections.forEach(function (section) {
		            result[section].push(line);
		          });
		        }
		      });

		    return result
		  },

		  readConfig: function readConfig(file) {
		    if (!isFile(file)) {
		      throw new BrowserslistError("Can't read " + file + ' config')
		    }
		    return module.exports.parseConfig(fs.readFileSync(file))
		  },

		  findConfig: function findConfig(from) {
		    from = path.resolve(from);

		    var passed = [];
		    var resolved = eachParent(from, function (dir) {
		      if (dir in configCache) {
		        return configCache[dir]
		      }

		      passed.push(dir);

		      var config = path.join(dir, 'browserslist');
		      var pkg = path.join(dir, 'package.json');
		      var rc = path.join(dir, '.browserslistrc');

		      var pkgBrowserslist;
		      if (isFile(pkg)) {
		        try {
		          pkgBrowserslist = parsePackage(pkg);
		        } catch (e) {
		          if (e.name === 'BrowserslistError') throw e
		          console.warn(
		            '[Browserslist] Could not parse ' + pkg + '. Ignoring it.'
		          );
		        }
		      }

		      if (isFile(config) && pkgBrowserslist) {
		        throw new BrowserslistError(
		          dir + ' contains both browserslist and package.json with browsers'
		        )
		      } else if (isFile(rc) && pkgBrowserslist) {
		        throw new BrowserslistError(
		          dir + ' contains both .browserslistrc and package.json with browsers'
		        )
		      } else if (isFile(config) && isFile(rc)) {
		        throw new BrowserslistError(
		          dir + ' contains both .browserslistrc and browserslist'
		        )
		      } else if (isFile(config)) {
		        return module.exports.readConfig(config)
		      } else if (isFile(rc)) {
		        return module.exports.readConfig(rc)
		      } else {
		        return pkgBrowserslist
		      }
		    });
		    if (!process.env.BROWSERSLIST_DISABLE_CACHE) {
		      passed.forEach(function (dir) {
		        configCache[dir] = resolved;
		      });
		    }
		    return resolved
		  },

		  clearCaches: function clearCaches() {
		    dataTimeChecked = false;
		    filenessCache = {};
		    configCache = {};

		    this.cache = {};
		  },

		  oldDataWarning: function oldDataWarning(agentsObj) {
		    if (dataTimeChecked) return
		    dataTimeChecked = true;
		    if (process.env.BROWSERSLIST_IGNORE_OLD_DATA) return

		    var latest = latestReleaseTime(agentsObj);
		    var halfYearAgo = Date.now() - TIME_TO_UPDATE_CANIUSE;

		    if (latest !== 0 && latest < halfYearAgo) {
		      console.warn(
		        'Browserslist: caniuse-lite is outdated. Please run:\n' +
		          '  npx update-browserslist-db@latest\n' +
		          '  Why you should do it regularly: ' +
		          'https://github.com/browserslist/update-db#readme'
		      );
		    }
		  },

		  currentNode: function currentNode() {
		    return 'node ' + process.versions.node
		  },

		  env: process.env
		}; 
	} (node));
	return node.exports;
}

var browserslist_1;
var hasRequiredBrowserslist;

function requireBrowserslist () {
	if (hasRequiredBrowserslist) return browserslist_1;
	hasRequiredBrowserslist = 1;
	var jsReleases = require$$0$3;
	var agents = requireAgents().agents;
	var jsEOL = require$$2;
	var path = path__default["default"];
	var e2c = requireVersions();

	var BrowserslistError = requireError();
	var parse = requireParse$1();
	var env = requireNode(); // Will load browser.js in webpack

	var YEAR = 365.259641 * 24 * 60 * 60 * 1000;
	var ANDROID_EVERGREEN_FIRST = '37';
	var OP_MOB_BLINK_FIRST = 14;

	// Helpers

	function isVersionsMatch(versionA, versionB) {
	  return (versionA + '.').indexOf(versionB + '.') === 0
	}

	function isEolReleased(name) {
	  var version = name.slice(1);
	  return browserslist.nodeVersions.some(function (i) {
	    return isVersionsMatch(i, version)
	  })
	}

	function normalize(versions) {
	  return versions.filter(function (version) {
	    return typeof version === 'string'
	  })
	}

	function normalizeElectron(version) {
	  var versionToUse = version;
	  if (version.split('.').length === 3) {
	    versionToUse = version.split('.').slice(0, -1).join('.');
	  }
	  return versionToUse
	}

	function nameMapper(name) {
	  return function mapName(version) {
	    return name + ' ' + version
	  }
	}

	function getMajor(version) {
	  return parseInt(version.split('.')[0])
	}

	function getMajorVersions(released, number) {
	  if (released.length === 0) return []
	  var majorVersions = uniq(released.map(getMajor));
	  var minimum = majorVersions[majorVersions.length - number];
	  if (!minimum) {
	    return released
	  }
	  var selected = [];
	  for (var i = released.length - 1; i >= 0; i--) {
	    if (minimum > getMajor(released[i])) break
	    selected.unshift(released[i]);
	  }
	  return selected
	}

	function uniq(array) {
	  var filtered = [];
	  for (var i = 0; i < array.length; i++) {
	    if (filtered.indexOf(array[i]) === -1) filtered.push(array[i]);
	  }
	  return filtered
	}

	function fillUsage(result, name, data) {
	  for (var i in data) {
	    result[name + ' ' + i] = data[i];
	  }
	}

	function generateFilter(sign, version) {
	  version = parseFloat(version);
	  if (sign === '>') {
	    return function (v) {
	      return parseFloat(v) > version
	    }
	  } else if (sign === '>=') {
	    return function (v) {
	      return parseFloat(v) >= version
	    }
	  } else if (sign === '<') {
	    return function (v) {
	      return parseFloat(v) < version
	    }
	  } else {
	    return function (v) {
	      return parseFloat(v) <= version
	    }
	  }
	}

	function generateSemverFilter(sign, version) {
	  version = version.split('.').map(parseSimpleInt);
	  version[1] = version[1] || 0;
	  version[2] = version[2] || 0;
	  if (sign === '>') {
	    return function (v) {
	      v = v.split('.').map(parseSimpleInt);
	      return compareSemver(v, version) > 0
	    }
	  } else if (sign === '>=') {
	    return function (v) {
	      v = v.split('.').map(parseSimpleInt);
	      return compareSemver(v, version) >= 0
	    }
	  } else if (sign === '<') {
	    return function (v) {
	      v = v.split('.').map(parseSimpleInt);
	      return compareSemver(version, v) > 0
	    }
	  } else {
	    return function (v) {
	      v = v.split('.').map(parseSimpleInt);
	      return compareSemver(version, v) >= 0
	    }
	  }
	}

	function parseSimpleInt(x) {
	  return parseInt(x)
	}

	function compare(a, b) {
	  if (a < b) return -1
	  if (a > b) return +1
	  return 0
	}

	function compareSemver(a, b) {
	  return (
	    compare(parseInt(a[0]), parseInt(b[0])) ||
	    compare(parseInt(a[1] || '0'), parseInt(b[1] || '0')) ||
	    compare(parseInt(a[2] || '0'), parseInt(b[2] || '0'))
	  )
	}

	// this follows the npm-like semver behavior
	function semverFilterLoose(operator, range) {
	  range = range.split('.').map(parseSimpleInt);
	  if (typeof range[1] === 'undefined') {
	    range[1] = 'x';
	  }
	  // ignore any patch version because we only return minor versions
	  // range[2] = 'x'
	  switch (operator) {
	    case '<=':
	      return function (version) {
	        version = version.split('.').map(parseSimpleInt);
	        return compareSemverLoose(version, range) <= 0
	      }
	    case '>=':
	    default:
	      return function (version) {
	        version = version.split('.').map(parseSimpleInt);
	        return compareSemverLoose(version, range) >= 0
	      }
	  }
	}

	// this follows the npm-like semver behavior
	function compareSemverLoose(version, range) {
	  if (version[0] !== range[0]) {
	    return version[0] < range[0] ? -1 : +1
	  }
	  if (range[1] === 'x') {
	    return 0
	  }
	  if (version[1] !== range[1]) {
	    return version[1] < range[1] ? -1 : +1
	  }
	  return 0
	}

	function resolveVersion(data, version) {
	  if (data.versions.indexOf(version) !== -1) {
	    return version
	  } else if (browserslist.versionAliases[data.name][version]) {
	    return browserslist.versionAliases[data.name][version]
	  } else {
	    return false
	  }
	}

	function normalizeVersion(data, version) {
	  var resolved = resolveVersion(data, version);
	  if (resolved) {
	    return resolved
	  } else if (data.versions.length === 1) {
	    return data.versions[0]
	  } else {
	    return false
	  }
	}

	function filterByYear(since, context) {
	  since = since / 1000;
	  return Object.keys(agents).reduce(function (selected, name) {
	    var data = byName(name, context);
	    if (!data) return selected
	    var versions = Object.keys(data.releaseDate).filter(function (v) {
	      var date = data.releaseDate[v];
	      return date !== null && date >= since
	    });
	    return selected.concat(versions.map(nameMapper(data.name)))
	  }, [])
	}

	function cloneData(data) {
	  return {
	    name: data.name,
	    versions: data.versions,
	    released: data.released,
	    releaseDate: data.releaseDate
	  }
	}

	function byName(name, context) {
	  name = name.toLowerCase();
	  name = browserslist.aliases[name] || name;
	  if (context.mobileToDesktop && browserslist.desktopNames[name]) {
	    var desktop = browserslist.data[browserslist.desktopNames[name]];
	    if (name === 'android') {
	      return normalizeAndroidData(cloneData(browserslist.data[name]), desktop)
	    } else {
	      var cloned = cloneData(desktop);
	      cloned.name = name;
	      return cloned
	    }
	  }
	  return browserslist.data[name]
	}

	function normalizeAndroidVersions(androidVersions, chromeVersions) {
	  var iFirstEvergreen = chromeVersions.indexOf(ANDROID_EVERGREEN_FIRST);
	  return androidVersions
	    .filter(function (version) {
	      return /^(?:[2-4]\.|[34]$)/.test(version)
	    })
	    .concat(chromeVersions.slice(iFirstEvergreen))
	}

	function copyObject(obj) {
	  var copy = {};
	  for (var key in obj) {
	    copy[key] = obj[key];
	  }
	  return copy
	}

	function normalizeAndroidData(android, chrome) {
	  android.released = normalizeAndroidVersions(android.released, chrome.released);
	  android.versions = normalizeAndroidVersions(android.versions, chrome.versions);
	  android.releaseDate = copyObject(android.releaseDate);
	  android.released.forEach(function (v) {
	    if (android.releaseDate[v] === undefined) {
	      android.releaseDate[v] = chrome.releaseDate[v];
	    }
	  });
	  return android
	}

	function checkName(name, context) {
	  var data = byName(name, context);
	  if (!data) throw new BrowserslistError('Unknown browser ' + name)
	  return data
	}

	function unknownQuery(query) {
	  return new BrowserslistError(
	    'Unknown browser query `' +
	      query +
	      '`. ' +
	      'Maybe you are using old Browserslist or made typo in query.'
	  )
	}

	// Adjusts last X versions queries for some mobile browsers,
	// where caniuse data jumps from a legacy version to the latest
	function filterJumps(list, name, nVersions, context) {
	  var jump = 1;
	  switch (name) {
	    case 'android':
	      if (context.mobileToDesktop) return list
	      var released = browserslist.data.chrome.released;
	      jump = released.length - released.indexOf(ANDROID_EVERGREEN_FIRST);
	      break
	    case 'op_mob':
	      var latest = browserslist.data.op_mob.released.slice(-1)[0];
	      jump = getMajor(latest) - OP_MOB_BLINK_FIRST + 1;
	      break
	    default:
	      return list
	  }
	  if (nVersions <= jump) {
	    return list.slice(-1)
	  }
	  return list.slice(jump - 1 - nVersions)
	}

	function isSupported(flags, withPartial) {
	  return (
	    typeof flags === 'string' &&
	    (flags.indexOf('y') >= 0 || (withPartial && flags.indexOf('a') >= 0))
	  )
	}

	function resolve(queries, context) {
	  return parse(QUERIES, queries).reduce(function (result, node, index) {
	    if (node.not && index === 0) {
	      throw new BrowserslistError(
	        'Write any browsers query (for instance, `defaults`) ' +
	          'before `' +
	          node.query +
	          '`'
	      )
	    }
	    var type = QUERIES[node.type];
	    var array = type.select.call(browserslist, context, node).map(function (j) {
	      var parts = j.split(' ');
	      if (parts[1] === '0') {
	        return parts[0] + ' ' + byName(parts[0], context).versions[0]
	      } else {
	        return j
	      }
	    });

	    if (node.compose === 'and') {
	      if (node.not) {
	        return result.filter(function (j) {
	          return array.indexOf(j) === -1
	        })
	      } else {
	        return result.filter(function (j) {
	          return array.indexOf(j) !== -1
	        })
	      }
	    } else {
	      if (node.not) {
	        var filter = {};
	        array.forEach(function (j) {
	          filter[j] = true;
	        });
	        return result.filter(function (j) {
	          return !filter[j]
	        })
	      }
	      return result.concat(array)
	    }
	  }, [])
	}

	function prepareOpts(opts) {
	  if (typeof opts === 'undefined') opts = {};

	  if (typeof opts.path === 'undefined') {
	    opts.path = path.resolve ? path.resolve('.') : '.';
	  }

	  return opts
	}

	function prepareQueries(queries, opts) {
	  if (typeof queries === 'undefined' || queries === null) {
	    var config = browserslist.loadConfig(opts);
	    if (config) {
	      queries = config;
	    } else {
	      queries = browserslist.defaults;
	    }
	  }

	  return queries
	}

	function checkQueries(queries) {
	  if (!(typeof queries === 'string' || Array.isArray(queries))) {
	    throw new BrowserslistError(
	      'Browser queries must be an array or string. Got ' + typeof queries + '.'
	    )
	  }
	}

	var cache = {};

	function browserslist(queries, opts) {
	  opts = prepareOpts(opts);
	  queries = prepareQueries(queries, opts);
	  checkQueries(queries);

	  var context = {
	    ignoreUnknownVersions: opts.ignoreUnknownVersions,
	    dangerousExtend: opts.dangerousExtend,
	    mobileToDesktop: opts.mobileToDesktop,
	    path: opts.path,
	    env: opts.env
	  };

	  env.oldDataWarning(browserslist.data);
	  var stats = env.getStat(opts, browserslist.data);
	  if (stats) {
	    context.customUsage = {};
	    for (var browser in stats) {
	      fillUsage(context.customUsage, browser, stats[browser]);
	    }
	  }

	  var cacheKey = JSON.stringify([queries, context]);
	  if (cache[cacheKey]) return cache[cacheKey]

	  var result = uniq(resolve(queries, context)).sort(function (name1, name2) {
	    name1 = name1.split(' ');
	    name2 = name2.split(' ');
	    if (name1[0] === name2[0]) {
	      // assumptions on caniuse data
	      // 1) version ranges never overlaps
	      // 2) if version is not a range, it never contains `-`
	      var version1 = name1[1].split('-')[0];
	      var version2 = name2[1].split('-')[0];
	      return compareSemver(version2.split('.'), version1.split('.'))
	    } else {
	      return compare(name1[0], name2[0])
	    }
	  });
	  if (!env.env.BROWSERSLIST_DISABLE_CACHE) {
	    cache[cacheKey] = result;
	  }
	  return result
	}

	browserslist.parse = function (queries, opts) {
	  opts = prepareOpts(opts);
	  queries = prepareQueries(queries, opts);
	  checkQueries(queries);
	  return parse(QUERIES, queries)
	};

	// Will be filled by Can I Use data below
	browserslist.cache = {};
	browserslist.data = {};
	browserslist.usage = {
	  global: {},
	  custom: null
	};

	// Default browsers query
	browserslist.defaults = ['> 0.5%', 'last 2 versions', 'Firefox ESR', 'not dead'];

	// Browser names aliases
	browserslist.aliases = {
	  fx: 'firefox',
	  ff: 'firefox',
	  ios: 'ios_saf',
	  explorer: 'ie',
	  blackberry: 'bb',
	  explorermobile: 'ie_mob',
	  operamini: 'op_mini',
	  operamobile: 'op_mob',
	  chromeandroid: 'and_chr',
	  firefoxandroid: 'and_ff',
	  ucandroid: 'and_uc',
	  qqandroid: 'and_qq'
	};

	// Can I Use only provides a few versions for some browsers (e.g. and_chr).
	// Fallback to a similar browser for unknown versions
	// Note op_mob is not included as its chromium versions are not in sync with Opera desktop
	browserslist.desktopNames = {
	  and_chr: 'chrome',
	  and_ff: 'firefox',
	  ie_mob: 'ie',
	  android: 'chrome' // has extra processing logic
	};

	// Aliases to work with joined versions like `ios_saf 7.0-7.1`
	browserslist.versionAliases = {};

	browserslist.clearCaches = env.clearCaches;
	browserslist.parseConfig = env.parseConfig;
	browserslist.readConfig = env.readConfig;
	browserslist.findConfig = env.findConfig;
	browserslist.loadConfig = env.loadConfig;

	browserslist.coverage = function (browsers, stats) {
	  var data;
	  if (typeof stats === 'undefined') {
	    data = browserslist.usage.global;
	  } else if (stats === 'my stats') {
	    var opts = {};
	    opts.path = path.resolve ? path.resolve('.') : '.';
	    var customStats = env.getStat(opts);
	    if (!customStats) {
	      throw new BrowserslistError('Custom usage statistics was not provided')
	    }
	    data = {};
	    for (var browser in customStats) {
	      fillUsage(data, browser, customStats[browser]);
	    }
	  } else if (typeof stats === 'string') {
	    if (stats.length > 2) {
	      stats = stats.toLowerCase();
	    } else {
	      stats = stats.toUpperCase();
	    }
	    env.loadCountry(browserslist.usage, stats, browserslist.data);
	    data = browserslist.usage[stats];
	  } else {
	    if ('dataByBrowser' in stats) {
	      stats = stats.dataByBrowser;
	    }
	    data = {};
	    for (var name in stats) {
	      for (var version in stats[name]) {
	        data[name + ' ' + version] = stats[name][version];
	      }
	    }
	  }

	  return browsers.reduce(function (all, i) {
	    var usage = data[i];
	    if (usage === undefined) {
	      usage = data[i.replace(/ \S+$/, ' 0')];
	    }
	    return all + (usage || 0)
	  }, 0)
	};

	function nodeQuery(context, node) {
	  var matched = browserslist.nodeVersions.filter(function (i) {
	    return isVersionsMatch(i, node.version)
	  });
	  if (matched.length === 0) {
	    if (context.ignoreUnknownVersions) {
	      return []
	    } else {
	      throw new BrowserslistError(
	        'Unknown version ' + node.version + ' of Node.js'
	      )
	    }
	  }
	  return ['node ' + matched[matched.length - 1]]
	}

	function sinceQuery(context, node) {
	  var year = parseInt(node.year);
	  var month = parseInt(node.month || '01') - 1;
	  var day = parseInt(node.day || '01');
	  return filterByYear(Date.UTC(year, month, day, 0, 0, 0), context)
	}

	function coverQuery(context, node) {
	  var coverage = parseFloat(node.coverage);
	  var usage = browserslist.usage.global;
	  if (node.place) {
	    if (node.place.match(/^my\s+stats$/i)) {
	      if (!context.customUsage) {
	        throw new BrowserslistError('Custom usage statistics was not provided')
	      }
	      usage = context.customUsage;
	    } else {
	      var place;
	      if (node.place.length === 2) {
	        place = node.place.toUpperCase();
	      } else {
	        place = node.place.toLowerCase();
	      }
	      env.loadCountry(browserslist.usage, place, browserslist.data);
	      usage = browserslist.usage[place];
	    }
	  }
	  var versions = Object.keys(usage).sort(function (a, b) {
	    return usage[b] - usage[a]
	  });
	  var coveraged = 0;
	  var result = [];
	  var version;
	  for (var i = 0; i < versions.length; i++) {
	    version = versions[i];
	    if (usage[version] === 0) break
	    coveraged += usage[version];
	    result.push(version);
	    if (coveraged >= coverage) break
	  }
	  return result
	}

	var QUERIES = {
	  last_major_versions: {
	    matches: ['versions'],
	    regexp: /^last\s+(\d+)\s+major\s+versions?$/i,
	    select: function (context, node) {
	      return Object.keys(agents).reduce(function (selected, name) {
	        var data = byName(name, context);
	        if (!data) return selected
	        var list = getMajorVersions(data.released, node.versions);
	        list = list.map(nameMapper(data.name));
	        list = filterJumps(list, data.name, node.versions, context);
	        return selected.concat(list)
	      }, [])
	    }
	  },
	  last_versions: {
	    matches: ['versions'],
	    regexp: /^last\s+(\d+)\s+versions?$/i,
	    select: function (context, node) {
	      return Object.keys(agents).reduce(function (selected, name) {
	        var data = byName(name, context);
	        if (!data) return selected
	        var list = data.released.slice(-node.versions);
	        list = list.map(nameMapper(data.name));
	        list = filterJumps(list, data.name, node.versions, context);
	        return selected.concat(list)
	      }, [])
	    }
	  },
	  last_electron_major_versions: {
	    matches: ['versions'],
	    regexp: /^last\s+(\d+)\s+electron\s+major\s+versions?$/i,
	    select: function (context, node) {
	      var validVersions = getMajorVersions(Object.keys(e2c), node.versions);
	      return validVersions.map(function (i) {
	        return 'chrome ' + e2c[i]
	      })
	    }
	  },
	  last_node_major_versions: {
	    matches: ['versions'],
	    regexp: /^last\s+(\d+)\s+node\s+major\s+versions?$/i,
	    select: function (context, node) {
	      return getMajorVersions(browserslist.nodeVersions, node.versions).map(
	        function (version) {
	          return 'node ' + version
	        }
	      )
	    }
	  },
	  last_browser_major_versions: {
	    matches: ['versions', 'browser'],
	    regexp: /^last\s+(\d+)\s+(\w+)\s+major\s+versions?$/i,
	    select: function (context, node) {
	      var data = checkName(node.browser, context);
	      var validVersions = getMajorVersions(data.released, node.versions);
	      var list = validVersions.map(nameMapper(data.name));
	      list = filterJumps(list, data.name, node.versions, context);
	      return list
	    }
	  },
	  last_electron_versions: {
	    matches: ['versions'],
	    regexp: /^last\s+(\d+)\s+electron\s+versions?$/i,
	    select: function (context, node) {
	      return Object.keys(e2c)
	        .slice(-node.versions)
	        .map(function (i) {
	          return 'chrome ' + e2c[i]
	        })
	    }
	  },
	  last_node_versions: {
	    matches: ['versions'],
	    regexp: /^last\s+(\d+)\s+node\s+versions?$/i,
	    select: function (context, node) {
	      return browserslist.nodeVersions
	        .slice(-node.versions)
	        .map(function (version) {
	          return 'node ' + version
	        })
	    }
	  },
	  last_browser_versions: {
	    matches: ['versions', 'browser'],
	    regexp: /^last\s+(\d+)\s+(\w+)\s+versions?$/i,
	    select: function (context, node) {
	      var data = checkName(node.browser, context);
	      var list = data.released.slice(-node.versions).map(nameMapper(data.name));
	      list = filterJumps(list, data.name, node.versions, context);
	      return list
	    }
	  },
	  unreleased_versions: {
	    matches: [],
	    regexp: /^unreleased\s+versions$/i,
	    select: function (context) {
	      return Object.keys(agents).reduce(function (selected, name) {
	        var data = byName(name, context);
	        if (!data) return selected
	        var list = data.versions.filter(function (v) {
	          return data.released.indexOf(v) === -1
	        });
	        list = list.map(nameMapper(data.name));
	        return selected.concat(list)
	      }, [])
	    }
	  },
	  unreleased_electron_versions: {
	    matches: [],
	    regexp: /^unreleased\s+electron\s+versions?$/i,
	    select: function () {
	      return []
	    }
	  },
	  unreleased_browser_versions: {
	    matches: ['browser'],
	    regexp: /^unreleased\s+(\w+)\s+versions?$/i,
	    select: function (context, node) {
	      var data = checkName(node.browser, context);
	      return data.versions
	        .filter(function (v) {
	          return data.released.indexOf(v) === -1
	        })
	        .map(nameMapper(data.name))
	    }
	  },
	  last_years: {
	    matches: ['years'],
	    regexp: /^last\s+(\d*.?\d+)\s+years?$/i,
	    select: function (context, node) {
	      return filterByYear(Date.now() - YEAR * node.years, context)
	    }
	  },
	  since_y: {
	    matches: ['year'],
	    regexp: /^since (\d+)$/i,
	    select: sinceQuery
	  },
	  since_y_m: {
	    matches: ['year', 'month'],
	    regexp: /^since (\d+)-(\d+)$/i,
	    select: sinceQuery
	  },
	  since_y_m_d: {
	    matches: ['year', 'month', 'day'],
	    regexp: /^since (\d+)-(\d+)-(\d+)$/i,
	    select: sinceQuery
	  },
	  popularity: {
	    matches: ['sign', 'popularity'],
	    regexp: /^(>=?|<=?)\s*(\d+|\d+\.\d+|\.\d+)%$/,
	    select: function (context, node) {
	      var popularity = parseFloat(node.popularity);
	      var usage = browserslist.usage.global;
	      return Object.keys(usage).reduce(function (result, version) {
	        if (node.sign === '>') {
	          if (usage[version] > popularity) {
	            result.push(version);
	          }
	        } else if (node.sign === '<') {
	          if (usage[version] < popularity) {
	            result.push(version);
	          }
	        } else if (node.sign === '<=') {
	          if (usage[version] <= popularity) {
	            result.push(version);
	          }
	        } else if (usage[version] >= popularity) {
	          result.push(version);
	        }
	        return result
	      }, [])
	    }
	  },
	  popularity_in_my_stats: {
	    matches: ['sign', 'popularity'],
	    regexp: /^(>=?|<=?)\s*(\d+|\d+\.\d+|\.\d+)%\s+in\s+my\s+stats$/,
	    select: function (context, node) {
	      var popularity = parseFloat(node.popularity);
	      if (!context.customUsage) {
	        throw new BrowserslistError('Custom usage statistics was not provided')
	      }
	      var usage = context.customUsage;
	      return Object.keys(usage).reduce(function (result, version) {
	        var percentage = usage[version];
	        if (percentage == null) {
	          return result
	        }

	        if (node.sign === '>') {
	          if (percentage > popularity) {
	            result.push(version);
	          }
	        } else if (node.sign === '<') {
	          if (percentage < popularity) {
	            result.push(version);
	          }
	        } else if (node.sign === '<=') {
	          if (percentage <= popularity) {
	            result.push(version);
	          }
	        } else if (percentage >= popularity) {
	          result.push(version);
	        }
	        return result
	      }, [])
	    }
	  },
	  popularity_in_config_stats: {
	    matches: ['sign', 'popularity', 'config'],
	    regexp: /^(>=?|<=?)\s*(\d+|\d+\.\d+|\.\d+)%\s+in\s+(\S+)\s+stats$/,
	    select: function (context, node) {
	      var popularity = parseFloat(node.popularity);
	      var stats = env.loadStat(context, node.config, browserslist.data);
	      if (stats) {
	        context.customUsage = {};
	        for (var browser in stats) {
	          fillUsage(context.customUsage, browser, stats[browser]);
	        }
	      }
	      if (!context.customUsage) {
	        throw new BrowserslistError('Custom usage statistics was not provided')
	      }
	      var usage = context.customUsage;
	      return Object.keys(usage).reduce(function (result, version) {
	        var percentage = usage[version];
	        if (percentage == null) {
	          return result
	        }

	        if (node.sign === '>') {
	          if (percentage > popularity) {
	            result.push(version);
	          }
	        } else if (node.sign === '<') {
	          if (percentage < popularity) {
	            result.push(version);
	          }
	        } else if (node.sign === '<=') {
	          if (percentage <= popularity) {
	            result.push(version);
	          }
	        } else if (percentage >= popularity) {
	          result.push(version);
	        }
	        return result
	      }, [])
	    }
	  },
	  popularity_in_place: {
	    matches: ['sign', 'popularity', 'place'],
	    regexp: /^(>=?|<=?)\s*(\d+|\d+\.\d+|\.\d+)%\s+in\s+((alt-)?\w\w)$/,
	    select: function (context, node) {
	      var popularity = parseFloat(node.popularity);
	      var place = node.place;
	      if (place.length === 2) {
	        place = place.toUpperCase();
	      } else {
	        place = place.toLowerCase();
	      }
	      env.loadCountry(browserslist.usage, place, browserslist.data);
	      var usage = browserslist.usage[place];
	      return Object.keys(usage).reduce(function (result, version) {
	        var percentage = usage[version];
	        if (percentage == null) {
	          return result
	        }

	        if (node.sign === '>') {
	          if (percentage > popularity) {
	            result.push(version);
	          }
	        } else if (node.sign === '<') {
	          if (percentage < popularity) {
	            result.push(version);
	          }
	        } else if (node.sign === '<=') {
	          if (percentage <= popularity) {
	            result.push(version);
	          }
	        } else if (percentage >= popularity) {
	          result.push(version);
	        }
	        return result
	      }, [])
	    }
	  },
	  cover: {
	    matches: ['coverage'],
	    regexp: /^cover\s+(\d+|\d+\.\d+|\.\d+)%$/i,
	    select: coverQuery
	  },
	  cover_in: {
	    matches: ['coverage', 'place'],
	    regexp: /^cover\s+(\d+|\d+\.\d+|\.\d+)%\s+in\s+(my\s+stats|(alt-)?\w\w)$/i,
	    select: coverQuery
	  },
	  supports: {
	    matches: ['supportType', 'feature'],
	    regexp: /^(?:(fully|partially)\s+)?supports\s+([\w-]+)$/,
	    select: function (context, node) {
	      env.loadFeature(browserslist.cache, node.feature);
	      var withPartial = node.supportType !== 'fully';
	      var features = browserslist.cache[node.feature];
	      var result = [];
	      for (var name in features) {
	        var data = byName(name, context);
	        // Only check desktop when latest released mobile has support
	        var checkDesktop =
	          context.mobileToDesktop &&
	          name in browserslist.desktopNames &&
	          isSupported(features[name][data.released.slice(-1)[0]], withPartial);
	        data.versions.forEach(function (version) {
	          var flags = features[name][version];
	          if (flags === undefined && checkDesktop) {
	            flags = features[browserslist.desktopNames[name]][version];
	          }
	          if (isSupported(flags, withPartial)) {
	            result.push(name + ' ' + version);
	          }
	        });
	      }
	      return result
	    }
	  },
	  electron_range: {
	    matches: ['from', 'to'],
	    regexp: /^electron\s+([\d.]+)\s*-\s*([\d.]+)$/i,
	    select: function (context, node) {
	      var fromToUse = normalizeElectron(node.from);
	      var toToUse = normalizeElectron(node.to);
	      var from = parseFloat(node.from);
	      var to = parseFloat(node.to);
	      if (!e2c[fromToUse]) {
	        throw new BrowserslistError('Unknown version ' + from + ' of electron')
	      }
	      if (!e2c[toToUse]) {
	        throw new BrowserslistError('Unknown version ' + to + ' of electron')
	      }
	      return Object.keys(e2c)
	        .filter(function (i) {
	          var parsed = parseFloat(i);
	          return parsed >= from && parsed <= to
	        })
	        .map(function (i) {
	          return 'chrome ' + e2c[i]
	        })
	    }
	  },
	  node_range: {
	    matches: ['from', 'to'],
	    regexp: /^node\s+([\d.]+)\s*-\s*([\d.]+)$/i,
	    select: function (context, node) {
	      return browserslist.nodeVersions
	        .filter(semverFilterLoose('>=', node.from))
	        .filter(semverFilterLoose('<=', node.to))
	        .map(function (v) {
	          return 'node ' + v
	        })
	    }
	  },
	  browser_range: {
	    matches: ['browser', 'from', 'to'],
	    regexp: /^(\w+)\s+([\d.]+)\s*-\s*([\d.]+)$/i,
	    select: function (context, node) {
	      var data = checkName(node.browser, context);
	      var from = parseFloat(normalizeVersion(data, node.from) || node.from);
	      var to = parseFloat(normalizeVersion(data, node.to) || node.to);
	      function filter(v) {
	        var parsed = parseFloat(v);
	        return parsed >= from && parsed <= to
	      }
	      return data.released.filter(filter).map(nameMapper(data.name))
	    }
	  },
	  electron_ray: {
	    matches: ['sign', 'version'],
	    regexp: /^electron\s*(>=?|<=?)\s*([\d.]+)$/i,
	    select: function (context, node) {
	      var versionToUse = normalizeElectron(node.version);
	      return Object.keys(e2c)
	        .filter(generateFilter(node.sign, versionToUse))
	        .map(function (i) {
	          return 'chrome ' + e2c[i]
	        })
	    }
	  },
	  node_ray: {
	    matches: ['sign', 'version'],
	    regexp: /^node\s*(>=?|<=?)\s*([\d.]+)$/i,
	    select: function (context, node) {
	      return browserslist.nodeVersions
	        .filter(generateSemverFilter(node.sign, node.version))
	        .map(function (v) {
	          return 'node ' + v
	        })
	    }
	  },
	  browser_ray: {
	    matches: ['browser', 'sign', 'version'],
	    regexp: /^(\w+)\s*(>=?|<=?)\s*([\d.]+)$/,
	    select: function (context, node) {
	      var version = node.version;
	      var data = checkName(node.browser, context);
	      var alias = browserslist.versionAliases[data.name][version];
	      if (alias) version = alias;
	      return data.released
	        .filter(generateFilter(node.sign, version))
	        .map(function (v) {
	          return data.name + ' ' + v
	        })
	    }
	  },
	  firefox_esr: {
	    matches: [],
	    regexp: /^(firefox|ff|fx)\s+esr$/i,
	    select: function () {
	      return ['firefox 115']
	    }
	  },
	  opera_mini_all: {
	    matches: [],
	    regexp: /(operamini|op_mini)\s+all/i,
	    select: function () {
	      return ['op_mini all']
	    }
	  },
	  electron_version: {
	    matches: ['version'],
	    regexp: /^electron\s+([\d.]+)$/i,
	    select: function (context, node) {
	      var versionToUse = normalizeElectron(node.version);
	      var chrome = e2c[versionToUse];
	      if (!chrome) {
	        throw new BrowserslistError(
	          'Unknown version ' + node.version + ' of electron'
	        )
	      }
	      return ['chrome ' + chrome]
	    }
	  },
	  node_major_version: {
	    matches: ['version'],
	    regexp: /^node\s+(\d+)$/i,
	    select: nodeQuery
	  },
	  node_minor_version: {
	    matches: ['version'],
	    regexp: /^node\s+(\d+\.\d+)$/i,
	    select: nodeQuery
	  },
	  node_patch_version: {
	    matches: ['version'],
	    regexp: /^node\s+(\d+\.\d+\.\d+)$/i,
	    select: nodeQuery
	  },
	  current_node: {
	    matches: [],
	    regexp: /^current\s+node$/i,
	    select: function (context) {
	      return [env.currentNode(resolve, context)]
	    }
	  },
	  maintained_node: {
	    matches: [],
	    regexp: /^maintained\s+node\s+versions$/i,
	    select: function (context) {
	      var now = Date.now();
	      var queries = Object.keys(jsEOL)
	        .filter(function (key) {
	          return (
	            now < Date.parse(jsEOL[key].end) &&
	            now > Date.parse(jsEOL[key].start) &&
	            isEolReleased(key)
	          )
	        })
	        .map(function (key) {
	          return 'node ' + key.slice(1)
	        });
	      return resolve(queries, context)
	    }
	  },
	  phantomjs_1_9: {
	    matches: [],
	    regexp: /^phantomjs\s+1.9$/i,
	    select: function () {
	      return ['safari 5']
	    }
	  },
	  phantomjs_2_1: {
	    matches: [],
	    regexp: /^phantomjs\s+2.1$/i,
	    select: function () {
	      return ['safari 6']
	    }
	  },
	  browser_version: {
	    matches: ['browser', 'version'],
	    regexp: /^(\w+)\s+(tp|[\d.]+)$/i,
	    select: function (context, node) {
	      var version = node.version;
	      if (/^tp$/i.test(version)) version = 'TP';
	      var data = checkName(node.browser, context);
	      var alias = normalizeVersion(data, version);
	      if (alias) {
	        version = alias;
	      } else {
	        if (version.indexOf('.') === -1) {
	          alias = version + '.0';
	        } else {
	          alias = version.replace(/\.0$/, '');
	        }
	        alias = normalizeVersion(data, alias);
	        if (alias) {
	          version = alias;
	        } else if (context.ignoreUnknownVersions) {
	          return []
	        } else {
	          throw new BrowserslistError(
	            'Unknown version ' + version + ' of ' + node.browser
	          )
	        }
	      }
	      return [data.name + ' ' + version]
	    }
	  },
	  browserslist_config: {
	    matches: [],
	    regexp: /^browserslist config$/i,
	    select: function (context) {
	      return browserslist(undefined, context)
	    }
	  },
	  extends: {
	    matches: ['config'],
	    regexp: /^extends (.+)$/i,
	    select: function (context, node) {
	      return resolve(env.loadQueries(context, node.config), context)
	    }
	  },
	  defaults: {
	    matches: [],
	    regexp: /^defaults$/i,
	    select: function (context) {
	      return resolve(browserslist.defaults, context)
	    }
	  },
	  dead: {
	    matches: [],
	    regexp: /^dead$/i,
	    select: function (context) {
	      var dead = [
	        'Baidu >= 0',
	        'ie <= 11',
	        'ie_mob <= 11',
	        'bb <= 10',
	        'op_mob <= 12.1',
	        'samsung 4'
	      ];
	      return resolve(dead, context)
	    }
	  },
	  unknown: {
	    matches: [],
	    regexp: /^(\w+)$/i,
	    select: function (context, node) {
	      if (byName(node.query, context)) {
	        throw new BrowserslistError(
	          'Specify versions in Browserslist query for browser ' + node.query
	        )
	      } else {
	        throw unknownQuery(node.query)
	      }
	    }
	  }
	}

	// Get and convert Can I Use data

	;(function () {
	  for (var name in agents) {
	    var browser = agents[name];
	    browserslist.data[name] = {
	      name: name,
	      versions: normalize(agents[name].versions),
	      released: normalize(agents[name].versions.slice(0, -3)),
	      releaseDate: agents[name].release_date
	    };
	    fillUsage(browserslist.usage.global, name, browser.usage_global);

	    browserslist.versionAliases[name] = {};
	    for (var i = 0; i < browser.versions.length; i++) {
	      var full = browser.versions[i];
	      if (!full) continue

	      if (full.indexOf('-') !== -1) {
	        var interval = full.split('-');
	        for (var j = 0; j < interval.length; j++) {
	          browserslist.versionAliases[name][interval[j]] = full;
	        }
	      }
	    }
	  }

	  browserslist.nodeVersions = jsReleases.map(function (release) {
	    return release.version
	  });
	})();

	browserslist_1 = browserslist;
	return browserslist_1;
}

var lib = {};

var validator = {};

var findSuggestion = {};

var hasRequiredFindSuggestion;

function requireFindSuggestion () {
	if (hasRequiredFindSuggestion) return findSuggestion;
	hasRequiredFindSuggestion = 1;

	Object.defineProperty(findSuggestion, "__esModule", {
	  value: true
	});
	findSuggestion.findSuggestion = findSuggestion$1;
	const {
	  min
	} = Math;
	function levenshtein(a, b) {
	  let t = [],
	    u = [],
	    i,
	    j;
	  const m = a.length,
	    n = b.length;
	  if (!m) {
	    return n;
	  }
	  if (!n) {
	    return m;
	  }
	  for (j = 0; j <= n; j++) {
	    t[j] = j;
	  }
	  for (i = 1; i <= m; i++) {
	    for (u = [i], j = 1; j <= n; j++) {
	      u[j] = a[i - 1] === b[j - 1] ? t[j - 1] : min(t[j - 1], t[j], u[j - 1]) + 1;
	    }
	    t = u;
	  }
	  return u[n];
	}
	function findSuggestion$1(str, arr) {
	  const distances = arr.map(el => levenshtein(el, str));
	  return arr[distances.indexOf(min(...distances))];
	}

	
	return findSuggestion;
}

var hasRequiredValidator;

function requireValidator () {
	if (hasRequiredValidator) return validator;
	hasRequiredValidator = 1;

	Object.defineProperty(validator, "__esModule", {
	  value: true
	});
	validator.OptionValidator = void 0;
	var _findSuggestion = requireFindSuggestion();
	class OptionValidator {
	  constructor(descriptor) {
	    this.descriptor = descriptor;
	  }
	  validateTopLevelOptions(options, TopLevelOptionShape) {
	    const validOptionNames = Object.keys(TopLevelOptionShape);
	    for (const option of Object.keys(options)) {
	      if (!validOptionNames.includes(option)) {
	        throw new Error(this.formatMessage(`'${option}' is not a valid top-level option.
- Did you mean '${(0, _findSuggestion.findSuggestion)(option, validOptionNames)}'?`));
	      }
	    }
	  }
	  validateBooleanOption(name, value, defaultValue) {
	    if (value === undefined) {
	      return defaultValue;
	    } else {
	      this.invariant(typeof value === "boolean", `'${name}' option must be a boolean.`);
	    }
	    return value;
	  }
	  validateStringOption(name, value, defaultValue) {
	    if (value === undefined) {
	      return defaultValue;
	    } else {
	      this.invariant(typeof value === "string", `'${name}' option must be a string.`);
	    }
	    return value;
	  }
	  invariant(condition, message) {
	    if (!condition) {
	      throw new Error(this.formatMessage(message));
	    }
	  }
	  formatMessage(message) {
	    return `${this.descriptor}: ${message}`;
	  }
	}
	validator.OptionValidator = OptionValidator;

	
	return validator;
}

var hasRequiredLib$2;

function requireLib$2 () {
	if (hasRequiredLib$2) return lib;
	hasRequiredLib$2 = 1;
	(function (exports) {

		Object.defineProperty(exports, "__esModule", {
		  value: true
		});
		Object.defineProperty(exports, "OptionValidator", {
		  enumerable: true,
		  get: function () {
		    return _validator.OptionValidator;
		  }
		});
		Object.defineProperty(exports, "findSuggestion", {
		  enumerable: true,
		  get: function () {
		    return _findSuggestion.findSuggestion;
		  }
		});
		var _validator = requireValidator();
		var _findSuggestion = requireFindSuggestion();

		
	} (lib));
	return lib;
}

var require$$0$2 = {
	"es6.module": {
	chrome: "61",
	and_chr: "61",
	edge: "16",
	firefox: "60",
	and_ff: "60",
	node: "13.2.0",
	opera: "48",
	op_mob: "45",
	safari: "10.1",
	ios: "10.3",
	samsung: "8.2",
	android: "61",
	electron: "2.0",
	ios_saf: "10.3"
}
};

var nativeModules;
var hasRequiredNativeModules;

function requireNativeModules () {
	if (hasRequiredNativeModules) return nativeModules;
	hasRequiredNativeModules = 1;
	nativeModules = require$$0$2;
	return nativeModules;
}

var iterator;
var hasRequiredIterator;

function requireIterator () {
	if (hasRequiredIterator) return iterator;
	hasRequiredIterator = 1;
	iterator = function (Yallist) {
	  Yallist.prototype[Symbol.iterator] = function* () {
	    for (let walker = this.head; walker; walker = walker.next) {
	      yield walker.value;
	    }
	  };
	};
	return iterator;
}

var yallist;
var hasRequiredYallist;

function requireYallist () {
	if (hasRequiredYallist) return yallist;
	hasRequiredYallist = 1;
	yallist = Yallist;

	Yallist.Node = Node;
	Yallist.create = Yallist;

	function Yallist (list) {
	  var self = this;
	  if (!(self instanceof Yallist)) {
	    self = new Yallist();
	  }

	  self.tail = null;
	  self.head = null;
	  self.length = 0;

	  if (list && typeof list.forEach === 'function') {
	    list.forEach(function (item) {
	      self.push(item);
	    });
	  } else if (arguments.length > 0) {
	    for (var i = 0, l = arguments.length; i < l; i++) {
	      self.push(arguments[i]);
	    }
	  }

	  return self
	}

	Yallist.prototype.removeNode = function (node) {
	  if (node.list !== this) {
	    throw new Error('removing node which does not belong to this list')
	  }

	  var next = node.next;
	  var prev = node.prev;

	  if (next) {
	    next.prev = prev;
	  }

	  if (prev) {
	    prev.next = next;
	  }

	  if (node === this.head) {
	    this.head = next;
	  }
	  if (node === this.tail) {
	    this.tail = prev;
	  }

	  node.list.length--;
	  node.next = null;
	  node.prev = null;
	  node.list = null;

	  return next
	};

	Yallist.prototype.unshiftNode = function (node) {
	  if (node === this.head) {
	    return
	  }

	  if (node.list) {
	    node.list.removeNode(node);
	  }

	  var head = this.head;
	  node.list = this;
	  node.next = head;
	  if (head) {
	    head.prev = node;
	  }

	  this.head = node;
	  if (!this.tail) {
	    this.tail = node;
	  }
	  this.length++;
	};

	Yallist.prototype.pushNode = function (node) {
	  if (node === this.tail) {
	    return
	  }

	  if (node.list) {
	    node.list.removeNode(node);
	  }

	  var tail = this.tail;
	  node.list = this;
	  node.prev = tail;
	  if (tail) {
	    tail.next = node;
	  }

	  this.tail = node;
	  if (!this.head) {
	    this.head = node;
	  }
	  this.length++;
	};

	Yallist.prototype.push = function () {
	  for (var i = 0, l = arguments.length; i < l; i++) {
	    push(this, arguments[i]);
	  }
	  return this.length
	};

	Yallist.prototype.unshift = function () {
	  for (var i = 0, l = arguments.length; i < l; i++) {
	    unshift(this, arguments[i]);
	  }
	  return this.length
	};

	Yallist.prototype.pop = function () {
	  if (!this.tail) {
	    return undefined
	  }

	  var res = this.tail.value;
	  this.tail = this.tail.prev;
	  if (this.tail) {
	    this.tail.next = null;
	  } else {
	    this.head = null;
	  }
	  this.length--;
	  return res
	};

	Yallist.prototype.shift = function () {
	  if (!this.head) {
	    return undefined
	  }

	  var res = this.head.value;
	  this.head = this.head.next;
	  if (this.head) {
	    this.head.prev = null;
	  } else {
	    this.tail = null;
	  }
	  this.length--;
	  return res
	};

	Yallist.prototype.forEach = function (fn, thisp) {
	  thisp = thisp || this;
	  for (var walker = this.head, i = 0; walker !== null; i++) {
	    fn.call(thisp, walker.value, i, this);
	    walker = walker.next;
	  }
	};

	Yallist.prototype.forEachReverse = function (fn, thisp) {
	  thisp = thisp || this;
	  for (var walker = this.tail, i = this.length - 1; walker !== null; i--) {
	    fn.call(thisp, walker.value, i, this);
	    walker = walker.prev;
	  }
	};

	Yallist.prototype.get = function (n) {
	  for (var i = 0, walker = this.head; walker !== null && i < n; i++) {
	    // abort out of the list early if we hit a cycle
	    walker = walker.next;
	  }
	  if (i === n && walker !== null) {
	    return walker.value
	  }
	};

	Yallist.prototype.getReverse = function (n) {
	  for (var i = 0, walker = this.tail; walker !== null && i < n; i++) {
	    // abort out of the list early if we hit a cycle
	    walker = walker.prev;
	  }
	  if (i === n && walker !== null) {
	    return walker.value
	  }
	};

	Yallist.prototype.map = function (fn, thisp) {
	  thisp = thisp || this;
	  var res = new Yallist();
	  for (var walker = this.head; walker !== null;) {
	    res.push(fn.call(thisp, walker.value, this));
	    walker = walker.next;
	  }
	  return res
	};

	Yallist.prototype.mapReverse = function (fn, thisp) {
	  thisp = thisp || this;
	  var res = new Yallist();
	  for (var walker = this.tail; walker !== null;) {
	    res.push(fn.call(thisp, walker.value, this));
	    walker = walker.prev;
	  }
	  return res
	};

	Yallist.prototype.reduce = function (fn, initial) {
	  var acc;
	  var walker = this.head;
	  if (arguments.length > 1) {
	    acc = initial;
	  } else if (this.head) {
	    walker = this.head.next;
	    acc = this.head.value;
	  } else {
	    throw new TypeError('Reduce of empty list with no initial value')
	  }

	  for (var i = 0; walker !== null; i++) {
	    acc = fn(acc, walker.value, i);
	    walker = walker.next;
	  }

	  return acc
	};

	Yallist.prototype.reduceReverse = function (fn, initial) {
	  var acc;
	  var walker = this.tail;
	  if (arguments.length > 1) {
	    acc = initial;
	  } else if (this.tail) {
	    walker = this.tail.prev;
	    acc = this.tail.value;
	  } else {
	    throw new TypeError('Reduce of empty list with no initial value')
	  }

	  for (var i = this.length - 1; walker !== null; i--) {
	    acc = fn(acc, walker.value, i);
	    walker = walker.prev;
	  }

	  return acc
	};

	Yallist.prototype.toArray = function () {
	  var arr = new Array(this.length);
	  for (var i = 0, walker = this.head; walker !== null; i++) {
	    arr[i] = walker.value;
	    walker = walker.next;
	  }
	  return arr
	};

	Yallist.prototype.toArrayReverse = function () {
	  var arr = new Array(this.length);
	  for (var i = 0, walker = this.tail; walker !== null; i++) {
	    arr[i] = walker.value;
	    walker = walker.prev;
	  }
	  return arr
	};

	Yallist.prototype.slice = function (from, to) {
	  to = to || this.length;
	  if (to < 0) {
	    to += this.length;
	  }
	  from = from || 0;
	  if (from < 0) {
	    from += this.length;
	  }
	  var ret = new Yallist();
	  if (to < from || to < 0) {
	    return ret
	  }
	  if (from < 0) {
	    from = 0;
	  }
	  if (to > this.length) {
	    to = this.length;
	  }
	  for (var i = 0, walker = this.head; walker !== null && i < from; i++) {
	    walker = walker.next;
	  }
	  for (; walker !== null && i < to; i++, walker = walker.next) {
	    ret.push(walker.value);
	  }
	  return ret
	};

	Yallist.prototype.sliceReverse = function (from, to) {
	  to = to || this.length;
	  if (to < 0) {
	    to += this.length;
	  }
	  from = from || 0;
	  if (from < 0) {
	    from += this.length;
	  }
	  var ret = new Yallist();
	  if (to < from || to < 0) {
	    return ret
	  }
	  if (from < 0) {
	    from = 0;
	  }
	  if (to > this.length) {
	    to = this.length;
	  }
	  for (var i = this.length, walker = this.tail; walker !== null && i > to; i--) {
	    walker = walker.prev;
	  }
	  for (; walker !== null && i > from; i--, walker = walker.prev) {
	    ret.push(walker.value);
	  }
	  return ret
	};

	Yallist.prototype.splice = function (start, deleteCount /*, ...nodes */) {
	  if (start > this.length) {
	    start = this.length - 1;
	  }
	  if (start < 0) {
	    start = this.length + start;
	  }

	  for (var i = 0, walker = this.head; walker !== null && i < start; i++) {
	    walker = walker.next;
	  }

	  var ret = [];
	  for (var i = 0; walker && i < deleteCount; i++) {
	    ret.push(walker.value);
	    walker = this.removeNode(walker);
	  }
	  if (walker === null) {
	    walker = this.tail;
	  }

	  if (walker !== this.head && walker !== this.tail) {
	    walker = walker.prev;
	  }

	  for (var i = 2; i < arguments.length; i++) {
	    walker = insert(this, walker, arguments[i]);
	  }
	  return ret;
	};

	Yallist.prototype.reverse = function () {
	  var head = this.head;
	  var tail = this.tail;
	  for (var walker = head; walker !== null; walker = walker.prev) {
	    var p = walker.prev;
	    walker.prev = walker.next;
	    walker.next = p;
	  }
	  this.head = tail;
	  this.tail = head;
	  return this
	};

	function insert (self, node, value) {
	  var inserted = node === self.head ?
	    new Node(value, null, node, self) :
	    new Node(value, node, node.next, self);

	  if (inserted.next === null) {
	    self.tail = inserted;
	  }
	  if (inserted.prev === null) {
	    self.head = inserted;
	  }

	  self.length++;

	  return inserted
	}

	function push (self, item) {
	  self.tail = new Node(item, self.tail, null, self);
	  if (!self.head) {
	    self.head = self.tail;
	  }
	  self.length++;
	}

	function unshift (self, item) {
	  self.head = new Node(item, null, self.head, self);
	  if (!self.tail) {
	    self.tail = self.head;
	  }
	  self.length++;
	}

	function Node (value, prev, next, list) {
	  if (!(this instanceof Node)) {
	    return new Node(value, prev, next, list)
	  }

	  this.list = list;
	  this.value = value;

	  if (prev) {
	    prev.next = this;
	    this.prev = prev;
	  } else {
	    this.prev = null;
	  }

	  if (next) {
	    next.prev = this;
	    this.next = next;
	  } else {
	    this.next = null;
	  }
	}

	try {
	  // add if support for Symbol.iterator is present
	  requireIterator()(Yallist);
	} catch (er) {}
	return yallist;
}

var lruCache;
var hasRequiredLruCache;

function requireLruCache () {
	if (hasRequiredLruCache) return lruCache;
	hasRequiredLruCache = 1;

	// A linked list to keep track of recently-used-ness
	const Yallist = requireYallist();

	const MAX = Symbol('max');
	const LENGTH = Symbol('length');
	const LENGTH_CALCULATOR = Symbol('lengthCalculator');
	const ALLOW_STALE = Symbol('allowStale');
	const MAX_AGE = Symbol('maxAge');
	const DISPOSE = Symbol('dispose');
	const NO_DISPOSE_ON_SET = Symbol('noDisposeOnSet');
	const LRU_LIST = Symbol('lruList');
	const CACHE = Symbol('cache');
	const UPDATE_AGE_ON_GET = Symbol('updateAgeOnGet');

	const naiveLength = () => 1;

	// lruList is a yallist where the head is the youngest
	// item, and the tail is the oldest.  the list contains the Hit
	// objects as the entries.
	// Each Hit object has a reference to its Yallist.Node.  This
	// never changes.
	//
	// cache is a Map (or PseudoMap) that matches the keys to
	// the Yallist.Node object.
	class LRUCache {
	  constructor (options) {
	    if (typeof options === 'number')
	      options = { max: options };

	    if (!options)
	      options = {};

	    if (options.max && (typeof options.max !== 'number' || options.max < 0))
	      throw new TypeError('max must be a non-negative number')
	    // Kind of weird to have a default max of Infinity, but oh well.
	    this[MAX] = options.max || Infinity;

	    const lc = options.length || naiveLength;
	    this[LENGTH_CALCULATOR] = (typeof lc !== 'function') ? naiveLength : lc;
	    this[ALLOW_STALE] = options.stale || false;
	    if (options.maxAge && typeof options.maxAge !== 'number')
	      throw new TypeError('maxAge must be a number')
	    this[MAX_AGE] = options.maxAge || 0;
	    this[DISPOSE] = options.dispose;
	    this[NO_DISPOSE_ON_SET] = options.noDisposeOnSet || false;
	    this[UPDATE_AGE_ON_GET] = options.updateAgeOnGet || false;
	    this.reset();
	  }

	  // resize the cache when the max changes.
	  set max (mL) {
	    if (typeof mL !== 'number' || mL < 0)
	      throw new TypeError('max must be a non-negative number')

	    this[MAX] = mL || Infinity;
	    trim(this);
	  }
	  get max () {
	    return this[MAX]
	  }

	  set allowStale (allowStale) {
	    this[ALLOW_STALE] = !!allowStale;
	  }
	  get allowStale () {
	    return this[ALLOW_STALE]
	  }

	  set maxAge (mA) {
	    if (typeof mA !== 'number')
	      throw new TypeError('maxAge must be a non-negative number')

	    this[MAX_AGE] = mA;
	    trim(this);
	  }
	  get maxAge () {
	    return this[MAX_AGE]
	  }

	  // resize the cache when the lengthCalculator changes.
	  set lengthCalculator (lC) {
	    if (typeof lC !== 'function')
	      lC = naiveLength;

	    if (lC !== this[LENGTH_CALCULATOR]) {
	      this[LENGTH_CALCULATOR] = lC;
	      this[LENGTH] = 0;
	      this[LRU_LIST].forEach(hit => {
	        hit.length = this[LENGTH_CALCULATOR](hit.value, hit.key);
	        this[LENGTH] += hit.length;
	      });
	    }
	    trim(this);
	  }
	  get lengthCalculator () { return this[LENGTH_CALCULATOR] }

	  get length () { return this[LENGTH] }
	  get itemCount () { return this[LRU_LIST].length }

	  rforEach (fn, thisp) {
	    thisp = thisp || this;
	    for (let walker = this[LRU_LIST].tail; walker !== null;) {
	      const prev = walker.prev;
	      forEachStep(this, fn, walker, thisp);
	      walker = prev;
	    }
	  }

	  forEach (fn, thisp) {
	    thisp = thisp || this;
	    for (let walker = this[LRU_LIST].head; walker !== null;) {
	      const next = walker.next;
	      forEachStep(this, fn, walker, thisp);
	      walker = next;
	    }
	  }

	  keys () {
	    return this[LRU_LIST].toArray().map(k => k.key)
	  }

	  values () {
	    return this[LRU_LIST].toArray().map(k => k.value)
	  }

	  reset () {
	    if (this[DISPOSE] &&
	        this[LRU_LIST] &&
	        this[LRU_LIST].length) {
	      this[LRU_LIST].forEach(hit => this[DISPOSE](hit.key, hit.value));
	    }

	    this[CACHE] = new Map(); // hash of items by key
	    this[LRU_LIST] = new Yallist(); // list of items in order of use recency
	    this[LENGTH] = 0; // length of items in the list
	  }

	  dump () {
	    return this[LRU_LIST].map(hit =>
	      isStale(this, hit) ? false : {
	        k: hit.key,
	        v: hit.value,
	        e: hit.now + (hit.maxAge || 0)
	      }).toArray().filter(h => h)
	  }

	  dumpLru () {
	    return this[LRU_LIST]
	  }

	  set (key, value, maxAge) {
	    maxAge = maxAge || this[MAX_AGE];

	    if (maxAge && typeof maxAge !== 'number')
	      throw new TypeError('maxAge must be a number')

	    const now = maxAge ? Date.now() : 0;
	    const len = this[LENGTH_CALCULATOR](value, key);

	    if (this[CACHE].has(key)) {
	      if (len > this[MAX]) {
	        del(this, this[CACHE].get(key));
	        return false
	      }

	      const node = this[CACHE].get(key);
	      const item = node.value;

	      // dispose of the old one before overwriting
	      // split out into 2 ifs for better coverage tracking
	      if (this[DISPOSE]) {
	        if (!this[NO_DISPOSE_ON_SET])
	          this[DISPOSE](key, item.value);
	      }

	      item.now = now;
	      item.maxAge = maxAge;
	      item.value = value;
	      this[LENGTH] += len - item.length;
	      item.length = len;
	      this.get(key);
	      trim(this);
	      return true
	    }

	    const hit = new Entry(key, value, len, now, maxAge);

	    // oversized objects fall out of cache automatically.
	    if (hit.length > this[MAX]) {
	      if (this[DISPOSE])
	        this[DISPOSE](key, value);

	      return false
	    }

	    this[LENGTH] += hit.length;
	    this[LRU_LIST].unshift(hit);
	    this[CACHE].set(key, this[LRU_LIST].head);
	    trim(this);
	    return true
	  }

	  has (key) {
	    if (!this[CACHE].has(key)) return false
	    const hit = this[CACHE].get(key).value;
	    return !isStale(this, hit)
	  }

	  get (key) {
	    return get(this, key, true)
	  }

	  peek (key) {
	    return get(this, key, false)
	  }

	  pop () {
	    const node = this[LRU_LIST].tail;
	    if (!node)
	      return null

	    del(this, node);
	    return node.value
	  }

	  del (key) {
	    del(this, this[CACHE].get(key));
	  }

	  load (arr) {
	    // reset the cache
	    this.reset();

	    const now = Date.now();
	    // A previous serialized cache has the most recent items first
	    for (let l = arr.length - 1; l >= 0; l--) {
	      const hit = arr[l];
	      const expiresAt = hit.e || 0;
	      if (expiresAt === 0)
	        // the item was created without expiration in a non aged cache
	        this.set(hit.k, hit.v);
	      else {
	        const maxAge = expiresAt - now;
	        // dont add already expired items
	        if (maxAge > 0) {
	          this.set(hit.k, hit.v, maxAge);
	        }
	      }
	    }
	  }

	  prune () {
	    this[CACHE].forEach((value, key) => get(this, key, false));
	  }
	}

	const get = (self, key, doUse) => {
	  const node = self[CACHE].get(key);
	  if (node) {
	    const hit = node.value;
	    if (isStale(self, hit)) {
	      del(self, node);
	      if (!self[ALLOW_STALE])
	        return undefined
	    } else {
	      if (doUse) {
	        if (self[UPDATE_AGE_ON_GET])
	          node.value.now = Date.now();
	        self[LRU_LIST].unshiftNode(node);
	      }
	    }
	    return hit.value
	  }
	};

	const isStale = (self, hit) => {
	  if (!hit || (!hit.maxAge && !self[MAX_AGE]))
	    return false

	  const diff = Date.now() - hit.now;
	  return hit.maxAge ? diff > hit.maxAge
	    : self[MAX_AGE] && (diff > self[MAX_AGE])
	};

	const trim = self => {
	  if (self[LENGTH] > self[MAX]) {
	    for (let walker = self[LRU_LIST].tail;
	      self[LENGTH] > self[MAX] && walker !== null;) {
	      // We know that we're about to delete this one, and also
	      // what the next least recently used key will be, so just
	      // go ahead and set it now.
	      const prev = walker.prev;
	      del(self, walker);
	      walker = prev;
	    }
	  }
	};

	const del = (self, node) => {
	  if (node) {
	    const hit = node.value;
	    if (self[DISPOSE])
	      self[DISPOSE](hit.key, hit.value);

	    self[LENGTH] -= hit.length;
	    self[CACHE].delete(hit.key);
	    self[LRU_LIST].removeNode(node);
	  }
	};

	class Entry {
	  constructor (key, value, length, now, maxAge) {
	    this.key = key;
	    this.value = value;
	    this.length = length;
	    this.now = now;
	    this.maxAge = maxAge || 0;
	  }
	}

	const forEachStep = (self, fn, node, thisp) => {
	  let hit = node.value;
	  if (isStale(self, hit)) {
	    del(self, node);
	    if (!self[ALLOW_STALE])
	      hit = undefined;
	  }
	  if (hit)
	    fn.call(thisp, hit.value, hit.key, self);
	};

	lruCache = LRUCache;
	return lruCache;
}

var utils = {};

var semver = {exports: {}};

semver.exports;

var hasRequiredSemver;

function requireSemver () {
	if (hasRequiredSemver) return semver.exports;
	hasRequiredSemver = 1;
	(function (module, exports) {
		exports = module.exports = SemVer;

		var debug;
		/* istanbul ignore next */
		if (typeof process === 'object' &&
		    process.env &&
		    process.env.NODE_DEBUG &&
		    /\bsemver\b/i.test(process.env.NODE_DEBUG)) {
		  debug = function () {
		    var args = Array.prototype.slice.call(arguments, 0);
		    args.unshift('SEMVER');
		    console.log.apply(console, args);
		  };
		} else {
		  debug = function () {};
		}

		// Note: this is the semver.org version of the spec that it implements
		// Not necessarily the package version of this code.
		exports.SEMVER_SPEC_VERSION = '2.0.0';

		var MAX_LENGTH = 256;
		var MAX_SAFE_INTEGER = Number.MAX_SAFE_INTEGER ||
		  /* istanbul ignore next */ 9007199254740991;

		// Max safe segment length for coercion.
		var MAX_SAFE_COMPONENT_LENGTH = 16;

		var MAX_SAFE_BUILD_LENGTH = MAX_LENGTH - 6;

		// The actual regexps go on exports.re
		var re = exports.re = [];
		var safeRe = exports.safeRe = [];
		var src = exports.src = [];
		var t = exports.tokens = {};
		var R = 0;

		function tok (n) {
		  t[n] = R++;
		}

		var LETTERDASHNUMBER = '[a-zA-Z0-9-]';

		// Replace some greedy regex tokens to prevent regex dos issues. These regex are
		// used internally via the safeRe object since all inputs in this library get
		// normalized first to trim and collapse all extra whitespace. The original
		// regexes are exported for userland consumption and lower level usage. A
		// future breaking change could export the safer regex only with a note that
		// all input should have extra whitespace removed.
		var safeRegexReplacements = [
		  ['\\s', 1],
		  ['\\d', MAX_LENGTH],
		  [LETTERDASHNUMBER, MAX_SAFE_BUILD_LENGTH],
		];

		function makeSafeRe (value) {
		  for (var i = 0; i < safeRegexReplacements.length; i++) {
		    var token = safeRegexReplacements[i][0];
		    var max = safeRegexReplacements[i][1];
		    value = value
		      .split(token + '*').join(token + '{0,' + max + '}')
		      .split(token + '+').join(token + '{1,' + max + '}');
		  }
		  return value
		}

		// The following Regular Expressions can be used for tokenizing,
		// validating, and parsing SemVer version strings.

		// ## Numeric Identifier
		// A single `0`, or a non-zero digit followed by zero or more digits.

		tok('NUMERICIDENTIFIER');
		src[t.NUMERICIDENTIFIER] = '0|[1-9]\\d*';
		tok('NUMERICIDENTIFIERLOOSE');
		src[t.NUMERICIDENTIFIERLOOSE] = '\\d+';

		// ## Non-numeric Identifier
		// Zero or more digits, followed by a letter or hyphen, and then zero or
		// more letters, digits, or hyphens.

		tok('NONNUMERICIDENTIFIER');
		src[t.NONNUMERICIDENTIFIER] = '\\d*[a-zA-Z-]' + LETTERDASHNUMBER + '*';

		// ## Main Version
		// Three dot-separated numeric identifiers.

		tok('MAINVERSION');
		src[t.MAINVERSION] = '(' + src[t.NUMERICIDENTIFIER] + ')\\.' +
		                   '(' + src[t.NUMERICIDENTIFIER] + ')\\.' +
		                   '(' + src[t.NUMERICIDENTIFIER] + ')';

		tok('MAINVERSIONLOOSE');
		src[t.MAINVERSIONLOOSE] = '(' + src[t.NUMERICIDENTIFIERLOOSE] + ')\\.' +
		                        '(' + src[t.NUMERICIDENTIFIERLOOSE] + ')\\.' +
		                        '(' + src[t.NUMERICIDENTIFIERLOOSE] + ')';

		// ## Pre-release Version Identifier
		// A numeric identifier, or a non-numeric identifier.

		tok('PRERELEASEIDENTIFIER');
		src[t.PRERELEASEIDENTIFIER] = '(?:' + src[t.NUMERICIDENTIFIER] +
		                            '|' + src[t.NONNUMERICIDENTIFIER] + ')';

		tok('PRERELEASEIDENTIFIERLOOSE');
		src[t.PRERELEASEIDENTIFIERLOOSE] = '(?:' + src[t.NUMERICIDENTIFIERLOOSE] +
		                                 '|' + src[t.NONNUMERICIDENTIFIER] + ')';

		// ## Pre-release Version
		// Hyphen, followed by one or more dot-separated pre-release version
		// identifiers.

		tok('PRERELEASE');
		src[t.PRERELEASE] = '(?:-(' + src[t.PRERELEASEIDENTIFIER] +
		                  '(?:\\.' + src[t.PRERELEASEIDENTIFIER] + ')*))';

		tok('PRERELEASELOOSE');
		src[t.PRERELEASELOOSE] = '(?:-?(' + src[t.PRERELEASEIDENTIFIERLOOSE] +
		                       '(?:\\.' + src[t.PRERELEASEIDENTIFIERLOOSE] + ')*))';

		// ## Build Metadata Identifier
		// Any combination of digits, letters, or hyphens.

		tok('BUILDIDENTIFIER');
		src[t.BUILDIDENTIFIER] = LETTERDASHNUMBER + '+';

		// ## Build Metadata
		// Plus sign, followed by one or more period-separated build metadata
		// identifiers.

		tok('BUILD');
		src[t.BUILD] = '(?:\\+(' + src[t.BUILDIDENTIFIER] +
		             '(?:\\.' + src[t.BUILDIDENTIFIER] + ')*))';

		// ## Full Version String
		// A main version, followed optionally by a pre-release version and
		// build metadata.

		// Note that the only major, minor, patch, and pre-release sections of
		// the version string are capturing groups.  The build metadata is not a
		// capturing group, because it should not ever be used in version
		// comparison.

		tok('FULL');
		tok('FULLPLAIN');
		src[t.FULLPLAIN] = 'v?' + src[t.MAINVERSION] +
		                  src[t.PRERELEASE] + '?' +
		                  src[t.BUILD] + '?';

		src[t.FULL] = '^' + src[t.FULLPLAIN] + '$';

		// like full, but allows v1.2.3 and =1.2.3, which people do sometimes.
		// also, 1.0.0alpha1 (prerelease without the hyphen) which is pretty
		// common in the npm registry.
		tok('LOOSEPLAIN');
		src[t.LOOSEPLAIN] = '[v=\\s]*' + src[t.MAINVERSIONLOOSE] +
		                  src[t.PRERELEASELOOSE] + '?' +
		                  src[t.BUILD] + '?';

		tok('LOOSE');
		src[t.LOOSE] = '^' + src[t.LOOSEPLAIN] + '$';

		tok('GTLT');
		src[t.GTLT] = '((?:<|>)?=?)';

		// Something like "2.*" or "1.2.x".
		// Note that "x.x" is a valid xRange identifer, meaning "any version"
		// Only the first item is strictly required.
		tok('XRANGEIDENTIFIERLOOSE');
		src[t.XRANGEIDENTIFIERLOOSE] = src[t.NUMERICIDENTIFIERLOOSE] + '|x|X|\\*';
		tok('XRANGEIDENTIFIER');
		src[t.XRANGEIDENTIFIER] = src[t.NUMERICIDENTIFIER] + '|x|X|\\*';

		tok('XRANGEPLAIN');
		src[t.XRANGEPLAIN] = '[v=\\s]*(' + src[t.XRANGEIDENTIFIER] + ')' +
		                   '(?:\\.(' + src[t.XRANGEIDENTIFIER] + ')' +
		                   '(?:\\.(' + src[t.XRANGEIDENTIFIER] + ')' +
		                   '(?:' + src[t.PRERELEASE] + ')?' +
		                   src[t.BUILD] + '?' +
		                   ')?)?';

		tok('XRANGEPLAINLOOSE');
		src[t.XRANGEPLAINLOOSE] = '[v=\\s]*(' + src[t.XRANGEIDENTIFIERLOOSE] + ')' +
		                        '(?:\\.(' + src[t.XRANGEIDENTIFIERLOOSE] + ')' +
		                        '(?:\\.(' + src[t.XRANGEIDENTIFIERLOOSE] + ')' +
		                        '(?:' + src[t.PRERELEASELOOSE] + ')?' +
		                        src[t.BUILD] + '?' +
		                        ')?)?';

		tok('XRANGE');
		src[t.XRANGE] = '^' + src[t.GTLT] + '\\s*' + src[t.XRANGEPLAIN] + '$';
		tok('XRANGELOOSE');
		src[t.XRANGELOOSE] = '^' + src[t.GTLT] + '\\s*' + src[t.XRANGEPLAINLOOSE] + '$';

		// Coercion.
		// Extract anything that could conceivably be a part of a valid semver
		tok('COERCE');
		src[t.COERCE] = '(^|[^\\d])' +
		              '(\\d{1,' + MAX_SAFE_COMPONENT_LENGTH + '})' +
		              '(?:\\.(\\d{1,' + MAX_SAFE_COMPONENT_LENGTH + '}))?' +
		              '(?:\\.(\\d{1,' + MAX_SAFE_COMPONENT_LENGTH + '}))?' +
		              '(?:$|[^\\d])';
		tok('COERCERTL');
		re[t.COERCERTL] = new RegExp(src[t.COERCE], 'g');
		safeRe[t.COERCERTL] = new RegExp(makeSafeRe(src[t.COERCE]), 'g');

		// Tilde ranges.
		// Meaning is "reasonably at or greater than"
		tok('LONETILDE');
		src[t.LONETILDE] = '(?:~>?)';

		tok('TILDETRIM');
		src[t.TILDETRIM] = '(\\s*)' + src[t.LONETILDE] + '\\s+';
		re[t.TILDETRIM] = new RegExp(src[t.TILDETRIM], 'g');
		safeRe[t.TILDETRIM] = new RegExp(makeSafeRe(src[t.TILDETRIM]), 'g');
		var tildeTrimReplace = '$1~';

		tok('TILDE');
		src[t.TILDE] = '^' + src[t.LONETILDE] + src[t.XRANGEPLAIN] + '$';
		tok('TILDELOOSE');
		src[t.TILDELOOSE] = '^' + src[t.LONETILDE] + src[t.XRANGEPLAINLOOSE] + '$';

		// Caret ranges.
		// Meaning is "at least and backwards compatible with"
		tok('LONECARET');
		src[t.LONECARET] = '(?:\\^)';

		tok('CARETTRIM');
		src[t.CARETTRIM] = '(\\s*)' + src[t.LONECARET] + '\\s+';
		re[t.CARETTRIM] = new RegExp(src[t.CARETTRIM], 'g');
		safeRe[t.CARETTRIM] = new RegExp(makeSafeRe(src[t.CARETTRIM]), 'g');
		var caretTrimReplace = '$1^';

		tok('CARET');
		src[t.CARET] = '^' + src[t.LONECARET] + src[t.XRANGEPLAIN] + '$';
		tok('CARETLOOSE');
		src[t.CARETLOOSE] = '^' + src[t.LONECARET] + src[t.XRANGEPLAINLOOSE] + '$';

		// A simple gt/lt/eq thing, or just "" to indicate "any version"
		tok('COMPARATORLOOSE');
		src[t.COMPARATORLOOSE] = '^' + src[t.GTLT] + '\\s*(' + src[t.LOOSEPLAIN] + ')$|^$';
		tok('COMPARATOR');
		src[t.COMPARATOR] = '^' + src[t.GTLT] + '\\s*(' + src[t.FULLPLAIN] + ')$|^$';

		// An expression to strip any whitespace between the gtlt and the thing
		// it modifies, so that `> 1.2.3` ==> `>1.2.3`
		tok('COMPARATORTRIM');
		src[t.COMPARATORTRIM] = '(\\s*)' + src[t.GTLT] +
		                      '\\s*(' + src[t.LOOSEPLAIN] + '|' + src[t.XRANGEPLAIN] + ')';

		// this one has to use the /g flag
		re[t.COMPARATORTRIM] = new RegExp(src[t.COMPARATORTRIM], 'g');
		safeRe[t.COMPARATORTRIM] = new RegExp(makeSafeRe(src[t.COMPARATORTRIM]), 'g');
		var comparatorTrimReplace = '$1$2$3';

		// Something like `1.2.3 - 1.2.4`
		// Note that these all use the loose form, because they'll be
		// checked against either the strict or loose comparator form
		// later.
		tok('HYPHENRANGE');
		src[t.HYPHENRANGE] = '^\\s*(' + src[t.XRANGEPLAIN] + ')' +
		                   '\\s+-\\s+' +
		                   '(' + src[t.XRANGEPLAIN] + ')' +
		                   '\\s*$';

		tok('HYPHENRANGELOOSE');
		src[t.HYPHENRANGELOOSE] = '^\\s*(' + src[t.XRANGEPLAINLOOSE] + ')' +
		                        '\\s+-\\s+' +
		                        '(' + src[t.XRANGEPLAINLOOSE] + ')' +
		                        '\\s*$';

		// Star ranges basically just allow anything at all.
		tok('STAR');
		src[t.STAR] = '(<|>)?=?\\s*\\*';

		// Compile to actual regexp objects.
		// All are flag-free, unless they were created above with a flag.
		for (var i = 0; i < R; i++) {
		  debug(i, src[i]);
		  if (!re[i]) {
		    re[i] = new RegExp(src[i]);

		    // Replace all greedy whitespace to prevent regex dos issues. These regex are
		    // used internally via the safeRe object since all inputs in this library get
		    // normalized first to trim and collapse all extra whitespace. The original
		    // regexes are exported for userland consumption and lower level usage. A
		    // future breaking change could export the safer regex only with a note that
		    // all input should have extra whitespace removed.
		    safeRe[i] = new RegExp(makeSafeRe(src[i]));
		  }
		}

		exports.parse = parse;
		function parse (version, options) {
		  if (!options || typeof options !== 'object') {
		    options = {
		      loose: !!options,
		      includePrerelease: false
		    };
		  }

		  if (version instanceof SemVer) {
		    return version
		  }

		  if (typeof version !== 'string') {
		    return null
		  }

		  if (version.length > MAX_LENGTH) {
		    return null
		  }

		  var r = options.loose ? safeRe[t.LOOSE] : safeRe[t.FULL];
		  if (!r.test(version)) {
		    return null
		  }

		  try {
		    return new SemVer(version, options)
		  } catch (er) {
		    return null
		  }
		}

		exports.valid = valid;
		function valid (version, options) {
		  var v = parse(version, options);
		  return v ? v.version : null
		}

		exports.clean = clean;
		function clean (version, options) {
		  var s = parse(version.trim().replace(/^[=v]+/, ''), options);
		  return s ? s.version : null
		}

		exports.SemVer = SemVer;

		function SemVer (version, options) {
		  if (!options || typeof options !== 'object') {
		    options = {
		      loose: !!options,
		      includePrerelease: false
		    };
		  }
		  if (version instanceof SemVer) {
		    if (version.loose === options.loose) {
		      return version
		    } else {
		      version = version.version;
		    }
		  } else if (typeof version !== 'string') {
		    throw new TypeError('Invalid Version: ' + version)
		  }

		  if (version.length > MAX_LENGTH) {
		    throw new TypeError('version is longer than ' + MAX_LENGTH + ' characters')
		  }

		  if (!(this instanceof SemVer)) {
		    return new SemVer(version, options)
		  }

		  debug('SemVer', version, options);
		  this.options = options;
		  this.loose = !!options.loose;

		  var m = version.trim().match(options.loose ? safeRe[t.LOOSE] : safeRe[t.FULL]);

		  if (!m) {
		    throw new TypeError('Invalid Version: ' + version)
		  }

		  this.raw = version;

		  // these are actually numbers
		  this.major = +m[1];
		  this.minor = +m[2];
		  this.patch = +m[3];

		  if (this.major > MAX_SAFE_INTEGER || this.major < 0) {
		    throw new TypeError('Invalid major version')
		  }

		  if (this.minor > MAX_SAFE_INTEGER || this.minor < 0) {
		    throw new TypeError('Invalid minor version')
		  }

		  if (this.patch > MAX_SAFE_INTEGER || this.patch < 0) {
		    throw new TypeError('Invalid patch version')
		  }

		  // numberify any prerelease numeric ids
		  if (!m[4]) {
		    this.prerelease = [];
		  } else {
		    this.prerelease = m[4].split('.').map(function (id) {
		      if (/^[0-9]+$/.test(id)) {
		        var num = +id;
		        if (num >= 0 && num < MAX_SAFE_INTEGER) {
		          return num
		        }
		      }
		      return id
		    });
		  }

		  this.build = m[5] ? m[5].split('.') : [];
		  this.format();
		}

		SemVer.prototype.format = function () {
		  this.version = this.major + '.' + this.minor + '.' + this.patch;
		  if (this.prerelease.length) {
		    this.version += '-' + this.prerelease.join('.');
		  }
		  return this.version
		};

		SemVer.prototype.toString = function () {
		  return this.version
		};

		SemVer.prototype.compare = function (other) {
		  debug('SemVer.compare', this.version, this.options, other);
		  if (!(other instanceof SemVer)) {
		    other = new SemVer(other, this.options);
		  }

		  return this.compareMain(other) || this.comparePre(other)
		};

		SemVer.prototype.compareMain = function (other) {
		  if (!(other instanceof SemVer)) {
		    other = new SemVer(other, this.options);
		  }

		  return compareIdentifiers(this.major, other.major) ||
		         compareIdentifiers(this.minor, other.minor) ||
		         compareIdentifiers(this.patch, other.patch)
		};

		SemVer.prototype.comparePre = function (other) {
		  if (!(other instanceof SemVer)) {
		    other = new SemVer(other, this.options);
		  }

		  // NOT having a prerelease is > having one
		  if (this.prerelease.length && !other.prerelease.length) {
		    return -1
		  } else if (!this.prerelease.length && other.prerelease.length) {
		    return 1
		  } else if (!this.prerelease.length && !other.prerelease.length) {
		    return 0
		  }

		  var i = 0;
		  do {
		    var a = this.prerelease[i];
		    var b = other.prerelease[i];
		    debug('prerelease compare', i, a, b);
		    if (a === undefined && b === undefined) {
		      return 0
		    } else if (b === undefined) {
		      return 1
		    } else if (a === undefined) {
		      return -1
		    } else if (a === b) {
		      continue
		    } else {
		      return compareIdentifiers(a, b)
		    }
		  } while (++i)
		};

		SemVer.prototype.compareBuild = function (other) {
		  if (!(other instanceof SemVer)) {
		    other = new SemVer(other, this.options);
		  }

		  var i = 0;
		  do {
		    var a = this.build[i];
		    var b = other.build[i];
		    debug('prerelease compare', i, a, b);
		    if (a === undefined && b === undefined) {
		      return 0
		    } else if (b === undefined) {
		      return 1
		    } else if (a === undefined) {
		      return -1
		    } else if (a === b) {
		      continue
		    } else {
		      return compareIdentifiers(a, b)
		    }
		  } while (++i)
		};

		// preminor will bump the version up to the next minor release, and immediately
		// down to pre-release. premajor and prepatch work the same way.
		SemVer.prototype.inc = function (release, identifier) {
		  switch (release) {
		    case 'premajor':
		      this.prerelease.length = 0;
		      this.patch = 0;
		      this.minor = 0;
		      this.major++;
		      this.inc('pre', identifier);
		      break
		    case 'preminor':
		      this.prerelease.length = 0;
		      this.patch = 0;
		      this.minor++;
		      this.inc('pre', identifier);
		      break
		    case 'prepatch':
		      // If this is already a prerelease, it will bump to the next version
		      // drop any prereleases that might already exist, since they are not
		      // relevant at this point.
		      this.prerelease.length = 0;
		      this.inc('patch', identifier);
		      this.inc('pre', identifier);
		      break
		    // If the input is a non-prerelease version, this acts the same as
		    // prepatch.
		    case 'prerelease':
		      if (this.prerelease.length === 0) {
		        this.inc('patch', identifier);
		      }
		      this.inc('pre', identifier);
		      break

		    case 'major':
		      // If this is a pre-major version, bump up to the same major version.
		      // Otherwise increment major.
		      // 1.0.0-5 bumps to 1.0.0
		      // 1.1.0 bumps to 2.0.0
		      if (this.minor !== 0 ||
		          this.patch !== 0 ||
		          this.prerelease.length === 0) {
		        this.major++;
		      }
		      this.minor = 0;
		      this.patch = 0;
		      this.prerelease = [];
		      break
		    case 'minor':
		      // If this is a pre-minor version, bump up to the same minor version.
		      // Otherwise increment minor.
		      // 1.2.0-5 bumps to 1.2.0
		      // 1.2.1 bumps to 1.3.0
		      if (this.patch !== 0 || this.prerelease.length === 0) {
		        this.minor++;
		      }
		      this.patch = 0;
		      this.prerelease = [];
		      break
		    case 'patch':
		      // If this is not a pre-release version, it will increment the patch.
		      // If it is a pre-release it will bump up to the same patch version.
		      // 1.2.0-5 patches to 1.2.0
		      // 1.2.0 patches to 1.2.1
		      if (this.prerelease.length === 0) {
		        this.patch++;
		      }
		      this.prerelease = [];
		      break
		    // This probably shouldn't be used publicly.
		    // 1.0.0 "pre" would become 1.0.0-0 which is the wrong direction.
		    case 'pre':
		      if (this.prerelease.length === 0) {
		        this.prerelease = [0];
		      } else {
		        var i = this.prerelease.length;
		        while (--i >= 0) {
		          if (typeof this.prerelease[i] === 'number') {
		            this.prerelease[i]++;
		            i = -2;
		          }
		        }
		        if (i === -1) {
		          // didn't increment anything
		          this.prerelease.push(0);
		        }
		      }
		      if (identifier) {
		        // 1.2.0-beta.1 bumps to 1.2.0-beta.2,
		        // 1.2.0-beta.fooblz or 1.2.0-beta bumps to 1.2.0-beta.0
		        if (this.prerelease[0] === identifier) {
		          if (isNaN(this.prerelease[1])) {
		            this.prerelease = [identifier, 0];
		          }
		        } else {
		          this.prerelease = [identifier, 0];
		        }
		      }
		      break

		    default:
		      throw new Error('invalid increment argument: ' + release)
		  }
		  this.format();
		  this.raw = this.version;
		  return this
		};

		exports.inc = inc;
		function inc (version, release, loose, identifier) {
		  if (typeof (loose) === 'string') {
		    identifier = loose;
		    loose = undefined;
		  }

		  try {
		    return new SemVer(version, loose).inc(release, identifier).version
		  } catch (er) {
		    return null
		  }
		}

		exports.diff = diff;
		function diff (version1, version2) {
		  if (eq(version1, version2)) {
		    return null
		  } else {
		    var v1 = parse(version1);
		    var v2 = parse(version2);
		    var prefix = '';
		    if (v1.prerelease.length || v2.prerelease.length) {
		      prefix = 'pre';
		      var defaultResult = 'prerelease';
		    }
		    for (var key in v1) {
		      if (key === 'major' || key === 'minor' || key === 'patch') {
		        if (v1[key] !== v2[key]) {
		          return prefix + key
		        }
		      }
		    }
		    return defaultResult // may be undefined
		  }
		}

		exports.compareIdentifiers = compareIdentifiers;

		var numeric = /^[0-9]+$/;
		function compareIdentifiers (a, b) {
		  var anum = numeric.test(a);
		  var bnum = numeric.test(b);

		  if (anum && bnum) {
		    a = +a;
		    b = +b;
		  }

		  return a === b ? 0
		    : (anum && !bnum) ? -1
		    : (bnum && !anum) ? 1
		    : a < b ? -1
		    : 1
		}

		exports.rcompareIdentifiers = rcompareIdentifiers;
		function rcompareIdentifiers (a, b) {
		  return compareIdentifiers(b, a)
		}

		exports.major = major;
		function major (a, loose) {
		  return new SemVer(a, loose).major
		}

		exports.minor = minor;
		function minor (a, loose) {
		  return new SemVer(a, loose).minor
		}

		exports.patch = patch;
		function patch (a, loose) {
		  return new SemVer(a, loose).patch
		}

		exports.compare = compare;
		function compare (a, b, loose) {
		  return new SemVer(a, loose).compare(new SemVer(b, loose))
		}

		exports.compareLoose = compareLoose;
		function compareLoose (a, b) {
		  return compare(a, b, true)
		}

		exports.compareBuild = compareBuild;
		function compareBuild (a, b, loose) {
		  var versionA = new SemVer(a, loose);
		  var versionB = new SemVer(b, loose);
		  return versionA.compare(versionB) || versionA.compareBuild(versionB)
		}

		exports.rcompare = rcompare;
		function rcompare (a, b, loose) {
		  return compare(b, a, loose)
		}

		exports.sort = sort;
		function sort (list, loose) {
		  return list.sort(function (a, b) {
		    return exports.compareBuild(a, b, loose)
		  })
		}

		exports.rsort = rsort;
		function rsort (list, loose) {
		  return list.sort(function (a, b) {
		    return exports.compareBuild(b, a, loose)
		  })
		}

		exports.gt = gt;
		function gt (a, b, loose) {
		  return compare(a, b, loose) > 0
		}

		exports.lt = lt;
		function lt (a, b, loose) {
		  return compare(a, b, loose) < 0
		}

		exports.eq = eq;
		function eq (a, b, loose) {
		  return compare(a, b, loose) === 0
		}

		exports.neq = neq;
		function neq (a, b, loose) {
		  return compare(a, b, loose) !== 0
		}

		exports.gte = gte;
		function gte (a, b, loose) {
		  return compare(a, b, loose) >= 0
		}

		exports.lte = lte;
		function lte (a, b, loose) {
		  return compare(a, b, loose) <= 0
		}

		exports.cmp = cmp;
		function cmp (a, op, b, loose) {
		  switch (op) {
		    case '===':
		      if (typeof a === 'object')
		        a = a.version;
		      if (typeof b === 'object')
		        b = b.version;
		      return a === b

		    case '!==':
		      if (typeof a === 'object')
		        a = a.version;
		      if (typeof b === 'object')
		        b = b.version;
		      return a !== b

		    case '':
		    case '=':
		    case '==':
		      return eq(a, b, loose)

		    case '!=':
		      return neq(a, b, loose)

		    case '>':
		      return gt(a, b, loose)

		    case '>=':
		      return gte(a, b, loose)

		    case '<':
		      return lt(a, b, loose)

		    case '<=':
		      return lte(a, b, loose)

		    default:
		      throw new TypeError('Invalid operator: ' + op)
		  }
		}

		exports.Comparator = Comparator;
		function Comparator (comp, options) {
		  if (!options || typeof options !== 'object') {
		    options = {
		      loose: !!options,
		      includePrerelease: false
		    };
		  }

		  if (comp instanceof Comparator) {
		    if (comp.loose === !!options.loose) {
		      return comp
		    } else {
		      comp = comp.value;
		    }
		  }

		  if (!(this instanceof Comparator)) {
		    return new Comparator(comp, options)
		  }

		  comp = comp.trim().split(/\s+/).join(' ');
		  debug('comparator', comp, options);
		  this.options = options;
		  this.loose = !!options.loose;
		  this.parse(comp);

		  if (this.semver === ANY) {
		    this.value = '';
		  } else {
		    this.value = this.operator + this.semver.version;
		  }

		  debug('comp', this);
		}

		var ANY = {};
		Comparator.prototype.parse = function (comp) {
		  var r = this.options.loose ? safeRe[t.COMPARATORLOOSE] : safeRe[t.COMPARATOR];
		  var m = comp.match(r);

		  if (!m) {
		    throw new TypeError('Invalid comparator: ' + comp)
		  }

		  this.operator = m[1] !== undefined ? m[1] : '';
		  if (this.operator === '=') {
		    this.operator = '';
		  }

		  // if it literally is just '>' or '' then allow anything.
		  if (!m[2]) {
		    this.semver = ANY;
		  } else {
		    this.semver = new SemVer(m[2], this.options.loose);
		  }
		};

		Comparator.prototype.toString = function () {
		  return this.value
		};

		Comparator.prototype.test = function (version) {
		  debug('Comparator.test', version, this.options.loose);

		  if (this.semver === ANY || version === ANY) {
		    return true
		  }

		  if (typeof version === 'string') {
		    try {
		      version = new SemVer(version, this.options);
		    } catch (er) {
		      return false
		    }
		  }

		  return cmp(version, this.operator, this.semver, this.options)
		};

		Comparator.prototype.intersects = function (comp, options) {
		  if (!(comp instanceof Comparator)) {
		    throw new TypeError('a Comparator is required')
		  }

		  if (!options || typeof options !== 'object') {
		    options = {
		      loose: !!options,
		      includePrerelease: false
		    };
		  }

		  var rangeTmp;

		  if (this.operator === '') {
		    if (this.value === '') {
		      return true
		    }
		    rangeTmp = new Range(comp.value, options);
		    return satisfies(this.value, rangeTmp, options)
		  } else if (comp.operator === '') {
		    if (comp.value === '') {
		      return true
		    }
		    rangeTmp = new Range(this.value, options);
		    return satisfies(comp.semver, rangeTmp, options)
		  }

		  var sameDirectionIncreasing =
		    (this.operator === '>=' || this.operator === '>') &&
		    (comp.operator === '>=' || comp.operator === '>');
		  var sameDirectionDecreasing =
		    (this.operator === '<=' || this.operator === '<') &&
		    (comp.operator === '<=' || comp.operator === '<');
		  var sameSemVer = this.semver.version === comp.semver.version;
		  var differentDirectionsInclusive =
		    (this.operator === '>=' || this.operator === '<=') &&
		    (comp.operator === '>=' || comp.operator === '<=');
		  var oppositeDirectionsLessThan =
		    cmp(this.semver, '<', comp.semver, options) &&
		    ((this.operator === '>=' || this.operator === '>') &&
		    (comp.operator === '<=' || comp.operator === '<'));
		  var oppositeDirectionsGreaterThan =
		    cmp(this.semver, '>', comp.semver, options) &&
		    ((this.operator === '<=' || this.operator === '<') &&
		    (comp.operator === '>=' || comp.operator === '>'));

		  return sameDirectionIncreasing || sameDirectionDecreasing ||
		    (sameSemVer && differentDirectionsInclusive) ||
		    oppositeDirectionsLessThan || oppositeDirectionsGreaterThan
		};

		exports.Range = Range;
		function Range (range, options) {
		  if (!options || typeof options !== 'object') {
		    options = {
		      loose: !!options,
		      includePrerelease: false
		    };
		  }

		  if (range instanceof Range) {
		    if (range.loose === !!options.loose &&
		        range.includePrerelease === !!options.includePrerelease) {
		      return range
		    } else {
		      return new Range(range.raw, options)
		    }
		  }

		  if (range instanceof Comparator) {
		    return new Range(range.value, options)
		  }

		  if (!(this instanceof Range)) {
		    return new Range(range, options)
		  }

		  this.options = options;
		  this.loose = !!options.loose;
		  this.includePrerelease = !!options.includePrerelease;

		  // First reduce all whitespace as much as possible so we do not have to rely
		  // on potentially slow regexes like \s*. This is then stored and used for
		  // future error messages as well.
		  this.raw = range
		    .trim()
		    .split(/\s+/)
		    .join(' ');

		  // First, split based on boolean or ||
		  this.set = this.raw.split('||').map(function (range) {
		    return this.parseRange(range.trim())
		  }, this).filter(function (c) {
		    // throw out any that are not relevant for whatever reason
		    return c.length
		  });

		  if (!this.set.length) {
		    throw new TypeError('Invalid SemVer Range: ' + this.raw)
		  }

		  this.format();
		}

		Range.prototype.format = function () {
		  this.range = this.set.map(function (comps) {
		    return comps.join(' ').trim()
		  }).join('||').trim();
		  return this.range
		};

		Range.prototype.toString = function () {
		  return this.range
		};

		Range.prototype.parseRange = function (range) {
		  var loose = this.options.loose;
		  // `1.2.3 - 1.2.4` => `>=1.2.3 <=1.2.4`
		  var hr = loose ? safeRe[t.HYPHENRANGELOOSE] : safeRe[t.HYPHENRANGE];
		  range = range.replace(hr, hyphenReplace);
		  debug('hyphen replace', range);
		  // `> 1.2.3 < 1.2.5` => `>1.2.3 <1.2.5`
		  range = range.replace(safeRe[t.COMPARATORTRIM], comparatorTrimReplace);
		  debug('comparator trim', range, safeRe[t.COMPARATORTRIM]);

		  // `~ 1.2.3` => `~1.2.3`
		  range = range.replace(safeRe[t.TILDETRIM], tildeTrimReplace);

		  // `^ 1.2.3` => `^1.2.3`
		  range = range.replace(safeRe[t.CARETTRIM], caretTrimReplace);

		  // normalize spaces
		  range = range.split(/\s+/).join(' ');

		  // At this point, the range is completely trimmed and
		  // ready to be split into comparators.

		  var compRe = loose ? safeRe[t.COMPARATORLOOSE] : safeRe[t.COMPARATOR];
		  var set = range.split(' ').map(function (comp) {
		    return parseComparator(comp, this.options)
		  }, this).join(' ').split(/\s+/);
		  if (this.options.loose) {
		    // in loose mode, throw out any that are not valid comparators
		    set = set.filter(function (comp) {
		      return !!comp.match(compRe)
		    });
		  }
		  set = set.map(function (comp) {
		    return new Comparator(comp, this.options)
		  }, this);

		  return set
		};

		Range.prototype.intersects = function (range, options) {
		  if (!(range instanceof Range)) {
		    throw new TypeError('a Range is required')
		  }

		  return this.set.some(function (thisComparators) {
		    return (
		      isSatisfiable(thisComparators, options) &&
		      range.set.some(function (rangeComparators) {
		        return (
		          isSatisfiable(rangeComparators, options) &&
		          thisComparators.every(function (thisComparator) {
		            return rangeComparators.every(function (rangeComparator) {
		              return thisComparator.intersects(rangeComparator, options)
		            })
		          })
		        )
		      })
		    )
		  })
		};

		// take a set of comparators and determine whether there
		// exists a version which can satisfy it
		function isSatisfiable (comparators, options) {
		  var result = true;
		  var remainingComparators = comparators.slice();
		  var testComparator = remainingComparators.pop();

		  while (result && remainingComparators.length) {
		    result = remainingComparators.every(function (otherComparator) {
		      return testComparator.intersects(otherComparator, options)
		    });

		    testComparator = remainingComparators.pop();
		  }

		  return result
		}

		// Mostly just for testing and legacy API reasons
		exports.toComparators = toComparators;
		function toComparators (range, options) {
		  return new Range(range, options).set.map(function (comp) {
		    return comp.map(function (c) {
		      return c.value
		    }).join(' ').trim().split(' ')
		  })
		}

		// comprised of xranges, tildes, stars, and gtlt's at this point.
		// already replaced the hyphen ranges
		// turn into a set of JUST comparators.
		function parseComparator (comp, options) {
		  debug('comp', comp, options);
		  comp = replaceCarets(comp, options);
		  debug('caret', comp);
		  comp = replaceTildes(comp, options);
		  debug('tildes', comp);
		  comp = replaceXRanges(comp, options);
		  debug('xrange', comp);
		  comp = replaceStars(comp, options);
		  debug('stars', comp);
		  return comp
		}

		function isX (id) {
		  return !id || id.toLowerCase() === 'x' || id === '*'
		}

		// ~, ~> --> * (any, kinda silly)
		// ~2, ~2.x, ~2.x.x, ~>2, ~>2.x ~>2.x.x --> >=2.0.0 <3.0.0
		// ~2.0, ~2.0.x, ~>2.0, ~>2.0.x --> >=2.0.0 <2.1.0
		// ~1.2, ~1.2.x, ~>1.2, ~>1.2.x --> >=1.2.0 <1.3.0
		// ~1.2.3, ~>1.2.3 --> >=1.2.3 <1.3.0
		// ~1.2.0, ~>1.2.0 --> >=1.2.0 <1.3.0
		function replaceTildes (comp, options) {
		  return comp.trim().split(/\s+/).map(function (comp) {
		    return replaceTilde(comp, options)
		  }).join(' ')
		}

		function replaceTilde (comp, options) {
		  var r = options.loose ? safeRe[t.TILDELOOSE] : safeRe[t.TILDE];
		  return comp.replace(r, function (_, M, m, p, pr) {
		    debug('tilde', comp, _, M, m, p, pr);
		    var ret;

		    if (isX(M)) {
		      ret = '';
		    } else if (isX(m)) {
		      ret = '>=' + M + '.0.0 <' + (+M + 1) + '.0.0';
		    } else if (isX(p)) {
		      // ~1.2 == >=1.2.0 <1.3.0
		      ret = '>=' + M + '.' + m + '.0 <' + M + '.' + (+m + 1) + '.0';
		    } else if (pr) {
		      debug('replaceTilde pr', pr);
		      ret = '>=' + M + '.' + m + '.' + p + '-' + pr +
		            ' <' + M + '.' + (+m + 1) + '.0';
		    } else {
		      // ~1.2.3 == >=1.2.3 <1.3.0
		      ret = '>=' + M + '.' + m + '.' + p +
		            ' <' + M + '.' + (+m + 1) + '.0';
		    }

		    debug('tilde return', ret);
		    return ret
		  })
		}

		// ^ --> * (any, kinda silly)
		// ^2, ^2.x, ^2.x.x --> >=2.0.0 <3.0.0
		// ^2.0, ^2.0.x --> >=2.0.0 <3.0.0
		// ^1.2, ^1.2.x --> >=1.2.0 <2.0.0
		// ^1.2.3 --> >=1.2.3 <2.0.0
		// ^1.2.0 --> >=1.2.0 <2.0.0
		function replaceCarets (comp, options) {
		  return comp.trim().split(/\s+/).map(function (comp) {
		    return replaceCaret(comp, options)
		  }).join(' ')
		}

		function replaceCaret (comp, options) {
		  debug('caret', comp, options);
		  var r = options.loose ? safeRe[t.CARETLOOSE] : safeRe[t.CARET];
		  return comp.replace(r, function (_, M, m, p, pr) {
		    debug('caret', comp, _, M, m, p, pr);
		    var ret;

		    if (isX(M)) {
		      ret = '';
		    } else if (isX(m)) {
		      ret = '>=' + M + '.0.0 <' + (+M + 1) + '.0.0';
		    } else if (isX(p)) {
		      if (M === '0') {
		        ret = '>=' + M + '.' + m + '.0 <' + M + '.' + (+m + 1) + '.0';
		      } else {
		        ret = '>=' + M + '.' + m + '.0 <' + (+M + 1) + '.0.0';
		      }
		    } else if (pr) {
		      debug('replaceCaret pr', pr);
		      if (M === '0') {
		        if (m === '0') {
		          ret = '>=' + M + '.' + m + '.' + p + '-' + pr +
		                ' <' + M + '.' + m + '.' + (+p + 1);
		        } else {
		          ret = '>=' + M + '.' + m + '.' + p + '-' + pr +
		                ' <' + M + '.' + (+m + 1) + '.0';
		        }
		      } else {
		        ret = '>=' + M + '.' + m + '.' + p + '-' + pr +
		              ' <' + (+M + 1) + '.0.0';
		      }
		    } else {
		      debug('no pr');
		      if (M === '0') {
		        if (m === '0') {
		          ret = '>=' + M + '.' + m + '.' + p +
		                ' <' + M + '.' + m + '.' + (+p + 1);
		        } else {
		          ret = '>=' + M + '.' + m + '.' + p +
		                ' <' + M + '.' + (+m + 1) + '.0';
		        }
		      } else {
		        ret = '>=' + M + '.' + m + '.' + p +
		              ' <' + (+M + 1) + '.0.0';
		      }
		    }

		    debug('caret return', ret);
		    return ret
		  })
		}

		function replaceXRanges (comp, options) {
		  debug('replaceXRanges', comp, options);
		  return comp.split(/\s+/).map(function (comp) {
		    return replaceXRange(comp, options)
		  }).join(' ')
		}

		function replaceXRange (comp, options) {
		  comp = comp.trim();
		  var r = options.loose ? safeRe[t.XRANGELOOSE] : safeRe[t.XRANGE];
		  return comp.replace(r, function (ret, gtlt, M, m, p, pr) {
		    debug('xRange', comp, ret, gtlt, M, m, p, pr);
		    var xM = isX(M);
		    var xm = xM || isX(m);
		    var xp = xm || isX(p);
		    var anyX = xp;

		    if (gtlt === '=' && anyX) {
		      gtlt = '';
		    }

		    // if we're including prereleases in the match, then we need
		    // to fix this to -0, the lowest possible prerelease value
		    pr = options.includePrerelease ? '-0' : '';

		    if (xM) {
		      if (gtlt === '>' || gtlt === '<') {
		        // nothing is allowed
		        ret = '<0.0.0-0';
		      } else {
		        // nothing is forbidden
		        ret = '*';
		      }
		    } else if (gtlt && anyX) {
		      // we know patch is an x, because we have any x at all.
		      // replace X with 0
		      if (xm) {
		        m = 0;
		      }
		      p = 0;

		      if (gtlt === '>') {
		        // >1 => >=2.0.0
		        // >1.2 => >=1.3.0
		        // >1.2.3 => >= 1.2.4
		        gtlt = '>=';
		        if (xm) {
		          M = +M + 1;
		          m = 0;
		          p = 0;
		        } else {
		          m = +m + 1;
		          p = 0;
		        }
		      } else if (gtlt === '<=') {
		        // <=0.7.x is actually <0.8.0, since any 0.7.x should
		        // pass.  Similarly, <=7.x is actually <8.0.0, etc.
		        gtlt = '<';
		        if (xm) {
		          M = +M + 1;
		        } else {
		          m = +m + 1;
		        }
		      }

		      ret = gtlt + M + '.' + m + '.' + p + pr;
		    } else if (xm) {
		      ret = '>=' + M + '.0.0' + pr + ' <' + (+M + 1) + '.0.0' + pr;
		    } else if (xp) {
		      ret = '>=' + M + '.' + m + '.0' + pr +
		        ' <' + M + '.' + (+m + 1) + '.0' + pr;
		    }

		    debug('xRange return', ret);

		    return ret
		  })
		}

		// Because * is AND-ed with everything else in the comparator,
		// and '' means "any version", just remove the *s entirely.
		function replaceStars (comp, options) {
		  debug('replaceStars', comp, options);
		  // Looseness is ignored here.  star is always as loose as it gets!
		  return comp.trim().replace(safeRe[t.STAR], '')
		}

		// This function is passed to string.replace(re[t.HYPHENRANGE])
		// M, m, patch, prerelease, build
		// 1.2 - 3.4.5 => >=1.2.0 <=3.4.5
		// 1.2.3 - 3.4 => >=1.2.0 <3.5.0 Any 3.4.x will do
		// 1.2 - 3.4 => >=1.2.0 <3.5.0
		function hyphenReplace ($0,
		  from, fM, fm, fp, fpr, fb,
		  to, tM, tm, tp, tpr, tb) {
		  if (isX(fM)) {
		    from = '';
		  } else if (isX(fm)) {
		    from = '>=' + fM + '.0.0';
		  } else if (isX(fp)) {
		    from = '>=' + fM + '.' + fm + '.0';
		  } else {
		    from = '>=' + from;
		  }

		  if (isX(tM)) {
		    to = '';
		  } else if (isX(tm)) {
		    to = '<' + (+tM + 1) + '.0.0';
		  } else if (isX(tp)) {
		    to = '<' + tM + '.' + (+tm + 1) + '.0';
		  } else if (tpr) {
		    to = '<=' + tM + '.' + tm + '.' + tp + '-' + tpr;
		  } else {
		    to = '<=' + to;
		  }

		  return (from + ' ' + to).trim()
		}

		// if ANY of the sets match ALL of its comparators, then pass
		Range.prototype.test = function (version) {
		  if (!version) {
		    return false
		  }

		  if (typeof version === 'string') {
		    try {
		      version = new SemVer(version, this.options);
		    } catch (er) {
		      return false
		    }
		  }

		  for (var i = 0; i < this.set.length; i++) {
		    if (testSet(this.set[i], version, this.options)) {
		      return true
		    }
		  }
		  return false
		};

		function testSet (set, version, options) {
		  for (var i = 0; i < set.length; i++) {
		    if (!set[i].test(version)) {
		      return false
		    }
		  }

		  if (version.prerelease.length && !options.includePrerelease) {
		    // Find the set of versions that are allowed to have prereleases
		    // For example, ^1.2.3-pr.1 desugars to >=1.2.3-pr.1 <2.0.0
		    // That should allow `1.2.3-pr.2` to pass.
		    // However, `1.2.4-alpha.notready` should NOT be allowed,
		    // even though it's within the range set by the comparators.
		    for (i = 0; i < set.length; i++) {
		      debug(set[i].semver);
		      if (set[i].semver === ANY) {
		        continue
		      }

		      if (set[i].semver.prerelease.length > 0) {
		        var allowed = set[i].semver;
		        if (allowed.major === version.major &&
		            allowed.minor === version.minor &&
		            allowed.patch === version.patch) {
		          return true
		        }
		      }
		    }

		    // Version has a -pre, but it's not one of the ones we like.
		    return false
		  }

		  return true
		}

		exports.satisfies = satisfies;
		function satisfies (version, range, options) {
		  try {
		    range = new Range(range, options);
		  } catch (er) {
		    return false
		  }
		  return range.test(version)
		}

		exports.maxSatisfying = maxSatisfying;
		function maxSatisfying (versions, range, options) {
		  var max = null;
		  var maxSV = null;
		  try {
		    var rangeObj = new Range(range, options);
		  } catch (er) {
		    return null
		  }
		  versions.forEach(function (v) {
		    if (rangeObj.test(v)) {
		      // satisfies(v, range, options)
		      if (!max || maxSV.compare(v) === -1) {
		        // compare(max, v, true)
		        max = v;
		        maxSV = new SemVer(max, options);
		      }
		    }
		  });
		  return max
		}

		exports.minSatisfying = minSatisfying;
		function minSatisfying (versions, range, options) {
		  var min = null;
		  var minSV = null;
		  try {
		    var rangeObj = new Range(range, options);
		  } catch (er) {
		    return null
		  }
		  versions.forEach(function (v) {
		    if (rangeObj.test(v)) {
		      // satisfies(v, range, options)
		      if (!min || minSV.compare(v) === 1) {
		        // compare(min, v, true)
		        min = v;
		        minSV = new SemVer(min, options);
		      }
		    }
		  });
		  return min
		}

		exports.minVersion = minVersion;
		function minVersion (range, loose) {
		  range = new Range(range, loose);

		  var minver = new SemVer('0.0.0');
		  if (range.test(minver)) {
		    return minver
		  }

		  minver = new SemVer('0.0.0-0');
		  if (range.test(minver)) {
		    return minver
		  }

		  minver = null;
		  for (var i = 0; i < range.set.length; ++i) {
		    var comparators = range.set[i];

		    comparators.forEach(function (comparator) {
		      // Clone to avoid manipulating the comparator's semver object.
		      var compver = new SemVer(comparator.semver.version);
		      switch (comparator.operator) {
		        case '>':
		          if (compver.prerelease.length === 0) {
		            compver.patch++;
		          } else {
		            compver.prerelease.push(0);
		          }
		          compver.raw = compver.format();
		          /* fallthrough */
		        case '':
		        case '>=':
		          if (!minver || gt(minver, compver)) {
		            minver = compver;
		          }
		          break
		        case '<':
		        case '<=':
		          /* Ignore maximum versions */
		          break
		        /* istanbul ignore next */
		        default:
		          throw new Error('Unexpected operation: ' + comparator.operator)
		      }
		    });
		  }

		  if (minver && range.test(minver)) {
		    return minver
		  }

		  return null
		}

		exports.validRange = validRange;
		function validRange (range, options) {
		  try {
		    // Return '*' instead of '' so that truthiness works.
		    // This will throw if it's invalid anyway
		    return new Range(range, options).range || '*'
		  } catch (er) {
		    return null
		  }
		}

		// Determine if version is less than all the versions possible in the range
		exports.ltr = ltr;
		function ltr (version, range, options) {
		  return outside(version, range, '<', options)
		}

		// Determine if version is greater than all the versions possible in the range.
		exports.gtr = gtr;
		function gtr (version, range, options) {
		  return outside(version, range, '>', options)
		}

		exports.outside = outside;
		function outside (version, range, hilo, options) {
		  version = new SemVer(version, options);
		  range = new Range(range, options);

		  var gtfn, ltefn, ltfn, comp, ecomp;
		  switch (hilo) {
		    case '>':
		      gtfn = gt;
		      ltefn = lte;
		      ltfn = lt;
		      comp = '>';
		      ecomp = '>=';
		      break
		    case '<':
		      gtfn = lt;
		      ltefn = gte;
		      ltfn = gt;
		      comp = '<';
		      ecomp = '<=';
		      break
		    default:
		      throw new TypeError('Must provide a hilo val of "<" or ">"')
		  }

		  // If it satisifes the range it is not outside
		  if (satisfies(version, range, options)) {
		    return false
		  }

		  // From now on, variable terms are as if we're in "gtr" mode.
		  // but note that everything is flipped for the "ltr" function.

		  for (var i = 0; i < range.set.length; ++i) {
		    var comparators = range.set[i];

		    var high = null;
		    var low = null;

		    comparators.forEach(function (comparator) {
		      if (comparator.semver === ANY) {
		        comparator = new Comparator('>=0.0.0');
		      }
		      high = high || comparator;
		      low = low || comparator;
		      if (gtfn(comparator.semver, high.semver, options)) {
		        high = comparator;
		      } else if (ltfn(comparator.semver, low.semver, options)) {
		        low = comparator;
		      }
		    });

		    // If the edge version comparator has a operator then our version
		    // isn't outside it
		    if (high.operator === comp || high.operator === ecomp) {
		      return false
		    }

		    // If the lowest version comparator has an operator and our version
		    // is less than it then it isn't higher than the range
		    if ((!low.operator || low.operator === comp) &&
		        ltefn(version, low.semver)) {
		      return false
		    } else if (low.operator === ecomp && ltfn(version, low.semver)) {
		      return false
		    }
		  }
		  return true
		}

		exports.prerelease = prerelease;
		function prerelease (version, options) {
		  var parsed = parse(version, options);
		  return (parsed && parsed.prerelease.length) ? parsed.prerelease : null
		}

		exports.intersects = intersects;
		function intersects (r1, r2, options) {
		  r1 = new Range(r1, options);
		  r2 = new Range(r2, options);
		  return r1.intersects(r2)
		}

		exports.coerce = coerce;
		function coerce (version, options) {
		  if (version instanceof SemVer) {
		    return version
		  }

		  if (typeof version === 'number') {
		    version = String(version);
		  }

		  if (typeof version !== 'string') {
		    return null
		  }

		  options = options || {};

		  var match = null;
		  if (!options.rtl) {
		    match = version.match(safeRe[t.COERCE]);
		  } else {
		    // Find the right-most coercible string that does not share
		    // a terminus with a more left-ward coercible string.
		    // Eg, '1.2.3.4' wants to coerce '2.3.4', not '3.4' or '4'
		    //
		    // Walk through the string checking with a /g regexp
		    // Manually set the index so as to pick up overlapping matches.
		    // Stop when we get a match that ends at the string end, since no
		    // coercible string can be more right-ward without the same terminus.
		    var next;
		    while ((next = safeRe[t.COERCERTL].exec(version)) &&
		      (!match || match.index + match[0].length !== version.length)
		    ) {
		      if (!match ||
		          next.index + next[0].length !== match.index + match[0].length) {
		        match = next;
		      }
		      safeRe[t.COERCERTL].lastIndex = next.index + next[1].length + next[2].length;
		    }
		    // leave it in a clean state
		    safeRe[t.COERCERTL].lastIndex = -1;
		  }

		  if (match === null) {
		    return null
		  }

		  return parse(match[2] +
		    '.' + (match[3] || '0') +
		    '.' + (match[4] || '0'), options)
		} 
	} (semver, semver.exports));
	return semver.exports;
}

var targets = {};

var hasRequiredTargets;

function requireTargets () {
	if (hasRequiredTargets) return targets;
	hasRequiredTargets = 1;

	Object.defineProperty(targets, "__esModule", {
	  value: true
	});
	targets.unreleasedLabels = targets.browserNameMap = void 0;
	targets.unreleasedLabels = {
	  safari: "tp"
	};
	targets.browserNameMap = {
	  and_chr: "chrome",
	  and_ff: "firefox",
	  android: "android",
	  chrome: "chrome",
	  edge: "edge",
	  firefox: "firefox",
	  ie: "ie",
	  ie_mob: "ie",
	  ios_saf: "ios",
	  node: "node",
	  deno: "deno",
	  op_mob: "opera_mobile",
	  opera: "opera",
	  safari: "safari",
	  samsung: "samsung"
	};

	
	return targets;
}

var hasRequiredUtils;

function requireUtils () {
	if (hasRequiredUtils) return utils;
	hasRequiredUtils = 1;

	Object.defineProperty(utils, "__esModule", {
	  value: true
	});
	utils.getHighestUnreleased = getHighestUnreleased;
	utils.getLowestImplementedVersion = getLowestImplementedVersion;
	utils.getLowestUnreleased = getLowestUnreleased;
	utils.isUnreleasedVersion = isUnreleasedVersion;
	utils.semverMin = semverMin;
	utils.semverify = semverify;
	var _semver = requireSemver();
	var _helperValidatorOption = requireLib$2();
	var _targets = requireTargets();
	const versionRegExp = /^(\d+|\d+.\d+)$/;
	const v = new _helperValidatorOption.OptionValidator("@babel/helper-compilation-targets");
	function semverMin(first, second) {
	  return first && _semver.lt(first, second) ? first : second;
	}
	function semverify(version) {
	  if (typeof version === "string" && _semver.valid(version)) {
	    return version;
	  }
	  v.invariant(typeof version === "number" || typeof version === "string" && versionRegExp.test(version), `'${version}' is not a valid version`);
	  version = version.toString();
	  let pos = 0;
	  let num = 0;
	  while ((pos = version.indexOf(".", pos + 1)) > 0) {
	    num++;
	  }
	  return version + ".0".repeat(2 - num);
	}
	function isUnreleasedVersion(version, env) {
	  const unreleasedLabel = _targets.unreleasedLabels[env];
	  return !!unreleasedLabel && unreleasedLabel === version.toString().toLowerCase();
	}
	function getLowestUnreleased(a, b, env) {
	  const unreleasedLabel = _targets.unreleasedLabels[env];
	  if (a === unreleasedLabel) {
	    return b;
	  }
	  if (b === unreleasedLabel) {
	    return a;
	  }
	  return semverMin(a, b);
	}
	function getHighestUnreleased(a, b, env) {
	  return getLowestUnreleased(a, b, env) === a ? b : a;
	}
	function getLowestImplementedVersion(plugin, environment) {
	  const result = plugin[environment];
	  if (!result && environment === "android") {
	    return plugin.chrome;
	  }
	  return result;
	}

	
	return utils;
}

var options$1 = {};

var hasRequiredOptions$1;

function requireOptions$1 () {
	if (hasRequiredOptions$1) return options$1;
	hasRequiredOptions$1 = 1;

	Object.defineProperty(options$1, "__esModule", {
	  value: true
	});
	options$1.TargetNames = void 0;
	options$1.TargetNames = {
	  node: "node",
	  deno: "deno",
	  chrome: "chrome",
	  opera: "opera",
	  edge: "edge",
	  firefox: "firefox",
	  safari: "safari",
	  ie: "ie",
	  ios: "ios",
	  android: "android",
	  electron: "electron",
	  samsung: "samsung",
	  rhino: "rhino",
	  opera_mobile: "opera_mobile"
	};

	
	return options$1;
}

var pretty = {};

var hasRequiredPretty;

function requirePretty () {
	if (hasRequiredPretty) return pretty;
	hasRequiredPretty = 1;

	Object.defineProperty(pretty, "__esModule", {
	  value: true
	});
	pretty.prettifyTargets = prettifyTargets;
	pretty.prettifyVersion = prettifyVersion;
	var _semver = requireSemver();
	var _targets = requireTargets();
	function prettifyVersion(version) {
	  if (typeof version !== "string") {
	    return version;
	  }
	  const {
	    major,
	    minor,
	    patch
	  } = _semver.parse(version);
	  const parts = [major];
	  if (minor || patch) {
	    parts.push(minor);
	  }
	  if (patch) {
	    parts.push(patch);
	  }
	  return parts.join(".");
	}
	function prettifyTargets(targets) {
	  return Object.keys(targets).reduce((results, target) => {
	    let value = targets[target];
	    const unreleasedLabel = _targets.unreleasedLabels[target];
	    if (typeof value === "string" && unreleasedLabel !== value) {
	      value = prettifyVersion(value);
	    }
	    results[target] = value;
	    return results;
	  }, {});
	}

	
	return pretty;
}

var debug = {};

var hasRequiredDebug;

function requireDebug () {
	if (hasRequiredDebug) return debug;
	hasRequiredDebug = 1;

	Object.defineProperty(debug, "__esModule", {
	  value: true
	});
	debug.getInclusionReasons = getInclusionReasons;
	var _semver = requireSemver();
	var _pretty = requirePretty();
	var _utils = requireUtils();
	function getInclusionReasons(item, targetVersions, list) {
	  const minVersions = list[item] || {};
	  return Object.keys(targetVersions).reduce((result, env) => {
	    const minVersion = (0, _utils.getLowestImplementedVersion)(minVersions, env);
	    const targetVersion = targetVersions[env];
	    if (!minVersion) {
	      result[env] = (0, _pretty.prettifyVersion)(targetVersion);
	    } else {
	      const minIsUnreleased = (0, _utils.isUnreleasedVersion)(minVersion, env);
	      const targetIsUnreleased = (0, _utils.isUnreleasedVersion)(targetVersion, env);
	      if (!targetIsUnreleased && (minIsUnreleased || _semver.lt(targetVersion.toString(), (0, _utils.semverify)(minVersion)))) {
	        result[env] = (0, _pretty.prettifyVersion)(targetVersion);
	      }
	    }
	    return result;
	  }, {});
	}

	
	return debug;
}

var filterItems = {};

var require$$0$1 = {
	"transform-unicode-sets-regex": {
	chrome: "112",
	opera: "98",
	edge: "112",
	firefox: "116",
	safari: "tp",
	node: "20",
	deno: "1.32",
	opera_mobile: "75",
	electron: "24.0"
},
	"bugfix/transform-v8-static-class-fields-redefine-readonly": {
	chrome: "98",
	opera: "84",
	edge: "98",
	firefox: "95",
	safari: "15",
	node: "12",
	deno: "1.18",
	ios: "15",
	samsung: "11",
	opera_mobile: "52",
	electron: "17.0"
},
	"bugfix/transform-firefox-class-in-computed-class-key": {
	chrome: "74",
	opera: "62",
	edge: "79",
	safari: "14.1",
	node: "12",
	deno: "1",
	ios: "14.5",
	samsung: "11",
	opera_mobile: "53",
	electron: "6.0"
},
	"transform-class-static-block": {
	chrome: "94",
	opera: "80",
	edge: "94",
	firefox: "93",
	safari: "16.4",
	node: "16.11",
	deno: "1.14",
	ios: "16.4",
	samsung: "17",
	opera_mobile: "66",
	electron: "15.0"
},
	"proposal-class-static-block": {
	chrome: "94",
	opera: "80",
	edge: "94",
	firefox: "93",
	safari: "16.4",
	node: "16.11",
	deno: "1.14",
	ios: "16.4",
	samsung: "17",
	opera_mobile: "66",
	electron: "15.0"
},
	"transform-private-property-in-object": {
	chrome: "91",
	opera: "77",
	edge: "91",
	firefox: "90",
	safari: "15",
	node: "16.9",
	deno: "1.9",
	ios: "15",
	samsung: "16",
	opera_mobile: "64",
	electron: "13.0"
},
	"proposal-private-property-in-object": {
	chrome: "91",
	opera: "77",
	edge: "91",
	firefox: "90",
	safari: "15",
	node: "16.9",
	deno: "1.9",
	ios: "15",
	samsung: "16",
	opera_mobile: "64",
	electron: "13.0"
},
	"transform-class-properties": {
	chrome: "74",
	opera: "62",
	edge: "79",
	firefox: "90",
	safari: "14.1",
	node: "12",
	deno: "1",
	ios: "14.5",
	samsung: "11",
	opera_mobile: "53",
	electron: "6.0"
},
	"proposal-class-properties": {
	chrome: "74",
	opera: "62",
	edge: "79",
	firefox: "90",
	safari: "14.1",
	node: "12",
	deno: "1",
	ios: "14.5",
	samsung: "11",
	opera_mobile: "53",
	electron: "6.0"
},
	"transform-private-methods": {
	chrome: "84",
	opera: "70",
	edge: "84",
	firefox: "90",
	safari: "15",
	node: "14.6",
	deno: "1",
	ios: "15",
	samsung: "14",
	opera_mobile: "60",
	electron: "10.0"
},
	"proposal-private-methods": {
	chrome: "84",
	opera: "70",
	edge: "84",
	firefox: "90",
	safari: "15",
	node: "14.6",
	deno: "1",
	ios: "15",
	samsung: "14",
	opera_mobile: "60",
	electron: "10.0"
},
	"transform-numeric-separator": {
	chrome: "75",
	opera: "62",
	edge: "79",
	firefox: "70",
	safari: "13",
	node: "12.5",
	deno: "1",
	ios: "13",
	samsung: "11",
	rhino: "1.7.14",
	opera_mobile: "54",
	electron: "6.0"
},
	"proposal-numeric-separator": {
	chrome: "75",
	opera: "62",
	edge: "79",
	firefox: "70",
	safari: "13",
	node: "12.5",
	deno: "1",
	ios: "13",
	samsung: "11",
	rhino: "1.7.14",
	opera_mobile: "54",
	electron: "6.0"
},
	"transform-logical-assignment-operators": {
	chrome: "85",
	opera: "71",
	edge: "85",
	firefox: "79",
	safari: "14",
	node: "15",
	deno: "1.2",
	ios: "14",
	samsung: "14",
	opera_mobile: "60",
	electron: "10.0"
},
	"proposal-logical-assignment-operators": {
	chrome: "85",
	opera: "71",
	edge: "85",
	firefox: "79",
	safari: "14",
	node: "15",
	deno: "1.2",
	ios: "14",
	samsung: "14",
	opera_mobile: "60",
	electron: "10.0"
},
	"transform-nullish-coalescing-operator": {
	chrome: "80",
	opera: "67",
	edge: "80",
	firefox: "72",
	safari: "13.1",
	node: "14",
	deno: "1",
	ios: "13.4",
	samsung: "13",
	opera_mobile: "57",
	electron: "8.0"
},
	"proposal-nullish-coalescing-operator": {
	chrome: "80",
	opera: "67",
	edge: "80",
	firefox: "72",
	safari: "13.1",
	node: "14",
	deno: "1",
	ios: "13.4",
	samsung: "13",
	opera_mobile: "57",
	electron: "8.0"
},
	"transform-optional-chaining": {
	chrome: "91",
	opera: "77",
	edge: "91",
	firefox: "74",
	safari: "13.1",
	node: "16.9",
	deno: "1.9",
	ios: "13.4",
	samsung: "16",
	opera_mobile: "64",
	electron: "13.0"
},
	"proposal-optional-chaining": {
	chrome: "91",
	opera: "77",
	edge: "91",
	firefox: "74",
	safari: "13.1",
	node: "16.9",
	deno: "1.9",
	ios: "13.4",
	samsung: "16",
	opera_mobile: "64",
	electron: "13.0"
},
	"transform-json-strings": {
	chrome: "66",
	opera: "53",
	edge: "79",
	firefox: "62",
	safari: "12",
	node: "10",
	deno: "1",
	ios: "12",
	samsung: "9",
	rhino: "1.7.14",
	opera_mobile: "47",
	electron: "3.0"
},
	"proposal-json-strings": {
	chrome: "66",
	opera: "53",
	edge: "79",
	firefox: "62",
	safari: "12",
	node: "10",
	deno: "1",
	ios: "12",
	samsung: "9",
	rhino: "1.7.14",
	opera_mobile: "47",
	electron: "3.0"
},
	"transform-optional-catch-binding": {
	chrome: "66",
	opera: "53",
	edge: "79",
	firefox: "58",
	safari: "11.1",
	node: "10",
	deno: "1",
	ios: "11.3",
	samsung: "9",
	opera_mobile: "47",
	electron: "3.0"
},
	"proposal-optional-catch-binding": {
	chrome: "66",
	opera: "53",
	edge: "79",
	firefox: "58",
	safari: "11.1",
	node: "10",
	deno: "1",
	ios: "11.3",
	samsung: "9",
	opera_mobile: "47",
	electron: "3.0"
},
	"transform-parameters": {
	chrome: "49",
	opera: "36",
	edge: "18",
	firefox: "53",
	safari: "16.3",
	node: "6",
	deno: "1",
	ios: "16.3",
	samsung: "5",
	opera_mobile: "36",
	electron: "0.37"
},
	"transform-async-generator-functions": {
	chrome: "63",
	opera: "50",
	edge: "79",
	firefox: "57",
	safari: "12",
	node: "10",
	deno: "1",
	ios: "12",
	samsung: "8",
	opera_mobile: "46",
	electron: "3.0"
},
	"proposal-async-generator-functions": {
	chrome: "63",
	opera: "50",
	edge: "79",
	firefox: "57",
	safari: "12",
	node: "10",
	deno: "1",
	ios: "12",
	samsung: "8",
	opera_mobile: "46",
	electron: "3.0"
},
	"transform-object-rest-spread": {
	chrome: "60",
	opera: "47",
	edge: "79",
	firefox: "55",
	safari: "11.1",
	node: "8.3",
	deno: "1",
	ios: "11.3",
	samsung: "8",
	opera_mobile: "44",
	electron: "2.0"
},
	"proposal-object-rest-spread": {
	chrome: "60",
	opera: "47",
	edge: "79",
	firefox: "55",
	safari: "11.1",
	node: "8.3",
	deno: "1",
	ios: "11.3",
	samsung: "8",
	opera_mobile: "44",
	electron: "2.0"
},
	"transform-dotall-regex": {
	chrome: "62",
	opera: "49",
	edge: "79",
	firefox: "78",
	safari: "11.1",
	node: "8.10",
	deno: "1",
	ios: "11.3",
	samsung: "8",
	opera_mobile: "46",
	electron: "3.0"
},
	"transform-unicode-property-regex": {
	chrome: "64",
	opera: "51",
	edge: "79",
	firefox: "78",
	safari: "11.1",
	node: "10",
	deno: "1",
	ios: "11.3",
	samsung: "9",
	opera_mobile: "47",
	electron: "3.0"
},
	"proposal-unicode-property-regex": {
	chrome: "64",
	opera: "51",
	edge: "79",
	firefox: "78",
	safari: "11.1",
	node: "10",
	deno: "1",
	ios: "11.3",
	samsung: "9",
	opera_mobile: "47",
	electron: "3.0"
},
	"transform-named-capturing-groups-regex": {
	chrome: "64",
	opera: "51",
	edge: "79",
	firefox: "78",
	safari: "11.1",
	node: "10",
	deno: "1",
	ios: "11.3",
	samsung: "9",
	opera_mobile: "47",
	electron: "3.0"
},
	"transform-async-to-generator": {
	chrome: "55",
	opera: "42",
	edge: "15",
	firefox: "52",
	safari: "11",
	node: "7.6",
	deno: "1",
	ios: "11",
	samsung: "6",
	opera_mobile: "42",
	electron: "1.6"
},
	"transform-exponentiation-operator": {
	chrome: "52",
	opera: "39",
	edge: "14",
	firefox: "52",
	safari: "10.1",
	node: "7",
	deno: "1",
	ios: "10.3",
	samsung: "6",
	rhino: "1.7.14",
	opera_mobile: "41",
	electron: "1.3"
},
	"transform-template-literals": {
	chrome: "41",
	opera: "28",
	edge: "13",
	firefox: "34",
	safari: "13",
	node: "4",
	deno: "1",
	ios: "13",
	samsung: "3.4",
	opera_mobile: "28",
	electron: "0.21"
},
	"transform-literals": {
	chrome: "44",
	opera: "31",
	edge: "12",
	firefox: "53",
	safari: "9",
	node: "4",
	deno: "1",
	ios: "9",
	samsung: "4",
	opera_mobile: "32",
	electron: "0.30"
},
	"transform-function-name": {
	chrome: "51",
	opera: "38",
	edge: "79",
	firefox: "53",
	safari: "10",
	node: "6.5",
	deno: "1",
	ios: "10",
	samsung: "5",
	opera_mobile: "41",
	electron: "1.2"
},
	"transform-arrow-functions": {
	chrome: "47",
	opera: "34",
	edge: "13",
	firefox: "43",
	safari: "10",
	node: "6",
	deno: "1",
	ios: "10",
	samsung: "5",
	rhino: "1.7.13",
	opera_mobile: "34",
	electron: "0.36"
},
	"transform-block-scoped-functions": {
	chrome: "41",
	opera: "28",
	edge: "12",
	firefox: "46",
	safari: "10",
	node: "4",
	deno: "1",
	ie: "11",
	ios: "10",
	samsung: "3.4",
	opera_mobile: "28",
	electron: "0.21"
},
	"transform-classes": {
	chrome: "46",
	opera: "33",
	edge: "13",
	firefox: "45",
	safari: "10",
	node: "5",
	deno: "1",
	ios: "10",
	samsung: "5",
	opera_mobile: "33",
	electron: "0.36"
},
	"transform-object-super": {
	chrome: "46",
	opera: "33",
	edge: "13",
	firefox: "45",
	safari: "10",
	node: "5",
	deno: "1",
	ios: "10",
	samsung: "5",
	opera_mobile: "33",
	electron: "0.36"
},
	"transform-shorthand-properties": {
	chrome: "43",
	opera: "30",
	edge: "12",
	firefox: "33",
	safari: "9",
	node: "4",
	deno: "1",
	ios: "9",
	samsung: "4",
	rhino: "1.7.14",
	opera_mobile: "30",
	electron: "0.27"
},
	"transform-duplicate-keys": {
	chrome: "42",
	opera: "29",
	edge: "12",
	firefox: "34",
	safari: "9",
	node: "4",
	deno: "1",
	ios: "9",
	samsung: "3.4",
	opera_mobile: "29",
	electron: "0.25"
},
	"transform-computed-properties": {
	chrome: "44",
	opera: "31",
	edge: "12",
	firefox: "34",
	safari: "7.1",
	node: "4",
	deno: "1",
	ios: "8",
	samsung: "4",
	opera_mobile: "32",
	electron: "0.30"
},
	"transform-for-of": {
	chrome: "51",
	opera: "38",
	edge: "15",
	firefox: "53",
	safari: "10",
	node: "6.5",
	deno: "1",
	ios: "10",
	samsung: "5",
	opera_mobile: "41",
	electron: "1.2"
},
	"transform-sticky-regex": {
	chrome: "49",
	opera: "36",
	edge: "13",
	firefox: "3",
	safari: "10",
	node: "6",
	deno: "1",
	ios: "10",
	samsung: "5",
	opera_mobile: "36",
	electron: "0.37"
},
	"transform-unicode-escapes": {
	chrome: "44",
	opera: "31",
	edge: "12",
	firefox: "53",
	safari: "9",
	node: "4",
	deno: "1",
	ios: "9",
	samsung: "4",
	opera_mobile: "32",
	electron: "0.30"
},
	"transform-unicode-regex": {
	chrome: "50",
	opera: "37",
	edge: "13",
	firefox: "46",
	safari: "12",
	node: "6",
	deno: "1",
	ios: "12",
	samsung: "5",
	opera_mobile: "37",
	electron: "1.1"
},
	"transform-spread": {
	chrome: "46",
	opera: "33",
	edge: "13",
	firefox: "45",
	safari: "10",
	node: "5",
	deno: "1",
	ios: "10",
	samsung: "5",
	opera_mobile: "33",
	electron: "0.36"
},
	"transform-destructuring": {
	chrome: "51",
	opera: "38",
	edge: "15",
	firefox: "53",
	safari: "10",
	node: "6.5",
	deno: "1",
	ios: "10",
	samsung: "5",
	opera_mobile: "41",
	electron: "1.2"
},
	"transform-block-scoping": {
	chrome: "50",
	opera: "37",
	edge: "14",
	firefox: "53",
	safari: "11",
	node: "6",
	deno: "1",
	ios: "11",
	samsung: "5",
	opera_mobile: "37",
	electron: "1.1"
},
	"transform-typeof-symbol": {
	chrome: "38",
	opera: "25",
	edge: "12",
	firefox: "36",
	safari: "9",
	node: "0.12",
	deno: "1",
	ios: "9",
	samsung: "3",
	rhino: "1.7.13",
	opera_mobile: "25",
	electron: "0.20"
},
	"transform-new-target": {
	chrome: "46",
	opera: "33",
	edge: "14",
	firefox: "41",
	safari: "10",
	node: "5",
	deno: "1",
	ios: "10",
	samsung: "5",
	opera_mobile: "33",
	electron: "0.36"
},
	"transform-regenerator": {
	chrome: "50",
	opera: "37",
	edge: "13",
	firefox: "53",
	safari: "10",
	node: "6",
	deno: "1",
	ios: "10",
	samsung: "5",
	opera_mobile: "37",
	electron: "1.1"
},
	"transform-member-expression-literals": {
	chrome: "7",
	opera: "12",
	edge: "12",
	firefox: "2",
	safari: "5.1",
	node: "0.4",
	deno: "1",
	ie: "9",
	android: "4",
	ios: "6",
	phantom: "1.9",
	samsung: "1",
	rhino: "1.7.13",
	opera_mobile: "12",
	electron: "0.20"
},
	"transform-property-literals": {
	chrome: "7",
	opera: "12",
	edge: "12",
	firefox: "2",
	safari: "5.1",
	node: "0.4",
	deno: "1",
	ie: "9",
	android: "4",
	ios: "6",
	phantom: "1.9",
	samsung: "1",
	rhino: "1.7.13",
	opera_mobile: "12",
	electron: "0.20"
},
	"transform-reserved-words": {
	chrome: "13",
	opera: "10.50",
	edge: "12",
	firefox: "2",
	safari: "3.1",
	node: "0.6",
	deno: "1",
	ie: "9",
	android: "4.4",
	ios: "6",
	phantom: "1.9",
	samsung: "1",
	rhino: "1.7.13",
	opera_mobile: "10.1",
	electron: "0.20"
},
	"transform-export-namespace-from": {
	chrome: "72",
	deno: "1.0",
	edge: "79",
	firefox: "80",
	node: "13.2",
	opera: "60",
	opera_mobile: "51",
	safari: "14.1",
	ios: "14.5",
	samsung: "11.0",
	android: "72",
	electron: "5.0"
},
	"proposal-export-namespace-from": {
	chrome: "72",
	deno: "1.0",
	edge: "79",
	firefox: "80",
	node: "13.2",
	opera: "60",
	opera_mobile: "51",
	safari: "14.1",
	ios: "14.5",
	samsung: "11.0",
	android: "72",
	electron: "5.0"
}
};

var plugins$2;
var hasRequiredPlugins$1;

function requirePlugins$1 () {
	if (hasRequiredPlugins$1) return plugins$2;
	hasRequiredPlugins$1 = 1;
	plugins$2 = require$$0$1;
	return plugins$2;
}

var hasRequiredFilterItems;

function requireFilterItems () {
	if (hasRequiredFilterItems) return filterItems;
	hasRequiredFilterItems = 1;

	Object.defineProperty(filterItems, "__esModule", {
	  value: true
	});
	filterItems.default = filterItems$1;
	filterItems.isRequired = isRequired;
	filterItems.targetsSupported = targetsSupported;
	var _semver = requireSemver();
	var _plugins = requirePlugins$1();
	var _utils = requireUtils();
	function targetsSupported(target, support) {
	  const targetEnvironments = Object.keys(target);
	  if (targetEnvironments.length === 0) {
	    return false;
	  }
	  const unsupportedEnvironments = targetEnvironments.filter(environment => {
	    const lowestImplementedVersion = (0, _utils.getLowestImplementedVersion)(support, environment);
	    if (!lowestImplementedVersion) {
	      return true;
	    }
	    const lowestTargetedVersion = target[environment];
	    if ((0, _utils.isUnreleasedVersion)(lowestTargetedVersion, environment)) {
	      return false;
	    }
	    if ((0, _utils.isUnreleasedVersion)(lowestImplementedVersion, environment)) {
	      return true;
	    }
	    if (!_semver.valid(lowestTargetedVersion.toString())) {
	      throw new Error(`Invalid version passed for target "${environment}": "${lowestTargetedVersion}". ` + "Versions must be in semver format (major.minor.patch)");
	    }
	    return _semver.gt((0, _utils.semverify)(lowestImplementedVersion), lowestTargetedVersion.toString());
	  });
	  return unsupportedEnvironments.length === 0;
	}
	function isRequired(name, targets, {
	  compatData = _plugins,
	  includes,
	  excludes
	} = {}) {
	  if (excludes != null && excludes.has(name)) return false;
	  if (includes != null && includes.has(name)) return true;
	  return !targetsSupported(targets, compatData[name]);
	}
	function filterItems$1(list, includes, excludes, targets, defaultIncludes, defaultExcludes, pluginSyntaxMap) {
	  const result = new Set();
	  const options = {
	    compatData: list,
	    includes,
	    excludes
	  };
	  for (const item in list) {
	    if (isRequired(item, targets, options)) {
	      result.add(item);
	    } else if (pluginSyntaxMap) {
	      const shippedProposalsSyntax = pluginSyntaxMap.get(item);
	      if (shippedProposalsSyntax) {
	        result.add(shippedProposalsSyntax);
	      }
	    }
	  }
	  defaultIncludes == null || defaultIncludes.forEach(item => !excludes.has(item) && result.add(item));
	  defaultExcludes == null || defaultExcludes.forEach(item => !includes.has(item) && result.delete(item));
	  return result;
	}

	
	return filterItems;
}

var hasRequiredLib$1;

function requireLib$1 () {
	if (hasRequiredLib$1) return lib$1;
	hasRequiredLib$1 = 1;
	(function (exports) {

		Object.defineProperty(exports, "__esModule", {
		  value: true
		});
		Object.defineProperty(exports, "TargetNames", {
		  enumerable: true,
		  get: function () {
		    return _options.TargetNames;
		  }
		});
		exports.default = getTargets;
		Object.defineProperty(exports, "filterItems", {
		  enumerable: true,
		  get: function () {
		    return _filterItems.default;
		  }
		});
		Object.defineProperty(exports, "getInclusionReasons", {
		  enumerable: true,
		  get: function () {
		    return _debug.getInclusionReasons;
		  }
		});
		exports.isBrowsersQueryValid = isBrowsersQueryValid;
		Object.defineProperty(exports, "isRequired", {
		  enumerable: true,
		  get: function () {
		    return _filterItems.isRequired;
		  }
		});
		Object.defineProperty(exports, "prettifyTargets", {
		  enumerable: true,
		  get: function () {
		    return _pretty.prettifyTargets;
		  }
		});
		Object.defineProperty(exports, "unreleasedLabels", {
		  enumerable: true,
		  get: function () {
		    return _targets.unreleasedLabels;
		  }
		});
		var _browserslist = requireBrowserslist();
		var _helperValidatorOption = requireLib$2();
		var _nativeModules = requireNativeModules();
		var _lruCache = requireLruCache();
		var _utils = requireUtils();
		var _targets = requireTargets();
		var _options = requireOptions$1();
		var _pretty = requirePretty();
		var _debug = requireDebug();
		var _filterItems = requireFilterItems();
		const ESM_SUPPORT = _nativeModules["es6.module"];
		const v = new _helperValidatorOption.OptionValidator("@babel/helper-compilation-targets");
		function validateTargetNames(targets) {
		  const validTargets = Object.keys(_options.TargetNames);
		  for (const target of Object.keys(targets)) {
		    if (!(target in _options.TargetNames)) {
		      throw new Error(v.formatMessage(`'${target}' is not a valid target
- Did you mean '${(0, _helperValidatorOption.findSuggestion)(target, validTargets)}'?`));
		    }
		  }
		  return targets;
		}
		function isBrowsersQueryValid(browsers) {
		  return typeof browsers === "string" || Array.isArray(browsers) && browsers.every(b => typeof b === "string");
		}
		function validateBrowsers(browsers) {
		  v.invariant(browsers === undefined || isBrowsersQueryValid(browsers), `'${String(browsers)}' is not a valid browserslist query`);
		  return browsers;
		}
		function getLowestVersions(browsers) {
		  return browsers.reduce((all, browser) => {
		    const [browserName, browserVersion] = browser.split(" ");
		    const target = _targets.browserNameMap[browserName];
		    if (!target) {
		      return all;
		    }
		    try {
		      const splitVersion = browserVersion.split("-")[0].toLowerCase();
		      const isSplitUnreleased = (0, _utils.isUnreleasedVersion)(splitVersion, target);
		      if (!all[target]) {
		        all[target] = isSplitUnreleased ? splitVersion : (0, _utils.semverify)(splitVersion);
		        return all;
		      }
		      const version = all[target];
		      const isUnreleased = (0, _utils.isUnreleasedVersion)(version, target);
		      if (isUnreleased && isSplitUnreleased) {
		        all[target] = (0, _utils.getLowestUnreleased)(version, splitVersion, target);
		      } else if (isUnreleased) {
		        all[target] = (0, _utils.semverify)(splitVersion);
		      } else if (!isUnreleased && !isSplitUnreleased) {
		        const parsedBrowserVersion = (0, _utils.semverify)(splitVersion);
		        all[target] = (0, _utils.semverMin)(version, parsedBrowserVersion);
		      }
		    } catch (e) {}
		    return all;
		  }, {});
		}
		function outputDecimalWarning(decimalTargets) {
		  if (!decimalTargets.length) {
		    return;
		  }
		  console.warn("Warning, the following targets are using a decimal version:\n");
		  decimalTargets.forEach(({
		    target,
		    value
		  }) => console.warn(`  ${target}: ${value}`));
		  console.warn(`
We recommend using a string for minor/patch versions to avoid numbers like 6.10
getting parsed as 6.1, which can lead to unexpected behavior.
`);
		}
		function semverifyTarget(target, value) {
		  try {
		    return (0, _utils.semverify)(value);
		  } catch (error) {
		    throw new Error(v.formatMessage(`'${value}' is not a valid value for 'targets.${target}'.`));
		  }
		}
		function nodeTargetParser(value) {
		  const parsed = value === true || value === "current" ? process.versions.node : semverifyTarget("node", value);
		  return ["node", parsed];
		}
		function defaultTargetParser(target, value) {
		  const version = (0, _utils.isUnreleasedVersion)(value, target) ? value.toLowerCase() : semverifyTarget(target, value);
		  return [target, version];
		}
		function generateTargets(inputTargets) {
		  const input = Object.assign({}, inputTargets);
		  delete input.esmodules;
		  delete input.browsers;
		  return input;
		}
		function resolveTargets(queries, env) {
		  const resolved = _browserslist(queries, {
		    mobileToDesktop: true,
		    env
		  });
		  return getLowestVersions(resolved);
		}
		const targetsCache = new _lruCache({
		  max: 64
		});
		function resolveTargetsCached(queries, env) {
		  const cacheKey = typeof queries === "string" ? queries : queries.join() + env;
		  let cached = targetsCache.get(cacheKey);
		  if (!cached) {
		    cached = resolveTargets(queries, env);
		    targetsCache.set(cacheKey, cached);
		  }
		  return Object.assign({}, cached);
		}
		function getTargets(inputTargets = {}, options = {}) {
		  var _browsers, _browsers2;
		  let {
		    browsers,
		    esmodules
		  } = inputTargets;
		  const {
		    configPath = "."
		  } = options;
		  validateBrowsers(browsers);
		  const input = generateTargets(inputTargets);
		  let targets = validateTargetNames(input);
		  const shouldParseBrowsers = !!browsers;
		  const hasTargets = shouldParseBrowsers || Object.keys(targets).length > 0;
		  const shouldSearchForConfig = !options.ignoreBrowserslistConfig && !hasTargets;
		  if (!browsers && shouldSearchForConfig) {
		    browsers = _browserslist.loadConfig({
		      config: options.configFile,
		      path: configPath,
		      env: options.browserslistEnv
		    });
		    if (browsers == null) {
		      {
		        browsers = [];
		      }
		    }
		  }
		  if (esmodules && (esmodules !== "intersect" || !((_browsers = browsers) != null && _browsers.length))) {
		    browsers = Object.keys(ESM_SUPPORT).map(browser => `${browser} >= ${ESM_SUPPORT[browser]}`).join(", ");
		    esmodules = false;
		  }
		  if ((_browsers2 = browsers) != null && _browsers2.length) {
		    const queryBrowsers = resolveTargetsCached(browsers, options.browserslistEnv);
		    if (esmodules === "intersect") {
		      for (const browser of Object.keys(queryBrowsers)) {
		        if (browser !== "deno" && browser !== "ie") {
		          const esmSupportVersion = ESM_SUPPORT[browser === "opera_mobile" ? "op_mob" : browser];
		          if (esmSupportVersion) {
		            const version = queryBrowsers[browser];
		            queryBrowsers[browser] = (0, _utils.getHighestUnreleased)(version, (0, _utils.semverify)(esmSupportVersion), browser);
		          } else {
		            delete queryBrowsers[browser];
		          }
		        } else {
		          delete queryBrowsers[browser];
		        }
		      }
		    }
		    targets = Object.assign(queryBrowsers, targets);
		  }
		  const result = {};
		  const decimalWarnings = [];
		  for (const target of Object.keys(targets).sort()) {
		    const value = targets[target];
		    if (typeof value === "number" && value % 1 !== 0) {
		      decimalWarnings.push({
		        target,
		        value
		      });
		    }
		    const [parsedTarget, parsedValue] = target === "node" ? nodeTargetParser(value) : defaultTargetParser(target, value);
		    if (parsedValue) {
		      result[parsedTarget] = parsedValue;
		    }
		  }
		  outputDecimalWarning(decimalWarnings);
		  return result;
		}

		
	} (lib$1));
	return lib$1;
}

Object.defineProperty(resolveTargets$1, "__esModule", {
  value: true
});
resolveTargets$1.resolveBrowserslistConfigFile = resolveBrowserslistConfigFile;
resolveTargets$1.resolveTargets = resolveTargets;
function _path$3() {
  const data = path__default["default"];
  _path$3 = function () {
    return data;
  };
  return data;
}
function _helperCompilationTargets() {
  const data = requireLib$1();
  _helperCompilationTargets = function () {
    return data;
  };
  return data;
}
function resolveBrowserslistConfigFile(browserslistConfigFile, configFileDir) {
  return _path$3().resolve(configFileDir, browserslistConfigFile);
}
function resolveTargets(options, root) {
  const optTargets = options.targets;
  let targets;
  if (typeof optTargets === "string" || Array.isArray(optTargets)) {
    targets = {
      browsers: optTargets
    };
  } else if (optTargets) {
    if ("esmodules" in optTargets) {
      targets = Object.assign({}, optTargets, {
        esmodules: "intersect"
      });
    } else {
      targets = optTargets;
    }
  }
  const {
    browserslistConfigFile
  } = options;
  let configFile;
  let ignoreBrowserslistConfig = false;
  if (typeof browserslistConfigFile === "string") {
    configFile = browserslistConfigFile;
  } else {
    ignoreBrowserslistConfig = browserslistConfigFile === false;
  }
  return (0, _helperCompilationTargets().default)(targets, {
    ignoreBrowserslistConfig,
    configFile,
    configPath: root,
    browserslistEnv: options.browserslistEnv
  });
}

var hasRequiredConfigDescriptors;

function requireConfigDescriptors () {
	if (hasRequiredConfigDescriptors) return configDescriptors;
	hasRequiredConfigDescriptors = 1;

	Object.defineProperty(configDescriptors, "__esModule", {
	  value: true
	});
	configDescriptors.createCachedDescriptors = createCachedDescriptors;
	configDescriptors.createDescriptor = createDescriptor;
	configDescriptors.createUncachedDescriptors = createUncachedDescriptors;
	function _gensync() {
	  const data = requireGensync();
	  _gensync = function () {
	    return data;
	  };
	  return data;
	}
	var _functional = functional;
	var _index = requireFiles();
	var _item = requireItem();
	var _caching = caching;
	var _resolveTargets = resolveTargets$1;
	function isEqualDescriptor(a, b) {
	  var _a$file, _b$file, _a$file2, _b$file2;
	  return a.name === b.name && a.value === b.value && a.options === b.options && a.dirname === b.dirname && a.alias === b.alias && a.ownPass === b.ownPass && ((_a$file = a.file) == null ? void 0 : _a$file.request) === ((_b$file = b.file) == null ? void 0 : _b$file.request) && ((_a$file2 = a.file) == null ? void 0 : _a$file2.resolved) === ((_b$file2 = b.file) == null ? void 0 : _b$file2.resolved);
	}
	function* handlerOf(value) {
	  return value;
	}
	function optionsWithResolvedBrowserslistConfigFile(options, dirname) {
	  if (typeof options.browserslistConfigFile === "string") {
	    options.browserslistConfigFile = (0, _resolveTargets.resolveBrowserslistConfigFile)(options.browserslistConfigFile, dirname);
	  }
	  return options;
	}
	function createCachedDescriptors(dirname, options, alias) {
	  const {
	    plugins,
	    presets,
	    passPerPreset
	  } = options;
	  return {
	    options: optionsWithResolvedBrowserslistConfigFile(options, dirname),
	    plugins: plugins ? () => createCachedPluginDescriptors(plugins, dirname)(alias) : () => handlerOf([]),
	    presets: presets ? () => createCachedPresetDescriptors(presets, dirname)(alias)(!!passPerPreset) : () => handlerOf([])
	  };
	}
	function createUncachedDescriptors(dirname, options, alias) {
	  return {
	    options: optionsWithResolvedBrowserslistConfigFile(options, dirname),
	    plugins: (0, _functional.once)(() => createPluginDescriptors(options.plugins || [], dirname, alias)),
	    presets: (0, _functional.once)(() => createPresetDescriptors(options.presets || [], dirname, alias, !!options.passPerPreset))
	  };
	}
	const PRESET_DESCRIPTOR_CACHE = new WeakMap();
	const createCachedPresetDescriptors = (0, _caching.makeWeakCacheSync)((items, cache) => {
	  const dirname = cache.using(dir => dir);
	  return (0, _caching.makeStrongCacheSync)(alias => (0, _caching.makeStrongCache)(function* (passPerPreset) {
	    const descriptors = yield* createPresetDescriptors(items, dirname, alias, passPerPreset);
	    return descriptors.map(desc => loadCachedDescriptor(PRESET_DESCRIPTOR_CACHE, desc));
	  }));
	});
	const PLUGIN_DESCRIPTOR_CACHE = new WeakMap();
	const createCachedPluginDescriptors = (0, _caching.makeWeakCacheSync)((items, cache) => {
	  const dirname = cache.using(dir => dir);
	  return (0, _caching.makeStrongCache)(function* (alias) {
	    const descriptors = yield* createPluginDescriptors(items, dirname, alias);
	    return descriptors.map(desc => loadCachedDescriptor(PLUGIN_DESCRIPTOR_CACHE, desc));
	  });
	});
	const DEFAULT_OPTIONS = {};
	function loadCachedDescriptor(cache, desc) {
	  const {
	    value,
	    options = DEFAULT_OPTIONS
	  } = desc;
	  if (options === false) return desc;
	  let cacheByOptions = cache.get(value);
	  if (!cacheByOptions) {
	    cacheByOptions = new WeakMap();
	    cache.set(value, cacheByOptions);
	  }
	  let possibilities = cacheByOptions.get(options);
	  if (!possibilities) {
	    possibilities = [];
	    cacheByOptions.set(options, possibilities);
	  }
	  if (possibilities.indexOf(desc) === -1) {
	    const matches = possibilities.filter(possibility => isEqualDescriptor(possibility, desc));
	    if (matches.length > 0) {
	      return matches[0];
	    }
	    possibilities.push(desc);
	  }
	  return desc;
	}
	function* createPresetDescriptors(items, dirname, alias, passPerPreset) {
	  return yield* createDescriptors("preset", items, dirname, alias, passPerPreset);
	}
	function* createPluginDescriptors(items, dirname, alias) {
	  return yield* createDescriptors("plugin", items, dirname, alias);
	}
	function* createDescriptors(type, items, dirname, alias, ownPass) {
	  const descriptors = yield* _gensync().all(items.map((item, index) => createDescriptor(item, dirname, {
	    type,
	    alias: `${alias}$${index}`,
	    ownPass: !!ownPass
	  })));
	  assertNoDuplicates(descriptors);
	  return descriptors;
	}
	function* createDescriptor(pair, dirname, {
	  type,
	  alias,
	  ownPass
	}) {
	  const desc = (0, _item.getItemDescriptor)(pair);
	  if (desc) {
	    return desc;
	  }
	  let name;
	  let options;
	  let value = pair;
	  if (Array.isArray(value)) {
	    if (value.length === 3) {
	      [value, options, name] = value;
	    } else {
	      [value, options] = value;
	    }
	  }
	  let file = undefined;
	  let filepath = null;
	  if (typeof value === "string") {
	    if (typeof type !== "string") {
	      throw new Error("To resolve a string-based item, the type of item must be given");
	    }
	    const resolver = type === "plugin" ? _index.loadPlugin : _index.loadPreset;
	    const request = value;
	    ({
	      filepath,
	      value
	    } = yield* resolver(value, dirname));
	    file = {
	      request,
	      resolved: filepath
	    };
	  }
	  if (!value) {
	    throw new Error(`Unexpected falsy value: ${String(value)}`);
	  }
	  if (typeof value === "object" && value.__esModule) {
	    if (value.default) {
	      value = value.default;
	    } else {
	      throw new Error("Must export a default export when using ES6 modules.");
	    }
	  }
	  if (typeof value !== "object" && typeof value !== "function") {
	    throw new Error(`Unsupported format: ${typeof value}. Expected an object or a function.`);
	  }
	  if (filepath !== null && typeof value === "object" && value) {
	    throw new Error(`Plugin/Preset files are not allowed to export objects, only functions. In ${filepath}`);
	  }
	  return {
	    name,
	    alias: filepath || alias,
	    value,
	    options,
	    dirname,
	    ownPass,
	    file
	  };
	}
	function assertNoDuplicates(items) {
	  const map = new Map();
	  for (const item of items) {
	    if (typeof item.value !== "function") continue;
	    let nameMap = map.get(item.value);
	    if (!nameMap) {
	      nameMap = new Set();
	      map.set(item.value, nameMap);
	    }
	    if (nameMap.has(item.name)) {
	      const conflicts = items.filter(i => i.value === item.value);
	      throw new Error([`Duplicate plugin/preset detected.`, `If you'd like to use two separate instances of a plugin,`, `they need separate names, e.g.`, ``, `  plugins: [`, `    ['some-plugin', {}],`, `    ['some-plugin', {}, 'some unique name'],`, `  ]`, ``, `Duplicates detected are:`, `${JSON.stringify(conflicts, null, 2)}`].join("\n"));
	    }
	    nameMap.add(item.name);
	  }
	}

	
	return configDescriptors;
}

var hasRequiredItem;

function requireItem () {
	if (hasRequiredItem) return item;
	hasRequiredItem = 1;

	Object.defineProperty(item, "__esModule", {
	  value: true
	});
	item.createConfigItem = createConfigItem;
	item.createItemFromDescriptor = createItemFromDescriptor;
	item.getItemDescriptor = getItemDescriptor;
	function _path() {
	  const data = path__default["default"];
	  _path = function () {
	    return data;
	  };
	  return data;
	}
	var _configDescriptors = requireConfigDescriptors();
	function createItemFromDescriptor(desc) {
	  return new ConfigItem(desc);
	}
	function* createConfigItem(value, {
	  dirname = ".",
	  type
	} = {}) {
	  const descriptor = yield* (0, _configDescriptors.createDescriptor)(value, _path().resolve(dirname), {
	    type,
	    alias: "programmatic item"
	  });
	  return createItemFromDescriptor(descriptor);
	}
	const CONFIG_ITEM_BRAND = Symbol.for("@babel/core@7 - ConfigItem");
	function getItemDescriptor(item) {
	  if (item != null && item[CONFIG_ITEM_BRAND]) {
	    return item._descriptor;
	  }
	  return undefined;
	}
	class ConfigItem {
	  constructor(descriptor) {
	    this._descriptor = void 0;
	    this[CONFIG_ITEM_BRAND] = true;
	    this.value = void 0;
	    this.options = void 0;
	    this.dirname = void 0;
	    this.name = void 0;
	    this.file = void 0;
	    this._descriptor = descriptor;
	    Object.defineProperty(this, "_descriptor", {
	      enumerable: false
	    });
	    Object.defineProperty(this, CONFIG_ITEM_BRAND, {
	      enumerable: false
	    });
	    this.value = this._descriptor.value;
	    this.options = this._descriptor.options;
	    this.dirname = this._descriptor.dirname;
	    this.name = this._descriptor.name;
	    this.file = this._descriptor.file ? {
	      request: this._descriptor.file.request,
	      resolved: this._descriptor.file.resolved
	    } : undefined;
	    Object.freeze(this);
	  }
	}
	Object.freeze(ConfigItem.prototype);

	
	return item;
}

var configChain = {};

var options = {};

var removed = {};

Object.defineProperty(removed, "__esModule", {
  value: true
});
removed.default = void 0;
removed.default = {
  auxiliaryComment: {
    message: "Use `auxiliaryCommentBefore` or `auxiliaryCommentAfter`"
  },
  blacklist: {
    message: "Put the specific transforms you want in the `plugins` option"
  },
  breakConfig: {
    message: "This is not a necessary option in Babel 6"
  },
  experimental: {
    message: "Put the specific transforms you want in the `plugins` option"
  },
  externalHelpers: {
    message: "Use the `external-helpers` plugin instead. " + "Check out http://babeljs.io/docs/plugins/external-helpers/"
  },
  extra: {
    message: ""
  },
  jsxPragma: {
    message: "use the `pragma` option in the `react-jsx` plugin. " + "Check out http://babeljs.io/docs/plugins/transform-react-jsx/"
  },
  loose: {
    message: "Specify the `loose` option for the relevant plugin you are using " + "or use a preset that sets the option."
  },
  metadataUsedHelpers: {
    message: "Not required anymore as this is enabled by default"
  },
  modules: {
    message: "Use the corresponding module transform plugin in the `plugins` option. " + "Check out http://babeljs.io/docs/plugins/#modules"
  },
  nonStandard: {
    message: "Use the `react-jsx` and `flow-strip-types` plugins to support JSX and Flow. " + "Also check out the react preset http://babeljs.io/docs/plugins/preset-react/"
  },
  optional: {
    message: "Put the specific transforms you want in the `plugins` option"
  },
  sourceMapName: {
    message: "The `sourceMapName` option has been removed because it makes more sense for the " + "tooling that calls Babel to assign `map.file` themselves."
  },
  stage: {
    message: "Check out the corresponding stage-x presets http://babeljs.io/docs/plugins/#presets"
  },
  whitelist: {
    message: "Put the specific transforms you want in the `plugins` option"
  },
  resolveModuleSource: {
    version: 6,
    message: "Use `babel-plugin-module-resolver@3`'s 'resolvePath' options"
  },
  metadata: {
    version: 6,
    message: "Generated plugin metadata is always included in the output result"
  },
  sourceMapTarget: {
    version: 6,
    message: "The `sourceMapTarget` option has been removed because it makes more sense for the tooling " + "that calls Babel to assign `map.file` themselves."
  }
};

var optionAssertions = {};

var hasRequiredOptionAssertions;

function requireOptionAssertions () {
	if (hasRequiredOptionAssertions) return optionAssertions;
	hasRequiredOptionAssertions = 1;

	Object.defineProperty(optionAssertions, "__esModule", {
	  value: true
	});
	optionAssertions.access = access;
	optionAssertions.assertArray = assertArray;
	optionAssertions.assertAssumptions = assertAssumptions;
	optionAssertions.assertBabelrcSearch = assertBabelrcSearch;
	optionAssertions.assertBoolean = assertBoolean;
	optionAssertions.assertCallerMetadata = assertCallerMetadata;
	optionAssertions.assertCompact = assertCompact;
	optionAssertions.assertConfigApplicableTest = assertConfigApplicableTest;
	optionAssertions.assertConfigFileSearch = assertConfigFileSearch;
	optionAssertions.assertFunction = assertFunction;
	optionAssertions.assertIgnoreList = assertIgnoreList;
	optionAssertions.assertInputSourceMap = assertInputSourceMap;
	optionAssertions.assertObject = assertObject;
	optionAssertions.assertPluginList = assertPluginList;
	optionAssertions.assertRootMode = assertRootMode;
	optionAssertions.assertSourceMaps = assertSourceMaps;
	optionAssertions.assertSourceType = assertSourceType;
	optionAssertions.assertString = assertString;
	optionAssertions.assertTargets = assertTargets;
	optionAssertions.msg = msg;
	function _helperCompilationTargets() {
	  const data = requireLib$1();
	  _helperCompilationTargets = function () {
	    return data;
	  };
	  return data;
	}
	var _options = requireOptions();
	function msg(loc) {
	  switch (loc.type) {
	    case "root":
	      return ``;
	    case "env":
	      return `${msg(loc.parent)}.env["${loc.name}"]`;
	    case "overrides":
	      return `${msg(loc.parent)}.overrides[${loc.index}]`;
	    case "option":
	      return `${msg(loc.parent)}.${loc.name}`;
	    case "access":
	      return `${msg(loc.parent)}[${JSON.stringify(loc.name)}]`;
	    default:
	      throw new Error(`Assertion failure: Unknown type ${loc.type}`);
	  }
	}
	function access(loc, name) {
	  return {
	    type: "access",
	    name,
	    parent: loc
	  };
	}
	function assertRootMode(loc, value) {
	  if (value !== undefined && value !== "root" && value !== "upward" && value !== "upward-optional") {
	    throw new Error(`${msg(loc)} must be a "root", "upward", "upward-optional" or undefined`);
	  }
	  return value;
	}
	function assertSourceMaps(loc, value) {
	  if (value !== undefined && typeof value !== "boolean" && value !== "inline" && value !== "both") {
	    throw new Error(`${msg(loc)} must be a boolean, "inline", "both", or undefined`);
	  }
	  return value;
	}
	function assertCompact(loc, value) {
	  if (value !== undefined && typeof value !== "boolean" && value !== "auto") {
	    throw new Error(`${msg(loc)} must be a boolean, "auto", or undefined`);
	  }
	  return value;
	}
	function assertSourceType(loc, value) {
	  if (value !== undefined && value !== "module" && value !== "script" && value !== "unambiguous") {
	    throw new Error(`${msg(loc)} must be "module", "script", "unambiguous", or undefined`);
	  }
	  return value;
	}
	function assertCallerMetadata(loc, value) {
	  const obj = assertObject(loc, value);
	  if (obj) {
	    if (typeof obj.name !== "string") {
	      throw new Error(`${msg(loc)} set but does not contain "name" property string`);
	    }
	    for (const prop of Object.keys(obj)) {
	      const propLoc = access(loc, prop);
	      const value = obj[prop];
	      if (value != null && typeof value !== "boolean" && typeof value !== "string" && typeof value !== "number") {
	        throw new Error(`${msg(propLoc)} must be null, undefined, a boolean, a string, or a number.`);
	      }
	    }
	  }
	  return value;
	}
	function assertInputSourceMap(loc, value) {
	  if (value !== undefined && typeof value !== "boolean" && (typeof value !== "object" || !value)) {
	    throw new Error(`${msg(loc)} must be a boolean, object, or undefined`);
	  }
	  return value;
	}
	function assertString(loc, value) {
	  if (value !== undefined && typeof value !== "string") {
	    throw new Error(`${msg(loc)} must be a string, or undefined`);
	  }
	  return value;
	}
	function assertFunction(loc, value) {
	  if (value !== undefined && typeof value !== "function") {
	    throw new Error(`${msg(loc)} must be a function, or undefined`);
	  }
	  return value;
	}
	function assertBoolean(loc, value) {
	  if (value !== undefined && typeof value !== "boolean") {
	    throw new Error(`${msg(loc)} must be a boolean, or undefined`);
	  }
	  return value;
	}
	function assertObject(loc, value) {
	  if (value !== undefined && (typeof value !== "object" || Array.isArray(value) || !value)) {
	    throw new Error(`${msg(loc)} must be an object, or undefined`);
	  }
	  return value;
	}
	function assertArray(loc, value) {
	  if (value != null && !Array.isArray(value)) {
	    throw new Error(`${msg(loc)} must be an array, or undefined`);
	  }
	  return value;
	}
	function assertIgnoreList(loc, value) {
	  const arr = assertArray(loc, value);
	  arr == null || arr.forEach((item, i) => assertIgnoreItem(access(loc, i), item));
	  return arr;
	}
	function assertIgnoreItem(loc, value) {
	  if (typeof value !== "string" && typeof value !== "function" && !(value instanceof RegExp)) {
	    throw new Error(`${msg(loc)} must be an array of string/Function/RegExp values, or undefined`);
	  }
	  return value;
	}
	function assertConfigApplicableTest(loc, value) {
	  if (value === undefined) {
	    return value;
	  }
	  if (Array.isArray(value)) {
	    value.forEach((item, i) => {
	      if (!checkValidTest(item)) {
	        throw new Error(`${msg(access(loc, i))} must be a string/Function/RegExp.`);
	      }
	    });
	  } else if (!checkValidTest(value)) {
	    throw new Error(`${msg(loc)} must be a string/Function/RegExp, or an array of those`);
	  }
	  return value;
	}
	function checkValidTest(value) {
	  return typeof value === "string" || typeof value === "function" || value instanceof RegExp;
	}
	function assertConfigFileSearch(loc, value) {
	  if (value !== undefined && typeof value !== "boolean" && typeof value !== "string") {
	    throw new Error(`${msg(loc)} must be a undefined, a boolean, a string, ` + `got ${JSON.stringify(value)}`);
	  }
	  return value;
	}
	function assertBabelrcSearch(loc, value) {
	  if (value === undefined || typeof value === "boolean") {
	    return value;
	  }
	  if (Array.isArray(value)) {
	    value.forEach((item, i) => {
	      if (!checkValidTest(item)) {
	        throw new Error(`${msg(access(loc, i))} must be a string/Function/RegExp.`);
	      }
	    });
	  } else if (!checkValidTest(value)) {
	    throw new Error(`${msg(loc)} must be a undefined, a boolean, a string/Function/RegExp ` + `or an array of those, got ${JSON.stringify(value)}`);
	  }
	  return value;
	}
	function assertPluginList(loc, value) {
	  const arr = assertArray(loc, value);
	  if (arr) {
	    arr.forEach((item, i) => assertPluginItem(access(loc, i), item));
	  }
	  return arr;
	}
	function assertPluginItem(loc, value) {
	  if (Array.isArray(value)) {
	    if (value.length === 0) {
	      throw new Error(`${msg(loc)} must include an object`);
	    }
	    if (value.length > 3) {
	      throw new Error(`${msg(loc)} may only be a two-tuple or three-tuple`);
	    }
	    assertPluginTarget(access(loc, 0), value[0]);
	    if (value.length > 1) {
	      const opts = value[1];
	      if (opts !== undefined && opts !== false && (typeof opts !== "object" || Array.isArray(opts) || opts === null)) {
	        throw new Error(`${msg(access(loc, 1))} must be an object, false, or undefined`);
	      }
	    }
	    if (value.length === 3) {
	      const name = value[2];
	      if (name !== undefined && typeof name !== "string") {
	        throw new Error(`${msg(access(loc, 2))} must be a string, or undefined`);
	      }
	    }
	  } else {
	    assertPluginTarget(loc, value);
	  }
	  return value;
	}
	function assertPluginTarget(loc, value) {
	  if ((typeof value !== "object" || !value) && typeof value !== "string" && typeof value !== "function") {
	    throw new Error(`${msg(loc)} must be a string, object, function`);
	  }
	  return value;
	}
	function assertTargets(loc, value) {
	  if ((0, _helperCompilationTargets().isBrowsersQueryValid)(value)) return value;
	  if (typeof value !== "object" || !value || Array.isArray(value)) {
	    throw new Error(`${msg(loc)} must be a string, an array of strings or an object`);
	  }
	  const browsersLoc = access(loc, "browsers");
	  const esmodulesLoc = access(loc, "esmodules");
	  assertBrowsersList(browsersLoc, value.browsers);
	  assertBoolean(esmodulesLoc, value.esmodules);
	  for (const key of Object.keys(value)) {
	    const val = value[key];
	    const subLoc = access(loc, key);
	    if (key === "esmodules") assertBoolean(subLoc, val);else if (key === "browsers") assertBrowsersList(subLoc, val);else if (!hasOwnProperty.call(_helperCompilationTargets().TargetNames, key)) {
	      const validTargets = Object.keys(_helperCompilationTargets().TargetNames).join(", ");
	      throw new Error(`${msg(subLoc)} is not a valid target. Supported targets are ${validTargets}`);
	    } else assertBrowserVersion(subLoc, val);
	  }
	  return value;
	}
	function assertBrowsersList(loc, value) {
	  if (value !== undefined && !(0, _helperCompilationTargets().isBrowsersQueryValid)(value)) {
	    throw new Error(`${msg(loc)} must be undefined, a string or an array of strings`);
	  }
	}
	function assertBrowserVersion(loc, value) {
	  if (typeof value === "number" && Math.round(value) === value) return;
	  if (typeof value === "string") return;
	  throw new Error(`${msg(loc)} must be a string or an integer number`);
	}
	function assertAssumptions(loc, value) {
	  if (value === undefined) return;
	  if (typeof value !== "object" || value === null) {
	    throw new Error(`${msg(loc)} must be an object or undefined.`);
	  }
	  let root = loc;
	  do {
	    root = root.parent;
	  } while (root.type !== "root");
	  const inPreset = root.source === "preset";
	  for (const name of Object.keys(value)) {
	    const subLoc = access(loc, name);
	    if (!_options.assumptionsNames.has(name)) {
	      throw new Error(`${msg(subLoc)} is not a supported assumption.`);
	    }
	    if (typeof value[name] !== "boolean") {
	      throw new Error(`${msg(subLoc)} must be a boolean.`);
	    }
	    if (inPreset && value[name] === false) {
	      throw new Error(`${msg(subLoc)} cannot be set to 'false' inside presets.`);
	    }
	  }
	  return value;
	}

	
	return optionAssertions;
}

var hasRequiredOptions;

function requireOptions () {
	if (hasRequiredOptions) return options;
	hasRequiredOptions = 1;

	Object.defineProperty(options, "__esModule", {
	  value: true
	});
	options.assumptionsNames = void 0;
	options.checkNoUnwrappedItemOptionPairs = checkNoUnwrappedItemOptionPairs;
	options.validate = validate;
	var _removed = removed;
	var _optionAssertions = requireOptionAssertions();
	var _configError = configError;
	const ROOT_VALIDATORS = {
	  cwd: _optionAssertions.assertString,
	  root: _optionAssertions.assertString,
	  rootMode: _optionAssertions.assertRootMode,
	  configFile: _optionAssertions.assertConfigFileSearch,
	  caller: _optionAssertions.assertCallerMetadata,
	  filename: _optionAssertions.assertString,
	  filenameRelative: _optionAssertions.assertString,
	  code: _optionAssertions.assertBoolean,
	  ast: _optionAssertions.assertBoolean,
	  cloneInputAst: _optionAssertions.assertBoolean,
	  envName: _optionAssertions.assertString
	};
	const BABELRC_VALIDATORS = {
	  babelrc: _optionAssertions.assertBoolean,
	  babelrcRoots: _optionAssertions.assertBabelrcSearch
	};
	const NONPRESET_VALIDATORS = {
	  extends: _optionAssertions.assertString,
	  ignore: _optionAssertions.assertIgnoreList,
	  only: _optionAssertions.assertIgnoreList,
	  targets: _optionAssertions.assertTargets,
	  browserslistConfigFile: _optionAssertions.assertConfigFileSearch,
	  browserslistEnv: _optionAssertions.assertString
	};
	const COMMON_VALIDATORS = {
	  inputSourceMap: _optionAssertions.assertInputSourceMap,
	  presets: _optionAssertions.assertPluginList,
	  plugins: _optionAssertions.assertPluginList,
	  passPerPreset: _optionAssertions.assertBoolean,
	  assumptions: _optionAssertions.assertAssumptions,
	  env: assertEnvSet,
	  overrides: assertOverridesList,
	  test: _optionAssertions.assertConfigApplicableTest,
	  include: _optionAssertions.assertConfigApplicableTest,
	  exclude: _optionAssertions.assertConfigApplicableTest,
	  retainLines: _optionAssertions.assertBoolean,
	  comments: _optionAssertions.assertBoolean,
	  shouldPrintComment: _optionAssertions.assertFunction,
	  compact: _optionAssertions.assertCompact,
	  minified: _optionAssertions.assertBoolean,
	  auxiliaryCommentBefore: _optionAssertions.assertString,
	  auxiliaryCommentAfter: _optionAssertions.assertString,
	  sourceType: _optionAssertions.assertSourceType,
	  wrapPluginVisitorMethod: _optionAssertions.assertFunction,
	  highlightCode: _optionAssertions.assertBoolean,
	  sourceMaps: _optionAssertions.assertSourceMaps,
	  sourceMap: _optionAssertions.assertSourceMaps,
	  sourceFileName: _optionAssertions.assertString,
	  sourceRoot: _optionAssertions.assertString,
	  parserOpts: _optionAssertions.assertObject,
	  generatorOpts: _optionAssertions.assertObject
	};
	{
	  Object.assign(COMMON_VALIDATORS, {
	    getModuleId: _optionAssertions.assertFunction,
	    moduleRoot: _optionAssertions.assertString,
	    moduleIds: _optionAssertions.assertBoolean,
	    moduleId: _optionAssertions.assertString
	  });
	}
	const knownAssumptions = ["arrayLikeIsIterable", "constantReexports", "constantSuper", "enumerableModuleMeta", "ignoreFunctionLength", "ignoreToPrimitiveHint", "iterableIsArray", "mutableTemplateObject", "noClassCalls", "noDocumentAll", "noIncompleteNsImportDetection", "noNewArrows", "noUninitializedPrivateFieldAccess", "objectRestNoSymbols", "privateFieldsAsSymbols", "privateFieldsAsProperties", "pureGetters", "setClassMethods", "setComputedProperties", "setPublicClassFields", "setSpreadProperties", "skipForOfIteratorClosing", "superIsCallableConstructor"];
	options.assumptionsNames = new Set(knownAssumptions);
	function getSource(loc) {
	  return loc.type === "root" ? loc.source : getSource(loc.parent);
	}
	function validate(type, opts, filename) {
	  try {
	    return validateNested({
	      type: "root",
	      source: type
	    }, opts);
	  } catch (error) {
	    const configError = new _configError.default(error.message, filename);
	    if (error.code) configError.code = error.code;
	    throw configError;
	  }
	}
	function validateNested(loc, opts) {
	  const type = getSource(loc);
	  assertNoDuplicateSourcemap(opts);
	  Object.keys(opts).forEach(key => {
	    const optLoc = {
	      type: "option",
	      name: key,
	      parent: loc
	    };
	    if (type === "preset" && NONPRESET_VALIDATORS[key]) {
	      throw new Error(`${(0, _optionAssertions.msg)(optLoc)} is not allowed in preset options`);
	    }
	    if (type !== "arguments" && ROOT_VALIDATORS[key]) {
	      throw new Error(`${(0, _optionAssertions.msg)(optLoc)} is only allowed in root programmatic options`);
	    }
	    if (type !== "arguments" && type !== "configfile" && BABELRC_VALIDATORS[key]) {
	      if (type === "babelrcfile" || type === "extendsfile") {
	        throw new Error(`${(0, _optionAssertions.msg)(optLoc)} is not allowed in .babelrc or "extends"ed files, only in root programmatic options, ` + `or babel.config.js/config file options`);
	      }
	      throw new Error(`${(0, _optionAssertions.msg)(optLoc)} is only allowed in root programmatic options, or babel.config.js/config file options`);
	    }
	    const validator = COMMON_VALIDATORS[key] || NONPRESET_VALIDATORS[key] || BABELRC_VALIDATORS[key] || ROOT_VALIDATORS[key] || throwUnknownError;
	    validator(optLoc, opts[key]);
	  });
	  return opts;
	}
	function throwUnknownError(loc) {
	  const key = loc.name;
	  if (_removed.default[key]) {
	    const {
	      message,
	      version = 5
	    } = _removed.default[key];
	    throw new Error(`Using removed Babel ${version} option: ${(0, _optionAssertions.msg)(loc)} - ${message}`);
	  } else {
	    const unknownOptErr = new Error(`Unknown option: ${(0, _optionAssertions.msg)(loc)}. Check out https://babeljs.io/docs/en/babel-core/#options for more information about options.`);
	    unknownOptErr.code = "BABEL_UNKNOWN_OPTION";
	    throw unknownOptErr;
	  }
	}
	function assertNoDuplicateSourcemap(opts) {
	  if (hasOwnProperty.call(opts, "sourceMap") && hasOwnProperty.call(opts, "sourceMaps")) {
	    throw new Error(".sourceMap is an alias for .sourceMaps, cannot use both");
	  }
	}
	function assertEnvSet(loc, value) {
	  if (loc.parent.type === "env") {
	    throw new Error(`${(0, _optionAssertions.msg)(loc)} is not allowed inside of another .env block`);
	  }
	  const parent = loc.parent;
	  const obj = (0, _optionAssertions.assertObject)(loc, value);
	  if (obj) {
	    for (const envName of Object.keys(obj)) {
	      const env = (0, _optionAssertions.assertObject)((0, _optionAssertions.access)(loc, envName), obj[envName]);
	      if (!env) continue;
	      const envLoc = {
	        type: "env",
	        name: envName,
	        parent
	      };
	      validateNested(envLoc, env);
	    }
	  }
	  return obj;
	}
	function assertOverridesList(loc, value) {
	  if (loc.parent.type === "env") {
	    throw new Error(`${(0, _optionAssertions.msg)(loc)} is not allowed inside an .env block`);
	  }
	  if (loc.parent.type === "overrides") {
	    throw new Error(`${(0, _optionAssertions.msg)(loc)} is not allowed inside an .overrides block`);
	  }
	  const parent = loc.parent;
	  const arr = (0, _optionAssertions.assertArray)(loc, value);
	  if (arr) {
	    for (const [index, item] of arr.entries()) {
	      const objLoc = (0, _optionAssertions.access)(loc, index);
	      const env = (0, _optionAssertions.assertObject)(objLoc, item);
	      if (!env) throw new Error(`${(0, _optionAssertions.msg)(objLoc)} must be an object`);
	      const overridesLoc = {
	        type: "overrides",
	        index,
	        parent
	      };
	      validateNested(overridesLoc, env);
	    }
	  }
	  return arr;
	}
	function checkNoUnwrappedItemOptionPairs(items, index, type, e) {
	  if (index === 0) return;
	  const lastItem = items[index - 1];
	  const thisItem = items[index];
	  if (lastItem.file && lastItem.options === undefined && typeof thisItem.value === "object") {
	    e.message += `\n- Maybe you meant to use\n` + `"${type}s": [\n  ["${lastItem.file.request}", ${JSON.stringify(thisItem.value, undefined, 2)}]\n]\n` + `To be a valid ${type}, its name and options should be wrapped in a pair of brackets`;
	  }
	}

	
	return options;
}

var patternToRegex = {};

Object.defineProperty(patternToRegex, "__esModule", {
  value: true
});
patternToRegex.default = pathToPattern;
function _path$2() {
  const data = path__default["default"];
  _path$2 = function () {
    return data;
  };
  return data;
}
const sep = `\\${_path$2().sep}`;
const endSep = `(?:${sep}|$)`;
const substitution = `[^${sep}]+`;
const starPat = `(?:${substitution}${sep})`;
const starPatLast = `(?:${substitution}${endSep})`;
const starStarPat = `${starPat}*?`;
const starStarPatLast = `${starPat}*?${starPatLast}?`;
function escapeRegExp(string) {
  return string.replace(/[|\\{}()[\]^$+*?.]/g, "\\$&");
}
function pathToPattern(pattern, dirname) {
  const parts = _path$2().resolve(dirname, pattern).split(_path$2().sep);
  return new RegExp(["^", ...parts.map((part, i) => {
    const last = i === parts.length - 1;
    if (part === "**") return last ? starStarPatLast : starStarPat;
    if (part === "*") return last ? starPatLast : starPat;
    if (part.indexOf("*.") === 0) {
      return substitution + escapeRegExp(part.slice(1)) + (last ? endSep : sep);
    }
    return escapeRegExp(part) + (last ? endSep : sep);
  })].join(""));
}

var printer = {};

Object.defineProperty(printer, "__esModule", {
  value: true
});
printer.ConfigPrinter = printer.ChainFormatter = void 0;
function _gensync() {
  const data = requireGensync();
  _gensync = function () {
    return data;
  };
  return data;
}
const ChainFormatter = printer.ChainFormatter = {
  Programmatic: 0,
  Config: 1
};
const Formatter = {
  title(type, callerName, filepath) {
    let title = "";
    if (type === ChainFormatter.Programmatic) {
      title = "programmatic options";
      if (callerName) {
        title += " from " + callerName;
      }
    } else {
      title = "config " + filepath;
    }
    return title;
  },
  loc(index, envName) {
    let loc = "";
    if (index != null) {
      loc += `.overrides[${index}]`;
    }
    if (envName != null) {
      loc += `.env["${envName}"]`;
    }
    return loc;
  },
  *optionsAndDescriptors(opt) {
    const content = Object.assign({}, opt.options);
    delete content.overrides;
    delete content.env;
    const pluginDescriptors = [...(yield* opt.plugins())];
    if (pluginDescriptors.length) {
      content.plugins = pluginDescriptors.map(d => descriptorToConfig(d));
    }
    const presetDescriptors = [...(yield* opt.presets())];
    if (presetDescriptors.length) {
      content.presets = [...presetDescriptors].map(d => descriptorToConfig(d));
    }
    return JSON.stringify(content, undefined, 2);
  }
};
function descriptorToConfig(d) {
  var _d$file;
  let name = (_d$file = d.file) == null ? void 0 : _d$file.request;
  if (name == null) {
    if (typeof d.value === "object") {
      name = d.value;
    } else if (typeof d.value === "function") {
      name = `[Function: ${d.value.toString().slice(0, 50)} ... ]`;
    }
  }
  if (name == null) {
    name = "[Unknown]";
  }
  if (d.options === undefined) {
    return name;
  } else if (d.name == null) {
    return [name, d.options];
  } else {
    return [name, d.options, d.name];
  }
}
class ConfigPrinter {
  constructor() {
    this._stack = [];
  }
  configure(enabled, type, {
    callerName,
    filepath
  }) {
    if (!enabled) return () => {};
    return (content, index, envName) => {
      this._stack.push({
        type,
        callerName,
        filepath,
        content,
        index,
        envName
      });
    };
  }
  static *format(config) {
    let title = Formatter.title(config.type, config.callerName, config.filepath);
    const loc = Formatter.loc(config.index, config.envName);
    if (loc) title += ` ${loc}`;
    const content = yield* Formatter.optionsAndDescriptors(config.content);
    return `${title}\n${content}`;
  }
  *output() {
    if (this._stack.length === 0) return "";
    const configs = yield* _gensync().all(this._stack.map(s => ConfigPrinter.format(s)));
    return configs.join("\n\n");
  }
}
printer.ConfigPrinter = ConfigPrinter;

var hasRequiredConfigChain;

function requireConfigChain () {
	if (hasRequiredConfigChain) return configChain;
	hasRequiredConfigChain = 1;

	Object.defineProperty(configChain, "__esModule", {
	  value: true
	});
	configChain.buildPresetChain = buildPresetChain;
	configChain.buildPresetChainWalker = void 0;
	configChain.buildRootChain = buildRootChain;
	function _path() {
	  const data = path__default["default"];
	  _path = function () {
	    return data;
	  };
	  return data;
	}
	function _debug() {
	  const data = srcExports;
	  _debug = function () {
	    return data;
	  };
	  return data;
	}
	var _options = requireOptions();
	var _patternToRegex = patternToRegex;
	var _printer = printer;
	var _rewriteStackTrace = rewriteStackTrace;
	var _configError = configError;
	var _index = requireFiles();
	var _caching = caching;
	var _configDescriptors = requireConfigDescriptors();
	const debug = _debug()("babel:config:config-chain");
	function* buildPresetChain(arg, context) {
	  const chain = yield* buildPresetChainWalker(arg, context);
	  if (!chain) return null;
	  return {
	    plugins: dedupDescriptors(chain.plugins),
	    presets: dedupDescriptors(chain.presets),
	    options: chain.options.map(o => normalizeOptions(o)),
	    files: new Set()
	  };
	}
	const buildPresetChainWalker = configChain.buildPresetChainWalker = makeChainWalker({
	  root: preset => loadPresetDescriptors(preset),
	  env: (preset, envName) => loadPresetEnvDescriptors(preset)(envName),
	  overrides: (preset, index) => loadPresetOverridesDescriptors(preset)(index),
	  overridesEnv: (preset, index, envName) => loadPresetOverridesEnvDescriptors(preset)(index)(envName),
	  createLogger: () => () => {}
	});
	const loadPresetDescriptors = (0, _caching.makeWeakCacheSync)(preset => buildRootDescriptors(preset, preset.alias, _configDescriptors.createUncachedDescriptors));
	const loadPresetEnvDescriptors = (0, _caching.makeWeakCacheSync)(preset => (0, _caching.makeStrongCacheSync)(envName => buildEnvDescriptors(preset, preset.alias, _configDescriptors.createUncachedDescriptors, envName)));
	const loadPresetOverridesDescriptors = (0, _caching.makeWeakCacheSync)(preset => (0, _caching.makeStrongCacheSync)(index => buildOverrideDescriptors(preset, preset.alias, _configDescriptors.createUncachedDescriptors, index)));
	const loadPresetOverridesEnvDescriptors = (0, _caching.makeWeakCacheSync)(preset => (0, _caching.makeStrongCacheSync)(index => (0, _caching.makeStrongCacheSync)(envName => buildOverrideEnvDescriptors(preset, preset.alias, _configDescriptors.createUncachedDescriptors, index, envName))));
	function* buildRootChain(opts, context) {
	  let configReport, babelRcReport;
	  const programmaticLogger = new _printer.ConfigPrinter();
	  const programmaticChain = yield* loadProgrammaticChain({
	    options: opts,
	    dirname: context.cwd
	  }, context, undefined, programmaticLogger);
	  if (!programmaticChain) return null;
	  const programmaticReport = yield* programmaticLogger.output();
	  let configFile;
	  if (typeof opts.configFile === "string") {
	    configFile = yield* (0, _index.loadConfig)(opts.configFile, context.cwd, context.envName, context.caller);
	  } else if (opts.configFile !== false) {
	    configFile = yield* (0, _index.findRootConfig)(context.root, context.envName, context.caller);
	  }
	  let {
	    babelrc,
	    babelrcRoots
	  } = opts;
	  let babelrcRootsDirectory = context.cwd;
	  const configFileChain = emptyChain();
	  const configFileLogger = new _printer.ConfigPrinter();
	  if (configFile) {
	    const validatedFile = validateConfigFile(configFile);
	    const result = yield* loadFileChain(validatedFile, context, undefined, configFileLogger);
	    if (!result) return null;
	    configReport = yield* configFileLogger.output();
	    if (babelrc === undefined) {
	      babelrc = validatedFile.options.babelrc;
	    }
	    if (babelrcRoots === undefined) {
	      babelrcRootsDirectory = validatedFile.dirname;
	      babelrcRoots = validatedFile.options.babelrcRoots;
	    }
	    mergeChain(configFileChain, result);
	  }
	  let ignoreFile, babelrcFile;
	  let isIgnored = false;
	  const fileChain = emptyChain();
	  if ((babelrc === true || babelrc === undefined) && typeof context.filename === "string") {
	    const pkgData = yield* (0, _index.findPackageData)(context.filename);
	    if (pkgData && babelrcLoadEnabled(context, pkgData, babelrcRoots, babelrcRootsDirectory)) {
	      ({
	        ignore: ignoreFile,
	        config: babelrcFile
	      } = yield* (0, _index.findRelativeConfig)(pkgData, context.envName, context.caller));
	      if (ignoreFile) {
	        fileChain.files.add(ignoreFile.filepath);
	      }
	      if (ignoreFile && shouldIgnore(context, ignoreFile.ignore, null, ignoreFile.dirname)) {
	        isIgnored = true;
	      }
	      if (babelrcFile && !isIgnored) {
	        const validatedFile = validateBabelrcFile(babelrcFile);
	        const babelrcLogger = new _printer.ConfigPrinter();
	        const result = yield* loadFileChain(validatedFile, context, undefined, babelrcLogger);
	        if (!result) {
	          isIgnored = true;
	        } else {
	          babelRcReport = yield* babelrcLogger.output();
	          mergeChain(fileChain, result);
	        }
	      }
	      if (babelrcFile && isIgnored) {
	        fileChain.files.add(babelrcFile.filepath);
	      }
	    }
	  }
	  if (context.showConfig) {
	    console.log(`Babel configs on "${context.filename}" (ascending priority):\n` + [configReport, babelRcReport, programmaticReport].filter(x => !!x).join("\n\n") + "\n-----End Babel configs-----");
	  }
	  const chain = mergeChain(mergeChain(mergeChain(emptyChain(), configFileChain), fileChain), programmaticChain);
	  return {
	    plugins: isIgnored ? [] : dedupDescriptors(chain.plugins),
	    presets: isIgnored ? [] : dedupDescriptors(chain.presets),
	    options: isIgnored ? [] : chain.options.map(o => normalizeOptions(o)),
	    fileHandling: isIgnored ? "ignored" : "transpile",
	    ignore: ignoreFile || undefined,
	    babelrc: babelrcFile || undefined,
	    config: configFile || undefined,
	    files: chain.files
	  };
	}
	function babelrcLoadEnabled(context, pkgData, babelrcRoots, babelrcRootsDirectory) {
	  if (typeof babelrcRoots === "boolean") return babelrcRoots;
	  const absoluteRoot = context.root;
	  if (babelrcRoots === undefined) {
	    return pkgData.directories.indexOf(absoluteRoot) !== -1;
	  }
	  let babelrcPatterns = babelrcRoots;
	  if (!Array.isArray(babelrcPatterns)) {
	    babelrcPatterns = [babelrcPatterns];
	  }
	  babelrcPatterns = babelrcPatterns.map(pat => {
	    return typeof pat === "string" ? _path().resolve(babelrcRootsDirectory, pat) : pat;
	  });
	  if (babelrcPatterns.length === 1 && babelrcPatterns[0] === absoluteRoot) {
	    return pkgData.directories.indexOf(absoluteRoot) !== -1;
	  }
	  return babelrcPatterns.some(pat => {
	    if (typeof pat === "string") {
	      pat = (0, _patternToRegex.default)(pat, babelrcRootsDirectory);
	    }
	    return pkgData.directories.some(directory => {
	      return matchPattern(pat, babelrcRootsDirectory, directory, context);
	    });
	  });
	}
	const validateConfigFile = (0, _caching.makeWeakCacheSync)(file => ({
	  filepath: file.filepath,
	  dirname: file.dirname,
	  options: (0, _options.validate)("configfile", file.options, file.filepath)
	}));
	const validateBabelrcFile = (0, _caching.makeWeakCacheSync)(file => ({
	  filepath: file.filepath,
	  dirname: file.dirname,
	  options: (0, _options.validate)("babelrcfile", file.options, file.filepath)
	}));
	const validateExtendFile = (0, _caching.makeWeakCacheSync)(file => ({
	  filepath: file.filepath,
	  dirname: file.dirname,
	  options: (0, _options.validate)("extendsfile", file.options, file.filepath)
	}));
	const loadProgrammaticChain = makeChainWalker({
	  root: input => buildRootDescriptors(input, "base", _configDescriptors.createCachedDescriptors),
	  env: (input, envName) => buildEnvDescriptors(input, "base", _configDescriptors.createCachedDescriptors, envName),
	  overrides: (input, index) => buildOverrideDescriptors(input, "base", _configDescriptors.createCachedDescriptors, index),
	  overridesEnv: (input, index, envName) => buildOverrideEnvDescriptors(input, "base", _configDescriptors.createCachedDescriptors, index, envName),
	  createLogger: (input, context, baseLogger) => buildProgrammaticLogger(input, context, baseLogger)
	});
	const loadFileChainWalker = makeChainWalker({
	  root: file => loadFileDescriptors(file),
	  env: (file, envName) => loadFileEnvDescriptors(file)(envName),
	  overrides: (file, index) => loadFileOverridesDescriptors(file)(index),
	  overridesEnv: (file, index, envName) => loadFileOverridesEnvDescriptors(file)(index)(envName),
	  createLogger: (file, context, baseLogger) => buildFileLogger(file.filepath, context, baseLogger)
	});
	function* loadFileChain(input, context, files, baseLogger) {
	  const chain = yield* loadFileChainWalker(input, context, files, baseLogger);
	  chain == null || chain.files.add(input.filepath);
	  return chain;
	}
	const loadFileDescriptors = (0, _caching.makeWeakCacheSync)(file => buildRootDescriptors(file, file.filepath, _configDescriptors.createUncachedDescriptors));
	const loadFileEnvDescriptors = (0, _caching.makeWeakCacheSync)(file => (0, _caching.makeStrongCacheSync)(envName => buildEnvDescriptors(file, file.filepath, _configDescriptors.createUncachedDescriptors, envName)));
	const loadFileOverridesDescriptors = (0, _caching.makeWeakCacheSync)(file => (0, _caching.makeStrongCacheSync)(index => buildOverrideDescriptors(file, file.filepath, _configDescriptors.createUncachedDescriptors, index)));
	const loadFileOverridesEnvDescriptors = (0, _caching.makeWeakCacheSync)(file => (0, _caching.makeStrongCacheSync)(index => (0, _caching.makeStrongCacheSync)(envName => buildOverrideEnvDescriptors(file, file.filepath, _configDescriptors.createUncachedDescriptors, index, envName))));
	function buildFileLogger(filepath, context, baseLogger) {
	  if (!baseLogger) {
	    return () => {};
	  }
	  return baseLogger.configure(context.showConfig, _printer.ChainFormatter.Config, {
	    filepath
	  });
	}
	function buildRootDescriptors({
	  dirname,
	  options
	}, alias, descriptors) {
	  return descriptors(dirname, options, alias);
	}
	function buildProgrammaticLogger(_, context, baseLogger) {
	  var _context$caller;
	  if (!baseLogger) {
	    return () => {};
	  }
	  return baseLogger.configure(context.showConfig, _printer.ChainFormatter.Programmatic, {
	    callerName: (_context$caller = context.caller) == null ? void 0 : _context$caller.name
	  });
	}
	function buildEnvDescriptors({
	  dirname,
	  options
	}, alias, descriptors, envName) {
	  var _options$env;
	  const opts = (_options$env = options.env) == null ? void 0 : _options$env[envName];
	  return opts ? descriptors(dirname, opts, `${alias}.env["${envName}"]`) : null;
	}
	function buildOverrideDescriptors({
	  dirname,
	  options
	}, alias, descriptors, index) {
	  var _options$overrides;
	  const opts = (_options$overrides = options.overrides) == null ? void 0 : _options$overrides[index];
	  if (!opts) throw new Error("Assertion failure - missing override");
	  return descriptors(dirname, opts, `${alias}.overrides[${index}]`);
	}
	function buildOverrideEnvDescriptors({
	  dirname,
	  options
	}, alias, descriptors, index, envName) {
	  var _options$overrides2, _override$env;
	  const override = (_options$overrides2 = options.overrides) == null ? void 0 : _options$overrides2[index];
	  if (!override) throw new Error("Assertion failure - missing override");
	  const opts = (_override$env = override.env) == null ? void 0 : _override$env[envName];
	  return opts ? descriptors(dirname, opts, `${alias}.overrides[${index}].env["${envName}"]`) : null;
	}
	function makeChainWalker({
	  root,
	  env,
	  overrides,
	  overridesEnv,
	  createLogger
	}) {
	  return function* chainWalker(input, context, files = new Set(), baseLogger) {
	    const {
	      dirname
	    } = input;
	    const flattenedConfigs = [];
	    const rootOpts = root(input);
	    if (configIsApplicable(rootOpts, dirname, context, input.filepath)) {
	      flattenedConfigs.push({
	        config: rootOpts,
	        envName: undefined,
	        index: undefined
	      });
	      const envOpts = env(input, context.envName);
	      if (envOpts && configIsApplicable(envOpts, dirname, context, input.filepath)) {
	        flattenedConfigs.push({
	          config: envOpts,
	          envName: context.envName,
	          index: undefined
	        });
	      }
	      (rootOpts.options.overrides || []).forEach((_, index) => {
	        const overrideOps = overrides(input, index);
	        if (configIsApplicable(overrideOps, dirname, context, input.filepath)) {
	          flattenedConfigs.push({
	            config: overrideOps,
	            index,
	            envName: undefined
	          });
	          const overrideEnvOpts = overridesEnv(input, index, context.envName);
	          if (overrideEnvOpts && configIsApplicable(overrideEnvOpts, dirname, context, input.filepath)) {
	            flattenedConfigs.push({
	              config: overrideEnvOpts,
	              index,
	              envName: context.envName
	            });
	          }
	        }
	      });
	    }
	    if (flattenedConfigs.some(({
	      config: {
	        options: {
	          ignore,
	          only
	        }
	      }
	    }) => shouldIgnore(context, ignore, only, dirname))) {
	      return null;
	    }
	    const chain = emptyChain();
	    const logger = createLogger(input, context, baseLogger);
	    for (const {
	      config,
	      index,
	      envName
	    } of flattenedConfigs) {
	      if (!(yield* mergeExtendsChain(chain, config.options, dirname, context, files, baseLogger))) {
	        return null;
	      }
	      logger(config, index, envName);
	      yield* mergeChainOpts(chain, config);
	    }
	    return chain;
	  };
	}
	function* mergeExtendsChain(chain, opts, dirname, context, files, baseLogger) {
	  if (opts.extends === undefined) return true;
	  const file = yield* (0, _index.loadConfig)(opts.extends, dirname, context.envName, context.caller);
	  if (files.has(file)) {
	    throw new Error(`Configuration cycle detected loading ${file.filepath}.\n` + `File already loaded following the config chain:\n` + Array.from(files, file => ` - ${file.filepath}`).join("\n"));
	  }
	  files.add(file);
	  const fileChain = yield* loadFileChain(validateExtendFile(file), context, files, baseLogger);
	  files.delete(file);
	  if (!fileChain) return false;
	  mergeChain(chain, fileChain);
	  return true;
	}
	function mergeChain(target, source) {
	  target.options.push(...source.options);
	  target.plugins.push(...source.plugins);
	  target.presets.push(...source.presets);
	  for (const file of source.files) {
	    target.files.add(file);
	  }
	  return target;
	}
	function* mergeChainOpts(target, {
	  options,
	  plugins,
	  presets
	}) {
	  target.options.push(options);
	  target.plugins.push(...(yield* plugins()));
	  target.presets.push(...(yield* presets()));
	  return target;
	}
	function emptyChain() {
	  return {
	    options: [],
	    presets: [],
	    plugins: [],
	    files: new Set()
	  };
	}
	function normalizeOptions(opts) {
	  const options = Object.assign({}, opts);
	  delete options.extends;
	  delete options.env;
	  delete options.overrides;
	  delete options.plugins;
	  delete options.presets;
	  delete options.passPerPreset;
	  delete options.ignore;
	  delete options.only;
	  delete options.test;
	  delete options.include;
	  delete options.exclude;
	  if (hasOwnProperty.call(options, "sourceMap")) {
	    options.sourceMaps = options.sourceMap;
	    delete options.sourceMap;
	  }
	  return options;
	}
	function dedupDescriptors(items) {
	  const map = new Map();
	  const descriptors = [];
	  for (const item of items) {
	    if (typeof item.value === "function") {
	      const fnKey = item.value;
	      let nameMap = map.get(fnKey);
	      if (!nameMap) {
	        nameMap = new Map();
	        map.set(fnKey, nameMap);
	      }
	      let desc = nameMap.get(item.name);
	      if (!desc) {
	        desc = {
	          value: item
	        };
	        descriptors.push(desc);
	        if (!item.ownPass) nameMap.set(item.name, desc);
	      } else {
	        desc.value = item;
	      }
	    } else {
	      descriptors.push({
	        value: item
	      });
	    }
	  }
	  return descriptors.reduce((acc, desc) => {
	    acc.push(desc.value);
	    return acc;
	  }, []);
	}
	function configIsApplicable({
	  options
	}, dirname, context, configName) {
	  return (options.test === undefined || configFieldIsApplicable(context, options.test, dirname, configName)) && (options.include === undefined || configFieldIsApplicable(context, options.include, dirname, configName)) && (options.exclude === undefined || !configFieldIsApplicable(context, options.exclude, dirname, configName));
	}
	function configFieldIsApplicable(context, test, dirname, configName) {
	  const patterns = Array.isArray(test) ? test : [test];
	  return matchesPatterns(context, patterns, dirname, configName);
	}
	function ignoreListReplacer(_key, value) {
	  if (value instanceof RegExp) {
	    return String(value);
	  }
	  return value;
	}
	function shouldIgnore(context, ignore, only, dirname) {
	  if (ignore && matchesPatterns(context, ignore, dirname)) {
	    var _context$filename;
	    const message = `No config is applied to "${(_context$filename = context.filename) != null ? _context$filename : "(unknown)"}" because it matches one of \`ignore: ${JSON.stringify(ignore, ignoreListReplacer)}\` from "${dirname}"`;
	    debug(message);
	    if (context.showConfig) {
	      console.log(message);
	    }
	    return true;
	  }
	  if (only && !matchesPatterns(context, only, dirname)) {
	    var _context$filename2;
	    const message = `No config is applied to "${(_context$filename2 = context.filename) != null ? _context$filename2 : "(unknown)"}" because it fails to match one of \`only: ${JSON.stringify(only, ignoreListReplacer)}\` from "${dirname}"`;
	    debug(message);
	    if (context.showConfig) {
	      console.log(message);
	    }
	    return true;
	  }
	  return false;
	}
	function matchesPatterns(context, patterns, dirname, configName) {
	  return patterns.some(pattern => matchPattern(pattern, dirname, context.filename, context, configName));
	}
	function matchPattern(pattern, dirname, pathToTest, context, configName) {
	  if (typeof pattern === "function") {
	    return !!(0, _rewriteStackTrace.endHiddenCallStack)(pattern)(pathToTest, {
	      dirname,
	      envName: context.envName,
	      caller: context.caller
	    });
	  }
	  if (typeof pathToTest !== "string") {
	    throw new _configError.default(`Configuration contains string/RegExp pattern, but no filename was passed to Babel`, configName);
	  }
	  if (typeof pattern === "string") {
	    pattern = (0, _patternToRegex.default)(pattern, dirname);
	  }
	  return pattern.test(pathToTest);
	}

	
	return configChain;
}

var plugins$1 = {};

Object.defineProperty(plugins$1, "__esModule", {
  value: true
});
plugins$1.validatePluginObject = validatePluginObject;
var _optionAssertions = requireOptionAssertions();
const VALIDATORS = {
  name: _optionAssertions.assertString,
  manipulateOptions: _optionAssertions.assertFunction,
  pre: _optionAssertions.assertFunction,
  post: _optionAssertions.assertFunction,
  inherits: _optionAssertions.assertFunction,
  visitor: assertVisitorMap,
  parserOverride: _optionAssertions.assertFunction,
  generatorOverride: _optionAssertions.assertFunction
};
function assertVisitorMap(loc, value) {
  const obj = (0, _optionAssertions.assertObject)(loc, value);
  if (obj) {
    Object.keys(obj).forEach(prop => {
      if (prop !== "_exploded" && prop !== "_verified") {
        assertVisitorHandler(prop, obj[prop]);
      }
    });
    if (obj.enter || obj.exit) {
      throw new Error(`${(0, _optionAssertions.msg)(loc)} cannot contain catch-all "enter" or "exit" handlers. Please target individual nodes.`);
    }
  }
  return obj;
}
function assertVisitorHandler(key, value) {
  if (value && typeof value === "object") {
    Object.keys(value).forEach(handler => {
      if (handler !== "enter" && handler !== "exit") {
        throw new Error(`.visitor["${key}"] may only have .enter and/or .exit handlers.`);
      }
    });
  } else if (typeof value !== "function") {
    throw new Error(`.visitor["${key}"] must be a function`);
  }
}
function validatePluginObject(obj) {
  const rootPath = {
    type: "root",
    source: "plugin"
  };
  Object.keys(obj).forEach(key => {
    const validator = VALIDATORS[key];
    if (validator) {
      const optLoc = {
        type: "option",
        name: key,
        parent: rootPath
      };
      validator(optLoc, obj[key]);
    } else {
      const invalidPluginPropertyError = new Error(`.${key} is not a valid Plugin property`);
      invalidPluginPropertyError.code = "BABEL_UNKNOWN_PLUGIN_PROPERTY";
      throw invalidPluginPropertyError;
    }
  });
  return obj;
}

var partial = {};

var environment = {};

Object.defineProperty(environment, "__esModule", {
  value: true
});
environment.getEnv = getEnv;
function getEnv(defaultValue = "development") {
  return process.env.BABEL_ENV || process.env.NODE_ENV || defaultValue;
}

var hasRequiredPartial;

function requirePartial () {
	if (hasRequiredPartial) return partial;
	hasRequiredPartial = 1;

	Object.defineProperty(partial, "__esModule", {
	  value: true
	});
	partial.default = loadPrivatePartialConfig;
	partial.loadPartialConfig = loadPartialConfig;
	function _path() {
	  const data = path__default["default"];
	  _path = function () {
	    return data;
	  };
	  return data;
	}
	var _plugin = plugin;
	var _util = util$2;
	var _item = requireItem();
	var _configChain = requireConfigChain();
	var _environment = environment;
	var _options = requireOptions();
	var _index = requireFiles();
	var _resolveTargets = resolveTargets$1;
	const _excluded = ["showIgnoredFiles"];
	function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
	function resolveRootMode(rootDir, rootMode) {
	  switch (rootMode) {
	    case "root":
	      return rootDir;
	    case "upward-optional":
	      {
	        const upwardRootDir = (0, _index.findConfigUpwards)(rootDir);
	        return upwardRootDir === null ? rootDir : upwardRootDir;
	      }
	    case "upward":
	      {
	        const upwardRootDir = (0, _index.findConfigUpwards)(rootDir);
	        if (upwardRootDir !== null) return upwardRootDir;
	        throw Object.assign(new Error(`Babel was run with rootMode:"upward" but a root could not ` + `be found when searching upward from "${rootDir}".\n` + `One of the following config files must be in the directory tree: ` + `"${_index.ROOT_CONFIG_FILENAMES.join(", ")}".`), {
	          code: "BABEL_ROOT_NOT_FOUND",
	          dirname: rootDir
	        });
	      }
	    default:
	      throw new Error(`Assertion failure - unknown rootMode value.`);
	  }
	}
	function* loadPrivatePartialConfig(inputOpts) {
	  if (inputOpts != null && (typeof inputOpts !== "object" || Array.isArray(inputOpts))) {
	    throw new Error("Babel options must be an object, null, or undefined");
	  }
	  const args = inputOpts ? (0, _options.validate)("arguments", inputOpts) : {};
	  const {
	    envName = (0, _environment.getEnv)(),
	    cwd = ".",
	    root: rootDir = ".",
	    rootMode = "root",
	    caller,
	    cloneInputAst = true
	  } = args;
	  const absoluteCwd = _path().resolve(cwd);
	  const absoluteRootDir = resolveRootMode(_path().resolve(absoluteCwd, rootDir), rootMode);
	  const filename = typeof args.filename === "string" ? _path().resolve(cwd, args.filename) : undefined;
	  const showConfigPath = yield* (0, _index.resolveShowConfigPath)(absoluteCwd);
	  const context = {
	    filename,
	    cwd: absoluteCwd,
	    root: absoluteRootDir,
	    envName,
	    caller,
	    showConfig: showConfigPath === filename
	  };
	  const configChain = yield* (0, _configChain.buildRootChain)(args, context);
	  if (!configChain) return null;
	  const merged = {
	    assumptions: {}
	  };
	  configChain.options.forEach(opts => {
	    (0, _util.mergeOptions)(merged, opts);
	  });
	  const options = Object.assign({}, merged, {
	    targets: (0, _resolveTargets.resolveTargets)(merged, absoluteRootDir),
	    cloneInputAst,
	    babelrc: false,
	    configFile: false,
	    browserslistConfigFile: false,
	    passPerPreset: false,
	    envName: context.envName,
	    cwd: context.cwd,
	    root: context.root,
	    rootMode: "root",
	    filename: typeof context.filename === "string" ? context.filename : undefined,
	    plugins: configChain.plugins.map(descriptor => (0, _item.createItemFromDescriptor)(descriptor)),
	    presets: configChain.presets.map(descriptor => (0, _item.createItemFromDescriptor)(descriptor))
	  });
	  return {
	    options,
	    context,
	    fileHandling: configChain.fileHandling,
	    ignore: configChain.ignore,
	    babelrc: configChain.babelrc,
	    config: configChain.config,
	    files: configChain.files
	  };
	}
	function* loadPartialConfig(opts) {
	  let showIgnoredFiles = false;
	  if (typeof opts === "object" && opts !== null && !Array.isArray(opts)) {
	    var _opts = opts;
	    ({
	      showIgnoredFiles
	    } = _opts);
	    opts = _objectWithoutPropertiesLoose(_opts, _excluded);
	  }
	  const result = yield* loadPrivatePartialConfig(opts);
	  if (!result) return null;
	  const {
	    options,
	    babelrc,
	    ignore,
	    config,
	    fileHandling,
	    files
	  } = result;
	  if (fileHandling === "ignored" && !showIgnoredFiles) {
	    return null;
	  }
	  (options.plugins || []).forEach(item => {
	    if (item.value instanceof _plugin.default) {
	      throw new Error("Passing cached plugin instances is not supported in " + "babel.loadPartialConfig()");
	    }
	  });
	  return new PartialConfig(options, babelrc ? babelrc.filepath : undefined, ignore ? ignore.filepath : undefined, config ? config.filepath : undefined, fileHandling, files);
	}
	class PartialConfig {
	  constructor(options, babelrc, ignore, config, fileHandling, files) {
	    this.options = void 0;
	    this.babelrc = void 0;
	    this.babelignore = void 0;
	    this.config = void 0;
	    this.fileHandling = void 0;
	    this.files = void 0;
	    this.options = options;
	    this.babelignore = ignore;
	    this.babelrc = babelrc;
	    this.config = config;
	    this.fileHandling = fileHandling;
	    this.files = files;
	    Object.freeze(this);
	  }
	  hasFilesystemConfig() {
	    return this.babelrc !== undefined || this.config !== undefined;
	  }
	}
	Object.freeze(PartialConfig.prototype);

	
	return partial;
}

var hasRequiredFull;

function requireFull () {
	if (hasRequiredFull) return full;
	hasRequiredFull = 1;

	Object.defineProperty(full, "__esModule", {
	  value: true
	});
	full.default = void 0;
	function _gensync() {
	  const data = requireGensync();
	  _gensync = function () {
	    return data;
	  };
	  return data;
	}
	var _async = async$2;
	var _util = util$2;
	var context = requireLib();
	var _plugin = plugin;
	var _item = requireItem();
	var _configChain = requireConfigChain();
	var _deepArray = deepArray;
	function _traverse() {
	  const data = requireLib$7();
	  _traverse = function () {
	    return data;
	  };
	  return data;
	}
	var _caching = caching;
	var _options = requireOptions();
	var _plugins = plugins$1;
	var _configApi = requireConfigApi();
	var _partial = requirePartial();
	var _configError = configError;
	full.default = _gensync()(function* loadFullConfig(inputOpts) {
	  var _opts$assumptions;
	  const result = yield* (0, _partial.default)(inputOpts);
	  if (!result) {
	    return null;
	  }
	  const {
	    options,
	    context,
	    fileHandling
	  } = result;
	  if (fileHandling === "ignored") {
	    return null;
	  }
	  const optionDefaults = {};
	  const {
	    plugins,
	    presets
	  } = options;
	  if (!plugins || !presets) {
	    throw new Error("Assertion failure - plugins and presets exist");
	  }
	  const presetContext = Object.assign({}, context, {
	    targets: options.targets
	  });
	  const toDescriptor = item => {
	    const desc = (0, _item.getItemDescriptor)(item);
	    if (!desc) {
	      throw new Error("Assertion failure - must be config item");
	    }
	    return desc;
	  };
	  const presetsDescriptors = presets.map(toDescriptor);
	  const initialPluginsDescriptors = plugins.map(toDescriptor);
	  const pluginDescriptorsByPass = [[]];
	  const passes = [];
	  const externalDependencies = [];
	  const ignored = yield* enhanceError(context, function* recursePresetDescriptors(rawPresets, pluginDescriptorsPass) {
	    const presets = [];
	    for (let i = 0; i < rawPresets.length; i++) {
	      const descriptor = rawPresets[i];
	      if (descriptor.options !== false) {
	        try {
	          var preset = yield* loadPresetDescriptor(descriptor, presetContext);
	        } catch (e) {
	          if (e.code === "BABEL_UNKNOWN_OPTION") {
	            (0, _options.checkNoUnwrappedItemOptionPairs)(rawPresets, i, "preset", e);
	          }
	          throw e;
	        }
	        externalDependencies.push(preset.externalDependencies);
	        if (descriptor.ownPass) {
	          presets.push({
	            preset: preset.chain,
	            pass: []
	          });
	        } else {
	          presets.unshift({
	            preset: preset.chain,
	            pass: pluginDescriptorsPass
	          });
	        }
	      }
	    }
	    if (presets.length > 0) {
	      pluginDescriptorsByPass.splice(1, 0, ...presets.map(o => o.pass).filter(p => p !== pluginDescriptorsPass));
	      for (const {
	        preset,
	        pass
	      } of presets) {
	        if (!preset) return true;
	        pass.push(...preset.plugins);
	        const ignored = yield* recursePresetDescriptors(preset.presets, pass);
	        if (ignored) return true;
	        preset.options.forEach(opts => {
	          (0, _util.mergeOptions)(optionDefaults, opts);
	        });
	      }
	    }
	  })(presetsDescriptors, pluginDescriptorsByPass[0]);
	  if (ignored) return null;
	  const opts = optionDefaults;
	  (0, _util.mergeOptions)(opts, options);
	  const pluginContext = Object.assign({}, presetContext, {
	    assumptions: (_opts$assumptions = opts.assumptions) != null ? _opts$assumptions : {}
	  });
	  yield* enhanceError(context, function* loadPluginDescriptors() {
	    pluginDescriptorsByPass[0].unshift(...initialPluginsDescriptors);
	    for (const descs of pluginDescriptorsByPass) {
	      const pass = [];
	      passes.push(pass);
	      for (let i = 0; i < descs.length; i++) {
	        const descriptor = descs[i];
	        if (descriptor.options !== false) {
	          try {
	            var plugin = yield* loadPluginDescriptor(descriptor, pluginContext);
	          } catch (e) {
	            if (e.code === "BABEL_UNKNOWN_PLUGIN_PROPERTY") {
	              (0, _options.checkNoUnwrappedItemOptionPairs)(descs, i, "plugin", e);
	            }
	            throw e;
	          }
	          pass.push(plugin);
	          externalDependencies.push(plugin.externalDependencies);
	        }
	      }
	    }
	  })();
	  opts.plugins = passes[0];
	  opts.presets = passes.slice(1).filter(plugins => plugins.length > 0).map(plugins => ({
	    plugins
	  }));
	  opts.passPerPreset = opts.presets.length > 0;
	  return {
	    options: opts,
	    passes: passes,
	    externalDependencies: (0, _deepArray.finalize)(externalDependencies)
	  };
	});
	function enhanceError(context, fn) {
	  return function* (arg1, arg2) {
	    try {
	      return yield* fn(arg1, arg2);
	    } catch (e) {
	      if (!/^\[BABEL\]/.test(e.message)) {
	        var _context$filename;
	        e.message = `[BABEL] ${(_context$filename = context.filename) != null ? _context$filename : "unknown file"}: ${e.message}`;
	      }
	      throw e;
	    }
	  };
	}
	const makeDescriptorLoader = apiFactory => (0, _caching.makeWeakCache)(function* ({
	  value,
	  options,
	  dirname,
	  alias
	}, cache) {
	  if (options === false) throw new Error("Assertion failure");
	  options = options || {};
	  const externalDependencies = [];
	  let item = value;
	  if (typeof value === "function") {
	    const factory = (0, _async.maybeAsync)(value, `You appear to be using an async plugin/preset, but Babel has been called synchronously`);
	    const api = Object.assign({}, context, apiFactory(cache, externalDependencies));
	    try {
	      item = yield* factory(api, options, dirname);
	    } catch (e) {
	      if (alias) {
	        e.message += ` (While processing: ${JSON.stringify(alias)})`;
	      }
	      throw e;
	    }
	  }
	  if (!item || typeof item !== "object") {
	    throw new Error("Plugin/Preset did not return an object.");
	  }
	  if ((0, _async.isThenable)(item)) {
	    yield* [];
	    throw new Error(`You appear to be using a promise as a plugin, ` + `which your current version of Babel does not support. ` + `If you're using a published plugin, ` + `you may need to upgrade your @babel/core version. ` + `As an alternative, you can prefix the promise with "await". ` + `(While processing: ${JSON.stringify(alias)})`);
	  }
	  if (externalDependencies.length > 0 && (!cache.configured() || cache.mode() === "forever")) {
	    let error = `A plugin/preset has external untracked dependencies ` + `(${externalDependencies[0]}), but the cache `;
	    if (!cache.configured()) {
	      error += `has not been configured to be invalidated when the external dependencies change. `;
	    } else {
	      error += ` has been configured to never be invalidated. `;
	    }
	    error += `Plugins/presets should configure their cache to be invalidated when the external ` + `dependencies change, for example using \`api.cache.invalidate(() => ` + `statSync(filepath).mtimeMs)\` or \`api.cache.never()\`\n` + `(While processing: ${JSON.stringify(alias)})`;
	    throw new Error(error);
	  }
	  return {
	    value: item,
	    options,
	    dirname,
	    alias,
	    externalDependencies: (0, _deepArray.finalize)(externalDependencies)
	  };
	});
	const pluginDescriptorLoader = makeDescriptorLoader(_configApi.makePluginAPI);
	const presetDescriptorLoader = makeDescriptorLoader(_configApi.makePresetAPI);
	const instantiatePlugin = (0, _caching.makeWeakCache)(function* ({
	  value,
	  options,
	  dirname,
	  alias,
	  externalDependencies
	}, cache) {
	  const pluginObj = (0, _plugins.validatePluginObject)(value);
	  const plugin = Object.assign({}, pluginObj);
	  if (plugin.visitor) {
	    plugin.visitor = _traverse().default.explode(Object.assign({}, plugin.visitor));
	  }
	  if (plugin.inherits) {
	    const inheritsDescriptor = {
	      name: undefined,
	      alias: `${alias}$inherits`,
	      value: plugin.inherits,
	      options,
	      dirname
	    };
	    const inherits = yield* (0, _async.forwardAsync)(loadPluginDescriptor, run => {
	      return cache.invalidate(data => run(inheritsDescriptor, data));
	    });
	    plugin.pre = chain(inherits.pre, plugin.pre);
	    plugin.post = chain(inherits.post, plugin.post);
	    plugin.manipulateOptions = chain(inherits.manipulateOptions, plugin.manipulateOptions);
	    plugin.visitor = _traverse().default.visitors.merge([inherits.visitor || {}, plugin.visitor || {}]);
	    if (inherits.externalDependencies.length > 0) {
	      if (externalDependencies.length === 0) {
	        externalDependencies = inherits.externalDependencies;
	      } else {
	        externalDependencies = (0, _deepArray.finalize)([externalDependencies, inherits.externalDependencies]);
	      }
	    }
	  }
	  return new _plugin.default(plugin, options, alias, externalDependencies);
	});
	function* loadPluginDescriptor(descriptor, context) {
	  if (descriptor.value instanceof _plugin.default) {
	    if (descriptor.options) {
	      throw new Error("Passed options to an existing Plugin instance will not work.");
	    }
	    return descriptor.value;
	  }
	  return yield* instantiatePlugin(yield* pluginDescriptorLoader(descriptor, context), context);
	}
	const needsFilename = val => val && typeof val !== "function";
	const validateIfOptionNeedsFilename = (options, descriptor) => {
	  if (needsFilename(options.test) || needsFilename(options.include) || needsFilename(options.exclude)) {
	    const formattedPresetName = descriptor.name ? `"${descriptor.name}"` : "/* your preset */";
	    throw new _configError.default([`Preset ${formattedPresetName} requires a filename to be set when babel is called directly,`, `\`\`\``, `babel.transformSync(code, { filename: 'file.ts', presets: [${formattedPresetName}] });`, `\`\`\``, `See https://babeljs.io/docs/en/options#filename for more information.`].join("\n"));
	  }
	};
	const validatePreset = (preset, context, descriptor) => {
	  if (!context.filename) {
	    var _options$overrides;
	    const {
	      options
	    } = preset;
	    validateIfOptionNeedsFilename(options, descriptor);
	    (_options$overrides = options.overrides) == null || _options$overrides.forEach(overrideOptions => validateIfOptionNeedsFilename(overrideOptions, descriptor));
	  }
	};
	const instantiatePreset = (0, _caching.makeWeakCacheSync)(({
	  value,
	  dirname,
	  alias,
	  externalDependencies
	}) => {
	  return {
	    options: (0, _options.validate)("preset", value),
	    alias,
	    dirname,
	    externalDependencies
	  };
	});
	function* loadPresetDescriptor(descriptor, context) {
	  const preset = instantiatePreset(yield* presetDescriptorLoader(descriptor, context));
	  validatePreset(preset, context, descriptor);
	  return {
	    chain: yield* (0, _configChain.buildPresetChain)(preset, context),
	    externalDependencies: preset.externalDependencies
	  };
	}
	function chain(a, b) {
	  const fns = [a, b].filter(Boolean);
	  if (fns.length <= 1) return fns[0];
	  return function (...args) {
	    for (const fn of fns) {
	      fn.apply(this, args);
	    }
	  };
	}

	
	return full;
}

var hasRequiredConfig;

function requireConfig () {
	if (hasRequiredConfig) return config$1;
	hasRequiredConfig = 1;
	(function (exports) {

		Object.defineProperty(exports, "__esModule", {
		  value: true
		});
		exports.createConfigItem = createConfigItem;
		exports.createConfigItemAsync = createConfigItemAsync;
		exports.createConfigItemSync = createConfigItemSync;
		Object.defineProperty(exports, "default", {
		  enumerable: true,
		  get: function () {
		    return _full.default;
		  }
		});
		exports.loadOptions = loadOptions;
		exports.loadOptionsAsync = loadOptionsAsync;
		exports.loadOptionsSync = loadOptionsSync;
		exports.loadPartialConfig = loadPartialConfig;
		exports.loadPartialConfigAsync = loadPartialConfigAsync;
		exports.loadPartialConfigSync = loadPartialConfigSync;
		function _gensync() {
		  const data = requireGensync();
		  _gensync = function () {
		    return data;
		  };
		  return data;
		}
		var _full = requireFull();
		var _partial = requirePartial();
		var _item = requireItem();
		var _rewriteStackTrace = rewriteStackTrace;
		const loadPartialConfigRunner = _gensync()(_partial.loadPartialConfig);
		function loadPartialConfigAsync(...args) {
		  return (0, _rewriteStackTrace.beginHiddenCallStack)(loadPartialConfigRunner.async)(...args);
		}
		function loadPartialConfigSync(...args) {
		  return (0, _rewriteStackTrace.beginHiddenCallStack)(loadPartialConfigRunner.sync)(...args);
		}
		function loadPartialConfig(opts, callback) {
		  if (callback !== undefined) {
		    (0, _rewriteStackTrace.beginHiddenCallStack)(loadPartialConfigRunner.errback)(opts, callback);
		  } else if (typeof opts === "function") {
		    (0, _rewriteStackTrace.beginHiddenCallStack)(loadPartialConfigRunner.errback)(undefined, opts);
		  } else {
		    {
		      return loadPartialConfigSync(opts);
		    }
		  }
		}
		function* loadOptionsImpl(opts) {
		  var _config$options;
		  const config = yield* (0, _full.default)(opts);
		  return (_config$options = config == null ? void 0 : config.options) != null ? _config$options : null;
		}
		const loadOptionsRunner = _gensync()(loadOptionsImpl);
		function loadOptionsAsync(...args) {
		  return (0, _rewriteStackTrace.beginHiddenCallStack)(loadOptionsRunner.async)(...args);
		}
		function loadOptionsSync(...args) {
		  return (0, _rewriteStackTrace.beginHiddenCallStack)(loadOptionsRunner.sync)(...args);
		}
		function loadOptions(opts, callback) {
		  if (callback !== undefined) {
		    (0, _rewriteStackTrace.beginHiddenCallStack)(loadOptionsRunner.errback)(opts, callback);
		  } else if (typeof opts === "function") {
		    (0, _rewriteStackTrace.beginHiddenCallStack)(loadOptionsRunner.errback)(undefined, opts);
		  } else {
		    {
		      return loadOptionsSync(opts);
		    }
		  }
		}
		const createConfigItemRunner = _gensync()(_item.createConfigItem);
		function createConfigItemAsync(...args) {
		  return (0, _rewriteStackTrace.beginHiddenCallStack)(createConfigItemRunner.async)(...args);
		}
		function createConfigItemSync(...args) {
		  return (0, _rewriteStackTrace.beginHiddenCallStack)(createConfigItemRunner.sync)(...args);
		}
		function createConfigItem(target, options, callback) {
		  if (callback !== undefined) {
		    (0, _rewriteStackTrace.beginHiddenCallStack)(createConfigItemRunner.errback)(target, options, callback);
		  } else if (typeof options === "function") {
		    (0, _rewriteStackTrace.beginHiddenCallStack)(createConfigItemRunner.errback)(target, undefined, callback);
		  } else {
		    {
		      return createConfigItemSync(target, options);
		    }
		  }
		}

		
	} (config$1));
	return config$1;
}

var transformation = {};

var pluginPass = {};

Object.defineProperty(pluginPass, "__esModule", {
  value: true
});
pluginPass.default = void 0;
class PluginPass {
  constructor(file, key, options) {
    this._map = new Map();
    this.key = void 0;
    this.file = void 0;
    this.opts = void 0;
    this.cwd = void 0;
    this.filename = void 0;
    this.key = key;
    this.file = file;
    this.opts = options || {};
    this.cwd = file.opts.cwd;
    this.filename = file.opts.filename;
  }
  set(key, val) {
    this._map.set(key, val);
  }
  get(key) {
    return this._map.get(key);
  }
  availableHelper(name, versionRange) {
    return this.file.availableHelper(name, versionRange);
  }
  addHelper(name) {
    return this.file.addHelper(name);
  }
  buildCodeFrameError(node, msg, _Error) {
    return this.file.buildCodeFrameError(node, msg, _Error);
  }
}
pluginPass.default = PluginPass;
{
  PluginPass.prototype.getModuleName = function getModuleName() {
    return this.file.getModuleName();
  };
  PluginPass.prototype.addImport = function addImport() {
    this.file.addImport();
  };
}

var blockHoistPlugin$1 = {};

Object.defineProperty(blockHoistPlugin$1, "__esModule", {
  value: true
});
blockHoistPlugin$1.default = loadBlockHoistPlugin;
function _traverse() {
  const data = requireLib$7();
  _traverse = function () {
    return data;
  };
  return data;
}
var _plugin = plugin;
let LOADED_PLUGIN;
const blockHoistPlugin = {
  name: "internal.blockHoist",
  visitor: {
    Block: {
      exit({
        node
      }) {
        node.body = performHoisting(node.body);
      }
    },
    SwitchCase: {
      exit({
        node
      }) {
        node.consequent = performHoisting(node.consequent);
      }
    }
  }
};
function performHoisting(body) {
  let max = Math.pow(2, 30) - 1;
  let hasChange = false;
  for (let i = 0; i < body.length; i++) {
    const n = body[i];
    const p = priority(n);
    if (p > max) {
      hasChange = true;
      break;
    }
    max = p;
  }
  if (!hasChange) return body;
  return stableSort(body.slice());
}
function loadBlockHoistPlugin() {
  if (!LOADED_PLUGIN) {
    LOADED_PLUGIN = new _plugin.default(Object.assign({}, blockHoistPlugin, {
      visitor: _traverse().default.explode(blockHoistPlugin.visitor)
    }), {});
  }
  return LOADED_PLUGIN;
}
function priority(bodyNode) {
  const priority = bodyNode == null ? void 0 : bodyNode._blockHoist;
  if (priority == null) return 1;
  if (priority === true) return 2;
  return priority;
}
function stableSort(body) {
  const buckets = Object.create(null);
  for (let i = 0; i < body.length; i++) {
    const n = body[i];
    const p = priority(n);
    const bucket = buckets[p] || (buckets[p] = []);
    bucket.push(n);
  }
  const keys = Object.keys(buckets).map(k => +k).sort((a, b) => b - a);
  let index = 0;
  for (const key of keys) {
    const bucket = buckets[key];
    for (const n of bucket) {
      body[index++] = n;
    }
  }
  return body;
}

var normalizeOpts = {};

Object.defineProperty(normalizeOpts, "__esModule", {
  value: true
});
normalizeOpts.default = normalizeOptions$3;
function _path$1() {
  const data = path__default["default"];
  _path$1 = function () {
    return data;
  };
  return data;
}
function normalizeOptions$3(config) {
  const {
    filename,
    cwd,
    filenameRelative = typeof filename === "string" ? _path$1().relative(cwd, filename) : "unknown",
    sourceType = "module",
    inputSourceMap,
    sourceMaps = !!inputSourceMap,
    sourceRoot = config.options.moduleRoot,
    sourceFileName = _path$1().basename(filenameRelative),
    comments = true,
    compact = "auto"
  } = config.options;
  const opts = config.options;
  const options = Object.assign({}, opts, {
    parserOpts: Object.assign({
      sourceType: _path$1().extname(filenameRelative) === ".mjs" ? "module" : sourceType,
      sourceFileName: filename,
      plugins: []
    }, opts.parserOpts),
    generatorOpts: Object.assign({
      filename,
      auxiliaryCommentBefore: opts.auxiliaryCommentBefore,
      auxiliaryCommentAfter: opts.auxiliaryCommentAfter,
      retainLines: opts.retainLines,
      comments,
      shouldPrintComment: opts.shouldPrintComment,
      compact,
      minified: opts.minified,
      sourceMaps,
      sourceRoot,
      sourceFileName
    }, opts.generatorOpts)
  });
  for (const plugins of config.passes) {
    for (const plugin of plugins) {
      if (plugin.manipulateOptions) {
        plugin.manipulateOptions(options, options.parserOpts);
      }
    }
  }
  return options;
}

var normalizeFile = {};

var convertSourceMap = {};

var hasRequiredConvertSourceMap;

function requireConvertSourceMap () {
	if (hasRequiredConvertSourceMap) return convertSourceMap;
	hasRequiredConvertSourceMap = 1;
	(function (exports) {

		Object.defineProperty(exports, 'commentRegex', {
		  get: function getCommentRegex () {
		    // Groups: 1: media type, 2: MIME type, 3: charset, 4: encoding, 5: data.
		    return /^\s*?\/[\/\*][@#]\s+?sourceMappingURL=data:(((?:application|text)\/json)(?:;charset=([^;,]+?)?)?)?(?:;(base64))?,(.*?)$/mg;
		  }
		});


		Object.defineProperty(exports, 'mapFileCommentRegex', {
		  get: function getMapFileCommentRegex () {
		    // Matches sourceMappingURL in either // or /* comment styles.
		    return /(?:\/\/[@#][ \t]+?sourceMappingURL=([^\s'"`]+?)[ \t]*?$)|(?:\/\*[@#][ \t]+sourceMappingURL=([^*]+?)[ \t]*?(?:\*\/){1}[ \t]*?$)/mg;
		  }
		});

		var decodeBase64;
		if (typeof Buffer !== 'undefined') {
		  if (typeof Buffer.from === 'function') {
		    decodeBase64 = decodeBase64WithBufferFrom;
		  } else {
		    decodeBase64 = decodeBase64WithNewBuffer;
		  }
		} else {
		  decodeBase64 = decodeBase64WithAtob;
		}

		function decodeBase64WithBufferFrom(base64) {
		  return Buffer.from(base64, 'base64').toString();
		}

		function decodeBase64WithNewBuffer(base64) {
		  if (typeof value === 'number') {
		    throw new TypeError('The value to decode must not be of type number.');
		  }
		  return new Buffer(base64, 'base64').toString();
		}

		function decodeBase64WithAtob(base64) {
		  return decodeURIComponent(escape(atob(base64)));
		}

		function stripComment(sm) {
		  return sm.split(',').pop();
		}

		function readFromFileMap(sm, read) {
		  var r = exports.mapFileCommentRegex.exec(sm);
		  // for some odd reason //# .. captures in 1 and /* .. */ in 2
		  var filename = r[1] || r[2];

		  try {
		    var sm = read(filename);
		    if (sm != null && typeof sm.catch === 'function') {
		      return sm.catch(throwError);
		    } else {
		      return sm;
		    }
		  } catch (e) {
		    throwError(e);
		  }

		  function throwError(e) {
		    throw new Error('An error occurred while trying to read the map file at ' + filename + '\n' + e.stack);
		  }
		}

		function Converter (sm, opts) {
		  opts = opts || {};

		  if (opts.hasComment) {
		    sm = stripComment(sm);
		  }

		  if (opts.encoding === 'base64') {
		    sm = decodeBase64(sm);
		  } else if (opts.encoding === 'uri') {
		    sm = decodeURIComponent(sm);
		  }

		  if (opts.isJSON || opts.encoding) {
		    sm = JSON.parse(sm);
		  }

		  this.sourcemap = sm;
		}

		Converter.prototype.toJSON = function (space) {
		  return JSON.stringify(this.sourcemap, null, space);
		};

		if (typeof Buffer !== 'undefined') {
		  if (typeof Buffer.from === 'function') {
		    Converter.prototype.toBase64 = encodeBase64WithBufferFrom;
		  } else {
		    Converter.prototype.toBase64 = encodeBase64WithNewBuffer;
		  }
		} else {
		  Converter.prototype.toBase64 = encodeBase64WithBtoa;
		}

		function encodeBase64WithBufferFrom() {
		  var json = this.toJSON();
		  return Buffer.from(json, 'utf8').toString('base64');
		}

		function encodeBase64WithNewBuffer() {
		  var json = this.toJSON();
		  if (typeof json === 'number') {
		    throw new TypeError('The json to encode must not be of type number.');
		  }
		  return new Buffer(json, 'utf8').toString('base64');
		}

		function encodeBase64WithBtoa() {
		  var json = this.toJSON();
		  return btoa(unescape(encodeURIComponent(json)));
		}

		Converter.prototype.toURI = function () {
		  var json = this.toJSON();
		  return encodeURIComponent(json);
		};

		Converter.prototype.toComment = function (options) {
		  var encoding, content, data;
		  if (options != null && options.encoding === 'uri') {
		    encoding = '';
		    content = this.toURI();
		  } else {
		    encoding = ';base64';
		    content = this.toBase64();
		  }
		  data = 'sourceMappingURL=data:application/json;charset=utf-8' + encoding + ',' + content;
		  return options != null && options.multiline ? '/*# ' + data + ' */' : '//# ' + data;
		};

		// returns copy instead of original
		Converter.prototype.toObject = function () {
		  return JSON.parse(this.toJSON());
		};

		Converter.prototype.addProperty = function (key, value) {
		  if (this.sourcemap.hasOwnProperty(key)) throw new Error('property "' + key + '" already exists on the sourcemap, use set property instead');
		  return this.setProperty(key, value);
		};

		Converter.prototype.setProperty = function (key, value) {
		  this.sourcemap[key] = value;
		  return this;
		};

		Converter.prototype.getProperty = function (key) {
		  return this.sourcemap[key];
		};

		exports.fromObject = function (obj) {
		  return new Converter(obj);
		};

		exports.fromJSON = function (json) {
		  return new Converter(json, { isJSON: true });
		};

		exports.fromURI = function (uri) {
		  return new Converter(uri, { encoding: 'uri' });
		};

		exports.fromBase64 = function (base64) {
		  return new Converter(base64, { encoding: 'base64' });
		};

		exports.fromComment = function (comment) {
		  var m, encoding;
		  comment = comment
		    .replace(/^\/\*/g, '//')
		    .replace(/\*\/$/g, '');
		  m = exports.commentRegex.exec(comment);
		  encoding = m && m[4] || 'uri';
		  return new Converter(comment, { encoding: encoding, hasComment: true });
		};

		function makeConverter(sm) {
		  return new Converter(sm, { isJSON: true });
		}

		exports.fromMapFileComment = function (comment, read) {
		  if (typeof read === 'string') {
		    throw new Error(
		      'String directory paths are no longer supported with `fromMapFileComment`\n' +
		      'Please review the Upgrading documentation at https://github.com/thlorenz/convert-source-map#upgrading'
		    )
		  }

		  var sm = readFromFileMap(comment, read);
		  if (sm != null && typeof sm.then === 'function') {
		    return sm.then(makeConverter);
		  } else {
		    return makeConverter(sm);
		  }
		};

		// Finds last sourcemap comment in file or returns null if none was found
		exports.fromSource = function (content) {
		  var m = content.match(exports.commentRegex);
		  return m ? exports.fromComment(m.pop()) : null;
		};

		// Finds last sourcemap comment in file or returns null if none was found
		exports.fromMapFileSource = function (content, read) {
		  if (typeof read === 'string') {
		    throw new Error(
		      'String directory paths are no longer supported with `fromMapFileSource`\n' +
		      'Please review the Upgrading documentation at https://github.com/thlorenz/convert-source-map#upgrading'
		    )
		  }
		  var m = content.match(exports.mapFileCommentRegex);
		  return m ? exports.fromMapFileComment(m.pop(), read) : null;
		};

		exports.removeComments = function (src) {
		  return src.replace(exports.commentRegex, '');
		};

		exports.removeMapFileComments = function (src) {
		  return src.replace(exports.mapFileCommentRegex, '');
		};

		exports.generateMapFileComment = function (file, options) {
		  var data = 'sourceMappingURL=' + file;
		  return options && options.multiline ? '/*# ' + data + ' */' : '//# ' + data;
		}; 
	} (convertSourceMap));
	return convertSourceMap;
}

var parser$1 = {};

var missingPluginHelper = {};

Object.defineProperty(missingPluginHelper, "__esModule", {
  value: true
});
missingPluginHelper.default = generateMissingPluginMessage;
const pluginNameMap = {
  asyncDoExpressions: {
    syntax: {
      name: "@babel/plugin-syntax-async-do-expressions",
      url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-async-do-expressions"
    }
  },
  decimal: {
    syntax: {
      name: "@babel/plugin-syntax-decimal",
      url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-decimal"
    }
  },
  decorators: {
    syntax: {
      name: "@babel/plugin-syntax-decorators",
      url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-decorators"
    },
    transform: {
      name: "@babel/plugin-proposal-decorators",
      url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-proposal-decorators"
    }
  },
  doExpressions: {
    syntax: {
      name: "@babel/plugin-syntax-do-expressions",
      url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-do-expressions"
    },
    transform: {
      name: "@babel/plugin-proposal-do-expressions",
      url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-proposal-do-expressions"
    }
  },
  exportDefaultFrom: {
    syntax: {
      name: "@babel/plugin-syntax-export-default-from",
      url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-export-default-from"
    },
    transform: {
      name: "@babel/plugin-proposal-export-default-from",
      url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-proposal-export-default-from"
    }
  },
  flow: {
    syntax: {
      name: "@babel/plugin-syntax-flow",
      url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-flow"
    },
    transform: {
      name: "@babel/preset-flow",
      url: "https://github.com/babel/babel/tree/main/packages/babel-preset-flow"
    }
  },
  functionBind: {
    syntax: {
      name: "@babel/plugin-syntax-function-bind",
      url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-function-bind"
    },
    transform: {
      name: "@babel/plugin-proposal-function-bind",
      url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-proposal-function-bind"
    }
  },
  functionSent: {
    syntax: {
      name: "@babel/plugin-syntax-function-sent",
      url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-function-sent"
    },
    transform: {
      name: "@babel/plugin-proposal-function-sent",
      url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-proposal-function-sent"
    }
  },
  jsx: {
    syntax: {
      name: "@babel/plugin-syntax-jsx",
      url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-jsx"
    },
    transform: {
      name: "@babel/preset-react",
      url: "https://github.com/babel/babel/tree/main/packages/babel-preset-react"
    }
  },
  importAttributes: {
    syntax: {
      name: "@babel/plugin-syntax-import-attributes",
      url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-import-attributes"
    }
  },
  pipelineOperator: {
    syntax: {
      name: "@babel/plugin-syntax-pipeline-operator",
      url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-pipeline-operator"
    },
    transform: {
      name: "@babel/plugin-proposal-pipeline-operator",
      url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-proposal-pipeline-operator"
    }
  },
  recordAndTuple: {
    syntax: {
      name: "@babel/plugin-syntax-record-and-tuple",
      url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-record-and-tuple"
    }
  },
  throwExpressions: {
    syntax: {
      name: "@babel/plugin-syntax-throw-expressions",
      url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-throw-expressions"
    },
    transform: {
      name: "@babel/plugin-proposal-throw-expressions",
      url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-proposal-throw-expressions"
    }
  },
  typescript: {
    syntax: {
      name: "@babel/plugin-syntax-typescript",
      url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-typescript"
    },
    transform: {
      name: "@babel/preset-typescript",
      url: "https://github.com/babel/babel/tree/main/packages/babel-preset-typescript"
    }
  }
};
{
  Object.assign(pluginNameMap, {
    asyncGenerators: {
      syntax: {
        name: "@babel/plugin-syntax-async-generators",
        url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-async-generators"
      },
      transform: {
        name: "@babel/plugin-transform-async-generator-functions",
        url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-transform-async-generator-functions"
      }
    },
    classProperties: {
      syntax: {
        name: "@babel/plugin-syntax-class-properties",
        url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-class-properties"
      },
      transform: {
        name: "@babel/plugin-transform-class-properties",
        url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-transform-class-properties"
      }
    },
    classPrivateProperties: {
      syntax: {
        name: "@babel/plugin-syntax-class-properties",
        url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-class-properties"
      },
      transform: {
        name: "@babel/plugin-transform-class-properties",
        url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-transform-class-properties"
      }
    },
    classPrivateMethods: {
      syntax: {
        name: "@babel/plugin-syntax-class-properties",
        url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-class-properties"
      },
      transform: {
        name: "@babel/plugin-transform-private-methods",
        url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-transform-private-methods"
      }
    },
    classStaticBlock: {
      syntax: {
        name: "@babel/plugin-syntax-class-static-block",
        url: "https://github.com/babel/babel/tree/HEAD/packages/babel-plugin-syntax-class-static-block"
      },
      transform: {
        name: "@babel/plugin-transform-class-static-block",
        url: "https://github.com/babel/babel/tree/HEAD/packages/babel-plugin-transform-class-static-block"
      }
    },
    dynamicImport: {
      syntax: {
        name: "@babel/plugin-syntax-dynamic-import",
        url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-dynamic-import"
      }
    },
    exportNamespaceFrom: {
      syntax: {
        name: "@babel/plugin-syntax-export-namespace-from",
        url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-export-namespace-from"
      },
      transform: {
        name: "@babel/plugin-transform-export-namespace-from",
        url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-transform-export-namespace-from"
      }
    },
    importAssertions: {
      syntax: {
        name: "@babel/plugin-syntax-import-assertions",
        url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-import-assertions"
      }
    },
    importMeta: {
      syntax: {
        name: "@babel/plugin-syntax-import-meta",
        url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-import-meta"
      }
    },
    logicalAssignment: {
      syntax: {
        name: "@babel/plugin-syntax-logical-assignment-operators",
        url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-logical-assignment-operators"
      },
      transform: {
        name: "@babel/plugin-transform-logical-assignment-operators",
        url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-transform-logical-assignment-operators"
      }
    },
    moduleStringNames: {
      syntax: {
        name: "@babel/plugin-syntax-module-string-names",
        url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-module-string-names"
      }
    },
    numericSeparator: {
      syntax: {
        name: "@babel/plugin-syntax-numeric-separator",
        url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-numeric-separator"
      },
      transform: {
        name: "@babel/plugin-transform-numeric-separator",
        url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-transform-numeric-separator"
      }
    },
    nullishCoalescingOperator: {
      syntax: {
        name: "@babel/plugin-syntax-nullish-coalescing-operator",
        url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-nullish-coalescing-operator"
      },
      transform: {
        name: "@babel/plugin-transform-nullish-coalescing-operator",
        url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-transform-nullish-coalescing-opearator"
      }
    },
    objectRestSpread: {
      syntax: {
        name: "@babel/plugin-syntax-object-rest-spread",
        url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-object-rest-spread"
      },
      transform: {
        name: "@babel/plugin-transform-object-rest-spread",
        url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-transform-object-rest-spread"
      }
    },
    optionalCatchBinding: {
      syntax: {
        name: "@babel/plugin-syntax-optional-catch-binding",
        url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-optional-catch-binding"
      },
      transform: {
        name: "@babel/plugin-transform-optional-catch-binding",
        url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-transform-optional-catch-binding"
      }
    },
    optionalChaining: {
      syntax: {
        name: "@babel/plugin-syntax-optional-chaining",
        url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-optional-chaining"
      },
      transform: {
        name: "@babel/plugin-transform-optional-chaining",
        url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-transform-optional-chaining"
      }
    },
    privateIn: {
      syntax: {
        name: "@babel/plugin-syntax-private-property-in-object",
        url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-private-property-in-object"
      },
      transform: {
        name: "@babel/plugin-transform-private-property-in-object",
        url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-transform-private-property-in-object"
      }
    },
    regexpUnicodeSets: {
      syntax: {
        name: "@babel/plugin-syntax-unicode-sets-regex",
        url: "https://github.com/babel/babel/blob/main/packages/babel-plugin-syntax-unicode-sets-regex/README.md"
      },
      transform: {
        name: "@babel/plugin-transform-unicode-sets-regex",
        url: "https://github.com/babel/babel/blob/main/packages/babel-plugin-proposalunicode-sets-regex/README.md"
      }
    }
  });
}
const getNameURLCombination = ({
  name,
  url
}) => `${name} (${url})`;
function generateMissingPluginMessage(missingPluginName, loc, codeFrame, filename) {
  let helpMessage = `Support for the experimental syntax '${missingPluginName}' isn't currently enabled ` + `(${loc.line}:${loc.column + 1}):\n\n` + codeFrame;
  const pluginInfo = pluginNameMap[missingPluginName];
  if (pluginInfo) {
    const {
      syntax: syntaxPlugin,
      transform: transformPlugin
    } = pluginInfo;
    if (syntaxPlugin) {
      const syntaxPluginInfo = getNameURLCombination(syntaxPlugin);
      if (transformPlugin) {
        const transformPluginInfo = getNameURLCombination(transformPlugin);
        const sectionType = transformPlugin.name.startsWith("@babel/plugin") ? "plugins" : "presets";
        helpMessage += `\n\nAdd ${transformPluginInfo} to the '${sectionType}' section of your Babel config to enable transformation.
If you want to leave it as-is, add ${syntaxPluginInfo} to the 'plugins' section to enable parsing.`;
      } else {
        helpMessage += `\n\nAdd ${syntaxPluginInfo} to the 'plugins' section of your Babel config ` + `to enable parsing.`;
      }
    }
  }
  const msgFilename = filename === "unknown" ? "<name of the input file>" : filename;
  helpMessage += `

If you already added the plugin for this syntax to your config, it's possible that your config \
isn't being loaded.
You can re-run Babel with the BABEL_SHOW_CONFIG_FOR environment variable to show the loaded \
configuration:
\tnpx cross-env BABEL_SHOW_CONFIG_FOR=${msgFilename} <your build command>
See https://babeljs.io/docs/configuration#print-effective-configs for more info.
`;
  return helpMessage;
}

Object.defineProperty(parser$1, "__esModule", {
  value: true
});
parser$1.default = parser;
function _parser() {
  const data = requireLib$b();
  _parser = function () {
    return data;
  };
  return data;
}
function _codeFrame() {
  const data = requireLib$c();
  _codeFrame = function () {
    return data;
  };
  return data;
}
var _missingPluginHelper = missingPluginHelper;
function* parser(pluginPasses, {
  parserOpts,
  highlightCode = true,
  filename = "unknown"
}, code) {
  try {
    const results = [];
    for (const plugins of pluginPasses) {
      for (const plugin of plugins) {
        const {
          parserOverride
        } = plugin;
        if (parserOverride) {
          const ast = parserOverride(code, parserOpts, _parser().parse);
          if (ast !== undefined) results.push(ast);
        }
      }
    }
    if (results.length === 0) {
      return (0, _parser().parse)(code, parserOpts);
    } else if (results.length === 1) {
      yield* [];
      if (typeof results[0].then === "function") {
        throw new Error(`You appear to be using an async parser plugin, ` + `which your current version of Babel does not support. ` + `If you're using a published plugin, you may need to upgrade ` + `your @babel/core version.`);
      }
      return results[0];
    }
    throw new Error("More than one plugin attempted to override parsing.");
  } catch (err) {
    if (err.code === "BABEL_PARSER_SOURCETYPE_MODULE_REQUIRED") {
      err.message += "\nConsider renaming the file to '.mjs', or setting sourceType:module " + "or sourceType:unambiguous in your Babel config for this file.";
    }
    const {
      loc,
      missingPlugin
    } = err;
    if (loc) {
      const codeFrame = (0, _codeFrame().codeFrameColumns)(code, {
        start: {
          line: loc.line,
          column: loc.column + 1
        }
      }, {
        highlightCode
      });
      if (missingPlugin) {
        err.message = `${filename}: ` + (0, _missingPluginHelper.default)(missingPlugin[0], loc, codeFrame, filename);
      } else {
        err.message = `${filename}: ${err.message}\n\n` + codeFrame;
      }
      err.code = "BABEL_PARSE_ERROR";
    }
    throw err;
  }
}

var cloneDeep = {};

Object.defineProperty(cloneDeep, "__esModule", {
  value: true
});
cloneDeep.default = _default;
function deepClone(value, cache) {
  if (value !== null) {
    if (cache.has(value)) return cache.get(value);
    let cloned;
    if (Array.isArray(value)) {
      cloned = new Array(value.length);
      cache.set(value, cloned);
      for (let i = 0; i < value.length; i++) {
        cloned[i] = typeof value[i] !== "object" ? value[i] : deepClone(value[i], cache);
      }
    } else {
      cloned = {};
      cache.set(value, cloned);
      const keys = Object.keys(value);
      for (let i = 0; i < keys.length; i++) {
        const key = keys[i];
        cloned[key] = typeof value[key] !== "object" ? value[key] : deepClone(value[key], cache);
      }
    }
    return cloned;
  }
  return value;
}
function _default(value) {
  if (typeof value !== "object") return value;
  return deepClone(value, new Map());
}

var hasRequiredNormalizeFile;

function requireNormalizeFile () {
	if (hasRequiredNormalizeFile) return normalizeFile;
	hasRequiredNormalizeFile = 1;

	Object.defineProperty(normalizeFile, "__esModule", {
	  value: true
	});
	normalizeFile.default = normalizeFile$1;
	function _fs() {
	  const data = require$$0__default["default"];
	  _fs = function () {
	    return data;
	  };
	  return data;
	}
	function _path() {
	  const data = path__default["default"];
	  _path = function () {
	    return data;
	  };
	  return data;
	}
	function _debug() {
	  const data = srcExports;
	  _debug = function () {
	    return data;
	  };
	  return data;
	}
	function _t() {
	  const data = requireLib$h();
	  _t = function () {
	    return data;
	  };
	  return data;
	}
	function _convertSourceMap() {
	  const data = requireConvertSourceMap();
	  _convertSourceMap = function () {
	    return data;
	  };
	  return data;
	}
	var _file = requireFile();
	var _index = parser$1;
	var _cloneDeep = cloneDeep;
	const {
	  file,
	  traverseFast
	} = _t();
	const debug = _debug()("babel:transform:file");
	const INLINE_SOURCEMAP_REGEX = /^[@#]\s+sourceMappingURL=data:(?:application|text)\/json;(?:charset[:=]\S+?;)?base64,(?:.*)$/;
	const EXTERNAL_SOURCEMAP_REGEX = /^[@#][ \t]+sourceMappingURL=([^\s'"`]+)[ \t]*$/;
	function* normalizeFile$1(pluginPasses, options, code, ast) {
	  code = `${code || ""}`;
	  if (ast) {
	    if (ast.type === "Program") {
	      ast = file(ast, [], []);
	    } else if (ast.type !== "File") {
	      throw new Error("AST root must be a Program or File node");
	    }
	    if (options.cloneInputAst) {
	      ast = (0, _cloneDeep.default)(ast);
	    }
	  } else {
	    ast = yield* (0, _index.default)(pluginPasses, options, code);
	  }
	  let inputMap = null;
	  if (options.inputSourceMap !== false) {
	    if (typeof options.inputSourceMap === "object") {
	      inputMap = _convertSourceMap().fromObject(options.inputSourceMap);
	    }
	    if (!inputMap) {
	      const lastComment = extractComments(INLINE_SOURCEMAP_REGEX, ast);
	      if (lastComment) {
	        try {
	          inputMap = _convertSourceMap().fromComment("//" + lastComment);
	        } catch (err) {
	          {
	            debug("discarding unknown inline input sourcemap");
	          }
	        }
	      }
	    }
	    if (!inputMap) {
	      const lastComment = extractComments(EXTERNAL_SOURCEMAP_REGEX, ast);
	      if (typeof options.filename === "string" && lastComment) {
	        try {
	          const match = EXTERNAL_SOURCEMAP_REGEX.exec(lastComment);
	          const inputMapContent = _fs().readFileSync(_path().resolve(_path().dirname(options.filename), match[1]), "utf8");
	          inputMap = _convertSourceMap().fromJSON(inputMapContent);
	        } catch (err) {
	          debug("discarding unknown file input sourcemap", err);
	        }
	      } else if (lastComment) {
	        debug("discarding un-loadable file input sourcemap");
	      }
	    }
	  }
	  return new _file.default(options, {
	    code,
	    ast: ast,
	    inputMap
	  });
	}
	function extractCommentsFromList(regex, comments, lastComment) {
	  if (comments) {
	    comments = comments.filter(({
	      value
	    }) => {
	      if (regex.test(value)) {
	        lastComment = value;
	        return false;
	      }
	      return true;
	    });
	  }
	  return [comments, lastComment];
	}
	function extractComments(regex, ast) {
	  let lastComment = null;
	  traverseFast(ast, node => {
	    [node.leadingComments, lastComment] = extractCommentsFromList(regex, node.leadingComments, lastComment);
	    [node.innerComments, lastComment] = extractCommentsFromList(regex, node.innerComments, lastComment);
	    [node.trailingComments, lastComment] = extractCommentsFromList(regex, node.trailingComments, lastComment);
	  });
	  return lastComment;
	}

	
	return normalizeFile;
}

var generate = {};

var mergeMap = {};

var remapping_umd = {exports: {}};

remapping_umd.exports;

var hasRequiredRemapping_umd;

function requireRemapping_umd () {
	if (hasRequiredRemapping_umd) return remapping_umd.exports;
	hasRequiredRemapping_umd = 1;
	(function (module, exports) {
		(function (global, factory) {
		    module.exports = factory(requireTraceMapping_umd(), requireGenMapping_umd()) ;
		})(commonjsGlobal, (function (traceMapping, genMapping) {
		    const SOURCELESS_MAPPING = /* #__PURE__ */ SegmentObject('', -1, -1, '', null, false);
		    const EMPTY_SOURCES = [];
		    function SegmentObject(source, line, column, name, content, ignore) {
		        return { source, line, column, name, content, ignore };
		    }
		    function Source(map, sources, source, content, ignore) {
		        return {
		            map,
		            sources,
		            source,
		            content,
		            ignore,
		        };
		    }
		    /**
		     * MapSource represents a single sourcemap, with the ability to trace mappings into its child nodes
		     * (which may themselves be SourceMapTrees).
		     */
		    function MapSource(map, sources) {
		        return Source(map, sources, '', null, false);
		    }
		    /**
		     * A "leaf" node in the sourcemap tree, representing an original, unmodified source file. Recursive
		     * segment tracing ends at the `OriginalSource`.
		     */
		    function OriginalSource(source, content, ignore) {
		        return Source(null, EMPTY_SOURCES, source, content, ignore);
		    }
		    /**
		     * traceMappings is only called on the root level SourceMapTree, and begins the process of
		     * resolving each mapping in terms of the original source files.
		     */
		    function traceMappings(tree) {
		        // TODO: Eventually support sourceRoot, which has to be removed because the sources are already
		        // fully resolved. We'll need to make sources relative to the sourceRoot before adding them.
		        const gen = new genMapping.GenMapping({ file: tree.map.file });
		        const { sources: rootSources, map } = tree;
		        const rootNames = map.names;
		        const rootMappings = traceMapping.decodedMappings(map);
		        for (let i = 0; i < rootMappings.length; i++) {
		            const segments = rootMappings[i];
		            for (let j = 0; j < segments.length; j++) {
		                const segment = segments[j];
		                const genCol = segment[0];
		                let traced = SOURCELESS_MAPPING;
		                // 1-length segments only move the current generated column, there's no source information
		                // to gather from it.
		                if (segment.length !== 1) {
		                    const source = rootSources[segment[1]];
		                    traced = originalPositionFor(source, segment[2], segment[3], segment.length === 5 ? rootNames[segment[4]] : '');
		                    // If the trace is invalid, then the trace ran into a sourcemap that doesn't contain a
		                    // respective segment into an original source.
		                    if (traced == null)
		                        continue;
		                }
		                const { column, line, name, content, source, ignore } = traced;
		                genMapping.maybeAddSegment(gen, i, genCol, source, line, column, name);
		                if (source && content != null)
		                    genMapping.setSourceContent(gen, source, content);
		                if (ignore)
		                    genMapping.setIgnore(gen, source, true);
		            }
		        }
		        return gen;
		    }
		    /**
		     * originalPositionFor is only called on children SourceMapTrees. It recurses down into its own
		     * child SourceMapTrees, until we find the original source map.
		     */
		    function originalPositionFor(source, line, column, name) {
		        if (!source.map) {
		            return SegmentObject(source.source, line, column, name, source.content, source.ignore);
		        }
		        const segment = traceMapping.traceSegment(source.map, line, column);
		        // If we couldn't find a segment, then this doesn't exist in the sourcemap.
		        if (segment == null)
		            return null;
		        // 1-length segments only move the current generated column, there's no source information
		        // to gather from it.
		        if (segment.length === 1)
		            return SOURCELESS_MAPPING;
		        return originalPositionFor(source.sources[segment[1]], segment[2], segment[3], segment.length === 5 ? source.map.names[segment[4]] : name);
		    }

		    function asArray(value) {
		        if (Array.isArray(value))
		            return value;
		        return [value];
		    }
		    /**
		     * Recursively builds a tree structure out of sourcemap files, with each node
		     * being either an `OriginalSource` "leaf" or a `SourceMapTree` composed of
		     * `OriginalSource`s and `SourceMapTree`s.
		     *
		     * Every sourcemap is composed of a collection of source files and mappings
		     * into locations of those source files. When we generate a `SourceMapTree` for
		     * the sourcemap, we attempt to load each source file's own sourcemap. If it
		     * does not have an associated sourcemap, it is considered an original,
		     * unmodified source file.
		     */
		    function buildSourceMapTree(input, loader) {
		        const maps = asArray(input).map((m) => new traceMapping.TraceMap(m, ''));
		        const map = maps.pop();
		        for (let i = 0; i < maps.length; i++) {
		            if (maps[i].sources.length > 1) {
		                throw new Error(`Transformation map ${i} must have exactly one source file.\n` +
		                    'Did you specify these with the most recent transformation maps first?');
		            }
		        }
		        let tree = build(map, loader, '', 0);
		        for (let i = maps.length - 1; i >= 0; i--) {
		            tree = MapSource(maps[i], [tree]);
		        }
		        return tree;
		    }
		    function build(map, loader, importer, importerDepth) {
		        const { resolvedSources, sourcesContent, ignoreList } = map;
		        const depth = importerDepth + 1;
		        const children = resolvedSources.map((sourceFile, i) => {
		            // The loading context gives the loader more information about why this file is being loaded
		            // (eg, from which importer). It also allows the loader to override the location of the loaded
		            // sourcemap/original source, or to override the content in the sourcesContent field if it's
		            // an unmodified source file.
		            const ctx = {
		                importer,
		                depth,
		                source: sourceFile || '',
		                content: undefined,
		                ignore: undefined,
		            };
		            // Use the provided loader callback to retrieve the file's sourcemap.
		            // TODO: We should eventually support async loading of sourcemap files.
		            const sourceMap = loader(ctx.source, ctx);
		            const { source, content, ignore } = ctx;
		            // If there is a sourcemap, then we need to recurse into it to load its source files.
		            if (sourceMap)
		                return build(new traceMapping.TraceMap(sourceMap, source), loader, source, depth);
		            // Else, it's an unmodified source file.
		            // The contents of this unmodified source file can be overridden via the loader context,
		            // allowing it to be explicitly null or a string. If it remains undefined, we fall back to
		            // the importing sourcemap's `sourcesContent` field.
		            const sourceContent = content !== undefined ? content : sourcesContent ? sourcesContent[i] : null;
		            const ignored = ignore !== undefined ? ignore : ignoreList ? ignoreList.includes(i) : false;
		            return OriginalSource(source, sourceContent, ignored);
		        });
		        return MapSource(map, children);
		    }

		    /**
		     * A SourceMap v3 compatible sourcemap, which only includes fields that were
		     * provided to it.
		     */
		    class SourceMap {
		        constructor(map, options) {
		            const out = options.decodedMappings ? genMapping.toDecodedMap(map) : genMapping.toEncodedMap(map);
		            this.version = out.version; // SourceMap spec says this should be first.
		            this.file = out.file;
		            this.mappings = out.mappings;
		            this.names = out.names;
		            this.ignoreList = out.ignoreList;
		            this.sourceRoot = out.sourceRoot;
		            this.sources = out.sources;
		            if (!options.excludeContent) {
		                this.sourcesContent = out.sourcesContent;
		            }
		        }
		        toString() {
		            return JSON.stringify(this);
		        }
		    }

		    /**
		     * Traces through all the mappings in the root sourcemap, through the sources
		     * (and their sourcemaps), all the way back to the original source location.
		     *
		     * `loader` will be called every time we encounter a source file. If it returns
		     * a sourcemap, we will recurse into that sourcemap to continue the trace. If
		     * it returns a falsey value, that source file is treated as an original,
		     * unmodified source file.
		     *
		     * Pass `excludeContent` to exclude any self-containing source file content
		     * from the output sourcemap.
		     *
		     * Pass `decodedMappings` to receive a SourceMap with decoded (instead of
		     * VLQ encoded) mappings.
		     */
		    function remapping(input, loader, options) {
		        const opts = typeof options === 'object' ? options : { excludeContent: !!options, decodedMappings: false };
		        const tree = buildSourceMapTree(input, loader);
		        return new SourceMap(traceMappings(tree), opts);
		    }

		    return remapping;

		}));
		
	} (remapping_umd, remapping_umd.exports));
	return remapping_umd.exports;
}

Object.defineProperty(mergeMap, "__esModule", {
  value: true
});
mergeMap.default = mergeSourceMap;
function _remapping() {
  const data = requireRemapping_umd();
  _remapping = function () {
    return data;
  };
  return data;
}
function mergeSourceMap(inputMap, map, sourceFileName) {
  const source = sourceFileName.replace(/\\/g, "/");
  let found = false;
  const result = _remapping()(rootless(map), (s, ctx) => {
    if (s === source && !found) {
      found = true;
      ctx.source = "";
      return rootless(inputMap);
    }
    return null;
  });
  if (typeof inputMap.sourceRoot === "string") {
    result.sourceRoot = inputMap.sourceRoot;
  }
  return Object.assign({}, result);
}
function rootless(map) {
  return Object.assign({}, map, {
    sourceRoot: null
  });
}

Object.defineProperty(generate, "__esModule", {
  value: true
});
generate.default = generateCode;
function _convertSourceMap() {
  const data = requireConvertSourceMap();
  _convertSourceMap = function () {
    return data;
  };
  return data;
}
function _generator() {
  const data = requireLib$e();
  _generator = function () {
    return data;
  };
  return data;
}
var _mergeMap = mergeMap;
function generateCode(pluginPasses, file) {
  const {
    opts,
    ast,
    code,
    inputMap
  } = file;
  const {
    generatorOpts
  } = opts;
  generatorOpts.inputSourceMap = inputMap == null ? void 0 : inputMap.toObject();
  const results = [];
  for (const plugins of pluginPasses) {
    for (const plugin of plugins) {
      const {
        generatorOverride
      } = plugin;
      if (generatorOverride) {
        const result = generatorOverride(ast, generatorOpts, code, _generator().default);
        if (result !== undefined) results.push(result);
      }
    }
  }
  let result;
  if (results.length === 0) {
    result = (0, _generator().default)(ast, generatorOpts, code);
  } else if (results.length === 1) {
    result = results[0];
    if (typeof result.then === "function") {
      throw new Error(`You appear to be using an async codegen plugin, ` + `which your current version of Babel does not support. ` + `If you're using a published plugin, ` + `you may need to upgrade your @babel/core version.`);
    }
  } else {
    throw new Error("More than one plugin attempted to override codegen.");
  }
  let {
    code: outputCode,
    decodedMap: outputMap = result.map
  } = result;
  if (result.__mergedMap) {
    outputMap = Object.assign({}, result.map);
  } else {
    if (outputMap) {
      if (inputMap) {
        outputMap = (0, _mergeMap.default)(inputMap.toObject(), outputMap, generatorOpts.sourceFileName);
      } else {
        outputMap = result.map;
      }
    }
  }
  if (opts.sourceMaps === "inline" || opts.sourceMaps === "both") {
    outputCode += "\n" + _convertSourceMap().fromObject(outputMap).toComment();
  }
  if (opts.sourceMaps === "inline") {
    outputMap = null;
  }
  return {
    outputCode,
    outputMap
  };
}

var hasRequiredTransformation;

function requireTransformation () {
	if (hasRequiredTransformation) return transformation;
	hasRequiredTransformation = 1;

	Object.defineProperty(transformation, "__esModule", {
	  value: true
	});
	transformation.run = run;
	function _traverse() {
	  const data = requireLib$7();
	  _traverse = function () {
	    return data;
	  };
	  return data;
	}
	var _pluginPass = pluginPass;
	var _blockHoistPlugin = blockHoistPlugin$1;
	var _normalizeOpts = normalizeOpts;
	var _normalizeFile = requireNormalizeFile();
	var _generate = generate;
	var _deepArray = deepArray;
	function* run(config, code, ast) {
	  const file = yield* (0, _normalizeFile.default)(config.passes, (0, _normalizeOpts.default)(config), code, ast);
	  const opts = file.opts;
	  try {
	    yield* transformFile(file, config.passes);
	  } catch (e) {
	    var _opts$filename;
	    e.message = `${(_opts$filename = opts.filename) != null ? _opts$filename : "unknown file"}: ${e.message}`;
	    if (!e.code) {
	      e.code = "BABEL_TRANSFORM_ERROR";
	    }
	    throw e;
	  }
	  let outputCode, outputMap;
	  try {
	    if (opts.code !== false) {
	      ({
	        outputCode,
	        outputMap
	      } = (0, _generate.default)(config.passes, file));
	    }
	  } catch (e) {
	    var _opts$filename2;
	    e.message = `${(_opts$filename2 = opts.filename) != null ? _opts$filename2 : "unknown file"}: ${e.message}`;
	    if (!e.code) {
	      e.code = "BABEL_GENERATE_ERROR";
	    }
	    throw e;
	  }
	  return {
	    metadata: file.metadata,
	    options: opts,
	    ast: opts.ast === true ? file.ast : null,
	    code: outputCode === undefined ? null : outputCode,
	    map: outputMap === undefined ? null : outputMap,
	    sourceType: file.ast.program.sourceType,
	    externalDependencies: (0, _deepArray.flattenToSet)(config.externalDependencies)
	  };
	}
	function* transformFile(file, pluginPasses) {
	  for (const pluginPairs of pluginPasses) {
	    const passPairs = [];
	    const passes = [];
	    const visitors = [];
	    for (const plugin of pluginPairs.concat([(0, _blockHoistPlugin.default)()])) {
	      const pass = new _pluginPass.default(file, plugin.key, plugin.options);
	      passPairs.push([plugin, pass]);
	      passes.push(pass);
	      visitors.push(plugin.visitor);
	    }
	    for (const [plugin, pass] of passPairs) {
	      const fn = plugin.pre;
	      if (fn) {
	        const result = fn.call(pass, file);
	        yield* [];
	        if (isThenable(result)) {
	          throw new Error(`You appear to be using an plugin with an async .pre, ` + `which your current version of Babel does not support. ` + `If you're using a published plugin, you may need to upgrade ` + `your @babel/core version.`);
	        }
	      }
	    }
	    const visitor = _traverse().default.visitors.merge(visitors, passes, file.opts.wrapPluginVisitorMethod);
	    {
	      (0, _traverse().default)(file.ast, visitor, file.scope);
	    }
	    for (const [plugin, pass] of passPairs) {
	      const fn = plugin.post;
	      if (fn) {
	        const result = fn.call(pass, file);
	        yield* [];
	        if (isThenable(result)) {
	          throw new Error(`You appear to be using an plugin with an async .post, ` + `which your current version of Babel does not support. ` + `If you're using a published plugin, you may need to upgrade ` + `your @babel/core version.`);
	        }
	      }
	    }
	  }
	}
	function isThenable(val) {
	  return !!val && (typeof val === "object" || typeof val === "function") && !!val.then && typeof val.then === "function";
	}

	
	return transformation;
}

var hasRequiredTransformFile;

function requireTransformFile () {
	if (hasRequiredTransformFile) return transformFile;
	hasRequiredTransformFile = 1;

	Object.defineProperty(transformFile, "__esModule", {
	  value: true
	});
	transformFile.transformFile = transformFile$1;
	transformFile.transformFileAsync = transformFileAsync;
	transformFile.transformFileSync = transformFileSync;
	function _gensync() {
	  const data = requireGensync();
	  _gensync = function () {
	    return data;
	  };
	  return data;
	}
	var _index = requireConfig();
	var _index2 = requireTransformation();
	var fs = fs$7;
	const transformFileRunner = _gensync()(function* (filename, opts) {
	  const options = Object.assign({}, opts, {
	    filename
	  });
	  const config = yield* (0, _index.default)(options);
	  if (config === null) return null;
	  const code = yield* fs.readFile(filename, "utf8");
	  return yield* (0, _index2.run)(config, code);
	});
	function transformFile$1(...args) {
	  transformFileRunner.errback(...args);
	}
	function transformFileSync(...args) {
	  return transformFileRunner.sync(...args);
	}
	function transformFileAsync(...args) {
	  return transformFileRunner.async(...args);
	}

	
	return transformFile;
}

var _import;
var hasRequired_import;

function require_import () {
	if (hasRequired_import) return _import;
	hasRequired_import = 1;
	_import = function import_(filepath) {
	  return (function (t) { return Promise.resolve().then(function () { return /*#__PURE__*/_interopNamespace(require(t)); }); })(filepath);
	};

	
	return _import;
}

var hasRequiredModuleTypes;

function requireModuleTypes () {
	if (hasRequiredModuleTypes) return moduleTypes;
	hasRequiredModuleTypes = 1;

	Object.defineProperty(moduleTypes, "__esModule", {
	  value: true
	});
	moduleTypes.default = loadCodeDefault;
	moduleTypes.supportsESM = void 0;
	var _async = async$2;
	function _path() {
	  const data = path__default["default"];
	  _path = function () {
	    return data;
	  };
	  return data;
	}
	function _url() {
	  const data = require$$1__default["default"];
	  _url = function () {
	    return data;
	  };
	  return data;
	}
	function _semver() {
	  const data = requireSemver$1();
	  _semver = function () {
	    return data;
	  };
	  return data;
	}
	function _debug() {
	  const data = srcExports;
	  _debug = function () {
	    return data;
	  };
	  return data;
	}
	var _rewriteStackTrace = rewriteStackTrace;
	var _configError = configError;
	var _transformFile = requireTransformFile();
	function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
	function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
	const debug = _debug()("babel:config:loading:files:module-types");
	{
	  try {
	    var import_ = require_import();
	  } catch (_unused) {}
	}
	moduleTypes.supportsESM = _semver().satisfies(process.versions.node, "^12.17 || >=13.2");
	function* loadCodeDefault(filepath, asyncError) {
	  switch (_path().extname(filepath)) {
	    case ".cjs":
	      {
	        return loadCjsDefault(filepath, arguments[2]);
	      }
	    case ".mjs":
	      break;
	    case ".cts":
	      return loadCtsDefault(filepath);
	    default:
	      try {
	        {
	          return loadCjsDefault(filepath, arguments[2]);
	        }
	      } catch (e) {
	        if (e.code !== "ERR_REQUIRE_ESM") throw e;
	      }
	  }
	  if (yield* (0, _async.isAsync)()) {
	    return yield* (0, _async.waitFor)(loadMjsDefault(filepath));
	  }
	  throw new _configError.default(asyncError, filepath);
	}
	function loadCtsDefault(filepath) {
	  const ext = ".cts";
	  const hasTsSupport = !!(commonjsRequire.extensions[".ts"] || commonjsRequire.extensions[".cts"] || commonjsRequire.extensions[".mts"]);
	  let handler;
	  if (!hasTsSupport) {
	    const opts = {
	      babelrc: false,
	      configFile: false,
	      sourceType: "unambiguous",
	      sourceMaps: "inline",
	      sourceFileName: _path().basename(filepath),
	      presets: [[getTSPreset(filepath), Object.assign({
	        onlyRemoveTypeImports: true,
	        optimizeConstEnums: true
	      }, {
	        allowDeclareFields: true
	      })]]
	    };
	    handler = function (m, filename) {
	      if (handler && filename.endsWith(ext)) {
	        try {
	          return m._compile((0, _transformFile.transformFileSync)(filename, Object.assign({}, opts, {
	            filename
	          })).code, filename);
	        } catch (error) {
	          if (!hasTsSupport) {
	            const packageJson = require$$9__default["default"];
	            if (_semver().lt(packageJson.version, "7.21.4")) {
	              console.error("`.cts` configuration file failed to load, please try to update `@babel/preset-typescript`.");
	            }
	          }
	          throw error;
	        }
	      }
	      return commonjsRequire.extensions[".js"](m, filename);
	    };
	    commonjsRequire.extensions[ext] = handler;
	  }
	  try {
	    return loadCjsDefault(filepath);
	  } finally {
	    if (!hasTsSupport) {
	      if (commonjsRequire.extensions[ext] === handler) delete commonjsRequire.extensions[ext];
	      handler = undefined;
	    }
	  }
	}
	const LOADING_CJS_FILES = new Set();
	function loadCjsDefault(filepath) {
	  if (LOADING_CJS_FILES.has(filepath)) {
	    debug("Auto-ignoring usage of config %o.", filepath);
	    return {};
	  }
	  let module;
	  try {
	    LOADING_CJS_FILES.add(filepath);
	    module = (0, _rewriteStackTrace.endHiddenCallStack)(commonjsRequire)(filepath);
	  } finally {
	    LOADING_CJS_FILES.delete(filepath);
	  }
	  {
	    var _module;
	    return (_module = module) != null && _module.__esModule ? module.default || (arguments[1] ? module : undefined) : module;
	  }
	}
	const loadMjsDefault = (0, _rewriteStackTrace.endHiddenCallStack)(function () {
	  var _loadMjsDefault = _asyncToGenerator(function* (filepath) {
	    const url = (0, _url().pathToFileURL)(filepath).toString();
	    {
	      if (!import_) {
	        throw new _configError.default("Internal error: Native ECMAScript modules aren't supported by this platform.\n", filepath);
	      }
	      return (yield import_(url)).default;
	    }
	  });
	  function loadMjsDefault(_x) {
	    return _loadMjsDefault.apply(this, arguments);
	  }
	  return loadMjsDefault;
	}());
	function getTSPreset(filepath) {
	  try {
	    return require("@babel/preset-typescript");
	  } catch (error) {
	    if (error.code !== "MODULE_NOT_FOUND") throw error;
	    let message = "You appear to be using a .cts file as Babel configuration, but the `@babel/preset-typescript` package was not found: please install it!";
	    {
	      if (process.versions.pnp) {
	        message += `
If you are using Yarn Plug'n'Play, you may also need to add the following configuration to your .yarnrc.yml file:

packageExtensions:
\t"@babel/core@*":
\t\tpeerDependencies:
\t\t\t"@babel/preset-typescript": "*"
`;
	      }
	    }
	    throw new _configError.default(message, filepath);
	  }
	}

	
	return moduleTypes;
}

var hasRequiredConfiguration;

function requireConfiguration () {
	if (hasRequiredConfiguration) return configuration;
	hasRequiredConfiguration = 1;

	Object.defineProperty(configuration, "__esModule", {
	  value: true
	});
	configuration.ROOT_CONFIG_FILENAMES = void 0;
	configuration.findConfigUpwards = findConfigUpwards;
	configuration.findRelativeConfig = findRelativeConfig;
	configuration.findRootConfig = findRootConfig;
	configuration.loadConfig = loadConfig;
	configuration.resolveShowConfigPath = resolveShowConfigPath;
	function _debug() {
	  const data = srcExports;
	  _debug = function () {
	    return data;
	  };
	  return data;
	}
	function _fs() {
	  const data = require$$0__default["default"];
	  _fs = function () {
	    return data;
	  };
	  return data;
	}
	function _path() {
	  const data = path__default["default"];
	  _path = function () {
	    return data;
	  };
	  return data;
	}
	function _json() {
	  const data = require$$3$1;
	  _json = function () {
	    return data;
	  };
	  return data;
	}
	function _gensync() {
	  const data = requireGensync();
	  _gensync = function () {
	    return data;
	  };
	  return data;
	}
	var _caching = caching;
	var _configApi = requireConfigApi();
	var _utils = utils$1;
	var _moduleTypes = requireModuleTypes();
	var _patternToRegex = patternToRegex;
	var _configError = configError;
	var fs = fs$7;
	var _rewriteStackTrace = rewriteStackTrace;
	const debug = _debug()("babel:config:loading:files:configuration");
	const ROOT_CONFIG_FILENAMES = configuration.ROOT_CONFIG_FILENAMES = ["babel.config.js", "babel.config.cjs", "babel.config.mjs", "babel.config.json", "babel.config.cts"];
	const RELATIVE_CONFIG_FILENAMES = [".babelrc", ".babelrc.js", ".babelrc.cjs", ".babelrc.mjs", ".babelrc.json", ".babelrc.cts"];
	const BABELIGNORE_FILENAME = ".babelignore";
	const runConfig = (0, _caching.makeWeakCache)(function* runConfig(options, cache) {
	  yield* [];
	  return {
	    options: (0, _rewriteStackTrace.endHiddenCallStack)(options)((0, _configApi.makeConfigAPI)(cache)),
	    cacheNeedsConfiguration: !cache.configured()
	  };
	});
	function* readConfigCode(filepath, data) {
	  if (!_fs().existsSync(filepath)) return null;
	  let options = yield* (0, _moduleTypes.default)(filepath, "You appear to be using a native ECMAScript module configuration " + "file, which is only supported when running Babel asynchronously.");
	  let cacheNeedsConfiguration = false;
	  if (typeof options === "function") {
	    ({
	      options,
	      cacheNeedsConfiguration
	    } = yield* runConfig(options, data));
	  }
	  if (!options || typeof options !== "object" || Array.isArray(options)) {
	    throw new _configError.default(`Configuration should be an exported JavaScript object.`, filepath);
	  }
	  if (typeof options.then === "function") {
	    options.catch == null || options.catch(() => {});
	    throw new _configError.default(`You appear to be using an async configuration, ` + `which your current version of Babel does not support. ` + `We may add support for this in the future, ` + `but if you're on the most recent version of @babel/core and still ` + `seeing this error, then you'll need to synchronously return your config.`, filepath);
	  }
	  if (cacheNeedsConfiguration) throwConfigError(filepath);
	  return buildConfigFileObject(options, filepath);
	}
	const cfboaf = new WeakMap();
	function buildConfigFileObject(options, filepath) {
	  let configFilesByFilepath = cfboaf.get(options);
	  if (!configFilesByFilepath) {
	    cfboaf.set(options, configFilesByFilepath = new Map());
	  }
	  let configFile = configFilesByFilepath.get(filepath);
	  if (!configFile) {
	    configFile = {
	      filepath,
	      dirname: _path().dirname(filepath),
	      options
	    };
	    configFilesByFilepath.set(filepath, configFile);
	  }
	  return configFile;
	}
	const packageToBabelConfig = (0, _caching.makeWeakCacheSync)(file => {
	  const babel = file.options["babel"];
	  if (typeof babel === "undefined") return null;
	  if (typeof babel !== "object" || Array.isArray(babel) || babel === null) {
	    throw new _configError.default(`.babel property must be an object`, file.filepath);
	  }
	  return {
	    filepath: file.filepath,
	    dirname: file.dirname,
	    options: babel
	  };
	});
	const readConfigJSON5 = (0, _utils.makeStaticFileCache)((filepath, content) => {
	  let options;
	  try {
	    options = _json().parse(content);
	  } catch (err) {
	    throw new _configError.default(`Error while parsing config - ${err.message}`, filepath);
	  }
	  if (!options) throw new _configError.default(`No config detected`, filepath);
	  if (typeof options !== "object") {
	    throw new _configError.default(`Config returned typeof ${typeof options}`, filepath);
	  }
	  if (Array.isArray(options)) {
	    throw new _configError.default(`Expected config object but found array`, filepath);
	  }
	  delete options["$schema"];
	  return {
	    filepath,
	    dirname: _path().dirname(filepath),
	    options
	  };
	});
	const readIgnoreConfig = (0, _utils.makeStaticFileCache)((filepath, content) => {
	  const ignoreDir = _path().dirname(filepath);
	  const ignorePatterns = content.split("\n").map(line => line.replace(/#(.*?)$/, "").trim()).filter(line => !!line);
	  for (const pattern of ignorePatterns) {
	    if (pattern[0] === "!") {
	      throw new _configError.default(`Negation of file paths is not supported.`, filepath);
	    }
	  }
	  return {
	    filepath,
	    dirname: _path().dirname(filepath),
	    ignore: ignorePatterns.map(pattern => (0, _patternToRegex.default)(pattern, ignoreDir))
	  };
	});
	function findConfigUpwards(rootDir) {
	  let dirname = rootDir;
	  for (;;) {
	    for (const filename of ROOT_CONFIG_FILENAMES) {
	      if (_fs().existsSync(_path().join(dirname, filename))) {
	        return dirname;
	      }
	    }
	    const nextDir = _path().dirname(dirname);
	    if (dirname === nextDir) break;
	    dirname = nextDir;
	  }
	  return null;
	}
	function* findRelativeConfig(packageData, envName, caller) {
	  let config = null;
	  let ignore = null;
	  const dirname = _path().dirname(packageData.filepath);
	  for (const loc of packageData.directories) {
	    if (!config) {
	      var _packageData$pkg;
	      config = yield* loadOneConfig(RELATIVE_CONFIG_FILENAMES, loc, envName, caller, ((_packageData$pkg = packageData.pkg) == null ? void 0 : _packageData$pkg.dirname) === loc ? packageToBabelConfig(packageData.pkg) : null);
	    }
	    if (!ignore) {
	      const ignoreLoc = _path().join(loc, BABELIGNORE_FILENAME);
	      ignore = yield* readIgnoreConfig(ignoreLoc);
	      if (ignore) {
	        debug("Found ignore %o from %o.", ignore.filepath, dirname);
	      }
	    }
	  }
	  return {
	    config,
	    ignore
	  };
	}
	function findRootConfig(dirname, envName, caller) {
	  return loadOneConfig(ROOT_CONFIG_FILENAMES, dirname, envName, caller);
	}
	function* loadOneConfig(names, dirname, envName, caller, previousConfig = null) {
	  const configs = yield* _gensync().all(names.map(filename => readConfig(_path().join(dirname, filename), envName, caller)));
	  const config = configs.reduce((previousConfig, config) => {
	    if (config && previousConfig) {
	      throw new _configError.default(`Multiple configuration files found. Please remove one:\n` + ` - ${_path().basename(previousConfig.filepath)}\n` + ` - ${config.filepath}\n` + `from ${dirname}`);
	    }
	    return config || previousConfig;
	  }, previousConfig);
	  if (config) {
	    debug("Found configuration %o from %o.", config.filepath, dirname);
	  }
	  return config;
	}
	function* loadConfig(name, dirname, envName, caller) {
	  const filepath = (((v, w) => (v = v.split("."), w = w.split("."), +v[0] > +w[0] || v[0] == w[0] && +v[1] >= +w[1]))(process.versions.node, "8.9") ? require.resolve : (r, {
	    paths: [b]
	  }, M = require$$3__default["default"]) => {
	    let f = M._findPath(r, M._nodeModulePaths(b).concat(b));
	    if (f) return f;
	    f = new Error(`Cannot resolve module '${r}'`);
	    f.code = "MODULE_NOT_FOUND";
	    throw f;
	  })(name, {
	    paths: [dirname]
	  });
	  const conf = yield* readConfig(filepath, envName, caller);
	  if (!conf) {
	    throw new _configError.default(`Config file contains no configuration data`, filepath);
	  }
	  debug("Loaded config %o from %o.", name, dirname);
	  return conf;
	}
	function readConfig(filepath, envName, caller) {
	  const ext = _path().extname(filepath);
	  switch (ext) {
	    case ".js":
	    case ".cjs":
	    case ".mjs":
	    case ".cts":
	      return readConfigCode(filepath, {
	        envName,
	        caller
	      });
	    default:
	      return readConfigJSON5(filepath);
	  }
	}
	function* resolveShowConfigPath(dirname) {
	  const targetPath = process.env.BABEL_SHOW_CONFIG_FOR;
	  if (targetPath != null) {
	    const absolutePath = _path().resolve(dirname, targetPath);
	    const stats = yield* fs.stat(absolutePath);
	    if (!stats.isFile()) {
	      throw new Error(`${absolutePath}: BABEL_SHOW_CONFIG_FOR must refer to a regular file, directories are not supported.`);
	    }
	    return absolutePath;
	  }
	  return null;
	}
	function throwConfigError(filepath) {
	  throw new _configError.default(`\
Caching was left unconfigured. Babel's plugins, presets, and .babelrc.js files can be configured
for various types of caching, using the first param of their handler functions:

module.exports = function(api) {
  // The API exposes the following:

  // Cache the returned value forever and don't call this function again.
  api.cache(true);

  // Don't cache at all. Not recommended because it will be very slow.
  api.cache(false);

  // Cached based on the value of some function. If this function returns a value different from
  // a previously-encountered value, the plugins will re-evaluate.
  var env = api.cache(() => process.env.NODE_ENV);

  // If testing for a specific env, we recommend specifics to avoid instantiating a plugin for
  // any possible NODE_ENV value that might come up during plugin execution.
  var isProd = api.cache(() => process.env.NODE_ENV === "production");

  // .cache(fn) will perform a linear search though instances to find the matching plugin based
  // based on previous instantiated plugins. If you want to recreate the plugin and discard the
  // previous instance whenever something changes, you may use:
  var isProd = api.cache.invalidate(() => process.env.NODE_ENV === "production");

  // Note, we also expose the following more-verbose versions of the above examples:
  api.cache.forever(); // api.cache(true)
  api.cache.never();   // api.cache(false)
  api.cache.using(fn); // api.cache(fn)

  // Return the value that will be cached.
  return { };
};`, filepath);
	}

	
	return configuration;
}

var plugins = {};

var importMetaResolve = {};

Object.defineProperty(importMetaResolve, "__esModule", {
  value: true
});
importMetaResolve.moduleResolve = moduleResolve;
importMetaResolve.resolve = resolve$2;
function _assert() {
  const data = require$$0__default$5["default"];
  _assert = function () {
    return data;
  };
  return data;
}
function _fs() {
  const data = _interopRequireWildcard(require$$0__default["default"], true);
  _fs = function () {
    return data;
  };
  return data;
}
function _process() {
  const data = require$$2__default["default"];
  _process = function () {
    return data;
  };
  return data;
}
function _url() {
  const data = require$$1__default["default"];
  _url = function () {
    return data;
  };
  return data;
}
function _path() {
  const data = path__default["default"];
  _path = function () {
    return data;
  };
  return data;
}
function _module() {
  const data = require$$3__default["default"];
  _module = function () {
    return data;
  };
  return data;
}
function _v() {
  const data = require$$6__default["default"];
  _v = function () {
    return data;
  };
  return data;
}
function _util() {
  const data = require$$0__default$2["default"];
  _util = function () {
    return data;
  };
  return data;
}
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
const own$1 = {}.hasOwnProperty;
const classRegExp = /^([A-Z][a-z\d]*)+$/;
const kTypes = new Set(['string', 'function', 'number', 'object', 'Function', 'Object', 'boolean', 'bigint', 'symbol']);
const codes = {};
function formatList(array, type = 'and') {
  return array.length < 3 ? array.join(` ${type} `) : `${array.slice(0, -1).join(', ')}, ${type} ${array[array.length - 1]}`;
}
const messages = new Map();
const nodeInternalPrefix = '__node_internal_';
let userStackTraceLimit;
codes.ERR_INVALID_ARG_TYPE = createError('ERR_INVALID_ARG_TYPE', (name, expected, actual) => {
  _assert()(typeof name === 'string', "'name' must be a string");
  if (!Array.isArray(expected)) {
    expected = [expected];
  }
  let message = 'The ';
  if (name.endsWith(' argument')) {
    message += `${name} `;
  } else {
    const type = name.includes('.') ? 'property' : 'argument';
    message += `"${name}" ${type} `;
  }
  message += 'must be ';
  const types = [];
  const instances = [];
  const other = [];
  for (const value of expected) {
    _assert()(typeof value === 'string', 'All expected entries have to be of type string');
    if (kTypes.has(value)) {
      types.push(value.toLowerCase());
    } else if (classRegExp.exec(value) === null) {
      _assert()(value !== 'object', 'The value "object" should be written as "Object"');
      other.push(value);
    } else {
      instances.push(value);
    }
  }
  if (instances.length > 0) {
    const pos = types.indexOf('object');
    if (pos !== -1) {
      types.slice(pos, 1);
      instances.push('Object');
    }
  }
  if (types.length > 0) {
    message += `${types.length > 1 ? 'one of type' : 'of type'} ${formatList(types, 'or')}`;
    if (instances.length > 0 || other.length > 0) message += ' or ';
  }
  if (instances.length > 0) {
    message += `an instance of ${formatList(instances, 'or')}`;
    if (other.length > 0) message += ' or ';
  }
  if (other.length > 0) {
    if (other.length > 1) {
      message += `one of ${formatList(other, 'or')}`;
    } else {
      if (other[0].toLowerCase() !== other[0]) message += 'an ';
      message += `${other[0]}`;
    }
  }
  message += `. Received ${determineSpecificType(actual)}`;
  return message;
}, TypeError);
codes.ERR_INVALID_MODULE_SPECIFIER = createError('ERR_INVALID_MODULE_SPECIFIER', (request, reason, base = undefined) => {
  return `Invalid module "${request}" ${reason}${base ? ` imported from ${base}` : ''}`;
}, TypeError);
codes.ERR_INVALID_PACKAGE_CONFIG = createError('ERR_INVALID_PACKAGE_CONFIG', (path, base, message) => {
  return `Invalid package config ${path}${base ? ` while importing ${base}` : ''}${message ? `. ${message}` : ''}`;
}, Error);
codes.ERR_INVALID_PACKAGE_TARGET = createError('ERR_INVALID_PACKAGE_TARGET', (pkgPath, key, target, isImport = false, base = undefined) => {
  const relError = typeof target === 'string' && !isImport && target.length > 0 && !target.startsWith('./');
  if (key === '.') {
    _assert()(isImport === false);
    return `Invalid "exports" main target ${JSON.stringify(target)} defined ` + `in the package config ${pkgPath}package.json${base ? ` imported from ${base}` : ''}${relError ? '; targets must start with "./"' : ''}`;
  }
  return `Invalid "${isImport ? 'imports' : 'exports'}" target ${JSON.stringify(target)} defined for '${key}' in the package config ${pkgPath}package.json${base ? ` imported from ${base}` : ''}${relError ? '; targets must start with "./"' : ''}`;
}, Error);
codes.ERR_MODULE_NOT_FOUND = createError('ERR_MODULE_NOT_FOUND', (path, base, exactUrl = false) => {
  return `Cannot find ${exactUrl ? 'module' : 'package'} '${path}' imported from ${base}`;
}, Error);
codes.ERR_NETWORK_IMPORT_DISALLOWED = createError('ERR_NETWORK_IMPORT_DISALLOWED', "import of '%s' by %s is not supported: %s", Error);
codes.ERR_PACKAGE_IMPORT_NOT_DEFINED = createError('ERR_PACKAGE_IMPORT_NOT_DEFINED', (specifier, packagePath, base) => {
  return `Package import specifier "${specifier}" is not defined${packagePath ? ` in package ${packagePath}package.json` : ''} imported from ${base}`;
}, TypeError);
codes.ERR_PACKAGE_PATH_NOT_EXPORTED = createError('ERR_PACKAGE_PATH_NOT_EXPORTED', (pkgPath, subpath, base = undefined) => {
  if (subpath === '.') return `No "exports" main defined in ${pkgPath}package.json${base ? ` imported from ${base}` : ''}`;
  return `Package subpath '${subpath}' is not defined by "exports" in ${pkgPath}package.json${base ? ` imported from ${base}` : ''}`;
}, Error);
codes.ERR_UNSUPPORTED_DIR_IMPORT = createError('ERR_UNSUPPORTED_DIR_IMPORT', "Directory import '%s' is not supported " + 'resolving ES modules imported from %s', Error);
codes.ERR_UNKNOWN_FILE_EXTENSION = createError('ERR_UNKNOWN_FILE_EXTENSION', (ext, path) => {
  return `Unknown file extension "${ext}" for ${path}`;
}, TypeError);
codes.ERR_INVALID_ARG_VALUE = createError('ERR_INVALID_ARG_VALUE', (name, value, reason = 'is invalid') => {
  let inspected = (0, _util().inspect)(value);
  if (inspected.length > 128) {
    inspected = `${inspected.slice(0, 128)}...`;
  }
  const type = name.includes('.') ? 'property' : 'argument';
  return `The ${type} '${name}' ${reason}. Received ${inspected}`;
}, TypeError);
function createError(sym, value, def) {
  messages.set(sym, value);
  return makeNodeErrorWithCode(def, sym);
}
function makeNodeErrorWithCode(Base, key) {
  return NodeError;
  function NodeError(...args) {
    const limit = Error.stackTraceLimit;
    if (isErrorStackTraceLimitWritable()) Error.stackTraceLimit = 0;
    const error = new Base();
    if (isErrorStackTraceLimitWritable()) Error.stackTraceLimit = limit;
    const message = getMessage(key, args, error);
    Object.defineProperties(error, {
      message: {
        value: message,
        enumerable: false,
        writable: true,
        configurable: true
      },
      toString: {
        value() {
          return `${this.name} [${key}]: ${this.message}`;
        },
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    captureLargerStackTrace(error);
    error.code = key;
    return error;
  }
}
function isErrorStackTraceLimitWritable() {
  try {
    if (_v().startupSnapshot.isBuildingSnapshot()) {
      return false;
    }
  } catch (_unused) {}
  const desc = Object.getOwnPropertyDescriptor(Error, 'stackTraceLimit');
  if (desc === undefined) {
    return Object.isExtensible(Error);
  }
  return own$1.call(desc, 'writable') && desc.writable !== undefined ? desc.writable : desc.set !== undefined;
}
function hideStackFrames(fn) {
  const hidden = nodeInternalPrefix + fn.name;
  Object.defineProperty(fn, 'name', {
    value: hidden
  });
  return fn;
}
const captureLargerStackTrace = hideStackFrames(function (error) {
  const stackTraceLimitIsWritable = isErrorStackTraceLimitWritable();
  if (stackTraceLimitIsWritable) {
    userStackTraceLimit = Error.stackTraceLimit;
    Error.stackTraceLimit = Number.POSITIVE_INFINITY;
  }
  Error.captureStackTrace(error);
  if (stackTraceLimitIsWritable) Error.stackTraceLimit = userStackTraceLimit;
  return error;
});
function getMessage(key, args, self) {
  const message = messages.get(key);
  _assert()(message !== undefined, 'expected `message` to be found');
  if (typeof message === 'function') {
    _assert()(message.length <= args.length, `Code: ${key}; The provided arguments length (${args.length}) does not ` + `match the required ones (${message.length}).`);
    return Reflect.apply(message, self, args);
  }
  const regex = /%[dfijoOs]/g;
  let expectedLength = 0;
  while (regex.exec(message) !== null) expectedLength++;
  _assert()(expectedLength === args.length, `Code: ${key}; The provided arguments length (${args.length}) does not ` + `match the required ones (${expectedLength}).`);
  if (args.length === 0) return message;
  args.unshift(message);
  return Reflect.apply(_util().format, null, args);
}
function determineSpecificType(value) {
  if (value === null || value === undefined) {
    return String(value);
  }
  if (typeof value === 'function' && value.name) {
    return `function ${value.name}`;
  }
  if (typeof value === 'object') {
    if (value.constructor && value.constructor.name) {
      return `an instance of ${value.constructor.name}`;
    }
    return `${(0, _util().inspect)(value, {
      depth: -1
    })}`;
  }
  let inspected = (0, _util().inspect)(value, {
    colors: false
  });
  if (inspected.length > 28) {
    inspected = `${inspected.slice(0, 25)}...`;
  }
  return `type ${typeof value} (${inspected})`;
}
const hasOwnProperty$1 = {}.hasOwnProperty;
const {
  ERR_INVALID_PACKAGE_CONFIG: ERR_INVALID_PACKAGE_CONFIG$1
} = codes;
const cache = new Map();
const reader = {
  read
};
var packageJsonReader = reader;
function read(jsonPath, {
  base,
  specifier
}) {
  const existing = cache.get(jsonPath);
  if (existing) {
    return existing;
  }
  let string;
  try {
    string = _fs().default.readFileSync(_path().toNamespacedPath(jsonPath), 'utf8');
  } catch (error) {
    const exception = error;
    if (exception.code !== 'ENOENT') {
      throw exception;
    }
  }
  const result = {
    exists: false,
    pjsonPath: jsonPath,
    main: undefined,
    name: undefined,
    type: 'none',
    exports: undefined,
    imports: undefined
  };
  if (string !== undefined) {
    let parsed;
    try {
      parsed = JSON.parse(string);
    } catch (error_) {
      const cause = error_;
      const error = new ERR_INVALID_PACKAGE_CONFIG$1(jsonPath, (base ? `"${specifier}" from ` : '') + (0, _url().fileURLToPath)(base || specifier), cause.message);
      error.cause = cause;
      throw error;
    }
    result.exists = true;
    if (hasOwnProperty$1.call(parsed, 'name') && typeof parsed.name === 'string') {
      result.name = parsed.name;
    }
    if (hasOwnProperty$1.call(parsed, 'main') && typeof parsed.main === 'string') {
      result.main = parsed.main;
    }
    if (hasOwnProperty$1.call(parsed, 'exports')) {
      result.exports = parsed.exports;
    }
    if (hasOwnProperty$1.call(parsed, 'imports')) {
      result.imports = parsed.imports;
    }
    if (hasOwnProperty$1.call(parsed, 'type') && (parsed.type === 'commonjs' || parsed.type === 'module')) {
      result.type = parsed.type;
    }
  }
  cache.set(jsonPath, result);
  return result;
}
function getPackageScopeConfig(resolved) {
  let packageJSONUrl = new (_url().URL)('package.json', resolved);
  while (true) {
    const packageJSONPath = packageJSONUrl.pathname;
    if (packageJSONPath.endsWith('node_modules/package.json')) {
      break;
    }
    const packageConfig = packageJsonReader.read((0, _url().fileURLToPath)(packageJSONUrl), {
      specifier: resolved
    });
    if (packageConfig.exists) {
      return packageConfig;
    }
    const lastPackageJSONUrl = packageJSONUrl;
    packageJSONUrl = new (_url().URL)('../package.json', packageJSONUrl);
    if (packageJSONUrl.pathname === lastPackageJSONUrl.pathname) {
      break;
    }
  }
  const packageJSONPath = (0, _url().fileURLToPath)(packageJSONUrl);
  return {
    pjsonPath: packageJSONPath,
    exists: false,
    main: undefined,
    name: undefined,
    type: 'none',
    exports: undefined,
    imports: undefined
  };
}
function getPackageType(url) {
  const packageConfig = getPackageScopeConfig(url);
  return packageConfig.type;
}
const {
  ERR_UNKNOWN_FILE_EXTENSION
} = codes;
const hasOwnProperty$2 = {}.hasOwnProperty;
const extensionFormatMap = {
  __proto__: null,
  '.cjs': 'commonjs',
  '.js': 'module',
  '.json': 'json',
  '.mjs': 'module'
};
function mimeToFormat(mime) {
  if (mime && /\s*(text|application)\/javascript\s*(;\s*charset=utf-?8\s*)?/i.test(mime)) return 'module';
  if (mime === 'application/json') return 'json';
  return null;
}
const protocolHandlers = {
  __proto__: null,
  'data:': getDataProtocolModuleFormat,
  'file:': getFileProtocolModuleFormat,
  'http:': getHttpProtocolModuleFormat,
  'https:': getHttpProtocolModuleFormat,
  'node:'() {
    return 'builtin';
  }
};
function getDataProtocolModuleFormat(parsed) {
  const {
    1: mime
  } = /^([^/]+\/[^;,]+)[^,]*?(;base64)?,/.exec(parsed.pathname) || [null, null, null];
  return mimeToFormat(mime);
}
function extname(url) {
  const pathname = url.pathname;
  let index = pathname.length;
  while (index--) {
    const code = pathname.codePointAt(index);
    if (code === 47) {
      return '';
    }
    if (code === 46) {
      return pathname.codePointAt(index - 1) === 47 ? '' : pathname.slice(index);
    }
  }
  return '';
}
function getFileProtocolModuleFormat(url, _context, ignoreErrors) {
  const ext = extname(url);
  if (ext === '.js') {
    const packageType = getPackageType(url);
    if (packageType !== 'none') {
      return packageType;
    }
    return 'commonjs';
  }
  if (ext === '') {
    const packageType = getPackageType(url);
    if (packageType === 'none' || packageType === 'commonjs') {
      return 'commonjs';
    }
    return 'module';
  }
  const format = extensionFormatMap[ext];
  if (format) return format;
  if (ignoreErrors) {
    return undefined;
  }
  const filepath = (0, _url().fileURLToPath)(url);
  throw new ERR_UNKNOWN_FILE_EXTENSION(ext, filepath);
}
function getHttpProtocolModuleFormat() {}
function defaultGetFormatWithoutErrors(url, context) {
  const protocol = url.protocol;
  if (!hasOwnProperty$2.call(protocolHandlers, protocol)) {
    return null;
  }
  return protocolHandlers[protocol](url, context, true) || null;
}
const {
  ERR_INVALID_ARG_VALUE
} = codes;
const DEFAULT_CONDITIONS = Object.freeze(['node', 'import']);
const DEFAULT_CONDITIONS_SET = new Set(DEFAULT_CONDITIONS);
function getDefaultConditions() {
  return DEFAULT_CONDITIONS;
}
function getDefaultConditionsSet() {
  return DEFAULT_CONDITIONS_SET;
}
function getConditionsSet(conditions) {
  if (conditions !== undefined && conditions !== getDefaultConditions()) {
    if (!Array.isArray(conditions)) {
      throw new ERR_INVALID_ARG_VALUE('conditions', conditions, 'expected an array');
    }
    return new Set(conditions);
  }
  return getDefaultConditionsSet();
}
const RegExpPrototypeSymbolReplace = RegExp.prototype[Symbol.replace];
const {
  ERR_NETWORK_IMPORT_DISALLOWED,
  ERR_INVALID_MODULE_SPECIFIER,
  ERR_INVALID_PACKAGE_CONFIG,
  ERR_INVALID_PACKAGE_TARGET,
  ERR_MODULE_NOT_FOUND,
  ERR_PACKAGE_IMPORT_NOT_DEFINED,
  ERR_PACKAGE_PATH_NOT_EXPORTED,
  ERR_UNSUPPORTED_DIR_IMPORT
} = codes;
const own = {}.hasOwnProperty;
const invalidSegmentRegEx = /(^|\\|\/)((\.|%2e)(\.|%2e)?|(n|%6e|%4e)(o|%6f|%4f)(d|%64|%44)(e|%65|%45)(_|%5f)(m|%6d|%4d)(o|%6f|%4f)(d|%64|%44)(u|%75|%55)(l|%6c|%4c)(e|%65|%45)(s|%73|%53))?(\\|\/|$)/i;
const deprecatedInvalidSegmentRegEx = /(^|\\|\/)((\.|%2e)(\.|%2e)?|(n|%6e|%4e)(o|%6f|%4f)(d|%64|%44)(e|%65|%45)(_|%5f)(m|%6d|%4d)(o|%6f|%4f)(d|%64|%44)(u|%75|%55)(l|%6c|%4c)(e|%65|%45)(s|%73|%53))(\\|\/|$)/i;
const invalidPackageNameRegEx = /^\.|%|\\/;
const patternRegEx = /\*/g;
const encodedSepRegEx = /%2f|%5c/i;
const emittedPackageWarnings = new Set();
const doubleSlashRegEx = /[/\\]{2}/;
function emitInvalidSegmentDeprecation(target, request, match, packageJsonUrl, internal, base, isTarget) {
  if (_process().noDeprecation) {
    return;
  }
  const pjsonPath = (0, _url().fileURLToPath)(packageJsonUrl);
  const double = doubleSlashRegEx.exec(isTarget ? target : request) !== null;
  _process().emitWarning(`Use of deprecated ${double ? 'double slash' : 'leading or trailing slash matching'} resolving "${target}" for module ` + `request "${request}" ${request === match ? '' : `matched to "${match}" `}in the "${internal ? 'imports' : 'exports'}" field module resolution of the package at ${pjsonPath}${base ? ` imported from ${(0, _url().fileURLToPath)(base)}` : ''}.`, 'DeprecationWarning', 'DEP0166');
}
function emitLegacyIndexDeprecation(url, packageJsonUrl, base, main) {
  if (_process().noDeprecation) {
    return;
  }
  const format = defaultGetFormatWithoutErrors(url, {
    parentURL: base.href
  });
  if (format !== 'module') return;
  const urlPath = (0, _url().fileURLToPath)(url.href);
  const pkgPath = (0, _url().fileURLToPath)(new (_url().URL)('.', packageJsonUrl));
  const basePath = (0, _url().fileURLToPath)(base);
  if (!main) {
    _process().emitWarning(`No "main" or "exports" field defined in the package.json for ${pkgPath} resolving the main entry point "${urlPath.slice(pkgPath.length)}", imported from ${basePath}.\nDefault "index" lookups for the main are deprecated for ES modules.`, 'DeprecationWarning', 'DEP0151');
  } else if (_path().resolve(pkgPath, main) !== urlPath) {
    _process().emitWarning(`Package ${pkgPath} has a "main" field set to "${main}", ` + `excluding the full filename and extension to the resolved file at "${urlPath.slice(pkgPath.length)}", imported from ${basePath}.\n Automatic extension resolution of the "main" field is ` + 'deprecated for ES modules.', 'DeprecationWarning', 'DEP0151');
  }
}
function tryStatSync(path) {
  try {
    return (0, _fs().statSync)(path);
  } catch (_unused2) {
    return new (_fs().Stats)();
  }
}
function fileExists(url) {
  const stats = (0, _fs().statSync)(url, {
    throwIfNoEntry: false
  });
  const isFile = stats ? stats.isFile() : undefined;
  return isFile === null || isFile === undefined ? false : isFile;
}
function legacyMainResolve(packageJsonUrl, packageConfig, base) {
  let guess;
  if (packageConfig.main !== undefined) {
    guess = new (_url().URL)(packageConfig.main, packageJsonUrl);
    if (fileExists(guess)) return guess;
    const tries = [`./${packageConfig.main}.js`, `./${packageConfig.main}.json`, `./${packageConfig.main}.node`, `./${packageConfig.main}/index.js`, `./${packageConfig.main}/index.json`, `./${packageConfig.main}/index.node`];
    let i = -1;
    while (++i < tries.length) {
      guess = new (_url().URL)(tries[i], packageJsonUrl);
      if (fileExists(guess)) break;
      guess = undefined;
    }
    if (guess) {
      emitLegacyIndexDeprecation(guess, packageJsonUrl, base, packageConfig.main);
      return guess;
    }
  }
  const tries = ['./index.js', './index.json', './index.node'];
  let i = -1;
  while (++i < tries.length) {
    guess = new (_url().URL)(tries[i], packageJsonUrl);
    if (fileExists(guess)) break;
    guess = undefined;
  }
  if (guess) {
    emitLegacyIndexDeprecation(guess, packageJsonUrl, base, packageConfig.main);
    return guess;
  }
  throw new ERR_MODULE_NOT_FOUND((0, _url().fileURLToPath)(new (_url().URL)('.', packageJsonUrl)), (0, _url().fileURLToPath)(base));
}
function finalizeResolution(resolved, base, preserveSymlinks) {
  if (encodedSepRegEx.exec(resolved.pathname) !== null) {
    throw new ERR_INVALID_MODULE_SPECIFIER(resolved.pathname, 'must not include encoded "/" or "\\" characters', (0, _url().fileURLToPath)(base));
  }
  let filePath;
  try {
    filePath = (0, _url().fileURLToPath)(resolved);
  } catch (error) {
    const cause = error;
    Object.defineProperty(cause, 'input', {
      value: String(resolved)
    });
    Object.defineProperty(cause, 'module', {
      value: String(base)
    });
    throw cause;
  }
  const stats = tryStatSync(filePath.endsWith('/') ? filePath.slice(-1) : filePath);
  if (stats.isDirectory()) {
    const error = new ERR_UNSUPPORTED_DIR_IMPORT(filePath, (0, _url().fileURLToPath)(base));
    error.url = String(resolved);
    throw error;
  }
  if (!stats.isFile()) {
    const error = new ERR_MODULE_NOT_FOUND(filePath || resolved.pathname, base && (0, _url().fileURLToPath)(base), true);
    error.url = String(resolved);
    throw error;
  }
  if (!preserveSymlinks) {
    const real = (0, _fs().realpathSync)(filePath);
    const {
      search,
      hash
    } = resolved;
    resolved = (0, _url().pathToFileURL)(real + (filePath.endsWith(_path().sep) ? '/' : ''));
    resolved.search = search;
    resolved.hash = hash;
  }
  return resolved;
}
function importNotDefined(specifier, packageJsonUrl, base) {
  return new ERR_PACKAGE_IMPORT_NOT_DEFINED(specifier, packageJsonUrl && (0, _url().fileURLToPath)(new (_url().URL)('.', packageJsonUrl)), (0, _url().fileURLToPath)(base));
}
function exportsNotFound(subpath, packageJsonUrl, base) {
  return new ERR_PACKAGE_PATH_NOT_EXPORTED((0, _url().fileURLToPath)(new (_url().URL)('.', packageJsonUrl)), subpath, base && (0, _url().fileURLToPath)(base));
}
function throwInvalidSubpath(request, match, packageJsonUrl, internal, base) {
  const reason = `request is not a valid match in pattern "${match}" for the "${internal ? 'imports' : 'exports'}" resolution of ${(0, _url().fileURLToPath)(packageJsonUrl)}`;
  throw new ERR_INVALID_MODULE_SPECIFIER(request, reason, base && (0, _url().fileURLToPath)(base));
}
function invalidPackageTarget(subpath, target, packageJsonUrl, internal, base) {
  target = typeof target === 'object' && target !== null ? JSON.stringify(target, null, '') : `${target}`;
  return new ERR_INVALID_PACKAGE_TARGET((0, _url().fileURLToPath)(new (_url().URL)('.', packageJsonUrl)), subpath, target, internal, base && (0, _url().fileURLToPath)(base));
}
function resolvePackageTargetString(target, subpath, match, packageJsonUrl, base, pattern, internal, isPathMap, conditions) {
  if (subpath !== '' && !pattern && target[target.length - 1] !== '/') throw invalidPackageTarget(match, target, packageJsonUrl, internal, base);
  if (!target.startsWith('./')) {
    if (internal && !target.startsWith('../') && !target.startsWith('/')) {
      let isURL = false;
      try {
        new (_url().URL)(target);
        isURL = true;
      } catch (_unused3) {}
      if (!isURL) {
        const exportTarget = pattern ? RegExpPrototypeSymbolReplace.call(patternRegEx, target, () => subpath) : target + subpath;
        return packageResolve(exportTarget, packageJsonUrl, conditions);
      }
    }
    throw invalidPackageTarget(match, target, packageJsonUrl, internal, base);
  }
  if (invalidSegmentRegEx.exec(target.slice(2)) !== null) {
    if (deprecatedInvalidSegmentRegEx.exec(target.slice(2)) === null) {
      if (!isPathMap) {
        const request = pattern ? match.replace('*', () => subpath) : match + subpath;
        const resolvedTarget = pattern ? RegExpPrototypeSymbolReplace.call(patternRegEx, target, () => subpath) : target;
        emitInvalidSegmentDeprecation(resolvedTarget, request, match, packageJsonUrl, internal, base, true);
      }
    } else {
      throw invalidPackageTarget(match, target, packageJsonUrl, internal, base);
    }
  }
  const resolved = new (_url().URL)(target, packageJsonUrl);
  const resolvedPath = resolved.pathname;
  const packagePath = new (_url().URL)('.', packageJsonUrl).pathname;
  if (!resolvedPath.startsWith(packagePath)) throw invalidPackageTarget(match, target, packageJsonUrl, internal, base);
  if (subpath === '') return resolved;
  if (invalidSegmentRegEx.exec(subpath) !== null) {
    const request = pattern ? match.replace('*', () => subpath) : match + subpath;
    if (deprecatedInvalidSegmentRegEx.exec(subpath) === null) {
      if (!isPathMap) {
        const resolvedTarget = pattern ? RegExpPrototypeSymbolReplace.call(patternRegEx, target, () => subpath) : target;
        emitInvalidSegmentDeprecation(resolvedTarget, request, match, packageJsonUrl, internal, base, false);
      }
    } else {
      throwInvalidSubpath(request, match, packageJsonUrl, internal, base);
    }
  }
  if (pattern) {
    return new (_url().URL)(RegExpPrototypeSymbolReplace.call(patternRegEx, resolved.href, () => subpath));
  }
  return new (_url().URL)(subpath, resolved);
}
function isArrayIndex(key) {
  const keyNumber = Number(key);
  if (`${keyNumber}` !== key) return false;
  return keyNumber >= 0 && keyNumber < 0xffffffff;
}
function resolvePackageTarget(packageJsonUrl, target, subpath, packageSubpath, base, pattern, internal, isPathMap, conditions) {
  if (typeof target === 'string') {
    return resolvePackageTargetString(target, subpath, packageSubpath, packageJsonUrl, base, pattern, internal, isPathMap, conditions);
  }
  if (Array.isArray(target)) {
    const targetList = target;
    if (targetList.length === 0) return null;
    let lastException;
    let i = -1;
    while (++i < targetList.length) {
      const targetItem = targetList[i];
      let resolveResult;
      try {
        resolveResult = resolvePackageTarget(packageJsonUrl, targetItem, subpath, packageSubpath, base, pattern, internal, isPathMap, conditions);
      } catch (error) {
        const exception = error;
        lastException = exception;
        if (exception.code === 'ERR_INVALID_PACKAGE_TARGET') continue;
        throw error;
      }
      if (resolveResult === undefined) continue;
      if (resolveResult === null) {
        lastException = null;
        continue;
      }
      return resolveResult;
    }
    if (lastException === undefined || lastException === null) {
      return null;
    }
    throw lastException;
  }
  if (typeof target === 'object' && target !== null) {
    const keys = Object.getOwnPropertyNames(target);
    let i = -1;
    while (++i < keys.length) {
      const key = keys[i];
      if (isArrayIndex(key)) {
        throw new ERR_INVALID_PACKAGE_CONFIG((0, _url().fileURLToPath)(packageJsonUrl), base, '"exports" cannot contain numeric property keys.');
      }
    }
    i = -1;
    while (++i < keys.length) {
      const key = keys[i];
      if (key === 'default' || conditions && conditions.has(key)) {
        const conditionalTarget = target[key];
        const resolveResult = resolvePackageTarget(packageJsonUrl, conditionalTarget, subpath, packageSubpath, base, pattern, internal, isPathMap, conditions);
        if (resolveResult === undefined) continue;
        return resolveResult;
      }
    }
    return null;
  }
  if (target === null) {
    return null;
  }
  throw invalidPackageTarget(packageSubpath, target, packageJsonUrl, internal, base);
}
function isConditionalExportsMainSugar(exports, packageJsonUrl, base) {
  if (typeof exports === 'string' || Array.isArray(exports)) return true;
  if (typeof exports !== 'object' || exports === null) return false;
  const keys = Object.getOwnPropertyNames(exports);
  let isConditionalSugar = false;
  let i = 0;
  let j = -1;
  while (++j < keys.length) {
    const key = keys[j];
    const curIsConditionalSugar = key === '' || key[0] !== '.';
    if (i++ === 0) {
      isConditionalSugar = curIsConditionalSugar;
    } else if (isConditionalSugar !== curIsConditionalSugar) {
      throw new ERR_INVALID_PACKAGE_CONFIG((0, _url().fileURLToPath)(packageJsonUrl), base, '"exports" cannot contain some keys starting with \'.\' and some not.' + ' The exports object must either be an object of package subpath keys' + ' or an object of main entry condition name keys only.');
    }
  }
  return isConditionalSugar;
}
function emitTrailingSlashPatternDeprecation(match, pjsonUrl, base) {
  if (_process().noDeprecation) {
    return;
  }
  const pjsonPath = (0, _url().fileURLToPath)(pjsonUrl);
  if (emittedPackageWarnings.has(pjsonPath + '|' + match)) return;
  emittedPackageWarnings.add(pjsonPath + '|' + match);
  _process().emitWarning(`Use of deprecated trailing slash pattern mapping "${match}" in the ` + `"exports" field module resolution of the package at ${pjsonPath}${base ? ` imported from ${(0, _url().fileURLToPath)(base)}` : ''}. Mapping specifiers ending in "/" is no longer supported.`, 'DeprecationWarning', 'DEP0155');
}
function packageExportsResolve(packageJsonUrl, packageSubpath, packageConfig, base, conditions) {
  let exports = packageConfig.exports;
  if (isConditionalExportsMainSugar(exports, packageJsonUrl, base)) {
    exports = {
      '.': exports
    };
  }
  if (own.call(exports, packageSubpath) && !packageSubpath.includes('*') && !packageSubpath.endsWith('/')) {
    const target = exports[packageSubpath];
    const resolveResult = resolvePackageTarget(packageJsonUrl, target, '', packageSubpath, base, false, false, false, conditions);
    if (resolveResult === null || resolveResult === undefined) {
      throw exportsNotFound(packageSubpath, packageJsonUrl, base);
    }
    return resolveResult;
  }
  let bestMatch = '';
  let bestMatchSubpath = '';
  const keys = Object.getOwnPropertyNames(exports);
  let i = -1;
  while (++i < keys.length) {
    const key = keys[i];
    const patternIndex = key.indexOf('*');
    if (patternIndex !== -1 && packageSubpath.startsWith(key.slice(0, patternIndex))) {
      if (packageSubpath.endsWith('/')) {
        emitTrailingSlashPatternDeprecation(packageSubpath, packageJsonUrl, base);
      }
      const patternTrailer = key.slice(patternIndex + 1);
      if (packageSubpath.length >= key.length && packageSubpath.endsWith(patternTrailer) && patternKeyCompare(bestMatch, key) === 1 && key.lastIndexOf('*') === patternIndex) {
        bestMatch = key;
        bestMatchSubpath = packageSubpath.slice(patternIndex, packageSubpath.length - patternTrailer.length);
      }
    }
  }
  if (bestMatch) {
    const target = exports[bestMatch];
    const resolveResult = resolvePackageTarget(packageJsonUrl, target, bestMatchSubpath, bestMatch, base, true, false, packageSubpath.endsWith('/'), conditions);
    if (resolveResult === null || resolveResult === undefined) {
      throw exportsNotFound(packageSubpath, packageJsonUrl, base);
    }
    return resolveResult;
  }
  throw exportsNotFound(packageSubpath, packageJsonUrl, base);
}
function patternKeyCompare(a, b) {
  const aPatternIndex = a.indexOf('*');
  const bPatternIndex = b.indexOf('*');
  const baseLengthA = aPatternIndex === -1 ? a.length : aPatternIndex + 1;
  const baseLengthB = bPatternIndex === -1 ? b.length : bPatternIndex + 1;
  if (baseLengthA > baseLengthB) return -1;
  if (baseLengthB > baseLengthA) return 1;
  if (aPatternIndex === -1) return 1;
  if (bPatternIndex === -1) return -1;
  if (a.length > b.length) return -1;
  if (b.length > a.length) return 1;
  return 0;
}
function packageImportsResolve(name, base, conditions) {
  if (name === '#' || name.startsWith('#/') || name.endsWith('/')) {
    const reason = 'is not a valid internal imports specifier name';
    throw new ERR_INVALID_MODULE_SPECIFIER(name, reason, (0, _url().fileURLToPath)(base));
  }
  let packageJsonUrl;
  const packageConfig = getPackageScopeConfig(base);
  if (packageConfig.exists) {
    packageJsonUrl = (0, _url().pathToFileURL)(packageConfig.pjsonPath);
    const imports = packageConfig.imports;
    if (imports) {
      if (own.call(imports, name) && !name.includes('*')) {
        const resolveResult = resolvePackageTarget(packageJsonUrl, imports[name], '', name, base, false, true, false, conditions);
        if (resolveResult !== null && resolveResult !== undefined) {
          return resolveResult;
        }
      } else {
        let bestMatch = '';
        let bestMatchSubpath = '';
        const keys = Object.getOwnPropertyNames(imports);
        let i = -1;
        while (++i < keys.length) {
          const key = keys[i];
          const patternIndex = key.indexOf('*');
          if (patternIndex !== -1 && name.startsWith(key.slice(0, -1))) {
            const patternTrailer = key.slice(patternIndex + 1);
            if (name.length >= key.length && name.endsWith(patternTrailer) && patternKeyCompare(bestMatch, key) === 1 && key.lastIndexOf('*') === patternIndex) {
              bestMatch = key;
              bestMatchSubpath = name.slice(patternIndex, name.length - patternTrailer.length);
            }
          }
        }
        if (bestMatch) {
          const target = imports[bestMatch];
          const resolveResult = resolvePackageTarget(packageJsonUrl, target, bestMatchSubpath, bestMatch, base, true, true, false, conditions);
          if (resolveResult !== null && resolveResult !== undefined) {
            return resolveResult;
          }
        }
      }
    }
  }
  throw importNotDefined(name, packageJsonUrl, base);
}
function parsePackageName(specifier, base) {
  let separatorIndex = specifier.indexOf('/');
  let validPackageName = true;
  let isScoped = false;
  if (specifier[0] === '@') {
    isScoped = true;
    if (separatorIndex === -1 || specifier.length === 0) {
      validPackageName = false;
    } else {
      separatorIndex = specifier.indexOf('/', separatorIndex + 1);
    }
  }
  const packageName = separatorIndex === -1 ? specifier : specifier.slice(0, separatorIndex);
  if (invalidPackageNameRegEx.exec(packageName) !== null) {
    validPackageName = false;
  }
  if (!validPackageName) {
    throw new ERR_INVALID_MODULE_SPECIFIER(specifier, 'is not a valid package name', (0, _url().fileURLToPath)(base));
  }
  const packageSubpath = '.' + (separatorIndex === -1 ? '' : specifier.slice(separatorIndex));
  return {
    packageName,
    packageSubpath,
    isScoped
  };
}
function packageResolve(specifier, base, conditions) {
  if (_module().builtinModules.includes(specifier)) {
    return new (_url().URL)('node:' + specifier);
  }
  const {
    packageName,
    packageSubpath,
    isScoped
  } = parsePackageName(specifier, base);
  const packageConfig = getPackageScopeConfig(base);
  if (packageConfig.exists) {
    const packageJsonUrl = (0, _url().pathToFileURL)(packageConfig.pjsonPath);
    if (packageConfig.name === packageName && packageConfig.exports !== undefined && packageConfig.exports !== null) {
      return packageExportsResolve(packageJsonUrl, packageSubpath, packageConfig, base, conditions);
    }
  }
  let packageJsonUrl = new (_url().URL)('./node_modules/' + packageName + '/package.json', base);
  let packageJsonPath = (0, _url().fileURLToPath)(packageJsonUrl);
  let lastPath;
  do {
    const stat = tryStatSync(packageJsonPath.slice(0, -13));
    if (!stat.isDirectory()) {
      lastPath = packageJsonPath;
      packageJsonUrl = new (_url().URL)((isScoped ? '../../../../node_modules/' : '../../../node_modules/') + packageName + '/package.json', packageJsonUrl);
      packageJsonPath = (0, _url().fileURLToPath)(packageJsonUrl);
      continue;
    }
    const packageConfig = packageJsonReader.read(packageJsonPath, {
      base,
      specifier
    });
    if (packageConfig.exports !== undefined && packageConfig.exports !== null) {
      return packageExportsResolve(packageJsonUrl, packageSubpath, packageConfig, base, conditions);
    }
    if (packageSubpath === '.') {
      return legacyMainResolve(packageJsonUrl, packageConfig, base);
    }
    return new (_url().URL)(packageSubpath, packageJsonUrl);
  } while (packageJsonPath.length !== lastPath.length);
  throw new ERR_MODULE_NOT_FOUND(packageName, (0, _url().fileURLToPath)(base), false);
}
function isRelativeSpecifier(specifier) {
  if (specifier[0] === '.') {
    if (specifier.length === 1 || specifier[1] === '/') return true;
    if (specifier[1] === '.' && (specifier.length === 2 || specifier[2] === '/')) {
      return true;
    }
  }
  return false;
}
function shouldBeTreatedAsRelativeOrAbsolutePath(specifier) {
  if (specifier === '') return false;
  if (specifier[0] === '/') return true;
  return isRelativeSpecifier(specifier);
}
function moduleResolve(specifier, base, conditions, preserveSymlinks) {
  const protocol = base.protocol;
  const isRemote = protocol === 'http:' || protocol === 'https:';
  let resolved;
  if (shouldBeTreatedAsRelativeOrAbsolutePath(specifier)) {
    resolved = new (_url().URL)(specifier, base);
  } else if (!isRemote && specifier[0] === '#') {
    resolved = packageImportsResolve(specifier, base, conditions);
  } else {
    try {
      resolved = new (_url().URL)(specifier);
    } catch (_unused4) {
      if (!isRemote) {
        resolved = packageResolve(specifier, base, conditions);
      }
    }
  }
  _assert()(resolved !== undefined, 'expected to be defined');
  if (resolved.protocol !== 'file:') {
    return resolved;
  }
  return finalizeResolution(resolved, base, preserveSymlinks);
}
function checkIfDisallowedImport(specifier, parsed, parsedParentURL) {
  if (parsedParentURL) {
    const parentProtocol = parsedParentURL.protocol;
    if (parentProtocol === 'http:' || parentProtocol === 'https:') {
      if (shouldBeTreatedAsRelativeOrAbsolutePath(specifier)) {
        const parsedProtocol = parsed == null ? void 0 : parsed.protocol;
        if (parsedProtocol && parsedProtocol !== 'https:' && parsedProtocol !== 'http:') {
          throw new ERR_NETWORK_IMPORT_DISALLOWED(specifier, parsedParentURL, 'remote imports cannot import from a local location.');
        }
        return {
          url: (parsed == null ? void 0 : parsed.href) || ''
        };
      }
      if (_module().builtinModules.includes(specifier)) {
        throw new ERR_NETWORK_IMPORT_DISALLOWED(specifier, parsedParentURL, 'remote imports cannot import from a local location.');
      }
      throw new ERR_NETWORK_IMPORT_DISALLOWED(specifier, parsedParentURL, 'only relative and absolute specifiers are supported.');
    }
  }
}
function isURL(self) {
  return Boolean(self && typeof self === 'object' && 'href' in self && typeof self.href === 'string' && 'protocol' in self && typeof self.protocol === 'string' && self.href && self.protocol);
}
function throwIfInvalidParentURL(parentURL) {
  if (parentURL === undefined) {
    return;
  }
  if (typeof parentURL !== 'string' && !isURL(parentURL)) {
    throw new codes.ERR_INVALID_ARG_TYPE('parentURL', ['string', 'URL'], parentURL);
  }
}
function defaultResolve(specifier, context = {}) {
  const {
    parentURL
  } = context;
  _assert()(parentURL !== undefined, 'expected `parentURL` to be defined');
  throwIfInvalidParentURL(parentURL);
  let parsedParentURL;
  if (parentURL) {
    try {
      parsedParentURL = new (_url().URL)(parentURL);
    } catch (_unused5) {}
  }
  let parsed;
  try {
    parsed = shouldBeTreatedAsRelativeOrAbsolutePath(specifier) ? new (_url().URL)(specifier, parsedParentURL) : new (_url().URL)(specifier);
    const protocol = parsed.protocol;
    if (protocol === 'data:') {
      return {
        url: parsed.href,
        format: null
      };
    }
  } catch (_unused6) {}
  const maybeReturn = checkIfDisallowedImport(specifier, parsed, parsedParentURL);
  if (maybeReturn) return maybeReturn;
  if (parsed && parsed.protocol === 'node:') return {
    url: specifier
  };
  const conditions = getConditionsSet(context.conditions);
  const url = moduleResolve(specifier, new (_url().URL)(parentURL), conditions, false);
  return {
    url: url.href,
    format: defaultGetFormatWithoutErrors(url, {
      parentURL
    })
  };
}
function resolve$2(specifier, parent) {
  if (!parent) {
    throw new Error('Please pass `parent`: `import-meta-resolve` cannot ponyfill that');
  }
  try {
    return defaultResolve(specifier, {
      parentURL: parent
    }).url;
  } catch (error) {
    const exception = error;
    if ((exception.code === 'ERR_UNSUPPORTED_DIR_IMPORT' || exception.code === 'ERR_MODULE_NOT_FOUND') && typeof exception.url === 'string') {
      return exception.url;
    }
    throw error;
  }
}

var hasRequiredPlugins;

function requirePlugins () {
	if (hasRequiredPlugins) return plugins;
	hasRequiredPlugins = 1;

	Object.defineProperty(plugins, "__esModule", {
	  value: true
	});
	plugins.loadPlugin = loadPlugin;
	plugins.loadPreset = loadPreset;
	plugins.resolvePreset = plugins.resolvePlugin = void 0;
	function _debug() {
	  const data = srcExports;
	  _debug = function () {
	    return data;
	  };
	  return data;
	}
	function _path() {
	  const data = path__default["default"];
	  _path = function () {
	    return data;
	  };
	  return data;
	}
	var _async = async$2;
	var _moduleTypes = requireModuleTypes();
	function _url() {
	  const data = require$$1__default["default"];
	  _url = function () {
	    return data;
	  };
	  return data;
	}
	var _importMetaResolve = importMetaResolve;
	function _fs() {
	  const data = require$$0__default["default"];
	  _fs = function () {
	    return data;
	  };
	  return data;
	}
	const debug = _debug()("babel:config:loading:files:plugins");
	const EXACT_RE = /^module:/;
	const BABEL_PLUGIN_PREFIX_RE = /^(?!@|module:|[^/]+\/|babel-plugin-)/;
	const BABEL_PRESET_PREFIX_RE = /^(?!@|module:|[^/]+\/|babel-preset-)/;
	const BABEL_PLUGIN_ORG_RE = /^(@babel\/)(?!plugin-|[^/]+\/)/;
	const BABEL_PRESET_ORG_RE = /^(@babel\/)(?!preset-|[^/]+\/)/;
	const OTHER_PLUGIN_ORG_RE = /^(@(?!babel\/)[^/]+\/)(?![^/]*babel-plugin(?:-|\/|$)|[^/]+\/)/;
	const OTHER_PRESET_ORG_RE = /^(@(?!babel\/)[^/]+\/)(?![^/]*babel-preset(?:-|\/|$)|[^/]+\/)/;
	const OTHER_ORG_DEFAULT_RE = /^(@(?!babel$)[^/]+)$/;
	const resolvePlugin = plugins.resolvePlugin = resolveStandardizedName.bind(null, "plugin");
	const resolvePreset = plugins.resolvePreset = resolveStandardizedName.bind(null, "preset");
	function* loadPlugin(name, dirname) {
	  const filepath = resolvePlugin(name, dirname, yield* (0, _async.isAsync)());
	  const value = yield* requireModule("plugin", filepath);
	  debug("Loaded plugin %o from %o.", name, dirname);
	  return {
	    filepath,
	    value
	  };
	}
	function* loadPreset(name, dirname) {
	  const filepath = resolvePreset(name, dirname, yield* (0, _async.isAsync)());
	  const value = yield* requireModule("preset", filepath);
	  debug("Loaded preset %o from %o.", name, dirname);
	  return {
	    filepath,
	    value
	  };
	}
	function standardizeName(type, name) {
	  if (_path().isAbsolute(name)) return name;
	  const isPreset = type === "preset";
	  return name.replace(isPreset ? BABEL_PRESET_PREFIX_RE : BABEL_PLUGIN_PREFIX_RE, `babel-${type}-`).replace(isPreset ? BABEL_PRESET_ORG_RE : BABEL_PLUGIN_ORG_RE, `$1${type}-`).replace(isPreset ? OTHER_PRESET_ORG_RE : OTHER_PLUGIN_ORG_RE, `$1babel-${type}-`).replace(OTHER_ORG_DEFAULT_RE, `$1/babel-${type}`).replace(EXACT_RE, "");
	}
	function* resolveAlternativesHelper(type, name) {
	  const standardizedName = standardizeName(type, name);
	  const {
	    error,
	    value
	  } = yield standardizedName;
	  if (!error) return value;
	  if (error.code !== "MODULE_NOT_FOUND") throw error;
	  if (standardizedName !== name && !(yield name).error) {
	    error.message += `\n- If you want to resolve "${name}", use "module:${name}"`;
	  }
	  if (!(yield standardizeName(type, "@babel/" + name)).error) {
	    error.message += `\n- Did you mean "@babel/${name}"?`;
	  }
	  const oppositeType = type === "preset" ? "plugin" : "preset";
	  if (!(yield standardizeName(oppositeType, name)).error) {
	    error.message += `\n- Did you accidentally pass a ${oppositeType} as a ${type}?`;
	  }
	  if (type === "plugin") {
	    const transformName = standardizedName.replace("-proposal-", "-transform-");
	    if (transformName !== standardizedName && !(yield transformName).error) {
	      error.message += `\n- Did you mean "${transformName}"?`;
	    }
	  }
	  error.message += `\n
Make sure that all the Babel plugins and presets you are using
are defined as dependencies or devDependencies in your package.json
file. It's possible that the missing plugin is loaded by a preset
you are using that forgot to add the plugin to its dependencies: you
can workaround this problem by explicitly adding the missing package
to your top-level package.json.
`;
	  throw error;
	}
	function tryRequireResolve(id, dirname) {
	  try {
	    if (dirname) {
	      return {
	        error: null,
	        value: (((v, w) => (v = v.split("."), w = w.split("."), +v[0] > +w[0] || v[0] == w[0] && +v[1] >= +w[1]))(process.versions.node, "8.9") ? require.resolve : (r, {
	          paths: [b]
	        }, M = require("module")) => {
	          let f = M._findPath(r, M._nodeModulePaths(b).concat(b));
	          if (f) return f;
	          f = new Error(`Cannot resolve module '${r}'`);
	          f.code = "MODULE_NOT_FOUND";
	          throw f;
	        })(id, {
	          paths: [dirname]
	        })
	      };
	    } else {
	      return {
	        error: null,
	        value: require.resolve(id)
	      };
	    }
	  } catch (error) {
	    return {
	      error,
	      value: null
	    };
	  }
	}
	function tryImportMetaResolve(id, options) {
	  try {
	    return {
	      error: null,
	      value: (0, _importMetaResolve.resolve)(id, options)
	    };
	  } catch (error) {
	    return {
	      error,
	      value: null
	    };
	  }
	}
	function resolveStandardizedNameForRequire(type, name, dirname) {
	  const it = resolveAlternativesHelper(type, name);
	  let res = it.next();
	  while (!res.done) {
	    res = it.next(tryRequireResolve(res.value, dirname));
	  }
	  return res.value;
	}
	function resolveStandardizedNameForImport(type, name, dirname) {
	  const parentUrl = (0, _url().pathToFileURL)(_path().join(dirname, "./babel-virtual-resolve-base.js")).href;
	  const it = resolveAlternativesHelper(type, name);
	  let res = it.next();
	  while (!res.done) {
	    res = it.next(tryImportMetaResolve(res.value, parentUrl));
	  }
	  return (0, _url().fileURLToPath)(res.value);
	}
	function resolveStandardizedName(type, name, dirname, resolveESM) {
	  if (!_moduleTypes.supportsESM || !resolveESM) {
	    return resolveStandardizedNameForRequire(type, name, dirname);
	  }
	  try {
	    const resolved = resolveStandardizedNameForImport(type, name, dirname);
	    if (!(0, _fs().existsSync)(resolved)) {
	      throw Object.assign(new Error(`Could not resolve "${name}" in file ${dirname}.`), {
	        type: "MODULE_NOT_FOUND"
	      });
	    }
	    return resolved;
	  } catch (e) {
	    try {
	      return resolveStandardizedNameForRequire(type, name, dirname);
	    } catch (e2) {
	      if (e.type === "MODULE_NOT_FOUND") throw e;
	      if (e2.type === "MODULE_NOT_FOUND") throw e2;
	      throw e;
	    }
	  }
	}
	{
	  var LOADING_MODULES = new Set();
	}
	function* requireModule(type, name) {
	  {
	    if (!(yield* (0, _async.isAsync)()) && LOADING_MODULES.has(name)) {
	      throw new Error(`Reentrant ${type} detected trying to load "${name}". This module is not ignored ` + "and is trying to load itself while compiling itself, leading to a dependency cycle. " + 'We recommend adding it to your "ignore" list in your babelrc, or to a .babelignore.');
	    }
	  }
	  try {
	    {
	      LOADING_MODULES.add(name);
	    }
	    {
	      return yield* (0, _moduleTypes.default)(name, `You appear to be using a native ECMAScript module ${type}, ` + "which is only supported when running Babel asynchronously.", true);
	    }
	  } catch (err) {
	    err.message = `[BABEL]: ${err.message} (While processing: ${name})`;
	    throw err;
	  } finally {
	    {
	      LOADING_MODULES.delete(name);
	    }
	  }
	}

	
	return plugins;
}

var hasRequiredFiles;

function requireFiles () {
	if (hasRequiredFiles) return files;
	hasRequiredFiles = 1;
	(function (exports) {

		Object.defineProperty(exports, "__esModule", {
		  value: true
		});
		Object.defineProperty(exports, "ROOT_CONFIG_FILENAMES", {
		  enumerable: true,
		  get: function () {
		    return _configuration.ROOT_CONFIG_FILENAMES;
		  }
		});
		Object.defineProperty(exports, "findConfigUpwards", {
		  enumerable: true,
		  get: function () {
		    return _configuration.findConfigUpwards;
		  }
		});
		Object.defineProperty(exports, "findPackageData", {
		  enumerable: true,
		  get: function () {
		    return _package$1.findPackageData;
		  }
		});
		Object.defineProperty(exports, "findRelativeConfig", {
		  enumerable: true,
		  get: function () {
		    return _configuration.findRelativeConfig;
		  }
		});
		Object.defineProperty(exports, "findRootConfig", {
		  enumerable: true,
		  get: function () {
		    return _configuration.findRootConfig;
		  }
		});
		Object.defineProperty(exports, "loadConfig", {
		  enumerable: true,
		  get: function () {
		    return _configuration.loadConfig;
		  }
		});
		Object.defineProperty(exports, "loadPlugin", {
		  enumerable: true,
		  get: function () {
		    return _plugins.loadPlugin;
		  }
		});
		Object.defineProperty(exports, "loadPreset", {
		  enumerable: true,
		  get: function () {
		    return _plugins.loadPreset;
		  }
		});
		Object.defineProperty(exports, "resolvePlugin", {
		  enumerable: true,
		  get: function () {
		    return _plugins.resolvePlugin;
		  }
		});
		Object.defineProperty(exports, "resolvePreset", {
		  enumerable: true,
		  get: function () {
		    return _plugins.resolvePreset;
		  }
		});
		Object.defineProperty(exports, "resolveShowConfigPath", {
		  enumerable: true,
		  get: function () {
		    return _configuration.resolveShowConfigPath;
		  }
		});
		var _package$1 = _package;
		var _configuration = requireConfiguration();
		var _plugins = requirePlugins();

		
	} (files));
	return files;
}

var transform = {};

var hasRequiredTransform;

function requireTransform () {
	if (hasRequiredTransform) return transform;
	hasRequiredTransform = 1;

	Object.defineProperty(transform, "__esModule", {
	  value: true
	});
	transform.transform = void 0;
	transform.transformAsync = transformAsync;
	transform.transformSync = transformSync;
	function _gensync() {
	  const data = requireGensync();
	  _gensync = function () {
	    return data;
	  };
	  return data;
	}
	var _index = requireConfig();
	var _index2 = requireTransformation();
	var _rewriteStackTrace = rewriteStackTrace;
	const transformRunner = _gensync()(function* transform(code, opts) {
	  const config = yield* (0, _index.default)(opts);
	  if (config === null) return null;
	  return yield* (0, _index2.run)(config, code);
	});
	transform.transform = function transform(code, optsOrCallback, maybeCallback) {
	  let opts;
	  let callback;
	  if (typeof optsOrCallback === "function") {
	    callback = optsOrCallback;
	    opts = undefined;
	  } else {
	    opts = optsOrCallback;
	    callback = maybeCallback;
	  }
	  if (callback === undefined) {
	    {
	      return (0, _rewriteStackTrace.beginHiddenCallStack)(transformRunner.sync)(code, opts);
	    }
	  }
	  (0, _rewriteStackTrace.beginHiddenCallStack)(transformRunner.errback)(code, opts, callback);
	};
	function transformSync(...args) {
	  return (0, _rewriteStackTrace.beginHiddenCallStack)(transformRunner.sync)(...args);
	}
	function transformAsync(...args) {
	  return (0, _rewriteStackTrace.beginHiddenCallStack)(transformRunner.async)(...args);
	}

	
	return transform;
}

var transformAst = {};

var hasRequiredTransformAst;

function requireTransformAst () {
	if (hasRequiredTransformAst) return transformAst;
	hasRequiredTransformAst = 1;

	Object.defineProperty(transformAst, "__esModule", {
	  value: true
	});
	transformAst.transformFromAst = void 0;
	transformAst.transformFromAstAsync = transformFromAstAsync;
	transformAst.transformFromAstSync = transformFromAstSync;
	function _gensync() {
	  const data = requireGensync();
	  _gensync = function () {
	    return data;
	  };
	  return data;
	}
	var _index = requireConfig();
	var _index2 = requireTransformation();
	var _rewriteStackTrace = rewriteStackTrace;
	const transformFromAstRunner = _gensync()(function* (ast, code, opts) {
	  const config = yield* (0, _index.default)(opts);
	  if (config === null) return null;
	  if (!ast) throw new Error("No AST given");
	  return yield* (0, _index2.run)(config, code, ast);
	});
	transformAst.transformFromAst = function transformFromAst(ast, code, optsOrCallback, maybeCallback) {
	  let opts;
	  let callback;
	  if (typeof optsOrCallback === "function") {
	    callback = optsOrCallback;
	    opts = undefined;
	  } else {
	    opts = optsOrCallback;
	    callback = maybeCallback;
	  }
	  if (callback === undefined) {
	    {
	      return (0, _rewriteStackTrace.beginHiddenCallStack)(transformFromAstRunner.sync)(ast, code, opts);
	    }
	  }
	  (0, _rewriteStackTrace.beginHiddenCallStack)(transformFromAstRunner.errback)(ast, code, opts, callback);
	};
	function transformFromAstSync(...args) {
	  return (0, _rewriteStackTrace.beginHiddenCallStack)(transformFromAstRunner.sync)(...args);
	}
	function transformFromAstAsync(...args) {
	  return (0, _rewriteStackTrace.beginHiddenCallStack)(transformFromAstRunner.async)(...args);
	}

	
	return transformAst;
}

var parse$2 = {};

var hasRequiredParse;

function requireParse () {
	if (hasRequiredParse) return parse$2;
	hasRequiredParse = 1;

	Object.defineProperty(parse$2, "__esModule", {
	  value: true
	});
	parse$2.parse = void 0;
	parse$2.parseAsync = parseAsync;
	parse$2.parseSync = parseSync;
	function _gensync() {
	  const data = requireGensync();
	  _gensync = function () {
	    return data;
	  };
	  return data;
	}
	var _index = requireConfig();
	var _index2 = parser$1;
	var _normalizeOpts = normalizeOpts;
	var _rewriteStackTrace = rewriteStackTrace;
	const parseRunner = _gensync()(function* parse(code, opts) {
	  const config = yield* (0, _index.default)(opts);
	  if (config === null) {
	    return null;
	  }
	  return yield* (0, _index2.default)(config.passes, (0, _normalizeOpts.default)(config), code);
	});
	parse$2.parse = function parse(code, opts, callback) {
	  if (typeof opts === "function") {
	    callback = opts;
	    opts = undefined;
	  }
	  if (callback === undefined) {
	    {
	      return (0, _rewriteStackTrace.beginHiddenCallStack)(parseRunner.sync)(code, opts);
	    }
	  }
	  (0, _rewriteStackTrace.beginHiddenCallStack)(parseRunner.errback)(code, opts, callback);
	};
	function parseSync(...args) {
	  return (0, _rewriteStackTrace.beginHiddenCallStack)(parseRunner.sync)(...args);
	}
	function parseAsync(...args) {
	  return (0, _rewriteStackTrace.beginHiddenCallStack)(parseRunner.async)(...args);
	}

	
	return parse$2;
}

var hasRequiredLib;

function requireLib () {
	if (hasRequiredLib) return lib$j;
	hasRequiredLib = 1;
	(function (exports) {

		Object.defineProperty(exports, "__esModule", {
		  value: true
		});
		exports.DEFAULT_EXTENSIONS = void 0;
		Object.defineProperty(exports, "File", {
		  enumerable: true,
		  get: function () {
		    return _file.default;
		  }
		});
		Object.defineProperty(exports, "buildExternalHelpers", {
		  enumerable: true,
		  get: function () {
		    return _buildExternalHelpers.default;
		  }
		});
		Object.defineProperty(exports, "createConfigItem", {
		  enumerable: true,
		  get: function () {
		    return _index2.createConfigItem;
		  }
		});
		Object.defineProperty(exports, "createConfigItemAsync", {
		  enumerable: true,
		  get: function () {
		    return _index2.createConfigItemAsync;
		  }
		});
		Object.defineProperty(exports, "createConfigItemSync", {
		  enumerable: true,
		  get: function () {
		    return _index2.createConfigItemSync;
		  }
		});
		Object.defineProperty(exports, "getEnv", {
		  enumerable: true,
		  get: function () {
		    return _environment.getEnv;
		  }
		});
		Object.defineProperty(exports, "loadOptions", {
		  enumerable: true,
		  get: function () {
		    return _index2.loadOptions;
		  }
		});
		Object.defineProperty(exports, "loadOptionsAsync", {
		  enumerable: true,
		  get: function () {
		    return _index2.loadOptionsAsync;
		  }
		});
		Object.defineProperty(exports, "loadOptionsSync", {
		  enumerable: true,
		  get: function () {
		    return _index2.loadOptionsSync;
		  }
		});
		Object.defineProperty(exports, "loadPartialConfig", {
		  enumerable: true,
		  get: function () {
		    return _index2.loadPartialConfig;
		  }
		});
		Object.defineProperty(exports, "loadPartialConfigAsync", {
		  enumerable: true,
		  get: function () {
		    return _index2.loadPartialConfigAsync;
		  }
		});
		Object.defineProperty(exports, "loadPartialConfigSync", {
		  enumerable: true,
		  get: function () {
		    return _index2.loadPartialConfigSync;
		  }
		});
		Object.defineProperty(exports, "parse", {
		  enumerable: true,
		  get: function () {
		    return _parse.parse;
		  }
		});
		Object.defineProperty(exports, "parseAsync", {
		  enumerable: true,
		  get: function () {
		    return _parse.parseAsync;
		  }
		});
		Object.defineProperty(exports, "parseSync", {
		  enumerable: true,
		  get: function () {
		    return _parse.parseSync;
		  }
		});
		Object.defineProperty(exports, "resolvePlugin", {
		  enumerable: true,
		  get: function () {
		    return _index.resolvePlugin;
		  }
		});
		Object.defineProperty(exports, "resolvePreset", {
		  enumerable: true,
		  get: function () {
		    return _index.resolvePreset;
		  }
		});
		Object.defineProperty((exports), "template", {
		  enumerable: true,
		  get: function () {
		    return _template().default;
		  }
		});
		Object.defineProperty((exports), "tokTypes", {
		  enumerable: true,
		  get: function () {
		    return _parser().tokTypes;
		  }
		});
		Object.defineProperty(exports, "transform", {
		  enumerable: true,
		  get: function () {
		    return _transform.transform;
		  }
		});
		Object.defineProperty(exports, "transformAsync", {
		  enumerable: true,
		  get: function () {
		    return _transform.transformAsync;
		  }
		});
		Object.defineProperty(exports, "transformFile", {
		  enumerable: true,
		  get: function () {
		    return _transformFile.transformFile;
		  }
		});
		Object.defineProperty(exports, "transformFileAsync", {
		  enumerable: true,
		  get: function () {
		    return _transformFile.transformFileAsync;
		  }
		});
		Object.defineProperty(exports, "transformFileSync", {
		  enumerable: true,
		  get: function () {
		    return _transformFile.transformFileSync;
		  }
		});
		Object.defineProperty(exports, "transformFromAst", {
		  enumerable: true,
		  get: function () {
		    return _transformAst.transformFromAst;
		  }
		});
		Object.defineProperty(exports, "transformFromAstAsync", {
		  enumerable: true,
		  get: function () {
		    return _transformAst.transformFromAstAsync;
		  }
		});
		Object.defineProperty(exports, "transformFromAstSync", {
		  enumerable: true,
		  get: function () {
		    return _transformAst.transformFromAstSync;
		  }
		});
		Object.defineProperty(exports, "transformSync", {
		  enumerable: true,
		  get: function () {
		    return _transform.transformSync;
		  }
		});
		Object.defineProperty((exports), "traverse", {
		  enumerable: true,
		  get: function () {
		    return _traverse().default;
		  }
		});
		exports.version = exports.types = void 0;
		var _file = requireFile();
		var _buildExternalHelpers = requireBuildExternalHelpers();
		var _index = requireFiles();
		var _environment = environment;
		function _types() {
		  const data = requireLib$h();
		  _types = function () {
		    return data;
		  };
		  return data;
		}
		Object.defineProperty((exports), "types", {
		  enumerable: true,
		  get: function () {
		    return _types();
		  }
		});
		function _parser() {
		  const data = requireLib$b();
		  _parser = function () {
		    return data;
		  };
		  return data;
		}
		function _traverse() {
		  const data = requireLib$7();
		  _traverse = function () {
		    return data;
		  };
		  return data;
		}
		function _template() {
		  const data = requireLib$9();
		  _template = function () {
		    return data;
		  };
		  return data;
		}
		var _index2 = requireConfig();
		var _transform = requireTransform();
		var _transformFile = requireTransformFile();
		var _transformAst = requireTransformAst();
		var _parse = requireParse();
		requireLib();
		exports.version = "7.24.5";
		exports.DEFAULT_EXTENSIONS = Object.freeze([".js", ".jsx", ".es6", ".es", ".mjs", ".cjs"]);
		{
		  exports.OptionManager = class OptionManager {
		    init(opts) {
		      return (0, _index2.loadOptionsSync)(opts);
		    }
		  };
		  exports.Plugin = function Plugin(alias) {
		    throw new Error(`The (${alias}) Babel 5 plugin is being run with an unsupported Babel version.`);
		  };
		}

		
	} (lib$j));
	return lib$j;
}

var cjs = {};

(function (exports) {

	Object.defineProperty(exports, '__esModule', { value: true });

	var path = path__default["default"];
	var pm = picomatch$1;

	function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

	var pm__default = /*#__PURE__*/_interopDefaultLegacy(pm);

	const addExtension = function addExtension(filename, ext = '.js') {
	    let result = `${filename}`;
	    if (!path.extname(filename))
	        result += ext;
	    return result;
	};

	class WalkerBase {constructor() { WalkerBase.prototype.__init.call(this);WalkerBase.prototype.__init2.call(this);WalkerBase.prototype.__init3.call(this);WalkerBase.prototype.__init4.call(this); }
		 __init() {this.should_skip = false;}
		 __init2() {this.should_remove = false;}
		 __init3() {this.replacement = null;}

		 __init4() {this.context = {
			skip: () => (this.should_skip = true),
			remove: () => (this.should_remove = true),
			replace: (node) => (this.replacement = node)
		};}

		 replace(parent, prop, index, node) {
			if (parent) {
				if (index !== null) {
					parent[prop][index] = node;
				} else {
					parent[prop] = node;
				}
			}
		}

		 remove(parent, prop, index) {
			if (parent) {
				if (index !== null) {
					parent[prop].splice(index, 1);
				} else {
					delete parent[prop];
				}
			}
		}
	}

	class SyncWalkerClass extends WalkerBase {
		
		

		constructor(walker) {
			super();
			this.enter = walker.enter;
			this.leave = walker.leave;
		}

		 visit(
			node,
			parent,
			enter,
			leave,
			prop,
			index
		) {
			if (node) {
				if (enter) {
					const _should_skip = this.should_skip;
					const _should_remove = this.should_remove;
					const _replacement = this.replacement;
					this.should_skip = false;
					this.should_remove = false;
					this.replacement = null;

					enter.call(this.context, node, parent, prop, index);

					if (this.replacement) {
						node = this.replacement;
						this.replace(parent, prop, index, node);
					}

					if (this.should_remove) {
						this.remove(parent, prop, index);
					}

					const skipped = this.should_skip;
					const removed = this.should_remove;

					this.should_skip = _should_skip;
					this.should_remove = _should_remove;
					this.replacement = _replacement;

					if (skipped) return node;
					if (removed) return null;
				}

				for (const key in node) {
					const value = (node )[key];

					if (typeof value !== "object") {
						continue;
					} else if (Array.isArray(value)) {
						for (let i = 0; i < value.length; i += 1) {
							if (value[i] !== null && typeof value[i].type === 'string') {
								if (!this.visit(value[i], node, enter, leave, key, i)) {
									// removed
									i--;
								}
							}
						}
					} else if (value !== null && typeof value.type === "string") {
						this.visit(value, node, enter, leave, key, null);
					}
				}

				if (leave) {
					const _replacement = this.replacement;
					const _should_remove = this.should_remove;
					this.replacement = null;
					this.should_remove = false;

					leave.call(this.context, node, parent, prop, index);

					if (this.replacement) {
						node = this.replacement;
						this.replace(parent, prop, index, node);
					}

					if (this.should_remove) {
						this.remove(parent, prop, index);
					}

					const removed = this.should_remove;

					this.replacement = _replacement;
					this.should_remove = _should_remove;

					if (removed) return null;
				}
			}

			return node;
		}
	}

	function walk(ast, walker) {
		const instance = new SyncWalkerClass(walker);
		return instance.visit(ast, null, walker.enter, walker.leave);
	}

	const extractors = {
	    ArrayPattern(names, param) {
	        for (const element of param.elements) {
	            if (element)
	                extractors[element.type](names, element);
	        }
	    },
	    AssignmentPattern(names, param) {
	        extractors[param.left.type](names, param.left);
	    },
	    Identifier(names, param) {
	        names.push(param.name);
	    },
	    MemberExpression() { },
	    ObjectPattern(names, param) {
	        for (const prop of param.properties) {
	            // @ts-ignore Typescript reports that this is not a valid type
	            if (prop.type === 'RestElement') {
	                extractors.RestElement(names, prop);
	            }
	            else {
	                extractors[prop.value.type](names, prop.value);
	            }
	        }
	    },
	    RestElement(names, param) {
	        extractors[param.argument.type](names, param.argument);
	    }
	};
	const extractAssignedNames = function extractAssignedNames(param) {
	    const names = [];
	    extractors[param.type](names, param);
	    return names;
	};

	const blockDeclarations = {
	    const: true,
	    let: true
	};
	class Scope {
	    constructor(options = {}) {
	        this.parent = options.parent;
	        this.isBlockScope = !!options.block;
	        this.declarations = Object.create(null);
	        if (options.params) {
	            options.params.forEach((param) => {
	                extractAssignedNames(param).forEach((name) => {
	                    this.declarations[name] = true;
	                });
	            });
	        }
	    }
	    addDeclaration(node, isBlockDeclaration, isVar) {
	        if (!isBlockDeclaration && this.isBlockScope) {
	            // it's a `var` or function node, and this
	            // is a block scope, so we need to go up
	            this.parent.addDeclaration(node, isBlockDeclaration, isVar);
	        }
	        else if (node.id) {
	            extractAssignedNames(node.id).forEach((name) => {
	                this.declarations[name] = true;
	            });
	        }
	    }
	    contains(name) {
	        return this.declarations[name] || (this.parent ? this.parent.contains(name) : false);
	    }
	}
	const attachScopes = function attachScopes(ast, propertyName = 'scope') {
	    let scope = new Scope();
	    walk(ast, {
	        enter(n, parent) {
	            const node = n;
	            // function foo () {...}
	            // class Foo {...}
	            if (/(Function|Class)Declaration/.test(node.type)) {
	                scope.addDeclaration(node, false, false);
	            }
	            // var foo = 1
	            if (node.type === 'VariableDeclaration') {
	                const { kind } = node;
	                const isBlockDeclaration = blockDeclarations[kind];
	                node.declarations.forEach((declaration) => {
	                    scope.addDeclaration(declaration, isBlockDeclaration, true);
	                });
	            }
	            let newScope;
	            // create new function scope
	            if (/Function/.test(node.type)) {
	                const func = node;
	                newScope = new Scope({
	                    parent: scope,
	                    block: false,
	                    params: func.params
	                });
	                // named function expressions - the name is considered
	                // part of the function's scope
	                if (func.type === 'FunctionExpression' && func.id) {
	                    newScope.addDeclaration(func, false, false);
	                }
	            }
	            // create new for scope
	            if (/For(In|Of)?Statement/.test(node.type)) {
	                newScope = new Scope({
	                    parent: scope,
	                    block: true
	                });
	            }
	            // create new block scope
	            if (node.type === 'BlockStatement' && !/Function/.test(parent.type)) {
	                newScope = new Scope({
	                    parent: scope,
	                    block: true
	                });
	            }
	            // catch clause has its own block scope
	            if (node.type === 'CatchClause') {
	                newScope = new Scope({
	                    parent: scope,
	                    params: node.param ? [node.param] : [],
	                    block: true
	                });
	            }
	            if (newScope) {
	                Object.defineProperty(node, propertyName, {
	                    value: newScope,
	                    configurable: true
	                });
	                scope = newScope;
	            }
	        },
	        leave(n) {
	            const node = n;
	            if (node[propertyName])
	                scope = scope.parent;
	        }
	    });
	    return scope;
	};

	// Helper since Typescript can't detect readonly arrays with Array.isArray
	function isArray(arg) {
	    return Array.isArray(arg);
	}
	function ensureArray(thing) {
	    if (isArray(thing))
	        return thing;
	    if (thing == null)
	        return [];
	    return [thing];
	}

	const normalizePath = function normalizePath(filename) {
	    return filename.split(path.win32.sep).join(path.posix.sep);
	};

	function getMatcherString(id, resolutionBase) {
	    if (resolutionBase === false || path.isAbsolute(id) || id.startsWith('*')) {
	        return normalizePath(id);
	    }
	    // resolve('') is valid and will default to process.cwd()
	    const basePath = normalizePath(path.resolve(resolutionBase || ''))
	        // escape all possible (posix + win) path characters that might interfere with regex
	        .replace(/[-^$*+?.()|[\]{}]/g, '\\$&');
	    // Note that we use posix.join because:
	    // 1. the basePath has been normalized to use /
	    // 2. the incoming glob (id) matcher, also uses /
	    // otherwise Node will force backslash (\) on windows
	    return path.posix.join(basePath, normalizePath(id));
	}
	const createFilter = function createFilter(include, exclude, options) {
	    const resolutionBase = options && options.resolve;
	    const getMatcher = (id) => id instanceof RegExp
	        ? id
	        : {
	            test: (what) => {
	                // this refactor is a tad overly verbose but makes for easy debugging
	                const pattern = getMatcherString(id, resolutionBase);
	                const fn = pm__default["default"](pattern, { dot: true });
	                const result = fn(what);
	                return result;
	            }
	        };
	    const includeMatchers = ensureArray(include).map(getMatcher);
	    const excludeMatchers = ensureArray(exclude).map(getMatcher);
	    return function result(id) {
	        if (typeof id !== 'string')
	            return false;
	        if (/\0/.test(id))
	            return false;
	        const pathId = normalizePath(id);
	        for (let i = 0; i < excludeMatchers.length; ++i) {
	            const matcher = excludeMatchers[i];
	            if (matcher.test(pathId))
	                return false;
	        }
	        for (let i = 0; i < includeMatchers.length; ++i) {
	            const matcher = includeMatchers[i];
	            if (matcher.test(pathId))
	                return true;
	        }
	        return !includeMatchers.length;
	    };
	};

	const reservedWords = 'break case class catch const continue debugger default delete do else export extends finally for function if import in instanceof let new return super switch this throw try typeof var void while with yield enum await implements package protected static interface private public';
	const builtins = 'arguments Infinity NaN undefined null true false eval uneval isFinite isNaN parseFloat parseInt decodeURI decodeURIComponent encodeURI encodeURIComponent escape unescape Object Function Boolean Symbol Error EvalError InternalError RangeError ReferenceError SyntaxError TypeError URIError Number Math Date String RegExp Array Int8Array Uint8Array Uint8ClampedArray Int16Array Uint16Array Int32Array Uint32Array Float32Array Float64Array Map Set WeakMap WeakSet SIMD ArrayBuffer DataView JSON Promise Generator GeneratorFunction Reflect Proxy Intl';
	const forbiddenIdentifiers = new Set(`${reservedWords} ${builtins}`.split(' '));
	forbiddenIdentifiers.add('');
	const makeLegalIdentifier = function makeLegalIdentifier(str) {
	    let identifier = str
	        .replace(/-(\w)/g, (_, letter) => letter.toUpperCase())
	        .replace(/[^$_a-zA-Z0-9]/g, '_');
	    if (/\d/.test(identifier[0]) || forbiddenIdentifiers.has(identifier)) {
	        identifier = `_${identifier}`;
	    }
	    return identifier || '_';
	};

	function stringify(obj) {
	    return (JSON.stringify(obj) || 'undefined').replace(/[\u2028\u2029]/g, (char) => `\\u${`000${char.charCodeAt(0).toString(16)}`.slice(-4)}`);
	}
	function serializeArray(arr, indent, baseIndent) {
	    let output = '[';
	    const separator = indent ? `\n${baseIndent}${indent}` : '';
	    for (let i = 0; i < arr.length; i++) {
	        const key = arr[i];
	        output += `${i > 0 ? ',' : ''}${separator}${serialize(key, indent, baseIndent + indent)}`;
	    }
	    return `${output}${indent ? `\n${baseIndent}` : ''}]`;
	}
	function serializeObject(obj, indent, baseIndent) {
	    let output = '{';
	    const separator = indent ? `\n${baseIndent}${indent}` : '';
	    const entries = Object.entries(obj);
	    for (let i = 0; i < entries.length; i++) {
	        const [key, value] = entries[i];
	        const stringKey = makeLegalIdentifier(key) === key ? key : stringify(key);
	        output += `${i > 0 ? ',' : ''}${separator}${stringKey}:${indent ? ' ' : ''}${serialize(value, indent, baseIndent + indent)}`;
	    }
	    return `${output}${indent ? `\n${baseIndent}` : ''}}`;
	}
	function serialize(obj, indent, baseIndent) {
	    if (typeof obj === 'object' && obj !== null) {
	        if (Array.isArray(obj))
	            return serializeArray(obj, indent, baseIndent);
	        if (obj instanceof Date)
	            return `new Date(${obj.getTime()})`;
	        if (obj instanceof RegExp)
	            return obj.toString();
	        return serializeObject(obj, indent, baseIndent);
	    }
	    if (typeof obj === 'number') {
	        if (obj === Infinity)
	            return 'Infinity';
	        if (obj === -Infinity)
	            return '-Infinity';
	        if (obj === 0)
	            return 1 / obj === Infinity ? '0' : '-0';
	        if (obj !== obj)
	            return 'NaN'; // eslint-disable-line no-self-compare
	    }
	    if (typeof obj === 'symbol') {
	        const key = Symbol.keyFor(obj);
	        if (key !== undefined)
	            return `Symbol.for(${stringify(key)})`;
	    }
	    if (typeof obj === 'bigint')
	        return `${obj}n`;
	    return stringify(obj);
	}
	const dataToEsm = function dataToEsm(data, options = {}) {
	    const t = options.compact ? '' : 'indent' in options ? options.indent : '\t';
	    const _ = options.compact ? '' : ' ';
	    const n = options.compact ? '' : '\n';
	    const declarationType = options.preferConst ? 'const' : 'var';
	    if (options.namedExports === false ||
	        typeof data !== 'object' ||
	        Array.isArray(data) ||
	        data instanceof Date ||
	        data instanceof RegExp ||
	        data === null) {
	        const code = serialize(data, options.compact ? null : t, '');
	        const magic = _ || (/^[{[\-\/]/.test(code) ? '' : ' '); // eslint-disable-line no-useless-escape
	        return `export default${magic}${code};`;
	    }
	    let namedExportCode = '';
	    const defaultExportRows = [];
	    for (const [key, value] of Object.entries(data)) {
	        if (key === makeLegalIdentifier(key)) {
	            if (options.objectShorthand)
	                defaultExportRows.push(key);
	            else
	                defaultExportRows.push(`${key}:${_}${key}`);
	            namedExportCode += `export ${declarationType} ${key}${_}=${_}${serialize(value, options.compact ? null : t, '')};${n}`;
	        }
	        else {
	            defaultExportRows.push(`${stringify(key)}:${_}${serialize(value, options.compact ? null : t, '')}`);
	        }
	    }
	    return `${namedExportCode}export default${_}{${n}${t}${defaultExportRows.join(`,${n}${t}`)}${n}};${n}`;
	};

	// TODO: remove this in next major
	var index = {
	    addExtension,
	    attachScopes,
	    createFilter,
	    dataToEsm,
	    extractAssignedNames,
	    makeLegalIdentifier,
	    normalizePath
	};

	exports.addExtension = addExtension;
	exports.attachScopes = attachScopes;
	exports.createFilter = createFilter;
	exports.dataToEsm = dataToEsm;
	exports["default"] = index;
	exports.extractAssignedNames = extractAssignedNames;
	exports.makeLegalIdentifier = makeLegalIdentifier;
	exports.normalizePath = normalizePath; 
} (cjs));

var os$3 = require$$0__default$1["default"];

// adapted from https://github.com/sindresorhus/os-homedir/blob/11e089f4754db38bb535e5a8416320c4446e8cfd/index.js

var homedir$2 = os$3.homedir || function homedir() {
    var home = process.env.HOME;
    var user = process.env.LOGNAME || process.env.USER || process.env.LNAME || process.env.USERNAME;

    if (process.platform === 'win32') {
        return process.env.USERPROFILE || process.env.HOMEDRIVE + process.env.HOMEPATH || home || null;
    }

    if (process.platform === 'darwin') {
        return home || (user ? '/Users/' + user : null);
    }

    if (process.platform === 'linux') {
        return home || (process.getuid() === 0 ? '/root' : (user ? '/home/' + user : null)); // eslint-disable-line no-extra-parens
    }

    return home || null;
};

var caller$2 = function () {
    // see https://code.google.com/p/v8/wiki/JavaScriptStackTraceApi
    var origPrepareStackTrace = Error.prepareStackTrace;
    Error.prepareStackTrace = function (_, stack) { return stack; };
    var stack = (new Error()).stack;
    Error.prepareStackTrace = origPrepareStackTrace;
    return stack[2].getFileName();
};

var pathParse = {exports: {}};

var hasRequiredPathParse;

function requirePathParse () {
	if (hasRequiredPathParse) return pathParse.exports;
	hasRequiredPathParse = 1;

	var isWindows = process.platform === 'win32';

	// Regex to split a windows path into into [dir, root, basename, name, ext]
	var splitWindowsRe =
	    /^(((?:[a-zA-Z]:|[\\\/]{2}[^\\\/]+[\\\/]+[^\\\/]+)?[\\\/]?)(?:[^\\\/]*[\\\/])*)((\.{1,2}|[^\\\/]+?|)(\.[^.\/\\]*|))[\\\/]*$/;

	var win32 = {};

	function win32SplitPath(filename) {
	  return splitWindowsRe.exec(filename).slice(1);
	}

	win32.parse = function(pathString) {
	  if (typeof pathString !== 'string') {
	    throw new TypeError(
	        "Parameter 'pathString' must be a string, not " + typeof pathString
	    );
	  }
	  var allParts = win32SplitPath(pathString);
	  if (!allParts || allParts.length !== 5) {
	    throw new TypeError("Invalid path '" + pathString + "'");
	  }
	  return {
	    root: allParts[1],
	    dir: allParts[0] === allParts[1] ? allParts[0] : allParts[0].slice(0, -1),
	    base: allParts[2],
	    ext: allParts[4],
	    name: allParts[3]
	  };
	};



	// Split a filename into [dir, root, basename, name, ext], unix version
	// 'root' is just a slash, or nothing.
	var splitPathRe =
	    /^((\/?)(?:[^\/]*\/)*)((\.{1,2}|[^\/]+?|)(\.[^.\/]*|))[\/]*$/;
	var posix = {};


	function posixSplitPath(filename) {
	  return splitPathRe.exec(filename).slice(1);
	}


	posix.parse = function(pathString) {
	  if (typeof pathString !== 'string') {
	    throw new TypeError(
	        "Parameter 'pathString' must be a string, not " + typeof pathString
	    );
	  }
	  var allParts = posixSplitPath(pathString);
	  if (!allParts || allParts.length !== 5) {
	    throw new TypeError("Invalid path '" + pathString + "'");
	  }
	  
	  return {
	    root: allParts[1],
	    dir: allParts[0].slice(0, -1),
	    base: allParts[2],
	    ext: allParts[4],
	    name: allParts[3],
	  };
	};


	if (isWindows)
	  pathParse.exports = win32.parse;
	else /* posix */
	  pathParse.exports = posix.parse;

	pathParse.exports.posix = posix.parse;
	pathParse.exports.win32 = win32.parse;
	return pathParse.exports;
}

var path$5 = path__default["default"];
var parse$1 = path$5.parse || requirePathParse(); // eslint-disable-line global-require

var getNodeModulesDirs = function getNodeModulesDirs(absoluteStart, modules) {
    var prefix = '/';
    if ((/^([A-Za-z]:)/).test(absoluteStart)) {
        prefix = '';
    } else if ((/^\\\\/).test(absoluteStart)) {
        prefix = '\\\\';
    }

    var paths = [absoluteStart];
    var parsed = parse$1(absoluteStart);
    while (parsed.dir !== paths[paths.length - 1]) {
        paths.push(parsed.dir);
        parsed = parse$1(parsed.dir);
    }

    return paths.reduce(function (dirs, aPath) {
        return dirs.concat(modules.map(function (moduleDir) {
            return path$5.resolve(prefix, aPath, moduleDir);
        }));
    }, []);
};

var nodeModulesPaths$2 = function nodeModulesPaths(start, opts, request) {
    var modules = opts && opts.moduleDirectory
        ? [].concat(opts.moduleDirectory)
        : ['node_modules'];

    if (opts && typeof opts.paths === 'function') {
        return opts.paths(
            request,
            start,
            function () { return getNodeModulesDirs(start, modules); },
            opts
        );
    }

    var dirs = getNodeModulesDirs(start, modules);
    return opts && opts.paths ? dirs.concat(opts.paths) : dirs;
};

var normalizeOptions$2 = function (x, opts) {
    /**
     * This file is purposefully a passthrough. It's expected that third-party
     * environments will override it at runtime in order to inject special logic
     * into `resolve` (by manipulating the options). One such example is the PnP
     * code path in Yarn.
     */

    return opts || {};
};

/* eslint no-invalid-this: 1 */

var ERROR_MESSAGE = 'Function.prototype.bind called on incompatible ';
var toStr = Object.prototype.toString;
var max = Math.max;
var funcType = '[object Function]';

var concatty = function concatty(a, b) {
    var arr = [];

    for (var i = 0; i < a.length; i += 1) {
        arr[i] = a[i];
    }
    for (var j = 0; j < b.length; j += 1) {
        arr[j + a.length] = b[j];
    }

    return arr;
};

var slicy = function slicy(arrLike, offset) {
    var arr = [];
    for (var i = offset || 0, j = 0; i < arrLike.length; i += 1, j += 1) {
        arr[j] = arrLike[i];
    }
    return arr;
};

var joiny = function (arr, joiner) {
    var str = '';
    for (var i = 0; i < arr.length; i += 1) {
        str += arr[i];
        if (i + 1 < arr.length) {
            str += joiner;
        }
    }
    return str;
};

var implementation$1 = function bind(that) {
    var target = this;
    if (typeof target !== 'function' || toStr.apply(target) !== funcType) {
        throw new TypeError(ERROR_MESSAGE + target);
    }
    var args = slicy(arguments, 1);

    var bound;
    var binder = function () {
        if (this instanceof bound) {
            var result = target.apply(
                this,
                concatty(args, arguments)
            );
            if (Object(result) === result) {
                return result;
            }
            return this;
        }
        return target.apply(
            that,
            concatty(args, arguments)
        );

    };

    var boundLength = max(0, target.length - args.length);
    var boundArgs = [];
    for (var i = 0; i < boundLength; i++) {
        boundArgs[i] = '$' + i;
    }

    bound = Function('binder', 'return function (' + joiny(boundArgs, ',') + '){ return binder.apply(this,arguments); }')(binder);

    if (target.prototype) {
        var Empty = function Empty() {};
        Empty.prototype = target.prototype;
        bound.prototype = new Empty();
        Empty.prototype = null;
    }

    return bound;
};

var implementation = implementation$1;

var functionBind = Function.prototype.bind || implementation;

var call = Function.prototype.call;
var $hasOwn = Object.prototype.hasOwnProperty;
var bind = functionBind;

/** @type {import('.')} */
var hasown = bind.call(call, $hasOwn);

var assert$1 = true;
var async_hooks$1 = ">= 8";
var buffer_ieee754$1 = ">= 0.5 && < 0.9.7";
var buffer$1 = true;
var child_process$1 = true;
var cluster$1 = ">= 0.5";
var console$2 = true;
var constants$1 = true;
var crypto$1 = true;
var _debug_agent$1 = ">= 1 && < 8";
var _debugger$1 = "< 8";
var dgram$1 = true;
var diagnostics_channel$1 = [
	">= 14.17 && < 15",
	">= 15.1"
];
var dns$1 = true;
var domain$1 = ">= 0.7.12";
var events$1 = true;
var freelist$1 = "< 6";
var fs$5 = true;
var _http_agent$1 = ">= 0.11.1";
var _http_client$1 = ">= 0.11.1";
var _http_common$1 = ">= 0.11.1";
var _http_incoming$1 = ">= 0.11.1";
var _http_outgoing$1 = ">= 0.11.1";
var _http_server$1 = ">= 0.11.1";
var http$1 = true;
var http2$1 = ">= 8.8";
var https$1 = true;
var inspector$1 = ">= 8";
var _linklist$1 = "< 8";
var module$2 = true;
var net$1 = true;
var os$2 = true;
var path$4 = true;
var perf_hooks$1 = ">= 8.5";
var process$2 = ">= 1";
var punycode$1 = ">= 0.5";
var querystring$1 = true;
var readline$1 = true;
var repl$1 = true;
var smalloc$1 = ">= 0.11.5 && < 3";
var _stream_duplex$1 = ">= 0.9.4";
var _stream_transform$1 = ">= 0.9.4";
var _stream_wrap$1 = ">= 1.4.1";
var _stream_passthrough$1 = ">= 0.9.4";
var _stream_readable$1 = ">= 0.9.4";
var _stream_writable$1 = ">= 0.9.4";
var stream$1 = true;
var string_decoder$1 = true;
var sys$1 = [
	">= 0.4 && < 0.7",
	">= 0.8"
];
var timers$1 = true;
var _tls_common$1 = ">= 0.11.13";
var _tls_legacy$1 = ">= 0.11.3 && < 10";
var _tls_wrap$1 = ">= 0.11.3";
var tls$1 = true;
var trace_events$1 = ">= 10";
var tty$1 = true;
var url$1 = true;
var util$1 = true;
var v8$1 = ">= 1";
var vm$1 = true;
var wasi$1 = [
	">= 13.4 && < 13.5",
	">= 18.17 && < 19",
	">= 20"
];
var worker_threads$1 = ">= 11.7";
var zlib$1 = ">= 0.5";
var require$$1$1 = {
	assert: assert$1,
	"node:assert": [
	">= 14.18 && < 15",
	">= 16"
],
	"assert/strict": ">= 15",
	"node:assert/strict": ">= 16",
	async_hooks: async_hooks$1,
	"node:async_hooks": [
	">= 14.18 && < 15",
	">= 16"
],
	buffer_ieee754: buffer_ieee754$1,
	buffer: buffer$1,
	"node:buffer": [
	">= 14.18 && < 15",
	">= 16"
],
	child_process: child_process$1,
	"node:child_process": [
	">= 14.18 && < 15",
	">= 16"
],
	cluster: cluster$1,
	"node:cluster": [
	">= 14.18 && < 15",
	">= 16"
],
	console: console$2,
	"node:console": [
	">= 14.18 && < 15",
	">= 16"
],
	constants: constants$1,
	"node:constants": [
	">= 14.18 && < 15",
	">= 16"
],
	crypto: crypto$1,
	"node:crypto": [
	">= 14.18 && < 15",
	">= 16"
],
	_debug_agent: _debug_agent$1,
	_debugger: _debugger$1,
	dgram: dgram$1,
	"node:dgram": [
	">= 14.18 && < 15",
	">= 16"
],
	diagnostics_channel: diagnostics_channel$1,
	"node:diagnostics_channel": [
	">= 14.18 && < 15",
	">= 16"
],
	dns: dns$1,
	"node:dns": [
	">= 14.18 && < 15",
	">= 16"
],
	"dns/promises": ">= 15",
	"node:dns/promises": ">= 16",
	domain: domain$1,
	"node:domain": [
	">= 14.18 && < 15",
	">= 16"
],
	events: events$1,
	"node:events": [
	">= 14.18 && < 15",
	">= 16"
],
	freelist: freelist$1,
	fs: fs$5,
	"node:fs": [
	">= 14.18 && < 15",
	">= 16"
],
	"fs/promises": [
	">= 10 && < 10.1",
	">= 14"
],
	"node:fs/promises": [
	">= 14.18 && < 15",
	">= 16"
],
	_http_agent: _http_agent$1,
	"node:_http_agent": [
	">= 14.18 && < 15",
	">= 16"
],
	_http_client: _http_client$1,
	"node:_http_client": [
	">= 14.18 && < 15",
	">= 16"
],
	_http_common: _http_common$1,
	"node:_http_common": [
	">= 14.18 && < 15",
	">= 16"
],
	_http_incoming: _http_incoming$1,
	"node:_http_incoming": [
	">= 14.18 && < 15",
	">= 16"
],
	_http_outgoing: _http_outgoing$1,
	"node:_http_outgoing": [
	">= 14.18 && < 15",
	">= 16"
],
	_http_server: _http_server$1,
	"node:_http_server": [
	">= 14.18 && < 15",
	">= 16"
],
	http: http$1,
	"node:http": [
	">= 14.18 && < 15",
	">= 16"
],
	http2: http2$1,
	"node:http2": [
	">= 14.18 && < 15",
	">= 16"
],
	https: https$1,
	"node:https": [
	">= 14.18 && < 15",
	">= 16"
],
	inspector: inspector$1,
	"node:inspector": [
	">= 14.18 && < 15",
	">= 16"
],
	"inspector/promises": [
	">= 19"
],
	"node:inspector/promises": [
	">= 19"
],
	_linklist: _linklist$1,
	module: module$2,
	"node:module": [
	">= 14.18 && < 15",
	">= 16"
],
	net: net$1,
	"node:net": [
	">= 14.18 && < 15",
	">= 16"
],
	"node-inspect/lib/_inspect": ">= 7.6 && < 12",
	"node-inspect/lib/internal/inspect_client": ">= 7.6 && < 12",
	"node-inspect/lib/internal/inspect_repl": ">= 7.6 && < 12",
	os: os$2,
	"node:os": [
	">= 14.18 && < 15",
	">= 16"
],
	path: path$4,
	"node:path": [
	">= 14.18 && < 15",
	">= 16"
],
	"path/posix": ">= 15.3",
	"node:path/posix": ">= 16",
	"path/win32": ">= 15.3",
	"node:path/win32": ">= 16",
	perf_hooks: perf_hooks$1,
	"node:perf_hooks": [
	">= 14.18 && < 15",
	">= 16"
],
	process: process$2,
	"node:process": [
	">= 14.18 && < 15",
	">= 16"
],
	punycode: punycode$1,
	"node:punycode": [
	">= 14.18 && < 15",
	">= 16"
],
	querystring: querystring$1,
	"node:querystring": [
	">= 14.18 && < 15",
	">= 16"
],
	readline: readline$1,
	"node:readline": [
	">= 14.18 && < 15",
	">= 16"
],
	"readline/promises": ">= 17",
	"node:readline/promises": ">= 17",
	repl: repl$1,
	"node:repl": [
	">= 14.18 && < 15",
	">= 16"
],
	smalloc: smalloc$1,
	_stream_duplex: _stream_duplex$1,
	"node:_stream_duplex": [
	">= 14.18 && < 15",
	">= 16"
],
	_stream_transform: _stream_transform$1,
	"node:_stream_transform": [
	">= 14.18 && < 15",
	">= 16"
],
	_stream_wrap: _stream_wrap$1,
	"node:_stream_wrap": [
	">= 14.18 && < 15",
	">= 16"
],
	_stream_passthrough: _stream_passthrough$1,
	"node:_stream_passthrough": [
	">= 14.18 && < 15",
	">= 16"
],
	_stream_readable: _stream_readable$1,
	"node:_stream_readable": [
	">= 14.18 && < 15",
	">= 16"
],
	_stream_writable: _stream_writable$1,
	"node:_stream_writable": [
	">= 14.18 && < 15",
	">= 16"
],
	stream: stream$1,
	"node:stream": [
	">= 14.18 && < 15",
	">= 16"
],
	"stream/consumers": ">= 16.7",
	"node:stream/consumers": ">= 16.7",
	"stream/promises": ">= 15",
	"node:stream/promises": ">= 16",
	"stream/web": ">= 16.5",
	"node:stream/web": ">= 16.5",
	string_decoder: string_decoder$1,
	"node:string_decoder": [
	">= 14.18 && < 15",
	">= 16"
],
	sys: sys$1,
	"node:sys": [
	">= 14.18 && < 15",
	">= 16"
],
	"test/reporters": ">= 19.9 && < 20.2",
	"node:test/reporters": [
	">= 18.17 && < 19",
	">= 19.9",
	">= 20"
],
	"node:test": [
	">= 16.17 && < 17",
	">= 18"
],
	timers: timers$1,
	"node:timers": [
	">= 14.18 && < 15",
	">= 16"
],
	"timers/promises": ">= 15",
	"node:timers/promises": ">= 16",
	_tls_common: _tls_common$1,
	"node:_tls_common": [
	">= 14.18 && < 15",
	">= 16"
],
	_tls_legacy: _tls_legacy$1,
	_tls_wrap: _tls_wrap$1,
	"node:_tls_wrap": [
	">= 14.18 && < 15",
	">= 16"
],
	tls: tls$1,
	"node:tls": [
	">= 14.18 && < 15",
	">= 16"
],
	trace_events: trace_events$1,
	"node:trace_events": [
	">= 14.18 && < 15",
	">= 16"
],
	tty: tty$1,
	"node:tty": [
	">= 14.18 && < 15",
	">= 16"
],
	url: url$1,
	"node:url": [
	">= 14.18 && < 15",
	">= 16"
],
	util: util$1,
	"node:util": [
	">= 14.18 && < 15",
	">= 16"
],
	"util/types": ">= 15.3",
	"node:util/types": ">= 16",
	"v8/tools/arguments": ">= 10 && < 12",
	"v8/tools/codemap": [
	">= 4.4 && < 5",
	">= 5.2 && < 12"
],
	"v8/tools/consarray": [
	">= 4.4 && < 5",
	">= 5.2 && < 12"
],
	"v8/tools/csvparser": [
	">= 4.4 && < 5",
	">= 5.2 && < 12"
],
	"v8/tools/logreader": [
	">= 4.4 && < 5",
	">= 5.2 && < 12"
],
	"v8/tools/profile_view": [
	">= 4.4 && < 5",
	">= 5.2 && < 12"
],
	"v8/tools/splaytree": [
	">= 4.4 && < 5",
	">= 5.2 && < 12"
],
	v8: v8$1,
	"node:v8": [
	">= 14.18 && < 15",
	">= 16"
],
	vm: vm$1,
	"node:vm": [
	">= 14.18 && < 15",
	">= 16"
],
	wasi: wasi$1,
	"node:wasi": [
	">= 18.17 && < 19",
	">= 20"
],
	worker_threads: worker_threads$1,
	"node:worker_threads": [
	">= 14.18 && < 15",
	">= 16"
],
	zlib: zlib$1,
	"node:zlib": [
	">= 14.18 && < 15",
	">= 16"
]
};

var hasOwn = hasown;

function specifierIncluded(current, specifier) {
	var nodeParts = current.split('.');
	var parts = specifier.split(' ');
	var op = parts.length > 1 ? parts[0] : '=';
	var versionParts = (parts.length > 1 ? parts[1] : parts[0]).split('.');

	for (var i = 0; i < 3; ++i) {
		var cur = parseInt(nodeParts[i] || 0, 10);
		var ver = parseInt(versionParts[i] || 0, 10);
		if (cur === ver) {
			continue; // eslint-disable-line no-restricted-syntax, no-continue
		}
		if (op === '<') {
			return cur < ver;
		}
		if (op === '>=') {
			return cur >= ver;
		}
		return false;
	}
	return op === '>=';
}

function matchesRange(current, range) {
	var specifiers = range.split(/ ?&& ?/);
	if (specifiers.length === 0) {
		return false;
	}
	for (var i = 0; i < specifiers.length; ++i) {
		if (!specifierIncluded(current, specifiers[i])) {
			return false;
		}
	}
	return true;
}

function versionIncluded(nodeVersion, specifierValue) {
	if (typeof specifierValue === 'boolean') {
		return specifierValue;
	}

	var current = typeof nodeVersion === 'undefined'
		? process.versions && process.versions.node
		: nodeVersion;

	if (typeof current !== 'string') {
		throw new TypeError(typeof nodeVersion === 'undefined' ? 'Unable to determine current node version' : 'If provided, a valid node version is required');
	}

	if (specifierValue && typeof specifierValue === 'object') {
		for (var i = 0; i < specifierValue.length; ++i) {
			if (matchesRange(current, specifierValue[i])) {
				return true;
			}
		}
		return false;
	}
	return matchesRange(current, specifierValue);
}

var data$1 = require$$1$1;

var isCoreModule$2 = function isCore(x, nodeVersion) {
	return hasOwn(data$1, x) && versionIncluded(nodeVersion, data$1[x]);
};

var fs$4 = require$$0__default["default"];
var getHomedir$1 = homedir$2;
var path$3 = path__default["default"];
var caller$1 = caller$2;
var nodeModulesPaths$1 = nodeModulesPaths$2;
var normalizeOptions$1 = normalizeOptions$2;
var isCore$2 = isCoreModule$2;

var realpathFS$1 = process.platform !== 'win32' && fs$4.realpath && typeof fs$4.realpath.native === 'function' ? fs$4.realpath.native : fs$4.realpath;

var homedir$1 = getHomedir$1();
var defaultPaths$1 = function () {
    return [
        path$3.join(homedir$1, '.node_modules'),
        path$3.join(homedir$1, '.node_libraries')
    ];
};

var defaultIsFile$1 = function isFile(file, cb) {
    fs$4.stat(file, function (err, stat) {
        if (!err) {
            return cb(null, stat.isFile() || stat.isFIFO());
        }
        if (err.code === 'ENOENT' || err.code === 'ENOTDIR') return cb(null, false);
        return cb(err);
    });
};

var defaultIsDir$1 = function isDirectory(dir, cb) {
    fs$4.stat(dir, function (err, stat) {
        if (!err) {
            return cb(null, stat.isDirectory());
        }
        if (err.code === 'ENOENT' || err.code === 'ENOTDIR') return cb(null, false);
        return cb(err);
    });
};

var defaultRealpath = function realpath(x, cb) {
    realpathFS$1(x, function (realpathErr, realPath) {
        if (realpathErr && realpathErr.code !== 'ENOENT') cb(realpathErr);
        else cb(null, realpathErr ? x : realPath);
    });
};

var maybeRealpath = function maybeRealpath(realpath, x, opts, cb) {
    if (opts && opts.preserveSymlinks === false) {
        realpath(x, cb);
    } else {
        cb(null, x);
    }
};

var defaultReadPackage = function defaultReadPackage(readFile, pkgfile, cb) {
    readFile(pkgfile, function (readFileErr, body) {
        if (readFileErr) cb(readFileErr);
        else {
            try {
                var pkg = JSON.parse(body);
                cb(null, pkg);
            } catch (jsonErr) {
                cb(null);
            }
        }
    });
};

var getPackageCandidates$1 = function getPackageCandidates(x, start, opts) {
    var dirs = nodeModulesPaths$1(start, opts, x);
    for (var i = 0; i < dirs.length; i++) {
        dirs[i] = path$3.join(dirs[i], x);
    }
    return dirs;
};

var async$1 = function resolve(x, options, callback) {
    var cb = callback;
    var opts = options;
    if (typeof options === 'function') {
        cb = opts;
        opts = {};
    }
    if (typeof x !== 'string') {
        var err = new TypeError('Path must be a string.');
        return process.nextTick(function () {
            cb(err);
        });
    }

    opts = normalizeOptions$1(x, opts);

    var isFile = opts.isFile || defaultIsFile$1;
    var isDirectory = opts.isDirectory || defaultIsDir$1;
    var readFile = opts.readFile || fs$4.readFile;
    var realpath = opts.realpath || defaultRealpath;
    var readPackage = opts.readPackage || defaultReadPackage;
    if (opts.readFile && opts.readPackage) {
        var conflictErr = new TypeError('`readFile` and `readPackage` are mutually exclusive.');
        return process.nextTick(function () {
            cb(conflictErr);
        });
    }
    var packageIterator = opts.packageIterator;

    var extensions = opts.extensions || ['.js'];
    var includeCoreModules = opts.includeCoreModules !== false;
    var basedir = opts.basedir || path$3.dirname(caller$1());
    var parent = opts.filename || basedir;

    opts.paths = opts.paths || defaultPaths$1();

    // ensure that `basedir` is an absolute path at this point, resolving against the process' current working directory
    var absoluteStart = path$3.resolve(basedir);

    maybeRealpath(
        realpath,
        absoluteStart,
        opts,
        function (err, realStart) {
            if (err) cb(err);
            else init(realStart);
        }
    );

    var res;
    function init(basedir) {
        if ((/^(?:\.\.?(?:\/|$)|\/|([A-Za-z]:)?[/\\])/).test(x)) {
            res = path$3.resolve(basedir, x);
            if (x === '.' || x === '..' || x.slice(-1) === '/') res += '/';
            if ((/\/$/).test(x) && res === basedir) {
                loadAsDirectory(res, opts.package, onfile);
            } else loadAsFile(res, opts.package, onfile);
        } else if (includeCoreModules && isCore$2(x)) {
            return cb(null, x);
        } else loadNodeModules(x, basedir, function (err, n, pkg) {
            if (err) cb(err);
            else if (n) {
                return maybeRealpath(realpath, n, opts, function (err, realN) {
                    if (err) {
                        cb(err);
                    } else {
                        cb(null, realN, pkg);
                    }
                });
            } else {
                var moduleError = new Error("Cannot find module '" + x + "' from '" + parent + "'");
                moduleError.code = 'MODULE_NOT_FOUND';
                cb(moduleError);
            }
        });
    }

    function onfile(err, m, pkg) {
        if (err) cb(err);
        else if (m) cb(null, m, pkg);
        else loadAsDirectory(res, function (err, d, pkg) {
            if (err) cb(err);
            else if (d) {
                maybeRealpath(realpath, d, opts, function (err, realD) {
                    if (err) {
                        cb(err);
                    } else {
                        cb(null, realD, pkg);
                    }
                });
            } else {
                var moduleError = new Error("Cannot find module '" + x + "' from '" + parent + "'");
                moduleError.code = 'MODULE_NOT_FOUND';
                cb(moduleError);
            }
        });
    }

    function loadAsFile(x, thePackage, callback) {
        var loadAsFilePackage = thePackage;
        var cb = callback;
        if (typeof loadAsFilePackage === 'function') {
            cb = loadAsFilePackage;
            loadAsFilePackage = undefined;
        }

        var exts = [''].concat(extensions);
        load(exts, x, loadAsFilePackage);

        function load(exts, x, loadPackage) {
            if (exts.length === 0) return cb(null, undefined, loadPackage);
            var file = x + exts[0];

            var pkg = loadPackage;
            if (pkg) onpkg(null, pkg);
            else loadpkg(path$3.dirname(file), onpkg);

            function onpkg(err, pkg_, dir) {
                pkg = pkg_;
                if (err) return cb(err);
                if (dir && pkg && opts.pathFilter) {
                    var rfile = path$3.relative(dir, file);
                    var rel = rfile.slice(0, rfile.length - exts[0].length);
                    var r = opts.pathFilter(pkg, x, rel);
                    if (r) return load(
                        [''].concat(extensions.slice()),
                        path$3.resolve(dir, r),
                        pkg
                    );
                }
                isFile(file, onex);
            }
            function onex(err, ex) {
                if (err) return cb(err);
                if (ex) return cb(null, file, pkg);
                load(exts.slice(1), x, pkg);
            }
        }
    }

    function loadpkg(dir, cb) {
        if (dir === '' || dir === '/') return cb(null);
        if (process.platform === 'win32' && (/^\w:[/\\]*$/).test(dir)) {
            return cb(null);
        }
        if ((/[/\\]node_modules[/\\]*$/).test(dir)) return cb(null);

        maybeRealpath(realpath, dir, opts, function (unwrapErr, pkgdir) {
            if (unwrapErr) return loadpkg(path$3.dirname(dir), cb);
            var pkgfile = path$3.join(pkgdir, 'package.json');
            isFile(pkgfile, function (err, ex) {
                // on err, ex is false
                if (!ex) return loadpkg(path$3.dirname(dir), cb);

                readPackage(readFile, pkgfile, function (err, pkgParam) {
                    if (err) cb(err);

                    var pkg = pkgParam;

                    if (pkg && opts.packageFilter) {
                        pkg = opts.packageFilter(pkg, pkgfile);
                    }
                    cb(null, pkg, dir);
                });
            });
        });
    }

    function loadAsDirectory(x, loadAsDirectoryPackage, callback) {
        var cb = callback;
        var fpkg = loadAsDirectoryPackage;
        if (typeof fpkg === 'function') {
            cb = fpkg;
            fpkg = opts.package;
        }

        maybeRealpath(realpath, x, opts, function (unwrapErr, pkgdir) {
            if (unwrapErr) return cb(unwrapErr);
            var pkgfile = path$3.join(pkgdir, 'package.json');
            isFile(pkgfile, function (err, ex) {
                if (err) return cb(err);
                if (!ex) return loadAsFile(path$3.join(x, 'index'), fpkg, cb);

                readPackage(readFile, pkgfile, function (err, pkgParam) {
                    if (err) return cb(err);

                    var pkg = pkgParam;

                    if (pkg && opts.packageFilter) {
                        pkg = opts.packageFilter(pkg, pkgfile);
                    }

                    if (pkg && pkg.main) {
                        if (typeof pkg.main !== 'string') {
                            var mainError = new TypeError('package “' + pkg.name + '” `main` must be a string');
                            mainError.code = 'INVALID_PACKAGE_MAIN';
                            return cb(mainError);
                        }
                        if (pkg.main === '.' || pkg.main === './') {
                            pkg.main = 'index';
                        }
                        loadAsFile(path$3.resolve(x, pkg.main), pkg, function (err, m, pkg) {
                            if (err) return cb(err);
                            if (m) return cb(null, m, pkg);
                            if (!pkg) return loadAsFile(path$3.join(x, 'index'), pkg, cb);

                            var dir = path$3.resolve(x, pkg.main);
                            loadAsDirectory(dir, pkg, function (err, n, pkg) {
                                if (err) return cb(err);
                                if (n) return cb(null, n, pkg);
                                loadAsFile(path$3.join(x, 'index'), pkg, cb);
                            });
                        });
                        return;
                    }

                    loadAsFile(path$3.join(x, '/index'), pkg, cb);
                });
            });
        });
    }

    function processDirs(cb, dirs) {
        if (dirs.length === 0) return cb(null, undefined);
        var dir = dirs[0];

        isDirectory(path$3.dirname(dir), isdir);

        function isdir(err, isdir) {
            if (err) return cb(err);
            if (!isdir) return processDirs(cb, dirs.slice(1));
            loadAsFile(dir, opts.package, onfile);
        }

        function onfile(err, m, pkg) {
            if (err) return cb(err);
            if (m) return cb(null, m, pkg);
            loadAsDirectory(dir, opts.package, ondir);
        }

        function ondir(err, n, pkg) {
            if (err) return cb(err);
            if (n) return cb(null, n, pkg);
            processDirs(cb, dirs.slice(1));
        }
    }
    function loadNodeModules(x, start, cb) {
        var thunk = function () { return getPackageCandidates$1(x, start, opts); };
        processDirs(
            cb,
            packageIterator ? packageIterator(x, start, thunk, opts) : thunk()
        );
    }
};

var assert = true;
var async_hooks = ">= 8";
var buffer_ieee754 = ">= 0.5 && < 0.9.7";
var buffer = true;
var child_process = true;
var cluster = ">= 0.5";
var console$1 = true;
var constants = true;
var crypto = true;
var _debug_agent = ">= 1 && < 8";
var _debugger = "< 8";
var dgram = true;
var diagnostics_channel = [
	">= 14.17 && < 15",
	">= 15.1"
];
var dns = true;
var domain = ">= 0.7.12";
var events = true;
var freelist = "< 6";
var fs$3 = true;
var _http_agent = ">= 0.11.1";
var _http_client = ">= 0.11.1";
var _http_common = ">= 0.11.1";
var _http_incoming = ">= 0.11.1";
var _http_outgoing = ">= 0.11.1";
var _http_server = ">= 0.11.1";
var http = true;
var http2 = ">= 8.8";
var https = true;
var inspector = ">= 8";
var _linklist = "< 8";
var module$1 = true;
var net = true;
var os$1 = true;
var path$2 = true;
var perf_hooks = ">= 8.5";
var process$1 = ">= 1";
var punycode = ">= 0.5";
var querystring = true;
var readline = true;
var repl = true;
var smalloc = ">= 0.11.5 && < 3";
var _stream_duplex = ">= 0.9.4";
var _stream_transform = ">= 0.9.4";
var _stream_wrap = ">= 1.4.1";
var _stream_passthrough = ">= 0.9.4";
var _stream_readable = ">= 0.9.4";
var _stream_writable = ">= 0.9.4";
var stream = true;
var string_decoder = true;
var sys = [
	">= 0.4 && < 0.7",
	">= 0.8"
];
var timers = true;
var _tls_common = ">= 0.11.13";
var _tls_legacy = ">= 0.11.3 && < 10";
var _tls_wrap = ">= 0.11.3";
var tls = true;
var trace_events = ">= 10";
var tty = true;
var url = true;
var util = true;
var v8 = ">= 1";
var vm = true;
var wasi = [
	">= 13.4 && < 13.5",
	">= 18.17 && < 19",
	">= 20"
];
var worker_threads = ">= 11.7";
var zlib = ">= 0.5";
var require$$1 = {
	assert: assert,
	"node:assert": [
	">= 14.18 && < 15",
	">= 16"
],
	"assert/strict": ">= 15",
	"node:assert/strict": ">= 16",
	async_hooks: async_hooks,
	"node:async_hooks": [
	">= 14.18 && < 15",
	">= 16"
],
	buffer_ieee754: buffer_ieee754,
	buffer: buffer,
	"node:buffer": [
	">= 14.18 && < 15",
	">= 16"
],
	child_process: child_process,
	"node:child_process": [
	">= 14.18 && < 15",
	">= 16"
],
	cluster: cluster,
	"node:cluster": [
	">= 14.18 && < 15",
	">= 16"
],
	console: console$1,
	"node:console": [
	">= 14.18 && < 15",
	">= 16"
],
	constants: constants,
	"node:constants": [
	">= 14.18 && < 15",
	">= 16"
],
	crypto: crypto,
	"node:crypto": [
	">= 14.18 && < 15",
	">= 16"
],
	_debug_agent: _debug_agent,
	_debugger: _debugger,
	dgram: dgram,
	"node:dgram": [
	">= 14.18 && < 15",
	">= 16"
],
	diagnostics_channel: diagnostics_channel,
	"node:diagnostics_channel": [
	">= 14.18 && < 15",
	">= 16"
],
	dns: dns,
	"node:dns": [
	">= 14.18 && < 15",
	">= 16"
],
	"dns/promises": ">= 15",
	"node:dns/promises": ">= 16",
	domain: domain,
	"node:domain": [
	">= 14.18 && < 15",
	">= 16"
],
	events: events,
	"node:events": [
	">= 14.18 && < 15",
	">= 16"
],
	freelist: freelist,
	fs: fs$3,
	"node:fs": [
	">= 14.18 && < 15",
	">= 16"
],
	"fs/promises": [
	">= 10 && < 10.1",
	">= 14"
],
	"node:fs/promises": [
	">= 14.18 && < 15",
	">= 16"
],
	_http_agent: _http_agent,
	"node:_http_agent": [
	">= 14.18 && < 15",
	">= 16"
],
	_http_client: _http_client,
	"node:_http_client": [
	">= 14.18 && < 15",
	">= 16"
],
	_http_common: _http_common,
	"node:_http_common": [
	">= 14.18 && < 15",
	">= 16"
],
	_http_incoming: _http_incoming,
	"node:_http_incoming": [
	">= 14.18 && < 15",
	">= 16"
],
	_http_outgoing: _http_outgoing,
	"node:_http_outgoing": [
	">= 14.18 && < 15",
	">= 16"
],
	_http_server: _http_server,
	"node:_http_server": [
	">= 14.18 && < 15",
	">= 16"
],
	http: http,
	"node:http": [
	">= 14.18 && < 15",
	">= 16"
],
	http2: http2,
	"node:http2": [
	">= 14.18 && < 15",
	">= 16"
],
	https: https,
	"node:https": [
	">= 14.18 && < 15",
	">= 16"
],
	inspector: inspector,
	"node:inspector": [
	">= 14.18 && < 15",
	">= 16"
],
	"inspector/promises": [
	">= 19"
],
	"node:inspector/promises": [
	">= 19"
],
	_linklist: _linklist,
	module: module$1,
	"node:module": [
	">= 14.18 && < 15",
	">= 16"
],
	net: net,
	"node:net": [
	">= 14.18 && < 15",
	">= 16"
],
	"node-inspect/lib/_inspect": ">= 7.6 && < 12",
	"node-inspect/lib/internal/inspect_client": ">= 7.6 && < 12",
	"node-inspect/lib/internal/inspect_repl": ">= 7.6 && < 12",
	os: os$1,
	"node:os": [
	">= 14.18 && < 15",
	">= 16"
],
	path: path$2,
	"node:path": [
	">= 14.18 && < 15",
	">= 16"
],
	"path/posix": ">= 15.3",
	"node:path/posix": ">= 16",
	"path/win32": ">= 15.3",
	"node:path/win32": ">= 16",
	perf_hooks: perf_hooks,
	"node:perf_hooks": [
	">= 14.18 && < 15",
	">= 16"
],
	process: process$1,
	"node:process": [
	">= 14.18 && < 15",
	">= 16"
],
	punycode: punycode,
	"node:punycode": [
	">= 14.18 && < 15",
	">= 16"
],
	querystring: querystring,
	"node:querystring": [
	">= 14.18 && < 15",
	">= 16"
],
	readline: readline,
	"node:readline": [
	">= 14.18 && < 15",
	">= 16"
],
	"readline/promises": ">= 17",
	"node:readline/promises": ">= 17",
	repl: repl,
	"node:repl": [
	">= 14.18 && < 15",
	">= 16"
],
	smalloc: smalloc,
	_stream_duplex: _stream_duplex,
	"node:_stream_duplex": [
	">= 14.18 && < 15",
	">= 16"
],
	_stream_transform: _stream_transform,
	"node:_stream_transform": [
	">= 14.18 && < 15",
	">= 16"
],
	_stream_wrap: _stream_wrap,
	"node:_stream_wrap": [
	">= 14.18 && < 15",
	">= 16"
],
	_stream_passthrough: _stream_passthrough,
	"node:_stream_passthrough": [
	">= 14.18 && < 15",
	">= 16"
],
	_stream_readable: _stream_readable,
	"node:_stream_readable": [
	">= 14.18 && < 15",
	">= 16"
],
	_stream_writable: _stream_writable,
	"node:_stream_writable": [
	">= 14.18 && < 15",
	">= 16"
],
	stream: stream,
	"node:stream": [
	">= 14.18 && < 15",
	">= 16"
],
	"stream/consumers": ">= 16.7",
	"node:stream/consumers": ">= 16.7",
	"stream/promises": ">= 15",
	"node:stream/promises": ">= 16",
	"stream/web": ">= 16.5",
	"node:stream/web": ">= 16.5",
	string_decoder: string_decoder,
	"node:string_decoder": [
	">= 14.18 && < 15",
	">= 16"
],
	sys: sys,
	"node:sys": [
	">= 14.18 && < 15",
	">= 16"
],
	"test/reporters": ">= 19.9 && < 20.2",
	"node:test/reporters": [
	">= 18.17 && < 19",
	">= 19.9",
	">= 20"
],
	"node:test": [
	">= 16.17 && < 17",
	">= 18"
],
	timers: timers,
	"node:timers": [
	">= 14.18 && < 15",
	">= 16"
],
	"timers/promises": ">= 15",
	"node:timers/promises": ">= 16",
	_tls_common: _tls_common,
	"node:_tls_common": [
	">= 14.18 && < 15",
	">= 16"
],
	_tls_legacy: _tls_legacy,
	_tls_wrap: _tls_wrap,
	"node:_tls_wrap": [
	">= 14.18 && < 15",
	">= 16"
],
	tls: tls,
	"node:tls": [
	">= 14.18 && < 15",
	">= 16"
],
	trace_events: trace_events,
	"node:trace_events": [
	">= 14.18 && < 15",
	">= 16"
],
	tty: tty,
	"node:tty": [
	">= 14.18 && < 15",
	">= 16"
],
	url: url,
	"node:url": [
	">= 14.18 && < 15",
	">= 16"
],
	util: util,
	"node:util": [
	">= 14.18 && < 15",
	">= 16"
],
	"util/types": ">= 15.3",
	"node:util/types": ">= 16",
	"v8/tools/arguments": ">= 10 && < 12",
	"v8/tools/codemap": [
	">= 4.4 && < 5",
	">= 5.2 && < 12"
],
	"v8/tools/consarray": [
	">= 4.4 && < 5",
	">= 5.2 && < 12"
],
	"v8/tools/csvparser": [
	">= 4.4 && < 5",
	">= 5.2 && < 12"
],
	"v8/tools/logreader": [
	">= 4.4 && < 5",
	">= 5.2 && < 12"
],
	"v8/tools/profile_view": [
	">= 4.4 && < 5",
	">= 5.2 && < 12"
],
	"v8/tools/splaytree": [
	">= 4.4 && < 5",
	">= 5.2 && < 12"
],
	v8: v8,
	"node:v8": [
	">= 14.18 && < 15",
	">= 16"
],
	vm: vm,
	"node:vm": [
	">= 14.18 && < 15",
	">= 16"
],
	wasi: wasi,
	"node:wasi": [
	">= 18.17 && < 19",
	">= 20"
],
	worker_threads: worker_threads,
	"node:worker_threads": [
	">= 14.18 && < 15",
	">= 16"
],
	zlib: zlib,
	"node:zlib": [
	">= 14.18 && < 15",
	">= 16"
]
};

var isCoreModule$1 = isCoreModule$2;
var data = require$$1;

var core = {};
for (var mod in data) { // eslint-disable-line no-restricted-syntax
    if (Object.prototype.hasOwnProperty.call(data, mod)) {
        core[mod] = isCoreModule$1(mod);
    }
}
var core_1 = core;

var isCoreModule = isCoreModule$2;

var isCore$1 = function isCore(x) {
    return isCoreModule(x);
};

var isCore = isCoreModule$2;
var fs$2 = require$$0__default["default"];
var path$1 = path__default["default"];
var getHomedir = homedir$2;
var caller = caller$2;
var nodeModulesPaths = nodeModulesPaths$2;
var normalizeOptions = normalizeOptions$2;

var realpathFS = process.platform !== 'win32' && fs$2.realpathSync && typeof fs$2.realpathSync.native === 'function' ? fs$2.realpathSync.native : fs$2.realpathSync;

var homedir = getHomedir();
var defaultPaths = function () {
    return [
        path$1.join(homedir, '.node_modules'),
        path$1.join(homedir, '.node_libraries')
    ];
};

var defaultIsFile = function isFile(file) {
    try {
        var stat = fs$2.statSync(file, { throwIfNoEntry: false });
    } catch (e) {
        if (e && (e.code === 'ENOENT' || e.code === 'ENOTDIR')) return false;
        throw e;
    }
    return !!stat && (stat.isFile() || stat.isFIFO());
};

var defaultIsDir = function isDirectory(dir) {
    try {
        var stat = fs$2.statSync(dir, { throwIfNoEntry: false });
    } catch (e) {
        if (e && (e.code === 'ENOENT' || e.code === 'ENOTDIR')) return false;
        throw e;
    }
    return !!stat && stat.isDirectory();
};

var defaultRealpathSync = function realpathSync(x) {
    try {
        return realpathFS(x);
    } catch (realpathErr) {
        if (realpathErr.code !== 'ENOENT') {
            throw realpathErr;
        }
    }
    return x;
};

var maybeRealpathSync = function maybeRealpathSync(realpathSync, x, opts) {
    if (opts && opts.preserveSymlinks === false) {
        return realpathSync(x);
    }
    return x;
};

var defaultReadPackageSync = function defaultReadPackageSync(readFileSync, pkgfile) {
    var body = readFileSync(pkgfile);
    try {
        var pkg = JSON.parse(body);
        return pkg;
    } catch (jsonErr) {}
};

var getPackageCandidates = function getPackageCandidates(x, start, opts) {
    var dirs = nodeModulesPaths(start, opts, x);
    for (var i = 0; i < dirs.length; i++) {
        dirs[i] = path$1.join(dirs[i], x);
    }
    return dirs;
};

var sync = function resolveSync(x, options) {
    if (typeof x !== 'string') {
        throw new TypeError('Path must be a string.');
    }
    var opts = normalizeOptions(x, options);

    var isFile = opts.isFile || defaultIsFile;
    var readFileSync = opts.readFileSync || fs$2.readFileSync;
    var isDirectory = opts.isDirectory || defaultIsDir;
    var realpathSync = opts.realpathSync || defaultRealpathSync;
    var readPackageSync = opts.readPackageSync || defaultReadPackageSync;
    if (opts.readFileSync && opts.readPackageSync) {
        throw new TypeError('`readFileSync` and `readPackageSync` are mutually exclusive.');
    }
    var packageIterator = opts.packageIterator;

    var extensions = opts.extensions || ['.js'];
    var includeCoreModules = opts.includeCoreModules !== false;
    var basedir = opts.basedir || path$1.dirname(caller());
    var parent = opts.filename || basedir;

    opts.paths = opts.paths || defaultPaths();

    // ensure that `basedir` is an absolute path at this point, resolving against the process' current working directory
    var absoluteStart = maybeRealpathSync(realpathSync, path$1.resolve(basedir), opts);

    if ((/^(?:\.\.?(?:\/|$)|\/|([A-Za-z]:)?[/\\])/).test(x)) {
        var res = path$1.resolve(absoluteStart, x);
        if (x === '.' || x === '..' || x.slice(-1) === '/') res += '/';
        var m = loadAsFileSync(res) || loadAsDirectorySync(res);
        if (m) return maybeRealpathSync(realpathSync, m, opts);
    } else if (includeCoreModules && isCore(x)) {
        return x;
    } else {
        var n = loadNodeModulesSync(x, absoluteStart);
        if (n) return maybeRealpathSync(realpathSync, n, opts);
    }

    var err = new Error("Cannot find module '" + x + "' from '" + parent + "'");
    err.code = 'MODULE_NOT_FOUND';
    throw err;

    function loadAsFileSync(x) {
        var pkg = loadpkg(path$1.dirname(x));

        if (pkg && pkg.dir && pkg.pkg && opts.pathFilter) {
            var rfile = path$1.relative(pkg.dir, x);
            var r = opts.pathFilter(pkg.pkg, x, rfile);
            if (r) {
                x = path$1.resolve(pkg.dir, r); // eslint-disable-line no-param-reassign
            }
        }

        if (isFile(x)) {
            return x;
        }

        for (var i = 0; i < extensions.length; i++) {
            var file = x + extensions[i];
            if (isFile(file)) {
                return file;
            }
        }
    }

    function loadpkg(dir) {
        if (dir === '' || dir === '/') return;
        if (process.platform === 'win32' && (/^\w:[/\\]*$/).test(dir)) {
            return;
        }
        if ((/[/\\]node_modules[/\\]*$/).test(dir)) return;

        var pkgfile = path$1.join(maybeRealpathSync(realpathSync, dir, opts), 'package.json');

        if (!isFile(pkgfile)) {
            return loadpkg(path$1.dirname(dir));
        }

        var pkg = readPackageSync(readFileSync, pkgfile);

        if (pkg && opts.packageFilter) {
            // v2 will pass pkgfile
            pkg = opts.packageFilter(pkg, /*pkgfile,*/ dir); // eslint-disable-line spaced-comment
        }

        return { pkg: pkg, dir: dir };
    }

    function loadAsDirectorySync(x) {
        var pkgfile = path$1.join(maybeRealpathSync(realpathSync, x, opts), '/package.json');
        if (isFile(pkgfile)) {
            try {
                var pkg = readPackageSync(readFileSync, pkgfile);
            } catch (e) {}

            if (pkg && opts.packageFilter) {
                // v2 will pass pkgfile
                pkg = opts.packageFilter(pkg, /*pkgfile,*/ x); // eslint-disable-line spaced-comment
            }

            if (pkg && pkg.main) {
                if (typeof pkg.main !== 'string') {
                    var mainError = new TypeError('package “' + pkg.name + '” `main` must be a string');
                    mainError.code = 'INVALID_PACKAGE_MAIN';
                    throw mainError;
                }
                if (pkg.main === '.' || pkg.main === './') {
                    pkg.main = 'index';
                }
                try {
                    var m = loadAsFileSync(path$1.resolve(x, pkg.main));
                    if (m) return m;
                    var n = loadAsDirectorySync(path$1.resolve(x, pkg.main));
                    if (n) return n;
                } catch (e) {}
            }
        }

        return loadAsFileSync(path$1.join(x, '/index'));
    }

    function loadNodeModulesSync(x, start) {
        var thunk = function () { return getPackageCandidates(x, start, opts); };
        var dirs = packageIterator ? packageIterator(x, start, thunk, opts) : thunk();

        for (var i = 0; i < dirs.length; i++) {
            var dir = dirs[i];
            if (isDirectory(path$1.dirname(dir))) {
                var m = loadAsFileSync(dir);
                if (m) return m;
                var n = loadAsDirectorySync(dir);
                if (n) return n;
            }
        }
    }
};

var async = async$1;
async.core = core_1;
async.isCore = isCore$1;
async.sync = sync;

var resolve = async;

var resolve$1 = /*@__PURE__*/getDefaultExportFromCjs(resolve);

var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __esm = (fn, res) => function __init() {
  return fn && (res = (0, fn[__getOwnPropNames(fn)[0]])(fn = 0)), res;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));

// src/jsx-runtime/babel-restore-jsx.ts
var babel_restore_jsx_exports = {};
__export(babel_restore_jsx_exports, {
  default: () => babel_restore_jsx_default
});
function babel_restore_jsx_default({ types: t }) {
  function getJSXNode(node) {
    if (!isReactCreateElement(node)) {
      return null;
    }
    const [nameNode, propsNode, ...childNodes] = node.arguments;
    const name = getJSXName(nameNode);
    if (name == null) {
      return null;
    }
    const props = getJSXProps(propsNode);
    if (props == null) {
      return null;
    }
    const children = getJSXChildren(childNodes);
    if (children == null) {
      return null;
    }
    if (t.isJSXMemberExpression(name) && t.isJSXIdentifier(name.object) && name.object.name === "React" && name.property.name === "Fragment") {
      return t.jsxFragment(t.jsxOpeningFragment(), t.jsxClosingFragment(), children);
    }
    const selfClosing = children.length === 0;
    const startTag = t.jsxOpeningElement(name, props, selfClosing);
    startTag.loc = node.loc;
    const endTag = selfClosing ? null : t.jsxClosingElement(name);
    return t.jsxElement(startTag, endTag, children, selfClosing);
  }
  function getJSXName(node) {
    if (node == null) {
      return null;
    }
    const name = getJSXIdentifier(node, true);
    if (name != null) {
      return name;
    }
    if (!t.isMemberExpression(node)) {
      return null;
    }
    const object = getJSXName(node.object);
    const property = getJSXName(node.property);
    if (object == null || property == null) {
      return null;
    }
    return t.jsxMemberExpression(object, property);
  }
  function getJSXProps(node) {
    if (node == null || isNullLikeNode(node)) {
      return [];
    }
    if (t.isCallExpression(node) && t.isIdentifier(node.callee, { name: "_extends" })) {
      const props = node.arguments.map(getJSXProps);
      if (props.every((prop) => prop != null)) {
        return [].concat(...props);
      }
    }
    if (!t.isObjectExpression(node) && t.isExpression(node))
      return [t.jsxSpreadAttribute(node)];
    if (!isPlainObjectExpression(node)) {
      return null;
    }
    return node.properties.map((prop) => t.isObjectProperty(prop) ? t.jsxAttribute(getJSXIdentifier(prop.key), getJSXAttributeValue(prop.value)) : t.jsxSpreadAttribute(prop.argument));
  }
  function getJSXChild(node) {
    if (t.isStringLiteral(node)) {
      return t.jsxText(node.value);
    }
    if (isReactCreateElement(node)) {
      return getJSXNode(node);
    }
    if (t.isExpression(node)) {
      return t.jsxExpressionContainer(node);
    }
    return null;
  }
  function getJSXChildren(nodes) {
    const children = nodes.filter((node) => !isNullLikeNode(node)).map(getJSXChild);
    if (children.some((child) => child == null)) {
      return null;
    }
    return children;
  }
  function getJSXIdentifier(node, tag = false) {
    if (t.isIdentifier(node) && (!tag || node.name.match(/^[A-Z]/))) {
      return t.jsxIdentifier(node.name);
    }
    if (t.isStringLiteral(node)) {
      return t.jsxIdentifier(node.value);
    }
    return null;
  }
  function getJSXAttributeValue(node) {
    if (t.isStringLiteral(node)) {
      return node;
    }
    if (t.isJSXElement(node)) {
      return node;
    }
    if (t.isExpression(node)) {
      return t.jsxExpressionContainer(node);
    }
    return null;
  }
  const isReactCreateElement = (node) => t.isCallExpression(node) && t.isMemberExpression(node.callee) && t.isIdentifier(node.callee.object, { name: "React" }) && t.isIdentifier(node.callee.property, { name: "createElement" }) && !node.callee.computed;
  const isNullLikeNode = (node) => t.isNullLiteral(node) || t.isIdentifier(node, { name: "undefined" });
  const isPlainObjectExpression = (node) => t.isObjectExpression(node) && node.properties.every((property) => t.isSpreadElement(property) || t.isObjectProperty(property, { computed: false }) && getJSXIdentifier(property.key) != null && getJSXAttributeValue(property.value) != null);
  return {
    visitor: {
      CallExpression(path2) {
        const node = getJSXNode(path2.node);
        if (node == null) {
          return null;
        }
        path2.replaceWith(node);
      }
    }
  };
}
var init_babel_restore_jsx = __esm({
  "src/jsx-runtime/babel-restore-jsx.ts"() {
  }
});

// src/index.ts
var src_exports = {};
__export(src_exports, {
  default: () => viteReact
});
var dist = viteReact;
viteReact['default'] = viteReact;
var babel$2 = __toESM(requireLib());
var import_pluginutils = cjs;
var import_resolve = __toESM(resolve);

// src/fast-refresh.ts
var import_fs = __toESM(require$$0__default["default"]);
var import_path = __toESM(path__default["default"]);
var runtimePublicPath = "/@react-refresh";
var reactRefreshDir = import_path.default.dirname(require.resolve("react-refresh/package.json"));
var runtimeFilePath = import_path.default.join(reactRefreshDir, "cjs/react-refresh-runtime.development.js");
var runtimeCode = `
const exports = {}
${import_fs.default.readFileSync(runtimeFilePath, "utf-8")}
function debounce(fn, delay) {
  let handle
  return () => {
    clearTimeout(handle)
    handle = setTimeout(fn, delay)
  }
}
exports.performReactRefresh = debounce(exports.performReactRefresh, 16)
export default exports
`;
var preambleCode = `
import RefreshRuntime from "__BASE__${runtimePublicPath.slice(1)}"
RefreshRuntime.injectIntoGlobalHook(window)
window.$RefreshReg$ = () => {}
window.$RefreshSig$ = () => (type) => type
window.__vite_plugin_react_preamble_installed__ = true
`;
var header = `
import RefreshRuntime from "${runtimePublicPath}";

let prevRefreshReg;
let prevRefreshSig;

if (import.meta.hot) {
  if (!window.__vite_plugin_react_preamble_installed__) {
    throw new Error(
      "@vitejs/plugin-react can't detect preamble. Something is wrong. " +
      "See https://github.com/vitejs/vite-plugin-react/pull/11#discussion_r430879201"
    );
  }

  prevRefreshReg = window.$RefreshReg$;
  prevRefreshSig = window.$RefreshSig$;
  window.$RefreshReg$ = (type, id) => {
    RefreshRuntime.register(type, __SOURCE__ + " " + id)
  };
  window.$RefreshSig$ = RefreshRuntime.createSignatureFunctionForTransform;
}`.replace(/[\n]+/gm, "");
var footer = `
if (import.meta.hot) {
  window.$RefreshReg$ = prevRefreshReg;
  window.$RefreshSig$ = prevRefreshSig;

  __ACCEPT__
  if (!window.__vite_plugin_react_timeout) {
    window.__vite_plugin_react_timeout = setTimeout(() => {
      window.__vite_plugin_react_timeout = 0;
      RefreshRuntime.performReactRefresh();
    }, 30);
  }
}`;
function addRefreshWrapper(code, id, accept) {
  return header.replace("__SOURCE__", JSON.stringify(id)) + code + footer.replace("__ACCEPT__", accept ? "import.meta.hot.accept();" : "");
}
function isRefreshBoundary(ast) {
  return ast.program.body.every((node) => {
    if (node.type !== "ExportNamedDeclaration") {
      return true;
    }
    const { declaration, specifiers } = node;
    if (declaration) {
      if (declaration.type === "VariableDeclaration") {
        return declaration.declarations.every((variable) => isComponentLikeIdentifier(variable.id));
      }
      if (declaration.type === "FunctionDeclaration") {
        return !!declaration.id && isComponentLikeIdentifier(declaration.id);
      }
    }
    return specifiers.every((spec) => {
      return isComponentLikeIdentifier(spec.exported);
    });
  });
}
function isComponentLikeIdentifier(node) {
  return node.type === "Identifier" && isComponentLikeName(node.name);
}
function isComponentLikeName(name) {
  return typeof name === "string" && name[0] >= "A" && name[0] <= "Z";
}

// src/jsx-runtime/babel-import-to-require.ts
function babelImportToRequire({ types: t }) {
  return {
    visitor: {
      ImportDeclaration(path2) {
        const decl = path2.node;
        const spec = decl.specifiers[0];
        path2.replaceWith(t.variableDeclaration("var", [
          t.variableDeclarator(spec.local, t.memberExpression(t.callExpression(t.identifier("require"), [decl.source]), spec.imported))
        ]));
      }
    }
  };
}

// src/jsx-runtime/restore-jsx.ts
var babelRestoreJSX;
var jsxNotFound = [null, false];
async function restoreJSX(babel2, code, filename) {
  if (filename.includes("/.vite/react-dom.js")) {
    return jsxNotFound;
  }
  const [reactAlias, isCommonJS] = parseReactAlias(code);
  if (!reactAlias) {
    return jsxNotFound;
  }
  let hasCompiledJsx = false;
  const fragmentPattern = `\\b${reactAlias}\\.Fragment\\b`;
  const createElementPattern = `\\b${reactAlias}\\.createElement\\(\\s*([A-Z"'][\\w$.]*["']?)`;
  code = code.replace(new RegExp(fragmentPattern, "g"), () => {
    hasCompiledJsx = true;
    return "React.Fragment";
  }).replace(new RegExp(createElementPattern, "g"), (original, component) => {
    if (/^[a-z][\w$]*$/.test(component)) {
      return original;
    }
    hasCompiledJsx = true;
    return "React.createElement(" + (component === "Fragment" ? "React.Fragment" : component);
  });
  if (!hasCompiledJsx) {
    return jsxNotFound;
  }
  babelRestoreJSX || (babelRestoreJSX = Promise.resolve().then(() => (init_babel_restore_jsx(), babel_restore_jsx_exports)));
  const result = await babel2.transformAsync(code, {
    babelrc: false,
    configFile: false,
    ast: true,
    code: false,
    filename,
    parserOpts: {
      plugins: ["jsx"]
    },
    plugins: [(await babelRestoreJSX).default]
  });
  return [result == null ? void 0 : result.ast, isCommonJS];
}
function parseReactAlias(code) {
  let match = code.match(/\b(var|let|const) +(\w+) *= *require\(["']react["']\)/);
  if (match) {
    return [match[2], true];
  }
  match = code.match(/^import (\w+).+? from ["']react["']/m);
  if (match) {
    return [match[1], false];
  }
  return [void 0, false];
}

// src/index.ts
function viteReact(opts = {}) {
  var _a;
  let base = "/";
  let filter = (0, import_pluginutils.createFilter)(opts.include, opts.exclude);
  let isProduction = true;
  let projectRoot = process.cwd();
  let skipFastRefresh = opts.fastRefresh === false;
  let skipReactImport = false;
  const useAutomaticRuntime = opts.jsxRuntime !== "classic";
  const babelOptions = __spreadValues({
    babelrc: false,
    configFile: false
  }, opts.babel);
  babelOptions.plugins || (babelOptions.plugins = []);
  babelOptions.presets || (babelOptions.presets = []);
  babelOptions.overrides || (babelOptions.overrides = []);
  babelOptions.parserOpts || (babelOptions.parserOpts = {});
  (_a = babelOptions.parserOpts).plugins || (_a.plugins = opts.parserPlugins || []);
  const importReactRE = /(^|\n)import\s+(\*\s+as\s+)?React(,|\s+)/;
  const fileExtensionRE = /\.[^\/\s\?]+$/;
  const viteBabel = {
    name: "vite:react-babel",
    enforce: "pre",
    configResolved(config) {
      base = config.base;
      projectRoot = config.root;
      filter = (0, import_pluginutils.createFilter)(opts.include, opts.exclude, {
        resolve: projectRoot
      });
      isProduction = config.isProduction;
      skipFastRefresh || (skipFastRefresh = isProduction || config.command === "build");
      const jsxInject = config.esbuild && config.esbuild.jsxInject;
      if (jsxInject && importReactRE.test(jsxInject)) {
        skipReactImport = true;
        config.logger.warn("[@vitejs/plugin-react] This plugin imports React for you automatically, so you can stop using `esbuild.jsxInject` for that purpose.");
      }
      config.plugins.forEach((plugin) => {
        var _a2;
        const hasConflict = plugin.name === "react-refresh" || plugin !== viteReactJsx && plugin.name === "vite:react-jsx";
        if (hasConflict)
          return config.logger.warn(`[@vitejs/plugin-react] You should stop using "${plugin.name}" since this plugin conflicts with it.`);
        if ((_a2 = plugin.api) == null ? void 0 : _a2.reactBabel) {
          plugin.api.reactBabel(babelOptions, config);
        }
      });
    },
    async transform(code, id, options) {
      const ssr = typeof options === "boolean" ? options : (options == null ? void 0 : options.ssr) === true;
      const [filepath, querystring = ""] = id.split("?");
      const [extension = ""] = querystring.match(fileExtensionRE) || filepath.match(fileExtensionRE) || [];
      if (/\.(mjs|[tj]sx?)$/.test(extension)) {
        const isJSX = extension.endsWith("x");
        const isNodeModules = id.includes("/node_modules/");
        const isProjectFile = !isNodeModules && (id[0] === "\0" || id.startsWith(projectRoot + "/"));
        const plugins = isProjectFile ? [...babelOptions.plugins] : [];
        let useFastRefresh = false;
        if (!skipFastRefresh && !ssr && !isNodeModules) {
          const isReactModule = isJSX || importReactRE.test(code);
          if (isReactModule && filter(id)) {
            useFastRefresh = true;
            plugins.push([
              await loadPlugin("react-refresh/babel"),
              { skipEnvCheck: true }
            ]);
          }
        }
        let ast;
        if (!isProjectFile || isJSX) {
          if (useAutomaticRuntime) {
            const [restoredAst, isCommonJS] = !isProjectFile && !isJSX ? await restoreJSX(babel$2, code, id) : [null, false];
            if (isJSX || (ast = restoredAst)) {
              plugins.push([
                await loadPlugin("@babel/plugin-transform-react-jsx" + (isProduction ? "" : "-development")),
                {
                  runtime: "automatic",
                  importSource: opts.jsxImportSource,
                  pure: opts.jsxPure !== false
                }
              ]);
              if (isCommonJS) {
                plugins.push(babelImportToRequire);
              }
            }
          } else if (isProjectFile) {
            if (!isProduction) {
              plugins.push(await loadPlugin("@babel/plugin-transform-react-jsx-self"), await loadPlugin("@babel/plugin-transform-react-jsx-source"));
            }
            if (!skipReactImport && !importReactRE.test(code)) {
              code = `import React from 'react'; ` + code;
            }
          }
        }
        const shouldSkip = !plugins.length && !babelOptions.configFile && !(isProjectFile && babelOptions.babelrc);
        if (shouldSkip) {
          return;
        }
        const parserPlugins = [
          ...babelOptions.parserOpts.plugins,
          "importMeta",
          "topLevelAwait",
          "classProperties",
          "classPrivateProperties",
          "classPrivateMethods"
        ];
        if (!extension.endsWith(".ts")) {
          parserPlugins.push("jsx");
        }
        if (/\.tsx?$/.test(extension)) {
          parserPlugins.push("typescript");
        }
        const transformAsync2 = ast ? babel$2.transformFromAstAsync.bind(babel$2, ast, code) : babel$2.transformAsync.bind(babel$2, code);
        const isReasonReact = extension.endsWith(".bs.js");
        const result = await transformAsync2(__spreadProps(__spreadValues({}, babelOptions), {
          ast: !isReasonReact,
          root: projectRoot,
          filename: id,
          sourceFileName: filepath,
          parserOpts: __spreadProps(__spreadValues({}, babelOptions.parserOpts), {
            sourceType: "module",
            allowAwaitOutsideFunction: true,
            plugins: parserPlugins
          }),
          generatorOpts: __spreadProps(__spreadValues({}, babelOptions.generatorOpts), {
            decoratorsBeforeExport: true
          }),
          plugins,
          sourceMaps: true,
          inputSourceMap: false
        }));
        if (result) {
          let code2 = result.code;
          if (useFastRefresh && /\$RefreshReg\$\(/.test(code2)) {
            const accept = isReasonReact || isRefreshBoundary(result.ast);
            code2 = addRefreshWrapper(code2, id, accept);
          }
          return {
            code: code2,
            map: result.map
          };
        }
      }
    }
  };
  const viteReactRefresh = {
    name: "vite:react-refresh",
    enforce: "pre",
    config: () => ({
      resolve: {
        dedupe: ["react", "react-dom"]
      }
    }),
    resolveId(id) {
      if (id === runtimePublicPath) {
        return id;
      }
    },
    load(id) {
      if (id === runtimePublicPath) {
        return runtimeCode;
      }
    },
    transformIndexHtml() {
      if (!skipFastRefresh)
        return [
          {
            tag: "script",
            attrs: { type: "module" },
            children: preambleCode.replace(`__BASE__`, base)
          }
        ];
    }
  };
  const runtimeId = "react/jsx-runtime";
  const viteReactJsx = {
    name: "vite:react-jsx",
    enforce: "pre",
    config() {
      return {
        optimizeDeps: {
          include: ["react/jsx-dev-runtime"]
        }
      };
    },
    resolveId(id) {
      return id === runtimeId ? id : null;
    },
    load(id) {
      if (id === runtimeId) {
        const runtimePath = import_resolve.default.sync(runtimeId, {
          basedir: projectRoot
        });
        const exports = ["jsx", "jsxs", "Fragment"];
        return [
          `import * as jsxRuntime from ${JSON.stringify(runtimePath)}`,
          ...exports.map((name) => `export const ${name} = jsxRuntime.${name}`)
        ].join("\n");
      }
    }
  };
  return [viteBabel, viteReactRefresh, useAutomaticRuntime && viteReactJsx];
}
viteReact.preambleCode = preambleCode;
function loadPlugin(path2) {
  return Promise.resolve().then(() => __toESM(commonjsRequire(path2))).then((module2) => module2.default || module2);
}
/**
 * https://github.com/flying-sheep/babel-plugin-transform-react-createelement-to-jsx
 * @license GNU General Public License v3.0
 */

var react = /*@__PURE__*/getDefaultExportFromCjs(dist);

var charToInteger = {};
var chars = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=';
for (var i = 0; i < chars.length; i++) {
    charToInteger[chars.charCodeAt(i)] = i;
}
function decode(mappings) {
    var decoded = [];
    var line = [];
    var segment = [
        0,
        0,
        0,
        0,
        0,
    ];
    var j = 0;
    for (var i = 0, shift = 0, value = 0; i < mappings.length; i++) {
        var c = mappings.charCodeAt(i);
        if (c === 44) { // ","
            segmentify(line, segment, j);
            j = 0;
        }
        else if (c === 59) { // ";"
            segmentify(line, segment, j);
            j = 0;
            decoded.push(line);
            line = [];
            segment[0] = 0;
        }
        else {
            var integer = charToInteger[c];
            if (integer === undefined) {
                throw new Error('Invalid character (' + String.fromCharCode(c) + ')');
            }
            var hasContinuationBit = integer & 32;
            integer &= 31;
            value += integer << shift;
            if (hasContinuationBit) {
                shift += 5;
            }
            else {
                var shouldNegate = value & 1;
                value >>>= 1;
                if (shouldNegate) {
                    value = value === 0 ? -0x80000000 : -value;
                }
                segment[j] += value;
                j++;
                value = shift = 0; // reset
            }
        }
    }
    segmentify(line, segment, j);
    decoded.push(line);
    return decoded;
}
function segmentify(line, segment, j) {
    // This looks ugly, but we're creating specialized arrays with a specific
    // length. This is much faster than creating a new array (which v8 expands to
    // a capacity of 17 after pushing the first item), or slicing out a subarray
    // (which is slow). Length 4 is assumed to be the most frequent, followed by
    // length 5 (since not everything will have an associated name), followed by
    // length 1 (it's probably rare for a source substring to not have an
    // associated segment data).
    if (j === 4)
        line.push([segment[0], segment[1], segment[2], segment[3]]);
    else if (j === 5)
        line.push([segment[0], segment[1], segment[2], segment[3], segment[4]]);
    else if (j === 1)
        line.push([segment[0]]);
}
function encode(decoded) {
    var sourceFileIndex = 0; // second field
    var sourceCodeLine = 0; // third field
    var sourceCodeColumn = 0; // fourth field
    var nameIndex = 0; // fifth field
    var mappings = '';
    for (var i = 0; i < decoded.length; i++) {
        var line = decoded[i];
        if (i > 0)
            mappings += ';';
        if (line.length === 0)
            continue;
        var generatedCodeColumn = 0; // first field
        var lineMappings = [];
        for (var _i = 0, line_1 = line; _i < line_1.length; _i++) {
            var segment = line_1[_i];
            var segmentMappings = encodeInteger(segment[0] - generatedCodeColumn);
            generatedCodeColumn = segment[0];
            if (segment.length > 1) {
                segmentMappings +=
                    encodeInteger(segment[1] - sourceFileIndex) +
                        encodeInteger(segment[2] - sourceCodeLine) +
                        encodeInteger(segment[3] - sourceCodeColumn);
                sourceFileIndex = segment[1];
                sourceCodeLine = segment[2];
                sourceCodeColumn = segment[3];
            }
            if (segment.length === 5) {
                segmentMappings += encodeInteger(segment[4] - nameIndex);
                nameIndex = segment[4];
            }
            lineMappings.push(segmentMappings);
        }
        mappings += lineMappings.join(',');
    }
    return mappings;
}
function encodeInteger(num) {
    var result = '';
    num = num < 0 ? (-num << 1) | 1 : num << 1;
    do {
        var clamped = num & 31;
        num >>>= 5;
        if (num > 0) {
            clamped |= 32;
        }
        result += chars[clamped];
    } while (num > 0);
    return result;
}

var sourcemapCodec_es = /*#__PURE__*/Object.freeze({
    __proto__: null,
    decode: decode,
    encode: encode
});

var require$$0 = /*@__PURE__*/getAugmentedNamespace(sourcemapCodec_es);

var sourcemapCodec = require$$0;

class BitSet {
	constructor(arg) {
		this.bits = arg instanceof BitSet ? arg.bits.slice() : [];
	}

	add(n) {
		this.bits[n >> 5] |= 1 << (n & 31);
	}

	has(n) {
		return !!(this.bits[n >> 5] & (1 << (n & 31)));
	}
}

class Chunk {
	constructor(start, end, content) {
		this.start = start;
		this.end = end;
		this.original = content;

		this.intro = '';
		this.outro = '';

		this.content = content;
		this.storeName = false;
		this.edited = false;

		{
			this.previous = null;
			this.next = null;
		}
	}

	appendLeft(content) {
		this.outro += content;
	}

	appendRight(content) {
		this.intro = this.intro + content;
	}

	clone() {
		const chunk = new Chunk(this.start, this.end, this.original);

		chunk.intro = this.intro;
		chunk.outro = this.outro;
		chunk.content = this.content;
		chunk.storeName = this.storeName;
		chunk.edited = this.edited;

		return chunk;
	}

	contains(index) {
		return this.start < index && index < this.end;
	}

	eachNext(fn) {
		let chunk = this;
		while (chunk) {
			fn(chunk);
			chunk = chunk.next;
		}
	}

	eachPrevious(fn) {
		let chunk = this;
		while (chunk) {
			fn(chunk);
			chunk = chunk.previous;
		}
	}

	edit(content, storeName, contentOnly) {
		this.content = content;
		if (!contentOnly) {
			this.intro = '';
			this.outro = '';
		}
		this.storeName = storeName;

		this.edited = true;

		return this;
	}

	prependLeft(content) {
		this.outro = content + this.outro;
	}

	prependRight(content) {
		this.intro = content + this.intro;
	}

	split(index) {
		const sliceIndex = index - this.start;

		const originalBefore = this.original.slice(0, sliceIndex);
		const originalAfter = this.original.slice(sliceIndex);

		this.original = originalBefore;

		const newChunk = new Chunk(index, this.end, originalAfter);
		newChunk.outro = this.outro;
		this.outro = '';

		this.end = index;

		if (this.edited) {
			// TODO is this block necessary?...
			newChunk.edit('', false);
			this.content = '';
		} else {
			this.content = originalBefore;
		}

		newChunk.next = this.next;
		if (newChunk.next) newChunk.next.previous = newChunk;
		newChunk.previous = this;
		this.next = newChunk;

		return newChunk;
	}

	toString() {
		return this.intro + this.content + this.outro;
	}

	trimEnd(rx) {
		this.outro = this.outro.replace(rx, '');
		if (this.outro.length) return true;

		const trimmed = this.content.replace(rx, '');

		if (trimmed.length) {
			if (trimmed !== this.content) {
				this.split(this.start + trimmed.length).edit('', undefined, true);
			}
			return true;
		} else {
			this.edit('', undefined, true);

			this.intro = this.intro.replace(rx, '');
			if (this.intro.length) return true;
		}
	}

	trimStart(rx) {
		this.intro = this.intro.replace(rx, '');
		if (this.intro.length) return true;

		const trimmed = this.content.replace(rx, '');

		if (trimmed.length) {
			if (trimmed !== this.content) {
				this.split(this.end - trimmed.length);
				this.edit('', undefined, true);
			}
			return true;
		} else {
			this.edit('', undefined, true);

			this.outro = this.outro.replace(rx, '');
			if (this.outro.length) return true;
		}
	}
}

function getBtoa () {
	if (typeof window !== 'undefined' && typeof window.btoa === 'function') {
		return (str) => window.btoa(unescape(encodeURIComponent(str)));
	} else if (typeof Buffer === 'function') {
		return (str) => Buffer.from(str, 'utf-8').toString('base64');
	} else {
		return () => {
			throw new Error('Unsupported environment: `window.btoa` or `Buffer` should be supported.');
		};
	}
}

const btoa$1 = /*#__PURE__*/ getBtoa();

class SourceMap {
	constructor(properties) {
		this.version = 3;
		this.file = properties.file;
		this.sources = properties.sources;
		this.sourcesContent = properties.sourcesContent;
		this.names = properties.names;
		this.mappings = sourcemapCodec.encode(properties.mappings);
	}

	toString() {
		return JSON.stringify(this);
	}

	toUrl() {
		return 'data:application/json;charset=utf-8;base64,' + btoa$1(this.toString());
	}
}

function guessIndent(code) {
	const lines = code.split('\n');

	const tabbed = lines.filter((line) => /^\t+/.test(line));
	const spaced = lines.filter((line) => /^ {2,}/.test(line));

	if (tabbed.length === 0 && spaced.length === 0) {
		return null;
	}

	// More lines tabbed than spaced? Assume tabs, and
	// default to tabs in the case of a tie (or nothing
	// to go on)
	if (tabbed.length >= spaced.length) {
		return '\t';
	}

	// Otherwise, we need to guess the multiple
	const min = spaced.reduce((previous, current) => {
		const numSpaces = /^ +/.exec(current)[0].length;
		return Math.min(numSpaces, previous);
	}, Infinity);

	return new Array(min + 1).join(' ');
}

function getRelativePath(from, to) {
	const fromParts = from.split(/[/\\]/);
	const toParts = to.split(/[/\\]/);

	fromParts.pop(); // get dirname

	while (fromParts[0] === toParts[0]) {
		fromParts.shift();
		toParts.shift();
	}

	if (fromParts.length) {
		let i = fromParts.length;
		while (i--) fromParts[i] = '..';
	}

	return fromParts.concat(toParts).join('/');
}

const toString = Object.prototype.toString;

function isObject(thing) {
	return toString.call(thing) === '[object Object]';
}

function getLocator(source) {
	const originalLines = source.split('\n');
	const lineOffsets = [];

	for (let i = 0, pos = 0; i < originalLines.length; i++) {
		lineOffsets.push(pos);
		pos += originalLines[i].length + 1;
	}

	return function locate(index) {
		let i = 0;
		let j = lineOffsets.length;
		while (i < j) {
			const m = (i + j) >> 1;
			if (index < lineOffsets[m]) {
				j = m;
			} else {
				i = m + 1;
			}
		}
		const line = i - 1;
		const column = index - lineOffsets[line];
		return { line, column };
	};
}

class Mappings {
	constructor(hires) {
		this.hires = hires;
		this.generatedCodeLine = 0;
		this.generatedCodeColumn = 0;
		this.raw = [];
		this.rawSegments = this.raw[this.generatedCodeLine] = [];
		this.pending = null;
	}

	addEdit(sourceIndex, content, loc, nameIndex) {
		if (content.length) {
			const segment = [this.generatedCodeColumn, sourceIndex, loc.line, loc.column];
			if (nameIndex >= 0) {
				segment.push(nameIndex);
			}
			this.rawSegments.push(segment);
		} else if (this.pending) {
			this.rawSegments.push(this.pending);
		}

		this.advance(content);
		this.pending = null;
	}

	addUneditedChunk(sourceIndex, chunk, original, loc, sourcemapLocations) {
		let originalCharIndex = chunk.start;
		let first = true;

		while (originalCharIndex < chunk.end) {
			if (this.hires || first || sourcemapLocations.has(originalCharIndex)) {
				this.rawSegments.push([this.generatedCodeColumn, sourceIndex, loc.line, loc.column]);
			}

			if (original[originalCharIndex] === '\n') {
				loc.line += 1;
				loc.column = 0;
				this.generatedCodeLine += 1;
				this.raw[this.generatedCodeLine] = this.rawSegments = [];
				this.generatedCodeColumn = 0;
				first = true;
			} else {
				loc.column += 1;
				this.generatedCodeColumn += 1;
				first = false;
			}

			originalCharIndex += 1;
		}

		this.pending = null;
	}

	advance(str) {
		if (!str) return;

		const lines = str.split('\n');

		if (lines.length > 1) {
			for (let i = 0; i < lines.length - 1; i++) {
				this.generatedCodeLine++;
				this.raw[this.generatedCodeLine] = this.rawSegments = [];
			}
			this.generatedCodeColumn = 0;
		}

		this.generatedCodeColumn += lines[lines.length - 1].length;
	}
}

const n = '\n';

const warned = {
	insertLeft: false,
	insertRight: false,
	storeName: false,
};

class MagicString$1 {
	constructor(string, options = {}) {
		const chunk = new Chunk(0, string.length, string);

		Object.defineProperties(this, {
			original: { writable: true, value: string },
			outro: { writable: true, value: '' },
			intro: { writable: true, value: '' },
			firstChunk: { writable: true, value: chunk },
			lastChunk: { writable: true, value: chunk },
			lastSearchedChunk: { writable: true, value: chunk },
			byStart: { writable: true, value: {} },
			byEnd: { writable: true, value: {} },
			filename: { writable: true, value: options.filename },
			indentExclusionRanges: { writable: true, value: options.indentExclusionRanges },
			sourcemapLocations: { writable: true, value: new BitSet() },
			storedNames: { writable: true, value: {} },
			indentStr: { writable: true, value: undefined },
		});

		this.byStart[0] = chunk;
		this.byEnd[string.length] = chunk;
	}

	addSourcemapLocation(char) {
		this.sourcemapLocations.add(char);
	}

	append(content) {
		if (typeof content !== 'string') throw new TypeError('outro content must be a string');

		this.outro += content;
		return this;
	}

	appendLeft(index, content) {
		if (typeof content !== 'string') throw new TypeError('inserted content must be a string');

		this._split(index);

		const chunk = this.byEnd[index];

		if (chunk) {
			chunk.appendLeft(content);
		} else {
			this.intro += content;
		}
		return this;
	}

	appendRight(index, content) {
		if (typeof content !== 'string') throw new TypeError('inserted content must be a string');

		this._split(index);

		const chunk = this.byStart[index];

		if (chunk) {
			chunk.appendRight(content);
		} else {
			this.outro += content;
		}
		return this;
	}

	clone() {
		const cloned = new MagicString$1(this.original, { filename: this.filename });

		let originalChunk = this.firstChunk;
		let clonedChunk = (cloned.firstChunk = cloned.lastSearchedChunk = originalChunk.clone());

		while (originalChunk) {
			cloned.byStart[clonedChunk.start] = clonedChunk;
			cloned.byEnd[clonedChunk.end] = clonedChunk;

			const nextOriginalChunk = originalChunk.next;
			const nextClonedChunk = nextOriginalChunk && nextOriginalChunk.clone();

			if (nextClonedChunk) {
				clonedChunk.next = nextClonedChunk;
				nextClonedChunk.previous = clonedChunk;

				clonedChunk = nextClonedChunk;
			}

			originalChunk = nextOriginalChunk;
		}

		cloned.lastChunk = clonedChunk;

		if (this.indentExclusionRanges) {
			cloned.indentExclusionRanges = this.indentExclusionRanges.slice();
		}

		cloned.sourcemapLocations = new BitSet(this.sourcemapLocations);

		cloned.intro = this.intro;
		cloned.outro = this.outro;

		return cloned;
	}

	generateDecodedMap(options) {
		options = options || {};

		const sourceIndex = 0;
		const names = Object.keys(this.storedNames);
		const mappings = new Mappings(options.hires);

		const locate = getLocator(this.original);

		if (this.intro) {
			mappings.advance(this.intro);
		}

		this.firstChunk.eachNext((chunk) => {
			const loc = locate(chunk.start);

			if (chunk.intro.length) mappings.advance(chunk.intro);

			if (chunk.edited) {
				mappings.addEdit(
					sourceIndex,
					chunk.content,
					loc,
					chunk.storeName ? names.indexOf(chunk.original) : -1
				);
			} else {
				mappings.addUneditedChunk(sourceIndex, chunk, this.original, loc, this.sourcemapLocations);
			}

			if (chunk.outro.length) mappings.advance(chunk.outro);
		});

		return {
			file: options.file ? options.file.split(/[/\\]/).pop() : null,
			sources: [options.source ? getRelativePath(options.file || '', options.source) : null],
			sourcesContent: options.includeContent ? [this.original] : [null],
			names,
			mappings: mappings.raw,
		};
	}

	generateMap(options) {
		return new SourceMap(this.generateDecodedMap(options));
	}

	_ensureindentStr() {
		if (this.indentStr === undefined) {
			this.indentStr = guessIndent(this.original);
		}
	}

	_getRawIndentString() {
		this._ensureindentStr();
		return this.indentStr;
	}

	getIndentString() {
		this._ensureindentStr();
		return this.indentStr === null ? '\t' : this.indentStr;
	}

	indent(indentStr, options) {
		const pattern = /^[^\r\n]/gm;

		if (isObject(indentStr)) {
			options = indentStr;
			indentStr = undefined;
		}

		if (indentStr === undefined) {
			this._ensureindentStr();
			indentStr = this.indentStr || '\t';
		}

		if (indentStr === '') return this; // noop

		options = options || {};

		// Process exclusion ranges
		const isExcluded = {};

		if (options.exclude) {
			const exclusions =
				typeof options.exclude[0] === 'number' ? [options.exclude] : options.exclude;
			exclusions.forEach((exclusion) => {
				for (let i = exclusion[0]; i < exclusion[1]; i += 1) {
					isExcluded[i] = true;
				}
			});
		}

		let shouldIndentNextCharacter = options.indentStart !== false;
		const replacer = (match) => {
			if (shouldIndentNextCharacter) return `${indentStr}${match}`;
			shouldIndentNextCharacter = true;
			return match;
		};

		this.intro = this.intro.replace(pattern, replacer);

		let charIndex = 0;
		let chunk = this.firstChunk;

		while (chunk) {
			const end = chunk.end;

			if (chunk.edited) {
				if (!isExcluded[charIndex]) {
					chunk.content = chunk.content.replace(pattern, replacer);

					if (chunk.content.length) {
						shouldIndentNextCharacter = chunk.content[chunk.content.length - 1] === '\n';
					}
				}
			} else {
				charIndex = chunk.start;

				while (charIndex < end) {
					if (!isExcluded[charIndex]) {
						const char = this.original[charIndex];

						if (char === '\n') {
							shouldIndentNextCharacter = true;
						} else if (char !== '\r' && shouldIndentNextCharacter) {
							shouldIndentNextCharacter = false;

							if (charIndex === chunk.start) {
								chunk.prependRight(indentStr);
							} else {
								this._splitChunk(chunk, charIndex);
								chunk = chunk.next;
								chunk.prependRight(indentStr);
							}
						}
					}

					charIndex += 1;
				}
			}

			charIndex = chunk.end;
			chunk = chunk.next;
		}

		this.outro = this.outro.replace(pattern, replacer);

		return this;
	}

	insert() {
		throw new Error(
			'magicString.insert(...) is deprecated. Use prependRight(...) or appendLeft(...)'
		);
	}

	insertLeft(index, content) {
		if (!warned.insertLeft) {
			console.warn(
				'magicString.insertLeft(...) is deprecated. Use magicString.appendLeft(...) instead'
			); // eslint-disable-line no-console
			warned.insertLeft = true;
		}

		return this.appendLeft(index, content);
	}

	insertRight(index, content) {
		if (!warned.insertRight) {
			console.warn(
				'magicString.insertRight(...) is deprecated. Use magicString.prependRight(...) instead'
			); // eslint-disable-line no-console
			warned.insertRight = true;
		}

		return this.prependRight(index, content);
	}

	move(start, end, index) {
		if (index >= start && index <= end) throw new Error('Cannot move a selection inside itself');

		this._split(start);
		this._split(end);
		this._split(index);

		const first = this.byStart[start];
		const last = this.byEnd[end];

		const oldLeft = first.previous;
		const oldRight = last.next;

		const newRight = this.byStart[index];
		if (!newRight && last === this.lastChunk) return this;
		const newLeft = newRight ? newRight.previous : this.lastChunk;

		if (oldLeft) oldLeft.next = oldRight;
		if (oldRight) oldRight.previous = oldLeft;

		if (newLeft) newLeft.next = first;
		if (newRight) newRight.previous = last;

		if (!first.previous) this.firstChunk = last.next;
		if (!last.next) {
			this.lastChunk = first.previous;
			this.lastChunk.next = null;
		}

		first.previous = newLeft;
		last.next = newRight || null;

		if (!newLeft) this.firstChunk = first;
		if (!newRight) this.lastChunk = last;
		return this;
	}

	overwrite(start, end, content, options) {
		options = options || {};
		return this.update(start, end, content, { ...options, overwrite: !options.contentOnly });
	}

	update(start, end, content, options) {
		if (typeof content !== 'string') throw new TypeError('replacement content must be a string');

		while (start < 0) start += this.original.length;
		while (end < 0) end += this.original.length;

		if (end > this.original.length) throw new Error('end is out of bounds');
		if (start === end)
			throw new Error(
				'Cannot overwrite a zero-length range – use appendLeft or prependRight instead'
			);

		this._split(start);
		this._split(end);

		if (options === true) {
			if (!warned.storeName) {
				console.warn(
					'The final argument to magicString.overwrite(...) should be an options object. See https://github.com/rich-harris/magic-string'
				); // eslint-disable-line no-console
				warned.storeName = true;
			}

			options = { storeName: true };
		}
		const storeName = options !== undefined ? options.storeName : false;
		const overwrite = options !== undefined ? options.overwrite : false;

		if (storeName) {
			const original = this.original.slice(start, end);
			Object.defineProperty(this.storedNames, original, {
				writable: true,
				value: true,
				enumerable: true,
			});
		}

		const first = this.byStart[start];
		const last = this.byEnd[end];

		if (first) {
			let chunk = first;
			while (chunk !== last) {
				if (chunk.next !== this.byStart[chunk.end]) {
					throw new Error('Cannot overwrite across a split point');
				}
				chunk = chunk.next;
				chunk.edit('', false);
			}

			first.edit(content, storeName, !overwrite);
		} else {
			// must be inserting at the end
			const newChunk = new Chunk(start, end, '').edit(content, storeName);

			// TODO last chunk in the array may not be the last chunk, if it's moved...
			last.next = newChunk;
			newChunk.previous = last;
		}
		return this;
	}

	prepend(content) {
		if (typeof content !== 'string') throw new TypeError('outro content must be a string');

		this.intro = content + this.intro;
		return this;
	}

	prependLeft(index, content) {
		if (typeof content !== 'string') throw new TypeError('inserted content must be a string');

		this._split(index);

		const chunk = this.byEnd[index];

		if (chunk) {
			chunk.prependLeft(content);
		} else {
			this.intro = content + this.intro;
		}
		return this;
	}

	prependRight(index, content) {
		if (typeof content !== 'string') throw new TypeError('inserted content must be a string');

		this._split(index);

		const chunk = this.byStart[index];

		if (chunk) {
			chunk.prependRight(content);
		} else {
			this.outro = content + this.outro;
		}
		return this;
	}

	remove(start, end) {
		while (start < 0) start += this.original.length;
		while (end < 0) end += this.original.length;

		if (start === end) return this;

		if (start < 0 || end > this.original.length) throw new Error('Character is out of bounds');
		if (start > end) throw new Error('end must be greater than start');

		this._split(start);
		this._split(end);

		let chunk = this.byStart[start];

		while (chunk) {
			chunk.intro = '';
			chunk.outro = '';
			chunk.edit('');

			chunk = end > chunk.end ? this.byStart[chunk.end] : null;
		}
		return this;
	}

	lastChar() {
		if (this.outro.length) return this.outro[this.outro.length - 1];
		let chunk = this.lastChunk;
		do {
			if (chunk.outro.length) return chunk.outro[chunk.outro.length - 1];
			if (chunk.content.length) return chunk.content[chunk.content.length - 1];
			if (chunk.intro.length) return chunk.intro[chunk.intro.length - 1];
		} while ((chunk = chunk.previous));
		if (this.intro.length) return this.intro[this.intro.length - 1];
		return '';
	}

	lastLine() {
		let lineIndex = this.outro.lastIndexOf(n);
		if (lineIndex !== -1) return this.outro.substr(lineIndex + 1);
		let lineStr = this.outro;
		let chunk = this.lastChunk;
		do {
			if (chunk.outro.length > 0) {
				lineIndex = chunk.outro.lastIndexOf(n);
				if (lineIndex !== -1) return chunk.outro.substr(lineIndex + 1) + lineStr;
				lineStr = chunk.outro + lineStr;
			}

			if (chunk.content.length > 0) {
				lineIndex = chunk.content.lastIndexOf(n);
				if (lineIndex !== -1) return chunk.content.substr(lineIndex + 1) + lineStr;
				lineStr = chunk.content + lineStr;
			}

			if (chunk.intro.length > 0) {
				lineIndex = chunk.intro.lastIndexOf(n);
				if (lineIndex !== -1) return chunk.intro.substr(lineIndex + 1) + lineStr;
				lineStr = chunk.intro + lineStr;
			}
		} while ((chunk = chunk.previous));
		lineIndex = this.intro.lastIndexOf(n);
		if (lineIndex !== -1) return this.intro.substr(lineIndex + 1) + lineStr;
		return this.intro + lineStr;
	}

	slice(start = 0, end = this.original.length) {
		while (start < 0) start += this.original.length;
		while (end < 0) end += this.original.length;

		let result = '';

		// find start chunk
		let chunk = this.firstChunk;
		while (chunk && (chunk.start > start || chunk.end <= start)) {
			// found end chunk before start
			if (chunk.start < end && chunk.end >= end) {
				return result;
			}

			chunk = chunk.next;
		}

		if (chunk && chunk.edited && chunk.start !== start)
			throw new Error(`Cannot use replaced character ${start} as slice start anchor.`);

		const startChunk = chunk;
		while (chunk) {
			if (chunk.intro && (startChunk !== chunk || chunk.start === start)) {
				result += chunk.intro;
			}

			const containsEnd = chunk.start < end && chunk.end >= end;
			if (containsEnd && chunk.edited && chunk.end !== end)
				throw new Error(`Cannot use replaced character ${end} as slice end anchor.`);

			const sliceStart = startChunk === chunk ? start - chunk.start : 0;
			const sliceEnd = containsEnd ? chunk.content.length + end - chunk.end : chunk.content.length;

			result += chunk.content.slice(sliceStart, sliceEnd);

			if (chunk.outro && (!containsEnd || chunk.end === end)) {
				result += chunk.outro;
			}

			if (containsEnd) {
				break;
			}

			chunk = chunk.next;
		}

		return result;
	}

	// TODO deprecate this? not really very useful
	snip(start, end) {
		const clone = this.clone();
		clone.remove(0, start);
		clone.remove(end, clone.original.length);

		return clone;
	}

	_split(index) {
		if (this.byStart[index] || this.byEnd[index]) return;

		let chunk = this.lastSearchedChunk;
		const searchForward = index > chunk.end;

		while (chunk) {
			if (chunk.contains(index)) return this._splitChunk(chunk, index);

			chunk = searchForward ? this.byStart[chunk.end] : this.byEnd[chunk.start];
		}
	}

	_splitChunk(chunk, index) {
		if (chunk.edited && chunk.content.length) {
			// zero-length edited chunks are a special case (overlapping replacements)
			const loc = getLocator(this.original)(index);
			throw new Error(
				`Cannot split a chunk that has already been edited (${loc.line}:${loc.column} – "${chunk.original}")`
			);
		}

		const newChunk = chunk.split(index);

		this.byEnd[index] = chunk;
		this.byStart[index] = newChunk;
		this.byEnd[newChunk.end] = newChunk;

		if (chunk === this.lastChunk) this.lastChunk = newChunk;

		this.lastSearchedChunk = chunk;
		return true;
	}

	toString() {
		let str = this.intro;

		let chunk = this.firstChunk;
		while (chunk) {
			str += chunk.toString();
			chunk = chunk.next;
		}

		return str + this.outro;
	}

	isEmpty() {
		let chunk = this.firstChunk;
		do {
			if (
				(chunk.intro.length && chunk.intro.trim()) ||
				(chunk.content.length && chunk.content.trim()) ||
				(chunk.outro.length && chunk.outro.trim())
			)
				return false;
		} while ((chunk = chunk.next));
		return true;
	}

	length() {
		let chunk = this.firstChunk;
		let length = 0;
		do {
			length += chunk.intro.length + chunk.content.length + chunk.outro.length;
		} while ((chunk = chunk.next));
		return length;
	}

	trimLines() {
		return this.trim('[\\r\\n]');
	}

	trim(charType) {
		return this.trimStart(charType).trimEnd(charType);
	}

	trimEndAborted(charType) {
		const rx = new RegExp((charType || '\\s') + '+$');

		this.outro = this.outro.replace(rx, '');
		if (this.outro.length) return true;

		let chunk = this.lastChunk;

		do {
			const end = chunk.end;
			const aborted = chunk.trimEnd(rx);

			// if chunk was trimmed, we have a new lastChunk
			if (chunk.end !== end) {
				if (this.lastChunk === chunk) {
					this.lastChunk = chunk.next;
				}

				this.byEnd[chunk.end] = chunk;
				this.byStart[chunk.next.start] = chunk.next;
				this.byEnd[chunk.next.end] = chunk.next;
			}

			if (aborted) return true;
			chunk = chunk.previous;
		} while (chunk);

		return false;
	}

	trimEnd(charType) {
		this.trimEndAborted(charType);
		return this;
	}
	trimStartAborted(charType) {
		const rx = new RegExp('^' + (charType || '\\s') + '+');

		this.intro = this.intro.replace(rx, '');
		if (this.intro.length) return true;

		let chunk = this.firstChunk;

		do {
			const end = chunk.end;
			const aborted = chunk.trimStart(rx);

			if (chunk.end !== end) {
				// special case...
				if (chunk === this.lastChunk) this.lastChunk = chunk.next;

				this.byEnd[chunk.end] = chunk;
				this.byStart[chunk.next.start] = chunk.next;
				this.byEnd[chunk.next.end] = chunk.next;
			}

			if (aborted) return true;
			chunk = chunk.next;
		} while (chunk);

		return false;
	}

	trimStart(charType) {
		this.trimStartAborted(charType);
		return this;
	}

	hasChanged() {
		return this.original !== this.toString();
	}

	_replaceRegexp(searchValue, replacement) {
		function getReplacement(match, str) {
			if (typeof replacement === 'string') {
				return replacement.replace(/\$(\$|&|\d+)/g, (_, i) => {
					// https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/String/replace#specifying_a_string_as_a_parameter
					if (i === '$') return '$';
					if (i === '&') return match[0];
					const num = +i;
					if (num < match.length) return match[+i];
					return `$${i}`;
				});
			} else {
				return replacement(...match, match.index, str, match.groups);
			}
		}
		function matchAll(re, str) {
			let match;
			const matches = [];
			while ((match = re.exec(str))) {
				matches.push(match);
			}
			return matches;
		}
		if (searchValue.global) {
			const matches = matchAll(searchValue, this.original);
			matches.forEach((match) => {
				if (match.index != null)
					this.overwrite(
						match.index,
						match.index + match[0].length,
						getReplacement(match, this.original)
					);
			});
		} else {
			const match = this.original.match(searchValue);
			if (match && match.index != null)
				this.overwrite(
					match.index,
					match.index + match[0].length,
					getReplacement(match, this.original)
				);
		}
		return this;
	}

	_replaceString(string, replacement) {
		const { original } = this;
		const index = original.indexOf(string);

		if (index !== -1) {
			this.overwrite(index, index + string.length, replacement);
		}

		return this;
	}

	replace(searchValue, replacement) {
		if (typeof searchValue === 'string') {
			return this._replaceString(searchValue, replacement);
		}

		return this._replaceRegexp(searchValue, replacement);
	}

	_replaceAllString(string, replacement) {
		const { original } = this;
		const stringLength = string.length;
		for (
			let index = original.indexOf(string);
			index !== -1;
			index = original.indexOf(string, index + stringLength)
		) {
			this.overwrite(index, index + stringLength, replacement);
		}

		return this;
	}

	replaceAll(searchValue, replacement) {
		if (typeof searchValue === 'string') {
			return this._replaceAllString(searchValue, replacement);
		}

		if (!searchValue.global) {
			throw new TypeError(
				'MagicString.prototype.replaceAll called with a non-global RegExp argument'
			);
		}

		return this._replaceRegexp(searchValue, replacement);
	}
}

const hasOwnProp = Object.prototype.hasOwnProperty;

class Bundle {
	constructor(options = {}) {
		this.intro = options.intro || '';
		this.separator = options.separator !== undefined ? options.separator : '\n';
		this.sources = [];
		this.uniqueSources = [];
		this.uniqueSourceIndexByFilename = {};
	}

	addSource(source) {
		if (source instanceof MagicString$1) {
			return this.addSource({
				content: source,
				filename: source.filename,
				separator: this.separator,
			});
		}

		if (!isObject(source) || !source.content) {
			throw new Error(
				'bundle.addSource() takes an object with a `content` property, which should be an instance of MagicString, and an optional `filename`'
			);
		}

		['filename', 'indentExclusionRanges', 'separator'].forEach((option) => {
			if (!hasOwnProp.call(source, option)) source[option] = source.content[option];
		});

		if (source.separator === undefined) {
			// TODO there's a bunch of this sort of thing, needs cleaning up
			source.separator = this.separator;
		}

		if (source.filename) {
			if (!hasOwnProp.call(this.uniqueSourceIndexByFilename, source.filename)) {
				this.uniqueSourceIndexByFilename[source.filename] = this.uniqueSources.length;
				this.uniqueSources.push({ filename: source.filename, content: source.content.original });
			} else {
				const uniqueSource = this.uniqueSources[this.uniqueSourceIndexByFilename[source.filename]];
				if (source.content.original !== uniqueSource.content) {
					throw new Error(`Illegal source: same filename (${source.filename}), different contents`);
				}
			}
		}

		this.sources.push(source);
		return this;
	}

	append(str, options) {
		this.addSource({
			content: new MagicString$1(str),
			separator: (options && options.separator) || '',
		});

		return this;
	}

	clone() {
		const bundle = new Bundle({
			intro: this.intro,
			separator: this.separator,
		});

		this.sources.forEach((source) => {
			bundle.addSource({
				filename: source.filename,
				content: source.content.clone(),
				separator: source.separator,
			});
		});

		return bundle;
	}

	generateDecodedMap(options = {}) {
		const names = [];
		this.sources.forEach((source) => {
			Object.keys(source.content.storedNames).forEach((name) => {
				if (!~names.indexOf(name)) names.push(name);
			});
		});

		const mappings = new Mappings(options.hires);

		if (this.intro) {
			mappings.advance(this.intro);
		}

		this.sources.forEach((source, i) => {
			if (i > 0) {
				mappings.advance(this.separator);
			}

			const sourceIndex = source.filename ? this.uniqueSourceIndexByFilename[source.filename] : -1;
			const magicString = source.content;
			const locate = getLocator(magicString.original);

			if (magicString.intro) {
				mappings.advance(magicString.intro);
			}

			magicString.firstChunk.eachNext((chunk) => {
				const loc = locate(chunk.start);

				if (chunk.intro.length) mappings.advance(chunk.intro);

				if (source.filename) {
					if (chunk.edited) {
						mappings.addEdit(
							sourceIndex,
							chunk.content,
							loc,
							chunk.storeName ? names.indexOf(chunk.original) : -1
						);
					} else {
						mappings.addUneditedChunk(
							sourceIndex,
							chunk,
							magicString.original,
							loc,
							magicString.sourcemapLocations
						);
					}
				} else {
					mappings.advance(chunk.content);
				}

				if (chunk.outro.length) mappings.advance(chunk.outro);
			});

			if (magicString.outro) {
				mappings.advance(magicString.outro);
			}
		});

		return {
			file: options.file ? options.file.split(/[/\\]/).pop() : null,
			sources: this.uniqueSources.map((source) => {
				return options.file ? getRelativePath(options.file, source.filename) : source.filename;
			}),
			sourcesContent: this.uniqueSources.map((source) => {
				return options.includeContent ? source.content : null;
			}),
			names,
			mappings: mappings.raw,
		};
	}

	generateMap(options) {
		return new SourceMap(this.generateDecodedMap(options));
	}

	getIndentString() {
		const indentStringCounts = {};

		this.sources.forEach((source) => {
			const indentStr = source.content._getRawIndentString();

			if (indentStr === null) return;

			if (!indentStringCounts[indentStr]) indentStringCounts[indentStr] = 0;
			indentStringCounts[indentStr] += 1;
		});

		return (
			Object.keys(indentStringCounts).sort((a, b) => {
				return indentStringCounts[a] - indentStringCounts[b];
			})[0] || '\t'
		);
	}

	indent(indentStr) {
		if (!arguments.length) {
			indentStr = this.getIndentString();
		}

		if (indentStr === '') return this; // noop

		let trailingNewline = !this.intro || this.intro.slice(-1) === '\n';

		this.sources.forEach((source, i) => {
			const separator = source.separator !== undefined ? source.separator : this.separator;
			const indentStart = trailingNewline || (i > 0 && /\r?\n$/.test(separator));

			source.content.indent(indentStr, {
				exclude: source.indentExclusionRanges,
				indentStart, //: trailingNewline || /\r?\n$/.test( separator )  //true///\r?\n/.test( separator )
			});

			trailingNewline = source.content.lastChar() === '\n';
		});

		if (this.intro) {
			this.intro =
				indentStr +
				this.intro.replace(/^[^\n]/gm, (match, index) => {
					return index > 0 ? indentStr + match : match;
				});
		}

		return this;
	}

	prepend(str) {
		this.intro = str + this.intro;
		return this;
	}

	toString() {
		const body = this.sources
			.map((source, i) => {
				const separator = source.separator !== undefined ? source.separator : this.separator;
				const str = (i > 0 ? separator : '') + source.content.toString();

				return str;
			})
			.join('');

		return this.intro + body;
	}

	isEmpty() {
		if (this.intro.length && this.intro.trim()) return false;
		if (this.sources.some((source) => !source.content.isEmpty())) return false;
		return true;
	}

	length() {
		return this.sources.reduce(
			(length, source) => length + source.content.length(),
			this.intro.length
		);
	}

	trimLines() {
		return this.trim('[\\r\\n]');
	}

	trim(charType) {
		return this.trimStart(charType).trimEnd(charType);
	}

	trimStart(charType) {
		const rx = new RegExp('^' + (charType || '\\s') + '+');
		this.intro = this.intro.replace(rx, '');

		if (!this.intro) {
			let source;
			let i = 0;

			do {
				source = this.sources[i++];
				if (!source) {
					break;
				}
			} while (!source.content.trimStartAborted(charType));
		}

		return this;
	}

	trimEnd(charType) {
		const rx = new RegExp((charType || '\\s') + '+$');

		let source;
		let i = this.sources.length - 1;

		do {
			source = this.sources[i--];
			if (!source) {
				this.intro = this.intro.replace(rx, '');
				break;
			}
		} while (!source.content.trimEndAborted(charType));

		return this;
	}
}

MagicString$1.Bundle = Bundle;
MagicString$1.SourceMap = SourceMap;
MagicString$1.default = MagicString$1; // work around TypeScript bug https://github.com/Rich-Harris/magic-string/pull/121

var magicString_cjs = MagicString$1;

var babel$1 = {exports: {}};

babel$1.exports;

var hasRequiredBabel;

function requireBabel () {
	if (hasRequiredBabel) return babel$1.exports;
	hasRequiredBabel = 1;
	(function (module, exports) {
		(function (global, factory) {
		  factory(exports) ;
		})(commonjsGlobal, (function (exports) {
		  var _babel = /*#__PURE__*/Object.freeze({
		    __proto__: null,
		    get DEFAULT_EXTENSIONS () { return DEFAULT_EXTENSIONS; },
		    get File () { return File; },
		    get buildExternalHelpers () { return babelBuildExternalHelpers; },
		    get createConfigItem () { return createConfigItem; },
		    get createConfigItemAsync () { return createConfigItemAsync; },
		    get createConfigItemSync () { return createConfigItemSync; },
		    get getEnv () { return getEnv; },
		    get loadOptions () { return loadOptions; },
		    get loadOptionsAsync () { return loadOptionsAsync; },
		    get loadOptionsSync () { return loadOptionsSync; },
		    get loadPartialConfig () { return loadPartialConfig; },
		    get loadPartialConfigAsync () { return loadPartialConfigAsync; },
		    get loadPartialConfigSync () { return loadPartialConfigSync; },
		    get parse () { return parse$1; },
		    get parseAsync () { return parseAsync; },
		    get parseSync () { return parseSync; },
		    get resolvePlugin () { return resolvePlugin; },
		    get resolvePreset () { return resolvePreset; },
		    get template () { return template$1; },
		    get tokTypes () { return tokTypes; },
		    get transform () { return transform$3; },
		    get transformAsync () { return transformAsync; },
		    get transformFile () { return transformFile; },
		    get transformFileAsync () { return transformFileAsync; },
		    get transformFileSync () { return transformFileSync; },
		    get transformFromAst () { return transformFromAst$1; },
		    get transformFromAstAsync () { return transformFromAstAsync; },
		    get transformFromAstSync () { return transformFromAstSync; },
		    get transformSync () { return transformSync; },
		    get traverse () { return traverse; },
		    get types () { return t$4; },
		    get version () { return version$1; }
		  });

		  function _construct(t, e, r) {
		    if (_isNativeReflectConstruct()) return Reflect.construct.apply(null, arguments);
		    var o = [null];
		    o.push.apply(o, e);
		    var p = new (t.bind.apply(t, o))();
		    return r && _setPrototypeOf(p, r.prototype), p;
		  }
		  function _isNativeReflectConstruct() {
		    try {
		      var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {}));
		    } catch (t) {}
		    return (_isNativeReflectConstruct = function () {
		      return !!t;
		    })();
		  }
		  function _iterableToArrayLimit(r, l) {
		    var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"];
		    if (null != t) {
		      var e,
		        n,
		        i,
		        u,
		        a = [],
		        f = !0,
		        o = !1;
		      try {
		        if (i = (t = t.call(r)).next, 0 === l) {
		          if (Object(t) !== t) return;
		          f = !1;
		        } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0);
		      } catch (r) {
		        o = !0, n = r;
		      } finally {
		        try {
		          if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return;
		        } finally {
		          if (o) throw n;
		        }
		      }
		      return a;
		    }
		  }
		  function _regeneratorRuntime() {
		    _regeneratorRuntime = function () {
		      return e;
		    };
		    var t,
		      e = {},
		      r = Object.prototype,
		      n = r.hasOwnProperty,
		      o = Object.defineProperty || function (t, e, r) {
		        t[e] = r.value;
		      },
		      i = "function" == typeof Symbol ? Symbol : {},
		      a = i.iterator || "@@iterator",
		      c = i.asyncIterator || "@@asyncIterator",
		      u = i.toStringTag || "@@toStringTag";
		    function define(t, e, r) {
		      return Object.defineProperty(t, e, {
		        value: r,
		        enumerable: !0,
		        configurable: !0,
		        writable: !0
		      }), t[e];
		    }
		    try {
		      define({}, "");
		    } catch (t) {
		      define = function (t, e, r) {
		        return t[e] = r;
		      };
		    }
		    function wrap(t, e, r, n) {
		      var i = e && e.prototype instanceof Generator ? e : Generator,
		        a = Object.create(i.prototype),
		        c = new Context(n || []);
		      return o(a, "_invoke", {
		        value: makeInvokeMethod(t, r, c)
		      }), a;
		    }
		    function tryCatch(t, e, r) {
		      try {
		        return {
		          type: "normal",
		          arg: t.call(e, r)
		        };
		      } catch (t) {
		        return {
		          type: "throw",
		          arg: t
		        };
		      }
		    }
		    e.wrap = wrap;
		    var h = "suspendedStart",
		      l = "suspendedYield",
		      f = "executing",
		      s = "completed",
		      y = {};
		    function Generator() {}
		    function GeneratorFunction() {}
		    function GeneratorFunctionPrototype() {}
		    var p = {};
		    define(p, a, function () {
		      return this;
		    });
		    var d = Object.getPrototypeOf,
		      v = d && d(d(values([])));
		    v && v !== r && n.call(v, a) && (p = v);
		    var g = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(p);
		    function defineIteratorMethods(t) {
		      ["next", "throw", "return"].forEach(function (e) {
		        define(t, e, function (t) {
		          return this._invoke(e, t);
		        });
		      });
		    }
		    function AsyncIterator(t, e) {
		      function invoke(r, o, i, a) {
		        var c = tryCatch(t[r], t, o);
		        if ("throw" !== c.type) {
		          var u = c.arg,
		            h = u.value;
		          return h && "object" == typeof h && n.call(h, "__await") ? e.resolve(h.__await).then(function (t) {
		            invoke("next", t, i, a);
		          }, function (t) {
		            invoke("throw", t, i, a);
		          }) : e.resolve(h).then(function (t) {
		            u.value = t, i(u);
		          }, function (t) {
		            return invoke("throw", t, i, a);
		          });
		        }
		        a(c.arg);
		      }
		      var r;
		      o(this, "_invoke", {
		        value: function (t, n) {
		          function callInvokeWithMethodAndArg() {
		            return new e(function (e, r) {
		              invoke(t, n, e, r);
		            });
		          }
		          return r = r ? r.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg();
		        }
		      });
		    }
		    function makeInvokeMethod(e, r, n) {
		      var o = h;
		      return function (i, a) {
		        if (o === f) throw Error("Generator is already running");
		        if (o === s) {
		          if ("throw" === i) throw a;
		          return {
		            value: t,
		            done: !0
		          };
		        }
		        for (n.method = i, n.arg = a;;) {
		          var c = n.delegate;
		          if (c) {
		            var u = maybeInvokeDelegate(c, n);
		            if (u) {
		              if (u === y) continue;
		              return u;
		            }
		          }
		          if ("next" === n.method) n.sent = n._sent = n.arg;else if ("throw" === n.method) {
		            if (o === h) throw o = s, n.arg;
		            n.dispatchException(n.arg);
		          } else "return" === n.method && n.abrupt("return", n.arg);
		          o = f;
		          var p = tryCatch(e, r, n);
		          if ("normal" === p.type) {
		            if (o = n.done ? s : l, p.arg === y) continue;
		            return {
		              value: p.arg,
		              done: n.done
		            };
		          }
		          "throw" === p.type && (o = s, n.method = "throw", n.arg = p.arg);
		        }
		      };
		    }
		    function maybeInvokeDelegate(e, r) {
		      var n = r.method,
		        o = e.iterator[n];
		      if (o === t) return r.delegate = null, "throw" === n && e.iterator.return && (r.method = "return", r.arg = t, maybeInvokeDelegate(e, r), "throw" === r.method) || "return" !== n && (r.method = "throw", r.arg = new TypeError("The iterator does not provide a '" + n + "' method")), y;
		      var i = tryCatch(o, e.iterator, r.arg);
		      if ("throw" === i.type) return r.method = "throw", r.arg = i.arg, r.delegate = null, y;
		      var a = i.arg;
		      return a ? a.done ? (r[e.resultName] = a.value, r.next = e.nextLoc, "return" !== r.method && (r.method = "next", r.arg = t), r.delegate = null, y) : a : (r.method = "throw", r.arg = new TypeError("iterator result is not an object"), r.delegate = null, y);
		    }
		    function pushTryEntry(t) {
		      var e = {
		        tryLoc: t[0]
		      };
		      1 in t && (e.catchLoc = t[1]), 2 in t && (e.finallyLoc = t[2], e.afterLoc = t[3]), this.tryEntries.push(e);
		    }
		    function resetTryEntry(t) {
		      var e = t.completion || {};
		      e.type = "normal", delete e.arg, t.completion = e;
		    }
		    function Context(t) {
		      this.tryEntries = [{
		        tryLoc: "root"
		      }], t.forEach(pushTryEntry, this), this.reset(!0);
		    }
		    function values(e) {
		      if (e || "" === e) {
		        var r = e[a];
		        if (r) return r.call(e);
		        if ("function" == typeof e.next) return e;
		        if (!isNaN(e.length)) {
		          var o = -1,
		            i = function next() {
		              for (; ++o < e.length;) if (n.call(e, o)) return next.value = e[o], next.done = !1, next;
		              return next.value = t, next.done = !0, next;
		            };
		          return i.next = i;
		        }
		      }
		      throw new TypeError(typeof e + " is not iterable");
		    }
		    return GeneratorFunction.prototype = GeneratorFunctionPrototype, o(g, "constructor", {
		      value: GeneratorFunctionPrototype,
		      configurable: !0
		    }), o(GeneratorFunctionPrototype, "constructor", {
		      value: GeneratorFunction,
		      configurable: !0
		    }), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, u, "GeneratorFunction"), e.isGeneratorFunction = function (t) {
		      var e = "function" == typeof t && t.constructor;
		      return !!e && (e === GeneratorFunction || "GeneratorFunction" === (e.displayName || e.name));
		    }, e.mark = function (t) {
		      return Object.setPrototypeOf ? Object.setPrototypeOf(t, GeneratorFunctionPrototype) : (t.__proto__ = GeneratorFunctionPrototype, define(t, u, "GeneratorFunction")), t.prototype = Object.create(g), t;
		    }, e.awrap = function (t) {
		      return {
		        __await: t
		      };
		    }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, c, function () {
		      return this;
		    }), e.AsyncIterator = AsyncIterator, e.async = function (t, r, n, o, i) {
		      void 0 === i && (i = Promise);
		      var a = new AsyncIterator(wrap(t, r, n, o), i);
		      return e.isGeneratorFunction(r) ? a : a.next().then(function (t) {
		        return t.done ? t.value : a.next();
		      });
		    }, defineIteratorMethods(g), define(g, u, "Generator"), define(g, a, function () {
		      return this;
		    }), define(g, "toString", function () {
		      return "[object Generator]";
		    }), e.keys = function (t) {
		      var e = Object(t),
		        r = [];
		      for (var n in e) r.push(n);
		      return r.reverse(), function next() {
		        for (; r.length;) {
		          var t = r.pop();
		          if (t in e) return next.value = t, next.done = !1, next;
		        }
		        return next.done = !0, next;
		      };
		    }, e.values = values, Context.prototype = {
		      constructor: Context,
		      reset: function (e) {
		        if (this.prev = 0, this.next = 0, this.sent = this._sent = t, this.done = !1, this.delegate = null, this.method = "next", this.arg = t, this.tryEntries.forEach(resetTryEntry), !e) for (var r in this) "t" === r.charAt(0) && n.call(this, r) && !isNaN(+r.slice(1)) && (this[r] = t);
		      },
		      stop: function () {
		        this.done = !0;
		        var t = this.tryEntries[0].completion;
		        if ("throw" === t.type) throw t.arg;
		        return this.rval;
		      },
		      dispatchException: function (e) {
		        if (this.done) throw e;
		        var r = this;
		        function handle(n, o) {
		          return a.type = "throw", a.arg = e, r.next = n, o && (r.method = "next", r.arg = t), !!o;
		        }
		        for (var o = this.tryEntries.length - 1; o >= 0; --o) {
		          var i = this.tryEntries[o],
		            a = i.completion;
		          if ("root" === i.tryLoc) return handle("end");
		          if (i.tryLoc <= this.prev) {
		            var c = n.call(i, "catchLoc"),
		              u = n.call(i, "finallyLoc");
		            if (c && u) {
		              if (this.prev < i.catchLoc) return handle(i.catchLoc, !0);
		              if (this.prev < i.finallyLoc) return handle(i.finallyLoc);
		            } else if (c) {
		              if (this.prev < i.catchLoc) return handle(i.catchLoc, !0);
		            } else {
		              if (!u) throw Error("try statement without catch or finally");
		              if (this.prev < i.finallyLoc) return handle(i.finallyLoc);
		            }
		          }
		        }
		      },
		      abrupt: function (t, e) {
		        for (var r = this.tryEntries.length - 1; r >= 0; --r) {
		          var o = this.tryEntries[r];
		          if (o.tryLoc <= this.prev && n.call(o, "finallyLoc") && this.prev < o.finallyLoc) {
		            var i = o;
		            break;
		          }
		        }
		        i && ("break" === t || "continue" === t) && i.tryLoc <= e && e <= i.finallyLoc && (i = null);
		        var a = i ? i.completion : {};
		        return a.type = t, a.arg = e, i ? (this.method = "next", this.next = i.finallyLoc, y) : this.complete(a);
		      },
		      complete: function (t, e) {
		        if ("throw" === t.type) throw t.arg;
		        return "break" === t.type || "continue" === t.type ? this.next = t.arg : "return" === t.type ? (this.rval = this.arg = t.arg, this.method = "return", this.next = "end") : "normal" === t.type && e && (this.next = e), y;
		      },
		      finish: function (t) {
		        for (var e = this.tryEntries.length - 1; e >= 0; --e) {
		          var r = this.tryEntries[e];
		          if (r.finallyLoc === t) return this.complete(r.completion, r.afterLoc), resetTryEntry(r), y;
		        }
		      },
		      catch: function (t) {
		        for (var e = this.tryEntries.length - 1; e >= 0; --e) {
		          var r = this.tryEntries[e];
		          if (r.tryLoc === t) {
		            var n = r.completion;
		            if ("throw" === n.type) {
		              var o = n.arg;
		              resetTryEntry(r);
		            }
		            return o;
		          }
		        }
		        throw Error("illegal catch attempt");
		      },
		      delegateYield: function (e, r, n) {
		        return this.delegate = {
		          iterator: values(e),
		          resultName: r,
		          nextLoc: n
		        }, "next" === this.method && (this.arg = t), y;
		      }
		    }, e;
		  }
		  function _toPrimitive(t, r) {
		    if ("object" != typeof t || !t) return t;
		    var e = t[Symbol.toPrimitive];
		    if (void 0 !== e) {
		      var i = e.call(t, r || "default");
		      if ("object" != typeof i) return i;
		      throw new TypeError("@@toPrimitive must return a primitive value.");
		    }
		    return ("string" === r ? String : Number)(t);
		  }
		  function _toPropertyKey(t) {
		    var i = _toPrimitive(t, "string");
		    return "symbol" == typeof i ? i : i + "";
		  }
		  function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
		    try {
		      var info = gen[key](arg);
		      var value = info.value;
		    } catch (error) {
		      reject(error);
		      return;
		    }
		    if (info.done) {
		      resolve(value);
		    } else {
		      Promise.resolve(value).then(_next, _throw);
		    }
		  }
		  function _asyncToGenerator(fn) {
		    return function () {
		      var self = this,
		        args = arguments;
		      return new Promise(function (resolve, reject) {
		        var gen = fn.apply(self, args);
		        function _next(value) {
		          asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
		        }
		        function _throw(err) {
		          asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
		        }
		        _next(undefined);
		      });
		    };
		  }
		  function _defineProperties(target, props) {
		    for (var i = 0; i < props.length; i++) {
		      var descriptor = props[i];
		      descriptor.enumerable = descriptor.enumerable || false;
		      descriptor.configurable = true;
		      if ("value" in descriptor) descriptor.writable = true;
		      Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor);
		    }
		  }
		  function _createClass(Constructor, protoProps, staticProps) {
		    if (protoProps) _defineProperties(Constructor.prototype, protoProps);
		    if (staticProps) _defineProperties(Constructor, staticProps);
		    Object.defineProperty(Constructor, "prototype", {
		      writable: false
		    });
		    return Constructor;
		  }
		  function _inherits(subClass, superClass) {
		    if (typeof superClass !== "function" && superClass !== null) {
		      throw new TypeError("Super expression must either be null or a function");
		    }
		    subClass.prototype = Object.create(superClass && superClass.prototype, {
		      constructor: {
		        value: subClass,
		        writable: true,
		        configurable: true
		      }
		    });
		    Object.defineProperty(subClass, "prototype", {
		      writable: false
		    });
		    if (superClass) _setPrototypeOf(subClass, superClass);
		  }
		  function _getPrototypeOf(o) {
		    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) {
		      return o.__proto__ || Object.getPrototypeOf(o);
		    };
		    return _getPrototypeOf(o);
		  }
		  function _setPrototypeOf(o, p) {
		    _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) {
		      o.__proto__ = p;
		      return o;
		    };
		    return _setPrototypeOf(o, p);
		  }
		  function _isNativeFunction(fn) {
		    try {
		      return Function.toString.call(fn).indexOf("[native code]") !== -1;
		    } catch (e) {
		      return typeof fn === "function";
		    }
		  }
		  function _wrapNativeSuper(Class) {
		    var _cache = typeof Map === "function" ? new Map() : undefined;
		    _wrapNativeSuper = function _wrapNativeSuper(Class) {
		      if (Class === null || !_isNativeFunction(Class)) return Class;
		      if (typeof Class !== "function") {
		        throw new TypeError("Super expression must either be null or a function");
		      }
		      if (typeof _cache !== "undefined") {
		        if (_cache.has(Class)) return _cache.get(Class);
		        _cache.set(Class, Wrapper);
		      }
		      function Wrapper() {
		        return _construct(Class, arguments, _getPrototypeOf(this).constructor);
		      }
		      Wrapper.prototype = Object.create(Class.prototype, {
		        constructor: {
		          value: Wrapper,
		          enumerable: false,
		          writable: true,
		          configurable: true
		        }
		      });
		      return _setPrototypeOf(Wrapper, Class);
		    };
		    return _wrapNativeSuper(Class);
		  }
		  function _objectWithoutPropertiesLoose(source, excluded) {
		    if (source == null) return {};
		    var target = {};
		    var sourceKeys = Object.keys(source);
		    var key, i;
		    for (i = 0; i < sourceKeys.length; i++) {
		      key = sourceKeys[i];
		      if (excluded.indexOf(key) >= 0) continue;
		      target[key] = source[key];
		    }
		    return target;
		  }
		  function _objectWithoutProperties(source, excluded) {
		    if (source == null) return {};
		    var target = _objectWithoutPropertiesLoose(source, excluded);
		    var key, i;
		    if (Object.getOwnPropertySymbols) {
		      var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
		      for (i = 0; i < sourceSymbolKeys.length; i++) {
		        key = sourceSymbolKeys[i];
		        if (excluded.indexOf(key) >= 0) continue;
		        if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
		        target[key] = source[key];
		      }
		    }
		    return target;
		  }
		  function _taggedTemplateLiteralLoose(strings, raw) {
		    if (!raw) {
		      raw = strings.slice(0);
		    }
		    strings.raw = raw;
		    return strings;
		  }
		  function _slicedToArray(arr, i) {
		    return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
		  }
		  function _toConsumableArray(arr) {
		    return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
		  }
		  function _arrayWithoutHoles(arr) {
		    if (Array.isArray(arr)) return _arrayLikeToArray(arr);
		  }
		  function _arrayWithHoles(arr) {
		    if (Array.isArray(arr)) return arr;
		  }
		  function _iterableToArray(iter) {
		    if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter);
		  }
		  function _unsupportedIterableToArray(o, minLen) {
		    if (!o) return;
		    if (typeof o === "string") return _arrayLikeToArray(o, minLen);
		    var n = Object.prototype.toString.call(o).slice(8, -1);
		    if (n === "Object" && o.constructor) n = o.constructor.name;
		    if (n === "Map" || n === "Set") return Array.from(o);
		    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
		  }
		  function _arrayLikeToArray(arr, len) {
		    if (len == null || len > arr.length) len = arr.length;
		    for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];
		    return arr2;
		  }
		  function _nonIterableSpread() {
		    throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
		  }
		  function _nonIterableRest() {
		    throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
		  }
		  function _createForOfIteratorHelperLoose(o, allowArrayLike) {
		    var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"];
		    if (it) return (it = it.call(o)).next.bind(it);
		    if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") {
		      if (it) o = it;
		      var i = 0;
		      return function () {
		        if (i >= o.length) return {
		          done: true
		        };
		        return {
		          done: false,
		          value: o[i++]
		        };
		      };
		    }
		    throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
		  }

		  var ReferencedIdentifier$1 = ["Identifier", "JSXIdentifier"];
		  var ReferencedMemberExpression = ["MemberExpression"];
		  var BindingIdentifier = ["Identifier"];
		  var Statement = ["Statement"];
		  var Expression = ["Expression"];
		  var Scope$2 = ["Scopable", "Pattern"];
		  var Referenced = null;
		  var BlockScoped = null;
		  var Var = ["VariableDeclaration"];
		  var User = null;
		  var Generated = null;
		  var Pure = null;
		  var Flow = ["Flow", "ImportDeclaration", "ExportDeclaration", "ImportSpecifier"];
		  var RestProperty$1 = ["RestElement"];
		  var SpreadProperty$1 = ["RestElement"];
		  var ExistentialTypeParam = ["ExistsTypeAnnotation"];
		  var NumericLiteralTypeAnnotation = ["NumberLiteralTypeAnnotation"];
		  var ForAwaitStatement = ["ForOfStatement"];

		  var virtualTypes = /*#__PURE__*/Object.freeze({
		    __proto__: null,
		    BindingIdentifier: BindingIdentifier,
		    BlockScoped: BlockScoped,
		    ExistentialTypeParam: ExistentialTypeParam,
		    Expression: Expression,
		    Flow: Flow,
		    ForAwaitStatement: ForAwaitStatement,
		    Generated: Generated,
		    NumericLiteralTypeAnnotation: NumericLiteralTypeAnnotation,
		    Pure: Pure,
		    Referenced: Referenced,
		    ReferencedIdentifier: ReferencedIdentifier$1,
		    ReferencedMemberExpression: ReferencedMemberExpression,
		    RestProperty: RestProperty$1,
		    Scope: Scope$2,
		    SpreadProperty: SpreadProperty$1,
		    Statement: Statement,
		    User: User,
		    Var: Var
		  });

		  function shallowEqual(actual, expected) {
		    var keys = Object.keys(expected);
		    for (var _i = 0, _keys = keys; _i < _keys.length; _i++) {
		      var key = _keys[_i];
		      if (actual[key] !== expected[key]) {
		        return false;
		      }
		    }
		    return true;
		  }

		  var warnings = new Set();
		  function deprecationWarning$1(oldName, newName, prefix) {
		    if (prefix === void 0) {
		      prefix = "";
		    }
		    if (warnings.has(oldName)) return;
		    warnings.add(oldName);
		    var _captureShortStackTra = captureShortStackTrace(1, 2),
		      internal = _captureShortStackTra.internal,
		      trace = _captureShortStackTra.trace;
		    if (internal) {
		      return;
		    }
		    console.warn(prefix + "`" + oldName + "` has been deprecated, please migrate to `" + newName + "`\n" + trace);
		  }
		  function captureShortStackTrace(skip, length) {
		    var stackTraceLimit = Error.stackTraceLimit,
		      prepareStackTrace = Error.prepareStackTrace;
		    var stackTrace;
		    Error.stackTraceLimit = 1 + skip + length;
		    Error.prepareStackTrace = function (err, stack) {
		      stackTrace = stack;
		    };
		    new Error().stack;
		    Error.stackTraceLimit = stackTraceLimit;
		    Error.prepareStackTrace = prepareStackTrace;
		    if (!stackTrace) return {
		      internal: false,
		      trace: ""
		    };
		    var shortStackTrace = stackTrace.slice(1 + skip, 1 + skip + length);
		    return {
		      internal: /[\\/]@babel[\\/]/.test(shortStackTrace[1].getFileName()),
		      trace: shortStackTrace.map(function (frame) {
		        return "    at " + frame;
		      }).join("\n")
		    };
		  }

		  function isArrayExpression$2(node, opts) {
		    if (!node) return false;
		    if (node.type !== "ArrayExpression") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isAssignmentExpression$3(node, opts) {
		    if (!node) return false;
		    if (node.type !== "AssignmentExpression") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isBinaryExpression$1(node, opts) {
		    if (!node) return false;
		    if (node.type !== "BinaryExpression") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isInterpreterDirective(node, opts) {
		    if (!node) return false;
		    if (node.type !== "InterpreterDirective") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isDirective(node, opts) {
		    if (!node) return false;
		    if (node.type !== "Directive") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isDirectiveLiteral(node, opts) {
		    if (!node) return false;
		    if (node.type !== "DirectiveLiteral") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isBlockStatement$3(node, opts) {
		    if (!node) return false;
		    if (node.type !== "BlockStatement") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isBreakStatement(node, opts) {
		    if (!node) return false;
		    if (node.type !== "BreakStatement") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isCallExpression$8(node, opts) {
		    if (!node) return false;
		    if (node.type !== "CallExpression") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isCatchClause(node, opts) {
		    if (!node) return false;
		    if (node.type !== "CatchClause") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isConditionalExpression(node, opts) {
		    if (!node) return false;
		    if (node.type !== "ConditionalExpression") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isContinueStatement(node, opts) {
		    if (!node) return false;
		    if (node.type !== "ContinueStatement") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isDebuggerStatement(node, opts) {
		    if (!node) return false;
		    if (node.type !== "DebuggerStatement") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isDoWhileStatement(node, opts) {
		    if (!node) return false;
		    if (node.type !== "DoWhileStatement") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isEmptyStatement$1(node, opts) {
		    if (!node) return false;
		    if (node.type !== "EmptyStatement") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isExpressionStatement$2(node, opts) {
		    if (!node) return false;
		    if (node.type !== "ExpressionStatement") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isFile(node, opts) {
		    if (!node) return false;
		    if (node.type !== "File") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isForInStatement(node, opts) {
		    if (!node) return false;
		    if (node.type !== "ForInStatement") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isForStatement$2(node, opts) {
		    if (!node) return false;
		    if (node.type !== "ForStatement") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isFunctionDeclaration$2(node, opts) {
		    if (!node) return false;
		    if (node.type !== "FunctionDeclaration") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isFunctionExpression$1(node, opts) {
		    if (!node) return false;
		    if (node.type !== "FunctionExpression") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isIdentifier$i(node, opts) {
		    if (!node) return false;
		    if (node.type !== "Identifier") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isIfStatement$2(node, opts) {
		    if (!node) return false;
		    if (node.type !== "IfStatement") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isLabeledStatement(node, opts) {
		    if (!node) return false;
		    if (node.type !== "LabeledStatement") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isStringLiteral$5(node, opts) {
		    if (!node) return false;
		    if (node.type !== "StringLiteral") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isNumericLiteral(node, opts) {
		    if (!node) return false;
		    if (node.type !== "NumericLiteral") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isNullLiteral$2(node, opts) {
		    if (!node) return false;
		    if (node.type !== "NullLiteral") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isBooleanLiteral(node, opts) {
		    if (!node) return false;
		    if (node.type !== "BooleanLiteral") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isRegExpLiteral$2(node, opts) {
		    if (!node) return false;
		    if (node.type !== "RegExpLiteral") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isLogicalExpression(node, opts) {
		    if (!node) return false;
		    if (node.type !== "LogicalExpression") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isMemberExpression$9(node, opts) {
		    if (!node) return false;
		    if (node.type !== "MemberExpression") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isNewExpression$3(node, opts) {
		    if (!node) return false;
		    if (node.type !== "NewExpression") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isProgram$1(node, opts) {
		    if (!node) return false;
		    if (node.type !== "Program") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isObjectExpression$3(node, opts) {
		    if (!node) return false;
		    if (node.type !== "ObjectExpression") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isObjectMethod$1(node, opts) {
		    if (!node) return false;
		    if (node.type !== "ObjectMethod") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isObjectProperty$4(node, opts) {
		    if (!node) return false;
		    if (node.type !== "ObjectProperty") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isRestElement$2(node, opts) {
		    if (!node) return false;
		    if (node.type !== "RestElement") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isReturnStatement(node, opts) {
		    if (!node) return false;
		    if (node.type !== "ReturnStatement") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isSequenceExpression$1(node, opts) {
		    if (!node) return false;
		    if (node.type !== "SequenceExpression") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isParenthesizedExpression$1(node, opts) {
		    if (!node) return false;
		    if (node.type !== "ParenthesizedExpression") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isSwitchCase(node, opts) {
		    if (!node) return false;
		    if (node.type !== "SwitchCase") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isSwitchStatement(node, opts) {
		    if (!node) return false;
		    if (node.type !== "SwitchStatement") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isThisExpression$2(node, opts) {
		    if (!node) return false;
		    if (node.type !== "ThisExpression") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isThrowStatement(node, opts) {
		    if (!node) return false;
		    if (node.type !== "ThrowStatement") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTryStatement(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TryStatement") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isUnaryExpression$1(node, opts) {
		    if (!node) return false;
		    if (node.type !== "UnaryExpression") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isUpdateExpression$1(node, opts) {
		    if (!node) return false;
		    if (node.type !== "UpdateExpression") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isVariableDeclaration$4(node, opts) {
		    if (!node) return false;
		    if (node.type !== "VariableDeclaration") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isVariableDeclarator$1(node, opts) {
		    if (!node) return false;
		    if (node.type !== "VariableDeclarator") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isWhileStatement(node, opts) {
		    if (!node) return false;
		    if (node.type !== "WhileStatement") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isWithStatement(node, opts) {
		    if (!node) return false;
		    if (node.type !== "WithStatement") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isAssignmentPattern$4(node, opts) {
		    if (!node) return false;
		    if (node.type !== "AssignmentPattern") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isArrayPattern(node, opts) {
		    if (!node) return false;
		    if (node.type !== "ArrayPattern") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isArrowFunctionExpression$2(node, opts) {
		    if (!node) return false;
		    if (node.type !== "ArrowFunctionExpression") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isClassBody$2(node, opts) {
		    if (!node) return false;
		    if (node.type !== "ClassBody") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isClassExpression$1(node, opts) {
		    if (!node) return false;
		    if (node.type !== "ClassExpression") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isClassDeclaration$2(node, opts) {
		    if (!node) return false;
		    if (node.type !== "ClassDeclaration") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isExportAllDeclaration$1(node, opts) {
		    if (!node) return false;
		    if (node.type !== "ExportAllDeclaration") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isExportDefaultDeclaration$2(node, opts) {
		    if (!node) return false;
		    if (node.type !== "ExportDefaultDeclaration") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isExportNamedDeclaration$3(node, opts) {
		    if (!node) return false;
		    if (node.type !== "ExportNamedDeclaration") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isExportSpecifier(node, opts) {
		    if (!node) return false;
		    if (node.type !== "ExportSpecifier") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isForOfStatement$2(node, opts) {
		    if (!node) return false;
		    if (node.type !== "ForOfStatement") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isImportDeclaration$3(node, opts) {
		    if (!node) return false;
		    if (node.type !== "ImportDeclaration") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isImportDefaultSpecifier$1(node, opts) {
		    if (!node) return false;
		    if (node.type !== "ImportDefaultSpecifier") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isImportNamespaceSpecifier$1(node, opts) {
		    if (!node) return false;
		    if (node.type !== "ImportNamespaceSpecifier") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isImportSpecifier$1(node, opts) {
		    if (!node) return false;
		    if (node.type !== "ImportSpecifier") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isImportExpression(node, opts) {
		    if (!node) return false;
		    if (node.type !== "ImportExpression") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isMetaProperty$1(node, opts) {
		    if (!node) return false;
		    if (node.type !== "MetaProperty") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isClassMethod(node, opts) {
		    if (!node) return false;
		    if (node.type !== "ClassMethod") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isObjectPattern$1(node, opts) {
		    if (!node) return false;
		    if (node.type !== "ObjectPattern") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isSpreadElement$1(node, opts) {
		    if (!node) return false;
		    if (node.type !== "SpreadElement") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isSuper$3(node, opts) {
		    if (!node) return false;
		    if (node.type !== "Super") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTaggedTemplateExpression$1(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TaggedTemplateExpression") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTemplateElement(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TemplateElement") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTemplateLiteral$2(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TemplateLiteral") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isYieldExpression$1(node, opts) {
		    if (!node) return false;
		    if (node.type !== "YieldExpression") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isAwaitExpression(node, opts) {
		    if (!node) return false;
		    if (node.type !== "AwaitExpression") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isImport(node, opts) {
		    if (!node) return false;
		    if (node.type !== "Import") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isBigIntLiteral(node, opts) {
		    if (!node) return false;
		    if (node.type !== "BigIntLiteral") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isExportNamespaceSpecifier$1(node, opts) {
		    if (!node) return false;
		    if (node.type !== "ExportNamespaceSpecifier") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isOptionalMemberExpression$3(node, opts) {
		    if (!node) return false;
		    if (node.type !== "OptionalMemberExpression") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isOptionalCallExpression$2(node, opts) {
		    if (!node) return false;
		    if (node.type !== "OptionalCallExpression") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isClassProperty(node, opts) {
		    if (!node) return false;
		    if (node.type !== "ClassProperty") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isClassAccessorProperty(node, opts) {
		    if (!node) return false;
		    if (node.type !== "ClassAccessorProperty") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isClassPrivateProperty(node, opts) {
		    if (!node) return false;
		    if (node.type !== "ClassPrivateProperty") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isClassPrivateMethod(node, opts) {
		    if (!node) return false;
		    if (node.type !== "ClassPrivateMethod") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isPrivateName$3(node, opts) {
		    if (!node) return false;
		    if (node.type !== "PrivateName") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isStaticBlock(node, opts) {
		    if (!node) return false;
		    if (node.type !== "StaticBlock") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isAnyTypeAnnotation$1(node, opts) {
		    if (!node) return false;
		    if (node.type !== "AnyTypeAnnotation") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isArrayTypeAnnotation$2(node, opts) {
		    if (!node) return false;
		    if (node.type !== "ArrayTypeAnnotation") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isBooleanTypeAnnotation$1(node, opts) {
		    if (!node) return false;
		    if (node.type !== "BooleanTypeAnnotation") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isBooleanLiteralTypeAnnotation(node, opts) {
		    if (!node) return false;
		    if (node.type !== "BooleanLiteralTypeAnnotation") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isNullLiteralTypeAnnotation(node, opts) {
		    if (!node) return false;
		    if (node.type !== "NullLiteralTypeAnnotation") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isClassImplements(node, opts) {
		    if (!node) return false;
		    if (node.type !== "ClassImplements") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isDeclareClass(node, opts) {
		    if (!node) return false;
		    if (node.type !== "DeclareClass") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isDeclareFunction(node, opts) {
		    if (!node) return false;
		    if (node.type !== "DeclareFunction") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isDeclareInterface(node, opts) {
		    if (!node) return false;
		    if (node.type !== "DeclareInterface") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isDeclareModule(node, opts) {
		    if (!node) return false;
		    if (node.type !== "DeclareModule") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isDeclareModuleExports(node, opts) {
		    if (!node) return false;
		    if (node.type !== "DeclareModuleExports") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isDeclareTypeAlias(node, opts) {
		    if (!node) return false;
		    if (node.type !== "DeclareTypeAlias") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isDeclareOpaqueType(node, opts) {
		    if (!node) return false;
		    if (node.type !== "DeclareOpaqueType") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isDeclareVariable(node, opts) {
		    if (!node) return false;
		    if (node.type !== "DeclareVariable") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isDeclareExportDeclaration$1(node, opts) {
		    if (!node) return false;
		    if (node.type !== "DeclareExportDeclaration") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isDeclareExportAllDeclaration(node, opts) {
		    if (!node) return false;
		    if (node.type !== "DeclareExportAllDeclaration") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isDeclaredPredicate(node, opts) {
		    if (!node) return false;
		    if (node.type !== "DeclaredPredicate") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isExistsTypeAnnotation(node, opts) {
		    if (!node) return false;
		    if (node.type !== "ExistsTypeAnnotation") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isFunctionTypeAnnotation(node, opts) {
		    if (!node) return false;
		    if (node.type !== "FunctionTypeAnnotation") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isFunctionTypeParam(node, opts) {
		    if (!node) return false;
		    if (node.type !== "FunctionTypeParam") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isGenericTypeAnnotation$1(node, opts) {
		    if (!node) return false;
		    if (node.type !== "GenericTypeAnnotation") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isInferredPredicate(node, opts) {
		    if (!node) return false;
		    if (node.type !== "InferredPredicate") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isInterfaceExtends(node, opts) {
		    if (!node) return false;
		    if (node.type !== "InterfaceExtends") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isInterfaceDeclaration(node, opts) {
		    if (!node) return false;
		    if (node.type !== "InterfaceDeclaration") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isInterfaceTypeAnnotation(node, opts) {
		    if (!node) return false;
		    if (node.type !== "InterfaceTypeAnnotation") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isIntersectionTypeAnnotation(node, opts) {
		    if (!node) return false;
		    if (node.type !== "IntersectionTypeAnnotation") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isMixedTypeAnnotation$1(node, opts) {
		    if (!node) return false;
		    if (node.type !== "MixedTypeAnnotation") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isEmptyTypeAnnotation$1(node, opts) {
		    if (!node) return false;
		    if (node.type !== "EmptyTypeAnnotation") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isNullableTypeAnnotation(node, opts) {
		    if (!node) return false;
		    if (node.type !== "NullableTypeAnnotation") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isNumberLiteralTypeAnnotation(node, opts) {
		    if (!node) return false;
		    if (node.type !== "NumberLiteralTypeAnnotation") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isNumberTypeAnnotation$1(node, opts) {
		    if (!node) return false;
		    if (node.type !== "NumberTypeAnnotation") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isObjectTypeAnnotation(node, opts) {
		    if (!node) return false;
		    if (node.type !== "ObjectTypeAnnotation") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isObjectTypeInternalSlot(node, opts) {
		    if (!node) return false;
		    if (node.type !== "ObjectTypeInternalSlot") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isObjectTypeCallProperty(node, opts) {
		    if (!node) return false;
		    if (node.type !== "ObjectTypeCallProperty") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isObjectTypeIndexer(node, opts) {
		    if (!node) return false;
		    if (node.type !== "ObjectTypeIndexer") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isObjectTypeProperty(node, opts) {
		    if (!node) return false;
		    if (node.type !== "ObjectTypeProperty") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isObjectTypeSpreadProperty(node, opts) {
		    if (!node) return false;
		    if (node.type !== "ObjectTypeSpreadProperty") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isOpaqueType(node, opts) {
		    if (!node) return false;
		    if (node.type !== "OpaqueType") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isQualifiedTypeIdentifier(node, opts) {
		    if (!node) return false;
		    if (node.type !== "QualifiedTypeIdentifier") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isStringLiteralTypeAnnotation(node, opts) {
		    if (!node) return false;
		    if (node.type !== "StringLiteralTypeAnnotation") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isStringTypeAnnotation$1(node, opts) {
		    if (!node) return false;
		    if (node.type !== "StringTypeAnnotation") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isSymbolTypeAnnotation(node, opts) {
		    if (!node) return false;
		    if (node.type !== "SymbolTypeAnnotation") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isThisTypeAnnotation(node, opts) {
		    if (!node) return false;
		    if (node.type !== "ThisTypeAnnotation") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTupleTypeAnnotation$1(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TupleTypeAnnotation") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTypeofTypeAnnotation(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TypeofTypeAnnotation") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTypeAlias(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TypeAlias") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTypeAnnotation$1(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TypeAnnotation") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTypeCastExpression$1(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TypeCastExpression") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTypeParameter(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TypeParameter") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTypeParameterDeclaration(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TypeParameterDeclaration") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTypeParameterInstantiation(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TypeParameterInstantiation") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isUnionTypeAnnotation$1(node, opts) {
		    if (!node) return false;
		    if (node.type !== "UnionTypeAnnotation") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isVariance(node, opts) {
		    if (!node) return false;
		    if (node.type !== "Variance") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isVoidTypeAnnotation$1(node, opts) {
		    if (!node) return false;
		    if (node.type !== "VoidTypeAnnotation") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isEnumDeclaration(node, opts) {
		    if (!node) return false;
		    if (node.type !== "EnumDeclaration") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isEnumBooleanBody(node, opts) {
		    if (!node) return false;
		    if (node.type !== "EnumBooleanBody") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isEnumNumberBody(node, opts) {
		    if (!node) return false;
		    if (node.type !== "EnumNumberBody") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isEnumStringBody(node, opts) {
		    if (!node) return false;
		    if (node.type !== "EnumStringBody") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isEnumSymbolBody(node, opts) {
		    if (!node) return false;
		    if (node.type !== "EnumSymbolBody") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isEnumBooleanMember(node, opts) {
		    if (!node) return false;
		    if (node.type !== "EnumBooleanMember") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isEnumNumberMember(node, opts) {
		    if (!node) return false;
		    if (node.type !== "EnumNumberMember") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isEnumStringMember(node, opts) {
		    if (!node) return false;
		    if (node.type !== "EnumStringMember") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isEnumDefaultedMember(node, opts) {
		    if (!node) return false;
		    if (node.type !== "EnumDefaultedMember") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isIndexedAccessType$1(node, opts) {
		    if (!node) return false;
		    if (node.type !== "IndexedAccessType") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isOptionalIndexedAccessType(node, opts) {
		    if (!node) return false;
		    if (node.type !== "OptionalIndexedAccessType") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isJSXAttribute(node, opts) {
		    if (!node) return false;
		    if (node.type !== "JSXAttribute") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isJSXClosingElement(node, opts) {
		    if (!node) return false;
		    if (node.type !== "JSXClosingElement") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isJSXElement(node, opts) {
		    if (!node) return false;
		    if (node.type !== "JSXElement") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isJSXEmptyExpression(node, opts) {
		    if (!node) return false;
		    if (node.type !== "JSXEmptyExpression") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isJSXExpressionContainer$1(node, opts) {
		    if (!node) return false;
		    if (node.type !== "JSXExpressionContainer") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isJSXSpreadChild(node, opts) {
		    if (!node) return false;
		    if (node.type !== "JSXSpreadChild") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isJSXIdentifier$3(node, opts) {
		    if (!node) return false;
		    if (node.type !== "JSXIdentifier") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isJSXMemberExpression$2(node, opts) {
		    if (!node) return false;
		    if (node.type !== "JSXMemberExpression") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isJSXNamespacedName$1(node, opts) {
		    if (!node) return false;
		    if (node.type !== "JSXNamespacedName") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isJSXOpeningElement(node, opts) {
		    if (!node) return false;
		    if (node.type !== "JSXOpeningElement") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isJSXSpreadAttribute$1(node, opts) {
		    if (!node) return false;
		    if (node.type !== "JSXSpreadAttribute") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isJSXText(node, opts) {
		    if (!node) return false;
		    if (node.type !== "JSXText") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isJSXFragment(node, opts) {
		    if (!node) return false;
		    if (node.type !== "JSXFragment") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isJSXOpeningFragment(node, opts) {
		    if (!node) return false;
		    if (node.type !== "JSXOpeningFragment") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isJSXClosingFragment(node, opts) {
		    if (!node) return false;
		    if (node.type !== "JSXClosingFragment") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isNoop(node, opts) {
		    if (!node) return false;
		    if (node.type !== "Noop") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isPlaceholder$1(node, opts) {
		    if (!node) return false;
		    if (node.type !== "Placeholder") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isV8IntrinsicIdentifier(node, opts) {
		    if (!node) return false;
		    if (node.type !== "V8IntrinsicIdentifier") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isArgumentPlaceholder(node, opts) {
		    if (!node) return false;
		    if (node.type !== "ArgumentPlaceholder") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isBindExpression(node, opts) {
		    if (!node) return false;
		    if (node.type !== "BindExpression") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isImportAttribute(node, opts) {
		    if (!node) return false;
		    if (node.type !== "ImportAttribute") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isDecorator(node, opts) {
		    if (!node) return false;
		    if (node.type !== "Decorator") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isDoExpression(node, opts) {
		    if (!node) return false;
		    if (node.type !== "DoExpression") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isExportDefaultSpecifier$1(node, opts) {
		    if (!node) return false;
		    if (node.type !== "ExportDefaultSpecifier") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isRecordExpression$1(node, opts) {
		    if (!node) return false;
		    if (node.type !== "RecordExpression") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTupleExpression$1(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TupleExpression") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isDecimalLiteral(node, opts) {
		    if (!node) return false;
		    if (node.type !== "DecimalLiteral") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isModuleExpression(node, opts) {
		    if (!node) return false;
		    if (node.type !== "ModuleExpression") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTopicReference$1(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TopicReference") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isPipelineTopicExpression(node, opts) {
		    if (!node) return false;
		    if (node.type !== "PipelineTopicExpression") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isPipelineBareFunction(node, opts) {
		    if (!node) return false;
		    if (node.type !== "PipelineBareFunction") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isPipelinePrimaryTopicReference(node, opts) {
		    if (!node) return false;
		    if (node.type !== "PipelinePrimaryTopicReference") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSParameterProperty(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TSParameterProperty") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSDeclareFunction(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TSDeclareFunction") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSDeclareMethod(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TSDeclareMethod") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSQualifiedName(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TSQualifiedName") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSCallSignatureDeclaration(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TSCallSignatureDeclaration") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSConstructSignatureDeclaration(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TSConstructSignatureDeclaration") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSPropertySignature(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TSPropertySignature") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSMethodSignature(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TSMethodSignature") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSIndexSignature(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TSIndexSignature") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSAnyKeyword(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TSAnyKeyword") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSBooleanKeyword(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TSBooleanKeyword") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSBigIntKeyword(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TSBigIntKeyword") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSIntrinsicKeyword(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TSIntrinsicKeyword") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSNeverKeyword(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TSNeverKeyword") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSNullKeyword(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TSNullKeyword") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSNumberKeyword(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TSNumberKeyword") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSObjectKeyword(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TSObjectKeyword") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSStringKeyword(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TSStringKeyword") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSSymbolKeyword(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TSSymbolKeyword") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSUndefinedKeyword(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TSUndefinedKeyword") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSUnknownKeyword(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TSUnknownKeyword") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSVoidKeyword(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TSVoidKeyword") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSThisType(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TSThisType") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSFunctionType(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TSFunctionType") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSConstructorType(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TSConstructorType") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSTypeReference$1(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TSTypeReference") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSTypePredicate(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TSTypePredicate") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSTypeQuery(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TSTypeQuery") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSTypeLiteral(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TSTypeLiteral") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSArrayType$1(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TSArrayType") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSTupleType(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TSTupleType") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSOptionalType(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TSOptionalType") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSRestType(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TSRestType") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSNamedTupleMember(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TSNamedTupleMember") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSUnionType(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TSUnionType") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSIntersectionType(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TSIntersectionType") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSConditionalType(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TSConditionalType") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSInferType(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TSInferType") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSParenthesizedType(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TSParenthesizedType") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSTypeOperator(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TSTypeOperator") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSIndexedAccessType(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TSIndexedAccessType") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSMappedType(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TSMappedType") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSLiteralType(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TSLiteralType") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSExpressionWithTypeArguments(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TSExpressionWithTypeArguments") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSInterfaceDeclaration(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TSInterfaceDeclaration") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSInterfaceBody$1(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TSInterfaceBody") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSTypeAliasDeclaration(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TSTypeAliasDeclaration") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSInstantiationExpression(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TSInstantiationExpression") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSAsExpression$1(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TSAsExpression") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSSatisfiesExpression$1(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TSSatisfiesExpression") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSTypeAssertion$1(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TSTypeAssertion") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSEnumDeclaration$1(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TSEnumDeclaration") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSEnumMember(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TSEnumMember") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSModuleDeclaration(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TSModuleDeclaration") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSModuleBlock(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TSModuleBlock") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSImportType(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TSImportType") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSImportEqualsDeclaration(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TSImportEqualsDeclaration") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSExternalModuleReference(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TSExternalModuleReference") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSNonNullExpression$1(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TSNonNullExpression") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSExportAssignment(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TSExportAssignment") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSNamespaceExportDeclaration(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TSNamespaceExportDeclaration") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSTypeAnnotation$1(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TSTypeAnnotation") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSTypeParameterInstantiation(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TSTypeParameterInstantiation") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSTypeParameterDeclaration(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TSTypeParameterDeclaration") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSTypeParameter(node, opts) {
		    if (!node) return false;
		    if (node.type !== "TSTypeParameter") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isStandardized(node, opts) {
		    if (!node) return false;
		    switch (node.type) {
		      case "ArrayExpression":
		      case "AssignmentExpression":
		      case "BinaryExpression":
		      case "InterpreterDirective":
		      case "Directive":
		      case "DirectiveLiteral":
		      case "BlockStatement":
		      case "BreakStatement":
		      case "CallExpression":
		      case "CatchClause":
		      case "ConditionalExpression":
		      case "ContinueStatement":
		      case "DebuggerStatement":
		      case "DoWhileStatement":
		      case "EmptyStatement":
		      case "ExpressionStatement":
		      case "File":
		      case "ForInStatement":
		      case "ForStatement":
		      case "FunctionDeclaration":
		      case "FunctionExpression":
		      case "Identifier":
		      case "IfStatement":
		      case "LabeledStatement":
		      case "StringLiteral":
		      case "NumericLiteral":
		      case "NullLiteral":
		      case "BooleanLiteral":
		      case "RegExpLiteral":
		      case "LogicalExpression":
		      case "MemberExpression":
		      case "NewExpression":
		      case "Program":
		      case "ObjectExpression":
		      case "ObjectMethod":
		      case "ObjectProperty":
		      case "RestElement":
		      case "ReturnStatement":
		      case "SequenceExpression":
		      case "ParenthesizedExpression":
		      case "SwitchCase":
		      case "SwitchStatement":
		      case "ThisExpression":
		      case "ThrowStatement":
		      case "TryStatement":
		      case "UnaryExpression":
		      case "UpdateExpression":
		      case "VariableDeclaration":
		      case "VariableDeclarator":
		      case "WhileStatement":
		      case "WithStatement":
		      case "AssignmentPattern":
		      case "ArrayPattern":
		      case "ArrowFunctionExpression":
		      case "ClassBody":
		      case "ClassExpression":
		      case "ClassDeclaration":
		      case "ExportAllDeclaration":
		      case "ExportDefaultDeclaration":
		      case "ExportNamedDeclaration":
		      case "ExportSpecifier":
		      case "ForOfStatement":
		      case "ImportDeclaration":
		      case "ImportDefaultSpecifier":
		      case "ImportNamespaceSpecifier":
		      case "ImportSpecifier":
		      case "ImportExpression":
		      case "MetaProperty":
		      case "ClassMethod":
		      case "ObjectPattern":
		      case "SpreadElement":
		      case "Super":
		      case "TaggedTemplateExpression":
		      case "TemplateElement":
		      case "TemplateLiteral":
		      case "YieldExpression":
		      case "AwaitExpression":
		      case "Import":
		      case "BigIntLiteral":
		      case "ExportNamespaceSpecifier":
		      case "OptionalMemberExpression":
		      case "OptionalCallExpression":
		      case "ClassProperty":
		      case "ClassAccessorProperty":
		      case "ClassPrivateProperty":
		      case "ClassPrivateMethod":
		      case "PrivateName":
		      case "StaticBlock":
		        break;
		      case "Placeholder":
		        switch (node.expectedNode) {
		          case "Identifier":
		          case "StringLiteral":
		          case "BlockStatement":
		          case "ClassBody":
		            break;
		          default:
		            return false;
		        }
		        break;
		      default:
		        return false;
		    }
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isExpression$4(node, opts) {
		    if (!node) return false;
		    switch (node.type) {
		      case "ArrayExpression":
		      case "AssignmentExpression":
		      case "BinaryExpression":
		      case "CallExpression":
		      case "ConditionalExpression":
		      case "FunctionExpression":
		      case "Identifier":
		      case "StringLiteral":
		      case "NumericLiteral":
		      case "NullLiteral":
		      case "BooleanLiteral":
		      case "RegExpLiteral":
		      case "LogicalExpression":
		      case "MemberExpression":
		      case "NewExpression":
		      case "ObjectExpression":
		      case "SequenceExpression":
		      case "ParenthesizedExpression":
		      case "ThisExpression":
		      case "UnaryExpression":
		      case "UpdateExpression":
		      case "ArrowFunctionExpression":
		      case "ClassExpression":
		      case "ImportExpression":
		      case "MetaProperty":
		      case "Super":
		      case "TaggedTemplateExpression":
		      case "TemplateLiteral":
		      case "YieldExpression":
		      case "AwaitExpression":
		      case "Import":
		      case "BigIntLiteral":
		      case "OptionalMemberExpression":
		      case "OptionalCallExpression":
		      case "TypeCastExpression":
		      case "JSXElement":
		      case "JSXFragment":
		      case "BindExpression":
		      case "DoExpression":
		      case "RecordExpression":
		      case "TupleExpression":
		      case "DecimalLiteral":
		      case "ModuleExpression":
		      case "TopicReference":
		      case "PipelineTopicExpression":
		      case "PipelineBareFunction":
		      case "PipelinePrimaryTopicReference":
		      case "TSInstantiationExpression":
		      case "TSAsExpression":
		      case "TSSatisfiesExpression":
		      case "TSTypeAssertion":
		      case "TSNonNullExpression":
		        break;
		      case "Placeholder":
		        switch (node.expectedNode) {
		          case "Expression":
		          case "Identifier":
		          case "StringLiteral":
		            break;
		          default:
		            return false;
		        }
		        break;
		      default:
		        return false;
		    }
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isBinary$2(node, opts) {
		    if (!node) return false;
		    switch (node.type) {
		      case "BinaryExpression":
		      case "LogicalExpression":
		        break;
		      default:
		        return false;
		    }
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isScopable(node, opts) {
		    if (!node) return false;
		    switch (node.type) {
		      case "BlockStatement":
		      case "CatchClause":
		      case "DoWhileStatement":
		      case "ForInStatement":
		      case "ForStatement":
		      case "FunctionDeclaration":
		      case "FunctionExpression":
		      case "Program":
		      case "ObjectMethod":
		      case "SwitchStatement":
		      case "WhileStatement":
		      case "ArrowFunctionExpression":
		      case "ClassExpression":
		      case "ClassDeclaration":
		      case "ForOfStatement":
		      case "ClassMethod":
		      case "ClassPrivateMethod":
		      case "StaticBlock":
		      case "TSModuleBlock":
		        break;
		      case "Placeholder":
		        if (node.expectedNode === "BlockStatement") break;
		      default:
		        return false;
		    }
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isBlockParent(node, opts) {
		    if (!node) return false;
		    switch (node.type) {
		      case "BlockStatement":
		      case "CatchClause":
		      case "DoWhileStatement":
		      case "ForInStatement":
		      case "ForStatement":
		      case "FunctionDeclaration":
		      case "FunctionExpression":
		      case "Program":
		      case "ObjectMethod":
		      case "SwitchStatement":
		      case "WhileStatement":
		      case "ArrowFunctionExpression":
		      case "ForOfStatement":
		      case "ClassMethod":
		      case "ClassPrivateMethod":
		      case "StaticBlock":
		      case "TSModuleBlock":
		        break;
		      case "Placeholder":
		        if (node.expectedNode === "BlockStatement") break;
		      default:
		        return false;
		    }
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isBlock(node, opts) {
		    if (!node) return false;
		    switch (node.type) {
		      case "BlockStatement":
		      case "Program":
		      case "TSModuleBlock":
		        break;
		      case "Placeholder":
		        if (node.expectedNode === "BlockStatement") break;
		      default:
		        return false;
		    }
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isStatement$8(node, opts) {
		    if (!node) return false;
		    switch (node.type) {
		      case "BlockStatement":
		      case "BreakStatement":
		      case "ContinueStatement":
		      case "DebuggerStatement":
		      case "DoWhileStatement":
		      case "EmptyStatement":
		      case "ExpressionStatement":
		      case "ForInStatement":
		      case "ForStatement":
		      case "FunctionDeclaration":
		      case "IfStatement":
		      case "LabeledStatement":
		      case "ReturnStatement":
		      case "SwitchStatement":
		      case "ThrowStatement":
		      case "TryStatement":
		      case "VariableDeclaration":
		      case "WhileStatement":
		      case "WithStatement":
		      case "ClassDeclaration":
		      case "ExportAllDeclaration":
		      case "ExportDefaultDeclaration":
		      case "ExportNamedDeclaration":
		      case "ForOfStatement":
		      case "ImportDeclaration":
		      case "DeclareClass":
		      case "DeclareFunction":
		      case "DeclareInterface":
		      case "DeclareModule":
		      case "DeclareModuleExports":
		      case "DeclareTypeAlias":
		      case "DeclareOpaqueType":
		      case "DeclareVariable":
		      case "DeclareExportDeclaration":
		      case "DeclareExportAllDeclaration":
		      case "InterfaceDeclaration":
		      case "OpaqueType":
		      case "TypeAlias":
		      case "EnumDeclaration":
		      case "TSDeclareFunction":
		      case "TSInterfaceDeclaration":
		      case "TSTypeAliasDeclaration":
		      case "TSEnumDeclaration":
		      case "TSModuleDeclaration":
		      case "TSImportEqualsDeclaration":
		      case "TSExportAssignment":
		      case "TSNamespaceExportDeclaration":
		        break;
		      case "Placeholder":
		        switch (node.expectedNode) {
		          case "Statement":
		          case "Declaration":
		          case "BlockStatement":
		            break;
		          default:
		            return false;
		        }
		        break;
		      default:
		        return false;
		    }
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTerminatorless(node, opts) {
		    if (!node) return false;
		    switch (node.type) {
		      case "BreakStatement":
		      case "ContinueStatement":
		      case "ReturnStatement":
		      case "ThrowStatement":
		      case "YieldExpression":
		      case "AwaitExpression":
		        break;
		      default:
		        return false;
		    }
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isCompletionStatement(node, opts) {
		    if (!node) return false;
		    switch (node.type) {
		      case "BreakStatement":
		      case "ContinueStatement":
		      case "ReturnStatement":
		      case "ThrowStatement":
		        break;
		      default:
		        return false;
		    }
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isConditional(node, opts) {
		    if (!node) return false;
		    switch (node.type) {
		      case "ConditionalExpression":
		      case "IfStatement":
		        break;
		      default:
		        return false;
		    }
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isLoop$1(node, opts) {
		    if (!node) return false;
		    switch (node.type) {
		      case "DoWhileStatement":
		      case "ForInStatement":
		      case "ForStatement":
		      case "WhileStatement":
		      case "ForOfStatement":
		        break;
		      default:
		        return false;
		    }
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isWhile(node, opts) {
		    if (!node) return false;
		    switch (node.type) {
		      case "DoWhileStatement":
		      case "WhileStatement":
		        break;
		      default:
		        return false;
		    }
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isExpressionWrapper(node, opts) {
		    if (!node) return false;
		    switch (node.type) {
		      case "ExpressionStatement":
		      case "ParenthesizedExpression":
		      case "TypeCastExpression":
		        break;
		      default:
		        return false;
		    }
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isFor$1(node, opts) {
		    if (!node) return false;
		    switch (node.type) {
		      case "ForInStatement":
		      case "ForStatement":
		      case "ForOfStatement":
		        break;
		      default:
		        return false;
		    }
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isForXStatement$1(node, opts) {
		    if (!node) return false;
		    switch (node.type) {
		      case "ForInStatement":
		      case "ForOfStatement":
		        break;
		      default:
		        return false;
		    }
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isFunction$5(node, opts) {
		    if (!node) return false;
		    switch (node.type) {
		      case "FunctionDeclaration":
		      case "FunctionExpression":
		      case "ObjectMethod":
		      case "ArrowFunctionExpression":
		      case "ClassMethod":
		      case "ClassPrivateMethod":
		        break;
		      default:
		        return false;
		    }
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isFunctionParent(node, opts) {
		    if (!node) return false;
		    switch (node.type) {
		      case "FunctionDeclaration":
		      case "FunctionExpression":
		      case "ObjectMethod":
		      case "ArrowFunctionExpression":
		      case "ClassMethod":
		      case "ClassPrivateMethod":
		      case "StaticBlock":
		      case "TSModuleBlock":
		        break;
		      default:
		        return false;
		    }
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isPureish$2(node, opts) {
		    if (!node) return false;
		    switch (node.type) {
		      case "FunctionDeclaration":
		      case "FunctionExpression":
		      case "StringLiteral":
		      case "NumericLiteral":
		      case "NullLiteral":
		      case "BooleanLiteral":
		      case "RegExpLiteral":
		      case "ArrowFunctionExpression":
		      case "BigIntLiteral":
		      case "DecimalLiteral":
		        break;
		      case "Placeholder":
		        if (node.expectedNode === "StringLiteral") break;
		      default:
		        return false;
		    }
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isDeclaration(node, opts) {
		    if (!node) return false;
		    switch (node.type) {
		      case "FunctionDeclaration":
		      case "VariableDeclaration":
		      case "ClassDeclaration":
		      case "ExportAllDeclaration":
		      case "ExportDefaultDeclaration":
		      case "ExportNamedDeclaration":
		      case "ImportDeclaration":
		      case "DeclareClass":
		      case "DeclareFunction":
		      case "DeclareInterface":
		      case "DeclareModule":
		      case "DeclareModuleExports":
		      case "DeclareTypeAlias":
		      case "DeclareOpaqueType":
		      case "DeclareVariable":
		      case "DeclareExportDeclaration":
		      case "DeclareExportAllDeclaration":
		      case "InterfaceDeclaration":
		      case "OpaqueType":
		      case "TypeAlias":
		      case "EnumDeclaration":
		      case "TSDeclareFunction":
		      case "TSInterfaceDeclaration":
		      case "TSTypeAliasDeclaration":
		      case "TSEnumDeclaration":
		      case "TSModuleDeclaration":
		        break;
		      case "Placeholder":
		        if (node.expectedNode === "Declaration") break;
		      default:
		        return false;
		    }
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isPatternLike(node, opts) {
		    if (!node) return false;
		    switch (node.type) {
		      case "Identifier":
		      case "RestElement":
		      case "AssignmentPattern":
		      case "ArrayPattern":
		      case "ObjectPattern":
		      case "TSAsExpression":
		      case "TSSatisfiesExpression":
		      case "TSTypeAssertion":
		      case "TSNonNullExpression":
		        break;
		      case "Placeholder":
		        switch (node.expectedNode) {
		          case "Pattern":
		          case "Identifier":
		            break;
		          default:
		            return false;
		        }
		        break;
		      default:
		        return false;
		    }
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isLVal(node, opts) {
		    if (!node) return false;
		    switch (node.type) {
		      case "Identifier":
		      case "MemberExpression":
		      case "RestElement":
		      case "AssignmentPattern":
		      case "ArrayPattern":
		      case "ObjectPattern":
		      case "TSParameterProperty":
		      case "TSAsExpression":
		      case "TSSatisfiesExpression":
		      case "TSTypeAssertion":
		      case "TSNonNullExpression":
		        break;
		      case "Placeholder":
		        switch (node.expectedNode) {
		          case "Pattern":
		          case "Identifier":
		            break;
		          default:
		            return false;
		        }
		        break;
		      default:
		        return false;
		    }
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSEntityName(node, opts) {
		    if (!node) return false;
		    switch (node.type) {
		      case "Identifier":
		      case "TSQualifiedName":
		        break;
		      case "Placeholder":
		        if (node.expectedNode === "Identifier") break;
		      default:
		        return false;
		    }
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isLiteral$6(node, opts) {
		    if (!node) return false;
		    switch (node.type) {
		      case "StringLiteral":
		      case "NumericLiteral":
		      case "NullLiteral":
		      case "BooleanLiteral":
		      case "RegExpLiteral":
		      case "TemplateLiteral":
		      case "BigIntLiteral":
		      case "DecimalLiteral":
		        break;
		      case "Placeholder":
		        if (node.expectedNode === "StringLiteral") break;
		      default:
		        return false;
		    }
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isUserWhitespacable(node, opts) {
		    if (!node) return false;
		    switch (node.type) {
		      case "ObjectMethod":
		      case "ObjectProperty":
		      case "ObjectTypeInternalSlot":
		      case "ObjectTypeCallProperty":
		      case "ObjectTypeIndexer":
		      case "ObjectTypeProperty":
		      case "ObjectTypeSpreadProperty":
		        break;
		      default:
		        return false;
		    }
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isMethod$1(node, opts) {
		    if (!node) return false;
		    switch (node.type) {
		      case "ObjectMethod":
		      case "ClassMethod":
		      case "ClassPrivateMethod":
		        break;
		      default:
		        return false;
		    }
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isObjectMember(node, opts) {
		    if (!node) return false;
		    switch (node.type) {
		      case "ObjectMethod":
		      case "ObjectProperty":
		        break;
		      default:
		        return false;
		    }
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isProperty$1(node, opts) {
		    if (!node) return false;
		    switch (node.type) {
		      case "ObjectProperty":
		      case "ClassProperty":
		      case "ClassAccessorProperty":
		      case "ClassPrivateProperty":
		        break;
		      default:
		        return false;
		    }
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isUnaryLike(node, opts) {
		    if (!node) return false;
		    switch (node.type) {
		      case "UnaryExpression":
		      case "SpreadElement":
		        break;
		      default:
		        return false;
		    }
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isPattern(node, opts) {
		    if (!node) return false;
		    switch (node.type) {
		      case "AssignmentPattern":
		      case "ArrayPattern":
		      case "ObjectPattern":
		        break;
		      case "Placeholder":
		        if (node.expectedNode === "Pattern") break;
		      default:
		        return false;
		    }
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isClass$1(node, opts) {
		    if (!node) return false;
		    switch (node.type) {
		      case "ClassExpression":
		      case "ClassDeclaration":
		        break;
		      default:
		        return false;
		    }
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isImportOrExportDeclaration(node, opts) {
		    if (!node) return false;
		    switch (node.type) {
		      case "ExportAllDeclaration":
		      case "ExportDefaultDeclaration":
		      case "ExportNamedDeclaration":
		      case "ImportDeclaration":
		        break;
		      default:
		        return false;
		    }
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isExportDeclaration$3(node, opts) {
		    if (!node) return false;
		    switch (node.type) {
		      case "ExportAllDeclaration":
		      case "ExportDefaultDeclaration":
		      case "ExportNamedDeclaration":
		        break;
		      default:
		        return false;
		    }
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isModuleSpecifier$1(node, opts) {
		    if (!node) return false;
		    switch (node.type) {
		      case "ExportSpecifier":
		      case "ImportDefaultSpecifier":
		      case "ImportNamespaceSpecifier":
		      case "ImportSpecifier":
		      case "ExportNamespaceSpecifier":
		      case "ExportDefaultSpecifier":
		        break;
		      default:
		        return false;
		    }
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isAccessor(node, opts) {
		    if (!node) return false;
		    switch (node.type) {
		      case "ClassAccessorProperty":
		        break;
		      default:
		        return false;
		    }
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isPrivate(node, opts) {
		    if (!node) return false;
		    switch (node.type) {
		      case "ClassPrivateProperty":
		      case "ClassPrivateMethod":
		      case "PrivateName":
		        break;
		      default:
		        return false;
		    }
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isFlow$1(node, opts) {
		    if (!node) return false;
		    switch (node.type) {
		      case "AnyTypeAnnotation":
		      case "ArrayTypeAnnotation":
		      case "BooleanTypeAnnotation":
		      case "BooleanLiteralTypeAnnotation":
		      case "NullLiteralTypeAnnotation":
		      case "ClassImplements":
		      case "DeclareClass":
		      case "DeclareFunction":
		      case "DeclareInterface":
		      case "DeclareModule":
		      case "DeclareModuleExports":
		      case "DeclareTypeAlias":
		      case "DeclareOpaqueType":
		      case "DeclareVariable":
		      case "DeclareExportDeclaration":
		      case "DeclareExportAllDeclaration":
		      case "DeclaredPredicate":
		      case "ExistsTypeAnnotation":
		      case "FunctionTypeAnnotation":
		      case "FunctionTypeParam":
		      case "GenericTypeAnnotation":
		      case "InferredPredicate":
		      case "InterfaceExtends":
		      case "InterfaceDeclaration":
		      case "InterfaceTypeAnnotation":
		      case "IntersectionTypeAnnotation":
		      case "MixedTypeAnnotation":
		      case "EmptyTypeAnnotation":
		      case "NullableTypeAnnotation":
		      case "NumberLiteralTypeAnnotation":
		      case "NumberTypeAnnotation":
		      case "ObjectTypeAnnotation":
		      case "ObjectTypeInternalSlot":
		      case "ObjectTypeCallProperty":
		      case "ObjectTypeIndexer":
		      case "ObjectTypeProperty":
		      case "ObjectTypeSpreadProperty":
		      case "OpaqueType":
		      case "QualifiedTypeIdentifier":
		      case "StringLiteralTypeAnnotation":
		      case "StringTypeAnnotation":
		      case "SymbolTypeAnnotation":
		      case "ThisTypeAnnotation":
		      case "TupleTypeAnnotation":
		      case "TypeofTypeAnnotation":
		      case "TypeAlias":
		      case "TypeAnnotation":
		      case "TypeCastExpression":
		      case "TypeParameter":
		      case "TypeParameterDeclaration":
		      case "TypeParameterInstantiation":
		      case "UnionTypeAnnotation":
		      case "Variance":
		      case "VoidTypeAnnotation":
		      case "EnumDeclaration":
		      case "EnumBooleanBody":
		      case "EnumNumberBody":
		      case "EnumStringBody":
		      case "EnumSymbolBody":
		      case "EnumBooleanMember":
		      case "EnumNumberMember":
		      case "EnumStringMember":
		      case "EnumDefaultedMember":
		      case "IndexedAccessType":
		      case "OptionalIndexedAccessType":
		        break;
		      default:
		        return false;
		    }
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isFlowType$1(node, opts) {
		    if (!node) return false;
		    switch (node.type) {
		      case "AnyTypeAnnotation":
		      case "ArrayTypeAnnotation":
		      case "BooleanTypeAnnotation":
		      case "BooleanLiteralTypeAnnotation":
		      case "NullLiteralTypeAnnotation":
		      case "ExistsTypeAnnotation":
		      case "FunctionTypeAnnotation":
		      case "GenericTypeAnnotation":
		      case "InterfaceTypeAnnotation":
		      case "IntersectionTypeAnnotation":
		      case "MixedTypeAnnotation":
		      case "EmptyTypeAnnotation":
		      case "NullableTypeAnnotation":
		      case "NumberLiteralTypeAnnotation":
		      case "NumberTypeAnnotation":
		      case "ObjectTypeAnnotation":
		      case "StringLiteralTypeAnnotation":
		      case "StringTypeAnnotation":
		      case "SymbolTypeAnnotation":
		      case "ThisTypeAnnotation":
		      case "TupleTypeAnnotation":
		      case "TypeofTypeAnnotation":
		      case "UnionTypeAnnotation":
		      case "VoidTypeAnnotation":
		      case "IndexedAccessType":
		      case "OptionalIndexedAccessType":
		        break;
		      default:
		        return false;
		    }
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isFlowBaseAnnotation$1(node, opts) {
		    if (!node) return false;
		    switch (node.type) {
		      case "AnyTypeAnnotation":
		      case "BooleanTypeAnnotation":
		      case "NullLiteralTypeAnnotation":
		      case "MixedTypeAnnotation":
		      case "EmptyTypeAnnotation":
		      case "NumberTypeAnnotation":
		      case "StringTypeAnnotation":
		      case "SymbolTypeAnnotation":
		      case "ThisTypeAnnotation":
		      case "VoidTypeAnnotation":
		        break;
		      default:
		        return false;
		    }
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isFlowDeclaration(node, opts) {
		    if (!node) return false;
		    switch (node.type) {
		      case "DeclareClass":
		      case "DeclareFunction":
		      case "DeclareInterface":
		      case "DeclareModule":
		      case "DeclareModuleExports":
		      case "DeclareTypeAlias":
		      case "DeclareOpaqueType":
		      case "DeclareVariable":
		      case "DeclareExportDeclaration":
		      case "DeclareExportAllDeclaration":
		      case "InterfaceDeclaration":
		      case "OpaqueType":
		      case "TypeAlias":
		        break;
		      default:
		        return false;
		    }
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isFlowPredicate(node, opts) {
		    if (!node) return false;
		    switch (node.type) {
		      case "DeclaredPredicate":
		      case "InferredPredicate":
		        break;
		      default:
		        return false;
		    }
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isEnumBody(node, opts) {
		    if (!node) return false;
		    switch (node.type) {
		      case "EnumBooleanBody":
		      case "EnumNumberBody":
		      case "EnumStringBody":
		      case "EnumSymbolBody":
		        break;
		      default:
		        return false;
		    }
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isEnumMember(node, opts) {
		    if (!node) return false;
		    switch (node.type) {
		      case "EnumBooleanMember":
		      case "EnumNumberMember":
		      case "EnumStringMember":
		      case "EnumDefaultedMember":
		        break;
		      default:
		        return false;
		    }
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isJSX(node, opts) {
		    if (!node) return false;
		    switch (node.type) {
		      case "JSXAttribute":
		      case "JSXClosingElement":
		      case "JSXElement":
		      case "JSXEmptyExpression":
		      case "JSXExpressionContainer":
		      case "JSXSpreadChild":
		      case "JSXIdentifier":
		      case "JSXMemberExpression":
		      case "JSXNamespacedName":
		      case "JSXOpeningElement":
		      case "JSXSpreadAttribute":
		      case "JSXText":
		      case "JSXFragment":
		      case "JSXOpeningFragment":
		      case "JSXClosingFragment":
		        break;
		      default:
		        return false;
		    }
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isMiscellaneous(node, opts) {
		    if (!node) return false;
		    switch (node.type) {
		      case "Noop":
		      case "Placeholder":
		      case "V8IntrinsicIdentifier":
		        break;
		      default:
		        return false;
		    }
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTypeScript(node, opts) {
		    if (!node) return false;
		    switch (node.type) {
		      case "TSParameterProperty":
		      case "TSDeclareFunction":
		      case "TSDeclareMethod":
		      case "TSQualifiedName":
		      case "TSCallSignatureDeclaration":
		      case "TSConstructSignatureDeclaration":
		      case "TSPropertySignature":
		      case "TSMethodSignature":
		      case "TSIndexSignature":
		      case "TSAnyKeyword":
		      case "TSBooleanKeyword":
		      case "TSBigIntKeyword":
		      case "TSIntrinsicKeyword":
		      case "TSNeverKeyword":
		      case "TSNullKeyword":
		      case "TSNumberKeyword":
		      case "TSObjectKeyword":
		      case "TSStringKeyword":
		      case "TSSymbolKeyword":
		      case "TSUndefinedKeyword":
		      case "TSUnknownKeyword":
		      case "TSVoidKeyword":
		      case "TSThisType":
		      case "TSFunctionType":
		      case "TSConstructorType":
		      case "TSTypeReference":
		      case "TSTypePredicate":
		      case "TSTypeQuery":
		      case "TSTypeLiteral":
		      case "TSArrayType":
		      case "TSTupleType":
		      case "TSOptionalType":
		      case "TSRestType":
		      case "TSNamedTupleMember":
		      case "TSUnionType":
		      case "TSIntersectionType":
		      case "TSConditionalType":
		      case "TSInferType":
		      case "TSParenthesizedType":
		      case "TSTypeOperator":
		      case "TSIndexedAccessType":
		      case "TSMappedType":
		      case "TSLiteralType":
		      case "TSExpressionWithTypeArguments":
		      case "TSInterfaceDeclaration":
		      case "TSInterfaceBody":
		      case "TSTypeAliasDeclaration":
		      case "TSInstantiationExpression":
		      case "TSAsExpression":
		      case "TSSatisfiesExpression":
		      case "TSTypeAssertion":
		      case "TSEnumDeclaration":
		      case "TSEnumMember":
		      case "TSModuleDeclaration":
		      case "TSModuleBlock":
		      case "TSImportType":
		      case "TSImportEqualsDeclaration":
		      case "TSExternalModuleReference":
		      case "TSNonNullExpression":
		      case "TSExportAssignment":
		      case "TSNamespaceExportDeclaration":
		      case "TSTypeAnnotation":
		      case "TSTypeParameterInstantiation":
		      case "TSTypeParameterDeclaration":
		      case "TSTypeParameter":
		        break;
		      default:
		        return false;
		    }
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSTypeElement(node, opts) {
		    if (!node) return false;
		    switch (node.type) {
		      case "TSCallSignatureDeclaration":
		      case "TSConstructSignatureDeclaration":
		      case "TSPropertySignature":
		      case "TSMethodSignature":
		      case "TSIndexSignature":
		        break;
		      default:
		        return false;
		    }
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSType$1(node, opts) {
		    if (!node) return false;
		    switch (node.type) {
		      case "TSAnyKeyword":
		      case "TSBooleanKeyword":
		      case "TSBigIntKeyword":
		      case "TSIntrinsicKeyword":
		      case "TSNeverKeyword":
		      case "TSNullKeyword":
		      case "TSNumberKeyword":
		      case "TSObjectKeyword":
		      case "TSStringKeyword":
		      case "TSSymbolKeyword":
		      case "TSUndefinedKeyword":
		      case "TSUnknownKeyword":
		      case "TSVoidKeyword":
		      case "TSThisType":
		      case "TSFunctionType":
		      case "TSConstructorType":
		      case "TSTypeReference":
		      case "TSTypePredicate":
		      case "TSTypeQuery":
		      case "TSTypeLiteral":
		      case "TSArrayType":
		      case "TSTupleType":
		      case "TSOptionalType":
		      case "TSRestType":
		      case "TSUnionType":
		      case "TSIntersectionType":
		      case "TSConditionalType":
		      case "TSInferType":
		      case "TSParenthesizedType":
		      case "TSTypeOperator":
		      case "TSIndexedAccessType":
		      case "TSMappedType":
		      case "TSLiteralType":
		      case "TSExpressionWithTypeArguments":
		      case "TSImportType":
		        break;
		      default:
		        return false;
		    }
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isTSBaseType(node, opts) {
		    if (!node) return false;
		    switch (node.type) {
		      case "TSAnyKeyword":
		      case "TSBooleanKeyword":
		      case "TSBigIntKeyword":
		      case "TSIntrinsicKeyword":
		      case "TSNeverKeyword":
		      case "TSNullKeyword":
		      case "TSNumberKeyword":
		      case "TSObjectKeyword":
		      case "TSStringKeyword":
		      case "TSSymbolKeyword":
		      case "TSUndefinedKeyword":
		      case "TSUnknownKeyword":
		      case "TSVoidKeyword":
		      case "TSThisType":
		      case "TSLiteralType":
		        break;
		      default:
		        return false;
		    }
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isNumberLiteral(node, opts) {
		    deprecationWarning$1("isNumberLiteral", "isNumericLiteral");
		    if (!node) return false;
		    if (node.type !== "NumberLiteral") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isRegexLiteral(node, opts) {
		    deprecationWarning$1("isRegexLiteral", "isRegExpLiteral");
		    if (!node) return false;
		    if (node.type !== "RegexLiteral") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isRestProperty$1(node, opts) {
		    deprecationWarning$1("isRestProperty", "isRestElement");
		    if (!node) return false;
		    if (node.type !== "RestProperty") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isSpreadProperty$1(node, opts) {
		    deprecationWarning$1("isSpreadProperty", "isSpreadElement");
		    if (!node) return false;
		    if (node.type !== "SpreadProperty") return false;
		    return opts == null || shallowEqual(node, opts);
		  }
		  function isModuleDeclaration(node, opts) {
		    deprecationWarning$1("isModuleDeclaration", "isImportOrExportDeclaration");
		    return isImportOrExportDeclaration(node, opts);
		  }

		  function matchesPattern$2(member, match, allowPartial) {
		    if (!isMemberExpression$9(member)) return false;
		    var parts = Array.isArray(match) ? match : match.split(".");
		    var nodes = [];
		    var node;
		    for (node = member; isMemberExpression$9(node); node = node.object) {
		      nodes.push(node.property);
		    }
		    nodes.push(node);
		    if (nodes.length < parts.length) return false;
		    if (!allowPartial && nodes.length > parts.length) return false;
		    for (var i = 0, j = nodes.length - 1; i < parts.length; i++, j--) {
		      var _node = nodes[j];
		      var value = void 0;
		      if (isIdentifier$i(_node)) {
		        value = _node.name;
		      } else if (isStringLiteral$5(_node)) {
		        value = _node.value;
		      } else if (isThisExpression$2(_node)) {
		        value = "this";
		      } else {
		        return false;
		      }
		      if (parts[i] !== value) return false;
		    }
		    return true;
		  }

		  function buildMatchMemberExpression$1(match, allowPartial) {
		    var parts = match.split(".");
		    return function (member) {
		      return matchesPattern$2(member, parts, allowPartial);
		    };
		  }

		  var isReactComponent = buildMatchMemberExpression$1("React.Component");

		  function isCompatTag$1(tagName) {
		    return !!tagName && /^[a-z]/.test(tagName);
		  }

		  var global$1 = (typeof commonjsGlobal !== "undefined" ? commonjsGlobal :
		    typeof self !== "undefined" ? self :
		    typeof window !== "undefined" ? window : {});

		  // shim for using process in browser
		  // based off https://github.com/defunctzombie/node-process/blob/master/browser.js

		  function defaultSetTimout() {
		      throw new Error('setTimeout has not been defined');
		  }
		  function defaultClearTimeout () {
		      throw new Error('clearTimeout has not been defined');
		  }
		  var cachedSetTimeout = defaultSetTimout;
		  var cachedClearTimeout = defaultClearTimeout;
		  if (typeof global$1.setTimeout === 'function') {
		      cachedSetTimeout = setTimeout;
		  }
		  if (typeof global$1.clearTimeout === 'function') {
		      cachedClearTimeout = clearTimeout;
		  }

		  function runTimeout(fun) {
		      if (cachedSetTimeout === setTimeout) {
		          //normal enviroments in sane situations
		          return setTimeout(fun, 0);
		      }
		      // if setTimeout wasn't available but was latter defined
		      if ((cachedSetTimeout === defaultSetTimout || !cachedSetTimeout) && setTimeout) {
		          cachedSetTimeout = setTimeout;
		          return setTimeout(fun, 0);
		      }
		      try {
		          // when when somebody has screwed with setTimeout but no I.E. maddness
		          return cachedSetTimeout(fun, 0);
		      } catch(e){
		          try {
		              // When we are in I.E. but the script has been evaled so I.E. doesn't trust the global object when called normally
		              return cachedSetTimeout.call(null, fun, 0);
		          } catch(e){
		              // same as above but when it's a version of I.E. that must have the global object for 'this', hopfully our context correct otherwise it will throw a global error
		              return cachedSetTimeout.call(this, fun, 0);
		          }
		      }


		  }
		  function runClearTimeout(marker) {
		      if (cachedClearTimeout === clearTimeout) {
		          //normal enviroments in sane situations
		          return clearTimeout(marker);
		      }
		      // if clearTimeout wasn't available but was latter defined
		      if ((cachedClearTimeout === defaultClearTimeout || !cachedClearTimeout) && clearTimeout) {
		          cachedClearTimeout = clearTimeout;
		          return clearTimeout(marker);
		      }
		      try {
		          // when when somebody has screwed with setTimeout but no I.E. maddness
		          return cachedClearTimeout(marker);
		      } catch (e){
		          try {
		              // When we are in I.E. but the script has been evaled so I.E. doesn't  trust the global object when called normally
		              return cachedClearTimeout.call(null, marker);
		          } catch (e){
		              // same as above but when it's a version of I.E. that must have the global object for 'this', hopfully our context correct otherwise it will throw a global error.
		              // Some versions of I.E. have different rules for clearTimeout vs setTimeout
		              return cachedClearTimeout.call(this, marker);
		          }
		      }



		  }
		  var queue = [];
		  var draining = false;
		  var currentQueue;
		  var queueIndex = -1;

		  function cleanUpNextTick() {
		      if (!draining || !currentQueue) {
		          return;
		      }
		      draining = false;
		      if (currentQueue.length) {
		          queue = currentQueue.concat(queue);
		      } else {
		          queueIndex = -1;
		      }
		      if (queue.length) {
		          drainQueue();
		      }
		  }

		  function drainQueue() {
		      if (draining) {
		          return;
		      }
		      var timeout = runTimeout(cleanUpNextTick);
		      draining = true;

		      var len = queue.length;
		      while(len) {
		          currentQueue = queue;
		          queue = [];
		          while (++queueIndex < len) {
		              if (currentQueue) {
		                  currentQueue[queueIndex].run();
		              }
		          }
		          queueIndex = -1;
		          len = queue.length;
		      }
		      currentQueue = null;
		      draining = false;
		      runClearTimeout(timeout);
		  }
		  function nextTick(fun) {
		      var args = new Array(arguments.length - 1);
		      if (arguments.length > 1) {
		          for (var i = 1; i < arguments.length; i++) {
		              args[i - 1] = arguments[i];
		          }
		      }
		      queue.push(new Item(fun, args));
		      if (queue.length === 1 && !draining) {
		          runTimeout(drainQueue);
		      }
		  }
		  // v8 likes predictible objects
		  function Item(fun, array) {
		      this.fun = fun;
		      this.array = array;
		  }
		  Item.prototype.run = function () {
		      this.fun.apply(null, this.array);
		  };
		  var title = 'browser';
		  var platform = 'browser';
		  var browser$3 = true;
		  var env$1 = {};
		  var argv = [];
		  var version$2 = ''; // empty string to avoid regexp issues
		  var versions$2 = {};
		  var release = {};
		  var config$1 = {};

		  function noop$2() {}

		  var on = noop$2;
		  var addListener = noop$2;
		  var once$1 = noop$2;
		  var off = noop$2;
		  var removeListener = noop$2;
		  var removeAllListeners = noop$2;
		  var emit$1 = noop$2;

		  function binding(name) {
		      throw new Error('process.binding is not supported');
		  }

		  function cwd () { return '/' }
		  function chdir (dir) {
		      throw new Error('process.chdir is not supported');
		  }function umask() { return 0; }

		  // from https://github.com/kumavis/browser-process-hrtime/blob/master/index.js
		  var performance = global$1.performance || {};
		  var performanceNow =
		    performance.now        ||
		    performance.mozNow     ||
		    performance.msNow      ||
		    performance.oNow       ||
		    performance.webkitNow  ||
		    function(){ return (new Date()).getTime() };

		  // generate timestamp or delta
		  // see http://nodejs.org/api/process.html#process_process_hrtime
		  function hrtime(previousTimestamp){
		    var clocktime = performanceNow.call(performance)*1e-3;
		    var seconds = Math.floor(clocktime);
		    var nanoseconds = Math.floor((clocktime%1)*1e9);
		    if (previousTimestamp) {
		      seconds = seconds - previousTimestamp[0];
		      nanoseconds = nanoseconds - previousTimestamp[1];
		      if (nanoseconds<0) {
		        seconds--;
		        nanoseconds += 1e9;
		      }
		    }
		    return [seconds,nanoseconds]
		  }

		  var startTime = new Date();
		  function uptime() {
		    var currentTime = new Date();
		    var dif = currentTime - startTime;
		    return dif / 1000;
		  }

		  var browser$1$1 = {
		    nextTick: nextTick,
		    title: title,
		    browser: browser$3,
		    env: env$1,
		    argv: argv,
		    version: version$2,
		    versions: versions$2,
		    on: on,
		    addListener: addListener,
		    once: once$1,
		    off: off,
		    removeListener: removeListener,
		    removeAllListeners: removeAllListeners,
		    emit: emit$1,
		    binding: binding,
		    cwd: cwd,
		    chdir: chdir,
		    umask: umask,
		    hrtime: hrtime,
		    platform: platform,
		    release: release,
		    config: config$1,
		    uptime: uptime
		  };

		  var commonjsGlobal$1 = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof commonjsGlobal !== 'undefined' ? commonjsGlobal : typeof self !== 'undefined' ? self : {};

		  function getAugmentedNamespace(n) {
		    if (n.__esModule) return n;
		    var f = n.default;
		  	if (typeof f == "function") {
		  		var a = function a () {
		  			if (this instanceof a) {
		          return Reflect.construct(f, arguments, this.constructor);
		  			}
		  			return f.apply(this, arguments);
		  		};
		  		a.prototype = f.prototype;
		    } else a = {};
		    Object.defineProperty(a, '__esModule', {value: true});
		  	Object.keys(n).forEach(function (k) {
		  		var d = Object.getOwnPropertyDescriptor(n, k);
		  		Object.defineProperty(a, k, d.get ? d : {
		  			enumerable: true,
		  			get: function () {
		  				return n[k];
		  			}
		  		});
		  	});
		  	return a;
		  }

		  var toFastPropertiesBABEL_8_BREAKINGFalse;
		  var hasRequiredToFastPropertiesBABEL_8_BREAKINGFalse;
		  function requireToFastPropertiesBABEL_8_BREAKINGFalse() {
		    if (hasRequiredToFastPropertiesBABEL_8_BREAKINGFalse) return toFastPropertiesBABEL_8_BREAKINGFalse;
		    hasRequiredToFastPropertiesBABEL_8_BREAKINGFalse = 1;
		    var fastProto = null;
		    function FastObject(o) {
		      if (fastProto !== null && typeof fastProto.property) {
		        var result = fastProto;
		        fastProto = FastObject.prototype = null;
		        return result;
		      }
		      fastProto = FastObject.prototype = o == null ? Object.create(null) : o;
		      return new FastObject();
		    }
		    FastObject();
		    toFastPropertiesBABEL_8_BREAKINGFalse = function toFastproperties(o) {
		      return FastObject(o);
		    };
		    return toFastPropertiesBABEL_8_BREAKINGFalse;
		  }

		  function bool$c(value) {
		    if (value == null) return false;
		    return value && value !== "false" && value !== "0";
		  }
		  var toFastProperties = bool$c(browser$1$1.env["BABEL_8_BREAKING"]) ? requireToFastPropertiesBABEL_8_BREAKINGFalse() : requireToFastPropertiesBABEL_8_BREAKINGFalse();

		  function isType$2(nodeType, targetType) {
		    if (nodeType === targetType) return true;
		    if (nodeType == null) return false;
		    if (ALIAS_KEYS[targetType]) return false;
		    var aliases = FLIPPED_ALIAS_KEYS$3[targetType];
		    if (aliases) {
		      if (aliases[0] === nodeType) return true;
		      for (var _iterator = _createForOfIteratorHelperLoose(aliases), _step; !(_step = _iterator()).done;) {
		        var alias = _step.value;
		        if (nodeType === alias) return true;
		      }
		    }
		    return false;
		  }

		  function isPlaceholderType(placeholderType, targetType) {
		    if (placeholderType === targetType) return true;
		    var aliases = PLACEHOLDERS_ALIAS[placeholderType];
		    if (aliases) {
		      for (var _iterator = _createForOfIteratorHelperLoose(aliases), _step; !(_step = _iterator()).done;) {
		        var alias = _step.value;
		        if (targetType === alias) return true;
		      }
		    }
		    return false;
		  }

		  function is$1(type, node, opts) {
		    if (!node) return false;
		    var matches = isType$2(node.type, type);
		    if (!matches) {
		      if (!opts && node.type === "Placeholder" && type in FLIPPED_ALIAS_KEYS$3) {
		        return isPlaceholderType(node.expectedNode, type);
		      }
		      return false;
		    }
		    if (typeof opts === "undefined") {
		      return true;
		    } else {
		      return shallowEqual(node, opts);
		    }
		  }

		  var nonASCIIidentifierStartChars = "\xAA\xB5\xBA\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07CA-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09F0\u09F1\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B71\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D5F-\u0D61\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0EDC-\u0EDF\u0F00\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u1820-\u1878\u1880-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1950-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u1A00-\u1A16\u1A20-\u1A54\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B83-\u1BA0\u1BAE\u1BAF\u1BBA-\u1BE5\u1C00-\u1C23\u1C4D-\u1C4F\u1C5A-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2071\u207F\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2118-\u211D\u2124\u2126\u2128\u212A-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2160-\u2188\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309B-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u31A0-\u31BF\u31F0-\u31FF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA61F\uA62A\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA840-\uA873\uA882-\uA8B3\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA90A-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF\uA9E0-\uA9E4\uA9E6-\uA9EF\uA9FA-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC";
		  var nonASCIIidentifierChars = "\u200C\u200D\xB7\u0300-\u036F\u0387\u0483-\u0487\u0591-\u05BD\u05BF\u05C1\u05C2\u05C4\u05C5\u05C7\u0610-\u061A\u064B-\u0669\u0670\u06D6-\u06DC\u06DF-\u06E4\u06E7\u06E8\u06EA-\u06ED\u06F0-\u06F9\u0711\u0730-\u074A\u07A6-\u07B0\u07C0-\u07C9\u07EB-\u07F3\u07FD\u0816-\u0819\u081B-\u0823\u0825-\u0827\u0829-\u082D\u0859-\u085B\u0898-\u089F\u08CA-\u08E1\u08E3-\u0903\u093A-\u093C\u093E-\u094F\u0951-\u0957\u0962\u0963\u0966-\u096F\u0981-\u0983\u09BC\u09BE-\u09C4\u09C7\u09C8\u09CB-\u09CD\u09D7\u09E2\u09E3\u09E6-\u09EF\u09FE\u0A01-\u0A03\u0A3C\u0A3E-\u0A42\u0A47\u0A48\u0A4B-\u0A4D\u0A51\u0A66-\u0A71\u0A75\u0A81-\u0A83\u0ABC\u0ABE-\u0AC5\u0AC7-\u0AC9\u0ACB-\u0ACD\u0AE2\u0AE3\u0AE6-\u0AEF\u0AFA-\u0AFF\u0B01-\u0B03\u0B3C\u0B3E-\u0B44\u0B47\u0B48\u0B4B-\u0B4D\u0B55-\u0B57\u0B62\u0B63\u0B66-\u0B6F\u0B82\u0BBE-\u0BC2\u0BC6-\u0BC8\u0BCA-\u0BCD\u0BD7\u0BE6-\u0BEF\u0C00-\u0C04\u0C3C\u0C3E-\u0C44\u0C46-\u0C48\u0C4A-\u0C4D\u0C55\u0C56\u0C62\u0C63\u0C66-\u0C6F\u0C81-\u0C83\u0CBC\u0CBE-\u0CC4\u0CC6-\u0CC8\u0CCA-\u0CCD\u0CD5\u0CD6\u0CE2\u0CE3\u0CE6-\u0CEF\u0CF3\u0D00-\u0D03\u0D3B\u0D3C\u0D3E-\u0D44\u0D46-\u0D48\u0D4A-\u0D4D\u0D57\u0D62\u0D63\u0D66-\u0D6F\u0D81-\u0D83\u0DCA\u0DCF-\u0DD4\u0DD6\u0DD8-\u0DDF\u0DE6-\u0DEF\u0DF2\u0DF3\u0E31\u0E34-\u0E3A\u0E47-\u0E4E\u0E50-\u0E59\u0EB1\u0EB4-\u0EBC\u0EC8-\u0ECE\u0ED0-\u0ED9\u0F18\u0F19\u0F20-\u0F29\u0F35\u0F37\u0F39\u0F3E\u0F3F\u0F71-\u0F84\u0F86\u0F87\u0F8D-\u0F97\u0F99-\u0FBC\u0FC6\u102B-\u103E\u1040-\u1049\u1056-\u1059\u105E-\u1060\u1062-\u1064\u1067-\u106D\u1071-\u1074\u1082-\u108D\u108F-\u109D\u135D-\u135F\u1369-\u1371\u1712-\u1715\u1732-\u1734\u1752\u1753\u1772\u1773\u17B4-\u17D3\u17DD\u17E0-\u17E9\u180B-\u180D\u180F-\u1819\u18A9\u1920-\u192B\u1930-\u193B\u1946-\u194F\u19D0-\u19DA\u1A17-\u1A1B\u1A55-\u1A5E\u1A60-\u1A7C\u1A7F-\u1A89\u1A90-\u1A99\u1AB0-\u1ABD\u1ABF-\u1ACE\u1B00-\u1B04\u1B34-\u1B44\u1B50-\u1B59\u1B6B-\u1B73\u1B80-\u1B82\u1BA1-\u1BAD\u1BB0-\u1BB9\u1BE6-\u1BF3\u1C24-\u1C37\u1C40-\u1C49\u1C50-\u1C59\u1CD0-\u1CD2\u1CD4-\u1CE8\u1CED\u1CF4\u1CF7-\u1CF9\u1DC0-\u1DFF\u200C\u200D\u203F\u2040\u2054\u20D0-\u20DC\u20E1\u20E5-\u20F0\u2CEF-\u2CF1\u2D7F\u2DE0-\u2DFF\u302A-\u302F\u3099\u309A\u30FB\uA620-\uA629\uA66F\uA674-\uA67D\uA69E\uA69F\uA6F0\uA6F1\uA802\uA806\uA80B\uA823-\uA827\uA82C\uA880\uA881\uA8B4-\uA8C5\uA8D0-\uA8D9\uA8E0-\uA8F1\uA8FF-\uA909\uA926-\uA92D\uA947-\uA953\uA980-\uA983\uA9B3-\uA9C0\uA9D0-\uA9D9\uA9E5\uA9F0-\uA9F9\uAA29-\uAA36\uAA43\uAA4C\uAA4D\uAA50-\uAA59\uAA7B-\uAA7D\uAAB0\uAAB2-\uAAB4\uAAB7\uAAB8\uAABE\uAABF\uAAC1\uAAEB-\uAAEF\uAAF5\uAAF6\uABE3-\uABEA\uABEC\uABED\uABF0-\uABF9\uFB1E\uFE00-\uFE0F\uFE20-\uFE2F\uFE33\uFE34\uFE4D-\uFE4F\uFF10-\uFF19\uFF3F\uFF65";
		  var nonASCIIidentifierStart = new RegExp("[" + nonASCIIidentifierStartChars + "]");
		  var nonASCIIidentifier = new RegExp("[" + nonASCIIidentifierStartChars + nonASCIIidentifierChars + "]");
		  nonASCIIidentifierStartChars = nonASCIIidentifierChars = null;
		  var astralIdentifierStartCodes = [0, 11, 2, 25, 2, 18, 2, 1, 2, 14, 3, 13, 35, 122, 70, 52, 268, 28, 4, 48, 48, 31, 14, 29, 6, 37, 11, 29, 3, 35, 5, 7, 2, 4, 43, 157, 19, 35, 5, 35, 5, 39, 9, 51, 13, 10, 2, 14, 2, 6, 2, 1, 2, 10, 2, 14, 2, 6, 2, 1, 68, 310, 10, 21, 11, 7, 25, 5, 2, 41, 2, 8, 70, 5, 3, 0, 2, 43, 2, 1, 4, 0, 3, 22, 11, 22, 10, 30, 66, 18, 2, 1, 11, 21, 11, 25, 71, 55, 7, 1, 65, 0, 16, 3, 2, 2, 2, 28, 43, 28, 4, 28, 36, 7, 2, 27, 28, 53, 11, 21, 11, 18, 14, 17, 111, 72, 56, 50, 14, 50, 14, 35, 349, 41, 7, 1, 79, 28, 11, 0, 9, 21, 43, 17, 47, 20, 28, 22, 13, 52, 58, 1, 3, 0, 14, 44, 33, 24, 27, 35, 30, 0, 3, 0, 9, 34, 4, 0, 13, 47, 15, 3, 22, 0, 2, 0, 36, 17, 2, 24, 20, 1, 64, 6, 2, 0, 2, 3, 2, 14, 2, 9, 8, 46, 39, 7, 3, 1, 3, 21, 2, 6, 2, 1, 2, 4, 4, 0, 19, 0, 13, 4, 159, 52, 19, 3, 21, 2, 31, 47, 21, 1, 2, 0, 185, 46, 42, 3, 37, 47, 21, 0, 60, 42, 14, 0, 72, 26, 38, 6, 186, 43, 117, 63, 32, 7, 3, 0, 3, 7, 2, 1, 2, 23, 16, 0, 2, 0, 95, 7, 3, 38, 17, 0, 2, 0, 29, 0, 11, 39, 8, 0, 22, 0, 12, 45, 20, 0, 19, 72, 264, 8, 2, 36, 18, 0, 50, 29, 113, 6, 2, 1, 2, 37, 22, 0, 26, 5, 2, 1, 2, 31, 15, 0, 328, 18, 16, 0, 2, 12, 2, 33, 125, 0, 80, 921, 103, 110, 18, 195, 2637, 96, 16, 1071, 18, 5, 4026, 582, 8634, 568, 8, 30, 18, 78, 18, 29, 19, 47, 17, 3, 32, 20, 6, 18, 689, 63, 129, 74, 6, 0, 67, 12, 65, 1, 2, 0, 29, 6135, 9, 1237, 43, 8, 8936, 3, 2, 6, 2, 1, 2, 290, 16, 0, 30, 2, 3, 0, 15, 3, 9, 395, 2309, 106, 6, 12, 4, 8, 8, 9, 5991, 84, 2, 70, 2, 1, 3, 0, 3, 1, 3, 3, 2, 11, 2, 0, 2, 6, 2, 64, 2, 3, 3, 7, 2, 6, 2, 27, 2, 3, 2, 4, 2, 0, 4, 6, 2, 339, 3, 24, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 7, 1845, 30, 7, 5, 262, 61, 147, 44, 11, 6, 17, 0, 322, 29, 19, 43, 485, 27, 757, 6, 2, 3, 2, 1, 2, 14, 2, 196, 60, 67, 8, 0, 1205, 3, 2, 26, 2, 1, 2, 0, 3, 0, 2, 9, 2, 3, 2, 0, 2, 0, 7, 0, 5, 0, 2, 0, 2, 0, 2, 2, 2, 1, 2, 0, 3, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 1, 2, 0, 3, 3, 2, 6, 2, 3, 2, 3, 2, 0, 2, 9, 2, 16, 6, 2, 2, 4, 2, 16, 4421, 42719, 33, 4153, 7, 221, 3, 5761, 15, 7472, 16, 621, 2467, 541, 1507, 4938, 6, 4191];
		  var astralIdentifierCodes = [509, 0, 227, 0, 150, 4, 294, 9, 1368, 2, 2, 1, 6, 3, 41, 2, 5, 0, 166, 1, 574, 3, 9, 9, 370, 1, 81, 2, 71, 10, 50, 3, 123, 2, 54, 14, 32, 10, 3, 1, 11, 3, 46, 10, 8, 0, 46, 9, 7, 2, 37, 13, 2, 9, 6, 1, 45, 0, 13, 2, 49, 13, 9, 3, 2, 11, 83, 11, 7, 0, 3, 0, 158, 11, 6, 9, 7, 3, 56, 1, 2, 6, 3, 1, 3, 2, 10, 0, 11, 1, 3, 6, 4, 4, 193, 17, 10, 9, 5, 0, 82, 19, 13, 9, 214, 6, 3, 8, 28, 1, 83, 16, 16, 9, 82, 12, 9, 9, 84, 14, 5, 9, 243, 14, 166, 9, 71, 5, 2, 1, 3, 3, 2, 0, 2, 1, 13, 9, 120, 6, 3, 6, 4, 0, 29, 9, 41, 6, 2, 3, 9, 0, 10, 10, 47, 15, 406, 7, 2, 7, 17, 9, 57, 21, 2, 13, 123, 5, 4, 0, 2, 1, 2, 6, 2, 0, 9, 9, 49, 4, 2, 1, 2, 4, 9, 9, 330, 3, 10, 1, 2, 0, 49, 6, 4, 4, 14, 9, 5351, 0, 7, 14, 13835, 9, 87, 9, 39, 4, 60, 6, 26, 9, 1014, 0, 2, 54, 8, 3, 82, 0, 12, 1, 19628, 1, 4706, 45, 3, 22, 543, 4, 4, 5, 9, 7, 3, 6, 31, 3, 149, 2, 1418, 49, 513, 54, 5, 49, 9, 0, 15, 0, 23, 4, 2, 14, 1361, 6, 2, 16, 3, 6, 2, 1, 2, 4, 101, 0, 161, 6, 10, 9, 357, 0, 62, 13, 499, 13, 983, 6, 110, 6, 6, 9, 4759, 9, 787719, 239];
		  function isInAstralSet(code, set) {
		    var pos = 0x10000;
		    for (var i = 0, length = set.length; i < length; i += 2) {
		      pos += set[i];
		      if (pos > code) return false;
		      pos += set[i + 1];
		      if (pos >= code) return true;
		    }
		    return false;
		  }
		  function isIdentifierStart(code) {
		    if (code < 65) return code === 36;
		    if (code <= 90) return true;
		    if (code < 97) return code === 95;
		    if (code <= 122) return true;
		    if (code <= 0xffff) {
		      return code >= 0xaa && nonASCIIidentifierStart.test(String.fromCharCode(code));
		    }
		    return isInAstralSet(code, astralIdentifierStartCodes);
		  }
		  function isIdentifierChar(code) {
		    if (code < 48) return code === 36;
		    if (code < 58) return true;
		    if (code < 65) return false;
		    if (code <= 90) return true;
		    if (code < 97) return code === 95;
		    if (code <= 122) return true;
		    if (code <= 0xffff) {
		      return code >= 0xaa && nonASCIIidentifier.test(String.fromCharCode(code));
		    }
		    return isInAstralSet(code, astralIdentifierStartCodes) || isInAstralSet(code, astralIdentifierCodes);
		  }
		  function isIdentifierName(name) {
		    var isFirst = true;
		    for (var i = 0; i < name.length; i++) {
		      var cp = name.charCodeAt(i);
		      if ((cp & 0xfc00) === 0xd800 && i + 1 < name.length) {
		        var trail = name.charCodeAt(++i);
		        if ((trail & 0xfc00) === 0xdc00) {
		          cp = 0x10000 + ((cp & 0x3ff) << 10) + (trail & 0x3ff);
		        }
		      }
		      if (isFirst) {
		        isFirst = false;
		        if (!isIdentifierStart(cp)) {
		          return false;
		        }
		      } else if (!isIdentifierChar(cp)) {
		        return false;
		      }
		    }
		    return !isFirst;
		  }

		  var reservedWords = {
		    keyword: ["break", "case", "catch", "continue", "debugger", "default", "do", "else", "finally", "for", "function", "if", "return", "switch", "throw", "try", "var", "const", "while", "with", "new", "this", "super", "class", "extends", "export", "import", "null", "true", "false", "in", "instanceof", "typeof", "void", "delete"],
		    strict: ["implements", "interface", "let", "package", "private", "protected", "public", "static", "yield"],
		    strictBind: ["eval", "arguments"]
		  };
		  var keywords$1 = new Set(reservedWords.keyword);
		  var reservedWordsStrictSet = new Set(reservedWords.strict);
		  var reservedWordsStrictBindSet = new Set(reservedWords.strictBind);
		  function isReservedWord(word, inModule) {
		    return inModule && word === "await" || word === "enum";
		  }
		  function isStrictReservedWord(word, inModule) {
		    return isReservedWord(word, inModule) || reservedWordsStrictSet.has(word);
		  }
		  function isStrictBindOnlyReservedWord(word) {
		    return reservedWordsStrictBindSet.has(word);
		  }
		  function isStrictBindReservedWord(word, inModule) {
		    return isStrictReservedWord(word, inModule) || isStrictBindOnlyReservedWord(word);
		  }
		  function isKeyword(word) {
		    return keywords$1.has(word);
		  }

		  function isValidIdentifier$1(name, reserved) {
		    if (reserved === void 0) {
		      reserved = true;
		    }
		    if (typeof name !== "string") return false;
		    if (reserved) {
		      if (isKeyword(name) || isStrictReservedWord(name, true)) {
		        return false;
		      }
		    }
		    return isIdentifierName(name);
		  }

		  var _isDigit = function isDigit(code) {
		    return code >= 48 && code <= 57;
		  };
		  var forbiddenNumericSeparatorSiblings = {
		    decBinOct: new Set([46, 66, 69, 79, 95, 98, 101, 111]),
		    hex: new Set([46, 88, 95, 120])
		  };
		  var isAllowedNumericSeparatorSibling = {
		    bin: function bin(ch) {
		      return ch === 48 || ch === 49;
		    },
		    oct: function oct(ch) {
		      return ch >= 48 && ch <= 55;
		    },
		    dec: function dec(ch) {
		      return ch >= 48 && ch <= 57;
		    },
		    hex: function hex(ch) {
		      return ch >= 48 && ch <= 57 || ch >= 65 && ch <= 70 || ch >= 97 && ch <= 102;
		    }
		  };
		  function readStringContents(type, input, pos, lineStart, curLine, errors) {
		    var initialPos = pos;
		    var initialLineStart = lineStart;
		    var initialCurLine = curLine;
		    var out = "";
		    var firstInvalidLoc = null;
		    var chunkStart = pos;
		    var length = input.length;
		    for (;;) {
		      if (pos >= length) {
		        errors.unterminated(initialPos, initialLineStart, initialCurLine);
		        out += input.slice(chunkStart, pos);
		        break;
		      }
		      var ch = input.charCodeAt(pos);
		      if (isStringEnd(type, ch, input, pos)) {
		        out += input.slice(chunkStart, pos);
		        break;
		      }
		      if (ch === 92) {
		        out += input.slice(chunkStart, pos);
		        var res = readEscapedChar(input, pos, lineStart, curLine, type === "template", errors);
		        if (res.ch === null && !firstInvalidLoc) {
		          firstInvalidLoc = {
		            pos: pos,
		            lineStart: lineStart,
		            curLine: curLine
		          };
		        } else {
		          out += res.ch;
		        }
		        pos = res.pos;
		        lineStart = res.lineStart;
		        curLine = res.curLine;
		        chunkStart = pos;
		      } else if (ch === 8232 || ch === 8233) {
		        ++pos;
		        ++curLine;
		        lineStart = pos;
		      } else if (ch === 10 || ch === 13) {
		        if (type === "template") {
		          out += input.slice(chunkStart, pos) + "\n";
		          ++pos;
		          if (ch === 13 && input.charCodeAt(pos) === 10) {
		            ++pos;
		          }
		          ++curLine;
		          chunkStart = lineStart = pos;
		        } else {
		          errors.unterminated(initialPos, initialLineStart, initialCurLine);
		        }
		      } else {
		        ++pos;
		      }
		    }
		    return {
		      pos: pos,
		      str: out,
		      firstInvalidLoc: firstInvalidLoc,
		      lineStart: lineStart,
		      curLine: curLine,
		      containsInvalid: !!firstInvalidLoc
		    };
		  }
		  function isStringEnd(type, ch, input, pos) {
		    if (type === "template") {
		      return ch === 96 || ch === 36 && input.charCodeAt(pos + 1) === 123;
		    }
		    return ch === (type === "double" ? 34 : 39);
		  }
		  function readEscapedChar(input, pos, lineStart, curLine, inTemplate, errors) {
		    var throwOnInvalid = !inTemplate;
		    pos++;
		    var res = function res(ch) {
		      return {
		        pos: pos,
		        ch: ch,
		        lineStart: lineStart,
		        curLine: curLine
		      };
		    };
		    var ch = input.charCodeAt(pos++);
		    switch (ch) {
		      case 110:
		        return res("\n");
		      case 114:
		        return res("\r");
		      case 120:
		        {
		          var code;
		          var _readHexChar = readHexChar(input, pos, lineStart, curLine, 2, false, throwOnInvalid, errors);
		          code = _readHexChar.code;
		          pos = _readHexChar.pos;
		          return res(code === null ? null : String.fromCharCode(code));
		        }
		      case 117:
		        {
		          var _code;
		          var _readCodePoint = readCodePoint(input, pos, lineStart, curLine, throwOnInvalid, errors);
		          _code = _readCodePoint.code;
		          pos = _readCodePoint.pos;
		          return res(_code === null ? null : String.fromCodePoint(_code));
		        }
		      case 116:
		        return res("\t");
		      case 98:
		        return res("\b");
		      case 118:
		        return res("\x0B");
		      case 102:
		        return res("\f");
		      case 13:
		        if (input.charCodeAt(pos) === 10) {
		          ++pos;
		        }
		      case 10:
		        lineStart = pos;
		        ++curLine;
		      case 8232:
		      case 8233:
		        return res("");
		      case 56:
		      case 57:
		        if (inTemplate) {
		          return res(null);
		        } else {
		          errors.strictNumericEscape(pos - 1, lineStart, curLine);
		        }
		      default:
		        if (ch >= 48 && ch <= 55) {
		          var startPos = pos - 1;
		          var match = input.slice(startPos, pos + 2).match(/^[0-7]+/);
		          var octalStr = match[0];
		          var octal = parseInt(octalStr, 8);
		          if (octal > 255) {
		            octalStr = octalStr.slice(0, -1);
		            octal = parseInt(octalStr, 8);
		          }
		          pos += octalStr.length - 1;
		          var next = input.charCodeAt(pos);
		          if (octalStr !== "0" || next === 56 || next === 57) {
		            if (inTemplate) {
		              return res(null);
		            } else {
		              errors.strictNumericEscape(startPos, lineStart, curLine);
		            }
		          }
		          return res(String.fromCharCode(octal));
		        }
		        return res(String.fromCharCode(ch));
		    }
		  }
		  function readHexChar(input, pos, lineStart, curLine, len, forceLen, throwOnInvalid, errors) {
		    var initialPos = pos;
		    var n;
		    var _readInt = readInt(input, pos, lineStart, curLine, 16, len, forceLen, false, errors, !throwOnInvalid);
		    n = _readInt.n;
		    pos = _readInt.pos;
		    if (n === null) {
		      if (throwOnInvalid) {
		        errors.invalidEscapeSequence(initialPos, lineStart, curLine);
		      } else {
		        pos = initialPos - 1;
		      }
		    }
		    return {
		      code: n,
		      pos: pos
		    };
		  }
		  function readInt(input, pos, lineStart, curLine, radix, len, forceLen, allowNumSeparator, errors, bailOnError) {
		    var start = pos;
		    var forbiddenSiblings = radix === 16 ? forbiddenNumericSeparatorSiblings.hex : forbiddenNumericSeparatorSiblings.decBinOct;
		    var isAllowedSibling = radix === 16 ? isAllowedNumericSeparatorSibling.hex : radix === 10 ? isAllowedNumericSeparatorSibling.dec : radix === 8 ? isAllowedNumericSeparatorSibling.oct : isAllowedNumericSeparatorSibling.bin;
		    var invalid = false;
		    var total = 0;
		    for (var i = 0, e = len == null ? Infinity : len; i < e; ++i) {
		      var code = input.charCodeAt(pos);
		      var val = void 0;
		      if (code === 95 && allowNumSeparator !== "bail") {
		        var prev = input.charCodeAt(pos - 1);
		        var next = input.charCodeAt(pos + 1);
		        if (!allowNumSeparator) {
		          if (bailOnError) return {
		            n: null,
		            pos: pos
		          };
		          errors.numericSeparatorInEscapeSequence(pos, lineStart, curLine);
		        } else if (Number.isNaN(next) || !isAllowedSibling(next) || forbiddenSiblings.has(prev) || forbiddenSiblings.has(next)) {
		          if (bailOnError) return {
		            n: null,
		            pos: pos
		          };
		          errors.unexpectedNumericSeparator(pos, lineStart, curLine);
		        }
		        ++pos;
		        continue;
		      }
		      if (code >= 97) {
		        val = code - 97 + 10;
		      } else if (code >= 65) {
		        val = code - 65 + 10;
		      } else if (_isDigit(code)) {
		        val = code - 48;
		      } else {
		        val = Infinity;
		      }
		      if (val >= radix) {
		        if (val <= 9 && bailOnError) {
		          return {
		            n: null,
		            pos: pos
		          };
		        } else if (val <= 9 && errors.invalidDigit(pos, lineStart, curLine, radix)) {
		          val = 0;
		        } else if (forceLen) {
		          val = 0;
		          invalid = true;
		        } else {
		          break;
		        }
		      }
		      ++pos;
		      total = total * radix + val;
		    }
		    if (pos === start || len != null && pos - start !== len || invalid) {
		      return {
		        n: null,
		        pos: pos
		      };
		    }
		    return {
		      n: total,
		      pos: pos
		    };
		  }
		  function readCodePoint(input, pos, lineStart, curLine, throwOnInvalid, errors) {
		    var ch = input.charCodeAt(pos);
		    var code;
		    if (ch === 123) {
		      ++pos;
		      var _readHexChar2 = readHexChar(input, pos, lineStart, curLine, input.indexOf("}", pos) - pos, true, throwOnInvalid, errors);
		      code = _readHexChar2.code;
		      pos = _readHexChar2.pos;
		      ++pos;
		      if (code !== null && code > 0x10ffff) {
		        if (throwOnInvalid) {
		          errors.invalidCodePoint(pos, lineStart, curLine);
		        } else {
		          return {
		            code: null,
		            pos: pos
		          };
		        }
		      }
		    } else {
		      var _readHexChar3 = readHexChar(input, pos, lineStart, curLine, 4, false, throwOnInvalid, errors);
		      code = _readHexChar3.code;
		      pos = _readHexChar3.pos;
		    }
		    return {
		      code: code,
		      pos: pos
		    };
		  }

		  var STATEMENT_OR_BLOCK_KEYS$1 = ["consequent", "body", "alternate"];
		  var FLATTENABLE_KEYS = ["body", "expressions"];
		  var FOR_INIT_KEYS = ["left", "init"];
		  var COMMENT_KEYS = ["leadingComments", "trailingComments", "innerComments"];
		  var LOGICAL_OPERATORS$3 = ["||", "&&", "??"];
		  var UPDATE_OPERATORS = ["++", "--"];
		  var BOOLEAN_NUMBER_BINARY_OPERATORS$1 = [">", "<", ">=", "<="];
		  var EQUALITY_BINARY_OPERATORS = ["==", "===", "!=", "!=="];
		  var COMPARISON_BINARY_OPERATORS = [].concat(EQUALITY_BINARY_OPERATORS, ["in", "instanceof"]);
		  var BOOLEAN_BINARY_OPERATORS$1 = [].concat(_toConsumableArray(COMPARISON_BINARY_OPERATORS), BOOLEAN_NUMBER_BINARY_OPERATORS$1);
		  var NUMBER_BINARY_OPERATORS$1 = ["-", "/", "%", "*", "**", "&", "|", ">>", ">>>", "<<", "^"];
		  var BINARY_OPERATORS = ["+"].concat(NUMBER_BINARY_OPERATORS$1, _toConsumableArray(BOOLEAN_BINARY_OPERATORS$1), ["|>"]);
		  var ASSIGNMENT_OPERATORS = ["=", "+="].concat(_toConsumableArray(NUMBER_BINARY_OPERATORS$1.map(function (op) {
		    return op + "=";
		  })), _toConsumableArray(LOGICAL_OPERATORS$3.map(function (op) {
		    return op + "=";
		  })));
		  var BOOLEAN_UNARY_OPERATORS$1 = ["delete", "!"];
		  var NUMBER_UNARY_OPERATORS$1 = ["+", "-", "~"];
		  var STRING_UNARY_OPERATORS$1 = ["typeof"];
		  var UNARY_OPERATORS = ["void", "throw"].concat(BOOLEAN_UNARY_OPERATORS$1, NUMBER_UNARY_OPERATORS$1, STRING_UNARY_OPERATORS$1);
		  var INHERIT_KEYS = {
		    optional: ["typeAnnotation", "typeParameters", "returnType"],
		    force: ["start", "loc", "end"]
		  };
		  var BLOCK_SCOPED_SYMBOL = Symbol["for"]("var used to be block scoped");
		  var NOT_LOCAL_BINDING$2 = Symbol["for"]("should not be considered a local binding");

		  var VISITOR_KEYS$5 = {};
		  var ALIAS_KEYS = {};
		  var FLIPPED_ALIAS_KEYS$3 = {};
		  var NODE_FIELDS = {};
		  var BUILDER_KEYS = {};
		  var DEPRECATED_KEYS$1 = {};
		  var NODE_PARENT_VALIDATIONS = {};
		  function getType$1(val) {
		    if (Array.isArray(val)) {
		      return "array";
		    } else if (val === null) {
		      return "null";
		    } else {
		      return typeof val;
		    }
		  }
		  function validate$6(validate) {
		    return {
		      validate: validate
		    };
		  }
		  function typeIs(typeName) {
		    return typeof typeName === "string" ? assertNodeType(typeName) : assertNodeType.apply(void 0, _toConsumableArray(typeName));
		  }
		  function validateType(typeName) {
		    return validate$6(typeIs(typeName));
		  }
		  function validateOptional(validate) {
		    return {
		      validate: validate,
		      optional: true
		    };
		  }
		  function validateOptionalType(typeName) {
		    return {
		      validate: typeIs(typeName),
		      optional: true
		    };
		  }
		  function arrayOf(elementType) {
		    return chain$1(assertValueType("array"), assertEach(elementType));
		  }
		  function arrayOfType(typeName) {
		    return arrayOf(typeIs(typeName));
		  }
		  function validateArrayOfType(typeName) {
		    return validate$6(arrayOfType(typeName));
		  }
		  function assertEach(callback) {
		    function validator(node, key, val) {
		      if (!Array.isArray(val)) return;
		      for (var i = 0; i < val.length; i++) {
		        var subkey = key + "[" + i + "]";
		        var v = val[i];
		        callback(node, subkey, v);
		        if (browser$1$1.env.BABEL_TYPES_8_BREAKING) validateChild(node, subkey, v);
		      }
		    }
		    validator.each = callback;
		    return validator;
		  }
		  function assertOneOf() {
		    for (var _len = arguments.length, values = new Array(_len), _key = 0; _key < _len; _key++) {
		      values[_key] = arguments[_key];
		    }
		    function validate(node, key, val) {
		      if (values.indexOf(val) < 0) {
		        throw new TypeError("Property " + key + " expected value to be one of " + JSON.stringify(values) + " but got " + JSON.stringify(val));
		      }
		    }
		    validate.oneOf = values;
		    return validate;
		  }
		  function assertNodeType() {
		    for (var _len2 = arguments.length, types = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
		      types[_key2] = arguments[_key2];
		    }
		    function validate(node, key, val) {
		      for (var _iterator = _createForOfIteratorHelperLoose(types), _step; !(_step = _iterator()).done;) {
		        var type = _step.value;
		        if (is$1(type, val)) {
		          validateChild(node, key, val);
		          return;
		        }
		      }
		      throw new TypeError("Property " + key + " of " + node.type + " expected node to be of a type " + JSON.stringify(types) + " but instead got " + JSON.stringify(val == null ? void 0 : val.type));
		    }
		    validate.oneOfNodeTypes = types;
		    return validate;
		  }
		  function assertNodeOrValueType() {
		    for (var _len3 = arguments.length, types = new Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
		      types[_key3] = arguments[_key3];
		    }
		    function validate(node, key, val) {
		      for (var _iterator2 = _createForOfIteratorHelperLoose(types), _step2; !(_step2 = _iterator2()).done;) {
		        var type = _step2.value;
		        if (getType$1(val) === type || is$1(type, val)) {
		          validateChild(node, key, val);
		          return;
		        }
		      }
		      throw new TypeError("Property " + key + " of " + node.type + " expected node to be of a type " + JSON.stringify(types) + " but instead got " + JSON.stringify(val == null ? void 0 : val.type));
		    }
		    validate.oneOfNodeOrValueTypes = types;
		    return validate;
		  }
		  function assertValueType(type) {
		    function validate(node, key, val) {
		      var valid = getType$1(val) === type;
		      if (!valid) {
		        throw new TypeError("Property " + key + " expected type of " + type + " but got " + getType$1(val));
		      }
		    }
		    validate.type = type;
		    return validate;
		  }
		  function assertShape(shape) {
		    function validate(node, key, val) {
		      var errors = [];
		      for (var _i = 0, _Object$keys = Object.keys(shape); _i < _Object$keys.length; _i++) {
		        var property = _Object$keys[_i];
		        try {
		          validateField(node, property, val[property], shape[property]);
		        } catch (error) {
		          if (error instanceof TypeError) {
		            errors.push(error.message);
		            continue;
		          }
		          throw error;
		        }
		      }
		      if (errors.length) {
		        throw new TypeError("Property " + key + " of " + node.type + " expected to have the following:\n" + errors.join("\n"));
		      }
		    }
		    validate.shapeOf = shape;
		    return validate;
		  }
		  function assertOptionalChainStart() {
		    function validate(node) {
		      var _current2;
		      var current = node;
		      while (node) {
		        var _current = current,
		          type = _current.type;
		        if (type === "OptionalCallExpression") {
		          if (current.optional) return;
		          current = current.callee;
		          continue;
		        }
		        if (type === "OptionalMemberExpression") {
		          if (current.optional) return;
		          current = current.object;
		          continue;
		        }
		        break;
		      }
		      throw new TypeError("Non-optional " + node.type + " must chain from an optional OptionalMemberExpression or OptionalCallExpression. Found chain from " + ((_current2 = current) == null ? void 0 : _current2.type));
		    }
		    return validate;
		  }
		  function chain$1() {
		    for (var _len4 = arguments.length, fns = new Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
		      fns[_key4] = arguments[_key4];
		    }
		    function validate() {
		      for (var _iterator3 = _createForOfIteratorHelperLoose(fns), _step3; !(_step3 = _iterator3()).done;) {
		        var fn = _step3.value;
		        fn.apply(void 0, arguments);
		      }
		    }
		    validate.chainOf = fns;
		    if (fns.length >= 2 && "type" in fns[0] && fns[0].type === "array" && !("each" in fns[1])) {
		      throw new Error("An assertValueType(\"array\") validator can only be followed by an assertEach(...) validator.");
		    }
		    return validate;
		  }
		  var validTypeOpts = ["aliases", "builder", "deprecatedAlias", "fields", "inherits", "visitor", "validate"];
		  var validFieldKeys = ["default", "optional", "deprecated", "validate"];
		  var store = {};
		  function defineAliasedType() {
		    for (var _len5 = arguments.length, aliases = new Array(_len5), _key5 = 0; _key5 < _len5; _key5++) {
		      aliases[_key5] = arguments[_key5];
		    }
		    return function (type, opts) {
		      var _defined2;
		      if (opts === void 0) {
		        opts = {};
		      }
		      var defined = opts.aliases;
		      if (!defined) {
		        var _store$opts$inherits$, _defined;
		        if (opts.inherits) defined = (_store$opts$inherits$ = store[opts.inherits].aliases) == null ? void 0 : _store$opts$inherits$.slice();
		        (_defined = defined) != null ? _defined : defined = [];
		        opts.aliases = defined;
		      }
		      var additional = aliases.filter(function (a) {
		        return !defined.includes(a);
		      });
		      (_defined2 = defined).unshift.apply(_defined2, _toConsumableArray(additional));
		      defineType$5(type, opts);
		    };
		  }
		  function defineType$5(type, opts) {
		    if (opts === void 0) {
		      opts = {};
		    }
		    var inherits = opts.inherits && store[opts.inherits] || {};
		    var fields = opts.fields;
		    if (!fields) {
		      fields = {};
		      if (inherits.fields) {
		        var keys = Object.getOwnPropertyNames(inherits.fields);
		        for (var _iterator4 = _createForOfIteratorHelperLoose(keys), _step4; !(_step4 = _iterator4()).done;) {
		          var _key6 = _step4.value;
		          var field = inherits.fields[_key6];
		          var def = field["default"];
		          if (Array.isArray(def) ? def.length > 0 : def && typeof def === "object") {
		            throw new Error("field defaults can only be primitives or empty arrays currently");
		          }
		          fields[_key6] = {
		            "default": Array.isArray(def) ? [] : def,
		            optional: field.optional,
		            deprecated: field.deprecated,
		            validate: field.validate
		          };
		        }
		      }
		    }
		    var visitor = opts.visitor || inherits.visitor || [];
		    var aliases = opts.aliases || inherits.aliases || [];
		    var builder = opts.builder || inherits.builder || opts.visitor || [];
		    for (var _i2 = 0, _Object$keys2 = Object.keys(opts); _i2 < _Object$keys2.length; _i2++) {
		      var k = _Object$keys2[_i2];
		      if (validTypeOpts.indexOf(k) === -1) {
		        throw new Error("Unknown type option \"" + k + "\" on " + type);
		      }
		    }
		    if (opts.deprecatedAlias) {
		      DEPRECATED_KEYS$1[opts.deprecatedAlias] = type;
		    }
		    for (var _iterator5 = _createForOfIteratorHelperLoose(visitor.concat(builder)), _step5; !(_step5 = _iterator5()).done;) {
		      var _key8 = _step5.value;
		      fields[_key8] = fields[_key8] || {};
		    }
		    for (var _i3 = 0, _Object$keys3 = Object.keys(fields); _i3 < _Object$keys3.length; _i3++) {
		      var _key7 = _Object$keys3[_i3];
		      var _field = fields[_key7];
		      if (_field["default"] !== undefined && builder.indexOf(_key7) === -1) {
		        _field.optional = true;
		      }
		      if (_field["default"] === undefined) {
		        _field["default"] = null;
		      } else if (!_field.validate && _field["default"] != null) {
		        _field.validate = assertValueType(getType$1(_field["default"]));
		      }
		      for (var _i4 = 0, _Object$keys4 = Object.keys(_field); _i4 < _Object$keys4.length; _i4++) {
		        var _k = _Object$keys4[_i4];
		        if (validFieldKeys.indexOf(_k) === -1) {
		          throw new Error("Unknown field key \"" + _k + "\" on " + type + "." + _key7);
		        }
		      }
		    }
		    VISITOR_KEYS$5[type] = opts.visitor = visitor;
		    BUILDER_KEYS[type] = opts.builder = builder;
		    NODE_FIELDS[type] = opts.fields = fields;
		    ALIAS_KEYS[type] = opts.aliases = aliases;
		    aliases.forEach(function (alias) {
		      FLIPPED_ALIAS_KEYS$3[alias] = FLIPPED_ALIAS_KEYS$3[alias] || [];
		      FLIPPED_ALIAS_KEYS$3[alias].push(type);
		    });
		    if (opts.validate) {
		      NODE_PARENT_VALIDATIONS[type] = opts.validate;
		    }
		    store[type] = opts;
		  }

		  var defineType$4 = defineAliasedType("Standardized");
		  defineType$4("ArrayExpression", {
		    fields: {
		      elements: {
		        validate: chain$1(assertValueType("array"), assertEach(assertNodeOrValueType("null", "Expression", "SpreadElement"))),
		        "default": !browser$1$1.env.BABEL_TYPES_8_BREAKING ? [] : undefined
		      }
		    },
		    visitor: ["elements"],
		    aliases: ["Expression"]
		  });
		  defineType$4("AssignmentExpression", {
		    fields: {
		      operator: {
		        validate: function () {
		          if (!browser$1$1.env.BABEL_TYPES_8_BREAKING) {
		            return assertValueType("string");
		          }
		          var identifier = assertOneOf.apply(void 0, _toConsumableArray(ASSIGNMENT_OPERATORS));
		          var pattern = assertOneOf("=");
		          return function (node, key, val) {
		            var validator = is$1("Pattern", node.left) ? pattern : identifier;
		            validator(node, key, val);
		          };
		        }()
		      },
		      left: {
		        validate: !browser$1$1.env.BABEL_TYPES_8_BREAKING ? assertNodeType("LVal", "OptionalMemberExpression") : assertNodeType("Identifier", "MemberExpression", "OptionalMemberExpression", "ArrayPattern", "ObjectPattern", "TSAsExpression", "TSSatisfiesExpression", "TSTypeAssertion", "TSNonNullExpression")
		      },
		      right: {
		        validate: assertNodeType("Expression")
		      }
		    },
		    builder: ["operator", "left", "right"],
		    visitor: ["left", "right"],
		    aliases: ["Expression"]
		  });
		  defineType$4("BinaryExpression", {
		    builder: ["operator", "left", "right"],
		    fields: {
		      operator: {
		        validate: assertOneOf.apply(void 0, _toConsumableArray(BINARY_OPERATORS))
		      },
		      left: {
		        validate: function () {
		          var expression = assertNodeType("Expression");
		          var inOp = assertNodeType("Expression", "PrivateName");
		          var validator = Object.assign(function (node, key, val) {
		            var validator = node.operator === "in" ? inOp : expression;
		            validator(node, key, val);
		          }, {
		            oneOfNodeTypes: ["Expression", "PrivateName"]
		          });
		          return validator;
		        }()
		      },
		      right: {
		        validate: assertNodeType("Expression")
		      }
		    },
		    visitor: ["left", "right"],
		    aliases: ["Binary", "Expression"]
		  });
		  defineType$4("InterpreterDirective", {
		    builder: ["value"],
		    fields: {
		      value: {
		        validate: assertValueType("string")
		      }
		    }
		  });
		  defineType$4("Directive", {
		    visitor: ["value"],
		    fields: {
		      value: {
		        validate: assertNodeType("DirectiveLiteral")
		      }
		    }
		  });
		  defineType$4("DirectiveLiteral", {
		    builder: ["value"],
		    fields: {
		      value: {
		        validate: assertValueType("string")
		      }
		    }
		  });
		  defineType$4("BlockStatement", {
		    builder: ["body", "directives"],
		    visitor: ["directives", "body"],
		    fields: {
		      directives: {
		        validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Directive"))),
		        "default": []
		      },
		      body: {
		        validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Statement")))
		      }
		    },
		    aliases: ["Scopable", "BlockParent", "Block", "Statement"]
		  });
		  defineType$4("BreakStatement", {
		    visitor: ["label"],
		    fields: {
		      label: {
		        validate: assertNodeType("Identifier"),
		        optional: true
		      }
		    },
		    aliases: ["Statement", "Terminatorless", "CompletionStatement"]
		  });
		  defineType$4("CallExpression", {
		    visitor: ["callee", "arguments", "typeParameters", "typeArguments"],
		    builder: ["callee", "arguments"],
		    aliases: ["Expression"],
		    fields: Object.assign({
		      callee: {
		        validate: assertNodeType("Expression", "Super", "V8IntrinsicIdentifier")
		      },
		      arguments: {
		        validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Expression", "SpreadElement", "ArgumentPlaceholder")))
		      }
		    }, !browser$1$1.env.BABEL_TYPES_8_BREAKING ? {
		      optional: {
		        validate: assertOneOf(true, false),
		        optional: true
		      }
		    } : {}, {
		      typeArguments: {
		        validate: assertNodeType("TypeParameterInstantiation"),
		        optional: true
		      },
		      typeParameters: {
		        validate: assertNodeType("TSTypeParameterInstantiation"),
		        optional: true
		      }
		    })
		  });
		  defineType$4("CatchClause", {
		    visitor: ["param", "body"],
		    fields: {
		      param: {
		        validate: assertNodeType("Identifier", "ArrayPattern", "ObjectPattern"),
		        optional: true
		      },
		      body: {
		        validate: assertNodeType("BlockStatement")
		      }
		    },
		    aliases: ["Scopable", "BlockParent"]
		  });
		  defineType$4("ConditionalExpression", {
		    visitor: ["test", "consequent", "alternate"],
		    fields: {
		      test: {
		        validate: assertNodeType("Expression")
		      },
		      consequent: {
		        validate: assertNodeType("Expression")
		      },
		      alternate: {
		        validate: assertNodeType("Expression")
		      }
		    },
		    aliases: ["Expression", "Conditional"]
		  });
		  defineType$4("ContinueStatement", {
		    visitor: ["label"],
		    fields: {
		      label: {
		        validate: assertNodeType("Identifier"),
		        optional: true
		      }
		    },
		    aliases: ["Statement", "Terminatorless", "CompletionStatement"]
		  });
		  defineType$4("DebuggerStatement", {
		    aliases: ["Statement"]
		  });
		  defineType$4("DoWhileStatement", {
		    visitor: ["test", "body"],
		    fields: {
		      test: {
		        validate: assertNodeType("Expression")
		      },
		      body: {
		        validate: assertNodeType("Statement")
		      }
		    },
		    aliases: ["Statement", "BlockParent", "Loop", "While", "Scopable"]
		  });
		  defineType$4("EmptyStatement", {
		    aliases: ["Statement"]
		  });
		  defineType$4("ExpressionStatement", {
		    visitor: ["expression"],
		    fields: {
		      expression: {
		        validate: assertNodeType("Expression")
		      }
		    },
		    aliases: ["Statement", "ExpressionWrapper"]
		  });
		  defineType$4("File", {
		    builder: ["program", "comments", "tokens"],
		    visitor: ["program"],
		    fields: {
		      program: {
		        validate: assertNodeType("Program")
		      },
		      comments: {
		        validate: !browser$1$1.env.BABEL_TYPES_8_BREAKING ? Object.assign(function () {}, {
		          each: {
		            oneOfNodeTypes: ["CommentBlock", "CommentLine"]
		          }
		        }) : assertEach(assertNodeType("CommentBlock", "CommentLine")),
		        optional: true
		      },
		      tokens: {
		        validate: assertEach(Object.assign(function () {}, {
		          type: "any"
		        })),
		        optional: true
		      }
		    }
		  });
		  defineType$4("ForInStatement", {
		    visitor: ["left", "right", "body"],
		    aliases: ["Scopable", "Statement", "For", "BlockParent", "Loop", "ForXStatement"],
		    fields: {
		      left: {
		        validate: !browser$1$1.env.BABEL_TYPES_8_BREAKING ? assertNodeType("VariableDeclaration", "LVal") : assertNodeType("VariableDeclaration", "Identifier", "MemberExpression", "ArrayPattern", "ObjectPattern", "TSAsExpression", "TSSatisfiesExpression", "TSTypeAssertion", "TSNonNullExpression")
		      },
		      right: {
		        validate: assertNodeType("Expression")
		      },
		      body: {
		        validate: assertNodeType("Statement")
		      }
		    }
		  });
		  defineType$4("ForStatement", {
		    visitor: ["init", "test", "update", "body"],
		    aliases: ["Scopable", "Statement", "For", "BlockParent", "Loop"],
		    fields: {
		      init: {
		        validate: assertNodeType("VariableDeclaration", "Expression"),
		        optional: true
		      },
		      test: {
		        validate: assertNodeType("Expression"),
		        optional: true
		      },
		      update: {
		        validate: assertNodeType("Expression"),
		        optional: true
		      },
		      body: {
		        validate: assertNodeType("Statement")
		      }
		    }
		  });
		  var functionCommon = function functionCommon() {
		    return {
		      params: {
		        validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Identifier", "Pattern", "RestElement")))
		      },
		      generator: {
		        "default": false
		      },
		      async: {
		        "default": false
		      }
		    };
		  };
		  var functionTypeAnnotationCommon = function functionTypeAnnotationCommon() {
		    return {
		      returnType: {
		        validate: assertNodeType("TypeAnnotation", "TSTypeAnnotation", "Noop"),
		        optional: true
		      },
		      typeParameters: {
		        validate: assertNodeType("TypeParameterDeclaration", "TSTypeParameterDeclaration", "Noop"),
		        optional: true
		      }
		    };
		  };
		  var functionDeclarationCommon = function functionDeclarationCommon() {
		    return Object.assign({}, functionCommon(), {
		      declare: {
		        validate: assertValueType("boolean"),
		        optional: true
		      },
		      id: {
		        validate: assertNodeType("Identifier"),
		        optional: true
		      }
		    });
		  };
		  defineType$4("FunctionDeclaration", {
		    builder: ["id", "params", "body", "generator", "async"],
		    visitor: ["id", "params", "body", "returnType", "typeParameters"],
		    fields: Object.assign({}, functionDeclarationCommon(), functionTypeAnnotationCommon(), {
		      body: {
		        validate: assertNodeType("BlockStatement")
		      },
		      predicate: {
		        validate: assertNodeType("DeclaredPredicate", "InferredPredicate"),
		        optional: true
		      }
		    }),
		    aliases: ["Scopable", "Function", "BlockParent", "FunctionParent", "Statement", "Pureish", "Declaration"],
		    validate: function () {
		      if (!browser$1$1.env.BABEL_TYPES_8_BREAKING) return function () {};
		      var identifier = assertNodeType("Identifier");
		      return function (parent, key, node) {
		        if (!is$1("ExportDefaultDeclaration", parent)) {
		          identifier(node, "id", node.id);
		        }
		      };
		    }()
		  });
		  defineType$4("FunctionExpression", {
		    inherits: "FunctionDeclaration",
		    aliases: ["Scopable", "Function", "BlockParent", "FunctionParent", "Expression", "Pureish"],
		    fields: Object.assign({}, functionCommon(), functionTypeAnnotationCommon(), {
		      id: {
		        validate: assertNodeType("Identifier"),
		        optional: true
		      },
		      body: {
		        validate: assertNodeType("BlockStatement")
		      },
		      predicate: {
		        validate: assertNodeType("DeclaredPredicate", "InferredPredicate"),
		        optional: true
		      }
		    })
		  });
		  var patternLikeCommon = function patternLikeCommon() {
		    return {
		      typeAnnotation: {
		        validate: assertNodeType("TypeAnnotation", "TSTypeAnnotation", "Noop"),
		        optional: true
		      },
		      optional: {
		        validate: assertValueType("boolean"),
		        optional: true
		      },
		      decorators: {
		        validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Decorator"))),
		        optional: true
		      }
		    };
		  };
		  defineType$4("Identifier", {
		    builder: ["name"],
		    visitor: ["typeAnnotation", "decorators"],
		    aliases: ["Expression", "PatternLike", "LVal", "TSEntityName"],
		    fields: Object.assign({}, patternLikeCommon(), {
		      name: {
		        validate: chain$1(assertValueType("string"), Object.assign(function (node, key, val) {
		          if (!browser$1$1.env.BABEL_TYPES_8_BREAKING) return;
		          if (!isValidIdentifier$1(val, false)) {
		            throw new TypeError("\"" + val + "\" is not a valid identifier name");
		          }
		        }, {
		          type: "string"
		        }))
		      }
		    }),
		    validate: function validate(parent, key, node) {
		      if (!browser$1$1.env.BABEL_TYPES_8_BREAKING) return;
		      var match = /\.(\w+)$/.exec(key);
		      if (!match) return;
		      var _match = _slicedToArray(match, 2),
		        parentKey = _match[1];
		      var nonComp = {
		        computed: false
		      };
		      if (parentKey === "property") {
		        if (is$1("MemberExpression", parent, nonComp)) return;
		        if (is$1("OptionalMemberExpression", parent, nonComp)) return;
		      } else if (parentKey === "key") {
		        if (is$1("Property", parent, nonComp)) return;
		        if (is$1("Method", parent, nonComp)) return;
		      } else if (parentKey === "exported") {
		        if (is$1("ExportSpecifier", parent)) return;
		      } else if (parentKey === "imported") {
		        if (is$1("ImportSpecifier", parent, {
		          imported: node
		        })) return;
		      } else if (parentKey === "meta") {
		        if (is$1("MetaProperty", parent, {
		          meta: node
		        })) return;
		      }
		      if ((isKeyword(node.name) || isReservedWord(node.name, false)) && node.name !== "this") {
		        throw new TypeError("\"" + node.name + "\" is not a valid identifier");
		      }
		    }
		  });
		  defineType$4("IfStatement", {
		    visitor: ["test", "consequent", "alternate"],
		    aliases: ["Statement", "Conditional"],
		    fields: {
		      test: {
		        validate: assertNodeType("Expression")
		      },
		      consequent: {
		        validate: assertNodeType("Statement")
		      },
		      alternate: {
		        optional: true,
		        validate: assertNodeType("Statement")
		      }
		    }
		  });
		  defineType$4("LabeledStatement", {
		    visitor: ["label", "body"],
		    aliases: ["Statement"],
		    fields: {
		      label: {
		        validate: assertNodeType("Identifier")
		      },
		      body: {
		        validate: assertNodeType("Statement")
		      }
		    }
		  });
		  defineType$4("StringLiteral", {
		    builder: ["value"],
		    fields: {
		      value: {
		        validate: assertValueType("string")
		      }
		    },
		    aliases: ["Expression", "Pureish", "Literal", "Immutable"]
		  });
		  defineType$4("NumericLiteral", {
		    builder: ["value"],
		    deprecatedAlias: "NumberLiteral",
		    fields: {
		      value: {
		        validate: chain$1(assertValueType("number"), Object.assign(function (node, key, val) {
		        }, {
		          type: "number"
		        }))
		      }
		    },
		    aliases: ["Expression", "Pureish", "Literal", "Immutable"]
		  });
		  defineType$4("NullLiteral", {
		    aliases: ["Expression", "Pureish", "Literal", "Immutable"]
		  });
		  defineType$4("BooleanLiteral", {
		    builder: ["value"],
		    fields: {
		      value: {
		        validate: assertValueType("boolean")
		      }
		    },
		    aliases: ["Expression", "Pureish", "Literal", "Immutable"]
		  });
		  defineType$4("RegExpLiteral", {
		    builder: ["pattern", "flags"],
		    deprecatedAlias: "RegexLiteral",
		    aliases: ["Expression", "Pureish", "Literal"],
		    fields: {
		      pattern: {
		        validate: assertValueType("string")
		      },
		      flags: {
		        validate: chain$1(assertValueType("string"), Object.assign(function (node, key, val) {
		          if (!browser$1$1.env.BABEL_TYPES_8_BREAKING) return;
		          var invalid = /[^gimsuy]/.exec(val);
		          if (invalid) {
		            throw new TypeError("\"" + invalid[0] + "\" is not a valid RegExp flag");
		          }
		        }, {
		          type: "string"
		        })),
		        "default": ""
		      }
		    }
		  });
		  defineType$4("LogicalExpression", {
		    builder: ["operator", "left", "right"],
		    visitor: ["left", "right"],
		    aliases: ["Binary", "Expression"],
		    fields: {
		      operator: {
		        validate: assertOneOf.apply(void 0, _toConsumableArray(LOGICAL_OPERATORS$3))
		      },
		      left: {
		        validate: assertNodeType("Expression")
		      },
		      right: {
		        validate: assertNodeType("Expression")
		      }
		    }
		  });
		  defineType$4("MemberExpression", {
		    builder: ["object", "property", "computed"].concat(_toConsumableArray(!browser$1$1.env.BABEL_TYPES_8_BREAKING ? ["optional"] : [])),
		    visitor: ["object", "property"],
		    aliases: ["Expression", "LVal"],
		    fields: Object.assign({
		      object: {
		        validate: assertNodeType("Expression", "Super")
		      },
		      property: {
		        validate: function () {
		          var normal = assertNodeType("Identifier", "PrivateName");
		          var computed = assertNodeType("Expression");
		          var validator = function validator(node, key, val) {
		            var validator = node.computed ? computed : normal;
		            validator(node, key, val);
		          };
		          validator.oneOfNodeTypes = ["Expression", "Identifier", "PrivateName"];
		          return validator;
		        }()
		      },
		      computed: {
		        "default": false
		      }
		    }, !browser$1$1.env.BABEL_TYPES_8_BREAKING ? {
		      optional: {
		        validate: assertOneOf(true, false),
		        optional: true
		      }
		    } : {})
		  });
		  defineType$4("NewExpression", {
		    inherits: "CallExpression"
		  });
		  defineType$4("Program", {
		    visitor: ["directives", "body"],
		    builder: ["body", "directives", "sourceType", "interpreter"],
		    fields: {
		      sourceType: {
		        validate: assertOneOf("script", "module"),
		        "default": "script"
		      },
		      interpreter: {
		        validate: assertNodeType("InterpreterDirective"),
		        "default": null,
		        optional: true
		      },
		      directives: {
		        validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Directive"))),
		        "default": []
		      },
		      body: {
		        validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Statement")))
		      }
		    },
		    aliases: ["Scopable", "BlockParent", "Block"]
		  });
		  defineType$4("ObjectExpression", {
		    visitor: ["properties"],
		    aliases: ["Expression"],
		    fields: {
		      properties: {
		        validate: chain$1(assertValueType("array"), assertEach(assertNodeType("ObjectMethod", "ObjectProperty", "SpreadElement")))
		      }
		    }
		  });
		  defineType$4("ObjectMethod", {
		    builder: ["kind", "key", "params", "body", "computed", "generator", "async"],
		    fields: Object.assign({}, functionCommon(), functionTypeAnnotationCommon(), {
		      kind: Object.assign({
		        validate: assertOneOf("method", "get", "set")
		      }, !browser$1$1.env.BABEL_TYPES_8_BREAKING ? {
		        "default": "method"
		      } : {}),
		      computed: {
		        "default": false
		      },
		      key: {
		        validate: function () {
		          var normal = assertNodeType("Identifier", "StringLiteral", "NumericLiteral", "BigIntLiteral");
		          var computed = assertNodeType("Expression");
		          var validator = function validator(node, key, val) {
		            var validator = node.computed ? computed : normal;
		            validator(node, key, val);
		          };
		          validator.oneOfNodeTypes = ["Expression", "Identifier", "StringLiteral", "NumericLiteral", "BigIntLiteral"];
		          return validator;
		        }()
		      },
		      decorators: {
		        validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Decorator"))),
		        optional: true
		      },
		      body: {
		        validate: assertNodeType("BlockStatement")
		      }
		    }),
		    visitor: ["key", "params", "body", "decorators", "returnType", "typeParameters"],
		    aliases: ["UserWhitespacable", "Function", "Scopable", "BlockParent", "FunctionParent", "Method", "ObjectMember"]
		  });
		  defineType$4("ObjectProperty", {
		    builder: ["key", "value", "computed", "shorthand"].concat(_toConsumableArray(!browser$1$1.env.BABEL_TYPES_8_BREAKING ? ["decorators"] : [])),
		    fields: {
		      computed: {
		        "default": false
		      },
		      key: {
		        validate: function () {
		          var normal = assertNodeType("Identifier", "StringLiteral", "NumericLiteral", "BigIntLiteral", "DecimalLiteral", "PrivateName");
		          var computed = assertNodeType("Expression");
		          var validator = Object.assign(function (node, key, val) {
		            var validator = node.computed ? computed : normal;
		            validator(node, key, val);
		          }, {
		            oneOfNodeTypes: ["Expression", "Identifier", "StringLiteral", "NumericLiteral", "BigIntLiteral", "DecimalLiteral", "PrivateName"]
		          });
		          return validator;
		        }()
		      },
		      value: {
		        validate: assertNodeType("Expression", "PatternLike")
		      },
		      shorthand: {
		        validate: chain$1(assertValueType("boolean"), Object.assign(function (node, key, val) {
		          if (!browser$1$1.env.BABEL_TYPES_8_BREAKING) return;
		          if (val && node.computed) {
		            throw new TypeError("Property shorthand of ObjectProperty cannot be true if computed is true");
		          }
		        }, {
		          type: "boolean"
		        }), function (node, key, val) {
		          if (!browser$1$1.env.BABEL_TYPES_8_BREAKING) return;
		          if (val && !is$1("Identifier", node.key)) {
		            throw new TypeError("Property shorthand of ObjectProperty cannot be true if key is not an Identifier");
		          }
		        }),
		        "default": false
		      },
		      decorators: {
		        validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Decorator"))),
		        optional: true
		      }
		    },
		    visitor: ["key", "value", "decorators"],
		    aliases: ["UserWhitespacable", "Property", "ObjectMember"],
		    validate: function () {
		      var pattern = assertNodeType("Identifier", "Pattern", "TSAsExpression", "TSSatisfiesExpression", "TSNonNullExpression", "TSTypeAssertion");
		      var expression = assertNodeType("Expression");
		      return function (parent, key, node) {
		        if (!browser$1$1.env.BABEL_TYPES_8_BREAKING) return;
		        var validator = is$1("ObjectPattern", parent) ? pattern : expression;
		        validator(node, "value", node.value);
		      };
		    }()
		  });
		  defineType$4("RestElement", {
		    visitor: ["argument", "typeAnnotation"],
		    builder: ["argument"],
		    aliases: ["LVal", "PatternLike"],
		    deprecatedAlias: "RestProperty",
		    fields: Object.assign({}, patternLikeCommon(), {
		      argument: {
		        validate: !browser$1$1.env.BABEL_TYPES_8_BREAKING ? assertNodeType("LVal") : assertNodeType("Identifier", "ArrayPattern", "ObjectPattern", "MemberExpression", "TSAsExpression", "TSSatisfiesExpression", "TSTypeAssertion", "TSNonNullExpression")
		      }
		    }),
		    validate: function validate(parent, key) {
		      if (!browser$1$1.env.BABEL_TYPES_8_BREAKING) return;
		      var match = /(\w+)\[(\d+)\]/.exec(key);
		      if (!match) throw new Error("Internal Babel error: malformed key.");
		      var _ref = match,
		        _ref2 = _slicedToArray(_ref, 3),
		        listKey = _ref2[1],
		        index = _ref2[2];
		      if (parent[listKey].length > +index + 1) {
		        throw new TypeError("RestElement must be last element of " + listKey);
		      }
		    }
		  });
		  defineType$4("ReturnStatement", {
		    visitor: ["argument"],
		    aliases: ["Statement", "Terminatorless", "CompletionStatement"],
		    fields: {
		      argument: {
		        validate: assertNodeType("Expression"),
		        optional: true
		      }
		    }
		  });
		  defineType$4("SequenceExpression", {
		    visitor: ["expressions"],
		    fields: {
		      expressions: {
		        validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Expression")))
		      }
		    },
		    aliases: ["Expression"]
		  });
		  defineType$4("ParenthesizedExpression", {
		    visitor: ["expression"],
		    aliases: ["Expression", "ExpressionWrapper"],
		    fields: {
		      expression: {
		        validate: assertNodeType("Expression")
		      }
		    }
		  });
		  defineType$4("SwitchCase", {
		    visitor: ["test", "consequent"],
		    fields: {
		      test: {
		        validate: assertNodeType("Expression"),
		        optional: true
		      },
		      consequent: {
		        validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Statement")))
		      }
		    }
		  });
		  defineType$4("SwitchStatement", {
		    visitor: ["discriminant", "cases"],
		    aliases: ["Statement", "BlockParent", "Scopable"],
		    fields: {
		      discriminant: {
		        validate: assertNodeType("Expression")
		      },
		      cases: {
		        validate: chain$1(assertValueType("array"), assertEach(assertNodeType("SwitchCase")))
		      }
		    }
		  });
		  defineType$4("ThisExpression", {
		    aliases: ["Expression"]
		  });
		  defineType$4("ThrowStatement", {
		    visitor: ["argument"],
		    aliases: ["Statement", "Terminatorless", "CompletionStatement"],
		    fields: {
		      argument: {
		        validate: assertNodeType("Expression")
		      }
		    }
		  });
		  defineType$4("TryStatement", {
		    visitor: ["block", "handler", "finalizer"],
		    aliases: ["Statement"],
		    fields: {
		      block: {
		        validate: chain$1(assertNodeType("BlockStatement"), Object.assign(function (node) {
		          if (!browser$1$1.env.BABEL_TYPES_8_BREAKING) return;
		          if (!node.handler && !node.finalizer) {
		            throw new TypeError("TryStatement expects either a handler or finalizer, or both");
		          }
		        }, {
		          oneOfNodeTypes: ["BlockStatement"]
		        }))
		      },
		      handler: {
		        optional: true,
		        validate: assertNodeType("CatchClause")
		      },
		      finalizer: {
		        optional: true,
		        validate: assertNodeType("BlockStatement")
		      }
		    }
		  });
		  defineType$4("UnaryExpression", {
		    builder: ["operator", "argument", "prefix"],
		    fields: {
		      prefix: {
		        "default": true
		      },
		      argument: {
		        validate: assertNodeType("Expression")
		      },
		      operator: {
		        validate: assertOneOf.apply(void 0, _toConsumableArray(UNARY_OPERATORS))
		      }
		    },
		    visitor: ["argument"],
		    aliases: ["UnaryLike", "Expression"]
		  });
		  defineType$4("UpdateExpression", {
		    builder: ["operator", "argument", "prefix"],
		    fields: {
		      prefix: {
		        "default": false
		      },
		      argument: {
		        validate: !browser$1$1.env.BABEL_TYPES_8_BREAKING ? assertNodeType("Expression") : assertNodeType("Identifier", "MemberExpression")
		      },
		      operator: {
		        validate: assertOneOf.apply(void 0, _toConsumableArray(UPDATE_OPERATORS))
		      }
		    },
		    visitor: ["argument"],
		    aliases: ["Expression"]
		  });
		  defineType$4("VariableDeclaration", {
		    builder: ["kind", "declarations"],
		    visitor: ["declarations"],
		    aliases: ["Statement", "Declaration"],
		    fields: {
		      declare: {
		        validate: assertValueType("boolean"),
		        optional: true
		      },
		      kind: {
		        validate: assertOneOf("var", "let", "const", "using", "await using")
		      },
		      declarations: {
		        validate: chain$1(assertValueType("array"), assertEach(assertNodeType("VariableDeclarator")))
		      }
		    },
		    validate: function validate(parent, key, node) {
		      if (!browser$1$1.env.BABEL_TYPES_8_BREAKING) return;
		      if (!is$1("ForXStatement", parent, {
		        left: node
		      })) return;
		      if (node.declarations.length !== 1) {
		        throw new TypeError("Exactly one VariableDeclarator is required in the VariableDeclaration of a " + parent.type);
		      }
		    }
		  });
		  defineType$4("VariableDeclarator", {
		    visitor: ["id", "init"],
		    fields: {
		      id: {
		        validate: function () {
		          if (!browser$1$1.env.BABEL_TYPES_8_BREAKING) {
		            return assertNodeType("LVal");
		          }
		          var normal = assertNodeType("Identifier", "ArrayPattern", "ObjectPattern");
		          var without = assertNodeType("Identifier");
		          return function (node, key, val) {
		            var validator = node.init ? normal : without;
		            validator(node, key, val);
		          };
		        }()
		      },
		      definite: {
		        optional: true,
		        validate: assertValueType("boolean")
		      },
		      init: {
		        optional: true,
		        validate: assertNodeType("Expression")
		      }
		    }
		  });
		  defineType$4("WhileStatement", {
		    visitor: ["test", "body"],
		    aliases: ["Statement", "BlockParent", "Loop", "While", "Scopable"],
		    fields: {
		      test: {
		        validate: assertNodeType("Expression")
		      },
		      body: {
		        validate: assertNodeType("Statement")
		      }
		    }
		  });
		  defineType$4("WithStatement", {
		    visitor: ["object", "body"],
		    aliases: ["Statement"],
		    fields: {
		      object: {
		        validate: assertNodeType("Expression")
		      },
		      body: {
		        validate: assertNodeType("Statement")
		      }
		    }
		  });
		  defineType$4("AssignmentPattern", {
		    visitor: ["left", "right", "decorators"],
		    builder: ["left", "right"],
		    aliases: ["Pattern", "PatternLike", "LVal"],
		    fields: Object.assign({}, patternLikeCommon(), {
		      left: {
		        validate: assertNodeType("Identifier", "ObjectPattern", "ArrayPattern", "MemberExpression", "TSAsExpression", "TSSatisfiesExpression", "TSTypeAssertion", "TSNonNullExpression")
		      },
		      right: {
		        validate: assertNodeType("Expression")
		      },
		      decorators: {
		        validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Decorator"))),
		        optional: true
		      }
		    })
		  });
		  defineType$4("ArrayPattern", {
		    visitor: ["elements", "typeAnnotation"],
		    builder: ["elements"],
		    aliases: ["Pattern", "PatternLike", "LVal"],
		    fields: Object.assign({}, patternLikeCommon(), {
		      elements: {
		        validate: chain$1(assertValueType("array"), assertEach(assertNodeOrValueType("null", "PatternLike", "LVal")))
		      }
		    })
		  });
		  defineType$4("ArrowFunctionExpression", {
		    builder: ["params", "body", "async"],
		    visitor: ["params", "body", "returnType", "typeParameters"],
		    aliases: ["Scopable", "Function", "BlockParent", "FunctionParent", "Expression", "Pureish"],
		    fields: Object.assign({}, functionCommon(), functionTypeAnnotationCommon(), {
		      expression: {
		        validate: assertValueType("boolean")
		      },
		      body: {
		        validate: assertNodeType("BlockStatement", "Expression")
		      },
		      predicate: {
		        validate: assertNodeType("DeclaredPredicate", "InferredPredicate"),
		        optional: true
		      }
		    })
		  });
		  defineType$4("ClassBody", {
		    visitor: ["body"],
		    fields: {
		      body: {
		        validate: chain$1(assertValueType("array"), assertEach(assertNodeType("ClassMethod", "ClassPrivateMethod", "ClassProperty", "ClassPrivateProperty", "ClassAccessorProperty", "TSDeclareMethod", "TSIndexSignature", "StaticBlock")))
		      }
		    }
		  });
		  defineType$4("ClassExpression", {
		    builder: ["id", "superClass", "body", "decorators"],
		    visitor: ["id", "body", "superClass", "mixins", "typeParameters", "superTypeParameters", "implements", "decorators"],
		    aliases: ["Scopable", "Class", "Expression"],
		    fields: {
		      id: {
		        validate: assertNodeType("Identifier"),
		        optional: true
		      },
		      typeParameters: {
		        validate: assertNodeType("TypeParameterDeclaration", "TSTypeParameterDeclaration", "Noop"),
		        optional: true
		      },
		      body: {
		        validate: assertNodeType("ClassBody")
		      },
		      superClass: {
		        optional: true,
		        validate: assertNodeType("Expression")
		      },
		      superTypeParameters: {
		        validate: assertNodeType("TypeParameterInstantiation", "TSTypeParameterInstantiation"),
		        optional: true
		      },
		      "implements": {
		        validate: chain$1(assertValueType("array"), assertEach(assertNodeType("TSExpressionWithTypeArguments", "ClassImplements"))),
		        optional: true
		      },
		      decorators: {
		        validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Decorator"))),
		        optional: true
		      },
		      mixins: {
		        validate: assertNodeType("InterfaceExtends"),
		        optional: true
		      }
		    }
		  });
		  defineType$4("ClassDeclaration", {
		    inherits: "ClassExpression",
		    aliases: ["Scopable", "Class", "Statement", "Declaration"],
		    fields: {
		      id: {
		        validate: assertNodeType("Identifier"),
		        optional: true
		      },
		      typeParameters: {
		        validate: assertNodeType("TypeParameterDeclaration", "TSTypeParameterDeclaration", "Noop"),
		        optional: true
		      },
		      body: {
		        validate: assertNodeType("ClassBody")
		      },
		      superClass: {
		        optional: true,
		        validate: assertNodeType("Expression")
		      },
		      superTypeParameters: {
		        validate: assertNodeType("TypeParameterInstantiation", "TSTypeParameterInstantiation"),
		        optional: true
		      },
		      "implements": {
		        validate: chain$1(assertValueType("array"), assertEach(assertNodeType("TSExpressionWithTypeArguments", "ClassImplements"))),
		        optional: true
		      },
		      decorators: {
		        validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Decorator"))),
		        optional: true
		      },
		      mixins: {
		        validate: assertNodeType("InterfaceExtends"),
		        optional: true
		      },
		      declare: {
		        validate: assertValueType("boolean"),
		        optional: true
		      },
		      "abstract": {
		        validate: assertValueType("boolean"),
		        optional: true
		      }
		    },
		    validate: function () {
		      var identifier = assertNodeType("Identifier");
		      return function (parent, key, node) {
		        if (!browser$1$1.env.BABEL_TYPES_8_BREAKING) return;
		        if (!is$1("ExportDefaultDeclaration", parent)) {
		          identifier(node, "id", node.id);
		        }
		      };
		    }()
		  });
		  defineType$4("ExportAllDeclaration", {
		    builder: ["source"],
		    visitor: ["source", "attributes", "assertions"],
		    aliases: ["Statement", "Declaration", "ImportOrExportDeclaration", "ExportDeclaration"],
		    fields: {
		      source: {
		        validate: assertNodeType("StringLiteral")
		      },
		      exportKind: validateOptional(assertOneOf("type", "value")),
		      attributes: {
		        optional: true,
		        validate: chain$1(assertValueType("array"), assertEach(assertNodeType("ImportAttribute")))
		      },
		      assertions: {
		        optional: true,
		        validate: chain$1(assertValueType("array"), assertEach(assertNodeType("ImportAttribute")))
		      }
		    }
		  });
		  defineType$4("ExportDefaultDeclaration", {
		    visitor: ["declaration"],
		    aliases: ["Statement", "Declaration", "ImportOrExportDeclaration", "ExportDeclaration"],
		    fields: {
		      declaration: {
		        validate: assertNodeType("TSDeclareFunction", "FunctionDeclaration", "ClassDeclaration", "Expression")
		      },
		      exportKind: validateOptional(assertOneOf("value"))
		    }
		  });
		  defineType$4("ExportNamedDeclaration", {
		    builder: ["declaration", "specifiers", "source"],
		    visitor: ["declaration", "specifiers", "source", "attributes", "assertions"],
		    aliases: ["Statement", "Declaration", "ImportOrExportDeclaration", "ExportDeclaration"],
		    fields: {
		      declaration: {
		        optional: true,
		        validate: chain$1(assertNodeType("Declaration"), Object.assign(function (node, key, val) {
		          if (!browser$1$1.env.BABEL_TYPES_8_BREAKING) return;
		          if (val && node.specifiers.length) {
		            throw new TypeError("Only declaration or specifiers is allowed on ExportNamedDeclaration");
		          }
		        }, {
		          oneOfNodeTypes: ["Declaration"]
		        }), function (node, key, val) {
		          if (!browser$1$1.env.BABEL_TYPES_8_BREAKING) return;
		          if (val && node.source) {
		            throw new TypeError("Cannot export a declaration from a source");
		          }
		        })
		      },
		      attributes: {
		        optional: true,
		        validate: chain$1(assertValueType("array"), assertEach(assertNodeType("ImportAttribute")))
		      },
		      assertions: {
		        optional: true,
		        validate: chain$1(assertValueType("array"), assertEach(assertNodeType("ImportAttribute")))
		      },
		      specifiers: {
		        "default": [],
		        validate: chain$1(assertValueType("array"), assertEach(function () {
		          var sourced = assertNodeType("ExportSpecifier", "ExportDefaultSpecifier", "ExportNamespaceSpecifier");
		          var sourceless = assertNodeType("ExportSpecifier");
		          if (!browser$1$1.env.BABEL_TYPES_8_BREAKING) return sourced;
		          return function (node, key, val) {
		            var validator = node.source ? sourced : sourceless;
		            validator(node, key, val);
		          };
		        }()))
		      },
		      source: {
		        validate: assertNodeType("StringLiteral"),
		        optional: true
		      },
		      exportKind: validateOptional(assertOneOf("type", "value"))
		    }
		  });
		  defineType$4("ExportSpecifier", {
		    visitor: ["local", "exported"],
		    aliases: ["ModuleSpecifier"],
		    fields: {
		      local: {
		        validate: assertNodeType("Identifier")
		      },
		      exported: {
		        validate: assertNodeType("Identifier", "StringLiteral")
		      },
		      exportKind: {
		        validate: assertOneOf("type", "value"),
		        optional: true
		      }
		    }
		  });
		  defineType$4("ForOfStatement", {
		    visitor: ["left", "right", "body"],
		    builder: ["left", "right", "body", "await"],
		    aliases: ["Scopable", "Statement", "For", "BlockParent", "Loop", "ForXStatement"],
		    fields: {
		      left: {
		        validate: function () {
		          if (!browser$1$1.env.BABEL_TYPES_8_BREAKING) {
		            return assertNodeType("VariableDeclaration", "LVal");
		          }
		          var declaration = assertNodeType("VariableDeclaration");
		          var lval = assertNodeType("Identifier", "MemberExpression", "ArrayPattern", "ObjectPattern", "TSAsExpression", "TSSatisfiesExpression", "TSTypeAssertion", "TSNonNullExpression");
		          return function (node, key, val) {
		            if (is$1("VariableDeclaration", val)) {
		              declaration(node, key, val);
		            } else {
		              lval(node, key, val);
		            }
		          };
		        }()
		      },
		      right: {
		        validate: assertNodeType("Expression")
		      },
		      body: {
		        validate: assertNodeType("Statement")
		      },
		      "await": {
		        "default": false
		      }
		    }
		  });
		  defineType$4("ImportDeclaration", {
		    builder: ["specifiers", "source"],
		    visitor: ["specifiers", "source", "attributes", "assertions"],
		    aliases: ["Statement", "Declaration", "ImportOrExportDeclaration"],
		    fields: {
		      attributes: {
		        optional: true,
		        validate: chain$1(assertValueType("array"), assertEach(assertNodeType("ImportAttribute")))
		      },
		      assertions: {
		        optional: true,
		        validate: chain$1(assertValueType("array"), assertEach(assertNodeType("ImportAttribute")))
		      },
		      module: {
		        optional: true,
		        validate: assertValueType("boolean")
		      },
		      phase: {
		        "default": null,
		        validate: assertOneOf("source", "defer")
		      },
		      specifiers: {
		        validate: chain$1(assertValueType("array"), assertEach(assertNodeType("ImportSpecifier", "ImportDefaultSpecifier", "ImportNamespaceSpecifier")))
		      },
		      source: {
		        validate: assertNodeType("StringLiteral")
		      },
		      importKind: {
		        validate: assertOneOf("type", "typeof", "value"),
		        optional: true
		      }
		    }
		  });
		  defineType$4("ImportDefaultSpecifier", {
		    visitor: ["local"],
		    aliases: ["ModuleSpecifier"],
		    fields: {
		      local: {
		        validate: assertNodeType("Identifier")
		      }
		    }
		  });
		  defineType$4("ImportNamespaceSpecifier", {
		    visitor: ["local"],
		    aliases: ["ModuleSpecifier"],
		    fields: {
		      local: {
		        validate: assertNodeType("Identifier")
		      }
		    }
		  });
		  defineType$4("ImportSpecifier", {
		    visitor: ["local", "imported"],
		    aliases: ["ModuleSpecifier"],
		    fields: {
		      local: {
		        validate: assertNodeType("Identifier")
		      },
		      imported: {
		        validate: assertNodeType("Identifier", "StringLiteral")
		      },
		      importKind: {
		        validate: assertOneOf("type", "typeof", "value"),
		        optional: true
		      }
		    }
		  });
		  defineType$4("ImportExpression", {
		    visitor: ["source", "options"],
		    aliases: ["Expression"],
		    fields: {
		      phase: {
		        "default": null,
		        validate: assertOneOf("source", "defer")
		      },
		      source: {
		        validate: assertNodeType("Expression")
		      },
		      options: {
		        validate: assertNodeType("Expression"),
		        optional: true
		      }
		    }
		  });
		  defineType$4("MetaProperty", {
		    visitor: ["meta", "property"],
		    aliases: ["Expression"],
		    fields: {
		      meta: {
		        validate: chain$1(assertNodeType("Identifier"), Object.assign(function (node, key, val) {
		          if (!browser$1$1.env.BABEL_TYPES_8_BREAKING) return;
		          var property;
		          switch (val.name) {
		            case "function":
		              property = "sent";
		              break;
		            case "new":
		              property = "target";
		              break;
		            case "import":
		              property = "meta";
		              break;
		          }
		          if (!is$1("Identifier", node.property, {
		            name: property
		          })) {
		            throw new TypeError("Unrecognised MetaProperty");
		          }
		        }, {
		          oneOfNodeTypes: ["Identifier"]
		        }))
		      },
		      property: {
		        validate: assertNodeType("Identifier")
		      }
		    }
		  });
		  var classMethodOrPropertyCommon = function classMethodOrPropertyCommon() {
		    return {
		      "abstract": {
		        validate: assertValueType("boolean"),
		        optional: true
		      },
		      accessibility: {
		        validate: assertOneOf("public", "private", "protected"),
		        optional: true
		      },
		      "static": {
		        "default": false
		      },
		      override: {
		        "default": false
		      },
		      computed: {
		        "default": false
		      },
		      optional: {
		        validate: assertValueType("boolean"),
		        optional: true
		      },
		      key: {
		        validate: chain$1(function () {
		          var normal = assertNodeType("Identifier", "StringLiteral", "NumericLiteral", "BigIntLiteral");
		          var computed = assertNodeType("Expression");
		          return function (node, key, val) {
		            var validator = node.computed ? computed : normal;
		            validator(node, key, val);
		          };
		        }(), assertNodeType("Identifier", "StringLiteral", "NumericLiteral", "BigIntLiteral", "Expression"))
		      }
		    };
		  };
		  var classMethodOrDeclareMethodCommon = function classMethodOrDeclareMethodCommon() {
		    return Object.assign({}, functionCommon(), classMethodOrPropertyCommon(), {
		      params: {
		        validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Identifier", "Pattern", "RestElement", "TSParameterProperty")))
		      },
		      kind: {
		        validate: assertOneOf("get", "set", "method", "constructor"),
		        "default": "method"
		      },
		      access: {
		        validate: chain$1(assertValueType("string"), assertOneOf("public", "private", "protected")),
		        optional: true
		      },
		      decorators: {
		        validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Decorator"))),
		        optional: true
		      }
		    });
		  };
		  defineType$4("ClassMethod", {
		    aliases: ["Function", "Scopable", "BlockParent", "FunctionParent", "Method"],
		    builder: ["kind", "key", "params", "body", "computed", "static", "generator", "async"],
		    visitor: ["key", "params", "body", "decorators", "returnType", "typeParameters"],
		    fields: Object.assign({}, classMethodOrDeclareMethodCommon(), functionTypeAnnotationCommon(), {
		      body: {
		        validate: assertNodeType("BlockStatement")
		      }
		    })
		  });
		  defineType$4("ObjectPattern", {
		    visitor: ["properties", "typeAnnotation", "decorators"],
		    builder: ["properties"],
		    aliases: ["Pattern", "PatternLike", "LVal"],
		    fields: Object.assign({}, patternLikeCommon(), {
		      properties: {
		        validate: chain$1(assertValueType("array"), assertEach(assertNodeType("RestElement", "ObjectProperty")))
		      }
		    })
		  });
		  defineType$4("SpreadElement", {
		    visitor: ["argument"],
		    aliases: ["UnaryLike"],
		    deprecatedAlias: "SpreadProperty",
		    fields: {
		      argument: {
		        validate: assertNodeType("Expression")
		      }
		    }
		  });
		  defineType$4("Super", {
		    aliases: ["Expression"]
		  });
		  defineType$4("TaggedTemplateExpression", {
		    visitor: ["tag", "quasi", "typeParameters"],
		    builder: ["tag", "quasi"],
		    aliases: ["Expression"],
		    fields: {
		      tag: {
		        validate: assertNodeType("Expression")
		      },
		      quasi: {
		        validate: assertNodeType("TemplateLiteral")
		      },
		      typeParameters: {
		        validate: assertNodeType("TypeParameterInstantiation", "TSTypeParameterInstantiation"),
		        optional: true
		      }
		    }
		  });
		  defineType$4("TemplateElement", {
		    builder: ["value", "tail"],
		    fields: {
		      value: {
		        validate: chain$1(assertShape({
		          raw: {
		            validate: assertValueType("string")
		          },
		          cooked: {
		            validate: assertValueType("string"),
		            optional: true
		          }
		        }), function templateElementCookedValidator(node) {
		          var raw = node.value.raw;
		          var unterminatedCalled = false;
		          var error = function error() {
		            throw new Error("Internal @babel/types error.");
		          };
		          var _readStringContents = readStringContents("template", raw, 0, 0, 0, {
		              unterminated: function unterminated() {
		                unterminatedCalled = true;
		              },
		              strictNumericEscape: error,
		              invalidEscapeSequence: error,
		              numericSeparatorInEscapeSequence: error,
		              unexpectedNumericSeparator: error,
		              invalidDigit: error,
		              invalidCodePoint: error
		            }),
		            str = _readStringContents.str,
		            firstInvalidLoc = _readStringContents.firstInvalidLoc;
		          if (!unterminatedCalled) throw new Error("Invalid raw");
		          node.value.cooked = firstInvalidLoc ? null : str;
		        })
		      },
		      tail: {
		        "default": false
		      }
		    }
		  });
		  defineType$4("TemplateLiteral", {
		    visitor: ["quasis", "expressions"],
		    aliases: ["Expression", "Literal"],
		    fields: {
		      quasis: {
		        validate: chain$1(assertValueType("array"), assertEach(assertNodeType("TemplateElement")))
		      },
		      expressions: {
		        validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Expression", "TSType")), function (node, key, val) {
		          if (node.quasis.length !== val.length + 1) {
		            throw new TypeError("Number of " + node.type + " quasis should be exactly one more than the number of expressions.\nExpected " + (val.length + 1) + " quasis but got " + node.quasis.length);
		          }
		        })
		      }
		    }
		  });
		  defineType$4("YieldExpression", {
		    builder: ["argument", "delegate"],
		    visitor: ["argument"],
		    aliases: ["Expression", "Terminatorless"],
		    fields: {
		      delegate: {
		        validate: chain$1(assertValueType("boolean"), Object.assign(function (node, key, val) {
		          if (!browser$1$1.env.BABEL_TYPES_8_BREAKING) return;
		          if (val && !node.argument) {
		            throw new TypeError("Property delegate of YieldExpression cannot be true if there is no argument");
		          }
		        }, {
		          type: "boolean"
		        })),
		        "default": false
		      },
		      argument: {
		        optional: true,
		        validate: assertNodeType("Expression")
		      }
		    }
		  });
		  defineType$4("AwaitExpression", {
		    builder: ["argument"],
		    visitor: ["argument"],
		    aliases: ["Expression", "Terminatorless"],
		    fields: {
		      argument: {
		        validate: assertNodeType("Expression")
		      }
		    }
		  });
		  defineType$4("Import", {
		    aliases: ["Expression"]
		  });
		  defineType$4("BigIntLiteral", {
		    builder: ["value"],
		    fields: {
		      value: {
		        validate: assertValueType("string")
		      }
		    },
		    aliases: ["Expression", "Pureish", "Literal", "Immutable"]
		  });
		  defineType$4("ExportNamespaceSpecifier", {
		    visitor: ["exported"],
		    aliases: ["ModuleSpecifier"],
		    fields: {
		      exported: {
		        validate: assertNodeType("Identifier")
		      }
		    }
		  });
		  defineType$4("OptionalMemberExpression", {
		    builder: ["object", "property", "computed", "optional"],
		    visitor: ["object", "property"],
		    aliases: ["Expression"],
		    fields: {
		      object: {
		        validate: assertNodeType("Expression")
		      },
		      property: {
		        validate: function () {
		          var normal = assertNodeType("Identifier");
		          var computed = assertNodeType("Expression");
		          var validator = Object.assign(function (node, key, val) {
		            var validator = node.computed ? computed : normal;
		            validator(node, key, val);
		          }, {
		            oneOfNodeTypes: ["Expression", "Identifier"]
		          });
		          return validator;
		        }()
		      },
		      computed: {
		        "default": false
		      },
		      optional: {
		        validate: !browser$1$1.env.BABEL_TYPES_8_BREAKING ? assertValueType("boolean") : chain$1(assertValueType("boolean"), assertOptionalChainStart())
		      }
		    }
		  });
		  defineType$4("OptionalCallExpression", {
		    visitor: ["callee", "arguments", "typeParameters", "typeArguments"],
		    builder: ["callee", "arguments", "optional"],
		    aliases: ["Expression"],
		    fields: {
		      callee: {
		        validate: assertNodeType("Expression")
		      },
		      arguments: {
		        validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Expression", "SpreadElement", "ArgumentPlaceholder")))
		      },
		      optional: {
		        validate: !browser$1$1.env.BABEL_TYPES_8_BREAKING ? assertValueType("boolean") : chain$1(assertValueType("boolean"), assertOptionalChainStart())
		      },
		      typeArguments: {
		        validate: assertNodeType("TypeParameterInstantiation"),
		        optional: true
		      },
		      typeParameters: {
		        validate: assertNodeType("TSTypeParameterInstantiation"),
		        optional: true
		      }
		    }
		  });
		  defineType$4("ClassProperty", {
		    visitor: ["key", "value", "typeAnnotation", "decorators"],
		    builder: ["key", "value", "typeAnnotation", "decorators", "computed", "static"],
		    aliases: ["Property"],
		    fields: Object.assign({}, classMethodOrPropertyCommon(), {
		      value: {
		        validate: assertNodeType("Expression"),
		        optional: true
		      },
		      definite: {
		        validate: assertValueType("boolean"),
		        optional: true
		      },
		      typeAnnotation: {
		        validate: assertNodeType("TypeAnnotation", "TSTypeAnnotation", "Noop"),
		        optional: true
		      },
		      decorators: {
		        validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Decorator"))),
		        optional: true
		      },
		      readonly: {
		        validate: assertValueType("boolean"),
		        optional: true
		      },
		      declare: {
		        validate: assertValueType("boolean"),
		        optional: true
		      },
		      variance: {
		        validate: assertNodeType("Variance"),
		        optional: true
		      }
		    })
		  });
		  defineType$4("ClassAccessorProperty", {
		    visitor: ["key", "value", "typeAnnotation", "decorators"],
		    builder: ["key", "value", "typeAnnotation", "decorators", "computed", "static"],
		    aliases: ["Property", "Accessor"],
		    fields: Object.assign({}, classMethodOrPropertyCommon(), {
		      key: {
		        validate: chain$1(function () {
		          var normal = assertNodeType("Identifier", "StringLiteral", "NumericLiteral", "BigIntLiteral", "PrivateName");
		          var computed = assertNodeType("Expression");
		          return function (node, key, val) {
		            var validator = node.computed ? computed : normal;
		            validator(node, key, val);
		          };
		        }(), assertNodeType("Identifier", "StringLiteral", "NumericLiteral", "BigIntLiteral", "Expression", "PrivateName"))
		      },
		      value: {
		        validate: assertNodeType("Expression"),
		        optional: true
		      },
		      definite: {
		        validate: assertValueType("boolean"),
		        optional: true
		      },
		      typeAnnotation: {
		        validate: assertNodeType("TypeAnnotation", "TSTypeAnnotation", "Noop"),
		        optional: true
		      },
		      decorators: {
		        validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Decorator"))),
		        optional: true
		      },
		      readonly: {
		        validate: assertValueType("boolean"),
		        optional: true
		      },
		      declare: {
		        validate: assertValueType("boolean"),
		        optional: true
		      },
		      variance: {
		        validate: assertNodeType("Variance"),
		        optional: true
		      }
		    })
		  });
		  defineType$4("ClassPrivateProperty", {
		    visitor: ["key", "value", "decorators", "typeAnnotation"],
		    builder: ["key", "value", "decorators", "static"],
		    aliases: ["Property", "Private"],
		    fields: {
		      key: {
		        validate: assertNodeType("PrivateName")
		      },
		      value: {
		        validate: assertNodeType("Expression"),
		        optional: true
		      },
		      typeAnnotation: {
		        validate: assertNodeType("TypeAnnotation", "TSTypeAnnotation", "Noop"),
		        optional: true
		      },
		      decorators: {
		        validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Decorator"))),
		        optional: true
		      },
		      "static": {
		        validate: assertValueType("boolean"),
		        "default": false
		      },
		      readonly: {
		        validate: assertValueType("boolean"),
		        optional: true
		      },
		      definite: {
		        validate: assertValueType("boolean"),
		        optional: true
		      },
		      variance: {
		        validate: assertNodeType("Variance"),
		        optional: true
		      }
		    }
		  });
		  defineType$4("ClassPrivateMethod", {
		    builder: ["kind", "key", "params", "body", "static"],
		    visitor: ["key", "params", "body", "decorators", "returnType", "typeParameters"],
		    aliases: ["Function", "Scopable", "BlockParent", "FunctionParent", "Method", "Private"],
		    fields: Object.assign({}, classMethodOrDeclareMethodCommon(), functionTypeAnnotationCommon(), {
		      kind: {
		        validate: assertOneOf("get", "set", "method"),
		        "default": "method"
		      },
		      key: {
		        validate: assertNodeType("PrivateName")
		      },
		      body: {
		        validate: assertNodeType("BlockStatement")
		      }
		    })
		  });
		  defineType$4("PrivateName", {
		    visitor: ["id"],
		    aliases: ["Private"],
		    fields: {
		      id: {
		        validate: assertNodeType("Identifier")
		      }
		    }
		  });
		  defineType$4("StaticBlock", {
		    visitor: ["body"],
		    fields: {
		      body: {
		        validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Statement")))
		      }
		    },
		    aliases: ["Scopable", "BlockParent", "FunctionParent"]
		  });

		  var defineType$3 = defineAliasedType("Flow");
		  var defineInterfaceishType = function defineInterfaceishType(name) {
		    var isDeclareClass = name === "DeclareClass";
		    defineType$3(name, {
		      builder: ["id", "typeParameters", "extends", "body"],
		      visitor: ["id", "typeParameters", "extends"].concat(_toConsumableArray(isDeclareClass ? ["mixins", "implements"] : []), ["body"]),
		      aliases: ["FlowDeclaration", "Statement", "Declaration"],
		      fields: Object.assign({
		        id: validateType("Identifier"),
		        typeParameters: validateOptionalType("TypeParameterDeclaration"),
		        "extends": validateOptional(arrayOfType("InterfaceExtends"))
		      }, isDeclareClass ? {
		        mixins: validateOptional(arrayOfType("InterfaceExtends")),
		        "implements": validateOptional(arrayOfType("ClassImplements"))
		      } : {}, {
		        body: validateType("ObjectTypeAnnotation")
		      })
		    });
		  };
		  defineType$3("AnyTypeAnnotation", {
		    aliases: ["FlowType", "FlowBaseAnnotation"]
		  });
		  defineType$3("ArrayTypeAnnotation", {
		    visitor: ["elementType"],
		    aliases: ["FlowType"],
		    fields: {
		      elementType: validateType("FlowType")
		    }
		  });
		  defineType$3("BooleanTypeAnnotation", {
		    aliases: ["FlowType", "FlowBaseAnnotation"]
		  });
		  defineType$3("BooleanLiteralTypeAnnotation", {
		    builder: ["value"],
		    aliases: ["FlowType"],
		    fields: {
		      value: validate$6(assertValueType("boolean"))
		    }
		  });
		  defineType$3("NullLiteralTypeAnnotation", {
		    aliases: ["FlowType", "FlowBaseAnnotation"]
		  });
		  defineType$3("ClassImplements", {
		    visitor: ["id", "typeParameters"],
		    fields: {
		      id: validateType("Identifier"),
		      typeParameters: validateOptionalType("TypeParameterInstantiation")
		    }
		  });
		  defineInterfaceishType("DeclareClass");
		  defineType$3("DeclareFunction", {
		    visitor: ["id"],
		    aliases: ["FlowDeclaration", "Statement", "Declaration"],
		    fields: {
		      id: validateType("Identifier"),
		      predicate: validateOptionalType("DeclaredPredicate")
		    }
		  });
		  defineInterfaceishType("DeclareInterface");
		  defineType$3("DeclareModule", {
		    builder: ["id", "body", "kind"],
		    visitor: ["id", "body"],
		    aliases: ["FlowDeclaration", "Statement", "Declaration"],
		    fields: {
		      id: validateType(["Identifier", "StringLiteral"]),
		      body: validateType("BlockStatement"),
		      kind: validateOptional(assertOneOf("CommonJS", "ES"))
		    }
		  });
		  defineType$3("DeclareModuleExports", {
		    visitor: ["typeAnnotation"],
		    aliases: ["FlowDeclaration", "Statement", "Declaration"],
		    fields: {
		      typeAnnotation: validateType("TypeAnnotation")
		    }
		  });
		  defineType$3("DeclareTypeAlias", {
		    visitor: ["id", "typeParameters", "right"],
		    aliases: ["FlowDeclaration", "Statement", "Declaration"],
		    fields: {
		      id: validateType("Identifier"),
		      typeParameters: validateOptionalType("TypeParameterDeclaration"),
		      right: validateType("FlowType")
		    }
		  });
		  defineType$3("DeclareOpaqueType", {
		    visitor: ["id", "typeParameters", "supertype"],
		    aliases: ["FlowDeclaration", "Statement", "Declaration"],
		    fields: {
		      id: validateType("Identifier"),
		      typeParameters: validateOptionalType("TypeParameterDeclaration"),
		      supertype: validateOptionalType("FlowType"),
		      impltype: validateOptionalType("FlowType")
		    }
		  });
		  defineType$3("DeclareVariable", {
		    visitor: ["id"],
		    aliases: ["FlowDeclaration", "Statement", "Declaration"],
		    fields: {
		      id: validateType("Identifier")
		    }
		  });
		  defineType$3("DeclareExportDeclaration", {
		    visitor: ["declaration", "specifiers", "source"],
		    aliases: ["FlowDeclaration", "Statement", "Declaration"],
		    fields: {
		      declaration: validateOptionalType("Flow"),
		      specifiers: validateOptional(arrayOfType(["ExportSpecifier", "ExportNamespaceSpecifier"])),
		      source: validateOptionalType("StringLiteral"),
		      "default": validateOptional(assertValueType("boolean"))
		    }
		  });
		  defineType$3("DeclareExportAllDeclaration", {
		    visitor: ["source"],
		    aliases: ["FlowDeclaration", "Statement", "Declaration"],
		    fields: {
		      source: validateType("StringLiteral"),
		      exportKind: validateOptional(assertOneOf("type", "value"))
		    }
		  });
		  defineType$3("DeclaredPredicate", {
		    visitor: ["value"],
		    aliases: ["FlowPredicate"],
		    fields: {
		      value: validateType("Flow")
		    }
		  });
		  defineType$3("ExistsTypeAnnotation", {
		    aliases: ["FlowType"]
		  });
		  defineType$3("FunctionTypeAnnotation", {
		    visitor: ["typeParameters", "params", "rest", "returnType"],
		    aliases: ["FlowType"],
		    fields: {
		      typeParameters: validateOptionalType("TypeParameterDeclaration"),
		      params: validate$6(arrayOfType("FunctionTypeParam")),
		      rest: validateOptionalType("FunctionTypeParam"),
		      "this": validateOptionalType("FunctionTypeParam"),
		      returnType: validateType("FlowType")
		    }
		  });
		  defineType$3("FunctionTypeParam", {
		    visitor: ["name", "typeAnnotation"],
		    fields: {
		      name: validateOptionalType("Identifier"),
		      typeAnnotation: validateType("FlowType"),
		      optional: validateOptional(assertValueType("boolean"))
		    }
		  });
		  defineType$3("GenericTypeAnnotation", {
		    visitor: ["id", "typeParameters"],
		    aliases: ["FlowType"],
		    fields: {
		      id: validateType(["Identifier", "QualifiedTypeIdentifier"]),
		      typeParameters: validateOptionalType("TypeParameterInstantiation")
		    }
		  });
		  defineType$3("InferredPredicate", {
		    aliases: ["FlowPredicate"]
		  });
		  defineType$3("InterfaceExtends", {
		    visitor: ["id", "typeParameters"],
		    fields: {
		      id: validateType(["Identifier", "QualifiedTypeIdentifier"]),
		      typeParameters: validateOptionalType("TypeParameterInstantiation")
		    }
		  });
		  defineInterfaceishType("InterfaceDeclaration");
		  defineType$3("InterfaceTypeAnnotation", {
		    visitor: ["extends", "body"],
		    aliases: ["FlowType"],
		    fields: {
		      "extends": validateOptional(arrayOfType("InterfaceExtends")),
		      body: validateType("ObjectTypeAnnotation")
		    }
		  });
		  defineType$3("IntersectionTypeAnnotation", {
		    visitor: ["types"],
		    aliases: ["FlowType"],
		    fields: {
		      types: validate$6(arrayOfType("FlowType"))
		    }
		  });
		  defineType$3("MixedTypeAnnotation", {
		    aliases: ["FlowType", "FlowBaseAnnotation"]
		  });
		  defineType$3("EmptyTypeAnnotation", {
		    aliases: ["FlowType", "FlowBaseAnnotation"]
		  });
		  defineType$3("NullableTypeAnnotation", {
		    visitor: ["typeAnnotation"],
		    aliases: ["FlowType"],
		    fields: {
		      typeAnnotation: validateType("FlowType")
		    }
		  });
		  defineType$3("NumberLiteralTypeAnnotation", {
		    builder: ["value"],
		    aliases: ["FlowType"],
		    fields: {
		      value: validate$6(assertValueType("number"))
		    }
		  });
		  defineType$3("NumberTypeAnnotation", {
		    aliases: ["FlowType", "FlowBaseAnnotation"]
		  });
		  defineType$3("ObjectTypeAnnotation", {
		    visitor: ["properties", "indexers", "callProperties", "internalSlots"],
		    aliases: ["FlowType"],
		    builder: ["properties", "indexers", "callProperties", "internalSlots", "exact"],
		    fields: {
		      properties: validate$6(arrayOfType(["ObjectTypeProperty", "ObjectTypeSpreadProperty"])),
		      indexers: {
		        validate: arrayOfType("ObjectTypeIndexer"),
		        optional: true,
		        "default": []
		      },
		      callProperties: {
		        validate: arrayOfType("ObjectTypeCallProperty"),
		        optional: true,
		        "default": []
		      },
		      internalSlots: {
		        validate: arrayOfType("ObjectTypeInternalSlot"),
		        optional: true,
		        "default": []
		      },
		      exact: {
		        validate: assertValueType("boolean"),
		        "default": false
		      },
		      inexact: validateOptional(assertValueType("boolean"))
		    }
		  });
		  defineType$3("ObjectTypeInternalSlot", {
		    visitor: ["id", "value", "optional", "static", "method"],
		    aliases: ["UserWhitespacable"],
		    fields: {
		      id: validateType("Identifier"),
		      value: validateType("FlowType"),
		      optional: validate$6(assertValueType("boolean")),
		      "static": validate$6(assertValueType("boolean")),
		      method: validate$6(assertValueType("boolean"))
		    }
		  });
		  defineType$3("ObjectTypeCallProperty", {
		    visitor: ["value"],
		    aliases: ["UserWhitespacable"],
		    fields: {
		      value: validateType("FlowType"),
		      "static": validate$6(assertValueType("boolean"))
		    }
		  });
		  defineType$3("ObjectTypeIndexer", {
		    visitor: ["id", "key", "value", "variance"],
		    aliases: ["UserWhitespacable"],
		    fields: {
		      id: validateOptionalType("Identifier"),
		      key: validateType("FlowType"),
		      value: validateType("FlowType"),
		      "static": validate$6(assertValueType("boolean")),
		      variance: validateOptionalType("Variance")
		    }
		  });
		  defineType$3("ObjectTypeProperty", {
		    visitor: ["key", "value", "variance"],
		    aliases: ["UserWhitespacable"],
		    fields: {
		      key: validateType(["Identifier", "StringLiteral"]),
		      value: validateType("FlowType"),
		      kind: validate$6(assertOneOf("init", "get", "set")),
		      "static": validate$6(assertValueType("boolean")),
		      proto: validate$6(assertValueType("boolean")),
		      optional: validate$6(assertValueType("boolean")),
		      variance: validateOptionalType("Variance"),
		      method: validate$6(assertValueType("boolean"))
		    }
		  });
		  defineType$3("ObjectTypeSpreadProperty", {
		    visitor: ["argument"],
		    aliases: ["UserWhitespacable"],
		    fields: {
		      argument: validateType("FlowType")
		    }
		  });
		  defineType$3("OpaqueType", {
		    visitor: ["id", "typeParameters", "supertype", "impltype"],
		    aliases: ["FlowDeclaration", "Statement", "Declaration"],
		    fields: {
		      id: validateType("Identifier"),
		      typeParameters: validateOptionalType("TypeParameterDeclaration"),
		      supertype: validateOptionalType("FlowType"),
		      impltype: validateType("FlowType")
		    }
		  });
		  defineType$3("QualifiedTypeIdentifier", {
		    visitor: ["id", "qualification"],
		    fields: {
		      id: validateType("Identifier"),
		      qualification: validateType(["Identifier", "QualifiedTypeIdentifier"])
		    }
		  });
		  defineType$3("StringLiteralTypeAnnotation", {
		    builder: ["value"],
		    aliases: ["FlowType"],
		    fields: {
		      value: validate$6(assertValueType("string"))
		    }
		  });
		  defineType$3("StringTypeAnnotation", {
		    aliases: ["FlowType", "FlowBaseAnnotation"]
		  });
		  defineType$3("SymbolTypeAnnotation", {
		    aliases: ["FlowType", "FlowBaseAnnotation"]
		  });
		  defineType$3("ThisTypeAnnotation", {
		    aliases: ["FlowType", "FlowBaseAnnotation"]
		  });
		  defineType$3("TupleTypeAnnotation", {
		    visitor: ["types"],
		    aliases: ["FlowType"],
		    fields: {
		      types: validate$6(arrayOfType("FlowType"))
		    }
		  });
		  defineType$3("TypeofTypeAnnotation", {
		    visitor: ["argument"],
		    aliases: ["FlowType"],
		    fields: {
		      argument: validateType("FlowType")
		    }
		  });
		  defineType$3("TypeAlias", {
		    visitor: ["id", "typeParameters", "right"],
		    aliases: ["FlowDeclaration", "Statement", "Declaration"],
		    fields: {
		      id: validateType("Identifier"),
		      typeParameters: validateOptionalType("TypeParameterDeclaration"),
		      right: validateType("FlowType")
		    }
		  });
		  defineType$3("TypeAnnotation", {
		    visitor: ["typeAnnotation"],
		    fields: {
		      typeAnnotation: validateType("FlowType")
		    }
		  });
		  defineType$3("TypeCastExpression", {
		    visitor: ["expression", "typeAnnotation"],
		    aliases: ["ExpressionWrapper", "Expression"],
		    fields: {
		      expression: validateType("Expression"),
		      typeAnnotation: validateType("TypeAnnotation")
		    }
		  });
		  defineType$3("TypeParameter", {
		    visitor: ["bound", "default", "variance"],
		    fields: {
		      name: validate$6(assertValueType("string")),
		      bound: validateOptionalType("TypeAnnotation"),
		      "default": validateOptionalType("FlowType"),
		      variance: validateOptionalType("Variance")
		    }
		  });
		  defineType$3("TypeParameterDeclaration", {
		    visitor: ["params"],
		    fields: {
		      params: validate$6(arrayOfType("TypeParameter"))
		    }
		  });
		  defineType$3("TypeParameterInstantiation", {
		    visitor: ["params"],
		    fields: {
		      params: validate$6(arrayOfType("FlowType"))
		    }
		  });
		  defineType$3("UnionTypeAnnotation", {
		    visitor: ["types"],
		    aliases: ["FlowType"],
		    fields: {
		      types: validate$6(arrayOfType("FlowType"))
		    }
		  });
		  defineType$3("Variance", {
		    builder: ["kind"],
		    fields: {
		      kind: validate$6(assertOneOf("minus", "plus"))
		    }
		  });
		  defineType$3("VoidTypeAnnotation", {
		    aliases: ["FlowType", "FlowBaseAnnotation"]
		  });
		  defineType$3("EnumDeclaration", {
		    aliases: ["Statement", "Declaration"],
		    visitor: ["id", "body"],
		    fields: {
		      id: validateType("Identifier"),
		      body: validateType(["EnumBooleanBody", "EnumNumberBody", "EnumStringBody", "EnumSymbolBody"])
		    }
		  });
		  defineType$3("EnumBooleanBody", {
		    aliases: ["EnumBody"],
		    visitor: ["members"],
		    fields: {
		      explicitType: validate$6(assertValueType("boolean")),
		      members: validateArrayOfType("EnumBooleanMember"),
		      hasUnknownMembers: validate$6(assertValueType("boolean"))
		    }
		  });
		  defineType$3("EnumNumberBody", {
		    aliases: ["EnumBody"],
		    visitor: ["members"],
		    fields: {
		      explicitType: validate$6(assertValueType("boolean")),
		      members: validateArrayOfType("EnumNumberMember"),
		      hasUnknownMembers: validate$6(assertValueType("boolean"))
		    }
		  });
		  defineType$3("EnumStringBody", {
		    aliases: ["EnumBody"],
		    visitor: ["members"],
		    fields: {
		      explicitType: validate$6(assertValueType("boolean")),
		      members: validateArrayOfType(["EnumStringMember", "EnumDefaultedMember"]),
		      hasUnknownMembers: validate$6(assertValueType("boolean"))
		    }
		  });
		  defineType$3("EnumSymbolBody", {
		    aliases: ["EnumBody"],
		    visitor: ["members"],
		    fields: {
		      members: validateArrayOfType("EnumDefaultedMember"),
		      hasUnknownMembers: validate$6(assertValueType("boolean"))
		    }
		  });
		  defineType$3("EnumBooleanMember", {
		    aliases: ["EnumMember"],
		    visitor: ["id"],
		    fields: {
		      id: validateType("Identifier"),
		      init: validateType("BooleanLiteral")
		    }
		  });
		  defineType$3("EnumNumberMember", {
		    aliases: ["EnumMember"],
		    visitor: ["id", "init"],
		    fields: {
		      id: validateType("Identifier"),
		      init: validateType("NumericLiteral")
		    }
		  });
		  defineType$3("EnumStringMember", {
		    aliases: ["EnumMember"],
		    visitor: ["id", "init"],
		    fields: {
		      id: validateType("Identifier"),
		      init: validateType("StringLiteral")
		    }
		  });
		  defineType$3("EnumDefaultedMember", {
		    aliases: ["EnumMember"],
		    visitor: ["id"],
		    fields: {
		      id: validateType("Identifier")
		    }
		  });
		  defineType$3("IndexedAccessType", {
		    visitor: ["objectType", "indexType"],
		    aliases: ["FlowType"],
		    fields: {
		      objectType: validateType("FlowType"),
		      indexType: validateType("FlowType")
		    }
		  });
		  defineType$3("OptionalIndexedAccessType", {
		    visitor: ["objectType", "indexType"],
		    aliases: ["FlowType"],
		    fields: {
		      objectType: validateType("FlowType"),
		      indexType: validateType("FlowType"),
		      optional: validate$6(assertValueType("boolean"))
		    }
		  });

		  var defineType$2 = defineAliasedType("JSX");
		  defineType$2("JSXAttribute", {
		    visitor: ["name", "value"],
		    aliases: ["Immutable"],
		    fields: {
		      name: {
		        validate: assertNodeType("JSXIdentifier", "JSXNamespacedName")
		      },
		      value: {
		        optional: true,
		        validate: assertNodeType("JSXElement", "JSXFragment", "StringLiteral", "JSXExpressionContainer")
		      }
		    }
		  });
		  defineType$2("JSXClosingElement", {
		    visitor: ["name"],
		    aliases: ["Immutable"],
		    fields: {
		      name: {
		        validate: assertNodeType("JSXIdentifier", "JSXMemberExpression", "JSXNamespacedName")
		      }
		    }
		  });
		  defineType$2("JSXElement", {
		    builder: ["openingElement", "closingElement", "children", "selfClosing"],
		    visitor: ["openingElement", "children", "closingElement"],
		    aliases: ["Immutable", "Expression"],
		    fields: Object.assign({
		      openingElement: {
		        validate: assertNodeType("JSXOpeningElement")
		      },
		      closingElement: {
		        optional: true,
		        validate: assertNodeType("JSXClosingElement")
		      },
		      children: {
		        validate: chain$1(assertValueType("array"), assertEach(assertNodeType("JSXText", "JSXExpressionContainer", "JSXSpreadChild", "JSXElement", "JSXFragment")))
		      }
		    }, {
		      selfClosing: {
		        validate: assertValueType("boolean"),
		        optional: true
		      }
		    })
		  });
		  defineType$2("JSXEmptyExpression", {});
		  defineType$2("JSXExpressionContainer", {
		    visitor: ["expression"],
		    aliases: ["Immutable"],
		    fields: {
		      expression: {
		        validate: assertNodeType("Expression", "JSXEmptyExpression")
		      }
		    }
		  });
		  defineType$2("JSXSpreadChild", {
		    visitor: ["expression"],
		    aliases: ["Immutable"],
		    fields: {
		      expression: {
		        validate: assertNodeType("Expression")
		      }
		    }
		  });
		  defineType$2("JSXIdentifier", {
		    builder: ["name"],
		    fields: {
		      name: {
		        validate: assertValueType("string")
		      }
		    }
		  });
		  defineType$2("JSXMemberExpression", {
		    visitor: ["object", "property"],
		    fields: {
		      object: {
		        validate: assertNodeType("JSXMemberExpression", "JSXIdentifier")
		      },
		      property: {
		        validate: assertNodeType("JSXIdentifier")
		      }
		    }
		  });
		  defineType$2("JSXNamespacedName", {
		    visitor: ["namespace", "name"],
		    fields: {
		      namespace: {
		        validate: assertNodeType("JSXIdentifier")
		      },
		      name: {
		        validate: assertNodeType("JSXIdentifier")
		      }
		    }
		  });
		  defineType$2("JSXOpeningElement", {
		    builder: ["name", "attributes", "selfClosing"],
		    visitor: ["name", "attributes"],
		    aliases: ["Immutable"],
		    fields: {
		      name: {
		        validate: assertNodeType("JSXIdentifier", "JSXMemberExpression", "JSXNamespacedName")
		      },
		      selfClosing: {
		        "default": false
		      },
		      attributes: {
		        validate: chain$1(assertValueType("array"), assertEach(assertNodeType("JSXAttribute", "JSXSpreadAttribute")))
		      },
		      typeParameters: {
		        validate: assertNodeType("TypeParameterInstantiation", "TSTypeParameterInstantiation"),
		        optional: true
		      }
		    }
		  });
		  defineType$2("JSXSpreadAttribute", {
		    visitor: ["argument"],
		    fields: {
		      argument: {
		        validate: assertNodeType("Expression")
		      }
		    }
		  });
		  defineType$2("JSXText", {
		    aliases: ["Immutable"],
		    builder: ["value"],
		    fields: {
		      value: {
		        validate: assertValueType("string")
		      }
		    }
		  });
		  defineType$2("JSXFragment", {
		    builder: ["openingFragment", "closingFragment", "children"],
		    visitor: ["openingFragment", "children", "closingFragment"],
		    aliases: ["Immutable", "Expression"],
		    fields: {
		      openingFragment: {
		        validate: assertNodeType("JSXOpeningFragment")
		      },
		      closingFragment: {
		        validate: assertNodeType("JSXClosingFragment")
		      },
		      children: {
		        validate: chain$1(assertValueType("array"), assertEach(assertNodeType("JSXText", "JSXExpressionContainer", "JSXSpreadChild", "JSXElement", "JSXFragment")))
		      }
		    }
		  });
		  defineType$2("JSXOpeningFragment", {
		    aliases: ["Immutable"]
		  });
		  defineType$2("JSXClosingFragment", {
		    aliases: ["Immutable"]
		  });

		  var PLACEHOLDERS = ["Identifier", "StringLiteral", "Expression", "Statement", "Declaration", "BlockStatement", "ClassBody", "Pattern"];
		  var PLACEHOLDERS_ALIAS = {
		    Declaration: ["Statement"],
		    Pattern: ["PatternLike", "LVal"]
		  };
		  for (var _i$2 = 0, _PLACEHOLDERS = PLACEHOLDERS; _i$2 < _PLACEHOLDERS.length; _i$2++) {
		    var type$2 = _PLACEHOLDERS[_i$2];
		    var alias = ALIAS_KEYS[type$2];
		    if (alias != null && alias.length) PLACEHOLDERS_ALIAS[type$2] = alias;
		  }
		  var PLACEHOLDERS_FLIPPED_ALIAS = {};
		  Object.keys(PLACEHOLDERS_ALIAS).forEach(function (type) {
		    PLACEHOLDERS_ALIAS[type].forEach(function (alias) {
		      if (!hasOwnProperty.call(PLACEHOLDERS_FLIPPED_ALIAS, alias)) {
		        PLACEHOLDERS_FLIPPED_ALIAS[alias] = [];
		      }
		      PLACEHOLDERS_FLIPPED_ALIAS[alias].push(type);
		    });
		  });

		  var defineType$1 = defineAliasedType("Miscellaneous");
		  {
		    defineType$1("Noop", {
		      visitor: []
		    });
		  }
		  defineType$1("Placeholder", {
		    visitor: [],
		    builder: ["expectedNode", "name"],
		    fields: {
		      name: {
		        validate: assertNodeType("Identifier")
		      },
		      expectedNode: {
		        validate: assertOneOf.apply(void 0, _toConsumableArray(PLACEHOLDERS))
		      }
		    }
		  });
		  defineType$1("V8IntrinsicIdentifier", {
		    builder: ["name"],
		    fields: {
		      name: {
		        validate: assertValueType("string")
		      }
		    }
		  });

		  defineType$5("ArgumentPlaceholder", {});
		  defineType$5("BindExpression", {
		    visitor: ["object", "callee"],
		    aliases: ["Expression"],
		    fields: !browser$1$1.env.BABEL_TYPES_8_BREAKING ? {
		      object: {
		        validate: Object.assign(function () {}, {
		          oneOfNodeTypes: ["Expression"]
		        })
		      },
		      callee: {
		        validate: Object.assign(function () {}, {
		          oneOfNodeTypes: ["Expression"]
		        })
		      }
		    } : {
		      object: {
		        validate: assertNodeType("Expression")
		      },
		      callee: {
		        validate: assertNodeType("Expression")
		      }
		    }
		  });
		  defineType$5("ImportAttribute", {
		    visitor: ["key", "value"],
		    fields: {
		      key: {
		        validate: assertNodeType("Identifier", "StringLiteral")
		      },
		      value: {
		        validate: assertNodeType("StringLiteral")
		      }
		    }
		  });
		  defineType$5("Decorator", {
		    visitor: ["expression"],
		    fields: {
		      expression: {
		        validate: assertNodeType("Expression")
		      }
		    }
		  });
		  defineType$5("DoExpression", {
		    visitor: ["body"],
		    builder: ["body", "async"],
		    aliases: ["Expression"],
		    fields: {
		      body: {
		        validate: assertNodeType("BlockStatement")
		      },
		      async: {
		        validate: assertValueType("boolean"),
		        "default": false
		      }
		    }
		  });
		  defineType$5("ExportDefaultSpecifier", {
		    visitor: ["exported"],
		    aliases: ["ModuleSpecifier"],
		    fields: {
		      exported: {
		        validate: assertNodeType("Identifier")
		      }
		    }
		  });
		  defineType$5("RecordExpression", {
		    visitor: ["properties"],
		    aliases: ["Expression"],
		    fields: {
		      properties: {
		        validate: chain$1(assertValueType("array"), assertEach(assertNodeType("ObjectProperty", "SpreadElement")))
		      }
		    }
		  });
		  defineType$5("TupleExpression", {
		    fields: {
		      elements: {
		        validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Expression", "SpreadElement"))),
		        "default": []
		      }
		    },
		    visitor: ["elements"],
		    aliases: ["Expression"]
		  });
		  defineType$5("DecimalLiteral", {
		    builder: ["value"],
		    fields: {
		      value: {
		        validate: assertValueType("string")
		      }
		    },
		    aliases: ["Expression", "Pureish", "Literal", "Immutable"]
		  });
		  defineType$5("ModuleExpression", {
		    visitor: ["body"],
		    fields: {
		      body: {
		        validate: assertNodeType("Program")
		      }
		    },
		    aliases: ["Expression"]
		  });
		  defineType$5("TopicReference", {
		    aliases: ["Expression"]
		  });
		  defineType$5("PipelineTopicExpression", {
		    builder: ["expression"],
		    visitor: ["expression"],
		    fields: {
		      expression: {
		        validate: assertNodeType("Expression")
		      }
		    },
		    aliases: ["Expression"]
		  });
		  defineType$5("PipelineBareFunction", {
		    builder: ["callee"],
		    visitor: ["callee"],
		    fields: {
		      callee: {
		        validate: assertNodeType("Expression")
		      }
		    },
		    aliases: ["Expression"]
		  });
		  defineType$5("PipelinePrimaryTopicReference", {
		    aliases: ["Expression"]
		  });

		  var defineType = defineAliasedType("TypeScript");
		  var bool$b = assertValueType("boolean");
		  var tSFunctionTypeAnnotationCommon = function tSFunctionTypeAnnotationCommon() {
		    return {
		      returnType: {
		        validate: assertNodeType("TSTypeAnnotation", "Noop"),
		        optional: true
		      },
		      typeParameters: {
		        validate: assertNodeType("TSTypeParameterDeclaration", "Noop"),
		        optional: true
		      }
		    };
		  };
		  defineType("TSParameterProperty", {
		    aliases: ["LVal"],
		    visitor: ["parameter"],
		    fields: {
		      accessibility: {
		        validate: assertOneOf("public", "private", "protected"),
		        optional: true
		      },
		      readonly: {
		        validate: assertValueType("boolean"),
		        optional: true
		      },
		      parameter: {
		        validate: assertNodeType("Identifier", "AssignmentPattern")
		      },
		      override: {
		        validate: assertValueType("boolean"),
		        optional: true
		      },
		      decorators: {
		        validate: chain$1(assertValueType("array"), assertEach(assertNodeType("Decorator"))),
		        optional: true
		      }
		    }
		  });
		  defineType("TSDeclareFunction", {
		    aliases: ["Statement", "Declaration"],
		    visitor: ["id", "typeParameters", "params", "returnType"],
		    fields: Object.assign({}, functionDeclarationCommon(), tSFunctionTypeAnnotationCommon())
		  });
		  defineType("TSDeclareMethod", {
		    visitor: ["decorators", "key", "typeParameters", "params", "returnType"],
		    fields: Object.assign({}, classMethodOrDeclareMethodCommon(), tSFunctionTypeAnnotationCommon())
		  });
		  defineType("TSQualifiedName", {
		    aliases: ["TSEntityName"],
		    visitor: ["left", "right"],
		    fields: {
		      left: validateType("TSEntityName"),
		      right: validateType("Identifier")
		    }
		  });
		  var signatureDeclarationCommon = function signatureDeclarationCommon() {
		    var _ref;
		    return _ref = {
		      typeParameters: validateOptionalType("TSTypeParameterDeclaration")
		    }, _ref["parameters"] = validateArrayOfType(["ArrayPattern", "Identifier", "ObjectPattern", "RestElement"]), _ref["typeAnnotation"] = validateOptionalType("TSTypeAnnotation"), _ref;
		  };
		  var callConstructSignatureDeclaration = {
		    aliases: ["TSTypeElement"],
		    visitor: ["typeParameters", "parameters", "typeAnnotation"],
		    fields: signatureDeclarationCommon()
		  };
		  defineType("TSCallSignatureDeclaration", callConstructSignatureDeclaration);
		  defineType("TSConstructSignatureDeclaration", callConstructSignatureDeclaration);
		  var namedTypeElementCommon = function namedTypeElementCommon() {
		    return {
		      key: validateType("Expression"),
		      computed: {
		        "default": false
		      },
		      optional: validateOptional(bool$b)
		    };
		  };
		  defineType("TSPropertySignature", {
		    aliases: ["TSTypeElement"],
		    visitor: ["key", "typeAnnotation"],
		    fields: Object.assign({}, namedTypeElementCommon(), {
		      readonly: validateOptional(bool$b),
		      typeAnnotation: validateOptionalType("TSTypeAnnotation"),
		      kind: {
		        validate: assertOneOf("get", "set")
		      }
		    })
		  });
		  defineType("TSMethodSignature", {
		    aliases: ["TSTypeElement"],
		    visitor: ["key", "typeParameters", "parameters", "typeAnnotation"],
		    fields: Object.assign({}, signatureDeclarationCommon(), namedTypeElementCommon(), {
		      kind: {
		        validate: assertOneOf("method", "get", "set")
		      }
		    })
		  });
		  defineType("TSIndexSignature", {
		    aliases: ["TSTypeElement"],
		    visitor: ["parameters", "typeAnnotation"],
		    fields: {
		      readonly: validateOptional(bool$b),
		      "static": validateOptional(bool$b),
		      parameters: validateArrayOfType("Identifier"),
		      typeAnnotation: validateOptionalType("TSTypeAnnotation")
		    }
		  });
		  var tsKeywordTypes = ["TSAnyKeyword", "TSBooleanKeyword", "TSBigIntKeyword", "TSIntrinsicKeyword", "TSNeverKeyword", "TSNullKeyword", "TSNumberKeyword", "TSObjectKeyword", "TSStringKeyword", "TSSymbolKeyword", "TSUndefinedKeyword", "TSUnknownKeyword", "TSVoidKeyword"];
		  for (var _i$1 = 0, _tsKeywordTypes = tsKeywordTypes; _i$1 < _tsKeywordTypes.length; _i$1++) {
		    var type$1 = _tsKeywordTypes[_i$1];
		    defineType(type$1, {
		      aliases: ["TSType", "TSBaseType"],
		      visitor: [],
		      fields: {}
		    });
		  }
		  defineType("TSThisType", {
		    aliases: ["TSType", "TSBaseType"],
		    visitor: [],
		    fields: {}
		  });
		  var fnOrCtrBase = {
		    aliases: ["TSType"],
		    visitor: ["typeParameters", "parameters", "typeAnnotation"]
		  };
		  defineType("TSFunctionType", Object.assign({}, fnOrCtrBase, {
		    fields: signatureDeclarationCommon()
		  }));
		  defineType("TSConstructorType", Object.assign({}, fnOrCtrBase, {
		    fields: Object.assign({}, signatureDeclarationCommon(), {
		      "abstract": validateOptional(bool$b)
		    })
		  }));
		  defineType("TSTypeReference", {
		    aliases: ["TSType"],
		    visitor: ["typeName", "typeParameters"],
		    fields: {
		      typeName: validateType("TSEntityName"),
		      typeParameters: validateOptionalType("TSTypeParameterInstantiation")
		    }
		  });
		  defineType("TSTypePredicate", {
		    aliases: ["TSType"],
		    visitor: ["parameterName", "typeAnnotation"],
		    builder: ["parameterName", "typeAnnotation", "asserts"],
		    fields: {
		      parameterName: validateType(["Identifier", "TSThisType"]),
		      typeAnnotation: validateOptionalType("TSTypeAnnotation"),
		      asserts: validateOptional(bool$b)
		    }
		  });
		  defineType("TSTypeQuery", {
		    aliases: ["TSType"],
		    visitor: ["exprName", "typeParameters"],
		    fields: {
		      exprName: validateType(["TSEntityName", "TSImportType"]),
		      typeParameters: validateOptionalType("TSTypeParameterInstantiation")
		    }
		  });
		  defineType("TSTypeLiteral", {
		    aliases: ["TSType"],
		    visitor: ["members"],
		    fields: {
		      members: validateArrayOfType("TSTypeElement")
		    }
		  });
		  defineType("TSArrayType", {
		    aliases: ["TSType"],
		    visitor: ["elementType"],
		    fields: {
		      elementType: validateType("TSType")
		    }
		  });
		  defineType("TSTupleType", {
		    aliases: ["TSType"],
		    visitor: ["elementTypes"],
		    fields: {
		      elementTypes: validateArrayOfType(["TSType", "TSNamedTupleMember"])
		    }
		  });
		  defineType("TSOptionalType", {
		    aliases: ["TSType"],
		    visitor: ["typeAnnotation"],
		    fields: {
		      typeAnnotation: validateType("TSType")
		    }
		  });
		  defineType("TSRestType", {
		    aliases: ["TSType"],
		    visitor: ["typeAnnotation"],
		    fields: {
		      typeAnnotation: validateType("TSType")
		    }
		  });
		  defineType("TSNamedTupleMember", {
		    visitor: ["label", "elementType"],
		    builder: ["label", "elementType", "optional"],
		    fields: {
		      label: validateType("Identifier"),
		      optional: {
		        validate: bool$b,
		        "default": false
		      },
		      elementType: validateType("TSType")
		    }
		  });
		  var unionOrIntersection = {
		    aliases: ["TSType"],
		    visitor: ["types"],
		    fields: {
		      types: validateArrayOfType("TSType")
		    }
		  };
		  defineType("TSUnionType", unionOrIntersection);
		  defineType("TSIntersectionType", unionOrIntersection);
		  defineType("TSConditionalType", {
		    aliases: ["TSType"],
		    visitor: ["checkType", "extendsType", "trueType", "falseType"],
		    fields: {
		      checkType: validateType("TSType"),
		      extendsType: validateType("TSType"),
		      trueType: validateType("TSType"),
		      falseType: validateType("TSType")
		    }
		  });
		  defineType("TSInferType", {
		    aliases: ["TSType"],
		    visitor: ["typeParameter"],
		    fields: {
		      typeParameter: validateType("TSTypeParameter")
		    }
		  });
		  defineType("TSParenthesizedType", {
		    aliases: ["TSType"],
		    visitor: ["typeAnnotation"],
		    fields: {
		      typeAnnotation: validateType("TSType")
		    }
		  });
		  defineType("TSTypeOperator", {
		    aliases: ["TSType"],
		    visitor: ["typeAnnotation"],
		    fields: {
		      operator: validate$6(assertValueType("string")),
		      typeAnnotation: validateType("TSType")
		    }
		  });
		  defineType("TSIndexedAccessType", {
		    aliases: ["TSType"],
		    visitor: ["objectType", "indexType"],
		    fields: {
		      objectType: validateType("TSType"),
		      indexType: validateType("TSType")
		    }
		  });
		  defineType("TSMappedType", {
		    aliases: ["TSType"],
		    visitor: ["typeParameter", "typeAnnotation", "nameType"],
		    fields: {
		      readonly: validateOptional(assertOneOf(true, false, "+", "-")),
		      typeParameter: validateType("TSTypeParameter"),
		      optional: validateOptional(assertOneOf(true, false, "+", "-")),
		      typeAnnotation: validateOptionalType("TSType"),
		      nameType: validateOptionalType("TSType")
		    }
		  });
		  defineType("TSLiteralType", {
		    aliases: ["TSType", "TSBaseType"],
		    visitor: ["literal"],
		    fields: {
		      literal: {
		        validate: function () {
		          var unaryExpression = assertNodeType("NumericLiteral", "BigIntLiteral");
		          var unaryOperator = assertOneOf("-");
		          var literal = assertNodeType("NumericLiteral", "StringLiteral", "BooleanLiteral", "BigIntLiteral", "TemplateLiteral");
		          function validator(parent, key, node) {
		            if (is$1("UnaryExpression", node)) {
		              unaryOperator(node, "operator", node.operator);
		              unaryExpression(node, "argument", node.argument);
		            } else {
		              literal(parent, key, node);
		            }
		          }
		          validator.oneOfNodeTypes = ["NumericLiteral", "StringLiteral", "BooleanLiteral", "BigIntLiteral", "TemplateLiteral", "UnaryExpression"];
		          return validator;
		        }()
		      }
		    }
		  });
		  defineType("TSExpressionWithTypeArguments", {
		    aliases: ["TSType"],
		    visitor: ["expression", "typeParameters"],
		    fields: {
		      expression: validateType("TSEntityName"),
		      typeParameters: validateOptionalType("TSTypeParameterInstantiation")
		    }
		  });
		  defineType("TSInterfaceDeclaration", {
		    aliases: ["Statement", "Declaration"],
		    visitor: ["id", "typeParameters", "extends", "body"],
		    fields: {
		      declare: validateOptional(bool$b),
		      id: validateType("Identifier"),
		      typeParameters: validateOptionalType("TSTypeParameterDeclaration"),
		      "extends": validateOptional(arrayOfType("TSExpressionWithTypeArguments")),
		      body: validateType("TSInterfaceBody")
		    }
		  });
		  defineType("TSInterfaceBody", {
		    visitor: ["body"],
		    fields: {
		      body: validateArrayOfType("TSTypeElement")
		    }
		  });
		  defineType("TSTypeAliasDeclaration", {
		    aliases: ["Statement", "Declaration"],
		    visitor: ["id", "typeParameters", "typeAnnotation"],
		    fields: {
		      declare: validateOptional(bool$b),
		      id: validateType("Identifier"),
		      typeParameters: validateOptionalType("TSTypeParameterDeclaration"),
		      typeAnnotation: validateType("TSType")
		    }
		  });
		  defineType("TSInstantiationExpression", {
		    aliases: ["Expression"],
		    visitor: ["expression", "typeParameters"],
		    fields: {
		      expression: validateType("Expression"),
		      typeParameters: validateOptionalType("TSTypeParameterInstantiation")
		    }
		  });
		  var TSTypeExpression$1 = {
		    aliases: ["Expression", "LVal", "PatternLike"],
		    visitor: ["expression", "typeAnnotation"],
		    fields: {
		      expression: validateType("Expression"),
		      typeAnnotation: validateType("TSType")
		    }
		  };
		  defineType("TSAsExpression", TSTypeExpression$1);
		  defineType("TSSatisfiesExpression", TSTypeExpression$1);
		  defineType("TSTypeAssertion", {
		    aliases: ["Expression", "LVal", "PatternLike"],
		    visitor: ["typeAnnotation", "expression"],
		    fields: {
		      typeAnnotation: validateType("TSType"),
		      expression: validateType("Expression")
		    }
		  });
		  defineType("TSEnumDeclaration", {
		    aliases: ["Statement", "Declaration"],
		    visitor: ["id", "members"],
		    fields: {
		      declare: validateOptional(bool$b),
		      "const": validateOptional(bool$b),
		      id: validateType("Identifier"),
		      members: validateArrayOfType("TSEnumMember"),
		      initializer: validateOptionalType("Expression")
		    }
		  });
		  defineType("TSEnumMember", {
		    visitor: ["id", "initializer"],
		    fields: {
		      id: validateType(["Identifier", "StringLiteral"]),
		      initializer: validateOptionalType("Expression")
		    }
		  });
		  defineType("TSModuleDeclaration", {
		    aliases: ["Statement", "Declaration"],
		    visitor: ["id", "body"],
		    fields: {
		      declare: validateOptional(bool$b),
		      global: validateOptional(bool$b),
		      id: validateType(["Identifier", "StringLiteral"]),
		      body: validateType(["TSModuleBlock", "TSModuleDeclaration"])
		    }
		  });
		  defineType("TSModuleBlock", {
		    aliases: ["Scopable", "Block", "BlockParent", "FunctionParent"],
		    visitor: ["body"],
		    fields: {
		      body: validateArrayOfType("Statement")
		    }
		  });
		  defineType("TSImportType", {
		    aliases: ["TSType"],
		    visitor: ["argument", "qualifier", "typeParameters"],
		    fields: {
		      argument: validateType("StringLiteral"),
		      qualifier: validateOptionalType("TSEntityName"),
		      typeParameters: validateOptionalType("TSTypeParameterInstantiation"),
		      options: {
		        validate: assertNodeType("Expression"),
		        optional: true
		      }
		    }
		  });
		  defineType("TSImportEqualsDeclaration", {
		    aliases: ["Statement"],
		    visitor: ["id", "moduleReference"],
		    fields: {
		      isExport: validate$6(bool$b),
		      id: validateType("Identifier"),
		      moduleReference: validateType(["TSEntityName", "TSExternalModuleReference"]),
		      importKind: {
		        validate: assertOneOf("type", "value"),
		        optional: true
		      }
		    }
		  });
		  defineType("TSExternalModuleReference", {
		    visitor: ["expression"],
		    fields: {
		      expression: validateType("StringLiteral")
		    }
		  });
		  defineType("TSNonNullExpression", {
		    aliases: ["Expression", "LVal", "PatternLike"],
		    visitor: ["expression"],
		    fields: {
		      expression: validateType("Expression")
		    }
		  });
		  defineType("TSExportAssignment", {
		    aliases: ["Statement"],
		    visitor: ["expression"],
		    fields: {
		      expression: validateType("Expression")
		    }
		  });
		  defineType("TSNamespaceExportDeclaration", {
		    aliases: ["Statement"],
		    visitor: ["id"],
		    fields: {
		      id: validateType("Identifier")
		    }
		  });
		  defineType("TSTypeAnnotation", {
		    visitor: ["typeAnnotation"],
		    fields: {
		      typeAnnotation: {
		        validate: assertNodeType("TSType")
		      }
		    }
		  });
		  defineType("TSTypeParameterInstantiation", {
		    visitor: ["params"],
		    fields: {
		      params: {
		        validate: chain$1(assertValueType("array"), assertEach(assertNodeType("TSType")))
		      }
		    }
		  });
		  defineType("TSTypeParameterDeclaration", {
		    visitor: ["params"],
		    fields: {
		      params: {
		        validate: chain$1(assertValueType("array"), assertEach(assertNodeType("TSTypeParameter")))
		      }
		    }
		  });
		  defineType("TSTypeParameter", {
		    builder: ["constraint", "default", "name"],
		    visitor: ["constraint", "default"],
		    fields: {
		      name: {
		        validate: assertValueType("string")
		      },
		      "in": {
		        validate: assertValueType("boolean"),
		        optional: true
		      },
		      out: {
		        validate: assertValueType("boolean"),
		        optional: true
		      },
		      "const": {
		        validate: assertValueType("boolean"),
		        optional: true
		      },
		      constraint: {
		        validate: assertNodeType("TSType"),
		        optional: true
		      },
		      "default": {
		        validate: assertNodeType("TSType"),
		        optional: true
		      }
		    }
		  });

		  var DEPRECATED_ALIASES$1 = {
		    ModuleDeclaration: "ImportOrExportDeclaration"
		  };

		  Object.keys(DEPRECATED_ALIASES$1).forEach(function (deprecatedAlias) {
		    FLIPPED_ALIAS_KEYS$3[deprecatedAlias] = FLIPPED_ALIAS_KEYS$3[DEPRECATED_ALIASES$1[deprecatedAlias]];
		  });
		  toFastProperties(VISITOR_KEYS$5);
		  toFastProperties(ALIAS_KEYS);
		  toFastProperties(FLIPPED_ALIAS_KEYS$3);
		  toFastProperties(NODE_FIELDS);
		  toFastProperties(BUILDER_KEYS);
		  toFastProperties(DEPRECATED_KEYS$1);
		  toFastProperties(PLACEHOLDERS_ALIAS);
		  toFastProperties(PLACEHOLDERS_FLIPPED_ALIAS);
		  var TYPES$1 = [].concat(Object.keys(VISITOR_KEYS$5), Object.keys(FLIPPED_ALIAS_KEYS$3), Object.keys(DEPRECATED_KEYS$1));

		  function validate$5(node, key, val) {
		    if (!node) return;
		    var fields = NODE_FIELDS[node.type];
		    if (!fields) return;
		    var field = fields[key];
		    validateField(node, key, val, field);
		    validateChild(node, key, val);
		  }
		  function validateField(node, key, val, field) {
		    if (!(field != null && field.validate)) return;
		    if (field.optional && val == null) return;
		    field.validate(node, key, val);
		  }
		  function validateChild(node, key, val) {
		    if (val == null) return;
		    var validate = NODE_PARENT_VALIDATIONS[val.type];
		    if (!validate) return;
		    validate(node, key, val);
		  }

		  function validateNode(node) {
		    var keys = BUILDER_KEYS[node.type];
		    for (var _iterator = _createForOfIteratorHelperLoose(keys), _step; !(_step = _iterator()).done;) {
		      var key = _step.value;
		      validate$5(node, key, node[key]);
		    }
		    return node;
		  }

		  function arrayExpression$1(elements) {
		    if (elements === void 0) {
		      elements = [];
		    }
		    return validateNode({
		      type: "ArrayExpression",
		      elements: elements
		    });
		  }
		  function assignmentExpression$d(operator, left, right) {
		    return validateNode({
		      type: "AssignmentExpression",
		      operator: operator,
		      left: left,
		      right: right
		    });
		  }
		  function binaryExpression$5(operator, left, right) {
		    return validateNode({
		      type: "BinaryExpression",
		      operator: operator,
		      left: left,
		      right: right
		    });
		  }
		  function interpreterDirective$1(value) {
		    return validateNode({
		      type: "InterpreterDirective",
		      value: value
		    });
		  }
		  function directive$1(value) {
		    return validateNode({
		      type: "Directive",
		      value: value
		    });
		  }
		  function directiveLiteral$1(value) {
		    return validateNode({
		      type: "DirectiveLiteral",
		      value: value
		    });
		  }
		  function blockStatement$6(body, directives) {
		    if (directives === void 0) {
		      directives = [];
		    }
		    return validateNode({
		      type: "BlockStatement",
		      body: body,
		      directives: directives
		    });
		  }
		  function breakStatement(label) {
		    if (label === void 0) {
		      label = null;
		    }
		    return validateNode({
		      type: "BreakStatement",
		      label: label
		    });
		  }
		  function callExpression$d(callee, _arguments) {
		    return validateNode({
		      type: "CallExpression",
		      callee: callee,
		      arguments: _arguments
		    });
		  }
		  function catchClause(param, body) {
		    if (param === void 0) {
		      param = null;
		    }
		    return validateNode({
		      type: "CatchClause",
		      param: param,
		      body: body
		    });
		  }
		  function conditionalExpression$5(test, consequent, alternate) {
		    return validateNode({
		      type: "ConditionalExpression",
		      test: test,
		      consequent: consequent,
		      alternate: alternate
		    });
		  }
		  function continueStatement(label) {
		    if (label === void 0) {
		      label = null;
		    }
		    return validateNode({
		      type: "ContinueStatement",
		      label: label
		    });
		  }
		  function debuggerStatement() {
		    return {
		      type: "DebuggerStatement"
		    };
		  }
		  function doWhileStatement(test, body) {
		    return validateNode({
		      type: "DoWhileStatement",
		      test: test,
		      body: body
		    });
		  }
		  function emptyStatement$1() {
		    return {
		      type: "EmptyStatement"
		    };
		  }
		  function expressionStatement$a(expression) {
		    return validateNode({
		      type: "ExpressionStatement",
		      expression: expression
		    });
		  }
		  function file$2(program, comments, tokens) {
		    if (comments === void 0) {
		      comments = null;
		    }
		    if (tokens === void 0) {
		      tokens = null;
		    }
		    return validateNode({
		      type: "File",
		      program: program,
		      comments: comments,
		      tokens: tokens
		    });
		  }
		  function forInStatement(left, right, body) {
		    return validateNode({
		      type: "ForInStatement",
		      left: left,
		      right: right,
		      body: body
		    });
		  }
		  function forStatement(init, test, update, body) {
		    if (init === void 0) {
		      init = null;
		    }
		    if (test === void 0) {
		      test = null;
		    }
		    if (update === void 0) {
		      update = null;
		    }
		    return validateNode({
		      type: "ForStatement",
		      init: init,
		      test: test,
		      update: update,
		      body: body
		    });
		  }
		  function functionDeclaration(id, params, body, generator, async) {
		    if (id === void 0) {
		      id = null;
		    }
		    if (generator === void 0) {
		      generator = false;
		    }
		    if (async === void 0) {
		      async = false;
		    }
		    return validateNode({
		      type: "FunctionDeclaration",
		      id: id,
		      params: params,
		      body: body,
		      generator: generator,
		      async: async
		    });
		  }
		  function functionExpression$2(id, params, body, generator, async) {
		    if (id === void 0) {
		      id = null;
		    }
		    if (generator === void 0) {
		      generator = false;
		    }
		    if (async === void 0) {
		      async = false;
		    }
		    return validateNode({
		      type: "FunctionExpression",
		      id: id,
		      params: params,
		      body: body,
		      generator: generator,
		      async: async
		    });
		  }
		  function identifier$j(name) {
		    return validateNode({
		      type: "Identifier",
		      name: name
		    });
		  }
		  function ifStatement(test, consequent, alternate) {
		    if (alternate === void 0) {
		      alternate = null;
		    }
		    return validateNode({
		      type: "IfStatement",
		      test: test,
		      consequent: consequent,
		      alternate: alternate
		    });
		  }
		  function labeledStatement(label, body) {
		    return validateNode({
		      type: "LabeledStatement",
		      label: label,
		      body: body
		    });
		  }
		  function stringLiteral$8(value) {
		    return validateNode({
		      type: "StringLiteral",
		      value: value
		    });
		  }
		  function numericLiteral$8(value) {
		    return validateNode({
		      type: "NumericLiteral",
		      value: value
		    });
		  }
		  function nullLiteral$2() {
		    return {
		      type: "NullLiteral"
		    };
		  }
		  function booleanLiteral$4(value) {
		    return validateNode({
		      type: "BooleanLiteral",
		      value: value
		    });
		  }
		  function regExpLiteral(pattern, flags) {
		    if (flags === void 0) {
		      flags = "";
		    }
		    return validateNode({
		      type: "RegExpLiteral",
		      pattern: pattern,
		      flags: flags
		    });
		  }
		  function logicalExpression$3(operator, left, right) {
		    return validateNode({
		      type: "LogicalExpression",
		      operator: operator,
		      left: left,
		      right: right
		    });
		  }
		  function memberExpression$c(object, property, computed, optional) {
		    if (computed === void 0) {
		      computed = false;
		    }
		    if (optional === void 0) {
		      optional = null;
		    }
		    return validateNode({
		      type: "MemberExpression",
		      object: object,
		      property: property,
		      computed: computed,
		      optional: optional
		    });
		  }
		  function newExpression(callee, _arguments) {
		    return validateNode({
		      type: "NewExpression",
		      callee: callee,
		      arguments: _arguments
		    });
		  }
		  function program$3(body, directives, sourceType, interpreter) {
		    if (directives === void 0) {
		      directives = [];
		    }
		    if (sourceType === void 0) {
		      sourceType = "script";
		    }
		    if (interpreter === void 0) {
		      interpreter = null;
		    }
		    return validateNode({
		      type: "Program",
		      body: body,
		      directives: directives,
		      sourceType: sourceType,
		      interpreter: interpreter
		    });
		  }
		  function objectExpression$3(properties) {
		    return validateNode({
		      type: "ObjectExpression",
		      properties: properties
		    });
		  }
		  function objectMethod(kind, key, params, body, computed, generator, async) {
		    if (kind === void 0) {
		      kind = "method";
		    }
		    if (computed === void 0) {
		      computed = false;
		    }
		    if (generator === void 0) {
		      generator = false;
		    }
		    if (async === void 0) {
		      async = false;
		    }
		    return validateNode({
		      type: "ObjectMethod",
		      kind: kind,
		      key: key,
		      params: params,
		      body: body,
		      computed: computed,
		      generator: generator,
		      async: async
		    });
		  }
		  function objectProperty$1(key, value, computed, shorthand, decorators) {
		    if (computed === void 0) {
		      computed = false;
		    }
		    if (shorthand === void 0) {
		      shorthand = false;
		    }
		    if (decorators === void 0) {
		      decorators = null;
		    }
		    return validateNode({
		      type: "ObjectProperty",
		      key: key,
		      value: value,
		      computed: computed,
		      shorthand: shorthand,
		      decorators: decorators
		    });
		  }
		  function restElement$2(argument) {
		    return validateNode({
		      type: "RestElement",
		      argument: argument
		    });
		  }
		  function returnStatement$3(argument) {
		    if (argument === void 0) {
		      argument = null;
		    }
		    return validateNode({
		      type: "ReturnStatement",
		      argument: argument
		    });
		  }
		  function sequenceExpression$8(expressions) {
		    return validateNode({
		      type: "SequenceExpression",
		      expressions: expressions
		    });
		  }
		  function parenthesizedExpression(expression) {
		    return validateNode({
		      type: "ParenthesizedExpression",
		      expression: expression
		    });
		  }
		  function switchCase(test, consequent) {
		    if (test === void 0) {
		      test = null;
		    }
		    return validateNode({
		      type: "SwitchCase",
		      test: test,
		      consequent: consequent
		    });
		  }
		  function switchStatement(discriminant, cases) {
		    return validateNode({
		      type: "SwitchStatement",
		      discriminant: discriminant,
		      cases: cases
		    });
		  }
		  function thisExpression$4() {
		    return {
		      type: "ThisExpression"
		    };
		  }
		  function throwStatement(argument) {
		    return validateNode({
		      type: "ThrowStatement",
		      argument: argument
		    });
		  }
		  function tryStatement(block, handler, finalizer) {
		    if (handler === void 0) {
		      handler = null;
		    }
		    if (finalizer === void 0) {
		      finalizer = null;
		    }
		    return validateNode({
		      type: "TryStatement",
		      block: block,
		      handler: handler,
		      finalizer: finalizer
		    });
		  }
		  function unaryExpression$6(operator, argument, prefix) {
		    if (prefix === void 0) {
		      prefix = true;
		    }
		    return validateNode({
		      type: "UnaryExpression",
		      operator: operator,
		      argument: argument,
		      prefix: prefix
		    });
		  }
		  function updateExpression$1(operator, argument, prefix) {
		    if (prefix === void 0) {
		      prefix = false;
		    }
		    return validateNode({
		      type: "UpdateExpression",
		      operator: operator,
		      argument: argument,
		      prefix: prefix
		    });
		  }
		  function variableDeclaration$8(kind, declarations) {
		    return validateNode({
		      type: "VariableDeclaration",
		      kind: kind,
		      declarations: declarations
		    });
		  }
		  function variableDeclarator$8(id, init) {
		    if (init === void 0) {
		      init = null;
		    }
		    return validateNode({
		      type: "VariableDeclarator",
		      id: id,
		      init: init
		    });
		  }
		  function whileStatement(test, body) {
		    return validateNode({
		      type: "WhileStatement",
		      test: test,
		      body: body
		    });
		  }
		  function withStatement(object, body) {
		    return validateNode({
		      type: "WithStatement",
		      object: object,
		      body: body
		    });
		  }
		  function assignmentPattern(left, right) {
		    return validateNode({
		      type: "AssignmentPattern",
		      left: left,
		      right: right
		    });
		  }
		  function arrayPattern(elements) {
		    return validateNode({
		      type: "ArrayPattern",
		      elements: elements
		    });
		  }
		  function arrowFunctionExpression$4(params, body, async) {
		    if (async === void 0) {
		      async = false;
		    }
		    return validateNode({
		      type: "ArrowFunctionExpression",
		      params: params,
		      body: body,
		      async: async,
		      expression: null
		    });
		  }
		  function classBody(body) {
		    return validateNode({
		      type: "ClassBody",
		      body: body
		    });
		  }
		  function classExpression(id, superClass, body, decorators) {
		    if (id === void 0) {
		      id = null;
		    }
		    if (superClass === void 0) {
		      superClass = null;
		    }
		    if (decorators === void 0) {
		      decorators = null;
		    }
		    return validateNode({
		      type: "ClassExpression",
		      id: id,
		      superClass: superClass,
		      body: body,
		      decorators: decorators
		    });
		  }
		  function classDeclaration(id, superClass, body, decorators) {
		    if (id === void 0) {
		      id = null;
		    }
		    if (superClass === void 0) {
		      superClass = null;
		    }
		    if (decorators === void 0) {
		      decorators = null;
		    }
		    return validateNode({
		      type: "ClassDeclaration",
		      id: id,
		      superClass: superClass,
		      body: body,
		      decorators: decorators
		    });
		  }
		  function exportAllDeclaration(source) {
		    return validateNode({
		      type: "ExportAllDeclaration",
		      source: source
		    });
		  }
		  function exportDefaultDeclaration(declaration) {
		    return validateNode({
		      type: "ExportDefaultDeclaration",
		      declaration: declaration
		    });
		  }
		  function exportNamedDeclaration$2(declaration, specifiers, source) {
		    if (declaration === void 0) {
		      declaration = null;
		    }
		    if (specifiers === void 0) {
		      specifiers = [];
		    }
		    if (source === void 0) {
		      source = null;
		    }
		    return validateNode({
		      type: "ExportNamedDeclaration",
		      declaration: declaration,
		      specifiers: specifiers,
		      source: source
		    });
		  }
		  function exportSpecifier$2(local, exported) {
		    return validateNode({
		      type: "ExportSpecifier",
		      local: local,
		      exported: exported
		    });
		  }
		  function forOfStatement(left, right, body, _await) {
		    if (_await === void 0) {
		      _await = false;
		    }
		    return validateNode({
		      type: "ForOfStatement",
		      left: left,
		      right: right,
		      body: body,
		      "await": _await
		    });
		  }
		  function importDeclaration$1(specifiers, source) {
		    return validateNode({
		      type: "ImportDeclaration",
		      specifiers: specifiers,
		      source: source
		    });
		  }
		  function importDefaultSpecifier$1(local) {
		    return validateNode({
		      type: "ImportDefaultSpecifier",
		      local: local
		    });
		  }
		  function importNamespaceSpecifier$1(local) {
		    return validateNode({
		      type: "ImportNamespaceSpecifier",
		      local: local
		    });
		  }
		  function importSpecifier$2(local, imported) {
		    return validateNode({
		      type: "ImportSpecifier",
		      local: local,
		      imported: imported
		    });
		  }
		  function importExpression(source, options) {
		    if (options === void 0) {
		      options = null;
		    }
		    return validateNode({
		      type: "ImportExpression",
		      source: source,
		      options: options
		    });
		  }
		  function metaProperty$1(meta, property) {
		    return validateNode({
		      type: "MetaProperty",
		      meta: meta,
		      property: property
		    });
		  }
		  function classMethod(kind, key, params, body, computed, _static, generator, async) {
		    if (kind === void 0) {
		      kind = "method";
		    }
		    if (computed === void 0) {
		      computed = false;
		    }
		    if (_static === void 0) {
		      _static = false;
		    }
		    if (generator === void 0) {
		      generator = false;
		    }
		    if (async === void 0) {
		      async = false;
		    }
		    return validateNode({
		      type: "ClassMethod",
		      kind: kind,
		      key: key,
		      params: params,
		      body: body,
		      computed: computed,
		      "static": _static,
		      generator: generator,
		      async: async
		    });
		  }
		  function objectPattern$1(properties) {
		    return validateNode({
		      type: "ObjectPattern",
		      properties: properties
		    });
		  }
		  function spreadElement$2(argument) {
		    return validateNode({
		      type: "SpreadElement",
		      argument: argument
		    });
		  }
		  function _super$1() {
		    return {
		      type: "Super"
		    };
		  }
		  function taggedTemplateExpression(tag, quasi) {
		    return validateNode({
		      type: "TaggedTemplateExpression",
		      tag: tag,
		      quasi: quasi
		    });
		  }
		  function templateElement(value, tail) {
		    if (tail === void 0) {
		      tail = false;
		    }
		    return validateNode({
		      type: "TemplateElement",
		      value: value,
		      tail: tail
		    });
		  }
		  function templateLiteral(quasis, expressions) {
		    return validateNode({
		      type: "TemplateLiteral",
		      quasis: quasis,
		      expressions: expressions
		    });
		  }
		  function yieldExpression$2(argument, delegate) {
		    if (argument === void 0) {
		      argument = null;
		    }
		    if (delegate === void 0) {
		      delegate = false;
		    }
		    return validateNode({
		      type: "YieldExpression",
		      argument: argument,
		      delegate: delegate
		    });
		  }
		  function awaitExpression$1(argument) {
		    return validateNode({
		      type: "AwaitExpression",
		      argument: argument
		    });
		  }
		  function _import() {
		    return {
		      type: "Import"
		    };
		  }
		  function bigIntLiteral(value) {
		    return validateNode({
		      type: "BigIntLiteral",
		      value: value
		    });
		  }
		  function exportNamespaceSpecifier(exported) {
		    return validateNode({
		      type: "ExportNamespaceSpecifier",
		      exported: exported
		    });
		  }
		  function optionalMemberExpression$2(object, property, computed, optional) {
		    if (computed === void 0) {
		      computed = false;
		    }
		    return validateNode({
		      type: "OptionalMemberExpression",
		      object: object,
		      property: property,
		      computed: computed,
		      optional: optional
		    });
		  }
		  function optionalCallExpression$2(callee, _arguments, optional) {
		    return validateNode({
		      type: "OptionalCallExpression",
		      callee: callee,
		      arguments: _arguments,
		      optional: optional
		    });
		  }
		  function classProperty(key, value, typeAnnotation, decorators, computed, _static) {
		    if (value === void 0) {
		      value = null;
		    }
		    if (typeAnnotation === void 0) {
		      typeAnnotation = null;
		    }
		    if (decorators === void 0) {
		      decorators = null;
		    }
		    if (computed === void 0) {
		      computed = false;
		    }
		    if (_static === void 0) {
		      _static = false;
		    }
		    return validateNode({
		      type: "ClassProperty",
		      key: key,
		      value: value,
		      typeAnnotation: typeAnnotation,
		      decorators: decorators,
		      computed: computed,
		      "static": _static
		    });
		  }
		  function classAccessorProperty(key, value, typeAnnotation, decorators, computed, _static) {
		    if (value === void 0) {
		      value = null;
		    }
		    if (typeAnnotation === void 0) {
		      typeAnnotation = null;
		    }
		    if (decorators === void 0) {
		      decorators = null;
		    }
		    if (computed === void 0) {
		      computed = false;
		    }
		    if (_static === void 0) {
		      _static = false;
		    }
		    return validateNode({
		      type: "ClassAccessorProperty",
		      key: key,
		      value: value,
		      typeAnnotation: typeAnnotation,
		      decorators: decorators,
		      computed: computed,
		      "static": _static
		    });
		  }
		  function classPrivateProperty(key, value, decorators, _static) {
		    if (value === void 0) {
		      value = null;
		    }
		    if (decorators === void 0) {
		      decorators = null;
		    }
		    if (_static === void 0) {
		      _static = false;
		    }
		    return validateNode({
		      type: "ClassPrivateProperty",
		      key: key,
		      value: value,
		      decorators: decorators,
		      "static": _static
		    });
		  }
		  function classPrivateMethod(kind, key, params, body, _static) {
		    if (kind === void 0) {
		      kind = "method";
		    }
		    if (_static === void 0) {
		      _static = false;
		    }
		    return validateNode({
		      type: "ClassPrivateMethod",
		      kind: kind,
		      key: key,
		      params: params,
		      body: body,
		      "static": _static
		    });
		  }
		  function privateName(id) {
		    return validateNode({
		      type: "PrivateName",
		      id: id
		    });
		  }
		  function staticBlock(body) {
		    return validateNode({
		      type: "StaticBlock",
		      body: body
		    });
		  }
		  function anyTypeAnnotation$2() {
		    return {
		      type: "AnyTypeAnnotation"
		    };
		  }
		  function arrayTypeAnnotation$1(elementType) {
		    return validateNode({
		      type: "ArrayTypeAnnotation",
		      elementType: elementType
		    });
		  }
		  function booleanTypeAnnotation$1() {
		    return {
		      type: "BooleanTypeAnnotation"
		    };
		  }
		  function booleanLiteralTypeAnnotation(value) {
		    return validateNode({
		      type: "BooleanLiteralTypeAnnotation",
		      value: value
		    });
		  }
		  function nullLiteralTypeAnnotation$1() {
		    return {
		      type: "NullLiteralTypeAnnotation"
		    };
		  }
		  function classImplements(id, typeParameters) {
		    if (typeParameters === void 0) {
		      typeParameters = null;
		    }
		    return validateNode({
		      type: "ClassImplements",
		      id: id,
		      typeParameters: typeParameters
		    });
		  }
		  function declareClass(id, typeParameters, _extends, body) {
		    if (typeParameters === void 0) {
		      typeParameters = null;
		    }
		    if (_extends === void 0) {
		      _extends = null;
		    }
		    return validateNode({
		      type: "DeclareClass",
		      id: id,
		      typeParameters: typeParameters,
		      "extends": _extends,
		      body: body
		    });
		  }
		  function declareFunction(id) {
		    return validateNode({
		      type: "DeclareFunction",
		      id: id
		    });
		  }
		  function declareInterface(id, typeParameters, _extends, body) {
		    if (typeParameters === void 0) {
		      typeParameters = null;
		    }
		    if (_extends === void 0) {
		      _extends = null;
		    }
		    return validateNode({
		      type: "DeclareInterface",
		      id: id,
		      typeParameters: typeParameters,
		      "extends": _extends,
		      body: body
		    });
		  }
		  function declareModule(id, body, kind) {
		    if (kind === void 0) {
		      kind = null;
		    }
		    return validateNode({
		      type: "DeclareModule",
		      id: id,
		      body: body,
		      kind: kind
		    });
		  }
		  function declareModuleExports(typeAnnotation) {
		    return validateNode({
		      type: "DeclareModuleExports",
		      typeAnnotation: typeAnnotation
		    });
		  }
		  function declareTypeAlias(id, typeParameters, right) {
		    if (typeParameters === void 0) {
		      typeParameters = null;
		    }
		    return validateNode({
		      type: "DeclareTypeAlias",
		      id: id,
		      typeParameters: typeParameters,
		      right: right
		    });
		  }
		  function declareOpaqueType(id, typeParameters, supertype) {
		    if (typeParameters === void 0) {
		      typeParameters = null;
		    }
		    if (supertype === void 0) {
		      supertype = null;
		    }
		    return validateNode({
		      type: "DeclareOpaqueType",
		      id: id,
		      typeParameters: typeParameters,
		      supertype: supertype
		    });
		  }
		  function declareVariable(id) {
		    return validateNode({
		      type: "DeclareVariable",
		      id: id
		    });
		  }
		  function declareExportDeclaration(declaration, specifiers, source) {
		    if (declaration === void 0) {
		      declaration = null;
		    }
		    if (specifiers === void 0) {
		      specifiers = null;
		    }
		    if (source === void 0) {
		      source = null;
		    }
		    return validateNode({
		      type: "DeclareExportDeclaration",
		      declaration: declaration,
		      specifiers: specifiers,
		      source: source
		    });
		  }
		  function declareExportAllDeclaration(source) {
		    return validateNode({
		      type: "DeclareExportAllDeclaration",
		      source: source
		    });
		  }
		  function declaredPredicate(value) {
		    return validateNode({
		      type: "DeclaredPredicate",
		      value: value
		    });
		  }
		  function existsTypeAnnotation() {
		    return {
		      type: "ExistsTypeAnnotation"
		    };
		  }
		  function functionTypeAnnotation(typeParameters, params, rest, returnType) {
		    if (typeParameters === void 0) {
		      typeParameters = null;
		    }
		    if (rest === void 0) {
		      rest = null;
		    }
		    return validateNode({
		      type: "FunctionTypeAnnotation",
		      typeParameters: typeParameters,
		      params: params,
		      rest: rest,
		      returnType: returnType
		    });
		  }
		  function functionTypeParam(name, typeAnnotation) {
		    if (name === void 0) {
		      name = null;
		    }
		    return validateNode({
		      type: "FunctionTypeParam",
		      name: name,
		      typeAnnotation: typeAnnotation
		    });
		  }
		  function genericTypeAnnotation$1(id, typeParameters) {
		    if (typeParameters === void 0) {
		      typeParameters = null;
		    }
		    return validateNode({
		      type: "GenericTypeAnnotation",
		      id: id,
		      typeParameters: typeParameters
		    });
		  }
		  function inferredPredicate() {
		    return {
		      type: "InferredPredicate"
		    };
		  }
		  function interfaceExtends(id, typeParameters) {
		    if (typeParameters === void 0) {
		      typeParameters = null;
		    }
		    return validateNode({
		      type: "InterfaceExtends",
		      id: id,
		      typeParameters: typeParameters
		    });
		  }
		  function interfaceDeclaration(id, typeParameters, _extends, body) {
		    if (typeParameters === void 0) {
		      typeParameters = null;
		    }
		    if (_extends === void 0) {
		      _extends = null;
		    }
		    return validateNode({
		      type: "InterfaceDeclaration",
		      id: id,
		      typeParameters: typeParameters,
		      "extends": _extends,
		      body: body
		    });
		  }
		  function interfaceTypeAnnotation(_extends, body) {
		    if (_extends === void 0) {
		      _extends = null;
		    }
		    return validateNode({
		      type: "InterfaceTypeAnnotation",
		      "extends": _extends,
		      body: body
		    });
		  }
		  function intersectionTypeAnnotation(types) {
		    return validateNode({
		      type: "IntersectionTypeAnnotation",
		      types: types
		    });
		  }
		  function mixedTypeAnnotation() {
		    return {
		      type: "MixedTypeAnnotation"
		    };
		  }
		  function emptyTypeAnnotation() {
		    return {
		      type: "EmptyTypeAnnotation"
		    };
		  }
		  function nullableTypeAnnotation(typeAnnotation) {
		    return validateNode({
		      type: "NullableTypeAnnotation",
		      typeAnnotation: typeAnnotation
		    });
		  }
		  function numberLiteralTypeAnnotation(value) {
		    return validateNode({
		      type: "NumberLiteralTypeAnnotation",
		      value: value
		    });
		  }
		  function numberTypeAnnotation$2() {
		    return {
		      type: "NumberTypeAnnotation"
		    };
		  }
		  function objectTypeAnnotation(properties, indexers, callProperties, internalSlots, exact) {
		    if (indexers === void 0) {
		      indexers = [];
		    }
		    if (callProperties === void 0) {
		      callProperties = [];
		    }
		    if (internalSlots === void 0) {
		      internalSlots = [];
		    }
		    if (exact === void 0) {
		      exact = false;
		    }
		    return validateNode({
		      type: "ObjectTypeAnnotation",
		      properties: properties,
		      indexers: indexers,
		      callProperties: callProperties,
		      internalSlots: internalSlots,
		      exact: exact
		    });
		  }
		  function objectTypeInternalSlot(id, value, optional, _static, method) {
		    return validateNode({
		      type: "ObjectTypeInternalSlot",
		      id: id,
		      value: value,
		      optional: optional,
		      "static": _static,
		      method: method
		    });
		  }
		  function objectTypeCallProperty(value) {
		    return validateNode({
		      type: "ObjectTypeCallProperty",
		      value: value,
		      "static": null
		    });
		  }
		  function objectTypeIndexer(id, key, value, variance) {
		    if (id === void 0) {
		      id = null;
		    }
		    if (variance === void 0) {
		      variance = null;
		    }
		    return validateNode({
		      type: "ObjectTypeIndexer",
		      id: id,
		      key: key,
		      value: value,
		      variance: variance,
		      "static": null
		    });
		  }
		  function objectTypeProperty(key, value, variance) {
		    if (variance === void 0) {
		      variance = null;
		    }
		    return validateNode({
		      type: "ObjectTypeProperty",
		      key: key,
		      value: value,
		      variance: variance,
		      kind: null,
		      method: null,
		      optional: null,
		      proto: null,
		      "static": null
		    });
		  }
		  function objectTypeSpreadProperty(argument) {
		    return validateNode({
		      type: "ObjectTypeSpreadProperty",
		      argument: argument
		    });
		  }
		  function opaqueType(id, typeParameters, supertype, impltype) {
		    if (typeParameters === void 0) {
		      typeParameters = null;
		    }
		    if (supertype === void 0) {
		      supertype = null;
		    }
		    return validateNode({
		      type: "OpaqueType",
		      id: id,
		      typeParameters: typeParameters,
		      supertype: supertype,
		      impltype: impltype
		    });
		  }
		  function qualifiedTypeIdentifier(id, qualification) {
		    return validateNode({
		      type: "QualifiedTypeIdentifier",
		      id: id,
		      qualification: qualification
		    });
		  }
		  function stringLiteralTypeAnnotation(value) {
		    return validateNode({
		      type: "StringLiteralTypeAnnotation",
		      value: value
		    });
		  }
		  function stringTypeAnnotation$2() {
		    return {
		      type: "StringTypeAnnotation"
		    };
		  }
		  function symbolTypeAnnotation() {
		    return {
		      type: "SymbolTypeAnnotation"
		    };
		  }
		  function thisTypeAnnotation() {
		    return {
		      type: "ThisTypeAnnotation"
		    };
		  }
		  function tupleTypeAnnotation$1(types) {
		    return validateNode({
		      type: "TupleTypeAnnotation",
		      types: types
		    });
		  }
		  function typeofTypeAnnotation(argument) {
		    return validateNode({
		      type: "TypeofTypeAnnotation",
		      argument: argument
		    });
		  }
		  function typeAlias(id, typeParameters, right) {
		    if (typeParameters === void 0) {
		      typeParameters = null;
		    }
		    return validateNode({
		      type: "TypeAlias",
		      id: id,
		      typeParameters: typeParameters,
		      right: right
		    });
		  }
		  function typeAnnotation(typeAnnotation) {
		    return validateNode({
		      type: "TypeAnnotation",
		      typeAnnotation: typeAnnotation
		    });
		  }
		  function typeCastExpression(expression, typeAnnotation) {
		    return validateNode({
		      type: "TypeCastExpression",
		      expression: expression,
		      typeAnnotation: typeAnnotation
		    });
		  }
		  function typeParameter(bound, _default, variance) {
		    if (bound === void 0) {
		      bound = null;
		    }
		    if (_default === void 0) {
		      _default = null;
		    }
		    if (variance === void 0) {
		      variance = null;
		    }
		    return validateNode({
		      type: "TypeParameter",
		      bound: bound,
		      "default": _default,
		      variance: variance,
		      name: null
		    });
		  }
		  function typeParameterDeclaration(params) {
		    return validateNode({
		      type: "TypeParameterDeclaration",
		      params: params
		    });
		  }
		  function typeParameterInstantiation(params) {
		    return validateNode({
		      type: "TypeParameterInstantiation",
		      params: params
		    });
		  }
		  function unionTypeAnnotation$1(types) {
		    return validateNode({
		      type: "UnionTypeAnnotation",
		      types: types
		    });
		  }
		  function variance(kind) {
		    return validateNode({
		      type: "Variance",
		      kind: kind
		    });
		  }
		  function voidTypeAnnotation$3() {
		    return {
		      type: "VoidTypeAnnotation"
		    };
		  }
		  function enumDeclaration(id, body) {
		    return validateNode({
		      type: "EnumDeclaration",
		      id: id,
		      body: body
		    });
		  }
		  function enumBooleanBody(members) {
		    return validateNode({
		      type: "EnumBooleanBody",
		      members: members,
		      explicitType: null,
		      hasUnknownMembers: null
		    });
		  }
		  function enumNumberBody(members) {
		    return validateNode({
		      type: "EnumNumberBody",
		      members: members,
		      explicitType: null,
		      hasUnknownMembers: null
		    });
		  }
		  function enumStringBody(members) {
		    return validateNode({
		      type: "EnumStringBody",
		      members: members,
		      explicitType: null,
		      hasUnknownMembers: null
		    });
		  }
		  function enumSymbolBody(members) {
		    return validateNode({
		      type: "EnumSymbolBody",
		      members: members,
		      hasUnknownMembers: null
		    });
		  }
		  function enumBooleanMember(id) {
		    return validateNode({
		      type: "EnumBooleanMember",
		      id: id,
		      init: null
		    });
		  }
		  function enumNumberMember(id, init) {
		    return validateNode({
		      type: "EnumNumberMember",
		      id: id,
		      init: init
		    });
		  }
		  function enumStringMember(id, init) {
		    return validateNode({
		      type: "EnumStringMember",
		      id: id,
		      init: init
		    });
		  }
		  function enumDefaultedMember(id) {
		    return validateNode({
		      type: "EnumDefaultedMember",
		      id: id
		    });
		  }
		  function indexedAccessType(objectType, indexType) {
		    return validateNode({
		      type: "IndexedAccessType",
		      objectType: objectType,
		      indexType: indexType
		    });
		  }
		  function optionalIndexedAccessType(objectType, indexType) {
		    return validateNode({
		      type: "OptionalIndexedAccessType",
		      objectType: objectType,
		      indexType: indexType,
		      optional: null
		    });
		  }
		  function jsxAttribute(name, value) {
		    if (value === void 0) {
		      value = null;
		    }
		    return validateNode({
		      type: "JSXAttribute",
		      name: name,
		      value: value
		    });
		  }
		  function jsxClosingElement(name) {
		    return validateNode({
		      type: "JSXClosingElement",
		      name: name
		    });
		  }
		  function jsxElement(openingElement, closingElement, children, selfClosing) {
		    if (closingElement === void 0) {
		      closingElement = null;
		    }
		    if (selfClosing === void 0) {
		      selfClosing = null;
		    }
		    return validateNode({
		      type: "JSXElement",
		      openingElement: openingElement,
		      closingElement: closingElement,
		      children: children,
		      selfClosing: selfClosing
		    });
		  }
		  function jsxEmptyExpression() {
		    return {
		      type: "JSXEmptyExpression"
		    };
		  }
		  function jsxExpressionContainer$1(expression) {
		    return validateNode({
		      type: "JSXExpressionContainer",
		      expression: expression
		    });
		  }
		  function jsxSpreadChild(expression) {
		    return validateNode({
		      type: "JSXSpreadChild",
		      expression: expression
		    });
		  }
		  function jsxIdentifier$2(name) {
		    return validateNode({
		      type: "JSXIdentifier",
		      name: name
		    });
		  }
		  function jsxMemberExpression$1(object, property) {
		    return validateNode({
		      type: "JSXMemberExpression",
		      object: object,
		      property: property
		    });
		  }
		  function jsxNamespacedName(namespace, name) {
		    return validateNode({
		      type: "JSXNamespacedName",
		      namespace: namespace,
		      name: name
		    });
		  }
		  function jsxOpeningElement(name, attributes, selfClosing) {
		    if (selfClosing === void 0) {
		      selfClosing = false;
		    }
		    return validateNode({
		      type: "JSXOpeningElement",
		      name: name,
		      attributes: attributes,
		      selfClosing: selfClosing
		    });
		  }
		  function jsxSpreadAttribute(argument) {
		    return validateNode({
		      type: "JSXSpreadAttribute",
		      argument: argument
		    });
		  }
		  function jsxText(value) {
		    return validateNode({
		      type: "JSXText",
		      value: value
		    });
		  }
		  function jsxFragment(openingFragment, closingFragment, children) {
		    return validateNode({
		      type: "JSXFragment",
		      openingFragment: openingFragment,
		      closingFragment: closingFragment,
		      children: children
		    });
		  }
		  function jsxOpeningFragment() {
		    return {
		      type: "JSXOpeningFragment"
		    };
		  }
		  function jsxClosingFragment() {
		    return {
		      type: "JSXClosingFragment"
		    };
		  }
		  function noop$1() {
		    return {
		      type: "Noop"
		    };
		  }
		  function placeholder(expectedNode, name) {
		    return validateNode({
		      type: "Placeholder",
		      expectedNode: expectedNode,
		      name: name
		    });
		  }
		  function v8IntrinsicIdentifier(name) {
		    return validateNode({
		      type: "V8IntrinsicIdentifier",
		      name: name
		    });
		  }
		  function argumentPlaceholder() {
		    return {
		      type: "ArgumentPlaceholder"
		    };
		  }
		  function bindExpression(object, callee) {
		    return validateNode({
		      type: "BindExpression",
		      object: object,
		      callee: callee
		    });
		  }
		  function importAttribute(key, value) {
		    return validateNode({
		      type: "ImportAttribute",
		      key: key,
		      value: value
		    });
		  }
		  function decorator(expression) {
		    return validateNode({
		      type: "Decorator",
		      expression: expression
		    });
		  }
		  function doExpression(body, async) {
		    if (async === void 0) {
		      async = false;
		    }
		    return validateNode({
		      type: "DoExpression",
		      body: body,
		      async: async
		    });
		  }
		  function exportDefaultSpecifier(exported) {
		    return validateNode({
		      type: "ExportDefaultSpecifier",
		      exported: exported
		    });
		  }
		  function recordExpression(properties) {
		    return validateNode({
		      type: "RecordExpression",
		      properties: properties
		    });
		  }
		  function tupleExpression(elements) {
		    if (elements === void 0) {
		      elements = [];
		    }
		    return validateNode({
		      type: "TupleExpression",
		      elements: elements
		    });
		  }
		  function decimalLiteral(value) {
		    return validateNode({
		      type: "DecimalLiteral",
		      value: value
		    });
		  }
		  function moduleExpression(body) {
		    return validateNode({
		      type: "ModuleExpression",
		      body: body
		    });
		  }
		  function topicReference() {
		    return {
		      type: "TopicReference"
		    };
		  }
		  function pipelineTopicExpression(expression) {
		    return validateNode({
		      type: "PipelineTopicExpression",
		      expression: expression
		    });
		  }
		  function pipelineBareFunction(callee) {
		    return validateNode({
		      type: "PipelineBareFunction",
		      callee: callee
		    });
		  }
		  function pipelinePrimaryTopicReference() {
		    return {
		      type: "PipelinePrimaryTopicReference"
		    };
		  }
		  function tsParameterProperty(parameter) {
		    return validateNode({
		      type: "TSParameterProperty",
		      parameter: parameter
		    });
		  }
		  function tsDeclareFunction(id, typeParameters, params, returnType) {
		    if (id === void 0) {
		      id = null;
		    }
		    if (typeParameters === void 0) {
		      typeParameters = null;
		    }
		    if (returnType === void 0) {
		      returnType = null;
		    }
		    return validateNode({
		      type: "TSDeclareFunction",
		      id: id,
		      typeParameters: typeParameters,
		      params: params,
		      returnType: returnType
		    });
		  }
		  function tsDeclareMethod(decorators, key, typeParameters, params, returnType) {
		    if (decorators === void 0) {
		      decorators = null;
		    }
		    if (typeParameters === void 0) {
		      typeParameters = null;
		    }
		    if (returnType === void 0) {
		      returnType = null;
		    }
		    return validateNode({
		      type: "TSDeclareMethod",
		      decorators: decorators,
		      key: key,
		      typeParameters: typeParameters,
		      params: params,
		      returnType: returnType
		    });
		  }
		  function tsQualifiedName(left, right) {
		    return validateNode({
		      type: "TSQualifiedName",
		      left: left,
		      right: right
		    });
		  }
		  function tsCallSignatureDeclaration(typeParameters, parameters, typeAnnotation) {
		    if (typeParameters === void 0) {
		      typeParameters = null;
		    }
		    if (typeAnnotation === void 0) {
		      typeAnnotation = null;
		    }
		    return validateNode({
		      type: "TSCallSignatureDeclaration",
		      typeParameters: typeParameters,
		      parameters: parameters,
		      typeAnnotation: typeAnnotation
		    });
		  }
		  function tsConstructSignatureDeclaration(typeParameters, parameters, typeAnnotation) {
		    if (typeParameters === void 0) {
		      typeParameters = null;
		    }
		    if (typeAnnotation === void 0) {
		      typeAnnotation = null;
		    }
		    return validateNode({
		      type: "TSConstructSignatureDeclaration",
		      typeParameters: typeParameters,
		      parameters: parameters,
		      typeAnnotation: typeAnnotation
		    });
		  }
		  function tsPropertySignature(key, typeAnnotation) {
		    if (typeAnnotation === void 0) {
		      typeAnnotation = null;
		    }
		    return validateNode({
		      type: "TSPropertySignature",
		      key: key,
		      typeAnnotation: typeAnnotation,
		      kind: null
		    });
		  }
		  function tsMethodSignature(key, typeParameters, parameters, typeAnnotation) {
		    if (typeParameters === void 0) {
		      typeParameters = null;
		    }
		    if (typeAnnotation === void 0) {
		      typeAnnotation = null;
		    }
		    return validateNode({
		      type: "TSMethodSignature",
		      key: key,
		      typeParameters: typeParameters,
		      parameters: parameters,
		      typeAnnotation: typeAnnotation,
		      kind: null
		    });
		  }
		  function tsIndexSignature(parameters, typeAnnotation) {
		    if (typeAnnotation === void 0) {
		      typeAnnotation = null;
		    }
		    return validateNode({
		      type: "TSIndexSignature",
		      parameters: parameters,
		      typeAnnotation: typeAnnotation
		    });
		  }
		  function tsAnyKeyword() {
		    return {
		      type: "TSAnyKeyword"
		    };
		  }
		  function tsBooleanKeyword() {
		    return {
		      type: "TSBooleanKeyword"
		    };
		  }
		  function tsBigIntKeyword() {
		    return {
		      type: "TSBigIntKeyword"
		    };
		  }
		  function tsIntrinsicKeyword() {
		    return {
		      type: "TSIntrinsicKeyword"
		    };
		  }
		  function tsNeverKeyword() {
		    return {
		      type: "TSNeverKeyword"
		    };
		  }
		  function tsNullKeyword() {
		    return {
		      type: "TSNullKeyword"
		    };
		  }
		  function tsNumberKeyword() {
		    return {
		      type: "TSNumberKeyword"
		    };
		  }
		  function tsObjectKeyword() {
		    return {
		      type: "TSObjectKeyword"
		    };
		  }
		  function tsStringKeyword() {
		    return {
		      type: "TSStringKeyword"
		    };
		  }
		  function tsSymbolKeyword() {
		    return {
		      type: "TSSymbolKeyword"
		    };
		  }
		  function tsUndefinedKeyword() {
		    return {
		      type: "TSUndefinedKeyword"
		    };
		  }
		  function tsUnknownKeyword() {
		    return {
		      type: "TSUnknownKeyword"
		    };
		  }
		  function tsVoidKeyword() {
		    return {
		      type: "TSVoidKeyword"
		    };
		  }
		  function tsThisType() {
		    return {
		      type: "TSThisType"
		    };
		  }
		  function tsFunctionType(typeParameters, parameters, typeAnnotation) {
		    if (typeParameters === void 0) {
		      typeParameters = null;
		    }
		    if (typeAnnotation === void 0) {
		      typeAnnotation = null;
		    }
		    return validateNode({
		      type: "TSFunctionType",
		      typeParameters: typeParameters,
		      parameters: parameters,
		      typeAnnotation: typeAnnotation
		    });
		  }
		  function tsConstructorType(typeParameters, parameters, typeAnnotation) {
		    if (typeParameters === void 0) {
		      typeParameters = null;
		    }
		    if (typeAnnotation === void 0) {
		      typeAnnotation = null;
		    }
		    return validateNode({
		      type: "TSConstructorType",
		      typeParameters: typeParameters,
		      parameters: parameters,
		      typeAnnotation: typeAnnotation
		    });
		  }
		  function tsTypeReference(typeName, typeParameters) {
		    if (typeParameters === void 0) {
		      typeParameters = null;
		    }
		    return validateNode({
		      type: "TSTypeReference",
		      typeName: typeName,
		      typeParameters: typeParameters
		    });
		  }
		  function tsTypePredicate(parameterName, typeAnnotation, asserts) {
		    if (typeAnnotation === void 0) {
		      typeAnnotation = null;
		    }
		    if (asserts === void 0) {
		      asserts = null;
		    }
		    return validateNode({
		      type: "TSTypePredicate",
		      parameterName: parameterName,
		      typeAnnotation: typeAnnotation,
		      asserts: asserts
		    });
		  }
		  function tsTypeQuery(exprName, typeParameters) {
		    if (typeParameters === void 0) {
		      typeParameters = null;
		    }
		    return validateNode({
		      type: "TSTypeQuery",
		      exprName: exprName,
		      typeParameters: typeParameters
		    });
		  }
		  function tsTypeLiteral(members) {
		    return validateNode({
		      type: "TSTypeLiteral",
		      members: members
		    });
		  }
		  function tsArrayType(elementType) {
		    return validateNode({
		      type: "TSArrayType",
		      elementType: elementType
		    });
		  }
		  function tsTupleType(elementTypes) {
		    return validateNode({
		      type: "TSTupleType",
		      elementTypes: elementTypes
		    });
		  }
		  function tsOptionalType(typeAnnotation) {
		    return validateNode({
		      type: "TSOptionalType",
		      typeAnnotation: typeAnnotation
		    });
		  }
		  function tsRestType(typeAnnotation) {
		    return validateNode({
		      type: "TSRestType",
		      typeAnnotation: typeAnnotation
		    });
		  }
		  function tsNamedTupleMember(label, elementType, optional) {
		    if (optional === void 0) {
		      optional = false;
		    }
		    return validateNode({
		      type: "TSNamedTupleMember",
		      label: label,
		      elementType: elementType,
		      optional: optional
		    });
		  }
		  function tsUnionType(types) {
		    return validateNode({
		      type: "TSUnionType",
		      types: types
		    });
		  }
		  function tsIntersectionType(types) {
		    return validateNode({
		      type: "TSIntersectionType",
		      types: types
		    });
		  }
		  function tsConditionalType(checkType, extendsType, trueType, falseType) {
		    return validateNode({
		      type: "TSConditionalType",
		      checkType: checkType,
		      extendsType: extendsType,
		      trueType: trueType,
		      falseType: falseType
		    });
		  }
		  function tsInferType(typeParameter) {
		    return validateNode({
		      type: "TSInferType",
		      typeParameter: typeParameter
		    });
		  }
		  function tsParenthesizedType(typeAnnotation) {
		    return validateNode({
		      type: "TSParenthesizedType",
		      typeAnnotation: typeAnnotation
		    });
		  }
		  function tsTypeOperator(typeAnnotation) {
		    return validateNode({
		      type: "TSTypeOperator",
		      typeAnnotation: typeAnnotation,
		      operator: null
		    });
		  }
		  function tsIndexedAccessType(objectType, indexType) {
		    return validateNode({
		      type: "TSIndexedAccessType",
		      objectType: objectType,
		      indexType: indexType
		    });
		  }
		  function tsMappedType(typeParameter, typeAnnotation, nameType) {
		    if (typeAnnotation === void 0) {
		      typeAnnotation = null;
		    }
		    if (nameType === void 0) {
		      nameType = null;
		    }
		    return validateNode({
		      type: "TSMappedType",
		      typeParameter: typeParameter,
		      typeAnnotation: typeAnnotation,
		      nameType: nameType
		    });
		  }
		  function tsLiteralType(literal) {
		    return validateNode({
		      type: "TSLiteralType",
		      literal: literal
		    });
		  }
		  function tsExpressionWithTypeArguments(expression, typeParameters) {
		    if (typeParameters === void 0) {
		      typeParameters = null;
		    }
		    return validateNode({
		      type: "TSExpressionWithTypeArguments",
		      expression: expression,
		      typeParameters: typeParameters
		    });
		  }
		  function tsInterfaceDeclaration(id, typeParameters, _extends, body) {
		    if (typeParameters === void 0) {
		      typeParameters = null;
		    }
		    if (_extends === void 0) {
		      _extends = null;
		    }
		    return validateNode({
		      type: "TSInterfaceDeclaration",
		      id: id,
		      typeParameters: typeParameters,
		      "extends": _extends,
		      body: body
		    });
		  }
		  function tsInterfaceBody(body) {
		    return validateNode({
		      type: "TSInterfaceBody",
		      body: body
		    });
		  }
		  function tsTypeAliasDeclaration(id, typeParameters, typeAnnotation) {
		    if (typeParameters === void 0) {
		      typeParameters = null;
		    }
		    return validateNode({
		      type: "TSTypeAliasDeclaration",
		      id: id,
		      typeParameters: typeParameters,
		      typeAnnotation: typeAnnotation
		    });
		  }
		  function tsInstantiationExpression(expression, typeParameters) {
		    if (typeParameters === void 0) {
		      typeParameters = null;
		    }
		    return validateNode({
		      type: "TSInstantiationExpression",
		      expression: expression,
		      typeParameters: typeParameters
		    });
		  }
		  function tsAsExpression(expression, typeAnnotation) {
		    return validateNode({
		      type: "TSAsExpression",
		      expression: expression,
		      typeAnnotation: typeAnnotation
		    });
		  }
		  function tsSatisfiesExpression(expression, typeAnnotation) {
		    return validateNode({
		      type: "TSSatisfiesExpression",
		      expression: expression,
		      typeAnnotation: typeAnnotation
		    });
		  }
		  function tsTypeAssertion(typeAnnotation, expression) {
		    return validateNode({
		      type: "TSTypeAssertion",
		      typeAnnotation: typeAnnotation,
		      expression: expression
		    });
		  }
		  function tsEnumDeclaration(id, members) {
		    return validateNode({
		      type: "TSEnumDeclaration",
		      id: id,
		      members: members
		    });
		  }
		  function tsEnumMember(id, initializer) {
		    if (initializer === void 0) {
		      initializer = null;
		    }
		    return validateNode({
		      type: "TSEnumMember",
		      id: id,
		      initializer: initializer
		    });
		  }
		  function tsModuleDeclaration(id, body) {
		    return validateNode({
		      type: "TSModuleDeclaration",
		      id: id,
		      body: body
		    });
		  }
		  function tsModuleBlock(body) {
		    return validateNode({
		      type: "TSModuleBlock",
		      body: body
		    });
		  }
		  function tsImportType(argument, qualifier, typeParameters) {
		    if (qualifier === void 0) {
		      qualifier = null;
		    }
		    if (typeParameters === void 0) {
		      typeParameters = null;
		    }
		    return validateNode({
		      type: "TSImportType",
		      argument: argument,
		      qualifier: qualifier,
		      typeParameters: typeParameters
		    });
		  }
		  function tsImportEqualsDeclaration(id, moduleReference) {
		    return validateNode({
		      type: "TSImportEqualsDeclaration",
		      id: id,
		      moduleReference: moduleReference,
		      isExport: null
		    });
		  }
		  function tsExternalModuleReference(expression) {
		    return validateNode({
		      type: "TSExternalModuleReference",
		      expression: expression
		    });
		  }
		  function tsNonNullExpression(expression) {
		    return validateNode({
		      type: "TSNonNullExpression",
		      expression: expression
		    });
		  }
		  function tsExportAssignment(expression) {
		    return validateNode({
		      type: "TSExportAssignment",
		      expression: expression
		    });
		  }
		  function tsNamespaceExportDeclaration(id) {
		    return validateNode({
		      type: "TSNamespaceExportDeclaration",
		      id: id
		    });
		  }
		  function tsTypeAnnotation(typeAnnotation) {
		    return validateNode({
		      type: "TSTypeAnnotation",
		      typeAnnotation: typeAnnotation
		    });
		  }
		  function tsTypeParameterInstantiation(params) {
		    return validateNode({
		      type: "TSTypeParameterInstantiation",
		      params: params
		    });
		  }
		  function tsTypeParameterDeclaration(params) {
		    return validateNode({
		      type: "TSTypeParameterDeclaration",
		      params: params
		    });
		  }
		  function tsTypeParameter(constraint, _default, name) {
		    if (constraint === void 0) {
		      constraint = null;
		    }
		    if (_default === void 0) {
		      _default = null;
		    }
		    return validateNode({
		      type: "TSTypeParameter",
		      constraint: constraint,
		      "default": _default,
		      name: name
		    });
		  }
		  function NumberLiteral(value) {
		    deprecationWarning$1("NumberLiteral", "NumericLiteral", "The node type ");
		    return numericLiteral$8(value);
		  }
		  function RegexLiteral(pattern, flags) {
		    if (flags === void 0) {
		      flags = "";
		    }
		    deprecationWarning$1("RegexLiteral", "RegExpLiteral", "The node type ");
		    return regExpLiteral(pattern, flags);
		  }
		  function RestProperty(argument) {
		    deprecationWarning$1("RestProperty", "RestElement", "The node type ");
		    return restElement$2(argument);
		  }
		  function SpreadProperty(argument) {
		    deprecationWarning$1("SpreadProperty", "SpreadElement", "The node type ");
		    return spreadElement$2(argument);
		  }

		  function cleanJSXElementLiteralChild(child, args) {
		    var lines = child.value.split(/\r\n|\n|\r/);
		    var lastNonEmptyLine = 0;
		    for (var i = 0; i < lines.length; i++) {
		      if (lines[i].match(/[^ \t]/)) {
		        lastNonEmptyLine = i;
		      }
		    }
		    var str = "";
		    for (var _i = 0; _i < lines.length; _i++) {
		      var line = lines[_i];
		      var isFirstLine = _i === 0;
		      var isLastLine = _i === lines.length - 1;
		      var isLastNonEmptyLine = _i === lastNonEmptyLine;
		      var trimmedLine = line.replace(/\t/g, " ");
		      if (!isFirstLine) {
		        trimmedLine = trimmedLine.replace(/^[ ]+/, "");
		      }
		      if (!isLastLine) {
		        trimmedLine = trimmedLine.replace(/[ ]+$/, "");
		      }
		      if (trimmedLine) {
		        if (!isLastNonEmptyLine) {
		          trimmedLine += " ";
		        }
		        str += trimmedLine;
		      }
		    }
		    if (str) args.push(inherits$3(stringLiteral$8(str), child));
		  }

		  function buildChildren(node) {
		    var elements = [];
		    for (var i = 0; i < node.children.length; i++) {
		      var child = node.children[i];
		      if (isJSXText(child)) {
		        cleanJSXElementLiteralChild(child, elements);
		        continue;
		      }
		      if (isJSXExpressionContainer$1(child)) child = child.expression;
		      if (isJSXEmptyExpression(child)) continue;
		      elements.push(child);
		    }
		    return elements;
		  }

		  function isNode(node) {
		    return !!(node && VISITOR_KEYS$5[node.type]);
		  }

		  function assertNode(node) {
		    if (!isNode(node)) {
		      var _node$type;
		      var type = (_node$type = node == null ? void 0 : node.type) != null ? _node$type : JSON.stringify(node);
		      throw new TypeError("Not a valid node of type \"" + type + "\"");
		    }
		  }

		  function assert$2(type, node, opts) {
		    if (!is$1(type, node, opts)) {
		      throw new Error("Expected type \"" + type + "\" with option " + JSON.stringify(opts) + ", " + ("but instead got \"" + node.type + "\"."));
		    }
		  }
		  function assertArrayExpression(node, opts) {
		    assert$2("ArrayExpression", node, opts);
		  }
		  function assertAssignmentExpression(node, opts) {
		    assert$2("AssignmentExpression", node, opts);
		  }
		  function assertBinaryExpression(node, opts) {
		    assert$2("BinaryExpression", node, opts);
		  }
		  function assertInterpreterDirective(node, opts) {
		    assert$2("InterpreterDirective", node, opts);
		  }
		  function assertDirective(node, opts) {
		    assert$2("Directive", node, opts);
		  }
		  function assertDirectiveLiteral(node, opts) {
		    assert$2("DirectiveLiteral", node, opts);
		  }
		  function assertBlockStatement(node, opts) {
		    assert$2("BlockStatement", node, opts);
		  }
		  function assertBreakStatement(node, opts) {
		    assert$2("BreakStatement", node, opts);
		  }
		  function assertCallExpression(node, opts) {
		    assert$2("CallExpression", node, opts);
		  }
		  function assertCatchClause(node, opts) {
		    assert$2("CatchClause", node, opts);
		  }
		  function assertConditionalExpression(node, opts) {
		    assert$2("ConditionalExpression", node, opts);
		  }
		  function assertContinueStatement(node, opts) {
		    assert$2("ContinueStatement", node, opts);
		  }
		  function assertDebuggerStatement(node, opts) {
		    assert$2("DebuggerStatement", node, opts);
		  }
		  function assertDoWhileStatement(node, opts) {
		    assert$2("DoWhileStatement", node, opts);
		  }
		  function assertEmptyStatement(node, opts) {
		    assert$2("EmptyStatement", node, opts);
		  }
		  function assertExpressionStatement$1(node, opts) {
		    assert$2("ExpressionStatement", node, opts);
		  }
		  function assertFile(node, opts) {
		    assert$2("File", node, opts);
		  }
		  function assertForInStatement(node, opts) {
		    assert$2("ForInStatement", node, opts);
		  }
		  function assertForStatement(node, opts) {
		    assert$2("ForStatement", node, opts);
		  }
		  function assertFunctionDeclaration(node, opts) {
		    assert$2("FunctionDeclaration", node, opts);
		  }
		  function assertFunctionExpression(node, opts) {
		    assert$2("FunctionExpression", node, opts);
		  }
		  function assertIdentifier(node, opts) {
		    assert$2("Identifier", node, opts);
		  }
		  function assertIfStatement(node, opts) {
		    assert$2("IfStatement", node, opts);
		  }
		  function assertLabeledStatement(node, opts) {
		    assert$2("LabeledStatement", node, opts);
		  }
		  function assertStringLiteral(node, opts) {
		    assert$2("StringLiteral", node, opts);
		  }
		  function assertNumericLiteral(node, opts) {
		    assert$2("NumericLiteral", node, opts);
		  }
		  function assertNullLiteral(node, opts) {
		    assert$2("NullLiteral", node, opts);
		  }
		  function assertBooleanLiteral(node, opts) {
		    assert$2("BooleanLiteral", node, opts);
		  }
		  function assertRegExpLiteral(node, opts) {
		    assert$2("RegExpLiteral", node, opts);
		  }
		  function assertLogicalExpression(node, opts) {
		    assert$2("LogicalExpression", node, opts);
		  }
		  function assertMemberExpression(node, opts) {
		    assert$2("MemberExpression", node, opts);
		  }
		  function assertNewExpression(node, opts) {
		    assert$2("NewExpression", node, opts);
		  }
		  function assertProgram(node, opts) {
		    assert$2("Program", node, opts);
		  }
		  function assertObjectExpression(node, opts) {
		    assert$2("ObjectExpression", node, opts);
		  }
		  function assertObjectMethod(node, opts) {
		    assert$2("ObjectMethod", node, opts);
		  }
		  function assertObjectProperty(node, opts) {
		    assert$2("ObjectProperty", node, opts);
		  }
		  function assertRestElement(node, opts) {
		    assert$2("RestElement", node, opts);
		  }
		  function assertReturnStatement(node, opts) {
		    assert$2("ReturnStatement", node, opts);
		  }
		  function assertSequenceExpression(node, opts) {
		    assert$2("SequenceExpression", node, opts);
		  }
		  function assertParenthesizedExpression(node, opts) {
		    assert$2("ParenthesizedExpression", node, opts);
		  }
		  function assertSwitchCase(node, opts) {
		    assert$2("SwitchCase", node, opts);
		  }
		  function assertSwitchStatement(node, opts) {
		    assert$2("SwitchStatement", node, opts);
		  }
		  function assertThisExpression(node, opts) {
		    assert$2("ThisExpression", node, opts);
		  }
		  function assertThrowStatement(node, opts) {
		    assert$2("ThrowStatement", node, opts);
		  }
		  function assertTryStatement(node, opts) {
		    assert$2("TryStatement", node, opts);
		  }
		  function assertUnaryExpression(node, opts) {
		    assert$2("UnaryExpression", node, opts);
		  }
		  function assertUpdateExpression(node, opts) {
		    assert$2("UpdateExpression", node, opts);
		  }
		  function assertVariableDeclaration(node, opts) {
		    assert$2("VariableDeclaration", node, opts);
		  }
		  function assertVariableDeclarator(node, opts) {
		    assert$2("VariableDeclarator", node, opts);
		  }
		  function assertWhileStatement(node, opts) {
		    assert$2("WhileStatement", node, opts);
		  }
		  function assertWithStatement(node, opts) {
		    assert$2("WithStatement", node, opts);
		  }
		  function assertAssignmentPattern(node, opts) {
		    assert$2("AssignmentPattern", node, opts);
		  }
		  function assertArrayPattern(node, opts) {
		    assert$2("ArrayPattern", node, opts);
		  }
		  function assertArrowFunctionExpression(node, opts) {
		    assert$2("ArrowFunctionExpression", node, opts);
		  }
		  function assertClassBody(node, opts) {
		    assert$2("ClassBody", node, opts);
		  }
		  function assertClassExpression(node, opts) {
		    assert$2("ClassExpression", node, opts);
		  }
		  function assertClassDeclaration(node, opts) {
		    assert$2("ClassDeclaration", node, opts);
		  }
		  function assertExportAllDeclaration(node, opts) {
		    assert$2("ExportAllDeclaration", node, opts);
		  }
		  function assertExportDefaultDeclaration(node, opts) {
		    assert$2("ExportDefaultDeclaration", node, opts);
		  }
		  function assertExportNamedDeclaration(node, opts) {
		    assert$2("ExportNamedDeclaration", node, opts);
		  }
		  function assertExportSpecifier$1(node, opts) {
		    assert$2("ExportSpecifier", node, opts);
		  }
		  function assertForOfStatement(node, opts) {
		    assert$2("ForOfStatement", node, opts);
		  }
		  function assertImportDeclaration(node, opts) {
		    assert$2("ImportDeclaration", node, opts);
		  }
		  function assertImportDefaultSpecifier(node, opts) {
		    assert$2("ImportDefaultSpecifier", node, opts);
		  }
		  function assertImportNamespaceSpecifier(node, opts) {
		    assert$2("ImportNamespaceSpecifier", node, opts);
		  }
		  function assertImportSpecifier(node, opts) {
		    assert$2("ImportSpecifier", node, opts);
		  }
		  function assertImportExpression(node, opts) {
		    assert$2("ImportExpression", node, opts);
		  }
		  function assertMetaProperty(node, opts) {
		    assert$2("MetaProperty", node, opts);
		  }
		  function assertClassMethod(node, opts) {
		    assert$2("ClassMethod", node, opts);
		  }
		  function assertObjectPattern(node, opts) {
		    assert$2("ObjectPattern", node, opts);
		  }
		  function assertSpreadElement(node, opts) {
		    assert$2("SpreadElement", node, opts);
		  }
		  function assertSuper(node, opts) {
		    assert$2("Super", node, opts);
		  }
		  function assertTaggedTemplateExpression(node, opts) {
		    assert$2("TaggedTemplateExpression", node, opts);
		  }
		  function assertTemplateElement(node, opts) {
		    assert$2("TemplateElement", node, opts);
		  }
		  function assertTemplateLiteral(node, opts) {
		    assert$2("TemplateLiteral", node, opts);
		  }
		  function assertYieldExpression(node, opts) {
		    assert$2("YieldExpression", node, opts);
		  }
		  function assertAwaitExpression(node, opts) {
		    assert$2("AwaitExpression", node, opts);
		  }
		  function assertImport(node, opts) {
		    assert$2("Import", node, opts);
		  }
		  function assertBigIntLiteral(node, opts) {
		    assert$2("BigIntLiteral", node, opts);
		  }
		  function assertExportNamespaceSpecifier(node, opts) {
		    assert$2("ExportNamespaceSpecifier", node, opts);
		  }
		  function assertOptionalMemberExpression(node, opts) {
		    assert$2("OptionalMemberExpression", node, opts);
		  }
		  function assertOptionalCallExpression(node, opts) {
		    assert$2("OptionalCallExpression", node, opts);
		  }
		  function assertClassProperty(node, opts) {
		    assert$2("ClassProperty", node, opts);
		  }
		  function assertClassAccessorProperty(node, opts) {
		    assert$2("ClassAccessorProperty", node, opts);
		  }
		  function assertClassPrivateProperty(node, opts) {
		    assert$2("ClassPrivateProperty", node, opts);
		  }
		  function assertClassPrivateMethod(node, opts) {
		    assert$2("ClassPrivateMethod", node, opts);
		  }
		  function assertPrivateName(node, opts) {
		    assert$2("PrivateName", node, opts);
		  }
		  function assertStaticBlock(node, opts) {
		    assert$2("StaticBlock", node, opts);
		  }
		  function assertAnyTypeAnnotation(node, opts) {
		    assert$2("AnyTypeAnnotation", node, opts);
		  }
		  function assertArrayTypeAnnotation(node, opts) {
		    assert$2("ArrayTypeAnnotation", node, opts);
		  }
		  function assertBooleanTypeAnnotation(node, opts) {
		    assert$2("BooleanTypeAnnotation", node, opts);
		  }
		  function assertBooleanLiteralTypeAnnotation(node, opts) {
		    assert$2("BooleanLiteralTypeAnnotation", node, opts);
		  }
		  function assertNullLiteralTypeAnnotation(node, opts) {
		    assert$2("NullLiteralTypeAnnotation", node, opts);
		  }
		  function assertClassImplements(node, opts) {
		    assert$2("ClassImplements", node, opts);
		  }
		  function assertDeclareClass(node, opts) {
		    assert$2("DeclareClass", node, opts);
		  }
		  function assertDeclareFunction(node, opts) {
		    assert$2("DeclareFunction", node, opts);
		  }
		  function assertDeclareInterface(node, opts) {
		    assert$2("DeclareInterface", node, opts);
		  }
		  function assertDeclareModule(node, opts) {
		    assert$2("DeclareModule", node, opts);
		  }
		  function assertDeclareModuleExports(node, opts) {
		    assert$2("DeclareModuleExports", node, opts);
		  }
		  function assertDeclareTypeAlias(node, opts) {
		    assert$2("DeclareTypeAlias", node, opts);
		  }
		  function assertDeclareOpaqueType(node, opts) {
		    assert$2("DeclareOpaqueType", node, opts);
		  }
		  function assertDeclareVariable(node, opts) {
		    assert$2("DeclareVariable", node, opts);
		  }
		  function assertDeclareExportDeclaration(node, opts) {
		    assert$2("DeclareExportDeclaration", node, opts);
		  }
		  function assertDeclareExportAllDeclaration(node, opts) {
		    assert$2("DeclareExportAllDeclaration", node, opts);
		  }
		  function assertDeclaredPredicate(node, opts) {
		    assert$2("DeclaredPredicate", node, opts);
		  }
		  function assertExistsTypeAnnotation(node, opts) {
		    assert$2("ExistsTypeAnnotation", node, opts);
		  }
		  function assertFunctionTypeAnnotation(node, opts) {
		    assert$2("FunctionTypeAnnotation", node, opts);
		  }
		  function assertFunctionTypeParam(node, opts) {
		    assert$2("FunctionTypeParam", node, opts);
		  }
		  function assertGenericTypeAnnotation(node, opts) {
		    assert$2("GenericTypeAnnotation", node, opts);
		  }
		  function assertInferredPredicate(node, opts) {
		    assert$2("InferredPredicate", node, opts);
		  }
		  function assertInterfaceExtends(node, opts) {
		    assert$2("InterfaceExtends", node, opts);
		  }
		  function assertInterfaceDeclaration(node, opts) {
		    assert$2("InterfaceDeclaration", node, opts);
		  }
		  function assertInterfaceTypeAnnotation(node, opts) {
		    assert$2("InterfaceTypeAnnotation", node, opts);
		  }
		  function assertIntersectionTypeAnnotation(node, opts) {
		    assert$2("IntersectionTypeAnnotation", node, opts);
		  }
		  function assertMixedTypeAnnotation(node, opts) {
		    assert$2("MixedTypeAnnotation", node, opts);
		  }
		  function assertEmptyTypeAnnotation(node, opts) {
		    assert$2("EmptyTypeAnnotation", node, opts);
		  }
		  function assertNullableTypeAnnotation(node, opts) {
		    assert$2("NullableTypeAnnotation", node, opts);
		  }
		  function assertNumberLiteralTypeAnnotation(node, opts) {
		    assert$2("NumberLiteralTypeAnnotation", node, opts);
		  }
		  function assertNumberTypeAnnotation(node, opts) {
		    assert$2("NumberTypeAnnotation", node, opts);
		  }
		  function assertObjectTypeAnnotation(node, opts) {
		    assert$2("ObjectTypeAnnotation", node, opts);
		  }
		  function assertObjectTypeInternalSlot(node, opts) {
		    assert$2("ObjectTypeInternalSlot", node, opts);
		  }
		  function assertObjectTypeCallProperty(node, opts) {
		    assert$2("ObjectTypeCallProperty", node, opts);
		  }
		  function assertObjectTypeIndexer(node, opts) {
		    assert$2("ObjectTypeIndexer", node, opts);
		  }
		  function assertObjectTypeProperty(node, opts) {
		    assert$2("ObjectTypeProperty", node, opts);
		  }
		  function assertObjectTypeSpreadProperty(node, opts) {
		    assert$2("ObjectTypeSpreadProperty", node, opts);
		  }
		  function assertOpaqueType(node, opts) {
		    assert$2("OpaqueType", node, opts);
		  }
		  function assertQualifiedTypeIdentifier(node, opts) {
		    assert$2("QualifiedTypeIdentifier", node, opts);
		  }
		  function assertStringLiteralTypeAnnotation(node, opts) {
		    assert$2("StringLiteralTypeAnnotation", node, opts);
		  }
		  function assertStringTypeAnnotation(node, opts) {
		    assert$2("StringTypeAnnotation", node, opts);
		  }
		  function assertSymbolTypeAnnotation(node, opts) {
		    assert$2("SymbolTypeAnnotation", node, opts);
		  }
		  function assertThisTypeAnnotation(node, opts) {
		    assert$2("ThisTypeAnnotation", node, opts);
		  }
		  function assertTupleTypeAnnotation(node, opts) {
		    assert$2("TupleTypeAnnotation", node, opts);
		  }
		  function assertTypeofTypeAnnotation(node, opts) {
		    assert$2("TypeofTypeAnnotation", node, opts);
		  }
		  function assertTypeAlias(node, opts) {
		    assert$2("TypeAlias", node, opts);
		  }
		  function assertTypeAnnotation(node, opts) {
		    assert$2("TypeAnnotation", node, opts);
		  }
		  function assertTypeCastExpression(node, opts) {
		    assert$2("TypeCastExpression", node, opts);
		  }
		  function assertTypeParameter(node, opts) {
		    assert$2("TypeParameter", node, opts);
		  }
		  function assertTypeParameterDeclaration(node, opts) {
		    assert$2("TypeParameterDeclaration", node, opts);
		  }
		  function assertTypeParameterInstantiation(node, opts) {
		    assert$2("TypeParameterInstantiation", node, opts);
		  }
		  function assertUnionTypeAnnotation(node, opts) {
		    assert$2("UnionTypeAnnotation", node, opts);
		  }
		  function assertVariance(node, opts) {
		    assert$2("Variance", node, opts);
		  }
		  function assertVoidTypeAnnotation(node, opts) {
		    assert$2("VoidTypeAnnotation", node, opts);
		  }
		  function assertEnumDeclaration(node, opts) {
		    assert$2("EnumDeclaration", node, opts);
		  }
		  function assertEnumBooleanBody(node, opts) {
		    assert$2("EnumBooleanBody", node, opts);
		  }
		  function assertEnumNumberBody(node, opts) {
		    assert$2("EnumNumberBody", node, opts);
		  }
		  function assertEnumStringBody(node, opts) {
		    assert$2("EnumStringBody", node, opts);
		  }
		  function assertEnumSymbolBody(node, opts) {
		    assert$2("EnumSymbolBody", node, opts);
		  }
		  function assertEnumBooleanMember(node, opts) {
		    assert$2("EnumBooleanMember", node, opts);
		  }
		  function assertEnumNumberMember(node, opts) {
		    assert$2("EnumNumberMember", node, opts);
		  }
		  function assertEnumStringMember(node, opts) {
		    assert$2("EnumStringMember", node, opts);
		  }
		  function assertEnumDefaultedMember(node, opts) {
		    assert$2("EnumDefaultedMember", node, opts);
		  }
		  function assertIndexedAccessType(node, opts) {
		    assert$2("IndexedAccessType", node, opts);
		  }
		  function assertOptionalIndexedAccessType(node, opts) {
		    assert$2("OptionalIndexedAccessType", node, opts);
		  }
		  function assertJSXAttribute(node, opts) {
		    assert$2("JSXAttribute", node, opts);
		  }
		  function assertJSXClosingElement(node, opts) {
		    assert$2("JSXClosingElement", node, opts);
		  }
		  function assertJSXElement(node, opts) {
		    assert$2("JSXElement", node, opts);
		  }
		  function assertJSXEmptyExpression(node, opts) {
		    assert$2("JSXEmptyExpression", node, opts);
		  }
		  function assertJSXExpressionContainer(node, opts) {
		    assert$2("JSXExpressionContainer", node, opts);
		  }
		  function assertJSXSpreadChild(node, opts) {
		    assert$2("JSXSpreadChild", node, opts);
		  }
		  function assertJSXIdentifier(node, opts) {
		    assert$2("JSXIdentifier", node, opts);
		  }
		  function assertJSXMemberExpression(node, opts) {
		    assert$2("JSXMemberExpression", node, opts);
		  }
		  function assertJSXNamespacedName(node, opts) {
		    assert$2("JSXNamespacedName", node, opts);
		  }
		  function assertJSXOpeningElement(node, opts) {
		    assert$2("JSXOpeningElement", node, opts);
		  }
		  function assertJSXSpreadAttribute(node, opts) {
		    assert$2("JSXSpreadAttribute", node, opts);
		  }
		  function assertJSXText(node, opts) {
		    assert$2("JSXText", node, opts);
		  }
		  function assertJSXFragment(node, opts) {
		    assert$2("JSXFragment", node, opts);
		  }
		  function assertJSXOpeningFragment(node, opts) {
		    assert$2("JSXOpeningFragment", node, opts);
		  }
		  function assertJSXClosingFragment(node, opts) {
		    assert$2("JSXClosingFragment", node, opts);
		  }
		  function assertNoop(node, opts) {
		    assert$2("Noop", node, opts);
		  }
		  function assertPlaceholder(node, opts) {
		    assert$2("Placeholder", node, opts);
		  }
		  function assertV8IntrinsicIdentifier(node, opts) {
		    assert$2("V8IntrinsicIdentifier", node, opts);
		  }
		  function assertArgumentPlaceholder(node, opts) {
		    assert$2("ArgumentPlaceholder", node, opts);
		  }
		  function assertBindExpression(node, opts) {
		    assert$2("BindExpression", node, opts);
		  }
		  function assertImportAttribute(node, opts) {
		    assert$2("ImportAttribute", node, opts);
		  }
		  function assertDecorator(node, opts) {
		    assert$2("Decorator", node, opts);
		  }
		  function assertDoExpression(node, opts) {
		    assert$2("DoExpression", node, opts);
		  }
		  function assertExportDefaultSpecifier(node, opts) {
		    assert$2("ExportDefaultSpecifier", node, opts);
		  }
		  function assertRecordExpression(node, opts) {
		    assert$2("RecordExpression", node, opts);
		  }
		  function assertTupleExpression(node, opts) {
		    assert$2("TupleExpression", node, opts);
		  }
		  function assertDecimalLiteral(node, opts) {
		    assert$2("DecimalLiteral", node, opts);
		  }
		  function assertModuleExpression(node, opts) {
		    assert$2("ModuleExpression", node, opts);
		  }
		  function assertTopicReference(node, opts) {
		    assert$2("TopicReference", node, opts);
		  }
		  function assertPipelineTopicExpression(node, opts) {
		    assert$2("PipelineTopicExpression", node, opts);
		  }
		  function assertPipelineBareFunction(node, opts) {
		    assert$2("PipelineBareFunction", node, opts);
		  }
		  function assertPipelinePrimaryTopicReference(node, opts) {
		    assert$2("PipelinePrimaryTopicReference", node, opts);
		  }
		  function assertTSParameterProperty(node, opts) {
		    assert$2("TSParameterProperty", node, opts);
		  }
		  function assertTSDeclareFunction(node, opts) {
		    assert$2("TSDeclareFunction", node, opts);
		  }
		  function assertTSDeclareMethod(node, opts) {
		    assert$2("TSDeclareMethod", node, opts);
		  }
		  function assertTSQualifiedName(node, opts) {
		    assert$2("TSQualifiedName", node, opts);
		  }
		  function assertTSCallSignatureDeclaration(node, opts) {
		    assert$2("TSCallSignatureDeclaration", node, opts);
		  }
		  function assertTSConstructSignatureDeclaration(node, opts) {
		    assert$2("TSConstructSignatureDeclaration", node, opts);
		  }
		  function assertTSPropertySignature(node, opts) {
		    assert$2("TSPropertySignature", node, opts);
		  }
		  function assertTSMethodSignature(node, opts) {
		    assert$2("TSMethodSignature", node, opts);
		  }
		  function assertTSIndexSignature(node, opts) {
		    assert$2("TSIndexSignature", node, opts);
		  }
		  function assertTSAnyKeyword(node, opts) {
		    assert$2("TSAnyKeyword", node, opts);
		  }
		  function assertTSBooleanKeyword(node, opts) {
		    assert$2("TSBooleanKeyword", node, opts);
		  }
		  function assertTSBigIntKeyword(node, opts) {
		    assert$2("TSBigIntKeyword", node, opts);
		  }
		  function assertTSIntrinsicKeyword(node, opts) {
		    assert$2("TSIntrinsicKeyword", node, opts);
		  }
		  function assertTSNeverKeyword(node, opts) {
		    assert$2("TSNeverKeyword", node, opts);
		  }
		  function assertTSNullKeyword(node, opts) {
		    assert$2("TSNullKeyword", node, opts);
		  }
		  function assertTSNumberKeyword(node, opts) {
		    assert$2("TSNumberKeyword", node, opts);
		  }
		  function assertTSObjectKeyword(node, opts) {
		    assert$2("TSObjectKeyword", node, opts);
		  }
		  function assertTSStringKeyword(node, opts) {
		    assert$2("TSStringKeyword", node, opts);
		  }
		  function assertTSSymbolKeyword(node, opts) {
		    assert$2("TSSymbolKeyword", node, opts);
		  }
		  function assertTSUndefinedKeyword(node, opts) {
		    assert$2("TSUndefinedKeyword", node, opts);
		  }
		  function assertTSUnknownKeyword(node, opts) {
		    assert$2("TSUnknownKeyword", node, opts);
		  }
		  function assertTSVoidKeyword(node, opts) {
		    assert$2("TSVoidKeyword", node, opts);
		  }
		  function assertTSThisType(node, opts) {
		    assert$2("TSThisType", node, opts);
		  }
		  function assertTSFunctionType(node, opts) {
		    assert$2("TSFunctionType", node, opts);
		  }
		  function assertTSConstructorType(node, opts) {
		    assert$2("TSConstructorType", node, opts);
		  }
		  function assertTSTypeReference(node, opts) {
		    assert$2("TSTypeReference", node, opts);
		  }
		  function assertTSTypePredicate(node, opts) {
		    assert$2("TSTypePredicate", node, opts);
		  }
		  function assertTSTypeQuery(node, opts) {
		    assert$2("TSTypeQuery", node, opts);
		  }
		  function assertTSTypeLiteral(node, opts) {
		    assert$2("TSTypeLiteral", node, opts);
		  }
		  function assertTSArrayType(node, opts) {
		    assert$2("TSArrayType", node, opts);
		  }
		  function assertTSTupleType(node, opts) {
		    assert$2("TSTupleType", node, opts);
		  }
		  function assertTSOptionalType(node, opts) {
		    assert$2("TSOptionalType", node, opts);
		  }
		  function assertTSRestType(node, opts) {
		    assert$2("TSRestType", node, opts);
		  }
		  function assertTSNamedTupleMember(node, opts) {
		    assert$2("TSNamedTupleMember", node, opts);
		  }
		  function assertTSUnionType(node, opts) {
		    assert$2("TSUnionType", node, opts);
		  }
		  function assertTSIntersectionType(node, opts) {
		    assert$2("TSIntersectionType", node, opts);
		  }
		  function assertTSConditionalType(node, opts) {
		    assert$2("TSConditionalType", node, opts);
		  }
		  function assertTSInferType(node, opts) {
		    assert$2("TSInferType", node, opts);
		  }
		  function assertTSParenthesizedType(node, opts) {
		    assert$2("TSParenthesizedType", node, opts);
		  }
		  function assertTSTypeOperator(node, opts) {
		    assert$2("TSTypeOperator", node, opts);
		  }
		  function assertTSIndexedAccessType(node, opts) {
		    assert$2("TSIndexedAccessType", node, opts);
		  }
		  function assertTSMappedType(node, opts) {
		    assert$2("TSMappedType", node, opts);
		  }
		  function assertTSLiteralType(node, opts) {
		    assert$2("TSLiteralType", node, opts);
		  }
		  function assertTSExpressionWithTypeArguments(node, opts) {
		    assert$2("TSExpressionWithTypeArguments", node, opts);
		  }
		  function assertTSInterfaceDeclaration(node, opts) {
		    assert$2("TSInterfaceDeclaration", node, opts);
		  }
		  function assertTSInterfaceBody(node, opts) {
		    assert$2("TSInterfaceBody", node, opts);
		  }
		  function assertTSTypeAliasDeclaration(node, opts) {
		    assert$2("TSTypeAliasDeclaration", node, opts);
		  }
		  function assertTSInstantiationExpression(node, opts) {
		    assert$2("TSInstantiationExpression", node, opts);
		  }
		  function assertTSAsExpression(node, opts) {
		    assert$2("TSAsExpression", node, opts);
		  }
		  function assertTSSatisfiesExpression(node, opts) {
		    assert$2("TSSatisfiesExpression", node, opts);
		  }
		  function assertTSTypeAssertion(node, opts) {
		    assert$2("TSTypeAssertion", node, opts);
		  }
		  function assertTSEnumDeclaration(node, opts) {
		    assert$2("TSEnumDeclaration", node, opts);
		  }
		  function assertTSEnumMember(node, opts) {
		    assert$2("TSEnumMember", node, opts);
		  }
		  function assertTSModuleDeclaration(node, opts) {
		    assert$2("TSModuleDeclaration", node, opts);
		  }
		  function assertTSModuleBlock(node, opts) {
		    assert$2("TSModuleBlock", node, opts);
		  }
		  function assertTSImportType(node, opts) {
		    assert$2("TSImportType", node, opts);
		  }
		  function assertTSImportEqualsDeclaration(node, opts) {
		    assert$2("TSImportEqualsDeclaration", node, opts);
		  }
		  function assertTSExternalModuleReference(node, opts) {
		    assert$2("TSExternalModuleReference", node, opts);
		  }
		  function assertTSNonNullExpression(node, opts) {
		    assert$2("TSNonNullExpression", node, opts);
		  }
		  function assertTSExportAssignment(node, opts) {
		    assert$2("TSExportAssignment", node, opts);
		  }
		  function assertTSNamespaceExportDeclaration(node, opts) {
		    assert$2("TSNamespaceExportDeclaration", node, opts);
		  }
		  function assertTSTypeAnnotation(node, opts) {
		    assert$2("TSTypeAnnotation", node, opts);
		  }
		  function assertTSTypeParameterInstantiation(node, opts) {
		    assert$2("TSTypeParameterInstantiation", node, opts);
		  }
		  function assertTSTypeParameterDeclaration(node, opts) {
		    assert$2("TSTypeParameterDeclaration", node, opts);
		  }
		  function assertTSTypeParameter(node, opts) {
		    assert$2("TSTypeParameter", node, opts);
		  }
		  function assertStandardized(node, opts) {
		    assert$2("Standardized", node, opts);
		  }
		  function assertExpression$1(node, opts) {
		    assert$2("Expression", node, opts);
		  }
		  function assertBinary(node, opts) {
		    assert$2("Binary", node, opts);
		  }
		  function assertScopable(node, opts) {
		    assert$2("Scopable", node, opts);
		  }
		  function assertBlockParent(node, opts) {
		    assert$2("BlockParent", node, opts);
		  }
		  function assertBlock(node, opts) {
		    assert$2("Block", node, opts);
		  }
		  function assertStatement(node, opts) {
		    assert$2("Statement", node, opts);
		  }
		  function assertTerminatorless(node, opts) {
		    assert$2("Terminatorless", node, opts);
		  }
		  function assertCompletionStatement(node, opts) {
		    assert$2("CompletionStatement", node, opts);
		  }
		  function assertConditional(node, opts) {
		    assert$2("Conditional", node, opts);
		  }
		  function assertLoop(node, opts) {
		    assert$2("Loop", node, opts);
		  }
		  function assertWhile(node, opts) {
		    assert$2("While", node, opts);
		  }
		  function assertExpressionWrapper(node, opts) {
		    assert$2("ExpressionWrapper", node, opts);
		  }
		  function assertFor(node, opts) {
		    assert$2("For", node, opts);
		  }
		  function assertForXStatement(node, opts) {
		    assert$2("ForXStatement", node, opts);
		  }
		  function assertFunction$1(node, opts) {
		    assert$2("Function", node, opts);
		  }
		  function assertFunctionParent(node, opts) {
		    assert$2("FunctionParent", node, opts);
		  }
		  function assertPureish(node, opts) {
		    assert$2("Pureish", node, opts);
		  }
		  function assertDeclaration(node, opts) {
		    assert$2("Declaration", node, opts);
		  }
		  function assertPatternLike(node, opts) {
		    assert$2("PatternLike", node, opts);
		  }
		  function assertLVal(node, opts) {
		    assert$2("LVal", node, opts);
		  }
		  function assertTSEntityName(node, opts) {
		    assert$2("TSEntityName", node, opts);
		  }
		  function assertLiteral(node, opts) {
		    assert$2("Literal", node, opts);
		  }
		  function assertImmutable(node, opts) {
		    assert$2("Immutable", node, opts);
		  }
		  function assertUserWhitespacable(node, opts) {
		    assert$2("UserWhitespacable", node, opts);
		  }
		  function assertMethod(node, opts) {
		    assert$2("Method", node, opts);
		  }
		  function assertObjectMember(node, opts) {
		    assert$2("ObjectMember", node, opts);
		  }
		  function assertProperty(node, opts) {
		    assert$2("Property", node, opts);
		  }
		  function assertUnaryLike(node, opts) {
		    assert$2("UnaryLike", node, opts);
		  }
		  function assertPattern(node, opts) {
		    assert$2("Pattern", node, opts);
		  }
		  function assertClass(node, opts) {
		    assert$2("Class", node, opts);
		  }
		  function assertImportOrExportDeclaration(node, opts) {
		    assert$2("ImportOrExportDeclaration", node, opts);
		  }
		  function assertExportDeclaration(node, opts) {
		    assert$2("ExportDeclaration", node, opts);
		  }
		  function assertModuleSpecifier(node, opts) {
		    assert$2("ModuleSpecifier", node, opts);
		  }
		  function assertAccessor(node, opts) {
		    assert$2("Accessor", node, opts);
		  }
		  function assertPrivate(node, opts) {
		    assert$2("Private", node, opts);
		  }
		  function assertFlow(node, opts) {
		    assert$2("Flow", node, opts);
		  }
		  function assertFlowType(node, opts) {
		    assert$2("FlowType", node, opts);
		  }
		  function assertFlowBaseAnnotation(node, opts) {
		    assert$2("FlowBaseAnnotation", node, opts);
		  }
		  function assertFlowDeclaration(node, opts) {
		    assert$2("FlowDeclaration", node, opts);
		  }
		  function assertFlowPredicate(node, opts) {
		    assert$2("FlowPredicate", node, opts);
		  }
		  function assertEnumBody(node, opts) {
		    assert$2("EnumBody", node, opts);
		  }
		  function assertEnumMember(node, opts) {
		    assert$2("EnumMember", node, opts);
		  }
		  function assertJSX(node, opts) {
		    assert$2("JSX", node, opts);
		  }
		  function assertMiscellaneous(node, opts) {
		    assert$2("Miscellaneous", node, opts);
		  }
		  function assertTypeScript(node, opts) {
		    assert$2("TypeScript", node, opts);
		  }
		  function assertTSTypeElement(node, opts) {
		    assert$2("TSTypeElement", node, opts);
		  }
		  function assertTSType(node, opts) {
		    assert$2("TSType", node, opts);
		  }
		  function assertTSBaseType(node, opts) {
		    assert$2("TSBaseType", node, opts);
		  }
		  function assertNumberLiteral(node, opts) {
		    deprecationWarning$1("assertNumberLiteral", "assertNumericLiteral");
		    assert$2("NumberLiteral", node, opts);
		  }
		  function assertRegexLiteral(node, opts) {
		    deprecationWarning$1("assertRegexLiteral", "assertRegExpLiteral");
		    assert$2("RegexLiteral", node, opts);
		  }
		  function assertRestProperty(node, opts) {
		    deprecationWarning$1("assertRestProperty", "assertRestElement");
		    assert$2("RestProperty", node, opts);
		  }
		  function assertSpreadProperty(node, opts) {
		    deprecationWarning$1("assertSpreadProperty", "assertSpreadElement");
		    assert$2("SpreadProperty", node, opts);
		  }
		  function assertModuleDeclaration(node, opts) {
		    deprecationWarning$1("assertModuleDeclaration", "assertImportOrExportDeclaration");
		    assert$2("ModuleDeclaration", node, opts);
		  }

		  function createTypeAnnotationBasedOnTypeof$1(type) {
		    switch (type) {
		      case "string":
		        return stringTypeAnnotation$2();
		      case "number":
		        return numberTypeAnnotation$2();
		      case "undefined":
		        return voidTypeAnnotation$3();
		      case "boolean":
		        return booleanTypeAnnotation$1();
		      case "function":
		        return genericTypeAnnotation$1(identifier$j("Function"));
		      case "object":
		        return genericTypeAnnotation$1(identifier$j("Object"));
		      case "symbol":
		        return genericTypeAnnotation$1(identifier$j("Symbol"));
		      case "bigint":
		        return anyTypeAnnotation$2();
		    }
		    throw new Error("Invalid typeof value: " + type);
		  }

		  function getQualifiedName$1(node) {
		    return isIdentifier$i(node) ? node.name : node.id.name + "." + getQualifiedName$1(node.qualification);
		  }
		  function removeTypeDuplicates$1(nodesIn) {
		    var nodes = Array.from(nodesIn);
		    var generics = new Map();
		    var bases = new Map();
		    var typeGroups = new Set();
		    var types = [];
		    for (var i = 0; i < nodes.length; i++) {
		      var node = nodes[i];
		      if (!node) continue;
		      if (types.indexOf(node) >= 0) {
		        continue;
		      }
		      if (isAnyTypeAnnotation$1(node)) {
		        return [node];
		      }
		      if (isFlowBaseAnnotation$1(node)) {
		        bases.set(node.type, node);
		        continue;
		      }
		      if (isUnionTypeAnnotation$1(node)) {
		        if (!typeGroups.has(node.types)) {
		          nodes.push.apply(nodes, _toConsumableArray(node.types));
		          typeGroups.add(node.types);
		        }
		        continue;
		      }
		      if (isGenericTypeAnnotation$1(node)) {
		        var name = getQualifiedName$1(node.id);
		        if (generics.has(name)) {
		          var existing = generics.get(name);
		          if (existing.typeParameters) {
		            if (node.typeParameters) {
		              var _existing$typeParamet;
		              (_existing$typeParamet = existing.typeParameters.params).push.apply(_existing$typeParamet, _toConsumableArray(node.typeParameters.params));
		              existing.typeParameters.params = removeTypeDuplicates$1(existing.typeParameters.params);
		            }
		          } else {
		            existing = node.typeParameters;
		          }
		        } else {
		          generics.set(name, node);
		        }
		        continue;
		      }
		      types.push(node);
		    }
		    for (var _iterator = _createForOfIteratorHelperLoose(bases), _step; !(_step = _iterator()).done;) {
		      var _step$value = _slicedToArray(_step.value, 2),
		        baseType = _step$value[1];
		      types.push(baseType);
		    }
		    for (var _iterator2 = _createForOfIteratorHelperLoose(generics), _step2; !(_step2 = _iterator2()).done;) {
		      var _step2$value = _slicedToArray(_step2.value, 2),
		        genericName = _step2$value[1];
		      types.push(genericName);
		    }
		    return types;
		  }

		  function createFlowUnionType$1(types) {
		    var flattened = removeTypeDuplicates$1(types);
		    if (flattened.length === 1) {
		      return flattened[0];
		    } else {
		      return unionTypeAnnotation$1(flattened);
		    }
		  }

		  function getQualifiedName(node) {
		    return isIdentifier$i(node) ? node.name : node.right.name + "." + getQualifiedName(node.left);
		  }
		  function removeTypeDuplicates(nodesIn) {
		    var nodes = Array.from(nodesIn);
		    var generics = new Map();
		    var bases = new Map();
		    var typeGroups = new Set();
		    var types = [];
		    for (var i = 0; i < nodes.length; i++) {
		      var node = nodes[i];
		      if (!node) continue;
		      if (types.indexOf(node) >= 0) {
		        continue;
		      }
		      if (isTSAnyKeyword(node)) {
		        return [node];
		      }
		      if (isTSBaseType(node)) {
		        bases.set(node.type, node);
		        continue;
		      }
		      if (isTSUnionType(node)) {
		        if (!typeGroups.has(node.types)) {
		          nodes.push.apply(nodes, _toConsumableArray(node.types));
		          typeGroups.add(node.types);
		        }
		        continue;
		      }
		      if (isTSTypeReference$1(node) && node.typeParameters) {
		        var name = getQualifiedName(node.typeName);
		        if (generics.has(name)) {
		          var existing = generics.get(name);
		          if (existing.typeParameters) {
		            if (node.typeParameters) {
		              var _existing$typeParamet;
		              (_existing$typeParamet = existing.typeParameters.params).push.apply(_existing$typeParamet, _toConsumableArray(node.typeParameters.params));
		              existing.typeParameters.params = removeTypeDuplicates(existing.typeParameters.params);
		            }
		          } else {
		            existing = node.typeParameters;
		          }
		        } else {
		          generics.set(name, node);
		        }
		        continue;
		      }
		      types.push(node);
		    }
		    for (var _iterator = _createForOfIteratorHelperLoose(bases), _step; !(_step = _iterator()).done;) {
		      var _step$value = _slicedToArray(_step.value, 2),
		        baseType = _step$value[1];
		      types.push(baseType);
		    }
		    for (var _iterator2 = _createForOfIteratorHelperLoose(generics), _step2; !(_step2 = _iterator2()).done;) {
		      var _step2$value = _slicedToArray(_step2.value, 2),
		        genericName = _step2$value[1];
		      types.push(genericName);
		    }
		    return types;
		  }

		  function createTSUnionType$1(typeAnnotations) {
		    var types = typeAnnotations.map(function (type) {
		      return isTSTypeAnnotation$1(type) ? type.typeAnnotation : type;
		    });
		    var flattened = removeTypeDuplicates(types);
		    if (flattened.length === 1) {
		      return flattened[0];
		    } else {
		      return tsUnionType(flattened);
		    }
		  }

		  function buildUndefinedNode$2() {
		    return unaryExpression$6("void", numericLiteral$8(0), true);
		  }

		  var _ref$1 = {
		      hasOwn: Function.call.bind(Object.prototype.hasOwnProperty)
		    },
		    hasOwn$1 = _ref$1.hasOwn;
		  function cloneIfNode(obj, deep, withoutLoc, commentsCache) {
		    if (obj && typeof obj.type === "string") {
		      return cloneNodeInternal(obj, deep, withoutLoc, commentsCache);
		    }
		    return obj;
		  }
		  function cloneIfNodeOrArray(obj, deep, withoutLoc, commentsCache) {
		    if (Array.isArray(obj)) {
		      return obj.map(function (node) {
		        return cloneIfNode(node, deep, withoutLoc, commentsCache);
		      });
		    }
		    return cloneIfNode(obj, deep, withoutLoc, commentsCache);
		  }
		  function cloneNode$j(node, deep, withoutLoc) {
		    if (deep === void 0) {
		      deep = true;
		    }
		    if (withoutLoc === void 0) {
		      withoutLoc = false;
		    }
		    return cloneNodeInternal(node, deep, withoutLoc, new Map());
		  }
		  function cloneNodeInternal(node, deep, withoutLoc, commentsCache) {
		    if (deep === void 0) {
		      deep = true;
		    }
		    if (withoutLoc === void 0) {
		      withoutLoc = false;
		    }
		    if (!node) return node;
		    var type = node.type;
		    var newNode = {
		      type: node.type
		    };
		    if (isIdentifier$i(node)) {
		      newNode.name = node.name;
		      if (hasOwn$1(node, "optional") && typeof node.optional === "boolean") {
		        newNode.optional = node.optional;
		      }
		      if (hasOwn$1(node, "typeAnnotation")) {
		        newNode.typeAnnotation = deep ? cloneIfNodeOrArray(node.typeAnnotation, true, withoutLoc, commentsCache) : node.typeAnnotation;
		      }
		    } else if (!hasOwn$1(NODE_FIELDS, type)) {
		      throw new Error("Unknown node type: \"" + type + "\"");
		    } else {
		      for (var _i = 0, _Object$keys = Object.keys(NODE_FIELDS[type]); _i < _Object$keys.length; _i++) {
		        var field = _Object$keys[_i];
		        if (hasOwn$1(node, field)) {
		          if (deep) {
		            newNode[field] = isFile(node) && field === "comments" ? maybeCloneComments(node.comments, deep, withoutLoc, commentsCache) : cloneIfNodeOrArray(node[field], true, withoutLoc, commentsCache);
		          } else {
		            newNode[field] = node[field];
		          }
		        }
		      }
		    }
		    if (hasOwn$1(node, "loc")) {
		      if (withoutLoc) {
		        newNode.loc = null;
		      } else {
		        newNode.loc = node.loc;
		      }
		    }
		    if (hasOwn$1(node, "leadingComments")) {
		      newNode.leadingComments = maybeCloneComments(node.leadingComments, deep, withoutLoc, commentsCache);
		    }
		    if (hasOwn$1(node, "innerComments")) {
		      newNode.innerComments = maybeCloneComments(node.innerComments, deep, withoutLoc, commentsCache);
		    }
		    if (hasOwn$1(node, "trailingComments")) {
		      newNode.trailingComments = maybeCloneComments(node.trailingComments, deep, withoutLoc, commentsCache);
		    }
		    if (hasOwn$1(node, "extra")) {
		      newNode.extra = Object.assign({}, node.extra);
		    }
		    return newNode;
		  }
		  function maybeCloneComments(comments, deep, withoutLoc, commentsCache) {
		    if (!comments || !deep) {
		      return comments;
		    }
		    return comments.map(function (comment) {
		      var cache = commentsCache.get(comment);
		      if (cache) return cache;
		      var type = comment.type,
		        value = comment.value,
		        loc = comment.loc;
		      var ret = {
		        type: type,
		        value: value,
		        loc: loc
		      };
		      if (withoutLoc) {
		        ret.loc = null;
		      }
		      commentsCache.set(comment, ret);
		      return ret;
		    });
		  }

		  function clone(node) {
		    return cloneNode$j(node, false);
		  }

		  function cloneDeep$1(node) {
		    return cloneNode$j(node);
		  }

		  function cloneDeepWithoutLoc(node) {
		    return cloneNode$j(node, true, true);
		  }

		  function cloneWithoutLoc(node) {
		    return cloneNode$j(node, false, true);
		  }

		  function addComments$1(node, type, comments) {
		    if (!comments || !node) return node;
		    var key = type + "Comments";
		    if (node[key]) {
		      if (type === "leading") {
		        node[key] = comments.concat(node[key]);
		      } else {
		        var _node$key;
		        (_node$key = node[key]).push.apply(_node$key, _toConsumableArray(comments));
		      }
		    } else {
		      node[key] = comments;
		    }
		    return node;
		  }

		  function addComment$2(node, type, content, line) {
		    return addComments$1(node, type, [{
		      type: line ? "CommentLine" : "CommentBlock",
		      value: content
		    }]);
		  }

		  function inherit(key, child, parent) {
		    if (child && parent) {
		      child[key] = Array.from(new Set([].concat(child[key], parent[key]).filter(Boolean)));
		    }
		  }

		  function inheritInnerComments(child, parent) {
		    inherit("innerComments", child, parent);
		  }

		  function inheritLeadingComments$1(child, parent) {
		    inherit("leadingComments", child, parent);
		  }

		  function inheritTrailingComments$1(child, parent) {
		    inherit("trailingComments", child, parent);
		  }

		  function inheritsComments$1(child, parent) {
		    inheritTrailingComments$1(child, parent);
		    inheritLeadingComments$1(child, parent);
		    inheritInnerComments(child, parent);
		    return child;
		  }

		  function removeComments$1(node) {
		    COMMENT_KEYS.forEach(function (key) {
		      node[key] = null;
		    });
		    return node;
		  }

		  var STANDARDIZED_TYPES = FLIPPED_ALIAS_KEYS$3["Standardized"];
		  var EXPRESSION_TYPES = FLIPPED_ALIAS_KEYS$3["Expression"];
		  var BINARY_TYPES = FLIPPED_ALIAS_KEYS$3["Binary"];
		  var SCOPABLE_TYPES = FLIPPED_ALIAS_KEYS$3["Scopable"];
		  var BLOCKPARENT_TYPES = FLIPPED_ALIAS_KEYS$3["BlockParent"];
		  var BLOCK_TYPES = FLIPPED_ALIAS_KEYS$3["Block"];
		  var STATEMENT_TYPES = FLIPPED_ALIAS_KEYS$3["Statement"];
		  var TERMINATORLESS_TYPES = FLIPPED_ALIAS_KEYS$3["Terminatorless"];
		  var COMPLETIONSTATEMENT_TYPES = FLIPPED_ALIAS_KEYS$3["CompletionStatement"];
		  var CONDITIONAL_TYPES = FLIPPED_ALIAS_KEYS$3["Conditional"];
		  var LOOP_TYPES = FLIPPED_ALIAS_KEYS$3["Loop"];
		  var WHILE_TYPES = FLIPPED_ALIAS_KEYS$3["While"];
		  var EXPRESSIONWRAPPER_TYPES = FLIPPED_ALIAS_KEYS$3["ExpressionWrapper"];
		  var FOR_TYPES = FLIPPED_ALIAS_KEYS$3["For"];
		  var FORXSTATEMENT_TYPES = FLIPPED_ALIAS_KEYS$3["ForXStatement"];
		  var FUNCTION_TYPES$1 = FLIPPED_ALIAS_KEYS$3["Function"];
		  var FUNCTIONPARENT_TYPES = FLIPPED_ALIAS_KEYS$3["FunctionParent"];
		  var PUREISH_TYPES = FLIPPED_ALIAS_KEYS$3["Pureish"];
		  var DECLARATION_TYPES = FLIPPED_ALIAS_KEYS$3["Declaration"];
		  var PATTERNLIKE_TYPES = FLIPPED_ALIAS_KEYS$3["PatternLike"];
		  var LVAL_TYPES = FLIPPED_ALIAS_KEYS$3["LVal"];
		  var TSENTITYNAME_TYPES = FLIPPED_ALIAS_KEYS$3["TSEntityName"];
		  var LITERAL_TYPES = FLIPPED_ALIAS_KEYS$3["Literal"];
		  var IMMUTABLE_TYPES = FLIPPED_ALIAS_KEYS$3["Immutable"];
		  var USERWHITESPACABLE_TYPES = FLIPPED_ALIAS_KEYS$3["UserWhitespacable"];
		  var METHOD_TYPES = FLIPPED_ALIAS_KEYS$3["Method"];
		  var OBJECTMEMBER_TYPES = FLIPPED_ALIAS_KEYS$3["ObjectMember"];
		  var PROPERTY_TYPES = FLIPPED_ALIAS_KEYS$3["Property"];
		  var UNARYLIKE_TYPES = FLIPPED_ALIAS_KEYS$3["UnaryLike"];
		  var PATTERN_TYPES = FLIPPED_ALIAS_KEYS$3["Pattern"];
		  var CLASS_TYPES = FLIPPED_ALIAS_KEYS$3["Class"];
		  var IMPORTOREXPORTDECLARATION_TYPES = FLIPPED_ALIAS_KEYS$3["ImportOrExportDeclaration"];
		  var EXPORTDECLARATION_TYPES = FLIPPED_ALIAS_KEYS$3["ExportDeclaration"];
		  var MODULESPECIFIER_TYPES = FLIPPED_ALIAS_KEYS$3["ModuleSpecifier"];
		  var ACCESSOR_TYPES = FLIPPED_ALIAS_KEYS$3["Accessor"];
		  var PRIVATE_TYPES = FLIPPED_ALIAS_KEYS$3["Private"];
		  var FLOW_TYPES = FLIPPED_ALIAS_KEYS$3["Flow"];
		  var FLOWTYPE_TYPES = FLIPPED_ALIAS_KEYS$3["FlowType"];
		  var FLOWBASEANNOTATION_TYPES = FLIPPED_ALIAS_KEYS$3["FlowBaseAnnotation"];
		  var FLOWDECLARATION_TYPES = FLIPPED_ALIAS_KEYS$3["FlowDeclaration"];
		  var FLOWPREDICATE_TYPES = FLIPPED_ALIAS_KEYS$3["FlowPredicate"];
		  var ENUMBODY_TYPES = FLIPPED_ALIAS_KEYS$3["EnumBody"];
		  var ENUMMEMBER_TYPES = FLIPPED_ALIAS_KEYS$3["EnumMember"];
		  var JSX_TYPES = FLIPPED_ALIAS_KEYS$3["JSX"];
		  var MISCELLANEOUS_TYPES = FLIPPED_ALIAS_KEYS$3["Miscellaneous"];
		  var TYPESCRIPT_TYPES = FLIPPED_ALIAS_KEYS$3["TypeScript"];
		  var TSTYPEELEMENT_TYPES = FLIPPED_ALIAS_KEYS$3["TSTypeElement"];
		  var TSTYPE_TYPES = FLIPPED_ALIAS_KEYS$3["TSType"];
		  var TSBASETYPE_TYPES = FLIPPED_ALIAS_KEYS$3["TSBaseType"];
		  var MODULEDECLARATION_TYPES = IMPORTOREXPORTDECLARATION_TYPES;

		  function toBlock(node, parent) {
		    if (isBlockStatement$3(node)) {
		      return node;
		    }
		    var blockNodes = [];
		    if (isEmptyStatement$1(node)) {
		      blockNodes = [];
		    } else {
		      if (!isStatement$8(node)) {
		        if (isFunction$5(parent)) {
		          node = returnStatement$3(node);
		        } else {
		          node = expressionStatement$a(node);
		        }
		      }
		      blockNodes = [node];
		    }
		    return blockStatement$6(blockNodes);
		  }

		  function ensureBlock$1(node, key) {
		    if (key === void 0) {
		      key = "body";
		    }
		    var result = toBlock(node[key], node);
		    node[key] = result;
		    return result;
		  }

		  function toIdentifier$1(input) {
		    input = input + "";
		    var name = "";
		    for (var _iterator = _createForOfIteratorHelperLoose(input), _step; !(_step = _iterator()).done;) {
		      var c = _step.value;
		      name += isIdentifierChar(c.codePointAt(0)) ? c : "-";
		    }
		    name = name.replace(/^[-0-9]+/, "");
		    name = name.replace(/[-\s]+(.)?/g, function (match, c) {
		      return c ? c.toUpperCase() : "";
		    });
		    if (!isValidIdentifier$1(name)) {
		      name = "_" + name;
		    }
		    return name || "_";
		  }

		  function toBindingIdentifierName$1(name) {
		    name = toIdentifier$1(name);
		    if (name === "eval" || name === "arguments") name = "_" + name;
		    return name;
		  }

		  function toComputedKey$2(node, key) {
		    if (key === void 0) {
		      key = node.key || node.property;
		    }
		    if (!node.computed && isIdentifier$i(key)) key = stringLiteral$8(key.name);
		    return key;
		  }

		  function toExpression$1(node) {
		    if (isExpressionStatement$2(node)) {
		      node = node.expression;
		    }
		    if (isExpression$4(node)) {
		      return node;
		    }
		    if (isClass$1(node)) {
		      node.type = "ClassExpression";
		    } else if (isFunction$5(node)) {
		      node.type = "FunctionExpression";
		    }
		    if (!isExpression$4(node)) {
		      throw new Error("cannot turn " + node.type + " to an expression");
		    }
		    return node;
		  }

		  function traverseFast$2(node, enter, opts) {
		    if (!node) return;
		    var keys = VISITOR_KEYS$5[node.type];
		    if (!keys) return;
		    opts = opts || {};
		    enter(node, opts);
		    for (var _iterator = _createForOfIteratorHelperLoose(keys), _step; !(_step = _iterator()).done;) {
		      var key = _step.value;
		      var subNode = node[key];
		      if (Array.isArray(subNode)) {
		        for (var _iterator2 = _createForOfIteratorHelperLoose(subNode), _step2; !(_step2 = _iterator2()).done;) {
		          var _node = _step2.value;
		          traverseFast$2(_node, enter, opts);
		        }
		      } else {
		        traverseFast$2(subNode, enter, opts);
		      }
		    }
		  }

		  var CLEAR_KEYS = ["tokens", "start", "end", "loc", "raw", "rawValue"];
		  var CLEAR_KEYS_PLUS_COMMENTS = [].concat(_toConsumableArray(COMMENT_KEYS), ["comments"], CLEAR_KEYS);
		  function removeProperties$1(node, opts) {
		    if (opts === void 0) {
		      opts = {};
		    }
		    var map = opts.preserveComments ? CLEAR_KEYS : CLEAR_KEYS_PLUS_COMMENTS;
		    for (var _iterator = _createForOfIteratorHelperLoose(map), _step; !(_step = _iterator()).done;) {
		      var _key = _step.value;
		      if (node[_key] != null) node[_key] = undefined;
		    }
		    for (var _i = 0, _Object$keys = Object.keys(node); _i < _Object$keys.length; _i++) {
		      var key = _Object$keys[_i];
		      if (key[0] === "_" && node[key] != null) node[key] = undefined;
		    }
		    var symbols = Object.getOwnPropertySymbols(node);
		    for (var _iterator2 = _createForOfIteratorHelperLoose(symbols), _step2; !(_step2 = _iterator2()).done;) {
		      var sym = _step2.value;
		      node[sym] = null;
		    }
		  }

		  function removePropertiesDeep$1(tree, opts) {
		    traverseFast$2(tree, removeProperties$1, opts);
		    return tree;
		  }

		  function toKeyAlias(node, key) {
		    if (key === void 0) {
		      key = node.key;
		    }
		    var alias;
		    if (node.kind === "method") {
		      return toKeyAlias.increment() + "";
		    } else if (isIdentifier$i(key)) {
		      alias = key.name;
		    } else if (isStringLiteral$5(key)) {
		      alias = JSON.stringify(key.value);
		    } else {
		      alias = JSON.stringify(removePropertiesDeep$1(cloneNode$j(key)));
		    }
		    if (node.computed) {
		      alias = "[" + alias + "]";
		    }
		    if (node["static"]) {
		      alias = "static:" + alias;
		    }
		    return alias;
		  }
		  toKeyAlias.uid = 0;
		  toKeyAlias.increment = function () {
		    if (toKeyAlias.uid >= Number.MAX_SAFE_INTEGER) {
		      return toKeyAlias.uid = 0;
		    } else {
		      return toKeyAlias.uid++;
		    }
		  };

		  function toStatement(node, ignore) {
		    if (isStatement$8(node)) {
		      return node;
		    }
		    var mustHaveId = false;
		    var newType;
		    if (isClass$1(node)) {
		      mustHaveId = true;
		      newType = "ClassDeclaration";
		    } else if (isFunction$5(node)) {
		      mustHaveId = true;
		      newType = "FunctionDeclaration";
		    } else if (isAssignmentExpression$3(node)) {
		      return expressionStatement$a(node);
		    }
		    if (mustHaveId && !node.id) {
		      newType = false;
		    }
		    if (!newType) {
		      if (ignore) {
		        return false;
		      } else {
		        throw new Error("cannot turn " + node.type + " to a statement");
		      }
		    }
		    node.type = newType;
		    return node;
		  }

		  var objectToString$1 = Function.call.bind(Object.prototype.toString);
		  function isRegExp$1(value) {
		    return objectToString$1(value) === "[object RegExp]";
		  }
		  function isPlainObject(value) {
		    if (typeof value !== "object" || value === null || Object.prototype.toString.call(value) !== "[object Object]") {
		      return false;
		    }
		    var proto = Object.getPrototypeOf(value);
		    return proto === null || Object.getPrototypeOf(proto) === null;
		  }
		  function valueToNode$1(value) {
		    if (value === undefined) {
		      return identifier$j("undefined");
		    }
		    if (value === true || value === false) {
		      return booleanLiteral$4(value);
		    }
		    if (value === null) {
		      return nullLiteral$2();
		    }
		    if (typeof value === "string") {
		      return stringLiteral$8(value);
		    }
		    if (typeof value === "number") {
		      var result;
		      if (Number.isFinite(value)) {
		        result = numericLiteral$8(Math.abs(value));
		      } else {
		        var numerator;
		        if (Number.isNaN(value)) {
		          numerator = numericLiteral$8(0);
		        } else {
		          numerator = numericLiteral$8(1);
		        }
		        result = binaryExpression$5("/", numerator, numericLiteral$8(0));
		      }
		      if (value < 0 || Object.is(value, -0)) {
		        result = unaryExpression$6("-", result);
		      }
		      return result;
		    }
		    if (isRegExp$1(value)) {
		      var pattern = value.source;
		      var flags = value.toString().match(/\/([a-z]+|)$/)[1];
		      return regExpLiteral(pattern, flags);
		    }
		    if (Array.isArray(value)) {
		      return arrayExpression$1(value.map(valueToNode$1));
		    }
		    if (isPlainObject(value)) {
		      var props = [];
		      for (var _i = 0, _Object$keys = Object.keys(value); _i < _Object$keys.length; _i++) {
		        var key = _Object$keys[_i];
		        var nodeKey = void 0;
		        if (isValidIdentifier$1(key)) {
		          nodeKey = identifier$j(key);
		        } else {
		          nodeKey = stringLiteral$8(key);
		        }
		        props.push(objectProperty$1(nodeKey, valueToNode$1(value[key])));
		      }
		      return objectExpression$3(props);
		    }
		    throw new Error("don't know how to turn this value into a node");
		  }

		  function appendToMemberExpression(member, append, computed) {
		    if (computed === void 0) {
		      computed = false;
		    }
		    member.object = memberExpression$c(member.object, member.property, member.computed);
		    member.property = append;
		    member.computed = !!computed;
		    return member;
		  }

		  function inherits$3(child, parent) {
		    if (!child || !parent) return child;
		    for (var _iterator = _createForOfIteratorHelperLoose(INHERIT_KEYS.optional), _step; !(_step = _iterator()).done;) {
		      var _key = _step.value;
		      if (child[_key] == null) {
		        child[_key] = parent[_key];
		      }
		    }
		    for (var _i = 0, _Object$keys = Object.keys(parent); _i < _Object$keys.length; _i++) {
		      var key = _Object$keys[_i];
		      if (key[0] === "_" && key !== "__clone") {
		        child[key] = parent[key];
		      }
		    }
		    for (var _iterator2 = _createForOfIteratorHelperLoose(INHERIT_KEYS.force), _step2; !(_step2 = _iterator2()).done;) {
		      var _key2 = _step2.value;
		      child[_key2] = parent[_key2];
		    }
		    inheritsComments$1(child, parent);
		    return child;
		  }

		  function prependToMemberExpression(member, prepend) {
		    if (isSuper$3(member.object)) {
		      throw new Error("Cannot prepend node to super property access (`super.foo`).");
		    }
		    member.object = memberExpression$c(prepend, member.object);
		    return member;
		  }

		  function getBindingIdentifiers$4(node, duplicates, outerOnly, newBindingsOnly) {
		    var search = [].concat(node);
		    var ids = Object.create(null);
		    while (search.length) {
		      var id = search.shift();
		      if (!id) continue;
		      if (newBindingsOnly && (isAssignmentExpression$3(id) || isUnaryExpression$1(id))) {
		        continue;
		      }
		      var keys = getBindingIdentifiers$4.keys[id.type];
		      if (isIdentifier$i(id)) {
		        if (duplicates) {
		          var _ids = ids[id.name] = ids[id.name] || [];
		          _ids.push(id);
		        } else {
		          ids[id.name] = id;
		        }
		        continue;
		      }
		      if (isExportDeclaration$3(id) && !isExportAllDeclaration$1(id)) {
		        if (isDeclaration(id.declaration)) {
		          search.push(id.declaration);
		        }
		        continue;
		      }
		      if (outerOnly) {
		        if (isFunctionDeclaration$2(id)) {
		          search.push(id.id);
		          continue;
		        }
		        if (isFunctionExpression$1(id)) {
		          continue;
		        }
		      }
		      if (keys) {
		        for (var i = 0; i < keys.length; i++) {
		          var key = keys[i];
		          var nodes = id[key];
		          if (nodes) {
		            Array.isArray(nodes) ? search.push.apply(search, _toConsumableArray(nodes)) : search.push(nodes);
		          }
		        }
		      }
		    }
		    return ids;
		  }
		  getBindingIdentifiers$4.keys = {
		    DeclareClass: ["id"],
		    DeclareFunction: ["id"],
		    DeclareModule: ["id"],
		    DeclareVariable: ["id"],
		    DeclareInterface: ["id"],
		    DeclareTypeAlias: ["id"],
		    DeclareOpaqueType: ["id"],
		    InterfaceDeclaration: ["id"],
		    TypeAlias: ["id"],
		    OpaqueType: ["id"],
		    CatchClause: ["param"],
		    LabeledStatement: ["label"],
		    UnaryExpression: ["argument"],
		    AssignmentExpression: ["left"],
		    ImportSpecifier: ["local"],
		    ImportNamespaceSpecifier: ["local"],
		    ImportDefaultSpecifier: ["local"],
		    ImportDeclaration: ["specifiers"],
		    ExportSpecifier: ["exported"],
		    ExportNamespaceSpecifier: ["exported"],
		    ExportDefaultSpecifier: ["exported"],
		    FunctionDeclaration: ["id", "params"],
		    FunctionExpression: ["id", "params"],
		    ArrowFunctionExpression: ["params"],
		    ObjectMethod: ["params"],
		    ClassMethod: ["params"],
		    ClassPrivateMethod: ["params"],
		    ForInStatement: ["left"],
		    ForOfStatement: ["left"],
		    ClassDeclaration: ["id"],
		    ClassExpression: ["id"],
		    RestElement: ["argument"],
		    UpdateExpression: ["argument"],
		    ObjectProperty: ["value"],
		    AssignmentPattern: ["left"],
		    ArrayPattern: ["elements"],
		    ObjectPattern: ["properties"],
		    VariableDeclaration: ["declarations"],
		    VariableDeclarator: ["id"]
		  };

		  function getOuterBindingIdentifiers$2(node, duplicates) {
		    return getBindingIdentifiers$4(node, duplicates, true);
		  }

		  function traverse$2(node, handlers, state) {
		    if (typeof handlers === "function") {
		      handlers = {
		        enter: handlers
		      };
		    }
		    var _handlers = handlers,
		      enter = _handlers.enter,
		      exit = _handlers.exit;
		    traverseSimpleImpl(node, enter, exit, state, []);
		  }
		  function traverseSimpleImpl(node, enter, exit, state, ancestors) {
		    var keys = VISITOR_KEYS$5[node.type];
		    if (!keys) return;
		    if (enter) enter(node, ancestors, state);
		    for (var _iterator = _createForOfIteratorHelperLoose(keys), _step; !(_step = _iterator()).done;) {
		      var key = _step.value;
		      var subNode = node[key];
		      if (Array.isArray(subNode)) {
		        for (var i = 0; i < subNode.length; i++) {
		          var child = subNode[i];
		          if (!child) continue;
		          ancestors.push({
		            node: node,
		            key: key,
		            index: i
		          });
		          traverseSimpleImpl(child, enter, exit, state, ancestors);
		          ancestors.pop();
		        }
		      } else if (subNode) {
		        ancestors.push({
		          node: node,
		          key: key
		        });
		        traverseSimpleImpl(subNode, enter, exit, state, ancestors);
		        ancestors.pop();
		      }
		    }
		    if (exit) exit(node, ancestors, state);
		  }

		  function isBinding$1(node, parent, grandparent) {
		    if (grandparent && node.type === "Identifier" && parent.type === "ObjectProperty" && grandparent.type === "ObjectExpression") {
		      return false;
		    }
		    var keys = getBindingIdentifiers$4.keys[parent.type];
		    if (keys) {
		      for (var i = 0; i < keys.length; i++) {
		        var key = keys[i];
		        var val = parent[key];
		        if (Array.isArray(val)) {
		          if (val.indexOf(node) >= 0) return true;
		        } else {
		          if (val === node) return true;
		        }
		      }
		    }
		    return false;
		  }

		  function isLet(node) {
		    return isVariableDeclaration$4(node) && (node.kind !== "var" || node[BLOCK_SCOPED_SYMBOL]);
		  }

		  function isBlockScoped$2(node) {
		    return isFunctionDeclaration$2(node) || isClassDeclaration$2(node) || isLet(node);
		  }

		  function isImmutable(node) {
		    if (isType$2(node.type, "Immutable")) return true;
		    if (isIdentifier$i(node)) {
		      if (node.name === "undefined") {
		        return true;
		      } else {
		        return false;
		      }
		    }
		    return false;
		  }

		  function isNodesEquivalent(a, b) {
		    if (typeof a !== "object" || typeof b !== "object" || a == null || b == null) {
		      return a === b;
		    }
		    if (a.type !== b.type) {
		      return false;
		    }
		    var fields = Object.keys(NODE_FIELDS[a.type] || a.type);
		    var visitorKeys = VISITOR_KEYS$5[a.type];
		    for (var _i = 0, _fields = fields; _i < _fields.length; _i++) {
		      var field = _fields[_i];
		      var val_a = a[field];
		      var val_b = b[field];
		      if (typeof val_a !== typeof val_b) {
		        return false;
		      }
		      if (val_a == null && val_b == null) {
		        continue;
		      } else if (val_a == null || val_b == null) {
		        return false;
		      }
		      if (Array.isArray(val_a)) {
		        if (!Array.isArray(val_b)) {
		          return false;
		        }
		        if (val_a.length !== val_b.length) {
		          return false;
		        }
		        for (var i = 0; i < val_a.length; i++) {
		          if (!isNodesEquivalent(val_a[i], val_b[i])) {
		            return false;
		          }
		        }
		        continue;
		      }
		      if (typeof val_a === "object" && !(visitorKeys != null && visitorKeys.includes(field))) {
		        for (var _i2 = 0, _Object$keys = Object.keys(val_a); _i2 < _Object$keys.length; _i2++) {
		          var key = _Object$keys[_i2];
		          if (val_a[key] !== val_b[key]) {
		            return false;
		          }
		        }
		        continue;
		      }
		      if (!isNodesEquivalent(val_a, val_b)) {
		        return false;
		      }
		    }
		    return true;
		  }

		  function isReferenced$2(node, parent, grandparent) {
		    switch (parent.type) {
		      case "MemberExpression":
		      case "OptionalMemberExpression":
		        if (parent.property === node) {
		          return !!parent.computed;
		        }
		        return parent.object === node;
		      case "JSXMemberExpression":
		        return parent.object === node;
		      case "VariableDeclarator":
		        return parent.init === node;
		      case "ArrowFunctionExpression":
		        return parent.body === node;
		      case "PrivateName":
		        return false;
		      case "ClassMethod":
		      case "ClassPrivateMethod":
		      case "ObjectMethod":
		        if (parent.key === node) {
		          return !!parent.computed;
		        }
		        return false;
		      case "ObjectProperty":
		        if (parent.key === node) {
		          return !!parent.computed;
		        }
		        return !grandparent || grandparent.type !== "ObjectPattern";
		      case "ClassProperty":
		      case "ClassAccessorProperty":
		        if (parent.key === node) {
		          return !!parent.computed;
		        }
		        return true;
		      case "ClassPrivateProperty":
		        return parent.key !== node;
		      case "ClassDeclaration":
		      case "ClassExpression":
		        return parent.superClass === node;
		      case "AssignmentExpression":
		        return parent.right === node;
		      case "AssignmentPattern":
		        return parent.right === node;
		      case "LabeledStatement":
		        return false;
		      case "CatchClause":
		        return false;
		      case "RestElement":
		        return false;
		      case "BreakStatement":
		      case "ContinueStatement":
		        return false;
		      case "FunctionDeclaration":
		      case "FunctionExpression":
		        return false;
		      case "ExportNamespaceSpecifier":
		      case "ExportDefaultSpecifier":
		        return false;
		      case "ExportSpecifier":
		        if (grandparent != null && grandparent.source) {
		          return false;
		        }
		        return parent.local === node;
		      case "ImportDefaultSpecifier":
		      case "ImportNamespaceSpecifier":
		      case "ImportSpecifier":
		        return false;
		      case "ImportAttribute":
		        return false;
		      case "JSXAttribute":
		        return false;
		      case "ObjectPattern":
		      case "ArrayPattern":
		        return false;
		      case "MetaProperty":
		        return false;
		      case "ObjectTypeProperty":
		        return parent.key !== node;
		      case "TSEnumMember":
		        return parent.id !== node;
		      case "TSPropertySignature":
		        if (parent.key === node) {
		          return !!parent.computed;
		        }
		        return true;
		    }
		    return true;
		  }

		  function isScope$1(node, parent) {
		    if (isBlockStatement$3(node) && (isFunction$5(parent) || isCatchClause(parent))) {
		      return false;
		    }
		    if (isPattern(node) && (isFunction$5(parent) || isCatchClause(parent))) {
		      return true;
		    }
		    return isScopable(node);
		  }

		  function isSpecifierDefault(specifier) {
		    return isImportDefaultSpecifier$1(specifier) || isIdentifier$i(specifier.imported || specifier.exported, {
		      name: "default"
		    });
		  }

		  var RESERVED_WORDS_ES3_ONLY = new Set(["abstract", "boolean", "byte", "char", "double", "enum", "final", "float", "goto", "implements", "int", "interface", "long", "native", "package", "private", "protected", "public", "short", "static", "synchronized", "throws", "transient", "volatile"]);
		  function isValidES3Identifier(name) {
		    return isValidIdentifier$1(name) && !RESERVED_WORDS_ES3_ONLY.has(name);
		  }

		  function isVar$1(node) {
		    return isVariableDeclaration$4(node, {
		      kind: "var"
		    }) && !node[BLOCK_SCOPED_SYMBOL];
		  }

		  var react$3 = {
		    isReactComponent: isReactComponent,
		    isCompatTag: isCompatTag$1,
		    buildChildren: buildChildren
		  };

		  var t$4 = /*#__PURE__*/Object.freeze({
		    __proto__: null,
		    ACCESSOR_TYPES: ACCESSOR_TYPES,
		    ALIAS_KEYS: ALIAS_KEYS,
		    ASSIGNMENT_OPERATORS: ASSIGNMENT_OPERATORS,
		    AnyTypeAnnotation: anyTypeAnnotation$2,
		    ArgumentPlaceholder: argumentPlaceholder,
		    ArrayExpression: arrayExpression$1,
		    ArrayPattern: arrayPattern,
		    ArrayTypeAnnotation: arrayTypeAnnotation$1,
		    ArrowFunctionExpression: arrowFunctionExpression$4,
		    AssignmentExpression: assignmentExpression$d,
		    AssignmentPattern: assignmentPattern,
		    AwaitExpression: awaitExpression$1,
		    BINARY_OPERATORS: BINARY_OPERATORS,
		    BINARY_TYPES: BINARY_TYPES,
		    BLOCKPARENT_TYPES: BLOCKPARENT_TYPES,
		    BLOCK_SCOPED_SYMBOL: BLOCK_SCOPED_SYMBOL,
		    BLOCK_TYPES: BLOCK_TYPES,
		    BOOLEAN_BINARY_OPERATORS: BOOLEAN_BINARY_OPERATORS$1,
		    BOOLEAN_NUMBER_BINARY_OPERATORS: BOOLEAN_NUMBER_BINARY_OPERATORS$1,
		    BOOLEAN_UNARY_OPERATORS: BOOLEAN_UNARY_OPERATORS$1,
		    BUILDER_KEYS: BUILDER_KEYS,
		    BigIntLiteral: bigIntLiteral,
		    BinaryExpression: binaryExpression$5,
		    BindExpression: bindExpression,
		    BlockStatement: blockStatement$6,
		    BooleanLiteral: booleanLiteral$4,
		    BooleanLiteralTypeAnnotation: booleanLiteralTypeAnnotation,
		    BooleanTypeAnnotation: booleanTypeAnnotation$1,
		    BreakStatement: breakStatement,
		    CLASS_TYPES: CLASS_TYPES,
		    COMMENT_KEYS: COMMENT_KEYS,
		    COMPARISON_BINARY_OPERATORS: COMPARISON_BINARY_OPERATORS,
		    COMPLETIONSTATEMENT_TYPES: COMPLETIONSTATEMENT_TYPES,
		    CONDITIONAL_TYPES: CONDITIONAL_TYPES,
		    CallExpression: callExpression$d,
		    CatchClause: catchClause,
		    ClassAccessorProperty: classAccessorProperty,
		    ClassBody: classBody,
		    ClassDeclaration: classDeclaration,
		    ClassExpression: classExpression,
		    ClassImplements: classImplements,
		    ClassMethod: classMethod,
		    ClassPrivateMethod: classPrivateMethod,
		    ClassPrivateProperty: classPrivateProperty,
		    ClassProperty: classProperty,
		    ConditionalExpression: conditionalExpression$5,
		    ContinueStatement: continueStatement,
		    DECLARATION_TYPES: DECLARATION_TYPES,
		    DEPRECATED_ALIASES: DEPRECATED_ALIASES$1,
		    DEPRECATED_KEYS: DEPRECATED_KEYS$1,
		    DebuggerStatement: debuggerStatement,
		    DecimalLiteral: decimalLiteral,
		    DeclareClass: declareClass,
		    DeclareExportAllDeclaration: declareExportAllDeclaration,
		    DeclareExportDeclaration: declareExportDeclaration,
		    DeclareFunction: declareFunction,
		    DeclareInterface: declareInterface,
		    DeclareModule: declareModule,
		    DeclareModuleExports: declareModuleExports,
		    DeclareOpaqueType: declareOpaqueType,
		    DeclareTypeAlias: declareTypeAlias,
		    DeclareVariable: declareVariable,
		    DeclaredPredicate: declaredPredicate,
		    Decorator: decorator,
		    Directive: directive$1,
		    DirectiveLiteral: directiveLiteral$1,
		    DoExpression: doExpression,
		    DoWhileStatement: doWhileStatement,
		    ENUMBODY_TYPES: ENUMBODY_TYPES,
		    ENUMMEMBER_TYPES: ENUMMEMBER_TYPES,
		    EQUALITY_BINARY_OPERATORS: EQUALITY_BINARY_OPERATORS,
		    EXPORTDECLARATION_TYPES: EXPORTDECLARATION_TYPES,
		    EXPRESSIONWRAPPER_TYPES: EXPRESSIONWRAPPER_TYPES,
		    EXPRESSION_TYPES: EXPRESSION_TYPES,
		    EmptyStatement: emptyStatement$1,
		    EmptyTypeAnnotation: emptyTypeAnnotation,
		    EnumBooleanBody: enumBooleanBody,
		    EnumBooleanMember: enumBooleanMember,
		    EnumDeclaration: enumDeclaration,
		    EnumDefaultedMember: enumDefaultedMember,
		    EnumNumberBody: enumNumberBody,
		    EnumNumberMember: enumNumberMember,
		    EnumStringBody: enumStringBody,
		    EnumStringMember: enumStringMember,
		    EnumSymbolBody: enumSymbolBody,
		    ExistsTypeAnnotation: existsTypeAnnotation,
		    ExportAllDeclaration: exportAllDeclaration,
		    ExportDefaultDeclaration: exportDefaultDeclaration,
		    ExportDefaultSpecifier: exportDefaultSpecifier,
		    ExportNamedDeclaration: exportNamedDeclaration$2,
		    ExportNamespaceSpecifier: exportNamespaceSpecifier,
		    ExportSpecifier: exportSpecifier$2,
		    ExpressionStatement: expressionStatement$a,
		    FLATTENABLE_KEYS: FLATTENABLE_KEYS,
		    FLIPPED_ALIAS_KEYS: FLIPPED_ALIAS_KEYS$3,
		    FLOWBASEANNOTATION_TYPES: FLOWBASEANNOTATION_TYPES,
		    FLOWDECLARATION_TYPES: FLOWDECLARATION_TYPES,
		    FLOWPREDICATE_TYPES: FLOWPREDICATE_TYPES,
		    FLOWTYPE_TYPES: FLOWTYPE_TYPES,
		    FLOW_TYPES: FLOW_TYPES,
		    FORXSTATEMENT_TYPES: FORXSTATEMENT_TYPES,
		    FOR_INIT_KEYS: FOR_INIT_KEYS,
		    FOR_TYPES: FOR_TYPES,
		    FUNCTIONPARENT_TYPES: FUNCTIONPARENT_TYPES,
		    FUNCTION_TYPES: FUNCTION_TYPES$1,
		    File: file$2,
		    ForInStatement: forInStatement,
		    ForOfStatement: forOfStatement,
		    ForStatement: forStatement,
		    FunctionDeclaration: functionDeclaration,
		    FunctionExpression: functionExpression$2,
		    FunctionTypeAnnotation: functionTypeAnnotation,
		    FunctionTypeParam: functionTypeParam,
		    GenericTypeAnnotation: genericTypeAnnotation$1,
		    IMMUTABLE_TYPES: IMMUTABLE_TYPES,
		    IMPORTOREXPORTDECLARATION_TYPES: IMPORTOREXPORTDECLARATION_TYPES,
		    INHERIT_KEYS: INHERIT_KEYS,
		    Identifier: identifier$j,
		    IfStatement: ifStatement,
		    Import: _import,
		    ImportAttribute: importAttribute,
		    ImportDeclaration: importDeclaration$1,
		    ImportDefaultSpecifier: importDefaultSpecifier$1,
		    ImportExpression: importExpression,
		    ImportNamespaceSpecifier: importNamespaceSpecifier$1,
		    ImportSpecifier: importSpecifier$2,
		    IndexedAccessType: indexedAccessType,
		    InferredPredicate: inferredPredicate,
		    InterfaceDeclaration: interfaceDeclaration,
		    InterfaceExtends: interfaceExtends,
		    InterfaceTypeAnnotation: interfaceTypeAnnotation,
		    InterpreterDirective: interpreterDirective$1,
		    IntersectionTypeAnnotation: intersectionTypeAnnotation,
		    JSXAttribute: jsxAttribute,
		    JSXClosingElement: jsxClosingElement,
		    JSXClosingFragment: jsxClosingFragment,
		    JSXElement: jsxElement,
		    JSXEmptyExpression: jsxEmptyExpression,
		    JSXExpressionContainer: jsxExpressionContainer$1,
		    JSXFragment: jsxFragment,
		    JSXIdentifier: jsxIdentifier$2,
		    JSXMemberExpression: jsxMemberExpression$1,
		    JSXNamespacedName: jsxNamespacedName,
		    JSXOpeningElement: jsxOpeningElement,
		    JSXOpeningFragment: jsxOpeningFragment,
		    JSXSpreadAttribute: jsxSpreadAttribute,
		    JSXSpreadChild: jsxSpreadChild,
		    JSXText: jsxText,
		    JSX_TYPES: JSX_TYPES,
		    LITERAL_TYPES: LITERAL_TYPES,
		    LOGICAL_OPERATORS: LOGICAL_OPERATORS$3,
		    LOOP_TYPES: LOOP_TYPES,
		    LVAL_TYPES: LVAL_TYPES,
		    LabeledStatement: labeledStatement,
		    LogicalExpression: logicalExpression$3,
		    METHOD_TYPES: METHOD_TYPES,
		    MISCELLANEOUS_TYPES: MISCELLANEOUS_TYPES,
		    MODULEDECLARATION_TYPES: MODULEDECLARATION_TYPES,
		    MODULESPECIFIER_TYPES: MODULESPECIFIER_TYPES,
		    MemberExpression: memberExpression$c,
		    MetaProperty: metaProperty$1,
		    MixedTypeAnnotation: mixedTypeAnnotation,
		    ModuleExpression: moduleExpression,
		    NODE_FIELDS: NODE_FIELDS,
		    NODE_PARENT_VALIDATIONS: NODE_PARENT_VALIDATIONS,
		    NOT_LOCAL_BINDING: NOT_LOCAL_BINDING$2,
		    NUMBER_BINARY_OPERATORS: NUMBER_BINARY_OPERATORS$1,
		    NUMBER_UNARY_OPERATORS: NUMBER_UNARY_OPERATORS$1,
		    NewExpression: newExpression,
		    Noop: noop$1,
		    NullLiteral: nullLiteral$2,
		    NullLiteralTypeAnnotation: nullLiteralTypeAnnotation$1,
		    NullableTypeAnnotation: nullableTypeAnnotation,
		    NumberLiteral: NumberLiteral,
		    NumberLiteralTypeAnnotation: numberLiteralTypeAnnotation,
		    NumberTypeAnnotation: numberTypeAnnotation$2,
		    NumericLiteral: numericLiteral$8,
		    OBJECTMEMBER_TYPES: OBJECTMEMBER_TYPES,
		    ObjectExpression: objectExpression$3,
		    ObjectMethod: objectMethod,
		    ObjectPattern: objectPattern$1,
		    ObjectProperty: objectProperty$1,
		    ObjectTypeAnnotation: objectTypeAnnotation,
		    ObjectTypeCallProperty: objectTypeCallProperty,
		    ObjectTypeIndexer: objectTypeIndexer,
		    ObjectTypeInternalSlot: objectTypeInternalSlot,
		    ObjectTypeProperty: objectTypeProperty,
		    ObjectTypeSpreadProperty: objectTypeSpreadProperty,
		    OpaqueType: opaqueType,
		    OptionalCallExpression: optionalCallExpression$2,
		    OptionalIndexedAccessType: optionalIndexedAccessType,
		    OptionalMemberExpression: optionalMemberExpression$2,
		    PATTERNLIKE_TYPES: PATTERNLIKE_TYPES,
		    PATTERN_TYPES: PATTERN_TYPES,
		    PLACEHOLDERS: PLACEHOLDERS,
		    PLACEHOLDERS_ALIAS: PLACEHOLDERS_ALIAS,
		    PLACEHOLDERS_FLIPPED_ALIAS: PLACEHOLDERS_FLIPPED_ALIAS,
		    PRIVATE_TYPES: PRIVATE_TYPES,
		    PROPERTY_TYPES: PROPERTY_TYPES,
		    PUREISH_TYPES: PUREISH_TYPES,
		    ParenthesizedExpression: parenthesizedExpression,
		    PipelineBareFunction: pipelineBareFunction,
		    PipelinePrimaryTopicReference: pipelinePrimaryTopicReference,
		    PipelineTopicExpression: pipelineTopicExpression,
		    Placeholder: placeholder,
		    PrivateName: privateName,
		    Program: program$3,
		    QualifiedTypeIdentifier: qualifiedTypeIdentifier,
		    RecordExpression: recordExpression,
		    RegExpLiteral: regExpLiteral,
		    RegexLiteral: RegexLiteral,
		    RestElement: restElement$2,
		    RestProperty: RestProperty,
		    ReturnStatement: returnStatement$3,
		    SCOPABLE_TYPES: SCOPABLE_TYPES,
		    STANDARDIZED_TYPES: STANDARDIZED_TYPES,
		    STATEMENT_OR_BLOCK_KEYS: STATEMENT_OR_BLOCK_KEYS$1,
		    STATEMENT_TYPES: STATEMENT_TYPES,
		    STRING_UNARY_OPERATORS: STRING_UNARY_OPERATORS$1,
		    SequenceExpression: sequenceExpression$8,
		    SpreadElement: spreadElement$2,
		    SpreadProperty: SpreadProperty,
		    StaticBlock: staticBlock,
		    StringLiteral: stringLiteral$8,
		    StringLiteralTypeAnnotation: stringLiteralTypeAnnotation,
		    StringTypeAnnotation: stringTypeAnnotation$2,
		    Super: _super$1,
		    SwitchCase: switchCase,
		    SwitchStatement: switchStatement,
		    SymbolTypeAnnotation: symbolTypeAnnotation,
		    TERMINATORLESS_TYPES: TERMINATORLESS_TYPES,
		    TSAnyKeyword: tsAnyKeyword,
		    TSArrayType: tsArrayType,
		    TSAsExpression: tsAsExpression,
		    TSBASETYPE_TYPES: TSBASETYPE_TYPES,
		    TSBigIntKeyword: tsBigIntKeyword,
		    TSBooleanKeyword: tsBooleanKeyword,
		    TSCallSignatureDeclaration: tsCallSignatureDeclaration,
		    TSConditionalType: tsConditionalType,
		    TSConstructSignatureDeclaration: tsConstructSignatureDeclaration,
		    TSConstructorType: tsConstructorType,
		    TSDeclareFunction: tsDeclareFunction,
		    TSDeclareMethod: tsDeclareMethod,
		    TSENTITYNAME_TYPES: TSENTITYNAME_TYPES,
		    TSEnumDeclaration: tsEnumDeclaration,
		    TSEnumMember: tsEnumMember,
		    TSExportAssignment: tsExportAssignment,
		    TSExpressionWithTypeArguments: tsExpressionWithTypeArguments,
		    TSExternalModuleReference: tsExternalModuleReference,
		    TSFunctionType: tsFunctionType,
		    TSImportEqualsDeclaration: tsImportEqualsDeclaration,
		    TSImportType: tsImportType,
		    TSIndexSignature: tsIndexSignature,
		    TSIndexedAccessType: tsIndexedAccessType,
		    TSInferType: tsInferType,
		    TSInstantiationExpression: tsInstantiationExpression,
		    TSInterfaceBody: tsInterfaceBody,
		    TSInterfaceDeclaration: tsInterfaceDeclaration,
		    TSIntersectionType: tsIntersectionType,
		    TSIntrinsicKeyword: tsIntrinsicKeyword,
		    TSLiteralType: tsLiteralType,
		    TSMappedType: tsMappedType,
		    TSMethodSignature: tsMethodSignature,
		    TSModuleBlock: tsModuleBlock,
		    TSModuleDeclaration: tsModuleDeclaration,
		    TSNamedTupleMember: tsNamedTupleMember,
		    TSNamespaceExportDeclaration: tsNamespaceExportDeclaration,
		    TSNeverKeyword: tsNeverKeyword,
		    TSNonNullExpression: tsNonNullExpression,
		    TSNullKeyword: tsNullKeyword,
		    TSNumberKeyword: tsNumberKeyword,
		    TSObjectKeyword: tsObjectKeyword,
		    TSOptionalType: tsOptionalType,
		    TSParameterProperty: tsParameterProperty,
		    TSParenthesizedType: tsParenthesizedType,
		    TSPropertySignature: tsPropertySignature,
		    TSQualifiedName: tsQualifiedName,
		    TSRestType: tsRestType,
		    TSSatisfiesExpression: tsSatisfiesExpression,
		    TSStringKeyword: tsStringKeyword,
		    TSSymbolKeyword: tsSymbolKeyword,
		    TSTYPEELEMENT_TYPES: TSTYPEELEMENT_TYPES,
		    TSTYPE_TYPES: TSTYPE_TYPES,
		    TSThisType: tsThisType,
		    TSTupleType: tsTupleType,
		    TSTypeAliasDeclaration: tsTypeAliasDeclaration,
		    TSTypeAnnotation: tsTypeAnnotation,
		    TSTypeAssertion: tsTypeAssertion,
		    TSTypeLiteral: tsTypeLiteral,
		    TSTypeOperator: tsTypeOperator,
		    TSTypeParameter: tsTypeParameter,
		    TSTypeParameterDeclaration: tsTypeParameterDeclaration,
		    TSTypeParameterInstantiation: tsTypeParameterInstantiation,
		    TSTypePredicate: tsTypePredicate,
		    TSTypeQuery: tsTypeQuery,
		    TSTypeReference: tsTypeReference,
		    TSUndefinedKeyword: tsUndefinedKeyword,
		    TSUnionType: tsUnionType,
		    TSUnknownKeyword: tsUnknownKeyword,
		    TSVoidKeyword: tsVoidKeyword,
		    TYPES: TYPES$1,
		    TYPESCRIPT_TYPES: TYPESCRIPT_TYPES,
		    TaggedTemplateExpression: taggedTemplateExpression,
		    TemplateElement: templateElement,
		    TemplateLiteral: templateLiteral,
		    ThisExpression: thisExpression$4,
		    ThisTypeAnnotation: thisTypeAnnotation,
		    ThrowStatement: throwStatement,
		    TopicReference: topicReference,
		    TryStatement: tryStatement,
		    TupleExpression: tupleExpression,
		    TupleTypeAnnotation: tupleTypeAnnotation$1,
		    TypeAlias: typeAlias,
		    TypeAnnotation: typeAnnotation,
		    TypeCastExpression: typeCastExpression,
		    TypeParameter: typeParameter,
		    TypeParameterDeclaration: typeParameterDeclaration,
		    TypeParameterInstantiation: typeParameterInstantiation,
		    TypeofTypeAnnotation: typeofTypeAnnotation,
		    UNARYLIKE_TYPES: UNARYLIKE_TYPES,
		    UNARY_OPERATORS: UNARY_OPERATORS,
		    UPDATE_OPERATORS: UPDATE_OPERATORS,
		    USERWHITESPACABLE_TYPES: USERWHITESPACABLE_TYPES,
		    UnaryExpression: unaryExpression$6,
		    UnionTypeAnnotation: unionTypeAnnotation$1,
		    UpdateExpression: updateExpression$1,
		    V8IntrinsicIdentifier: v8IntrinsicIdentifier,
		    VISITOR_KEYS: VISITOR_KEYS$5,
		    VariableDeclaration: variableDeclaration$8,
		    VariableDeclarator: variableDeclarator$8,
		    Variance: variance,
		    VoidTypeAnnotation: voidTypeAnnotation$3,
		    WHILE_TYPES: WHILE_TYPES,
		    WhileStatement: whileStatement,
		    WithStatement: withStatement,
		    YieldExpression: yieldExpression$2,
		    __internal__deprecationWarning: deprecationWarning$1,
		    addComment: addComment$2,
		    addComments: addComments$1,
		    anyTypeAnnotation: anyTypeAnnotation$2,
		    appendToMemberExpression: appendToMemberExpression,
		    argumentPlaceholder: argumentPlaceholder,
		    arrayExpression: arrayExpression$1,
		    arrayPattern: arrayPattern,
		    arrayTypeAnnotation: arrayTypeAnnotation$1,
		    arrowFunctionExpression: arrowFunctionExpression$4,
		    assertAccessor: assertAccessor,
		    assertAnyTypeAnnotation: assertAnyTypeAnnotation,
		    assertArgumentPlaceholder: assertArgumentPlaceholder,
		    assertArrayExpression: assertArrayExpression,
		    assertArrayPattern: assertArrayPattern,
		    assertArrayTypeAnnotation: assertArrayTypeAnnotation,
		    assertArrowFunctionExpression: assertArrowFunctionExpression,
		    assertAssignmentExpression: assertAssignmentExpression,
		    assertAssignmentPattern: assertAssignmentPattern,
		    assertAwaitExpression: assertAwaitExpression,
		    assertBigIntLiteral: assertBigIntLiteral,
		    assertBinary: assertBinary,
		    assertBinaryExpression: assertBinaryExpression,
		    assertBindExpression: assertBindExpression,
		    assertBlock: assertBlock,
		    assertBlockParent: assertBlockParent,
		    assertBlockStatement: assertBlockStatement,
		    assertBooleanLiteral: assertBooleanLiteral,
		    assertBooleanLiteralTypeAnnotation: assertBooleanLiteralTypeAnnotation,
		    assertBooleanTypeAnnotation: assertBooleanTypeAnnotation,
		    assertBreakStatement: assertBreakStatement,
		    assertCallExpression: assertCallExpression,
		    assertCatchClause: assertCatchClause,
		    assertClass: assertClass,
		    assertClassAccessorProperty: assertClassAccessorProperty,
		    assertClassBody: assertClassBody,
		    assertClassDeclaration: assertClassDeclaration,
		    assertClassExpression: assertClassExpression,
		    assertClassImplements: assertClassImplements,
		    assertClassMethod: assertClassMethod,
		    assertClassPrivateMethod: assertClassPrivateMethod,
		    assertClassPrivateProperty: assertClassPrivateProperty,
		    assertClassProperty: assertClassProperty,
		    assertCompletionStatement: assertCompletionStatement,
		    assertConditional: assertConditional,
		    assertConditionalExpression: assertConditionalExpression,
		    assertContinueStatement: assertContinueStatement,
		    assertDebuggerStatement: assertDebuggerStatement,
		    assertDecimalLiteral: assertDecimalLiteral,
		    assertDeclaration: assertDeclaration,
		    assertDeclareClass: assertDeclareClass,
		    assertDeclareExportAllDeclaration: assertDeclareExportAllDeclaration,
		    assertDeclareExportDeclaration: assertDeclareExportDeclaration,
		    assertDeclareFunction: assertDeclareFunction,
		    assertDeclareInterface: assertDeclareInterface,
		    assertDeclareModule: assertDeclareModule,
		    assertDeclareModuleExports: assertDeclareModuleExports,
		    assertDeclareOpaqueType: assertDeclareOpaqueType,
		    assertDeclareTypeAlias: assertDeclareTypeAlias,
		    assertDeclareVariable: assertDeclareVariable,
		    assertDeclaredPredicate: assertDeclaredPredicate,
		    assertDecorator: assertDecorator,
		    assertDirective: assertDirective,
		    assertDirectiveLiteral: assertDirectiveLiteral,
		    assertDoExpression: assertDoExpression,
		    assertDoWhileStatement: assertDoWhileStatement,
		    assertEmptyStatement: assertEmptyStatement,
		    assertEmptyTypeAnnotation: assertEmptyTypeAnnotation,
		    assertEnumBody: assertEnumBody,
		    assertEnumBooleanBody: assertEnumBooleanBody,
		    assertEnumBooleanMember: assertEnumBooleanMember,
		    assertEnumDeclaration: assertEnumDeclaration,
		    assertEnumDefaultedMember: assertEnumDefaultedMember,
		    assertEnumMember: assertEnumMember,
		    assertEnumNumberBody: assertEnumNumberBody,
		    assertEnumNumberMember: assertEnumNumberMember,
		    assertEnumStringBody: assertEnumStringBody,
		    assertEnumStringMember: assertEnumStringMember,
		    assertEnumSymbolBody: assertEnumSymbolBody,
		    assertExistsTypeAnnotation: assertExistsTypeAnnotation,
		    assertExportAllDeclaration: assertExportAllDeclaration,
		    assertExportDeclaration: assertExportDeclaration,
		    assertExportDefaultDeclaration: assertExportDefaultDeclaration,
		    assertExportDefaultSpecifier: assertExportDefaultSpecifier,
		    assertExportNamedDeclaration: assertExportNamedDeclaration,
		    assertExportNamespaceSpecifier: assertExportNamespaceSpecifier,
		    assertExportSpecifier: assertExportSpecifier$1,
		    assertExpression: assertExpression$1,
		    assertExpressionStatement: assertExpressionStatement$1,
		    assertExpressionWrapper: assertExpressionWrapper,
		    assertFile: assertFile,
		    assertFlow: assertFlow,
		    assertFlowBaseAnnotation: assertFlowBaseAnnotation,
		    assertFlowDeclaration: assertFlowDeclaration,
		    assertFlowPredicate: assertFlowPredicate,
		    assertFlowType: assertFlowType,
		    assertFor: assertFor,
		    assertForInStatement: assertForInStatement,
		    assertForOfStatement: assertForOfStatement,
		    assertForStatement: assertForStatement,
		    assertForXStatement: assertForXStatement,
		    assertFunction: assertFunction$1,
		    assertFunctionDeclaration: assertFunctionDeclaration,
		    assertFunctionExpression: assertFunctionExpression,
		    assertFunctionParent: assertFunctionParent,
		    assertFunctionTypeAnnotation: assertFunctionTypeAnnotation,
		    assertFunctionTypeParam: assertFunctionTypeParam,
		    assertGenericTypeAnnotation: assertGenericTypeAnnotation,
		    assertIdentifier: assertIdentifier,
		    assertIfStatement: assertIfStatement,
		    assertImmutable: assertImmutable,
		    assertImport: assertImport,
		    assertImportAttribute: assertImportAttribute,
		    assertImportDeclaration: assertImportDeclaration,
		    assertImportDefaultSpecifier: assertImportDefaultSpecifier,
		    assertImportExpression: assertImportExpression,
		    assertImportNamespaceSpecifier: assertImportNamespaceSpecifier,
		    assertImportOrExportDeclaration: assertImportOrExportDeclaration,
		    assertImportSpecifier: assertImportSpecifier,
		    assertIndexedAccessType: assertIndexedAccessType,
		    assertInferredPredicate: assertInferredPredicate,
		    assertInterfaceDeclaration: assertInterfaceDeclaration,
		    assertInterfaceExtends: assertInterfaceExtends,
		    assertInterfaceTypeAnnotation: assertInterfaceTypeAnnotation,
		    assertInterpreterDirective: assertInterpreterDirective,
		    assertIntersectionTypeAnnotation: assertIntersectionTypeAnnotation,
		    assertJSX: assertJSX,
		    assertJSXAttribute: assertJSXAttribute,
		    assertJSXClosingElement: assertJSXClosingElement,
		    assertJSXClosingFragment: assertJSXClosingFragment,
		    assertJSXElement: assertJSXElement,
		    assertJSXEmptyExpression: assertJSXEmptyExpression,
		    assertJSXExpressionContainer: assertJSXExpressionContainer,
		    assertJSXFragment: assertJSXFragment,
		    assertJSXIdentifier: assertJSXIdentifier,
		    assertJSXMemberExpression: assertJSXMemberExpression,
		    assertJSXNamespacedName: assertJSXNamespacedName,
		    assertJSXOpeningElement: assertJSXOpeningElement,
		    assertJSXOpeningFragment: assertJSXOpeningFragment,
		    assertJSXSpreadAttribute: assertJSXSpreadAttribute,
		    assertJSXSpreadChild: assertJSXSpreadChild,
		    assertJSXText: assertJSXText,
		    assertLVal: assertLVal,
		    assertLabeledStatement: assertLabeledStatement,
		    assertLiteral: assertLiteral,
		    assertLogicalExpression: assertLogicalExpression,
		    assertLoop: assertLoop,
		    assertMemberExpression: assertMemberExpression,
		    assertMetaProperty: assertMetaProperty,
		    assertMethod: assertMethod,
		    assertMiscellaneous: assertMiscellaneous,
		    assertMixedTypeAnnotation: assertMixedTypeAnnotation,
		    assertModuleDeclaration: assertModuleDeclaration,
		    assertModuleExpression: assertModuleExpression,
		    assertModuleSpecifier: assertModuleSpecifier,
		    assertNewExpression: assertNewExpression,
		    assertNode: assertNode,
		    assertNoop: assertNoop,
		    assertNullLiteral: assertNullLiteral,
		    assertNullLiteralTypeAnnotation: assertNullLiteralTypeAnnotation,
		    assertNullableTypeAnnotation: assertNullableTypeAnnotation,
		    assertNumberLiteral: assertNumberLiteral,
		    assertNumberLiteralTypeAnnotation: assertNumberLiteralTypeAnnotation,
		    assertNumberTypeAnnotation: assertNumberTypeAnnotation,
		    assertNumericLiteral: assertNumericLiteral,
		    assertObjectExpression: assertObjectExpression,
		    assertObjectMember: assertObjectMember,
		    assertObjectMethod: assertObjectMethod,
		    assertObjectPattern: assertObjectPattern,
		    assertObjectProperty: assertObjectProperty,
		    assertObjectTypeAnnotation: assertObjectTypeAnnotation,
		    assertObjectTypeCallProperty: assertObjectTypeCallProperty,
		    assertObjectTypeIndexer: assertObjectTypeIndexer,
		    assertObjectTypeInternalSlot: assertObjectTypeInternalSlot,
		    assertObjectTypeProperty: assertObjectTypeProperty,
		    assertObjectTypeSpreadProperty: assertObjectTypeSpreadProperty,
		    assertOpaqueType: assertOpaqueType,
		    assertOptionalCallExpression: assertOptionalCallExpression,
		    assertOptionalIndexedAccessType: assertOptionalIndexedAccessType,
		    assertOptionalMemberExpression: assertOptionalMemberExpression,
		    assertParenthesizedExpression: assertParenthesizedExpression,
		    assertPattern: assertPattern,
		    assertPatternLike: assertPatternLike,
		    assertPipelineBareFunction: assertPipelineBareFunction,
		    assertPipelinePrimaryTopicReference: assertPipelinePrimaryTopicReference,
		    assertPipelineTopicExpression: assertPipelineTopicExpression,
		    assertPlaceholder: assertPlaceholder,
		    assertPrivate: assertPrivate,
		    assertPrivateName: assertPrivateName,
		    assertProgram: assertProgram,
		    assertProperty: assertProperty,
		    assertPureish: assertPureish,
		    assertQualifiedTypeIdentifier: assertQualifiedTypeIdentifier,
		    assertRecordExpression: assertRecordExpression,
		    assertRegExpLiteral: assertRegExpLiteral,
		    assertRegexLiteral: assertRegexLiteral,
		    assertRestElement: assertRestElement,
		    assertRestProperty: assertRestProperty,
		    assertReturnStatement: assertReturnStatement,
		    assertScopable: assertScopable,
		    assertSequenceExpression: assertSequenceExpression,
		    assertSpreadElement: assertSpreadElement,
		    assertSpreadProperty: assertSpreadProperty,
		    assertStandardized: assertStandardized,
		    assertStatement: assertStatement,
		    assertStaticBlock: assertStaticBlock,
		    assertStringLiteral: assertStringLiteral,
		    assertStringLiteralTypeAnnotation: assertStringLiteralTypeAnnotation,
		    assertStringTypeAnnotation: assertStringTypeAnnotation,
		    assertSuper: assertSuper,
		    assertSwitchCase: assertSwitchCase,
		    assertSwitchStatement: assertSwitchStatement,
		    assertSymbolTypeAnnotation: assertSymbolTypeAnnotation,
		    assertTSAnyKeyword: assertTSAnyKeyword,
		    assertTSArrayType: assertTSArrayType,
		    assertTSAsExpression: assertTSAsExpression,
		    assertTSBaseType: assertTSBaseType,
		    assertTSBigIntKeyword: assertTSBigIntKeyword,
		    assertTSBooleanKeyword: assertTSBooleanKeyword,
		    assertTSCallSignatureDeclaration: assertTSCallSignatureDeclaration,
		    assertTSConditionalType: assertTSConditionalType,
		    assertTSConstructSignatureDeclaration: assertTSConstructSignatureDeclaration,
		    assertTSConstructorType: assertTSConstructorType,
		    assertTSDeclareFunction: assertTSDeclareFunction,
		    assertTSDeclareMethod: assertTSDeclareMethod,
		    assertTSEntityName: assertTSEntityName,
		    assertTSEnumDeclaration: assertTSEnumDeclaration,
		    assertTSEnumMember: assertTSEnumMember,
		    assertTSExportAssignment: assertTSExportAssignment,
		    assertTSExpressionWithTypeArguments: assertTSExpressionWithTypeArguments,
		    assertTSExternalModuleReference: assertTSExternalModuleReference,
		    assertTSFunctionType: assertTSFunctionType,
		    assertTSImportEqualsDeclaration: assertTSImportEqualsDeclaration,
		    assertTSImportType: assertTSImportType,
		    assertTSIndexSignature: assertTSIndexSignature,
		    assertTSIndexedAccessType: assertTSIndexedAccessType,
		    assertTSInferType: assertTSInferType,
		    assertTSInstantiationExpression: assertTSInstantiationExpression,
		    assertTSInterfaceBody: assertTSInterfaceBody,
		    assertTSInterfaceDeclaration: assertTSInterfaceDeclaration,
		    assertTSIntersectionType: assertTSIntersectionType,
		    assertTSIntrinsicKeyword: assertTSIntrinsicKeyword,
		    assertTSLiteralType: assertTSLiteralType,
		    assertTSMappedType: assertTSMappedType,
		    assertTSMethodSignature: assertTSMethodSignature,
		    assertTSModuleBlock: assertTSModuleBlock,
		    assertTSModuleDeclaration: assertTSModuleDeclaration,
		    assertTSNamedTupleMember: assertTSNamedTupleMember,
		    assertTSNamespaceExportDeclaration: assertTSNamespaceExportDeclaration,
		    assertTSNeverKeyword: assertTSNeverKeyword,
		    assertTSNonNullExpression: assertTSNonNullExpression,
		    assertTSNullKeyword: assertTSNullKeyword,
		    assertTSNumberKeyword: assertTSNumberKeyword,
		    assertTSObjectKeyword: assertTSObjectKeyword,
		    assertTSOptionalType: assertTSOptionalType,
		    assertTSParameterProperty: assertTSParameterProperty,
		    assertTSParenthesizedType: assertTSParenthesizedType,
		    assertTSPropertySignature: assertTSPropertySignature,
		    assertTSQualifiedName: assertTSQualifiedName,
		    assertTSRestType: assertTSRestType,
		    assertTSSatisfiesExpression: assertTSSatisfiesExpression,
		    assertTSStringKeyword: assertTSStringKeyword,
		    assertTSSymbolKeyword: assertTSSymbolKeyword,
		    assertTSThisType: assertTSThisType,
		    assertTSTupleType: assertTSTupleType,
		    assertTSType: assertTSType,
		    assertTSTypeAliasDeclaration: assertTSTypeAliasDeclaration,
		    assertTSTypeAnnotation: assertTSTypeAnnotation,
		    assertTSTypeAssertion: assertTSTypeAssertion,
		    assertTSTypeElement: assertTSTypeElement,
		    assertTSTypeLiteral: assertTSTypeLiteral,
		    assertTSTypeOperator: assertTSTypeOperator,
		    assertTSTypeParameter: assertTSTypeParameter,
		    assertTSTypeParameterDeclaration: assertTSTypeParameterDeclaration,
		    assertTSTypeParameterInstantiation: assertTSTypeParameterInstantiation,
		    assertTSTypePredicate: assertTSTypePredicate,
		    assertTSTypeQuery: assertTSTypeQuery,
		    assertTSTypeReference: assertTSTypeReference,
		    assertTSUndefinedKeyword: assertTSUndefinedKeyword,
		    assertTSUnionType: assertTSUnionType,
		    assertTSUnknownKeyword: assertTSUnknownKeyword,
		    assertTSVoidKeyword: assertTSVoidKeyword,
		    assertTaggedTemplateExpression: assertTaggedTemplateExpression,
		    assertTemplateElement: assertTemplateElement,
		    assertTemplateLiteral: assertTemplateLiteral,
		    assertTerminatorless: assertTerminatorless,
		    assertThisExpression: assertThisExpression,
		    assertThisTypeAnnotation: assertThisTypeAnnotation,
		    assertThrowStatement: assertThrowStatement,
		    assertTopicReference: assertTopicReference,
		    assertTryStatement: assertTryStatement,
		    assertTupleExpression: assertTupleExpression,
		    assertTupleTypeAnnotation: assertTupleTypeAnnotation,
		    assertTypeAlias: assertTypeAlias,
		    assertTypeAnnotation: assertTypeAnnotation,
		    assertTypeCastExpression: assertTypeCastExpression,
		    assertTypeParameter: assertTypeParameter,
		    assertTypeParameterDeclaration: assertTypeParameterDeclaration,
		    assertTypeParameterInstantiation: assertTypeParameterInstantiation,
		    assertTypeScript: assertTypeScript,
		    assertTypeofTypeAnnotation: assertTypeofTypeAnnotation,
		    assertUnaryExpression: assertUnaryExpression,
		    assertUnaryLike: assertUnaryLike,
		    assertUnionTypeAnnotation: assertUnionTypeAnnotation,
		    assertUpdateExpression: assertUpdateExpression,
		    assertUserWhitespacable: assertUserWhitespacable,
		    assertV8IntrinsicIdentifier: assertV8IntrinsicIdentifier,
		    assertVariableDeclaration: assertVariableDeclaration,
		    assertVariableDeclarator: assertVariableDeclarator,
		    assertVariance: assertVariance,
		    assertVoidTypeAnnotation: assertVoidTypeAnnotation,
		    assertWhile: assertWhile,
		    assertWhileStatement: assertWhileStatement,
		    assertWithStatement: assertWithStatement,
		    assertYieldExpression: assertYieldExpression,
		    assignmentExpression: assignmentExpression$d,
		    assignmentPattern: assignmentPattern,
		    awaitExpression: awaitExpression$1,
		    bigIntLiteral: bigIntLiteral,
		    binaryExpression: binaryExpression$5,
		    bindExpression: bindExpression,
		    blockStatement: blockStatement$6,
		    booleanLiteral: booleanLiteral$4,
		    booleanLiteralTypeAnnotation: booleanLiteralTypeAnnotation,
		    booleanTypeAnnotation: booleanTypeAnnotation$1,
		    breakStatement: breakStatement,
		    buildMatchMemberExpression: buildMatchMemberExpression$1,
		    buildUndefinedNode: buildUndefinedNode$2,
		    callExpression: callExpression$d,
		    catchClause: catchClause,
		    classAccessorProperty: classAccessorProperty,
		    classBody: classBody,
		    classDeclaration: classDeclaration,
		    classExpression: classExpression,
		    classImplements: classImplements,
		    classMethod: classMethod,
		    classPrivateMethod: classPrivateMethod,
		    classPrivateProperty: classPrivateProperty,
		    classProperty: classProperty,
		    clone: clone,
		    cloneDeep: cloneDeep$1,
		    cloneDeepWithoutLoc: cloneDeepWithoutLoc,
		    cloneNode: cloneNode$j,
		    cloneWithoutLoc: cloneWithoutLoc,
		    conditionalExpression: conditionalExpression$5,
		    continueStatement: continueStatement,
		    createFlowUnionType: createFlowUnionType$1,
		    createTSUnionType: createTSUnionType$1,
		    createTypeAnnotationBasedOnTypeof: createTypeAnnotationBasedOnTypeof$1,
		    createUnionTypeAnnotation: createFlowUnionType$1,
		    debuggerStatement: debuggerStatement,
		    decimalLiteral: decimalLiteral,
		    declareClass: declareClass,
		    declareExportAllDeclaration: declareExportAllDeclaration,
		    declareExportDeclaration: declareExportDeclaration,
		    declareFunction: declareFunction,
		    declareInterface: declareInterface,
		    declareModule: declareModule,
		    declareModuleExports: declareModuleExports,
		    declareOpaqueType: declareOpaqueType,
		    declareTypeAlias: declareTypeAlias,
		    declareVariable: declareVariable,
		    declaredPredicate: declaredPredicate,
		    decorator: decorator,
		    directive: directive$1,
		    directiveLiteral: directiveLiteral$1,
		    doExpression: doExpression,
		    doWhileStatement: doWhileStatement,
		    emptyStatement: emptyStatement$1,
		    emptyTypeAnnotation: emptyTypeAnnotation,
		    ensureBlock: ensureBlock$1,
		    enumBooleanBody: enumBooleanBody,
		    enumBooleanMember: enumBooleanMember,
		    enumDeclaration: enumDeclaration,
		    enumDefaultedMember: enumDefaultedMember,
		    enumNumberBody: enumNumberBody,
		    enumNumberMember: enumNumberMember,
		    enumStringBody: enumStringBody,
		    enumStringMember: enumStringMember,
		    enumSymbolBody: enumSymbolBody,
		    existsTypeAnnotation: existsTypeAnnotation,
		    exportAllDeclaration: exportAllDeclaration,
		    exportDefaultDeclaration: exportDefaultDeclaration,
		    exportDefaultSpecifier: exportDefaultSpecifier,
		    exportNamedDeclaration: exportNamedDeclaration$2,
		    exportNamespaceSpecifier: exportNamespaceSpecifier,
		    exportSpecifier: exportSpecifier$2,
		    expressionStatement: expressionStatement$a,
		    file: file$2,
		    forInStatement: forInStatement,
		    forOfStatement: forOfStatement,
		    forStatement: forStatement,
		    functionDeclaration: functionDeclaration,
		    functionExpression: functionExpression$2,
		    functionTypeAnnotation: functionTypeAnnotation,
		    functionTypeParam: functionTypeParam,
		    genericTypeAnnotation: genericTypeAnnotation$1,
		    getBindingIdentifiers: getBindingIdentifiers$4,
		    getOuterBindingIdentifiers: getOuterBindingIdentifiers$2,
		    identifier: identifier$j,
		    ifStatement: ifStatement,
		    import: _import,
		    importAttribute: importAttribute,
		    importDeclaration: importDeclaration$1,
		    importDefaultSpecifier: importDefaultSpecifier$1,
		    importExpression: importExpression,
		    importNamespaceSpecifier: importNamespaceSpecifier$1,
		    importSpecifier: importSpecifier$2,
		    indexedAccessType: indexedAccessType,
		    inferredPredicate: inferredPredicate,
		    inheritInnerComments: inheritInnerComments,
		    inheritLeadingComments: inheritLeadingComments$1,
		    inheritTrailingComments: inheritTrailingComments$1,
		    inherits: inherits$3,
		    inheritsComments: inheritsComments$1,
		    interfaceDeclaration: interfaceDeclaration,
		    interfaceExtends: interfaceExtends,
		    interfaceTypeAnnotation: interfaceTypeAnnotation,
		    interpreterDirective: interpreterDirective$1,
		    intersectionTypeAnnotation: intersectionTypeAnnotation,
		    is: is$1,
		    isAccessor: isAccessor,
		    isAnyTypeAnnotation: isAnyTypeAnnotation$1,
		    isArgumentPlaceholder: isArgumentPlaceholder,
		    isArrayExpression: isArrayExpression$2,
		    isArrayPattern: isArrayPattern,
		    isArrayTypeAnnotation: isArrayTypeAnnotation$2,
		    isArrowFunctionExpression: isArrowFunctionExpression$2,
		    isAssignmentExpression: isAssignmentExpression$3,
		    isAssignmentPattern: isAssignmentPattern$4,
		    isAwaitExpression: isAwaitExpression,
		    isBigIntLiteral: isBigIntLiteral,
		    isBinary: isBinary$2,
		    isBinaryExpression: isBinaryExpression$1,
		    isBindExpression: isBindExpression,
		    isBinding: isBinding$1,
		    isBlock: isBlock,
		    isBlockParent: isBlockParent,
		    isBlockScoped: isBlockScoped$2,
		    isBlockStatement: isBlockStatement$3,
		    isBooleanLiteral: isBooleanLiteral,
		    isBooleanLiteralTypeAnnotation: isBooleanLiteralTypeAnnotation,
		    isBooleanTypeAnnotation: isBooleanTypeAnnotation$1,
		    isBreakStatement: isBreakStatement,
		    isCallExpression: isCallExpression$8,
		    isCatchClause: isCatchClause,
		    isClass: isClass$1,
		    isClassAccessorProperty: isClassAccessorProperty,
		    isClassBody: isClassBody$2,
		    isClassDeclaration: isClassDeclaration$2,
		    isClassExpression: isClassExpression$1,
		    isClassImplements: isClassImplements,
		    isClassMethod: isClassMethod,
		    isClassPrivateMethod: isClassPrivateMethod,
		    isClassPrivateProperty: isClassPrivateProperty,
		    isClassProperty: isClassProperty,
		    isCompletionStatement: isCompletionStatement,
		    isConditional: isConditional,
		    isConditionalExpression: isConditionalExpression,
		    isContinueStatement: isContinueStatement,
		    isDebuggerStatement: isDebuggerStatement,
		    isDecimalLiteral: isDecimalLiteral,
		    isDeclaration: isDeclaration,
		    isDeclareClass: isDeclareClass,
		    isDeclareExportAllDeclaration: isDeclareExportAllDeclaration,
		    isDeclareExportDeclaration: isDeclareExportDeclaration$1,
		    isDeclareFunction: isDeclareFunction,
		    isDeclareInterface: isDeclareInterface,
		    isDeclareModule: isDeclareModule,
		    isDeclareModuleExports: isDeclareModuleExports,
		    isDeclareOpaqueType: isDeclareOpaqueType,
		    isDeclareTypeAlias: isDeclareTypeAlias,
		    isDeclareVariable: isDeclareVariable,
		    isDeclaredPredicate: isDeclaredPredicate,
		    isDecorator: isDecorator,
		    isDirective: isDirective,
		    isDirectiveLiteral: isDirectiveLiteral,
		    isDoExpression: isDoExpression,
		    isDoWhileStatement: isDoWhileStatement,
		    isEmptyStatement: isEmptyStatement$1,
		    isEmptyTypeAnnotation: isEmptyTypeAnnotation$1,
		    isEnumBody: isEnumBody,
		    isEnumBooleanBody: isEnumBooleanBody,
		    isEnumBooleanMember: isEnumBooleanMember,
		    isEnumDeclaration: isEnumDeclaration,
		    isEnumDefaultedMember: isEnumDefaultedMember,
		    isEnumMember: isEnumMember,
		    isEnumNumberBody: isEnumNumberBody,
		    isEnumNumberMember: isEnumNumberMember,
		    isEnumStringBody: isEnumStringBody,
		    isEnumStringMember: isEnumStringMember,
		    isEnumSymbolBody: isEnumSymbolBody,
		    isExistsTypeAnnotation: isExistsTypeAnnotation,
		    isExportAllDeclaration: isExportAllDeclaration$1,
		    isExportDeclaration: isExportDeclaration$3,
		    isExportDefaultDeclaration: isExportDefaultDeclaration$2,
		    isExportDefaultSpecifier: isExportDefaultSpecifier$1,
		    isExportNamedDeclaration: isExportNamedDeclaration$3,
		    isExportNamespaceSpecifier: isExportNamespaceSpecifier$1,
		    isExportSpecifier: isExportSpecifier,
		    isExpression: isExpression$4,
		    isExpressionStatement: isExpressionStatement$2,
		    isExpressionWrapper: isExpressionWrapper,
		    isFile: isFile,
		    isFlow: isFlow$1,
		    isFlowBaseAnnotation: isFlowBaseAnnotation$1,
		    isFlowDeclaration: isFlowDeclaration,
		    isFlowPredicate: isFlowPredicate,
		    isFlowType: isFlowType$1,
		    isFor: isFor$1,
		    isForInStatement: isForInStatement,
		    isForOfStatement: isForOfStatement$2,
		    isForStatement: isForStatement$2,
		    isForXStatement: isForXStatement$1,
		    isFunction: isFunction$5,
		    isFunctionDeclaration: isFunctionDeclaration$2,
		    isFunctionExpression: isFunctionExpression$1,
		    isFunctionParent: isFunctionParent,
		    isFunctionTypeAnnotation: isFunctionTypeAnnotation,
		    isFunctionTypeParam: isFunctionTypeParam,
		    isGenericTypeAnnotation: isGenericTypeAnnotation$1,
		    isIdentifier: isIdentifier$i,
		    isIfStatement: isIfStatement$2,
		    isImmutable: isImmutable,
		    isImport: isImport,
		    isImportAttribute: isImportAttribute,
		    isImportDeclaration: isImportDeclaration$3,
		    isImportDefaultSpecifier: isImportDefaultSpecifier$1,
		    isImportExpression: isImportExpression,
		    isImportNamespaceSpecifier: isImportNamespaceSpecifier$1,
		    isImportOrExportDeclaration: isImportOrExportDeclaration,
		    isImportSpecifier: isImportSpecifier$1,
		    isIndexedAccessType: isIndexedAccessType$1,
		    isInferredPredicate: isInferredPredicate,
		    isInterfaceDeclaration: isInterfaceDeclaration,
		    isInterfaceExtends: isInterfaceExtends,
		    isInterfaceTypeAnnotation: isInterfaceTypeAnnotation,
		    isInterpreterDirective: isInterpreterDirective,
		    isIntersectionTypeAnnotation: isIntersectionTypeAnnotation,
		    isJSX: isJSX,
		    isJSXAttribute: isJSXAttribute,
		    isJSXClosingElement: isJSXClosingElement,
		    isJSXClosingFragment: isJSXClosingFragment,
		    isJSXElement: isJSXElement,
		    isJSXEmptyExpression: isJSXEmptyExpression,
		    isJSXExpressionContainer: isJSXExpressionContainer$1,
		    isJSXFragment: isJSXFragment,
		    isJSXIdentifier: isJSXIdentifier$3,
		    isJSXMemberExpression: isJSXMemberExpression$2,
		    isJSXNamespacedName: isJSXNamespacedName$1,
		    isJSXOpeningElement: isJSXOpeningElement,
		    isJSXOpeningFragment: isJSXOpeningFragment,
		    isJSXSpreadAttribute: isJSXSpreadAttribute$1,
		    isJSXSpreadChild: isJSXSpreadChild,
		    isJSXText: isJSXText,
		    isLVal: isLVal,
		    isLabeledStatement: isLabeledStatement,
		    isLet: isLet,
		    isLiteral: isLiteral$6,
		    isLogicalExpression: isLogicalExpression,
		    isLoop: isLoop$1,
		    isMemberExpression: isMemberExpression$9,
		    isMetaProperty: isMetaProperty$1,
		    isMethod: isMethod$1,
		    isMiscellaneous: isMiscellaneous,
		    isMixedTypeAnnotation: isMixedTypeAnnotation$1,
		    isModuleDeclaration: isModuleDeclaration,
		    isModuleExpression: isModuleExpression,
		    isModuleSpecifier: isModuleSpecifier$1,
		    isNewExpression: isNewExpression$3,
		    isNode: isNode,
		    isNodesEquivalent: isNodesEquivalent,
		    isNoop: isNoop,
		    isNullLiteral: isNullLiteral$2,
		    isNullLiteralTypeAnnotation: isNullLiteralTypeAnnotation,
		    isNullableTypeAnnotation: isNullableTypeAnnotation,
		    isNumberLiteral: isNumberLiteral,
		    isNumberLiteralTypeAnnotation: isNumberLiteralTypeAnnotation,
		    isNumberTypeAnnotation: isNumberTypeAnnotation$1,
		    isNumericLiteral: isNumericLiteral,
		    isObjectExpression: isObjectExpression$3,
		    isObjectMember: isObjectMember,
		    isObjectMethod: isObjectMethod$1,
		    isObjectPattern: isObjectPattern$1,
		    isObjectProperty: isObjectProperty$4,
		    isObjectTypeAnnotation: isObjectTypeAnnotation,
		    isObjectTypeCallProperty: isObjectTypeCallProperty,
		    isObjectTypeIndexer: isObjectTypeIndexer,
		    isObjectTypeInternalSlot: isObjectTypeInternalSlot,
		    isObjectTypeProperty: isObjectTypeProperty,
		    isObjectTypeSpreadProperty: isObjectTypeSpreadProperty,
		    isOpaqueType: isOpaqueType,
		    isOptionalCallExpression: isOptionalCallExpression$2,
		    isOptionalIndexedAccessType: isOptionalIndexedAccessType,
		    isOptionalMemberExpression: isOptionalMemberExpression$3,
		    isParenthesizedExpression: isParenthesizedExpression$1,
		    isPattern: isPattern,
		    isPatternLike: isPatternLike,
		    isPipelineBareFunction: isPipelineBareFunction,
		    isPipelinePrimaryTopicReference: isPipelinePrimaryTopicReference,
		    isPipelineTopicExpression: isPipelineTopicExpression,
		    isPlaceholder: isPlaceholder$1,
		    isPlaceholderType: isPlaceholderType,
		    isPrivate: isPrivate,
		    isPrivateName: isPrivateName$3,
		    isProgram: isProgram$1,
		    isProperty: isProperty$1,
		    isPureish: isPureish$2,
		    isQualifiedTypeIdentifier: isQualifiedTypeIdentifier,
		    isRecordExpression: isRecordExpression$1,
		    isReferenced: isReferenced$2,
		    isRegExpLiteral: isRegExpLiteral$2,
		    isRegexLiteral: isRegexLiteral,
		    isRestElement: isRestElement$2,
		    isRestProperty: isRestProperty$1,
		    isReturnStatement: isReturnStatement,
		    isScopable: isScopable,
		    isScope: isScope$1,
		    isSequenceExpression: isSequenceExpression$1,
		    isSpecifierDefault: isSpecifierDefault,
		    isSpreadElement: isSpreadElement$1,
		    isSpreadProperty: isSpreadProperty$1,
		    isStandardized: isStandardized,
		    isStatement: isStatement$8,
		    isStaticBlock: isStaticBlock,
		    isStringLiteral: isStringLiteral$5,
		    isStringLiteralTypeAnnotation: isStringLiteralTypeAnnotation,
		    isStringTypeAnnotation: isStringTypeAnnotation$1,
		    isSuper: isSuper$3,
		    isSwitchCase: isSwitchCase,
		    isSwitchStatement: isSwitchStatement,
		    isSymbolTypeAnnotation: isSymbolTypeAnnotation,
		    isTSAnyKeyword: isTSAnyKeyword,
		    isTSArrayType: isTSArrayType$1,
		    isTSAsExpression: isTSAsExpression$1,
		    isTSBaseType: isTSBaseType,
		    isTSBigIntKeyword: isTSBigIntKeyword,
		    isTSBooleanKeyword: isTSBooleanKeyword,
		    isTSCallSignatureDeclaration: isTSCallSignatureDeclaration,
		    isTSConditionalType: isTSConditionalType,
		    isTSConstructSignatureDeclaration: isTSConstructSignatureDeclaration,
		    isTSConstructorType: isTSConstructorType,
		    isTSDeclareFunction: isTSDeclareFunction,
		    isTSDeclareMethod: isTSDeclareMethod,
		    isTSEntityName: isTSEntityName,
		    isTSEnumDeclaration: isTSEnumDeclaration$1,
		    isTSEnumMember: isTSEnumMember,
		    isTSExportAssignment: isTSExportAssignment,
		    isTSExpressionWithTypeArguments: isTSExpressionWithTypeArguments,
		    isTSExternalModuleReference: isTSExternalModuleReference,
		    isTSFunctionType: isTSFunctionType,
		    isTSImportEqualsDeclaration: isTSImportEqualsDeclaration,
		    isTSImportType: isTSImportType,
		    isTSIndexSignature: isTSIndexSignature,
		    isTSIndexedAccessType: isTSIndexedAccessType,
		    isTSInferType: isTSInferType,
		    isTSInstantiationExpression: isTSInstantiationExpression,
		    isTSInterfaceBody: isTSInterfaceBody$1,
		    isTSInterfaceDeclaration: isTSInterfaceDeclaration,
		    isTSIntersectionType: isTSIntersectionType,
		    isTSIntrinsicKeyword: isTSIntrinsicKeyword,
		    isTSLiteralType: isTSLiteralType,
		    isTSMappedType: isTSMappedType,
		    isTSMethodSignature: isTSMethodSignature,
		    isTSModuleBlock: isTSModuleBlock,
		    isTSModuleDeclaration: isTSModuleDeclaration,
		    isTSNamedTupleMember: isTSNamedTupleMember,
		    isTSNamespaceExportDeclaration: isTSNamespaceExportDeclaration,
		    isTSNeverKeyword: isTSNeverKeyword,
		    isTSNonNullExpression: isTSNonNullExpression$1,
		    isTSNullKeyword: isTSNullKeyword,
		    isTSNumberKeyword: isTSNumberKeyword,
		    isTSObjectKeyword: isTSObjectKeyword,
		    isTSOptionalType: isTSOptionalType,
		    isTSParameterProperty: isTSParameterProperty,
		    isTSParenthesizedType: isTSParenthesizedType,
		    isTSPropertySignature: isTSPropertySignature,
		    isTSQualifiedName: isTSQualifiedName,
		    isTSRestType: isTSRestType,
		    isTSSatisfiesExpression: isTSSatisfiesExpression$1,
		    isTSStringKeyword: isTSStringKeyword,
		    isTSSymbolKeyword: isTSSymbolKeyword,
		    isTSThisType: isTSThisType,
		    isTSTupleType: isTSTupleType,
		    isTSType: isTSType$1,
		    isTSTypeAliasDeclaration: isTSTypeAliasDeclaration,
		    isTSTypeAnnotation: isTSTypeAnnotation$1,
		    isTSTypeAssertion: isTSTypeAssertion$1,
		    isTSTypeElement: isTSTypeElement,
		    isTSTypeLiteral: isTSTypeLiteral,
		    isTSTypeOperator: isTSTypeOperator,
		    isTSTypeParameter: isTSTypeParameter,
		    isTSTypeParameterDeclaration: isTSTypeParameterDeclaration,
		    isTSTypeParameterInstantiation: isTSTypeParameterInstantiation,
		    isTSTypePredicate: isTSTypePredicate,
		    isTSTypeQuery: isTSTypeQuery,
		    isTSTypeReference: isTSTypeReference$1,
		    isTSUndefinedKeyword: isTSUndefinedKeyword,
		    isTSUnionType: isTSUnionType,
		    isTSUnknownKeyword: isTSUnknownKeyword,
		    isTSVoidKeyword: isTSVoidKeyword,
		    isTaggedTemplateExpression: isTaggedTemplateExpression$1,
		    isTemplateElement: isTemplateElement,
		    isTemplateLiteral: isTemplateLiteral$2,
		    isTerminatorless: isTerminatorless,
		    isThisExpression: isThisExpression$2,
		    isThisTypeAnnotation: isThisTypeAnnotation,
		    isThrowStatement: isThrowStatement,
		    isTopicReference: isTopicReference$1,
		    isTryStatement: isTryStatement,
		    isTupleExpression: isTupleExpression$1,
		    isTupleTypeAnnotation: isTupleTypeAnnotation$1,
		    isType: isType$2,
		    isTypeAlias: isTypeAlias,
		    isTypeAnnotation: isTypeAnnotation$1,
		    isTypeCastExpression: isTypeCastExpression$1,
		    isTypeParameter: isTypeParameter,
		    isTypeParameterDeclaration: isTypeParameterDeclaration,
		    isTypeParameterInstantiation: isTypeParameterInstantiation,
		    isTypeScript: isTypeScript,
		    isTypeofTypeAnnotation: isTypeofTypeAnnotation,
		    isUnaryExpression: isUnaryExpression$1,
		    isUnaryLike: isUnaryLike,
		    isUnionTypeAnnotation: isUnionTypeAnnotation$1,
		    isUpdateExpression: isUpdateExpression$1,
		    isUserWhitespacable: isUserWhitespacable,
		    isV8IntrinsicIdentifier: isV8IntrinsicIdentifier,
		    isValidES3Identifier: isValidES3Identifier,
		    isValidIdentifier: isValidIdentifier$1,
		    isVar: isVar$1,
		    isVariableDeclaration: isVariableDeclaration$4,
		    isVariableDeclarator: isVariableDeclarator$1,
		    isVariance: isVariance,
		    isVoidTypeAnnotation: isVoidTypeAnnotation$1,
		    isWhile: isWhile,
		    isWhileStatement: isWhileStatement,
		    isWithStatement: isWithStatement,
		    isYieldExpression: isYieldExpression$1,
		    jSXAttribute: jsxAttribute,
		    jSXClosingElement: jsxClosingElement,
		    jSXClosingFragment: jsxClosingFragment,
		    jSXElement: jsxElement,
		    jSXEmptyExpression: jsxEmptyExpression,
		    jSXExpressionContainer: jsxExpressionContainer$1,
		    jSXFragment: jsxFragment,
		    jSXIdentifier: jsxIdentifier$2,
		    jSXMemberExpression: jsxMemberExpression$1,
		    jSXNamespacedName: jsxNamespacedName,
		    jSXOpeningElement: jsxOpeningElement,
		    jSXOpeningFragment: jsxOpeningFragment,
		    jSXSpreadAttribute: jsxSpreadAttribute,
		    jSXSpreadChild: jsxSpreadChild,
		    jSXText: jsxText,
		    jsxAttribute: jsxAttribute,
		    jsxClosingElement: jsxClosingElement,
		    jsxClosingFragment: jsxClosingFragment,
		    jsxElement: jsxElement,
		    jsxEmptyExpression: jsxEmptyExpression,
		    jsxExpressionContainer: jsxExpressionContainer$1,
		    jsxFragment: jsxFragment,
		    jsxIdentifier: jsxIdentifier$2,
		    jsxMemberExpression: jsxMemberExpression$1,
		    jsxNamespacedName: jsxNamespacedName,
		    jsxOpeningElement: jsxOpeningElement,
		    jsxOpeningFragment: jsxOpeningFragment,
		    jsxSpreadAttribute: jsxSpreadAttribute,
		    jsxSpreadChild: jsxSpreadChild,
		    jsxText: jsxText,
		    labeledStatement: labeledStatement,
		    logicalExpression: logicalExpression$3,
		    matchesPattern: matchesPattern$2,
		    memberExpression: memberExpression$c,
		    metaProperty: metaProperty$1,
		    mixedTypeAnnotation: mixedTypeAnnotation,
		    moduleExpression: moduleExpression,
		    newExpression: newExpression,
		    noop: noop$1,
		    nullLiteral: nullLiteral$2,
		    nullLiteralTypeAnnotation: nullLiteralTypeAnnotation$1,
		    nullableTypeAnnotation: nullableTypeAnnotation,
		    numberLiteral: NumberLiteral,
		    numberLiteralTypeAnnotation: numberLiteralTypeAnnotation,
		    numberTypeAnnotation: numberTypeAnnotation$2,
		    numericLiteral: numericLiteral$8,
		    objectExpression: objectExpression$3,
		    objectMethod: objectMethod,
		    objectPattern: objectPattern$1,
		    objectProperty: objectProperty$1,
		    objectTypeAnnotation: objectTypeAnnotation,
		    objectTypeCallProperty: objectTypeCallProperty,
		    objectTypeIndexer: objectTypeIndexer,
		    objectTypeInternalSlot: objectTypeInternalSlot,
		    objectTypeProperty: objectTypeProperty,
		    objectTypeSpreadProperty: objectTypeSpreadProperty,
		    opaqueType: opaqueType,
		    optionalCallExpression: optionalCallExpression$2,
		    optionalIndexedAccessType: optionalIndexedAccessType,
		    optionalMemberExpression: optionalMemberExpression$2,
		    parenthesizedExpression: parenthesizedExpression,
		    pipelineBareFunction: pipelineBareFunction,
		    pipelinePrimaryTopicReference: pipelinePrimaryTopicReference,
		    pipelineTopicExpression: pipelineTopicExpression,
		    placeholder: placeholder,
		    prependToMemberExpression: prependToMemberExpression,
		    privateName: privateName,
		    program: program$3,
		    qualifiedTypeIdentifier: qualifiedTypeIdentifier,
		    react: react$3,
		    recordExpression: recordExpression,
		    regExpLiteral: regExpLiteral,
		    regexLiteral: RegexLiteral,
		    removeComments: removeComments$1,
		    removeProperties: removeProperties$1,
		    removePropertiesDeep: removePropertiesDeep$1,
		    removeTypeDuplicates: removeTypeDuplicates$1,
		    restElement: restElement$2,
		    restProperty: RestProperty,
		    returnStatement: returnStatement$3,
		    sequenceExpression: sequenceExpression$8,
		    shallowEqual: shallowEqual,
		    spreadElement: spreadElement$2,
		    spreadProperty: SpreadProperty,
		    staticBlock: staticBlock,
		    stringLiteral: stringLiteral$8,
		    stringLiteralTypeAnnotation: stringLiteralTypeAnnotation,
		    stringTypeAnnotation: stringTypeAnnotation$2,
		    super: _super$1,
		    switchCase: switchCase,
		    switchStatement: switchStatement,
		    symbolTypeAnnotation: symbolTypeAnnotation,
		    tSAnyKeyword: tsAnyKeyword,
		    tSArrayType: tsArrayType,
		    tSAsExpression: tsAsExpression,
		    tSBigIntKeyword: tsBigIntKeyword,
		    tSBooleanKeyword: tsBooleanKeyword,
		    tSCallSignatureDeclaration: tsCallSignatureDeclaration,
		    tSConditionalType: tsConditionalType,
		    tSConstructSignatureDeclaration: tsConstructSignatureDeclaration,
		    tSConstructorType: tsConstructorType,
		    tSDeclareFunction: tsDeclareFunction,
		    tSDeclareMethod: tsDeclareMethod,
		    tSEnumDeclaration: tsEnumDeclaration,
		    tSEnumMember: tsEnumMember,
		    tSExportAssignment: tsExportAssignment,
		    tSExpressionWithTypeArguments: tsExpressionWithTypeArguments,
		    tSExternalModuleReference: tsExternalModuleReference,
		    tSFunctionType: tsFunctionType,
		    tSImportEqualsDeclaration: tsImportEqualsDeclaration,
		    tSImportType: tsImportType,
		    tSIndexSignature: tsIndexSignature,
		    tSIndexedAccessType: tsIndexedAccessType,
		    tSInferType: tsInferType,
		    tSInstantiationExpression: tsInstantiationExpression,
		    tSInterfaceBody: tsInterfaceBody,
		    tSInterfaceDeclaration: tsInterfaceDeclaration,
		    tSIntersectionType: tsIntersectionType,
		    tSIntrinsicKeyword: tsIntrinsicKeyword,
		    tSLiteralType: tsLiteralType,
		    tSMappedType: tsMappedType,
		    tSMethodSignature: tsMethodSignature,
		    tSModuleBlock: tsModuleBlock,
		    tSModuleDeclaration: tsModuleDeclaration,
		    tSNamedTupleMember: tsNamedTupleMember,
		    tSNamespaceExportDeclaration: tsNamespaceExportDeclaration,
		    tSNeverKeyword: tsNeverKeyword,
		    tSNonNullExpression: tsNonNullExpression,
		    tSNullKeyword: tsNullKeyword,
		    tSNumberKeyword: tsNumberKeyword,
		    tSObjectKeyword: tsObjectKeyword,
		    tSOptionalType: tsOptionalType,
		    tSParameterProperty: tsParameterProperty,
		    tSParenthesizedType: tsParenthesizedType,
		    tSPropertySignature: tsPropertySignature,
		    tSQualifiedName: tsQualifiedName,
		    tSRestType: tsRestType,
		    tSSatisfiesExpression: tsSatisfiesExpression,
		    tSStringKeyword: tsStringKeyword,
		    tSSymbolKeyword: tsSymbolKeyword,
		    tSThisType: tsThisType,
		    tSTupleType: tsTupleType,
		    tSTypeAliasDeclaration: tsTypeAliasDeclaration,
		    tSTypeAnnotation: tsTypeAnnotation,
		    tSTypeAssertion: tsTypeAssertion,
		    tSTypeLiteral: tsTypeLiteral,
		    tSTypeOperator: tsTypeOperator,
		    tSTypeParameter: tsTypeParameter,
		    tSTypeParameterDeclaration: tsTypeParameterDeclaration,
		    tSTypeParameterInstantiation: tsTypeParameterInstantiation,
		    tSTypePredicate: tsTypePredicate,
		    tSTypeQuery: tsTypeQuery,
		    tSTypeReference: tsTypeReference,
		    tSUndefinedKeyword: tsUndefinedKeyword,
		    tSUnionType: tsUnionType,
		    tSUnknownKeyword: tsUnknownKeyword,
		    tSVoidKeyword: tsVoidKeyword,
		    taggedTemplateExpression: taggedTemplateExpression,
		    templateElement: templateElement,
		    templateLiteral: templateLiteral,
		    thisExpression: thisExpression$4,
		    thisTypeAnnotation: thisTypeAnnotation,
		    throwStatement: throwStatement,
		    toBindingIdentifierName: toBindingIdentifierName$1,
		    toBlock: toBlock,
		    toComputedKey: toComputedKey$2,
		    toExpression: toExpression$1,
		    toIdentifier: toIdentifier$1,
		    toKeyAlias: toKeyAlias,
		    toStatement: toStatement,
		    topicReference: topicReference,
		    traverse: traverse$2,
		    traverseFast: traverseFast$2,
		    tryStatement: tryStatement,
		    tsAnyKeyword: tsAnyKeyword,
		    tsArrayType: tsArrayType,
		    tsAsExpression: tsAsExpression,
		    tsBigIntKeyword: tsBigIntKeyword,
		    tsBooleanKeyword: tsBooleanKeyword,
		    tsCallSignatureDeclaration: tsCallSignatureDeclaration,
		    tsConditionalType: tsConditionalType,
		    tsConstructSignatureDeclaration: tsConstructSignatureDeclaration,
		    tsConstructorType: tsConstructorType,
		    tsDeclareFunction: tsDeclareFunction,
		    tsDeclareMethod: tsDeclareMethod,
		    tsEnumDeclaration: tsEnumDeclaration,
		    tsEnumMember: tsEnumMember,
		    tsExportAssignment: tsExportAssignment,
		    tsExpressionWithTypeArguments: tsExpressionWithTypeArguments,
		    tsExternalModuleReference: tsExternalModuleReference,
		    tsFunctionType: tsFunctionType,
		    tsImportEqualsDeclaration: tsImportEqualsDeclaration,
		    tsImportType: tsImportType,
		    tsIndexSignature: tsIndexSignature,
		    tsIndexedAccessType: tsIndexedAccessType,
		    tsInferType: tsInferType,
		    tsInstantiationExpression: tsInstantiationExpression,
		    tsInterfaceBody: tsInterfaceBody,
		    tsInterfaceDeclaration: tsInterfaceDeclaration,
		    tsIntersectionType: tsIntersectionType,
		    tsIntrinsicKeyword: tsIntrinsicKeyword,
		    tsLiteralType: tsLiteralType,
		    tsMappedType: tsMappedType,
		    tsMethodSignature: tsMethodSignature,
		    tsModuleBlock: tsModuleBlock,
		    tsModuleDeclaration: tsModuleDeclaration,
		    tsNamedTupleMember: tsNamedTupleMember,
		    tsNamespaceExportDeclaration: tsNamespaceExportDeclaration,
		    tsNeverKeyword: tsNeverKeyword,
		    tsNonNullExpression: tsNonNullExpression,
		    tsNullKeyword: tsNullKeyword,
		    tsNumberKeyword: tsNumberKeyword,
		    tsObjectKeyword: tsObjectKeyword,
		    tsOptionalType: tsOptionalType,
		    tsParameterProperty: tsParameterProperty,
		    tsParenthesizedType: tsParenthesizedType,
		    tsPropertySignature: tsPropertySignature,
		    tsQualifiedName: tsQualifiedName,
		    tsRestType: tsRestType,
		    tsSatisfiesExpression: tsSatisfiesExpression,
		    tsStringKeyword: tsStringKeyword,
		    tsSymbolKeyword: tsSymbolKeyword,
		    tsThisType: tsThisType,
		    tsTupleType: tsTupleType,
		    tsTypeAliasDeclaration: tsTypeAliasDeclaration,
		    tsTypeAnnotation: tsTypeAnnotation,
		    tsTypeAssertion: tsTypeAssertion,
		    tsTypeLiteral: tsTypeLiteral,
		    tsTypeOperator: tsTypeOperator,
		    tsTypeParameter: tsTypeParameter,
		    tsTypeParameterDeclaration: tsTypeParameterDeclaration,
		    tsTypeParameterInstantiation: tsTypeParameterInstantiation,
		    tsTypePredicate: tsTypePredicate,
		    tsTypeQuery: tsTypeQuery,
		    tsTypeReference: tsTypeReference,
		    tsUndefinedKeyword: tsUndefinedKeyword,
		    tsUnionType: tsUnionType,
		    tsUnknownKeyword: tsUnknownKeyword,
		    tsVoidKeyword: tsVoidKeyword,
		    tupleExpression: tupleExpression,
		    tupleTypeAnnotation: tupleTypeAnnotation$1,
		    typeAlias: typeAlias,
		    typeAnnotation: typeAnnotation,
		    typeCastExpression: typeCastExpression,
		    typeParameter: typeParameter,
		    typeParameterDeclaration: typeParameterDeclaration,
		    typeParameterInstantiation: typeParameterInstantiation,
		    typeofTypeAnnotation: typeofTypeAnnotation,
		    unaryExpression: unaryExpression$6,
		    unionTypeAnnotation: unionTypeAnnotation$1,
		    updateExpression: updateExpression$1,
		    v8IntrinsicIdentifier: v8IntrinsicIdentifier,
		    validate: validate$5,
		    valueToNode: valueToNode$1,
		    variableDeclaration: variableDeclaration$8,
		    variableDeclarator: variableDeclarator$8,
		    variance: variance,
		    voidTypeAnnotation: voidTypeAnnotation$3,
		    whileStatement: whileStatement,
		    withStatement: withStatement,
		    yieldExpression: yieldExpression$2
		  });

		  var isBinding = isBinding$1,
		    nodeIsBlockScoped = isBlockScoped$2,
		    isExportDeclaration$2 = isExportDeclaration$3,
		    nodeIsExpression = isExpression$4,
		    nodeIsFlow = isFlow$1,
		    isForStatement$1 = isForStatement$2,
		    isForXStatement = isForXStatement$1,
		    isIdentifier$h = isIdentifier$i,
		    isImportDeclaration$2 = isImportDeclaration$3,
		    isImportSpecifier = isImportSpecifier$1,
		    isJSXIdentifier$2 = isJSXIdentifier$3,
		    isJSXMemberExpression$1 = isJSXMemberExpression$2,
		    isMemberExpression$8 = isMemberExpression$9,
		    nodeIsRestElement = isRestElement$2,
		    nodeIsReferenced = isReferenced$2,
		    nodeIsScope = isScope$1,
		    nodeIsStatement = isStatement$8,
		    nodeIsVar = isVar$1,
		    isVariableDeclaration$3 = isVariableDeclaration$4,
		    react$2 = react$3,
		    isForOfStatement$1 = isForOfStatement$2;
		  var isCompatTag = react$2.isCompatTag;
		  function isReferencedIdentifier(opts) {
		    var node = this.node,
		      parent = this.parent;
		    if (!isIdentifier$h(node, opts) && !isJSXMemberExpression$1(parent, opts)) {
		      if (isJSXIdentifier$2(node, opts)) {
		        if (isCompatTag(node.name)) return false;
		      } else {
		        return false;
		      }
		    }
		    return nodeIsReferenced(node, parent, this.parentPath.parent);
		  }
		  function isReferencedMemberExpression() {
		    var node = this.node,
		      parent = this.parent;
		    return isMemberExpression$8(node) && nodeIsReferenced(node, parent);
		  }
		  function isBindingIdentifier() {
		    var node = this.node,
		      parent = this.parent;
		    var grandparent = this.parentPath.parent;
		    return isIdentifier$h(node) && isBinding(node, parent, grandparent);
		  }
		  function isStatement$7() {
		    var node = this.node,
		      parent = this.parent;
		    if (nodeIsStatement(node)) {
		      if (isVariableDeclaration$3(node)) {
		        if (isForXStatement(parent, {
		          left: node
		        })) return false;
		        if (isForStatement$1(parent, {
		          init: node
		        })) return false;
		      }
		      return true;
		    } else {
		      return false;
		    }
		  }
		  function isExpression$3() {
		    if (this.isIdentifier()) {
		      return this.isReferencedIdentifier();
		    } else {
		      return nodeIsExpression(this.node);
		    }
		  }
		  function isScope() {
		    return nodeIsScope(this.node, this.parent);
		  }
		  function isReferenced$1() {
		    return nodeIsReferenced(this.node, this.parent);
		  }
		  function isBlockScoped$1() {
		    return nodeIsBlockScoped(this.node);
		  }
		  function isVar() {
		    return nodeIsVar(this.node);
		  }
		  function isUser() {
		    return this.node && !!this.node.loc;
		  }
		  function isGenerated() {
		    return !this.isUser();
		  }
		  function isPure(constantsOnly) {
		    return this.scope.isPure(this.node, constantsOnly);
		  }
		  function isFlow() {
		    var node = this.node;
		    if (nodeIsFlow(node)) {
		      return true;
		    } else if (isImportDeclaration$2(node)) {
		      return node.importKind === "type" || node.importKind === "typeof";
		    } else if (isExportDeclaration$2(node)) {
		      return node.exportKind === "type";
		    } else if (isImportSpecifier(node)) {
		      return node.importKind === "type" || node.importKind === "typeof";
		    } else {
		      return false;
		    }
		  }
		  function isRestProperty() {
		    var _this$parentPath;
		    return nodeIsRestElement(this.node) && ((_this$parentPath = this.parentPath) == null ? void 0 : _this$parentPath.isObjectPattern());
		  }
		  function isSpreadProperty() {
		    var _this$parentPath2;
		    return nodeIsRestElement(this.node) && ((_this$parentPath2 = this.parentPath) == null ? void 0 : _this$parentPath2.isObjectExpression());
		  }
		  function isForAwaitStatement() {
		    return isForOfStatement$1(this.node, {
		      "await": true
		    });
		  }
		  {
		    exports.isExistentialTypeParam = function isExistentialTypeParam() {
		      throw new Error("`path.isExistentialTypeParam` has been renamed to `path.isExistsTypeAnnotation()` in Babel 7.");
		    };
		    exports.isNumericLiteralTypeAnnotation = function isNumericLiteralTypeAnnotation() {
		      throw new Error("`path.isNumericLiteralTypeAnnotation()` has been renamed to `path.isNumberLiteralTypeAnnotation()` in Babel 7.");
		    };
		  }

		  var NodePath_virtual_types_validator = /*#__PURE__*/Object.freeze({
		    __proto__: null,
		    isBindingIdentifier: isBindingIdentifier,
		    isBlockScoped: isBlockScoped$1,
		    isExpression: isExpression$3,
		    isFlow: isFlow,
		    isForAwaitStatement: isForAwaitStatement,
		    isGenerated: isGenerated,
		    isPure: isPure,
		    isReferenced: isReferenced$1,
		    isReferencedIdentifier: isReferencedIdentifier,
		    isReferencedMemberExpression: isReferencedMemberExpression,
		    isRestProperty: isRestProperty,
		    isScope: isScope,
		    isSpreadProperty: isSpreadProperty,
		    isStatement: isStatement$7,
		    isUser: isUser,
		    isVar: isVar
		  });

		  var DEPRECATED_KEYS = DEPRECATED_KEYS$1,
		    DEPRECATED_ALIASES = DEPRECATED_ALIASES$1,
		    FLIPPED_ALIAS_KEYS$2 = FLIPPED_ALIAS_KEYS$3,
		    TYPES = TYPES$1,
		    deprecationWarning = deprecationWarning$1;
		  function isVirtualType(type) {
		    return type in virtualTypes;
		  }
		  function isExplodedVisitor(visitor) {
		    return visitor == null ? void 0 : visitor._exploded;
		  }
		  function explode$1(visitor) {
		    if (isExplodedVisitor(visitor)) return visitor;
		    visitor._exploded = true;
		    for (var _i = 0, _arr = Object.keys(visitor); _i < _arr.length; _i++) {
		      var nodeType = _arr[_i];
		      if (shouldIgnoreKey(nodeType)) continue;
		      var parts = nodeType.split("|");
		      if (parts.length === 1) continue;
		      var fns = visitor[nodeType];
		      delete visitor[nodeType];
		      for (var _iterator = _createForOfIteratorHelperLoose(parts), _step; !(_step = _iterator()).done;) {
		        var part = _step.value;
		        visitor[part] = fns;
		      }
		    }
		    verify(visitor);
		    delete visitor.__esModule;
		    ensureEntranceObjects(visitor);
		    ensureCallbackArrays(visitor);
		    for (var _i2 = 0, _Object$keys = Object.keys(visitor); _i2 < _Object$keys.length; _i2++) {
		      var _nodeType = _Object$keys[_i2];
		      if (shouldIgnoreKey(_nodeType)) continue;
		      if (!isVirtualType(_nodeType)) continue;
		      var _fns = visitor[_nodeType];
		      for (var _i3 = 0, _Object$keys2 = Object.keys(_fns); _i3 < _Object$keys2.length; _i3++) {
		        var type = _Object$keys2[_i3];
		        _fns[type] = wrapCheck(_nodeType, _fns[type]);
		      }
		      delete visitor[_nodeType];
		      var types = virtualTypes[_nodeType];
		      if (types !== null) {
		        for (var _iterator2 = _createForOfIteratorHelperLoose(types), _step2; !(_step2 = _iterator2()).done;) {
		          var _type = _step2.value;
		          if (visitor[_type]) {
		            mergePair(visitor[_type], _fns);
		          } else {
		            visitor[_type] = _fns;
		          }
		        }
		      } else {
		        mergePair(visitor, _fns);
		      }
		    }
		    for (var _i4 = 0, _arr2 = Object.keys(visitor); _i4 < _arr2.length; _i4++) {
		      var _nodeType2 = _arr2[_i4];
		      if (shouldIgnoreKey(_nodeType2)) continue;
		      var aliases = FLIPPED_ALIAS_KEYS$2[_nodeType2];
		      if (_nodeType2 in DEPRECATED_KEYS) {
		        var deprecatedKey = DEPRECATED_KEYS[_nodeType2];
		        deprecationWarning(_nodeType2, deprecatedKey, "Visitor ");
		        aliases = [deprecatedKey];
		      } else if (_nodeType2 in DEPRECATED_ALIASES) {
		        var deprecatedAlias = DEPRECATED_ALIASES[_nodeType2];
		        deprecationWarning(_nodeType2, deprecatedAlias, "Visitor ");
		        aliases = FLIPPED_ALIAS_KEYS$2[deprecatedAlias];
		      }
		      if (!aliases) continue;
		      var _fns2 = visitor[_nodeType2];
		      delete visitor[_nodeType2];
		      for (var _iterator3 = _createForOfIteratorHelperLoose(aliases), _step3; !(_step3 = _iterator3()).done;) {
		        var alias = _step3.value;
		        var existing = visitor[alias];
		        if (existing) {
		          mergePair(existing, _fns2);
		        } else {
		          visitor[alias] = Object.assign({}, _fns2);
		        }
		      }
		    }
		    for (var _i5 = 0, _Object$keys3 = Object.keys(visitor); _i5 < _Object$keys3.length; _i5++) {
		      var _nodeType3 = _Object$keys3[_i5];
		      if (shouldIgnoreKey(_nodeType3)) continue;
		      ensureCallbackArrays(visitor[_nodeType3]);
		    }
		    return visitor;
		  }
		  function verify(visitor) {
		    if (visitor._verified) return;
		    if (typeof visitor === "function") {
		      throw new Error("You passed `traverse()` a function when it expected a visitor object, " + "are you sure you didn't mean `{ enter: Function }`?");
		    }
		    for (var _i6 = 0, _arr3 = Object.keys(visitor); _i6 < _arr3.length; _i6++) {
		      var nodeType = _arr3[_i6];
		      if (nodeType === "enter" || nodeType === "exit") {
		        validateVisitorMethods(nodeType, visitor[nodeType]);
		      }
		      if (shouldIgnoreKey(nodeType)) continue;
		      if (TYPES.indexOf(nodeType) < 0) {
		        throw new Error("You gave us a visitor for the node type " + nodeType + " but it's not a valid type");
		      }
		      var _visitors = visitor[nodeType];
		      if (typeof _visitors === "object") {
		        for (var _i7 = 0, _Object$keys4 = Object.keys(_visitors); _i7 < _Object$keys4.length; _i7++) {
		          var visitorKey = _Object$keys4[_i7];
		          if (visitorKey === "enter" || visitorKey === "exit") {
		            validateVisitorMethods(nodeType + "." + visitorKey, _visitors[visitorKey]);
		          } else {
		            throw new Error("You passed `traverse()` a visitor object with the property " + (nodeType + " that has the invalid property " + visitorKey));
		          }
		        }
		      }
		    }
		    visitor._verified = true;
		  }
		  function validateVisitorMethods(path, val) {
		    var fns = [].concat(val);
		    for (var _iterator4 = _createForOfIteratorHelperLoose(fns), _step4; !(_step4 = _iterator4()).done;) {
		      var fn = _step4.value;
		      if (typeof fn !== "function") {
		        throw new TypeError("Non-function found defined in " + path + " with type " + typeof fn);
		      }
		    }
		  }
		  function merge$1(visitors, states, wrapper) {
		    if (states === void 0) {
		      states = [];
		    }
		    var mergedVisitor = {};
		    for (var i = 0; i < visitors.length; i++) {
		      var visitor = explode$1(visitors[i]);
		      var state = states[i];
		      var topVisitor = visitor;
		      if (state || wrapper) {
		        topVisitor = wrapWithStateOrWrapper(topVisitor, state, wrapper);
		      }
		      mergePair(mergedVisitor, topVisitor);
		      for (var _i8 = 0, _arr4 = Object.keys(visitor); _i8 < _arr4.length; _i8++) {
		        var key = _arr4[_i8];
		        if (shouldIgnoreKey(key)) continue;
		        var typeVisitor = visitor[key];
		        if (state || wrapper) {
		          typeVisitor = wrapWithStateOrWrapper(typeVisitor, state, wrapper);
		        }
		        var nodeVisitor = mergedVisitor[key] || (mergedVisitor[key] = {});
		        mergePair(nodeVisitor, typeVisitor);
		      }
		    }
		    return mergedVisitor;
		  }
		  function wrapWithStateOrWrapper(oldVisitor, state, wrapper) {
		    var newVisitor = {};
		    var _loop = function _loop() {
		      var phase = _arr5[_i9];
		      var fns = oldVisitor[phase];
		      if (!Array.isArray(fns)) return 1;
		      fns = fns.map(function (fn) {
		        var newFn = fn;
		        if (state) {
		          newFn = function newFn(path) {
		            fn.call(state, path, state);
		          };
		        }
		        if (wrapper) {
		          newFn = wrapper(state == null ? void 0 : state.key, phase, newFn);
		        }
		        if (newFn !== fn) {
		          newFn.toString = function () {
		            return fn.toString();
		          };
		        }
		        return newFn;
		      });
		      newVisitor[phase] = fns;
		    };
		    for (var _i9 = 0, _arr5 = ["enter", "exit"]; _i9 < _arr5.length; _i9++) {
		      if (_loop()) continue;
		    }
		    return newVisitor;
		  }
		  function ensureEntranceObjects(obj) {
		    for (var _i10 = 0, _arr6 = Object.keys(obj); _i10 < _arr6.length; _i10++) {
		      var key = _arr6[_i10];
		      if (shouldIgnoreKey(key)) continue;
		      var fns = obj[key];
		      if (typeof fns === "function") {
		        obj[key] = {
		          enter: fns
		        };
		      }
		    }
		  }
		  function ensureCallbackArrays(obj) {
		    if (obj.enter && !Array.isArray(obj.enter)) obj.enter = [obj.enter];
		    if (obj.exit && !Array.isArray(obj.exit)) obj.exit = [obj.exit];
		  }
		  function wrapCheck(nodeType, fn) {
		    var fnKey = "is" + nodeType;
		    var validator = NodePath_virtual_types_validator[fnKey];
		    var newFn = function newFn(path) {
		      if (validator.call(path)) {
		        return fn.apply(this, arguments);
		      }
		    };
		    newFn.toString = function () {
		      return fn.toString();
		    };
		    return newFn;
		  }
		  function shouldIgnoreKey(key) {
		    if (key[0] === "_") return true;
		    if (key === "enter" || key === "exit" || key === "shouldSkip") return true;
		    if (key === "denylist" || key === "noScope" || key === "skipKeys") {
		      return true;
		    }
		    {
		      if (key === "blacklist") {
		        return true;
		      }
		    }
		    return false;
		  }
		  function mergePair(dest, src) {
		    for (var _i11 = 0, _arr7 = ["enter", "exit"]; _i11 < _arr7.length; _i11++) {
		      var phase = _arr7[_i11];
		      if (!src[phase]) continue;
		      dest[phase] = [].concat(dest[phase] || [], src[phase]);
		    }
		  }

		  var visitors$2 = /*#__PURE__*/Object.freeze({
		    __proto__: null,
		    explode: explode$1,
		    isExplodedVisitor: isExplodedVisitor,
		    merge: merge$1,
		    verify: verify
		  });

		  var pathsCache = new WeakMap();
		  var scope = new WeakMap();
		  function clear() {
		    clearPath();
		    clearScope();
		  }
		  function clearPath() {
		    pathsCache = new WeakMap();
		  }
		  function clearScope() {
		    scope = new WeakMap();
		  }
		  var nullHub = Object.freeze({});
		  function getCachedPaths(hub, parent) {
		    var _pathsCache$get, _hub;
		    {
		      hub = null;
		    }
		    return (_pathsCache$get = pathsCache.get((_hub = hub) != null ? _hub : nullHub)) == null ? void 0 : _pathsCache$get.get(parent);
		  }
		  function getOrCreateCachedPaths(hub, parent) {
		    var _hub2, _hub3;
		    {
		      hub = null;
		    }
		    var parents = pathsCache.get((_hub2 = hub) != null ? _hub2 : nullHub);
		    if (!parents) pathsCache.set((_hub3 = hub) != null ? _hub3 : nullHub, parents = new WeakMap());
		    var paths = parents.get(parent);
		    if (!paths) parents.set(parent, paths = new Map());
		    return paths;
		  }

		  var cache$1 = /*#__PURE__*/Object.freeze({
		    __proto__: null,
		    clear: clear,
		    clearPath: clearPath,
		    clearScope: clearScope,
		    getCachedPaths: getCachedPaths,
		    getOrCreateCachedPaths: getOrCreateCachedPaths,
		    get path () { return pathsCache; },
		    get scope () { return scope; }
		  });

		  var browser$2 = {exports: {}};

		  var ms;
		  var hasRequiredMs;
		  function requireMs() {
		    if (hasRequiredMs) return ms;
		    hasRequiredMs = 1;
		    var s = 1000;
		    var m = s * 60;
		    var h = m * 60;
		    var d = h * 24;
		    var w = d * 7;
		    var y = d * 365.25;
		    ms = function ms(val, options) {
		      options = options || {};
		      var type = typeof val;
		      if (type === 'string' && val.length > 0) {
		        return parse(val);
		      } else if (type === 'number' && isFinite(val)) {
		        return options["long"] ? fmtLong(val) : fmtShort(val);
		      }
		      throw new Error('val is not a non-empty string or a valid number. val=' + JSON.stringify(val));
		    };
		    function parse(str) {
		      str = String(str);
		      if (str.length > 100) {
		        return;
		      }
		      var match = /^(-?(?:\d+)?\.?\d+) *(milliseconds?|msecs?|ms|seconds?|secs?|s|minutes?|mins?|m|hours?|hrs?|h|days?|d|weeks?|w|years?|yrs?|y)?$/i.exec(str);
		      if (!match) {
		        return;
		      }
		      var n = parseFloat(match[1]);
		      var type = (match[2] || 'ms').toLowerCase();
		      switch (type) {
		        case 'years':
		        case 'year':
		        case 'yrs':
		        case 'yr':
		        case 'y':
		          return n * y;
		        case 'weeks':
		        case 'week':
		        case 'w':
		          return n * w;
		        case 'days':
		        case 'day':
		        case 'd':
		          return n * d;
		        case 'hours':
		        case 'hour':
		        case 'hrs':
		        case 'hr':
		        case 'h':
		          return n * h;
		        case 'minutes':
		        case 'minute':
		        case 'mins':
		        case 'min':
		        case 'm':
		          return n * m;
		        case 'seconds':
		        case 'second':
		        case 'secs':
		        case 'sec':
		        case 's':
		          return n * s;
		        case 'milliseconds':
		        case 'millisecond':
		        case 'msecs':
		        case 'msec':
		        case 'ms':
		          return n;
		        default:
		          return undefined;
		      }
		    }
		    function fmtShort(ms) {
		      var msAbs = Math.abs(ms);
		      if (msAbs >= d) {
		        return Math.round(ms / d) + 'd';
		      }
		      if (msAbs >= h) {
		        return Math.round(ms / h) + 'h';
		      }
		      if (msAbs >= m) {
		        return Math.round(ms / m) + 'm';
		      }
		      if (msAbs >= s) {
		        return Math.round(ms / s) + 's';
		      }
		      return ms + 'ms';
		    }
		    function fmtLong(ms) {
		      var msAbs = Math.abs(ms);
		      if (msAbs >= d) {
		        return plural(ms, msAbs, d, 'day');
		      }
		      if (msAbs >= h) {
		        return plural(ms, msAbs, h, 'hour');
		      }
		      if (msAbs >= m) {
		        return plural(ms, msAbs, m, 'minute');
		      }
		      if (msAbs >= s) {
		        return plural(ms, msAbs, s, 'second');
		      }
		      return ms + ' ms';
		    }
		    function plural(ms, msAbs, n, name) {
		      var isPlural = msAbs >= n * 1.5;
		      return Math.round(ms / n) + ' ' + name + (isPlural ? 's' : '');
		    }
		    return ms;
		  }

		  function setup$1(env) {
		    createDebug.debug = createDebug;
		    createDebug["default"] = createDebug;
		    createDebug.coerce = coerce;
		    createDebug.disable = disable;
		    createDebug.enable = enable;
		    createDebug.enabled = enabled;
		    createDebug.humanize = requireMs();
		    createDebug.destroy = destroy;
		    Object.keys(env).forEach(function (key) {
		      createDebug[key] = env[key];
		    });
		    createDebug.names = [];
		    createDebug.skips = [];
		    createDebug.formatters = {};
		    function selectColor(namespace) {
		      var hash = 0;
		      for (var i = 0; i < namespace.length; i++) {
		        hash = (hash << 5) - hash + namespace.charCodeAt(i);
		        hash |= 0;
		      }
		      return createDebug.colors[Math.abs(hash) % createDebug.colors.length];
		    }
		    createDebug.selectColor = selectColor;
		    function createDebug(namespace) {
		      var prevTime;
		      var enableOverride = null;
		      var namespacesCache;
		      var enabledCache;
		      function debug() {
		        for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
		          args[_key] = arguments[_key];
		        }
		        if (!debug.enabled) {
		          return;
		        }
		        var self = debug;
		        var curr = Number(new Date());
		        var ms = curr - (prevTime || curr);
		        self.diff = ms;
		        self.prev = prevTime;
		        self.curr = curr;
		        prevTime = curr;
		        args[0] = createDebug.coerce(args[0]);
		        if (typeof args[0] !== 'string') {
		          args.unshift('%O');
		        }
		        var index = 0;
		        args[0] = args[0].replace(/%([a-zA-Z%])/g, function (match, format) {
		          if (match === '%%') {
		            return '%';
		          }
		          index++;
		          var formatter = createDebug.formatters[format];
		          if (typeof formatter === 'function') {
		            var val = args[index];
		            match = formatter.call(self, val);
		            args.splice(index, 1);
		            index--;
		          }
		          return match;
		        });
		        createDebug.formatArgs.call(self, args);
		        var logFn = self.log || createDebug.log;
		        logFn.apply(self, args);
		      }
		      debug.namespace = namespace;
		      debug.useColors = createDebug.useColors();
		      debug.color = createDebug.selectColor(namespace);
		      debug.extend = extend;
		      debug.destroy = createDebug.destroy;
		      Object.defineProperty(debug, 'enabled', {
		        enumerable: true,
		        configurable: false,
		        get: function get() {
		          if (enableOverride !== null) {
		            return enableOverride;
		          }
		          if (namespacesCache !== createDebug.namespaces) {
		            namespacesCache = createDebug.namespaces;
		            enabledCache = createDebug.enabled(namespace);
		          }
		          return enabledCache;
		        },
		        set: function set(v) {
		          enableOverride = v;
		        }
		      });
		      if (typeof createDebug.init === 'function') {
		        createDebug.init(debug);
		      }
		      return debug;
		    }
		    function extend(namespace, delimiter) {
		      var newDebug = createDebug(this.namespace + (typeof delimiter === 'undefined' ? ':' : delimiter) + namespace);
		      newDebug.log = this.log;
		      return newDebug;
		    }
		    function enable(namespaces) {
		      createDebug.save(namespaces);
		      createDebug.namespaces = namespaces;
		      createDebug.names = [];
		      createDebug.skips = [];
		      var i;
		      var split = (typeof namespaces === 'string' ? namespaces : '').split(/[\s,]+/);
		      var len = split.length;
		      for (i = 0; i < len; i++) {
		        if (!split[i]) {
		          continue;
		        }
		        namespaces = split[i].replace(/\*/g, '.*?');
		        if (namespaces[0] === '-') {
		          createDebug.skips.push(new RegExp('^' + namespaces.slice(1) + '$'));
		        } else {
		          createDebug.names.push(new RegExp('^' + namespaces + '$'));
		        }
		      }
		    }
		    function disable() {
		      var namespaces = [].concat(_toConsumableArray(createDebug.names.map(toNamespace)), _toConsumableArray(createDebug.skips.map(toNamespace).map(function (namespace) {
		        return '-' + namespace;
		      }))).join(',');
		      createDebug.enable('');
		      return namespaces;
		    }
		    function enabled(name) {
		      if (name[name.length - 1] === '*') {
		        return true;
		      }
		      var i;
		      var len;
		      for (i = 0, len = createDebug.skips.length; i < len; i++) {
		        if (createDebug.skips[i].test(name)) {
		          return false;
		        }
		      }
		      for (i = 0, len = createDebug.names.length; i < len; i++) {
		        if (createDebug.names[i].test(name)) {
		          return true;
		        }
		      }
		      return false;
		    }
		    function toNamespace(regexp) {
		      return regexp.toString().substring(2, regexp.toString().length - 2).replace(/\.\*\?$/, '*');
		    }
		    function coerce(val) {
		      if (val instanceof Error) {
		        return val.stack || val.message;
		      }
		      return val;
		    }
		    function destroy() {
		      console.warn('Instance method `debug.destroy()` is deprecated and no longer does anything. It will be removed in the next major version of `debug`.');
		    }
		    createDebug.enable(createDebug.load());
		    return createDebug;
		  }
		  var common = setup$1;

		  (function (module, exports) {
		    exports.formatArgs = formatArgs;
		    exports.save = save;
		    exports.load = load;
		    exports.useColors = useColors;
		    exports.storage = localstorage();
		    exports.destroy = function () {
		      var warned = false;
		      return function () {
		        if (!warned) {
		          warned = true;
		          console.warn('Instance method `debug.destroy()` is deprecated and no longer does anything. It will be removed in the next major version of `debug`.');
		        }
		      };
		    }();
		    exports.colors = ['#0000CC', '#0000FF', '#0033CC', '#0033FF', '#0066CC', '#0066FF', '#0099CC', '#0099FF', '#00CC00', '#00CC33', '#00CC66', '#00CC99', '#00CCCC', '#00CCFF', '#3300CC', '#3300FF', '#3333CC', '#3333FF', '#3366CC', '#3366FF', '#3399CC', '#3399FF', '#33CC00', '#33CC33', '#33CC66', '#33CC99', '#33CCCC', '#33CCFF', '#6600CC', '#6600FF', '#6633CC', '#6633FF', '#66CC00', '#66CC33', '#9900CC', '#9900FF', '#9933CC', '#9933FF', '#99CC00', '#99CC33', '#CC0000', '#CC0033', '#CC0066', '#CC0099', '#CC00CC', '#CC00FF', '#CC3300', '#CC3333', '#CC3366', '#CC3399', '#CC33CC', '#CC33FF', '#CC6600', '#CC6633', '#CC9900', '#CC9933', '#CCCC00', '#CCCC33', '#FF0000', '#FF0033', '#FF0066', '#FF0099', '#FF00CC', '#FF00FF', '#FF3300', '#FF3333', '#FF3366', '#FF3399', '#FF33CC', '#FF33FF', '#FF6600', '#FF6633', '#FF9900', '#FF9933', '#FFCC00', '#FFCC33'];
		    function useColors() {
		      if (typeof window !== 'undefined' && window.process && (window.process.type === 'renderer' || window.process.__nwjs)) {
		        return true;
		      }
		      if (typeof navigator !== 'undefined' && navigator.userAgent && navigator.userAgent.toLowerCase().match(/(edge|trident)\/(\d+)/)) {
		        return false;
		      }
		      return typeof document !== 'undefined' && document.documentElement && document.documentElement.style && document.documentElement.style.WebkitAppearance || typeof window !== 'undefined' && window.console && (window.console.firebug || window.console.exception && window.console.table) || typeof navigator !== 'undefined' && navigator.userAgent && navigator.userAgent.toLowerCase().match(/firefox\/(\d+)/) && parseInt(RegExp.$1, 10) >= 31 || typeof navigator !== 'undefined' && navigator.userAgent && navigator.userAgent.toLowerCase().match(/applewebkit\/(\d+)/);
		    }
		    function formatArgs(args) {
		      args[0] = (this.useColors ? '%c' : '') + this.namespace + (this.useColors ? ' %c' : ' ') + args[0] + (this.useColors ? '%c ' : ' ') + '+' + module.exports.humanize(this.diff);
		      if (!this.useColors) {
		        return;
		      }
		      var c = 'color: ' + this.color;
		      args.splice(1, 0, c, 'color: inherit');
		      var index = 0;
		      var lastC = 0;
		      args[0].replace(/%[a-zA-Z%]/g, function (match) {
		        if (match === '%%') {
		          return;
		        }
		        index++;
		        if (match === '%c') {
		          lastC = index;
		        }
		      });
		      args.splice(lastC, 0, c);
		    }
		    exports.log = console.debug || console.log || function () {};
		    function save(namespaces) {
		      try {
		        if (namespaces) {
		          exports.storage.setItem('debug', namespaces);
		        } else {
		          exports.storage.removeItem('debug');
		        }
		      } catch (error) {}
		    }
		    function load() {
		      var r;
		      try {
		        r = exports.storage.getItem('debug');
		      } catch (error) {}
		      if (!r && typeof browser$1$1 !== 'undefined' && 'env' in browser$1$1) {
		        r = browser$1$1.env.DEBUG;
		      }
		      return r;
		    }
		    function localstorage() {
		      try {
		        return localStorage;
		      } catch (error) {}
		    }
		    module.exports = common(exports);
		    var formatters = module.exports.formatters;
		    formatters.j = function (v) {
		      try {
		        return JSON.stringify(v);
		      } catch (error) {
		        return '[UnexpectedJSONParseError]: ' + error.message;
		      }
		    };
		  })(browser$2, browser$2.exports);
		  var browserExports = browser$2.exports;

		  var cloneNode$i = cloneNode$j,
		    exportNamedDeclaration$1 = exportNamedDeclaration$2,
		    exportSpecifier$1 = exportSpecifier$2,
		    identifier$i = identifier$j,
		    variableDeclaration$7 = variableDeclaration$8,
		    variableDeclarator$7 = variableDeclarator$8;
		  function splitExportDeclaration(exportDeclaration) {
		    if (!exportDeclaration.isExportDeclaration() || exportDeclaration.isExportAllDeclaration()) {
		      throw new Error("Only default and named export declarations can be split.");
		    }
		    if (exportDeclaration.isExportDefaultDeclaration()) {
		      var _declaration = exportDeclaration.get("declaration");
		      var standaloneDeclaration = _declaration.isFunctionDeclaration() || _declaration.isClassDeclaration();
		      var exportExpr = _declaration.isFunctionExpression() || _declaration.isClassExpression();
		      var scope = _declaration.isScope() ? _declaration.scope.parent : _declaration.scope;
		      var id = _declaration.node.id;
		      var needBindingRegistration = false;
		      if (!id) {
		        needBindingRegistration = true;
		        id = scope.generateUidIdentifier("default");
		        if (standaloneDeclaration || exportExpr) {
		          _declaration.node.id = cloneNode$i(id);
		        }
		      } else if (exportExpr && scope.hasBinding(id.name)) {
		        needBindingRegistration = true;
		        id = scope.generateUidIdentifier(id.name);
		      }
		      var updatedDeclaration = standaloneDeclaration ? _declaration.node : variableDeclaration$7("var", [variableDeclarator$7(cloneNode$i(id), _declaration.node)]);
		      var updatedExportDeclaration = exportNamedDeclaration$1(null, [exportSpecifier$1(cloneNode$i(id), identifier$i("default"))]);
		      exportDeclaration.insertAfter(updatedExportDeclaration);
		      exportDeclaration.replaceWith(updatedDeclaration);
		      if (needBindingRegistration) {
		        scope.registerDeclaration(exportDeclaration);
		      }
		      return exportDeclaration;
		    } else if (exportDeclaration.get("specifiers").length > 0) {
		      throw new Error("It doesn't make sense to split exported specifiers.");
		    }
		    var declaration = exportDeclaration.get("declaration");
		    var bindingIdentifiers = declaration.getOuterBindingIdentifiers();
		    var specifiers = Object.keys(bindingIdentifiers).map(function (name) {
		      return exportSpecifier$1(identifier$i(name), identifier$i(name));
		    });
		    var aliasDeclar = exportNamedDeclaration$1(null, specifiers);
		    exportDeclaration.insertAfter(aliasDeclar);
		    exportDeclaration.replaceWith(declaration.node);
		    return exportDeclaration;
		  }

		  function requeueComputedKeyAndDecorators(path) {
		    var context = path.context,
		      node = path.node;
		    if (node.computed) {
		      context.maybeQueue(path.get("key"));
		    }
		    if (node.decorators) {
		      for (var _iterator = _createForOfIteratorHelperLoose(path.get("decorators")), _step; !(_step = _iterator()).done;) {
		        var decorator = _step.value;
		        context.maybeQueue(decorator);
		      }
		    }
		  }
		  var visitor$5 = {
		    FunctionParent: function FunctionParent(path) {
		      if (path.isArrowFunctionExpression()) {
		        return;
		      } else {
		        path.skip();
		        if (path.isMethod()) {
		          requeueComputedKeyAndDecorators(path);
		        }
		      }
		    },
		    Property: function Property(path) {
		      if (path.isObjectProperty()) {
		        return;
		      }
		      path.skip();
		      requeueComputedKeyAndDecorators(path);
		    }
		  };

		  var renameVisitor = {
		    ReferencedIdentifier: function ReferencedIdentifier(_ref, state) {
		      var node = _ref.node;
		      if (node.name === state.oldName) {
		        node.name = state.newName;
		      }
		    },
		    Scope: function Scope(path, state) {
		      if (!path.scope.bindingIdentifierEquals(state.oldName, state.binding.identifier)) {
		        path.skip();
		        if (path.isMethod()) {
		          requeueComputedKeyAndDecorators(path);
		        }
		      }
		    },
		    ObjectProperty: function ObjectProperty(_ref2, state) {
		      var node = _ref2.node,
		        scope = _ref2.scope;
		      var _ref3 = node.key,
		        name = _ref3.name;
		      if (node.shorthand && (name === state.oldName || name === state.newName) && scope.getBindingIdentifier(name) === state.binding.identifier) {
		        var _node$extra;
		        node.shorthand = false;
		        if ((_node$extra = node.extra) != null && _node$extra.shorthand) node.extra.shorthand = false;
		      }
		    },
		    "AssignmentExpression|Declaration|VariableDeclarator": function AssignmentExpressionDeclarationVariableDeclarator(path, state) {
		      if (path.isVariableDeclaration()) return;
		      var ids = path.getOuterBindingIdentifiers();
		      for (var name in ids) {
		        if (name === state.oldName) ids[name].name = state.newName;
		      }
		    }
		  };
		  var Renamer = function () {
		    function Renamer(binding, oldName, newName) {
		      this.newName = newName;
		      this.oldName = oldName;
		      this.binding = binding;
		    }
		    var _proto = Renamer.prototype;
		    _proto.maybeConvertFromExportDeclaration = function maybeConvertFromExportDeclaration(parentDeclar) {
		      var maybeExportDeclar = parentDeclar.parentPath;
		      if (!maybeExportDeclar.isExportDeclaration()) {
		        return;
		      }
		      if (maybeExportDeclar.isExportDefaultDeclaration()) {
		        var declaration = maybeExportDeclar.node.declaration;
		        if (isDeclaration(declaration) && !declaration.id) {
		          return;
		        }
		      }
		      if (maybeExportDeclar.isExportAllDeclaration()) {
		        return;
		      }
		      splitExportDeclaration(maybeExportDeclar);
		    };
		    _proto.maybeConvertFromClassFunctionDeclaration = function maybeConvertFromClassFunctionDeclaration(path) {
		      return path;
		    };
		    _proto.maybeConvertFromClassFunctionExpression = function maybeConvertFromClassFunctionExpression(path) {
		      return path;
		    };
		    _proto.rename = function rename() {
		      var binding = this.binding,
		        oldName = this.oldName,
		        newName = this.newName;
		      var scope = binding.scope,
		        path = binding.path;
		      var parentDeclar = path.find(function (path) {
		        return path.isDeclaration() || path.isFunctionExpression() || path.isClassExpression();
		      });
		      if (parentDeclar) {
		        var bindingIds = parentDeclar.getOuterBindingIdentifiers();
		        if (bindingIds[oldName] === binding.identifier) {
		          this.maybeConvertFromExportDeclaration(parentDeclar);
		        }
		      }
		      var blockToTraverse = arguments[0] || scope.block;
		      traverseNode(blockToTraverse, explode$1(renameVisitor), scope, this, scope.path, {
		        discriminant: true
		      });
		      if (!arguments[0]) {
		        scope.removeOwnBinding(oldName);
		        scope.bindings[newName] = binding;
		        this.binding.identifier.name = newName;
		      }
		      if (parentDeclar) {
		        this.maybeConvertFromClassFunctionDeclaration(path);
		        this.maybeConvertFromClassFunctionExpression(path);
		      }
		    };
		    return _createClass(Renamer);
		  }();

		  var Binding = function () {
		    function Binding(_ref) {
		      var identifier = _ref.identifier,
		        scope = _ref.scope,
		        path = _ref.path,
		        kind = _ref.kind;
		      this.identifier = void 0;
		      this.scope = void 0;
		      this.path = void 0;
		      this.kind = void 0;
		      this.constantViolations = [];
		      this.constant = true;
		      this.referencePaths = [];
		      this.referenced = false;
		      this.references = 0;
		      this.identifier = identifier;
		      this.scope = scope;
		      this.path = path;
		      this.kind = kind;
		      if ((kind === "var" || kind === "hoisted") && isDeclaredInLoop(path)) {
		        this.reassign(path);
		      }
		      this.clearValue();
		    }
		    var _proto = Binding.prototype;
		    _proto.deoptValue = function deoptValue() {
		      this.clearValue();
		      this.hasDeoptedValue = true;
		    };
		    _proto.setValue = function setValue(value) {
		      if (this.hasDeoptedValue) return;
		      this.hasValue = true;
		      this.value = value;
		    };
		    _proto.clearValue = function clearValue() {
		      this.hasDeoptedValue = false;
		      this.hasValue = false;
		      this.value = null;
		    };
		    _proto.reassign = function reassign(path) {
		      this.constant = false;
		      if (this.constantViolations.indexOf(path) !== -1) {
		        return;
		      }
		      this.constantViolations.push(path);
		    };
		    _proto.reference = function reference(path) {
		      if (this.referencePaths.indexOf(path) !== -1) {
		        return;
		      }
		      this.referenced = true;
		      this.references++;
		      this.referencePaths.push(path);
		    };
		    _proto.dereference = function dereference() {
		      this.references--;
		      this.referenced = !!this.references;
		    };
		    return _createClass(Binding);
		  }();
		  function isDeclaredInLoop(path) {
		    for (var parentPath = path.parentPath, key = path.key; parentPath; _parentPath = parentPath, parentPath = _parentPath.parentPath, key = _parentPath.key, _parentPath) {
		      var _parentPath;
		      if (parentPath.isFunctionParent()) return false;
		      if (parentPath.isWhile() || parentPath.isForXStatement() || parentPath.isForStatement() && key === "body") {
		        return true;
		      }
		    }
		    return false;
		  }

		  var builtin = {
		  	"Array": false,
		  	"ArrayBuffer": false,
		  	Atomics: false,
		  	BigInt: false,
		  	BigInt64Array: false,
		  	BigUint64Array: false,
		  	"Boolean": false,
		  	constructor: false,
		  	"DataView": false,
		  	"Date": false,
		  	"decodeURI": false,
		  	"decodeURIComponent": false,
		  	"encodeURI": false,
		  	"encodeURIComponent": false,
		  	"Error": false,
		  	"escape": false,
		  	"eval": false,
		  	"EvalError": false,
		  	"Float32Array": false,
		  	"Float64Array": false,
		  	"Function": false,
		  	globalThis: false,
		  	hasOwnProperty: false,
		  	"Infinity": false,
		  	"Int16Array": false,
		  	"Int32Array": false,
		  	"Int8Array": false,
		  	"isFinite": false,
		  	"isNaN": false,
		  	isPrototypeOf: false,
		  	"JSON": false,
		  	"Map": false,
		  	"Math": false,
		  	"NaN": false,
		  	"Number": false,
		  	"Object": false,
		  	"parseFloat": false,
		  	"parseInt": false,
		  	"Promise": false,
		  	propertyIsEnumerable: false,
		  	"Proxy": false,
		  	"RangeError": false,
		  	"ReferenceError": false,
		  	"Reflect": false,
		  	"RegExp": false,
		  	"Set": false,
		  	SharedArrayBuffer: false,
		  	"String": false,
		  	"Symbol": false,
		  	"SyntaxError": false,
		  	toLocaleString: false,
		  	toString: false,
		  	"TypeError": false,
		  	"Uint16Array": false,
		  	"Uint32Array": false,
		  	"Uint8Array": false,
		  	"Uint8ClampedArray": false,
		  	"undefined": false,
		  	"unescape": false,
		  	"URIError": false,
		  	valueOf: false,
		  	"WeakMap": false,
		  	"WeakSet": false
		  };
		  var es5 = {
		  	"Array": false,
		  	"Boolean": false,
		  	constructor: false,
		  	"Date": false,
		  	"decodeURI": false,
		  	"decodeURIComponent": false,
		  	"encodeURI": false,
		  	"encodeURIComponent": false,
		  	"Error": false,
		  	"escape": false,
		  	"eval": false,
		  	"EvalError": false,
		  	"Function": false,
		  	hasOwnProperty: false,
		  	"Infinity": false,
		  	"isFinite": false,
		  	"isNaN": false,
		  	isPrototypeOf: false,
		  	"JSON": false,
		  	"Math": false,
		  	"NaN": false,
		  	"Number": false,
		  	"Object": false,
		  	"parseFloat": false,
		  	"parseInt": false,
		  	propertyIsEnumerable: false,
		  	"RangeError": false,
		  	"ReferenceError": false,
		  	"RegExp": false,
		  	"String": false,
		  	"SyntaxError": false,
		  	toLocaleString: false,
		  	toString: false,
		  	"TypeError": false,
		  	"undefined": false,
		  	"unescape": false,
		  	"URIError": false,
		  	valueOf: false
		  };
		  var es2015 = {
		  	"Array": false,
		  	"ArrayBuffer": false,
		  	"Boolean": false,
		  	constructor: false,
		  	"DataView": false,
		  	"Date": false,
		  	"decodeURI": false,
		  	"decodeURIComponent": false,
		  	"encodeURI": false,
		  	"encodeURIComponent": false,
		  	"Error": false,
		  	"escape": false,
		  	"eval": false,
		  	"EvalError": false,
		  	"Float32Array": false,
		  	"Float64Array": false,
		  	"Function": false,
		  	hasOwnProperty: false,
		  	"Infinity": false,
		  	"Int16Array": false,
		  	"Int32Array": false,
		  	"Int8Array": false,
		  	"isFinite": false,
		  	"isNaN": false,
		  	isPrototypeOf: false,
		  	"JSON": false,
		  	"Map": false,
		  	"Math": false,
		  	"NaN": false,
		  	"Number": false,
		  	"Object": false,
		  	"parseFloat": false,
		  	"parseInt": false,
		  	"Promise": false,
		  	propertyIsEnumerable: false,
		  	"Proxy": false,
		  	"RangeError": false,
		  	"ReferenceError": false,
		  	"Reflect": false,
		  	"RegExp": false,
		  	"Set": false,
		  	"String": false,
		  	"Symbol": false,
		  	"SyntaxError": false,
		  	toLocaleString: false,
		  	toString: false,
		  	"TypeError": false,
		  	"Uint16Array": false,
		  	"Uint32Array": false,
		  	"Uint8Array": false,
		  	"Uint8ClampedArray": false,
		  	"undefined": false,
		  	"unescape": false,
		  	"URIError": false,
		  	valueOf: false,
		  	"WeakMap": false,
		  	"WeakSet": false
		  };
		  var es2017 = {
		  	"Array": false,
		  	"ArrayBuffer": false,
		  	Atomics: false,
		  	"Boolean": false,
		  	constructor: false,
		  	"DataView": false,
		  	"Date": false,
		  	"decodeURI": false,
		  	"decodeURIComponent": false,
		  	"encodeURI": false,
		  	"encodeURIComponent": false,
		  	"Error": false,
		  	"escape": false,
		  	"eval": false,
		  	"EvalError": false,
		  	"Float32Array": false,
		  	"Float64Array": false,
		  	"Function": false,
		  	hasOwnProperty: false,
		  	"Infinity": false,
		  	"Int16Array": false,
		  	"Int32Array": false,
		  	"Int8Array": false,
		  	"isFinite": false,
		  	"isNaN": false,
		  	isPrototypeOf: false,
		  	"JSON": false,
		  	"Map": false,
		  	"Math": false,
		  	"NaN": false,
		  	"Number": false,
		  	"Object": false,
		  	"parseFloat": false,
		  	"parseInt": false,
		  	"Promise": false,
		  	propertyIsEnumerable: false,
		  	"Proxy": false,
		  	"RangeError": false,
		  	"ReferenceError": false,
		  	"Reflect": false,
		  	"RegExp": false,
		  	"Set": false,
		  	SharedArrayBuffer: false,
		  	"String": false,
		  	"Symbol": false,
		  	"SyntaxError": false,
		  	toLocaleString: false,
		  	toString: false,
		  	"TypeError": false,
		  	"Uint16Array": false,
		  	"Uint32Array": false,
		  	"Uint8Array": false,
		  	"Uint8ClampedArray": false,
		  	"undefined": false,
		  	"unescape": false,
		  	"URIError": false,
		  	valueOf: false,
		  	"WeakMap": false,
		  	"WeakSet": false
		  };
		  var browser$1 = {
		  	AbortController: false,
		  	AbortSignal: false,
		  	addEventListener: false,
		  	alert: false,
		  	AnalyserNode: false,
		  	Animation: false,
		  	AnimationEffectReadOnly: false,
		  	AnimationEffectTiming: false,
		  	AnimationEffectTimingReadOnly: false,
		  	AnimationEvent: false,
		  	AnimationPlaybackEvent: false,
		  	AnimationTimeline: false,
		  	applicationCache: false,
		  	ApplicationCache: false,
		  	ApplicationCacheErrorEvent: false,
		  	atob: false,
		  	Attr: false,
		  	Audio: false,
		  	AudioBuffer: false,
		  	AudioBufferSourceNode: false,
		  	AudioContext: false,
		  	AudioDestinationNode: false,
		  	AudioListener: false,
		  	AudioNode: false,
		  	AudioParam: false,
		  	AudioProcessingEvent: false,
		  	AudioScheduledSourceNode: false,
		  	"AudioWorkletGlobalScope ": false,
		  	AudioWorkletNode: false,
		  	AudioWorkletProcessor: false,
		  	BarProp: false,
		  	BaseAudioContext: false,
		  	BatteryManager: false,
		  	BeforeUnloadEvent: false,
		  	BiquadFilterNode: false,
		  	Blob: false,
		  	BlobEvent: false,
		  	blur: false,
		  	BroadcastChannel: false,
		  	btoa: false,
		  	BudgetService: false,
		  	ByteLengthQueuingStrategy: false,
		  	Cache: false,
		  	caches: false,
		  	CacheStorage: false,
		  	cancelAnimationFrame: false,
		  	cancelIdleCallback: false,
		  	CanvasCaptureMediaStreamTrack: false,
		  	CanvasGradient: false,
		  	CanvasPattern: false,
		  	CanvasRenderingContext2D: false,
		  	ChannelMergerNode: false,
		  	ChannelSplitterNode: false,
		  	CharacterData: false,
		  	clearInterval: false,
		  	clearTimeout: false,
		  	clientInformation: false,
		  	ClipboardEvent: false,
		  	close: false,
		  	closed: false,
		  	CloseEvent: false,
		  	Comment: false,
		  	CompositionEvent: false,
		  	confirm: false,
		  	console: false,
		  	ConstantSourceNode: false,
		  	ConvolverNode: false,
		  	CountQueuingStrategy: false,
		  	createImageBitmap: false,
		  	Credential: false,
		  	CredentialsContainer: false,
		  	crypto: false,
		  	Crypto: false,
		  	CryptoKey: false,
		  	CSS: false,
		  	CSSConditionRule: false,
		  	CSSFontFaceRule: false,
		  	CSSGroupingRule: false,
		  	CSSImportRule: false,
		  	CSSKeyframeRule: false,
		  	CSSKeyframesRule: false,
		  	CSSMediaRule: false,
		  	CSSNamespaceRule: false,
		  	CSSPageRule: false,
		  	CSSRule: false,
		  	CSSRuleList: false,
		  	CSSStyleDeclaration: false,
		  	CSSStyleRule: false,
		  	CSSStyleSheet: false,
		  	CSSSupportsRule: false,
		  	CustomElementRegistry: false,
		  	customElements: false,
		  	CustomEvent: false,
		  	DataTransfer: false,
		  	DataTransferItem: false,
		  	DataTransferItemList: false,
		  	defaultstatus: false,
		  	defaultStatus: false,
		  	DelayNode: false,
		  	DeviceMotionEvent: false,
		  	DeviceOrientationEvent: false,
		  	devicePixelRatio: false,
		  	dispatchEvent: false,
		  	document: false,
		  	Document: false,
		  	DocumentFragment: false,
		  	DocumentType: false,
		  	DOMError: false,
		  	DOMException: false,
		  	DOMImplementation: false,
		  	DOMMatrix: false,
		  	DOMMatrixReadOnly: false,
		  	DOMParser: false,
		  	DOMPoint: false,
		  	DOMPointReadOnly: false,
		  	DOMQuad: false,
		  	DOMRect: false,
		  	DOMRectReadOnly: false,
		  	DOMStringList: false,
		  	DOMStringMap: false,
		  	DOMTokenList: false,
		  	DragEvent: false,
		  	DynamicsCompressorNode: false,
		  	Element: false,
		  	ErrorEvent: false,
		  	event: false,
		  	Event: false,
		  	EventSource: false,
		  	EventTarget: false,
		  	external: false,
		  	fetch: false,
		  	File: false,
		  	FileList: false,
		  	FileReader: false,
		  	find: false,
		  	focus: false,
		  	FocusEvent: false,
		  	FontFace: false,
		  	FontFaceSetLoadEvent: false,
		  	FormData: false,
		  	frameElement: false,
		  	frames: false,
		  	GainNode: false,
		  	Gamepad: false,
		  	GamepadButton: false,
		  	GamepadEvent: false,
		  	getComputedStyle: false,
		  	getSelection: false,
		  	HashChangeEvent: false,
		  	Headers: false,
		  	history: false,
		  	History: false,
		  	HTMLAllCollection: false,
		  	HTMLAnchorElement: false,
		  	HTMLAreaElement: false,
		  	HTMLAudioElement: false,
		  	HTMLBaseElement: false,
		  	HTMLBodyElement: false,
		  	HTMLBRElement: false,
		  	HTMLButtonElement: false,
		  	HTMLCanvasElement: false,
		  	HTMLCollection: false,
		  	HTMLContentElement: false,
		  	HTMLDataElement: false,
		  	HTMLDataListElement: false,
		  	HTMLDetailsElement: false,
		  	HTMLDialogElement: false,
		  	HTMLDirectoryElement: false,
		  	HTMLDivElement: false,
		  	HTMLDListElement: false,
		  	HTMLDocument: false,
		  	HTMLElement: false,
		  	HTMLEmbedElement: false,
		  	HTMLFieldSetElement: false,
		  	HTMLFontElement: false,
		  	HTMLFormControlsCollection: false,
		  	HTMLFormElement: false,
		  	HTMLFrameElement: false,
		  	HTMLFrameSetElement: false,
		  	HTMLHeadElement: false,
		  	HTMLHeadingElement: false,
		  	HTMLHRElement: false,
		  	HTMLHtmlElement: false,
		  	HTMLIFrameElement: false,
		  	HTMLImageElement: false,
		  	HTMLInputElement: false,
		  	HTMLLabelElement: false,
		  	HTMLLegendElement: false,
		  	HTMLLIElement: false,
		  	HTMLLinkElement: false,
		  	HTMLMapElement: false,
		  	HTMLMarqueeElement: false,
		  	HTMLMediaElement: false,
		  	HTMLMenuElement: false,
		  	HTMLMetaElement: false,
		  	HTMLMeterElement: false,
		  	HTMLModElement: false,
		  	HTMLObjectElement: false,
		  	HTMLOListElement: false,
		  	HTMLOptGroupElement: false,
		  	HTMLOptionElement: false,
		  	HTMLOptionsCollection: false,
		  	HTMLOutputElement: false,
		  	HTMLParagraphElement: false,
		  	HTMLParamElement: false,
		  	HTMLPictureElement: false,
		  	HTMLPreElement: false,
		  	HTMLProgressElement: false,
		  	HTMLQuoteElement: false,
		  	HTMLScriptElement: false,
		  	HTMLSelectElement: false,
		  	HTMLShadowElement: false,
		  	HTMLSlotElement: false,
		  	HTMLSourceElement: false,
		  	HTMLSpanElement: false,
		  	HTMLStyleElement: false,
		  	HTMLTableCaptionElement: false,
		  	HTMLTableCellElement: false,
		  	HTMLTableColElement: false,
		  	HTMLTableElement: false,
		  	HTMLTableRowElement: false,
		  	HTMLTableSectionElement: false,
		  	HTMLTemplateElement: false,
		  	HTMLTextAreaElement: false,
		  	HTMLTimeElement: false,
		  	HTMLTitleElement: false,
		  	HTMLTrackElement: false,
		  	HTMLUListElement: false,
		  	HTMLUnknownElement: false,
		  	HTMLVideoElement: false,
		  	IDBCursor: false,
		  	IDBCursorWithValue: false,
		  	IDBDatabase: false,
		  	IDBFactory: false,
		  	IDBIndex: false,
		  	IDBKeyRange: false,
		  	IDBObjectStore: false,
		  	IDBOpenDBRequest: false,
		  	IDBRequest: false,
		  	IDBTransaction: false,
		  	IDBVersionChangeEvent: false,
		  	IdleDeadline: false,
		  	IIRFilterNode: false,
		  	Image: false,
		  	ImageBitmap: false,
		  	ImageBitmapRenderingContext: false,
		  	ImageCapture: false,
		  	ImageData: false,
		  	indexedDB: false,
		  	innerHeight: false,
		  	innerWidth: false,
		  	InputEvent: false,
		  	IntersectionObserver: false,
		  	IntersectionObserverEntry: false,
		  	"Intl": false,
		  	isSecureContext: false,
		  	KeyboardEvent: false,
		  	KeyframeEffect: false,
		  	KeyframeEffectReadOnly: false,
		  	length: false,
		  	localStorage: false,
		  	location: true,
		  	Location: false,
		  	locationbar: false,
		  	matchMedia: false,
		  	MediaDeviceInfo: false,
		  	MediaDevices: false,
		  	MediaElementAudioSourceNode: false,
		  	MediaEncryptedEvent: false,
		  	MediaError: false,
		  	MediaKeyMessageEvent: false,
		  	MediaKeySession: false,
		  	MediaKeyStatusMap: false,
		  	MediaKeySystemAccess: false,
		  	MediaList: false,
		  	MediaQueryList: false,
		  	MediaQueryListEvent: false,
		  	MediaRecorder: false,
		  	MediaSettingsRange: false,
		  	MediaSource: false,
		  	MediaStream: false,
		  	MediaStreamAudioDestinationNode: false,
		  	MediaStreamAudioSourceNode: false,
		  	MediaStreamEvent: false,
		  	MediaStreamTrack: false,
		  	MediaStreamTrackEvent: false,
		  	menubar: false,
		  	MessageChannel: false,
		  	MessageEvent: false,
		  	MessagePort: false,
		  	MIDIAccess: false,
		  	MIDIConnectionEvent: false,
		  	MIDIInput: false,
		  	MIDIInputMap: false,
		  	MIDIMessageEvent: false,
		  	MIDIOutput: false,
		  	MIDIOutputMap: false,
		  	MIDIPort: false,
		  	MimeType: false,
		  	MimeTypeArray: false,
		  	MouseEvent: false,
		  	moveBy: false,
		  	moveTo: false,
		  	MutationEvent: false,
		  	MutationObserver: false,
		  	MutationRecord: false,
		  	name: false,
		  	NamedNodeMap: false,
		  	NavigationPreloadManager: false,
		  	navigator: false,
		  	Navigator: false,
		  	NetworkInformation: false,
		  	Node: false,
		  	NodeFilter: false,
		  	NodeIterator: false,
		  	NodeList: false,
		  	Notification: false,
		  	OfflineAudioCompletionEvent: false,
		  	OfflineAudioContext: false,
		  	offscreenBuffering: false,
		  	OffscreenCanvas: true,
		  	onabort: true,
		  	onafterprint: true,
		  	onanimationend: true,
		  	onanimationiteration: true,
		  	onanimationstart: true,
		  	onappinstalled: true,
		  	onauxclick: true,
		  	onbeforeinstallprompt: true,
		  	onbeforeprint: true,
		  	onbeforeunload: true,
		  	onblur: true,
		  	oncancel: true,
		  	oncanplay: true,
		  	oncanplaythrough: true,
		  	onchange: true,
		  	onclick: true,
		  	onclose: true,
		  	oncontextmenu: true,
		  	oncuechange: true,
		  	ondblclick: true,
		  	ondevicemotion: true,
		  	ondeviceorientation: true,
		  	ondeviceorientationabsolute: true,
		  	ondrag: true,
		  	ondragend: true,
		  	ondragenter: true,
		  	ondragleave: true,
		  	ondragover: true,
		  	ondragstart: true,
		  	ondrop: true,
		  	ondurationchange: true,
		  	onemptied: true,
		  	onended: true,
		  	onerror: true,
		  	onfocus: true,
		  	ongotpointercapture: true,
		  	onhashchange: true,
		  	oninput: true,
		  	oninvalid: true,
		  	onkeydown: true,
		  	onkeypress: true,
		  	onkeyup: true,
		  	onlanguagechange: true,
		  	onload: true,
		  	onloadeddata: true,
		  	onloadedmetadata: true,
		  	onloadstart: true,
		  	onlostpointercapture: true,
		  	onmessage: true,
		  	onmessageerror: true,
		  	onmousedown: true,
		  	onmouseenter: true,
		  	onmouseleave: true,
		  	onmousemove: true,
		  	onmouseout: true,
		  	onmouseover: true,
		  	onmouseup: true,
		  	onmousewheel: true,
		  	onoffline: true,
		  	ononline: true,
		  	onpagehide: true,
		  	onpageshow: true,
		  	onpause: true,
		  	onplay: true,
		  	onplaying: true,
		  	onpointercancel: true,
		  	onpointerdown: true,
		  	onpointerenter: true,
		  	onpointerleave: true,
		  	onpointermove: true,
		  	onpointerout: true,
		  	onpointerover: true,
		  	onpointerup: true,
		  	onpopstate: true,
		  	onprogress: true,
		  	onratechange: true,
		  	onrejectionhandled: true,
		  	onreset: true,
		  	onresize: true,
		  	onscroll: true,
		  	onsearch: true,
		  	onseeked: true,
		  	onseeking: true,
		  	onselect: true,
		  	onstalled: true,
		  	onstorage: true,
		  	onsubmit: true,
		  	onsuspend: true,
		  	ontimeupdate: true,
		  	ontoggle: true,
		  	ontransitionend: true,
		  	onunhandledrejection: true,
		  	onunload: true,
		  	onvolumechange: true,
		  	onwaiting: true,
		  	onwheel: true,
		  	open: false,
		  	openDatabase: false,
		  	opener: false,
		  	Option: false,
		  	origin: false,
		  	OscillatorNode: false,
		  	outerHeight: false,
		  	outerWidth: false,
		  	PageTransitionEvent: false,
		  	pageXOffset: false,
		  	pageYOffset: false,
		  	PannerNode: false,
		  	parent: false,
		  	Path2D: false,
		  	PaymentAddress: false,
		  	PaymentRequest: false,
		  	PaymentRequestUpdateEvent: false,
		  	PaymentResponse: false,
		  	performance: false,
		  	Performance: false,
		  	PerformanceEntry: false,
		  	PerformanceLongTaskTiming: false,
		  	PerformanceMark: false,
		  	PerformanceMeasure: false,
		  	PerformanceNavigation: false,
		  	PerformanceNavigationTiming: false,
		  	PerformanceObserver: false,
		  	PerformanceObserverEntryList: false,
		  	PerformancePaintTiming: false,
		  	PerformanceResourceTiming: false,
		  	PerformanceTiming: false,
		  	PeriodicWave: false,
		  	Permissions: false,
		  	PermissionStatus: false,
		  	personalbar: false,
		  	PhotoCapabilities: false,
		  	Plugin: false,
		  	PluginArray: false,
		  	PointerEvent: false,
		  	PopStateEvent: false,
		  	postMessage: false,
		  	Presentation: false,
		  	PresentationAvailability: false,
		  	PresentationConnection: false,
		  	PresentationConnectionAvailableEvent: false,
		  	PresentationConnectionCloseEvent: false,
		  	PresentationConnectionList: false,
		  	PresentationReceiver: false,
		  	PresentationRequest: false,
		  	print: false,
		  	ProcessingInstruction: false,
		  	ProgressEvent: false,
		  	PromiseRejectionEvent: false,
		  	prompt: false,
		  	PushManager: false,
		  	PushSubscription: false,
		  	PushSubscriptionOptions: false,
		  	queueMicrotask: false,
		  	RadioNodeList: false,
		  	Range: false,
		  	ReadableStream: false,
		  	registerProcessor: false,
		  	RemotePlayback: false,
		  	removeEventListener: false,
		  	Request: false,
		  	requestAnimationFrame: false,
		  	requestIdleCallback: false,
		  	resizeBy: false,
		  	ResizeObserver: false,
		  	ResizeObserverEntry: false,
		  	resizeTo: false,
		  	Response: false,
		  	RTCCertificate: false,
		  	RTCDataChannel: false,
		  	RTCDataChannelEvent: false,
		  	RTCDtlsTransport: false,
		  	RTCIceCandidate: false,
		  	RTCIceGatherer: false,
		  	RTCIceTransport: false,
		  	RTCPeerConnection: false,
		  	RTCPeerConnectionIceEvent: false,
		  	RTCRtpContributingSource: false,
		  	RTCRtpReceiver: false,
		  	RTCRtpSender: false,
		  	RTCSctpTransport: false,
		  	RTCSessionDescription: false,
		  	RTCStatsReport: false,
		  	RTCTrackEvent: false,
		  	screen: false,
		  	Screen: false,
		  	screenLeft: false,
		  	ScreenOrientation: false,
		  	screenTop: false,
		  	screenX: false,
		  	screenY: false,
		  	ScriptProcessorNode: false,
		  	scroll: false,
		  	scrollbars: false,
		  	scrollBy: false,
		  	scrollTo: false,
		  	scrollX: false,
		  	scrollY: false,
		  	SecurityPolicyViolationEvent: false,
		  	Selection: false,
		  	self: false,
		  	ServiceWorker: false,
		  	ServiceWorkerContainer: false,
		  	ServiceWorkerRegistration: false,
		  	sessionStorage: false,
		  	setInterval: false,
		  	setTimeout: false,
		  	ShadowRoot: false,
		  	SharedWorker: false,
		  	SourceBuffer: false,
		  	SourceBufferList: false,
		  	speechSynthesis: false,
		  	SpeechSynthesisEvent: false,
		  	SpeechSynthesisUtterance: false,
		  	StaticRange: false,
		  	status: false,
		  	statusbar: false,
		  	StereoPannerNode: false,
		  	stop: false,
		  	Storage: false,
		  	StorageEvent: false,
		  	StorageManager: false,
		  	styleMedia: false,
		  	StyleSheet: false,
		  	StyleSheetList: false,
		  	SubtleCrypto: false,
		  	SVGAElement: false,
		  	SVGAngle: false,
		  	SVGAnimatedAngle: false,
		  	SVGAnimatedBoolean: false,
		  	SVGAnimatedEnumeration: false,
		  	SVGAnimatedInteger: false,
		  	SVGAnimatedLength: false,
		  	SVGAnimatedLengthList: false,
		  	SVGAnimatedNumber: false,
		  	SVGAnimatedNumberList: false,
		  	SVGAnimatedPreserveAspectRatio: false,
		  	SVGAnimatedRect: false,
		  	SVGAnimatedString: false,
		  	SVGAnimatedTransformList: false,
		  	SVGAnimateElement: false,
		  	SVGAnimateMotionElement: false,
		  	SVGAnimateTransformElement: false,
		  	SVGAnimationElement: false,
		  	SVGCircleElement: false,
		  	SVGClipPathElement: false,
		  	SVGComponentTransferFunctionElement: false,
		  	SVGDefsElement: false,
		  	SVGDescElement: false,
		  	SVGDiscardElement: false,
		  	SVGElement: false,
		  	SVGEllipseElement: false,
		  	SVGFEBlendElement: false,
		  	SVGFEColorMatrixElement: false,
		  	SVGFEComponentTransferElement: false,
		  	SVGFECompositeElement: false,
		  	SVGFEConvolveMatrixElement: false,
		  	SVGFEDiffuseLightingElement: false,
		  	SVGFEDisplacementMapElement: false,
		  	SVGFEDistantLightElement: false,
		  	SVGFEDropShadowElement: false,
		  	SVGFEFloodElement: false,
		  	SVGFEFuncAElement: false,
		  	SVGFEFuncBElement: false,
		  	SVGFEFuncGElement: false,
		  	SVGFEFuncRElement: false,
		  	SVGFEGaussianBlurElement: false,
		  	SVGFEImageElement: false,
		  	SVGFEMergeElement: false,
		  	SVGFEMergeNodeElement: false,
		  	SVGFEMorphologyElement: false,
		  	SVGFEOffsetElement: false,
		  	SVGFEPointLightElement: false,
		  	SVGFESpecularLightingElement: false,
		  	SVGFESpotLightElement: false,
		  	SVGFETileElement: false,
		  	SVGFETurbulenceElement: false,
		  	SVGFilterElement: false,
		  	SVGForeignObjectElement: false,
		  	SVGGElement: false,
		  	SVGGeometryElement: false,
		  	SVGGradientElement: false,
		  	SVGGraphicsElement: false,
		  	SVGImageElement: false,
		  	SVGLength: false,
		  	SVGLengthList: false,
		  	SVGLinearGradientElement: false,
		  	SVGLineElement: false,
		  	SVGMarkerElement: false,
		  	SVGMaskElement: false,
		  	SVGMatrix: false,
		  	SVGMetadataElement: false,
		  	SVGMPathElement: false,
		  	SVGNumber: false,
		  	SVGNumberList: false,
		  	SVGPathElement: false,
		  	SVGPatternElement: false,
		  	SVGPoint: false,
		  	SVGPointList: false,
		  	SVGPolygonElement: false,
		  	SVGPolylineElement: false,
		  	SVGPreserveAspectRatio: false,
		  	SVGRadialGradientElement: false,
		  	SVGRect: false,
		  	SVGRectElement: false,
		  	SVGScriptElement: false,
		  	SVGSetElement: false,
		  	SVGStopElement: false,
		  	SVGStringList: false,
		  	SVGStyleElement: false,
		  	SVGSVGElement: false,
		  	SVGSwitchElement: false,
		  	SVGSymbolElement: false,
		  	SVGTextContentElement: false,
		  	SVGTextElement: false,
		  	SVGTextPathElement: false,
		  	SVGTextPositioningElement: false,
		  	SVGTitleElement: false,
		  	SVGTransform: false,
		  	SVGTransformList: false,
		  	SVGTSpanElement: false,
		  	SVGUnitTypes: false,
		  	SVGUseElement: false,
		  	SVGViewElement: false,
		  	TaskAttributionTiming: false,
		  	Text: false,
		  	TextDecoder: false,
		  	TextEncoder: false,
		  	TextEvent: false,
		  	TextMetrics: false,
		  	TextTrack: false,
		  	TextTrackCue: false,
		  	TextTrackCueList: false,
		  	TextTrackList: false,
		  	TimeRanges: false,
		  	toolbar: false,
		  	top: false,
		  	Touch: false,
		  	TouchEvent: false,
		  	TouchList: false,
		  	TrackEvent: false,
		  	TransitionEvent: false,
		  	TreeWalker: false,
		  	UIEvent: false,
		  	URL: false,
		  	URLSearchParams: false,
		  	ValidityState: false,
		  	visualViewport: false,
		  	VisualViewport: false,
		  	VTTCue: false,
		  	WaveShaperNode: false,
		  	WebAssembly: false,
		  	WebGL2RenderingContext: false,
		  	WebGLActiveInfo: false,
		  	WebGLBuffer: false,
		  	WebGLContextEvent: false,
		  	WebGLFramebuffer: false,
		  	WebGLProgram: false,
		  	WebGLQuery: false,
		  	WebGLRenderbuffer: false,
		  	WebGLRenderingContext: false,
		  	WebGLSampler: false,
		  	WebGLShader: false,
		  	WebGLShaderPrecisionFormat: false,
		  	WebGLSync: false,
		  	WebGLTexture: false,
		  	WebGLTransformFeedback: false,
		  	WebGLUniformLocation: false,
		  	WebGLVertexArrayObject: false,
		  	WebSocket: false,
		  	WheelEvent: false,
		  	window: false,
		  	Window: false,
		  	Worker: false,
		  	WritableStream: false,
		  	XMLDocument: false,
		  	XMLHttpRequest: false,
		  	XMLHttpRequestEventTarget: false,
		  	XMLHttpRequestUpload: false,
		  	XMLSerializer: false,
		  	XPathEvaluator: false,
		  	XPathExpression: false,
		  	XPathResult: false,
		  	XSLTProcessor: false
		  };
		  var worker = {
		  	addEventListener: false,
		  	applicationCache: false,
		  	atob: false,
		  	Blob: false,
		  	BroadcastChannel: false,
		  	btoa: false,
		  	Cache: false,
		  	caches: false,
		  	clearInterval: false,
		  	clearTimeout: false,
		  	close: true,
		  	console: false,
		  	fetch: false,
		  	FileReaderSync: false,
		  	FormData: false,
		  	Headers: false,
		  	IDBCursor: false,
		  	IDBCursorWithValue: false,
		  	IDBDatabase: false,
		  	IDBFactory: false,
		  	IDBIndex: false,
		  	IDBKeyRange: false,
		  	IDBObjectStore: false,
		  	IDBOpenDBRequest: false,
		  	IDBRequest: false,
		  	IDBTransaction: false,
		  	IDBVersionChangeEvent: false,
		  	ImageData: false,
		  	importScripts: true,
		  	indexedDB: false,
		  	location: false,
		  	MessageChannel: false,
		  	MessagePort: false,
		  	name: false,
		  	navigator: false,
		  	Notification: false,
		  	onclose: true,
		  	onconnect: true,
		  	onerror: true,
		  	onlanguagechange: true,
		  	onmessage: true,
		  	onoffline: true,
		  	ononline: true,
		  	onrejectionhandled: true,
		  	onunhandledrejection: true,
		  	performance: false,
		  	Performance: false,
		  	PerformanceEntry: false,
		  	PerformanceMark: false,
		  	PerformanceMeasure: false,
		  	PerformanceNavigation: false,
		  	PerformanceResourceTiming: false,
		  	PerformanceTiming: false,
		  	postMessage: true,
		  	"Promise": false,
		  	queueMicrotask: false,
		  	removeEventListener: false,
		  	Request: false,
		  	Response: false,
		  	self: true,
		  	ServiceWorkerRegistration: false,
		  	setInterval: false,
		  	setTimeout: false,
		  	TextDecoder: false,
		  	TextEncoder: false,
		  	URL: false,
		  	URLSearchParams: false,
		  	WebSocket: false,
		  	Worker: false,
		  	WorkerGlobalScope: false,
		  	XMLHttpRequest: false
		  };
		  var node$1 = {
		  	__dirname: false,
		  	__filename: false,
		  	Buffer: false,
		  	clearImmediate: false,
		  	clearInterval: false,
		  	clearTimeout: false,
		  	console: false,
		  	exports: true,
		  	global: false,
		  	"Intl": false,
		  	module: false,
		  	process: false,
		  	queueMicrotask: false,
		  	require: false,
		  	setImmediate: false,
		  	setInterval: false,
		  	setTimeout: false,
		  	TextDecoder: false,
		  	TextEncoder: false,
		  	URL: false,
		  	URLSearchParams: false
		  };
		  var commonjs = {
		  	exports: true,
		  	global: false,
		  	module: false,
		  	require: false
		  };
		  var amd = {
		  	define: false,
		  	require: false
		  };
		  var mocha = {
		  	after: false,
		  	afterEach: false,
		  	before: false,
		  	beforeEach: false,
		  	context: false,
		  	describe: false,
		  	it: false,
		  	mocha: false,
		  	run: false,
		  	setup: false,
		  	specify: false,
		  	suite: false,
		  	suiteSetup: false,
		  	suiteTeardown: false,
		  	teardown: false,
		  	test: false,
		  	xcontext: false,
		  	xdescribe: false,
		  	xit: false,
		  	xspecify: false
		  };
		  var jasmine = {
		  	afterAll: false,
		  	afterEach: false,
		  	beforeAll: false,
		  	beforeEach: false,
		  	describe: false,
		  	expect: false,
		  	fail: false,
		  	fdescribe: false,
		  	fit: false,
		  	it: false,
		  	jasmine: false,
		  	pending: false,
		  	runs: false,
		  	spyOn: false,
		  	spyOnProperty: false,
		  	waits: false,
		  	waitsFor: false,
		  	xdescribe: false,
		  	xit: false
		  };
		  var jest = {
		  	afterAll: false,
		  	afterEach: false,
		  	beforeAll: false,
		  	beforeEach: false,
		  	describe: false,
		  	expect: false,
		  	fdescribe: false,
		  	fit: false,
		  	it: false,
		  	jest: false,
		  	pit: false,
		  	require: false,
		  	test: false,
		  	xdescribe: false,
		  	xit: false,
		  	xtest: false
		  };
		  var qunit = {
		  	asyncTest: false,
		  	deepEqual: false,
		  	equal: false,
		  	expect: false,
		  	module: false,
		  	notDeepEqual: false,
		  	notEqual: false,
		  	notOk: false,
		  	notPropEqual: false,
		  	notStrictEqual: false,
		  	ok: false,
		  	propEqual: false,
		  	QUnit: false,
		  	raises: false,
		  	start: false,
		  	stop: false,
		  	strictEqual: false,
		  	test: false,
		  	throws: false
		  };
		  var phantomjs = {
		  	console: true,
		  	exports: true,
		  	phantom: true,
		  	require: true,
		  	WebPage: true
		  };
		  var couch = {
		  	emit: false,
		  	exports: false,
		  	getRow: false,
		  	log: false,
		  	module: false,
		  	provides: false,
		  	require: false,
		  	respond: false,
		  	send: false,
		  	start: false,
		  	sum: false
		  };
		  var rhino = {
		  	defineClass: false,
		  	deserialize: false,
		  	gc: false,
		  	help: false,
		  	importClass: false,
		  	importPackage: false,
		  	java: false,
		  	load: false,
		  	loadClass: false,
		  	Packages: false,
		  	print: false,
		  	quit: false,
		  	readFile: false,
		  	readUrl: false,
		  	runCommand: false,
		  	seal: false,
		  	serialize: false,
		  	spawn: false,
		  	sync: false,
		  	toint32: false,
		  	version: false
		  };
		  var nashorn = {
		  	__DIR__: false,
		  	__FILE__: false,
		  	__LINE__: false,
		  	com: false,
		  	edu: false,
		  	exit: false,
		  	java: false,
		  	Java: false,
		  	javafx: false,
		  	JavaImporter: false,
		  	javax: false,
		  	JSAdapter: false,
		  	load: false,
		  	loadWithNewGlobal: false,
		  	org: false,
		  	Packages: false,
		  	print: false,
		  	quit: false
		  };
		  var wsh = {
		  	ActiveXObject: true,
		  	Enumerator: true,
		  	GetObject: true,
		  	ScriptEngine: true,
		  	ScriptEngineBuildVersion: true,
		  	ScriptEngineMajorVersion: true,
		  	ScriptEngineMinorVersion: true,
		  	VBArray: true,
		  	WScript: true,
		  	WSH: true,
		  	XDomainRequest: true
		  };
		  var jquery = {
		  	$: false,
		  	jQuery: false
		  };
		  var yui = {
		  	YAHOO: false,
		  	YAHOO_config: false,
		  	YUI: false,
		  	YUI_config: false
		  };
		  var shelljs = {
		  	cat: false,
		  	cd: false,
		  	chmod: false,
		  	config: false,
		  	cp: false,
		  	dirs: false,
		  	echo: false,
		  	env: false,
		  	error: false,
		  	exec: false,
		  	exit: false,
		  	find: false,
		  	grep: false,
		  	ln: false,
		  	ls: false,
		  	mkdir: false,
		  	mv: false,
		  	popd: false,
		  	pushd: false,
		  	pwd: false,
		  	rm: false,
		  	sed: false,
		  	set: false,
		  	target: false,
		  	tempdir: false,
		  	test: false,
		  	touch: false,
		  	which: false
		  };
		  var prototypejs = {
		  	$: false,
		  	$$: false,
		  	$A: false,
		  	$break: false,
		  	$continue: false,
		  	$F: false,
		  	$H: false,
		  	$R: false,
		  	$w: false,
		  	Abstract: false,
		  	Ajax: false,
		  	Autocompleter: false,
		  	Builder: false,
		  	Class: false,
		  	Control: false,
		  	Draggable: false,
		  	Draggables: false,
		  	Droppables: false,
		  	Effect: false,
		  	Element: false,
		  	Enumerable: false,
		  	Event: false,
		  	Field: false,
		  	Form: false,
		  	Hash: false,
		  	Insertion: false,
		  	ObjectRange: false,
		  	PeriodicalExecuter: false,
		  	Position: false,
		  	Prototype: false,
		  	Scriptaculous: false,
		  	Selector: false,
		  	Sortable: false,
		  	SortableObserver: false,
		  	Sound: false,
		  	Template: false,
		  	Toggle: false,
		  	Try: false
		  };
		  var meteor = {
		  	_: false,
		  	$: false,
		  	Accounts: false,
		  	AccountsClient: false,
		  	AccountsCommon: false,
		  	AccountsServer: false,
		  	App: false,
		  	Assets: false,
		  	Blaze: false,
		  	check: false,
		  	Cordova: false,
		  	DDP: false,
		  	DDPRateLimiter: false,
		  	DDPServer: false,
		  	Deps: false,
		  	EJSON: false,
		  	Email: false,
		  	HTTP: false,
		  	Log: false,
		  	Match: false,
		  	Meteor: false,
		  	Mongo: false,
		  	MongoInternals: false,
		  	Npm: false,
		  	Package: false,
		  	Plugin: false,
		  	process: false,
		  	Random: false,
		  	ReactiveDict: false,
		  	ReactiveVar: false,
		  	Router: false,
		  	ServiceConfiguration: false,
		  	Session: false,
		  	share: false,
		  	Spacebars: false,
		  	Template: false,
		  	Tinytest: false,
		  	Tracker: false,
		  	UI: false,
		  	Utils: false,
		  	WebApp: false,
		  	WebAppInternals: false
		  };
		  var mongo = {
		  	_isWindows: false,
		  	_rand: false,
		  	BulkWriteResult: false,
		  	cat: false,
		  	cd: false,
		  	connect: false,
		  	db: false,
		  	getHostName: false,
		  	getMemInfo: false,
		  	hostname: false,
		  	ISODate: false,
		  	listFiles: false,
		  	load: false,
		  	ls: false,
		  	md5sumFile: false,
		  	mkdir: false,
		  	Mongo: false,
		  	NumberInt: false,
		  	NumberLong: false,
		  	ObjectId: false,
		  	PlanCache: false,
		  	print: false,
		  	printjson: false,
		  	pwd: false,
		  	quit: false,
		  	removeFile: false,
		  	rs: false,
		  	sh: false,
		  	UUID: false,
		  	version: false,
		  	WriteResult: false
		  };
		  var applescript = {
		  	$: false,
		  	Application: false,
		  	Automation: false,
		  	console: false,
		  	delay: false,
		  	Library: false,
		  	ObjC: false,
		  	ObjectSpecifier: false,
		  	Path: false,
		  	Progress: false,
		  	Ref: false
		  };
		  var serviceworker = {
		  	addEventListener: false,
		  	applicationCache: false,
		  	atob: false,
		  	Blob: false,
		  	BroadcastChannel: false,
		  	btoa: false,
		  	Cache: false,
		  	caches: false,
		  	CacheStorage: false,
		  	clearInterval: false,
		  	clearTimeout: false,
		  	Client: false,
		  	clients: false,
		  	Clients: false,
		  	close: true,
		  	console: false,
		  	ExtendableEvent: false,
		  	ExtendableMessageEvent: false,
		  	fetch: false,
		  	FetchEvent: false,
		  	FileReaderSync: false,
		  	FormData: false,
		  	Headers: false,
		  	IDBCursor: false,
		  	IDBCursorWithValue: false,
		  	IDBDatabase: false,
		  	IDBFactory: false,
		  	IDBIndex: false,
		  	IDBKeyRange: false,
		  	IDBObjectStore: false,
		  	IDBOpenDBRequest: false,
		  	IDBRequest: false,
		  	IDBTransaction: false,
		  	IDBVersionChangeEvent: false,
		  	ImageData: false,
		  	importScripts: false,
		  	indexedDB: false,
		  	location: false,
		  	MessageChannel: false,
		  	MessagePort: false,
		  	name: false,
		  	navigator: false,
		  	Notification: false,
		  	onclose: true,
		  	onconnect: true,
		  	onerror: true,
		  	onfetch: true,
		  	oninstall: true,
		  	onlanguagechange: true,
		  	onmessage: true,
		  	onmessageerror: true,
		  	onnotificationclick: true,
		  	onnotificationclose: true,
		  	onoffline: true,
		  	ononline: true,
		  	onpush: true,
		  	onpushsubscriptionchange: true,
		  	onrejectionhandled: true,
		  	onsync: true,
		  	onunhandledrejection: true,
		  	performance: false,
		  	Performance: false,
		  	PerformanceEntry: false,
		  	PerformanceMark: false,
		  	PerformanceMeasure: false,
		  	PerformanceNavigation: false,
		  	PerformanceResourceTiming: false,
		  	PerformanceTiming: false,
		  	postMessage: true,
		  	"Promise": false,
		  	queueMicrotask: false,
		  	registration: false,
		  	removeEventListener: false,
		  	Request: false,
		  	Response: false,
		  	self: false,
		  	ServiceWorker: false,
		  	ServiceWorkerContainer: false,
		  	ServiceWorkerGlobalScope: false,
		  	ServiceWorkerMessageEvent: false,
		  	ServiceWorkerRegistration: false,
		  	setInterval: false,
		  	setTimeout: false,
		  	skipWaiting: false,
		  	TextDecoder: false,
		  	TextEncoder: false,
		  	URL: false,
		  	URLSearchParams: false,
		  	WebSocket: false,
		  	WindowClient: false,
		  	Worker: false,
		  	WorkerGlobalScope: false,
		  	XMLHttpRequest: false
		  };
		  var atomtest = {
		  	advanceClock: false,
		  	fakeClearInterval: false,
		  	fakeClearTimeout: false,
		  	fakeSetInterval: false,
		  	fakeSetTimeout: false,
		  	resetTimeouts: false,
		  	waitsForPromise: false
		  };
		  var embertest = {
		  	andThen: false,
		  	click: false,
		  	currentPath: false,
		  	currentRouteName: false,
		  	currentURL: false,
		  	fillIn: false,
		  	find: false,
		  	findAll: false,
		  	findWithAssert: false,
		  	keyEvent: false,
		  	pauseTest: false,
		  	resumeTest: false,
		  	triggerEvent: false,
		  	visit: false,
		  	wait: false
		  };
		  var protractor = {
		  	$: false,
		  	$$: false,
		  	browser: false,
		  	by: false,
		  	By: false,
		  	DartObject: false,
		  	element: false,
		  	protractor: false
		  };
		  var webextensions = {
		  	browser: false,
		  	chrome: false,
		  	opr: false
		  };
		  var greasemonkey = {
		  	cloneInto: false,
		  	createObjectIn: false,
		  	exportFunction: false,
		  	GM: false,
		  	GM_addStyle: false,
		  	GM_deleteValue: false,
		  	GM_getResourceText: false,
		  	GM_getResourceURL: false,
		  	GM_getValue: false,
		  	GM_info: false,
		  	GM_listValues: false,
		  	GM_log: false,
		  	GM_openInTab: false,
		  	GM_registerMenuCommand: false,
		  	GM_setClipboard: false,
		  	GM_setValue: false,
		  	GM_xmlhttpRequest: false,
		  	unsafeWindow: false
		  };
		  var devtools = {
		  	$: false,
		  	$_: false,
		  	$$: false,
		  	$0: false,
		  	$1: false,
		  	$2: false,
		  	$3: false,
		  	$4: false,
		  	$x: false,
		  	chrome: false,
		  	clear: false,
		  	copy: false,
		  	debug: false,
		  	dir: false,
		  	dirxml: false,
		  	getEventListeners: false,
		  	inspect: false,
		  	keys: false,
		  	monitor: false,
		  	monitorEvents: false,
		  	profile: false,
		  	profileEnd: false,
		  	queryObjects: false,
		  	table: false,
		  	undebug: false,
		  	unmonitor: false,
		  	unmonitorEvents: false,
		  	values: false
		  };
		  var require$$0$9 = {
		  	builtin: builtin,
		  	es5: es5,
		  	es2015: es2015,
		  	es2017: es2017,
		  	browser: browser$1,
		  	worker: worker,
		  	node: node$1,
		  	commonjs: commonjs,
		  	amd: amd,
		  	mocha: mocha,
		  	jasmine: jasmine,
		  	jest: jest,
		  	qunit: qunit,
		  	phantomjs: phantomjs,
		  	couch: couch,
		  	rhino: rhino,
		  	nashorn: nashorn,
		  	wsh: wsh,
		  	jquery: jquery,
		  	yui: yui,
		  	shelljs: shelljs,
		  	prototypejs: prototypejs,
		  	meteor: meteor,
		  	mongo: mongo,
		  	applescript: applescript,
		  	serviceworker: serviceworker,
		  	atomtest: atomtest,
		  	embertest: embertest,
		  	protractor: protractor,
		  	"shared-node-browser": {
		  	clearInterval: false,
		  	clearTimeout: false,
		  	console: false,
		  	setInterval: false,
		  	setTimeout: false,
		  	URL: false,
		  	URLSearchParams: false
		  },
		  	webextensions: webextensions,
		  	greasemonkey: greasemonkey,
		  	devtools: devtools
		  };

		  var globalsBABEL_8_BREAKINGFalse;
		  var hasRequiredGlobalsBABEL_8_BREAKINGFalse;
		  function requireGlobalsBABEL_8_BREAKINGFalse() {
		    if (hasRequiredGlobalsBABEL_8_BREAKINGFalse) return globalsBABEL_8_BREAKINGFalse;
		    hasRequiredGlobalsBABEL_8_BREAKINGFalse = 1;
		    globalsBABEL_8_BREAKINGFalse = require$$0$9;
		    return globalsBABEL_8_BREAKINGFalse;
		  }

		  function bool$a(value) {
		    if (value == null) return false;
		    return value && value !== "false" && value !== "0";
		  }
		  var globals$1 = bool$a(browser$1$1.env["BABEL_8_BREAKING"]) ? requireGlobalsBABEL_8_BREAKINGFalse() : requireGlobalsBABEL_8_BREAKINGFalse();

		  var NOT_LOCAL_BINDING$1 = NOT_LOCAL_BINDING$2,
		    callExpression$c = callExpression$d,
		    cloneNode$h = cloneNode$j,
		    getBindingIdentifiers$3 = getBindingIdentifiers$4,
		    identifier$h = identifier$j,
		    isArrayExpression$1 = isArrayExpression$2,
		    isBinary$1 = isBinary$2,
		    isCallExpression$7 = isCallExpression$8,
		    isClass = isClass$1,
		    isClassBody$1 = isClassBody$2,
		    isClassDeclaration$1 = isClassDeclaration$2,
		    isExportAllDeclaration = isExportAllDeclaration$1,
		    isExportDefaultDeclaration$1 = isExportDefaultDeclaration$2,
		    isExportNamedDeclaration$2 = isExportNamedDeclaration$3,
		    isFunctionDeclaration$1 = isFunctionDeclaration$2,
		    isIdentifier$g = isIdentifier$i,
		    isImportDeclaration$1 = isImportDeclaration$3,
		    isLiteral$5 = isLiteral$6,
		    isMemberExpression$7 = isMemberExpression$9,
		    isMethod = isMethod$1,
		    isModuleSpecifier = isModuleSpecifier$1,
		    isNullLiteral$1 = isNullLiteral$2,
		    isObjectExpression$2 = isObjectExpression$3,
		    isProperty = isProperty$1,
		    isPureish$1 = isPureish$2,
		    isRegExpLiteral$1 = isRegExpLiteral$2,
		    isSuper$2 = isSuper$3,
		    isTaggedTemplateExpression = isTaggedTemplateExpression$1,
		    isTemplateLiteral$1 = isTemplateLiteral$2,
		    isThisExpression$1 = isThisExpression$2,
		    isUnaryExpression = isUnaryExpression$1,
		    isVariableDeclaration$2 = isVariableDeclaration$4,
		    matchesPattern$1 = matchesPattern$2,
		    memberExpression$b = memberExpression$c,
		    numericLiteral$7 = numericLiteral$8,
		    toIdentifier = toIdentifier$1,
		    variableDeclaration$6 = variableDeclaration$8,
		    variableDeclarator$6 = variableDeclarator$8,
		    isRecordExpression = isRecordExpression$1,
		    isTupleExpression = isTupleExpression$1,
		    isObjectProperty$3 = isObjectProperty$4,
		    isTopicReference = isTopicReference$1,
		    isMetaProperty = isMetaProperty$1,
		    isPrivateName$2 = isPrivateName$3,
		    isExportDeclaration$1 = isExportDeclaration$3,
		    _buildUndefinedNode = buildUndefinedNode$2;
		  function gatherNodeParts(node, parts) {
		    switch (node == null ? void 0 : node.type) {
		      default:
		        if (isImportDeclaration$1(node) || isExportDeclaration$1(node)) {
		          var _node$specifiers;
		          if ((isExportAllDeclaration(node) || isExportNamedDeclaration$2(node) || isImportDeclaration$1(node)) && node.source) {
		            gatherNodeParts(node.source, parts);
		          } else if ((isExportNamedDeclaration$2(node) || isImportDeclaration$1(node)) && (_node$specifiers = node.specifiers) != null && _node$specifiers.length) {
		            for (var _iterator = _createForOfIteratorHelperLoose(node.specifiers), _step; !(_step = _iterator()).done;) {
		              var e = _step.value;
		              gatherNodeParts(e, parts);
		            }
		          } else if ((isExportDefaultDeclaration$1(node) || isExportNamedDeclaration$2(node)) && node.declaration) {
		            gatherNodeParts(node.declaration, parts);
		          }
		        } else if (isModuleSpecifier(node)) {
		          gatherNodeParts(node.local, parts);
		        } else if (isLiteral$5(node) && !isNullLiteral$1(node) && !isRegExpLiteral$1(node) && !isTemplateLiteral$1(node)) {
		          parts.push(node.value);
		        }
		        break;
		      case "MemberExpression":
		      case "OptionalMemberExpression":
		      case "JSXMemberExpression":
		        gatherNodeParts(node.object, parts);
		        gatherNodeParts(node.property, parts);
		        break;
		      case "Identifier":
		      case "JSXIdentifier":
		        parts.push(node.name);
		        break;
		      case "CallExpression":
		      case "OptionalCallExpression":
		      case "NewExpression":
		        gatherNodeParts(node.callee, parts);
		        break;
		      case "ObjectExpression":
		      case "ObjectPattern":
		        for (var _iterator2 = _createForOfIteratorHelperLoose(node.properties), _step2; !(_step2 = _iterator2()).done;) {
		          var _e = _step2.value;
		          gatherNodeParts(_e, parts);
		        }
		        break;
		      case "SpreadElement":
		      case "RestElement":
		        gatherNodeParts(node.argument, parts);
		        break;
		      case "ObjectProperty":
		      case "ObjectMethod":
		      case "ClassProperty":
		      case "ClassMethod":
		      case "ClassPrivateProperty":
		      case "ClassPrivateMethod":
		        gatherNodeParts(node.key, parts);
		        break;
		      case "ThisExpression":
		        parts.push("this");
		        break;
		      case "Super":
		        parts.push("super");
		        break;
		      case "Import":
		        parts.push("import");
		        break;
		      case "DoExpression":
		        parts.push("do");
		        break;
		      case "YieldExpression":
		        parts.push("yield");
		        gatherNodeParts(node.argument, parts);
		        break;
		      case "AwaitExpression":
		        parts.push("await");
		        gatherNodeParts(node.argument, parts);
		        break;
		      case "AssignmentExpression":
		        gatherNodeParts(node.left, parts);
		        break;
		      case "VariableDeclarator":
		        gatherNodeParts(node.id, parts);
		        break;
		      case "FunctionExpression":
		      case "FunctionDeclaration":
		      case "ClassExpression":
		      case "ClassDeclaration":
		        gatherNodeParts(node.id, parts);
		        break;
		      case "PrivateName":
		        gatherNodeParts(node.id, parts);
		        break;
		      case "ParenthesizedExpression":
		        gatherNodeParts(node.expression, parts);
		        break;
		      case "UnaryExpression":
		      case "UpdateExpression":
		        gatherNodeParts(node.argument, parts);
		        break;
		      case "MetaProperty":
		        gatherNodeParts(node.meta, parts);
		        gatherNodeParts(node.property, parts);
		        break;
		      case "JSXElement":
		        gatherNodeParts(node.openingElement, parts);
		        break;
		      case "JSXOpeningElement":
		        gatherNodeParts(node.name, parts);
		        break;
		      case "JSXFragment":
		        gatherNodeParts(node.openingFragment, parts);
		        break;
		      case "JSXOpeningFragment":
		        parts.push("Fragment");
		        break;
		      case "JSXNamespacedName":
		        gatherNodeParts(node.namespace, parts);
		        gatherNodeParts(node.name, parts);
		        break;
		    }
		  }
		  var collectorVisitor = {
		    ForStatement: function ForStatement(path) {
		      var declar = path.get("init");
		      if (declar.isVar()) {
		        var scope = path.scope;
		        var parentScope = scope.getFunctionParent() || scope.getProgramParent();
		        parentScope.registerBinding("var", declar);
		      }
		    },
		    Declaration: function Declaration(path) {
		      if (path.isBlockScoped()) return;
		      if (path.isImportDeclaration()) return;
		      if (path.isExportDeclaration()) return;
		      var parent = path.scope.getFunctionParent() || path.scope.getProgramParent();
		      parent.registerDeclaration(path);
		    },
		    ImportDeclaration: function ImportDeclaration(path) {
		      var parent = path.scope.getBlockParent();
		      parent.registerDeclaration(path);
		    },
		    ReferencedIdentifier: function ReferencedIdentifier(path, state) {
		      state.references.push(path);
		    },
		    ForXStatement: function ForXStatement(path, state) {
		      var left = path.get("left");
		      if (left.isPattern() || left.isIdentifier()) {
		        state.constantViolations.push(path);
		      } else if (left.isVar()) {
		        var scope = path.scope;
		        var parentScope = scope.getFunctionParent() || scope.getProgramParent();
		        parentScope.registerBinding("var", left);
		      }
		    },
		    ExportDeclaration: {
		      exit: function exit(path) {
		        var node = path.node,
		          scope = path.scope;
		        if (isExportAllDeclaration(node)) return;
		        var declar = node.declaration;
		        if (isClassDeclaration$1(declar) || isFunctionDeclaration$1(declar)) {
		          var id = declar.id;
		          if (!id) return;
		          var binding = scope.getBinding(id.name);
		          binding == null || binding.reference(path);
		        } else if (isVariableDeclaration$2(declar)) {
		          for (var _iterator3 = _createForOfIteratorHelperLoose(declar.declarations), _step3; !(_step3 = _iterator3()).done;) {
		            var decl = _step3.value;
		            for (var _i = 0, _Object$keys = Object.keys(getBindingIdentifiers$3(decl)); _i < _Object$keys.length; _i++) {
		              var _name = _Object$keys[_i];
		              var _binding = scope.getBinding(_name);
		              _binding == null || _binding.reference(path);
		            }
		          }
		        }
		      }
		    },
		    LabeledStatement: function LabeledStatement(path) {
		      path.scope.getBlockParent().registerDeclaration(path);
		    },
		    AssignmentExpression: function AssignmentExpression(path, state) {
		      state.assignments.push(path);
		    },
		    UpdateExpression: function UpdateExpression(path, state) {
		      state.constantViolations.push(path);
		    },
		    UnaryExpression: function UnaryExpression(path, state) {
		      if (path.node.operator === "delete") {
		        state.constantViolations.push(path);
		      }
		    },
		    BlockScoped: function BlockScoped(path) {
		      var scope = path.scope;
		      if (scope.path === path) scope = scope.parent;
		      var parent = scope.getBlockParent();
		      parent.registerDeclaration(path);
		      if (path.isClassDeclaration() && path.node.id) {
		        var id = path.node.id;
		        var _name2 = id.name;
		        path.scope.bindings[_name2] = path.scope.parent.getBinding(_name2);
		      }
		    },
		    CatchClause: function CatchClause(path) {
		      path.scope.registerBinding("let", path);
		    },
		    Function: function Function(path) {
		      var params = path.get("params");
		      for (var _iterator4 = _createForOfIteratorHelperLoose(params), _step4; !(_step4 = _iterator4()).done;) {
		        var param = _step4.value;
		        path.scope.registerBinding("param", param);
		      }
		      if (path.isFunctionExpression() && path.has("id") && !path.get("id").node[NOT_LOCAL_BINDING$1]) {
		        path.scope.registerBinding("local", path.get("id"), path);
		      }
		    },
		    ClassExpression: function ClassExpression(path) {
		      if (path.has("id") && !path.get("id").node[NOT_LOCAL_BINDING$1]) {
		        path.scope.registerBinding("local", path);
		      }
		    },
		    TSTypeAnnotation: function TSTypeAnnotation(path) {
		      path.skip();
		    }
		  };
		  var uid = 0;
		  var Scope$1 = function () {
		    function Scope(path) {
		      this.uid = void 0;
		      this.path = void 0;
		      this.block = void 0;
		      this.labels = void 0;
		      this.inited = void 0;
		      this.bindings = void 0;
		      this.references = void 0;
		      this.globals = void 0;
		      this.uids = void 0;
		      this.data = void 0;
		      this.crawling = void 0;
		      var node = path.node;
		      var cached = scope.get(node);
		      if ((cached == null ? void 0 : cached.path) === path) {
		        return cached;
		      }
		      scope.set(node, this);
		      this.uid = uid++;
		      this.block = node;
		      this.path = path;
		      this.labels = new Map();
		      this.inited = false;
		    }
		    var _proto = Scope.prototype;
		    _proto.traverse = function traverse$1(node, opts, state) {
		      traverse(node, opts, this, state, this.path);
		    };
		    _proto.generateDeclaredUidIdentifier = function generateDeclaredUidIdentifier(name) {
		      var id = this.generateUidIdentifier(name);
		      this.push({
		        id: id
		      });
		      return cloneNode$h(id);
		    };
		    _proto.generateUidIdentifier = function generateUidIdentifier(name) {
		      return identifier$h(this.generateUid(name));
		    };
		    _proto.generateUid = function generateUid(name) {
		      if (name === void 0) {
		        name = "temp";
		      }
		      name = toIdentifier(name).replace(/^_+/, "").replace(/[0-9]+$/g, "");
		      var uid;
		      var i = 1;
		      do {
		        uid = this._generateUid(name, i);
		        i++;
		      } while (this.hasLabel(uid) || this.hasBinding(uid) || this.hasGlobal(uid) || this.hasReference(uid));
		      var program = this.getProgramParent();
		      program.references[uid] = true;
		      program.uids[uid] = true;
		      return uid;
		    };
		    _proto._generateUid = function _generateUid(name, i) {
		      var id = name;
		      if (i > 1) id += i;
		      return "_" + id;
		    };
		    _proto.generateUidBasedOnNode = function generateUidBasedOnNode(node, defaultName) {
		      var parts = [];
		      gatherNodeParts(node, parts);
		      var id = parts.join("$");
		      id = id.replace(/^_/, "") || defaultName || "ref";
		      return this.generateUid(id.slice(0, 20));
		    };
		    _proto.generateUidIdentifierBasedOnNode = function generateUidIdentifierBasedOnNode(node, defaultName) {
		      return identifier$h(this.generateUidBasedOnNode(node, defaultName));
		    };
		    _proto.isStatic = function isStatic(node) {
		      if (isThisExpression$1(node) || isSuper$2(node) || isTopicReference(node)) {
		        return true;
		      }
		      if (isIdentifier$g(node)) {
		        var binding = this.getBinding(node.name);
		        if (binding) {
		          return binding.constant;
		        } else {
		          return this.hasBinding(node.name);
		        }
		      }
		      return false;
		    };
		    _proto.maybeGenerateMemoised = function maybeGenerateMemoised(node, dontPush) {
		      if (this.isStatic(node)) {
		        return null;
		      } else {
		        var id = this.generateUidIdentifierBasedOnNode(node);
		        if (!dontPush) {
		          this.push({
		            id: id
		          });
		          return cloneNode$h(id);
		        }
		        return id;
		      }
		    };
		    _proto.checkBlockScopedCollisions = function checkBlockScopedCollisions(local, kind, name, id) {
		      if (kind === "param") return;
		      if (local.kind === "local") return;
		      var duplicate = kind === "let" || local.kind === "let" || local.kind === "const" || local.kind === "module" || local.kind === "param" && kind === "const";
		      if (duplicate) {
		        throw this.hub.buildError(id, "Duplicate declaration \"" + name + "\"", TypeError);
		      }
		    };
		    _proto.rename = function rename(oldName, newName) {
		      var binding = this.getBinding(oldName);
		      if (binding) {
		        newName || (newName = this.generateUidIdentifier(oldName).name);
		        var renamer = new Renamer(binding, oldName, newName);
		        {
		          renamer.rename(arguments[2]);
		        }
		      }
		    };
		    _proto._renameFromMap = function _renameFromMap(map, oldName, newName, value) {
		      if (map[oldName]) {
		        map[newName] = value;
		        map[oldName] = null;
		      }
		    };
		    _proto.dump = function dump() {
		      var sep = "-".repeat(60);
		      console.log(sep);
		      var scope = this;
		      do {
		        console.log("#", scope.block.type);
		        for (var _i2 = 0, _Object$keys2 = Object.keys(scope.bindings); _i2 < _Object$keys2.length; _i2++) {
		          var _name3 = _Object$keys2[_i2];
		          var binding = scope.bindings[_name3];
		          console.log(" -", _name3, {
		            constant: binding.constant,
		            references: binding.references,
		            violations: binding.constantViolations.length,
		            kind: binding.kind
		          });
		        }
		      } while (scope = scope.parent);
		      console.log(sep);
		    };
		    _proto.toArray = function toArray(node, i, arrayLikeIsIterable) {
		      if (isIdentifier$g(node)) {
		        var binding = this.getBinding(node.name);
		        if (binding != null && binding.constant && binding.path.isGenericType("Array")) {
		          return node;
		        }
		      }
		      if (isArrayExpression$1(node)) {
		        return node;
		      }
		      if (isIdentifier$g(node, {
		        name: "arguments"
		      })) {
		        return callExpression$c(memberExpression$b(memberExpression$b(memberExpression$b(identifier$h("Array"), identifier$h("prototype")), identifier$h("slice")), identifier$h("call")), [node]);
		      }
		      var helperName;
		      var args = [node];
		      if (i === true) {
		        helperName = "toConsumableArray";
		      } else if (typeof i === "number") {
		        args.push(numericLiteral$7(i));
		        helperName = "slicedToArray";
		      } else {
		        helperName = "toArray";
		      }
		      if (arrayLikeIsIterable) {
		        args.unshift(this.hub.addHelper(helperName));
		        helperName = "maybeArrayLike";
		      }
		      return callExpression$c(this.hub.addHelper(helperName), args);
		    };
		    _proto.hasLabel = function hasLabel(name) {
		      return !!this.getLabel(name);
		    };
		    _proto.getLabel = function getLabel(name) {
		      return this.labels.get(name);
		    };
		    _proto.registerLabel = function registerLabel(path) {
		      this.labels.set(path.node.label.name, path);
		    };
		    _proto.registerDeclaration = function registerDeclaration(path) {
		      if (path.isLabeledStatement()) {
		        this.registerLabel(path);
		      } else if (path.isFunctionDeclaration()) {
		        this.registerBinding("hoisted", path.get("id"), path);
		      } else if (path.isVariableDeclaration()) {
		        var declarations = path.get("declarations");
		        var kind = path.node.kind;
		        for (var _iterator5 = _createForOfIteratorHelperLoose(declarations), _step5; !(_step5 = _iterator5()).done;) {
		          var declar = _step5.value;
		          this.registerBinding(kind === "using" || kind === "await using" ? "const" : kind, declar);
		        }
		      } else if (path.isClassDeclaration()) {
		        if (path.node.declare) return;
		        this.registerBinding("let", path);
		      } else if (path.isImportDeclaration()) {
		        var isTypeDeclaration = path.node.importKind === "type" || path.node.importKind === "typeof";
		        var specifiers = path.get("specifiers");
		        for (var _iterator6 = _createForOfIteratorHelperLoose(specifiers), _step6; !(_step6 = _iterator6()).done;) {
		          var specifier = _step6.value;
		          var isTypeSpecifier = isTypeDeclaration || specifier.isImportSpecifier() && (specifier.node.importKind === "type" || specifier.node.importKind === "typeof");
		          this.registerBinding(isTypeSpecifier ? "unknown" : "module", specifier);
		        }
		      } else if (path.isExportDeclaration()) {
		        var _declar = path.get("declaration");
		        if (_declar.isClassDeclaration() || _declar.isFunctionDeclaration() || _declar.isVariableDeclaration()) {
		          this.registerDeclaration(_declar);
		        }
		      } else {
		        this.registerBinding("unknown", path);
		      }
		    };
		    _proto.buildUndefinedNode = function buildUndefinedNode() {
		      return _buildUndefinedNode();
		    };
		    _proto.registerConstantViolation = function registerConstantViolation(path) {
		      var ids = path.getBindingIdentifiers();
		      for (var _i3 = 0, _Object$keys3 = Object.keys(ids); _i3 < _Object$keys3.length; _i3++) {
		        var _this$getBinding;
		        var _name4 = _Object$keys3[_i3];
		        (_this$getBinding = this.getBinding(_name4)) == null || _this$getBinding.reassign(path);
		      }
		    };
		    _proto.registerBinding = function registerBinding(kind, path, bindingPath) {
		      if (bindingPath === void 0) {
		        bindingPath = path;
		      }
		      if (!kind) throw new ReferenceError("no `kind`");
		      if (path.isVariableDeclaration()) {
		        var declarators = path.get("declarations");
		        for (var _iterator7 = _createForOfIteratorHelperLoose(declarators), _step7; !(_step7 = _iterator7()).done;) {
		          var declar = _step7.value;
		          this.registerBinding(kind, declar);
		        }
		        return;
		      }
		      var parent = this.getProgramParent();
		      var ids = path.getOuterBindingIdentifiers(true);
		      for (var _i4 = 0, _Object$keys4 = Object.keys(ids); _i4 < _Object$keys4.length; _i4++) {
		        var _name5 = _Object$keys4[_i4];
		        parent.references[_name5] = true;
		        for (var _iterator8 = _createForOfIteratorHelperLoose(ids[_name5]), _step8; !(_step8 = _iterator8()).done;) {
		          var id = _step8.value;
		          var local = this.getOwnBinding(_name5);
		          if (local) {
		            if (local.identifier === id) continue;
		            this.checkBlockScopedCollisions(local, kind, _name5, id);
		          }
		          if (local) {
		            this.registerConstantViolation(bindingPath);
		          } else {
		            this.bindings[_name5] = new Binding({
		              identifier: id,
		              scope: this,
		              path: bindingPath,
		              kind: kind
		            });
		          }
		        }
		      }
		    };
		    _proto.addGlobal = function addGlobal(node) {
		      this.globals[node.name] = node;
		    };
		    _proto.hasUid = function hasUid(name) {
		      var scope = this;
		      do {
		        if (scope.uids[name]) return true;
		      } while (scope = scope.parent);
		      return false;
		    };
		    _proto.hasGlobal = function hasGlobal(name) {
		      var scope = this;
		      do {
		        if (scope.globals[name]) return true;
		      } while (scope = scope.parent);
		      return false;
		    };
		    _proto.hasReference = function hasReference(name) {
		      return !!this.getProgramParent().references[name];
		    };
		    _proto.isPure = function isPure(node, constantsOnly) {
		      if (isIdentifier$g(node)) {
		        var binding = this.getBinding(node.name);
		        if (!binding) return false;
		        if (constantsOnly) return binding.constant;
		        return true;
		      } else if (isThisExpression$1(node) || isMetaProperty(node) || isTopicReference(node) || isPrivateName$2(node)) {
		        return true;
		      } else if (isClass(node)) {
		        var _node$decorators;
		        if (node.superClass && !this.isPure(node.superClass, constantsOnly)) {
		          return false;
		        }
		        if (((_node$decorators = node.decorators) == null ? void 0 : _node$decorators.length) > 0) {
		          return false;
		        }
		        return this.isPure(node.body, constantsOnly);
		      } else if (isClassBody$1(node)) {
		        for (var _iterator9 = _createForOfIteratorHelperLoose(node.body), _step9; !(_step9 = _iterator9()).done;) {
		          var method = _step9.value;
		          if (!this.isPure(method, constantsOnly)) return false;
		        }
		        return true;
		      } else if (isBinary$1(node)) {
		        return this.isPure(node.left, constantsOnly) && this.isPure(node.right, constantsOnly);
		      } else if (isArrayExpression$1(node) || isTupleExpression(node)) {
		        for (var _iterator10 = _createForOfIteratorHelperLoose(node.elements), _step10; !(_step10 = _iterator10()).done;) {
		          var elem = _step10.value;
		          if (elem !== null && !this.isPure(elem, constantsOnly)) return false;
		        }
		        return true;
		      } else if (isObjectExpression$2(node) || isRecordExpression(node)) {
		        for (var _iterator11 = _createForOfIteratorHelperLoose(node.properties), _step11; !(_step11 = _iterator11()).done;) {
		          var prop = _step11.value;
		          if (!this.isPure(prop, constantsOnly)) return false;
		        }
		        return true;
		      } else if (isMethod(node)) {
		        var _node$decorators2;
		        if (node.computed && !this.isPure(node.key, constantsOnly)) return false;
		        if (((_node$decorators2 = node.decorators) == null ? void 0 : _node$decorators2.length) > 0) {
		          return false;
		        }
		        return true;
		      } else if (isProperty(node)) {
		        var _node$decorators3;
		        if (node.computed && !this.isPure(node.key, constantsOnly)) return false;
		        if (((_node$decorators3 = node.decorators) == null ? void 0 : _node$decorators3.length) > 0) {
		          return false;
		        }
		        if (isObjectProperty$3(node) || node["static"]) {
		          if (node.value !== null && !this.isPure(node.value, constantsOnly)) {
		            return false;
		          }
		        }
		        return true;
		      } else if (isUnaryExpression(node)) {
		        return this.isPure(node.argument, constantsOnly);
		      } else if (isTemplateLiteral$1(node)) {
		        for (var _iterator12 = _createForOfIteratorHelperLoose(node.expressions), _step12; !(_step12 = _iterator12()).done;) {
		          var expression = _step12.value;
		          if (!this.isPure(expression, constantsOnly)) return false;
		        }
		        return true;
		      } else if (isTaggedTemplateExpression(node)) {
		        return matchesPattern$1(node.tag, "String.raw") && !this.hasBinding("String", {
		          noGlobals: true
		        }) && this.isPure(node.quasi, constantsOnly);
		      } else if (isMemberExpression$7(node)) {
		        return !node.computed && isIdentifier$g(node.object) && node.object.name === "Symbol" && isIdentifier$g(node.property) && node.property.name !== "for" && !this.hasBinding("Symbol", {
		          noGlobals: true
		        });
		      } else if (isCallExpression$7(node)) {
		        return matchesPattern$1(node.callee, "Symbol.for") && !this.hasBinding("Symbol", {
		          noGlobals: true
		        }) && node.arguments.length === 1 && isStringLiteral$5(node.arguments[0]);
		      } else {
		        return isPureish$1(node);
		      }
		    };
		    _proto.setData = function setData(key, val) {
		      return this.data[key] = val;
		    };
		    _proto.getData = function getData(key) {
		      var scope = this;
		      do {
		        var data = scope.data[key];
		        if (data != null) return data;
		      } while (scope = scope.parent);
		    };
		    _proto.removeData = function removeData(key) {
		      var scope = this;
		      do {
		        var data = scope.data[key];
		        if (data != null) scope.data[key] = null;
		      } while (scope = scope.parent);
		    };
		    _proto.init = function init() {
		      if (!this.inited) {
		        this.inited = true;
		        this.crawl();
		      }
		    };
		    _proto.crawl = function crawl() {
		      var path = this.path;
		      this.references = Object.create(null);
		      this.bindings = Object.create(null);
		      this.globals = Object.create(null);
		      this.uids = Object.create(null);
		      this.data = Object.create(null);
		      var programParent = this.getProgramParent();
		      if (programParent.crawling) return;
		      var state = {
		        references: [],
		        constantViolations: [],
		        assignments: []
		      };
		      this.crawling = true;
		      if (path.type !== "Program" && isExplodedVisitor(collectorVisitor)) {
		        for (var _iterator13 = _createForOfIteratorHelperLoose(collectorVisitor.enter), _step13; !(_step13 = _iterator13()).done;) {
		          var _visit = _step13.value;
		          _visit.call(state, path, state);
		        }
		        var typeVisitors = collectorVisitor[path.type];
		        if (typeVisitors) {
		          for (var _iterator14 = _createForOfIteratorHelperLoose(typeVisitors.enter), _step14; !(_step14 = _iterator14()).done;) {
		            var visit = _step14.value;
		            visit.call(state, path, state);
		          }
		        }
		      }
		      path.traverse(collectorVisitor, state);
		      this.crawling = false;
		      for (var _iterator15 = _createForOfIteratorHelperLoose(state.assignments), _step15; !(_step15 = _iterator15()).done;) {
		        var _path = _step15.value;
		        var ids = _path.getBindingIdentifiers();
		        for (var _i5 = 0, _Object$keys5 = Object.keys(ids); _i5 < _Object$keys5.length; _i5++) {
		          var _name6 = _Object$keys5[_i5];
		          if (_path.scope.getBinding(_name6)) continue;
		          programParent.addGlobal(ids[_name6]);
		        }
		        _path.scope.registerConstantViolation(_path);
		      }
		      for (var _iterator16 = _createForOfIteratorHelperLoose(state.references), _step16; !(_step16 = _iterator16()).done;) {
		        var ref = _step16.value;
		        var binding = ref.scope.getBinding(ref.node.name);
		        if (binding) {
		          binding.reference(ref);
		        } else {
		          programParent.addGlobal(ref.node);
		        }
		      }
		      for (var _iterator17 = _createForOfIteratorHelperLoose(state.constantViolations), _step17; !(_step17 = _iterator17()).done;) {
		        var _path2 = _step17.value;
		        _path2.scope.registerConstantViolation(_path2);
		      }
		    };
		    _proto.push = function push(opts) {
		      var path = this.path;
		      if (path.isPattern()) {
		        path = this.getPatternParent().path;
		      } else if (!path.isBlockStatement() && !path.isProgram()) {
		        path = this.getBlockParent().path;
		      }
		      if (path.isSwitchStatement()) {
		        path = (this.getFunctionParent() || this.getProgramParent()).path;
		      }
		      var init = opts.init,
		        unique = opts.unique,
		        _opts$kind = opts.kind,
		        kind = _opts$kind === void 0 ? "var" : _opts$kind,
		        id = opts.id;
		      if (!init && !unique && (kind === "var" || kind === "let") && path.isFunction() && !path.node.name && isCallExpression$7(path.parent, {
		        callee: path.node
		      }) && path.parent.arguments.length <= path.node.params.length && isIdentifier$g(id)) {
		        path.pushContainer("params", id);
		        path.scope.registerBinding("param", path.get("params")[path.node.params.length - 1]);
		        return;
		      }
		      if (path.isLoop() || path.isCatchClause() || path.isFunction()) {
		        path.ensureBlock();
		        path = path.get("body");
		      }
		      var blockHoist = opts._blockHoist == null ? 2 : opts._blockHoist;
		      var dataKey = "declaration:" + kind + ":" + blockHoist;
		      var declarPath = !unique && path.getData(dataKey);
		      if (!declarPath) {
		        var declar = variableDeclaration$6(kind, []);
		        declar._blockHoist = blockHoist;
		        var _unshiftContainer = path.unshiftContainer("body", [declar]);
		        var _unshiftContainer2 = _slicedToArray(_unshiftContainer, 1);
		        declarPath = _unshiftContainer2[0];
		        if (!unique) path.setData(dataKey, declarPath);
		      }
		      var declarator = variableDeclarator$6(id, init);
		      var len = declarPath.node.declarations.push(declarator);
		      path.scope.registerBinding(kind, declarPath.get("declarations")[len - 1]);
		    };
		    _proto.getProgramParent = function getProgramParent() {
		      var scope = this;
		      do {
		        if (scope.path.isProgram()) {
		          return scope;
		        }
		      } while (scope = scope.parent);
		      throw new Error("Couldn't find a Program");
		    };
		    _proto.getFunctionParent = function getFunctionParent() {
		      var scope = this;
		      do {
		        if (scope.path.isFunctionParent()) {
		          return scope;
		        }
		      } while (scope = scope.parent);
		      return null;
		    };
		    _proto.getBlockParent = function getBlockParent() {
		      var scope = this;
		      do {
		        if (scope.path.isBlockParent()) {
		          return scope;
		        }
		      } while (scope = scope.parent);
		      throw new Error("We couldn't find a BlockStatement, For, Switch, Function, Loop or Program...");
		    };
		    _proto.getPatternParent = function getPatternParent() {
		      var scope = this;
		      do {
		        if (!scope.path.isPattern()) {
		          return scope.getBlockParent();
		        }
		      } while (scope = scope.parent.parent);
		      throw new Error("We couldn't find a BlockStatement, For, Switch, Function, Loop or Program...");
		    };
		    _proto.getAllBindings = function getAllBindings() {
		      var ids = Object.create(null);
		      var scope = this;
		      do {
		        for (var _i6 = 0, _Object$keys6 = Object.keys(scope.bindings); _i6 < _Object$keys6.length; _i6++) {
		          var _key = _Object$keys6[_i6];
		          if (_key in ids === false) {
		            ids[_key] = scope.bindings[_key];
		          }
		        }
		        scope = scope.parent;
		      } while (scope);
		      return ids;
		    };
		    _proto.getAllBindingsOfKind = function getAllBindingsOfKind() {
		      var ids = Object.create(null);
		      for (var _len = arguments.length, kinds = new Array(_len), _key2 = 0; _key2 < _len; _key2++) {
		        kinds[_key2] = arguments[_key2];
		      }
		      for (var _i7 = 0, _kinds = kinds; _i7 < _kinds.length; _i7++) {
		        var kind = _kinds[_i7];
		        var scope = this;
		        do {
		          for (var _i8 = 0, _Object$keys7 = Object.keys(scope.bindings); _i8 < _Object$keys7.length; _i8++) {
		            var _name7 = _Object$keys7[_i8];
		            var binding = scope.bindings[_name7];
		            if (binding.kind === kind) ids[_name7] = binding;
		          }
		          scope = scope.parent;
		        } while (scope);
		      }
		      return ids;
		    };
		    _proto.bindingIdentifierEquals = function bindingIdentifierEquals(name, node) {
		      return this.getBindingIdentifier(name) === node;
		    };
		    _proto.getBinding = function getBinding(name) {
		      var scope = this;
		      var previousPath;
		      do {
		        var binding = scope.getOwnBinding(name);
		        if (binding) {
		          var _previousPath;
		          if ((_previousPath = previousPath) != null && _previousPath.isPattern() && binding.kind !== "param" && binding.kind !== "local") ; else {
		            return binding;
		          }
		        } else if (!binding && name === "arguments" && scope.path.isFunction() && !scope.path.isArrowFunctionExpression()) {
		          break;
		        }
		        previousPath = scope.path;
		      } while (scope = scope.parent);
		    };
		    _proto.getOwnBinding = function getOwnBinding(name) {
		      return this.bindings[name];
		    };
		    _proto.getBindingIdentifier = function getBindingIdentifier(name) {
		      var _this$getBinding2;
		      return (_this$getBinding2 = this.getBinding(name)) == null ? void 0 : _this$getBinding2.identifier;
		    };
		    _proto.getOwnBindingIdentifier = function getOwnBindingIdentifier(name) {
		      var binding = this.bindings[name];
		      return binding == null ? void 0 : binding.identifier;
		    };
		    _proto.hasOwnBinding = function hasOwnBinding(name) {
		      return !!this.getOwnBinding(name);
		    };
		    _proto.hasBinding = function hasBinding(name, opts) {
		      var _opts, _opts2, _opts3;
		      if (!name) return false;
		      if (this.hasOwnBinding(name)) return true;
		      {
		        if (typeof opts === "boolean") opts = {
		          noGlobals: opts
		        };
		      }
		      if (this.parentHasBinding(name, opts)) return true;
		      if (!((_opts = opts) != null && _opts.noUids) && this.hasUid(name)) return true;
		      if (!((_opts2 = opts) != null && _opts2.noGlobals) && Scope.globals.includes(name)) return true;
		      if (!((_opts3 = opts) != null && _opts3.noGlobals) && Scope.contextVariables.includes(name)) return true;
		      return false;
		    };
		    _proto.parentHasBinding = function parentHasBinding(name, opts) {
		      var _this$parent;
		      return (_this$parent = this.parent) == null ? void 0 : _this$parent.hasBinding(name, opts);
		    };
		    _proto.moveBindingTo = function moveBindingTo(name, scope) {
		      var info = this.getBinding(name);
		      if (info) {
		        info.scope.removeOwnBinding(name);
		        info.scope = scope;
		        scope.bindings[name] = info;
		      }
		    };
		    _proto.removeOwnBinding = function removeOwnBinding(name) {
		      delete this.bindings[name];
		    };
		    _proto.removeBinding = function removeBinding(name) {
		      var _this$getBinding3;
		      (_this$getBinding3 = this.getBinding(name)) == null || _this$getBinding3.scope.removeOwnBinding(name);
		      var scope = this;
		      do {
		        if (scope.uids[name]) {
		          scope.uids[name] = false;
		        }
		      } while (scope = scope.parent);
		    };
		    return _createClass(Scope, [{
		      key: "parent",
		      get: function get() {
		        var _parent;
		        var parent,
		          path = this.path;
		        do {
		          var shouldSkip = path.key === "key" || path.listKey === "decorators";
		          path = path.parentPath;
		          if (shouldSkip && path.isMethod()) path = path.parentPath;
		          if (path && path.isScope()) parent = path;
		        } while (path && !parent);
		        return (_parent = parent) == null ? void 0 : _parent.scope;
		      }
		    }, {
		      key: "parentBlock",
		      get: function get() {
		        return this.path.parent;
		      }
		    }, {
		      key: "hub",
		      get: function get() {
		        return this.path.hub;
		      }
		    }]);
		  }();
		  Scope$1.globals = Object.keys(globals$1.builtin);
		  Scope$1.contextVariables = ["arguments", "undefined", "Infinity", "NaN"];

		  var genMapping_umd$1 = {exports: {}};

		  var setArray_umd = {exports: {}};

		  var hasRequiredSetArray_umd;
		  function requireSetArray_umd() {
		    if (hasRequiredSetArray_umd) return setArray_umd.exports;
		    hasRequiredSetArray_umd = 1;
		    (function (module, exports) {
		      (function (global, factory) {
		        factory(exports) ;
		      })(commonjsGlobal$1, function (exports) {
		        var SetArray = _createClass(function SetArray() {
		          this._indexes = {
		            __proto__: null
		          };
		          this.array = [];
		        });
		        function cast(set) {
		          return set;
		        }
		        function get(setarr, key) {
		          return cast(setarr)._indexes[key];
		        }
		        function put(setarr, key) {
		          var index = get(setarr, key);
		          if (index !== undefined) return index;
		          var _cast = cast(setarr),
		            array = _cast.array,
		            indexes = _cast._indexes;
		          var length = array.push(key);
		          return indexes[key] = length - 1;
		        }
		        function pop(setarr) {
		          var _cast2 = cast(setarr),
		            array = _cast2.array,
		            indexes = _cast2._indexes;
		          if (array.length === 0) return;
		          var last = array.pop();
		          indexes[last] = undefined;
		        }
		        function remove(setarr, key) {
		          var index = get(setarr, key);
		          if (index === undefined) return;
		          var _cast3 = cast(setarr),
		            array = _cast3.array,
		            indexes = _cast3._indexes;
		          for (var i = index + 1; i < array.length; i++) {
		            var k = array[i];
		            array[i - 1] = k;
		            indexes[k]--;
		          }
		          indexes[key] = undefined;
		          array.pop();
		        }
		        exports.SetArray = SetArray;
		        exports.get = get;
		        exports.pop = pop;
		        exports.put = put;
		        exports.remove = remove;
		        Object.defineProperty(exports, '__esModule', {
		          value: true
		        });
		      });
		    })(setArray_umd, setArray_umd.exports);
		    return setArray_umd.exports;
		  }

		  var lookup = [];
		  var revLookup = [];
		  var Arr = typeof Uint8Array !== 'undefined' ? Uint8Array : Array;
		  var inited = false;
		  function init () {
		    inited = true;
		    var code = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
		    for (var i = 0, len = code.length; i < len; ++i) {
		      lookup[i] = code[i];
		      revLookup[code.charCodeAt(i)] = i;
		    }

		    revLookup['-'.charCodeAt(0)] = 62;
		    revLookup['_'.charCodeAt(0)] = 63;
		  }

		  function toByteArray (b64) {
		    if (!inited) {
		      init();
		    }
		    var i, j, l, tmp, placeHolders, arr;
		    var len = b64.length;

		    if (len % 4 > 0) {
		      throw new Error('Invalid string. Length must be a multiple of 4')
		    }

		    // the number of equal signs (place holders)
		    // if there are two placeholders, than the two characters before it
		    // represent one byte
		    // if there is only one, then the three characters before it represent 2 bytes
		    // this is just a cheap hack to not do indexOf twice
		    placeHolders = b64[len - 2] === '=' ? 2 : b64[len - 1] === '=' ? 1 : 0;

		    // base64 is 4/3 + up to two characters of the original data
		    arr = new Arr(len * 3 / 4 - placeHolders);

		    // if there are placeholders, only get up to the last complete 4 chars
		    l = placeHolders > 0 ? len - 4 : len;

		    var L = 0;

		    for (i = 0, j = 0; i < l; i += 4, j += 3) {
		      tmp = (revLookup[b64.charCodeAt(i)] << 18) | (revLookup[b64.charCodeAt(i + 1)] << 12) | (revLookup[b64.charCodeAt(i + 2)] << 6) | revLookup[b64.charCodeAt(i + 3)];
		      arr[L++] = (tmp >> 16) & 0xFF;
		      arr[L++] = (tmp >> 8) & 0xFF;
		      arr[L++] = tmp & 0xFF;
		    }

		    if (placeHolders === 2) {
		      tmp = (revLookup[b64.charCodeAt(i)] << 2) | (revLookup[b64.charCodeAt(i + 1)] >> 4);
		      arr[L++] = tmp & 0xFF;
		    } else if (placeHolders === 1) {
		      tmp = (revLookup[b64.charCodeAt(i)] << 10) | (revLookup[b64.charCodeAt(i + 1)] << 4) | (revLookup[b64.charCodeAt(i + 2)] >> 2);
		      arr[L++] = (tmp >> 8) & 0xFF;
		      arr[L++] = tmp & 0xFF;
		    }

		    return arr
		  }

		  function tripletToBase64 (num) {
		    return lookup[num >> 18 & 0x3F] + lookup[num >> 12 & 0x3F] + lookup[num >> 6 & 0x3F] + lookup[num & 0x3F]
		  }

		  function encodeChunk (uint8, start, end) {
		    var tmp;
		    var output = [];
		    for (var i = start; i < end; i += 3) {
		      tmp = (uint8[i] << 16) + (uint8[i + 1] << 8) + (uint8[i + 2]);
		      output.push(tripletToBase64(tmp));
		    }
		    return output.join('')
		  }

		  function fromByteArray (uint8) {
		    if (!inited) {
		      init();
		    }
		    var tmp;
		    var len = uint8.length;
		    var extraBytes = len % 3; // if we have 1 byte left, pad 2 bytes
		    var output = '';
		    var parts = [];
		    var maxChunkLength = 16383; // must be multiple of 3

		    // go through the array every three bytes, we'll deal with trailing stuff later
		    for (var i = 0, len2 = len - extraBytes; i < len2; i += maxChunkLength) {
		      parts.push(encodeChunk(uint8, i, (i + maxChunkLength) > len2 ? len2 : (i + maxChunkLength)));
		    }

		    // pad the end with zeros, but make sure to not forget the extra bytes
		    if (extraBytes === 1) {
		      tmp = uint8[len - 1];
		      output += lookup[tmp >> 2];
		      output += lookup[(tmp << 4) & 0x3F];
		      output += '==';
		    } else if (extraBytes === 2) {
		      tmp = (uint8[len - 2] << 8) + (uint8[len - 1]);
		      output += lookup[tmp >> 10];
		      output += lookup[(tmp >> 4) & 0x3F];
		      output += lookup[(tmp << 2) & 0x3F];
		      output += '=';
		    }

		    parts.push(output);

		    return parts.join('')
		  }

		  function read (buffer, offset, isLE, mLen, nBytes) {
		    var e, m;
		    var eLen = nBytes * 8 - mLen - 1;
		    var eMax = (1 << eLen) - 1;
		    var eBias = eMax >> 1;
		    var nBits = -7;
		    var i = isLE ? (nBytes - 1) : 0;
		    var d = isLE ? -1 : 1;
		    var s = buffer[offset + i];

		    i += d;

		    e = s & ((1 << (-nBits)) - 1);
		    s >>= (-nBits);
		    nBits += eLen;
		    for (; nBits > 0; e = e * 256 + buffer[offset + i], i += d, nBits -= 8) {}

		    m = e & ((1 << (-nBits)) - 1);
		    e >>= (-nBits);
		    nBits += mLen;
		    for (; nBits > 0; m = m * 256 + buffer[offset + i], i += d, nBits -= 8) {}

		    if (e === 0) {
		      e = 1 - eBias;
		    } else if (e === eMax) {
		      return m ? NaN : ((s ? -1 : 1) * Infinity)
		    } else {
		      m = m + Math.pow(2, mLen);
		      e = e - eBias;
		    }
		    return (s ? -1 : 1) * m * Math.pow(2, e - mLen)
		  }

		  function write (buffer, value, offset, isLE, mLen, nBytes) {
		    var e, m, c;
		    var eLen = nBytes * 8 - mLen - 1;
		    var eMax = (1 << eLen) - 1;
		    var eBias = eMax >> 1;
		    var rt = (mLen === 23 ? Math.pow(2, -24) - Math.pow(2, -77) : 0);
		    var i = isLE ? 0 : (nBytes - 1);
		    var d = isLE ? 1 : -1;
		    var s = value < 0 || (value === 0 && 1 / value < 0) ? 1 : 0;

		    value = Math.abs(value);

		    if (isNaN(value) || value === Infinity) {
		      m = isNaN(value) ? 1 : 0;
		      e = eMax;
		    } else {
		      e = Math.floor(Math.log(value) / Math.LN2);
		      if (value * (c = Math.pow(2, -e)) < 1) {
		        e--;
		        c *= 2;
		      }
		      if (e + eBias >= 1) {
		        value += rt / c;
		      } else {
		        value += rt * Math.pow(2, 1 - eBias);
		      }
		      if (value * c >= 2) {
		        e++;
		        c /= 2;
		      }

		      if (e + eBias >= eMax) {
		        m = 0;
		        e = eMax;
		      } else if (e + eBias >= 1) {
		        m = (value * c - 1) * Math.pow(2, mLen);
		        e = e + eBias;
		      } else {
		        m = value * Math.pow(2, eBias - 1) * Math.pow(2, mLen);
		        e = 0;
		      }
		    }

		    for (; mLen >= 8; buffer[offset + i] = m & 0xff, i += d, m /= 256, mLen -= 8) {}

		    e = (e << mLen) | m;
		    eLen += mLen;
		    for (; eLen > 0; buffer[offset + i] = e & 0xff, i += d, e /= 256, eLen -= 8) {}

		    buffer[offset + i - d] |= s * 128;
		  }

		  var toString = {}.toString;

		  var isArray$2 = Array.isArray || function (arr) {
		    return toString.call(arr) == '[object Array]';
		  };

		  /*!
		   * The buffer module from node.js, for the browser.
		   *
		   * @author   Feross Aboukhadijeh <feross@feross.org> <http://feross.org>
		   * @license  MIT
		   */
		  /* eslint-disable no-proto */


		  var INSPECT_MAX_BYTES = 50;

		  /**
		   * If `Buffer.TYPED_ARRAY_SUPPORT`:
		   *   === true    Use Uint8Array implementation (fastest)
		   *   === false   Use Object implementation (most compatible, even IE6)
		   *
		   * Browsers that support typed arrays are IE 10+, Firefox 4+, Chrome 7+, Safari 5.1+,
		   * Opera 11.6+, iOS 4.2+.
		   *
		   * Due to various browser bugs, sometimes the Object implementation will be used even
		   * when the browser supports typed arrays.
		   *
		   * Note:
		   *
		   *   - Firefox 4-29 lacks support for adding new properties to `Uint8Array` instances,
		   *     See: https://bugzilla.mozilla.org/show_bug.cgi?id=695438.
		   *
		   *   - Chrome 9-10 is missing the `TypedArray.prototype.subarray` function.
		   *
		   *   - IE10 has a broken `TypedArray.prototype.subarray` function which returns arrays of
		   *     incorrect length in some situations.

		   * We detect these buggy browsers and set `Buffer.TYPED_ARRAY_SUPPORT` to `false` so they
		   * get the Object implementation, which is slower but behaves correctly.
		   */
		  Buffer$1.TYPED_ARRAY_SUPPORT = global$1.TYPED_ARRAY_SUPPORT !== undefined
		    ? global$1.TYPED_ARRAY_SUPPORT
		    : true;

		  /*
		   * Export kMaxLength after typed array support is determined.
		   */
		  kMaxLength();

		  function kMaxLength () {
		    return Buffer$1.TYPED_ARRAY_SUPPORT
		      ? 0x7fffffff
		      : 0x3fffffff
		  }

		  function createBuffer (that, length) {
		    if (kMaxLength() < length) {
		      throw new RangeError('Invalid typed array length')
		    }
		    if (Buffer$1.TYPED_ARRAY_SUPPORT) {
		      // Return an augmented `Uint8Array` instance, for best performance
		      that = new Uint8Array(length);
		      that.__proto__ = Buffer$1.prototype;
		    } else {
		      // Fallback: Return an object instance of the Buffer class
		      if (that === null) {
		        that = new Buffer$1(length);
		      }
		      that.length = length;
		    }

		    return that
		  }

		  /**
		   * The Buffer constructor returns instances of `Uint8Array` that have their
		   * prototype changed to `Buffer.prototype`. Furthermore, `Buffer` is a subclass of
		   * `Uint8Array`, so the returned instances will have all the node `Buffer` methods
		   * and the `Uint8Array` methods. Square bracket notation works as expected -- it
		   * returns a single octet.
		   *
		   * The `Uint8Array` prototype remains unmodified.
		   */

		  function Buffer$1 (arg, encodingOrOffset, length) {
		    if (!Buffer$1.TYPED_ARRAY_SUPPORT && !(this instanceof Buffer$1)) {
		      return new Buffer$1(arg, encodingOrOffset, length)
		    }

		    // Common case.
		    if (typeof arg === 'number') {
		      if (typeof encodingOrOffset === 'string') {
		        throw new Error(
		          'If encoding is specified then the first argument must be a string'
		        )
		      }
		      return allocUnsafe(this, arg)
		    }
		    return from(this, arg, encodingOrOffset, length)
		  }

		  Buffer$1.poolSize = 8192; // not used by this implementation

		  // TODO: Legacy, not needed anymore. Remove in next major version.
		  Buffer$1._augment = function (arr) {
		    arr.__proto__ = Buffer$1.prototype;
		    return arr
		  };

		  function from (that, value, encodingOrOffset, length) {
		    if (typeof value === 'number') {
		      throw new TypeError('"value" argument must not be a number')
		    }

		    if (typeof ArrayBuffer !== 'undefined' && value instanceof ArrayBuffer) {
		      return fromArrayBuffer(that, value, encodingOrOffset, length)
		    }

		    if (typeof value === 'string') {
		      return fromString(that, value, encodingOrOffset)
		    }

		    return fromObject(that, value)
		  }

		  /**
		   * Functionally equivalent to Buffer(arg, encoding) but throws a TypeError
		   * if value is a number.
		   * Buffer.from(str[, encoding])
		   * Buffer.from(array)
		   * Buffer.from(buffer)
		   * Buffer.from(arrayBuffer[, byteOffset[, length]])
		   **/
		  Buffer$1.from = function (value, encodingOrOffset, length) {
		    return from(null, value, encodingOrOffset, length)
		  };

		  if (Buffer$1.TYPED_ARRAY_SUPPORT) {
		    Buffer$1.prototype.__proto__ = Uint8Array.prototype;
		    Buffer$1.__proto__ = Uint8Array;
		    if (typeof Symbol !== 'undefined' && Symbol.species &&
		        Buffer$1[Symbol.species] === Buffer$1) ;
		  }

		  function assertSize (size) {
		    if (typeof size !== 'number') {
		      throw new TypeError('"size" argument must be a number')
		    } else if (size < 0) {
		      throw new RangeError('"size" argument must not be negative')
		    }
		  }

		  function alloc (that, size, fill, encoding) {
		    assertSize(size);
		    if (size <= 0) {
		      return createBuffer(that, size)
		    }
		    if (fill !== undefined) {
		      // Only pay attention to encoding if it's a string. This
		      // prevents accidentally sending in a number that would
		      // be interpretted as a start offset.
		      return typeof encoding === 'string'
		        ? createBuffer(that, size).fill(fill, encoding)
		        : createBuffer(that, size).fill(fill)
		    }
		    return createBuffer(that, size)
		  }

		  /**
		   * Creates a new filled Buffer instance.
		   * alloc(size[, fill[, encoding]])
		   **/
		  Buffer$1.alloc = function (size, fill, encoding) {
		    return alloc(null, size, fill, encoding)
		  };

		  function allocUnsafe (that, size) {
		    assertSize(size);
		    that = createBuffer(that, size < 0 ? 0 : checked(size) | 0);
		    if (!Buffer$1.TYPED_ARRAY_SUPPORT) {
		      for (var i = 0; i < size; ++i) {
		        that[i] = 0;
		      }
		    }
		    return that
		  }

		  /**
		   * Equivalent to Buffer(num), by default creates a non-zero-filled Buffer instance.
		   * */
		  Buffer$1.allocUnsafe = function (size) {
		    return allocUnsafe(null, size)
		  };
		  /**
		   * Equivalent to SlowBuffer(num), by default creates a non-zero-filled Buffer instance.
		   */
		  Buffer$1.allocUnsafeSlow = function (size) {
		    return allocUnsafe(null, size)
		  };

		  function fromString (that, string, encoding) {
		    if (typeof encoding !== 'string' || encoding === '') {
		      encoding = 'utf8';
		    }

		    if (!Buffer$1.isEncoding(encoding)) {
		      throw new TypeError('"encoding" must be a valid string encoding')
		    }

		    var length = byteLength(string, encoding) | 0;
		    that = createBuffer(that, length);

		    var actual = that.write(string, encoding);

		    if (actual !== length) {
		      // Writing a hex string, for example, that contains invalid characters will
		      // cause everything after the first invalid character to be ignored. (e.g.
		      // 'abxxcd' will be treated as 'ab')
		      that = that.slice(0, actual);
		    }

		    return that
		  }

		  function fromArrayLike (that, array) {
		    var length = array.length < 0 ? 0 : checked(array.length) | 0;
		    that = createBuffer(that, length);
		    for (var i = 0; i < length; i += 1) {
		      that[i] = array[i] & 255;
		    }
		    return that
		  }

		  function fromArrayBuffer (that, array, byteOffset, length) {
		    array.byteLength; // this throws if `array` is not a valid ArrayBuffer

		    if (byteOffset < 0 || array.byteLength < byteOffset) {
		      throw new RangeError('\'offset\' is out of bounds')
		    }

		    if (array.byteLength < byteOffset + (length || 0)) {
		      throw new RangeError('\'length\' is out of bounds')
		    }

		    if (byteOffset === undefined && length === undefined) {
		      array = new Uint8Array(array);
		    } else if (length === undefined) {
		      array = new Uint8Array(array, byteOffset);
		    } else {
		      array = new Uint8Array(array, byteOffset, length);
		    }

		    if (Buffer$1.TYPED_ARRAY_SUPPORT) {
		      // Return an augmented `Uint8Array` instance, for best performance
		      that = array;
		      that.__proto__ = Buffer$1.prototype;
		    } else {
		      // Fallback: Return an object instance of the Buffer class
		      that = fromArrayLike(that, array);
		    }
		    return that
		  }

		  function fromObject (that, obj) {
		    if (internalIsBuffer(obj)) {
		      var len = checked(obj.length) | 0;
		      that = createBuffer(that, len);

		      if (that.length === 0) {
		        return that
		      }

		      obj.copy(that, 0, 0, len);
		      return that
		    }

		    if (obj) {
		      if ((typeof ArrayBuffer !== 'undefined' &&
		          obj.buffer instanceof ArrayBuffer) || 'length' in obj) {
		        if (typeof obj.length !== 'number' || isnan(obj.length)) {
		          return createBuffer(that, 0)
		        }
		        return fromArrayLike(that, obj)
		      }

		      if (obj.type === 'Buffer' && isArray$2(obj.data)) {
		        return fromArrayLike(that, obj.data)
		      }
		    }

		    throw new TypeError('First argument must be a string, Buffer, ArrayBuffer, Array, or array-like object.')
		  }

		  function checked (length) {
		    // Note: cannot use `length < kMaxLength()` here because that fails when
		    // length is NaN (which is otherwise coerced to zero.)
		    if (length >= kMaxLength()) {
		      throw new RangeError('Attempt to allocate Buffer larger than maximum ' +
		                           'size: 0x' + kMaxLength().toString(16) + ' bytes')
		    }
		    return length | 0
		  }
		  Buffer$1.isBuffer = isBuffer$1;
		  function internalIsBuffer (b) {
		    return !!(b != null && b._isBuffer)
		  }

		  Buffer$1.compare = function compare (a, b) {
		    if (!internalIsBuffer(a) || !internalIsBuffer(b)) {
		      throw new TypeError('Arguments must be Buffers')
		    }

		    if (a === b) return 0

		    var x = a.length;
		    var y = b.length;

		    for (var i = 0, len = Math.min(x, y); i < len; ++i) {
		      if (a[i] !== b[i]) {
		        x = a[i];
		        y = b[i];
		        break
		      }
		    }

		    if (x < y) return -1
		    if (y < x) return 1
		    return 0
		  };

		  Buffer$1.isEncoding = function isEncoding (encoding) {
		    switch (String(encoding).toLowerCase()) {
		      case 'hex':
		      case 'utf8':
		      case 'utf-8':
		      case 'ascii':
		      case 'latin1':
		      case 'binary':
		      case 'base64':
		      case 'ucs2':
		      case 'ucs-2':
		      case 'utf16le':
		      case 'utf-16le':
		        return true
		      default:
		        return false
		    }
		  };

		  Buffer$1.concat = function concat (list, length) {
		    if (!isArray$2(list)) {
		      throw new TypeError('"list" argument must be an Array of Buffers')
		    }

		    if (list.length === 0) {
		      return Buffer$1.alloc(0)
		    }

		    var i;
		    if (length === undefined) {
		      length = 0;
		      for (i = 0; i < list.length; ++i) {
		        length += list[i].length;
		      }
		    }

		    var buffer = Buffer$1.allocUnsafe(length);
		    var pos = 0;
		    for (i = 0; i < list.length; ++i) {
		      var buf = list[i];
		      if (!internalIsBuffer(buf)) {
		        throw new TypeError('"list" argument must be an Array of Buffers')
		      }
		      buf.copy(buffer, pos);
		      pos += buf.length;
		    }
		    return buffer
		  };

		  function byteLength (string, encoding) {
		    if (internalIsBuffer(string)) {
		      return string.length
		    }
		    if (typeof ArrayBuffer !== 'undefined' && typeof ArrayBuffer.isView === 'function' &&
		        (ArrayBuffer.isView(string) || string instanceof ArrayBuffer)) {
		      return string.byteLength
		    }
		    if (typeof string !== 'string') {
		      string = '' + string;
		    }

		    var len = string.length;
		    if (len === 0) return 0

		    // Use a for loop to avoid recursion
		    var loweredCase = false;
		    for (;;) {
		      switch (encoding) {
		        case 'ascii':
		        case 'latin1':
		        case 'binary':
		          return len
		        case 'utf8':
		        case 'utf-8':
		        case undefined:
		          return utf8ToBytes(string).length
		        case 'ucs2':
		        case 'ucs-2':
		        case 'utf16le':
		        case 'utf-16le':
		          return len * 2
		        case 'hex':
		          return len >>> 1
		        case 'base64':
		          return base64ToBytes(string).length
		        default:
		          if (loweredCase) return utf8ToBytes(string).length // assume utf8
		          encoding = ('' + encoding).toLowerCase();
		          loweredCase = true;
		      }
		    }
		  }
		  Buffer$1.byteLength = byteLength;

		  function slowToString (encoding, start, end) {
		    var loweredCase = false;

		    // No need to verify that "this.length <= MAX_UINT32" since it's a read-only
		    // property of a typed array.

		    // This behaves neither like String nor Uint8Array in that we set start/end
		    // to their upper/lower bounds if the value passed is out of range.
		    // undefined is handled specially as per ECMA-262 6th Edition,
		    // Section 13.3.3.7 Runtime Semantics: KeyedBindingInitialization.
		    if (start === undefined || start < 0) {
		      start = 0;
		    }
		    // Return early if start > this.length. Done here to prevent potential uint32
		    // coercion fail below.
		    if (start > this.length) {
		      return ''
		    }

		    if (end === undefined || end > this.length) {
		      end = this.length;
		    }

		    if (end <= 0) {
		      return ''
		    }

		    // Force coersion to uint32. This will also coerce falsey/NaN values to 0.
		    end >>>= 0;
		    start >>>= 0;

		    if (end <= start) {
		      return ''
		    }

		    if (!encoding) encoding = 'utf8';

		    while (true) {
		      switch (encoding) {
		        case 'hex':
		          return hexSlice(this, start, end)

		        case 'utf8':
		        case 'utf-8':
		          return utf8Slice(this, start, end)

		        case 'ascii':
		          return asciiSlice(this, start, end)

		        case 'latin1':
		        case 'binary':
		          return latin1Slice(this, start, end)

		        case 'base64':
		          return base64Slice(this, start, end)

		        case 'ucs2':
		        case 'ucs-2':
		        case 'utf16le':
		        case 'utf-16le':
		          return utf16leSlice(this, start, end)

		        default:
		          if (loweredCase) throw new TypeError('Unknown encoding: ' + encoding)
		          encoding = (encoding + '').toLowerCase();
		          loweredCase = true;
		      }
		    }
		  }

		  // The property is used by `Buffer.isBuffer` and `is-buffer` (in Safari 5-7) to detect
		  // Buffer instances.
		  Buffer$1.prototype._isBuffer = true;

		  function swap (b, n, m) {
		    var i = b[n];
		    b[n] = b[m];
		    b[m] = i;
		  }

		  Buffer$1.prototype.swap16 = function swap16 () {
		    var len = this.length;
		    if (len % 2 !== 0) {
		      throw new RangeError('Buffer size must be a multiple of 16-bits')
		    }
		    for (var i = 0; i < len; i += 2) {
		      swap(this, i, i + 1);
		    }
		    return this
		  };

		  Buffer$1.prototype.swap32 = function swap32 () {
		    var len = this.length;
		    if (len % 4 !== 0) {
		      throw new RangeError('Buffer size must be a multiple of 32-bits')
		    }
		    for (var i = 0; i < len; i += 4) {
		      swap(this, i, i + 3);
		      swap(this, i + 1, i + 2);
		    }
		    return this
		  };

		  Buffer$1.prototype.swap64 = function swap64 () {
		    var len = this.length;
		    if (len % 8 !== 0) {
		      throw new RangeError('Buffer size must be a multiple of 64-bits')
		    }
		    for (var i = 0; i < len; i += 8) {
		      swap(this, i, i + 7);
		      swap(this, i + 1, i + 6);
		      swap(this, i + 2, i + 5);
		      swap(this, i + 3, i + 4);
		    }
		    return this
		  };

		  Buffer$1.prototype.toString = function toString () {
		    var length = this.length | 0;
		    if (length === 0) return ''
		    if (arguments.length === 0) return utf8Slice(this, 0, length)
		    return slowToString.apply(this, arguments)
		  };

		  Buffer$1.prototype.equals = function equals (b) {
		    if (!internalIsBuffer(b)) throw new TypeError('Argument must be a Buffer')
		    if (this === b) return true
		    return Buffer$1.compare(this, b) === 0
		  };

		  Buffer$1.prototype.inspect = function inspect () {
		    var str = '';
		    var max = INSPECT_MAX_BYTES;
		    if (this.length > 0) {
		      str = this.toString('hex', 0, max).match(/.{2}/g).join(' ');
		      if (this.length > max) str += ' ... ';
		    }
		    return '<Buffer ' + str + '>'
		  };

		  Buffer$1.prototype.compare = function compare (target, start, end, thisStart, thisEnd) {
		    if (!internalIsBuffer(target)) {
		      throw new TypeError('Argument must be a Buffer')
		    }

		    if (start === undefined) {
		      start = 0;
		    }
		    if (end === undefined) {
		      end = target ? target.length : 0;
		    }
		    if (thisStart === undefined) {
		      thisStart = 0;
		    }
		    if (thisEnd === undefined) {
		      thisEnd = this.length;
		    }

		    if (start < 0 || end > target.length || thisStart < 0 || thisEnd > this.length) {
		      throw new RangeError('out of range index')
		    }

		    if (thisStart >= thisEnd && start >= end) {
		      return 0
		    }
		    if (thisStart >= thisEnd) {
		      return -1
		    }
		    if (start >= end) {
		      return 1
		    }

		    start >>>= 0;
		    end >>>= 0;
		    thisStart >>>= 0;
		    thisEnd >>>= 0;

		    if (this === target) return 0

		    var x = thisEnd - thisStart;
		    var y = end - start;
		    var len = Math.min(x, y);

		    var thisCopy = this.slice(thisStart, thisEnd);
		    var targetCopy = target.slice(start, end);

		    for (var i = 0; i < len; ++i) {
		      if (thisCopy[i] !== targetCopy[i]) {
		        x = thisCopy[i];
		        y = targetCopy[i];
		        break
		      }
		    }

		    if (x < y) return -1
		    if (y < x) return 1
		    return 0
		  };

		  // Finds either the first index of `val` in `buffer` at offset >= `byteOffset`,
		  // OR the last index of `val` in `buffer` at offset <= `byteOffset`.
		  //
		  // Arguments:
		  // - buffer - a Buffer to search
		  // - val - a string, Buffer, or number
		  // - byteOffset - an index into `buffer`; will be clamped to an int32
		  // - encoding - an optional encoding, relevant is val is a string
		  // - dir - true for indexOf, false for lastIndexOf
		  function bidirectionalIndexOf (buffer, val, byteOffset, encoding, dir) {
		    // Empty buffer means no match
		    if (buffer.length === 0) return -1

		    // Normalize byteOffset
		    if (typeof byteOffset === 'string') {
		      encoding = byteOffset;
		      byteOffset = 0;
		    } else if (byteOffset > 0x7fffffff) {
		      byteOffset = 0x7fffffff;
		    } else if (byteOffset < -0x80000000) {
		      byteOffset = -0x80000000;
		    }
		    byteOffset = +byteOffset;  // Coerce to Number.
		    if (isNaN(byteOffset)) {
		      // byteOffset: it it's undefined, null, NaN, "foo", etc, search whole buffer
		      byteOffset = dir ? 0 : (buffer.length - 1);
		    }

		    // Normalize byteOffset: negative offsets start from the end of the buffer
		    if (byteOffset < 0) byteOffset = buffer.length + byteOffset;
		    if (byteOffset >= buffer.length) {
		      if (dir) return -1
		      else byteOffset = buffer.length - 1;
		    } else if (byteOffset < 0) {
		      if (dir) byteOffset = 0;
		      else return -1
		    }

		    // Normalize val
		    if (typeof val === 'string') {
		      val = Buffer$1.from(val, encoding);
		    }

		    // Finally, search either indexOf (if dir is true) or lastIndexOf
		    if (internalIsBuffer(val)) {
		      // Special case: looking for empty string/buffer always fails
		      if (val.length === 0) {
		        return -1
		      }
		      return arrayIndexOf(buffer, val, byteOffset, encoding, dir)
		    } else if (typeof val === 'number') {
		      val = val & 0xFF; // Search for a byte value [0-255]
		      if (Buffer$1.TYPED_ARRAY_SUPPORT &&
		          typeof Uint8Array.prototype.indexOf === 'function') {
		        if (dir) {
		          return Uint8Array.prototype.indexOf.call(buffer, val, byteOffset)
		        } else {
		          return Uint8Array.prototype.lastIndexOf.call(buffer, val, byteOffset)
		        }
		      }
		      return arrayIndexOf(buffer, [ val ], byteOffset, encoding, dir)
		    }

		    throw new TypeError('val must be string, number or Buffer')
		  }

		  function arrayIndexOf (arr, val, byteOffset, encoding, dir) {
		    var indexSize = 1;
		    var arrLength = arr.length;
		    var valLength = val.length;

		    if (encoding !== undefined) {
		      encoding = String(encoding).toLowerCase();
		      if (encoding === 'ucs2' || encoding === 'ucs-2' ||
		          encoding === 'utf16le' || encoding === 'utf-16le') {
		        if (arr.length < 2 || val.length < 2) {
		          return -1
		        }
		        indexSize = 2;
		        arrLength /= 2;
		        valLength /= 2;
		        byteOffset /= 2;
		      }
		    }

		    function read (buf, i) {
		      if (indexSize === 1) {
		        return buf[i]
		      } else {
		        return buf.readUInt16BE(i * indexSize)
		      }
		    }

		    var i;
		    if (dir) {
		      var foundIndex = -1;
		      for (i = byteOffset; i < arrLength; i++) {
		        if (read(arr, i) === read(val, foundIndex === -1 ? 0 : i - foundIndex)) {
		          if (foundIndex === -1) foundIndex = i;
		          if (i - foundIndex + 1 === valLength) return foundIndex * indexSize
		        } else {
		          if (foundIndex !== -1) i -= i - foundIndex;
		          foundIndex = -1;
		        }
		      }
		    } else {
		      if (byteOffset + valLength > arrLength) byteOffset = arrLength - valLength;
		      for (i = byteOffset; i >= 0; i--) {
		        var found = true;
		        for (var j = 0; j < valLength; j++) {
		          if (read(arr, i + j) !== read(val, j)) {
		            found = false;
		            break
		          }
		        }
		        if (found) return i
		      }
		    }

		    return -1
		  }

		  Buffer$1.prototype.includes = function includes (val, byteOffset, encoding) {
		    return this.indexOf(val, byteOffset, encoding) !== -1
		  };

		  Buffer$1.prototype.indexOf = function indexOf (val, byteOffset, encoding) {
		    return bidirectionalIndexOf(this, val, byteOffset, encoding, true)
		  };

		  Buffer$1.prototype.lastIndexOf = function lastIndexOf (val, byteOffset, encoding) {
		    return bidirectionalIndexOf(this, val, byteOffset, encoding, false)
		  };

		  function hexWrite (buf, string, offset, length) {
		    offset = Number(offset) || 0;
		    var remaining = buf.length - offset;
		    if (!length) {
		      length = remaining;
		    } else {
		      length = Number(length);
		      if (length > remaining) {
		        length = remaining;
		      }
		    }

		    // must be an even number of digits
		    var strLen = string.length;
		    if (strLen % 2 !== 0) throw new TypeError('Invalid hex string')

		    if (length > strLen / 2) {
		      length = strLen / 2;
		    }
		    for (var i = 0; i < length; ++i) {
		      var parsed = parseInt(string.substr(i * 2, 2), 16);
		      if (isNaN(parsed)) return i
		      buf[offset + i] = parsed;
		    }
		    return i
		  }

		  function utf8Write (buf, string, offset, length) {
		    return blitBuffer(utf8ToBytes(string, buf.length - offset), buf, offset, length)
		  }

		  function asciiWrite (buf, string, offset, length) {
		    return blitBuffer(asciiToBytes(string), buf, offset, length)
		  }

		  function latin1Write (buf, string, offset, length) {
		    return asciiWrite(buf, string, offset, length)
		  }

		  function base64Write (buf, string, offset, length) {
		    return blitBuffer(base64ToBytes(string), buf, offset, length)
		  }

		  function ucs2Write (buf, string, offset, length) {
		    return blitBuffer(utf16leToBytes(string, buf.length - offset), buf, offset, length)
		  }

		  Buffer$1.prototype.write = function write (string, offset, length, encoding) {
		    // Buffer#write(string)
		    if (offset === undefined) {
		      encoding = 'utf8';
		      length = this.length;
		      offset = 0;
		    // Buffer#write(string, encoding)
		    } else if (length === undefined && typeof offset === 'string') {
		      encoding = offset;
		      length = this.length;
		      offset = 0;
		    // Buffer#write(string, offset[, length][, encoding])
		    } else if (isFinite(offset)) {
		      offset = offset | 0;
		      if (isFinite(length)) {
		        length = length | 0;
		        if (encoding === undefined) encoding = 'utf8';
		      } else {
		        encoding = length;
		        length = undefined;
		      }
		    // legacy write(string, encoding, offset, length) - remove in v0.13
		    } else {
		      throw new Error(
		        'Buffer.write(string, encoding, offset[, length]) is no longer supported'
		      )
		    }

		    var remaining = this.length - offset;
		    if (length === undefined || length > remaining) length = remaining;

		    if ((string.length > 0 && (length < 0 || offset < 0)) || offset > this.length) {
		      throw new RangeError('Attempt to write outside buffer bounds')
		    }

		    if (!encoding) encoding = 'utf8';

		    var loweredCase = false;
		    for (;;) {
		      switch (encoding) {
		        case 'hex':
		          return hexWrite(this, string, offset, length)

		        case 'utf8':
		        case 'utf-8':
		          return utf8Write(this, string, offset, length)

		        case 'ascii':
		          return asciiWrite(this, string, offset, length)

		        case 'latin1':
		        case 'binary':
		          return latin1Write(this, string, offset, length)

		        case 'base64':
		          // Warning: maxLength not taken into account in base64Write
		          return base64Write(this, string, offset, length)

		        case 'ucs2':
		        case 'ucs-2':
		        case 'utf16le':
		        case 'utf-16le':
		          return ucs2Write(this, string, offset, length)

		        default:
		          if (loweredCase) throw new TypeError('Unknown encoding: ' + encoding)
		          encoding = ('' + encoding).toLowerCase();
		          loweredCase = true;
		      }
		    }
		  };

		  Buffer$1.prototype.toJSON = function toJSON () {
		    return {
		      type: 'Buffer',
		      data: Array.prototype.slice.call(this._arr || this, 0)
		    }
		  };

		  function base64Slice (buf, start, end) {
		    if (start === 0 && end === buf.length) {
		      return fromByteArray(buf)
		    } else {
		      return fromByteArray(buf.slice(start, end))
		    }
		  }

		  function utf8Slice (buf, start, end) {
		    end = Math.min(buf.length, end);
		    var res = [];

		    var i = start;
		    while (i < end) {
		      var firstByte = buf[i];
		      var codePoint = null;
		      var bytesPerSequence = (firstByte > 0xEF) ? 4
		        : (firstByte > 0xDF) ? 3
		        : (firstByte > 0xBF) ? 2
		        : 1;

		      if (i + bytesPerSequence <= end) {
		        var secondByte, thirdByte, fourthByte, tempCodePoint;

		        switch (bytesPerSequence) {
		          case 1:
		            if (firstByte < 0x80) {
		              codePoint = firstByte;
		            }
		            break
		          case 2:
		            secondByte = buf[i + 1];
		            if ((secondByte & 0xC0) === 0x80) {
		              tempCodePoint = (firstByte & 0x1F) << 0x6 | (secondByte & 0x3F);
		              if (tempCodePoint > 0x7F) {
		                codePoint = tempCodePoint;
		              }
		            }
		            break
		          case 3:
		            secondByte = buf[i + 1];
		            thirdByte = buf[i + 2];
		            if ((secondByte & 0xC0) === 0x80 && (thirdByte & 0xC0) === 0x80) {
		              tempCodePoint = (firstByte & 0xF) << 0xC | (secondByte & 0x3F) << 0x6 | (thirdByte & 0x3F);
		              if (tempCodePoint > 0x7FF && (tempCodePoint < 0xD800 || tempCodePoint > 0xDFFF)) {
		                codePoint = tempCodePoint;
		              }
		            }
		            break
		          case 4:
		            secondByte = buf[i + 1];
		            thirdByte = buf[i + 2];
		            fourthByte = buf[i + 3];
		            if ((secondByte & 0xC0) === 0x80 && (thirdByte & 0xC0) === 0x80 && (fourthByte & 0xC0) === 0x80) {
		              tempCodePoint = (firstByte & 0xF) << 0x12 | (secondByte & 0x3F) << 0xC | (thirdByte & 0x3F) << 0x6 | (fourthByte & 0x3F);
		              if (tempCodePoint > 0xFFFF && tempCodePoint < 0x110000) {
		                codePoint = tempCodePoint;
		              }
		            }
		        }
		      }

		      if (codePoint === null) {
		        // we did not generate a valid codePoint so insert a
		        // replacement char (U+FFFD) and advance only 1 byte
		        codePoint = 0xFFFD;
		        bytesPerSequence = 1;
		      } else if (codePoint > 0xFFFF) {
		        // encode to utf16 (surrogate pair dance)
		        codePoint -= 0x10000;
		        res.push(codePoint >>> 10 & 0x3FF | 0xD800);
		        codePoint = 0xDC00 | codePoint & 0x3FF;
		      }

		      res.push(codePoint);
		      i += bytesPerSequence;
		    }

		    return decodeCodePointsArray(res)
		  }

		  // Based on http://stackoverflow.com/a/22747272/680742, the browser with
		  // the lowest limit is Chrome, with 0x10000 args.
		  // We go 1 magnitude less, for safety
		  var MAX_ARGUMENTS_LENGTH = 0x1000;

		  function decodeCodePointsArray (codePoints) {
		    var len = codePoints.length;
		    if (len <= MAX_ARGUMENTS_LENGTH) {
		      return String.fromCharCode.apply(String, codePoints) // avoid extra slice()
		    }

		    // Decode in chunks to avoid "call stack size exceeded".
		    var res = '';
		    var i = 0;
		    while (i < len) {
		      res += String.fromCharCode.apply(
		        String,
		        codePoints.slice(i, i += MAX_ARGUMENTS_LENGTH)
		      );
		    }
		    return res
		  }

		  function asciiSlice (buf, start, end) {
		    var ret = '';
		    end = Math.min(buf.length, end);

		    for (var i = start; i < end; ++i) {
		      ret += String.fromCharCode(buf[i] & 0x7F);
		    }
		    return ret
		  }

		  function latin1Slice (buf, start, end) {
		    var ret = '';
		    end = Math.min(buf.length, end);

		    for (var i = start; i < end; ++i) {
		      ret += String.fromCharCode(buf[i]);
		    }
		    return ret
		  }

		  function hexSlice (buf, start, end) {
		    var len = buf.length;

		    if (!start || start < 0) start = 0;
		    if (!end || end < 0 || end > len) end = len;

		    var out = '';
		    for (var i = start; i < end; ++i) {
		      out += toHex(buf[i]);
		    }
		    return out
		  }

		  function utf16leSlice (buf, start, end) {
		    var bytes = buf.slice(start, end);
		    var res = '';
		    for (var i = 0; i < bytes.length; i += 2) {
		      res += String.fromCharCode(bytes[i] + bytes[i + 1] * 256);
		    }
		    return res
		  }

		  Buffer$1.prototype.slice = function slice (start, end) {
		    var len = this.length;
		    start = ~~start;
		    end = end === undefined ? len : ~~end;

		    if (start < 0) {
		      start += len;
		      if (start < 0) start = 0;
		    } else if (start > len) {
		      start = len;
		    }

		    if (end < 0) {
		      end += len;
		      if (end < 0) end = 0;
		    } else if (end > len) {
		      end = len;
		    }

		    if (end < start) end = start;

		    var newBuf;
		    if (Buffer$1.TYPED_ARRAY_SUPPORT) {
		      newBuf = this.subarray(start, end);
		      newBuf.__proto__ = Buffer$1.prototype;
		    } else {
		      var sliceLen = end - start;
		      newBuf = new Buffer$1(sliceLen, undefined);
		      for (var i = 0; i < sliceLen; ++i) {
		        newBuf[i] = this[i + start];
		      }
		    }

		    return newBuf
		  };

		  /*
		   * Need to make sure that buffer isn't trying to write out of bounds.
		   */
		  function checkOffset (offset, ext, length) {
		    if ((offset % 1) !== 0 || offset < 0) throw new RangeError('offset is not uint')
		    if (offset + ext > length) throw new RangeError('Trying to access beyond buffer length')
		  }

		  Buffer$1.prototype.readUIntLE = function readUIntLE (offset, byteLength, noAssert) {
		    offset = offset | 0;
		    byteLength = byteLength | 0;
		    if (!noAssert) checkOffset(offset, byteLength, this.length);

		    var val = this[offset];
		    var mul = 1;
		    var i = 0;
		    while (++i < byteLength && (mul *= 0x100)) {
		      val += this[offset + i] * mul;
		    }

		    return val
		  };

		  Buffer$1.prototype.readUIntBE = function readUIntBE (offset, byteLength, noAssert) {
		    offset = offset | 0;
		    byteLength = byteLength | 0;
		    if (!noAssert) {
		      checkOffset(offset, byteLength, this.length);
		    }

		    var val = this[offset + --byteLength];
		    var mul = 1;
		    while (byteLength > 0 && (mul *= 0x100)) {
		      val += this[offset + --byteLength] * mul;
		    }

		    return val
		  };

		  Buffer$1.prototype.readUInt8 = function readUInt8 (offset, noAssert) {
		    if (!noAssert) checkOffset(offset, 1, this.length);
		    return this[offset]
		  };

		  Buffer$1.prototype.readUInt16LE = function readUInt16LE (offset, noAssert) {
		    if (!noAssert) checkOffset(offset, 2, this.length);
		    return this[offset] | (this[offset + 1] << 8)
		  };

		  Buffer$1.prototype.readUInt16BE = function readUInt16BE (offset, noAssert) {
		    if (!noAssert) checkOffset(offset, 2, this.length);
		    return (this[offset] << 8) | this[offset + 1]
		  };

		  Buffer$1.prototype.readUInt32LE = function readUInt32LE (offset, noAssert) {
		    if (!noAssert) checkOffset(offset, 4, this.length);

		    return ((this[offset]) |
		        (this[offset + 1] << 8) |
		        (this[offset + 2] << 16)) +
		        (this[offset + 3] * 0x1000000)
		  };

		  Buffer$1.prototype.readUInt32BE = function readUInt32BE (offset, noAssert) {
		    if (!noAssert) checkOffset(offset, 4, this.length);

		    return (this[offset] * 0x1000000) +
		      ((this[offset + 1] << 16) |
		      (this[offset + 2] << 8) |
		      this[offset + 3])
		  };

		  Buffer$1.prototype.readIntLE = function readIntLE (offset, byteLength, noAssert) {
		    offset = offset | 0;
		    byteLength = byteLength | 0;
		    if (!noAssert) checkOffset(offset, byteLength, this.length);

		    var val = this[offset];
		    var mul = 1;
		    var i = 0;
		    while (++i < byteLength && (mul *= 0x100)) {
		      val += this[offset + i] * mul;
		    }
		    mul *= 0x80;

		    if (val >= mul) val -= Math.pow(2, 8 * byteLength);

		    return val
		  };

		  Buffer$1.prototype.readIntBE = function readIntBE (offset, byteLength, noAssert) {
		    offset = offset | 0;
		    byteLength = byteLength | 0;
		    if (!noAssert) checkOffset(offset, byteLength, this.length);

		    var i = byteLength;
		    var mul = 1;
		    var val = this[offset + --i];
		    while (i > 0 && (mul *= 0x100)) {
		      val += this[offset + --i] * mul;
		    }
		    mul *= 0x80;

		    if (val >= mul) val -= Math.pow(2, 8 * byteLength);

		    return val
		  };

		  Buffer$1.prototype.readInt8 = function readInt8 (offset, noAssert) {
		    if (!noAssert) checkOffset(offset, 1, this.length);
		    if (!(this[offset] & 0x80)) return (this[offset])
		    return ((0xff - this[offset] + 1) * -1)
		  };

		  Buffer$1.prototype.readInt16LE = function readInt16LE (offset, noAssert) {
		    if (!noAssert) checkOffset(offset, 2, this.length);
		    var val = this[offset] | (this[offset + 1] << 8);
		    return (val & 0x8000) ? val | 0xFFFF0000 : val
		  };

		  Buffer$1.prototype.readInt16BE = function readInt16BE (offset, noAssert) {
		    if (!noAssert) checkOffset(offset, 2, this.length);
		    var val = this[offset + 1] | (this[offset] << 8);
		    return (val & 0x8000) ? val | 0xFFFF0000 : val
		  };

		  Buffer$1.prototype.readInt32LE = function readInt32LE (offset, noAssert) {
		    if (!noAssert) checkOffset(offset, 4, this.length);

		    return (this[offset]) |
		      (this[offset + 1] << 8) |
		      (this[offset + 2] << 16) |
		      (this[offset + 3] << 24)
		  };

		  Buffer$1.prototype.readInt32BE = function readInt32BE (offset, noAssert) {
		    if (!noAssert) checkOffset(offset, 4, this.length);

		    return (this[offset] << 24) |
		      (this[offset + 1] << 16) |
		      (this[offset + 2] << 8) |
		      (this[offset + 3])
		  };

		  Buffer$1.prototype.readFloatLE = function readFloatLE (offset, noAssert) {
		    if (!noAssert) checkOffset(offset, 4, this.length);
		    return read(this, offset, true, 23, 4)
		  };

		  Buffer$1.prototype.readFloatBE = function readFloatBE (offset, noAssert) {
		    if (!noAssert) checkOffset(offset, 4, this.length);
		    return read(this, offset, false, 23, 4)
		  };

		  Buffer$1.prototype.readDoubleLE = function readDoubleLE (offset, noAssert) {
		    if (!noAssert) checkOffset(offset, 8, this.length);
		    return read(this, offset, true, 52, 8)
		  };

		  Buffer$1.prototype.readDoubleBE = function readDoubleBE (offset, noAssert) {
		    if (!noAssert) checkOffset(offset, 8, this.length);
		    return read(this, offset, false, 52, 8)
		  };

		  function checkInt (buf, value, offset, ext, max, min) {
		    if (!internalIsBuffer(buf)) throw new TypeError('"buffer" argument must be a Buffer instance')
		    if (value > max || value < min) throw new RangeError('"value" argument is out of bounds')
		    if (offset + ext > buf.length) throw new RangeError('Index out of range')
		  }

		  Buffer$1.prototype.writeUIntLE = function writeUIntLE (value, offset, byteLength, noAssert) {
		    value = +value;
		    offset = offset | 0;
		    byteLength = byteLength | 0;
		    if (!noAssert) {
		      var maxBytes = Math.pow(2, 8 * byteLength) - 1;
		      checkInt(this, value, offset, byteLength, maxBytes, 0);
		    }

		    var mul = 1;
		    var i = 0;
		    this[offset] = value & 0xFF;
		    while (++i < byteLength && (mul *= 0x100)) {
		      this[offset + i] = (value / mul) & 0xFF;
		    }

		    return offset + byteLength
		  };

		  Buffer$1.prototype.writeUIntBE = function writeUIntBE (value, offset, byteLength, noAssert) {
		    value = +value;
		    offset = offset | 0;
		    byteLength = byteLength | 0;
		    if (!noAssert) {
		      var maxBytes = Math.pow(2, 8 * byteLength) - 1;
		      checkInt(this, value, offset, byteLength, maxBytes, 0);
		    }

		    var i = byteLength - 1;
		    var mul = 1;
		    this[offset + i] = value & 0xFF;
		    while (--i >= 0 && (mul *= 0x100)) {
		      this[offset + i] = (value / mul) & 0xFF;
		    }

		    return offset + byteLength
		  };

		  Buffer$1.prototype.writeUInt8 = function writeUInt8 (value, offset, noAssert) {
		    value = +value;
		    offset = offset | 0;
		    if (!noAssert) checkInt(this, value, offset, 1, 0xff, 0);
		    if (!Buffer$1.TYPED_ARRAY_SUPPORT) value = Math.floor(value);
		    this[offset] = (value & 0xff);
		    return offset + 1
		  };

		  function objectWriteUInt16 (buf, value, offset, littleEndian) {
		    if (value < 0) value = 0xffff + value + 1;
		    for (var i = 0, j = Math.min(buf.length - offset, 2); i < j; ++i) {
		      buf[offset + i] = (value & (0xff << (8 * (littleEndian ? i : 1 - i)))) >>>
		        (littleEndian ? i : 1 - i) * 8;
		    }
		  }

		  Buffer$1.prototype.writeUInt16LE = function writeUInt16LE (value, offset, noAssert) {
		    value = +value;
		    offset = offset | 0;
		    if (!noAssert) checkInt(this, value, offset, 2, 0xffff, 0);
		    if (Buffer$1.TYPED_ARRAY_SUPPORT) {
		      this[offset] = (value & 0xff);
		      this[offset + 1] = (value >>> 8);
		    } else {
		      objectWriteUInt16(this, value, offset, true);
		    }
		    return offset + 2
		  };

		  Buffer$1.prototype.writeUInt16BE = function writeUInt16BE (value, offset, noAssert) {
		    value = +value;
		    offset = offset | 0;
		    if (!noAssert) checkInt(this, value, offset, 2, 0xffff, 0);
		    if (Buffer$1.TYPED_ARRAY_SUPPORT) {
		      this[offset] = (value >>> 8);
		      this[offset + 1] = (value & 0xff);
		    } else {
		      objectWriteUInt16(this, value, offset, false);
		    }
		    return offset + 2
		  };

		  function objectWriteUInt32 (buf, value, offset, littleEndian) {
		    if (value < 0) value = 0xffffffff + value + 1;
		    for (var i = 0, j = Math.min(buf.length - offset, 4); i < j; ++i) {
		      buf[offset + i] = (value >>> (littleEndian ? i : 3 - i) * 8) & 0xff;
		    }
		  }

		  Buffer$1.prototype.writeUInt32LE = function writeUInt32LE (value, offset, noAssert) {
		    value = +value;
		    offset = offset | 0;
		    if (!noAssert) checkInt(this, value, offset, 4, 0xffffffff, 0);
		    if (Buffer$1.TYPED_ARRAY_SUPPORT) {
		      this[offset + 3] = (value >>> 24);
		      this[offset + 2] = (value >>> 16);
		      this[offset + 1] = (value >>> 8);
		      this[offset] = (value & 0xff);
		    } else {
		      objectWriteUInt32(this, value, offset, true);
		    }
		    return offset + 4
		  };

		  Buffer$1.prototype.writeUInt32BE = function writeUInt32BE (value, offset, noAssert) {
		    value = +value;
		    offset = offset | 0;
		    if (!noAssert) checkInt(this, value, offset, 4, 0xffffffff, 0);
		    if (Buffer$1.TYPED_ARRAY_SUPPORT) {
		      this[offset] = (value >>> 24);
		      this[offset + 1] = (value >>> 16);
		      this[offset + 2] = (value >>> 8);
		      this[offset + 3] = (value & 0xff);
		    } else {
		      objectWriteUInt32(this, value, offset, false);
		    }
		    return offset + 4
		  };

		  Buffer$1.prototype.writeIntLE = function writeIntLE (value, offset, byteLength, noAssert) {
		    value = +value;
		    offset = offset | 0;
		    if (!noAssert) {
		      var limit = Math.pow(2, 8 * byteLength - 1);

		      checkInt(this, value, offset, byteLength, limit - 1, -limit);
		    }

		    var i = 0;
		    var mul = 1;
		    var sub = 0;
		    this[offset] = value & 0xFF;
		    while (++i < byteLength && (mul *= 0x100)) {
		      if (value < 0 && sub === 0 && this[offset + i - 1] !== 0) {
		        sub = 1;
		      }
		      this[offset + i] = ((value / mul) >> 0) - sub & 0xFF;
		    }

		    return offset + byteLength
		  };

		  Buffer$1.prototype.writeIntBE = function writeIntBE (value, offset, byteLength, noAssert) {
		    value = +value;
		    offset = offset | 0;
		    if (!noAssert) {
		      var limit = Math.pow(2, 8 * byteLength - 1);

		      checkInt(this, value, offset, byteLength, limit - 1, -limit);
		    }

		    var i = byteLength - 1;
		    var mul = 1;
		    var sub = 0;
		    this[offset + i] = value & 0xFF;
		    while (--i >= 0 && (mul *= 0x100)) {
		      if (value < 0 && sub === 0 && this[offset + i + 1] !== 0) {
		        sub = 1;
		      }
		      this[offset + i] = ((value / mul) >> 0) - sub & 0xFF;
		    }

		    return offset + byteLength
		  };

		  Buffer$1.prototype.writeInt8 = function writeInt8 (value, offset, noAssert) {
		    value = +value;
		    offset = offset | 0;
		    if (!noAssert) checkInt(this, value, offset, 1, 0x7f, -0x80);
		    if (!Buffer$1.TYPED_ARRAY_SUPPORT) value = Math.floor(value);
		    if (value < 0) value = 0xff + value + 1;
		    this[offset] = (value & 0xff);
		    return offset + 1
		  };

		  Buffer$1.prototype.writeInt16LE = function writeInt16LE (value, offset, noAssert) {
		    value = +value;
		    offset = offset | 0;
		    if (!noAssert) checkInt(this, value, offset, 2, 0x7fff, -0x8000);
		    if (Buffer$1.TYPED_ARRAY_SUPPORT) {
		      this[offset] = (value & 0xff);
		      this[offset + 1] = (value >>> 8);
		    } else {
		      objectWriteUInt16(this, value, offset, true);
		    }
		    return offset + 2
		  };

		  Buffer$1.prototype.writeInt16BE = function writeInt16BE (value, offset, noAssert) {
		    value = +value;
		    offset = offset | 0;
		    if (!noAssert) checkInt(this, value, offset, 2, 0x7fff, -0x8000);
		    if (Buffer$1.TYPED_ARRAY_SUPPORT) {
		      this[offset] = (value >>> 8);
		      this[offset + 1] = (value & 0xff);
		    } else {
		      objectWriteUInt16(this, value, offset, false);
		    }
		    return offset + 2
		  };

		  Buffer$1.prototype.writeInt32LE = function writeInt32LE (value, offset, noAssert) {
		    value = +value;
		    offset = offset | 0;
		    if (!noAssert) checkInt(this, value, offset, 4, 0x7fffffff, -0x80000000);
		    if (Buffer$1.TYPED_ARRAY_SUPPORT) {
		      this[offset] = (value & 0xff);
		      this[offset + 1] = (value >>> 8);
		      this[offset + 2] = (value >>> 16);
		      this[offset + 3] = (value >>> 24);
		    } else {
		      objectWriteUInt32(this, value, offset, true);
		    }
		    return offset + 4
		  };

		  Buffer$1.prototype.writeInt32BE = function writeInt32BE (value, offset, noAssert) {
		    value = +value;
		    offset = offset | 0;
		    if (!noAssert) checkInt(this, value, offset, 4, 0x7fffffff, -0x80000000);
		    if (value < 0) value = 0xffffffff + value + 1;
		    if (Buffer$1.TYPED_ARRAY_SUPPORT) {
		      this[offset] = (value >>> 24);
		      this[offset + 1] = (value >>> 16);
		      this[offset + 2] = (value >>> 8);
		      this[offset + 3] = (value & 0xff);
		    } else {
		      objectWriteUInt32(this, value, offset, false);
		    }
		    return offset + 4
		  };

		  function checkIEEE754 (buf, value, offset, ext, max, min) {
		    if (offset + ext > buf.length) throw new RangeError('Index out of range')
		    if (offset < 0) throw new RangeError('Index out of range')
		  }

		  function writeFloat (buf, value, offset, littleEndian, noAssert) {
		    if (!noAssert) {
		      checkIEEE754(buf, value, offset, 4);
		    }
		    write(buf, value, offset, littleEndian, 23, 4);
		    return offset + 4
		  }

		  Buffer$1.prototype.writeFloatLE = function writeFloatLE (value, offset, noAssert) {
		    return writeFloat(this, value, offset, true, noAssert)
		  };

		  Buffer$1.prototype.writeFloatBE = function writeFloatBE (value, offset, noAssert) {
		    return writeFloat(this, value, offset, false, noAssert)
		  };

		  function writeDouble (buf, value, offset, littleEndian, noAssert) {
		    if (!noAssert) {
		      checkIEEE754(buf, value, offset, 8);
		    }
		    write(buf, value, offset, littleEndian, 52, 8);
		    return offset + 8
		  }

		  Buffer$1.prototype.writeDoubleLE = function writeDoubleLE (value, offset, noAssert) {
		    return writeDouble(this, value, offset, true, noAssert)
		  };

		  Buffer$1.prototype.writeDoubleBE = function writeDoubleBE (value, offset, noAssert) {
		    return writeDouble(this, value, offset, false, noAssert)
		  };

		  // copy(targetBuffer, targetStart=0, sourceStart=0, sourceEnd=buffer.length)
		  Buffer$1.prototype.copy = function copy (target, targetStart, start, end) {
		    if (!start) start = 0;
		    if (!end && end !== 0) end = this.length;
		    if (targetStart >= target.length) targetStart = target.length;
		    if (!targetStart) targetStart = 0;
		    if (end > 0 && end < start) end = start;

		    // Copy 0 bytes; we're done
		    if (end === start) return 0
		    if (target.length === 0 || this.length === 0) return 0

		    // Fatal error conditions
		    if (targetStart < 0) {
		      throw new RangeError('targetStart out of bounds')
		    }
		    if (start < 0 || start >= this.length) throw new RangeError('sourceStart out of bounds')
		    if (end < 0) throw new RangeError('sourceEnd out of bounds')

		    // Are we oob?
		    if (end > this.length) end = this.length;
		    if (target.length - targetStart < end - start) {
		      end = target.length - targetStart + start;
		    }

		    var len = end - start;
		    var i;

		    if (this === target && start < targetStart && targetStart < end) {
		      // descending copy from end
		      for (i = len - 1; i >= 0; --i) {
		        target[i + targetStart] = this[i + start];
		      }
		    } else if (len < 1000 || !Buffer$1.TYPED_ARRAY_SUPPORT) {
		      // ascending copy from start
		      for (i = 0; i < len; ++i) {
		        target[i + targetStart] = this[i + start];
		      }
		    } else {
		      Uint8Array.prototype.set.call(
		        target,
		        this.subarray(start, start + len),
		        targetStart
		      );
		    }

		    return len
		  };

		  // Usage:
		  //    buffer.fill(number[, offset[, end]])
		  //    buffer.fill(buffer[, offset[, end]])
		  //    buffer.fill(string[, offset[, end]][, encoding])
		  Buffer$1.prototype.fill = function fill (val, start, end, encoding) {
		    // Handle string cases:
		    if (typeof val === 'string') {
		      if (typeof start === 'string') {
		        encoding = start;
		        start = 0;
		        end = this.length;
		      } else if (typeof end === 'string') {
		        encoding = end;
		        end = this.length;
		      }
		      if (val.length === 1) {
		        var code = val.charCodeAt(0);
		        if (code < 256) {
		          val = code;
		        }
		      }
		      if (encoding !== undefined && typeof encoding !== 'string') {
		        throw new TypeError('encoding must be a string')
		      }
		      if (typeof encoding === 'string' && !Buffer$1.isEncoding(encoding)) {
		        throw new TypeError('Unknown encoding: ' + encoding)
		      }
		    } else if (typeof val === 'number') {
		      val = val & 255;
		    }

		    // Invalid ranges are not set to a default, so can range check early.
		    if (start < 0 || this.length < start || this.length < end) {
		      throw new RangeError('Out of range index')
		    }

		    if (end <= start) {
		      return this
		    }

		    start = start >>> 0;
		    end = end === undefined ? this.length : end >>> 0;

		    if (!val) val = 0;

		    var i;
		    if (typeof val === 'number') {
		      for (i = start; i < end; ++i) {
		        this[i] = val;
		      }
		    } else {
		      var bytes = internalIsBuffer(val)
		        ? val
		        : utf8ToBytes(new Buffer$1(val, encoding).toString());
		      var len = bytes.length;
		      for (i = 0; i < end - start; ++i) {
		        this[i + start] = bytes[i % len];
		      }
		    }

		    return this
		  };

		  // HELPER FUNCTIONS
		  // ================

		  var INVALID_BASE64_RE = /[^+\/0-9A-Za-z-_]/g;

		  function base64clean (str) {
		    // Node strips out invalid characters like \n and \t from the string, base64-js does not
		    str = stringtrim(str).replace(INVALID_BASE64_RE, '');
		    // Node converts strings with length < 2 to ''
		    if (str.length < 2) return ''
		    // Node allows for non-padded base64 strings (missing trailing ===), base64-js does not
		    while (str.length % 4 !== 0) {
		      str = str + '=';
		    }
		    return str
		  }

		  function stringtrim (str) {
		    if (str.trim) return str.trim()
		    return str.replace(/^\s+|\s+$/g, '')
		  }

		  function toHex (n) {
		    if (n < 16) return '0' + n.toString(16)
		    return n.toString(16)
		  }

		  function utf8ToBytes (string, units) {
		    units = units || Infinity;
		    var codePoint;
		    var length = string.length;
		    var leadSurrogate = null;
		    var bytes = [];

		    for (var i = 0; i < length; ++i) {
		      codePoint = string.charCodeAt(i);

		      // is surrogate component
		      if (codePoint > 0xD7FF && codePoint < 0xE000) {
		        // last char was a lead
		        if (!leadSurrogate) {
		          // no lead yet
		          if (codePoint > 0xDBFF) {
		            // unexpected trail
		            if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD);
		            continue
		          } else if (i + 1 === length) {
		            // unpaired lead
		            if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD);
		            continue
		          }

		          // valid lead
		          leadSurrogate = codePoint;

		          continue
		        }

		        // 2 leads in a row
		        if (codePoint < 0xDC00) {
		          if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD);
		          leadSurrogate = codePoint;
		          continue
		        }

		        // valid surrogate pair
		        codePoint = (leadSurrogate - 0xD800 << 10 | codePoint - 0xDC00) + 0x10000;
		      } else if (leadSurrogate) {
		        // valid bmp char, but last char was a lead
		        if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD);
		      }

		      leadSurrogate = null;

		      // encode utf8
		      if (codePoint < 0x80) {
		        if ((units -= 1) < 0) break
		        bytes.push(codePoint);
		      } else if (codePoint < 0x800) {
		        if ((units -= 2) < 0) break
		        bytes.push(
		          codePoint >> 0x6 | 0xC0,
		          codePoint & 0x3F | 0x80
		        );
		      } else if (codePoint < 0x10000) {
		        if ((units -= 3) < 0) break
		        bytes.push(
		          codePoint >> 0xC | 0xE0,
		          codePoint >> 0x6 & 0x3F | 0x80,
		          codePoint & 0x3F | 0x80
		        );
		      } else if (codePoint < 0x110000) {
		        if ((units -= 4) < 0) break
		        bytes.push(
		          codePoint >> 0x12 | 0xF0,
		          codePoint >> 0xC & 0x3F | 0x80,
		          codePoint >> 0x6 & 0x3F | 0x80,
		          codePoint & 0x3F | 0x80
		        );
		      } else {
		        throw new Error('Invalid code point')
		      }
		    }

		    return bytes
		  }

		  function asciiToBytes (str) {
		    var byteArray = [];
		    for (var i = 0; i < str.length; ++i) {
		      // Node's code seems to be doing this and not & 0x7F..
		      byteArray.push(str.charCodeAt(i) & 0xFF);
		    }
		    return byteArray
		  }

		  function utf16leToBytes (str, units) {
		    var c, hi, lo;
		    var byteArray = [];
		    for (var i = 0; i < str.length; ++i) {
		      if ((units -= 2) < 0) break

		      c = str.charCodeAt(i);
		      hi = c >> 8;
		      lo = c % 256;
		      byteArray.push(lo);
		      byteArray.push(hi);
		    }

		    return byteArray
		  }


		  function base64ToBytes (str) {
		    return toByteArray(base64clean(str))
		  }

		  function blitBuffer (src, dst, offset, length) {
		    for (var i = 0; i < length; ++i) {
		      if ((i + offset >= dst.length) || (i >= src.length)) break
		      dst[i + offset] = src[i];
		    }
		    return i
		  }

		  function isnan (val) {
		    return val !== val // eslint-disable-line no-self-compare
		  }


		  // the following is from is-buffer, also by Feross Aboukhadijeh and with same lisence
		  // The _isBuffer check is for Safari 5-7 support, because it's missing
		  // Object.prototype.constructor. Remove this eventually
		  function isBuffer$1(obj) {
		    return obj != null && (!!obj._isBuffer || isFastBuffer(obj) || isSlowBuffer(obj))
		  }

		  function isFastBuffer (obj) {
		    return !!obj.constructor && typeof obj.constructor.isBuffer === 'function' && obj.constructor.isBuffer(obj)
		  }

		  // For Node v0.10 support. Remove this eventually.
		  function isSlowBuffer (obj) {
		    return typeof obj.readFloatLE === 'function' && typeof obj.slice === 'function' && isFastBuffer(obj.slice(0, 0))
		  }

		  var sourcemapCodec_umd = {exports: {}};

		  var hasRequiredSourcemapCodec_umd;
		  function requireSourcemapCodec_umd() {
		    if (hasRequiredSourcemapCodec_umd) return sourcemapCodec_umd.exports;
		    hasRequiredSourcemapCodec_umd = 1;
		    (function (module, exports) {
		      (function (global, factory) {
		        factory(exports) ;
		      })(commonjsGlobal$1, function (exports) {

		        var comma = ','.charCodeAt(0);
		        var semicolon = ';'.charCodeAt(0);
		        var chars = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
		        var intToChar = new Uint8Array(64);
		        var charToInt = new Uint8Array(128);
		        for (var i = 0; i < chars.length; i++) {
		          var c = chars.charCodeAt(i);
		          intToChar[i] = c;
		          charToInt[c] = i;
		        }
		        var td = typeof TextDecoder !== 'undefined' ? new TextDecoder() : typeof Buffer$1 !== 'undefined' ? {
		          decode: function decode(buf) {
		            var out = Buffer$1.from(buf.buffer, buf.byteOffset, buf.byteLength);
		            return out.toString();
		          }
		        } : {
		          decode: function decode(buf) {
		            var out = '';
		            for (var _i = 0; _i < buf.length; _i++) {
		              out += String.fromCharCode(buf[_i]);
		            }
		            return out;
		          }
		        };
		        function decode(mappings) {
		          var state = new Int32Array(5);
		          var decoded = [];
		          var index = 0;
		          do {
		            var semi = indexOf(mappings, index);
		            var line = [];
		            var sorted = true;
		            var lastCol = 0;
		            state[0] = 0;
		            for (var _i2 = index; _i2 < semi; _i2++) {
		              var seg = void 0;
		              _i2 = decodeInteger(mappings, _i2, state, 0);
		              var col = state[0];
		              if (col < lastCol) sorted = false;
		              lastCol = col;
		              if (hasMoreVlq(mappings, _i2, semi)) {
		                _i2 = decodeInteger(mappings, _i2, state, 1);
		                _i2 = decodeInteger(mappings, _i2, state, 2);
		                _i2 = decodeInteger(mappings, _i2, state, 3);
		                if (hasMoreVlq(mappings, _i2, semi)) {
		                  _i2 = decodeInteger(mappings, _i2, state, 4);
		                  seg = [col, state[1], state[2], state[3], state[4]];
		                } else {
		                  seg = [col, state[1], state[2], state[3]];
		                }
		              } else {
		                seg = [col];
		              }
		              line.push(seg);
		            }
		            if (!sorted) sort(line);
		            decoded.push(line);
		            index = semi + 1;
		          } while (index <= mappings.length);
		          return decoded;
		        }
		        function indexOf(mappings, index) {
		          var idx = mappings.indexOf(';', index);
		          return idx === -1 ? mappings.length : idx;
		        }
		        function decodeInteger(mappings, pos, state, j) {
		          var value = 0;
		          var shift = 0;
		          var integer = 0;
		          do {
		            var _c = mappings.charCodeAt(pos++);
		            integer = charToInt[_c];
		            value |= (integer & 31) << shift;
		            shift += 5;
		          } while (integer & 32);
		          var shouldNegate = value & 1;
		          value >>>= 1;
		          if (shouldNegate) {
		            value = -0x80000000 | -value;
		          }
		          state[j] += value;
		          return pos;
		        }
		        function hasMoreVlq(mappings, i, length) {
		          if (i >= length) return false;
		          return mappings.charCodeAt(i) !== comma;
		        }
		        function sort(line) {
		          line.sort(sortComparator);
		        }
		        function sortComparator(a, b) {
		          return a[0] - b[0];
		        }
		        function encode(decoded) {
		          var state = new Int32Array(5);
		          var bufLength = 1024 * 16;
		          var subLength = bufLength - 36;
		          var buf = new Uint8Array(bufLength);
		          var sub = buf.subarray(0, subLength);
		          var pos = 0;
		          var out = '';
		          for (var _i3 = 0; _i3 < decoded.length; _i3++) {
		            var line = decoded[_i3];
		            if (_i3 > 0) {
		              if (pos === bufLength) {
		                out += td.decode(buf);
		                pos = 0;
		              }
		              buf[pos++] = semicolon;
		            }
		            if (line.length === 0) continue;
		            state[0] = 0;
		            for (var j = 0; j < line.length; j++) {
		              var segment = line[j];
		              if (pos > subLength) {
		                out += td.decode(sub);
		                buf.copyWithin(0, subLength, pos);
		                pos -= subLength;
		              }
		              if (j > 0) buf[pos++] = comma;
		              pos = encodeInteger(buf, pos, state, segment, 0);
		              if (segment.length === 1) continue;
		              pos = encodeInteger(buf, pos, state, segment, 1);
		              pos = encodeInteger(buf, pos, state, segment, 2);
		              pos = encodeInteger(buf, pos, state, segment, 3);
		              if (segment.length === 4) continue;
		              pos = encodeInteger(buf, pos, state, segment, 4);
		            }
		          }
		          return out + td.decode(buf.subarray(0, pos));
		        }
		        function encodeInteger(buf, pos, state, segment, j) {
		          var next = segment[j];
		          var num = next - state[j];
		          state[j] = next;
		          num = num < 0 ? -num << 1 | 1 : num << 1;
		          do {
		            var clamped = num & 31;
		            num >>>= 5;
		            if (num > 0) clamped |= 32;
		            buf[pos++] = intToChar[clamped];
		          } while (num > 0);
		          return pos;
		        }
		        exports.decode = decode;
		        exports.encode = encode;
		        Object.defineProperty(exports, '__esModule', {
		          value: true
		        });
		      });
		    })(sourcemapCodec_umd, sourcemapCodec_umd.exports);
		    return sourcemapCodec_umd.exports;
		  }

		  var traceMapping_umd = {exports: {}};

		  var resolveUri_umd = {exports: {}};

		  var hasRequiredResolveUri_umd;
		  function requireResolveUri_umd() {
		    if (hasRequiredResolveUri_umd) return resolveUri_umd.exports;
		    hasRequiredResolveUri_umd = 1;
		    (function (module, exports) {
		      (function (global, factory) {
		        module.exports = factory() ;
		      })(commonjsGlobal$1, function () {
		        var schemeRegex = /^[\w+.-]+:\/\//;
		        var urlRegex = /^([\w+.-]+:)\/\/([^@/#?]*@)?([^:/#?]*)(:\d+)?(\/[^#?]*)?(\?[^#]*)?(#.*)?/;
		        var fileRegex = /^file:(?:\/\/((?![a-z]:)[^/#?]*)?)?(\/?[^#?]*)(\?[^#]*)?(#.*)?/i;
		        function isAbsoluteUrl(input) {
		          return schemeRegex.test(input);
		        }
		        function isSchemeRelativeUrl(input) {
		          return input.startsWith('//');
		        }
		        function isAbsolutePath(input) {
		          return input.startsWith('/');
		        }
		        function isFileUrl(input) {
		          return input.startsWith('file:');
		        }
		        function isRelative(input) {
		          return /^[.?#]/.test(input);
		        }
		        function parseAbsoluteUrl(input) {
		          var match = urlRegex.exec(input);
		          return makeUrl(match[1], match[2] || '', match[3], match[4] || '', match[5] || '/', match[6] || '', match[7] || '');
		        }
		        function parseFileUrl(input) {
		          var match = fileRegex.exec(input);
		          var path = match[2];
		          return makeUrl('file:', '', match[1] || '', '', isAbsolutePath(path) ? path : '/' + path, match[3] || '', match[4] || '');
		        }
		        function makeUrl(scheme, user, host, port, path, query, hash) {
		          return {
		            scheme: scheme,
		            user: user,
		            host: host,
		            port: port,
		            path: path,
		            query: query,
		            hash: hash,
		            type: 7
		          };
		        }
		        function parseUrl(input) {
		          if (isSchemeRelativeUrl(input)) {
		            var _url = parseAbsoluteUrl('http:' + input);
		            _url.scheme = '';
		            _url.type = 6;
		            return _url;
		          }
		          if (isAbsolutePath(input)) {
		            var _url2 = parseAbsoluteUrl('http://foo.com' + input);
		            _url2.scheme = '';
		            _url2.host = '';
		            _url2.type = 5;
		            return _url2;
		          }
		          if (isFileUrl(input)) return parseFileUrl(input);
		          if (isAbsoluteUrl(input)) return parseAbsoluteUrl(input);
		          var url = parseAbsoluteUrl('http://foo.com/' + input);
		          url.scheme = '';
		          url.host = '';
		          url.type = input ? input.startsWith('?') ? 3 : input.startsWith('#') ? 2 : 4 : 1;
		          return url;
		        }
		        function stripPathFilename(path) {
		          if (path.endsWith('/..')) return path;
		          var index = path.lastIndexOf('/');
		          return path.slice(0, index + 1);
		        }
		        function mergePaths(url, base) {
		          normalizePath(base, base.type);
		          if (url.path === '/') {
		            url.path = base.path;
		          } else {
		            url.path = stripPathFilename(base.path) + url.path;
		          }
		        }
		        function normalizePath(url, type) {
		          var rel = type <= 4;
		          var pieces = url.path.split('/');
		          var pointer = 1;
		          var positive = 0;
		          var addTrailingSlash = false;
		          for (var i = 1; i < pieces.length; i++) {
		            var piece = pieces[i];
		            if (!piece) {
		              addTrailingSlash = true;
		              continue;
		            }
		            addTrailingSlash = false;
		            if (piece === '.') continue;
		            if (piece === '..') {
		              if (positive) {
		                addTrailingSlash = true;
		                positive--;
		                pointer--;
		              } else if (rel) {
		                pieces[pointer++] = piece;
		              }
		              continue;
		            }
		            pieces[pointer++] = piece;
		            positive++;
		          }
		          var path = '';
		          for (var _i = 1; _i < pointer; _i++) {
		            path += '/' + pieces[_i];
		          }
		          if (!path || addTrailingSlash && !path.endsWith('/..')) {
		            path += '/';
		          }
		          url.path = path;
		        }
		        function resolve(input, base) {
		          if (!input && !base) return '';
		          var url = parseUrl(input);
		          var inputType = url.type;
		          if (base && inputType !== 7) {
		            var baseUrl = parseUrl(base);
		            var baseType = baseUrl.type;
		            switch (inputType) {
		              case 1:
		                url.hash = baseUrl.hash;
		              case 2:
		                url.query = baseUrl.query;
		              case 3:
		              case 4:
		                mergePaths(url, baseUrl);
		              case 5:
		                url.user = baseUrl.user;
		                url.host = baseUrl.host;
		                url.port = baseUrl.port;
		              case 6:
		                url.scheme = baseUrl.scheme;
		            }
		            if (baseType > inputType) inputType = baseType;
		          }
		          normalizePath(url, inputType);
		          var queryHash = url.query + url.hash;
		          switch (inputType) {
		            case 2:
		            case 3:
		              return queryHash;
		            case 4:
		              {
		                var path = url.path.slice(1);
		                if (!path) return queryHash || '.';
		                if (isRelative(base || input) && !isRelative(path)) {
		                  return './' + path + queryHash;
		                }
		                return path + queryHash;
		              }
		            case 5:
		              return url.path + queryHash;
		            default:
		              return url.scheme + '//' + url.user + url.host + url.port + url.path + queryHash;
		          }
		        }
		        return resolve;
		      });
		    })(resolveUri_umd);
		    return resolveUri_umd.exports;
		  }

		  (function (module, exports) {
		    (function (global, factory) {
		      factory(exports, requireSourcemapCodec_umd(), requireResolveUri_umd()) ;
		    })(commonjsGlobal$1, function (exports, sourcemapCodec, resolveUri) {

		      function resolve(input, base) {
		        if (base && !base.endsWith('/')) base += '/';
		        return resolveUri(input, base);
		      }
		      function stripFilename(path) {
		        if (!path) return '';
		        var index = path.lastIndexOf('/');
		        return path.slice(0, index + 1);
		      }
		      var COLUMN = 0;
		      var SOURCES_INDEX = 1;
		      var SOURCE_LINE = 2;
		      var SOURCE_COLUMN = 3;
		      var NAMES_INDEX = 4;
		      var REV_GENERATED_LINE = 1;
		      var REV_GENERATED_COLUMN = 2;
		      function maybeSort(mappings, owned) {
		        var unsortedIndex = nextUnsortedSegmentLine(mappings, 0);
		        if (unsortedIndex === mappings.length) return mappings;
		        if (!owned) mappings = mappings.slice();
		        for (var i = unsortedIndex; i < mappings.length; i = nextUnsortedSegmentLine(mappings, i + 1)) {
		          mappings[i] = sortSegments(mappings[i], owned);
		        }
		        return mappings;
		      }
		      function nextUnsortedSegmentLine(mappings, start) {
		        for (var i = start; i < mappings.length; i++) {
		          if (!isSorted(mappings[i])) return i;
		        }
		        return mappings.length;
		      }
		      function isSorted(line) {
		        for (var j = 1; j < line.length; j++) {
		          if (line[j][COLUMN] < line[j - 1][COLUMN]) {
		            return false;
		          }
		        }
		        return true;
		      }
		      function sortSegments(line, owned) {
		        if (!owned) line = line.slice();
		        return line.sort(sortComparator);
		      }
		      function sortComparator(a, b) {
		        return a[COLUMN] - b[COLUMN];
		      }
		      var found = false;
		      function binarySearch(haystack, needle, low, high) {
		        while (low <= high) {
		          var mid = low + (high - low >> 1);
		          var cmp = haystack[mid][COLUMN] - needle;
		          if (cmp === 0) {
		            found = true;
		            return mid;
		          }
		          if (cmp < 0) {
		            low = mid + 1;
		          } else {
		            high = mid - 1;
		          }
		        }
		        found = false;
		        return low - 1;
		      }
		      function upperBound(haystack, needle, index) {
		        for (var i = index + 1; i < haystack.length; index = i++) {
		          if (haystack[i][COLUMN] !== needle) break;
		        }
		        return index;
		      }
		      function lowerBound(haystack, needle, index) {
		        for (var i = index - 1; i >= 0; index = i--) {
		          if (haystack[i][COLUMN] !== needle) break;
		        }
		        return index;
		      }
		      function memoizedState() {
		        return {
		          lastKey: -1,
		          lastNeedle: -1,
		          lastIndex: -1
		        };
		      }
		      function memoizedBinarySearch(haystack, needle, state, key) {
		        var lastKey = state.lastKey,
		          lastNeedle = state.lastNeedle,
		          lastIndex = state.lastIndex;
		        var low = 0;
		        var high = haystack.length - 1;
		        if (key === lastKey) {
		          if (needle === lastNeedle) {
		            found = lastIndex !== -1 && haystack[lastIndex][COLUMN] === needle;
		            return lastIndex;
		          }
		          if (needle >= lastNeedle) {
		            low = lastIndex === -1 ? 0 : lastIndex;
		          } else {
		            high = lastIndex;
		          }
		        }
		        state.lastKey = key;
		        state.lastNeedle = needle;
		        return state.lastIndex = binarySearch(haystack, needle, low, high);
		      }
		      function buildBySources(decoded, memos) {
		        var sources = memos.map(buildNullArray);
		        for (var i = 0; i < decoded.length; i++) {
		          var line = decoded[i];
		          for (var j = 0; j < line.length; j++) {
		            var seg = line[j];
		            if (seg.length === 1) continue;
		            var _sourceIndex = seg[SOURCES_INDEX];
		            var sourceLine = seg[SOURCE_LINE];
		            var sourceColumn = seg[SOURCE_COLUMN];
		            var originalSource = sources[_sourceIndex];
		            var originalLine = originalSource[sourceLine] || (originalSource[sourceLine] = []);
		            var memo = memos[_sourceIndex];
		            var index = upperBound(originalLine, sourceColumn, memoizedBinarySearch(originalLine, sourceColumn, memo, sourceLine));
		            memo.lastIndex = ++index;
		            insert(originalLine, index, [sourceColumn, i, seg[COLUMN]]);
		          }
		        }
		        return sources;
		      }
		      function insert(array, index, value) {
		        for (var i = array.length; i > index; i--) {
		          array[i] = array[i - 1];
		        }
		        array[index] = value;
		      }
		      function buildNullArray() {
		        return {
		          __proto__: null
		        };
		      }
		      var AnyMap = function AnyMap(map, mapUrl) {
		        var parsed = parse(map);
		        if (!('sections' in parsed)) {
		          return new TraceMap(parsed, mapUrl);
		        }
		        var mappings = [];
		        var sources = [];
		        var sourcesContent = [];
		        var names = [];
		        var ignoreList = [];
		        recurse(parsed, mapUrl, mappings, sources, sourcesContent, names, ignoreList, 0, 0, Infinity, Infinity);
		        var joined = {
		          version: 3,
		          file: parsed.file,
		          names: names,
		          sources: sources,
		          sourcesContent: sourcesContent,
		          mappings: mappings,
		          ignoreList: ignoreList
		        };
		        return presortedDecodedMap(joined);
		      };
		      function parse(map) {
		        return typeof map === 'string' ? JSON.parse(map) : map;
		      }
		      function recurse(input, mapUrl, mappings, sources, sourcesContent, names, ignoreList, lineOffset, columnOffset, stopLine, stopColumn) {
		        var sections = input.sections;
		        for (var i = 0; i < sections.length; i++) {
		          var _sections$i = sections[i],
		            map = _sections$i.map,
		            offset = _sections$i.offset;
		          var sl = stopLine;
		          var sc = stopColumn;
		          if (i + 1 < sections.length) {
		            var nextOffset = sections[i + 1].offset;
		            sl = Math.min(stopLine, lineOffset + nextOffset.line);
		            if (sl === stopLine) {
		              sc = Math.min(stopColumn, columnOffset + nextOffset.column);
		            } else if (sl < stopLine) {
		              sc = columnOffset + nextOffset.column;
		            }
		          }
		          addSection(map, mapUrl, mappings, sources, sourcesContent, names, ignoreList, lineOffset + offset.line, columnOffset + offset.column, sl, sc);
		        }
		      }
		      function addSection(input, mapUrl, mappings, sources, sourcesContent, names, ignoreList, lineOffset, columnOffset, stopLine, stopColumn) {
		        var parsed = parse(input);
		        if ('sections' in parsed) return recurse.apply(void 0, arguments);
		        var map = new TraceMap(parsed, mapUrl);
		        var sourcesOffset = sources.length;
		        var namesOffset = names.length;
		        var decoded = decodedMappings(map);
		        var resolvedSources = map.resolvedSources,
		          contents = map.sourcesContent,
		          ignores = map.ignoreList;
		        append(sources, resolvedSources);
		        append(names, map.names);
		        if (contents) append(sourcesContent, contents);else for (var i = 0; i < resolvedSources.length; i++) sourcesContent.push(null);
		        if (ignores) for (var _i = 0; _i < ignores.length; _i++) ignoreList.push(ignores[_i] + sourcesOffset);
		        for (var _i2 = 0; _i2 < decoded.length; _i2++) {
		          var lineI = lineOffset + _i2;
		          if (lineI > stopLine) return;
		          var out = getLine(mappings, lineI);
		          var cOffset = _i2 === 0 ? columnOffset : 0;
		          var line = decoded[_i2];
		          for (var j = 0; j < line.length; j++) {
		            var seg = line[j];
		            var column = cOffset + seg[COLUMN];
		            if (lineI === stopLine && column >= stopColumn) return;
		            if (seg.length === 1) {
		              out.push([column]);
		              continue;
		            }
		            var sourcesIndex = sourcesOffset + seg[SOURCES_INDEX];
		            var sourceLine = seg[SOURCE_LINE];
		            var sourceColumn = seg[SOURCE_COLUMN];
		            out.push(seg.length === 4 ? [column, sourcesIndex, sourceLine, sourceColumn] : [column, sourcesIndex, sourceLine, sourceColumn, namesOffset + seg[NAMES_INDEX]]);
		          }
		        }
		      }
		      function append(arr, other) {
		        for (var i = 0; i < other.length; i++) arr.push(other[i]);
		      }
		      function getLine(arr, index) {
		        for (var i = arr.length; i <= index; i++) arr[i] = [];
		        return arr[index];
		      }
		      var LINE_GTR_ZERO = '`line` must be greater than 0 (lines start at line 1)';
		      var COL_GTR_EQ_ZERO = '`column` must be greater than or equal to 0 (columns start at column 0)';
		      var LEAST_UPPER_BOUND = -1;
		      var GREATEST_LOWER_BOUND = 1;
		      var TraceMap = _createClass(function TraceMap(map, mapUrl) {
		        var isString = typeof map === 'string';
		        if (!isString && map._decodedMemo) return map;
		        var parsed = isString ? JSON.parse(map) : map;
		        var version = parsed.version,
		          file = parsed.file,
		          names = parsed.names,
		          sourceRoot = parsed.sourceRoot,
		          sources = parsed.sources,
		          sourcesContent = parsed.sourcesContent;
		        this.version = version;
		        this.file = file;
		        this.names = names || [];
		        this.sourceRoot = sourceRoot;
		        this.sources = sources;
		        this.sourcesContent = sourcesContent;
		        this.ignoreList = parsed.ignoreList || parsed.x_google_ignoreList || undefined;
		        var from = resolve(sourceRoot || '', stripFilename(mapUrl));
		        this.resolvedSources = sources.map(function (s) {
		          return resolve(s || '', from);
		        });
		        var mappings = parsed.mappings;
		        if (typeof mappings === 'string') {
		          this._encoded = mappings;
		          this._decoded = undefined;
		        } else {
		          this._encoded = undefined;
		          this._decoded = maybeSort(mappings, isString);
		        }
		        this._decodedMemo = memoizedState();
		        this._bySources = undefined;
		        this._bySourceMemos = undefined;
		      });
		      function cast(map) {
		        return map;
		      }
		      function encodedMappings(map) {
		        var _a;
		        var _b;
		        return (_a = (_b = cast(map))._encoded) !== null && _a !== void 0 ? _a : _b._encoded = sourcemapCodec.encode(cast(map)._decoded);
		      }
		      function decodedMappings(map) {
		        var _a;
		        return (_a = cast(map))._decoded || (_a._decoded = sourcemapCodec.decode(cast(map)._encoded));
		      }
		      function traceSegment(map, line, column) {
		        var decoded = decodedMappings(map);
		        if (line >= decoded.length) return null;
		        var segments = decoded[line];
		        var index = traceSegmentInternal(segments, cast(map)._decodedMemo, line, column, GREATEST_LOWER_BOUND);
		        return index === -1 ? null : segments[index];
		      }
		      function originalPositionFor(map, needle) {
		        var line = needle.line,
		          column = needle.column,
		          bias = needle.bias;
		        line--;
		        if (line < 0) throw new Error(LINE_GTR_ZERO);
		        if (column < 0) throw new Error(COL_GTR_EQ_ZERO);
		        var decoded = decodedMappings(map);
		        if (line >= decoded.length) return OMapping(null, null, null, null);
		        var segments = decoded[line];
		        var index = traceSegmentInternal(segments, cast(map)._decodedMemo, line, column, bias || GREATEST_LOWER_BOUND);
		        if (index === -1) return OMapping(null, null, null, null);
		        var segment = segments[index];
		        if (segment.length === 1) return OMapping(null, null, null, null);
		        var names = map.names,
		          resolvedSources = map.resolvedSources;
		        return OMapping(resolvedSources[segment[SOURCES_INDEX]], segment[SOURCE_LINE] + 1, segment[SOURCE_COLUMN], segment.length === 5 ? names[segment[NAMES_INDEX]] : null);
		      }
		      function generatedPositionFor(map, needle) {
		        var source = needle.source,
		          line = needle.line,
		          column = needle.column,
		          bias = needle.bias;
		        return generatedPosition(map, source, line, column, bias || GREATEST_LOWER_BOUND, false);
		      }
		      function allGeneratedPositionsFor(map, needle) {
		        var source = needle.source,
		          line = needle.line,
		          column = needle.column,
		          bias = needle.bias;
		        return generatedPosition(map, source, line, column, bias || LEAST_UPPER_BOUND, true);
		      }
		      function eachMapping(map, cb) {
		        var decoded = decodedMappings(map);
		        var names = map.names,
		          resolvedSources = map.resolvedSources;
		        for (var i = 0; i < decoded.length; i++) {
		          var line = decoded[i];
		          for (var j = 0; j < line.length; j++) {
		            var seg = line[j];
		            var generatedLine = i + 1;
		            var generatedColumn = seg[0];
		            var source = null;
		            var originalLine = null;
		            var originalColumn = null;
		            var name = null;
		            if (seg.length !== 1) {
		              source = resolvedSources[seg[1]];
		              originalLine = seg[2] + 1;
		              originalColumn = seg[3];
		            }
		            if (seg.length === 5) name = names[seg[4]];
		            cb({
		              generatedLine: generatedLine,
		              generatedColumn: generatedColumn,
		              source: source,
		              originalLine: originalLine,
		              originalColumn: originalColumn,
		              name: name
		            });
		          }
		        }
		      }
		      function sourceIndex(map, source) {
		        var sources = map.sources,
		          resolvedSources = map.resolvedSources;
		        var index = sources.indexOf(source);
		        if (index === -1) index = resolvedSources.indexOf(source);
		        return index;
		      }
		      function sourceContentFor(map, source) {
		        var sourcesContent = map.sourcesContent;
		        if (sourcesContent == null) return null;
		        var index = sourceIndex(map, source);
		        return index === -1 ? null : sourcesContent[index];
		      }
		      function isIgnored(map, source) {
		        var ignoreList = map.ignoreList;
		        if (ignoreList == null) return false;
		        var index = sourceIndex(map, source);
		        return index === -1 ? false : ignoreList.includes(index);
		      }
		      function presortedDecodedMap(map, mapUrl) {
		        var tracer = new TraceMap(clone(map, []), mapUrl);
		        cast(tracer)._decoded = map.mappings;
		        return tracer;
		      }
		      function decodedMap(map) {
		        return clone(map, decodedMappings(map));
		      }
		      function encodedMap(map) {
		        return clone(map, encodedMappings(map));
		      }
		      function clone(map, mappings) {
		        return {
		          version: map.version,
		          file: map.file,
		          names: map.names,
		          sourceRoot: map.sourceRoot,
		          sources: map.sources,
		          sourcesContent: map.sourcesContent,
		          mappings: mappings,
		          ignoreList: map.ignoreList || map.x_google_ignoreList
		        };
		      }
		      function OMapping(source, line, column, name) {
		        return {
		          source: source,
		          line: line,
		          column: column,
		          name: name
		        };
		      }
		      function GMapping(line, column) {
		        return {
		          line: line,
		          column: column
		        };
		      }
		      function traceSegmentInternal(segments, memo, line, column, bias) {
		        var index = memoizedBinarySearch(segments, column, memo, line);
		        if (found) {
		          index = (bias === LEAST_UPPER_BOUND ? upperBound : lowerBound)(segments, column, index);
		        } else if (bias === LEAST_UPPER_BOUND) index++;
		        if (index === -1 || index === segments.length) return -1;
		        return index;
		      }
		      function sliceGeneratedPositions(segments, memo, line, column, bias) {
		        var min = traceSegmentInternal(segments, memo, line, column, GREATEST_LOWER_BOUND);
		        if (!found && bias === LEAST_UPPER_BOUND) min++;
		        if (min === -1 || min === segments.length) return [];
		        var matchedColumn = found ? column : segments[min][COLUMN];
		        if (!found) min = lowerBound(segments, matchedColumn, min);
		        var max = upperBound(segments, matchedColumn, min);
		        var result = [];
		        for (; min <= max; min++) {
		          var segment = segments[min];
		          result.push(GMapping(segment[REV_GENERATED_LINE] + 1, segment[REV_GENERATED_COLUMN]));
		        }
		        return result;
		      }
		      function generatedPosition(map, source, line, column, bias, all) {
		        var _a;
		        line--;
		        if (line < 0) throw new Error(LINE_GTR_ZERO);
		        if (column < 0) throw new Error(COL_GTR_EQ_ZERO);
		        var sources = map.sources,
		          resolvedSources = map.resolvedSources;
		        var sourceIndex = sources.indexOf(source);
		        if (sourceIndex === -1) sourceIndex = resolvedSources.indexOf(source);
		        if (sourceIndex === -1) return all ? [] : GMapping(null, null);
		        var generated = (_a = cast(map))._bySources || (_a._bySources = buildBySources(decodedMappings(map), cast(map)._bySourceMemos = sources.map(memoizedState)));
		        var segments = generated[sourceIndex][line];
		        if (segments == null) return all ? [] : GMapping(null, null);
		        var memo = cast(map)._bySourceMemos[sourceIndex];
		        if (all) return sliceGeneratedPositions(segments, memo, line, column, bias);
		        var index = traceSegmentInternal(segments, memo, line, column, bias);
		        if (index === -1) return GMapping(null, null);
		        var segment = segments[index];
		        return GMapping(segment[REV_GENERATED_LINE] + 1, segment[REV_GENERATED_COLUMN]);
		      }
		      exports.AnyMap = AnyMap;
		      exports.GREATEST_LOWER_BOUND = GREATEST_LOWER_BOUND;
		      exports.LEAST_UPPER_BOUND = LEAST_UPPER_BOUND;
		      exports.TraceMap = TraceMap;
		      exports.allGeneratedPositionsFor = allGeneratedPositionsFor;
		      exports.decodedMap = decodedMap;
		      exports.decodedMappings = decodedMappings;
		      exports.eachMapping = eachMapping;
		      exports.encodedMap = encodedMap;
		      exports.encodedMappings = encodedMappings;
		      exports.generatedPositionFor = generatedPositionFor;
		      exports.isIgnored = isIgnored;
		      exports.originalPositionFor = originalPositionFor;
		      exports.presortedDecodedMap = presortedDecodedMap;
		      exports.sourceContentFor = sourceContentFor;
		      exports.traceSegment = traceSegment;
		    });
		  })(traceMapping_umd, traceMapping_umd.exports);
		  var traceMapping_umdExports = traceMapping_umd.exports;

		  (function (module, exports) {
		    (function (global, factory) {
		      factory(exports, requireSetArray_umd(), requireSourcemapCodec_umd(), traceMapping_umdExports) ;
		    })(commonjsGlobal$1, function (exports, setArray, sourcemapCodec, traceMapping) {

		      var COLUMN = 0;
		      var SOURCES_INDEX = 1;
		      var SOURCE_LINE = 2;
		      var SOURCE_COLUMN = 3;
		      var NAMES_INDEX = 4;
		      var NO_NAME = -1;
		      var GenMapping = _createClass(function GenMapping(_temp) {
		        var _ref = _temp === void 0 ? {} : _temp,
		          file = _ref.file,
		          sourceRoot = _ref.sourceRoot;
		        this._names = new setArray.SetArray();
		        this._sources = new setArray.SetArray();
		        this._sourcesContent = [];
		        this._mappings = [];
		        this.file = file;
		        this.sourceRoot = sourceRoot;
		        this._ignoreList = new setArray.SetArray();
		      });
		      function cast(map) {
		        return map;
		      }
		      function addSegment(map, genLine, genColumn, source, sourceLine, sourceColumn, name, content) {
		        return addSegmentInternal(false, map, genLine, genColumn, source, sourceLine, sourceColumn, name, content);
		      }
		      function addMapping(map, mapping) {
		        return addMappingInternal(false, map, mapping);
		      }
		      var maybeAddSegment = function maybeAddSegment(map, genLine, genColumn, source, sourceLine, sourceColumn, name, content) {
		        return addSegmentInternal(true, map, genLine, genColumn, source, sourceLine, sourceColumn, name, content);
		      };
		      var maybeAddMapping = function maybeAddMapping(map, mapping) {
		        return addMappingInternal(true, map, mapping);
		      };
		      function setSourceContent(map, source, content) {
		        var _cast = cast(map),
		          sources = _cast._sources,
		          sourcesContent = _cast._sourcesContent;
		        var index = setArray.put(sources, source);
		        sourcesContent[index] = content;
		      }
		      function setIgnore(map, source, ignore) {
		        if (ignore === void 0) {
		          ignore = true;
		        }
		        var _cast2 = cast(map),
		          sources = _cast2._sources,
		          sourcesContent = _cast2._sourcesContent,
		          ignoreList = _cast2._ignoreList;
		        var index = setArray.put(sources, source);
		        if (index === sourcesContent.length) sourcesContent[index] = null;
		        if (ignore) setArray.put(ignoreList, index);else setArray.remove(ignoreList, index);
		      }
		      function toDecodedMap(map) {
		        var _cast3 = cast(map),
		          mappings = _cast3._mappings,
		          sources = _cast3._sources,
		          sourcesContent = _cast3._sourcesContent,
		          names = _cast3._names,
		          ignoreList = _cast3._ignoreList;
		        removeEmptyFinalLines(mappings);
		        return {
		          version: 3,
		          file: map.file || undefined,
		          names: names.array,
		          sourceRoot: map.sourceRoot || undefined,
		          sources: sources.array,
		          sourcesContent: sourcesContent,
		          mappings: mappings,
		          ignoreList: ignoreList.array
		        };
		      }
		      function toEncodedMap(map) {
		        var decoded = toDecodedMap(map);
		        return Object.assign(Object.assign({}, decoded), {
		          mappings: sourcemapCodec.encode(decoded.mappings)
		        });
		      }
		      function fromMap(input) {
		        var map = new traceMapping.TraceMap(input);
		        var gen = new GenMapping({
		          file: map.file,
		          sourceRoot: map.sourceRoot
		        });
		        putAll(cast(gen)._names, map.names);
		        putAll(cast(gen)._sources, map.sources);
		        cast(gen)._sourcesContent = map.sourcesContent || map.sources.map(function () {
		          return null;
		        });
		        cast(gen)._mappings = traceMapping.decodedMappings(map);
		        if (map.ignoreList) putAll(cast(gen)._ignoreList, map.ignoreList);
		        return gen;
		      }
		      function allMappings(map) {
		        var out = [];
		        var _cast4 = cast(map),
		          mappings = _cast4._mappings,
		          sources = _cast4._sources,
		          names = _cast4._names;
		        for (var i = 0; i < mappings.length; i++) {
		          var line = mappings[i];
		          for (var j = 0; j < line.length; j++) {
		            var seg = line[j];
		            var generated = {
		              line: i + 1,
		              column: seg[COLUMN]
		            };
		            var source = undefined;
		            var original = undefined;
		            var name = undefined;
		            if (seg.length !== 1) {
		              source = sources.array[seg[SOURCES_INDEX]];
		              original = {
		                line: seg[SOURCE_LINE] + 1,
		                column: seg[SOURCE_COLUMN]
		              };
		              if (seg.length === 5) name = names.array[seg[NAMES_INDEX]];
		            }
		            out.push({
		              generated: generated,
		              source: source,
		              original: original,
		              name: name
		            });
		          }
		        }
		        return out;
		      }
		      function addSegmentInternal(skipable, map, genLine, genColumn, source, sourceLine, sourceColumn, name, content) {
		        var _cast5 = cast(map),
		          mappings = _cast5._mappings,
		          sources = _cast5._sources,
		          sourcesContent = _cast5._sourcesContent,
		          names = _cast5._names;
		        var line = getLine(mappings, genLine);
		        var index = getColumnIndex(line, genColumn);
		        if (!source) {
		          if (skipable && skipSourceless(line, index)) return;
		          return insert(line, index, [genColumn]);
		        }
		        var sourcesIndex = setArray.put(sources, source);
		        var namesIndex = name ? setArray.put(names, name) : NO_NAME;
		        if (sourcesIndex === sourcesContent.length) sourcesContent[sourcesIndex] = content !== null && content !== void 0 ? content : null;
		        if (skipable && skipSource(line, index, sourcesIndex, sourceLine, sourceColumn, namesIndex)) {
		          return;
		        }
		        return insert(line, index, name ? [genColumn, sourcesIndex, sourceLine, sourceColumn, namesIndex] : [genColumn, sourcesIndex, sourceLine, sourceColumn]);
		      }
		      function getLine(mappings, index) {
		        for (var i = mappings.length; i <= index; i++) {
		          mappings[i] = [];
		        }
		        return mappings[index];
		      }
		      function getColumnIndex(line, genColumn) {
		        var index = line.length;
		        for (var i = index - 1; i >= 0; index = i--) {
		          var current = line[i];
		          if (genColumn >= current[COLUMN]) break;
		        }
		        return index;
		      }
		      function insert(array, index, value) {
		        for (var i = array.length; i > index; i--) {
		          array[i] = array[i - 1];
		        }
		        array[index] = value;
		      }
		      function removeEmptyFinalLines(mappings) {
		        var length = mappings.length;
		        var len = length;
		        for (var i = len - 1; i >= 0; len = i, i--) {
		          if (mappings[i].length > 0) break;
		        }
		        if (len < length) mappings.length = len;
		      }
		      function putAll(setarr, array) {
		        for (var i = 0; i < array.length; i++) setArray.put(setarr, array[i]);
		      }
		      function skipSourceless(line, index) {
		        if (index === 0) return true;
		        var prev = line[index - 1];
		        return prev.length === 1;
		      }
		      function skipSource(line, index, sourcesIndex, sourceLine, sourceColumn, namesIndex) {
		        if (index === 0) return false;
		        var prev = line[index - 1];
		        if (prev.length === 1) return false;
		        return sourcesIndex === prev[SOURCES_INDEX] && sourceLine === prev[SOURCE_LINE] && sourceColumn === prev[SOURCE_COLUMN] && namesIndex === (prev.length === 5 ? prev[NAMES_INDEX] : NO_NAME);
		      }
		      function addMappingInternal(skipable, map, mapping) {
		        var generated = mapping.generated,
		          source = mapping.source,
		          original = mapping.original,
		          name = mapping.name,
		          content = mapping.content;
		        if (!source) {
		          return addSegmentInternal(skipable, map, generated.line - 1, generated.column, null, null, null, null, null);
		        }
		        return addSegmentInternal(skipable, map, generated.line - 1, generated.column, source, original.line - 1, original.column, name, content);
		      }
		      exports.GenMapping = GenMapping;
		      exports.addMapping = addMapping;
		      exports.addSegment = addSegment;
		      exports.allMappings = allMappings;
		      exports.fromMap = fromMap;
		      exports.maybeAddMapping = maybeAddMapping;
		      exports.maybeAddSegment = maybeAddSegment;
		      exports.setIgnore = setIgnore;
		      exports.setSourceContent = setSourceContent;
		      exports.toDecodedMap = toDecodedMap;
		      exports.toEncodedMap = toEncodedMap;
		      Object.defineProperty(exports, '__esModule', {
		        value: true
		      });
		    });
		  })(genMapping_umd$1, genMapping_umd$1.exports);
		  var genMapping_umdExports$1 = genMapping_umd$1.exports;

		  var SourceMap$1 = function () {
		    function SourceMap(opts, code) {
		      var _opts$sourceFileName;
		      this._map = void 0;
		      this._rawMappings = void 0;
		      this._sourceFileName = void 0;
		      this._lastGenLine = 0;
		      this._lastSourceLine = 0;
		      this._lastSourceColumn = 0;
		      this._inputMap = void 0;
		      var map = this._map = new genMapping_umdExports$1.GenMapping({
		        sourceRoot: opts.sourceRoot
		      });
		      this._sourceFileName = (_opts$sourceFileName = opts.sourceFileName) == null ? void 0 : _opts$sourceFileName.replace(/\\/g, "/");
		      this._rawMappings = undefined;
		      if (opts.inputSourceMap) {
		        this._inputMap = new traceMapping_umdExports.TraceMap(opts.inputSourceMap);
		        var resolvedSources = this._inputMap.resolvedSources;
		        if (resolvedSources.length) {
		          for (var i = 0; i < resolvedSources.length; i++) {
		            var _this$_inputMap$sourc;
		            genMapping_umdExports$1.setSourceContent(map, resolvedSources[i], (_this$_inputMap$sourc = this._inputMap.sourcesContent) == null ? void 0 : _this$_inputMap$sourc[i]);
		          }
		        }
		      }
		      if (typeof code === "string" && !opts.inputSourceMap) {
		        genMapping_umdExports$1.setSourceContent(map, this._sourceFileName, code);
		      } else if (typeof code === "object") {
		        for (var _i = 0, _Object$keys = Object.keys(code); _i < _Object$keys.length; _i++) {
		          var _sourceFileName = _Object$keys[_i];
		          genMapping_umdExports$1.setSourceContent(map, _sourceFileName.replace(/\\/g, "/"), code[_sourceFileName]);
		        }
		      }
		    }
		    var _proto = SourceMap.prototype;
		    _proto.get = function get() {
		      return genMapping_umdExports$1.toEncodedMap(this._map);
		    };
		    _proto.getDecoded = function getDecoded() {
		      return genMapping_umdExports$1.toDecodedMap(this._map);
		    };
		    _proto.getRawMappings = function getRawMappings() {
		      return this._rawMappings || (this._rawMappings = genMapping_umdExports$1.allMappings(this._map));
		    };
		    _proto.mark = function mark(generated, line, column, identifierName, identifierNamePos, filename) {
		      var _originalMapping;
		      this._rawMappings = undefined;
		      var originalMapping;
		      if (line != null) {
		        if (this._inputMap) {
		          originalMapping = traceMapping_umdExports.originalPositionFor(this._inputMap, {
		            line: line,
		            column: column
		          });
		          if (!originalMapping.name && identifierNamePos) {
		            var originalIdentifierMapping = traceMapping_umdExports.originalPositionFor(this._inputMap, identifierNamePos);
		            if (originalIdentifierMapping.name) {
		              identifierName = originalIdentifierMapping.name;
		            }
		          }
		        } else {
		          originalMapping = {
		            source: (filename == null ? void 0 : filename.replace(/\\/g, "/")) || this._sourceFileName,
		            line: line,
		            column: column
		          };
		        }
		      }
		      genMapping_umdExports$1.maybeAddMapping(this._map, {
		        name: identifierName,
		        generated: generated,
		        source: (_originalMapping = originalMapping) == null ? void 0 : _originalMapping.source,
		        original: originalMapping
		      });
		    };
		    return _createClass(SourceMap);
		  }();

		  var Buffer = function () {
		    function Buffer(map, indentChar) {
		      this._map = null;
		      this._buf = "";
		      this._str = "";
		      this._appendCount = 0;
		      this._last = 0;
		      this._queue = [];
		      this._queueCursor = 0;
		      this._canMarkIdName = true;
		      this._indentChar = "";
		      this._fastIndentations = [];
		      this._position = {
		        line: 1,
		        column: 0
		      };
		      this._sourcePosition = {
		        identifierName: undefined,
		        identifierNamePos: undefined,
		        line: undefined,
		        column: undefined,
		        filename: undefined
		      };
		      this._map = map;
		      this._indentChar = indentChar;
		      for (var i = 0; i < 64; i++) {
		        this._fastIndentations.push(indentChar.repeat(i));
		      }
		      this._allocQueue();
		    }
		    var _proto = Buffer.prototype;
		    _proto._allocQueue = function _allocQueue() {
		      var queue = this._queue;
		      for (var i = 0; i < 16; i++) {
		        queue.push({
		          "char": 0,
		          repeat: 1,
		          line: undefined,
		          column: undefined,
		          identifierName: undefined,
		          identifierNamePos: undefined,
		          filename: ""
		        });
		      }
		    };
		    _proto._pushQueue = function _pushQueue(_char, repeat, line, column, filename) {
		      var cursor = this._queueCursor;
		      if (cursor === this._queue.length) {
		        this._allocQueue();
		      }
		      var item = this._queue[cursor];
		      item["char"] = _char;
		      item.repeat = repeat;
		      item.line = line;
		      item.column = column;
		      item.filename = filename;
		      this._queueCursor++;
		    };
		    _proto._popQueue = function _popQueue() {
		      if (this._queueCursor === 0) {
		        throw new Error("Cannot pop from empty queue");
		      }
		      return this._queue[--this._queueCursor];
		    };
		    _proto.get = function get() {
		      this._flush();
		      var map = this._map;
		      var result = {
		        code: (this._buf + this._str).trimRight(),
		        decodedMap: map == null ? void 0 : map.getDecoded(),
		        get __mergedMap() {
		          return this.map;
		        },
		        get map() {
		          var resultMap = map ? map.get() : null;
		          result.map = resultMap;
		          return resultMap;
		        },
		        set map(value) {
		          Object.defineProperty(result, "map", {
		            value: value,
		            writable: true
		          });
		        },
		        get rawMappings() {
		          var mappings = map == null ? void 0 : map.getRawMappings();
		          result.rawMappings = mappings;
		          return mappings;
		        },
		        set rawMappings(value) {
		          Object.defineProperty(result, "rawMappings", {
		            value: value,
		            writable: true
		          });
		        }
		      };
		      return result;
		    };
		    _proto.append = function append(str, maybeNewline) {
		      this._flush();
		      this._append(str, this._sourcePosition, maybeNewline);
		    };
		    _proto.appendChar = function appendChar(_char2) {
		      this._flush();
		      this._appendChar(_char2, 1, this._sourcePosition);
		    };
		    _proto.queue = function queue(_char3) {
		      if (_char3 === 10) {
		        while (this._queueCursor !== 0) {
		          var _char4 = this._queue[this._queueCursor - 1]["char"];
		          if (_char4 !== 32 && _char4 !== 9) {
		            break;
		          }
		          this._queueCursor--;
		        }
		      }
		      var sourcePosition = this._sourcePosition;
		      this._pushQueue(_char3, 1, sourcePosition.line, sourcePosition.column, sourcePosition.filename);
		    };
		    _proto.queueIndentation = function queueIndentation(repeat) {
		      if (repeat === 0) return;
		      this._pushQueue(-1, repeat, undefined, undefined, undefined);
		    };
		    _proto._flush = function _flush() {
		      var queueCursor = this._queueCursor;
		      var queue = this._queue;
		      for (var i = 0; i < queueCursor; i++) {
		        var item = queue[i];
		        this._appendChar(item["char"], item.repeat, item);
		      }
		      this._queueCursor = 0;
		    };
		    _proto._appendChar = function _appendChar(_char5, repeat, sourcePos) {
		      this._last = _char5;
		      if (_char5 === -1) {
		        var fastIndentation = this._fastIndentations[repeat];
		        if (fastIndentation !== undefined) {
		          this._str += fastIndentation;
		        } else {
		          this._str += repeat > 1 ? this._indentChar.repeat(repeat) : this._indentChar;
		        }
		      } else {
		        this._str += repeat > 1 ? String.fromCharCode(_char5).repeat(repeat) : String.fromCharCode(_char5);
		      }
		      if (_char5 !== 10) {
		        this._mark(sourcePos.line, sourcePos.column, sourcePos.identifierName, sourcePos.identifierNamePos, sourcePos.filename);
		        this._position.column += repeat;
		      } else {
		        this._position.line++;
		        this._position.column = 0;
		      }
		      if (this._canMarkIdName) {
		        sourcePos.identifierName = undefined;
		        sourcePos.identifierNamePos = undefined;
		      }
		    };
		    _proto._append = function _append(str, sourcePos, maybeNewline) {
		      var len = str.length;
		      var position = this._position;
		      this._last = str.charCodeAt(len - 1);
		      if (++this._appendCount > 4096) {
		        +this._str;
		        this._buf += this._str;
		        this._str = str;
		        this._appendCount = 0;
		      } else {
		        this._str += str;
		      }
		      if (!maybeNewline && !this._map) {
		        position.column += len;
		        return;
		      }
		      var column = sourcePos.column,
		        identifierName = sourcePos.identifierName,
		        identifierNamePos = sourcePos.identifierNamePos,
		        filename = sourcePos.filename;
		      var line = sourcePos.line;
		      if ((identifierName != null || identifierNamePos != null) && this._canMarkIdName) {
		        sourcePos.identifierName = undefined;
		        sourcePos.identifierNamePos = undefined;
		      }
		      var i = str.indexOf("\n");
		      var last = 0;
		      if (i !== 0) {
		        this._mark(line, column, identifierName, identifierNamePos, filename);
		      }
		      while (i !== -1) {
		        position.line++;
		        position.column = 0;
		        last = i + 1;
		        if (last < len && line !== undefined) {
		          this._mark(++line, 0, null, null, filename);
		        }
		        i = str.indexOf("\n", last);
		      }
		      position.column += len - last;
		    };
		    _proto._mark = function _mark(line, column, identifierName, identifierNamePos, filename) {
		      var _this$_map;
		      (_this$_map = this._map) == null || _this$_map.mark(this._position, line, column, identifierName, identifierNamePos, filename);
		    };
		    _proto.removeTrailingNewline = function removeTrailingNewline() {
		      var queueCursor = this._queueCursor;
		      if (queueCursor !== 0 && this._queue[queueCursor - 1]["char"] === 10) {
		        this._queueCursor--;
		      }
		    };
		    _proto.removeLastSemicolon = function removeLastSemicolon() {
		      var queueCursor = this._queueCursor;
		      if (queueCursor !== 0 && this._queue[queueCursor - 1]["char"] === 59) {
		        this._queueCursor--;
		      }
		    };
		    _proto.getLastChar = function getLastChar() {
		      var queueCursor = this._queueCursor;
		      return queueCursor !== 0 ? this._queue[queueCursor - 1]["char"] : this._last;
		    };
		    _proto.getNewlineCount = function getNewlineCount() {
		      var queueCursor = this._queueCursor;
		      var count = 0;
		      if (queueCursor === 0) return this._last === 10 ? 1 : 0;
		      for (var i = queueCursor - 1; i >= 0; i--) {
		        if (this._queue[i]["char"] !== 10) {
		          break;
		        }
		        count++;
		      }
		      return count === queueCursor && this._last === 10 ? count + 1 : count;
		    };
		    _proto.endsWithCharAndNewline = function endsWithCharAndNewline() {
		      var queue = this._queue;
		      var queueCursor = this._queueCursor;
		      if (queueCursor !== 0) {
		        var lastCp = queue[queueCursor - 1]["char"];
		        if (lastCp !== 10) return;
		        if (queueCursor > 1) {
		          return queue[queueCursor - 2]["char"];
		        } else {
		          return this._last;
		        }
		      }
		    };
		    _proto.hasContent = function hasContent() {
		      return this._queueCursor !== 0 || !!this._last;
		    };
		    _proto.exactSource = function exactSource(loc, cb) {
		      if (!this._map) {
		        cb();
		        return;
		      }
		      this.source("start", loc);
		      var identifierName = loc.identifierName;
		      var sourcePos = this._sourcePosition;
		      if (identifierName) {
		        this._canMarkIdName = false;
		        sourcePos.identifierName = identifierName;
		      }
		      cb();
		      if (identifierName) {
		        this._canMarkIdName = true;
		        sourcePos.identifierName = undefined;
		        sourcePos.identifierNamePos = undefined;
		      }
		      this.source("end", loc);
		    };
		    _proto.source = function source(prop, loc) {
		      if (!this._map) return;
		      this._normalizePosition(prop, loc, 0);
		    };
		    _proto.sourceWithOffset = function sourceWithOffset(prop, loc, columnOffset) {
		      if (!this._map) return;
		      this._normalizePosition(prop, loc, columnOffset);
		    };
		    _proto.withSource = function withSource(prop, loc, cb) {
		      if (this._map) {
		        this.source(prop, loc);
		      }
		      cb();
		    };
		    _proto._normalizePosition = function _normalizePosition(prop, loc, columnOffset) {
		      var pos = loc[prop];
		      var target = this._sourcePosition;
		      if (pos) {
		        target.line = pos.line;
		        target.column = Math.max(pos.column + columnOffset, 0);
		        target.filename = loc.filename;
		      }
		    };
		    _proto.getCurrentColumn = function getCurrentColumn() {
		      var queue = this._queue;
		      var queueCursor = this._queueCursor;
		      var lastIndex = -1;
		      var len = 0;
		      for (var i = 0; i < queueCursor; i++) {
		        var item = queue[i];
		        if (item["char"] === 10) {
		          lastIndex = len;
		        }
		        len += item.repeat;
		      }
		      return lastIndex === -1 ? this._position.column + len : len - 1 - lastIndex;
		    };
		    _proto.getCurrentLine = function getCurrentLine() {
		      var count = 0;
		      var queue = this._queue;
		      for (var i = 0; i < this._queueCursor; i++) {
		        if (queue[i]["char"] === 10) {
		          count++;
		        }
		      }
		      return this._position.line + count;
		    };
		    return _createClass(Buffer);
		  }();

		  var FLIPPED_ALIAS_KEYS$1 = FLIPPED_ALIAS_KEYS$3,
		    isArrayExpression = isArrayExpression$2,
		    isAssignmentExpression$2 = isAssignmentExpression$3,
		    isBinary = isBinary$2,
		    isBlockStatement$2 = isBlockStatement$3,
		    isCallExpression$6 = isCallExpression$8,
		    isFunction$4 = isFunction$5,
		    isIdentifier$f = isIdentifier$i,
		    isLiteral$4 = isLiteral$6,
		    isMemberExpression$6 = isMemberExpression$9,
		    isObjectExpression$1 = isObjectExpression$3,
		    isOptionalCallExpression$1 = isOptionalCallExpression$2,
		    isOptionalMemberExpression$2 = isOptionalMemberExpression$3,
		    isStringLiteral$4 = isStringLiteral$5;
		  function crawlInternal(node, state) {
		    if (!node) return state;
		    if (isMemberExpression$6(node) || isOptionalMemberExpression$2(node)) {
		      crawlInternal(node.object, state);
		      if (node.computed) crawlInternal(node.property, state);
		    } else if (isBinary(node) || isAssignmentExpression$2(node)) {
		      crawlInternal(node.left, state);
		      crawlInternal(node.right, state);
		    } else if (isCallExpression$6(node) || isOptionalCallExpression$1(node)) {
		      state.hasCall = true;
		      crawlInternal(node.callee, state);
		    } else if (isFunction$4(node)) {
		      state.hasFunction = true;
		    } else if (isIdentifier$f(node)) {
		      state.hasHelper = state.hasHelper || node.callee && isHelper(node.callee);
		    }
		    return state;
		  }
		  function crawl(node) {
		    return crawlInternal(node, {
		      hasCall: false,
		      hasFunction: false,
		      hasHelper: false
		    });
		  }
		  function isHelper(node) {
		    if (!node) return false;
		    if (isMemberExpression$6(node)) {
		      return isHelper(node.object) || isHelper(node.property);
		    } else if (isIdentifier$f(node)) {
		      return node.name === "require" || node.name.charCodeAt(0) === 95;
		    } else if (isCallExpression$6(node)) {
		      return isHelper(node.callee);
		    } else if (isBinary(node) || isAssignmentExpression$2(node)) {
		      return isIdentifier$f(node.left) && isHelper(node.left) || isHelper(node.right);
		    } else {
		      return false;
		    }
		  }
		  function isType$1(node) {
		    return isLiteral$4(node) || isObjectExpression$1(node) || isArrayExpression(node) || isIdentifier$f(node) || isMemberExpression$6(node);
		  }
		  var nodes = {
		    AssignmentExpression: function (_AssignmentExpression) {
		      function AssignmentExpression(_x) {
		        return _AssignmentExpression.apply(this, arguments);
		      }
		      AssignmentExpression.toString = function () {
		        return _AssignmentExpression.toString();
		      };
		      return AssignmentExpression;
		    }(function (node) {
		      var state = crawl(node.right);
		      if (state.hasCall && state.hasHelper || state.hasFunction) {
		        return state.hasFunction ? 1 | 2 : 2;
		      }
		    }),
		    SwitchCase: function (_SwitchCase) {
		      function SwitchCase(_x2, _x3) {
		        return _SwitchCase.apply(this, arguments);
		      }
		      SwitchCase.toString = function () {
		        return _SwitchCase.toString();
		      };
		      return SwitchCase;
		    }(function (node, parent) {
		      return (!!node.consequent.length || parent.cases[0] === node ? 1 : 0) | (!node.consequent.length && parent.cases[parent.cases.length - 1] === node ? 2 : 0);
		    }),
		    LogicalExpression: function (_LogicalExpression) {
		      function LogicalExpression(_x4) {
		        return _LogicalExpression.apply(this, arguments);
		      }
		      LogicalExpression.toString = function () {
		        return _LogicalExpression.toString();
		      };
		      return LogicalExpression;
		    }(function (node) {
		      if (isFunction$4(node.left) || isFunction$4(node.right)) {
		        return 2;
		      }
		    }),
		    Literal: function (_Literal) {
		      function Literal(_x5) {
		        return _Literal.apply(this, arguments);
		      }
		      Literal.toString = function () {
		        return _Literal.toString();
		      };
		      return Literal;
		    }(function (node) {
		      if (isStringLiteral$4(node) && node.value === "use strict") {
		        return 2;
		      }
		    }),
		    CallExpression: function (_CallExpression) {
		      function CallExpression(_x6) {
		        return _CallExpression.apply(this, arguments);
		      }
		      CallExpression.toString = function () {
		        return _CallExpression.toString();
		      };
		      return CallExpression;
		    }(function (node) {
		      if (isFunction$4(node.callee) || isHelper(node)) {
		        return 1 | 2;
		      }
		    }),
		    OptionalCallExpression: function (_OptionalCallExpression) {
		      function OptionalCallExpression(_x7) {
		        return _OptionalCallExpression.apply(this, arguments);
		      }
		      OptionalCallExpression.toString = function () {
		        return _OptionalCallExpression.toString();
		      };
		      return OptionalCallExpression;
		    }(function (node) {
		      if (isFunction$4(node.callee)) {
		        return 1 | 2;
		      }
		    }),
		    VariableDeclaration: function (_VariableDeclaration) {
		      function VariableDeclaration(_x8) {
		        return _VariableDeclaration.apply(this, arguments);
		      }
		      VariableDeclaration.toString = function () {
		        return _VariableDeclaration.toString();
		      };
		      return VariableDeclaration;
		    }(function (node) {
		      for (var i = 0; i < node.declarations.length; i++) {
		        var declar = node.declarations[i];
		        var enabled = isHelper(declar.id) && !isType$1(declar.init);
		        if (!enabled && declar.init) {
		          var state = crawl(declar.init);
		          enabled = isHelper(declar.init) && state.hasCall || state.hasFunction;
		        }
		        if (enabled) {
		          return 1 | 2;
		        }
		      }
		    }),
		    IfStatement: function (_IfStatement) {
		      function IfStatement(_x9) {
		        return _IfStatement.apply(this, arguments);
		      }
		      IfStatement.toString = function () {
		        return _IfStatement.toString();
		      };
		      return IfStatement;
		    }(function (node) {
		      if (isBlockStatement$2(node.consequent)) {
		        return 1 | 2;
		      }
		    })
		  };
		  nodes.ObjectProperty = nodes.ObjectTypeProperty = nodes.ObjectMethod = function (node, parent) {
		    if (parent.properties[0] === node) {
		      return 1;
		    }
		  };
		  nodes.ObjectTypeCallProperty = function (node, parent) {
		    var _parent$properties;
		    if (parent.callProperties[0] === node && !((_parent$properties = parent.properties) != null && _parent$properties.length)) {
		      return 1;
		    }
		  };
		  nodes.ObjectTypeIndexer = function (node, parent) {
		    var _parent$properties2, _parent$callPropertie;
		    if (parent.indexers[0] === node && !((_parent$properties2 = parent.properties) != null && _parent$properties2.length) && !((_parent$callPropertie = parent.callProperties) != null && _parent$callPropertie.length)) {
		      return 1;
		    }
		  };
		  nodes.ObjectTypeInternalSlot = function (node, parent) {
		    var _parent$properties3, _parent$callPropertie2, _parent$indexers;
		    if (parent.internalSlots[0] === node && !((_parent$properties3 = parent.properties) != null && _parent$properties3.length) && !((_parent$callPropertie2 = parent.callProperties) != null && _parent$callPropertie2.length) && !((_parent$indexers = parent.indexers) != null && _parent$indexers.length)) {
		      return 1;
		    }
		  };
		  [["Function", true], ["Class", true], ["Loop", true], ["LabeledStatement", true], ["SwitchStatement", true], ["TryStatement", true]].forEach(function (_ref) {
		    var _ref2 = _slicedToArray(_ref, 2),
		      type = _ref2[0],
		      amounts = _ref2[1];
		    [type].concat(FLIPPED_ALIAS_KEYS$1[type] || []).forEach(function (type) {
		      var ret = amounts ? 1 | 2 : 0;
		      nodes[type] = function () {
		        return ret;
		      };
		    });
		  });

		  var isArrayTypeAnnotation$1 = isArrayTypeAnnotation$2,
		    isArrowFunctionExpression$1 = isArrowFunctionExpression$2,
		    isBinaryExpression = isBinaryExpression$1,
		    isCallExpression$5 = isCallExpression$8,
		    isExportDeclaration = isExportDeclaration$3,
		    isForOfStatement = isForOfStatement$2,
		    isIndexedAccessType = isIndexedAccessType$1,
		    isMemberExpression$5 = isMemberExpression$9,
		    isObjectPattern = isObjectPattern$1,
		    isOptionalMemberExpression$1 = isOptionalMemberExpression$3,
		    isYieldExpression = isYieldExpression$1;
		  var PRECEDENCE = new Map([["||", 0], ["??", 0], ["|>", 0], ["&&", 1], ["|", 2], ["^", 3], ["&", 4], ["==", 5], ["===", 5], ["!=", 5], ["!==", 5], ["<", 6], [">", 6], ["<=", 6], [">=", 6], ["in", 6], ["instanceof", 6], [">>", 7], ["<<", 7], [">>>", 7], ["+", 8], ["-", 8], ["*", 9], ["/", 9], ["%", 9], ["**", 10]]);
		  function isTSTypeExpression(nodeType) {
		    return nodeType === "TSAsExpression" || nodeType === "TSSatisfiesExpression" || nodeType === "TSTypeAssertion";
		  }
		  var isClassExtendsClause = function isClassExtendsClause(node, parent) {
		    var parentType = parent.type;
		    return (parentType === "ClassDeclaration" || parentType === "ClassExpression") && parent.superClass === node;
		  };
		  var hasPostfixPart = function hasPostfixPart(node, parent) {
		    var parentType = parent.type;
		    return (parentType === "MemberExpression" || parentType === "OptionalMemberExpression") && parent.object === node || (parentType === "CallExpression" || parentType === "OptionalCallExpression" || parentType === "NewExpression") && parent.callee === node || parentType === "TaggedTemplateExpression" && parent.tag === node || parentType === "TSNonNullExpression";
		  };
		  function NullableTypeAnnotation$1(node, parent) {
		    return isArrayTypeAnnotation$1(parent);
		  }
		  function FunctionTypeAnnotation$1(node, parent, printStack) {
		    if (printStack.length < 3) return;
		    var parentType = parent.type;
		    return parentType === "UnionTypeAnnotation" || parentType === "IntersectionTypeAnnotation" || parentType === "ArrayTypeAnnotation" || parentType === "TypeAnnotation" && isArrowFunctionExpression$1(printStack[printStack.length - 3]);
		  }
		  function UpdateExpression$2(node, parent) {
		    return hasPostfixPart(node, parent) || isClassExtendsClause(node, parent);
		  }
		  function ObjectExpression$2(node, parent, printStack) {
		    return isFirstInContext(printStack, 1 | 2);
		  }
		  function DoExpression$1(node, parent, printStack) {
		    return !node.async && isFirstInContext(printStack, 1);
		  }
		  function Binary(node, parent) {
		    var parentType = parent.type;
		    if (node.operator === "**" && parentType === "BinaryExpression" && parent.operator === "**") {
		      return parent.left === node;
		    }
		    if (isClassExtendsClause(node, parent)) {
		      return true;
		    }
		    if (hasPostfixPart(node, parent) || parentType === "UnaryExpression" || parentType === "SpreadElement" || parentType === "AwaitExpression") {
		      return true;
		    }
		    if (parentType === "BinaryExpression" || parentType === "LogicalExpression") {
		      var parentPos = PRECEDENCE.get(parent.operator);
		      var nodePos = PRECEDENCE.get(node.operator);
		      if (parentPos === nodePos && parent.right === node && parentType !== "LogicalExpression" || parentPos > nodePos) {
		        return true;
		      }
		    }
		    return undefined;
		  }
		  function UnionTypeAnnotation$1(node, parent) {
		    var parentType = parent.type;
		    return parentType === "ArrayTypeAnnotation" || parentType === "NullableTypeAnnotation" || parentType === "IntersectionTypeAnnotation" || parentType === "UnionTypeAnnotation";
		  }
		  function OptionalIndexedAccessType$1(node, parent) {
		    return isIndexedAccessType(parent) && parent.objectType === node;
		  }
		  function TSAsExpression$1() {
		    return true;
		  }
		  function TSUnionType$1(node, parent) {
		    var parentType = parent.type;
		    return parentType === "TSArrayType" || parentType === "TSOptionalType" || parentType === "TSIntersectionType" || parentType === "TSUnionType" || parentType === "TSRestType";
		  }
		  function TSInferType$1(node, parent) {
		    var parentType = parent.type;
		    return parentType === "TSArrayType" || parentType === "TSOptionalType";
		  }
		  function TSInstantiationExpression$1(node, parent) {
		    var parentType = parent.type;
		    return (parentType === "CallExpression" || parentType === "OptionalCallExpression" || parentType === "NewExpression" || parentType === "TSInstantiationExpression") && !!parent.typeParameters;
		  }
		  function BinaryExpression$1(node, parent) {
		    if (node.operator === "in") {
		      var parentType = parent.type;
		      return parentType === "VariableDeclarator" || parentType === "ForStatement" || parentType === "ForInStatement" || parentType === "ForOfStatement";
		    }
		    return false;
		  }
		  function SequenceExpression$2(node, parent) {
		    var parentType = parent.type;
		    if (parentType === "ForStatement" || parentType === "ThrowStatement" || parentType === "ReturnStatement" || parentType === "IfStatement" && parent.test === node || parentType === "WhileStatement" && parent.test === node || parentType === "ForInStatement" && parent.right === node || parentType === "SwitchStatement" && parent.discriminant === node || parentType === "ExpressionStatement" && parent.expression === node) {
		      return false;
		    }
		    return true;
		  }
		  function YieldExpression$1(node, parent) {
		    var parentType = parent.type;
		    return parentType === "BinaryExpression" || parentType === "LogicalExpression" || parentType === "UnaryExpression" || parentType === "SpreadElement" || hasPostfixPart(node, parent) || parentType === "AwaitExpression" && isYieldExpression(node) || parentType === "ConditionalExpression" && node === parent.test || isClassExtendsClause(node, parent);
		  }
		  function ClassExpression(node, parent, printStack) {
		    return isFirstInContext(printStack, 1 | 4);
		  }
		  function UnaryLike(node, parent) {
		    return hasPostfixPart(node, parent) || isBinaryExpression(parent) && parent.operator === "**" && parent.left === node || isClassExtendsClause(node, parent);
		  }
		  function FunctionExpression$1(node, parent, printStack) {
		    return isFirstInContext(printStack, 1 | 4);
		  }
		  function ArrowFunctionExpression$1(node, parent) {
		    return isExportDeclaration(parent) || ConditionalExpression$2(node, parent);
		  }
		  function ConditionalExpression$2(node, parent) {
		    var parentType = parent.type;
		    if (parentType === "UnaryExpression" || parentType === "SpreadElement" || parentType === "BinaryExpression" || parentType === "LogicalExpression" || parentType === "ConditionalExpression" && parent.test === node || parentType === "AwaitExpression" || isTSTypeExpression(parentType)) {
		      return true;
		    }
		    return UnaryLike(node, parent);
		  }
		  function OptionalMemberExpression$1(node, parent) {
		    return isCallExpression$5(parent) && parent.callee === node || isMemberExpression$5(parent) && parent.object === node;
		  }
		  function AssignmentExpression$2(node, parent) {
		    if (isObjectPattern(node.left)) {
		      return true;
		    } else {
		      return ConditionalExpression$2(node, parent);
		    }
		  }
		  function LogicalExpression$1(node, parent) {
		    var parentType = parent.type;
		    if (isTSTypeExpression(parentType)) return true;
		    if (parentType !== "LogicalExpression") return false;
		    switch (node.operator) {
		      case "||":
		        return parent.operator === "??" || parent.operator === "&&";
		      case "&&":
		        return parent.operator === "??";
		      case "??":
		        return parent.operator !== "??";
		    }
		  }
		  function Identifier$1(node, parent, printStack) {
		    var _node$extra;
		    var parentType = parent.type;
		    if ((_node$extra = node.extra) != null && _node$extra.parenthesized && parentType === "AssignmentExpression" && parent.left === node) {
		      var rightType = parent.right.type;
		      if ((rightType === "FunctionExpression" || rightType === "ClassExpression") && parent.right.id == null) {
		        return true;
		      }
		    }
		    if (node.name === "let") {
		      var isFollowedByBracket = isMemberExpression$5(parent, {
		        object: node,
		        computed: true
		      }) || isOptionalMemberExpression$1(parent, {
		        object: node,
		        computed: true,
		        optional: false
		      });
		      return isFirstInContext(printStack, isFollowedByBracket ? 1 | 8 | 16 | 32 : 32);
		    }
		    return node.name === "async" && isForOfStatement(parent) && node === parent.left;
		  }
		  function isFirstInContext(printStack, checkParam) {
		    var expressionStatement = checkParam & 1;
		    var arrowBody = checkParam & 2;
		    var exportDefault = checkParam & 4;
		    var forHead = checkParam & 8;
		    var forInHead = checkParam & 16;
		    var forOfHead = checkParam & 32;
		    var i = printStack.length - 1;
		    if (i <= 0) return;
		    var node = printStack[i];
		    i--;
		    var parent = printStack[i];
		    while (i >= 0) {
		      var parentType = parent.type;
		      if (expressionStatement && parentType === "ExpressionStatement" && parent.expression === node || exportDefault && parentType === "ExportDefaultDeclaration" && node === parent.declaration || arrowBody && parentType === "ArrowFunctionExpression" && parent.body === node || forHead && parentType === "ForStatement" && parent.init === node || forInHead && parentType === "ForInStatement" && parent.left === node || forOfHead && parentType === "ForOfStatement" && parent.left === node) {
		        return true;
		      }
		      if (i > 0 && (hasPostfixPart(node, parent) && parentType !== "NewExpression" || parentType === "SequenceExpression" && parent.expressions[0] === node || parentType === "UpdateExpression" && !parent.prefix || parentType === "ConditionalExpression" && parent.test === node || (parentType === "BinaryExpression" || parentType === "LogicalExpression") && parent.left === node || parentType === "AssignmentExpression" && parent.left === node)) {
		        node = parent;
		        i--;
		        parent = printStack[i];
		      } else {
		        return false;
		      }
		    }
		    return false;
		  }

		  var parens = /*#__PURE__*/Object.freeze({
		    __proto__: null,
		    ArrowFunctionExpression: ArrowFunctionExpression$1,
		    AssignmentExpression: AssignmentExpression$2,
		    AwaitExpression: YieldExpression$1,
		    Binary: Binary,
		    BinaryExpression: BinaryExpression$1,
		    ClassExpression: ClassExpression,
		    ConditionalExpression: ConditionalExpression$2,
		    DoExpression: DoExpression$1,
		    FunctionExpression: FunctionExpression$1,
		    FunctionTypeAnnotation: FunctionTypeAnnotation$1,
		    Identifier: Identifier$1,
		    IntersectionTypeAnnotation: UnionTypeAnnotation$1,
		    LogicalExpression: LogicalExpression$1,
		    NullableTypeAnnotation: NullableTypeAnnotation$1,
		    ObjectExpression: ObjectExpression$2,
		    OptionalCallExpression: OptionalMemberExpression$1,
		    OptionalIndexedAccessType: OptionalIndexedAccessType$1,
		    OptionalMemberExpression: OptionalMemberExpression$1,
		    SequenceExpression: SequenceExpression$2,
		    TSAsExpression: TSAsExpression$1,
		    TSInferType: TSInferType$1,
		    TSInstantiationExpression: TSInstantiationExpression$1,
		    TSIntersectionType: TSUnionType$1,
		    TSSatisfiesExpression: TSAsExpression$1,
		    TSTypeAssertion: TSAsExpression$1,
		    TSUnionType: TSUnionType$1,
		    UnaryLike: UnaryLike,
		    UnionTypeAnnotation: UnionTypeAnnotation$1,
		    UpdateExpression: UpdateExpression$2,
		    YieldExpression: YieldExpression$1
		  });

		  var FLIPPED_ALIAS_KEYS = FLIPPED_ALIAS_KEYS$3,
		    isCallExpression$4 = isCallExpression$8,
		    isMemberExpression$4 = isMemberExpression$9,
		    isNewExpression$2 = isNewExpression$3;
		  function expandAliases(obj) {
		    var map = new Map();
		    function add(type, func) {
		      var fn = map.get(type);
		      map.set(type, fn ? function (node, parent, stack) {
		        var _fn;
		        return (_fn = fn(node, parent, stack)) != null ? _fn : func(node, parent, stack);
		      } : func);
		    }
		    for (var _i = 0, _Object$keys = Object.keys(obj); _i < _Object$keys.length; _i++) {
		      var type = _Object$keys[_i];
		      var aliases = FLIPPED_ALIAS_KEYS[type];
		      if (aliases) {
		        for (var _iterator = _createForOfIteratorHelperLoose(aliases), _step; !(_step = _iterator()).done;) {
		          var alias = _step.value;
		          add(alias, obj[type]);
		        }
		      } else {
		        add(type, obj[type]);
		      }
		    }
		    return map;
		  }
		  var expandedParens = expandAliases(parens);
		  expandAliases(nodes);
		  function isOrHasCallExpression(node) {
		    if (isCallExpression$4(node)) {
		      return true;
		    }
		    return isMemberExpression$4(node) && isOrHasCallExpression(node.object);
		  }
		  function needsParens$1(node, parent, printStack) {
		    var _expandedParens$get;
		    if (!parent) return false;
		    if (isNewExpression$2(parent) && parent.callee === node) {
		      if (isOrHasCallExpression(node)) return true;
		    }
		    return (_expandedParens$get = expandedParens.get(node.type)) == null ? void 0 : _expandedParens$get(node, parent, printStack);
		  }

		  function TaggedTemplateExpression$1(node) {
		    this.print(node.tag, node);
		    this.print(node.typeParameters, node);
		    this.print(node.quasi, node);
		  }
		  function TemplateElement(node, parent) {
		    var isFirst = parent.quasis[0] === node;
		    var isLast = parent.quasis[parent.quasis.length - 1] === node;
		    var value = (isFirst ? "`" : "}") + node.value.raw + (isLast ? "`" : "${");
		    this.token(value, true);
		  }
		  function TemplateLiteral$1(node) {
		    var quasis = node.quasis;
		    for (var i = 0; i < quasis.length; i++) {
		      this.print(quasis[i], node);
		      if (i + 1 < quasis.length) {
		        this.print(node.expressions[i], node);
		      }
		    }
		  }

		  var isCallExpression$3 = isCallExpression$8,
		    isLiteral$3 = isLiteral$6,
		    isMemberExpression$3 = isMemberExpression$9,
		    isNewExpression$1 = isNewExpression$3;
		  function UnaryExpression$1(node) {
		    var operator = node.operator;
		    if (operator === "void" || operator === "delete" || operator === "typeof" || operator === "throw") {
		      this.word(operator);
		      this.space();
		    } else {
		      this.token(operator);
		    }
		    this.print(node.argument, node);
		  }
		  function DoExpression(node) {
		    if (node.async) {
		      this.word("async", true);
		      this.space();
		    }
		    this.word("do");
		    this.space();
		    this.print(node.body, node);
		  }
		  function ParenthesizedExpression$1(node) {
		    this.tokenChar(40);
		    this.print(node.expression, node);
		    this.rightParens(node);
		  }
		  function UpdateExpression$1(node) {
		    if (node.prefix) {
		      this.token(node.operator);
		      this.print(node.argument, node);
		    } else {
		      this.printTerminatorless(node.argument, node, true);
		      this.token(node.operator);
		    }
		  }
		  function ConditionalExpression$1(node) {
		    this.print(node.test, node);
		    this.space();
		    this.tokenChar(63);
		    this.space();
		    this.print(node.consequent, node);
		    this.space();
		    this.tokenChar(58);
		    this.space();
		    this.print(node.alternate, node);
		  }
		  function NewExpression$1(node, parent) {
		    this.word("new");
		    this.space();
		    this.print(node.callee, node);
		    if (this.format.minified && node.arguments.length === 0 && !node.optional && !isCallExpression$3(parent, {
		      callee: node
		    }) && !isMemberExpression$3(parent) && !isNewExpression$1(parent)) {
		      return;
		    }
		    this.print(node.typeArguments, node);
		    this.print(node.typeParameters, node);
		    if (node.optional) {
		      this.token("?.");
		    }
		    this.tokenChar(40);
		    this.printList(node.arguments, node);
		    this.rightParens(node);
		  }
		  function SequenceExpression$1(node) {
		    this.printList(node.expressions, node);
		  }
		  function ThisExpression() {
		    this.word("this");
		  }
		  function Super() {
		    this.word("super");
		  }
		  function isDecoratorMemberExpression(node) {
		    switch (node.type) {
		      case "Identifier":
		        return true;
		      case "MemberExpression":
		        return !node.computed && node.property.type === "Identifier" && isDecoratorMemberExpression(node.object);
		      default:
		        return false;
		    }
		  }
		  function shouldParenthesizeDecoratorExpression(node) {
		    if (node.type === "ParenthesizedExpression") {
		      return false;
		    }
		    return !isDecoratorMemberExpression(node.type === "CallExpression" ? node.callee : node);
		  }
		  function _shouldPrintDecoratorsBeforeExport(node) {
		    if (typeof this.format.decoratorsBeforeExport === "boolean") {
		      return this.format.decoratorsBeforeExport;
		    }
		    return typeof node.start === "number" && node.start === node.declaration.start;
		  }
		  function Decorator(node) {
		    this.tokenChar(64);
		    var expression = node.expression;
		    if (shouldParenthesizeDecoratorExpression(expression)) {
		      this.tokenChar(40);
		      this.print(expression, node);
		      this.tokenChar(41);
		    } else {
		      this.print(expression, node);
		    }
		    this.newline();
		  }
		  function OptionalMemberExpression(node) {
		    var computed = node.computed;
		    var optional = node.optional,
		      property = node.property;
		    this.print(node.object, node);
		    if (!computed && isMemberExpression$3(property)) {
		      throw new TypeError("Got a MemberExpression for MemberExpression property");
		    }
		    if (isLiteral$3(property) && typeof property.value === "number") {
		      computed = true;
		    }
		    if (optional) {
		      this.token("?.");
		    }
		    if (computed) {
		      this.tokenChar(91);
		      this.print(property, node);
		      this.tokenChar(93);
		    } else {
		      if (!optional) {
		        this.tokenChar(46);
		      }
		      this.print(property, node);
		    }
		  }
		  function OptionalCallExpression(node) {
		    this.print(node.callee, node);
		    this.print(node.typeParameters, node);
		    if (node.optional) {
		      this.token("?.");
		    }
		    this.print(node.typeArguments, node);
		    this.tokenChar(40);
		    this.printList(node.arguments, node);
		    this.rightParens(node);
		  }
		  function CallExpression$1(node) {
		    this.print(node.callee, node);
		    this.print(node.typeArguments, node);
		    this.print(node.typeParameters, node);
		    this.tokenChar(40);
		    this.printList(node.arguments, node);
		    this.rightParens(node);
		  }
		  function Import() {
		    this.word("import");
		  }
		  function AwaitExpression(node) {
		    this.word("await");
		    if (node.argument) {
		      this.space();
		      this.printTerminatorless(node.argument, node, false);
		    }
		  }
		  function YieldExpression(node) {
		    this.word("yield", true);
		    if (node.delegate) {
		      this.tokenChar(42);
		      if (node.argument) {
		        this.space();
		        this.print(node.argument, node);
		      }
		    } else {
		      if (node.argument) {
		        this.space();
		        this.printTerminatorless(node.argument, node, false);
		      }
		    }
		  }
		  function EmptyStatement() {
		    this.semicolon(true);
		  }
		  function ExpressionStatement(node) {
		    this.print(node.expression, node);
		    this.semicolon();
		  }
		  function AssignmentPattern(node) {
		    this.print(node.left, node);
		    if (node.left.optional) this.tokenChar(63);
		    this.print(node.left.typeAnnotation, node);
		    this.space();
		    this.tokenChar(61);
		    this.space();
		    this.print(node.right, node);
		  }
		  function AssignmentExpression$1(node, parent) {
		    var parens = this.inForStatementInitCounter && node.operator === "in" && !needsParens$1(node, parent);
		    if (parens) {
		      this.tokenChar(40);
		    }
		    this.print(node.left, node);
		    this.space();
		    if (node.operator === "in" || node.operator === "instanceof") {
		      this.word(node.operator);
		    } else {
		      this.token(node.operator);
		    }
		    this.space();
		    this.print(node.right, node);
		    if (parens) {
		      this.tokenChar(41);
		    }
		  }
		  function BindExpression(node) {
		    this.print(node.object, node);
		    this.token("::");
		    this.print(node.callee, node);
		  }
		  function MemberExpression(node) {
		    this.print(node.object, node);
		    if (!node.computed && isMemberExpression$3(node.property)) {
		      throw new TypeError("Got a MemberExpression for MemberExpression property");
		    }
		    var computed = node.computed;
		    if (isLiteral$3(node.property) && typeof node.property.value === "number") {
		      computed = true;
		    }
		    if (computed) {
		      this.tokenChar(91);
		      this.print(node.property, node);
		      this.tokenChar(93);
		    } else {
		      this.tokenChar(46);
		      this.print(node.property, node);
		    }
		  }
		  function MetaProperty(node) {
		    this.print(node.meta, node);
		    this.tokenChar(46);
		    this.print(node.property, node);
		  }
		  function PrivateName(node) {
		    this.tokenChar(35);
		    this.print(node.id, node);
		  }
		  function V8IntrinsicIdentifier(node) {
		    this.tokenChar(37);
		    this.word(node.name);
		  }
		  function ModuleExpression(node) {
		    this.word("module", true);
		    this.space();
		    this.tokenChar(123);
		    this.indent();
		    var body = node.body;
		    if (body.body.length || body.directives.length) {
		      this.newline();
		    }
		    this.print(body, node);
		    this.dedent();
		    this.rightBrace(node);
		  }

		  var isFor = isFor$1,
		    isForStatement = isForStatement$2,
		    isIfStatement$1 = isIfStatement$2,
		    isStatement$6 = isStatement$8;
		  function WithStatement(node) {
		    this.word("with");
		    this.space();
		    this.tokenChar(40);
		    this.print(node.object, node);
		    this.tokenChar(41);
		    this.printBlock(node);
		  }
		  function IfStatement(node) {
		    this.word("if");
		    this.space();
		    this.tokenChar(40);
		    this.print(node.test, node);
		    this.tokenChar(41);
		    this.space();
		    var needsBlock = node.alternate && isIfStatement$1(getLastStatement(node.consequent));
		    if (needsBlock) {
		      this.tokenChar(123);
		      this.newline();
		      this.indent();
		    }
		    this.printAndIndentOnComments(node.consequent, node);
		    if (needsBlock) {
		      this.dedent();
		      this.newline();
		      this.tokenChar(125);
		    }
		    if (node.alternate) {
		      if (this.endsWith(125)) this.space();
		      this.word("else");
		      this.space();
		      this.printAndIndentOnComments(node.alternate, node);
		    }
		  }
		  function getLastStatement(statement) {
		    var body = statement.body;
		    if (isStatement$6(body) === false) {
		      return statement;
		    }
		    return getLastStatement(body);
		  }
		  function ForStatement(node) {
		    this.word("for");
		    this.space();
		    this.tokenChar(40);
		    this.inForStatementInitCounter++;
		    this.print(node.init, node);
		    this.inForStatementInitCounter--;
		    this.tokenChar(59);
		    if (node.test) {
		      this.space();
		      this.print(node.test, node);
		    }
		    this.tokenChar(59);
		    if (node.update) {
		      this.space();
		      this.print(node.update, node);
		    }
		    this.tokenChar(41);
		    this.printBlock(node);
		  }
		  function WhileStatement(node) {
		    this.word("while");
		    this.space();
		    this.tokenChar(40);
		    this.print(node.test, node);
		    this.tokenChar(41);
		    this.printBlock(node);
		  }
		  function ForXStatement(node) {
		    this.word("for");
		    this.space();
		    var isForOf = node.type === "ForOfStatement";
		    if (isForOf && node["await"]) {
		      this.word("await");
		      this.space();
		    }
		    this.noIndentInnerCommentsHere();
		    this.tokenChar(40);
		    this.print(node.left, node);
		    this.space();
		    this.word(isForOf ? "of" : "in");
		    this.space();
		    this.print(node.right, node);
		    this.tokenChar(41);
		    this.printBlock(node);
		  }
		  var ForInStatement = ForXStatement;
		  var ForOfStatement = ForXStatement;
		  function DoWhileStatement(node) {
		    this.word("do");
		    this.space();
		    this.print(node.body, node);
		    this.space();
		    this.word("while");
		    this.space();
		    this.tokenChar(40);
		    this.print(node.test, node);
		    this.tokenChar(41);
		    this.semicolon();
		  }
		  function printStatementAfterKeyword(printer, node, parent, isLabel) {
		    if (node) {
		      printer.space();
		      printer.printTerminatorless(node, parent, isLabel);
		    }
		    printer.semicolon();
		  }
		  function BreakStatement(node) {
		    this.word("break");
		    printStatementAfterKeyword(this, node.label, node, true);
		  }
		  function ContinueStatement(node) {
		    this.word("continue");
		    printStatementAfterKeyword(this, node.label, node, true);
		  }
		  function ReturnStatement(node) {
		    this.word("return");
		    printStatementAfterKeyword(this, node.argument, node, false);
		  }
		  function ThrowStatement(node) {
		    this.word("throw");
		    printStatementAfterKeyword(this, node.argument, node, false);
		  }
		  function LabeledStatement(node) {
		    this.print(node.label, node);
		    this.tokenChar(58);
		    this.space();
		    this.print(node.body, node);
		  }
		  function TryStatement(node) {
		    this.word("try");
		    this.space();
		    this.print(node.block, node);
		    this.space();
		    if (node.handlers) {
		      this.print(node.handlers[0], node);
		    } else {
		      this.print(node.handler, node);
		    }
		    if (node.finalizer) {
		      this.space();
		      this.word("finally");
		      this.space();
		      this.print(node.finalizer, node);
		    }
		  }
		  function CatchClause(node) {
		    this.word("catch");
		    this.space();
		    if (node.param) {
		      this.tokenChar(40);
		      this.print(node.param, node);
		      this.print(node.param.typeAnnotation, node);
		      this.tokenChar(41);
		      this.space();
		    }
		    this.print(node.body, node);
		  }
		  function SwitchStatement(node) {
		    this.word("switch");
		    this.space();
		    this.tokenChar(40);
		    this.print(node.discriminant, node);
		    this.tokenChar(41);
		    this.space();
		    this.tokenChar(123);
		    this.printSequence(node.cases, node, {
		      indent: true,
		      addNewlines: function addNewlines(leading, cas) {
		        if (!leading && node.cases[node.cases.length - 1] === cas) return -1;
		      }
		    });
		    this.rightBrace(node);
		  }
		  function SwitchCase(node) {
		    if (node.test) {
		      this.word("case");
		      this.space();
		      this.print(node.test, node);
		      this.tokenChar(58);
		    } else {
		      this.word("default");
		      this.tokenChar(58);
		    }
		    if (node.consequent.length) {
		      this.newline();
		      this.printSequence(node.consequent, node, {
		        indent: true
		      });
		    }
		  }
		  function DebuggerStatement() {
		    this.word("debugger");
		    this.semicolon();
		  }
		  function VariableDeclaration(node, parent) {
		    if (node.declare) {
		      this.word("declare");
		      this.space();
		    }
		    var kind = node.kind;
		    this.word(kind, kind === "using" || kind === "await using");
		    this.space();
		    var hasInits = false;
		    if (!isFor(parent)) {
		      for (var _iterator = _createForOfIteratorHelperLoose(node.declarations), _step; !(_step = _iterator()).done;) {
		        var declar = _step.value;
		        if (declar.init) {
		          hasInits = true;
		        }
		      }
		    }
		    this.printList(node.declarations, node, {
		      separator: hasInits ? function () {
		        this.tokenChar(44);
		        this.newline();
		      } : undefined,
		      indent: node.declarations.length > 1 ? true : false
		    });
		    if (isFor(parent)) {
		      if (isForStatement(parent)) {
		        if (parent.init === node) return;
		      } else {
		        if (parent.left === node) return;
		      }
		    }
		    this.semicolon();
		  }
		  function VariableDeclarator$1(node) {
		    this.print(node.id, node);
		    if (node.definite) this.tokenChar(33);
		    this.print(node.id.typeAnnotation, node);
		    if (node.init) {
		      this.space();
		      this.tokenChar(61);
		      this.space();
		      this.print(node.init, node);
		    }
		  }

		  var isExportDefaultDeclaration = isExportDefaultDeclaration$2,
		    isExportNamedDeclaration$1 = isExportNamedDeclaration$3;
		  function ClassDeclaration(node, parent) {
		    var inExport = isExportDefaultDeclaration(parent) || isExportNamedDeclaration$1(parent);
		    if (!inExport || !this._shouldPrintDecoratorsBeforeExport(parent)) {
		      this.printJoin(node.decorators, node);
		    }
		    if (node.declare) {
		      this.word("declare");
		      this.space();
		    }
		    if (node["abstract"]) {
		      this.word("abstract");
		      this.space();
		    }
		    this.word("class");
		    if (node.id) {
		      this.space();
		      this.print(node.id, node);
		    }
		    this.print(node.typeParameters, node);
		    if (node.superClass) {
		      this.space();
		      this.word("extends");
		      this.space();
		      this.print(node.superClass, node);
		      this.print(node.superTypeParameters, node);
		    }
		    if (node["implements"]) {
		      this.space();
		      this.word("implements");
		      this.space();
		      this.printList(node["implements"], node);
		    }
		    this.space();
		    this.print(node.body, node);
		  }
		  function ClassBody(node) {
		    this.tokenChar(123);
		    if (node.body.length === 0) {
		      this.tokenChar(125);
		    } else {
		      this.newline();
		      this.printSequence(node.body, node, {
		        indent: true
		      });
		      if (!this.endsWith(10)) this.newline();
		      this.rightBrace(node);
		    }
		  }
		  function ClassProperty(node) {
		    var _node$key$loc;
		    this.printJoin(node.decorators, node);
		    var endLine = (_node$key$loc = node.key.loc) == null || (_node$key$loc = _node$key$loc.end) == null ? void 0 : _node$key$loc.line;
		    if (endLine) this.catchUp(endLine);
		    this.tsPrintClassMemberModifiers(node);
		    if (node.computed) {
		      this.tokenChar(91);
		      this.print(node.key, node);
		      this.tokenChar(93);
		    } else {
		      this._variance(node);
		      this.print(node.key, node);
		    }
		    if (node.optional) {
		      this.tokenChar(63);
		    }
		    if (node.definite) {
		      this.tokenChar(33);
		    }
		    this.print(node.typeAnnotation, node);
		    if (node.value) {
		      this.space();
		      this.tokenChar(61);
		      this.space();
		      this.print(node.value, node);
		    }
		    this.semicolon();
		  }
		  function ClassAccessorProperty(node) {
		    var _node$key$loc2;
		    this.printJoin(node.decorators, node);
		    var endLine = (_node$key$loc2 = node.key.loc) == null || (_node$key$loc2 = _node$key$loc2.end) == null ? void 0 : _node$key$loc2.line;
		    if (endLine) this.catchUp(endLine);
		    this.tsPrintClassMemberModifiers(node);
		    this.word("accessor", true);
		    this.space();
		    if (node.computed) {
		      this.tokenChar(91);
		      this.print(node.key, node);
		      this.tokenChar(93);
		    } else {
		      this._variance(node);
		      this.print(node.key, node);
		    }
		    if (node.optional) {
		      this.tokenChar(63);
		    }
		    if (node.definite) {
		      this.tokenChar(33);
		    }
		    this.print(node.typeAnnotation, node);
		    if (node.value) {
		      this.space();
		      this.tokenChar(61);
		      this.space();
		      this.print(node.value, node);
		    }
		    this.semicolon();
		  }
		  function ClassPrivateProperty(node) {
		    this.printJoin(node.decorators, node);
		    if (node["static"]) {
		      this.word("static");
		      this.space();
		    }
		    this.print(node.key, node);
		    this.print(node.typeAnnotation, node);
		    if (node.value) {
		      this.space();
		      this.tokenChar(61);
		      this.space();
		      this.print(node.value, node);
		    }
		    this.semicolon();
		  }
		  function ClassMethod(node) {
		    this._classMethodHead(node);
		    this.space();
		    this.print(node.body, node);
		  }
		  function ClassPrivateMethod(node) {
		    this._classMethodHead(node);
		    this.space();
		    this.print(node.body, node);
		  }
		  function _classMethodHead(node) {
		    var _node$key$loc3;
		    this.printJoin(node.decorators, node);
		    var endLine = (_node$key$loc3 = node.key.loc) == null || (_node$key$loc3 = _node$key$loc3.end) == null ? void 0 : _node$key$loc3.line;
		    if (endLine) this.catchUp(endLine);
		    this.tsPrintClassMemberModifiers(node);
		    this._methodHead(node);
		  }
		  function StaticBlock(node) {
		    this.word("static");
		    this.space();
		    this.tokenChar(123);
		    if (node.body.length === 0) {
		      this.tokenChar(125);
		    } else {
		      this.newline();
		      this.printSequence(node.body, node, {
		        indent: true
		      });
		      this.rightBrace(node);
		    }
		  }

		  var isIdentifier$e = isIdentifier$i;
		  function _params(node, idNode, parentNode) {
		    this.print(node.typeParameters, node);
		    var nameInfo = _getFuncIdName.call(this, idNode, parentNode);
		    if (nameInfo) {
		      this.sourceIdentifierName(nameInfo.name, nameInfo.pos);
		    }
		    this.tokenChar(40);
		    this._parameters(node.params, node);
		    this.tokenChar(41);
		    var noLineTerminator = node.type === "ArrowFunctionExpression";
		    this.print(node.returnType, node, noLineTerminator);
		    this._noLineTerminator = noLineTerminator;
		  }
		  function _parameters(parameters, parent) {
		    var paramLength = parameters.length;
		    for (var i = 0; i < paramLength; i++) {
		      this._param(parameters[i], parent);
		      if (i < parameters.length - 1) {
		        this.tokenChar(44);
		        this.space();
		      }
		    }
		  }
		  function _param(parameter, parent) {
		    this.printJoin(parameter.decorators, parameter);
		    this.print(parameter, parent);
		    if (parameter.optional) {
		      this.tokenChar(63);
		    }
		    this.print(parameter.typeAnnotation, parameter);
		  }
		  function _methodHead(node) {
		    var kind = node.kind;
		    var key = node.key;
		    if (kind === "get" || kind === "set") {
		      this.word(kind);
		      this.space();
		    }
		    if (node.async) {
		      this.word("async", true);
		      this.space();
		    }
		    if (kind === "method" || kind === "init") {
		      if (node.generator) {
		        this.tokenChar(42);
		      }
		    }
		    if (node.computed) {
		      this.tokenChar(91);
		      this.print(key, node);
		      this.tokenChar(93);
		    } else {
		      this.print(key, node);
		    }
		    if (node.optional) {
		      this.tokenChar(63);
		    }
		    this._params(node, node.computed && node.key.type !== "StringLiteral" ? undefined : node.key, undefined);
		  }
		  function _predicate(node, noLineTerminatorAfter) {
		    if (node.predicate) {
		      if (!node.returnType) {
		        this.tokenChar(58);
		      }
		      this.space();
		      this.print(node.predicate, node, noLineTerminatorAfter);
		    }
		  }
		  function _functionHead(node, parent) {
		    if (node.async) {
		      this.word("async");
		      this._endsWithInnerRaw = false;
		      this.space();
		    }
		    this.word("function");
		    if (node.generator) {
		      this._endsWithInnerRaw = false;
		      this.tokenChar(42);
		    }
		    this.space();
		    if (node.id) {
		      this.print(node.id, node);
		    }
		    this._params(node, node.id, parent);
		    if (node.type !== "TSDeclareFunction") {
		      this._predicate(node);
		    }
		  }
		  function FunctionExpression(node, parent) {
		    this._functionHead(node, parent);
		    this.space();
		    this.print(node.body, node);
		  }
		  function ArrowFunctionExpression(node, parent) {
		    if (node.async) {
		      this.word("async", true);
		      this.space();
		    }
		    var firstParam;
		    if (!this.format.retainLines && node.params.length === 1 && isIdentifier$e(firstParam = node.params[0]) && !hasTypesOrComments(node, firstParam)) {
		      this.print(firstParam, node, true);
		    } else {
		      this._params(node, undefined, parent);
		    }
		    this._predicate(node, true);
		    this.space();
		    this.printInnerComments();
		    this.token("=>");
		    this.space();
		    this.print(node.body, node);
		  }
		  function hasTypesOrComments(node, param) {
		    var _param$leadingComment, _param$trailingCommen;
		    return !!(node.typeParameters || node.returnType || node.predicate || param.typeAnnotation || param.optional || (_param$leadingComment = param.leadingComments) != null && _param$leadingComment.length || (_param$trailingCommen = param.trailingComments) != null && _param$trailingCommen.length);
		  }
		  function _getFuncIdName(idNode, parent) {
		    var id = idNode;
		    if (!id && parent) {
		      var parentType = parent.type;
		      if (parentType === "VariableDeclarator") {
		        id = parent.id;
		      } else if (parentType === "AssignmentExpression" || parentType === "AssignmentPattern") {
		        id = parent.left;
		      } else if (parentType === "ObjectProperty" || parentType === "ClassProperty") {
		        if (!parent.computed || parent.key.type === "StringLiteral") {
		          id = parent.key;
		        }
		      } else if (parentType === "ClassPrivateProperty" || parentType === "ClassAccessorProperty") {
		        id = parent.key;
		      }
		    }
		    if (!id) return;
		    var nameInfo;
		    if (id.type === "Identifier") {
		      var _id$loc, _id$loc2;
		      nameInfo = {
		        pos: (_id$loc = id.loc) == null ? void 0 : _id$loc.start,
		        name: ((_id$loc2 = id.loc) == null ? void 0 : _id$loc2.identifierName) || id.name
		      };
		    } else if (id.type === "PrivateName") {
		      var _id$loc3;
		      nameInfo = {
		        pos: (_id$loc3 = id.loc) == null ? void 0 : _id$loc3.start,
		        name: "#" + id.id.name
		      };
		    } else if (id.type === "StringLiteral") {
		      var _id$loc4;
		      nameInfo = {
		        pos: (_id$loc4 = id.loc) == null ? void 0 : _id$loc4.start,
		        name: id.value
		      };
		    }
		    return nameInfo;
		  }

		  var isClassDeclaration = isClassDeclaration$2,
		    isExportDefaultSpecifier = isExportDefaultSpecifier$1,
		    isExportNamespaceSpecifier = isExportNamespaceSpecifier$1,
		    isImportDefaultSpecifier = isImportDefaultSpecifier$1,
		    isImportNamespaceSpecifier = isImportNamespaceSpecifier$1,
		    isStatement$5 = isStatement$8;
		  function ImportSpecifier(node) {
		    if (node.importKind === "type" || node.importKind === "typeof") {
		      this.word(node.importKind);
		      this.space();
		    }
		    this.print(node.imported, node);
		    if (node.local && node.local.name !== node.imported.name) {
		      this.space();
		      this.word("as");
		      this.space();
		      this.print(node.local, node);
		    }
		  }
		  function ImportDefaultSpecifier(node) {
		    this.print(node.local, node);
		  }
		  function ExportDefaultSpecifier(node) {
		    this.print(node.exported, node);
		  }
		  function ExportSpecifier(node) {
		    if (node.exportKind === "type") {
		      this.word("type");
		      this.space();
		    }
		    this.print(node.local, node);
		    if (node.exported && node.local.name !== node.exported.name) {
		      this.space();
		      this.word("as");
		      this.space();
		      this.print(node.exported, node);
		    }
		  }
		  function ExportNamespaceSpecifier(node) {
		    this.tokenChar(42);
		    this.space();
		    this.word("as");
		    this.space();
		    this.print(node.exported, node);
		  }
		  var warningShown = false;
		  function _printAttributes(node) {
		    var importAttributesKeyword = this.format.importAttributesKeyword;
		    var attributes = node.attributes,
		      assertions = node.assertions;
		    if (attributes && !importAttributesKeyword && !warningShown) {
		      warningShown = true;
		      console.warn("You are using import attributes, without specifying the desired output syntax.\nPlease specify the \"importAttributesKeyword\" generator option, whose value can be one of:\n - \"with\"        : `import { a } from \"b\" with { type: \"json\" };`\n - \"assert\"      : `import { a } from \"b\" assert { type: \"json\" };`\n - \"with-legacy\" : `import { a } from \"b\" with type: \"json\";`\n");
		    }
		    var useAssertKeyword = importAttributesKeyword === "assert" || !importAttributesKeyword && assertions;
		    this.word(useAssertKeyword ? "assert" : "with");
		    this.space();
		    if (!useAssertKeyword && importAttributesKeyword !== "with") {
		      this.printList(attributes || assertions, node);
		      return;
		    }
		    this.tokenChar(123);
		    this.space();
		    this.printList(attributes || assertions, node);
		    this.space();
		    this.tokenChar(125);
		  }
		  function ExportAllDeclaration(node) {
		    var _node$attributes, _node$assertions;
		    this.word("export");
		    this.space();
		    if (node.exportKind === "type") {
		      this.word("type");
		      this.space();
		    }
		    this.tokenChar(42);
		    this.space();
		    this.word("from");
		    this.space();
		    if ((_node$attributes = node.attributes) != null && _node$attributes.length || (_node$assertions = node.assertions) != null && _node$assertions.length) {
		      this.print(node.source, node, true);
		      this.space();
		      this._printAttributes(node);
		    } else {
		      this.print(node.source, node);
		    }
		    this.semicolon();
		  }
		  function maybePrintDecoratorsBeforeExport(printer, node) {
		    if (isClassDeclaration(node.declaration) && printer._shouldPrintDecoratorsBeforeExport(node)) {
		      printer.printJoin(node.declaration.decorators, node);
		    }
		  }
		  function ExportNamedDeclaration(node) {
		    maybePrintDecoratorsBeforeExport(this, node);
		    this.word("export");
		    this.space();
		    if (node.declaration) {
		      var declar = node.declaration;
		      this.print(declar, node);
		      if (!isStatement$5(declar)) this.semicolon();
		    } else {
		      if (node.exportKind === "type") {
		        this.word("type");
		        this.space();
		      }
		      var specifiers = node.specifiers.slice(0);
		      var hasSpecial = false;
		      for (;;) {
		        var first = specifiers[0];
		        if (isExportDefaultSpecifier(first) || isExportNamespaceSpecifier(first)) {
		          hasSpecial = true;
		          this.print(specifiers.shift(), node);
		          if (specifiers.length) {
		            this.tokenChar(44);
		            this.space();
		          }
		        } else {
		          break;
		        }
		      }
		      if (specifiers.length || !specifiers.length && !hasSpecial) {
		        this.tokenChar(123);
		        if (specifiers.length) {
		          this.space();
		          this.printList(specifiers, node);
		          this.space();
		        }
		        this.tokenChar(125);
		      }
		      if (node.source) {
		        var _node$attributes2, _node$assertions2;
		        this.space();
		        this.word("from");
		        this.space();
		        if ((_node$attributes2 = node.attributes) != null && _node$attributes2.length || (_node$assertions2 = node.assertions) != null && _node$assertions2.length) {
		          this.print(node.source, node, true);
		          this.space();
		          this._printAttributes(node);
		        } else {
		          this.print(node.source, node);
		        }
		      }
		      this.semicolon();
		    }
		  }
		  function ExportDefaultDeclaration(node) {
		    maybePrintDecoratorsBeforeExport(this, node);
		    this.word("export");
		    this.noIndentInnerCommentsHere();
		    this.space();
		    this.word("default");
		    this.space();
		    var declar = node.declaration;
		    this.print(declar, node);
		    if (!isStatement$5(declar)) this.semicolon();
		  }
		  function ImportDeclaration(node) {
		    var _node$attributes3, _node$assertions3;
		    this.word("import");
		    this.space();
		    var isTypeKind = node.importKind === "type" || node.importKind === "typeof";
		    if (isTypeKind) {
		      this.noIndentInnerCommentsHere();
		      this.word(node.importKind);
		      this.space();
		    } else if (node.module) {
		      this.noIndentInnerCommentsHere();
		      this.word("module");
		      this.space();
		    } else if (node.phase) {
		      this.noIndentInnerCommentsHere();
		      this.word(node.phase);
		      this.space();
		    }
		    var specifiers = node.specifiers.slice(0);
		    var hasSpecifiers = !!specifiers.length;
		    while (hasSpecifiers) {
		      var first = specifiers[0];
		      if (isImportDefaultSpecifier(first) || isImportNamespaceSpecifier(first)) {
		        this.print(specifiers.shift(), node);
		        if (specifiers.length) {
		          this.tokenChar(44);
		          this.space();
		        }
		      } else {
		        break;
		      }
		    }
		    if (specifiers.length) {
		      this.tokenChar(123);
		      this.space();
		      this.printList(specifiers, node);
		      this.space();
		      this.tokenChar(125);
		    } else if (isTypeKind && !hasSpecifiers) {
		      this.tokenChar(123);
		      this.tokenChar(125);
		    }
		    if (hasSpecifiers || isTypeKind) {
		      this.space();
		      this.word("from");
		      this.space();
		    }
		    if ((_node$attributes3 = node.attributes) != null && _node$attributes3.length || (_node$assertions3 = node.assertions) != null && _node$assertions3.length) {
		      this.print(node.source, node, true);
		      this.space();
		      this._printAttributes(node);
		    } else {
		      this.print(node.source, node);
		    }
		    this.semicolon();
		  }
		  function ImportAttribute(node) {
		    this.print(node.key);
		    this.tokenChar(58);
		    this.space();
		    this.print(node.value);
		  }
		  function ImportNamespaceSpecifier(node) {
		    this.tokenChar(42);
		    this.space();
		    this.word("as");
		    this.space();
		    this.print(node.local, node);
		  }
		  function ImportExpression(node) {
		    this.word("import");
		    if (node.phase) {
		      this.tokenChar(46);
		      this.word(node.phase);
		    }
		    this.tokenChar(40);
		    this.print(node.source, node);
		    if (node.options != null) {
		      this.tokenChar(44);
		      this.space();
		      this.print(node.options, node);
		    }
		    this.tokenChar(41);
		  }

		  var jsesc_1;
		  var hasRequiredJsesc;
		  function requireJsesc() {
		    if (hasRequiredJsesc) return jsesc_1;
		    hasRequiredJsesc = 1;
		    var object = {};
		    var hasOwnProperty = object.hasOwnProperty;
		    var forOwn = function forOwn(object, callback) {
		      for (var key in object) {
		        if (hasOwnProperty.call(object, key)) {
		          callback(key, object[key]);
		        }
		      }
		    };
		    var extend = function extend(destination, source) {
		      if (!source) {
		        return destination;
		      }
		      forOwn(source, function (key, value) {
		        destination[key] = value;
		      });
		      return destination;
		    };
		    var forEach = function forEach(array, callback) {
		      var length = array.length;
		      var index = -1;
		      while (++index < length) {
		        callback(array[index]);
		      }
		    };
		    var toString = object.toString;
		    var isArray = Array.isArray;
		    var isBuffer = Buffer$1.isBuffer;
		    var isObject = function isObject(value) {
		      return toString.call(value) == '[object Object]';
		    };
		    var isString = function isString(value) {
		      return typeof value == 'string' || toString.call(value) == '[object String]';
		    };
		    var isNumber = function isNumber(value) {
		      return typeof value == 'number' || toString.call(value) == '[object Number]';
		    };
		    var isFunction = function isFunction(value) {
		      return typeof value == 'function';
		    };
		    var isMap = function isMap(value) {
		      return toString.call(value) == '[object Map]';
		    };
		    var isSet = function isSet(value) {
		      return toString.call(value) == '[object Set]';
		    };
		    var singleEscapes = {
		      '"': '\\"',
		      '\'': '\\\'',
		      '\\': '\\\\',
		      '\b': '\\b',
		      '\f': '\\f',
		      '\n': '\\n',
		      '\r': '\\r',
		      '\t': '\\t'
		    };
		    var regexSingleEscape = /["'\\\b\f\n\r\t]/;
		    var regexDigit = /[0-9]/;
		    var regexWhitelist = /[ !#-&\(-\[\]-_a-~]/;
		    var jsesc = function jsesc(argument, options) {
		      var increaseIndentation = function increaseIndentation() {
		        oldIndent = indent;
		        ++options.indentLevel;
		        indent = options.indent.repeat(options.indentLevel);
		      };
		      var defaults = {
		        'escapeEverything': false,
		        'minimal': false,
		        'isScriptContext': false,
		        'quotes': 'single',
		        'wrap': false,
		        'es6': false,
		        'json': false,
		        'compact': true,
		        'lowercaseHex': false,
		        'numbers': 'decimal',
		        'indent': '\t',
		        'indentLevel': 0,
		        '__inline1__': false,
		        '__inline2__': false
		      };
		      var json = options && options.json;
		      if (json) {
		        defaults.quotes = 'double';
		        defaults.wrap = true;
		      }
		      options = extend(defaults, options);
		      if (options.quotes != 'single' && options.quotes != 'double' && options.quotes != 'backtick') {
		        options.quotes = 'single';
		      }
		      var quote = options.quotes == 'double' ? '"' : options.quotes == 'backtick' ? '`' : '\'';
		      var compact = options.compact;
		      var lowercaseHex = options.lowercaseHex;
		      var indent = options.indent.repeat(options.indentLevel);
		      var oldIndent = '';
		      var inline1 = options.__inline1__;
		      var inline2 = options.__inline2__;
		      var newLine = compact ? '' : '\n';
		      var result;
		      var isEmpty = true;
		      var useBinNumbers = options.numbers == 'binary';
		      var useOctNumbers = options.numbers == 'octal';
		      var useDecNumbers = options.numbers == 'decimal';
		      var useHexNumbers = options.numbers == 'hexadecimal';
		      if (json && argument && isFunction(argument.toJSON)) {
		        argument = argument.toJSON();
		      }
		      if (!isString(argument)) {
		        if (isMap(argument)) {
		          if (argument.size == 0) {
		            return 'new Map()';
		          }
		          if (!compact) {
		            options.__inline1__ = true;
		            options.__inline2__ = false;
		          }
		          return 'new Map(' + jsesc(Array.from(argument), options) + ')';
		        }
		        if (isSet(argument)) {
		          if (argument.size == 0) {
		            return 'new Set()';
		          }
		          return 'new Set(' + jsesc(Array.from(argument), options) + ')';
		        }
		        if (isBuffer(argument)) {
		          if (argument.length == 0) {
		            return 'Buffer.from([])';
		          }
		          return 'Buffer.from(' + jsesc(Array.from(argument), options) + ')';
		        }
		        if (isArray(argument)) {
		          result = [];
		          options.wrap = true;
		          if (inline1) {
		            options.__inline1__ = false;
		            options.__inline2__ = true;
		          }
		          if (!inline2) {
		            increaseIndentation();
		          }
		          forEach(argument, function (value) {
		            isEmpty = false;
		            if (inline2) {
		              options.__inline2__ = false;
		            }
		            result.push((compact || inline2 ? '' : indent) + jsesc(value, options));
		          });
		          if (isEmpty) {
		            return '[]';
		          }
		          if (inline2) {
		            return '[' + result.join(', ') + ']';
		          }
		          return '[' + newLine + result.join(',' + newLine) + newLine + (compact ? '' : oldIndent) + ']';
		        } else if (isNumber(argument)) {
		          if (json) {
		            return JSON.stringify(argument);
		          }
		          if (useDecNumbers) {
		            return String(argument);
		          }
		          if (useHexNumbers) {
		            var hexadecimal = argument.toString(16);
		            if (!lowercaseHex) {
		              hexadecimal = hexadecimal.toUpperCase();
		            }
		            return '0x' + hexadecimal;
		          }
		          if (useBinNumbers) {
		            return '0b' + argument.toString(2);
		          }
		          if (useOctNumbers) {
		            return '0o' + argument.toString(8);
		          }
		        } else if (!isObject(argument)) {
		          if (json) {
		            return JSON.stringify(argument) || 'null';
		          }
		          return String(argument);
		        } else {
		          result = [];
		          options.wrap = true;
		          increaseIndentation();
		          forOwn(argument, function (key, value) {
		            isEmpty = false;
		            result.push((compact ? '' : indent) + jsesc(key, options) + ':' + (compact ? '' : ' ') + jsesc(value, options));
		          });
		          if (isEmpty) {
		            return '{}';
		          }
		          return '{' + newLine + result.join(',' + newLine) + newLine + (compact ? '' : oldIndent) + '}';
		        }
		      }
		      var string = argument;
		      var index = -1;
		      var length = string.length;
		      result = '';
		      while (++index < length) {
		        var character = string.charAt(index);
		        if (options.es6) {
		          var first = string.charCodeAt(index);
		          if (first >= 0xD800 && first <= 0xDBFF && length > index + 1) {
		            var second = string.charCodeAt(index + 1);
		            if (second >= 0xDC00 && second <= 0xDFFF) {
		              var codePoint = (first - 0xD800) * 0x400 + second - 0xDC00 + 0x10000;
		              var _hexadecimal = codePoint.toString(16);
		              if (!lowercaseHex) {
		                _hexadecimal = _hexadecimal.toUpperCase();
		              }
		              result += "\\u{" + _hexadecimal + '}';
		              ++index;
		              continue;
		            }
		          }
		        }
		        if (!options.escapeEverything) {
		          if (regexWhitelist.test(character)) {
		            result += character;
		            continue;
		          }
		          if (character == '"') {
		            result += quote == character ? '\\"' : character;
		            continue;
		          }
		          if (character == '`') {
		            result += quote == character ? '\\`' : character;
		            continue;
		          }
		          if (character == '\'') {
		            result += quote == character ? '\\\'' : character;
		            continue;
		          }
		        }
		        if (character == '\0' && !json && !regexDigit.test(string.charAt(index + 1))) {
		          result += '\\0';
		          continue;
		        }
		        if (regexSingleEscape.test(character)) {
		          result += singleEscapes[character];
		          continue;
		        }
		        var charCode = character.charCodeAt(0);
		        if (options.minimal && charCode != 0x2028 && charCode != 0x2029) {
		          result += character;
		          continue;
		        }
		        var _hexadecimal2 = charCode.toString(16);
		        if (!lowercaseHex) {
		          _hexadecimal2 = _hexadecimal2.toUpperCase();
		        }
		        var longhand = _hexadecimal2.length > 2 || json;
		        var escaped = '\\' + (longhand ? 'u' : 'x') + ('0000' + _hexadecimal2).slice(longhand ? -4 : -2);
		        result += escaped;
		        continue;
		      }
		      if (options.wrap) {
		        result = quote + result + quote;
		      }
		      if (quote == '`') {
		        result = result.replace(/\$\{/g, '\\\$\{');
		      }
		      if (options.isScriptContext) {
		        return result.replace(/<\/(script|style)/gi, '<\\/$1').replace(/<!--/g, json ? "\\u003C!--" : '\\x3C!--');
		      }
		      return result;
		    };
		    jsesc.version = '2.5.2';
		    jsesc_1 = jsesc;
		    return jsesc_1;
		  }

		  function bool$9(value) {
		    if (value == null) return false;
		    return value && value !== "false" && value !== "0";
		  }
		  var jsesc = bool$9(browser$1$1.env["BABEL_8_BREAKING"]) ? requireJsesc() : requireJsesc();

		  var isAssignmentPattern$3 = isAssignmentPattern$4,
		    isIdentifier$d = isIdentifier$i;
		  function Identifier(node) {
		    var _node$loc;
		    this.sourceIdentifierName(((_node$loc = node.loc) == null ? void 0 : _node$loc.identifierName) || node.name);
		    this.word(node.name);
		  }
		  function ArgumentPlaceholder() {
		    this.tokenChar(63);
		  }
		  function RestElement$1(node) {
		    this.token("...");
		    this.print(node.argument, node);
		  }
		  function ObjectExpression$1(node) {
		    var props = node.properties;
		    this.tokenChar(123);
		    if (props.length) {
		      this.space();
		      this.printList(props, node, {
		        indent: true,
		        statement: true
		      });
		      this.space();
		    }
		    this.sourceWithOffset("end", node.loc, -1);
		    this.tokenChar(125);
		  }
		  function ObjectMethod(node) {
		    this.printJoin(node.decorators, node);
		    this._methodHead(node);
		    this.space();
		    this.print(node.body, node);
		  }
		  function ObjectProperty(node) {
		    this.printJoin(node.decorators, node);
		    if (node.computed) {
		      this.tokenChar(91);
		      this.print(node.key, node);
		      this.tokenChar(93);
		    } else {
		      if (isAssignmentPattern$3(node.value) && isIdentifier$d(node.key) && node.key.name === node.value.left.name) {
		        this.print(node.value, node);
		        return;
		      }
		      this.print(node.key, node);
		      if (node.shorthand && isIdentifier$d(node.key) && isIdentifier$d(node.value) && node.key.name === node.value.name) {
		        return;
		      }
		    }
		    this.tokenChar(58);
		    this.space();
		    this.print(node.value, node);
		  }
		  function ArrayExpression$1(node) {
		    var elems = node.elements;
		    var len = elems.length;
		    this.tokenChar(91);
		    for (var i = 0; i < elems.length; i++) {
		      var elem = elems[i];
		      if (elem) {
		        if (i > 0) this.space();
		        this.print(elem, node);
		        if (i < len - 1) this.tokenChar(44);
		      } else {
		        this.tokenChar(44);
		      }
		    }
		    this.tokenChar(93);
		  }
		  function RecordExpression(node) {
		    var props = node.properties;
		    var startToken;
		    var endToken;
		    if (this.format.recordAndTupleSyntaxType === "bar") {
		      startToken = "{|";
		      endToken = "|}";
		    } else if (this.format.recordAndTupleSyntaxType !== "hash" && this.format.recordAndTupleSyntaxType != null) {
		      throw new Error("The \"recordAndTupleSyntaxType\" generator option must be \"bar\" or \"hash\" (" + JSON.stringify(this.format.recordAndTupleSyntaxType) + " received).");
		    } else {
		      startToken = "#{";
		      endToken = "}";
		    }
		    this.token(startToken);
		    if (props.length) {
		      this.space();
		      this.printList(props, node, {
		        indent: true,
		        statement: true
		      });
		      this.space();
		    }
		    this.token(endToken);
		  }
		  function TupleExpression(node) {
		    var elems = node.elements;
		    var len = elems.length;
		    var startToken;
		    var endToken;
		    if (this.format.recordAndTupleSyntaxType === "bar") {
		      startToken = "[|";
		      endToken = "|]";
		    } else if (this.format.recordAndTupleSyntaxType === "hash") {
		      startToken = "#[";
		      endToken = "]";
		    } else {
		      throw new Error(this.format.recordAndTupleSyntaxType + " is not a valid recordAndTuple syntax type");
		    }
		    this.token(startToken);
		    for (var i = 0; i < elems.length; i++) {
		      var elem = elems[i];
		      if (elem) {
		        if (i > 0) this.space();
		        this.print(elem, node);
		        if (i < len - 1) this.tokenChar(44);
		      }
		    }
		    this.token(endToken);
		  }
		  function RegExpLiteral$1(node) {
		    this.word("/" + node.pattern + "/" + node.flags);
		  }
		  function BooleanLiteral$1(node) {
		    this.word(node.value ? "true" : "false");
		  }
		  function NullLiteral$1() {
		    this.word("null");
		  }
		  function NumericLiteral$1(node) {
		    var raw = this.getPossibleRaw(node);
		    var opts = this.format.jsescOption;
		    var value = node.value;
		    var str = value + "";
		    if (opts.numbers) {
		      this.number(jsesc(value, opts), value);
		    } else if (raw == null) {
		      this.number(str, value);
		    } else if (this.format.minified) {
		      this.number(raw.length < str.length ? raw : str, value);
		    } else {
		      this.number(raw, value);
		    }
		  }
		  function StringLiteral$1(node) {
		    var raw = this.getPossibleRaw(node);
		    if (!this.format.minified && raw !== undefined) {
		      this.token(raw);
		      return;
		    }
		    var val = jsesc(node.value, this.format.jsescOption);
		    this.token(val);
		  }
		  function BigIntLiteral(node) {
		    var raw = this.getPossibleRaw(node);
		    if (!this.format.minified && raw !== undefined) {
		      this.word(raw);
		      return;
		    }
		    this.word(node.value + "n");
		  }
		  function DecimalLiteral(node) {
		    var raw = this.getPossibleRaw(node);
		    if (!this.format.minified && raw !== undefined) {
		      this.word(raw);
		      return;
		    }
		    this.word(node.value + "m");
		  }
		  var validTopicTokenSet = new Set(["^^", "@@", "^", "%", "#"]);
		  function TopicReference() {
		    var topicToken = this.format.topicToken;
		    if (validTopicTokenSet.has(topicToken)) {
		      this.token(topicToken);
		    } else {
		      var givenTopicTokenJSON = JSON.stringify(topicToken);
		      var validTopics = Array.from(validTopicTokenSet, function (v) {
		        return JSON.stringify(v);
		      });
		      throw new Error("The \"topicToken\" generator option must be one of " + (validTopics.join(", ") + " (" + givenTopicTokenJSON + " received instead)."));
		    }
		  }
		  function PipelineTopicExpression(node) {
		    this.print(node.expression, node);
		  }
		  function PipelineBareFunction(node) {
		    this.print(node.callee, node);
		  }
		  function PipelinePrimaryTopicReference() {
		    this.tokenChar(35);
		  }

		  var isDeclareExportDeclaration = isDeclareExportDeclaration$1,
		    isStatement$4 = isStatement$8;
		  function AnyTypeAnnotation() {
		    this.word("any");
		  }
		  function ArrayTypeAnnotation(node) {
		    this.print(node.elementType, node, true);
		    this.tokenChar(91);
		    this.tokenChar(93);
		  }
		  function BooleanTypeAnnotation() {
		    this.word("boolean");
		  }
		  function BooleanLiteralTypeAnnotation(node) {
		    this.word(node.value ? "true" : "false");
		  }
		  function NullLiteralTypeAnnotation() {
		    this.word("null");
		  }
		  function DeclareClass(node, parent) {
		    if (!isDeclareExportDeclaration(parent)) {
		      this.word("declare");
		      this.space();
		    }
		    this.word("class");
		    this.space();
		    this._interfaceish(node);
		  }
		  function DeclareFunction(node, parent) {
		    if (!isDeclareExportDeclaration(parent)) {
		      this.word("declare");
		      this.space();
		    }
		    this.word("function");
		    this.space();
		    this.print(node.id, node);
		    this.print(node.id.typeAnnotation.typeAnnotation, node);
		    if (node.predicate) {
		      this.space();
		      this.print(node.predicate, node);
		    }
		    this.semicolon();
		  }
		  function InferredPredicate() {
		    this.tokenChar(37);
		    this.word("checks");
		  }
		  function DeclaredPredicate(node) {
		    this.tokenChar(37);
		    this.word("checks");
		    this.tokenChar(40);
		    this.print(node.value, node);
		    this.tokenChar(41);
		  }
		  function DeclareInterface(node) {
		    this.word("declare");
		    this.space();
		    this.InterfaceDeclaration(node);
		  }
		  function DeclareModule(node) {
		    this.word("declare");
		    this.space();
		    this.word("module");
		    this.space();
		    this.print(node.id, node);
		    this.space();
		    this.print(node.body, node);
		  }
		  function DeclareModuleExports(node) {
		    this.word("declare");
		    this.space();
		    this.word("module");
		    this.tokenChar(46);
		    this.word("exports");
		    this.print(node.typeAnnotation, node);
		  }
		  function DeclareTypeAlias(node) {
		    this.word("declare");
		    this.space();
		    this.TypeAlias(node);
		  }
		  function DeclareOpaqueType(node, parent) {
		    if (!isDeclareExportDeclaration(parent)) {
		      this.word("declare");
		      this.space();
		    }
		    this.OpaqueType(node);
		  }
		  function DeclareVariable(node, parent) {
		    if (!isDeclareExportDeclaration(parent)) {
		      this.word("declare");
		      this.space();
		    }
		    this.word("var");
		    this.space();
		    this.print(node.id, node);
		    this.print(node.id.typeAnnotation, node);
		    this.semicolon();
		  }
		  function DeclareExportDeclaration(node) {
		    this.word("declare");
		    this.space();
		    this.word("export");
		    this.space();
		    if (node["default"]) {
		      this.word("default");
		      this.space();
		    }
		    FlowExportDeclaration.call(this, node);
		  }
		  function DeclareExportAllDeclaration(node) {
		    this.word("declare");
		    this.space();
		    ExportAllDeclaration.call(this, node);
		  }
		  function EnumDeclaration(node) {
		    var id = node.id,
		      body = node.body;
		    this.word("enum");
		    this.space();
		    this.print(id, node);
		    this.print(body, node);
		  }
		  function enumExplicitType(context, name, hasExplicitType) {
		    if (hasExplicitType) {
		      context.space();
		      context.word("of");
		      context.space();
		      context.word(name);
		    }
		    context.space();
		  }
		  function enumBody(context, node) {
		    var members = node.members;
		    context.token("{");
		    context.indent();
		    context.newline();
		    for (var _iterator = _createForOfIteratorHelperLoose(members), _step; !(_step = _iterator()).done;) {
		      var member = _step.value;
		      context.print(member, node);
		      context.newline();
		    }
		    if (node.hasUnknownMembers) {
		      context.token("...");
		      context.newline();
		    }
		    context.dedent();
		    context.token("}");
		  }
		  function EnumBooleanBody(node) {
		    var explicitType = node.explicitType;
		    enumExplicitType(this, "boolean", explicitType);
		    enumBody(this, node);
		  }
		  function EnumNumberBody(node) {
		    var explicitType = node.explicitType;
		    enumExplicitType(this, "number", explicitType);
		    enumBody(this, node);
		  }
		  function EnumStringBody(node) {
		    var explicitType = node.explicitType;
		    enumExplicitType(this, "string", explicitType);
		    enumBody(this, node);
		  }
		  function EnumSymbolBody(node) {
		    enumExplicitType(this, "symbol", true);
		    enumBody(this, node);
		  }
		  function EnumDefaultedMember(node) {
		    var id = node.id;
		    this.print(id, node);
		    this.tokenChar(44);
		  }
		  function enumInitializedMember(context, node) {
		    var id = node.id,
		      init = node.init;
		    context.print(id, node);
		    context.space();
		    context.token("=");
		    context.space();
		    context.print(init, node);
		    context.token(",");
		  }
		  function EnumBooleanMember(node) {
		    enumInitializedMember(this, node);
		  }
		  function EnumNumberMember(node) {
		    enumInitializedMember(this, node);
		  }
		  function EnumStringMember(node) {
		    enumInitializedMember(this, node);
		  }
		  function FlowExportDeclaration(node) {
		    if (node.declaration) {
		      var declar = node.declaration;
		      this.print(declar, node);
		      if (!isStatement$4(declar)) this.semicolon();
		    } else {
		      this.tokenChar(123);
		      if (node.specifiers.length) {
		        this.space();
		        this.printList(node.specifiers, node);
		        this.space();
		      }
		      this.tokenChar(125);
		      if (node.source) {
		        this.space();
		        this.word("from");
		        this.space();
		        this.print(node.source, node);
		      }
		      this.semicolon();
		    }
		  }
		  function ExistsTypeAnnotation() {
		    this.tokenChar(42);
		  }
		  function FunctionTypeAnnotation(node, parent) {
		    this.print(node.typeParameters, node);
		    this.tokenChar(40);
		    if (node["this"]) {
		      this.word("this");
		      this.tokenChar(58);
		      this.space();
		      this.print(node["this"].typeAnnotation, node);
		      if (node.params.length || node.rest) {
		        this.tokenChar(44);
		        this.space();
		      }
		    }
		    this.printList(node.params, node);
		    if (node.rest) {
		      if (node.params.length) {
		        this.tokenChar(44);
		        this.space();
		      }
		      this.token("...");
		      this.print(node.rest, node);
		    }
		    this.tokenChar(41);
		    var type = parent == null ? void 0 : parent.type;
		    if (type != null && (type === "ObjectTypeCallProperty" || type === "ObjectTypeInternalSlot" || type === "DeclareFunction" || type === "ObjectTypeProperty" && parent.method)) {
		      this.tokenChar(58);
		    } else {
		      this.space();
		      this.token("=>");
		    }
		    this.space();
		    this.print(node.returnType, node);
		  }
		  function FunctionTypeParam(node) {
		    this.print(node.name, node);
		    if (node.optional) this.tokenChar(63);
		    if (node.name) {
		      this.tokenChar(58);
		      this.space();
		    }
		    this.print(node.typeAnnotation, node);
		  }
		  function InterfaceExtends(node) {
		    this.print(node.id, node);
		    this.print(node.typeParameters, node, true);
		  }
		  function _interfaceish(node) {
		    var _node$extends;
		    this.print(node.id, node);
		    this.print(node.typeParameters, node);
		    if ((_node$extends = node["extends"]) != null && _node$extends.length) {
		      this.space();
		      this.word("extends");
		      this.space();
		      this.printList(node["extends"], node);
		    }
		    if (node.type === "DeclareClass") {
		      var _node$mixins, _node$implements;
		      if ((_node$mixins = node.mixins) != null && _node$mixins.length) {
		        this.space();
		        this.word("mixins");
		        this.space();
		        this.printList(node.mixins, node);
		      }
		      if ((_node$implements = node["implements"]) != null && _node$implements.length) {
		        this.space();
		        this.word("implements");
		        this.space();
		        this.printList(node["implements"], node);
		      }
		    }
		    this.space();
		    this.print(node.body, node);
		  }
		  function _variance(node) {
		    var _node$variance;
		    var kind = (_node$variance = node.variance) == null ? void 0 : _node$variance.kind;
		    if (kind != null) {
		      if (kind === "plus") {
		        this.tokenChar(43);
		      } else if (kind === "minus") {
		        this.tokenChar(45);
		      }
		    }
		  }
		  function InterfaceDeclaration(node) {
		    this.word("interface");
		    this.space();
		    this._interfaceish(node);
		  }
		  function andSeparator() {
		    this.space();
		    this.tokenChar(38);
		    this.space();
		  }
		  function InterfaceTypeAnnotation(node) {
		    var _node$extends2;
		    this.word("interface");
		    if ((_node$extends2 = node["extends"]) != null && _node$extends2.length) {
		      this.space();
		      this.word("extends");
		      this.space();
		      this.printList(node["extends"], node);
		    }
		    this.space();
		    this.print(node.body, node);
		  }
		  function IntersectionTypeAnnotation(node) {
		    this.printJoin(node.types, node, {
		      separator: andSeparator
		    });
		  }
		  function MixedTypeAnnotation() {
		    this.word("mixed");
		  }
		  function EmptyTypeAnnotation() {
		    this.word("empty");
		  }
		  function NullableTypeAnnotation(node) {
		    this.tokenChar(63);
		    this.print(node.typeAnnotation, node);
		  }
		  function NumberTypeAnnotation() {
		    this.word("number");
		  }
		  function StringTypeAnnotation() {
		    this.word("string");
		  }
		  function ThisTypeAnnotation() {
		    this.word("this");
		  }
		  function TupleTypeAnnotation(node) {
		    this.tokenChar(91);
		    this.printList(node.types, node);
		    this.tokenChar(93);
		  }
		  function TypeofTypeAnnotation(node) {
		    this.word("typeof");
		    this.space();
		    this.print(node.argument, node);
		  }
		  function TypeAlias(node) {
		    this.word("type");
		    this.space();
		    this.print(node.id, node);
		    this.print(node.typeParameters, node);
		    this.space();
		    this.tokenChar(61);
		    this.space();
		    this.print(node.right, node);
		    this.semicolon();
		  }
		  function TypeAnnotation(node) {
		    this.tokenChar(58);
		    this.space();
		    if (node.optional) this.tokenChar(63);
		    this.print(node.typeAnnotation, node);
		  }
		  function TypeParameterInstantiation(node) {
		    this.tokenChar(60);
		    this.printList(node.params, node, {});
		    this.tokenChar(62);
		  }
		  function TypeParameter(node) {
		    this._variance(node);
		    this.word(node.name);
		    if (node.bound) {
		      this.print(node.bound, node);
		    }
		    if (node["default"]) {
		      this.space();
		      this.tokenChar(61);
		      this.space();
		      this.print(node["default"], node);
		    }
		  }
		  function OpaqueType(node) {
		    this.word("opaque");
		    this.space();
		    this.word("type");
		    this.space();
		    this.print(node.id, node);
		    this.print(node.typeParameters, node);
		    if (node.supertype) {
		      this.tokenChar(58);
		      this.space();
		      this.print(node.supertype, node);
		    }
		    if (node.impltype) {
		      this.space();
		      this.tokenChar(61);
		      this.space();
		      this.print(node.impltype, node);
		    }
		    this.semicolon();
		  }
		  function ObjectTypeAnnotation(node) {
		    var _this = this;
		    if (node.exact) {
		      this.token("{|");
		    } else {
		      this.tokenChar(123);
		    }
		    var props = [].concat(_toConsumableArray(node.properties), _toConsumableArray(node.callProperties || []), _toConsumableArray(node.indexers || []), _toConsumableArray(node.internalSlots || []));
		    if (props.length) {
		      this.newline();
		      this.space();
		      this.printJoin(props, node, {
		        addNewlines: function addNewlines(leading) {
		          if (leading && !props[0]) return 1;
		        },
		        indent: true,
		        statement: true,
		        iterator: function iterator() {
		          if (props.length !== 1 || node.inexact) {
		            _this.token(",");
		            _this.space();
		          }
		        }
		      });
		      this.space();
		    }
		    if (node.inexact) {
		      this.indent();
		      this.token("...");
		      if (props.length) {
		        this.newline();
		      }
		      this.dedent();
		    }
		    if (node.exact) {
		      this.token("|}");
		    } else {
		      this.tokenChar(125);
		    }
		  }
		  function ObjectTypeInternalSlot(node) {
		    if (node["static"]) {
		      this.word("static");
		      this.space();
		    }
		    this.tokenChar(91);
		    this.tokenChar(91);
		    this.print(node.id, node);
		    this.tokenChar(93);
		    this.tokenChar(93);
		    if (node.optional) this.tokenChar(63);
		    if (!node.method) {
		      this.tokenChar(58);
		      this.space();
		    }
		    this.print(node.value, node);
		  }
		  function ObjectTypeCallProperty(node) {
		    if (node["static"]) {
		      this.word("static");
		      this.space();
		    }
		    this.print(node.value, node);
		  }
		  function ObjectTypeIndexer(node) {
		    if (node["static"]) {
		      this.word("static");
		      this.space();
		    }
		    this._variance(node);
		    this.tokenChar(91);
		    if (node.id) {
		      this.print(node.id, node);
		      this.tokenChar(58);
		      this.space();
		    }
		    this.print(node.key, node);
		    this.tokenChar(93);
		    this.tokenChar(58);
		    this.space();
		    this.print(node.value, node);
		  }
		  function ObjectTypeProperty(node) {
		    if (node.proto) {
		      this.word("proto");
		      this.space();
		    }
		    if (node["static"]) {
		      this.word("static");
		      this.space();
		    }
		    if (node.kind === "get" || node.kind === "set") {
		      this.word(node.kind);
		      this.space();
		    }
		    this._variance(node);
		    this.print(node.key, node);
		    if (node.optional) this.tokenChar(63);
		    if (!node.method) {
		      this.tokenChar(58);
		      this.space();
		    }
		    this.print(node.value, node);
		  }
		  function ObjectTypeSpreadProperty(node) {
		    this.token("...");
		    this.print(node.argument, node);
		  }
		  function QualifiedTypeIdentifier(node) {
		    this.print(node.qualification, node);
		    this.tokenChar(46);
		    this.print(node.id, node);
		  }
		  function SymbolTypeAnnotation() {
		    this.word("symbol");
		  }
		  function orSeparator() {
		    this.space();
		    this.tokenChar(124);
		    this.space();
		  }
		  function UnionTypeAnnotation(node) {
		    this.printJoin(node.types, node, {
		      separator: orSeparator
		    });
		  }
		  function TypeCastExpression$1(node) {
		    this.tokenChar(40);
		    this.print(node.expression, node);
		    this.print(node.typeAnnotation, node);
		    this.tokenChar(41);
		  }
		  function Variance(node) {
		    if (node.kind === "plus") {
		      this.tokenChar(43);
		    } else {
		      this.tokenChar(45);
		    }
		  }
		  function VoidTypeAnnotation() {
		    this.word("void");
		  }
		  function IndexedAccessType(node) {
		    this.print(node.objectType, node, true);
		    this.tokenChar(91);
		    this.print(node.indexType, node);
		    this.tokenChar(93);
		  }
		  function OptionalIndexedAccessType(node) {
		    this.print(node.objectType, node);
		    if (node.optional) {
		      this.token("?.");
		    }
		    this.tokenChar(91);
		    this.print(node.indexType, node);
		    this.tokenChar(93);
		  }

		  function File$1(node) {
		    if (node.program) {
		      this.print(node.program.interpreter, node);
		    }
		    this.print(node.program, node);
		  }
		  function Program(node) {
		    var _node$directives;
		    this.noIndentInnerCommentsHere();
		    this.printInnerComments();
		    var directivesLen = (_node$directives = node.directives) == null ? void 0 : _node$directives.length;
		    if (directivesLen) {
		      var _node$directives$trai;
		      var newline = node.body.length ? 2 : 1;
		      this.printSequence(node.directives, node, {
		        trailingCommentsLineOffset: newline
		      });
		      if (!((_node$directives$trai = node.directives[directivesLen - 1].trailingComments) != null && _node$directives$trai.length)) {
		        this.newline(newline);
		      }
		    }
		    this.printSequence(node.body, node);
		  }
		  function BlockStatement(node) {
		    var _node$directives2;
		    this.tokenChar(123);
		    var directivesLen = (_node$directives2 = node.directives) == null ? void 0 : _node$directives2.length;
		    if (directivesLen) {
		      var _node$directives$trai2;
		      var newline = node.body.length ? 2 : 1;
		      this.printSequence(node.directives, node, {
		        indent: true,
		        trailingCommentsLineOffset: newline
		      });
		      if (!((_node$directives$trai2 = node.directives[directivesLen - 1].trailingComments) != null && _node$directives$trai2.length)) {
		        this.newline(newline);
		      }
		    }
		    this.printSequence(node.body, node, {
		      indent: true
		    });
		    this.rightBrace(node);
		  }
		  function Directive(node) {
		    this.print(node.value, node);
		    this.semicolon();
		  }
		  var unescapedSingleQuoteRE = /(?:^|[^\\])(?:\\\\)*'/;
		  var unescapedDoubleQuoteRE = /(?:^|[^\\])(?:\\\\)*"/;
		  function DirectiveLiteral(node) {
		    var raw = this.getPossibleRaw(node);
		    if (!this.format.minified && raw !== undefined) {
		      this.token(raw);
		      return;
		    }
		    var value = node.value;
		    if (!unescapedDoubleQuoteRE.test(value)) {
		      this.token("\"" + value + "\"");
		    } else if (!unescapedSingleQuoteRE.test(value)) {
		      this.token("'" + value + "'");
		    } else {
		      throw new Error("Malformed AST: it is not possible to print a directive containing" + " both unescaped single and double quotes.");
		    }
		  }
		  function InterpreterDirective(node) {
		    this.token("#!" + node.value);
		    this.newline(1, true);
		  }
		  function Placeholder(node) {
		    this.token("%%");
		    this.print(node.name);
		    this.token("%%");
		    if (node.expectedNode === "Statement") {
		      this.semicolon();
		    }
		  }

		  function JSXAttribute(node) {
		    this.print(node.name, node);
		    if (node.value) {
		      this.tokenChar(61);
		      this.print(node.value, node);
		    }
		  }
		  function JSXIdentifier(node) {
		    this.word(node.name);
		  }
		  function JSXNamespacedName(node) {
		    this.print(node.namespace, node);
		    this.tokenChar(58);
		    this.print(node.name, node);
		  }
		  function JSXMemberExpression(node) {
		    this.print(node.object, node);
		    this.tokenChar(46);
		    this.print(node.property, node);
		  }
		  function JSXSpreadAttribute(node) {
		    this.tokenChar(123);
		    this.token("...");
		    this.print(node.argument, node);
		    this.tokenChar(125);
		  }
		  function JSXExpressionContainer(node) {
		    this.tokenChar(123);
		    this.print(node.expression, node);
		    this.tokenChar(125);
		  }
		  function JSXSpreadChild(node) {
		    this.tokenChar(123);
		    this.token("...");
		    this.print(node.expression, node);
		    this.tokenChar(125);
		  }
		  function JSXText(node) {
		    var raw = this.getPossibleRaw(node);
		    if (raw !== undefined) {
		      this.token(raw, true);
		    } else {
		      this.token(node.value, true);
		    }
		  }
		  function JSXElement(node) {
		    var open = node.openingElement;
		    this.print(open, node);
		    if (open.selfClosing) return;
		    this.indent();
		    for (var _iterator = _createForOfIteratorHelperLoose(node.children), _step; !(_step = _iterator()).done;) {
		      var child = _step.value;
		      this.print(child, node);
		    }
		    this.dedent();
		    this.print(node.closingElement, node);
		  }
		  function spaceSeparator() {
		    this.space();
		  }
		  function JSXOpeningElement(node) {
		    this.tokenChar(60);
		    this.print(node.name, node);
		    this.print(node.typeParameters, node);
		    if (node.attributes.length > 0) {
		      this.space();
		      this.printJoin(node.attributes, node, {
		        separator: spaceSeparator
		      });
		    }
		    if (node.selfClosing) {
		      this.space();
		      this.token("/>");
		    } else {
		      this.tokenChar(62);
		    }
		  }
		  function JSXClosingElement(node) {
		    this.token("</");
		    this.print(node.name, node);
		    this.tokenChar(62);
		  }
		  function JSXEmptyExpression() {
		    this.printInnerComments();
		  }
		  function JSXFragment(node) {
		    this.print(node.openingFragment, node);
		    this.indent();
		    for (var _iterator2 = _createForOfIteratorHelperLoose(node.children), _step2; !(_step2 = _iterator2()).done;) {
		      var child = _step2.value;
		      this.print(child, node);
		    }
		    this.dedent();
		    this.print(node.closingFragment, node);
		  }
		  function JSXOpeningFragment() {
		    this.tokenChar(60);
		    this.tokenChar(62);
		  }
		  function JSXClosingFragment() {
		    this.token("</");
		    this.tokenChar(62);
		  }

		  function TSTypeAnnotation(node) {
		    this.tokenChar(58);
		    this.space();
		    if (node.optional) this.tokenChar(63);
		    this.print(node.typeAnnotation, node);
		  }
		  function TSTypeParameterInstantiation(node, parent) {
		    this.tokenChar(60);
		    this.printList(node.params, node, {});
		    if (parent.type === "ArrowFunctionExpression" && node.params.length === 1) {
		      this.tokenChar(44);
		    }
		    this.tokenChar(62);
		  }
		  function TSTypeParameter(node) {
		    if (node["in"]) {
		      this.word("in");
		      this.space();
		    }
		    if (node.out) {
		      this.word("out");
		      this.space();
		    }
		    this.word(node.name);
		    if (node.constraint) {
		      this.space();
		      this.word("extends");
		      this.space();
		      this.print(node.constraint, node);
		    }
		    if (node["default"]) {
		      this.space();
		      this.tokenChar(61);
		      this.space();
		      this.print(node["default"], node);
		    }
		  }
		  function TSParameterProperty(node) {
		    if (node.accessibility) {
		      this.word(node.accessibility);
		      this.space();
		    }
		    if (node.readonly) {
		      this.word("readonly");
		      this.space();
		    }
		    this._param(node.parameter);
		  }
		  function TSDeclareFunction(node, parent) {
		    if (node.declare) {
		      this.word("declare");
		      this.space();
		    }
		    this._functionHead(node, parent);
		    this.tokenChar(59);
		  }
		  function TSDeclareMethod(node) {
		    this._classMethodHead(node);
		    this.tokenChar(59);
		  }
		  function TSQualifiedName(node) {
		    this.print(node.left, node);
		    this.tokenChar(46);
		    this.print(node.right, node);
		  }
		  function TSCallSignatureDeclaration(node) {
		    this.tsPrintSignatureDeclarationBase(node);
		    this.tokenChar(59);
		  }
		  function TSConstructSignatureDeclaration(node) {
		    this.word("new");
		    this.space();
		    this.tsPrintSignatureDeclarationBase(node);
		    this.tokenChar(59);
		  }
		  function TSPropertySignature(node) {
		    var readonly = node.readonly;
		    if (readonly) {
		      this.word("readonly");
		      this.space();
		    }
		    this.tsPrintPropertyOrMethodName(node);
		    this.print(node.typeAnnotation, node);
		    this.tokenChar(59);
		  }
		  function tsPrintPropertyOrMethodName(node) {
		    if (node.computed) {
		      this.tokenChar(91);
		    }
		    this.print(node.key, node);
		    if (node.computed) {
		      this.tokenChar(93);
		    }
		    if (node.optional) {
		      this.tokenChar(63);
		    }
		  }
		  function TSMethodSignature(node) {
		    var kind = node.kind;
		    if (kind === "set" || kind === "get") {
		      this.word(kind);
		      this.space();
		    }
		    this.tsPrintPropertyOrMethodName(node);
		    this.tsPrintSignatureDeclarationBase(node);
		    this.tokenChar(59);
		  }
		  function TSIndexSignature(node) {
		    var readonly = node.readonly,
		      isStatic = node["static"];
		    if (isStatic) {
		      this.word("static");
		      this.space();
		    }
		    if (readonly) {
		      this.word("readonly");
		      this.space();
		    }
		    this.tokenChar(91);
		    this._parameters(node.parameters, node);
		    this.tokenChar(93);
		    this.print(node.typeAnnotation, node);
		    this.tokenChar(59);
		  }
		  function TSAnyKeyword() {
		    this.word("any");
		  }
		  function TSBigIntKeyword() {
		    this.word("bigint");
		  }
		  function TSUnknownKeyword() {
		    this.word("unknown");
		  }
		  function TSNumberKeyword() {
		    this.word("number");
		  }
		  function TSObjectKeyword() {
		    this.word("object");
		  }
		  function TSBooleanKeyword() {
		    this.word("boolean");
		  }
		  function TSStringKeyword() {
		    this.word("string");
		  }
		  function TSSymbolKeyword() {
		    this.word("symbol");
		  }
		  function TSVoidKeyword() {
		    this.word("void");
		  }
		  function TSUndefinedKeyword() {
		    this.word("undefined");
		  }
		  function TSNullKeyword() {
		    this.word("null");
		  }
		  function TSNeverKeyword() {
		    this.word("never");
		  }
		  function TSIntrinsicKeyword() {
		    this.word("intrinsic");
		  }
		  function TSThisType() {
		    this.word("this");
		  }
		  function TSFunctionType(node) {
		    this.tsPrintFunctionOrConstructorType(node);
		  }
		  function TSConstructorType(node) {
		    if (node["abstract"]) {
		      this.word("abstract");
		      this.space();
		    }
		    this.word("new");
		    this.space();
		    this.tsPrintFunctionOrConstructorType(node);
		  }
		  function tsPrintFunctionOrConstructorType(node) {
		    var typeParameters = node.typeParameters;
		    var parameters = node.parameters;
		    this.print(typeParameters, node);
		    this.tokenChar(40);
		    this._parameters(parameters, node);
		    this.tokenChar(41);
		    this.space();
		    this.token("=>");
		    this.space();
		    var returnType = node.typeAnnotation;
		    this.print(returnType.typeAnnotation, node);
		  }
		  function TSTypeReference(node) {
		    this.print(node.typeName, node, true);
		    this.print(node.typeParameters, node, true);
		  }
		  function TSTypePredicate(node) {
		    if (node.asserts) {
		      this.word("asserts");
		      this.space();
		    }
		    this.print(node.parameterName);
		    if (node.typeAnnotation) {
		      this.space();
		      this.word("is");
		      this.space();
		      this.print(node.typeAnnotation.typeAnnotation);
		    }
		  }
		  function TSTypeQuery(node) {
		    this.word("typeof");
		    this.space();
		    this.print(node.exprName);
		    if (node.typeParameters) {
		      this.print(node.typeParameters, node);
		    }
		  }
		  function TSTypeLiteral(node) {
		    this.tsPrintTypeLiteralOrInterfaceBody(node.members, node);
		  }
		  function tsPrintTypeLiteralOrInterfaceBody(members, node) {
		    tsPrintBraced(this, members, node);
		  }
		  function tsPrintBraced(printer, members, node) {
		    printer.token("{");
		    if (members.length) {
		      printer.indent();
		      printer.newline();
		      for (var _iterator = _createForOfIteratorHelperLoose(members), _step; !(_step = _iterator()).done;) {
		        var member = _step.value;
		        printer.print(member, node);
		        printer.newline();
		      }
		      printer.dedent();
		    }
		    printer.rightBrace(node);
		  }
		  function TSArrayType(node) {
		    this.print(node.elementType, node, true);
		    this.token("[]");
		  }
		  function TSTupleType(node) {
		    this.tokenChar(91);
		    this.printList(node.elementTypes, node);
		    this.tokenChar(93);
		  }
		  function TSOptionalType(node) {
		    this.print(node.typeAnnotation, node);
		    this.tokenChar(63);
		  }
		  function TSRestType(node) {
		    this.token("...");
		    this.print(node.typeAnnotation, node);
		  }
		  function TSNamedTupleMember(node) {
		    this.print(node.label, node);
		    if (node.optional) this.tokenChar(63);
		    this.tokenChar(58);
		    this.space();
		    this.print(node.elementType, node);
		  }
		  function TSUnionType(node) {
		    tsPrintUnionOrIntersectionType(this, node, "|");
		  }
		  function TSIntersectionType(node) {
		    tsPrintUnionOrIntersectionType(this, node, "&");
		  }
		  function tsPrintUnionOrIntersectionType(printer, node, sep) {
		    printer.printJoin(node.types, node, {
		      separator: function separator() {
		        this.space();
		        this.token(sep);
		        this.space();
		      }
		    });
		  }
		  function TSConditionalType(node) {
		    this.print(node.checkType);
		    this.space();
		    this.word("extends");
		    this.space();
		    this.print(node.extendsType);
		    this.space();
		    this.tokenChar(63);
		    this.space();
		    this.print(node.trueType);
		    this.space();
		    this.tokenChar(58);
		    this.space();
		    this.print(node.falseType);
		  }
		  function TSInferType(node) {
		    this.token("infer");
		    this.space();
		    this.print(node.typeParameter);
		  }
		  function TSParenthesizedType(node) {
		    this.tokenChar(40);
		    this.print(node.typeAnnotation, node);
		    this.tokenChar(41);
		  }
		  function TSTypeOperator(node) {
		    this.word(node.operator);
		    this.space();
		    this.print(node.typeAnnotation, node);
		  }
		  function TSIndexedAccessType(node) {
		    this.print(node.objectType, node, true);
		    this.tokenChar(91);
		    this.print(node.indexType, node);
		    this.tokenChar(93);
		  }
		  function TSMappedType(node) {
		    var nameType = node.nameType,
		      optional = node.optional,
		      readonly = node.readonly,
		      typeParameter = node.typeParameter,
		      typeAnnotation = node.typeAnnotation;
		    this.tokenChar(123);
		    this.space();
		    if (readonly) {
		      tokenIfPlusMinus(this, readonly);
		      this.word("readonly");
		      this.space();
		    }
		    this.tokenChar(91);
		    this.word(typeParameter.name);
		    this.space();
		    this.word("in");
		    this.space();
		    this.print(typeParameter.constraint, typeParameter);
		    if (nameType) {
		      this.space();
		      this.word("as");
		      this.space();
		      this.print(nameType, node);
		    }
		    this.tokenChar(93);
		    if (optional) {
		      tokenIfPlusMinus(this, optional);
		      this.tokenChar(63);
		    }
		    if (typeAnnotation) {
		      this.tokenChar(58);
		      this.space();
		      this.print(typeAnnotation, node);
		    }
		    this.space();
		    this.tokenChar(125);
		  }
		  function tokenIfPlusMinus(self, tok) {
		    if (tok !== true) {
		      self.token(tok);
		    }
		  }
		  function TSLiteralType(node) {
		    this.print(node.literal, node);
		  }
		  function TSExpressionWithTypeArguments(node) {
		    this.print(node.expression, node);
		    this.print(node.typeParameters, node);
		  }
		  function TSInterfaceDeclaration(node) {
		    var declare = node.declare,
		      id = node.id,
		      typeParameters = node.typeParameters,
		      extendz = node["extends"],
		      body = node.body;
		    if (declare) {
		      this.word("declare");
		      this.space();
		    }
		    this.word("interface");
		    this.space();
		    this.print(id, node);
		    this.print(typeParameters, node);
		    if (extendz != null && extendz.length) {
		      this.space();
		      this.word("extends");
		      this.space();
		      this.printList(extendz, node);
		    }
		    this.space();
		    this.print(body, node);
		  }
		  function TSInterfaceBody(node) {
		    this.tsPrintTypeLiteralOrInterfaceBody(node.body, node);
		  }
		  function TSTypeAliasDeclaration(node) {
		    var declare = node.declare,
		      id = node.id,
		      typeParameters = node.typeParameters,
		      typeAnnotation = node.typeAnnotation;
		    if (declare) {
		      this.word("declare");
		      this.space();
		    }
		    this.word("type");
		    this.space();
		    this.print(id, node);
		    this.print(typeParameters, node);
		    this.space();
		    this.tokenChar(61);
		    this.space();
		    this.print(typeAnnotation, node);
		    this.tokenChar(59);
		  }
		  function TSTypeExpression(node) {
		    var _expression$trailingC;
		    var type = node.type,
		      expression = node.expression,
		      typeAnnotation = node.typeAnnotation;
		    var forceParens = !!((_expression$trailingC = expression.trailingComments) != null && _expression$trailingC.length);
		    this.print(expression, node, true, undefined, forceParens);
		    this.space();
		    this.word(type === "TSAsExpression" ? "as" : "satisfies");
		    this.space();
		    this.print(typeAnnotation, node);
		  }
		  function TSTypeAssertion(node) {
		    var typeAnnotation = node.typeAnnotation,
		      expression = node.expression;
		    this.tokenChar(60);
		    this.print(typeAnnotation, node);
		    this.tokenChar(62);
		    this.space();
		    this.print(expression, node);
		  }
		  function TSInstantiationExpression(node) {
		    this.print(node.expression, node);
		    this.print(node.typeParameters, node);
		  }
		  function TSEnumDeclaration(node) {
		    var declare = node.declare,
		      isConst = node["const"],
		      id = node.id,
		      members = node.members;
		    if (declare) {
		      this.word("declare");
		      this.space();
		    }
		    if (isConst) {
		      this.word("const");
		      this.space();
		    }
		    this.word("enum");
		    this.space();
		    this.print(id, node);
		    this.space();
		    tsPrintBraced(this, members, node);
		  }
		  function TSEnumMember(node) {
		    var id = node.id,
		      initializer = node.initializer;
		    this.print(id, node);
		    if (initializer) {
		      this.space();
		      this.tokenChar(61);
		      this.space();
		      this.print(initializer, node);
		    }
		    this.tokenChar(44);
		  }
		  function TSModuleDeclaration(node) {
		    var declare = node.declare,
		      id = node.id;
		    if (declare) {
		      this.word("declare");
		      this.space();
		    }
		    if (!node.global) {
		      this.word(id.type === "Identifier" ? "namespace" : "module");
		      this.space();
		    }
		    this.print(id, node);
		    if (!node.body) {
		      this.tokenChar(59);
		      return;
		    }
		    var body = node.body;
		    while (body.type === "TSModuleDeclaration") {
		      this.tokenChar(46);
		      this.print(body.id, body);
		      body = body.body;
		    }
		    this.space();
		    this.print(body, node);
		  }
		  function TSModuleBlock(node) {
		    tsPrintBraced(this, node.body, node);
		  }
		  function TSImportType(node) {
		    var argument = node.argument,
		      qualifier = node.qualifier,
		      typeParameters = node.typeParameters;
		    this.word("import");
		    this.tokenChar(40);
		    this.print(argument, node);
		    this.tokenChar(41);
		    if (qualifier) {
		      this.tokenChar(46);
		      this.print(qualifier, node);
		    }
		    if (typeParameters) {
		      this.print(typeParameters, node);
		    }
		  }
		  function TSImportEqualsDeclaration(node) {
		    var isExport = node.isExport,
		      id = node.id,
		      moduleReference = node.moduleReference;
		    if (isExport) {
		      this.word("export");
		      this.space();
		    }
		    this.word("import");
		    this.space();
		    this.print(id, node);
		    this.space();
		    this.tokenChar(61);
		    this.space();
		    this.print(moduleReference, node);
		    this.tokenChar(59);
		  }
		  function TSExternalModuleReference(node) {
		    this.token("require(");
		    this.print(node.expression, node);
		    this.tokenChar(41);
		  }
		  function TSNonNullExpression$1(node) {
		    this.print(node.expression, node);
		    this.tokenChar(33);
		  }
		  function TSExportAssignment(node) {
		    this.word("export");
		    this.space();
		    this.tokenChar(61);
		    this.space();
		    this.print(node.expression, node);
		    this.tokenChar(59);
		  }
		  function TSNamespaceExportDeclaration(node) {
		    this.word("export");
		    this.space();
		    this.word("as");
		    this.space();
		    this.word("namespace");
		    this.space();
		    this.print(node.id, node);
		  }
		  function tsPrintSignatureDeclarationBase(node) {
		    var typeParameters = node.typeParameters;
		    var parameters = node.parameters;
		    this.print(typeParameters, node);
		    this.tokenChar(40);
		    this._parameters(parameters, node);
		    this.tokenChar(41);
		    var returnType = node.typeAnnotation;
		    this.print(returnType, node);
		  }
		  function tsPrintClassMemberModifiers(node) {
		    var isField = node.type === "ClassAccessorProperty" || node.type === "ClassProperty";
		    if (isField && node.declare) {
		      this.word("declare");
		      this.space();
		    }
		    if (node.accessibility) {
		      this.word(node.accessibility);
		      this.space();
		    }
		    if (node["static"]) {
		      this.word("static");
		      this.space();
		    }
		    if (node.override) {
		      this.word("override");
		      this.space();
		    }
		    if (node["abstract"]) {
		      this.word("abstract");
		      this.space();
		    }
		    if (isField && node.readonly) {
		      this.word("readonly");
		      this.space();
		    }
		  }

		  var generatorFunctions = /*#__PURE__*/Object.freeze({
		    __proto__: null,
		    AnyTypeAnnotation: AnyTypeAnnotation,
		    ArgumentPlaceholder: ArgumentPlaceholder,
		    ArrayExpression: ArrayExpression$1,
		    ArrayPattern: ArrayExpression$1,
		    ArrayTypeAnnotation: ArrayTypeAnnotation,
		    ArrowFunctionExpression: ArrowFunctionExpression,
		    AssignmentExpression: AssignmentExpression$1,
		    AssignmentPattern: AssignmentPattern,
		    AwaitExpression: AwaitExpression,
		    BigIntLiteral: BigIntLiteral,
		    BinaryExpression: AssignmentExpression$1,
		    BindExpression: BindExpression,
		    BlockStatement: BlockStatement,
		    BooleanLiteral: BooleanLiteral$1,
		    BooleanLiteralTypeAnnotation: BooleanLiteralTypeAnnotation,
		    BooleanTypeAnnotation: BooleanTypeAnnotation,
		    BreakStatement: BreakStatement,
		    CallExpression: CallExpression$1,
		    CatchClause: CatchClause,
		    ClassAccessorProperty: ClassAccessorProperty,
		    ClassBody: ClassBody,
		    ClassDeclaration: ClassDeclaration,
		    ClassExpression: ClassDeclaration,
		    ClassImplements: InterfaceExtends,
		    ClassMethod: ClassMethod,
		    ClassPrivateMethod: ClassPrivateMethod,
		    ClassPrivateProperty: ClassPrivateProperty,
		    ClassProperty: ClassProperty,
		    ConditionalExpression: ConditionalExpression$1,
		    ContinueStatement: ContinueStatement,
		    DebuggerStatement: DebuggerStatement,
		    DecimalLiteral: DecimalLiteral,
		    DeclareClass: DeclareClass,
		    DeclareExportAllDeclaration: DeclareExportAllDeclaration,
		    DeclareExportDeclaration: DeclareExportDeclaration,
		    DeclareFunction: DeclareFunction,
		    DeclareInterface: DeclareInterface,
		    DeclareModule: DeclareModule,
		    DeclareModuleExports: DeclareModuleExports,
		    DeclareOpaqueType: DeclareOpaqueType,
		    DeclareTypeAlias: DeclareTypeAlias,
		    DeclareVariable: DeclareVariable,
		    DeclaredPredicate: DeclaredPredicate,
		    Decorator: Decorator,
		    Directive: Directive,
		    DirectiveLiteral: DirectiveLiteral,
		    DoExpression: DoExpression,
		    DoWhileStatement: DoWhileStatement,
		    EmptyStatement: EmptyStatement,
		    EmptyTypeAnnotation: EmptyTypeAnnotation,
		    EnumBooleanBody: EnumBooleanBody,
		    EnumBooleanMember: EnumBooleanMember,
		    EnumDeclaration: EnumDeclaration,
		    EnumDefaultedMember: EnumDefaultedMember,
		    EnumNumberBody: EnumNumberBody,
		    EnumNumberMember: EnumNumberMember,
		    EnumStringBody: EnumStringBody,
		    EnumStringMember: EnumStringMember,
		    EnumSymbolBody: EnumSymbolBody,
		    ExistsTypeAnnotation: ExistsTypeAnnotation,
		    ExportAllDeclaration: ExportAllDeclaration,
		    ExportDefaultDeclaration: ExportDefaultDeclaration,
		    ExportDefaultSpecifier: ExportDefaultSpecifier,
		    ExportNamedDeclaration: ExportNamedDeclaration,
		    ExportNamespaceSpecifier: ExportNamespaceSpecifier,
		    ExportSpecifier: ExportSpecifier,
		    ExpressionStatement: ExpressionStatement,
		    File: File$1,
		    ForInStatement: ForInStatement,
		    ForOfStatement: ForOfStatement,
		    ForStatement: ForStatement,
		    FunctionDeclaration: FunctionExpression,
		    FunctionExpression: FunctionExpression,
		    FunctionTypeAnnotation: FunctionTypeAnnotation,
		    FunctionTypeParam: FunctionTypeParam,
		    GenericTypeAnnotation: InterfaceExtends,
		    Identifier: Identifier,
		    IfStatement: IfStatement,
		    Import: Import,
		    ImportAttribute: ImportAttribute,
		    ImportDeclaration: ImportDeclaration,
		    ImportDefaultSpecifier: ImportDefaultSpecifier,
		    ImportExpression: ImportExpression,
		    ImportNamespaceSpecifier: ImportNamespaceSpecifier,
		    ImportSpecifier: ImportSpecifier,
		    IndexedAccessType: IndexedAccessType,
		    InferredPredicate: InferredPredicate,
		    InterfaceDeclaration: InterfaceDeclaration,
		    InterfaceExtends: InterfaceExtends,
		    InterfaceTypeAnnotation: InterfaceTypeAnnotation,
		    InterpreterDirective: InterpreterDirective,
		    IntersectionTypeAnnotation: IntersectionTypeAnnotation,
		    JSXAttribute: JSXAttribute,
		    JSXClosingElement: JSXClosingElement,
		    JSXClosingFragment: JSXClosingFragment,
		    JSXElement: JSXElement,
		    JSXEmptyExpression: JSXEmptyExpression,
		    JSXExpressionContainer: JSXExpressionContainer,
		    JSXFragment: JSXFragment,
		    JSXIdentifier: JSXIdentifier,
		    JSXMemberExpression: JSXMemberExpression,
		    JSXNamespacedName: JSXNamespacedName,
		    JSXOpeningElement: JSXOpeningElement,
		    JSXOpeningFragment: JSXOpeningFragment,
		    JSXSpreadAttribute: JSXSpreadAttribute,
		    JSXSpreadChild: JSXSpreadChild,
		    JSXText: JSXText,
		    LabeledStatement: LabeledStatement,
		    LogicalExpression: AssignmentExpression$1,
		    MemberExpression: MemberExpression,
		    MetaProperty: MetaProperty,
		    MixedTypeAnnotation: MixedTypeAnnotation,
		    ModuleExpression: ModuleExpression,
		    NewExpression: NewExpression$1,
		    NullLiteral: NullLiteral$1,
		    NullLiteralTypeAnnotation: NullLiteralTypeAnnotation,
		    NullableTypeAnnotation: NullableTypeAnnotation,
		    NumberLiteralTypeAnnotation: NumericLiteral$1,
		    NumberTypeAnnotation: NumberTypeAnnotation,
		    NumericLiteral: NumericLiteral$1,
		    ObjectExpression: ObjectExpression$1,
		    ObjectMethod: ObjectMethod,
		    ObjectPattern: ObjectExpression$1,
		    ObjectProperty: ObjectProperty,
		    ObjectTypeAnnotation: ObjectTypeAnnotation,
		    ObjectTypeCallProperty: ObjectTypeCallProperty,
		    ObjectTypeIndexer: ObjectTypeIndexer,
		    ObjectTypeInternalSlot: ObjectTypeInternalSlot,
		    ObjectTypeProperty: ObjectTypeProperty,
		    ObjectTypeSpreadProperty: ObjectTypeSpreadProperty,
		    OpaqueType: OpaqueType,
		    OptionalCallExpression: OptionalCallExpression,
		    OptionalIndexedAccessType: OptionalIndexedAccessType,
		    OptionalMemberExpression: OptionalMemberExpression,
		    ParenthesizedExpression: ParenthesizedExpression$1,
		    PipelineBareFunction: PipelineBareFunction,
		    PipelinePrimaryTopicReference: PipelinePrimaryTopicReference,
		    PipelineTopicExpression: PipelineTopicExpression,
		    Placeholder: Placeholder,
		    PrivateName: PrivateName,
		    Program: Program,
		    QualifiedTypeIdentifier: QualifiedTypeIdentifier,
		    RecordExpression: RecordExpression,
		    RegExpLiteral: RegExpLiteral$1,
		    RestElement: RestElement$1,
		    ReturnStatement: ReturnStatement,
		    SequenceExpression: SequenceExpression$1,
		    SpreadElement: RestElement$1,
		    StaticBlock: StaticBlock,
		    StringLiteral: StringLiteral$1,
		    StringLiteralTypeAnnotation: StringLiteral$1,
		    StringTypeAnnotation: StringTypeAnnotation,
		    Super: Super,
		    SwitchCase: SwitchCase,
		    SwitchStatement: SwitchStatement,
		    SymbolTypeAnnotation: SymbolTypeAnnotation,
		    TSAnyKeyword: TSAnyKeyword,
		    TSArrayType: TSArrayType,
		    TSAsExpression: TSTypeExpression,
		    TSBigIntKeyword: TSBigIntKeyword,
		    TSBooleanKeyword: TSBooleanKeyword,
		    TSCallSignatureDeclaration: TSCallSignatureDeclaration,
		    TSConditionalType: TSConditionalType,
		    TSConstructSignatureDeclaration: TSConstructSignatureDeclaration,
		    TSConstructorType: TSConstructorType,
		    TSDeclareFunction: TSDeclareFunction,
		    TSDeclareMethod: TSDeclareMethod,
		    TSEnumDeclaration: TSEnumDeclaration,
		    TSEnumMember: TSEnumMember,
		    TSExportAssignment: TSExportAssignment,
		    TSExpressionWithTypeArguments: TSExpressionWithTypeArguments,
		    TSExternalModuleReference: TSExternalModuleReference,
		    TSFunctionType: TSFunctionType,
		    TSImportEqualsDeclaration: TSImportEqualsDeclaration,
		    TSImportType: TSImportType,
		    TSIndexSignature: TSIndexSignature,
		    TSIndexedAccessType: TSIndexedAccessType,
		    TSInferType: TSInferType,
		    TSInstantiationExpression: TSInstantiationExpression,
		    TSInterfaceBody: TSInterfaceBody,
		    TSInterfaceDeclaration: TSInterfaceDeclaration,
		    TSIntersectionType: TSIntersectionType,
		    TSIntrinsicKeyword: TSIntrinsicKeyword,
		    TSLiteralType: TSLiteralType,
		    TSMappedType: TSMappedType,
		    TSMethodSignature: TSMethodSignature,
		    TSModuleBlock: TSModuleBlock,
		    TSModuleDeclaration: TSModuleDeclaration,
		    TSNamedTupleMember: TSNamedTupleMember,
		    TSNamespaceExportDeclaration: TSNamespaceExportDeclaration,
		    TSNeverKeyword: TSNeverKeyword,
		    TSNonNullExpression: TSNonNullExpression$1,
		    TSNullKeyword: TSNullKeyword,
		    TSNumberKeyword: TSNumberKeyword,
		    TSObjectKeyword: TSObjectKeyword,
		    TSOptionalType: TSOptionalType,
		    TSParameterProperty: TSParameterProperty,
		    TSParenthesizedType: TSParenthesizedType,
		    TSPropertySignature: TSPropertySignature,
		    TSQualifiedName: TSQualifiedName,
		    TSRestType: TSRestType,
		    TSSatisfiesExpression: TSTypeExpression,
		    TSStringKeyword: TSStringKeyword,
		    TSSymbolKeyword: TSSymbolKeyword,
		    TSThisType: TSThisType,
		    TSTupleType: TSTupleType,
		    TSTypeAliasDeclaration: TSTypeAliasDeclaration,
		    TSTypeAnnotation: TSTypeAnnotation,
		    TSTypeAssertion: TSTypeAssertion,
		    TSTypeLiteral: TSTypeLiteral,
		    TSTypeOperator: TSTypeOperator,
		    TSTypeParameter: TSTypeParameter,
		    TSTypeParameterDeclaration: TSTypeParameterInstantiation,
		    TSTypeParameterInstantiation: TSTypeParameterInstantiation,
		    TSTypePredicate: TSTypePredicate,
		    TSTypeQuery: TSTypeQuery,
		    TSTypeReference: TSTypeReference,
		    TSUndefinedKeyword: TSUndefinedKeyword,
		    TSUnionType: TSUnionType,
		    TSUnknownKeyword: TSUnknownKeyword,
		    TSVoidKeyword: TSVoidKeyword,
		    TaggedTemplateExpression: TaggedTemplateExpression$1,
		    TemplateElement: TemplateElement,
		    TemplateLiteral: TemplateLiteral$1,
		    ThisExpression: ThisExpression,
		    ThisTypeAnnotation: ThisTypeAnnotation,
		    ThrowStatement: ThrowStatement,
		    TopicReference: TopicReference,
		    TryStatement: TryStatement,
		    TupleExpression: TupleExpression,
		    TupleTypeAnnotation: TupleTypeAnnotation,
		    TypeAlias: TypeAlias,
		    TypeAnnotation: TypeAnnotation,
		    TypeCastExpression: TypeCastExpression$1,
		    TypeParameter: TypeParameter,
		    TypeParameterDeclaration: TypeParameterInstantiation,
		    TypeParameterInstantiation: TypeParameterInstantiation,
		    TypeofTypeAnnotation: TypeofTypeAnnotation,
		    UnaryExpression: UnaryExpression$1,
		    UnionTypeAnnotation: UnionTypeAnnotation,
		    UpdateExpression: UpdateExpression$1,
		    V8IntrinsicIdentifier: V8IntrinsicIdentifier,
		    VariableDeclaration: VariableDeclaration,
		    VariableDeclarator: VariableDeclarator$1,
		    Variance: Variance,
		    VoidTypeAnnotation: VoidTypeAnnotation,
		    WhileStatement: WhileStatement,
		    WithStatement: WithStatement,
		    YieldExpression: YieldExpression,
		    _classMethodHead: _classMethodHead,
		    _functionHead: _functionHead,
		    _interfaceish: _interfaceish,
		    _methodHead: _methodHead,
		    _param: _param,
		    _parameters: _parameters,
		    _params: _params,
		    _predicate: _predicate,
		    _printAttributes: _printAttributes,
		    _shouldPrintDecoratorsBeforeExport: _shouldPrintDecoratorsBeforeExport,
		    _variance: _variance,
		    tsPrintClassMemberModifiers: tsPrintClassMemberModifiers,
		    tsPrintFunctionOrConstructorType: tsPrintFunctionOrConstructorType,
		    tsPrintPropertyOrMethodName: tsPrintPropertyOrMethodName,
		    tsPrintSignatureDeclarationBase: tsPrintSignatureDeclarationBase,
		    tsPrintTypeLiteralOrInterfaceBody: tsPrintTypeLiteralOrInterfaceBody
		  });

		  var isFunction$3 = isFunction$5,
		    isStatement$3 = isStatement$8,
		    isClassBody = isClassBody$2,
		    isTSInterfaceBody = isTSInterfaceBody$1,
		    isTSEnumDeclaration = isTSEnumDeclaration$1;
		  var SCIENTIFIC_NOTATION = /e/i;
		  var ZERO_DECIMAL_INTEGER = /\.0+$/;
		  var HAS_NEWLINE = /[\n\r\u2028\u2029]/;
		  var HAS_NEWLINE_OR_BlOCK_COMMENT_END = /[\n\r\u2028\u2029]|\*\//;
		  var needsParens = needsParens$1;
		  var Printer = function () {
		    function Printer(format, map) {
		      this.inForStatementInitCounter = 0;
		      this._printStack = [];
		      this._indent = 0;
		      this._indentRepeat = 0;
		      this._insideAux = false;
		      this._parenPushNewlineState = null;
		      this._noLineTerminator = false;
		      this._printAuxAfterOnNextUserNode = false;
		      this._printedComments = new Set();
		      this._endsWithInteger = false;
		      this._endsWithWord = false;
		      this._lastCommentLine = 0;
		      this._endsWithInnerRaw = false;
		      this._indentInnerComments = true;
		      this.format = format;
		      this._indentRepeat = format.indent.style.length;
		      this._inputMap = map == null ? void 0 : map._inputMap;
		      this._buf = new Buffer(map, format.indent.style[0]);
		    }
		    var _proto = Printer.prototype;
		    _proto.generate = function generate(ast) {
		      this.print(ast);
		      this._maybeAddAuxComment();
		      return this._buf.get();
		    };
		    _proto.indent = function indent() {
		      if (this.format.compact || this.format.concise) return;
		      this._indent++;
		    };
		    _proto.dedent = function dedent() {
		      if (this.format.compact || this.format.concise) return;
		      this._indent--;
		    };
		    _proto.semicolon = function semicolon(force) {
		      if (force === void 0) {
		        force = false;
		      }
		      this._maybeAddAuxComment();
		      if (force) {
		        this._appendChar(59);
		      } else {
		        this._queue(59);
		      }
		      this._noLineTerminator = false;
		    };
		    _proto.rightBrace = function rightBrace(node) {
		      if (this.format.minified) {
		        this._buf.removeLastSemicolon();
		      }
		      this.sourceWithOffset("end", node.loc, -1);
		      this.tokenChar(125);
		    };
		    _proto.rightParens = function rightParens(node) {
		      this.sourceWithOffset("end", node.loc, -1);
		      this.tokenChar(41);
		    };
		    _proto.space = function space(force) {
		      if (force === void 0) {
		        force = false;
		      }
		      if (this.format.compact) return;
		      if (force) {
		        this._space();
		      } else if (this._buf.hasContent()) {
		        var lastCp = this.getLastChar();
		        if (lastCp !== 32 && lastCp !== 10) {
		          this._space();
		        }
		      }
		    };
		    _proto.word = function word(str, noLineTerminatorAfter) {
		      if (noLineTerminatorAfter === void 0) {
		        noLineTerminatorAfter = false;
		      }
		      this._maybePrintInnerComments();
		      if (this._endsWithWord || str.charCodeAt(0) === 47 && this.endsWith(47)) {
		        this._space();
		      }
		      this._maybeAddAuxComment();
		      this._append(str, false);
		      this._endsWithWord = true;
		      this._noLineTerminator = noLineTerminatorAfter;
		    };
		    _proto.number = function number(str, _number) {
		      function isNonDecimalLiteral(str) {
		        if (str.length > 2 && str.charCodeAt(0) === 48) {
		          var secondChar = str.charCodeAt(1);
		          return secondChar === 98 || secondChar === 111 || secondChar === 120;
		        }
		        return false;
		      }
		      this.word(str);
		      this._endsWithInteger = Number.isInteger(_number) && !isNonDecimalLiteral(str) && !SCIENTIFIC_NOTATION.test(str) && !ZERO_DECIMAL_INTEGER.test(str) && str.charCodeAt(str.length - 1) !== 46;
		    };
		    _proto.token = function token(str, maybeNewline) {
		      if (maybeNewline === void 0) {
		        maybeNewline = false;
		      }
		      this._maybePrintInnerComments();
		      var lastChar = this.getLastChar();
		      var strFirst = str.charCodeAt(0);
		      if (lastChar === 33 && (str === "--" || strFirst === 61) || strFirst === 43 && lastChar === 43 || strFirst === 45 && lastChar === 45 || strFirst === 46 && this._endsWithInteger) {
		        this._space();
		      }
		      this._maybeAddAuxComment();
		      this._append(str, maybeNewline);
		      this._noLineTerminator = false;
		    };
		    _proto.tokenChar = function tokenChar(_char) {
		      this._maybePrintInnerComments();
		      var lastChar = this.getLastChar();
		      if (_char === 43 && lastChar === 43 || _char === 45 && lastChar === 45 || _char === 46 && this._endsWithInteger) {
		        this._space();
		      }
		      this._maybeAddAuxComment();
		      this._appendChar(_char);
		      this._noLineTerminator = false;
		    };
		    _proto.newline = function newline(i, force) {
		      if (i === void 0) {
		        i = 1;
		      }
		      if (i <= 0) return;
		      if (!force) {
		        if (this.format.retainLines || this.format.compact) return;
		        if (this.format.concise) {
		          this.space();
		          return;
		        }
		      }
		      if (i > 2) i = 2;
		      i -= this._buf.getNewlineCount();
		      for (var j = 0; j < i; j++) {
		        this._newline();
		      }
		      return;
		    };
		    _proto.endsWith = function endsWith(_char2) {
		      return this.getLastChar() === _char2;
		    };
		    _proto.getLastChar = function getLastChar() {
		      return this._buf.getLastChar();
		    };
		    _proto.endsWithCharAndNewline = function endsWithCharAndNewline() {
		      return this._buf.endsWithCharAndNewline();
		    };
		    _proto.removeTrailingNewline = function removeTrailingNewline() {
		      this._buf.removeTrailingNewline();
		    };
		    _proto.exactSource = function exactSource(loc, cb) {
		      if (!loc) {
		        cb();
		        return;
		      }
		      this._catchUp("start", loc);
		      this._buf.exactSource(loc, cb);
		    };
		    _proto.source = function source(prop, loc) {
		      if (!loc) return;
		      this._catchUp(prop, loc);
		      this._buf.source(prop, loc);
		    };
		    _proto.sourceWithOffset = function sourceWithOffset(prop, loc, columnOffset) {
		      if (!loc) return;
		      this._catchUp(prop, loc);
		      this._buf.sourceWithOffset(prop, loc, columnOffset);
		    };
		    _proto.withSource = function withSource(prop, loc, cb) {
		      if (!loc) {
		        cb();
		        return;
		      }
		      this._catchUp(prop, loc);
		      this._buf.withSource(prop, loc, cb);
		    };
		    _proto.sourceIdentifierName = function sourceIdentifierName(identifierName, pos) {
		      if (!this._buf._canMarkIdName) return;
		      var sourcePosition = this._buf._sourcePosition;
		      sourcePosition.identifierNamePos = pos;
		      sourcePosition.identifierName = identifierName;
		    };
		    _proto._space = function _space() {
		      this._queue(32);
		    };
		    _proto._newline = function _newline() {
		      this._queue(10);
		    };
		    _proto._append = function _append(str, maybeNewline) {
		      this._maybeAddParen(str);
		      this._maybeIndent(str.charCodeAt(0));
		      this._buf.append(str, maybeNewline);
		      this._endsWithWord = false;
		      this._endsWithInteger = false;
		    };
		    _proto._appendChar = function _appendChar(_char3) {
		      this._maybeAddParenChar(_char3);
		      this._maybeIndent(_char3);
		      this._buf.appendChar(_char3);
		      this._endsWithWord = false;
		      this._endsWithInteger = false;
		    };
		    _proto._queue = function _queue(_char4) {
		      this._maybeAddParenChar(_char4);
		      this._maybeIndent(_char4);
		      this._buf.queue(_char4);
		      this._endsWithWord = false;
		      this._endsWithInteger = false;
		    };
		    _proto._maybeIndent = function _maybeIndent(firstChar) {
		      if (this._indent && firstChar !== 10 && this.endsWith(10)) {
		        this._buf.queueIndentation(this._getIndent());
		      }
		    };
		    _proto._shouldIndent = function _shouldIndent(firstChar) {
		      if (this._indent && firstChar !== 10 && this.endsWith(10)) {
		        return true;
		      }
		    };
		    _proto._maybeAddParenChar = function _maybeAddParenChar(_char5) {
		      var parenPushNewlineState = this._parenPushNewlineState;
		      if (!parenPushNewlineState) return;
		      if (_char5 === 32) {
		        return;
		      }
		      if (_char5 !== 10) {
		        this._parenPushNewlineState = null;
		        return;
		      }
		      this.tokenChar(40);
		      this.indent();
		      parenPushNewlineState.printed = true;
		    };
		    _proto._maybeAddParen = function _maybeAddParen(str) {
		      var parenPushNewlineState = this._parenPushNewlineState;
		      if (!parenPushNewlineState) return;
		      var len = str.length;
		      var i;
		      for (i = 0; i < len && str.charCodeAt(i) === 32; i++) continue;
		      if (i === len) {
		        return;
		      }
		      var cha = str.charCodeAt(i);
		      if (cha !== 10) {
		        if (cha !== 47 || i + 1 === len) {
		          this._parenPushNewlineState = null;
		          return;
		        }
		        var chaPost = str.charCodeAt(i + 1);
		        if (chaPost === 42) {
		          return;
		        } else if (chaPost !== 47) {
		          this._parenPushNewlineState = null;
		          return;
		        }
		      }
		      this.tokenChar(40);
		      this.indent();
		      parenPushNewlineState.printed = true;
		    };
		    _proto.catchUp = function catchUp(line) {
		      if (!this.format.retainLines) return;
		      var count = line - this._buf.getCurrentLine();
		      for (var i = 0; i < count; i++) {
		        this._newline();
		      }
		    };
		    _proto._catchUp = function _catchUp(prop, loc) {
		      var _loc$prop;
		      if (!this.format.retainLines) return;
		      var line = loc == null || (_loc$prop = loc[prop]) == null ? void 0 : _loc$prop.line;
		      if (line != null) {
		        var count = line - this._buf.getCurrentLine();
		        for (var i = 0; i < count; i++) {
		          this._newline();
		        }
		      }
		    };
		    _proto._getIndent = function _getIndent() {
		      return this._indentRepeat * this._indent;
		    };
		    _proto.printTerminatorless = function printTerminatorless(node, parent, isLabel) {
		      if (isLabel) {
		        this._noLineTerminator = true;
		        this.print(node, parent);
		      } else {
		        var terminatorState = {
		          printed: false
		        };
		        this._parenPushNewlineState = terminatorState;
		        this.print(node, parent);
		        if (terminatorState.printed) {
		          this.dedent();
		          this.newline();
		          this.tokenChar(41);
		        }
		      }
		    };
		    _proto.print = function print(node, parent, noLineTerminatorAfter, trailingCommentsLineOffset, forceParens) {
		      var _node$extra, _node$leadingComments;
		      if (!node) return;
		      this._endsWithInnerRaw = false;
		      var nodeType = node.type;
		      var format = this.format;
		      var oldConcise = format.concise;
		      if (node._compact) {
		        format.concise = true;
		      }
		      var printMethod = this[nodeType];
		      if (printMethod === undefined) {
		        throw new ReferenceError("unknown node of type " + JSON.stringify(nodeType) + " with constructor " + JSON.stringify(node.constructor.name));
		      }
		      this._printStack.push(node);
		      var oldInAux = this._insideAux;
		      this._insideAux = node.loc == null;
		      this._maybeAddAuxComment(this._insideAux && !oldInAux);
		      var parenthesized = (_node$extra = node.extra) == null ? void 0 : _node$extra.parenthesized;
		      var shouldPrintParens = forceParens || parenthesized && format.retainFunctionParens && nodeType === "FunctionExpression" || needsParens(node, parent, this._printStack);
		      if (!shouldPrintParens && parenthesized && (_node$leadingComments = node.leadingComments) != null && _node$leadingComments.length && node.leadingComments[0].type === "CommentBlock") {
		        var parentType = parent == null ? void 0 : parent.type;
		        switch (parentType) {
		          case "ExpressionStatement":
		          case "VariableDeclarator":
		          case "AssignmentExpression":
		          case "ReturnStatement":
		            break;
		          case "CallExpression":
		          case "OptionalCallExpression":
		          case "NewExpression":
		            if (parent.callee !== node) break;
		          default:
		            shouldPrintParens = true;
		        }
		      }
		      if (shouldPrintParens) {
		        this.tokenChar(40);
		        this._endsWithInnerRaw = false;
		      }
		      this._lastCommentLine = 0;
		      this._printLeadingComments(node, parent);
		      var loc = nodeType === "Program" || nodeType === "File" ? null : node.loc;
		      this.exactSource(loc, printMethod.bind(this, node, parent));
		      if (shouldPrintParens) {
		        this._printTrailingComments(node, parent);
		        this.tokenChar(41);
		        this._noLineTerminator = noLineTerminatorAfter;
		      } else if (noLineTerminatorAfter && !this._noLineTerminator) {
		        this._noLineTerminator = true;
		        this._printTrailingComments(node, parent);
		      } else {
		        this._printTrailingComments(node, parent, trailingCommentsLineOffset);
		      }
		      this._printStack.pop();
		      format.concise = oldConcise;
		      this._insideAux = oldInAux;
		      this._endsWithInnerRaw = false;
		    };
		    _proto._maybeAddAuxComment = function _maybeAddAuxComment(enteredPositionlessNode) {
		      if (enteredPositionlessNode) this._printAuxBeforeComment();
		      if (!this._insideAux) this._printAuxAfterComment();
		    };
		    _proto._printAuxBeforeComment = function _printAuxBeforeComment() {
		      if (this._printAuxAfterOnNextUserNode) return;
		      this._printAuxAfterOnNextUserNode = true;
		      var comment = this.format.auxiliaryCommentBefore;
		      if (comment) {
		        this._printComment({
		          type: "CommentBlock",
		          value: comment
		        }, 0);
		      }
		    };
		    _proto._printAuxAfterComment = function _printAuxAfterComment() {
		      if (!this._printAuxAfterOnNextUserNode) return;
		      this._printAuxAfterOnNextUserNode = false;
		      var comment = this.format.auxiliaryCommentAfter;
		      if (comment) {
		        this._printComment({
		          type: "CommentBlock",
		          value: comment
		        }, 0);
		      }
		    };
		    _proto.getPossibleRaw = function getPossibleRaw(node) {
		      var extra = node.extra;
		      if ((extra == null ? void 0 : extra.raw) != null && extra.rawValue != null && node.value === extra.rawValue) {
		        return extra.raw;
		      }
		    };
		    _proto.printJoin = function printJoin(nodes, parent, opts) {
		      if (opts === void 0) {
		        opts = {};
		      }
		      if (!(nodes != null && nodes.length)) return;
		      var _opts = opts,
		        indent = _opts.indent;
		      if (indent == null && this.format.retainLines) {
		        var _nodes$0$loc;
		        var startLine = (_nodes$0$loc = nodes[0].loc) == null ? void 0 : _nodes$0$loc.start.line;
		        if (startLine != null && startLine !== this._buf.getCurrentLine()) {
		          indent = true;
		        }
		      }
		      if (indent) this.indent();
		      var newlineOpts = {
		        addNewlines: opts.addNewlines,
		        nextNodeStartLine: 0
		      };
		      var separator = opts.separator ? opts.separator.bind(this) : null;
		      var len = nodes.length;
		      for (var i = 0; i < len; i++) {
		        var _node = nodes[i];
		        if (!_node) continue;
		        if (opts.statement) this._printNewline(i === 0, newlineOpts);
		        this.print(_node, parent, undefined, opts.trailingCommentsLineOffset || 0);
		        opts.iterator == null || opts.iterator(_node, i);
		        if (i < len - 1) separator == null || separator();
		        if (opts.statement) {
		          var _node$trailingComment;
		          if (!((_node$trailingComment = _node.trailingComments) != null && _node$trailingComment.length)) {
		            this._lastCommentLine = 0;
		          }
		          if (i + 1 === len) {
		            this.newline(1);
		          } else {
		            var _nextNode$loc;
		            var nextNode = nodes[i + 1];
		            newlineOpts.nextNodeStartLine = ((_nextNode$loc = nextNode.loc) == null ? void 0 : _nextNode$loc.start.line) || 0;
		            this._printNewline(true, newlineOpts);
		          }
		        }
		      }
		      if (indent) this.dedent();
		    };
		    _proto.printAndIndentOnComments = function printAndIndentOnComments(node, parent) {
		      var indent = node.leadingComments && node.leadingComments.length > 0;
		      if (indent) this.indent();
		      this.print(node, parent);
		      if (indent) this.dedent();
		    };
		    _proto.printBlock = function printBlock(parent) {
		      var node = parent.body;
		      if (node.type !== "EmptyStatement") {
		        this.space();
		      }
		      this.print(node, parent);
		    };
		    _proto._printTrailingComments = function _printTrailingComments(node, parent, lineOffset) {
		      var innerComments = node.innerComments,
		        trailingComments = node.trailingComments;
		      if (innerComments != null && innerComments.length) {
		        this._printComments(2, innerComments, node, parent, lineOffset);
		      }
		      if (trailingComments != null && trailingComments.length) {
		        this._printComments(2, trailingComments, node, parent, lineOffset);
		      }
		    };
		    _proto._printLeadingComments = function _printLeadingComments(node, parent) {
		      var comments = node.leadingComments;
		      if (!(comments != null && comments.length)) return;
		      this._printComments(0, comments, node, parent);
		    };
		    _proto._maybePrintInnerComments = function _maybePrintInnerComments() {
		      if (this._endsWithInnerRaw) this.printInnerComments();
		      this._endsWithInnerRaw = true;
		      this._indentInnerComments = true;
		    };
		    _proto.printInnerComments = function printInnerComments() {
		      var node = this._printStack[this._printStack.length - 1];
		      var comments = node.innerComments;
		      if (!(comments != null && comments.length)) return;
		      var hasSpace = this.endsWith(32);
		      var indent = this._indentInnerComments;
		      var printedCommentsCount = this._printedComments.size;
		      if (indent) this.indent();
		      this._printComments(1, comments, node);
		      if (hasSpace && printedCommentsCount !== this._printedComments.size) {
		        this.space();
		      }
		      if (indent) this.dedent();
		    };
		    _proto.noIndentInnerCommentsHere = function noIndentInnerCommentsHere() {
		      this._indentInnerComments = false;
		    };
		    _proto.printSequence = function printSequence(nodes, parent, opts) {
		      var _opts2, _opts2$indent;
		      if (opts === void 0) {
		        opts = {};
		      }
		      opts.statement = true;
		      (_opts2$indent = (_opts2 = opts).indent) != null ? _opts2$indent : _opts2.indent = false;
		      this.printJoin(nodes, parent, opts);
		    };
		    _proto.printList = function printList(items, parent, opts) {
		      if (opts === void 0) {
		        opts = {};
		      }
		      if (opts.separator == null) {
		        opts.separator = commaSeparator;
		      }
		      this.printJoin(items, parent, opts);
		    };
		    _proto._printNewline = function _printNewline(newLine, opts) {
		      var format = this.format;
		      if (format.retainLines || format.compact) return;
		      if (format.concise) {
		        this.space();
		        return;
		      }
		      if (!newLine) {
		        return;
		      }
		      var startLine = opts.nextNodeStartLine;
		      var lastCommentLine = this._lastCommentLine;
		      if (startLine > 0 && lastCommentLine > 0) {
		        var offset = startLine - lastCommentLine;
		        if (offset >= 0) {
		          this.newline(offset || 1);
		          return;
		        }
		      }
		      if (this._buf.hasContent()) {
		        this.newline(1);
		      }
		    };
		    _proto._shouldPrintComment = function _shouldPrintComment(comment) {
		      if (comment.ignore) return 0;
		      if (this._printedComments.has(comment)) return 0;
		      if (this._noLineTerminator && HAS_NEWLINE_OR_BlOCK_COMMENT_END.test(comment.value)) {
		        return 2;
		      }
		      this._printedComments.add(comment);
		      if (!this.format.shouldPrintComment(comment.value)) {
		        return 0;
		      }
		      return 1;
		    };
		    _proto._printComment = function _printComment(comment, skipNewLines) {
		      var noLineTerminator = this._noLineTerminator;
		      var isBlockComment = comment.type === "CommentBlock";
		      var printNewLines = isBlockComment && skipNewLines !== 1 && !this._noLineTerminator;
		      if (printNewLines && this._buf.hasContent() && skipNewLines !== 2) {
		        this.newline(1);
		      }
		      var lastCharCode = this.getLastChar();
		      if (lastCharCode !== 91 && lastCharCode !== 123) {
		        this.space();
		      }
		      var val;
		      if (isBlockComment) {
		        var _parenPushNewlineState = this._parenPushNewlineState;
		        if ((_parenPushNewlineState == null ? void 0 : _parenPushNewlineState.printed) === false && HAS_NEWLINE.test(comment.value)) {
		          this.tokenChar(40);
		          this.indent();
		          _parenPushNewlineState.printed = true;
		        }
		        val = "/*" + comment.value + "*/";
		        if (this.format.indent.adjustMultilineComment) {
		          var _comment$loc;
		          var offset = (_comment$loc = comment.loc) == null ? void 0 : _comment$loc.start.column;
		          if (offset) {
		            var newlineRegex = new RegExp("\\n\\s{1," + offset + "}", "g");
		            val = val.replace(newlineRegex, "\n");
		          }
		          if (this.format.concise) {
		            val = val.replace(/\n(?!$)/g, "\n");
		          } else {
		            var indentSize = this.format.retainLines ? 0 : this._buf.getCurrentColumn();
		            if (this._shouldIndent(47) || this.format.retainLines) {
		              indentSize += this._getIndent();
		            }
		            val = val.replace(/\n(?!$)/g, "\n" + " ".repeat(indentSize));
		          }
		        }
		      } else if (!noLineTerminator) {
		        val = "//" + comment.value;
		      } else {
		        val = "/*" + comment.value + "*/";
		      }
		      if (this.endsWith(47)) this._space();
		      this.source("start", comment.loc);
		      this._append(val, isBlockComment);
		      if (!isBlockComment && !noLineTerminator) {
		        this.newline(1, true);
		      }
		      if (printNewLines && skipNewLines !== 3) {
		        this.newline(1);
		      }
		    };
		    _proto._printComments = function _printComments(type, comments, node, parent, lineOffset) {
		      if (lineOffset === void 0) {
		        lineOffset = 0;
		      }
		      var nodeLoc = node.loc;
		      var len = comments.length;
		      var hasLoc = !!nodeLoc;
		      var nodeStartLine = hasLoc ? nodeLoc.start.line : 0;
		      var nodeEndLine = hasLoc ? nodeLoc.end.line : 0;
		      var lastLine = 0;
		      var leadingCommentNewline = 0;
		      var maybeNewline = this._noLineTerminator ? function () {} : this.newline.bind(this);
		      for (var i = 0; i < len; i++) {
		        var _comment = comments[i];
		        var shouldPrint = this._shouldPrintComment(_comment);
		        if (shouldPrint === 2) {
		          hasLoc = false;
		          break;
		        }
		        if (hasLoc && _comment.loc && shouldPrint === 1) {
		          var commentStartLine = _comment.loc.start.line;
		          var commentEndLine = _comment.loc.end.line;
		          if (type === 0) {
		            var offset = 0;
		            if (i === 0) {
		              if (this._buf.hasContent() && (_comment.type === "CommentLine" || commentStartLine !== commentEndLine)) {
		                offset = leadingCommentNewline = 1;
		              }
		            } else {
		              offset = commentStartLine - lastLine;
		            }
		            lastLine = commentEndLine;
		            maybeNewline(offset);
		            this._printComment(_comment, 1);
		            if (i + 1 === len) {
		              maybeNewline(Math.max(nodeStartLine - lastLine, leadingCommentNewline));
		              lastLine = nodeStartLine;
		            }
		          } else if (type === 1) {
		            var _offset = commentStartLine - (i === 0 ? nodeStartLine : lastLine);
		            lastLine = commentEndLine;
		            maybeNewline(_offset);
		            this._printComment(_comment, 1);
		            if (i + 1 === len) {
		              maybeNewline(Math.min(1, nodeEndLine - lastLine));
		              lastLine = nodeEndLine;
		            }
		          } else {
		            var _offset2 = commentStartLine - (i === 0 ? nodeEndLine - lineOffset : lastLine);
		            lastLine = commentEndLine;
		            maybeNewline(_offset2);
		            this._printComment(_comment, 1);
		          }
		        } else {
		          hasLoc = false;
		          if (shouldPrint !== 1) {
		            continue;
		          }
		          if (len === 1) {
		            var singleLine = _comment.loc ? _comment.loc.start.line === _comment.loc.end.line : !HAS_NEWLINE.test(_comment.value);
		            var shouldSkipNewline = singleLine && !isStatement$3(node) && !isClassBody(parent) && !isTSInterfaceBody(parent) && !isTSEnumDeclaration(parent);
		            if (type === 0) {
		              this._printComment(_comment, shouldSkipNewline && node.type !== "ObjectExpression" || singleLine && isFunction$3(parent, {
		                body: node
		              }) ? 1 : 0);
		            } else if (shouldSkipNewline && type === 2) {
		              this._printComment(_comment, 1);
		            } else {
		              this._printComment(_comment, 0);
		            }
		          } else if (type === 1 && !(node.type === "ObjectExpression" && node.properties.length > 1) && node.type !== "ClassBody" && node.type !== "TSInterfaceBody") {
		            this._printComment(_comment, i === 0 ? 2 : i === len - 1 ? 3 : 0);
		          } else {
		            this._printComment(_comment, 0);
		          }
		        }
		      }
		      if (type === 2 && hasLoc && lastLine) {
		        this._lastCommentLine = lastLine;
		      }
		    };
		    return _createClass(Printer);
		  }();
		  Object.assign(Printer.prototype, generatorFunctions);
		  {
		    Printer.prototype.Noop = function Noop() {};
		  }
		  function commaSeparator() {
		    this.tokenChar(44);
		    this.space();
		  }

		  function normalizeOptions$8(code, opts) {
		    var _opts$recordAndTupleS;
		    var format = {
		      auxiliaryCommentBefore: opts.auxiliaryCommentBefore,
		      auxiliaryCommentAfter: opts.auxiliaryCommentAfter,
		      shouldPrintComment: opts.shouldPrintComment,
		      retainLines: opts.retainLines,
		      retainFunctionParens: opts.retainFunctionParens,
		      comments: opts.comments == null || opts.comments,
		      compact: opts.compact,
		      minified: opts.minified,
		      concise: opts.concise,
		      indent: {
		        adjustMultilineComment: true,
		        style: "  "
		      },
		      jsescOption: Object.assign({
		        quotes: "double",
		        wrap: true,
		        minimal: false
		      }, opts.jsescOption),
		      recordAndTupleSyntaxType: (_opts$recordAndTupleS = opts.recordAndTupleSyntaxType) != null ? _opts$recordAndTupleS : "hash",
		      topicToken: opts.topicToken,
		      importAttributesKeyword: opts.importAttributesKeyword
		    };
		    {
		      format.decoratorsBeforeExport = opts.decoratorsBeforeExport;
		      format.jsescOption.json = opts.jsonCompatibleStrings;
		    }
		    if (format.minified) {
		      format.compact = true;
		      format.shouldPrintComment = format.shouldPrintComment || function () {
		        return format.comments;
		      };
		    } else {
		      format.shouldPrintComment = format.shouldPrintComment || function (value) {
		        return format.comments || value.includes("@license") || value.includes("@preserve");
		      };
		    }
		    if (format.compact === "auto") {
		      format.compact = typeof code === "string" && code.length > 500000;
		      if (format.compact) {
		        console.error("[BABEL] Note: The code generator has deoptimised the styling of " + (opts.filename + " as it exceeds the max of " + "500KB" + "."));
		      }
		    }
		    if (format.compact) {
		      format.indent.adjustMultilineComment = false;
		    }
		    var auxiliaryCommentBefore = format.auxiliaryCommentBefore,
		      auxiliaryCommentAfter = format.auxiliaryCommentAfter,
		      shouldPrintComment = format.shouldPrintComment;
		    if (auxiliaryCommentBefore && !shouldPrintComment(auxiliaryCommentBefore)) {
		      format.auxiliaryCommentBefore = undefined;
		    }
		    if (auxiliaryCommentAfter && !shouldPrintComment(auxiliaryCommentAfter)) {
		      format.auxiliaryCommentAfter = undefined;
		    }
		    return format;
		  }
		  {
		    exports.CodeGenerator = function () {
		      function CodeGenerator(ast, opts, code) {
		        if (opts === void 0) {
		          opts = {};
		        }
		        this._ast = void 0;
		        this._format = void 0;
		        this._map = void 0;
		        this._ast = ast;
		        this._format = normalizeOptions$8(code, opts);
		        this._map = opts.sourceMaps ? new SourceMap$1(opts, code) : null;
		      }
		      var _proto = CodeGenerator.prototype;
		      _proto.generate = function generate() {
		        var printer = new Printer(this._format, this._map);
		        return printer.generate(this._ast);
		      };
		      return _createClass(CodeGenerator);
		    }();
		  }
		  function generate$1(ast, opts, code) {
		    if (opts === void 0) {
		      opts = {};
		    }
		    var format = normalizeOptions$8(code, opts);
		    var map = opts.sourceMaps ? new SourceMap$1(opts, code) : null;
		    var printer = new Printer(format, map);
		    return printer.generate(ast);
		  }

		  var index$4 = /*#__PURE__*/Object.freeze({
		    __proto__: null,
		    default: generate$1
		  });

		  var VISITOR_KEYS$4 = VISITOR_KEYS$5;
		  function findParent(callback) {
		    var path = this;
		    while (path = path.parentPath) {
		      if (callback(path)) return path;
		    }
		    return null;
		  }
		  function find$1(callback) {
		    var path = this;
		    do {
		      if (callback(path)) return path;
		    } while (path = path.parentPath);
		    return null;
		  }
		  function getFunctionParent() {
		    return this.findParent(function (p) {
		      return p.isFunction();
		    });
		  }
		  function getStatementParent() {
		    var path = this;
		    do {
		      if (!path.parentPath || Array.isArray(path.container) && path.isStatement()) {
		        break;
		      } else {
		        path = path.parentPath;
		      }
		    } while (path);
		    if (path && (path.isProgram() || path.isFile())) {
		      throw new Error("File/Program node, we can't possibly find a statement parent to this");
		    }
		    return path;
		  }
		  function getEarliestCommonAncestorFrom(paths) {
		    return this.getDeepestCommonAncestorFrom(paths, function (deepest, i, ancestries) {
		      var earliest;
		      var keys = VISITOR_KEYS$4[deepest.type];
		      for (var _iterator = _createForOfIteratorHelperLoose(ancestries), _step; !(_step = _iterator()).done;) {
		        var ancestry = _step.value;
		        var path = ancestry[i + 1];
		        if (!earliest) {
		          earliest = path;
		          continue;
		        }
		        if (path.listKey && earliest.listKey === path.listKey) {
		          if (path.key < earliest.key) {
		            earliest = path;
		            continue;
		          }
		        }
		        var earliestKeyIndex = keys.indexOf(earliest.parentKey);
		        var currentKeyIndex = keys.indexOf(path.parentKey);
		        if (earliestKeyIndex > currentKeyIndex) {
		          earliest = path;
		        }
		      }
		      return earliest;
		    });
		  }
		  function getDeepestCommonAncestorFrom(paths, filter) {
		    var _this = this;
		    if (!paths.length) {
		      return this;
		    }
		    if (paths.length === 1) {
		      return paths[0];
		    }
		    var minDepth = Infinity;
		    var lastCommonIndex, lastCommon;
		    var ancestries = paths.map(function (path) {
		      var ancestry = [];
		      do {
		        ancestry.unshift(path);
		      } while ((path = path.parentPath) && path !== _this);
		      if (ancestry.length < minDepth) {
		        minDepth = ancestry.length;
		      }
		      return ancestry;
		    });
		    var first = ancestries[0];
		    depthLoop: for (var _i = 0; _i < minDepth; _i++) {
		      var shouldMatch = first[_i];
		      for (var _iterator2 = _createForOfIteratorHelperLoose(ancestries), _step2; !(_step2 = _iterator2()).done;) {
		        var ancestry = _step2.value;
		        if (ancestry[_i] !== shouldMatch) {
		          break depthLoop;
		        }
		      }
		      lastCommonIndex = _i;
		      lastCommon = shouldMatch;
		    }
		    if (lastCommon) {
		      if (filter) {
		        return filter(lastCommon, lastCommonIndex, ancestries);
		      } else {
		        return lastCommon;
		      }
		    } else {
		      throw new Error("Couldn't find intersection");
		    }
		  }
		  function getAncestry() {
		    var path = this;
		    var paths = [];
		    do {
		      paths.push(path);
		    } while (path = path.parentPath);
		    return paths;
		  }
		  function isAncestor(maybeDescendant) {
		    return maybeDescendant.isDescendant(this);
		  }
		  function isDescendant(maybeAncestor) {
		    return !!this.findParent(function (parent) {
		      return parent === maybeAncestor;
		    });
		  }
		  function inType() {
		    var path = this;
		    for (var _len = arguments.length, candidateTypes = new Array(_len), _key = 0; _key < _len; _key++) {
		      candidateTypes[_key] = arguments[_key];
		    }
		    while (path) {
		      for (var _iterator3 = _createForOfIteratorHelperLoose(candidateTypes), _step3; !(_step3 = _iterator3()).done;) {
		        var type = _step3.value;
		        if (path.node.type === type) return true;
		      }
		      path = path.parentPath;
		    }
		    return false;
		  }

		  var NodePath_ancestry = /*#__PURE__*/Object.freeze({
		    __proto__: null,
		    find: find$1,
		    findParent: findParent,
		    getAncestry: getAncestry,
		    getDeepestCommonAncestorFrom: getDeepestCommonAncestorFrom,
		    getEarliestCommonAncestorFrom: getEarliestCommonAncestorFrom,
		    getFunctionParent: getFunctionParent,
		    getStatementParent: getStatementParent,
		    inType: inType,
		    isAncestor: isAncestor,
		    isDescendant: isDescendant
		  });

		  var createFlowUnionType = createFlowUnionType$1,
		    createTSUnionType = createTSUnionType$1,
		    createUnionTypeAnnotation = createFlowUnionType$1,
		    isFlowType = isFlowType$1,
		    isTSType = isTSType$1;
		  function createUnionType(types) {
		    {
		      if (types.every(function (v) {
		        return isFlowType(v);
		      })) {
		        if (createFlowUnionType) {
		          return createFlowUnionType(types);
		        }
		        return createUnionTypeAnnotation(types);
		      } else if (types.every(function (v) {
		        return isTSType(v);
		      })) {
		        if (createTSUnionType) {
		          return createTSUnionType(types);
		        }
		      }
		    }
		  }

		  var BOOLEAN_NUMBER_BINARY_OPERATORS = BOOLEAN_NUMBER_BINARY_OPERATORS$1,
		    createTypeAnnotationBasedOnTypeof = createTypeAnnotationBasedOnTypeof$1,
		    numberTypeAnnotation$1 = numberTypeAnnotation$2,
		    voidTypeAnnotation$2 = voidTypeAnnotation$3;
		  function infererReference (node) {
		    if (!this.isReferenced()) return;
		    var binding = this.scope.getBinding(node.name);
		    if (binding) {
		      if (binding.identifier.typeAnnotation) {
		        return binding.identifier.typeAnnotation;
		      } else {
		        return getTypeAnnotationBindingConstantViolations(binding, this, node.name);
		      }
		    }
		    if (node.name === "undefined") {
		      return voidTypeAnnotation$2();
		    } else if (node.name === "NaN" || node.name === "Infinity") {
		      return numberTypeAnnotation$1();
		    } else if (node.name === "arguments") ;
		  }
		  function getTypeAnnotationBindingConstantViolations(binding, path, name) {
		    var types = [];
		    var functionConstantViolations = [];
		    var constantViolations = getConstantViolationsBefore(binding, path, functionConstantViolations);
		    var testType = getConditionalAnnotation(binding, path, name);
		    if (testType) {
		      var testConstantViolations = getConstantViolationsBefore(binding, testType.ifStatement);
		      constantViolations = constantViolations.filter(function (path) {
		        return testConstantViolations.indexOf(path) < 0;
		      });
		      types.push(testType.typeAnnotation);
		    }
		    if (constantViolations.length) {
		      var _constantViolations;
		      (_constantViolations = constantViolations).push.apply(_constantViolations, functionConstantViolations);
		      for (var _iterator = _createForOfIteratorHelperLoose(constantViolations), _step; !(_step = _iterator()).done;) {
		        var violation = _step.value;
		        types.push(violation.getTypeAnnotation());
		      }
		    }
		    if (!types.length) {
		      return;
		    }
		    return createUnionType(types);
		  }
		  function getConstantViolationsBefore(binding, path, functions) {
		    var violations = binding.constantViolations.slice();
		    violations.unshift(binding.path);
		    return violations.filter(function (violation) {
		      violation = violation.resolve();
		      var status = violation._guessExecutionStatusRelativeTo(path);
		      if (functions && status === "unknown") functions.push(violation);
		      return status === "before";
		    });
		  }
		  function inferAnnotationFromBinaryExpression(name, path) {
		    var operator = path.node.operator;
		    var right = path.get("right").resolve();
		    var left = path.get("left").resolve();
		    var target;
		    if (left.isIdentifier({
		      name: name
		    })) {
		      target = right;
		    } else if (right.isIdentifier({
		      name: name
		    })) {
		      target = left;
		    }
		    if (target) {
		      if (operator === "===") {
		        return target.getTypeAnnotation();
		      }
		      if (BOOLEAN_NUMBER_BINARY_OPERATORS.indexOf(operator) >= 0) {
		        return numberTypeAnnotation$1();
		      }
		      return;
		    }
		    if (operator !== "===" && operator !== "==") return;
		    var typeofPath;
		    var typePath;
		    if (left.isUnaryExpression({
		      operator: "typeof"
		    })) {
		      typeofPath = left;
		      typePath = right;
		    } else if (right.isUnaryExpression({
		      operator: "typeof"
		    })) {
		      typeofPath = right;
		      typePath = left;
		    }
		    if (!typeofPath) return;
		    if (!typeofPath.get("argument").isIdentifier({
		      name: name
		    })) return;
		    typePath = typePath.resolve();
		    if (!typePath.isLiteral()) return;
		    var typeValue = typePath.node.value;
		    if (typeof typeValue !== "string") return;
		    return createTypeAnnotationBasedOnTypeof(typeValue);
		  }
		  function getParentConditionalPath(binding, path, name) {
		    var parentPath;
		    while (parentPath = path.parentPath) {
		      if (parentPath.isIfStatement() || parentPath.isConditionalExpression()) {
		        if (path.key === "test") {
		          return;
		        }
		        return parentPath;
		      }
		      if (parentPath.isFunction()) {
		        if (parentPath.parentPath.scope.getBinding(name) !== binding) return;
		      }
		      path = parentPath;
		    }
		  }
		  function getConditionalAnnotation(binding, path, name) {
		    var ifStatement = getParentConditionalPath(binding, path, name);
		    if (!ifStatement) return;
		    var test = ifStatement.get("test");
		    var paths = [test];
		    var types = [];
		    for (var i = 0; i < paths.length; i++) {
		      var _path = paths[i];
		      if (_path.isLogicalExpression()) {
		        if (_path.node.operator === "&&") {
		          paths.push(_path.get("left"));
		          paths.push(_path.get("right"));
		        }
		      } else if (_path.isBinaryExpression()) {
		        var type = inferAnnotationFromBinaryExpression(name, _path);
		        if (type) types.push(type);
		      }
		    }
		    if (types.length) {
		      return {
		        typeAnnotation: createUnionType(types),
		        ifStatement: ifStatement
		      };
		    }
		    return getConditionalAnnotation(binding, ifStatement, name);
		  }

		  var BOOLEAN_BINARY_OPERATORS = BOOLEAN_BINARY_OPERATORS$1,
		    BOOLEAN_UNARY_OPERATORS = BOOLEAN_UNARY_OPERATORS$1,
		    NUMBER_BINARY_OPERATORS = NUMBER_BINARY_OPERATORS$1,
		    NUMBER_UNARY_OPERATORS = NUMBER_UNARY_OPERATORS$1,
		    STRING_UNARY_OPERATORS = STRING_UNARY_OPERATORS$1,
		    anyTypeAnnotation$1 = anyTypeAnnotation$2,
		    arrayTypeAnnotation = arrayTypeAnnotation$1,
		    booleanTypeAnnotation = booleanTypeAnnotation$1,
		    buildMatchMemberExpression = buildMatchMemberExpression$1,
		    genericTypeAnnotation = genericTypeAnnotation$1,
		    identifier$g = identifier$j,
		    nullLiteralTypeAnnotation = nullLiteralTypeAnnotation$1,
		    numberTypeAnnotation = numberTypeAnnotation$2,
		    stringTypeAnnotation$1 = stringTypeAnnotation$2,
		    tupleTypeAnnotation = tupleTypeAnnotation$1,
		    unionTypeAnnotation = unionTypeAnnotation$1,
		    voidTypeAnnotation$1 = voidTypeAnnotation$3,
		    isIdentifier$c = isIdentifier$i;
		  function VariableDeclarator() {
		    if (!this.get("id").isIdentifier()) return;
		    return this.get("init").getTypeAnnotation();
		  }
		  function TypeCastExpression(node) {
		    return node.typeAnnotation;
		  }
		  TypeCastExpression.validParent = true;
		  function TSAsExpression(node) {
		    return node.typeAnnotation;
		  }
		  TSAsExpression.validParent = true;
		  function TSNonNullExpression() {
		    return this.get("expression").getTypeAnnotation();
		  }
		  function NewExpression(node) {
		    if (node.callee.type === "Identifier") {
		      return genericTypeAnnotation(node.callee);
		    }
		  }
		  function TemplateLiteral() {
		    return stringTypeAnnotation$1();
		  }
		  function UnaryExpression(node) {
		    var operator = node.operator;
		    if (operator === "void") {
		      return voidTypeAnnotation$1();
		    } else if (NUMBER_UNARY_OPERATORS.indexOf(operator) >= 0) {
		      return numberTypeAnnotation();
		    } else if (STRING_UNARY_OPERATORS.indexOf(operator) >= 0) {
		      return stringTypeAnnotation$1();
		    } else if (BOOLEAN_UNARY_OPERATORS.indexOf(operator) >= 0) {
		      return booleanTypeAnnotation();
		    }
		  }
		  function BinaryExpression(node) {
		    var operator = node.operator;
		    if (NUMBER_BINARY_OPERATORS.indexOf(operator) >= 0) {
		      return numberTypeAnnotation();
		    } else if (BOOLEAN_BINARY_OPERATORS.indexOf(operator) >= 0) {
		      return booleanTypeAnnotation();
		    } else if (operator === "+") {
		      var right = this.get("right");
		      var left = this.get("left");
		      if (left.isBaseType("number") && right.isBaseType("number")) {
		        return numberTypeAnnotation();
		      } else if (left.isBaseType("string") || right.isBaseType("string")) {
		        return stringTypeAnnotation$1();
		      }
		      return unionTypeAnnotation([stringTypeAnnotation$1(), numberTypeAnnotation()]);
		    }
		  }
		  function LogicalExpression() {
		    var argumentTypes = [this.get("left").getTypeAnnotation(), this.get("right").getTypeAnnotation()];
		    return createUnionType(argumentTypes);
		  }
		  function ConditionalExpression() {
		    var argumentTypes = [this.get("consequent").getTypeAnnotation(), this.get("alternate").getTypeAnnotation()];
		    return createUnionType(argumentTypes);
		  }
		  function SequenceExpression() {
		    return this.get("expressions").pop().getTypeAnnotation();
		  }
		  function ParenthesizedExpression() {
		    return this.get("expression").getTypeAnnotation();
		  }
		  function AssignmentExpression() {
		    return this.get("right").getTypeAnnotation();
		  }
		  function UpdateExpression(node) {
		    var operator = node.operator;
		    if (operator === "++" || operator === "--") {
		      return numberTypeAnnotation();
		    }
		  }
		  function StringLiteral() {
		    return stringTypeAnnotation$1();
		  }
		  function NumericLiteral() {
		    return numberTypeAnnotation();
		  }
		  function BooleanLiteral() {
		    return booleanTypeAnnotation();
		  }
		  function NullLiteral() {
		    return nullLiteralTypeAnnotation();
		  }
		  function RegExpLiteral() {
		    return genericTypeAnnotation(identifier$g("RegExp"));
		  }
		  function ObjectExpression() {
		    return genericTypeAnnotation(identifier$g("Object"));
		  }
		  function ArrayExpression() {
		    return genericTypeAnnotation(identifier$g("Array"));
		  }
		  function RestElement() {
		    return ArrayExpression();
		  }
		  RestElement.validParent = true;
		  function Func() {
		    return genericTypeAnnotation(identifier$g("Function"));
		  }
		  var isArrayFrom = buildMatchMemberExpression("Array.from");
		  var isObjectKeys = buildMatchMemberExpression("Object.keys");
		  var isObjectValues = buildMatchMemberExpression("Object.values");
		  var isObjectEntries = buildMatchMemberExpression("Object.entries");
		  function CallExpression() {
		    var callee = this.node.callee;
		    if (isObjectKeys(callee)) {
		      return arrayTypeAnnotation(stringTypeAnnotation$1());
		    } else if (isArrayFrom(callee) || isObjectValues(callee) || isIdentifier$c(callee, {
		      name: "Array"
		    })) {
		      return arrayTypeAnnotation(anyTypeAnnotation$1());
		    } else if (isObjectEntries(callee)) {
		      return arrayTypeAnnotation(tupleTypeAnnotation([stringTypeAnnotation$1(), anyTypeAnnotation$1()]));
		    }
		    return resolveCall(this.get("callee"));
		  }
		  function TaggedTemplateExpression() {
		    return resolveCall(this.get("tag"));
		  }
		  function resolveCall(callee) {
		    callee = callee.resolve();
		    if (callee.isFunction()) {
		      var _callee = callee,
		        node = _callee.node;
		      if (node.async) {
		        if (node.generator) {
		          return genericTypeAnnotation(identifier$g("AsyncIterator"));
		        } else {
		          return genericTypeAnnotation(identifier$g("Promise"));
		        }
		      } else {
		        if (node.generator) {
		          return genericTypeAnnotation(identifier$g("Iterator"));
		        } else if (callee.node.returnType) {
		          return callee.node.returnType;
		        } else ;
		      }
		    }
		  }

		  var inferers = /*#__PURE__*/Object.freeze({
		    __proto__: null,
		    ArrayExpression: ArrayExpression,
		    ArrowFunctionExpression: Func,
		    AssignmentExpression: AssignmentExpression,
		    BinaryExpression: BinaryExpression,
		    BooleanLiteral: BooleanLiteral,
		    CallExpression: CallExpression,
		    ClassDeclaration: Func,
		    ClassExpression: Func,
		    ConditionalExpression: ConditionalExpression,
		    FunctionDeclaration: Func,
		    FunctionExpression: Func,
		    Identifier: infererReference,
		    LogicalExpression: LogicalExpression,
		    NewExpression: NewExpression,
		    NullLiteral: NullLiteral,
		    NumericLiteral: NumericLiteral,
		    ObjectExpression: ObjectExpression,
		    ParenthesizedExpression: ParenthesizedExpression,
		    RegExpLiteral: RegExpLiteral,
		    RestElement: RestElement,
		    SequenceExpression: SequenceExpression,
		    StringLiteral: StringLiteral,
		    TSAsExpression: TSAsExpression,
		    TSNonNullExpression: TSNonNullExpression,
		    TaggedTemplateExpression: TaggedTemplateExpression,
		    TemplateLiteral: TemplateLiteral,
		    TypeCastExpression: TypeCastExpression,
		    UnaryExpression: UnaryExpression,
		    UpdateExpression: UpdateExpression,
		    VariableDeclarator: VariableDeclarator
		  });

		  var anyTypeAnnotation = anyTypeAnnotation$2,
		    isAnyTypeAnnotation = isAnyTypeAnnotation$1,
		    isArrayTypeAnnotation = isArrayTypeAnnotation$2,
		    isBooleanTypeAnnotation = isBooleanTypeAnnotation$1,
		    isEmptyTypeAnnotation = isEmptyTypeAnnotation$1,
		    isFlowBaseAnnotation = isFlowBaseAnnotation$1,
		    isGenericTypeAnnotation = isGenericTypeAnnotation$1,
		    isIdentifier$b = isIdentifier$i,
		    isMixedTypeAnnotation = isMixedTypeAnnotation$1,
		    isNumberTypeAnnotation = isNumberTypeAnnotation$1,
		    isStringTypeAnnotation = isStringTypeAnnotation$1,
		    isTSArrayType = isTSArrayType$1,
		    isTSTypeAnnotation = isTSTypeAnnotation$1,
		    isTSTypeReference = isTSTypeReference$1,
		    isTupleTypeAnnotation = isTupleTypeAnnotation$1,
		    isTypeAnnotation = isTypeAnnotation$1,
		    isUnionTypeAnnotation = isUnionTypeAnnotation$1,
		    isVoidTypeAnnotation = isVoidTypeAnnotation$1,
		    stringTypeAnnotation = stringTypeAnnotation$2,
		    voidTypeAnnotation = voidTypeAnnotation$3;
		  function getTypeAnnotation() {
		    var type = this.getData("typeAnnotation");
		    if (type != null) {
		      return type;
		    }
		    type = this._getTypeAnnotation() || anyTypeAnnotation();
		    if (isTypeAnnotation(type) || isTSTypeAnnotation(type)) {
		      type = type.typeAnnotation;
		    }
		    this.setData("typeAnnotation", type);
		    return type;
		  }
		  var typeAnnotationInferringNodes = new WeakSet();
		  function _getTypeAnnotation() {
		    var node = this.node;
		    if (!node) {
		      if (this.key === "init" && this.parentPath.isVariableDeclarator()) {
		        var declar = this.parentPath.parentPath;
		        var declarParent = declar.parentPath;
		        if (declar.key === "left" && declarParent.isForInStatement()) {
		          return stringTypeAnnotation();
		        }
		        if (declar.key === "left" && declarParent.isForOfStatement()) {
		          return anyTypeAnnotation();
		        }
		        return voidTypeAnnotation();
		      } else {
		        return;
		      }
		    }
		    if (node.typeAnnotation) {
		      return node.typeAnnotation;
		    }
		    if (typeAnnotationInferringNodes.has(node)) {
		      return;
		    }
		    typeAnnotationInferringNodes.add(node);
		    try {
		      var _inferer;
		      var inferer = inferers[node.type];
		      if (inferer) {
		        return inferer.call(this, node);
		      }
		      inferer = inferers[this.parentPath.type];
		      if ((_inferer = inferer) != null && _inferer.validParent) {
		        return this.parentPath.getTypeAnnotation();
		      }
		    } finally {
		      typeAnnotationInferringNodes["delete"](node);
		    }
		  }
		  function isBaseType(baseName, soft) {
		    return _isBaseType(baseName, this.getTypeAnnotation(), soft);
		  }
		  function _isBaseType(baseName, type, soft) {
		    if (baseName === "string") {
		      return isStringTypeAnnotation(type);
		    } else if (baseName === "number") {
		      return isNumberTypeAnnotation(type);
		    } else if (baseName === "boolean") {
		      return isBooleanTypeAnnotation(type);
		    } else if (baseName === "any") {
		      return isAnyTypeAnnotation(type);
		    } else if (baseName === "mixed") {
		      return isMixedTypeAnnotation(type);
		    } else if (baseName === "empty") {
		      return isEmptyTypeAnnotation(type);
		    } else if (baseName === "void") {
		      return isVoidTypeAnnotation(type);
		    } else {
		      if (soft) {
		        return false;
		      } else {
		        throw new Error("Unknown base type " + baseName);
		      }
		    }
		  }
		  function couldBeBaseType(name) {
		    var type = this.getTypeAnnotation();
		    if (isAnyTypeAnnotation(type)) return true;
		    if (isUnionTypeAnnotation(type)) {
		      for (var _iterator = _createForOfIteratorHelperLoose(type.types), _step; !(_step = _iterator()).done;) {
		        var type2 = _step.value;
		        if (isAnyTypeAnnotation(type2) || _isBaseType(name, type2, true)) {
		          return true;
		        }
		      }
		      return false;
		    } else {
		      return _isBaseType(name, type, true);
		    }
		  }
		  function baseTypeStrictlyMatches(rightArg) {
		    var left = this.getTypeAnnotation();
		    var right = rightArg.getTypeAnnotation();
		    if (!isAnyTypeAnnotation(left) && isFlowBaseAnnotation(left)) {
		      return right.type === left.type;
		    }
		    return false;
		  }
		  function isGenericType(genericName) {
		    var type = this.getTypeAnnotation();
		    if (genericName === "Array") {
		      if (isTSArrayType(type) || isArrayTypeAnnotation(type) || isTupleTypeAnnotation(type)) {
		        return true;
		      }
		    }
		    return isGenericTypeAnnotation(type) && isIdentifier$b(type.id, {
		      name: genericName
		    }) || isTSTypeReference(type) && isIdentifier$b(type.typeName, {
		      name: genericName
		    });
		  }

		  var NodePath_inference = /*#__PURE__*/Object.freeze({
		    __proto__: null,
		    _getTypeAnnotation: _getTypeAnnotation,
		    baseTypeStrictlyMatches: baseTypeStrictlyMatches,
		    couldBeBaseType: couldBeBaseType,
		    getTypeAnnotation: getTypeAnnotation,
		    isBaseType: isBaseType,
		    isGenericType: isGenericType
		  });

		  var jsTokensBABEL_8_BREAKINGFalse = {};

		  var hasRequiredJsTokensBABEL_8_BREAKINGFalse;
		  function requireJsTokensBABEL_8_BREAKINGFalse() {
		    if (hasRequiredJsTokensBABEL_8_BREAKINGFalse) return jsTokensBABEL_8_BREAKINGFalse;
		    hasRequiredJsTokensBABEL_8_BREAKINGFalse = 1;
		    Object.defineProperty(jsTokensBABEL_8_BREAKINGFalse, "__esModule", {
		      value: true
		    });
		    jsTokensBABEL_8_BREAKINGFalse["default"] = /((['"])(?:(?!\2|\\).|\\(?:\r\n|[\s\S]))*(\2)?|`(?:[^`\\$]|\\[\s\S]|\$(?!\{)|\$\{(?:[^{}]|\{[^}]*\}?)*\}?)*(`)?)|(\/\/.*)|(\/\*(?:[^*]|\*(?!\/))*(\*\/)?)|(\/(?!\*)(?:\[(?:(?![\]\\]).|\\.)*\]|(?![\/\]\\]).|\\.)+\/(?:(?!\s*(?:\b|[\u0080-\uFFFF$\\'"~({]|[+\-!](?!=)|\.?\d))|[gmiyus]{1,6}\b(?![\u0080-\uFFFF$\\]|\s*(?:[+\-*%&|^<>!=?({]|\/(?![\/*])))))|(0[xX][\da-fA-F]+|0[oO][0-7]+|0[bB][01]+|(?:\d*\.\d+|\d+\.?)(?:[eE][+-]?\d+)?)|((?!\d)(?:(?!\s)[$\w\u0080-\uFFFF]|\\u[\da-fA-F]{4}|\\u\{[\da-fA-F]+\})+)|(--|\+\+|&&|\|\||=>|\.{3}|(?:[+\-\/%&|^]|\*{1,2}|<{1,2}|>{1,3}|!=?|={1,2})=?|[?~.,:;[\](){}])|(\s+)|(^$|[\s\S])/g;
		    jsTokensBABEL_8_BREAKINGFalse.matchToToken = function (match) {
		      var token = {
		        type: "invalid",
		        value: match[0],
		        closed: undefined
		      };
		      if (match[1]) token.type = "string", token.closed = !!(match[3] || match[4]);else if (match[5]) token.type = "comment";else if (match[6]) token.type = "comment", token.closed = !!match[7];else if (match[8]) token.type = "regex";else if (match[9]) token.type = "number";else if (match[10]) token.type = "name";else if (match[11]) token.type = "punctuator";else if (match[12]) token.type = "whitespace";
		      return token;
		    };
		    return jsTokensBABEL_8_BREAKINGFalse;
		  }

		  function bool$8(value) {
		    if (value == null) return false;
		    return value && value !== "false" && value !== "0";
		  }
		  var jsTokens = bool$8(browser$1$1.env["BABEL_8_BREAKING"]) ? requireJsTokensBABEL_8_BREAKINGFalse() : requireJsTokensBABEL_8_BREAKINGFalse();

		  var picocolors_browser = {exports: {}};

		  var x = String;
		  var create = function create() {
		    return {
		      isColorSupported: false,
		      reset: x,
		      bold: x,
		      dim: x,
		      italic: x,
		      underline: x,
		      inverse: x,
		      hidden: x,
		      strikethrough: x,
		      black: x,
		      red: x,
		      green: x,
		      yellow: x,
		      blue: x,
		      magenta: x,
		      cyan: x,
		      white: x,
		      gray: x,
		      bgBlack: x,
		      bgRed: x,
		      bgGreen: x,
		      bgYellow: x,
		      bgBlue: x,
		      bgMagenta: x,
		      bgCyan: x,
		      bgWhite: x
		    };
		  };
		  picocolors_browser.exports = create();
		  var createColors = picocolors_browser.exports.createColors = create;
		  var picocolors_browserExports = picocolors_browser.exports;

		  var colors$1 = typeof browser$1$1 === "object" && (browser$1$1.env.FORCE_COLOR === "0" || browser$1$1.env.FORCE_COLOR === "false") ? createColors(false) : picocolors_browserExports;
		  var compose$1 = function compose(f, g) {
		    return function (v) {
		      return f(g(v));
		    };
		  };
		  var sometimesKeywords = new Set(["as", "async", "from", "get", "of", "set"]);
		  function getDefs$1(colors) {
		    return {
		      keyword: colors.cyan,
		      capitalized: colors.yellow,
		      jsxIdentifier: colors.yellow,
		      punctuator: colors.yellow,
		      number: colors.magenta,
		      string: colors.green,
		      regex: colors.magenta,
		      comment: colors.gray,
		      invalid: compose$1(compose$1(colors.white, colors.bgRed), colors.bold)
		    };
		  }
		  var NEWLINE$1 = /\r\n|[\n\r\u2028\u2029]/;
		  var BRACKET = /^[()[\]{}]$/;
		  var tokenize;
		  {
		    var JSX_TAG = /^[a-z][\w-]*$/i;
		    var getTokenType = function getTokenType(token, offset, text) {
		      if (token.type === "name") {
		        if (isKeyword(token.value) || isStrictReservedWord(token.value, true) || sometimesKeywords.has(token.value)) {
		          return "keyword";
		        }
		        if (JSX_TAG.test(token.value) && (text[offset - 1] === "<" || text.slice(offset - 2, offset) === "</")) {
		          return "jsxIdentifier";
		        }
		        if (token.value[0] !== token.value[0].toLowerCase()) {
		          return "capitalized";
		        }
		      }
		      if (token.type === "punctuator" && BRACKET.test(token.value)) {
		        return "bracket";
		      }
		      if (token.type === "invalid" && (token.value === "@" || token.value === "#")) {
		        return "punctuator";
		      }
		      return token.type;
		    };
		    tokenize = _regeneratorRuntime().mark(function tokenize(text) {
		      var match, token;
		      return _regeneratorRuntime().wrap(function tokenize$(_context) {
		        while (1) switch (_context.prev = _context.next) {
		          case 0:
		            if (!(match = jsTokens["default"].exec(text))) {
		              _context.next = 6;
		              break;
		            }
		            token = jsTokens.matchToToken(match);
		            _context.next = 4;
		            return {
		              type: getTokenType(token, match.index, text),
		              value: token.value
		            };
		          case 4:
		            _context.next = 0;
		            break;
		          case 6:
		          case "end":
		            return _context.stop();
		        }
		      }, tokenize);
		    });
		  }
		  function highlightTokens(defs, text) {
		    var highlighted = "";
		    var _loop = function _loop() {
		      var _step$value = _step.value,
		        type = _step$value.type,
		        value = _step$value.value;
		      var colorize = defs[type];
		      if (colorize) {
		        highlighted += value.split(NEWLINE$1).map(function (str) {
		          return colorize(str);
		        }).join("\n");
		      } else {
		        highlighted += value;
		      }
		    };
		    for (var _iterator = _createForOfIteratorHelperLoose(tokenize(text)), _step; !(_step = _iterator()).done;) {
		      _loop();
		    }
		    return highlighted;
		  }
		  function shouldHighlight(options) {
		    return colors$1.isColorSupported || options.forceColor;
		  }
		  var pcWithForcedColor$1 = undefined;
		  function getColors$1(forceColor) {
		    if (forceColor) {
		      var _pcWithForcedColor;
		      (_pcWithForcedColor = pcWithForcedColor$1) != null ? _pcWithForcedColor : pcWithForcedColor$1 = createColors(true);
		      return pcWithForcedColor$1;
		    }
		    return colors$1;
		  }
		  function highlight(code, options) {
		    if (options === void 0) {
		      options = {};
		    }
		    if (code !== "" && shouldHighlight(options)) {
		      var defs = getDefs$1(getColors$1(options.forceColor));
		      return highlightTokens(defs, code);
		    } else {
		      return code;
		    }
		  }

		  var colors = typeof browser$1$1 === "object" && (browser$1$1.env.FORCE_COLOR === "0" || browser$1$1.env.FORCE_COLOR === "false") ? createColors(false) : picocolors_browserExports;
		  var compose = function compose(f, g) {
		    return function (v) {
		      return f(g(v));
		    };
		  };
		  var pcWithForcedColor = undefined;
		  function getColors(forceColor) {
		    if (forceColor) {
		      var _pcWithForcedColor;
		      (_pcWithForcedColor = pcWithForcedColor) != null ? _pcWithForcedColor : pcWithForcedColor = createColors(true);
		      return pcWithForcedColor;
		    }
		    return colors;
		  }
		  function getDefs(colors) {
		    return {
		      gutter: colors.gray,
		      marker: compose(colors.red, colors.bold),
		      message: compose(colors.red, colors.bold)
		    };
		  }
		  var NEWLINE = /\r\n|[\n\r\u2028\u2029]/;
		  function getMarkerLines(loc, source, opts) {
		    var startLoc = Object.assign({
		      column: 0,
		      line: -1
		    }, loc.start);
		    var endLoc = Object.assign({}, startLoc, loc.end);
		    var _ref = opts || {},
		      _ref$linesAbove = _ref.linesAbove,
		      linesAbove = _ref$linesAbove === void 0 ? 2 : _ref$linesAbove,
		      _ref$linesBelow = _ref.linesBelow,
		      linesBelow = _ref$linesBelow === void 0 ? 3 : _ref$linesBelow;
		    var startLine = startLoc.line;
		    var startColumn = startLoc.column;
		    var endLine = endLoc.line;
		    var endColumn = endLoc.column;
		    var start = Math.max(startLine - (linesAbove + 1), 0);
		    var end = Math.min(source.length, endLine + linesBelow);
		    if (startLine === -1) {
		      start = 0;
		    }
		    if (endLine === -1) {
		      end = source.length;
		    }
		    var lineDiff = endLine - startLine;
		    var markerLines = {};
		    if (lineDiff) {
		      for (var i = 0; i <= lineDiff; i++) {
		        var lineNumber = i + startLine;
		        if (!startColumn) {
		          markerLines[lineNumber] = true;
		        } else if (i === 0) {
		          var sourceLength = source[lineNumber - 1].length;
		          markerLines[lineNumber] = [startColumn, sourceLength - startColumn + 1];
		        } else if (i === lineDiff) {
		          markerLines[lineNumber] = [0, endColumn];
		        } else {
		          var _sourceLength = source[lineNumber - i].length;
		          markerLines[lineNumber] = [0, _sourceLength];
		        }
		      }
		    } else {
		      if (startColumn === endColumn) {
		        if (startColumn) {
		          markerLines[startLine] = [startColumn, 0];
		        } else {
		          markerLines[startLine] = true;
		        }
		      } else {
		        markerLines[startLine] = [startColumn, endColumn - startColumn];
		      }
		    }
		    return {
		      start: start,
		      end: end,
		      markerLines: markerLines
		    };
		  }
		  function codeFrameColumns(rawLines, loc, opts) {
		    if (opts === void 0) {
		      opts = {};
		    }
		    var highlighted = (opts.highlightCode || opts.forceColor) && shouldHighlight(opts);
		    var colors = getColors(opts.forceColor);
		    var defs = getDefs(colors);
		    var maybeHighlight = function maybeHighlight(fmt, string) {
		      return highlighted ? fmt(string) : string;
		    };
		    var lines = rawLines.split(NEWLINE);
		    var _getMarkerLines = getMarkerLines(loc, lines, opts),
		      start = _getMarkerLines.start,
		      end = _getMarkerLines.end,
		      markerLines = _getMarkerLines.markerLines;
		    var hasColumns = loc.start && typeof loc.start.column === "number";
		    var numberMaxWidth = String(end).length;
		    var highlightedLines = highlighted ? highlight(rawLines, opts) : rawLines;
		    var frame = highlightedLines.split(NEWLINE, end).slice(start, end).map(function (line, index) {
		      var number = start + 1 + index;
		      var paddedNumber = (" " + number).slice(-numberMaxWidth);
		      var gutter = " " + paddedNumber + " |";
		      var hasMarker = markerLines[number];
		      var lastMarkerLine = !markerLines[number + 1];
		      if (hasMarker) {
		        var markerLine = "";
		        if (Array.isArray(hasMarker)) {
		          var markerSpacing = line.slice(0, Math.max(hasMarker[0] - 1, 0)).replace(/[^\t]/g, " ");
		          var numberOfMarkers = hasMarker[1] || 1;
		          markerLine = ["\n ", maybeHighlight(defs.gutter, gutter.replace(/\d/g, " ")), " ", markerSpacing, maybeHighlight(defs.marker, "^").repeat(numberOfMarkers)].join("");
		          if (lastMarkerLine && opts.message) {
		            markerLine += " " + maybeHighlight(defs.message, opts.message);
		          }
		        }
		        return [maybeHighlight(defs.marker, ">"), maybeHighlight(defs.gutter, gutter), line.length > 0 ? " " + line : "", markerLine].join("");
		      } else {
		        return " " + maybeHighlight(defs.gutter, gutter) + (line.length > 0 ? " " + line : "");
		      }
		    }).join("\n");
		    if (opts.message && !hasColumns) {
		      frame = "" + " ".repeat(numberMaxWidth + 1) + opts.message + "\n" + frame;
		    }
		    if (highlighted) {
		      return colors.reset(frame);
		    } else {
		      return frame;
		    }
		  }

		  var Position = _createClass(function Position(line, col, index) {
		    this.line = void 0;
		    this.column = void 0;
		    this.index = void 0;
		    this.line = line;
		    this.column = col;
		    this.index = index;
		  });
		  var SourceLocation = _createClass(function SourceLocation(start, end) {
		    this.start = void 0;
		    this.end = void 0;
		    this.filename = void 0;
		    this.identifierName = void 0;
		    this.start = start;
		    this.end = end;
		  });
		  function createPositionWithColumnOffset(position, columnOffset) {
		    var line = position.line,
		      column = position.column,
		      index = position.index;
		    return new Position(line, column + columnOffset, index + columnOffset);
		  }

		  var code = "BABEL_PARSER_SOURCETYPE_MODULE_REQUIRED";
		  var ModuleErrors = {
		    ImportMetaOutsideModule: {
		      message: "import.meta may appear only with 'sourceType: \"module\"'",
		      code: code
		    },
		    ImportOutsideModule: {
		      message: "'import' and 'export' may appear only with 'sourceType: \"module\"'",
		      code: code
		    }
		  };

		  var NodeDescriptions = {
		    ArrayPattern: "array destructuring pattern",
		    AssignmentExpression: "assignment expression",
		    AssignmentPattern: "assignment expression",
		    ArrowFunctionExpression: "arrow function expression",
		    ConditionalExpression: "conditional expression",
		    CatchClause: "catch clause",
		    ForOfStatement: "for-of statement",
		    ForInStatement: "for-in statement",
		    ForStatement: "for-loop",
		    FormalParameters: "function parameter list",
		    Identifier: "identifier",
		    ImportSpecifier: "import specifier",
		    ImportDefaultSpecifier: "import default specifier",
		    ImportNamespaceSpecifier: "import namespace specifier",
		    ObjectPattern: "object destructuring pattern",
		    ParenthesizedExpression: "parenthesized expression",
		    RestElement: "rest element",
		    UpdateExpression: {
		      "true": "prefix operation",
		      "false": "postfix operation"
		    },
		    VariableDeclarator: "variable declaration",
		    YieldExpression: "yield expression"
		  };
		  var toNodeDescription = function toNodeDescription(node) {
		    return node.type === "UpdateExpression" ? NodeDescriptions.UpdateExpression["" + node.prefix] : NodeDescriptions[node.type];
		  };

		  var StandardErrors = {
		    AccessorIsGenerator: function AccessorIsGenerator(_ref) {
		      var kind = _ref.kind;
		      return "A " + kind + "ter cannot be a generator.";
		    },
		    ArgumentsInClass: "'arguments' is only allowed in functions and class methods.",
		    AsyncFunctionInSingleStatementContext: "Async functions can only be declared at the top level or inside a block.",
		    AwaitBindingIdentifier: "Can not use 'await' as identifier inside an async function.",
		    AwaitBindingIdentifierInStaticBlock: "Can not use 'await' as identifier inside a static block.",
		    AwaitExpressionFormalParameter: "'await' is not allowed in async function parameters.",
		    AwaitUsingNotInAsyncContext: "'await using' is only allowed within async functions and at the top levels of modules.",
		    AwaitNotInAsyncContext: "'await' is only allowed within async functions and at the top levels of modules.",
		    AwaitNotInAsyncFunction: "'await' is only allowed within async functions.",
		    BadGetterArity: "A 'get' accessor must not have any formal parameters.",
		    BadSetterArity: "A 'set' accessor must have exactly one formal parameter.",
		    BadSetterRestParameter: "A 'set' accessor function argument must not be a rest parameter.",
		    ConstructorClassField: "Classes may not have a field named 'constructor'.",
		    ConstructorClassPrivateField: "Classes may not have a private field named '#constructor'.",
		    ConstructorIsAccessor: "Class constructor may not be an accessor.",
		    ConstructorIsAsync: "Constructor can't be an async function.",
		    ConstructorIsGenerator: "Constructor can't be a generator.",
		    DeclarationMissingInitializer: function DeclarationMissingInitializer(_ref2) {
		      var kind = _ref2.kind;
		      return "Missing initializer in " + kind + " declaration.";
		    },
		    DecoratorArgumentsOutsideParentheses: "Decorator arguments must be moved inside parentheses: use '@(decorator(args))' instead of '@(decorator)(args)'.",
		    DecoratorBeforeExport: "Decorators must be placed *before* the 'export' keyword. Remove the 'decoratorsBeforeExport: true' option to use the 'export @decorator class {}' syntax.",
		    DecoratorsBeforeAfterExport: "Decorators can be placed *either* before or after the 'export' keyword, but not in both locations at the same time.",
		    DecoratorConstructor: "Decorators can't be used with a constructor. Did you mean '@dec class { ... }'?",
		    DecoratorExportClass: "Decorators must be placed *after* the 'export' keyword. Remove the 'decoratorsBeforeExport: false' option to use the '@decorator export class {}' syntax.",
		    DecoratorSemicolon: "Decorators must not be followed by a semicolon.",
		    DecoratorStaticBlock: "Decorators can't be used with a static block.",
		    DeferImportRequiresNamespace: 'Only `import defer * as x from "./module"` is valid.',
		    DeletePrivateField: "Deleting a private field is not allowed.",
		    DestructureNamedImport: "ES2015 named imports do not destructure. Use another statement for destructuring after the import.",
		    DuplicateConstructor: "Duplicate constructor in the same class.",
		    DuplicateDefaultExport: "Only one default export allowed per module.",
		    DuplicateExport: function DuplicateExport(_ref3) {
		      var exportName = _ref3.exportName;
		      return "`" + exportName + "` has already been exported. Exported identifiers must be unique.";
		    },
		    DuplicateProto: "Redefinition of __proto__ property.",
		    DuplicateRegExpFlags: "Duplicate regular expression flag.",
		    DynamicImportPhaseRequiresImportExpressions: function DynamicImportPhaseRequiresImportExpressions(_ref4) {
		      var phase = _ref4.phase;
		      return "'import." + phase + "(...)' can only be parsed when using the 'createImportExpressions' option.";
		    },
		    ElementAfterRest: "Rest element must be last element.",
		    EscapedCharNotAnIdentifier: "Invalid Unicode escape.",
		    ExportBindingIsString: function ExportBindingIsString(_ref5) {
		      var localName = _ref5.localName,
		        exportName = _ref5.exportName;
		      return "A string literal cannot be used as an exported binding without `from`.\n- Did you mean `export { '" + localName + "' as '" + exportName + "' } from 'some-module'`?";
		    },
		    ExportDefaultFromAsIdentifier: "'from' is not allowed as an identifier after 'export default'.",
		    ForInOfLoopInitializer: function ForInOfLoopInitializer(_ref6) {
		      var type = _ref6.type;
		      return "'" + (type === "ForInStatement" ? "for-in" : "for-of") + "' loop variable declaration may not have an initializer.";
		    },
		    ForInUsing: "For-in loop may not start with 'using' declaration.",
		    ForOfAsync: "The left-hand side of a for-of loop may not be 'async'.",
		    ForOfLet: "The left-hand side of a for-of loop may not start with 'let'.",
		    GeneratorInSingleStatementContext: "Generators can only be declared at the top level or inside a block.",
		    IllegalBreakContinue: function IllegalBreakContinue(_ref7) {
		      var type = _ref7.type;
		      return "Unsyntactic " + (type === "BreakStatement" ? "break" : "continue") + ".";
		    },
		    IllegalLanguageModeDirective: "Illegal 'use strict' directive in function with non-simple parameter list.",
		    IllegalReturn: "'return' outside of function.",
		    ImportAttributesUseAssert: "The `assert` keyword in import attributes is deprecated and it has been replaced by the `with` keyword. You can enable the `deprecatedAssertSyntax: true` option in the import attributes plugin to suppress this error.",
		    ImportBindingIsString: function ImportBindingIsString(_ref8) {
		      var importName = _ref8.importName;
		      return "A string literal cannot be used as an imported binding.\n- Did you mean `import { \"" + importName + "\" as foo }`?";
		    },
		    ImportCallArgumentTrailingComma: "Trailing comma is disallowed inside import(...) arguments.",
		    ImportCallArity: function ImportCallArity(_ref9) {
		      var maxArgumentCount = _ref9.maxArgumentCount;
		      return "`import()` requires exactly " + (maxArgumentCount === 1 ? "one argument" : "one or two arguments") + ".";
		    },
		    ImportCallNotNewExpression: "Cannot use new with import(...).",
		    ImportCallSpreadArgument: "`...` is not allowed in `import()`.",
		    ImportJSONBindingNotDefault: "A JSON module can only be imported with `default`.",
		    ImportReflectionHasAssertion: "`import module x` cannot have assertions.",
		    ImportReflectionNotBinding: 'Only `import module x from "./module"` is valid.',
		    IncompatibleRegExpUVFlags: "The 'u' and 'v' regular expression flags cannot be enabled at the same time.",
		    InvalidBigIntLiteral: "Invalid BigIntLiteral.",
		    InvalidCodePoint: "Code point out of bounds.",
		    InvalidCoverInitializedName: "Invalid shorthand property initializer.",
		    InvalidDecimal: "Invalid decimal.",
		    InvalidDigit: function InvalidDigit(_ref10) {
		      var radix = _ref10.radix;
		      return "Expected number in radix " + radix + ".";
		    },
		    InvalidEscapeSequence: "Bad character escape sequence.",
		    InvalidEscapeSequenceTemplate: "Invalid escape sequence in template.",
		    InvalidEscapedReservedWord: function InvalidEscapedReservedWord(_ref11) {
		      var reservedWord = _ref11.reservedWord;
		      return "Escape sequence in keyword " + reservedWord + ".";
		    },
		    InvalidIdentifier: function InvalidIdentifier(_ref12) {
		      var identifierName = _ref12.identifierName;
		      return "Invalid identifier " + identifierName + ".";
		    },
		    InvalidLhs: function InvalidLhs(_ref13) {
		      var ancestor = _ref13.ancestor;
		      return "Invalid left-hand side in " + toNodeDescription(ancestor) + ".";
		    },
		    InvalidLhsBinding: function InvalidLhsBinding(_ref14) {
		      var ancestor = _ref14.ancestor;
		      return "Binding invalid left-hand side in " + toNodeDescription(ancestor) + ".";
		    },
		    InvalidLhsOptionalChaining: function InvalidLhsOptionalChaining(_ref15) {
		      var ancestor = _ref15.ancestor;
		      return "Invalid optional chaining in the left-hand side of " + toNodeDescription(ancestor) + ".";
		    },
		    InvalidNumber: "Invalid number.",
		    InvalidOrMissingExponent: "Floating-point numbers require a valid exponent after the 'e'.",
		    InvalidOrUnexpectedToken: function InvalidOrUnexpectedToken(_ref16) {
		      var unexpected = _ref16.unexpected;
		      return "Unexpected character '" + unexpected + "'.";
		    },
		    InvalidParenthesizedAssignment: "Invalid parenthesized assignment pattern.",
		    InvalidPrivateFieldResolution: function InvalidPrivateFieldResolution(_ref17) {
		      var identifierName = _ref17.identifierName;
		      return "Private name #" + identifierName + " is not defined.";
		    },
		    InvalidPropertyBindingPattern: "Binding member expression.",
		    InvalidRecordProperty: "Only properties and spread elements are allowed in record definitions.",
		    InvalidRestAssignmentPattern: "Invalid rest operator's argument.",
		    LabelRedeclaration: function LabelRedeclaration(_ref18) {
		      var labelName = _ref18.labelName;
		      return "Label '" + labelName + "' is already declared.";
		    },
		    LetInLexicalBinding: "'let' is disallowed as a lexically bound name.",
		    LineTerminatorBeforeArrow: "No line break is allowed before '=>'.",
		    MalformedRegExpFlags: "Invalid regular expression flag.",
		    MissingClassName: "A class name is required.",
		    MissingEqInAssignment: "Only '=' operator can be used for specifying default value.",
		    MissingSemicolon: "Missing semicolon.",
		    MissingPlugin: function MissingPlugin(_ref19) {
		      var missingPlugin = _ref19.missingPlugin;
		      return "This experimental syntax requires enabling the parser plugin: " + missingPlugin.map(function (name) {
		        return JSON.stringify(name);
		      }).join(", ") + ".";
		    },
		    MissingOneOfPlugins: function MissingOneOfPlugins(_ref20) {
		      var missingPlugin = _ref20.missingPlugin;
		      return "This experimental syntax requires enabling one of the following parser plugin(s): " + missingPlugin.map(function (name) {
		        return JSON.stringify(name);
		      }).join(", ") + ".";
		    },
		    MissingUnicodeEscape: "Expecting Unicode escape sequence \\uXXXX.",
		    MixingCoalesceWithLogical: "Nullish coalescing operator(??) requires parens when mixing with logical operators.",
		    ModuleAttributeDifferentFromType: "The only accepted module attribute is `type`.",
		    ModuleAttributeInvalidValue: "Only string literals are allowed as module attribute values.",
		    ModuleAttributesWithDuplicateKeys: function ModuleAttributesWithDuplicateKeys(_ref21) {
		      var key = _ref21.key;
		      return "Duplicate key \"" + key + "\" is not allowed in module attributes.";
		    },
		    ModuleExportNameHasLoneSurrogate: function ModuleExportNameHasLoneSurrogate(_ref22) {
		      var surrogateCharCode = _ref22.surrogateCharCode;
		      return "An export name cannot include a lone surrogate, found '\\u" + surrogateCharCode.toString(16) + "'.";
		    },
		    ModuleExportUndefined: function ModuleExportUndefined(_ref23) {
		      var localName = _ref23.localName;
		      return "Export '" + localName + "' is not defined.";
		    },
		    MultipleDefaultsInSwitch: "Multiple default clauses.",
		    NewlineAfterThrow: "Illegal newline after throw.",
		    NoCatchOrFinally: "Missing catch or finally clause.",
		    NumberIdentifier: "Identifier directly after number.",
		    NumericSeparatorInEscapeSequence: "Numeric separators are not allowed inside unicode escape sequences or hex escape sequences.",
		    ObsoleteAwaitStar: "'await*' has been removed from the async functions proposal. Use Promise.all() instead.",
		    OptionalChainingNoNew: "Constructors in/after an Optional Chain are not allowed.",
		    OptionalChainingNoTemplate: "Tagged Template Literals are not allowed in optionalChain.",
		    OverrideOnConstructor: "'override' modifier cannot appear on a constructor declaration.",
		    ParamDupe: "Argument name clash.",
		    PatternHasAccessor: "Object pattern can't contain getter or setter.",
		    PatternHasMethod: "Object pattern can't contain methods.",
		    PrivateInExpectedIn: function PrivateInExpectedIn(_ref24) {
		      var identifierName = _ref24.identifierName;
		      return "Private names are only allowed in property accesses (`obj.#" + identifierName + "`) or in `in` expressions (`#" + identifierName + " in obj`).";
		    },
		    PrivateNameRedeclaration: function PrivateNameRedeclaration(_ref25) {
		      var identifierName = _ref25.identifierName;
		      return "Duplicate private name #" + identifierName + ".";
		    },
		    RecordExpressionBarIncorrectEndSyntaxType: "Record expressions ending with '|}' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'bar'.",
		    RecordExpressionBarIncorrectStartSyntaxType: "Record expressions starting with '{|' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'bar'.",
		    RecordExpressionHashIncorrectStartSyntaxType: "Record expressions starting with '#{' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'hash'.",
		    RecordNoProto: "'__proto__' is not allowed in Record expressions.",
		    RestTrailingComma: "Unexpected trailing comma after rest element.",
		    SloppyFunction: "In non-strict mode code, functions can only be declared at top level or inside a block.",
		    SloppyFunctionAnnexB: "In non-strict mode code, functions can only be declared at top level, inside a block, or as the body of an if statement.",
		    SourcePhaseImportRequiresDefault: 'Only `import source x from "./module"` is valid.',
		    StaticPrototype: "Classes may not have static property named prototype.",
		    SuperNotAllowed: "`super()` is only valid inside a class constructor of a subclass. Maybe a typo in the method name ('constructor') or not extending another class?",
		    SuperPrivateField: "Private fields can't be accessed on super.",
		    TrailingDecorator: "Decorators must be attached to a class element.",
		    TupleExpressionBarIncorrectEndSyntaxType: "Tuple expressions ending with '|]' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'bar'.",
		    TupleExpressionBarIncorrectStartSyntaxType: "Tuple expressions starting with '[|' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'bar'.",
		    TupleExpressionHashIncorrectStartSyntaxType: "Tuple expressions starting with '#[' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'hash'.",
		    UnexpectedArgumentPlaceholder: "Unexpected argument placeholder.",
		    UnexpectedAwaitAfterPipelineBody: 'Unexpected "await" after pipeline body; await must have parentheses in minimal proposal.',
		    UnexpectedDigitAfterHash: "Unexpected digit after hash token.",
		    UnexpectedImportExport: "'import' and 'export' may only appear at the top level.",
		    UnexpectedKeyword: function UnexpectedKeyword(_ref26) {
		      var keyword = _ref26.keyword;
		      return "Unexpected keyword '" + keyword + "'.";
		    },
		    UnexpectedLeadingDecorator: "Leading decorators must be attached to a class declaration.",
		    UnexpectedLexicalDeclaration: "Lexical declaration cannot appear in a single-statement context.",
		    UnexpectedNewTarget: "`new.target` can only be used in functions or class properties.",
		    UnexpectedNumericSeparator: "A numeric separator is only allowed between two digits.",
		    UnexpectedPrivateField: "Unexpected private name.",
		    UnexpectedReservedWord: function UnexpectedReservedWord(_ref27) {
		      var reservedWord = _ref27.reservedWord;
		      return "Unexpected reserved word '" + reservedWord + "'.";
		    },
		    UnexpectedSuper: "'super' is only allowed in object methods and classes.",
		    UnexpectedToken: function UnexpectedToken(_ref28) {
		      var expected = _ref28.expected,
		        unexpected = _ref28.unexpected;
		      return "Unexpected token" + (unexpected ? " '" + unexpected + "'." : "") + (expected ? ", expected \"" + expected + "\"" : "");
		    },
		    UnexpectedTokenUnaryExponentiation: "Illegal expression. Wrap left hand side or entire exponentiation in parentheses.",
		    UnexpectedUsingDeclaration: "Using declaration cannot appear in the top level when source type is `script`.",
		    UnsupportedBind: "Binding should be performed on object property.",
		    UnsupportedDecoratorExport: "A decorated export must export a class declaration.",
		    UnsupportedDefaultExport: "Only expressions, functions or classes are allowed as the `default` export.",
		    UnsupportedImport: "`import` can only be used in `import()` or `import.meta`.",
		    UnsupportedMetaProperty: function UnsupportedMetaProperty(_ref29) {
		      var target = _ref29.target,
		        onlyValidPropertyName = _ref29.onlyValidPropertyName;
		      return "The only valid meta property for " + target + " is " + target + "." + onlyValidPropertyName + ".";
		    },
		    UnsupportedParameterDecorator: "Decorators cannot be used to decorate parameters.",
		    UnsupportedPropertyDecorator: "Decorators cannot be used to decorate object literal properties.",
		    UnsupportedSuper: "'super' can only be used with function calls (i.e. super()) or in property accesses (i.e. super.prop or super[prop]).",
		    UnterminatedComment: "Unterminated comment.",
		    UnterminatedRegExp: "Unterminated regular expression.",
		    UnterminatedString: "Unterminated string constant.",
		    UnterminatedTemplate: "Unterminated template.",
		    UsingDeclarationExport: "Using declaration cannot be exported.",
		    UsingDeclarationHasBindingPattern: "Using declaration cannot have destructuring patterns.",
		    VarRedeclaration: function VarRedeclaration(_ref30) {
		      var identifierName = _ref30.identifierName;
		      return "Identifier '" + identifierName + "' has already been declared.";
		    },
		    YieldBindingIdentifier: "Can not use 'yield' as identifier inside a generator.",
		    YieldInParameter: "Yield expression is not allowed in formal parameters.",
		    ZeroDigitNumericSeparator: "Numeric separator can not be used after leading 0."
		  };

		  var StrictModeErrors = {
		    StrictDelete: "Deleting local variable in strict mode.",
		    StrictEvalArguments: function StrictEvalArguments(_ref) {
		      var referenceName = _ref.referenceName;
		      return "Assigning to '" + referenceName + "' in strict mode.";
		    },
		    StrictEvalArgumentsBinding: function StrictEvalArgumentsBinding(_ref2) {
		      var bindingName = _ref2.bindingName;
		      return "Binding '" + bindingName + "' in strict mode.";
		    },
		    StrictFunction: "In strict mode code, functions can only be declared at top level or inside a block.",
		    StrictNumericEscape: "The only valid numeric escape in strict mode is '\\0'.",
		    StrictOctalLiteral: "Legacy octal literals are not allowed in strict mode.",
		    StrictWith: "'with' in strict mode."
		  };

		  var UnparenthesizedPipeBodyDescriptions = new Set(["ArrowFunctionExpression", "AssignmentExpression", "ConditionalExpression", "YieldExpression"]);
		  var PipelineOperatorErrors = {
		    PipeBodyIsTighter: "Unexpected yield after pipeline body; any yield expression acting as Hack-style pipe body must be parenthesized due to its loose operator precedence.",
		    PipeTopicRequiresHackPipes: 'Topic reference is used, but the pipelineOperator plugin was not passed a "proposal": "hack" or "smart" option.',
		    PipeTopicUnbound: "Topic reference is unbound; it must be inside a pipe body.",
		    PipeTopicUnconfiguredToken: function PipeTopicUnconfiguredToken(_ref) {
		      var token = _ref.token;
		      return "Invalid topic token " + token + ". In order to use " + token + " as a topic reference, the pipelineOperator plugin must be configured with { \"proposal\": \"hack\", \"topicToken\": \"" + token + "\" }.";
		    },
		    PipeTopicUnused: "Hack-style pipe body does not contain a topic reference; Hack-style pipes must use topic at least once.",
		    PipeUnparenthesizedBody: function PipeUnparenthesizedBody(_ref2) {
		      var type = _ref2.type;
		      return "Hack-style pipe body cannot be an unparenthesized " + toNodeDescription({
		        type: type
		      }) + "; please wrap it in parentheses.";
		    },
		    PipelineBodyNoArrow: 'Unexpected arrow "=>" after pipeline body; arrow function in pipeline body must be parenthesized.',
		    PipelineBodySequenceExpression: "Pipeline body may not be a comma-separated sequence expression.",
		    PipelineHeadSequenceExpression: "Pipeline head should not be a comma-separated sequence expression.",
		    PipelineTopicUnused: "Pipeline is in topic style but does not use topic reference.",
		    PrimaryTopicNotAllowed: "Topic reference was used in a lexical context without topic binding.",
		    PrimaryTopicRequiresSmartPipeline: 'Topic reference is used, but the pipelineOperator plugin was not passed a "proposal": "hack" or "smart" option.'
		  };

		  var _templateObject$G;
		  var _excluded$4 = ["toMessage"],
		    _excluded2 = ["message"];
		  function defineHidden(obj, key, value) {
		    Object.defineProperty(obj, key, {
		      enumerable: false,
		      configurable: true,
		      value: value
		    });
		  }
		  function toParseErrorConstructor(_ref) {
		    var toMessage = _ref.toMessage,
		      properties = _objectWithoutPropertiesLoose(_ref, _excluded$4);
		    return function constructor(loc, details) {
		      var error = new SyntaxError();
		      Object.assign(error, properties, {
		        loc: loc,
		        pos: loc.index
		      });
		      if ("missingPlugin" in details) {
		        Object.assign(error, {
		          missingPlugin: details.missingPlugin
		        });
		      }
		      defineHidden(error, "clone", function clone(overrides) {
		        var _overrides$loc;
		        if (overrides === void 0) {
		          overrides = {};
		        }
		        var _ref2 = (_overrides$loc = overrides.loc) != null ? _overrides$loc : loc,
		          line = _ref2.line,
		          column = _ref2.column,
		          index = _ref2.index;
		        return constructor(new Position(line, column, index), Object.assign({}, details, overrides.details));
		      });
		      defineHidden(error, "details", details);
		      Object.defineProperty(error, "message", {
		        configurable: true,
		        get: function get() {
		          var message = toMessage(details) + " (" + loc.line + ":" + loc.column + ")";
		          this.message = message;
		          return message;
		        },
		        set: function set(value) {
		          Object.defineProperty(this, "message", {
		            value: value,
		            writable: true
		          });
		        }
		      });
		      return error;
		    };
		  }
		  function ParseErrorEnum(argument, syntaxPlugin) {
		    if (Array.isArray(argument)) {
		      return function (parseErrorTemplates) {
		        return ParseErrorEnum(parseErrorTemplates, argument[0]);
		      };
		    }
		    var ParseErrorConstructors = {};
		    var _loop = function _loop() {
		      var reasonCode = _Object$keys2[_i2];
		      var template = argument[reasonCode];
		      var _ref3 = typeof template === "string" ? {
		          message: function message() {
		            return template;
		          }
		        } : typeof template === "function" ? {
		          message: template
		        } : template,
		        message = _ref3.message,
		        rest = _objectWithoutPropertiesLoose(_ref3, _excluded2);
		      var toMessage = typeof message === "string" ? function () {
		        return message;
		      } : message;
		      ParseErrorConstructors[reasonCode] = toParseErrorConstructor(Object.assign({
		        code: "BABEL_PARSER_SYNTAX_ERROR",
		        reasonCode: reasonCode,
		        toMessage: toMessage
		      }, syntaxPlugin ? {
		        syntaxPlugin: syntaxPlugin
		      } : {}, rest));
		    };
		    for (var _i2 = 0, _Object$keys2 = Object.keys(argument); _i2 < _Object$keys2.length; _i2++) {
		      _loop();
		    }
		    return ParseErrorConstructors;
		  }
		  var Errors = Object.assign({}, ParseErrorEnum(ModuleErrors), ParseErrorEnum(StandardErrors), ParseErrorEnum(StrictModeErrors), ParseErrorEnum(_templateObject$G || (_templateObject$G = _taggedTemplateLiteralLoose(["pipelineOperator"])))(PipelineOperatorErrors));

		  var defineProperty = Object.defineProperty;
		  var toUnenumerable = function toUnenumerable(object, key) {
		    return defineProperty(object, key, {
		      enumerable: false,
		      value: object[key]
		    });
		  };
		  function toESTreeLocation(node) {
		    node.loc.start && toUnenumerable(node.loc.start, "index");
		    node.loc.end && toUnenumerable(node.loc.end, "index");
		    return node;
		  }
		  var estree = (function (superClass) {
		    return function (_superClass) {
		      function ESTreeParserMixin() {
		        return _superClass.apply(this, arguments) || this;
		      }
		      _inherits(ESTreeParserMixin, _superClass);
		      var _proto = ESTreeParserMixin.prototype;
		      _proto.parse = function parse() {
		        var file = toESTreeLocation(_superClass.prototype.parse.call(this));
		        if (this.options.tokens) {
		          file.tokens = file.tokens.map(toESTreeLocation);
		        }
		        return file;
		      };
		      _proto.parseRegExpLiteral = function parseRegExpLiteral(_ref) {
		        var pattern = _ref.pattern,
		          flags = _ref.flags;
		        var regex = null;
		        try {
		          regex = new RegExp(pattern, flags);
		        } catch (e) {}
		        var node = this.estreeParseLiteral(regex);
		        node.regex = {
		          pattern: pattern,
		          flags: flags
		        };
		        return node;
		      };
		      _proto.parseBigIntLiteral = function parseBigIntLiteral(value) {
		        var bigInt;
		        try {
		          bigInt = BigInt(value);
		        } catch (_unused) {
		          bigInt = null;
		        }
		        var node = this.estreeParseLiteral(bigInt);
		        node.bigint = String(node.value || value);
		        return node;
		      };
		      _proto.parseDecimalLiteral = function parseDecimalLiteral(value) {
		        var decimal = null;
		        var node = this.estreeParseLiteral(decimal);
		        node.decimal = String(node.value || value);
		        return node;
		      };
		      _proto.estreeParseLiteral = function estreeParseLiteral(value) {
		        return this.parseLiteral(value, "Literal");
		      };
		      _proto.parseStringLiteral = function parseStringLiteral(value) {
		        return this.estreeParseLiteral(value);
		      };
		      _proto.parseNumericLiteral = function parseNumericLiteral(value) {
		        return this.estreeParseLiteral(value);
		      };
		      _proto.parseNullLiteral = function parseNullLiteral() {
		        return this.estreeParseLiteral(null);
		      };
		      _proto.parseBooleanLiteral = function parseBooleanLiteral(value) {
		        return this.estreeParseLiteral(value);
		      };
		      _proto.directiveToStmt = function directiveToStmt(directive) {
		        var expression = directive.value;
		        delete directive.value;
		        expression.type = "Literal";
		        expression.raw = expression.extra.raw;
		        expression.value = expression.extra.expressionValue;
		        var stmt = directive;
		        stmt.type = "ExpressionStatement";
		        stmt.expression = expression;
		        stmt.directive = expression.extra.rawValue;
		        delete expression.extra;
		        return stmt;
		      };
		      _proto.initFunction = function initFunction(node, isAsync) {
		        _superClass.prototype.initFunction.call(this, node, isAsync);
		        node.expression = false;
		      };
		      _proto.checkDeclaration = function checkDeclaration(node) {
		        if (node != null && this.isObjectProperty(node)) {
		          this.checkDeclaration(node.value);
		        } else {
		          _superClass.prototype.checkDeclaration.call(this, node);
		        }
		      };
		      _proto.getObjectOrClassMethodParams = function getObjectOrClassMethodParams(method) {
		        return method.value.params;
		      };
		      _proto.isValidDirective = function isValidDirective(stmt) {
		        var _stmt$expression$extr;
		        return stmt.type === "ExpressionStatement" && stmt.expression.type === "Literal" && typeof stmt.expression.value === "string" && !((_stmt$expression$extr = stmt.expression.extra) != null && _stmt$expression$extr.parenthesized);
		      };
		      _proto.parseBlockBody = function parseBlockBody(node, allowDirectives, topLevel, end, afterBlockParse) {
		        var _this = this;
		        _superClass.prototype.parseBlockBody.call(this, node, allowDirectives, topLevel, end, afterBlockParse);
		        var directiveStatements = node.directives.map(function (d) {
		          return _this.directiveToStmt(d);
		        });
		        node.body = directiveStatements.concat(node.body);
		        delete node.directives;
		      };
		      _proto.pushClassMethod = function pushClassMethod(classBody, method, isGenerator, isAsync, isConstructor, allowsDirectSuper) {
		        this.parseMethod(method, isGenerator, isAsync, isConstructor, allowsDirectSuper, "ClassMethod", true);
		        if (method.typeParameters) {
		          method.value.typeParameters = method.typeParameters;
		          delete method.typeParameters;
		        }
		        classBody.body.push(method);
		      };
		      _proto.parsePrivateName = function parsePrivateName() {
		        var node = _superClass.prototype.parsePrivateName.call(this);
		        {
		          if (!this.getPluginOption("estree", "classFeatures")) {
		            return node;
		          }
		        }
		        return this.convertPrivateNameToPrivateIdentifier(node);
		      };
		      _proto.convertPrivateNameToPrivateIdentifier = function convertPrivateNameToPrivateIdentifier(node) {
		        var name = _superClass.prototype.getPrivateNameSV.call(this, node);
		        node = node;
		        delete node.id;
		        node.name = name;
		        node.type = "PrivateIdentifier";
		        return node;
		      };
		      _proto.isPrivateName = function isPrivateName(node) {
		        {
		          if (!this.getPluginOption("estree", "classFeatures")) {
		            return _superClass.prototype.isPrivateName.call(this, node);
		          }
		        }
		        return node.type === "PrivateIdentifier";
		      };
		      _proto.getPrivateNameSV = function getPrivateNameSV(node) {
		        {
		          if (!this.getPluginOption("estree", "classFeatures")) {
		            return _superClass.prototype.getPrivateNameSV.call(this, node);
		          }
		        }
		        return node.name;
		      };
		      _proto.parseLiteral = function parseLiteral(value, type) {
		        var node = _superClass.prototype.parseLiteral.call(this, value, type);
		        node.raw = node.extra.raw;
		        delete node.extra;
		        return node;
		      };
		      _proto.parseFunctionBody = function parseFunctionBody(node, allowExpression, isMethod) {
		        if (isMethod === void 0) {
		          isMethod = false;
		        }
		        _superClass.prototype.parseFunctionBody.call(this, node, allowExpression, isMethod);
		        node.expression = node.body.type !== "BlockStatement";
		      };
		      _proto.parseMethod = function parseMethod(node, isGenerator, isAsync, isConstructor, allowDirectSuper, type, inClassScope) {
		        if (inClassScope === void 0) {
		          inClassScope = false;
		        }
		        var funcNode = this.startNode();
		        funcNode.kind = node.kind;
		        funcNode = _superClass.prototype.parseMethod.call(this, funcNode, isGenerator, isAsync, isConstructor, allowDirectSuper, type, inClassScope);
		        funcNode.type = "FunctionExpression";
		        delete funcNode.kind;
		        node.value = funcNode;
		        if (type === "ClassPrivateMethod") {
		          node.computed = false;
		        }
		        return this.finishNode(node, "MethodDefinition");
		      };
		      _proto.nameIsConstructor = function nameIsConstructor(key) {
		        if (key.type === "Literal") return key.value === "constructor";
		        return _superClass.prototype.nameIsConstructor.call(this, key);
		      };
		      _proto.parseClassProperty = function parseClassProperty() {
		        var _superClass$prototype;
		        for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
		          args[_key] = arguments[_key];
		        }
		        var propertyNode = (_superClass$prototype = _superClass.prototype.parseClassProperty).call.apply(_superClass$prototype, [this].concat(args));
		        {
		          if (!this.getPluginOption("estree", "classFeatures")) {
		            return propertyNode;
		          }
		        }
		        propertyNode.type = "PropertyDefinition";
		        return propertyNode;
		      };
		      _proto.parseClassPrivateProperty = function parseClassPrivateProperty() {
		        var _superClass$prototype2;
		        for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
		          args[_key2] = arguments[_key2];
		        }
		        var propertyNode = (_superClass$prototype2 = _superClass.prototype.parseClassPrivateProperty).call.apply(_superClass$prototype2, [this].concat(args));
		        {
		          if (!this.getPluginOption("estree", "classFeatures")) {
		            return propertyNode;
		          }
		        }
		        propertyNode.type = "PropertyDefinition";
		        propertyNode.computed = false;
		        return propertyNode;
		      };
		      _proto.parseObjectMethod = function parseObjectMethod(prop, isGenerator, isAsync, isPattern, isAccessor) {
		        var node = _superClass.prototype.parseObjectMethod.call(this, prop, isGenerator, isAsync, isPattern, isAccessor);
		        if (node) {
		          node.type = "Property";
		          if (node.kind === "method") {
		            node.kind = "init";
		          }
		          node.shorthand = false;
		        }
		        return node;
		      };
		      _proto.parseObjectProperty = function parseObjectProperty(prop, startLoc, isPattern, refExpressionErrors) {
		        var node = _superClass.prototype.parseObjectProperty.call(this, prop, startLoc, isPattern, refExpressionErrors);
		        if (node) {
		          node.kind = "init";
		          node.type = "Property";
		        }
		        return node;
		      };
		      _proto.isValidLVal = function isValidLVal(type, isUnparenthesizedInAssign, binding) {
		        return type === "Property" ? "value" : _superClass.prototype.isValidLVal.call(this, type, isUnparenthesizedInAssign, binding);
		      };
		      _proto.isAssignable = function isAssignable(node, isBinding) {
		        if (node != null && this.isObjectProperty(node)) {
		          return this.isAssignable(node.value, isBinding);
		        }
		        return _superClass.prototype.isAssignable.call(this, node, isBinding);
		      };
		      _proto.toAssignable = function toAssignable(node, isLHS) {
		        if (isLHS === void 0) {
		          isLHS = false;
		        }
		        if (node != null && this.isObjectProperty(node)) {
		          var key = node.key,
		            value = node.value;
		          if (this.isPrivateName(key)) {
		            this.classScope.usePrivateName(this.getPrivateNameSV(key), key.loc.start);
		          }
		          this.toAssignable(value, isLHS);
		        } else {
		          _superClass.prototype.toAssignable.call(this, node, isLHS);
		        }
		      };
		      _proto.toAssignableObjectExpressionProp = function toAssignableObjectExpressionProp(prop, isLast, isLHS) {
		        if (prop.type === "Property" && (prop.kind === "get" || prop.kind === "set")) {
		          this.raise(Errors.PatternHasAccessor, prop.key);
		        } else if (prop.type === "Property" && prop.method) {
		          this.raise(Errors.PatternHasMethod, prop.key);
		        } else {
		          _superClass.prototype.toAssignableObjectExpressionProp.call(this, prop, isLast, isLHS);
		        }
		      };
		      _proto.finishCallExpression = function finishCallExpression(unfinished, optional) {
		        var node = _superClass.prototype.finishCallExpression.call(this, unfinished, optional);
		        if (node.callee.type === "Import") {
		          node.type = "ImportExpression";
		          node.source = node.arguments[0];
		          if (this.hasPlugin("importAttributes") || this.hasPlugin("importAssertions")) {
		            var _ref2, _ref3;
		            node.options = (_ref2 = node.arguments[1]) != null ? _ref2 : null;
		            node.attributes = (_ref3 = node.arguments[1]) != null ? _ref3 : null;
		          }
		          delete node.arguments;
		          delete node.callee;
		        }
		        return node;
		      };
		      _proto.toReferencedArguments = function toReferencedArguments(node) {
		        if (node.type === "ImportExpression") {
		          return;
		        }
		        _superClass.prototype.toReferencedArguments.call(this, node);
		      };
		      _proto.parseExport = function parseExport(unfinished, decorators) {
		        var exportStartLoc = this.state.lastTokStartLoc;
		        var node = _superClass.prototype.parseExport.call(this, unfinished, decorators);
		        switch (node.type) {
		          case "ExportAllDeclaration":
		            node.exported = null;
		            break;
		          case "ExportNamedDeclaration":
		            if (node.specifiers.length === 1 && node.specifiers[0].type === "ExportNamespaceSpecifier") {
		              node.type = "ExportAllDeclaration";
		              node.exported = node.specifiers[0].exported;
		              delete node.specifiers;
		            }
		          case "ExportDefaultDeclaration":
		            {
		              var _declaration$decorato;
		              var declaration = node.declaration;
		              if ((declaration == null ? void 0 : declaration.type) === "ClassDeclaration" && ((_declaration$decorato = declaration.decorators) == null ? void 0 : _declaration$decorato.length) > 0 && declaration.start === node.start) {
		                this.resetStartLocation(node, exportStartLoc);
		              }
		            }
		            break;
		        }
		        return node;
		      };
		      _proto.parseSubscript = function parseSubscript(base, startLoc, noCalls, state) {
		        var node = _superClass.prototype.parseSubscript.call(this, base, startLoc, noCalls, state);
		        if (state.optionalChainMember) {
		          if (node.type === "OptionalMemberExpression" || node.type === "OptionalCallExpression") {
		            node.type = node.type.substring(8);
		          }
		          if (state.stop) {
		            var chain = this.startNodeAtNode(node);
		            chain.expression = node;
		            return this.finishNode(chain, "ChainExpression");
		          }
		        } else if (node.type === "MemberExpression" || node.type === "CallExpression") {
		          node.optional = false;
		        }
		        return node;
		      };
		      _proto.isOptionalMemberExpression = function isOptionalMemberExpression(node) {
		        if (node.type === "ChainExpression") {
		          return node.expression.type === "MemberExpression";
		        }
		        return _superClass.prototype.isOptionalMemberExpression.call(this, node);
		      };
		      _proto.hasPropertyAsPrivateName = function hasPropertyAsPrivateName(node) {
		        if (node.type === "ChainExpression") {
		          node = node.expression;
		        }
		        return _superClass.prototype.hasPropertyAsPrivateName.call(this, node);
		      };
		      _proto.isObjectProperty = function isObjectProperty(node) {
		        return node.type === "Property" && node.kind === "init" && !node.method;
		      };
		      _proto.isObjectMethod = function isObjectMethod(node) {
		        return node.type === "Property" && (node.method || node.kind === "get" || node.kind === "set");
		      };
		      _proto.finishNodeAt = function finishNodeAt(node, type, endLoc) {
		        return toESTreeLocation(_superClass.prototype.finishNodeAt.call(this, node, type, endLoc));
		      };
		      _proto.resetStartLocation = function resetStartLocation(node, startLoc) {
		        _superClass.prototype.resetStartLocation.call(this, node, startLoc);
		        toESTreeLocation(node);
		      };
		      _proto.resetEndLocation = function resetEndLocation(node, endLoc) {
		        if (endLoc === void 0) {
		          endLoc = this.state.lastTokEndLoc;
		        }
		        _superClass.prototype.resetEndLocation.call(this, node, endLoc);
		        toESTreeLocation(node);
		      };
		      return _createClass(ESTreeParserMixin);
		    }(superClass);
		  });

		  var TokContext = _createClass(function TokContext(token, preserveSpace) {
		    this.token = void 0;
		    this.preserveSpace = void 0;
		    this.token = token;
		    this.preserveSpace = !!preserveSpace;
		  });
		  var types = {
		    brace: new TokContext("{"),
		    j_oTag: new TokContext("<tag"),
		    j_cTag: new TokContext("</tag"),
		    j_expr: new TokContext("<tag>...</tag>", true)
		  };
		  {
		    types.template = new TokContext("`", true);
		  }

		  var beforeExpr = true;
		  var startsExpr = true;
		  var isLoop = true;
		  var isAssign = true;
		  var prefix = true;
		  var postfix = true;
		  var ExportedTokenType = _createClass(function ExportedTokenType(label, conf) {
		    if (conf === void 0) {
		      conf = {};
		    }
		    this.label = void 0;
		    this.keyword = void 0;
		    this.beforeExpr = void 0;
		    this.startsExpr = void 0;
		    this.rightAssociative = void 0;
		    this.isLoop = void 0;
		    this.isAssign = void 0;
		    this.prefix = void 0;
		    this.postfix = void 0;
		    this.binop = void 0;
		    this.label = label;
		    this.keyword = conf.keyword;
		    this.beforeExpr = !!conf.beforeExpr;
		    this.startsExpr = !!conf.startsExpr;
		    this.rightAssociative = !!conf.rightAssociative;
		    this.isLoop = !!conf.isLoop;
		    this.isAssign = !!conf.isAssign;
		    this.prefix = !!conf.prefix;
		    this.postfix = !!conf.postfix;
		    this.binop = conf.binop != null ? conf.binop : null;
		    {
		      this.updateContext = null;
		    }
		  });
		  var keywords = new Map();
		  function createKeyword(name, options) {
		    if (options === void 0) {
		      options = {};
		    }
		    options.keyword = name;
		    var token = createToken(name, options);
		    keywords.set(name, token);
		    return token;
		  }
		  function createBinop(name, binop) {
		    return createToken(name, {
		      beforeExpr: beforeExpr,
		      binop: binop
		    });
		  }
		  var tokenTypeCounter = -1;
		  var tokenTypes = [];
		  var tokenLabels = [];
		  var tokenBinops = [];
		  var tokenBeforeExprs = [];
		  var tokenStartsExprs = [];
		  var tokenPrefixes = [];
		  function createToken(name, options) {
		    var _options$binop, _options$beforeExpr, _options$startsExpr, _options$prefix;
		    if (options === void 0) {
		      options = {};
		    }
		    ++tokenTypeCounter;
		    tokenLabels.push(name);
		    tokenBinops.push((_options$binop = options.binop) != null ? _options$binop : -1);
		    tokenBeforeExprs.push((_options$beforeExpr = options.beforeExpr) != null ? _options$beforeExpr : false);
		    tokenStartsExprs.push((_options$startsExpr = options.startsExpr) != null ? _options$startsExpr : false);
		    tokenPrefixes.push((_options$prefix = options.prefix) != null ? _options$prefix : false);
		    tokenTypes.push(new ExportedTokenType(name, options));
		    return tokenTypeCounter;
		  }
		  function createKeywordLike(name, options) {
		    var _options$binop2, _options$beforeExpr2, _options$startsExpr2, _options$prefix2;
		    if (options === void 0) {
		      options = {};
		    }
		    ++tokenTypeCounter;
		    keywords.set(name, tokenTypeCounter);
		    tokenLabels.push(name);
		    tokenBinops.push((_options$binop2 = options.binop) != null ? _options$binop2 : -1);
		    tokenBeforeExprs.push((_options$beforeExpr2 = options.beforeExpr) != null ? _options$beforeExpr2 : false);
		    tokenStartsExprs.push((_options$startsExpr2 = options.startsExpr) != null ? _options$startsExpr2 : false);
		    tokenPrefixes.push((_options$prefix2 = options.prefix) != null ? _options$prefix2 : false);
		    tokenTypes.push(new ExportedTokenType("name", options));
		    return tokenTypeCounter;
		  }
		  var tt = {
		    bracketL: createToken("[", {
		      beforeExpr: beforeExpr,
		      startsExpr: startsExpr
		    }),
		    bracketHashL: createToken("#[", {
		      beforeExpr: beforeExpr,
		      startsExpr: startsExpr
		    }),
		    bracketBarL: createToken("[|", {
		      beforeExpr: beforeExpr,
		      startsExpr: startsExpr
		    }),
		    bracketR: createToken("]"),
		    bracketBarR: createToken("|]"),
		    braceL: createToken("{", {
		      beforeExpr: beforeExpr,
		      startsExpr: startsExpr
		    }),
		    braceBarL: createToken("{|", {
		      beforeExpr: beforeExpr,
		      startsExpr: startsExpr
		    }),
		    braceHashL: createToken("#{", {
		      beforeExpr: beforeExpr,
		      startsExpr: startsExpr
		    }),
		    braceR: createToken("}"),
		    braceBarR: createToken("|}"),
		    parenL: createToken("(", {
		      beforeExpr: beforeExpr,
		      startsExpr: startsExpr
		    }),
		    parenR: createToken(")"),
		    comma: createToken(",", {
		      beforeExpr: beforeExpr
		    }),
		    semi: createToken(";", {
		      beforeExpr: beforeExpr
		    }),
		    colon: createToken(":", {
		      beforeExpr: beforeExpr
		    }),
		    doubleColon: createToken("::", {
		      beforeExpr: beforeExpr
		    }),
		    dot: createToken("."),
		    question: createToken("?", {
		      beforeExpr: beforeExpr
		    }),
		    questionDot: createToken("?."),
		    arrow: createToken("=>", {
		      beforeExpr: beforeExpr
		    }),
		    template: createToken("template"),
		    ellipsis: createToken("...", {
		      beforeExpr: beforeExpr
		    }),
		    backQuote: createToken("`", {
		      startsExpr: startsExpr
		    }),
		    dollarBraceL: createToken("${", {
		      beforeExpr: beforeExpr,
		      startsExpr: startsExpr
		    }),
		    templateTail: createToken("...`", {
		      startsExpr: startsExpr
		    }),
		    templateNonTail: createToken("...${", {
		      beforeExpr: beforeExpr,
		      startsExpr: startsExpr
		    }),
		    at: createToken("@"),
		    hash: createToken("#", {
		      startsExpr: startsExpr
		    }),
		    interpreterDirective: createToken("#!..."),
		    eq: createToken("=", {
		      beforeExpr: beforeExpr,
		      isAssign: isAssign
		    }),
		    assign: createToken("_=", {
		      beforeExpr: beforeExpr,
		      isAssign: isAssign
		    }),
		    slashAssign: createToken("_=", {
		      beforeExpr: beforeExpr,
		      isAssign: isAssign
		    }),
		    xorAssign: createToken("_=", {
		      beforeExpr: beforeExpr,
		      isAssign: isAssign
		    }),
		    moduloAssign: createToken("_=", {
		      beforeExpr: beforeExpr,
		      isAssign: isAssign
		    }),
		    incDec: createToken("++/--", {
		      prefix: prefix,
		      postfix: postfix,
		      startsExpr: startsExpr
		    }),
		    bang: createToken("!", {
		      beforeExpr: beforeExpr,
		      prefix: prefix,
		      startsExpr: startsExpr
		    }),
		    tilde: createToken("~", {
		      beforeExpr: beforeExpr,
		      prefix: prefix,
		      startsExpr: startsExpr
		    }),
		    doubleCaret: createToken("^^", {
		      startsExpr: startsExpr
		    }),
		    doubleAt: createToken("@@", {
		      startsExpr: startsExpr
		    }),
		    pipeline: createBinop("|>", 0),
		    nullishCoalescing: createBinop("??", 1),
		    logicalOR: createBinop("||", 1),
		    logicalAND: createBinop("&&", 2),
		    bitwiseOR: createBinop("|", 3),
		    bitwiseXOR: createBinop("^", 4),
		    bitwiseAND: createBinop("&", 5),
		    equality: createBinop("==/!=/===/!==", 6),
		    lt: createBinop("</>/<=/>=", 7),
		    gt: createBinop("</>/<=/>=", 7),
		    relational: createBinop("</>/<=/>=", 7),
		    bitShift: createBinop("<</>>/>>>", 8),
		    bitShiftL: createBinop("<</>>/>>>", 8),
		    bitShiftR: createBinop("<</>>/>>>", 8),
		    plusMin: createToken("+/-", {
		      beforeExpr: beforeExpr,
		      binop: 9,
		      prefix: prefix,
		      startsExpr: startsExpr
		    }),
		    modulo: createToken("%", {
		      binop: 10,
		      startsExpr: startsExpr
		    }),
		    star: createToken("*", {
		      binop: 10
		    }),
		    slash: createBinop("/", 10),
		    exponent: createToken("**", {
		      beforeExpr: beforeExpr,
		      binop: 11,
		      rightAssociative: true
		    }),
		    _in: createKeyword("in", {
		      beforeExpr: beforeExpr,
		      binop: 7
		    }),
		    _instanceof: createKeyword("instanceof", {
		      beforeExpr: beforeExpr,
		      binop: 7
		    }),
		    _break: createKeyword("break"),
		    _case: createKeyword("case", {
		      beforeExpr: beforeExpr
		    }),
		    _catch: createKeyword("catch"),
		    _continue: createKeyword("continue"),
		    _debugger: createKeyword("debugger"),
		    _default: createKeyword("default", {
		      beforeExpr: beforeExpr
		    }),
		    _else: createKeyword("else", {
		      beforeExpr: beforeExpr
		    }),
		    _finally: createKeyword("finally"),
		    _function: createKeyword("function", {
		      startsExpr: startsExpr
		    }),
		    _if: createKeyword("if"),
		    _return: createKeyword("return", {
		      beforeExpr: beforeExpr
		    }),
		    _switch: createKeyword("switch"),
		    _throw: createKeyword("throw", {
		      beforeExpr: beforeExpr,
		      prefix: prefix,
		      startsExpr: startsExpr
		    }),
		    _try: createKeyword("try"),
		    _var: createKeyword("var"),
		    _const: createKeyword("const"),
		    _with: createKeyword("with"),
		    _new: createKeyword("new", {
		      beforeExpr: beforeExpr,
		      startsExpr: startsExpr
		    }),
		    _this: createKeyword("this", {
		      startsExpr: startsExpr
		    }),
		    _super: createKeyword("super", {
		      startsExpr: startsExpr
		    }),
		    _class: createKeyword("class", {
		      startsExpr: startsExpr
		    }),
		    _extends: createKeyword("extends", {
		      beforeExpr: beforeExpr
		    }),
		    _export: createKeyword("export"),
		    _import: createKeyword("import", {
		      startsExpr: startsExpr
		    }),
		    _null: createKeyword("null", {
		      startsExpr: startsExpr
		    }),
		    _true: createKeyword("true", {
		      startsExpr: startsExpr
		    }),
		    _false: createKeyword("false", {
		      startsExpr: startsExpr
		    }),
		    _typeof: createKeyword("typeof", {
		      beforeExpr: beforeExpr,
		      prefix: prefix,
		      startsExpr: startsExpr
		    }),
		    _void: createKeyword("void", {
		      beforeExpr: beforeExpr,
		      prefix: prefix,
		      startsExpr: startsExpr
		    }),
		    _delete: createKeyword("delete", {
		      beforeExpr: beforeExpr,
		      prefix: prefix,
		      startsExpr: startsExpr
		    }),
		    _do: createKeyword("do", {
		      isLoop: isLoop,
		      beforeExpr: beforeExpr
		    }),
		    _for: createKeyword("for", {
		      isLoop: isLoop
		    }),
		    _while: createKeyword("while", {
		      isLoop: isLoop
		    }),
		    _as: createKeywordLike("as", {
		      startsExpr: startsExpr
		    }),
		    _assert: createKeywordLike("assert", {
		      startsExpr: startsExpr
		    }),
		    _async: createKeywordLike("async", {
		      startsExpr: startsExpr
		    }),
		    _await: createKeywordLike("await", {
		      startsExpr: startsExpr
		    }),
		    _defer: createKeywordLike("defer", {
		      startsExpr: startsExpr
		    }),
		    _from: createKeywordLike("from", {
		      startsExpr: startsExpr
		    }),
		    _get: createKeywordLike("get", {
		      startsExpr: startsExpr
		    }),
		    _let: createKeywordLike("let", {
		      startsExpr: startsExpr
		    }),
		    _meta: createKeywordLike("meta", {
		      startsExpr: startsExpr
		    }),
		    _of: createKeywordLike("of", {
		      startsExpr: startsExpr
		    }),
		    _sent: createKeywordLike("sent", {
		      startsExpr: startsExpr
		    }),
		    _set: createKeywordLike("set", {
		      startsExpr: startsExpr
		    }),
		    _source: createKeywordLike("source", {
		      startsExpr: startsExpr
		    }),
		    _static: createKeywordLike("static", {
		      startsExpr: startsExpr
		    }),
		    _using: createKeywordLike("using", {
		      startsExpr: startsExpr
		    }),
		    _yield: createKeywordLike("yield", {
		      startsExpr: startsExpr
		    }),
		    _asserts: createKeywordLike("asserts", {
		      startsExpr: startsExpr
		    }),
		    _checks: createKeywordLike("checks", {
		      startsExpr: startsExpr
		    }),
		    _exports: createKeywordLike("exports", {
		      startsExpr: startsExpr
		    }),
		    _global: createKeywordLike("global", {
		      startsExpr: startsExpr
		    }),
		    _implements: createKeywordLike("implements", {
		      startsExpr: startsExpr
		    }),
		    _intrinsic: createKeywordLike("intrinsic", {
		      startsExpr: startsExpr
		    }),
		    _infer: createKeywordLike("infer", {
		      startsExpr: startsExpr
		    }),
		    _is: createKeywordLike("is", {
		      startsExpr: startsExpr
		    }),
		    _mixins: createKeywordLike("mixins", {
		      startsExpr: startsExpr
		    }),
		    _proto: createKeywordLike("proto", {
		      startsExpr: startsExpr
		    }),
		    _require: createKeywordLike("require", {
		      startsExpr: startsExpr
		    }),
		    _satisfies: createKeywordLike("satisfies", {
		      startsExpr: startsExpr
		    }),
		    _keyof: createKeywordLike("keyof", {
		      startsExpr: startsExpr
		    }),
		    _readonly: createKeywordLike("readonly", {
		      startsExpr: startsExpr
		    }),
		    _unique: createKeywordLike("unique", {
		      startsExpr: startsExpr
		    }),
		    _abstract: createKeywordLike("abstract", {
		      startsExpr: startsExpr
		    }),
		    _declare: createKeywordLike("declare", {
		      startsExpr: startsExpr
		    }),
		    _enum: createKeywordLike("enum", {
		      startsExpr: startsExpr
		    }),
		    _module: createKeywordLike("module", {
		      startsExpr: startsExpr
		    }),
		    _namespace: createKeywordLike("namespace", {
		      startsExpr: startsExpr
		    }),
		    _interface: createKeywordLike("interface", {
		      startsExpr: startsExpr
		    }),
		    _type: createKeywordLike("type", {
		      startsExpr: startsExpr
		    }),
		    _opaque: createKeywordLike("opaque", {
		      startsExpr: startsExpr
		    }),
		    name: createToken("name", {
		      startsExpr: startsExpr
		    }),
		    string: createToken("string", {
		      startsExpr: startsExpr
		    }),
		    num: createToken("num", {
		      startsExpr: startsExpr
		    }),
		    bigint: createToken("bigint", {
		      startsExpr: startsExpr
		    }),
		    decimal: createToken("decimal", {
		      startsExpr: startsExpr
		    }),
		    regexp: createToken("regexp", {
		      startsExpr: startsExpr
		    }),
		    privateName: createToken("#name", {
		      startsExpr: startsExpr
		    }),
		    eof: createToken("eof"),
		    jsxName: createToken("jsxName"),
		    jsxText: createToken("jsxText", {
		      beforeExpr: true
		    }),
		    jsxTagStart: createToken("jsxTagStart", {
		      startsExpr: true
		    }),
		    jsxTagEnd: createToken("jsxTagEnd"),
		    placeholder: createToken("%%", {
		      startsExpr: true
		    })
		  };
		  function tokenIsIdentifier(token) {
		    return token >= 93 && token <= 132;
		  }
		  function tokenKeywordOrIdentifierIsKeyword(token) {
		    return token <= 92;
		  }
		  function tokenIsKeywordOrIdentifier(token) {
		    return token >= 58 && token <= 132;
		  }
		  function tokenIsLiteralPropertyName(token) {
		    return token >= 58 && token <= 136;
		  }
		  function tokenComesBeforeExpression(token) {
		    return tokenBeforeExprs[token];
		  }
		  function tokenCanStartExpression(token) {
		    return tokenStartsExprs[token];
		  }
		  function tokenIsAssignment(token) {
		    return token >= 29 && token <= 33;
		  }
		  function tokenIsFlowInterfaceOrTypeOrOpaque(token) {
		    return token >= 129 && token <= 131;
		  }
		  function tokenIsLoop(token) {
		    return token >= 90 && token <= 92;
		  }
		  function tokenIsKeyword(token) {
		    return token >= 58 && token <= 92;
		  }
		  function tokenIsOperator(token) {
		    return token >= 39 && token <= 59;
		  }
		  function tokenIsPostfix(token) {
		    return token === 34;
		  }
		  function tokenIsPrefix(token) {
		    return tokenPrefixes[token];
		  }
		  function tokenIsTSTypeOperator(token) {
		    return token >= 121 && token <= 123;
		  }
		  function tokenIsTSDeclarationStart(token) {
		    return token >= 124 && token <= 130;
		  }
		  function tokenLabelName(token) {
		    return tokenLabels[token];
		  }
		  function tokenOperatorPrecedence(token) {
		    return tokenBinops[token];
		  }
		  function tokenIsRightAssociative(token) {
		    return token === 57;
		  }
		  function tokenIsTemplate(token) {
		    return token >= 24 && token <= 25;
		  }
		  function getExportedToken(token) {
		    return tokenTypes[token];
		  }
		  {
		    tokenTypes[8].updateContext = function (context) {
		      context.pop();
		    };
		    tokenTypes[5].updateContext = tokenTypes[7].updateContext = tokenTypes[23].updateContext = function (context) {
		      context.push(types.brace);
		    };
		    tokenTypes[22].updateContext = function (context) {
		      if (context[context.length - 1] === types.template) {
		        context.pop();
		      } else {
		        context.push(types.template);
		      }
		    };
		    tokenTypes[142].updateContext = function (context) {
		      context.push(types.j_expr, types.j_oTag);
		    };
		  }

		  function isIteratorStart(current, next, next2) {
		    return current === 64 && next === 64 && isIdentifierStart(next2);
		  }
		  var reservedWordLikeSet = new Set(["break", "case", "catch", "continue", "debugger", "default", "do", "else", "finally", "for", "function", "if", "return", "switch", "throw", "try", "var", "const", "while", "with", "new", "this", "super", "class", "extends", "export", "import", "null", "true", "false", "in", "instanceof", "typeof", "void", "delete", "implements", "interface", "let", "package", "private", "protected", "public", "static", "yield", "eval", "arguments", "enum", "await"]);
		  function canBeReservedWord(word) {
		    return reservedWordLikeSet.has(word);
		  }

		  var ScopeFlag = {
		    OTHER: 0,
		    PROGRAM: 1,
		    FUNCTION: 2,
		    ARROW: 4,
		    SIMPLE_CATCH: 8,
		    SUPER: 16,
		    DIRECT_SUPER: 32,
		    CLASS: 64,
		    STATIC_BLOCK: 128,
		    TS_MODULE: 256,
		    VAR: 387
		  };
		  var BindingFlag = {
		    KIND_VALUE: 1,
		    KIND_TYPE: 2,
		    SCOPE_VAR: 4,
		    SCOPE_LEXICAL: 8,
		    SCOPE_FUNCTION: 16,
		    SCOPE_OUTSIDE: 32,
		    FLAG_NONE: 64,
		    FLAG_CLASS: 128,
		    FLAG_TS_ENUM: 256,
		    FLAG_TS_CONST_ENUM: 512,
		    FLAG_TS_EXPORT_ONLY: 1024,
		    FLAG_FLOW_DECLARE_FN: 2048,
		    FLAG_TS_IMPORT: 4096,
		    FLAG_NO_LET_IN_LEXICAL: 8192,
		    TYPE_CLASS: 8331,
		    TYPE_LEXICAL: 8201,
		    TYPE_CATCH_PARAM: 9,
		    TYPE_VAR: 5,
		    TYPE_FUNCTION: 17,
		    TYPE_TS_INTERFACE: 130,
		    TYPE_TS_TYPE: 2,
		    TYPE_TS_ENUM: 8459,
		    TYPE_TS_AMBIENT: 1024,
		    TYPE_NONE: 64,
		    TYPE_OUTSIDE: 65,
		    TYPE_TS_CONST_ENUM: 8971,
		    TYPE_TS_NAMESPACE: 1024,
		    TYPE_TS_TYPE_IMPORT: 4098,
		    TYPE_TS_VALUE_IMPORT: 4096,
		    TYPE_FLOW_DECLARE_FN: 2048
		  };
		  var ClassElementType = {
		    OTHER: 0,
		    FLAG_STATIC: 4,
		    KIND_GETTER: 2,
		    KIND_SETTER: 1,
		    KIND_ACCESSOR: 3,
		    STATIC_GETTER: 6,
		    STATIC_SETTER: 5,
		    INSTANCE_GETTER: 2,
		    INSTANCE_SETTER: 1
		  };

		  var NameType = {
		    Var: 1,
		    Lexical: 2,
		    Function: 4
		  };
		  var Scope = _createClass(function Scope(flags) {
		    this.flags = 0;
		    this.names = new Map();
		    this.firstLexicalName = "";
		    this.flags = flags;
		  });
		  var ScopeHandler = function () {
		    function ScopeHandler(parser, inModule) {
		      this.parser = void 0;
		      this.scopeStack = [];
		      this.inModule = void 0;
		      this.undefinedExports = new Map();
		      this.parser = parser;
		      this.inModule = inModule;
		    }
		    var _proto = ScopeHandler.prototype;
		    _proto.createScope = function createScope(flags) {
		      return new Scope(flags);
		    };
		    _proto.enter = function enter(flags) {
		      this.scopeStack.push(this.createScope(flags));
		    };
		    _proto.exit = function exit() {
		      var scope = this.scopeStack.pop();
		      return scope.flags;
		    };
		    _proto.treatFunctionsAsVarInScope = function treatFunctionsAsVarInScope(scope) {
		      return !!(scope.flags & (ScopeFlag.FUNCTION | ScopeFlag.STATIC_BLOCK) || !this.parser.inModule && scope.flags & ScopeFlag.PROGRAM);
		    };
		    _proto.declareName = function declareName(name, bindingType, loc) {
		      var scope = this.currentScope();
		      if (bindingType & BindingFlag.SCOPE_LEXICAL || bindingType & BindingFlag.SCOPE_FUNCTION) {
		        this.checkRedeclarationInScope(scope, name, bindingType, loc);
		        var type = scope.names.get(name) || 0;
		        if (bindingType & BindingFlag.SCOPE_FUNCTION) {
		          type = type | NameType.Function;
		        } else {
		          if (!scope.firstLexicalName) {
		            scope.firstLexicalName = name;
		          }
		          type = type | NameType.Lexical;
		        }
		        scope.names.set(name, type);
		        if (bindingType & BindingFlag.SCOPE_LEXICAL) {
		          this.maybeExportDefined(scope, name);
		        }
		      } else if (bindingType & BindingFlag.SCOPE_VAR) {
		        for (var i = this.scopeStack.length - 1; i >= 0; --i) {
		          scope = this.scopeStack[i];
		          this.checkRedeclarationInScope(scope, name, bindingType, loc);
		          scope.names.set(name, (scope.names.get(name) || 0) | NameType.Var);
		          this.maybeExportDefined(scope, name);
		          if (scope.flags & ScopeFlag.VAR) break;
		        }
		      }
		      if (this.parser.inModule && scope.flags & ScopeFlag.PROGRAM) {
		        this.undefinedExports["delete"](name);
		      }
		    };
		    _proto.maybeExportDefined = function maybeExportDefined(scope, name) {
		      if (this.parser.inModule && scope.flags & ScopeFlag.PROGRAM) {
		        this.undefinedExports["delete"](name);
		      }
		    };
		    _proto.checkRedeclarationInScope = function checkRedeclarationInScope(scope, name, bindingType, loc) {
		      if (this.isRedeclaredInScope(scope, name, bindingType)) {
		        this.parser.raise(Errors.VarRedeclaration, loc, {
		          identifierName: name
		        });
		      }
		    };
		    _proto.isRedeclaredInScope = function isRedeclaredInScope(scope, name, bindingType) {
		      if (!(bindingType & BindingFlag.KIND_VALUE)) return false;
		      if (bindingType & BindingFlag.SCOPE_LEXICAL) {
		        return scope.names.has(name);
		      }
		      var type = scope.names.get(name);
		      if (bindingType & BindingFlag.SCOPE_FUNCTION) {
		        return (type & NameType.Lexical) > 0 || !this.treatFunctionsAsVarInScope(scope) && (type & NameType.Var) > 0;
		      }
		      return (type & NameType.Lexical) > 0 && !(scope.flags & ScopeFlag.SIMPLE_CATCH && scope.firstLexicalName === name) || !this.treatFunctionsAsVarInScope(scope) && (type & NameType.Function) > 0;
		    };
		    _proto.checkLocalExport = function checkLocalExport(id) {
		      var name = id.name;
		      var topLevelScope = this.scopeStack[0];
		      if (!topLevelScope.names.has(name)) {
		        this.undefinedExports.set(name, id.loc.start);
		      }
		    };
		    _proto.currentScope = function currentScope() {
		      return this.scopeStack[this.scopeStack.length - 1];
		    };
		    _proto.currentVarScopeFlags = function currentVarScopeFlags() {
		      for (var i = this.scopeStack.length - 1;; i--) {
		        var flags = this.scopeStack[i].flags;
		        if (flags & ScopeFlag.VAR) {
		          return flags;
		        }
		      }
		    };
		    _proto.currentThisScopeFlags = function currentThisScopeFlags() {
		      for (var i = this.scopeStack.length - 1;; i--) {
		        var flags = this.scopeStack[i].flags;
		        if (flags & (ScopeFlag.VAR | ScopeFlag.CLASS) && !(flags & ScopeFlag.ARROW)) {
		          return flags;
		        }
		      }
		    };
		    return _createClass(ScopeHandler, [{
		      key: "inTopLevel",
		      get: function get() {
		        return (this.currentScope().flags & ScopeFlag.PROGRAM) > 0;
		      }
		    }, {
		      key: "inFunction",
		      get: function get() {
		        return (this.currentVarScopeFlags() & ScopeFlag.FUNCTION) > 0;
		      }
		    }, {
		      key: "allowSuper",
		      get: function get() {
		        return (this.currentThisScopeFlags() & ScopeFlag.SUPER) > 0;
		      }
		    }, {
		      key: "allowDirectSuper",
		      get: function get() {
		        return (this.currentThisScopeFlags() & ScopeFlag.DIRECT_SUPER) > 0;
		      }
		    }, {
		      key: "inClass",
		      get: function get() {
		        return (this.currentThisScopeFlags() & ScopeFlag.CLASS) > 0;
		      }
		    }, {
		      key: "inClassAndNotInNonArrowFunction",
		      get: function get() {
		        var flags = this.currentThisScopeFlags();
		        return (flags & ScopeFlag.CLASS) > 0 && (flags & ScopeFlag.FUNCTION) === 0;
		      }
		    }, {
		      key: "inStaticBlock",
		      get: function get() {
		        for (var i = this.scopeStack.length - 1;; i--) {
		          var flags = this.scopeStack[i].flags;
		          if (flags & ScopeFlag.STATIC_BLOCK) {
		            return true;
		          }
		          if (flags & (ScopeFlag.VAR | ScopeFlag.CLASS)) {
		            return false;
		          }
		        }
		      }
		    }, {
		      key: "inNonArrowFunction",
		      get: function get() {
		        return (this.currentThisScopeFlags() & ScopeFlag.FUNCTION) > 0;
		      }
		    }, {
		      key: "treatFunctionsAsVar",
		      get: function get() {
		        return this.treatFunctionsAsVarInScope(this.currentScope());
		      }
		    }]);
		  }();

		  var FlowScope = function (_Scope) {
		    function FlowScope() {
		      var _this;
		      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
		        args[_key] = arguments[_key];
		      }
		      _this = _Scope.call.apply(_Scope, [this].concat(args)) || this;
		      _this.declareFunctions = new Set();
		      return _this;
		    }
		    _inherits(FlowScope, _Scope);
		    return _createClass(FlowScope);
		  }(Scope);
		  var FlowScopeHandler = function (_ScopeHandler) {
		    function FlowScopeHandler() {
		      return _ScopeHandler.apply(this, arguments) || this;
		    }
		    _inherits(FlowScopeHandler, _ScopeHandler);
		    var _proto = FlowScopeHandler.prototype;
		    _proto.createScope = function createScope(flags) {
		      return new FlowScope(flags);
		    };
		    _proto.declareName = function declareName(name, bindingType, loc) {
		      var scope = this.currentScope();
		      if (bindingType & BindingFlag.FLAG_FLOW_DECLARE_FN) {
		        this.checkRedeclarationInScope(scope, name, bindingType, loc);
		        this.maybeExportDefined(scope, name);
		        scope.declareFunctions.add(name);
		        return;
		      }
		      _ScopeHandler.prototype.declareName.call(this, name, bindingType, loc);
		    };
		    _proto.isRedeclaredInScope = function isRedeclaredInScope(scope, name, bindingType) {
		      if (_ScopeHandler.prototype.isRedeclaredInScope.call(this, scope, name, bindingType)) return true;
		      if (bindingType & BindingFlag.FLAG_FLOW_DECLARE_FN && !scope.declareFunctions.has(name)) {
		        var type = scope.names.get(name);
		        return (type & NameType.Function) > 0 || (type & NameType.Lexical) > 0;
		      }
		      return false;
		    };
		    _proto.checkLocalExport = function checkLocalExport(id) {
		      if (!this.scopeStack[0].declareFunctions.has(id.name)) {
		        _ScopeHandler.prototype.checkLocalExport.call(this, id);
		      }
		    };
		    return _createClass(FlowScopeHandler);
		  }(ScopeHandler);

		  var BaseParser = function () {
		    function BaseParser() {
		      this.sawUnambiguousESM = false;
		      this.ambiguousScriptDifferentAst = false;
		    }
		    var _proto = BaseParser.prototype;
		    _proto.hasPlugin = function hasPlugin(pluginConfig) {
		      if (typeof pluginConfig === "string") {
		        return this.plugins.has(pluginConfig);
		      } else {
		        var pluginName = pluginConfig[0],
		          pluginOptions = pluginConfig[1];
		        if (!this.hasPlugin(pluginName)) {
		          return false;
		        }
		        var actualOptions = this.plugins.get(pluginName);
		        for (var _i2 = 0, _Object$keys2 = Object.keys(pluginOptions); _i2 < _Object$keys2.length; _i2++) {
		          var key = _Object$keys2[_i2];
		          if ((actualOptions == null ? void 0 : actualOptions[key]) !== pluginOptions[key]) {
		            return false;
		          }
		        }
		        return true;
		      }
		    };
		    _proto.getPluginOption = function getPluginOption(plugin, name) {
		      var _this$plugins$get;
		      return (_this$plugins$get = this.plugins.get(plugin)) == null ? void 0 : _this$plugins$get[name];
		    };
		    return _createClass(BaseParser);
		  }();

		  function setTrailingComments(node, comments) {
		    if (node.trailingComments === undefined) {
		      node.trailingComments = comments;
		    } else {
		      var _node$trailingComment;
		      (_node$trailingComment = node.trailingComments).unshift.apply(_node$trailingComment, comments);
		    }
		  }
		  function setLeadingComments(node, comments) {
		    if (node.leadingComments === undefined) {
		      node.leadingComments = comments;
		    } else {
		      var _node$leadingComments;
		      (_node$leadingComments = node.leadingComments).unshift.apply(_node$leadingComments, comments);
		    }
		  }
		  function setInnerComments(node, comments) {
		    if (node.innerComments === undefined) {
		      node.innerComments = comments;
		    } else {
		      var _node$innerComments;
		      (_node$innerComments = node.innerComments).unshift.apply(_node$innerComments, comments);
		    }
		  }
		  function adjustInnerComments(node, elements, commentWS) {
		    var lastElement = null;
		    var i = elements.length;
		    while (lastElement === null && i > 0) {
		      lastElement = elements[--i];
		    }
		    if (lastElement === null || lastElement.start > commentWS.start) {
		      setInnerComments(node, commentWS.comments);
		    } else {
		      setTrailingComments(lastElement, commentWS.comments);
		    }
		  }
		  var CommentsParser = function (_BaseParser) {
		    function CommentsParser() {
		      return _BaseParser.apply(this, arguments) || this;
		    }
		    _inherits(CommentsParser, _BaseParser);
		    var _proto = CommentsParser.prototype;
		    _proto.addComment = function addComment(comment) {
		      if (this.filename) comment.loc.filename = this.filename;
		      var commentsLen = this.state.commentsLen;
		      if (this.comments.length !== commentsLen) {
		        this.comments.length = commentsLen;
		      }
		      this.comments.push(comment);
		      this.state.commentsLen++;
		    };
		    _proto.processComment = function processComment(node) {
		      var commentStack = this.state.commentStack;
		      var commentStackLength = commentStack.length;
		      if (commentStackLength === 0) return;
		      var i = commentStackLength - 1;
		      var lastCommentWS = commentStack[i];
		      if (lastCommentWS.start === node.end) {
		        lastCommentWS.leadingNode = node;
		        i--;
		      }
		      var nodeStart = node.start;
		      for (; i >= 0; i--) {
		        var commentWS = commentStack[i];
		        var commentEnd = commentWS.end;
		        if (commentEnd > nodeStart) {
		          commentWS.containingNode = node;
		          this.finalizeComment(commentWS);
		          commentStack.splice(i, 1);
		        } else {
		          if (commentEnd === nodeStart) {
		            commentWS.trailingNode = node;
		          }
		          break;
		        }
		      }
		    };
		    _proto.finalizeComment = function finalizeComment(commentWS) {
		      var comments = commentWS.comments;
		      if (commentWS.leadingNode !== null || commentWS.trailingNode !== null) {
		        if (commentWS.leadingNode !== null) {
		          setTrailingComments(commentWS.leadingNode, comments);
		        }
		        if (commentWS.trailingNode !== null) {
		          setLeadingComments(commentWS.trailingNode, comments);
		        }
		      } else {
		        var node = commentWS.containingNode,
		          commentStart = commentWS.start;
		        if (this.input.charCodeAt(commentStart - 1) === 44) {
		          switch (node.type) {
		            case "ObjectExpression":
		            case "ObjectPattern":
		            case "RecordExpression":
		              adjustInnerComments(node, node.properties, commentWS);
		              break;
		            case "CallExpression":
		            case "OptionalCallExpression":
		              adjustInnerComments(node, node.arguments, commentWS);
		              break;
		            case "FunctionDeclaration":
		            case "FunctionExpression":
		            case "ArrowFunctionExpression":
		            case "ObjectMethod":
		            case "ClassMethod":
		            case "ClassPrivateMethod":
		              adjustInnerComments(node, node.params, commentWS);
		              break;
		            case "ArrayExpression":
		            case "ArrayPattern":
		            case "TupleExpression":
		              adjustInnerComments(node, node.elements, commentWS);
		              break;
		            case "ExportNamedDeclaration":
		            case "ImportDeclaration":
		              adjustInnerComments(node, node.specifiers, commentWS);
		              break;
		            default:
		              {
		                setInnerComments(node, comments);
		              }
		          }
		        } else {
		          setInnerComments(node, comments);
		        }
		      }
		    };
		    _proto.finalizeRemainingComments = function finalizeRemainingComments() {
		      var commentStack = this.state.commentStack;
		      for (var i = commentStack.length - 1; i >= 0; i--) {
		        this.finalizeComment(commentStack[i]);
		      }
		      this.state.commentStack = [];
		    };
		    _proto.resetPreviousNodeTrailingComments = function resetPreviousNodeTrailingComments(node) {
		      var commentStack = this.state.commentStack;
		      var length = commentStack.length;
		      if (length === 0) return;
		      var commentWS = commentStack[length - 1];
		      if (commentWS.leadingNode === node) {
		        commentWS.leadingNode = null;
		      }
		    };
		    _proto.resetPreviousIdentifierLeadingComments = function resetPreviousIdentifierLeadingComments(node) {
		      var commentStack = this.state.commentStack;
		      var length = commentStack.length;
		      if (length === 0) return;
		      if (commentStack[length - 1].trailingNode === node) {
		        commentStack[length - 1].trailingNode = null;
		      } else if (length >= 2 && commentStack[length - 2].trailingNode === node) {
		        commentStack[length - 2].trailingNode = null;
		      }
		    };
		    _proto.takeSurroundingComments = function takeSurroundingComments(node, start, end) {
		      var commentStack = this.state.commentStack;
		      var commentStackLength = commentStack.length;
		      if (commentStackLength === 0) return;
		      var i = commentStackLength - 1;
		      for (; i >= 0; i--) {
		        var commentWS = commentStack[i];
		        var commentEnd = commentWS.end;
		        var commentStart = commentWS.start;
		        if (commentStart === end) {
		          commentWS.leadingNode = node;
		        } else if (commentEnd === start) {
		          commentWS.trailingNode = node;
		        } else if (commentEnd < start) {
		          break;
		        }
		      }
		    };
		    return _createClass(CommentsParser);
		  }(BaseParser);

		  var lineBreak = /\r\n?|[\n\u2028\u2029]/;
		  var lineBreakG = new RegExp(lineBreak.source, "g");
		  function isNewLine(code) {
		    switch (code) {
		      case 10:
		      case 13:
		      case 8232:
		      case 8233:
		        return true;
		      default:
		        return false;
		    }
		  }
		  var skipWhiteSpace = /(?:\s|\/\/.*|\/\*[^]*?\*\/)*/g;
		  var skipWhiteSpaceInLine = /(?:[^\S\n\r\u2028\u2029]|\/\/.*|\/\*.*?\*\/)*/g;
		  var skipWhiteSpaceToLineBreak = new RegExp("(?=(" + skipWhiteSpaceInLine.source + "))\\1" + /(?=[\n\r\u2028\u2029]|\/\*(?!.*?\*\/)|$)/.source, "y");
		  function isWhitespace(code) {
		    switch (code) {
		      case 0x0009:
		      case 0x000b:
		      case 0x000c:
		      case 32:
		      case 160:
		      case 5760:
		      case 0x2000:
		      case 0x2001:
		      case 0x2002:
		      case 0x2003:
		      case 0x2004:
		      case 0x2005:
		      case 0x2006:
		      case 0x2007:
		      case 0x2008:
		      case 0x2009:
		      case 0x200a:
		      case 0x202f:
		      case 0x205f:
		      case 0x3000:
		      case 0xfeff:
		        return true;
		      default:
		        return false;
		    }
		  }

		  var LoopLabelKind = {
		    Loop: 1,
		    Switch: 2
		  };
		  var State = function () {
		    function State() {
		      this.flags = 1024;
		      this.curLine = void 0;
		      this.lineStart = void 0;
		      this.startLoc = void 0;
		      this.endLoc = void 0;
		      this.errors = [];
		      this.potentialArrowAt = -1;
		      this.noArrowAt = [];
		      this.noArrowParamsConversionAt = [];
		      this.topicContext = {
		        maxNumOfResolvableTopics: 0,
		        maxTopicIndex: null
		      };
		      this.labels = [];
		      this.commentsLen = 0;
		      this.commentStack = [];
		      this.pos = 0;
		      this.type = 139;
		      this.value = null;
		      this.start = 0;
		      this.end = 0;
		      this.lastTokEndLoc = null;
		      this.lastTokStartLoc = null;
		      this.context = [types.brace];
		      this.firstInvalidTemplateEscapePos = null;
		      this.strictErrors = new Map();
		      this.tokensLength = 0;
		    }
		    var _proto = State.prototype;
		    _proto.init = function init(_ref) {
		      var strictMode = _ref.strictMode,
		        sourceType = _ref.sourceType,
		        startLine = _ref.startLine,
		        startColumn = _ref.startColumn;
		      this.strict = strictMode === false ? false : strictMode === true ? true : sourceType === "module";
		      this.curLine = startLine;
		      this.lineStart = -startColumn;
		      this.startLoc = this.endLoc = new Position(startLine, startColumn, 0);
		    };
		    _proto.curPosition = function curPosition() {
		      return new Position(this.curLine, this.pos - this.lineStart, this.pos);
		    };
		    _proto.clone = function clone() {
		      var state = new State();
		      state.flags = this.flags;
		      state.curLine = this.curLine;
		      state.lineStart = this.lineStart;
		      state.startLoc = this.startLoc;
		      state.endLoc = this.endLoc;
		      state.errors = this.errors.slice();
		      state.potentialArrowAt = this.potentialArrowAt;
		      state.noArrowAt = this.noArrowAt.slice();
		      state.noArrowParamsConversionAt = this.noArrowParamsConversionAt.slice();
		      state.topicContext = this.topicContext;
		      state.labels = this.labels.slice();
		      state.commentsLen = this.commentsLen;
		      state.commentStack = this.commentStack.slice();
		      state.pos = this.pos;
		      state.type = this.type;
		      state.value = this.value;
		      state.start = this.start;
		      state.end = this.end;
		      state.lastTokEndLoc = this.lastTokEndLoc;
		      state.lastTokStartLoc = this.lastTokStartLoc;
		      state.context = this.context.slice();
		      state.firstInvalidTemplateEscapePos = this.firstInvalidTemplateEscapePos;
		      state.strictErrors = this.strictErrors;
		      state.tokensLength = this.tokensLength;
		      return state;
		    };
		    return _createClass(State, [{
		      key: "strict",
		      get: function get() {
		        return (this.flags & 1) > 0;
		      },
		      set: function set(value) {
		        if (value) {
		          this.flags |= 1;
		        } else {
		          this.flags &= ~1;
		        }
		      }
		    }, {
		      key: "maybeInArrowParameters",
		      get: function get() {
		        return (this.flags & 2) > 0;
		      },
		      set: function set(value) {
		        if (value) {
		          this.flags |= 2;
		        } else {
		          this.flags &= ~2;
		        }
		      }
		    }, {
		      key: "inType",
		      get: function get() {
		        return (this.flags & 4) > 0;
		      },
		      set: function set(value) {
		        if (value) {
		          this.flags |= 4;
		        } else {
		          this.flags &= ~4;
		        }
		      }
		    }, {
		      key: "noAnonFunctionType",
		      get: function get() {
		        return (this.flags & 8) > 0;
		      },
		      set: function set(value) {
		        if (value) {
		          this.flags |= 8;
		        } else {
		          this.flags &= ~8;
		        }
		      }
		    }, {
		      key: "hasFlowComment",
		      get: function get() {
		        return (this.flags & 16) > 0;
		      },
		      set: function set(value) {
		        if (value) {
		          this.flags |= 16;
		        } else {
		          this.flags &= ~16;
		        }
		      }
		    }, {
		      key: "isAmbientContext",
		      get: function get() {
		        return (this.flags & 32) > 0;
		      },
		      set: function set(value) {
		        if (value) {
		          this.flags |= 32;
		        } else {
		          this.flags &= ~32;
		        }
		      }
		    }, {
		      key: "inAbstractClass",
		      get: function get() {
		        return (this.flags & 64) > 0;
		      },
		      set: function set(value) {
		        if (value) {
		          this.flags |= 64;
		        } else {
		          this.flags &= ~64;
		        }
		      }
		    }, {
		      key: "inDisallowConditionalTypesContext",
		      get: function get() {
		        return (this.flags & 128) > 0;
		      },
		      set: function set(value) {
		        if (value) {
		          this.flags |= 128;
		        } else {
		          this.flags &= ~128;
		        }
		      }
		    }, {
		      key: "soloAwait",
		      get: function get() {
		        return (this.flags & 256) > 0;
		      },
		      set: function set(value) {
		        if (value) {
		          this.flags |= 256;
		        } else {
		          this.flags &= ~256;
		        }
		      }
		    }, {
		      key: "inFSharpPipelineDirectBody",
		      get: function get() {
		        return (this.flags & 512) > 0;
		      },
		      set: function set(value) {
		        if (value) {
		          this.flags |= 512;
		        } else {
		          this.flags &= ~512;
		        }
		      }
		    }, {
		      key: "canStartJSXElement",
		      get: function get() {
		        return (this.flags & 1024) > 0;
		      },
		      set: function set(value) {
		        if (value) {
		          this.flags |= 1024;
		        } else {
		          this.flags &= ~1024;
		        }
		      }
		    }, {
		      key: "containsEsc",
		      get: function get() {
		        return (this.flags & 2048) > 0;
		      },
		      set: function set(value) {
		        if (value) {
		          this.flags |= 2048;
		        } else {
		          this.flags &= ~2048;
		        }
		      }
		    }]);
		  }();

		  function buildPosition(pos, lineStart, curLine) {
		    return new Position(curLine, pos - lineStart, pos);
		  }
		  var VALID_REGEX_FLAGS = new Set([103, 109, 115, 105, 121, 117, 100, 118]);
		  var Token = _createClass(function Token(state) {
		    this.type = state.type;
		    this.value = state.value;
		    this.start = state.start;
		    this.end = state.end;
		    this.loc = new SourceLocation(state.startLoc, state.endLoc);
		  });
		  var Tokenizer = function (_CommentsParser) {
		    function Tokenizer(options, input) {
		      var _this;
		      _this = _CommentsParser.call(this) || this;
		      _this.isLookahead = void 0;
		      _this.tokens = [];
		      _this.errorHandlers_readInt = {
		        invalidDigit: function invalidDigit(pos, lineStart, curLine, radix) {
		          if (!_this.options.errorRecovery) return false;
		          _this.raise(Errors.InvalidDigit, buildPosition(pos, lineStart, curLine), {
		            radix: radix
		          });
		          return true;
		        },
		        numericSeparatorInEscapeSequence: _this.errorBuilder(Errors.NumericSeparatorInEscapeSequence),
		        unexpectedNumericSeparator: _this.errorBuilder(Errors.UnexpectedNumericSeparator)
		      };
		      _this.errorHandlers_readCodePoint = Object.assign({}, _this.errorHandlers_readInt, {
		        invalidEscapeSequence: _this.errorBuilder(Errors.InvalidEscapeSequence),
		        invalidCodePoint: _this.errorBuilder(Errors.InvalidCodePoint)
		      });
		      _this.errorHandlers_readStringContents_string = Object.assign({}, _this.errorHandlers_readCodePoint, {
		        strictNumericEscape: function strictNumericEscape(pos, lineStart, curLine) {
		          _this.recordStrictModeErrors(Errors.StrictNumericEscape, buildPosition(pos, lineStart, curLine));
		        },
		        unterminated: function unterminated(pos, lineStart, curLine) {
		          throw _this.raise(Errors.UnterminatedString, buildPosition(pos - 1, lineStart, curLine));
		        }
		      });
		      _this.errorHandlers_readStringContents_template = Object.assign({}, _this.errorHandlers_readCodePoint, {
		        strictNumericEscape: _this.errorBuilder(Errors.StrictNumericEscape),
		        unterminated: function unterminated(pos, lineStart, curLine) {
		          throw _this.raise(Errors.UnterminatedTemplate, buildPosition(pos, lineStart, curLine));
		        }
		      });
		      _this.state = new State();
		      _this.state.init(options);
		      _this.input = input;
		      _this.length = input.length;
		      _this.comments = [];
		      _this.isLookahead = false;
		      return _this;
		    }
		    _inherits(Tokenizer, _CommentsParser);
		    var _proto = Tokenizer.prototype;
		    _proto.pushToken = function pushToken(token) {
		      this.tokens.length = this.state.tokensLength;
		      this.tokens.push(token);
		      ++this.state.tokensLength;
		    };
		    _proto.next = function next() {
		      this.checkKeywordEscapes();
		      if (this.options.tokens) {
		        this.pushToken(new Token(this.state));
		      }
		      this.state.lastTokEndLoc = this.state.endLoc;
		      this.state.lastTokStartLoc = this.state.startLoc;
		      this.nextToken();
		    };
		    _proto.eat = function eat(type) {
		      if (this.match(type)) {
		        this.next();
		        return true;
		      } else {
		        return false;
		      }
		    };
		    _proto.match = function match(type) {
		      return this.state.type === type;
		    };
		    _proto.createLookaheadState = function createLookaheadState(state) {
		      return {
		        pos: state.pos,
		        value: null,
		        type: state.type,
		        start: state.start,
		        end: state.end,
		        context: [this.curContext()],
		        inType: state.inType,
		        startLoc: state.startLoc,
		        lastTokEndLoc: state.lastTokEndLoc,
		        curLine: state.curLine,
		        lineStart: state.lineStart,
		        curPosition: state.curPosition
		      };
		    };
		    _proto.lookahead = function lookahead() {
		      var old = this.state;
		      this.state = this.createLookaheadState(old);
		      this.isLookahead = true;
		      this.nextToken();
		      this.isLookahead = false;
		      var curr = this.state;
		      this.state = old;
		      return curr;
		    };
		    _proto.nextTokenStart = function nextTokenStart() {
		      return this.nextTokenStartSince(this.state.pos);
		    };
		    _proto.nextTokenStartSince = function nextTokenStartSince(pos) {
		      skipWhiteSpace.lastIndex = pos;
		      return skipWhiteSpace.test(this.input) ? skipWhiteSpace.lastIndex : pos;
		    };
		    _proto.lookaheadCharCode = function lookaheadCharCode() {
		      return this.input.charCodeAt(this.nextTokenStart());
		    };
		    _proto.nextTokenInLineStart = function nextTokenInLineStart() {
		      return this.nextTokenInLineStartSince(this.state.pos);
		    };
		    _proto.nextTokenInLineStartSince = function nextTokenInLineStartSince(pos) {
		      skipWhiteSpaceInLine.lastIndex = pos;
		      return skipWhiteSpaceInLine.test(this.input) ? skipWhiteSpaceInLine.lastIndex : pos;
		    };
		    _proto.lookaheadInLineCharCode = function lookaheadInLineCharCode() {
		      return this.input.charCodeAt(this.nextTokenInLineStart());
		    };
		    _proto.codePointAtPos = function codePointAtPos(pos) {
		      var cp = this.input.charCodeAt(pos);
		      if ((cp & 0xfc00) === 0xd800 && ++pos < this.input.length) {
		        var trail = this.input.charCodeAt(pos);
		        if ((trail & 0xfc00) === 0xdc00) {
		          cp = 0x10000 + ((cp & 0x3ff) << 10) + (trail & 0x3ff);
		        }
		      }
		      return cp;
		    };
		    _proto.setStrict = function setStrict(strict) {
		      var _this2 = this;
		      this.state.strict = strict;
		      if (strict) {
		        this.state.strictErrors.forEach(function (_ref) {
		          var toParseError = _ref[0],
		            at = _ref[1];
		          return _this2.raise(toParseError, at);
		        });
		        this.state.strictErrors.clear();
		      }
		    };
		    _proto.curContext = function curContext() {
		      return this.state.context[this.state.context.length - 1];
		    };
		    _proto.nextToken = function nextToken() {
		      this.skipSpace();
		      this.state.start = this.state.pos;
		      if (!this.isLookahead) this.state.startLoc = this.state.curPosition();
		      if (this.state.pos >= this.length) {
		        this.finishToken(139);
		        return;
		      }
		      this.getTokenFromCode(this.codePointAtPos(this.state.pos));
		    };
		    _proto.skipBlockComment = function skipBlockComment(commentEnd) {
		      var startLoc;
		      if (!this.isLookahead) startLoc = this.state.curPosition();
		      var start = this.state.pos;
		      var end = this.input.indexOf(commentEnd, start + 2);
		      if (end === -1) {
		        throw this.raise(Errors.UnterminatedComment, this.state.curPosition());
		      }
		      this.state.pos = end + commentEnd.length;
		      lineBreakG.lastIndex = start + 2;
		      while (lineBreakG.test(this.input) && lineBreakG.lastIndex <= end) {
		        ++this.state.curLine;
		        this.state.lineStart = lineBreakG.lastIndex;
		      }
		      if (this.isLookahead) return;
		      var comment = {
		        type: "CommentBlock",
		        value: this.input.slice(start + 2, end),
		        start: start,
		        end: end + commentEnd.length,
		        loc: new SourceLocation(startLoc, this.state.curPosition())
		      };
		      if (this.options.tokens) this.pushToken(comment);
		      return comment;
		    };
		    _proto.skipLineComment = function skipLineComment(startSkip) {
		      var start = this.state.pos;
		      var startLoc;
		      if (!this.isLookahead) startLoc = this.state.curPosition();
		      var ch = this.input.charCodeAt(this.state.pos += startSkip);
		      if (this.state.pos < this.length) {
		        while (!isNewLine(ch) && ++this.state.pos < this.length) {
		          ch = this.input.charCodeAt(this.state.pos);
		        }
		      }
		      if (this.isLookahead) return;
		      var end = this.state.pos;
		      var value = this.input.slice(start + startSkip, end);
		      var comment = {
		        type: "CommentLine",
		        value: value,
		        start: start,
		        end: end,
		        loc: new SourceLocation(startLoc, this.state.curPosition())
		      };
		      if (this.options.tokens) this.pushToken(comment);
		      return comment;
		    };
		    _proto.skipSpace = function skipSpace() {
		      var spaceStart = this.state.pos;
		      var comments = [];
		      loop: while (this.state.pos < this.length) {
		        var ch = this.input.charCodeAt(this.state.pos);
		        switch (ch) {
		          case 32:
		          case 160:
		          case 9:
		            ++this.state.pos;
		            break;
		          case 13:
		            if (this.input.charCodeAt(this.state.pos + 1) === 10) {
		              ++this.state.pos;
		            }
		          case 10:
		          case 8232:
		          case 8233:
		            ++this.state.pos;
		            ++this.state.curLine;
		            this.state.lineStart = this.state.pos;
		            break;
		          case 47:
		            switch (this.input.charCodeAt(this.state.pos + 1)) {
		              case 42:
		                {
		                  var comment = this.skipBlockComment("*/");
		                  if (comment !== undefined) {
		                    this.addComment(comment);
		                    if (this.options.attachComment) comments.push(comment);
		                  }
		                  break;
		                }
		              case 47:
		                {
		                  var _comment = this.skipLineComment(2);
		                  if (_comment !== undefined) {
		                    this.addComment(_comment);
		                    if (this.options.attachComment) comments.push(_comment);
		                  }
		                  break;
		                }
		              default:
		                break loop;
		            }
		            break;
		          default:
		            if (isWhitespace(ch)) {
		              ++this.state.pos;
		            } else if (ch === 45 && !this.inModule && this.options.annexB) {
		              var pos = this.state.pos;
		              if (this.input.charCodeAt(pos + 1) === 45 && this.input.charCodeAt(pos + 2) === 62 && (spaceStart === 0 || this.state.lineStart > spaceStart)) {
		                var _comment2 = this.skipLineComment(3);
		                if (_comment2 !== undefined) {
		                  this.addComment(_comment2);
		                  if (this.options.attachComment) comments.push(_comment2);
		                }
		              } else {
		                break loop;
		              }
		            } else if (ch === 60 && !this.inModule && this.options.annexB) {
		              var _pos = this.state.pos;
		              if (this.input.charCodeAt(_pos + 1) === 33 && this.input.charCodeAt(_pos + 2) === 45 && this.input.charCodeAt(_pos + 3) === 45) {
		                var _comment3 = this.skipLineComment(4);
		                if (_comment3 !== undefined) {
		                  this.addComment(_comment3);
		                  if (this.options.attachComment) comments.push(_comment3);
		                }
		              } else {
		                break loop;
		              }
		            } else {
		              break loop;
		            }
		        }
		      }
		      if (comments.length > 0) {
		        var end = this.state.pos;
		        var commentWhitespace = {
		          start: spaceStart,
		          end: end,
		          comments: comments,
		          leadingNode: null,
		          trailingNode: null,
		          containingNode: null
		        };
		        this.state.commentStack.push(commentWhitespace);
		      }
		    };
		    _proto.finishToken = function finishToken(type, val) {
		      this.state.end = this.state.pos;
		      this.state.endLoc = this.state.curPosition();
		      var prevType = this.state.type;
		      this.state.type = type;
		      this.state.value = val;
		      if (!this.isLookahead) {
		        this.updateContext(prevType);
		      }
		    };
		    _proto.replaceToken = function replaceToken(type) {
		      this.state.type = type;
		      this.updateContext();
		    };
		    _proto.readToken_numberSign = function readToken_numberSign() {
		      if (this.state.pos === 0 && this.readToken_interpreter()) {
		        return;
		      }
		      var nextPos = this.state.pos + 1;
		      var next = this.codePointAtPos(nextPos);
		      if (next >= 48 && next <= 57) {
		        throw this.raise(Errors.UnexpectedDigitAfterHash, this.state.curPosition());
		      }
		      if (next === 123 || next === 91 && this.hasPlugin("recordAndTuple")) {
		        this.expectPlugin("recordAndTuple");
		        if (this.getPluginOption("recordAndTuple", "syntaxType") === "bar") {
		          throw this.raise(next === 123 ? Errors.RecordExpressionHashIncorrectStartSyntaxType : Errors.TupleExpressionHashIncorrectStartSyntaxType, this.state.curPosition());
		        }
		        this.state.pos += 2;
		        if (next === 123) {
		          this.finishToken(7);
		        } else {
		          this.finishToken(1);
		        }
		      } else if (isIdentifierStart(next)) {
		        ++this.state.pos;
		        this.finishToken(138, this.readWord1(next));
		      } else if (next === 92) {
		        ++this.state.pos;
		        this.finishToken(138, this.readWord1());
		      } else {
		        this.finishOp(27, 1);
		      }
		    };
		    _proto.readToken_dot = function readToken_dot() {
		      var next = this.input.charCodeAt(this.state.pos + 1);
		      if (next >= 48 && next <= 57) {
		        this.readNumber(true);
		        return;
		      }
		      if (next === 46 && this.input.charCodeAt(this.state.pos + 2) === 46) {
		        this.state.pos += 3;
		        this.finishToken(21);
		      } else {
		        ++this.state.pos;
		        this.finishToken(16);
		      }
		    };
		    _proto.readToken_slash = function readToken_slash() {
		      var next = this.input.charCodeAt(this.state.pos + 1);
		      if (next === 61) {
		        this.finishOp(31, 2);
		      } else {
		        this.finishOp(56, 1);
		      }
		    };
		    _proto.readToken_interpreter = function readToken_interpreter() {
		      if (this.state.pos !== 0 || this.length < 2) return false;
		      var ch = this.input.charCodeAt(this.state.pos + 1);
		      if (ch !== 33) return false;
		      var start = this.state.pos;
		      this.state.pos += 1;
		      while (!isNewLine(ch) && ++this.state.pos < this.length) {
		        ch = this.input.charCodeAt(this.state.pos);
		      }
		      var value = this.input.slice(start + 2, this.state.pos);
		      this.finishToken(28, value);
		      return true;
		    };
		    _proto.readToken_mult_modulo = function readToken_mult_modulo(code) {
		      var type = code === 42 ? 55 : 54;
		      var width = 1;
		      var next = this.input.charCodeAt(this.state.pos + 1);
		      if (code === 42 && next === 42) {
		        width++;
		        next = this.input.charCodeAt(this.state.pos + 2);
		        type = 57;
		      }
		      if (next === 61 && !this.state.inType) {
		        width++;
		        type = code === 37 ? 33 : 30;
		      }
		      this.finishOp(type, width);
		    };
		    _proto.readToken_pipe_amp = function readToken_pipe_amp(code) {
		      var next = this.input.charCodeAt(this.state.pos + 1);
		      if (next === code) {
		        if (this.input.charCodeAt(this.state.pos + 2) === 61) {
		          this.finishOp(30, 3);
		        } else {
		          this.finishOp(code === 124 ? 41 : 42, 2);
		        }
		        return;
		      }
		      if (code === 124) {
		        if (next === 62) {
		          this.finishOp(39, 2);
		          return;
		        }
		        if (this.hasPlugin("recordAndTuple") && next === 125) {
		          if (this.getPluginOption("recordAndTuple", "syntaxType") !== "bar") {
		            throw this.raise(Errors.RecordExpressionBarIncorrectEndSyntaxType, this.state.curPosition());
		          }
		          this.state.pos += 2;
		          this.finishToken(9);
		          return;
		        }
		        if (this.hasPlugin("recordAndTuple") && next === 93) {
		          if (this.getPluginOption("recordAndTuple", "syntaxType") !== "bar") {
		            throw this.raise(Errors.TupleExpressionBarIncorrectEndSyntaxType, this.state.curPosition());
		          }
		          this.state.pos += 2;
		          this.finishToken(4);
		          return;
		        }
		      }
		      if (next === 61) {
		        this.finishOp(30, 2);
		        return;
		      }
		      this.finishOp(code === 124 ? 43 : 45, 1);
		    };
		    _proto.readToken_caret = function readToken_caret() {
		      var next = this.input.charCodeAt(this.state.pos + 1);
		      if (next === 61 && !this.state.inType) {
		        this.finishOp(32, 2);
		      } else if (next === 94 && this.hasPlugin(["pipelineOperator", {
		        proposal: "hack",
		        topicToken: "^^"
		      }])) {
		        this.finishOp(37, 2);
		        var lookaheadCh = this.input.codePointAt(this.state.pos);
		        if (lookaheadCh === 94) {
		          this.unexpected();
		        }
		      } else {
		        this.finishOp(44, 1);
		      }
		    };
		    _proto.readToken_atSign = function readToken_atSign() {
		      var next = this.input.charCodeAt(this.state.pos + 1);
		      if (next === 64 && this.hasPlugin(["pipelineOperator", {
		        proposal: "hack",
		        topicToken: "@@"
		      }])) {
		        this.finishOp(38, 2);
		      } else {
		        this.finishOp(26, 1);
		      }
		    };
		    _proto.readToken_plus_min = function readToken_plus_min(code) {
		      var next = this.input.charCodeAt(this.state.pos + 1);
		      if (next === code) {
		        this.finishOp(34, 2);
		        return;
		      }
		      if (next === 61) {
		        this.finishOp(30, 2);
		      } else {
		        this.finishOp(53, 1);
		      }
		    };
		    _proto.readToken_lt = function readToken_lt() {
		      var pos = this.state.pos;
		      var next = this.input.charCodeAt(pos + 1);
		      if (next === 60) {
		        if (this.input.charCodeAt(pos + 2) === 61) {
		          this.finishOp(30, 3);
		          return;
		        }
		        this.finishOp(51, 2);
		        return;
		      }
		      if (next === 61) {
		        this.finishOp(49, 2);
		        return;
		      }
		      this.finishOp(47, 1);
		    };
		    _proto.readToken_gt = function readToken_gt() {
		      var pos = this.state.pos;
		      var next = this.input.charCodeAt(pos + 1);
		      if (next === 62) {
		        var size = this.input.charCodeAt(pos + 2) === 62 ? 3 : 2;
		        if (this.input.charCodeAt(pos + size) === 61) {
		          this.finishOp(30, size + 1);
		          return;
		        }
		        this.finishOp(52, size);
		        return;
		      }
		      if (next === 61) {
		        this.finishOp(49, 2);
		        return;
		      }
		      this.finishOp(48, 1);
		    };
		    _proto.readToken_eq_excl = function readToken_eq_excl(code) {
		      var next = this.input.charCodeAt(this.state.pos + 1);
		      if (next === 61) {
		        this.finishOp(46, this.input.charCodeAt(this.state.pos + 2) === 61 ? 3 : 2);
		        return;
		      }
		      if (code === 61 && next === 62) {
		        this.state.pos += 2;
		        this.finishToken(19);
		        return;
		      }
		      this.finishOp(code === 61 ? 29 : 35, 1);
		    };
		    _proto.readToken_question = function readToken_question() {
		      var next = this.input.charCodeAt(this.state.pos + 1);
		      var next2 = this.input.charCodeAt(this.state.pos + 2);
		      if (next === 63) {
		        if (next2 === 61) {
		          this.finishOp(30, 3);
		        } else {
		          this.finishOp(40, 2);
		        }
		      } else if (next === 46 && !(next2 >= 48 && next2 <= 57)) {
		        this.state.pos += 2;
		        this.finishToken(18);
		      } else {
		        ++this.state.pos;
		        this.finishToken(17);
		      }
		    };
		    _proto.getTokenFromCode = function getTokenFromCode(code) {
		      switch (code) {
		        case 46:
		          this.readToken_dot();
		          return;
		        case 40:
		          ++this.state.pos;
		          this.finishToken(10);
		          return;
		        case 41:
		          ++this.state.pos;
		          this.finishToken(11);
		          return;
		        case 59:
		          ++this.state.pos;
		          this.finishToken(13);
		          return;
		        case 44:
		          ++this.state.pos;
		          this.finishToken(12);
		          return;
		        case 91:
		          if (this.hasPlugin("recordAndTuple") && this.input.charCodeAt(this.state.pos + 1) === 124) {
		            if (this.getPluginOption("recordAndTuple", "syntaxType") !== "bar") {
		              throw this.raise(Errors.TupleExpressionBarIncorrectStartSyntaxType, this.state.curPosition());
		            }
		            this.state.pos += 2;
		            this.finishToken(2);
		          } else {
		            ++this.state.pos;
		            this.finishToken(0);
		          }
		          return;
		        case 93:
		          ++this.state.pos;
		          this.finishToken(3);
		          return;
		        case 123:
		          if (this.hasPlugin("recordAndTuple") && this.input.charCodeAt(this.state.pos + 1) === 124) {
		            if (this.getPluginOption("recordAndTuple", "syntaxType") !== "bar") {
		              throw this.raise(Errors.RecordExpressionBarIncorrectStartSyntaxType, this.state.curPosition());
		            }
		            this.state.pos += 2;
		            this.finishToken(6);
		          } else {
		            ++this.state.pos;
		            this.finishToken(5);
		          }
		          return;
		        case 125:
		          ++this.state.pos;
		          this.finishToken(8);
		          return;
		        case 58:
		          if (this.hasPlugin("functionBind") && this.input.charCodeAt(this.state.pos + 1) === 58) {
		            this.finishOp(15, 2);
		          } else {
		            ++this.state.pos;
		            this.finishToken(14);
		          }
		          return;
		        case 63:
		          this.readToken_question();
		          return;
		        case 96:
		          this.readTemplateToken();
		          return;
		        case 48:
		          {
		            var next = this.input.charCodeAt(this.state.pos + 1);
		            if (next === 120 || next === 88) {
		              this.readRadixNumber(16);
		              return;
		            }
		            if (next === 111 || next === 79) {
		              this.readRadixNumber(8);
		              return;
		            }
		            if (next === 98 || next === 66) {
		              this.readRadixNumber(2);
		              return;
		            }
		          }
		        case 49:
		        case 50:
		        case 51:
		        case 52:
		        case 53:
		        case 54:
		        case 55:
		        case 56:
		        case 57:
		          this.readNumber(false);
		          return;
		        case 34:
		        case 39:
		          this.readString(code);
		          return;
		        case 47:
		          this.readToken_slash();
		          return;
		        case 37:
		        case 42:
		          this.readToken_mult_modulo(code);
		          return;
		        case 124:
		        case 38:
		          this.readToken_pipe_amp(code);
		          return;
		        case 94:
		          this.readToken_caret();
		          return;
		        case 43:
		        case 45:
		          this.readToken_plus_min(code);
		          return;
		        case 60:
		          this.readToken_lt();
		          return;
		        case 62:
		          this.readToken_gt();
		          return;
		        case 61:
		        case 33:
		          this.readToken_eq_excl(code);
		          return;
		        case 126:
		          this.finishOp(36, 1);
		          return;
		        case 64:
		          this.readToken_atSign();
		          return;
		        case 35:
		          this.readToken_numberSign();
		          return;
		        case 92:
		          this.readWord();
		          return;
		        default:
		          if (isIdentifierStart(code)) {
		            this.readWord(code);
		            return;
		          }
		      }
		      throw this.raise(Errors.InvalidOrUnexpectedToken, this.state.curPosition(), {
		        unexpected: String.fromCodePoint(code)
		      });
		    };
		    _proto.finishOp = function finishOp(type, size) {
		      var str = this.input.slice(this.state.pos, this.state.pos + size);
		      this.state.pos += size;
		      this.finishToken(type, str);
		    };
		    _proto.readRegexp = function readRegexp() {
		      var startLoc = this.state.startLoc;
		      var start = this.state.start + 1;
		      var escaped, inClass;
		      var pos = this.state.pos;
		      for (;; ++pos) {
		        if (pos >= this.length) {
		          throw this.raise(Errors.UnterminatedRegExp, createPositionWithColumnOffset(startLoc, 1));
		        }
		        var ch = this.input.charCodeAt(pos);
		        if (isNewLine(ch)) {
		          throw this.raise(Errors.UnterminatedRegExp, createPositionWithColumnOffset(startLoc, 1));
		        }
		        if (escaped) {
		          escaped = false;
		        } else {
		          if (ch === 91) {
		            inClass = true;
		          } else if (ch === 93 && inClass) {
		            inClass = false;
		          } else if (ch === 47 && !inClass) {
		            break;
		          }
		          escaped = ch === 92;
		        }
		      }
		      var content = this.input.slice(start, pos);
		      ++pos;
		      var mods = "";
		      var nextPos = function nextPos() {
		        return createPositionWithColumnOffset(startLoc, pos + 2 - start);
		      };
		      while (pos < this.length) {
		        var cp = this.codePointAtPos(pos);
		        var _char = String.fromCharCode(cp);
		        if (VALID_REGEX_FLAGS.has(cp)) {
		          if (cp === 118) {
		            if (mods.includes("u")) {
		              this.raise(Errors.IncompatibleRegExpUVFlags, nextPos());
		            }
		          } else if (cp === 117) {
		            if (mods.includes("v")) {
		              this.raise(Errors.IncompatibleRegExpUVFlags, nextPos());
		            }
		          }
		          if (mods.includes(_char)) {
		            this.raise(Errors.DuplicateRegExpFlags, nextPos());
		          }
		        } else if (isIdentifierChar(cp) || cp === 92) {
		          this.raise(Errors.MalformedRegExpFlags, nextPos());
		        } else {
		          break;
		        }
		        ++pos;
		        mods += _char;
		      }
		      this.state.pos = pos;
		      this.finishToken(137, {
		        pattern: content,
		        flags: mods
		      });
		    };
		    _proto.readInt = function readInt$1(radix, len, forceLen, allowNumSeparator) {
		      if (forceLen === void 0) {
		        forceLen = false;
		      }
		      if (allowNumSeparator === void 0) {
		        allowNumSeparator = true;
		      }
		      var _readInt2 = readInt(this.input, this.state.pos, this.state.lineStart, this.state.curLine, radix, len, forceLen, allowNumSeparator, this.errorHandlers_readInt, false),
		        n = _readInt2.n,
		        pos = _readInt2.pos;
		      this.state.pos = pos;
		      return n;
		    };
		    _proto.readRadixNumber = function readRadixNumber(radix) {
		      var startLoc = this.state.curPosition();
		      var isBigInt = false;
		      this.state.pos += 2;
		      var val = this.readInt(radix);
		      if (val == null) {
		        this.raise(Errors.InvalidDigit, createPositionWithColumnOffset(startLoc, 2), {
		          radix: radix
		        });
		      }
		      var next = this.input.charCodeAt(this.state.pos);
		      if (next === 110) {
		        ++this.state.pos;
		        isBigInt = true;
		      } else if (next === 109) {
		        throw this.raise(Errors.InvalidDecimal, startLoc);
		      }
		      if (isIdentifierStart(this.codePointAtPos(this.state.pos))) {
		        throw this.raise(Errors.NumberIdentifier, this.state.curPosition());
		      }
		      if (isBigInt) {
		        var str = this.input.slice(startLoc.index, this.state.pos).replace(/[_n]/g, "");
		        this.finishToken(135, str);
		        return;
		      }
		      this.finishToken(134, val);
		    };
		    _proto.readNumber = function readNumber(startsWithDot) {
		      var start = this.state.pos;
		      var startLoc = this.state.curPosition();
		      var isFloat = false;
		      var isBigInt = false;
		      var isDecimal = false;
		      var hasExponent = false;
		      var isOctal = false;
		      if (!startsWithDot && this.readInt(10) === null) {
		        this.raise(Errors.InvalidNumber, this.state.curPosition());
		      }
		      var hasLeadingZero = this.state.pos - start >= 2 && this.input.charCodeAt(start) === 48;
		      if (hasLeadingZero) {
		        var integer = this.input.slice(start, this.state.pos);
		        this.recordStrictModeErrors(Errors.StrictOctalLiteral, startLoc);
		        if (!this.state.strict) {
		          var underscorePos = integer.indexOf("_");
		          if (underscorePos > 0) {
		            this.raise(Errors.ZeroDigitNumericSeparator, createPositionWithColumnOffset(startLoc, underscorePos));
		          }
		        }
		        isOctal = hasLeadingZero && !/[89]/.test(integer);
		      }
		      var next = this.input.charCodeAt(this.state.pos);
		      if (next === 46 && !isOctal) {
		        ++this.state.pos;
		        this.readInt(10);
		        isFloat = true;
		        next = this.input.charCodeAt(this.state.pos);
		      }
		      if ((next === 69 || next === 101) && !isOctal) {
		        next = this.input.charCodeAt(++this.state.pos);
		        if (next === 43 || next === 45) {
		          ++this.state.pos;
		        }
		        if (this.readInt(10) === null) {
		          this.raise(Errors.InvalidOrMissingExponent, startLoc);
		        }
		        isFloat = true;
		        hasExponent = true;
		        next = this.input.charCodeAt(this.state.pos);
		      }
		      if (next === 110) {
		        if (isFloat || hasLeadingZero) {
		          this.raise(Errors.InvalidBigIntLiteral, startLoc);
		        }
		        ++this.state.pos;
		        isBigInt = true;
		      }
		      if (next === 109) {
		        this.expectPlugin("decimal", this.state.curPosition());
		        if (hasExponent || hasLeadingZero) {
		          this.raise(Errors.InvalidDecimal, startLoc);
		        }
		        ++this.state.pos;
		        isDecimal = true;
		      }
		      if (isIdentifierStart(this.codePointAtPos(this.state.pos))) {
		        throw this.raise(Errors.NumberIdentifier, this.state.curPosition());
		      }
		      var str = this.input.slice(start, this.state.pos).replace(/[_mn]/g, "");
		      if (isBigInt) {
		        this.finishToken(135, str);
		        return;
		      }
		      if (isDecimal) {
		        this.finishToken(136, str);
		        return;
		      }
		      var val = isOctal ? parseInt(str, 8) : parseFloat(str);
		      this.finishToken(134, val);
		    };
		    _proto.readCodePoint = function readCodePoint$1(throwOnInvalid) {
		      var _readCodePoint2 = readCodePoint(this.input, this.state.pos, this.state.lineStart, this.state.curLine, throwOnInvalid, this.errorHandlers_readCodePoint),
		        code = _readCodePoint2.code,
		        pos = _readCodePoint2.pos;
		      this.state.pos = pos;
		      return code;
		    };
		    _proto.readString = function readString(quote) {
		      var _readStringContents = readStringContents(quote === 34 ? "double" : "single", this.input, this.state.pos + 1, this.state.lineStart, this.state.curLine, this.errorHandlers_readStringContents_string),
		        str = _readStringContents.str,
		        pos = _readStringContents.pos,
		        curLine = _readStringContents.curLine,
		        lineStart = _readStringContents.lineStart;
		      this.state.pos = pos + 1;
		      this.state.lineStart = lineStart;
		      this.state.curLine = curLine;
		      this.finishToken(133, str);
		    };
		    _proto.readTemplateContinuation = function readTemplateContinuation() {
		      if (!this.match(8)) {
		        this.unexpected(null, 8);
		      }
		      this.state.pos--;
		      this.readTemplateToken();
		    };
		    _proto.readTemplateToken = function readTemplateToken() {
		      var opening = this.input[this.state.pos];
		      var _readStringContents2 = readStringContents("template", this.input, this.state.pos + 1, this.state.lineStart, this.state.curLine, this.errorHandlers_readStringContents_template),
		        str = _readStringContents2.str,
		        firstInvalidLoc = _readStringContents2.firstInvalidLoc,
		        pos = _readStringContents2.pos,
		        curLine = _readStringContents2.curLine,
		        lineStart = _readStringContents2.lineStart;
		      this.state.pos = pos + 1;
		      this.state.lineStart = lineStart;
		      this.state.curLine = curLine;
		      if (firstInvalidLoc) {
		        this.state.firstInvalidTemplateEscapePos = new Position(firstInvalidLoc.curLine, firstInvalidLoc.pos - firstInvalidLoc.lineStart, firstInvalidLoc.pos);
		      }
		      if (this.input.codePointAt(pos) === 96) {
		        this.finishToken(24, firstInvalidLoc ? null : opening + str + "`");
		      } else {
		        this.state.pos++;
		        this.finishToken(25, firstInvalidLoc ? null : opening + str + "${");
		      }
		    };
		    _proto.recordStrictModeErrors = function recordStrictModeErrors(toParseError, at) {
		      var index = at.index;
		      if (this.state.strict && !this.state.strictErrors.has(index)) {
		        this.raise(toParseError, at);
		      } else {
		        this.state.strictErrors.set(index, [toParseError, at]);
		      }
		    };
		    _proto.readWord1 = function readWord1(firstCode) {
		      this.state.containsEsc = false;
		      var word = "";
		      var start = this.state.pos;
		      var chunkStart = this.state.pos;
		      if (firstCode !== undefined) {
		        this.state.pos += firstCode <= 0xffff ? 1 : 2;
		      }
		      while (this.state.pos < this.length) {
		        var ch = this.codePointAtPos(this.state.pos);
		        if (isIdentifierChar(ch)) {
		          this.state.pos += ch <= 0xffff ? 1 : 2;
		        } else if (ch === 92) {
		          this.state.containsEsc = true;
		          word += this.input.slice(chunkStart, this.state.pos);
		          var escStart = this.state.curPosition();
		          var identifierCheck = this.state.pos === start ? isIdentifierStart : isIdentifierChar;
		          if (this.input.charCodeAt(++this.state.pos) !== 117) {
		            this.raise(Errors.MissingUnicodeEscape, this.state.curPosition());
		            chunkStart = this.state.pos - 1;
		            continue;
		          }
		          ++this.state.pos;
		          var esc = this.readCodePoint(true);
		          if (esc !== null) {
		            if (!identifierCheck(esc)) {
		              this.raise(Errors.EscapedCharNotAnIdentifier, escStart);
		            }
		            word += String.fromCodePoint(esc);
		          }
		          chunkStart = this.state.pos;
		        } else {
		          break;
		        }
		      }
		      return word + this.input.slice(chunkStart, this.state.pos);
		    };
		    _proto.readWord = function readWord(firstCode) {
		      var word = this.readWord1(firstCode);
		      var type = keywords.get(word);
		      if (type !== undefined) {
		        this.finishToken(type, tokenLabelName(type));
		      } else {
		        this.finishToken(132, word);
		      }
		    };
		    _proto.checkKeywordEscapes = function checkKeywordEscapes() {
		      var type = this.state.type;
		      if (tokenIsKeyword(type) && this.state.containsEsc) {
		        this.raise(Errors.InvalidEscapedReservedWord, this.state.startLoc, {
		          reservedWord: tokenLabelName(type)
		        });
		      }
		    };
		    _proto.raise = function raise(toParseError, at, details) {
		      if (details === void 0) {
		        details = {};
		      }
		      var loc = at instanceof Position ? at : at.loc.start;
		      var error = toParseError(loc, details);
		      if (!this.options.errorRecovery) throw error;
		      if (!this.isLookahead) this.state.errors.push(error);
		      return error;
		    };
		    _proto.raiseOverwrite = function raiseOverwrite(toParseError, at, details) {
		      if (details === void 0) {
		        details = {};
		      }
		      var loc = at instanceof Position ? at : at.loc.start;
		      var pos = loc.index;
		      var errors = this.state.errors;
		      for (var i = errors.length - 1; i >= 0; i--) {
		        var error = errors[i];
		        if (error.loc.index === pos) {
		          return errors[i] = toParseError(loc, details);
		        }
		        if (error.loc.index < pos) break;
		      }
		      return this.raise(toParseError, at, details);
		    };
		    _proto.updateContext = function updateContext(prevType) {};
		    _proto.unexpected = function unexpected(loc, type) {
		      throw this.raise(Errors.UnexpectedToken, loc != null ? loc : this.state.startLoc, {
		        expected: type ? tokenLabelName(type) : null
		      });
		    };
		    _proto.expectPlugin = function expectPlugin(pluginName, loc) {
		      if (this.hasPlugin(pluginName)) {
		        return true;
		      }
		      throw this.raise(Errors.MissingPlugin, loc != null ? loc : this.state.startLoc, {
		        missingPlugin: [pluginName]
		      });
		    };
		    _proto.expectOnePlugin = function expectOnePlugin(pluginNames) {
		      var _this3 = this;
		      if (!pluginNames.some(function (name) {
		        return _this3.hasPlugin(name);
		      })) {
		        throw this.raise(Errors.MissingOneOfPlugins, this.state.startLoc, {
		          missingPlugin: pluginNames
		        });
		      }
		    };
		    _proto.errorBuilder = function errorBuilder(error) {
		      var _this4 = this;
		      return function (pos, lineStart, curLine) {
		        _this4.raise(error, buildPosition(pos, lineStart, curLine));
		      };
		    };
		    return _createClass(Tokenizer);
		  }(CommentsParser);

		  var ClassScope = _createClass(function ClassScope() {
		    this.privateNames = new Set();
		    this.loneAccessors = new Map();
		    this.undefinedPrivateNames = new Map();
		  });
		  var ClassScopeHandler = function () {
		    function ClassScopeHandler(parser) {
		      this.parser = void 0;
		      this.stack = [];
		      this.undefinedPrivateNames = new Map();
		      this.parser = parser;
		    }
		    var _proto = ClassScopeHandler.prototype;
		    _proto.current = function current() {
		      return this.stack[this.stack.length - 1];
		    };
		    _proto.enter = function enter() {
		      this.stack.push(new ClassScope());
		    };
		    _proto.exit = function exit() {
		      var oldClassScope = this.stack.pop();
		      var current = this.current();
		      for (var _i2 = 0, _Array$from2 = Array.from(oldClassScope.undefinedPrivateNames); _i2 < _Array$from2.length; _i2++) {
		        var _Array$from2$_i = _Array$from2[_i2],
		          name = _Array$from2$_i[0],
		          loc = _Array$from2$_i[1];
		        if (current) {
		          if (!current.undefinedPrivateNames.has(name)) {
		            current.undefinedPrivateNames.set(name, loc);
		          }
		        } else {
		          this.parser.raise(Errors.InvalidPrivateFieldResolution, loc, {
		            identifierName: name
		          });
		        }
		      }
		    };
		    _proto.declarePrivateName = function declarePrivateName(name, elementType, loc) {
		      var _this$current = this.current(),
		        privateNames = _this$current.privateNames,
		        loneAccessors = _this$current.loneAccessors,
		        undefinedPrivateNames = _this$current.undefinedPrivateNames;
		      var redefined = privateNames.has(name);
		      if (elementType & ClassElementType.KIND_ACCESSOR) {
		        var accessor = redefined && loneAccessors.get(name);
		        if (accessor) {
		          var oldStatic = accessor & ClassElementType.FLAG_STATIC;
		          var newStatic = elementType & ClassElementType.FLAG_STATIC;
		          var oldKind = accessor & ClassElementType.KIND_ACCESSOR;
		          var newKind = elementType & ClassElementType.KIND_ACCESSOR;
		          redefined = oldKind === newKind || oldStatic !== newStatic;
		          if (!redefined) loneAccessors["delete"](name);
		        } else if (!redefined) {
		          loneAccessors.set(name, elementType);
		        }
		      }
		      if (redefined) {
		        this.parser.raise(Errors.PrivateNameRedeclaration, loc, {
		          identifierName: name
		        });
		      }
		      privateNames.add(name);
		      undefinedPrivateNames["delete"](name);
		    };
		    _proto.usePrivateName = function usePrivateName(name, loc) {
		      var classScope;
		      for (var _i4 = 0, _this$stack2 = this.stack; _i4 < _this$stack2.length; _i4++) {
		        classScope = _this$stack2[_i4];
		        if (classScope.privateNames.has(name)) return;
		      }
		      if (classScope) {
		        classScope.undefinedPrivateNames.set(name, loc);
		      } else {
		        this.parser.raise(Errors.InvalidPrivateFieldResolution, loc, {
		          identifierName: name
		        });
		      }
		    };
		    return _createClass(ClassScopeHandler);
		  }();

		  var ExpressionScope = function () {
		    function ExpressionScope(type) {
		      if (type === void 0) {
		        type = 0;
		      }
		      this.type = type;
		    }
		    var _proto = ExpressionScope.prototype;
		    _proto.canBeArrowParameterDeclaration = function canBeArrowParameterDeclaration() {
		      return this.type === 2 || this.type === 1;
		    };
		    _proto.isCertainlyParameterDeclaration = function isCertainlyParameterDeclaration() {
		      return this.type === 3;
		    };
		    return _createClass(ExpressionScope);
		  }();
		  var ArrowHeadParsingScope = function (_ExpressionScope) {
		    function ArrowHeadParsingScope(type) {
		      var _this;
		      _this = _ExpressionScope.call(this, type) || this;
		      _this.declarationErrors = new Map();
		      return _this;
		    }
		    _inherits(ArrowHeadParsingScope, _ExpressionScope);
		    var _proto2 = ArrowHeadParsingScope.prototype;
		    _proto2.recordDeclarationError = function recordDeclarationError(ParsingErrorClass, at) {
		      var index = at.index;
		      this.declarationErrors.set(index, [ParsingErrorClass, at]);
		    };
		    _proto2.clearDeclarationError = function clearDeclarationError(index) {
		      this.declarationErrors["delete"](index);
		    };
		    _proto2.iterateErrors = function iterateErrors(iterator) {
		      this.declarationErrors.forEach(iterator);
		    };
		    return _createClass(ArrowHeadParsingScope);
		  }(ExpressionScope);
		  var ExpressionScopeHandler = function () {
		    function ExpressionScopeHandler(parser) {
		      this.parser = void 0;
		      this.stack = [new ExpressionScope()];
		      this.parser = parser;
		    }
		    var _proto3 = ExpressionScopeHandler.prototype;
		    _proto3.enter = function enter(scope) {
		      this.stack.push(scope);
		    };
		    _proto3.exit = function exit() {
		      this.stack.pop();
		    };
		    _proto3.recordParameterInitializerError = function recordParameterInitializerError(toParseError, node) {
		      var origin = node.loc.start;
		      var stack = this.stack;
		      var i = stack.length - 1;
		      var scope = stack[i];
		      while (!scope.isCertainlyParameterDeclaration()) {
		        if (scope.canBeArrowParameterDeclaration()) {
		          scope.recordDeclarationError(toParseError, origin);
		        } else {
		          return;
		        }
		        scope = stack[--i];
		      }
		      this.parser.raise(toParseError, origin);
		    };
		    _proto3.recordArrowParameterBindingError = function recordArrowParameterBindingError(error, node) {
		      var stack = this.stack;
		      var scope = stack[stack.length - 1];
		      var origin = node.loc.start;
		      if (scope.isCertainlyParameterDeclaration()) {
		        this.parser.raise(error, origin);
		      } else if (scope.canBeArrowParameterDeclaration()) {
		        scope.recordDeclarationError(error, origin);
		      } else {
		        return;
		      }
		    };
		    _proto3.recordAsyncArrowParametersError = function recordAsyncArrowParametersError(at) {
		      var stack = this.stack;
		      var i = stack.length - 1;
		      var scope = stack[i];
		      while (scope.canBeArrowParameterDeclaration()) {
		        if (scope.type === 2) {
		          scope.recordDeclarationError(Errors.AwaitBindingIdentifier, at);
		        }
		        scope = stack[--i];
		      }
		    };
		    _proto3.validateAsPattern = function validateAsPattern() {
		      var _this2 = this;
		      var stack = this.stack;
		      var currentScope = stack[stack.length - 1];
		      if (!currentScope.canBeArrowParameterDeclaration()) return;
		      currentScope.iterateErrors(function (_ref) {
		        var toParseError = _ref[0],
		          loc = _ref[1];
		        _this2.parser.raise(toParseError, loc);
		        var i = stack.length - 2;
		        var scope = stack[i];
		        while (scope.canBeArrowParameterDeclaration()) {
		          scope.clearDeclarationError(loc.index);
		          scope = stack[--i];
		        }
		      });
		    };
		    return _createClass(ExpressionScopeHandler);
		  }();
		  function newParameterDeclarationScope() {
		    return new ExpressionScope(3);
		  }
		  function newArrowHeadScope() {
		    return new ArrowHeadParsingScope(1);
		  }
		  function newAsyncArrowScope() {
		    return new ArrowHeadParsingScope(2);
		  }
		  function newExpressionScope() {
		    return new ExpressionScope();
		  }

		  var ParamKind = {
		    PARAM: 0,
		    PARAM_YIELD: 1,
		    PARAM_AWAIT: 2,
		    PARAM_RETURN: 4,
		    PARAM_IN: 8
		  };
		  var ProductionParameterHandler = function () {
		    function ProductionParameterHandler() {
		      this.stacks = [];
		    }
		    var _proto = ProductionParameterHandler.prototype;
		    _proto.enter = function enter(flags) {
		      this.stacks.push(flags);
		    };
		    _proto.exit = function exit() {
		      this.stacks.pop();
		    };
		    _proto.currentFlags = function currentFlags() {
		      return this.stacks[this.stacks.length - 1];
		    };
		    return _createClass(ProductionParameterHandler, [{
		      key: "hasAwait",
		      get: function get() {
		        return (this.currentFlags() & ParamKind.PARAM_AWAIT) > 0;
		      }
		    }, {
		      key: "hasYield",
		      get: function get() {
		        return (this.currentFlags() & ParamKind.PARAM_YIELD) > 0;
		      }
		    }, {
		      key: "hasReturn",
		      get: function get() {
		        return (this.currentFlags() & ParamKind.PARAM_RETURN) > 0;
		      }
		    }, {
		      key: "hasIn",
		      get: function get() {
		        return (this.currentFlags() & ParamKind.PARAM_IN) > 0;
		      }
		    }]);
		  }();
		  function functionFlags(isAsync, isGenerator) {
		    return (isAsync ? ParamKind.PARAM_AWAIT : 0) | (isGenerator ? ParamKind.PARAM_YIELD : 0);
		  }

		  var UtilParser = function (_Tokenizer) {
		    function UtilParser() {
		      return _Tokenizer.apply(this, arguments) || this;
		    }
		    _inherits(UtilParser, _Tokenizer);
		    var _proto = UtilParser.prototype;
		    _proto.addExtra = function addExtra(node, key, value, enumerable) {
		      if (enumerable === void 0) {
		        enumerable = true;
		      }
		      if (!node) return;
		      var extra = node.extra = node.extra || {};
		      if (enumerable) {
		        extra[key] = value;
		      } else {
		        Object.defineProperty(extra, key, {
		          enumerable: enumerable,
		          value: value
		        });
		      }
		    };
		    _proto.isContextual = function isContextual(token) {
		      return this.state.type === token && !this.state.containsEsc;
		    };
		    _proto.isUnparsedContextual = function isUnparsedContextual(nameStart, name) {
		      var nameEnd = nameStart + name.length;
		      if (this.input.slice(nameStart, nameEnd) === name) {
		        var nextCh = this.input.charCodeAt(nameEnd);
		        return !(isIdentifierChar(nextCh) || (nextCh & 0xfc00) === 0xd800);
		      }
		      return false;
		    };
		    _proto.isLookaheadContextual = function isLookaheadContextual(name) {
		      var next = this.nextTokenStart();
		      return this.isUnparsedContextual(next, name);
		    };
		    _proto.eatContextual = function eatContextual(token) {
		      if (this.isContextual(token)) {
		        this.next();
		        return true;
		      }
		      return false;
		    };
		    _proto.expectContextual = function expectContextual(token, toParseError) {
		      if (!this.eatContextual(token)) {
		        if (toParseError != null) {
		          throw this.raise(toParseError, this.state.startLoc);
		        }
		        this.unexpected(null, token);
		      }
		    };
		    _proto.canInsertSemicolon = function canInsertSemicolon() {
		      return this.match(139) || this.match(8) || this.hasPrecedingLineBreak();
		    };
		    _proto.hasPrecedingLineBreak = function hasPrecedingLineBreak() {
		      return lineBreak.test(this.input.slice(this.state.lastTokEndLoc.index, this.state.start));
		    };
		    _proto.hasFollowingLineBreak = function hasFollowingLineBreak() {
		      skipWhiteSpaceToLineBreak.lastIndex = this.state.end;
		      return skipWhiteSpaceToLineBreak.test(this.input);
		    };
		    _proto.isLineTerminator = function isLineTerminator() {
		      return this.eat(13) || this.canInsertSemicolon();
		    };
		    _proto.semicolon = function semicolon(allowAsi) {
		      if (allowAsi === void 0) {
		        allowAsi = true;
		      }
		      if (allowAsi ? this.isLineTerminator() : this.eat(13)) return;
		      this.raise(Errors.MissingSemicolon, this.state.lastTokEndLoc);
		    };
		    _proto.expect = function expect(type, loc) {
		      this.eat(type) || this.unexpected(loc, type);
		    };
		    _proto.tryParse = function tryParse(fn, oldState) {
		      if (oldState === void 0) {
		        oldState = this.state.clone();
		      }
		      var abortSignal = {
		        node: null
		      };
		      try {
		        var _node = fn(function (node) {
		          if (node === void 0) {
		            node = null;
		          }
		          abortSignal.node = node;
		          throw abortSignal;
		        });
		        if (this.state.errors.length > oldState.errors.length) {
		          var failState = this.state;
		          this.state = oldState;
		          this.state.tokensLength = failState.tokensLength;
		          return {
		            node: _node,
		            error: failState.errors[oldState.errors.length],
		            thrown: false,
		            aborted: false,
		            failState: failState
		          };
		        }
		        return {
		          node: _node,
		          error: null,
		          thrown: false,
		          aborted: false,
		          failState: null
		        };
		      } catch (error) {
		        var _failState = this.state;
		        this.state = oldState;
		        if (error instanceof SyntaxError) {
		          return {
		            node: null,
		            error: error,
		            thrown: true,
		            aborted: false,
		            failState: _failState
		          };
		        }
		        if (error === abortSignal) {
		          return {
		            node: abortSignal.node,
		            error: null,
		            thrown: false,
		            aborted: true,
		            failState: _failState
		          };
		        }
		        throw error;
		      }
		    };
		    _proto.checkExpressionErrors = function checkExpressionErrors(refExpressionErrors, andThrow) {
		      if (!refExpressionErrors) return false;
		      var shorthandAssignLoc = refExpressionErrors.shorthandAssignLoc,
		        doubleProtoLoc = refExpressionErrors.doubleProtoLoc,
		        privateKeyLoc = refExpressionErrors.privateKeyLoc,
		        optionalParametersLoc = refExpressionErrors.optionalParametersLoc;
		      var hasErrors = !!shorthandAssignLoc || !!doubleProtoLoc || !!optionalParametersLoc || !!privateKeyLoc;
		      if (!andThrow) {
		        return hasErrors;
		      }
		      if (shorthandAssignLoc != null) {
		        this.raise(Errors.InvalidCoverInitializedName, shorthandAssignLoc);
		      }
		      if (doubleProtoLoc != null) {
		        this.raise(Errors.DuplicateProto, doubleProtoLoc);
		      }
		      if (privateKeyLoc != null) {
		        this.raise(Errors.UnexpectedPrivateField, privateKeyLoc);
		      }
		      if (optionalParametersLoc != null) {
		        this.unexpected(optionalParametersLoc);
		      }
		    };
		    _proto.isLiteralPropertyName = function isLiteralPropertyName() {
		      return tokenIsLiteralPropertyName(this.state.type);
		    };
		    _proto.isPrivateName = function isPrivateName(node) {
		      return node.type === "PrivateName";
		    };
		    _proto.getPrivateNameSV = function getPrivateNameSV(node) {
		      return node.id.name;
		    };
		    _proto.hasPropertyAsPrivateName = function hasPropertyAsPrivateName(node) {
		      return (node.type === "MemberExpression" || node.type === "OptionalMemberExpression") && this.isPrivateName(node.property);
		    };
		    _proto.isObjectProperty = function isObjectProperty(node) {
		      return node.type === "ObjectProperty";
		    };
		    _proto.isObjectMethod = function isObjectMethod(node) {
		      return node.type === "ObjectMethod";
		    };
		    _proto.initializeScopes = function initializeScopes(inModule) {
		      var _this = this;
		      if (inModule === void 0) {
		        inModule = this.options.sourceType === "module";
		      }
		      var oldLabels = this.state.labels;
		      this.state.labels = [];
		      var oldExportedIdentifiers = this.exportedIdentifiers;
		      this.exportedIdentifiers = new Set();
		      var oldInModule = this.inModule;
		      this.inModule = inModule;
		      var oldScope = this.scope;
		      var ScopeHandler = this.getScopeHandler();
		      this.scope = new ScopeHandler(this, inModule);
		      var oldProdParam = this.prodParam;
		      this.prodParam = new ProductionParameterHandler();
		      var oldClassScope = this.classScope;
		      this.classScope = new ClassScopeHandler(this);
		      var oldExpressionScope = this.expressionScope;
		      this.expressionScope = new ExpressionScopeHandler(this);
		      return function () {
		        _this.state.labels = oldLabels;
		        _this.exportedIdentifiers = oldExportedIdentifiers;
		        _this.inModule = oldInModule;
		        _this.scope = oldScope;
		        _this.prodParam = oldProdParam;
		        _this.classScope = oldClassScope;
		        _this.expressionScope = oldExpressionScope;
		      };
		    };
		    _proto.enterInitialScopes = function enterInitialScopes() {
		      var paramFlags = ParamKind.PARAM;
		      if (this.inModule) {
		        paramFlags |= ParamKind.PARAM_AWAIT;
		      }
		      this.scope.enter(ScopeFlag.PROGRAM);
		      this.prodParam.enter(paramFlags);
		    };
		    _proto.checkDestructuringPrivate = function checkDestructuringPrivate(refExpressionErrors) {
		      var privateKeyLoc = refExpressionErrors.privateKeyLoc;
		      if (privateKeyLoc !== null) {
		        this.expectPlugin("destructuringPrivate", privateKeyLoc);
		      }
		    };
		    return _createClass(UtilParser);
		  }(Tokenizer);
		  var ExpressionErrors = _createClass(function ExpressionErrors() {
		    this.shorthandAssignLoc = null;
		    this.doubleProtoLoc = null;
		    this.privateKeyLoc = null;
		    this.optionalParametersLoc = null;
		  });

		  var Node = _createClass(function Node(parser, pos, loc) {
		    this.type = "";
		    this.start = pos;
		    this.end = 0;
		    this.loc = new SourceLocation(loc);
		    if (parser != null && parser.options.ranges) this.range = [pos, 0];
		    if (parser != null && parser.filename) this.loc.filename = parser.filename;
		  });
		  var NodePrototype = Node.prototype;
		  {
		    NodePrototype.__clone = function () {
		      var newNode = new Node(undefined, this.start, this.loc.start);
		      var keys = Object.keys(this);
		      for (var i = 0, length = keys.length; i < length; i++) {
		        var _key = keys[i];
		        if (_key !== "leadingComments" && _key !== "trailingComments" && _key !== "innerComments") {
		          newNode[_key] = this[_key];
		        }
		      }
		      return newNode;
		    };
		  }
		  function clonePlaceholder(node) {
		    return cloneIdentifier(node);
		  }
		  function cloneIdentifier(node) {
		    var type = node.type,
		      start = node.start,
		      end = node.end,
		      loc = node.loc,
		      range = node.range,
		      extra = node.extra,
		      name = node.name;
		    var cloned = Object.create(NodePrototype);
		    cloned.type = type;
		    cloned.start = start;
		    cloned.end = end;
		    cloned.loc = loc;
		    cloned.range = range;
		    cloned.extra = extra;
		    cloned.name = name;
		    if (type === "Placeholder") {
		      cloned.expectedNode = node.expectedNode;
		    }
		    return cloned;
		  }
		  function cloneStringLiteral(node) {
		    var type = node.type,
		      start = node.start,
		      end = node.end,
		      loc = node.loc,
		      range = node.range,
		      extra = node.extra;
		    if (type === "Placeholder") {
		      return clonePlaceholder(node);
		    }
		    var cloned = Object.create(NodePrototype);
		    cloned.type = type;
		    cloned.start = start;
		    cloned.end = end;
		    cloned.loc = loc;
		    cloned.range = range;
		    if (node.raw !== undefined) {
		      cloned.raw = node.raw;
		    } else {
		      cloned.extra = extra;
		    }
		    cloned.value = node.value;
		    return cloned;
		  }
		  var NodeUtils = function (_UtilParser) {
		    function NodeUtils() {
		      return _UtilParser.apply(this, arguments) || this;
		    }
		    _inherits(NodeUtils, _UtilParser);
		    var _proto = NodeUtils.prototype;
		    _proto.startNode = function startNode() {
		      var loc = this.state.startLoc;
		      return new Node(this, loc.index, loc);
		    };
		    _proto.startNodeAt = function startNodeAt(loc) {
		      return new Node(this, loc.index, loc);
		    };
		    _proto.startNodeAtNode = function startNodeAtNode(type) {
		      return this.startNodeAt(type.loc.start);
		    };
		    _proto.finishNode = function finishNode(node, type) {
		      return this.finishNodeAt(node, type, this.state.lastTokEndLoc);
		    };
		    _proto.finishNodeAt = function finishNodeAt(node, type, endLoc) {
		      node.type = type;
		      node.end = endLoc.index;
		      node.loc.end = endLoc;
		      if (this.options.ranges) node.range[1] = endLoc.index;
		      if (this.options.attachComment) this.processComment(node);
		      return node;
		    };
		    _proto.resetStartLocation = function resetStartLocation(node, startLoc) {
		      node.start = startLoc.index;
		      node.loc.start = startLoc;
		      if (this.options.ranges) node.range[0] = startLoc.index;
		    };
		    _proto.resetEndLocation = function resetEndLocation(node, endLoc) {
		      if (endLoc === void 0) {
		        endLoc = this.state.lastTokEndLoc;
		      }
		      node.end = endLoc.index;
		      node.loc.end = endLoc;
		      if (this.options.ranges) node.range[1] = endLoc.index;
		    };
		    _proto.resetStartLocationFromNode = function resetStartLocationFromNode(node, locationNode) {
		      this.resetStartLocation(node, locationNode.loc.start);
		    };
		    return _createClass(NodeUtils);
		  }(UtilParser);

		  var _templateObject$F;
		  var reservedTypes = new Set(["_", "any", "bool", "boolean", "empty", "extends", "false", "interface", "mixed", "null", "number", "static", "string", "true", "typeof", "void"]);
		  var FlowErrors = ParseErrorEnum(_templateObject$F || (_templateObject$F = _taggedTemplateLiteralLoose(["flow"])))({
		    AmbiguousConditionalArrow: "Ambiguous expression: wrap the arrow functions in parentheses to disambiguate.",
		    AmbiguousDeclareModuleKind: "Found both `declare module.exports` and `declare export` in the same module. Modules can only have 1 since they are either an ES module or they are a CommonJS module.",
		    AssignReservedType: function AssignReservedType(_ref) {
		      var reservedType = _ref.reservedType;
		      return "Cannot overwrite reserved type " + reservedType + ".";
		    },
		    DeclareClassElement: "The `declare` modifier can only appear on class fields.",
		    DeclareClassFieldInitializer: "Initializers are not allowed in fields with the `declare` modifier.",
		    DuplicateDeclareModuleExports: "Duplicate `declare module.exports` statement.",
		    EnumBooleanMemberNotInitialized: function EnumBooleanMemberNotInitialized(_ref2) {
		      var memberName = _ref2.memberName,
		        enumName = _ref2.enumName;
		      return "Boolean enum members need to be initialized. Use either `" + memberName + " = true,` or `" + memberName + " = false,` in enum `" + enumName + "`.";
		    },
		    EnumDuplicateMemberName: function EnumDuplicateMemberName(_ref3) {
		      var memberName = _ref3.memberName,
		        enumName = _ref3.enumName;
		      return "Enum member names need to be unique, but the name `" + memberName + "` has already been used before in enum `" + enumName + "`.";
		    },
		    EnumInconsistentMemberValues: function EnumInconsistentMemberValues(_ref4) {
		      var enumName = _ref4.enumName;
		      return "Enum `" + enumName + "` has inconsistent member initializers. Either use no initializers, or consistently use literals (either booleans, numbers, or strings) for all member initializers.";
		    },
		    EnumInvalidExplicitType: function EnumInvalidExplicitType(_ref5) {
		      var invalidEnumType = _ref5.invalidEnumType,
		        enumName = _ref5.enumName;
		      return "Enum type `" + invalidEnumType + "` is not valid. Use one of `boolean`, `number`, `string`, or `symbol` in enum `" + enumName + "`.";
		    },
		    EnumInvalidExplicitTypeUnknownSupplied: function EnumInvalidExplicitTypeUnknownSupplied(_ref6) {
		      var enumName = _ref6.enumName;
		      return "Supplied enum type is not valid. Use one of `boolean`, `number`, `string`, or `symbol` in enum `" + enumName + "`.";
		    },
		    EnumInvalidMemberInitializerPrimaryType: function EnumInvalidMemberInitializerPrimaryType(_ref7) {
		      var enumName = _ref7.enumName,
		        memberName = _ref7.memberName,
		        explicitType = _ref7.explicitType;
		      return "Enum `" + enumName + "` has type `" + explicitType + "`, so the initializer of `" + memberName + "` needs to be a " + explicitType + " literal.";
		    },
		    EnumInvalidMemberInitializerSymbolType: function EnumInvalidMemberInitializerSymbolType(_ref8) {
		      var enumName = _ref8.enumName,
		        memberName = _ref8.memberName;
		      return "Symbol enum members cannot be initialized. Use `" + memberName + ",` in enum `" + enumName + "`.";
		    },
		    EnumInvalidMemberInitializerUnknownType: function EnumInvalidMemberInitializerUnknownType(_ref9) {
		      var enumName = _ref9.enumName,
		        memberName = _ref9.memberName;
		      return "The enum member initializer for `" + memberName + "` needs to be a literal (either a boolean, number, or string) in enum `" + enumName + "`.";
		    },
		    EnumInvalidMemberName: function EnumInvalidMemberName(_ref10) {
		      var enumName = _ref10.enumName,
		        memberName = _ref10.memberName,
		        suggestion = _ref10.suggestion;
		      return "Enum member names cannot start with lowercase 'a' through 'z'. Instead of using `" + memberName + "`, consider using `" + suggestion + "`, in enum `" + enumName + "`.";
		    },
		    EnumNumberMemberNotInitialized: function EnumNumberMemberNotInitialized(_ref11) {
		      var enumName = _ref11.enumName,
		        memberName = _ref11.memberName;
		      return "Number enum members need to be initialized, e.g. `" + memberName + " = 1` in enum `" + enumName + "`.";
		    },
		    EnumStringMemberInconsistentlyInitialized: function EnumStringMemberInconsistentlyInitialized(_ref12) {
		      var enumName = _ref12.enumName;
		      return "String enum members need to consistently either all use initializers, or use no initializers, in enum `" + enumName + "`.";
		    },
		    GetterMayNotHaveThisParam: "A getter cannot have a `this` parameter.",
		    ImportReflectionHasImportType: "An `import module` declaration can not use `type` or `typeof` keyword.",
		    ImportTypeShorthandOnlyInPureImport: "The `type` and `typeof` keywords on named imports can only be used on regular `import` statements. It cannot be used with `import type` or `import typeof` statements.",
		    InexactInsideExact: "Explicit inexact syntax cannot appear inside an explicit exact object type.",
		    InexactInsideNonObject: "Explicit inexact syntax cannot appear in class or interface definitions.",
		    InexactVariance: "Explicit inexact syntax cannot have variance.",
		    InvalidNonTypeImportInDeclareModule: "Imports within a `declare module` body must always be `import type` or `import typeof`.",
		    MissingTypeParamDefault: "Type parameter declaration needs a default, since a preceding type parameter declaration has a default.",
		    NestedDeclareModule: "`declare module` cannot be used inside another `declare module`.",
		    NestedFlowComment: "Cannot have a flow comment inside another flow comment.",
		    PatternIsOptional: Object.assign({
		      message: "A binding pattern parameter cannot be optional in an implementation signature."
		    }, {
		      reasonCode: "OptionalBindingPattern"
		    }),
		    SetterMayNotHaveThisParam: "A setter cannot have a `this` parameter.",
		    SpreadVariance: "Spread properties cannot have variance.",
		    ThisParamAnnotationRequired: "A type annotation is required for the `this` parameter.",
		    ThisParamBannedInConstructor: "Constructors cannot have a `this` parameter; constructors don't bind `this` like other functions.",
		    ThisParamMayNotBeOptional: "The `this` parameter cannot be optional.",
		    ThisParamMustBeFirst: "The `this` parameter must be the first function parameter.",
		    ThisParamNoDefault: "The `this` parameter may not have a default value.",
		    TypeBeforeInitializer: "Type annotations must come before default assignments, e.g. instead of `age = 25: number` use `age: number = 25`.",
		    TypeCastInPattern: "The type cast expression is expected to be wrapped with parenthesis.",
		    UnexpectedExplicitInexactInObject: "Explicit inexact syntax must appear at the end of an inexact object.",
		    UnexpectedReservedType: function UnexpectedReservedType(_ref13) {
		      var reservedType = _ref13.reservedType;
		      return "Unexpected reserved type " + reservedType + ".";
		    },
		    UnexpectedReservedUnderscore: "`_` is only allowed as a type argument to call or new.",
		    UnexpectedSpaceBetweenModuloChecks: "Spaces between `%` and `checks` are not allowed here.",
		    UnexpectedSpreadType: "Spread operator cannot appear in class or interface definitions.",
		    UnexpectedSubtractionOperand: 'Unexpected token, expected "number" or "bigint".',
		    UnexpectedTokenAfterTypeParameter: "Expected an arrow function after this type parameter declaration.",
		    UnexpectedTypeParameterBeforeAsyncArrowFunction: "Type parameters must come after the async keyword, e.g. instead of `<T> async () => {}`, use `async <T>() => {}`.",
		    UnsupportedDeclareExportKind: function UnsupportedDeclareExportKind(_ref14) {
		      var unsupportedExportKind = _ref14.unsupportedExportKind,
		        suggestion = _ref14.suggestion;
		      return "`declare export " + unsupportedExportKind + "` is not supported. Use `" + suggestion + "` instead.";
		    },
		    UnsupportedStatementInDeclareModule: "Only declares and type imports are allowed inside declare module.",
		    UnterminatedFlowComment: "Unterminated flow-comment."
		  });
		  function isEsModuleType(bodyElement) {
		    return bodyElement.type === "DeclareExportAllDeclaration" || bodyElement.type === "DeclareExportDeclaration" && (!bodyElement.declaration || bodyElement.declaration.type !== "TypeAlias" && bodyElement.declaration.type !== "InterfaceDeclaration");
		  }
		  function hasTypeImportKind(node) {
		    return node.importKind === "type" || node.importKind === "typeof";
		  }
		  var exportSuggestions = {
		    "const": "declare export var",
		    "let": "declare export var",
		    type: "export type",
		    "interface": "export interface"
		  };
		  function partition(list, test) {
		    var list1 = [];
		    var list2 = [];
		    for (var i = 0; i < list.length; i++) {
		      (test(list[i], i, list) ? list1 : list2).push(list[i]);
		    }
		    return [list1, list2];
		  }
		  var FLOW_PRAGMA_REGEX = /\*?\s*@((?:no)?flow)\b/;
		  var flow = (function (superClass) {
		    return function (_superClass) {
		      function FlowParserMixin() {
		        var _this2;
		        for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
		          args[_key] = arguments[_key];
		        }
		        _this2 = _superClass.call.apply(_superClass, [this].concat(args)) || this;
		        _this2.flowPragma = undefined;
		        return _this2;
		      }
		      _inherits(FlowParserMixin, _superClass);
		      var _proto = FlowParserMixin.prototype;
		      _proto.getScopeHandler = function getScopeHandler() {
		        return FlowScopeHandler;
		      };
		      _proto.shouldParseTypes = function shouldParseTypes() {
		        return this.getPluginOption("flow", "all") || this.flowPragma === "flow";
		      };
		      _proto.shouldParseEnums = function shouldParseEnums() {
		        return !!this.getPluginOption("flow", "enums");
		      };
		      _proto.finishToken = function finishToken(type, val) {
		        if (type !== 133 && type !== 13 && type !== 28) {
		          if (this.flowPragma === undefined) {
		            this.flowPragma = null;
		          }
		        }
		        _superClass.prototype.finishToken.call(this, type, val);
		      };
		      _proto.addComment = function addComment(comment) {
		        if (this.flowPragma === undefined) {
		          var matches = FLOW_PRAGMA_REGEX.exec(comment.value);
		          if (!matches) ; else if (matches[1] === "flow") {
		            this.flowPragma = "flow";
		          } else if (matches[1] === "noflow") {
		            this.flowPragma = "noflow";
		          } else {
		            throw new Error("Unexpected flow pragma");
		          }
		        }
		        _superClass.prototype.addComment.call(this, comment);
		      };
		      _proto.flowParseTypeInitialiser = function flowParseTypeInitialiser(tok) {
		        var oldInType = this.state.inType;
		        this.state.inType = true;
		        this.expect(tok || 14);
		        var type = this.flowParseType();
		        this.state.inType = oldInType;
		        return type;
		      };
		      _proto.flowParsePredicate = function flowParsePredicate() {
		        var node = this.startNode();
		        var moduloLoc = this.state.startLoc;
		        this.next();
		        this.expectContextual(110);
		        if (this.state.lastTokStartLoc.index > moduloLoc.index + 1) {
		          this.raise(FlowErrors.UnexpectedSpaceBetweenModuloChecks, moduloLoc);
		        }
		        if (this.eat(10)) {
		          node.value = _superClass.prototype.parseExpression.call(this);
		          this.expect(11);
		          return this.finishNode(node, "DeclaredPredicate");
		        } else {
		          return this.finishNode(node, "InferredPredicate");
		        }
		      };
		      _proto.flowParseTypeAndPredicateInitialiser = function flowParseTypeAndPredicateInitialiser() {
		        var oldInType = this.state.inType;
		        this.state.inType = true;
		        this.expect(14);
		        var type = null;
		        var predicate = null;
		        if (this.match(54)) {
		          this.state.inType = oldInType;
		          predicate = this.flowParsePredicate();
		        } else {
		          type = this.flowParseType();
		          this.state.inType = oldInType;
		          if (this.match(54)) {
		            predicate = this.flowParsePredicate();
		          }
		        }
		        return [type, predicate];
		      };
		      _proto.flowParseDeclareClass = function flowParseDeclareClass(node) {
		        this.next();
		        this.flowParseInterfaceish(node, true);
		        return this.finishNode(node, "DeclareClass");
		      };
		      _proto.flowParseDeclareFunction = function flowParseDeclareFunction(node) {
		        this.next();
		        var id = node.id = this.parseIdentifier();
		        var typeNode = this.startNode();
		        var typeContainer = this.startNode();
		        if (this.match(47)) {
		          typeNode.typeParameters = this.flowParseTypeParameterDeclaration();
		        } else {
		          typeNode.typeParameters = null;
		        }
		        this.expect(10);
		        var tmp = this.flowParseFunctionTypeParams();
		        typeNode.params = tmp.params;
		        typeNode.rest = tmp.rest;
		        typeNode["this"] = tmp._this;
		        this.expect(11);
		        var _this$flowParseTypeAn = this.flowParseTypeAndPredicateInitialiser();
		        typeNode.returnType = _this$flowParseTypeAn[0];
		        node.predicate = _this$flowParseTypeAn[1];
		        typeContainer.typeAnnotation = this.finishNode(typeNode, "FunctionTypeAnnotation");
		        id.typeAnnotation = this.finishNode(typeContainer, "TypeAnnotation");
		        this.resetEndLocation(id);
		        this.semicolon();
		        this.scope.declareName(node.id.name, BindingFlag.TYPE_FLOW_DECLARE_FN, node.id.loc.start);
		        return this.finishNode(node, "DeclareFunction");
		      };
		      _proto.flowParseDeclare = function flowParseDeclare(node, insideModule) {
		        if (this.match(80)) {
		          return this.flowParseDeclareClass(node);
		        } else if (this.match(68)) {
		          return this.flowParseDeclareFunction(node);
		        } else if (this.match(74)) {
		          return this.flowParseDeclareVariable(node);
		        } else if (this.eatContextual(127)) {
		          if (this.match(16)) {
		            return this.flowParseDeclareModuleExports(node);
		          } else {
		            if (insideModule) {
		              this.raise(FlowErrors.NestedDeclareModule, this.state.lastTokStartLoc);
		            }
		            return this.flowParseDeclareModule(node);
		          }
		        } else if (this.isContextual(130)) {
		          return this.flowParseDeclareTypeAlias(node);
		        } else if (this.isContextual(131)) {
		          return this.flowParseDeclareOpaqueType(node);
		        } else if (this.isContextual(129)) {
		          return this.flowParseDeclareInterface(node);
		        } else if (this.match(82)) {
		          return this.flowParseDeclareExportDeclaration(node, insideModule);
		        } else {
		          this.unexpected();
		        }
		      };
		      _proto.flowParseDeclareVariable = function flowParseDeclareVariable(node) {
		        this.next();
		        node.id = this.flowParseTypeAnnotatableIdentifier(true);
		        this.scope.declareName(node.id.name, BindingFlag.TYPE_VAR, node.id.loc.start);
		        this.semicolon();
		        return this.finishNode(node, "DeclareVariable");
		      };
		      _proto.flowParseDeclareModule = function flowParseDeclareModule(node) {
		        var _this3 = this;
		        this.scope.enter(ScopeFlag.OTHER);
		        if (this.match(133)) {
		          node.id = _superClass.prototype.parseExprAtom.call(this);
		        } else {
		          node.id = this.parseIdentifier();
		        }
		        var bodyNode = node.body = this.startNode();
		        var body = bodyNode.body = [];
		        this.expect(5);
		        while (!this.match(8)) {
		          var _bodyNode = this.startNode();
		          if (this.match(83)) {
		            this.next();
		            if (!this.isContextual(130) && !this.match(87)) {
		              this.raise(FlowErrors.InvalidNonTypeImportInDeclareModule, this.state.lastTokStartLoc);
		            }
		            _superClass.prototype.parseImport.call(this, _bodyNode);
		          } else {
		            this.expectContextual(125, FlowErrors.UnsupportedStatementInDeclareModule);
		            _bodyNode = this.flowParseDeclare(_bodyNode, true);
		          }
		          body.push(_bodyNode);
		        }
		        this.scope.exit();
		        this.expect(8);
		        this.finishNode(bodyNode, "BlockStatement");
		        var kind = null;
		        var hasModuleExport = false;
		        body.forEach(function (bodyElement) {
		          if (isEsModuleType(bodyElement)) {
		            if (kind === "CommonJS") {
		              _this3.raise(FlowErrors.AmbiguousDeclareModuleKind, bodyElement);
		            }
		            kind = "ES";
		          } else if (bodyElement.type === "DeclareModuleExports") {
		            if (hasModuleExport) {
		              _this3.raise(FlowErrors.DuplicateDeclareModuleExports, bodyElement);
		            }
		            if (kind === "ES") {
		              _this3.raise(FlowErrors.AmbiguousDeclareModuleKind, bodyElement);
		            }
		            kind = "CommonJS";
		            hasModuleExport = true;
		          }
		        });
		        node.kind = kind || "CommonJS";
		        return this.finishNode(node, "DeclareModule");
		      };
		      _proto.flowParseDeclareExportDeclaration = function flowParseDeclareExportDeclaration(node, insideModule) {
		        this.expect(82);
		        if (this.eat(65)) {
		          if (this.match(68) || this.match(80)) {
		            node.declaration = this.flowParseDeclare(this.startNode());
		          } else {
		            node.declaration = this.flowParseType();
		            this.semicolon();
		          }
		          node["default"] = true;
		          return this.finishNode(node, "DeclareExportDeclaration");
		        } else {
		          if (this.match(75) || this.isLet() || (this.isContextual(130) || this.isContextual(129)) && !insideModule) {
		            var label = this.state.value;
		            throw this.raise(FlowErrors.UnsupportedDeclareExportKind, this.state.startLoc, {
		              unsupportedExportKind: label,
		              suggestion: exportSuggestions[label]
		            });
		          }
		          if (this.match(74) || this.match(68) || this.match(80) || this.isContextual(131)) {
		            node.declaration = this.flowParseDeclare(this.startNode());
		            node["default"] = false;
		            return this.finishNode(node, "DeclareExportDeclaration");
		          } else if (this.match(55) || this.match(5) || this.isContextual(129) || this.isContextual(130) || this.isContextual(131)) {
		            node = this.parseExport(node, null);
		            if (node.type === "ExportNamedDeclaration") {
		              node.type = "ExportDeclaration";
		              node["default"] = false;
		              delete node.exportKind;
		            }
		            node.type = "Declare" + node.type;
		            return node;
		          }
		        }
		        this.unexpected();
		      };
		      _proto.flowParseDeclareModuleExports = function flowParseDeclareModuleExports(node) {
		        this.next();
		        this.expectContextual(111);
		        node.typeAnnotation = this.flowParseTypeAnnotation();
		        this.semicolon();
		        return this.finishNode(node, "DeclareModuleExports");
		      };
		      _proto.flowParseDeclareTypeAlias = function flowParseDeclareTypeAlias(node) {
		        this.next();
		        var finished = this.flowParseTypeAlias(node);
		        finished.type = "DeclareTypeAlias";
		        return finished;
		      };
		      _proto.flowParseDeclareOpaqueType = function flowParseDeclareOpaqueType(node) {
		        this.next();
		        var finished = this.flowParseOpaqueType(node, true);
		        finished.type = "DeclareOpaqueType";
		        return finished;
		      };
		      _proto.flowParseDeclareInterface = function flowParseDeclareInterface(node) {
		        this.next();
		        this.flowParseInterfaceish(node, false);
		        return this.finishNode(node, "DeclareInterface");
		      };
		      _proto.flowParseInterfaceish = function flowParseInterfaceish(node, isClass) {
		        node.id = this.flowParseRestrictedIdentifier(!isClass, true);
		        this.scope.declareName(node.id.name, isClass ? BindingFlag.TYPE_FUNCTION : BindingFlag.TYPE_LEXICAL, node.id.loc.start);
		        if (this.match(47)) {
		          node.typeParameters = this.flowParseTypeParameterDeclaration();
		        } else {
		          node.typeParameters = null;
		        }
		        node["extends"] = [];
		        if (this.eat(81)) {
		          do {
		            node["extends"].push(this.flowParseInterfaceExtends());
		          } while (!isClass && this.eat(12));
		        }
		        if (isClass) {
		          node["implements"] = [];
		          node.mixins = [];
		          if (this.eatContextual(117)) {
		            do {
		              node.mixins.push(this.flowParseInterfaceExtends());
		            } while (this.eat(12));
		          }
		          if (this.eatContextual(113)) {
		            do {
		              node["implements"].push(this.flowParseInterfaceExtends());
		            } while (this.eat(12));
		          }
		        }
		        node.body = this.flowParseObjectType({
		          allowStatic: isClass,
		          allowExact: false,
		          allowSpread: false,
		          allowProto: isClass,
		          allowInexact: false
		        });
		      };
		      _proto.flowParseInterfaceExtends = function flowParseInterfaceExtends() {
		        var node = this.startNode();
		        node.id = this.flowParseQualifiedTypeIdentifier();
		        if (this.match(47)) {
		          node.typeParameters = this.flowParseTypeParameterInstantiation();
		        } else {
		          node.typeParameters = null;
		        }
		        return this.finishNode(node, "InterfaceExtends");
		      };
		      _proto.flowParseInterface = function flowParseInterface(node) {
		        this.flowParseInterfaceish(node, false);
		        return this.finishNode(node, "InterfaceDeclaration");
		      };
		      _proto.checkNotUnderscore = function checkNotUnderscore(word) {
		        if (word === "_") {
		          this.raise(FlowErrors.UnexpectedReservedUnderscore, this.state.startLoc);
		        }
		      };
		      _proto.checkReservedType = function checkReservedType(word, startLoc, declaration) {
		        if (!reservedTypes.has(word)) return;
		        this.raise(declaration ? FlowErrors.AssignReservedType : FlowErrors.UnexpectedReservedType, startLoc, {
		          reservedType: word
		        });
		      };
		      _proto.flowParseRestrictedIdentifier = function flowParseRestrictedIdentifier(liberal, declaration) {
		        this.checkReservedType(this.state.value, this.state.startLoc, declaration);
		        return this.parseIdentifier(liberal);
		      };
		      _proto.flowParseTypeAlias = function flowParseTypeAlias(node) {
		        node.id = this.flowParseRestrictedIdentifier(false, true);
		        this.scope.declareName(node.id.name, BindingFlag.TYPE_LEXICAL, node.id.loc.start);
		        if (this.match(47)) {
		          node.typeParameters = this.flowParseTypeParameterDeclaration();
		        } else {
		          node.typeParameters = null;
		        }
		        node.right = this.flowParseTypeInitialiser(29);
		        this.semicolon();
		        return this.finishNode(node, "TypeAlias");
		      };
		      _proto.flowParseOpaqueType = function flowParseOpaqueType(node, declare) {
		        this.expectContextual(130);
		        node.id = this.flowParseRestrictedIdentifier(true, true);
		        this.scope.declareName(node.id.name, BindingFlag.TYPE_LEXICAL, node.id.loc.start);
		        if (this.match(47)) {
		          node.typeParameters = this.flowParseTypeParameterDeclaration();
		        } else {
		          node.typeParameters = null;
		        }
		        node.supertype = null;
		        if (this.match(14)) {
		          node.supertype = this.flowParseTypeInitialiser(14);
		        }
		        node.impltype = null;
		        if (!declare) {
		          node.impltype = this.flowParseTypeInitialiser(29);
		        }
		        this.semicolon();
		        return this.finishNode(node, "OpaqueType");
		      };
		      _proto.flowParseTypeParameter = function flowParseTypeParameter(requireDefault) {
		        if (requireDefault === void 0) {
		          requireDefault = false;
		        }
		        var nodeStartLoc = this.state.startLoc;
		        var node = this.startNode();
		        var variance = this.flowParseVariance();
		        var ident = this.flowParseTypeAnnotatableIdentifier();
		        node.name = ident.name;
		        node.variance = variance;
		        node.bound = ident.typeAnnotation;
		        if (this.match(29)) {
		          this.eat(29);
		          node["default"] = this.flowParseType();
		        } else {
		          if (requireDefault) {
		            this.raise(FlowErrors.MissingTypeParamDefault, nodeStartLoc);
		          }
		        }
		        return this.finishNode(node, "TypeParameter");
		      };
		      _proto.flowParseTypeParameterDeclaration = function flowParseTypeParameterDeclaration() {
		        var oldInType = this.state.inType;
		        var node = this.startNode();
		        node.params = [];
		        this.state.inType = true;
		        if (this.match(47) || this.match(142)) {
		          this.next();
		        } else {
		          this.unexpected();
		        }
		        var defaultRequired = false;
		        do {
		          var typeParameter = this.flowParseTypeParameter(defaultRequired);
		          node.params.push(typeParameter);
		          if (typeParameter["default"]) {
		            defaultRequired = true;
		          }
		          if (!this.match(48)) {
		            this.expect(12);
		          }
		        } while (!this.match(48));
		        this.expect(48);
		        this.state.inType = oldInType;
		        return this.finishNode(node, "TypeParameterDeclaration");
		      };
		      _proto.flowParseTypeParameterInstantiation = function flowParseTypeParameterInstantiation() {
		        var node = this.startNode();
		        var oldInType = this.state.inType;
		        node.params = [];
		        this.state.inType = true;
		        this.expect(47);
		        var oldNoAnonFunctionType = this.state.noAnonFunctionType;
		        this.state.noAnonFunctionType = false;
		        while (!this.match(48)) {
		          node.params.push(this.flowParseType());
		          if (!this.match(48)) {
		            this.expect(12);
		          }
		        }
		        this.state.noAnonFunctionType = oldNoAnonFunctionType;
		        this.expect(48);
		        this.state.inType = oldInType;
		        return this.finishNode(node, "TypeParameterInstantiation");
		      };
		      _proto.flowParseTypeParameterInstantiationCallOrNew = function flowParseTypeParameterInstantiationCallOrNew() {
		        var node = this.startNode();
		        var oldInType = this.state.inType;
		        node.params = [];
		        this.state.inType = true;
		        this.expect(47);
		        while (!this.match(48)) {
		          node.params.push(this.flowParseTypeOrImplicitInstantiation());
		          if (!this.match(48)) {
		            this.expect(12);
		          }
		        }
		        this.expect(48);
		        this.state.inType = oldInType;
		        return this.finishNode(node, "TypeParameterInstantiation");
		      };
		      _proto.flowParseInterfaceType = function flowParseInterfaceType() {
		        var node = this.startNode();
		        this.expectContextual(129);
		        node["extends"] = [];
		        if (this.eat(81)) {
		          do {
		            node["extends"].push(this.flowParseInterfaceExtends());
		          } while (this.eat(12));
		        }
		        node.body = this.flowParseObjectType({
		          allowStatic: false,
		          allowExact: false,
		          allowSpread: false,
		          allowProto: false,
		          allowInexact: false
		        });
		        return this.finishNode(node, "InterfaceTypeAnnotation");
		      };
		      _proto.flowParseObjectPropertyKey = function flowParseObjectPropertyKey() {
		        return this.match(134) || this.match(133) ? _superClass.prototype.parseExprAtom.call(this) : this.parseIdentifier(true);
		      };
		      _proto.flowParseObjectTypeIndexer = function flowParseObjectTypeIndexer(node, isStatic, variance) {
		        node["static"] = isStatic;
		        if (this.lookahead().type === 14) {
		          node.id = this.flowParseObjectPropertyKey();
		          node.key = this.flowParseTypeInitialiser();
		        } else {
		          node.id = null;
		          node.key = this.flowParseType();
		        }
		        this.expect(3);
		        node.value = this.flowParseTypeInitialiser();
		        node.variance = variance;
		        return this.finishNode(node, "ObjectTypeIndexer");
		      };
		      _proto.flowParseObjectTypeInternalSlot = function flowParseObjectTypeInternalSlot(node, isStatic) {
		        node["static"] = isStatic;
		        node.id = this.flowParseObjectPropertyKey();
		        this.expect(3);
		        this.expect(3);
		        if (this.match(47) || this.match(10)) {
		          node.method = true;
		          node.optional = false;
		          node.value = this.flowParseObjectTypeMethodish(this.startNodeAt(node.loc.start));
		        } else {
		          node.method = false;
		          if (this.eat(17)) {
		            node.optional = true;
		          }
		          node.value = this.flowParseTypeInitialiser();
		        }
		        return this.finishNode(node, "ObjectTypeInternalSlot");
		      };
		      _proto.flowParseObjectTypeMethodish = function flowParseObjectTypeMethodish(node) {
		        node.params = [];
		        node.rest = null;
		        node.typeParameters = null;
		        node["this"] = null;
		        if (this.match(47)) {
		          node.typeParameters = this.flowParseTypeParameterDeclaration();
		        }
		        this.expect(10);
		        if (this.match(78)) {
		          node["this"] = this.flowParseFunctionTypeParam(true);
		          node["this"].name = null;
		          if (!this.match(11)) {
		            this.expect(12);
		          }
		        }
		        while (!this.match(11) && !this.match(21)) {
		          node.params.push(this.flowParseFunctionTypeParam(false));
		          if (!this.match(11)) {
		            this.expect(12);
		          }
		        }
		        if (this.eat(21)) {
		          node.rest = this.flowParseFunctionTypeParam(false);
		        }
		        this.expect(11);
		        node.returnType = this.flowParseTypeInitialiser();
		        return this.finishNode(node, "FunctionTypeAnnotation");
		      };
		      _proto.flowParseObjectTypeCallProperty = function flowParseObjectTypeCallProperty(node, isStatic) {
		        var valueNode = this.startNode();
		        node["static"] = isStatic;
		        node.value = this.flowParseObjectTypeMethodish(valueNode);
		        return this.finishNode(node, "ObjectTypeCallProperty");
		      };
		      _proto.flowParseObjectType = function flowParseObjectType(_ref15) {
		        var allowStatic = _ref15.allowStatic,
		          allowExact = _ref15.allowExact,
		          allowSpread = _ref15.allowSpread,
		          allowProto = _ref15.allowProto,
		          allowInexact = _ref15.allowInexact;
		        var oldInType = this.state.inType;
		        this.state.inType = true;
		        var nodeStart = this.startNode();
		        nodeStart.callProperties = [];
		        nodeStart.properties = [];
		        nodeStart.indexers = [];
		        nodeStart.internalSlots = [];
		        var endDelim;
		        var exact;
		        var inexact = false;
		        if (allowExact && this.match(6)) {
		          this.expect(6);
		          endDelim = 9;
		          exact = true;
		        } else {
		          this.expect(5);
		          endDelim = 8;
		          exact = false;
		        }
		        nodeStart.exact = exact;
		        while (!this.match(endDelim)) {
		          var isStatic = false;
		          var protoStartLoc = null;
		          var inexactStartLoc = null;
		          var node = this.startNode();
		          if (allowProto && this.isContextual(118)) {
		            var lookahead = this.lookahead();
		            if (lookahead.type !== 14 && lookahead.type !== 17) {
		              this.next();
		              protoStartLoc = this.state.startLoc;
		              allowStatic = false;
		            }
		          }
		          if (allowStatic && this.isContextual(106)) {
		            var _lookahead = this.lookahead();
		            if (_lookahead.type !== 14 && _lookahead.type !== 17) {
		              this.next();
		              isStatic = true;
		            }
		          }
		          var variance = this.flowParseVariance();
		          if (this.eat(0)) {
		            if (protoStartLoc != null) {
		              this.unexpected(protoStartLoc);
		            }
		            if (this.eat(0)) {
		              if (variance) {
		                this.unexpected(variance.loc.start);
		              }
		              nodeStart.internalSlots.push(this.flowParseObjectTypeInternalSlot(node, isStatic));
		            } else {
		              nodeStart.indexers.push(this.flowParseObjectTypeIndexer(node, isStatic, variance));
		            }
		          } else if (this.match(10) || this.match(47)) {
		            if (protoStartLoc != null) {
		              this.unexpected(protoStartLoc);
		            }
		            if (variance) {
		              this.unexpected(variance.loc.start);
		            }
		            nodeStart.callProperties.push(this.flowParseObjectTypeCallProperty(node, isStatic));
		          } else {
		            var kind = "init";
		            if (this.isContextual(99) || this.isContextual(104)) {
		              var _lookahead2 = this.lookahead();
		              if (tokenIsLiteralPropertyName(_lookahead2.type)) {
		                kind = this.state.value;
		                this.next();
		              }
		            }
		            var propOrInexact = this.flowParseObjectTypeProperty(node, isStatic, protoStartLoc, variance, kind, allowSpread, allowInexact != null ? allowInexact : !exact);
		            if (propOrInexact === null) {
		              inexact = true;
		              inexactStartLoc = this.state.lastTokStartLoc;
		            } else {
		              nodeStart.properties.push(propOrInexact);
		            }
		          }
		          this.flowObjectTypeSemicolon();
		          if (inexactStartLoc && !this.match(8) && !this.match(9)) {
		            this.raise(FlowErrors.UnexpectedExplicitInexactInObject, inexactStartLoc);
		          }
		        }
		        this.expect(endDelim);
		        if (allowSpread) {
		          nodeStart.inexact = inexact;
		        }
		        var out = this.finishNode(nodeStart, "ObjectTypeAnnotation");
		        this.state.inType = oldInType;
		        return out;
		      };
		      _proto.flowParseObjectTypeProperty = function flowParseObjectTypeProperty(node, isStatic, protoStartLoc, variance, kind, allowSpread, allowInexact) {
		        if (this.eat(21)) {
		          var isInexactToken = this.match(12) || this.match(13) || this.match(8) || this.match(9);
		          if (isInexactToken) {
		            if (!allowSpread) {
		              this.raise(FlowErrors.InexactInsideNonObject, this.state.lastTokStartLoc);
		            } else if (!allowInexact) {
		              this.raise(FlowErrors.InexactInsideExact, this.state.lastTokStartLoc);
		            }
		            if (variance) {
		              this.raise(FlowErrors.InexactVariance, variance);
		            }
		            return null;
		          }
		          if (!allowSpread) {
		            this.raise(FlowErrors.UnexpectedSpreadType, this.state.lastTokStartLoc);
		          }
		          if (protoStartLoc != null) {
		            this.unexpected(protoStartLoc);
		          }
		          if (variance) {
		            this.raise(FlowErrors.SpreadVariance, variance);
		          }
		          node.argument = this.flowParseType();
		          return this.finishNode(node, "ObjectTypeSpreadProperty");
		        } else {
		          node.key = this.flowParseObjectPropertyKey();
		          node["static"] = isStatic;
		          node.proto = protoStartLoc != null;
		          node.kind = kind;
		          var optional = false;
		          if (this.match(47) || this.match(10)) {
		            node.method = true;
		            if (protoStartLoc != null) {
		              this.unexpected(protoStartLoc);
		            }
		            if (variance) {
		              this.unexpected(variance.loc.start);
		            }
		            node.value = this.flowParseObjectTypeMethodish(this.startNodeAt(node.loc.start));
		            if (kind === "get" || kind === "set") {
		              this.flowCheckGetterSetterParams(node);
		            }
		            if (!allowSpread && node.key.name === "constructor" && node.value["this"]) {
		              this.raise(FlowErrors.ThisParamBannedInConstructor, node.value["this"]);
		            }
		          } else {
		            if (kind !== "init") this.unexpected();
		            node.method = false;
		            if (this.eat(17)) {
		              optional = true;
		            }
		            node.value = this.flowParseTypeInitialiser();
		            node.variance = variance;
		          }
		          node.optional = optional;
		          return this.finishNode(node, "ObjectTypeProperty");
		        }
		      };
		      _proto.flowCheckGetterSetterParams = function flowCheckGetterSetterParams(property) {
		        var paramCount = property.kind === "get" ? 0 : 1;
		        var length = property.value.params.length + (property.value.rest ? 1 : 0);
		        if (property.value["this"]) {
		          this.raise(property.kind === "get" ? FlowErrors.GetterMayNotHaveThisParam : FlowErrors.SetterMayNotHaveThisParam, property.value["this"]);
		        }
		        if (length !== paramCount) {
		          this.raise(property.kind === "get" ? Errors.BadGetterArity : Errors.BadSetterArity, property);
		        }
		        if (property.kind === "set" && property.value.rest) {
		          this.raise(Errors.BadSetterRestParameter, property);
		        }
		      };
		      _proto.flowObjectTypeSemicolon = function flowObjectTypeSemicolon() {
		        if (!this.eat(13) && !this.eat(12) && !this.match(8) && !this.match(9)) {
		          this.unexpected();
		        }
		      };
		      _proto.flowParseQualifiedTypeIdentifier = function flowParseQualifiedTypeIdentifier(startLoc, id) {
		        var _startLoc;
		        (_startLoc = startLoc) != null ? _startLoc : startLoc = this.state.startLoc;
		        var node = id || this.flowParseRestrictedIdentifier(true);
		        while (this.eat(16)) {
		          var node2 = this.startNodeAt(startLoc);
		          node2.qualification = node;
		          node2.id = this.flowParseRestrictedIdentifier(true);
		          node = this.finishNode(node2, "QualifiedTypeIdentifier");
		        }
		        return node;
		      };
		      _proto.flowParseGenericType = function flowParseGenericType(startLoc, id) {
		        var node = this.startNodeAt(startLoc);
		        node.typeParameters = null;
		        node.id = this.flowParseQualifiedTypeIdentifier(startLoc, id);
		        if (this.match(47)) {
		          node.typeParameters = this.flowParseTypeParameterInstantiation();
		        }
		        return this.finishNode(node, "GenericTypeAnnotation");
		      };
		      _proto.flowParseTypeofType = function flowParseTypeofType() {
		        var node = this.startNode();
		        this.expect(87);
		        node.argument = this.flowParsePrimaryType();
		        return this.finishNode(node, "TypeofTypeAnnotation");
		      };
		      _proto.flowParseTupleType = function flowParseTupleType() {
		        var node = this.startNode();
		        node.types = [];
		        this.expect(0);
		        while (this.state.pos < this.length && !this.match(3)) {
		          node.types.push(this.flowParseType());
		          if (this.match(3)) break;
		          this.expect(12);
		        }
		        this.expect(3);
		        return this.finishNode(node, "TupleTypeAnnotation");
		      };
		      _proto.flowParseFunctionTypeParam = function flowParseFunctionTypeParam(first) {
		        var name = null;
		        var optional = false;
		        var typeAnnotation = null;
		        var node = this.startNode();
		        var lh = this.lookahead();
		        var isThis = this.state.type === 78;
		        if (lh.type === 14 || lh.type === 17) {
		          if (isThis && !first) {
		            this.raise(FlowErrors.ThisParamMustBeFirst, node);
		          }
		          name = this.parseIdentifier(isThis);
		          if (this.eat(17)) {
		            optional = true;
		            if (isThis) {
		              this.raise(FlowErrors.ThisParamMayNotBeOptional, node);
		            }
		          }
		          typeAnnotation = this.flowParseTypeInitialiser();
		        } else {
		          typeAnnotation = this.flowParseType();
		        }
		        node.name = name;
		        node.optional = optional;
		        node.typeAnnotation = typeAnnotation;
		        return this.finishNode(node, "FunctionTypeParam");
		      };
		      _proto.reinterpretTypeAsFunctionTypeParam = function reinterpretTypeAsFunctionTypeParam(type) {
		        var node = this.startNodeAt(type.loc.start);
		        node.name = null;
		        node.optional = false;
		        node.typeAnnotation = type;
		        return this.finishNode(node, "FunctionTypeParam");
		      };
		      _proto.flowParseFunctionTypeParams = function flowParseFunctionTypeParams(params) {
		        if (params === void 0) {
		          params = [];
		        }
		        var rest = null;
		        var _this = null;
		        if (this.match(78)) {
		          _this = this.flowParseFunctionTypeParam(true);
		          _this.name = null;
		          if (!this.match(11)) {
		            this.expect(12);
		          }
		        }
		        while (!this.match(11) && !this.match(21)) {
		          params.push(this.flowParseFunctionTypeParam(false));
		          if (!this.match(11)) {
		            this.expect(12);
		          }
		        }
		        if (this.eat(21)) {
		          rest = this.flowParseFunctionTypeParam(false);
		        }
		        return {
		          params: params,
		          rest: rest,
		          _this: _this
		        };
		      };
		      _proto.flowIdentToTypeAnnotation = function flowIdentToTypeAnnotation(startLoc, node, id) {
		        switch (id.name) {
		          case "any":
		            return this.finishNode(node, "AnyTypeAnnotation");
		          case "bool":
		          case "boolean":
		            return this.finishNode(node, "BooleanTypeAnnotation");
		          case "mixed":
		            return this.finishNode(node, "MixedTypeAnnotation");
		          case "empty":
		            return this.finishNode(node, "EmptyTypeAnnotation");
		          case "number":
		            return this.finishNode(node, "NumberTypeAnnotation");
		          case "string":
		            return this.finishNode(node, "StringTypeAnnotation");
		          case "symbol":
		            return this.finishNode(node, "SymbolTypeAnnotation");
		          default:
		            this.checkNotUnderscore(id.name);
		            return this.flowParseGenericType(startLoc, id);
		        }
		      };
		      _proto.flowParsePrimaryType = function flowParsePrimaryType() {
		        var startLoc = this.state.startLoc;
		        var node = this.startNode();
		        var tmp;
		        var type;
		        var isGroupedType = false;
		        var oldNoAnonFunctionType = this.state.noAnonFunctionType;
		        switch (this.state.type) {
		          case 5:
		            return this.flowParseObjectType({
		              allowStatic: false,
		              allowExact: false,
		              allowSpread: true,
		              allowProto: false,
		              allowInexact: true
		            });
		          case 6:
		            return this.flowParseObjectType({
		              allowStatic: false,
		              allowExact: true,
		              allowSpread: true,
		              allowProto: false,
		              allowInexact: false
		            });
		          case 0:
		            this.state.noAnonFunctionType = false;
		            type = this.flowParseTupleType();
		            this.state.noAnonFunctionType = oldNoAnonFunctionType;
		            return type;
		          case 47:
		            {
		              var _node = this.startNode();
		              _node.typeParameters = this.flowParseTypeParameterDeclaration();
		              this.expect(10);
		              tmp = this.flowParseFunctionTypeParams();
		              _node.params = tmp.params;
		              _node.rest = tmp.rest;
		              _node["this"] = tmp._this;
		              this.expect(11);
		              this.expect(19);
		              _node.returnType = this.flowParseType();
		              return this.finishNode(_node, "FunctionTypeAnnotation");
		            }
		          case 10:
		            {
		              var _node2 = this.startNode();
		              this.next();
		              if (!this.match(11) && !this.match(21)) {
		                if (tokenIsIdentifier(this.state.type) || this.match(78)) {
		                  var token = this.lookahead().type;
		                  isGroupedType = token !== 17 && token !== 14;
		                } else {
		                  isGroupedType = true;
		                }
		              }
		              if (isGroupedType) {
		                this.state.noAnonFunctionType = false;
		                type = this.flowParseType();
		                this.state.noAnonFunctionType = oldNoAnonFunctionType;
		                if (this.state.noAnonFunctionType || !(this.match(12) || this.match(11) && this.lookahead().type === 19)) {
		                  this.expect(11);
		                  return type;
		                } else {
		                  this.eat(12);
		                }
		              }
		              if (type) {
		                tmp = this.flowParseFunctionTypeParams([this.reinterpretTypeAsFunctionTypeParam(type)]);
		              } else {
		                tmp = this.flowParseFunctionTypeParams();
		              }
		              _node2.params = tmp.params;
		              _node2.rest = tmp.rest;
		              _node2["this"] = tmp._this;
		              this.expect(11);
		              this.expect(19);
		              _node2.returnType = this.flowParseType();
		              _node2.typeParameters = null;
		              return this.finishNode(_node2, "FunctionTypeAnnotation");
		            }
		          case 133:
		            return this.parseLiteral(this.state.value, "StringLiteralTypeAnnotation");
		          case 85:
		          case 86:
		            node.value = this.match(85);
		            this.next();
		            return this.finishNode(node, "BooleanLiteralTypeAnnotation");
		          case 53:
		            if (this.state.value === "-") {
		              this.next();
		              if (this.match(134)) {
		                return this.parseLiteralAtNode(-this.state.value, "NumberLiteralTypeAnnotation", node);
		              }
		              if (this.match(135)) {
		                return this.parseLiteralAtNode(-this.state.value, "BigIntLiteralTypeAnnotation", node);
		              }
		              throw this.raise(FlowErrors.UnexpectedSubtractionOperand, this.state.startLoc);
		            }
		            this.unexpected();
		            return;
		          case 134:
		            return this.parseLiteral(this.state.value, "NumberLiteralTypeAnnotation");
		          case 135:
		            return this.parseLiteral(this.state.value, "BigIntLiteralTypeAnnotation");
		          case 88:
		            this.next();
		            return this.finishNode(node, "VoidTypeAnnotation");
		          case 84:
		            this.next();
		            return this.finishNode(node, "NullLiteralTypeAnnotation");
		          case 78:
		            this.next();
		            return this.finishNode(node, "ThisTypeAnnotation");
		          case 55:
		            this.next();
		            return this.finishNode(node, "ExistsTypeAnnotation");
		          case 87:
		            return this.flowParseTypeofType();
		          default:
		            if (tokenIsKeyword(this.state.type)) {
		              var label = tokenLabelName(this.state.type);
		              this.next();
		              return _superClass.prototype.createIdentifier.call(this, node, label);
		            } else if (tokenIsIdentifier(this.state.type)) {
		              if (this.isContextual(129)) {
		                return this.flowParseInterfaceType();
		              }
		              return this.flowIdentToTypeAnnotation(startLoc, node, this.parseIdentifier());
		            }
		        }
		        this.unexpected();
		      };
		      _proto.flowParsePostfixType = function flowParsePostfixType() {
		        var startLoc = this.state.startLoc;
		        var type = this.flowParsePrimaryType();
		        var seenOptionalIndexedAccess = false;
		        while ((this.match(0) || this.match(18)) && !this.canInsertSemicolon()) {
		          var node = this.startNodeAt(startLoc);
		          var optional = this.eat(18);
		          seenOptionalIndexedAccess = seenOptionalIndexedAccess || optional;
		          this.expect(0);
		          if (!optional && this.match(3)) {
		            node.elementType = type;
		            this.next();
		            type = this.finishNode(node, "ArrayTypeAnnotation");
		          } else {
		            node.objectType = type;
		            node.indexType = this.flowParseType();
		            this.expect(3);
		            if (seenOptionalIndexedAccess) {
		              node.optional = optional;
		              type = this.finishNode(node, "OptionalIndexedAccessType");
		            } else {
		              type = this.finishNode(node, "IndexedAccessType");
		            }
		          }
		        }
		        return type;
		      };
		      _proto.flowParsePrefixType = function flowParsePrefixType() {
		        var node = this.startNode();
		        if (this.eat(17)) {
		          node.typeAnnotation = this.flowParsePrefixType();
		          return this.finishNode(node, "NullableTypeAnnotation");
		        } else {
		          return this.flowParsePostfixType();
		        }
		      };
		      _proto.flowParseAnonFunctionWithoutParens = function flowParseAnonFunctionWithoutParens() {
		        var param = this.flowParsePrefixType();
		        if (!this.state.noAnonFunctionType && this.eat(19)) {
		          var node = this.startNodeAt(param.loc.start);
		          node.params = [this.reinterpretTypeAsFunctionTypeParam(param)];
		          node.rest = null;
		          node["this"] = null;
		          node.returnType = this.flowParseType();
		          node.typeParameters = null;
		          return this.finishNode(node, "FunctionTypeAnnotation");
		        }
		        return param;
		      };
		      _proto.flowParseIntersectionType = function flowParseIntersectionType() {
		        var node = this.startNode();
		        this.eat(45);
		        var type = this.flowParseAnonFunctionWithoutParens();
		        node.types = [type];
		        while (this.eat(45)) {
		          node.types.push(this.flowParseAnonFunctionWithoutParens());
		        }
		        return node.types.length === 1 ? type : this.finishNode(node, "IntersectionTypeAnnotation");
		      };
		      _proto.flowParseUnionType = function flowParseUnionType() {
		        var node = this.startNode();
		        this.eat(43);
		        var type = this.flowParseIntersectionType();
		        node.types = [type];
		        while (this.eat(43)) {
		          node.types.push(this.flowParseIntersectionType());
		        }
		        return node.types.length === 1 ? type : this.finishNode(node, "UnionTypeAnnotation");
		      };
		      _proto.flowParseType = function flowParseType() {
		        var oldInType = this.state.inType;
		        this.state.inType = true;
		        var type = this.flowParseUnionType();
		        this.state.inType = oldInType;
		        return type;
		      };
		      _proto.flowParseTypeOrImplicitInstantiation = function flowParseTypeOrImplicitInstantiation() {
		        if (this.state.type === 132 && this.state.value === "_") {
		          var startLoc = this.state.startLoc;
		          var node = this.parseIdentifier();
		          return this.flowParseGenericType(startLoc, node);
		        } else {
		          return this.flowParseType();
		        }
		      };
		      _proto.flowParseTypeAnnotation = function flowParseTypeAnnotation() {
		        var node = this.startNode();
		        node.typeAnnotation = this.flowParseTypeInitialiser();
		        return this.finishNode(node, "TypeAnnotation");
		      };
		      _proto.flowParseTypeAnnotatableIdentifier = function flowParseTypeAnnotatableIdentifier(allowPrimitiveOverride) {
		        var ident = allowPrimitiveOverride ? this.parseIdentifier() : this.flowParseRestrictedIdentifier();
		        if (this.match(14)) {
		          ident.typeAnnotation = this.flowParseTypeAnnotation();
		          this.resetEndLocation(ident);
		        }
		        return ident;
		      };
		      _proto.typeCastToParameter = function typeCastToParameter(node) {
		        node.expression.typeAnnotation = node.typeAnnotation;
		        this.resetEndLocation(node.expression, node.typeAnnotation.loc.end);
		        return node.expression;
		      };
		      _proto.flowParseVariance = function flowParseVariance() {
		        var variance = null;
		        if (this.match(53)) {
		          variance = this.startNode();
		          if (this.state.value === "+") {
		            variance.kind = "plus";
		          } else {
		            variance.kind = "minus";
		          }
		          this.next();
		          return this.finishNode(variance, "Variance");
		        }
		        return variance;
		      };
		      _proto.parseFunctionBody = function parseFunctionBody(node, allowExpressionBody, isMethod) {
		        var _this4 = this;
		        if (isMethod === void 0) {
		          isMethod = false;
		        }
		        if (allowExpressionBody) {
		          this.forwardNoArrowParamsConversionAt(node, function () {
		            return _superClass.prototype.parseFunctionBody.call(_this4, node, true, isMethod);
		          });
		          return;
		        }
		        _superClass.prototype.parseFunctionBody.call(this, node, false, isMethod);
		      };
		      _proto.parseFunctionBodyAndFinish = function parseFunctionBodyAndFinish(node, type, isMethod) {
		        if (isMethod === void 0) {
		          isMethod = false;
		        }
		        if (this.match(14)) {
		          var typeNode = this.startNode();
		          var _this$flowParseTypeAn2 = this.flowParseTypeAndPredicateInitialiser();
		          typeNode.typeAnnotation = _this$flowParseTypeAn2[0];
		          node.predicate = _this$flowParseTypeAn2[1];
		          node.returnType = typeNode.typeAnnotation ? this.finishNode(typeNode, "TypeAnnotation") : null;
		        }
		        return _superClass.prototype.parseFunctionBodyAndFinish.call(this, node, type, isMethod);
		      };
		      _proto.parseStatementLike = function parseStatementLike(flags) {
		        if (this.state.strict && this.isContextual(129)) {
		          var lookahead = this.lookahead();
		          if (tokenIsKeywordOrIdentifier(lookahead.type)) {
		            var node = this.startNode();
		            this.next();
		            return this.flowParseInterface(node);
		          }
		        } else if (this.shouldParseEnums() && this.isContextual(126)) {
		          var _node3 = this.startNode();
		          this.next();
		          return this.flowParseEnumDeclaration(_node3);
		        }
		        var stmt = _superClass.prototype.parseStatementLike.call(this, flags);
		        if (this.flowPragma === undefined && !this.isValidDirective(stmt)) {
		          this.flowPragma = null;
		        }
		        return stmt;
		      };
		      _proto.parseExpressionStatement = function parseExpressionStatement(node, expr, decorators) {
		        if (expr.type === "Identifier") {
		          if (expr.name === "declare") {
		            if (this.match(80) || tokenIsIdentifier(this.state.type) || this.match(68) || this.match(74) || this.match(82)) {
		              return this.flowParseDeclare(node);
		            }
		          } else if (tokenIsIdentifier(this.state.type)) {
		            if (expr.name === "interface") {
		              return this.flowParseInterface(node);
		            } else if (expr.name === "type") {
		              return this.flowParseTypeAlias(node);
		            } else if (expr.name === "opaque") {
		              return this.flowParseOpaqueType(node, false);
		            }
		          }
		        }
		        return _superClass.prototype.parseExpressionStatement.call(this, node, expr, decorators);
		      };
		      _proto.shouldParseExportDeclaration = function shouldParseExportDeclaration() {
		        var type = this.state.type;
		        if (tokenIsFlowInterfaceOrTypeOrOpaque(type) || this.shouldParseEnums() && type === 126) {
		          return !this.state.containsEsc;
		        }
		        return _superClass.prototype.shouldParseExportDeclaration.call(this);
		      };
		      _proto.isExportDefaultSpecifier = function isExportDefaultSpecifier() {
		        var type = this.state.type;
		        if (tokenIsFlowInterfaceOrTypeOrOpaque(type) || this.shouldParseEnums() && type === 126) {
		          return this.state.containsEsc;
		        }
		        return _superClass.prototype.isExportDefaultSpecifier.call(this);
		      };
		      _proto.parseExportDefaultExpression = function parseExportDefaultExpression() {
		        if (this.shouldParseEnums() && this.isContextual(126)) {
		          var node = this.startNode();
		          this.next();
		          return this.flowParseEnumDeclaration(node);
		        }
		        return _superClass.prototype.parseExportDefaultExpression.call(this);
		      };
		      _proto.parseConditional = function parseConditional(expr, startLoc, refExpressionErrors) {
		        var _this5 = this;
		        if (!this.match(17)) return expr;
		        if (this.state.maybeInArrowParameters) {
		          var nextCh = this.lookaheadCharCode();
		          if (nextCh === 44 || nextCh === 61 || nextCh === 58 || nextCh === 41) {
		            this.setOptionalParametersError(refExpressionErrors);
		            return expr;
		          }
		        }
		        this.expect(17);
		        var state = this.state.clone();
		        var originalNoArrowAt = this.state.noArrowAt;
		        var node = this.startNodeAt(startLoc);
		        var _this$tryParseConditi = this.tryParseConditionalConsequent(),
		          consequent = _this$tryParseConditi.consequent,
		          failed = _this$tryParseConditi.failed;
		        var _this$getArrowLikeExp = this.getArrowLikeExpressions(consequent),
		          valid = _this$getArrowLikeExp[0],
		          invalid = _this$getArrowLikeExp[1];
		        if (failed || invalid.length > 0) {
		          var noArrowAt = [].concat(originalNoArrowAt);
		          if (invalid.length > 0) {
		            this.state = state;
		            this.state.noArrowAt = noArrowAt;
		            for (var i = 0; i < invalid.length; i++) {
		              noArrowAt.push(invalid[i].start);
		            }
		            var _this$tryParseConditi2 = this.tryParseConditionalConsequent();
		            consequent = _this$tryParseConditi2.consequent;
		            failed = _this$tryParseConditi2.failed;
		            var _this$getArrowLikeExp2 = this.getArrowLikeExpressions(consequent);
		            valid = _this$getArrowLikeExp2[0];
		            invalid = _this$getArrowLikeExp2[1];
		          }
		          if (failed && valid.length > 1) {
		            this.raise(FlowErrors.AmbiguousConditionalArrow, state.startLoc);
		          }
		          if (failed && valid.length === 1) {
		            this.state = state;
		            noArrowAt.push(valid[0].start);
		            this.state.noArrowAt = noArrowAt;
		            var _this$tryParseConditi3 = this.tryParseConditionalConsequent();
		            consequent = _this$tryParseConditi3.consequent;
		            failed = _this$tryParseConditi3.failed;
		          }
		        }
		        this.getArrowLikeExpressions(consequent, true);
		        this.state.noArrowAt = originalNoArrowAt;
		        this.expect(14);
		        node.test = expr;
		        node.consequent = consequent;
		        node.alternate = this.forwardNoArrowParamsConversionAt(node, function () {
		          return _this5.parseMaybeAssign(undefined, undefined);
		        });
		        return this.finishNode(node, "ConditionalExpression");
		      };
		      _proto.tryParseConditionalConsequent = function tryParseConditionalConsequent() {
		        this.state.noArrowParamsConversionAt.push(this.state.start);
		        var consequent = this.parseMaybeAssignAllowIn();
		        var failed = !this.match(14);
		        this.state.noArrowParamsConversionAt.pop();
		        return {
		          consequent: consequent,
		          failed: failed
		        };
		      };
		      _proto.getArrowLikeExpressions = function getArrowLikeExpressions(node, disallowInvalid) {
		        var _this6 = this;
		        var stack = [node];
		        var arrows = [];
		        while (stack.length !== 0) {
		          var _node4 = stack.pop();
		          if (_node4.type === "ArrowFunctionExpression" && _node4.body.type !== "BlockStatement") {
		            if (_node4.typeParameters || !_node4.returnType) {
		              this.finishArrowValidation(_node4);
		            } else {
		              arrows.push(_node4);
		            }
		            stack.push(_node4.body);
		          } else if (_node4.type === "ConditionalExpression") {
		            stack.push(_node4.consequent);
		            stack.push(_node4.alternate);
		          }
		        }
		        if (disallowInvalid) {
		          arrows.forEach(function (node) {
		            return _this6.finishArrowValidation(node);
		          });
		          return [arrows, []];
		        }
		        return partition(arrows, function (node) {
		          return node.params.every(function (param) {
		            return _this6.isAssignable(param, true);
		          });
		        });
		      };
		      _proto.finishArrowValidation = function finishArrowValidation(node) {
		        var _node$extra;
		        this.toAssignableList(node.params, (_node$extra = node.extra) == null ? void 0 : _node$extra.trailingCommaLoc, false);
		        this.scope.enter(ScopeFlag.FUNCTION | ScopeFlag.ARROW);
		        _superClass.prototype.checkParams.call(this, node, false, true);
		        this.scope.exit();
		      };
		      _proto.forwardNoArrowParamsConversionAt = function forwardNoArrowParamsConversionAt(node, parse) {
		        var result;
		        if (this.state.noArrowParamsConversionAt.indexOf(node.start) !== -1) {
		          this.state.noArrowParamsConversionAt.push(this.state.start);
		          result = parse();
		          this.state.noArrowParamsConversionAt.pop();
		        } else {
		          result = parse();
		        }
		        return result;
		      };
		      _proto.parseParenItem = function parseParenItem(node, startLoc) {
		        var newNode = _superClass.prototype.parseParenItem.call(this, node, startLoc);
		        if (this.eat(17)) {
		          newNode.optional = true;
		          this.resetEndLocation(node);
		        }
		        if (this.match(14)) {
		          var typeCastNode = this.startNodeAt(startLoc);
		          typeCastNode.expression = newNode;
		          typeCastNode.typeAnnotation = this.flowParseTypeAnnotation();
		          return this.finishNode(typeCastNode, "TypeCastExpression");
		        }
		        return newNode;
		      };
		      _proto.assertModuleNodeAllowed = function assertModuleNodeAllowed(node) {
		        if (node.type === "ImportDeclaration" && (node.importKind === "type" || node.importKind === "typeof") || node.type === "ExportNamedDeclaration" && node.exportKind === "type" || node.type === "ExportAllDeclaration" && node.exportKind === "type") {
		          return;
		        }
		        _superClass.prototype.assertModuleNodeAllowed.call(this, node);
		      };
		      _proto.parseExportDeclaration = function parseExportDeclaration(node) {
		        if (this.isContextual(130)) {
		          node.exportKind = "type";
		          var declarationNode = this.startNode();
		          this.next();
		          if (this.match(5)) {
		            node.specifiers = this.parseExportSpecifiers(true);
		            _superClass.prototype.parseExportFrom.call(this, node);
		            return null;
		          } else {
		            return this.flowParseTypeAlias(declarationNode);
		          }
		        } else if (this.isContextual(131)) {
		          node.exportKind = "type";
		          var _declarationNode = this.startNode();
		          this.next();
		          return this.flowParseOpaqueType(_declarationNode, false);
		        } else if (this.isContextual(129)) {
		          node.exportKind = "type";
		          var _declarationNode2 = this.startNode();
		          this.next();
		          return this.flowParseInterface(_declarationNode2);
		        } else if (this.shouldParseEnums() && this.isContextual(126)) {
		          node.exportKind = "value";
		          var _declarationNode3 = this.startNode();
		          this.next();
		          return this.flowParseEnumDeclaration(_declarationNode3);
		        } else {
		          return _superClass.prototype.parseExportDeclaration.call(this, node);
		        }
		      };
		      _proto.eatExportStar = function eatExportStar(node) {
		        if (_superClass.prototype.eatExportStar.call(this, node)) return true;
		        if (this.isContextual(130) && this.lookahead().type === 55) {
		          node.exportKind = "type";
		          this.next();
		          this.next();
		          return true;
		        }
		        return false;
		      };
		      _proto.maybeParseExportNamespaceSpecifier = function maybeParseExportNamespaceSpecifier(node) {
		        var startLoc = this.state.startLoc;
		        var hasNamespace = _superClass.prototype.maybeParseExportNamespaceSpecifier.call(this, node);
		        if (hasNamespace && node.exportKind === "type") {
		          this.unexpected(startLoc);
		        }
		        return hasNamespace;
		      };
		      _proto.parseClassId = function parseClassId(node, isStatement, optionalId) {
		        _superClass.prototype.parseClassId.call(this, node, isStatement, optionalId);
		        if (this.match(47)) {
		          node.typeParameters = this.flowParseTypeParameterDeclaration();
		        }
		      };
		      _proto.parseClassMember = function parseClassMember(classBody, member, state) {
		        var startLoc = this.state.startLoc;
		        if (this.isContextual(125)) {
		          if (_superClass.prototype.parseClassMemberFromModifier.call(this, classBody, member)) {
		            return;
		          }
		          member.declare = true;
		        }
		        _superClass.prototype.parseClassMember.call(this, classBody, member, state);
		        if (member.declare) {
		          if (member.type !== "ClassProperty" && member.type !== "ClassPrivateProperty" && member.type !== "PropertyDefinition") {
		            this.raise(FlowErrors.DeclareClassElement, startLoc);
		          } else if (member.value) {
		            this.raise(FlowErrors.DeclareClassFieldInitializer, member.value);
		          }
		        }
		      };
		      _proto.isIterator = function isIterator(word) {
		        return word === "iterator" || word === "asyncIterator";
		      };
		      _proto.readIterator = function readIterator() {
		        var word = _superClass.prototype.readWord1.call(this);
		        var fullWord = "@@" + word;
		        if (!this.isIterator(word) || !this.state.inType) {
		          this.raise(Errors.InvalidIdentifier, this.state.curPosition(), {
		            identifierName: fullWord
		          });
		        }
		        this.finishToken(132, fullWord);
		      };
		      _proto.getTokenFromCode = function getTokenFromCode(code) {
		        var next = this.input.charCodeAt(this.state.pos + 1);
		        if (code === 123 && next === 124) {
		          this.finishOp(6, 2);
		        } else if (this.state.inType && (code === 62 || code === 60)) {
		          this.finishOp(code === 62 ? 48 : 47, 1);
		        } else if (this.state.inType && code === 63) {
		          if (next === 46) {
		            this.finishOp(18, 2);
		          } else {
		            this.finishOp(17, 1);
		          }
		        } else if (isIteratorStart(code, next, this.input.charCodeAt(this.state.pos + 2))) {
		          this.state.pos += 2;
		          this.readIterator();
		        } else {
		          _superClass.prototype.getTokenFromCode.call(this, code);
		        }
		      };
		      _proto.isAssignable = function isAssignable(node, isBinding) {
		        if (node.type === "TypeCastExpression") {
		          return this.isAssignable(node.expression, isBinding);
		        } else {
		          return _superClass.prototype.isAssignable.call(this, node, isBinding);
		        }
		      };
		      _proto.toAssignable = function toAssignable(node, isLHS) {
		        if (isLHS === void 0) {
		          isLHS = false;
		        }
		        if (!isLHS && node.type === "AssignmentExpression" && node.left.type === "TypeCastExpression") {
		          node.left = this.typeCastToParameter(node.left);
		        }
		        _superClass.prototype.toAssignable.call(this, node, isLHS);
		      };
		      _proto.toAssignableList = function toAssignableList(exprList, trailingCommaLoc, isLHS) {
		        for (var i = 0; i < exprList.length; i++) {
		          var expr = exprList[i];
		          if ((expr == null ? void 0 : expr.type) === "TypeCastExpression") {
		            exprList[i] = this.typeCastToParameter(expr);
		          }
		        }
		        _superClass.prototype.toAssignableList.call(this, exprList, trailingCommaLoc, isLHS);
		      };
		      _proto.toReferencedList = function toReferencedList(exprList, isParenthesizedExpr) {
		        for (var i = 0; i < exprList.length; i++) {
		          var _expr$extra;
		          var expr = exprList[i];
		          if (expr && expr.type === "TypeCastExpression" && !((_expr$extra = expr.extra) != null && _expr$extra.parenthesized) && (exprList.length > 1 || !isParenthesizedExpr)) {
		            this.raise(FlowErrors.TypeCastInPattern, expr.typeAnnotation);
		          }
		        }
		        return exprList;
		      };
		      _proto.parseArrayLike = function parseArrayLike(close, canBePattern, isTuple, refExpressionErrors) {
		        var node = _superClass.prototype.parseArrayLike.call(this, close, canBePattern, isTuple, refExpressionErrors);
		        if (canBePattern && !this.state.maybeInArrowParameters) {
		          this.toReferencedList(node.elements);
		        }
		        return node;
		      };
		      _proto.isValidLVal = function isValidLVal(type, isParenthesized, binding) {
		        return type === "TypeCastExpression" || _superClass.prototype.isValidLVal.call(this, type, isParenthesized, binding);
		      };
		      _proto.parseClassProperty = function parseClassProperty(node) {
		        if (this.match(14)) {
		          node.typeAnnotation = this.flowParseTypeAnnotation();
		        }
		        return _superClass.prototype.parseClassProperty.call(this, node);
		      };
		      _proto.parseClassPrivateProperty = function parseClassPrivateProperty(node) {
		        if (this.match(14)) {
		          node.typeAnnotation = this.flowParseTypeAnnotation();
		        }
		        return _superClass.prototype.parseClassPrivateProperty.call(this, node);
		      };
		      _proto.isClassMethod = function isClassMethod() {
		        return this.match(47) || _superClass.prototype.isClassMethod.call(this);
		      };
		      _proto.isClassProperty = function isClassProperty() {
		        return this.match(14) || _superClass.prototype.isClassProperty.call(this);
		      };
		      _proto.isNonstaticConstructor = function isNonstaticConstructor(method) {
		        return !this.match(14) && _superClass.prototype.isNonstaticConstructor.call(this, method);
		      };
		      _proto.pushClassMethod = function pushClassMethod(classBody, method, isGenerator, isAsync, isConstructor, allowsDirectSuper) {
		        if (method.variance) {
		          this.unexpected(method.variance.loc.start);
		        }
		        delete method.variance;
		        if (this.match(47)) {
		          method.typeParameters = this.flowParseTypeParameterDeclaration();
		        }
		        _superClass.prototype.pushClassMethod.call(this, classBody, method, isGenerator, isAsync, isConstructor, allowsDirectSuper);
		        if (method.params && isConstructor) {
		          var params = method.params;
		          if (params.length > 0 && this.isThisParam(params[0])) {
		            this.raise(FlowErrors.ThisParamBannedInConstructor, method);
		          }
		        } else if (method.type === "MethodDefinition" && isConstructor && method.value.params) {
		          var _params = method.value.params;
		          if (_params.length > 0 && this.isThisParam(_params[0])) {
		            this.raise(FlowErrors.ThisParamBannedInConstructor, method);
		          }
		        }
		      };
		      _proto.pushClassPrivateMethod = function pushClassPrivateMethod(classBody, method, isGenerator, isAsync) {
		        if (method.variance) {
		          this.unexpected(method.variance.loc.start);
		        }
		        delete method.variance;
		        if (this.match(47)) {
		          method.typeParameters = this.flowParseTypeParameterDeclaration();
		        }
		        _superClass.prototype.pushClassPrivateMethod.call(this, classBody, method, isGenerator, isAsync);
		      };
		      _proto.parseClassSuper = function parseClassSuper(node) {
		        _superClass.prototype.parseClassSuper.call(this, node);
		        if (node.superClass && this.match(47)) {
		          node.superTypeParameters = this.flowParseTypeParameterInstantiation();
		        }
		        if (this.isContextual(113)) {
		          this.next();
		          var implemented = node["implements"] = [];
		          do {
		            var _node5 = this.startNode();
		            _node5.id = this.flowParseRestrictedIdentifier(true);
		            if (this.match(47)) {
		              _node5.typeParameters = this.flowParseTypeParameterInstantiation();
		            } else {
		              _node5.typeParameters = null;
		            }
		            implemented.push(this.finishNode(_node5, "ClassImplements"));
		          } while (this.eat(12));
		        }
		      };
		      _proto.checkGetterSetterParams = function checkGetterSetterParams(method) {
		        _superClass.prototype.checkGetterSetterParams.call(this, method);
		        var params = this.getObjectOrClassMethodParams(method);
		        if (params.length > 0) {
		          var param = params[0];
		          if (this.isThisParam(param) && method.kind === "get") {
		            this.raise(FlowErrors.GetterMayNotHaveThisParam, param);
		          } else if (this.isThisParam(param)) {
		            this.raise(FlowErrors.SetterMayNotHaveThisParam, param);
		          }
		        }
		      };
		      _proto.parsePropertyNamePrefixOperator = function parsePropertyNamePrefixOperator(node) {
		        node.variance = this.flowParseVariance();
		      };
		      _proto.parseObjPropValue = function parseObjPropValue(prop, startLoc, isGenerator, isAsync, isPattern, isAccessor, refExpressionErrors) {
		        if (prop.variance) {
		          this.unexpected(prop.variance.loc.start);
		        }
		        delete prop.variance;
		        var typeParameters;
		        if (this.match(47) && !isAccessor) {
		          typeParameters = this.flowParseTypeParameterDeclaration();
		          if (!this.match(10)) this.unexpected();
		        }
		        var result = _superClass.prototype.parseObjPropValue.call(this, prop, startLoc, isGenerator, isAsync, isPattern, isAccessor, refExpressionErrors);
		        if (typeParameters) {
		          (result.value || result).typeParameters = typeParameters;
		        }
		        return result;
		      };
		      _proto.parseAssignableListItemTypes = function parseAssignableListItemTypes(param) {
		        if (this.eat(17)) {
		          if (param.type !== "Identifier") {
		            this.raise(FlowErrors.PatternIsOptional, param);
		          }
		          if (this.isThisParam(param)) {
		            this.raise(FlowErrors.ThisParamMayNotBeOptional, param);
		          }
		          param.optional = true;
		        }
		        if (this.match(14)) {
		          param.typeAnnotation = this.flowParseTypeAnnotation();
		        } else if (this.isThisParam(param)) {
		          this.raise(FlowErrors.ThisParamAnnotationRequired, param);
		        }
		        if (this.match(29) && this.isThisParam(param)) {
		          this.raise(FlowErrors.ThisParamNoDefault, param);
		        }
		        this.resetEndLocation(param);
		        return param;
		      };
		      _proto.parseMaybeDefault = function parseMaybeDefault(startLoc, left) {
		        var node = _superClass.prototype.parseMaybeDefault.call(this, startLoc, left);
		        if (node.type === "AssignmentPattern" && node.typeAnnotation && node.right.start < node.typeAnnotation.start) {
		          this.raise(FlowErrors.TypeBeforeInitializer, node.typeAnnotation);
		        }
		        return node;
		      };
		      _proto.checkImportReflection = function checkImportReflection(node) {
		        _superClass.prototype.checkImportReflection.call(this, node);
		        if (node.module && node.importKind !== "value") {
		          this.raise(FlowErrors.ImportReflectionHasImportType, node.specifiers[0].loc.start);
		        }
		      };
		      _proto.parseImportSpecifierLocal = function parseImportSpecifierLocal(node, specifier, type) {
		        specifier.local = hasTypeImportKind(node) ? this.flowParseRestrictedIdentifier(true, true) : this.parseIdentifier();
		        node.specifiers.push(this.finishImportSpecifier(specifier, type));
		      };
		      _proto.isPotentialImportPhase = function isPotentialImportPhase(isExport) {
		        if (_superClass.prototype.isPotentialImportPhase.call(this, isExport)) return true;
		        if (this.isContextual(130)) {
		          if (!isExport) return true;
		          var ch = this.lookaheadCharCode();
		          return ch === 123 || ch === 42;
		        }
		        return !isExport && this.isContextual(87);
		      };
		      _proto.applyImportPhase = function applyImportPhase(node, isExport, phase, loc) {
		        _superClass.prototype.applyImportPhase.call(this, node, isExport, phase, loc);
		        if (isExport) {
		          if (!phase && this.match(65)) {
		            return;
		          }
		          node.exportKind = phase === "type" ? phase : "value";
		        } else {
		          if (phase === "type" && this.match(55)) this.unexpected();
		          node.importKind = phase === "type" || phase === "typeof" ? phase : "value";
		        }
		      };
		      _proto.parseImportSpecifier = function parseImportSpecifier(specifier, importedIsString, isInTypeOnlyImport, isMaybeTypeOnly, bindingType) {
		        var firstIdent = specifier.imported;
		        var specifierTypeKind = null;
		        if (firstIdent.type === "Identifier") {
		          if (firstIdent.name === "type") {
		            specifierTypeKind = "type";
		          } else if (firstIdent.name === "typeof") {
		            specifierTypeKind = "typeof";
		          }
		        }
		        var isBinding = false;
		        if (this.isContextual(93) && !this.isLookaheadContextual("as")) {
		          var as_ident = this.parseIdentifier(true);
		          if (specifierTypeKind !== null && !tokenIsKeywordOrIdentifier(this.state.type)) {
		            specifier.imported = as_ident;
		            specifier.importKind = specifierTypeKind;
		            specifier.local = cloneIdentifier(as_ident);
		          } else {
		            specifier.imported = firstIdent;
		            specifier.importKind = null;
		            specifier.local = this.parseIdentifier();
		          }
		        } else {
		          if (specifierTypeKind !== null && tokenIsKeywordOrIdentifier(this.state.type)) {
		            specifier.imported = this.parseIdentifier(true);
		            specifier.importKind = specifierTypeKind;
		          } else {
		            if (importedIsString) {
		              throw this.raise(Errors.ImportBindingIsString, specifier, {
		                importName: firstIdent.value
		              });
		            }
		            specifier.imported = firstIdent;
		            specifier.importKind = null;
		          }
		          if (this.eatContextual(93)) {
		            specifier.local = this.parseIdentifier();
		          } else {
		            isBinding = true;
		            specifier.local = cloneIdentifier(specifier.imported);
		          }
		        }
		        var specifierIsTypeImport = hasTypeImportKind(specifier);
		        if (isInTypeOnlyImport && specifierIsTypeImport) {
		          this.raise(FlowErrors.ImportTypeShorthandOnlyInPureImport, specifier);
		        }
		        if (isInTypeOnlyImport || specifierIsTypeImport) {
		          this.checkReservedType(specifier.local.name, specifier.local.loc.start, true);
		        }
		        if (isBinding && !isInTypeOnlyImport && !specifierIsTypeImport) {
		          this.checkReservedWord(specifier.local.name, specifier.loc.start, true, true);
		        }
		        return this.finishImportSpecifier(specifier, "ImportSpecifier");
		      };
		      _proto.parseBindingAtom = function parseBindingAtom() {
		        switch (this.state.type) {
		          case 78:
		            return this.parseIdentifier(true);
		          default:
		            return _superClass.prototype.parseBindingAtom.call(this);
		        }
		      };
		      _proto.parseFunctionParams = function parseFunctionParams(node, isConstructor) {
		        var kind = node.kind;
		        if (kind !== "get" && kind !== "set" && this.match(47)) {
		          node.typeParameters = this.flowParseTypeParameterDeclaration();
		        }
		        _superClass.prototype.parseFunctionParams.call(this, node, isConstructor);
		      };
		      _proto.parseVarId = function parseVarId(decl, kind) {
		        _superClass.prototype.parseVarId.call(this, decl, kind);
		        if (this.match(14)) {
		          decl.id.typeAnnotation = this.flowParseTypeAnnotation();
		          this.resetEndLocation(decl.id);
		        }
		      };
		      _proto.parseAsyncArrowFromCallExpression = function parseAsyncArrowFromCallExpression(node, call) {
		        if (this.match(14)) {
		          var oldNoAnonFunctionType = this.state.noAnonFunctionType;
		          this.state.noAnonFunctionType = true;
		          node.returnType = this.flowParseTypeAnnotation();
		          this.state.noAnonFunctionType = oldNoAnonFunctionType;
		        }
		        return _superClass.prototype.parseAsyncArrowFromCallExpression.call(this, node, call);
		      };
		      _proto.shouldParseAsyncArrow = function shouldParseAsyncArrow() {
		        return this.match(14) || _superClass.prototype.shouldParseAsyncArrow.call(this);
		      };
		      _proto.parseMaybeAssign = function parseMaybeAssign(refExpressionErrors, afterLeftParse) {
		        var _this7 = this,
		          _jsx;
		        var state = null;
		        var jsx;
		        if (this.hasPlugin("jsx") && (this.match(142) || this.match(47))) {
		          state = this.state.clone();
		          jsx = this.tryParse(function () {
		            return _superClass.prototype.parseMaybeAssign.call(_this7, refExpressionErrors, afterLeftParse);
		          }, state);
		          if (!jsx.error) return jsx.node;
		          var context = this.state.context;
		          var currentContext = context[context.length - 1];
		          if (currentContext === types.j_oTag || currentContext === types.j_expr) {
		            context.pop();
		          }
		        }
		        if ((_jsx = jsx) != null && _jsx.error || this.match(47)) {
		          var _jsx2, _jsx3;
		          state = state || this.state.clone();
		          var typeParameters;
		          var arrow = this.tryParse(function (abort) {
		            var _arrowExpression$extr;
		            typeParameters = _this7.flowParseTypeParameterDeclaration();
		            var arrowExpression = _this7.forwardNoArrowParamsConversionAt(typeParameters, function () {
		              var result = _superClass.prototype.parseMaybeAssign.call(_this7, refExpressionErrors, afterLeftParse);
		              _this7.resetStartLocationFromNode(result, typeParameters);
		              return result;
		            });
		            if ((_arrowExpression$extr = arrowExpression.extra) != null && _arrowExpression$extr.parenthesized) abort();
		            var expr = _this7.maybeUnwrapTypeCastExpression(arrowExpression);
		            if (expr.type !== "ArrowFunctionExpression") abort();
		            expr.typeParameters = typeParameters;
		            _this7.resetStartLocationFromNode(expr, typeParameters);
		            return arrowExpression;
		          }, state);
		          var arrowExpression = null;
		          if (arrow.node && this.maybeUnwrapTypeCastExpression(arrow.node).type === "ArrowFunctionExpression") {
		            if (!arrow.error && !arrow.aborted) {
		              if (arrow.node.async) {
		                this.raise(FlowErrors.UnexpectedTypeParameterBeforeAsyncArrowFunction, typeParameters);
		              }
		              return arrow.node;
		            }
		            arrowExpression = arrow.node;
		          }
		          if ((_jsx2 = jsx) != null && _jsx2.node) {
		            this.state = jsx.failState;
		            return jsx.node;
		          }
		          if (arrowExpression) {
		            this.state = arrow.failState;
		            return arrowExpression;
		          }
		          if ((_jsx3 = jsx) != null && _jsx3.thrown) throw jsx.error;
		          if (arrow.thrown) throw arrow.error;
		          throw this.raise(FlowErrors.UnexpectedTokenAfterTypeParameter, typeParameters);
		        }
		        return _superClass.prototype.parseMaybeAssign.call(this, refExpressionErrors, afterLeftParse);
		      };
		      _proto.parseArrow = function parseArrow(node) {
		        var _this8 = this;
		        if (this.match(14)) {
		          var result = this.tryParse(function () {
		            var oldNoAnonFunctionType = _this8.state.noAnonFunctionType;
		            _this8.state.noAnonFunctionType = true;
		            var typeNode = _this8.startNode();
		            var _this8$flowParseTypeA = _this8.flowParseTypeAndPredicateInitialiser();
		            typeNode.typeAnnotation = _this8$flowParseTypeA[0];
		            node.predicate = _this8$flowParseTypeA[1];
		            _this8.state.noAnonFunctionType = oldNoAnonFunctionType;
		            if (_this8.canInsertSemicolon()) _this8.unexpected();
		            if (!_this8.match(19)) _this8.unexpected();
		            return typeNode;
		          });
		          if (result.thrown) return null;
		          if (result.error) this.state = result.failState;
		          node.returnType = result.node.typeAnnotation ? this.finishNode(result.node, "TypeAnnotation") : null;
		        }
		        return _superClass.prototype.parseArrow.call(this, node);
		      };
		      _proto.shouldParseArrow = function shouldParseArrow(params) {
		        return this.match(14) || _superClass.prototype.shouldParseArrow.call(this, params);
		      };
		      _proto.setArrowFunctionParameters = function setArrowFunctionParameters(node, params) {
		        if (this.state.noArrowParamsConversionAt.indexOf(node.start) !== -1) {
		          node.params = params;
		        } else {
		          _superClass.prototype.setArrowFunctionParameters.call(this, node, params);
		        }
		      };
		      _proto.checkParams = function checkParams(node, allowDuplicates, isArrowFunction, strictModeChanged) {
		        if (strictModeChanged === void 0) {
		          strictModeChanged = true;
		        }
		        if (isArrowFunction && this.state.noArrowParamsConversionAt.indexOf(node.start) !== -1) {
		          return;
		        }
		        for (var i = 0; i < node.params.length; i++) {
		          if (this.isThisParam(node.params[i]) && i > 0) {
		            this.raise(FlowErrors.ThisParamMustBeFirst, node.params[i]);
		          }
		        }
		        _superClass.prototype.checkParams.call(this, node, allowDuplicates, isArrowFunction, strictModeChanged);
		      };
		      _proto.parseParenAndDistinguishExpression = function parseParenAndDistinguishExpression(canBeArrow) {
		        return _superClass.prototype.parseParenAndDistinguishExpression.call(this, canBeArrow && this.state.noArrowAt.indexOf(this.state.start) === -1);
		      };
		      _proto.parseSubscripts = function parseSubscripts(base, startLoc, noCalls) {
		        var _this9 = this;
		        if (base.type === "Identifier" && base.name === "async" && this.state.noArrowAt.indexOf(startLoc.index) !== -1) {
		          this.next();
		          var node = this.startNodeAt(startLoc);
		          node.callee = base;
		          node.arguments = _superClass.prototype.parseCallExpressionArguments.call(this, 11, false);
		          base = this.finishNode(node, "CallExpression");
		        } else if (base.type === "Identifier" && base.name === "async" && this.match(47)) {
		          var state = this.state.clone();
		          var arrow = this.tryParse(function (abort) {
		            return _this9.parseAsyncArrowWithTypeParameters(startLoc) || abort();
		          }, state);
		          if (!arrow.error && !arrow.aborted) return arrow.node;
		          var result = this.tryParse(function () {
		            return _superClass.prototype.parseSubscripts.call(_this9, base, startLoc, noCalls);
		          }, state);
		          if (result.node && !result.error) return result.node;
		          if (arrow.node) {
		            this.state = arrow.failState;
		            return arrow.node;
		          }
		          if (result.node) {
		            this.state = result.failState;
		            return result.node;
		          }
		          throw arrow.error || result.error;
		        }
		        return _superClass.prototype.parseSubscripts.call(this, base, startLoc, noCalls);
		      };
		      _proto.parseSubscript = function parseSubscript(base, startLoc, noCalls, subscriptState) {
		        var _this10 = this;
		        if (this.match(18) && this.isLookaheadToken_lt()) {
		          subscriptState.optionalChainMember = true;
		          if (noCalls) {
		            subscriptState.stop = true;
		            return base;
		          }
		          this.next();
		          var node = this.startNodeAt(startLoc);
		          node.callee = base;
		          node.typeArguments = this.flowParseTypeParameterInstantiation();
		          this.expect(10);
		          node.arguments = this.parseCallExpressionArguments(11, false);
		          node.optional = true;
		          return this.finishCallExpression(node, true);
		        } else if (!noCalls && this.shouldParseTypes() && this.match(47)) {
		          var _node6 = this.startNodeAt(startLoc);
		          _node6.callee = base;
		          var result = this.tryParse(function () {
		            _node6.typeArguments = _this10.flowParseTypeParameterInstantiationCallOrNew();
		            _this10.expect(10);
		            _node6.arguments = _superClass.prototype.parseCallExpressionArguments.call(_this10, 11, false);
		            if (subscriptState.optionalChainMember) {
		              _node6.optional = false;
		            }
		            return _this10.finishCallExpression(_node6, subscriptState.optionalChainMember);
		          });
		          if (result.node) {
		            if (result.error) this.state = result.failState;
		            return result.node;
		          }
		        }
		        return _superClass.prototype.parseSubscript.call(this, base, startLoc, noCalls, subscriptState);
		      };
		      _proto.parseNewCallee = function parseNewCallee(node) {
		        var _this11 = this;
		        _superClass.prototype.parseNewCallee.call(this, node);
		        var targs = null;
		        if (this.shouldParseTypes() && this.match(47)) {
		          targs = this.tryParse(function () {
		            return _this11.flowParseTypeParameterInstantiationCallOrNew();
		          }).node;
		        }
		        node.typeArguments = targs;
		      };
		      _proto.parseAsyncArrowWithTypeParameters = function parseAsyncArrowWithTypeParameters(startLoc) {
		        var node = this.startNodeAt(startLoc);
		        this.parseFunctionParams(node, false);
		        if (!this.parseArrow(node)) return;
		        return _superClass.prototype.parseArrowExpression.call(this, node, undefined, true);
		      };
		      _proto.readToken_mult_modulo = function readToken_mult_modulo(code) {
		        var next = this.input.charCodeAt(this.state.pos + 1);
		        if (code === 42 && next === 47 && this.state.hasFlowComment) {
		          this.state.hasFlowComment = false;
		          this.state.pos += 2;
		          this.nextToken();
		          return;
		        }
		        _superClass.prototype.readToken_mult_modulo.call(this, code);
		      };
		      _proto.readToken_pipe_amp = function readToken_pipe_amp(code) {
		        var next = this.input.charCodeAt(this.state.pos + 1);
		        if (code === 124 && next === 125) {
		          this.finishOp(9, 2);
		          return;
		        }
		        _superClass.prototype.readToken_pipe_amp.call(this, code);
		      };
		      _proto.parseTopLevel = function parseTopLevel(file, program) {
		        var fileNode = _superClass.prototype.parseTopLevel.call(this, file, program);
		        if (this.state.hasFlowComment) {
		          this.raise(FlowErrors.UnterminatedFlowComment, this.state.curPosition());
		        }
		        return fileNode;
		      };
		      _proto.skipBlockComment = function skipBlockComment() {
		        if (this.hasPlugin("flowComments") && this.skipFlowComment()) {
		          if (this.state.hasFlowComment) {
		            throw this.raise(FlowErrors.NestedFlowComment, this.state.startLoc);
		          }
		          this.hasFlowCommentCompletion();
		          var commentSkip = this.skipFlowComment();
		          if (commentSkip) {
		            this.state.pos += commentSkip;
		            this.state.hasFlowComment = true;
		          }
		          return;
		        }
		        return _superClass.prototype.skipBlockComment.call(this, this.state.hasFlowComment ? "*-/" : "*/");
		      };
		      _proto.skipFlowComment = function skipFlowComment() {
		        var pos = this.state.pos;
		        var shiftToFirstNonWhiteSpace = 2;
		        while ([32, 9].includes(this.input.charCodeAt(pos + shiftToFirstNonWhiteSpace))) {
		          shiftToFirstNonWhiteSpace++;
		        }
		        var ch2 = this.input.charCodeAt(shiftToFirstNonWhiteSpace + pos);
		        var ch3 = this.input.charCodeAt(shiftToFirstNonWhiteSpace + pos + 1);
		        if (ch2 === 58 && ch3 === 58) {
		          return shiftToFirstNonWhiteSpace + 2;
		        }
		        if (this.input.slice(shiftToFirstNonWhiteSpace + pos, shiftToFirstNonWhiteSpace + pos + 12) === "flow-include") {
		          return shiftToFirstNonWhiteSpace + 12;
		        }
		        if (ch2 === 58 && ch3 !== 58) {
		          return shiftToFirstNonWhiteSpace;
		        }
		        return false;
		      };
		      _proto.hasFlowCommentCompletion = function hasFlowCommentCompletion() {
		        var end = this.input.indexOf("*/", this.state.pos);
		        if (end === -1) {
		          throw this.raise(Errors.UnterminatedComment, this.state.curPosition());
		        }
		      };
		      _proto.flowEnumErrorBooleanMemberNotInitialized = function flowEnumErrorBooleanMemberNotInitialized(loc, _ref16) {
		        var enumName = _ref16.enumName,
		          memberName = _ref16.memberName;
		        this.raise(FlowErrors.EnumBooleanMemberNotInitialized, loc, {
		          memberName: memberName,
		          enumName: enumName
		        });
		      };
		      _proto.flowEnumErrorInvalidMemberInitializer = function flowEnumErrorInvalidMemberInitializer(loc, enumContext) {
		        return this.raise(!enumContext.explicitType ? FlowErrors.EnumInvalidMemberInitializerUnknownType : enumContext.explicitType === "symbol" ? FlowErrors.EnumInvalidMemberInitializerSymbolType : FlowErrors.EnumInvalidMemberInitializerPrimaryType, loc, enumContext);
		      };
		      _proto.flowEnumErrorNumberMemberNotInitialized = function flowEnumErrorNumberMemberNotInitialized(loc, details) {
		        this.raise(FlowErrors.EnumNumberMemberNotInitialized, loc, details);
		      };
		      _proto.flowEnumErrorStringMemberInconsistentlyInitialized = function flowEnumErrorStringMemberInconsistentlyInitialized(node, details) {
		        this.raise(FlowErrors.EnumStringMemberInconsistentlyInitialized, node, details);
		      };
		      _proto.flowEnumMemberInit = function flowEnumMemberInit() {
		        var _this12 = this;
		        var startLoc = this.state.startLoc;
		        var endOfInit = function endOfInit() {
		          return _this12.match(12) || _this12.match(8);
		        };
		        switch (this.state.type) {
		          case 134:
		            {
		              var literal = this.parseNumericLiteral(this.state.value);
		              if (endOfInit()) {
		                return {
		                  type: "number",
		                  loc: literal.loc.start,
		                  value: literal
		                };
		              }
		              return {
		                type: "invalid",
		                loc: startLoc
		              };
		            }
		          case 133:
		            {
		              var _literal = this.parseStringLiteral(this.state.value);
		              if (endOfInit()) {
		                return {
		                  type: "string",
		                  loc: _literal.loc.start,
		                  value: _literal
		                };
		              }
		              return {
		                type: "invalid",
		                loc: startLoc
		              };
		            }
		          case 85:
		          case 86:
		            {
		              var _literal2 = this.parseBooleanLiteral(this.match(85));
		              if (endOfInit()) {
		                return {
		                  type: "boolean",
		                  loc: _literal2.loc.start,
		                  value: _literal2
		                };
		              }
		              return {
		                type: "invalid",
		                loc: startLoc
		              };
		            }
		          default:
		            return {
		              type: "invalid",
		              loc: startLoc
		            };
		        }
		      };
		      _proto.flowEnumMemberRaw = function flowEnumMemberRaw() {
		        var loc = this.state.startLoc;
		        var id = this.parseIdentifier(true);
		        var init = this.eat(29) ? this.flowEnumMemberInit() : {
		          type: "none",
		          loc: loc
		        };
		        return {
		          id: id,
		          init: init
		        };
		      };
		      _proto.flowEnumCheckExplicitTypeMismatch = function flowEnumCheckExplicitTypeMismatch(loc, context, expectedType) {
		        var explicitType = context.explicitType;
		        if (explicitType === null) {
		          return;
		        }
		        if (explicitType !== expectedType) {
		          this.flowEnumErrorInvalidMemberInitializer(loc, context);
		        }
		      };
		      _proto.flowEnumMembers = function flowEnumMembers(_ref17) {
		        var enumName = _ref17.enumName,
		          explicitType = _ref17.explicitType;
		        var seenNames = new Set();
		        var members = {
		          booleanMembers: [],
		          numberMembers: [],
		          stringMembers: [],
		          defaultedMembers: []
		        };
		        var hasUnknownMembers = false;
		        while (!this.match(8)) {
		          if (this.eat(21)) {
		            hasUnknownMembers = true;
		            break;
		          }
		          var memberNode = this.startNode();
		          var _this$flowEnumMemberR = this.flowEnumMemberRaw(),
		            id = _this$flowEnumMemberR.id,
		            init = _this$flowEnumMemberR.init;
		          var memberName = id.name;
		          if (memberName === "") {
		            continue;
		          }
		          if (/^[a-z]/.test(memberName)) {
		            this.raise(FlowErrors.EnumInvalidMemberName, id, {
		              memberName: memberName,
		              suggestion: memberName[0].toUpperCase() + memberName.slice(1),
		              enumName: enumName
		            });
		          }
		          if (seenNames.has(memberName)) {
		            this.raise(FlowErrors.EnumDuplicateMemberName, id, {
		              memberName: memberName,
		              enumName: enumName
		            });
		          }
		          seenNames.add(memberName);
		          var context = {
		            enumName: enumName,
		            explicitType: explicitType,
		            memberName: memberName
		          };
		          memberNode.id = id;
		          switch (init.type) {
		            case "boolean":
		              {
		                this.flowEnumCheckExplicitTypeMismatch(init.loc, context, "boolean");
		                memberNode.init = init.value;
		                members.booleanMembers.push(this.finishNode(memberNode, "EnumBooleanMember"));
		                break;
		              }
		            case "number":
		              {
		                this.flowEnumCheckExplicitTypeMismatch(init.loc, context, "number");
		                memberNode.init = init.value;
		                members.numberMembers.push(this.finishNode(memberNode, "EnumNumberMember"));
		                break;
		              }
		            case "string":
		              {
		                this.flowEnumCheckExplicitTypeMismatch(init.loc, context, "string");
		                memberNode.init = init.value;
		                members.stringMembers.push(this.finishNode(memberNode, "EnumStringMember"));
		                break;
		              }
		            case "invalid":
		              {
		                throw this.flowEnumErrorInvalidMemberInitializer(init.loc, context);
		              }
		            case "none":
		              {
		                switch (explicitType) {
		                  case "boolean":
		                    this.flowEnumErrorBooleanMemberNotInitialized(init.loc, context);
		                    break;
		                  case "number":
		                    this.flowEnumErrorNumberMemberNotInitialized(init.loc, context);
		                    break;
		                  default:
		                    members.defaultedMembers.push(this.finishNode(memberNode, "EnumDefaultedMember"));
		                }
		              }
		          }
		          if (!this.match(8)) {
		            this.expect(12);
		          }
		        }
		        return {
		          members: members,
		          hasUnknownMembers: hasUnknownMembers
		        };
		      };
		      _proto.flowEnumStringMembers = function flowEnumStringMembers(initializedMembers, defaultedMembers, _ref18) {
		        var enumName = _ref18.enumName;
		        if (initializedMembers.length === 0) {
		          return defaultedMembers;
		        } else if (defaultedMembers.length === 0) {
		          return initializedMembers;
		        } else if (defaultedMembers.length > initializedMembers.length) {
		          for (var _i2 = 0; _i2 < initializedMembers.length; _i2++) {
		            var member = initializedMembers[_i2];
		            this.flowEnumErrorStringMemberInconsistentlyInitialized(member, {
		              enumName: enumName
		            });
		          }
		          return defaultedMembers;
		        } else {
		          for (var _i4 = 0; _i4 < defaultedMembers.length; _i4++) {
		            var _member = defaultedMembers[_i4];
		            this.flowEnumErrorStringMemberInconsistentlyInitialized(_member, {
		              enumName: enumName
		            });
		          }
		          return initializedMembers;
		        }
		      };
		      _proto.flowEnumParseExplicitType = function flowEnumParseExplicitType(_ref19) {
		        var enumName = _ref19.enumName;
		        if (!this.eatContextual(102)) return null;
		        if (!tokenIsIdentifier(this.state.type)) {
		          throw this.raise(FlowErrors.EnumInvalidExplicitTypeUnknownSupplied, this.state.startLoc, {
		            enumName: enumName
		          });
		        }
		        var value = this.state.value;
		        this.next();
		        if (value !== "boolean" && value !== "number" && value !== "string" && value !== "symbol") {
		          this.raise(FlowErrors.EnumInvalidExplicitType, this.state.startLoc, {
		            enumName: enumName,
		            invalidEnumType: value
		          });
		        }
		        return value;
		      };
		      _proto.flowEnumBody = function flowEnumBody(node, id) {
		        var _this13 = this;
		        var enumName = id.name;
		        var nameLoc = id.loc.start;
		        var explicitType = this.flowEnumParseExplicitType({
		          enumName: enumName
		        });
		        this.expect(5);
		        var _this$flowEnumMembers = this.flowEnumMembers({
		            enumName: enumName,
		            explicitType: explicitType
		          }),
		          members = _this$flowEnumMembers.members,
		          hasUnknownMembers = _this$flowEnumMembers.hasUnknownMembers;
		        node.hasUnknownMembers = hasUnknownMembers;
		        switch (explicitType) {
		          case "boolean":
		            node.explicitType = true;
		            node.members = members.booleanMembers;
		            this.expect(8);
		            return this.finishNode(node, "EnumBooleanBody");
		          case "number":
		            node.explicitType = true;
		            node.members = members.numberMembers;
		            this.expect(8);
		            return this.finishNode(node, "EnumNumberBody");
		          case "string":
		            node.explicitType = true;
		            node.members = this.flowEnumStringMembers(members.stringMembers, members.defaultedMembers, {
		              enumName: enumName
		            });
		            this.expect(8);
		            return this.finishNode(node, "EnumStringBody");
		          case "symbol":
		            node.members = members.defaultedMembers;
		            this.expect(8);
		            return this.finishNode(node, "EnumSymbolBody");
		          default:
		            {
		              var empty = function empty() {
		                node.members = [];
		                _this13.expect(8);
		                return _this13.finishNode(node, "EnumStringBody");
		              };
		              node.explicitType = false;
		              var boolsLen = members.booleanMembers.length;
		              var numsLen = members.numberMembers.length;
		              var strsLen = members.stringMembers.length;
		              var defaultedLen = members.defaultedMembers.length;
		              if (!boolsLen && !numsLen && !strsLen && !defaultedLen) {
		                return empty();
		              } else if (!boolsLen && !numsLen) {
		                node.members = this.flowEnumStringMembers(members.stringMembers, members.defaultedMembers, {
		                  enumName: enumName
		                });
		                this.expect(8);
		                return this.finishNode(node, "EnumStringBody");
		              } else if (!numsLen && !strsLen && boolsLen >= defaultedLen) {
		                for (var _i6 = 0, _members$defaultedMem2 = members.defaultedMembers; _i6 < _members$defaultedMem2.length; _i6++) {
		                  var member = _members$defaultedMem2[_i6];
		                  this.flowEnumErrorBooleanMemberNotInitialized(member.loc.start, {
		                    enumName: enumName,
		                    memberName: member.id.name
		                  });
		                }
		                node.members = members.booleanMembers;
		                this.expect(8);
		                return this.finishNode(node, "EnumBooleanBody");
		              } else if (!boolsLen && !strsLen && numsLen >= defaultedLen) {
		                for (var _i8 = 0, _members$defaultedMem4 = members.defaultedMembers; _i8 < _members$defaultedMem4.length; _i8++) {
		                  var _member2 = _members$defaultedMem4[_i8];
		                  this.flowEnumErrorNumberMemberNotInitialized(_member2.loc.start, {
		                    enumName: enumName,
		                    memberName: _member2.id.name
		                  });
		                }
		                node.members = members.numberMembers;
		                this.expect(8);
		                return this.finishNode(node, "EnumNumberBody");
		              } else {
		                this.raise(FlowErrors.EnumInconsistentMemberValues, nameLoc, {
		                  enumName: enumName
		                });
		                return empty();
		              }
		            }
		        }
		      };
		      _proto.flowParseEnumDeclaration = function flowParseEnumDeclaration(node) {
		        var id = this.parseIdentifier();
		        node.id = id;
		        node.body = this.flowEnumBody(this.startNode(), id);
		        return this.finishNode(node, "EnumDeclaration");
		      };
		      _proto.isLookaheadToken_lt = function isLookaheadToken_lt() {
		        var next = this.nextTokenStart();
		        if (this.input.charCodeAt(next) === 60) {
		          var afterNext = this.input.charCodeAt(next + 1);
		          return afterNext !== 60 && afterNext !== 61;
		        }
		        return false;
		      };
		      _proto.maybeUnwrapTypeCastExpression = function maybeUnwrapTypeCastExpression(node) {
		        return node.type === "TypeCastExpression" ? node.expression : node;
		      };
		      return _createClass(FlowParserMixin);
		    }(superClass);
		  });

		  var entities = {
		    __proto__: null,
		    quot: "\"",
		    amp: "&",
		    apos: "'",
		    lt: "<",
		    gt: ">",
		    nbsp: "\xA0",
		    iexcl: "\xA1",
		    cent: "\xA2",
		    pound: "\xA3",
		    curren: "\xA4",
		    yen: "\xA5",
		    brvbar: "\xA6",
		    sect: "\xA7",
		    uml: "\xA8",
		    copy: "\xA9",
		    ordf: "\xAA",
		    laquo: "\xAB",
		    not: "\xAC",
		    shy: "\xAD",
		    reg: "\xAE",
		    macr: "\xAF",
		    deg: "\xB0",
		    plusmn: "\xB1",
		    sup2: "\xB2",
		    sup3: "\xB3",
		    acute: "\xB4",
		    micro: "\xB5",
		    para: "\xB6",
		    middot: "\xB7",
		    cedil: "\xB8",
		    sup1: "\xB9",
		    ordm: "\xBA",
		    raquo: "\xBB",
		    frac14: "\xBC",
		    frac12: "\xBD",
		    frac34: "\xBE",
		    iquest: "\xBF",
		    Agrave: "\xC0",
		    Aacute: "\xC1",
		    Acirc: "\xC2",
		    Atilde: "\xC3",
		    Auml: "\xC4",
		    Aring: "\xC5",
		    AElig: "\xC6",
		    Ccedil: "\xC7",
		    Egrave: "\xC8",
		    Eacute: "\xC9",
		    Ecirc: "\xCA",
		    Euml: "\xCB",
		    Igrave: "\xCC",
		    Iacute: "\xCD",
		    Icirc: "\xCE",
		    Iuml: "\xCF",
		    ETH: "\xD0",
		    Ntilde: "\xD1",
		    Ograve: "\xD2",
		    Oacute: "\xD3",
		    Ocirc: "\xD4",
		    Otilde: "\xD5",
		    Ouml: "\xD6",
		    times: "\xD7",
		    Oslash: "\xD8",
		    Ugrave: "\xD9",
		    Uacute: "\xDA",
		    Ucirc: "\xDB",
		    Uuml: "\xDC",
		    Yacute: "\xDD",
		    THORN: "\xDE",
		    szlig: "\xDF",
		    agrave: "\xE0",
		    aacute: "\xE1",
		    acirc: "\xE2",
		    atilde: "\xE3",
		    auml: "\xE4",
		    aring: "\xE5",
		    aelig: "\xE6",
		    ccedil: "\xE7",
		    egrave: "\xE8",
		    eacute: "\xE9",
		    ecirc: "\xEA",
		    euml: "\xEB",
		    igrave: "\xEC",
		    iacute: "\xED",
		    icirc: "\xEE",
		    iuml: "\xEF",
		    eth: "\xF0",
		    ntilde: "\xF1",
		    ograve: "\xF2",
		    oacute: "\xF3",
		    ocirc: "\xF4",
		    otilde: "\xF5",
		    ouml: "\xF6",
		    divide: "\xF7",
		    oslash: "\xF8",
		    ugrave: "\xF9",
		    uacute: "\xFA",
		    ucirc: "\xFB",
		    uuml: "\xFC",
		    yacute: "\xFD",
		    thorn: "\xFE",
		    yuml: "\xFF",
		    OElig: "\u0152",
		    oelig: "\u0153",
		    Scaron: "\u0160",
		    scaron: "\u0161",
		    Yuml: "\u0178",
		    fnof: "\u0192",
		    circ: "\u02C6",
		    tilde: "\u02DC",
		    Alpha: "\u0391",
		    Beta: "\u0392",
		    Gamma: "\u0393",
		    Delta: "\u0394",
		    Epsilon: "\u0395",
		    Zeta: "\u0396",
		    Eta: "\u0397",
		    Theta: "\u0398",
		    Iota: "\u0399",
		    Kappa: "\u039A",
		    Lambda: "\u039B",
		    Mu: "\u039C",
		    Nu: "\u039D",
		    Xi: "\u039E",
		    Omicron: "\u039F",
		    Pi: "\u03A0",
		    Rho: "\u03A1",
		    Sigma: "\u03A3",
		    Tau: "\u03A4",
		    Upsilon: "\u03A5",
		    Phi: "\u03A6",
		    Chi: "\u03A7",
		    Psi: "\u03A8",
		    Omega: "\u03A9",
		    alpha: "\u03B1",
		    beta: "\u03B2",
		    gamma: "\u03B3",
		    delta: "\u03B4",
		    epsilon: "\u03B5",
		    zeta: "\u03B6",
		    eta: "\u03B7",
		    theta: "\u03B8",
		    iota: "\u03B9",
		    kappa: "\u03BA",
		    lambda: "\u03BB",
		    mu: "\u03BC",
		    nu: "\u03BD",
		    xi: "\u03BE",
		    omicron: "\u03BF",
		    pi: "\u03C0",
		    rho: "\u03C1",
		    sigmaf: "\u03C2",
		    sigma: "\u03C3",
		    tau: "\u03C4",
		    upsilon: "\u03C5",
		    phi: "\u03C6",
		    chi: "\u03C7",
		    psi: "\u03C8",
		    omega: "\u03C9",
		    thetasym: "\u03D1",
		    upsih: "\u03D2",
		    piv: "\u03D6",
		    ensp: "\u2002",
		    emsp: "\u2003",
		    thinsp: "\u2009",
		    zwnj: "\u200C",
		    zwj: "\u200D",
		    lrm: "\u200E",
		    rlm: "\u200F",
		    ndash: "\u2013",
		    mdash: "\u2014",
		    lsquo: "\u2018",
		    rsquo: "\u2019",
		    sbquo: "\u201A",
		    ldquo: "\u201C",
		    rdquo: "\u201D",
		    bdquo: "\u201E",
		    dagger: "\u2020",
		    Dagger: "\u2021",
		    bull: "\u2022",
		    hellip: "\u2026",
		    permil: "\u2030",
		    prime: "\u2032",
		    Prime: "\u2033",
		    lsaquo: "\u2039",
		    rsaquo: "\u203A",
		    oline: "\u203E",
		    frasl: "\u2044",
		    euro: "\u20AC",
		    image: "\u2111",
		    weierp: "\u2118",
		    real: "\u211C",
		    trade: "\u2122",
		    alefsym: "\u2135",
		    larr: "\u2190",
		    uarr: "\u2191",
		    rarr: "\u2192",
		    darr: "\u2193",
		    harr: "\u2194",
		    crarr: "\u21B5",
		    lArr: "\u21D0",
		    uArr: "\u21D1",
		    rArr: "\u21D2",
		    dArr: "\u21D3",
		    hArr: "\u21D4",
		    forall: "\u2200",
		    part: "\u2202",
		    exist: "\u2203",
		    empty: "\u2205",
		    nabla: "\u2207",
		    isin: "\u2208",
		    notin: "\u2209",
		    ni: "\u220B",
		    prod: "\u220F",
		    sum: "\u2211",
		    minus: "\u2212",
		    lowast: "\u2217",
		    radic: "\u221A",
		    prop: "\u221D",
		    infin: "\u221E",
		    ang: "\u2220",
		    and: "\u2227",
		    or: "\u2228",
		    cap: "\u2229",
		    cup: "\u222A",
		    "int": "\u222B",
		    there4: "\u2234",
		    sim: "\u223C",
		    cong: "\u2245",
		    asymp: "\u2248",
		    ne: "\u2260",
		    equiv: "\u2261",
		    le: "\u2264",
		    ge: "\u2265",
		    sub: "\u2282",
		    sup: "\u2283",
		    nsub: "\u2284",
		    sube: "\u2286",
		    supe: "\u2287",
		    oplus: "\u2295",
		    otimes: "\u2297",
		    perp: "\u22A5",
		    sdot: "\u22C5",
		    lceil: "\u2308",
		    rceil: "\u2309",
		    lfloor: "\u230A",
		    rfloor: "\u230B",
		    lang: "\u2329",
		    rang: "\u232A",
		    loz: "\u25CA",
		    spades: "\u2660",
		    clubs: "\u2663",
		    hearts: "\u2665",
		    diams: "\u2666"
		  };

		  var _templateObject$E;
		  var JsxErrors = ParseErrorEnum(_templateObject$E || (_templateObject$E = _taggedTemplateLiteralLoose(["jsx"])))({
		    AttributeIsEmpty: "JSX attributes must only be assigned a non-empty expression.",
		    MissingClosingTagElement: function MissingClosingTagElement(_ref) {
		      var openingTagName = _ref.openingTagName;
		      return "Expected corresponding JSX closing tag for <" + openingTagName + ">.";
		    },
		    MissingClosingTagFragment: "Expected corresponding JSX closing tag for <>.",
		    UnexpectedSequenceExpression: "Sequence expressions cannot be directly nested inside JSX. Did you mean to wrap it in parentheses (...)?",
		    UnexpectedToken: function UnexpectedToken(_ref2) {
		      var unexpected = _ref2.unexpected,
		        HTMLEntity = _ref2.HTMLEntity;
		      return "Unexpected token `" + unexpected + "`. Did you mean `" + HTMLEntity + "` or `{'" + unexpected + "'}`?";
		    },
		    UnsupportedJsxValue: "JSX value should be either an expression or a quoted JSX text.",
		    UnterminatedJsxContent: "Unterminated JSX contents.",
		    UnwrappedAdjacentJSXElements: "Adjacent JSX elements must be wrapped in an enclosing tag. Did you want a JSX fragment <>...</>?"
		  });
		  function isFragment(object) {
		    return object ? object.type === "JSXOpeningFragment" || object.type === "JSXClosingFragment" : false;
		  }
		  function getQualifiedJSXName(object) {
		    if (object.type === "JSXIdentifier") {
		      return object.name;
		    }
		    if (object.type === "JSXNamespacedName") {
		      return object.namespace.name + ":" + object.name.name;
		    }
		    if (object.type === "JSXMemberExpression") {
		      return getQualifiedJSXName(object.object) + "." + getQualifiedJSXName(object.property);
		    }
		    throw new Error("Node had unexpected type: " + object.type);
		  }
		  var jsx = (function (superClass) {
		    return function (_superClass) {
		      function JSXParserMixin() {
		        return _superClass.apply(this, arguments) || this;
		      }
		      _inherits(JSXParserMixin, _superClass);
		      var _proto = JSXParserMixin.prototype;
		      _proto.jsxReadToken = function jsxReadToken() {
		        var out = "";
		        var chunkStart = this.state.pos;
		        for (;;) {
		          if (this.state.pos >= this.length) {
		            throw this.raise(JsxErrors.UnterminatedJsxContent, this.state.startLoc);
		          }
		          var ch = this.input.charCodeAt(this.state.pos);
		          switch (ch) {
		            case 60:
		            case 123:
		              if (this.state.pos === this.state.start) {
		                if (ch === 60 && this.state.canStartJSXElement) {
		                  ++this.state.pos;
		                  this.finishToken(142);
		                } else {
		                  _superClass.prototype.getTokenFromCode.call(this, ch);
		                }
		                return;
		              }
		              out += this.input.slice(chunkStart, this.state.pos);
		              this.finishToken(141, out);
		              return;
		            case 38:
		              out += this.input.slice(chunkStart, this.state.pos);
		              out += this.jsxReadEntity();
		              chunkStart = this.state.pos;
		              break;
		            case 62:
		            case 125:
		            default:
		              if (isNewLine(ch)) {
		                out += this.input.slice(chunkStart, this.state.pos);
		                out += this.jsxReadNewLine(true);
		                chunkStart = this.state.pos;
		              } else {
		                ++this.state.pos;
		              }
		          }
		        }
		      };
		      _proto.jsxReadNewLine = function jsxReadNewLine(normalizeCRLF) {
		        var ch = this.input.charCodeAt(this.state.pos);
		        var out;
		        ++this.state.pos;
		        if (ch === 13 && this.input.charCodeAt(this.state.pos) === 10) {
		          ++this.state.pos;
		          out = normalizeCRLF ? "\n" : "\r\n";
		        } else {
		          out = String.fromCharCode(ch);
		        }
		        ++this.state.curLine;
		        this.state.lineStart = this.state.pos;
		        return out;
		      };
		      _proto.jsxReadString = function jsxReadString(quote) {
		        var out = "";
		        var chunkStart = ++this.state.pos;
		        for (;;) {
		          if (this.state.pos >= this.length) {
		            throw this.raise(Errors.UnterminatedString, this.state.startLoc);
		          }
		          var ch = this.input.charCodeAt(this.state.pos);
		          if (ch === quote) break;
		          if (ch === 38) {
		            out += this.input.slice(chunkStart, this.state.pos);
		            out += this.jsxReadEntity();
		            chunkStart = this.state.pos;
		          } else if (isNewLine(ch)) {
		            out += this.input.slice(chunkStart, this.state.pos);
		            out += this.jsxReadNewLine(false);
		            chunkStart = this.state.pos;
		          } else {
		            ++this.state.pos;
		          }
		        }
		        out += this.input.slice(chunkStart, this.state.pos++);
		        this.finishToken(133, out);
		      };
		      _proto.jsxReadEntity = function jsxReadEntity() {
		        var startPos = ++this.state.pos;
		        if (this.codePointAtPos(this.state.pos) === 35) {
		          ++this.state.pos;
		          var radix = 10;
		          if (this.codePointAtPos(this.state.pos) === 120) {
		            radix = 16;
		            ++this.state.pos;
		          }
		          var codePoint = this.readInt(radix, undefined, false, "bail");
		          if (codePoint !== null && this.codePointAtPos(this.state.pos) === 59) {
		            ++this.state.pos;
		            return String.fromCodePoint(codePoint);
		          }
		        } else {
		          var count = 0;
		          var semi = false;
		          while (count++ < 10 && this.state.pos < this.length && !(semi = this.codePointAtPos(this.state.pos) === 59)) {
		            ++this.state.pos;
		          }
		          if (semi) {
		            var desc = this.input.slice(startPos, this.state.pos);
		            var entity = entities[desc];
		            ++this.state.pos;
		            if (entity) {
		              return entity;
		            }
		          }
		        }
		        this.state.pos = startPos;
		        return "&";
		      };
		      _proto.jsxReadWord = function jsxReadWord() {
		        var ch;
		        var start = this.state.pos;
		        do {
		          ch = this.input.charCodeAt(++this.state.pos);
		        } while (isIdentifierChar(ch) || ch === 45);
		        this.finishToken(140, this.input.slice(start, this.state.pos));
		      };
		      _proto.jsxParseIdentifier = function jsxParseIdentifier() {
		        var node = this.startNode();
		        if (this.match(140)) {
		          node.name = this.state.value;
		        } else if (tokenIsKeyword(this.state.type)) {
		          node.name = tokenLabelName(this.state.type);
		        } else {
		          this.unexpected();
		        }
		        this.next();
		        return this.finishNode(node, "JSXIdentifier");
		      };
		      _proto.jsxParseNamespacedName = function jsxParseNamespacedName() {
		        var startLoc = this.state.startLoc;
		        var name = this.jsxParseIdentifier();
		        if (!this.eat(14)) return name;
		        var node = this.startNodeAt(startLoc);
		        node.namespace = name;
		        node.name = this.jsxParseIdentifier();
		        return this.finishNode(node, "JSXNamespacedName");
		      };
		      _proto.jsxParseElementName = function jsxParseElementName() {
		        var startLoc = this.state.startLoc;
		        var node = this.jsxParseNamespacedName();
		        if (node.type === "JSXNamespacedName") {
		          return node;
		        }
		        while (this.eat(16)) {
		          var newNode = this.startNodeAt(startLoc);
		          newNode.object = node;
		          newNode.property = this.jsxParseIdentifier();
		          node = this.finishNode(newNode, "JSXMemberExpression");
		        }
		        return node;
		      };
		      _proto.jsxParseAttributeValue = function jsxParseAttributeValue() {
		        var node;
		        switch (this.state.type) {
		          case 5:
		            node = this.startNode();
		            this.setContext(types.brace);
		            this.next();
		            node = this.jsxParseExpressionContainer(node, types.j_oTag);
		            if (node.expression.type === "JSXEmptyExpression") {
		              this.raise(JsxErrors.AttributeIsEmpty, node);
		            }
		            return node;
		          case 142:
		          case 133:
		            return this.parseExprAtom();
		          default:
		            throw this.raise(JsxErrors.UnsupportedJsxValue, this.state.startLoc);
		        }
		      };
		      _proto.jsxParseEmptyExpression = function jsxParseEmptyExpression() {
		        var node = this.startNodeAt(this.state.lastTokEndLoc);
		        return this.finishNodeAt(node, "JSXEmptyExpression", this.state.startLoc);
		      };
		      _proto.jsxParseSpreadChild = function jsxParseSpreadChild(node) {
		        this.next();
		        node.expression = this.parseExpression();
		        this.setContext(types.j_expr);
		        this.state.canStartJSXElement = true;
		        this.expect(8);
		        return this.finishNode(node, "JSXSpreadChild");
		      };
		      _proto.jsxParseExpressionContainer = function jsxParseExpressionContainer(node, previousContext) {
		        if (this.match(8)) {
		          node.expression = this.jsxParseEmptyExpression();
		        } else {
		          var expression = this.parseExpression();
		          node.expression = expression;
		        }
		        this.setContext(previousContext);
		        this.state.canStartJSXElement = true;
		        this.expect(8);
		        return this.finishNode(node, "JSXExpressionContainer");
		      };
		      _proto.jsxParseAttribute = function jsxParseAttribute() {
		        var node = this.startNode();
		        if (this.match(5)) {
		          this.setContext(types.brace);
		          this.next();
		          this.expect(21);
		          node.argument = this.parseMaybeAssignAllowIn();
		          this.setContext(types.j_oTag);
		          this.state.canStartJSXElement = true;
		          this.expect(8);
		          return this.finishNode(node, "JSXSpreadAttribute");
		        }
		        node.name = this.jsxParseNamespacedName();
		        node.value = this.eat(29) ? this.jsxParseAttributeValue() : null;
		        return this.finishNode(node, "JSXAttribute");
		      };
		      _proto.jsxParseOpeningElementAt = function jsxParseOpeningElementAt(startLoc) {
		        var node = this.startNodeAt(startLoc);
		        if (this.eat(143)) {
		          return this.finishNode(node, "JSXOpeningFragment");
		        }
		        node.name = this.jsxParseElementName();
		        return this.jsxParseOpeningElementAfterName(node);
		      };
		      _proto.jsxParseOpeningElementAfterName = function jsxParseOpeningElementAfterName(node) {
		        var attributes = [];
		        while (!this.match(56) && !this.match(143)) {
		          attributes.push(this.jsxParseAttribute());
		        }
		        node.attributes = attributes;
		        node.selfClosing = this.eat(56);
		        this.expect(143);
		        return this.finishNode(node, "JSXOpeningElement");
		      };
		      _proto.jsxParseClosingElementAt = function jsxParseClosingElementAt(startLoc) {
		        var node = this.startNodeAt(startLoc);
		        if (this.eat(143)) {
		          return this.finishNode(node, "JSXClosingFragment");
		        }
		        node.name = this.jsxParseElementName();
		        this.expect(143);
		        return this.finishNode(node, "JSXClosingElement");
		      };
		      _proto.jsxParseElementAt = function jsxParseElementAt(startLoc) {
		        var node = this.startNodeAt(startLoc);
		        var children = [];
		        var openingElement = this.jsxParseOpeningElementAt(startLoc);
		        var closingElement = null;
		        if (!openingElement.selfClosing) {
		          contents: for (;;) {
		            switch (this.state.type) {
		              case 142:
		                startLoc = this.state.startLoc;
		                this.next();
		                if (this.eat(56)) {
		                  closingElement = this.jsxParseClosingElementAt(startLoc);
		                  break contents;
		                }
		                children.push(this.jsxParseElementAt(startLoc));
		                break;
		              case 141:
		                children.push(this.parseLiteral(this.state.value, "JSXText"));
		                break;
		              case 5:
		                {
		                  var _node = this.startNode();
		                  this.setContext(types.brace);
		                  this.next();
		                  if (this.match(21)) {
		                    children.push(this.jsxParseSpreadChild(_node));
		                  } else {
		                    children.push(this.jsxParseExpressionContainer(_node, types.j_expr));
		                  }
		                  break;
		                }
		              default:
		                this.unexpected();
		            }
		          }
		          if (isFragment(openingElement) && !isFragment(closingElement) && closingElement !== null) {
		            this.raise(JsxErrors.MissingClosingTagFragment, closingElement);
		          } else if (!isFragment(openingElement) && isFragment(closingElement)) {
		            this.raise(JsxErrors.MissingClosingTagElement, closingElement, {
		              openingTagName: getQualifiedJSXName(openingElement.name)
		            });
		          } else if (!isFragment(openingElement) && !isFragment(closingElement)) {
		            if (getQualifiedJSXName(closingElement.name) !== getQualifiedJSXName(openingElement.name)) {
		              this.raise(JsxErrors.MissingClosingTagElement, closingElement, {
		                openingTagName: getQualifiedJSXName(openingElement.name)
		              });
		            }
		          }
		        }
		        if (isFragment(openingElement)) {
		          node.openingFragment = openingElement;
		          node.closingFragment = closingElement;
		        } else {
		          node.openingElement = openingElement;
		          node.closingElement = closingElement;
		        }
		        node.children = children;
		        if (this.match(47)) {
		          throw this.raise(JsxErrors.UnwrappedAdjacentJSXElements, this.state.startLoc);
		        }
		        return isFragment(openingElement) ? this.finishNode(node, "JSXFragment") : this.finishNode(node, "JSXElement");
		      };
		      _proto.jsxParseElement = function jsxParseElement() {
		        var startLoc = this.state.startLoc;
		        this.next();
		        return this.jsxParseElementAt(startLoc);
		      };
		      _proto.setContext = function setContext(newContext) {
		        var context = this.state.context;
		        context[context.length - 1] = newContext;
		      };
		      _proto.parseExprAtom = function parseExprAtom(refExpressionErrors) {
		        if (this.match(142)) {
		          return this.jsxParseElement();
		        } else if (this.match(47) && this.input.charCodeAt(this.state.pos) !== 33) {
		          this.replaceToken(142);
		          return this.jsxParseElement();
		        } else {
		          return _superClass.prototype.parseExprAtom.call(this, refExpressionErrors);
		        }
		      };
		      _proto.skipSpace = function skipSpace() {
		        var curContext = this.curContext();
		        if (!curContext.preserveSpace) _superClass.prototype.skipSpace.call(this);
		      };
		      _proto.getTokenFromCode = function getTokenFromCode(code) {
		        var context = this.curContext();
		        if (context === types.j_expr) {
		          this.jsxReadToken();
		          return;
		        }
		        if (context === types.j_oTag || context === types.j_cTag) {
		          if (isIdentifierStart(code)) {
		            this.jsxReadWord();
		            return;
		          }
		          if (code === 62) {
		            ++this.state.pos;
		            this.finishToken(143);
		            return;
		          }
		          if ((code === 34 || code === 39) && context === types.j_oTag) {
		            this.jsxReadString(code);
		            return;
		          }
		        }
		        if (code === 60 && this.state.canStartJSXElement && this.input.charCodeAt(this.state.pos + 1) !== 33) {
		          ++this.state.pos;
		          this.finishToken(142);
		          return;
		        }
		        _superClass.prototype.getTokenFromCode.call(this, code);
		      };
		      _proto.updateContext = function updateContext(prevType) {
		        var _this$state = this.state,
		          context = _this$state.context,
		          type = _this$state.type;
		        if (type === 56 && prevType === 142) {
		          context.splice(-2, 2, types.j_cTag);
		          this.state.canStartJSXElement = false;
		        } else if (type === 142) {
		          context.push(types.j_oTag);
		        } else if (type === 143) {
		          var out = context[context.length - 1];
		          if (out === types.j_oTag && prevType === 56 || out === types.j_cTag) {
		            context.pop();
		            this.state.canStartJSXElement = context[context.length - 1] === types.j_expr;
		          } else {
		            this.setContext(types.j_expr);
		            this.state.canStartJSXElement = true;
		          }
		        } else {
		          this.state.canStartJSXElement = tokenComesBeforeExpression(type);
		        }
		      };
		      return _createClass(JSXParserMixin);
		    }(superClass);
		  });

		  var TypeScriptScope = function (_Scope) {
		    function TypeScriptScope() {
		      var _this;
		      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
		        args[_key] = arguments[_key];
		      }
		      _this = _Scope.call.apply(_Scope, [this].concat(args)) || this;
		      _this.tsNames = new Map();
		      return _this;
		    }
		    _inherits(TypeScriptScope, _Scope);
		    return _createClass(TypeScriptScope);
		  }(Scope);
		  var TypeScriptScopeHandler = function (_ScopeHandler) {
		    function TypeScriptScopeHandler() {
		      var _this2;
		      for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
		        args[_key2] = arguments[_key2];
		      }
		      _this2 = _ScopeHandler.call.apply(_ScopeHandler, [this].concat(args)) || this;
		      _this2.importsStack = [];
		      return _this2;
		    }
		    _inherits(TypeScriptScopeHandler, _ScopeHandler);
		    var _proto = TypeScriptScopeHandler.prototype;
		    _proto.createScope = function createScope(flags) {
		      this.importsStack.push(new Set());
		      return new TypeScriptScope(flags);
		    };
		    _proto.enter = function enter(flags) {
		      if (flags === ScopeFlag.TS_MODULE) {
		        this.importsStack.push(new Set());
		      }
		      _ScopeHandler.prototype.enter.call(this, flags);
		    };
		    _proto.exit = function exit() {
		      var flags = _ScopeHandler.prototype.exit.call(this);
		      if (flags === ScopeFlag.TS_MODULE) {
		        this.importsStack.pop();
		      }
		      return flags;
		    };
		    _proto.hasImport = function hasImport(name, allowShadow) {
		      var len = this.importsStack.length;
		      if (this.importsStack[len - 1].has(name)) {
		        return true;
		      }
		      if (!allowShadow && len > 1) {
		        for (var i = 0; i < len - 1; i++) {
		          if (this.importsStack[i].has(name)) return true;
		        }
		      }
		      return false;
		    };
		    _proto.declareName = function declareName(name, bindingType, loc) {
		      if (bindingType & BindingFlag.FLAG_TS_IMPORT) {
		        if (this.hasImport(name, true)) {
		          this.parser.raise(Errors.VarRedeclaration, loc, {
		            identifierName: name
		          });
		        }
		        this.importsStack[this.importsStack.length - 1].add(name);
		        return;
		      }
		      var scope = this.currentScope();
		      var type = scope.tsNames.get(name) || 0;
		      if (bindingType & BindingFlag.FLAG_TS_EXPORT_ONLY) {
		        this.maybeExportDefined(scope, name);
		        scope.tsNames.set(name, type | 16);
		        return;
		      }
		      _ScopeHandler.prototype.declareName.call(this, name, bindingType, loc);
		      if (bindingType & BindingFlag.KIND_TYPE) {
		        if (!(bindingType & BindingFlag.KIND_VALUE)) {
		          this.checkRedeclarationInScope(scope, name, bindingType, loc);
		          this.maybeExportDefined(scope, name);
		        }
		        type = type | 1;
		      }
		      if (bindingType & BindingFlag.FLAG_TS_ENUM) {
		        type = type | 2;
		      }
		      if (bindingType & BindingFlag.FLAG_TS_CONST_ENUM) {
		        type = type | 4;
		      }
		      if (bindingType & BindingFlag.FLAG_CLASS) {
		        type = type | 8;
		      }
		      if (type) scope.tsNames.set(name, type);
		    };
		    _proto.isRedeclaredInScope = function isRedeclaredInScope(scope, name, bindingType) {
		      var type = scope.tsNames.get(name);
		      if ((type & 2) > 0) {
		        if (bindingType & BindingFlag.FLAG_TS_ENUM) {
		          var isConst = !!(bindingType & BindingFlag.FLAG_TS_CONST_ENUM);
		          var wasConst = (type & 4) > 0;
		          return isConst !== wasConst;
		        }
		        return true;
		      }
		      if (bindingType & BindingFlag.FLAG_CLASS && (type & 8) > 0) {
		        if (scope.names.get(name) & NameType.Lexical) {
		          return !!(bindingType & BindingFlag.KIND_VALUE);
		        } else {
		          return false;
		        }
		      }
		      if (bindingType & BindingFlag.KIND_TYPE && (type & 1) > 0) {
		        return true;
		      }
		      return _ScopeHandler.prototype.isRedeclaredInScope.call(this, scope, name, bindingType);
		    };
		    _proto.checkLocalExport = function checkLocalExport(id) {
		      var name = id.name;
		      if (this.hasImport(name)) return;
		      var len = this.scopeStack.length;
		      for (var i = len - 1; i >= 0; i--) {
		        var scope = this.scopeStack[i];
		        var type = scope.tsNames.get(name);
		        if ((type & 1) > 0 || (type & 16) > 0) {
		          return;
		        }
		      }
		      _ScopeHandler.prototype.checkLocalExport.call(this, id);
		    };
		    return _createClass(TypeScriptScopeHandler);
		  }(ScopeHandler);

		  var getOwn$1 = function getOwn(object, key) {
		    return hasOwnProperty.call(object, key) && object[key];
		  };
		  var unwrapParenthesizedExpression = function unwrapParenthesizedExpression(node) {
		    return node.type === "ParenthesizedExpression" ? unwrapParenthesizedExpression(node.expression) : node;
		  };
		  var ParseBindingListFlags = {
		    ALLOW_EMPTY: 1,
		    IS_FUNCTION_PARAMS: 2,
		    IS_CONSTRUCTOR_PARAMS: 4
		  };
		  var LValParser = function (_NodeUtils) {
		    function LValParser() {
		      return _NodeUtils.apply(this, arguments) || this;
		    }
		    _inherits(LValParser, _NodeUtils);
		    var _proto = LValParser.prototype;
		    _proto.toAssignable = function toAssignable(node, isLHS) {
		      var _node$extra, _node$extra3;
		      if (isLHS === void 0) {
		        isLHS = false;
		      }
		      var parenthesized = undefined;
		      if (node.type === "ParenthesizedExpression" || (_node$extra = node.extra) != null && _node$extra.parenthesized) {
		        parenthesized = unwrapParenthesizedExpression(node);
		        if (isLHS) {
		          if (parenthesized.type === "Identifier") {
		            this.expressionScope.recordArrowParameterBindingError(Errors.InvalidParenthesizedAssignment, node);
		          } else if (parenthesized.type !== "MemberExpression" && !this.isOptionalMemberExpression(parenthesized)) {
		            this.raise(Errors.InvalidParenthesizedAssignment, node);
		          }
		        } else {
		          this.raise(Errors.InvalidParenthesizedAssignment, node);
		        }
		      }
		      switch (node.type) {
		        case "Identifier":
		        case "ObjectPattern":
		        case "ArrayPattern":
		        case "AssignmentPattern":
		        case "RestElement":
		          break;
		        case "ObjectExpression":
		          node.type = "ObjectPattern";
		          for (var i = 0, length = node.properties.length, last = length - 1; i < length; i++) {
		            var _node$extra2;
		            var _prop = node.properties[i];
		            var isLast = i === last;
		            this.toAssignableObjectExpressionProp(_prop, isLast, isLHS);
		            if (isLast && _prop.type === "RestElement" && (_node$extra2 = node.extra) != null && _node$extra2.trailingCommaLoc) {
		              this.raise(Errors.RestTrailingComma, node.extra.trailingCommaLoc);
		            }
		          }
		          break;
		        case "ObjectProperty":
		          {
		            var key = node.key,
		              value = node.value;
		            if (this.isPrivateName(key)) {
		              this.classScope.usePrivateName(this.getPrivateNameSV(key), key.loc.start);
		            }
		            this.toAssignable(value, isLHS);
		            break;
		          }
		        case "SpreadElement":
		          {
		            throw new Error("Internal @babel/parser error (this is a bug, please report it)." + " SpreadElement should be converted by .toAssignable's caller.");
		          }
		        case "ArrayExpression":
		          node.type = "ArrayPattern";
		          this.toAssignableList(node.elements, (_node$extra3 = node.extra) == null ? void 0 : _node$extra3.trailingCommaLoc, isLHS);
		          break;
		        case "AssignmentExpression":
		          if (node.operator !== "=") {
		            this.raise(Errors.MissingEqInAssignment, node.left.loc.end);
		          }
		          node.type = "AssignmentPattern";
		          delete node.operator;
		          this.toAssignable(node.left, isLHS);
		          break;
		        case "ParenthesizedExpression":
		          this.toAssignable(parenthesized, isLHS);
		          break;
		      }
		    };
		    _proto.toAssignableObjectExpressionProp = function toAssignableObjectExpressionProp(prop, isLast, isLHS) {
		      if (prop.type === "ObjectMethod") {
		        this.raise(prop.kind === "get" || prop.kind === "set" ? Errors.PatternHasAccessor : Errors.PatternHasMethod, prop.key);
		      } else if (prop.type === "SpreadElement") {
		        prop.type = "RestElement";
		        var arg = prop.argument;
		        this.checkToRestConversion(arg, false);
		        this.toAssignable(arg, isLHS);
		        if (!isLast) {
		          this.raise(Errors.RestTrailingComma, prop);
		        }
		      } else {
		        this.toAssignable(prop, isLHS);
		      }
		    };
		    _proto.toAssignableList = function toAssignableList(exprList, trailingCommaLoc, isLHS) {
		      var end = exprList.length - 1;
		      for (var i = 0; i <= end; i++) {
		        var elt = exprList[i];
		        if (!elt) continue;
		        if (elt.type === "SpreadElement") {
		          elt.type = "RestElement";
		          var arg = elt.argument;
		          this.checkToRestConversion(arg, true);
		          this.toAssignable(arg, isLHS);
		        } else {
		          this.toAssignable(elt, isLHS);
		        }
		        if (elt.type === "RestElement") {
		          if (i < end) {
		            this.raise(Errors.RestTrailingComma, elt);
		          } else if (trailingCommaLoc) {
		            this.raise(Errors.RestTrailingComma, trailingCommaLoc);
		          }
		        }
		      }
		    };
		    _proto.isAssignable = function isAssignable(node, isBinding) {
		      var _this = this;
		      switch (node.type) {
		        case "Identifier":
		        case "ObjectPattern":
		        case "ArrayPattern":
		        case "AssignmentPattern":
		        case "RestElement":
		          return true;
		        case "ObjectExpression":
		          {
		            var last = node.properties.length - 1;
		            return node.properties.every(function (prop, i) {
		              return prop.type !== "ObjectMethod" && (i === last || prop.type !== "SpreadElement") && _this.isAssignable(prop);
		            });
		          }
		        case "ObjectProperty":
		          return this.isAssignable(node.value);
		        case "SpreadElement":
		          return this.isAssignable(node.argument);
		        case "ArrayExpression":
		          return node.elements.every(function (element) {
		            return element === null || _this.isAssignable(element);
		          });
		        case "AssignmentExpression":
		          return node.operator === "=";
		        case "ParenthesizedExpression":
		          return this.isAssignable(node.expression);
		        case "MemberExpression":
		        case "OptionalMemberExpression":
		          return !isBinding;
		        default:
		          return false;
		      }
		    };
		    _proto.toReferencedList = function toReferencedList(exprList, isParenthesizedExpr) {
		      return exprList;
		    };
		    _proto.toReferencedListDeep = function toReferencedListDeep(exprList, isParenthesizedExpr) {
		      this.toReferencedList(exprList, isParenthesizedExpr);
		      for (var _i2 = 0; _i2 < exprList.length; _i2++) {
		        var expr = exprList[_i2];
		        if ((expr == null ? void 0 : expr.type) === "ArrayExpression") {
		          this.toReferencedListDeep(expr.elements);
		        }
		      }
		    };
		    _proto.parseSpread = function parseSpread(refExpressionErrors) {
		      var node = this.startNode();
		      this.next();
		      node.argument = this.parseMaybeAssignAllowIn(refExpressionErrors, undefined);
		      return this.finishNode(node, "SpreadElement");
		    };
		    _proto.parseRestBinding = function parseRestBinding() {
		      var node = this.startNode();
		      this.next();
		      node.argument = this.parseBindingAtom();
		      return this.finishNode(node, "RestElement");
		    };
		    _proto.parseBindingAtom = function parseBindingAtom() {
		      switch (this.state.type) {
		        case 0:
		          {
		            var node = this.startNode();
		            this.next();
		            node.elements = this.parseBindingList(3, 93, ParseBindingListFlags.ALLOW_EMPTY);
		            return this.finishNode(node, "ArrayPattern");
		          }
		        case 5:
		          return this.parseObjectLike(8, true);
		      }
		      return this.parseIdentifier();
		    };
		    _proto.parseBindingList = function parseBindingList(close, closeCharCode, flags) {
		      var allowEmpty = flags & ParseBindingListFlags.ALLOW_EMPTY;
		      var elts = [];
		      var first = true;
		      while (!this.eat(close)) {
		        if (first) {
		          first = false;
		        } else {
		          this.expect(12);
		        }
		        if (allowEmpty && this.match(12)) {
		          elts.push(null);
		        } else if (this.eat(close)) {
		          break;
		        } else if (this.match(21)) {
		          elts.push(this.parseAssignableListItemTypes(this.parseRestBinding(), flags));
		          if (!this.checkCommaAfterRest(closeCharCode)) {
		            this.expect(close);
		            break;
		          }
		        } else {
		          var decorators = [];
		          if (this.match(26) && this.hasPlugin("decorators")) {
		            this.raise(Errors.UnsupportedParameterDecorator, this.state.startLoc);
		          }
		          while (this.match(26)) {
		            decorators.push(this.parseDecorator());
		          }
		          elts.push(this.parseAssignableListItem(flags, decorators));
		        }
		      }
		      return elts;
		    };
		    _proto.parseBindingRestProperty = function parseBindingRestProperty(prop) {
		      this.next();
		      prop.argument = this.parseIdentifier();
		      this.checkCommaAfterRest(125);
		      return this.finishNode(prop, "RestElement");
		    };
		    _proto.parseBindingProperty = function parseBindingProperty() {
		      var _this$state = this.state,
		        type = _this$state.type,
		        startLoc = _this$state.startLoc;
		      if (type === 21) {
		        return this.parseBindingRestProperty(this.startNode());
		      }
		      var prop = this.startNode();
		      if (type === 138) {
		        this.expectPlugin("destructuringPrivate", startLoc);
		        this.classScope.usePrivateName(this.state.value, startLoc);
		        prop.key = this.parsePrivateName();
		      } else {
		        this.parsePropertyName(prop);
		      }
		      prop.method = false;
		      return this.parseObjPropValue(prop, startLoc, false, false, true, false);
		    };
		    _proto.parseAssignableListItem = function parseAssignableListItem(flags, decorators) {
		      var left = this.parseMaybeDefault();
		      this.parseAssignableListItemTypes(left, flags);
		      var elt = this.parseMaybeDefault(left.loc.start, left);
		      if (decorators.length) {
		        left.decorators = decorators;
		      }
		      return elt;
		    };
		    _proto.parseAssignableListItemTypes = function parseAssignableListItemTypes(param, flags) {
		      return param;
		    };
		    _proto.parseMaybeDefault = function parseMaybeDefault(startLoc, left) {
		      var _startLoc, _left;
		      (_startLoc = startLoc) != null ? _startLoc : startLoc = this.state.startLoc;
		      left = (_left = left) != null ? _left : this.parseBindingAtom();
		      if (!this.eat(29)) return left;
		      var node = this.startNodeAt(startLoc);
		      node.left = left;
		      node.right = this.parseMaybeAssignAllowIn();
		      return this.finishNode(node, "AssignmentPattern");
		    };
		    _proto.isValidLVal = function isValidLVal(type, isUnparenthesizedInAssign, binding) {
		      return getOwn$1({
		        AssignmentPattern: "left",
		        RestElement: "argument",
		        ObjectProperty: "value",
		        ParenthesizedExpression: "expression",
		        ArrayPattern: "elements",
		        ObjectPattern: "properties"
		      }, type);
		    };
		    _proto.isOptionalMemberExpression = function isOptionalMemberExpression(expression) {
		      return expression.type === "OptionalMemberExpression";
		    };
		    _proto.checkLVal = function checkLVal(expression, _ref) {
		      var _expression$extra;
		      var ancestor = _ref["in"],
		        _ref$binding = _ref.binding,
		        binding = _ref$binding === void 0 ? BindingFlag.TYPE_NONE : _ref$binding,
		        _ref$checkClashes = _ref.checkClashes,
		        checkClashes = _ref$checkClashes === void 0 ? false : _ref$checkClashes,
		        _ref$strictModeChange = _ref.strictModeChanged,
		        strictModeChanged = _ref$strictModeChange === void 0 ? false : _ref$strictModeChange,
		        _ref$hasParenthesized = _ref.hasParenthesizedAncestor,
		        hasParenthesizedAncestor = _ref$hasParenthesized === void 0 ? false : _ref$hasParenthesized;
		      var type = expression.type;
		      if (this.isObjectMethod(expression)) return;
		      var isOptionalMemberExpression = this.isOptionalMemberExpression(expression);
		      if (isOptionalMemberExpression || type === "MemberExpression") {
		        if (isOptionalMemberExpression) {
		          this.expectPlugin("optionalChainingAssign", expression.loc.start);
		          if (ancestor.type !== "AssignmentExpression") {
		            this.raise(Errors.InvalidLhsOptionalChaining, expression, {
		              ancestor: ancestor
		            });
		          }
		        }
		        if (binding !== BindingFlag.TYPE_NONE) {
		          this.raise(Errors.InvalidPropertyBindingPattern, expression);
		        }
		        return;
		      }
		      if (type === "Identifier") {
		        this.checkIdentifier(expression, binding, strictModeChanged);
		        var name = expression.name;
		        if (checkClashes) {
		          if (checkClashes.has(name)) {
		            this.raise(Errors.ParamDupe, expression);
		          } else {
		            checkClashes.add(name);
		          }
		        }
		        return;
		      }
		      var validity = this.isValidLVal(type, !(hasParenthesizedAncestor || (_expression$extra = expression.extra) != null && _expression$extra.parenthesized) && ancestor.type === "AssignmentExpression", binding);
		      if (validity === true) return;
		      if (validity === false) {
		        var ParseErrorClass = binding === BindingFlag.TYPE_NONE ? Errors.InvalidLhs : Errors.InvalidLhsBinding;
		        this.raise(ParseErrorClass, expression, {
		          ancestor: ancestor
		        });
		        return;
		      }
		      var _ref2 = Array.isArray(validity) ? validity : [validity, type === "ParenthesizedExpression"],
		        key = _ref2[0],
		        isParenthesizedExpression = _ref2[1];
		      var nextAncestor = type === "ArrayPattern" || type === "ObjectPattern" ? {
		        type: type
		      } : ancestor;
		      for (var _i4 = 0, _concat2 = [].concat(expression[key]); _i4 < _concat2.length; _i4++) {
		        var child = _concat2[_i4];
		        if (child) {
		          this.checkLVal(child, {
		            "in": nextAncestor,
		            binding: binding,
		            checkClashes: checkClashes,
		            strictModeChanged: strictModeChanged,
		            hasParenthesizedAncestor: isParenthesizedExpression
		          });
		        }
		      }
		    };
		    _proto.checkIdentifier = function checkIdentifier(at, bindingType, strictModeChanged) {
		      if (strictModeChanged === void 0) {
		        strictModeChanged = false;
		      }
		      if (this.state.strict && (strictModeChanged ? isStrictBindReservedWord(at.name, this.inModule) : isStrictBindOnlyReservedWord(at.name))) {
		        if (bindingType === BindingFlag.TYPE_NONE) {
		          this.raise(Errors.StrictEvalArguments, at, {
		            referenceName: at.name
		          });
		        } else {
		          this.raise(Errors.StrictEvalArgumentsBinding, at, {
		            bindingName: at.name
		          });
		        }
		      }
		      if (bindingType & BindingFlag.FLAG_NO_LET_IN_LEXICAL && at.name === "let") {
		        this.raise(Errors.LetInLexicalBinding, at);
		      }
		      if (!(bindingType & BindingFlag.TYPE_NONE)) {
		        this.declareNameFromIdentifier(at, bindingType);
		      }
		    };
		    _proto.declareNameFromIdentifier = function declareNameFromIdentifier(identifier, binding) {
		      this.scope.declareName(identifier.name, binding, identifier.loc.start);
		    };
		    _proto.checkToRestConversion = function checkToRestConversion(node, allowPattern) {
		      switch (node.type) {
		        case "ParenthesizedExpression":
		          this.checkToRestConversion(node.expression, allowPattern);
		          break;
		        case "Identifier":
		        case "MemberExpression":
		          break;
		        case "ArrayExpression":
		        case "ObjectExpression":
		          if (allowPattern) break;
		        default:
		          this.raise(Errors.InvalidRestAssignmentPattern, node);
		      }
		    };
		    _proto.checkCommaAfterRest = function checkCommaAfterRest(close) {
		      if (!this.match(12)) {
		        return false;
		      }
		      this.raise(this.lookaheadCharCode() === close ? Errors.RestTrailingComma : Errors.ElementAfterRest, this.state.startLoc);
		      return true;
		    };
		    return _createClass(LValParser);
		  }(NodeUtils);

		  var _templateObject$D;
		  var getOwn = function getOwn(object, key) {
		    return hasOwnProperty.call(object, key) && object[key];
		  };
		  function nonNull(x) {
		    if (x == null) {
		      throw new Error("Unexpected " + x + " value.");
		    }
		    return x;
		  }
		  function assert$1(x) {
		    if (!x) {
		      throw new Error("Assert fail");
		    }
		  }
		  var TSErrors = ParseErrorEnum(_templateObject$D || (_templateObject$D = _taggedTemplateLiteralLoose(["typescript"])))({
		    AbstractMethodHasImplementation: function AbstractMethodHasImplementation(_ref) {
		      var methodName = _ref.methodName;
		      return "Method '" + methodName + "' cannot have an implementation because it is marked abstract.";
		    },
		    AbstractPropertyHasInitializer: function AbstractPropertyHasInitializer(_ref2) {
		      var propertyName = _ref2.propertyName;
		      return "Property '" + propertyName + "' cannot have an initializer because it is marked abstract.";
		    },
		    AccesorCannotDeclareThisParameter: "'get' and 'set' accessors cannot declare 'this' parameters.",
		    AccesorCannotHaveTypeParameters: "An accessor cannot have type parameters.",
		    AccessorCannotBeOptional: "An 'accessor' property cannot be declared optional.",
		    ClassMethodHasDeclare: "Class methods cannot have the 'declare' modifier.",
		    ClassMethodHasReadonly: "Class methods cannot have the 'readonly' modifier.",
		    ConstInitiailizerMustBeStringOrNumericLiteralOrLiteralEnumReference: "A 'const' initializer in an ambient context must be a string or numeric literal or literal enum reference.",
		    ConstructorHasTypeParameters: "Type parameters cannot appear on a constructor declaration.",
		    DeclareAccessor: function DeclareAccessor(_ref3) {
		      var kind = _ref3.kind;
		      return "'declare' is not allowed in " + kind + "ters.";
		    },
		    DeclareClassFieldHasInitializer: "Initializers are not allowed in ambient contexts.",
		    DeclareFunctionHasImplementation: "An implementation cannot be declared in ambient contexts.",
		    DuplicateAccessibilityModifier: function DuplicateAccessibilityModifier(_ref4) {
		      _ref4.modifier;
		      return "Accessibility modifier already seen.";
		    },
		    DuplicateModifier: function DuplicateModifier(_ref5) {
		      var modifier = _ref5.modifier;
		      return "Duplicate modifier: '" + modifier + "'.";
		    },
		    EmptyHeritageClauseType: function EmptyHeritageClauseType(_ref6) {
		      var token = _ref6.token;
		      return "'" + token + "' list cannot be empty.";
		    },
		    EmptyTypeArguments: "Type argument list cannot be empty.",
		    EmptyTypeParameters: "Type parameter list cannot be empty.",
		    ExpectedAmbientAfterExportDeclare: "'export declare' must be followed by an ambient declaration.",
		    ImportAliasHasImportType: "An import alias can not use 'import type'.",
		    ImportReflectionHasImportType: "An `import module` declaration can not use `type` modifier",
		    IncompatibleModifiers: function IncompatibleModifiers(_ref7) {
		      var modifiers = _ref7.modifiers;
		      return "'" + modifiers[0] + "' modifier cannot be used with '" + modifiers[1] + "' modifier.";
		    },
		    IndexSignatureHasAbstract: "Index signatures cannot have the 'abstract' modifier.",
		    IndexSignatureHasAccessibility: function IndexSignatureHasAccessibility(_ref8) {
		      var modifier = _ref8.modifier;
		      return "Index signatures cannot have an accessibility modifier ('" + modifier + "').";
		    },
		    IndexSignatureHasDeclare: "Index signatures cannot have the 'declare' modifier.",
		    IndexSignatureHasOverride: "'override' modifier cannot appear on an index signature.",
		    IndexSignatureHasStatic: "Index signatures cannot have the 'static' modifier.",
		    InitializerNotAllowedInAmbientContext: "Initializers are not allowed in ambient contexts.",
		    InvalidModifierOnTypeMember: function InvalidModifierOnTypeMember(_ref9) {
		      var modifier = _ref9.modifier;
		      return "'" + modifier + "' modifier cannot appear on a type member.";
		    },
		    InvalidModifierOnTypeParameter: function InvalidModifierOnTypeParameter(_ref10) {
		      var modifier = _ref10.modifier;
		      return "'" + modifier + "' modifier cannot appear on a type parameter.";
		    },
		    InvalidModifierOnTypeParameterPositions: function InvalidModifierOnTypeParameterPositions(_ref11) {
		      var modifier = _ref11.modifier;
		      return "'" + modifier + "' modifier can only appear on a type parameter of a class, interface or type alias.";
		    },
		    InvalidModifiersOrder: function InvalidModifiersOrder(_ref12) {
		      var orderedModifiers = _ref12.orderedModifiers;
		      return "'" + orderedModifiers[0] + "' modifier must precede '" + orderedModifiers[1] + "' modifier.";
		    },
		    InvalidPropertyAccessAfterInstantiationExpression: "Invalid property access after an instantiation expression. " + "You can either wrap the instantiation expression in parentheses, or delete the type arguments.",
		    InvalidTupleMemberLabel: "Tuple members must be labeled with a simple identifier.",
		    MissingInterfaceName: "'interface' declarations must be followed by an identifier.",
		    NonAbstractClassHasAbstractMethod: "Abstract methods can only appear within an abstract class.",
		    NonClassMethodPropertyHasAbstractModifer: "'abstract' modifier can only appear on a class, method, or property declaration.",
		    OptionalTypeBeforeRequired: "A required element cannot follow an optional element.",
		    OverrideNotInSubClass: "This member cannot have an 'override' modifier because its containing class does not extend another class.",
		    PatternIsOptional: "A binding pattern parameter cannot be optional in an implementation signature.",
		    PrivateElementHasAbstract: "Private elements cannot have the 'abstract' modifier.",
		    PrivateElementHasAccessibility: function PrivateElementHasAccessibility(_ref13) {
		      var modifier = _ref13.modifier;
		      return "Private elements cannot have an accessibility modifier ('" + modifier + "').";
		    },
		    ReadonlyForMethodSignature: "'readonly' modifier can only appear on a property declaration or index signature.",
		    ReservedArrowTypeParam: "This syntax is reserved in files with the .mts or .cts extension. Add a trailing comma, as in `<T,>() => ...`.",
		    ReservedTypeAssertion: "This syntax is reserved in files with the .mts or .cts extension. Use an `as` expression instead.",
		    SetAccesorCannotHaveOptionalParameter: "A 'set' accessor cannot have an optional parameter.",
		    SetAccesorCannotHaveRestParameter: "A 'set' accessor cannot have rest parameter.",
		    SetAccesorCannotHaveReturnType: "A 'set' accessor cannot have a return type annotation.",
		    SingleTypeParameterWithoutTrailingComma: function SingleTypeParameterWithoutTrailingComma(_ref14) {
		      var typeParameterName = _ref14.typeParameterName;
		      return "Single type parameter " + typeParameterName + " should have a trailing comma. Example usage: <" + typeParameterName + ",>.";
		    },
		    StaticBlockCannotHaveModifier: "Static class blocks cannot have any modifier.",
		    TupleOptionalAfterType: "A labeled tuple optional element must be declared using a question mark after the name and before the colon (`name?: type`), rather than after the type (`name: type?`).",
		    TypeAnnotationAfterAssign: "Type annotations must come before default assignments, e.g. instead of `age = 25: number` use `age: number = 25`.",
		    TypeImportCannotSpecifyDefaultAndNamed: "A type-only import can specify a default import or named bindings, but not both.",
		    TypeModifierIsUsedInTypeExports: "The 'type' modifier cannot be used on a named export when 'export type' is used on its export statement.",
		    TypeModifierIsUsedInTypeImports: "The 'type' modifier cannot be used on a named import when 'import type' is used on its import statement.",
		    UnexpectedParameterModifier: "A parameter property is only allowed in a constructor implementation.",
		    UnexpectedReadonly: "'readonly' type modifier is only permitted on array and tuple literal types.",
		    UnexpectedTypeAnnotation: "Did not expect a type annotation here.",
		    UnexpectedTypeCastInParameter: "Unexpected type cast in parameter position.",
		    UnsupportedImportTypeArgument: "Argument in a type import must be a string literal.",
		    UnsupportedParameterPropertyKind: "A parameter property may not be declared using a binding pattern.",
		    UnsupportedSignatureParameterKind: function UnsupportedSignatureParameterKind(_ref15) {
		      var type = _ref15.type;
		      return "Name in a signature must be an Identifier, ObjectPattern or ArrayPattern, instead got " + type + ".";
		    }
		  });
		  function keywordTypeFromName(value) {
		    switch (value) {
		      case "any":
		        return "TSAnyKeyword";
		      case "boolean":
		        return "TSBooleanKeyword";
		      case "bigint":
		        return "TSBigIntKeyword";
		      case "never":
		        return "TSNeverKeyword";
		      case "number":
		        return "TSNumberKeyword";
		      case "object":
		        return "TSObjectKeyword";
		      case "string":
		        return "TSStringKeyword";
		      case "symbol":
		        return "TSSymbolKeyword";
		      case "undefined":
		        return "TSUndefinedKeyword";
		      case "unknown":
		        return "TSUnknownKeyword";
		      default:
		        return undefined;
		    }
		  }
		  function tsIsAccessModifier(modifier) {
		    return modifier === "private" || modifier === "public" || modifier === "protected";
		  }
		  function tsIsVarianceAnnotations(modifier) {
		    return modifier === "in" || modifier === "out";
		  }
		  var typescript = (function (superClass) {
		    return function (_superClass) {
		      function TypeScriptParserMixin() {
		        var _this;
		        for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
		          args[_key] = arguments[_key];
		        }
		        _this = _superClass.call.apply(_superClass, [this].concat(args)) || this;
		        _this.tsParseInOutModifiers = _this.tsParseModifiers.bind(_this, {
		          allowedModifiers: ["in", "out"],
		          disallowedModifiers: ["const", "public", "private", "protected", "readonly", "declare", "abstract", "override"],
		          errorTemplate: TSErrors.InvalidModifierOnTypeParameter
		        });
		        _this.tsParseConstModifier = _this.tsParseModifiers.bind(_this, {
		          allowedModifiers: ["const"],
		          disallowedModifiers: ["in", "out"],
		          errorTemplate: TSErrors.InvalidModifierOnTypeParameterPositions
		        });
		        _this.tsParseInOutConstModifiers = _this.tsParseModifiers.bind(_this, {
		          allowedModifiers: ["in", "out", "const"],
		          disallowedModifiers: ["public", "private", "protected", "readonly", "declare", "abstract", "override"],
		          errorTemplate: TSErrors.InvalidModifierOnTypeParameter
		        });
		        return _this;
		      }
		      _inherits(TypeScriptParserMixin, _superClass);
		      var _proto = TypeScriptParserMixin.prototype;
		      _proto.getScopeHandler = function getScopeHandler() {
		        return TypeScriptScopeHandler;
		      };
		      _proto.tsIsIdentifier = function tsIsIdentifier() {
		        return tokenIsIdentifier(this.state.type);
		      };
		      _proto.tsTokenCanFollowModifier = function tsTokenCanFollowModifier() {
		        return (this.match(0) || this.match(5) || this.match(55) || this.match(21) || this.match(138) || this.isLiteralPropertyName()) && !this.hasPrecedingLineBreak();
		      };
		      _proto.tsNextTokenCanFollowModifier = function tsNextTokenCanFollowModifier() {
		        this.next();
		        return this.tsTokenCanFollowModifier();
		      };
		      _proto.tsParseModifier = function tsParseModifier(allowedModifiers, stopOnStartOfClassStaticBlock) {
		        if (!tokenIsIdentifier(this.state.type) && this.state.type !== 58 && this.state.type !== 75) {
		          return undefined;
		        }
		        var modifier = this.state.value;
		        if (allowedModifiers.indexOf(modifier) !== -1) {
		          if (stopOnStartOfClassStaticBlock && this.tsIsStartOfStaticBlocks()) {
		            return undefined;
		          }
		          if (this.tsTryParse(this.tsNextTokenCanFollowModifier.bind(this))) {
		            return modifier;
		          }
		        }
		        return undefined;
		      };
		      _proto.tsParseModifiers = function tsParseModifiers(_ref16, modified) {
		        var _this2 = this;
		        var allowedModifiers = _ref16.allowedModifiers,
		          disallowedModifiers = _ref16.disallowedModifiers,
		          stopOnStartOfClassStaticBlock = _ref16.stopOnStartOfClassStaticBlock,
		          _ref16$errorTemplate = _ref16.errorTemplate,
		          errorTemplate = _ref16$errorTemplate === void 0 ? TSErrors.InvalidModifierOnTypeMember : _ref16$errorTemplate;
		        var enforceOrder = function enforceOrder(loc, modifier, before, after) {
		          if (modifier === before && modified[after]) {
		            _this2.raise(TSErrors.InvalidModifiersOrder, loc, {
		              orderedModifiers: [before, after]
		            });
		          }
		        };
		        var incompatible = function incompatible(loc, modifier, mod1, mod2) {
		          if (modified[mod1] && modifier === mod2 || modified[mod2] && modifier === mod1) {
		            _this2.raise(TSErrors.IncompatibleModifiers, loc, {
		              modifiers: [mod1, mod2]
		            });
		          }
		        };
		        for (;;) {
		          var startLoc = this.state.startLoc;
		          var modifier = this.tsParseModifier(allowedModifiers.concat(disallowedModifiers != null ? disallowedModifiers : []), stopOnStartOfClassStaticBlock);
		          if (!modifier) break;
		          if (tsIsAccessModifier(modifier)) {
		            if (modified.accessibility) {
		              this.raise(TSErrors.DuplicateAccessibilityModifier, startLoc, {
		                modifier: modifier
		              });
		            } else {
		              enforceOrder(startLoc, modifier, modifier, "override");
		              enforceOrder(startLoc, modifier, modifier, "static");
		              enforceOrder(startLoc, modifier, modifier, "readonly");
		              modified.accessibility = modifier;
		            }
		          } else if (tsIsVarianceAnnotations(modifier)) {
		            if (modified[modifier]) {
		              this.raise(TSErrors.DuplicateModifier, startLoc, {
		                modifier: modifier
		              });
		            }
		            modified[modifier] = true;
		            enforceOrder(startLoc, modifier, "in", "out");
		          } else {
		            if (hasOwnProperty.call(modified, modifier)) {
		              this.raise(TSErrors.DuplicateModifier, startLoc, {
		                modifier: modifier
		              });
		            } else {
		              enforceOrder(startLoc, modifier, "static", "readonly");
		              enforceOrder(startLoc, modifier, "static", "override");
		              enforceOrder(startLoc, modifier, "override", "readonly");
		              enforceOrder(startLoc, modifier, "abstract", "override");
		              incompatible(startLoc, modifier, "declare", "override");
		              incompatible(startLoc, modifier, "static", "abstract");
		            }
		            modified[modifier] = true;
		          }
		          if (disallowedModifiers != null && disallowedModifiers.includes(modifier)) {
		            this.raise(errorTemplate, startLoc, {
		              modifier: modifier
		            });
		          }
		        }
		      };
		      _proto.tsIsListTerminator = function tsIsListTerminator(kind) {
		        switch (kind) {
		          case "EnumMembers":
		          case "TypeMembers":
		            return this.match(8);
		          case "HeritageClauseElement":
		            return this.match(5);
		          case "TupleElementTypes":
		            return this.match(3);
		          case "TypeParametersOrArguments":
		            return this.match(48);
		        }
		      };
		      _proto.tsParseList = function tsParseList(kind, parseElement) {
		        var result = [];
		        while (!this.tsIsListTerminator(kind)) {
		          result.push(parseElement());
		        }
		        return result;
		      };
		      _proto.tsParseDelimitedList = function tsParseDelimitedList(kind, parseElement, refTrailingCommaPos) {
		        return nonNull(this.tsParseDelimitedListWorker(kind, parseElement, true, refTrailingCommaPos));
		      };
		      _proto.tsParseDelimitedListWorker = function tsParseDelimitedListWorker(kind, parseElement, expectSuccess, refTrailingCommaPos) {
		        var result = [];
		        var trailingCommaPos = -1;
		        for (;;) {
		          if (this.tsIsListTerminator(kind)) {
		            break;
		          }
		          trailingCommaPos = -1;
		          var element = parseElement();
		          if (element == null) {
		            return undefined;
		          }
		          result.push(element);
		          if (this.eat(12)) {
		            trailingCommaPos = this.state.lastTokStartLoc.index;
		            continue;
		          }
		          if (this.tsIsListTerminator(kind)) {
		            break;
		          }
		          if (expectSuccess) {
		            this.expect(12);
		          }
		          return undefined;
		        }
		        if (refTrailingCommaPos) {
		          refTrailingCommaPos.value = trailingCommaPos;
		        }
		        return result;
		      };
		      _proto.tsParseBracketedList = function tsParseBracketedList(kind, parseElement, bracket, skipFirstToken, refTrailingCommaPos) {
		        if (!skipFirstToken) {
		          if (bracket) {
		            this.expect(0);
		          } else {
		            this.expect(47);
		          }
		        }
		        var result = this.tsParseDelimitedList(kind, parseElement, refTrailingCommaPos);
		        if (bracket) {
		          this.expect(3);
		        } else {
		          this.expect(48);
		        }
		        return result;
		      };
		      _proto.tsParseImportType = function tsParseImportType() {
		        var node = this.startNode();
		        this.expect(83);
		        this.expect(10);
		        if (!this.match(133)) {
		          this.raise(TSErrors.UnsupportedImportTypeArgument, this.state.startLoc);
		        }
		        node.argument = _superClass.prototype.parseExprAtom.call(this);
		        if (this.hasPlugin("importAttributes") || this.hasPlugin("importAssertions")) {
		          node.options = null;
		        }
		        if (this.eat(12)) {
		          this.expectImportAttributesPlugin();
		          if (!this.match(11)) {
		            node.options = _superClass.prototype.parseMaybeAssignAllowIn.call(this);
		            this.eat(12);
		          }
		        }
		        this.expect(11);
		        if (this.eat(16)) {
		          node.qualifier = this.tsParseEntityName();
		        }
		        if (this.match(47)) {
		          node.typeParameters = this.tsParseTypeArguments();
		        }
		        return this.finishNode(node, "TSImportType");
		      };
		      _proto.tsParseEntityName = function tsParseEntityName(allowReservedWords) {
		        if (allowReservedWords === void 0) {
		          allowReservedWords = true;
		        }
		        var entity = this.parseIdentifier(allowReservedWords);
		        while (this.eat(16)) {
		          var _node = this.startNodeAtNode(entity);
		          _node.left = entity;
		          _node.right = this.parseIdentifier(allowReservedWords);
		          entity = this.finishNode(_node, "TSQualifiedName");
		        }
		        return entity;
		      };
		      _proto.tsParseTypeReference = function tsParseTypeReference() {
		        var node = this.startNode();
		        node.typeName = this.tsParseEntityName();
		        if (!this.hasPrecedingLineBreak() && this.match(47)) {
		          node.typeParameters = this.tsParseTypeArguments();
		        }
		        return this.finishNode(node, "TSTypeReference");
		      };
		      _proto.tsParseThisTypePredicate = function tsParseThisTypePredicate(lhs) {
		        this.next();
		        var node = this.startNodeAtNode(lhs);
		        node.parameterName = lhs;
		        node.typeAnnotation = this.tsParseTypeAnnotation(false);
		        node.asserts = false;
		        return this.finishNode(node, "TSTypePredicate");
		      };
		      _proto.tsParseThisTypeNode = function tsParseThisTypeNode() {
		        var node = this.startNode();
		        this.next();
		        return this.finishNode(node, "TSThisType");
		      };
		      _proto.tsParseTypeQuery = function tsParseTypeQuery() {
		        var node = this.startNode();
		        this.expect(87);
		        if (this.match(83)) {
		          node.exprName = this.tsParseImportType();
		        } else {
		          node.exprName = this.tsParseEntityName();
		        }
		        if (!this.hasPrecedingLineBreak() && this.match(47)) {
		          node.typeParameters = this.tsParseTypeArguments();
		        }
		        return this.finishNode(node, "TSTypeQuery");
		      };
		      _proto.tsParseTypeParameter = function tsParseTypeParameter(parseModifiers) {
		        var node = this.startNode();
		        parseModifiers(node);
		        node.name = this.tsParseTypeParameterName();
		        node.constraint = this.tsEatThenParseType(81);
		        node["default"] = this.tsEatThenParseType(29);
		        return this.finishNode(node, "TSTypeParameter");
		      };
		      _proto.tsTryParseTypeParameters = function tsTryParseTypeParameters(parseModifiers) {
		        if (this.match(47)) {
		          return this.tsParseTypeParameters(parseModifiers);
		        }
		      };
		      _proto.tsParseTypeParameters = function tsParseTypeParameters(parseModifiers) {
		        var node = this.startNode();
		        if (this.match(47) || this.match(142)) {
		          this.next();
		        } else {
		          this.unexpected();
		        }
		        var refTrailingCommaPos = {
		          value: -1
		        };
		        node.params = this.tsParseBracketedList("TypeParametersOrArguments", this.tsParseTypeParameter.bind(this, parseModifiers), false, true, refTrailingCommaPos);
		        if (node.params.length === 0) {
		          this.raise(TSErrors.EmptyTypeParameters, node);
		        }
		        if (refTrailingCommaPos.value !== -1) {
		          this.addExtra(node, "trailingComma", refTrailingCommaPos.value);
		        }
		        return this.finishNode(node, "TSTypeParameterDeclaration");
		      };
		      _proto.tsFillSignature = function tsFillSignature(returnToken, signature) {
		        var returnTokenRequired = returnToken === 19;
		        var paramsKey = "parameters";
		        var returnTypeKey = "typeAnnotation";
		        signature.typeParameters = this.tsTryParseTypeParameters(this.tsParseConstModifier);
		        this.expect(10);
		        signature[paramsKey] = this.tsParseBindingListForSignature();
		        if (returnTokenRequired) {
		          signature[returnTypeKey] = this.tsParseTypeOrTypePredicateAnnotation(returnToken);
		        } else if (this.match(returnToken)) {
		          signature[returnTypeKey] = this.tsParseTypeOrTypePredicateAnnotation(returnToken);
		        }
		      };
		      _proto.tsParseBindingListForSignature = function tsParseBindingListForSignature() {
		        var list = _superClass.prototype.parseBindingList.call(this, 11, 41, ParseBindingListFlags.IS_FUNCTION_PARAMS);
		        for (var _i2 = 0; _i2 < list.length; _i2++) {
		          var pattern = list[_i2];
		          var type = pattern.type;
		          if (type === "AssignmentPattern" || type === "TSParameterProperty") {
		            this.raise(TSErrors.UnsupportedSignatureParameterKind, pattern, {
		              type: type
		            });
		          }
		        }
		        return list;
		      };
		      _proto.tsParseTypeMemberSemicolon = function tsParseTypeMemberSemicolon() {
		        if (!this.eat(12) && !this.isLineTerminator()) {
		          this.expect(13);
		        }
		      };
		      _proto.tsParseSignatureMember = function tsParseSignatureMember(kind, node) {
		        this.tsFillSignature(14, node);
		        this.tsParseTypeMemberSemicolon();
		        return this.finishNode(node, kind);
		      };
		      _proto.tsIsUnambiguouslyIndexSignature = function tsIsUnambiguouslyIndexSignature() {
		        this.next();
		        if (tokenIsIdentifier(this.state.type)) {
		          this.next();
		          return this.match(14);
		        }
		        return false;
		      };
		      _proto.tsTryParseIndexSignature = function tsTryParseIndexSignature(node) {
		        if (!(this.match(0) && this.tsLookAhead(this.tsIsUnambiguouslyIndexSignature.bind(this)))) {
		          return;
		        }
		        this.expect(0);
		        var id = this.parseIdentifier();
		        id.typeAnnotation = this.tsParseTypeAnnotation();
		        this.resetEndLocation(id);
		        this.expect(3);
		        node.parameters = [id];
		        var type = this.tsTryParseTypeAnnotation();
		        if (type) node.typeAnnotation = type;
		        this.tsParseTypeMemberSemicolon();
		        return this.finishNode(node, "TSIndexSignature");
		      };
		      _proto.tsParsePropertyOrMethodSignature = function tsParsePropertyOrMethodSignature(node, readonly) {
		        if (this.eat(17)) node.optional = true;
		        var nodeAny = node;
		        if (this.match(10) || this.match(47)) {
		          if (readonly) {
		            this.raise(TSErrors.ReadonlyForMethodSignature, node);
		          }
		          var method = nodeAny;
		          if (method.kind && this.match(47)) {
		            this.raise(TSErrors.AccesorCannotHaveTypeParameters, this.state.curPosition());
		          }
		          this.tsFillSignature(14, method);
		          this.tsParseTypeMemberSemicolon();
		          var paramsKey = "parameters";
		          var returnTypeKey = "typeAnnotation";
		          if (method.kind === "get") {
		            if (method[paramsKey].length > 0) {
		              this.raise(Errors.BadGetterArity, this.state.curPosition());
		              if (this.isThisParam(method[paramsKey][0])) {
		                this.raise(TSErrors.AccesorCannotDeclareThisParameter, this.state.curPosition());
		              }
		            }
		          } else if (method.kind === "set") {
		            if (method[paramsKey].length !== 1) {
		              this.raise(Errors.BadSetterArity, this.state.curPosition());
		            } else {
		              var firstParameter = method[paramsKey][0];
		              if (this.isThisParam(firstParameter)) {
		                this.raise(TSErrors.AccesorCannotDeclareThisParameter, this.state.curPosition());
		              }
		              if (firstParameter.type === "Identifier" && firstParameter.optional) {
		                this.raise(TSErrors.SetAccesorCannotHaveOptionalParameter, this.state.curPosition());
		              }
		              if (firstParameter.type === "RestElement") {
		                this.raise(TSErrors.SetAccesorCannotHaveRestParameter, this.state.curPosition());
		              }
		            }
		            if (method[returnTypeKey]) {
		              this.raise(TSErrors.SetAccesorCannotHaveReturnType, method[returnTypeKey]);
		            }
		          } else {
		            method.kind = "method";
		          }
		          return this.finishNode(method, "TSMethodSignature");
		        } else {
		          var property = nodeAny;
		          if (readonly) property.readonly = true;
		          var type = this.tsTryParseTypeAnnotation();
		          if (type) property.typeAnnotation = type;
		          this.tsParseTypeMemberSemicolon();
		          return this.finishNode(property, "TSPropertySignature");
		        }
		      };
		      _proto.tsParseTypeMember = function tsParseTypeMember() {
		        var node = this.startNode();
		        if (this.match(10) || this.match(47)) {
		          return this.tsParseSignatureMember("TSCallSignatureDeclaration", node);
		        }
		        if (this.match(77)) {
		          var id = this.startNode();
		          this.next();
		          if (this.match(10) || this.match(47)) {
		            return this.tsParseSignatureMember("TSConstructSignatureDeclaration", node);
		          } else {
		            node.key = this.createIdentifier(id, "new");
		            return this.tsParsePropertyOrMethodSignature(node, false);
		          }
		        }
		        this.tsParseModifiers({
		          allowedModifiers: ["readonly"],
		          disallowedModifiers: ["declare", "abstract", "private", "protected", "public", "static", "override"]
		        }, node);
		        var idx = this.tsTryParseIndexSignature(node);
		        if (idx) {
		          return idx;
		        }
		        _superClass.prototype.parsePropertyName.call(this, node);
		        if (!node.computed && node.key.type === "Identifier" && (node.key.name === "get" || node.key.name === "set") && this.tsTokenCanFollowModifier()) {
		          node.kind = node.key.name;
		          _superClass.prototype.parsePropertyName.call(this, node);
		        }
		        return this.tsParsePropertyOrMethodSignature(node, !!node.readonly);
		      };
		      _proto.tsParseTypeLiteral = function tsParseTypeLiteral() {
		        var node = this.startNode();
		        node.members = this.tsParseObjectTypeMembers();
		        return this.finishNode(node, "TSTypeLiteral");
		      };
		      _proto.tsParseObjectTypeMembers = function tsParseObjectTypeMembers() {
		        this.expect(5);
		        var members = this.tsParseList("TypeMembers", this.tsParseTypeMember.bind(this));
		        this.expect(8);
		        return members;
		      };
		      _proto.tsIsStartOfMappedType = function tsIsStartOfMappedType() {
		        this.next();
		        if (this.eat(53)) {
		          return this.isContextual(122);
		        }
		        if (this.isContextual(122)) {
		          this.next();
		        }
		        if (!this.match(0)) {
		          return false;
		        }
		        this.next();
		        if (!this.tsIsIdentifier()) {
		          return false;
		        }
		        this.next();
		        return this.match(58);
		      };
		      _proto.tsParseMappedTypeParameter = function tsParseMappedTypeParameter() {
		        var node = this.startNode();
		        node.name = this.tsParseTypeParameterName();
		        node.constraint = this.tsExpectThenParseType(58);
		        return this.finishNode(node, "TSTypeParameter");
		      };
		      _proto.tsParseMappedType = function tsParseMappedType() {
		        var node = this.startNode();
		        this.expect(5);
		        if (this.match(53)) {
		          node.readonly = this.state.value;
		          this.next();
		          this.expectContextual(122);
		        } else if (this.eatContextual(122)) {
		          node.readonly = true;
		        }
		        this.expect(0);
		        node.typeParameter = this.tsParseMappedTypeParameter();
		        node.nameType = this.eatContextual(93) ? this.tsParseType() : null;
		        this.expect(3);
		        if (this.match(53)) {
		          node.optional = this.state.value;
		          this.next();
		          this.expect(17);
		        } else if (this.eat(17)) {
		          node.optional = true;
		        }
		        node.typeAnnotation = this.tsTryParseType();
		        this.semicolon();
		        this.expect(8);
		        return this.finishNode(node, "TSMappedType");
		      };
		      _proto.tsParseTupleType = function tsParseTupleType() {
		        var _this3 = this;
		        var node = this.startNode();
		        node.elementTypes = this.tsParseBracketedList("TupleElementTypes", this.tsParseTupleElementType.bind(this), true, false);
		        var seenOptionalElement = false;
		        node.elementTypes.forEach(function (elementNode) {
		          var type = elementNode.type;
		          if (seenOptionalElement && type !== "TSRestType" && type !== "TSOptionalType" && !(type === "TSNamedTupleMember" && elementNode.optional)) {
		            _this3.raise(TSErrors.OptionalTypeBeforeRequired, elementNode);
		          }
		          seenOptionalElement || (seenOptionalElement = type === "TSNamedTupleMember" && elementNode.optional || type === "TSOptionalType");
		        });
		        return this.finishNode(node, "TSTupleType");
		      };
		      _proto.tsParseTupleElementType = function tsParseTupleElementType() {
		        var startLoc = this.state.startLoc;
		        var rest = this.eat(21);
		        var labeled;
		        var label;
		        var optional;
		        var type;
		        var isWord = tokenIsKeywordOrIdentifier(this.state.type);
		        var chAfterWord = isWord ? this.lookaheadCharCode() : null;
		        if (chAfterWord === 58) {
		          labeled = true;
		          optional = false;
		          label = this.parseIdentifier(true);
		          this.expect(14);
		          type = this.tsParseType();
		        } else if (chAfterWord === 63) {
		          optional = true;
		          var _startLoc = this.state.startLoc;
		          var wordName = this.state.value;
		          var typeOrLabel = this.tsParseNonArrayType();
		          if (this.lookaheadCharCode() === 58) {
		            labeled = true;
		            label = this.createIdentifier(this.startNodeAt(_startLoc), wordName);
		            this.expect(17);
		            this.expect(14);
		            type = this.tsParseType();
		          } else {
		            labeled = false;
		            type = typeOrLabel;
		            this.expect(17);
		          }
		        } else {
		          type = this.tsParseType();
		          optional = this.eat(17);
		          labeled = this.eat(14);
		        }
		        if (labeled) {
		          var labeledNode;
		          if (label) {
		            labeledNode = this.startNodeAtNode(label);
		            labeledNode.optional = optional;
		            labeledNode.label = label;
		            labeledNode.elementType = type;
		            if (this.eat(17)) {
		              labeledNode.optional = true;
		              this.raise(TSErrors.TupleOptionalAfterType, this.state.lastTokStartLoc);
		            }
		          } else {
		            labeledNode = this.startNodeAtNode(type);
		            labeledNode.optional = optional;
		            this.raise(TSErrors.InvalidTupleMemberLabel, type);
		            labeledNode.label = type;
		            labeledNode.elementType = this.tsParseType();
		          }
		          type = this.finishNode(labeledNode, "TSNamedTupleMember");
		        } else if (optional) {
		          var optionalTypeNode = this.startNodeAtNode(type);
		          optionalTypeNode.typeAnnotation = type;
		          type = this.finishNode(optionalTypeNode, "TSOptionalType");
		        }
		        if (rest) {
		          var restNode = this.startNodeAt(startLoc);
		          restNode.typeAnnotation = type;
		          type = this.finishNode(restNode, "TSRestType");
		        }
		        return type;
		      };
		      _proto.tsParseParenthesizedType = function tsParseParenthesizedType() {
		        var node = this.startNode();
		        this.expect(10);
		        node.typeAnnotation = this.tsParseType();
		        this.expect(11);
		        return this.finishNode(node, "TSParenthesizedType");
		      };
		      _proto.tsParseFunctionOrConstructorType = function tsParseFunctionOrConstructorType(type, _abstract) {
		        var _this4 = this;
		        var node = this.startNode();
		        if (type === "TSConstructorType") {
		          node["abstract"] = !!_abstract;
		          if (_abstract) this.next();
		          this.next();
		        }
		        this.tsInAllowConditionalTypesContext(function () {
		          return _this4.tsFillSignature(19, node);
		        });
		        return this.finishNode(node, type);
		      };
		      _proto.tsParseLiteralTypeNode = function tsParseLiteralTypeNode() {
		        var node = this.startNode();
		        switch (this.state.type) {
		          case 134:
		          case 135:
		          case 133:
		          case 85:
		          case 86:
		            node.literal = _superClass.prototype.parseExprAtom.call(this);
		            break;
		          default:
		            this.unexpected();
		        }
		        return this.finishNode(node, "TSLiteralType");
		      };
		      _proto.tsParseTemplateLiteralType = function tsParseTemplateLiteralType() {
		        var node = this.startNode();
		        node.literal = _superClass.prototype.parseTemplate.call(this, false);
		        return this.finishNode(node, "TSLiteralType");
		      };
		      _proto.parseTemplateSubstitution = function parseTemplateSubstitution() {
		        if (this.state.inType) return this.tsParseType();
		        return _superClass.prototype.parseTemplateSubstitution.call(this);
		      };
		      _proto.tsParseThisTypeOrThisTypePredicate = function tsParseThisTypeOrThisTypePredicate() {
		        var thisKeyword = this.tsParseThisTypeNode();
		        if (this.isContextual(116) && !this.hasPrecedingLineBreak()) {
		          return this.tsParseThisTypePredicate(thisKeyword);
		        } else {
		          return thisKeyword;
		        }
		      };
		      _proto.tsParseNonArrayType = function tsParseNonArrayType() {
		        switch (this.state.type) {
		          case 133:
		          case 134:
		          case 135:
		          case 85:
		          case 86:
		            return this.tsParseLiteralTypeNode();
		          case 53:
		            if (this.state.value === "-") {
		              var _node2 = this.startNode();
		              var nextToken = this.lookahead();
		              if (nextToken.type !== 134 && nextToken.type !== 135) {
		                this.unexpected();
		              }
		              _node2.literal = this.parseMaybeUnary();
		              return this.finishNode(_node2, "TSLiteralType");
		            }
		            break;
		          case 78:
		            return this.tsParseThisTypeOrThisTypePredicate();
		          case 87:
		            return this.tsParseTypeQuery();
		          case 83:
		            return this.tsParseImportType();
		          case 5:
		            return this.tsLookAhead(this.tsIsStartOfMappedType.bind(this)) ? this.tsParseMappedType() : this.tsParseTypeLiteral();
		          case 0:
		            return this.tsParseTupleType();
		          case 10:
		            return this.tsParseParenthesizedType();
		          case 25:
		          case 24:
		            return this.tsParseTemplateLiteralType();
		          default:
		            {
		              var type = this.state.type;
		              if (tokenIsIdentifier(type) || type === 88 || type === 84) {
		                var nodeType = type === 88 ? "TSVoidKeyword" : type === 84 ? "TSNullKeyword" : keywordTypeFromName(this.state.value);
		                if (nodeType !== undefined && this.lookaheadCharCode() !== 46) {
		                  var _node3 = this.startNode();
		                  this.next();
		                  return this.finishNode(_node3, nodeType);
		                }
		                return this.tsParseTypeReference();
		              }
		            }
		        }
		        this.unexpected();
		      };
		      _proto.tsParseArrayTypeOrHigher = function tsParseArrayTypeOrHigher() {
		        var type = this.tsParseNonArrayType();
		        while (!this.hasPrecedingLineBreak() && this.eat(0)) {
		          if (this.match(3)) {
		            var _node4 = this.startNodeAtNode(type);
		            _node4.elementType = type;
		            this.expect(3);
		            type = this.finishNode(_node4, "TSArrayType");
		          } else {
		            var _node5 = this.startNodeAtNode(type);
		            _node5.objectType = type;
		            _node5.indexType = this.tsParseType();
		            this.expect(3);
		            type = this.finishNode(_node5, "TSIndexedAccessType");
		          }
		        }
		        return type;
		      };
		      _proto.tsParseTypeOperator = function tsParseTypeOperator() {
		        var node = this.startNode();
		        var operator = this.state.value;
		        this.next();
		        node.operator = operator;
		        node.typeAnnotation = this.tsParseTypeOperatorOrHigher();
		        if (operator === "readonly") {
		          this.tsCheckTypeAnnotationForReadOnly(node);
		        }
		        return this.finishNode(node, "TSTypeOperator");
		      };
		      _proto.tsCheckTypeAnnotationForReadOnly = function tsCheckTypeAnnotationForReadOnly(node) {
		        switch (node.typeAnnotation.type) {
		          case "TSTupleType":
		          case "TSArrayType":
		            return;
		          default:
		            this.raise(TSErrors.UnexpectedReadonly, node);
		        }
		      };
		      _proto.tsParseInferType = function tsParseInferType() {
		        var _this5 = this;
		        var node = this.startNode();
		        this.expectContextual(115);
		        var typeParameter = this.startNode();
		        typeParameter.name = this.tsParseTypeParameterName();
		        typeParameter.constraint = this.tsTryParse(function () {
		          return _this5.tsParseConstraintForInferType();
		        });
		        node.typeParameter = this.finishNode(typeParameter, "TSTypeParameter");
		        return this.finishNode(node, "TSInferType");
		      };
		      _proto.tsParseConstraintForInferType = function tsParseConstraintForInferType() {
		        var _this6 = this;
		        if (this.eat(81)) {
		          var constraint = this.tsInDisallowConditionalTypesContext(function () {
		            return _this6.tsParseType();
		          });
		          if (this.state.inDisallowConditionalTypesContext || !this.match(17)) {
		            return constraint;
		          }
		        }
		      };
		      _proto.tsParseTypeOperatorOrHigher = function tsParseTypeOperatorOrHigher() {
		        var _this7 = this;
		        var isTypeOperator = tokenIsTSTypeOperator(this.state.type) && !this.state.containsEsc;
		        return isTypeOperator ? this.tsParseTypeOperator() : this.isContextual(115) ? this.tsParseInferType() : this.tsInAllowConditionalTypesContext(function () {
		          return _this7.tsParseArrayTypeOrHigher();
		        });
		      };
		      _proto.tsParseUnionOrIntersectionType = function tsParseUnionOrIntersectionType(kind, parseConstituentType, operator) {
		        var node = this.startNode();
		        var hasLeadingOperator = this.eat(operator);
		        var types = [];
		        do {
		          types.push(parseConstituentType());
		        } while (this.eat(operator));
		        if (types.length === 1 && !hasLeadingOperator) {
		          return types[0];
		        }
		        node.types = types;
		        return this.finishNode(node, kind);
		      };
		      _proto.tsParseIntersectionTypeOrHigher = function tsParseIntersectionTypeOrHigher() {
		        return this.tsParseUnionOrIntersectionType("TSIntersectionType", this.tsParseTypeOperatorOrHigher.bind(this), 45);
		      };
		      _proto.tsParseUnionTypeOrHigher = function tsParseUnionTypeOrHigher() {
		        return this.tsParseUnionOrIntersectionType("TSUnionType", this.tsParseIntersectionTypeOrHigher.bind(this), 43);
		      };
		      _proto.tsIsStartOfFunctionType = function tsIsStartOfFunctionType() {
		        if (this.match(47)) {
		          return true;
		        }
		        return this.match(10) && this.tsLookAhead(this.tsIsUnambiguouslyStartOfFunctionType.bind(this));
		      };
		      _proto.tsSkipParameterStart = function tsSkipParameterStart() {
		        if (tokenIsIdentifier(this.state.type) || this.match(78)) {
		          this.next();
		          return true;
		        }
		        if (this.match(5)) {
		          var errors = this.state.errors;
		          var previousErrorCount = errors.length;
		          try {
		            this.parseObjectLike(8, true);
		            return errors.length === previousErrorCount;
		          } catch (_unused) {
		            return false;
		          }
		        }
		        if (this.match(0)) {
		          this.next();
		          var _errors = this.state.errors;
		          var _previousErrorCount = _errors.length;
		          try {
		            _superClass.prototype.parseBindingList.call(this, 3, 93, ParseBindingListFlags.ALLOW_EMPTY);
		            return _errors.length === _previousErrorCount;
		          } catch (_unused2) {
		            return false;
		          }
		        }
		        return false;
		      };
		      _proto.tsIsUnambiguouslyStartOfFunctionType = function tsIsUnambiguouslyStartOfFunctionType() {
		        this.next();
		        if (this.match(11) || this.match(21)) {
		          return true;
		        }
		        if (this.tsSkipParameterStart()) {
		          if (this.match(14) || this.match(12) || this.match(17) || this.match(29)) {
		            return true;
		          }
		          if (this.match(11)) {
		            this.next();
		            if (this.match(19)) {
		              return true;
		            }
		          }
		        }
		        return false;
		      };
		      _proto.tsParseTypeOrTypePredicateAnnotation = function tsParseTypeOrTypePredicateAnnotation(returnToken) {
		        var _this8 = this;
		        return this.tsInType(function () {
		          var t = _this8.startNode();
		          _this8.expect(returnToken);
		          var node = _this8.startNode();
		          var asserts = !!_this8.tsTryParse(_this8.tsParseTypePredicateAsserts.bind(_this8));
		          if (asserts && _this8.match(78)) {
		            var thisTypePredicate = _this8.tsParseThisTypeOrThisTypePredicate();
		            if (thisTypePredicate.type === "TSThisType") {
		              node.parameterName = thisTypePredicate;
		              node.asserts = true;
		              node.typeAnnotation = null;
		              thisTypePredicate = _this8.finishNode(node, "TSTypePredicate");
		            } else {
		              _this8.resetStartLocationFromNode(thisTypePredicate, node);
		              thisTypePredicate.asserts = true;
		            }
		            t.typeAnnotation = thisTypePredicate;
		            return _this8.finishNode(t, "TSTypeAnnotation");
		          }
		          var typePredicateVariable = _this8.tsIsIdentifier() && _this8.tsTryParse(_this8.tsParseTypePredicatePrefix.bind(_this8));
		          if (!typePredicateVariable) {
		            if (!asserts) {
		              return _this8.tsParseTypeAnnotation(false, t);
		            }
		            node.parameterName = _this8.parseIdentifier();
		            node.asserts = asserts;
		            node.typeAnnotation = null;
		            t.typeAnnotation = _this8.finishNode(node, "TSTypePredicate");
		            return _this8.finishNode(t, "TSTypeAnnotation");
		          }
		          var type = _this8.tsParseTypeAnnotation(false);
		          node.parameterName = typePredicateVariable;
		          node.typeAnnotation = type;
		          node.asserts = asserts;
		          t.typeAnnotation = _this8.finishNode(node, "TSTypePredicate");
		          return _this8.finishNode(t, "TSTypeAnnotation");
		        });
		      };
		      _proto.tsTryParseTypeOrTypePredicateAnnotation = function tsTryParseTypeOrTypePredicateAnnotation() {
		        if (this.match(14)) {
		          return this.tsParseTypeOrTypePredicateAnnotation(14);
		        }
		      };
		      _proto.tsTryParseTypeAnnotation = function tsTryParseTypeAnnotation() {
		        if (this.match(14)) {
		          return this.tsParseTypeAnnotation();
		        }
		      };
		      _proto.tsTryParseType = function tsTryParseType() {
		        return this.tsEatThenParseType(14);
		      };
		      _proto.tsParseTypePredicatePrefix = function tsParseTypePredicatePrefix() {
		        var id = this.parseIdentifier();
		        if (this.isContextual(116) && !this.hasPrecedingLineBreak()) {
		          this.next();
		          return id;
		        }
		      };
		      _proto.tsParseTypePredicateAsserts = function tsParseTypePredicateAsserts() {
		        if (this.state.type !== 109) {
		          return false;
		        }
		        var containsEsc = this.state.containsEsc;
		        this.next();
		        if (!tokenIsIdentifier(this.state.type) && !this.match(78)) {
		          return false;
		        }
		        if (containsEsc) {
		          this.raise(Errors.InvalidEscapedReservedWord, this.state.lastTokStartLoc, {
		            reservedWord: "asserts"
		          });
		        }
		        return true;
		      };
		      _proto.tsParseTypeAnnotation = function tsParseTypeAnnotation(eatColon, t) {
		        var _this9 = this;
		        if (eatColon === void 0) {
		          eatColon = true;
		        }
		        if (t === void 0) {
		          t = this.startNode();
		        }
		        this.tsInType(function () {
		          if (eatColon) _this9.expect(14);
		          t.typeAnnotation = _this9.tsParseType();
		        });
		        return this.finishNode(t, "TSTypeAnnotation");
		      };
		      _proto.tsParseType = function tsParseType() {
		        var _this10 = this;
		        assert$1(this.state.inType);
		        var type = this.tsParseNonConditionalType();
		        if (this.state.inDisallowConditionalTypesContext || this.hasPrecedingLineBreak() || !this.eat(81)) {
		          return type;
		        }
		        var node = this.startNodeAtNode(type);
		        node.checkType = type;
		        node.extendsType = this.tsInDisallowConditionalTypesContext(function () {
		          return _this10.tsParseNonConditionalType();
		        });
		        this.expect(17);
		        node.trueType = this.tsInAllowConditionalTypesContext(function () {
		          return _this10.tsParseType();
		        });
		        this.expect(14);
		        node.falseType = this.tsInAllowConditionalTypesContext(function () {
		          return _this10.tsParseType();
		        });
		        return this.finishNode(node, "TSConditionalType");
		      };
		      _proto.isAbstractConstructorSignature = function isAbstractConstructorSignature() {
		        return this.isContextual(124) && this.lookahead().type === 77;
		      };
		      _proto.tsParseNonConditionalType = function tsParseNonConditionalType() {
		        if (this.tsIsStartOfFunctionType()) {
		          return this.tsParseFunctionOrConstructorType("TSFunctionType");
		        }
		        if (this.match(77)) {
		          return this.tsParseFunctionOrConstructorType("TSConstructorType");
		        } else if (this.isAbstractConstructorSignature()) {
		          return this.tsParseFunctionOrConstructorType("TSConstructorType", true);
		        }
		        return this.tsParseUnionTypeOrHigher();
		      };
		      _proto.tsParseTypeAssertion = function tsParseTypeAssertion() {
		        var _this11 = this;
		        if (this.getPluginOption("typescript", "disallowAmbiguousJSXLike")) {
		          this.raise(TSErrors.ReservedTypeAssertion, this.state.startLoc);
		        }
		        var node = this.startNode();
		        node.typeAnnotation = this.tsInType(function () {
		          _this11.next();
		          return _this11.match(75) ? _this11.tsParseTypeReference() : _this11.tsParseType();
		        });
		        this.expect(48);
		        node.expression = this.parseMaybeUnary();
		        return this.finishNode(node, "TSTypeAssertion");
		      };
		      _proto.tsParseHeritageClause = function tsParseHeritageClause(token) {
		        var _this12 = this;
		        var originalStartLoc = this.state.startLoc;
		        var delimitedList = this.tsParseDelimitedList("HeritageClauseElement", function () {
		          var node = _this12.startNode();
		          node.expression = _this12.tsParseEntityName();
		          if (_this12.match(47)) {
		            node.typeParameters = _this12.tsParseTypeArguments();
		          }
		          return _this12.finishNode(node, "TSExpressionWithTypeArguments");
		        });
		        if (!delimitedList.length) {
		          this.raise(TSErrors.EmptyHeritageClauseType, originalStartLoc, {
		            token: token
		          });
		        }
		        return delimitedList;
		      };
		      _proto.tsParseInterfaceDeclaration = function tsParseInterfaceDeclaration(node, properties) {
		        if (properties === void 0) {
		          properties = {};
		        }
		        if (this.hasFollowingLineBreak()) return null;
		        this.expectContextual(129);
		        if (properties.declare) node.declare = true;
		        if (tokenIsIdentifier(this.state.type)) {
		          node.id = this.parseIdentifier();
		          this.checkIdentifier(node.id, BindingFlag.TYPE_TS_INTERFACE);
		        } else {
		          node.id = null;
		          this.raise(TSErrors.MissingInterfaceName, this.state.startLoc);
		        }
		        node.typeParameters = this.tsTryParseTypeParameters(this.tsParseInOutConstModifiers);
		        if (this.eat(81)) {
		          node["extends"] = this.tsParseHeritageClause("extends");
		        }
		        var body = this.startNode();
		        body.body = this.tsInType(this.tsParseObjectTypeMembers.bind(this));
		        node.body = this.finishNode(body, "TSInterfaceBody");
		        return this.finishNode(node, "TSInterfaceDeclaration");
		      };
		      _proto.tsParseTypeAliasDeclaration = function tsParseTypeAliasDeclaration(node) {
		        var _this13 = this;
		        node.id = this.parseIdentifier();
		        this.checkIdentifier(node.id, BindingFlag.TYPE_TS_TYPE);
		        node.typeAnnotation = this.tsInType(function () {
		          node.typeParameters = _this13.tsTryParseTypeParameters(_this13.tsParseInOutModifiers);
		          _this13.expect(29);
		          if (_this13.isContextual(114) && _this13.lookahead().type !== 16) {
		            var _node6 = _this13.startNode();
		            _this13.next();
		            return _this13.finishNode(_node6, "TSIntrinsicKeyword");
		          }
		          return _this13.tsParseType();
		        });
		        this.semicolon();
		        return this.finishNode(node, "TSTypeAliasDeclaration");
		      };
		      _proto.tsInNoContext = function tsInNoContext(cb) {
		        var oldContext = this.state.context;
		        this.state.context = [oldContext[0]];
		        try {
		          return cb();
		        } finally {
		          this.state.context = oldContext;
		        }
		      };
		      _proto.tsInType = function tsInType(cb) {
		        var oldInType = this.state.inType;
		        this.state.inType = true;
		        try {
		          return cb();
		        } finally {
		          this.state.inType = oldInType;
		        }
		      };
		      _proto.tsInDisallowConditionalTypesContext = function tsInDisallowConditionalTypesContext(cb) {
		        var oldInDisallowConditionalTypesContext = this.state.inDisallowConditionalTypesContext;
		        this.state.inDisallowConditionalTypesContext = true;
		        try {
		          return cb();
		        } finally {
		          this.state.inDisallowConditionalTypesContext = oldInDisallowConditionalTypesContext;
		        }
		      };
		      _proto.tsInAllowConditionalTypesContext = function tsInAllowConditionalTypesContext(cb) {
		        var oldInDisallowConditionalTypesContext = this.state.inDisallowConditionalTypesContext;
		        this.state.inDisallowConditionalTypesContext = false;
		        try {
		          return cb();
		        } finally {
		          this.state.inDisallowConditionalTypesContext = oldInDisallowConditionalTypesContext;
		        }
		      };
		      _proto.tsEatThenParseType = function tsEatThenParseType(token) {
		        if (this.match(token)) {
		          return this.tsNextThenParseType();
		        }
		      };
		      _proto.tsExpectThenParseType = function tsExpectThenParseType(token) {
		        var _this14 = this;
		        return this.tsInType(function () {
		          _this14.expect(token);
		          return _this14.tsParseType();
		        });
		      };
		      _proto.tsNextThenParseType = function tsNextThenParseType() {
		        var _this15 = this;
		        return this.tsInType(function () {
		          _this15.next();
		          return _this15.tsParseType();
		        });
		      };
		      _proto.tsParseEnumMember = function tsParseEnumMember() {
		        var node = this.startNode();
		        node.id = this.match(133) ? _superClass.prototype.parseStringLiteral.call(this, this.state.value) : this.parseIdentifier(true);
		        if (this.eat(29)) {
		          node.initializer = _superClass.prototype.parseMaybeAssignAllowIn.call(this);
		        }
		        return this.finishNode(node, "TSEnumMember");
		      };
		      _proto.tsParseEnumDeclaration = function tsParseEnumDeclaration(node, properties) {
		        if (properties === void 0) {
		          properties = {};
		        }
		        if (properties["const"]) node["const"] = true;
		        if (properties.declare) node.declare = true;
		        this.expectContextual(126);
		        node.id = this.parseIdentifier();
		        this.checkIdentifier(node.id, node["const"] ? BindingFlag.TYPE_TS_CONST_ENUM : BindingFlag.TYPE_TS_ENUM);
		        this.expect(5);
		        node.members = this.tsParseDelimitedList("EnumMembers", this.tsParseEnumMember.bind(this));
		        this.expect(8);
		        return this.finishNode(node, "TSEnumDeclaration");
		      };
		      _proto.tsParseModuleBlock = function tsParseModuleBlock() {
		        var node = this.startNode();
		        this.scope.enter(ScopeFlag.OTHER);
		        this.expect(5);
		        _superClass.prototype.parseBlockOrModuleBlockBody.call(this, node.body = [], undefined, true, 8);
		        this.scope.exit();
		        return this.finishNode(node, "TSModuleBlock");
		      };
		      _proto.tsParseModuleOrNamespaceDeclaration = function tsParseModuleOrNamespaceDeclaration(node, nested) {
		        if (nested === void 0) {
		          nested = false;
		        }
		        node.id = this.parseIdentifier();
		        if (!nested) {
		          this.checkIdentifier(node.id, BindingFlag.TYPE_TS_NAMESPACE);
		        }
		        if (this.eat(16)) {
		          var inner = this.startNode();
		          this.tsParseModuleOrNamespaceDeclaration(inner, true);
		          node.body = inner;
		        } else {
		          this.scope.enter(ScopeFlag.TS_MODULE);
		          this.prodParam.enter(ParamKind.PARAM);
		          node.body = this.tsParseModuleBlock();
		          this.prodParam.exit();
		          this.scope.exit();
		        }
		        return this.finishNode(node, "TSModuleDeclaration");
		      };
		      _proto.tsParseAmbientExternalModuleDeclaration = function tsParseAmbientExternalModuleDeclaration(node) {
		        if (this.isContextual(112)) {
		          node.global = true;
		          node.id = this.parseIdentifier();
		        } else if (this.match(133)) {
		          node.id = _superClass.prototype.parseStringLiteral.call(this, this.state.value);
		        } else {
		          this.unexpected();
		        }
		        if (this.match(5)) {
		          this.scope.enter(ScopeFlag.TS_MODULE);
		          this.prodParam.enter(ParamKind.PARAM);
		          node.body = this.tsParseModuleBlock();
		          this.prodParam.exit();
		          this.scope.exit();
		        } else {
		          this.semicolon();
		        }
		        return this.finishNode(node, "TSModuleDeclaration");
		      };
		      _proto.tsParseImportEqualsDeclaration = function tsParseImportEqualsDeclaration(node, maybeDefaultIdentifier, isExport) {
		        node.isExport = isExport || false;
		        node.id = maybeDefaultIdentifier || this.parseIdentifier();
		        this.checkIdentifier(node.id, BindingFlag.TYPE_TS_VALUE_IMPORT);
		        this.expect(29);
		        var moduleReference = this.tsParseModuleReference();
		        if (node.importKind === "type" && moduleReference.type !== "TSExternalModuleReference") {
		          this.raise(TSErrors.ImportAliasHasImportType, moduleReference);
		        }
		        node.moduleReference = moduleReference;
		        this.semicolon();
		        return this.finishNode(node, "TSImportEqualsDeclaration");
		      };
		      _proto.tsIsExternalModuleReference = function tsIsExternalModuleReference() {
		        return this.isContextual(119) && this.lookaheadCharCode() === 40;
		      };
		      _proto.tsParseModuleReference = function tsParseModuleReference() {
		        return this.tsIsExternalModuleReference() ? this.tsParseExternalModuleReference() : this.tsParseEntityName(false);
		      };
		      _proto.tsParseExternalModuleReference = function tsParseExternalModuleReference() {
		        var node = this.startNode();
		        this.expectContextual(119);
		        this.expect(10);
		        if (!this.match(133)) {
		          this.unexpected();
		        }
		        node.expression = _superClass.prototype.parseExprAtom.call(this);
		        this.expect(11);
		        this.sawUnambiguousESM = true;
		        return this.finishNode(node, "TSExternalModuleReference");
		      };
		      _proto.tsLookAhead = function tsLookAhead(f) {
		        var state = this.state.clone();
		        var res = f();
		        this.state = state;
		        return res;
		      };
		      _proto.tsTryParseAndCatch = function tsTryParseAndCatch(f) {
		        var result = this.tryParse(function (abort) {
		          return f() || abort();
		        });
		        if (result.aborted || !result.node) return;
		        if (result.error) this.state = result.failState;
		        return result.node;
		      };
		      _proto.tsTryParse = function tsTryParse(f) {
		        var state = this.state.clone();
		        var result = f();
		        if (result !== undefined && result !== false) {
		          return result;
		        }
		        this.state = state;
		      };
		      _proto.tsTryParseDeclare = function tsTryParseDeclare(nany) {
		        var _this16 = this;
		        if (this.isLineTerminator()) {
		          return;
		        }
		        var startType = this.state.type;
		        var kind;
		        if (this.isContextual(100)) {
		          startType = 74;
		          kind = "let";
		        }
		        return this.tsInAmbientContext(function () {
		          switch (startType) {
		            case 68:
		              nany.declare = true;
		              return _superClass.prototype.parseFunctionStatement.call(_this16, nany, false, false);
		            case 80:
		              nany.declare = true;
		              return _this16.parseClass(nany, true, false);
		            case 126:
		              return _this16.tsParseEnumDeclaration(nany, {
		                declare: true
		              });
		            case 112:
		              return _this16.tsParseAmbientExternalModuleDeclaration(nany);
		            case 75:
		            case 74:
		              if (!_this16.match(75) || !_this16.isLookaheadContextual("enum")) {
		                nany.declare = true;
		                return _this16.parseVarStatement(nany, kind || _this16.state.value, true);
		              }
		              _this16.expect(75);
		              return _this16.tsParseEnumDeclaration(nany, {
		                "const": true,
		                declare: true
		              });
		            case 129:
		              {
		                var result = _this16.tsParseInterfaceDeclaration(nany, {
		                  declare: true
		                });
		                if (result) return result;
		              }
		            default:
		              if (tokenIsIdentifier(startType)) {
		                return _this16.tsParseDeclaration(nany, _this16.state.value, true, null);
		              }
		          }
		        });
		      };
		      _proto.tsTryParseExportDeclaration = function tsTryParseExportDeclaration() {
		        return this.tsParseDeclaration(this.startNode(), this.state.value, true, null);
		      };
		      _proto.tsParseExpressionStatement = function tsParseExpressionStatement(node, expr, decorators) {
		        switch (expr.name) {
		          case "declare":
		            {
		              var declaration = this.tsTryParseDeclare(node);
		              if (declaration) {
		                declaration.declare = true;
		              }
		              return declaration;
		            }
		          case "global":
		            if (this.match(5)) {
		              this.scope.enter(ScopeFlag.TS_MODULE);
		              this.prodParam.enter(ParamKind.PARAM);
		              var mod = node;
		              mod.global = true;
		              mod.id = expr;
		              mod.body = this.tsParseModuleBlock();
		              this.scope.exit();
		              this.prodParam.exit();
		              return this.finishNode(mod, "TSModuleDeclaration");
		            }
		            break;
		          default:
		            return this.tsParseDeclaration(node, expr.name, false, decorators);
		        }
		      };
		      _proto.tsParseDeclaration = function tsParseDeclaration(node, value, next, decorators) {
		        switch (value) {
		          case "abstract":
		            if (this.tsCheckLineTerminator(next) && (this.match(80) || tokenIsIdentifier(this.state.type))) {
		              return this.tsParseAbstractDeclaration(node, decorators);
		            }
		            break;
		          case "module":
		            if (this.tsCheckLineTerminator(next)) {
		              if (this.match(133)) {
		                return this.tsParseAmbientExternalModuleDeclaration(node);
		              } else if (tokenIsIdentifier(this.state.type)) {
		                return this.tsParseModuleOrNamespaceDeclaration(node);
		              }
		            }
		            break;
		          case "namespace":
		            if (this.tsCheckLineTerminator(next) && tokenIsIdentifier(this.state.type)) {
		              return this.tsParseModuleOrNamespaceDeclaration(node);
		            }
		            break;
		          case "type":
		            if (this.tsCheckLineTerminator(next) && tokenIsIdentifier(this.state.type)) {
		              return this.tsParseTypeAliasDeclaration(node);
		            }
		            break;
		        }
		      };
		      _proto.tsCheckLineTerminator = function tsCheckLineTerminator(next) {
		        if (next) {
		          if (this.hasFollowingLineBreak()) return false;
		          this.next();
		          return true;
		        }
		        return !this.isLineTerminator();
		      };
		      _proto.tsTryParseGenericAsyncArrowFunction = function tsTryParseGenericAsyncArrowFunction(startLoc) {
		        var _this17 = this;
		        if (!this.match(47)) return;
		        var oldMaybeInArrowParameters = this.state.maybeInArrowParameters;
		        this.state.maybeInArrowParameters = true;
		        var res = this.tsTryParseAndCatch(function () {
		          var node = _this17.startNodeAt(startLoc);
		          node.typeParameters = _this17.tsParseTypeParameters(_this17.tsParseConstModifier);
		          _superClass.prototype.parseFunctionParams.call(_this17, node);
		          node.returnType = _this17.tsTryParseTypeOrTypePredicateAnnotation();
		          _this17.expect(19);
		          return node;
		        });
		        this.state.maybeInArrowParameters = oldMaybeInArrowParameters;
		        if (!res) return;
		        return _superClass.prototype.parseArrowExpression.call(this, res, null, true);
		      };
		      _proto.tsParseTypeArgumentsInExpression = function tsParseTypeArgumentsInExpression() {
		        if (this.reScan_lt() !== 47) return;
		        return this.tsParseTypeArguments();
		      };
		      _proto.tsParseTypeArguments = function tsParseTypeArguments() {
		        var _this18 = this;
		        var node = this.startNode();
		        node.params = this.tsInType(function () {
		          return _this18.tsInNoContext(function () {
		            _this18.expect(47);
		            return _this18.tsParseDelimitedList("TypeParametersOrArguments", _this18.tsParseType.bind(_this18));
		          });
		        });
		        if (node.params.length === 0) {
		          this.raise(TSErrors.EmptyTypeArguments, node);
		        } else if (!this.state.inType && this.curContext() === types.brace) {
		          this.reScan_lt_gt();
		        }
		        this.expect(48);
		        return this.finishNode(node, "TSTypeParameterInstantiation");
		      };
		      _proto.tsIsDeclarationStart = function tsIsDeclarationStart() {
		        return tokenIsTSDeclarationStart(this.state.type);
		      };
		      _proto.isExportDefaultSpecifier = function isExportDefaultSpecifier() {
		        if (this.tsIsDeclarationStart()) return false;
		        return _superClass.prototype.isExportDefaultSpecifier.call(this);
		      };
		      _proto.parseAssignableListItem = function parseAssignableListItem(flags, decorators) {
		        var startLoc = this.state.startLoc;
		        var modified = {};
		        this.tsParseModifiers({
		          allowedModifiers: ["public", "private", "protected", "override", "readonly"]
		        }, modified);
		        var accessibility = modified.accessibility;
		        var override = modified.override;
		        var readonly = modified.readonly;
		        if (!(flags & ParseBindingListFlags.IS_CONSTRUCTOR_PARAMS) && (accessibility || readonly || override)) {
		          this.raise(TSErrors.UnexpectedParameterModifier, startLoc);
		        }
		        var left = this.parseMaybeDefault();
		        this.parseAssignableListItemTypes(left, flags);
		        var elt = this.parseMaybeDefault(left.loc.start, left);
		        if (accessibility || readonly || override) {
		          var pp = this.startNodeAt(startLoc);
		          if (decorators.length) {
		            pp.decorators = decorators;
		          }
		          if (accessibility) pp.accessibility = accessibility;
		          if (readonly) pp.readonly = readonly;
		          if (override) pp.override = override;
		          if (elt.type !== "Identifier" && elt.type !== "AssignmentPattern") {
		            this.raise(TSErrors.UnsupportedParameterPropertyKind, pp);
		          }
		          pp.parameter = elt;
		          return this.finishNode(pp, "TSParameterProperty");
		        }
		        if (decorators.length) {
		          left.decorators = decorators;
		        }
		        return elt;
		      };
		      _proto.isSimpleParameter = function isSimpleParameter(node) {
		        return node.type === "TSParameterProperty" && _superClass.prototype.isSimpleParameter.call(this, node.parameter) || _superClass.prototype.isSimpleParameter.call(this, node);
		      };
		      _proto.tsDisallowOptionalPattern = function tsDisallowOptionalPattern(node) {
		        for (var _i4 = 0, _node$params2 = node.params; _i4 < _node$params2.length; _i4++) {
		          var param = _node$params2[_i4];
		          if (param.type !== "Identifier" && param.optional && !this.state.isAmbientContext) {
		            this.raise(TSErrors.PatternIsOptional, param);
		          }
		        }
		      };
		      _proto.setArrowFunctionParameters = function setArrowFunctionParameters(node, params, trailingCommaLoc) {
		        _superClass.prototype.setArrowFunctionParameters.call(this, node, params, trailingCommaLoc);
		        this.tsDisallowOptionalPattern(node);
		      };
		      _proto.parseFunctionBodyAndFinish = function parseFunctionBodyAndFinish(node, type, isMethod) {
		        if (isMethod === void 0) {
		          isMethod = false;
		        }
		        if (this.match(14)) {
		          node.returnType = this.tsParseTypeOrTypePredicateAnnotation(14);
		        }
		        var bodilessType = type === "FunctionDeclaration" ? "TSDeclareFunction" : type === "ClassMethod" || type === "ClassPrivateMethod" ? "TSDeclareMethod" : undefined;
		        if (bodilessType && !this.match(5) && this.isLineTerminator()) {
		          return this.finishNode(node, bodilessType);
		        }
		        if (bodilessType === "TSDeclareFunction" && this.state.isAmbientContext) {
		          this.raise(TSErrors.DeclareFunctionHasImplementation, node);
		          if (node.declare) {
		            return _superClass.prototype.parseFunctionBodyAndFinish.call(this, node, bodilessType, isMethod);
		          }
		        }
		        this.tsDisallowOptionalPattern(node);
		        return _superClass.prototype.parseFunctionBodyAndFinish.call(this, node, type, isMethod);
		      };
		      _proto.registerFunctionStatementId = function registerFunctionStatementId(node) {
		        if (!node.body && node.id) {
		          this.checkIdentifier(node.id, BindingFlag.TYPE_TS_AMBIENT);
		        } else {
		          _superClass.prototype.registerFunctionStatementId.call(this, node);
		        }
		      };
		      _proto.tsCheckForInvalidTypeCasts = function tsCheckForInvalidTypeCasts(items) {
		        var _this19 = this;
		        items.forEach(function (node) {
		          if ((node == null ? void 0 : node.type) === "TSTypeCastExpression") {
		            _this19.raise(TSErrors.UnexpectedTypeAnnotation, node.typeAnnotation);
		          }
		        });
		      };
		      _proto.toReferencedList = function toReferencedList(exprList, isInParens) {
		        this.tsCheckForInvalidTypeCasts(exprList);
		        return exprList;
		      };
		      _proto.parseArrayLike = function parseArrayLike(close, canBePattern, isTuple, refExpressionErrors) {
		        var node = _superClass.prototype.parseArrayLike.call(this, close, canBePattern, isTuple, refExpressionErrors);
		        if (node.type === "ArrayExpression") {
		          this.tsCheckForInvalidTypeCasts(node.elements);
		        }
		        return node;
		      };
		      _proto.parseSubscript = function parseSubscript(base, startLoc, noCalls, state) {
		        var _this20 = this;
		        if (!this.hasPrecedingLineBreak() && this.match(35)) {
		          this.state.canStartJSXElement = false;
		          this.next();
		          var nonNullExpression = this.startNodeAt(startLoc);
		          nonNullExpression.expression = base;
		          return this.finishNode(nonNullExpression, "TSNonNullExpression");
		        }
		        var isOptionalCall = false;
		        if (this.match(18) && this.lookaheadCharCode() === 60) {
		          if (noCalls) {
		            state.stop = true;
		            return base;
		          }
		          state.optionalChainMember = isOptionalCall = true;
		          this.next();
		        }
		        if (this.match(47) || this.match(51)) {
		          var missingParenErrorLoc;
		          var result = this.tsTryParseAndCatch(function () {
		            if (!noCalls && _this20.atPossibleAsyncArrow(base)) {
		              var asyncArrowFn = _this20.tsTryParseGenericAsyncArrowFunction(startLoc);
		              if (asyncArrowFn) {
		                return asyncArrowFn;
		              }
		            }
		            var typeArguments = _this20.tsParseTypeArgumentsInExpression();
		            if (!typeArguments) return;
		            if (isOptionalCall && !_this20.match(10)) {
		              missingParenErrorLoc = _this20.state.curPosition();
		              return;
		            }
		            if (tokenIsTemplate(_this20.state.type)) {
		              var _result = _superClass.prototype.parseTaggedTemplateExpression.call(_this20, base, startLoc, state);
		              _result.typeParameters = typeArguments;
		              return _result;
		            }
		            if (!noCalls && _this20.eat(10)) {
		              var _node7 = _this20.startNodeAt(startLoc);
		              _node7.callee = base;
		              _node7.arguments = _this20.parseCallExpressionArguments(11, false);
		              _this20.tsCheckForInvalidTypeCasts(_node7.arguments);
		              _node7.typeParameters = typeArguments;
		              if (state.optionalChainMember) {
		                _node7.optional = isOptionalCall;
		              }
		              return _this20.finishCallExpression(_node7, state.optionalChainMember);
		            }
		            var tokenType = _this20.state.type;
		            if (tokenType === 48 || tokenType === 52 || tokenType !== 10 && tokenCanStartExpression(tokenType) && !_this20.hasPrecedingLineBreak()) {
		              return;
		            }
		            var node = _this20.startNodeAt(startLoc);
		            node.expression = base;
		            node.typeParameters = typeArguments;
		            return _this20.finishNode(node, "TSInstantiationExpression");
		          });
		          if (missingParenErrorLoc) {
		            this.unexpected(missingParenErrorLoc, 10);
		          }
		          if (result) {
		            if (result.type === "TSInstantiationExpression" && (this.match(16) || this.match(18) && this.lookaheadCharCode() !== 40)) {
		              this.raise(TSErrors.InvalidPropertyAccessAfterInstantiationExpression, this.state.startLoc);
		            }
		            return result;
		          }
		        }
		        return _superClass.prototype.parseSubscript.call(this, base, startLoc, noCalls, state);
		      };
		      _proto.parseNewCallee = function parseNewCallee(node) {
		        var _callee$extra;
		        _superClass.prototype.parseNewCallee.call(this, node);
		        var callee = node.callee;
		        if (callee.type === "TSInstantiationExpression" && !((_callee$extra = callee.extra) != null && _callee$extra.parenthesized)) {
		          node.typeParameters = callee.typeParameters;
		          node.callee = callee.expression;
		        }
		      };
		      _proto.parseExprOp = function parseExprOp(left, leftStartLoc, minPrec) {
		        var _this21 = this;
		        var isSatisfies;
		        if (tokenOperatorPrecedence(58) > minPrec && !this.hasPrecedingLineBreak() && (this.isContextual(93) || (isSatisfies = this.isContextual(120)))) {
		          var _node8 = this.startNodeAt(leftStartLoc);
		          _node8.expression = left;
		          _node8.typeAnnotation = this.tsInType(function () {
		            _this21.next();
		            if (_this21.match(75)) {
		              if (isSatisfies) {
		                _this21.raise(Errors.UnexpectedKeyword, _this21.state.startLoc, {
		                  keyword: "const"
		                });
		              }
		              return _this21.tsParseTypeReference();
		            }
		            return _this21.tsParseType();
		          });
		          this.finishNode(_node8, isSatisfies ? "TSSatisfiesExpression" : "TSAsExpression");
		          this.reScan_lt_gt();
		          return this.parseExprOp(_node8, leftStartLoc, minPrec);
		        }
		        return _superClass.prototype.parseExprOp.call(this, left, leftStartLoc, minPrec);
		      };
		      _proto.checkReservedWord = function checkReservedWord(word, startLoc, checkKeywords, isBinding) {
		        if (!this.state.isAmbientContext) {
		          _superClass.prototype.checkReservedWord.call(this, word, startLoc, checkKeywords, isBinding);
		        }
		      };
		      _proto.checkImportReflection = function checkImportReflection(node) {
		        _superClass.prototype.checkImportReflection.call(this, node);
		        if (node.module && node.importKind !== "value") {
		          this.raise(TSErrors.ImportReflectionHasImportType, node.specifiers[0].loc.start);
		        }
		      };
		      _proto.checkDuplicateExports = function checkDuplicateExports() {};
		      _proto.isPotentialImportPhase = function isPotentialImportPhase(isExport) {
		        if (_superClass.prototype.isPotentialImportPhase.call(this, isExport)) return true;
		        if (this.isContextual(130)) {
		          var ch = this.lookaheadCharCode();
		          return isExport ? ch === 123 || ch === 42 : ch !== 61;
		        }
		        return !isExport && this.isContextual(87);
		      };
		      _proto.applyImportPhase = function applyImportPhase(node, isExport, phase, loc) {
		        _superClass.prototype.applyImportPhase.call(this, node, isExport, phase, loc);
		        if (isExport) {
		          node.exportKind = phase === "type" ? "type" : "value";
		        } else {
		          node.importKind = phase === "type" || phase === "typeof" ? phase : "value";
		        }
		      };
		      _proto.parseImport = function parseImport(node) {
		        if (this.match(133)) {
		          node.importKind = "value";
		          return _superClass.prototype.parseImport.call(this, node);
		        }
		        var importNode;
		        if (tokenIsIdentifier(this.state.type) && this.lookaheadCharCode() === 61) {
		          node.importKind = "value";
		          return this.tsParseImportEqualsDeclaration(node);
		        } else if (this.isContextual(130)) {
		          var maybeDefaultIdentifier = this.parseMaybeImportPhase(node, false);
		          if (this.lookaheadCharCode() === 61) {
		            return this.tsParseImportEqualsDeclaration(node, maybeDefaultIdentifier);
		          } else {
		            importNode = _superClass.prototype.parseImportSpecifiersAndAfter.call(this, node, maybeDefaultIdentifier);
		          }
		        } else {
		          importNode = _superClass.prototype.parseImport.call(this, node);
		        }
		        if (importNode.importKind === "type" && importNode.specifiers.length > 1 && importNode.specifiers[0].type === "ImportDefaultSpecifier") {
		          this.raise(TSErrors.TypeImportCannotSpecifyDefaultAndNamed, importNode);
		        }
		        return importNode;
		      };
		      _proto.parseExport = function parseExport(node, decorators) {
		        if (this.match(83)) {
		          this.next();
		          var nodeImportEquals = node;
		          var maybeDefaultIdentifier = null;
		          if (this.isContextual(130) && this.isPotentialImportPhase(false)) {
		            maybeDefaultIdentifier = this.parseMaybeImportPhase(nodeImportEquals, false);
		          } else {
		            nodeImportEquals.importKind = "value";
		          }
		          return this.tsParseImportEqualsDeclaration(nodeImportEquals, maybeDefaultIdentifier, true);
		        } else if (this.eat(29)) {
		          var assign = node;
		          assign.expression = _superClass.prototype.parseExpression.call(this);
		          this.semicolon();
		          this.sawUnambiguousESM = true;
		          return this.finishNode(assign, "TSExportAssignment");
		        } else if (this.eatContextual(93)) {
		          var decl = node;
		          this.expectContextual(128);
		          decl.id = this.parseIdentifier();
		          this.semicolon();
		          return this.finishNode(decl, "TSNamespaceExportDeclaration");
		        } else {
		          return _superClass.prototype.parseExport.call(this, node, decorators);
		        }
		      };
		      _proto.isAbstractClass = function isAbstractClass() {
		        return this.isContextual(124) && this.lookahead().type === 80;
		      };
		      _proto.parseExportDefaultExpression = function parseExportDefaultExpression() {
		        if (this.isAbstractClass()) {
		          var cls = this.startNode();
		          this.next();
		          cls["abstract"] = true;
		          return this.parseClass(cls, true, true);
		        }
		        if (this.match(129)) {
		          var result = this.tsParseInterfaceDeclaration(this.startNode());
		          if (result) return result;
		        }
		        return _superClass.prototype.parseExportDefaultExpression.call(this);
		      };
		      _proto.parseVarStatement = function parseVarStatement(node, kind, allowMissingInitializer) {
		        if (allowMissingInitializer === void 0) {
		          allowMissingInitializer = false;
		        }
		        var isAmbientContext = this.state.isAmbientContext;
		        var declaration = _superClass.prototype.parseVarStatement.call(this, node, kind, allowMissingInitializer || isAmbientContext);
		        if (!isAmbientContext) return declaration;
		        for (var _i6 = 0, _declaration$declarat2 = declaration.declarations; _i6 < _declaration$declarat2.length; _i6++) {
		          var _declaration$declarat3 = _declaration$declarat2[_i6],
		            id = _declaration$declarat3.id,
		            init = _declaration$declarat3.init;
		          if (!init) continue;
		          if (kind !== "const" || !!id.typeAnnotation) {
		            this.raise(TSErrors.InitializerNotAllowedInAmbientContext, init);
		          } else if (!isValidAmbientConstInitializer(init, this.hasPlugin("estree"))) {
		            this.raise(TSErrors.ConstInitiailizerMustBeStringOrNumericLiteralOrLiteralEnumReference, init);
		          }
		        }
		        return declaration;
		      };
		      _proto.parseStatementContent = function parseStatementContent(flags, decorators) {
		        if (this.match(75) && this.isLookaheadContextual("enum")) {
		          var _node9 = this.startNode();
		          this.expect(75);
		          return this.tsParseEnumDeclaration(_node9, {
		            "const": true
		          });
		        }
		        if (this.isContextual(126)) {
		          return this.tsParseEnumDeclaration(this.startNode());
		        }
		        if (this.isContextual(129)) {
		          var result = this.tsParseInterfaceDeclaration(this.startNode());
		          if (result) return result;
		        }
		        return _superClass.prototype.parseStatementContent.call(this, flags, decorators);
		      };
		      _proto.parseAccessModifier = function parseAccessModifier() {
		        return this.tsParseModifier(["public", "protected", "private"]);
		      };
		      _proto.tsHasSomeModifiers = function tsHasSomeModifiers(member, modifiers) {
		        return modifiers.some(function (modifier) {
		          if (tsIsAccessModifier(modifier)) {
		            return member.accessibility === modifier;
		          }
		          return !!member[modifier];
		        });
		      };
		      _proto.tsIsStartOfStaticBlocks = function tsIsStartOfStaticBlocks() {
		        return this.isContextual(106) && this.lookaheadCharCode() === 123;
		      };
		      _proto.parseClassMember = function parseClassMember(classBody, member, state) {
		        var _this22 = this;
		        var modifiers = ["declare", "private", "public", "protected", "override", "abstract", "readonly", "static"];
		        this.tsParseModifiers({
		          allowedModifiers: modifiers,
		          disallowedModifiers: ["in", "out"],
		          stopOnStartOfClassStaticBlock: true,
		          errorTemplate: TSErrors.InvalidModifierOnTypeParameterPositions
		        }, member);
		        var callParseClassMemberWithIsStatic = function callParseClassMemberWithIsStatic() {
		          if (_this22.tsIsStartOfStaticBlocks()) {
		            _this22.next();
		            _this22.next();
		            if (_this22.tsHasSomeModifiers(member, modifiers)) {
		              _this22.raise(TSErrors.StaticBlockCannotHaveModifier, _this22.state.curPosition());
		            }
		            _superClass.prototype.parseClassStaticBlock.call(_this22, classBody, member);
		          } else {
		            _this22.parseClassMemberWithIsStatic(classBody, member, state, !!member["static"]);
		          }
		        };
		        if (member.declare) {
		          this.tsInAmbientContext(callParseClassMemberWithIsStatic);
		        } else {
		          callParseClassMemberWithIsStatic();
		        }
		      };
		      _proto.parseClassMemberWithIsStatic = function parseClassMemberWithIsStatic(classBody, member, state, isStatic) {
		        var idx = this.tsTryParseIndexSignature(member);
		        if (idx) {
		          classBody.body.push(idx);
		          if (member["abstract"]) {
		            this.raise(TSErrors.IndexSignatureHasAbstract, member);
		          }
		          if (member.accessibility) {
		            this.raise(TSErrors.IndexSignatureHasAccessibility, member, {
		              modifier: member.accessibility
		            });
		          }
		          if (member.declare) {
		            this.raise(TSErrors.IndexSignatureHasDeclare, member);
		          }
		          if (member.override) {
		            this.raise(TSErrors.IndexSignatureHasOverride, member);
		          }
		          return;
		        }
		        if (!this.state.inAbstractClass && member["abstract"]) {
		          this.raise(TSErrors.NonAbstractClassHasAbstractMethod, member);
		        }
		        if (member.override) {
		          if (!state.hadSuperClass) {
		            this.raise(TSErrors.OverrideNotInSubClass, member);
		          }
		        }
		        _superClass.prototype.parseClassMemberWithIsStatic.call(this, classBody, member, state, isStatic);
		      };
		      _proto.parsePostMemberNameModifiers = function parsePostMemberNameModifiers(methodOrProp) {
		        var optional = this.eat(17);
		        if (optional) methodOrProp.optional = true;
		        if (methodOrProp.readonly && this.match(10)) {
		          this.raise(TSErrors.ClassMethodHasReadonly, methodOrProp);
		        }
		        if (methodOrProp.declare && this.match(10)) {
		          this.raise(TSErrors.ClassMethodHasDeclare, methodOrProp);
		        }
		      };
		      _proto.parseExpressionStatement = function parseExpressionStatement(node, expr, decorators) {
		        var decl = expr.type === "Identifier" ? this.tsParseExpressionStatement(node, expr, decorators) : undefined;
		        return decl || _superClass.prototype.parseExpressionStatement.call(this, node, expr, decorators);
		      };
		      _proto.shouldParseExportDeclaration = function shouldParseExportDeclaration() {
		        if (this.tsIsDeclarationStart()) return true;
		        return _superClass.prototype.shouldParseExportDeclaration.call(this);
		      };
		      _proto.parseConditional = function parseConditional(expr, startLoc, refExpressionErrors) {
		        var _this23 = this;
		        if (!this.state.maybeInArrowParameters || !this.match(17)) {
		          return _superClass.prototype.parseConditional.call(this, expr, startLoc, refExpressionErrors);
		        }
		        var result = this.tryParse(function () {
		          return _superClass.prototype.parseConditional.call(_this23, expr, startLoc);
		        });
		        if (!result.node) {
		          if (result.error) {
		            _superClass.prototype.setOptionalParametersError.call(this, refExpressionErrors, result.error);
		          }
		          return expr;
		        }
		        if (result.error) this.state = result.failState;
		        return result.node;
		      };
		      _proto.parseParenItem = function parseParenItem(node, startLoc) {
		        var newNode = _superClass.prototype.parseParenItem.call(this, node, startLoc);
		        if (this.eat(17)) {
		          newNode.optional = true;
		          this.resetEndLocation(node);
		        }
		        if (this.match(14)) {
		          var typeCastNode = this.startNodeAt(startLoc);
		          typeCastNode.expression = node;
		          typeCastNode.typeAnnotation = this.tsParseTypeAnnotation();
		          return this.finishNode(typeCastNode, "TSTypeCastExpression");
		        }
		        return node;
		      };
		      _proto.parseExportDeclaration = function parseExportDeclaration(node) {
		        var _this24 = this;
		        if (!this.state.isAmbientContext && this.isContextual(125)) {
		          return this.tsInAmbientContext(function () {
		            return _this24.parseExportDeclaration(node);
		          });
		        }
		        var startLoc = this.state.startLoc;
		        var isDeclare = this.eatContextual(125);
		        if (isDeclare && (this.isContextual(125) || !this.shouldParseExportDeclaration())) {
		          throw this.raise(TSErrors.ExpectedAmbientAfterExportDeclare, this.state.startLoc);
		        }
		        var isIdentifier = tokenIsIdentifier(this.state.type);
		        var declaration = isIdentifier && this.tsTryParseExportDeclaration() || _superClass.prototype.parseExportDeclaration.call(this, node);
		        if (!declaration) return null;
		        if (declaration.type === "TSInterfaceDeclaration" || declaration.type === "TSTypeAliasDeclaration" || isDeclare) {
		          node.exportKind = "type";
		        }
		        if (isDeclare) {
		          this.resetStartLocation(declaration, startLoc);
		          declaration.declare = true;
		        }
		        return declaration;
		      };
		      _proto.parseClassId = function parseClassId(node, isStatement, optionalId, bindingType) {
		        if ((!isStatement || optionalId) && this.isContextual(113)) {
		          return;
		        }
		        _superClass.prototype.parseClassId.call(this, node, isStatement, optionalId, node.declare ? BindingFlag.TYPE_TS_AMBIENT : BindingFlag.TYPE_CLASS);
		        var typeParameters = this.tsTryParseTypeParameters(this.tsParseInOutConstModifiers);
		        if (typeParameters) node.typeParameters = typeParameters;
		      };
		      _proto.parseClassPropertyAnnotation = function parseClassPropertyAnnotation(node) {
		        if (!node.optional) {
		          if (this.eat(35)) {
		            node.definite = true;
		          } else if (this.eat(17)) {
		            node.optional = true;
		          }
		        }
		        var type = this.tsTryParseTypeAnnotation();
		        if (type) node.typeAnnotation = type;
		      };
		      _proto.parseClassProperty = function parseClassProperty(node) {
		        this.parseClassPropertyAnnotation(node);
		        if (this.state.isAmbientContext && !(node.readonly && !node.typeAnnotation) && this.match(29)) {
		          this.raise(TSErrors.DeclareClassFieldHasInitializer, this.state.startLoc);
		        }
		        if (node["abstract"] && this.match(29)) {
		          var key = node.key;
		          this.raise(TSErrors.AbstractPropertyHasInitializer, this.state.startLoc, {
		            propertyName: key.type === "Identifier" && !node.computed ? key.name : "[" + this.input.slice(key.start, key.end) + "]"
		          });
		        }
		        return _superClass.prototype.parseClassProperty.call(this, node);
		      };
		      _proto.parseClassPrivateProperty = function parseClassPrivateProperty(node) {
		        if (node["abstract"]) {
		          this.raise(TSErrors.PrivateElementHasAbstract, node);
		        }
		        if (node.accessibility) {
		          this.raise(TSErrors.PrivateElementHasAccessibility, node, {
		            modifier: node.accessibility
		          });
		        }
		        this.parseClassPropertyAnnotation(node);
		        return _superClass.prototype.parseClassPrivateProperty.call(this, node);
		      };
		      _proto.parseClassAccessorProperty = function parseClassAccessorProperty(node) {
		        this.parseClassPropertyAnnotation(node);
		        if (node.optional) {
		          this.raise(TSErrors.AccessorCannotBeOptional, node);
		        }
		        return _superClass.prototype.parseClassAccessorProperty.call(this, node);
		      };
		      _proto.pushClassMethod = function pushClassMethod(classBody, method, isGenerator, isAsync, isConstructor, allowsDirectSuper) {
		        var typeParameters = this.tsTryParseTypeParameters(this.tsParseConstModifier);
		        if (typeParameters && isConstructor) {
		          this.raise(TSErrors.ConstructorHasTypeParameters, typeParameters);
		        }
		        var _method$declare = method.declare,
		          declare = _method$declare === void 0 ? false : _method$declare,
		          kind = method.kind;
		        if (declare && (kind === "get" || kind === "set")) {
		          this.raise(TSErrors.DeclareAccessor, method, {
		            kind: kind
		          });
		        }
		        if (typeParameters) method.typeParameters = typeParameters;
		        _superClass.prototype.pushClassMethod.call(this, classBody, method, isGenerator, isAsync, isConstructor, allowsDirectSuper);
		      };
		      _proto.pushClassPrivateMethod = function pushClassPrivateMethod(classBody, method, isGenerator, isAsync) {
		        var typeParameters = this.tsTryParseTypeParameters(this.tsParseConstModifier);
		        if (typeParameters) method.typeParameters = typeParameters;
		        _superClass.prototype.pushClassPrivateMethod.call(this, classBody, method, isGenerator, isAsync);
		      };
		      _proto.declareClassPrivateMethodInScope = function declareClassPrivateMethodInScope(node, kind) {
		        if (node.type === "TSDeclareMethod") return;
		        if (node.type === "MethodDefinition" && !hasOwnProperty.call(node.value, "body")) {
		          return;
		        }
		        _superClass.prototype.declareClassPrivateMethodInScope.call(this, node, kind);
		      };
		      _proto.parseClassSuper = function parseClassSuper(node) {
		        _superClass.prototype.parseClassSuper.call(this, node);
		        if (node.superClass && (this.match(47) || this.match(51))) {
		          node.superTypeParameters = this.tsParseTypeArgumentsInExpression();
		        }
		        if (this.eatContextual(113)) {
		          node["implements"] = this.tsParseHeritageClause("implements");
		        }
		      };
		      _proto.parseObjPropValue = function parseObjPropValue(prop, startLoc, isGenerator, isAsync, isPattern, isAccessor, refExpressionErrors) {
		        var typeParameters = this.tsTryParseTypeParameters(this.tsParseConstModifier);
		        if (typeParameters) prop.typeParameters = typeParameters;
		        return _superClass.prototype.parseObjPropValue.call(this, prop, startLoc, isGenerator, isAsync, isPattern, isAccessor, refExpressionErrors);
		      };
		      _proto.parseFunctionParams = function parseFunctionParams(node, isConstructor) {
		        var typeParameters = this.tsTryParseTypeParameters(this.tsParseConstModifier);
		        if (typeParameters) node.typeParameters = typeParameters;
		        _superClass.prototype.parseFunctionParams.call(this, node, isConstructor);
		      };
		      _proto.parseVarId = function parseVarId(decl, kind) {
		        _superClass.prototype.parseVarId.call(this, decl, kind);
		        if (decl.id.type === "Identifier" && !this.hasPrecedingLineBreak() && this.eat(35)) {
		          decl.definite = true;
		        }
		        var type = this.tsTryParseTypeAnnotation();
		        if (type) {
		          decl.id.typeAnnotation = type;
		          this.resetEndLocation(decl.id);
		        }
		      };
		      _proto.parseAsyncArrowFromCallExpression = function parseAsyncArrowFromCallExpression(node, call) {
		        if (this.match(14)) {
		          node.returnType = this.tsParseTypeAnnotation();
		        }
		        return _superClass.prototype.parseAsyncArrowFromCallExpression.call(this, node, call);
		      };
		      _proto.parseMaybeAssign = function parseMaybeAssign(refExpressionErrors, afterLeftParse) {
		        var _this25 = this,
		          _jsx,
		          _jsx2,
		          _typeCast,
		          _jsx3,
		          _typeCast2;
		        var state;
		        var jsx;
		        var typeCast;
		        if (this.hasPlugin("jsx") && (this.match(142) || this.match(47))) {
		          state = this.state.clone();
		          jsx = this.tryParse(function () {
		            return _superClass.prototype.parseMaybeAssign.call(_this25, refExpressionErrors, afterLeftParse);
		          }, state);
		          if (!jsx.error) return jsx.node;
		          var context = this.state.context;
		          var currentContext = context[context.length - 1];
		          if (currentContext === types.j_oTag || currentContext === types.j_expr) {
		            context.pop();
		          }
		        }
		        if (!((_jsx = jsx) != null && _jsx.error) && !this.match(47)) {
		          return _superClass.prototype.parseMaybeAssign.call(this, refExpressionErrors, afterLeftParse);
		        }
		        if (!state || state === this.state) state = this.state.clone();
		        var typeParameters;
		        var arrow = this.tryParse(function (abort) {
		          var _expr$extra, _typeParameters;
		          typeParameters = _this25.tsParseTypeParameters(_this25.tsParseConstModifier);
		          var expr = _superClass.prototype.parseMaybeAssign.call(_this25, refExpressionErrors, afterLeftParse);
		          if (expr.type !== "ArrowFunctionExpression" || (_expr$extra = expr.extra) != null && _expr$extra.parenthesized) {
		            abort();
		          }
		          if (((_typeParameters = typeParameters) == null ? void 0 : _typeParameters.params.length) !== 0) {
		            _this25.resetStartLocationFromNode(expr, typeParameters);
		          }
		          expr.typeParameters = typeParameters;
		          return expr;
		        }, state);
		        if (!arrow.error && !arrow.aborted) {
		          if (typeParameters) this.reportReservedArrowTypeParam(typeParameters);
		          return arrow.node;
		        }
		        if (!jsx) {
		          assert$1(!this.hasPlugin("jsx"));
		          typeCast = this.tryParse(function () {
		            return _superClass.prototype.parseMaybeAssign.call(_this25, refExpressionErrors, afterLeftParse);
		          }, state);
		          if (!typeCast.error) return typeCast.node;
		        }
		        if ((_jsx2 = jsx) != null && _jsx2.node) {
		          this.state = jsx.failState;
		          return jsx.node;
		        }
		        if (arrow.node) {
		          this.state = arrow.failState;
		          if (typeParameters) this.reportReservedArrowTypeParam(typeParameters);
		          return arrow.node;
		        }
		        if ((_typeCast = typeCast) != null && _typeCast.node) {
		          this.state = typeCast.failState;
		          return typeCast.node;
		        }
		        throw ((_jsx3 = jsx) == null ? void 0 : _jsx3.error) || arrow.error || ((_typeCast2 = typeCast) == null ? void 0 : _typeCast2.error);
		      };
		      _proto.reportReservedArrowTypeParam = function reportReservedArrowTypeParam(node) {
		        var _node$extra;
		        if (node.params.length === 1 && !node.params[0].constraint && !((_node$extra = node.extra) != null && _node$extra.trailingComma) && this.getPluginOption("typescript", "disallowAmbiguousJSXLike")) {
		          this.raise(TSErrors.ReservedArrowTypeParam, node);
		        }
		      };
		      _proto.parseMaybeUnary = function parseMaybeUnary(refExpressionErrors, sawUnary) {
		        if (!this.hasPlugin("jsx") && this.match(47)) {
		          return this.tsParseTypeAssertion();
		        }
		        return _superClass.prototype.parseMaybeUnary.call(this, refExpressionErrors, sawUnary);
		      };
		      _proto.parseArrow = function parseArrow(node) {
		        var _this26 = this;
		        if (this.match(14)) {
		          var result = this.tryParse(function (abort) {
		            var returnType = _this26.tsParseTypeOrTypePredicateAnnotation(14);
		            if (_this26.canInsertSemicolon() || !_this26.match(19)) abort();
		            return returnType;
		          });
		          if (result.aborted) return;
		          if (!result.thrown) {
		            if (result.error) this.state = result.failState;
		            node.returnType = result.node;
		          }
		        }
		        return _superClass.prototype.parseArrow.call(this, node);
		      };
		      _proto.parseAssignableListItemTypes = function parseAssignableListItemTypes(param, flags) {
		        if (!(flags & ParseBindingListFlags.IS_FUNCTION_PARAMS)) return param;
		        if (this.eat(17)) {
		          param.optional = true;
		        }
		        var type = this.tsTryParseTypeAnnotation();
		        if (type) param.typeAnnotation = type;
		        this.resetEndLocation(param);
		        return param;
		      };
		      _proto.isAssignable = function isAssignable(node, isBinding) {
		        switch (node.type) {
		          case "TSTypeCastExpression":
		            return this.isAssignable(node.expression, isBinding);
		          case "TSParameterProperty":
		            return true;
		          default:
		            return _superClass.prototype.isAssignable.call(this, node, isBinding);
		        }
		      };
		      _proto.toAssignable = function toAssignable(node, isLHS) {
		        if (isLHS === void 0) {
		          isLHS = false;
		        }
		        switch (node.type) {
		          case "ParenthesizedExpression":
		            this.toAssignableParenthesizedExpression(node, isLHS);
		            break;
		          case "TSAsExpression":
		          case "TSSatisfiesExpression":
		          case "TSNonNullExpression":
		          case "TSTypeAssertion":
		            if (isLHS) {
		              this.expressionScope.recordArrowParameterBindingError(TSErrors.UnexpectedTypeCastInParameter, node);
		            } else {
		              this.raise(TSErrors.UnexpectedTypeCastInParameter, node);
		            }
		            this.toAssignable(node.expression, isLHS);
		            break;
		          case "AssignmentExpression":
		            if (!isLHS && node.left.type === "TSTypeCastExpression") {
		              node.left = this.typeCastToParameter(node.left);
		            }
		          default:
		            _superClass.prototype.toAssignable.call(this, node, isLHS);
		        }
		      };
		      _proto.toAssignableParenthesizedExpression = function toAssignableParenthesizedExpression(node, isLHS) {
		        switch (node.expression.type) {
		          case "TSAsExpression":
		          case "TSSatisfiesExpression":
		          case "TSNonNullExpression":
		          case "TSTypeAssertion":
		          case "ParenthesizedExpression":
		            this.toAssignable(node.expression, isLHS);
		            break;
		          default:
		            _superClass.prototype.toAssignable.call(this, node, isLHS);
		        }
		      };
		      _proto.checkToRestConversion = function checkToRestConversion(node, allowPattern) {
		        switch (node.type) {
		          case "TSAsExpression":
		          case "TSSatisfiesExpression":
		          case "TSTypeAssertion":
		          case "TSNonNullExpression":
		            this.checkToRestConversion(node.expression, false);
		            break;
		          default:
		            _superClass.prototype.checkToRestConversion.call(this, node, allowPattern);
		        }
		      };
		      _proto.isValidLVal = function isValidLVal(type, isUnparenthesizedInAssign, binding) {
		        return getOwn({
		          TSTypeCastExpression: true,
		          TSParameterProperty: "parameter",
		          TSNonNullExpression: "expression",
		          TSAsExpression: (binding !== BindingFlag.TYPE_NONE || !isUnparenthesizedInAssign) && ["expression", true],
		          TSSatisfiesExpression: (binding !== BindingFlag.TYPE_NONE || !isUnparenthesizedInAssign) && ["expression", true],
		          TSTypeAssertion: (binding !== BindingFlag.TYPE_NONE || !isUnparenthesizedInAssign) && ["expression", true]
		        }, type) || _superClass.prototype.isValidLVal.call(this, type, isUnparenthesizedInAssign, binding);
		      };
		      _proto.parseBindingAtom = function parseBindingAtom() {
		        if (this.state.type === 78) {
		          return this.parseIdentifier(true);
		        }
		        return _superClass.prototype.parseBindingAtom.call(this);
		      };
		      _proto.parseMaybeDecoratorArguments = function parseMaybeDecoratorArguments(expr) {
		        if (this.match(47) || this.match(51)) {
		          var typeArguments = this.tsParseTypeArgumentsInExpression();
		          if (this.match(10)) {
		            var call = _superClass.prototype.parseMaybeDecoratorArguments.call(this, expr);
		            call.typeParameters = typeArguments;
		            return call;
		          }
		          this.unexpected(null, 10);
		        }
		        return _superClass.prototype.parseMaybeDecoratorArguments.call(this, expr);
		      };
		      _proto.checkCommaAfterRest = function checkCommaAfterRest(close) {
		        if (this.state.isAmbientContext && this.match(12) && this.lookaheadCharCode() === close) {
		          this.next();
		          return false;
		        }
		        return _superClass.prototype.checkCommaAfterRest.call(this, close);
		      };
		      _proto.isClassMethod = function isClassMethod() {
		        return this.match(47) || _superClass.prototype.isClassMethod.call(this);
		      };
		      _proto.isClassProperty = function isClassProperty() {
		        return this.match(35) || this.match(14) || _superClass.prototype.isClassProperty.call(this);
		      };
		      _proto.parseMaybeDefault = function parseMaybeDefault(startLoc, left) {
		        var node = _superClass.prototype.parseMaybeDefault.call(this, startLoc, left);
		        if (node.type === "AssignmentPattern" && node.typeAnnotation && node.right.start < node.typeAnnotation.start) {
		          this.raise(TSErrors.TypeAnnotationAfterAssign, node.typeAnnotation);
		        }
		        return node;
		      };
		      _proto.getTokenFromCode = function getTokenFromCode(code) {
		        if (this.state.inType) {
		          if (code === 62) {
		            this.finishOp(48, 1);
		            return;
		          }
		          if (code === 60) {
		            this.finishOp(47, 1);
		            return;
		          }
		        }
		        _superClass.prototype.getTokenFromCode.call(this, code);
		      };
		      _proto.reScan_lt_gt = function reScan_lt_gt() {
		        var type = this.state.type;
		        if (type === 47) {
		          this.state.pos -= 1;
		          this.readToken_lt();
		        } else if (type === 48) {
		          this.state.pos -= 1;
		          this.readToken_gt();
		        }
		      };
		      _proto.reScan_lt = function reScan_lt() {
		        var type = this.state.type;
		        if (type === 51) {
		          this.state.pos -= 2;
		          this.finishOp(47, 1);
		          return 47;
		        }
		        return type;
		      };
		      _proto.toAssignableList = function toAssignableList(exprList, trailingCommaLoc, isLHS) {
		        for (var i = 0; i < exprList.length; i++) {
		          var expr = exprList[i];
		          if ((expr == null ? void 0 : expr.type) === "TSTypeCastExpression") {
		            exprList[i] = this.typeCastToParameter(expr);
		          }
		        }
		        _superClass.prototype.toAssignableList.call(this, exprList, trailingCommaLoc, isLHS);
		      };
		      _proto.typeCastToParameter = function typeCastToParameter(node) {
		        node.expression.typeAnnotation = node.typeAnnotation;
		        this.resetEndLocation(node.expression, node.typeAnnotation.loc.end);
		        return node.expression;
		      };
		      _proto.shouldParseArrow = function shouldParseArrow(params) {
		        var _this27 = this;
		        if (this.match(14)) {
		          return params.every(function (expr) {
		            return _this27.isAssignable(expr, true);
		          });
		        }
		        return _superClass.prototype.shouldParseArrow.call(this, params);
		      };
		      _proto.shouldParseAsyncArrow = function shouldParseAsyncArrow() {
		        return this.match(14) || _superClass.prototype.shouldParseAsyncArrow.call(this);
		      };
		      _proto.canHaveLeadingDecorator = function canHaveLeadingDecorator() {
		        return _superClass.prototype.canHaveLeadingDecorator.call(this) || this.isAbstractClass();
		      };
		      _proto.jsxParseOpeningElementAfterName = function jsxParseOpeningElementAfterName(node) {
		        var _this28 = this;
		        if (this.match(47) || this.match(51)) {
		          var typeArguments = this.tsTryParseAndCatch(function () {
		            return _this28.tsParseTypeArgumentsInExpression();
		          });
		          if (typeArguments) node.typeParameters = typeArguments;
		        }
		        return _superClass.prototype.jsxParseOpeningElementAfterName.call(this, node);
		      };
		      _proto.getGetterSetterExpectedParamCount = function getGetterSetterExpectedParamCount(method) {
		        var baseCount = _superClass.prototype.getGetterSetterExpectedParamCount.call(this, method);
		        var params = this.getObjectOrClassMethodParams(method);
		        var firstParam = params[0];
		        var hasContextParam = firstParam && this.isThisParam(firstParam);
		        return hasContextParam ? baseCount + 1 : baseCount;
		      };
		      _proto.parseCatchClauseParam = function parseCatchClauseParam() {
		        var param = _superClass.prototype.parseCatchClauseParam.call(this);
		        var type = this.tsTryParseTypeAnnotation();
		        if (type) {
		          param.typeAnnotation = type;
		          this.resetEndLocation(param);
		        }
		        return param;
		      };
		      _proto.tsInAmbientContext = function tsInAmbientContext(cb) {
		        var oldIsAmbientContext = this.state.isAmbientContext;
		        this.state.isAmbientContext = true;
		        try {
		          return cb();
		        } finally {
		          this.state.isAmbientContext = oldIsAmbientContext;
		        }
		      };
		      _proto.parseClass = function parseClass(node, isStatement, optionalId) {
		        var oldInAbstractClass = this.state.inAbstractClass;
		        this.state.inAbstractClass = !!node["abstract"];
		        try {
		          return _superClass.prototype.parseClass.call(this, node, isStatement, optionalId);
		        } finally {
		          this.state.inAbstractClass = oldInAbstractClass;
		        }
		      };
		      _proto.tsParseAbstractDeclaration = function tsParseAbstractDeclaration(node, decorators) {
		        if (this.match(80)) {
		          node["abstract"] = true;
		          return this.maybeTakeDecorators(decorators, this.parseClass(node, true, false));
		        } else if (this.isContextual(129)) {
		          if (!this.hasFollowingLineBreak()) {
		            node["abstract"] = true;
		            this.raise(TSErrors.NonClassMethodPropertyHasAbstractModifer, node);
		            return this.tsParseInterfaceDeclaration(node);
		          }
		        } else {
		          this.unexpected(null, 80);
		        }
		      };
		      _proto.parseMethod = function parseMethod(node, isGenerator, isAsync, isConstructor, allowDirectSuper, type, inClassScope) {
		        var method = _superClass.prototype.parseMethod.call(this, node, isGenerator, isAsync, isConstructor, allowDirectSuper, type, inClassScope);
		        if (method["abstract"]) {
		          var hasBody = this.hasPlugin("estree") ? !!method.value.body : !!method.body;
		          if (hasBody) {
		            var key = method.key;
		            this.raise(TSErrors.AbstractMethodHasImplementation, method, {
		              methodName: key.type === "Identifier" && !method.computed ? key.name : "[" + this.input.slice(key.start, key.end) + "]"
		            });
		          }
		        }
		        return method;
		      };
		      _proto.tsParseTypeParameterName = function tsParseTypeParameterName() {
		        var typeName = this.parseIdentifier();
		        return typeName.name;
		      };
		      _proto.shouldParseAsAmbientContext = function shouldParseAsAmbientContext() {
		        return !!this.getPluginOption("typescript", "dts");
		      };
		      _proto.parse = function parse() {
		        if (this.shouldParseAsAmbientContext()) {
		          this.state.isAmbientContext = true;
		        }
		        return _superClass.prototype.parse.call(this);
		      };
		      _proto.getExpression = function getExpression() {
		        if (this.shouldParseAsAmbientContext()) {
		          this.state.isAmbientContext = true;
		        }
		        return _superClass.prototype.getExpression.call(this);
		      };
		      _proto.parseExportSpecifier = function parseExportSpecifier(node, isString, isInTypeExport, isMaybeTypeOnly) {
		        if (!isString && isMaybeTypeOnly) {
		          this.parseTypeOnlyImportExportSpecifier(node, false, isInTypeExport);
		          return this.finishNode(node, "ExportSpecifier");
		        }
		        node.exportKind = "value";
		        return _superClass.prototype.parseExportSpecifier.call(this, node, isString, isInTypeExport, isMaybeTypeOnly);
		      };
		      _proto.parseImportSpecifier = function parseImportSpecifier(specifier, importedIsString, isInTypeOnlyImport, isMaybeTypeOnly, bindingType) {
		        if (!importedIsString && isMaybeTypeOnly) {
		          this.parseTypeOnlyImportExportSpecifier(specifier, true, isInTypeOnlyImport);
		          return this.finishNode(specifier, "ImportSpecifier");
		        }
		        specifier.importKind = "value";
		        return _superClass.prototype.parseImportSpecifier.call(this, specifier, importedIsString, isInTypeOnlyImport, isMaybeTypeOnly, isInTypeOnlyImport ? BindingFlag.TYPE_TS_TYPE_IMPORT : BindingFlag.TYPE_TS_VALUE_IMPORT);
		      };
		      _proto.parseTypeOnlyImportExportSpecifier = function parseTypeOnlyImportExportSpecifier(node, isImport, isInTypeOnlyImportExport) {
		        var leftOfAsKey = isImport ? "imported" : "local";
		        var rightOfAsKey = isImport ? "local" : "exported";
		        var leftOfAs = node[leftOfAsKey];
		        var rightOfAs;
		        var hasTypeSpecifier = false;
		        var canParseAsKeyword = true;
		        var loc = leftOfAs.loc.start;
		        if (this.isContextual(93)) {
		          var firstAs = this.parseIdentifier();
		          if (this.isContextual(93)) {
		            var secondAs = this.parseIdentifier();
		            if (tokenIsKeywordOrIdentifier(this.state.type)) {
		              hasTypeSpecifier = true;
		              leftOfAs = firstAs;
		              rightOfAs = isImport ? this.parseIdentifier() : this.parseModuleExportName();
		              canParseAsKeyword = false;
		            } else {
		              rightOfAs = secondAs;
		              canParseAsKeyword = false;
		            }
		          } else if (tokenIsKeywordOrIdentifier(this.state.type)) {
		            canParseAsKeyword = false;
		            rightOfAs = isImport ? this.parseIdentifier() : this.parseModuleExportName();
		          } else {
		            hasTypeSpecifier = true;
		            leftOfAs = firstAs;
		          }
		        } else if (tokenIsKeywordOrIdentifier(this.state.type)) {
		          hasTypeSpecifier = true;
		          if (isImport) {
		            leftOfAs = this.parseIdentifier(true);
		            if (!this.isContextual(93)) {
		              this.checkReservedWord(leftOfAs.name, leftOfAs.loc.start, true, true);
		            }
		          } else {
		            leftOfAs = this.parseModuleExportName();
		          }
		        }
		        if (hasTypeSpecifier && isInTypeOnlyImportExport) {
		          this.raise(isImport ? TSErrors.TypeModifierIsUsedInTypeImports : TSErrors.TypeModifierIsUsedInTypeExports, loc);
		        }
		        node[leftOfAsKey] = leftOfAs;
		        node[rightOfAsKey] = rightOfAs;
		        var kindKey = isImport ? "importKind" : "exportKind";
		        node[kindKey] = hasTypeSpecifier ? "type" : "value";
		        if (canParseAsKeyword && this.eatContextual(93)) {
		          node[rightOfAsKey] = isImport ? this.parseIdentifier() : this.parseModuleExportName();
		        }
		        if (!node[rightOfAsKey]) {
		          node[rightOfAsKey] = cloneIdentifier(node[leftOfAsKey]);
		        }
		        if (isImport) {
		          this.checkIdentifier(node[rightOfAsKey], hasTypeSpecifier ? BindingFlag.TYPE_TS_TYPE_IMPORT : BindingFlag.TYPE_TS_VALUE_IMPORT);
		        }
		      };
		      return _createClass(TypeScriptParserMixin);
		    }(superClass);
		  });
		  function isPossiblyLiteralEnum(expression) {
		    if (expression.type !== "MemberExpression") return false;
		    var computed = expression.computed,
		      property = expression.property;
		    if (computed && property.type !== "StringLiteral" && (property.type !== "TemplateLiteral" || property.expressions.length > 0)) {
		      return false;
		    }
		    return isUncomputedMemberExpressionChain(expression.object);
		  }
		  function isValidAmbientConstInitializer(expression, estree) {
		    var _expression$extra;
		    var type = expression.type;
		    if ((_expression$extra = expression.extra) != null && _expression$extra.parenthesized) {
		      return false;
		    }
		    if (estree) {
		      if (type === "Literal") {
		        var value = expression.value;
		        if (typeof value === "string" || typeof value === "boolean") {
		          return true;
		        }
		      }
		    } else {
		      if (type === "StringLiteral" || type === "BooleanLiteral") {
		        return true;
		      }
		    }
		    if (isNumber$1(expression, estree) || isNegativeNumber(expression, estree)) {
		      return true;
		    }
		    if (type === "TemplateLiteral" && expression.expressions.length === 0) {
		      return true;
		    }
		    if (isPossiblyLiteralEnum(expression)) {
		      return true;
		    }
		    return false;
		  }
		  function isNumber$1(expression, estree) {
		    if (estree) {
		      return expression.type === "Literal" && (typeof expression.value === "number" || "bigint" in expression);
		    }
		    return expression.type === "NumericLiteral" || expression.type === "BigIntLiteral";
		  }
		  function isNegativeNumber(expression, estree) {
		    if (expression.type === "UnaryExpression") {
		      var operator = expression.operator,
		        argument = expression.argument;
		      if (operator === "-" && isNumber$1(argument, estree)) {
		        return true;
		      }
		    }
		    return false;
		  }
		  function isUncomputedMemberExpressionChain(expression) {
		    if (expression.type === "Identifier") return true;
		    if (expression.type !== "MemberExpression" || expression.computed) {
		      return false;
		    }
		    return isUncomputedMemberExpressionChain(expression.object);
		  }

		  var _templateObject$C;
		  var PlaceholderErrors = ParseErrorEnum(_templateObject$C || (_templateObject$C = _taggedTemplateLiteralLoose(["placeholders"])))({
		    ClassNameIsRequired: "A class name is required.",
		    UnexpectedSpace: "Unexpected space in placeholder."
		  });
		  var placeholders = (function (superClass) {
		    return function (_superClass) {
		      function PlaceholdersParserMixin() {
		        return _superClass.apply(this, arguments) || this;
		      }
		      _inherits(PlaceholdersParserMixin, _superClass);
		      var _proto = PlaceholdersParserMixin.prototype;
		      _proto.parsePlaceholder = function parsePlaceholder(expectedNode) {
		        if (this.match(144)) {
		          var node = this.startNode();
		          this.next();
		          this.assertNoSpace();
		          node.name = _superClass.prototype.parseIdentifier.call(this, true);
		          this.assertNoSpace();
		          this.expect(144);
		          return this.finishPlaceholder(node, expectedNode);
		        }
		      };
		      _proto.finishPlaceholder = function finishPlaceholder(node, expectedNode) {
		        var placeholder = node;
		        if (!placeholder.expectedNode || !placeholder.type) {
		          placeholder = this.finishNode(placeholder, "Placeholder");
		        }
		        placeholder.expectedNode = expectedNode;
		        return placeholder;
		      };
		      _proto.getTokenFromCode = function getTokenFromCode(code) {
		        if (code === 37 && this.input.charCodeAt(this.state.pos + 1) === 37) {
		          this.finishOp(144, 2);
		        } else {
		          _superClass.prototype.getTokenFromCode.call(this, code);
		        }
		      };
		      _proto.parseExprAtom = function parseExprAtom(refExpressionErrors) {
		        return this.parsePlaceholder("Expression") || _superClass.prototype.parseExprAtom.call(this, refExpressionErrors);
		      };
		      _proto.parseIdentifier = function parseIdentifier(liberal) {
		        return this.parsePlaceholder("Identifier") || _superClass.prototype.parseIdentifier.call(this, liberal);
		      };
		      _proto.checkReservedWord = function checkReservedWord(word, startLoc, checkKeywords, isBinding) {
		        if (word !== undefined) {
		          _superClass.prototype.checkReservedWord.call(this, word, startLoc, checkKeywords, isBinding);
		        }
		      };
		      _proto.parseBindingAtom = function parseBindingAtom() {
		        return this.parsePlaceholder("Pattern") || _superClass.prototype.parseBindingAtom.call(this);
		      };
		      _proto.isValidLVal = function isValidLVal(type, isParenthesized, binding) {
		        return type === "Placeholder" || _superClass.prototype.isValidLVal.call(this, type, isParenthesized, binding);
		      };
		      _proto.toAssignable = function toAssignable(node, isLHS) {
		        if (node && node.type === "Placeholder" && node.expectedNode === "Expression") {
		          node.expectedNode = "Pattern";
		        } else {
		          _superClass.prototype.toAssignable.call(this, node, isLHS);
		        }
		      };
		      _proto.chStartsBindingIdentifier = function chStartsBindingIdentifier(ch, pos) {
		        if (_superClass.prototype.chStartsBindingIdentifier.call(this, ch, pos)) {
		          return true;
		        }
		        var nextToken = this.lookahead();
		        if (nextToken.type === 144) {
		          return true;
		        }
		        return false;
		      };
		      _proto.verifyBreakContinue = function verifyBreakContinue(node, isBreak) {
		        if (node.label && node.label.type === "Placeholder") return;
		        _superClass.prototype.verifyBreakContinue.call(this, node, isBreak);
		      };
		      _proto.parseExpressionStatement = function parseExpressionStatement(node, expr) {
		        var _expr$extra;
		        if (expr.type !== "Placeholder" || (_expr$extra = expr.extra) != null && _expr$extra.parenthesized) {
		          return _superClass.prototype.parseExpressionStatement.call(this, node, expr);
		        }
		        if (this.match(14)) {
		          var stmt = node;
		          stmt.label = this.finishPlaceholder(expr, "Identifier");
		          this.next();
		          stmt.body = _superClass.prototype.parseStatementOrSloppyAnnexBFunctionDeclaration.call(this);
		          return this.finishNode(stmt, "LabeledStatement");
		        }
		        this.semicolon();
		        var stmtPlaceholder = node;
		        stmtPlaceholder.name = expr.name;
		        return this.finishPlaceholder(stmtPlaceholder, "Statement");
		      };
		      _proto.parseBlock = function parseBlock(allowDirectives, createNewLexicalScope, afterBlockParse) {
		        return this.parsePlaceholder("BlockStatement") || _superClass.prototype.parseBlock.call(this, allowDirectives, createNewLexicalScope, afterBlockParse);
		      };
		      _proto.parseFunctionId = function parseFunctionId(requireId) {
		        return this.parsePlaceholder("Identifier") || _superClass.prototype.parseFunctionId.call(this, requireId);
		      };
		      _proto.parseClass = function parseClass(node, isStatement, optionalId) {
		        var type = isStatement ? "ClassDeclaration" : "ClassExpression";
		        this.next();
		        var oldStrict = this.state.strict;
		        var placeholder = this.parsePlaceholder("Identifier");
		        if (placeholder) {
		          if (this.match(81) || this.match(144) || this.match(5)) {
		            node.id = placeholder;
		          } else if (optionalId || !isStatement) {
		            node.id = null;
		            node.body = this.finishPlaceholder(placeholder, "ClassBody");
		            return this.finishNode(node, type);
		          } else {
		            throw this.raise(PlaceholderErrors.ClassNameIsRequired, this.state.startLoc);
		          }
		        } else {
		          this.parseClassId(node, isStatement, optionalId);
		        }
		        _superClass.prototype.parseClassSuper.call(this, node);
		        node.body = this.parsePlaceholder("ClassBody") || _superClass.prototype.parseClassBody.call(this, !!node.superClass, oldStrict);
		        return this.finishNode(node, type);
		      };
		      _proto.parseExport = function parseExport(node, decorators) {
		        var placeholder = this.parsePlaceholder("Identifier");
		        if (!placeholder) return _superClass.prototype.parseExport.call(this, node, decorators);
		        var node2 = node;
		        if (!this.isContextual(98) && !this.match(12)) {
		          node2.specifiers = [];
		          node2.source = null;
		          node2.declaration = this.finishPlaceholder(placeholder, "Declaration");
		          return this.finishNode(node2, "ExportNamedDeclaration");
		        }
		        this.expectPlugin("exportDefaultFrom");
		        var specifier = this.startNode();
		        specifier.exported = placeholder;
		        node2.specifiers = [this.finishNode(specifier, "ExportDefaultSpecifier")];
		        return _superClass.prototype.parseExport.call(this, node2, decorators);
		      };
		      _proto.isExportDefaultSpecifier = function isExportDefaultSpecifier() {
		        if (this.match(65)) {
		          var next = this.nextTokenStart();
		          if (this.isUnparsedContextual(next, "from")) {
		            if (this.input.startsWith(tokenLabelName(144), this.nextTokenStartSince(next + 4))) {
		              return true;
		            }
		          }
		        }
		        return _superClass.prototype.isExportDefaultSpecifier.call(this);
		      };
		      _proto.maybeParseExportDefaultSpecifier = function maybeParseExportDefaultSpecifier(node, maybeDefaultIdentifier) {
		        var _specifiers;
		        if ((_specifiers = node.specifiers) != null && _specifiers.length) {
		          return true;
		        }
		        return _superClass.prototype.maybeParseExportDefaultSpecifier.call(this, node, maybeDefaultIdentifier);
		      };
		      _proto.checkExport = function checkExport(node) {
		        var specifiers = node.specifiers;
		        if (specifiers != null && specifiers.length) {
		          node.specifiers = specifiers.filter(function (node) {
		            return node.exported.type === "Placeholder";
		          });
		        }
		        _superClass.prototype.checkExport.call(this, node);
		        node.specifiers = specifiers;
		      };
		      _proto.parseImport = function parseImport(node) {
		        var placeholder = this.parsePlaceholder("Identifier");
		        if (!placeholder) return _superClass.prototype.parseImport.call(this, node);
		        node.specifiers = [];
		        if (!this.isContextual(98) && !this.match(12)) {
		          node.source = this.finishPlaceholder(placeholder, "StringLiteral");
		          this.semicolon();
		          return this.finishNode(node, "ImportDeclaration");
		        }
		        var specifier = this.startNodeAtNode(placeholder);
		        specifier.local = placeholder;
		        node.specifiers.push(this.finishNode(specifier, "ImportDefaultSpecifier"));
		        if (this.eat(12)) {
		          var hasStarImport = this.maybeParseStarImportSpecifier(node);
		          if (!hasStarImport) this.parseNamedImportSpecifiers(node);
		        }
		        this.expectContextual(98);
		        node.source = this.parseImportSource();
		        this.semicolon();
		        return this.finishNode(node, "ImportDeclaration");
		      };
		      _proto.parseImportSource = function parseImportSource() {
		        return this.parsePlaceholder("StringLiteral") || _superClass.prototype.parseImportSource.call(this);
		      };
		      _proto.assertNoSpace = function assertNoSpace() {
		        if (this.state.start > this.state.lastTokEndLoc.index) {
		          this.raise(PlaceholderErrors.UnexpectedSpace, this.state.lastTokEndLoc);
		        }
		      };
		      return _createClass(PlaceholdersParserMixin);
		    }(superClass);
		  });

		  var v8intrinsic = (function (superClass) {
		    return function (_superClass) {
		      function V8IntrinsicMixin() {
		        return _superClass.apply(this, arguments) || this;
		      }
		      _inherits(V8IntrinsicMixin, _superClass);
		      var _proto = V8IntrinsicMixin.prototype;
		      _proto.parseV8Intrinsic = function parseV8Intrinsic() {
		        if (this.match(54)) {
		          var v8IntrinsicStartLoc = this.state.startLoc;
		          var node = this.startNode();
		          this.next();
		          if (tokenIsIdentifier(this.state.type)) {
		            var name = this.parseIdentifierName();
		            var identifier = this.createIdentifier(node, name);
		            identifier.type = "V8IntrinsicIdentifier";
		            if (this.match(10)) {
		              return identifier;
		            }
		          }
		          this.unexpected(v8IntrinsicStartLoc);
		        }
		      };
		      _proto.parseExprAtom = function parseExprAtom(refExpressionErrors) {
		        return this.parseV8Intrinsic() || _superClass.prototype.parseExprAtom.call(this, refExpressionErrors);
		      };
		      return _createClass(V8IntrinsicMixin);
		    }(superClass);
		  });

		  function hasPlugin(plugins, expectedConfig) {
		    var _ref = typeof expectedConfig === "string" ? [expectedConfig, {}] : expectedConfig,
		      expectedName = _ref[0],
		      expectedOptions = _ref[1];
		    var expectedKeys = Object.keys(expectedOptions);
		    var expectedOptionsIsEmpty = expectedKeys.length === 0;
		    return plugins.some(function (p) {
		      if (typeof p === "string") {
		        return expectedOptionsIsEmpty && p === expectedName;
		      } else {
		        var pluginName = p[0],
		          pluginOptions = p[1];
		        if (pluginName !== expectedName) {
		          return false;
		        }
		        for (var _i2 = 0; _i2 < expectedKeys.length; _i2++) {
		          var key = expectedKeys[_i2];
		          if (pluginOptions[key] !== expectedOptions[key]) {
		            return false;
		          }
		        }
		        return true;
		      }
		    });
		  }
		  function getPluginOption(plugins, name, option) {
		    var plugin = plugins.find(function (plugin) {
		      if (Array.isArray(plugin)) {
		        return plugin[0] === name;
		      } else {
		        return plugin === name;
		      }
		    });
		    if (plugin && Array.isArray(plugin) && plugin.length > 1) {
		      return plugin[1][option];
		    }
		    return null;
		  }
		  var PIPELINE_PROPOSALS$1 = ["minimal", "fsharp", "hack", "smart"];
		  var TOPIC_TOKENS$1 = ["^^", "@@", "^", "%", "#"];
		  var RECORD_AND_TUPLE_SYNTAX_TYPES = ["hash", "bar"];
		  function validatePlugins(plugins) {
		    if (hasPlugin(plugins, "decorators")) {
		      if (hasPlugin(plugins, "decorators-legacy")) {
		        throw new Error("Cannot use the decorators and decorators-legacy plugin together");
		      }
		      var decoratorsBeforeExport = getPluginOption(plugins, "decorators", "decoratorsBeforeExport");
		      if (decoratorsBeforeExport != null && typeof decoratorsBeforeExport !== "boolean") {
		        throw new Error("'decoratorsBeforeExport' must be a boolean, if specified.");
		      }
		      var allowCallParenthesized = getPluginOption(plugins, "decorators", "allowCallParenthesized");
		      if (allowCallParenthesized != null && typeof allowCallParenthesized !== "boolean") {
		        throw new Error("'allowCallParenthesized' must be a boolean.");
		      }
		    }
		    if (hasPlugin(plugins, "flow") && hasPlugin(plugins, "typescript")) {
		      throw new Error("Cannot combine flow and typescript plugins.");
		    }
		    if (hasPlugin(plugins, "placeholders") && hasPlugin(plugins, "v8intrinsic")) {
		      throw new Error("Cannot combine placeholders and v8intrinsic plugins.");
		    }
		    if (hasPlugin(plugins, "pipelineOperator")) {
		      var proposal = getPluginOption(plugins, "pipelineOperator", "proposal");
		      if (!PIPELINE_PROPOSALS$1.includes(proposal)) {
		        var proposalList = PIPELINE_PROPOSALS$1.map(function (p) {
		          return "\"" + p + "\"";
		        }).join(", ");
		        throw new Error("\"pipelineOperator\" requires \"proposal\" option whose value must be one of: " + proposalList + ".");
		      }
		      var tupleSyntaxIsHash = hasPlugin(plugins, ["recordAndTuple", {
		        syntaxType: "hash"
		      }]);
		      if (proposal === "hack") {
		        if (hasPlugin(plugins, "placeholders")) {
		          throw new Error("Cannot combine placeholders plugin and Hack-style pipes.");
		        }
		        if (hasPlugin(plugins, "v8intrinsic")) {
		          throw new Error("Cannot combine v8intrinsic plugin and Hack-style pipes.");
		        }
		        var topicToken = getPluginOption(plugins, "pipelineOperator", "topicToken");
		        if (!TOPIC_TOKENS$1.includes(topicToken)) {
		          var tokenList = TOPIC_TOKENS$1.map(function (t) {
		            return "\"" + t + "\"";
		          }).join(", ");
		          throw new Error("\"pipelineOperator\" in \"proposal\": \"hack\" mode also requires a \"topicToken\" option whose value must be one of: " + tokenList + ".");
		        }
		        if (topicToken === "#" && tupleSyntaxIsHash) {
		          throw new Error('Plugin conflict between `["pipelineOperator", { proposal: "hack", topicToken: "#" }]` and `["recordAndtuple", { syntaxType: "hash"}]`.');
		        }
		      } else if (proposal === "smart" && tupleSyntaxIsHash) {
		        throw new Error('Plugin conflict between `["pipelineOperator", { proposal: "smart" }]` and `["recordAndtuple", { syntaxType: "hash"}]`.');
		      }
		    }
		    if (hasPlugin(plugins, "moduleAttributes")) {
		      {
		        if (hasPlugin(plugins, "importAssertions") || hasPlugin(plugins, "importAttributes")) {
		          throw new Error("Cannot combine importAssertions, importAttributes and moduleAttributes plugins.");
		        }
		        var moduleAttributesVersionPluginOption = getPluginOption(plugins, "moduleAttributes", "version");
		        if (moduleAttributesVersionPluginOption !== "may-2020") {
		          throw new Error("The 'moduleAttributes' plugin requires a 'version' option," + " representing the last proposal update. Currently, the" + " only supported value is 'may-2020'.");
		        }
		      }
		    }
		    if (hasPlugin(plugins, "importAssertions") && hasPlugin(plugins, "importAttributes")) {
		      throw new Error("Cannot combine importAssertions and importAttributes plugins.");
		    }
		    if (hasPlugin(plugins, "recordAndTuple") && getPluginOption(plugins, "recordAndTuple", "syntaxType") != null && !RECORD_AND_TUPLE_SYNTAX_TYPES.includes(getPluginOption(plugins, "recordAndTuple", "syntaxType"))) {
		      throw new Error("The 'syntaxType' option of the 'recordAndTuple' plugin must be one of: " + RECORD_AND_TUPLE_SYNTAX_TYPES.map(function (p) {
		        return "'" + p + "'";
		      }).join(", "));
		    }
		    if (hasPlugin(plugins, "asyncDoExpressions") && !hasPlugin(plugins, "doExpressions")) {
		      var error = new Error("'asyncDoExpressions' requires 'doExpressions', please add 'doExpressions' to parser plugins.");
		      error.missingPlugins = "doExpressions";
		      throw error;
		    }
		    if (hasPlugin(plugins, "optionalChainingAssign") && getPluginOption(plugins, "optionalChainingAssign", "version") !== "2023-07") {
		      throw new Error("The 'optionalChainingAssign' plugin requires a 'version' option," + " representing the last proposal update. Currently, the" + " only supported value is '2023-07'.");
		    }
		  }
		  var mixinPlugins = {
		    estree: estree,
		    jsx: jsx,
		    flow: flow,
		    typescript: typescript,
		    v8intrinsic: v8intrinsic,
		    placeholders: placeholders
		  };
		  var mixinPluginNames = Object.keys(mixinPlugins);

		  var defaultOptions = {
		    sourceType: "script",
		    sourceFilename: undefined,
		    startColumn: 0,
		    startLine: 1,
		    allowAwaitOutsideFunction: false,
		    allowReturnOutsideFunction: false,
		    allowNewTargetOutsideFunction: false,
		    allowImportExportEverywhere: false,
		    allowSuperOutsideMethod: false,
		    allowUndeclaredExports: false,
		    plugins: [],
		    strictMode: null,
		    ranges: false,
		    tokens: false,
		    createImportExpressions: false,
		    createParenthesizedExpressions: false,
		    errorRecovery: false,
		    attachComment: true,
		    annexB: true
		  };
		  function getOptions(opts) {
		    if (opts == null) {
		      return Object.assign({}, defaultOptions);
		    }
		    if (opts.annexB != null && opts.annexB !== false) {
		      throw new Error("The `annexB` option can only be set to `false`.");
		    }
		    var options = {};
		    for (var _i2 = 0, _Object$keys2 = Object.keys(defaultOptions); _i2 < _Object$keys2.length; _i2++) {
		      var _opts$key;
		      var key = _Object$keys2[_i2];
		      options[key] = (_opts$key = opts[key]) != null ? _opts$key : defaultOptions[key];
		    }
		    return options;
		  }

		  var ExpressionParser = function (_LValParser) {
		    function ExpressionParser() {
		      return _LValParser.apply(this, arguments) || this;
		    }
		    _inherits(ExpressionParser, _LValParser);
		    var _proto = ExpressionParser.prototype;
		    _proto.checkProto = function checkProto(prop, isRecord, protoRef, refExpressionErrors) {
		      if (prop.type === "SpreadElement" || this.isObjectMethod(prop) || prop.computed || prop.shorthand) {
		        return;
		      }
		      var key = prop.key;
		      var name = key.type === "Identifier" ? key.name : key.value;
		      if (name === "__proto__") {
		        if (isRecord) {
		          this.raise(Errors.RecordNoProto, key);
		          return;
		        }
		        if (protoRef.used) {
		          if (refExpressionErrors) {
		            if (refExpressionErrors.doubleProtoLoc === null) {
		              refExpressionErrors.doubleProtoLoc = key.loc.start;
		            }
		          } else {
		            this.raise(Errors.DuplicateProto, key);
		          }
		        }
		        protoRef.used = true;
		      }
		    };
		    _proto.shouldExitDescending = function shouldExitDescending(expr, potentialArrowAt) {
		      return expr.type === "ArrowFunctionExpression" && expr.start === potentialArrowAt;
		    };
		    _proto.getExpression = function getExpression() {
		      this.enterInitialScopes();
		      this.nextToken();
		      var expr = this.parseExpression();
		      if (!this.match(139)) {
		        this.unexpected();
		      }
		      this.finalizeRemainingComments();
		      expr.comments = this.comments;
		      expr.errors = this.state.errors;
		      if (this.options.tokens) {
		        expr.tokens = this.tokens;
		      }
		      return expr;
		    };
		    _proto.parseExpression = function parseExpression(disallowIn, refExpressionErrors) {
		      var _this = this;
		      if (disallowIn) {
		        return this.disallowInAnd(function () {
		          return _this.parseExpressionBase(refExpressionErrors);
		        });
		      }
		      return this.allowInAnd(function () {
		        return _this.parseExpressionBase(refExpressionErrors);
		      });
		    };
		    _proto.parseExpressionBase = function parseExpressionBase(refExpressionErrors) {
		      var startLoc = this.state.startLoc;
		      var expr = this.parseMaybeAssign(refExpressionErrors);
		      if (this.match(12)) {
		        var _node = this.startNodeAt(startLoc);
		        _node.expressions = [expr];
		        while (this.eat(12)) {
		          _node.expressions.push(this.parseMaybeAssign(refExpressionErrors));
		        }
		        this.toReferencedList(_node.expressions);
		        return this.finishNode(_node, "SequenceExpression");
		      }
		      return expr;
		    };
		    _proto.parseMaybeAssignDisallowIn = function parseMaybeAssignDisallowIn(refExpressionErrors, afterLeftParse) {
		      var _this2 = this;
		      return this.disallowInAnd(function () {
		        return _this2.parseMaybeAssign(refExpressionErrors, afterLeftParse);
		      });
		    };
		    _proto.parseMaybeAssignAllowIn = function parseMaybeAssignAllowIn(refExpressionErrors, afterLeftParse) {
		      var _this3 = this;
		      return this.allowInAnd(function () {
		        return _this3.parseMaybeAssign(refExpressionErrors, afterLeftParse);
		      });
		    };
		    _proto.setOptionalParametersError = function setOptionalParametersError(refExpressionErrors, resultError) {
		      var _resultError$loc;
		      refExpressionErrors.optionalParametersLoc = (_resultError$loc = resultError == null ? void 0 : resultError.loc) != null ? _resultError$loc : this.state.startLoc;
		    };
		    _proto.parseMaybeAssign = function parseMaybeAssign(refExpressionErrors, afterLeftParse) {
		      var startLoc = this.state.startLoc;
		      if (this.isContextual(108)) {
		        if (this.prodParam.hasYield) {
		          var _left = this.parseYield();
		          if (afterLeftParse) {
		            _left = afterLeftParse.call(this, _left, startLoc);
		          }
		          return _left;
		        }
		      }
		      var ownExpressionErrors;
		      if (refExpressionErrors) {
		        ownExpressionErrors = false;
		      } else {
		        refExpressionErrors = new ExpressionErrors();
		        ownExpressionErrors = true;
		      }
		      var type = this.state.type;
		      if (type === 10 || tokenIsIdentifier(type)) {
		        this.state.potentialArrowAt = this.state.start;
		      }
		      var left = this.parseMaybeConditional(refExpressionErrors);
		      if (afterLeftParse) {
		        left = afterLeftParse.call(this, left, startLoc);
		      }
		      if (tokenIsAssignment(this.state.type)) {
		        var _node2 = this.startNodeAt(startLoc);
		        var operator = this.state.value;
		        _node2.operator = operator;
		        if (this.match(29)) {
		          this.toAssignable(left, true);
		          _node2.left = left;
		          var startIndex = startLoc.index;
		          if (refExpressionErrors.doubleProtoLoc != null && refExpressionErrors.doubleProtoLoc.index >= startIndex) {
		            refExpressionErrors.doubleProtoLoc = null;
		          }
		          if (refExpressionErrors.shorthandAssignLoc != null && refExpressionErrors.shorthandAssignLoc.index >= startIndex) {
		            refExpressionErrors.shorthandAssignLoc = null;
		          }
		          if (refExpressionErrors.privateKeyLoc != null && refExpressionErrors.privateKeyLoc.index >= startIndex) {
		            this.checkDestructuringPrivate(refExpressionErrors);
		            refExpressionErrors.privateKeyLoc = null;
		          }
		        } else {
		          _node2.left = left;
		        }
		        this.next();
		        _node2.right = this.parseMaybeAssign();
		        this.checkLVal(left, {
		          "in": this.finishNode(_node2, "AssignmentExpression")
		        });
		        return _node2;
		      } else if (ownExpressionErrors) {
		        this.checkExpressionErrors(refExpressionErrors, true);
		      }
		      return left;
		    };
		    _proto.parseMaybeConditional = function parseMaybeConditional(refExpressionErrors) {
		      var startLoc = this.state.startLoc;
		      var potentialArrowAt = this.state.potentialArrowAt;
		      var expr = this.parseExprOps(refExpressionErrors);
		      if (this.shouldExitDescending(expr, potentialArrowAt)) {
		        return expr;
		      }
		      return this.parseConditional(expr, startLoc, refExpressionErrors);
		    };
		    _proto.parseConditional = function parseConditional(expr, startLoc, refExpressionErrors) {
		      if (this.eat(17)) {
		        var _node3 = this.startNodeAt(startLoc);
		        _node3.test = expr;
		        _node3.consequent = this.parseMaybeAssignAllowIn();
		        this.expect(14);
		        _node3.alternate = this.parseMaybeAssign();
		        return this.finishNode(_node3, "ConditionalExpression");
		      }
		      return expr;
		    };
		    _proto.parseMaybeUnaryOrPrivate = function parseMaybeUnaryOrPrivate(refExpressionErrors) {
		      return this.match(138) ? this.parsePrivateName() : this.parseMaybeUnary(refExpressionErrors);
		    };
		    _proto.parseExprOps = function parseExprOps(refExpressionErrors) {
		      var startLoc = this.state.startLoc;
		      var potentialArrowAt = this.state.potentialArrowAt;
		      var expr = this.parseMaybeUnaryOrPrivate(refExpressionErrors);
		      if (this.shouldExitDescending(expr, potentialArrowAt)) {
		        return expr;
		      }
		      return this.parseExprOp(expr, startLoc, -1);
		    };
		    _proto.parseExprOp = function parseExprOp(left, leftStartLoc, minPrec) {
		      if (this.isPrivateName(left)) {
		        var value = this.getPrivateNameSV(left);
		        if (minPrec >= tokenOperatorPrecedence(58) || !this.prodParam.hasIn || !this.match(58)) {
		          this.raise(Errors.PrivateInExpectedIn, left, {
		            identifierName: value
		          });
		        }
		        this.classScope.usePrivateName(value, left.loc.start);
		      }
		      var op = this.state.type;
		      if (tokenIsOperator(op) && (this.prodParam.hasIn || !this.match(58))) {
		        var prec = tokenOperatorPrecedence(op);
		        if (prec > minPrec) {
		          if (op === 39) {
		            this.expectPlugin("pipelineOperator");
		            if (this.state.inFSharpPipelineDirectBody) {
		              return left;
		            }
		            this.checkPipelineAtInfixOperator(left, leftStartLoc);
		          }
		          var _node4 = this.startNodeAt(leftStartLoc);
		          _node4.left = left;
		          _node4.operator = this.state.value;
		          var logical = op === 41 || op === 42;
		          var coalesce = op === 40;
		          if (coalesce) {
		            prec = tokenOperatorPrecedence(42);
		          }
		          this.next();
		          if (op === 39 && this.hasPlugin(["pipelineOperator", {
		            proposal: "minimal"
		          }])) {
		            if (this.state.type === 96 && this.prodParam.hasAwait) {
		              throw this.raise(Errors.UnexpectedAwaitAfterPipelineBody, this.state.startLoc);
		            }
		          }
		          _node4.right = this.parseExprOpRightExpr(op, prec);
		          var finishedNode = this.finishNode(_node4, logical || coalesce ? "LogicalExpression" : "BinaryExpression");
		          var nextOp = this.state.type;
		          if (coalesce && (nextOp === 41 || nextOp === 42) || logical && nextOp === 40) {
		            throw this.raise(Errors.MixingCoalesceWithLogical, this.state.startLoc);
		          }
		          return this.parseExprOp(finishedNode, leftStartLoc, minPrec);
		        }
		      }
		      return left;
		    };
		    _proto.parseExprOpRightExpr = function parseExprOpRightExpr(op, prec) {
		      var _this4 = this;
		      var startLoc = this.state.startLoc;
		      switch (op) {
		        case 39:
		          switch (this.getPluginOption("pipelineOperator", "proposal")) {
		            case "hack":
		              return this.withTopicBindingContext(function () {
		                return _this4.parseHackPipeBody();
		              });
		            case "smart":
		              return this.withTopicBindingContext(function () {
		                if (_this4.prodParam.hasYield && _this4.isContextual(108)) {
		                  throw _this4.raise(Errors.PipeBodyIsTighter, _this4.state.startLoc);
		                }
		                return _this4.parseSmartPipelineBodyInStyle(_this4.parseExprOpBaseRightExpr(op, prec), startLoc);
		              });
		            case "fsharp":
		              return this.withSoloAwaitPermittingContext(function () {
		                return _this4.parseFSharpPipelineBody(prec);
		              });
		          }
		        default:
		          return this.parseExprOpBaseRightExpr(op, prec);
		      }
		    };
		    _proto.parseExprOpBaseRightExpr = function parseExprOpBaseRightExpr(op, prec) {
		      var startLoc = this.state.startLoc;
		      return this.parseExprOp(this.parseMaybeUnaryOrPrivate(), startLoc, tokenIsRightAssociative(op) ? prec - 1 : prec);
		    };
		    _proto.parseHackPipeBody = function parseHackPipeBody() {
		      var _body$extra;
		      var startLoc = this.state.startLoc;
		      var body = this.parseMaybeAssign();
		      var requiredParentheses = UnparenthesizedPipeBodyDescriptions.has(body.type);
		      if (requiredParentheses && !((_body$extra = body.extra) != null && _body$extra.parenthesized)) {
		        this.raise(Errors.PipeUnparenthesizedBody, startLoc, {
		          type: body.type
		        });
		      }
		      if (!this.topicReferenceWasUsedInCurrentContext()) {
		        this.raise(Errors.PipeTopicUnused, startLoc);
		      }
		      return body;
		    };
		    _proto.checkExponentialAfterUnary = function checkExponentialAfterUnary(node) {
		      if (this.match(57)) {
		        this.raise(Errors.UnexpectedTokenUnaryExponentiation, node.argument);
		      }
		    };
		    _proto.parseMaybeUnary = function parseMaybeUnary(refExpressionErrors, sawUnary) {
		      var startLoc = this.state.startLoc;
		      var isAwait = this.isContextual(96);
		      if (isAwait && this.isAwaitAllowed()) {
		        this.next();
		        var _expr = this.parseAwait(startLoc);
		        if (!sawUnary) this.checkExponentialAfterUnary(_expr);
		        return _expr;
		      }
		      var update = this.match(34);
		      var node = this.startNode();
		      if (tokenIsPrefix(this.state.type)) {
		        node.operator = this.state.value;
		        node.prefix = true;
		        if (this.match(72)) {
		          this.expectPlugin("throwExpressions");
		        }
		        var isDelete = this.match(89);
		        this.next();
		        node.argument = this.parseMaybeUnary(null, true);
		        this.checkExpressionErrors(refExpressionErrors, true);
		        if (this.state.strict && isDelete) {
		          var arg = node.argument;
		          if (arg.type === "Identifier") {
		            this.raise(Errors.StrictDelete, node);
		          } else if (this.hasPropertyAsPrivateName(arg)) {
		            this.raise(Errors.DeletePrivateField, node);
		          }
		        }
		        if (!update) {
		          if (!sawUnary) {
		            this.checkExponentialAfterUnary(node);
		          }
		          return this.finishNode(node, "UnaryExpression");
		        }
		      }
		      var expr = this.parseUpdate(node, update, refExpressionErrors);
		      if (isAwait) {
		        var type = this.state.type;
		        var startsExpr = this.hasPlugin("v8intrinsic") ? tokenCanStartExpression(type) : tokenCanStartExpression(type) && !this.match(54);
		        if (startsExpr && !this.isAmbiguousAwait()) {
		          this.raiseOverwrite(Errors.AwaitNotInAsyncContext, startLoc);
		          return this.parseAwait(startLoc);
		        }
		      }
		      return expr;
		    };
		    _proto.parseUpdate = function parseUpdate(node, update, refExpressionErrors) {
		      if (update) {
		        var updateExpressionNode = node;
		        this.checkLVal(updateExpressionNode.argument, {
		          "in": this.finishNode(updateExpressionNode, "UpdateExpression")
		        });
		        return node;
		      }
		      var startLoc = this.state.startLoc;
		      var expr = this.parseExprSubscripts(refExpressionErrors);
		      if (this.checkExpressionErrors(refExpressionErrors, false)) return expr;
		      while (tokenIsPostfix(this.state.type) && !this.canInsertSemicolon()) {
		        var _node5 = this.startNodeAt(startLoc);
		        _node5.operator = this.state.value;
		        _node5.prefix = false;
		        _node5.argument = expr;
		        this.next();
		        this.checkLVal(expr, {
		          "in": expr = this.finishNode(_node5, "UpdateExpression")
		        });
		      }
		      return expr;
		    };
		    _proto.parseExprSubscripts = function parseExprSubscripts(refExpressionErrors) {
		      var startLoc = this.state.startLoc;
		      var potentialArrowAt = this.state.potentialArrowAt;
		      var expr = this.parseExprAtom(refExpressionErrors);
		      if (this.shouldExitDescending(expr, potentialArrowAt)) {
		        return expr;
		      }
		      return this.parseSubscripts(expr, startLoc);
		    };
		    _proto.parseSubscripts = function parseSubscripts(base, startLoc, noCalls) {
		      var state = {
		        optionalChainMember: false,
		        maybeAsyncArrow: this.atPossibleAsyncArrow(base),
		        stop: false
		      };
		      do {
		        base = this.parseSubscript(base, startLoc, noCalls, state);
		        state.maybeAsyncArrow = false;
		      } while (!state.stop);
		      return base;
		    };
		    _proto.parseSubscript = function parseSubscript(base, startLoc, noCalls, state) {
		      var type = this.state.type;
		      if (!noCalls && type === 15) {
		        return this.parseBind(base, startLoc, noCalls, state);
		      } else if (tokenIsTemplate(type)) {
		        return this.parseTaggedTemplateExpression(base, startLoc, state);
		      }
		      var optional = false;
		      if (type === 18) {
		        if (noCalls) {
		          this.raise(Errors.OptionalChainingNoNew, this.state.startLoc);
		          if (this.lookaheadCharCode() === 40) {
		            state.stop = true;
		            return base;
		          }
		        }
		        state.optionalChainMember = optional = true;
		        this.next();
		      }
		      if (!noCalls && this.match(10)) {
		        return this.parseCoverCallAndAsyncArrowHead(base, startLoc, state, optional);
		      } else {
		        var computed = this.eat(0);
		        if (computed || optional || this.eat(16)) {
		          return this.parseMember(base, startLoc, state, computed, optional);
		        } else {
		          state.stop = true;
		          return base;
		        }
		      }
		    };
		    _proto.parseMember = function parseMember(base, startLoc, state, computed, optional) {
		      var node = this.startNodeAt(startLoc);
		      node.object = base;
		      node.computed = computed;
		      if (computed) {
		        node.property = this.parseExpression();
		        this.expect(3);
		      } else if (this.match(138)) {
		        if (base.type === "Super") {
		          this.raise(Errors.SuperPrivateField, startLoc);
		        }
		        this.classScope.usePrivateName(this.state.value, this.state.startLoc);
		        node.property = this.parsePrivateName();
		      } else {
		        node.property = this.parseIdentifier(true);
		      }
		      if (state.optionalChainMember) {
		        node.optional = optional;
		        return this.finishNode(node, "OptionalMemberExpression");
		      } else {
		        return this.finishNode(node, "MemberExpression");
		      }
		    };
		    _proto.parseBind = function parseBind(base, startLoc, noCalls, state) {
		      var node = this.startNodeAt(startLoc);
		      node.object = base;
		      this.next();
		      node.callee = this.parseNoCallExpr();
		      state.stop = true;
		      return this.parseSubscripts(this.finishNode(node, "BindExpression"), startLoc, noCalls);
		    };
		    _proto.parseCoverCallAndAsyncArrowHead = function parseCoverCallAndAsyncArrowHead(base, startLoc, state, optional) {
		      var oldMaybeInArrowParameters = this.state.maybeInArrowParameters;
		      var refExpressionErrors = null;
		      this.state.maybeInArrowParameters = true;
		      this.next();
		      var node = this.startNodeAt(startLoc);
		      node.callee = base;
		      var maybeAsyncArrow = state.maybeAsyncArrow,
		        optionalChainMember = state.optionalChainMember;
		      if (maybeAsyncArrow) {
		        this.expressionScope.enter(newAsyncArrowScope());
		        refExpressionErrors = new ExpressionErrors();
		      }
		      if (optionalChainMember) {
		        node.optional = optional;
		      }
		      if (optional) {
		        node.arguments = this.parseCallExpressionArguments(11);
		      } else {
		        node.arguments = this.parseCallExpressionArguments(11, base.type === "Import", base.type !== "Super", node, refExpressionErrors);
		      }
		      var finishedNode = this.finishCallExpression(node, optionalChainMember);
		      if (maybeAsyncArrow && this.shouldParseAsyncArrow() && !optional) {
		        state.stop = true;
		        this.checkDestructuringPrivate(refExpressionErrors);
		        this.expressionScope.validateAsPattern();
		        this.expressionScope.exit();
		        finishedNode = this.parseAsyncArrowFromCallExpression(this.startNodeAt(startLoc), finishedNode);
		      } else {
		        if (maybeAsyncArrow) {
		          this.checkExpressionErrors(refExpressionErrors, true);
		          this.expressionScope.exit();
		        }
		        this.toReferencedArguments(finishedNode);
		      }
		      this.state.maybeInArrowParameters = oldMaybeInArrowParameters;
		      return finishedNode;
		    };
		    _proto.toReferencedArguments = function toReferencedArguments(node, isParenthesizedExpr) {
		      this.toReferencedListDeep(node.arguments, isParenthesizedExpr);
		    };
		    _proto.parseTaggedTemplateExpression = function parseTaggedTemplateExpression(base, startLoc, state) {
		      var node = this.startNodeAt(startLoc);
		      node.tag = base;
		      node.quasi = this.parseTemplate(true);
		      if (state.optionalChainMember) {
		        this.raise(Errors.OptionalChainingNoTemplate, startLoc);
		      }
		      return this.finishNode(node, "TaggedTemplateExpression");
		    };
		    _proto.atPossibleAsyncArrow = function atPossibleAsyncArrow(base) {
		      return base.type === "Identifier" && base.name === "async" && this.state.lastTokEndLoc.index === base.end && !this.canInsertSemicolon() && base.end - base.start === 5 && base.start === this.state.potentialArrowAt;
		    };
		    _proto.expectImportAttributesPlugin = function expectImportAttributesPlugin() {
		      if (!this.hasPlugin("importAssertions")) {
		        this.expectPlugin("importAttributes");
		      }
		    };
		    _proto.finishCallExpression = function finishCallExpression(node, optional) {
		      if (node.callee.type === "Import") {
		        if (node.arguments.length === 2) {
		          {
		            if (!this.hasPlugin("moduleAttributes")) {
		              this.expectImportAttributesPlugin();
		            }
		          }
		        }
		        if (node.arguments.length === 0 || node.arguments.length > 2) {
		          this.raise(Errors.ImportCallArity, node, {
		            maxArgumentCount: this.hasPlugin("importAttributes") || this.hasPlugin("importAssertions") || this.hasPlugin("moduleAttributes") ? 2 : 1
		          });
		        } else {
		          for (var _i2 = 0, _node$arguments2 = node.arguments; _i2 < _node$arguments2.length; _i2++) {
		            var arg = _node$arguments2[_i2];
		            if (arg.type === "SpreadElement") {
		              this.raise(Errors.ImportCallSpreadArgument, arg);
		            }
		          }
		        }
		      }
		      return this.finishNode(node, optional ? "OptionalCallExpression" : "CallExpression");
		    };
		    _proto.parseCallExpressionArguments = function parseCallExpressionArguments(close, dynamicImport, allowPlaceholder, nodeForExtra, refExpressionErrors) {
		      var elts = [];
		      var first = true;
		      var oldInFSharpPipelineDirectBody = this.state.inFSharpPipelineDirectBody;
		      this.state.inFSharpPipelineDirectBody = false;
		      while (!this.eat(close)) {
		        if (first) {
		          first = false;
		        } else {
		          this.expect(12);
		          if (this.match(close)) {
		            if (dynamicImport && !this.hasPlugin("importAttributes") && !this.hasPlugin("importAssertions") && !this.hasPlugin("moduleAttributes")) {
		              this.raise(Errors.ImportCallArgumentTrailingComma, this.state.lastTokStartLoc);
		            }
		            if (nodeForExtra) {
		              this.addTrailingCommaExtraToNode(nodeForExtra);
		            }
		            this.next();
		            break;
		          }
		        }
		        elts.push(this.parseExprListItem(false, refExpressionErrors, allowPlaceholder));
		      }
		      this.state.inFSharpPipelineDirectBody = oldInFSharpPipelineDirectBody;
		      return elts;
		    };
		    _proto.shouldParseAsyncArrow = function shouldParseAsyncArrow() {
		      return this.match(19) && !this.canInsertSemicolon();
		    };
		    _proto.parseAsyncArrowFromCallExpression = function parseAsyncArrowFromCallExpression(node, call) {
		      var _call$extra;
		      this.resetPreviousNodeTrailingComments(call);
		      this.expect(19);
		      this.parseArrowExpression(node, call.arguments, true, (_call$extra = call.extra) == null ? void 0 : _call$extra.trailingCommaLoc);
		      if (call.innerComments) {
		        setInnerComments(node, call.innerComments);
		      }
		      if (call.callee.trailingComments) {
		        setInnerComments(node, call.callee.trailingComments);
		      }
		      return node;
		    };
		    _proto.parseNoCallExpr = function parseNoCallExpr() {
		      var startLoc = this.state.startLoc;
		      return this.parseSubscripts(this.parseExprAtom(), startLoc, true);
		    };
		    _proto.parseExprAtom = function parseExprAtom(refExpressionErrors) {
		      var node;
		      var decorators = null;
		      var type = this.state.type;
		      switch (type) {
		        case 79:
		          return this.parseSuper();
		        case 83:
		          node = this.startNode();
		          this.next();
		          if (this.match(16)) {
		            return this.parseImportMetaProperty(node);
		          }
		          if (this.match(10)) {
		            if (this.options.createImportExpressions) {
		              return this.parseImportCall(node);
		            } else {
		              return this.finishNode(node, "Import");
		            }
		          } else {
		            this.raise(Errors.UnsupportedImport, this.state.lastTokStartLoc);
		            return this.finishNode(node, "Import");
		          }
		        case 78:
		          node = this.startNode();
		          this.next();
		          return this.finishNode(node, "ThisExpression");
		        case 90:
		          {
		            return this.parseDo(this.startNode(), false);
		          }
		        case 56:
		        case 31:
		          {
		            this.readRegexp();
		            return this.parseRegExpLiteral(this.state.value);
		          }
		        case 134:
		          return this.parseNumericLiteral(this.state.value);
		        case 135:
		          return this.parseBigIntLiteral(this.state.value);
		        case 136:
		          return this.parseDecimalLiteral(this.state.value);
		        case 133:
		          return this.parseStringLiteral(this.state.value);
		        case 84:
		          return this.parseNullLiteral();
		        case 85:
		          return this.parseBooleanLiteral(true);
		        case 86:
		          return this.parseBooleanLiteral(false);
		        case 10:
		          {
		            var canBeArrow = this.state.potentialArrowAt === this.state.start;
		            return this.parseParenAndDistinguishExpression(canBeArrow);
		          }
		        case 2:
		        case 1:
		          {
		            return this.parseArrayLike(this.state.type === 2 ? 4 : 3, false, true);
		          }
		        case 0:
		          {
		            return this.parseArrayLike(3, true, false, refExpressionErrors);
		          }
		        case 6:
		        case 7:
		          {
		            return this.parseObjectLike(this.state.type === 6 ? 9 : 8, false, true);
		          }
		        case 5:
		          {
		            return this.parseObjectLike(8, false, false, refExpressionErrors);
		          }
		        case 68:
		          return this.parseFunctionOrFunctionSent();
		        case 26:
		          decorators = this.parseDecorators();
		        case 80:
		          return this.parseClass(this.maybeTakeDecorators(decorators, this.startNode()), false);
		        case 77:
		          return this.parseNewOrNewTarget();
		        case 25:
		        case 24:
		          return this.parseTemplate(false);
		        case 15:
		          {
		            node = this.startNode();
		            this.next();
		            node.object = null;
		            var callee = node.callee = this.parseNoCallExpr();
		            if (callee.type === "MemberExpression") {
		              return this.finishNode(node, "BindExpression");
		            } else {
		              throw this.raise(Errors.UnsupportedBind, callee);
		            }
		          }
		        case 138:
		          {
		            this.raise(Errors.PrivateInExpectedIn, this.state.startLoc, {
		              identifierName: this.state.value
		            });
		            return this.parsePrivateName();
		          }
		        case 33:
		          {
		            return this.parseTopicReferenceThenEqualsSign(54, "%");
		          }
		        case 32:
		          {
		            return this.parseTopicReferenceThenEqualsSign(44, "^");
		          }
		        case 37:
		        case 38:
		          {
		            return this.parseTopicReference("hack");
		          }
		        case 44:
		        case 54:
		        case 27:
		          {
		            var pipeProposal = this.getPluginOption("pipelineOperator", "proposal");
		            if (pipeProposal) {
		              return this.parseTopicReference(pipeProposal);
		            }
		            this.unexpected();
		            break;
		          }
		        case 47:
		          {
		            var lookaheadCh = this.input.codePointAt(this.nextTokenStart());
		            if (isIdentifierStart(lookaheadCh) || lookaheadCh === 62) {
		              this.expectOnePlugin(["jsx", "flow", "typescript"]);
		            } else {
		              this.unexpected();
		            }
		            break;
		          }
		        default:
		          if (tokenIsIdentifier(type)) {
		            if (this.isContextual(127) && this.lookaheadInLineCharCode() === 123) {
		              return this.parseModuleExpression();
		            }
		            var _canBeArrow = this.state.potentialArrowAt === this.state.start;
		            var containsEsc = this.state.containsEsc;
		            var id = this.parseIdentifier();
		            if (!containsEsc && id.name === "async" && !this.canInsertSemicolon()) {
		              var _type = this.state.type;
		              if (_type === 68) {
		                this.resetPreviousNodeTrailingComments(id);
		                this.next();
		                return this.parseAsyncFunctionExpression(this.startNodeAtNode(id));
		              } else if (tokenIsIdentifier(_type)) {
		                if (this.lookaheadCharCode() === 61) {
		                  return this.parseAsyncArrowUnaryFunction(this.startNodeAtNode(id));
		                } else {
		                  return id;
		                }
		              } else if (_type === 90) {
		                this.resetPreviousNodeTrailingComments(id);
		                return this.parseDo(this.startNodeAtNode(id), true);
		              }
		            }
		            if (_canBeArrow && this.match(19) && !this.canInsertSemicolon()) {
		              this.next();
		              return this.parseArrowExpression(this.startNodeAtNode(id), [id], false);
		            }
		            return id;
		          } else {
		            this.unexpected();
		          }
		      }
		    };
		    _proto.parseTopicReferenceThenEqualsSign = function parseTopicReferenceThenEqualsSign(topicTokenType, topicTokenValue) {
		      var pipeProposal = this.getPluginOption("pipelineOperator", "proposal");
		      if (pipeProposal) {
		        this.state.type = topicTokenType;
		        this.state.value = topicTokenValue;
		        this.state.pos--;
		        this.state.end--;
		        this.state.endLoc = createPositionWithColumnOffset(this.state.endLoc, -1);
		        return this.parseTopicReference(pipeProposal);
		      } else {
		        this.unexpected();
		      }
		    };
		    _proto.parseTopicReference = function parseTopicReference(pipeProposal) {
		      var node = this.startNode();
		      var startLoc = this.state.startLoc;
		      var tokenType = this.state.type;
		      this.next();
		      return this.finishTopicReference(node, startLoc, pipeProposal, tokenType);
		    };
		    _proto.finishTopicReference = function finishTopicReference(node, startLoc, pipeProposal, tokenType) {
		      if (this.testTopicReferenceConfiguration(pipeProposal, startLoc, tokenType)) {
		        var nodeType = pipeProposal === "smart" ? "PipelinePrimaryTopicReference" : "TopicReference";
		        if (!this.topicReferenceIsAllowedInCurrentContext()) {
		          this.raise(pipeProposal === "smart" ? Errors.PrimaryTopicNotAllowed : Errors.PipeTopicUnbound, startLoc);
		        }
		        this.registerTopicReference();
		        return this.finishNode(node, nodeType);
		      } else {
		        throw this.raise(Errors.PipeTopicUnconfiguredToken, startLoc, {
		          token: tokenLabelName(tokenType)
		        });
		      }
		    };
		    _proto.testTopicReferenceConfiguration = function testTopicReferenceConfiguration(pipeProposal, startLoc, tokenType) {
		      switch (pipeProposal) {
		        case "hack":
		          {
		            return this.hasPlugin(["pipelineOperator", {
		              topicToken: tokenLabelName(tokenType)
		            }]);
		          }
		        case "smart":
		          return tokenType === 27;
		        default:
		          throw this.raise(Errors.PipeTopicRequiresHackPipes, startLoc);
		      }
		    };
		    _proto.parseAsyncArrowUnaryFunction = function parseAsyncArrowUnaryFunction(node) {
		      this.prodParam.enter(functionFlags(true, this.prodParam.hasYield));
		      var params = [this.parseIdentifier()];
		      this.prodParam.exit();
		      if (this.hasPrecedingLineBreak()) {
		        this.raise(Errors.LineTerminatorBeforeArrow, this.state.curPosition());
		      }
		      this.expect(19);
		      return this.parseArrowExpression(node, params, true);
		    };
		    _proto.parseDo = function parseDo(node, isAsync) {
		      this.expectPlugin("doExpressions");
		      if (isAsync) {
		        this.expectPlugin("asyncDoExpressions");
		      }
		      node.async = isAsync;
		      this.next();
		      var oldLabels = this.state.labels;
		      this.state.labels = [];
		      if (isAsync) {
		        this.prodParam.enter(ParamKind.PARAM_AWAIT);
		        node.body = this.parseBlock();
		        this.prodParam.exit();
		      } else {
		        node.body = this.parseBlock();
		      }
		      this.state.labels = oldLabels;
		      return this.finishNode(node, "DoExpression");
		    };
		    _proto.parseSuper = function parseSuper() {
		      var node = this.startNode();
		      this.next();
		      if (this.match(10) && !this.scope.allowDirectSuper && !this.options.allowSuperOutsideMethod) {
		        this.raise(Errors.SuperNotAllowed, node);
		      } else if (!this.scope.allowSuper && !this.options.allowSuperOutsideMethod) {
		        this.raise(Errors.UnexpectedSuper, node);
		      }
		      if (!this.match(10) && !this.match(0) && !this.match(16)) {
		        this.raise(Errors.UnsupportedSuper, node);
		      }
		      return this.finishNode(node, "Super");
		    };
		    _proto.parsePrivateName = function parsePrivateName() {
		      var node = this.startNode();
		      var id = this.startNodeAt(createPositionWithColumnOffset(this.state.startLoc, 1));
		      var name = this.state.value;
		      this.next();
		      node.id = this.createIdentifier(id, name);
		      return this.finishNode(node, "PrivateName");
		    };
		    _proto.parseFunctionOrFunctionSent = function parseFunctionOrFunctionSent() {
		      var node = this.startNode();
		      this.next();
		      if (this.prodParam.hasYield && this.match(16)) {
		        var meta = this.createIdentifier(this.startNodeAtNode(node), "function");
		        this.next();
		        if (this.match(103)) {
		          this.expectPlugin("functionSent");
		        } else if (!this.hasPlugin("functionSent")) {
		          this.unexpected();
		        }
		        return this.parseMetaProperty(node, meta, "sent");
		      }
		      return this.parseFunction(node);
		    };
		    _proto.parseMetaProperty = function parseMetaProperty(node, meta, propertyName) {
		      node.meta = meta;
		      var containsEsc = this.state.containsEsc;
		      node.property = this.parseIdentifier(true);
		      if (node.property.name !== propertyName || containsEsc) {
		        this.raise(Errors.UnsupportedMetaProperty, node.property, {
		          target: meta.name,
		          onlyValidPropertyName: propertyName
		        });
		      }
		      return this.finishNode(node, "MetaProperty");
		    };
		    _proto.parseImportMetaProperty = function parseImportMetaProperty(node) {
		      var id = this.createIdentifier(this.startNodeAtNode(node), "import");
		      this.next();
		      if (this.isContextual(101)) {
		        if (!this.inModule) {
		          this.raise(Errors.ImportMetaOutsideModule, id);
		        }
		        this.sawUnambiguousESM = true;
		      } else if (this.isContextual(105) || this.isContextual(97)) {
		        var isSource = this.isContextual(105);
		        if (!isSource) this.unexpected();
		        this.expectPlugin(isSource ? "sourcePhaseImports" : "deferredImportEvaluation");
		        if (!this.options.createImportExpressions) {
		          throw this.raise(Errors.DynamicImportPhaseRequiresImportExpressions, this.state.startLoc, {
		            phase: this.state.value
		          });
		        }
		        this.next();
		        node.phase = isSource ? "source" : "defer";
		        return this.parseImportCall(node);
		      }
		      return this.parseMetaProperty(node, id, "meta");
		    };
		    _proto.parseLiteralAtNode = function parseLiteralAtNode(value, type, node) {
		      this.addExtra(node, "rawValue", value);
		      this.addExtra(node, "raw", this.input.slice(node.start, this.state.end));
		      node.value = value;
		      this.next();
		      return this.finishNode(node, type);
		    };
		    _proto.parseLiteral = function parseLiteral(value, type) {
		      var node = this.startNode();
		      return this.parseLiteralAtNode(value, type, node);
		    };
		    _proto.parseStringLiteral = function parseStringLiteral(value) {
		      return this.parseLiteral(value, "StringLiteral");
		    };
		    _proto.parseNumericLiteral = function parseNumericLiteral(value) {
		      return this.parseLiteral(value, "NumericLiteral");
		    };
		    _proto.parseBigIntLiteral = function parseBigIntLiteral(value) {
		      return this.parseLiteral(value, "BigIntLiteral");
		    };
		    _proto.parseDecimalLiteral = function parseDecimalLiteral(value) {
		      return this.parseLiteral(value, "DecimalLiteral");
		    };
		    _proto.parseRegExpLiteral = function parseRegExpLiteral(value) {
		      var node = this.parseLiteral(value.value, "RegExpLiteral");
		      node.pattern = value.pattern;
		      node.flags = value.flags;
		      return node;
		    };
		    _proto.parseBooleanLiteral = function parseBooleanLiteral(value) {
		      var node = this.startNode();
		      node.value = value;
		      this.next();
		      return this.finishNode(node, "BooleanLiteral");
		    };
		    _proto.parseNullLiteral = function parseNullLiteral() {
		      var node = this.startNode();
		      this.next();
		      return this.finishNode(node, "NullLiteral");
		    };
		    _proto.parseParenAndDistinguishExpression = function parseParenAndDistinguishExpression(canBeArrow) {
		      var startLoc = this.state.startLoc;
		      var val;
		      this.next();
		      this.expressionScope.enter(newArrowHeadScope());
		      var oldMaybeInArrowParameters = this.state.maybeInArrowParameters;
		      var oldInFSharpPipelineDirectBody = this.state.inFSharpPipelineDirectBody;
		      this.state.maybeInArrowParameters = true;
		      this.state.inFSharpPipelineDirectBody = false;
		      var innerStartLoc = this.state.startLoc;
		      var exprList = [];
		      var refExpressionErrors = new ExpressionErrors();
		      var first = true;
		      var spreadStartLoc;
		      var optionalCommaStartLoc;
		      while (!this.match(11)) {
		        if (first) {
		          first = false;
		        } else {
		          this.expect(12, refExpressionErrors.optionalParametersLoc === null ? null : refExpressionErrors.optionalParametersLoc);
		          if (this.match(11)) {
		            optionalCommaStartLoc = this.state.startLoc;
		            break;
		          }
		        }
		        if (this.match(21)) {
		          var spreadNodeStartLoc = this.state.startLoc;
		          spreadStartLoc = this.state.startLoc;
		          exprList.push(this.parseParenItem(this.parseRestBinding(), spreadNodeStartLoc));
		          if (!this.checkCommaAfterRest(41)) {
		            break;
		          }
		        } else {
		          exprList.push(this.parseMaybeAssignAllowIn(refExpressionErrors, this.parseParenItem));
		        }
		      }
		      var innerEndLoc = this.state.lastTokEndLoc;
		      this.expect(11);
		      this.state.maybeInArrowParameters = oldMaybeInArrowParameters;
		      this.state.inFSharpPipelineDirectBody = oldInFSharpPipelineDirectBody;
		      var arrowNode = this.startNodeAt(startLoc);
		      if (canBeArrow && this.shouldParseArrow(exprList) && (arrowNode = this.parseArrow(arrowNode))) {
		        this.checkDestructuringPrivate(refExpressionErrors);
		        this.expressionScope.validateAsPattern();
		        this.expressionScope.exit();
		        this.parseArrowExpression(arrowNode, exprList, false);
		        return arrowNode;
		      }
		      this.expressionScope.exit();
		      if (!exprList.length) {
		        this.unexpected(this.state.lastTokStartLoc);
		      }
		      if (optionalCommaStartLoc) this.unexpected(optionalCommaStartLoc);
		      if (spreadStartLoc) this.unexpected(spreadStartLoc);
		      this.checkExpressionErrors(refExpressionErrors, true);
		      this.toReferencedListDeep(exprList, true);
		      if (exprList.length > 1) {
		        val = this.startNodeAt(innerStartLoc);
		        val.expressions = exprList;
		        this.finishNode(val, "SequenceExpression");
		        this.resetEndLocation(val, innerEndLoc);
		      } else {
		        val = exprList[0];
		      }
		      return this.wrapParenthesis(startLoc, val);
		    };
		    _proto.wrapParenthesis = function wrapParenthesis(startLoc, expression) {
		      if (!this.options.createParenthesizedExpressions) {
		        this.addExtra(expression, "parenthesized", true);
		        this.addExtra(expression, "parenStart", startLoc.index);
		        this.takeSurroundingComments(expression, startLoc.index, this.state.lastTokEndLoc.index);
		        return expression;
		      }
		      var parenExpression = this.startNodeAt(startLoc);
		      parenExpression.expression = expression;
		      return this.finishNode(parenExpression, "ParenthesizedExpression");
		    };
		    _proto.shouldParseArrow = function shouldParseArrow(params) {
		      return !this.canInsertSemicolon();
		    };
		    _proto.parseArrow = function parseArrow(node) {
		      if (this.eat(19)) {
		        return node;
		      }
		    };
		    _proto.parseParenItem = function parseParenItem(node, startLoc) {
		      return node;
		    };
		    _proto.parseNewOrNewTarget = function parseNewOrNewTarget() {
		      var node = this.startNode();
		      this.next();
		      if (this.match(16)) {
		        var meta = this.createIdentifier(this.startNodeAtNode(node), "new");
		        this.next();
		        var metaProp = this.parseMetaProperty(node, meta, "target");
		        if (!this.scope.inNonArrowFunction && !this.scope.inClass && !this.options.allowNewTargetOutsideFunction) {
		          this.raise(Errors.UnexpectedNewTarget, metaProp);
		        }
		        return metaProp;
		      }
		      return this.parseNew(node);
		    };
		    _proto.parseNew = function parseNew(node) {
		      this.parseNewCallee(node);
		      if (this.eat(10)) {
		        var args = this.parseExprList(11);
		        this.toReferencedList(args);
		        node.arguments = args;
		      } else {
		        node.arguments = [];
		      }
		      return this.finishNode(node, "NewExpression");
		    };
		    _proto.parseNewCallee = function parseNewCallee(node) {
		      var isImport = this.match(83);
		      var callee = this.parseNoCallExpr();
		      node.callee = callee;
		      if (isImport && (callee.type === "Import" || callee.type === "ImportExpression")) {
		        this.raise(Errors.ImportCallNotNewExpression, callee);
		      }
		    };
		    _proto.parseTemplateElement = function parseTemplateElement(isTagged) {
		      var _this$state = this.state,
		        start = _this$state.start,
		        startLoc = _this$state.startLoc,
		        end = _this$state.end,
		        value = _this$state.value;
		      var elemStart = start + 1;
		      var elem = this.startNodeAt(createPositionWithColumnOffset(startLoc, 1));
		      if (value === null) {
		        if (!isTagged) {
		          this.raise(Errors.InvalidEscapeSequenceTemplate, createPositionWithColumnOffset(this.state.firstInvalidTemplateEscapePos, 1));
		        }
		      }
		      var isTail = this.match(24);
		      var endOffset = isTail ? -1 : -2;
		      var elemEnd = end + endOffset;
		      elem.value = {
		        raw: this.input.slice(elemStart, elemEnd).replace(/\r\n?/g, "\n"),
		        cooked: value === null ? null : value.slice(1, endOffset)
		      };
		      elem.tail = isTail;
		      this.next();
		      var finishedNode = this.finishNode(elem, "TemplateElement");
		      this.resetEndLocation(finishedNode, createPositionWithColumnOffset(this.state.lastTokEndLoc, endOffset));
		      return finishedNode;
		    };
		    _proto.parseTemplate = function parseTemplate(isTagged) {
		      var node = this.startNode();
		      var curElt = this.parseTemplateElement(isTagged);
		      var quasis = [curElt];
		      var substitutions = [];
		      while (!curElt.tail) {
		        substitutions.push(this.parseTemplateSubstitution());
		        this.readTemplateContinuation();
		        quasis.push(curElt = this.parseTemplateElement(isTagged));
		      }
		      node.expressions = substitutions;
		      node.quasis = quasis;
		      return this.finishNode(node, "TemplateLiteral");
		    };
		    _proto.parseTemplateSubstitution = function parseTemplateSubstitution() {
		      return this.parseExpression();
		    };
		    _proto.parseObjectLike = function parseObjectLike(close, isPattern, isRecord, refExpressionErrors) {
		      if (isRecord) {
		        this.expectPlugin("recordAndTuple");
		      }
		      var oldInFSharpPipelineDirectBody = this.state.inFSharpPipelineDirectBody;
		      this.state.inFSharpPipelineDirectBody = false;
		      var propHash = Object.create(null);
		      var first = true;
		      var node = this.startNode();
		      node.properties = [];
		      this.next();
		      while (!this.match(close)) {
		        if (first) {
		          first = false;
		        } else {
		          this.expect(12);
		          if (this.match(close)) {
		            this.addTrailingCommaExtraToNode(node);
		            break;
		          }
		        }
		        var prop = void 0;
		        if (isPattern) {
		          prop = this.parseBindingProperty();
		        } else {
		          prop = this.parsePropertyDefinition(refExpressionErrors);
		          this.checkProto(prop, isRecord, propHash, refExpressionErrors);
		        }
		        if (isRecord && !this.isObjectProperty(prop) && prop.type !== "SpreadElement") {
		          this.raise(Errors.InvalidRecordProperty, prop);
		        }
		        if (prop.shorthand) {
		          this.addExtra(prop, "shorthand", true);
		        }
		        node.properties.push(prop);
		      }
		      this.next();
		      this.state.inFSharpPipelineDirectBody = oldInFSharpPipelineDirectBody;
		      var type = "ObjectExpression";
		      if (isPattern) {
		        type = "ObjectPattern";
		      } else if (isRecord) {
		        type = "RecordExpression";
		      }
		      return this.finishNode(node, type);
		    };
		    _proto.addTrailingCommaExtraToNode = function addTrailingCommaExtraToNode(node) {
		      this.addExtra(node, "trailingComma", this.state.lastTokStartLoc.index);
		      this.addExtra(node, "trailingCommaLoc", this.state.lastTokStartLoc, false);
		    };
		    _proto.maybeAsyncOrAccessorProp = function maybeAsyncOrAccessorProp(prop) {
		      return !prop.computed && prop.key.type === "Identifier" && (this.isLiteralPropertyName() || this.match(0) || this.match(55));
		    };
		    _proto.parsePropertyDefinition = function parsePropertyDefinition(refExpressionErrors) {
		      var decorators = [];
		      if (this.match(26)) {
		        if (this.hasPlugin("decorators")) {
		          this.raise(Errors.UnsupportedPropertyDecorator, this.state.startLoc);
		        }
		        while (this.match(26)) {
		          decorators.push(this.parseDecorator());
		        }
		      }
		      var prop = this.startNode();
		      var isAsync = false;
		      var isAccessor = false;
		      var startLoc;
		      if (this.match(21)) {
		        if (decorators.length) this.unexpected();
		        return this.parseSpread();
		      }
		      if (decorators.length) {
		        prop.decorators = decorators;
		        decorators = [];
		      }
		      prop.method = false;
		      if (refExpressionErrors) {
		        startLoc = this.state.startLoc;
		      }
		      var isGenerator = this.eat(55);
		      this.parsePropertyNamePrefixOperator(prop);
		      var containsEsc = this.state.containsEsc;
		      this.parsePropertyName(prop, refExpressionErrors);
		      if (!isGenerator && !containsEsc && this.maybeAsyncOrAccessorProp(prop)) {
		        var key = prop.key;
		        var keyName = key.name;
		        if (keyName === "async" && !this.hasPrecedingLineBreak()) {
		          isAsync = true;
		          this.resetPreviousNodeTrailingComments(key);
		          isGenerator = this.eat(55);
		          this.parsePropertyName(prop);
		        }
		        if (keyName === "get" || keyName === "set") {
		          isAccessor = true;
		          this.resetPreviousNodeTrailingComments(key);
		          prop.kind = keyName;
		          if (this.match(55)) {
		            isGenerator = true;
		            this.raise(Errors.AccessorIsGenerator, this.state.curPosition(), {
		              kind: keyName
		            });
		            this.next();
		          }
		          this.parsePropertyName(prop);
		        }
		      }
		      return this.parseObjPropValue(prop, startLoc, isGenerator, isAsync, false, isAccessor, refExpressionErrors);
		    };
		    _proto.getGetterSetterExpectedParamCount = function getGetterSetterExpectedParamCount(method) {
		      return method.kind === "get" ? 0 : 1;
		    };
		    _proto.getObjectOrClassMethodParams = function getObjectOrClassMethodParams(method) {
		      return method.params;
		    };
		    _proto.checkGetterSetterParams = function checkGetterSetterParams(method) {
		      var _params;
		      var paramCount = this.getGetterSetterExpectedParamCount(method);
		      var params = this.getObjectOrClassMethodParams(method);
		      if (params.length !== paramCount) {
		        this.raise(method.kind === "get" ? Errors.BadGetterArity : Errors.BadSetterArity, method);
		      }
		      if (method.kind === "set" && ((_params = params[params.length - 1]) == null ? void 0 : _params.type) === "RestElement") {
		        this.raise(Errors.BadSetterRestParameter, method);
		      }
		    };
		    _proto.parseObjectMethod = function parseObjectMethod(prop, isGenerator, isAsync, isPattern, isAccessor) {
		      if (isAccessor) {
		        var finishedProp = this.parseMethod(prop, isGenerator, false, false, false, "ObjectMethod");
		        this.checkGetterSetterParams(finishedProp);
		        return finishedProp;
		      }
		      if (isAsync || isGenerator || this.match(10)) {
		        if (isPattern) this.unexpected();
		        prop.kind = "method";
		        prop.method = true;
		        return this.parseMethod(prop, isGenerator, isAsync, false, false, "ObjectMethod");
		      }
		    };
		    _proto.parseObjectProperty = function parseObjectProperty(prop, startLoc, isPattern, refExpressionErrors) {
		      prop.shorthand = false;
		      if (this.eat(14)) {
		        prop.value = isPattern ? this.parseMaybeDefault(this.state.startLoc) : this.parseMaybeAssignAllowIn(refExpressionErrors);
		        return this.finishNode(prop, "ObjectProperty");
		      }
		      if (!prop.computed && prop.key.type === "Identifier") {
		        this.checkReservedWord(prop.key.name, prop.key.loc.start, true, false);
		        if (isPattern) {
		          prop.value = this.parseMaybeDefault(startLoc, cloneIdentifier(prop.key));
		        } else if (this.match(29)) {
		          var shorthandAssignLoc = this.state.startLoc;
		          if (refExpressionErrors != null) {
		            if (refExpressionErrors.shorthandAssignLoc === null) {
		              refExpressionErrors.shorthandAssignLoc = shorthandAssignLoc;
		            }
		          } else {
		            this.raise(Errors.InvalidCoverInitializedName, shorthandAssignLoc);
		          }
		          prop.value = this.parseMaybeDefault(startLoc, cloneIdentifier(prop.key));
		        } else {
		          prop.value = cloneIdentifier(prop.key);
		        }
		        prop.shorthand = true;
		        return this.finishNode(prop, "ObjectProperty");
		      }
		    };
		    _proto.parseObjPropValue = function parseObjPropValue(prop, startLoc, isGenerator, isAsync, isPattern, isAccessor, refExpressionErrors) {
		      var node = this.parseObjectMethod(prop, isGenerator, isAsync, isPattern, isAccessor) || this.parseObjectProperty(prop, startLoc, isPattern, refExpressionErrors);
		      if (!node) this.unexpected();
		      return node;
		    };
		    _proto.parsePropertyName = function parsePropertyName(prop, refExpressionErrors) {
		      if (this.eat(0)) {
		        prop.computed = true;
		        prop.key = this.parseMaybeAssignAllowIn();
		        this.expect(3);
		      } else {
		        var _this$state2 = this.state,
		          type = _this$state2.type,
		          value = _this$state2.value;
		        var key;
		        if (tokenIsKeywordOrIdentifier(type)) {
		          key = this.parseIdentifier(true);
		        } else {
		          switch (type) {
		            case 134:
		              key = this.parseNumericLiteral(value);
		              break;
		            case 133:
		              key = this.parseStringLiteral(value);
		              break;
		            case 135:
		              key = this.parseBigIntLiteral(value);
		              break;
		            case 136:
		              key = this.parseDecimalLiteral(value);
		              break;
		            case 138:
		              {
		                var privateKeyLoc = this.state.startLoc;
		                if (refExpressionErrors != null) {
		                  if (refExpressionErrors.privateKeyLoc === null) {
		                    refExpressionErrors.privateKeyLoc = privateKeyLoc;
		                  }
		                } else {
		                  this.raise(Errors.UnexpectedPrivateField, privateKeyLoc);
		                }
		                key = this.parsePrivateName();
		                break;
		              }
		            default:
		              this.unexpected();
		          }
		        }
		        prop.key = key;
		        if (type !== 138) {
		          prop.computed = false;
		        }
		      }
		    };
		    _proto.initFunction = function initFunction(node, isAsync) {
		      node.id = null;
		      node.generator = false;
		      node.async = isAsync;
		    };
		    _proto.parseMethod = function parseMethod(node, isGenerator, isAsync, isConstructor, allowDirectSuper, type, inClassScope) {
		      if (inClassScope === void 0) {
		        inClassScope = false;
		      }
		      this.initFunction(node, isAsync);
		      node.generator = isGenerator;
		      this.scope.enter(ScopeFlag.FUNCTION | ScopeFlag.SUPER | (inClassScope ? ScopeFlag.CLASS : 0) | (allowDirectSuper ? ScopeFlag.DIRECT_SUPER : 0));
		      this.prodParam.enter(functionFlags(isAsync, node.generator));
		      this.parseFunctionParams(node, isConstructor);
		      var finishedNode = this.parseFunctionBodyAndFinish(node, type, true);
		      this.prodParam.exit();
		      this.scope.exit();
		      return finishedNode;
		    };
		    _proto.parseArrayLike = function parseArrayLike(close, canBePattern, isTuple, refExpressionErrors) {
		      if (isTuple) {
		        this.expectPlugin("recordAndTuple");
		      }
		      var oldInFSharpPipelineDirectBody = this.state.inFSharpPipelineDirectBody;
		      this.state.inFSharpPipelineDirectBody = false;
		      var node = this.startNode();
		      this.next();
		      node.elements = this.parseExprList(close, !isTuple, refExpressionErrors, node);
		      this.state.inFSharpPipelineDirectBody = oldInFSharpPipelineDirectBody;
		      return this.finishNode(node, isTuple ? "TupleExpression" : "ArrayExpression");
		    };
		    _proto.parseArrowExpression = function parseArrowExpression(node, params, isAsync, trailingCommaLoc) {
		      this.scope.enter(ScopeFlag.FUNCTION | ScopeFlag.ARROW);
		      var flags = functionFlags(isAsync, false);
		      if (!this.match(5) && this.prodParam.hasIn) {
		        flags |= ParamKind.PARAM_IN;
		      }
		      this.prodParam.enter(flags);
		      this.initFunction(node, isAsync);
		      var oldMaybeInArrowParameters = this.state.maybeInArrowParameters;
		      if (params) {
		        this.state.maybeInArrowParameters = true;
		        this.setArrowFunctionParameters(node, params, trailingCommaLoc);
		      }
		      this.state.maybeInArrowParameters = false;
		      this.parseFunctionBody(node, true);
		      this.prodParam.exit();
		      this.scope.exit();
		      this.state.maybeInArrowParameters = oldMaybeInArrowParameters;
		      return this.finishNode(node, "ArrowFunctionExpression");
		    };
		    _proto.setArrowFunctionParameters = function setArrowFunctionParameters(node, params, trailingCommaLoc) {
		      this.toAssignableList(params, trailingCommaLoc, false);
		      node.params = params;
		    };
		    _proto.parseFunctionBodyAndFinish = function parseFunctionBodyAndFinish(node, type, isMethod) {
		      if (isMethod === void 0) {
		        isMethod = false;
		      }
		      this.parseFunctionBody(node, false, isMethod);
		      return this.finishNode(node, type);
		    };
		    _proto.parseFunctionBody = function parseFunctionBody(node, allowExpression, isMethod) {
		      var _this5 = this;
		      if (isMethod === void 0) {
		        isMethod = false;
		      }
		      var isExpression = allowExpression && !this.match(5);
		      this.expressionScope.enter(newExpressionScope());
		      if (isExpression) {
		        node.body = this.parseMaybeAssign();
		        this.checkParams(node, false, allowExpression, false);
		      } else {
		        var oldStrict = this.state.strict;
		        var oldLabels = this.state.labels;
		        this.state.labels = [];
		        this.prodParam.enter(this.prodParam.currentFlags() | ParamKind.PARAM_RETURN);
		        node.body = this.parseBlock(true, false, function (hasStrictModeDirective) {
		          var nonSimple = !_this5.isSimpleParamList(node.params);
		          if (hasStrictModeDirective && nonSimple) {
		            _this5.raise(Errors.IllegalLanguageModeDirective, (node.kind === "method" || node.kind === "constructor") && !!node.key ? node.key.loc.end : node);
		          }
		          var strictModeChanged = !oldStrict && _this5.state.strict;
		          _this5.checkParams(node, !_this5.state.strict && !allowExpression && !isMethod && !nonSimple, allowExpression, strictModeChanged);
		          if (_this5.state.strict && node.id) {
		            _this5.checkIdentifier(node.id, BindingFlag.TYPE_OUTSIDE, strictModeChanged);
		          }
		        });
		        this.prodParam.exit();
		        this.state.labels = oldLabels;
		      }
		      this.expressionScope.exit();
		    };
		    _proto.isSimpleParameter = function isSimpleParameter(node) {
		      return node.type === "Identifier";
		    };
		    _proto.isSimpleParamList = function isSimpleParamList(params) {
		      for (var i = 0, len = params.length; i < len; i++) {
		        if (!this.isSimpleParameter(params[i])) return false;
		      }
		      return true;
		    };
		    _proto.checkParams = function checkParams(node, allowDuplicates, isArrowFunction, strictModeChanged) {
		      if (strictModeChanged === void 0) {
		        strictModeChanged = true;
		      }
		      var checkClashes = !allowDuplicates && new Set();
		      var formalParameters = {
		        type: "FormalParameters"
		      };
		      for (var _i4 = 0, _node$params2 = node.params; _i4 < _node$params2.length; _i4++) {
		        var param = _node$params2[_i4];
		        this.checkLVal(param, {
		          "in": formalParameters,
		          binding: BindingFlag.TYPE_VAR,
		          checkClashes: checkClashes,
		          strictModeChanged: strictModeChanged
		        });
		      }
		    };
		    _proto.parseExprList = function parseExprList(close, allowEmpty, refExpressionErrors, nodeForExtra) {
		      var elts = [];
		      var first = true;
		      while (!this.eat(close)) {
		        if (first) {
		          first = false;
		        } else {
		          this.expect(12);
		          if (this.match(close)) {
		            if (nodeForExtra) {
		              this.addTrailingCommaExtraToNode(nodeForExtra);
		            }
		            this.next();
		            break;
		          }
		        }
		        elts.push(this.parseExprListItem(allowEmpty, refExpressionErrors));
		      }
		      return elts;
		    };
		    _proto.parseExprListItem = function parseExprListItem(allowEmpty, refExpressionErrors, allowPlaceholder) {
		      var elt;
		      if (this.match(12)) {
		        if (!allowEmpty) {
		          this.raise(Errors.UnexpectedToken, this.state.curPosition(), {
		            unexpected: ","
		          });
		        }
		        elt = null;
		      } else if (this.match(21)) {
		        var spreadNodeStartLoc = this.state.startLoc;
		        elt = this.parseParenItem(this.parseSpread(refExpressionErrors), spreadNodeStartLoc);
		      } else if (this.match(17)) {
		        this.expectPlugin("partialApplication");
		        if (!allowPlaceholder) {
		          this.raise(Errors.UnexpectedArgumentPlaceholder, this.state.startLoc);
		        }
		        var _node6 = this.startNode();
		        this.next();
		        elt = this.finishNode(_node6, "ArgumentPlaceholder");
		      } else {
		        elt = this.parseMaybeAssignAllowIn(refExpressionErrors, this.parseParenItem);
		      }
		      return elt;
		    };
		    _proto.parseIdentifier = function parseIdentifier(liberal) {
		      var node = this.startNode();
		      var name = this.parseIdentifierName(liberal);
		      return this.createIdentifier(node, name);
		    };
		    _proto.createIdentifier = function createIdentifier(node, name) {
		      node.name = name;
		      node.loc.identifierName = name;
		      return this.finishNode(node, "Identifier");
		    };
		    _proto.parseIdentifierName = function parseIdentifierName(liberal) {
		      var name;
		      var _this$state3 = this.state,
		        startLoc = _this$state3.startLoc,
		        type = _this$state3.type;
		      if (tokenIsKeywordOrIdentifier(type)) {
		        name = this.state.value;
		      } else {
		        this.unexpected();
		      }
		      var tokenIsKeyword = tokenKeywordOrIdentifierIsKeyword(type);
		      if (liberal) {
		        if (tokenIsKeyword) {
		          this.replaceToken(132);
		        }
		      } else {
		        this.checkReservedWord(name, startLoc, tokenIsKeyword, false);
		      }
		      this.next();
		      return name;
		    };
		    _proto.checkReservedWord = function checkReservedWord(word, startLoc, checkKeywords, isBinding) {
		      if (word.length > 10) {
		        return;
		      }
		      if (!canBeReservedWord(word)) {
		        return;
		      }
		      if (checkKeywords && isKeyword(word)) {
		        this.raise(Errors.UnexpectedKeyword, startLoc, {
		          keyword: word
		        });
		        return;
		      }
		      var reservedTest = !this.state.strict ? isReservedWord : isBinding ? isStrictBindReservedWord : isStrictReservedWord;
		      if (reservedTest(word, this.inModule)) {
		        this.raise(Errors.UnexpectedReservedWord, startLoc, {
		          reservedWord: word
		        });
		        return;
		      } else if (word === "yield") {
		        if (this.prodParam.hasYield) {
		          this.raise(Errors.YieldBindingIdentifier, startLoc);
		          return;
		        }
		      } else if (word === "await") {
		        if (this.prodParam.hasAwait) {
		          this.raise(Errors.AwaitBindingIdentifier, startLoc);
		          return;
		        }
		        if (this.scope.inStaticBlock) {
		          this.raise(Errors.AwaitBindingIdentifierInStaticBlock, startLoc);
		          return;
		        }
		        this.expressionScope.recordAsyncArrowParametersError(startLoc);
		      } else if (word === "arguments") {
		        if (this.scope.inClassAndNotInNonArrowFunction) {
		          this.raise(Errors.ArgumentsInClass, startLoc);
		          return;
		        }
		      }
		    };
		    _proto.isAwaitAllowed = function isAwaitAllowed() {
		      if (this.prodParam.hasAwait) return true;
		      if (this.options.allowAwaitOutsideFunction && !this.scope.inFunction) {
		        return true;
		      }
		      return false;
		    };
		    _proto.parseAwait = function parseAwait(startLoc) {
		      var node = this.startNodeAt(startLoc);
		      this.expressionScope.recordParameterInitializerError(Errors.AwaitExpressionFormalParameter, node);
		      if (this.eat(55)) {
		        this.raise(Errors.ObsoleteAwaitStar, node);
		      }
		      if (!this.scope.inFunction && !this.options.allowAwaitOutsideFunction) {
		        if (this.isAmbiguousAwait()) {
		          this.ambiguousScriptDifferentAst = true;
		        } else {
		          this.sawUnambiguousESM = true;
		        }
		      }
		      if (!this.state.soloAwait) {
		        node.argument = this.parseMaybeUnary(null, true);
		      }
		      return this.finishNode(node, "AwaitExpression");
		    };
		    _proto.isAmbiguousAwait = function isAmbiguousAwait() {
		      if (this.hasPrecedingLineBreak()) return true;
		      var type = this.state.type;
		      return type === 53 || type === 10 || type === 0 || tokenIsTemplate(type) || type === 102 && !this.state.containsEsc || type === 137 || type === 56 || this.hasPlugin("v8intrinsic") && type === 54;
		    };
		    _proto.parseYield = function parseYield() {
		      var node = this.startNode();
		      this.expressionScope.recordParameterInitializerError(Errors.YieldInParameter, node);
		      this.next();
		      var delegating = false;
		      var argument = null;
		      if (!this.hasPrecedingLineBreak()) {
		        delegating = this.eat(55);
		        switch (this.state.type) {
		          case 13:
		          case 139:
		          case 8:
		          case 11:
		          case 3:
		          case 9:
		          case 14:
		          case 12:
		            if (!delegating) break;
		          default:
		            argument = this.parseMaybeAssign();
		        }
		      }
		      node.delegate = delegating;
		      node.argument = argument;
		      return this.finishNode(node, "YieldExpression");
		    };
		    _proto.parseImportCall = function parseImportCall(node) {
		      this.next();
		      node.source = this.parseMaybeAssignAllowIn();
		      if (this.hasPlugin("importAttributes") || this.hasPlugin("importAssertions")) {
		        node.options = null;
		      }
		      if (this.eat(12)) {
		        this.expectImportAttributesPlugin();
		        if (!this.match(11)) {
		          node.options = this.parseMaybeAssignAllowIn();
		          this.eat(12);
		        }
		      }
		      this.expect(11);
		      return this.finishNode(node, "ImportExpression");
		    };
		    _proto.checkPipelineAtInfixOperator = function checkPipelineAtInfixOperator(left, leftStartLoc) {
		      if (this.hasPlugin(["pipelineOperator", {
		        proposal: "smart"
		      }])) {
		        if (left.type === "SequenceExpression") {
		          this.raise(Errors.PipelineHeadSequenceExpression, leftStartLoc);
		        }
		      }
		    };
		    _proto.parseSmartPipelineBodyInStyle = function parseSmartPipelineBodyInStyle(childExpr, startLoc) {
		      if (this.isSimpleReference(childExpr)) {
		        var bodyNode = this.startNodeAt(startLoc);
		        bodyNode.callee = childExpr;
		        return this.finishNode(bodyNode, "PipelineBareFunction");
		      } else {
		        var _bodyNode = this.startNodeAt(startLoc);
		        this.checkSmartPipeTopicBodyEarlyErrors(startLoc);
		        _bodyNode.expression = childExpr;
		        return this.finishNode(_bodyNode, "PipelineTopicExpression");
		      }
		    };
		    _proto.isSimpleReference = function isSimpleReference(expression) {
		      switch (expression.type) {
		        case "MemberExpression":
		          return !expression.computed && this.isSimpleReference(expression.object);
		        case "Identifier":
		          return true;
		        default:
		          return false;
		      }
		    };
		    _proto.checkSmartPipeTopicBodyEarlyErrors = function checkSmartPipeTopicBodyEarlyErrors(startLoc) {
		      if (this.match(19)) {
		        throw this.raise(Errors.PipelineBodyNoArrow, this.state.startLoc);
		      }
		      if (!this.topicReferenceWasUsedInCurrentContext()) {
		        this.raise(Errors.PipelineTopicUnused, startLoc);
		      }
		    };
		    _proto.withTopicBindingContext = function withTopicBindingContext(callback) {
		      var outerContextTopicState = this.state.topicContext;
		      this.state.topicContext = {
		        maxNumOfResolvableTopics: 1,
		        maxTopicIndex: null
		      };
		      try {
		        return callback();
		      } finally {
		        this.state.topicContext = outerContextTopicState;
		      }
		    };
		    _proto.withSmartMixTopicForbiddingContext = function withSmartMixTopicForbiddingContext(callback) {
		      if (this.hasPlugin(["pipelineOperator", {
		        proposal: "smart"
		      }])) {
		        var outerContextTopicState = this.state.topicContext;
		        this.state.topicContext = {
		          maxNumOfResolvableTopics: 0,
		          maxTopicIndex: null
		        };
		        try {
		          return callback();
		        } finally {
		          this.state.topicContext = outerContextTopicState;
		        }
		      } else {
		        return callback();
		      }
		    };
		    _proto.withSoloAwaitPermittingContext = function withSoloAwaitPermittingContext(callback) {
		      var outerContextSoloAwaitState = this.state.soloAwait;
		      this.state.soloAwait = true;
		      try {
		        return callback();
		      } finally {
		        this.state.soloAwait = outerContextSoloAwaitState;
		      }
		    };
		    _proto.allowInAnd = function allowInAnd(callback) {
		      var flags = this.prodParam.currentFlags();
		      var prodParamToSet = ParamKind.PARAM_IN & ~flags;
		      if (prodParamToSet) {
		        this.prodParam.enter(flags | ParamKind.PARAM_IN);
		        try {
		          return callback();
		        } finally {
		          this.prodParam.exit();
		        }
		      }
		      return callback();
		    };
		    _proto.disallowInAnd = function disallowInAnd(callback) {
		      var flags = this.prodParam.currentFlags();
		      var prodParamToClear = ParamKind.PARAM_IN & flags;
		      if (prodParamToClear) {
		        this.prodParam.enter(flags & ~ParamKind.PARAM_IN);
		        try {
		          return callback();
		        } finally {
		          this.prodParam.exit();
		        }
		      }
		      return callback();
		    };
		    _proto.registerTopicReference = function registerTopicReference() {
		      this.state.topicContext.maxTopicIndex = 0;
		    };
		    _proto.topicReferenceIsAllowedInCurrentContext = function topicReferenceIsAllowedInCurrentContext() {
		      return this.state.topicContext.maxNumOfResolvableTopics >= 1;
		    };
		    _proto.topicReferenceWasUsedInCurrentContext = function topicReferenceWasUsedInCurrentContext() {
		      return this.state.topicContext.maxTopicIndex != null && this.state.topicContext.maxTopicIndex >= 0;
		    };
		    _proto.parseFSharpPipelineBody = function parseFSharpPipelineBody(prec) {
		      var startLoc = this.state.startLoc;
		      this.state.potentialArrowAt = this.state.start;
		      var oldInFSharpPipelineDirectBody = this.state.inFSharpPipelineDirectBody;
		      this.state.inFSharpPipelineDirectBody = true;
		      var ret = this.parseExprOp(this.parseMaybeUnaryOrPrivate(), startLoc, prec);
		      this.state.inFSharpPipelineDirectBody = oldInFSharpPipelineDirectBody;
		      return ret;
		    };
		    _proto.parseModuleExpression = function parseModuleExpression() {
		      this.expectPlugin("moduleBlocks");
		      var node = this.startNode();
		      this.next();
		      if (!this.match(5)) {
		        this.unexpected(null, 5);
		      }
		      var program = this.startNodeAt(this.state.endLoc);
		      this.next();
		      var revertScopes = this.initializeScopes(true);
		      this.enterInitialScopes();
		      try {
		        node.body = this.parseProgram(program, 8, "module");
		      } finally {
		        revertScopes();
		      }
		      return this.finishNode(node, "ModuleExpression");
		    };
		    _proto.parsePropertyNamePrefixOperator = function parsePropertyNamePrefixOperator(prop) {};
		    return _createClass(ExpressionParser);
		  }(LValParser);

		  var loopLabel = {
		      kind: LoopLabelKind.Loop
		    },
		    switchLabel = {
		      kind: LoopLabelKind.Switch
		    };
		  var ParseFunctionFlag = {
		    Expression: 0,
		    Declaration: 1,
		    HangingDeclaration: 2,
		    NullableId: 4,
		    Async: 8
		  };
		  var ParseStatementFlag = {
		    StatementOnly: 0,
		    AllowImportExport: 1,
		    AllowDeclaration: 2,
		    AllowFunctionDeclaration: 4,
		    AllowLabeledFunction: 8
		  };
		  var loneSurrogate = /(?:[\uD800-\uDBFF](?![\uDC00-\uDFFF])|(?:[^\uD800-\uDBFF]|^)[\uDC00-\uDFFF])/;
		  var keywordRelationalOperator = new RegExp("in(?:stanceof)?", "y");
		  function babel7CompatTokens(tokens, input) {
		    for (var i = 0; i < tokens.length; i++) {
		      var token = tokens[i];
		      var type = token.type;
		      if (typeof type === "number") {
		        {
		          if (type === 138) {
		            var loc = token.loc,
		              start = token.start,
		              value = token.value,
		              end = token.end;
		            var hashEndPos = start + 1;
		            var hashEndLoc = createPositionWithColumnOffset(loc.start, 1);
		            tokens.splice(i, 1, new Token({
		              type: getExportedToken(27),
		              value: "#",
		              start: start,
		              end: hashEndPos,
		              startLoc: loc.start,
		              endLoc: hashEndLoc
		            }), new Token({
		              type: getExportedToken(132),
		              value: value,
		              start: hashEndPos,
		              end: end,
		              startLoc: hashEndLoc,
		              endLoc: loc.end
		            }));
		            i++;
		            continue;
		          }
		          if (tokenIsTemplate(type)) {
		            var _loc = token.loc,
		              _start = token.start,
		              _value = token.value,
		              _end = token.end;
		            var backquoteEnd = _start + 1;
		            var backquoteEndLoc = createPositionWithColumnOffset(_loc.start, 1);
		            var startToken = void 0;
		            if (input.charCodeAt(_start) === 96) {
		              startToken = new Token({
		                type: getExportedToken(22),
		                value: "`",
		                start: _start,
		                end: backquoteEnd,
		                startLoc: _loc.start,
		                endLoc: backquoteEndLoc
		              });
		            } else {
		              startToken = new Token({
		                type: getExportedToken(8),
		                value: "}",
		                start: _start,
		                end: backquoteEnd,
		                startLoc: _loc.start,
		                endLoc: backquoteEndLoc
		              });
		            }
		            var templateValue = void 0,
		              templateElementEnd = void 0,
		              templateElementEndLoc = void 0,
		              endToken = void 0;
		            if (type === 24) {
		              templateElementEnd = _end - 1;
		              templateElementEndLoc = createPositionWithColumnOffset(_loc.end, -1);
		              templateValue = _value === null ? null : _value.slice(1, -1);
		              endToken = new Token({
		                type: getExportedToken(22),
		                value: "`",
		                start: templateElementEnd,
		                end: _end,
		                startLoc: templateElementEndLoc,
		                endLoc: _loc.end
		              });
		            } else {
		              templateElementEnd = _end - 2;
		              templateElementEndLoc = createPositionWithColumnOffset(_loc.end, -2);
		              templateValue = _value === null ? null : _value.slice(1, -2);
		              endToken = new Token({
		                type: getExportedToken(23),
		                value: "${",
		                start: templateElementEnd,
		                end: _end,
		                startLoc: templateElementEndLoc,
		                endLoc: _loc.end
		              });
		            }
		            tokens.splice(i, 1, startToken, new Token({
		              type: getExportedToken(20),
		              value: templateValue,
		              start: backquoteEnd,
		              end: templateElementEnd,
		              startLoc: backquoteEndLoc,
		              endLoc: templateElementEndLoc
		            }), endToken);
		            i += 2;
		            continue;
		          }
		        }
		        token.type = getExportedToken(type);
		      }
		    }
		    return tokens;
		  }
		  var StatementParser = function (_ExpressionParser) {
		    function StatementParser() {
		      return _ExpressionParser.apply(this, arguments) || this;
		    }
		    _inherits(StatementParser, _ExpressionParser);
		    var _proto = StatementParser.prototype;
		    _proto.parseTopLevel = function parseTopLevel(file, program) {
		      file.program = this.parseProgram(program);
		      file.comments = this.comments;
		      if (this.options.tokens) {
		        file.tokens = babel7CompatTokens(this.tokens, this.input);
		      }
		      return this.finishNode(file, "File");
		    };
		    _proto.parseProgram = function parseProgram(program, end, sourceType) {
		      if (end === void 0) {
		        end = 139;
		      }
		      if (sourceType === void 0) {
		        sourceType = this.options.sourceType;
		      }
		      program.sourceType = sourceType;
		      program.interpreter = this.parseInterpreterDirective();
		      this.parseBlockBody(program, true, true, end);
		      if (this.inModule && !this.options.allowUndeclaredExports && this.scope.undefinedExports.size > 0) {
		        for (var _i2 = 0, _Array$from2 = Array.from(this.scope.undefinedExports); _i2 < _Array$from2.length; _i2++) {
		          var _Array$from2$_i = _Array$from2[_i2],
		            localName = _Array$from2$_i[0],
		            at = _Array$from2$_i[1];
		          this.raise(Errors.ModuleExportUndefined, at, {
		            localName: localName
		          });
		        }
		      }
		      var finishedProgram;
		      if (end === 139) {
		        finishedProgram = this.finishNode(program, "Program");
		      } else {
		        finishedProgram = this.finishNodeAt(program, "Program", createPositionWithColumnOffset(this.state.startLoc, -1));
		      }
		      return finishedProgram;
		    };
		    _proto.stmtToDirective = function stmtToDirective(stmt) {
		      var directive = stmt;
		      directive.type = "Directive";
		      directive.value = directive.expression;
		      delete directive.expression;
		      var directiveLiteral = directive.value;
		      var expressionValue = directiveLiteral.value;
		      var raw = this.input.slice(directiveLiteral.start, directiveLiteral.end);
		      var val = directiveLiteral.value = raw.slice(1, -1);
		      this.addExtra(directiveLiteral, "raw", raw);
		      this.addExtra(directiveLiteral, "rawValue", val);
		      this.addExtra(directiveLiteral, "expressionValue", expressionValue);
		      directiveLiteral.type = "DirectiveLiteral";
		      return directive;
		    };
		    _proto.parseInterpreterDirective = function parseInterpreterDirective() {
		      if (!this.match(28)) {
		        return null;
		      }
		      var node = this.startNode();
		      node.value = this.state.value;
		      this.next();
		      return this.finishNode(node, "InterpreterDirective");
		    };
		    _proto.isLet = function isLet() {
		      if (!this.isContextual(100)) {
		        return false;
		      }
		      return this.hasFollowingBindingAtom();
		    };
		    _proto.chStartsBindingIdentifier = function chStartsBindingIdentifier(ch, pos) {
		      if (isIdentifierStart(ch)) {
		        keywordRelationalOperator.lastIndex = pos;
		        if (keywordRelationalOperator.test(this.input)) {
		          var endCh = this.codePointAtPos(keywordRelationalOperator.lastIndex);
		          if (!isIdentifierChar(endCh) && endCh !== 92) {
		            return false;
		          }
		        }
		        return true;
		      } else if (ch === 92) {
		        return true;
		      } else {
		        return false;
		      }
		    };
		    _proto.chStartsBindingPattern = function chStartsBindingPattern(ch) {
		      return ch === 91 || ch === 123;
		    };
		    _proto.hasFollowingBindingAtom = function hasFollowingBindingAtom() {
		      var next = this.nextTokenStart();
		      var nextCh = this.codePointAtPos(next);
		      return this.chStartsBindingPattern(nextCh) || this.chStartsBindingIdentifier(nextCh, next);
		    };
		    _proto.hasInLineFollowingBindingIdentifier = function hasInLineFollowingBindingIdentifier() {
		      var next = this.nextTokenInLineStart();
		      var nextCh = this.codePointAtPos(next);
		      return this.chStartsBindingIdentifier(nextCh, next);
		    };
		    _proto.startsUsingForOf = function startsUsingForOf() {
		      var _this$lookahead = this.lookahead(),
		        type = _this$lookahead.type,
		        containsEsc = _this$lookahead.containsEsc;
		      if (type === 102 && !containsEsc) {
		        return false;
		      } else if (tokenIsIdentifier(type) && !this.hasFollowingLineBreak()) {
		        this.expectPlugin("explicitResourceManagement");
		        return true;
		      }
		    };
		    _proto.startsAwaitUsing = function startsAwaitUsing() {
		      var next = this.nextTokenInLineStart();
		      if (this.isUnparsedContextual(next, "using")) {
		        next = this.nextTokenInLineStartSince(next + 5);
		        var nextCh = this.codePointAtPos(next);
		        if (this.chStartsBindingIdentifier(nextCh, next)) {
		          this.expectPlugin("explicitResourceManagement");
		          return true;
		        }
		      }
		      return false;
		    };
		    _proto.parseModuleItem = function parseModuleItem() {
		      return this.parseStatementLike(ParseStatementFlag.AllowImportExport | ParseStatementFlag.AllowDeclaration | ParseStatementFlag.AllowFunctionDeclaration | ParseStatementFlag.AllowLabeledFunction);
		    };
		    _proto.parseStatementListItem = function parseStatementListItem() {
		      return this.parseStatementLike(ParseStatementFlag.AllowDeclaration | ParseStatementFlag.AllowFunctionDeclaration | (!this.options.annexB || this.state.strict ? 0 : ParseStatementFlag.AllowLabeledFunction));
		    };
		    _proto.parseStatementOrSloppyAnnexBFunctionDeclaration = function parseStatementOrSloppyAnnexBFunctionDeclaration(allowLabeledFunction) {
		      if (allowLabeledFunction === void 0) {
		        allowLabeledFunction = false;
		      }
		      var flags = ParseStatementFlag.StatementOnly;
		      if (this.options.annexB && !this.state.strict) {
		        flags |= ParseStatementFlag.AllowFunctionDeclaration;
		        if (allowLabeledFunction) {
		          flags |= ParseStatementFlag.AllowLabeledFunction;
		        }
		      }
		      return this.parseStatementLike(flags);
		    };
		    _proto.parseStatement = function parseStatement() {
		      return this.parseStatementLike(ParseStatementFlag.StatementOnly);
		    };
		    _proto.parseStatementLike = function parseStatementLike(flags) {
		      var decorators = null;
		      if (this.match(26)) {
		        decorators = this.parseDecorators(true);
		      }
		      return this.parseStatementContent(flags, decorators);
		    };
		    _proto.parseStatementContent = function parseStatementContent(flags, decorators) {
		      var starttype = this.state.type;
		      var node = this.startNode();
		      var allowDeclaration = !!(flags & ParseStatementFlag.AllowDeclaration);
		      var allowFunctionDeclaration = !!(flags & ParseStatementFlag.AllowFunctionDeclaration);
		      var topLevel = flags & ParseStatementFlag.AllowImportExport;
		      switch (starttype) {
		        case 60:
		          return this.parseBreakContinueStatement(node, true);
		        case 63:
		          return this.parseBreakContinueStatement(node, false);
		        case 64:
		          return this.parseDebuggerStatement(node);
		        case 90:
		          return this.parseDoWhileStatement(node);
		        case 91:
		          return this.parseForStatement(node);
		        case 68:
		          if (this.lookaheadCharCode() === 46) break;
		          if (!allowFunctionDeclaration) {
		            this.raise(this.state.strict ? Errors.StrictFunction : this.options.annexB ? Errors.SloppyFunctionAnnexB : Errors.SloppyFunction, this.state.startLoc);
		          }
		          return this.parseFunctionStatement(node, false, !allowDeclaration && allowFunctionDeclaration);
		        case 80:
		          if (!allowDeclaration) this.unexpected();
		          return this.parseClass(this.maybeTakeDecorators(decorators, node), true);
		        case 69:
		          return this.parseIfStatement(node);
		        case 70:
		          return this.parseReturnStatement(node);
		        case 71:
		          return this.parseSwitchStatement(node);
		        case 72:
		          return this.parseThrowStatement(node);
		        case 73:
		          return this.parseTryStatement(node);
		        case 96:
		          if (!this.state.containsEsc && this.startsAwaitUsing()) {
		            if (!this.isAwaitAllowed()) {
		              this.raise(Errors.AwaitUsingNotInAsyncContext, node);
		            } else if (!allowDeclaration) {
		              this.raise(Errors.UnexpectedLexicalDeclaration, node);
		            }
		            this.next();
		            return this.parseVarStatement(node, "await using");
		          }
		          break;
		        case 107:
		          if (this.state.containsEsc || !this.hasInLineFollowingBindingIdentifier()) {
		            break;
		          }
		          this.expectPlugin("explicitResourceManagement");
		          if (!this.scope.inModule && this.scope.inTopLevel) {
		            this.raise(Errors.UnexpectedUsingDeclaration, this.state.startLoc);
		          } else if (!allowDeclaration) {
		            this.raise(Errors.UnexpectedLexicalDeclaration, this.state.startLoc);
		          }
		          return this.parseVarStatement(node, "using");
		        case 100:
		          {
		            if (this.state.containsEsc) {
		              break;
		            }
		            var next = this.nextTokenStart();
		            var nextCh = this.codePointAtPos(next);
		            if (nextCh !== 91) {
		              if (!allowDeclaration && this.hasFollowingLineBreak()) break;
		              if (!this.chStartsBindingIdentifier(nextCh, next) && nextCh !== 123) {
		                break;
		              }
		            }
		          }
		        case 75:
		          {
		            if (!allowDeclaration) {
		              this.raise(Errors.UnexpectedLexicalDeclaration, this.state.startLoc);
		            }
		          }
		        case 74:
		          {
		            var kind = this.state.value;
		            return this.parseVarStatement(node, kind);
		          }
		        case 92:
		          return this.parseWhileStatement(node);
		        case 76:
		          return this.parseWithStatement(node);
		        case 5:
		          return this.parseBlock();
		        case 13:
		          return this.parseEmptyStatement(node);
		        case 83:
		          {
		            var nextTokenCharCode = this.lookaheadCharCode();
		            if (nextTokenCharCode === 40 || nextTokenCharCode === 46) {
		              break;
		            }
		          }
		        case 82:
		          {
		            if (!this.options.allowImportExportEverywhere && !topLevel) {
		              this.raise(Errors.UnexpectedImportExport, this.state.startLoc);
		            }
		            this.next();
		            var result;
		            if (starttype === 83) {
		              result = this.parseImport(node);
		              if (result.type === "ImportDeclaration" && (!result.importKind || result.importKind === "value")) {
		                this.sawUnambiguousESM = true;
		              }
		            } else {
		              result = this.parseExport(node, decorators);
		              if (result.type === "ExportNamedDeclaration" && (!result.exportKind || result.exportKind === "value") || result.type === "ExportAllDeclaration" && (!result.exportKind || result.exportKind === "value") || result.type === "ExportDefaultDeclaration") {
		                this.sawUnambiguousESM = true;
		              }
		            }
		            this.assertModuleNodeAllowed(result);
		            return result;
		          }
		        default:
		          {
		            if (this.isAsyncFunction()) {
		              if (!allowDeclaration) {
		                this.raise(Errors.AsyncFunctionInSingleStatementContext, this.state.startLoc);
		              }
		              this.next();
		              return this.parseFunctionStatement(node, true, !allowDeclaration && allowFunctionDeclaration);
		            }
		          }
		      }
		      var maybeName = this.state.value;
		      var expr = this.parseExpression();
		      if (tokenIsIdentifier(starttype) && expr.type === "Identifier" && this.eat(14)) {
		        return this.parseLabeledStatement(node, maybeName, expr, flags);
		      } else {
		        return this.parseExpressionStatement(node, expr, decorators);
		      }
		    };
		    _proto.assertModuleNodeAllowed = function assertModuleNodeAllowed(node) {
		      if (!this.options.allowImportExportEverywhere && !this.inModule) {
		        this.raise(Errors.ImportOutsideModule, node);
		      }
		    };
		    _proto.decoratorsEnabledBeforeExport = function decoratorsEnabledBeforeExport() {
		      if (this.hasPlugin("decorators-legacy")) return true;
		      return this.hasPlugin("decorators") && this.getPluginOption("decorators", "decoratorsBeforeExport") !== false;
		    };
		    _proto.maybeTakeDecorators = function maybeTakeDecorators(maybeDecorators, classNode, exportNode) {
		      if (maybeDecorators) {
		        if (classNode.decorators && classNode.decorators.length > 0) {
		          var _classNode$decorators;
		          if (typeof this.getPluginOption("decorators", "decoratorsBeforeExport") !== "boolean") {
		            this.raise(Errors.DecoratorsBeforeAfterExport, classNode.decorators[0]);
		          }
		          (_classNode$decorators = classNode.decorators).unshift.apply(_classNode$decorators, maybeDecorators);
		        } else {
		          classNode.decorators = maybeDecorators;
		        }
		        this.resetStartLocationFromNode(classNode, maybeDecorators[0]);
		        if (exportNode) this.resetStartLocationFromNode(exportNode, classNode);
		      }
		      return classNode;
		    };
		    _proto.canHaveLeadingDecorator = function canHaveLeadingDecorator() {
		      return this.match(80);
		    };
		    _proto.parseDecorators = function parseDecorators(allowExport) {
		      var decorators = [];
		      do {
		        decorators.push(this.parseDecorator());
		      } while (this.match(26));
		      if (this.match(82)) {
		        if (!allowExport) {
		          this.unexpected();
		        }
		        if (!this.decoratorsEnabledBeforeExport()) {
		          this.raise(Errors.DecoratorExportClass, this.state.startLoc);
		        }
		      } else if (!this.canHaveLeadingDecorator()) {
		        throw this.raise(Errors.UnexpectedLeadingDecorator, this.state.startLoc);
		      }
		      return decorators;
		    };
		    _proto.parseDecorator = function parseDecorator() {
		      this.expectOnePlugin(["decorators", "decorators-legacy"]);
		      var node = this.startNode();
		      this.next();
		      if (this.hasPlugin("decorators")) {
		        var startLoc = this.state.startLoc;
		        var expr;
		        if (this.match(10)) {
		          var _startLoc = this.state.startLoc;
		          this.next();
		          expr = this.parseExpression();
		          this.expect(11);
		          expr = this.wrapParenthesis(_startLoc, expr);
		          var paramsStartLoc = this.state.startLoc;
		          node.expression = this.parseMaybeDecoratorArguments(expr);
		          if (this.getPluginOption("decorators", "allowCallParenthesized") === false && node.expression !== expr) {
		            this.raise(Errors.DecoratorArgumentsOutsideParentheses, paramsStartLoc);
		          }
		        } else {
		          expr = this.parseIdentifier(false);
		          while (this.eat(16)) {
		            var _node = this.startNodeAt(startLoc);
		            _node.object = expr;
		            if (this.match(138)) {
		              this.classScope.usePrivateName(this.state.value, this.state.startLoc);
		              _node.property = this.parsePrivateName();
		            } else {
		              _node.property = this.parseIdentifier(true);
		            }
		            _node.computed = false;
		            expr = this.finishNode(_node, "MemberExpression");
		          }
		          node.expression = this.parseMaybeDecoratorArguments(expr);
		        }
		      } else {
		        node.expression = this.parseExprSubscripts();
		      }
		      return this.finishNode(node, "Decorator");
		    };
		    _proto.parseMaybeDecoratorArguments = function parseMaybeDecoratorArguments(expr) {
		      if (this.eat(10)) {
		        var _node2 = this.startNodeAtNode(expr);
		        _node2.callee = expr;
		        _node2.arguments = this.parseCallExpressionArguments(11, false);
		        this.toReferencedList(_node2.arguments);
		        return this.finishNode(_node2, "CallExpression");
		      }
		      return expr;
		    };
		    _proto.parseBreakContinueStatement = function parseBreakContinueStatement(node, isBreak) {
		      this.next();
		      if (this.isLineTerminator()) {
		        node.label = null;
		      } else {
		        node.label = this.parseIdentifier();
		        this.semicolon();
		      }
		      this.verifyBreakContinue(node, isBreak);
		      return this.finishNode(node, isBreak ? "BreakStatement" : "ContinueStatement");
		    };
		    _proto.verifyBreakContinue = function verifyBreakContinue(node, isBreak) {
		      var i;
		      for (i = 0; i < this.state.labels.length; ++i) {
		        var lab = this.state.labels[i];
		        if (node.label == null || lab.name === node.label.name) {
		          if (lab.kind != null && (isBreak || lab.kind === LoopLabelKind.Loop)) {
		            break;
		          }
		          if (node.label && isBreak) break;
		        }
		      }
		      if (i === this.state.labels.length) {
		        var type = isBreak ? "BreakStatement" : "ContinueStatement";
		        this.raise(Errors.IllegalBreakContinue, node, {
		          type: type
		        });
		      }
		    };
		    _proto.parseDebuggerStatement = function parseDebuggerStatement(node) {
		      this.next();
		      this.semicolon();
		      return this.finishNode(node, "DebuggerStatement");
		    };
		    _proto.parseHeaderExpression = function parseHeaderExpression() {
		      this.expect(10);
		      var val = this.parseExpression();
		      this.expect(11);
		      return val;
		    };
		    _proto.parseDoWhileStatement = function parseDoWhileStatement(node) {
		      var _this = this;
		      this.next();
		      this.state.labels.push(loopLabel);
		      node.body = this.withSmartMixTopicForbiddingContext(function () {
		        return _this.parseStatement();
		      });
		      this.state.labels.pop();
		      this.expect(92);
		      node.test = this.parseHeaderExpression();
		      this.eat(13);
		      return this.finishNode(node, "DoWhileStatement");
		    };
		    _proto.parseForStatement = function parseForStatement(node) {
		      this.next();
		      this.state.labels.push(loopLabel);
		      var awaitAt = null;
		      if (this.isAwaitAllowed() && this.eatContextual(96)) {
		        awaitAt = this.state.lastTokStartLoc;
		      }
		      this.scope.enter(ScopeFlag.OTHER);
		      this.expect(10);
		      if (this.match(13)) {
		        if (awaitAt !== null) {
		          this.unexpected(awaitAt);
		        }
		        return this.parseFor(node, null);
		      }
		      var startsWithLet = this.isContextual(100);
		      {
		        var startsWithAwaitUsing = this.isContextual(96) && this.startsAwaitUsing();
		        var starsWithUsingDeclaration = startsWithAwaitUsing || this.isContextual(107) && this.startsUsingForOf();
		        var isLetOrUsing = startsWithLet && this.hasFollowingBindingAtom() || starsWithUsingDeclaration;
		        if (this.match(74) || this.match(75) || isLetOrUsing) {
		          var initNode = this.startNode();
		          var kind;
		          if (startsWithAwaitUsing) {
		            kind = "await using";
		            if (!this.isAwaitAllowed()) {
		              this.raise(Errors.AwaitUsingNotInAsyncContext, this.state.startLoc);
		            }
		            this.next();
		          } else {
		            kind = this.state.value;
		          }
		          this.next();
		          this.parseVar(initNode, true, kind);
		          var _init = this.finishNode(initNode, "VariableDeclaration");
		          var isForIn = this.match(58);
		          if (isForIn && starsWithUsingDeclaration) {
		            this.raise(Errors.ForInUsing, _init);
		          }
		          if ((isForIn || this.isContextual(102)) && _init.declarations.length === 1) {
		            return this.parseForIn(node, _init, awaitAt);
		          }
		          if (awaitAt !== null) {
		            this.unexpected(awaitAt);
		          }
		          return this.parseFor(node, _init);
		        }
		      }
		      var startsWithAsync = this.isContextual(95);
		      var refExpressionErrors = new ExpressionErrors();
		      var init = this.parseExpression(true, refExpressionErrors);
		      var isForOf = this.isContextual(102);
		      if (isForOf) {
		        if (startsWithLet) {
		          this.raise(Errors.ForOfLet, init);
		        }
		        if (awaitAt === null && startsWithAsync && init.type === "Identifier") {
		          this.raise(Errors.ForOfAsync, init);
		        }
		      }
		      if (isForOf || this.match(58)) {
		        this.checkDestructuringPrivate(refExpressionErrors);
		        this.toAssignable(init, true);
		        var type = isForOf ? "ForOfStatement" : "ForInStatement";
		        this.checkLVal(init, {
		          "in": {
		            type: type
		          }
		        });
		        return this.parseForIn(node, init, awaitAt);
		      } else {
		        this.checkExpressionErrors(refExpressionErrors, true);
		      }
		      if (awaitAt !== null) {
		        this.unexpected(awaitAt);
		      }
		      return this.parseFor(node, init);
		    };
		    _proto.parseFunctionStatement = function parseFunctionStatement(node, isAsync, isHangingDeclaration) {
		      this.next();
		      return this.parseFunction(node, ParseFunctionFlag.Declaration | (isHangingDeclaration ? ParseFunctionFlag.HangingDeclaration : 0) | (isAsync ? ParseFunctionFlag.Async : 0));
		    };
		    _proto.parseIfStatement = function parseIfStatement(node) {
		      this.next();
		      node.test = this.parseHeaderExpression();
		      node.consequent = this.parseStatementOrSloppyAnnexBFunctionDeclaration();
		      node.alternate = this.eat(66) ? this.parseStatementOrSloppyAnnexBFunctionDeclaration() : null;
		      return this.finishNode(node, "IfStatement");
		    };
		    _proto.parseReturnStatement = function parseReturnStatement(node) {
		      if (!this.prodParam.hasReturn && !this.options.allowReturnOutsideFunction) {
		        this.raise(Errors.IllegalReturn, this.state.startLoc);
		      }
		      this.next();
		      if (this.isLineTerminator()) {
		        node.argument = null;
		      } else {
		        node.argument = this.parseExpression();
		        this.semicolon();
		      }
		      return this.finishNode(node, "ReturnStatement");
		    };
		    _proto.parseSwitchStatement = function parseSwitchStatement(node) {
		      this.next();
		      node.discriminant = this.parseHeaderExpression();
		      var cases = node.cases = [];
		      this.expect(5);
		      this.state.labels.push(switchLabel);
		      this.scope.enter(ScopeFlag.OTHER);
		      var cur;
		      for (var sawDefault; !this.match(8);) {
		        if (this.match(61) || this.match(65)) {
		          var isCase = this.match(61);
		          if (cur) this.finishNode(cur, "SwitchCase");
		          cases.push(cur = this.startNode());
		          cur.consequent = [];
		          this.next();
		          if (isCase) {
		            cur.test = this.parseExpression();
		          } else {
		            if (sawDefault) {
		              this.raise(Errors.MultipleDefaultsInSwitch, this.state.lastTokStartLoc);
		            }
		            sawDefault = true;
		            cur.test = null;
		          }
		          this.expect(14);
		        } else {
		          if (cur) {
		            cur.consequent.push(this.parseStatementListItem());
		          } else {
		            this.unexpected();
		          }
		        }
		      }
		      this.scope.exit();
		      if (cur) this.finishNode(cur, "SwitchCase");
		      this.next();
		      this.state.labels.pop();
		      return this.finishNode(node, "SwitchStatement");
		    };
		    _proto.parseThrowStatement = function parseThrowStatement(node) {
		      this.next();
		      if (this.hasPrecedingLineBreak()) {
		        this.raise(Errors.NewlineAfterThrow, this.state.lastTokEndLoc);
		      }
		      node.argument = this.parseExpression();
		      this.semicolon();
		      return this.finishNode(node, "ThrowStatement");
		    };
		    _proto.parseCatchClauseParam = function parseCatchClauseParam() {
		      var param = this.parseBindingAtom();
		      this.scope.enter(this.options.annexB && param.type === "Identifier" ? ScopeFlag.SIMPLE_CATCH : 0);
		      this.checkLVal(param, {
		        "in": {
		          type: "CatchClause"
		        },
		        binding: BindingFlag.TYPE_CATCH_PARAM
		      });
		      return param;
		    };
		    _proto.parseTryStatement = function parseTryStatement(node) {
		      var _this2 = this;
		      this.next();
		      node.block = this.parseBlock();
		      node.handler = null;
		      if (this.match(62)) {
		        var clause = this.startNode();
		        this.next();
		        if (this.match(10)) {
		          this.expect(10);
		          clause.param = this.parseCatchClauseParam();
		          this.expect(11);
		        } else {
		          clause.param = null;
		          this.scope.enter(ScopeFlag.OTHER);
		        }
		        clause.body = this.withSmartMixTopicForbiddingContext(function () {
		          return _this2.parseBlock(false, false);
		        });
		        this.scope.exit();
		        node.handler = this.finishNode(clause, "CatchClause");
		      }
		      node.finalizer = this.eat(67) ? this.parseBlock() : null;
		      if (!node.handler && !node.finalizer) {
		        this.raise(Errors.NoCatchOrFinally, node);
		      }
		      return this.finishNode(node, "TryStatement");
		    };
		    _proto.parseVarStatement = function parseVarStatement(node, kind, allowMissingInitializer) {
		      if (allowMissingInitializer === void 0) {
		        allowMissingInitializer = false;
		      }
		      this.next();
		      this.parseVar(node, false, kind, allowMissingInitializer);
		      this.semicolon();
		      return this.finishNode(node, "VariableDeclaration");
		    };
		    _proto.parseWhileStatement = function parseWhileStatement(node) {
		      var _this3 = this;
		      this.next();
		      node.test = this.parseHeaderExpression();
		      this.state.labels.push(loopLabel);
		      node.body = this.withSmartMixTopicForbiddingContext(function () {
		        return _this3.parseStatement();
		      });
		      this.state.labels.pop();
		      return this.finishNode(node, "WhileStatement");
		    };
		    _proto.parseWithStatement = function parseWithStatement(node) {
		      var _this4 = this;
		      if (this.state.strict) {
		        this.raise(Errors.StrictWith, this.state.startLoc);
		      }
		      this.next();
		      node.object = this.parseHeaderExpression();
		      node.body = this.withSmartMixTopicForbiddingContext(function () {
		        return _this4.parseStatement();
		      });
		      return this.finishNode(node, "WithStatement");
		    };
		    _proto.parseEmptyStatement = function parseEmptyStatement(node) {
		      this.next();
		      return this.finishNode(node, "EmptyStatement");
		    };
		    _proto.parseLabeledStatement = function parseLabeledStatement(node, maybeName, expr, flags) {
		      for (var _i4 = 0, _this$state$labels2 = this.state.labels; _i4 < _this$state$labels2.length; _i4++) {
		        var label = _this$state$labels2[_i4];
		        if (label.name === maybeName) {
		          this.raise(Errors.LabelRedeclaration, expr, {
		            labelName: maybeName
		          });
		        }
		      }
		      var kind = tokenIsLoop(this.state.type) ? LoopLabelKind.Loop : this.match(71) ? LoopLabelKind.Switch : null;
		      for (var i = this.state.labels.length - 1; i >= 0; i--) {
		        var _label = this.state.labels[i];
		        if (_label.statementStart === node.start) {
		          _label.statementStart = this.state.start;
		          _label.kind = kind;
		        } else {
		          break;
		        }
		      }
		      this.state.labels.push({
		        name: maybeName,
		        kind: kind,
		        statementStart: this.state.start
		      });
		      node.body = flags & ParseStatementFlag.AllowLabeledFunction ? this.parseStatementOrSloppyAnnexBFunctionDeclaration(true) : this.parseStatement();
		      this.state.labels.pop();
		      node.label = expr;
		      return this.finishNode(node, "LabeledStatement");
		    };
		    _proto.parseExpressionStatement = function parseExpressionStatement(node, expr, decorators) {
		      node.expression = expr;
		      this.semicolon();
		      return this.finishNode(node, "ExpressionStatement");
		    };
		    _proto.parseBlock = function parseBlock(allowDirectives, createNewLexicalScope, afterBlockParse) {
		      if (allowDirectives === void 0) {
		        allowDirectives = false;
		      }
		      if (createNewLexicalScope === void 0) {
		        createNewLexicalScope = true;
		      }
		      var node = this.startNode();
		      if (allowDirectives) {
		        this.state.strictErrors.clear();
		      }
		      this.expect(5);
		      if (createNewLexicalScope) {
		        this.scope.enter(ScopeFlag.OTHER);
		      }
		      this.parseBlockBody(node, allowDirectives, false, 8, afterBlockParse);
		      if (createNewLexicalScope) {
		        this.scope.exit();
		      }
		      return this.finishNode(node, "BlockStatement");
		    };
		    _proto.isValidDirective = function isValidDirective(stmt) {
		      return stmt.type === "ExpressionStatement" && stmt.expression.type === "StringLiteral" && !stmt.expression.extra.parenthesized;
		    };
		    _proto.parseBlockBody = function parseBlockBody(node, allowDirectives, topLevel, end, afterBlockParse) {
		      var body = node.body = [];
		      var directives = node.directives = [];
		      this.parseBlockOrModuleBlockBody(body, allowDirectives ? directives : undefined, topLevel, end, afterBlockParse);
		    };
		    _proto.parseBlockOrModuleBlockBody = function parseBlockOrModuleBlockBody(body, directives, topLevel, end, afterBlockParse) {
		      var oldStrict = this.state.strict;
		      var hasStrictModeDirective = false;
		      var parsedNonDirective = false;
		      while (!this.match(end)) {
		        var stmt = topLevel ? this.parseModuleItem() : this.parseStatementListItem();
		        if (directives && !parsedNonDirective) {
		          if (this.isValidDirective(stmt)) {
		            var directive = this.stmtToDirective(stmt);
		            directives.push(directive);
		            if (!hasStrictModeDirective && directive.value.value === "use strict") {
		              hasStrictModeDirective = true;
		              this.setStrict(true);
		            }
		            continue;
		          }
		          parsedNonDirective = true;
		          this.state.strictErrors.clear();
		        }
		        body.push(stmt);
		      }
		      afterBlockParse == null || afterBlockParse.call(this, hasStrictModeDirective);
		      if (!oldStrict) {
		        this.setStrict(false);
		      }
		      this.next();
		    };
		    _proto.parseFor = function parseFor(node, init) {
		      var _this5 = this;
		      node.init = init;
		      this.semicolon(false);
		      node.test = this.match(13) ? null : this.parseExpression();
		      this.semicolon(false);
		      node.update = this.match(11) ? null : this.parseExpression();
		      this.expect(11);
		      node.body = this.withSmartMixTopicForbiddingContext(function () {
		        return _this5.parseStatement();
		      });
		      this.scope.exit();
		      this.state.labels.pop();
		      return this.finishNode(node, "ForStatement");
		    };
		    _proto.parseForIn = function parseForIn(node, init, awaitAt) {
		      var _this6 = this;
		      var isForIn = this.match(58);
		      this.next();
		      if (isForIn) {
		        if (awaitAt !== null) this.unexpected(awaitAt);
		      } else {
		        node["await"] = awaitAt !== null;
		      }
		      if (init.type === "VariableDeclaration" && init.declarations[0].init != null && (!isForIn || !this.options.annexB || this.state.strict || init.kind !== "var" || init.declarations[0].id.type !== "Identifier")) {
		        this.raise(Errors.ForInOfLoopInitializer, init, {
		          type: isForIn ? "ForInStatement" : "ForOfStatement"
		        });
		      }
		      if (init.type === "AssignmentPattern") {
		        this.raise(Errors.InvalidLhs, init, {
		          ancestor: {
		            type: "ForStatement"
		          }
		        });
		      }
		      node.left = init;
		      node.right = isForIn ? this.parseExpression() : this.parseMaybeAssignAllowIn();
		      this.expect(11);
		      node.body = this.withSmartMixTopicForbiddingContext(function () {
		        return _this6.parseStatement();
		      });
		      this.scope.exit();
		      this.state.labels.pop();
		      return this.finishNode(node, isForIn ? "ForInStatement" : "ForOfStatement");
		    };
		    _proto.parseVar = function parseVar(node, isFor, kind, allowMissingInitializer) {
		      if (allowMissingInitializer === void 0) {
		        allowMissingInitializer = false;
		      }
		      var declarations = node.declarations = [];
		      node.kind = kind;
		      for (;;) {
		        var decl = this.startNode();
		        this.parseVarId(decl, kind);
		        decl.init = !this.eat(29) ? null : isFor ? this.parseMaybeAssignDisallowIn() : this.parseMaybeAssignAllowIn();
		        if (decl.init === null && !allowMissingInitializer) {
		          if (decl.id.type !== "Identifier" && !(isFor && (this.match(58) || this.isContextual(102)))) {
		            this.raise(Errors.DeclarationMissingInitializer, this.state.lastTokEndLoc, {
		              kind: "destructuring"
		            });
		          } else if ((kind === "const" || kind === "using" || kind === "await using") && !(this.match(58) || this.isContextual(102))) {
		            this.raise(Errors.DeclarationMissingInitializer, this.state.lastTokEndLoc, {
		              kind: kind
		            });
		          }
		        }
		        declarations.push(this.finishNode(decl, "VariableDeclarator"));
		        if (!this.eat(12)) break;
		      }
		      return node;
		    };
		    _proto.parseVarId = function parseVarId(decl, kind) {
		      var id = this.parseBindingAtom();
		      this.checkLVal(id, {
		        "in": {
		          type: "VariableDeclarator"
		        },
		        binding: kind === "var" ? BindingFlag.TYPE_VAR : BindingFlag.TYPE_LEXICAL
		      });
		      decl.id = id;
		    };
		    _proto.parseAsyncFunctionExpression = function parseAsyncFunctionExpression(node) {
		      return this.parseFunction(node, ParseFunctionFlag.Async);
		    };
		    _proto.parseFunction = function parseFunction(node, flags) {
		      var _this7 = this;
		      if (flags === void 0) {
		        flags = ParseFunctionFlag.Expression;
		      }
		      var hangingDeclaration = flags & ParseFunctionFlag.HangingDeclaration;
		      var isDeclaration = !!(flags & ParseFunctionFlag.Declaration);
		      var requireId = isDeclaration && !(flags & ParseFunctionFlag.NullableId);
		      var isAsync = !!(flags & ParseFunctionFlag.Async);
		      this.initFunction(node, isAsync);
		      if (this.match(55)) {
		        if (hangingDeclaration) {
		          this.raise(Errors.GeneratorInSingleStatementContext, this.state.startLoc);
		        }
		        this.next();
		        node.generator = true;
		      }
		      if (isDeclaration) {
		        node.id = this.parseFunctionId(requireId);
		      }
		      var oldMaybeInArrowParameters = this.state.maybeInArrowParameters;
		      this.state.maybeInArrowParameters = false;
		      this.scope.enter(ScopeFlag.FUNCTION);
		      this.prodParam.enter(functionFlags(isAsync, node.generator));
		      if (!isDeclaration) {
		        node.id = this.parseFunctionId();
		      }
		      this.parseFunctionParams(node, false);
		      this.withSmartMixTopicForbiddingContext(function () {
		        _this7.parseFunctionBodyAndFinish(node, isDeclaration ? "FunctionDeclaration" : "FunctionExpression");
		      });
		      this.prodParam.exit();
		      this.scope.exit();
		      if (isDeclaration && !hangingDeclaration) {
		        this.registerFunctionStatementId(node);
		      }
		      this.state.maybeInArrowParameters = oldMaybeInArrowParameters;
		      return node;
		    };
		    _proto.parseFunctionId = function parseFunctionId(requireId) {
		      return requireId || tokenIsIdentifier(this.state.type) ? this.parseIdentifier() : null;
		    };
		    _proto.parseFunctionParams = function parseFunctionParams(node, isConstructor) {
		      this.expect(10);
		      this.expressionScope.enter(newParameterDeclarationScope());
		      node.params = this.parseBindingList(11, 41, ParseBindingListFlags.IS_FUNCTION_PARAMS | (isConstructor ? ParseBindingListFlags.IS_CONSTRUCTOR_PARAMS : 0));
		      this.expressionScope.exit();
		    };
		    _proto.registerFunctionStatementId = function registerFunctionStatementId(node) {
		      if (!node.id) return;
		      this.scope.declareName(node.id.name, !this.options.annexB || this.state.strict || node.generator || node.async ? this.scope.treatFunctionsAsVar ? BindingFlag.TYPE_VAR : BindingFlag.TYPE_LEXICAL : BindingFlag.TYPE_FUNCTION, node.id.loc.start);
		    };
		    _proto.parseClass = function parseClass(node, isStatement, optionalId) {
		      this.next();
		      var oldStrict = this.state.strict;
		      this.state.strict = true;
		      this.parseClassId(node, isStatement, optionalId);
		      this.parseClassSuper(node);
		      node.body = this.parseClassBody(!!node.superClass, oldStrict);
		      return this.finishNode(node, isStatement ? "ClassDeclaration" : "ClassExpression");
		    };
		    _proto.isClassProperty = function isClassProperty() {
		      return this.match(29) || this.match(13) || this.match(8);
		    };
		    _proto.isClassMethod = function isClassMethod() {
		      return this.match(10);
		    };
		    _proto.nameIsConstructor = function nameIsConstructor(key) {
		      return key.type === "Identifier" && key.name === "constructor" || key.type === "StringLiteral" && key.value === "constructor";
		    };
		    _proto.isNonstaticConstructor = function isNonstaticConstructor(method) {
		      return !method.computed && !method["static"] && this.nameIsConstructor(method.key);
		    };
		    _proto.parseClassBody = function parseClassBody(hadSuperClass, oldStrict) {
		      var _this8 = this;
		      this.classScope.enter();
		      var state = {
		        hadConstructor: false,
		        hadSuperClass: hadSuperClass
		      };
		      var decorators = [];
		      var classBody = this.startNode();
		      classBody.body = [];
		      this.expect(5);
		      this.withSmartMixTopicForbiddingContext(function () {
		        while (!_this8.match(8)) {
		          if (_this8.eat(13)) {
		            if (decorators.length > 0) {
		              throw _this8.raise(Errors.DecoratorSemicolon, _this8.state.lastTokEndLoc);
		            }
		            continue;
		          }
		          if (_this8.match(26)) {
		            decorators.push(_this8.parseDecorator());
		            continue;
		          }
		          var member = _this8.startNode();
		          if (decorators.length) {
		            member.decorators = decorators;
		            _this8.resetStartLocationFromNode(member, decorators[0]);
		            decorators = [];
		          }
		          _this8.parseClassMember(classBody, member, state);
		          if (member.kind === "constructor" && member.decorators && member.decorators.length > 0) {
		            _this8.raise(Errors.DecoratorConstructor, member);
		          }
		        }
		      });
		      this.state.strict = oldStrict;
		      this.next();
		      if (decorators.length) {
		        throw this.raise(Errors.TrailingDecorator, this.state.startLoc);
		      }
		      this.classScope.exit();
		      return this.finishNode(classBody, "ClassBody");
		    };
		    _proto.parseClassMemberFromModifier = function parseClassMemberFromModifier(classBody, member) {
		      var key = this.parseIdentifier(true);
		      if (this.isClassMethod()) {
		        var method = member;
		        method.kind = "method";
		        method.computed = false;
		        method.key = key;
		        method["static"] = false;
		        this.pushClassMethod(classBody, method, false, false, false, false);
		        return true;
		      } else if (this.isClassProperty()) {
		        var prop = member;
		        prop.computed = false;
		        prop.key = key;
		        prop["static"] = false;
		        classBody.body.push(this.parseClassProperty(prop));
		        return true;
		      }
		      this.resetPreviousNodeTrailingComments(key);
		      return false;
		    };
		    _proto.parseClassMember = function parseClassMember(classBody, member, state) {
		      var isStatic = this.isContextual(106);
		      if (isStatic) {
		        if (this.parseClassMemberFromModifier(classBody, member)) {
		          return;
		        }
		        if (this.eat(5)) {
		          this.parseClassStaticBlock(classBody, member);
		          return;
		        }
		      }
		      this.parseClassMemberWithIsStatic(classBody, member, state, isStatic);
		    };
		    _proto.parseClassMemberWithIsStatic = function parseClassMemberWithIsStatic(classBody, member, state, isStatic) {
		      var publicMethod = member;
		      var privateMethod = member;
		      var publicProp = member;
		      var privateProp = member;
		      var accessorProp = member;
		      var method = publicMethod;
		      var publicMember = publicMethod;
		      member["static"] = isStatic;
		      this.parsePropertyNamePrefixOperator(member);
		      if (this.eat(55)) {
		        method.kind = "method";
		        var isPrivateName = this.match(138);
		        this.parseClassElementName(method);
		        if (isPrivateName) {
		          this.pushClassPrivateMethod(classBody, privateMethod, true, false);
		          return;
		        }
		        if (this.isNonstaticConstructor(publicMethod)) {
		          this.raise(Errors.ConstructorIsGenerator, publicMethod.key);
		        }
		        this.pushClassMethod(classBody, publicMethod, true, false, false, false);
		        return;
		      }
		      var isContextual = !this.state.containsEsc && tokenIsIdentifier(this.state.type);
		      var key = this.parseClassElementName(member);
		      var maybeContextualKw = isContextual ? key.name : null;
		      var isPrivate = this.isPrivateName(key);
		      var maybeQuestionTokenStartLoc = this.state.startLoc;
		      this.parsePostMemberNameModifiers(publicMember);
		      if (this.isClassMethod()) {
		        method.kind = "method";
		        if (isPrivate) {
		          this.pushClassPrivateMethod(classBody, privateMethod, false, false);
		          return;
		        }
		        var isConstructor = this.isNonstaticConstructor(publicMethod);
		        var allowsDirectSuper = false;
		        if (isConstructor) {
		          publicMethod.kind = "constructor";
		          if (state.hadConstructor && !this.hasPlugin("typescript")) {
		            this.raise(Errors.DuplicateConstructor, key);
		          }
		          if (isConstructor && this.hasPlugin("typescript") && member.override) {
		            this.raise(Errors.OverrideOnConstructor, key);
		          }
		          state.hadConstructor = true;
		          allowsDirectSuper = state.hadSuperClass;
		        }
		        this.pushClassMethod(classBody, publicMethod, false, false, isConstructor, allowsDirectSuper);
		      } else if (this.isClassProperty()) {
		        if (isPrivate) {
		          this.pushClassPrivateProperty(classBody, privateProp);
		        } else {
		          this.pushClassProperty(classBody, publicProp);
		        }
		      } else if (maybeContextualKw === "async" && !this.isLineTerminator()) {
		        this.resetPreviousNodeTrailingComments(key);
		        var isGenerator = this.eat(55);
		        if (publicMember.optional) {
		          this.unexpected(maybeQuestionTokenStartLoc);
		        }
		        method.kind = "method";
		        var _isPrivate = this.match(138);
		        this.parseClassElementName(method);
		        this.parsePostMemberNameModifiers(publicMember);
		        if (_isPrivate) {
		          this.pushClassPrivateMethod(classBody, privateMethod, isGenerator, true);
		        } else {
		          if (this.isNonstaticConstructor(publicMethod)) {
		            this.raise(Errors.ConstructorIsAsync, publicMethod.key);
		          }
		          this.pushClassMethod(classBody, publicMethod, isGenerator, true, false, false);
		        }
		      } else if ((maybeContextualKw === "get" || maybeContextualKw === "set") && !(this.match(55) && this.isLineTerminator())) {
		        this.resetPreviousNodeTrailingComments(key);
		        method.kind = maybeContextualKw;
		        var _isPrivate2 = this.match(138);
		        this.parseClassElementName(publicMethod);
		        if (_isPrivate2) {
		          this.pushClassPrivateMethod(classBody, privateMethod, false, false);
		        } else {
		          if (this.isNonstaticConstructor(publicMethod)) {
		            this.raise(Errors.ConstructorIsAccessor, publicMethod.key);
		          }
		          this.pushClassMethod(classBody, publicMethod, false, false, false, false);
		        }
		        this.checkGetterSetterParams(publicMethod);
		      } else if (maybeContextualKw === "accessor" && !this.isLineTerminator()) {
		        this.expectPlugin("decoratorAutoAccessors");
		        this.resetPreviousNodeTrailingComments(key);
		        var _isPrivate3 = this.match(138);
		        this.parseClassElementName(publicProp);
		        this.pushClassAccessorProperty(classBody, accessorProp, _isPrivate3);
		      } else if (this.isLineTerminator()) {
		        if (isPrivate) {
		          this.pushClassPrivateProperty(classBody, privateProp);
		        } else {
		          this.pushClassProperty(classBody, publicProp);
		        }
		      } else {
		        this.unexpected();
		      }
		    };
		    _proto.parseClassElementName = function parseClassElementName(member) {
		      var _this$state = this.state,
		        type = _this$state.type,
		        value = _this$state.value;
		      if ((type === 132 || type === 133) && member["static"] && value === "prototype") {
		        this.raise(Errors.StaticPrototype, this.state.startLoc);
		      }
		      if (type === 138) {
		        if (value === "constructor") {
		          this.raise(Errors.ConstructorClassPrivateField, this.state.startLoc);
		        }
		        var key = this.parsePrivateName();
		        member.key = key;
		        return key;
		      }
		      this.parsePropertyName(member);
		      return member.key;
		    };
		    _proto.parseClassStaticBlock = function parseClassStaticBlock(classBody, member) {
		      var _member$decorators;
		      this.scope.enter(ScopeFlag.CLASS | ScopeFlag.STATIC_BLOCK | ScopeFlag.SUPER);
		      var oldLabels = this.state.labels;
		      this.state.labels = [];
		      this.prodParam.enter(ParamKind.PARAM);
		      var body = member.body = [];
		      this.parseBlockOrModuleBlockBody(body, undefined, false, 8);
		      this.prodParam.exit();
		      this.scope.exit();
		      this.state.labels = oldLabels;
		      classBody.body.push(this.finishNode(member, "StaticBlock"));
		      if ((_member$decorators = member.decorators) != null && _member$decorators.length) {
		        this.raise(Errors.DecoratorStaticBlock, member);
		      }
		    };
		    _proto.pushClassProperty = function pushClassProperty(classBody, prop) {
		      if (!prop.computed && this.nameIsConstructor(prop.key)) {
		        this.raise(Errors.ConstructorClassField, prop.key);
		      }
		      classBody.body.push(this.parseClassProperty(prop));
		    };
		    _proto.pushClassPrivateProperty = function pushClassPrivateProperty(classBody, prop) {
		      var node = this.parseClassPrivateProperty(prop);
		      classBody.body.push(node);
		      this.classScope.declarePrivateName(this.getPrivateNameSV(node.key), ClassElementType.OTHER, node.key.loc.start);
		    };
		    _proto.pushClassAccessorProperty = function pushClassAccessorProperty(classBody, prop, isPrivate) {
		      if (!isPrivate && !prop.computed && this.nameIsConstructor(prop.key)) {
		        this.raise(Errors.ConstructorClassField, prop.key);
		      }
		      var node = this.parseClassAccessorProperty(prop);
		      classBody.body.push(node);
		      if (isPrivate) {
		        this.classScope.declarePrivateName(this.getPrivateNameSV(node.key), ClassElementType.OTHER, node.key.loc.start);
		      }
		    };
		    _proto.pushClassMethod = function pushClassMethod(classBody, method, isGenerator, isAsync, isConstructor, allowsDirectSuper) {
		      classBody.body.push(this.parseMethod(method, isGenerator, isAsync, isConstructor, allowsDirectSuper, "ClassMethod", true));
		    };
		    _proto.pushClassPrivateMethod = function pushClassPrivateMethod(classBody, method, isGenerator, isAsync) {
		      var node = this.parseMethod(method, isGenerator, isAsync, false, false, "ClassPrivateMethod", true);
		      classBody.body.push(node);
		      var kind = node.kind === "get" ? node["static"] ? ClassElementType.STATIC_GETTER : ClassElementType.INSTANCE_GETTER : node.kind === "set" ? node["static"] ? ClassElementType.STATIC_SETTER : ClassElementType.INSTANCE_SETTER : ClassElementType.OTHER;
		      this.declareClassPrivateMethodInScope(node, kind);
		    };
		    _proto.declareClassPrivateMethodInScope = function declareClassPrivateMethodInScope(node, kind) {
		      this.classScope.declarePrivateName(this.getPrivateNameSV(node.key), kind, node.key.loc.start);
		    };
		    _proto.parsePostMemberNameModifiers = function parsePostMemberNameModifiers(methodOrProp) {};
		    _proto.parseClassPrivateProperty = function parseClassPrivateProperty(node) {
		      this.parseInitializer(node);
		      this.semicolon();
		      return this.finishNode(node, "ClassPrivateProperty");
		    };
		    _proto.parseClassProperty = function parseClassProperty(node) {
		      this.parseInitializer(node);
		      this.semicolon();
		      return this.finishNode(node, "ClassProperty");
		    };
		    _proto.parseClassAccessorProperty = function parseClassAccessorProperty(node) {
		      this.parseInitializer(node);
		      this.semicolon();
		      return this.finishNode(node, "ClassAccessorProperty");
		    };
		    _proto.parseInitializer = function parseInitializer(node) {
		      this.scope.enter(ScopeFlag.CLASS | ScopeFlag.SUPER);
		      this.expressionScope.enter(newExpressionScope());
		      this.prodParam.enter(ParamKind.PARAM);
		      node.value = this.eat(29) ? this.parseMaybeAssignAllowIn() : null;
		      this.expressionScope.exit();
		      this.prodParam.exit();
		      this.scope.exit();
		    };
		    _proto.parseClassId = function parseClassId(node, isStatement, optionalId, bindingType) {
		      if (bindingType === void 0) {
		        bindingType = BindingFlag.TYPE_CLASS;
		      }
		      if (tokenIsIdentifier(this.state.type)) {
		        node.id = this.parseIdentifier();
		        if (isStatement) {
		          this.declareNameFromIdentifier(node.id, bindingType);
		        }
		      } else {
		        if (optionalId || !isStatement) {
		          node.id = null;
		        } else {
		          throw this.raise(Errors.MissingClassName, this.state.startLoc);
		        }
		      }
		    };
		    _proto.parseClassSuper = function parseClassSuper(node) {
		      node.superClass = this.eat(81) ? this.parseExprSubscripts() : null;
		    };
		    _proto.parseExport = function parseExport(node, decorators) {
		      var maybeDefaultIdentifier = this.parseMaybeImportPhase(node, true);
		      var hasDefault = this.maybeParseExportDefaultSpecifier(node, maybeDefaultIdentifier);
		      var parseAfterDefault = !hasDefault || this.eat(12);
		      var hasStar = parseAfterDefault && this.eatExportStar(node);
		      var hasNamespace = hasStar && this.maybeParseExportNamespaceSpecifier(node);
		      var parseAfterNamespace = parseAfterDefault && (!hasNamespace || this.eat(12));
		      var isFromRequired = hasDefault || hasStar;
		      if (hasStar && !hasNamespace) {
		        if (hasDefault) this.unexpected();
		        if (decorators) {
		          throw this.raise(Errors.UnsupportedDecoratorExport, node);
		        }
		        this.parseExportFrom(node, true);
		        return this.finishNode(node, "ExportAllDeclaration");
		      }
		      var hasSpecifiers = this.maybeParseExportNamedSpecifiers(node);
		      if (hasDefault && parseAfterDefault && !hasStar && !hasSpecifiers) {
		        this.unexpected(null, 5);
		      }
		      if (hasNamespace && parseAfterNamespace) {
		        this.unexpected(null, 98);
		      }
		      var hasDeclaration;
		      if (isFromRequired || hasSpecifiers) {
		        hasDeclaration = false;
		        if (decorators) {
		          throw this.raise(Errors.UnsupportedDecoratorExport, node);
		        }
		        this.parseExportFrom(node, isFromRequired);
		      } else {
		        hasDeclaration = this.maybeParseExportDeclaration(node);
		      }
		      if (isFromRequired || hasSpecifiers || hasDeclaration) {
		        var _node2$declaration;
		        var node2 = node;
		        this.checkExport(node2, true, false, !!node2.source);
		        if (((_node2$declaration = node2.declaration) == null ? void 0 : _node2$declaration.type) === "ClassDeclaration") {
		          this.maybeTakeDecorators(decorators, node2.declaration, node2);
		        } else if (decorators) {
		          throw this.raise(Errors.UnsupportedDecoratorExport, node);
		        }
		        return this.finishNode(node2, "ExportNamedDeclaration");
		      }
		      if (this.eat(65)) {
		        var _node3 = node;
		        var decl = this.parseExportDefaultExpression();
		        _node3.declaration = decl;
		        if (decl.type === "ClassDeclaration") {
		          this.maybeTakeDecorators(decorators, decl, _node3);
		        } else if (decorators) {
		          throw this.raise(Errors.UnsupportedDecoratorExport, node);
		        }
		        this.checkExport(_node3, true, true);
		        return this.finishNode(_node3, "ExportDefaultDeclaration");
		      }
		      this.unexpected(null, 5);
		    };
		    _proto.eatExportStar = function eatExportStar(node) {
		      return this.eat(55);
		    };
		    _proto.maybeParseExportDefaultSpecifier = function maybeParseExportDefaultSpecifier(node, maybeDefaultIdentifier) {
		      if (maybeDefaultIdentifier || this.isExportDefaultSpecifier()) {
		        this.expectPlugin("exportDefaultFrom", maybeDefaultIdentifier == null ? void 0 : maybeDefaultIdentifier.loc.start);
		        var id = maybeDefaultIdentifier || this.parseIdentifier(true);
		        var specifier = this.startNodeAtNode(id);
		        specifier.exported = id;
		        node.specifiers = [this.finishNode(specifier, "ExportDefaultSpecifier")];
		        return true;
		      }
		      return false;
		    };
		    _proto.maybeParseExportNamespaceSpecifier = function maybeParseExportNamespaceSpecifier(node) {
		      if (this.isContextual(93)) {
		        var _ref, _ref$specifiers;
		        (_ref$specifiers = (_ref = node).specifiers) != null ? _ref$specifiers : _ref.specifiers = [];
		        var specifier = this.startNodeAt(this.state.lastTokStartLoc);
		        this.next();
		        specifier.exported = this.parseModuleExportName();
		        node.specifiers.push(this.finishNode(specifier, "ExportNamespaceSpecifier"));
		        return true;
		      }
		      return false;
		    };
		    _proto.maybeParseExportNamedSpecifiers = function maybeParseExportNamedSpecifiers(node) {
		      if (this.match(5)) {
		        var _node2$specifiers;
		        var node2 = node;
		        if (!node2.specifiers) node2.specifiers = [];
		        var isTypeExport = node2.exportKind === "type";
		        (_node2$specifiers = node2.specifiers).push.apply(_node2$specifiers, this.parseExportSpecifiers(isTypeExport));
		        node2.source = null;
		        node2.declaration = null;
		        if (this.hasPlugin("importAssertions")) {
		          node2.assertions = [];
		        }
		        return true;
		      }
		      return false;
		    };
		    _proto.maybeParseExportDeclaration = function maybeParseExportDeclaration(node) {
		      if (this.shouldParseExportDeclaration()) {
		        node.specifiers = [];
		        node.source = null;
		        if (this.hasPlugin("importAssertions")) {
		          node.assertions = [];
		        }
		        node.declaration = this.parseExportDeclaration(node);
		        return true;
		      }
		      return false;
		    };
		    _proto.isAsyncFunction = function isAsyncFunction() {
		      if (!this.isContextual(95)) return false;
		      var next = this.nextTokenInLineStart();
		      return this.isUnparsedContextual(next, "function");
		    };
		    _proto.parseExportDefaultExpression = function parseExportDefaultExpression() {
		      var expr = this.startNode();
		      if (this.match(68)) {
		        this.next();
		        return this.parseFunction(expr, ParseFunctionFlag.Declaration | ParseFunctionFlag.NullableId);
		      } else if (this.isAsyncFunction()) {
		        this.next();
		        this.next();
		        return this.parseFunction(expr, ParseFunctionFlag.Declaration | ParseFunctionFlag.NullableId | ParseFunctionFlag.Async);
		      }
		      if (this.match(80)) {
		        return this.parseClass(expr, true, true);
		      }
		      if (this.match(26)) {
		        if (this.hasPlugin("decorators") && this.getPluginOption("decorators", "decoratorsBeforeExport") === true) {
		          this.raise(Errors.DecoratorBeforeExport, this.state.startLoc);
		        }
		        return this.parseClass(this.maybeTakeDecorators(this.parseDecorators(false), this.startNode()), true, true);
		      }
		      if (this.match(75) || this.match(74) || this.isLet()) {
		        throw this.raise(Errors.UnsupportedDefaultExport, this.state.startLoc);
		      }
		      var res = this.parseMaybeAssignAllowIn();
		      this.semicolon();
		      return res;
		    };
		    _proto.parseExportDeclaration = function parseExportDeclaration(node) {
		      if (this.match(80)) {
		        var _node4 = this.parseClass(this.startNode(), true, false);
		        return _node4;
		      }
		      return this.parseStatementListItem();
		    };
		    _proto.isExportDefaultSpecifier = function isExportDefaultSpecifier() {
		      var type = this.state.type;
		      if (tokenIsIdentifier(type)) {
		        if (type === 95 && !this.state.containsEsc || type === 100) {
		          return false;
		        }
		        if ((type === 130 || type === 129) && !this.state.containsEsc) {
		          var _this$lookahead2 = this.lookahead(),
		            nextType = _this$lookahead2.type;
		          if (tokenIsIdentifier(nextType) && nextType !== 98 || nextType === 5) {
		            this.expectOnePlugin(["flow", "typescript"]);
		            return false;
		          }
		        }
		      } else if (!this.match(65)) {
		        return false;
		      }
		      var next = this.nextTokenStart();
		      var hasFrom = this.isUnparsedContextual(next, "from");
		      if (this.input.charCodeAt(next) === 44 || tokenIsIdentifier(this.state.type) && hasFrom) {
		        return true;
		      }
		      if (this.match(65) && hasFrom) {
		        var nextAfterFrom = this.input.charCodeAt(this.nextTokenStartSince(next + 4));
		        return nextAfterFrom === 34 || nextAfterFrom === 39;
		      }
		      return false;
		    };
		    _proto.parseExportFrom = function parseExportFrom(node, expect) {
		      if (this.eatContextual(98)) {
		        node.source = this.parseImportSource();
		        this.checkExport(node);
		        this.maybeParseImportAttributes(node);
		        this.checkJSONModuleImport(node);
		      } else if (expect) {
		        this.unexpected();
		      }
		      this.semicolon();
		    };
		    _proto.shouldParseExportDeclaration = function shouldParseExportDeclaration() {
		      var type = this.state.type;
		      if (type === 26) {
		        this.expectOnePlugin(["decorators", "decorators-legacy"]);
		        if (this.hasPlugin("decorators")) {
		          if (this.getPluginOption("decorators", "decoratorsBeforeExport") === true) {
		            this.raise(Errors.DecoratorBeforeExport, this.state.startLoc);
		          }
		          return true;
		        }
		      }
		      if (this.isContextual(107)) {
		        this.raise(Errors.UsingDeclarationExport, this.state.startLoc);
		        return true;
		      }
		      if (this.isContextual(96) && this.startsAwaitUsing()) {
		        this.raise(Errors.UsingDeclarationExport, this.state.startLoc);
		        return true;
		      }
		      return type === 74 || type === 75 || type === 68 || type === 80 || this.isLet() || this.isAsyncFunction();
		    };
		    _proto.checkExport = function checkExport(node, checkNames, isDefault, isFrom) {
		      if (checkNames) {
		        var _node$specifiers;
		        if (isDefault) {
		          this.checkDuplicateExports(node, "default");
		          if (this.hasPlugin("exportDefaultFrom")) {
		            var _declaration$extra;
		            var declaration = node.declaration;
		            if (declaration.type === "Identifier" && declaration.name === "from" && declaration.end - declaration.start === 4 && !((_declaration$extra = declaration.extra) != null && _declaration$extra.parenthesized)) {
		              this.raise(Errors.ExportDefaultFromAsIdentifier, declaration);
		            }
		          }
		        } else if ((_node$specifiers = node.specifiers) != null && _node$specifiers.length) {
		          for (var _i6 = 0, _node$specifiers3 = node.specifiers; _i6 < _node$specifiers3.length; _i6++) {
		            var specifier = _node$specifiers3[_i6];
		            var exported = specifier.exported;
		            var exportName = exported.type === "Identifier" ? exported.name : exported.value;
		            this.checkDuplicateExports(specifier, exportName);
		            if (!isFrom && specifier.local) {
		              var local = specifier.local;
		              if (local.type !== "Identifier") {
		                this.raise(Errors.ExportBindingIsString, specifier, {
		                  localName: local.value,
		                  exportName: exportName
		                });
		              } else {
		                this.checkReservedWord(local.name, local.loc.start, true, false);
		                this.scope.checkLocalExport(local);
		              }
		            }
		          }
		        } else if (node.declaration) {
		          var decl = node.declaration;
		          if (decl.type === "FunctionDeclaration" || decl.type === "ClassDeclaration") {
		            var id = decl.id;
		            if (!id) throw new Error("Assertion failure");
		            this.checkDuplicateExports(node, id.name);
		          } else if (decl.type === "VariableDeclaration") {
		            for (var _i8 = 0, _decl$declarations2 = decl.declarations; _i8 < _decl$declarations2.length; _i8++) {
		              var _declaration = _decl$declarations2[_i8];
		              this.checkDeclaration(_declaration.id);
		            }
		          }
		        }
		      }
		    };
		    _proto.checkDeclaration = function checkDeclaration(node) {
		      if (node.type === "Identifier") {
		        this.checkDuplicateExports(node, node.name);
		      } else if (node.type === "ObjectPattern") {
		        for (var _i10 = 0, _node$properties2 = node.properties; _i10 < _node$properties2.length; _i10++) {
		          var prop = _node$properties2[_i10];
		          this.checkDeclaration(prop);
		        }
		      } else if (node.type === "ArrayPattern") {
		        for (var _i12 = 0, _node$elements2 = node.elements; _i12 < _node$elements2.length; _i12++) {
		          var elem = _node$elements2[_i12];
		          if (elem) {
		            this.checkDeclaration(elem);
		          }
		        }
		      } else if (node.type === "ObjectProperty") {
		        this.checkDeclaration(node.value);
		      } else if (node.type === "RestElement") {
		        this.checkDeclaration(node.argument);
		      } else if (node.type === "AssignmentPattern") {
		        this.checkDeclaration(node.left);
		      }
		    };
		    _proto.checkDuplicateExports = function checkDuplicateExports(node, exportName) {
		      if (this.exportedIdentifiers.has(exportName)) {
		        if (exportName === "default") {
		          this.raise(Errors.DuplicateDefaultExport, node);
		        } else {
		          this.raise(Errors.DuplicateExport, node, {
		            exportName: exportName
		          });
		        }
		      }
		      this.exportedIdentifiers.add(exportName);
		    };
		    _proto.parseExportSpecifiers = function parseExportSpecifiers(isInTypeExport) {
		      var nodes = [];
		      var first = true;
		      this.expect(5);
		      while (!this.eat(8)) {
		        if (first) {
		          first = false;
		        } else {
		          this.expect(12);
		          if (this.eat(8)) break;
		        }
		        var isMaybeTypeOnly = this.isContextual(130);
		        var isString = this.match(133);
		        var _node5 = this.startNode();
		        _node5.local = this.parseModuleExportName();
		        nodes.push(this.parseExportSpecifier(_node5, isString, isInTypeExport, isMaybeTypeOnly));
		      }
		      return nodes;
		    };
		    _proto.parseExportSpecifier = function parseExportSpecifier(node, isString, isInTypeExport, isMaybeTypeOnly) {
		      if (this.eatContextual(93)) {
		        node.exported = this.parseModuleExportName();
		      } else if (isString) {
		        node.exported = cloneStringLiteral(node.local);
		      } else if (!node.exported) {
		        node.exported = cloneIdentifier(node.local);
		      }
		      return this.finishNode(node, "ExportSpecifier");
		    };
		    _proto.parseModuleExportName = function parseModuleExportName() {
		      if (this.match(133)) {
		        var result = this.parseStringLiteral(this.state.value);
		        var surrogate = result.value.match(loneSurrogate);
		        if (surrogate) {
		          this.raise(Errors.ModuleExportNameHasLoneSurrogate, result, {
		            surrogateCharCode: surrogate[0].charCodeAt(0)
		          });
		        }
		        return result;
		      }
		      return this.parseIdentifier(true);
		    };
		    _proto.isJSONModuleImport = function isJSONModuleImport(node) {
		      if (node.assertions != null) {
		        return node.assertions.some(function (_ref2) {
		          var key = _ref2.key,
		            value = _ref2.value;
		          return value.value === "json" && (key.type === "Identifier" ? key.name === "type" : key.value === "type");
		        });
		      }
		      return false;
		    };
		    _proto.checkImportReflection = function checkImportReflection(node) {
		      var specifiers = node.specifiers;
		      var singleBindingType = specifiers.length === 1 ? specifiers[0].type : null;
		      if (node.phase === "source") {
		        if (singleBindingType !== "ImportDefaultSpecifier") {
		          this.raise(Errors.SourcePhaseImportRequiresDefault, specifiers[0].loc.start);
		        }
		      } else if (node.phase === "defer") {
		        if (singleBindingType !== "ImportNamespaceSpecifier") {
		          this.raise(Errors.DeferImportRequiresNamespace, specifiers[0].loc.start);
		        }
		      } else if (node.module) {
		        var _node$assertions;
		        if (singleBindingType !== "ImportDefaultSpecifier") {
		          this.raise(Errors.ImportReflectionNotBinding, specifiers[0].loc.start);
		        }
		        if (((_node$assertions = node.assertions) == null ? void 0 : _node$assertions.length) > 0) {
		          this.raise(Errors.ImportReflectionHasAssertion, specifiers[0].loc.start);
		        }
		      }
		    };
		    _proto.checkJSONModuleImport = function checkJSONModuleImport(node) {
		      if (this.isJSONModuleImport(node) && node.type !== "ExportAllDeclaration") {
		        var specifiers = node.specifiers;
		        if (specifiers != null) {
		          var nonDefaultNamedSpecifier = specifiers.find(function (specifier) {
		            var imported;
		            if (specifier.type === "ExportSpecifier") {
		              imported = specifier.local;
		            } else if (specifier.type === "ImportSpecifier") {
		              imported = specifier.imported;
		            }
		            if (imported !== undefined) {
		              return imported.type === "Identifier" ? imported.name !== "default" : imported.value !== "default";
		            }
		          });
		          if (nonDefaultNamedSpecifier !== undefined) {
		            this.raise(Errors.ImportJSONBindingNotDefault, nonDefaultNamedSpecifier.loc.start);
		          }
		        }
		      }
		    };
		    _proto.isPotentialImportPhase = function isPotentialImportPhase(isExport) {
		      if (isExport) return false;
		      return this.isContextual(105) || this.isContextual(97) || this.isContextual(127);
		    };
		    _proto.applyImportPhase = function applyImportPhase(node, isExport, phase, loc) {
		      if (isExport) {
		        return;
		      }
		      if (phase === "module") {
		        this.expectPlugin("importReflection", loc);
		        node.module = true;
		      } else if (this.hasPlugin("importReflection")) {
		        node.module = false;
		      }
		      if (phase === "source") {
		        this.expectPlugin("sourcePhaseImports", loc);
		        node.phase = "source";
		      } else if (phase === "defer") {
		        this.expectPlugin("deferredImportEvaluation", loc);
		        node.phase = "defer";
		      } else if (this.hasPlugin("sourcePhaseImports")) {
		        node.phase = null;
		      }
		    };
		    _proto.parseMaybeImportPhase = function parseMaybeImportPhase(node, isExport) {
		      if (!this.isPotentialImportPhase(isExport)) {
		        this.applyImportPhase(node, isExport, null);
		        return null;
		      }
		      var phaseIdentifier = this.parseIdentifier(true);
		      var type = this.state.type;
		      var isImportPhase = tokenIsKeywordOrIdentifier(type) ? type !== 98 || this.lookaheadCharCode() === 102 : type !== 12;
		      if (isImportPhase) {
		        this.resetPreviousIdentifierLeadingComments(phaseIdentifier);
		        this.applyImportPhase(node, isExport, phaseIdentifier.name, phaseIdentifier.loc.start);
		        return null;
		      } else {
		        this.applyImportPhase(node, isExport, null);
		        return phaseIdentifier;
		      }
		    };
		    _proto.isPrecedingIdImportPhase = function isPrecedingIdImportPhase(phase) {
		      var type = this.state.type;
		      return tokenIsIdentifier(type) ? type !== 98 || this.lookaheadCharCode() === 102 : type !== 12;
		    };
		    _proto.parseImport = function parseImport(node) {
		      if (this.match(133)) {
		        return this.parseImportSourceAndAttributes(node);
		      }
		      return this.parseImportSpecifiersAndAfter(node, this.parseMaybeImportPhase(node, false));
		    };
		    _proto.parseImportSpecifiersAndAfter = function parseImportSpecifiersAndAfter(node, maybeDefaultIdentifier) {
		      node.specifiers = [];
		      var hasDefault = this.maybeParseDefaultImportSpecifier(node, maybeDefaultIdentifier);
		      var parseNext = !hasDefault || this.eat(12);
		      var hasStar = parseNext && this.maybeParseStarImportSpecifier(node);
		      if (parseNext && !hasStar) this.parseNamedImportSpecifiers(node);
		      this.expectContextual(98);
		      return this.parseImportSourceAndAttributes(node);
		    };
		    _proto.parseImportSourceAndAttributes = function parseImportSourceAndAttributes(node) {
		      var _node$specifiers4;
		      (_node$specifiers4 = node.specifiers) != null ? _node$specifiers4 : node.specifiers = [];
		      node.source = this.parseImportSource();
		      this.maybeParseImportAttributes(node);
		      this.checkImportReflection(node);
		      this.checkJSONModuleImport(node);
		      this.semicolon();
		      return this.finishNode(node, "ImportDeclaration");
		    };
		    _proto.parseImportSource = function parseImportSource() {
		      if (!this.match(133)) this.unexpected();
		      return this.parseExprAtom();
		    };
		    _proto.parseImportSpecifierLocal = function parseImportSpecifierLocal(node, specifier, type) {
		      specifier.local = this.parseIdentifier();
		      node.specifiers.push(this.finishImportSpecifier(specifier, type));
		    };
		    _proto.finishImportSpecifier = function finishImportSpecifier(specifier, type, bindingType) {
		      if (bindingType === void 0) {
		        bindingType = BindingFlag.TYPE_LEXICAL;
		      }
		      this.checkLVal(specifier.local, {
		        "in": {
		          type: type
		        },
		        binding: bindingType
		      });
		      return this.finishNode(specifier, type);
		    };
		    _proto.parseImportAttributes = function parseImportAttributes() {
		      this.expect(5);
		      var attrs = [];
		      var attrNames = new Set();
		      do {
		        if (this.match(8)) {
		          break;
		        }
		        var _node6 = this.startNode();
		        var keyName = this.state.value;
		        if (attrNames.has(keyName)) {
		          this.raise(Errors.ModuleAttributesWithDuplicateKeys, this.state.startLoc, {
		            key: keyName
		          });
		        }
		        attrNames.add(keyName);
		        if (this.match(133)) {
		          _node6.key = this.parseStringLiteral(keyName);
		        } else {
		          _node6.key = this.parseIdentifier(true);
		        }
		        this.expect(14);
		        if (!this.match(133)) {
		          throw this.raise(Errors.ModuleAttributeInvalidValue, this.state.startLoc);
		        }
		        _node6.value = this.parseStringLiteral(this.state.value);
		        attrs.push(this.finishNode(_node6, "ImportAttribute"));
		      } while (this.eat(12));
		      this.expect(8);
		      return attrs;
		    };
		    _proto.parseModuleAttributes = function parseModuleAttributes() {
		      var attrs = [];
		      var attributes = new Set();
		      do {
		        var _node7 = this.startNode();
		        _node7.key = this.parseIdentifier(true);
		        if (_node7.key.name !== "type") {
		          this.raise(Errors.ModuleAttributeDifferentFromType, _node7.key);
		        }
		        if (attributes.has(_node7.key.name)) {
		          this.raise(Errors.ModuleAttributesWithDuplicateKeys, _node7.key, {
		            key: _node7.key.name
		          });
		        }
		        attributes.add(_node7.key.name);
		        this.expect(14);
		        if (!this.match(133)) {
		          throw this.raise(Errors.ModuleAttributeInvalidValue, this.state.startLoc);
		        }
		        _node7.value = this.parseStringLiteral(this.state.value);
		        attrs.push(this.finishNode(_node7, "ImportAttribute"));
		      } while (this.eat(12));
		      return attrs;
		    };
		    _proto.maybeParseImportAttributes = function maybeParseImportAttributes(node) {
		      var attributes;
		      var useWith = false;
		      if (this.match(76)) {
		        if (this.hasPrecedingLineBreak() && this.lookaheadCharCode() === 40) {
		          return;
		        }
		        this.next();
		        {
		          if (this.hasPlugin("moduleAttributes")) {
		            attributes = this.parseModuleAttributes();
		          } else {
		            this.expectImportAttributesPlugin();
		            attributes = this.parseImportAttributes();
		          }
		        }
		        useWith = true;
		      } else if (this.isContextual(94) && !this.hasPrecedingLineBreak()) {
		        if (this.hasPlugin("importAttributes")) {
		          if (this.getPluginOption("importAttributes", "deprecatedAssertSyntax") !== true) {
		            this.raise(Errors.ImportAttributesUseAssert, this.state.startLoc);
		          }
		          this.addExtra(node, "deprecatedAssertSyntax", true);
		        } else {
		          this.expectOnePlugin(["importAttributes", "importAssertions"]);
		        }
		        this.next();
		        attributes = this.parseImportAttributes();
		      } else if (this.hasPlugin("importAttributes") || this.hasPlugin("importAssertions")) {
		        attributes = [];
		      } else {
		        if (this.hasPlugin("moduleAttributes")) {
		          attributes = [];
		        } else return;
		      }
		      if (!useWith && this.hasPlugin("importAssertions")) {
		        node.assertions = attributes;
		      } else {
		        node.attributes = attributes;
		      }
		    };
		    _proto.maybeParseDefaultImportSpecifier = function maybeParseDefaultImportSpecifier(node, maybeDefaultIdentifier) {
		      if (maybeDefaultIdentifier) {
		        var specifier = this.startNodeAtNode(maybeDefaultIdentifier);
		        specifier.local = maybeDefaultIdentifier;
		        node.specifiers.push(this.finishImportSpecifier(specifier, "ImportDefaultSpecifier"));
		        return true;
		      } else if (tokenIsKeywordOrIdentifier(this.state.type)) {
		        this.parseImportSpecifierLocal(node, this.startNode(), "ImportDefaultSpecifier");
		        return true;
		      }
		      return false;
		    };
		    _proto.maybeParseStarImportSpecifier = function maybeParseStarImportSpecifier(node) {
		      if (this.match(55)) {
		        var specifier = this.startNode();
		        this.next();
		        this.expectContextual(93);
		        this.parseImportSpecifierLocal(node, specifier, "ImportNamespaceSpecifier");
		        return true;
		      }
		      return false;
		    };
		    _proto.parseNamedImportSpecifiers = function parseNamedImportSpecifiers(node) {
		      var first = true;
		      this.expect(5);
		      while (!this.eat(8)) {
		        if (first) {
		          first = false;
		        } else {
		          if (this.eat(14)) {
		            throw this.raise(Errors.DestructureNamedImport, this.state.startLoc);
		          }
		          this.expect(12);
		          if (this.eat(8)) break;
		        }
		        var specifier = this.startNode();
		        var importedIsString = this.match(133);
		        var isMaybeTypeOnly = this.isContextual(130);
		        specifier.imported = this.parseModuleExportName();
		        var importSpecifier = this.parseImportSpecifier(specifier, importedIsString, node.importKind === "type" || node.importKind === "typeof", isMaybeTypeOnly, undefined);
		        node.specifiers.push(importSpecifier);
		      }
		    };
		    _proto.parseImportSpecifier = function parseImportSpecifier(specifier, importedIsString, isInTypeOnlyImport, isMaybeTypeOnly, bindingType) {
		      if (this.eatContextual(93)) {
		        specifier.local = this.parseIdentifier();
		      } else {
		        var imported = specifier.imported;
		        if (importedIsString) {
		          throw this.raise(Errors.ImportBindingIsString, specifier, {
		            importName: imported.value
		          });
		        }
		        this.checkReservedWord(imported.name, specifier.loc.start, true, true);
		        if (!specifier.local) {
		          specifier.local = cloneIdentifier(imported);
		        }
		      }
		      return this.finishImportSpecifier(specifier, "ImportSpecifier", bindingType);
		    };
		    _proto.isThisParam = function isThisParam(param) {
		      return param.type === "Identifier" && param.name === "this";
		    };
		    return _createClass(StatementParser);
		  }(ExpressionParser);

		  var Parser = function (_StatementParser) {
		    function Parser(options, input) {
		      var _this;
		      options = getOptions(options);
		      _this = _StatementParser.call(this, options, input) || this;
		      _this.options = options;
		      _this.initializeScopes();
		      _this.plugins = pluginsMap(_this.options.plugins);
		      _this.filename = options.sourceFilename;
		      return _this;
		    }
		    _inherits(Parser, _StatementParser);
		    var _proto = Parser.prototype;
		    _proto.getScopeHandler = function getScopeHandler() {
		      return ScopeHandler;
		    };
		    _proto.parse = function parse() {
		      this.enterInitialScopes();
		      var file = this.startNode();
		      var program = this.startNode();
		      this.nextToken();
		      file.errors = null;
		      this.parseTopLevel(file, program);
		      file.errors = this.state.errors;
		      file.comments.length = this.state.commentsLen;
		      return file;
		    };
		    return _createClass(Parser);
		  }(StatementParser);
		  function pluginsMap(plugins) {
		    var pluginMap = new Map();
		    for (var _i2 = 0; _i2 < plugins.length; _i2++) {
		      var plugin = plugins[_i2];
		      var _ref = Array.isArray(plugin) ? plugin : [plugin, {}],
		        name = _ref[0],
		        options = _ref[1];
		      if (!pluginMap.has(name)) pluginMap.set(name, options || {});
		    }
		    return pluginMap;
		  }

		  function parse$4(input, options) {
		    var _options;
		    if (((_options = options) == null ? void 0 : _options.sourceType) === "unambiguous") {
		      options = Object.assign({}, options);
		      try {
		        options.sourceType = "module";
		        var parser = getParser(options, input);
		        var ast = parser.parse();
		        if (parser.sawUnambiguousESM) {
		          return ast;
		        }
		        if (parser.ambiguousScriptDifferentAst) {
		          try {
		            options.sourceType = "script";
		            return getParser(options, input).parse();
		          } catch (_unused) {}
		        } else {
		          ast.program.sourceType = "script";
		        }
		        return ast;
		      } catch (moduleError) {
		        try {
		          options.sourceType = "script";
		          return getParser(options, input).parse();
		        } catch (_unused2) {}
		        throw moduleError;
		      }
		    } else {
		      return getParser(options, input).parse();
		    }
		  }
		  function parseExpression(input, options) {
		    var parser = getParser(options, input);
		    if (parser.options.strictMode) {
		      parser.state.strict = true;
		    }
		    return parser.getExpression();
		  }
		  function generateExportedTokenTypes(internalTokenTypes) {
		    var tokenTypes = {};
		    for (var _i2 = 0, _Object$keys2 = Object.keys(internalTokenTypes); _i2 < _Object$keys2.length; _i2++) {
		      var typeName = _Object$keys2[_i2];
		      tokenTypes[typeName] = getExportedToken(internalTokenTypes[typeName]);
		    }
		    return tokenTypes;
		  }
		  var tokTypes = generateExportedTokenTypes(tt);
		  function getParser(options, input) {
		    var cls = Parser;
		    if (options != null && options.plugins) {
		      validatePlugins(options.plugins);
		      cls = getParserClass(options.plugins);
		    }
		    return new cls(options, input);
		  }
		  var parserClassCache = {};
		  function getParserClass(pluginsFromOptions) {
		    var pluginList = mixinPluginNames.filter(function (name) {
		      return hasPlugin(pluginsFromOptions, name);
		    });
		    var key = pluginList.join("/");
		    var cls = parserClassCache[key];
		    if (!cls) {
		      cls = Parser;
		      for (var _i4 = 0; _i4 < pluginList.length; _i4++) {
		        var plugin = pluginList[_i4];
		        cls = mixinPlugins[plugin](cls);
		      }
		      parserClassCache[key] = cls;
		    }
		    return cls;
		  }

		  var index$3 = /*#__PURE__*/Object.freeze({
		    __proto__: null,
		    parse: parse$4,
		    parseExpression: parseExpression,
		    tokTypes: tokTypes
		  });

		  var assignmentExpression$c = assignmentExpression$d,
		    expressionStatement$9 = expressionStatement$a,
		    identifier$f = identifier$j;
		  var visitor$4 = {
		    Scope: function Scope(path, state) {
		      if (state.kind === "let") path.skip();
		    },
		    FunctionParent: function FunctionParent(path) {
		      path.skip();
		    },
		    VariableDeclaration: function (_VariableDeclaration) {
		      function VariableDeclaration(_x, _x2) {
		        return _VariableDeclaration.apply(this, arguments);
		      }
		      VariableDeclaration.toString = function () {
		        return _VariableDeclaration.toString();
		      };
		      return VariableDeclaration;
		    }(function (path, state) {
		      if (state.kind && path.node.kind !== state.kind) return;
		      var nodes = [];
		      var declarations = path.get("declarations");
		      var firstId;
		      for (var _iterator = _createForOfIteratorHelperLoose(declarations), _step; !(_step = _iterator()).done;) {
		        var declar = _step.value;
		        firstId = declar.node.id;
		        if (declar.node.init) {
		          nodes.push(expressionStatement$9(assignmentExpression$c("=", declar.node.id, declar.node.init)));
		        }
		        for (var _i = 0, _Object$keys = Object.keys(declar.getBindingIdentifiers()); _i < _Object$keys.length; _i++) {
		          var name = _Object$keys[_i];
		          state.emit(identifier$f(name), name, declar.node.init !== null);
		        }
		      }
		      if (path.parentPath.isFor({
		        left: path.node
		      })) {
		        path.replaceWith(firstId);
		      } else {
		        path.replaceWithMultiple(nodes);
		      }
		    })
		  };
		  function hoistVariables(path, emit, kind) {
		    if (kind === void 0) {
		      kind = "var";
		    }
		    path.traverse(visitor$4, {
		      kind: kind,
		      emit: emit
		    });
		  }

		  var FUNCTION_TYPES = FUNCTION_TYPES$1,
		    arrowFunctionExpression$3 = arrowFunctionExpression$4,
		    assignmentExpression$b = assignmentExpression$d,
		    awaitExpression = awaitExpression$1,
		    blockStatement$5 = blockStatement$6,
		    buildUndefinedNode$1 = buildUndefinedNode$2,
		    callExpression$b = callExpression$d,
		    cloneNode$g = cloneNode$j,
		    conditionalExpression$4 = conditionalExpression$5,
		    expressionStatement$8 = expressionStatement$a,
		    getBindingIdentifiers$2 = getBindingIdentifiers$4,
		    identifier$e = identifier$j,
		    inheritLeadingComments = inheritLeadingComments$1,
		    inheritTrailingComments = inheritTrailingComments$1,
		    inheritsComments = inheritsComments$1,
		    isBlockStatement$1 = isBlockStatement$3,
		    isEmptyStatement = isEmptyStatement$1,
		    isExpression$2 = isExpression$4,
		    isExpressionStatement$1 = isExpressionStatement$2,
		    isIfStatement = isIfStatement$2,
		    isProgram = isProgram$1,
		    isStatement$2 = isStatement$8,
		    isVariableDeclaration$1 = isVariableDeclaration$4,
		    removeComments = removeComments$1,
		    returnStatement$2 = returnStatement$3,
		    sequenceExpression$7 = sequenceExpression$8,
		    validate$4 = validate$5,
		    yieldExpression$1 = yieldExpression$2;
		  function replaceWithMultiple(nodes) {
		    var _getCachedPaths;
		    this.resync();
		    nodes = this._verifyNodeList(nodes);
		    inheritLeadingComments(nodes[0], this.node);
		    inheritTrailingComments(nodes[nodes.length - 1], this.node);
		    (_getCachedPaths = getCachedPaths(this.hub, this.parent)) == null || _getCachedPaths["delete"](this.node);
		    this.node = this.container[this.key] = null;
		    var paths = this.insertAfter(nodes);
		    if (this.node) {
		      this.requeue();
		    } else {
		      this.remove();
		    }
		    return paths;
		  }
		  function replaceWithSourceString(replacement) {
		    this.resync();
		    var ast;
		    try {
		      replacement = "(" + replacement + ")";
		      ast = parse$4(replacement);
		    } catch (err) {
		      var loc = err.loc;
		      if (loc) {
		        err.message += " - make sure this is an expression.\n" + codeFrameColumns(replacement, {
		          start: {
		            line: loc.line,
		            column: loc.column + 1
		          }
		        });
		        err.code = "BABEL_REPLACE_SOURCE_ERROR";
		      }
		      throw err;
		    }
		    var expressionAST = ast.program.body[0].expression;
		    traverse.removeProperties(expressionAST);
		    return this.replaceWith(expressionAST);
		  }
		  function replaceWith(replacementPath) {
		    this.resync();
		    if (this.removed) {
		      throw new Error("You can't replace this node, we've already removed it");
		    }
		    var replacement = replacementPath instanceof NodePath_Final ? replacementPath.node : replacementPath;
		    if (!replacement) {
		      throw new Error("You passed `path.replaceWith()` a falsy node, use `path.remove()` instead");
		    }
		    if (this.node === replacement) {
		      return [this];
		    }
		    if (this.isProgram() && !isProgram(replacement)) {
		      throw new Error("You can only replace a Program root node with another Program node");
		    }
		    if (Array.isArray(replacement)) {
		      throw new Error("Don't use `path.replaceWith()` with an array of nodes, use `path.replaceWithMultiple()`");
		    }
		    if (typeof replacement === "string") {
		      throw new Error("Don't use `path.replaceWith()` with a source string, use `path.replaceWithSourceString()`");
		    }
		    var nodePath = "";
		    if (this.isNodeType("Statement") && isExpression$2(replacement)) {
		      if (!this.canHaveVariableDeclarationOrExpression() && !this.canSwapBetweenExpressionAndStatement(replacement) && !this.parentPath.isExportDefaultDeclaration()) {
		        replacement = expressionStatement$8(replacement);
		        nodePath = "expression";
		      }
		    }
		    if (this.isNodeType("Expression") && isStatement$2(replacement)) {
		      if (!this.canHaveVariableDeclarationOrExpression() && !this.canSwapBetweenExpressionAndStatement(replacement)) {
		        return this.replaceExpressionWithStatements([replacement]);
		      }
		    }
		    var oldNode = this.node;
		    if (oldNode) {
		      inheritsComments(replacement, oldNode);
		      removeComments(oldNode);
		    }
		    this._replaceWith(replacement);
		    this.type = replacement.type;
		    this.setScope();
		    this.requeue();
		    return [nodePath ? this.get(nodePath) : this];
		  }
		  function _replaceWith(node) {
		    var _getCachedPaths2;
		    if (!this.container) {
		      throw new ReferenceError("Container is falsy");
		    }
		    if (this.inList) {
		      validate$4(this.parent, this.key, [node]);
		    } else {
		      validate$4(this.parent, this.key, node);
		    }
		    this.debug("Replace with " + (node == null ? void 0 : node.type));
		    (_getCachedPaths2 = getCachedPaths(this.hub, this.parent)) == null || _getCachedPaths2.set(node, this)["delete"](this.node);
		    this.node = this.container[this.key] = node;
		  }
		  function replaceExpressionWithStatements(nodes) {
		    var _this = this;
		    this.resync();
		    var declars = [];
		    var nodesAsSingleExpression = gatherSequenceExpressions(nodes, declars);
		    if (nodesAsSingleExpression) {
		      for (var _iterator = _createForOfIteratorHelperLoose(declars), _step; !(_step = _iterator()).done;) {
		        var id = _step.value;
		        this.scope.push({
		          id: id
		        });
		      }
		      return this.replaceWith(nodesAsSingleExpression)[0].get("expressions");
		    }
		    var functionParent = this.getFunctionParent();
		    var isParentAsync = functionParent == null ? void 0 : functionParent.is("async");
		    var isParentGenerator = functionParent == null ? void 0 : functionParent.is("generator");
		    var container = arrowFunctionExpression$3([], blockStatement$5(nodes));
		    this.replaceWith(callExpression$b(container, []));
		    var callee = this.get("callee");
		    hoistVariables(callee.get("body"), function (id) {
		      _this.scope.push({
		        id: id
		      });
		    }, "var");
		    var completionRecords = this.get("callee").getCompletionRecords();
		    for (var _iterator2 = _createForOfIteratorHelperLoose(completionRecords), _step2; !(_step2 = _iterator2()).done;) {
		      var path = _step2.value;
		      if (!path.isExpressionStatement()) continue;
		      var loop = path.findParent(function (path) {
		        return path.isLoop();
		      });
		      if (loop) {
		        var uid = loop.getData("expressionReplacementReturnUid");
		        if (!uid) {
		          uid = callee.scope.generateDeclaredUidIdentifier("ret");
		          callee.get("body").pushContainer("body", returnStatement$2(cloneNode$g(uid)));
		          loop.setData("expressionReplacementReturnUid", uid);
		        } else {
		          uid = identifier$e(uid.name);
		        }
		        path.get("expression").replaceWith(assignmentExpression$b("=", cloneNode$g(uid), path.node.expression));
		      } else {
		        path.replaceWith(returnStatement$2(path.node.expression));
		      }
		    }
		    callee.arrowFunctionToExpression();
		    var newCallee = callee;
		    var needToAwaitFunction = isParentAsync && traverse.hasType(this.get("callee.body").node, "AwaitExpression", FUNCTION_TYPES);
		    var needToYieldFunction = isParentGenerator && traverse.hasType(this.get("callee.body").node, "YieldExpression", FUNCTION_TYPES);
		    if (needToAwaitFunction) {
		      newCallee.set("async", true);
		      if (!needToYieldFunction) {
		        this.replaceWith(awaitExpression(this.node));
		      }
		    }
		    if (needToYieldFunction) {
		      newCallee.set("generator", true);
		      this.replaceWith(yieldExpression$1(this.node, true));
		    }
		    return newCallee.get("body.body");
		  }
		  function gatherSequenceExpressions(nodes, declars) {
		    var exprs = [];
		    var ensureLastUndefined = true;
		    for (var _iterator3 = _createForOfIteratorHelperLoose(nodes), _step3; !(_step3 = _iterator3()).done;) {
		      var node = _step3.value;
		      if (!isEmptyStatement(node)) {
		        ensureLastUndefined = false;
		      }
		      if (isExpression$2(node)) {
		        exprs.push(node);
		      } else if (isExpressionStatement$1(node)) {
		        exprs.push(node.expression);
		      } else if (isVariableDeclaration$1(node)) {
		        if (node.kind !== "var") return;
		        for (var _iterator4 = _createForOfIteratorHelperLoose(node.declarations), _step4; !(_step4 = _iterator4()).done;) {
		          var declar = _step4.value;
		          var bindings = getBindingIdentifiers$2(declar);
		          for (var _i = 0, _Object$keys = Object.keys(bindings); _i < _Object$keys.length; _i++) {
		            var key = _Object$keys[_i];
		            declars.push(cloneNode$g(bindings[key]));
		          }
		          if (declar.init) {
		            exprs.push(assignmentExpression$b("=", declar.id, declar.init));
		          }
		        }
		        ensureLastUndefined = true;
		      } else if (isIfStatement(node)) {
		        var consequent = node.consequent ? gatherSequenceExpressions([node.consequent], declars) : buildUndefinedNode$1();
		        var alternate = node.alternate ? gatherSequenceExpressions([node.alternate], declars) : buildUndefinedNode$1();
		        if (!consequent || !alternate) return;
		        exprs.push(conditionalExpression$4(node.test, consequent, alternate));
		      } else if (isBlockStatement$1(node)) {
		        var body = gatherSequenceExpressions(node.body, declars);
		        if (!body) return;
		        exprs.push(body);
		      } else if (isEmptyStatement(node)) {
		        if (nodes.indexOf(node) === 0) {
		          ensureLastUndefined = true;
		        }
		      } else {
		        return;
		      }
		    }
		    if (ensureLastUndefined) exprs.push(buildUndefinedNode$1());
		    if (exprs.length === 1) {
		      return exprs[0];
		    } else {
		      return sequenceExpression$7(exprs);
		    }
		  }
		  function replaceInline(nodes) {
		    this.resync();
		    if (Array.isArray(nodes)) {
		      if (Array.isArray(this.container)) {
		        nodes = this._verifyNodeList(nodes);
		        var paths = this._containerInsertAfter(nodes);
		        this.remove();
		        return paths;
		      } else {
		        return this.replaceWithMultiple(nodes);
		      }
		    } else {
		      return this.replaceWith(nodes);
		    }
		  }

		  var NodePath_replacement = /*#__PURE__*/Object.freeze({
		    __proto__: null,
		    _replaceWith: _replaceWith,
		    replaceExpressionWithStatements: replaceExpressionWithStatements,
		    replaceInline: replaceInline,
		    replaceWith: replaceWith,
		    replaceWithMultiple: replaceWithMultiple,
		    replaceWithSourceString: replaceWithSourceString
		  });

		  var VALID_OBJECT_CALLEES = ["Number", "String", "Math"];
		  var VALID_IDENTIFIER_CALLEES = ["isFinite", "isNaN", "parseFloat", "parseInt", "decodeURI", "decodeURIComponent", "encodeURI", "encodeURIComponent", null, null];
		  var INVALID_METHODS = ["random"];
		  function isValidObjectCallee(val) {
		    return VALID_OBJECT_CALLEES.includes(val);
		  }
		  function isValidIdentifierCallee(val) {
		    return VALID_IDENTIFIER_CALLEES.includes(val);
		  }
		  function isInvalidMethod(val) {
		    return INVALID_METHODS.includes(val);
		  }
		  function evaluateTruthy() {
		    var res = this.evaluate();
		    if (res.confident) return !!res.value;
		  }
		  function deopt(path, state) {
		    if (!state.confident) return;
		    state.deoptPath = path;
		    state.confident = false;
		  }
		  var Globals = new Map([["undefined", undefined], ["Infinity", Infinity], ["NaN", NaN]]);
		  function evaluateCached(path, state) {
		    var node = path.node;
		    var seen = state.seen;
		    if (seen.has(node)) {
		      var existing = seen.get(node);
		      if (existing.resolved) {
		        return existing.value;
		      } else {
		        deopt(path, state);
		        return;
		      }
		    } else {
		      var item = {
		        resolved: false
		      };
		      seen.set(node, item);
		      var val = _evaluate(path, state);
		      if (state.confident) {
		        item.resolved = true;
		        item.value = val;
		      }
		      return val;
		    }
		  }
		  function _evaluate(path, state) {
		    if (!state.confident) return;
		    if (path.isSequenceExpression()) {
		      var exprs = path.get("expressions");
		      return evaluateCached(exprs[exprs.length - 1], state);
		    }
		    if (path.isStringLiteral() || path.isNumericLiteral() || path.isBooleanLiteral()) {
		      return path.node.value;
		    }
		    if (path.isNullLiteral()) {
		      return null;
		    }
		    if (path.isTemplateLiteral()) {
		      return evaluateQuasis(path, path.node.quasis, state);
		    }
		    if (path.isTaggedTemplateExpression() && path.get("tag").isMemberExpression()) {
		      var object = path.get("tag.object");
		      var name = object.node.name;
		      var property = path.get("tag.property");
		      if (object.isIdentifier() && name === "String" && !path.scope.getBinding(name) && property.isIdentifier() && property.node.name === "raw") {
		        return evaluateQuasis(path, path.node.quasi.quasis, state, true);
		      }
		    }
		    if (path.isConditionalExpression()) {
		      var testResult = evaluateCached(path.get("test"), state);
		      if (!state.confident) return;
		      if (testResult) {
		        return evaluateCached(path.get("consequent"), state);
		      } else {
		        return evaluateCached(path.get("alternate"), state);
		      }
		    }
		    if (path.isExpressionWrapper()) {
		      return evaluateCached(path.get("expression"), state);
		    }
		    if (path.isMemberExpression() && !path.parentPath.isCallExpression({
		      callee: path.node
		    })) {
		      var _property = path.get("property");
		      var _object = path.get("object");
		      if (_object.isLiteral()) {
		        var value = _object.node.value;
		        var type = typeof value;
		        var key = null;
		        if (path.node.computed) {
		          key = evaluateCached(_property, state);
		          if (!state.confident) return;
		        } else if (_property.isIdentifier()) {
		          key = _property.node.name;
		        }
		        if ((type === "number" || type === "string") && key != null && (typeof key === "number" || typeof key === "string")) {
		          return value[key];
		        }
		      }
		    }
		    if (path.isReferencedIdentifier()) {
		      var binding = path.scope.getBinding(path.node.name);
		      if (binding) {
		        if (binding.constantViolations.length > 0 || path.node.start < binding.path.node.end) {
		          deopt(binding.path, state);
		          return;
		        }
		        if (binding.hasValue) {
		          return binding.value;
		        }
		      }
		      var _name = path.node.name;
		      if (Globals.has(_name)) {
		        if (!binding) {
		          return Globals.get(_name);
		        }
		        deopt(binding.path, state);
		        return;
		      }
		      var resolved = path.resolve();
		      if (resolved === path) {
		        deopt(path, state);
		        return;
		      } else {
		        return evaluateCached(resolved, state);
		      }
		    }
		    if (path.isUnaryExpression({
		      prefix: true
		    })) {
		      if (path.node.operator === "void") {
		        return undefined;
		      }
		      var argument = path.get("argument");
		      if (path.node.operator === "typeof" && (argument.isFunction() || argument.isClass())) {
		        return "function";
		      }
		      var arg = evaluateCached(argument, state);
		      if (!state.confident) return;
		      switch (path.node.operator) {
		        case "!":
		          return !arg;
		        case "+":
		          return +arg;
		        case "-":
		          return -arg;
		        case "~":
		          return ~arg;
		        case "typeof":
		          return typeof arg;
		      }
		    }
		    if (path.isArrayExpression()) {
		      var arr = [];
		      var elems = path.get("elements");
		      for (var _iterator = _createForOfIteratorHelperLoose(elems), _step; !(_step = _iterator()).done;) {
		        var elem = _step.value;
		        var elemValue = elem.evaluate();
		        if (elemValue.confident) {
		          arr.push(elemValue.value);
		        } else {
		          deopt(elemValue.deopt, state);
		          return;
		        }
		      }
		      return arr;
		    }
		    if (path.isObjectExpression()) {
		      var obj = {};
		      var props = path.get("properties");
		      for (var _iterator2 = _createForOfIteratorHelperLoose(props), _step2; !(_step2 = _iterator2()).done;) {
		        var prop = _step2.value;
		        if (prop.isObjectMethod() || prop.isSpreadElement()) {
		          deopt(prop, state);
		          return;
		        }
		        var keyPath = prop.get("key");
		        var _key = void 0;
		        if (prop.node.computed) {
		          _key = keyPath.evaluate();
		          if (!_key.confident) {
		            deopt(_key.deopt, state);
		            return;
		          }
		          _key = _key.value;
		        } else if (keyPath.isIdentifier()) {
		          _key = keyPath.node.name;
		        } else {
		          _key = keyPath.node.value;
		        }
		        var valuePath = prop.get("value");
		        var _value = valuePath.evaluate();
		        if (!_value.confident) {
		          deopt(_value.deopt, state);
		          return;
		        }
		        _value = _value.value;
		        obj[_key] = _value;
		      }
		      return obj;
		    }
		    if (path.isLogicalExpression()) {
		      var wasConfident = state.confident;
		      var left = evaluateCached(path.get("left"), state);
		      var leftConfident = state.confident;
		      state.confident = wasConfident;
		      var right = evaluateCached(path.get("right"), state);
		      var rightConfident = state.confident;
		      switch (path.node.operator) {
		        case "||":
		          state.confident = leftConfident && (!!left || rightConfident);
		          if (!state.confident) return;
		          return left || right;
		        case "&&":
		          state.confident = leftConfident && (!left || rightConfident);
		          if (!state.confident) return;
		          return left && right;
		        case "??":
		          state.confident = leftConfident && (left != null || rightConfident);
		          if (!state.confident) return;
		          return left != null ? left : right;
		      }
		    }
		    if (path.isBinaryExpression()) {
		      var _left = evaluateCached(path.get("left"), state);
		      if (!state.confident) return;
		      var _right = evaluateCached(path.get("right"), state);
		      if (!state.confident) return;
		      switch (path.node.operator) {
		        case "-":
		          return _left - _right;
		        case "+":
		          return _left + _right;
		        case "/":
		          return _left / _right;
		        case "*":
		          return _left * _right;
		        case "%":
		          return _left % _right;
		        case "**":
		          return Math.pow(_left, _right);
		        case "<":
		          return _left < _right;
		        case ">":
		          return _left > _right;
		        case "<=":
		          return _left <= _right;
		        case ">=":
		          return _left >= _right;
		        case "==":
		          return _left == _right;
		        case "!=":
		          return _left != _right;
		        case "===":
		          return _left === _right;
		        case "!==":
		          return _left !== _right;
		        case "|":
		          return _left | _right;
		        case "&":
		          return _left & _right;
		        case "^":
		          return _left ^ _right;
		        case "<<":
		          return _left << _right;
		        case ">>":
		          return _left >> _right;
		        case ">>>":
		          return _left >>> _right;
		      }
		    }
		    if (path.isCallExpression()) {
		      var callee = path.get("callee");
		      var context;
		      var func;
		      if (callee.isIdentifier() && !path.scope.getBinding(callee.node.name) && (isValidObjectCallee(callee.node.name) || isValidIdentifierCallee(callee.node.name))) {
		        func = global$1[callee.node.name];
		      }
		      if (callee.isMemberExpression()) {
		        var _object2 = callee.get("object");
		        var _property2 = callee.get("property");
		        if (_object2.isIdentifier() && _property2.isIdentifier() && isValidObjectCallee(_object2.node.name) && !isInvalidMethod(_property2.node.name)) {
		          context = global$1[_object2.node.name];
		          var _key2 = _property2.node.name;
		          if (hasOwnProperty.call(context, _key2)) {
		            func = context[_key2];
		          }
		        }
		        if (_object2.isLiteral() && _property2.isIdentifier()) {
		          var _type = typeof _object2.node.value;
		          if (_type === "string" || _type === "number") {
		            context = _object2.node.value;
		            func = context[_property2.node.name];
		          }
		        }
		      }
		      if (func) {
		        var args = path.get("arguments").map(function (arg) {
		          return evaluateCached(arg, state);
		        });
		        if (!state.confident) return;
		        return func.apply(context, args);
		      }
		    }
		    deopt(path, state);
		  }
		  function evaluateQuasis(path, quasis, state, raw) {
		    if (raw === void 0) {
		      raw = false;
		    }
		    var str = "";
		    var i = 0;
		    var exprs = path.isTemplateLiteral() ? path.get("expressions") : path.get("quasi.expressions");
		    for (var _iterator3 = _createForOfIteratorHelperLoose(quasis), _step3; !(_step3 = _iterator3()).done;) {
		      var elem = _step3.value;
		      if (!state.confident) break;
		      str += raw ? elem.value.raw : elem.value.cooked;
		      var expr = exprs[i++];
		      if (expr) str += String(evaluateCached(expr, state));
		    }
		    if (!state.confident) return;
		    return str;
		  }
		  function evaluate() {
		    var state = {
		      confident: true,
		      deoptPath: null,
		      seen: new Map()
		    };
		    var value = evaluateCached(this, state);
		    if (!state.confident) value = undefined;
		    return {
		      confident: state.confident,
		      deopt: state.deoptPath,
		      value: value
		    };
		  }

		  var NodePath_evaluation = /*#__PURE__*/Object.freeze({
		    __proto__: null,
		    evaluate: evaluate,
		    evaluateTruthy: evaluateTruthy
		  });

		  var assertExpressionStatement = assertExpressionStatement$1;
		  function makeStatementFormatter(fn) {
		    return {
		      code: function code(str) {
		        return "/* @babel/template */;\n" + str;
		      },
		      validate: function validate() {},
		      unwrap: function unwrap(ast) {
		        return fn(ast.program.body.slice(1));
		      }
		    };
		  }
		  var smart$1 = makeStatementFormatter(function (body) {
		    if (body.length > 1) {
		      return body;
		    } else {
		      return body[0];
		    }
		  });
		  var statements$1 = makeStatementFormatter(function (body) {
		    return body;
		  });
		  var statement$1 = makeStatementFormatter(function (body) {
		    if (body.length === 0) {
		      throw new Error("Found nothing to return.");
		    }
		    if (body.length > 1) {
		      throw new Error("Found multiple statements but wanted one");
		    }
		    return body[0];
		  });
		  var expression$1 = {
		    code: function code(str) {
		      return "(\n" + str + "\n)";
		    },
		    validate: function validate(ast) {
		      if (ast.program.body.length > 1) {
		        throw new Error("Found multiple statements but wanted one");
		      }
		      if (expression$1.unwrap(ast).start === 0) {
		        throw new Error("Parse result included parens.");
		      }
		    },
		    unwrap: function unwrap(_ref) {
		      var program = _ref.program;
		      var _program$body = _slicedToArray(program.body, 1),
		        stmt = _program$body[0];
		      assertExpressionStatement(stmt);
		      return stmt.expression;
		    }
		  };
		  var program$2 = {
		    code: function code(str) {
		      return str;
		    },
		    validate: function validate() {},
		    unwrap: function unwrap(ast) {
		      return ast.program;
		    }
		  };

		  var _excluded$3 = ["placeholderWhitelist", "placeholderPattern", "preserveComments", "syntacticPlaceholders"];
		  function merge(a, b) {
		    var _b$placeholderWhiteli = b.placeholderWhitelist,
		      placeholderWhitelist = _b$placeholderWhiteli === void 0 ? a.placeholderWhitelist : _b$placeholderWhiteli,
		      _b$placeholderPattern = b.placeholderPattern,
		      placeholderPattern = _b$placeholderPattern === void 0 ? a.placeholderPattern : _b$placeholderPattern,
		      _b$preserveComments = b.preserveComments,
		      preserveComments = _b$preserveComments === void 0 ? a.preserveComments : _b$preserveComments,
		      _b$syntacticPlacehold = b.syntacticPlaceholders,
		      syntacticPlaceholders = _b$syntacticPlacehold === void 0 ? a.syntacticPlaceholders : _b$syntacticPlacehold;
		    return {
		      parser: Object.assign({}, a.parser, b.parser),
		      placeholderWhitelist: placeholderWhitelist,
		      placeholderPattern: placeholderPattern,
		      preserveComments: preserveComments,
		      syntacticPlaceholders: syntacticPlaceholders
		    };
		  }
		  function validate$3(opts) {
		    if (opts != null && typeof opts !== "object") {
		      throw new Error("Unknown template options.");
		    }
		    var _ref = opts || {},
		      placeholderWhitelist = _ref.placeholderWhitelist,
		      placeholderPattern = _ref.placeholderPattern,
		      preserveComments = _ref.preserveComments,
		      syntacticPlaceholders = _ref.syntacticPlaceholders,
		      parser = _objectWithoutPropertiesLoose(_ref, _excluded$3);
		    if (placeholderWhitelist != null && !(placeholderWhitelist instanceof Set)) {
		      throw new Error("'.placeholderWhitelist' must be a Set, null, or undefined");
		    }
		    if (placeholderPattern != null && !(placeholderPattern instanceof RegExp) && placeholderPattern !== false) {
		      throw new Error("'.placeholderPattern' must be a RegExp, false, null, or undefined");
		    }
		    if (preserveComments != null && typeof preserveComments !== "boolean") {
		      throw new Error("'.preserveComments' must be a boolean, null, or undefined");
		    }
		    if (syntacticPlaceholders != null && typeof syntacticPlaceholders !== "boolean") {
		      throw new Error("'.syntacticPlaceholders' must be a boolean, null, or undefined");
		    }
		    if (syntacticPlaceholders === true && (placeholderWhitelist != null || placeholderPattern != null)) {
		      throw new Error("'.placeholderWhitelist' and '.placeholderPattern' aren't compatible" + " with '.syntacticPlaceholders: true'");
		    }
		    return {
		      parser: parser,
		      placeholderWhitelist: placeholderWhitelist || undefined,
		      placeholderPattern: placeholderPattern == null ? undefined : placeholderPattern,
		      preserveComments: preserveComments == null ? undefined : preserveComments,
		      syntacticPlaceholders: syntacticPlaceholders == null ? undefined : syntacticPlaceholders
		    };
		  }
		  function normalizeReplacements(replacements) {
		    if (Array.isArray(replacements)) {
		      return replacements.reduce(function (acc, replacement, i) {
		        acc["$" + i] = replacement;
		        return acc;
		      }, {});
		    } else if (typeof replacements === "object" || replacements == null) {
		      return replacements || undefined;
		    }
		    throw new Error("Template replacements must be an array, object, null, or undefined");
		  }

		  var isCallExpression$2 = isCallExpression$8,
		    isExpressionStatement = isExpressionStatement$2,
		    isFunction$2 = isFunction$5,
		    isIdentifier$a = isIdentifier$i,
		    isJSXIdentifier$1 = isJSXIdentifier$3,
		    isNewExpression = isNewExpression$3,
		    isPlaceholder = isPlaceholder$1,
		    isStatement$1 = isStatement$8,
		    isStringLiteral$3 = isStringLiteral$5,
		    removePropertiesDeep = removePropertiesDeep$1,
		    traverse$1 = traverse$2;
		  var PATTERN = /^[_$A-Z0-9]+$/;
		  function parseAndBuildMetadata(formatter, code, opts) {
		    var placeholderWhitelist = opts.placeholderWhitelist,
		      placeholderPattern = opts.placeholderPattern,
		      preserveComments = opts.preserveComments,
		      syntacticPlaceholders = opts.syntacticPlaceholders;
		    var ast = parseWithCodeFrame(code, opts.parser, syntacticPlaceholders);
		    removePropertiesDeep(ast, {
		      preserveComments: preserveComments
		    });
		    formatter.validate(ast);
		    var state = {
		      syntactic: {
		        placeholders: [],
		        placeholderNames: new Set()
		      },
		      legacy: {
		        placeholders: [],
		        placeholderNames: new Set()
		      },
		      placeholderWhitelist: placeholderWhitelist,
		      placeholderPattern: placeholderPattern,
		      syntacticPlaceholders: syntacticPlaceholders
		    };
		    traverse$1(ast, placeholderVisitorHandler, state);
		    return Object.assign({
		      ast: ast
		    }, state.syntactic.placeholders.length ? state.syntactic : state.legacy);
		  }
		  function placeholderVisitorHandler(node, ancestors, state) {
		    var _state$placeholderWhi;
		    var name;
		    var hasSyntacticPlaceholders = state.syntactic.placeholders.length > 0;
		    if (isPlaceholder(node)) {
		      if (state.syntacticPlaceholders === false) {
		        throw new Error("%%foo%%-style placeholders can't be used when " + "'.syntacticPlaceholders' is false.");
		      }
		      name = node.name.name;
		      hasSyntacticPlaceholders = true;
		    } else if (hasSyntacticPlaceholders || state.syntacticPlaceholders) {
		      return;
		    } else if (isIdentifier$a(node) || isJSXIdentifier$1(node)) {
		      name = node.name;
		    } else if (isStringLiteral$3(node)) {
		      name = node.value;
		    } else {
		      return;
		    }
		    if (hasSyntacticPlaceholders && (state.placeholderPattern != null || state.placeholderWhitelist != null)) {
		      throw new Error("'.placeholderWhitelist' and '.placeholderPattern' aren't compatible" + " with '.syntacticPlaceholders: true'");
		    }
		    if (!hasSyntacticPlaceholders && (state.placeholderPattern === false || !(state.placeholderPattern || PATTERN).test(name)) && !((_state$placeholderWhi = state.placeholderWhitelist) != null && _state$placeholderWhi.has(name))) {
		      return;
		    }
		    ancestors = ancestors.slice();
		    var _ancestors = ancestors[ancestors.length - 1],
		      parent = _ancestors.node,
		      key = _ancestors.key;
		    var type;
		    if (isStringLiteral$3(node) || isPlaceholder(node, {
		      expectedNode: "StringLiteral"
		    })) {
		      type = "string";
		    } else if (isNewExpression(parent) && key === "arguments" || isCallExpression$2(parent) && key === "arguments" || isFunction$2(parent) && key === "params") {
		      type = "param";
		    } else if (isExpressionStatement(parent) && !isPlaceholder(node)) {
		      type = "statement";
		      ancestors = ancestors.slice(0, -1);
		    } else if (isStatement$1(node) && isPlaceholder(node)) {
		      type = "statement";
		    } else {
		      type = "other";
		    }
		    var _ref = !hasSyntacticPlaceholders ? state.legacy : state.syntactic,
		      placeholders = _ref.placeholders,
		      placeholderNames = _ref.placeholderNames;
		    placeholders.push({
		      name: name,
		      type: type,
		      resolve: function resolve(ast) {
		        return resolveAncestors(ast, ancestors);
		      },
		      isDuplicate: placeholderNames.has(name)
		    });
		    placeholderNames.add(name);
		  }
		  function resolveAncestors(ast, ancestors) {
		    var parent = ast;
		    for (var i = 0; i < ancestors.length - 1; i++) {
		      var _ancestors$i = ancestors[i],
		        _key = _ancestors$i.key,
		        _index = _ancestors$i.index;
		      if (_index === undefined) {
		        parent = parent[_key];
		      } else {
		        parent = parent[_key][_index];
		      }
		    }
		    var _ancestors2 = ancestors[ancestors.length - 1],
		      key = _ancestors2.key,
		      index = _ancestors2.index;
		    return {
		      parent: parent,
		      key: key,
		      index: index
		    };
		  }
		  function parseWithCodeFrame(code, parserOpts, syntacticPlaceholders) {
		    var plugins = (parserOpts.plugins || []).slice();
		    if (syntacticPlaceholders !== false) {
		      plugins.push("placeholders");
		    }
		    parserOpts = Object.assign({
		      allowReturnOutsideFunction: true,
		      allowSuperOutsideMethod: true,
		      sourceType: "module"
		    }, parserOpts, {
		      plugins: plugins
		    });
		    try {
		      return parse$4(code, parserOpts);
		    } catch (err) {
		      var loc = err.loc;
		      if (loc) {
		        err.message += "\n" + codeFrameColumns(code, {
		          start: loc
		        });
		        err.code = "BABEL_TEMPLATE_PARSE_ERROR";
		      }
		      throw err;
		    }
		  }

		  var blockStatement$4 = blockStatement$6,
		    cloneNode$f = cloneNode$j,
		    emptyStatement = emptyStatement$1,
		    expressionStatement$7 = expressionStatement$a,
		    identifier$d = identifier$j,
		    isStatement = isStatement$8,
		    isStringLiteral$2 = isStringLiteral$5,
		    stringLiteral$7 = stringLiteral$8,
		    validate$2 = validate$5;
		  function populatePlaceholders(metadata, replacements) {
		    var ast = cloneNode$f(metadata.ast);
		    if (replacements) {
		      metadata.placeholders.forEach(function (placeholder) {
		        if (!hasOwnProperty.call(replacements, placeholder.name)) {
		          var placeholderName = placeholder.name;
		          throw new Error("Error: No substitution given for \"" + placeholderName + "\". If this is not meant to be a\n            placeholder you may want to consider passing one of the following options to @babel/template:\n            - { placeholderPattern: false, placeholderWhitelist: new Set(['" + placeholderName + "'])}\n            - { placeholderPattern: /^" + placeholderName + "$/ }");
		        }
		      });
		      Object.keys(replacements).forEach(function (key) {
		        if (!metadata.placeholderNames.has(key)) {
		          throw new Error("Unknown substitution \"" + key + "\" given");
		        }
		      });
		    }
		    metadata.placeholders.slice().reverse().forEach(function (placeholder) {
		      try {
		        applyReplacement(placeholder, ast, replacements && replacements[placeholder.name] || null);
		      } catch (e) {
		        e.message = "@babel/template placeholder \"" + placeholder.name + "\": " + e.message;
		        throw e;
		      }
		    });
		    return ast;
		  }
		  function applyReplacement(placeholder, ast, replacement) {
		    if (placeholder.isDuplicate) {
		      if (Array.isArray(replacement)) {
		        replacement = replacement.map(function (node) {
		          return cloneNode$f(node);
		        });
		      } else if (typeof replacement === "object") {
		        replacement = cloneNode$f(replacement);
		      }
		    }
		    var _placeholder$resolve = placeholder.resolve(ast),
		      parent = _placeholder$resolve.parent,
		      key = _placeholder$resolve.key,
		      index = _placeholder$resolve.index;
		    if (placeholder.type === "string") {
		      if (typeof replacement === "string") {
		        replacement = stringLiteral$7(replacement);
		      }
		      if (!replacement || !isStringLiteral$2(replacement)) {
		        throw new Error("Expected string substitution");
		      }
		    } else if (placeholder.type === "statement") {
		      if (index === undefined) {
		        if (!replacement) {
		          replacement = emptyStatement();
		        } else if (Array.isArray(replacement)) {
		          replacement = blockStatement$4(replacement);
		        } else if (typeof replacement === "string") {
		          replacement = expressionStatement$7(identifier$d(replacement));
		        } else if (!isStatement(replacement)) {
		          replacement = expressionStatement$7(replacement);
		        }
		      } else {
		        if (replacement && !Array.isArray(replacement)) {
		          if (typeof replacement === "string") {
		            replacement = identifier$d(replacement);
		          }
		          if (!isStatement(replacement)) {
		            replacement = expressionStatement$7(replacement);
		          }
		        }
		      }
		    } else if (placeholder.type === "param") {
		      if (typeof replacement === "string") {
		        replacement = identifier$d(replacement);
		      }
		      if (index === undefined) throw new Error("Assertion failure.");
		    } else {
		      if (typeof replacement === "string") {
		        replacement = identifier$d(replacement);
		      }
		      if (Array.isArray(replacement)) {
		        throw new Error("Cannot replace single expression with an array.");
		      }
		    }
		    if (index === undefined) {
		      validate$2(parent, key, replacement);
		      parent[key] = replacement;
		    } else {
		      var items = parent[key].slice();
		      if (placeholder.type === "statement" || placeholder.type === "param") {
		        if (replacement == null) {
		          items.splice(index, 1);
		        } else if (Array.isArray(replacement)) {
		          items.splice.apply(items, [index, 1].concat(_toConsumableArray(replacement)));
		        } else {
		          items[index] = replacement;
		        }
		      } else {
		        items[index] = replacement;
		      }
		      validate$2(parent, key, items);
		      parent[key] = items;
		    }
		  }

		  function stringTemplate(formatter, code, opts) {
		    code = formatter.code(code);
		    var metadata;
		    return function (arg) {
		      var replacements = normalizeReplacements(arg);
		      if (!metadata) metadata = parseAndBuildMetadata(formatter, code, opts);
		      return formatter.unwrap(populatePlaceholders(metadata, replacements));
		    };
		  }

		  function literalTemplate(formatter, tpl, opts) {
		    var _buildLiteralData = buildLiteralData(formatter, tpl, opts),
		      metadata = _buildLiteralData.metadata,
		      names = _buildLiteralData.names;
		    return function (arg) {
		      var defaultReplacements = {};
		      arg.forEach(function (replacement, i) {
		        defaultReplacements[names[i]] = replacement;
		      });
		      return function (arg) {
		        var replacements = normalizeReplacements(arg);
		        if (replacements) {
		          Object.keys(replacements).forEach(function (key) {
		            if (hasOwnProperty.call(defaultReplacements, key)) {
		              throw new Error("Unexpected replacement overlap.");
		            }
		          });
		        }
		        return formatter.unwrap(populatePlaceholders(metadata, replacements ? Object.assign(replacements, defaultReplacements) : defaultReplacements));
		      };
		    };
		  }
		  function buildLiteralData(formatter, tpl, opts) {
		    var prefix = "BABEL_TPL$";
		    var raw = tpl.join("");
		    do {
		      prefix = "$$" + prefix;
		    } while (raw.includes(prefix));
		    var _buildTemplateCode = buildTemplateCode(tpl, prefix),
		      names = _buildTemplateCode.names,
		      code = _buildTemplateCode.code;
		    var metadata = parseAndBuildMetadata(formatter, formatter.code(code), {
		      parser: opts.parser,
		      placeholderWhitelist: new Set(names.concat(opts.placeholderWhitelist ? Array.from(opts.placeholderWhitelist) : [])),
		      placeholderPattern: opts.placeholderPattern,
		      preserveComments: opts.preserveComments,
		      syntacticPlaceholders: opts.syntacticPlaceholders
		    });
		    return {
		      metadata: metadata,
		      names: names
		    };
		  }
		  function buildTemplateCode(tpl, prefix) {
		    var names = [];
		    var code = tpl[0];
		    for (var i = 1; i < tpl.length; i++) {
		      var value = "" + prefix + (i - 1);
		      names.push(value);
		      code += value + tpl[i];
		    }
		    return {
		      names: names,
		      code: code
		    };
		  }

		  var NO_PLACEHOLDER = validate$3({
		    placeholderPattern: false
		  });
		  function createTemplateBuilder(formatter, defaultOpts) {
		    var templateFnCache = new WeakMap();
		    var templateAstCache = new WeakMap();
		    var cachedOpts = defaultOpts || validate$3(null);
		    return Object.assign(function (tpl) {
		      for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
		        args[_key - 1] = arguments[_key];
		      }
		      if (typeof tpl === "string") {
		        if (args.length > 1) throw new Error("Unexpected extra params.");
		        return extendedTrace(stringTemplate(formatter, tpl, merge(cachedOpts, validate$3(args[0]))));
		      } else if (Array.isArray(tpl)) {
		        var builder = templateFnCache.get(tpl);
		        if (!builder) {
		          builder = literalTemplate(formatter, tpl, cachedOpts);
		          templateFnCache.set(tpl, builder);
		        }
		        return extendedTrace(builder(args));
		      } else if (typeof tpl === "object" && tpl) {
		        if (args.length > 0) throw new Error("Unexpected extra params.");
		        return createTemplateBuilder(formatter, merge(cachedOpts, validate$3(tpl)));
		      }
		      throw new Error("Unexpected template param " + typeof tpl);
		    }, {
		      ast: function ast(tpl) {
		        for (var _len2 = arguments.length, args = new Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
		          args[_key2 - 1] = arguments[_key2];
		        }
		        if (typeof tpl === "string") {
		          if (args.length > 1) throw new Error("Unexpected extra params.");
		          return stringTemplate(formatter, tpl, merge(merge(cachedOpts, validate$3(args[0])), NO_PLACEHOLDER))();
		        } else if (Array.isArray(tpl)) {
		          var builder = templateAstCache.get(tpl);
		          if (!builder) {
		            builder = literalTemplate(formatter, tpl, merge(cachedOpts, NO_PLACEHOLDER));
		            templateAstCache.set(tpl, builder);
		          }
		          return builder(args)();
		        }
		        throw new Error("Unexpected template param " + typeof tpl);
		      }
		    });
		  }
		  function extendedTrace(fn) {
		    var rootStack = "";
		    try {
		      throw new Error();
		    } catch (error) {
		      if (error.stack) {
		        rootStack = error.stack.split("\n").slice(3).join("\n");
		      }
		    }
		    return function (arg) {
		      try {
		        return fn(arg);
		      } catch (err) {
		        err.stack += "\n    =============\n" + rootStack;
		        throw err;
		      }
		    };
		  }

		  var smart = createTemplateBuilder(smart$1);
		  var statement = createTemplateBuilder(statement$1);
		  var statements = createTemplateBuilder(statements$1);
		  var expression = createTemplateBuilder(expression$1);
		  var program$1 = createTemplateBuilder(program$2);
		  var template$1 = Object.assign(smart.bind(undefined), {
		    smart: smart,
		    statement: statement,
		    statements: statements,
		    expression: expression,
		    program: program$1,
		    ast: smart.ast
		  });

		  var index$2 = /*#__PURE__*/Object.freeze({
		    __proto__: null,
		    default: template$1,
		    expression: expression,
		    program: program$1,
		    smart: smart,
		    statement: statement,
		    statements: statements
		  });

		  var NOT_LOCAL_BINDING = NOT_LOCAL_BINDING$2,
		    cloneNode$e = cloneNode$j,
		    identifier$c = identifier$j,
		    isAssignmentExpression$1 = isAssignmentExpression$3,
		    isAssignmentPattern$2 = isAssignmentPattern$4,
		    isFunction$1 = isFunction$5,
		    isIdentifier$9 = isIdentifier$i,
		    isLiteral$2 = isLiteral$6,
		    isNullLiteral = isNullLiteral$2,
		    isObjectMethod = isObjectMethod$1,
		    isObjectProperty$2 = isObjectProperty$4,
		    isRegExpLiteral = isRegExpLiteral$2,
		    isRestElement$1 = isRestElement$2,
		    isTemplateLiteral = isTemplateLiteral$2,
		    isVariableDeclarator = isVariableDeclarator$1,
		    toBindingIdentifierName = toBindingIdentifierName$1;
		  function getFunctionArity(node) {
		    var count = node.params.findIndex(function (param) {
		      return isAssignmentPattern$2(param) || isRestElement$1(param);
		    });
		    return count === -1 ? node.params.length : count;
		  }
		  var buildPropertyMethodAssignmentWrapper = template$1.statement("\n  (function (FUNCTION_KEY) {\n    function FUNCTION_ID() {\n      return FUNCTION_KEY.apply(this, arguments);\n    }\n\n    FUNCTION_ID.toString = function () {\n      return FUNCTION_KEY.toString();\n    }\n\n    return FUNCTION_ID;\n  })(FUNCTION)\n");
		  var buildGeneratorPropertyMethodAssignmentWrapper = template$1.statement("\n  (function (FUNCTION_KEY) {\n    function* FUNCTION_ID() {\n      return yield* FUNCTION_KEY.apply(this, arguments);\n    }\n\n    FUNCTION_ID.toString = function () {\n      return FUNCTION_KEY.toString();\n    };\n\n    return FUNCTION_ID;\n  })(FUNCTION)\n");
		  var visitor$3 = {
		    "ReferencedIdentifier|BindingIdentifier": function ReferencedIdentifierBindingIdentifier(path, state) {
		      if (path.node.name !== state.name) return;
		      var localDeclar = path.scope.getBindingIdentifier(state.name);
		      if (localDeclar !== state.outerDeclar) return;
		      state.selfReference = true;
		      path.stop();
		    }
		  };
		  function getNameFromLiteralId(id) {
		    if (isNullLiteral(id)) {
		      return "null";
		    }
		    if (isRegExpLiteral(id)) {
		      return "_" + id.pattern + "_" + id.flags;
		    }
		    if (isTemplateLiteral(id)) {
		      return id.quasis.map(function (quasi) {
		        return quasi.value.raw;
		      }).join("");
		    }
		    if (id.value !== undefined) {
		      return id.value + "";
		    }
		    return "";
		  }
		  function wrap$1(state, method, id, scope) {
		    if (state.selfReference) {
		      if (scope.hasBinding(id.name) && !scope.hasGlobal(id.name)) {
		        scope.rename(id.name);
		      } else {
		        if (!isFunction$1(method)) return;
		        var build = buildPropertyMethodAssignmentWrapper;
		        if (method.generator) {
		          build = buildGeneratorPropertyMethodAssignmentWrapper;
		        }
		        var _template = build({
		          FUNCTION: method,
		          FUNCTION_ID: id,
		          FUNCTION_KEY: scope.generateUidIdentifier(id.name)
		        }).expression;
		        var params = _template.callee.body.body[0].params;
		        for (var i = 0, len = getFunctionArity(method); i < len; i++) {
		          params.push(scope.generateUidIdentifier("x"));
		        }
		        return _template;
		      }
		    }
		    method.id = id;
		    scope.getProgramParent().references[id.name] = true;
		  }
		  function visit$2(node, name, scope) {
		    var state = {
		      selfAssignment: false,
		      selfReference: false,
		      outerDeclar: scope.getBindingIdentifier(name),
		      name: name
		    };
		    var binding = scope.getOwnBinding(name);
		    if (binding) {
		      if (binding.kind === "param") {
		        state.selfReference = true;
		      }
		    } else if (state.outerDeclar || scope.hasGlobal(name)) {
		      scope.traverse(node, visitor$3, state);
		    }
		    return state;
		  }
		  function nameFunction (_ref, localBinding, supportUnicodeId) {
		    var node = _ref.node,
		      parent = _ref.parent,
		      scope = _ref.scope,
		      id = _ref.id;
		    if (localBinding === void 0) {
		      localBinding = false;
		    }
		    if (supportUnicodeId === void 0) {
		      supportUnicodeId = false;
		    }
		    if (node.id) return;
		    if ((isObjectProperty$2(parent) || isObjectMethod(parent, {
		      kind: "method"
		    })) && (!parent.computed || isLiteral$2(parent.key))) {
		      id = parent.key;
		    } else if (isVariableDeclarator(parent)) {
		      id = parent.id;
		      if (isIdentifier$9(id) && !localBinding) {
		        var binding = scope.parent.getBinding(id.name);
		        if (binding && binding.constant && scope.getBinding(id.name) === binding) {
		          node.id = cloneNode$e(id);
		          node.id[NOT_LOCAL_BINDING] = true;
		          return;
		        }
		      }
		    } else if (isAssignmentExpression$1(parent, {
		      operator: "="
		    })) {
		      id = parent.left;
		    } else if (!id) {
		      return;
		    }
		    var name;
		    if (id && isLiteral$2(id)) {
		      name = getNameFromLiteralId(id);
		    } else if (id && isIdentifier$9(id)) {
		      name = id.name;
		    }
		    if (name === undefined) {
		      return;
		    }
		    if (!supportUnicodeId && isFunction$1(node) && /[\uD800-\uDFFF]/.test(name)) {
		      return;
		    }
		    name = toBindingIdentifierName(name);
		    var newId = identifier$c(name);
		    newId[NOT_LOCAL_BINDING] = true;
		    var state = visit$2(node, name, scope);
		    return wrap$1(state, node, newId, scope) || node;
		  }

		  var arrowFunctionExpression$2 = arrowFunctionExpression$4,
		    assignmentExpression$a = assignmentExpression$d,
		    binaryExpression$4 = binaryExpression$5,
		    blockStatement$3 = blockStatement$6,
		    callExpression$a = callExpression$d,
		    conditionalExpression$3 = conditionalExpression$5,
		    expressionStatement$6 = expressionStatement$a,
		    identifier$b = identifier$j,
		    isIdentifier$8 = isIdentifier$i,
		    jsxIdentifier$1 = jsxIdentifier$2,
		    logicalExpression$2 = logicalExpression$3,
		    LOGICAL_OPERATORS$2 = LOGICAL_OPERATORS$3,
		    memberExpression$a = memberExpression$c,
		    metaProperty = metaProperty$1,
		    numericLiteral$6 = numericLiteral$8,
		    objectExpression$2 = objectExpression$3,
		    restElement$1 = restElement$2,
		    returnStatement$1 = returnStatement$3,
		    sequenceExpression$6 = sequenceExpression$8,
		    spreadElement$1 = spreadElement$2,
		    stringLiteral$6 = stringLiteral$8,
		    _super = _super$1,
		    thisExpression$3 = thisExpression$4,
		    toExpression = toExpression$1,
		    unaryExpression$5 = unaryExpression$6;
		  function toComputedKey$1() {
		    var key;
		    if (this.isMemberExpression()) {
		      key = this.node.property;
		    } else if (this.isProperty() || this.isMethod()) {
		      key = this.node.key;
		    } else {
		      throw new ReferenceError("todo");
		    }
		    if (!this.node.computed) {
		      if (isIdentifier$8(key)) key = stringLiteral$6(key.name);
		    }
		    return key;
		  }
		  function ensureBlock() {
		    var body = this.get("body");
		    var bodyNode = body.node;
		    if (Array.isArray(body)) {
		      throw new Error("Can't convert array path to a block statement");
		    }
		    if (!bodyNode) {
		      throw new Error("Can't convert node without a body");
		    }
		    if (body.isBlockStatement()) {
		      return bodyNode;
		    }
		    var statements = [];
		    var stringPath = "body";
		    var key;
		    var listKey;
		    if (body.isStatement()) {
		      listKey = "body";
		      key = 0;
		      statements.push(body.node);
		    } else {
		      stringPath += ".body.0";
		      if (this.isFunction()) {
		        key = "argument";
		        statements.push(returnStatement$1(body.node));
		      } else {
		        key = "expression";
		        statements.push(expressionStatement$6(body.node));
		      }
		    }
		    this.node.body = blockStatement$3(statements);
		    var parentPath = this.get(stringPath);
		    body.setup(parentPath, listKey ? parentPath.node[listKey] : parentPath.node, listKey, key);
		    return this.node;
		  }
		  {
		    exports.arrowFunctionToShadowed = function () {
		      if (!this.isArrowFunctionExpression()) return;
		      this.arrowFunctionToExpression();
		    };
		  }
		  function unwrapFunctionEnvironment() {
		    if (!this.isArrowFunctionExpression() && !this.isFunctionExpression() && !this.isFunctionDeclaration()) {
		      throw this.buildCodeFrameError("Can only unwrap the environment of a function.");
		    }
		    hoistFunctionEnvironment(this);
		  }
		  function setType(path, type) {
		    path.node.type = type;
		  }
		  function arrowFunctionToExpression(_temp) {
		    var _arguments$;
		    var _ref = _temp === void 0 ? {} : _temp,
		      _ref$allowInsertArrow = _ref.allowInsertArrow,
		      allowInsertArrow = _ref$allowInsertArrow === void 0 ? true : _ref$allowInsertArrow,
		      _ref$allowInsertArrow2 = _ref.allowInsertArrowWithRest,
		      allowInsertArrowWithRest = _ref$allowInsertArrow2 === void 0 ? allowInsertArrow : _ref$allowInsertArrow2,
		      _ref$noNewArrows = _ref.noNewArrows,
		      noNewArrows = _ref$noNewArrows === void 0 ? !((_arguments$ = arguments[0]) != null && _arguments$.specCompliant) : _ref$noNewArrows;
		    if (!this.isArrowFunctionExpression()) {
		      throw this.buildCodeFrameError("Cannot convert non-arrow function to a function expression.");
		    }
		    var _hoistFunctionEnviron = hoistFunctionEnvironment(this, noNewArrows, allowInsertArrow, allowInsertArrowWithRest),
		      thisBinding = _hoistFunctionEnviron.thisBinding,
		      fn = _hoistFunctionEnviron.fnPath;
		    fn.ensureBlock();
		    setType(fn, "FunctionExpression");
		    if (!noNewArrows) {
		      var checkBinding = thisBinding ? null : fn.scope.generateUidIdentifier("arrowCheckId");
		      if (checkBinding) {
		        fn.parentPath.scope.push({
		          id: checkBinding,
		          init: objectExpression$2([])
		        });
		      }
		      fn.get("body").unshiftContainer("body", expressionStatement$6(callExpression$a(this.hub.addHelper("newArrowCheck"), [thisExpression$3(), checkBinding ? identifier$b(checkBinding.name) : identifier$b(thisBinding)])));
		      fn.replaceWith(callExpression$a(memberExpression$a(nameFunction(this, true) || fn.node, identifier$b("bind")), [checkBinding ? identifier$b(checkBinding.name) : thisExpression$3()]));
		      return fn.get("callee.object");
		    }
		    return fn;
		  }
		  var getSuperCallsVisitor = merge$1([{
		    CallExpression: function CallExpression(child, _ref2) {
		      var allSuperCalls = _ref2.allSuperCalls;
		      if (!child.get("callee").isSuper()) return;
		      allSuperCalls.push(child);
		    }
		  }, visitor$5]);
		  function hoistFunctionEnvironment(fnPath, noNewArrows, allowInsertArrow, allowInsertArrowWithRest) {
		    if (noNewArrows === void 0) {
		      noNewArrows = true;
		    }
		    if (allowInsertArrow === void 0) {
		      allowInsertArrow = true;
		    }
		    if (allowInsertArrowWithRest === void 0) {
		      allowInsertArrowWithRest = true;
		    }
		    var arrowParent;
		    var thisEnvFn = fnPath.findParent(function (p) {
		      if (p.isArrowFunctionExpression()) {
		        var _arrowParent;
		        (_arrowParent = arrowParent) != null ? _arrowParent : arrowParent = p;
		        return false;
		      }
		      return p.isFunction() || p.isProgram() || p.isClassProperty({
		        "static": false
		      }) || p.isClassPrivateProperty({
		        "static": false
		      });
		    });
		    var inConstructor = thisEnvFn.isClassMethod({
		      kind: "constructor"
		    });
		    if (thisEnvFn.isClassProperty() || thisEnvFn.isClassPrivateProperty()) {
		      if (arrowParent) {
		        thisEnvFn = arrowParent;
		      } else if (allowInsertArrow) {
		        fnPath.replaceWith(callExpression$a(arrowFunctionExpression$2([], toExpression(fnPath.node)), []));
		        thisEnvFn = fnPath.get("callee");
		        fnPath = thisEnvFn.get("body");
		      } else {
		        throw fnPath.buildCodeFrameError("Unable to transform arrow inside class property");
		      }
		    }
		    var _getScopeInformation = getScopeInformation(fnPath),
		      thisPaths = _getScopeInformation.thisPaths,
		      argumentsPaths = _getScopeInformation.argumentsPaths,
		      newTargetPaths = _getScopeInformation.newTargetPaths,
		      superProps = _getScopeInformation.superProps,
		      superCalls = _getScopeInformation.superCalls;
		    if (inConstructor && superCalls.length > 0) {
		      if (!allowInsertArrow) {
		        throw superCalls[0].buildCodeFrameError("When using '@babel/plugin-transform-arrow-functions', " + "it's not possible to compile `super()` in an arrow function without compiling classes.\n" + "Please add '@babel/plugin-transform-classes' to your Babel configuration.");
		      }
		      if (!allowInsertArrowWithRest) {
		        throw superCalls[0].buildCodeFrameError("When using '@babel/plugin-transform-parameters', " + "it's not possible to compile `super()` in an arrow function with default or rest parameters without compiling classes.\n" + "Please add '@babel/plugin-transform-classes' to your Babel configuration.");
		      }
		      var allSuperCalls = [];
		      thisEnvFn.traverse(getSuperCallsVisitor, {
		        allSuperCalls: allSuperCalls
		      });
		      var superBinding = getSuperBinding(thisEnvFn);
		      allSuperCalls.forEach(function (superCall) {
		        var callee = identifier$b(superBinding);
		        callee.loc = superCall.node.callee.loc;
		        superCall.get("callee").replaceWith(callee);
		      });
		    }
		    if (argumentsPaths.length > 0) {
		      var argumentsBinding = getBinding(thisEnvFn, "arguments", function () {
		        var args = function args() {
		          return identifier$b("arguments");
		        };
		        if (thisEnvFn.scope.path.isProgram()) {
		          return conditionalExpression$3(binaryExpression$4("===", unaryExpression$5("typeof", args()), stringLiteral$6("undefined")), thisEnvFn.scope.buildUndefinedNode(), args());
		        } else {
		          return args();
		        }
		      });
		      argumentsPaths.forEach(function (argumentsChild) {
		        var argsRef = identifier$b(argumentsBinding);
		        argsRef.loc = argumentsChild.node.loc;
		        argumentsChild.replaceWith(argsRef);
		      });
		    }
		    if (newTargetPaths.length > 0) {
		      var newTargetBinding = getBinding(thisEnvFn, "newtarget", function () {
		        return metaProperty(identifier$b("new"), identifier$b("target"));
		      });
		      newTargetPaths.forEach(function (targetChild) {
		        var targetRef = identifier$b(newTargetBinding);
		        targetRef.loc = targetChild.node.loc;
		        targetChild.replaceWith(targetRef);
		      });
		    }
		    if (superProps.length > 0) {
		      if (!allowInsertArrow) {
		        throw superProps[0].buildCodeFrameError("When using '@babel/plugin-transform-arrow-functions', " + "it's not possible to compile `super.prop` in an arrow function without compiling classes.\n" + "Please add '@babel/plugin-transform-classes' to your Babel configuration.");
		      }
		      var flatSuperProps = superProps.reduce(function (acc, superProp) {
		        return acc.concat(standardizeSuperProperty(superProp));
		      }, []);
		      flatSuperProps.forEach(function (superProp) {
		        var key = superProp.node.computed ? "" : superProp.get("property").node.name;
		        var superParentPath = superProp.parentPath;
		        var isAssignment = superParentPath.isAssignmentExpression({
		          left: superProp.node
		        });
		        var isCall = superParentPath.isCallExpression({
		          callee: superProp.node
		        });
		        var isTaggedTemplate = superParentPath.isTaggedTemplateExpression({
		          tag: superProp.node
		        });
		        var superBinding = getSuperPropBinding(thisEnvFn, isAssignment, key);
		        var args = [];
		        if (superProp.node.computed) {
		          args.push(superProp.get("property").node);
		        }
		        if (isAssignment) {
		          var value = superParentPath.node.right;
		          args.push(value);
		        }
		        var call = callExpression$a(identifier$b(superBinding), args);
		        if (isCall) {
		          superParentPath.unshiftContainer("arguments", thisExpression$3());
		          superProp.replaceWith(memberExpression$a(call, identifier$b("call")));
		          thisPaths.push(superParentPath.get("arguments.0"));
		        } else if (isAssignment) {
		          superParentPath.replaceWith(call);
		        } else if (isTaggedTemplate) {
		          superProp.replaceWith(callExpression$a(memberExpression$a(call, identifier$b("bind"), false), [thisExpression$3()]));
		          thisPaths.push(superProp.get("arguments.0"));
		        } else {
		          superProp.replaceWith(call);
		        }
		      });
		    }
		    var thisBinding;
		    if (thisPaths.length > 0 || !noNewArrows) {
		      thisBinding = getThisBinding(thisEnvFn, inConstructor);
		      if (noNewArrows || inConstructor && hasSuperClass(thisEnvFn)) {
		        thisPaths.forEach(function (thisChild) {
		          var thisRef = thisChild.isJSX() ? jsxIdentifier$1(thisBinding) : identifier$b(thisBinding);
		          thisRef.loc = thisChild.node.loc;
		          thisChild.replaceWith(thisRef);
		        });
		        if (!noNewArrows) thisBinding = null;
		      }
		    }
		    return {
		      thisBinding: thisBinding,
		      fnPath: fnPath
		    };
		  }
		  function isLogicalOp(op) {
		    return LOGICAL_OPERATORS$2.includes(op);
		  }
		  function standardizeSuperProperty(superProp) {
		    if (superProp.parentPath.isAssignmentExpression() && superProp.parentPath.node.operator !== "=") {
		      var assignmentPath = superProp.parentPath;
		      var op = assignmentPath.node.operator.slice(0, -1);
		      var value = assignmentPath.node.right;
		      var isLogicalAssignment = isLogicalOp(op);
		      if (superProp.node.computed) {
		        var tmp = superProp.scope.generateDeclaredUidIdentifier("tmp");
		        var object = superProp.node.object;
		        var property = superProp.node.property;
		        assignmentPath.get("left").replaceWith(memberExpression$a(object, assignmentExpression$a("=", tmp, property), true));
		        assignmentPath.get("right").replaceWith(rightExpression(isLogicalAssignment ? "=" : op, memberExpression$a(object, identifier$b(tmp.name), true), value));
		      } else {
		        var _object = superProp.node.object;
		        var _property = superProp.node.property;
		        assignmentPath.get("left").replaceWith(memberExpression$a(_object, _property));
		        assignmentPath.get("right").replaceWith(rightExpression(isLogicalAssignment ? "=" : op, memberExpression$a(_object, identifier$b(_property.name)), value));
		      }
		      if (isLogicalAssignment) {
		        assignmentPath.replaceWith(logicalExpression$2(op, assignmentPath.node.left, assignmentPath.node.right));
		      } else {
		        assignmentPath.node.operator = "=";
		      }
		      return [assignmentPath.get("left"), assignmentPath.get("right").get("left")];
		    } else if (superProp.parentPath.isUpdateExpression()) {
		      var updateExpr = superProp.parentPath;
		      var _tmp = superProp.scope.generateDeclaredUidIdentifier("tmp");
		      var computedKey = superProp.node.computed ? superProp.scope.generateDeclaredUidIdentifier("prop") : null;
		      var parts = [assignmentExpression$a("=", _tmp, memberExpression$a(superProp.node.object, computedKey ? assignmentExpression$a("=", computedKey, superProp.node.property) : superProp.node.property, superProp.node.computed)), assignmentExpression$a("=", memberExpression$a(superProp.node.object, computedKey ? identifier$b(computedKey.name) : superProp.node.property, superProp.node.computed), binaryExpression$4(superProp.parentPath.node.operator[0], identifier$b(_tmp.name), numericLiteral$6(1)))];
		      if (!superProp.parentPath.node.prefix) {
		        parts.push(identifier$b(_tmp.name));
		      }
		      updateExpr.replaceWith(sequenceExpression$6(parts));
		      var left = updateExpr.get("expressions.0.right");
		      var right = updateExpr.get("expressions.1.left");
		      return [left, right];
		    }
		    return [superProp];
		    function rightExpression(op, left, right) {
		      if (op === "=") {
		        return assignmentExpression$a("=", left, right);
		      } else {
		        return binaryExpression$4(op, left, right);
		      }
		    }
		  }
		  function hasSuperClass(thisEnvFn) {
		    return thisEnvFn.isClassMethod() && !!thisEnvFn.parentPath.parentPath.node.superClass;
		  }
		  var assignSuperThisVisitor = merge$1([{
		    CallExpression: function CallExpression(child, _ref3) {
		      var supers = _ref3.supers,
		        thisBinding = _ref3.thisBinding;
		      if (!child.get("callee").isSuper()) return;
		      if (supers.has(child.node)) return;
		      supers.add(child.node);
		      child.replaceWithMultiple([child.node, assignmentExpression$a("=", identifier$b(thisBinding), identifier$b("this"))]);
		    }
		  }, visitor$5]);
		  function getThisBinding(thisEnvFn, inConstructor) {
		    return getBinding(thisEnvFn, "this", function (thisBinding) {
		      if (!inConstructor || !hasSuperClass(thisEnvFn)) return thisExpression$3();
		      thisEnvFn.traverse(assignSuperThisVisitor, {
		        supers: new WeakSet(),
		        thisBinding: thisBinding
		      });
		    });
		  }
		  function getSuperBinding(thisEnvFn) {
		    return getBinding(thisEnvFn, "supercall", function () {
		      var argsBinding = thisEnvFn.scope.generateUidIdentifier("args");
		      return arrowFunctionExpression$2([restElement$1(argsBinding)], callExpression$a(_super(), [spreadElement$1(identifier$b(argsBinding.name))]));
		    });
		  }
		  function getSuperPropBinding(thisEnvFn, isAssignment, propName) {
		    var op = isAssignment ? "set" : "get";
		    return getBinding(thisEnvFn, "superprop_" + op + ":" + (propName || ""), function () {
		      var argsList = [];
		      var fnBody;
		      if (propName) {
		        fnBody = memberExpression$a(_super(), identifier$b(propName));
		      } else {
		        var method = thisEnvFn.scope.generateUidIdentifier("prop");
		        argsList.unshift(method);
		        fnBody = memberExpression$a(_super(), identifier$b(method.name), true);
		      }
		      if (isAssignment) {
		        var valueIdent = thisEnvFn.scope.generateUidIdentifier("value");
		        argsList.push(valueIdent);
		        fnBody = assignmentExpression$a("=", fnBody, identifier$b(valueIdent.name));
		      }
		      return arrowFunctionExpression$2(argsList, fnBody);
		    });
		  }
		  function getBinding(thisEnvFn, key, init) {
		    var cacheKey = "binding:" + key;
		    var data = thisEnvFn.getData(cacheKey);
		    if (!data) {
		      var id = thisEnvFn.scope.generateUidIdentifier(key);
		      data = id.name;
		      thisEnvFn.setData(cacheKey, data);
		      thisEnvFn.scope.push({
		        id: id,
		        init: init(data)
		      });
		    }
		    return data;
		  }
		  var getScopeInformationVisitor = merge$1([{
		    ThisExpression: function ThisExpression(child, _ref4) {
		      var thisPaths = _ref4.thisPaths;
		      thisPaths.push(child);
		    },
		    JSXIdentifier: function JSXIdentifier(child, _ref5) {
		      var thisPaths = _ref5.thisPaths;
		      if (child.node.name !== "this") return;
		      if (!child.parentPath.isJSXMemberExpression({
		        object: child.node
		      }) && !child.parentPath.isJSXOpeningElement({
		        name: child.node
		      })) {
		        return;
		      }
		      thisPaths.push(child);
		    },
		    CallExpression: function CallExpression(child, _ref6) {
		      var superCalls = _ref6.superCalls;
		      if (child.get("callee").isSuper()) superCalls.push(child);
		    },
		    MemberExpression: function MemberExpression(child, _ref7) {
		      var superProps = _ref7.superProps;
		      if (child.get("object").isSuper()) superProps.push(child);
		    },
		    Identifier: function Identifier(child, _ref8) {
		      var argumentsPaths = _ref8.argumentsPaths;
		      if (!child.isReferencedIdentifier({
		        name: "arguments"
		      })) return;
		      var curr = child.scope;
		      do {
		        if (curr.hasOwnBinding("arguments")) {
		          curr.rename("arguments");
		          return;
		        }
		        if (curr.path.isFunction() && !curr.path.isArrowFunctionExpression()) {
		          break;
		        }
		      } while (curr = curr.parent);
		      argumentsPaths.push(child);
		    },
		    MetaProperty: function MetaProperty(child, _ref9) {
		      var newTargetPaths = _ref9.newTargetPaths;
		      if (!child.get("meta").isIdentifier({
		        name: "new"
		      })) return;
		      if (!child.get("property").isIdentifier({
		        name: "target"
		      })) return;
		      newTargetPaths.push(child);
		    }
		  }, visitor$5]);
		  function getScopeInformation(fnPath) {
		    var thisPaths = [];
		    var argumentsPaths = [];
		    var newTargetPaths = [];
		    var superProps = [];
		    var superCalls = [];
		    fnPath.traverse(getScopeInformationVisitor, {
		      thisPaths: thisPaths,
		      argumentsPaths: argumentsPaths,
		      newTargetPaths: newTargetPaths,
		      superProps: superProps,
		      superCalls: superCalls
		    });
		    return {
		      thisPaths: thisPaths,
		      argumentsPaths: argumentsPaths,
		      newTargetPaths: newTargetPaths,
		      superProps: superProps,
		      superCalls: superCalls
		    };
		  }

		  var NodePath_conversion = /*#__PURE__*/Object.freeze({
		    __proto__: null,
		    arrowFunctionToExpression: arrowFunctionToExpression,
		    ensureBlock: ensureBlock,
		    toComputedKey: toComputedKey$1,
		    unwrapFunctionEnvironment: unwrapFunctionEnvironment
		  });

		  var STATEMENT_OR_BLOCK_KEYS = STATEMENT_OR_BLOCK_KEYS$1,
		    VISITOR_KEYS$3 = VISITOR_KEYS$5,
		    isBlockStatement = isBlockStatement$3,
		    isExpression$1 = isExpression$4,
		    isIdentifier$7 = isIdentifier$i,
		    isLiteral$1 = isLiteral$6,
		    isStringLiteral$1 = isStringLiteral$5,
		    isType = isType$2,
		    _matchesPattern = matchesPattern$2;
		  function matchesPattern(pattern, allowPartial) {
		    return _matchesPattern(this.node, pattern, allowPartial);
		  }
		  function has$3(key) {
		    var _this$node;
		    var val = (_this$node = this.node) == null ? void 0 : _this$node[key];
		    if (val && Array.isArray(val)) {
		      return !!val.length;
		    } else {
		      return !!val;
		    }
		  }
		  function isStatic() {
		    return this.scope.isStatic(this.node);
		  }
		  var is = has$3;
		  function isnt(key) {
		    return !this.has(key);
		  }
		  function equals(key, value) {
		    return this.node[key] === value;
		  }
		  function isNodeType(type) {
		    return isType(this.type, type);
		  }
		  function canHaveVariableDeclarationOrExpression() {
		    return (this.key === "init" || this.key === "left") && this.parentPath.isFor();
		  }
		  function canSwapBetweenExpressionAndStatement(replacement) {
		    if (this.key !== "body" || !this.parentPath.isArrowFunctionExpression()) {
		      return false;
		    }
		    if (this.isExpression()) {
		      return isBlockStatement(replacement);
		    } else if (this.isBlockStatement()) {
		      return isExpression$1(replacement);
		    }
		    return false;
		  }
		  function isCompletionRecord(allowInsideFunction) {
		    var path = this;
		    var first = true;
		    do {
		      var _path = path,
		        type = _path.type,
		        container = _path.container;
		      if (!first && (path.isFunction() || type === "StaticBlock")) {
		        return !!allowInsideFunction;
		      }
		      first = false;
		      if (Array.isArray(container) && path.key !== container.length - 1) {
		        return false;
		      }
		    } while ((path = path.parentPath) && !path.isProgram() && !path.isDoExpression());
		    return true;
		  }
		  function isStatementOrBlock() {
		    if (this.parentPath.isLabeledStatement() || isBlockStatement(this.container)) {
		      return false;
		    } else {
		      return STATEMENT_OR_BLOCK_KEYS.includes(this.key);
		    }
		  }
		  function referencesImport(moduleSource, importName) {
		    if (!this.isReferencedIdentifier()) {
		      if (this.isJSXMemberExpression() && this.node.property.name === importName || (this.isMemberExpression() || this.isOptionalMemberExpression()) && (this.node.computed ? isStringLiteral$1(this.node.property, {
		        value: importName
		      }) : this.node.property.name === importName)) {
		        var object = this.get("object");
		        return object.isReferencedIdentifier() && object.referencesImport(moduleSource, "*");
		      }
		      return false;
		    }
		    var binding = this.scope.getBinding(this.node.name);
		    if (!binding || binding.kind !== "module") return false;
		    var path = binding.path;
		    var parent = path.parentPath;
		    if (!parent.isImportDeclaration()) return false;
		    if (parent.node.source.value === moduleSource) {
		      if (!importName) return true;
		    } else {
		      return false;
		    }
		    if (path.isImportDefaultSpecifier() && importName === "default") {
		      return true;
		    }
		    if (path.isImportNamespaceSpecifier() && importName === "*") {
		      return true;
		    }
		    if (path.isImportSpecifier() && isIdentifier$7(path.node.imported, {
		      name: importName
		    })) {
		      return true;
		    }
		    return false;
		  }
		  function getSource$1() {
		    var node = this.node;
		    if (node.end) {
		      var code = this.hub.getCode();
		      if (code) return code.slice(node.start, node.end);
		    }
		    return "";
		  }
		  function willIMaybeExecuteBefore(target) {
		    return this._guessExecutionStatusRelativeTo(target) !== "after";
		  }
		  function getOuterFunction(path) {
		    return path.isProgram() ? path : (path.parentPath.scope.getFunctionParent() || path.parentPath.scope.getProgramParent()).path;
		  }
		  function isExecutionUncertain(type, key) {
		    switch (type) {
		      case "LogicalExpression":
		        return key === "right";
		      case "ConditionalExpression":
		      case "IfStatement":
		        return key === "consequent" || key === "alternate";
		      case "WhileStatement":
		      case "DoWhileStatement":
		      case "ForInStatement":
		      case "ForOfStatement":
		        return key === "body";
		      case "ForStatement":
		        return key === "body" || key === "update";
		      case "SwitchStatement":
		        return key === "cases";
		      case "TryStatement":
		        return key === "handler";
		      case "AssignmentPattern":
		        return key === "right";
		      case "OptionalMemberExpression":
		        return key === "property";
		      case "OptionalCallExpression":
		        return key === "arguments";
		      default:
		        return false;
		    }
		  }
		  function isExecutionUncertainInList(paths, maxIndex) {
		    for (var i = 0; i < maxIndex; i++) {
		      var path = paths[i];
		      if (isExecutionUncertain(path.parent.type, path.parentKey)) {
		        return true;
		      }
		    }
		    return false;
		  }
		  var SYMBOL_CHECKING = Symbol();
		  function _guessExecutionStatusRelativeTo(target) {
		    return _guessExecutionStatusRelativeToCached(this, target, new Map());
		  }
		  function _guessExecutionStatusRelativeToCached(base, target, cache) {
		    var funcParent = {
		      "this": getOuterFunction(base),
		      target: getOuterFunction(target)
		    };
		    if (funcParent.target.node !== funcParent["this"].node) {
		      return _guessExecutionStatusRelativeToDifferentFunctionsCached(base, funcParent.target, cache);
		    }
		    var paths = {
		      target: target.getAncestry(),
		      "this": base.getAncestry()
		    };
		    if (paths.target.indexOf(base) >= 0) return "after";
		    if (paths["this"].indexOf(target) >= 0) return "before";
		    var commonPath;
		    var commonIndex = {
		      target: 0,
		      "this": 0
		    };
		    while (!commonPath && commonIndex["this"] < paths["this"].length) {
		      var path = paths["this"][commonIndex["this"]];
		      commonIndex.target = paths.target.indexOf(path);
		      if (commonIndex.target >= 0) {
		        commonPath = path;
		      } else {
		        commonIndex["this"]++;
		      }
		    }
		    if (!commonPath) {
		      throw new Error("Internal Babel error - The two compared nodes" + " don't appear to belong to the same program.");
		    }
		    if (isExecutionUncertainInList(paths["this"], commonIndex["this"] - 1) || isExecutionUncertainInList(paths.target, commonIndex.target - 1)) {
		      return "unknown";
		    }
		    var divergence = {
		      "this": paths["this"][commonIndex["this"] - 1],
		      target: paths.target[commonIndex.target - 1]
		    };
		    if (divergence.target.listKey && divergence["this"].listKey && divergence.target.container === divergence["this"].container) {
		      return divergence.target.key > divergence["this"].key ? "before" : "after";
		    }
		    var keys = VISITOR_KEYS$3[commonPath.type];
		    var keyPosition = {
		      "this": keys.indexOf(divergence["this"].parentKey),
		      target: keys.indexOf(divergence.target.parentKey)
		    };
		    return keyPosition.target > keyPosition["this"] ? "before" : "after";
		  }
		  function _guessExecutionStatusRelativeToDifferentFunctionsInternal(base, target, cache) {
		    if (!target.isFunctionDeclaration()) {
		      if (_guessExecutionStatusRelativeToCached(base, target, cache) === "before") {
		        return "before";
		      }
		      return "unknown";
		    } else if (target.parentPath.isExportDeclaration()) {
		      return "unknown";
		    }
		    var binding = target.scope.getBinding(target.node.id.name);
		    if (!binding.references) return "before";
		    var referencePaths = binding.referencePaths;
		    var allStatus;
		    for (var _iterator = _createForOfIteratorHelperLoose(referencePaths), _step; !(_step = _iterator()).done;) {
		      var path = _step.value;
		      var childOfFunction = !!path.find(function (path) {
		        return path.node === target.node;
		      });
		      if (childOfFunction) continue;
		      if (path.key !== "callee" || !path.parentPath.isCallExpression()) {
		        return "unknown";
		      }
		      var status = _guessExecutionStatusRelativeToCached(base, path, cache);
		      if (allStatus && allStatus !== status) {
		        return "unknown";
		      } else {
		        allStatus = status;
		      }
		    }
		    return allStatus;
		  }
		  function _guessExecutionStatusRelativeToDifferentFunctionsCached(base, target, cache) {
		    var nodeMap = cache.get(base.node);
		    var cached;
		    if (!nodeMap) {
		      cache.set(base.node, nodeMap = new Map());
		    } else if (cached = nodeMap.get(target.node)) {
		      if (cached === SYMBOL_CHECKING) {
		        return "unknown";
		      }
		      return cached;
		    }
		    nodeMap.set(target.node, SYMBOL_CHECKING);
		    var result = _guessExecutionStatusRelativeToDifferentFunctionsInternal(base, target, cache);
		    nodeMap.set(target.node, result);
		    return result;
		  }
		  function resolve$3(dangerous, resolved) {
		    return this._resolve(dangerous, resolved) || this;
		  }
		  function _resolve(dangerous, resolved) {
		    if (resolved && resolved.indexOf(this) >= 0) return;
		    resolved = resolved || [];
		    resolved.push(this);
		    if (this.isVariableDeclarator()) {
		      if (this.get("id").isIdentifier()) {
		        return this.get("init").resolve(dangerous, resolved);
		      }
		    } else if (this.isReferencedIdentifier()) {
		      var binding = this.scope.getBinding(this.node.name);
		      if (!binding) return;
		      if (!binding.constant) return;
		      if (binding.kind === "module") return;
		      if (binding.path !== this) {
		        var ret = binding.path.resolve(dangerous, resolved);
		        if (this.find(function (parent) {
		          return parent.node === ret.node;
		        })) return;
		        return ret;
		      }
		    } else if (this.isTypeCastExpression()) {
		      return this.get("expression").resolve(dangerous, resolved);
		    } else if (dangerous && this.isMemberExpression()) {
		      var targetKey = this.toComputedKey();
		      if (!isLiteral$1(targetKey)) return;
		      var targetName = targetKey.value;
		      var target = this.get("object").resolve(dangerous, resolved);
		      if (target.isObjectExpression()) {
		        var props = target.get("properties");
		        for (var _i = 0, _arr = props; _i < _arr.length; _i++) {
		          var prop = _arr[_i];
		          if (!prop.isProperty()) continue;
		          var key = prop.get("key");
		          var match = prop.isnt("computed") && key.isIdentifier({
		            name: targetName
		          });
		          match = match || key.isLiteral({
		            value: targetName
		          });
		          if (match) return prop.get("value").resolve(dangerous, resolved);
		        }
		      } else if (target.isArrayExpression() && !isNaN(+targetName)) {
		        var elems = target.get("elements");
		        var elem = elems[targetName];
		        if (elem) return elem.resolve(dangerous, resolved);
		      }
		    }
		  }
		  function isConstantExpression() {
		    if (this.isIdentifier()) {
		      var binding = this.scope.getBinding(this.node.name);
		      if (!binding) return false;
		      return binding.constant;
		    }
		    if (this.isLiteral()) {
		      if (this.isRegExpLiteral()) {
		        return false;
		      }
		      if (this.isTemplateLiteral()) {
		        return this.get("expressions").every(function (expression) {
		          return expression.isConstantExpression();
		        });
		      }
		      return true;
		    }
		    if (this.isUnaryExpression()) {
		      if (this.node.operator !== "void") {
		        return false;
		      }
		      return this.get("argument").isConstantExpression();
		    }
		    if (this.isBinaryExpression()) {
		      var operator = this.node.operator;
		      return operator !== "in" && operator !== "instanceof" && this.get("left").isConstantExpression() && this.get("right").isConstantExpression();
		    }
		    if (this.isMemberExpression()) {
		      return !this.node.computed && this.get("object").isIdentifier({
		        name: "Symbol"
		      }) && !this.scope.hasBinding("Symbol", {
		        noGlobals: true
		      });
		    }
		    if (this.isCallExpression()) {
		      return this.node.arguments.length === 1 && this.get("callee").matchesPattern("Symbol.for") && !this.scope.hasBinding("Symbol", {
		        noGlobals: true
		      }) && this.get("arguments")[0].isStringLiteral();
		    }
		    return false;
		  }
		  function isInStrictMode() {
		    var start = this.isProgram() ? this : this.parentPath;
		    var strictParent = start.find(function (path) {
		      if (path.isProgram({
		        sourceType: "module"
		      })) return true;
		      if (path.isClass()) return true;
		      if (path.isArrowFunctionExpression() && !path.get("body").isBlockStatement()) {
		        return false;
		      }
		      var body;
		      if (path.isFunction()) {
		        body = path.node.body;
		      } else if (path.isProgram()) {
		        body = path.node;
		      } else {
		        return false;
		      }
		      for (var _iterator2 = _createForOfIteratorHelperLoose(body.directives), _step2; !(_step2 = _iterator2()).done;) {
		        var directive = _step2.value;
		        if (directive.value.value === "use strict") {
		          return true;
		        }
		      }
		    });
		    return !!strictParent;
		  }

		  var NodePath_introspection = /*#__PURE__*/Object.freeze({
		    __proto__: null,
		    _guessExecutionStatusRelativeTo: _guessExecutionStatusRelativeTo,
		    _resolve: _resolve,
		    canHaveVariableDeclarationOrExpression: canHaveVariableDeclarationOrExpression,
		    canSwapBetweenExpressionAndStatement: canSwapBetweenExpressionAndStatement,
		    equals: equals,
		    getSource: getSource$1,
		    has: has$3,
		    is: is,
		    isCompletionRecord: isCompletionRecord,
		    isConstantExpression: isConstantExpression,
		    isInStrictMode: isInStrictMode,
		    isNodeType: isNodeType,
		    isStatementOrBlock: isStatementOrBlock,
		    isStatic: isStatic,
		    isnt: isnt,
		    matchesPattern: matchesPattern,
		    referencesImport: referencesImport,
		    resolve: resolve$3,
		    willIMaybeExecuteBefore: willIMaybeExecuteBefore
		  });

		  function call(key) {
		    var opts = this.opts;
		    this.debug(key);
		    if (this.node) {
		      if (this._call(opts[key])) return true;
		    }
		    if (this.node) {
		      var _opts$this$node$type;
		      return this._call((_opts$this$node$type = opts[this.node.type]) == null ? void 0 : _opts$this$node$type[key]);
		    }
		    return false;
		  }
		  function _call(fns) {
		    if (!fns) return false;
		    for (var _iterator = _createForOfIteratorHelperLoose(fns), _step; !(_step = _iterator()).done;) {
		      var fn = _step.value;
		      if (!fn) continue;
		      var node = this.node;
		      if (!node) return true;
		      var ret = fn.call(this.state, this, this.state);
		      if (ret && typeof ret === "object" && typeof ret.then === "function") {
		        throw new Error("You appear to be using a plugin with an async traversal visitor, " + "which your current version of Babel does not support. " + "If you're using a published plugin, you may need to upgrade " + "your @babel/core version.");
		      }
		      if (ret) {
		        throw new Error("Unexpected return value from visitor method " + fn);
		      }
		      if (this.node !== node) return true;
		      if (this._traverseFlags > 0) return true;
		    }
		    return false;
		  }
		  function isDenylisted() {
		    var _this$opts$denylist;
		    var denylist = (_this$opts$denylist = this.opts.denylist) != null ? _this$opts$denylist : this.opts.blacklist;
		    return denylist && denylist.indexOf(this.node.type) > -1;
		  }
		  function restoreContext(path, context) {
		    if (path.context !== context) {
		      path.context = context;
		      path.state = context.state;
		      path.opts = context.opts;
		    }
		  }
		  function visit$1() {
		    var _this$opts$shouldSkip, _this$opts;
		    if (!this.node) {
		      return false;
		    }
		    if (this.isDenylisted()) {
		      return false;
		    }
		    if ((_this$opts$shouldSkip = (_this$opts = this.opts).shouldSkip) != null && _this$opts$shouldSkip.call(_this$opts, this)) {
		      return false;
		    }
		    var currentContext = this.context;
		    if (this.shouldSkip || this.call("enter")) {
		      this.debug("Skip...");
		      return this.shouldStop;
		    }
		    restoreContext(this, currentContext);
		    this.debug("Recursing into...");
		    this.shouldStop = traverseNode(this.node, this.opts, this.scope, this.state, this, this.skipKeys);
		    restoreContext(this, currentContext);
		    this.call("exit");
		    return this.shouldStop;
		  }
		  function skip() {
		    this.shouldSkip = true;
		  }
		  function skipKey(key) {
		    if (this.skipKeys == null) {
		      this.skipKeys = {};
		    }
		    this.skipKeys[key] = true;
		  }
		  function stop() {
		    this._traverseFlags |= SHOULD_SKIP | SHOULD_STOP;
		  }
		  function setScope() {
		    var _this$opts2, _this$scope;
		    if ((_this$opts2 = this.opts) != null && _this$opts2.noScope) return;
		    var path = this.parentPath;
		    if ((this.key === "key" || this.listKey === "decorators") && path.isMethod() || this.key === "discriminant" && path.isSwitchStatement()) {
		      path = path.parentPath;
		    }
		    var target;
		    while (path && !target) {
		      var _path$opts;
		      if ((_path$opts = path.opts) != null && _path$opts.noScope) return;
		      target = path.scope;
		      path = path.parentPath;
		    }
		    this.scope = this.getScope(target);
		    (_this$scope = this.scope) == null || _this$scope.init();
		  }
		  function setContext(context) {
		    if (this.skipKeys != null) {
		      this.skipKeys = {};
		    }
		    this._traverseFlags = 0;
		    if (context) {
		      this.context = context;
		      this.state = context.state;
		      this.opts = context.opts;
		    }
		    this.setScope();
		    return this;
		  }
		  function resync() {
		    if (this.removed) return;
		    this._resyncParent();
		    this._resyncList();
		    this._resyncKey();
		  }
		  function _resyncParent() {
		    if (this.parentPath) {
		      this.parent = this.parentPath.node;
		    }
		  }
		  function _resyncKey() {
		    if (!this.container) return;
		    if (this.node === this.container[this.key]) {
		      return;
		    }
		    if (Array.isArray(this.container)) {
		      for (var i = 0; i < this.container.length; i++) {
		        if (this.container[i] === this.node) {
		          this.setKey(i);
		          return;
		        }
		      }
		    } else {
		      for (var _i = 0, _Object$keys = Object.keys(this.container); _i < _Object$keys.length; _i++) {
		        var key = _Object$keys[_i];
		        if (this.container[key] === this.node) {
		          this.setKey(key);
		          return;
		        }
		      }
		    }
		    this.key = null;
		  }
		  function _resyncList() {
		    if (!this.parent || !this.inList) return;
		    var newContainer = this.parent[this.listKey];
		    if (this.container === newContainer) return;
		    this.container = newContainer || null;
		  }
		  function _resyncRemoved() {
		    if (this.key == null || !this.container || this.container[this.key] !== this.node) {
		      this._markRemoved();
		    }
		  }
		  function popContext() {
		    this.contexts.pop();
		    if (this.contexts.length > 0) {
		      this.setContext(this.contexts[this.contexts.length - 1]);
		    } else {
		      this.setContext(undefined);
		    }
		  }
		  function pushContext(context) {
		    this.contexts.push(context);
		    this.setContext(context);
		  }
		  function setup(parentPath, container, listKey, key) {
		    this.listKey = listKey;
		    this.container = container;
		    this.parentPath = parentPath || this.parentPath;
		    this.setKey(key);
		  }
		  function setKey(key) {
		    var _this$node;
		    this.key = key;
		    this.node = this.container[this.key];
		    this.type = (_this$node = this.node) == null ? void 0 : _this$node.type;
		  }
		  function requeue(pathToQueue) {
		    if (pathToQueue === void 0) {
		      pathToQueue = this;
		    }
		    if (pathToQueue.removed) return;
		    var contexts = this.contexts;
		    for (var _iterator2 = _createForOfIteratorHelperLoose(contexts), _step2; !(_step2 = _iterator2()).done;) {
		      var context = _step2.value;
		      context.maybeQueue(pathToQueue);
		    }
		  }
		  function _getQueueContexts() {
		    var path = this;
		    var contexts = this.contexts;
		    while (!contexts.length) {
		      path = path.parentPath;
		      if (!path) break;
		      contexts = path.contexts;
		    }
		    return contexts;
		  }

		  var NodePath_context = /*#__PURE__*/Object.freeze({
		    __proto__: null,
		    _call: _call,
		    _getQueueContexts: _getQueueContexts,
		    _resyncKey: _resyncKey,
		    _resyncList: _resyncList,
		    _resyncParent: _resyncParent,
		    _resyncRemoved: _resyncRemoved,
		    call: call,
		    isBlacklisted: isDenylisted,
		    isDenylisted: isDenylisted,
		    popContext: popContext,
		    pushContext: pushContext,
		    requeue: requeue,
		    resync: resync,
		    setContext: setContext,
		    setKey: setKey,
		    setScope: setScope,
		    setup: setup,
		    skip: skip,
		    skipKey: skipKey,
		    stop: stop,
		    visit: visit$1
		  });

		  var hooks = [function (self, parent) {
		    var removeParent = self.key === "test" && (parent.isWhile() || parent.isSwitchCase()) || self.key === "declaration" && parent.isExportDeclaration() || self.key === "body" && parent.isLabeledStatement() || self.listKey === "declarations" && parent.isVariableDeclaration() && parent.node.declarations.length === 1 || self.key === "expression" && parent.isExpressionStatement();
		    if (removeParent) {
		      parent.remove();
		      return true;
		    }
		  }, function (self, parent) {
		    if (parent.isSequenceExpression() && parent.node.expressions.length === 1) {
		      parent.replaceWith(parent.node.expressions[0]);
		      return true;
		    }
		  }, function (self, parent) {
		    if (parent.isBinary()) {
		      if (self.key === "left") {
		        parent.replaceWith(parent.node.right);
		      } else {
		        parent.replaceWith(parent.node.left);
		      }
		      return true;
		    }
		  }, function (self, parent) {
		    if (parent.isIfStatement() && self.key === "consequent" || self.key === "body" && (parent.isLoop() || parent.isArrowFunctionExpression())) {
		      self.replaceWith({
		        type: "BlockStatement",
		        body: []
		      });
		      return true;
		    }
		  }];

		  var getBindingIdentifiers$1 = getBindingIdentifiers$4;
		  function remove() {
		    var _this$opts;
		    this._assertUnremoved();
		    this.resync();
		    if (!((_this$opts = this.opts) != null && _this$opts.noScope)) {
		      this._removeFromScope();
		    }
		    if (this._callRemovalHooks()) {
		      this._markRemoved();
		      return;
		    }
		    this.shareCommentsWithSiblings();
		    this._remove();
		    this._markRemoved();
		  }
		  function _removeFromScope() {
		    var _this = this;
		    var bindings = getBindingIdentifiers$1(this.node, false, false, true);
		    Object.keys(bindings).forEach(function (name) {
		      return _this.scope.removeBinding(name);
		    });
		  }
		  function _callRemovalHooks() {
		    if (this.parentPath) {
		      for (var _iterator = _createForOfIteratorHelperLoose(hooks), _step; !(_step = _iterator()).done;) {
		        var fn = _step.value;
		        if (fn(this, this.parentPath)) return true;
		      }
		    }
		  }
		  function _remove() {
		    if (Array.isArray(this.container)) {
		      this.container.splice(this.key, 1);
		      this.updateSiblingKeys(this.key, -1);
		    } else {
		      this._replaceWith(null);
		    }
		  }
		  function _markRemoved() {
		    this._traverseFlags |= SHOULD_SKIP | REMOVED;
		    if (this.parent) {
		      getCachedPaths(this.hub, this.parent)["delete"](this.node);
		    }
		    this.node = null;
		  }
		  function _assertUnremoved() {
		    if (this.removed) {
		      throw this.buildCodeFrameError("NodePath has been removed so is read-only.");
		    }
		  }

		  var NodePath_removal = /*#__PURE__*/Object.freeze({
		    __proto__: null,
		    _assertUnremoved: _assertUnremoved,
		    _callRemovalHooks: _callRemovalHooks,
		    _markRemoved: _markRemoved,
		    _remove: _remove,
		    _removeFromScope: _removeFromScope,
		    remove: remove
		  });

		  var react$1 = react$3;
		  var cloneNode$d = cloneNode$j,
		    jsxExpressionContainer = jsxExpressionContainer$1,
		    variableDeclaration$5 = variableDeclaration$8,
		    variableDeclarator$5 = variableDeclarator$8;
		  var referenceVisitor$1 = {
		    ReferencedIdentifier: function ReferencedIdentifier(path, state) {
		      if (path.isJSXIdentifier() && react$1.isCompatTag(path.node.name) && !path.parentPath.isJSXMemberExpression()) {
		        return;
		      }
		      if (path.node.name === "this") {
		        var scope = path.scope;
		        do {
		          if (scope.path.isFunction() && !scope.path.isArrowFunctionExpression()) {
		            break;
		          }
		        } while (scope = scope.parent);
		        if (scope) state.breakOnScopePaths.push(scope.path);
		      }
		      var binding = path.scope.getBinding(path.node.name);
		      if (!binding) return;
		      for (var _iterator = _createForOfIteratorHelperLoose(binding.constantViolations), _step; !(_step = _iterator()).done;) {
		        var violation = _step.value;
		        if (violation.scope !== binding.path.scope) {
		          state.mutableBinding = true;
		          path.stop();
		          return;
		        }
		      }
		      if (binding !== state.scope.getBinding(path.node.name)) return;
		      state.bindings[path.node.name] = binding;
		    }
		  };
		  var PathHoister = function () {
		    function PathHoister(path, scope) {
		      this.breakOnScopePaths = void 0;
		      this.bindings = void 0;
		      this.mutableBinding = void 0;
		      this.scopes = void 0;
		      this.scope = void 0;
		      this.path = void 0;
		      this.attachAfter = void 0;
		      this.breakOnScopePaths = [];
		      this.bindings = {};
		      this.mutableBinding = false;
		      this.scopes = [];
		      this.scope = scope;
		      this.path = path;
		      this.attachAfter = false;
		    }
		    var _proto = PathHoister.prototype;
		    _proto.isCompatibleScope = function isCompatibleScope(scope) {
		      for (var _i = 0, _Object$keys = Object.keys(this.bindings); _i < _Object$keys.length; _i++) {
		        var key = _Object$keys[_i];
		        var binding = this.bindings[key];
		        if (!scope.bindingIdentifierEquals(key, binding.identifier)) {
		          return false;
		        }
		      }
		      return true;
		    };
		    _proto.getCompatibleScopes = function getCompatibleScopes() {
		      var scope = this.path.scope;
		      do {
		        if (this.isCompatibleScope(scope)) {
		          this.scopes.push(scope);
		        } else {
		          break;
		        }
		        if (this.breakOnScopePaths.indexOf(scope.path) >= 0) {
		          break;
		        }
		      } while (scope = scope.parent);
		    };
		    _proto.getAttachmentPath = function getAttachmentPath() {
		      var path = this._getAttachmentPath();
		      if (!path) return;
		      var targetScope = path.scope;
		      if (targetScope.path === path) {
		        targetScope = path.scope.parent;
		      }
		      if (targetScope.path.isProgram() || targetScope.path.isFunction()) {
		        for (var _i2 = 0, _Object$keys2 = Object.keys(this.bindings); _i2 < _Object$keys2.length; _i2++) {
		          var name = _Object$keys2[_i2];
		          if (!targetScope.hasOwnBinding(name)) continue;
		          var binding = this.bindings[name];
		          if (binding.kind === "param" || binding.path.parentKey === "params") {
		            continue;
		          }
		          var bindingParentPath = this.getAttachmentParentForPath(binding.path);
		          if (bindingParentPath.key >= path.key) {
		            this.attachAfter = true;
		            path = binding.path;
		            for (var _iterator2 = _createForOfIteratorHelperLoose(binding.constantViolations), _step2; !(_step2 = _iterator2()).done;) {
		              var violationPath = _step2.value;
		              if (this.getAttachmentParentForPath(violationPath).key > path.key) {
		                path = violationPath;
		              }
		            }
		          }
		        }
		      }
		      return path;
		    };
		    _proto._getAttachmentPath = function _getAttachmentPath() {
		      var scopes = this.scopes;
		      var scope = scopes.pop();
		      if (!scope) return;
		      if (scope.path.isFunction()) {
		        if (this.hasOwnParamBindings(scope)) {
		          if (this.scope === scope) return;
		          var bodies = scope.path.get("body").get("body");
		          for (var i = 0; i < bodies.length; i++) {
		            if (bodies[i].node._blockHoist) continue;
		            return bodies[i];
		          }
		        } else {
		          return this.getNextScopeAttachmentParent();
		        }
		      } else if (scope.path.isProgram()) {
		        return this.getNextScopeAttachmentParent();
		      }
		    };
		    _proto.getNextScopeAttachmentParent = function getNextScopeAttachmentParent() {
		      var scope = this.scopes.pop();
		      if (scope) return this.getAttachmentParentForPath(scope.path);
		    };
		    _proto.getAttachmentParentForPath = function getAttachmentParentForPath(path) {
		      do {
		        if (!path.parentPath || Array.isArray(path.container) && path.isStatement()) {
		          return path;
		        }
		      } while (path = path.parentPath);
		    };
		    _proto.hasOwnParamBindings = function hasOwnParamBindings(scope) {
		      for (var _i3 = 0, _Object$keys3 = Object.keys(this.bindings); _i3 < _Object$keys3.length; _i3++) {
		        var name = _Object$keys3[_i3];
		        if (!scope.hasOwnBinding(name)) continue;
		        var binding = this.bindings[name];
		        if (binding.kind === "param" && binding.constant) return true;
		      }
		      return false;
		    };
		    _proto.run = function run() {
		      this.path.traverse(referenceVisitor$1, this);
		      if (this.mutableBinding) return;
		      this.getCompatibleScopes();
		      var attachTo = this.getAttachmentPath();
		      if (!attachTo) return;
		      if (attachTo.getFunctionParent() === this.path.getFunctionParent()) return;
		      var uid = attachTo.scope.generateUidIdentifier("ref");
		      var declarator = variableDeclarator$5(uid, this.path.node);
		      var insertFn = this.attachAfter ? "insertAfter" : "insertBefore";
		      var _attachTo$insertFn = attachTo[insertFn]([attachTo.isVariableDeclarator() ? declarator : variableDeclaration$5("var", [declarator])]),
		        _attachTo$insertFn2 = _slicedToArray(_attachTo$insertFn, 1),
		        attached = _attachTo$insertFn2[0];
		      var parent = this.path.parentPath;
		      if (parent.isJSXElement() && this.path.container === parent.node.children) {
		        uid = jsxExpressionContainer(uid);
		      }
		      this.path.replaceWith(cloneNode$d(uid));
		      return attachTo.isVariableDeclarator() ? attached.get("init") : attached.get("declarations.0.init");
		    };
		    return _createClass(PathHoister);
		  }();

		  var arrowFunctionExpression$1 = arrowFunctionExpression$4,
		    assertExpression = assertExpression$1,
		    assignmentExpression$9 = assignmentExpression$d,
		    blockStatement$2 = blockStatement$6,
		    callExpression$9 = callExpression$d,
		    cloneNode$c = cloneNode$j,
		    expressionStatement$5 = expressionStatement$a,
		    isAssignmentExpression = isAssignmentExpression$3,
		    isCallExpression$1 = isCallExpression$8,
		    isExportNamedDeclaration = isExportNamedDeclaration$3,
		    isExpression = isExpression$4,
		    isIdentifier$6 = isIdentifier$i,
		    isSequenceExpression = isSequenceExpression$1,
		    isSuper$1 = isSuper$3,
		    thisExpression$2 = thisExpression$4;
		  function insertBefore(nodes_) {
		    this._assertUnremoved();
		    var nodes = this._verifyNodeList(nodes_);
		    var parentPath = this.parentPath,
		      parent = this.parent;
		    if (parentPath.isExpressionStatement() || parentPath.isLabeledStatement() || isExportNamedDeclaration(parent) || parentPath.isExportDefaultDeclaration() && this.isDeclaration()) {
		      return parentPath.insertBefore(nodes);
		    } else if (this.isNodeType("Expression") && !this.isJSXElement() || parentPath.isForStatement() && this.key === "init") {
		      if (this.node) nodes.push(this.node);
		      return this.replaceExpressionWithStatements(nodes);
		    } else if (Array.isArray(this.container)) {
		      return this._containerInsertBefore(nodes);
		    } else if (this.isStatementOrBlock()) {
		      var node = this.node;
		      var shouldInsertCurrentNode = node && (!this.isExpressionStatement() || node.expression != null);
		      this.replaceWith(blockStatement$2(shouldInsertCurrentNode ? [node] : []));
		      return this.unshiftContainer("body", nodes);
		    } else {
		      throw new Error("We don't know what to do with this node type. " + "We were previously a Statement but we can't fit in here?");
		    }
		  }
		  function _containerInsert(from, nodes) {
		    var _this$container;
		    this.updateSiblingKeys(from, nodes.length);
		    var paths = [];
		    (_this$container = this.container).splice.apply(_this$container, [from, 0].concat(_toConsumableArray(nodes)));
		    for (var i = 0; i < nodes.length; i++) {
		      var _this$context;
		      var to = from + i;
		      var path = this.getSibling(to);
		      paths.push(path);
		      if ((_this$context = this.context) != null && _this$context.queue) {
		        path.pushContext(this.context);
		      }
		    }
		    var contexts = this._getQueueContexts();
		    for (var _i = 0, _paths = paths; _i < _paths.length; _i++) {
		      var _path = _paths[_i];
		      _path.setScope();
		      _path.debug("Inserted.");
		      for (var _iterator = _createForOfIteratorHelperLoose(contexts), _step; !(_step = _iterator()).done;) {
		        var context = _step.value;
		        context.maybeQueue(_path, true);
		      }
		    }
		    return paths;
		  }
		  function _containerInsertBefore(nodes) {
		    return this._containerInsert(this.key, nodes);
		  }
		  function _containerInsertAfter(nodes) {
		    return this._containerInsert(this.key + 1, nodes);
		  }
		  var last$1 = function last(arr) {
		    return arr[arr.length - 1];
		  };
		  function isHiddenInSequenceExpression(path) {
		    return isSequenceExpression(path.parent) && (last$1(path.parent.expressions) !== path.node || isHiddenInSequenceExpression(path.parentPath));
		  }
		  function isAlmostConstantAssignment(node, scope) {
		    if (!isAssignmentExpression(node) || !isIdentifier$6(node.left)) {
		      return false;
		    }
		    var blockScope = scope.getBlockParent();
		    return blockScope.hasOwnBinding(node.left.name) && blockScope.getOwnBinding(node.left.name).constantViolations.length <= 1;
		  }
		  function insertAfter(nodes_) {
		    this._assertUnremoved();
		    if (this.isSequenceExpression()) {
		      return last$1(this.get("expressions")).insertAfter(nodes_);
		    }
		    var nodes = this._verifyNodeList(nodes_);
		    var parentPath = this.parentPath,
		      parent = this.parent;
		    if (parentPath.isExpressionStatement() || parentPath.isLabeledStatement() || isExportNamedDeclaration(parent) || parentPath.isExportDefaultDeclaration() && this.isDeclaration()) {
		      return parentPath.insertAfter(nodes.map(function (node) {
		        return isExpression(node) ? expressionStatement$5(node) : node;
		      }));
		    } else if (this.isNodeType("Expression") && !this.isJSXElement() && !parentPath.isJSXElement() || parentPath.isForStatement() && this.key === "init") {
		      var self = this;
		      if (self.node) {
		        var node = self.node;
		        var scope = this.scope;
		        if (scope.path.isPattern()) {
		          assertExpression(node);
		          self.replaceWith(callExpression$9(arrowFunctionExpression$1([], node), []));
		          self.get("callee.body").insertAfter(nodes);
		          return [self];
		        }
		        if (isHiddenInSequenceExpression(self)) {
		          nodes.unshift(node);
		        } else if (isCallExpression$1(node) && isSuper$1(node.callee)) {
		          nodes.unshift(node);
		          nodes.push(thisExpression$2());
		        } else if (isAlmostConstantAssignment(node, scope)) {
		          nodes.unshift(node);
		          nodes.push(cloneNode$c(node.left));
		        } else if (scope.isPure(node, true)) {
		          nodes.push(node);
		        } else {
		          if (parentPath.isMethod({
		            computed: true,
		            key: node
		          })) {
		            scope = scope.parent;
		          }
		          var temp = scope.generateDeclaredUidIdentifier();
		          nodes.unshift(expressionStatement$5(assignmentExpression$9("=", cloneNode$c(temp), node)));
		          nodes.push(expressionStatement$5(cloneNode$c(temp)));
		        }
		      }
		      return this.replaceExpressionWithStatements(nodes);
		    } else if (Array.isArray(this.container)) {
		      return this._containerInsertAfter(nodes);
		    } else if (this.isStatementOrBlock()) {
		      var _node = this.node;
		      var shouldInsertCurrentNode = _node && (!this.isExpressionStatement() || _node.expression != null);
		      this.replaceWith(blockStatement$2(shouldInsertCurrentNode ? [_node] : []));
		      return this.pushContainer("body", nodes);
		    } else {
		      throw new Error("We don't know what to do with this node type. " + "We were previously a Statement but we can't fit in here?");
		    }
		  }
		  function updateSiblingKeys(fromIndex, incrementBy) {
		    if (!this.parent) return;
		    var paths = getCachedPaths(this.hub, this.parent) || [];
		    for (var _iterator2 = _createForOfIteratorHelperLoose(paths), _step2; !(_step2 = _iterator2()).done;) {
		      var _step2$value = _slicedToArray(_step2.value, 2),
		        path = _step2$value[1];
		      if (typeof path.key === "number" && path.key >= fromIndex) {
		        path.key += incrementBy;
		      }
		    }
		  }
		  function _verifyNodeList(nodes) {
		    if (!nodes) {
		      return [];
		    }
		    if (!Array.isArray(nodes)) {
		      nodes = [nodes];
		    }
		    for (var i = 0; i < nodes.length; i++) {
		      var node = nodes[i];
		      var msg = void 0;
		      if (!node) {
		        msg = "has falsy node";
		      } else if (typeof node !== "object") {
		        msg = "contains a non-object node";
		      } else if (!node.type) {
		        msg = "without a type";
		      } else if (node instanceof NodePath_Final) {
		        msg = "has a NodePath when it expected a raw object";
		      }
		      if (msg) {
		        var type = Array.isArray(node) ? "array" : typeof node;
		        throw new Error("Node list " + msg + " with the index of " + i + " and type of " + type);
		      }
		    }
		    return nodes;
		  }
		  function unshiftContainer(listKey, nodes) {
		    this._assertUnremoved();
		    nodes = this._verifyNodeList(nodes);
		    var path = NodePath_Final.get({
		      parentPath: this,
		      parent: this.node,
		      container: this.node[listKey],
		      listKey: listKey,
		      key: 0
		    }).setContext(this.context);
		    return path._containerInsertBefore(nodes);
		  }
		  function pushContainer(listKey, nodes) {
		    this._assertUnremoved();
		    var verifiedNodes = this._verifyNodeList(nodes);
		    var container = this.node[listKey];
		    var path = NodePath_Final.get({
		      parentPath: this,
		      parent: this.node,
		      container: container,
		      listKey: listKey,
		      key: container.length
		    }).setContext(this.context);
		    return path.replaceWithMultiple(verifiedNodes);
		  }
		  function hoist$2(scope) {
		    if (scope === void 0) {
		      scope = this.scope;
		    }
		    var hoister = new PathHoister(this, scope);
		    return hoister.run();
		  }

		  var NodePath_modification = /*#__PURE__*/Object.freeze({
		    __proto__: null,
		    _containerInsert: _containerInsert,
		    _containerInsertAfter: _containerInsertAfter,
		    _containerInsertBefore: _containerInsertBefore,
		    _verifyNodeList: _verifyNodeList,
		    hoist: hoist$2,
		    insertAfter: insertAfter,
		    insertBefore: insertBefore,
		    pushContainer: pushContainer,
		    unshiftContainer: unshiftContainer,
		    updateSiblingKeys: updateSiblingKeys
		  });

		  var _getBindingIdentifiers = getBindingIdentifiers$4,
		    _getOuterBindingIdentifiers = getOuterBindingIdentifiers$2,
		    numericLiteral$5 = numericLiteral$8,
		    unaryExpression$4 = unaryExpression$6;
		  var NORMAL_COMPLETION = 0;
		  var BREAK_COMPLETION = 1;
		  function NormalCompletion(path) {
		    return {
		      type: NORMAL_COMPLETION,
		      path: path
		    };
		  }
		  function BreakCompletion(path) {
		    return {
		      type: BREAK_COMPLETION,
		      path: path
		    };
		  }
		  function getOpposite() {
		    if (this.key === "left") {
		      return this.getSibling("right");
		    } else if (this.key === "right") {
		      return this.getSibling("left");
		    }
		    return null;
		  }
		  function addCompletionRecords(path, records, context) {
		    if (path) {
		      records.push.apply(records, _toConsumableArray(_getCompletionRecords(path, context)));
		    }
		    return records;
		  }
		  function completionRecordForSwitch(cases, records, context) {
		    var lastNormalCompletions = [];
		    for (var i = 0; i < cases.length; i++) {
		      var casePath = cases[i];
		      var caseCompletions = _getCompletionRecords(casePath, context);
		      var normalCompletions = [];
		      var breakCompletions = [];
		      for (var _i = 0, _caseCompletions = caseCompletions; _i < _caseCompletions.length; _i++) {
		        var c = _caseCompletions[_i];
		        if (c.type === NORMAL_COMPLETION) {
		          normalCompletions.push(c);
		        }
		        if (c.type === BREAK_COMPLETION) {
		          breakCompletions.push(c);
		        }
		      }
		      if (normalCompletions.length) {
		        lastNormalCompletions = normalCompletions;
		      }
		      records.push.apply(records, breakCompletions);
		    }
		    records.push.apply(records, _toConsumableArray(lastNormalCompletions));
		    return records;
		  }
		  function normalCompletionToBreak(completions) {
		    completions.forEach(function (c) {
		      c.type = BREAK_COMPLETION;
		    });
		  }
		  function replaceBreakStatementInBreakCompletion(completions, reachable) {
		    completions.forEach(function (c) {
		      if (c.path.isBreakStatement({
		        label: null
		      })) {
		        if (reachable) {
		          c.path.replaceWith(unaryExpression$4("void", numericLiteral$5(0)));
		        } else {
		          c.path.remove();
		        }
		      }
		    });
		  }
		  function getStatementListCompletion(paths, context) {
		    var completions = [];
		    if (context.canHaveBreak) {
		      var lastNormalCompletions = [];
		      for (var i = 0; i < paths.length; i++) {
		        var path = paths[i];
		        var newContext = Object.assign({}, context, {
		          inCaseClause: false
		        });
		        if (path.isBlockStatement() && (context.inCaseClause || context.shouldPopulateBreak)) {
		          newContext.shouldPopulateBreak = true;
		        } else {
		          newContext.shouldPopulateBreak = false;
		        }
		        var statementCompletions = _getCompletionRecords(path, newContext);
		        if (statementCompletions.length > 0 && statementCompletions.every(function (c) {
		          return c.type === BREAK_COMPLETION;
		        })) {
		          if (lastNormalCompletions.length > 0 && statementCompletions.every(function (c) {
		            return c.path.isBreakStatement({
		              label: null
		            });
		          })) {
		            normalCompletionToBreak(lastNormalCompletions);
		            completions.push.apply(completions, _toConsumableArray(lastNormalCompletions));
		            if (lastNormalCompletions.some(function (c) {
		              return c.path.isDeclaration();
		            })) {
		              completions.push.apply(completions, statementCompletions);
		              replaceBreakStatementInBreakCompletion(statementCompletions, true);
		            }
		            replaceBreakStatementInBreakCompletion(statementCompletions, false);
		          } else {
		            completions.push.apply(completions, statementCompletions);
		            if (!context.shouldPopulateBreak) {
		              replaceBreakStatementInBreakCompletion(statementCompletions, true);
		            }
		          }
		          break;
		        }
		        if (i === paths.length - 1) {
		          completions.push.apply(completions, statementCompletions);
		        } else {
		          lastNormalCompletions = [];
		          for (var _i2 = 0; _i2 < statementCompletions.length; _i2++) {
		            var c = statementCompletions[_i2];
		            if (c.type === BREAK_COMPLETION) {
		              completions.push(c);
		            }
		            if (c.type === NORMAL_COMPLETION) {
		              lastNormalCompletions.push(c);
		            }
		          }
		        }
		      }
		    } else if (paths.length) {
		      for (var _i3 = paths.length - 1; _i3 >= 0; _i3--) {
		        var pathCompletions = _getCompletionRecords(paths[_i3], context);
		        if (pathCompletions.length > 1 || pathCompletions.length === 1 && !pathCompletions[0].path.isVariableDeclaration()) {
		          completions.push.apply(completions, pathCompletions);
		          break;
		        }
		      }
		    }
		    return completions;
		  }
		  function _getCompletionRecords(path, context) {
		    var records = [];
		    if (path.isIfStatement()) {
		      records = addCompletionRecords(path.get("consequent"), records, context);
		      records = addCompletionRecords(path.get("alternate"), records, context);
		    } else if (path.isDoExpression() || path.isFor() || path.isWhile() || path.isLabeledStatement()) {
		      return addCompletionRecords(path.get("body"), records, context);
		    } else if (path.isProgram() || path.isBlockStatement()) {
		      return getStatementListCompletion(path.get("body"), context);
		    } else if (path.isFunction()) {
		      return _getCompletionRecords(path.get("body"), context);
		    } else if (path.isTryStatement()) {
		      records = addCompletionRecords(path.get("block"), records, context);
		      records = addCompletionRecords(path.get("handler"), records, context);
		    } else if (path.isCatchClause()) {
		      return addCompletionRecords(path.get("body"), records, context);
		    } else if (path.isSwitchStatement()) {
		      return completionRecordForSwitch(path.get("cases"), records, context);
		    } else if (path.isSwitchCase()) {
		      return getStatementListCompletion(path.get("consequent"), {
		        canHaveBreak: true,
		        shouldPopulateBreak: false,
		        inCaseClause: true
		      });
		    } else if (path.isBreakStatement()) {
		      records.push(BreakCompletion(path));
		    } else {
		      records.push(NormalCompletion(path));
		    }
		    return records;
		  }
		  function getCompletionRecords() {
		    var records = _getCompletionRecords(this, {
		      canHaveBreak: false,
		      shouldPopulateBreak: false,
		      inCaseClause: false
		    });
		    return records.map(function (r) {
		      return r.path;
		    });
		  }
		  function getSibling(key) {
		    return NodePath_Final.get({
		      parentPath: this.parentPath,
		      parent: this.parent,
		      container: this.container,
		      listKey: this.listKey,
		      key: key
		    }).setContext(this.context);
		  }
		  function getPrevSibling() {
		    return this.getSibling(this.key - 1);
		  }
		  function getNextSibling() {
		    return this.getSibling(this.key + 1);
		  }
		  function getAllNextSiblings() {
		    var _key = this.key;
		    var sibling = this.getSibling(++_key);
		    var siblings = [];
		    while (sibling.node) {
		      siblings.push(sibling);
		      sibling = this.getSibling(++_key);
		    }
		    return siblings;
		  }
		  function getAllPrevSiblings() {
		    var _key = this.key;
		    var sibling = this.getSibling(--_key);
		    var siblings = [];
		    while (sibling.node) {
		      siblings.push(sibling);
		      sibling = this.getSibling(--_key);
		    }
		    return siblings;
		  }
		  function get$2(key, context) {
		    if (context === void 0) {
		      context = true;
		    }
		    if (context === true) context = this.context;
		    var parts = key.split(".");
		    if (parts.length === 1) {
		      return this._getKey(key, context);
		    } else {
		      return this._getPattern(parts, context);
		    }
		  }
		  function _getKey(key, context) {
		    var _this = this;
		    var node = this.node;
		    var container = node[key];
		    if (Array.isArray(container)) {
		      return container.map(function (_, i) {
		        return NodePath_Final.get({
		          listKey: key,
		          parentPath: _this,
		          parent: node,
		          container: container,
		          key: i
		        }).setContext(context);
		      });
		    } else {
		      return NodePath_Final.get({
		        parentPath: this,
		        parent: node,
		        container: node,
		        key: key
		      }).setContext(context);
		    }
		  }
		  function _getPattern(parts, context) {
		    var path = this;
		    for (var _iterator = _createForOfIteratorHelperLoose(parts), _step; !(_step = _iterator()).done;) {
		      var part = _step.value;
		      if (part === ".") {
		        path = path.parentPath;
		      } else {
		        if (Array.isArray(path)) {
		          path = path[part];
		        } else {
		          path = path.get(part, context);
		        }
		      }
		    }
		    return path;
		  }
		  function getBindingIdentifiers(duplicates) {
		    return _getBindingIdentifiers(this.node, duplicates);
		  }
		  function getOuterBindingIdentifiers$1(duplicates) {
		    return _getOuterBindingIdentifiers(this.node, duplicates);
		  }
		  function getBindingIdentifierPaths(duplicates, outerOnly) {
		    if (duplicates === void 0) {
		      duplicates = false;
		    }
		    if (outerOnly === void 0) {
		      outerOnly = false;
		    }
		    var path = this;
		    var search = [path];
		    var ids = Object.create(null);
		    while (search.length) {
		      var id = search.shift();
		      if (!id) continue;
		      if (!id.node) continue;
		      var keys = _getBindingIdentifiers.keys[id.node.type];
		      if (id.isIdentifier()) {
		        if (duplicates) {
		          var _ids = ids[id.node.name] = ids[id.node.name] || [];
		          _ids.push(id);
		        } else {
		          ids[id.node.name] = id;
		        }
		        continue;
		      }
		      if (id.isExportDeclaration()) {
		        var declaration = id.get("declaration");
		        if (declaration.isDeclaration()) {
		          search.push(declaration);
		        }
		        continue;
		      }
		      if (outerOnly) {
		        if (id.isFunctionDeclaration()) {
		          search.push(id.get("id"));
		          continue;
		        }
		        if (id.isFunctionExpression()) {
		          continue;
		        }
		      }
		      if (keys) {
		        for (var i = 0; i < keys.length; i++) {
		          var _key2 = keys[i];
		          var child = id.get(_key2);
		          if (Array.isArray(child)) {
		            search.push.apply(search, _toConsumableArray(child));
		          } else if (child.node) {
		            search.push(child);
		          }
		        }
		      }
		    }
		    return ids;
		  }
		  function getOuterBindingIdentifierPaths(duplicates) {
		    if (duplicates === void 0) {
		      duplicates = false;
		    }
		    return this.getBindingIdentifierPaths(duplicates, true);
		  }

		  var NodePath_family = /*#__PURE__*/Object.freeze({
		    __proto__: null,
		    _getKey: _getKey,
		    _getPattern: _getPattern,
		    get: get$2,
		    getAllNextSiblings: getAllNextSiblings,
		    getAllPrevSiblings: getAllPrevSiblings,
		    getBindingIdentifierPaths: getBindingIdentifierPaths,
		    getBindingIdentifiers: getBindingIdentifiers,
		    getCompletionRecords: getCompletionRecords,
		    getNextSibling: getNextSibling,
		    getOpposite: getOpposite,
		    getOuterBindingIdentifierPaths: getOuterBindingIdentifierPaths,
		    getOuterBindingIdentifiers: getOuterBindingIdentifiers$1,
		    getPrevSibling: getPrevSibling,
		    getSibling: getSibling
		  });

		  var _addComment = addComment$2,
		    _addComments = addComments$1;
		  function shareCommentsWithSiblings() {
		    if (typeof this.key === "string") return;
		    var node = this.node;
		    if (!node) return;
		    var trailing = node.trailingComments;
		    var leading = node.leadingComments;
		    if (!trailing && !leading) return;
		    var prev = this.getSibling(this.key - 1);
		    var next = this.getSibling(this.key + 1);
		    var hasPrev = Boolean(prev.node);
		    var hasNext = Boolean(next.node);
		    if (hasPrev) {
		      if (leading) {
		        prev.addComments("trailing", removeIfExisting(leading, prev.node.trailingComments));
		      }
		      if (trailing && !hasNext) prev.addComments("trailing", trailing);
		    }
		    if (hasNext) {
		      if (trailing) {
		        next.addComments("leading", removeIfExisting(trailing, next.node.leadingComments));
		      }
		      if (leading && !hasPrev) next.addComments("leading", leading);
		    }
		  }
		  function removeIfExisting(list, toRemove) {
		    if (!(toRemove != null && toRemove.length)) return list;
		    var set = new Set(toRemove);
		    return list.filter(function (el) {
		      return !set.has(el);
		    });
		  }
		  function addComment$1(type, content, line) {
		    _addComment(this.node, type, content, line);
		  }
		  function addComments(type, comments) {
		    _addComments(this.node, type, comments);
		  }

		  var NodePath_comments = /*#__PURE__*/Object.freeze({
		    __proto__: null,
		    addComment: addComment$1,
		    addComments: addComments,
		    shareCommentsWithSiblings: shareCommentsWithSiblings
		  });

		  var validate$1 = validate$5;
		  var _debug = browserExports("babel");
		  var REMOVED = 1 << 0;
		  var SHOULD_STOP = 1 << 1;
		  var SHOULD_SKIP = 1 << 2;
		  var NodePath_Final = function () {
		    function NodePath(hub, parent) {
		      this.contexts = [];
		      this.state = null;
		      this.opts = null;
		      this._traverseFlags = 0;
		      this.skipKeys = null;
		      this.parentPath = null;
		      this.container = null;
		      this.listKey = null;
		      this.key = null;
		      this.node = null;
		      this.type = null;
		      this.parent = parent;
		      this.hub = hub;
		      this.data = null;
		      this.context = null;
		      this.scope = null;
		    }
		    NodePath.get = function get(_ref) {
		      var hub = _ref.hub,
		        parentPath = _ref.parentPath,
		        parent = _ref.parent,
		        container = _ref.container,
		        listKey = _ref.listKey,
		        key = _ref.key;
		      if (!hub && parentPath) {
		        hub = parentPath.hub;
		      }
		      if (!parent) {
		        throw new Error("To get a node path the parent needs to exist");
		      }
		      var targetNode = container[key];
		      var paths = getOrCreateCachedPaths(hub, parent);
		      var path = paths.get(targetNode);
		      if (!path) {
		        path = new NodePath(hub, parent);
		        if (targetNode) paths.set(targetNode, path);
		      }
		      path.setup(parentPath, container, listKey, key);
		      return path;
		    };
		    var _proto = NodePath.prototype;
		    _proto.getScope = function getScope(scope) {
		      return this.isScope() ? new Scope$1(this) : scope;
		    };
		    _proto.setData = function setData(key, val) {
		      if (this.data == null) {
		        this.data = Object.create(null);
		      }
		      return this.data[key] = val;
		    };
		    _proto.getData = function getData(key, def) {
		      if (this.data == null) {
		        this.data = Object.create(null);
		      }
		      var val = this.data[key];
		      if (val === undefined && def !== undefined) val = this.data[key] = def;
		      return val;
		    };
		    _proto.hasNode = function hasNode() {
		      return this.node != null;
		    };
		    _proto.buildCodeFrameError = function buildCodeFrameError(msg, Error) {
		      if (Error === void 0) {
		        Error = SyntaxError;
		      }
		      return this.hub.buildError(this.node, msg, Error);
		    };
		    _proto.traverse = function traverse$1(visitor, state) {
		      traverse(this.node, visitor, this.scope, state, this);
		    };
		    _proto.set = function set(key, node) {
		      validate$1(this.node, key, node);
		      this.node[key] = node;
		    };
		    _proto.getPathLocation = function getPathLocation() {
		      var parts = [];
		      var path = this;
		      do {
		        var key = path.key;
		        if (path.inList) key = path.listKey + "[" + key + "]";
		        parts.unshift(key);
		      } while (path = path.parentPath);
		      return parts.join(".");
		    };
		    _proto.debug = function debug(message) {
		      if (!_debug.enabled) return;
		      _debug(this.getPathLocation() + " " + this.type + ": " + message);
		    };
		    _proto.toString = function toString() {
		      return generate$1(this.node).code;
		    };
		    return _createClass(NodePath, [{
		      key: "inList",
		      get: function get() {
		        return !!this.listKey;
		      },
		      set: function set(inList) {
		        if (!inList) {
		          this.listKey = null;
		        }
		      }
		    }, {
		      key: "parentKey",
		      get: function get() {
		        return this.listKey || this.key;
		      }
		    }, {
		      key: "shouldSkip",
		      get: function get() {
		        return !!(this._traverseFlags & SHOULD_SKIP);
		      },
		      set: function set(v) {
		        if (v) {
		          this._traverseFlags |= SHOULD_SKIP;
		        } else {
		          this._traverseFlags &= ~SHOULD_SKIP;
		        }
		      }
		    }, {
		      key: "shouldStop",
		      get: function get() {
		        return !!(this._traverseFlags & SHOULD_STOP);
		      },
		      set: function set(v) {
		        if (v) {
		          this._traverseFlags |= SHOULD_STOP;
		        } else {
		          this._traverseFlags &= ~SHOULD_STOP;
		        }
		      }
		    }, {
		      key: "removed",
		      get: function get() {
		        return !!(this._traverseFlags & REMOVED);
		      },
		      set: function set(v) {
		        if (v) {
		          this._traverseFlags |= REMOVED;
		        } else {
		          this._traverseFlags &= ~REMOVED;
		        }
		      }
		    }]);
		  }();
		  Object.assign(NodePath_Final.prototype, NodePath_ancestry, NodePath_inference, NodePath_replacement, NodePath_evaluation, NodePath_conversion, NodePath_introspection, NodePath_context, NodePath_removal, NodePath_modification, NodePath_family, NodePath_comments);
		  {
		    NodePath_Final.prototype._guessExecutionStatusRelativeToDifferentFunctions = _guessExecutionStatusRelativeTo;
		  }
		  var _loop = function _loop() {
		    var type = _step.value;
		    var typeKey = "is" + type;
		    var fn = t$4[typeKey];
		    NodePath_Final.prototype[typeKey] = function (opts) {
		      return fn(this.node, opts);
		    };
		    NodePath_Final.prototype["assert" + type] = function (opts) {
		      if (!fn(this.node, opts)) {
		        throw new TypeError("Expected node path of type " + type);
		      }
		    };
		  };
		  for (var _iterator = _createForOfIteratorHelperLoose(TYPES$1), _step; !(_step = _iterator()).done;) {
		    _loop();
		  }
		  Object.assign(NodePath_Final.prototype, NodePath_virtual_types_validator);
		  for (var _i = 0, _arr = Object.keys(virtualTypes); _i < _arr.length; _i++) {
		    var type = _arr[_i];
		    if (type[0] === "_") continue;
		    if (!TYPES$1.includes(type)) TYPES$1.push(type);
		  }

		  var VISITOR_KEYS$2 = VISITOR_KEYS$5;
		  var TraversalContext = function () {
		    function TraversalContext(scope, opts, state, parentPath) {
		      this.queue = null;
		      this.priorityQueue = null;
		      this.parentPath = parentPath;
		      this.scope = scope;
		      this.state = state;
		      this.opts = opts;
		    }
		    var _proto = TraversalContext.prototype;
		    _proto.shouldVisit = function shouldVisit(node) {
		      var opts = this.opts;
		      if (opts.enter || opts.exit) return true;
		      if (opts[node.type]) return true;
		      var keys = VISITOR_KEYS$2[node.type];
		      if (!(keys != null && keys.length)) return false;
		      for (var _iterator = _createForOfIteratorHelperLoose(keys), _step; !(_step = _iterator()).done;) {
		        var key = _step.value;
		        if (node[key]) {
		          return true;
		        }
		      }
		      return false;
		    };
		    _proto.create = function create(node, container, key, listKey) {
		      return NodePath_Final.get({
		        parentPath: this.parentPath,
		        parent: node,
		        container: container,
		        key: key,
		        listKey: listKey
		      });
		    };
		    _proto.maybeQueue = function maybeQueue(path, notPriority) {
		      if (this.queue) {
		        if (notPriority) {
		          this.queue.push(path);
		        } else {
		          this.priorityQueue.push(path);
		        }
		      }
		    };
		    _proto.visitMultiple = function visitMultiple(container, parent, listKey) {
		      if (container.length === 0) return false;
		      var queue = [];
		      for (var key = 0; key < container.length; key++) {
		        var node = container[key];
		        if (node && this.shouldVisit(node)) {
		          queue.push(this.create(parent, container, key, listKey));
		        }
		      }
		      return this.visitQueue(queue);
		    };
		    _proto.visitSingle = function visitSingle(node, key) {
		      if (this.shouldVisit(node[key])) {
		        return this.visitQueue([this.create(node, node, key)]);
		      } else {
		        return false;
		      }
		    };
		    _proto.visitQueue = function visitQueue(queue) {
		      this.queue = queue;
		      this.priorityQueue = [];
		      var visited = new WeakSet();
		      var stop = false;
		      var visitIndex = 0;
		      for (; visitIndex < queue.length;) {
		        var path = queue[visitIndex];
		        visitIndex++;
		        path.resync();
		        if (path.contexts.length === 0 || path.contexts[path.contexts.length - 1] !== this) {
		          path.pushContext(this);
		        }
		        if (path.key === null) continue;
		        var node = path.node;
		        if (visited.has(node)) continue;
		        if (node) visited.add(node);
		        if (path.visit()) {
		          stop = true;
		          break;
		        }
		        if (this.priorityQueue.length) {
		          stop = this.visitQueue(this.priorityQueue);
		          this.priorityQueue = [];
		          this.queue = queue;
		          if (stop) break;
		        }
		      }
		      for (var i = 0; i < visitIndex; i++) {
		        queue[i].popContext();
		      }
		      this.queue = null;
		      return stop;
		    };
		    _proto.visit = function visit(node, key) {
		      var nodes = node[key];
		      if (!nodes) return false;
		      if (Array.isArray(nodes)) {
		        return this.visitMultiple(nodes, node, key);
		      } else {
		        return this.visitSingle(node, key);
		      }
		    };
		    return _createClass(TraversalContext);
		  }();

		  var VISITOR_KEYS$1 = VISITOR_KEYS$5;
		  function traverseNode(node, opts, scope, state, path, skipKeys, visitSelf) {
		    var keys = VISITOR_KEYS$1[node.type];
		    if (!keys) return false;
		    var context = new TraversalContext(scope, opts, state, path);
		    if (visitSelf) {
		      if (skipKeys != null && skipKeys[path.parentKey]) return false;
		      return context.visitQueue([path]);
		    }
		    for (var _iterator = _createForOfIteratorHelperLoose(keys), _step; !(_step = _iterator()).done;) {
		      var key = _step.value;
		      if (skipKeys != null && skipKeys[key]) continue;
		      if (context.visit(node, key)) {
		        return true;
		      }
		    }
		    return false;
		  }

		  var Hub = function () {
		    function Hub() {}
		    var _proto = Hub.prototype;
		    _proto.getCode = function getCode() {};
		    _proto.getScope = function getScope() {};
		    _proto.addHelper = function addHelper() {
		      throw new Error("Helpers are not supported by the default hub.");
		    };
		    _proto.buildError = function buildError(node, msg, Error) {
		      if (Error === void 0) {
		        Error = TypeError;
		      }
		      return new Error(msg);
		    };
		    return _createClass(Hub);
		  }();

		  var VISITOR_KEYS = VISITOR_KEYS$5,
		    removeProperties = removeProperties$1,
		    traverseFast$1 = traverseFast$2;
		  function traverse(parent, opts, scope, state, parentPath, visitSelf) {
		    if (opts === void 0) {
		      opts = {};
		    }
		    if (!parent) return;
		    if (!opts.noScope && !scope) {
		      if (parent.type !== "Program" && parent.type !== "File") {
		        throw new Error("You must pass a scope and parentPath unless traversing a Program/File. " + ("Instead of that you tried to traverse a " + parent.type + " node without ") + "passing scope and parentPath.");
		      }
		    }
		    if (!parentPath && visitSelf) {
		      throw new Error("visitSelf can only be used when providing a NodePath.");
		    }
		    if (!VISITOR_KEYS[parent.type]) {
		      return;
		    }
		    explode$1(opts);
		    traverseNode(parent, opts, scope, state, parentPath, null, visitSelf);
		  }
		  traverse.visitors = visitors$2;
		  traverse.verify = verify;
		  traverse.explode = explode$1;
		  traverse.cheap = function (node, enter) {
		    traverseFast$1(node, enter);
		    return;
		  };
		  traverse.node = function (node, opts, scope, state, path, skipKeys) {
		    traverseNode(node, opts, scope, state, path, skipKeys);
		  };
		  traverse.clearNode = function (node, opts) {
		    removeProperties(node, opts);
		  };
		  traverse.removeProperties = function (tree, opts) {
		    traverseFast$1(tree, traverse.clearNode, opts);
		    return tree;
		  };
		  function hasDenylistedType(path, state) {
		    if (path.node.type === state.type) {
		      state.has = true;
		      path.stop();
		    }
		  }
		  traverse.hasType = function (tree, type, denylistTypes) {
		    if (denylistTypes != null && denylistTypes.includes(tree.type)) return false;
		    if (tree.type === type) return true;
		    var state = {
		      has: false,
		      type: type
		    };
		    traverse(tree, {
		      noScope: true,
		      denylist: denylistTypes,
		      enter: hasDenylistedType
		    }, null, state);
		    return state.has;
		  };
		  traverse.cache = cache$1;

		  var index$1 = /*#__PURE__*/Object.freeze({
		    __proto__: null,
		    Hub: Hub,
		    NodePath: NodePath_Final,
		    Scope: Scope$1,
		    default: traverse,
		    visitors: visitors$2
		  });

		  function helper$3(minVersion, source) {
		    return Object.freeze({
		      minVersion: minVersion,
		      ast: function ast() {
		        return template$1.program.ast(source, {
		          preserveComments: true
		        });
		      }
		    });
		  }
		  var generated = Object.freeze({
		    AsyncGenerator: helper$3("7.0.0-beta.0", 'import OverloadYield from"OverloadYield";export default function AsyncGenerator(e){var r,t;function resume(r,t){try{var n=e[r](t),o=n.value,u=o instanceof OverloadYield;Promise.resolve(u?o.v:o).then((function(t){if(u){var i="return"===r?"return":"next";if(!o.k||t.done)return resume(i,t);t=e[i](t).value}settle(n.done?"return":"normal",t)}),(function(e){resume("throw",e)}))}catch(e){settle("throw",e)}}function settle(e,n){switch(e){case"return":r.resolve({value:n,done:!0});break;case"throw":r.reject(n);break;default:r.resolve({value:n,done:!1})}(r=r.next)?resume(r.key,r.arg):t=null}this._invoke=function(e,n){return new Promise((function(o,u){var i={key:e,arg:n,resolve:o,reject:u,next:null};t?t=t.next=i:(r=t=i,resume(e,n))}))},"function"!=typeof e.return&&(this.return=void 0)}AsyncGenerator.prototype["function"==typeof Symbol&&Symbol.asyncIterator||"@@asyncIterator"]=function(){return this},AsyncGenerator.prototype.next=function(e){return this._invoke("next",e)},AsyncGenerator.prototype.throw=function(e){return this._invoke("throw",e)},AsyncGenerator.prototype.return=function(e){return this._invoke("return",e)};'),
		    OverloadYield: helper$3("7.18.14", "export default function _OverloadYield(t,e){this.v=t,this.k=e}"),
		    applyDecs: helper$3("7.17.8", 'import setFunctionName from"setFunctionName";import toPropertyKey from"toPropertyKey";function old_createMetadataMethodsForProperty(e,t,a,r){return{getMetadata:function(o){old_assertNotFinished(r,"getMetadata"),old_assertMetadataKey(o);var i=e[o];if(void 0!==i)if(1===t){var n=i.public;if(void 0!==n)return n[a]}else if(2===t){var l=i.private;if(void 0!==l)return l.get(a)}else if(Object.hasOwnProperty.call(i,"constructor"))return i.constructor},setMetadata:function(o,i){old_assertNotFinished(r,"setMetadata"),old_assertMetadataKey(o);var n=e[o];if(void 0===n&&(n=e[o]={}),1===t){var l=n.public;void 0===l&&(l=n.public={}),l[a]=i}else if(2===t){var s=n.priv;void 0===s&&(s=n.private=new Map),s.set(a,i)}else n.constructor=i}}}function old_convertMetadataMapToFinal(e,t){var a=e[Symbol.metadata||Symbol.for("Symbol.metadata")],r=Object.getOwnPropertySymbols(t);if(0!==r.length){for(var o=0;o<r.length;o++){var i=r[o],n=t[i],l=a?a[i]:null,s=n.public,c=l?l.public:null;s&&c&&Object.setPrototypeOf(s,c);var d=n.private;if(d){var u=Array.from(d.values()),f=l?l.private:null;f&&(u=u.concat(f)),n.private=u}l&&Object.setPrototypeOf(n,l)}a&&Object.setPrototypeOf(t,a),e[Symbol.metadata||Symbol.for("Symbol.metadata")]=t}}function old_createAddInitializerMethod(e,t){return function(a){old_assertNotFinished(t,"addInitializer"),old_assertCallable(a,"An initializer"),e.push(a)}}function old_memberDec(e,t,a,r,o,i,n,l,s){var c;switch(i){case 1:c="accessor";break;case 2:c="method";break;case 3:c="getter";break;case 4:c="setter";break;default:c="field"}var d,u,f={kind:c,name:l?"#"+t:toPropertyKey(t),isStatic:n,isPrivate:l},p={v:!1};if(0!==i&&(f.addInitializer=old_createAddInitializerMethod(o,p)),l){d=2,u=Symbol(t);var v={};0===i?(v.get=a.get,v.set=a.set):2===i?v.get=function(){return a.value}:(1!==i&&3!==i||(v.get=function(){return a.get.call(this)}),1!==i&&4!==i||(v.set=function(e){a.set.call(this,e)})),f.access=v}else d=1,u=t;try{return e(s,Object.assign(f,old_createMetadataMethodsForProperty(r,d,u,p)))}finally{p.v=!0}}function old_assertNotFinished(e,t){if(e.v)throw Error("attempted to call "+t+" after decoration was finished")}function old_assertMetadataKey(e){if("symbol"!=typeof e)throw new TypeError("Metadata keys must be symbols, received: "+e)}function old_assertCallable(e,t){if("function"!=typeof e)throw new TypeError(t+" must be a function")}function old_assertValidReturnValue(e,t){var a=typeof t;if(1===e){if("object"!==a||null===t)throw new TypeError("accessor decorators must return an object with get, set, or init properties or void 0");void 0!==t.get&&old_assertCallable(t.get,"accessor.get"),void 0!==t.set&&old_assertCallable(t.set,"accessor.set"),void 0!==t.init&&old_assertCallable(t.init,"accessor.init"),void 0!==t.initializer&&old_assertCallable(t.initializer,"accessor.initializer")}else if("function"!==a)throw new TypeError((0===e?"field":10===e?"class":"method")+" decorators must return a function or void 0")}function old_getInit(e){var t;return null==(t=e.init)&&(t=e.initializer)&&void 0!==console&&console.warn(".initializer has been renamed to .init as of March 2022"),t}function old_applyMemberDec(e,t,a,r,o,i,n,l,s){var c,d,u,f,p,v,y,h=a[0];if(n?(0===o||1===o?(c={get:a[3],set:a[4]},u="get"):3===o?(c={get:a[3]},u="get"):4===o?(c={set:a[3]},u="set"):c={value:a[3]},0!==o&&(1===o&&setFunctionName(a[4],"#"+r,"set"),setFunctionName(a[3],"#"+r,u))):0!==o&&(c=Object.getOwnPropertyDescriptor(t,r)),1===o?f={get:c.get,set:c.set}:2===o?f=c.value:3===o?f=c.get:4===o&&(f=c.set),"function"==typeof h)void 0!==(p=old_memberDec(h,r,c,l,s,o,i,n,f))&&(old_assertValidReturnValue(o,p),0===o?d=p:1===o?(d=old_getInit(p),v=p.get||f.get,y=p.set||f.set,f={get:v,set:y}):f=p);else for(var m=h.length-1;m>=0;m--){var b;void 0!==(p=old_memberDec(h[m],r,c,l,s,o,i,n,f))&&(old_assertValidReturnValue(o,p),0===o?b=p:1===o?(b=old_getInit(p),v=p.get||f.get,y=p.set||f.set,f={get:v,set:y}):f=p,void 0!==b&&(void 0===d?d=b:"function"==typeof d?d=[d,b]:d.push(b)))}if(0===o||1===o){if(void 0===d)d=function(e,t){return t};else if("function"!=typeof d){var g=d;d=function(e,t){for(var a=t,r=0;r<g.length;r++)a=g[r].call(e,a);return a}}else{var _=d;d=function(e,t){return _.call(e,t)}}e.push(d)}0!==o&&(1===o?(c.get=f.get,c.set=f.set):2===o?c.value=f:3===o?c.get=f:4===o&&(c.set=f),n?1===o?(e.push((function(e,t){return f.get.call(e,t)})),e.push((function(e,t){return f.set.call(e,t)}))):2===o?e.push(f):e.push((function(e,t){return f.call(e,t)})):Object.defineProperty(t,r,c))}function old_applyMemberDecs(e,t,a,r,o){for(var i,n,l=new Map,s=new Map,c=0;c<o.length;c++){var d=o[c];if(Array.isArray(d)){var u,f,p,v=d[1],y=d[2],h=d.length>3,m=v>=5;if(m?(u=t,f=r,0!=(v-=5)&&(p=n=n||[])):(u=t.prototype,f=a,0!==v&&(p=i=i||[])),0!==v&&!h){var b=m?s:l,g=b.get(y)||0;if(!0===g||3===g&&4!==v||4===g&&3!==v)throw Error("Attempted to decorate a public method/accessor that has the same name as a previously decorated public method/accessor. This is not currently supported by the decorators plugin. Property name was: "+y);!g&&v>2?b.set(y,v):b.set(y,!0)}old_applyMemberDec(e,u,d,y,v,m,h,f,p)}}old_pushInitializers(e,i),old_pushInitializers(e,n)}function old_pushInitializers(e,t){t&&e.push((function(e){for(var a=0;a<t.length;a++)t[a].call(e);return e}))}function old_applyClassDecs(e,t,a,r){if(r.length>0){for(var o=[],i=t,n=t.name,l=r.length-1;l>=0;l--){var s={v:!1};try{var c=Object.assign({kind:"class",name:n,addInitializer:old_createAddInitializerMethod(o,s)},old_createMetadataMethodsForProperty(a,0,n,s)),d=r[l](i,c)}finally{s.v=!0}void 0!==d&&(old_assertValidReturnValue(10,d),i=d)}e.push(i,(function(){for(var e=0;e<o.length;e++)o[e].call(i)}))}}export default function applyDecs(e,t,a){var r=[],o={},i={};return old_applyMemberDecs(r,e,i,o,t),old_convertMetadataMapToFinal(e.prototype,i),old_applyClassDecs(r,e,o,a),old_convertMetadataMapToFinal(e,o),r}'),
		    applyDecs2203: helper$3("7.19.0", 'function applyDecs2203Factory(){function createAddInitializerMethod(e,t){return function(r){!function(e,t){if(e.v)throw Error("attempted to call addInitializer after decoration was finished")}(t),assertCallable(r,"An initializer"),e.push(r)}}function memberDec(e,t,r,a,n,i,s,o){var c;switch(n){case 1:c="accessor";break;case 2:c="method";break;case 3:c="getter";break;case 4:c="setter";break;default:c="field"}var l,u,f={kind:c,name:s?"#"+t:t,static:i,private:s},p={v:!1};0!==n&&(f.addInitializer=createAddInitializerMethod(a,p)),0===n?s?(l=r.get,u=r.set):(l=function(){return this[t]},u=function(e){this[t]=e}):2===n?l=function(){return r.value}:(1!==n&&3!==n||(l=function(){return r.get.call(this)}),1!==n&&4!==n||(u=function(e){r.set.call(this,e)})),f.access=l&&u?{get:l,set:u}:l?{get:l}:{set:u};try{return e(o,f)}finally{p.v=!0}}function assertCallable(e,t){if("function"!=typeof e)throw new TypeError(t+" must be a function")}function assertValidReturnValue(e,t){var r=typeof t;if(1===e){if("object"!==r||null===t)throw new TypeError("accessor decorators must return an object with get, set, or init properties or void 0");void 0!==t.get&&assertCallable(t.get,"accessor.get"),void 0!==t.set&&assertCallable(t.set,"accessor.set"),void 0!==t.init&&assertCallable(t.init,"accessor.init")}else if("function"!==r)throw new TypeError((0===e?"field":10===e?"class":"method")+" decorators must return a function or void 0")}function applyMemberDec(e,t,r,a,n,i,s,o){var c,l,u,f,p,d,h=r[0];if(s?c=0===n||1===n?{get:r[3],set:r[4]}:3===n?{get:r[3]}:4===n?{set:r[3]}:{value:r[3]}:0!==n&&(c=Object.getOwnPropertyDescriptor(t,a)),1===n?u={get:c.get,set:c.set}:2===n?u=c.value:3===n?u=c.get:4===n&&(u=c.set),"function"==typeof h)void 0!==(f=memberDec(h,a,c,o,n,i,s,u))&&(assertValidReturnValue(n,f),0===n?l=f:1===n?(l=f.init,p=f.get||u.get,d=f.set||u.set,u={get:p,set:d}):u=f);else for(var v=h.length-1;v>=0;v--){var g;void 0!==(f=memberDec(h[v],a,c,o,n,i,s,u))&&(assertValidReturnValue(n,f),0===n?g=f:1===n?(g=f.init,p=f.get||u.get,d=f.set||u.set,u={get:p,set:d}):u=f,void 0!==g&&(void 0===l?l=g:"function"==typeof l?l=[l,g]:l.push(g)))}if(0===n||1===n){if(void 0===l)l=function(e,t){return t};else if("function"!=typeof l){var y=l;l=function(e,t){for(var r=t,a=0;a<y.length;a++)r=y[a].call(e,r);return r}}else{var m=l;l=function(e,t){return m.call(e,t)}}e.push(l)}0!==n&&(1===n?(c.get=u.get,c.set=u.set):2===n?c.value=u:3===n?c.get=u:4===n&&(c.set=u),s?1===n?(e.push((function(e,t){return u.get.call(e,t)})),e.push((function(e,t){return u.set.call(e,t)}))):2===n?e.push(u):e.push((function(e,t){return u.call(e,t)})):Object.defineProperty(t,a,c))}function pushInitializers(e,t){t&&e.push((function(e){for(var r=0;r<t.length;r++)t[r].call(e);return e}))}return function(e,t,r){var a=[];return function(e,t,r){for(var a,n,i=new Map,s=new Map,o=0;o<r.length;o++){var c=r[o];if(Array.isArray(c)){var l,u,f=c[1],p=c[2],d=c.length>3,h=f>=5;if(h?(l=t,0!=(f-=5)&&(u=n=n||[])):(l=t.prototype,0!==f&&(u=a=a||[])),0!==f&&!d){var v=h?s:i,g=v.get(p)||0;if(!0===g||3===g&&4!==f||4===g&&3!==f)throw Error("Attempted to decorate a public method/accessor that has the same name as a previously decorated public method/accessor. This is not currently supported by the decorators plugin. Property name was: "+p);!g&&f>2?v.set(p,f):v.set(p,!0)}applyMemberDec(e,l,c,p,f,h,d,u)}}pushInitializers(e,a),pushInitializers(e,n)}(a,e,t),function(e,t,r){if(r.length>0){for(var a=[],n=t,i=t.name,s=r.length-1;s>=0;s--){var o={v:!1};try{var c=r[s](n,{kind:"class",name:i,addInitializer:createAddInitializerMethod(a,o)})}finally{o.v=!0}void 0!==c&&(assertValidReturnValue(10,c),n=c)}e.push(n,(function(){for(var e=0;e<a.length;e++)a[e].call(n)}))}}(a,e,r),a}}var applyDecs2203Impl;export default function applyDecs2203(e,t,r){return(applyDecs2203Impl=applyDecs2203Impl||applyDecs2203Factory())(e,t,r)}'),
		    applyDecs2203R: helper$3("7.20.0", 'import setFunctionName from"setFunctionName";import toPropertyKey from"toPropertyKey";function applyDecs2203RFactory(){function createAddInitializerMethod(e,t){return function(r){!function(e,t){if(e.v)throw Error("attempted to call addInitializer after decoration was finished")}(t),assertCallable(r,"An initializer"),e.push(r)}}function memberDec(e,t,r,n,a,i,o,s){var c;switch(a){case 1:c="accessor";break;case 2:c="method";break;case 3:c="getter";break;case 4:c="setter";break;default:c="field"}var l,u,f={kind:c,name:o?"#"+t:toPropertyKey(t),static:i,private:o},p={v:!1};0!==a&&(f.addInitializer=createAddInitializerMethod(n,p)),0===a?o?(l=r.get,u=r.set):(l=function(){return this[t]},u=function(e){this[t]=e}):2===a?l=function(){return r.value}:(1!==a&&3!==a||(l=function(){return r.get.call(this)}),1!==a&&4!==a||(u=function(e){r.set.call(this,e)})),f.access=l&&u?{get:l,set:u}:l?{get:l}:{set:u};try{return e(s,f)}finally{p.v=!0}}function assertCallable(e,t){if("function"!=typeof e)throw new TypeError(t+" must be a function")}function assertValidReturnValue(e,t){var r=typeof t;if(1===e){if("object"!==r||null===t)throw new TypeError("accessor decorators must return an object with get, set, or init properties or void 0");void 0!==t.get&&assertCallable(t.get,"accessor.get"),void 0!==t.set&&assertCallable(t.set,"accessor.set"),void 0!==t.init&&assertCallable(t.init,"accessor.init")}else if("function"!==r)throw new TypeError((0===e?"field":10===e?"class":"method")+" decorators must return a function or void 0")}function applyMemberDec(e,t,r,n,a,i,o,s){var c,l,u,f,p,d,h,v=r[0];if(o?(0===a||1===a?(c={get:r[3],set:r[4]},u="get"):3===a?(c={get:r[3]},u="get"):4===a?(c={set:r[3]},u="set"):c={value:r[3]},0!==a&&(1===a&&setFunctionName(r[4],"#"+n,"set"),setFunctionName(r[3],"#"+n,u))):0!==a&&(c=Object.getOwnPropertyDescriptor(t,n)),1===a?f={get:c.get,set:c.set}:2===a?f=c.value:3===a?f=c.get:4===a&&(f=c.set),"function"==typeof v)void 0!==(p=memberDec(v,n,c,s,a,i,o,f))&&(assertValidReturnValue(a,p),0===a?l=p:1===a?(l=p.init,d=p.get||f.get,h=p.set||f.set,f={get:d,set:h}):f=p);else for(var g=v.length-1;g>=0;g--){var y;void 0!==(p=memberDec(v[g],n,c,s,a,i,o,f))&&(assertValidReturnValue(a,p),0===a?y=p:1===a?(y=p.init,d=p.get||f.get,h=p.set||f.set,f={get:d,set:h}):f=p,void 0!==y&&(void 0===l?l=y:"function"==typeof l?l=[l,y]:l.push(y)))}if(0===a||1===a){if(void 0===l)l=function(e,t){return t};else if("function"!=typeof l){var m=l;l=function(e,t){for(var r=t,n=0;n<m.length;n++)r=m[n].call(e,r);return r}}else{var b=l;l=function(e,t){return b.call(e,t)}}e.push(l)}0!==a&&(1===a?(c.get=f.get,c.set=f.set):2===a?c.value=f:3===a?c.get=f:4===a&&(c.set=f),o?1===a?(e.push((function(e,t){return f.get.call(e,t)})),e.push((function(e,t){return f.set.call(e,t)}))):2===a?e.push(f):e.push((function(e,t){return f.call(e,t)})):Object.defineProperty(t,n,c))}function applyMemberDecs(e,t){for(var r,n,a=[],i=new Map,o=new Map,s=0;s<t.length;s++){var c=t[s];if(Array.isArray(c)){var l,u,f=c[1],p=c[2],d=c.length>3,h=f>=5;if(h?(l=e,0!=(f-=5)&&(u=n=n||[])):(l=e.prototype,0!==f&&(u=r=r||[])),0!==f&&!d){var v=h?o:i,g=v.get(p)||0;if(!0===g||3===g&&4!==f||4===g&&3!==f)throw Error("Attempted to decorate a public method/accessor that has the same name as a previously decorated public method/accessor. This is not currently supported by the decorators plugin. Property name was: "+p);!g&&f>2?v.set(p,f):v.set(p,!0)}applyMemberDec(a,l,c,p,f,h,d,u)}}return pushInitializers(a,r),pushInitializers(a,n),a}function pushInitializers(e,t){t&&e.push((function(e){for(var r=0;r<t.length;r++)t[r].call(e);return e}))}return function(e,t,r){return{e:applyMemberDecs(e,t),get c(){return function(e,t){if(t.length>0){for(var r=[],n=e,a=e.name,i=t.length-1;i>=0;i--){var o={v:!1};try{var s=t[i](n,{kind:"class",name:a,addInitializer:createAddInitializerMethod(r,o)})}finally{o.v=!0}void 0!==s&&(assertValidReturnValue(10,s),n=s)}return[n,function(){for(var e=0;e<r.length;e++)r[e].call(n)}]}}(e,r)}}}}export default function applyDecs2203R(e,t,r){return(applyDecs2203R=applyDecs2203RFactory())(e,t,r)}'),
		    applyDecs2301: helper$3("7.21.0", 'import checkInRHS from"checkInRHS";import setFunctionName from"setFunctionName";import toPropertyKey from"toPropertyKey";function applyDecs2301Factory(){function createAddInitializerMethod(e,t){return function(r){!function(e,t){if(e.v)throw Error("attempted to call addInitializer after decoration was finished")}(t),assertCallable(r,"An initializer"),e.push(r)}}function assertInstanceIfPrivate(e,t){if(!e(t))throw new TypeError("Attempted to access private element on non-instance")}function memberDec(e,t,r,n,a,i,s,o,c){var u;switch(a){case 1:u="accessor";break;case 2:u="method";break;case 3:u="getter";break;case 4:u="setter";break;default:u="field"}var l,f,p={kind:u,name:s?"#"+t:toPropertyKey(t),static:i,private:s},d={v:!1};if(0!==a&&(p.addInitializer=createAddInitializerMethod(n,d)),s||0!==a&&2!==a)if(2===a)l=function(e){return assertInstanceIfPrivate(c,e),r.value};else{var h=0===a||1===a;(h||3===a)&&(l=s?function(e){return assertInstanceIfPrivate(c,e),r.get.call(e)}:function(e){return r.get.call(e)}),(h||4===a)&&(f=s?function(e,t){assertInstanceIfPrivate(c,e),r.set.call(e,t)}:function(e,t){r.set.call(e,t)})}else l=function(e){return e[t]},0===a&&(f=function(e,r){e[t]=r});var v=s?c.bind():function(e){return t in e};p.access=l&&f?{get:l,set:f,has:v}:l?{get:l,has:v}:{set:f,has:v};try{return e(o,p)}finally{d.v=!0}}function assertCallable(e,t){if("function"!=typeof e)throw new TypeError(t+" must be a function")}function assertValidReturnValue(e,t){var r=typeof t;if(1===e){if("object"!==r||null===t)throw new TypeError("accessor decorators must return an object with get, set, or init properties or void 0");void 0!==t.get&&assertCallable(t.get,"accessor.get"),void 0!==t.set&&assertCallable(t.set,"accessor.set"),void 0!==t.init&&assertCallable(t.init,"accessor.init")}else if("function"!==r)throw new TypeError((0===e?"field":10===e?"class":"method")+" decorators must return a function or void 0")}function curryThis2(e){return function(t){e(this,t)}}function applyMemberDec(e,t,r,n,a,i,s,o,c){var u,l,f,p,d,h,v,y,g=r[0];if(s?(0===a||1===a?(u={get:(d=r[3],function(){return d(this)}),set:curryThis2(r[4])},f="get"):3===a?(u={get:r[3]},f="get"):4===a?(u={set:r[3]},f="set"):u={value:r[3]},0!==a&&(1===a&&setFunctionName(u.set,"#"+n,"set"),setFunctionName(u[f||"value"],"#"+n,f))):0!==a&&(u=Object.getOwnPropertyDescriptor(t,n)),1===a?p={get:u.get,set:u.set}:2===a?p=u.value:3===a?p=u.get:4===a&&(p=u.set),"function"==typeof g)void 0!==(h=memberDec(g,n,u,o,a,i,s,p,c))&&(assertValidReturnValue(a,h),0===a?l=h:1===a?(l=h.init,v=h.get||p.get,y=h.set||p.set,p={get:v,set:y}):p=h);else for(var m=g.length-1;m>=0;m--){var b;void 0!==(h=memberDec(g[m],n,u,o,a,i,s,p,c))&&(assertValidReturnValue(a,h),0===a?b=h:1===a?(b=h.init,v=h.get||p.get,y=h.set||p.set,p={get:v,set:y}):p=h,void 0!==b&&(void 0===l?l=b:"function"==typeof l?l=[l,b]:l.push(b)))}if(0===a||1===a){if(void 0===l)l=function(e,t){return t};else if("function"!=typeof l){var I=l;l=function(e,t){for(var r=t,n=0;n<I.length;n++)r=I[n].call(e,r);return r}}else{var w=l;l=function(e,t){return w.call(e,t)}}e.push(l)}0!==a&&(1===a?(u.get=p.get,u.set=p.set):2===a?u.value=p:3===a?u.get=p:4===a&&(u.set=p),s?1===a?(e.push((function(e,t){return p.get.call(e,t)})),e.push((function(e,t){return p.set.call(e,t)}))):2===a?e.push(p):e.push((function(e,t){return p.call(e,t)})):Object.defineProperty(t,n,u))}function applyMemberDecs(e,t,r){for(var n,a,i,s=[],o=new Map,c=new Map,u=0;u<t.length;u++){var l=t[u];if(Array.isArray(l)){var f,p,d=l[1],h=l[2],v=l.length>3,y=d>=5,g=r;if(y?(f=e,0!=(d-=5)&&(p=a=a||[]),v&&!i&&(i=function(t){return checkInRHS(t)===e}),g=i):(f=e.prototype,0!==d&&(p=n=n||[])),0!==d&&!v){var m=y?c:o,b=m.get(h)||0;if(!0===b||3===b&&4!==d||4===b&&3!==d)throw Error("Attempted to decorate a public method/accessor that has the same name as a previously decorated public method/accessor. This is not currently supported by the decorators plugin. Property name was: "+h);!b&&d>2?m.set(h,d):m.set(h,!0)}applyMemberDec(s,f,l,h,d,y,v,p,g)}}return pushInitializers(s,n),pushInitializers(s,a),s}function pushInitializers(e,t){t&&e.push((function(e){for(var r=0;r<t.length;r++)t[r].call(e);return e}))}return function(e,t,r,n){return{e:applyMemberDecs(e,t,n),get c(){return function(e,t){if(t.length>0){for(var r=[],n=e,a=e.name,i=t.length-1;i>=0;i--){var s={v:!1};try{var o=t[i](n,{kind:"class",name:a,addInitializer:createAddInitializerMethod(r,s)})}finally{s.v=!0}void 0!==o&&(assertValidReturnValue(10,o),n=o)}return[n,function(){for(var e=0;e<r.length;e++)r[e].call(n)}]}}(e,r)}}}}export default function applyDecs2301(e,t,r,n){return(applyDecs2301=applyDecs2301Factory())(e,t,r,n)}'),
		    applyDecs2305: helper$3("7.21.0", 'import checkInRHS from"checkInRHS";import setFunctionName from"setFunctionName";import toPropertyKey from"toPropertyKey";export default function applyDecs2305(e,t,r,n,o,a){function i(e,t,r){return function(n,o){return r&&r(n),e[t].call(n,o)}}function c(e,t){for(var r=0;r<e.length;r++)e[r].call(t);return t}function s(e,t,r,n){if("function"!=typeof e&&(n||void 0!==e))throw new TypeError(t+" must "+(r||"be")+" a function"+(n?"":" or undefined"));return e}function applyDec(e,t,r,n,o,a,c,u,l,f,p,d,h){function m(e){if(!h(e))throw new TypeError("Attempted to access private element on non-instance")}var y,v=t[0],g=t[3],b=!u;if(!b){r||Array.isArray(v)||(v=[v]);var w={},S=[],A=3===o?"get":4===o||d?"set":"value";f?(p||d?w={get:setFunctionName((function(){return g(this)}),n,"get"),set:function(e){t[4](this,e)}}:w[A]=g,p||setFunctionName(w[A],n,2===o?"":A)):p||(w=Object.getOwnPropertyDescriptor(e,n))}for(var P=e,j=v.length-1;j>=0;j-=r?2:1){var D=v[j],E=r?v[j-1]:void 0,I={},O={kind:["field","accessor","method","getter","setter","class"][o],name:n,metadata:a,addInitializer:function(e,t){if(e.v)throw Error("attempted to call addInitializer after decoration was finished");s(t,"An initializer","be",!0),c.push(t)}.bind(null,I)};try{if(b)(y=s(D.call(E,P,O),"class decorators","return"))&&(P=y);else{var k,F;O.static=l,O.private=f,f?2===o?k=function(e){return m(e),w.value}:(o<4&&(k=i(w,"get",m)),3!==o&&(F=i(w,"set",m))):(k=function(e){return e[n]},(o<2||4===o)&&(F=function(e,t){e[n]=t}));var N=O.access={has:f?h.bind():function(e){return n in e}};if(k&&(N.get=k),F&&(N.set=F),P=D.call(E,d?{get:w.get,set:w.set}:w[A],O),d){if("object"==typeof P&&P)(y=s(P.get,"accessor.get"))&&(w.get=y),(y=s(P.set,"accessor.set"))&&(w.set=y),(y=s(P.init,"accessor.init"))&&S.push(y);else if(void 0!==P)throw new TypeError("accessor decorators must return an object with get, set, or init properties or void 0")}else s(P,(p?"field":"method")+" decorators","return")&&(p?S.push(P):w[A]=P)}}finally{I.v=!0}}return(p||d)&&u.push((function(e,t){for(var r=S.length-1;r>=0;r--)t=S[r].call(e,t);return t})),p||b||(f?d?u.push(i(w,"get"),i(w,"set")):u.push(2===o?w[A]:i.call.bind(w[A])):Object.defineProperty(e,n,w)),P}function u(e,t){return Object.defineProperty(e,Symbol.metadata||Symbol.for("Symbol.metadata"),{configurable:!0,enumerable:!0,value:t})}if(arguments.length>=6)var l=a[Symbol.metadata||Symbol.for("Symbol.metadata")];var f=Object.create(null==l?null:l),p=function(e,t,r,n){var o,a,i=[],s=function(t){return checkInRHS(t)===e},u=new Map;function l(e){e&&i.push(c.bind(null,e))}for(var f=0;f<t.length;f++){var p=t[f];if(Array.isArray(p)){var d=p[1],h=p[2],m=p.length>3,y=16&d,v=!!(8&d),g=0==(d&=7),b=h+"/"+v;if(!g&&!m){var w=u.get(b);if(!0===w||3===w&&4!==d||4===w&&3!==d)throw Error("Attempted to decorate a public method/accessor that has the same name as a previously decorated public method/accessor. This is not currently supported by the decorators plugin. Property name was: "+h);u.set(b,!(d>2)||d)}applyDec(v?e:e.prototype,p,y,m?"#"+h:toPropertyKey(h),d,n,v?a=a||[]:o=o||[],i,v,m,g,1===d,v&&m?s:r)}}return l(o),l(a),i}(e,t,o,f);return r.length||u(e,f),{e:p,get c(){var t=[];return r.length&&[u(applyDec(e,[r],n,e.name,5,f,t),f),c.bind(null,t,e)]}}}'),
		    applyDecs2311: helper$3("7.24.0", 'import checkInRHS from"checkInRHS";import setFunctionName from"setFunctionName";import toPropertyKey from"toPropertyKey";export default function applyDecs2311(e,t,n,r,o,i){var a,c,u,s,f,l,p,d=Symbol.metadata||Symbol.for("Symbol.metadata"),m=Object.defineProperty,h=Object.create,y=[h(null),h(null)],v=t.length;function g(t,n,r){return function(o,i){n&&(i=o,o=e);for(var a=0;a<t.length;a++)i=t[a].apply(o,r?[i]:[]);return r?i:o}}function b(e,t,n,r){if("function"!=typeof e&&(r||void 0!==e))throw new TypeError(t+" must "+(n||"be")+" a function"+(r?"":" or undefined"));return e}function applyDec(e,t,n,r,o,i,u,s,f,l,p){function d(e){if(!p(e))throw new TypeError("Attempted to access private element on non-instance")}var h=[].concat(t[0]),v=t[3],w=!u,D=1===o,S=3===o,j=4===o,E=2===o;function I(t,n,r){return function(o,i){return n&&(i=o,o=e),r&&r(o),P[t].call(o,i)}}if(!w){var P={},k=[],F=S?"get":j||D?"set":"value";if(f?(l||D?P={get:setFunctionName((function(){return v(this)}),r,"get"),set:function(e){t[4](this,e)}}:P[F]=v,l||setFunctionName(P[F],r,E?"":F)):l||(P=Object.getOwnPropertyDescriptor(e,r)),!l&&!f){if((c=y[+s][r])&&7!=(c^o))throw Error("Decorating two elements with the same name ("+P[F].name+") is not supported yet");y[+s][r]=o<3?1:o}}for(var N=e,O=h.length-1;O>=0;O-=n?2:1){var z=b(h[O],"A decorator","be",!0),A=n?h[O-1]:void 0,H={},K={kind:["field","accessor","method","getter","setter","class"][o],name:r,metadata:a,addInitializer:function(e,t){if(e.v)throw Error("attempted to call addInitializer after decoration was finished");b(t,"An initializer","be",!0),i.push(t)}.bind(null,H)};if(w)c=z.call(A,N,K),H.v=1,b(c,"class decorators","return")&&(N=c);else if(K.static=s,K.private=f,c=K.access={has:f?p.bind():function(e){return r in e}},j||(c.get=f?E?function(e){return d(e),P.value}:I("get",0,d):function(e){return e[r]}),E||S||(c.set=f?I("set",0,d):function(e,t){e[r]=t}),N=z.call(A,D?{get:P.get,set:P.set}:P[F],K),H.v=1,D){if("object"==typeof N&&N)(c=b(N.get,"accessor.get"))&&(P.get=c),(c=b(N.set,"accessor.set"))&&(P.set=c),(c=b(N.init,"accessor.init"))&&k.unshift(c);else if(void 0!==N)throw new TypeError("accessor decorators must return an object with get, set, or init properties or undefined")}else b(N,(l?"field":"method")+" decorators","return")&&(l?k.unshift(N):P[F]=N)}return o<2&&u.push(g(k,s,1),g(i,s,0)),l||w||(f?D?u.splice(-1,0,I("get",s),I("set",s)):u.push(E?P[F]:b.call.bind(P[F])):m(e,r,P)),N}function w(e){return m(e,d,{configurable:!0,enumerable:!0,value:a})}return void 0!==i&&(a=i[d]),a=h(null==a?null:a),f=[],l=function(e){e&&f.push(g(e))},p=function(t,r){for(var i=0;i<n.length;i++){var a=n[i],c=a[1],l=7&c;if((8&c)==t&&!l==r){var p=a[2],d=!!a[3],m=16&c;applyDec(t?e:e.prototype,a,m,d?"#"+p:toPropertyKey(p),l,l<2?[]:t?s=s||[]:u=u||[],f,!!t,d,r,t&&d?function(t){return checkInRHS(t)===e}:o)}}},p(8,0),p(0,0),p(8,1),p(0,1),l(u),l(s),c=f,v||w(e),{e:c,get c(){var n=[];return v&&[w(e=applyDec(e,[t],r,e.name,5,n)),g(n,1)]}}}'),
		    assertClassBrand: helper$3("7.24.0", 'export default function _assertClassBrand(e,t,n){if("function"==typeof e?e===t:e.has(t))return arguments.length<3?t:n;throw new TypeError("Private element is not present on this object")}'),
		    asyncGeneratorDelegate: helper$3("7.0.0-beta.0", 'import OverloadYield from"OverloadYield";export default function _asyncGeneratorDelegate(t){var e={},n=!1;function pump(e,r){return n=!0,r=new Promise((function(n){n(t[e](r))})),{done:!1,value:new OverloadYield(r,1)}}return e["undefined"!=typeof Symbol&&Symbol.iterator||"@@iterator"]=function(){return this},e.next=function(t){return n?(n=!1,t):pump("next",t)},"function"==typeof t.throw&&(e.throw=function(t){if(n)throw n=!1,t;return pump("throw",t)}),"function"==typeof t.return&&(e.return=function(t){return n?(n=!1,t):pump("return",t)}),e}'),
		    asyncIterator: helper$3("7.15.9", 'export default function _asyncIterator(r){var n,t,o,e=2;for("undefined"!=typeof Symbol&&(t=Symbol.asyncIterator,o=Symbol.iterator);e--;){if(t&&null!=(n=r[t]))return n.call(r);if(o&&null!=(n=r[o]))return new AsyncFromSyncIterator(n.call(r));t="@@asyncIterator",o="@@iterator"}throw new TypeError("Object is not async iterable")}function AsyncFromSyncIterator(r){function AsyncFromSyncIteratorContinuation(r){if(Object(r)!==r)return Promise.reject(new TypeError(r+" is not an object."));var n=r.done;return Promise.resolve(r.value).then((function(r){return{value:r,done:n}}))}return AsyncFromSyncIterator=function(r){this.s=r,this.n=r.next},AsyncFromSyncIterator.prototype={s:null,n:null,next:function(){return AsyncFromSyncIteratorContinuation(this.n.apply(this.s,arguments))},return:function(r){var n=this.s.return;return void 0===n?Promise.resolve({value:r,done:!0}):AsyncFromSyncIteratorContinuation(n.apply(this.s,arguments))},throw:function(r){var n=this.s.return;return void 0===n?Promise.reject(r):AsyncFromSyncIteratorContinuation(n.apply(this.s,arguments))}},new AsyncFromSyncIterator(r)}'),
		    awaitAsyncGenerator: helper$3("7.0.0-beta.0", 'import OverloadYield from"OverloadYield";export default function _awaitAsyncGenerator(e){return new OverloadYield(e,0)}'),
		    callSuper: helper$3("7.23.8", 'import getPrototypeOf from"getPrototypeOf";import isNativeReflectConstruct from"isNativeReflectConstruct";import possibleConstructorReturn from"possibleConstructorReturn";export default function _callSuper(t,o,e){return o=getPrototypeOf(o),possibleConstructorReturn(t,isNativeReflectConstruct()?Reflect.construct(o,e||[],getPrototypeOf(t).constructor):o.apply(t,e))}'),
		    checkInRHS: helper$3("7.20.5", 'export default function _checkInRHS(e){if(Object(e)!==e)throw TypeError("right-hand side of \'in\' should be an object, got "+(null!==e?typeof e:"null"));return e}'),
		    classPrivateFieldGet2: helper$3("7.24.0", 'import assertClassBrand from"assertClassBrand";export default function _classPrivateFieldGet2(s,a){return s.get(assertClassBrand(s,a))}'),
		    classPrivateFieldSet2: helper$3("7.24.0", 'import assertClassBrand from"assertClassBrand";export default function _classPrivateFieldSet2(s,a,r){return s.set(assertClassBrand(s,a),r),r}'),
		    classPrivateGetter: helper$3("7.24.0", 'import assertClassBrand from"assertClassBrand";export default function _classPrivateGetter(s,r,a){return a(assertClassBrand(s,r))}'),
		    classPrivateSetter: helper$3("7.24.0", 'import assertClassBrand from"assertClassBrand";export default function _classPrivateSetter(s,r,a,t){return r(assertClassBrand(s,a),t),t}'),
		    construct: helper$3("7.0.0-beta.0", 'import setPrototypeOf from"setPrototypeOf";import isNativeReflectConstruct from"isNativeReflectConstruct";export default function _construct(t,e,r){if(isNativeReflectConstruct())return Reflect.construct.apply(null,arguments);var o=[null];o.push.apply(o,e);var p=new(t.bind.apply(t,o));return r&&setPrototypeOf(p,r.prototype),p}'),
		    defineAccessor: helper$3("7.20.7", "export default function _defineAccessor(e,r,n,t){var c={configurable:!0,enumerable:!0};return c[e]=t,Object.defineProperty(r,n,c)}"),
		    dispose: helper$3("7.22.0", 'function dispose_SuppressedError(r,e){return"undefined"!=typeof SuppressedError?dispose_SuppressedError=SuppressedError:(dispose_SuppressedError=function(r,e){this.suppressed=e,this.error=r,this.stack=Error().stack},dispose_SuppressedError.prototype=Object.create(Error.prototype,{constructor:{value:dispose_SuppressedError,writable:!0,configurable:!0}})),new dispose_SuppressedError(r,e)}export default function _dispose(r,e,s){function next(){for(;r.length>0;)try{var o=r.pop(),p=o.d.call(o.v);if(o.a)return Promise.resolve(p).then(next,err)}catch(r){return err(r)}if(s)throw e}function err(r){return e=s?new dispose_SuppressedError(e,r):r,s=!0,next()}return next()}'),
		    importDeferProxy: helper$3("7.23.0", "export default function _importDeferProxy(e){var t=null,constValue=function(e){return function(){return e}},proxy=function(r){return function(n,o,f){return null===t&&(t=e()),r(t,o,f)}};return new Proxy({},{defineProperty:constValue(!1),deleteProperty:constValue(!1),get:proxy(Reflect.get),getOwnPropertyDescriptor:proxy(Reflect.getOwnPropertyDescriptor),getPrototypeOf:constValue(null),isExtensible:constValue(!1),has:proxy(Reflect.has),ownKeys:proxy(Reflect.ownKeys),preventExtensions:constValue(!0),set:constValue(!1),setPrototypeOf:constValue(!1)})}"),
		    interopRequireWildcard: helper$3("7.14.0", 'function _getRequireWildcardCache(e){if("function"!=typeof WeakMap)return null;var r=new WeakMap,t=new WeakMap;return(_getRequireWildcardCache=function(e){return e?t:r})(e)}export default function _interopRequireWildcard(e,r){if(!r&&e&&e.__esModule)return e;if(null===e||"object"!=typeof e&&"function"!=typeof e)return{default:e};var t=_getRequireWildcardCache(r);if(t&&t.has(e))return t.get(e);var n={__proto__:null},a=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var u in e)if("default"!==u&&{}.hasOwnProperty.call(e,u)){var i=a?Object.getOwnPropertyDescriptor(e,u):null;i&&(i.get||i.set)?Object.defineProperty(n,u,i):n[u]=e[u]}return n.default=e,t&&t.set(e,n),n}'),
		    isNativeReflectConstruct: helper$3("7.9.0", "export default function _isNativeReflectConstruct(){try{var t=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(t){}return(_isNativeReflectConstruct=function(){return!!t})()}"),
		    iterableToArrayLimit: helper$3("7.0.0-beta.0", 'export default function _iterableToArrayLimit(r,l){var t=null==r?null:"undefined"!=typeof Symbol&&r[Symbol.iterator]||r["@@iterator"];if(null!=t){var e,n,i,u,a=[],f=!0,o=!1;try{if(i=(t=t.call(r)).next,0===l){if(Object(t)!==t)return;f=!1}else for(;!(f=(e=i.call(t)).done)&&(a.push(e.value),a.length!==l);f=!0);}catch(r){o=!0,n=r}finally{try{if(!f&&null!=t.return&&(u=t.return(),Object(u)!==u))return}finally{if(o)throw n}}return a}}'),
		    iterableToArrayLimitLoose: helper$3("7.0.0-beta.0", 'export default function _iterableToArrayLimitLoose(e,r){var t=e&&("undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"]);if(null!=t){var o,l=[];for(t=t.call(e);e.length<r&&!(o=t.next()).done;)l.push(o.value);return l}}'),
		    jsx: helper$3("7.0.0-beta.0", 'var REACT_ELEMENT_TYPE;export default function _createRawReactElement(e,r,E,l){REACT_ELEMENT_TYPE||(REACT_ELEMENT_TYPE="function"==typeof Symbol&&Symbol.for&&Symbol.for("react.element")||60103);var o=e&&e.defaultProps,n=arguments.length-3;if(r||0===n||(r={children:void 0}),1===n)r.children=l;else if(n>1){for(var t=Array(n),f=0;f<n;f++)t[f]=arguments[f+3];r.children=t}if(r&&o)for(var i in o)void 0===r[i]&&(r[i]=o[i]);else r||(r=o||{});return{$$typeof:REACT_ELEMENT_TYPE,type:e,key:void 0===E?null:""+E,ref:null,props:r,_owner:null}}'),
		    objectSpread2: helper$3("7.5.0", 'import defineProperty from"defineProperty";function ownKeys(e,r){var t=Object.keys(e);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);r&&(o=o.filter((function(r){return Object.getOwnPropertyDescriptor(e,r).enumerable}))),t.push.apply(t,o)}return t}export default function _objectSpread2(e){for(var r=1;r<arguments.length;r++){var t=null!=arguments[r]?arguments[r]:{};r%2?ownKeys(Object(t),!0).forEach((function(r){defineProperty(e,r,t[r])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):ownKeys(Object(t)).forEach((function(r){Object.defineProperty(e,r,Object.getOwnPropertyDescriptor(t,r))}))}return e}'),
		    regeneratorRuntime: helper$3("7.18.0", 'export default function _regeneratorRuntime(){"use strict";\n/*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */_regeneratorRuntime=function(){return e};var t,e={},r=Object.prototype,n=r.hasOwnProperty,o=Object.defineProperty||function(t,e,r){t[e]=r.value},i="function"==typeof Symbol?Symbol:{},a=i.iterator||"@@iterator",c=i.asyncIterator||"@@asyncIterator",u=i.toStringTag||"@@toStringTag";function define(t,e,r){return Object.defineProperty(t,e,{value:r,enumerable:!0,configurable:!0,writable:!0}),t[e]}try{define({},"")}catch(t){define=function(t,e,r){return t[e]=r}}function wrap(t,e,r,n){var i=e&&e.prototype instanceof Generator?e:Generator,a=Object.create(i.prototype),c=new Context(n||[]);return o(a,"_invoke",{value:makeInvokeMethod(t,r,c)}),a}function tryCatch(t,e,r){try{return{type:"normal",arg:t.call(e,r)}}catch(t){return{type:"throw",arg:t}}}e.wrap=wrap;var h="suspendedStart",l="suspendedYield",f="executing",s="completed",y={};function Generator(){}function GeneratorFunction(){}function GeneratorFunctionPrototype(){}var p={};define(p,a,(function(){return this}));var d=Object.getPrototypeOf,v=d&&d(d(values([])));v&&v!==r&&n.call(v,a)&&(p=v);var g=GeneratorFunctionPrototype.prototype=Generator.prototype=Object.create(p);function defineIteratorMethods(t){["next","throw","return"].forEach((function(e){define(t,e,(function(t){return this._invoke(e,t)}))}))}function AsyncIterator(t,e){function invoke(r,o,i,a){var c=tryCatch(t[r],t,o);if("throw"!==c.type){var u=c.arg,h=u.value;return h&&"object"==typeof h&&n.call(h,"__await")?e.resolve(h.__await).then((function(t){invoke("next",t,i,a)}),(function(t){invoke("throw",t,i,a)})):e.resolve(h).then((function(t){u.value=t,i(u)}),(function(t){return invoke("throw",t,i,a)}))}a(c.arg)}var r;o(this,"_invoke",{value:function(t,n){function callInvokeWithMethodAndArg(){return new e((function(e,r){invoke(t,n,e,r)}))}return r=r?r.then(callInvokeWithMethodAndArg,callInvokeWithMethodAndArg):callInvokeWithMethodAndArg()}})}function makeInvokeMethod(e,r,n){var o=h;return function(i,a){if(o===f)throw Error("Generator is already running");if(o===s){if("throw"===i)throw a;return{value:t,done:!0}}for(n.method=i,n.arg=a;;){var c=n.delegate;if(c){var u=maybeInvokeDelegate(c,n);if(u){if(u===y)continue;return u}}if("next"===n.method)n.sent=n._sent=n.arg;else if("throw"===n.method){if(o===h)throw o=s,n.arg;n.dispatchException(n.arg)}else"return"===n.method&&n.abrupt("return",n.arg);o=f;var p=tryCatch(e,r,n);if("normal"===p.type){if(o=n.done?s:l,p.arg===y)continue;return{value:p.arg,done:n.done}}"throw"===p.type&&(o=s,n.method="throw",n.arg=p.arg)}}}function maybeInvokeDelegate(e,r){var n=r.method,o=e.iterator[n];if(o===t)return r.delegate=null,"throw"===n&&e.iterator.return&&(r.method="return",r.arg=t,maybeInvokeDelegate(e,r),"throw"===r.method)||"return"!==n&&(r.method="throw",r.arg=new TypeError("The iterator does not provide a \'"+n+"\' method")),y;var i=tryCatch(o,e.iterator,r.arg);if("throw"===i.type)return r.method="throw",r.arg=i.arg,r.delegate=null,y;var a=i.arg;return a?a.done?(r[e.resultName]=a.value,r.next=e.nextLoc,"return"!==r.method&&(r.method="next",r.arg=t),r.delegate=null,y):a:(r.method="throw",r.arg=new TypeError("iterator result is not an object"),r.delegate=null,y)}function pushTryEntry(t){var e={tryLoc:t[0]};1 in t&&(e.catchLoc=t[1]),2 in t&&(e.finallyLoc=t[2],e.afterLoc=t[3]),this.tryEntries.push(e)}function resetTryEntry(t){var e=t.completion||{};e.type="normal",delete e.arg,t.completion=e}function Context(t){this.tryEntries=[{tryLoc:"root"}],t.forEach(pushTryEntry,this),this.reset(!0)}function values(e){if(e||""===e){var r=e[a];if(r)return r.call(e);if("function"==typeof e.next)return e;if(!isNaN(e.length)){var o=-1,i=function next(){for(;++o<e.length;)if(n.call(e,o))return next.value=e[o],next.done=!1,next;return next.value=t,next.done=!0,next};return i.next=i}}throw new TypeError(typeof e+" is not iterable")}return GeneratorFunction.prototype=GeneratorFunctionPrototype,o(g,"constructor",{value:GeneratorFunctionPrototype,configurable:!0}),o(GeneratorFunctionPrototype,"constructor",{value:GeneratorFunction,configurable:!0}),GeneratorFunction.displayName=define(GeneratorFunctionPrototype,u,"GeneratorFunction"),e.isGeneratorFunction=function(t){var e="function"==typeof t&&t.constructor;return!!e&&(e===GeneratorFunction||"GeneratorFunction"===(e.displayName||e.name))},e.mark=function(t){return Object.setPrototypeOf?Object.setPrototypeOf(t,GeneratorFunctionPrototype):(t.__proto__=GeneratorFunctionPrototype,define(t,u,"GeneratorFunction")),t.prototype=Object.create(g),t},e.awrap=function(t){return{__await:t}},defineIteratorMethods(AsyncIterator.prototype),define(AsyncIterator.prototype,c,(function(){return this})),e.AsyncIterator=AsyncIterator,e.async=function(t,r,n,o,i){void 0===i&&(i=Promise);var a=new AsyncIterator(wrap(t,r,n,o),i);return e.isGeneratorFunction(r)?a:a.next().then((function(t){return t.done?t.value:a.next()}))},defineIteratorMethods(g),define(g,u,"Generator"),define(g,a,(function(){return this})),define(g,"toString",(function(){return"[object Generator]"})),e.keys=function(t){var e=Object(t),r=[];for(var n in e)r.push(n);return r.reverse(),function next(){for(;r.length;){var t=r.pop();if(t in e)return next.value=t,next.done=!1,next}return next.done=!0,next}},e.values=values,Context.prototype={constructor:Context,reset:function(e){if(this.prev=0,this.next=0,this.sent=this._sent=t,this.done=!1,this.delegate=null,this.method="next",this.arg=t,this.tryEntries.forEach(resetTryEntry),!e)for(var r in this)"t"===r.charAt(0)&&n.call(this,r)&&!isNaN(+r.slice(1))&&(this[r]=t)},stop:function(){this.done=!0;var t=this.tryEntries[0].completion;if("throw"===t.type)throw t.arg;return this.rval},dispatchException:function(e){if(this.done)throw e;var r=this;function handle(n,o){return a.type="throw",a.arg=e,r.next=n,o&&(r.method="next",r.arg=t),!!o}for(var o=this.tryEntries.length-1;o>=0;--o){var i=this.tryEntries[o],a=i.completion;if("root"===i.tryLoc)return handle("end");if(i.tryLoc<=this.prev){var c=n.call(i,"catchLoc"),u=n.call(i,"finallyLoc");if(c&&u){if(this.prev<i.catchLoc)return handle(i.catchLoc,!0);if(this.prev<i.finallyLoc)return handle(i.finallyLoc)}else if(c){if(this.prev<i.catchLoc)return handle(i.catchLoc,!0)}else{if(!u)throw Error("try statement without catch or finally");if(this.prev<i.finallyLoc)return handle(i.finallyLoc)}}}},abrupt:function(t,e){for(var r=this.tryEntries.length-1;r>=0;--r){var o=this.tryEntries[r];if(o.tryLoc<=this.prev&&n.call(o,"finallyLoc")&&this.prev<o.finallyLoc){var i=o;break}}i&&("break"===t||"continue"===t)&&i.tryLoc<=e&&e<=i.finallyLoc&&(i=null);var a=i?i.completion:{};return a.type=t,a.arg=e,i?(this.method="next",this.next=i.finallyLoc,y):this.complete(a)},complete:function(t,e){if("throw"===t.type)throw t.arg;return"break"===t.type||"continue"===t.type?this.next=t.arg:"return"===t.type?(this.rval=this.arg=t.arg,this.method="return",this.next="end"):"normal"===t.type&&e&&(this.next=e),y},finish:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var r=this.tryEntries[e];if(r.finallyLoc===t)return this.complete(r.completion,r.afterLoc),resetTryEntry(r),y}},catch:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var r=this.tryEntries[e];if(r.tryLoc===t){var n=r.completion;if("throw"===n.type){var o=n.arg;resetTryEntry(r)}return o}}throw Error("illegal catch attempt")},delegateYield:function(e,r,n){return this.delegate={iterator:values(e),resultName:r,nextLoc:n},"next"===this.method&&(this.arg=t),y}},e}'),
		    setFunctionName: helper$3("7.23.6", 'export default function setFunctionName(e,t,n){"symbol"==typeof t&&(t=(t=t.description)?"["+t+"]":"");try{Object.defineProperty(e,"name",{configurable:!0,value:n?n+" "+t:t})}catch(e){}return e}'),
		    toPrimitive: helper$3("7.1.5", 'export default function toPrimitive(t,r){if("object"!=typeof t||!t)return t;var e=t[Symbol.toPrimitive];if(void 0!==e){var i=e.call(t,r||"default");if("object"!=typeof i)return i;throw new TypeError("@@toPrimitive must return a primitive value.")}return("string"===r?String:Number)(t)}'),
		    toPropertyKey: helper$3("7.1.5", 'import toPrimitive from"toPrimitive";export default function toPropertyKey(t){var i=toPrimitive(t,"string");return"symbol"==typeof i?i:i+""}'),
		    toSetter: helper$3("7.24.0", 'export default function _toSetter(t,e,n){e||(e=[]);var r=e.length++;return Object.defineProperty({},"_",{set:function(o){e[r]=o,t.apply(n,e)}})}'),
		    "typeof": helper$3("7.0.0-beta.0", 'export default function _typeof(o){"@babel/helpers - typeof";return _typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(o){return typeof o}:function(o){return o&&"function"==typeof Symbol&&o.constructor===Symbol&&o!==Symbol.prototype?"symbol":typeof o},_typeof(o)}'),
		    using: helper$3("7.22.0", 'export default function _using(o,n,e){if(null==n)return n;if(Object(n)!==n)throw new TypeError("using declarations can only be used with objects, functions, null, or undefined.");if(e)var r=n[Symbol.asyncDispose||Symbol.for("Symbol.asyncDispose")];if(null==r&&(r=n[Symbol.dispose||Symbol.for("Symbol.dispose")]),"function"!=typeof r)throw new TypeError("Property [Symbol.dispose] is not a function.");return o.push({v:n,d:r,a:e}),n}'),
		    usingCtx: helper$3("7.23.9", 'export default function _usingCtx(){var r="function"==typeof SuppressedError?SuppressedError:function(r,n){var e=Error();return e.name="SuppressedError",e.error=r,e.suppressed=n,e},n={},e=[];function using(r,n){if(null!=n){if(Object(n)!==n)throw new TypeError("using declarations can only be used with objects, functions, null, or undefined.");if(r)var o=n[Symbol.asyncDispose||Symbol.for("Symbol.asyncDispose")];if(null==o&&(o=n[Symbol.dispose||Symbol.for("Symbol.dispose")]),"function"!=typeof o)throw new TypeError("Property [Symbol.dispose] is not a function.");e.push({v:n,d:o,a:r})}else r&&e.push({d:n,a:r});return n}return{e:n,u:using.bind(null,!1),a:using.bind(null,!0),d:function(){var o=this.e;function next(){for(;r=e.pop();)try{var r,t=r.d&&r.d.call(r.v);if(r.a)return Promise.resolve(t).then(next,err)}catch(r){return err(r)}if(o!==n)throw o}function err(e){return o=o!==n?new r(e,o):e,next()}return next()}}}'),
		    wrapRegExp: helper$3("7.19.0", 'import setPrototypeOf from"setPrototypeOf";import inherits from"inherits";export default function _wrapRegExp(){_wrapRegExp=function(e,r){return new BabelRegExp(e,void 0,r)};var e=RegExp.prototype,r=new WeakMap;function BabelRegExp(e,t,p){var o=RegExp(e,t);return r.set(o,p||r.get(e)),setPrototypeOf(o,BabelRegExp.prototype)}function buildGroups(e,t){var p=r.get(t);return Object.keys(p).reduce((function(r,t){var o=p[t];if("number"==typeof o)r[t]=e[o];else{for(var i=0;void 0===e[o[i]]&&i+1<o.length;)i++;r[t]=e[o[i]]}return r}),Object.create(null))}return inherits(BabelRegExp,RegExp),BabelRegExp.prototype.exec=function(r){var t=e.exec.call(this,r);if(t){t.groups=buildGroups(t,this);var p=t.indices;p&&(p.groups=buildGroups(p,this))}return t},BabelRegExp.prototype[Symbol.replace]=function(t,p){if("string"==typeof p){var o=r.get(this);return e[Symbol.replace].call(this,t,p.replace(/\\$<([^>]+)>/g,(function(e,r){var t=o[r];return"$"+(Array.isArray(t)?t.join("$"):t)})))}if("function"==typeof p){var i=this;return e[Symbol.replace].call(this,t,(function(){var e=arguments;return"object"!=typeof e[e.length-1]&&(e=[].slice.call(e)).push(buildGroups(e,i)),p.apply(this,e)}))}return e[Symbol.replace].call(this,t,p)},_wrapRegExp.apply(this,arguments)}')
		  });

		  var _templateObject$B, _templateObject2$k, _templateObject3$e, _templateObject4$a, _templateObject5$6, _templateObject6$4, _templateObject7$3, _templateObject8$3, _templateObject9$3, _templateObject10$3, _templateObject11$3, _templateObject12$3, _templateObject13$3, _templateObject14$3, _templateObject15$2, _templateObject16$2, _templateObject17$2, _templateObject18$2, _templateObject19$1, _templateObject20$1, _templateObject21$1, _templateObject22$1, _templateObject23, _templateObject24, _templateObject25, _templateObject26, _templateObject27, _templateObject28, _templateObject29, _templateObject30, _templateObject31, _templateObject32, _templateObject33, _templateObject34, _templateObject35, _templateObject36, _templateObject37, _templateObject38, _templateObject39, _templateObject40, _templateObject41, _templateObject42, _templateObject43, _templateObject44, _templateObject45, _templateObject46, _templateObject47, _templateObject48, _templateObject49, _templateObject50, _templateObject51, _templateObject52, _templateObject53, _templateObject54, _templateObject55, _templateObject56, _templateObject57, _templateObject58, _templateObject59, _templateObject60, _templateObject61, _templateObject62, _templateObject63, _templateObject64, _templateObject65, _templateObject66, _templateObject67, _templateObject68, _templateObject69, _templateObject70, _templateObject71, _templateObject72, _templateObject73, _templateObject74, _templateObject75, _templateObject76, _templateObject77, _templateObject78;
		  var helpers$3 = Object.assign({
		    __proto__: null
		  }, generated);
		  var helper$2 = function helper(minVersion) {
		    return function (tpl) {
		      return {
		        minVersion: minVersion,
		        ast: function ast() {
		          return template$1.program.ast(tpl);
		        }
		      };
		    };
		  };
		  {
		    helpers$3.AwaitValue = helper$2("7.0.0-beta.0")(_templateObject$B || (_templateObject$B = _taggedTemplateLiteralLoose(["\n    export default function _AwaitValue(value) {\n      this.wrapped = value;\n    }\n  "])));
		  }
		  helpers$3.wrapAsyncGenerator = helper$2("7.0.0-beta.0")(_templateObject2$k || (_templateObject2$k = _taggedTemplateLiteralLoose(["\n  import AsyncGenerator from \"AsyncGenerator\";\n\n  export default function _wrapAsyncGenerator(fn) {\n    return function () {\n      return new AsyncGenerator(fn.apply(this, arguments));\n    };\n  }\n"])));
		  helpers$3.asyncToGenerator = helper$2("7.0.0-beta.0")(_templateObject3$e || (_templateObject3$e = _taggedTemplateLiteralLoose(["\n  function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {\n    try {\n      var info = gen[key](arg);\n      var value = info.value;\n    } catch (error) {\n      reject(error);\n      return;\n    }\n\n    if (info.done) {\n      resolve(value);\n    } else {\n      Promise.resolve(value).then(_next, _throw);\n    }\n  }\n\n  export default function _asyncToGenerator(fn) {\n    return function () {\n      var self = this, args = arguments;\n      return new Promise(function (resolve, reject) {\n        var gen = fn.apply(self, args);\n        function _next(value) {\n          asyncGeneratorStep(gen, resolve, reject, _next, _throw, \"next\", value);\n        }\n        function _throw(err) {\n          asyncGeneratorStep(gen, resolve, reject, _next, _throw, \"throw\", err);\n        }\n\n        _next(undefined);\n      });\n    };\n  }\n"])));
		  helpers$3.classCallCheck = helper$2("7.0.0-beta.0")(_templateObject4$a || (_templateObject4$a = _taggedTemplateLiteralLoose(["\n  export default function _classCallCheck(instance, Constructor) {\n    if (!(instance instanceof Constructor)) {\n      throw new TypeError(\"Cannot call a class as a function\");\n    }\n  }\n"])));
		  helpers$3.createClass = helper$2("7.0.0-beta.0")(_templateObject5$6 || (_templateObject5$6 = _taggedTemplateLiteralLoose(["\n  import toPropertyKey from \"toPropertyKey\";\n  function _defineProperties(target, props) {\n    for (var i = 0; i < props.length; i ++) {\n      var descriptor = props[i];\n      descriptor.enumerable = descriptor.enumerable || false;\n      descriptor.configurable = true;\n      if (\"value\" in descriptor) descriptor.writable = true;\n      Object.defineProperty(target, toPropertyKey(descriptor.key), descriptor);\n    }\n  }\n\n  export default function _createClass(Constructor, protoProps, staticProps) {\n    if (protoProps) _defineProperties(Constructor.prototype, protoProps);\n    if (staticProps) _defineProperties(Constructor, staticProps);\n    Object.defineProperty(Constructor, \"prototype\", { writable: false });\n    return Constructor;\n  }\n"])));
		  {
		    helpers$3.defineEnumerableProperties = helper$2("7.0.0-beta.0")(_templateObject6$4 || (_templateObject6$4 = _taggedTemplateLiteralLoose(["\n    export default function _defineEnumerableProperties(obj, descs) {\n      for (var key in descs) {\n        var desc = descs[key];\n        desc.configurable = desc.enumerable = true;\n        if (\"value\" in desc) desc.writable = true;\n        Object.defineProperty(obj, key, desc);\n      }\n\n      // Symbols are not enumerated over by for-in loops. If native\n      // Symbols are available, fetch all of the descs object's own\n      // symbol properties and define them on our target object too.\n      if (Object.getOwnPropertySymbols) {\n        var objectSymbols = Object.getOwnPropertySymbols(descs);\n        for (var i = 0; i < objectSymbols.length; i++) {\n          var sym = objectSymbols[i];\n          var desc = descs[sym];\n          desc.configurable = desc.enumerable = true;\n          if (\"value\" in desc) desc.writable = true;\n          Object.defineProperty(obj, sym, desc);\n        }\n      }\n      return obj;\n    }\n"])));
		  }
		  helpers$3.defaults = helper$2("7.0.0-beta.0")(_templateObject7$3 || (_templateObject7$3 = _taggedTemplateLiteralLoose(["\n  export default function _defaults(obj, defaults) {\n    var keys = Object.getOwnPropertyNames(defaults);\n    for (var i = 0; i < keys.length; i++) {\n      var key = keys[i];\n      var value = Object.getOwnPropertyDescriptor(defaults, key);\n      if (value && value.configurable && obj[key] === undefined) {\n        Object.defineProperty(obj, key, value);\n      }\n    }\n    return obj;\n  }\n"])));
		  helpers$3.defineProperty = helper$2("7.0.0-beta.0")(_templateObject8$3 || (_templateObject8$3 = _taggedTemplateLiteralLoose(["\n  import toPropertyKey from \"toPropertyKey\";\n  export default function _defineProperty(obj, key, value) {\n    key = toPropertyKey(key);\n    // Shortcircuit the slow defineProperty path when possible.\n    // We are trying to avoid issues where setters defined on the\n    // prototype cause side effects under the fast path of simple\n    // assignment. By checking for existence of the property with\n    // the in operator, we can optimize most of this overhead away.\n    if (key in obj) {\n      Object.defineProperty(obj, key, {\n        value: value,\n        enumerable: true,\n        configurable: true,\n        writable: true\n      });\n    } else {\n      obj[key] = value;\n    }\n    return obj;\n  }\n"])));
		  helpers$3["extends"] = helper$2("7.0.0-beta.0")(_templateObject9$3 || (_templateObject9$3 = _taggedTemplateLiteralLoose(["\n  export default function _extends() {\n    _extends = Object.assign ? Object.assign.bind() : function (target) {\n      for (var i = 1; i < arguments.length; i++) {\n        var source = arguments[i];\n        for (var key in source) {\n          if (Object.prototype.hasOwnProperty.call(source, key)) {\n            target[key] = source[key];\n          }\n        }\n      }\n      return target;\n    };\n\n    return _extends.apply(this, arguments);\n  }\n"])));
		  {
		    helpers$3.objectSpread = helper$2("7.0.0-beta.0")(_templateObject10$3 || (_templateObject10$3 = _taggedTemplateLiteralLoose(["\n    import defineProperty from \"defineProperty\";\n\n    export default function _objectSpread(target) {\n      for (var i = 1; i < arguments.length; i++) {\n        var source = (arguments[i] != null) ? Object(arguments[i]) : {};\n        var ownKeys = Object.keys(source);\n        if (typeof Object.getOwnPropertySymbols === 'function') {\n          ownKeys.push.apply(ownKeys, Object.getOwnPropertySymbols(source).filter(function(sym) {\n            return Object.getOwnPropertyDescriptor(source, sym).enumerable;\n          }));\n        }\n        ownKeys.forEach(function(key) {\n          defineProperty(target, key, source[key]);\n        });\n      }\n      return target;\n    }\n  "])));
		  }
		  helpers$3.inherits = helper$2("7.0.0-beta.0")(_templateObject11$3 || (_templateObject11$3 = _taggedTemplateLiteralLoose(["\n  import setPrototypeOf from \"setPrototypeOf\";\n\n  export default function _inherits(subClass, superClass) {\n    if (typeof superClass !== \"function\" && superClass !== null) {\n      throw new TypeError(\"Super expression must either be null or a function\");\n    }\n    // We can't use defineProperty to set the prototype in a single step because it\n    // doesn't work in Chrome <= 36. https://github.com/babel/babel/issues/14056\n    // V8 bug: https://bugs.chromium.org/p/v8/issues/detail?id=3334\n    subClass.prototype = Object.create(superClass && superClass.prototype, {\n      constructor: {\n        value: subClass,\n        writable: true,\n        configurable: true\n      }\n    });\n    Object.defineProperty(subClass, \"prototype\", { writable: false });\n    if (superClass) setPrototypeOf(subClass, superClass);\n  }\n"])));
		  helpers$3.inheritsLoose = helper$2("7.0.0-beta.0")(_templateObject12$3 || (_templateObject12$3 = _taggedTemplateLiteralLoose(["\n  import setPrototypeOf from \"setPrototypeOf\";\n\n  export default function _inheritsLoose(subClass, superClass) {\n    subClass.prototype = Object.create(superClass.prototype);\n    subClass.prototype.constructor = subClass;\n    setPrototypeOf(subClass, superClass);\n  }\n"])));
		  helpers$3.getPrototypeOf = helper$2("7.0.0-beta.0")(_templateObject13$3 || (_templateObject13$3 = _taggedTemplateLiteralLoose(["\n  export default function _getPrototypeOf(o) {\n    _getPrototypeOf = Object.setPrototypeOf\n      ? Object.getPrototypeOf.bind()\n      : function _getPrototypeOf(o) {\n          return o.__proto__ || Object.getPrototypeOf(o);\n        };\n    return _getPrototypeOf(o);\n  }\n"])));
		  helpers$3.setPrototypeOf = helper$2("7.0.0-beta.0")(_templateObject14$3 || (_templateObject14$3 = _taggedTemplateLiteralLoose(["\n  export default function _setPrototypeOf(o, p) {\n    _setPrototypeOf = Object.setPrototypeOf\n      ? Object.setPrototypeOf.bind()\n      : function _setPrototypeOf(o, p) {\n          o.__proto__ = p;\n          return o;\n        };\n    return _setPrototypeOf(o, p);\n  }\n"])));
		  helpers$3.isNativeFunction = helper$2("7.0.0-beta.0")(_templateObject15$2 || (_templateObject15$2 = _taggedTemplateLiteralLoose(["\n  export default function _isNativeFunction(fn) {\n    // Note: This function returns \"true\" for core-js functions.\n    try {\n      return Function.toString.call(fn).indexOf(\"[native code]\") !== -1;\n    } catch (e) {\n      // Firefox 31 throws when \"toString\" is applied to an HTMLElement\n      return typeof fn === \"function\";\n    }\n  }\n"])));
		  helpers$3.wrapNativeSuper = helper$2("7.0.0-beta.0")(_templateObject16$2 || (_templateObject16$2 = _taggedTemplateLiteralLoose(["\n  import getPrototypeOf from \"getPrototypeOf\";\n  import setPrototypeOf from \"setPrototypeOf\";\n  import isNativeFunction from \"isNativeFunction\";\n  import construct from \"construct\";\n\n  export default function _wrapNativeSuper(Class) {\n    var _cache = typeof Map === \"function\" ? new Map() : undefined;\n\n    _wrapNativeSuper = function _wrapNativeSuper(Class) {\n      if (Class === null || !isNativeFunction(Class)) return Class;\n      if (typeof Class !== \"function\") {\n        throw new TypeError(\"Super expression must either be null or a function\");\n      }\n      if (typeof _cache !== \"undefined\") {\n        if (_cache.has(Class)) return _cache.get(Class);\n        _cache.set(Class, Wrapper);\n      }\n      function Wrapper() {\n        return construct(Class, arguments, getPrototypeOf(this).constructor)\n      }\n      Wrapper.prototype = Object.create(Class.prototype, {\n        constructor: {\n          value: Wrapper,\n          enumerable: false,\n          writable: true,\n          configurable: true,\n        }\n      });\n\n      return setPrototypeOf(Wrapper, Class);\n    }\n\n    return _wrapNativeSuper(Class)\n  }\n"])));
		  helpers$3["instanceof"] = helper$2("7.0.0-beta.0")(_templateObject17$2 || (_templateObject17$2 = _taggedTemplateLiteralLoose(["\n  export default function _instanceof(left, right) {\n    if (right != null && typeof Symbol !== \"undefined\" && right[Symbol.hasInstance]) {\n      return !!right[Symbol.hasInstance](left);\n    } else {\n      return left instanceof right;\n    }\n  }\n"])));
		  helpers$3.interopRequireDefault = helper$2("7.0.0-beta.0")(_templateObject18$2 || (_templateObject18$2 = _taggedTemplateLiteralLoose(["\n  export default function _interopRequireDefault(obj) {\n    return obj && obj.__esModule ? obj : { default: obj };\n  }\n"])));
		  helpers$3.newArrowCheck = helper$2("7.0.0-beta.0")(_templateObject19$1 || (_templateObject19$1 = _taggedTemplateLiteralLoose(["\n  export default function _newArrowCheck(innerThis, boundThis) {\n    if (innerThis !== boundThis) {\n      throw new TypeError(\"Cannot instantiate an arrow function\");\n    }\n  }\n"])));
		  helpers$3.objectDestructuringEmpty = helper$2("7.0.0-beta.0")(_templateObject20$1 || (_templateObject20$1 = _taggedTemplateLiteralLoose(["\n  export default function _objectDestructuringEmpty(obj) {\n    if (obj == null) throw new TypeError(\"Cannot destructure \" + obj);\n  }\n"])));
		  helpers$3.objectWithoutPropertiesLoose = helper$2("7.0.0-beta.0")(_templateObject21$1 || (_templateObject21$1 = _taggedTemplateLiteralLoose(["\n  export default function _objectWithoutPropertiesLoose(source, excluded) {\n    if (source == null) return {};\n\n    var target = {};\n\n    for (var key in source) {\n      if (Object.prototype.hasOwnProperty.call(source, key)) {\n        if (excluded.indexOf(key) >= 0) continue;\n        target[key] = source[key];\n      }\n    }\n\n    return target;\n  }\n"])));
		  helpers$3.objectWithoutProperties = helper$2("7.0.0-beta.0")(_templateObject22$1 || (_templateObject22$1 = _taggedTemplateLiteralLoose(["\n  import objectWithoutPropertiesLoose from \"objectWithoutPropertiesLoose\";\n\n  export default function _objectWithoutProperties(source, excluded) {\n    if (source == null) return {};\n\n    var target = objectWithoutPropertiesLoose(source, excluded);\n    var key, i;\n\n    if (Object.getOwnPropertySymbols) {\n      var sourceSymbolKeys = Object.getOwnPropertySymbols(source);\n      for (i = 0; i < sourceSymbolKeys.length; i++) {\n        key = sourceSymbolKeys[i];\n        if (excluded.indexOf(key) >= 0) continue;\n        if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;\n        target[key] = source[key];\n      }\n    }\n\n    return target;\n  }\n"])));
		  helpers$3.assertThisInitialized = helper$2("7.0.0-beta.0")(_templateObject23 || (_templateObject23 = _taggedTemplateLiteralLoose(["\n  export default function _assertThisInitialized(self) {\n    if (self === void 0) {\n      throw new ReferenceError(\"this hasn't been initialised - super() hasn't been called\");\n    }\n    return self;\n  }\n"])));
		  helpers$3.possibleConstructorReturn = helper$2("7.0.0-beta.0")(_templateObject24 || (_templateObject24 = _taggedTemplateLiteralLoose(["\n  import assertThisInitialized from \"assertThisInitialized\";\n\n  export default function _possibleConstructorReturn(self, call) {\n    if (call && (typeof call === \"object\" || typeof call === \"function\")) {\n      return call;\n    } else if (call !== void 0) {\n      throw new TypeError(\"Derived constructors may only return object or undefined\");\n    }\n\n    return assertThisInitialized(self);\n  }\n"])));
		  {
		    helpers$3.createSuper = helper$2("7.9.0")(_templateObject25 || (_templateObject25 = _taggedTemplateLiteralLoose(["\n    import getPrototypeOf from \"getPrototypeOf\";\n    import isNativeReflectConstruct from \"isNativeReflectConstruct\";\n    import possibleConstructorReturn from \"possibleConstructorReturn\";\n\n    export default function _createSuper(Derived) {\n      var hasNativeReflectConstruct = isNativeReflectConstruct();\n\n      return function _createSuperInternal() {\n        var Super = getPrototypeOf(Derived), result;\n        if (hasNativeReflectConstruct) {\n          // NOTE: This doesn't work if this.__proto__.constructor has been modified.\n          var NewTarget = getPrototypeOf(this).constructor;\n          result = Reflect.construct(Super, arguments, NewTarget);\n        } else {\n          result = Super.apply(this, arguments);\n        }\n        return possibleConstructorReturn(this, result);\n      }\n    }\n"])));
		  }
		  helpers$3.superPropBase = helper$2("7.0.0-beta.0")(_templateObject26 || (_templateObject26 = _taggedTemplateLiteralLoose(["\n  import getPrototypeOf from \"getPrototypeOf\";\n\n  export default function _superPropBase(object, property) {\n    // Yes, this throws if object is null to being with, that's on purpose.\n    while (!Object.prototype.hasOwnProperty.call(object, property)) {\n      object = getPrototypeOf(object);\n      if (object === null) break;\n    }\n    return object;\n  }\n"])));
		  helpers$3.get = helper$2("7.0.0-beta.0")(_templateObject27 || (_templateObject27 = _taggedTemplateLiteralLoose(["\n  import superPropBase from \"superPropBase\";\n\n  export default function _get() {\n    if (typeof Reflect !== \"undefined\" && Reflect.get) {\n      _get = Reflect.get.bind();\n    } else {\n      _get = function _get(target, property, receiver) {\n        var base = superPropBase(target, property);\n\n        if (!base) return;\n\n        var desc = Object.getOwnPropertyDescriptor(base, property);\n        if (desc.get) {\n          // STEP 3. If receiver is not present, then set receiver to target.\n          return desc.get.call(arguments.length < 3 ? target : receiver);\n        }\n\n        return desc.value;\n      };\n    }\n    return _get.apply(this, arguments);\n  }\n"])));
		  helpers$3.set = helper$2("7.0.0-beta.0")(_templateObject28 || (_templateObject28 = _taggedTemplateLiteralLoose(["\n  import superPropBase from \"superPropBase\";\n  import defineProperty from \"defineProperty\";\n\n  function set(target, property, value, receiver) {\n    if (typeof Reflect !== \"undefined\" && Reflect.set) {\n      set = Reflect.set;\n    } else {\n      set = function set(target, property, value, receiver) {\n        var base = superPropBase(target, property);\n        var desc;\n\n        if (base) {\n          desc = Object.getOwnPropertyDescriptor(base, property);\n          if (desc.set) {\n            desc.set.call(receiver, value);\n            return true;\n          } else if (!desc.writable) {\n            // Both getter and non-writable fall into this.\n            return false;\n          }\n        }\n\n        // Without a super that defines the property, spec boils down to\n        // \"define on receiver\" for some reason.\n        desc = Object.getOwnPropertyDescriptor(receiver, property);\n        if (desc) {\n          if (!desc.writable) {\n            // Setter, getter, and non-writable fall into this.\n            return false;\n          }\n\n          desc.value = value;\n          Object.defineProperty(receiver, property, desc);\n        } else {\n          // Avoid setters that may be defined on Sub's prototype, but not on\n          // the instance.\n          defineProperty(receiver, property, value);\n        }\n\n        return true;\n      };\n    }\n\n    return set(target, property, value, receiver);\n  }\n\n  export default function _set(target, property, value, receiver, isStrict) {\n    var s = set(target, property, value, receiver || target);\n    if (!s && isStrict) {\n      throw new TypeError('failed to set property');\n    }\n\n    return value;\n  }\n"])));
		  helpers$3.taggedTemplateLiteral = helper$2("7.0.0-beta.0")(_templateObject29 || (_templateObject29 = _taggedTemplateLiteralLoose(["\n  export default function _taggedTemplateLiteral(strings, raw) {\n    if (!raw) { raw = strings.slice(0); }\n    return Object.freeze(Object.defineProperties(strings, {\n        raw: { value: Object.freeze(raw) }\n    }));\n  }\n"])));
		  helpers$3.taggedTemplateLiteralLoose = helper$2("7.0.0-beta.0")(_templateObject30 || (_templateObject30 = _taggedTemplateLiteralLoose(["\n  export default function _taggedTemplateLiteralLoose(strings, raw) {\n    if (!raw) { raw = strings.slice(0); }\n    strings.raw = raw;\n    return strings;\n  }\n"])));
		  helpers$3.readOnlyError = helper$2("7.0.0-beta.0")(_templateObject31 || (_templateObject31 = _taggedTemplateLiteralLoose(["\n  export default function _readOnlyError(name) {\n    throw new TypeError(\"\\\"\" + name + \"\\\" is read-only\");\n  }\n"], ["\n  export default function _readOnlyError(name) {\n    throw new TypeError(\"\\\\\"\" + name + \"\\\\\" is read-only\");\n  }\n"])));
		  helpers$3.writeOnlyError = helper$2("7.12.13")(_templateObject32 || (_templateObject32 = _taggedTemplateLiteralLoose(["\n  export default function _writeOnlyError(name) {\n    throw new TypeError(\"\\\"\" + name + \"\\\" is write-only\");\n  }\n"], ["\n  export default function _writeOnlyError(name) {\n    throw new TypeError(\"\\\\\"\" + name + \"\\\\\" is write-only\");\n  }\n"])));
		  helpers$3.classNameTDZError = helper$2("7.0.0-beta.0")(_templateObject33 || (_templateObject33 = _taggedTemplateLiteralLoose(["\n  export default function _classNameTDZError(name) {\n    throw new ReferenceError(\"Class \\\"\" + name + \"\\\" cannot be referenced in computed property keys.\");\n  }\n"], ["\n  export default function _classNameTDZError(name) {\n    throw new ReferenceError(\"Class \\\\\"\" + name + \"\\\\\" cannot be referenced in computed property keys.\");\n  }\n"])));
		  helpers$3.temporalUndefined = helper$2("7.0.0-beta.0")(_templateObject34 || (_templateObject34 = _taggedTemplateLiteralLoose(["\n  // This function isn't mean to be called, but to be used as a reference.\n  // We can't use a normal object because it isn't hoisted.\n  export default function _temporalUndefined() {}\n"])));
		  helpers$3.tdz = helper$2("7.5.5")(_templateObject35 || (_templateObject35 = _taggedTemplateLiteralLoose(["\n  export default function _tdzError(name) {\n    throw new ReferenceError(name + \" is not defined - temporal dead zone\");\n  }\n"])));
		  helpers$3.temporalRef = helper$2("7.0.0-beta.0")(_templateObject36 || (_templateObject36 = _taggedTemplateLiteralLoose(["\n  import undef from \"temporalUndefined\";\n  import err from \"tdz\";\n\n  export default function _temporalRef(val, name) {\n    return val === undef ? err(name) : val;\n  }\n"])));
		  helpers$3.slicedToArray = helper$2("7.0.0-beta.0")(_templateObject37 || (_templateObject37 = _taggedTemplateLiteralLoose(["\n  import arrayWithHoles from \"arrayWithHoles\";\n  import iterableToArrayLimit from \"iterableToArrayLimit\";\n  import unsupportedIterableToArray from \"unsupportedIterableToArray\";\n  import nonIterableRest from \"nonIterableRest\";\n\n  export default function _slicedToArray(arr, i) {\n    return (\n      arrayWithHoles(arr) ||\n      iterableToArrayLimit(arr, i) ||\n      unsupportedIterableToArray(arr, i) ||\n      nonIterableRest()\n    );\n  }\n"])));
		  helpers$3.slicedToArrayLoose = helper$2("7.0.0-beta.0")(_templateObject38 || (_templateObject38 = _taggedTemplateLiteralLoose(["\n  import arrayWithHoles from \"arrayWithHoles\";\n  import iterableToArrayLimitLoose from \"iterableToArrayLimitLoose\";\n  import unsupportedIterableToArray from \"unsupportedIterableToArray\";\n  import nonIterableRest from \"nonIterableRest\";\n\n  export default function _slicedToArrayLoose(arr, i) {\n    return (\n      arrayWithHoles(arr) ||\n      iterableToArrayLimitLoose(arr, i) ||\n      unsupportedIterableToArray(arr, i) ||\n      nonIterableRest()\n    );\n  }\n"])));
		  helpers$3.toArray = helper$2("7.0.0-beta.0")(_templateObject39 || (_templateObject39 = _taggedTemplateLiteralLoose(["\n  import arrayWithHoles from \"arrayWithHoles\";\n  import iterableToArray from \"iterableToArray\";\n  import unsupportedIterableToArray from \"unsupportedIterableToArray\";\n  import nonIterableRest from \"nonIterableRest\";\n\n  export default function _toArray(arr) {\n    return (\n      arrayWithHoles(arr) ||\n      iterableToArray(arr) ||\n      unsupportedIterableToArray(arr) ||\n      nonIterableRest()\n    );\n  }\n"])));
		  helpers$3.toConsumableArray = helper$2("7.0.0-beta.0")(_templateObject40 || (_templateObject40 = _taggedTemplateLiteralLoose(["\n  import arrayWithoutHoles from \"arrayWithoutHoles\";\n  import iterableToArray from \"iterableToArray\";\n  import unsupportedIterableToArray from \"unsupportedIterableToArray\";\n  import nonIterableSpread from \"nonIterableSpread\";\n\n  export default function _toConsumableArray(arr) {\n    return (\n      arrayWithoutHoles(arr) ||\n      iterableToArray(arr) ||\n      unsupportedIterableToArray(arr) ||\n      nonIterableSpread()\n    );\n  }\n"])));
		  helpers$3.arrayWithoutHoles = helper$2("7.0.0-beta.0")(_templateObject41 || (_templateObject41 = _taggedTemplateLiteralLoose(["\n  import arrayLikeToArray from \"arrayLikeToArray\";\n\n  export default function _arrayWithoutHoles(arr) {\n    if (Array.isArray(arr)) return arrayLikeToArray(arr);\n  }\n"])));
		  helpers$3.arrayWithHoles = helper$2("7.0.0-beta.0")(_templateObject42 || (_templateObject42 = _taggedTemplateLiteralLoose(["\n  export default function _arrayWithHoles(arr) {\n    if (Array.isArray(arr)) return arr;\n  }\n"])));
		  helpers$3.maybeArrayLike = helper$2("7.9.0")(_templateObject43 || (_templateObject43 = _taggedTemplateLiteralLoose(["\n  import arrayLikeToArray from \"arrayLikeToArray\";\n\n  export default function _maybeArrayLike(next, arr, i) {\n    if (arr && !Array.isArray(arr) && typeof arr.length === \"number\") {\n      var len = arr.length;\n      return arrayLikeToArray(arr, i !== void 0 && i < len ? i : len);\n    }\n    return next(arr, i);\n  }\n"])));
		  helpers$3.iterableToArray = helper$2("7.0.0-beta.0")(_templateObject44 || (_templateObject44 = _taggedTemplateLiteralLoose(["\n  export default function _iterableToArray(iter) {\n    if (typeof Symbol !== \"undefined\" && iter[Symbol.iterator] != null || iter[\"@@iterator\"] != null) return Array.from(iter);\n  }\n"])));
		  helpers$3.unsupportedIterableToArray = helper$2("7.9.0")(_templateObject45 || (_templateObject45 = _taggedTemplateLiteralLoose(["\n  import arrayLikeToArray from \"arrayLikeToArray\";\n\n  export default function _unsupportedIterableToArray(o, minLen) {\n    if (!o) return;\n    if (typeof o === \"string\") return arrayLikeToArray(o, minLen);\n    var n = Object.prototype.toString.call(o).slice(8, -1);\n    if (n === \"Object\" && o.constructor) n = o.constructor.name;\n    if (n === \"Map\" || n === \"Set\") return Array.from(o);\n    if (n === \"Arguments\" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))\n      return arrayLikeToArray(o, minLen);\n  }\n"])));
		  helpers$3.arrayLikeToArray = helper$2("7.9.0")(_templateObject46 || (_templateObject46 = _taggedTemplateLiteralLoose(["\n  export default function _arrayLikeToArray(arr, len) {\n    if (len == null || len > arr.length) len = arr.length;\n    for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];\n    return arr2;\n  }\n"])));
		  helpers$3.nonIterableSpread = helper$2("7.0.0-beta.0")(_templateObject47 || (_templateObject47 = _taggedTemplateLiteralLoose(["\n  export default function _nonIterableSpread() {\n    throw new TypeError(\n      \"Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.\"\n    );\n  }\n"], ["\n  export default function _nonIterableSpread() {\n    throw new TypeError(\n      \"Invalid attempt to spread non-iterable instance.\\\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.\"\n    );\n  }\n"])));
		  helpers$3.nonIterableRest = helper$2("7.0.0-beta.0")(_templateObject48 || (_templateObject48 = _taggedTemplateLiteralLoose(["\n  export default function _nonIterableRest() {\n    throw new TypeError(\n      \"Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.\"\n    );\n  }\n"], ["\n  export default function _nonIterableRest() {\n    throw new TypeError(\n      \"Invalid attempt to destructure non-iterable instance.\\\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.\"\n    );\n  }\n"])));
		  helpers$3.createForOfIteratorHelper = helper$2("7.9.0")(_templateObject49 || (_templateObject49 = _taggedTemplateLiteralLoose(["\n  import unsupportedIterableToArray from \"unsupportedIterableToArray\";\n\n  // s: start (create the iterator)\n  // n: next\n  // e: error (called whenever something throws)\n  // f: finish (always called at the end)\n\n  export default function _createForOfIteratorHelper(o, allowArrayLike) {\n    var it = typeof Symbol !== \"undefined\" && o[Symbol.iterator] || o[\"@@iterator\"];\n\n    if (!it) {\n      // Fallback for engines without symbol support\n      if (\n        Array.isArray(o) ||\n        (it = unsupportedIterableToArray(o)) ||\n        (allowArrayLike && o && typeof o.length === \"number\")\n      ) {\n        if (it) o = it;\n        var i = 0;\n        var F = function(){};\n        return {\n          s: F,\n          n: function() {\n            if (i >= o.length) return { done: true };\n            return { done: false, value: o[i++] };\n          },\n          e: function(e) { throw e; },\n          f: F,\n        };\n      }\n\n      throw new TypeError(\"Invalid attempt to iterate non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.\");\n    }\n\n    var normalCompletion = true, didErr = false, err;\n\n    return {\n      s: function() {\n        it = it.call(o);\n      },\n      n: function() {\n        var step = it.next();\n        normalCompletion = step.done;\n        return step;\n      },\n      e: function(e) {\n        didErr = true;\n        err = e;\n      },\n      f: function() {\n        try {\n          if (!normalCompletion && it.return != null) it.return();\n        } finally {\n          if (didErr) throw err;\n        }\n      }\n    };\n  }\n"], ["\n  import unsupportedIterableToArray from \"unsupportedIterableToArray\";\n\n  // s: start (create the iterator)\n  // n: next\n  // e: error (called whenever something throws)\n  // f: finish (always called at the end)\n\n  export default function _createForOfIteratorHelper(o, allowArrayLike) {\n    var it = typeof Symbol !== \"undefined\" && o[Symbol.iterator] || o[\"@@iterator\"];\n\n    if (!it) {\n      // Fallback for engines without symbol support\n      if (\n        Array.isArray(o) ||\n        (it = unsupportedIterableToArray(o)) ||\n        (allowArrayLike && o && typeof o.length === \"number\")\n      ) {\n        if (it) o = it;\n        var i = 0;\n        var F = function(){};\n        return {\n          s: F,\n          n: function() {\n            if (i >= o.length) return { done: true };\n            return { done: false, value: o[i++] };\n          },\n          e: function(e) { throw e; },\n          f: F,\n        };\n      }\n\n      throw new TypeError(\"Invalid attempt to iterate non-iterable instance.\\\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.\");\n    }\n\n    var normalCompletion = true, didErr = false, err;\n\n    return {\n      s: function() {\n        it = it.call(o);\n      },\n      n: function() {\n        var step = it.next();\n        normalCompletion = step.done;\n        return step;\n      },\n      e: function(e) {\n        didErr = true;\n        err = e;\n      },\n      f: function() {\n        try {\n          if (!normalCompletion && it.return != null) it.return();\n        } finally {\n          if (didErr) throw err;\n        }\n      }\n    };\n  }\n"])));
		  helpers$3.createForOfIteratorHelperLoose = helper$2("7.9.0")(_templateObject50 || (_templateObject50 = _taggedTemplateLiteralLoose(["\n  import unsupportedIterableToArray from \"unsupportedIterableToArray\";\n\n  export default function _createForOfIteratorHelperLoose(o, allowArrayLike) {\n    var it = typeof Symbol !== \"undefined\" && o[Symbol.iterator] || o[\"@@iterator\"];\n\n    if (it) return (it = it.call(o)).next.bind(it);\n\n    // Fallback for engines without symbol support\n    if (\n      Array.isArray(o) ||\n      (it = unsupportedIterableToArray(o)) ||\n      (allowArrayLike && o && typeof o.length === \"number\")\n    ) {\n      if (it) o = it;\n      var i = 0;\n      return function() {\n        if (i >= o.length) return { done: true };\n        return { done: false, value: o[i++] };\n      }\n    }\n\n    throw new TypeError(\"Invalid attempt to iterate non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.\");\n  }\n"], ["\n  import unsupportedIterableToArray from \"unsupportedIterableToArray\";\n\n  export default function _createForOfIteratorHelperLoose(o, allowArrayLike) {\n    var it = typeof Symbol !== \"undefined\" && o[Symbol.iterator] || o[\"@@iterator\"];\n\n    if (it) return (it = it.call(o)).next.bind(it);\n\n    // Fallback for engines without symbol support\n    if (\n      Array.isArray(o) ||\n      (it = unsupportedIterableToArray(o)) ||\n      (allowArrayLike && o && typeof o.length === \"number\")\n    ) {\n      if (it) o = it;\n      var i = 0;\n      return function() {\n        if (i >= o.length) return { done: true };\n        return { done: false, value: o[i++] };\n      }\n    }\n\n    throw new TypeError(\"Invalid attempt to iterate non-iterable instance.\\\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.\");\n  }\n"])));
		  helpers$3.skipFirstGeneratorNext = helper$2("7.0.0-beta.0")(_templateObject51 || (_templateObject51 = _taggedTemplateLiteralLoose(["\n  export default function _skipFirstGeneratorNext(fn) {\n    return function () {\n      var it = fn.apply(this, arguments);\n      it.next();\n      return it;\n    }\n  }\n"])));
		  helpers$3.initializerWarningHelper = helper$2("7.0.0-beta.0")(_templateObject52 || (_templateObject52 = _taggedTemplateLiteralLoose(["\n    export default function _initializerWarningHelper(descriptor, context){\n        throw new Error(\n          'Decorating class property failed. Please ensure that ' +\n          'transform-class-properties is enabled and runs after the decorators transform.'\n        );\n    }\n"])));
		  helpers$3.initializerDefineProperty = helper$2("7.0.0-beta.0")(_templateObject53 || (_templateObject53 = _taggedTemplateLiteralLoose(["\n    export default function _initializerDefineProperty(target, property, descriptor, context){\n        if (!descriptor) return;\n\n        Object.defineProperty(target, property, {\n            enumerable: descriptor.enumerable,\n            configurable: descriptor.configurable,\n            writable: descriptor.writable,\n            value: descriptor.initializer ? descriptor.initializer.call(context) : void 0,\n        });\n    }\n"])));
		  helpers$3.applyDecoratedDescriptor = helper$2("7.0.0-beta.0")(_templateObject54 || (_templateObject54 = _taggedTemplateLiteralLoose(["\n    export default function _applyDecoratedDescriptor(target, property, decorators, descriptor, context){\n        var desc = {};\n        Object.keys(descriptor).forEach(function(key){\n            desc[key] = descriptor[key];\n        });\n        desc.enumerable = !!desc.enumerable;\n        desc.configurable = !!desc.configurable;\n        if ('value' in desc || desc.initializer){\n            desc.writable = true;\n        }\n\n        desc = decorators.slice().reverse().reduce(function(desc, decorator){\n            return decorator(target, property, desc) || desc;\n        }, desc);\n\n        if (context && desc.initializer !== void 0){\n            desc.value = desc.initializer ? desc.initializer.call(context) : void 0;\n            desc.initializer = undefined;\n        }\n\n        if (desc.initializer === void 0){\n            Object.defineProperty(target, property, desc);\n            desc = null;\n        }\n\n        return desc;\n    }\n"])));
		  helpers$3.classPrivateFieldLooseKey = helper$2("7.0.0-beta.0")(_templateObject55 || (_templateObject55 = _taggedTemplateLiteralLoose(["\n  var id = 0;\n  export default function _classPrivateFieldKey(name) {\n    return \"__private_\" + (id++) + \"_\" + name;\n  }\n"])));
		  helpers$3.classPrivateFieldLooseBase = helper$2("7.0.0-beta.0")(_templateObject56 || (_templateObject56 = _taggedTemplateLiteralLoose(["\n  export default function _classPrivateFieldBase(receiver, privateKey) {\n    if (!Object.prototype.hasOwnProperty.call(receiver, privateKey)) {\n      throw new TypeError(\"attempted to use private field on non-instance\");\n    }\n    return receiver;\n  }\n"])));
		  helpers$3.classPrivateFieldGet = helper$2("7.0.0-beta.0")(_templateObject57 || (_templateObject57 = _taggedTemplateLiteralLoose(["\n  import classApplyDescriptorGet from \"classApplyDescriptorGet\";\n  import classPrivateFieldGet2 from \"classPrivateFieldGet2\";\n  export default function _classPrivateFieldGet(receiver, privateMap) {\n    var descriptor = classPrivateFieldGet2(privateMap, receiver);\n    return classApplyDescriptorGet(receiver, descriptor);\n  }\n"])));
		  helpers$3.classPrivateFieldSet = helper$2("7.0.0-beta.0")(_templateObject58 || (_templateObject58 = _taggedTemplateLiteralLoose(["\n  import classApplyDescriptorSet from \"classApplyDescriptorSet\";\n  import classPrivateFieldGet2 from \"classPrivateFieldGet2\";\n  export default function _classPrivateFieldSet(receiver, privateMap, value) {\n    var descriptor = classPrivateFieldGet2(privateMap, receiver);\n    classApplyDescriptorSet(receiver, descriptor, value);\n    return value;\n  }\n"])));
		  helpers$3.classPrivateFieldDestructureSet = helper$2("7.4.4")(_templateObject59 || (_templateObject59 = _taggedTemplateLiteralLoose(["\n  import classApplyDescriptorDestructureSet from \"classApplyDescriptorDestructureSet\";\n  import classPrivateFieldGet2 from \"classPrivateFieldGet2\";\n  export default function _classPrivateFieldDestructureSet(receiver, privateMap) {\n    var descriptor = classPrivateFieldGet2(privateMap, receiver);\n    return classApplyDescriptorDestructureSet(receiver, descriptor);\n  }\n"])));
		  helpers$3.classExtractFieldDescriptor = helper$2("7.13.10")(_templateObject60 || (_templateObject60 = _taggedTemplateLiteralLoose(["\n  import classPrivateFieldGet2 from \"classPrivateFieldGet2\";\n\n  export default function _classExtractFieldDescriptor(receiver, privateMap) {\n    return classPrivateFieldGet2(privateMap, receiver);\n  }\n"])));
		  helpers$3.classStaticPrivateFieldSpecGet = helper$2("7.0.2")(_templateObject61 || (_templateObject61 = _taggedTemplateLiteralLoose(["\n  import classApplyDescriptorGet from \"classApplyDescriptorGet\";\n  import assertClassBrand from \"assertClassBrand\";\n  import classCheckPrivateStaticFieldDescriptor from \"classCheckPrivateStaticFieldDescriptor\";\n  export default function _classStaticPrivateFieldSpecGet(receiver, classConstructor, descriptor) {\n    assertClassBrand(classConstructor, receiver);\n    classCheckPrivateStaticFieldDescriptor(descriptor, \"get\");\n    return classApplyDescriptorGet(receiver, descriptor);\n  }\n"])));
		  helpers$3.classStaticPrivateFieldSpecSet = helper$2("7.0.2")(_templateObject62 || (_templateObject62 = _taggedTemplateLiteralLoose(["\n  import classApplyDescriptorSet from \"classApplyDescriptorSet\";\n  import assertClassBrand from \"assertClassBrand\";\n  import classCheckPrivateStaticFieldDescriptor from \"classCheckPrivateStaticFieldDescriptor\";\n  export default function _classStaticPrivateFieldSpecSet(receiver, classConstructor, descriptor, value) {\n    assertClassBrand(classConstructor, receiver);\n    classCheckPrivateStaticFieldDescriptor(descriptor, \"set\");\n    classApplyDescriptorSet(receiver, descriptor, value);\n    return value;\n  }\n"])));
		  helpers$3.classStaticPrivateMethodGet = helper$2("7.3.2")(_templateObject63 || (_templateObject63 = _taggedTemplateLiteralLoose(["\n  import assertClassBrand from \"assertClassBrand\";\n  export default function _classStaticPrivateMethodGet(receiver, classConstructor, method) {\n    assertClassBrand(classConstructor, receiver);\n    return method;\n  }\n"])));
		  helpers$3.classStaticPrivateMethodSet = helper$2("7.3.2")(_templateObject64 || (_templateObject64 = _taggedTemplateLiteralLoose(["\n  export default function _classStaticPrivateMethodSet() {\n    throw new TypeError(\"attempted to set read only static private field\");\n  }\n"])));
		  helpers$3.classApplyDescriptorGet = helper$2("7.13.10")(_templateObject65 || (_templateObject65 = _taggedTemplateLiteralLoose(["\n  export default function _classApplyDescriptorGet(receiver, descriptor) {\n    if (descriptor.get) {\n      return descriptor.get.call(receiver);\n    }\n    return descriptor.value;\n  }\n"])));
		  helpers$3.classApplyDescriptorSet = helper$2("7.13.10")(_templateObject66 || (_templateObject66 = _taggedTemplateLiteralLoose(["\n  export default function _classApplyDescriptorSet(receiver, descriptor, value) {\n    if (descriptor.set) {\n      descriptor.set.call(receiver, value);\n    } else {\n      if (!descriptor.writable) {\n        // This should only throw in strict mode, but class bodies are\n        // always strict and private fields can only be used inside\n        // class bodies.\n        throw new TypeError(\"attempted to set read only private field\");\n      }\n      descriptor.value = value;\n    }\n  }\n"])));
		  helpers$3.classApplyDescriptorDestructureSet = helper$2("7.13.10")(_templateObject67 || (_templateObject67 = _taggedTemplateLiteralLoose(["\n  export default function _classApplyDescriptorDestructureSet(receiver, descriptor) {\n    if (descriptor.set) {\n      if (!(\"__destrObj\" in descriptor)) {\n        descriptor.__destrObj = {\n          set value(v) {\n            descriptor.set.call(receiver, v)\n          },\n        };\n      }\n      return descriptor.__destrObj;\n    } else {\n      if (!descriptor.writable) {\n        // This should only throw in strict mode, but class bodies are\n        // always strict and private fields can only be used inside\n        // class bodies.\n        throw new TypeError(\"attempted to set read only private field\");\n      }\n\n      return descriptor;\n    }\n  }\n"])));
		  helpers$3.classStaticPrivateFieldDestructureSet = helper$2("7.13.10")(_templateObject68 || (_templateObject68 = _taggedTemplateLiteralLoose(["\n  import classApplyDescriptorDestructureSet from \"classApplyDescriptorDestructureSet\";\n  import assertClassBrand from \"assertClassBrand\";\n  import classCheckPrivateStaticFieldDescriptor from \"classCheckPrivateStaticFieldDescriptor\";\n  export default function _classStaticPrivateFieldDestructureSet(receiver, classConstructor, descriptor) {\n    assertClassBrand(classConstructor, receiver);\n    classCheckPrivateStaticFieldDescriptor(descriptor, \"set\");\n    return classApplyDescriptorDestructureSet(receiver, descriptor);\n  }\n"])));
		  helpers$3.classCheckPrivateStaticAccess = helper$2("7.13.10")(_templateObject69 || (_templateObject69 = _taggedTemplateLiteralLoose(["\n  import assertClassBrand from \"assertClassBrand\";\n  export default function _classCheckPrivateStaticAccess(receiver, classConstructor, returnValue) {\n    return assertClassBrand(classConstructor, receiver, returnValue);\n  }\n"])));
		  helpers$3.classCheckPrivateStaticFieldDescriptor = helper$2("7.13.10")(_templateObject70 || (_templateObject70 = _taggedTemplateLiteralLoose(["\n  export default function _classCheckPrivateStaticFieldDescriptor(descriptor, action) {\n    if (descriptor === undefined) {\n      throw new TypeError(\"attempted to \" + action + \" private static field before its declaration\");\n    }\n  }\n"])));
		  helpers$3.decorate = helper$2("7.1.5")(_templateObject71 || (_templateObject71 = _taggedTemplateLiteralLoose(["\n  import toArray from \"toArray\";\n  import toPropertyKey from \"toPropertyKey\";\n\n  // These comments are stripped by @babel/template\n  /*::\n  type PropertyDescriptor =\n    | {\n        value: any,\n        writable: boolean,\n        configurable: boolean,\n        enumerable: boolean,\n      }\n    | {\n        get?: () => any,\n        set?: (v: any) => void,\n        configurable: boolean,\n        enumerable: boolean,\n      };\n\n  type FieldDescriptor ={\n    writable: boolean,\n    configurable: boolean,\n    enumerable: boolean,\n  };\n\n  type Placement = \"static\" | \"prototype\" | \"own\";\n  type Key = string | symbol; // PrivateName is not supported yet.\n\n  type ElementDescriptor =\n    | {\n        kind: \"method\",\n        key: Key,\n        placement: Placement,\n        descriptor: PropertyDescriptor\n      }\n    | {\n        kind: \"field\",\n        key: Key,\n        placement: Placement,\n        descriptor: FieldDescriptor,\n        initializer?: () => any,\n      };\n\n  // This is exposed to the user code\n  type ElementObjectInput = ElementDescriptor & {\n    [@@toStringTag]?: \"Descriptor\"\n  };\n\n  // This is exposed to the user code\n  type ElementObjectOutput = ElementDescriptor & {\n    [@@toStringTag]?: \"Descriptor\"\n    extras?: ElementDescriptor[],\n    finisher?: ClassFinisher,\n  };\n\n  // This is exposed to the user code\n  type ClassObject = {\n    [@@toStringTag]?: \"Descriptor\",\n    kind: \"class\",\n    elements: ElementDescriptor[],\n  };\n\n  type ElementDecorator = (descriptor: ElementObjectInput) => ?ElementObjectOutput;\n  type ClassDecorator = (descriptor: ClassObject) => ?ClassObject;\n  type ClassFinisher = <A, B>(cl: Class<A>) => Class<B>;\n\n  // Only used by Babel in the transform output, not part of the spec.\n  type ElementDefinition =\n    | {\n        kind: \"method\",\n        value: any,\n        key: Key,\n        static?: boolean,\n        decorators?: ElementDecorator[],\n      }\n    | {\n        kind: \"field\",\n        value: () => any,\n        key: Key,\n        static?: boolean,\n        decorators?: ElementDecorator[],\n    };\n\n  declare function ClassFactory<C>(initialize: (instance: C) => void): {\n    F: Class<C>,\n    d: ElementDefinition[]\n  }\n\n  */\n\n  /*::\n  // Various combinations with/without extras and with one or many finishers\n\n  type ElementFinisherExtras = {\n    element: ElementDescriptor,\n    finisher?: ClassFinisher,\n    extras?: ElementDescriptor[],\n  };\n\n  type ElementFinishersExtras = {\n    element: ElementDescriptor,\n    finishers: ClassFinisher[],\n    extras: ElementDescriptor[],\n  };\n\n  type ElementsFinisher = {\n    elements: ElementDescriptor[],\n    finisher?: ClassFinisher,\n  };\n\n  type ElementsFinishers = {\n    elements: ElementDescriptor[],\n    finishers: ClassFinisher[],\n  };\n\n  */\n\n  /*::\n\n  type Placements = {\n    static: Key[],\n    prototype: Key[],\n    own: Key[],\n  };\n\n  */\n\n  // ClassDefinitionEvaluation (Steps 26-*)\n  export default function _decorate(\n    decorators /*: ClassDecorator[] */,\n    factory /*: ClassFactory */,\n    superClass /*: ?Class<*> */,\n    mixins /*: ?Array<Function> */,\n  ) /*: Class<*> */ {\n    var api = _getDecoratorsApi();\n    if (mixins) {\n      for (var i = 0; i < mixins.length; i++) {\n        api = mixins[i](api);\n      }\n    }\n\n    var r = factory(function initialize(O) {\n      api.initializeInstanceElements(O, decorated.elements);\n    }, superClass);\n    var decorated = api.decorateClass(\n      _coalesceClassElements(r.d.map(_createElementDescriptor)),\n      decorators,\n    );\n\n    api.initializeClassElements(r.F, decorated.elements);\n\n    return api.runClassFinishers(r.F, decorated.finishers);\n  }\n\n  function _getDecoratorsApi() {\n    _getDecoratorsApi = function() {\n      return api;\n    };\n\n    var api = {\n      elementsDefinitionOrder: [[\"method\"], [\"field\"]],\n\n      // InitializeInstanceElements\n      initializeInstanceElements: function(\n        /*::<C>*/ O /*: C */,\n        elements /*: ElementDescriptor[] */,\n      ) {\n        [\"method\", \"field\"].forEach(function(kind) {\n          elements.forEach(function(element /*: ElementDescriptor */) {\n            if (element.kind === kind && element.placement === \"own\") {\n              this.defineClassElement(O, element);\n            }\n          }, this);\n        }, this);\n      },\n\n      // InitializeClassElements\n      initializeClassElements: function(\n        /*::<C>*/ F /*: Class<C> */,\n        elements /*: ElementDescriptor[] */,\n      ) {\n        var proto = F.prototype;\n\n        [\"method\", \"field\"].forEach(function(kind) {\n          elements.forEach(function(element /*: ElementDescriptor */) {\n            var placement = element.placement;\n            if (\n              element.kind === kind &&\n              (placement === \"static\" || placement === \"prototype\")\n            ) {\n              var receiver = placement === \"static\" ? F : proto;\n              this.defineClassElement(receiver, element);\n            }\n          }, this);\n        }, this);\n      },\n\n      // DefineClassElement\n      defineClassElement: function(\n        /*::<C>*/ receiver /*: C | Class<C> */,\n        element /*: ElementDescriptor */,\n      ) {\n        var descriptor /*: PropertyDescriptor */ = element.descriptor;\n        if (element.kind === \"field\") {\n          var initializer = element.initializer;\n          descriptor = {\n            enumerable: descriptor.enumerable,\n            writable: descriptor.writable,\n            configurable: descriptor.configurable,\n            value: initializer === void 0 ? void 0 : initializer.call(receiver),\n          };\n        }\n        Object.defineProperty(receiver, element.key, descriptor);\n      },\n\n      // DecorateClass\n      decorateClass: function(\n        elements /*: ElementDescriptor[] */,\n        decorators /*: ClassDecorator[] */,\n      ) /*: ElementsFinishers */ {\n        var newElements /*: ElementDescriptor[] */ = [];\n        var finishers /*: ClassFinisher[] */ = [];\n        var placements /*: Placements */ = {\n          static: [],\n          prototype: [],\n          own: [],\n        };\n\n        elements.forEach(function(element /*: ElementDescriptor */) {\n          this.addElementPlacement(element, placements);\n        }, this);\n\n        elements.forEach(function(element /*: ElementDescriptor */) {\n          if (!_hasDecorators(element)) return newElements.push(element);\n\n          var elementFinishersExtras /*: ElementFinishersExtras */ = this.decorateElement(\n            element,\n            placements,\n          );\n          newElements.push(elementFinishersExtras.element);\n          newElements.push.apply(newElements, elementFinishersExtras.extras);\n          finishers.push.apply(finishers, elementFinishersExtras.finishers);\n        }, this);\n\n        if (!decorators) {\n          return { elements: newElements, finishers: finishers };\n        }\n\n        var result /*: ElementsFinishers */ = this.decorateConstructor(\n          newElements,\n          decorators,\n        );\n        finishers.push.apply(finishers, result.finishers);\n        result.finishers = finishers;\n\n        return result;\n      },\n\n      // AddElementPlacement\n      addElementPlacement: function(\n        element /*: ElementDescriptor */,\n        placements /*: Placements */,\n        silent /*: boolean */,\n      ) {\n        var keys = placements[element.placement];\n        if (!silent && keys.indexOf(element.key) !== -1) {\n          throw new TypeError(\"Duplicated element (\" + element.key + \")\");\n        }\n        keys.push(element.key);\n      },\n\n      // DecorateElement\n      decorateElement: function(\n        element /*: ElementDescriptor */,\n        placements /*: Placements */,\n      ) /*: ElementFinishersExtras */ {\n        var extras /*: ElementDescriptor[] */ = [];\n        var finishers /*: ClassFinisher[] */ = [];\n\n        for (\n          var decorators = element.decorators, i = decorators.length - 1;\n          i >= 0;\n          i--\n        ) {\n          // (inlined) RemoveElementPlacement\n          var keys = placements[element.placement];\n          keys.splice(keys.indexOf(element.key), 1);\n\n          var elementObject /*: ElementObjectInput */ = this.fromElementDescriptor(\n            element,\n          );\n          var elementFinisherExtras /*: ElementFinisherExtras */ = this.toElementFinisherExtras(\n            (0, decorators[i])(elementObject) /*: ElementObjectOutput */ ||\n              elementObject,\n          );\n\n          element = elementFinisherExtras.element;\n          this.addElementPlacement(element, placements);\n\n          if (elementFinisherExtras.finisher) {\n            finishers.push(elementFinisherExtras.finisher);\n          }\n\n          var newExtras /*: ElementDescriptor[] | void */ =\n            elementFinisherExtras.extras;\n          if (newExtras) {\n            for (var j = 0; j < newExtras.length; j++) {\n              this.addElementPlacement(newExtras[j], placements);\n            }\n            extras.push.apply(extras, newExtras);\n          }\n        }\n\n        return { element: element, finishers: finishers, extras: extras };\n      },\n\n      // DecorateConstructor\n      decorateConstructor: function(\n        elements /*: ElementDescriptor[] */,\n        decorators /*: ClassDecorator[] */,\n      ) /*: ElementsFinishers */ {\n        var finishers /*: ClassFinisher[] */ = [];\n\n        for (var i = decorators.length - 1; i >= 0; i--) {\n          var obj /*: ClassObject */ = this.fromClassDescriptor(elements);\n          var elementsAndFinisher /*: ElementsFinisher */ = this.toClassDescriptor(\n            (0, decorators[i])(obj) /*: ClassObject */ || obj,\n          );\n\n          if (elementsAndFinisher.finisher !== undefined) {\n            finishers.push(elementsAndFinisher.finisher);\n          }\n\n          if (elementsAndFinisher.elements !== undefined) {\n            elements = elementsAndFinisher.elements;\n\n            for (var j = 0; j < elements.length - 1; j++) {\n              for (var k = j + 1; k < elements.length; k++) {\n                if (\n                  elements[j].key === elements[k].key &&\n                  elements[j].placement === elements[k].placement\n                ) {\n                  throw new TypeError(\n                    \"Duplicated element (\" + elements[j].key + \")\",\n                  );\n                }\n              }\n            }\n          }\n        }\n\n        return { elements: elements, finishers: finishers };\n      },\n\n      // FromElementDescriptor\n      fromElementDescriptor: function(\n        element /*: ElementDescriptor */,\n      ) /*: ElementObject */ {\n        var obj /*: ElementObject */ = {\n          kind: element.kind,\n          key: element.key,\n          placement: element.placement,\n          descriptor: element.descriptor,\n        };\n\n        var desc = {\n          value: \"Descriptor\",\n          configurable: true,\n        };\n        Object.defineProperty(obj, Symbol.toStringTag, desc);\n\n        if (element.kind === \"field\") obj.initializer = element.initializer;\n\n        return obj;\n      },\n\n      // ToElementDescriptors\n      toElementDescriptors: function(\n        elementObjects /*: ElementObject[] */,\n      ) /*: ElementDescriptor[] */ {\n        if (elementObjects === undefined) return;\n        return toArray(elementObjects).map(function(elementObject) {\n          var element = this.toElementDescriptor(elementObject);\n          this.disallowProperty(elementObject, \"finisher\", \"An element descriptor\");\n          this.disallowProperty(elementObject, \"extras\", \"An element descriptor\");\n          return element;\n        }, this);\n      },\n\n      // ToElementDescriptor\n      toElementDescriptor: function(\n        elementObject /*: ElementObject */,\n      ) /*: ElementDescriptor */ {\n        var kind = String(elementObject.kind);\n        if (kind !== \"method\" && kind !== \"field\") {\n          throw new TypeError(\n            'An element descriptor\\'s .kind property must be either \"method\" or' +\n              ' \"field\", but a decorator created an element descriptor with' +\n              ' .kind \"' +\n              kind +\n              '\"',\n          );\n        }\n\n        var key = toPropertyKey(elementObject.key);\n\n        var placement = String(elementObject.placement);\n        if (\n          placement !== \"static\" &&\n          placement !== \"prototype\" &&\n          placement !== \"own\"\n        ) {\n          throw new TypeError(\n            'An element descriptor\\'s .placement property must be one of \"static\",' +\n              ' \"prototype\" or \"own\", but a decorator created an element descriptor' +\n              ' with .placement \"' +\n              placement +\n              '\"',\n          );\n        }\n\n        var descriptor /*: PropertyDescriptor */ = elementObject.descriptor;\n\n        this.disallowProperty(elementObject, \"elements\", \"An element descriptor\");\n\n        var element /*: ElementDescriptor */ = {\n          kind: kind,\n          key: key,\n          placement: placement,\n          descriptor: Object.assign({}, descriptor),\n        };\n\n        if (kind !== \"field\") {\n          this.disallowProperty(elementObject, \"initializer\", \"A method descriptor\");\n        } else {\n          this.disallowProperty(\n            descriptor,\n            \"get\",\n            \"The property descriptor of a field descriptor\",\n          );\n          this.disallowProperty(\n            descriptor,\n            \"set\",\n            \"The property descriptor of a field descriptor\",\n          );\n          this.disallowProperty(\n            descriptor,\n            \"value\",\n            \"The property descriptor of a field descriptor\",\n          );\n\n          element.initializer = elementObject.initializer;\n        }\n\n        return element;\n      },\n\n      toElementFinisherExtras: function(\n        elementObject /*: ElementObject */,\n      ) /*: ElementFinisherExtras */ {\n        var element /*: ElementDescriptor */ = this.toElementDescriptor(\n          elementObject,\n        );\n        var finisher /*: ClassFinisher */ = _optionalCallableProperty(\n          elementObject,\n          \"finisher\",\n        );\n        var extras /*: ElementDescriptors[] */ = this.toElementDescriptors(\n          elementObject.extras,\n        );\n\n        return { element: element, finisher: finisher, extras: extras };\n      },\n\n      // FromClassDescriptor\n      fromClassDescriptor: function(\n        elements /*: ElementDescriptor[] */,\n      ) /*: ClassObject */ {\n        var obj = {\n          kind: \"class\",\n          elements: elements.map(this.fromElementDescriptor, this),\n        };\n\n        var desc = { value: \"Descriptor\", configurable: true };\n        Object.defineProperty(obj, Symbol.toStringTag, desc);\n\n        return obj;\n      },\n\n      // ToClassDescriptor\n      toClassDescriptor: function(\n        obj /*: ClassObject */,\n      ) /*: ElementsFinisher */ {\n        var kind = String(obj.kind);\n        if (kind !== \"class\") {\n          throw new TypeError(\n            'A class descriptor\\'s .kind property must be \"class\", but a decorator' +\n              ' created a class descriptor with .kind \"' +\n              kind +\n              '\"',\n          );\n        }\n\n        this.disallowProperty(obj, \"key\", \"A class descriptor\");\n        this.disallowProperty(obj, \"placement\", \"A class descriptor\");\n        this.disallowProperty(obj, \"descriptor\", \"A class descriptor\");\n        this.disallowProperty(obj, \"initializer\", \"A class descriptor\");\n        this.disallowProperty(obj, \"extras\", \"A class descriptor\");\n\n        var finisher = _optionalCallableProperty(obj, \"finisher\");\n        var elements = this.toElementDescriptors(obj.elements);\n\n        return { elements: elements, finisher: finisher };\n      },\n\n      // RunClassFinishers\n      runClassFinishers: function(\n        constructor /*: Class<*> */,\n        finishers /*: ClassFinisher[] */,\n      ) /*: Class<*> */ {\n        for (var i = 0; i < finishers.length; i++) {\n          var newConstructor /*: ?Class<*> */ = (0, finishers[i])(constructor);\n          if (newConstructor !== undefined) {\n            // NOTE: This should check if IsConstructor(newConstructor) is false.\n            if (typeof newConstructor !== \"function\") {\n              throw new TypeError(\"Finishers must return a constructor.\");\n            }\n            constructor = newConstructor;\n          }\n        }\n        return constructor;\n      },\n\n      disallowProperty: function(obj, name, objectType) {\n        if (obj[name] !== undefined) {\n          throw new TypeError(objectType + \" can't have a .\" + name + \" property.\");\n        }\n      }\n    };\n\n    return api;\n  }\n\n  // ClassElementEvaluation\n  function _createElementDescriptor(\n    def /*: ElementDefinition */,\n  ) /*: ElementDescriptor */ {\n    var key = toPropertyKey(def.key);\n\n    var descriptor /*: PropertyDescriptor */;\n    if (def.kind === \"method\") {\n      descriptor = {\n        value: def.value,\n        writable: true,\n        configurable: true,\n        enumerable: false,\n      };\n    } else if (def.kind === \"get\") {\n      descriptor = { get: def.value, configurable: true, enumerable: false };\n    } else if (def.kind === \"set\") {\n      descriptor = { set: def.value, configurable: true, enumerable: false };\n    } else if (def.kind === \"field\") {\n      descriptor = { configurable: true, writable: true, enumerable: true };\n    }\n\n    var element /*: ElementDescriptor */ = {\n      kind: def.kind === \"field\" ? \"field\" : \"method\",\n      key: key,\n      placement: def.static\n        ? \"static\"\n        : def.kind === \"field\"\n        ? \"own\"\n        : \"prototype\",\n      descriptor: descriptor,\n    };\n    if (def.decorators) element.decorators = def.decorators;\n    if (def.kind === \"field\") element.initializer = def.value;\n\n    return element;\n  }\n\n  // CoalesceGetterSetter\n  function _coalesceGetterSetter(\n    element /*: ElementDescriptor */,\n    other /*: ElementDescriptor */,\n  ) {\n    if (element.descriptor.get !== undefined) {\n      other.descriptor.get = element.descriptor.get;\n    } else {\n      other.descriptor.set = element.descriptor.set;\n    }\n  }\n\n  // CoalesceClassElements\n  function _coalesceClassElements(\n    elements /*: ElementDescriptor[] */,\n  ) /*: ElementDescriptor[] */ {\n    var newElements /*: ElementDescriptor[] */ = [];\n\n    var isSameElement = function(\n      other /*: ElementDescriptor */,\n    ) /*: boolean */ {\n      return (\n        other.kind === \"method\" &&\n        other.key === element.key &&\n        other.placement === element.placement\n      );\n    };\n\n    for (var i = 0; i < elements.length; i++) {\n      var element /*: ElementDescriptor */ = elements[i];\n      var other /*: ElementDescriptor */;\n\n      if (\n        element.kind === \"method\" &&\n        (other = newElements.find(isSameElement))\n      ) {\n        if (\n          _isDataDescriptor(element.descriptor) ||\n          _isDataDescriptor(other.descriptor)\n        ) {\n          if (_hasDecorators(element) || _hasDecorators(other)) {\n            throw new ReferenceError(\n              \"Duplicated methods (\" + element.key + \") can't be decorated.\",\n            );\n          }\n          other.descriptor = element.descriptor;\n        } else {\n          if (_hasDecorators(element)) {\n            if (_hasDecorators(other)) {\n              throw new ReferenceError(\n                \"Decorators can't be placed on different accessors with for \" +\n                  \"the same property (\" +\n                  element.key +\n                  \").\",\n              );\n            }\n            other.decorators = element.decorators;\n          }\n          _coalesceGetterSetter(element, other);\n        }\n      } else {\n        newElements.push(element);\n      }\n    }\n\n    return newElements;\n  }\n\n  function _hasDecorators(element /*: ElementDescriptor */) /*: boolean */ {\n    return element.decorators && element.decorators.length;\n  }\n\n  function _isDataDescriptor(desc /*: PropertyDescriptor */) /*: boolean */ {\n    return (\n      desc !== undefined &&\n      !(desc.value === undefined && desc.writable === undefined)\n    );\n  }\n\n  function _optionalCallableProperty /*::<T>*/(\n    obj /*: T */,\n    name /*: $Keys<T> */,\n  ) /*: ?Function */ {\n    var value = obj[name];\n    if (value !== undefined && typeof value !== \"function\") {\n      throw new TypeError(\"Expected '\" + name + \"' to be a function\");\n    }\n    return value;\n  }\n\n"], ["\n  import toArray from \"toArray\";\n  import toPropertyKey from \"toPropertyKey\";\n\n  // These comments are stripped by @babel/template\n  /*::\n  type PropertyDescriptor =\n    | {\n        value: any,\n        writable: boolean,\n        configurable: boolean,\n        enumerable: boolean,\n      }\n    | {\n        get?: () => any,\n        set?: (v: any) => void,\n        configurable: boolean,\n        enumerable: boolean,\n      };\n\n  type FieldDescriptor ={\n    writable: boolean,\n    configurable: boolean,\n    enumerable: boolean,\n  };\n\n  type Placement = \"static\" | \"prototype\" | \"own\";\n  type Key = string | symbol; // PrivateName is not supported yet.\n\n  type ElementDescriptor =\n    | {\n        kind: \"method\",\n        key: Key,\n        placement: Placement,\n        descriptor: PropertyDescriptor\n      }\n    | {\n        kind: \"field\",\n        key: Key,\n        placement: Placement,\n        descriptor: FieldDescriptor,\n        initializer?: () => any,\n      };\n\n  // This is exposed to the user code\n  type ElementObjectInput = ElementDescriptor & {\n    [@@toStringTag]?: \"Descriptor\"\n  };\n\n  // This is exposed to the user code\n  type ElementObjectOutput = ElementDescriptor & {\n    [@@toStringTag]?: \"Descriptor\"\n    extras?: ElementDescriptor[],\n    finisher?: ClassFinisher,\n  };\n\n  // This is exposed to the user code\n  type ClassObject = {\n    [@@toStringTag]?: \"Descriptor\",\n    kind: \"class\",\n    elements: ElementDescriptor[],\n  };\n\n  type ElementDecorator = (descriptor: ElementObjectInput) => ?ElementObjectOutput;\n  type ClassDecorator = (descriptor: ClassObject) => ?ClassObject;\n  type ClassFinisher = <A, B>(cl: Class<A>) => Class<B>;\n\n  // Only used by Babel in the transform output, not part of the spec.\n  type ElementDefinition =\n    | {\n        kind: \"method\",\n        value: any,\n        key: Key,\n        static?: boolean,\n        decorators?: ElementDecorator[],\n      }\n    | {\n        kind: \"field\",\n        value: () => any,\n        key: Key,\n        static?: boolean,\n        decorators?: ElementDecorator[],\n    };\n\n  declare function ClassFactory<C>(initialize: (instance: C) => void): {\n    F: Class<C>,\n    d: ElementDefinition[]\n  }\n\n  */\n\n  /*::\n  // Various combinations with/without extras and with one or many finishers\n\n  type ElementFinisherExtras = {\n    element: ElementDescriptor,\n    finisher?: ClassFinisher,\n    extras?: ElementDescriptor[],\n  };\n\n  type ElementFinishersExtras = {\n    element: ElementDescriptor,\n    finishers: ClassFinisher[],\n    extras: ElementDescriptor[],\n  };\n\n  type ElementsFinisher = {\n    elements: ElementDescriptor[],\n    finisher?: ClassFinisher,\n  };\n\n  type ElementsFinishers = {\n    elements: ElementDescriptor[],\n    finishers: ClassFinisher[],\n  };\n\n  */\n\n  /*::\n\n  type Placements = {\n    static: Key[],\n    prototype: Key[],\n    own: Key[],\n  };\n\n  */\n\n  // ClassDefinitionEvaluation (Steps 26-*)\n  export default function _decorate(\n    decorators /*: ClassDecorator[] */,\n    factory /*: ClassFactory */,\n    superClass /*: ?Class<*> */,\n    mixins /*: ?Array<Function> */,\n  ) /*: Class<*> */ {\n    var api = _getDecoratorsApi();\n    if (mixins) {\n      for (var i = 0; i < mixins.length; i++) {\n        api = mixins[i](api);\n      }\n    }\n\n    var r = factory(function initialize(O) {\n      api.initializeInstanceElements(O, decorated.elements);\n    }, superClass);\n    var decorated = api.decorateClass(\n      _coalesceClassElements(r.d.map(_createElementDescriptor)),\n      decorators,\n    );\n\n    api.initializeClassElements(r.F, decorated.elements);\n\n    return api.runClassFinishers(r.F, decorated.finishers);\n  }\n\n  function _getDecoratorsApi() {\n    _getDecoratorsApi = function() {\n      return api;\n    };\n\n    var api = {\n      elementsDefinitionOrder: [[\"method\"], [\"field\"]],\n\n      // InitializeInstanceElements\n      initializeInstanceElements: function(\n        /*::<C>*/ O /*: C */,\n        elements /*: ElementDescriptor[] */,\n      ) {\n        [\"method\", \"field\"].forEach(function(kind) {\n          elements.forEach(function(element /*: ElementDescriptor */) {\n            if (element.kind === kind && element.placement === \"own\") {\n              this.defineClassElement(O, element);\n            }\n          }, this);\n        }, this);\n      },\n\n      // InitializeClassElements\n      initializeClassElements: function(\n        /*::<C>*/ F /*: Class<C> */,\n        elements /*: ElementDescriptor[] */,\n      ) {\n        var proto = F.prototype;\n\n        [\"method\", \"field\"].forEach(function(kind) {\n          elements.forEach(function(element /*: ElementDescriptor */) {\n            var placement = element.placement;\n            if (\n              element.kind === kind &&\n              (placement === \"static\" || placement === \"prototype\")\n            ) {\n              var receiver = placement === \"static\" ? F : proto;\n              this.defineClassElement(receiver, element);\n            }\n          }, this);\n        }, this);\n      },\n\n      // DefineClassElement\n      defineClassElement: function(\n        /*::<C>*/ receiver /*: C | Class<C> */,\n        element /*: ElementDescriptor */,\n      ) {\n        var descriptor /*: PropertyDescriptor */ = element.descriptor;\n        if (element.kind === \"field\") {\n          var initializer = element.initializer;\n          descriptor = {\n            enumerable: descriptor.enumerable,\n            writable: descriptor.writable,\n            configurable: descriptor.configurable,\n            value: initializer === void 0 ? void 0 : initializer.call(receiver),\n          };\n        }\n        Object.defineProperty(receiver, element.key, descriptor);\n      },\n\n      // DecorateClass\n      decorateClass: function(\n        elements /*: ElementDescriptor[] */,\n        decorators /*: ClassDecorator[] */,\n      ) /*: ElementsFinishers */ {\n        var newElements /*: ElementDescriptor[] */ = [];\n        var finishers /*: ClassFinisher[] */ = [];\n        var placements /*: Placements */ = {\n          static: [],\n          prototype: [],\n          own: [],\n        };\n\n        elements.forEach(function(element /*: ElementDescriptor */) {\n          this.addElementPlacement(element, placements);\n        }, this);\n\n        elements.forEach(function(element /*: ElementDescriptor */) {\n          if (!_hasDecorators(element)) return newElements.push(element);\n\n          var elementFinishersExtras /*: ElementFinishersExtras */ = this.decorateElement(\n            element,\n            placements,\n          );\n          newElements.push(elementFinishersExtras.element);\n          newElements.push.apply(newElements, elementFinishersExtras.extras);\n          finishers.push.apply(finishers, elementFinishersExtras.finishers);\n        }, this);\n\n        if (!decorators) {\n          return { elements: newElements, finishers: finishers };\n        }\n\n        var result /*: ElementsFinishers */ = this.decorateConstructor(\n          newElements,\n          decorators,\n        );\n        finishers.push.apply(finishers, result.finishers);\n        result.finishers = finishers;\n\n        return result;\n      },\n\n      // AddElementPlacement\n      addElementPlacement: function(\n        element /*: ElementDescriptor */,\n        placements /*: Placements */,\n        silent /*: boolean */,\n      ) {\n        var keys = placements[element.placement];\n        if (!silent && keys.indexOf(element.key) !== -1) {\n          throw new TypeError(\"Duplicated element (\" + element.key + \")\");\n        }\n        keys.push(element.key);\n      },\n\n      // DecorateElement\n      decorateElement: function(\n        element /*: ElementDescriptor */,\n        placements /*: Placements */,\n      ) /*: ElementFinishersExtras */ {\n        var extras /*: ElementDescriptor[] */ = [];\n        var finishers /*: ClassFinisher[] */ = [];\n\n        for (\n          var decorators = element.decorators, i = decorators.length - 1;\n          i >= 0;\n          i--\n        ) {\n          // (inlined) RemoveElementPlacement\n          var keys = placements[element.placement];\n          keys.splice(keys.indexOf(element.key), 1);\n\n          var elementObject /*: ElementObjectInput */ = this.fromElementDescriptor(\n            element,\n          );\n          var elementFinisherExtras /*: ElementFinisherExtras */ = this.toElementFinisherExtras(\n            (0, decorators[i])(elementObject) /*: ElementObjectOutput */ ||\n              elementObject,\n          );\n\n          element = elementFinisherExtras.element;\n          this.addElementPlacement(element, placements);\n\n          if (elementFinisherExtras.finisher) {\n            finishers.push(elementFinisherExtras.finisher);\n          }\n\n          var newExtras /*: ElementDescriptor[] | void */ =\n            elementFinisherExtras.extras;\n          if (newExtras) {\n            for (var j = 0; j < newExtras.length; j++) {\n              this.addElementPlacement(newExtras[j], placements);\n            }\n            extras.push.apply(extras, newExtras);\n          }\n        }\n\n        return { element: element, finishers: finishers, extras: extras };\n      },\n\n      // DecorateConstructor\n      decorateConstructor: function(\n        elements /*: ElementDescriptor[] */,\n        decorators /*: ClassDecorator[] */,\n      ) /*: ElementsFinishers */ {\n        var finishers /*: ClassFinisher[] */ = [];\n\n        for (var i = decorators.length - 1; i >= 0; i--) {\n          var obj /*: ClassObject */ = this.fromClassDescriptor(elements);\n          var elementsAndFinisher /*: ElementsFinisher */ = this.toClassDescriptor(\n            (0, decorators[i])(obj) /*: ClassObject */ || obj,\n          );\n\n          if (elementsAndFinisher.finisher !== undefined) {\n            finishers.push(elementsAndFinisher.finisher);\n          }\n\n          if (elementsAndFinisher.elements !== undefined) {\n            elements = elementsAndFinisher.elements;\n\n            for (var j = 0; j < elements.length - 1; j++) {\n              for (var k = j + 1; k < elements.length; k++) {\n                if (\n                  elements[j].key === elements[k].key &&\n                  elements[j].placement === elements[k].placement\n                ) {\n                  throw new TypeError(\n                    \"Duplicated element (\" + elements[j].key + \")\",\n                  );\n                }\n              }\n            }\n          }\n        }\n\n        return { elements: elements, finishers: finishers };\n      },\n\n      // FromElementDescriptor\n      fromElementDescriptor: function(\n        element /*: ElementDescriptor */,\n      ) /*: ElementObject */ {\n        var obj /*: ElementObject */ = {\n          kind: element.kind,\n          key: element.key,\n          placement: element.placement,\n          descriptor: element.descriptor,\n        };\n\n        var desc = {\n          value: \"Descriptor\",\n          configurable: true,\n        };\n        Object.defineProperty(obj, Symbol.toStringTag, desc);\n\n        if (element.kind === \"field\") obj.initializer = element.initializer;\n\n        return obj;\n      },\n\n      // ToElementDescriptors\n      toElementDescriptors: function(\n        elementObjects /*: ElementObject[] */,\n      ) /*: ElementDescriptor[] */ {\n        if (elementObjects === undefined) return;\n        return toArray(elementObjects).map(function(elementObject) {\n          var element = this.toElementDescriptor(elementObject);\n          this.disallowProperty(elementObject, \"finisher\", \"An element descriptor\");\n          this.disallowProperty(elementObject, \"extras\", \"An element descriptor\");\n          return element;\n        }, this);\n      },\n\n      // ToElementDescriptor\n      toElementDescriptor: function(\n        elementObject /*: ElementObject */,\n      ) /*: ElementDescriptor */ {\n        var kind = String(elementObject.kind);\n        if (kind !== \"method\" && kind !== \"field\") {\n          throw new TypeError(\n            'An element descriptor\\\\'s .kind property must be either \"method\" or' +\n              ' \"field\", but a decorator created an element descriptor with' +\n              ' .kind \"' +\n              kind +\n              '\"',\n          );\n        }\n\n        var key = toPropertyKey(elementObject.key);\n\n        var placement = String(elementObject.placement);\n        if (\n          placement !== \"static\" &&\n          placement !== \"prototype\" &&\n          placement !== \"own\"\n        ) {\n          throw new TypeError(\n            'An element descriptor\\\\'s .placement property must be one of \"static\",' +\n              ' \"prototype\" or \"own\", but a decorator created an element descriptor' +\n              ' with .placement \"' +\n              placement +\n              '\"',\n          );\n        }\n\n        var descriptor /*: PropertyDescriptor */ = elementObject.descriptor;\n\n        this.disallowProperty(elementObject, \"elements\", \"An element descriptor\");\n\n        var element /*: ElementDescriptor */ = {\n          kind: kind,\n          key: key,\n          placement: placement,\n          descriptor: Object.assign({}, descriptor),\n        };\n\n        if (kind !== \"field\") {\n          this.disallowProperty(elementObject, \"initializer\", \"A method descriptor\");\n        } else {\n          this.disallowProperty(\n            descriptor,\n            \"get\",\n            \"The property descriptor of a field descriptor\",\n          );\n          this.disallowProperty(\n            descriptor,\n            \"set\",\n            \"The property descriptor of a field descriptor\",\n          );\n          this.disallowProperty(\n            descriptor,\n            \"value\",\n            \"The property descriptor of a field descriptor\",\n          );\n\n          element.initializer = elementObject.initializer;\n        }\n\n        return element;\n      },\n\n      toElementFinisherExtras: function(\n        elementObject /*: ElementObject */,\n      ) /*: ElementFinisherExtras */ {\n        var element /*: ElementDescriptor */ = this.toElementDescriptor(\n          elementObject,\n        );\n        var finisher /*: ClassFinisher */ = _optionalCallableProperty(\n          elementObject,\n          \"finisher\",\n        );\n        var extras /*: ElementDescriptors[] */ = this.toElementDescriptors(\n          elementObject.extras,\n        );\n\n        return { element: element, finisher: finisher, extras: extras };\n      },\n\n      // FromClassDescriptor\n      fromClassDescriptor: function(\n        elements /*: ElementDescriptor[] */,\n      ) /*: ClassObject */ {\n        var obj = {\n          kind: \"class\",\n          elements: elements.map(this.fromElementDescriptor, this),\n        };\n\n        var desc = { value: \"Descriptor\", configurable: true };\n        Object.defineProperty(obj, Symbol.toStringTag, desc);\n\n        return obj;\n      },\n\n      // ToClassDescriptor\n      toClassDescriptor: function(\n        obj /*: ClassObject */,\n      ) /*: ElementsFinisher */ {\n        var kind = String(obj.kind);\n        if (kind !== \"class\") {\n          throw new TypeError(\n            'A class descriptor\\\\'s .kind property must be \"class\", but a decorator' +\n              ' created a class descriptor with .kind \"' +\n              kind +\n              '\"',\n          );\n        }\n\n        this.disallowProperty(obj, \"key\", \"A class descriptor\");\n        this.disallowProperty(obj, \"placement\", \"A class descriptor\");\n        this.disallowProperty(obj, \"descriptor\", \"A class descriptor\");\n        this.disallowProperty(obj, \"initializer\", \"A class descriptor\");\n        this.disallowProperty(obj, \"extras\", \"A class descriptor\");\n\n        var finisher = _optionalCallableProperty(obj, \"finisher\");\n        var elements = this.toElementDescriptors(obj.elements);\n\n        return { elements: elements, finisher: finisher };\n      },\n\n      // RunClassFinishers\n      runClassFinishers: function(\n        constructor /*: Class<*> */,\n        finishers /*: ClassFinisher[] */,\n      ) /*: Class<*> */ {\n        for (var i = 0; i < finishers.length; i++) {\n          var newConstructor /*: ?Class<*> */ = (0, finishers[i])(constructor);\n          if (newConstructor !== undefined) {\n            // NOTE: This should check if IsConstructor(newConstructor) is false.\n            if (typeof newConstructor !== \"function\") {\n              throw new TypeError(\"Finishers must return a constructor.\");\n            }\n            constructor = newConstructor;\n          }\n        }\n        return constructor;\n      },\n\n      disallowProperty: function(obj, name, objectType) {\n        if (obj[name] !== undefined) {\n          throw new TypeError(objectType + \" can't have a .\" + name + \" property.\");\n        }\n      }\n    };\n\n    return api;\n  }\n\n  // ClassElementEvaluation\n  function _createElementDescriptor(\n    def /*: ElementDefinition */,\n  ) /*: ElementDescriptor */ {\n    var key = toPropertyKey(def.key);\n\n    var descriptor /*: PropertyDescriptor */;\n    if (def.kind === \"method\") {\n      descriptor = {\n        value: def.value,\n        writable: true,\n        configurable: true,\n        enumerable: false,\n      };\n    } else if (def.kind === \"get\") {\n      descriptor = { get: def.value, configurable: true, enumerable: false };\n    } else if (def.kind === \"set\") {\n      descriptor = { set: def.value, configurable: true, enumerable: false };\n    } else if (def.kind === \"field\") {\n      descriptor = { configurable: true, writable: true, enumerable: true };\n    }\n\n    var element /*: ElementDescriptor */ = {\n      kind: def.kind === \"field\" ? \"field\" : \"method\",\n      key: key,\n      placement: def.static\n        ? \"static\"\n        : def.kind === \"field\"\n        ? \"own\"\n        : \"prototype\",\n      descriptor: descriptor,\n    };\n    if (def.decorators) element.decorators = def.decorators;\n    if (def.kind === \"field\") element.initializer = def.value;\n\n    return element;\n  }\n\n  // CoalesceGetterSetter\n  function _coalesceGetterSetter(\n    element /*: ElementDescriptor */,\n    other /*: ElementDescriptor */,\n  ) {\n    if (element.descriptor.get !== undefined) {\n      other.descriptor.get = element.descriptor.get;\n    } else {\n      other.descriptor.set = element.descriptor.set;\n    }\n  }\n\n  // CoalesceClassElements\n  function _coalesceClassElements(\n    elements /*: ElementDescriptor[] */,\n  ) /*: ElementDescriptor[] */ {\n    var newElements /*: ElementDescriptor[] */ = [];\n\n    var isSameElement = function(\n      other /*: ElementDescriptor */,\n    ) /*: boolean */ {\n      return (\n        other.kind === \"method\" &&\n        other.key === element.key &&\n        other.placement === element.placement\n      );\n    };\n\n    for (var i = 0; i < elements.length; i++) {\n      var element /*: ElementDescriptor */ = elements[i];\n      var other /*: ElementDescriptor */;\n\n      if (\n        element.kind === \"method\" &&\n        (other = newElements.find(isSameElement))\n      ) {\n        if (\n          _isDataDescriptor(element.descriptor) ||\n          _isDataDescriptor(other.descriptor)\n        ) {\n          if (_hasDecorators(element) || _hasDecorators(other)) {\n            throw new ReferenceError(\n              \"Duplicated methods (\" + element.key + \") can't be decorated.\",\n            );\n          }\n          other.descriptor = element.descriptor;\n        } else {\n          if (_hasDecorators(element)) {\n            if (_hasDecorators(other)) {\n              throw new ReferenceError(\n                \"Decorators can't be placed on different accessors with for \" +\n                  \"the same property (\" +\n                  element.key +\n                  \").\",\n              );\n            }\n            other.decorators = element.decorators;\n          }\n          _coalesceGetterSetter(element, other);\n        }\n      } else {\n        newElements.push(element);\n      }\n    }\n\n    return newElements;\n  }\n\n  function _hasDecorators(element /*: ElementDescriptor */) /*: boolean */ {\n    return element.decorators && element.decorators.length;\n  }\n\n  function _isDataDescriptor(desc /*: PropertyDescriptor */) /*: boolean */ {\n    return (\n      desc !== undefined &&\n      !(desc.value === undefined && desc.writable === undefined)\n    );\n  }\n\n  function _optionalCallableProperty /*::<T>*/(\n    obj /*: T */,\n    name /*: $Keys<T> */,\n  ) /*: ?Function */ {\n    var value = obj[name];\n    if (value !== undefined && typeof value !== \"function\") {\n      throw new TypeError(\"Expected '\" + name + \"' to be a function\");\n    }\n    return value;\n  }\n\n"])));
		  helpers$3.classPrivateMethodGet = helper$2("7.1.6")(_templateObject72 || (_templateObject72 = _taggedTemplateLiteralLoose(["\n  import assertClassBrand from \"assertClassBrand\";\n  export default function _classPrivateMethodGet(receiver, privateSet, fn) {\n    assertClassBrand(privateSet, receiver);\n    return fn;\n  }\n"])));
		  helpers$3.checkPrivateRedeclaration = helper$2("7.14.1")(_templateObject73 || (_templateObject73 = _taggedTemplateLiteralLoose(["\n  export default function _checkPrivateRedeclaration(obj, privateCollection) {\n    if (privateCollection.has(obj)) {\n      throw new TypeError(\"Cannot initialize the same private elements twice on an object\");\n    }\n  }\n"])));
		  helpers$3.classPrivateFieldInitSpec = helper$2("7.14.1")(_templateObject74 || (_templateObject74 = _taggedTemplateLiteralLoose(["\n  import checkPrivateRedeclaration from \"checkPrivateRedeclaration\";\n\n  export default function _classPrivateFieldInitSpec(obj, privateMap, value) {\n    checkPrivateRedeclaration(obj, privateMap);\n    privateMap.set(obj, value);\n  }\n"])));
		  helpers$3.classPrivateMethodInitSpec = helper$2("7.14.1")(_templateObject75 || (_templateObject75 = _taggedTemplateLiteralLoose(["\n  import checkPrivateRedeclaration from \"checkPrivateRedeclaration\";\n\n  export default function _classPrivateMethodInitSpec(obj, privateSet) {\n    checkPrivateRedeclaration(obj, privateSet);\n    privateSet.add(obj);\n  }\n"])));
		  {
		    helpers$3.classPrivateMethodSet = helper$2("7.1.6")(_templateObject76 || (_templateObject76 = _taggedTemplateLiteralLoose(["\n    export default function _classPrivateMethodSet() {\n      throw new TypeError(\"attempted to reassign private method\");\n    }\n  "])));
		  }
		  helpers$3.identity = helper$2("7.17.0")(_templateObject77 || (_templateObject77 = _taggedTemplateLiteralLoose(["\n  export default function _identity(x) {\n    return x;\n  }\n"])));
		  helpers$3.nullishReceiverError = helper$2("7.22.6")(_templateObject78 || (_templateObject78 = _taggedTemplateLiteralLoose(["\n  export default function _nullishReceiverError(r) {\n    throw new TypeError(\"Cannot set property of null or undefined.\");\n  }\n"])));

		  var assignmentExpression$8 = assignmentExpression$d,
		    cloneNode$b = cloneNode$j,
		    expressionStatement$4 = expressionStatement$a,
		    file$1 = file$2,
		    identifier$a = identifier$j;
		  function makePath(path) {
		    var parts = [];
		    for (; path.parentPath; path = path.parentPath) {
		      parts.push(path.key);
		      if (path.inList) parts.push(path.listKey);
		    }
		    return parts.reverse().join(".");
		  }
		  var FileClass = undefined;
		  function getHelperMetadata(file) {
		    var globals = new Set();
		    var localBindingNames = new Set();
		    var dependencies = new Map();
		    var exportName;
		    var exportPath;
		    var exportBindingAssignments = [];
		    var importPaths = [];
		    var importBindingsReferences = [];
		    var dependencyVisitor = {
		      ImportDeclaration: function ImportDeclaration(child) {
		        var name = child.node.source.value;
		        if (!helpers$3[name]) {
		          throw child.buildCodeFrameError("Unknown helper " + name);
		        }
		        if (child.get("specifiers").length !== 1 || !child.get("specifiers.0").isImportDefaultSpecifier()) {
		          throw child.buildCodeFrameError("Helpers can only import a default value");
		        }
		        var bindingIdentifier = child.node.specifiers[0].local;
		        dependencies.set(bindingIdentifier, name);
		        importPaths.push(makePath(child));
		      },
		      ExportDefaultDeclaration: function ExportDefaultDeclaration(child) {
		        var decl = child.get("declaration");
		        if (!decl.isFunctionDeclaration() || !decl.node.id) {
		          throw decl.buildCodeFrameError("Helpers can only export named function declarations");
		        }
		        exportName = decl.node.id.name;
		        exportPath = makePath(child);
		      },
		      ExportAllDeclaration: function ExportAllDeclaration(child) {
		        throw child.buildCodeFrameError("Helpers can only export default");
		      },
		      ExportNamedDeclaration: function ExportNamedDeclaration(child) {
		        throw child.buildCodeFrameError("Helpers can only export default");
		      },
		      Statement: function Statement(child) {
		        if (child.isImportDeclaration() || child.isExportDeclaration()) return;
		        child.skip();
		      }
		    };
		    var referenceVisitor = {
		      Program: function Program(path) {
		        var bindings = path.scope.getAllBindings();
		        Object.keys(bindings).forEach(function (name) {
		          if (name === exportName) return;
		          if (dependencies.has(bindings[name].identifier)) return;
		          localBindingNames.add(name);
		        });
		      },
		      ReferencedIdentifier: function ReferencedIdentifier(child) {
		        var name = child.node.name;
		        var binding = child.scope.getBinding(name);
		        if (!binding) {
		          if (name !== "arguments" || child.scope.path.isProgram()) {
		            globals.add(name);
		          }
		        } else if (dependencies.has(binding.identifier)) {
		          importBindingsReferences.push(makePath(child));
		        }
		      },
		      AssignmentExpression: function AssignmentExpression(child) {
		        var left = child.get("left");
		        if (!(exportName in left.getBindingIdentifiers())) return;
		        if (!left.isIdentifier()) {
		          throw left.buildCodeFrameError("Only simple assignments to exports are allowed in helpers");
		        }
		        var binding = child.scope.getBinding(exportName);
		        if (binding != null && binding.scope.path.isProgram()) {
		          exportBindingAssignments.push(makePath(child));
		        }
		      }
		    };
		    traverse(file.ast, dependencyVisitor, file.scope);
		    traverse(file.ast, referenceVisitor, file.scope);
		    if (!exportPath) throw new Error("Helpers must have a default export.");
		    exportBindingAssignments.reverse();
		    return {
		      globals: Array.from(globals),
		      localBindingNames: Array.from(localBindingNames),
		      dependencies: dependencies,
		      exportBindingAssignments: exportBindingAssignments,
		      exportPath: exportPath,
		      exportName: exportName,
		      importBindingsReferences: importBindingsReferences,
		      importPaths: importPaths
		    };
		  }
		  function permuteHelperAST(file, metadata, id, localBindings, getDependency) {
		    if (localBindings && !id) {
		      throw new Error("Unexpected local bindings for module-based helpers.");
		    }
		    if (!id) return;
		    var localBindingNames = metadata.localBindingNames,
		      dependencies = metadata.dependencies,
		      exportBindingAssignments = metadata.exportBindingAssignments,
		      exportPath = metadata.exportPath,
		      exportName = metadata.exportName,
		      importBindingsReferences = metadata.importBindingsReferences,
		      importPaths = metadata.importPaths;
		    var dependenciesRefs = {};
		    dependencies.forEach(function (name, id) {
		      dependenciesRefs[id.name] = typeof getDependency === "function" && getDependency(name) || id;
		    });
		    var toRename = {};
		    var bindings = new Set(localBindings || []);
		    if (id.type === "Identifier") bindings.add(id.name);
		    localBindingNames.forEach(function (name) {
		      var newName = name;
		      while (bindings.has(newName)) newName = "_" + newName;
		      if (newName !== name) toRename[name] = newName;
		    });
		    if (id.type === "Identifier" && exportName !== id.name) {
		      toRename[exportName] = id.name;
		    }
		    var path = file.path;
		    var exp = path.get(exportPath);
		    var imps = importPaths.map(function (p) {
		      return path.get(p);
		    });
		    var impsBindingRefs = importBindingsReferences.map(function (p) {
		      return path.get(p);
		    });
		    var decl = exp.get("declaration");
		    if (id.type === "Identifier") {
		      exp.replaceWith(decl);
		    } else if (id.type === "MemberExpression") {
		      exportBindingAssignments.forEach(function (assignPath) {
		        var assign = path.get(assignPath);
		        assign.replaceWith(assignmentExpression$8("=", id, assign.node));
		      });
		      exp.replaceWith(decl);
		      path.pushContainer("body", expressionStatement$4(assignmentExpression$8("=", id, identifier$a(exportName))));
		    } else {
		      throw new Error("Unexpected helper format.");
		    }
		    Object.keys(toRename).forEach(function (name) {
		      path.scope.rename(name, toRename[name]);
		    });
		    for (var _iterator = _createForOfIteratorHelperLoose(imps), _step; !(_step = _iterator()).done;) {
		      var _path = _step.value;
		      _path.remove();
		    }
		    for (var _iterator2 = _createForOfIteratorHelperLoose(impsBindingRefs), _step2; !(_step2 = _iterator2()).done;) {
		      var _path2 = _step2.value;
		      var node = cloneNode$b(dependenciesRefs[_path2.node.name]);
		      _path2.replaceWith(node);
		    }
		  }
		  var helperData = Object.create(null);
		  function loadHelper(name) {
		    if (!helperData[name]) {
		      var helper = helpers$3[name];
		      if (!helper) {
		        throw Object.assign(new ReferenceError("Unknown helper " + name), {
		          code: "BABEL_HELPER_UNKNOWN",
		          helper: name
		        });
		      }
		      var fn = function fn() {
		        {
		          if (!FileClass) {
		            var fakeFile = {
		              ast: file$1(helper.ast()),
		              path: null
		            };
		            traverse(fakeFile.ast, {
		              Program: function Program(path) {
		                return (fakeFile.path = path).stop();
		              }
		            });
		            return fakeFile;
		          }
		        }
		        return new FileClass({
		          filename: "babel-helper://" + name
		        }, {
		          ast: file$1(helper.ast()),
		          code: "[internal Babel helper code]",
		          inputMap: null
		        });
		      };
		      var metadata = null;
		      helperData[name] = {
		        minVersion: helper.minVersion,
		        build: function build(getDependency, id, localBindings) {
		          var file = fn();
		          metadata || (metadata = getHelperMetadata(file));
		          permuteHelperAST(file, metadata, id, localBindings, getDependency);
		          return {
		            nodes: file.ast.program.body,
		            globals: metadata.globals
		          };
		        },
		        getDependencies: function getDependencies() {
		          metadata || (metadata = getHelperMetadata(fn()));
		          return Array.from(metadata.dependencies.values());
		        }
		      };
		    }
		    return helperData[name];
		  }
		  function get$1(name, getDependency, id, localBindings) {
		    return loadHelper(name).build(getDependency, id, localBindings);
		  }
		  function minVersion(name) {
		    return loadHelper(name).minVersion;
		  }
		  function getDependencies(name) {
		    return loadHelper(name).getDependencies();
		  }
		  function ensure(name, newFileClass) {
		    FileClass || (FileClass = newFileClass);
		    loadHelper(name);
		  }
		  var list = Object.keys(helpers$3).map(function (name) {
		    return name.replace(/^_/, "");
		  });

		  var inherits$1;
		  if (typeof Object.create === 'function'){
		    inherits$1 = function inherits(ctor, superCtor) {
		      // implementation from standard node.js 'util' module
		      ctor.super_ = superCtor;
		      ctor.prototype = Object.create(superCtor.prototype, {
		        constructor: {
		          value: ctor,
		          enumerable: false,
		          writable: true,
		          configurable: true
		        }
		      });
		    };
		  } else {
		    inherits$1 = function inherits(ctor, superCtor) {
		      ctor.super_ = superCtor;
		      var TempCtor = function () {};
		      TempCtor.prototype = superCtor.prototype;
		      ctor.prototype = new TempCtor();
		      ctor.prototype.constructor = ctor;
		    };
		  }
		  var inherits$2 = inherits$1;

		  var getOwnPropertyDescriptors = Object.getOwnPropertyDescriptors ||
		    function getOwnPropertyDescriptors(obj) {
		      var keys = Object.keys(obj);
		      var descriptors = {};
		      for (var i = 0; i < keys.length; i++) {
		        descriptors[keys[i]] = Object.getOwnPropertyDescriptor(obj, keys[i]);
		      }
		      return descriptors;
		    };

		  var formatRegExp = /%[sdj%]/g;
		  function format(f) {
		    if (!isString(f)) {
		      var objects = [];
		      for (var i = 0; i < arguments.length; i++) {
		        objects.push(inspect$1(arguments[i]));
		      }
		      return objects.join(' ');
		    }

		    var i = 1;
		    var args = arguments;
		    var len = args.length;
		    var str = String(f).replace(formatRegExp, function(x) {
		      if (x === '%%') return '%';
		      if (i >= len) return x;
		      switch (x) {
		        case '%s': return String(args[i++]);
		        case '%d': return Number(args[i++]);
		        case '%j':
		          try {
		            return JSON.stringify(args[i++]);
		          } catch (_) {
		            return '[Circular]';
		          }
		        default:
		          return x;
		      }
		    });
		    for (var x = args[i]; i < len; x = args[++i]) {
		      if (isNull(x) || !isObject(x)) {
		        str += ' ' + x;
		      } else {
		        str += ' ' + inspect$1(x);
		      }
		    }
		    return str;
		  }

		  // Mark that a method should not be used.
		  // Returns a modified function which warns once by default.
		  // If --no-deprecation is set, then it is a no-op.
		  function deprecate(fn, msg) {
		    // Allow for deprecating things in the process of starting up.
		    if (isUndefined(global$1.process)) {
		      return function() {
		        return deprecate(fn, msg).apply(this, arguments);
		      };
		    }

		    if (browser$1$1.noDeprecation === true) {
		      return fn;
		    }

		    var warned = false;
		    function deprecated() {
		      if (!warned) {
		        if (browser$1$1.throwDeprecation) {
		          throw new Error(msg);
		        } else if (browser$1$1.traceDeprecation) {
		          console.trace(msg);
		        } else {
		          console.error(msg);
		        }
		        warned = true;
		      }
		      return fn.apply(this, arguments);
		    }

		    return deprecated;
		  }

		  var debugs = {};
		  var debugEnviron;
		  function debuglog(set) {
		    if (isUndefined(debugEnviron))
		      debugEnviron = browser$1$1.env.NODE_DEBUG || '';
		    set = set.toUpperCase();
		    if (!debugs[set]) {
		      if (new RegExp('\\b' + set + '\\b', 'i').test(debugEnviron)) {
		        var pid = 0;
		        debugs[set] = function() {
		          var msg = format.apply(null, arguments);
		          console.error('%s %d: %s', set, pid, msg);
		        };
		      } else {
		        debugs[set] = function() {};
		      }
		    }
		    return debugs[set];
		  }

		  /**
		   * Echos the value of a value. Trys to print the value out
		   * in the best way possible given the different types.
		   *
		   * @param {Object} obj The object to print out.
		   * @param {Object} opts Optional options object that alters the output.
		   */
		  /* legacy: obj, showHidden, depth, colors*/
		  function inspect$1(obj, opts) {
		    // default options
		    var ctx = {
		      seen: [],
		      stylize: stylizeNoColor
		    };
		    // legacy...
		    if (arguments.length >= 3) ctx.depth = arguments[2];
		    if (arguments.length >= 4) ctx.colors = arguments[3];
		    if (isBoolean(opts)) {
		      // legacy...
		      ctx.showHidden = opts;
		    } else if (opts) {
		      // got an "options" object
		      _extend(ctx, opts);
		    }
		    // set default options
		    if (isUndefined(ctx.showHidden)) ctx.showHidden = false;
		    if (isUndefined(ctx.depth)) ctx.depth = 2;
		    if (isUndefined(ctx.colors)) ctx.colors = false;
		    if (isUndefined(ctx.customInspect)) ctx.customInspect = true;
		    if (ctx.colors) ctx.stylize = stylizeWithColor;
		    return formatValue(ctx, obj, ctx.depth);
		  }

		  // http://en.wikipedia.org/wiki/ANSI_escape_code#graphics
		  inspect$1.colors = {
		    'bold' : [1, 22],
		    'italic' : [3, 23],
		    'underline' : [4, 24],
		    'inverse' : [7, 27],
		    'white' : [37, 39],
		    'grey' : [90, 39],
		    'black' : [30, 39],
		    'blue' : [34, 39],
		    'cyan' : [36, 39],
		    'green' : [32, 39],
		    'magenta' : [35, 39],
		    'red' : [31, 39],
		    'yellow' : [33, 39]
		  };

		  // Don't use 'blue' not visible on cmd.exe
		  inspect$1.styles = {
		    'special': 'cyan',
		    'number': 'yellow',
		    'boolean': 'yellow',
		    'undefined': 'grey',
		    'null': 'bold',
		    'string': 'green',
		    'date': 'magenta',
		    // "name": intentionally not styling
		    'regexp': 'red'
		  };


		  function stylizeWithColor(str, styleType) {
		    var style = inspect$1.styles[styleType];

		    if (style) {
		      return '\u001b[' + inspect$1.colors[style][0] + 'm' + str +
		             '\u001b[' + inspect$1.colors[style][1] + 'm';
		    } else {
		      return str;
		    }
		  }


		  function stylizeNoColor(str, styleType) {
		    return str;
		  }


		  function arrayToHash(array) {
		    var hash = {};

		    array.forEach(function(val, idx) {
		      hash[val] = true;
		    });

		    return hash;
		  }


		  function formatValue(ctx, value, recurseTimes) {
		    // Provide a hook for user-specified inspect functions.
		    // Check that value is an object with an inspect function on it
		    if (ctx.customInspect &&
		        value &&
		        isFunction(value.inspect) &&
		        // Filter out the util module, it's inspect function is special
		        value.inspect !== inspect$1 &&
		        // Also filter out any prototype objects using the circular check.
		        !(value.constructor && value.constructor.prototype === value)) {
		      var ret = value.inspect(recurseTimes, ctx);
		      if (!isString(ret)) {
		        ret = formatValue(ctx, ret, recurseTimes);
		      }
		      return ret;
		    }

		    // Primitive types cannot have properties
		    var primitive = formatPrimitive(ctx, value);
		    if (primitive) {
		      return primitive;
		    }

		    // Look up the keys of the object.
		    var keys = Object.keys(value);
		    var visibleKeys = arrayToHash(keys);

		    if (ctx.showHidden) {
		      keys = Object.getOwnPropertyNames(value);
		    }

		    // IE doesn't make error fields non-enumerable
		    // http://msdn.microsoft.com/en-us/library/ie/dww52sbt(v=vs.94).aspx
		    if (isError(value)
		        && (keys.indexOf('message') >= 0 || keys.indexOf('description') >= 0)) {
		      return formatError(value);
		    }

		    // Some type of object without properties can be shortcutted.
		    if (keys.length === 0) {
		      if (isFunction(value)) {
		        var name = value.name ? ': ' + value.name : '';
		        return ctx.stylize('[Function' + name + ']', 'special');
		      }
		      if (isRegExp(value)) {
		        return ctx.stylize(RegExp.prototype.toString.call(value), 'regexp');
		      }
		      if (isDate(value)) {
		        return ctx.stylize(Date.prototype.toString.call(value), 'date');
		      }
		      if (isError(value)) {
		        return formatError(value);
		      }
		    }

		    var base = '', array = false, braces = ['{', '}'];

		    // Make Array say that they are Array
		    if (isArray$1(value)) {
		      array = true;
		      braces = ['[', ']'];
		    }

		    // Make functions say that they are functions
		    if (isFunction(value)) {
		      var n = value.name ? ': ' + value.name : '';
		      base = ' [Function' + n + ']';
		    }

		    // Make RegExps say that they are RegExps
		    if (isRegExp(value)) {
		      base = ' ' + RegExp.prototype.toString.call(value);
		    }

		    // Make dates with properties first say the date
		    if (isDate(value)) {
		      base = ' ' + Date.prototype.toUTCString.call(value);
		    }

		    // Make error with message first say the error
		    if (isError(value)) {
		      base = ' ' + formatError(value);
		    }

		    if (keys.length === 0 && (!array || value.length == 0)) {
		      return braces[0] + base + braces[1];
		    }

		    if (recurseTimes < 0) {
		      if (isRegExp(value)) {
		        return ctx.stylize(RegExp.prototype.toString.call(value), 'regexp');
		      } else {
		        return ctx.stylize('[Object]', 'special');
		      }
		    }

		    ctx.seen.push(value);

		    var output;
		    if (array) {
		      output = formatArray(ctx, value, recurseTimes, visibleKeys, keys);
		    } else {
		      output = keys.map(function(key) {
		        return formatProperty(ctx, value, recurseTimes, visibleKeys, key, array);
		      });
		    }

		    ctx.seen.pop();

		    return reduceToSingleString(output, base, braces);
		  }


		  function formatPrimitive(ctx, value) {
		    if (isUndefined(value))
		      return ctx.stylize('undefined', 'undefined');
		    if (isString(value)) {
		      var simple = '\'' + JSON.stringify(value).replace(/^"|"$/g, '')
		                                               .replace(/'/g, "\\'")
		                                               .replace(/\\"/g, '"') + '\'';
		      return ctx.stylize(simple, 'string');
		    }
		    if (isNumber(value))
		      return ctx.stylize('' + value, 'number');
		    if (isBoolean(value))
		      return ctx.stylize('' + value, 'boolean');
		    // For some reason typeof null is "object", so special case here.
		    if (isNull(value))
		      return ctx.stylize('null', 'null');
		  }


		  function formatError(value) {
		    return '[' + Error.prototype.toString.call(value) + ']';
		  }


		  function formatArray(ctx, value, recurseTimes, visibleKeys, keys) {
		    var output = [];
		    for (var i = 0, l = value.length; i < l; ++i) {
		      if (hasOwnProperty$1(value, String(i))) {
		        output.push(formatProperty(ctx, value, recurseTimes, visibleKeys,
		            String(i), true));
		      } else {
		        output.push('');
		      }
		    }
		    keys.forEach(function(key) {
		      if (!key.match(/^\d+$/)) {
		        output.push(formatProperty(ctx, value, recurseTimes, visibleKeys,
		            key, true));
		      }
		    });
		    return output;
		  }


		  function formatProperty(ctx, value, recurseTimes, visibleKeys, key, array) {
		    var name, str, desc;
		    desc = Object.getOwnPropertyDescriptor(value, key) || { value: value[key] };
		    if (desc.get) {
		      if (desc.set) {
		        str = ctx.stylize('[Getter/Setter]', 'special');
		      } else {
		        str = ctx.stylize('[Getter]', 'special');
		      }
		    } else {
		      if (desc.set) {
		        str = ctx.stylize('[Setter]', 'special');
		      }
		    }
		    if (!hasOwnProperty$1(visibleKeys, key)) {
		      name = '[' + key + ']';
		    }
		    if (!str) {
		      if (ctx.seen.indexOf(desc.value) < 0) {
		        if (isNull(recurseTimes)) {
		          str = formatValue(ctx, desc.value, null);
		        } else {
		          str = formatValue(ctx, desc.value, recurseTimes - 1);
		        }
		        if (str.indexOf('\n') > -1) {
		          if (array) {
		            str = str.split('\n').map(function(line) {
		              return '  ' + line;
		            }).join('\n').substr(2);
		          } else {
		            str = '\n' + str.split('\n').map(function(line) {
		              return '   ' + line;
		            }).join('\n');
		          }
		        }
		      } else {
		        str = ctx.stylize('[Circular]', 'special');
		      }
		    }
		    if (isUndefined(name)) {
		      if (array && key.match(/^\d+$/)) {
		        return str;
		      }
		      name = JSON.stringify('' + key);
		      if (name.match(/^"([a-zA-Z_][a-zA-Z_0-9]*)"$/)) {
		        name = name.substr(1, name.length - 2);
		        name = ctx.stylize(name, 'name');
		      } else {
		        name = name.replace(/'/g, "\\'")
		                   .replace(/\\"/g, '"')
		                   .replace(/(^"|"$)/g, "'");
		        name = ctx.stylize(name, 'string');
		      }
		    }

		    return name + ': ' + str;
		  }


		  function reduceToSingleString(output, base, braces) {
		    var length = output.reduce(function(prev, cur) {
		      if (cur.indexOf('\n') >= 0) ;
		      return prev + cur.replace(/\u001b\[\d\d?m/g, '').length + 1;
		    }, 0);

		    if (length > 60) {
		      return braces[0] +
		             (base === '' ? '' : base + '\n ') +
		             ' ' +
		             output.join(',\n  ') +
		             ' ' +
		             braces[1];
		    }

		    return braces[0] + base + ' ' + output.join(', ') + ' ' + braces[1];
		  }


		  // NOTE: These type checking functions intentionally don't use `instanceof`
		  // because it is fragile and can be easily faked with `Object.create()`.
		  function isArray$1(ar) {
		    return Array.isArray(ar);
		  }

		  function isBoolean(arg) {
		    return typeof arg === 'boolean';
		  }

		  function isNull(arg) {
		    return arg === null;
		  }

		  function isNullOrUndefined(arg) {
		    return arg == null;
		  }

		  function isNumber(arg) {
		    return typeof arg === 'number';
		  }

		  function isString(arg) {
		    return typeof arg === 'string';
		  }

		  function isSymbol(arg) {
		    return typeof arg === 'symbol';
		  }

		  function isUndefined(arg) {
		    return arg === void 0;
		  }

		  function isRegExp(re) {
		    return isObject(re) && objectToString(re) === '[object RegExp]';
		  }

		  function isObject(arg) {
		    return typeof arg === 'object' && arg !== null;
		  }

		  function isDate(d) {
		    return isObject(d) && objectToString(d) === '[object Date]';
		  }

		  function isError(e) {
		    return isObject(e) &&
		        (objectToString(e) === '[object Error]' || e instanceof Error);
		  }

		  function isFunction(arg) {
		    return typeof arg === 'function';
		  }

		  function isPrimitive(arg) {
		    return arg === null ||
		           typeof arg === 'boolean' ||
		           typeof arg === 'number' ||
		           typeof arg === 'string' ||
		           typeof arg === 'symbol' ||  // ES6 symbol
		           typeof arg === 'undefined';
		  }

		  function isBuffer(maybeBuf) {
		    return Buffer$1.isBuffer(maybeBuf);
		  }

		  function objectToString(o) {
		    return Object.prototype.toString.call(o);
		  }


		  function pad(n) {
		    return n < 10 ? '0' + n.toString(10) : n.toString(10);
		  }


		  var months = ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep',
		                'Oct', 'Nov', 'Dec'];

		  // 26 Feb 16:19:34
		  function timestamp() {
		    var d = new Date();
		    var time = [pad(d.getHours()),
		                pad(d.getMinutes()),
		                pad(d.getSeconds())].join(':');
		    return [d.getDate(), months[d.getMonth()], time].join(' ');
		  }


		  // log is just a thin wrapper to console.log that prepends a timestamp
		  function log() {
		    console.log('%s - %s', timestamp(), format.apply(null, arguments));
		  }

		  function _extend(origin, add) {
		    // Don't do anything if add isn't an object
		    if (!add || !isObject(add)) return origin;

		    var keys = Object.keys(add);
		    var i = keys.length;
		    while (i--) {
		      origin[keys[i]] = add[keys[i]];
		    }
		    return origin;
		  }
		  function hasOwnProperty$1(obj, prop) {
		    return Object.prototype.hasOwnProperty.call(obj, prop);
		  }

		  var kCustomPromisifiedSymbol = typeof Symbol !== 'undefined' ? Symbol('util.promisify.custom') : undefined;

		  function promisify(original) {
		    if (typeof original !== 'function')
		      throw new TypeError('The "original" argument must be of type Function');

		    if (kCustomPromisifiedSymbol && original[kCustomPromisifiedSymbol]) {
		      var fn = original[kCustomPromisifiedSymbol];
		      if (typeof fn !== 'function') {
		        throw new TypeError('The "util.promisify.custom" argument must be of type Function');
		      }
		      Object.defineProperty(fn, kCustomPromisifiedSymbol, {
		        value: fn, enumerable: false, writable: false, configurable: true
		      });
		      return fn;
		    }

		    function fn() {
		      var promiseResolve, promiseReject;
		      var promise = new Promise(function (resolve, reject) {
		        promiseResolve = resolve;
		        promiseReject = reject;
		      });

		      var args = [];
		      for (var i = 0; i < arguments.length; i++) {
		        args.push(arguments[i]);
		      }
		      args.push(function (err, value) {
		        if (err) {
		          promiseReject(err);
		        } else {
		          promiseResolve(value);
		        }
		      });

		      try {
		        original.apply(this, args);
		      } catch (err) {
		        promiseReject(err);
		      }

		      return promise;
		    }

		    Object.setPrototypeOf(fn, Object.getPrototypeOf(original));

		    if (kCustomPromisifiedSymbol) Object.defineProperty(fn, kCustomPromisifiedSymbol, {
		      value: fn, enumerable: false, writable: false, configurable: true
		    });
		    return Object.defineProperties(
		      fn,
		      getOwnPropertyDescriptors(original)
		    );
		  }

		  promisify.custom = kCustomPromisifiedSymbol;

		  function callbackifyOnRejected(reason, cb) {
		    // `!reason` guard inspired by bluebird (Ref: https://goo.gl/t5IS6M).
		    // Because `null` is a special error value in callbacks which means "no error
		    // occurred", we error-wrap so the callback consumer can distinguish between
		    // "the promise rejected with null" or "the promise fulfilled with undefined".
		    if (!reason) {
		      var newReason = new Error('Promise was rejected with a falsy value');
		      newReason.reason = reason;
		      reason = newReason;
		    }
		    return cb(reason);
		  }

		  function callbackify(original) {
		    if (typeof original !== 'function') {
		      throw new TypeError('The "original" argument must be of type Function');
		    }

		    // We DO NOT return the promise as it gives the user a false sense that
		    // the promise is actually somehow related to the callback's execution
		    // and that the callback throwing will reject the promise.
		    function callbackified() {
		      var args = [];
		      for (var i = 0; i < arguments.length; i++) {
		        args.push(arguments[i]);
		      }

		      var maybeCb = args.pop();
		      if (typeof maybeCb !== 'function') {
		        throw new TypeError('The last argument must be of type Function');
		      }
		      var self = this;
		      var cb = function() {
		        return maybeCb.apply(self, arguments);
		      };
		      // In true node style we process the callback on `nextTick` with all the
		      // implications (stack, `uncaughtException`, `async_hooks`)
		      original.apply(this, args)
		        .then(function(ret) { browser$1$1.nextTick(cb.bind(null, null, ret)); },
		          function(rej) { browser$1$1.nextTick(callbackifyOnRejected.bind(null, rej, cb)); });
		    }

		    Object.setPrototypeOf(callbackified, Object.getPrototypeOf(original));
		    Object.defineProperties(callbackified, getOwnPropertyDescriptors(original));
		    return callbackified;
		  }

		  var _polyfillNode_util = {
		    inherits: inherits$2,
		    _extend: _extend,
		    log: log,
		    isBuffer: isBuffer,
		    isPrimitive: isPrimitive,
		    isFunction: isFunction,
		    isError: isError,
		    isDate: isDate,
		    isObject: isObject,
		    isRegExp: isRegExp,
		    isUndefined: isUndefined,
		    isSymbol: isSymbol,
		    isString: isString,
		    isNumber: isNumber,
		    isNullOrUndefined: isNullOrUndefined,
		    isNull: isNull,
		    isBoolean: isBoolean,
		    isArray: isArray$1,
		    inspect: inspect$1,
		    deprecate: deprecate,
		    format: format,
		    debuglog: debuglog,
		    promisify: promisify,
		    callbackify: callbackify,
		  };

		  var _polyfillNode_util$1 = /*#__PURE__*/Object.freeze({
		    __proto__: null,
		    _extend: _extend,
		    callbackify: callbackify,
		    debuglog: debuglog,
		    default: _polyfillNode_util,
		    deprecate: deprecate,
		    format: format,
		    inherits: inherits$2,
		    inspect: inspect$1,
		    isArray: isArray$1,
		    isBoolean: isBoolean,
		    isBuffer: isBuffer,
		    isDate: isDate,
		    isError: isError,
		    isFunction: isFunction,
		    isNull: isNull,
		    isNullOrUndefined: isNullOrUndefined,
		    isNumber: isNumber,
		    isObject: isObject,
		    isPrimitive: isPrimitive,
		    isRegExp: isRegExp,
		    isString: isString,
		    isSymbol: isSymbol,
		    isUndefined: isUndefined,
		    log: log,
		    promisify: promisify
		  });

		  function compare$3(a, b) {
		    if (a === b) {
		      return 0;
		    }

		    var x = a.length;
		    var y = b.length;

		    for (var i = 0, len = Math.min(x, y); i < len; ++i) {
		      if (a[i] !== b[i]) {
		        x = a[i];
		        y = b[i];
		        break;
		      }
		    }

		    if (x < y) {
		      return -1;
		    }
		    if (y < x) {
		      return 1;
		    }
		    return 0;
		  }
		  var hasOwn = Object.prototype.hasOwnProperty;

		  var objectKeys = Object.keys || function (obj) {
		    var keys = [];
		    for (var key in obj) {
		      if (hasOwn.call(obj, key)) keys.push(key);
		    }
		    return keys;
		  };
		  var pSlice = Array.prototype.slice;
		  var _functionsHaveNames;
		  function functionsHaveNames() {
		    if (typeof _functionsHaveNames !== 'undefined') {
		      return _functionsHaveNames;
		    }
		    return _functionsHaveNames = (function () {
		      return function foo() {}.name === 'foo';
		    }());
		  }
		  function pToString (obj) {
		    return Object.prototype.toString.call(obj);
		  }
		  function isView(arrbuf) {
		    if (isBuffer$1(arrbuf)) {
		      return false;
		    }
		    if (typeof global$1.ArrayBuffer !== 'function') {
		      return false;
		    }
		    if (typeof ArrayBuffer.isView === 'function') {
		      return ArrayBuffer.isView(arrbuf);
		    }
		    if (!arrbuf) {
		      return false;
		    }
		    if (arrbuf instanceof DataView) {
		      return true;
		    }
		    if (arrbuf.buffer && arrbuf.buffer instanceof ArrayBuffer) {
		      return true;
		    }
		    return false;
		  }
		  // 1. The assert module provides functions that throw
		  // AssertionError's when particular conditions are not met. The
		  // assert module must conform to the following interface.

		  function assert(value, message) {
		    if (!value) fail(value, true, message, '==', ok);
		  }

		  // 2. The AssertionError is defined in assert.
		  // new assert.AssertionError({ message: message,
		  //                             actual: actual,
		  //                             expected: expected })

		  var regex = /\s*function\s+([^\(\s]*)\s*/;
		  // based on https://github.com/ljharb/function.prototype.name/blob/adeeeec8bfcc6068b187d7d9fb3d5bb1d3a30899/implementation.js
		  function getName$1(func) {
		    if (!isFunction(func)) {
		      return;
		    }
		    if (functionsHaveNames()) {
		      return func.name;
		    }
		    var str = func.toString();
		    var match = str.match(regex);
		    return match && match[1];
		  }
		  assert.AssertionError = AssertionError;
		  function AssertionError(options) {
		    this.name = 'AssertionError';
		    this.actual = options.actual;
		    this.expected = options.expected;
		    this.operator = options.operator;
		    if (options.message) {
		      this.message = options.message;
		      this.generatedMessage = false;
		    } else {
		      this.message = getMessage(this);
		      this.generatedMessage = true;
		    }
		    var stackStartFunction = options.stackStartFunction || fail;
		    if (Error.captureStackTrace) {
		      Error.captureStackTrace(this, stackStartFunction);
		    } else {
		      // non v8 browsers so we can have a stacktrace
		      var err = new Error();
		      if (err.stack) {
		        var out = err.stack;

		        // try to strip useless frames
		        var fn_name = getName$1(stackStartFunction);
		        var idx = out.indexOf('\n' + fn_name);
		        if (idx >= 0) {
		          // once we have located the function frame
		          // we need to strip out everything before it (and its line)
		          var next_line = out.indexOf('\n', idx + 1);
		          out = out.substring(next_line + 1);
		        }

		        this.stack = out;
		      }
		    }
		  }

		  // assert.AssertionError instanceof Error
		  inherits$2(AssertionError, Error);

		  function truncate(s, n) {
		    if (typeof s === 'string') {
		      return s.length < n ? s : s.slice(0, n);
		    } else {
		      return s;
		    }
		  }
		  function inspect(something) {
		    if (functionsHaveNames() || !isFunction(something)) {
		      return inspect$1(something);
		    }
		    var rawname = getName$1(something);
		    var name = rawname ? ': ' + rawname : '';
		    return '[Function' +  name + ']';
		  }
		  function getMessage(self) {
		    return truncate(inspect(self.actual), 128) + ' ' +
		           self.operator + ' ' +
		           truncate(inspect(self.expected), 128);
		  }

		  // At present only the three keys mentioned above are used and
		  // understood by the spec. Implementations or sub modules can pass
		  // other keys to the AssertionError's constructor - they will be
		  // ignored.

		  // 3. All of the following functions must throw an AssertionError
		  // when a corresponding condition is not met, with a message that
		  // may be undefined if not provided.  All assertion methods provide
		  // both the actual and expected values to the assertion error for
		  // display purposes.

		  function fail(actual, expected, message, operator, stackStartFunction) {
		    throw new AssertionError({
		      message: message,
		      actual: actual,
		      expected: expected,
		      operator: operator,
		      stackStartFunction: stackStartFunction
		    });
		  }

		  // EXTENSION! allows for well behaved errors defined elsewhere.
		  assert.fail = fail;

		  // 4. Pure assertion tests whether a value is truthy, as determined
		  // by !!guard.
		  // assert.ok(guard, message_opt);
		  // This statement is equivalent to assert.equal(true, !!guard,
		  // message_opt);. To test strictly for the value true, use
		  // assert.strictEqual(true, guard, message_opt);.

		  function ok(value, message) {
		    if (!value) fail(value, true, message, '==', ok);
		  }
		  assert.ok = ok;

		  // 5. The equality assertion tests shallow, coercive equality with
		  // ==.
		  // assert.equal(actual, expected, message_opt);
		  assert.equal = equal;
		  function equal(actual, expected, message) {
		    if (actual != expected) fail(actual, expected, message, '==', equal);
		  }

		  // 6. The non-equality assertion tests for whether two objects are not equal
		  // with != assert.notEqual(actual, expected, message_opt);
		  assert.notEqual = notEqual;
		  function notEqual(actual, expected, message) {
		    if (actual == expected) {
		      fail(actual, expected, message, '!=', notEqual);
		    }
		  }

		  // 7. The equivalence assertion tests a deep equality relation.
		  // assert.deepEqual(actual, expected, message_opt);
		  assert.deepEqual = deepEqual;
		  function deepEqual(actual, expected, message) {
		    if (!_deepEqual(actual, expected, false)) {
		      fail(actual, expected, message, 'deepEqual', deepEqual);
		    }
		  }
		  assert.deepStrictEqual = deepStrictEqual;
		  function deepStrictEqual(actual, expected, message) {
		    if (!_deepEqual(actual, expected, true)) {
		      fail(actual, expected, message, 'deepStrictEqual', deepStrictEqual);
		    }
		  }

		  function _deepEqual(actual, expected, strict, memos) {
		    // 7.1. All identical values are equivalent, as determined by ===.
		    if (actual === expected) {
		      return true;
		    } else if (isBuffer$1(actual) && isBuffer$1(expected)) {
		      return compare$3(actual, expected) === 0;

		    // 7.2. If the expected value is a Date object, the actual value is
		    // equivalent if it is also a Date object that refers to the same time.
		    } else if (isDate(actual) && isDate(expected)) {
		      return actual.getTime() === expected.getTime();

		    // 7.3 If the expected value is a RegExp object, the actual value is
		    // equivalent if it is also a RegExp object with the same source and
		    // properties (`global`, `multiline`, `lastIndex`, `ignoreCase`).
		    } else if (isRegExp(actual) && isRegExp(expected)) {
		      return actual.source === expected.source &&
		             actual.global === expected.global &&
		             actual.multiline === expected.multiline &&
		             actual.lastIndex === expected.lastIndex &&
		             actual.ignoreCase === expected.ignoreCase;

		    // 7.4. Other pairs that do not both pass typeof value == 'object',
		    // equivalence is determined by ==.
		    } else if ((actual === null || typeof actual !== 'object') &&
		               (expected === null || typeof expected !== 'object')) {
		      return strict ? actual === expected : actual == expected;

		    // If both values are instances of typed arrays, wrap their underlying
		    // ArrayBuffers in a Buffer each to increase performance
		    // This optimization requires the arrays to have the same type as checked by
		    // Object.prototype.toString (aka pToString). Never perform binary
		    // comparisons for Float*Arrays, though, since e.g. +0 === -0 but their
		    // bit patterns are not identical.
		    } else if (isView(actual) && isView(expected) &&
		               pToString(actual) === pToString(expected) &&
		               !(actual instanceof Float32Array ||
		                 actual instanceof Float64Array)) {
		      return compare$3(new Uint8Array(actual.buffer),
		                     new Uint8Array(expected.buffer)) === 0;

		    // 7.5 For all other Object pairs, including Array objects, equivalence is
		    // determined by having the same number of owned properties (as verified
		    // with Object.prototype.hasOwnProperty.call), the same set of keys
		    // (although not necessarily the same order), equivalent values for every
		    // corresponding key, and an identical 'prototype' property. Note: this
		    // accounts for both named and indexed properties on Arrays.
		    } else if (isBuffer$1(actual) !== isBuffer$1(expected)) {
		      return false;
		    } else {
		      memos = memos || {actual: [], expected: []};

		      var actualIndex = memos.actual.indexOf(actual);
		      if (actualIndex !== -1) {
		        if (actualIndex === memos.expected.indexOf(expected)) {
		          return true;
		        }
		      }

		      memos.actual.push(actual);
		      memos.expected.push(expected);

		      return objEquiv(actual, expected, strict, memos);
		    }
		  }

		  function isArguments(object) {
		    return Object.prototype.toString.call(object) == '[object Arguments]';
		  }

		  function objEquiv(a, b, strict, actualVisitedObjects) {
		    if (a === null || a === undefined || b === null || b === undefined)
		      return false;
		    // if one is a primitive, the other must be same
		    if (isPrimitive(a) || isPrimitive(b))
		      return a === b;
		    if (strict && Object.getPrototypeOf(a) !== Object.getPrototypeOf(b))
		      return false;
		    var aIsArgs = isArguments(a);
		    var bIsArgs = isArguments(b);
		    if ((aIsArgs && !bIsArgs) || (!aIsArgs && bIsArgs))
		      return false;
		    if (aIsArgs) {
		      a = pSlice.call(a);
		      b = pSlice.call(b);
		      return _deepEqual(a, b, strict);
		    }
		    var ka = objectKeys(a);
		    var kb = objectKeys(b);
		    var key, i;
		    // having the same number of owned properties (keys incorporates
		    // hasOwnProperty)
		    if (ka.length !== kb.length)
		      return false;
		    //the same set of keys (although not necessarily the same order),
		    ka.sort();
		    kb.sort();
		    //~~~cheap key test
		    for (i = ka.length - 1; i >= 0; i--) {
		      if (ka[i] !== kb[i])
		        return false;
		    }
		    //equivalent values for every corresponding key, and
		    //~~~possibly expensive deep test
		    for (i = ka.length - 1; i >= 0; i--) {
		      key = ka[i];
		      if (!_deepEqual(a[key], b[key], strict, actualVisitedObjects))
		        return false;
		    }
		    return true;
		  }

		  // 8. The non-equivalence assertion tests for any deep inequality.
		  // assert.notDeepEqual(actual, expected, message_opt);
		  assert.notDeepEqual = notDeepEqual;
		  function notDeepEqual(actual, expected, message) {
		    if (_deepEqual(actual, expected, false)) {
		      fail(actual, expected, message, 'notDeepEqual', notDeepEqual);
		    }
		  }

		  assert.notDeepStrictEqual = notDeepStrictEqual;
		  function notDeepStrictEqual(actual, expected, message) {
		    if (_deepEqual(actual, expected, true)) {
		      fail(actual, expected, message, 'notDeepStrictEqual', notDeepStrictEqual);
		    }
		  }


		  // 9. The strict equality assertion tests strict equality, as determined by ===.
		  // assert.strictEqual(actual, expected, message_opt);
		  assert.strictEqual = strictEqual;
		  function strictEqual(actual, expected, message) {
		    if (actual !== expected) {
		      fail(actual, expected, message, '===', strictEqual);
		    }
		  }

		  // 10. The strict non-equality assertion tests for strict inequality, as
		  // determined by !==.  assert.notStrictEqual(actual, expected, message_opt);
		  assert.notStrictEqual = notStrictEqual;
		  function notStrictEqual(actual, expected, message) {
		    if (actual === expected) {
		      fail(actual, expected, message, '!==', notStrictEqual);
		    }
		  }

		  function expectedException(actual, expected) {
		    if (!actual || !expected) {
		      return false;
		    }

		    if (Object.prototype.toString.call(expected) == '[object RegExp]') {
		      return expected.test(actual);
		    }

		    try {
		      if (actual instanceof expected) {
		        return true;
		      }
		    } catch (e) {
		      // Ignore.  The instanceof check doesn't work for arrow functions.
		    }

		    if (Error.isPrototypeOf(expected)) {
		      return false;
		    }

		    return expected.call({}, actual) === true;
		  }

		  function _tryBlock(block) {
		    var error;
		    try {
		      block();
		    } catch (e) {
		      error = e;
		    }
		    return error;
		  }

		  function _throws(shouldThrow, block, expected, message) {
		    var actual;

		    if (typeof block !== 'function') {
		      throw new TypeError('"block" argument must be a function');
		    }

		    if (typeof expected === 'string') {
		      message = expected;
		      expected = null;
		    }

		    actual = _tryBlock(block);

		    message = (expected && expected.name ? ' (' + expected.name + ').' : '.') +
		              (message ? ' ' + message : '.');

		    if (shouldThrow && !actual) {
		      fail(actual, expected, 'Missing expected exception' + message);
		    }

		    var userProvidedMessage = typeof message === 'string';
		    var isUnwantedException = !shouldThrow && isError(actual);
		    var isUnexpectedException = !shouldThrow && actual && !expected;

		    if ((isUnwantedException &&
		        userProvidedMessage &&
		        expectedException(actual, expected)) ||
		        isUnexpectedException) {
		      fail(actual, expected, 'Got unwanted exception' + message);
		    }

		    if ((shouldThrow && actual && expected &&
		        !expectedException(actual, expected)) || (!shouldThrow && actual)) {
		      throw actual;
		    }
		  }

		  // 11. Expected to throw an error:
		  // assert.throws(block, Error_opt, message_opt);
		  assert.throws = throws;
		  function throws(block, /*optional*/error, /*optional*/message) {
		    _throws(true, block, error, message);
		  }

		  // EXTENSION! This is annoying to write outside this module.
		  assert.doesNotThrow = doesNotThrow;
		  function doesNotThrow(block, /*optional*/error, /*optional*/message) {
		    _throws(false, block, error, message);
		  }

		  assert.ifError = ifError;
		  function ifError(err) {
		    if (err) throw err;
		  }

		  var _polyfillNode_assert = /*#__PURE__*/Object.freeze({
		    __proto__: null,
		    AssertionError: AssertionError,
		    assert: ok,
		    deepEqual: deepEqual,
		    deepStrictEqual: deepStrictEqual,
		    default: assert,
		    doesNotThrow: doesNotThrow,
		    equal: equal,
		    fail: fail,
		    ifError: ifError,
		    notDeepEqual: notDeepEqual,
		    notDeepStrictEqual: notDeepStrictEqual,
		    notEqual: notEqual,
		    notStrictEqual: notStrictEqual,
		    ok: ok,
		    strictEqual: strictEqual,
		    throws: throws
		  });

		  var callExpression$8 = callExpression$d,
		    cloneNode$a = cloneNode$j,
		    expressionStatement$3 = expressionStatement$a,
		    identifier$9 = identifier$j,
		    importDeclaration = importDeclaration$1,
		    importDefaultSpecifier = importDefaultSpecifier$1,
		    importNamespaceSpecifier = importNamespaceSpecifier$1,
		    importSpecifier$1 = importSpecifier$2,
		    memberExpression$9 = memberExpression$c,
		    stringLiteral$5 = stringLiteral$8,
		    variableDeclaration$4 = variableDeclaration$8,
		    variableDeclarator$4 = variableDeclarator$8;
		  var ImportBuilder = function () {
		    function ImportBuilder(importedSource, scope, hub) {
		      this._statements = [];
		      this._resultName = null;
		      this._importedSource = void 0;
		      this._scope = scope;
		      this._hub = hub;
		      this._importedSource = importedSource;
		    }
		    var _proto = ImportBuilder.prototype;
		    _proto.done = function done() {
		      return {
		        statements: this._statements,
		        resultName: this._resultName
		      };
		    };
		    _proto["import"] = function _import() {
		      this._statements.push(importDeclaration([], stringLiteral$5(this._importedSource)));
		      return this;
		    };
		    _proto.require = function require() {
		      this._statements.push(expressionStatement$3(callExpression$8(identifier$9("require"), [stringLiteral$5(this._importedSource)])));
		      return this;
		    };
		    _proto.namespace = function namespace(name) {
		      if (name === void 0) {
		        name = "namespace";
		      }
		      var local = this._scope.generateUidIdentifier(name);
		      var statement = this._statements[this._statements.length - 1];
		      assert(statement.type === "ImportDeclaration");
		      assert(statement.specifiers.length === 0);
		      statement.specifiers = [importNamespaceSpecifier(local)];
		      this._resultName = cloneNode$a(local);
		      return this;
		    };
		    _proto["default"] = function _default(name) {
		      var id = this._scope.generateUidIdentifier(name);
		      var statement = this._statements[this._statements.length - 1];
		      assert(statement.type === "ImportDeclaration");
		      assert(statement.specifiers.length === 0);
		      statement.specifiers = [importDefaultSpecifier(id)];
		      this._resultName = cloneNode$a(id);
		      return this;
		    };
		    _proto.named = function named(name, importName) {
		      if (importName === "default") return this["default"](name);
		      var id = this._scope.generateUidIdentifier(name);
		      var statement = this._statements[this._statements.length - 1];
		      assert(statement.type === "ImportDeclaration");
		      assert(statement.specifiers.length === 0);
		      statement.specifiers = [importSpecifier$1(id, identifier$9(importName))];
		      this._resultName = cloneNode$a(id);
		      return this;
		    };
		    _proto["var"] = function _var(name) {
		      var id = this._scope.generateUidIdentifier(name);
		      var statement = this._statements[this._statements.length - 1];
		      if (statement.type !== "ExpressionStatement") {
		        assert(this._resultName);
		        statement = expressionStatement$3(this._resultName);
		        this._statements.push(statement);
		      }
		      this._statements[this._statements.length - 1] = variableDeclaration$4("var", [variableDeclarator$4(id, statement.expression)]);
		      this._resultName = cloneNode$a(id);
		      return this;
		    };
		    _proto.defaultInterop = function defaultInterop() {
		      return this._interop(this._hub.addHelper("interopRequireDefault"));
		    };
		    _proto.wildcardInterop = function wildcardInterop() {
		      return this._interop(this._hub.addHelper("interopRequireWildcard"));
		    };
		    _proto._interop = function _interop(callee) {
		      var statement = this._statements[this._statements.length - 1];
		      if (statement.type === "ExpressionStatement") {
		        statement.expression = callExpression$8(callee, [statement.expression]);
		      } else if (statement.type === "VariableDeclaration") {
		        assert(statement.declarations.length === 1);
		        statement.declarations[0].init = callExpression$8(callee, [statement.declarations[0].init]);
		      } else {
		        assert.fail("Unexpected type.");
		      }
		      return this;
		    };
		    _proto.prop = function prop(name) {
		      var statement = this._statements[this._statements.length - 1];
		      if (statement.type === "ExpressionStatement") {
		        statement.expression = memberExpression$9(statement.expression, identifier$9(name));
		      } else if (statement.type === "VariableDeclaration") {
		        assert(statement.declarations.length === 1);
		        statement.declarations[0].init = memberExpression$9(statement.declarations[0].init, identifier$9(name));
		      } else {
		        assert.fail("Unexpected type:" + statement.type);
		      }
		      return this;
		    };
		    _proto.read = function read(name) {
		      this._resultName = memberExpression$9(this._resultName, identifier$9(name));
		    };
		    return _createClass(ImportBuilder);
		  }();

		  function isModule(path) {
		    return path.node.sourceType === "module";
		  }

		  var identifier$8 = identifier$j,
		    importSpecifier = importSpecifier$2,
		    numericLiteral$4 = numericLiteral$8,
		    sequenceExpression$5 = sequenceExpression$8,
		    isImportDeclaration = isImportDeclaration$3;
		  var ImportInjector = function () {
		    function ImportInjector(path, importedSource, opts) {
		      this._defaultOpts = {
		        importedSource: null,
		        importedType: "commonjs",
		        importedInterop: "babel",
		        importingInterop: "babel",
		        ensureLiveReference: false,
		        ensureNoContext: false,
		        importPosition: "before"
		      };
		      var programPath = path.find(function (p) {
		        return p.isProgram();
		      });
		      this._programPath = programPath;
		      this._programScope = programPath.scope;
		      this._hub = programPath.hub;
		      this._defaultOpts = this._applyDefaults(importedSource, opts, true);
		    }
		    var _proto = ImportInjector.prototype;
		    _proto.addDefault = function addDefault(importedSourceIn, opts) {
		      return this.addNamed("default", importedSourceIn, opts);
		    };
		    _proto.addNamed = function addNamed(importName, importedSourceIn, opts) {
		      assert(typeof importName === "string");
		      return this._generateImport(this._applyDefaults(importedSourceIn, opts), importName);
		    };
		    _proto.addNamespace = function addNamespace(importedSourceIn, opts) {
		      return this._generateImport(this._applyDefaults(importedSourceIn, opts), null);
		    };
		    _proto.addSideEffect = function addSideEffect(importedSourceIn, opts) {
		      return this._generateImport(this._applyDefaults(importedSourceIn, opts), void 0);
		    };
		    _proto._applyDefaults = function _applyDefaults(importedSource, opts, isInit) {
		      if (isInit === void 0) {
		        isInit = false;
		      }
		      var newOpts;
		      if (typeof importedSource === "string") {
		        newOpts = Object.assign({}, this._defaultOpts, {
		          importedSource: importedSource
		        }, opts);
		      } else {
		        assert(!opts, "Unexpected secondary arguments.");
		        newOpts = Object.assign({}, this._defaultOpts, importedSource);
		      }
		      if (!isInit && opts) {
		        if (opts.nameHint !== undefined) newOpts.nameHint = opts.nameHint;
		        if (opts.blockHoist !== undefined) newOpts.blockHoist = opts.blockHoist;
		      }
		      return newOpts;
		    };
		    _proto._generateImport = function _generateImport(opts, importName) {
		      var isDefault = importName === "default";
		      var isNamed = !!importName && !isDefault;
		      var isNamespace = importName === null;
		      var importedSource = opts.importedSource,
		        importedType = opts.importedType,
		        importedInterop = opts.importedInterop,
		        importingInterop = opts.importingInterop,
		        ensureLiveReference = opts.ensureLiveReference,
		        ensureNoContext = opts.ensureNoContext,
		        nameHint = opts.nameHint,
		        importPosition = opts.importPosition,
		        blockHoist = opts.blockHoist;
		      var name = nameHint || importName;
		      var isMod = isModule(this._programPath);
		      var isModuleForNode = isMod && importingInterop === "node";
		      var isModuleForBabel = isMod && importingInterop === "babel";
		      if (importPosition === "after" && !isMod) {
		        throw new Error("\"importPosition\": \"after\" is only supported in modules");
		      }
		      var builder = new ImportBuilder(importedSource, this._programScope, this._hub);
		      if (importedType === "es6") {
		        if (!isModuleForNode && !isModuleForBabel) {
		          throw new Error("Cannot import an ES6 module from CommonJS");
		        }
		        builder["import"]();
		        if (isNamespace) {
		          builder.namespace(nameHint || importedSource);
		        } else if (isDefault || isNamed) {
		          builder.named(name, importName);
		        }
		      } else if (importedType !== "commonjs") {
		        throw new Error("Unexpected interopType \"" + importedType + "\"");
		      } else if (importedInterop === "babel") {
		        if (isModuleForNode) {
		          name = name !== "default" ? name : importedSource;
		          var es6Default = importedSource + "$es6Default";
		          builder["import"]();
		          if (isNamespace) {
		            builder["default"](es6Default)["var"](name || importedSource).wildcardInterop();
		          } else if (isDefault) {
		            if (ensureLiveReference) {
		              builder["default"](es6Default)["var"](name || importedSource).defaultInterop().read("default");
		            } else {
		              builder["default"](es6Default)["var"](name).defaultInterop().prop(importName);
		            }
		          } else if (isNamed) {
		            builder["default"](es6Default).read(importName);
		          }
		        } else if (isModuleForBabel) {
		          builder["import"]();
		          if (isNamespace) {
		            builder.namespace(name || importedSource);
		          } else if (isDefault || isNamed) {
		            builder.named(name, importName);
		          }
		        } else {
		          builder.require();
		          if (isNamespace) {
		            builder["var"](name || importedSource).wildcardInterop();
		          } else if ((isDefault || isNamed) && ensureLiveReference) {
		            if (isDefault) {
		              name = name !== "default" ? name : importedSource;
		              builder["var"](name).read(importName);
		              builder.defaultInterop();
		            } else {
		              builder["var"](importedSource).read(importName);
		            }
		          } else if (isDefault) {
		            builder["var"](name).defaultInterop().prop(importName);
		          } else if (isNamed) {
		            builder["var"](name).prop(importName);
		          }
		        }
		      } else if (importedInterop === "compiled") {
		        if (isModuleForNode) {
		          builder["import"]();
		          if (isNamespace) {
		            builder["default"](name || importedSource);
		          } else if (isDefault || isNamed) {
		            builder["default"](importedSource).read(name);
		          }
		        } else if (isModuleForBabel) {
		          builder["import"]();
		          if (isNamespace) {
		            builder.namespace(name || importedSource);
		          } else if (isDefault || isNamed) {
		            builder.named(name, importName);
		          }
		        } else {
		          builder.require();
		          if (isNamespace) {
		            builder["var"](name || importedSource);
		          } else if (isDefault || isNamed) {
		            if (ensureLiveReference) {
		              builder["var"](importedSource).read(name);
		            } else {
		              builder.prop(importName)["var"](name);
		            }
		          }
		        }
		      } else if (importedInterop === "uncompiled") {
		        if (isDefault && ensureLiveReference) {
		          throw new Error("No live reference for commonjs default");
		        }
		        if (isModuleForNode) {
		          builder["import"]();
		          if (isNamespace) {
		            builder["default"](name || importedSource);
		          } else if (isDefault) {
		            builder["default"](name);
		          } else if (isNamed) {
		            builder["default"](importedSource).read(name);
		          }
		        } else if (isModuleForBabel) {
		          builder["import"]();
		          if (isNamespace) {
		            builder["default"](name || importedSource);
		          } else if (isDefault) {
		            builder["default"](name);
		          } else if (isNamed) {
		            builder.named(name, importName);
		          }
		        } else {
		          builder.require();
		          if (isNamespace) {
		            builder["var"](name || importedSource);
		          } else if (isDefault) {
		            builder["var"](name);
		          } else if (isNamed) {
		            if (ensureLiveReference) {
		              builder["var"](importedSource).read(name);
		            } else {
		              builder["var"](name).prop(importName);
		            }
		          }
		        }
		      } else {
		        throw new Error("Unknown importedInterop \"" + importedInterop + "\".");
		      }
		      var _builder$done = builder.done(),
		        statements = _builder$done.statements,
		        resultName = _builder$done.resultName;
		      this._insertStatements(statements, importPosition, blockHoist);
		      if ((isDefault || isNamed) && ensureNoContext && resultName.type !== "Identifier") {
		        return sequenceExpression$5([numericLiteral$4(0), resultName]);
		      }
		      return resultName;
		    };
		    _proto._insertStatements = function _insertStatements(statements, importPosition, blockHoist) {
		      if (importPosition === void 0) {
		        importPosition = "before";
		      }
		      if (blockHoist === void 0) {
		        blockHoist = 3;
		      }
		      if (importPosition === "after") {
		        if (this._insertStatementsAfter(statements)) return;
		      } else {
		        if (this._insertStatementsBefore(statements, blockHoist)) return;
		      }
		      this._programPath.unshiftContainer("body", statements);
		    };
		    _proto._insertStatementsBefore = function _insertStatementsBefore(statements, blockHoist) {
		      if (statements.length === 1 && isImportDeclaration(statements[0]) && isValueImport(statements[0])) {
		        var firstImportDecl = this._programPath.get("body").find(function (p) {
		          return p.isImportDeclaration() && isValueImport(p.node);
		        });
		        if ((firstImportDecl == null ? void 0 : firstImportDecl.node.source.value) === statements[0].source.value && maybeAppendImportSpecifiers(firstImportDecl.node, statements[0])) {
		          return true;
		        }
		      }
		      statements.forEach(function (node) {
		        node._blockHoist = blockHoist;
		      });
		      var targetPath = this._programPath.get("body").find(function (p) {
		        var val = p.node._blockHoist;
		        return Number.isFinite(val) && val < 4;
		      });
		      if (targetPath) {
		        targetPath.insertBefore(statements);
		        return true;
		      }
		      return false;
		    };
		    _proto._insertStatementsAfter = function _insertStatementsAfter(statements) {
		      var statementsSet = new Set(statements);
		      var importDeclarations = new Map();
		      for (var _iterator = _createForOfIteratorHelperLoose(statements), _step; !(_step = _iterator()).done;) {
		        var statement = _step.value;
		        if (isImportDeclaration(statement) && isValueImport(statement)) {
		          var source = statement.source.value;
		          if (!importDeclarations.has(source)) importDeclarations.set(source, []);
		          importDeclarations.get(source).push(statement);
		        }
		      }
		      var lastImportPath = null;
		      for (var _iterator2 = _createForOfIteratorHelperLoose(this._programPath.get("body")), _step2; !(_step2 = _iterator2()).done;) {
		        var bodyStmt = _step2.value;
		        if (bodyStmt.isImportDeclaration() && isValueImport(bodyStmt.node)) {
		          lastImportPath = bodyStmt;
		          var _source = bodyStmt.node.source.value;
		          var newImports = importDeclarations.get(_source);
		          if (!newImports) continue;
		          for (var _iterator3 = _createForOfIteratorHelperLoose(newImports), _step3; !(_step3 = _iterator3()).done;) {
		            var decl = _step3.value;
		            if (!statementsSet.has(decl)) continue;
		            if (maybeAppendImportSpecifiers(bodyStmt.node, decl)) {
		              statementsSet["delete"](decl);
		            }
		          }
		        }
		      }
		      if (statementsSet.size === 0) return true;
		      if (lastImportPath) lastImportPath.insertAfter(Array.from(statementsSet));
		      return !!lastImportPath;
		    };
		    return _createClass(ImportInjector);
		  }();
		  function isValueImport(node) {
		    return node.importKind !== "type" && node.importKind !== "typeof";
		  }
		  function hasNamespaceImport(node) {
		    return node.specifiers.length === 1 && node.specifiers[0].type === "ImportNamespaceSpecifier" || node.specifiers.length === 2 && node.specifiers[1].type === "ImportNamespaceSpecifier";
		  }
		  function hasDefaultImport(node) {
		    return node.specifiers.length > 0 && node.specifiers[0].type === "ImportDefaultSpecifier";
		  }
		  function maybeAppendImportSpecifiers(target, source) {
		    var _target$specifiers;
		    if (!target.specifiers.length) {
		      target.specifiers = source.specifiers;
		      return true;
		    }
		    if (!source.specifiers.length) return true;
		    if (hasNamespaceImport(target) || hasNamespaceImport(source)) return false;
		    if (hasDefaultImport(source)) {
		      if (hasDefaultImport(target)) {
		        source.specifiers[0] = importSpecifier(source.specifiers[0].local, identifier$8("default"));
		      } else {
		        target.specifiers.unshift(source.specifiers.shift());
		      }
		    }
		    (_target$specifiers = target.specifiers).push.apply(_target$specifiers, _toConsumableArray(source.specifiers));
		    return true;
		  }

		  function addDefault(path, importedSource, opts) {
		    return new ImportInjector(path).addDefault(importedSource, opts);
		  }
		  function addNamed(path, name, importedSource, opts) {
		    return new ImportInjector(path).addNamed(name, importedSource, opts);
		  }
		  function addNamespace(path, importedSource, opts) {
		    return new ImportInjector(path).addNamespace(importedSource, opts);
		  }

		  var numericLiteral$3 = numericLiteral$8,
		    unaryExpression$3 = unaryExpression$6;
		  var rewriteThisVisitor = traverse.visitors.merge([visitor$5, {
		    ThisExpression: function ThisExpression(path) {
		      path.replaceWith(unaryExpression$3("void", numericLiteral$3(0), true));
		    }
		  }]);
		  function rewriteThis(programPath) {
		    traverse(programPath.node, Object.assign({}, rewriteThisVisitor, {
		      noScope: true
		    }));
		  }

		  var LOGICAL_OPERATORS$1 = LOGICAL_OPERATORS$3,
		    assignmentExpression$7 = assignmentExpression$d,
		    binaryExpression$3 = binaryExpression$5,
		    cloneNode$9 = cloneNode$j,
		    identifier$7 = identifier$j,
		    logicalExpression$1 = logicalExpression$3,
		    numericLiteral$2 = numericLiteral$8,
		    sequenceExpression$4 = sequenceExpression$8,
		    unaryExpression$2 = unaryExpression$6;
		  var simpleAssignmentVisitor = {
		    AssignmentExpression: {
		      exit: function exit(path) {
		        var scope = this.scope,
		          seen = this.seen,
		          bindingNames = this.bindingNames;
		        if (path.node.operator === "=") return;
		        if (seen.has(path.node)) return;
		        seen.add(path.node);
		        var left = path.get("left");
		        if (!left.isIdentifier()) return;
		        var localName = left.node.name;
		        if (!bindingNames.has(localName)) return;
		        if (scope.getBinding(localName) !== path.scope.getBinding(localName)) {
		          return;
		        }
		        var operator = path.node.operator.slice(0, -1);
		        if (LOGICAL_OPERATORS$1.includes(operator)) {
		          path.replaceWith(logicalExpression$1(operator, path.node.left, assignmentExpression$7("=", cloneNode$9(path.node.left), path.node.right)));
		        } else {
		          path.node.right = binaryExpression$3(operator, cloneNode$9(path.node.left), path.node.right);
		          path.node.operator = "=";
		        }
		      }
		    }
		  };
		  {
		    simpleAssignmentVisitor.UpdateExpression = {
		      exit: function exit(path) {
		        if (!this.includeUpdateExpression) return;
		        var scope = this.scope,
		          bindingNames = this.bindingNames;
		        var arg = path.get("argument");
		        if (!arg.isIdentifier()) return;
		        var localName = arg.node.name;
		        if (!bindingNames.has(localName)) return;
		        if (scope.getBinding(localName) !== path.scope.getBinding(localName)) {
		          return;
		        }
		        if (path.parentPath.isExpressionStatement() && !path.isCompletionRecord()) {
		          var operator = path.node.operator === "++" ? "+=" : "-=";
		          path.replaceWith(assignmentExpression$7(operator, arg.node, numericLiteral$2(1)));
		        } else if (path.node.prefix) {
		          path.replaceWith(assignmentExpression$7("=", identifier$7(localName), binaryExpression$3(path.node.operator[0], unaryExpression$2("+", arg.node), numericLiteral$2(1))));
		        } else {
		          var old = path.scope.generateUidIdentifierBasedOnNode(arg.node, "old");
		          var varName = old.name;
		          path.scope.push({
		            id: old
		          });
		          var binary = binaryExpression$3(path.node.operator[0], identifier$7(varName), numericLiteral$2(1));
		          path.replaceWith(sequenceExpression$4([assignmentExpression$7("=", identifier$7(varName), unaryExpression$2("+", arg.node)), assignmentExpression$7("=", cloneNode$9(arg.node), binary), identifier$7(varName)]));
		        }
		      }
		    };
		  }
		  function simplifyAccess(path, bindingNames) {
		    {
		      var _arguments$;
		      path.traverse(simpleAssignmentVisitor, {
		        scope: path.scope,
		        bindingNames: bindingNames,
		        seen: new WeakSet(),
		        includeUpdateExpression: (_arguments$ = arguments[2]) != null ? _arguments$ : true
		      });
		    }
		  }

		  var _templateObject$A;
		  var assignmentExpression$6 = assignmentExpression$d,
		    cloneNode$8 = cloneNode$j,
		    expressionStatement$2 = expressionStatement$a,
		    getOuterBindingIdentifiers = getOuterBindingIdentifiers$2,
		    identifier$6 = identifier$j,
		    isArrowFunctionExpression = isArrowFunctionExpression$2,
		    isClassExpression = isClassExpression$1,
		    isFunctionExpression = isFunctionExpression$1,
		    isIdentifier$5 = isIdentifier$i,
		    isMemberExpression$2 = isMemberExpression$9,
		    isVariableDeclaration = isVariableDeclaration$4,
		    jsxIdentifier = jsxIdentifier$2,
		    jsxMemberExpression = jsxMemberExpression$1,
		    memberExpression$8 = memberExpression$c,
		    numericLiteral$1 = numericLiteral$8,
		    sequenceExpression$3 = sequenceExpression$8,
		    stringLiteral$4 = stringLiteral$8,
		    variableDeclaration$3 = variableDeclaration$8,
		    variableDeclarator$3 = variableDeclarator$8;
		  function isInType$1(path) {
		    do {
		      switch (path.parent.type) {
		        case "TSTypeAnnotation":
		        case "TSTypeAliasDeclaration":
		        case "TSTypeReference":
		        case "TypeAnnotation":
		        case "TypeAlias":
		          return true;
		        case "ExportSpecifier":
		          return path.parentPath.parent.exportKind === "type";
		        default:
		          if (path.parentPath.isStatement() || path.parentPath.isExpression()) {
		            return false;
		          }
		      }
		    } while (path = path.parentPath);
		  }
		  function rewriteLiveReferences(programPath, metadata, wrapReference) {
		    var imported = new Map();
		    var exported = new Map();
		    var requeueInParent = function requeueInParent(path) {
		      programPath.requeue(path);
		    };
		    for (var _iterator = _createForOfIteratorHelperLoose(metadata.source), _step; !(_step = _iterator()).done;) {
		      var _step$value = _slicedToArray(_step.value, 2),
		        source = _step$value[0],
		        data = _step$value[1];
		      for (var _iterator3 = _createForOfIteratorHelperLoose(data.imports), _step3; !(_step3 = _iterator3()).done;) {
		        var _step3$value = _slicedToArray(_step3.value, 2),
		          localName = _step3$value[0],
		          importName = _step3$value[1];
		        imported.set(localName, [source, importName, null]);
		      }
		      for (var _iterator4 = _createForOfIteratorHelperLoose(data.importsNamespace), _step4; !(_step4 = _iterator4()).done;) {
		        var _localName = _step4.value;
		        imported.set(_localName, [source, null, _localName]);
		      }
		    }
		    for (var _iterator2 = _createForOfIteratorHelperLoose(metadata.local), _step2; !(_step2 = _iterator2()).done;) {
		      var _exportMeta;
		      var _step2$value = _slicedToArray(_step2.value, 2),
		        local = _step2$value[0],
		        _data = _step2$value[1];
		      var exportMeta = exported.get(local);
		      if (!exportMeta) {
		        exportMeta = [];
		        exported.set(local, exportMeta);
		      }
		      (_exportMeta = exportMeta).push.apply(_exportMeta, _toConsumableArray(_data.names));
		    }
		    var rewriteBindingInitVisitorState = {
		      metadata: metadata,
		      requeueInParent: requeueInParent,
		      scope: programPath.scope,
		      exported: exported
		    };
		    programPath.traverse(rewriteBindingInitVisitor, rewriteBindingInitVisitorState);
		    var bindingNames = new Set([].concat(_toConsumableArray(Array.from(imported.keys())), _toConsumableArray(Array.from(exported.keys()))));
		    {
		      simplifyAccess(programPath, bindingNames, false);
		    }
		    var rewriteReferencesVisitorState = {
		      seen: new WeakSet(),
		      metadata: metadata,
		      requeueInParent: requeueInParent,
		      scope: programPath.scope,
		      imported: imported,
		      exported: exported,
		      buildImportReference: function buildImportReference(_ref, identNode) {
		        var _ref2 = _slicedToArray(_ref, 3),
		          source = _ref2[0],
		          importName = _ref2[1],
		          localName = _ref2[2];
		        var meta = metadata.source.get(source);
		        meta.referenced = true;
		        if (localName) {
		          if (meta.wrap) {
		            var _wrapReference;
		            identNode = (_wrapReference = wrapReference(identNode, meta.wrap)) != null ? _wrapReference : identNode;
		          }
		          return identNode;
		        }
		        var namespace = identifier$6(meta.name);
		        if (meta.wrap) {
		          var _wrapReference2;
		          namespace = (_wrapReference2 = wrapReference(namespace, meta.wrap)) != null ? _wrapReference2 : namespace;
		        }
		        if (importName === "default" && meta.interop === "node-default") {
		          return namespace;
		        }
		        var computed = metadata.stringSpecifiers.has(importName);
		        return memberExpression$8(namespace, computed ? stringLiteral$4(importName) : identifier$6(importName), computed);
		      }
		    };
		    programPath.traverse(rewriteReferencesVisitor, rewriteReferencesVisitorState);
		  }
		  var rewriteBindingInitVisitor = {
		    Scope: function Scope(path) {
		      path.skip();
		    },
		    ClassDeclaration: function ClassDeclaration(path) {
		      var requeueInParent = this.requeueInParent,
		        exported = this.exported,
		        metadata = this.metadata;
		      var id = path.node.id;
		      if (!id) throw new Error("Expected class to have a name");
		      var localName = id.name;
		      var exportNames = exported.get(localName) || [];
		      if (exportNames.length > 0) {
		        var statement = expressionStatement$2(buildBindingExportAssignmentExpression(metadata, exportNames, identifier$6(localName), path.scope));
		        statement._blockHoist = path.node._blockHoist;
		        requeueInParent(path.insertAfter(statement)[0]);
		      }
		    },
		    VariableDeclaration: function VariableDeclaration(path) {
		      var requeueInParent = this.requeueInParent,
		        exported = this.exported,
		        metadata = this.metadata;
		      var isVar = path.node.kind === "var";
		      for (var _iterator5 = _createForOfIteratorHelperLoose(path.get("declarations")), _step5; !(_step5 = _iterator5()).done;) {
		        var decl = _step5.value;
		        var id = decl.node.id;
		        var init = decl.node.init;
		        if (isIdentifier$5(id) && exported.has(id.name) && !isArrowFunctionExpression(init) && (!isFunctionExpression(init) || init.id) && (!isClassExpression(init) || init.id)) {
		          if (!init) {
		            if (isVar) {
		              continue;
		            } else {
		              init = path.scope.buildUndefinedNode();
		            }
		          }
		          decl.node.init = buildBindingExportAssignmentExpression(metadata, exported.get(id.name), init, path.scope);
		          requeueInParent(decl.get("init"));
		        } else {
		          for (var _i = 0, _Object$keys = Object.keys(decl.getOuterBindingIdentifiers()); _i < _Object$keys.length; _i++) {
		            var localName = _Object$keys[_i];
		            if (exported.has(localName)) {
		              var statement = expressionStatement$2(buildBindingExportAssignmentExpression(metadata, exported.get(localName), identifier$6(localName), path.scope));
		              statement._blockHoist = path.node._blockHoist;
		              requeueInParent(path.insertAfter(statement)[0]);
		            }
		          }
		        }
		      }
		    }
		  };
		  var buildBindingExportAssignmentExpression = function buildBindingExportAssignmentExpression(metadata, exportNames, localExpr, scope) {
		    var exportsObjectName = metadata.exportName;
		    for (var currentScope = scope; currentScope != null; currentScope = currentScope.parent) {
		      if (currentScope.hasOwnBinding(exportsObjectName)) {
		        currentScope.rename(exportsObjectName);
		      }
		    }
		    return (exportNames || []).reduce(function (expr, exportName) {
		      var stringSpecifiers = metadata.stringSpecifiers;
		      var computed = stringSpecifiers.has(exportName);
		      return assignmentExpression$6("=", memberExpression$8(identifier$6(exportsObjectName), computed ? stringLiteral$4(exportName) : identifier$6(exportName), computed), expr);
		    }, localExpr);
		  };
		  var buildImportThrow = function buildImportThrow(localName) {
		    return template$1.expression.ast(_templateObject$A || (_templateObject$A = _taggedTemplateLiteralLoose(["\n    (function() {\n      throw new Error('\"' + '", "' + '\" is read-only.');\n    })()\n  "])), localName);
		  };
		  var rewriteReferencesVisitor = {
		    ReferencedIdentifier: function ReferencedIdentifier(path) {
		      var seen = this.seen,
		        buildImportReference = this.buildImportReference,
		        scope = this.scope,
		        imported = this.imported,
		        requeueInParent = this.requeueInParent;
		      if (seen.has(path.node)) return;
		      seen.add(path.node);
		      var localName = path.node.name;
		      var importData = imported.get(localName);
		      if (importData) {
		        if (isInType$1(path)) {
		          throw path.buildCodeFrameError("Cannot transform the imported binding \"" + localName + "\" since it's also used in a type annotation. " + "Please strip type annotations using @babel/preset-typescript or @babel/preset-flow.");
		        }
		        var localBinding = path.scope.getBinding(localName);
		        var rootBinding = scope.getBinding(localName);
		        if (rootBinding !== localBinding) return;
		        var _ref3 = buildImportReference(importData, path.node);
		        _ref3.loc = path.node.loc;
		        if ((path.parentPath.isCallExpression({
		          callee: path.node
		        }) || path.parentPath.isOptionalCallExpression({
		          callee: path.node
		        }) || path.parentPath.isTaggedTemplateExpression({
		          tag: path.node
		        })) && isMemberExpression$2(_ref3)) {
		          path.replaceWith(sequenceExpression$3([numericLiteral$1(0), _ref3]));
		        } else if (path.isJSXIdentifier() && isMemberExpression$2(_ref3)) {
		          var object = _ref3.object,
		            property = _ref3.property;
		          path.replaceWith(jsxMemberExpression(jsxIdentifier(object.name), jsxIdentifier(property.name)));
		        } else {
		          path.replaceWith(_ref3);
		        }
		        requeueInParent(path);
		        path.skip();
		      }
		    },
		    UpdateExpression: function UpdateExpression(path) {
		      var scope = this.scope,
		        seen = this.seen,
		        imported = this.imported,
		        exported = this.exported,
		        requeueInParent = this.requeueInParent,
		        buildImportReference = this.buildImportReference;
		      if (seen.has(path.node)) return;
		      seen.add(path.node);
		      var arg = path.get("argument");
		      if (arg.isMemberExpression()) return;
		      var update = path.node;
		      if (arg.isIdentifier()) {
		        var localName = arg.node.name;
		        if (scope.getBinding(localName) !== path.scope.getBinding(localName)) {
		          return;
		        }
		        var exportedNames = exported.get(localName);
		        var importData = imported.get(localName);
		        if ((exportedNames == null ? void 0 : exportedNames.length) > 0 || importData) {
		          if (importData) {
		            path.replaceWith(assignmentExpression$6(update.operator[0] + "=", buildImportReference(importData, arg.node), buildImportThrow(localName)));
		          } else if (update.prefix) {
		            path.replaceWith(buildBindingExportAssignmentExpression(this.metadata, exportedNames, cloneNode$8(update), path.scope));
		          } else {
		            var _ref4 = scope.generateDeclaredUidIdentifier(localName);
		            path.replaceWith(sequenceExpression$3([assignmentExpression$6("=", cloneNode$8(_ref4), cloneNode$8(update)), buildBindingExportAssignmentExpression(this.metadata, exportedNames, identifier$6(localName), path.scope), cloneNode$8(_ref4)]));
		          }
		        }
		      }
		      requeueInParent(path);
		      path.skip();
		    },
		    AssignmentExpression: {
		      exit: function exit(path) {
		        var _this = this;
		        var scope = this.scope,
		          seen = this.seen,
		          imported = this.imported,
		          exported = this.exported,
		          requeueInParent = this.requeueInParent,
		          buildImportReference = this.buildImportReference;
		        if (seen.has(path.node)) return;
		        seen.add(path.node);
		        var left = path.get("left");
		        if (left.isMemberExpression()) return;
		        if (left.isIdentifier()) {
		          var localName = left.node.name;
		          if (scope.getBinding(localName) !== path.scope.getBinding(localName)) {
		            return;
		          }
		          var exportedNames = exported.get(localName);
		          var importData = imported.get(localName);
		          if ((exportedNames == null ? void 0 : exportedNames.length) > 0 || importData) {
		            assert(path.node.operator === "=", "Path was not simplified");
		            var assignment = path.node;
		            if (importData) {
		              assignment.left = buildImportReference(importData, left.node);
		              assignment.right = sequenceExpression$3([assignment.right, buildImportThrow(localName)]);
		            }
		            path.replaceWith(buildBindingExportAssignmentExpression(this.metadata, exportedNames, assignment, path.scope));
		            requeueInParent(path);
		          }
		        } else {
		          var ids = left.getOuterBindingIdentifiers();
		          var programScopeIds = Object.keys(ids).filter(function (localName) {
		            return scope.getBinding(localName) === path.scope.getBinding(localName);
		          });
		          var id = programScopeIds.find(function (localName) {
		            return imported.has(localName);
		          });
		          if (id) {
		            path.node.right = sequenceExpression$3([path.node.right, buildImportThrow(id)]);
		          }
		          var items = [];
		          programScopeIds.forEach(function (localName) {
		            var exportedNames = exported.get(localName) || [];
		            if (exportedNames.length > 0) {
		              items.push(buildBindingExportAssignmentExpression(_this.metadata, exportedNames, identifier$6(localName), path.scope));
		            }
		          });
		          if (items.length > 0) {
		            var node = sequenceExpression$3(items);
		            if (path.parentPath.isExpressionStatement()) {
		              node = expressionStatement$2(node);
		              node._blockHoist = path.parentPath.node._blockHoist;
		            }
		            var statement = path.insertAfter(node)[0];
		            requeueInParent(statement);
		          }
		        }
		      }
		    },
		    "ForOfStatement|ForInStatement": function ForOfStatementForInStatement(path) {
		      var scope = path.scope,
		        node = path.node;
		      var left = node.left;
		      var exported = this.exported,
		        imported = this.imported,
		        programScope = this.scope;
		      if (!isVariableDeclaration(left)) {
		        var didTransformExport = false,
		          importConstViolationName;
		        var loopBodyScope = path.get("body").scope;
		        for (var _i2 = 0, _Object$keys2 = Object.keys(getOuterBindingIdentifiers(left)); _i2 < _Object$keys2.length; _i2++) {
		          var name = _Object$keys2[_i2];
		          if (programScope.getBinding(name) === scope.getBinding(name)) {
		            if (exported.has(name)) {
		              didTransformExport = true;
		              if (loopBodyScope.hasOwnBinding(name)) {
		                loopBodyScope.rename(name);
		              }
		            }
		            if (imported.has(name) && !importConstViolationName) {
		              importConstViolationName = name;
		            }
		          }
		        }
		        if (!didTransformExport && !importConstViolationName) {
		          return;
		        }
		        path.ensureBlock();
		        var bodyPath = path.get("body");
		        var newLoopId = scope.generateUidIdentifierBasedOnNode(left);
		        path.get("left").replaceWith(variableDeclaration$3("let", [variableDeclarator$3(cloneNode$8(newLoopId))]));
		        scope.registerDeclaration(path.get("left"));
		        if (didTransformExport) {
		          bodyPath.unshiftContainer("body", expressionStatement$2(assignmentExpression$6("=", left, newLoopId)));
		        }
		        if (importConstViolationName) {
		          bodyPath.unshiftContainer("body", expressionStatement$2(buildImportThrow(importConstViolationName)));
		        }
		      }
		    }
		  };

		  // Copyright Joyent, Inc. and other Node contributors.
		  //
		  // Permission is hereby granted, free of charge, to any person obtaining a
		  // copy of this software and associated documentation files (the
		  // "Software"), to deal in the Software without restriction, including
		  // without limitation the rights to use, copy, modify, merge, publish,
		  // distribute, sublicense, and/or sell copies of the Software, and to permit
		  // persons to whom the Software is furnished to do so, subject to the
		  // following conditions:
		  //
		  // The above copyright notice and this permission notice shall be included
		  // in all copies or substantial portions of the Software.
		  //
		  // THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
		  // OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
		  // MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
		  // NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
		  // DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
		  // OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
		  // USE OR OTHER DEALINGS IN THE SOFTWARE.

		  // resolves . and .. elements in a path array with directory names there
		  // must be no slashes, empty elements, or device names (c:\) in the array
		  // (so also no leading and trailing slashes - it does not distinguish
		  // relative and absolute paths)
		  function normalizeArray(parts, allowAboveRoot) {
		    // if the path tries to go above the root, `up` ends up > 0
		    var up = 0;
		    for (var i = parts.length - 1; i >= 0; i--) {
		      var last = parts[i];
		      if (last === '.') {
		        parts.splice(i, 1);
		      } else if (last === '..') {
		        parts.splice(i, 1);
		        up++;
		      } else if (up) {
		        parts.splice(i, 1);
		        up--;
		      }
		    }

		    // if the path is allowed to go above the root, restore leading ..s
		    if (allowAboveRoot) {
		      for (; up--; up) {
		        parts.unshift('..');
		      }
		    }

		    return parts;
		  }

		  // Split a filename into [root, dir, basename, ext], unix version
		  // 'root' is just a slash, or nothing.
		  var splitPathRe =
		      /^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/;
		  var splitPath = function(filename) {
		    return splitPathRe.exec(filename).slice(1);
		  };

		  // path.resolve([from ...], to)
		  // posix version
		  function resolve$2() {
		    var resolvedPath = '',
		        resolvedAbsolute = false;

		    for (var i = arguments.length - 1; i >= -1 && !resolvedAbsolute; i--) {
		      var path = (i >= 0) ? arguments[i] : '/';

		      // Skip empty and invalid entries
		      if (typeof path !== 'string') {
		        throw new TypeError('Arguments to path.resolve must be strings');
		      } else if (!path) {
		        continue;
		      }

		      resolvedPath = path + '/' + resolvedPath;
		      resolvedAbsolute = path.charAt(0) === '/';
		    }

		    // At this point the path should be resolved to a full absolute path, but
		    // handle relative paths to be safe (might happen when process.cwd() fails)

		    // Normalize the path
		    resolvedPath = normalizeArray(filter(resolvedPath.split('/'), function(p) {
		      return !!p;
		    }), !resolvedAbsolute).join('/');

		    return ((resolvedAbsolute ? '/' : '') + resolvedPath) || '.';
		  }
		  // path.normalize(path)
		  // posix version
		  function normalize$2(path) {
		    var isPathAbsolute = isAbsolute(path),
		        trailingSlash = substr(path, -1) === '/';

		    // Normalize the path
		    path = normalizeArray(filter(path.split('/'), function(p) {
		      return !!p;
		    }), !isPathAbsolute).join('/');

		    if (!path && !isPathAbsolute) {
		      path = '.';
		    }
		    if (path && trailingSlash) {
		      path += '/';
		    }

		    return (isPathAbsolute ? '/' : '') + path;
		  }
		  // posix version
		  function isAbsolute(path) {
		    return path.charAt(0) === '/';
		  }

		  // posix version
		  function join() {
		    var paths = Array.prototype.slice.call(arguments, 0);
		    return normalize$2(filter(paths, function(p, index) {
		      if (typeof p !== 'string') {
		        throw new TypeError('Arguments to path.join must be strings');
		      }
		      return p;
		    }).join('/'));
		  }


		  // path.relative(from, to)
		  // posix version
		  function relative(from, to) {
		    from = resolve$2(from).substr(1);
		    to = resolve$2(to).substr(1);

		    function trim(arr) {
		      var start = 0;
		      for (; start < arr.length; start++) {
		        if (arr[start] !== '') break;
		      }

		      var end = arr.length - 1;
		      for (; end >= 0; end--) {
		        if (arr[end] !== '') break;
		      }

		      if (start > end) return [];
		      return arr.slice(start, end - start + 1);
		    }

		    var fromParts = trim(from.split('/'));
		    var toParts = trim(to.split('/'));

		    var length = Math.min(fromParts.length, toParts.length);
		    var samePartsLength = length;
		    for (var i = 0; i < length; i++) {
		      if (fromParts[i] !== toParts[i]) {
		        samePartsLength = i;
		        break;
		      }
		    }

		    var outputParts = [];
		    for (var i = samePartsLength; i < fromParts.length; i++) {
		      outputParts.push('..');
		    }

		    outputParts = outputParts.concat(toParts.slice(samePartsLength));

		    return outputParts.join('/');
		  }

		  var sep$1 = '/';
		  var delimiter = ':';

		  function dirname(path) {
		    var result = splitPath(path),
		        root = result[0],
		        dir = result[1];

		    if (!root && !dir) {
		      // No dirname whatsoever
		      return '.';
		    }

		    if (dir) {
		      // It has a dirname, strip trailing slash
		      dir = dir.substr(0, dir.length - 1);
		    }

		    return root + dir;
		  }

		  function basename(path, ext) {
		    var f = splitPath(path)[2];
		    // TODO: make this comparison case-insensitive on windows?
		    if (ext && f.substr(-1 * ext.length) === ext) {
		      f = f.substr(0, f.length - ext.length);
		    }
		    return f;
		  }


		  function extname(path) {
		    return splitPath(path)[3];
		  }
		  var path$1 = {
		    extname: extname,
		    basename: basename,
		    dirname: dirname,
		    sep: sep$1,
		    delimiter: delimiter,
		    relative: relative,
		    join: join,
		    isAbsolute: isAbsolute,
		    normalize: normalize$2,
		    resolve: resolve$2
		  };
		  function filter (xs, f) {
		      if (xs.filter) return xs.filter(f);
		      var res = [];
		      for (var i = 0; i < xs.length; i++) {
		          if (f(xs[i], i, xs)) res.push(xs[i]);
		      }
		      return res;
		  }

		  // String.prototype.substr - negative index don't work in IE8
		  var substr = 'ab'.substr(-1) === 'b' ?
		      function (str, start, len) { return str.substr(start, len) } :
		      function (str, start, len) {
		          if (start < 0) start = str.length + start;
		          return str.substr(start, len);
		      }
		  ;

		  var _polyfillNode_path = /*#__PURE__*/Object.freeze({
		    __proto__: null,
		    basename: basename,
		    default: path$1,
		    delimiter: delimiter,
		    dirname: dirname,
		    extname: extname,
		    isAbsolute: isAbsolute,
		    join: join,
		    normalize: normalize$2,
		    relative: relative,
		    resolve: resolve$2,
		    sep: sep$1
		  });

		  function hasExports(metadata) {
		    return metadata.hasExports;
		  }
		  function isSideEffectImport(source) {
		    return source.imports.size === 0 && source.importsNamespace.size === 0 && source.reexports.size === 0 && source.reexportNamespace.size === 0 && !source.reexportAll;
		  }
		  function validateImportInteropOption(importInterop) {
		    if (typeof importInterop !== "function" && importInterop !== "none" && importInterop !== "babel" && importInterop !== "node") {
		      throw new Error(".importInterop must be one of \"none\", \"babel\", \"node\", or a function returning one of those values (received " + importInterop + ").");
		    }
		    return importInterop;
		  }
		  function resolveImportInterop(importInterop, source, filename) {
		    if (typeof importInterop === "function") {
		      return validateImportInteropOption(importInterop(source, filename));
		    }
		    return importInterop;
		  }
		  function normalizeModuleAndLoadMetadata(programPath, exportName, _ref) {
		    var importInterop = _ref.importInterop,
		      _ref$initializeReexpo = _ref.initializeReexports,
		      initializeReexports = _ref$initializeReexpo === void 0 ? false : _ref$initializeReexpo,
		      getWrapperPayload = _ref.getWrapperPayload,
		      _ref$esNamespaceOnly = _ref.esNamespaceOnly,
		      esNamespaceOnly = _ref$esNamespaceOnly === void 0 ? false : _ref$esNamespaceOnly,
		      filename = _ref.filename;
		    if (!exportName) {
		      exportName = programPath.scope.generateUidIdentifier("exports").name;
		    }
		    var stringSpecifiers = new Set();
		    nameAnonymousExports(programPath);
		    var _getModuleMetadata = getModuleMetadata(programPath, {
		        initializeReexports: initializeReexports,
		        getWrapperPayload: getWrapperPayload
		      }, stringSpecifiers),
		      local = _getModuleMetadata.local,
		      sources = _getModuleMetadata.sources,
		      hasExports = _getModuleMetadata.hasExports;
		    removeImportExportDeclarations(programPath);
		    for (var _iterator = _createForOfIteratorHelperLoose(sources), _step; !(_step = _iterator()).done;) {
		      var _step$value = _slicedToArray(_step.value, 2),
		        _source = _step$value[0],
		        _metadata = _step$value[1];
		      var importsNamespace = _metadata.importsNamespace,
		        imports = _metadata.imports;
		      if (importsNamespace.size > 0 && imports.size === 0) {
		        var _importsNamespace = _slicedToArray(importsNamespace, 1),
		          nameOfnamespace = _importsNamespace[0];
		        _metadata.name = nameOfnamespace;
		      }
		      var resolvedInterop = resolveImportInterop(importInterop, _source, filename);
		      if (resolvedInterop === "none") {
		        _metadata.interop = "none";
		      } else if (resolvedInterop === "node" && _metadata.interop === "namespace") {
		        _metadata.interop = "node-namespace";
		      } else if (resolvedInterop === "node" && _metadata.interop === "default") {
		        _metadata.interop = "node-default";
		      } else if (esNamespaceOnly && _metadata.interop === "namespace") {
		        _metadata.interop = "default";
		      }
		    }
		    return {
		      exportName: exportName,
		      exportNameListName: null,
		      hasExports: hasExports,
		      local: local,
		      source: sources,
		      stringSpecifiers: stringSpecifiers
		    };
		  }
		  function getExportSpecifierName$1(path, stringSpecifiers) {
		    if (path.isIdentifier()) {
		      return path.node.name;
		    } else if (path.isStringLiteral()) {
		      var stringValue = path.node.value;
		      if (!isIdentifierName(stringValue)) {
		        stringSpecifiers.add(stringValue);
		      }
		      return stringValue;
		    } else {
		      throw new Error("Expected export specifier to be either Identifier or StringLiteral, got " + path.node.type);
		    }
		  }
		  function assertExportSpecifier(path) {
		    if (path.isExportSpecifier()) {
		      return;
		    } else if (path.isExportNamespaceSpecifier()) {
		      throw path.buildCodeFrameError("Export namespace should be first transformed by `@babel/plugin-transform-export-namespace-from`.");
		    } else {
		      throw path.buildCodeFrameError("Unexpected export specifier type");
		    }
		  }
		  function getModuleMetadata(programPath, _ref2, stringSpecifiers) {
		    var getWrapperPayload = _ref2.getWrapperPayload,
		      initializeReexports = _ref2.initializeReexports;
		    var localData = getLocalExportMetadata(programPath, initializeReexports, stringSpecifiers);
		    var importNodes = new Map();
		    var sourceData = new Map();
		    var getData = function getData(sourceNode, node) {
		      var source = sourceNode.value;
		      var data = sourceData.get(source);
		      if (!data) {
		        data = {
		          name: programPath.scope.generateUidIdentifier(basename(source, extname(source))).name,
		          interop: "none",
		          loc: null,
		          imports: new Map(),
		          importsNamespace: new Set(),
		          reexports: new Map(),
		          reexportNamespace: new Set(),
		          reexportAll: null,
		          wrap: null,
		          get lazy() {
		            return this.wrap === "lazy";
		          },
		          referenced: false
		        };
		        sourceData.set(source, data);
		        importNodes.set(source, [node]);
		      } else {
		        importNodes.get(source).push(node);
		      }
		      return data;
		    };
		    var hasExports = false;
		    programPath.get("body").forEach(function (child) {
		      if (child.isImportDeclaration()) {
		        var data = getData(child.node.source, child.node);
		        if (!data.loc) data.loc = child.node.loc;
		        child.get("specifiers").forEach(function (spec) {
		          if (spec.isImportDefaultSpecifier()) {
		            var localName = spec.get("local").node.name;
		            data.imports.set(localName, "default");
		            var reexport = localData.get(localName);
		            if (reexport) {
		              localData["delete"](localName);
		              reexport.names.forEach(function (name) {
		                data.reexports.set(name, "default");
		              });
		              data.referenced = true;
		            }
		          } else if (spec.isImportNamespaceSpecifier()) {
		            var _localName = spec.get("local").node.name;
		            data.importsNamespace.add(_localName);
		            var _reexport = localData.get(_localName);
		            if (_reexport) {
		              localData["delete"](_localName);
		              _reexport.names.forEach(function (name) {
		                data.reexportNamespace.add(name);
		              });
		              data.referenced = true;
		            }
		          } else if (spec.isImportSpecifier()) {
		            var importName = getExportSpecifierName$1(spec.get("imported"), stringSpecifiers);
		            var _localName2 = spec.get("local").node.name;
		            data.imports.set(_localName2, importName);
		            var _reexport2 = localData.get(_localName2);
		            if (_reexport2) {
		              localData["delete"](_localName2);
		              _reexport2.names.forEach(function (name) {
		                data.reexports.set(name, importName);
		              });
		              data.referenced = true;
		            }
		          }
		        });
		      } else if (child.isExportAllDeclaration()) {
		        hasExports = true;
		        var _data = getData(child.node.source, child.node);
		        if (!_data.loc) _data.loc = child.node.loc;
		        _data.reexportAll = {
		          loc: child.node.loc
		        };
		        _data.referenced = true;
		      } else if (child.isExportNamedDeclaration() && child.node.source) {
		        hasExports = true;
		        var _data2 = getData(child.node.source, child.node);
		        if (!_data2.loc) _data2.loc = child.node.loc;
		        child.get("specifiers").forEach(function (spec) {
		          assertExportSpecifier(spec);
		          var importName = getExportSpecifierName$1(spec.get("local"), stringSpecifiers);
		          var exportName = getExportSpecifierName$1(spec.get("exported"), stringSpecifiers);
		          _data2.reexports.set(exportName, importName);
		          _data2.referenced = true;
		          if (exportName === "__esModule") {
		            throw spec.get("exported").buildCodeFrameError('Illegal export "__esModule".');
		          }
		        });
		      } else if (child.isExportNamedDeclaration() || child.isExportDefaultDeclaration()) {
		        hasExports = true;
		      }
		    });
		    for (var _iterator2 = _createForOfIteratorHelperLoose(sourceData.values()), _step2; !(_step2 = _iterator2()).done;) {
		      var _metadata3 = _step2.value;
		      var needsDefault = false;
		      var needsNamed = false;
		      if (_metadata3.importsNamespace.size > 0) {
		        needsDefault = true;
		        needsNamed = true;
		      }
		      if (_metadata3.reexportAll) {
		        needsNamed = true;
		      }
		      for (var _iterator4 = _createForOfIteratorHelperLoose(_metadata3.imports.values()), _step4; !(_step4 = _iterator4()).done;) {
		        var importName = _step4.value;
		        if (importName === "default") needsDefault = true;else needsNamed = true;
		      }
		      for (var _iterator5 = _createForOfIteratorHelperLoose(_metadata3.reexports.values()), _step5; !(_step5 = _iterator5()).done;) {
		        var _importName = _step5.value;
		        if (_importName === "default") needsDefault = true;else needsNamed = true;
		      }
		      if (needsDefault && needsNamed) {
		        _metadata3.interop = "namespace";
		      } else if (needsDefault) {
		        _metadata3.interop = "default";
		      }
		    }
		    if (getWrapperPayload) {
		      for (var _iterator3 = _createForOfIteratorHelperLoose(sourceData), _step3; !(_step3 = _iterator3()).done;) {
		        var _step3$value = _slicedToArray(_step3.value, 2),
		          _source2 = _step3$value[0],
		          _metadata2 = _step3$value[1];
		        _metadata2.wrap = getWrapperPayload(_source2, _metadata2, importNodes.get(_source2));
		      }
		    }
		    return {
		      hasExports: hasExports,
		      local: localData,
		      sources: sourceData
		    };
		  }
		  function getLocalExportMetadata(programPath, initializeReexports, stringSpecifiers) {
		    var bindingKindLookup = new Map();
		    programPath.get("body").forEach(function (child) {
		      var kind;
		      if (child.isImportDeclaration()) {
		        kind = "import";
		      } else {
		        if (child.isExportDefaultDeclaration()) {
		          child = child.get("declaration");
		        }
		        if (child.isExportNamedDeclaration()) {
		          if (child.node.declaration) {
		            child = child.get("declaration");
		          } else if (initializeReexports && child.node.source && child.get("source").isStringLiteral()) {
		            child.get("specifiers").forEach(function (spec) {
		              assertExportSpecifier(spec);
		              bindingKindLookup.set(spec.get("local").node.name, "block");
		            });
		            return;
		          }
		        }
		        if (child.isFunctionDeclaration()) {
		          kind = "hoisted";
		        } else if (child.isClassDeclaration()) {
		          kind = "block";
		        } else if (child.isVariableDeclaration({
		          kind: "var"
		        })) {
		          kind = "var";
		        } else if (child.isVariableDeclaration()) {
		          kind = "block";
		        } else {
		          return;
		        }
		      }
		      Object.keys(child.getOuterBindingIdentifiers()).forEach(function (name) {
		        bindingKindLookup.set(name, kind);
		      });
		    });
		    var localMetadata = new Map();
		    var getLocalMetadata = function getLocalMetadata(idPath) {
		      var localName = idPath.node.name;
		      var metadata = localMetadata.get(localName);
		      if (!metadata) {
		        var kind = bindingKindLookup.get(localName);
		        if (kind === undefined) {
		          throw idPath.buildCodeFrameError("Exporting local \"" + localName + "\", which is not declared.");
		        }
		        metadata = {
		          names: [],
		          kind: kind
		        };
		        localMetadata.set(localName, metadata);
		      }
		      return metadata;
		    };
		    programPath.get("body").forEach(function (child) {
		      if (child.isExportNamedDeclaration() && (initializeReexports || !child.node.source)) {
		        if (child.node.declaration) {
		          var declaration = child.get("declaration");
		          var ids = declaration.getOuterBindingIdentifierPaths();
		          Object.keys(ids).forEach(function (name) {
		            if (name === "__esModule") {
		              throw declaration.buildCodeFrameError('Illegal export "__esModule".');
		            }
		            getLocalMetadata(ids[name]).names.push(name);
		          });
		        } else {
		          child.get("specifiers").forEach(function (spec) {
		            var local = spec.get("local");
		            var exported = spec.get("exported");
		            var localMetadata = getLocalMetadata(local);
		            var exportName = getExportSpecifierName$1(exported, stringSpecifiers);
		            if (exportName === "__esModule") {
		              throw exported.buildCodeFrameError('Illegal export "__esModule".');
		            }
		            localMetadata.names.push(exportName);
		          });
		        }
		      } else if (child.isExportDefaultDeclaration()) {
		        var _declaration = child.get("declaration");
		        if (_declaration.isFunctionDeclaration() || _declaration.isClassDeclaration()) {
		          getLocalMetadata(_declaration.get("id")).names.push("default");
		        } else {
		          throw _declaration.buildCodeFrameError("Unexpected default expression export.");
		        }
		      }
		    });
		    return localMetadata;
		  }
		  function nameAnonymousExports(programPath) {
		    programPath.get("body").forEach(function (child) {
		      if (!child.isExportDefaultDeclaration()) return;
		      splitExportDeclaration(child);
		    });
		  }
		  function removeImportExportDeclarations(programPath) {
		    programPath.get("body").forEach(function (child) {
		      if (child.isImportDeclaration()) {
		        child.remove();
		      } else if (child.isExportNamedDeclaration()) {
		        if (child.node.declaration) {
		          child.node.declaration._blockHoist = child.node._blockHoist;
		          child.replaceWith(child.node.declaration);
		        } else {
		          child.remove();
		        }
		      } else if (child.isExportDefaultDeclaration()) {
		        var declaration = child.get("declaration");
		        if (declaration.isFunctionDeclaration() || declaration.isClassDeclaration()) {
		          declaration._blockHoist = child.node._blockHoist;
		          child.replaceWith(declaration);
		        } else {
		          throw declaration.buildCodeFrameError("Unexpected default expression export.");
		        }
		      } else if (child.isExportAllDeclaration()) {
		        child.remove();
		      }
		    });
		  }

		  function toGetWrapperPayload(lazy) {
		    return function (source, metadata) {
		      if (lazy === false) return null;
		      if (isSideEffectImport(metadata) || metadata.reexportAll) return null;
		      if (lazy === true) {
		        return /\./.test(source) ? null : "lazy";
		      }
		      if (Array.isArray(lazy)) {
		        return lazy.indexOf(source) === -1 ? null : "lazy";
		      }
		      if (typeof lazy === "function") {
		        return lazy(source) ? "lazy" : null;
		      }
		      throw new Error(".lazy must be a boolean, string array, or function");
		    };
		  }
		  function wrapReference(ref, payload) {
		    if (payload === "lazy") return callExpression$d(ref, []);
		    return null;
		  }

		  var _templateObject$z, _templateObject2$j, _templateObject3$d, _templateObject4$9;
		  function buildDynamicImport(node, deferToThen, wrapWithPromise, builder) {
		    var specifier = isCallExpression$8(node) ? node.arguments[0] : node.source;
		    if (isStringLiteral$5(specifier) || isTemplateLiteral$2(specifier) && specifier.quasis.length === 0) {
		      if (deferToThen) {
		        return template$1.expression.ast(_templateObject$z || (_templateObject$z = _taggedTemplateLiteralLoose(["\n        Promise.resolve().then(() => ", ")\n      "])), builder(specifier));
		      } else return builder(specifier);
		    }
		    var specifierToString = isTemplateLiteral$2(specifier) ? identifier$j("specifier") : templateLiteral([templateElement({
		      raw: ""
		    }), templateElement({
		      raw: ""
		    })], [identifier$j("specifier")]);
		    if (deferToThen) {
		      return template$1.expression.ast(_templateObject2$j || (_templateObject2$j = _taggedTemplateLiteralLoose(["\n      (specifier =>\n        new Promise(r => r(", "))\n          .then(s => ", ")\n      )(", ")\n    "])), specifierToString, builder(identifier$j("s")), specifier);
		    } else if (wrapWithPromise) {
		      return template$1.expression.ast(_templateObject3$d || (_templateObject3$d = _taggedTemplateLiteralLoose(["\n      (specifier =>\n        new Promise(r => r(", "))\n      )(", ")\n    "])), builder(specifierToString), specifier);
		    } else {
		      return template$1.expression.ast(_templateObject4$9 || (_templateObject4$9 = _taggedTemplateLiteralLoose(["\n      (specifier => ", ")(", ")\n    "])), builder(specifierToString), specifier);
		    }
		  }

		  {
		    var originalGetModuleName = getModuleName;
		    getModuleName = function getModuleName(rootOpts, pluginOpts) {
		      var _pluginOpts$moduleId, _pluginOpts$moduleIds, _pluginOpts$getModule, _pluginOpts$moduleRoo;
		      return originalGetModuleName(rootOpts, {
		        moduleId: (_pluginOpts$moduleId = pluginOpts.moduleId) != null ? _pluginOpts$moduleId : rootOpts.moduleId,
		        moduleIds: (_pluginOpts$moduleIds = pluginOpts.moduleIds) != null ? _pluginOpts$moduleIds : rootOpts.moduleIds,
		        getModuleId: (_pluginOpts$getModule = pluginOpts.getModuleId) != null ? _pluginOpts$getModule : rootOpts.getModuleId,
		        moduleRoot: (_pluginOpts$moduleRoo = pluginOpts.moduleRoot) != null ? _pluginOpts$moduleRoo : rootOpts.moduleRoot
		      });
		    };
		  }
		  function getModuleName(rootOpts, pluginOpts) {
		    var filename = rootOpts.filename,
		      _rootOpts$filenameRel = rootOpts.filenameRelative,
		      filenameRelative = _rootOpts$filenameRel === void 0 ? filename : _rootOpts$filenameRel,
		      _rootOpts$sourceRoot = rootOpts.sourceRoot,
		      sourceRoot = _rootOpts$sourceRoot === void 0 ? pluginOpts.moduleRoot : _rootOpts$sourceRoot;
		    var moduleId = pluginOpts.moduleId,
		      _pluginOpts$moduleIds2 = pluginOpts.moduleIds,
		      moduleIds = _pluginOpts$moduleIds2 === void 0 ? !!moduleId : _pluginOpts$moduleIds2,
		      getModuleId = pluginOpts.getModuleId,
		      _pluginOpts$moduleRoo2 = pluginOpts.moduleRoot,
		      moduleRoot = _pluginOpts$moduleRoo2 === void 0 ? sourceRoot : _pluginOpts$moduleRoo2;
		    if (!moduleIds) return null;
		    if (moduleId != null && !getModuleId) {
		      return moduleId;
		    }
		    var moduleName = moduleRoot != null ? moduleRoot + "/" : "";
		    if (filenameRelative) {
		      var sourceRootReplacer = sourceRoot != null ? new RegExp("^" + sourceRoot + "/?") : "";
		      moduleName += filenameRelative.replace(sourceRootReplacer, "").replace(/\.(\w*?)$/, "");
		    }
		    moduleName = moduleName.replace(/\\/g, "/");
		    if (getModuleId) {
		      return getModuleId(moduleName) || moduleName;
		    } else {
		      return moduleName;
		    }
		  }

		  var _templateObject$y, _templateObject2$i, _templateObject3$c, _templateObject4$8, _templateObject5$5, _templateObject6$3, _templateObject7$2, _templateObject8$2, _templateObject9$2, _templateObject10$2, _templateObject11$2, _templateObject12$2, _templateObject13$2, _templateObject14$2;
		  var booleanLiteral$3 = booleanLiteral$4,
		    callExpression$7 = callExpression$d,
		    cloneNode$7 = cloneNode$j,
		    directive = directive$1,
		    directiveLiteral = directiveLiteral$1,
		    expressionStatement$1 = expressionStatement$a,
		    identifier$5 = identifier$j,
		    isIdentifier$4 = isIdentifier$i,
		    memberExpression$7 = memberExpression$c,
		    stringLiteral$3 = stringLiteral$8,
		    valueToNode = valueToNode$1,
		    variableDeclaration$2 = variableDeclaration$8,
		    variableDeclarator$2 = variableDeclarator$8;
		  function rewriteModuleStatementsAndPrepareHeader(path, _ref) {
		    var exportName = _ref.exportName,
		      strict = _ref.strict,
		      allowTopLevelThis = _ref.allowTopLevelThis,
		      strictMode = _ref.strictMode,
		      noInterop = _ref.noInterop,
		      _ref$importInterop = _ref.importInterop,
		      importInterop = _ref$importInterop === void 0 ? noInterop ? "none" : "babel" : _ref$importInterop,
		      lazy = _ref.lazy,
		      _ref$getWrapperPayloa = _ref.getWrapperPayload,
		      getWrapperPayload = _ref$getWrapperPayloa === void 0 ? toGetWrapperPayload(lazy != null ? lazy : false) : _ref$getWrapperPayloa,
		      _ref$wrapReference = _ref.wrapReference,
		      wrapReference$1 = _ref$wrapReference === void 0 ? wrapReference : _ref$wrapReference,
		      esNamespaceOnly = _ref.esNamespaceOnly,
		      filename = _ref.filename,
		      _ref$constantReexport = _ref.constantReexports,
		      constantReexports = _ref$constantReexport === void 0 ? arguments[1].loose : _ref$constantReexport,
		      _ref$enumerableModule = _ref.enumerableModuleMeta,
		      enumerableModuleMeta = _ref$enumerableModule === void 0 ? arguments[1].loose : _ref$enumerableModule,
		      noIncompleteNsImportDetection = _ref.noIncompleteNsImportDetection;
		    validateImportInteropOption(importInterop);
		    assert(isModule(path), "Cannot process module statements in a script");
		    path.node.sourceType = "script";
		    var meta = normalizeModuleAndLoadMetadata(path, exportName, {
		      importInterop: importInterop,
		      initializeReexports: constantReexports,
		      getWrapperPayload: getWrapperPayload,
		      esNamespaceOnly: esNamespaceOnly,
		      filename: filename
		    });
		    if (!allowTopLevelThis) {
		      rewriteThis(path);
		    }
		    rewriteLiveReferences(path, meta, wrapReference$1);
		    if (strictMode !== false) {
		      var hasStrict = path.node.directives.some(function (directive) {
		        return directive.value.value === "use strict";
		      });
		      if (!hasStrict) {
		        path.unshiftContainer("directives", directive(directiveLiteral("use strict")));
		      }
		    }
		    var headers = [];
		    if (hasExports(meta) && !strict) {
		      headers.push(buildESModuleHeader(meta, enumerableModuleMeta));
		    }
		    var nameList = buildExportNameListDeclaration(path, meta);
		    if (nameList) {
		      meta.exportNameListName = nameList.name;
		      headers.push(nameList.statement);
		    }
		    headers.push.apply(headers, _toConsumableArray(buildExportInitializationStatements(path, meta, wrapReference$1, constantReexports, noIncompleteNsImportDetection)));
		    return {
		      meta: meta,
		      headers: headers
		    };
		  }
		  function ensureStatementsHoisted(statements) {
		    statements.forEach(function (header) {
		      header._blockHoist = 3;
		    });
		  }
		  function wrapInterop(programPath, expr, type) {
		    if (type === "none") {
		      return null;
		    }
		    if (type === "node-namespace") {
		      return callExpression$7(programPath.hub.addHelper("interopRequireWildcard"), [expr, booleanLiteral$3(true)]);
		    } else if (type === "node-default") {
		      return null;
		    }
		    var helper;
		    if (type === "default") {
		      helper = "interopRequireDefault";
		    } else if (type === "namespace") {
		      helper = "interopRequireWildcard";
		    } else {
		      throw new Error("Unknown interop: " + type);
		    }
		    return callExpression$7(programPath.hub.addHelper(helper), [expr]);
		  }
		  function buildNamespaceInitStatements(metadata, sourceMetadata, constantReexports, wrapReference$1) {
		    var _wrapReference;
		    if (constantReexports === void 0) {
		      constantReexports = false;
		    }
		    if (wrapReference$1 === void 0) {
		      wrapReference$1 = wrapReference;
		    }
		    var statements = [];
		    var srcNamespaceId = identifier$5(sourceMetadata.name);
		    for (var _iterator = _createForOfIteratorHelperLoose(sourceMetadata.importsNamespace), _step; !(_step = _iterator()).done;) {
		      var localName = _step.value;
		      if (localName === sourceMetadata.name) continue;
		      statements.push(template$1.statement(_templateObject$y || (_templateObject$y = _taggedTemplateLiteralLoose(["var NAME = SOURCE;"])))({
		        NAME: localName,
		        SOURCE: cloneNode$7(srcNamespaceId)
		      }));
		    }
		    var srcNamespace = (_wrapReference = wrapReference$1(srcNamespaceId, sourceMetadata.wrap)) != null ? _wrapReference : srcNamespaceId;
		    if (constantReexports) {
		      statements.push.apply(statements, _toConsumableArray(buildReexportsFromMeta(metadata, sourceMetadata, true, wrapReference$1)));
		    }
		    for (var _iterator2 = _createForOfIteratorHelperLoose(sourceMetadata.reexportNamespace), _step2; !(_step2 = _iterator2()).done;) {
		      var exportName = _step2.value;
		      statements.push((!isIdentifier$i(srcNamespace) ? template$1.statement(_templateObject2$i || (_templateObject2$i = _taggedTemplateLiteralLoose(["\n            Object.defineProperty(EXPORTS, \"NAME\", {\n              enumerable: true,\n              get: function() {\n                return NAMESPACE;\n              }\n            });\n          "]))) : template$1.statement(_templateObject3$c || (_templateObject3$c = _taggedTemplateLiteralLoose(["EXPORTS.NAME = NAMESPACE;"]))))({
		        EXPORTS: metadata.exportName,
		        NAME: exportName,
		        NAMESPACE: cloneNode$7(srcNamespace)
		      }));
		    }
		    if (sourceMetadata.reexportAll) {
		      var statement = buildNamespaceReexport(metadata, cloneNode$7(srcNamespace), constantReexports);
		      statement.loc = sourceMetadata.reexportAll.loc;
		      statements.push(statement);
		    }
		    return statements;
		  }
		  var ReexportTemplate = {
		    constant: template$1.statement(_templateObject4$8 || (_templateObject4$8 = _taggedTemplateLiteralLoose(["EXPORTS.EXPORT_NAME = NAMESPACE_IMPORT;"]))),
		    constantComputed: template$1.statement(_templateObject5$5 || (_templateObject5$5 = _taggedTemplateLiteralLoose(["EXPORTS[\"EXPORT_NAME\"] = NAMESPACE_IMPORT;"]))),
		    spec: template$1.statement(_templateObject6$3 || (_templateObject6$3 = _taggedTemplateLiteralLoose(["\n    Object.defineProperty(EXPORTS, \"EXPORT_NAME\", {\n      enumerable: true,\n      get: function() {\n        return NAMESPACE_IMPORT;\n      },\n    });\n    "])))
		  };
		  function buildReexportsFromMeta(meta, metadata, constantReexports, wrapReference) {
		    var _wrapReference2;
		    var namespace = identifier$5(metadata.name);
		    namespace = (_wrapReference2 = wrapReference(namespace, metadata.wrap)) != null ? _wrapReference2 : namespace;
		    var stringSpecifiers = meta.stringSpecifiers;
		    return Array.from(metadata.reexports, function (_ref2) {
		      var _ref3 = _slicedToArray(_ref2, 2),
		        exportName = _ref3[0],
		        importName = _ref3[1];
		      var NAMESPACE_IMPORT = cloneNode$7(namespace);
		      if (importName === "default" && metadata.interop === "node-default") ; else if (stringSpecifiers.has(importName)) {
		        NAMESPACE_IMPORT = memberExpression$7(NAMESPACE_IMPORT, stringLiteral$3(importName), true);
		      } else {
		        NAMESPACE_IMPORT = memberExpression$7(NAMESPACE_IMPORT, identifier$5(importName));
		      }
		      var astNodes = {
		        EXPORTS: meta.exportName,
		        EXPORT_NAME: exportName,
		        NAMESPACE_IMPORT: NAMESPACE_IMPORT
		      };
		      if (constantReexports || isIdentifier$4(NAMESPACE_IMPORT)) {
		        if (stringSpecifiers.has(exportName)) {
		          return ReexportTemplate.constantComputed(astNodes);
		        } else {
		          return ReexportTemplate.constant(astNodes);
		        }
		      } else {
		        return ReexportTemplate.spec(astNodes);
		      }
		    });
		  }
		  function buildESModuleHeader(metadata, enumerableModuleMeta) {
		    if (enumerableModuleMeta === void 0) {
		      enumerableModuleMeta = false;
		    }
		    return (enumerableModuleMeta ? template$1.statement(_templateObject7$2 || (_templateObject7$2 = _taggedTemplateLiteralLoose(["\n        EXPORTS.__esModule = true;\n      "]))) : template$1.statement(_templateObject8$2 || (_templateObject8$2 = _taggedTemplateLiteralLoose(["\n        Object.defineProperty(EXPORTS, \"__esModule\", {\n          value: true,\n        });\n      "]))))({
		      EXPORTS: metadata.exportName
		    });
		  }
		  function buildNamespaceReexport(metadata, namespace, constantReexports) {
		    return (constantReexports ? template$1.statement(_templateObject9$2 || (_templateObject9$2 = _taggedTemplateLiteralLoose(["\n        Object.keys(NAMESPACE).forEach(function(key) {\n          if (key === \"default\" || key === \"__esModule\") return;\n          VERIFY_NAME_LIST;\n          if (key in EXPORTS && EXPORTS[key] === NAMESPACE[key]) return;\n\n          EXPORTS[key] = NAMESPACE[key];\n        });\n      "]))) : template$1.statement(_templateObject10$2 || (_templateObject10$2 = _taggedTemplateLiteralLoose(["\n        Object.keys(NAMESPACE).forEach(function(key) {\n          if (key === \"default\" || key === \"__esModule\") return;\n          VERIFY_NAME_LIST;\n          if (key in EXPORTS && EXPORTS[key] === NAMESPACE[key]) return;\n\n          Object.defineProperty(EXPORTS, key, {\n            enumerable: true,\n            get: function() {\n              return NAMESPACE[key];\n            },\n          });\n        });\n    "]))))({
		      NAMESPACE: namespace,
		      EXPORTS: metadata.exportName,
		      VERIFY_NAME_LIST: metadata.exportNameListName ? template$1(_templateObject11$2 || (_templateObject11$2 = _taggedTemplateLiteralLoose(["\n            if (Object.prototype.hasOwnProperty.call(EXPORTS_LIST, key)) return;\n          "])))({
		        EXPORTS_LIST: metadata.exportNameListName
		      }) : null
		    });
		  }
		  function buildExportNameListDeclaration(programPath, metadata) {
		    var exportedVars = Object.create(null);
		    for (var _iterator3 = _createForOfIteratorHelperLoose(metadata.local.values()), _step3; !(_step3 = _iterator3()).done;) {
		      var data = _step3.value;
		      for (var _iterator5 = _createForOfIteratorHelperLoose(data.names), _step5; !(_step5 = _iterator5()).done;) {
		        var _name = _step5.value;
		        exportedVars[_name] = true;
		      }
		    }
		    var hasReexport = false;
		    for (var _iterator4 = _createForOfIteratorHelperLoose(metadata.source.values()), _step4; !(_step4 = _iterator4()).done;) {
		      var _data = _step4.value;
		      for (var _iterator6 = _createForOfIteratorHelperLoose(_data.reexports.keys()), _step6; !(_step6 = _iterator6()).done;) {
		        var exportName = _step6.value;
		        exportedVars[exportName] = true;
		      }
		      for (var _iterator7 = _createForOfIteratorHelperLoose(_data.reexportNamespace), _step7; !(_step7 = _iterator7()).done;) {
		        var _exportName = _step7.value;
		        exportedVars[_exportName] = true;
		      }
		      hasReexport = hasReexport || !!_data.reexportAll;
		    }
		    if (!hasReexport || Object.keys(exportedVars).length === 0) return null;
		    var name = programPath.scope.generateUidIdentifier("exportNames");
		    delete exportedVars["default"];
		    return {
		      name: name.name,
		      statement: variableDeclaration$2("var", [variableDeclarator$2(name, valueToNode(exportedVars))])
		    };
		  }
		  function buildExportInitializationStatements(programPath, metadata, wrapReference, constantReexports, noIncompleteNsImportDetection) {
		    if (constantReexports === void 0) {
		      constantReexports = false;
		    }
		    if (noIncompleteNsImportDetection === void 0) {
		      noIncompleteNsImportDetection = false;
		    }
		    var initStatements = [];
		    for (var _iterator8 = _createForOfIteratorHelperLoose(metadata.local), _step8; !(_step8 = _iterator8()).done;) {
		      var _step8$value = _slicedToArray(_step8.value, 2),
		        localName = _step8$value[0],
		        data = _step8$value[1];
		      if (data.kind === "import") ; else if (data.kind === "hoisted") {
		        initStatements.push([data.names[0], buildInitStatement(metadata, data.names, identifier$5(localName))]);
		      } else if (!noIncompleteNsImportDetection) {
		        for (var _iterator11 = _createForOfIteratorHelperLoose(data.names), _step11; !(_step11 = _iterator11()).done;) {
		          var _exportName2 = _step11.value;
		          initStatements.push([_exportName2, null]);
		        }
		      }
		    }
		    for (var _iterator9 = _createForOfIteratorHelperLoose(metadata.source.values()), _step9; !(_step9 = _iterator9()).done;) {
		      var _data2 = _step9.value;
		      if (!constantReexports) {
		        var reexportsStatements = buildReexportsFromMeta(metadata, _data2, false, wrapReference);
		        var reexports = _toConsumableArray(_data2.reexports.keys());
		        for (var _i = 0; _i < reexportsStatements.length; _i++) {
		          initStatements.push([reexports[_i], reexportsStatements[_i]]);
		        }
		      }
		      if (!noIncompleteNsImportDetection) {
		        for (var _iterator12 = _createForOfIteratorHelperLoose(_data2.reexportNamespace), _step12; !(_step12 = _iterator12()).done;) {
		          var _exportName3 = _step12.value;
		          initStatements.push([_exportName3, null]);
		        }
		      }
		    }
		    initStatements.sort(function (_ref4, _ref5) {
		      var _ref6 = _slicedToArray(_ref4, 1),
		        a = _ref6[0];
		      var _ref7 = _slicedToArray(_ref5, 1),
		        b = _ref7[0];
		      if (a < b) return -1;
		      if (b < a) return 1;
		      return 0;
		    });
		    var results = [];
		    if (noIncompleteNsImportDetection) {
		      for (var _iterator10 = _createForOfIteratorHelperLoose(initStatements), _step10; !(_step10 = _iterator10()).done;) {
		        var _step10$value = _slicedToArray(_step10.value, 2),
		          initStatement = _step10$value[1];
		        results.push(initStatement);
		      }
		    } else {
		      var chunkSize = 100;
		      for (var i = 0; i < initStatements.length; i += chunkSize) {
		        var uninitializedExportNames = [];
		        for (var j = 0; j < chunkSize && i + j < initStatements.length; j++) {
		          var _initStatements = _slicedToArray(initStatements[i + j], 2),
		            exportName = _initStatements[0],
		            _initStatement = _initStatements[1];
		          if (_initStatement !== null) {
		            if (uninitializedExportNames.length > 0) {
		              results.push(buildInitStatement(metadata, uninitializedExportNames, programPath.scope.buildUndefinedNode()));
		              uninitializedExportNames = [];
		            }
		            results.push(_initStatement);
		          } else {
		            uninitializedExportNames.push(exportName);
		          }
		        }
		        if (uninitializedExportNames.length > 0) {
		          results.push(buildInitStatement(metadata, uninitializedExportNames, programPath.scope.buildUndefinedNode()));
		        }
		      }
		    }
		    return results;
		  }
		  var InitTemplate = {
		    computed: template$1.expression(_templateObject12$2 || (_templateObject12$2 = _taggedTemplateLiteralLoose(["EXPORTS[\"NAME\"] = VALUE"]))),
		    "default": template$1.expression(_templateObject13$2 || (_templateObject13$2 = _taggedTemplateLiteralLoose(["EXPORTS.NAME = VALUE"]))),
		    define: template$1.expression(_templateObject14$2 || (_templateObject14$2 = _taggedTemplateLiteralLoose(["Object.defineProperty(EXPORTS, \"NAME\", { enumerable:true, value: void 0, writable: true })[\"NAME\"] = VALUE"])))
		  };
		  function buildInitStatement(metadata, exportNames, initExpr) {
		    var stringSpecifiers = metadata.stringSpecifiers,
		      EXPORTS = metadata.exportName;
		    return expressionStatement$1(exportNames.reduce(function (acc, exportName) {
		      var params = {
		        EXPORTS: EXPORTS,
		        NAME: exportName,
		        VALUE: acc
		      };
		      if (exportName === "__proto__") {
		        return InitTemplate.define(params);
		      }
		      if (stringSpecifiers.has(exportName)) {
		        return InitTemplate.computed(params);
		      }
		      return InitTemplate["default"](params);
		    }, initExpr));
		  }

		  var semver$a = {exports: {}};

		  var hasRequiredSemver$2;
		  function requireSemver$2() {
		    if (hasRequiredSemver$2) return semver$a.exports;
		    hasRequiredSemver$2 = 1;
		    (function (module, exports) {
		      exports = module.exports = SemVer;
		      var debug;
		      if (typeof browser$1$1 === 'object' && browser$1$1.env && browser$1$1.env.NODE_DEBUG && /\bsemver\b/i.test(browser$1$1.env.NODE_DEBUG)) {
		        debug = function debug() {
		          var args = Array.prototype.slice.call(arguments, 0);
		          args.unshift('SEMVER');
		          console.log.apply(console, args);
		        };
		      } else {
		        debug = function debug() {};
		      }
		      exports.SEMVER_SPEC_VERSION = '2.0.0';
		      var MAX_LENGTH = 256;
		      var MAX_SAFE_INTEGER = Number.MAX_SAFE_INTEGER || 9007199254740991;
		      var MAX_SAFE_COMPONENT_LENGTH = 16;
		      var MAX_SAFE_BUILD_LENGTH = MAX_LENGTH - 6;
		      var re = exports.re = [];
		      var safeRe = exports.safeRe = [];
		      var src = exports.src = [];
		      var t = exports.tokens = {};
		      var R = 0;
		      function tok(n) {
		        t[n] = R++;
		      }
		      var LETTERDASHNUMBER = '[a-zA-Z0-9-]';
		      var safeRegexReplacements = [['\\s', 1], ['\\d', MAX_LENGTH], [LETTERDASHNUMBER, MAX_SAFE_BUILD_LENGTH]];
		      function makeSafeRe(value) {
		        for (var i = 0; i < safeRegexReplacements.length; i++) {
		          var token = safeRegexReplacements[i][0];
		          var max = safeRegexReplacements[i][1];
		          value = value.split(token + '*').join(token + '{0,' + max + '}').split(token + '+').join(token + '{1,' + max + '}');
		        }
		        return value;
		      }
		      tok('NUMERICIDENTIFIER');
		      src[t.NUMERICIDENTIFIER] = '0|[1-9]\\d*';
		      tok('NUMERICIDENTIFIERLOOSE');
		      src[t.NUMERICIDENTIFIERLOOSE] = '\\d+';
		      tok('NONNUMERICIDENTIFIER');
		      src[t.NONNUMERICIDENTIFIER] = '\\d*[a-zA-Z-]' + LETTERDASHNUMBER + '*';
		      tok('MAINVERSION');
		      src[t.MAINVERSION] = '(' + src[t.NUMERICIDENTIFIER] + ')\\.' + '(' + src[t.NUMERICIDENTIFIER] + ')\\.' + '(' + src[t.NUMERICIDENTIFIER] + ')';
		      tok('MAINVERSIONLOOSE');
		      src[t.MAINVERSIONLOOSE] = '(' + src[t.NUMERICIDENTIFIERLOOSE] + ')\\.' + '(' + src[t.NUMERICIDENTIFIERLOOSE] + ')\\.' + '(' + src[t.NUMERICIDENTIFIERLOOSE] + ')';
		      tok('PRERELEASEIDENTIFIER');
		      src[t.PRERELEASEIDENTIFIER] = '(?:' + src[t.NUMERICIDENTIFIER] + '|' + src[t.NONNUMERICIDENTIFIER] + ')';
		      tok('PRERELEASEIDENTIFIERLOOSE');
		      src[t.PRERELEASEIDENTIFIERLOOSE] = '(?:' + src[t.NUMERICIDENTIFIERLOOSE] + '|' + src[t.NONNUMERICIDENTIFIER] + ')';
		      tok('PRERELEASE');
		      src[t.PRERELEASE] = '(?:-(' + src[t.PRERELEASEIDENTIFIER] + '(?:\\.' + src[t.PRERELEASEIDENTIFIER] + ')*))';
		      tok('PRERELEASELOOSE');
		      src[t.PRERELEASELOOSE] = '(?:-?(' + src[t.PRERELEASEIDENTIFIERLOOSE] + '(?:\\.' + src[t.PRERELEASEIDENTIFIERLOOSE] + ')*))';
		      tok('BUILDIDENTIFIER');
		      src[t.BUILDIDENTIFIER] = LETTERDASHNUMBER + '+';
		      tok('BUILD');
		      src[t.BUILD] = '(?:\\+(' + src[t.BUILDIDENTIFIER] + '(?:\\.' + src[t.BUILDIDENTIFIER] + ')*))';
		      tok('FULL');
		      tok('FULLPLAIN');
		      src[t.FULLPLAIN] = 'v?' + src[t.MAINVERSION] + src[t.PRERELEASE] + '?' + src[t.BUILD] + '?';
		      src[t.FULL] = '^' + src[t.FULLPLAIN] + '$';
		      tok('LOOSEPLAIN');
		      src[t.LOOSEPLAIN] = '[v=\\s]*' + src[t.MAINVERSIONLOOSE] + src[t.PRERELEASELOOSE] + '?' + src[t.BUILD] + '?';
		      tok('LOOSE');
		      src[t.LOOSE] = '^' + src[t.LOOSEPLAIN] + '$';
		      tok('GTLT');
		      src[t.GTLT] = '((?:<|>)?=?)';
		      tok('XRANGEIDENTIFIERLOOSE');
		      src[t.XRANGEIDENTIFIERLOOSE] = src[t.NUMERICIDENTIFIERLOOSE] + '|x|X|\\*';
		      tok('XRANGEIDENTIFIER');
		      src[t.XRANGEIDENTIFIER] = src[t.NUMERICIDENTIFIER] + '|x|X|\\*';
		      tok('XRANGEPLAIN');
		      src[t.XRANGEPLAIN] = '[v=\\s]*(' + src[t.XRANGEIDENTIFIER] + ')' + '(?:\\.(' + src[t.XRANGEIDENTIFIER] + ')' + '(?:\\.(' + src[t.XRANGEIDENTIFIER] + ')' + '(?:' + src[t.PRERELEASE] + ')?' + src[t.BUILD] + '?' + ')?)?';
		      tok('XRANGEPLAINLOOSE');
		      src[t.XRANGEPLAINLOOSE] = '[v=\\s]*(' + src[t.XRANGEIDENTIFIERLOOSE] + ')' + '(?:\\.(' + src[t.XRANGEIDENTIFIERLOOSE] + ')' + '(?:\\.(' + src[t.XRANGEIDENTIFIERLOOSE] + ')' + '(?:' + src[t.PRERELEASELOOSE] + ')?' + src[t.BUILD] + '?' + ')?)?';
		      tok('XRANGE');
		      src[t.XRANGE] = '^' + src[t.GTLT] + '\\s*' + src[t.XRANGEPLAIN] + '$';
		      tok('XRANGELOOSE');
		      src[t.XRANGELOOSE] = '^' + src[t.GTLT] + '\\s*' + src[t.XRANGEPLAINLOOSE] + '$';
		      tok('COERCE');
		      src[t.COERCE] = '(^|[^\\d])' + '(\\d{1,' + MAX_SAFE_COMPONENT_LENGTH + '})' + '(?:\\.(\\d{1,' + MAX_SAFE_COMPONENT_LENGTH + '}))?' + '(?:\\.(\\d{1,' + MAX_SAFE_COMPONENT_LENGTH + '}))?' + '(?:$|[^\\d])';
		      tok('COERCERTL');
		      re[t.COERCERTL] = new RegExp(src[t.COERCE], 'g');
		      safeRe[t.COERCERTL] = new RegExp(makeSafeRe(src[t.COERCE]), 'g');
		      tok('LONETILDE');
		      src[t.LONETILDE] = '(?:~>?)';
		      tok('TILDETRIM');
		      src[t.TILDETRIM] = '(\\s*)' + src[t.LONETILDE] + '\\s+';
		      re[t.TILDETRIM] = new RegExp(src[t.TILDETRIM], 'g');
		      safeRe[t.TILDETRIM] = new RegExp(makeSafeRe(src[t.TILDETRIM]), 'g');
		      var tildeTrimReplace = '$1~';
		      tok('TILDE');
		      src[t.TILDE] = '^' + src[t.LONETILDE] + src[t.XRANGEPLAIN] + '$';
		      tok('TILDELOOSE');
		      src[t.TILDELOOSE] = '^' + src[t.LONETILDE] + src[t.XRANGEPLAINLOOSE] + '$';
		      tok('LONECARET');
		      src[t.LONECARET] = '(?:\\^)';
		      tok('CARETTRIM');
		      src[t.CARETTRIM] = '(\\s*)' + src[t.LONECARET] + '\\s+';
		      re[t.CARETTRIM] = new RegExp(src[t.CARETTRIM], 'g');
		      safeRe[t.CARETTRIM] = new RegExp(makeSafeRe(src[t.CARETTRIM]), 'g');
		      var caretTrimReplace = '$1^';
		      tok('CARET');
		      src[t.CARET] = '^' + src[t.LONECARET] + src[t.XRANGEPLAIN] + '$';
		      tok('CARETLOOSE');
		      src[t.CARETLOOSE] = '^' + src[t.LONECARET] + src[t.XRANGEPLAINLOOSE] + '$';
		      tok('COMPARATORLOOSE');
		      src[t.COMPARATORLOOSE] = '^' + src[t.GTLT] + '\\s*(' + src[t.LOOSEPLAIN] + ')$|^$';
		      tok('COMPARATOR');
		      src[t.COMPARATOR] = '^' + src[t.GTLT] + '\\s*(' + src[t.FULLPLAIN] + ')$|^$';
		      tok('COMPARATORTRIM');
		      src[t.COMPARATORTRIM] = '(\\s*)' + src[t.GTLT] + '\\s*(' + src[t.LOOSEPLAIN] + '|' + src[t.XRANGEPLAIN] + ')';
		      re[t.COMPARATORTRIM] = new RegExp(src[t.COMPARATORTRIM], 'g');
		      safeRe[t.COMPARATORTRIM] = new RegExp(makeSafeRe(src[t.COMPARATORTRIM]), 'g');
		      var comparatorTrimReplace = '$1$2$3';
		      tok('HYPHENRANGE');
		      src[t.HYPHENRANGE] = '^\\s*(' + src[t.XRANGEPLAIN] + ')' + '\\s+-\\s+' + '(' + src[t.XRANGEPLAIN] + ')' + '\\s*$';
		      tok('HYPHENRANGELOOSE');
		      src[t.HYPHENRANGELOOSE] = '^\\s*(' + src[t.XRANGEPLAINLOOSE] + ')' + '\\s+-\\s+' + '(' + src[t.XRANGEPLAINLOOSE] + ')' + '\\s*$';
		      tok('STAR');
		      src[t.STAR] = '(<|>)?=?\\s*\\*';
		      for (var i = 0; i < R; i++) {
		        debug(i, src[i]);
		        if (!re[i]) {
		          re[i] = new RegExp(src[i]);
		          safeRe[i] = new RegExp(makeSafeRe(src[i]));
		        }
		      }
		      exports.parse = parse;
		      function parse(version, options) {
		        if (!options || typeof options !== 'object') {
		          options = {
		            loose: !!options,
		            includePrerelease: false
		          };
		        }
		        if (version instanceof SemVer) {
		          return version;
		        }
		        if (typeof version !== 'string') {
		          return null;
		        }
		        if (version.length > MAX_LENGTH) {
		          return null;
		        }
		        var r = options.loose ? safeRe[t.LOOSE] : safeRe[t.FULL];
		        if (!r.test(version)) {
		          return null;
		        }
		        try {
		          return new SemVer(version, options);
		        } catch (er) {
		          return null;
		        }
		      }
		      exports.valid = valid;
		      function valid(version, options) {
		        var v = parse(version, options);
		        return v ? v.version : null;
		      }
		      exports.clean = clean;
		      function clean(version, options) {
		        var s = parse(version.trim().replace(/^[=v]+/, ''), options);
		        return s ? s.version : null;
		      }
		      exports.SemVer = SemVer;
		      function SemVer(version, options) {
		        if (!options || typeof options !== 'object') {
		          options = {
		            loose: !!options,
		            includePrerelease: false
		          };
		        }
		        if (version instanceof SemVer) {
		          if (version.loose === options.loose) {
		            return version;
		          } else {
		            version = version.version;
		          }
		        } else if (typeof version !== 'string') {
		          throw new TypeError('Invalid Version: ' + version);
		        }
		        if (version.length > MAX_LENGTH) {
		          throw new TypeError('version is longer than ' + MAX_LENGTH + ' characters');
		        }
		        if (!(this instanceof SemVer)) {
		          return new SemVer(version, options);
		        }
		        debug('SemVer', version, options);
		        this.options = options;
		        this.loose = !!options.loose;
		        var m = version.trim().match(options.loose ? safeRe[t.LOOSE] : safeRe[t.FULL]);
		        if (!m) {
		          throw new TypeError('Invalid Version: ' + version);
		        }
		        this.raw = version;
		        this.major = +m[1];
		        this.minor = +m[2];
		        this.patch = +m[3];
		        if (this.major > MAX_SAFE_INTEGER || this.major < 0) {
		          throw new TypeError('Invalid major version');
		        }
		        if (this.minor > MAX_SAFE_INTEGER || this.minor < 0) {
		          throw new TypeError('Invalid minor version');
		        }
		        if (this.patch > MAX_SAFE_INTEGER || this.patch < 0) {
		          throw new TypeError('Invalid patch version');
		        }
		        if (!m[4]) {
		          this.prerelease = [];
		        } else {
		          this.prerelease = m[4].split('.').map(function (id) {
		            if (/^[0-9]+$/.test(id)) {
		              var num = +id;
		              if (num >= 0 && num < MAX_SAFE_INTEGER) {
		                return num;
		              }
		            }
		            return id;
		          });
		        }
		        this.build = m[5] ? m[5].split('.') : [];
		        this.format();
		      }
		      SemVer.prototype.format = function () {
		        this.version = this.major + '.' + this.minor + '.' + this.patch;
		        if (this.prerelease.length) {
		          this.version += '-' + this.prerelease.join('.');
		        }
		        return this.version;
		      };
		      SemVer.prototype.toString = function () {
		        return this.version;
		      };
		      SemVer.prototype.compare = function (other) {
		        debug('SemVer.compare', this.version, this.options, other);
		        if (!(other instanceof SemVer)) {
		          other = new SemVer(other, this.options);
		        }
		        return this.compareMain(other) || this.comparePre(other);
		      };
		      SemVer.prototype.compareMain = function (other) {
		        if (!(other instanceof SemVer)) {
		          other = new SemVer(other, this.options);
		        }
		        return compareIdentifiers(this.major, other.major) || compareIdentifiers(this.minor, other.minor) || compareIdentifiers(this.patch, other.patch);
		      };
		      SemVer.prototype.comparePre = function (other) {
		        if (!(other instanceof SemVer)) {
		          other = new SemVer(other, this.options);
		        }
		        if (this.prerelease.length && !other.prerelease.length) {
		          return -1;
		        } else if (!this.prerelease.length && other.prerelease.length) {
		          return 1;
		        } else if (!this.prerelease.length && !other.prerelease.length) {
		          return 0;
		        }
		        var i = 0;
		        do {
		          var a = this.prerelease[i];
		          var b = other.prerelease[i];
		          debug('prerelease compare', i, a, b);
		          if (a === undefined && b === undefined) {
		            return 0;
		          } else if (b === undefined) {
		            return 1;
		          } else if (a === undefined) {
		            return -1;
		          } else if (a === b) {
		            continue;
		          } else {
		            return compareIdentifiers(a, b);
		          }
		        } while (++i);
		      };
		      SemVer.prototype.compareBuild = function (other) {
		        if (!(other instanceof SemVer)) {
		          other = new SemVer(other, this.options);
		        }
		        var i = 0;
		        do {
		          var a = this.build[i];
		          var b = other.build[i];
		          debug('prerelease compare', i, a, b);
		          if (a === undefined && b === undefined) {
		            return 0;
		          } else if (b === undefined) {
		            return 1;
		          } else if (a === undefined) {
		            return -1;
		          } else if (a === b) {
		            continue;
		          } else {
		            return compareIdentifiers(a, b);
		          }
		        } while (++i);
		      };
		      SemVer.prototype.inc = function (release, identifier) {
		        switch (release) {
		          case 'premajor':
		            this.prerelease.length = 0;
		            this.patch = 0;
		            this.minor = 0;
		            this.major++;
		            this.inc('pre', identifier);
		            break;
		          case 'preminor':
		            this.prerelease.length = 0;
		            this.patch = 0;
		            this.minor++;
		            this.inc('pre', identifier);
		            break;
		          case 'prepatch':
		            this.prerelease.length = 0;
		            this.inc('patch', identifier);
		            this.inc('pre', identifier);
		            break;
		          case 'prerelease':
		            if (this.prerelease.length === 0) {
		              this.inc('patch', identifier);
		            }
		            this.inc('pre', identifier);
		            break;
		          case 'major':
		            if (this.minor !== 0 || this.patch !== 0 || this.prerelease.length === 0) {
		              this.major++;
		            }
		            this.minor = 0;
		            this.patch = 0;
		            this.prerelease = [];
		            break;
		          case 'minor':
		            if (this.patch !== 0 || this.prerelease.length === 0) {
		              this.minor++;
		            }
		            this.patch = 0;
		            this.prerelease = [];
		            break;
		          case 'patch':
		            if (this.prerelease.length === 0) {
		              this.patch++;
		            }
		            this.prerelease = [];
		            break;
		          case 'pre':
		            if (this.prerelease.length === 0) {
		              this.prerelease = [0];
		            } else {
		              var i = this.prerelease.length;
		              while (--i >= 0) {
		                if (typeof this.prerelease[i] === 'number') {
		                  this.prerelease[i]++;
		                  i = -2;
		                }
		              }
		              if (i === -1) {
		                this.prerelease.push(0);
		              }
		            }
		            if (identifier) {
		              if (this.prerelease[0] === identifier) {
		                if (isNaN(this.prerelease[1])) {
		                  this.prerelease = [identifier, 0];
		                }
		              } else {
		                this.prerelease = [identifier, 0];
		              }
		            }
		            break;
		          default:
		            throw new Error('invalid increment argument: ' + release);
		        }
		        this.format();
		        this.raw = this.version;
		        return this;
		      };
		      exports.inc = inc;
		      function inc(version, release, loose, identifier) {
		        if (typeof loose === 'string') {
		          identifier = loose;
		          loose = undefined;
		        }
		        try {
		          return new SemVer(version, loose).inc(release, identifier).version;
		        } catch (er) {
		          return null;
		        }
		      }
		      exports.diff = diff;
		      function diff(version1, version2) {
		        if (eq(version1, version2)) {
		          return null;
		        } else {
		          var v1 = parse(version1);
		          var v2 = parse(version2);
		          var prefix = '';
		          if (v1.prerelease.length || v2.prerelease.length) {
		            prefix = 'pre';
		            var defaultResult = 'prerelease';
		          }
		          for (var key in v1) {
		            if (key === 'major' || key === 'minor' || key === 'patch') {
		              if (v1[key] !== v2[key]) {
		                return prefix + key;
		              }
		            }
		          }
		          return defaultResult;
		        }
		      }
		      exports.compareIdentifiers = compareIdentifiers;
		      var numeric = /^[0-9]+$/;
		      function compareIdentifiers(a, b) {
		        var anum = numeric.test(a);
		        var bnum = numeric.test(b);
		        if (anum && bnum) {
		          a = +a;
		          b = +b;
		        }
		        return a === b ? 0 : anum && !bnum ? -1 : bnum && !anum ? 1 : a < b ? -1 : 1;
		      }
		      exports.rcompareIdentifiers = rcompareIdentifiers;
		      function rcompareIdentifiers(a, b) {
		        return compareIdentifiers(b, a);
		      }
		      exports.major = major;
		      function major(a, loose) {
		        return new SemVer(a, loose).major;
		      }
		      exports.minor = minor;
		      function minor(a, loose) {
		        return new SemVer(a, loose).minor;
		      }
		      exports.patch = patch;
		      function patch(a, loose) {
		        return new SemVer(a, loose).patch;
		      }
		      exports.compare = compare;
		      function compare(a, b, loose) {
		        return new SemVer(a, loose).compare(new SemVer(b, loose));
		      }
		      exports.compareLoose = compareLoose;
		      function compareLoose(a, b) {
		        return compare(a, b, true);
		      }
		      exports.compareBuild = compareBuild;
		      function compareBuild(a, b, loose) {
		        var versionA = new SemVer(a, loose);
		        var versionB = new SemVer(b, loose);
		        return versionA.compare(versionB) || versionA.compareBuild(versionB);
		      }
		      exports.rcompare = rcompare;
		      function rcompare(a, b, loose) {
		        return compare(b, a, loose);
		      }
		      exports.sort = sort;
		      function sort(list, loose) {
		        return list.sort(function (a, b) {
		          return exports.compareBuild(a, b, loose);
		        });
		      }
		      exports.rsort = rsort;
		      function rsort(list, loose) {
		        return list.sort(function (a, b) {
		          return exports.compareBuild(b, a, loose);
		        });
		      }
		      exports.gt = gt;
		      function gt(a, b, loose) {
		        return compare(a, b, loose) > 0;
		      }
		      exports.lt = lt;
		      function lt(a, b, loose) {
		        return compare(a, b, loose) < 0;
		      }
		      exports.eq = eq;
		      function eq(a, b, loose) {
		        return compare(a, b, loose) === 0;
		      }
		      exports.neq = neq;
		      function neq(a, b, loose) {
		        return compare(a, b, loose) !== 0;
		      }
		      exports.gte = gte;
		      function gte(a, b, loose) {
		        return compare(a, b, loose) >= 0;
		      }
		      exports.lte = lte;
		      function lte(a, b, loose) {
		        return compare(a, b, loose) <= 0;
		      }
		      exports.cmp = cmp;
		      function cmp(a, op, b, loose) {
		        switch (op) {
		          case '===':
		            if (typeof a === 'object') a = a.version;
		            if (typeof b === 'object') b = b.version;
		            return a === b;
		          case '!==':
		            if (typeof a === 'object') a = a.version;
		            if (typeof b === 'object') b = b.version;
		            return a !== b;
		          case '':
		          case '=':
		          case '==':
		            return eq(a, b, loose);
		          case '!=':
		            return neq(a, b, loose);
		          case '>':
		            return gt(a, b, loose);
		          case '>=':
		            return gte(a, b, loose);
		          case '<':
		            return lt(a, b, loose);
		          case '<=':
		            return lte(a, b, loose);
		          default:
		            throw new TypeError('Invalid operator: ' + op);
		        }
		      }
		      exports.Comparator = Comparator;
		      function Comparator(comp, options) {
		        if (!options || typeof options !== 'object') {
		          options = {
		            loose: !!options,
		            includePrerelease: false
		          };
		        }
		        if (comp instanceof Comparator) {
		          if (comp.loose === !!options.loose) {
		            return comp;
		          } else {
		            comp = comp.value;
		          }
		        }
		        if (!(this instanceof Comparator)) {
		          return new Comparator(comp, options);
		        }
		        comp = comp.trim().split(/\s+/).join(' ');
		        debug('comparator', comp, options);
		        this.options = options;
		        this.loose = !!options.loose;
		        this.parse(comp);
		        if (this.semver === ANY) {
		          this.value = '';
		        } else {
		          this.value = this.operator + this.semver.version;
		        }
		        debug('comp', this);
		      }
		      var ANY = {};
		      Comparator.prototype.parse = function (comp) {
		        var r = this.options.loose ? safeRe[t.COMPARATORLOOSE] : safeRe[t.COMPARATOR];
		        var m = comp.match(r);
		        if (!m) {
		          throw new TypeError('Invalid comparator: ' + comp);
		        }
		        this.operator = m[1] !== undefined ? m[1] : '';
		        if (this.operator === '=') {
		          this.operator = '';
		        }
		        if (!m[2]) {
		          this.semver = ANY;
		        } else {
		          this.semver = new SemVer(m[2], this.options.loose);
		        }
		      };
		      Comparator.prototype.toString = function () {
		        return this.value;
		      };
		      Comparator.prototype.test = function (version) {
		        debug('Comparator.test', version, this.options.loose);
		        if (this.semver === ANY || version === ANY) {
		          return true;
		        }
		        if (typeof version === 'string') {
		          try {
		            version = new SemVer(version, this.options);
		          } catch (er) {
		            return false;
		          }
		        }
		        return cmp(version, this.operator, this.semver, this.options);
		      };
		      Comparator.prototype.intersects = function (comp, options) {
		        if (!(comp instanceof Comparator)) {
		          throw new TypeError('a Comparator is required');
		        }
		        if (!options || typeof options !== 'object') {
		          options = {
		            loose: !!options,
		            includePrerelease: false
		          };
		        }
		        var rangeTmp;
		        if (this.operator === '') {
		          if (this.value === '') {
		            return true;
		          }
		          rangeTmp = new Range(comp.value, options);
		          return satisfies(this.value, rangeTmp, options);
		        } else if (comp.operator === '') {
		          if (comp.value === '') {
		            return true;
		          }
		          rangeTmp = new Range(this.value, options);
		          return satisfies(comp.semver, rangeTmp, options);
		        }
		        var sameDirectionIncreasing = (this.operator === '>=' || this.operator === '>') && (comp.operator === '>=' || comp.operator === '>');
		        var sameDirectionDecreasing = (this.operator === '<=' || this.operator === '<') && (comp.operator === '<=' || comp.operator === '<');
		        var sameSemVer = this.semver.version === comp.semver.version;
		        var differentDirectionsInclusive = (this.operator === '>=' || this.operator === '<=') && (comp.operator === '>=' || comp.operator === '<=');
		        var oppositeDirectionsLessThan = cmp(this.semver, '<', comp.semver, options) && (this.operator === '>=' || this.operator === '>') && (comp.operator === '<=' || comp.operator === '<');
		        var oppositeDirectionsGreaterThan = cmp(this.semver, '>', comp.semver, options) && (this.operator === '<=' || this.operator === '<') && (comp.operator === '>=' || comp.operator === '>');
		        return sameDirectionIncreasing || sameDirectionDecreasing || sameSemVer && differentDirectionsInclusive || oppositeDirectionsLessThan || oppositeDirectionsGreaterThan;
		      };
		      exports.Range = Range;
		      function Range(range, options) {
		        if (!options || typeof options !== 'object') {
		          options = {
		            loose: !!options,
		            includePrerelease: false
		          };
		        }
		        if (range instanceof Range) {
		          if (range.loose === !!options.loose && range.includePrerelease === !!options.includePrerelease) {
		            return range;
		          } else {
		            return new Range(range.raw, options);
		          }
		        }
		        if (range instanceof Comparator) {
		          return new Range(range.value, options);
		        }
		        if (!(this instanceof Range)) {
		          return new Range(range, options);
		        }
		        this.options = options;
		        this.loose = !!options.loose;
		        this.includePrerelease = !!options.includePrerelease;
		        this.raw = range.trim().split(/\s+/).join(' ');
		        this.set = this.raw.split('||').map(function (range) {
		          return this.parseRange(range.trim());
		        }, this).filter(function (c) {
		          return c.length;
		        });
		        if (!this.set.length) {
		          throw new TypeError('Invalid SemVer Range: ' + this.raw);
		        }
		        this.format();
		      }
		      Range.prototype.format = function () {
		        this.range = this.set.map(function (comps) {
		          return comps.join(' ').trim();
		        }).join('||').trim();
		        return this.range;
		      };
		      Range.prototype.toString = function () {
		        return this.range;
		      };
		      Range.prototype.parseRange = function (range) {
		        var loose = this.options.loose;
		        var hr = loose ? safeRe[t.HYPHENRANGELOOSE] : safeRe[t.HYPHENRANGE];
		        range = range.replace(hr, hyphenReplace);
		        debug('hyphen replace', range);
		        range = range.replace(safeRe[t.COMPARATORTRIM], comparatorTrimReplace);
		        debug('comparator trim', range, safeRe[t.COMPARATORTRIM]);
		        range = range.replace(safeRe[t.TILDETRIM], tildeTrimReplace);
		        range = range.replace(safeRe[t.CARETTRIM], caretTrimReplace);
		        range = range.split(/\s+/).join(' ');
		        var compRe = loose ? safeRe[t.COMPARATORLOOSE] : safeRe[t.COMPARATOR];
		        var set = range.split(' ').map(function (comp) {
		          return parseComparator(comp, this.options);
		        }, this).join(' ').split(/\s+/);
		        if (this.options.loose) {
		          set = set.filter(function (comp) {
		            return !!comp.match(compRe);
		          });
		        }
		        set = set.map(function (comp) {
		          return new Comparator(comp, this.options);
		        }, this);
		        return set;
		      };
		      Range.prototype.intersects = function (range, options) {
		        if (!(range instanceof Range)) {
		          throw new TypeError('a Range is required');
		        }
		        return this.set.some(function (thisComparators) {
		          return isSatisfiable(thisComparators, options) && range.set.some(function (rangeComparators) {
		            return isSatisfiable(rangeComparators, options) && thisComparators.every(function (thisComparator) {
		              return rangeComparators.every(function (rangeComparator) {
		                return thisComparator.intersects(rangeComparator, options);
		              });
		            });
		          });
		        });
		      };
		      function isSatisfiable(comparators, options) {
		        var result = true;
		        var remainingComparators = comparators.slice();
		        var testComparator = remainingComparators.pop();
		        while (result && remainingComparators.length) {
		          result = remainingComparators.every(function (otherComparator) {
		            return testComparator.intersects(otherComparator, options);
		          });
		          testComparator = remainingComparators.pop();
		        }
		        return result;
		      }
		      exports.toComparators = toComparators;
		      function toComparators(range, options) {
		        return new Range(range, options).set.map(function (comp) {
		          return comp.map(function (c) {
		            return c.value;
		          }).join(' ').trim().split(' ');
		        });
		      }
		      function parseComparator(comp, options) {
		        debug('comp', comp, options);
		        comp = replaceCarets(comp, options);
		        debug('caret', comp);
		        comp = replaceTildes(comp, options);
		        debug('tildes', comp);
		        comp = replaceXRanges(comp, options);
		        debug('xrange', comp);
		        comp = replaceStars(comp, options);
		        debug('stars', comp);
		        return comp;
		      }
		      function isX(id) {
		        return !id || id.toLowerCase() === 'x' || id === '*';
		      }
		      function replaceTildes(comp, options) {
		        return comp.trim().split(/\s+/).map(function (comp) {
		          return replaceTilde(comp, options);
		        }).join(' ');
		      }
		      function replaceTilde(comp, options) {
		        var r = options.loose ? safeRe[t.TILDELOOSE] : safeRe[t.TILDE];
		        return comp.replace(r, function (_, M, m, p, pr) {
		          debug('tilde', comp, _, M, m, p, pr);
		          var ret;
		          if (isX(M)) {
		            ret = '';
		          } else if (isX(m)) {
		            ret = '>=' + M + '.0.0 <' + (+M + 1) + '.0.0';
		          } else if (isX(p)) {
		            ret = '>=' + M + '.' + m + '.0 <' + M + '.' + (+m + 1) + '.0';
		          } else if (pr) {
		            debug('replaceTilde pr', pr);
		            ret = '>=' + M + '.' + m + '.' + p + '-' + pr + ' <' + M + '.' + (+m + 1) + '.0';
		          } else {
		            ret = '>=' + M + '.' + m + '.' + p + ' <' + M + '.' + (+m + 1) + '.0';
		          }
		          debug('tilde return', ret);
		          return ret;
		        });
		      }
		      function replaceCarets(comp, options) {
		        return comp.trim().split(/\s+/).map(function (comp) {
		          return replaceCaret(comp, options);
		        }).join(' ');
		      }
		      function replaceCaret(comp, options) {
		        debug('caret', comp, options);
		        var r = options.loose ? safeRe[t.CARETLOOSE] : safeRe[t.CARET];
		        return comp.replace(r, function (_, M, m, p, pr) {
		          debug('caret', comp, _, M, m, p, pr);
		          var ret;
		          if (isX(M)) {
		            ret = '';
		          } else if (isX(m)) {
		            ret = '>=' + M + '.0.0 <' + (+M + 1) + '.0.0';
		          } else if (isX(p)) {
		            if (M === '0') {
		              ret = '>=' + M + '.' + m + '.0 <' + M + '.' + (+m + 1) + '.0';
		            } else {
		              ret = '>=' + M + '.' + m + '.0 <' + (+M + 1) + '.0.0';
		            }
		          } else if (pr) {
		            debug('replaceCaret pr', pr);
		            if (M === '0') {
		              if (m === '0') {
		                ret = '>=' + M + '.' + m + '.' + p + '-' + pr + ' <' + M + '.' + m + '.' + (+p + 1);
		              } else {
		                ret = '>=' + M + '.' + m + '.' + p + '-' + pr + ' <' + M + '.' + (+m + 1) + '.0';
		              }
		            } else {
		              ret = '>=' + M + '.' + m + '.' + p + '-' + pr + ' <' + (+M + 1) + '.0.0';
		            }
		          } else {
		            debug('no pr');
		            if (M === '0') {
		              if (m === '0') {
		                ret = '>=' + M + '.' + m + '.' + p + ' <' + M + '.' + m + '.' + (+p + 1);
		              } else {
		                ret = '>=' + M + '.' + m + '.' + p + ' <' + M + '.' + (+m + 1) + '.0';
		              }
		            } else {
		              ret = '>=' + M + '.' + m + '.' + p + ' <' + (+M + 1) + '.0.0';
		            }
		          }
		          debug('caret return', ret);
		          return ret;
		        });
		      }
		      function replaceXRanges(comp, options) {
		        debug('replaceXRanges', comp, options);
		        return comp.split(/\s+/).map(function (comp) {
		          return replaceXRange(comp, options);
		        }).join(' ');
		      }
		      function replaceXRange(comp, options) {
		        comp = comp.trim();
		        var r = options.loose ? safeRe[t.XRANGELOOSE] : safeRe[t.XRANGE];
		        return comp.replace(r, function (ret, gtlt, M, m, p, pr) {
		          debug('xRange', comp, ret, gtlt, M, m, p, pr);
		          var xM = isX(M);
		          var xm = xM || isX(m);
		          var xp = xm || isX(p);
		          var anyX = xp;
		          if (gtlt === '=' && anyX) {
		            gtlt = '';
		          }
		          pr = options.includePrerelease ? '-0' : '';
		          if (xM) {
		            if (gtlt === '>' || gtlt === '<') {
		              ret = '<0.0.0-0';
		            } else {
		              ret = '*';
		            }
		          } else if (gtlt && anyX) {
		            if (xm) {
		              m = 0;
		            }
		            p = 0;
		            if (gtlt === '>') {
		              gtlt = '>=';
		              if (xm) {
		                M = +M + 1;
		                m = 0;
		                p = 0;
		              } else {
		                m = +m + 1;
		                p = 0;
		              }
		            } else if (gtlt === '<=') {
		              gtlt = '<';
		              if (xm) {
		                M = +M + 1;
		              } else {
		                m = +m + 1;
		              }
		            }
		            ret = gtlt + M + '.' + m + '.' + p + pr;
		          } else if (xm) {
		            ret = '>=' + M + '.0.0' + pr + ' <' + (+M + 1) + '.0.0' + pr;
		          } else if (xp) {
		            ret = '>=' + M + '.' + m + '.0' + pr + ' <' + M + '.' + (+m + 1) + '.0' + pr;
		          }
		          debug('xRange return', ret);
		          return ret;
		        });
		      }
		      function replaceStars(comp, options) {
		        debug('replaceStars', comp, options);
		        return comp.trim().replace(safeRe[t.STAR], '');
		      }
		      function hyphenReplace($0, from, fM, fm, fp, fpr, fb, to, tM, tm, tp, tpr, tb) {
		        if (isX(fM)) {
		          from = '';
		        } else if (isX(fm)) {
		          from = '>=' + fM + '.0.0';
		        } else if (isX(fp)) {
		          from = '>=' + fM + '.' + fm + '.0';
		        } else {
		          from = '>=' + from;
		        }
		        if (isX(tM)) {
		          to = '';
		        } else if (isX(tm)) {
		          to = '<' + (+tM + 1) + '.0.0';
		        } else if (isX(tp)) {
		          to = '<' + tM + '.' + (+tm + 1) + '.0';
		        } else if (tpr) {
		          to = '<=' + tM + '.' + tm + '.' + tp + '-' + tpr;
		        } else {
		          to = '<=' + to;
		        }
		        return (from + ' ' + to).trim();
		      }
		      Range.prototype.test = function (version) {
		        if (!version) {
		          return false;
		        }
		        if (typeof version === 'string') {
		          try {
		            version = new SemVer(version, this.options);
		          } catch (er) {
		            return false;
		          }
		        }
		        for (var i = 0; i < this.set.length; i++) {
		          if (testSet(this.set[i], version, this.options)) {
		            return true;
		          }
		        }
		        return false;
		      };
		      function testSet(set, version, options) {
		        for (var i = 0; i < set.length; i++) {
		          if (!set[i].test(version)) {
		            return false;
		          }
		        }
		        if (version.prerelease.length && !options.includePrerelease) {
		          for (i = 0; i < set.length; i++) {
		            debug(set[i].semver);
		            if (set[i].semver === ANY) {
		              continue;
		            }
		            if (set[i].semver.prerelease.length > 0) {
		              var allowed = set[i].semver;
		              if (allowed.major === version.major && allowed.minor === version.minor && allowed.patch === version.patch) {
		                return true;
		              }
		            }
		          }
		          return false;
		        }
		        return true;
		      }
		      exports.satisfies = satisfies;
		      function satisfies(version, range, options) {
		        try {
		          range = new Range(range, options);
		        } catch (er) {
		          return false;
		        }
		        return range.test(version);
		      }
		      exports.maxSatisfying = maxSatisfying;
		      function maxSatisfying(versions, range, options) {
		        var max = null;
		        var maxSV = null;
		        try {
		          var rangeObj = new Range(range, options);
		        } catch (er) {
		          return null;
		        }
		        versions.forEach(function (v) {
		          if (rangeObj.test(v)) {
		            if (!max || maxSV.compare(v) === -1) {
		              max = v;
		              maxSV = new SemVer(max, options);
		            }
		          }
		        });
		        return max;
		      }
		      exports.minSatisfying = minSatisfying;
		      function minSatisfying(versions, range, options) {
		        var min = null;
		        var minSV = null;
		        try {
		          var rangeObj = new Range(range, options);
		        } catch (er) {
		          return null;
		        }
		        versions.forEach(function (v) {
		          if (rangeObj.test(v)) {
		            if (!min || minSV.compare(v) === 1) {
		              min = v;
		              minSV = new SemVer(min, options);
		            }
		          }
		        });
		        return min;
		      }
		      exports.minVersion = minVersion;
		      function minVersion(range, loose) {
		        range = new Range(range, loose);
		        var minver = new SemVer('0.0.0');
		        if (range.test(minver)) {
		          return minver;
		        }
		        minver = new SemVer('0.0.0-0');
		        if (range.test(minver)) {
		          return minver;
		        }
		        minver = null;
		        for (var i = 0; i < range.set.length; ++i) {
		          var comparators = range.set[i];
		          comparators.forEach(function (comparator) {
		            var compver = new SemVer(comparator.semver.version);
		            switch (comparator.operator) {
		              case '>':
		                if (compver.prerelease.length === 0) {
		                  compver.patch++;
		                } else {
		                  compver.prerelease.push(0);
		                }
		                compver.raw = compver.format();
		              case '':
		              case '>=':
		                if (!minver || gt(minver, compver)) {
		                  minver = compver;
		                }
		                break;
		              case '<':
		              case '<=':
		                break;
		              default:
		                throw new Error('Unexpected operation: ' + comparator.operator);
		            }
		          });
		        }
		        if (minver && range.test(minver)) {
		          return minver;
		        }
		        return null;
		      }
		      exports.validRange = validRange;
		      function validRange(range, options) {
		        try {
		          return new Range(range, options).range || '*';
		        } catch (er) {
		          return null;
		        }
		      }
		      exports.ltr = ltr;
		      function ltr(version, range, options) {
		        return outside(version, range, '<', options);
		      }
		      exports.gtr = gtr;
		      function gtr(version, range, options) {
		        return outside(version, range, '>', options);
		      }
		      exports.outside = outside;
		      function outside(version, range, hilo, options) {
		        version = new SemVer(version, options);
		        range = new Range(range, options);
		        var gtfn, ltefn, ltfn, comp, ecomp;
		        switch (hilo) {
		          case '>':
		            gtfn = gt;
		            ltefn = lte;
		            ltfn = lt;
		            comp = '>';
		            ecomp = '>=';
		            break;
		          case '<':
		            gtfn = lt;
		            ltefn = gte;
		            ltfn = gt;
		            comp = '<';
		            ecomp = '<=';
		            break;
		          default:
		            throw new TypeError('Must provide a hilo val of "<" or ">"');
		        }
		        if (satisfies(version, range, options)) {
		          return false;
		        }
		        for (var i = 0; i < range.set.length; ++i) {
		          var comparators = range.set[i];
		          var high = null;
		          var low = null;
		          comparators.forEach(function (comparator) {
		            if (comparator.semver === ANY) {
		              comparator = new Comparator('>=0.0.0');
		            }
		            high = high || comparator;
		            low = low || comparator;
		            if (gtfn(comparator.semver, high.semver, options)) {
		              high = comparator;
		            } else if (ltfn(comparator.semver, low.semver, options)) {
		              low = comparator;
		            }
		          });
		          if (high.operator === comp || high.operator === ecomp) {
		            return false;
		          }
		          if ((!low.operator || low.operator === comp) && ltefn(version, low.semver)) {
		            return false;
		          } else if (low.operator === ecomp && ltfn(version, low.semver)) {
		            return false;
		          }
		        }
		        return true;
		      }
		      exports.prerelease = prerelease;
		      function prerelease(version, options) {
		        var parsed = parse(version, options);
		        return parsed && parsed.prerelease.length ? parsed.prerelease : null;
		      }
		      exports.intersects = intersects;
		      function intersects(r1, r2, options) {
		        r1 = new Range(r1, options);
		        r2 = new Range(r2, options);
		        return r1.intersects(r2);
		      }
		      exports.coerce = coerce;
		      function coerce(version, options) {
		        if (version instanceof SemVer) {
		          return version;
		        }
		        if (typeof version === 'number') {
		          version = String(version);
		        }
		        if (typeof version !== 'string') {
		          return null;
		        }
		        options = options || {};
		        var match = null;
		        if (!options.rtl) {
		          match = version.match(safeRe[t.COERCE]);
		        } else {
		          var next;
		          while ((next = safeRe[t.COERCERTL].exec(version)) && (!match || match.index + match[0].length !== version.length)) {
		            if (!match || next.index + next[0].length !== match.index + match[0].length) {
		              match = next;
		            }
		            safeRe[t.COERCERTL].lastIndex = next.index + next[1].length + next[2].length;
		          }
		          safeRe[t.COERCERTL].lastIndex = -1;
		        }
		        if (match === null) {
		          return null;
		        }
		        return parse(match[2] + '.' + (match[3] || '0') + '.' + (match[4] || '0'), options);
		      }
		    })(semver$a, semver$a.exports);
		    return semver$a.exports;
		  }

		  function bool$7(value) {
		    if (value == null) return false;
		    return value && value !== "false" && value !== "0";
		  }
		  var semver$9 = bool$7(browser$1$1.env["BABEL_8_BREAKING"]) ? requireSemver$2() : requireSemver$2();

		  var cloneNode$6 = cloneNode$j,
		    interpreterDirective = interpreterDirective$1;
		  var errorVisitor = {
		    enter: function enter(path, state) {
		      var loc = path.node.loc;
		      if (loc) {
		        state.loc = loc;
		        path.stop();
		      }
		    }
		  };
		  var File = function () {
		    function File(options, _ref) {
		      var _this = this;
		      var code = _ref.code,
		        ast = _ref.ast,
		        inputMap = _ref.inputMap;
		      this._map = new Map();
		      this.opts = void 0;
		      this.declarations = {};
		      this.path = void 0;
		      this.ast = void 0;
		      this.scope = void 0;
		      this.metadata = {};
		      this.code = "";
		      this.inputMap = void 0;
		      this.hub = {
		        file: this,
		        getCode: function getCode() {
		          return _this.code;
		        },
		        getScope: function getScope() {
		          return _this.scope;
		        },
		        addHelper: this.addHelper.bind(this),
		        buildError: this.buildCodeFrameError.bind(this)
		      };
		      this.opts = options;
		      this.code = code;
		      this.ast = ast;
		      this.inputMap = inputMap;
		      this.path = NodePath_Final.get({
		        hub: this.hub,
		        parentPath: null,
		        parent: this.ast,
		        container: this.ast,
		        key: "program"
		      }).setContext();
		      this.scope = this.path.scope;
		    }
		    var _proto = File.prototype;
		    _proto.set = function set(key, val) {
		      {
		        if (key === "helpersNamespace") {
		          throw new Error("Babel 7.0.0-beta.56 has dropped support for the 'helpersNamespace' utility." + "If you are using @babel/plugin-external-helpers you will need to use a newer " + "version than the one you currently have installed. " + "If you have your own implementation, you'll want to explore using 'helperGenerator' " + "alongside 'file.availableHelper()'.");
		        }
		      }
		      this._map.set(key, val);
		    };
		    _proto.get = function get(key) {
		      return this._map.get(key);
		    };
		    _proto.has = function has(key) {
		      return this._map.has(key);
		    };
		    _proto.getModuleName = function getModuleName$1() {
		      return getModuleName(this.opts, this.opts);
		    };
		    _proto.availableHelper = function availableHelper(name, versionRange) {
		      var minVersion$1;
		      try {
		        minVersion$1 = minVersion(name);
		      } catch (err) {
		        if (err.code !== "BABEL_HELPER_UNKNOWN") throw err;
		        return false;
		      }
		      if (typeof versionRange !== "string") return true;
		      if (semver$9.valid(versionRange)) versionRange = "^" + versionRange;
		      {
		        return !semver$9.intersects("<" + minVersion$1, versionRange) && !semver$9.intersects(">=8.0.0", versionRange);
		      }
		    };
		    _proto.addHelper = function addHelper(name) {
		      var _this2 = this;
		      var declar = this.declarations[name];
		      if (declar) return cloneNode$6(declar);
		      var generator = this.get("helperGenerator");
		      if (generator) {
		        var res = generator(name);
		        if (res) return res;
		      }
		      ensure(name, File);
		      var uid = this.declarations[name] = this.scope.generateUidIdentifier(name);
		      var dependencies = {};
		      for (var _iterator = _createForOfIteratorHelperLoose(getDependencies(name)), _step; !(_step = _iterator()).done;) {
		        var dep = _step.value;
		        dependencies[dep] = this.addHelper(dep);
		      }
		      var _helpers$get = get$1(name, function (dep) {
		          return dependencies[dep];
		        }, uid, Object.keys(this.scope.getAllBindings())),
		        nodes = _helpers$get.nodes,
		        globals = _helpers$get.globals;
		      globals.forEach(function (name) {
		        if (_this2.path.scope.hasBinding(name, true)) {
		          _this2.path.scope.rename(name);
		        }
		      });
		      nodes.forEach(function (node) {
		        node._compact = true;
		      });
		      var added = this.path.unshiftContainer("body", nodes);
		      for (var _iterator2 = _createForOfIteratorHelperLoose(added), _step2; !(_step2 = _iterator2()).done;) {
		        var path = _step2.value;
		        if (path.isVariableDeclaration()) this.scope.registerDeclaration(path);
		      }
		      return uid;
		    };
		    _proto.buildCodeFrameError = function buildCodeFrameError(node, msg, _Error) {
		      if (_Error === void 0) {
		        _Error = SyntaxError;
		      }
		      var loc = node == null ? void 0 : node.loc;
		      if (!loc && node) {
		        var state = {
		          loc: null
		        };
		        traverse(node, errorVisitor, this.scope, state);
		        loc = state.loc;
		        var txt = "This is an error on an internal node. Probably an internal error.";
		        if (loc) txt += " Location has been estimated.";
		        msg += " (" + txt + ")";
		      }
		      if (loc) {
		        var _this$opts$highlightC = this.opts.highlightCode,
		          highlightCode = _this$opts$highlightC === void 0 ? true : _this$opts$highlightC;
		        msg += "\n" + codeFrameColumns(this.code, {
		          start: {
		            line: loc.start.line,
		            column: loc.start.column + 1
		          },
		          end: loc.end && loc.start.line === loc.end.line ? {
		            line: loc.end.line,
		            column: loc.end.column + 1
		          } : undefined
		        }, {
		          highlightCode: highlightCode
		        });
		      }
		      return new _Error(msg);
		    };
		    return _createClass(File, [{
		      key: "shebang",
		      get: function get() {
		        var interpreter = this.path.node.interpreter;
		        return interpreter ? interpreter.value : "";
		      },
		      set: function set(value) {
		        if (value) {
		          this.path.get("interpreter").replaceWith(interpreterDirective(value));
		        } else {
		          this.path.get("interpreter").remove();
		        }
		      }
		    }]);
		  }();
		  {
		    File.prototype.addImport = function addImport() {
		      throw new Error("This API has been removed. If you're looking for this " + "functionality in Babel 7, you should import the " + "'@babel/helper-module-imports' module and use the functions exposed " + " from that module, such as 'addNamed' or 'addDefault'.");
		    };
		    File.prototype.addTemplateObject = function addTemplateObject() {
		      throw new Error("This function has been moved into the template literal transform itself.");
		    };
		  }

		  var _templateObject$x;
		  var arrayExpression = arrayExpression$1,
		    assignmentExpression$5 = assignmentExpression$d,
		    binaryExpression$2 = binaryExpression$5,
		    blockStatement$1 = blockStatement$6,
		    callExpression$6 = callExpression$d,
		    cloneNode$5 = cloneNode$j,
		    conditionalExpression$2 = conditionalExpression$5,
		    exportNamedDeclaration = exportNamedDeclaration$2,
		    exportSpecifier = exportSpecifier$2,
		    expressionStatement = expressionStatement$a,
		    functionExpression$1 = functionExpression$2,
		    identifier$4 = identifier$j,
		    memberExpression$6 = memberExpression$c,
		    objectExpression$1 = objectExpression$3,
		    program = program$3,
		    stringLiteral$2 = stringLiteral$8,
		    unaryExpression$1 = unaryExpression$6,
		    variableDeclaration$1 = variableDeclaration$8,
		    variableDeclarator$1 = variableDeclarator$8;
		  var buildUmdWrapper = function buildUmdWrapper(replacements) {
		    return template$1.statement(_templateObject$x || (_templateObject$x = _taggedTemplateLiteralLoose(["\n    (function (root, factory) {\n      if (typeof define === \"function\" && define.amd) {\n        define(AMD_ARGUMENTS, factory);\n      } else if (typeof exports === \"object\") {\n        factory(COMMON_ARGUMENTS);\n      } else {\n        factory(BROWSER_ARGUMENTS);\n      }\n    })(UMD_ROOT, function (FACTORY_PARAMETERS) {\n      FACTORY_BODY\n    });\n  "])))(replacements);
		  };
		  function buildGlobal(allowlist) {
		    var namespace = identifier$4("babelHelpers");
		    var body = [];
		    var container = functionExpression$1(null, [identifier$4("global")], blockStatement$1(body));
		    var tree = program([expressionStatement(callExpression$6(container, [conditionalExpression$2(binaryExpression$2("===", unaryExpression$1("typeof", identifier$4("global")), stringLiteral$2("undefined")), identifier$4("self"), identifier$4("global"))]))]);
		    body.push(variableDeclaration$1("var", [variableDeclarator$1(namespace, assignmentExpression$5("=", memberExpression$6(identifier$4("global"), namespace), objectExpression$1([])))]));
		    buildHelpers(body, namespace, allowlist);
		    return tree;
		  }
		  function buildModule(allowlist) {
		    var body = [];
		    var refs = buildHelpers(body, null, allowlist);
		    body.unshift(exportNamedDeclaration(null, Object.keys(refs).map(function (name) {
		      return exportSpecifier(cloneNode$5(refs[name]), identifier$4(name));
		    })));
		    return program(body, [], "module");
		  }
		  function buildUmd(allowlist) {
		    var namespace = identifier$4("babelHelpers");
		    var body = [];
		    body.push(variableDeclaration$1("var", [variableDeclarator$1(namespace, identifier$4("global"))]));
		    buildHelpers(body, namespace, allowlist);
		    return program([buildUmdWrapper({
		      FACTORY_PARAMETERS: identifier$4("global"),
		      BROWSER_ARGUMENTS: assignmentExpression$5("=", memberExpression$6(identifier$4("root"), namespace), objectExpression$1([])),
		      COMMON_ARGUMENTS: identifier$4("exports"),
		      AMD_ARGUMENTS: arrayExpression([stringLiteral$2("exports")]),
		      FACTORY_BODY: body,
		      UMD_ROOT: identifier$4("this")
		    })]);
		  }
		  function buildVar(allowlist) {
		    var namespace = identifier$4("babelHelpers");
		    var body = [];
		    body.push(variableDeclaration$1("var", [variableDeclarator$1(namespace, objectExpression$1([]))]));
		    var tree = program(body);
		    buildHelpers(body, namespace, allowlist);
		    body.push(expressionStatement(namespace));
		    return tree;
		  }
		  function buildHelpers(body, namespace, allowlist) {
		    var getHelperReference = function getHelperReference(name) {
		      return namespace ? memberExpression$6(namespace, identifier$4(name)) : identifier$4("_" + name);
		    };
		    var refs = {};
		    list.forEach(function (name) {
		      if (allowlist && allowlist.indexOf(name) < 0) return;
		      var ref = refs[name] = getHelperReference(name);
		      ensure(name, File);
		      var _helpers$get = get$1(name, getHelperReference, ref),
		        nodes = _helpers$get.nodes;
		      body.push.apply(body, _toConsumableArray(nodes));
		    });
		    return refs;
		  }
		  function babelBuildExternalHelpers (allowlist, outputType) {
		    if (outputType === void 0) {
		      outputType = "global";
		    }
		    var tree;
		    var build = {
		      global: buildGlobal,
		      module: buildModule,
		      umd: buildUmd,
		      "var": buildVar
		    }[outputType];
		    if (build) {
		      tree = build(allowlist);
		    } else {
		      throw new Error("Unsupported output type " + outputType);
		    }
		    return generate$1(tree).code;
		  }

		  var _marked$9 = _regeneratorRuntime().mark(findPackageData),
		    _marked2$7 = _regeneratorRuntime().mark(findRelativeConfig),
		    _marked3$4 = _regeneratorRuntime().mark(findRootConfig),
		    _marked4$2 = _regeneratorRuntime().mark(loadConfig$1),
		    _marked5 = _regeneratorRuntime().mark(resolveShowConfigPath);
		  function findConfigUpwards(rootDir) {
		    return null;
		  }
		  function findPackageData(filepath) {
		    return _regeneratorRuntime().wrap(function findPackageData$(_context) {
		      while (1) switch (_context.prev = _context.next) {
		        case 0:
		          return _context.abrupt("return", {
		            filepath: filepath,
		            directories: [],
		            pkg: null,
		            isPackage: false
		          });
		        case 1:
		        case "end":
		          return _context.stop();
		      }
		    }, _marked$9);
		  }
		  function findRelativeConfig(pkgData, envName, caller) {
		    return _regeneratorRuntime().wrap(function findRelativeConfig$(_context2) {
		      while (1) switch (_context2.prev = _context2.next) {
		        case 0:
		          return _context2.abrupt("return", {
		            config: null,
		            ignore: null
		          });
		        case 1:
		        case "end":
		          return _context2.stop();
		      }
		    }, _marked2$7);
		  }
		  function findRootConfig(dirname, envName, caller) {
		    return _regeneratorRuntime().wrap(function findRootConfig$(_context3) {
		      while (1) switch (_context3.prev = _context3.next) {
		        case 0:
		          return _context3.abrupt("return", null);
		        case 1:
		        case "end":
		          return _context3.stop();
		      }
		    }, _marked3$4);
		  }
		  function loadConfig$1(name, dirname, envName, caller) {
		    return _regeneratorRuntime().wrap(function loadConfig$(_context4) {
		      while (1) switch (_context4.prev = _context4.next) {
		        case 0:
		          throw new Error("Cannot load " + name + " relative to " + dirname + " in a browser");
		        case 1:
		        case "end":
		          return _context4.stop();
		      }
		    }, _marked4$2);
		  }
		  function resolveShowConfigPath(dirname) {
		    return _regeneratorRuntime().wrap(function resolveShowConfigPath$(_context5) {
		      while (1) switch (_context5.prev = _context5.next) {
		        case 0:
		          return _context5.abrupt("return", null);
		        case 1:
		        case "end":
		          return _context5.stop();
		      }
		    }, _marked5);
		  }
		  var ROOT_CONFIG_FILENAMES = [];
		  function resolvePlugin(name, dirname) {
		    return null;
		  }
		  function resolvePreset(name, dirname) {
		    return null;
		  }
		  function loadPlugin(name, dirname) {
		    throw new Error("Cannot load plugin " + name + " relative to " + dirname + " in a browser");
		  }
		  function loadPreset(name, dirname) {
		    throw new Error("Cannot load preset " + name + " relative to " + dirname + " in a browser");
		  }

		  function getEnv(defaultValue) {
		    if (defaultValue === void 0) {
		      defaultValue = "development";
		    }
		    return browser$1$1.env.BABEL_ENV || "production" || defaultValue;
		  }

		  var GENSYNC_START = Symbol["for"]("gensync:v1:start");
		  var GENSYNC_SUSPEND = Symbol["for"]("gensync:v1:suspend");
		  var GENSYNC_EXPECTED_START = "GENSYNC_EXPECTED_START";
		  var GENSYNC_EXPECTED_SUSPEND = "GENSYNC_EXPECTED_SUSPEND";
		  var GENSYNC_OPTIONS_ERROR = "GENSYNC_OPTIONS_ERROR";
		  var GENSYNC_RACE_NONEMPTY = "GENSYNC_RACE_NONEMPTY";
		  var GENSYNC_ERRBACK_NO_CALLBACK = "GENSYNC_ERRBACK_NO_CALLBACK";
		  var gensync = Object.assign(function gensync(optsOrFn) {
		    var genFn = optsOrFn;
		    if (typeof optsOrFn !== "function") {
		      genFn = newGenerator(optsOrFn);
		    } else {
		      genFn = wrapGenerator(optsOrFn);
		    }
		    return Object.assign(genFn, makeFunctionAPI(genFn));
		  }, {
		    all: buildOperation({
		      name: "all",
		      arity: 1,
		      sync: function sync(args) {
		        var items = Array.from(args[0]);
		        return items.map(function (item) {
		          return evaluateSync(item);
		        });
		      },
		      async: function async(args, resolve, reject) {
		        var items = Array.from(args[0]);
		        if (items.length === 0) {
		          Promise.resolve().then(function () {
		            return resolve([]);
		          });
		          return;
		        }
		        var count = 0;
		        var results = items.map(function () {
		          return undefined;
		        });
		        items.forEach(function (item, i) {
		          evaluateAsync(item, function (val) {
		            results[i] = val;
		            count += 1;
		            if (count === results.length) resolve(results);
		          }, reject);
		        });
		      }
		    }),
		    race: buildOperation({
		      name: "race",
		      arity: 1,
		      sync: function sync(args) {
		        var items = Array.from(args[0]);
		        if (items.length === 0) {
		          throw makeError("Must race at least 1 item", GENSYNC_RACE_NONEMPTY);
		        }
		        return evaluateSync(items[0]);
		      },
		      async: function async(args, resolve, reject) {
		        var items = Array.from(args[0]);
		        if (items.length === 0) {
		          throw makeError("Must race at least 1 item", GENSYNC_RACE_NONEMPTY);
		        }
		        for (var _i = 0, _items = items; _i < _items.length; _i++) {
		          var item = _items[_i];
		          evaluateAsync(item, resolve, reject);
		        }
		      }
		    })
		  });
		  function makeFunctionAPI(genFn) {
		    var fns = {
		      sync: function sync() {
		        for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
		          args[_key] = arguments[_key];
		        }
		        return evaluateSync(genFn.apply(this, args));
		      },
		      async: function async() {
		        var _this = this;
		        for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
		          args[_key2] = arguments[_key2];
		        }
		        return new Promise(function (resolve, reject) {
		          evaluateAsync(genFn.apply(_this, args), resolve, reject);
		        });
		      },
		      errback: function errback() {
		        for (var _len3 = arguments.length, args = new Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
		          args[_key3] = arguments[_key3];
		        }
		        var cb = args.pop();
		        if (typeof cb !== "function") {
		          throw makeError("Asynchronous function called without callback", GENSYNC_ERRBACK_NO_CALLBACK);
		        }
		        var gen;
		        try {
		          gen = genFn.apply(this, args);
		        } catch (err) {
		          cb(err);
		          return;
		        }
		        evaluateAsync(gen, function (val) {
		          return cb(undefined, val);
		        }, function (err) {
		          return cb(err);
		        });
		      }
		    };
		    return fns;
		  }
		  function assertTypeof(type, name, value, allowUndefined) {
		    if (typeof value === type || allowUndefined && typeof value === "undefined") {
		      return;
		    }
		    var msg;
		    if (allowUndefined) {
		      msg = "Expected opts." + name + " to be either a " + type + ", or undefined.";
		    } else {
		      msg = "Expected opts." + name + " to be a " + type + ".";
		    }
		    throw makeError(msg, GENSYNC_OPTIONS_ERROR);
		  }
		  function makeError(msg, code) {
		    return Object.assign(new Error(msg), {
		      code: code
		    });
		  }
		  function newGenerator(_ref) {
		    var name = _ref.name,
		      arity = _ref.arity,
		      _sync = _ref.sync,
		      _async = _ref.async,
		      errback = _ref.errback;
		    assertTypeof("string", "name", name, true);
		    assertTypeof("number", "arity", arity, true);
		    assertTypeof("function", "sync", _sync);
		    assertTypeof("function", "async", _async, true);
		    assertTypeof("function", "errback", errback, true);
		    if (_async && errback) {
		      throw makeError("Expected one of either opts.async or opts.errback, but got _both_.", GENSYNC_OPTIONS_ERROR);
		    }
		    if (typeof name !== "string") {
		      var fnName;
		      if (errback && errback.name && errback.name !== "errback") {
		        fnName = errback.name;
		      }
		      if (_async && _async.name && _async.name !== "async") {
		        fnName = _async.name.replace(/Async$/, "");
		      }
		      if (_sync && _sync.name && _sync.name !== "sync") {
		        fnName = _sync.name.replace(/Sync$/, "");
		      }
		      if (typeof fnName === "string") {
		        name = fnName;
		      }
		    }
		    if (typeof arity !== "number") {
		      arity = _sync.length;
		    }
		    return buildOperation({
		      name: name,
		      arity: arity,
		      sync: function sync(args) {
		        return _sync.apply(this, args);
		      },
		      async: function async(args, resolve, reject) {
		        if (_async) {
		          _async.apply(this, args).then(resolve, reject);
		        } else if (errback) {
		          errback.call.apply(errback, [this].concat(_toConsumableArray(args), [function (err, value) {
		            if (err == null) resolve(value);else reject(err);
		          }]));
		        } else {
		          resolve(_sync.apply(this, args));
		        }
		      }
		    });
		  }
		  function wrapGenerator(genFn) {
		    return setFunctionMetadata(genFn.name, genFn.length, function () {
		      for (var _len4 = arguments.length, args = new Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
		        args[_key4] = arguments[_key4];
		      }
		      return genFn.apply(this, args);
		    });
		  }
		  function buildOperation(_ref2) {
		    var name = _ref2.name,
		      arity = _ref2.arity,
		      sync = _ref2.sync,
		      async = _ref2.async;
		    return setFunctionMetadata(name, arity, _regeneratorRuntime().mark(function _callee() {
		      var resume,
		        _len5,
		        args,
		        _key5,
		        res,
		        result,
		        _args = arguments;
		      return _regeneratorRuntime().wrap(function _callee$(_context) {
		        while (1) switch (_context.prev = _context.next) {
		          case 0:
		            _context.next = 2;
		            return GENSYNC_START;
		          case 2:
		            resume = _context.sent;
		            for (_len5 = _args.length, args = new Array(_len5), _key5 = 0; _key5 < _len5; _key5++) {
		              args[_key5] = _args[_key5];
		            }
		            if (resume) {
		              _context.next = 7;
		              break;
		            }
		            res = sync.call(this, args);
		            return _context.abrupt("return", res);
		          case 7:
		            try {
		              async.call(this, args, function (value) {
		                if (result) return;
		                result = {
		                  value: value
		                };
		                resume();
		              }, function (err) {
		                if (result) return;
		                result = {
		                  err: err
		                };
		                resume();
		              });
		            } catch (err) {
		              result = {
		                err: err
		              };
		              resume();
		            }
		            _context.next = 10;
		            return GENSYNC_SUSPEND;
		          case 10:
		            if (!result.hasOwnProperty("err")) {
		              _context.next = 12;
		              break;
		            }
		            throw result.err;
		          case 12:
		            return _context.abrupt("return", result.value);
		          case 13:
		          case "end":
		            return _context.stop();
		        }
		      }, _callee, this);
		    }));
		  }
		  function evaluateSync(gen) {
		    var value;
		    while (!(_gen$next = gen.next(), value = _gen$next.value, _gen$next).done) {
		      var _gen$next;
		      assertStart(value, gen);
		    }
		    return value;
		  }
		  function evaluateAsync(gen, resolve, reject) {
		    (function step() {
		      try {
		        var value;
		        var _loop = function _loop() {
		            assertStart(value, gen);
		            var sync = true;
		            var didSyncResume = false;
		            var out = gen.next(function () {
		              if (sync) {
		                didSyncResume = true;
		              } else {
		                step();
		              }
		            });
		            sync = false;
		            assertSuspend(out, gen);
		            if (!didSyncResume) {
		              return {
		                v: void 0
		              };
		            }
		          },
		          _ret;
		        while (!(_gen$next2 = gen.next(), value = _gen$next2.value, _gen$next2).done) {
		          var _gen$next2;
		          _ret = _loop();
		          if (_ret) return _ret.v;
		        }
		        return resolve(value);
		      } catch (err) {
		        return reject(err);
		      }
		    })();
		  }
		  function assertStart(value, gen) {
		    if (value === GENSYNC_START) return;
		    throwError(gen, makeError("Got unexpected yielded value in gensync generator: " + JSON.stringify(value) + ". Did you perhaps mean to use 'yield*' instead of 'yield'?", GENSYNC_EXPECTED_START));
		  }
		  function assertSuspend(_ref3, gen) {
		    var value = _ref3.value,
		      done = _ref3.done;
		    if (!done && value === GENSYNC_SUSPEND) return;
		    throwError(gen, makeError(done ? "Unexpected generator completion. If you get this, it is probably a gensync bug." : "Expected GENSYNC_SUSPEND, got " + JSON.stringify(value) + ". If you get this, it is probably a gensync bug.", GENSYNC_EXPECTED_SUSPEND));
		  }
		  function throwError(gen, err) {
		    if (gen["throw"]) gen["throw"](err);
		    throw err;
		  }
		  function setFunctionMetadata(name, arity, fn) {
		    if (typeof name === "string") {
		      var nameDesc = Object.getOwnPropertyDescriptor(fn, "name");
		      if (!nameDesc || nameDesc.configurable) {
		        Object.defineProperty(fn, "name", Object.assign(nameDesc || {}, {
		          configurable: true,
		          value: name
		        }));
		      }
		    }
		    if (typeof arity === "number") {
		      var lengthDesc = Object.getOwnPropertyDescriptor(fn, "length");
		      if (!lengthDesc || lengthDesc.configurable) {
		        Object.defineProperty(fn, "length", Object.assign(lengthDesc || {}, {
		          configurable: true,
		          value: arity
		        }));
		      }
		    }
		    return fn;
		  }

		  var runGenerator = gensync(_regeneratorRuntime().mark(function _callee(item) {
		    return _regeneratorRuntime().wrap(function _callee$(_context) {
		      while (1) switch (_context.prev = _context.next) {
		        case 0:
		          return _context.delegateYield(item, "t0", 1);
		        case 1:
		          return _context.abrupt("return", _context.t0);
		        case 2:
		        case "end":
		          return _context.stop();
		      }
		    }, _callee);
		  }));
		  var isAsync = gensync({
		    sync: function sync() {
		      return false;
		    },
		    errback: function errback(cb) {
		      return cb(null, true);
		    }
		  });
		  function maybeAsync(fn, message) {
		    return gensync({
		      sync: function sync() {
		        for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
		          args[_key] = arguments[_key];
		        }
		        var result = fn.apply(this, args);
		        if (isThenable$1(result)) throw new Error(message);
		        return result;
		      },
		      async: function async() {
		        for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
		          args[_key2] = arguments[_key2];
		        }
		        return Promise.resolve(fn.apply(this, args));
		      }
		    });
		  }
		  var withKind = gensync({
		    sync: function sync(cb) {
		      return cb("sync");
		    },
		    async: function () {
		      var _async = _asyncToGenerator(_regeneratorRuntime().mark(function _callee2(cb) {
		        return _regeneratorRuntime().wrap(function _callee2$(_context2) {
		          while (1) switch (_context2.prev = _context2.next) {
		            case 0:
		              return _context2.abrupt("return", cb("async"));
		            case 1:
		            case "end":
		              return _context2.stop();
		          }
		        }, _callee2);
		      }));
		      function async(_x) {
		        return _async.apply(this, arguments);
		      }
		      return async;
		    }()
		  });
		  function forwardAsync(action, cb) {
		    var g = gensync(action);
		    return withKind(function (kind) {
		      var adapted = g[kind];
		      return cb(adapted);
		    });
		  }
		  var onFirstPause = gensync({
		    name: "onFirstPause",
		    arity: 2,
		    sync: function sync(item) {
		      return runGenerator.sync(item);
		    },
		    errback: function errback(item, firstPause, cb) {
		      var completed = false;
		      runGenerator.errback(item, function (err, value) {
		        completed = true;
		        cb(err, value);
		      });
		      if (!completed) {
		        firstPause();
		      }
		    }
		  });
		  var waitFor = gensync({
		    sync: function sync(x) {
		      return x;
		    },
		    async: function () {
		      var _async2 = _asyncToGenerator(_regeneratorRuntime().mark(function _callee3(x) {
		        return _regeneratorRuntime().wrap(function _callee3$(_context3) {
		          while (1) switch (_context3.prev = _context3.next) {
		            case 0:
		              return _context3.abrupt("return", x);
		            case 1:
		            case "end":
		              return _context3.stop();
		          }
		        }, _callee3);
		      }));
		      function async(_x2) {
		        return _async2.apply(this, arguments);
		      }
		      return async;
		    }()
		  });
		  function isThenable$1(val) {
		    return !!val && (typeof val === "object" || typeof val === "function") && !!val.then && typeof val.then === "function";
		  }

		  function mergeOptions(target, source) {
		    for (var _i = 0, _Object$keys = Object.keys(source); _i < _Object$keys.length; _i++) {
		      var k = _Object$keys[_i];
		      if ((k === "parserOpts" || k === "generatorOpts" || k === "assumptions") && source[k]) {
		        var parserOpts = source[k];
		        var targetObj = target[k] || (target[k] = {});
		        mergeDefaultFields(targetObj, parserOpts);
		      } else {
		        var val = source[k];
		        if (val !== undefined) target[k] = val;
		      }
		    }
		  }
		  function mergeDefaultFields(target, source) {
		    for (var _i2 = 0, _arr = Object.keys(source); _i2 < _arr.length; _i2++) {
		      var k = _arr[_i2];
		      var val = source[k];
		      if (val !== undefined) target[k] = val;
		    }
		  }
		  function isIterableIterator(value) {
		    return !!value && typeof value.next === "function" && typeof value[Symbol.iterator] === "function";
		  }

		  function finalize(deepArr) {
		    return Object.freeze(deepArr);
		  }
		  function flattenToSet(arr) {
		    var result = new Set();
		    var stack = [arr];
		    while (stack.length > 0) {
		      for (var _iterator = _createForOfIteratorHelperLoose(stack.pop()), _step; !(_step = _iterator()).done;) {
		        var el = _step.value;
		        if (Array.isArray(el)) stack.push(el);else result.add(el);
		      }
		    }
		    return result;
		  }

		  var Plugin = _createClass(function Plugin(plugin, options, key, externalDependencies) {
		    if (externalDependencies === void 0) {
		      externalDependencies = finalize([]);
		    }
		    this.key = void 0;
		    this.manipulateOptions = void 0;
		    this.post = void 0;
		    this.pre = void 0;
		    this.visitor = void 0;
		    this.parserOverride = void 0;
		    this.generatorOverride = void 0;
		    this.options = void 0;
		    this.externalDependencies = void 0;
		    this.key = plugin.name || key;
		    this.manipulateOptions = plugin.manipulateOptions;
		    this.post = plugin.post;
		    this.pre = plugin.pre;
		    this.visitor = plugin.visitor || {};
		    this.parserOverride = plugin.parserOverride;
		    this.generatorOverride = plugin.generatorOverride;
		    this.options = options;
		    this.externalDependencies = externalDependencies;
		  });

		  function once(fn) {
		    var result;
		    var resultP;
		    var promiseReferenced = false;
		    return _regeneratorRuntime().mark(function _callee() {
		      var resolve, reject;
		      return _regeneratorRuntime().wrap(function _callee$(_context) {
		        while (1) switch (_context.prev = _context.next) {
		          case 0:
		            if (result) {
		              _context.next = 32;
		              break;
		            }
		            if (!resultP) {
		              _context.next = 5;
		              break;
		            }
		            promiseReferenced = true;
		            return _context.delegateYield(waitFor(resultP), "t0", 4);
		          case 4:
		            return _context.abrupt("return", _context.t0);
		          case 5:
		            return _context.delegateYield(isAsync(), "t1", 6);
		          case 6:
		            if (_context.t1) {
		              _context.next = 18;
		              break;
		            }
		            _context.prev = 7;
		            return _context.delegateYield(fn(), "t2", 9);
		          case 9:
		            _context.t3 = _context.t2;
		            result = {
		              ok: true,
		              value: _context.t3
		            };
		            _context.next = 16;
		            break;
		          case 13:
		            _context.prev = 13;
		            _context.t4 = _context["catch"](7);
		            result = {
		              ok: false,
		              value: _context.t4
		            };
		          case 16:
		            _context.next = 32;
		            break;
		          case 18:
		            resultP = new Promise(function (res, rej) {
		              resolve = res;
		              reject = rej;
		            });
		            _context.prev = 19;
		            return _context.delegateYield(fn(), "t5", 21);
		          case 21:
		            _context.t6 = _context.t5;
		            result = {
		              ok: true,
		              value: _context.t6
		            };
		            resultP = null;
		            if (promiseReferenced) resolve(result.value);
		            _context.next = 32;
		            break;
		          case 27:
		            _context.prev = 27;
		            _context.t7 = _context["catch"](19);
		            result = {
		              ok: false,
		              value: _context.t7
		            };
		            resultP = null;
		            if (promiseReferenced) reject(_context.t7);
		          case 32:
		            if (!result.ok) {
		              _context.next = 36;
		              break;
		            }
		            return _context.abrupt("return", result.value);
		          case 36:
		            throw result.value;
		          case 37:
		          case "end":
		            return _context.stop();
		        }
		      }, _callee, null, [[7, 13], [19, 27]]);
		    });
		  }

		  var _marked$8 = _regeneratorRuntime().mark(genTrue),
		    _marked2$6 = _regeneratorRuntime().mark(getCachedValue),
		    _marked3$3 = _regeneratorRuntime().mark(getCachedValueOrWait);
		  var synchronize = function synchronize(gen) {
		    return gensync(gen).sync;
		  };
		  function genTrue() {
		    return _regeneratorRuntime().wrap(function genTrue$(_context) {
		      while (1) switch (_context.prev = _context.next) {
		        case 0:
		          return _context.abrupt("return", true);
		        case 1:
		        case "end":
		          return _context.stop();
		      }
		    }, _marked$8);
		  }
		  function makeWeakCache(handler) {
		    return makeCachedFunction(WeakMap, handler);
		  }
		  function makeWeakCacheSync(handler) {
		    return synchronize(makeWeakCache(handler));
		  }
		  function makeStrongCache(handler) {
		    return makeCachedFunction(Map, handler);
		  }
		  function makeStrongCacheSync(handler) {
		    return synchronize(makeStrongCache(handler));
		  }
		  function makeCachedFunction(CallCache, handler) {
		    var callCacheSync = new CallCache();
		    var callCacheAsync = new CallCache();
		    var futureCache = new CallCache();
		    return _regeneratorRuntime().mark(function cachedFunction(arg, data) {
		      var asyncContext, callCache, cached, cache, handlerResult, finishLock, value;
		      return _regeneratorRuntime().wrap(function cachedFunction$(_context2) {
		        while (1) switch (_context2.prev = _context2.next) {
		          case 0:
		            return _context2.delegateYield(isAsync(), "t0", 1);
		          case 1:
		            asyncContext = _context2.t0;
		            callCache = asyncContext ? callCacheAsync : callCacheSync;
		            return _context2.delegateYield(getCachedValueOrWait(asyncContext, callCache, futureCache, arg, data), "t1", 4);
		          case 4:
		            cached = _context2.t1;
		            if (!cached.valid) {
		              _context2.next = 7;
		              break;
		            }
		            return _context2.abrupt("return", cached.value);
		          case 7:
		            cache = new CacheConfigurator(data);
		            handlerResult = handler(arg, cache);
		            if (!isIterableIterator(handlerResult)) {
		              _context2.next = 14;
		              break;
		            }
		            return _context2.delegateYield(onFirstPause(handlerResult, function () {
		              finishLock = setupAsyncLocks(cache, futureCache, arg);
		            }), "t2", 11);
		          case 11:
		            value = _context2.t2;
		            _context2.next = 15;
		            break;
		          case 14:
		            value = handlerResult;
		          case 15:
		            updateFunctionCache(callCache, cache, arg, value);
		            if (finishLock) {
		              futureCache["delete"](arg);
		              finishLock.release(value);
		            }
		            return _context2.abrupt("return", value);
		          case 18:
		          case "end":
		            return _context2.stop();
		        }
		      }, cachedFunction);
		    });
		  }
		  function getCachedValue(cache, arg, data) {
		    var cachedValue, _iterator, _step, _step$value, _value, valid;
		    return _regeneratorRuntime().wrap(function getCachedValue$(_context3) {
		      while (1) switch (_context3.prev = _context3.next) {
		        case 0:
		          cachedValue = cache.get(arg);
		          if (!cachedValue) {
		            _context3.next = 10;
		            break;
		          }
		          _iterator = _createForOfIteratorHelperLoose(cachedValue);
		        case 3:
		          if ((_step = _iterator()).done) {
		            _context3.next = 10;
		            break;
		          }
		          _step$value = _step.value, _value = _step$value.value, valid = _step$value.valid;
		          return _context3.delegateYield(valid(data), "t0", 6);
		        case 6:
		          if (!_context3.t0) {
		            _context3.next = 8;
		            break;
		          }
		          return _context3.abrupt("return", {
		            valid: true,
		            value: _value
		          });
		        case 8:
		          _context3.next = 3;
		          break;
		        case 10:
		          return _context3.abrupt("return", {
		            valid: false,
		            value: null
		          });
		        case 11:
		        case "end":
		          return _context3.stop();
		      }
		    }, _marked2$6);
		  }
		  function getCachedValueOrWait(asyncContext, callCache, futureCache, arg, data) {
		    var cached, _cached, _value2;
		    return _regeneratorRuntime().wrap(function getCachedValueOrWait$(_context4) {
		      while (1) switch (_context4.prev = _context4.next) {
		        case 0:
		          return _context4.delegateYield(getCachedValue(callCache, arg, data), "t0", 1);
		        case 1:
		          cached = _context4.t0;
		          if (!cached.valid) {
		            _context4.next = 4;
		            break;
		          }
		          return _context4.abrupt("return", cached);
		        case 4:
		          if (!asyncContext) {
		            _context4.next = 11;
		            break;
		          }
		          return _context4.delegateYield(getCachedValue(futureCache, arg, data), "t1", 6);
		        case 6:
		          _cached = _context4.t1;
		          if (!_cached.valid) {
		            _context4.next = 11;
		            break;
		          }
		          return _context4.delegateYield(waitFor(_cached.value.promise), "t2", 9);
		        case 9:
		          _value2 = _context4.t2;
		          return _context4.abrupt("return", {
		            valid: true,
		            value: _value2
		          });
		        case 11:
		          return _context4.abrupt("return", {
		            valid: false,
		            value: null
		          });
		        case 12:
		        case "end":
		          return _context4.stop();
		      }
		    }, _marked3$3);
		  }
		  function setupAsyncLocks(config, futureCache, arg) {
		    var finishLock = new Lock();
		    updateFunctionCache(futureCache, config, arg, finishLock);
		    return finishLock;
		  }
		  function updateFunctionCache(cache, config, arg, value) {
		    if (!config.configured()) config.forever();
		    var cachedValue = cache.get(arg);
		    config.deactivate();
		    switch (config.mode()) {
		      case "forever":
		        cachedValue = [{
		          value: value,
		          valid: genTrue
		        }];
		        cache.set(arg, cachedValue);
		        break;
		      case "invalidate":
		        cachedValue = [{
		          value: value,
		          valid: config.validator()
		        }];
		        cache.set(arg, cachedValue);
		        break;
		      case "valid":
		        if (cachedValue) {
		          cachedValue.push({
		            value: value,
		            valid: config.validator()
		          });
		        } else {
		          cachedValue = [{
		            value: value,
		            valid: config.validator()
		          }];
		          cache.set(arg, cachedValue);
		        }
		    }
		  }
		  var CacheConfigurator = function () {
		    function CacheConfigurator(data) {
		      this._active = true;
		      this._never = false;
		      this._forever = false;
		      this._invalidate = false;
		      this._configured = false;
		      this._pairs = [];
		      this._data = void 0;
		      this._data = data;
		    }
		    var _proto = CacheConfigurator.prototype;
		    _proto.simple = function simple() {
		      return makeSimpleConfigurator(this);
		    };
		    _proto.mode = function mode() {
		      if (this._never) return "never";
		      if (this._forever) return "forever";
		      if (this._invalidate) return "invalidate";
		      return "valid";
		    };
		    _proto.forever = function forever() {
		      if (!this._active) {
		        throw new Error("Cannot change caching after evaluation has completed.");
		      }
		      if (this._never) {
		        throw new Error("Caching has already been configured with .never()");
		      }
		      this._forever = true;
		      this._configured = true;
		    };
		    _proto.never = function never() {
		      if (!this._active) {
		        throw new Error("Cannot change caching after evaluation has completed.");
		      }
		      if (this._forever) {
		        throw new Error("Caching has already been configured with .forever()");
		      }
		      this._never = true;
		      this._configured = true;
		    };
		    _proto.using = function using(handler) {
		      var _this = this;
		      if (!this._active) {
		        throw new Error("Cannot change caching after evaluation has completed.");
		      }
		      if (this._never || this._forever) {
		        throw new Error("Caching has already been configured with .never or .forever()");
		      }
		      this._configured = true;
		      var key = handler(this._data);
		      var fn = maybeAsync(handler, "You appear to be using an async cache handler, but Babel has been called synchronously");
		      if (isThenable$1(key)) {
		        return key.then(function (key) {
		          _this._pairs.push([key, fn]);
		          return key;
		        });
		      }
		      this._pairs.push([key, fn]);
		      return key;
		    };
		    _proto.invalidate = function invalidate(handler) {
		      this._invalidate = true;
		      return this.using(handler);
		    };
		    _proto.validator = function validator() {
		      var pairs = this._pairs;
		      return _regeneratorRuntime().mark(function _callee(data) {
		        var _iterator2, _step2, _step2$value, key, fn;
		        return _regeneratorRuntime().wrap(function _callee$(_context5) {
		          while (1) switch (_context5.prev = _context5.next) {
		            case 0:
		              _iterator2 = _createForOfIteratorHelperLoose(pairs);
		            case 1:
		              if ((_step2 = _iterator2()).done) {
		                _context5.next = 10;
		                break;
		              }
		              _step2$value = _slicedToArray(_step2.value, 2), key = _step2$value[0], fn = _step2$value[1];
		              _context5.t0 = key;
		              return _context5.delegateYield(fn(data), "t1", 5);
		            case 5:
		              _context5.t2 = _context5.t1;
		              if (!(_context5.t0 !== _context5.t2)) {
		                _context5.next = 8;
		                break;
		              }
		              return _context5.abrupt("return", false);
		            case 8:
		              _context5.next = 1;
		              break;
		            case 10:
		              return _context5.abrupt("return", true);
		            case 11:
		            case "end":
		              return _context5.stop();
		          }
		        }, _callee);
		      });
		    };
		    _proto.deactivate = function deactivate() {
		      this._active = false;
		    };
		    _proto.configured = function configured() {
		      return this._configured;
		    };
		    return _createClass(CacheConfigurator);
		  }();
		  function makeSimpleConfigurator(cache) {
		    function cacheFn(val) {
		      if (typeof val === "boolean") {
		        if (val) cache.forever();else cache.never();
		        return;
		      }
		      return cache.using(function () {
		        return assertSimpleType(val());
		      });
		    }
		    cacheFn.forever = function () {
		      return cache.forever();
		    };
		    cacheFn.never = function () {
		      return cache.never();
		    };
		    cacheFn.using = function (cb) {
		      return cache.using(function () {
		        return assertSimpleType(cb());
		      });
		    };
		    cacheFn.invalidate = function (cb) {
		      return cache.invalidate(function () {
		        return assertSimpleType(cb());
		      });
		    };
		    return cacheFn;
		  }
		  function assertSimpleType(value) {
		    if (isThenable$1(value)) {
		      throw new Error("You appear to be using an async cache handler, " + "which your current version of Babel does not support. " + "We may add support for this in the future, " + "but if you're on the most recent version of @babel/core and still " + "seeing this error, then you'll need to synchronously handle your caching logic.");
		    }
		    if (value != null && typeof value !== "string" && typeof value !== "boolean" && typeof value !== "number") {
		      throw new Error("Cache keys must be either string, boolean, number, null, or undefined.");
		    }
		    return value;
		  }
		  var Lock = function () {
		    function Lock() {
		      var _this2 = this;
		      this.released = false;
		      this.promise = void 0;
		      this._resolve = void 0;
		      this.promise = new Promise(function (resolve) {
		        _this2._resolve = resolve;
		      });
		    }
		    var _proto2 = Lock.prototype;
		    _proto2.release = function release(value) {
		      this.released = true;
		      this._resolve(value);
		    };
		    return _createClass(Lock);
		  }();

		  var require$$0$8 = [
		  	{
		  		name: "nodejs",
		  		version: "0.2.0",
		  		date: "2011-08-26",
		  		lts: false,
		  		security: false,
		  		v8: "2.3.8.0"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "0.3.0",
		  		date: "2011-08-26",
		  		lts: false,
		  		security: false,
		  		v8: "2.5.1.0"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "0.4.0",
		  		date: "2011-08-26",
		  		lts: false,
		  		security: false,
		  		v8: "3.1.2.0"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "0.5.0",
		  		date: "2011-08-26",
		  		lts: false,
		  		security: false,
		  		v8: "3.1.8.25"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "0.6.0",
		  		date: "2011-11-04",
		  		lts: false,
		  		security: false,
		  		v8: "3.6.6.6"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "0.7.0",
		  		date: "2012-01-17",
		  		lts: false,
		  		security: false,
		  		v8: "3.8.6.0"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "0.8.0",
		  		date: "2012-06-22",
		  		lts: false,
		  		security: false,
		  		v8: "3.11.10.10"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "0.9.0",
		  		date: "2012-07-20",
		  		lts: false,
		  		security: false,
		  		v8: "3.11.10.15"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "0.10.0",
		  		date: "2013-03-11",
		  		lts: false,
		  		security: false,
		  		v8: "3.14.5.8"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "0.11.0",
		  		date: "2013-03-28",
		  		lts: false,
		  		security: false,
		  		v8: "3.17.13.0"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "0.12.0",
		  		date: "2015-02-06",
		  		lts: false,
		  		security: false,
		  		v8: "3.28.73.0"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "4.0.0",
		  		date: "2015-09-08",
		  		lts: false,
		  		security: false,
		  		v8: "4.5.103.30"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "4.1.0",
		  		date: "2015-09-17",
		  		lts: false,
		  		security: false,
		  		v8: "4.5.103.33"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "4.2.0",
		  		date: "2015-10-12",
		  		lts: "Argon",
		  		security: false,
		  		v8: "4.5.103.35"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "4.3.0",
		  		date: "2016-02-09",
		  		lts: "Argon",
		  		security: false,
		  		v8: "4.5.103.35"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "4.4.0",
		  		date: "2016-03-08",
		  		lts: "Argon",
		  		security: false,
		  		v8: "4.5.103.35"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "4.5.0",
		  		date: "2016-08-16",
		  		lts: "Argon",
		  		security: false,
		  		v8: "4.5.103.37"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "4.6.0",
		  		date: "2016-09-27",
		  		lts: "Argon",
		  		security: true,
		  		v8: "4.5.103.37"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "4.7.0",
		  		date: "2016-12-06",
		  		lts: "Argon",
		  		security: false,
		  		v8: "4.5.103.43"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "4.8.0",
		  		date: "2017-02-21",
		  		lts: "Argon",
		  		security: false,
		  		v8: "4.5.103.45"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "4.9.0",
		  		date: "2018-03-28",
		  		lts: "Argon",
		  		security: true,
		  		v8: "4.5.103.53"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "5.0.0",
		  		date: "2015-10-29",
		  		lts: false,
		  		security: false,
		  		v8: "4.6.85.28"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "5.1.0",
		  		date: "2015-11-17",
		  		lts: false,
		  		security: false,
		  		v8: "4.6.85.31"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "5.2.0",
		  		date: "2015-12-09",
		  		lts: false,
		  		security: false,
		  		v8: "4.6.85.31"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "5.3.0",
		  		date: "2015-12-15",
		  		lts: false,
		  		security: false,
		  		v8: "4.6.85.31"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "5.4.0",
		  		date: "2016-01-06",
		  		lts: false,
		  		security: false,
		  		v8: "4.6.85.31"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "5.5.0",
		  		date: "2016-01-21",
		  		lts: false,
		  		security: false,
		  		v8: "4.6.85.31"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "5.6.0",
		  		date: "2016-02-09",
		  		lts: false,
		  		security: false,
		  		v8: "4.6.85.31"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "5.7.0",
		  		date: "2016-02-23",
		  		lts: false,
		  		security: false,
		  		v8: "4.6.85.31"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "5.8.0",
		  		date: "2016-03-09",
		  		lts: false,
		  		security: false,
		  		v8: "4.6.85.31"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "5.9.0",
		  		date: "2016-03-16",
		  		lts: false,
		  		security: false,
		  		v8: "4.6.85.31"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "5.10.0",
		  		date: "2016-04-01",
		  		lts: false,
		  		security: false,
		  		v8: "4.6.85.31"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "5.11.0",
		  		date: "2016-04-21",
		  		lts: false,
		  		security: false,
		  		v8: "4.6.85.31"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "5.12.0",
		  		date: "2016-06-23",
		  		lts: false,
		  		security: false,
		  		v8: "4.6.85.32"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "6.0.0",
		  		date: "2016-04-26",
		  		lts: false,
		  		security: false,
		  		v8: "5.0.71.35"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "6.1.0",
		  		date: "2016-05-05",
		  		lts: false,
		  		security: false,
		  		v8: "5.0.71.35"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "6.2.0",
		  		date: "2016-05-17",
		  		lts: false,
		  		security: false,
		  		v8: "5.0.71.47"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "6.3.0",
		  		date: "2016-07-06",
		  		lts: false,
		  		security: false,
		  		v8: "5.0.71.52"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "6.4.0",
		  		date: "2016-08-12",
		  		lts: false,
		  		security: false,
		  		v8: "5.0.71.60"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "6.5.0",
		  		date: "2016-08-26",
		  		lts: false,
		  		security: false,
		  		v8: "5.1.281.81"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "6.6.0",
		  		date: "2016-09-14",
		  		lts: false,
		  		security: false,
		  		v8: "5.1.281.83"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "6.7.0",
		  		date: "2016-09-27",
		  		lts: false,
		  		security: true,
		  		v8: "5.1.281.83"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "6.8.0",
		  		date: "2016-10-12",
		  		lts: false,
		  		security: false,
		  		v8: "5.1.281.84"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "6.9.0",
		  		date: "2016-10-18",
		  		lts: "Boron",
		  		security: false,
		  		v8: "5.1.281.84"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "6.10.0",
		  		date: "2017-02-21",
		  		lts: "Boron",
		  		security: false,
		  		v8: "5.1.281.93"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "6.11.0",
		  		date: "2017-06-06",
		  		lts: "Boron",
		  		security: false,
		  		v8: "5.1.281.102"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "6.12.0",
		  		date: "2017-11-06",
		  		lts: "Boron",
		  		security: false,
		  		v8: "5.1.281.108"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "6.13.0",
		  		date: "2018-02-10",
		  		lts: "Boron",
		  		security: false,
		  		v8: "5.1.281.111"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "6.14.0",
		  		date: "2018-03-28",
		  		lts: "Boron",
		  		security: true,
		  		v8: "5.1.281.111"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "6.15.0",
		  		date: "2018-11-27",
		  		lts: "Boron",
		  		security: true,
		  		v8: "5.1.281.111"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "6.16.0",
		  		date: "2018-12-26",
		  		lts: "Boron",
		  		security: false,
		  		v8: "5.1.281.111"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "6.17.0",
		  		date: "2019-02-28",
		  		lts: "Boron",
		  		security: true,
		  		v8: "5.1.281.111"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "7.0.0",
		  		date: "2016-10-25",
		  		lts: false,
		  		security: false,
		  		v8: "5.4.500.36"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "7.1.0",
		  		date: "2016-11-08",
		  		lts: false,
		  		security: false,
		  		v8: "5.4.500.36"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "7.2.0",
		  		date: "2016-11-22",
		  		lts: false,
		  		security: false,
		  		v8: "5.4.500.43"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "7.3.0",
		  		date: "2016-12-20",
		  		lts: false,
		  		security: false,
		  		v8: "5.4.500.45"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "7.4.0",
		  		date: "2017-01-04",
		  		lts: false,
		  		security: false,
		  		v8: "5.4.500.45"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "7.5.0",
		  		date: "2017-01-31",
		  		lts: false,
		  		security: false,
		  		v8: "5.4.500.48"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "7.6.0",
		  		date: "2017-02-21",
		  		lts: false,
		  		security: false,
		  		v8: "5.5.372.40"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "7.7.0",
		  		date: "2017-02-28",
		  		lts: false,
		  		security: false,
		  		v8: "5.5.372.41"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "7.8.0",
		  		date: "2017-03-29",
		  		lts: false,
		  		security: false,
		  		v8: "5.5.372.43"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "7.9.0",
		  		date: "2017-04-11",
		  		lts: false,
		  		security: false,
		  		v8: "5.5.372.43"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "7.10.0",
		  		date: "2017-05-02",
		  		lts: false,
		  		security: false,
		  		v8: "5.5.372.43"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "8.0.0",
		  		date: "2017-05-30",
		  		lts: false,
		  		security: false,
		  		v8: "5.8.283.41"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "8.1.0",
		  		date: "2017-06-08",
		  		lts: false,
		  		security: false,
		  		v8: "5.8.283.41"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "8.2.0",
		  		date: "2017-07-19",
		  		lts: false,
		  		security: false,
		  		v8: "5.8.283.41"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "8.3.0",
		  		date: "2017-08-08",
		  		lts: false,
		  		security: false,
		  		v8: "6.0.286.52"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "8.4.0",
		  		date: "2017-08-15",
		  		lts: false,
		  		security: false,
		  		v8: "6.0.286.52"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "8.5.0",
		  		date: "2017-09-12",
		  		lts: false,
		  		security: false,
		  		v8: "6.0.287.53"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "8.6.0",
		  		date: "2017-09-26",
		  		lts: false,
		  		security: false,
		  		v8: "6.0.287.53"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "8.7.0",
		  		date: "2017-10-11",
		  		lts: false,
		  		security: false,
		  		v8: "6.1.534.42"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "8.8.0",
		  		date: "2017-10-24",
		  		lts: false,
		  		security: false,
		  		v8: "6.1.534.42"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "8.9.0",
		  		date: "2017-10-31",
		  		lts: "Carbon",
		  		security: false,
		  		v8: "6.1.534.46"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "8.10.0",
		  		date: "2018-03-06",
		  		lts: "Carbon",
		  		security: false,
		  		v8: "6.2.414.50"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "8.11.0",
		  		date: "2018-03-28",
		  		lts: "Carbon",
		  		security: true,
		  		v8: "6.2.414.50"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "8.12.0",
		  		date: "2018-09-10",
		  		lts: "Carbon",
		  		security: false,
		  		v8: "6.2.414.66"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "8.13.0",
		  		date: "2018-11-20",
		  		lts: "Carbon",
		  		security: false,
		  		v8: "6.2.414.72"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "8.14.0",
		  		date: "2018-11-27",
		  		lts: "Carbon",
		  		security: true,
		  		v8: "6.2.414.72"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "8.15.0",
		  		date: "2018-12-26",
		  		lts: "Carbon",
		  		security: false,
		  		v8: "6.2.414.75"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "8.16.0",
		  		date: "2019-04-16",
		  		lts: "Carbon",
		  		security: false,
		  		v8: "6.2.414.77"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "8.17.0",
		  		date: "2019-12-17",
		  		lts: "Carbon",
		  		security: true,
		  		v8: "6.2.414.78"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "9.0.0",
		  		date: "2017-10-31",
		  		lts: false,
		  		security: false,
		  		v8: "6.2.414.32"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "9.1.0",
		  		date: "2017-11-07",
		  		lts: false,
		  		security: false,
		  		v8: "6.2.414.32"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "9.2.0",
		  		date: "2017-11-14",
		  		lts: false,
		  		security: false,
		  		v8: "6.2.414.44"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "9.3.0",
		  		date: "2017-12-12",
		  		lts: false,
		  		security: false,
		  		v8: "6.2.414.46"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "9.4.0",
		  		date: "2018-01-10",
		  		lts: false,
		  		security: false,
		  		v8: "6.2.414.46"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "9.5.0",
		  		date: "2018-01-31",
		  		lts: false,
		  		security: false,
		  		v8: "6.2.414.46"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "9.6.0",
		  		date: "2018-02-21",
		  		lts: false,
		  		security: false,
		  		v8: "6.2.414.46"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "9.7.0",
		  		date: "2018-03-01",
		  		lts: false,
		  		security: false,
		  		v8: "6.2.414.46"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "9.8.0",
		  		date: "2018-03-07",
		  		lts: false,
		  		security: false,
		  		v8: "6.2.414.46"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "9.9.0",
		  		date: "2018-03-21",
		  		lts: false,
		  		security: false,
		  		v8: "6.2.414.46"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "9.10.0",
		  		date: "2018-03-28",
		  		lts: false,
		  		security: true,
		  		v8: "6.2.414.46"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "9.11.0",
		  		date: "2018-04-04",
		  		lts: false,
		  		security: false,
		  		v8: "6.2.414.46"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "10.0.0",
		  		date: "2018-04-24",
		  		lts: false,
		  		security: false,
		  		v8: "6.6.346.24"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "10.1.0",
		  		date: "2018-05-08",
		  		lts: false,
		  		security: false,
		  		v8: "6.6.346.27"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "10.2.0",
		  		date: "2018-05-23",
		  		lts: false,
		  		security: false,
		  		v8: "6.6.346.32"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "10.3.0",
		  		date: "2018-05-29",
		  		lts: false,
		  		security: false,
		  		v8: "6.6.346.32"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "10.4.0",
		  		date: "2018-06-06",
		  		lts: false,
		  		security: false,
		  		v8: "6.7.288.43"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "10.5.0",
		  		date: "2018-06-20",
		  		lts: false,
		  		security: false,
		  		v8: "6.7.288.46"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "10.6.0",
		  		date: "2018-07-04",
		  		lts: false,
		  		security: false,
		  		v8: "6.7.288.46"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "10.7.0",
		  		date: "2018-07-18",
		  		lts: false,
		  		security: false,
		  		v8: "6.7.288.49"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "10.8.0",
		  		date: "2018-08-01",
		  		lts: false,
		  		security: false,
		  		v8: "6.7.288.49"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "10.9.0",
		  		date: "2018-08-15",
		  		lts: false,
		  		security: false,
		  		v8: "6.8.275.24"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "10.10.0",
		  		date: "2018-09-06",
		  		lts: false,
		  		security: false,
		  		v8: "6.8.275.30"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "10.11.0",
		  		date: "2018-09-19",
		  		lts: false,
		  		security: false,
		  		v8: "6.8.275.32"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "10.12.0",
		  		date: "2018-10-10",
		  		lts: false,
		  		security: false,
		  		v8: "6.8.275.32"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "10.13.0",
		  		date: "2018-10-30",
		  		lts: "Dubnium",
		  		security: false,
		  		v8: "6.8.275.32"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "10.14.0",
		  		date: "2018-11-27",
		  		lts: "Dubnium",
		  		security: true,
		  		v8: "6.8.275.32"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "10.15.0",
		  		date: "2018-12-26",
		  		lts: "Dubnium",
		  		security: false,
		  		v8: "6.8.275.32"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "10.16.0",
		  		date: "2019-05-28",
		  		lts: "Dubnium",
		  		security: false,
		  		v8: "6.8.275.32"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "10.17.0",
		  		date: "2019-10-22",
		  		lts: "Dubnium",
		  		security: false,
		  		v8: "6.8.275.32"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "10.18.0",
		  		date: "2019-12-17",
		  		lts: "Dubnium",
		  		security: true,
		  		v8: "6.8.275.32"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "10.19.0",
		  		date: "2020-02-05",
		  		lts: "Dubnium",
		  		security: true,
		  		v8: "6.8.275.32"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "10.20.0",
		  		date: "2020-03-26",
		  		lts: "Dubnium",
		  		security: false,
		  		v8: "6.8.275.32"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "10.21.0",
		  		date: "2020-06-02",
		  		lts: "Dubnium",
		  		security: true,
		  		v8: "6.8.275.32"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "10.22.0",
		  		date: "2020-07-21",
		  		lts: "Dubnium",
		  		security: false,
		  		v8: "6.8.275.32"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "10.23.0",
		  		date: "2020-10-27",
		  		lts: "Dubnium",
		  		security: false,
		  		v8: "6.8.275.32"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "10.24.0",
		  		date: "2021-02-23",
		  		lts: "Dubnium",
		  		security: true,
		  		v8: "6.8.275.32"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "11.0.0",
		  		date: "2018-10-23",
		  		lts: false,
		  		security: false,
		  		v8: "7.0.276.28"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "11.1.0",
		  		date: "2018-10-30",
		  		lts: false,
		  		security: false,
		  		v8: "7.0.276.32"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "11.2.0",
		  		date: "2018-11-15",
		  		lts: false,
		  		security: false,
		  		v8: "7.0.276.38"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "11.3.0",
		  		date: "2018-11-27",
		  		lts: false,
		  		security: true,
		  		v8: "7.0.276.38"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "11.4.0",
		  		date: "2018-12-07",
		  		lts: false,
		  		security: false,
		  		v8: "7.0.276.38"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "11.5.0",
		  		date: "2018-12-18",
		  		lts: false,
		  		security: false,
		  		v8: "7.0.276.38"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "11.6.0",
		  		date: "2018-12-26",
		  		lts: false,
		  		security: false,
		  		v8: "7.0.276.38"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "11.7.0",
		  		date: "2019-01-17",
		  		lts: false,
		  		security: false,
		  		v8: "7.0.276.38"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "11.8.0",
		  		date: "2019-01-24",
		  		lts: false,
		  		security: false,
		  		v8: "7.0.276.38"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "11.9.0",
		  		date: "2019-01-30",
		  		lts: false,
		  		security: false,
		  		v8: "7.0.276.38"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "11.10.0",
		  		date: "2019-02-14",
		  		lts: false,
		  		security: false,
		  		v8: "7.0.276.38"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "11.11.0",
		  		date: "2019-03-05",
		  		lts: false,
		  		security: false,
		  		v8: "7.0.276.38"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "11.12.0",
		  		date: "2019-03-14",
		  		lts: false,
		  		security: false,
		  		v8: "7.0.276.38"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "11.13.0",
		  		date: "2019-03-28",
		  		lts: false,
		  		security: false,
		  		v8: "7.0.276.38"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "11.14.0",
		  		date: "2019-04-10",
		  		lts: false,
		  		security: false,
		  		v8: "7.0.276.38"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "11.15.0",
		  		date: "2019-04-30",
		  		lts: false,
		  		security: false,
		  		v8: "7.0.276.38"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "12.0.0",
		  		date: "2019-04-23",
		  		lts: false,
		  		security: false,
		  		v8: "7.4.288.21"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "12.1.0",
		  		date: "2019-04-29",
		  		lts: false,
		  		security: false,
		  		v8: "7.4.288.21"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "12.2.0",
		  		date: "2019-05-07",
		  		lts: false,
		  		security: false,
		  		v8: "7.4.288.21"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "12.3.0",
		  		date: "2019-05-21",
		  		lts: false,
		  		security: false,
		  		v8: "7.4.288.27"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "12.4.0",
		  		date: "2019-06-04",
		  		lts: false,
		  		security: false,
		  		v8: "7.4.288.27"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "12.5.0",
		  		date: "2019-06-26",
		  		lts: false,
		  		security: false,
		  		v8: "7.5.288.22"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "12.6.0",
		  		date: "2019-07-03",
		  		lts: false,
		  		security: false,
		  		v8: "7.5.288.22"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "12.7.0",
		  		date: "2019-07-23",
		  		lts: false,
		  		security: false,
		  		v8: "7.5.288.22"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "12.8.0",
		  		date: "2019-08-06",
		  		lts: false,
		  		security: false,
		  		v8: "7.5.288.22"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "12.9.0",
		  		date: "2019-08-20",
		  		lts: false,
		  		security: false,
		  		v8: "7.6.303.29"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "12.10.0",
		  		date: "2019-09-04",
		  		lts: false,
		  		security: false,
		  		v8: "7.6.303.29"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "12.11.0",
		  		date: "2019-09-25",
		  		lts: false,
		  		security: false,
		  		v8: "7.7.299.11"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "12.12.0",
		  		date: "2019-10-11",
		  		lts: false,
		  		security: false,
		  		v8: "7.7.299.13"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "12.13.0",
		  		date: "2019-10-21",
		  		lts: "Erbium",
		  		security: false,
		  		v8: "7.7.299.13"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "12.14.0",
		  		date: "2019-12-17",
		  		lts: "Erbium",
		  		security: true,
		  		v8: "7.7.299.13"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "12.15.0",
		  		date: "2020-02-05",
		  		lts: "Erbium",
		  		security: true,
		  		v8: "7.7.299.13"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "12.16.0",
		  		date: "2020-02-11",
		  		lts: "Erbium",
		  		security: false,
		  		v8: "7.8.279.23"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "12.17.0",
		  		date: "2020-05-26",
		  		lts: "Erbium",
		  		security: false,
		  		v8: "7.8.279.23"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "12.18.0",
		  		date: "2020-06-02",
		  		lts: "Erbium",
		  		security: true,
		  		v8: "7.8.279.23"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "12.19.0",
		  		date: "2020-10-06",
		  		lts: "Erbium",
		  		security: false,
		  		v8: "7.8.279.23"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "12.20.0",
		  		date: "2020-11-24",
		  		lts: "Erbium",
		  		security: false,
		  		v8: "7.8.279.23"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "12.21.0",
		  		date: "2021-02-23",
		  		lts: "Erbium",
		  		security: true,
		  		v8: "7.8.279.23"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "12.22.0",
		  		date: "2021-03-30",
		  		lts: "Erbium",
		  		security: false,
		  		v8: "7.8.279.23"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "13.0.0",
		  		date: "2019-10-22",
		  		lts: false,
		  		security: false,
		  		v8: "7.8.279.17"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "13.1.0",
		  		date: "2019-11-05",
		  		lts: false,
		  		security: false,
		  		v8: "7.8.279.17"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "13.2.0",
		  		date: "2019-11-21",
		  		lts: false,
		  		security: false,
		  		v8: "7.9.317.23"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "13.3.0",
		  		date: "2019-12-03",
		  		lts: false,
		  		security: false,
		  		v8: "7.9.317.25"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "13.4.0",
		  		date: "2019-12-17",
		  		lts: false,
		  		security: true,
		  		v8: "7.9.317.25"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "13.5.0",
		  		date: "2019-12-18",
		  		lts: false,
		  		security: false,
		  		v8: "7.9.317.25"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "13.6.0",
		  		date: "2020-01-07",
		  		lts: false,
		  		security: false,
		  		v8: "7.9.317.25"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "13.7.0",
		  		date: "2020-01-21",
		  		lts: false,
		  		security: false,
		  		v8: "7.9.317.25"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "13.8.0",
		  		date: "2020-02-05",
		  		lts: false,
		  		security: true,
		  		v8: "7.9.317.25"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "13.9.0",
		  		date: "2020-02-18",
		  		lts: false,
		  		security: false,
		  		v8: "7.9.317.25"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "13.10.0",
		  		date: "2020-03-04",
		  		lts: false,
		  		security: false,
		  		v8: "7.9.317.25"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "13.11.0",
		  		date: "2020-03-12",
		  		lts: false,
		  		security: false,
		  		v8: "7.9.317.25"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "13.12.0",
		  		date: "2020-03-26",
		  		lts: false,
		  		security: false,
		  		v8: "7.9.317.25"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "13.13.0",
		  		date: "2020-04-14",
		  		lts: false,
		  		security: false,
		  		v8: "7.9.317.25"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "13.14.0",
		  		date: "2020-04-29",
		  		lts: false,
		  		security: false,
		  		v8: "7.9.317.25"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "14.0.0",
		  		date: "2020-04-21",
		  		lts: false,
		  		security: false,
		  		v8: "8.1.307.30"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "14.1.0",
		  		date: "2020-04-29",
		  		lts: false,
		  		security: false,
		  		v8: "8.1.307.31"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "14.2.0",
		  		date: "2020-05-05",
		  		lts: false,
		  		security: false,
		  		v8: "8.1.307.31"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "14.3.0",
		  		date: "2020-05-19",
		  		lts: false,
		  		security: false,
		  		v8: "8.1.307.31"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "14.4.0",
		  		date: "2020-06-02",
		  		lts: false,
		  		security: true,
		  		v8: "8.1.307.31"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "14.5.0",
		  		date: "2020-06-30",
		  		lts: false,
		  		security: false,
		  		v8: "8.3.110.9"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "14.6.0",
		  		date: "2020-07-20",
		  		lts: false,
		  		security: false,
		  		v8: "8.4.371.19"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "14.7.0",
		  		date: "2020-07-29",
		  		lts: false,
		  		security: false,
		  		v8: "8.4.371.19"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "14.8.0",
		  		date: "2020-08-11",
		  		lts: false,
		  		security: false,
		  		v8: "8.4.371.19"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "14.9.0",
		  		date: "2020-08-27",
		  		lts: false,
		  		security: false,
		  		v8: "8.4.371.19"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "14.10.0",
		  		date: "2020-09-08",
		  		lts: false,
		  		security: false,
		  		v8: "8.4.371.19"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "14.11.0",
		  		date: "2020-09-15",
		  		lts: false,
		  		security: true,
		  		v8: "8.4.371.19"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "14.12.0",
		  		date: "2020-09-22",
		  		lts: false,
		  		security: false,
		  		v8: "8.4.371.19"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "14.13.0",
		  		date: "2020-09-29",
		  		lts: false,
		  		security: false,
		  		v8: "8.4.371.19"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "14.14.0",
		  		date: "2020-10-15",
		  		lts: false,
		  		security: false,
		  		v8: "8.4.371.19"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "14.15.0",
		  		date: "2020-10-27",
		  		lts: "Fermium",
		  		security: false,
		  		v8: "8.4.371.19"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "14.16.0",
		  		date: "2021-02-23",
		  		lts: "Fermium",
		  		security: true,
		  		v8: "8.4.371.19"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "14.17.0",
		  		date: "2021-05-11",
		  		lts: "Fermium",
		  		security: false,
		  		v8: "8.4.371.23"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "14.18.0",
		  		date: "2021-09-28",
		  		lts: "Fermium",
		  		security: false,
		  		v8: "8.4.371.23"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "14.19.0",
		  		date: "2022-02-01",
		  		lts: "Fermium",
		  		security: false,
		  		v8: "8.4.371.23"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "14.20.0",
		  		date: "2022-07-07",
		  		lts: "Fermium",
		  		security: true,
		  		v8: "8.4.371.23"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "14.21.0",
		  		date: "2022-11-01",
		  		lts: "Fermium",
		  		security: false,
		  		v8: "8.4.371.23"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "15.0.0",
		  		date: "2020-10-20",
		  		lts: false,
		  		security: false,
		  		v8: "8.6.395.16"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "15.1.0",
		  		date: "2020-11-04",
		  		lts: false,
		  		security: false,
		  		v8: "8.6.395.17"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "15.2.0",
		  		date: "2020-11-10",
		  		lts: false,
		  		security: false,
		  		v8: "8.6.395.17"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "15.3.0",
		  		date: "2020-11-24",
		  		lts: false,
		  		security: false,
		  		v8: "8.6.395.17"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "15.4.0",
		  		date: "2020-12-09",
		  		lts: false,
		  		security: false,
		  		v8: "8.6.395.17"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "15.5.0",
		  		date: "2020-12-22",
		  		lts: false,
		  		security: false,
		  		v8: "8.6.395.17"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "15.6.0",
		  		date: "2021-01-14",
		  		lts: false,
		  		security: false,
		  		v8: "8.6.395.17"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "15.7.0",
		  		date: "2021-01-25",
		  		lts: false,
		  		security: false,
		  		v8: "8.6.395.17"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "15.8.0",
		  		date: "2021-02-02",
		  		lts: false,
		  		security: false,
		  		v8: "8.6.395.17"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "15.9.0",
		  		date: "2021-02-18",
		  		lts: false,
		  		security: false,
		  		v8: "8.6.395.17"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "15.10.0",
		  		date: "2021-02-23",
		  		lts: false,
		  		security: true,
		  		v8: "8.6.395.17"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "15.11.0",
		  		date: "2021-03-03",
		  		lts: false,
		  		security: false,
		  		v8: "8.6.395.17"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "15.12.0",
		  		date: "2021-03-17",
		  		lts: false,
		  		security: false,
		  		v8: "8.6.395.17"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "15.13.0",
		  		date: "2021-03-31",
		  		lts: false,
		  		security: false,
		  		v8: "8.6.395.17"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "15.14.0",
		  		date: "2021-04-06",
		  		lts: false,
		  		security: false,
		  		v8: "8.6.395.17"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "16.0.0",
		  		date: "2021-04-20",
		  		lts: false,
		  		security: false,
		  		v8: "9.0.257.17"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "16.1.0",
		  		date: "2021-05-04",
		  		lts: false,
		  		security: false,
		  		v8: "9.0.257.24"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "16.2.0",
		  		date: "2021-05-19",
		  		lts: false,
		  		security: false,
		  		v8: "9.0.257.25"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "16.3.0",
		  		date: "2021-06-03",
		  		lts: false,
		  		security: false,
		  		v8: "9.0.257.25"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "16.4.0",
		  		date: "2021-06-23",
		  		lts: false,
		  		security: false,
		  		v8: "9.1.269.36"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "16.5.0",
		  		date: "2021-07-14",
		  		lts: false,
		  		security: false,
		  		v8: "9.1.269.38"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "16.6.0",
		  		date: "2021-07-29",
		  		lts: false,
		  		security: true,
		  		v8: "9.2.230.21"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "16.7.0",
		  		date: "2021-08-18",
		  		lts: false,
		  		security: false,
		  		v8: "9.2.230.21"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "16.8.0",
		  		date: "2021-08-25",
		  		lts: false,
		  		security: false,
		  		v8: "9.2.230.21"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "16.9.0",
		  		date: "2021-09-07",
		  		lts: false,
		  		security: false,
		  		v8: "9.3.345.16"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "16.10.0",
		  		date: "2021-09-22",
		  		lts: false,
		  		security: false,
		  		v8: "9.3.345.19"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "16.11.0",
		  		date: "2021-10-08",
		  		lts: false,
		  		security: false,
		  		v8: "9.4.146.19"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "16.12.0",
		  		date: "2021-10-20",
		  		lts: false,
		  		security: false,
		  		v8: "9.4.146.19"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "16.13.0",
		  		date: "2021-10-26",
		  		lts: "Gallium",
		  		security: false,
		  		v8: "9.4.146.19"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "16.14.0",
		  		date: "2022-02-08",
		  		lts: "Gallium",
		  		security: false,
		  		v8: "9.4.146.24"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "16.15.0",
		  		date: "2022-04-26",
		  		lts: "Gallium",
		  		security: false,
		  		v8: "9.4.146.24"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "16.16.0",
		  		date: "2022-07-07",
		  		lts: "Gallium",
		  		security: true,
		  		v8: "9.4.146.24"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "16.17.0",
		  		date: "2022-08-16",
		  		lts: "Gallium",
		  		security: false,
		  		v8: "9.4.146.26"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "16.18.0",
		  		date: "2022-10-12",
		  		lts: "Gallium",
		  		security: false,
		  		v8: "9.4.146.26"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "16.19.0",
		  		date: "2022-12-13",
		  		lts: "Gallium",
		  		security: false,
		  		v8: "9.4.146.26"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "16.20.0",
		  		date: "2023-03-28",
		  		lts: "Gallium",
		  		security: false,
		  		v8: "9.4.146.26"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "17.0.0",
		  		date: "2021-10-19",
		  		lts: false,
		  		security: false,
		  		v8: "9.5.172.21"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "17.1.0",
		  		date: "2021-11-09",
		  		lts: false,
		  		security: false,
		  		v8: "9.5.172.25"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "17.2.0",
		  		date: "2021-11-30",
		  		lts: false,
		  		security: false,
		  		v8: "9.6.180.14"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "17.3.0",
		  		date: "2021-12-17",
		  		lts: false,
		  		security: false,
		  		v8: "9.6.180.15"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "17.4.0",
		  		date: "2022-01-18",
		  		lts: false,
		  		security: false,
		  		v8: "9.6.180.15"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "17.5.0",
		  		date: "2022-02-10",
		  		lts: false,
		  		security: false,
		  		v8: "9.6.180.15"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "17.6.0",
		  		date: "2022-02-22",
		  		lts: false,
		  		security: false,
		  		v8: "9.6.180.15"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "17.7.0",
		  		date: "2022-03-09",
		  		lts: false,
		  		security: false,
		  		v8: "9.6.180.15"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "17.8.0",
		  		date: "2022-03-22",
		  		lts: false,
		  		security: false,
		  		v8: "9.6.180.15"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "17.9.0",
		  		date: "2022-04-07",
		  		lts: false,
		  		security: false,
		  		v8: "9.6.180.15"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "18.0.0",
		  		date: "2022-04-18",
		  		lts: false,
		  		security: false,
		  		v8: "10.1.124.8"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "18.1.0",
		  		date: "2022-05-03",
		  		lts: false,
		  		security: false,
		  		v8: "10.1.124.8"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "18.2.0",
		  		date: "2022-05-17",
		  		lts: false,
		  		security: false,
		  		v8: "10.1.124.8"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "18.3.0",
		  		date: "2022-06-02",
		  		lts: false,
		  		security: false,
		  		v8: "10.2.154.4"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "18.4.0",
		  		date: "2022-06-16",
		  		lts: false,
		  		security: false,
		  		v8: "10.2.154.4"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "18.5.0",
		  		date: "2022-07-06",
		  		lts: false,
		  		security: true,
		  		v8: "10.2.154.4"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "18.6.0",
		  		date: "2022-07-13",
		  		lts: false,
		  		security: false,
		  		v8: "10.2.154.13"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "18.7.0",
		  		date: "2022-07-26",
		  		lts: false,
		  		security: false,
		  		v8: "10.2.154.13"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "18.8.0",
		  		date: "2022-08-24",
		  		lts: false,
		  		security: false,
		  		v8: "10.2.154.13"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "18.9.0",
		  		date: "2022-09-07",
		  		lts: false,
		  		security: false,
		  		v8: "10.2.154.15"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "18.10.0",
		  		date: "2022-09-28",
		  		lts: false,
		  		security: false,
		  		v8: "10.2.154.15"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "18.11.0",
		  		date: "2022-10-13",
		  		lts: false,
		  		security: false,
		  		v8: "10.2.154.15"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "18.12.0",
		  		date: "2022-10-25",
		  		lts: "Hydrogen",
		  		security: false,
		  		v8: "10.2.154.15"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "18.13.0",
		  		date: "2023-01-05",
		  		lts: "Hydrogen",
		  		security: false,
		  		v8: "10.2.154.23"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "18.14.0",
		  		date: "2023-02-01",
		  		lts: "Hydrogen",
		  		security: false,
		  		v8: "10.2.154.23"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "18.15.0",
		  		date: "2023-03-05",
		  		lts: "Hydrogen",
		  		security: false,
		  		v8: "10.2.154.26"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "18.16.0",
		  		date: "2023-04-12",
		  		lts: "Hydrogen",
		  		security: false,
		  		v8: "10.2.154.26"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "18.17.0",
		  		date: "2023-07-18",
		  		lts: "Hydrogen",
		  		security: false,
		  		v8: "10.2.154.26"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "18.18.0",
		  		date: "2023-09-18",
		  		lts: "Hydrogen",
		  		security: false,
		  		v8: "10.2.154.26"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "18.19.0",
		  		date: "2023-11-29",
		  		lts: "Hydrogen",
		  		security: false,
		  		v8: "10.2.154.26"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "19.0.0",
		  		date: "2022-10-17",
		  		lts: false,
		  		security: false,
		  		v8: "10.7.193.13"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "19.1.0",
		  		date: "2022-11-14",
		  		lts: false,
		  		security: false,
		  		v8: "10.7.193.20"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "19.2.0",
		  		date: "2022-11-29",
		  		lts: false,
		  		security: false,
		  		v8: "10.8.168.20"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "19.3.0",
		  		date: "2022-12-14",
		  		lts: false,
		  		security: false,
		  		v8: "10.8.168.21"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "19.4.0",
		  		date: "2023-01-05",
		  		lts: false,
		  		security: false,
		  		v8: "10.8.168.25"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "19.5.0",
		  		date: "2023-01-24",
		  		lts: false,
		  		security: false,
		  		v8: "10.8.168.25"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "19.6.0",
		  		date: "2023-02-01",
		  		lts: false,
		  		security: false,
		  		v8: "10.8.168.25"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "19.7.0",
		  		date: "2023-02-21",
		  		lts: false,
		  		security: false,
		  		v8: "10.8.168.25"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "19.8.0",
		  		date: "2023-03-14",
		  		lts: false,
		  		security: false,
		  		v8: "10.8.168.25"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "19.9.0",
		  		date: "2023-04-10",
		  		lts: false,
		  		security: false,
		  		v8: "10.8.168.25"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "20.0.0",
		  		date: "2023-04-17",
		  		lts: false,
		  		security: false,
		  		v8: "11.3.244.4"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "20.1.0",
		  		date: "2023-05-03",
		  		lts: false,
		  		security: false,
		  		v8: "11.3.244.8"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "20.2.0",
		  		date: "2023-05-16",
		  		lts: false,
		  		security: false,
		  		v8: "11.3.244.8"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "20.3.0",
		  		date: "2023-06-08",
		  		lts: false,
		  		security: false,
		  		v8: "11.3.244.8"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "20.4.0",
		  		date: "2023-07-04",
		  		lts: false,
		  		security: false,
		  		v8: "11.3.244.8"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "20.5.0",
		  		date: "2023-07-19",
		  		lts: false,
		  		security: false,
		  		v8: "11.3.244.8"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "20.6.0",
		  		date: "2023-08-23",
		  		lts: false,
		  		security: false,
		  		v8: "11.3.244.8"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "20.7.0",
		  		date: "2023-09-18",
		  		lts: false,
		  		security: false,
		  		v8: "11.3.244.8"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "20.8.0",
		  		date: "2023-09-28",
		  		lts: false,
		  		security: false,
		  		v8: "11.3.244.8"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "20.9.0",
		  		date: "2023-10-24",
		  		lts: "Iron",
		  		security: false,
		  		v8: "11.3.244.8"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "20.10.0",
		  		date: "2023-11-22",
		  		lts: "Iron",
		  		security: false,
		  		v8: "11.3.244.8"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "21.0.0",
		  		date: "2023-10-17",
		  		lts: false,
		  		security: false,
		  		v8: "11.8.172.13"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "21.1.0",
		  		date: "2023-10-24",
		  		lts: false,
		  		security: false,
		  		v8: "11.8.172.15"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "21.2.0",
		  		date: "2023-11-14",
		  		lts: false,
		  		security: false,
		  		v8: "11.8.172.17"
		  	},
		  	{
		  		name: "nodejs",
		  		version: "21.3.0",
		  		date: "2023-11-30",
		  		lts: false,
		  		security: false,
		  		v8: "11.8.172.17"
		  	}
		  ];

		  var agents$2 = {};

		  var browsers$2 = {};

		  var browsers$1 = {
		    A: "ie",
		    B: "edge",
		    C: "firefox",
		    D: "chrome",
		    E: "safari",
		    F: "opera",
		    G: "ios_saf",
		    H: "op_mini",
		    I: "android",
		    J: "bb",
		    K: "op_mob",
		    L: "and_chr",
		    M: "and_ff",
		    N: "ie_mob",
		    O: "and_uc",
		    P: "samsung",
		    Q: "and_qq",
		    R: "baidu",
		    S: "kaios"
		  };

		  browsers$2.browsers = browsers$1;

		  var browserVersions$1 = {};

		  var browserVersions = {
		    "0": "112",
		    "1": "113",
		    "2": "114",
		    "3": "115",
		    "4": "116",
		    "5": "117",
		    "6": "118",
		    "7": "5",
		    "8": "19",
		    "9": "24",
		    A: "10",
		    B: "11",
		    C: "12",
		    D: "119",
		    E: "7",
		    F: "8",
		    G: "9",
		    H: "15",
		    I: "4",
		    J: "6",
		    K: "13",
		    L: "14",
		    M: "16",
		    N: "17",
		    O: "18",
		    P: "79",
		    Q: "80",
		    R: "81",
		    S: "83",
		    T: "84",
		    U: "85",
		    V: "86",
		    W: "87",
		    X: "88",
		    Y: "89",
		    Z: "90",
		    a: "91",
		    b: "92",
		    c: "93",
		    d: "94",
		    e: "95",
		    f: "96",
		    g: "97",
		    h: "98",
		    i: "99",
		    j: "100",
		    k: "101",
		    l: "102",
		    m: "103",
		    n: "104",
		    o: "20",
		    p: "21",
		    q: "22",
		    r: "23",
		    s: "73",
		    t: "105",
		    u: "106",
		    v: "107",
		    w: "108",
		    x: "109",
		    y: "110",
		    z: "111",
		    AB: "25",
		    BB: "26",
		    CB: "27",
		    DB: "28",
		    EB: "29",
		    FB: "30",
		    GB: "31",
		    HB: "32",
		    IB: "33",
		    JB: "34",
		    KB: "35",
		    LB: "36",
		    MB: "37",
		    NB: "38",
		    OB: "39",
		    PB: "40",
		    QB: "41",
		    RB: "42",
		    SB: "43",
		    TB: "44",
		    UB: "45",
		    VB: "46",
		    WB: "47",
		    XB: "48",
		    YB: "49",
		    ZB: "50",
		    aB: "51",
		    bB: "52",
		    cB: "53",
		    dB: "54",
		    eB: "55",
		    fB: "56",
		    gB: "57",
		    hB: "58",
		    iB: "60",
		    jB: "62",
		    kB: "63",
		    lB: "64",
		    mB: "65",
		    nB: "66",
		    oB: "67",
		    pB: "68",
		    qB: "69",
		    rB: "70",
		    sB: "71",
		    tB: "72",
		    uB: "74",
		    vB: "75",
		    wB: "76",
		    xB: "77",
		    yB: "78",
		    zB: "11.1",
		    "0B": "12.1",
		    "1B": "15.5",
		    "2B": "16.0",
		    "3B": "17.0",
		    "4B": "3",
		    "5B": "59",
		    "6B": "61",
		    "7B": "82",
		    "8B": "120",
		    "9B": "121",
		    AC: "122",
		    BC: "3.2",
		    CC: "10.1",
		    DC: "13.1",
		    EC: "15.2-15.3",
		    FC: "15.4",
		    GC: "16.1",
		    HC: "16.2",
		    IC: "16.3",
		    JC: "16.4",
		    KC: "16.5",
		    LC: "17.1",
		    MC: "17.2",
		    NC: "11.5",
		    OC: "4.2-4.3",
		    PC: "5.5",
		    QC: "2",
		    RC: "123",
		    SC: "3.5",
		    TC: "3.6",
		    UC: "3.1",
		    VC: "5.1",
		    WC: "6.1",
		    XC: "7.1",
		    YC: "9.1",
		    ZC: "14.1",
		    aC: "15.1",
		    bC: "15.6",
		    cC: "16.6",
		    dC: "TP",
		    eC: "9.5-9.6",
		    fC: "10.0-10.1",
		    gC: "10.5",
		    hC: "10.6",
		    iC: "11.6",
		    jC: "4.0-4.1",
		    kC: "5.0-5.1",
		    lC: "6.0-6.1",
		    mC: "7.0-7.1",
		    nC: "8.1-8.4",
		    oC: "9.0-9.2",
		    pC: "9.3",
		    qC: "10.0-10.2",
		    rC: "10.3",
		    sC: "11.0-11.2",
		    tC: "11.3-11.4",
		    uC: "12.0-12.1",
		    vC: "12.2-12.5",
		    wC: "13.0-13.1",
		    xC: "13.2",
		    yC: "13.3",
		    zC: "13.4-13.7",
		    "0C": "14.0-14.4",
		    "1C": "14.5-14.8",
		    "2C": "15.0-15.1",
		    "3C": "15.6-15.7",
		    "4C": "16.6-16.7",
		    "5C": "all",
		    "6C": "2.1",
		    "7C": "2.2",
		    "8C": "2.3",
		    "9C": "4.1",
		    AD: "4.4",
		    BD: "4.4.3-4.4.4",
		    CD: "5.0-5.4",
		    DD: "6.2-6.4",
		    ED: "7.2-7.4",
		    FD: "8.2",
		    GD: "9.2",
		    HD: "11.1-11.2",
		    ID: "12.0",
		    JD: "13.0",
		    KD: "14.0",
		    LD: "15.0",
		    MD: "18.0",
		    ND: "19.0",
		    OD: "13.18",
		    PD: "2.5",
		    QD: "3.0-3.1"
		  };

		  browserVersions$1.browserVersions = browserVersions;

		  var agents$1 = {
		    A: {
		      A: {
		        J: 0,
		        E: 0,
		        F: 0.0125552,
		        G: 0.062776,
		        A: 0,
		        B: 0.364101,
		        PC: 0
		      },
		      B: "ms",
		      C: ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "PC", "J", "E", "F", "G", "A", "B", "", "", ""],
		      E: "IE",
		      F: {
		        PC: 962323200,
		        J: 998870400,
		        E: 1161129600,
		        F: 1237420800,
		        G: 1300060800,
		        A: 1346716800,
		        B: 1381968000
		      }
		    },
		    B: {
		      A: {
		        "0": 0.013452,
		        "1": 0.017936,
		        "2": 0.02242,
		        "3": 0.026904,
		        "4": 0.040356,
		        "5": 0.461852,
		        "6": 0.816088,
		        C: 0.008968,
		        K: 0.008968,
		        L: 0.013452,
		        H: 0.008968,
		        M: 0,
		        N: 0.004484,
		        O: 0.008968,
		        P: 0,
		        Q: 0,
		        R: 0,
		        S: 0,
		        T: 0.004484,
		        U: 0.004484,
		        V: 0,
		        W: 0.219716,
		        X: 0,
		        Y: 0,
		        Z: 0,
		        a: 0,
		        b: 0.013452,
		        c: 0,
		        d: 0,
		        e: 0,
		        f: 0,
		        g: 0,
		        h: 0,
		        i: 0.017936,
		        j: 0,
		        k: 0,
		        l: 0,
		        m: 0,
		        n: 0,
		        t: 0,
		        u: 0.004484,
		        v: 0.008968,
		        w: 0.013452,
		        x: 0.085196,
		        y: 0.013452,
		        z: 0.013452,
		        D: 3.48407
		      },
		      B: "webkit",
		      C: ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "C", "K", "L", "H", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z", "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "t", "u", "v", "w", "x", "y", "z", "0", "1", "2", "3", "4", "5", "6", "D", "", "", ""],
		      E: "Edge",
		      F: {
		        "0": 1680825600,
		        "1": 1683158400,
		        "2": 1685664000,
		        "3": 1689897600,
		        "4": 1692576000,
		        "5": 1694649600,
		        "6": 1697155200,
		        C: 1438128000,
		        K: 1447286400,
		        L: 1470096000,
		        H: 1491868800,
		        M: 1508198400,
		        N: 1525046400,
		        O: 1542067200,
		        P: 1579046400,
		        Q: 1581033600,
		        R: 1586736000,
		        S: 1590019200,
		        T: 1594857600,
		        U: 1598486400,
		        V: 1602201600,
		        W: 1605830400,
		        X: 1611360000,
		        Y: 1614816000,
		        Z: 1618358400,
		        a: 1622073600,
		        b: 1626912000,
		        c: 1630627200,
		        d: 1632441600,
		        e: 1634774400,
		        f: 1637539200,
		        g: 1641427200,
		        h: 1643932800,
		        i: 1646265600,
		        j: 1649635200,
		        k: 1651190400,
		        l: 1653955200,
		        m: 1655942400,
		        n: 1659657600,
		        t: 1661990400,
		        u: 1664755200,
		        v: 1666915200,
		        w: 1670198400,
		        x: 1673481600,
		        y: 1675900800,
		        z: 1678665600,
		        D: 1698969600
		      },
		      D: {
		        C: "ms",
		        K: "ms",
		        L: "ms",
		        H: "ms",
		        M: "ms",
		        N: "ms",
		        O: "ms"
		      }
		    },
		    C: {
		      A: {
		        "0": 0.008968,
		        "1": 0.017936,
		        "2": 0.017936,
		        "3": 0.372172,
		        "4": 0.017936,
		        "5": 0.017936,
		        "6": 0.13452,
		        "7": 0,
		        "8": 0,
		        "9": 0,
		        QC: 0,
		        "4B": 0,
		        I: 0,
		        J: 0,
		        E: 0.004484,
		        F: 0,
		        G: 0,
		        A: 0,
		        B: 0.026904,
		        C: 0.013452,
		        K: 0,
		        L: 0,
		        H: 0,
		        M: 0,
		        N: 0,
		        O: 0,
		        o: 0,
		        p: 0,
		        q: 0,
		        r: 0,
		        AB: 0,
		        BB: 0,
		        CB: 0,
		        DB: 0,
		        EB: 0,
		        FB: 0,
		        GB: 0,
		        HB: 0,
		        IB: 0,
		        JB: 0,
		        KB: 0,
		        LB: 0,
		        MB: 0,
		        NB: 0,
		        OB: 0,
		        PB: 0,
		        QB: 0,
		        RB: 0,
		        SB: 0.004484,
		        TB: 0.004484,
		        UB: 0,
		        VB: 0,
		        WB: 0,
		        XB: 0.031388,
		        YB: 0,
		        ZB: 0.013452,
		        aB: 0,
		        bB: 0.062776,
		        cB: 0.008968,
		        dB: 0.017936,
		        eB: 0.004484,
		        fB: 0.02242,
		        gB: 0,
		        hB: 0,
		        "5B": 0.008968,
		        iB: 0,
		        "6B": 0,
		        jB: 0,
		        kB: 0.004484,
		        lB: 0,
		        mB: 0,
		        nB: 0,
		        oB: 0,
		        pB: 0.004484,
		        qB: 0,
		        rB: 0,
		        sB: 0,
		        tB: 0.008968,
		        s: 0,
		        uB: 0,
		        vB: 0,
		        wB: 0,
		        xB: 0.004484,
		        yB: 0.026904,
		        P: 0,
		        Q: 0,
		        R: 0,
		        "7B": 0,
		        S: 0.004484,
		        T: 0,
		        U: 0,
		        V: 0,
		        W: 0,
		        X: 0.008968,
		        Y: 0,
		        Z: 0,
		        a: 0.013452,
		        b: 0,
		        c: 0,
		        d: 0.004484,
		        e: 0,
		        f: 0,
		        g: 0,
		        h: 0,
		        i: 0,
		        j: 0,
		        k: 0.004484,
		        l: 0.031388,
		        m: 0.031388,
		        n: 0,
		        t: 0.004484,
		        u: 0.004484,
		        v: 0.004484,
		        w: 0.008968,
		        x: 0.008968,
		        y: 0.008968,
		        z: 0.008968,
		        D: 1.43488,
		        "8B": 0.372172,
		        "9B": 0,
		        AC: 0,
		        RC: 0,
		        SC: 0,
		        TC: 0
		      },
		      B: "moz",
		      C: ["QC", "4B", "SC", "TC", "I", "7", "J", "E", "F", "G", "A", "B", "C", "K", "L", "H", "M", "N", "O", "8", "o", "p", "q", "r", "9", "AB", "BB", "CB", "DB", "EB", "FB", "GB", "HB", "IB", "JB", "KB", "LB", "MB", "NB", "OB", "PB", "QB", "RB", "SB", "TB", "UB", "VB", "WB", "XB", "YB", "ZB", "aB", "bB", "cB", "dB", "eB", "fB", "gB", "hB", "5B", "iB", "6B", "jB", "kB", "lB", "mB", "nB", "oB", "pB", "qB", "rB", "sB", "tB", "s", "uB", "vB", "wB", "xB", "yB", "P", "Q", "R", "7B", "S", "T", "U", "V", "W", "X", "Y", "Z", "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "t", "u", "v", "w", "x", "y", "z", "0", "1", "2", "3", "4", "5", "6", "D", "8B", "9B", "AC", "RC"],
		      E: "Firefox",
		      F: {
		        "0": 1681171200,
		        "1": 1683590400,
		        "2": 1686009600,
		        "3": 1688428800,
		        "4": 1690848000,
		        "5": 1693267200,
		        "6": 1695686400,
		        "7": 1308614400,
		        "8": 1357603200,
		        "9": 1375747200,
		        QC: 1161648000,
		        "4B": 1213660800,
		        SC: 1246320000,
		        TC: 1264032000,
		        I: 1300752000,
		        J: 1313452800,
		        E: 1317081600,
		        F: 1317081600,
		        G: 1320710400,
		        A: 1324339200,
		        B: 1327968000,
		        C: 1331596800,
		        K: 1335225600,
		        L: 1338854400,
		        H: 1342483200,
		        M: 1346112000,
		        N: 1349740800,
		        O: 1353628800,
		        o: 1361232000,
		        p: 1364860800,
		        q: 1368489600,
		        r: 1372118400,
		        AB: 1379376000,
		        BB: 1386633600,
		        CB: 1391472000,
		        DB: 1395100800,
		        EB: 1398729600,
		        FB: 1402358400,
		        GB: 1405987200,
		        HB: 1409616000,
		        IB: 1413244800,
		        JB: 1417392000,
		        KB: 1421107200,
		        LB: 1424736000,
		        MB: 1428278400,
		        NB: 1431475200,
		        OB: 1435881600,
		        PB: 1439251200,
		        QB: 1442880000,
		        RB: 1446508800,
		        SB: 1450137600,
		        TB: 1453852800,
		        UB: 1457395200,
		        VB: 1461628800,
		        WB: 1465257600,
		        XB: 1470096000,
		        YB: 1474329600,
		        ZB: 1479168000,
		        aB: 1485216000,
		        bB: 1488844800,
		        cB: 1492560000,
		        dB: 1497312000,
		        eB: 1502150400,
		        fB: 1506556800,
		        gB: 1510617600,
		        hB: 1516665600,
		        "5B": 1520985600,
		        iB: 1525824000,
		        "6B": 1529971200,
		        jB: 1536105600,
		        kB: 1540252800,
		        lB: 1544486400,
		        mB: 1548720000,
		        nB: 1552953600,
		        oB: 1558396800,
		        pB: 1562630400,
		        qB: 1567468800,
		        rB: 1571788800,
		        sB: 1575331200,
		        tB: 1578355200,
		        s: 1581379200,
		        uB: 1583798400,
		        vB: 1586304000,
		        wB: 1588636800,
		        xB: 1591056000,
		        yB: 1593475200,
		        P: 1595894400,
		        Q: 1598313600,
		        R: 1600732800,
		        "7B": 1603152000,
		        S: 1605571200,
		        T: 1607990400,
		        U: 1611619200,
		        V: 1614038400,
		        W: 1616457600,
		        X: 1618790400,
		        Y: 1622505600,
		        Z: 1626134400,
		        a: 1628553600,
		        b: 1630972800,
		        c: 1633392000,
		        d: 1635811200,
		        e: 1638835200,
		        f: 1641859200,
		        g: 1644364800,
		        h: 1646697600,
		        i: 1649116800,
		        j: 1651536000,
		        k: 1653955200,
		        l: 1656374400,
		        m: 1658793600,
		        n: 1661212800,
		        t: 1663632000,
		        u: 1666051200,
		        v: 1668470400,
		        w: 1670889600,
		        x: 1673913600,
		        y: 1676332800,
		        z: 1678752000,
		        D: 1698105600,
		        "8B": 1700524800,
		        "9B": null,
		        AC: null,
		        RC: null
		      }
		    },
		    D: {
		      A: {
		        "0": 0.116584,
		        "1": 0.20178,
		        "2": 0.219716,
		        "3": 0.147972,
		        "4": 0.497724,
		        "5": 0.69502,
		        "6": 5.40322,
		        "7": 0,
		        "8": 0,
		        "9": 0,
		        I: 0,
		        J: 0,
		        E: 0,
		        F: 0,
		        G: 0,
		        A: 0,
		        B: 0,
		        C: 0,
		        K: 0,
		        L: 0,
		        H: 0,
		        M: 0,
		        N: 0,
		        O: 0,
		        o: 0,
		        p: 0,
		        q: 0,
		        r: 0,
		        AB: 0,
		        BB: 0,
		        CB: 0,
		        DB: 0,
		        EB: 0,
		        FB: 0,
		        GB: 0,
		        HB: 0,
		        IB: 0,
		        JB: 0.004484,
		        KB: 0,
		        LB: 0,
		        MB: 0,
		        NB: 0.013452,
		        OB: 0,
		        PB: 0,
		        QB: 0.004484,
		        RB: 0,
		        SB: 0,
		        TB: 0,
		        UB: 0.008968,
		        VB: 0,
		        WB: 0.008968,
		        XB: 0.026904,
		        YB: 0.031388,
		        ZB: 0.008968,
		        aB: 0.004484,
		        bB: 0.004484,
		        cB: 0.008968,
		        dB: 0,
		        eB: 0.008968,
		        fB: 0.026904,
		        gB: 0.013452,
		        hB: 0.004484,
		        "5B": 0,
		        iB: 0.035872,
		        "6B": 0.013452,
		        jB: 0,
		        kB: 0.008968,
		        lB: 0.004484,
		        mB: 0.008968,
		        nB: 0.02242,
		        oB: 0.004484,
		        pB: 0.013452,
		        qB: 0.049324,
		        rB: 0.192812,
		        sB: 0.013452,
		        tB: 0.017936,
		        s: 0.026904,
		        uB: 0.026904,
		        vB: 0.02242,
		        wB: 0.058292,
		        xB: 0.02242,
		        yB: 0.026904,
		        P: 0.161424,
		        Q: 0.049324,
		        R: 0.04484,
		        S: 0.053808,
		        T: 0.026904,
		        U: 0.076228,
		        V: 0.062776,
		        W: 0.08968,
		        X: 0.026904,
		        Y: 0.026904,
		        Z: 0.035872,
		        a: 0.080712,
		        b: 0.040356,
		        c: 0.116584,
		        d: 0.040356,
		        e: 0.017936,
		        f: 0.017936,
		        g: 0.02242,
		        h: 0.06726,
		        i: 0.035872,
		        j: 0.035872,
		        k: 0.049324,
		        l: 0.035872,
		        m: 0.38114,
		        n: 0.049324,
		        t: 0.049324,
		        u: 0.062776,
		        v: 0.058292,
		        w: 0.1121,
		        x: 1.78912,
		        y: 0.080712,
		        z: 0.094164,
		        D: 14.703,
		        "8B": 0.02242,
		        "9B": 0.013452,
		        AC: 0
		      },
		      B: "webkit",
		      C: ["", "", "", "", "", "", "I", "7", "J", "E", "F", "G", "A", "B", "C", "K", "L", "H", "M", "N", "O", "8", "o", "p", "q", "r", "9", "AB", "BB", "CB", "DB", "EB", "FB", "GB", "HB", "IB", "JB", "KB", "LB", "MB", "NB", "OB", "PB", "QB", "RB", "SB", "TB", "UB", "VB", "WB", "XB", "YB", "ZB", "aB", "bB", "cB", "dB", "eB", "fB", "gB", "hB", "5B", "iB", "6B", "jB", "kB", "lB", "mB", "nB", "oB", "pB", "qB", "rB", "sB", "tB", "s", "uB", "vB", "wB", "xB", "yB", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z", "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "t", "u", "v", "w", "x", "y", "z", "0", "1", "2", "3", "4", "5", "6", "D", "8B", "9B", "AC"],
		      E: "Chrome",
		      F: {
		        "0": 1680566400,
		        "1": 1682985600,
		        "2": 1685404800,
		        "3": 1689724800,
		        "4": 1692057600,
		        "5": 1694476800,
		        "6": 1696896000,
		        "7": 1274745600,
		        "8": 1332892800,
		        "9": 1352246400,
		        I: 1264377600,
		        J: 1283385600,
		        E: 1287619200,
		        F: 1291248000,
		        G: 1296777600,
		        A: 1299542400,
		        B: 1303862400,
		        C: 1307404800,
		        K: 1312243200,
		        L: 1316131200,
		        H: 1316131200,
		        M: 1319500800,
		        N: 1323734400,
		        O: 1328659200,
		        o: 1337040000,
		        p: 1340668800,
		        q: 1343692800,
		        r: 1348531200,
		        AB: 1357862400,
		        BB: 1361404800,
		        CB: 1364428800,
		        DB: 1369094400,
		        EB: 1374105600,
		        FB: 1376956800,
		        GB: 1384214400,
		        HB: 1389657600,
		        IB: 1392940800,
		        JB: 1397001600,
		        KB: 1400544000,
		        LB: 1405468800,
		        MB: 1409011200,
		        NB: 1412640000,
		        OB: 1416268800,
		        PB: 1421798400,
		        QB: 1425513600,
		        RB: 1429401600,
		        SB: 1432080000,
		        TB: 1437523200,
		        UB: 1441152000,
		        VB: 1444780800,
		        WB: 1449014400,
		        XB: 1453248000,
		        YB: 1456963200,
		        ZB: 1460592000,
		        aB: 1464134400,
		        bB: 1469059200,
		        cB: 1472601600,
		        dB: 1476230400,
		        eB: 1480550400,
		        fB: 1485302400,
		        gB: 1489017600,
		        hB: 1492560000,
		        "5B": 1496707200,
		        iB: 1500940800,
		        "6B": 1504569600,
		        jB: 1508198400,
		        kB: 1512518400,
		        lB: 1516752000,
		        mB: 1520294400,
		        nB: 1523923200,
		        oB: 1527552000,
		        pB: 1532390400,
		        qB: 1536019200,
		        rB: 1539648000,
		        sB: 1543968000,
		        tB: 1548720000,
		        s: 1552348800,
		        uB: 1555977600,
		        vB: 1559606400,
		        wB: 1564444800,
		        xB: 1568073600,
		        yB: 1571702400,
		        P: 1575936000,
		        Q: 1580860800,
		        R: 1586304000,
		        S: 1589846400,
		        T: 1594684800,
		        U: 1598313600,
		        V: 1601942400,
		        W: 1605571200,
		        X: 1611014400,
		        Y: 1614556800,
		        Z: 1618272000,
		        a: 1621987200,
		        b: 1626739200,
		        c: 1630368000,
		        d: 1632268800,
		        e: 1634601600,
		        f: 1637020800,
		        g: 1641340800,
		        h: 1643673600,
		        i: 1646092800,
		        j: 1648512000,
		        k: 1650931200,
		        l: 1653350400,
		        m: 1655769600,
		        n: 1659398400,
		        t: 1661817600,
		        u: 1664236800,
		        v: 1666656000,
		        w: 1669680000,
		        x: 1673308800,
		        y: 1675728000,
		        z: 1678147200,
		        D: 1698710400,
		        "8B": null,
		        "9B": null,
		        AC: null
		      }
		    },
		    E: {
		      A: {
		        "7": 0,
		        I: 0,
		        J: 0,
		        E: 0,
		        F: 0,
		        G: 0,
		        A: 0,
		        B: 0,
		        C: 0,
		        K: 0.013452,
		        L: 0.085196,
		        H: 0.017936,
		        UC: 0,
		        BC: 0,
		        VC: 0.008968,
		        WC: 0,
		        XC: 0,
		        YC: 0.06726,
		        CC: 0,
		        zB: 0.008968,
		        "0B": 0.02242,
		        DC: 0.1121,
		        ZC: 0.206264,
		        aC: 0.040356,
		        EC: 0.031388,
		        FC: 0.06726,
		        "1B": 0.103132,
		        bC: 0.520144,
		        "2B": 0.06726,
		        GC: 0.17936,
		        HC: 0.165908,
		        IC: 0.367688,
		        JC: 0.143488,
		        KC: 0.295944,
		        cC: 2.08058,
		        "3B": 0.443916,
		        LC: 0.686052,
		        MC: 0.017936,
		        dC: 0
		      },
		      B: "webkit",
		      C: ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "UC", "BC", "I", "7", "VC", "J", "WC", "E", "XC", "F", "G", "YC", "A", "CC", "B", "zB", "C", "0B", "K", "DC", "L", "ZC", "H", "aC", "EC", "FC", "1B", "bC", "2B", "GC", "HC", "IC", "JC", "KC", "cC", "3B", "LC", "MC", "dC", ""],
		      E: "Safari",
		      F: {
		        "7": 1275868800,
		        UC: 1205798400,
		        BC: 1226534400,
		        I: 1244419200,
		        VC: 1311120000,
		        J: 1343174400,
		        WC: 1382400000,
		        E: 1382400000,
		        XC: 1410998400,
		        F: 1413417600,
		        G: 1443657600,
		        YC: 1458518400,
		        A: 1474329600,
		        CC: 1490572800,
		        B: 1505779200,
		        zB: 1522281600,
		        C: 1537142400,
		        "0B": 1553472000,
		        K: 1568851200,
		        DC: 1585008000,
		        L: 1600214400,
		        ZC: 1619395200,
		        H: 1632096000,
		        aC: 1635292800,
		        EC: 1639353600,
		        FC: 1647216000,
		        "1B": 1652745600,
		        bC: 1658275200,
		        "2B": 1662940800,
		        GC: 1666569600,
		        HC: 1670889600,
		        IC: 1674432000,
		        JC: 1679875200,
		        KC: 1684368000,
		        cC: 1690156800,
		        "3B": 1695686400,
		        LC: 1698192000,
		        MC: null,
		        dC: null
		      }
		    },
		    F: {
		      A: {
		        "8": 0,
		        "9": 0,
		        G: 0,
		        B: 0,
		        C: 0,
		        H: 0,
		        M: 0,
		        N: 0,
		        O: 0,
		        o: 0,
		        p: 0,
		        q: 0,
		        r: 0,
		        AB: 0,
		        BB: 0,
		        CB: 0,
		        DB: 0,
		        EB: 0,
		        FB: 0,
		        GB: 0,
		        HB: 0,
		        IB: 0,
		        JB: 0,
		        KB: 0,
		        LB: 0,
		        MB: 0,
		        NB: 0,
		        OB: 0,
		        PB: 0,
		        QB: 0,
		        RB: 0,
		        SB: 0,
		        TB: 0,
		        UB: 0,
		        VB: 0.013452,
		        WB: 0,
		        XB: 0,
		        YB: 0,
		        ZB: 0,
		        aB: 0,
		        bB: 0,
		        cB: 0,
		        dB: 0,
		        eB: 0,
		        fB: 0,
		        gB: 0,
		        hB: 0,
		        iB: 0,
		        jB: 0,
		        kB: 0,
		        lB: 0,
		        mB: 0,
		        nB: 0,
		        oB: 0,
		        pB: 0,
		        qB: 0,
		        rB: 0,
		        sB: 0,
		        tB: 0,
		        s: 0,
		        uB: 0,
		        vB: 0,
		        wB: 0,
		        xB: 0,
		        yB: 0,
		        P: 0,
		        Q: 0,
		        R: 0,
		        "7B": 0,
		        S: 0,
		        T: 0,
		        U: 0,
		        V: 0,
		        W: 0,
		        X: 0,
		        Y: 0,
		        Z: 0,
		        a: 0,
		        b: 0,
		        c: 0,
		        d: 0,
		        e: 0.053808,
		        f: 0,
		        g: 0,
		        h: 0,
		        i: 0.004484,
		        j: 0.004484,
		        k: 0.004484,
		        l: 0.914736,
		        m: 0.161424,
		        n: 0.663632,
		        eC: 0,
		        fC: 0,
		        gC: 0,
		        hC: 0,
		        zB: 0,
		        NC: 0,
		        iC: 0,
		        "0B": 0
		      },
		      B: "webkit",
		      C: ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "G", "eC", "fC", "gC", "hC", "B", "zB", "NC", "iC", "C", "0B", "H", "M", "N", "O", "8", "o", "p", "q", "r", "9", "AB", "BB", "CB", "DB", "EB", "FB", "GB", "HB", "IB", "JB", "KB", "LB", "MB", "NB", "OB", "PB", "QB", "RB", "SB", "TB", "UB", "VB", "WB", "XB", "YB", "ZB", "aB", "bB", "cB", "dB", "eB", "fB", "gB", "hB", "iB", "jB", "kB", "lB", "mB", "nB", "oB", "pB", "qB", "rB", "sB", "tB", "s", "uB", "vB", "wB", "xB", "yB", "P", "Q", "R", "7B", "S", "T", "U", "V", "W", "X", "Y", "Z", "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "", "", ""],
		      E: "Opera",
		      F: {
		        "8": 1390867200,
		        "9": 1409616000,
		        G: 1150761600,
		        eC: 1223424000,
		        fC: 1251763200,
		        gC: 1267488000,
		        hC: 1277942400,
		        B: 1292457600,
		        zB: 1302566400,
		        NC: 1309219200,
		        iC: 1323129600,
		        C: 1323129600,
		        "0B": 1352073600,
		        H: 1372723200,
		        M: 1377561600,
		        N: 1381104000,
		        O: 1386288000,
		        o: 1393891200,
		        p: 1399334400,
		        q: 1401753600,
		        r: 1405987200,
		        AB: 1413331200,
		        BB: 1417132800,
		        CB: 1422316800,
		        DB: 1425945600,
		        EB: 1430179200,
		        FB: 1433808000,
		        GB: 1438646400,
		        HB: 1442448000,
		        IB: 1445904000,
		        JB: 1449100800,
		        KB: 1454371200,
		        LB: 1457308800,
		        MB: 1462320000,
		        NB: 1465344000,
		        OB: 1470096000,
		        PB: 1474329600,
		        QB: 1477267200,
		        RB: 1481587200,
		        SB: 1486425600,
		        TB: 1490054400,
		        UB: 1494374400,
		        VB: 1498003200,
		        WB: 1502236800,
		        XB: 1506470400,
		        YB: 1510099200,
		        ZB: 1515024000,
		        aB: 1517961600,
		        bB: 1521676800,
		        cB: 1525910400,
		        dB: 1530144000,
		        eB: 1534982400,
		        fB: 1537833600,
		        gB: 1543363200,
		        hB: 1548201600,
		        iB: 1554768000,
		        jB: 1561593600,
		        kB: 1566259200,
		        lB: 1570406400,
		        mB: 1573689600,
		        nB: 1578441600,
		        oB: 1583971200,
		        pB: 1587513600,
		        qB: 1592956800,
		        rB: 1595894400,
		        sB: 1600128000,
		        tB: 1603238400,
		        s: 1613520000,
		        uB: 1612224000,
		        vB: 1616544000,
		        wB: 1619568000,
		        xB: 1623715200,
		        yB: 1627948800,
		        P: 1631577600,
		        Q: 1633392000,
		        R: 1635984000,
		        "7B": 1638403200,
		        S: 1642550400,
		        T: 1644969600,
		        U: 1647993600,
		        V: 1650412800,
		        W: 1652745600,
		        X: 1654646400,
		        Y: 1657152000,
		        Z: 1660780800,
		        a: 1663113600,
		        b: 1668816000,
		        c: 1668643200,
		        d: 1671062400,
		        e: 1675209600,
		        f: 1677024000,
		        g: 1679529600,
		        h: 1681948800,
		        i: 1684195200,
		        j: 1687219200,
		        k: 1690329600,
		        l: 1692748800,
		        m: 1696204800,
		        n: 1699920000
		      },
		      D: {
		        G: "o",
		        B: "o",
		        C: "o",
		        eC: "o",
		        fC: "o",
		        gC: "o",
		        hC: "o",
		        zB: "o",
		        NC: "o",
		        iC: "o",
		        "0B": "o"
		      }
		    },
		    G: {
		      A: {
		        F: 0,
		        BC: 0,
		        jC: 0,
		        OC: 0.00276131,
		        kC: 0.00276131,
		        lC: 0.00690327,
		        mC: 0.00966458,
		        nC: 0.00138065,
		        oC: 0.0110452,
		        pC: 0.0345164,
		        qC: 0.00276131,
		        rC: 0.0497036,
		        sC: 0.0248518,
		        tC: 0.0207098,
		        uC: 0.0124259,
		        vC: 0.226427,
		        wC: 0.00552262,
		        xC: 0.0248518,
		        yC: 0.0138065,
		        zC: 0.040039,
		        "0C": 0.107691,
		        "1C": 0.171201,
		        "2C": 0.0690327,
		        EC: 0.0828393,
		        FC: 0.0925039,
		        "1B": 0.129782,
		        "3C": 0.682043,
		        "2B": 0.320312,
		        GC: 0.642004,
		        HC: 0.306505,
		        IC: 0.575733,
		        JC: 0.121498,
		        KC: 0.306505,
		        "4C": 5.19264,
		        "3B": 1.556,
		        LC: 2.6122,
		        MC: 0.0731747
		      },
		      B: "webkit",
		      C: ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "BC", "jC", "OC", "kC", "lC", "mC", "F", "nC", "oC", "pC", "qC", "rC", "sC", "tC", "uC", "vC", "wC", "xC", "yC", "zC", "0C", "1C", "2C", "EC", "FC", "1B", "3C", "2B", "GC", "HC", "IC", "JC", "KC", "4C", "3B", "LC", "MC", "", ""],
		      E: "Safari on iOS",
		      F: {
		        BC: 1270252800,
		        jC: 1283904000,
		        OC: 1299628800,
		        kC: 1331078400,
		        lC: 1359331200,
		        mC: 1394409600,
		        F: 1410912000,
		        nC: 1413763200,
		        oC: 1442361600,
		        pC: 1458518400,
		        qC: 1473724800,
		        rC: 1490572800,
		        sC: 1505779200,
		        tC: 1522281600,
		        uC: 1537142400,
		        vC: 1553472000,
		        wC: 1568851200,
		        xC: 1572220800,
		        yC: 1580169600,
		        zC: 1585008000,
		        "0C": 1600214400,
		        "1C": 1619395200,
		        "2C": 1632096000,
		        EC: 1639353600,
		        FC: 1647216000,
		        "1B": 1652659200,
		        "3C": 1658275200,
		        "2B": 1662940800,
		        GC: 1666569600,
		        HC: 1670889600,
		        IC: 1674432000,
		        JC: 1679875200,
		        KC: 1684368000,
		        "4C": 1690156800,
		        "3B": 1694995200,
		        LC: 1698192000,
		        MC: null
		      }
		    },
		    H: {
		      A: {
		        "5C": 0.06
		      },
		      B: "o",
		      C: ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "5C", "", "", ""],
		      E: "Opera Mini",
		      F: {
		        "5C": 1426464000
		      }
		    },
		    I: {
		      A: {
		        "4B": 0.0000512988,
		        I: 0.000102598,
		        D: 0.510372,
		        "6C": 0,
		        "7C": 0.000102598,
		        "8C": 0,
		        "9C": 0.0000512988,
		        OC: 0.000359092,
		        AD: 0,
		        BD: 0.00148767
		      },
		      B: "webkit",
		      C: ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "6C", "7C", "8C", "4B", "I", "9C", "OC", "AD", "BD", "D", "", "", ""],
		      E: "Android Browser",
		      F: {
		        "6C": 1256515200,
		        "7C": 1274313600,
		        "8C": 1291593600,
		        "4B": 1298332800,
		        I: 1318896000,
		        "9C": 1341792000,
		        OC: 1374624000,
		        AD: 1386547200,
		        BD: 1401667200,
		        D: 1698710400
		      }
		    },
		    J: {
		      A: {
		        E: 0,
		        A: 0
		      },
		      B: "webkit",
		      C: ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "E", "A", "", "", ""],
		      E: "Blackberry Browser",
		      F: {
		        E: 1325376000,
		        A: 1359504000
		      }
		    },
		    K: {
		      A: {
		        A: 0,
		        B: 0,
		        C: 0,
		        s: 1.08181,
		        zB: 0,
		        NC: 0,
		        "0B": 0
		      },
		      B: "o",
		      C: ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "A", "B", "zB", "NC", "C", "0B", "s", "", "", ""],
		      E: "Opera Mobile",
		      F: {
		        A: 1287100800,
		        B: 1300752000,
		        zB: 1314835200,
		        NC: 1318291200,
		        C: 1330300800,
		        "0B": 1349740800,
		        s: 1673827200
		      },
		      D: {
		        s: "webkit"
		      }
		    },
		    L: {
		      A: {
		        D: 36.3992
		      },
		      B: "webkit",
		      C: ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "D", "", "", ""],
		      E: "Chrome for Android",
		      F: {
		        D: 1698710400
		      }
		    },
		    M: {
		      A: {
		        D: 0.286832
		      },
		      B: "moz",
		      C: ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "D", "", "", ""],
		      E: "Firefox for Android",
		      F: {
		        D: 1698105600
		      }
		    },
		    N: {
		      A: {
		        A: 0,
		        B: 0
		      },
		      B: "ms",
		      C: ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "A", "B", "", "", ""],
		      E: "IE Mobile",
		      F: {
		        A: 1340150400,
		        B: 1353456000
		      }
		    },
		    O: {
		      A: {
		        "1B": 0.794304
		      },
		      B: "webkit",
		      C: ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "1B", "", "", ""],
		      E: "UC Browser for Android",
		      F: {
		        "1B": 1687132800
		      },
		      D: {
		        "1B": "webkit"
		      }
		    },
		    P: {
		      A: {
		        I: 0.109121,
		        o: 0.0436483,
		        p: 0.0982088,
		        q: 0.250978,
		        r: 1.83323,
		        CD: 0,
		        DD: 0,
		        ED: 0.0327363,
		        FD: 0,
		        GD: 0,
		        CC: 0,
		        HD: 0.0109121,
		        ID: 0,
		        JD: 0.0109121,
		        KD: 0,
		        LD: 0,
		        "2B": 0.0218242,
		        "3B": 0.0327363,
		        MD: 0.0218242,
		        ND: 0.0436483
		      },
		      B: "webkit",
		      C: ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "I", "CD", "DD", "ED", "FD", "GD", "CC", "HD", "ID", "JD", "KD", "LD", "2B", "3B", "MD", "ND", "o", "p", "q", "r", "", "", ""],
		      E: "Samsung Internet",
		      F: {
		        I: 1461024000,
		        CD: 1481846400,
		        DD: 1509408000,
		        ED: 1528329600,
		        FD: 1546128000,
		        GD: 1554163200,
		        CC: 1567900800,
		        HD: 1582588800,
		        ID: 1593475200,
		        JD: 1605657600,
		        KD: 1618531200,
		        LD: 1629072000,
		        "2B": 1640736000,
		        "3B": 1651708800,
		        MD: 1659657600,
		        ND: 1667260800,
		        o: 1677369600,
		        p: 1684454400,
		        q: 1689292800,
		        r: 1697587200
		      }
		    },
		    Q: {
		      A: {
		        DC: 0.143416
		      },
		      B: "webkit",
		      C: ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "DC", "", "", ""],
		      E: "QQ Browser",
		      F: {
		        DC: 1663718400
		      }
		    },
		    R: {
		      A: {
		        OD: 0
		      },
		      B: "webkit",
		      C: ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "OD", "", "", ""],
		      E: "Baidu Browser",
		      F: {
		        OD: 1663027200
		      }
		    },
		    S: {
		      A: {
		        PD: 0.066192,
		        QD: 0
		      },
		      B: "moz",
		      C: ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "PD", "QD", "", "", ""],
		      E: "KaiOS Browser",
		      F: {
		        PD: 1527811200,
		        QD: 1631664000
		      }
		    }
		  };

		  var browsers = browsers$2.browsers;
		  var versions$1 = browserVersions$1.browserVersions;
		  var agentsData = agents$1;
		  function unpackBrowserVersions(versionsData) {
		    return Object.keys(versionsData).reduce(function (usage, version) {
		      usage[versions$1[version]] = versionsData[version];
		      return usage;
		    }, {});
		  }
		  agents$2.agents = Object.keys(agentsData).reduce(function (map, key) {
		    var versionsData = agentsData[key];
		    map[browsers[key]] = Object.keys(versionsData).reduce(function (data, entry) {
		      if (entry === 'A') {
		        data.usage_global = unpackBrowserVersions(versionsData[entry]);
		      } else if (entry === 'C') {
		        data.versions = versionsData[entry].reduce(function (list, version) {
		          if (version === '') {
		            list.push(null);
		          } else {
		            list.push(versions$1[version]);
		          }
		          return list;
		        }, []);
		      } else if (entry === 'D') {
		        data.prefix_exceptions = unpackBrowserVersions(versionsData[entry]);
		      } else if (entry === 'E') {
		        data.browser = versionsData[entry];
		      } else if (entry === 'F') {
		        data.release_date = Object.keys(versionsData[entry]).reduce(function (map2, key2) {
		          map2[versions$1[key2]] = versionsData[entry][key2];
		          return map2;
		        }, {});
		      } else {
		        data.prefix = versionsData[entry];
		      }
		      return data;
		    }, {});
		    return map;
		  }, {});

		  var v4 = {
		  	start: "2015-09-08",
		  	lts: "2015-10-12",
		  	maintenance: "2017-04-01",
		  	end: "2018-04-30",
		  	codename: "Argon"
		  };
		  var v5 = {
		  	start: "2015-10-29",
		  	maintenance: "2016-04-30",
		  	end: "2016-06-30"
		  };
		  var v6 = {
		  	start: "2016-04-26",
		  	lts: "2016-10-18",
		  	maintenance: "2018-04-30",
		  	end: "2019-04-30",
		  	codename: "Boron"
		  };
		  var v7 = {
		  	start: "2016-10-25",
		  	maintenance: "2017-04-30",
		  	end: "2017-06-30"
		  };
		  var v8 = {
		  	start: "2017-05-30",
		  	lts: "2017-10-31",
		  	maintenance: "2019-01-01",
		  	end: "2019-12-31",
		  	codename: "Carbon"
		  };
		  var v9 = {
		  	start: "2017-10-01",
		  	maintenance: "2018-04-01",
		  	end: "2018-06-30"
		  };
		  var v10 = {
		  	start: "2018-04-24",
		  	lts: "2018-10-30",
		  	maintenance: "2020-05-19",
		  	end: "2021-04-30",
		  	codename: "Dubnium"
		  };
		  var v11 = {
		  	start: "2018-10-23",
		  	maintenance: "2019-04-22",
		  	end: "2019-06-01"
		  };
		  var v12 = {
		  	start: "2019-04-23",
		  	lts: "2019-10-21",
		  	maintenance: "2020-11-30",
		  	end: "2022-04-30",
		  	codename: "Erbium"
		  };
		  var v13 = {
		  	start: "2019-10-22",
		  	maintenance: "2020-04-01",
		  	end: "2020-06-01"
		  };
		  var v14 = {
		  	start: "2020-04-21",
		  	lts: "2020-10-27",
		  	maintenance: "2021-10-19",
		  	end: "2023-04-30",
		  	codename: "Fermium"
		  };
		  var v15 = {
		  	start: "2020-10-20",
		  	maintenance: "2021-04-01",
		  	end: "2021-06-01"
		  };
		  var v16 = {
		  	start: "2021-04-20",
		  	lts: "2021-10-26",
		  	maintenance: "2022-10-18",
		  	end: "2023-09-11",
		  	codename: "Gallium"
		  };
		  var v17 = {
		  	start: "2021-10-19",
		  	maintenance: "2022-04-01",
		  	end: "2022-06-01"
		  };
		  var v18 = {
		  	start: "2022-04-19",
		  	lts: "2022-10-25",
		  	maintenance: "2023-10-18",
		  	end: "2025-04-30",
		  	codename: "Hydrogen"
		  };
		  var v19 = {
		  	start: "2022-10-18",
		  	maintenance: "2023-04-01",
		  	end: "2023-06-01"
		  };
		  var v20 = {
		  	start: "2023-04-18",
		  	lts: "2023-10-24",
		  	maintenance: "2024-10-22",
		  	end: "2026-04-30",
		  	codename: "Iron"
		  };
		  var v21 = {
		  	start: "2023-10-17",
		  	maintenance: "2024-04-01",
		  	end: "2024-06-01"
		  };
		  var v22 = {
		  	start: "2024-04-23",
		  	lts: "2024-10-29",
		  	maintenance: "2025-10-21",
		  	end: "2027-04-30",
		  	codename: ""
		  };
		  var v23 = {
		  	start: "2024-10-15",
		  	maintenance: "2025-04-01",
		  	end: "2025-06-01"
		  };
		  var v24 = {
		  	start: "2025-04-22",
		  	lts: "2025-10-28",
		  	maintenance: "2026-10-20",
		  	end: "2028-04-30",
		  	codename: ""
		  };
		  var require$$2$1 = {
		  	"v0.8": {
		  	start: "2012-06-25",
		  	end: "2014-07-31"
		  },
		  	"v0.10": {
		  	start: "2013-03-11",
		  	end: "2016-10-31"
		  },
		  	"v0.12": {
		  	start: "2015-02-06",
		  	end: "2016-12-31"
		  },
		  	v4: v4,
		  	v5: v5,
		  	v6: v6,
		  	v7: v7,
		  	v8: v8,
		  	v9: v9,
		  	v10: v10,
		  	v11: v11,
		  	v12: v12,
		  	v13: v13,
		  	v14: v14,
		  	v15: v15,
		  	v16: v16,
		  	v17: v17,
		  	v18: v18,
		  	v19: v19,
		  	v20: v20,
		  	v21: v21,
		  	v22: v22,
		  	v23: v23,
		  	v24: v24
		  };

		  var require$$3$1 = /*@__PURE__*/getAugmentedNamespace(_polyfillNode_path);

		  var versions = {
		    "0.20": "39",
		    "0.21": "41",
		    "0.22": "41",
		    "0.23": "41",
		    "0.24": "41",
		    "0.25": "42",
		    "0.26": "42",
		    "0.27": "43",
		    "0.28": "43",
		    "0.29": "43",
		    "0.30": "44",
		    "0.31": "45",
		    "0.32": "45",
		    "0.33": "45",
		    "0.34": "45",
		    "0.35": "45",
		    "0.36": "47",
		    "0.37": "49",
		    "1.0": "49",
		    "1.1": "50",
		    "1.2": "51",
		    "1.3": "52",
		    "1.4": "53",
		    "1.5": "54",
		    "1.6": "56",
		    "1.7": "58",
		    "1.8": "59",
		    "2.0": "61",
		    "2.1": "61",
		    "3.0": "66",
		    "3.1": "66",
		    "4.0": "69",
		    "4.1": "69",
		    "4.2": "69",
		    "5.0": "73",
		    "6.0": "76",
		    "6.1": "76",
		    "7.0": "78",
		    "7.1": "78",
		    "7.2": "78",
		    "7.3": "78",
		    "8.0": "80",
		    "8.1": "80",
		    "8.2": "80",
		    "8.3": "80",
		    "8.4": "80",
		    "8.5": "80",
		    "9.0": "83",
		    "9.1": "83",
		    "9.2": "83",
		    "9.3": "83",
		    "9.4": "83",
		    "10.0": "85",
		    "10.1": "85",
		    "10.2": "85",
		    "10.3": "85",
		    "10.4": "85",
		    "11.0": "87",
		    "11.1": "87",
		    "11.2": "87",
		    "11.3": "87",
		    "11.4": "87",
		    "11.5": "87",
		    "12.0": "89",
		    "12.1": "89",
		    "12.2": "89",
		    "13.0": "91",
		    "13.1": "91",
		    "13.2": "91",
		    "13.3": "91",
		    "13.4": "91",
		    "13.5": "91",
		    "13.6": "91",
		    "14.0": "93",
		    "14.1": "93",
		    "14.2": "93",
		    "15.0": "94",
		    "15.1": "94",
		    "15.2": "94",
		    "15.3": "94",
		    "15.4": "94",
		    "15.5": "94",
		    "16.0": "96",
		    "16.1": "96",
		    "16.2": "96",
		    "17.0": "98",
		    "17.1": "98",
		    "17.2": "98",
		    "17.3": "98",
		    "17.4": "98",
		    "18.0": "100",
		    "18.1": "100",
		    "18.2": "100",
		    "18.3": "100",
		    "19.0": "102",
		    "19.1": "102",
		    "20.0": "104",
		    "20.1": "104",
		    "20.2": "104",
		    "20.3": "104",
		    "21.0": "106",
		    "21.1": "106",
		    "21.2": "106",
		    "21.3": "106",
		    "21.4": "106",
		    "22.0": "108",
		    "22.1": "108",
		    "22.2": "108",
		    "22.3": "108",
		    "23.0": "110",
		    "23.1": "110",
		    "23.2": "110",
		    "23.3": "110",
		    "24.0": "112",
		    "24.1": "112",
		    "24.2": "112",
		    "24.3": "112",
		    "24.4": "112",
		    "24.5": "112",
		    "24.6": "112",
		    "25.0": "114",
		    "25.1": "114",
		    "25.2": "114",
		    "26.0": "116"
		  };

		  function BrowserslistError$2(message) {
		    this.name = 'BrowserslistError';
		    this.message = message;
		    this.browserslist = true;
		    if (Error.captureStackTrace) {
		      Error.captureStackTrace(this, BrowserslistError$2);
		    }
		  }
		  BrowserslistError$2.prototype = Error.prototype;
		  var error = BrowserslistError$2;

		  var AND_REGEXP = /^\s+and\s+(.*)/i;
		  var OR_REGEXP = /^(?:,\s*|\s+or\s+)(.*)/i;
		  function flatten(array) {
		    if (!Array.isArray(array)) return [array];
		    return array.reduce(function (a, b) {
		      return a.concat(flatten(b));
		    }, []);
		  }
		  function find(string, predicate) {
		    for (var n = 1, max = string.length; n <= max; n++) {
		      var parsed = string.substr(-n, n);
		      if (predicate(parsed, n, max)) {
		        return string.slice(0, -n);
		      }
		    }
		    return '';
		  }
		  function matchQuery(all, query) {
		    var node = {
		      query: query
		    };
		    if (query.indexOf('not ') === 0) {
		      node.not = true;
		      query = query.slice(4);
		    }
		    for (var name in all) {
		      var type = all[name];
		      var match = query.match(type.regexp);
		      if (match) {
		        node.type = name;
		        for (var i = 0; i < type.matches.length; i++) {
		          node[type.matches[i]] = match[i + 1];
		        }
		        return node;
		      }
		    }
		    node.type = 'unknown';
		    return node;
		  }
		  function matchBlock(all, string, qs) {
		    var node;
		    return find(string, function (parsed, n, max) {
		      if (AND_REGEXP.test(parsed)) {
		        node = matchQuery(all, parsed.match(AND_REGEXP)[1]);
		        node.compose = 'and';
		        qs.unshift(node);
		        return true;
		      } else if (OR_REGEXP.test(parsed)) {
		        node = matchQuery(all, parsed.match(OR_REGEXP)[1]);
		        node.compose = 'or';
		        qs.unshift(node);
		        return true;
		      } else if (n === max) {
		        node = matchQuery(all, parsed.trim());
		        node.compose = 'or';
		        qs.unshift(node);
		        return true;
		      }
		      return false;
		    });
		  }
		  var parse$3 = function parse(all, queries) {
		    if (!Array.isArray(queries)) queries = [queries];
		    return flatten(queries.map(function (block) {
		      var qs = [];
		      do {
		        block = matchBlock(all, block, qs);
		      } while (block);
		      return qs;
		    }));
		  };

		  var BrowserslistError$1 = error;
		  function noop() {}
		  var browser = {
		    loadQueries: function loadQueries() {
		      throw new BrowserslistError$1('Sharable configs are not supported in client-side build of Browserslist');
		    },
		    getStat: function getStat(opts) {
		      return opts.stats;
		    },
		    loadConfig: function loadConfig(opts) {
		      if (opts.config) {
		        throw new BrowserslistError$1('Browserslist config are not supported in client-side build');
		      }
		    },
		    loadCountry: function loadCountry() {
		      throw new BrowserslistError$1('Country statistics are not supported ' + 'in client-side build of Browserslist');
		    },
		    loadFeature: function loadFeature() {
		      throw new BrowserslistError$1('Supports queries are not available in client-side build of Browserslist');
		    },
		    currentNode: function currentNode(resolve, context) {
		      return resolve(['maintained node versions'], context)[0];
		    },
		    parseConfig: noop,
		    readConfig: noop,
		    findConfig: noop,
		    clearCaches: noop,
		    oldDataWarning: noop,
		    env: {}
		  };

		  var jsReleases = require$$0$8;
		  var agents = agents$2.agents;
		  var jsEOL = require$$2$1;
		  var path = require$$3$1;
		  var e2c = versions;
		  var BrowserslistError = error;
		  var parse$2 = parse$3;
		  var env = browser;
		  var YEAR = 365.259641 * 24 * 60 * 60 * 1000;
		  var ANDROID_EVERGREEN_FIRST = '37';
		  var OP_MOB_BLINK_FIRST = 14;
		  function isVersionsMatch(versionA, versionB) {
		    return (versionA + '.').indexOf(versionB + '.') === 0;
		  }
		  function isEolReleased(name) {
		    var version = name.slice(1);
		    return browserslist.nodeVersions.some(function (i) {
		      return isVersionsMatch(i, version);
		    });
		  }
		  function normalize$1(versions) {
		    return versions.filter(function (version) {
		      return typeof version === 'string';
		    });
		  }
		  function normalizeElectron(version) {
		    var versionToUse = version;
		    if (version.split('.').length === 3) {
		      versionToUse = version.split('.').slice(0, -1).join('.');
		    }
		    return versionToUse;
		  }
		  function nameMapper(name) {
		    return function mapName(version) {
		      return name + ' ' + version;
		    };
		  }
		  function getMajor(version) {
		    return parseInt(version.split('.')[0]);
		  }
		  function getMajorVersions(released, number) {
		    if (released.length === 0) return [];
		    var majorVersions = uniq(released.map(getMajor));
		    var minimum = majorVersions[majorVersions.length - number];
		    if (!minimum) {
		      return released;
		    }
		    var selected = [];
		    for (var i = released.length - 1; i >= 0; i--) {
		      if (minimum > getMajor(released[i])) break;
		      selected.unshift(released[i]);
		    }
		    return selected;
		  }
		  function uniq(array) {
		    var filtered = [];
		    for (var i = 0; i < array.length; i++) {
		      if (filtered.indexOf(array[i]) === -1) filtered.push(array[i]);
		    }
		    return filtered;
		  }
		  function fillUsage(result, name, data) {
		    for (var i in data) {
		      result[name + ' ' + i] = data[i];
		    }
		  }
		  function generateFilter(sign, version) {
		    version = parseFloat(version);
		    if (sign === '>') {
		      return function (v) {
		        return parseFloat(v) > version;
		      };
		    } else if (sign === '>=') {
		      return function (v) {
		        return parseFloat(v) >= version;
		      };
		    } else if (sign === '<') {
		      return function (v) {
		        return parseFloat(v) < version;
		      };
		    } else {
		      return function (v) {
		        return parseFloat(v) <= version;
		      };
		    }
		  }
		  function generateSemverFilter(sign, version) {
		    version = version.split('.').map(parseSimpleInt);
		    version[1] = version[1] || 0;
		    version[2] = version[2] || 0;
		    if (sign === '>') {
		      return function (v) {
		        v = v.split('.').map(parseSimpleInt);
		        return compareSemver(v, version) > 0;
		      };
		    } else if (sign === '>=') {
		      return function (v) {
		        v = v.split('.').map(parseSimpleInt);
		        return compareSemver(v, version) >= 0;
		      };
		    } else if (sign === '<') {
		      return function (v) {
		        v = v.split('.').map(parseSimpleInt);
		        return compareSemver(version, v) > 0;
		      };
		    } else {
		      return function (v) {
		        v = v.split('.').map(parseSimpleInt);
		        return compareSemver(version, v) >= 0;
		      };
		    }
		  }
		  function parseSimpleInt(x) {
		    return parseInt(x);
		  }
		  function compare$2(a, b) {
		    if (a < b) return -1;
		    if (a > b) return +1;
		    return 0;
		  }
		  function compareSemver(a, b) {
		    return compare$2(parseInt(a[0]), parseInt(b[0])) || compare$2(parseInt(a[1] || '0'), parseInt(b[1] || '0')) || compare$2(parseInt(a[2] || '0'), parseInt(b[2] || '0'));
		  }
		  function semverFilterLoose(operator, range) {
		    range = range.split('.').map(parseSimpleInt);
		    if (typeof range[1] === 'undefined') {
		      range[1] = 'x';
		    }
		    switch (operator) {
		      case '<=':
		        return function (version) {
		          version = version.split('.').map(parseSimpleInt);
		          return compareSemverLoose(version, range) <= 0;
		        };
		      case '>=':
		      default:
		        return function (version) {
		          version = version.split('.').map(parseSimpleInt);
		          return compareSemverLoose(version, range) >= 0;
		        };
		    }
		  }
		  function compareSemverLoose(version, range) {
		    if (version[0] !== range[0]) {
		      return version[0] < range[0] ? -1 : +1;
		    }
		    if (range[1] === 'x') {
		      return 0;
		    }
		    if (version[1] !== range[1]) {
		      return version[1] < range[1] ? -1 : +1;
		    }
		    return 0;
		  }
		  function resolveVersion(data, version) {
		    if (data.versions.indexOf(version) !== -1) {
		      return version;
		    } else if (browserslist.versionAliases[data.name][version]) {
		      return browserslist.versionAliases[data.name][version];
		    } else {
		      return false;
		    }
		  }
		  function normalizeVersion(data, version) {
		    var resolved = resolveVersion(data, version);
		    if (resolved) {
		      return resolved;
		    } else if (data.versions.length === 1) {
		      return data.versions[0];
		    } else {
		      return false;
		    }
		  }
		  function filterByYear(since, context) {
		    since = since / 1000;
		    return Object.keys(agents).reduce(function (selected, name) {
		      var data = byName(name, context);
		      if (!data) return selected;
		      var versions = Object.keys(data.releaseDate).filter(function (v) {
		        var date = data.releaseDate[v];
		        return date !== null && date >= since;
		      });
		      return selected.concat(versions.map(nameMapper(data.name)));
		    }, []);
		  }
		  function cloneData(data) {
		    return {
		      name: data.name,
		      versions: data.versions,
		      released: data.released,
		      releaseDate: data.releaseDate
		    };
		  }
		  function byName(name, context) {
		    name = name.toLowerCase();
		    name = browserslist.aliases[name] || name;
		    if (context.mobileToDesktop && browserslist.desktopNames[name]) {
		      var desktop = browserslist.data[browserslist.desktopNames[name]];
		      if (name === 'android') {
		        return normalizeAndroidData(cloneData(browserslist.data[name]), desktop);
		      } else {
		        var cloned = cloneData(desktop);
		        cloned.name = name;
		        return cloned;
		      }
		    }
		    return browserslist.data[name];
		  }
		  function normalizeAndroidVersions(androidVersions, chromeVersions) {
		    var iFirstEvergreen = chromeVersions.indexOf(ANDROID_EVERGREEN_FIRST);
		    return androidVersions.filter(function (version) {
		      return /^(?:[2-4]\.|[34]$)/.test(version);
		    }).concat(chromeVersions.slice(iFirstEvergreen));
		  }
		  function copyObject(obj) {
		    var copy = {};
		    for (var key in obj) {
		      copy[key] = obj[key];
		    }
		    return copy;
		  }
		  function normalizeAndroidData(android, chrome) {
		    android.released = normalizeAndroidVersions(android.released, chrome.released);
		    android.versions = normalizeAndroidVersions(android.versions, chrome.versions);
		    android.releaseDate = copyObject(android.releaseDate);
		    android.released.forEach(function (v) {
		      if (android.releaseDate[v] === undefined) {
		        android.releaseDate[v] = chrome.releaseDate[v];
		      }
		    });
		    return android;
		  }
		  function checkName(name, context) {
		    var data = byName(name, context);
		    if (!data) throw new BrowserslistError('Unknown browser ' + name);
		    return data;
		  }
		  function unknownQuery(query) {
		    return new BrowserslistError('Unknown browser query `' + query + '`. ' + 'Maybe you are using old Browserslist or made typo in query.');
		  }
		  function filterJumps(list, name, nVersions, context) {
		    var jump = 1;
		    switch (name) {
		      case 'android':
		        if (context.mobileToDesktop) return list;
		        var released = browserslist.data.chrome.released;
		        jump = released.length - released.indexOf(ANDROID_EVERGREEN_FIRST);
		        break;
		      case 'op_mob':
		        var latest = browserslist.data.op_mob.released.slice(-1)[0];
		        jump = getMajor(latest) - OP_MOB_BLINK_FIRST + 1;
		        break;
		      default:
		        return list;
		    }
		    if (nVersions <= jump) {
		      return list.slice(-1);
		    }
		    return list.slice(jump - 1 - nVersions);
		  }
		  function isSupported(flags, withPartial) {
		    return typeof flags === 'string' && (flags.indexOf('y') >= 0 || withPartial && flags.indexOf('a') >= 0);
		  }
		  function resolve$1(queries, context) {
		    return parse$2(QUERIES, queries).reduce(function (result, node, index) {
		      if (node.not && index === 0) {
		        throw new BrowserslistError('Write any browsers query (for instance, `defaults`) ' + 'before `' + node.query + '`');
		      }
		      var type = QUERIES[node.type];
		      var array = type.select.call(browserslist, context, node).map(function (j) {
		        var parts = j.split(' ');
		        if (parts[1] === '0') {
		          return parts[0] + ' ' + byName(parts[0], context).versions[0];
		        } else {
		          return j;
		        }
		      });
		      if (node.compose === 'and') {
		        if (node.not) {
		          return result.filter(function (j) {
		            return array.indexOf(j) === -1;
		          });
		        } else {
		          return result.filter(function (j) {
		            return array.indexOf(j) !== -1;
		          });
		        }
		      } else {
		        if (node.not) {
		          var filter = {};
		          array.forEach(function (j) {
		            filter[j] = true;
		          });
		          return result.filter(function (j) {
		            return !filter[j];
		          });
		        }
		        return result.concat(array);
		      }
		    }, []);
		  }
		  function prepareOpts(opts) {
		    if (typeof opts === 'undefined') opts = {};
		    if (typeof opts.path === 'undefined') {
		      opts.path = path.resolve ? path.resolve('.') : '.';
		    }
		    return opts;
		  }
		  function prepareQueries(queries, opts) {
		    if (typeof queries === 'undefined' || queries === null) {
		      var config = browserslist.loadConfig(opts);
		      if (config) {
		        queries = config;
		      } else {
		        queries = browserslist.defaults;
		      }
		    }
		    return queries;
		  }
		  function checkQueries(queries) {
		    if (!(typeof queries === 'string' || Array.isArray(queries))) {
		      throw new BrowserslistError('Browser queries must be an array or string. Got ' + typeof queries + '.');
		    }
		  }
		  var cache = {};
		  function browserslist(queries, opts) {
		    opts = prepareOpts(opts);
		    queries = prepareQueries(queries, opts);
		    checkQueries(queries);
		    var context = {
		      ignoreUnknownVersions: opts.ignoreUnknownVersions,
		      dangerousExtend: opts.dangerousExtend,
		      mobileToDesktop: opts.mobileToDesktop,
		      path: opts.path,
		      env: opts.env
		    };
		    env.oldDataWarning(browserslist.data);
		    var stats = env.getStat(opts, browserslist.data);
		    if (stats) {
		      context.customUsage = {};
		      for (var browser in stats) {
		        fillUsage(context.customUsage, browser, stats[browser]);
		      }
		    }
		    var cacheKey = JSON.stringify([queries, context]);
		    if (cache[cacheKey]) return cache[cacheKey];
		    var result = uniq(resolve$1(queries, context)).sort(function (name1, name2) {
		      name1 = name1.split(' ');
		      name2 = name2.split(' ');
		      if (name1[0] === name2[0]) {
		        var version1 = name1[1].split('-')[0];
		        var version2 = name2[1].split('-')[0];
		        return compareSemver(version2.split('.'), version1.split('.'));
		      } else {
		        return compare$2(name1[0], name2[0]);
		      }
		    });
		    if (!env.env.BROWSERSLIST_DISABLE_CACHE) {
		      cache[cacheKey] = result;
		    }
		    return result;
		  }
		  browserslist.parse = function (queries, opts) {
		    opts = prepareOpts(opts);
		    queries = prepareQueries(queries, opts);
		    checkQueries(queries);
		    return parse$2(QUERIES, queries);
		  };
		  browserslist.cache = {};
		  browserslist.data = {};
		  browserslist.usage = {
		    global: {},
		    custom: null
		  };
		  browserslist.defaults = ['> 0.5%', 'last 2 versions', 'Firefox ESR', 'not dead'];
		  browserslist.aliases = {
		    fx: 'firefox',
		    ff: 'firefox',
		    ios: 'ios_saf',
		    explorer: 'ie',
		    blackberry: 'bb',
		    explorermobile: 'ie_mob',
		    operamini: 'op_mini',
		    operamobile: 'op_mob',
		    chromeandroid: 'and_chr',
		    firefoxandroid: 'and_ff',
		    ucandroid: 'and_uc',
		    qqandroid: 'and_qq'
		  };
		  browserslist.desktopNames = {
		    and_chr: 'chrome',
		    and_ff: 'firefox',
		    ie_mob: 'ie',
		    android: 'chrome'
		  };
		  browserslist.versionAliases = {};
		  browserslist.clearCaches = env.clearCaches;
		  browserslist.parseConfig = env.parseConfig;
		  browserslist.readConfig = env.readConfig;
		  browserslist.findConfig = env.findConfig;
		  browserslist.loadConfig = env.loadConfig;
		  browserslist.coverage = function (browsers, stats) {
		    var data;
		    if (typeof stats === 'undefined') {
		      data = browserslist.usage.global;
		    } else if (stats === 'my stats') {
		      var opts = {};
		      opts.path = path.resolve ? path.resolve('.') : '.';
		      var customStats = env.getStat(opts);
		      if (!customStats) {
		        throw new BrowserslistError('Custom usage statistics was not provided');
		      }
		      data = {};
		      for (var browser in customStats) {
		        fillUsage(data, browser, customStats[browser]);
		      }
		    } else if (typeof stats === 'string') {
		      if (stats.length > 2) {
		        stats = stats.toLowerCase();
		      } else {
		        stats = stats.toUpperCase();
		      }
		      env.loadCountry(browserslist.usage, stats, browserslist.data);
		      data = browserslist.usage[stats];
		    } else {
		      if ('dataByBrowser' in stats) {
		        stats = stats.dataByBrowser;
		      }
		      data = {};
		      for (var name in stats) {
		        for (var version in stats[name]) {
		          data[name + ' ' + version] = stats[name][version];
		        }
		      }
		    }
		    return browsers.reduce(function (all, i) {
		      var usage = data[i];
		      if (usage === undefined) {
		        usage = data[i.replace(/ \S+$/, ' 0')];
		      }
		      return all + (usage || 0);
		    }, 0);
		  };
		  function nodeQuery(context, node) {
		    var matched = browserslist.nodeVersions.filter(function (i) {
		      return isVersionsMatch(i, node.version);
		    });
		    if (matched.length === 0) {
		      if (context.ignoreUnknownVersions) {
		        return [];
		      } else {
		        throw new BrowserslistError('Unknown version ' + node.version + ' of Node.js');
		      }
		    }
		    return ['node ' + matched[matched.length - 1]];
		  }
		  function sinceQuery(context, node) {
		    var year = parseInt(node.year);
		    var month = parseInt(node.month || '01') - 1;
		    var day = parseInt(node.day || '01');
		    return filterByYear(Date.UTC(year, month, day, 0, 0, 0), context);
		  }
		  function coverQuery(context, node) {
		    var coverage = parseFloat(node.coverage);
		    var usage = browserslist.usage.global;
		    if (node.place) {
		      if (node.place.match(/^my\s+stats$/i)) {
		        if (!context.customUsage) {
		          throw new BrowserslistError('Custom usage statistics was not provided');
		        }
		        usage = context.customUsage;
		      } else {
		        var place;
		        if (node.place.length === 2) {
		          place = node.place.toUpperCase();
		        } else {
		          place = node.place.toLowerCase();
		        }
		        env.loadCountry(browserslist.usage, place, browserslist.data);
		        usage = browserslist.usage[place];
		      }
		    }
		    var versions = Object.keys(usage).sort(function (a, b) {
		      return usage[b] - usage[a];
		    });
		    var coveraged = 0;
		    var result = [];
		    var version;
		    for (var i = 0; i < versions.length; i++) {
		      version = versions[i];
		      if (usage[version] === 0) break;
		      coveraged += usage[version];
		      result.push(version);
		      if (coveraged >= coverage) break;
		    }
		    return result;
		  }
		  var QUERIES = {
		    last_major_versions: {
		      matches: ['versions'],
		      regexp: /^last\s+(\d+)\s+major\s+versions?$/i,
		      select: function select(context, node) {
		        return Object.keys(agents).reduce(function (selected, name) {
		          var data = byName(name, context);
		          if (!data) return selected;
		          var list = getMajorVersions(data.released, node.versions);
		          list = list.map(nameMapper(data.name));
		          list = filterJumps(list, data.name, node.versions, context);
		          return selected.concat(list);
		        }, []);
		      }
		    },
		    last_versions: {
		      matches: ['versions'],
		      regexp: /^last\s+(\d+)\s+versions?$/i,
		      select: function select(context, node) {
		        return Object.keys(agents).reduce(function (selected, name) {
		          var data = byName(name, context);
		          if (!data) return selected;
		          var list = data.released.slice(-node.versions);
		          list = list.map(nameMapper(data.name));
		          list = filterJumps(list, data.name, node.versions, context);
		          return selected.concat(list);
		        }, []);
		      }
		    },
		    last_electron_major_versions: {
		      matches: ['versions'],
		      regexp: /^last\s+(\d+)\s+electron\s+major\s+versions?$/i,
		      select: function select(context, node) {
		        var validVersions = getMajorVersions(Object.keys(e2c), node.versions);
		        return validVersions.map(function (i) {
		          return 'chrome ' + e2c[i];
		        });
		      }
		    },
		    last_node_major_versions: {
		      matches: ['versions'],
		      regexp: /^last\s+(\d+)\s+node\s+major\s+versions?$/i,
		      select: function select(context, node) {
		        return getMajorVersions(browserslist.nodeVersions, node.versions).map(function (version) {
		          return 'node ' + version;
		        });
		      }
		    },
		    last_browser_major_versions: {
		      matches: ['versions', 'browser'],
		      regexp: /^last\s+(\d+)\s+(\w+)\s+major\s+versions?$/i,
		      select: function select(context, node) {
		        var data = checkName(node.browser, context);
		        var validVersions = getMajorVersions(data.released, node.versions);
		        var list = validVersions.map(nameMapper(data.name));
		        list = filterJumps(list, data.name, node.versions, context);
		        return list;
		      }
		    },
		    last_electron_versions: {
		      matches: ['versions'],
		      regexp: /^last\s+(\d+)\s+electron\s+versions?$/i,
		      select: function select(context, node) {
		        return Object.keys(e2c).slice(-node.versions).map(function (i) {
		          return 'chrome ' + e2c[i];
		        });
		      }
		    },
		    last_node_versions: {
		      matches: ['versions'],
		      regexp: /^last\s+(\d+)\s+node\s+versions?$/i,
		      select: function select(context, node) {
		        return browserslist.nodeVersions.slice(-node.versions).map(function (version) {
		          return 'node ' + version;
		        });
		      }
		    },
		    last_browser_versions: {
		      matches: ['versions', 'browser'],
		      regexp: /^last\s+(\d+)\s+(\w+)\s+versions?$/i,
		      select: function select(context, node) {
		        var data = checkName(node.browser, context);
		        var list = data.released.slice(-node.versions).map(nameMapper(data.name));
		        list = filterJumps(list, data.name, node.versions, context);
		        return list;
		      }
		    },
		    unreleased_versions: {
		      matches: [],
		      regexp: /^unreleased\s+versions$/i,
		      select: function select(context) {
		        return Object.keys(agents).reduce(function (selected, name) {
		          var data = byName(name, context);
		          if (!data) return selected;
		          var list = data.versions.filter(function (v) {
		            return data.released.indexOf(v) === -1;
		          });
		          list = list.map(nameMapper(data.name));
		          return selected.concat(list);
		        }, []);
		      }
		    },
		    unreleased_electron_versions: {
		      matches: [],
		      regexp: /^unreleased\s+electron\s+versions?$/i,
		      select: function select() {
		        return [];
		      }
		    },
		    unreleased_browser_versions: {
		      matches: ['browser'],
		      regexp: /^unreleased\s+(\w+)\s+versions?$/i,
		      select: function select(context, node) {
		        var data = checkName(node.browser, context);
		        return data.versions.filter(function (v) {
		          return data.released.indexOf(v) === -1;
		        }).map(nameMapper(data.name));
		      }
		    },
		    last_years: {
		      matches: ['years'],
		      regexp: /^last\s+(\d*.?\d+)\s+years?$/i,
		      select: function select(context, node) {
		        return filterByYear(Date.now() - YEAR * node.years, context);
		      }
		    },
		    since_y: {
		      matches: ['year'],
		      regexp: /^since (\d+)$/i,
		      select: sinceQuery
		    },
		    since_y_m: {
		      matches: ['year', 'month'],
		      regexp: /^since (\d+)-(\d+)$/i,
		      select: sinceQuery
		    },
		    since_y_m_d: {
		      matches: ['year', 'month', 'day'],
		      regexp: /^since (\d+)-(\d+)-(\d+)$/i,
		      select: sinceQuery
		    },
		    popularity: {
		      matches: ['sign', 'popularity'],
		      regexp: /^(>=?|<=?)\s*(\d+|\d+\.\d+|\.\d+)%$/,
		      select: function select(context, node) {
		        var popularity = parseFloat(node.popularity);
		        var usage = browserslist.usage.global;
		        return Object.keys(usage).reduce(function (result, version) {
		          if (node.sign === '>') {
		            if (usage[version] > popularity) {
		              result.push(version);
		            }
		          } else if (node.sign === '<') {
		            if (usage[version] < popularity) {
		              result.push(version);
		            }
		          } else if (node.sign === '<=') {
		            if (usage[version] <= popularity) {
		              result.push(version);
		            }
		          } else if (usage[version] >= popularity) {
		            result.push(version);
		          }
		          return result;
		        }, []);
		      }
		    },
		    popularity_in_my_stats: {
		      matches: ['sign', 'popularity'],
		      regexp: /^(>=?|<=?)\s*(\d+|\d+\.\d+|\.\d+)%\s+in\s+my\s+stats$/,
		      select: function select(context, node) {
		        var popularity = parseFloat(node.popularity);
		        if (!context.customUsage) {
		          throw new BrowserslistError('Custom usage statistics was not provided');
		        }
		        var usage = context.customUsage;
		        return Object.keys(usage).reduce(function (result, version) {
		          var percentage = usage[version];
		          if (percentage == null) {
		            return result;
		          }
		          if (node.sign === '>') {
		            if (percentage > popularity) {
		              result.push(version);
		            }
		          } else if (node.sign === '<') {
		            if (percentage < popularity) {
		              result.push(version);
		            }
		          } else if (node.sign === '<=') {
		            if (percentage <= popularity) {
		              result.push(version);
		            }
		          } else if (percentage >= popularity) {
		            result.push(version);
		          }
		          return result;
		        }, []);
		      }
		    },
		    popularity_in_config_stats: {
		      matches: ['sign', 'popularity', 'config'],
		      regexp: /^(>=?|<=?)\s*(\d+|\d+\.\d+|\.\d+)%\s+in\s+(\S+)\s+stats$/,
		      select: function select(context, node) {
		        var popularity = parseFloat(node.popularity);
		        var stats = env.loadStat(context, node.config, browserslist.data);
		        if (stats) {
		          context.customUsage = {};
		          for (var browser in stats) {
		            fillUsage(context.customUsage, browser, stats[browser]);
		          }
		        }
		        if (!context.customUsage) {
		          throw new BrowserslistError('Custom usage statistics was not provided');
		        }
		        var usage = context.customUsage;
		        return Object.keys(usage).reduce(function (result, version) {
		          var percentage = usage[version];
		          if (percentage == null) {
		            return result;
		          }
		          if (node.sign === '>') {
		            if (percentage > popularity) {
		              result.push(version);
		            }
		          } else if (node.sign === '<') {
		            if (percentage < popularity) {
		              result.push(version);
		            }
		          } else if (node.sign === '<=') {
		            if (percentage <= popularity) {
		              result.push(version);
		            }
		          } else if (percentage >= popularity) {
		            result.push(version);
		          }
		          return result;
		        }, []);
		      }
		    },
		    popularity_in_place: {
		      matches: ['sign', 'popularity', 'place'],
		      regexp: /^(>=?|<=?)\s*(\d+|\d+\.\d+|\.\d+)%\s+in\s+((alt-)?\w\w)$/,
		      select: function select(context, node) {
		        var popularity = parseFloat(node.popularity);
		        var place = node.place;
		        if (place.length === 2) {
		          place = place.toUpperCase();
		        } else {
		          place = place.toLowerCase();
		        }
		        env.loadCountry(browserslist.usage, place, browserslist.data);
		        var usage = browserslist.usage[place];
		        return Object.keys(usage).reduce(function (result, version) {
		          var percentage = usage[version];
		          if (percentage == null) {
		            return result;
		          }
		          if (node.sign === '>') {
		            if (percentage > popularity) {
		              result.push(version);
		            }
		          } else if (node.sign === '<') {
		            if (percentage < popularity) {
		              result.push(version);
		            }
		          } else if (node.sign === '<=') {
		            if (percentage <= popularity) {
		              result.push(version);
		            }
		          } else if (percentage >= popularity) {
		            result.push(version);
		          }
		          return result;
		        }, []);
		      }
		    },
		    cover: {
		      matches: ['coverage'],
		      regexp: /^cover\s+(\d+|\d+\.\d+|\.\d+)%$/i,
		      select: coverQuery
		    },
		    cover_in: {
		      matches: ['coverage', 'place'],
		      regexp: /^cover\s+(\d+|\d+\.\d+|\.\d+)%\s+in\s+(my\s+stats|(alt-)?\w\w)$/i,
		      select: coverQuery
		    },
		    supports: {
		      matches: ['supportType', 'feature'],
		      regexp: /^(?:(fully|partially) )?supports\s+([\w-]+)$/,
		      select: function select(context, node) {
		        env.loadFeature(browserslist.cache, node.feature);
		        var withPartial = node.supportType !== 'fully';
		        var features = browserslist.cache[node.feature];
		        var result = [];
		        for (var name in features) {
		          var data = byName(name, context);
		          var checkDesktop = context.mobileToDesktop && name in browserslist.desktopNames && isSupported(features[name][data.released.slice(-1)[0]], withPartial);
		          data.versions.forEach(function (version) {
		            var flags = features[name][version];
		            if (flags === undefined && checkDesktop) {
		              flags = features[browserslist.desktopNames[name]][version];
		            }
		            if (isSupported(flags, withPartial)) {
		              result.push(name + ' ' + version);
		            }
		          });
		        }
		        return result;
		      }
		    },
		    electron_range: {
		      matches: ['from', 'to'],
		      regexp: /^electron\s+([\d.]+)\s*-\s*([\d.]+)$/i,
		      select: function select(context, node) {
		        var fromToUse = normalizeElectron(node.from);
		        var toToUse = normalizeElectron(node.to);
		        var from = parseFloat(node.from);
		        var to = parseFloat(node.to);
		        if (!e2c[fromToUse]) {
		          throw new BrowserslistError('Unknown version ' + from + ' of electron');
		        }
		        if (!e2c[toToUse]) {
		          throw new BrowserslistError('Unknown version ' + to + ' of electron');
		        }
		        return Object.keys(e2c).filter(function (i) {
		          var parsed = parseFloat(i);
		          return parsed >= from && parsed <= to;
		        }).map(function (i) {
		          return 'chrome ' + e2c[i];
		        });
		      }
		    },
		    node_range: {
		      matches: ['from', 'to'],
		      regexp: /^node\s+([\d.]+)\s*-\s*([\d.]+)$/i,
		      select: function select(context, node) {
		        return browserslist.nodeVersions.filter(semverFilterLoose('>=', node.from)).filter(semverFilterLoose('<=', node.to)).map(function (v) {
		          return 'node ' + v;
		        });
		      }
		    },
		    browser_range: {
		      matches: ['browser', 'from', 'to'],
		      regexp: /^(\w+)\s+([\d.]+)\s*-\s*([\d.]+)$/i,
		      select: function select(context, node) {
		        var data = checkName(node.browser, context);
		        var from = parseFloat(normalizeVersion(data, node.from) || node.from);
		        var to = parseFloat(normalizeVersion(data, node.to) || node.to);
		        function filter(v) {
		          var parsed = parseFloat(v);
		          return parsed >= from && parsed <= to;
		        }
		        return data.released.filter(filter).map(nameMapper(data.name));
		      }
		    },
		    electron_ray: {
		      matches: ['sign', 'version'],
		      regexp: /^electron\s*(>=?|<=?)\s*([\d.]+)$/i,
		      select: function select(context, node) {
		        var versionToUse = normalizeElectron(node.version);
		        return Object.keys(e2c).filter(generateFilter(node.sign, versionToUse)).map(function (i) {
		          return 'chrome ' + e2c[i];
		        });
		      }
		    },
		    node_ray: {
		      matches: ['sign', 'version'],
		      regexp: /^node\s*(>=?|<=?)\s*([\d.]+)$/i,
		      select: function select(context, node) {
		        return browserslist.nodeVersions.filter(generateSemverFilter(node.sign, node.version)).map(function (v) {
		          return 'node ' + v;
		        });
		      }
		    },
		    browser_ray: {
		      matches: ['browser', 'sign', 'version'],
		      regexp: /^(\w+)\s*(>=?|<=?)\s*([\d.]+)$/,
		      select: function select(context, node) {
		        var version = node.version;
		        var data = checkName(node.browser, context);
		        var alias = browserslist.versionAliases[data.name][version];
		        if (alias) version = alias;
		        return data.released.filter(generateFilter(node.sign, version)).map(function (v) {
		          return data.name + ' ' + v;
		        });
		      }
		    },
		    firefox_esr: {
		      matches: [],
		      regexp: /^(firefox|ff|fx)\s+esr$/i,
		      select: function select() {
		        return ['firefox 115'];
		      }
		    },
		    opera_mini_all: {
		      matches: [],
		      regexp: /(operamini|op_mini)\s+all/i,
		      select: function select() {
		        return ['op_mini all'];
		      }
		    },
		    electron_version: {
		      matches: ['version'],
		      regexp: /^electron\s+([\d.]+)$/i,
		      select: function select(context, node) {
		        var versionToUse = normalizeElectron(node.version);
		        var chrome = e2c[versionToUse];
		        if (!chrome) {
		          throw new BrowserslistError('Unknown version ' + node.version + ' of electron');
		        }
		        return ['chrome ' + chrome];
		      }
		    },
		    node_major_version: {
		      matches: ['version'],
		      regexp: /^node\s+(\d+)$/i,
		      select: nodeQuery
		    },
		    node_minor_version: {
		      matches: ['version'],
		      regexp: /^node\s+(\d+\.\d+)$/i,
		      select: nodeQuery
		    },
		    node_patch_version: {
		      matches: ['version'],
		      regexp: /^node\s+(\d+\.\d+\.\d+)$/i,
		      select: nodeQuery
		    },
		    current_node: {
		      matches: [],
		      regexp: /^current\s+node$/i,
		      select: function select(context) {
		        return [env.currentNode(resolve$1, context)];
		      }
		    },
		    maintained_node: {
		      matches: [],
		      regexp: /^maintained\s+node\s+versions$/i,
		      select: function select(context) {
		        var now = Date.now();
		        var queries = Object.keys(jsEOL).filter(function (key) {
		          return now < Date.parse(jsEOL[key].end) && now > Date.parse(jsEOL[key].start) && isEolReleased(key);
		        }).map(function (key) {
		          return 'node ' + key.slice(1);
		        });
		        return resolve$1(queries, context);
		      }
		    },
		    phantomjs_1_9: {
		      matches: [],
		      regexp: /^phantomjs\s+1.9$/i,
		      select: function select() {
		        return ['safari 5'];
		      }
		    },
		    phantomjs_2_1: {
		      matches: [],
		      regexp: /^phantomjs\s+2.1$/i,
		      select: function select() {
		        return ['safari 6'];
		      }
		    },
		    browser_version: {
		      matches: ['browser', 'version'],
		      regexp: /^(\w+)\s+(tp|[\d.]+)$/i,
		      select: function select(context, node) {
		        var version = node.version;
		        if (/^tp$/i.test(version)) version = 'TP';
		        var data = checkName(node.browser, context);
		        var alias = normalizeVersion(data, version);
		        if (alias) {
		          version = alias;
		        } else {
		          if (version.indexOf('.') === -1) {
		            alias = version + '.0';
		          } else {
		            alias = version.replace(/\.0$/, '');
		          }
		          alias = normalizeVersion(data, alias);
		          if (alias) {
		            version = alias;
		          } else if (context.ignoreUnknownVersions) {
		            return [];
		          } else {
		            throw new BrowserslistError('Unknown version ' + version + ' of ' + node.browser);
		          }
		        }
		        return [data.name + ' ' + version];
		      }
		    },
		    browserslist_config: {
		      matches: [],
		      regexp: /^browserslist config$/i,
		      select: function select(context) {
		        return browserslist(undefined, context);
		      }
		    },
		    "extends": {
		      matches: ['config'],
		      regexp: /^extends (.+)$/i,
		      select: function select(context, node) {
		        return resolve$1(env.loadQueries(context, node.config), context);
		      }
		    },
		    defaults: {
		      matches: [],
		      regexp: /^defaults$/i,
		      select: function select(context) {
		        return resolve$1(browserslist.defaults, context);
		      }
		    },
		    dead: {
		      matches: [],
		      regexp: /^dead$/i,
		      select: function select(context) {
		        var dead = ['Baidu >= 0', 'ie <= 11', 'ie_mob <= 11', 'bb <= 10', 'op_mob <= 12.1', 'samsung 4'];
		        return resolve$1(dead, context);
		      }
		    },
		    unknown: {
		      matches: [],
		      regexp: /^(\w+)$/i,
		      select: function select(context, node) {
		        if (byName(node.query, context)) {
		          throw new BrowserslistError('Specify versions in Browserslist query for browser ' + node.query);
		        } else {
		          throw unknownQuery(node.query);
		        }
		      }
		    }
		  };
		  (function () {
		    for (var name in agents) {
		      var browser = agents[name];
		      browserslist.data[name] = {
		        name: name,
		        versions: normalize$1(agents[name].versions),
		        released: normalize$1(agents[name].versions.slice(0, -3)),
		        releaseDate: agents[name].release_date
		      };
		      fillUsage(browserslist.usage.global, name, browser.usage_global);
		      browserslist.versionAliases[name] = {};
		      for (var i = 0; i < browser.versions.length; i++) {
		        var full = browser.versions[i];
		        if (!full) continue;
		        if (full.indexOf('-') !== -1) {
		          var interval = full.split('-');
		          for (var j = 0; j < interval.length; j++) {
		            browserslist.versionAliases[name][interval[j]] = full;
		          }
		        }
		      }
		    }
		    browserslist.nodeVersions = jsReleases.map(function (release) {
		      return release.version;
		    });
		  })();
		  var browserslist_1 = browserslist;

		  var min = Math.min;
		  function levenshtein(a, b) {
		    var t = [],
		      u = [],
		      i,
		      j;
		    var m = a.length,
		      n = b.length;
		    if (!m) {
		      return n;
		    }
		    if (!n) {
		      return m;
		    }
		    for (j = 0; j <= n; j++) {
		      t[j] = j;
		    }
		    for (i = 1; i <= m; i++) {
		      for (u = [i], j = 1; j <= n; j++) {
		        u[j] = a[i - 1] === b[j - 1] ? t[j - 1] : min(t[j - 1], t[j], u[j - 1]) + 1;
		      }
		      t = u;
		    }
		    return u[n];
		  }
		  function findSuggestion(str, arr) {
		    var distances = arr.map(function (el) {
		      return levenshtein(el, str);
		    });
		    return arr[distances.indexOf(min.apply(void 0, _toConsumableArray(distances)))];
		  }

		  var OptionValidator = function () {
		    function OptionValidator(descriptor) {
		      this.descriptor = descriptor;
		    }
		    var _proto = OptionValidator.prototype;
		    _proto.validateTopLevelOptions = function validateTopLevelOptions(options, TopLevelOptionShape) {
		      var validOptionNames = Object.keys(TopLevelOptionShape);
		      for (var _i = 0, _Object$keys = Object.keys(options); _i < _Object$keys.length; _i++) {
		        var option = _Object$keys[_i];
		        if (!validOptionNames.includes(option)) {
		          throw new Error(this.formatMessage("'" + option + "' is not a valid top-level option.\n- Did you mean '" + findSuggestion(option, validOptionNames) + "'?"));
		        }
		      }
		    };
		    _proto.validateBooleanOption = function validateBooleanOption(name, value, defaultValue) {
		      if (value === undefined) {
		        return defaultValue;
		      } else {
		        this.invariant(typeof value === "boolean", "'" + name + "' option must be a boolean.");
		      }
		      return value;
		    };
		    _proto.validateStringOption = function validateStringOption(name, value, defaultValue) {
		      if (value === undefined) {
		        return defaultValue;
		      } else {
		        this.invariant(typeof value === "string", "'" + name + "' option must be a string.");
		      }
		      return value;
		    };
		    _proto.invariant = function invariant(condition, message) {
		      if (!condition) {
		        throw new Error(this.formatMessage(message));
		      }
		    };
		    _proto.formatMessage = function formatMessage(message) {
		      return this.descriptor + ": " + message;
		    };
		    return _createClass(OptionValidator);
		  }();

		  var require$$0$7 = {
		  	"es6.module": {
		  	chrome: "61",
		  	and_chr: "61",
		  	edge: "16",
		  	firefox: "60",
		  	and_ff: "60",
		  	node: "13.2.0",
		  	opera: "48",
		  	op_mob: "45",
		  	safari: "10.1",
		  	ios: "10.3",
		  	samsung: "8.2",
		  	android: "61",
		  	electron: "2.0",
		  	ios_saf: "10.3"
		  }
		  };

		  var nativeModules = require$$0$7;

		  var iterator;
		  var hasRequiredIterator;
		  function requireIterator() {
		    if (hasRequiredIterator) return iterator;
		    hasRequiredIterator = 1;
		    iterator = function iterator(Yallist) {
		      Yallist.prototype[Symbol.iterator] = _regeneratorRuntime().mark(function _callee() {
		        var walker;
		        return _regeneratorRuntime().wrap(function _callee$(_context) {
		          while (1) switch (_context.prev = _context.next) {
		            case 0:
		              walker = this.head;
		            case 1:
		              if (!walker) {
		                _context.next = 7;
		                break;
		              }
		              _context.next = 4;
		              return walker.value;
		            case 4:
		              walker = walker.next;
		              _context.next = 1;
		              break;
		            case 7:
		            case "end":
		              return _context.stop();
		          }
		        }, _callee, this);
		      });
		    };
		    return iterator;
		  }

		  var yallist;
		  var hasRequiredYallist;
		  function requireYallist() {
		    if (hasRequiredYallist) return yallist;
		    hasRequiredYallist = 1;
		    yallist = Yallist;
		    Yallist.Node = Node;
		    Yallist.create = Yallist;
		    function Yallist(list) {
		      var self = this;
		      if (!(self instanceof Yallist)) {
		        self = new Yallist();
		      }
		      self.tail = null;
		      self.head = null;
		      self.length = 0;
		      if (list && typeof list.forEach === 'function') {
		        list.forEach(function (item) {
		          self.push(item);
		        });
		      } else if (arguments.length > 0) {
		        for (var i = 0, l = arguments.length; i < l; i++) {
		          self.push(arguments[i]);
		        }
		      }
		      return self;
		    }
		    Yallist.prototype.removeNode = function (node) {
		      if (node.list !== this) {
		        throw new Error('removing node which does not belong to this list');
		      }
		      var next = node.next;
		      var prev = node.prev;
		      if (next) {
		        next.prev = prev;
		      }
		      if (prev) {
		        prev.next = next;
		      }
		      if (node === this.head) {
		        this.head = next;
		      }
		      if (node === this.tail) {
		        this.tail = prev;
		      }
		      node.list.length--;
		      node.next = null;
		      node.prev = null;
		      node.list = null;
		      return next;
		    };
		    Yallist.prototype.unshiftNode = function (node) {
		      if (node === this.head) {
		        return;
		      }
		      if (node.list) {
		        node.list.removeNode(node);
		      }
		      var head = this.head;
		      node.list = this;
		      node.next = head;
		      if (head) {
		        head.prev = node;
		      }
		      this.head = node;
		      if (!this.tail) {
		        this.tail = node;
		      }
		      this.length++;
		    };
		    Yallist.prototype.pushNode = function (node) {
		      if (node === this.tail) {
		        return;
		      }
		      if (node.list) {
		        node.list.removeNode(node);
		      }
		      var tail = this.tail;
		      node.list = this;
		      node.prev = tail;
		      if (tail) {
		        tail.next = node;
		      }
		      this.tail = node;
		      if (!this.head) {
		        this.head = node;
		      }
		      this.length++;
		    };
		    Yallist.prototype.push = function () {
		      for (var i = 0, l = arguments.length; i < l; i++) {
		        push(this, arguments[i]);
		      }
		      return this.length;
		    };
		    Yallist.prototype.unshift = function () {
		      for (var i = 0, l = arguments.length; i < l; i++) {
		        unshift(this, arguments[i]);
		      }
		      return this.length;
		    };
		    Yallist.prototype.pop = function () {
		      if (!this.tail) {
		        return undefined;
		      }
		      var res = this.tail.value;
		      this.tail = this.tail.prev;
		      if (this.tail) {
		        this.tail.next = null;
		      } else {
		        this.head = null;
		      }
		      this.length--;
		      return res;
		    };
		    Yallist.prototype.shift = function () {
		      if (!this.head) {
		        return undefined;
		      }
		      var res = this.head.value;
		      this.head = this.head.next;
		      if (this.head) {
		        this.head.prev = null;
		      } else {
		        this.tail = null;
		      }
		      this.length--;
		      return res;
		    };
		    Yallist.prototype.forEach = function (fn, thisp) {
		      thisp = thisp || this;
		      for (var walker = this.head, i = 0; walker !== null; i++) {
		        fn.call(thisp, walker.value, i, this);
		        walker = walker.next;
		      }
		    };
		    Yallist.prototype.forEachReverse = function (fn, thisp) {
		      thisp = thisp || this;
		      for (var walker = this.tail, i = this.length - 1; walker !== null; i--) {
		        fn.call(thisp, walker.value, i, this);
		        walker = walker.prev;
		      }
		    };
		    Yallist.prototype.get = function (n) {
		      for (var i = 0, walker = this.head; walker !== null && i < n; i++) {
		        walker = walker.next;
		      }
		      if (i === n && walker !== null) {
		        return walker.value;
		      }
		    };
		    Yallist.prototype.getReverse = function (n) {
		      for (var i = 0, walker = this.tail; walker !== null && i < n; i++) {
		        walker = walker.prev;
		      }
		      if (i === n && walker !== null) {
		        return walker.value;
		      }
		    };
		    Yallist.prototype.map = function (fn, thisp) {
		      thisp = thisp || this;
		      var res = new Yallist();
		      for (var walker = this.head; walker !== null;) {
		        res.push(fn.call(thisp, walker.value, this));
		        walker = walker.next;
		      }
		      return res;
		    };
		    Yallist.prototype.mapReverse = function (fn, thisp) {
		      thisp = thisp || this;
		      var res = new Yallist();
		      for (var walker = this.tail; walker !== null;) {
		        res.push(fn.call(thisp, walker.value, this));
		        walker = walker.prev;
		      }
		      return res;
		    };
		    Yallist.prototype.reduce = function (fn, initial) {
		      var acc;
		      var walker = this.head;
		      if (arguments.length > 1) {
		        acc = initial;
		      } else if (this.head) {
		        walker = this.head.next;
		        acc = this.head.value;
		      } else {
		        throw new TypeError('Reduce of empty list with no initial value');
		      }
		      for (var i = 0; walker !== null; i++) {
		        acc = fn(acc, walker.value, i);
		        walker = walker.next;
		      }
		      return acc;
		    };
		    Yallist.prototype.reduceReverse = function (fn, initial) {
		      var acc;
		      var walker = this.tail;
		      if (arguments.length > 1) {
		        acc = initial;
		      } else if (this.tail) {
		        walker = this.tail.prev;
		        acc = this.tail.value;
		      } else {
		        throw new TypeError('Reduce of empty list with no initial value');
		      }
		      for (var i = this.length - 1; walker !== null; i--) {
		        acc = fn(acc, walker.value, i);
		        walker = walker.prev;
		      }
		      return acc;
		    };
		    Yallist.prototype.toArray = function () {
		      var arr = new Array(this.length);
		      for (var i = 0, walker = this.head; walker !== null; i++) {
		        arr[i] = walker.value;
		        walker = walker.next;
		      }
		      return arr;
		    };
		    Yallist.prototype.toArrayReverse = function () {
		      var arr = new Array(this.length);
		      for (var i = 0, walker = this.tail; walker !== null; i++) {
		        arr[i] = walker.value;
		        walker = walker.prev;
		      }
		      return arr;
		    };
		    Yallist.prototype.slice = function (from, to) {
		      to = to || this.length;
		      if (to < 0) {
		        to += this.length;
		      }
		      from = from || 0;
		      if (from < 0) {
		        from += this.length;
		      }
		      var ret = new Yallist();
		      if (to < from || to < 0) {
		        return ret;
		      }
		      if (from < 0) {
		        from = 0;
		      }
		      if (to > this.length) {
		        to = this.length;
		      }
		      for (var i = 0, walker = this.head; walker !== null && i < from; i++) {
		        walker = walker.next;
		      }
		      for (; walker !== null && i < to; i++, walker = walker.next) {
		        ret.push(walker.value);
		      }
		      return ret;
		    };
		    Yallist.prototype.sliceReverse = function (from, to) {
		      to = to || this.length;
		      if (to < 0) {
		        to += this.length;
		      }
		      from = from || 0;
		      if (from < 0) {
		        from += this.length;
		      }
		      var ret = new Yallist();
		      if (to < from || to < 0) {
		        return ret;
		      }
		      if (from < 0) {
		        from = 0;
		      }
		      if (to > this.length) {
		        to = this.length;
		      }
		      for (var i = this.length, walker = this.tail; walker !== null && i > to; i--) {
		        walker = walker.prev;
		      }
		      for (; walker !== null && i > from; i--, walker = walker.prev) {
		        ret.push(walker.value);
		      }
		      return ret;
		    };
		    Yallist.prototype.splice = function (start, deleteCount) {
		      if (start > this.length) {
		        start = this.length - 1;
		      }
		      if (start < 0) {
		        start = this.length + start;
		      }
		      for (var i = 0, walker = this.head; walker !== null && i < start; i++) {
		        walker = walker.next;
		      }
		      var ret = [];
		      for (var i = 0; walker && i < deleteCount; i++) {
		        ret.push(walker.value);
		        walker = this.removeNode(walker);
		      }
		      if (walker === null) {
		        walker = this.tail;
		      }
		      if (walker !== this.head && walker !== this.tail) {
		        walker = walker.prev;
		      }
		      for (var i = 2; i < arguments.length; i++) {
		        walker = insert(this, walker, arguments[i]);
		      }
		      return ret;
		    };
		    Yallist.prototype.reverse = function () {
		      var head = this.head;
		      var tail = this.tail;
		      for (var walker = head; walker !== null; walker = walker.prev) {
		        var p = walker.prev;
		        walker.prev = walker.next;
		        walker.next = p;
		      }
		      this.head = tail;
		      this.tail = head;
		      return this;
		    };
		    function insert(self, node, value) {
		      var inserted = node === self.head ? new Node(value, null, node, self) : new Node(value, node, node.next, self);
		      if (inserted.next === null) {
		        self.tail = inserted;
		      }
		      if (inserted.prev === null) {
		        self.head = inserted;
		      }
		      self.length++;
		      return inserted;
		    }
		    function push(self, item) {
		      self.tail = new Node(item, self.tail, null, self);
		      if (!self.head) {
		        self.head = self.tail;
		      }
		      self.length++;
		    }
		    function unshift(self, item) {
		      self.head = new Node(item, null, self.head, self);
		      if (!self.tail) {
		        self.tail = self.head;
		      }
		      self.length++;
		    }
		    function Node(value, prev, next, list) {
		      if (!(this instanceof Node)) {
		        return new Node(value, prev, next, list);
		      }
		      this.list = list;
		      this.value = value;
		      if (prev) {
		        prev.next = this;
		        this.prev = prev;
		      } else {
		        this.prev = null;
		      }
		      if (next) {
		        next.prev = this;
		        this.next = next;
		      } else {
		        this.next = null;
		      }
		    }
		    try {
		      requireIterator()(Yallist);
		    } catch (er) {}
		    return yallist;
		  }

		  var lruCacheBABEL_8_BREAKINGFalse;
		  var hasRequiredLruCacheBABEL_8_BREAKINGFalse;
		  function requireLruCacheBABEL_8_BREAKINGFalse() {
		    if (hasRequiredLruCacheBABEL_8_BREAKINGFalse) return lruCacheBABEL_8_BREAKINGFalse;
		    hasRequiredLruCacheBABEL_8_BREAKINGFalse = 1;
		    var Yallist = requireYallist();
		    var MAX = Symbol('max');
		    var LENGTH = Symbol('length');
		    var LENGTH_CALCULATOR = Symbol('lengthCalculator');
		    var ALLOW_STALE = Symbol('allowStale');
		    var MAX_AGE = Symbol('maxAge');
		    var DISPOSE = Symbol('dispose');
		    var NO_DISPOSE_ON_SET = Symbol('noDisposeOnSet');
		    var LRU_LIST = Symbol('lruList');
		    var CACHE = Symbol('cache');
		    var UPDATE_AGE_ON_GET = Symbol('updateAgeOnGet');
		    var naiveLength = function naiveLength() {
		      return 1;
		    };
		    var LRUCache = function () {
		      function LRUCache(options) {
		        if (typeof options === 'number') options = {
		          max: options
		        };
		        if (!options) options = {};
		        if (options.max && (typeof options.max !== 'number' || options.max < 0)) throw new TypeError('max must be a non-negative number');
		        this[MAX] = options.max || Infinity;
		        var lc = options.length || naiveLength;
		        this[LENGTH_CALCULATOR] = typeof lc !== 'function' ? naiveLength : lc;
		        this[ALLOW_STALE] = options.stale || false;
		        if (options.maxAge && typeof options.maxAge !== 'number') throw new TypeError('maxAge must be a number');
		        this[MAX_AGE] = options.maxAge || 0;
		        this[DISPOSE] = options.dispose;
		        this[NO_DISPOSE_ON_SET] = options.noDisposeOnSet || false;
		        this[UPDATE_AGE_ON_GET] = options.updateAgeOnGet || false;
		        this.reset();
		      }
		      var _proto = LRUCache.prototype;
		      _proto.rforEach = function rforEach(fn, thisp) {
		        thisp = thisp || this;
		        for (var walker = this[LRU_LIST].tail; walker !== null;) {
		          var prev = walker.prev;
		          forEachStep(this, fn, walker, thisp);
		          walker = prev;
		        }
		      };
		      _proto.forEach = function forEach(fn, thisp) {
		        thisp = thisp || this;
		        for (var walker = this[LRU_LIST].head; walker !== null;) {
		          var next = walker.next;
		          forEachStep(this, fn, walker, thisp);
		          walker = next;
		        }
		      };
		      _proto.keys = function keys() {
		        return this[LRU_LIST].toArray().map(function (k) {
		          return k.key;
		        });
		      };
		      _proto.values = function values() {
		        return this[LRU_LIST].toArray().map(function (k) {
		          return k.value;
		        });
		      };
		      _proto.reset = function reset() {
		        var _this = this;
		        if (this[DISPOSE] && this[LRU_LIST] && this[LRU_LIST].length) {
		          this[LRU_LIST].forEach(function (hit) {
		            return _this[DISPOSE](hit.key, hit.value);
		          });
		        }
		        this[CACHE] = new Map();
		        this[LRU_LIST] = new Yallist();
		        this[LENGTH] = 0;
		      };
		      _proto.dump = function dump() {
		        var _this2 = this;
		        return this[LRU_LIST].map(function (hit) {
		          return isStale(_this2, hit) ? false : {
		            k: hit.key,
		            v: hit.value,
		            e: hit.now + (hit.maxAge || 0)
		          };
		        }).toArray().filter(function (h) {
		          return h;
		        });
		      };
		      _proto.dumpLru = function dumpLru() {
		        return this[LRU_LIST];
		      };
		      _proto.set = function set(key, value, maxAge) {
		        maxAge = maxAge || this[MAX_AGE];
		        if (maxAge && typeof maxAge !== 'number') throw new TypeError('maxAge must be a number');
		        var now = maxAge ? Date.now() : 0;
		        var len = this[LENGTH_CALCULATOR](value, key);
		        if (this[CACHE].has(key)) {
		          if (len > this[MAX]) {
		            _del(this, this[CACHE].get(key));
		            return false;
		          }
		          var node = this[CACHE].get(key);
		          var item = node.value;
		          if (this[DISPOSE]) {
		            if (!this[NO_DISPOSE_ON_SET]) this[DISPOSE](key, item.value);
		          }
		          item.now = now;
		          item.maxAge = maxAge;
		          item.value = value;
		          this[LENGTH] += len - item.length;
		          item.length = len;
		          this.get(key);
		          trim(this);
		          return true;
		        }
		        var hit = new Entry(key, value, len, now, maxAge);
		        if (hit.length > this[MAX]) {
		          if (this[DISPOSE]) this[DISPOSE](key, value);
		          return false;
		        }
		        this[LENGTH] += hit.length;
		        this[LRU_LIST].unshift(hit);
		        this[CACHE].set(key, this[LRU_LIST].head);
		        trim(this);
		        return true;
		      };
		      _proto.has = function has(key) {
		        if (!this[CACHE].has(key)) return false;
		        var hit = this[CACHE].get(key).value;
		        return !isStale(this, hit);
		      };
		      _proto.get = function get(key) {
		        return _get(this, key, true);
		      };
		      _proto.peek = function peek(key) {
		        return _get(this, key, false);
		      };
		      _proto.pop = function pop() {
		        var node = this[LRU_LIST].tail;
		        if (!node) return null;
		        _del(this, node);
		        return node.value;
		      };
		      _proto.del = function del(key) {
		        _del(this, this[CACHE].get(key));
		      };
		      _proto.load = function load(arr) {
		        this.reset();
		        var now = Date.now();
		        for (var l = arr.length - 1; l >= 0; l--) {
		          var hit = arr[l];
		          var expiresAt = hit.e || 0;
		          if (expiresAt === 0) this.set(hit.k, hit.v);else {
		            var maxAge = expiresAt - now;
		            if (maxAge > 0) {
		              this.set(hit.k, hit.v, maxAge);
		            }
		          }
		        }
		      };
		      _proto.prune = function prune() {
		        var _this3 = this;
		        this[CACHE].forEach(function (value, key) {
		          return _get(_this3, key, false);
		        });
		      };
		      return _createClass(LRUCache, [{
		        key: "max",
		        get: function get() {
		          return this[MAX];
		        },
		        set: function set(mL) {
		          if (typeof mL !== 'number' || mL < 0) throw new TypeError('max must be a non-negative number');
		          this[MAX] = mL || Infinity;
		          trim(this);
		        }
		      }, {
		        key: "allowStale",
		        get: function get() {
		          return this[ALLOW_STALE];
		        },
		        set: function set(allowStale) {
		          this[ALLOW_STALE] = !!allowStale;
		        }
		      }, {
		        key: "maxAge",
		        get: function get() {
		          return this[MAX_AGE];
		        },
		        set: function set(mA) {
		          if (typeof mA !== 'number') throw new TypeError('maxAge must be a non-negative number');
		          this[MAX_AGE] = mA;
		          trim(this);
		        }
		      }, {
		        key: "lengthCalculator",
		        get: function get() {
		          return this[LENGTH_CALCULATOR];
		        },
		        set: function set(lC) {
		          var _this4 = this;
		          if (typeof lC !== 'function') lC = naiveLength;
		          if (lC !== this[LENGTH_CALCULATOR]) {
		            this[LENGTH_CALCULATOR] = lC;
		            this[LENGTH] = 0;
		            this[LRU_LIST].forEach(function (hit) {
		              hit.length = _this4[LENGTH_CALCULATOR](hit.value, hit.key);
		              _this4[LENGTH] += hit.length;
		            });
		          }
		          trim(this);
		        }
		      }, {
		        key: "length",
		        get: function get() {
		          return this[LENGTH];
		        }
		      }, {
		        key: "itemCount",
		        get: function get() {
		          return this[LRU_LIST].length;
		        }
		      }]);
		    }();
		    var _get = function _get(self, key, doUse) {
		      var node = self[CACHE].get(key);
		      if (node) {
		        var hit = node.value;
		        if (isStale(self, hit)) {
		          _del(self, node);
		          if (!self[ALLOW_STALE]) return undefined;
		        } else {
		          if (doUse) {
		            if (self[UPDATE_AGE_ON_GET]) node.value.now = Date.now();
		            self[LRU_LIST].unshiftNode(node);
		          }
		        }
		        return hit.value;
		      }
		    };
		    var isStale = function isStale(self, hit) {
		      if (!hit || !hit.maxAge && !self[MAX_AGE]) return false;
		      var diff = Date.now() - hit.now;
		      return hit.maxAge ? diff > hit.maxAge : self[MAX_AGE] && diff > self[MAX_AGE];
		    };
		    var trim = function trim(self) {
		      if (self[LENGTH] > self[MAX]) {
		        for (var walker = self[LRU_LIST].tail; self[LENGTH] > self[MAX] && walker !== null;) {
		          var prev = walker.prev;
		          _del(self, walker);
		          walker = prev;
		        }
		      }
		    };
		    var _del = function _del(self, node) {
		      if (node) {
		        var hit = node.value;
		        if (self[DISPOSE]) self[DISPOSE](hit.key, hit.value);
		        self[LENGTH] -= hit.length;
		        self[CACHE]["delete"](hit.key);
		        self[LRU_LIST].removeNode(node);
		      }
		    };
		    var Entry = _createClass(function Entry(key, value, length, now, maxAge) {
		      this.key = key;
		      this.value = value;
		      this.length = length;
		      this.now = now;
		      this.maxAge = maxAge || 0;
		    });
		    var forEachStep = function forEachStep(self, fn, node, thisp) {
		      var hit = node.value;
		      if (isStale(self, hit)) {
		        _del(self, node);
		        if (!self[ALLOW_STALE]) hit = undefined;
		      }
		      if (hit) fn.call(thisp, hit.value, hit.key, self);
		    };
		    lruCacheBABEL_8_BREAKINGFalse = LRUCache;
		    return lruCacheBABEL_8_BREAKINGFalse;
		  }

		  function bool$6(value) {
		    if (value == null) return false;
		    return value && value !== "false" && value !== "0";
		  }
		  var lruCache = bool$6(browser$1$1.env["BABEL_8_BREAKING"]) ? requireLruCacheBABEL_8_BREAKINGFalse() : requireLruCacheBABEL_8_BREAKINGFalse();

		  function bool$5(value) {
		    if (value == null) return false;
		    return value && value !== "false" && value !== "0";
		  }
		  var semver$8 = bool$5(browser$1$1.env["BABEL_8_BREAKING"]) ? requireSemver$2() : requireSemver$2();

		  var unreleasedLabels = {
		    safari: "tp"
		  };
		  var browserNameMap = {
		    and_chr: "chrome",
		    and_ff: "firefox",
		    android: "android",
		    chrome: "chrome",
		    edge: "edge",
		    firefox: "firefox",
		    ie: "ie",
		    ie_mob: "ie",
		    ios_saf: "ios",
		    node: "node",
		    deno: "deno",
		    op_mob: "opera_mobile",
		    opera: "opera",
		    safari: "safari",
		    samsung: "samsung"
		  };

		  var versionRegExp = /^(\d+|\d+.\d+)$/;
		  var v$5 = new OptionValidator("@babel/helper-compilation-targets");
		  function semverMin(first, second) {
		    return first && semver$8.lt(first, second) ? first : second;
		  }
		  function semverify(version) {
		    if (typeof version === "string" && semver$8.valid(version)) {
		      return version;
		    }
		    v$5.invariant(typeof version === "number" || typeof version === "string" && versionRegExp.test(version), "'" + version + "' is not a valid version");
		    version = version.toString();
		    var pos = 0;
		    var num = 0;
		    while ((pos = version.indexOf(".", pos + 1)) > 0) {
		      num++;
		    }
		    return version + ".0".repeat(2 - num);
		  }
		  function isUnreleasedVersion(version, env) {
		    var unreleasedLabel = unreleasedLabels[env];
		    return !!unreleasedLabel && unreleasedLabel === version.toString().toLowerCase();
		  }
		  function getLowestUnreleased(a, b, env) {
		    var unreleasedLabel = unreleasedLabels[env];
		    if (a === unreleasedLabel) {
		      return b;
		    }
		    if (b === unreleasedLabel) {
		      return a;
		    }
		    return semverMin(a, b);
		  }
		  function getHighestUnreleased(a, b, env) {
		    return getLowestUnreleased(a, b, env) === a ? b : a;
		  }
		  function getLowestImplementedVersion(plugin, environment) {
		    var result = plugin[environment];
		    if (!result && environment === "android") {
		      return plugin.chrome;
		    }
		    return result;
		  }

		  var TargetNames = {
		    node: "node",
		    deno: "deno",
		    chrome: "chrome",
		    opera: "opera",
		    edge: "edge",
		    firefox: "firefox",
		    safari: "safari",
		    ie: "ie",
		    ios: "ios",
		    android: "android",
		    electron: "electron",
		    samsung: "samsung",
		    rhino: "rhino",
		    opera_mobile: "opera_mobile"
		  };

		  function prettifyVersion(version) {
		    if (typeof version !== "string") {
		      return version;
		    }
		    var _semver$parse = semver$8.parse(version),
		      major = _semver$parse.major,
		      minor = _semver$parse.minor,
		      patch = _semver$parse.patch;
		    var parts = [major];
		    if (minor || patch) {
		      parts.push(minor);
		    }
		    if (patch) {
		      parts.push(patch);
		    }
		    return parts.join(".");
		  }
		  function prettifyTargets(targets) {
		    return Object.keys(targets).reduce(function (results, target) {
		      var value = targets[target];
		      var unreleasedLabel = unreleasedLabels[target];
		      if (typeof value === "string" && unreleasedLabel !== value) {
		        value = prettifyVersion(value);
		      }
		      results[target] = value;
		      return results;
		    }, {});
		  }

		  function getInclusionReasons(item, targetVersions, list) {
		    var minVersions = list[item] || {};
		    return Object.keys(targetVersions).reduce(function (result, env) {
		      var minVersion = getLowestImplementedVersion(minVersions, env);
		      var targetVersion = targetVersions[env];
		      if (!minVersion) {
		        result[env] = prettifyVersion(targetVersion);
		      } else {
		        var minIsUnreleased = isUnreleasedVersion(minVersion, env);
		        var targetIsUnreleased = isUnreleasedVersion(targetVersion, env);
		        if (!targetIsUnreleased && (minIsUnreleased || semver$8.lt(targetVersion.toString(), semverify(minVersion)))) {
		          result[env] = prettifyVersion(targetVersion);
		        }
		      }
		      return result;
		    }, {});
		  }

		  var require$$0$6 = {
		  	"transform-unicode-sets-regex": {
		  	chrome: "112",
		  	opera: "98",
		  	edge: "112",
		  	firefox: "116",
		  	safari: "tp",
		  	node: "20",
		  	deno: "1.32",
		  	opera_mobile: "75",
		  	electron: "24.0"
		  },
		  	"bugfix/transform-v8-static-class-fields-redefine-readonly": {
		  	chrome: "98",
		  	opera: "84",
		  	edge: "98",
		  	firefox: "95",
		  	safari: "15",
		  	node: "12",
		  	deno: "1.18",
		  	ios: "15",
		  	samsung: "11",
		  	opera_mobile: "52",
		  	electron: "17.0"
		  },
		  	"bugfix/transform-firefox-class-in-computed-class-key": {
		  	chrome: "74",
		  	opera: "62",
		  	edge: "79",
		  	safari: "14.1",
		  	node: "12",
		  	deno: "1",
		  	ios: "14.5",
		  	samsung: "11",
		  	opera_mobile: "53",
		  	electron: "6.0"
		  },
		  	"transform-class-static-block": {
		  	chrome: "94",
		  	opera: "80",
		  	edge: "94",
		  	firefox: "93",
		  	safari: "16.4",
		  	node: "16.11",
		  	deno: "1.14",
		  	ios: "16.4",
		  	samsung: "17",
		  	opera_mobile: "66",
		  	electron: "15.0"
		  },
		  	"proposal-class-static-block": {
		  	chrome: "94",
		  	opera: "80",
		  	edge: "94",
		  	firefox: "93",
		  	safari: "16.4",
		  	node: "16.11",
		  	deno: "1.14",
		  	ios: "16.4",
		  	samsung: "17",
		  	opera_mobile: "66",
		  	electron: "15.0"
		  },
		  	"transform-private-property-in-object": {
		  	chrome: "91",
		  	opera: "77",
		  	edge: "91",
		  	firefox: "90",
		  	safari: "15",
		  	node: "16.9",
		  	deno: "1.9",
		  	ios: "15",
		  	samsung: "16",
		  	opera_mobile: "64",
		  	electron: "13.0"
		  },
		  	"proposal-private-property-in-object": {
		  	chrome: "91",
		  	opera: "77",
		  	edge: "91",
		  	firefox: "90",
		  	safari: "15",
		  	node: "16.9",
		  	deno: "1.9",
		  	ios: "15",
		  	samsung: "16",
		  	opera_mobile: "64",
		  	electron: "13.0"
		  },
		  	"transform-class-properties": {
		  	chrome: "74",
		  	opera: "62",
		  	edge: "79",
		  	firefox: "90",
		  	safari: "14.1",
		  	node: "12",
		  	deno: "1",
		  	ios: "14.5",
		  	samsung: "11",
		  	opera_mobile: "53",
		  	electron: "6.0"
		  },
		  	"proposal-class-properties": {
		  	chrome: "74",
		  	opera: "62",
		  	edge: "79",
		  	firefox: "90",
		  	safari: "14.1",
		  	node: "12",
		  	deno: "1",
		  	ios: "14.5",
		  	samsung: "11",
		  	opera_mobile: "53",
		  	electron: "6.0"
		  },
		  	"transform-private-methods": {
		  	chrome: "84",
		  	opera: "70",
		  	edge: "84",
		  	firefox: "90",
		  	safari: "15",
		  	node: "14.6",
		  	deno: "1",
		  	ios: "15",
		  	samsung: "14",
		  	opera_mobile: "60",
		  	electron: "10.0"
		  },
		  	"proposal-private-methods": {
		  	chrome: "84",
		  	opera: "70",
		  	edge: "84",
		  	firefox: "90",
		  	safari: "15",
		  	node: "14.6",
		  	deno: "1",
		  	ios: "15",
		  	samsung: "14",
		  	opera_mobile: "60",
		  	electron: "10.0"
		  },
		  	"transform-numeric-separator": {
		  	chrome: "75",
		  	opera: "62",
		  	edge: "79",
		  	firefox: "70",
		  	safari: "13",
		  	node: "12.5",
		  	deno: "1",
		  	ios: "13",
		  	samsung: "11",
		  	rhino: "1.7.14",
		  	opera_mobile: "54",
		  	electron: "6.0"
		  },
		  	"proposal-numeric-separator": {
		  	chrome: "75",
		  	opera: "62",
		  	edge: "79",
		  	firefox: "70",
		  	safari: "13",
		  	node: "12.5",
		  	deno: "1",
		  	ios: "13",
		  	samsung: "11",
		  	rhino: "1.7.14",
		  	opera_mobile: "54",
		  	electron: "6.0"
		  },
		  	"transform-logical-assignment-operators": {
		  	chrome: "85",
		  	opera: "71",
		  	edge: "85",
		  	firefox: "79",
		  	safari: "14",
		  	node: "15",
		  	deno: "1.2",
		  	ios: "14",
		  	samsung: "14",
		  	opera_mobile: "60",
		  	electron: "10.0"
		  },
		  	"proposal-logical-assignment-operators": {
		  	chrome: "85",
		  	opera: "71",
		  	edge: "85",
		  	firefox: "79",
		  	safari: "14",
		  	node: "15",
		  	deno: "1.2",
		  	ios: "14",
		  	samsung: "14",
		  	opera_mobile: "60",
		  	electron: "10.0"
		  },
		  	"transform-nullish-coalescing-operator": {
		  	chrome: "80",
		  	opera: "67",
		  	edge: "80",
		  	firefox: "72",
		  	safari: "13.1",
		  	node: "14",
		  	deno: "1",
		  	ios: "13.4",
		  	samsung: "13",
		  	opera_mobile: "57",
		  	electron: "8.0"
		  },
		  	"proposal-nullish-coalescing-operator": {
		  	chrome: "80",
		  	opera: "67",
		  	edge: "80",
		  	firefox: "72",
		  	safari: "13.1",
		  	node: "14",
		  	deno: "1",
		  	ios: "13.4",
		  	samsung: "13",
		  	opera_mobile: "57",
		  	electron: "8.0"
		  },
		  	"transform-optional-chaining": {
		  	chrome: "91",
		  	opera: "77",
		  	edge: "91",
		  	firefox: "74",
		  	safari: "13.1",
		  	node: "16.9",
		  	deno: "1.9",
		  	ios: "13.4",
		  	samsung: "16",
		  	opera_mobile: "64",
		  	electron: "13.0"
		  },
		  	"proposal-optional-chaining": {
		  	chrome: "91",
		  	opera: "77",
		  	edge: "91",
		  	firefox: "74",
		  	safari: "13.1",
		  	node: "16.9",
		  	deno: "1.9",
		  	ios: "13.4",
		  	samsung: "16",
		  	opera_mobile: "64",
		  	electron: "13.0"
		  },
		  	"transform-json-strings": {
		  	chrome: "66",
		  	opera: "53",
		  	edge: "79",
		  	firefox: "62",
		  	safari: "12",
		  	node: "10",
		  	deno: "1",
		  	ios: "12",
		  	samsung: "9",
		  	rhino: "1.7.14",
		  	opera_mobile: "47",
		  	electron: "3.0"
		  },
		  	"proposal-json-strings": {
		  	chrome: "66",
		  	opera: "53",
		  	edge: "79",
		  	firefox: "62",
		  	safari: "12",
		  	node: "10",
		  	deno: "1",
		  	ios: "12",
		  	samsung: "9",
		  	rhino: "1.7.14",
		  	opera_mobile: "47",
		  	electron: "3.0"
		  },
		  	"transform-optional-catch-binding": {
		  	chrome: "66",
		  	opera: "53",
		  	edge: "79",
		  	firefox: "58",
		  	safari: "11.1",
		  	node: "10",
		  	deno: "1",
		  	ios: "11.3",
		  	samsung: "9",
		  	opera_mobile: "47",
		  	electron: "3.0"
		  },
		  	"proposal-optional-catch-binding": {
		  	chrome: "66",
		  	opera: "53",
		  	edge: "79",
		  	firefox: "58",
		  	safari: "11.1",
		  	node: "10",
		  	deno: "1",
		  	ios: "11.3",
		  	samsung: "9",
		  	opera_mobile: "47",
		  	electron: "3.0"
		  },
		  	"transform-parameters": {
		  	chrome: "49",
		  	opera: "36",
		  	edge: "18",
		  	firefox: "53",
		  	safari: "16.3",
		  	node: "6",
		  	deno: "1",
		  	ios: "16.3",
		  	samsung: "5",
		  	opera_mobile: "36",
		  	electron: "0.37"
		  },
		  	"transform-async-generator-functions": {
		  	chrome: "63",
		  	opera: "50",
		  	edge: "79",
		  	firefox: "57",
		  	safari: "12",
		  	node: "10",
		  	deno: "1",
		  	ios: "12",
		  	samsung: "8",
		  	opera_mobile: "46",
		  	electron: "3.0"
		  },
		  	"proposal-async-generator-functions": {
		  	chrome: "63",
		  	opera: "50",
		  	edge: "79",
		  	firefox: "57",
		  	safari: "12",
		  	node: "10",
		  	deno: "1",
		  	ios: "12",
		  	samsung: "8",
		  	opera_mobile: "46",
		  	electron: "3.0"
		  },
		  	"transform-object-rest-spread": {
		  	chrome: "60",
		  	opera: "47",
		  	edge: "79",
		  	firefox: "55",
		  	safari: "11.1",
		  	node: "8.3",
		  	deno: "1",
		  	ios: "11.3",
		  	samsung: "8",
		  	opera_mobile: "44",
		  	electron: "2.0"
		  },
		  	"proposal-object-rest-spread": {
		  	chrome: "60",
		  	opera: "47",
		  	edge: "79",
		  	firefox: "55",
		  	safari: "11.1",
		  	node: "8.3",
		  	deno: "1",
		  	ios: "11.3",
		  	samsung: "8",
		  	opera_mobile: "44",
		  	electron: "2.0"
		  },
		  	"transform-dotall-regex": {
		  	chrome: "62",
		  	opera: "49",
		  	edge: "79",
		  	firefox: "78",
		  	safari: "11.1",
		  	node: "8.10",
		  	deno: "1",
		  	ios: "11.3",
		  	samsung: "8",
		  	opera_mobile: "46",
		  	electron: "3.0"
		  },
		  	"transform-unicode-property-regex": {
		  	chrome: "64",
		  	opera: "51",
		  	edge: "79",
		  	firefox: "78",
		  	safari: "11.1",
		  	node: "10",
		  	deno: "1",
		  	ios: "11.3",
		  	samsung: "9",
		  	opera_mobile: "47",
		  	electron: "3.0"
		  },
		  	"proposal-unicode-property-regex": {
		  	chrome: "64",
		  	opera: "51",
		  	edge: "79",
		  	firefox: "78",
		  	safari: "11.1",
		  	node: "10",
		  	deno: "1",
		  	ios: "11.3",
		  	samsung: "9",
		  	opera_mobile: "47",
		  	electron: "3.0"
		  },
		  	"transform-named-capturing-groups-regex": {
		  	chrome: "64",
		  	opera: "51",
		  	edge: "79",
		  	firefox: "78",
		  	safari: "11.1",
		  	node: "10",
		  	deno: "1",
		  	ios: "11.3",
		  	samsung: "9",
		  	opera_mobile: "47",
		  	electron: "3.0"
		  },
		  	"transform-async-to-generator": {
		  	chrome: "55",
		  	opera: "42",
		  	edge: "15",
		  	firefox: "52",
		  	safari: "11",
		  	node: "7.6",
		  	deno: "1",
		  	ios: "11",
		  	samsung: "6",
		  	opera_mobile: "42",
		  	electron: "1.6"
		  },
		  	"transform-exponentiation-operator": {
		  	chrome: "52",
		  	opera: "39",
		  	edge: "14",
		  	firefox: "52",
		  	safari: "10.1",
		  	node: "7",
		  	deno: "1",
		  	ios: "10.3",
		  	samsung: "6",
		  	rhino: "1.7.14",
		  	opera_mobile: "41",
		  	electron: "1.3"
		  },
		  	"transform-template-literals": {
		  	chrome: "41",
		  	opera: "28",
		  	edge: "13",
		  	firefox: "34",
		  	safari: "13",
		  	node: "4",
		  	deno: "1",
		  	ios: "13",
		  	samsung: "3.4",
		  	opera_mobile: "28",
		  	electron: "0.21"
		  },
		  	"transform-literals": {
		  	chrome: "44",
		  	opera: "31",
		  	edge: "12",
		  	firefox: "53",
		  	safari: "9",
		  	node: "4",
		  	deno: "1",
		  	ios: "9",
		  	samsung: "4",
		  	opera_mobile: "32",
		  	electron: "0.30"
		  },
		  	"transform-function-name": {
		  	chrome: "51",
		  	opera: "38",
		  	edge: "79",
		  	firefox: "53",
		  	safari: "10",
		  	node: "6.5",
		  	deno: "1",
		  	ios: "10",
		  	samsung: "5",
		  	opera_mobile: "41",
		  	electron: "1.2"
		  },
		  	"transform-arrow-functions": {
		  	chrome: "47",
		  	opera: "34",
		  	edge: "13",
		  	firefox: "43",
		  	safari: "10",
		  	node: "6",
		  	deno: "1",
		  	ios: "10",
		  	samsung: "5",
		  	rhino: "1.7.13",
		  	opera_mobile: "34",
		  	electron: "0.36"
		  },
		  	"transform-block-scoped-functions": {
		  	chrome: "41",
		  	opera: "28",
		  	edge: "12",
		  	firefox: "46",
		  	safari: "10",
		  	node: "4",
		  	deno: "1",
		  	ie: "11",
		  	ios: "10",
		  	samsung: "3.4",
		  	opera_mobile: "28",
		  	electron: "0.21"
		  },
		  	"transform-classes": {
		  	chrome: "46",
		  	opera: "33",
		  	edge: "13",
		  	firefox: "45",
		  	safari: "10",
		  	node: "5",
		  	deno: "1",
		  	ios: "10",
		  	samsung: "5",
		  	opera_mobile: "33",
		  	electron: "0.36"
		  },
		  	"transform-object-super": {
		  	chrome: "46",
		  	opera: "33",
		  	edge: "13",
		  	firefox: "45",
		  	safari: "10",
		  	node: "5",
		  	deno: "1",
		  	ios: "10",
		  	samsung: "5",
		  	opera_mobile: "33",
		  	electron: "0.36"
		  },
		  	"transform-shorthand-properties": {
		  	chrome: "43",
		  	opera: "30",
		  	edge: "12",
		  	firefox: "33",
		  	safari: "9",
		  	node: "4",
		  	deno: "1",
		  	ios: "9",
		  	samsung: "4",
		  	rhino: "1.7.14",
		  	opera_mobile: "30",
		  	electron: "0.27"
		  },
		  	"transform-duplicate-keys": {
		  	chrome: "42",
		  	opera: "29",
		  	edge: "12",
		  	firefox: "34",
		  	safari: "9",
		  	node: "4",
		  	deno: "1",
		  	ios: "9",
		  	samsung: "3.4",
		  	opera_mobile: "29",
		  	electron: "0.25"
		  },
		  	"transform-computed-properties": {
		  	chrome: "44",
		  	opera: "31",
		  	edge: "12",
		  	firefox: "34",
		  	safari: "7.1",
		  	node: "4",
		  	deno: "1",
		  	ios: "8",
		  	samsung: "4",
		  	opera_mobile: "32",
		  	electron: "0.30"
		  },
		  	"transform-for-of": {
		  	chrome: "51",
		  	opera: "38",
		  	edge: "15",
		  	firefox: "53",
		  	safari: "10",
		  	node: "6.5",
		  	deno: "1",
		  	ios: "10",
		  	samsung: "5",
		  	opera_mobile: "41",
		  	electron: "1.2"
		  },
		  	"transform-sticky-regex": {
		  	chrome: "49",
		  	opera: "36",
		  	edge: "13",
		  	firefox: "3",
		  	safari: "10",
		  	node: "6",
		  	deno: "1",
		  	ios: "10",
		  	samsung: "5",
		  	opera_mobile: "36",
		  	electron: "0.37"
		  },
		  	"transform-unicode-escapes": {
		  	chrome: "44",
		  	opera: "31",
		  	edge: "12",
		  	firefox: "53",
		  	safari: "9",
		  	node: "4",
		  	deno: "1",
		  	ios: "9",
		  	samsung: "4",
		  	opera_mobile: "32",
		  	electron: "0.30"
		  },
		  	"transform-unicode-regex": {
		  	chrome: "50",
		  	opera: "37",
		  	edge: "13",
		  	firefox: "46",
		  	safari: "12",
		  	node: "6",
		  	deno: "1",
		  	ios: "12",
		  	samsung: "5",
		  	opera_mobile: "37",
		  	electron: "1.1"
		  },
		  	"transform-spread": {
		  	chrome: "46",
		  	opera: "33",
		  	edge: "13",
		  	firefox: "45",
		  	safari: "10",
		  	node: "5",
		  	deno: "1",
		  	ios: "10",
		  	samsung: "5",
		  	opera_mobile: "33",
		  	electron: "0.36"
		  },
		  	"transform-destructuring": {
		  	chrome: "51",
		  	opera: "38",
		  	edge: "15",
		  	firefox: "53",
		  	safari: "10",
		  	node: "6.5",
		  	deno: "1",
		  	ios: "10",
		  	samsung: "5",
		  	opera_mobile: "41",
		  	electron: "1.2"
		  },
		  	"transform-block-scoping": {
		  	chrome: "50",
		  	opera: "37",
		  	edge: "14",
		  	firefox: "53",
		  	safari: "11",
		  	node: "6",
		  	deno: "1",
		  	ios: "11",
		  	samsung: "5",
		  	opera_mobile: "37",
		  	electron: "1.1"
		  },
		  	"transform-typeof-symbol": {
		  	chrome: "38",
		  	opera: "25",
		  	edge: "12",
		  	firefox: "36",
		  	safari: "9",
		  	node: "0.12",
		  	deno: "1",
		  	ios: "9",
		  	samsung: "3",
		  	rhino: "1.7.13",
		  	opera_mobile: "25",
		  	electron: "0.20"
		  },
		  	"transform-new-target": {
		  	chrome: "46",
		  	opera: "33",
		  	edge: "14",
		  	firefox: "41",
		  	safari: "10",
		  	node: "5",
		  	deno: "1",
		  	ios: "10",
		  	samsung: "5",
		  	opera_mobile: "33",
		  	electron: "0.36"
		  },
		  	"transform-regenerator": {
		  	chrome: "50",
		  	opera: "37",
		  	edge: "13",
		  	firefox: "53",
		  	safari: "10",
		  	node: "6",
		  	deno: "1",
		  	ios: "10",
		  	samsung: "5",
		  	opera_mobile: "37",
		  	electron: "1.1"
		  },
		  	"transform-member-expression-literals": {
		  	chrome: "7",
		  	opera: "12",
		  	edge: "12",
		  	firefox: "2",
		  	safari: "5.1",
		  	node: "0.4",
		  	deno: "1",
		  	ie: "9",
		  	android: "4",
		  	ios: "6",
		  	phantom: "1.9",
		  	samsung: "1",
		  	rhino: "1.7.13",
		  	opera_mobile: "12",
		  	electron: "0.20"
		  },
		  	"transform-property-literals": {
		  	chrome: "7",
		  	opera: "12",
		  	edge: "12",
		  	firefox: "2",
		  	safari: "5.1",
		  	node: "0.4",
		  	deno: "1",
		  	ie: "9",
		  	android: "4",
		  	ios: "6",
		  	phantom: "1.9",
		  	samsung: "1",
		  	rhino: "1.7.13",
		  	opera_mobile: "12",
		  	electron: "0.20"
		  },
		  	"transform-reserved-words": {
		  	chrome: "13",
		  	opera: "10.50",
		  	edge: "12",
		  	firefox: "2",
		  	safari: "3.1",
		  	node: "0.6",
		  	deno: "1",
		  	ie: "9",
		  	android: "4.4",
		  	ios: "6",
		  	phantom: "1.9",
		  	samsung: "1",
		  	rhino: "1.7.13",
		  	opera_mobile: "10.1",
		  	electron: "0.20"
		  },
		  	"transform-export-namespace-from": {
		  	chrome: "72",
		  	deno: "1.0",
		  	edge: "79",
		  	firefox: "80",
		  	node: "13.2",
		  	opera: "60",
		  	opera_mobile: "51",
		  	safari: "14.1",
		  	ios: "14.5",
		  	samsung: "11.0",
		  	android: "72",
		  	electron: "5.0"
		  },
		  	"proposal-export-namespace-from": {
		  	chrome: "72",
		  	deno: "1.0",
		  	edge: "79",
		  	firefox: "80",
		  	node: "13.2",
		  	opera: "60",
		  	opera_mobile: "51",
		  	safari: "14.1",
		  	ios: "14.5",
		  	samsung: "11.0",
		  	android: "72",
		  	electron: "5.0"
		  }
		  };

		  var plugins$1 = require$$0$6;

		  function targetsSupported(target, support) {
		    var targetEnvironments = Object.keys(target);
		    if (targetEnvironments.length === 0) {
		      return false;
		    }
		    var unsupportedEnvironments = targetEnvironments.filter(function (environment) {
		      var lowestImplementedVersion = getLowestImplementedVersion(support, environment);
		      if (!lowestImplementedVersion) {
		        return true;
		      }
		      var lowestTargetedVersion = target[environment];
		      if (isUnreleasedVersion(lowestTargetedVersion, environment)) {
		        return false;
		      }
		      if (isUnreleasedVersion(lowestImplementedVersion, environment)) {
		        return true;
		      }
		      if (!semver$8.valid(lowestTargetedVersion.toString())) {
		        throw new Error("Invalid version passed for target \"" + environment + "\": \"" + lowestTargetedVersion + "\". " + "Versions must be in semver format (major.minor.patch)");
		      }
		      return semver$8.gt(semverify(lowestImplementedVersion), lowestTargetedVersion.toString());
		    });
		    return unsupportedEnvironments.length === 0;
		  }
		  function isRequired(name, targets, _temp) {
		    var _ref = _temp === void 0 ? {} : _temp,
		      _ref$compatData = _ref.compatData,
		      compatData = _ref$compatData === void 0 ? plugins$1 : _ref$compatData,
		      includes = _ref.includes,
		      excludes = _ref.excludes;
		    if (excludes != null && excludes.has(name)) return false;
		    if (includes != null && includes.has(name)) return true;
		    return !targetsSupported(targets, compatData[name]);
		  }
		  function filterItems(list, includes, excludes, targets, defaultIncludes, defaultExcludes, pluginSyntaxMap) {
		    var result = new Set();
		    var options = {
		      compatData: list,
		      includes: includes,
		      excludes: excludes
		    };
		    for (var item in list) {
		      if (isRequired(item, targets, options)) {
		        result.add(item);
		      } else if (pluginSyntaxMap) {
		        var shippedProposalsSyntax = pluginSyntaxMap.get(item);
		        if (shippedProposalsSyntax) {
		          result.add(shippedProposalsSyntax);
		        }
		      }
		    }
		    defaultIncludes == null || defaultIncludes.forEach(function (item) {
		      return !excludes.has(item) && result.add(item);
		    });
		    defaultExcludes == null || defaultExcludes.forEach(function (item) {
		      return !includes.has(item) && result["delete"](item);
		    });
		    return result;
		  }

		  var ESM_SUPPORT = nativeModules["es6.module"];
		  var v$4 = new OptionValidator("@babel/helper-compilation-targets");
		  function validateTargetNames(targets) {
		    var validTargets = Object.keys(TargetNames);
		    for (var _i = 0, _Object$keys = Object.keys(targets); _i < _Object$keys.length; _i++) {
		      var target = _Object$keys[_i];
		      if (!(target in TargetNames)) {
		        throw new Error(v$4.formatMessage("'" + target + "' is not a valid target\n- Did you mean '" + findSuggestion(target, validTargets) + "'?"));
		      }
		    }
		    return targets;
		  }
		  function isBrowsersQueryValid(browsers) {
		    return typeof browsers === "string" || Array.isArray(browsers) && browsers.every(function (b) {
		      return typeof b === "string";
		    });
		  }
		  function validateBrowsers(browsers) {
		    v$4.invariant(browsers === undefined || isBrowsersQueryValid(browsers), "'" + String(browsers) + "' is not a valid browserslist query");
		    return browsers;
		  }
		  function getLowestVersions(browsers) {
		    return browsers.reduce(function (all, browser) {
		      var _ref = browser.split(" "),
		        _ref2 = _slicedToArray(_ref, 2),
		        browserName = _ref2[0],
		        browserVersion = _ref2[1];
		      var target = browserNameMap[browserName];
		      if (!target) {
		        return all;
		      }
		      try {
		        var splitVersion = browserVersion.split("-")[0].toLowerCase();
		        var isSplitUnreleased = isUnreleasedVersion(splitVersion, target);
		        if (!all[target]) {
		          all[target] = isSplitUnreleased ? splitVersion : semverify(splitVersion);
		          return all;
		        }
		        var version = all[target];
		        var isUnreleased = isUnreleasedVersion(version, target);
		        if (isUnreleased && isSplitUnreleased) {
		          all[target] = getLowestUnreleased(version, splitVersion, target);
		        } else if (isUnreleased) {
		          all[target] = semverify(splitVersion);
		        } else if (!isUnreleased && !isSplitUnreleased) {
		          var parsedBrowserVersion = semverify(splitVersion);
		          all[target] = semverMin(version, parsedBrowserVersion);
		        }
		      } catch (e) {}
		      return all;
		    }, {});
		  }
		  function outputDecimalWarning(decimalTargets) {
		    if (!decimalTargets.length) {
		      return;
		    }
		    console.warn("Warning, the following targets are using a decimal version:\n");
		    decimalTargets.forEach(function (_ref3) {
		      var target = _ref3.target,
		        value = _ref3.value;
		      return console.warn("  " + target + ": " + value);
		    });
		    console.warn("\nWe recommend using a string for minor/patch versions to avoid numbers like 6.10\ngetting parsed as 6.1, which can lead to unexpected behavior.\n");
		  }
		  function semverifyTarget(target, value) {
		    try {
		      return semverify(value);
		    } catch (error) {
		      throw new Error(v$4.formatMessage("'" + value + "' is not a valid value for 'targets." + target + "'."));
		    }
		  }
		  function nodeTargetParser(value) {
		    var parsed = value === true || value === "current" ? browser$1$1.versions.node : semverifyTarget("node", value);
		    return ["node", parsed];
		  }
		  function defaultTargetParser(target, value) {
		    var version = isUnreleasedVersion(value, target) ? value.toLowerCase() : semverifyTarget(target, value);
		    return [target, version];
		  }
		  function generateTargets(inputTargets) {
		    var input = Object.assign({}, inputTargets);
		    delete input.esmodules;
		    delete input.browsers;
		    return input;
		  }
		  function resolveTargets$1(queries, env) {
		    var resolved = browserslist_1(queries, {
		      mobileToDesktop: true,
		      env: env
		    });
		    return getLowestVersions(resolved);
		  }
		  var targetsCache = new lruCache({
		    max: 64
		  });
		  function resolveTargetsCached(queries, env) {
		    var cacheKey = typeof queries === "string" ? queries : queries.join() + env;
		    var cached = targetsCache.get(cacheKey);
		    if (!cached) {
		      cached = resolveTargets$1(queries, env);
		      targetsCache.set(cacheKey, cached);
		    }
		    return Object.assign({}, cached);
		  }
		  function getTargets$1(inputTargets, options) {
		    var _browsers, _browsers2;
		    if (inputTargets === void 0) {
		      inputTargets = {};
		    }
		    if (options === void 0) {
		      options = {};
		    }
		    var _inputTargets = inputTargets,
		      browsers = _inputTargets.browsers,
		      esmodules = _inputTargets.esmodules;
		    var _options = options,
		      _options$configPath = _options.configPath,
		      configPath = _options$configPath === void 0 ? "." : _options$configPath;
		    validateBrowsers(browsers);
		    var input = generateTargets(inputTargets);
		    var targets = validateTargetNames(input);
		    var shouldParseBrowsers = !!browsers;
		    var hasTargets = shouldParseBrowsers || Object.keys(targets).length > 0;
		    var shouldSearchForConfig = !options.ignoreBrowserslistConfig && !hasTargets;
		    if (!browsers && shouldSearchForConfig) {
		      browsers = browserslist_1.loadConfig({
		        config: options.configFile,
		        path: configPath,
		        env: options.browserslistEnv
		      });
		      if (browsers == null) {
		        {
		          browsers = [];
		        }
		      }
		    }
		    if (esmodules && (esmodules !== "intersect" || !((_browsers = browsers) != null && _browsers.length))) {
		      browsers = Object.keys(ESM_SUPPORT).map(function (browser) {
		        return browser + " >= " + ESM_SUPPORT[browser];
		      }).join(", ");
		      esmodules = false;
		    }
		    if ((_browsers2 = browsers) != null && _browsers2.length) {
		      var queryBrowsers = resolveTargetsCached(browsers, options.browserslistEnv);
		      if (esmodules === "intersect") {
		        for (var _i2 = 0, _arr = Object.keys(queryBrowsers); _i2 < _arr.length; _i2++) {
		          var browser = _arr[_i2];
		          if (browser !== "deno" && browser !== "ie") {
		            var esmSupportVersion = ESM_SUPPORT[browser === "opera_mobile" ? "op_mob" : browser];
		            if (esmSupportVersion) {
		              var version = queryBrowsers[browser];
		              queryBrowsers[browser] = getHighestUnreleased(version, semverify(esmSupportVersion), browser);
		            } else {
		              delete queryBrowsers[browser];
		            }
		          } else {
		            delete queryBrowsers[browser];
		          }
		        }
		      }
		      targets = Object.assign(queryBrowsers, targets);
		    }
		    var result = {};
		    var decimalWarnings = [];
		    for (var _i3 = 0, _arr2 = Object.keys(targets).sort(); _i3 < _arr2.length; _i3++) {
		      var target = _arr2[_i3];
		      var value = targets[target];
		      if (typeof value === "number" && value % 1 !== 0) {
		        decimalWarnings.push({
		          target: target,
		          value: value
		        });
		      }
		      var _ref4 = target === "node" ? nodeTargetParser(value) : defaultTargetParser(target, value),
		        _ref5 = _slicedToArray(_ref4, 2),
		        parsedTarget = _ref5[0],
		        parsedValue = _ref5[1];
		      if (parsedValue) {
		        result[parsedTarget] = parsedValue;
		      }
		    }
		    outputDecimalWarning(decimalWarnings);
		    return result;
		  }

		  var src = /*#__PURE__*/Object.freeze({
		    __proto__: null,
		    TargetNames: TargetNames,
		    default: getTargets$1,
		    filterItems: filterItems,
		    getInclusionReasons: getInclusionReasons,
		    isBrowsersQueryValid: isBrowsersQueryValid,
		    isRequired: isRequired,
		    prettifyTargets: prettifyTargets,
		    unreleasedLabels: unreleasedLabels
		  });

		  function resolveBrowserslistConfigFile(browserslistConfigFile, configFilePath) {
		    return undefined;
		  }
		  function resolveTargets(options, root) {
		    var optTargets = options.targets;
		    var targets;
		    if (typeof optTargets === "string" || Array.isArray(optTargets)) {
		      targets = {
		        browsers: optTargets
		      };
		    } else if (optTargets) {
		      if ("esmodules" in optTargets) {
		        targets = Object.assign({}, optTargets, {
		          esmodules: "intersect"
		        });
		      } else {
		        targets = optTargets;
		      }
		    }
		    return getTargets$1(targets, {
		      ignoreBrowserslistConfig: true,
		      browserslistEnv: options.browserslistEnv
		    });
		  }

		  var _marked$7 = _regeneratorRuntime().mark(handlerOf),
		    _marked2$5 = _regeneratorRuntime().mark(createPresetDescriptors),
		    _marked3$2 = _regeneratorRuntime().mark(createPluginDescriptors),
		    _marked4$1 = _regeneratorRuntime().mark(createDescriptors);
		  function isEqualDescriptor(a, b) {
		    var _a$file, _b$file, _a$file2, _b$file2;
		    return a.name === b.name && a.value === b.value && a.options === b.options && a.dirname === b.dirname && a.alias === b.alias && a.ownPass === b.ownPass && ((_a$file = a.file) == null ? void 0 : _a$file.request) === ((_b$file = b.file) == null ? void 0 : _b$file.request) && ((_a$file2 = a.file) == null ? void 0 : _a$file2.resolved) === ((_b$file2 = b.file) == null ? void 0 : _b$file2.resolved);
		  }
		  function handlerOf(value) {
		    return _regeneratorRuntime().wrap(function handlerOf$(_context) {
		      while (1) switch (_context.prev = _context.next) {
		        case 0:
		          return _context.abrupt("return", value);
		        case 1:
		        case "end":
		          return _context.stop();
		      }
		    }, _marked$7);
		  }
		  function optionsWithResolvedBrowserslistConfigFile(options, dirname) {
		    if (typeof options.browserslistConfigFile === "string") {
		      options.browserslistConfigFile = resolveBrowserslistConfigFile(options.browserslistConfigFile);
		    }
		    return options;
		  }
		  function createCachedDescriptors(dirname, options, alias) {
		    var plugins = options.plugins,
		      presets = options.presets,
		      passPerPreset = options.passPerPreset;
		    return {
		      options: optionsWithResolvedBrowserslistConfigFile(options),
		      plugins: plugins ? function () {
		        return createCachedPluginDescriptors(plugins, dirname)(alias);
		      } : function () {
		        return handlerOf([]);
		      },
		      presets: presets ? function () {
		        return createCachedPresetDescriptors(presets, dirname)(alias)(!!passPerPreset);
		      } : function () {
		        return handlerOf([]);
		      }
		    };
		  }
		  function createUncachedDescriptors(dirname, options, alias) {
		    return {
		      options: optionsWithResolvedBrowserslistConfigFile(options),
		      plugins: once(function () {
		        return createPluginDescriptors(options.plugins || [], dirname, alias);
		      }),
		      presets: once(function () {
		        return createPresetDescriptors(options.presets || [], dirname, alias, !!options.passPerPreset);
		      })
		    };
		  }
		  var PRESET_DESCRIPTOR_CACHE = new WeakMap();
		  var createCachedPresetDescriptors = makeWeakCacheSync(function (items, cache) {
		    var dirname = cache.using(function (dir) {
		      return dir;
		    });
		    return makeStrongCacheSync(function (alias) {
		      return makeStrongCache(_regeneratorRuntime().mark(function _callee(passPerPreset) {
		        var descriptors;
		        return _regeneratorRuntime().wrap(function _callee$(_context2) {
		          while (1) switch (_context2.prev = _context2.next) {
		            case 0:
		              return _context2.delegateYield(createPresetDescriptors(items, dirname, alias, passPerPreset), "t0", 1);
		            case 1:
		              descriptors = _context2.t0;
		              return _context2.abrupt("return", descriptors.map(function (desc) {
		                return loadCachedDescriptor(PRESET_DESCRIPTOR_CACHE, desc);
		              }));
		            case 3:
		            case "end":
		              return _context2.stop();
		          }
		        }, _callee);
		      }));
		    });
		  });
		  var PLUGIN_DESCRIPTOR_CACHE = new WeakMap();
		  var createCachedPluginDescriptors = makeWeakCacheSync(function (items, cache) {
		    var dirname = cache.using(function (dir) {
		      return dir;
		    });
		    return makeStrongCache(_regeneratorRuntime().mark(function _callee2(alias) {
		      var descriptors;
		      return _regeneratorRuntime().wrap(function _callee2$(_context3) {
		        while (1) switch (_context3.prev = _context3.next) {
		          case 0:
		            return _context3.delegateYield(createPluginDescriptors(items, dirname, alias), "t0", 1);
		          case 1:
		            descriptors = _context3.t0;
		            return _context3.abrupt("return", descriptors.map(function (desc) {
		              return loadCachedDescriptor(PLUGIN_DESCRIPTOR_CACHE, desc);
		            }));
		          case 3:
		          case "end":
		            return _context3.stop();
		        }
		      }, _callee2);
		    }));
		  });
		  var DEFAULT_OPTIONS = {};
		  function loadCachedDescriptor(cache, desc) {
		    var value = desc.value,
		      _desc$options = desc.options,
		      options = _desc$options === void 0 ? DEFAULT_OPTIONS : _desc$options;
		    if (options === false) return desc;
		    var cacheByOptions = cache.get(value);
		    if (!cacheByOptions) {
		      cacheByOptions = new WeakMap();
		      cache.set(value, cacheByOptions);
		    }
		    var possibilities = cacheByOptions.get(options);
		    if (!possibilities) {
		      possibilities = [];
		      cacheByOptions.set(options, possibilities);
		    }
		    if (possibilities.indexOf(desc) === -1) {
		      var matches = possibilities.filter(function (possibility) {
		        return isEqualDescriptor(possibility, desc);
		      });
		      if (matches.length > 0) {
		        return matches[0];
		      }
		      possibilities.push(desc);
		    }
		    return desc;
		  }
		  function createPresetDescriptors(items, dirname, alias, passPerPreset) {
		    return _regeneratorRuntime().wrap(function createPresetDescriptors$(_context4) {
		      while (1) switch (_context4.prev = _context4.next) {
		        case 0:
		          return _context4.delegateYield(createDescriptors("preset", items, dirname, alias, passPerPreset), "t0", 1);
		        case 1:
		          return _context4.abrupt("return", _context4.t0);
		        case 2:
		        case "end":
		          return _context4.stop();
		      }
		    }, _marked2$5);
		  }
		  function createPluginDescriptors(items, dirname, alias) {
		    return _regeneratorRuntime().wrap(function createPluginDescriptors$(_context5) {
		      while (1) switch (_context5.prev = _context5.next) {
		        case 0:
		          return _context5.delegateYield(createDescriptors("plugin", items, dirname, alias), "t0", 1);
		        case 1:
		          return _context5.abrupt("return", _context5.t0);
		        case 2:
		        case "end":
		          return _context5.stop();
		      }
		    }, _marked3$2);
		  }
		  function createDescriptors(type, items, dirname, alias, ownPass) {
		    var descriptors;
		    return _regeneratorRuntime().wrap(function createDescriptors$(_context6) {
		      while (1) switch (_context6.prev = _context6.next) {
		        case 0:
		          return _context6.delegateYield(gensync.all(items.map(function (item, index) {
		            return createDescriptor(item, dirname, {
		              type: type,
		              alias: alias + "$" + index,
		              ownPass: !!ownPass
		            });
		          })), "t0", 1);
		        case 1:
		          descriptors = _context6.t0;
		          assertNoDuplicates(descriptors);
		          return _context6.abrupt("return", descriptors);
		        case 4:
		        case "end":
		          return _context6.stop();
		      }
		    }, _marked4$1);
		  }
		  function createDescriptor(pair, dirname, _ref) {
		    var type = _ref.type,
		      alias = _ref.alias,
		      ownPass = _ref.ownPass;
		    return _regeneratorRuntime().mark(function _callee3() {
		      var desc, name, options, value, _value, _value2, _value3, _value4, file, filepath, resolver, request, _yield$resolver;
		      return _regeneratorRuntime().wrap(function _callee3$(_context7) {
		        while (1) switch (_context7.prev = _context7.next) {
		          case 0:
		            desc = getItemDescriptor(pair);
		            if (!desc) {
		              _context7.next = 3;
		              break;
		            }
		            return _context7.abrupt("return", desc);
		          case 3:
		            value = pair;
		            if (Array.isArray(value)) {
		              if (value.length === 3) {
		                _value = value;
		                _value2 = _slicedToArray(_value, 3);
		                value = _value2[0];
		                options = _value2[1];
		                name = _value2[2];
		              } else {
		                _value3 = value;
		                _value4 = _slicedToArray(_value3, 2);
		                value = _value4[0];
		                options = _value4[1];
		              }
		            }
		            file = undefined;
		            filepath = null;
		            if (!(typeof value === "string")) {
		              _context7.next = 17;
		              break;
		            }
		            if (!(typeof type !== "string")) {
		              _context7.next = 10;
		              break;
		            }
		            throw new Error("To resolve a string-based item, the type of item must be given");
		          case 10:
		            resolver = type === "plugin" ? loadPlugin : loadPreset;
		            request = value;
		            return _context7.delegateYield(resolver(value, dirname), "t0", 13);
		          case 13:
		            _yield$resolver = _context7.t0;
		            filepath = _yield$resolver.filepath;
		            value = _yield$resolver.value;
		            file = {
		              request: request,
		              resolved: filepath
		            };
		          case 17:
		            if (value) {
		              _context7.next = 19;
		              break;
		            }
		            throw new Error("Unexpected falsy value: " + String(value));
		          case 19:
		            if (!(typeof value === "object" && value.__esModule)) {
		              _context7.next = 25;
		              break;
		            }
		            if (!value["default"]) {
		              _context7.next = 24;
		              break;
		            }
		            value = value["default"];
		            _context7.next = 25;
		            break;
		          case 24:
		            throw new Error("Must export a default export when using ES6 modules.");
		          case 25:
		            if (!(typeof value !== "object" && typeof value !== "function")) {
		              _context7.next = 27;
		              break;
		            }
		            throw new Error("Unsupported format: " + typeof value + ". Expected an object or a function.");
		          case 27:
		            if (!(filepath !== null && typeof value === "object" && value)) {
		              _context7.next = 29;
		              break;
		            }
		            throw new Error("Plugin/Preset files are not allowed to export objects, only functions. In " + filepath);
		          case 29:
		            return _context7.abrupt("return", {
		              name: name,
		              alias: filepath || alias,
		              value: value,
		              options: options,
		              dirname: dirname,
		              ownPass: ownPass,
		              file: file
		            });
		          case 30:
		          case "end":
		            return _context7.stop();
		        }
		      }, _callee3);
		    })();
		  }
		  function assertNoDuplicates(items) {
		    var map = new Map();
		    var _loop = function _loop() {
		      var item = _step.value;
		      if (typeof item.value !== "function") return 1;
		      var nameMap = map.get(item.value);
		      if (!nameMap) {
		        nameMap = new Set();
		        map.set(item.value, nameMap);
		      }
		      if (nameMap.has(item.name)) {
		        var conflicts = items.filter(function (i) {
		          return i.value === item.value;
		        });
		        throw new Error(["Duplicate plugin/preset detected.", "If you'd like to use two separate instances of a plugin,", "they need separate names, e.g.", "", "  plugins: [", "    ['some-plugin', {}],", "    ['some-plugin', {}, 'some unique name'],", "  ]", "", "Duplicates detected are:", "" + JSON.stringify(conflicts, null, 2)].join("\n"));
		      }
		      nameMap.add(item.name);
		    };
		    for (var _iterator = _createForOfIteratorHelperLoose(items), _step; !(_step = _iterator()).done;) {
		      if (_loop()) continue;
		    }
		  }

		  function createItemFromDescriptor(desc) {
		    return new ConfigItem(desc);
		  }
		  function createConfigItem$1(value, _temp) {
		    var _ref = _temp === void 0 ? {} : _temp,
		      _ref$dirname = _ref.dirname,
		      dirname = _ref$dirname === void 0 ? "." : _ref$dirname,
		      type = _ref.type;
		    return _regeneratorRuntime().mark(function _callee() {
		      var descriptor;
		      return _regeneratorRuntime().wrap(function _callee$(_context) {
		        while (1) switch (_context.prev = _context.next) {
		          case 0:
		            return _context.delegateYield(createDescriptor(value, path$1.resolve(dirname), {
		              type: type,
		              alias: "programmatic item"
		            }), "t0", 1);
		          case 1:
		            descriptor = _context.t0;
		            return _context.abrupt("return", createItemFromDescriptor(descriptor));
		          case 3:
		          case "end":
		            return _context.stop();
		        }
		      }, _callee);
		    })();
		  }
		  var CONFIG_ITEM_BRAND = Symbol["for"]("@babel/core@7 - ConfigItem");
		  function getItemDescriptor(item) {
		    if (item != null && item[CONFIG_ITEM_BRAND]) {
		      return item._descriptor;
		    }
		    return undefined;
		  }
		  var ConfigItem = _createClass(function ConfigItem(descriptor) {
		    this._descriptor = void 0;
		    this[CONFIG_ITEM_BRAND] = true;
		    this.value = void 0;
		    this.options = void 0;
		    this.dirname = void 0;
		    this.name = void 0;
		    this.file = void 0;
		    this._descriptor = descriptor;
		    Object.defineProperty(this, "_descriptor", {
		      enumerable: false
		    });
		    Object.defineProperty(this, CONFIG_ITEM_BRAND, {
		      enumerable: false
		    });
		    this.value = this._descriptor.value;
		    this.options = this._descriptor.options;
		    this.dirname = this._descriptor.dirname;
		    this.name = this._descriptor.name;
		    this.file = this._descriptor.file ? {
		      request: this._descriptor.file.request,
		      resolved: this._descriptor.file.resolved
		    } : undefined;
		    Object.freeze(this);
		  });
		  Object.freeze(ConfigItem.prototype);

		  var removed = {
		    auxiliaryComment: {
		      message: "Use `auxiliaryCommentBefore` or `auxiliaryCommentAfter`"
		    },
		    blacklist: {
		      message: "Put the specific transforms you want in the `plugins` option"
		    },
		    breakConfig: {
		      message: "This is not a necessary option in Babel 6"
		    },
		    experimental: {
		      message: "Put the specific transforms you want in the `plugins` option"
		    },
		    externalHelpers: {
		      message: "Use the `external-helpers` plugin instead. " + "Check out http://babeljs.io/docs/plugins/external-helpers/"
		    },
		    extra: {
		      message: ""
		    },
		    jsxPragma: {
		      message: "use the `pragma` option in the `react-jsx` plugin. " + "Check out http://babeljs.io/docs/plugins/transform-react-jsx/"
		    },
		    loose: {
		      message: "Specify the `loose` option for the relevant plugin you are using " + "or use a preset that sets the option."
		    },
		    metadataUsedHelpers: {
		      message: "Not required anymore as this is enabled by default"
		    },
		    modules: {
		      message: "Use the corresponding module transform plugin in the `plugins` option. " + "Check out http://babeljs.io/docs/plugins/#modules"
		    },
		    nonStandard: {
		      message: "Use the `react-jsx` and `flow-strip-types` plugins to support JSX and Flow. " + "Also check out the react preset http://babeljs.io/docs/plugins/preset-react/"
		    },
		    optional: {
		      message: "Put the specific transforms you want in the `plugins` option"
		    },
		    sourceMapName: {
		      message: "The `sourceMapName` option has been removed because it makes more sense for the " + "tooling that calls Babel to assign `map.file` themselves."
		    },
		    stage: {
		      message: "Check out the corresponding stage-x presets http://babeljs.io/docs/plugins/#presets"
		    },
		    whitelist: {
		      message: "Put the specific transforms you want in the `plugins` option"
		    },
		    resolveModuleSource: {
		      version: 6,
		      message: "Use `babel-plugin-module-resolver@3`'s 'resolvePath' options"
		    },
		    metadata: {
		      version: 6,
		      message: "Generated plugin metadata is always included in the output result"
		    },
		    sourceMapTarget: {
		      version: 6,
		      message: "The `sourceMapTarget` option has been removed because it makes more sense for the tooling " + "that calls Babel to assign `map.file` themselves."
		    }
		  };

		  function msg(loc) {
		    switch (loc.type) {
		      case "root":
		        return "";
		      case "env":
		        return msg(loc.parent) + ".env[\"" + loc.name + "\"]";
		      case "overrides":
		        return msg(loc.parent) + ".overrides[" + loc.index + "]";
		      case "option":
		        return msg(loc.parent) + "." + loc.name;
		      case "access":
		        return msg(loc.parent) + "[" + JSON.stringify(loc.name) + "]";
		      default:
		        throw new Error("Assertion failure: Unknown type " + loc.type);
		    }
		  }
		  function access(loc, name) {
		    return {
		      type: "access",
		      name: name,
		      parent: loc
		    };
		  }
		  function assertRootMode(loc, value) {
		    if (value !== undefined && value !== "root" && value !== "upward" && value !== "upward-optional") {
		      throw new Error(msg(loc) + " must be a \"root\", \"upward\", \"upward-optional\" or undefined");
		    }
		    return value;
		  }
		  function assertSourceMaps(loc, value) {
		    if (value !== undefined && typeof value !== "boolean" && value !== "inline" && value !== "both") {
		      throw new Error(msg(loc) + " must be a boolean, \"inline\", \"both\", or undefined");
		    }
		    return value;
		  }
		  function assertCompact(loc, value) {
		    if (value !== undefined && typeof value !== "boolean" && value !== "auto") {
		      throw new Error(msg(loc) + " must be a boolean, \"auto\", or undefined");
		    }
		    return value;
		  }
		  function assertSourceType(loc, value) {
		    if (value !== undefined && value !== "module" && value !== "script" && value !== "unambiguous") {
		      throw new Error(msg(loc) + " must be \"module\", \"script\", \"unambiguous\", or undefined");
		    }
		    return value;
		  }
		  function assertCallerMetadata(loc, value) {
		    var obj = assertObject(loc, value);
		    if (obj) {
		      if (typeof obj.name !== "string") {
		        throw new Error(msg(loc) + " set but does not contain \"name\" property string");
		      }
		      for (var _i = 0, _Object$keys = Object.keys(obj); _i < _Object$keys.length; _i++) {
		        var prop = _Object$keys[_i];
		        var propLoc = access(loc, prop);
		        var _value = obj[prop];
		        if (_value != null && typeof _value !== "boolean" && typeof _value !== "string" && typeof _value !== "number") {
		          throw new Error(msg(propLoc) + " must be null, undefined, a boolean, a string, or a number.");
		        }
		      }
		    }
		    return value;
		  }
		  function assertInputSourceMap(loc, value) {
		    if (value !== undefined && typeof value !== "boolean" && (typeof value !== "object" || !value)) {
		      throw new Error(msg(loc) + " must be a boolean, object, or undefined");
		    }
		    return value;
		  }
		  function assertString(loc, value) {
		    if (value !== undefined && typeof value !== "string") {
		      throw new Error(msg(loc) + " must be a string, or undefined");
		    }
		    return value;
		  }
		  function assertFunction(loc, value) {
		    if (value !== undefined && typeof value !== "function") {
		      throw new Error(msg(loc) + " must be a function, or undefined");
		    }
		    return value;
		  }
		  function assertBoolean(loc, value) {
		    if (value !== undefined && typeof value !== "boolean") {
		      throw new Error(msg(loc) + " must be a boolean, or undefined");
		    }
		    return value;
		  }
		  function assertObject(loc, value) {
		    if (value !== undefined && (typeof value !== "object" || Array.isArray(value) || !value)) {
		      throw new Error(msg(loc) + " must be an object, or undefined");
		    }
		    return value;
		  }
		  function assertArray(loc, value) {
		    if (value != null && !Array.isArray(value)) {
		      throw new Error(msg(loc) + " must be an array, or undefined");
		    }
		    return value;
		  }
		  function assertIgnoreList(loc, value) {
		    var arr = assertArray(loc, value);
		    arr == null || arr.forEach(function (item, i) {
		      return assertIgnoreItem(access(loc, i), item);
		    });
		    return arr;
		  }
		  function assertIgnoreItem(loc, value) {
		    if (typeof value !== "string" && typeof value !== "function" && !(value instanceof RegExp)) {
		      throw new Error(msg(loc) + " must be an array of string/Function/RegExp values, or undefined");
		    }
		    return value;
		  }
		  function assertConfigApplicableTest(loc, value) {
		    if (value === undefined) {
		      return value;
		    }
		    if (Array.isArray(value)) {
		      value.forEach(function (item, i) {
		        if (!checkValidTest(item)) {
		          throw new Error(msg(access(loc, i)) + " must be a string/Function/RegExp.");
		        }
		      });
		    } else if (!checkValidTest(value)) {
		      throw new Error(msg(loc) + " must be a string/Function/RegExp, or an array of those");
		    }
		    return value;
		  }
		  function checkValidTest(value) {
		    return typeof value === "string" || typeof value === "function" || value instanceof RegExp;
		  }
		  function assertConfigFileSearch(loc, value) {
		    if (value !== undefined && typeof value !== "boolean" && typeof value !== "string") {
		      throw new Error(msg(loc) + " must be a undefined, a boolean, a string, " + ("got " + JSON.stringify(value)));
		    }
		    return value;
		  }
		  function assertBabelrcSearch(loc, value) {
		    if (value === undefined || typeof value === "boolean") {
		      return value;
		    }
		    if (Array.isArray(value)) {
		      value.forEach(function (item, i) {
		        if (!checkValidTest(item)) {
		          throw new Error(msg(access(loc, i)) + " must be a string/Function/RegExp.");
		        }
		      });
		    } else if (!checkValidTest(value)) {
		      throw new Error(msg(loc) + " must be a undefined, a boolean, a string/Function/RegExp " + ("or an array of those, got " + JSON.stringify(value)));
		    }
		    return value;
		  }
		  function assertPluginList(loc, value) {
		    var arr = assertArray(loc, value);
		    if (arr) {
		      arr.forEach(function (item, i) {
		        return assertPluginItem(access(loc, i), item);
		      });
		    }
		    return arr;
		  }
		  function assertPluginItem(loc, value) {
		    if (Array.isArray(value)) {
		      if (value.length === 0) {
		        throw new Error(msg(loc) + " must include an object");
		      }
		      if (value.length > 3) {
		        throw new Error(msg(loc) + " may only be a two-tuple or three-tuple");
		      }
		      assertPluginTarget(access(loc, 0), value[0]);
		      if (value.length > 1) {
		        var opts = value[1];
		        if (opts !== undefined && opts !== false && (typeof opts !== "object" || Array.isArray(opts) || opts === null)) {
		          throw new Error(msg(access(loc, 1)) + " must be an object, false, or undefined");
		        }
		      }
		      if (value.length === 3) {
		        var _name = value[2];
		        if (_name !== undefined && typeof _name !== "string") {
		          throw new Error(msg(access(loc, 2)) + " must be a string, or undefined");
		        }
		      }
		    } else {
		      assertPluginTarget(loc, value);
		    }
		    return value;
		  }
		  function assertPluginTarget(loc, value) {
		    if ((typeof value !== "object" || !value) && typeof value !== "string" && typeof value !== "function") {
		      throw new Error(msg(loc) + " must be a string, object, function");
		    }
		    return value;
		  }
		  function assertTargets(loc, value) {
		    if (isBrowsersQueryValid(value)) return value;
		    if (typeof value !== "object" || !value || Array.isArray(value)) {
		      throw new Error(msg(loc) + " must be a string, an array of strings or an object");
		    }
		    var browsersLoc = access(loc, "browsers");
		    var esmodulesLoc = access(loc, "esmodules");
		    assertBrowsersList(browsersLoc, value.browsers);
		    assertBoolean(esmodulesLoc, value.esmodules);
		    for (var _i2 = 0, _Object$keys2 = Object.keys(value); _i2 < _Object$keys2.length; _i2++) {
		      var _key = _Object$keys2[_i2];
		      var val = value[_key];
		      var subLoc = access(loc, _key);
		      if (_key === "esmodules") assertBoolean(subLoc, val);else if (_key === "browsers") assertBrowsersList(subLoc, val);else if (!hasOwnProperty.call(TargetNames, _key)) {
		        var validTargets = Object.keys(TargetNames).join(", ");
		        throw new Error(msg(subLoc) + " is not a valid target. Supported targets are " + validTargets);
		      } else assertBrowserVersion(subLoc, val);
		    }
		    return value;
		  }
		  function assertBrowsersList(loc, value) {
		    if (value !== undefined && !isBrowsersQueryValid(value)) {
		      throw new Error(msg(loc) + " must be undefined, a string or an array of strings");
		    }
		  }
		  function assertBrowserVersion(loc, value) {
		    if (typeof value === "number" && Math.round(value) === value) return;
		    if (typeof value === "string") return;
		    throw new Error(msg(loc) + " must be a string or an integer number");
		  }
		  function assertAssumptions(loc, value) {
		    if (value === undefined) return;
		    if (typeof value !== "object" || value === null) {
		      throw new Error(msg(loc) + " must be an object or undefined.");
		    }
		    var root = loc;
		    do {
		      root = root.parent;
		    } while (root.type !== "root");
		    var inPreset = root.source === "preset";
		    for (var _i3 = 0, _Object$keys3 = Object.keys(value); _i3 < _Object$keys3.length; _i3++) {
		      var _name2 = _Object$keys3[_i3];
		      var subLoc = access(loc, _name2);
		      if (!assumptionsNames.has(_name2)) {
		        throw new Error(msg(subLoc) + " is not a supported assumption.");
		      }
		      if (typeof value[_name2] !== "boolean") {
		        throw new Error(msg(subLoc) + " must be a boolean.");
		      }
		      if (inPreset && value[_name2] === false) {
		        throw new Error(msg(subLoc) + " cannot be set to 'false' inside presets.");
		      }
		    }
		    return value;
		  }

		  var _Object$getOwnPropert;
		  var ErrorToString = Function.call.bind(Error.prototype.toString);
		  var SUPPORTED = !!Error.captureStackTrace && ((_Object$getOwnPropert = Object.getOwnPropertyDescriptor(Error, "stackTraceLimit")) == null ? void 0 : _Object$getOwnPropert.writable) === true;
		  var START_HIDING = "startHiding - secret - don't use this - v1";
		  var STOP_HIDING = "stopHiding - secret - don't use this - v1";
		  var expectedErrors = new WeakSet();
		  var virtualFrames = new WeakMap();
		  function CallSite(filename) {
		    return Object.create({
		      isNative: function isNative() {
		        return false;
		      },
		      isConstructor: function isConstructor() {
		        return false;
		      },
		      isToplevel: function isToplevel() {
		        return true;
		      },
		      getFileName: function getFileName() {
		        return filename;
		      },
		      getLineNumber: function getLineNumber() {
		        return undefined;
		      },
		      getColumnNumber: function getColumnNumber() {
		        return undefined;
		      },
		      getFunctionName: function getFunctionName() {
		        return undefined;
		      },
		      getMethodName: function getMethodName() {
		        return undefined;
		      },
		      getTypeName: function getTypeName() {
		        return undefined;
		      },
		      toString: function toString() {
		        return filename;
		      }
		    });
		  }
		  function injectVirtualStackFrame(error, filename) {
		    if (!SUPPORTED) return;
		    var frames = virtualFrames.get(error);
		    if (!frames) virtualFrames.set(error, frames = []);
		    frames.push(CallSite(filename));
		    return error;
		  }
		  function expectedError(error) {
		    if (!SUPPORTED) return;
		    expectedErrors.add(error);
		    return error;
		  }
		  function beginHiddenCallStack(fn) {
		    if (!SUPPORTED) return fn;
		    return Object.defineProperty(function () {
		      setupPrepareStackTrace();
		      return fn.apply(void 0, arguments);
		    }, "name", {
		      value: STOP_HIDING
		    });
		  }
		  function endHiddenCallStack(fn) {
		    if (!SUPPORTED) return fn;
		    return Object.defineProperty(function () {
		      return fn.apply(void 0, arguments);
		    }, "name", {
		      value: START_HIDING
		    });
		  }
		  function setupPrepareStackTrace() {
		    setupPrepareStackTrace = function setupPrepareStackTrace() {};
		    var _Error$prepareStackTr = Error.prepareStackTrace,
		      prepareStackTrace = _Error$prepareStackTr === void 0 ? defaultPrepareStackTrace : _Error$prepareStackTr;
		    var MIN_STACK_TRACE_LIMIT = 50;
		    Error.stackTraceLimit && (Error.stackTraceLimit = Math.max(Error.stackTraceLimit, MIN_STACK_TRACE_LIMIT));
		    Error.prepareStackTrace = function stackTraceRewriter(err, trace) {
		      var newTrace = [];
		      var isExpected = expectedErrors.has(err);
		      var status = isExpected ? "hiding" : "unknown";
		      for (var i = 0; i < trace.length; i++) {
		        var name = trace[i].getFunctionName();
		        if (name === START_HIDING) {
		          status = "hiding";
		        } else if (name === STOP_HIDING) {
		          if (status === "hiding") {
		            status = "showing";
		            if (virtualFrames.has(err)) {
		              var _newTrace;
		              (_newTrace = newTrace).unshift.apply(_newTrace, _toConsumableArray(virtualFrames.get(err)));
		            }
		          } else if (status === "unknown") {
		            newTrace = trace;
		            break;
		          }
		        } else if (status !== "hiding") {
		          newTrace.push(trace[i]);
		        }
		      }
		      return prepareStackTrace(err, newTrace);
		    };
		  }
		  function defaultPrepareStackTrace(err, trace) {
		    if (trace.length === 0) return ErrorToString(err);
		    return ErrorToString(err) + "\n    at " + trace.join("\n    at ");
		  }

		  var ConfigError = function (_Error) {
		    function ConfigError(message, filename) {
		      var _this;
		      _this = _Error.call(this, message) || this;
		      expectedError(_this);
		      if (filename) injectVirtualStackFrame(_this, filename);
		      return _this;
		    }
		    _inherits(ConfigError, _Error);
		    return _createClass(ConfigError);
		  }(_wrapNativeSuper(Error));

		  var ROOT_VALIDATORS = {
		    cwd: assertString,
		    root: assertString,
		    rootMode: assertRootMode,
		    configFile: assertConfigFileSearch,
		    caller: assertCallerMetadata,
		    filename: assertString,
		    filenameRelative: assertString,
		    code: assertBoolean,
		    ast: assertBoolean,
		    cloneInputAst: assertBoolean,
		    envName: assertString
		  };
		  var BABELRC_VALIDATORS = {
		    babelrc: assertBoolean,
		    babelrcRoots: assertBabelrcSearch
		  };
		  var NONPRESET_VALIDATORS = {
		    "extends": assertString,
		    ignore: assertIgnoreList,
		    only: assertIgnoreList,
		    targets: assertTargets,
		    browserslistConfigFile: assertConfigFileSearch,
		    browserslistEnv: assertString
		  };
		  var COMMON_VALIDATORS = {
		    inputSourceMap: assertInputSourceMap,
		    presets: assertPluginList,
		    plugins: assertPluginList,
		    passPerPreset: assertBoolean,
		    assumptions: assertAssumptions,
		    env: assertEnvSet,
		    overrides: assertOverridesList,
		    test: assertConfigApplicableTest,
		    include: assertConfigApplicableTest,
		    exclude: assertConfigApplicableTest,
		    retainLines: assertBoolean,
		    comments: assertBoolean,
		    shouldPrintComment: assertFunction,
		    compact: assertCompact,
		    minified: assertBoolean,
		    auxiliaryCommentBefore: assertString,
		    auxiliaryCommentAfter: assertString,
		    sourceType: assertSourceType,
		    wrapPluginVisitorMethod: assertFunction,
		    highlightCode: assertBoolean,
		    sourceMaps: assertSourceMaps,
		    sourceMap: assertSourceMaps,
		    sourceFileName: assertString,
		    sourceRoot: assertString,
		    parserOpts: assertObject,
		    generatorOpts: assertObject
		  };
		  {
		    Object.assign(COMMON_VALIDATORS, {
		      getModuleId: assertFunction,
		      moduleRoot: assertString,
		      moduleIds: assertBoolean,
		      moduleId: assertString
		    });
		  }
		  var knownAssumptions = ["arrayLikeIsIterable", "constantReexports", "constantSuper", "enumerableModuleMeta", "ignoreFunctionLength", "ignoreToPrimitiveHint", "iterableIsArray", "mutableTemplateObject", "noClassCalls", "noDocumentAll", "noIncompleteNsImportDetection", "noNewArrows", "noUninitializedPrivateFieldAccess", "objectRestNoSymbols", "privateFieldsAsSymbols", "privateFieldsAsProperties", "pureGetters", "setClassMethods", "setComputedProperties", "setPublicClassFields", "setSpreadProperties", "skipForOfIteratorClosing", "superIsCallableConstructor"];
		  var assumptionsNames = new Set(knownAssumptions);
		  function getSource(loc) {
		    return loc.type === "root" ? loc.source : getSource(loc.parent);
		  }
		  function validate(type, opts, filename) {
		    try {
		      return validateNested({
		        type: "root",
		        source: type
		      }, opts);
		    } catch (error) {
		      var configError = new ConfigError(error.message, filename);
		      if (error.code) configError.code = error.code;
		      throw configError;
		    }
		  }
		  function validateNested(loc, opts) {
		    var type = getSource(loc);
		    assertNoDuplicateSourcemap(opts);
		    Object.keys(opts).forEach(function (key) {
		      var optLoc = {
		        type: "option",
		        name: key,
		        parent: loc
		      };
		      if (type === "preset" && NONPRESET_VALIDATORS[key]) {
		        throw new Error(msg(optLoc) + " is not allowed in preset options");
		      }
		      if (type !== "arguments" && ROOT_VALIDATORS[key]) {
		        throw new Error(msg(optLoc) + " is only allowed in root programmatic options");
		      }
		      if (type !== "arguments" && type !== "configfile" && BABELRC_VALIDATORS[key]) {
		        if (type === "babelrcfile" || type === "extendsfile") {
		          throw new Error(msg(optLoc) + " is not allowed in .babelrc or \"extends\"ed files, only in root programmatic options, " + "or babel.config.js/config file options");
		        }
		        throw new Error(msg(optLoc) + " is only allowed in root programmatic options, or babel.config.js/config file options");
		      }
		      var validator = COMMON_VALIDATORS[key] || NONPRESET_VALIDATORS[key] || BABELRC_VALIDATORS[key] || ROOT_VALIDATORS[key] || throwUnknownError;
		      validator(optLoc, opts[key]);
		    });
		    return opts;
		  }
		  function throwUnknownError(loc) {
		    var key = loc.name;
		    if (removed[key]) {
		      var _removed$key = removed[key],
		        message = _removed$key.message,
		        _removed$key$version = _removed$key.version,
		        version = _removed$key$version === void 0 ? 5 : _removed$key$version;
		      throw new Error("Using removed Babel " + version + " option: " + msg(loc) + " - " + message);
		    } else {
		      var unknownOptErr = new Error("Unknown option: " + msg(loc) + ". Check out https://babeljs.io/docs/en/babel-core/#options for more information about options.");
		      unknownOptErr.code = "BABEL_UNKNOWN_OPTION";
		      throw unknownOptErr;
		    }
		  }
		  function assertNoDuplicateSourcemap(opts) {
		    if (hasOwnProperty.call(opts, "sourceMap") && hasOwnProperty.call(opts, "sourceMaps")) {
		      throw new Error(".sourceMap is an alias for .sourceMaps, cannot use both");
		    }
		  }
		  function assertEnvSet(loc, value) {
		    if (loc.parent.type === "env") {
		      throw new Error(msg(loc) + " is not allowed inside of another .env block");
		    }
		    var parent = loc.parent;
		    var obj = assertObject(loc, value);
		    if (obj) {
		      for (var _i = 0, _Object$keys = Object.keys(obj); _i < _Object$keys.length; _i++) {
		        var envName = _Object$keys[_i];
		        var env = assertObject(access(loc, envName), obj[envName]);
		        if (!env) continue;
		        var envLoc = {
		          type: "env",
		          name: envName,
		          parent: parent
		        };
		        validateNested(envLoc, env);
		      }
		    }
		    return obj;
		  }
		  function assertOverridesList(loc, value) {
		    if (loc.parent.type === "env") {
		      throw new Error(msg(loc) + " is not allowed inside an .env block");
		    }
		    if (loc.parent.type === "overrides") {
		      throw new Error(msg(loc) + " is not allowed inside an .overrides block");
		    }
		    var parent = loc.parent;
		    var arr = assertArray(loc, value);
		    if (arr) {
		      for (var _iterator = _createForOfIteratorHelperLoose(arr.entries()), _step; !(_step = _iterator()).done;) {
		        var _step$value = _slicedToArray(_step.value, 2),
		          index = _step$value[0],
		          item = _step$value[1];
		        var objLoc = access(loc, index);
		        var env = assertObject(objLoc, item);
		        if (!env) throw new Error(msg(objLoc) + " must be an object");
		        var overridesLoc = {
		          type: "overrides",
		          index: index,
		          parent: parent
		        };
		        validateNested(overridesLoc, env);
		      }
		    }
		    return arr;
		  }
		  function checkNoUnwrappedItemOptionPairs(items, index, type, e) {
		    if (index === 0) return;
		    var lastItem = items[index - 1];
		    var thisItem = items[index];
		    if (lastItem.file && lastItem.options === undefined && typeof thisItem.value === "object") {
		      e.message += "\n- Maybe you meant to use\n" + ("\"" + type + "s\": [\n  [\"" + lastItem.file.request + "\", " + JSON.stringify(thisItem.value, undefined, 2) + "]\n]\n") + ("To be a valid " + type + ", its name and options should be wrapped in a pair of brackets");
		    }
		  }

		  var sep = "\\" + path$1.sep;
		  var endSep = "(?:" + sep + "|$)";
		  var substitution = "[^" + sep + "]+";
		  var starPat = "(?:" + substitution + sep + ")";
		  var starPatLast = "(?:" + substitution + endSep + ")";
		  var starStarPat = starPat + "*?";
		  var starStarPatLast = starPat + "*?" + starPatLast + "?";
		  function escapeRegExp(string) {
		    return string.replace(/[|\\{}()[\]^$+*?.]/g, "\\$&");
		  }
		  function pathToPattern(pattern, dirname) {
		    var parts = path$1.resolve(dirname, pattern).split(path$1.sep);
		    return new RegExp(["^"].concat(_toConsumableArray(parts.map(function (part, i) {
		      var last = i === parts.length - 1;
		      if (part === "**") return last ? starStarPatLast : starStarPat;
		      if (part === "*") return last ? starPatLast : starPat;
		      if (part.indexOf("*.") === 0) {
		        return substitution + escapeRegExp(part.slice(1)) + (last ? endSep : sep);
		      }
		      return escapeRegExp(part) + (last ? endSep : sep);
		    }))).join(""));
		  }

		  var ChainFormatter = {
		    Programmatic: 0,
		    Config: 1
		  };
		  var Formatter = {
		    title: function title(type, callerName, filepath) {
		      var title = "";
		      if (type === ChainFormatter.Programmatic) {
		        title = "programmatic options";
		        if (callerName) {
		          title += " from " + callerName;
		        }
		      } else {
		        title = "config " + filepath;
		      }
		      return title;
		    },
		    loc: function loc(index, envName) {
		      var loc = "";
		      if (index != null) {
		        loc += ".overrides[" + index + "]";
		      }
		      if (envName != null) {
		        loc += ".env[\"" + envName + "\"]";
		      }
		      return loc;
		    },
		    optionsAndDescriptors: _regeneratorRuntime().mark(function optionsAndDescriptors(opt) {
		      var content, pluginDescriptors, presetDescriptors;
		      return _regeneratorRuntime().wrap(function optionsAndDescriptors$(_context) {
		        while (1) switch (_context.prev = _context.next) {
		          case 0:
		            content = Object.assign({}, opt.options);
		            delete content.overrides;
		            delete content.env;
		            _context.t0 = _toConsumableArray;
		            return _context.delegateYield(opt.plugins(), "t1", 5);
		          case 5:
		            _context.t2 = _context.t1;
		            pluginDescriptors = (0, _context.t0)(_context.t2);
		            if (pluginDescriptors.length) {
		              content.plugins = pluginDescriptors.map(function (d) {
		                return descriptorToConfig(d);
		              });
		            }
		            _context.t3 = _toConsumableArray;
		            return _context.delegateYield(opt.presets(), "t4", 10);
		          case 10:
		            _context.t5 = _context.t4;
		            presetDescriptors = (0, _context.t3)(_context.t5);
		            if (presetDescriptors.length) {
		              content.presets = _toConsumableArray(presetDescriptors).map(function (d) {
		                return descriptorToConfig(d);
		              });
		            }
		            return _context.abrupt("return", JSON.stringify(content, undefined, 2));
		          case 14:
		          case "end":
		            return _context.stop();
		        }
		      }, optionsAndDescriptors);
		    })
		  };
		  function descriptorToConfig(d) {
		    var _d$file;
		    var name = (_d$file = d.file) == null ? void 0 : _d$file.request;
		    if (name == null) {
		      if (typeof d.value === "object") {
		        name = d.value;
		      } else if (typeof d.value === "function") {
		        name = "[Function: " + d.value.toString().slice(0, 50) + " ... ]";
		      }
		    }
		    if (name == null) {
		      name = "[Unknown]";
		    }
		    if (d.options === undefined) {
		      return name;
		    } else if (d.name == null) {
		      return [name, d.options];
		    } else {
		      return [name, d.options, d.name];
		    }
		  }
		  var ConfigPrinter = function () {
		    function ConfigPrinter() {
		      this._stack = [];
		    }
		    var _proto = ConfigPrinter.prototype;
		    _proto.configure = function configure(enabled, type, _ref) {
		      var _this = this;
		      var callerName = _ref.callerName,
		        filepath = _ref.filepath;
		      if (!enabled) return function () {};
		      return function (content, index, envName) {
		        _this._stack.push({
		          type: type,
		          callerName: callerName,
		          filepath: filepath,
		          content: content,
		          index: index,
		          envName: envName
		        });
		      };
		    };
		    ConfigPrinter.format = _regeneratorRuntime().mark(function format(config) {
		      var title, loc, content;
		      return _regeneratorRuntime().wrap(function format$(_context2) {
		        while (1) switch (_context2.prev = _context2.next) {
		          case 0:
		            title = Formatter.title(config.type, config.callerName, config.filepath);
		            loc = Formatter.loc(config.index, config.envName);
		            if (loc) title += " " + loc;
		            return _context2.delegateYield(Formatter.optionsAndDescriptors(config.content), "t0", 4);
		          case 4:
		            content = _context2.t0;
		            return _context2.abrupt("return", title + "\n" + content);
		          case 6:
		          case "end":
		            return _context2.stop();
		        }
		      }, format);
		    });
		    _proto.output = _regeneratorRuntime().mark(function output() {
		      var configs;
		      return _regeneratorRuntime().wrap(function output$(_context3) {
		        while (1) switch (_context3.prev = _context3.next) {
		          case 0:
		            if (!(this._stack.length === 0)) {
		              _context3.next = 2;
		              break;
		            }
		            return _context3.abrupt("return", "");
		          case 2:
		            return _context3.delegateYield(gensync.all(this._stack.map(function (s) {
		              return ConfigPrinter.format(s);
		            })), "t0", 3);
		          case 3:
		            configs = _context3.t0;
		            return _context3.abrupt("return", configs.join("\n\n"));
		          case 5:
		          case "end":
		            return _context3.stop();
		        }
		      }, output, this);
		    });
		    return _createClass(ConfigPrinter);
		  }();

		  var _marked$6 = _regeneratorRuntime().mark(buildPresetChain),
		    _marked2$4 = _regeneratorRuntime().mark(buildRootChain),
		    _marked3$1 = _regeneratorRuntime().mark(loadFileChain),
		    _marked4 = _regeneratorRuntime().mark(mergeExtendsChain);
		  var debug$1 = browserExports("babel:config:config-chain");
		  function buildPresetChain(arg, context) {
		    var chain;
		    return _regeneratorRuntime().wrap(function buildPresetChain$(_context) {
		      while (1) switch (_context.prev = _context.next) {
		        case 0:
		          return _context.delegateYield(buildPresetChainWalker(arg, context), "t0", 1);
		        case 1:
		          chain = _context.t0;
		          if (chain) {
		            _context.next = 4;
		            break;
		          }
		          return _context.abrupt("return", null);
		        case 4:
		          return _context.abrupt("return", {
		            plugins: dedupDescriptors(chain.plugins),
		            presets: dedupDescriptors(chain.presets),
		            options: chain.options.map(function (o) {
		              return normalizeOptions$7(o);
		            }),
		            files: new Set()
		          });
		        case 5:
		        case "end":
		          return _context.stop();
		      }
		    }, _marked$6);
		  }
		  var buildPresetChainWalker = makeChainWalker({
		    root: function root(preset) {
		      return loadPresetDescriptors(preset);
		    },
		    env: function env(preset, envName) {
		      return loadPresetEnvDescriptors(preset)(envName);
		    },
		    overrides: function overrides(preset, index) {
		      return loadPresetOverridesDescriptors(preset)(index);
		    },
		    overridesEnv: function overridesEnv(preset, index, envName) {
		      return loadPresetOverridesEnvDescriptors(preset)(index)(envName);
		    },
		    createLogger: function createLogger() {
		      return function () {};
		    }
		  });
		  var loadPresetDescriptors = makeWeakCacheSync(function (preset) {
		    return buildRootDescriptors(preset, preset.alias, createUncachedDescriptors);
		  });
		  var loadPresetEnvDescriptors = makeWeakCacheSync(function (preset) {
		    return makeStrongCacheSync(function (envName) {
		      return buildEnvDescriptors(preset, preset.alias, createUncachedDescriptors, envName);
		    });
		  });
		  var loadPresetOverridesDescriptors = makeWeakCacheSync(function (preset) {
		    return makeStrongCacheSync(function (index) {
		      return buildOverrideDescriptors(preset, preset.alias, createUncachedDescriptors, index);
		    });
		  });
		  var loadPresetOverridesEnvDescriptors = makeWeakCacheSync(function (preset) {
		    return makeStrongCacheSync(function (index) {
		      return makeStrongCacheSync(function (envName) {
		        return buildOverrideEnvDescriptors(preset, preset.alias, createUncachedDescriptors, index, envName);
		      });
		    });
		  });
		  function buildRootChain(opts, context) {
		    var configReport, babelRcReport, programmaticLogger, programmaticChain, programmaticReport, configFile, babelrc, babelrcRoots, babelrcRootsDirectory, configFileChain, configFileLogger, validatedFile, result, ignoreFile, babelrcFile, isIgnored, fileChain, pkgData, _yield$findRelativeCo, _validatedFile, babelrcLogger, _result, chain;
		    return _regeneratorRuntime().wrap(function buildRootChain$(_context2) {
		      while (1) switch (_context2.prev = _context2.next) {
		        case 0:
		          programmaticLogger = new ConfigPrinter();
		          return _context2.delegateYield(loadProgrammaticChain({
		            options: opts,
		            dirname: context.cwd
		          }, context, undefined, programmaticLogger), "t0", 2);
		        case 2:
		          programmaticChain = _context2.t0;
		          if (programmaticChain) {
		            _context2.next = 5;
		            break;
		          }
		          return _context2.abrupt("return", null);
		        case 5:
		          return _context2.delegateYield(programmaticLogger.output(), "t1", 6);
		        case 6:
		          programmaticReport = _context2.t1;
		          if (!(typeof opts.configFile === "string")) {
		            _context2.next = 12;
		            break;
		          }
		          return _context2.delegateYield(loadConfig$1(opts.configFile, context.cwd, context.envName, context.caller), "t2", 9);
		        case 9:
		          configFile = _context2.t2;
		          _context2.next = 15;
		          break;
		        case 12:
		          if (!(opts.configFile !== false)) {
		            _context2.next = 15;
		            break;
		          }
		          return _context2.delegateYield(findRootConfig(context.root, context.envName, context.caller), "t3", 14);
		        case 14:
		          configFile = _context2.t3;
		        case 15:
		          babelrc = opts.babelrc, babelrcRoots = opts.babelrcRoots;
		          babelrcRootsDirectory = context.cwd;
		          configFileChain = emptyChain();
		          configFileLogger = new ConfigPrinter();
		          if (!configFile) {
		            _context2.next = 30;
		            break;
		          }
		          validatedFile = validateConfigFile(configFile);
		          return _context2.delegateYield(loadFileChain(validatedFile, context, undefined, configFileLogger), "t4", 22);
		        case 22:
		          result = _context2.t4;
		          if (result) {
		            _context2.next = 25;
		            break;
		          }
		          return _context2.abrupt("return", null);
		        case 25:
		          return _context2.delegateYield(configFileLogger.output(), "t5", 26);
		        case 26:
		          configReport = _context2.t5;
		          if (babelrc === undefined) {
		            babelrc = validatedFile.options.babelrc;
		          }
		          if (babelrcRoots === undefined) {
		            babelrcRootsDirectory = validatedFile.dirname;
		            babelrcRoots = validatedFile.options.babelrcRoots;
		          }
		          mergeChain(configFileChain, result);
		        case 30:
		          isIgnored = false;
		          fileChain = emptyChain();
		          if (!((babelrc === true || babelrc === undefined) && typeof context.filename === "string")) {
		            _context2.next = 55;
		            break;
		          }
		          return _context2.delegateYield(findPackageData(context.filename), "t6", 34);
		        case 34:
		          pkgData = _context2.t6;
		          if (!(pkgData && babelrcLoadEnabled(context, pkgData, babelrcRoots, babelrcRootsDirectory))) {
		            _context2.next = 55;
		            break;
		          }
		          return _context2.delegateYield(findRelativeConfig(pkgData, context.envName, context.caller), "t7", 37);
		        case 37:
		          _yield$findRelativeCo = _context2.t7;
		          ignoreFile = _yield$findRelativeCo.ignore;
		          babelrcFile = _yield$findRelativeCo.config;
		          if (ignoreFile) {
		            fileChain.files.add(ignoreFile.filepath);
		          }
		          if (ignoreFile && shouldIgnore(context, ignoreFile.ignore, null, ignoreFile.dirname)) {
		            isIgnored = true;
		          }
		          if (!(babelrcFile && !isIgnored)) {
		            _context2.next = 54;
		            break;
		          }
		          _validatedFile = validateBabelrcFile(babelrcFile);
		          babelrcLogger = new ConfigPrinter();
		          return _context2.delegateYield(loadFileChain(_validatedFile, context, undefined, babelrcLogger), "t8", 46);
		        case 46:
		          _result = _context2.t8;
		          if (_result) {
		            _context2.next = 51;
		            break;
		          }
		          isIgnored = true;
		          _context2.next = 54;
		          break;
		        case 51:
		          return _context2.delegateYield(babelrcLogger.output(), "t9", 52);
		        case 52:
		          babelRcReport = _context2.t9;
		          mergeChain(fileChain, _result);
		        case 54:
		          if (babelrcFile && isIgnored) {
		            fileChain.files.add(babelrcFile.filepath);
		          }
		        case 55:
		          if (context.showConfig) {
		            console.log("Babel configs on \"" + context.filename + "\" (ascending priority):\n" + [configReport, babelRcReport, programmaticReport].filter(function (x) {
		              return !!x;
		            }).join("\n\n") + "\n-----End Babel configs-----");
		          }
		          chain = mergeChain(mergeChain(mergeChain(emptyChain(), configFileChain), fileChain), programmaticChain);
		          return _context2.abrupt("return", {
		            plugins: isIgnored ? [] : dedupDescriptors(chain.plugins),
		            presets: isIgnored ? [] : dedupDescriptors(chain.presets),
		            options: isIgnored ? [] : chain.options.map(function (o) {
		              return normalizeOptions$7(o);
		            }),
		            fileHandling: isIgnored ? "ignored" : "transpile",
		            ignore: ignoreFile || undefined,
		            babelrc: babelrcFile || undefined,
		            config: configFile || undefined,
		            files: chain.files
		          });
		        case 58:
		        case "end":
		          return _context2.stop();
		      }
		    }, _marked2$4);
		  }
		  function babelrcLoadEnabled(context, pkgData, babelrcRoots, babelrcRootsDirectory) {
		    if (typeof babelrcRoots === "boolean") return babelrcRoots;
		    var absoluteRoot = context.root;
		    if (babelrcRoots === undefined) {
		      return pkgData.directories.indexOf(absoluteRoot) !== -1;
		    }
		    var babelrcPatterns = babelrcRoots;
		    if (!Array.isArray(babelrcPatterns)) {
		      babelrcPatterns = [babelrcPatterns];
		    }
		    babelrcPatterns = babelrcPatterns.map(function (pat) {
		      return typeof pat === "string" ? path$1.resolve(babelrcRootsDirectory, pat) : pat;
		    });
		    if (babelrcPatterns.length === 1 && babelrcPatterns[0] === absoluteRoot) {
		      return pkgData.directories.indexOf(absoluteRoot) !== -1;
		    }
		    return babelrcPatterns.some(function (pat) {
		      if (typeof pat === "string") {
		        pat = pathToPattern(pat, babelrcRootsDirectory);
		      }
		      return pkgData.directories.some(function (directory) {
		        return matchPattern(pat, babelrcRootsDirectory, directory, context);
		      });
		    });
		  }
		  var validateConfigFile = makeWeakCacheSync(function (file) {
		    return {
		      filepath: file.filepath,
		      dirname: file.dirname,
		      options: validate("configfile", file.options, file.filepath)
		    };
		  });
		  var validateBabelrcFile = makeWeakCacheSync(function (file) {
		    return {
		      filepath: file.filepath,
		      dirname: file.dirname,
		      options: validate("babelrcfile", file.options, file.filepath)
		    };
		  });
		  var validateExtendFile = makeWeakCacheSync(function (file) {
		    return {
		      filepath: file.filepath,
		      dirname: file.dirname,
		      options: validate("extendsfile", file.options, file.filepath)
		    };
		  });
		  var loadProgrammaticChain = makeChainWalker({
		    root: function root(input) {
		      return buildRootDescriptors(input, "base", createCachedDescriptors);
		    },
		    env: function env(input, envName) {
		      return buildEnvDescriptors(input, "base", createCachedDescriptors, envName);
		    },
		    overrides: function overrides(input, index) {
		      return buildOverrideDescriptors(input, "base", createCachedDescriptors, index);
		    },
		    overridesEnv: function overridesEnv(input, index, envName) {
		      return buildOverrideEnvDescriptors(input, "base", createCachedDescriptors, index, envName);
		    },
		    createLogger: function createLogger(input, context, baseLogger) {
		      return buildProgrammaticLogger(input, context, baseLogger);
		    }
		  });
		  var loadFileChainWalker = makeChainWalker({
		    root: function root(file) {
		      return loadFileDescriptors(file);
		    },
		    env: function env(file, envName) {
		      return loadFileEnvDescriptors(file)(envName);
		    },
		    overrides: function overrides(file, index) {
		      return loadFileOverridesDescriptors(file)(index);
		    },
		    overridesEnv: function overridesEnv(file, index, envName) {
		      return loadFileOverridesEnvDescriptors(file)(index)(envName);
		    },
		    createLogger: function createLogger(file, context, baseLogger) {
		      return buildFileLogger(file.filepath, context, baseLogger);
		    }
		  });
		  function loadFileChain(input, context, files, baseLogger) {
		    var chain;
		    return _regeneratorRuntime().wrap(function loadFileChain$(_context3) {
		      while (1) switch (_context3.prev = _context3.next) {
		        case 0:
		          return _context3.delegateYield(loadFileChainWalker(input, context, files, baseLogger), "t0", 1);
		        case 1:
		          chain = _context3.t0;
		          chain == null || chain.files.add(input.filepath);
		          return _context3.abrupt("return", chain);
		        case 4:
		        case "end":
		          return _context3.stop();
		      }
		    }, _marked3$1);
		  }
		  var loadFileDescriptors = makeWeakCacheSync(function (file) {
		    return buildRootDescriptors(file, file.filepath, createUncachedDescriptors);
		  });
		  var loadFileEnvDescriptors = makeWeakCacheSync(function (file) {
		    return makeStrongCacheSync(function (envName) {
		      return buildEnvDescriptors(file, file.filepath, createUncachedDescriptors, envName);
		    });
		  });
		  var loadFileOverridesDescriptors = makeWeakCacheSync(function (file) {
		    return makeStrongCacheSync(function (index) {
		      return buildOverrideDescriptors(file, file.filepath, createUncachedDescriptors, index);
		    });
		  });
		  var loadFileOverridesEnvDescriptors = makeWeakCacheSync(function (file) {
		    return makeStrongCacheSync(function (index) {
		      return makeStrongCacheSync(function (envName) {
		        return buildOverrideEnvDescriptors(file, file.filepath, createUncachedDescriptors, index, envName);
		      });
		    });
		  });
		  function buildFileLogger(filepath, context, baseLogger) {
		    if (!baseLogger) {
		      return function () {};
		    }
		    return baseLogger.configure(context.showConfig, ChainFormatter.Config, {
		      filepath: filepath
		    });
		  }
		  function buildRootDescriptors(_ref, alias, descriptors) {
		    var dirname = _ref.dirname,
		      options = _ref.options;
		    return descriptors(dirname, options, alias);
		  }
		  function buildProgrammaticLogger(_, context, baseLogger) {
		    var _context$caller;
		    if (!baseLogger) {
		      return function () {};
		    }
		    return baseLogger.configure(context.showConfig, ChainFormatter.Programmatic, {
		      callerName: (_context$caller = context.caller) == null ? void 0 : _context$caller.name
		    });
		  }
		  function buildEnvDescriptors(_ref2, alias, descriptors, envName) {
		    var _options$env;
		    var dirname = _ref2.dirname,
		      options = _ref2.options;
		    var opts = (_options$env = options.env) == null ? void 0 : _options$env[envName];
		    return opts ? descriptors(dirname, opts, alias + ".env[\"" + envName + "\"]") : null;
		  }
		  function buildOverrideDescriptors(_ref3, alias, descriptors, index) {
		    var _options$overrides;
		    var dirname = _ref3.dirname,
		      options = _ref3.options;
		    var opts = (_options$overrides = options.overrides) == null ? void 0 : _options$overrides[index];
		    if (!opts) throw new Error("Assertion failure - missing override");
		    return descriptors(dirname, opts, alias + ".overrides[" + index + "]");
		  }
		  function buildOverrideEnvDescriptors(_ref4, alias, descriptors, index, envName) {
		    var _options$overrides2, _override$env;
		    var dirname = _ref4.dirname,
		      options = _ref4.options;
		    var override = (_options$overrides2 = options.overrides) == null ? void 0 : _options$overrides2[index];
		    if (!override) throw new Error("Assertion failure - missing override");
		    var opts = (_override$env = override.env) == null ? void 0 : _override$env[envName];
		    return opts ? descriptors(dirname, opts, alias + ".overrides[" + index + "].env[\"" + envName + "\"]") : null;
		  }
		  function makeChainWalker(_ref5) {
		    var root = _ref5.root,
		      env = _ref5.env,
		      overrides = _ref5.overrides,
		      overridesEnv = _ref5.overridesEnv,
		      createLogger = _ref5.createLogger;
		    return function chainWalker(input, context, files, baseLogger) {
		      if (files === void 0) {
		        files = new Set();
		      }
		      return _regeneratorRuntime().mark(function _callee() {
		        var dirname, flattenedConfigs, rootOpts, envOpts, chain, logger, _i, _flattenedConfigs, _flattenedConfigs$_i, config, _index, envName;
		        return _regeneratorRuntime().wrap(function _callee$(_context4) {
		          while (1) switch (_context4.prev = _context4.next) {
		            case 0:
		              dirname = input.dirname;
		              flattenedConfigs = [];
		              rootOpts = root(input);
		              if (configIsApplicable(rootOpts, dirname, context, input.filepath)) {
		                flattenedConfigs.push({
		                  config: rootOpts,
		                  envName: undefined,
		                  index: undefined
		                });
		                envOpts = env(input, context.envName);
		                if (envOpts && configIsApplicable(envOpts, dirname, context, input.filepath)) {
		                  flattenedConfigs.push({
		                    config: envOpts,
		                    envName: context.envName,
		                    index: undefined
		                  });
		                }
		                (rootOpts.options.overrides || []).forEach(function (_, index) {
		                  var overrideOps = overrides(input, index);
		                  if (configIsApplicable(overrideOps, dirname, context, input.filepath)) {
		                    flattenedConfigs.push({
		                      config: overrideOps,
		                      index: index,
		                      envName: undefined
		                    });
		                    var overrideEnvOpts = overridesEnv(input, index, context.envName);
		                    if (overrideEnvOpts && configIsApplicable(overrideEnvOpts, dirname, context, input.filepath)) {
		                      flattenedConfigs.push({
		                        config: overrideEnvOpts,
		                        index: index,
		                        envName: context.envName
		                      });
		                    }
		                  }
		                });
		              }
		              if (!flattenedConfigs.some(function (_ref6) {
		                var _ref6$config$options = _ref6.config.options,
		                  ignore = _ref6$config$options.ignore,
		                  only = _ref6$config$options.only;
		                return shouldIgnore(context, ignore, only, dirname);
		              })) {
		                _context4.next = 6;
		                break;
		              }
		              return _context4.abrupt("return", null);
		            case 6:
		              chain = emptyChain();
		              logger = createLogger(input, context, baseLogger);
		              _i = 0, _flattenedConfigs = flattenedConfigs;
		            case 9:
		              if (!(_i < _flattenedConfigs.length)) {
		                _context4.next = 19;
		                break;
		              }
		              _flattenedConfigs$_i = _flattenedConfigs[_i], config = _flattenedConfigs$_i.config, _index = _flattenedConfigs$_i.index, envName = _flattenedConfigs$_i.envName;
		              return _context4.delegateYield(mergeExtendsChain(chain, config.options, dirname, context, files, baseLogger), "t0", 12);
		            case 12:
		              if (_context4.t0) {
		                _context4.next = 14;
		                break;
		              }
		              return _context4.abrupt("return", null);
		            case 14:
		              logger(config, _index, envName);
		              return _context4.delegateYield(mergeChainOpts(chain, config), "t1", 16);
		            case 16:
		              _i++;
		              _context4.next = 9;
		              break;
		            case 19:
		              return _context4.abrupt("return", chain);
		            case 20:
		            case "end":
		              return _context4.stop();
		          }
		        }, _callee);
		      })();
		    };
		  }
		  function mergeExtendsChain(chain, opts, dirname, context, files, baseLogger) {
		    var file, fileChain;
		    return _regeneratorRuntime().wrap(function mergeExtendsChain$(_context5) {
		      while (1) switch (_context5.prev = _context5.next) {
		        case 0:
		          if (!(opts["extends"] === undefined)) {
		            _context5.next = 2;
		            break;
		          }
		          return _context5.abrupt("return", true);
		        case 2:
		          return _context5.delegateYield(loadConfig$1(opts["extends"], dirname, context.envName, context.caller), "t0", 3);
		        case 3:
		          file = _context5.t0;
		          if (!files.has(file)) {
		            _context5.next = 6;
		            break;
		          }
		          throw new Error("Configuration cycle detected loading " + file.filepath + ".\n" + "File already loaded following the config chain:\n" + Array.from(files, function (file) {
		            return " - " + file.filepath;
		          }).join("\n"));
		        case 6:
		          files.add(file);
		          return _context5.delegateYield(loadFileChain(validateExtendFile(file), context, files, baseLogger), "t1", 8);
		        case 8:
		          fileChain = _context5.t1;
		          files["delete"](file);
		          if (fileChain) {
		            _context5.next = 12;
		            break;
		          }
		          return _context5.abrupt("return", false);
		        case 12:
		          mergeChain(chain, fileChain);
		          return _context5.abrupt("return", true);
		        case 14:
		        case "end":
		          return _context5.stop();
		      }
		    }, _marked4);
		  }
		  function mergeChain(target, source) {
		    var _target$options, _target$plugins, _target$presets;
		    (_target$options = target.options).push.apply(_target$options, _toConsumableArray(source.options));
		    (_target$plugins = target.plugins).push.apply(_target$plugins, _toConsumableArray(source.plugins));
		    (_target$presets = target.presets).push.apply(_target$presets, _toConsumableArray(source.presets));
		    for (var _iterator = _createForOfIteratorHelperLoose(source.files), _step; !(_step = _iterator()).done;) {
		      var file = _step.value;
		      target.files.add(file);
		    }
		    return target;
		  }
		  function mergeChainOpts(target, _ref7) {
		    var options = _ref7.options,
		      plugins = _ref7.plugins,
		      presets = _ref7.presets;
		    return _regeneratorRuntime().mark(function _callee2(_target$plugins2, _target$presets2) {
		      return _regeneratorRuntime().wrap(function _callee2$(_context6) {
		        while (1) switch (_context6.prev = _context6.next) {
		          case 0:
		            target.options.push(options);
		            _context6.t0 = (_target$plugins2 = target.plugins).push;
		            _context6.t1 = _target$plugins2;
		            _context6.t2 = _toConsumableArray;
		            return _context6.delegateYield(plugins(), "t3", 5);
		          case 5:
		            _context6.t4 = _context6.t3;
		            _context6.t5 = (0, _context6.t2)(_context6.t4);
		            _context6.t0.apply.call(_context6.t0, _context6.t1, _context6.t5);
		            _context6.t6 = (_target$presets2 = target.presets).push;
		            _context6.t7 = _target$presets2;
		            _context6.t8 = _toConsumableArray;
		            return _context6.delegateYield(presets(), "t9", 12);
		          case 12:
		            _context6.t10 = _context6.t9;
		            _context6.t11 = (0, _context6.t8)(_context6.t10);
		            _context6.t6.apply.call(_context6.t6, _context6.t7, _context6.t11);
		            return _context6.abrupt("return", target);
		          case 16:
		          case "end":
		            return _context6.stop();
		        }
		      }, _callee2);
		    })();
		  }
		  function emptyChain() {
		    return {
		      options: [],
		      presets: [],
		      plugins: [],
		      files: new Set()
		    };
		  }
		  function normalizeOptions$7(opts) {
		    var options = Object.assign({}, opts);
		    delete options["extends"];
		    delete options.env;
		    delete options.overrides;
		    delete options.plugins;
		    delete options.presets;
		    delete options.passPerPreset;
		    delete options.ignore;
		    delete options.only;
		    delete options.test;
		    delete options.include;
		    delete options.exclude;
		    if (hasOwnProperty.call(options, "sourceMap")) {
		      options.sourceMaps = options.sourceMap;
		      delete options.sourceMap;
		    }
		    return options;
		  }
		  function dedupDescriptors(items) {
		    var map = new Map();
		    var descriptors = [];
		    for (var _iterator2 = _createForOfIteratorHelperLoose(items), _step2; !(_step2 = _iterator2()).done;) {
		      var item = _step2.value;
		      if (typeof item.value === "function") {
		        var fnKey = item.value;
		        var nameMap = map.get(fnKey);
		        if (!nameMap) {
		          nameMap = new Map();
		          map.set(fnKey, nameMap);
		        }
		        var desc = nameMap.get(item.name);
		        if (!desc) {
		          desc = {
		            value: item
		          };
		          descriptors.push(desc);
		          if (!item.ownPass) nameMap.set(item.name, desc);
		        } else {
		          desc.value = item;
		        }
		      } else {
		        descriptors.push({
		          value: item
		        });
		      }
		    }
		    return descriptors.reduce(function (acc, desc) {
		      acc.push(desc.value);
		      return acc;
		    }, []);
		  }
		  function configIsApplicable(_ref8, dirname, context, configName) {
		    var options = _ref8.options;
		    return (options.test === undefined || configFieldIsApplicable(context, options.test, dirname, configName)) && (options.include === undefined || configFieldIsApplicable(context, options.include, dirname, configName)) && (options.exclude === undefined || !configFieldIsApplicable(context, options.exclude, dirname, configName));
		  }
		  function configFieldIsApplicable(context, test, dirname, configName) {
		    var patterns = Array.isArray(test) ? test : [test];
		    return matchesPatterns(context, patterns, dirname, configName);
		  }
		  function ignoreListReplacer(_key, value) {
		    if (value instanceof RegExp) {
		      return String(value);
		    }
		    return value;
		  }
		  function shouldIgnore(context, ignore, only, dirname) {
		    if (ignore && matchesPatterns(context, ignore, dirname)) {
		      var _context$filename;
		      var message = "No config is applied to \"" + ((_context$filename = context.filename) != null ? _context$filename : "(unknown)") + "\" because it matches one of `ignore: " + JSON.stringify(ignore, ignoreListReplacer) + "` from \"" + dirname + "\"";
		      debug$1(message);
		      if (context.showConfig) {
		        console.log(message);
		      }
		      return true;
		    }
		    if (only && !matchesPatterns(context, only, dirname)) {
		      var _context$filename2;
		      var _message = "No config is applied to \"" + ((_context$filename2 = context.filename) != null ? _context$filename2 : "(unknown)") + "\" because it fails to match one of `only: " + JSON.stringify(only, ignoreListReplacer) + "` from \"" + dirname + "\"";
		      debug$1(_message);
		      if (context.showConfig) {
		        console.log(_message);
		      }
		      return true;
		    }
		    return false;
		  }
		  function matchesPatterns(context, patterns, dirname, configName) {
		    return patterns.some(function (pattern) {
		      return matchPattern(pattern, dirname, context.filename, context, configName);
		    });
		  }
		  function matchPattern(pattern, dirname, pathToTest, context, configName) {
		    if (typeof pattern === "function") {
		      return !!endHiddenCallStack(pattern)(pathToTest, {
		        dirname: dirname,
		        envName: context.envName,
		        caller: context.caller
		      });
		    }
		    if (typeof pathToTest !== "string") {
		      throw new ConfigError("Configuration contains string/RegExp pattern, but no filename was passed to Babel", configName);
		    }
		    if (typeof pattern === "string") {
		      pattern = pathToPattern(pattern, dirname);
		    }
		    return pattern.test(pathToTest);
		  }

		  var VALIDATORS = {
		    name: assertString,
		    manipulateOptions: assertFunction,
		    pre: assertFunction,
		    post: assertFunction,
		    inherits: assertFunction,
		    visitor: assertVisitorMap,
		    parserOverride: assertFunction,
		    generatorOverride: assertFunction
		  };
		  function assertVisitorMap(loc, value) {
		    var obj = assertObject(loc, value);
		    if (obj) {
		      Object.keys(obj).forEach(function (prop) {
		        if (prop !== "_exploded" && prop !== "_verified") {
		          assertVisitorHandler(prop, obj[prop]);
		        }
		      });
		      if (obj.enter || obj.exit) {
		        throw new Error(msg(loc) + " cannot contain catch-all \"enter\" or \"exit\" handlers. Please target individual nodes.");
		      }
		    }
		    return obj;
		  }
		  function assertVisitorHandler(key, value) {
		    if (value && typeof value === "object") {
		      Object.keys(value).forEach(function (handler) {
		        if (handler !== "enter" && handler !== "exit") {
		          throw new Error(".visitor[\"" + key + "\"] may only have .enter and/or .exit handlers.");
		        }
		      });
		    } else if (typeof value !== "function") {
		      throw new Error(".visitor[\"" + key + "\"] must be a function");
		    }
		  }
		  function validatePluginObject(obj) {
		    var rootPath = {
		      type: "root",
		      source: "plugin"
		    };
		    Object.keys(obj).forEach(function (key) {
		      var validator = VALIDATORS[key];
		      if (validator) {
		        var optLoc = {
		          type: "option",
		          name: key,
		          parent: rootPath
		        };
		        validator(optLoc, obj[key]);
		      } else {
		        var invalidPluginPropertyError = new Error("." + key + " is not a valid Plugin property");
		        invalidPluginPropertyError.code = "BABEL_UNKNOWN_PLUGIN_PROPERTY";
		        throw invalidPluginPropertyError;
		      }
		    });
		    return obj;
		  }

		  function makeConfigAPI(cache) {
		    var env = function env(value) {
		      return cache.using(function (data) {
		        if (typeof value === "undefined") return data.envName;
		        if (typeof value === "function") {
		          return assertSimpleType(value(data.envName));
		        }
		        return (Array.isArray(value) ? value : [value]).some(function (entry) {
		          if (typeof entry !== "string") {
		            throw new Error("Unexpected non-string value");
		          }
		          return entry === data.envName;
		        });
		      });
		    };
		    var caller = function caller(cb) {
		      return cache.using(function (data) {
		        return assertSimpleType(cb(data.caller));
		      });
		    };
		    return {
		      version: version$1,
		      cache: cache.simple(),
		      env: env,
		      async: function async() {
		        return false;
		      },
		      caller: caller,
		      assertVersion: assertVersion
		    };
		  }
		  function makePresetAPI(cache, externalDependencies) {
		    var targets = function targets() {
		      return JSON.parse(cache.using(function (data) {
		        return JSON.stringify(data.targets);
		      }));
		    };
		    var addExternalDependency = function addExternalDependency(ref) {
		      externalDependencies.push(ref);
		    };
		    return Object.assign({}, makeConfigAPI(cache), {
		      targets: targets,
		      addExternalDependency: addExternalDependency
		    });
		  }
		  function makePluginAPI(cache, externalDependencies) {
		    var assumption = function assumption(name) {
		      return cache.using(function (data) {
		        return data.assumptions[name];
		      });
		    };
		    return Object.assign({}, makePresetAPI(cache, externalDependencies), {
		      assumption: assumption
		    });
		  }
		  function assertVersion(range) {
		    if (typeof range === "number") {
		      if (!Number.isInteger(range)) {
		        throw new Error("Expected string or integer value.");
		      }
		      range = "^" + range + ".0.0-0";
		    }
		    if (typeof range !== "string") {
		      throw new Error("Expected string or integer value.");
		    }
		    if (range === "*" || semver$9.satisfies(version$1, range)) return;
		    var limit = Error.stackTraceLimit;
		    if (typeof limit === "number" && limit < 25) {
		      Error.stackTraceLimit = 25;
		    }
		    var err = new Error("Requires Babel \"" + range + "\", but was loaded with \"" + version$1 + "\". " + "If you are sure you have a compatible version of @babel/core, " + "it is likely that something in your build process is loading the " + "wrong version. Inspect the stack trace of this error to look for " + "the first entry that doesn't mention \"@babel/core\" or \"babel-core\" " + "to see what is calling Babel.");
		    if (typeof limit === "number") {
		      Error.stackTraceLimit = limit;
		    }
		    throw Object.assign(err, {
		      code: "BABEL_VERSION_UNSUPPORTED",
		      version: version$1,
		      range: range
		    });
		  }

		  var _excluded$2 = ["showIgnoredFiles"];
		  var _marked$5 = _regeneratorRuntime().mark(loadPrivatePartialConfig),
		    _marked2$3 = _regeneratorRuntime().mark(loadPartialConfig$1);
		  function resolveRootMode(rootDir, rootMode) {
		    switch (rootMode) {
		      case "root":
		        return rootDir;
		      case "upward-optional":
		        {
		          var upwardRootDir = findConfigUpwards();
		          return upwardRootDir === null ? rootDir : upwardRootDir;
		        }
		      case "upward":
		        {
		          var _upwardRootDir = findConfigUpwards();
		          if (_upwardRootDir !== null) return _upwardRootDir;
		          throw Object.assign(new Error("Babel was run with rootMode:\"upward\" but a root could not " + ("be found when searching upward from \"" + rootDir + "\".\n") + "One of the following config files must be in the directory tree: " + ("\"" + ROOT_CONFIG_FILENAMES.join(", ") + "\".")), {
		            code: "BABEL_ROOT_NOT_FOUND",
		            dirname: rootDir
		          });
		        }
		      default:
		        throw new Error("Assertion failure - unknown rootMode value.");
		    }
		  }
		  function loadPrivatePartialConfig(inputOpts) {
		    var args, _args$envName, envName, _args$cwd, cwd, _args$root, rootDir, _args$rootMode, rootMode, caller, _args$cloneInputAst, cloneInputAst, absoluteCwd, absoluteRootDir, filename, showConfigPath, context, configChain, merged, options;
		    return _regeneratorRuntime().wrap(function loadPrivatePartialConfig$(_context) {
		      while (1) switch (_context.prev = _context.next) {
		        case 0:
		          if (!(inputOpts != null && (typeof inputOpts !== "object" || Array.isArray(inputOpts)))) {
		            _context.next = 2;
		            break;
		          }
		          throw new Error("Babel options must be an object, null, or undefined");
		        case 2:
		          args = inputOpts ? validate("arguments", inputOpts) : {};
		          _args$envName = args.envName, envName = _args$envName === void 0 ? getEnv() : _args$envName, _args$cwd = args.cwd, cwd = _args$cwd === void 0 ? "." : _args$cwd, _args$root = args.root, rootDir = _args$root === void 0 ? "." : _args$root, _args$rootMode = args.rootMode, rootMode = _args$rootMode === void 0 ? "root" : _args$rootMode, caller = args.caller, _args$cloneInputAst = args.cloneInputAst, cloneInputAst = _args$cloneInputAst === void 0 ? true : _args$cloneInputAst;
		          absoluteCwd = path$1.resolve(cwd);
		          absoluteRootDir = resolveRootMode(path$1.resolve(absoluteCwd, rootDir), rootMode);
		          filename = typeof args.filename === "string" ? path$1.resolve(cwd, args.filename) : undefined;
		          return _context.delegateYield(resolveShowConfigPath(), "t0", 8);
		        case 8:
		          showConfigPath = _context.t0;
		          context = {
		            filename: filename,
		            cwd: absoluteCwd,
		            root: absoluteRootDir,
		            envName: envName,
		            caller: caller,
		            showConfig: showConfigPath === filename
		          };
		          return _context.delegateYield(buildRootChain(args, context), "t1", 11);
		        case 11:
		          configChain = _context.t1;
		          if (configChain) {
		            _context.next = 14;
		            break;
		          }
		          return _context.abrupt("return", null);
		        case 14:
		          merged = {
		            assumptions: {}
		          };
		          configChain.options.forEach(function (opts) {
		            mergeOptions(merged, opts);
		          });
		          options = Object.assign({}, merged, {
		            targets: resolveTargets(merged),
		            cloneInputAst: cloneInputAst,
		            babelrc: false,
		            configFile: false,
		            browserslistConfigFile: false,
		            passPerPreset: false,
		            envName: context.envName,
		            cwd: context.cwd,
		            root: context.root,
		            rootMode: "root",
		            filename: typeof context.filename === "string" ? context.filename : undefined,
		            plugins: configChain.plugins.map(function (descriptor) {
		              return createItemFromDescriptor(descriptor);
		            }),
		            presets: configChain.presets.map(function (descriptor) {
		              return createItemFromDescriptor(descriptor);
		            })
		          });
		          return _context.abrupt("return", {
		            options: options,
		            context: context,
		            fileHandling: configChain.fileHandling,
		            ignore: configChain.ignore,
		            babelrc: configChain.babelrc,
		            config: configChain.config,
		            files: configChain.files
		          });
		        case 18:
		        case "end":
		          return _context.stop();
		      }
		    }, _marked$5);
		  }
		  function loadPartialConfig$1(opts) {
		    var showIgnoredFiles, _opts, result, options, babelrc, ignore, config, fileHandling, files;
		    return _regeneratorRuntime().wrap(function loadPartialConfig$(_context2) {
		      while (1) switch (_context2.prev = _context2.next) {
		        case 0:
		          showIgnoredFiles = false;
		          if (typeof opts === "object" && opts !== null && !Array.isArray(opts)) {
		            _opts = opts;
		            showIgnoredFiles = _opts.showIgnoredFiles;
		            opts = _objectWithoutPropertiesLoose(_opts, _excluded$2);
		          }
		          return _context2.delegateYield(loadPrivatePartialConfig(opts), "t0", 3);
		        case 3:
		          result = _context2.t0;
		          if (result) {
		            _context2.next = 6;
		            break;
		          }
		          return _context2.abrupt("return", null);
		        case 6:
		          options = result.options, babelrc = result.babelrc, ignore = result.ignore, config = result.config, fileHandling = result.fileHandling, files = result.files;
		          if (!(fileHandling === "ignored" && !showIgnoredFiles)) {
		            _context2.next = 9;
		            break;
		          }
		          return _context2.abrupt("return", null);
		        case 9:
		          (options.plugins || []).forEach(function (item) {
		            if (item.value instanceof Plugin) {
		              throw new Error("Passing cached plugin instances is not supported in " + "babel.loadPartialConfig()");
		            }
		          });
		          return _context2.abrupt("return", new PartialConfig(options, babelrc ? babelrc.filepath : undefined, ignore ? ignore.filepath : undefined, config ? config.filepath : undefined, fileHandling, files));
		        case 11:
		        case "end":
		          return _context2.stop();
		      }
		    }, _marked2$3);
		  }
		  var PartialConfig = function () {
		    function PartialConfig(options, babelrc, ignore, config, fileHandling, files) {
		      this.options = void 0;
		      this.babelrc = void 0;
		      this.babelignore = void 0;
		      this.config = void 0;
		      this.fileHandling = void 0;
		      this.files = void 0;
		      this.options = options;
		      this.babelignore = ignore;
		      this.babelrc = babelrc;
		      this.config = config;
		      this.fileHandling = fileHandling;
		      this.files = files;
		      Object.freeze(this);
		    }
		    var _proto = PartialConfig.prototype;
		    _proto.hasFilesystemConfig = function hasFilesystemConfig() {
		      return this.babelrc !== undefined || this.config !== undefined;
		    };
		    return _createClass(PartialConfig);
		  }();
		  Object.freeze(PartialConfig.prototype);

		  var _marked$4 = _regeneratorRuntime().mark(loadPluginDescriptor),
		    _marked2$2 = _regeneratorRuntime().mark(loadPresetDescriptor);
		  var loadConfig = gensync(_regeneratorRuntime().mark(function loadFullConfig(inputOpts) {
		    var _opts$assumptions;
		    var result, options, context, fileHandling, optionDefaults, plugins, presets, presetContext, toDescriptor, presetsDescriptors, initialPluginsDescriptors, pluginDescriptorsByPass, passes, externalDependencies, ignored, opts, pluginContext;
		    return _regeneratorRuntime().wrap(function loadFullConfig$(_context3) {
		      while (1) switch (_context3.prev = _context3.next) {
		        case 0:
		          return _context3.delegateYield(loadPrivatePartialConfig(inputOpts), "t0", 1);
		        case 1:
		          result = _context3.t0;
		          if (result) {
		            _context3.next = 4;
		            break;
		          }
		          return _context3.abrupt("return", null);
		        case 4:
		          options = result.options, context = result.context, fileHandling = result.fileHandling;
		          if (!(fileHandling === "ignored")) {
		            _context3.next = 7;
		            break;
		          }
		          return _context3.abrupt("return", null);
		        case 7:
		          optionDefaults = {};
		          plugins = options.plugins, presets = options.presets;
		          if (!(!plugins || !presets)) {
		            _context3.next = 11;
		            break;
		          }
		          throw new Error("Assertion failure - plugins and presets exist");
		        case 11:
		          presetContext = Object.assign({}, context, {
		            targets: options.targets
		          });
		          toDescriptor = function toDescriptor(item) {
		            var desc = getItemDescriptor(item);
		            if (!desc) {
		              throw new Error("Assertion failure - must be config item");
		            }
		            return desc;
		          };
		          presetsDescriptors = presets.map(toDescriptor);
		          initialPluginsDescriptors = plugins.map(toDescriptor);
		          pluginDescriptorsByPass = [[]];
		          passes = [];
		          externalDependencies = [];
		          return _context3.delegateYield(enhanceError(context, _regeneratorRuntime().mark(function recursePresetDescriptors(rawPresets, pluginDescriptorsPass) {
		            var presets, i, descriptor, preset, _iterator, _step, _step$value, _preset, pass, _ignored;
		            return _regeneratorRuntime().wrap(function recursePresetDescriptors$(_context) {
		              while (1) switch (_context.prev = _context.next) {
		                case 0:
		                  presets = [];
		                  i = 0;
		                case 2:
		                  if (!(i < rawPresets.length)) {
		                    _context.next = 19;
		                    break;
		                  }
		                  descriptor = rawPresets[i];
		                  if (!(descriptor.options !== false)) {
		                    _context.next = 16;
		                    break;
		                  }
		                  _context.prev = 5;
		                  return _context.delegateYield(loadPresetDescriptor(descriptor, presetContext), "t0", 7);
		                case 7:
		                  preset = _context.t0;
		                  _context.next = 14;
		                  break;
		                case 10:
		                  _context.prev = 10;
		                  _context.t1 = _context["catch"](5);
		                  if (_context.t1.code === "BABEL_UNKNOWN_OPTION") {
		                    checkNoUnwrappedItemOptionPairs(rawPresets, i, "preset", _context.t1);
		                  }
		                  throw _context.t1;
		                case 14:
		                  externalDependencies.push(preset.externalDependencies);
		                  if (descriptor.ownPass) {
		                    presets.push({
		                      preset: preset.chain,
		                      pass: []
		                    });
		                  } else {
		                    presets.unshift({
		                      preset: preset.chain,
		                      pass: pluginDescriptorsPass
		                    });
		                  }
		                case 16:
		                  i++;
		                  _context.next = 2;
		                  break;
		                case 19:
		                  if (!(presets.length > 0)) {
		                    _context.next = 34;
		                    break;
		                  }
		                  pluginDescriptorsByPass.splice.apply(pluginDescriptorsByPass, [1, 0].concat(_toConsumableArray(presets.map(function (o) {
		                    return o.pass;
		                  }).filter(function (p) {
		                    return p !== pluginDescriptorsPass;
		                  }))));
		                  _iterator = _createForOfIteratorHelperLoose(presets);
		                case 22:
		                  if ((_step = _iterator()).done) {
		                    _context.next = 34;
		                    break;
		                  }
		                  _step$value = _step.value, _preset = _step$value.preset, pass = _step$value.pass;
		                  if (_preset) {
		                    _context.next = 26;
		                    break;
		                  }
		                  return _context.abrupt("return", true);
		                case 26:
		                  pass.push.apply(pass, _toConsumableArray(_preset.plugins));
		                  return _context.delegateYield(recursePresetDescriptors(_preset.presets, pass), "t2", 28);
		                case 28:
		                  _ignored = _context.t2;
		                  if (!_ignored) {
		                    _context.next = 31;
		                    break;
		                  }
		                  return _context.abrupt("return", true);
		                case 31:
		                  _preset.options.forEach(function (opts) {
		                    mergeOptions(optionDefaults, opts);
		                  });
		                case 32:
		                  _context.next = 22;
		                  break;
		                case 34:
		                case "end":
		                  return _context.stop();
		              }
		            }, recursePresetDescriptors, null, [[5, 10]]);
		          }))(presetsDescriptors, pluginDescriptorsByPass[0]), "t1", 19);
		        case 19:
		          ignored = _context3.t1;
		          if (!ignored) {
		            _context3.next = 22;
		            break;
		          }
		          return _context3.abrupt("return", null);
		        case 22:
		          opts = optionDefaults;
		          mergeOptions(opts, options);
		          pluginContext = Object.assign({}, presetContext, {
		            assumptions: (_opts$assumptions = opts.assumptions) != null ? _opts$assumptions : {}
		          });
		          return _context3.delegateYield(enhanceError(context, _regeneratorRuntime().mark(function loadPluginDescriptors() {
		            var _pluginDescriptorsByP;
		            var _i, _pluginDescriptorsByP2, descs, pass, i, descriptor, plugin;
		            return _regeneratorRuntime().wrap(function loadPluginDescriptors$(_context2) {
		              while (1) switch (_context2.prev = _context2.next) {
		                case 0:
		                  (_pluginDescriptorsByP = pluginDescriptorsByPass[0]).unshift.apply(_pluginDescriptorsByP, _toConsumableArray(initialPluginsDescriptors));
		                  _i = 0, _pluginDescriptorsByP2 = pluginDescriptorsByPass;
		                case 2:
		                  if (!(_i < _pluginDescriptorsByP2.length)) {
		                    _context2.next = 27;
		                    break;
		                  }
		                  descs = _pluginDescriptorsByP2[_i];
		                  pass = [];
		                  passes.push(pass);
		                  i = 0;
		                case 7:
		                  if (!(i < descs.length)) {
		                    _context2.next = 24;
		                    break;
		                  }
		                  descriptor = descs[i];
		                  if (!(descriptor.options !== false)) {
		                    _context2.next = 21;
		                    break;
		                  }
		                  _context2.prev = 10;
		                  return _context2.delegateYield(loadPluginDescriptor(descriptor, pluginContext), "t0", 12);
		                case 12:
		                  plugin = _context2.t0;
		                  _context2.next = 19;
		                  break;
		                case 15:
		                  _context2.prev = 15;
		                  _context2.t1 = _context2["catch"](10);
		                  if (_context2.t1.code === "BABEL_UNKNOWN_PLUGIN_PROPERTY") {
		                    checkNoUnwrappedItemOptionPairs(descs, i, "plugin", _context2.t1);
		                  }
		                  throw _context2.t1;
		                case 19:
		                  pass.push(plugin);
		                  externalDependencies.push(plugin.externalDependencies);
		                case 21:
		                  i++;
		                  _context2.next = 7;
		                  break;
		                case 24:
		                  _i++;
		                  _context2.next = 2;
		                  break;
		                case 27:
		                case "end":
		                  return _context2.stop();
		              }
		            }, loadPluginDescriptors, null, [[10, 15]]);
		          }))(), "t2", 26);
		        case 26:
		          opts.plugins = passes[0];
		          opts.presets = passes.slice(1).filter(function (plugins) {
		            return plugins.length > 0;
		          }).map(function (plugins) {
		            return {
		              plugins: plugins
		            };
		          });
		          opts.passPerPreset = opts.presets.length > 0;
		          return _context3.abrupt("return", {
		            options: opts,
		            passes: passes,
		            externalDependencies: finalize(externalDependencies)
		          });
		        case 30:
		        case "end":
		          return _context3.stop();
		      }
		    }, loadFullConfig);
		  }));
		  function enhanceError(context, fn) {
		    return _regeneratorRuntime().mark(function _callee(arg1, arg2) {
		      var _context$filename;
		      return _regeneratorRuntime().wrap(function _callee$(_context4) {
		        while (1) switch (_context4.prev = _context4.next) {
		          case 0:
		            _context4.prev = 0;
		            return _context4.delegateYield(fn(arg1, arg2), "t0", 2);
		          case 2:
		            return _context4.abrupt("return", _context4.t0);
		          case 5:
		            _context4.prev = 5;
		            _context4.t1 = _context4["catch"](0);
		            if (!/^\[BABEL\]/.test(_context4.t1.message)) {
		              _context4.t1.message = "[BABEL] " + ((_context$filename = context.filename) != null ? _context$filename : "unknown file") + ": " + _context4.t1.message;
		            }
		            throw _context4.t1;
		          case 9:
		          case "end":
		            return _context4.stop();
		        }
		      }, _callee, null, [[0, 5]]);
		    });
		  }
		  var makeDescriptorLoader = function makeDescriptorLoader(apiFactory) {
		    return makeWeakCache(function (_ref, cache) {
		      var value = _ref.value,
		        options = _ref.options,
		        dirname = _ref.dirname,
		        alias = _ref.alias;
		      return _regeneratorRuntime().mark(function _callee2() {
		        var externalDependencies, item, factory, api, error;
		        return _regeneratorRuntime().wrap(function _callee2$(_context5) {
		          while (1) switch (_context5.prev = _context5.next) {
		            case 0:
		              if (!(options === false)) {
		                _context5.next = 2;
		                break;
		              }
		              throw new Error("Assertion failure");
		            case 2:
		              options = options || {};
		              externalDependencies = [];
		              item = value;
		              if (!(typeof value === "function")) {
		                _context5.next = 17;
		                break;
		              }
		              factory = maybeAsync(value, "You appear to be using an async plugin/preset, but Babel has been called synchronously");
		              api = Object.assign({}, _babel, apiFactory(cache, externalDependencies));
		              _context5.prev = 8;
		              return _context5.delegateYield(factory(api, options, dirname), "t0", 10);
		            case 10:
		              item = _context5.t0;
		              _context5.next = 17;
		              break;
		            case 13:
		              _context5.prev = 13;
		              _context5.t1 = _context5["catch"](8);
		              if (alias) {
		                _context5.t1.message += " (While processing: " + JSON.stringify(alias) + ")";
		              }
		              throw _context5.t1;
		            case 17:
		              if (!(!item || typeof item !== "object")) {
		                _context5.next = 19;
		                break;
		              }
		              throw new Error("Plugin/Preset did not return an object.");
		            case 19:
		              if (!isThenable$1(item)) {
		                _context5.next = 22;
		                break;
		              }
		              return _context5.delegateYield([], "t2", 21);
		            case 21:
		              throw new Error("You appear to be using a promise as a plugin, " + "which your current version of Babel does not support. " + "If you're using a published plugin, " + "you may need to upgrade your @babel/core version. " + "As an alternative, you can prefix the promise with \"await\". " + ("(While processing: " + JSON.stringify(alias) + ")"));
		            case 22:
		              if (!(externalDependencies.length > 0 && (!cache.configured() || cache.mode() === "forever"))) {
		                _context5.next = 27;
		                break;
		              }
		              error = "A plugin/preset has external untracked dependencies " + ("(" + externalDependencies[0] + "), but the cache ");
		              if (!cache.configured()) {
		                error += "has not been configured to be invalidated when the external dependencies change. ";
		              } else {
		                error += " has been configured to never be invalidated. ";
		              }
		              error += "Plugins/presets should configure their cache to be invalidated when the external " + "dependencies change, for example using `api.cache.invalidate(() => " + "statSync(filepath).mtimeMs)` or `api.cache.never()`\n" + ("(While processing: " + JSON.stringify(alias) + ")");
		              throw new Error(error);
		            case 27:
		              return _context5.abrupt("return", {
		                value: item,
		                options: options,
		                dirname: dirname,
		                alias: alias,
		                externalDependencies: finalize(externalDependencies)
		              });
		            case 28:
		            case "end":
		              return _context5.stop();
		          }
		        }, _callee2, null, [[8, 13]]);
		      })();
		    });
		  };
		  var pluginDescriptorLoader = makeDescriptorLoader(makePluginAPI);
		  var presetDescriptorLoader = makeDescriptorLoader(makePresetAPI);
		  var instantiatePlugin = makeWeakCache(function (_ref2, cache) {
		    var value = _ref2.value,
		      options = _ref2.options,
		      dirname = _ref2.dirname,
		      alias = _ref2.alias,
		      externalDependencies = _ref2.externalDependencies;
		    return _regeneratorRuntime().mark(function _callee3() {
		      var pluginObj, plugin, inheritsDescriptor, inherits;
		      return _regeneratorRuntime().wrap(function _callee3$(_context6) {
		        while (1) switch (_context6.prev = _context6.next) {
		          case 0:
		            pluginObj = validatePluginObject(value);
		            plugin = Object.assign({}, pluginObj);
		            if (plugin.visitor) {
		              plugin.visitor = traverse.explode(Object.assign({}, plugin.visitor));
		            }
		            if (!plugin.inherits) {
		              _context6.next = 12;
		              break;
		            }
		            inheritsDescriptor = {
		              name: undefined,
		              alias: alias + "$inherits",
		              value: plugin.inherits,
		              options: options,
		              dirname: dirname
		            };
		            return _context6.delegateYield(forwardAsync(loadPluginDescriptor, function (run) {
		              return cache.invalidate(function (data) {
		                return run(inheritsDescriptor, data);
		              });
		            }), "t0", 6);
		          case 6:
		            inherits = _context6.t0;
		            plugin.pre = chain(inherits.pre, plugin.pre);
		            plugin.post = chain(inherits.post, plugin.post);
		            plugin.manipulateOptions = chain(inherits.manipulateOptions, plugin.manipulateOptions);
		            plugin.visitor = traverse.visitors.merge([inherits.visitor || {}, plugin.visitor || {}]);
		            if (inherits.externalDependencies.length > 0) {
		              if (externalDependencies.length === 0) {
		                externalDependencies = inherits.externalDependencies;
		              } else {
		                externalDependencies = finalize([externalDependencies, inherits.externalDependencies]);
		              }
		            }
		          case 12:
		            return _context6.abrupt("return", new Plugin(plugin, options, alias, externalDependencies));
		          case 13:
		          case "end":
		            return _context6.stop();
		        }
		      }, _callee3);
		    })();
		  });
		  function loadPluginDescriptor(descriptor, context) {
		    return _regeneratorRuntime().wrap(function loadPluginDescriptor$(_context7) {
		      while (1) switch (_context7.prev = _context7.next) {
		        case 0:
		          if (!(descriptor.value instanceof Plugin)) {
		            _context7.next = 4;
		            break;
		          }
		          if (!descriptor.options) {
		            _context7.next = 3;
		            break;
		          }
		          throw new Error("Passed options to an existing Plugin instance will not work.");
		        case 3:
		          return _context7.abrupt("return", descriptor.value);
		        case 4:
		          _context7.t0 = instantiatePlugin;
		          return _context7.delegateYield(pluginDescriptorLoader(descriptor, context), "t1", 6);
		        case 6:
		          _context7.t2 = _context7.t1;
		          _context7.t3 = context;
		          return _context7.delegateYield((0, _context7.t0)(_context7.t2, _context7.t3), "t4", 9);
		        case 9:
		          return _context7.abrupt("return", _context7.t4);
		        case 10:
		        case "end":
		          return _context7.stop();
		      }
		    }, _marked$4);
		  }
		  var needsFilename = function needsFilename(val) {
		    return val && typeof val !== "function";
		  };
		  var validateIfOptionNeedsFilename = function validateIfOptionNeedsFilename(options, descriptor) {
		    if (needsFilename(options.test) || needsFilename(options.include) || needsFilename(options.exclude)) {
		      var formattedPresetName = descriptor.name ? "\"" + descriptor.name + "\"" : "/* your preset */";
		      throw new ConfigError(["Preset " + formattedPresetName + " requires a filename to be set when babel is called directly,", "```", "babel.transformSync(code, { filename: 'file.ts', presets: [" + formattedPresetName + "] });", "```", "See https://babeljs.io/docs/en/options#filename for more information."].join("\n"));
		    }
		  };
		  var validatePreset = function validatePreset(preset, context, descriptor) {
		    if (!context.filename) {
		      var _options$overrides;
		      var options = preset.options;
		      validateIfOptionNeedsFilename(options, descriptor);
		      (_options$overrides = options.overrides) == null || _options$overrides.forEach(function (overrideOptions) {
		        return validateIfOptionNeedsFilename(overrideOptions, descriptor);
		      });
		    }
		  };
		  var instantiatePreset = makeWeakCacheSync(function (_ref3) {
		    var value = _ref3.value,
		      dirname = _ref3.dirname,
		      alias = _ref3.alias,
		      externalDependencies = _ref3.externalDependencies;
		    return {
		      options: validate("preset", value),
		      alias: alias,
		      dirname: dirname,
		      externalDependencies: externalDependencies
		    };
		  });
		  function loadPresetDescriptor(descriptor, context) {
		    var preset;
		    return _regeneratorRuntime().wrap(function loadPresetDescriptor$(_context8) {
		      while (1) switch (_context8.prev = _context8.next) {
		        case 0:
		          _context8.t0 = instantiatePreset;
		          return _context8.delegateYield(presetDescriptorLoader(descriptor, context), "t1", 2);
		        case 2:
		          _context8.t2 = _context8.t1;
		          preset = (0, _context8.t0)(_context8.t2);
		          validatePreset(preset, context, descriptor);
		          return _context8.delegateYield(buildPresetChain(preset, context), "t3", 6);
		        case 6:
		          _context8.t4 = _context8.t3;
		          _context8.t5 = preset.externalDependencies;
		          return _context8.abrupt("return", {
		            chain: _context8.t4,
		            externalDependencies: _context8.t5
		          });
		        case 9:
		        case "end":
		          return _context8.stop();
		      }
		    }, _marked2$2);
		  }
		  function chain(a, b) {
		    var fns = [a, b].filter(Boolean);
		    if (fns.length <= 1) return fns[0];
		    return function () {
		      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
		        args[_key] = arguments[_key];
		      }
		      for (var _iterator2 = _createForOfIteratorHelperLoose(fns), _step2; !(_step2 = _iterator2()).done;) {
		        var fn = _step2.value;
		        fn.apply(this, args);
		      }
		    };
		  }

		  var _marked$3 = _regeneratorRuntime().mark(loadOptionsImpl);
		  var loadPartialConfigRunner = gensync(loadPartialConfig$1);
		  function loadPartialConfigAsync() {
		    return beginHiddenCallStack(loadPartialConfigRunner.async).apply(void 0, arguments);
		  }
		  function loadPartialConfigSync() {
		    return beginHiddenCallStack(loadPartialConfigRunner.sync).apply(void 0, arguments);
		  }
		  function loadPartialConfig(opts, callback) {
		    if (callback !== undefined) {
		      beginHiddenCallStack(loadPartialConfigRunner.errback)(opts, callback);
		    } else if (typeof opts === "function") {
		      beginHiddenCallStack(loadPartialConfigRunner.errback)(undefined, opts);
		    } else {
		      {
		        return loadPartialConfigSync(opts);
		      }
		    }
		  }
		  function loadOptionsImpl(opts) {
		    var _config$options;
		    var config;
		    return _regeneratorRuntime().wrap(function loadOptionsImpl$(_context) {
		      while (1) switch (_context.prev = _context.next) {
		        case 0:
		          return _context.delegateYield(loadConfig(opts), "t0", 1);
		        case 1:
		          config = _context.t0;
		          return _context.abrupt("return", (_config$options = config == null ? void 0 : config.options) != null ? _config$options : null);
		        case 3:
		        case "end":
		          return _context.stop();
		      }
		    }, _marked$3);
		  }
		  var loadOptionsRunner = gensync(loadOptionsImpl);
		  function loadOptionsAsync() {
		    return beginHiddenCallStack(loadOptionsRunner.async).apply(void 0, arguments);
		  }
		  function loadOptionsSync() {
		    return beginHiddenCallStack(loadOptionsRunner.sync).apply(void 0, arguments);
		  }
		  function loadOptions(opts, callback) {
		    if (callback !== undefined) {
		      beginHiddenCallStack(loadOptionsRunner.errback)(opts, callback);
		    } else if (typeof opts === "function") {
		      beginHiddenCallStack(loadOptionsRunner.errback)(undefined, opts);
		    } else {
		      {
		        return loadOptionsSync(opts);
		      }
		    }
		  }
		  var createConfigItemRunner = gensync(createConfigItem$1);
		  function createConfigItemAsync() {
		    return beginHiddenCallStack(createConfigItemRunner.async).apply(void 0, arguments);
		  }
		  function createConfigItemSync() {
		    return beginHiddenCallStack(createConfigItemRunner.sync).apply(void 0, arguments);
		  }
		  function createConfigItem(target, options, callback) {
		    if (callback !== undefined) {
		      beginHiddenCallStack(createConfigItemRunner.errback)(target, options, callback);
		    } else if (typeof options === "function") {
		      beginHiddenCallStack(createConfigItemRunner.errback)(target, undefined, callback);
		    } else {
		      {
		        return createConfigItemSync(target, options);
		      }
		    }
		  }

		  var PluginPass = function () {
		    function PluginPass(file, key, options) {
		      this._map = new Map();
		      this.key = void 0;
		      this.file = void 0;
		      this.opts = void 0;
		      this.cwd = void 0;
		      this.filename = void 0;
		      this.key = key;
		      this.file = file;
		      this.opts = options || {};
		      this.cwd = file.opts.cwd;
		      this.filename = file.opts.filename;
		    }
		    var _proto = PluginPass.prototype;
		    _proto.set = function set(key, val) {
		      this._map.set(key, val);
		    };
		    _proto.get = function get(key) {
		      return this._map.get(key);
		    };
		    _proto.availableHelper = function availableHelper(name, versionRange) {
		      return this.file.availableHelper(name, versionRange);
		    };
		    _proto.addHelper = function addHelper(name) {
		      return this.file.addHelper(name);
		    };
		    _proto.buildCodeFrameError = function buildCodeFrameError(node, msg, _Error) {
		      return this.file.buildCodeFrameError(node, msg, _Error);
		    };
		    return _createClass(PluginPass);
		  }();
		  {
		    PluginPass.prototype.getModuleName = function getModuleName() {
		      return this.file.getModuleName();
		    };
		    PluginPass.prototype.addImport = function addImport() {
		      this.file.addImport();
		    };
		  }

		  var LOADED_PLUGIN;
		  var blockHoistPlugin = {
		    name: "internal.blockHoist",
		    visitor: {
		      Block: {
		        exit: function exit(_ref) {
		          var node = _ref.node;
		          node.body = performHoisting(node.body);
		        }
		      },
		      SwitchCase: {
		        exit: function exit(_ref2) {
		          var node = _ref2.node;
		          node.consequent = performHoisting(node.consequent);
		        }
		      }
		    }
		  };
		  function performHoisting(body) {
		    var max = Math.pow(2, 30) - 1;
		    var hasChange = false;
		    for (var i = 0; i < body.length; i++) {
		      var n = body[i];
		      var p = priority(n);
		      if (p > max) {
		        hasChange = true;
		        break;
		      }
		      max = p;
		    }
		    if (!hasChange) return body;
		    return stableSort(body.slice());
		  }
		  function loadBlockHoistPlugin() {
		    if (!LOADED_PLUGIN) {
		      LOADED_PLUGIN = new Plugin(Object.assign({}, blockHoistPlugin, {
		        visitor: traverse.explode(blockHoistPlugin.visitor)
		      }), {});
		    }
		    return LOADED_PLUGIN;
		  }
		  function priority(bodyNode) {
		    var priority = bodyNode == null ? void 0 : bodyNode._blockHoist;
		    if (priority == null) return 1;
		    if (priority === true) return 2;
		    return priority;
		  }
		  function stableSort(body) {
		    var buckets = Object.create(null);
		    for (var i = 0; i < body.length; i++) {
		      var n = body[i];
		      var p = priority(n);
		      var bucket = buckets[p] || (buckets[p] = []);
		      bucket.push(n);
		    }
		    var keys = Object.keys(buckets).map(function (k) {
		      return +k;
		    }).sort(function (a, b) {
		      return b - a;
		    });
		    var index = 0;
		    for (var _iterator = _createForOfIteratorHelperLoose(keys), _step; !(_step = _iterator()).done;) {
		      var key = _step.value;
		      var _bucket = buckets[key];
		      for (var _iterator2 = _createForOfIteratorHelperLoose(_bucket), _step2; !(_step2 = _iterator2()).done;) {
		        var _n = _step2.value;
		        body[index++] = _n;
		      }
		    }
		    return body;
		  }

		  function normalizeOptions$6(config) {
		    var _config$options = config.options,
		      filename = _config$options.filename,
		      cwd = _config$options.cwd,
		      _config$options$filen = _config$options.filenameRelative,
		      filenameRelative = _config$options$filen === void 0 ? typeof filename === "string" ? path$1.relative(cwd, filename) : "unknown" : _config$options$filen,
		      _config$options$sourc = _config$options.sourceType,
		      sourceType = _config$options$sourc === void 0 ? "module" : _config$options$sourc,
		      inputSourceMap = _config$options.inputSourceMap,
		      _config$options$sourc2 = _config$options.sourceMaps,
		      sourceMaps = _config$options$sourc2 === void 0 ? !!inputSourceMap : _config$options$sourc2,
		      _config$options$sourc3 = _config$options.sourceRoot,
		      sourceRoot = _config$options$sourc3 === void 0 ? config.options.moduleRoot : _config$options$sourc3,
		      _config$options$sourc4 = _config$options.sourceFileName,
		      sourceFileName = _config$options$sourc4 === void 0 ? path$1.basename(filenameRelative) : _config$options$sourc4,
		      _config$options$comme = _config$options.comments,
		      comments = _config$options$comme === void 0 ? true : _config$options$comme,
		      _config$options$compa = _config$options.compact,
		      compact = _config$options$compa === void 0 ? "auto" : _config$options$compa;
		    var opts = config.options;
		    var options = Object.assign({}, opts, {
		      parserOpts: Object.assign({
		        sourceType: path$1.extname(filenameRelative) === ".mjs" ? "module" : sourceType,
		        sourceFileName: filename,
		        plugins: []
		      }, opts.parserOpts),
		      generatorOpts: Object.assign({
		        filename: filename,
		        auxiliaryCommentBefore: opts.auxiliaryCommentBefore,
		        auxiliaryCommentAfter: opts.auxiliaryCommentAfter,
		        retainLines: opts.retainLines,
		        comments: comments,
		        shouldPrintComment: opts.shouldPrintComment,
		        compact: compact,
		        minified: opts.minified,
		        sourceMaps: sourceMaps,
		        sourceRoot: sourceRoot,
		        sourceFileName: sourceFileName
		      }, opts.generatorOpts)
		    });
		    for (var _iterator = _createForOfIteratorHelperLoose(config.passes), _step; !(_step = _iterator()).done;) {
		      var plugins = _step.value;
		      for (var _iterator2 = _createForOfIteratorHelperLoose(plugins), _step2; !(_step2 = _iterator2()).done;) {
		        var plugin = _step2.value;
		        if (plugin.manipulateOptions) {
		          plugin.manipulateOptions(options, options.parserOpts);
		        }
		      }
		    }
		    return options;
		  }

		  var fs = {};

		  var convertSourceMap = {};

		  (function (exports) {

		    Object.defineProperty(exports, 'commentRegex', {
		      get: function getCommentRegex() {
		        return /^\s*?\/[\/\*][@#]\s+?sourceMappingURL=data:(((?:application|text)\/json)(?:;charset=([^;,]+?)?)?)?(?:;(base64))?,(.*?)$/mg;
		      }
		    });
		    Object.defineProperty(exports, 'mapFileCommentRegex', {
		      get: function getMapFileCommentRegex() {
		        return /(?:\/\/[@#][ \t]+?sourceMappingURL=([^\s'"`]+?)[ \t]*?$)|(?:\/\*[@#][ \t]+sourceMappingURL=([^*]+?)[ \t]*?(?:\*\/){1}[ \t]*?$)/mg;
		      }
		    });
		    var decodeBase64;
		    if (typeof Buffer$1 !== 'undefined') {
		      if (typeof Buffer$1.from === 'function') {
		        decodeBase64 = decodeBase64WithBufferFrom;
		      } else {
		        decodeBase64 = decodeBase64WithNewBuffer;
		      }
		    } else {
		      decodeBase64 = decodeBase64WithAtob;
		    }
		    function decodeBase64WithBufferFrom(base64) {
		      return Buffer$1.from(base64, 'base64').toString();
		    }
		    function decodeBase64WithNewBuffer(base64) {
		      if (typeof value === 'number') {
		        throw new TypeError('The value to decode must not be of type number.');
		      }
		      return new Buffer$1(base64, 'base64').toString();
		    }
		    function decodeBase64WithAtob(base64) {
		      return decodeURIComponent(escape(atob(base64)));
		    }
		    function stripComment(sm) {
		      return sm.split(',').pop();
		    }
		    function readFromFileMap(sm, read) {
		      var r = exports.mapFileCommentRegex.exec(sm);
		      var filename = r[1] || r[2];
		      try {
		        var sm = read(filename);
		        if (sm != null && typeof sm["catch"] === 'function') {
		          return sm["catch"](throwError);
		        } else {
		          return sm;
		        }
		      } catch (e) {
		        throwError(e);
		      }
		      function throwError(e) {
		        throw new Error('An error occurred while trying to read the map file at ' + filename + '\n' + e.stack);
		      }
		    }
		    function Converter(sm, opts) {
		      opts = opts || {};
		      if (opts.hasComment) {
		        sm = stripComment(sm);
		      }
		      if (opts.encoding === 'base64') {
		        sm = decodeBase64(sm);
		      } else if (opts.encoding === 'uri') {
		        sm = decodeURIComponent(sm);
		      }
		      if (opts.isJSON || opts.encoding) {
		        sm = JSON.parse(sm);
		      }
		      this.sourcemap = sm;
		    }
		    Converter.prototype.toJSON = function (space) {
		      return JSON.stringify(this.sourcemap, null, space);
		    };
		    if (typeof Buffer$1 !== 'undefined') {
		      if (typeof Buffer$1.from === 'function') {
		        Converter.prototype.toBase64 = encodeBase64WithBufferFrom;
		      } else {
		        Converter.prototype.toBase64 = encodeBase64WithNewBuffer;
		      }
		    } else {
		      Converter.prototype.toBase64 = encodeBase64WithBtoa;
		    }
		    function encodeBase64WithBufferFrom() {
		      var json = this.toJSON();
		      return Buffer$1.from(json, 'utf8').toString('base64');
		    }
		    function encodeBase64WithNewBuffer() {
		      var json = this.toJSON();
		      if (typeof json === 'number') {
		        throw new TypeError('The json to encode must not be of type number.');
		      }
		      return new Buffer$1(json, 'utf8').toString('base64');
		    }
		    function encodeBase64WithBtoa() {
		      var json = this.toJSON();
		      return btoa(unescape(encodeURIComponent(json)));
		    }
		    Converter.prototype.toURI = function () {
		      var json = this.toJSON();
		      return encodeURIComponent(json);
		    };
		    Converter.prototype.toComment = function (options) {
		      var encoding, content, data;
		      if (options != null && options.encoding === 'uri') {
		        encoding = '';
		        content = this.toURI();
		      } else {
		        encoding = ';base64';
		        content = this.toBase64();
		      }
		      data = 'sourceMappingURL=data:application/json;charset=utf-8' + encoding + ',' + content;
		      return options != null && options.multiline ? '/*# ' + data + ' */' : '//# ' + data;
		    };
		    Converter.prototype.toObject = function () {
		      return JSON.parse(this.toJSON());
		    };
		    Converter.prototype.addProperty = function (key, value) {
		      if (this.sourcemap.hasOwnProperty(key)) throw new Error('property "' + key + '" already exists on the sourcemap, use set property instead');
		      return this.setProperty(key, value);
		    };
		    Converter.prototype.setProperty = function (key, value) {
		      this.sourcemap[key] = value;
		      return this;
		    };
		    Converter.prototype.getProperty = function (key) {
		      return this.sourcemap[key];
		    };
		    exports.fromObject = function (obj) {
		      return new Converter(obj);
		    };
		    exports.fromJSON = function (json) {
		      return new Converter(json, {
		        isJSON: true
		      });
		    };
		    exports.fromURI = function (uri) {
		      return new Converter(uri, {
		        encoding: 'uri'
		      });
		    };
		    exports.fromBase64 = function (base64) {
		      return new Converter(base64, {
		        encoding: 'base64'
		      });
		    };
		    exports.fromComment = function (comment) {
		      var m, encoding;
		      comment = comment.replace(/^\/\*/g, '//').replace(/\*\/$/g, '');
		      m = exports.commentRegex.exec(comment);
		      encoding = m && m[4] || 'uri';
		      return new Converter(comment, {
		        encoding: encoding,
		        hasComment: true
		      });
		    };
		    function makeConverter(sm) {
		      return new Converter(sm, {
		        isJSON: true
		      });
		    }
		    exports.fromMapFileComment = function (comment, read) {
		      if (typeof read === 'string') {
		        throw new Error('String directory paths are no longer supported with `fromMapFileComment`\n' + 'Please review the Upgrading documentation at https://github.com/thlorenz/convert-source-map#upgrading');
		      }
		      var sm = readFromFileMap(comment, read);
		      if (sm != null && typeof sm.then === 'function') {
		        return sm.then(makeConverter);
		      } else {
		        return makeConverter(sm);
		      }
		    };
		    exports.fromSource = function (content) {
		      var m = content.match(exports.commentRegex);
		      return m ? exports.fromComment(m.pop()) : null;
		    };
		    exports.fromMapFileSource = function (content, read) {
		      if (typeof read === 'string') {
		        throw new Error('String directory paths are no longer supported with `fromMapFileSource`\n' + 'Please review the Upgrading documentation at https://github.com/thlorenz/convert-source-map#upgrading');
		      }
		      var m = content.match(exports.mapFileCommentRegex);
		      return m ? exports.fromMapFileComment(m.pop(), read) : null;
		    };
		    exports.removeComments = function (src) {
		      return src.replace(exports.commentRegex, '');
		    };
		    exports.removeMapFileComments = function (src) {
		      return src.replace(exports.mapFileCommentRegex, '');
		    };
		    exports.generateMapFileComment = function (file, options) {
		      var data = 'sourceMappingURL=' + file;
		      return options && options.multiline ? '/*# ' + data + ' */' : '//# ' + data;
		    };
		  })(convertSourceMap);

		  var pluginNameMap = {
		    asyncDoExpressions: {
		      syntax: {
		        name: "@babel/plugin-syntax-async-do-expressions",
		        url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-async-do-expressions"
		      }
		    },
		    decimal: {
		      syntax: {
		        name: "@babel/plugin-syntax-decimal",
		        url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-decimal"
		      }
		    },
		    decorators: {
		      syntax: {
		        name: "@babel/plugin-syntax-decorators",
		        url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-decorators"
		      },
		      transform: {
		        name: "@babel/plugin-proposal-decorators",
		        url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-proposal-decorators"
		      }
		    },
		    doExpressions: {
		      syntax: {
		        name: "@babel/plugin-syntax-do-expressions",
		        url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-do-expressions"
		      },
		      transform: {
		        name: "@babel/plugin-proposal-do-expressions",
		        url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-proposal-do-expressions"
		      }
		    },
		    exportDefaultFrom: {
		      syntax: {
		        name: "@babel/plugin-syntax-export-default-from",
		        url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-export-default-from"
		      },
		      transform: {
		        name: "@babel/plugin-proposal-export-default-from",
		        url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-proposal-export-default-from"
		      }
		    },
		    flow: {
		      syntax: {
		        name: "@babel/plugin-syntax-flow",
		        url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-flow"
		      },
		      transform: {
		        name: "@babel/preset-flow",
		        url: "https://github.com/babel/babel/tree/main/packages/babel-preset-flow"
		      }
		    },
		    functionBind: {
		      syntax: {
		        name: "@babel/plugin-syntax-function-bind",
		        url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-function-bind"
		      },
		      transform: {
		        name: "@babel/plugin-proposal-function-bind",
		        url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-proposal-function-bind"
		      }
		    },
		    functionSent: {
		      syntax: {
		        name: "@babel/plugin-syntax-function-sent",
		        url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-function-sent"
		      },
		      transform: {
		        name: "@babel/plugin-proposal-function-sent",
		        url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-proposal-function-sent"
		      }
		    },
		    jsx: {
		      syntax: {
		        name: "@babel/plugin-syntax-jsx",
		        url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-jsx"
		      },
		      transform: {
		        name: "@babel/preset-react",
		        url: "https://github.com/babel/babel/tree/main/packages/babel-preset-react"
		      }
		    },
		    importAttributes: {
		      syntax: {
		        name: "@babel/plugin-syntax-import-attributes",
		        url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-import-attributes"
		      }
		    },
		    pipelineOperator: {
		      syntax: {
		        name: "@babel/plugin-syntax-pipeline-operator",
		        url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-pipeline-operator"
		      },
		      transform: {
		        name: "@babel/plugin-proposal-pipeline-operator",
		        url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-proposal-pipeline-operator"
		      }
		    },
		    recordAndTuple: {
		      syntax: {
		        name: "@babel/plugin-syntax-record-and-tuple",
		        url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-record-and-tuple"
		      }
		    },
		    throwExpressions: {
		      syntax: {
		        name: "@babel/plugin-syntax-throw-expressions",
		        url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-throw-expressions"
		      },
		      transform: {
		        name: "@babel/plugin-proposal-throw-expressions",
		        url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-proposal-throw-expressions"
		      }
		    },
		    typescript: {
		      syntax: {
		        name: "@babel/plugin-syntax-typescript",
		        url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-typescript"
		      },
		      transform: {
		        name: "@babel/preset-typescript",
		        url: "https://github.com/babel/babel/tree/main/packages/babel-preset-typescript"
		      }
		    }
		  };
		  {
		    Object.assign(pluginNameMap, {
		      asyncGenerators: {
		        syntax: {
		          name: "@babel/plugin-syntax-async-generators",
		          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-async-generators"
		        },
		        transform: {
		          name: "@babel/plugin-transform-async-generator-functions",
		          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-transform-async-generator-functions"
		        }
		      },
		      classProperties: {
		        syntax: {
		          name: "@babel/plugin-syntax-class-properties",
		          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-class-properties"
		        },
		        transform: {
		          name: "@babel/plugin-transform-class-properties",
		          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-transform-class-properties"
		        }
		      },
		      classPrivateProperties: {
		        syntax: {
		          name: "@babel/plugin-syntax-class-properties",
		          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-class-properties"
		        },
		        transform: {
		          name: "@babel/plugin-transform-class-properties",
		          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-transform-class-properties"
		        }
		      },
		      classPrivateMethods: {
		        syntax: {
		          name: "@babel/plugin-syntax-class-properties",
		          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-class-properties"
		        },
		        transform: {
		          name: "@babel/plugin-transform-private-methods",
		          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-transform-private-methods"
		        }
		      },
		      classStaticBlock: {
		        syntax: {
		          name: "@babel/plugin-syntax-class-static-block",
		          url: "https://github.com/babel/babel/tree/HEAD/packages/babel-plugin-syntax-class-static-block"
		        },
		        transform: {
		          name: "@babel/plugin-transform-class-static-block",
		          url: "https://github.com/babel/babel/tree/HEAD/packages/babel-plugin-transform-class-static-block"
		        }
		      },
		      dynamicImport: {
		        syntax: {
		          name: "@babel/plugin-syntax-dynamic-import",
		          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-dynamic-import"
		        }
		      },
		      exportNamespaceFrom: {
		        syntax: {
		          name: "@babel/plugin-syntax-export-namespace-from",
		          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-export-namespace-from"
		        },
		        transform: {
		          name: "@babel/plugin-transform-export-namespace-from",
		          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-transform-export-namespace-from"
		        }
		      },
		      importAssertions: {
		        syntax: {
		          name: "@babel/plugin-syntax-import-assertions",
		          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-import-assertions"
		        }
		      },
		      importMeta: {
		        syntax: {
		          name: "@babel/plugin-syntax-import-meta",
		          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-import-meta"
		        }
		      },
		      logicalAssignment: {
		        syntax: {
		          name: "@babel/plugin-syntax-logical-assignment-operators",
		          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-logical-assignment-operators"
		        },
		        transform: {
		          name: "@babel/plugin-transform-logical-assignment-operators",
		          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-transform-logical-assignment-operators"
		        }
		      },
		      moduleStringNames: {
		        syntax: {
		          name: "@babel/plugin-syntax-module-string-names",
		          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-module-string-names"
		        }
		      },
		      numericSeparator: {
		        syntax: {
		          name: "@babel/plugin-syntax-numeric-separator",
		          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-numeric-separator"
		        },
		        transform: {
		          name: "@babel/plugin-transform-numeric-separator",
		          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-transform-numeric-separator"
		        }
		      },
		      nullishCoalescingOperator: {
		        syntax: {
		          name: "@babel/plugin-syntax-nullish-coalescing-operator",
		          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-nullish-coalescing-operator"
		        },
		        transform: {
		          name: "@babel/plugin-transform-nullish-coalescing-operator",
		          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-transform-nullish-coalescing-opearator"
		        }
		      },
		      objectRestSpread: {
		        syntax: {
		          name: "@babel/plugin-syntax-object-rest-spread",
		          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-object-rest-spread"
		        },
		        transform: {
		          name: "@babel/plugin-transform-object-rest-spread",
		          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-transform-object-rest-spread"
		        }
		      },
		      optionalCatchBinding: {
		        syntax: {
		          name: "@babel/plugin-syntax-optional-catch-binding",
		          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-optional-catch-binding"
		        },
		        transform: {
		          name: "@babel/plugin-transform-optional-catch-binding",
		          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-transform-optional-catch-binding"
		        }
		      },
		      optionalChaining: {
		        syntax: {
		          name: "@babel/plugin-syntax-optional-chaining",
		          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-optional-chaining"
		        },
		        transform: {
		          name: "@babel/plugin-transform-optional-chaining",
		          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-transform-optional-chaining"
		        }
		      },
		      privateIn: {
		        syntax: {
		          name: "@babel/plugin-syntax-private-property-in-object",
		          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-syntax-private-property-in-object"
		        },
		        transform: {
		          name: "@babel/plugin-transform-private-property-in-object",
		          url: "https://github.com/babel/babel/tree/main/packages/babel-plugin-transform-private-property-in-object"
		        }
		      },
		      regexpUnicodeSets: {
		        syntax: {
		          name: "@babel/plugin-syntax-unicode-sets-regex",
		          url: "https://github.com/babel/babel/blob/main/packages/babel-plugin-syntax-unicode-sets-regex/README.md"
		        },
		        transform: {
		          name: "@babel/plugin-transform-unicode-sets-regex",
		          url: "https://github.com/babel/babel/blob/main/packages/babel-plugin-proposalunicode-sets-regex/README.md"
		        }
		      }
		    });
		  }
		  var getNameURLCombination = function getNameURLCombination(_ref) {
		    var name = _ref.name,
		      url = _ref.url;
		    return name + " (" + url + ")";
		  };
		  function generateMissingPluginMessage(missingPluginName, loc, codeFrame, filename) {
		    var helpMessage = "Support for the experimental syntax '" + missingPluginName + "' isn't currently enabled " + ("(" + loc.line + ":" + (loc.column + 1) + "):\n\n") + codeFrame;
		    var pluginInfo = pluginNameMap[missingPluginName];
		    if (pluginInfo) {
		      var syntaxPlugin = pluginInfo.syntax,
		        transformPlugin = pluginInfo.transform;
		      if (syntaxPlugin) {
		        var syntaxPluginInfo = getNameURLCombination(syntaxPlugin);
		        if (transformPlugin) {
		          var transformPluginInfo = getNameURLCombination(transformPlugin);
		          var sectionType = transformPlugin.name.startsWith("@babel/plugin") ? "plugins" : "presets";
		          helpMessage += "\n\nAdd " + transformPluginInfo + " to the '" + sectionType + "' section of your Babel config to enable transformation.\nIf you want to leave it as-is, add " + syntaxPluginInfo + " to the 'plugins' section to enable parsing.";
		        } else {
		          helpMessage += "\n\nAdd " + syntaxPluginInfo + " to the 'plugins' section of your Babel config " + "to enable parsing.";
		        }
		      }
		    }
		    var msgFilename = filename === "unknown" ? "<name of the input file>" : filename;
		    helpMessage += "\n\nIf you already added the plugin for this syntax to your config, it's possible that your config isn't being loaded.\nYou can re-run Babel with the BABEL_SHOW_CONFIG_FOR environment variable to show the loaded configuration:\n\tnpx cross-env BABEL_SHOW_CONFIG_FOR=" + msgFilename + " <your build command>\nSee https://babeljs.io/docs/configuration#print-effective-configs for more info.\n";
		    return helpMessage;
		  }

		  function parser$1(pluginPasses, _ref, code) {
		    var parserOpts = _ref.parserOpts,
		      _ref$highlightCode = _ref.highlightCode,
		      highlightCode = _ref$highlightCode === void 0 ? true : _ref$highlightCode,
		      _ref$filename = _ref.filename,
		      filename = _ref$filename === void 0 ? "unknown" : _ref$filename;
		    return _regeneratorRuntime().mark(function _callee() {
		      var results, _iterator, _step, plugins, _iterator2, _step2, plugin, parserOverride, ast, loc, missingPlugin, codeFrame;
		      return _regeneratorRuntime().wrap(function _callee$(_context) {
		        while (1) switch (_context.prev = _context.next) {
		          case 0:
		            _context.prev = 0;
		            results = [];
		            for (_iterator = _createForOfIteratorHelperLoose(pluginPasses); !(_step = _iterator()).done;) {
		              plugins = _step.value;
		              for (_iterator2 = _createForOfIteratorHelperLoose(plugins); !(_step2 = _iterator2()).done;) {
		                plugin = _step2.value;
		                parserOverride = plugin.parserOverride;
		                if (parserOverride) {
		                  ast = parserOverride(code, parserOpts, parse$4);
		                  if (ast !== undefined) results.push(ast);
		                }
		              }
		            }
		            if (!(results.length === 0)) {
		              _context.next = 7;
		              break;
		            }
		            return _context.abrupt("return", parse$4(code, parserOpts));
		          case 7:
		            if (!(results.length === 1)) {
		              _context.next = 12;
		              break;
		            }
		            return _context.delegateYield([], "t0", 9);
		          case 9:
		            if (!(typeof results[0].then === "function")) {
		              _context.next = 11;
		              break;
		            }
		            throw new Error("You appear to be using an async parser plugin, " + "which your current version of Babel does not support. " + "If you're using a published plugin, you may need to upgrade " + "your @babel/core version.");
		          case 11:
		            return _context.abrupt("return", results[0]);
		          case 12:
		            throw new Error("More than one plugin attempted to override parsing.");
		          case 15:
		            _context.prev = 15;
		            _context.t1 = _context["catch"](0);
		            if (_context.t1.code === "BABEL_PARSER_SOURCETYPE_MODULE_REQUIRED") {
		              _context.t1.message += "\nConsider renaming the file to '.mjs', or setting sourceType:module " + "or sourceType:unambiguous in your Babel config for this file.";
		            }
		            loc = _context.t1.loc, missingPlugin = _context.t1.missingPlugin;
		            if (loc) {
		              codeFrame = codeFrameColumns(code, {
		                start: {
		                  line: loc.line,
		                  column: loc.column + 1
		                }
		              }, {
		                highlightCode: highlightCode
		              });
		              if (missingPlugin) {
		                _context.t1.message = filename + ": " + generateMissingPluginMessage(missingPlugin[0], loc, codeFrame, filename);
		              } else {
		                _context.t1.message = filename + ": " + _context.t1.message + "\n\n" + codeFrame;
		              }
		              _context.t1.code = "BABEL_PARSE_ERROR";
		            }
		            throw _context.t1;
		          case 21:
		          case "end":
		            return _context.stop();
		        }
		      }, _callee, null, [[0, 15]]);
		    })();
		  }

		  function deepClone(value, cache) {
		    if (value !== null) {
		      if (cache.has(value)) return cache.get(value);
		      var cloned;
		      if (Array.isArray(value)) {
		        cloned = new Array(value.length);
		        cache.set(value, cloned);
		        for (var i = 0; i < value.length; i++) {
		          cloned[i] = typeof value[i] !== "object" ? value[i] : deepClone(value[i], cache);
		        }
		      } else {
		        cloned = {};
		        cache.set(value, cloned);
		        var keys = Object.keys(value);
		        for (var _i = 0; _i < keys.length; _i++) {
		          var key = keys[_i];
		          cloned[key] = typeof value[key] !== "object" ? value[key] : deepClone(value[key], cache);
		        }
		      }
		      return cloned;
		    }
		    return value;
		  }
		  function cloneDeep (value) {
		    if (typeof value !== "object") return value;
		    return deepClone(value, new Map());
		  }

		  var _marked$2 = _regeneratorRuntime().mark(normalizeFile);
		  var file = file$2,
		    traverseFast = traverseFast$2;
		  var debug = browserExports("babel:transform:file");
		  var INLINE_SOURCEMAP_REGEX = /^[@#]\s+sourceMappingURL=data:(?:application|text)\/json;(?:charset[:=]\S+?;)?base64,(?:.*)$/;
		  var EXTERNAL_SOURCEMAP_REGEX = /^[@#][ \t]+sourceMappingURL=([^\s'"`]+)[ \t]*$/;
		  function normalizeFile(pluginPasses, options, code, ast) {
		    var inputMap, lastComment, _lastComment, match, inputMapContent;
		    return _regeneratorRuntime().wrap(function normalizeFile$(_context) {
		      while (1) switch (_context.prev = _context.next) {
		        case 0:
		          code = "" + (code || "");
		          if (!ast) {
		            _context.next = 11;
		            break;
		          }
		          if (!(ast.type === "Program")) {
		            _context.next = 6;
		            break;
		          }
		          ast = file(ast, [], []);
		          _context.next = 8;
		          break;
		        case 6:
		          if (!(ast.type !== "File")) {
		            _context.next = 8;
		            break;
		          }
		          throw new Error("AST root must be a Program or File node");
		        case 8:
		          if (options.cloneInputAst) {
		            ast = cloneDeep(ast);
		          }
		          _context.next = 13;
		          break;
		        case 11:
		          return _context.delegateYield(parser$1(pluginPasses, options, code), "t0", 12);
		        case 12:
		          ast = _context.t0;
		        case 13:
		          inputMap = null;
		          if (options.inputSourceMap !== false) {
		            if (typeof options.inputSourceMap === "object") {
		              inputMap = convertSourceMap.fromObject(options.inputSourceMap);
		            }
		            if (!inputMap) {
		              lastComment = extractComments(INLINE_SOURCEMAP_REGEX, ast);
		              if (lastComment) {
		                try {
		                  inputMap = convertSourceMap.fromComment("//" + lastComment);
		                } catch (err) {
		                  {
		                    debug("discarding unknown inline input sourcemap");
		                  }
		                }
		              }
		            }
		            if (!inputMap) {
		              _lastComment = extractComments(EXTERNAL_SOURCEMAP_REGEX, ast);
		              if (typeof options.filename === "string" && _lastComment) {
		                try {
		                  match = EXTERNAL_SOURCEMAP_REGEX.exec(_lastComment);
		                  inputMapContent = fs.readFileSync(path$1.resolve(path$1.dirname(options.filename), match[1]), "utf8");
		                  inputMap = convertSourceMap.fromJSON(inputMapContent);
		                } catch (err) {
		                  debug("discarding unknown file input sourcemap", err);
		                }
		              } else if (_lastComment) {
		                debug("discarding un-loadable file input sourcemap");
		              }
		            }
		          }
		          return _context.abrupt("return", new File(options, {
		            code: code,
		            ast: ast,
		            inputMap: inputMap
		          }));
		        case 16:
		        case "end":
		          return _context.stop();
		      }
		    }, _marked$2);
		  }
		  function extractCommentsFromList(regex, comments, lastComment) {
		    if (comments) {
		      comments = comments.filter(function (_ref) {
		        var value = _ref.value;
		        if (regex.test(value)) {
		          lastComment = value;
		          return false;
		        }
		        return true;
		      });
		    }
		    return [comments, lastComment];
		  }
		  function extractComments(regex, ast) {
		    var lastComment = null;
		    traverseFast(ast, function (node) {
		      var _extractCommentsFromL = extractCommentsFromList(regex, node.leadingComments, lastComment);
		      var _extractCommentsFromL2 = _slicedToArray(_extractCommentsFromL, 2);
		      node.leadingComments = _extractCommentsFromL2[0];
		      lastComment = _extractCommentsFromL2[1];
		      var _extractCommentsFromL3 = extractCommentsFromList(regex, node.innerComments, lastComment);
		      var _extractCommentsFromL4 = _slicedToArray(_extractCommentsFromL3, 2);
		      node.innerComments = _extractCommentsFromL4[0];
		      lastComment = _extractCommentsFromL4[1];
		      var _extractCommentsFromL5 = extractCommentsFromList(regex, node.trailingComments, lastComment);
		      var _extractCommentsFromL6 = _slicedToArray(_extractCommentsFromL5, 2);
		      node.trailingComments = _extractCommentsFromL6[0];
		      lastComment = _extractCommentsFromL6[1];
		    });
		    return lastComment;
		  }

		  var genMapping_umd = {exports: {}};

		  (function (module, exports) {
		    (function (global, factory) {
		      factory(exports, requireSetArray_umd(), requireSourcemapCodec_umd()) ;
		    })(commonjsGlobal$1, function (exports, setArray, sourcemapCodec) {
		      exports.addSegment = void 0;
		      exports.addMapping = void 0;
		      exports.setSourceContent = void 0;
		      exports.decodedMap = void 0;
		      exports.encodedMap = void 0;
		      exports.allMappings = void 0;
		      var GenMapping = _createClass(function GenMapping(_temp) {
		        var _ref = _temp === void 0 ? {} : _temp,
		          file = _ref.file,
		          sourceRoot = _ref.sourceRoot;
		        this._names = new setArray.SetArray();
		        this._sources = new setArray.SetArray();
		        this._sourcesContent = [];
		        this._mappings = [];
		        this.file = file;
		        this.sourceRoot = sourceRoot;
		      });
		      (function () {
		        exports.addSegment = function (map, genLine, genColumn, source, sourceLine, sourceColumn, name) {
		          var mappings = map._mappings,
		            sources = map._sources,
		            sourcesContent = map._sourcesContent,
		            names = map._names;
		          var line = getLine(mappings, genLine);
		          if (source == null) {
		            var _seg = [genColumn];
		            var _index = getColumnIndex(line, genColumn, _seg);
		            return insert(line, _index, _seg);
		          }
		          var sourcesIndex = setArray.put(sources, source);
		          var seg = name ? [genColumn, sourcesIndex, sourceLine, sourceColumn, setArray.put(names, name)] : [genColumn, sourcesIndex, sourceLine, sourceColumn];
		          var index = getColumnIndex(line, genColumn, seg);
		          if (sourcesIndex === sourcesContent.length) sourcesContent[sourcesIndex] = null;
		          insert(line, index, seg);
		        };
		        exports.addMapping = function (map, mapping) {
		          var generated = mapping.generated,
		            source = mapping.source,
		            original = mapping.original,
		            name = mapping.name;
		          return exports.addSegment(map, generated.line - 1, generated.column, source, original == null ? undefined : original.line - 1, original === null || original === void 0 ? void 0 : original.column, name);
		        };
		        exports.setSourceContent = function (map, source, content) {
		          var sources = map._sources,
		            sourcesContent = map._sourcesContent;
		          sourcesContent[setArray.put(sources, source)] = content;
		        };
		        exports.decodedMap = function (map) {
		          var file = map.file,
		            sourceRoot = map.sourceRoot,
		            mappings = map._mappings,
		            sources = map._sources,
		            sourcesContent = map._sourcesContent,
		            names = map._names;
		          return {
		            version: 3,
		            file: file,
		            names: names.array,
		            sourceRoot: sourceRoot || undefined,
		            sources: sources.array,
		            sourcesContent: sourcesContent,
		            mappings: mappings
		          };
		        };
		        exports.encodedMap = function (map) {
		          var decoded = exports.decodedMap(map);
		          return Object.assign(Object.assign({}, decoded), {
		            mappings: sourcemapCodec.encode(decoded.mappings)
		          });
		        };
		        exports.allMappings = function (map) {
		          var out = [];
		          var mappings = map._mappings,
		            sources = map._sources,
		            names = map._names;
		          for (var i = 0; i < mappings.length; i++) {
		            var line = mappings[i];
		            for (var j = 0; j < line.length; j++) {
		              var seg = line[j];
		              var generated = {
		                line: i + 1,
		                column: seg[0]
		              };
		              var source = undefined;
		              var original = undefined;
		              var name = undefined;
		              if (seg.length !== 1) {
		                source = sources.array[seg[1]];
		                original = {
		                  line: seg[2] + 1,
		                  column: seg[3]
		                };
		                if (seg.length === 5) name = names.array[seg[4]];
		              }
		              out.push({
		                generated: generated,
		                source: source,
		                original: original,
		                name: name
		              });
		            }
		          }
		          return out;
		        };
		      })();
		      function getLine(mappings, index) {
		        for (var i = mappings.length; i <= index; i++) {
		          mappings[i] = [];
		        }
		        return mappings[index];
		      }
		      function getColumnIndex(line, column, seg) {
		        var index = line.length;
		        for (var i = index - 1; i >= 0; i--, index--) {
		          var current = line[i];
		          var col = current[0];
		          if (col > column) continue;
		          if (col < column) break;
		          var cmp = compare(current, seg);
		          if (cmp === 0) return index;
		          if (cmp < 0) break;
		        }
		        return index;
		      }
		      function compare(a, b) {
		        var cmp = compareNum(a.length, b.length);
		        if (cmp !== 0) return cmp;
		        if (a.length === 1) return 0;
		        cmp = compareNum(a[1], b[1]);
		        if (cmp !== 0) return cmp;
		        cmp = compareNum(a[2], b[2]);
		        if (cmp !== 0) return cmp;
		        cmp = compareNum(a[3], b[3]);
		        if (cmp !== 0) return cmp;
		        if (a.length === 4) return 0;
		        return compareNum(a[4], b[4]);
		      }
		      function compareNum(a, b) {
		        return a - b;
		      }
		      function insert(array, index, value) {
		        if (index === -1) return;
		        for (var i = array.length; i > index; i--) {
		          array[i] = array[i - 1];
		        }
		        array[index] = value;
		      }
		      exports.GenMapping = GenMapping;
		      Object.defineProperty(exports, '__esModule', {
		        value: true
		      });
		    });
		  })(genMapping_umd, genMapping_umd.exports);
		  var genMapping_umdExports = genMapping_umd.exports;

		  var SOURCELESS_MAPPING = {
		    source: null,
		    column: null,
		    line: null,
		    name: null,
		    content: null
		  };
		  var EMPTY_SOURCES = [];
		  function Source(map, sources, source, content) {
		    return {
		      map: map,
		      sources: sources,
		      source: source,
		      content: content
		    };
		  }
		  function MapSource(map, sources) {
		    return Source(map, sources, '', null);
		  }
		  function OriginalSource(source, content) {
		    return Source(null, EMPTY_SOURCES, source, content);
		  }
		  function traceMappings(tree) {
		    var gen = new genMapping_umdExports.GenMapping({
		      file: tree.map.file
		    });
		    var rootSources = tree.sources,
		      map = tree.map;
		    var rootNames = map.names;
		    var rootMappings = traceMapping_umdExports.decodedMappings(map);
		    for (var i = 0; i < rootMappings.length; i++) {
		      var segments = rootMappings[i];
		      var lastSource = null;
		      var lastSourceLine = null;
		      var lastSourceColumn = null;
		      for (var j = 0; j < segments.length; j++) {
		        var segment = segments[j];
		        var genCol = segment[0];
		        var traced = SOURCELESS_MAPPING;
		        if (segment.length !== 1) {
		          var _source = rootSources[segment[1]];
		          traced = originalPositionFor(_source, segment[2], segment[3], segment.length === 5 ? rootNames[segment[4]] : '');
		          if (traced == null) continue;
		        }
		        var _traced = traced,
		          column = _traced.column,
		          line = _traced.line,
		          name = _traced.name,
		          content = _traced.content,
		          source = _traced.source;
		        if (line === lastSourceLine && column === lastSourceColumn && source === lastSource) {
		          continue;
		        }
		        lastSourceLine = line;
		        lastSourceColumn = column;
		        lastSource = source;
		        genMapping_umdExports.addSegment(gen, i, genCol, source, line, column, name);
		        if (content != null) genMapping_umdExports.setSourceContent(gen, source, content);
		      }
		    }
		    return gen;
		  }
		  function originalPositionFor(source, line, column, name) {
		    if (!source.map) {
		      return {
		        column: column,
		        line: line,
		        name: name,
		        source: source.source,
		        content: source.content
		      };
		    }
		    var segment = traceMapping_umdExports.traceSegment(source.map, line, column);
		    if (segment == null) return null;
		    if (segment.length === 1) return SOURCELESS_MAPPING;
		    return originalPositionFor(source.sources[segment[1]], segment[2], segment[3], segment.length === 5 ? source.map.names[segment[4]] : name);
		  }
		  function asArray(value) {
		    if (Array.isArray(value)) return value;
		    return [value];
		  }
		  function buildSourceMapTree(input, loader) {
		    var maps = asArray(input).map(function (m) {
		      return new traceMapping_umdExports.TraceMap(m, '');
		    });
		    var map = maps.pop();
		    for (var i = 0; i < maps.length; i++) {
		      if (maps[i].sources.length > 1) {
		        throw new Error("Transformation map " + i + " must have exactly one source file.\n" + 'Did you specify these with the most recent transformation maps first?');
		      }
		    }
		    var tree = build$1(map, loader, '', 0);
		    for (var _i = maps.length - 1; _i >= 0; _i--) {
		      tree = MapSource(maps[_i], [tree]);
		    }
		    return tree;
		  }
		  function build$1(map, loader, importer, importerDepth) {
		    var resolvedSources = map.resolvedSources,
		      sourcesContent = map.sourcesContent;
		    var depth = importerDepth + 1;
		    var children = resolvedSources.map(function (sourceFile, i) {
		      var ctx = {
		        importer: importer,
		        depth: depth,
		        source: sourceFile || '',
		        content: undefined
		      };
		      var sourceMap = loader(ctx.source, ctx);
		      var source = ctx.source,
		        content = ctx.content;
		      if (sourceMap) return build$1(new traceMapping_umdExports.TraceMap(sourceMap, source), loader, source, depth);
		      var sourceContent = content !== undefined ? content : sourcesContent ? sourcesContent[i] : null;
		      return OriginalSource(source, sourceContent);
		    });
		    return MapSource(map, children);
		  }
		  var SourceMap = function () {
		    function SourceMap(map, options) {
		      var out = options.decodedMappings ? genMapping_umdExports.decodedMap(map) : genMapping_umdExports.encodedMap(map);
		      this.version = out.version;
		      this.file = out.file;
		      this.mappings = out.mappings;
		      this.names = out.names;
		      this.sourceRoot = out.sourceRoot;
		      this.sources = out.sources;
		      if (!options.excludeContent) {
		        this.sourcesContent = out.sourcesContent;
		      }
		    }
		    var _proto = SourceMap.prototype;
		    _proto.toString = function toString() {
		      return JSON.stringify(this);
		    };
		    return _createClass(SourceMap);
		  }();
		  function remapping(input, loader, options) {
		    var opts = typeof options === 'object' ? options : {
		      excludeContent: !!options,
		      decodedMappings: false
		    };
		    var tree = buildSourceMapTree(input, loader);
		    return new SourceMap(traceMappings(tree), opts);
		  }

		  function mergeSourceMap(inputMap, map, sourceFileName) {
		    var source = sourceFileName.replace(/\\/g, "/");
		    var found = false;
		    var result = remapping(rootless(map), function (s, ctx) {
		      if (s === source && !found) {
		        found = true;
		        ctx.source = "";
		        return rootless(inputMap);
		      }
		      return null;
		    });
		    if (typeof inputMap.sourceRoot === "string") {
		      result.sourceRoot = inputMap.sourceRoot;
		    }
		    return Object.assign({}, result);
		  }
		  function rootless(map) {
		    return Object.assign({}, map, {
		      sourceRoot: null
		    });
		  }

		  function generateCode(pluginPasses, file) {
		    var opts = file.opts,
		      ast = file.ast,
		      code = file.code,
		      inputMap = file.inputMap;
		    var generatorOpts = opts.generatorOpts;
		    generatorOpts.inputSourceMap = inputMap == null ? void 0 : inputMap.toObject();
		    var results = [];
		    for (var _iterator = _createForOfIteratorHelperLoose(pluginPasses), _step; !(_step = _iterator()).done;) {
		      var plugins = _step.value;
		      for (var _iterator2 = _createForOfIteratorHelperLoose(plugins), _step2; !(_step2 = _iterator2()).done;) {
		        var plugin = _step2.value;
		        var generatorOverride = plugin.generatorOverride;
		        if (generatorOverride) {
		          var _result2 = generatorOverride(ast, generatorOpts, code, generate$1);
		          if (_result2 !== undefined) results.push(_result2);
		        }
		      }
		    }
		    var result;
		    if (results.length === 0) {
		      result = generate$1(ast, generatorOpts, code);
		    } else if (results.length === 1) {
		      result = results[0];
		      if (typeof result.then === "function") {
		        throw new Error("You appear to be using an async codegen plugin, " + "which your current version of Babel does not support. " + "If you're using a published plugin, " + "you may need to upgrade your @babel/core version.");
		      }
		    } else {
		      throw new Error("More than one plugin attempted to override codegen.");
		    }
		    var _result = result,
		      outputCode = _result.code,
		      _result$decodedMap = _result.decodedMap,
		      outputMap = _result$decodedMap === void 0 ? result.map : _result$decodedMap;
		    if (result.__mergedMap) {
		      outputMap = Object.assign({}, result.map);
		    } else {
		      if (outputMap) {
		        if (inputMap) {
		          outputMap = mergeSourceMap(inputMap.toObject(), outputMap, generatorOpts.sourceFileName);
		        } else {
		          outputMap = result.map;
		        }
		      }
		    }
		    if (opts.sourceMaps === "inline" || opts.sourceMaps === "both") {
		      outputCode += "\n" + convertSourceMap.fromObject(outputMap).toComment();
		    }
		    if (opts.sourceMaps === "inline") {
		      outputMap = null;
		    }
		    return {
		      outputCode: outputCode,
		      outputMap: outputMap
		    };
		  }

		  var _marked$1 = _regeneratorRuntime().mark(run$1),
		    _marked2$1 = _regeneratorRuntime().mark(transformFile$1);
		  function run$1(config, code, ast) {
		    var file, opts, _opts$filename, outputCode, outputMap, _generateCode, _opts$filename2;
		    return _regeneratorRuntime().wrap(function run$(_context) {
		      while (1) switch (_context.prev = _context.next) {
		        case 0:
		          return _context.delegateYield(normalizeFile(config.passes, normalizeOptions$6(config), code, ast), "t0", 1);
		        case 1:
		          file = _context.t0;
		          opts = file.opts;
		          _context.prev = 3;
		          return _context.delegateYield(transformFile$1(file, config.passes), "t1", 5);
		        case 5:
		          _context.next = 12;
		          break;
		        case 7:
		          _context.prev = 7;
		          _context.t2 = _context["catch"](3);
		          _context.t2.message = ((_opts$filename = opts.filename) != null ? _opts$filename : "unknown file") + ": " + _context.t2.message;
		          if (!_context.t2.code) {
		            _context.t2.code = "BABEL_TRANSFORM_ERROR";
		          }
		          throw _context.t2;
		        case 12:
		          _context.prev = 12;
		          if (opts.code !== false) {
		            _generateCode = generateCode(config.passes, file);
		            outputCode = _generateCode.outputCode;
		            outputMap = _generateCode.outputMap;
		          }
		          _context.next = 21;
		          break;
		        case 16:
		          _context.prev = 16;
		          _context.t3 = _context["catch"](12);
		          _context.t3.message = ((_opts$filename2 = opts.filename) != null ? _opts$filename2 : "unknown file") + ": " + _context.t3.message;
		          if (!_context.t3.code) {
		            _context.t3.code = "BABEL_GENERATE_ERROR";
		          }
		          throw _context.t3;
		        case 21:
		          return _context.abrupt("return", {
		            metadata: file.metadata,
		            options: opts,
		            ast: opts.ast === true ? file.ast : null,
		            code: outputCode === undefined ? null : outputCode,
		            map: outputMap === undefined ? null : outputMap,
		            sourceType: file.ast.program.sourceType,
		            externalDependencies: flattenToSet(config.externalDependencies)
		          });
		        case 22:
		        case "end":
		          return _context.stop();
		      }
		    }, _marked$1, null, [[3, 7], [12, 16]]);
		  }
		  function transformFile$1(file, pluginPasses) {
		    var _iterator, _step, pluginPairs, passPairs, passes, visitors, _iterator2, _step2, _plugin2, _pass2, _i, _passPairs, _passPairs$_i, plugin, pass, fn, result, visitor, _i2, _passPairs2, _passPairs2$_i, _plugin, _pass, _fn, _result;
		    return _regeneratorRuntime().wrap(function transformFile$(_context2) {
		      while (1) switch (_context2.prev = _context2.next) {
		        case 0:
		          _iterator = _createForOfIteratorHelperLoose(pluginPasses);
		        case 1:
		          if ((_step = _iterator()).done) {
		            _context2.next = 35;
		            break;
		          }
		          pluginPairs = _step.value;
		          passPairs = [];
		          passes = [];
		          visitors = [];
		          for (_iterator2 = _createForOfIteratorHelperLoose(pluginPairs.concat([loadBlockHoistPlugin()])); !(_step2 = _iterator2()).done;) {
		            _plugin2 = _step2.value;
		            _pass2 = new PluginPass(file, _plugin2.key, _plugin2.options);
		            passPairs.push([_plugin2, _pass2]);
		            passes.push(_pass2);
		            visitors.push(_plugin2.visitor);
		          }
		          _i = 0, _passPairs = passPairs;
		        case 8:
		          if (!(_i < _passPairs.length)) {
		            _context2.next = 19;
		            break;
		          }
		          _passPairs$_i = _slicedToArray(_passPairs[_i], 2), plugin = _passPairs$_i[0], pass = _passPairs$_i[1];
		          fn = plugin.pre;
		          if (!fn) {
		            _context2.next = 16;
		            break;
		          }
		          result = fn.call(pass, file);
		          return _context2.delegateYield([], "t0", 14);
		        case 14:
		          if (!isThenable(result)) {
		            _context2.next = 16;
		            break;
		          }
		          throw new Error("You appear to be using an plugin with an async .pre, " + "which your current version of Babel does not support. " + "If you're using a published plugin, you may need to upgrade " + "your @babel/core version.");
		        case 16:
		          _i++;
		          _context2.next = 8;
		          break;
		        case 19:
		          visitor = traverse.visitors.merge(visitors, passes, file.opts.wrapPluginVisitorMethod);
		          traverse(file.ast, visitor, file.scope);
		          _i2 = 0, _passPairs2 = passPairs;
		        case 22:
		          if (!(_i2 < _passPairs2.length)) {
		            _context2.next = 33;
		            break;
		          }
		          _passPairs2$_i = _slicedToArray(_passPairs2[_i2], 2), _plugin = _passPairs2$_i[0], _pass = _passPairs2$_i[1];
		          _fn = _plugin.post;
		          if (!_fn) {
		            _context2.next = 30;
		            break;
		          }
		          _result = _fn.call(_pass, file);
		          return _context2.delegateYield([], "t1", 28);
		        case 28:
		          if (!isThenable(_result)) {
		            _context2.next = 30;
		            break;
		          }
		          throw new Error("You appear to be using an plugin with an async .post, " + "which your current version of Babel does not support. " + "If you're using a published plugin, you may need to upgrade " + "your @babel/core version.");
		        case 30:
		          _i2++;
		          _context2.next = 22;
		          break;
		        case 33:
		          _context2.next = 1;
		          break;
		        case 35:
		        case "end":
		          return _context2.stop();
		      }
		    }, _marked2$1);
		  }
		  function isThenable(val) {
		    return !!val && (typeof val === "object" || typeof val === "function") && !!val.then && typeof val.then === "function";
		  }

		  var transformRunner = gensync(_regeneratorRuntime().mark(function transform(code, opts) {
		    var config;
		    return _regeneratorRuntime().wrap(function transform$(_context) {
		      while (1) switch (_context.prev = _context.next) {
		        case 0:
		          return _context.delegateYield(loadConfig(opts), "t0", 1);
		        case 1:
		          config = _context.t0;
		          if (!(config === null)) {
		            _context.next = 4;
		            break;
		          }
		          return _context.abrupt("return", null);
		        case 4:
		          return _context.delegateYield(run$1(config, code), "t1", 5);
		        case 5:
		          return _context.abrupt("return", _context.t1);
		        case 6:
		        case "end":
		          return _context.stop();
		      }
		    }, transform);
		  }));
		  var transform$3 = function transform(code, optsOrCallback, maybeCallback) {
		    var opts;
		    var callback;
		    if (typeof optsOrCallback === "function") {
		      callback = optsOrCallback;
		      opts = undefined;
		    } else {
		      opts = optsOrCallback;
		      callback = maybeCallback;
		    }
		    if (callback === undefined) {
		      {
		        return beginHiddenCallStack(transformRunner.sync)(code, opts);
		      }
		    }
		    beginHiddenCallStack(transformRunner.errback)(code, opts, callback);
		  };
		  function transformSync() {
		    return beginHiddenCallStack(transformRunner.sync).apply(void 0, arguments);
		  }
		  function transformAsync() {
		    return beginHiddenCallStack(transformRunner.async).apply(void 0, arguments);
		  }

		  var transformFile = function transformFile(filename, opts, callback) {
		    if (typeof opts === "function") {
		      callback = opts;
		    }
		    callback(new Error("Transforming files is not supported in browsers"), null);
		  };
		  function transformFileSync() {
		    throw new Error("Transforming files is not supported in browsers");
		  }
		  function transformFileAsync() {
		    return Promise.reject(new Error("Transforming files is not supported in browsers"));
		  }

		  var transformFromAstRunner = gensync(_regeneratorRuntime().mark(function _callee(ast, code, opts) {
		    var config;
		    return _regeneratorRuntime().wrap(function _callee$(_context) {
		      while (1) switch (_context.prev = _context.next) {
		        case 0:
		          return _context.delegateYield(loadConfig(opts), "t0", 1);
		        case 1:
		          config = _context.t0;
		          if (!(config === null)) {
		            _context.next = 4;
		            break;
		          }
		          return _context.abrupt("return", null);
		        case 4:
		          if (ast) {
		            _context.next = 6;
		            break;
		          }
		          throw new Error("No AST given");
		        case 6:
		          return _context.delegateYield(run$1(config, code, ast), "t1", 7);
		        case 7:
		          return _context.abrupt("return", _context.t1);
		        case 8:
		        case "end":
		          return _context.stop();
		      }
		    }, _callee);
		  }));
		  var transformFromAst$1 = function transformFromAst(ast, code, optsOrCallback, maybeCallback) {
		    var opts;
		    var callback;
		    if (typeof optsOrCallback === "function") {
		      callback = optsOrCallback;
		      opts = undefined;
		    } else {
		      opts = optsOrCallback;
		      callback = maybeCallback;
		    }
		    if (callback === undefined) {
		      {
		        return beginHiddenCallStack(transformFromAstRunner.sync)(ast, code, opts);
		      }
		    }
		    beginHiddenCallStack(transformFromAstRunner.errback)(ast, code, opts, callback);
		  };
		  function transformFromAstSync() {
		    return beginHiddenCallStack(transformFromAstRunner.sync).apply(void 0, arguments);
		  }
		  function transformFromAstAsync() {
		    return beginHiddenCallStack(transformFromAstRunner.async).apply(void 0, arguments);
		  }

		  var parseRunner = gensync(_regeneratorRuntime().mark(function parse(code, opts) {
		    var config;
		    return _regeneratorRuntime().wrap(function parse$(_context) {
		      while (1) switch (_context.prev = _context.next) {
		        case 0:
		          return _context.delegateYield(loadConfig(opts), "t0", 1);
		        case 1:
		          config = _context.t0;
		          if (!(config === null)) {
		            _context.next = 4;
		            break;
		          }
		          return _context.abrupt("return", null);
		        case 4:
		          return _context.delegateYield(parser$1(config.passes, normalizeOptions$6(config), code), "t1", 5);
		        case 5:
		          return _context.abrupt("return", _context.t1);
		        case 6:
		        case "end":
		          return _context.stop();
		      }
		    }, parse);
		  }));
		  var parse$1 = function parse(code, opts, callback) {
		    if (typeof opts === "function") {
		      callback = opts;
		      opts = undefined;
		    }
		    if (callback === undefined) {
		      {
		        return beginHiddenCallStack(parseRunner.sync)(code, opts);
		      }
		    }
		    beginHiddenCallStack(parseRunner.errback)(code, opts, callback);
		  };
		  function parseSync() {
		    return beginHiddenCallStack(parseRunner.sync).apply(void 0, arguments);
		  }
		  function parseAsync() {
		    return beginHiddenCallStack(parseRunner.async).apply(void 0, arguments);
		  }

		  var version$1 = "7.24.5";
		  var DEFAULT_EXTENSIONS = Object.freeze([".js", ".jsx", ".es6", ".es", ".mjs", ".cjs"]);
		  {
		    exports.OptionManager = function () {
		      function OptionManager() {}
		      var _proto = OptionManager.prototype;
		      _proto.init = function init(opts) {
		        return loadOptionsSync(opts);
		      };
		      return _createClass(OptionManager);
		    }();
		    exports.Plugin = function Plugin(alias) {
		      throw new Error("The (" + alias + ") Babel 5 plugin is being run with an unsupported Babel version.");
		    };
		  }

		  function makeNoopPlugin() {
		    var p;
		    return (p = function p() {
		      return {};
		    })["default"] = p;
		  }

		  function declare(x) {
		    return x;
		  }

		  var pluginUtilsShim = /*#__PURE__*/Object.freeze({
		    __proto__: null,
		    declare: declare,
		    declarePreset: declare
		  });

		  var externalHelpers = declare(function (api, options) {
		    api.assertVersion("*");
		    var _options$helperVersio = options.helperVersion,
		      helperVersion = _options$helperVersio === void 0 ? "7.0.0-beta.0" : _options$helperVersio,
		      _options$whitelist = options.whitelist,
		      whitelist = _options$whitelist === void 0 ? false : _options$whitelist;
		    if (whitelist !== false && (!Array.isArray(whitelist) || whitelist.some(function (w) {
		      return typeof w !== "string";
		    }))) {
		      throw new Error(".whitelist must be undefined, false, or an array of strings");
		    }
		    var helperWhitelist = whitelist ? new Set(whitelist) : null;
		    return {
		      name: "external-helpers",
		      pre: function pre(file) {
		        file.set("helperGenerator", function (name) {
		          if (file.availableHelper && !file.availableHelper(name, helperVersion)) {
		            return;
		          }
		          if (helperWhitelist && !helperWhitelist.has(name)) return;
		          return memberExpression$c(identifier$j("babelHelpers"), identifier$j(name));
		        });
		      }
		    };
		  });

		  var syntaxDecimal = declare(function (api) {
		    api.assertVersion("*");
		    return {
		      name: "syntax-decimal",
		      manipulateOptions: function manipulateOptions(opts, parserOpts) {
		        parserOpts.plugins.push("decimal");
		      }
		    };
		  });

		  var syntaxDecorators = declare(function (api, options) {
		    api.assertVersion("*");
		    var version = options.version;
		    {
		      var legacy = options.legacy;
		      if (legacy !== undefined) {
		        if (typeof legacy !== "boolean") {
		          throw new Error(".legacy must be a boolean.");
		        }
		        if (version !== undefined) {
		          throw new Error("You can either use the .legacy or the .version option, not both.");
		        }
		      }
		      if (version === undefined) {
		        version = legacy ? "legacy" : "2018-09";
		      } else if (version !== "2023-11" && version !== "2023-05" && version !== "2023-01" && version !== "2022-03" && version !== "2021-12" && version !== "2018-09" && version !== "legacy") {
		        throw new Error("Unsupported decorators version: " + version);
		      }
		      var decoratorsBeforeExport = options.decoratorsBeforeExport;
		      if (decoratorsBeforeExport === undefined) {
		        if (version === "2021-12" || version === "2022-03") {
		          decoratorsBeforeExport = false;
		        } else if (version === "2018-09") {
		          throw new Error("The decorators plugin, when .version is '2018-09' or not specified," + " requires a 'decoratorsBeforeExport' option, whose value must be a boolean.");
		        }
		      } else {
		        if (version === "legacy" || version === "2022-03" || version === "2023-01") {
		          throw new Error("'decoratorsBeforeExport' can't be used with " + version + " decorators.");
		        }
		        if (typeof decoratorsBeforeExport !== "boolean") {
		          throw new Error("'decoratorsBeforeExport' must be a boolean.");
		        }
		      }
		    }
		    return {
		      name: "syntax-decorators",
		      manipulateOptions: function manipulateOptions(_ref, parserOpts) {
		        var generatorOpts = _ref.generatorOpts;
		        if (version === "legacy") {
		          parserOpts.plugins.push("decorators-legacy");
		        } else {
		          if (version === "2023-01" || version === "2023-05" || version === "2023-11") {
		            parserOpts.plugins.push(["decorators", {
		              allowCallParenthesized: false
		            }], "decoratorAutoAccessors");
		          } else if (version === "2022-03") {
		            parserOpts.plugins.push(["decorators", {
		              decoratorsBeforeExport: false,
		              allowCallParenthesized: false
		            }], "decoratorAutoAccessors");
		          } else if (version === "2021-12") {
		            parserOpts.plugins.push(["decorators", {
		              decoratorsBeforeExport: decoratorsBeforeExport
		            }], "decoratorAutoAccessors");
		            generatorOpts.decoratorsBeforeExport = decoratorsBeforeExport;
		          } else if (version === "2018-09") {
		            parserOpts.plugins.push(["decorators", {
		              decoratorsBeforeExport: decoratorsBeforeExport
		            }]);
		            generatorOpts.decoratorsBeforeExport = decoratorsBeforeExport;
		          }
		        }
		      }
		    };
		  });

		  var syntaxDestructuringPrivate = declare(function (api) {
		    api.assertVersion("*");
		    return {
		      name: "syntax-destructuring-private",
		      manipulateOptions: function manipulateOptions(_, parserOpts) {
		        parserOpts.plugins.push("destructuringPrivate");
		      }
		    };
		  });

		  var syntaxDoExpressions = declare(function (api) {
		    api.assertVersion("*");
		    return {
		      name: "syntax-do-expressions",
		      manipulateOptions: function manipulateOptions(opts, parserOpts) {
		        parserOpts.plugins.push("doExpressions");
		      }
		    };
		  });

		  var syntaxExplicitResourceManagement = declare(function (api) {
		    api.assertVersion("*");
		    return {
		      name: "syntax-explicit-resource-management",
		      manipulateOptions: function manipulateOptions(opts, parserOpts) {
		        parserOpts.plugins.push("explicitResourceManagement");
		      }
		    };
		  });

		  var syntaxExportDefaultFrom = declare(function (api) {
		    api.assertVersion("*");
		    return {
		      name: "syntax-export-default-from",
		      manipulateOptions: function manipulateOptions(opts, parserOpts) {
		        parserOpts.plugins.push("exportDefaultFrom");
		      }
		    };
		  });

		  var syntaxFlow = declare(function (api, options) {
		    api.assertVersion("*");
		    var all = options.all,
		      enums = options.enums;
		    if (typeof all !== "boolean" && typeof all !== "undefined") {
		      throw new Error(".all must be a boolean, or undefined");
		    }
		    if (typeof enums !== "boolean" && typeof enums !== "undefined") {
		      throw new Error(".enums must be a boolean, or undefined");
		    }
		    return {
		      name: "syntax-flow",
		      manipulateOptions: function manipulateOptions(opts, parserOpts) {
		        {
		          if (parserOpts.plugins.some(function (p) {
		            return (Array.isArray(p) ? p[0] : p) === "typescript";
		          })) {
		            return;
		          }
		        }
		        parserOpts.plugins.push(["flow", {
		          all: all,
		          enums: enums
		        }]);
		      }
		    };
		  });

		  var syntaxFunctionBind = declare(function (api) {
		    api.assertVersion("*");
		    return {
		      name: "syntax-function-bind",
		      manipulateOptions: function manipulateOptions(opts, parserOpts) {
		        parserOpts.plugins.push("functionBind");
		      }
		    };
		  });

		  var syntaxFunctionSent = declare(function (api) {
		    api.assertVersion("*");
		    return {
		      name: "syntax-function-sent",
		      manipulateOptions: function manipulateOptions(opts, parserOpts) {
		        parserOpts.plugins.push("functionSent");
		      }
		    };
		  });

		  var _syntaxImportAssertions = declare(function (api) {
		    api.assertVersion("*");
		    return {
		      name: "syntax-import-assertions",
		      manipulateOptions: function manipulateOptions(opts, parserOpts) {
		        parserOpts.plugins.push("importAssertions");
		      }
		    };
		  });

		  var _syntaxImportAttributes = declare(function (api, _ref) {
		    var deprecatedAssertSyntax = _ref.deprecatedAssertSyntax;
		    api.assertVersion("*");
		    if (deprecatedAssertSyntax != null && typeof deprecatedAssertSyntax !== "boolean") {
		      throw new Error("'deprecatedAssertSyntax' must be a boolean, if specified.");
		    }
		    return {
		      name: "syntax-import-attributes",
		      manipulateOptions: function manipulateOptions(_ref2) {
		        var _generatorOpts$import;
		        var parserOpts = _ref2.parserOpts,
		          generatorOpts = _ref2.generatorOpts;
		        (_generatorOpts$import = generatorOpts.importAttributesKeyword) != null ? _generatorOpts$import : generatorOpts.importAttributesKeyword = "with";
		        parserOpts.plugins.push(["importAttributes", {
		          deprecatedAssertSyntax: Boolean(deprecatedAssertSyntax)
		        }]);
		      }
		    };
		  });

		  var syntaxImportReflection = declare(function (api) {
		    api.assertVersion("*");
		    return {
		      name: "syntax-import-reflection",
		      manipulateOptions: function manipulateOptions(_, parserOpts) {
		        parserOpts.plugins.push("importReflection");
		      }
		    };
		  });

		  var syntaxJsx = declare(function (api) {
		    api.assertVersion("*");
		    return {
		      name: "syntax-jsx",
		      manipulateOptions: function manipulateOptions(opts, parserOpts) {
		        {
		          if (parserOpts.plugins.some(function (p) {
		            return (Array.isArray(p) ? p[0] : p) === "typescript";
		          })) {
		            return;
		          }
		        }
		        parserOpts.plugins.push("jsx");
		      }
		    };
		  });

		  var syntaxModuleBlocks = declare(function (api) {
		    api.assertVersion("*");
		    return {
		      name: "syntax-module-blocks",
		      manipulateOptions: function manipulateOptions(opts, parserOpts) {
		        parserOpts.plugins.push("moduleBlocks");
		      }
		    };
		  });

		  var v$3 = new OptionValidator("@babel/plugin-syntax-optional-chaining-assign");
		  var syntaxOptionalChainingAssign = declare(function (api, options) {
		    api.assertVersion("*");
		    v$3.validateTopLevelOptions(options, {
		      version: "version"
		    });
		    var version = options.version;
		    v$3.invariant(version === "2023-07", "'.version' option required, representing the last proposal update. " + "Currently, the only supported value is '2023-07'.");
		    return {
		      name: "syntax-optional-chaining-assign",
		      manipulateOptions: function manipulateOptions(opts, parserOpts) {
		        parserOpts.plugins.push(["optionalChainingAssign", {
		          version: version
		        }]);
		      }
		    };
		  });

		  var PIPELINE_PROPOSALS = ["minimal", "fsharp", "hack", "smart"];
		  var TOPIC_TOKENS = ["^^", "@@", "^", "%", "#"];
		  var documentationURL = "https://babeljs.io/docs/en/babel-plugin-proposal-pipeline-operator";
		  var syntaxPipelineOperator = declare(function (api, _ref) {
		    var proposal = _ref.proposal,
		      topicToken = _ref.topicToken;
		    api.assertVersion("*");
		    if (typeof proposal !== "string" || !PIPELINE_PROPOSALS.includes(proposal)) {
		      var proposalList = PIPELINE_PROPOSALS.map(function (p) {
		        return "\"" + p + "\"";
		      }).join(", ");
		      throw new Error("The pipeline plugin requires a \"proposal\" option. \"proposal\" must be one of: " + proposalList + ". See <" + documentationURL + ">.");
		    }
		    if (proposal === "hack" && !TOPIC_TOKENS.includes(topicToken)) {
		      var topicTokenList = TOPIC_TOKENS.map(function (t) {
		        return "\"" + t + "\"";
		      }).join(", ");
		      throw new Error("The pipeline plugin in \"proposal\": \"hack\" mode also requires a \"topicToken\" option. \"topicToken\" must be one of: " + topicTokenList + ". See <" + documentationURL + ">.");
		    }
		    return {
		      name: "syntax-pipeline-operator",
		      manipulateOptions: function manipulateOptions(opts, parserOpts) {
		        parserOpts.plugins.push(["pipelineOperator", {
		          proposal: proposal,
		          topicToken: topicToken
		        }]);
		        opts.generatorOpts.topicToken = topicToken;
		      }
		    };
		  });

		  var syntaxRecordAndTuple = declare(function (api, options) {
		    api.assertVersion("*");
		    return {
		      name: "syntax-record-and-tuple",
		      manipulateOptions: function manipulateOptions(opts, parserOpts) {
		        opts.generatorOpts.recordAndTupleSyntaxType = options.syntaxType;
		        parserOpts.plugins.push(["recordAndTuple", {
		          syntaxType: options.syntaxType
		        }]);
		      }
		    };
		  });

		  {
		    var removePlugin = function removePlugin(plugins, name) {
		      var indices = [];
		      plugins.forEach(function (plugin, i) {
		        var n = Array.isArray(plugin) ? plugin[0] : plugin;
		        if (n === name) {
		          indices.unshift(i);
		        }
		      });
		      for (var _i = 0, _indices = indices; _i < _indices.length; _i++) {
		        var i = _indices[_i];
		        plugins.splice(i, 1);
		      }
		    };
		  }
		  var syntaxTypescript = declare(function (api, opts) {
		    api.assertVersion("*");
		    var disallowAmbiguousJSXLike = opts.disallowAmbiguousJSXLike,
		      dts = opts.dts;
		    {
		      var isTSX = opts.isTSX;
		    }
		    return {
		      name: "syntax-typescript",
		      manipulateOptions: function manipulateOptions(opts, parserOpts) {
		        {
		          var plugins = parserOpts.plugins;
		          removePlugin(plugins, "flow");
		          removePlugin(plugins, "jsx");
		          plugins.push("objectRestSpread", "classProperties");
		          if (isTSX) {
		            plugins.push("jsx");
		          }
		        }
		        parserOpts.plugins.push(["typescript", {
		          disallowAmbiguousJSXLike: disallowAmbiguousJSXLike,
		          dts: dts
		        }]);
		      }
		    };
		  });

		  var blockStatement = blockStatement$6,
		    callExpression$5 = callExpression$d,
		    functionExpression = functionExpression$2,
		    isAssignmentPattern$1 = isAssignmentPattern$4,
		    isFunctionDeclaration = isFunctionDeclaration$2,
		    isRestElement = isRestElement$2,
		    returnStatement = returnStatement$3,
		    isCallExpression = isCallExpression$8;
		  var buildAnonymousExpressionWrapper = template$1.expression("\n  (function () {\n    var REF = FUNCTION;\n    return function NAME(PARAMS) {\n      return REF.apply(this, arguments);\n    };\n  })()\n");
		  var buildNamedExpressionWrapper = template$1.expression("\n  (function () {\n    var REF = FUNCTION;\n    function NAME(PARAMS) {\n      return REF.apply(this, arguments);\n    }\n    return NAME;\n  })()\n");
		  var buildDeclarationWrapper = template$1.statements("\n  function NAME(PARAMS) { return REF.apply(this, arguments); }\n  function REF() {\n    REF = FUNCTION;\n    return REF.apply(this, arguments);\n  }\n");
		  function classOrObjectMethod(path, callId) {
		    var node = path.node;
		    var body = node.body;
		    var container = functionExpression(null, [], blockStatement(body.body), true);
		    body.body = [returnStatement(callExpression$5(callExpression$5(callId, [container]), []))];
		    node.async = false;
		    node.generator = false;
		    path.get("body.body.0.argument.callee.arguments.0").unwrapFunctionEnvironment();
		  }
		  function plainFunction(inPath, callId, noNewArrows, ignoreFunctionLength) {
		    var path = inPath;
		    var node;
		    var functionId = null;
		    var nodeParams = inPath.node.params;
		    if (path.isArrowFunctionExpression()) {
		      {
		        var _path$arrowFunctionTo;
		        path = (_path$arrowFunctionTo = path.arrowFunctionToExpression({
		          noNewArrows: noNewArrows
		        })) != null ? _path$arrowFunctionTo : path;
		      }
		      node = path.node;
		    } else {
		      node = path.node;
		    }
		    var isDeclaration = isFunctionDeclaration(node);
		    var built = node;
		    if (!isCallExpression(node)) {
		      functionId = node.id;
		      node.id = null;
		      node.type = "FunctionExpression";
		      built = callExpression$5(callId, [node]);
		    }
		    var params = [];
		    for (var _iterator = _createForOfIteratorHelperLoose(nodeParams), _step; !(_step = _iterator()).done;) {
		      var param = _step.value;
		      if (isAssignmentPattern$1(param) || isRestElement(param)) {
		        break;
		      }
		      params.push(path.scope.generateUidIdentifier("x"));
		    }
		    var wrapperArgs = {
		      NAME: functionId || null,
		      REF: path.scope.generateUidIdentifier(functionId ? functionId.name : "ref"),
		      FUNCTION: built,
		      PARAMS: params
		    };
		    if (isDeclaration) {
		      var container = buildDeclarationWrapper(wrapperArgs);
		      path.replaceWith(container[0]);
		      path.insertAfter(container[1]);
		    } else {
		      var _container;
		      if (functionId) {
		        _container = buildNamedExpressionWrapper(wrapperArgs);
		      } else {
		        _container = buildAnonymousExpressionWrapper(wrapperArgs);
		        var returnFn = _container.callee.body.body[1].argument;
		        nameFunction({
		          node: returnFn,
		          parent: path.parent,
		          scope: path.scope
		        });
		        functionId = returnFn.id;
		      }
		      if (functionId || !ignoreFunctionLength && params.length) {
		        path.replaceWith(_container);
		      } else {
		        path.replaceWith(built);
		      }
		    }
		  }
		  function wrapFunction(path, callId, noNewArrows, ignoreFunctionLength) {
		    if (noNewArrows === void 0) {
		      noNewArrows = true;
		    }
		    if (ignoreFunctionLength === void 0) {
		      ignoreFunctionLength = false;
		    }
		    if (path.isMethod()) {
		      classOrObjectMethod(path, callId);
		    } else {
		      plainFunction(path, callId, noNewArrows, ignoreFunctionLength);
		    }
		  }

		  var addComment = addComment$2;
		  var PURE_ANNOTATION = "#__PURE__";
		  var isPureAnnotated = function isPureAnnotated(_ref) {
		    var leadingComments = _ref.leadingComments;
		    return !!leadingComments && leadingComments.some(function (comment) {
		      return /[@#]__PURE__/.test(comment.value);
		    });
		  };
		  function annotateAsPure(pathOrNode) {
		    var node = pathOrNode["node"] || pathOrNode;
		    if (isPureAnnotated(node)) {
		      return;
		    }
		    addComment(node, "leading", PURE_ANNOTATION);
		  }

		  var callExpression$4 = callExpression$d,
		    cloneNode$4 = cloneNode$j,
		    isIdentifier$3 = isIdentifier$i,
		    isThisExpression = isThisExpression$2,
		    yieldExpression = yieldExpression$2;
		  var awaitVisitor$1 = traverse.visitors.merge([{
		    ArrowFunctionExpression: function ArrowFunctionExpression(path) {
		      path.skip();
		    },
		    AwaitExpression: function AwaitExpression(path, _ref) {
		      var wrapAwait = _ref.wrapAwait;
		      var argument = path.get("argument");
		      path.replaceWith(yieldExpression(wrapAwait ? callExpression$4(cloneNode$4(wrapAwait), [argument.node]) : argument.node));
		    }
		  }, visitor$5]);
		  function remapAsyncToGenerator (path, helpers, noNewArrows, ignoreFunctionLength) {
		    path.traverse(awaitVisitor$1, {
		      wrapAwait: helpers.wrapAwait
		    });
		    var isIIFE = checkIsIIFE(path);
		    path.node.async = false;
		    path.node.generator = true;
		    wrapFunction(path, cloneNode$4(helpers.wrapAsync), noNewArrows, ignoreFunctionLength);
		    var isProperty = path.isObjectMethod() || path.isClassMethod() || path.parentPath.isObjectProperty() || path.parentPath.isClassProperty();
		    if (!isProperty && !isIIFE && path.isExpression()) {
		      annotateAsPure(path);
		    }
		    function checkIsIIFE(path) {
		      if (path.parentPath.isCallExpression({
		        callee: path.node
		      })) {
		        return true;
		      }
		      var parentPath = path.parentPath;
		      if (parentPath.isMemberExpression() && isIdentifier$3(parentPath.node.property, {
		        name: "bind"
		      })) {
		        var bindCall = parentPath.parentPath;
		        return bindCall.isCallExpression() && bindCall.node.arguments.length === 1 && isThisExpression(bindCall.node.arguments[0]) && bindCall.parentPath.isCallExpression({
		          callee: bindCall.node
		        });
		      }
		      return false;
		    }
		  }

		  var buildForAwait = template$1("\n  async function wrapper() {\n    var ITERATOR_ABRUPT_COMPLETION = false;\n    var ITERATOR_HAD_ERROR_KEY = false;\n    var ITERATOR_ERROR_KEY;\n    try {\n      for (\n        var ITERATOR_KEY = GET_ITERATOR(OBJECT), STEP_KEY;\n        ITERATOR_ABRUPT_COMPLETION = !(STEP_KEY = await ITERATOR_KEY.next()).done;\n        ITERATOR_ABRUPT_COMPLETION = false\n      ) {\n      }\n    } catch (err) {\n      ITERATOR_HAD_ERROR_KEY = true;\n      ITERATOR_ERROR_KEY = err;\n    } finally {\n      try {\n        if (ITERATOR_ABRUPT_COMPLETION && ITERATOR_KEY.return != null) {\n          await ITERATOR_KEY.return();\n        }\n      } finally {\n        if (ITERATOR_HAD_ERROR_KEY) {\n          throw ITERATOR_ERROR_KEY;\n        }\n      }\n    }\n  }\n");
		  function rewriteForAwait (path, _ref) {
		    var getAsyncIterator = _ref.getAsyncIterator;
		    var node = path.node,
		      scope = path.scope,
		      parent = path.parent;
		    var stepKey = scope.generateUidIdentifier("step");
		    var stepValue = memberExpression$c(stepKey, identifier$j("value"));
		    var left = node.left;
		    var declar;
		    if (isIdentifier$i(left) || isPattern(left) || isMemberExpression$9(left)) {
		      declar = expressionStatement$a(assignmentExpression$d("=", left, stepValue));
		    } else if (isVariableDeclaration$4(left)) {
		      declar = variableDeclaration$8(left.kind, [variableDeclarator$8(left.declarations[0].id, stepValue)]);
		    }
		    var template = buildForAwait({
		      ITERATOR_HAD_ERROR_KEY: scope.generateUidIdentifier("didIteratorError"),
		      ITERATOR_ABRUPT_COMPLETION: scope.generateUidIdentifier("iteratorAbruptCompletion"),
		      ITERATOR_ERROR_KEY: scope.generateUidIdentifier("iteratorError"),
		      ITERATOR_KEY: scope.generateUidIdentifier("iterator"),
		      GET_ITERATOR: getAsyncIterator,
		      OBJECT: node.right,
		      STEP_KEY: cloneNode$j(stepKey)
		    });
		    template = template.body.body;
		    var isLabeledParent = isLabeledStatement(parent);
		    var tryBody = template[3].block.body;
		    var loop = tryBody[0];
		    if (isLabeledParent) {
		      tryBody[0] = labeledStatement(parent.label, loop);
		    }
		    return {
		      replaceParent: isLabeledParent,
		      node: template,
		      declar: declar,
		      loop: loop
		    };
		  }

		  var proposalAsyncGeneratorFunctions = declare(function (api) {
		    api.assertVersion("*");
		    var yieldStarVisitor = traverse.visitors.merge([{
		      ArrowFunctionExpression: function ArrowFunctionExpression(path) {
		        path.skip();
		      },
		      YieldExpression: function YieldExpression(_ref, state) {
		        var node = _ref.node;
		        if (!node.delegate) return;
		        var asyncIter = callExpression$d(state.addHelper("asyncIterator"), [node.argument]);
		        node.argument = callExpression$d(state.addHelper("asyncGeneratorDelegate"), [asyncIter, state.addHelper("awaitAsyncGenerator")]);
		      }
		    }, visitor$5]);
		    var forAwaitVisitor = traverse.visitors.merge([{
		      ArrowFunctionExpression: function ArrowFunctionExpression(path) {
		        path.skip();
		      },
		      ForOfStatement: function (_ForOfStatement) {
		        function ForOfStatement(_x, _x2) {
		          return _ForOfStatement.apply(this, arguments);
		        }
		        ForOfStatement.toString = function () {
		          return _ForOfStatement.toString();
		        };
		        return ForOfStatement;
		      }(function (path, _ref2) {
		        var file = _ref2.file;
		        var node = path.node;
		        if (!node["await"]) return;
		        var build = rewriteForAwait(path, {
		          getAsyncIterator: file.addHelper("asyncIterator")
		        });
		        var declar = build.declar,
		          loop = build.loop;
		        var block = loop.body;
		        path.ensureBlock();
		        if (declar) {
		          block.body.push(declar);
		          if (path.node.body.body.length) {
		            block.body.push(blockStatement$6(path.node.body.body));
		          }
		        } else {
		          var _block$body;
		          (_block$body = block.body).push.apply(_block$body, _toConsumableArray(path.node.body.body));
		        }
		        inherits$3(loop, node);
		        inherits$3(loop.body, node.body);
		        var p = build.replaceParent ? path.parentPath : path;
		        p.replaceWithMultiple(build.node);
		        p.scope.parent.crawl();
		      })
		    }, visitor$5]);
		    var visitor = {
		      Function: function Function(path, state) {
		        if (!path.node.async) return;
		        path.traverse(forAwaitVisitor, state);
		        if (!path.node.generator) return;
		        path.traverse(yieldStarVisitor, state);
		        remapAsyncToGenerator(path, {
		          wrapAsync: state.addHelper("wrapAsyncGenerator"),
		          wrapAwait: state.addHelper("awaitAsyncGenerator")
		        });
		      }
		    };
		    return {
		      name: "transform-async-generator-functions",
		      inherits: undefined,
		      visitor: {
		        Program: function Program(path, state) {
		          path.traverse(visitor, state);
		        }
		      }
		    };
		  });

		  function willPathCastToBoolean$1(path) {
		    var maybeWrapped = path;
		    var node = maybeWrapped.node,
		      parentPath = maybeWrapped.parentPath;
		    if (parentPath.isLogicalExpression()) {
		      var _parentPath$node = parentPath.node,
		        operator = _parentPath$node.operator,
		        right = _parentPath$node.right;
		      if (operator === "&&" || operator === "||" || operator === "??" && node === right) {
		        return willPathCastToBoolean$1(parentPath);
		      }
		    }
		    if (parentPath.isSequenceExpression()) {
		      var expressions = parentPath.node.expressions;
		      if (expressions[expressions.length - 1] === node) {
		        return willPathCastToBoolean$1(parentPath);
		      } else {
		        return true;
		      }
		    }
		    return parentPath.isConditional({
		      test: node
		    }) || parentPath.isUnaryExpression({
		      operator: "!"
		    }) || parentPath.isLoop({
		      test: node
		    });
		  }

		  var LOGICAL_OPERATORS = LOGICAL_OPERATORS$3,
		    arrowFunctionExpression = arrowFunctionExpression$4,
		    assignmentExpression$4 = assignmentExpression$d,
		    binaryExpression$1 = binaryExpression$5,
		    booleanLiteral$2 = booleanLiteral$4,
		    callExpression$3 = callExpression$d,
		    cloneNode$3 = cloneNode$j,
		    conditionalExpression$1 = conditionalExpression$5,
		    identifier$3 = identifier$j,
		    isMemberExpression$1 = isMemberExpression$9,
		    isOptionalCallExpression = isOptionalCallExpression$2,
		    isOptionalMemberExpression = isOptionalMemberExpression$3,
		    isUpdateExpression = isUpdateExpression$1,
		    logicalExpression = logicalExpression$3,
		    memberExpression$5 = memberExpression$c,
		    nullLiteral$1 = nullLiteral$2,
		    optionalCallExpression$1 = optionalCallExpression$2,
		    optionalMemberExpression$1 = optionalMemberExpression$2,
		    sequenceExpression$2 = sequenceExpression$8,
		    updateExpression = updateExpression$1;
		  var AssignmentMemoiser = function () {
		    function AssignmentMemoiser() {
		      this._map = void 0;
		      this._map = new WeakMap();
		    }
		    var _proto = AssignmentMemoiser.prototype;
		    _proto.has = function has(key) {
		      return this._map.has(key);
		    };
		    _proto.get = function get(key) {
		      if (!this.has(key)) return;
		      var record = this._map.get(key);
		      var value = record.value;
		      record.count--;
		      if (record.count === 0) {
		        return assignmentExpression$4("=", value, key);
		      }
		      return value;
		    };
		    _proto.set = function set(key, value, count) {
		      return this._map.set(key, {
		        count: count,
		        value: value
		      });
		    };
		    return _createClass(AssignmentMemoiser);
		  }();
		  function toNonOptional(path, base) {
		    var node = path.node;
		    if (isOptionalMemberExpression(node)) {
		      return memberExpression$5(base, node.property, node.computed);
		    }
		    if (path.isOptionalCallExpression()) {
		      var callee = path.get("callee");
		      if (path.node.optional && callee.isOptionalMemberExpression()) {
		        var object = callee.node.object;
		        var context = path.scope.maybeGenerateMemoised(object);
		        callee.get("object").replaceWith(assignmentExpression$4("=", context, object));
		        return callExpression$3(memberExpression$5(base, identifier$3("call")), [context].concat(_toConsumableArray(path.node.arguments)));
		      }
		      return callExpression$3(base, path.node.arguments);
		    }
		    return path.node;
		  }
		  function isInDetachedTree(path) {
		    while (path) {
		      if (path.isProgram()) break;
		      var _path = path,
		        parentPath = _path.parentPath,
		        container = _path.container,
		        listKey = _path.listKey;
		      var parentNode = parentPath.node;
		      if (listKey) {
		        if (container !== parentNode[listKey]) {
		          return true;
		        }
		      } else {
		        if (container !== parentNode) return true;
		      }
		      path = parentPath;
		    }
		    return false;
		  }
		  var handle = {
		    memoise: function memoise() {},
		    handle: function handle(member, noDocumentAll) {
		      var node = member.node,
		        parent = member.parent,
		        parentPath = member.parentPath,
		        scope = member.scope;
		      if (member.isOptionalMemberExpression()) {
		        if (isInDetachedTree(member)) return;
		        var endPath = member.find(function (_ref) {
		          var node = _ref.node,
		            parent = _ref.parent;
		          if (isOptionalMemberExpression(parent)) {
		            return parent.optional || parent.object !== node;
		          }
		          if (isOptionalCallExpression(parent)) {
		            return node !== member.node && parent.optional || parent.callee !== node;
		          }
		          return true;
		        });
		        if (scope.path.isPattern()) {
		          endPath.replaceWith(callExpression$3(arrowFunctionExpression([], endPath.node), []));
		          return;
		        }
		        var willEndPathCastToBoolean = willPathCastToBoolean$1(endPath);
		        var rootParentPath = endPath.parentPath;
		        if (rootParentPath.isUpdateExpression({
		          argument: node
		        })) {
		          throw member.buildCodeFrameError("can't handle update expression");
		        }
		        var isAssignment = rootParentPath.isAssignmentExpression({
		          left: endPath.node
		        });
		        var isDeleteOperation = rootParentPath.isUnaryExpression({
		          operator: "delete"
		        });
		        if (isDeleteOperation && endPath.isOptionalMemberExpression() && endPath.get("property").isPrivateName()) {
		          throw member.buildCodeFrameError("can't delete a private class element");
		        }
		        var startingOptional = member;
		        for (;;) {
		          if (startingOptional.isOptionalMemberExpression()) {
		            if (startingOptional.node.optional) break;
		            startingOptional = startingOptional.get("object");
		            continue;
		          } else if (startingOptional.isOptionalCallExpression()) {
		            if (startingOptional.node.optional) break;
		            startingOptional = startingOptional.get("callee");
		            continue;
		          }
		          throw new Error("Internal error: unexpected " + startingOptional.node.type);
		        }
		        var startingNode = startingOptional.isOptionalMemberExpression() ? startingOptional.node.object : startingOptional.node.callee;
		        var baseNeedsMemoised = scope.maybeGenerateMemoised(startingNode);
		        var baseRef = baseNeedsMemoised != null ? baseNeedsMemoised : startingNode;
		        var parentIsOptionalCall = parentPath.isOptionalCallExpression({
		          callee: node
		        });
		        var isOptionalCall = function isOptionalCall(parent) {
		          return parentIsOptionalCall;
		        };
		        var parentIsCall = parentPath.isCallExpression({
		          callee: node
		        });
		        startingOptional.replaceWith(toNonOptional(startingOptional, baseRef));
		        if (isOptionalCall(parent)) {
		          if (parent.optional) {
		            parentPath.replaceWith(this.optionalCall(member, parent.arguments));
		          } else {
		            parentPath.replaceWith(this.call(member, parent.arguments));
		          }
		        } else if (parentIsCall) {
		          member.replaceWith(this.boundGet(member));
		        } else if (this["delete"] && parentPath.isUnaryExpression({
		          operator: "delete"
		        })) {
		          parentPath.replaceWith(this["delete"](member));
		        } else if (parentPath.isAssignmentExpression()) {
		          handleAssignment(this, member, parentPath);
		        } else {
		          member.replaceWith(this.get(member));
		        }
		        var regular = member.node;
		        for (var current = member; current !== endPath;) {
		          var _parentPath = current.parentPath;
		          if (_parentPath === endPath && isOptionalCall(parent) && parent.optional) {
		            regular = _parentPath.node;
		            break;
		          }
		          regular = toNonOptional(_parentPath, regular);
		          current = _parentPath;
		        }
		        var context;
		        var endParentPath = endPath.parentPath;
		        if (isMemberExpression$1(regular) && endParentPath.isOptionalCallExpression({
		          callee: endPath.node,
		          optional: true
		        })) {
		          var _regular = regular,
		            object = _regular.object;
		          context = member.scope.maybeGenerateMemoised(object);
		          if (context) {
		            regular.object = assignmentExpression$4("=", context, object);
		          }
		        }
		        var replacementPath = endPath;
		        if (isDeleteOperation || isAssignment) {
		          replacementPath = endParentPath;
		          regular = endParentPath.node;
		        }
		        var baseMemoised = baseNeedsMemoised ? assignmentExpression$4("=", cloneNode$3(baseRef), cloneNode$3(startingNode)) : cloneNode$3(baseRef);
		        if (willEndPathCastToBoolean) {
		          var nonNullishCheck;
		          if (noDocumentAll) {
		            nonNullishCheck = binaryExpression$1("!=", baseMemoised, nullLiteral$1());
		          } else {
		            nonNullishCheck = logicalExpression("&&", binaryExpression$1("!==", baseMemoised, nullLiteral$1()), binaryExpression$1("!==", cloneNode$3(baseRef), scope.buildUndefinedNode()));
		          }
		          replacementPath.replaceWith(logicalExpression("&&", nonNullishCheck, regular));
		        } else {
		          var nullishCheck;
		          if (noDocumentAll) {
		            nullishCheck = binaryExpression$1("==", baseMemoised, nullLiteral$1());
		          } else {
		            nullishCheck = logicalExpression("||", binaryExpression$1("===", baseMemoised, nullLiteral$1()), binaryExpression$1("===", cloneNode$3(baseRef), scope.buildUndefinedNode()));
		          }
		          replacementPath.replaceWith(conditionalExpression$1(nullishCheck, isDeleteOperation ? booleanLiteral$2(true) : scope.buildUndefinedNode(), regular));
		        }
		        if (context) {
		          var endParent = endParentPath.node;
		          endParentPath.replaceWith(optionalCallExpression$1(optionalMemberExpression$1(endParent.callee, identifier$3("call"), false, true), [cloneNode$3(context)].concat(_toConsumableArray(endParent.arguments)), false));
		        }
		        return;
		      }
		      if (isUpdateExpression(parent, {
		        argument: node
		      })) {
		        if (this.simpleSet) {
		          member.replaceWith(this.simpleSet(member));
		          return;
		        }
		        var operator = parent.operator,
		          prefix = parent.prefix;
		        this.memoise(member, 2);
		        var ref = scope.generateUidIdentifierBasedOnNode(node);
		        scope.push({
		          id: ref
		        });
		        var seq = [assignmentExpression$4("=", cloneNode$3(ref), this.get(member))];
		        if (prefix) {
		          seq.push(updateExpression(operator, cloneNode$3(ref), prefix));
		          var _value = sequenceExpression$2(seq);
		          parentPath.replaceWith(this.set(member, _value));
		          return;
		        } else {
		          var ref2 = scope.generateUidIdentifierBasedOnNode(node);
		          scope.push({
		            id: ref2
		          });
		          seq.push(assignmentExpression$4("=", cloneNode$3(ref2), updateExpression(operator, cloneNode$3(ref), prefix)), cloneNode$3(ref));
		          var _value2 = sequenceExpression$2(seq);
		          parentPath.replaceWith(sequenceExpression$2([this.set(member, _value2), cloneNode$3(ref2)]));
		          return;
		        }
		      }
		      if (parentPath.isAssignmentExpression({
		        left: node
		      })) {
		        handleAssignment(this, member, parentPath);
		        return;
		      }
		      if (parentPath.isCallExpression({
		        callee: node
		      })) {
		        parentPath.replaceWith(this.call(member, parentPath.node.arguments));
		        return;
		      }
		      if (parentPath.isOptionalCallExpression({
		        callee: node
		      })) {
		        if (scope.path.isPattern()) {
		          parentPath.replaceWith(callExpression$3(arrowFunctionExpression([], parentPath.node), []));
		          return;
		        }
		        parentPath.replaceWith(this.optionalCall(member, parentPath.node.arguments));
		        return;
		      }
		      if (this["delete"] && parentPath.isUnaryExpression({
		        operator: "delete"
		      })) {
		        parentPath.replaceWith(this["delete"](member));
		        return;
		      }
		      if (parentPath.isForXStatement({
		        left: node
		      }) || parentPath.isObjectProperty({
		        value: node
		      }) && parentPath.parentPath.isObjectPattern() || parentPath.isAssignmentPattern({
		        left: node
		      }) && parentPath.parentPath.isObjectProperty({
		        value: parent
		      }) && parentPath.parentPath.parentPath.isObjectPattern() || parentPath.isArrayPattern() || parentPath.isAssignmentPattern({
		        left: node
		      }) && parentPath.parentPath.isArrayPattern() || parentPath.isRestElement()) {
		        member.replaceWith(this.destructureSet(member));
		        return;
		      }
		      if (parentPath.isTaggedTemplateExpression()) {
		        member.replaceWith(this.boundGet(member));
		      } else {
		        member.replaceWith(this.get(member));
		      }
		    }
		  };
		  function handleAssignment(state, member, parentPath) {
		    if (state.simpleSet) {
		      member.replaceWith(state.simpleSet(member));
		      return;
		    }
		    var _parentPath$node = parentPath.node,
		      operator = _parentPath$node.operator,
		      value = _parentPath$node.right;
		    if (operator === "=") {
		      parentPath.replaceWith(state.set(member, value));
		    } else {
		      var operatorTrunc = operator.slice(0, -1);
		      if (LOGICAL_OPERATORS.includes(operatorTrunc)) {
		        state.memoise(member, 1);
		        parentPath.replaceWith(logicalExpression(operatorTrunc, state.get(member), state.set(member, value)));
		      } else {
		        state.memoise(member, 2);
		        parentPath.replaceWith(state.set(member, binaryExpression$1(operatorTrunc, state.get(member), value)));
		      }
		    }
		  }
		  function memberExpressionToFunctions(path, visitor, state) {
		    path.traverse(visitor, Object.assign({}, handle, state, {
		      memoiser: new AssignmentMemoiser()
		    }));
		  }

		  var callExpression$2 = callExpression$d,
		    identifier$2 = identifier$j,
		    isIdentifier$2 = isIdentifier$i,
		    isSpreadElement = isSpreadElement$1,
		    memberExpression$4 = memberExpression$c,
		    optionalCallExpression = optionalCallExpression$2,
		    optionalMemberExpression = optionalMemberExpression$2;
		  function optimiseCallExpression(callee, thisNode, args, optional) {
		    if (args.length === 1 && isSpreadElement(args[0]) && isIdentifier$2(args[0].argument, {
		      name: "arguments"
		    })) {
		      if (optional) {
		        return optionalCallExpression(optionalMemberExpression(callee, identifier$2("apply"), false, true), [thisNode, args[0].argument], false);
		      }
		      return callExpression$2(memberExpression$4(callee, identifier$2("apply")), [thisNode, args[0].argument]);
		    } else {
		      if (optional) {
		        return optionalCallExpression(optionalMemberExpression(callee, identifier$2("call"), false, true), [thisNode].concat(_toConsumableArray(args)), false);
		      }
		      return callExpression$2(memberExpression$4(callee, identifier$2("call")), [thisNode].concat(_toConsumableArray(args)));
		    }
		  }

		  var _templateObject$w, _templateObject2$h;
		  var assignmentExpression$3 = assignmentExpression$d,
		    booleanLiteral$1 = booleanLiteral$4,
		    callExpression$1 = callExpression$d,
		    cloneNode$2 = cloneNode$j,
		    identifier$1 = identifier$j,
		    memberExpression$3 = memberExpression$c,
		    sequenceExpression$1 = sequenceExpression$8,
		    stringLiteral$1 = stringLiteral$8,
		    thisExpression$1 = thisExpression$4;
		  function getPrototypeOfExpression(objectRef, isStatic, file, isPrivateMethod) {
		    objectRef = cloneNode$2(objectRef);
		    var targetRef = isStatic || isPrivateMethod ? objectRef : memberExpression$3(objectRef, identifier$1("prototype"));
		    return callExpression$1(file.addHelper("getPrototypeOf"), [targetRef]);
		  }
		  var visitor$2 = traverse.visitors.merge([visitor$5, {
		    Super: function Super(path, state) {
		      var node = path.node,
		        parentPath = path.parentPath;
		      if (!parentPath.isMemberExpression({
		        object: node
		      })) return;
		      state.handle(parentPath);
		    }
		  }]);
		  var unshadowSuperBindingVisitor = traverse.visitors.merge([visitor$5, {
		    Scopable: function Scopable(path, _ref) {
		      var refName = _ref.refName;
		      var binding = path.scope.getOwnBinding(refName);
		      if (binding && binding.identifier.name === refName) {
		        path.scope.rename(refName);
		      }
		    }
		  }]);
		  var specHandlers = {
		    memoise: function memoise(superMember, count) {
		      var scope = superMember.scope,
		        node = superMember.node;
		      var computed = node.computed,
		        property = node.property;
		      if (!computed) {
		        return;
		      }
		      var memo = scope.maybeGenerateMemoised(property);
		      if (!memo) {
		        return;
		      }
		      this.memoiser.set(property, memo, count);
		    },
		    prop: function prop(superMember) {
		      var _superMember$node = superMember.node,
		        computed = _superMember$node.computed,
		        property = _superMember$node.property;
		      if (this.memoiser.has(property)) {
		        return cloneNode$2(this.memoiser.get(property));
		      }
		      if (computed) {
		        return cloneNode$2(property);
		      }
		      return stringLiteral$1(property.name);
		    },
		    get: function get(superMember) {
		      return this._get(superMember, this._getThisRefs());
		    },
		    _get: function _get(superMember, thisRefs) {
		      var proto = getPrototypeOfExpression(this.getObjectRef(), this.isStatic, this.file, this.isPrivateMethod);
		      return callExpression$1(this.file.addHelper("get"), [thisRefs.needAccessFirst ? sequenceExpression$1([thisRefs["this"], proto]) : proto, this.prop(superMember), thisRefs["this"]]);
		    },
		    _getThisRefs: function _getThisRefs() {
		      return {
		        needAccessFirst: this.isDerivedConstructor,
		        "this": thisExpression$1()
		      };
		    },
		    set: function set(superMember, value) {
		      var thisRefs = this._getThisRefs();
		      var proto = getPrototypeOfExpression(this.getObjectRef(), this.isStatic, this.file, this.isPrivateMethod);
		      return callExpression$1(this.file.addHelper("set"), [thisRefs.needAccessFirst ? sequenceExpression$1([thisRefs["this"], proto]) : proto, this.prop(superMember), value, thisRefs["this"], booleanLiteral$1(superMember.isInStrictMode())]);
		    },
		    destructureSet: function destructureSet(superMember) {
		      throw superMember.buildCodeFrameError("Destructuring to a super field is not supported yet.");
		    },
		    call: function call(superMember, args) {
		      var thisRefs = this._getThisRefs();
		      return optimiseCallExpression(this._get(superMember, thisRefs), cloneNode$2(thisRefs["this"]), args, false);
		    },
		    optionalCall: function optionalCall(superMember, args) {
		      var thisRefs = this._getThisRefs();
		      return optimiseCallExpression(this._get(superMember, thisRefs), cloneNode$2(thisRefs["this"]), args, true);
		    },
		    "delete": function _delete(superMember) {
		      if (superMember.node.computed) {
		        return sequenceExpression$1([callExpression$1(this.file.addHelper("toPropertyKey"), [cloneNode$2(superMember.node.property)]), template$1.expression.ast(_templateObject$w || (_templateObject$w = _taggedTemplateLiteralLoose(["\n          function () { throw new ReferenceError(\"'delete super[expr]' is invalid\"); }()\n        "])))]);
		      } else {
		        return template$1.expression.ast(_templateObject2$h || (_templateObject2$h = _taggedTemplateLiteralLoose(["\n        function () { throw new ReferenceError(\"'delete super.prop' is invalid\"); }()\n      "])));
		      }
		    }
		  };
		  var looseHandlers = Object.assign({}, specHandlers, {
		    prop: function prop(superMember) {
		      var property = superMember.node.property;
		      if (this.memoiser.has(property)) {
		        return cloneNode$2(this.memoiser.get(property));
		      }
		      return cloneNode$2(property);
		    },
		    get: function get(superMember) {
		      var isStatic = this.isStatic,
		        getSuperRef = this.getSuperRef;
		      var computed = superMember.node.computed;
		      var prop = this.prop(superMember);
		      var object;
		      if (isStatic) {
		        var _getSuperRef;
		        object = (_getSuperRef = getSuperRef()) != null ? _getSuperRef : memberExpression$3(identifier$1("Function"), identifier$1("prototype"));
		      } else {
		        var _getSuperRef2;
		        object = memberExpression$3((_getSuperRef2 = getSuperRef()) != null ? _getSuperRef2 : identifier$1("Object"), identifier$1("prototype"));
		      }
		      return memberExpression$3(object, prop, computed);
		    },
		    set: function set(superMember, value) {
		      var computed = superMember.node.computed;
		      var prop = this.prop(superMember);
		      return assignmentExpression$3("=", memberExpression$3(thisExpression$1(), prop, computed), value);
		    },
		    destructureSet: function destructureSet(superMember) {
		      var computed = superMember.node.computed;
		      var prop = this.prop(superMember);
		      return memberExpression$3(thisExpression$1(), prop, computed);
		    },
		    call: function call(superMember, args) {
		      return optimiseCallExpression(this.get(superMember), thisExpression$1(), args, false);
		    },
		    optionalCall: function optionalCall(superMember, args) {
		      return optimiseCallExpression(this.get(superMember), thisExpression$1(), args, true);
		    }
		  });
		  var ReplaceSupers = function () {
		    function ReplaceSupers(opts) {
		      var _opts$constantSuper;
		      var path = opts.methodPath;
		      this.methodPath = path;
		      this.isDerivedConstructor = path.isClassMethod({
		        kind: "constructor"
		      }) && !!opts.superRef;
		      this.isStatic = path.isObjectMethod() || path.node["static"] || (path.isStaticBlock == null ? void 0 : path.isStaticBlock());
		      this.isPrivateMethod = path.isPrivate() && path.isMethod();
		      this.file = opts.file;
		      this.constantSuper = (_opts$constantSuper = opts.constantSuper) != null ? _opts$constantSuper : opts.isLoose;
		      this.opts = opts;
		    }
		    var _proto = ReplaceSupers.prototype;
		    _proto.getObjectRef = function getObjectRef() {
		      return cloneNode$2(this.opts.objectRef || this.opts.getObjectRef());
		    };
		    _proto.getSuperRef = function getSuperRef() {
		      if (this.opts.superRef) return cloneNode$2(this.opts.superRef);
		      if (this.opts.getSuperRef) {
		        return cloneNode$2(this.opts.getSuperRef());
		      }
		    };
		    _proto.replace = function replace() {
		      var methodPath = this.methodPath;
		      if (this.opts.refToPreserve) {
		        methodPath.traverse(unshadowSuperBindingVisitor, {
		          refName: this.opts.refToPreserve.name
		        });
		      }
		      var handler = this.constantSuper ? looseHandlers : specHandlers;
		      visitor$2.shouldSkip = function (path) {
		        if (path.parentPath === methodPath) {
		          if (path.parentKey === "decorators" || path.parentKey === "key") {
		            return true;
		          }
		        }
		      };
		      memberExpressionToFunctions(methodPath, visitor$2, Object.assign({
		        file: this.file,
		        scope: this.methodPath.scope,
		        isDerivedConstructor: this.isDerivedConstructor,
		        isStatic: this.isStatic,
		        isPrivateMethod: this.isPrivateMethod,
		        getObjectRef: this.getObjectRef.bind(this),
		        getSuperRef: this.getSuperRef.bind(this),
		        boundGet: handler.get
		      }, handler));
		    };
		    return _createClass(ReplaceSupers);
		  }();

		  var isParenthesizedExpression = isParenthesizedExpression$1,
		    isTSAsExpression = isTSAsExpression$1,
		    isTSNonNullExpression = isTSNonNullExpression$1,
		    isTSSatisfiesExpression = isTSSatisfiesExpression$1,
		    isTSTypeAssertion = isTSTypeAssertion$1,
		    isTypeCastExpression = isTypeCastExpression$1;
		  function isTransparentExprWrapper(node) {
		    return isTSAsExpression(node) || isTSSatisfiesExpression(node) || isTSTypeAssertion(node) || isTSNonNullExpression(node) || isTypeCastExpression(node) || isParenthesizedExpression(node);
		  }
		  function skipTransparentExprWrappers(path) {
		    while (isTransparentExprWrapper(path.node)) {
		      path = path.get("expression");
		    }
		    return path;
		  }
		  function skipTransparentExprWrapperNodes(node) {
		    while (isTransparentExprWrapper(node)) {
		      node = node.expression;
		    }
		    return node;
		  }

		  function assertFieldTransformed(path) {
		    if (path.node.declare || false) {
		      throw path.buildCodeFrameError("TypeScript 'declare' fields must first be transformed by " + "@babel/plugin-transform-typescript.\n" + "If you have already enabled that plugin (or '@babel/preset-typescript'), make sure " + "that it runs before any plugin related to additional class features:\n" + " - @babel/plugin-transform-class-properties\n" + " - @babel/plugin-transform-private-methods\n" + " - @babel/plugin-proposal-decorators");
		    }
		  }

		  var _templateObject$v, _templateObject2$g, _templateObject3$b, _templateObject4$7, _templateObject5$4, _templateObject6$2, _templateObject7$1, _templateObject8$1, _templateObject9$1, _templateObject10$1, _templateObject11$1, _templateObject12$1, _templateObject13$1, _templateObject14$1, _templateObject15$1, _templateObject16$1, _templateObject17$1, _templateObject18$1, _templateObject19, _templateObject20, _templateObject21, _templateObject22;
		  {
		    var newHelpers = function newHelpers(file) {
		      return file.availableHelper("classPrivateFieldGet2");
		    };
		  }
		  function buildPrivateNamesMap(className, privateFieldsAsSymbolsOrProperties, props, file) {
		    var privateNamesMap = new Map();
		    var classBrandId;
		    for (var _iterator = _createForOfIteratorHelperLoose(props), _step; !(_step = _iterator()).done;) {
		      var prop = _step.value;
		      if (prop.isPrivate()) {
		        var name = prop.node.key.id.name;
		        var update = privateNamesMap.get(name);
		        if (!update) {
		          var isMethod = !prop.isProperty();
		          var isStatic = prop.node["static"];
		          var initAdded = false;
		          var id = void 0;
		          if (!privateFieldsAsSymbolsOrProperties && newHelpers(file) && isMethod && !isStatic) {
		            var _classBrandId;
		            initAdded = !!classBrandId;
		            (_classBrandId = classBrandId) != null ? _classBrandId : classBrandId = prop.scope.generateUidIdentifier(className + "_brand");
		            id = classBrandId;
		          } else {
		            id = prop.scope.generateUidIdentifier(name);
		          }
		          update = {
		            id: id,
		            "static": isStatic,
		            method: isMethod,
		            initAdded: initAdded
		          };
		          privateNamesMap.set(name, update);
		        }
		        if (prop.isClassPrivateMethod()) {
		          if (prop.node.kind === "get") {
		            var body = prop.node.body.body;
		            var $ = void 0;
		            if (body.length === 1 && isReturnStatement($ = body[0]) && isCallExpression$8($ = $.argument) && $.arguments.length === 1 && isThisExpression$2($.arguments[0]) && isIdentifier$i($ = $.callee)) {
		              update.getId = cloneNode$j($);
		              update.getterDeclared = true;
		            } else {
		              update.getId = prop.scope.generateUidIdentifier("get_" + name);
		            }
		          } else if (prop.node.kind === "set") {
		            var params = prop.node.params;
		            var _body = prop.node.body.body;
		            var _$ = void 0;
		            if (_body.length === 1 && isExpressionStatement$2(_$ = _body[0]) && isCallExpression$8(_$ = _$.expression) && _$.arguments.length === 2 && isThisExpression$2(_$.arguments[0]) && isIdentifier$i(_$.arguments[1], {
		              name: params[0].name
		            }) && isIdentifier$i(_$ = _$.callee)) {
		              update.setId = cloneNode$j(_$);
		              update.setterDeclared = true;
		            } else {
		              update.setId = prop.scope.generateUidIdentifier("set_" + name);
		            }
		          } else if (prop.node.kind === "method") {
		            update.methodId = prop.scope.generateUidIdentifier(name);
		          }
		        }
		        privateNamesMap.set(name, update);
		      }
		    }
		    return privateNamesMap;
		  }
		  function buildPrivateNamesNodes(privateNamesMap, privateFieldsAsProperties, privateFieldsAsSymbols, state) {
		    var initNodes = [];
		    var injectedIds = new Set();
		    for (var _iterator2 = _createForOfIteratorHelperLoose(privateNamesMap), _step2; !(_step2 = _iterator2()).done;) {
		      var _step2$value = _slicedToArray(_step2.value, 2),
		        name = _step2$value[0],
		        value = _step2$value[1];
		      var isStatic = value["static"],
		        isMethod = value.method,
		        getId = value.getId,
		        setId = value.setId;
		      var isGetterOrSetter = getId || setId;
		      var id = cloneNode$j(value.id);
		      var init = void 0;
		      if (privateFieldsAsProperties) {
		        init = callExpression$d(state.addHelper("classPrivateFieldLooseKey"), [stringLiteral$8(name)]);
		      } else if (privateFieldsAsSymbols) {
		        init = callExpression$d(identifier$j("Symbol"), [stringLiteral$8(name)]);
		      } else if (!isStatic) {
		        if (injectedIds.has(id.name)) continue;
		        injectedIds.add(id.name);
		        init = newExpression(identifier$j(isMethod && (!isGetterOrSetter || newHelpers(state)) ? "WeakSet" : "WeakMap"), []);
		      }
		      if (init) {
		        if (!privateFieldsAsSymbols) {
		          annotateAsPure(init);
		        }
		        initNodes.push(template$1.statement.ast(_templateObject$v || (_templateObject$v = _taggedTemplateLiteralLoose(["var ", " = ", ""])), id, init));
		      }
		    }
		    return initNodes;
		  }
		  function privateNameVisitorFactory(visitor) {
		    var nestedVisitor = traverse.visitors.merge([Object.assign({}, visitor), visitor$5]);
		    var privateNameVisitor = Object.assign({}, visitor, {
		      Class: function Class(path) {
		        var privateNamesMap = this.privateNamesMap;
		        var body = path.get("body.body");
		        var visiblePrivateNames = new Map(privateNamesMap);
		        var redeclared = [];
		        for (var _iterator3 = _createForOfIteratorHelperLoose(body), _step3; !(_step3 = _iterator3()).done;) {
		          var prop = _step3.value;
		          if (!prop.isPrivate()) continue;
		          var name = prop.node.key.id.name;
		          visiblePrivateNames["delete"](name);
		          redeclared.push(name);
		        }
		        if (!redeclared.length) {
		          return;
		        }
		        path.get("body").traverse(nestedVisitor, Object.assign({}, this, {
		          redeclared: redeclared
		        }));
		        path.traverse(privateNameVisitor, Object.assign({}, this, {
		          privateNamesMap: visiblePrivateNames
		        }));
		        path.skipKey("body");
		      }
		    });
		    return privateNameVisitor;
		  }
		  var privateNameVisitor = privateNameVisitorFactory({
		    PrivateName: function PrivateName(path, _ref) {
		      var noDocumentAll = _ref.noDocumentAll;
		      var privateNamesMap = this.privateNamesMap,
		        redeclared = this.redeclared;
		      var node = path.node,
		        parentPath = path.parentPath;
		      if (!parentPath.isMemberExpression({
		        property: node
		      }) && !parentPath.isOptionalMemberExpression({
		        property: node
		      })) {
		        return;
		      }
		      var name = node.id.name;
		      if (!privateNamesMap.has(name)) return;
		      if (redeclared && redeclared.includes(name)) return;
		      this.handle(parentPath, noDocumentAll);
		    }
		  });
		  function unshadow(name, scope, innerBinding) {
		    while ((_scope = scope) != null && _scope.hasBinding(name) && !scope.bindingIdentifierEquals(name, innerBinding)) {
		      var _scope;
		      scope.rename(name);
		      scope = scope.parent;
		    }
		  }
		  function buildCheckInRHS(rhs, file, inRHSIsObject) {
		    if (inRHSIsObject || !(file.availableHelper != null && file.availableHelper("checkInRHS"))) return rhs;
		    return callExpression$d(file.addHelper("checkInRHS"), [rhs]);
		  }
		  var privateInVisitor = privateNameVisitorFactory({
		    BinaryExpression: function BinaryExpression(path, _ref2) {
		      var file = _ref2.file;
		      var _path$node = path.node,
		        operator = _path$node.operator,
		        left = _path$node.left,
		        right = _path$node.right;
		      if (operator !== "in") return;
		      if (!isPrivateName$3(left)) return;
		      var privateFieldsAsProperties = this.privateFieldsAsProperties,
		        privateNamesMap = this.privateNamesMap,
		        redeclared = this.redeclared;
		      var name = left.id.name;
		      if (!privateNamesMap.has(name)) return;
		      if (redeclared && redeclared.includes(name)) return;
		      unshadow(this.classRef.name, path.scope, this.innerBinding);
		      if (privateFieldsAsProperties) {
		        var _privateNamesMap$get = privateNamesMap.get(name),
		          _id = _privateNamesMap$get.id;
		        path.replaceWith(template$1.expression.ast(_templateObject2$g || (_templateObject2$g = _taggedTemplateLiteralLoose(["\n        Object.prototype.hasOwnProperty.call(", ", ", ")\n      "])), buildCheckInRHS(right, file), cloneNode$j(_id)));
		        return;
		      }
		      var _privateNamesMap$get2 = privateNamesMap.get(name),
		        id = _privateNamesMap$get2.id,
		        isStatic = _privateNamesMap$get2["static"];
		      if (isStatic) {
		        path.replaceWith(template$1.expression.ast(_templateObject3$b || (_templateObject3$b = _taggedTemplateLiteralLoose(["", " === ", ""])), buildCheckInRHS(right, file), cloneNode$j(this.classRef)));
		        return;
		      }
		      path.replaceWith(template$1.expression.ast(_templateObject4$7 || (_templateObject4$7 = _taggedTemplateLiteralLoose(["", ".has(", ")"])), cloneNode$j(id), buildCheckInRHS(right, file)));
		    }
		  });
		  function readOnlyError(file, name) {
		    return callExpression$d(file.addHelper("readOnlyError"), [stringLiteral$8("#" + name)]);
		  }
		  function writeOnlyError(file, name) {
		    if (!file.availableHelper("writeOnlyError")) {
		      console.warn("@babel/helpers is outdated, update it to silence this warning.");
		      return buildUndefinedNode$2();
		    }
		    return callExpression$d(file.addHelper("writeOnlyError"), [stringLiteral$8("#" + name)]);
		  }
		  function buildStaticPrivateFieldAccess(expr, noUninitializedPrivateFieldAccess) {
		    if (noUninitializedPrivateFieldAccess) return expr;
		    return memberExpression$c(expr, identifier$j("_"));
		  }
		  var privateNameHandlerSpec = {
		    memoise: function memoise(member, count) {
		      var scope = member.scope;
		      var _ref3 = member.node,
		        object = _ref3.object;
		      var memo = scope.maybeGenerateMemoised(object);
		      if (!memo) {
		        return;
		      }
		      this.memoiser.set(object, memo, count);
		    },
		    receiver: function receiver(member) {
		      var _ref4 = member.node,
		        object = _ref4.object;
		      if (this.memoiser.has(object)) {
		        return cloneNode$j(this.memoiser.get(object));
		      }
		      return cloneNode$j(object);
		    },
		    get: function get(member) {
		      var classRef = this.classRef,
		        privateNamesMap = this.privateNamesMap,
		        file = this.file,
		        innerBinding = this.innerBinding,
		        noUninitializedPrivateFieldAccess = this.noUninitializedPrivateFieldAccess;
		      var name = member.node.property.id.name;
		      var _privateNamesMap$get3 = privateNamesMap.get(name),
		        id = _privateNamesMap$get3.id,
		        isStatic = _privateNamesMap$get3["static"],
		        isMethod = _privateNamesMap$get3.method,
		        methodId = _privateNamesMap$get3.methodId,
		        getId = _privateNamesMap$get3.getId,
		        setId = _privateNamesMap$get3.setId;
		      var isGetterOrSetter = getId || setId;
		      if (isStatic) {
		        unshadow(classRef.name, member.scope, innerBinding);
		        if (!newHelpers(file)) {
		          var helperName = isMethod && !isGetterOrSetter ? "classStaticPrivateMethodGet" : "classStaticPrivateFieldSpecGet";
		          return callExpression$d(file.addHelper(helperName), [this.receiver(member), cloneNode$j(classRef), cloneNode$j(id)]);
		        }
		        var _receiver = this.receiver(member);
		        var skipCheck = isIdentifier$i(_receiver) && _receiver.name === classRef.name;
		        if (!isMethod) {
		          if (skipCheck) {
		            return buildStaticPrivateFieldAccess(cloneNode$j(id), noUninitializedPrivateFieldAccess);
		          }
		          return buildStaticPrivateFieldAccess(callExpression$d(file.addHelper("assertClassBrand"), [cloneNode$j(classRef), _receiver, cloneNode$j(id)]), noUninitializedPrivateFieldAccess);
		        }
		        if (getId) {
		          if (skipCheck) {
		            return callExpression$d(cloneNode$j(getId), [_receiver]);
		          }
		          return callExpression$d(file.addHelper("classPrivateGetter"), [cloneNode$j(classRef), _receiver, cloneNode$j(getId)]);
		        }
		        if (setId) {
		          var err = buildUndefinedNode$2();
		          if (skipCheck) return err;
		          return sequenceExpression$8([callExpression$d(file.addHelper("assertClassBrand"), [cloneNode$j(classRef), _receiver]), err]);
		        }
		        if (skipCheck) return cloneNode$j(id);
		        return callExpression$d(file.addHelper("assertClassBrand"), [cloneNode$j(classRef), _receiver, cloneNode$j(id)]);
		      }
		      if (isMethod) {
		        if (isGetterOrSetter) {
		          if (!getId) {
		            return sequenceExpression$8([this.receiver(member), writeOnlyError(file, name)]);
		          }
		          if (!newHelpers(file)) {
		            return callExpression$d(file.addHelper("classPrivateFieldGet"), [this.receiver(member), cloneNode$j(id)]);
		          }
		          return callExpression$d(file.addHelper("classPrivateGetter"), [cloneNode$j(id), this.receiver(member), cloneNode$j(getId)]);
		        }
		        if (!newHelpers(file)) {
		          return callExpression$d(file.addHelper("classPrivateMethodGet"), [this.receiver(member), cloneNode$j(id), cloneNode$j(methodId)]);
		        }
		        return callExpression$d(file.addHelper("assertClassBrand"), [cloneNode$j(id), this.receiver(member), cloneNode$j(methodId)]);
		      }
		      if (newHelpers(file)) {
		        return callExpression$d(file.addHelper("classPrivateFieldGet2"), [cloneNode$j(id), this.receiver(member)]);
		      }
		      return callExpression$d(file.addHelper("classPrivateFieldGet"), [this.receiver(member), cloneNode$j(id)]);
		    },
		    boundGet: function boundGet(member) {
		      this.memoise(member, 1);
		      return callExpression$d(memberExpression$c(this.get(member), identifier$j("bind")), [this.receiver(member)]);
		    },
		    set: function set(member, value) {
		      var classRef = this.classRef,
		        privateNamesMap = this.privateNamesMap,
		        file = this.file,
		        noUninitializedPrivateFieldAccess = this.noUninitializedPrivateFieldAccess;
		      var name = member.node.property.id.name;
		      var _privateNamesMap$get4 = privateNamesMap.get(name),
		        id = _privateNamesMap$get4.id,
		        isStatic = _privateNamesMap$get4["static"],
		        isMethod = _privateNamesMap$get4.method,
		        setId = _privateNamesMap$get4.setId,
		        getId = _privateNamesMap$get4.getId;
		      var isGetterOrSetter = getId || setId;
		      if (isStatic) {
		        if (!newHelpers(file)) {
		          var helperName = isMethod && !isGetterOrSetter ? "classStaticPrivateMethodSet" : "classStaticPrivateFieldSpecSet";
		          return callExpression$d(file.addHelper(helperName), [this.receiver(member), cloneNode$j(classRef), cloneNode$j(id), value]);
		        }
		        var _receiver2 = this.receiver(member);
		        var skipCheck = isIdentifier$i(_receiver2) && _receiver2.name === classRef.name;
		        if (isMethod && !setId) {
		          var err = readOnlyError(file, name);
		          if (skipCheck) return sequenceExpression$8([value, err]);
		          return sequenceExpression$8([value, callExpression$d(file.addHelper("assertClassBrand"), [cloneNode$j(classRef), _receiver2]), readOnlyError(file, name)]);
		        }
		        if (setId) {
		          if (skipCheck) {
		            return callExpression$d(cloneNode$j(setId), [_receiver2, value]);
		          }
		          return callExpression$d(file.addHelper("classPrivateSetter"), [cloneNode$j(classRef), cloneNode$j(setId), _receiver2, value]);
		        }
		        return assignmentExpression$d("=", buildStaticPrivateFieldAccess(cloneNode$j(id), noUninitializedPrivateFieldAccess), skipCheck ? value : callExpression$d(file.addHelper("assertClassBrand"), [cloneNode$j(classRef), _receiver2, value]));
		      }
		      if (isMethod) {
		        if (setId) {
		          if (!newHelpers(file)) {
		            return callExpression$d(file.addHelper("classPrivateFieldSet"), [this.receiver(member), cloneNode$j(id), value]);
		          }
		          return callExpression$d(file.addHelper("classPrivateSetter"), [cloneNode$j(id), cloneNode$j(setId), this.receiver(member), value]);
		        }
		        return sequenceExpression$8([this.receiver(member), value, readOnlyError(file, name)]);
		      }
		      if (newHelpers(file)) {
		        return callExpression$d(file.addHelper("classPrivateFieldSet2"), [cloneNode$j(id), this.receiver(member), value]);
		      }
		      return callExpression$d(file.addHelper("classPrivateFieldSet"), [this.receiver(member), cloneNode$j(id), value]);
		    },
		    destructureSet: function destructureSet(member) {
		      var classRef = this.classRef,
		        privateNamesMap = this.privateNamesMap,
		        file = this.file,
		        noUninitializedPrivateFieldAccess = this.noUninitializedPrivateFieldAccess;
		      var name = member.node.property.id.name;
		      var _privateNamesMap$get5 = privateNamesMap.get(name),
		        id = _privateNamesMap$get5.id,
		        isStatic = _privateNamesMap$get5["static"],
		        isMethod = _privateNamesMap$get5.method,
		        setId = _privateNamesMap$get5.setId;
		      if (!newHelpers(file)) {
		        if (isStatic) {
		          try {
		            var helper = file.addHelper("classStaticPrivateFieldDestructureSet");
		          } catch (_unused) {
		            throw new Error("Babel can not transpile `[C.#p] = [0]` with @babel/helpers < 7.13.10, \n" + "please update @babel/helpers to the latest version.");
		          }
		          return memberExpression$c(callExpression$d(helper, [this.receiver(member), cloneNode$j(classRef), cloneNode$j(id)]), identifier$j("value"));
		        }
		        return memberExpression$c(callExpression$d(file.addHelper("classPrivateFieldDestructureSet"), [this.receiver(member), cloneNode$j(id)]), identifier$j("value"));
		      }
		      if (isMethod && !setId) {
		        return memberExpression$c(sequenceExpression$8([member.node.object, readOnlyError(file, name)]), identifier$j("_"));
		      }
		      if (isStatic && !isMethod) {
		        var getCall = this.get(member);
		        if (!noUninitializedPrivateFieldAccess || !isCallExpression$8(getCall)) {
		          return getCall;
		        }
		        var ref = getCall.arguments.pop();
		        getCall.arguments.push(template$1.expression.ast(_templateObject5$4 || (_templateObject5$4 = _taggedTemplateLiteralLoose(["(_) => ", " = _"])), ref));
		        return memberExpression$c(callExpression$d(file.addHelper("toSetter"), [getCall]), identifier$j("_"));
		      }
		      var setCall = this.set(member, identifier$j("_"));
		      if (!isCallExpression$8(setCall) || !isIdentifier$i(setCall.arguments[setCall.arguments.length - 1], {
		        name: "_"
		      })) {
		        throw member.buildCodeFrameError("Internal Babel error while compiling this code. This is a Babel bug. " + "Please report it at https://github.com/babel/babel/issues.");
		      }
		      var args;
		      if (isMemberExpression$9(setCall.callee, {
		        computed: false
		      }) && isIdentifier$i(setCall.callee.property) && setCall.callee.property.name === "call") {
		        args = [setCall.callee.object, arrayExpression$1(setCall.arguments.slice(1, -1)), setCall.arguments[0]];
		      } else {
		        args = [setCall.callee, arrayExpression$1(setCall.arguments.slice(0, -1))];
		      }
		      return memberExpression$c(callExpression$d(file.addHelper("toSetter"), args), identifier$j("_"));
		    },
		    call: function call(member, args) {
		      this.memoise(member, 1);
		      return optimiseCallExpression(this.get(member), this.receiver(member), args, false);
		    },
		    optionalCall: function optionalCall(member, args) {
		      this.memoise(member, 1);
		      return optimiseCallExpression(this.get(member), this.receiver(member), args, true);
		    },
		    "delete": function _delete() {
		      throw new Error("Internal Babel error: deleting private elements is a parsing error.");
		    }
		  };
		  var privateNameHandlerLoose = {
		    get: function get(member) {
		      var privateNamesMap = this.privateNamesMap,
		        file = this.file;
		      var object = member.node.object;
		      var name = member.node.property.id.name;
		      return template$1.expression(_templateObject6$2 || (_templateObject6$2 = _taggedTemplateLiteralLoose(["BASE(REF, PROP)[PROP]"])))({
		        BASE: file.addHelper("classPrivateFieldLooseBase"),
		        REF: cloneNode$j(object),
		        PROP: cloneNode$j(privateNamesMap.get(name).id)
		      });
		    },
		    set: function set() {
		      throw new Error("private name handler with loose = true don't need set()");
		    },
		    boundGet: function boundGet(member) {
		      return callExpression$d(memberExpression$c(this.get(member), identifier$j("bind")), [cloneNode$j(member.node.object)]);
		    },
		    simpleSet: function simpleSet(member) {
		      return this.get(member);
		    },
		    destructureSet: function destructureSet(member) {
		      return this.get(member);
		    },
		    call: function call(member, args) {
		      return callExpression$d(this.get(member), args);
		    },
		    optionalCall: function optionalCall(member, args) {
		      return optionalCallExpression$2(this.get(member), args, true);
		    },
		    "delete": function _delete() {
		      throw new Error("Internal Babel error: deleting private elements is a parsing error.");
		    }
		  };
		  function transformPrivateNamesUsage(ref, path, privateNamesMap, _ref5, state) {
		    var privateFieldsAsProperties = _ref5.privateFieldsAsProperties,
		      noUninitializedPrivateFieldAccess = _ref5.noUninitializedPrivateFieldAccess,
		      noDocumentAll = _ref5.noDocumentAll,
		      innerBinding = _ref5.innerBinding;
		    if (!privateNamesMap.size) return;
		    var body = path.get("body");
		    var handler = privateFieldsAsProperties ? privateNameHandlerLoose : privateNameHandlerSpec;
		    memberExpressionToFunctions(body, privateNameVisitor, Object.assign({
		      privateNamesMap: privateNamesMap,
		      classRef: ref,
		      file: state
		    }, handler, {
		      noDocumentAll: noDocumentAll,
		      noUninitializedPrivateFieldAccess: noUninitializedPrivateFieldAccess,
		      innerBinding: innerBinding
		    }));
		    body.traverse(privateInVisitor, {
		      privateNamesMap: privateNamesMap,
		      classRef: ref,
		      file: state,
		      privateFieldsAsProperties: privateFieldsAsProperties,
		      innerBinding: innerBinding
		    });
		  }
		  function buildPrivateFieldInitLoose(ref, prop, privateNamesMap) {
		    var _privateNamesMap$get6 = privateNamesMap.get(prop.node.key.id.name),
		      id = _privateNamesMap$get6.id;
		    var value = prop.node.value || prop.scope.buildUndefinedNode();
		    return inheritPropComments(template$1.statement.ast(_templateObject7$1 || (_templateObject7$1 = _taggedTemplateLiteralLoose(["\n      Object.defineProperty(", ", ", ", {\n        // configurable is false by default\n        // enumerable is false by default\n        writable: true,\n        value: ", "\n      });\n    "])), ref, cloneNode$j(id), value), prop);
		  }
		  function buildPrivateInstanceFieldInitSpec(ref, prop, privateNamesMap, state) {
		    var _privateNamesMap$get7 = privateNamesMap.get(prop.node.key.id.name),
		      id = _privateNamesMap$get7.id;
		    var value = prop.node.value || prop.scope.buildUndefinedNode();
		    {
		      if (!state.availableHelper("classPrivateFieldInitSpec")) {
		        return inheritPropComments(template$1.statement.ast(_templateObject8$1 || (_templateObject8$1 = _taggedTemplateLiteralLoose(["", ".set(", ", {\n          // configurable is always false for private elements\n          // enumerable is always false for private elements\n          writable: true,\n          value: ", ",\n        })"])), cloneNode$j(id), ref, value), prop);
		      }
		    }
		    var helper = state.addHelper("classPrivateFieldInitSpec");
		    return inheritPropComments(expressionStatement$a(callExpression$d(helper, [thisExpression$4(), cloneNode$j(id), newHelpers(state) ? value : template$1.expression.ast(_templateObject9$1 || (_templateObject9$1 = _taggedTemplateLiteralLoose(["{ writable: true, value: ", " }"])), value)])), prop);
		  }
		  function buildPrivateStaticFieldInitSpec(prop, privateNamesMap, noUninitializedPrivateFieldAccess) {
		    var privateName = privateNamesMap.get(prop.node.key.id.name);
		    var value = noUninitializedPrivateFieldAccess ? prop.node.value : template$1.expression.ast(_templateObject10$1 || (_templateObject10$1 = _taggedTemplateLiteralLoose(["{\n        _: ", "\n      }"])), prop.node.value || buildUndefinedNode$2());
		    return inheritPropComments(variableDeclaration$8("var", [variableDeclarator$8(cloneNode$j(privateName.id), value)]), prop);
		  }
		  {
		    var buildPrivateStaticFieldInitSpecOld = function buildPrivateStaticFieldInitSpecOld(prop, privateNamesMap) {
		      var privateName = privateNamesMap.get(prop.node.key.id.name);
		      var id = privateName.id,
		        getId = privateName.getId,
		        setId = privateName.setId,
		        initAdded = privateName.initAdded;
		      var isGetterOrSetter = getId || setId;
		      if (!prop.isProperty() && (initAdded || !isGetterOrSetter)) return;
		      if (isGetterOrSetter) {
		        privateNamesMap.set(prop.node.key.id.name, Object.assign({}, privateName, {
		          initAdded: true
		        }));
		        return inheritPropComments(template$1.statement.ast(_templateObject11$1 || (_templateObject11$1 = _taggedTemplateLiteralLoose(["\n          var ", " = {\n            // configurable is false by default\n            // enumerable is false by default\n            // writable is false by default\n            get: ", ",\n            set: ", "\n          }\n        "])), cloneNode$j(id), getId ? getId.name : prop.scope.buildUndefinedNode(), setId ? setId.name : prop.scope.buildUndefinedNode()), prop);
		      }
		      var value = prop.node.value || prop.scope.buildUndefinedNode();
		      return inheritPropComments(template$1.statement.ast(_templateObject12$1 || (_templateObject12$1 = _taggedTemplateLiteralLoose(["\n        var ", " = {\n          // configurable is false by default\n          // enumerable is false by default\n          writable: true,\n          value: ", "\n        };\n      "])), cloneNode$j(id), value), prop);
		    };
		  }
		  function buildPrivateMethodInitLoose(ref, prop, privateNamesMap) {
		    var privateName = privateNamesMap.get(prop.node.key.id.name);
		    var methodId = privateName.methodId,
		      id = privateName.id,
		      getId = privateName.getId,
		      setId = privateName.setId,
		      initAdded = privateName.initAdded;
		    if (initAdded) return;
		    if (methodId) {
		      return inheritPropComments(template$1.statement.ast(_templateObject13$1 || (_templateObject13$1 = _taggedTemplateLiteralLoose(["\n        Object.defineProperty(", ", ", ", {\n          // configurable is false by default\n          // enumerable is false by default\n          // writable is false by default\n          value: ", "\n        });\n      "])), ref, id, methodId.name), prop);
		    }
		    var isGetterOrSetter = getId || setId;
		    if (isGetterOrSetter) {
		      privateNamesMap.set(prop.node.key.id.name, Object.assign({}, privateName, {
		        initAdded: true
		      }));
		      return inheritPropComments(template$1.statement.ast(_templateObject14$1 || (_templateObject14$1 = _taggedTemplateLiteralLoose(["\n        Object.defineProperty(", ", ", ", {\n          // configurable is false by default\n          // enumerable is false by default\n          // writable is false by default\n          get: ", ",\n          set: ", "\n        });\n      "])), ref, id, getId ? getId.name : prop.scope.buildUndefinedNode(), setId ? setId.name : prop.scope.buildUndefinedNode()), prop);
		    }
		  }
		  function buildPrivateInstanceMethodInitSpec(ref, prop, privateNamesMap, state) {
		    var privateName = privateNamesMap.get(prop.node.key.id.name);
		    if (privateName.initAdded) return;
		    if (!newHelpers(state)) {
		      var isGetterOrSetter = privateName.getId || privateName.setId;
		      if (isGetterOrSetter) {
		        return buildPrivateAccessorInitialization(ref, prop, privateNamesMap, state);
		      }
		    }
		    return buildPrivateInstanceMethodInitialization(ref, prop, privateNamesMap, state);
		  }
		  function buildPrivateAccessorInitialization(ref, prop, privateNamesMap, state) {
		    var privateName = privateNamesMap.get(prop.node.key.id.name);
		    var id = privateName.id,
		      getId = privateName.getId,
		      setId = privateName.setId;
		    privateNamesMap.set(prop.node.key.id.name, Object.assign({}, privateName, {
		      initAdded: true
		    }));
		    {
		      if (!state.availableHelper("classPrivateFieldInitSpec")) {
		        return inheritPropComments(template$1.statement.ast(_templateObject15$1 || (_templateObject15$1 = _taggedTemplateLiteralLoose(["\n          ", ".set(", ", {\n            get: ", ",\n            set: ", "\n          });\n        "])), id, ref, getId ? getId.name : prop.scope.buildUndefinedNode(), setId ? setId.name : prop.scope.buildUndefinedNode()), prop);
		      }
		    }
		    var helper = state.addHelper("classPrivateFieldInitSpec");
		    return inheritPropComments(template$1.statement.ast(_templateObject16$1 || (_templateObject16$1 = _taggedTemplateLiteralLoose(["", "(\n      ", ",\n      ", ",\n      {\n        get: ", ",\n        set: ", "\n      },\n    )"])), helper, thisExpression$4(), cloneNode$j(id), getId ? getId.name : prop.scope.buildUndefinedNode(), setId ? setId.name : prop.scope.buildUndefinedNode()), prop);
		  }
		  function buildPrivateInstanceMethodInitialization(ref, prop, privateNamesMap, state) {
		    var privateName = privateNamesMap.get(prop.node.key.id.name);
		    var id = privateName.id;
		    {
		      if (!state.availableHelper("classPrivateMethodInitSpec")) {
		        return inheritPropComments(template$1.statement.ast(_templateObject17$1 || (_templateObject17$1 = _taggedTemplateLiteralLoose(["", ".add(", ")"])), id, ref), prop);
		      }
		    }
		    var helper = state.addHelper("classPrivateMethodInitSpec");
		    return inheritPropComments(template$1.statement.ast(_templateObject18$1 || (_templateObject18$1 = _taggedTemplateLiteralLoose(["", "(\n      ", ",\n      ", "\n    )"])), helper, thisExpression$4(), cloneNode$j(id)), prop);
		  }
		  function buildPublicFieldInitLoose(ref, prop) {
		    var _prop$node = prop.node,
		      key = _prop$node.key,
		      computed = _prop$node.computed;
		    var value = prop.node.value || prop.scope.buildUndefinedNode();
		    return inheritPropComments(expressionStatement$a(assignmentExpression$d("=", memberExpression$c(ref, key, computed || isLiteral$6(key)), value)), prop);
		  }
		  function buildPublicFieldInitSpec(ref, prop, state) {
		    var _prop$node2 = prop.node,
		      key = _prop$node2.key,
		      computed = _prop$node2.computed;
		    var value = prop.node.value || prop.scope.buildUndefinedNode();
		    return inheritPropComments(expressionStatement$a(callExpression$d(state.addHelper("defineProperty"), [ref, computed || isLiteral$6(key) ? key : stringLiteral$8(key.name), value])), prop);
		  }
		  function buildPrivateStaticMethodInitLoose(ref, prop, state, privateNamesMap) {
		    var privateName = privateNamesMap.get(prop.node.key.id.name);
		    var id = privateName.id,
		      methodId = privateName.methodId,
		      getId = privateName.getId,
		      setId = privateName.setId,
		      initAdded = privateName.initAdded;
		    if (initAdded) return;
		    var isGetterOrSetter = getId || setId;
		    if (isGetterOrSetter) {
		      privateNamesMap.set(prop.node.key.id.name, Object.assign({}, privateName, {
		        initAdded: true
		      }));
		      return inheritPropComments(template$1.statement.ast(_templateObject19 || (_templateObject19 = _taggedTemplateLiteralLoose(["\n        Object.defineProperty(", ", ", ", {\n          // configurable is false by default\n          // enumerable is false by default\n          // writable is false by default\n          get: ", ",\n          set: ", "\n        })\n      "])), ref, id, getId ? getId.name : prop.scope.buildUndefinedNode(), setId ? setId.name : prop.scope.buildUndefinedNode()), prop);
		    }
		    return inheritPropComments(template$1.statement.ast(_templateObject20 || (_templateObject20 = _taggedTemplateLiteralLoose(["\n      Object.defineProperty(", ", ", ", {\n        // configurable is false by default\n        // enumerable is false by default\n        // writable is false by default\n        value: ", "\n      });\n    "])), ref, id, methodId.name), prop);
		  }
		  function buildPrivateMethodDeclaration(file, prop, privateNamesMap, privateFieldsAsSymbolsOrProperties) {
		    if (privateFieldsAsSymbolsOrProperties === void 0) {
		      privateFieldsAsSymbolsOrProperties = false;
		    }
		    var privateName = privateNamesMap.get(prop.node.key.id.name);
		    var id = privateName.id,
		      methodId = privateName.methodId,
		      getId = privateName.getId,
		      setId = privateName.setId,
		      getterDeclared = privateName.getterDeclared,
		      setterDeclared = privateName.setterDeclared,
		      isStatic = privateName["static"];
		    var _prop$node3 = prop.node,
		      params = _prop$node3.params,
		      body = _prop$node3.body,
		      generator = _prop$node3.generator,
		      async = _prop$node3.async;
		    var isGetter = getId && params.length === 0;
		    var isSetter = setId && params.length > 0;
		    if (isGetter && getterDeclared || isSetter && setterDeclared) {
		      privateNamesMap.set(prop.node.key.id.name, Object.assign({}, privateName, {
		        initAdded: true
		      }));
		      return null;
		    }
		    if (newHelpers(file) && (isGetter || isSetter) && !privateFieldsAsSymbolsOrProperties) {
		      var scope = prop.get("body").scope;
		      var thisArg = scope.generateUidIdentifier("this");
		      var state = {
		        thisRef: thisArg,
		        argumentsPath: []
		      };
		      prop.traverse(thisContextVisitor, state);
		      if (state.argumentsPath.length) {
		        var argumentsId = scope.generateUidIdentifier("arguments");
		        scope.push({
		          id: argumentsId,
		          init: template$1.expression.ast(_templateObject21 || (_templateObject21 = _taggedTemplateLiteralLoose(["[].slice.call(arguments, 1)"])))
		        });
		        for (var _iterator4 = _createForOfIteratorHelperLoose(state.argumentsPath), _step4; !(_step4 = _iterator4()).done;) {
		          var path = _step4.value;
		          path.replaceWith(cloneNode$j(argumentsId));
		        }
		      }
		      params.unshift(cloneNode$j(thisArg));
		    }
		    var declId = methodId;
		    if (isGetter) {
		      privateNamesMap.set(prop.node.key.id.name, Object.assign({}, privateName, {
		        getterDeclared: true,
		        initAdded: true
		      }));
		      declId = getId;
		    } else if (isSetter) {
		      privateNamesMap.set(prop.node.key.id.name, Object.assign({}, privateName, {
		        setterDeclared: true,
		        initAdded: true
		      }));
		      declId = setId;
		    } else if (isStatic && !privateFieldsAsSymbolsOrProperties) {
		      declId = id;
		    }
		    return inheritPropComments(functionDeclaration(cloneNode$j(declId), params, body, generator, async), prop);
		  }
		  var thisContextVisitor = traverse.visitors.merge([{
		    Identifier: function Identifier(path, state) {
		      if (state.argumentsPath && path.node.name === "arguments") {
		        state.argumentsPath.push(path);
		      }
		    },
		    UnaryExpression: function UnaryExpression(path) {
		      var node = path.node;
		      if (node.operator === "delete") {
		        var argument = skipTransparentExprWrapperNodes(node.argument);
		        if (isThisExpression$2(argument)) {
		          path.replaceWith(booleanLiteral$4(true));
		        }
		      }
		    },
		    ThisExpression: function ThisExpression(path, state) {
		      state.needsClassRef = true;
		      path.replaceWith(cloneNode$j(state.thisRef));
		    },
		    MetaProperty: function MetaProperty(path) {
		      var node = path.node,
		        scope = path.scope;
		      if (node.meta.name === "new" && node.property.name === "target") {
		        path.replaceWith(scope.buildUndefinedNode());
		      }
		    }
		  }, visitor$5]);
		  var innerReferencesVisitor = {
		    ReferencedIdentifier: function ReferencedIdentifier(path, state) {
		      if (path.scope.bindingIdentifierEquals(path.node.name, state.innerBinding)) {
		        state.needsClassRef = true;
		        path.node.name = state.thisRef.name;
		      }
		    }
		  };
		  function replaceThisContext(path, ref, innerBindingRef) {
		    var _state$thisRef;
		    var state = {
		      thisRef: ref,
		      needsClassRef: false,
		      innerBinding: innerBindingRef
		    };
		    if (!path.isMethod()) {
		      path.traverse(thisContextVisitor, state);
		    }
		    if (innerBindingRef != null && (_state$thisRef = state.thisRef) != null && _state$thisRef.name && state.thisRef.name !== innerBindingRef.name) {
		      path.traverse(innerReferencesVisitor, state);
		    }
		    return state.needsClassRef;
		  }
		  function isNameOrLength$1(_ref6) {
		    var key = _ref6.key,
		      computed = _ref6.computed;
		    if (key.type === "Identifier") {
		      return !computed && (key.name === "name" || key.name === "length");
		    }
		    if (key.type === "StringLiteral") {
		      return key.value === "name" || key.value === "length";
		    }
		    return false;
		  }
		  function inheritPropComments(node, prop) {
		    inheritLeadingComments$1(node, prop.node);
		    inheritInnerComments(node, prop.node);
		    return node;
		  }
		  function buildFieldsInitNodes(ref, superRef, props, privateNamesMap, file, setPublicClassFields, privateFieldsAsSymbolsOrProperties, noUninitializedPrivateFieldAccess, constantSuper, innerBindingRef) {
		    var _ref7, _ref8;
		    var classRefFlags = 0;
		    var injectSuperRef;
		    var staticNodes = [];
		    var instanceNodes = [];
		    var lastInstanceNodeReturnsThis = false;
		    var pureStaticNodes = [];
		    var classBindingNode = null;
		    var getSuperRef = isIdentifier$i(superRef) ? function () {
		      return superRef;
		    } : function () {
		      var _injectSuperRef;
		      (_injectSuperRef = injectSuperRef) != null ? _injectSuperRef : injectSuperRef = props[0].scope.generateUidIdentifierBasedOnNode(superRef);
		      return injectSuperRef;
		    };
		    var classRefForInnerBinding = (_ref7 = ref) != null ? _ref7 : props[0].scope.generateUidIdentifier((innerBindingRef == null ? void 0 : innerBindingRef.name) || "Class");
		    (_ref8 = ref) != null ? _ref8 : ref = cloneNode$j(innerBindingRef);
		    var _loop = function _loop() {
		      var prop = _step5.value;
		      prop.isClassProperty() && assertFieldTransformed(prop);
		      var isStatic = !(isStaticBlock != null && isStaticBlock(prop.node)) && prop.node["static"];
		      var isInstance = !isStatic;
		      var isPrivate = prop.isPrivate();
		      var isPublic = !isPrivate;
		      var isField = prop.isProperty();
		      var isMethod = !isField;
		      var isStaticBlock$1 = prop.isStaticBlock == null ? void 0 : prop.isStaticBlock();
		      if (isStatic) classRefFlags |= 1;
		      if (isStatic || isMethod && isPrivate || isStaticBlock$1) {
		        new ReplaceSupers({
		          methodPath: prop,
		          constantSuper: constantSuper,
		          file: file,
		          refToPreserve: innerBindingRef,
		          getSuperRef: getSuperRef,
		          getObjectRef: function getObjectRef() {
		            classRefFlags |= 2;
		            if (isStatic || isStaticBlock$1) {
		              return classRefForInnerBinding;
		            } else {
		              return memberExpression$c(classRefForInnerBinding, identifier$j("prototype"));
		            }
		          }
		        }).replace();
		        var replaced = replaceThisContext(prop, classRefForInnerBinding, innerBindingRef);
		        if (replaced) {
		          classRefFlags |= 2;
		        }
		      }
		      lastInstanceNodeReturnsThis = false;
		      switch (true) {
		        case isStaticBlock$1:
		          {
		            var blockBody = prop.node.body;
		            if (blockBody.length === 1 && isExpressionStatement$2(blockBody[0])) {
		              staticNodes.push(inheritPropComments(blockBody[0], prop));
		            } else {
		              staticNodes.push(inheritsComments$1(template$1.statement.ast(_templateObject22 || (_templateObject22 = _taggedTemplateLiteralLoose(["(() => { ", " })()"])), blockBody), prop.node));
		            }
		            break;
		          }
		        case isStatic && isPrivate && isField && privateFieldsAsSymbolsOrProperties:
		          staticNodes.push(buildPrivateFieldInitLoose(cloneNode$j(ref), prop, privateNamesMap));
		          break;
		        case isStatic && isPrivate && isField && !privateFieldsAsSymbolsOrProperties:
		          if (!newHelpers(file)) {
		            staticNodes.push(buildPrivateStaticFieldInitSpecOld(prop, privateNamesMap));
		          } else {
		            staticNodes.push(buildPrivateStaticFieldInitSpec(prop, privateNamesMap, noUninitializedPrivateFieldAccess));
		          }
		          break;
		        case isStatic && isPublic && isField && setPublicClassFields:
		          if (!isNameOrLength$1(prop.node)) {
		            staticNodes.push(buildPublicFieldInitLoose(cloneNode$j(ref), prop));
		            break;
		          }
		        case isStatic && isPublic && isField && !setPublicClassFields:
		          staticNodes.push(buildPublicFieldInitSpec(cloneNode$j(ref), prop, file));
		          break;
		        case isInstance && isPrivate && isField && privateFieldsAsSymbolsOrProperties:
		          instanceNodes.push(buildPrivateFieldInitLoose(thisExpression$4(), prop, privateNamesMap));
		          break;
		        case isInstance && isPrivate && isField && !privateFieldsAsSymbolsOrProperties:
		          instanceNodes.push(buildPrivateInstanceFieldInitSpec(thisExpression$4(), prop, privateNamesMap, file));
		          break;
		        case isInstance && isPrivate && isMethod && privateFieldsAsSymbolsOrProperties:
		          instanceNodes.unshift(buildPrivateMethodInitLoose(thisExpression$4(), prop, privateNamesMap));
		          pureStaticNodes.push(buildPrivateMethodDeclaration(file, prop, privateNamesMap, privateFieldsAsSymbolsOrProperties));
		          break;
		        case isInstance && isPrivate && isMethod && !privateFieldsAsSymbolsOrProperties:
		          instanceNodes.unshift(buildPrivateInstanceMethodInitSpec(thisExpression$4(), prop, privateNamesMap, file));
		          pureStaticNodes.push(buildPrivateMethodDeclaration(file, prop, privateNamesMap, privateFieldsAsSymbolsOrProperties));
		          break;
		        case isStatic && isPrivate && isMethod && !privateFieldsAsSymbolsOrProperties:
		          if (!newHelpers(file)) {
		            staticNodes.unshift(buildPrivateStaticFieldInitSpecOld(prop, privateNamesMap));
		          }
		          pureStaticNodes.push(buildPrivateMethodDeclaration(file, prop, privateNamesMap, privateFieldsAsSymbolsOrProperties));
		          break;
		        case isStatic && isPrivate && isMethod && privateFieldsAsSymbolsOrProperties:
		          staticNodes.unshift(buildPrivateStaticMethodInitLoose(cloneNode$j(ref), prop, file, privateNamesMap));
		          pureStaticNodes.push(buildPrivateMethodDeclaration(file, prop, privateNamesMap, privateFieldsAsSymbolsOrProperties));
		          break;
		        case isInstance && isPublic && isField && setPublicClassFields:
		          instanceNodes.push(buildPublicFieldInitLoose(thisExpression$4(), prop));
		          break;
		        case isInstance && isPublic && isField && !setPublicClassFields:
		          lastInstanceNodeReturnsThis = true;
		          instanceNodes.push(buildPublicFieldInitSpec(thisExpression$4(), prop, file));
		          break;
		        default:
		          throw new Error("Unreachable.");
		      }
		    };
		    for (var _iterator5 = _createForOfIteratorHelperLoose(props), _step5; !(_step5 = _iterator5()).done;) {
		      _loop();
		    }
		    if (classRefFlags & 2 && innerBindingRef != null) {
		      classBindingNode = expressionStatement$a(assignmentExpression$d("=", cloneNode$j(classRefForInnerBinding), cloneNode$j(innerBindingRef)));
		    }
		    return {
		      staticNodes: staticNodes.filter(Boolean),
		      instanceNodes: instanceNodes.filter(Boolean),
		      lastInstanceNodeReturnsThis: lastInstanceNodeReturnsThis,
		      pureStaticNodes: pureStaticNodes.filter(Boolean),
		      classBindingNode: classBindingNode,
		      wrapClass: function wrapClass(path) {
		        for (var _iterator6 = _createForOfIteratorHelperLoose(props), _step6; !(_step6 = _iterator6()).done;) {
		          var prop = _step6.value;
		          prop.node.leadingComments = null;
		          prop.remove();
		        }
		        if (injectSuperRef) {
		          path.scope.push({
		            id: cloneNode$j(injectSuperRef)
		          });
		          path.set("superClass", assignmentExpression$d("=", injectSuperRef, path.node.superClass));
		        }
		        if (classRefFlags !== 0) {
		          if (path.isClassExpression()) {
		            path.scope.push({
		              id: ref
		            });
		            path.replaceWith(assignmentExpression$d("=", cloneNode$j(ref), path.node));
		          } else {
		            if (innerBindingRef == null) {
		              path.node.id = ref;
		            }
		            if (classBindingNode != null) {
		              path.scope.push({
		                id: classRefForInnerBinding
		              });
		            }
		          }
		        }
		        return path;
		      }
		    };
		  }

		  var _templateObject$u;
		  var findBareSupers = traverse.visitors.merge([{
		    Super: function Super(path) {
		      var node = path.node,
		        parentPath = path.parentPath;
		      if (parentPath.isCallExpression({
		        callee: node
		      })) {
		        this.push(parentPath);
		      }
		    }
		  }, visitor$5]);
		  var referenceVisitor = {
		    "TSTypeAnnotation|TypeAnnotation": function TSTypeAnnotationTypeAnnotation(path) {
		      path.skip();
		    },
		    ReferencedIdentifier: function ReferencedIdentifier(path, _ref) {
		      var scope = _ref.scope;
		      if (scope.hasOwnBinding(path.node.name)) {
		        scope.rename(path.node.name);
		        path.skip();
		      }
		    }
		  };
		  function handleClassTDZ(path, state) {
		    if (state.classBinding && state.classBinding === path.scope.getBinding(path.node.name)) {
		      var classNameTDZError = state.file.addHelper("classNameTDZError");
		      var throwNode = callExpression$d(classNameTDZError, [stringLiteral$8(path.node.name)]);
		      path.replaceWith(sequenceExpression$8([throwNode, path.node]));
		      path.skip();
		    }
		  }
		  var classFieldDefinitionEvaluationTDZVisitor = {
		    ReferencedIdentifier: handleClassTDZ
		  };
		  function injectInitialization(path, constructor, nodes, renamer, lastReturnsThis) {
		    if (!nodes.length) return;
		    var isDerived = !!path.node.superClass;
		    if (!constructor) {
		      var newConstructor = classMethod("constructor", identifier$j("constructor"), [], blockStatement$6([]));
		      if (isDerived) {
		        newConstructor.params = [restElement$2(identifier$j("args"))];
		        newConstructor.body.body.push(template$1.statement.ast(_templateObject$u || (_templateObject$u = _taggedTemplateLiteralLoose(["super(...args)"]))));
		      }
		      var _ref2 = path.get("body").unshiftContainer("body", newConstructor);
		      var _ref3 = _slicedToArray(_ref2, 1);
		      constructor = _ref3[0];
		    }
		    if (renamer) {
		      renamer(referenceVisitor, {
		        scope: constructor.scope
		      });
		    }
		    if (isDerived) {
		      var bareSupers = [];
		      constructor.traverse(findBareSupers, bareSupers);
		      var isFirst = true;
		      for (var _i = 0, _bareSupers = bareSupers; _i < _bareSupers.length; _i++) {
		        var bareSuper = _bareSupers[_i];
		        if (isFirst) {
		          isFirst = false;
		        } else {
		          nodes = nodes.map(function (n) {
		            return cloneNode$j(n);
		          });
		        }
		        if (!bareSuper.parentPath.isExpressionStatement()) {
		          var allNodes = [bareSuper.node].concat(_toConsumableArray(nodes.map(function (n) {
		            return toExpression$1(n);
		          })));
		          if (!lastReturnsThis) allNodes.push(thisExpression$4());
		          bareSuper.replaceWith(sequenceExpression$8(allNodes));
		        } else {
		          bareSuper.insertAfter(nodes);
		        }
		      }
		    } else {
		      constructor.get("body").unshiftContainer("body", nodes);
		    }
		  }
		  function memoiseComputedKey(keyNode, scope, hint) {
		    var isUidReference = isIdentifier$i(keyNode) && scope.hasUid(keyNode.name);
		    if (isUidReference) {
		      return;
		    }
		    var isMemoiseAssignment = isAssignmentExpression$3(keyNode, {
		      operator: "="
		    }) && isIdentifier$i(keyNode.left) && scope.hasUid(keyNode.left.name);
		    if (isMemoiseAssignment) {
		      return cloneNode$j(keyNode);
		    } else {
		      var ident = identifier$j(hint);
		      scope.push({
		        id: ident,
		        kind: "let"
		      });
		      return assignmentExpression$d("=", cloneNode$j(ident), keyNode);
		    }
		  }
		  function extractComputedKeys(path, computedPaths, file) {
		    var scope = path.scope;
		    var declarations = [];
		    var state = {
		      classBinding: path.node.id && scope.getBinding(path.node.id.name),
		      file: file
		    };
		    for (var _iterator = _createForOfIteratorHelperLoose(computedPaths), _step; !(_step = _iterator()).done;) {
		      var computedPath = _step.value;
		      var computedKey = computedPath.get("key");
		      if (computedKey.isReferencedIdentifier()) {
		        handleClassTDZ(computedKey, state);
		      } else {
		        computedKey.traverse(classFieldDefinitionEvaluationTDZVisitor, state);
		      }
		      var computedNode = computedPath.node;
		      if (!computedKey.isConstantExpression()) {
		        var assignment = memoiseComputedKey(computedKey.node, scope, scope.generateUidBasedOnNode(computedKey.node));
		        if (assignment) {
		          declarations.push(expressionStatement$a(assignment));
		          computedNode.key = cloneNode$j(assignment.left);
		        }
		      }
		    }
		    return declarations;
		  }

		  var _templateObject$t, _templateObject2$f, _templateObject3$a, _templateObject4$6, _templateObject5$3;
		  function incrementId(id, idx) {
		    if (idx === void 0) {
		      idx = id.length - 1;
		    }
		    if (idx === -1) {
		      id.unshift(65);
		      return;
		    }
		    var current = id[idx];
		    if (current === 90) {
		      id[idx] = 97;
		    } else if (current === 122) {
		      id[idx] = 65;
		      incrementId(id, idx - 1);
		    } else {
		      id[idx] = current + 1;
		    }
		  }
		  function createPrivateUidGeneratorForClass(classPath) {
		    var currentPrivateId = [];
		    var privateNames = new Set();
		    classPath.traverse({
		      PrivateName: function PrivateName(path) {
		        privateNames.add(path.node.id.name);
		      }
		    });
		    return function () {
		      var reifiedId;
		      do {
		        incrementId(currentPrivateId);
		        reifiedId = String.fromCharCode.apply(String, currentPrivateId);
		      } while (privateNames.has(reifiedId));
		      return privateName(identifier$j(reifiedId));
		    };
		  }
		  function createLazyPrivateUidGeneratorForClass(classPath) {
		    var generator;
		    return function () {
		      if (!generator) {
		        generator = createPrivateUidGeneratorForClass(classPath);
		      }
		      return generator();
		    };
		  }
		  function replaceClassWithVar(path, className) {
		    var id = path.node.id;
		    var scope = path.scope;
		    if (path.type === "ClassDeclaration") {
		      var _className = id.name;
		      var varId = scope.generateUidIdentifierBasedOnNode(id);
		      var classId = identifier$j(_className);
		      scope.rename(_className, varId.name);
		      path.get("id").replaceWith(classId);
		      return {
		        id: cloneNode$j(varId),
		        path: path
		      };
		    } else {
		      var _varId;
		      if (id) {
		        className = id.name;
		        _varId = generateLetUidIdentifier(scope.parent, className);
		        scope.rename(className, _varId.name);
		      } else {
		        _varId = generateLetUidIdentifier(scope.parent, typeof className === "string" ? className : "decorated_class");
		      }
		      var newClassExpr = classExpression(typeof className === "string" ? identifier$j(className) : null, path.node.superClass, path.node.body);
		      var _path$replaceWith = path.replaceWith(sequenceExpression$8([newClassExpr, _varId])),
		        _path$replaceWith2 = _slicedToArray(_path$replaceWith, 1),
		        newPath = _path$replaceWith2[0];
		      return {
		        id: cloneNode$j(_varId),
		        path: newPath.get("expressions.0")
		      };
		    }
		  }
		  function generateClassProperty(key, value, isStatic) {
		    if (key.type === "PrivateName") {
		      return classPrivateProperty(key, value, undefined, isStatic);
		    } else {
		      return classProperty(key, value, undefined, undefined, isStatic);
		    }
		  }
		  function addProxyAccessorsFor(className, element, getterKey, setterKey, targetKey, isComputed, isStatic, version) {
		    var thisArg = (version === "2023-11" || version === "2023-05") && isStatic ? className : thisExpression$4();
		    var getterBody = blockStatement$6([returnStatement$3(memberExpression$c(cloneNode$j(thisArg), cloneNode$j(targetKey)))]);
		    var setterBody = blockStatement$6([expressionStatement$a(assignmentExpression$d("=", memberExpression$c(cloneNode$j(thisArg), cloneNode$j(targetKey)), identifier$j("v")))]);
		    var getter, setter;
		    if (getterKey.type === "PrivateName") {
		      getter = classPrivateMethod("get", getterKey, [], getterBody, isStatic);
		      setter = classPrivateMethod("set", setterKey, [identifier$j("v")], setterBody, isStatic);
		    } else {
		      getter = classMethod("get", getterKey, [], getterBody, isComputed, isStatic);
		      setter = classMethod("set", setterKey, [identifier$j("v")], setterBody, isComputed, isStatic);
		    }
		    element.insertAfter(setter);
		    element.insertAfter(getter);
		  }
		  function extractProxyAccessorsFor(targetKey, version) {
		    if (version !== "2023-11" && version !== "2023-05" && version !== "2023-01") {
		      return [template$1.expression.ast(_templateObject$t || (_templateObject$t = _taggedTemplateLiteralLoose(["\n        function () {\n          return this.", ";\n        }\n      "])), cloneNode$j(targetKey)), template$1.expression.ast(_templateObject2$f || (_templateObject2$f = _taggedTemplateLiteralLoose(["\n        function (value) {\n          this.", " = value;\n        }\n      "])), cloneNode$j(targetKey))];
		    }
		    return [template$1.expression.ast(_templateObject3$a || (_templateObject3$a = _taggedTemplateLiteralLoose(["\n      o => o.", "\n    "])), cloneNode$j(targetKey)), template$1.expression.ast(_templateObject4$6 || (_templateObject4$6 = _taggedTemplateLiteralLoose(["\n      (o, v) => o.", " = v\n    "])), cloneNode$j(targetKey))];
		  }
		  function getComputedKeyLastElement(path) {
		    path = skipTransparentExprWrappers(path);
		    if (path.isSequenceExpression()) {
		      var expressions = path.get("expressions");
		      return getComputedKeyLastElement(expressions[expressions.length - 1]);
		    }
		    return path;
		  }
		  function getComputedKeyMemoiser(path) {
		    var element = getComputedKeyLastElement(path);
		    if (element.isConstantExpression()) {
		      return cloneNode$j(path.node);
		    } else if (element.isIdentifier() && path.scope.hasUid(element.node.name)) {
		      return cloneNode$j(path.node);
		    } else if (element.isAssignmentExpression() && element.get("left").isIdentifier()) {
		      return cloneNode$j(element.node.left);
		    } else {
		      throw new Error("Internal Error: the computed key " + path.toString() + " has not yet been memoised.");
		    }
		  }
		  function prependExpressionsToComputedKey(expressions, fieldPath) {
		    var key = fieldPath.get("key");
		    if (key.isSequenceExpression()) {
		      expressions.push.apply(expressions, _toConsumableArray(key.node.expressions));
		    } else {
		      expressions.push(key.node);
		    }
		    key.replaceWith(maybeSequenceExpression(expressions));
		  }
		  function appendExpressionsToComputedKey(expressions, fieldPath) {
		    var key = fieldPath.get("key");
		    var completion = getComputedKeyLastElement(key);
		    if (completion.isConstantExpression()) {
		      prependExpressionsToComputedKey(expressions, fieldPath);
		    } else {
		      var scopeParent = key.scope.parent;
		      var maybeAssignment = memoiseComputedKey(completion.node, scopeParent, scopeParent.generateUid("computedKey"));
		      if (!maybeAssignment) {
		        prependExpressionsToComputedKey(expressions, fieldPath);
		      } else {
		        var expressionSequence = [].concat(_toConsumableArray(expressions), [cloneNode$j(maybeAssignment.left)]);
		        var completionParent = completion.parentPath;
		        if (completionParent.isSequenceExpression()) {
		          completionParent.pushContainer("expressions", expressionSequence);
		        } else {
		          completion.replaceWith(maybeSequenceExpression([cloneNode$j(maybeAssignment)].concat(_toConsumableArray(expressionSequence))));
		        }
		      }
		    }
		  }
		  function prependExpressionsToFieldInitializer(expressions, fieldPath) {
		    var initializer = fieldPath.get("value");
		    if (initializer.node) {
		      expressions.push(initializer.node);
		    } else if (expressions.length > 0) {
		      expressions[expressions.length - 1] = unaryExpression$6("void", expressions[expressions.length - 1]);
		    }
		    initializer.replaceWith(maybeSequenceExpression(expressions));
		  }
		  function prependExpressionsToStaticBlock(expressions, blockPath) {
		    blockPath.unshiftContainer("body", expressionStatement$a(maybeSequenceExpression(expressions)));
		  }
		  function prependExpressionsToConstructor(expressions, constructorPath) {
		    constructorPath.node.body.body.unshift(expressionStatement$a(maybeSequenceExpression(expressions)));
		  }
		  function isProtoInitCallExpression(expression, protoInitCall) {
		    return isCallExpression$8(expression) && isIdentifier$i(expression.callee, {
		      name: protoInitCall.name
		    });
		  }
		  function optimizeSuperCallAndExpressions(expressions, protoInitLocal) {
		    if (protoInitLocal) {
		      if (expressions.length >= 2 && isProtoInitCallExpression(expressions[1], protoInitLocal)) {
		        var mergedSuperCall = callExpression$d(cloneNode$j(protoInitLocal), [expressions[0]]);
		        expressions.splice(0, 2, mergedSuperCall);
		      }
		      if (expressions.length >= 2 && isThisExpression$2(expressions[expressions.length - 1]) && isProtoInitCallExpression(expressions[expressions.length - 2], protoInitLocal)) {
		        expressions.splice(expressions.length - 1, 1);
		      }
		    }
		    return maybeSequenceExpression(expressions);
		  }
		  function insertExpressionsAfterSuperCallAndOptimize(expressions, constructorPath, protoInitLocal) {
		    constructorPath.traverse({
		      CallExpression: {
		        exit: function exit(path) {
		          if (!path.get("callee").isSuper()) return;
		          var newNodes = [path.node].concat(_toConsumableArray(expressions.map(function (expr) {
		            return cloneNode$j(expr);
		          })));
		          if (path.isCompletionRecord()) {
		            newNodes.push(thisExpression$4());
		          }
		          path.replaceWith(optimizeSuperCallAndExpressions(newNodes, protoInitLocal));
		          path.skip();
		        }
		      },
		      ClassMethod: function ClassMethod(path) {
		        if (path.node.kind === "constructor") {
		          path.skip();
		        }
		      }
		    });
		  }
		  function createConstructorFromExpressions(expressions, isDerivedClass) {
		    var body = [expressionStatement$a(maybeSequenceExpression(expressions))];
		    if (isDerivedClass) {
		      body.unshift(expressionStatement$a(callExpression$d(_super$1(), [spreadElement$2(identifier$j("args"))])));
		    }
		    return classMethod("constructor", identifier$j("constructor"), isDerivedClass ? [restElement$2(identifier$j("args"))] : [], blockStatement$6(body));
		  }
		  function createStaticBlockFromExpressions(expressions) {
		    return staticBlock([expressionStatement$a(maybeSequenceExpression(expressions))]);
		  }
		  var FIELD = 0;
		  var ACCESSOR = 1;
		  var METHOD = 2;
		  var GETTER = 3;
		  var SETTER = 4;
		  var STATIC_OLD_VERSION = 5;
		  var STATIC = 8;
		  var DECORATORS_HAVE_THIS = 16;
		  function getElementKind(element) {
		    switch (element.node.type) {
		      case "ClassProperty":
		      case "ClassPrivateProperty":
		        return FIELD;
		      case "ClassAccessorProperty":
		        return ACCESSOR;
		      case "ClassMethod":
		      case "ClassPrivateMethod":
		        if (element.node.kind === "get") {
		          return GETTER;
		        } else if (element.node.kind === "set") {
		          return SETTER;
		        } else {
		          return METHOD;
		        }
		    }
		  }
		  function toSortedDecoratorInfo(info) {
		    return [].concat(_toConsumableArray(info.filter(function (el) {
		      return el.isStatic && el.kind >= ACCESSOR && el.kind <= SETTER;
		    })), _toConsumableArray(info.filter(function (el) {
		      return !el.isStatic && el.kind >= ACCESSOR && el.kind <= SETTER;
		    })), _toConsumableArray(info.filter(function (el) {
		      return el.isStatic && el.kind === FIELD;
		    })), _toConsumableArray(info.filter(function (el) {
		      return !el.isStatic && el.kind === FIELD;
		    })));
		  }
		  function generateDecorationList(decorators, decoratorsThis, version) {
		    var decsCount = decorators.length;
		    var haveOneThis = decoratorsThis.some(Boolean);
		    var decs = [];
		    for (var i = 0; i < decsCount; i++) {
		      if ((version === "2023-11" || version === "2023-05") && haveOneThis) {
		        decs.push(decoratorsThis[i] || unaryExpression$6("void", numericLiteral$8(0)));
		      }
		      decs.push(decorators[i]);
		    }
		    return {
		      haveThis: haveOneThis,
		      decs: decs
		    };
		  }
		  function generateDecorationExprs(decorationInfo, version) {
		    return arrayExpression$1(decorationInfo.map(function (el) {
		      var flag = el.kind;
		      if (el.isStatic) {
		        flag += version === "2023-11" || version === "2023-05" ? STATIC : STATIC_OLD_VERSION;
		      }
		      if (el.decoratorsHaveThis) flag += DECORATORS_HAVE_THIS;
		      return arrayExpression$1([el.decoratorsArray, numericLiteral$8(flag), el.name].concat(_toConsumableArray(el.privateMethods || [])));
		    }));
		  }
		  function extractElementLocalAssignments(decorationInfo) {
		    var localIds = [];
		    for (var _iterator = _createForOfIteratorHelperLoose(decorationInfo), _step; !(_step = _iterator()).done;) {
		      var el = _step.value;
		      var locals = el.locals;
		      if (Array.isArray(locals)) {
		        localIds.push.apply(localIds, _toConsumableArray(locals));
		      } else if (locals !== undefined) {
		        localIds.push(locals);
		      }
		    }
		    return localIds;
		  }
		  function addCallAccessorsFor(version, element, key, getId, setId, isStatic) {
		    element.insertAfter(classPrivateMethod("get", cloneNode$j(key), [], blockStatement$6([returnStatement$3(callExpression$d(cloneNode$j(getId), version === "2023-11" && isStatic ? [] : [thisExpression$4()]))]), isStatic));
		    element.insertAfter(classPrivateMethod("set", cloneNode$j(key), [identifier$j("v")], blockStatement$6([expressionStatement$a(callExpression$d(cloneNode$j(setId), version === "2023-11" && isStatic ? [identifier$j("v")] : [thisExpression$4(), identifier$j("v")]))]), isStatic));
		  }
		  function movePrivateAccessor(element, key, methodLocalVar, isStatic) {
		    var params;
		    var block;
		    if (element.node.kind === "set") {
		      params = [identifier$j("v")];
		      block = [expressionStatement$a(callExpression$d(methodLocalVar, [thisExpression$4(), identifier$j("v")]))];
		    } else {
		      params = [];
		      block = [returnStatement$3(callExpression$d(methodLocalVar, [thisExpression$4()]))];
		    }
		    element.replaceWith(classPrivateMethod(element.node.kind, cloneNode$j(key), params, blockStatement$6(block), isStatic));
		  }
		  function isClassDecoratableElementPath(path) {
		    var type = path.type;
		    return type !== "TSDeclareMethod" && type !== "TSIndexSignature" && type !== "StaticBlock";
		  }
		  function staticBlockToIIFE(block) {
		    return callExpression$d(arrowFunctionExpression$4([], blockStatement$6(block.body)), []);
		  }
		  function staticBlockToFunctionClosure(block) {
		    return functionExpression$2(null, [], blockStatement$6(block.body));
		  }
		  function fieldInitializerToClosure(value) {
		    return functionExpression$2(null, [], blockStatement$6([returnStatement$3(value)]));
		  }
		  function maybeSequenceExpression(exprs) {
		    if (exprs.length === 0) return unaryExpression$6("void", numericLiteral$8(0));
		    if (exprs.length === 1) return exprs[0];
		    return sequenceExpression$8(exprs);
		  }
		  function createFunctionExpressionFromPrivateMethod(node) {
		    var params = node.params,
		      body = node.body,
		      isGenerator = node.generator,
		      isAsync = node.async;
		    return functionExpression$2(undefined, params, body, isGenerator, isAsync);
		  }
		  function createSetFunctionNameCall(state, className) {
		    return callExpression$d(state.addHelper("setFunctionName"), [thisExpression$4(), className]);
		  }
		  function createToPropertyKeyCall(state, propertyKey) {
		    return callExpression$d(state.addHelper("toPropertyKey"), [propertyKey]);
		  }
		  function createPrivateBrandCheckClosure(brandName) {
		    return arrowFunctionExpression$4([identifier$j("_")], binaryExpression$5("in", cloneNode$j(brandName), identifier$j("_")));
		  }
		  function usesPrivateField(expression) {
		    try {
		      traverseFast$2(expression, function (node) {
		        if (isPrivateName$3(node)) {
		          throw null;
		        }
		      });
		      return false;
		    } catch (_unused) {
		      return true;
		    }
		  }
		  function convertToComputedKey(path) {
		    var node = path.node;
		    node.computed = true;
		    if (isIdentifier$i(node.key)) {
		      node.key = stringLiteral$8(node.key.name);
		    }
		  }
		  function hasInstancePrivateAccess(path, privateNames) {
		    var containsInstancePrivateAccess = false;
		    if (privateNames.length > 0) {
		      var privateNameVisitor = privateNameVisitorFactory({
		        PrivateName: function PrivateName(path, state) {
		          if (state.privateNamesMap.has(path.node.id.name)) {
		            containsInstancePrivateAccess = true;
		            path.stop();
		          }
		        }
		      });
		      var privateNamesMap = new Map();
		      for (var _iterator2 = _createForOfIteratorHelperLoose(privateNames), _step2; !(_step2 = _iterator2()).done;) {
		        var _name = _step2.value;
		        privateNamesMap.set(_name, null);
		      }
		      path.traverse(privateNameVisitor, {
		        privateNamesMap: privateNamesMap
		      });
		    }
		    return containsInstancePrivateAccess;
		  }
		  function checkPrivateMethodUpdateError(path, decoratedPrivateMethods) {
		    var privateNameVisitor = privateNameVisitorFactory({
		      PrivateName: function PrivateName(path, state) {
		        if (!state.privateNamesMap.has(path.node.id.name)) return;
		        var parentPath = path.parentPath;
		        var parentParentPath = parentPath.parentPath;
		        if (parentParentPath.node.type === "AssignmentExpression" && parentParentPath.node.left === parentPath.node || parentParentPath.node.type === "UpdateExpression" || parentParentPath.node.type === "RestElement" || parentParentPath.node.type === "ArrayPattern" || parentParentPath.node.type === "ObjectProperty" && parentParentPath.node.value === parentPath.node && parentParentPath.parentPath.type === "ObjectPattern" || parentParentPath.node.type === "ForOfStatement" && parentParentPath.node.left === parentPath.node) {
		          throw path.buildCodeFrameError("Decorated private methods are read-only, but \"#" + path.node.id.name + "\" is updated via this expression.");
		        }
		      }
		    });
		    var privateNamesMap = new Map();
		    for (var _iterator3 = _createForOfIteratorHelperLoose(decoratedPrivateMethods), _step3; !(_step3 = _iterator3()).done;) {
		      var _name2 = _step3.value;
		      privateNamesMap.set(_name2, null);
		    }
		    path.traverse(privateNameVisitor, {
		      privateNamesMap: privateNamesMap
		    });
		  }
		  function transformClass$1(path, state, constantSuper, ignoreFunctionLength, className, propertyVisitor, version) {
		    var _path$node$id, _classDecorationsId;
		    var body = path.get("body.body");
		    var classDecorators = path.node.decorators;
		    var hasElementDecorators = false;
		    var hasComputedKeysSideEffects = false;
		    var elemDecsUseFnContext = false;
		    var generateClassPrivateUid = createLazyPrivateUidGeneratorForClass(path);
		    var classAssignments = [];
		    var scopeParent = path.scope.parent;
		    var memoiseExpression = function memoiseExpression(expression, hint, assignments) {
		      var localEvaluatedId = generateLetUidIdentifier(scopeParent, hint);
		      assignments.push(assignmentExpression$d("=", localEvaluatedId, expression));
		      return cloneNode$j(localEvaluatedId);
		    };
		    var protoInitLocal;
		    var staticInitLocal;
		    var classIdName = (_path$node$id = path.node.id) == null ? void 0 : _path$node$id.name;
		    var usesFunctionContextOrYieldAwait = function usesFunctionContextOrYieldAwait(expression) {
		      try {
		        traverseFast$2(expression, function (node) {
		          if (isThisExpression$2(node) || isSuper$3(node) || isYieldExpression$1(node) || isAwaitExpression(node) || isIdentifier$i(node, {
		            name: "arguments"
		          }) || classIdName && isIdentifier$i(node, {
		            name: classIdName
		          }) || isMetaProperty$1(node) && node.meta.name !== "import") {
		            throw null;
		          }
		        });
		        return false;
		      } catch (_unused2) {
		        return true;
		      }
		    };
		    var instancePrivateNames = [];
		    for (var _iterator4 = _createForOfIteratorHelperLoose(body), _step4; !(_step4 = _iterator4()).done;) {
		      var _element2 = _step4.value;
		      if (!isClassDecoratableElementPath(_element2)) {
		        continue;
		      }
		      var elementNode = _element2.node;
		      if (!elementNode["static"] && isPrivateName$3(elementNode.key)) {
		        instancePrivateNames.push(elementNode.key.id.name);
		      }
		      if (isDecorated(elementNode)) {
		        switch (elementNode.type) {
		          case "ClassProperty":
		            propertyVisitor.ClassProperty(_element2, state);
		            break;
		          case "ClassPrivateProperty":
		            propertyVisitor.ClassPrivateProperty(_element2, state);
		            break;
		          case "ClassAccessorProperty":
		            propertyVisitor.ClassAccessorProperty(_element2, state);
		            if (version === "2023-11") {
		              break;
		            }
		          default:
		            if (elementNode["static"]) {
		              var _staticInitLocal;
		              (_staticInitLocal = staticInitLocal) != null ? _staticInitLocal : staticInitLocal = generateLetUidIdentifier(scopeParent, "initStatic");
		            } else {
		              var _protoInitLocal;
		              (_protoInitLocal = protoInitLocal) != null ? _protoInitLocal : protoInitLocal = generateLetUidIdentifier(scopeParent, "initProto");
		            }
		            break;
		        }
		        hasElementDecorators = true;
		        elemDecsUseFnContext || (elemDecsUseFnContext = elementNode.decorators.some(usesFunctionContextOrYieldAwait));
		      } else if (elementNode.type === "ClassAccessorProperty") {
		        propertyVisitor.ClassAccessorProperty(_element2, state);
		        var _key3 = elementNode.key,
		          _value = elementNode.value,
		          _isStatic = elementNode["static"],
		          computed = elementNode.computed;
		        var _newId = generateClassPrivateUid();
		        var _newField = generateClassProperty(_newId, _value, _isStatic);
		        var keyPath = _element2.get("key");
		        var _element2$replaceWith = _element2.replaceWith(_newField),
		          _element2$replaceWith2 = _slicedToArray(_element2$replaceWith, 1),
		          _newPath2 = _element2$replaceWith2[0];
		        var getterKey = void 0,
		          setterKey = void 0;
		        if (computed && !keyPath.isConstantExpression()) {
		          getterKey = memoiseComputedKey(createToPropertyKeyCall(state, _key3), scopeParent, scopeParent.generateUid("computedKey"));
		          setterKey = cloneNode$j(getterKey.left);
		        } else {
		          getterKey = cloneNode$j(_key3);
		          setterKey = cloneNode$j(_key3);
		        }
		        addProxyAccessorsFor(path.node.id, _newPath2, getterKey, setterKey, _newId, computed, _isStatic, version);
		      }
		      if ("computed" in _element2.node && _element2.node.computed) {
		        hasComputedKeysSideEffects || (hasComputedKeysSideEffects = !scopeParent.isStatic(_element2.node.key));
		      }
		    }
		    if (!classDecorators && !hasElementDecorators) {
		      return;
		    }
		    var elementDecoratorInfo = [];
		    var constructorPath;
		    var decoratedPrivateMethods = new Set();
		    var classInitLocal, classIdLocal;
		    var decoratorReceiverId = null;
		    function handleDecoratorExpressions(expressions) {
		      var hasSideEffects = false;
		      var usesFnContext = false;
		      var decoratorsThis = [];
		      for (var _iterator5 = _createForOfIteratorHelperLoose(expressions), _step5; !(_step5 = _iterator5()).done;) {
		        var expression = _step5.value;
		        var object = void 0;
		        if ((version === "2023-11" || version === "2023-05") && isMemberExpression$9(expression)) {
		          if (isSuper$3(expression.object)) {
		            object = thisExpression$4();
		          } else if (scopeParent.isStatic(expression.object)) {
		            object = cloneNode$j(expression.object);
		          } else {
		            var _decoratorReceiverId;
		            (_decoratorReceiverId = decoratorReceiverId) != null ? _decoratorReceiverId : decoratorReceiverId = generateLetUidIdentifier(scopeParent, "obj");
		            object = assignmentExpression$d("=", cloneNode$j(decoratorReceiverId), expression.object);
		            expression.object = cloneNode$j(decoratorReceiverId);
		          }
		        }
		        decoratorsThis.push(object);
		        hasSideEffects || (hasSideEffects = !scopeParent.isStatic(expression));
		        usesFnContext || (usesFnContext = usesFunctionContextOrYieldAwait(expression));
		      }
		      return {
		        hasSideEffects: hasSideEffects,
		        usesFnContext: usesFnContext,
		        decoratorsThis: decoratorsThis
		      };
		    }
		    var willExtractSomeElemDecs = hasComputedKeysSideEffects || elemDecsUseFnContext || version !== "2023-11";
		    var needsDeclaraionForClassBinding = false;
		    var classDecorationsFlag = 0;
		    var classDecorations = [];
		    var classDecorationsId;
		    var computedKeyAssignments = [];
		    if (classDecorators) {
		      classInitLocal = generateLetUidIdentifier(scopeParent, "initClass");
		      needsDeclaraionForClassBinding = path.isClassDeclaration();
		      var _replaceClassWithVar = replaceClassWithVar(path, className);
		      classIdLocal = _replaceClassWithVar.id;
		      path = _replaceClassWithVar.path;
		      path.node.decorators = null;
		      var decoratorExpressions = classDecorators.map(function (el) {
		        return el.expression;
		      });
		      var classDecsUsePrivateName = decoratorExpressions.some(usesPrivateField);
		      var _handleDecoratorExpre = handleDecoratorExpressions(decoratorExpressions),
		        hasSideEffects = _handleDecoratorExpre.hasSideEffects,
		        decoratorsThis = _handleDecoratorExpre.decoratorsThis;
		      var _generateDecorationLi = generateDecorationList(decoratorExpressions, decoratorsThis, version),
		        haveThis = _generateDecorationLi.haveThis,
		        decs = _generateDecorationLi.decs;
		      classDecorationsFlag = haveThis ? 1 : 0;
		      classDecorations = decs;
		      if (hasSideEffects && willExtractSomeElemDecs || classDecsUsePrivateName) {
		        classDecorationsId = memoiseExpression(arrayExpression$1(classDecorations), "classDecs", classAssignments);
		      }
		      if (!hasElementDecorators) {
		        for (var _iterator6 = _createForOfIteratorHelperLoose(path.get("body.body")), _step6; !(_step6 = _iterator6()).done;) {
		          var element = _step6.value;
		          var node = element.node;
		          var isComputed = "computed" in node && node.computed;
		          if (isComputed) {
		            if (element.isClassProperty({
		              "static": true
		            })) {
		              if (!element.get("key").isConstantExpression()) {
		                var key = node.key;
		                var maybeAssignment = memoiseComputedKey(key, scopeParent, scopeParent.generateUid("computedKey"));
		                if (maybeAssignment != null) {
		                  node.key = cloneNode$j(maybeAssignment.left);
		                  computedKeyAssignments.push(maybeAssignment);
		                }
		              }
		            } else if (computedKeyAssignments.length > 0) {
		              prependExpressionsToComputedKey(computedKeyAssignments, element);
		              computedKeyAssignments = [];
		            }
		          }
		        }
		      }
		    } else {
		      if (!path.node.id) {
		        path.node.id = path.scope.generateUidIdentifier("Class");
		      }
		      classIdLocal = cloneNode$j(path.node.id);
		    }
		    var lastInstancePrivateName;
		    var needsInstancePrivateBrandCheck = false;
		    var fieldInitializerExpressions = [];
		    var staticFieldInitializerExpressions = [];
		    if (hasElementDecorators) {
		      if (protoInitLocal) {
		        var protoInitCall = callExpression$d(cloneNode$j(protoInitLocal), [thisExpression$4()]);
		        fieldInitializerExpressions.push(protoInitCall);
		      }
		      for (var _iterator7 = _createForOfIteratorHelperLoose(body), _step7; !(_step7 = _iterator7()).done;) {
		        var _element = _step7.value;
		        if (!isClassDecoratableElementPath(_element)) {
		          if (staticFieldInitializerExpressions.length > 0 && _element.isStaticBlock()) {
		            prependExpressionsToStaticBlock(staticFieldInitializerExpressions, _element);
		            staticFieldInitializerExpressions = [];
		          }
		          continue;
		        }
		        var _node = _element.node;
		        var decorators = _node.decorators;
		        var hasDecorators = !!(decorators != null && decorators.length);
		        var _isComputed = "computed" in _node && _node.computed;
		        var _name3 = "computedKey";
		        if (_node.key.type === "PrivateName") {
		          _name3 = _node.key.id.name;
		        } else if (!_isComputed && _node.key.type === "Identifier") {
		          _name3 = _node.key.name;
		        }
		        var decoratorsArray = void 0;
		        var decoratorsHaveThis = void 0;
		        if (hasDecorators) {
		          var _decoratorExpressions = decorators.map(function (d) {
		            return d.expression;
		          });
		          var _handleDecoratorExpre2 = handleDecoratorExpressions(_decoratorExpressions),
		            _hasSideEffects = _handleDecoratorExpre2.hasSideEffects,
		            usesFnContext = _handleDecoratorExpre2.usesFnContext,
		            _decoratorsThis = _handleDecoratorExpre2.decoratorsThis;
		          var _generateDecorationLi2 = generateDecorationList(_decoratorExpressions, _decoratorsThis, version),
		            _decs = _generateDecorationLi2.decs,
		            _haveThis = _generateDecorationLi2.haveThis;
		          decoratorsHaveThis = _haveThis;
		          decoratorsArray = _decs.length === 1 ? _decs[0] : arrayExpression$1(_decs);
		          if (usesFnContext || _hasSideEffects && willExtractSomeElemDecs) {
		            decoratorsArray = memoiseExpression(decoratorsArray, _name3 + "Decs", computedKeyAssignments);
		          }
		        }
		        if (_isComputed) {
		          if (!_element.get("key").isConstantExpression()) {
		            var _key = _node.key;
		            var _maybeAssignment = memoiseComputedKey(hasDecorators ? createToPropertyKeyCall(state, _key) : _key, scopeParent, scopeParent.generateUid("computedKey"));
		            if (_maybeAssignment != null) {
		              if (classDecorators && _element.isClassProperty({
		                "static": true
		              })) {
		                _node.key = cloneNode$j(_maybeAssignment.left);
		                computedKeyAssignments.push(_maybeAssignment);
		              } else {
		                _node.key = _maybeAssignment;
		              }
		            }
		          }
		        }
		        var _key2 = _node.key,
		          isStatic = _node["static"];
		        var isPrivate = _key2.type === "PrivateName";
		        var kind = getElementKind(_element);
		        if (isPrivate && !isStatic) {
		          if (hasDecorators) {
		            needsInstancePrivateBrandCheck = true;
		          }
		          if (isClassPrivateProperty(_node) || !lastInstancePrivateName) {
		            lastInstancePrivateName = _key2;
		          }
		        }
		        if (_element.isClassMethod({
		          kind: "constructor"
		        })) {
		          constructorPath = _element;
		        }
		        var locals = void 0;
		        if (hasDecorators) {
		          var privateMethods = void 0;
		          var nameExpr = void 0;
		          if (_isComputed) {
		            nameExpr = getComputedKeyMemoiser(_element.get("key"));
		          } else if (_key2.type === "PrivateName") {
		            nameExpr = stringLiteral$8(_key2.id.name);
		          } else if (_key2.type === "Identifier") {
		            nameExpr = stringLiteral$8(_key2.name);
		          } else {
		            nameExpr = cloneNode$j(_key2);
		          }
		          if (kind === ACCESSOR) {
		            var _ref = _element.node,
		              value = _ref.value;
		            var params = version === "2023-11" && isStatic ? [] : [thisExpression$4()];
		            if (value) {
		              params.push(cloneNode$j(value));
		            }
		            var newId = generateClassPrivateUid();
		            var newFieldInitId = generateLetUidIdentifier(scopeParent, "init_" + _name3);
		            var newValue = callExpression$d(cloneNode$j(newFieldInitId), params);
		            var newField = generateClassProperty(newId, newValue, isStatic);
		            var _element$replaceWith = _element.replaceWith(newField),
		              _element$replaceWith2 = _slicedToArray(_element$replaceWith, 1),
		              newPath = _element$replaceWith2[0];
		            if (isPrivate) {
		              privateMethods = extractProxyAccessorsFor(newId, version);
		              var getId = generateLetUidIdentifier(scopeParent, "get_" + _name3);
		              var setId = generateLetUidIdentifier(scopeParent, "set_" + _name3);
		              addCallAccessorsFor(version, newPath, _key2, getId, setId, isStatic);
		              locals = [newFieldInitId, getId, setId];
		            } else {
		              addProxyAccessorsFor(path.node.id, newPath, cloneNode$j(_key2), isAssignmentExpression$3(_key2) ? cloneNode$j(_key2.left) : cloneNode$j(_key2), newId, _isComputed, isStatic, version);
		              locals = [newFieldInitId];
		            }
		          } else if (kind === FIELD) {
		            var initId = generateLetUidIdentifier(scopeParent, "init_" + _name3);
		            var valuePath = _element.get("value");
		            var args = version === "2023-11" && isStatic ? [] : [thisExpression$4()];
		            if (valuePath.node) args.push(valuePath.node);
		            valuePath.replaceWith(callExpression$d(cloneNode$j(initId), args));
		            locals = [initId];
		            if (isPrivate) {
		              privateMethods = extractProxyAccessorsFor(_key2, version);
		            }
		          } else if (isPrivate) {
		            var callId = generateLetUidIdentifier(scopeParent, "call_" + _name3);
		            locals = [callId];
		            var replaceSupers = new ReplaceSupers({
		              constantSuper: constantSuper,
		              methodPath: _element,
		              objectRef: classIdLocal,
		              superRef: path.node.superClass,
		              file: state.file,
		              refToPreserve: classIdLocal
		            });
		            replaceSupers.replace();
		            privateMethods = [createFunctionExpressionFromPrivateMethod(_element.node)];
		            if (kind === GETTER || kind === SETTER) {
		              movePrivateAccessor(_element, cloneNode$j(_key2), cloneNode$j(callId), isStatic);
		            } else {
		              var _node2 = _element.node;
		              path.node.body.body.unshift(classPrivateProperty(_key2, cloneNode$j(callId), [], _node2["static"]));
		              decoratedPrivateMethods.add(_key2.id.name);
		              _element.remove();
		            }
		          }
		          elementDecoratorInfo.push({
		            kind: kind,
		            decoratorsArray: decoratorsArray,
		            decoratorsHaveThis: decoratorsHaveThis,
		            name: nameExpr,
		            isStatic: isStatic,
		            privateMethods: privateMethods,
		            locals: locals
		          });
		          if (_element.node) {
		            _element.node.decorators = null;
		          }
		        }
		        if (_isComputed && computedKeyAssignments.length > 0) {
		          if (classDecorators && _element.isClassProperty({
		            "static": true
		          })) ; else {
		            prependExpressionsToComputedKey(computedKeyAssignments, kind === ACCESSOR ? _element.getNextSibling() : _element);
		            computedKeyAssignments = [];
		          }
		        }
		        if (fieldInitializerExpressions.length > 0 && !isStatic && (kind === FIELD || kind === ACCESSOR)) {
		          prependExpressionsToFieldInitializer(fieldInitializerExpressions, _element);
		          fieldInitializerExpressions = [];
		        }
		        if (staticFieldInitializerExpressions.length > 0 && isStatic && (kind === FIELD || kind === ACCESSOR)) {
		          prependExpressionsToFieldInitializer(staticFieldInitializerExpressions, _element);
		          staticFieldInitializerExpressions = [];
		        }
		        if (hasDecorators && version === "2023-11") {
		          if (kind === FIELD || kind === ACCESSOR) {
		            var initExtraId = generateLetUidIdentifier(scopeParent, "init_extra_" + _name3);
		            locals.push(initExtraId);
		            var initExtraCall = callExpression$d(cloneNode$j(initExtraId), isStatic ? [] : [thisExpression$4()]);
		            if (!isStatic) {
		              fieldInitializerExpressions.push(initExtraCall);
		            } else {
		              staticFieldInitializerExpressions.push(initExtraCall);
		            }
		          }
		        }
		      }
		    }
		    if (computedKeyAssignments.length > 0) {
		      var elements = path.get("body.body");
		      var lastComputedElement;
		      for (var i = elements.length - 1; i >= 0; i--) {
		        var _path = elements[i];
		        var _node3 = _path.node;
		        if (_node3.computed) {
		          if (classDecorators && isClassProperty(_node3, {
		            "static": true
		          })) {
		            continue;
		          }
		          lastComputedElement = _path;
		          break;
		        }
		      }
		      if (lastComputedElement != null) {
		        appendExpressionsToComputedKey(computedKeyAssignments, lastComputedElement);
		        computedKeyAssignments = [];
		      }
		    }
		    if (fieldInitializerExpressions.length > 0) {
		      var isDerivedClass = !!path.node.superClass;
		      if (constructorPath) {
		        if (isDerivedClass) {
		          insertExpressionsAfterSuperCallAndOptimize(fieldInitializerExpressions, constructorPath, protoInitLocal);
		        } else {
		          prependExpressionsToConstructor(fieldInitializerExpressions, constructorPath);
		        }
		      } else {
		        path.node.body.body.unshift(createConstructorFromExpressions(fieldInitializerExpressions, isDerivedClass));
		      }
		      fieldInitializerExpressions = [];
		    }
		    if (staticFieldInitializerExpressions.length > 0) {
		      path.node.body.body.push(createStaticBlockFromExpressions(staticFieldInitializerExpressions));
		      staticFieldInitializerExpressions = [];
		    }
		    var sortedElementDecoratorInfo = toSortedDecoratorInfo(elementDecoratorInfo);
		    var elementDecorations = generateDecorationExprs(version === "2023-11" ? elementDecoratorInfo : sortedElementDecoratorInfo, version);
		    var elementLocals = extractElementLocalAssignments(sortedElementDecoratorInfo);
		    if (protoInitLocal) {
		      elementLocals.push(protoInitLocal);
		    }
		    if (staticInitLocal) {
		      elementLocals.push(staticInitLocal);
		    }
		    var classLocals = [];
		    var classInitInjected = false;
		    var classInitCall = classInitLocal && callExpression$d(cloneNode$j(classInitLocal), []);
		    var originalClassPath = path;
		    var originalClass = path.node;
		    var staticClosures = [];
		    if (classDecorators) {
		      classLocals.push(classIdLocal, classInitLocal);
		      var statics = [];
		      path.get("body.body").forEach(function (element) {
		        if (element.isStaticBlock()) {
		          if (hasInstancePrivateAccess(element, instancePrivateNames)) {
		            var staticBlockClosureId = memoiseExpression(staticBlockToFunctionClosure(element.node), "staticBlock", staticClosures);
		            staticFieldInitializerExpressions.push(callExpression$d(memberExpression$c(staticBlockClosureId, identifier$j("call")), [thisExpression$4()]));
		          } else {
		            staticFieldInitializerExpressions.push(staticBlockToIIFE(element.node));
		          }
		          element.remove();
		          return;
		        }
		        if ((element.isClassProperty() || element.isClassPrivateProperty()) && element.node["static"]) {
		          var _valuePath = element.get("value");
		          if (hasInstancePrivateAccess(_valuePath, instancePrivateNames)) {
		            var fieldValueClosureId = memoiseExpression(fieldInitializerToClosure(_valuePath.node), "fieldValue", staticClosures);
		            _valuePath.replaceWith(callExpression$d(memberExpression$c(fieldValueClosureId, identifier$j("call")), [thisExpression$4()]));
		          }
		          if (staticFieldInitializerExpressions.length > 0) {
		            prependExpressionsToFieldInitializer(staticFieldInitializerExpressions, element);
		            staticFieldInitializerExpressions = [];
		          }
		          element.node["static"] = false;
		          statics.push(element.node);
		          element.remove();
		        } else if (element.isClassPrivateMethod({
		          "static": true
		        })) {
		          if (hasInstancePrivateAccess(element, instancePrivateNames)) {
		            var _replaceSupers = new ReplaceSupers({
		              constantSuper: constantSuper,
		              methodPath: element,
		              objectRef: classIdLocal,
		              superRef: path.node.superClass,
		              file: state.file,
		              refToPreserve: classIdLocal
		            });
		            _replaceSupers.replace();
		            var privateMethodDelegateId = memoiseExpression(createFunctionExpressionFromPrivateMethod(element.node), element.get("key.id").node.name, staticClosures);
		            if (ignoreFunctionLength) {
		              element.node.params = [restElement$2(identifier$j("arg"))];
		              element.node.body = blockStatement$6([returnStatement$3(callExpression$d(memberExpression$c(privateMethodDelegateId, identifier$j("apply")), [thisExpression$4(), identifier$j("arg")]))]);
		            } else {
		              element.node.params = element.node.params.map(function (p, i) {
		                if (isRestElement$2(p)) {
		                  return restElement$2(identifier$j("arg"));
		                } else {
		                  return identifier$j("_" + i);
		                }
		              });
		              element.node.body = blockStatement$6([returnStatement$3(callExpression$d(memberExpression$c(privateMethodDelegateId, identifier$j("apply")), [thisExpression$4(), identifier$j("arguments")]))]);
		            }
		          }
		          element.node["static"] = false;
		          statics.push(element.node);
		          element.remove();
		        }
		      });
		      if (statics.length > 0 || staticFieldInitializerExpressions.length > 0) {
		        var staticsClass = template$1.expression.ast(_templateObject5$3 || (_templateObject5$3 = _taggedTemplateLiteralLoose(["\n        class extends ", " {}\n      "])), state.addHelper("identity"));
		        staticsClass.body.body = [classProperty(toExpression$1(originalClass), undefined, undefined, undefined, true, true)].concat(statics);
		        var constructorBody = [];
		        var newExpr = newExpression(staticsClass, []);
		        if (staticFieldInitializerExpressions.length > 0) {
		          constructorBody.push.apply(constructorBody, _toConsumableArray(staticFieldInitializerExpressions));
		        }
		        if (classInitCall) {
		          classInitInjected = true;
		          constructorBody.push(classInitCall);
		        }
		        if (constructorBody.length > 0) {
		          constructorBody.unshift(callExpression$d(_super$1(), [cloneNode$j(classIdLocal)]));
		          staticsClass.body.body.push(createConstructorFromExpressions(constructorBody, false));
		        } else {
		          newExpr.arguments.push(cloneNode$j(classIdLocal));
		        }
		        var _path$replaceWith3 = path.replaceWith(newExpr),
		          _path$replaceWith4 = _slicedToArray(_path$replaceWith3, 1),
		          _newPath = _path$replaceWith4[0];
		        originalClassPath = _newPath.get("callee").get("body").get("body.0.key");
		      }
		    }
		    if (!classInitInjected && classInitCall) {
		      path.node.body.body.push(staticBlock([expressionStatement$a(classInitCall)]));
		    }
		    var superClass = originalClass.superClass;
		    if (superClass && (version === "2023-11" || version === "2023-05")) {
		      var id = path.scope.maybeGenerateMemoised(superClass);
		      if (id) {
		        originalClass.superClass = assignmentExpression$d("=", id, superClass);
		        superClass = id;
		      }
		    }
		    var applyDecoratorWrapper = staticBlock([]);
		    originalClass.body.body.unshift(applyDecoratorWrapper);
		    var applyDecsBody = applyDecoratorWrapper.body;
		    if (computedKeyAssignments.length > 0) {
		      var _elements = originalClassPath.get("body.body");
		      var firstPublicElement;
		      for (var _iterator8 = _createForOfIteratorHelperLoose(_elements), _step8; !(_step8 = _iterator8()).done;) {
		        var _path2 = _step8.value;
		        if ((_path2.isClassProperty() || _path2.isClassMethod()) && _path2.node.kind !== "constructor") {
		          firstPublicElement = _path2;
		          break;
		        }
		      }
		      if (firstPublicElement != null) {
		        convertToComputedKey(firstPublicElement);
		        prependExpressionsToComputedKey(computedKeyAssignments, firstPublicElement);
		      } else {
		        originalClass.body.body.unshift(classProperty(sequenceExpression$8([].concat(_toConsumableArray(computedKeyAssignments), [stringLiteral$8("_")])), undefined, undefined, undefined, true, true));
		        applyDecsBody.push(expressionStatement$a(unaryExpression$6("delete", memberExpression$c(thisExpression$4(), identifier$j("_")))));
		      }
		      computedKeyAssignments = [];
		    }
		    applyDecsBody.push(expressionStatement$a(createLocalsAssignment(elementLocals, classLocals, elementDecorations, (_classDecorationsId = classDecorationsId) != null ? _classDecorationsId : arrayExpression$1(classDecorations), numericLiteral$8(classDecorationsFlag), needsInstancePrivateBrandCheck ? lastInstancePrivateName : null, typeof className === "object" ? className : undefined, cloneNode$j(superClass), state, version)));
		    if (staticInitLocal) {
		      applyDecsBody.push(expressionStatement$a(callExpression$d(cloneNode$j(staticInitLocal), [thisExpression$4()])));
		    }
		    if (staticClosures.length > 0) {
		      applyDecsBody.push.apply(applyDecsBody, _toConsumableArray(staticClosures.map(function (expr) {
		        return expressionStatement$a(expr);
		      })));
		    }
		    path.insertBefore(classAssignments.map(function (expr) {
		      return expressionStatement$a(expr);
		    }));
		    if (needsDeclaraionForClassBinding) {
		      var classBindingInfo = scopeParent.getBinding(classIdLocal.name);
		      if (!classBindingInfo.constantViolations.length) {
		        path.insertBefore(variableDeclaration$8("let", [variableDeclarator$8(cloneNode$j(classIdLocal))]));
		      } else {
		        var classOuterBindingDelegateLocal = scopeParent.generateUidIdentifier("t" + classIdLocal.name);
		        var classOuterBindingLocal = classIdLocal;
		        path.replaceWithMultiple([variableDeclaration$8("let", [variableDeclarator$8(cloneNode$j(classOuterBindingLocal)), variableDeclarator$8(classOuterBindingDelegateLocal)]), blockStatement$6([variableDeclaration$8("let", [variableDeclarator$8(cloneNode$j(classIdLocal))]), path.node, expressionStatement$a(assignmentExpression$d("=", cloneNode$j(classOuterBindingDelegateLocal), cloneNode$j(classIdLocal)))]), expressionStatement$a(assignmentExpression$d("=", cloneNode$j(classOuterBindingLocal), cloneNode$j(classOuterBindingDelegateLocal)))]);
		      }
		    }
		    if (decoratedPrivateMethods.size > 0) {
		      checkPrivateMethodUpdateError(path, decoratedPrivateMethods);
		    }
		    path.scope.crawl();
		    return path;
		  }
		  function createLocalsAssignment(elementLocals, classLocals, elementDecorations, classDecorations, classDecorationsFlag, maybePrivateBrandName, setClassName, superClass, state, version) {
		    var lhs, rhs;
		    var args = [setClassName ? createSetFunctionNameCall(state, setClassName) : thisExpression$4(), classDecorations, elementDecorations];
		    {
		      if (version !== "2023-11") {
		        args.splice(1, 2, elementDecorations, classDecorations);
		      }
		      if (version === "2021-12" || version === "2022-03" && !state.availableHelper("applyDecs2203R")) {
		        lhs = arrayPattern([].concat(_toConsumableArray(elementLocals), _toConsumableArray(classLocals)));
		        rhs = callExpression$d(state.addHelper(version === "2021-12" ? "applyDecs" : "applyDecs2203"), args);
		        return assignmentExpression$d("=", lhs, rhs);
		      } else if (version === "2022-03") {
		        rhs = callExpression$d(state.addHelper("applyDecs2203R"), args);
		      } else if (version === "2023-01") {
		        if (maybePrivateBrandName) {
		          args.push(createPrivateBrandCheckClosure(maybePrivateBrandName));
		        }
		        rhs = callExpression$d(state.addHelper("applyDecs2301"), args);
		      } else if (version === "2023-05") {
		        if (maybePrivateBrandName || superClass || classDecorationsFlag.value !== 0) {
		          args.push(classDecorationsFlag);
		        }
		        if (maybePrivateBrandName) {
		          args.push(createPrivateBrandCheckClosure(maybePrivateBrandName));
		        } else if (superClass) {
		          args.push(unaryExpression$6("void", numericLiteral$8(0)));
		        }
		        if (superClass) args.push(superClass);
		        rhs = callExpression$d(state.addHelper("applyDecs2305"), args);
		      }
		    }
		    if (version === "2023-11") {
		      if (maybePrivateBrandName || superClass || classDecorationsFlag.value !== 0) {
		        args.push(classDecorationsFlag);
		      }
		      if (maybePrivateBrandName) {
		        args.push(createPrivateBrandCheckClosure(maybePrivateBrandName));
		      } else if (superClass) {
		        args.push(unaryExpression$6("void", numericLiteral$8(0)));
		      }
		      if (superClass) args.push(superClass);
		      rhs = callExpression$d(state.addHelper("applyDecs2311"), args);
		    }
		    if (elementLocals.length > 0) {
		      if (classLocals.length > 0) {
		        lhs = objectPattern$1([objectProperty$1(identifier$j("e"), arrayPattern(elementLocals)), objectProperty$1(identifier$j("c"), arrayPattern(classLocals))]);
		      } else {
		        lhs = arrayPattern(elementLocals);
		        rhs = memberExpression$c(rhs, identifier$j("e"), false, false);
		      }
		    } else {
		      lhs = arrayPattern(classLocals);
		      rhs = memberExpression$c(rhs, identifier$j("c"), false, false);
		    }
		    return assignmentExpression$d("=", lhs, rhs);
		  }
		  function isProtoKey(node) {
		    return node.type === "Identifier" ? node.name === "__proto__" : node.value === "__proto__";
		  }
		  function isDecorated(node) {
		    return node.decorators && node.decorators.length > 0;
		  }
		  function shouldTransformElement(node) {
		    switch (node.type) {
		      case "ClassAccessorProperty":
		        return true;
		      case "ClassMethod":
		      case "ClassProperty":
		      case "ClassPrivateMethod":
		      case "ClassPrivateProperty":
		        return isDecorated(node);
		      default:
		        return false;
		    }
		  }
		  function shouldTransformClass(node) {
		    return isDecorated(node) || node.body.body.some(shouldTransformElement);
		  }
		  function NamedEvaluationVisitoryFactory(isAnonymous, visitor) {
		    function handleComputedProperty(propertyPath, key, state) {
		      switch (key.type) {
		        case "StringLiteral":
		          return stringLiteral$8(key.value);
		        case "NumericLiteral":
		        case "BigIntLiteral":
		          {
		            var keyValue = key.value + "";
		            propertyPath.get("key").replaceWith(stringLiteral$8(keyValue));
		            return stringLiteral$8(keyValue);
		          }
		        default:
		          {
		            var ref = propertyPath.scope.maybeGenerateMemoised(key);
		            propertyPath.get("key").replaceWith(assignmentExpression$d("=", ref, createToPropertyKeyCall(state, key)));
		            return cloneNode$j(ref);
		          }
		      }
		    }
		    return {
		      VariableDeclarator: function VariableDeclarator(path, state) {
		        var id = path.node.id;
		        if (id.type === "Identifier") {
		          var initializer = skipTransparentExprWrappers(path.get("init"));
		          if (isAnonymous(initializer)) {
		            var _name4 = id.name;
		            visitor(initializer, state, _name4);
		          }
		        }
		      },
		      AssignmentExpression: function AssignmentExpression(path, state) {
		        var id = path.node.left;
		        if (id.type === "Identifier") {
		          var initializer = skipTransparentExprWrappers(path.get("right"));
		          if (isAnonymous(initializer)) {
		            switch (path.node.operator) {
		              case "=":
		              case "&&=":
		              case "||=":
		              case "??=":
		                visitor(initializer, state, id.name);
		            }
		          }
		        }
		      },
		      AssignmentPattern: function AssignmentPattern(path, state) {
		        var id = path.node.left;
		        if (id.type === "Identifier") {
		          var initializer = skipTransparentExprWrappers(path.get("right"));
		          if (isAnonymous(initializer)) {
		            var _name5 = id.name;
		            visitor(initializer, state, _name5);
		          }
		        }
		      },
		      ObjectExpression: function ObjectExpression(path, state) {
		        for (var _iterator9 = _createForOfIteratorHelperLoose(path.get("properties")), _step9; !(_step9 = _iterator9()).done;) {
		          var propertyPath = _step9.value;
		          if (!propertyPath.isObjectProperty()) continue;
		          var node = propertyPath.node;
		          var id = node.key;
		          var initializer = skipTransparentExprWrappers(propertyPath.get("value"));
		          if (isAnonymous(initializer)) {
		            if (!node.computed) {
		              if (!isProtoKey(id)) {
		                if (id.type === "Identifier") {
		                  visitor(initializer, state, id.name);
		                } else {
		                  var className = stringLiteral$8(id.value + "");
		                  visitor(initializer, state, className);
		                }
		              }
		            } else {
		              var ref = handleComputedProperty(propertyPath, id, state);
		              visitor(initializer, state, ref);
		            }
		          }
		        }
		      },
		      ClassPrivateProperty: function ClassPrivateProperty(path, state) {
		        var node = path.node;
		        var initializer = skipTransparentExprWrappers(path.get("value"));
		        if (isAnonymous(initializer)) {
		          var className = stringLiteral$8("#" + node.key.id.name);
		          visitor(initializer, state, className);
		        }
		      },
		      ClassAccessorProperty: function ClassAccessorProperty(path, state) {
		        var node = path.node;
		        var id = node.key;
		        var initializer = skipTransparentExprWrappers(path.get("value"));
		        if (isAnonymous(initializer)) {
		          if (!node.computed) {
		            if (id.type === "Identifier") {
		              visitor(initializer, state, id.name);
		            } else if (id.type === "PrivateName") {
		              var className = stringLiteral$8("#" + id.id.name);
		              visitor(initializer, state, className);
		            } else {
		              var _className2 = stringLiteral$8(id.value + "");
		              visitor(initializer, state, _className2);
		            }
		          } else {
		            var ref = handleComputedProperty(path, id, state);
		            visitor(initializer, state, ref);
		          }
		        }
		      },
		      ClassProperty: function ClassProperty(path, state) {
		        var node = path.node;
		        var id = node.key;
		        var initializer = skipTransparentExprWrappers(path.get("value"));
		        if (isAnonymous(initializer)) {
		          if (!node.computed) {
		            if (id.type === "Identifier") {
		              visitor(initializer, state, id.name);
		            } else {
		              var className = stringLiteral$8(id.value + "");
		              visitor(initializer, state, className);
		            }
		          } else {
		            var ref = handleComputedProperty(path, id, state);
		            visitor(initializer, state, ref);
		          }
		        }
		      }
		    };
		  }
		  function isDecoratedAnonymousClassExpression(path) {
		    return path.isClassExpression({
		      id: null
		    }) && shouldTransformClass(path.node);
		  }
		  function generateLetUidIdentifier(scope, name) {
		    var id = scope.generateUidIdentifier(name);
		    scope.push({
		      id: id,
		      kind: "let"
		    });
		    return cloneNode$j(id);
		  }
		  function createDecoratorTransform (_ref2, _ref3, version, inherits) {
		    var _assumption, _assumption2;
		    var assertVersion = _ref2.assertVersion,
		      assumption = _ref2.assumption;
		    var loose = _ref3.loose;
		    {
		      if (version === "2023-11" || version === "2023-05" || version === "2023-01") {
		        assertVersion("*");
		      } else if (version === "2021-12") {
		        assertVersion("*");
		      } else {
		        assertVersion("*");
		      }
		    }
		    var VISITED = new WeakSet();
		    var constantSuper = (_assumption = assumption("constantSuper")) != null ? _assumption : loose;
		    var ignoreFunctionLength = (_assumption2 = assumption("ignoreFunctionLength")) != null ? _assumption2 : loose;
		    var namedEvaluationVisitor = NamedEvaluationVisitoryFactory(isDecoratedAnonymousClassExpression, visitClass);
		    function visitClass(path, state, className) {
		      var _className3, _node$id;
		      if (VISITED.has(path)) return;
		      var node = path.node;
		      (_className3 = className) != null ? _className3 : className = (_node$id = node.id) == null ? void 0 : _node$id.name;
		      var newPath = transformClass$1(path, state, constantSuper, ignoreFunctionLength, className, namedEvaluationVisitor, version);
		      if (newPath) {
		        VISITED.add(newPath);
		        return;
		      }
		      VISITED.add(path);
		    }
		    return {
		      name: "proposal-decorators",
		      inherits: inherits,
		      visitor: Object.assign({
		        ExportDefaultDeclaration: function ExportDefaultDeclaration(path, state) {
		          var declaration = path.node.declaration;
		          if ((declaration == null ? void 0 : declaration.type) === "ClassDeclaration" && isDecorated(declaration)) {
		            var isAnonymous = !declaration.id;
		            var updatedVarDeclarationPath = splitExportDeclaration(path);
		            if (isAnonymous) {
		              visitClass(updatedVarDeclarationPath, state, stringLiteral$8("default"));
		            }
		          }
		        },
		        ExportNamedDeclaration: function ExportNamedDeclaration(path) {
		          var declaration = path.node.declaration;
		          if ((declaration == null ? void 0 : declaration.type) === "ClassDeclaration" && isDecorated(declaration)) {
		            splitExportDeclaration(path);
		          }
		        },
		        Class: function Class(path, state) {
		          visitClass(path, state, undefined);
		        }
		      }, namedEvaluationVisitor)
		    };
		  }

		  function bool$4(value) {
		    if (value == null) return false;
		    return value && value !== "false" && value !== "0";
		  }
		  var semver$7 = bool$4(browser$1$1.env["BABEL_8_BREAKING"]) ? requireSemver$2() : requireSemver$2();

		  var _templateObject$s, _templateObject2$e, _templateObject3$9, _templateObject4$5;
		  function hasOwnDecorators(node) {
		    var _node$decorators;
		    return !!((_node$decorators = node.decorators) != null && _node$decorators.length);
		  }
		  function hasDecorators(node) {
		    return hasOwnDecorators(node) || node.body.body.some(hasOwnDecorators);
		  }
		  function prop(key, value) {
		    if (!value) return null;
		    return objectProperty$1(identifier$j(key), value);
		  }
		  function method(key, body) {
		    return objectMethod("method", identifier$j(key), [], blockStatement$6(body));
		  }
		  function takeDecorators(node) {
		    var result;
		    if (node.decorators && node.decorators.length > 0) {
		      result = arrayExpression$1(node.decorators.map(function (decorator) {
		        return decorator.expression;
		      }));
		    }
		    node.decorators = undefined;
		    return result;
		  }
		  function getKey(node) {
		    if (node.computed) {
		      return node.key;
		    } else if (isIdentifier$i(node.key)) {
		      return stringLiteral$8(node.key.name);
		    } else {
		      return stringLiteral$8(String(node.key.value));
		    }
		  }
		  function extractElementDescriptor(file, classRef, superRef, path) {
		    var isMethod = path.isClassMethod();
		    if (path.isPrivate()) {
		      throw path.buildCodeFrameError("Private " + (isMethod ? "methods" : "fields") + " in decorated classes are not supported yet.");
		    }
		    if (path.node.type === "ClassAccessorProperty") {
		      throw path.buildCodeFrameError("Accessor properties are not supported in 2018-09 decorator transform, please specify { \"version\": \"2021-12\" } instead.");
		    }
		    if (path.node.type === "StaticBlock") {
		      throw path.buildCodeFrameError("Static blocks are not supported in 2018-09 decorator transform, please specify { \"version\": \"2021-12\" } instead.");
		    }
		    var _ref = path,
		      node = _ref.node,
		      scope = _ref.scope;
		    if (!path.isTSDeclareMethod()) {
		      new ReplaceSupers({
		        methodPath: path,
		        objectRef: classRef,
		        superRef: superRef,
		        file: file,
		        refToPreserve: classRef
		      }).replace();
		    }
		    var properties = [prop("kind", stringLiteral$8(isClassMethod(node) ? node.kind : "field")), prop("decorators", takeDecorators(node)), prop("static", node["static"] && booleanLiteral$4(true)), prop("key", getKey(node))].filter(Boolean);
		    if (isClassMethod(node)) {
		      var id = node.computed ? null : node.key;
		      var transformed = toExpression$1(node);
		      properties.push(prop("value", nameFunction({
		        node: transformed,
		        id: id,
		        scope: scope
		      }) || transformed));
		    } else if (isClassProperty(node) && node.value) {
		      properties.push(method("value", template$1.statements.ast(_templateObject$s || (_templateObject$s = _taggedTemplateLiteralLoose(["return ", ""])), node.value)));
		    } else {
		      properties.push(prop("value", scope.buildUndefinedNode()));
		    }
		    path.remove();
		    return objectExpression$3(properties);
		  }
		  function addDecorateHelper(file) {
		    return file.addHelper("decorate");
		  }
		  function buildDecoratedClass(ref, path, elements, file) {
		    var node = path.node,
		      scope = path.scope;
		    var initializeId = scope.generateUidIdentifier("initialize");
		    var isDeclaration = node.id && path.isDeclaration();
		    var isStrict = path.isInStrictMode();
		    var superClass = node.superClass;
		    node.type = "ClassDeclaration";
		    if (!node.id) node.id = cloneNode$j(ref);
		    var superId;
		    if (superClass) {
		      superId = scope.generateUidIdentifierBasedOnNode(node.superClass, "super");
		      node.superClass = superId;
		    }
		    var classDecorators = takeDecorators(node);
		    var definitions = arrayExpression$1(elements.filter(function (element) {
		      return !element.node["abstract"] && element.node.type !== "TSIndexSignature";
		    }).map(function (path) {
		      return extractElementDescriptor(file, node.id, superId, path);
		    }));
		    var wrapperCall = template$1.expression.ast(_templateObject2$e || (_templateObject2$e = _taggedTemplateLiteralLoose(["\n    ", "(\n      ", ",\n      function (", ", ", ") {\n        ", "\n        return { F: ", ", d: ", " };\n      },\n      ", "\n    )\n  "])), addDecorateHelper(file), classDecorators || nullLiteral$2(), initializeId, superClass ? cloneNode$j(superId) : null, node, cloneNode$j(node.id), definitions, superClass);
		    if (!isStrict) {
		      wrapperCall.arguments[1].body.directives.push(directive$1(directiveLiteral$1("use strict")));
		    }
		    var replacement = wrapperCall;
		    var classPathDesc = "arguments.1.body.body.0";
		    if (isDeclaration) {
		      replacement = template$1.statement.ast(_templateObject3$9 || (_templateObject3$9 = _taggedTemplateLiteralLoose(["let ", " = ", ""])), ref, wrapperCall);
		      classPathDesc = "declarations.0.init." + classPathDesc;
		    }
		    return {
		      instanceNodes: [template$1.statement.ast(_templateObject4$5 || (_templateObject4$5 = _taggedTemplateLiteralLoose(["\n        ", "(this)\n      "])), cloneNode$j(initializeId))],
		      wrapClass: function wrapClass(path) {
		        path.replaceWith(replacement);
		        return path.get(classPathDesc);
		      }
		    };
		  }

		  var FEATURES$1 = Object.freeze({
		    fields: 1 << 1,
		    privateMethods: 1 << 2,
		    decorators: 1 << 3,
		    privateIn: 1 << 4,
		    staticBlocks: 1 << 5
		  });
		  var featuresSameLoose = new Map([[FEATURES$1.fields, "@babel/plugin-transform-class-properties"], [FEATURES$1.privateMethods, "@babel/plugin-transform-private-methods"], [FEATURES$1.privateIn, "@babel/plugin-transform-private-property-in-object"]]);
		  var featuresKey$1 = "@babel/plugin-class-features/featuresKey";
		  var looseKey = "@babel/plugin-class-features/looseKey";
		  {
		    var looseLowPriorityKey = "@babel/plugin-class-features/looseLowPriorityKey/#__internal__@babel/preset-env__please-overwrite-loose-instead-of-throwing";
		  }
		  {
		    var canIgnoreLoose = function canIgnoreLoose(file, feature) {
		      return !!(file.get(looseLowPriorityKey) & feature);
		    };
		  }
		  function enableFeature$1(file, feature, loose) {
		    if (!hasFeature$1(file, feature) || canIgnoreLoose(file, feature)) {
		      file.set(featuresKey$1, file.get(featuresKey$1) | feature);
		      if (loose === "#__internal__@babel/preset-env__prefer-true-but-false-is-ok-if-it-prevents-an-error") {
		        setLoose(file, feature, true);
		        file.set(looseLowPriorityKey, file.get(looseLowPriorityKey) | feature);
		      } else if (loose === "#__internal__@babel/preset-env__prefer-false-but-true-is-ok-if-it-prevents-an-error") {
		        setLoose(file, feature, false);
		        file.set(looseLowPriorityKey, file.get(looseLowPriorityKey) | feature);
		      } else {
		        setLoose(file, feature, loose);
		      }
		    }
		    var resolvedLoose;
		    for (var _iterator = _createForOfIteratorHelperLoose(featuresSameLoose), _step; !(_step = _iterator()).done;) {
		      var _step$value = _slicedToArray(_step.value, 2),
		        _mask = _step$value[0],
		        _name = _step$value[1];
		      if (!hasFeature$1(file, _mask)) continue;
		      {
		        if (canIgnoreLoose(file, _mask)) continue;
		      }
		      var _loose = isLoose(file, _mask);
		      if (resolvedLoose === !_loose) {
		        throw new Error("'loose' mode configuration must be the same for @babel/plugin-transform-class-properties, " + "@babel/plugin-transform-private-methods and " + "@babel/plugin-transform-private-property-in-object (when they are enabled)." + "\n\n" + getBabelShowConfigForHint(file));
		      } else {
		        resolvedLoose = _loose;
		        {
		          var higherPriorityPluginName = _name;
		        }
		      }
		    }
		    if (resolvedLoose !== undefined) {
		      for (var _iterator2 = _createForOfIteratorHelperLoose(featuresSameLoose), _step2; !(_step2 = _iterator2()).done;) {
		        var _step2$value = _slicedToArray(_step2.value, 2),
		          mask = _step2$value[0],
		          name = _step2$value[1];
		        if (hasFeature$1(file, mask) && isLoose(file, mask) !== resolvedLoose) {
		          setLoose(file, mask, resolvedLoose);
		          console.warn("Though the \"loose\" option was set to \"" + !resolvedLoose + "\" in your @babel/preset-env " + ("config, it will not be used for " + name + " since the \"loose\" mode option was set to ") + ("\"" + resolvedLoose + "\" for " + higherPriorityPluginName + ".\nThe \"loose\" option must be the ") + "same for @babel/plugin-transform-class-properties, @babel/plugin-transform-private-methods " + "and @babel/plugin-transform-private-property-in-object (when they are enabled): you can " + "silence this warning by explicitly adding\n" + ("\t[\"" + name + "\", { \"loose\": " + resolvedLoose + " }]\n") + "to the \"plugins\" section of your Babel config." + "\n\n" + getBabelShowConfigForHint(file));
		        }
		      }
		    }
		  }
		  function getBabelShowConfigForHint(file) {
		    var filename = file.opts.filename;
		    if (!filename || filename === "unknown") {
		      filename = "[name of the input file]";
		    }
		    return "If you already set the same 'loose' mode for these plugins in your config, it's possible that they are enabled multiple times with different options.\nYou can re-run Babel with the BABEL_SHOW_CONFIG_FOR environment variable to show the loaded configuration:\n\tnpx cross-env BABEL_SHOW_CONFIG_FOR=" + filename + " <your build command>\nSee https://babeljs.io/docs/configuration#print-effective-configs for more info.";
		  }
		  function hasFeature$1(file, feature) {
		    return !!(file.get(featuresKey$1) & feature);
		  }
		  function isLoose(file, feature) {
		    return !!(file.get(looseKey) & feature);
		  }
		  function setLoose(file, feature, loose) {
		    if (loose) file.set(looseKey, file.get(looseKey) | feature);else file.set(looseKey, file.get(looseKey) & ~feature);
		    {
		      file.set(looseLowPriorityKey, file.get(looseLowPriorityKey) & ~feature);
		    }
		  }
		  function shouldTransform$2(path, file) {
		    var decoratorPath = null;
		    var publicFieldPath = null;
		    var privateFieldPath = null;
		    var privateMethodPath = null;
		    var staticBlockPath = null;
		    if (hasOwnDecorators(path.node)) {
		      decoratorPath = path.get("decorators.0");
		    }
		    for (var _iterator3 = _createForOfIteratorHelperLoose(path.get("body.body")), _step3; !(_step3 = _iterator3()).done;) {
		      var el = _step3.value;
		      if (!decoratorPath && hasOwnDecorators(el.node)) {
		        decoratorPath = el.get("decorators.0");
		      }
		      if (!publicFieldPath && el.isClassProperty()) {
		        publicFieldPath = el;
		      }
		      if (!privateFieldPath && el.isClassPrivateProperty()) {
		        privateFieldPath = el;
		      }
		      if (!privateMethodPath && el.isClassPrivateMethod != null && el.isClassPrivateMethod()) {
		        privateMethodPath = el;
		      }
		      if (!staticBlockPath && el.isStaticBlock != null && el.isStaticBlock()) {
		        staticBlockPath = el;
		      }
		    }
		    if (decoratorPath && privateFieldPath) {
		      throw privateFieldPath.buildCodeFrameError("Private fields in decorated classes are not supported yet.");
		    }
		    if (decoratorPath && privateMethodPath) {
		      throw privateMethodPath.buildCodeFrameError("Private methods in decorated classes are not supported yet.");
		    }
		    if (decoratorPath && !hasFeature$1(file, FEATURES$1.decorators)) {
		      throw path.buildCodeFrameError("Decorators are not enabled." + "\nIf you are using " + '["@babel/plugin-proposal-decorators", { "version": "legacy" }], ' + 'make sure it comes *before* "@babel/plugin-transform-class-properties" ' + "and enable loose mode, like so:\n" + '\t["@babel/plugin-proposal-decorators", { "version": "legacy" }]\n' + '\t["@babel/plugin-transform-class-properties", { "loose": true }]');
		    }
		    if (privateMethodPath && !hasFeature$1(file, FEATURES$1.privateMethods)) {
		      throw privateMethodPath.buildCodeFrameError("Class private methods are not enabled. " + "Please add `@babel/plugin-transform-private-methods` to your configuration.");
		    }
		    if ((publicFieldPath || privateFieldPath) && !hasFeature$1(file, FEATURES$1.fields) && !hasFeature$1(file, FEATURES$1.privateMethods)) {
		      throw path.buildCodeFrameError("Class fields are not enabled. " + "Please add `@babel/plugin-transform-class-properties` to your configuration.");
		    }
		    if (staticBlockPath && !hasFeature$1(file, FEATURES$1.staticBlocks)) {
		      throw path.buildCodeFrameError("Static class blocks are not enabled. " + "Please add `@babel/plugin-transform-class-static-block` to your configuration.");
		    }
		    if (decoratorPath || privateMethodPath || staticBlockPath) {
		      return true;
		    }
		    if ((publicFieldPath || privateFieldPath) && hasFeature$1(file, FEATURES$1.fields)) {
		      return true;
		    }
		    return false;
		  }

		  var versionKey$1 = "@babel/plugin-class-features/version";
		  function createClassFeaturePlugin(_ref) {
		    var _api$assumption;
		    var name = _ref.name,
		      feature = _ref.feature,
		      loose = _ref.loose,
		      manipulateOptions = _ref.manipulateOptions,
		      api = _ref.api,
		      inherits = _ref.inherits,
		      decoratorVersion = _ref.decoratorVersion;
		    if (feature & FEATURES$1.decorators) {
		      {
		        if (decoratorVersion === "2023-11" || decoratorVersion === "2023-05" || decoratorVersion === "2023-01" || decoratorVersion === "2022-03" || decoratorVersion === "2021-12") {
		          return createDecoratorTransform(api, {
		            loose: loose
		          }, decoratorVersion, inherits);
		        }
		      }
		    }
		    {
		      var _api;
		      (_api = api) != null ? _api : api = {
		        assumption: function assumption() {
		          return void 0;
		        }
		      };
		    }
		    var setPublicClassFields = api.assumption("setPublicClassFields");
		    var privateFieldsAsSymbols = api.assumption("privateFieldsAsSymbols");
		    var privateFieldsAsProperties = api.assumption("privateFieldsAsProperties");
		    var noUninitializedPrivateFieldAccess = (_api$assumption = api.assumption("noUninitializedPrivateFieldAccess")) != null ? _api$assumption : false;
		    var constantSuper = api.assumption("constantSuper");
		    var noDocumentAll = api.assumption("noDocumentAll");
		    if (privateFieldsAsProperties && privateFieldsAsSymbols) {
		      throw new Error("Cannot enable both the \"privateFieldsAsProperties\" and " + "\"privateFieldsAsSymbols\" assumptions as the same time.");
		    }
		    var privateFieldsAsSymbolsOrProperties = privateFieldsAsProperties || privateFieldsAsSymbols;
		    if (loose === true) {
		      var explicit = [];
		      if (setPublicClassFields !== undefined) {
		        explicit.push("\"setPublicClassFields\"");
		      }
		      if (privateFieldsAsProperties !== undefined) {
		        explicit.push("\"privateFieldsAsProperties\"");
		      }
		      if (privateFieldsAsSymbols !== undefined) {
		        explicit.push("\"privateFieldsAsSymbols\"");
		      }
		      if (explicit.length !== 0) {
		        console.warn("[" + name + "]: You are using the \"loose: true\" option and you are" + (" explicitly setting a value for the " + explicit.join(" and ")) + (" assumption" + (explicit.length > 1 ? "s" : "") + ". The \"loose\" option") + " can cause incompatibilities with the other class features" + " plugins, so it's recommended that you replace it with the" + " following top-level option:\n" + "\t\"assumptions\": {\n" + "\t\t\"setPublicClassFields\": true,\n" + "\t\t\"privateFieldsAsSymbols\": true\n" + "\t}");
		      }
		    }
		    return {
		      name: name,
		      manipulateOptions: manipulateOptions,
		      inherits: inherits,
		      pre: function pre(file) {
		        enableFeature$1(file, feature, loose);
		        {
		          if (typeof file.get(versionKey$1) === "number") {
		            file.set(versionKey$1, "7.24.5");
		            return;
		          }
		        }
		        if (!file.get(versionKey$1) || semver$7.lt(file.get(versionKey$1), "7.24.5")) {
		          file.set(versionKey$1, "7.24.5");
		        }
		      },
		      visitor: {
		        Class: function (_Class) {
		          function Class(_x, _x2) {
		            return _Class.apply(this, arguments);
		          }
		          Class.toString = function () {
		            return _Class.toString();
		          };
		          return Class;
		        }(function (path, _ref2) {
		          var _ref3;
		          var file = _ref2.file;
		          if (file.get(versionKey$1) !== "7.24.5") return;
		          if (!shouldTransform$2(path, file)) return;
		          var pathIsClassDeclaration = path.isClassDeclaration();
		          if (pathIsClassDeclaration) assertFieldTransformed(path);
		          var loose = isLoose(file, feature);
		          var constructor;
		          var isDecorated = hasDecorators(path.node);
		          var props = [];
		          var elements = [];
		          var computedPaths = [];
		          var privateNames = new Set();
		          var body = path.get("body");
		          for (var _iterator = _createForOfIteratorHelperLoose(body.get("body")), _step; !(_step = _iterator()).done;) {
		            var _path = _step.value;
		            if ((_path.isClassProperty() || _path.isClassMethod()) && _path.node.computed) {
		              computedPaths.push(_path);
		            }
		            if (_path.isPrivate()) {
		              var _name = _path.node.key.id.name;
		              var getName = "get " + _name;
		              var setName = "set " + _name;
		              if (_path.isClassPrivateMethod()) {
		                if (_path.node.kind === "get") {
		                  if (privateNames.has(getName) || privateNames.has(_name) && !privateNames.has(setName)) {
		                    throw _path.buildCodeFrameError("Duplicate private field");
		                  }
		                  privateNames.add(getName).add(_name);
		                } else if (_path.node.kind === "set") {
		                  if (privateNames.has(setName) || privateNames.has(_name) && !privateNames.has(getName)) {
		                    throw _path.buildCodeFrameError("Duplicate private field");
		                  }
		                  privateNames.add(setName).add(_name);
		                }
		              } else {
		                if (privateNames.has(_name) && !privateNames.has(getName) && !privateNames.has(setName) || privateNames.has(_name) && (privateNames.has(getName) || privateNames.has(setName))) {
		                  throw _path.buildCodeFrameError("Duplicate private field");
		                }
		                privateNames.add(_name);
		              }
		            }
		            if (_path.isClassMethod({
		              kind: "constructor"
		            })) {
		              constructor = _path;
		            } else {
		              elements.push(_path);
		              if (_path.isProperty() || _path.isPrivate() || _path.isStaticBlock != null && _path.isStaticBlock()) {
		                props.push(_path);
		              }
		            }
		          }
		          {
		            if (!props.length && !isDecorated) return;
		          }
		          var innerBinding = path.node.id;
		          var ref;
		          if (!innerBinding || !pathIsClassDeclaration) {
		            nameFunction(path);
		            ref = path.scope.generateUidIdentifier((innerBinding == null ? void 0 : innerBinding.name) || "Class");
		          }
		          var classRefForDefine = (_ref3 = ref) != null ? _ref3 : cloneNode$j(innerBinding);
		          var privateNamesMap = buildPrivateNamesMap(classRefForDefine.name, privateFieldsAsSymbolsOrProperties != null ? privateFieldsAsSymbolsOrProperties : loose, props, file);
		          var privateNamesNodes = buildPrivateNamesNodes(privateNamesMap, privateFieldsAsProperties != null ? privateFieldsAsProperties : loose, privateFieldsAsSymbols != null ? privateFieldsAsSymbols : false, file);
		          transformPrivateNamesUsage(classRefForDefine, path, privateNamesMap, {
		            privateFieldsAsProperties: privateFieldsAsSymbolsOrProperties != null ? privateFieldsAsSymbolsOrProperties : loose,
		            noUninitializedPrivateFieldAccess: noUninitializedPrivateFieldAccess,
		            noDocumentAll: noDocumentAll,
		            innerBinding: innerBinding
		          }, file);
		          var keysNodes, staticNodes, instanceNodes, lastInstanceNodeReturnsThis, pureStaticNodes, classBindingNode, wrapClass;
		          {
		            if (isDecorated) {
		              staticNodes = pureStaticNodes = keysNodes = [];
		              var _buildDecoratedClass = buildDecoratedClass(classRefForDefine, path, elements, file);
		              instanceNodes = _buildDecoratedClass.instanceNodes;
		              wrapClass = _buildDecoratedClass.wrapClass;
		            } else {
		              keysNodes = extractComputedKeys(path, computedPaths, file);
		              var _buildFieldsInitNodes = buildFieldsInitNodes(ref, path.node.superClass, props, privateNamesMap, file, setPublicClassFields != null ? setPublicClassFields : loose, privateFieldsAsSymbolsOrProperties != null ? privateFieldsAsSymbolsOrProperties : loose, noUninitializedPrivateFieldAccess, constantSuper != null ? constantSuper : loose, innerBinding);
		              staticNodes = _buildFieldsInitNodes.staticNodes;
		              pureStaticNodes = _buildFieldsInitNodes.pureStaticNodes;
		              instanceNodes = _buildFieldsInitNodes.instanceNodes;
		              lastInstanceNodeReturnsThis = _buildFieldsInitNodes.lastInstanceNodeReturnsThis;
		              classBindingNode = _buildFieldsInitNodes.classBindingNode;
		              wrapClass = _buildFieldsInitNodes.wrapClass;
		            }
		          }
		          if (instanceNodes.length > 0) {
		            injectInitialization(path, constructor, instanceNodes, function (referenceVisitor, state) {
		              {
		                if (isDecorated) return;
		              }
		              for (var _iterator2 = _createForOfIteratorHelperLoose(props), _step2; !(_step2 = _iterator2()).done;) {
		                var prop = _step2.value;
		                if (isStaticBlock != null && isStaticBlock(prop.node) || prop.node["static"]) continue;
		                prop.traverse(referenceVisitor, state);
		              }
		            }, lastInstanceNodeReturnsThis);
		          }
		          var wrappedPath = wrapClass(path);
		          wrappedPath.insertBefore([].concat(_toConsumableArray(privateNamesNodes), _toConsumableArray(keysNodes)));
		          if (staticNodes.length > 0) {
		            wrappedPath.insertAfter(staticNodes);
		          }
		          if (pureStaticNodes.length > 0) {
		            wrappedPath.find(function (parent) {
		              return parent.isStatement() || parent.isDeclaration();
		            }).insertAfter(pureStaticNodes);
		          }
		          if (classBindingNode != null && pathIsClassDeclaration) {
		            wrappedPath.insertAfter(classBindingNode);
		          }
		        }),
		        ExportDefaultDeclaration: function ExportDefaultDeclaration(path, _ref4) {
		          var file = _ref4.file;
		          {
		            if (file.get(versionKey$1) !== "7.24.5") return;
		            var decl = path.get("declaration");
		            if (decl.isClassDeclaration() && hasDecorators(decl.node)) {
		              if (decl.node.id) {
		                splitExportDeclaration(path);
		              } else {
		                decl.node.type = "ClassExpression";
		              }
		            }
		          }
		        }
		      }
		    };
		  }

		  var proposalClassProperties = declare(function (api, options) {
		    api.assertVersion("*");
		    return createClassFeaturePlugin({
		      name: "transform-class-properties",
		      api: api,
		      feature: FEATURES$1.fields,
		      loose: options.loose,
		      manipulateOptions: function manipulateOptions(opts, parserOpts) {
		        parserOpts.plugins.push("classProperties", "classPrivateProperties");
		      }
		    });
		  });

		  var _templateObject$r;
		  function generateUid(scope, denyList) {
		    var name = "";
		    var uid;
		    var i = 1;
		    do {
		      uid = scope._generateUid(name, i);
		      i++;
		    } while (denyList.has(uid));
		    return uid;
		  }
		  var proposalClassStaticBlock = declare(function (_ref) {
		    var t = _ref.types,
		      template = _ref.template,
		      assertVersion = _ref.assertVersion;
		      _ref.version;
		    assertVersion("*");
		    return {
		      name: "transform-class-static-block",
		      inherits: undefined,
		      pre: function pre() {
		        enableFeature$1(this.file, FEATURES$1.staticBlocks, false);
		      },
		      visitor: {
		        ClassBody: function ClassBody(classBody) {
		          var scope = classBody.scope;
		          var privateNames = new Set();
		          var body = classBody.get("body");
		          for (var _iterator = _createForOfIteratorHelperLoose(body), _step; !(_step = _iterator()).done;) {
		            var path = _step.value;
		            if (path.isPrivate()) {
		              privateNames.add(path.get("key.id").node.name);
		            }
		          }
		          for (var _iterator2 = _createForOfIteratorHelperLoose(body), _step2; !(_step2 = _iterator2()).done;) {
		            var _path = _step2.value;
		            if (!_path.isStaticBlock()) continue;
		            var staticBlockPrivateId = generateUid(scope, privateNames);
		            privateNames.add(staticBlockPrivateId);
		            var staticBlockRef = t.privateName(t.identifier(staticBlockPrivateId));
		            var replacement = void 0;
		            var blockBody = _path.node.body;
		            if (blockBody.length === 1 && t.isExpressionStatement(blockBody[0])) {
		              replacement = t.inheritsComments(blockBody[0].expression, blockBody[0]);
		            } else {
		              replacement = template.expression.ast(_templateObject$r || (_templateObject$r = _taggedTemplateLiteralLoose(["(() => { ", " })()"])), blockBody);
		            }
		            _path.replaceWith(t.classPrivateProperty(staticBlockRef, replacement, [], true));
		          }
		        }
		      }
		    };
		  });

		  var buildClassDecorator = template$1.statement("\n  DECORATOR(CLASS_REF = INNER) || CLASS_REF;\n");
		  var buildClassPrototype = template$1("\n  CLASS_REF.prototype;\n");
		  var buildGetDescriptor = template$1("\n    Object.getOwnPropertyDescriptor(TARGET, PROPERTY);\n");
		  var buildGetObjectInitializer = template$1("\n    (TEMP = Object.getOwnPropertyDescriptor(TARGET, PROPERTY), (TEMP = TEMP ? TEMP.value : undefined), {\n        enumerable: true,\n        configurable: true,\n        writable: true,\n        initializer: function(){\n            return TEMP;\n        }\n    })\n");
		  var WARNING_CALLS = new WeakSet();
		  function applyEnsureOrdering(path) {
		    var decorators = (path.isClass() ? [path].concat(_toConsumableArray(path.get("body.body"))) : path.get("properties")).reduce(function (acc, prop) {
		      return acc.concat(prop.node.decorators || []);
		    }, []);
		    var identDecorators = decorators.filter(function (decorator) {
		      return !isIdentifier$i(decorator.expression);
		    });
		    if (identDecorators.length === 0) return;
		    return sequenceExpression$8(identDecorators.map(function (decorator) {
		      var expression = decorator.expression;
		      var id = decorator.expression = path.scope.generateDeclaredUidIdentifier("dec");
		      return assignmentExpression$d("=", id, expression);
		    }).concat([path.node]));
		  }
		  function applyClassDecorators(classPath) {
		    if (!hasClassDecorators(classPath.node)) return;
		    var decorators = classPath.node.decorators || [];
		    classPath.node.decorators = null;
		    var name = classPath.scope.generateDeclaredUidIdentifier("class");
		    return decorators.map(function (dec) {
		      return dec.expression;
		    }).reverse().reduce(function (acc, decorator) {
		      return buildClassDecorator({
		        CLASS_REF: cloneNode$j(name),
		        DECORATOR: cloneNode$j(decorator),
		        INNER: acc
		      }).expression;
		    }, classPath.node);
		  }
		  function hasClassDecorators(classNode) {
		    var _classNode$decorators;
		    return !!((_classNode$decorators = classNode.decorators) != null && _classNode$decorators.length);
		  }
		  function applyMethodDecorators(path, state) {
		    if (!hasMethodDecorators(path.node.body.body)) return;
		    return applyTargetDecorators(path, state, path.node.body.body);
		  }
		  function hasMethodDecorators(body) {
		    return body.some(function (node) {
		      var _node$decorators;
		      return (_node$decorators = node.decorators) == null ? void 0 : _node$decorators.length;
		    });
		  }
		  function applyObjectDecorators(path, state) {
		    if (!hasMethodDecorators(path.node.properties)) return;
		    return applyTargetDecorators(path, state, path.node.properties.filter(function (prop) {
		      return prop.type !== "SpreadElement";
		    }));
		  }
		  function applyTargetDecorators(path, state, decoratedProps) {
		    var name = path.scope.generateDeclaredUidIdentifier(path.isClass() ? "class" : "obj");
		    var exprs = decoratedProps.reduce(function (acc, node) {
		      var decorators = [];
		      if (node.decorators != null) {
		        decorators = node.decorators;
		        node.decorators = null;
		      }
		      if (decorators.length === 0) return acc;
		      if (node.computed) {
		        throw path.buildCodeFrameError("Computed method/property decorators are not yet supported.");
		      }
		      var property = isLiteral$6(node.key) ? node.key : stringLiteral$8(node.key.name);
		      var target = path.isClass() && !node["static"] ? buildClassPrototype({
		        CLASS_REF: name
		      }).expression : name;
		      if (isClassProperty(node, {
		        "static": false
		      })) {
		        var descriptor = path.scope.generateDeclaredUidIdentifier("descriptor");
		        var initializer = node.value ? functionExpression$2(null, [], blockStatement$6([returnStatement$3(node.value)])) : nullLiteral$2();
		        node.value = callExpression$d(state.addHelper("initializerWarningHelper"), [descriptor, thisExpression$4()]);
		        WARNING_CALLS.add(node.value);
		        acc.push(assignmentExpression$d("=", cloneNode$j(descriptor), callExpression$d(state.addHelper("applyDecoratedDescriptor"), [cloneNode$j(target), cloneNode$j(property), arrayExpression$1(decorators.map(function (dec) {
		          return cloneNode$j(dec.expression);
		        })), objectExpression$3([objectProperty$1(identifier$j("configurable"), booleanLiteral$4(true)), objectProperty$1(identifier$j("enumerable"), booleanLiteral$4(true)), objectProperty$1(identifier$j("writable"), booleanLiteral$4(true)), objectProperty$1(identifier$j("initializer"), initializer)])])));
		      } else {
		        acc.push(callExpression$d(state.addHelper("applyDecoratedDescriptor"), [cloneNode$j(target), cloneNode$j(property), arrayExpression$1(decorators.map(function (dec) {
		          return cloneNode$j(dec.expression);
		        })), isObjectProperty$4(node) || isClassProperty(node, {
		          "static": true
		        }) ? buildGetObjectInitializer({
		          TEMP: path.scope.generateDeclaredUidIdentifier("init"),
		          TARGET: cloneNode$j(target),
		          PROPERTY: cloneNode$j(property)
		        }).expression : buildGetDescriptor({
		          TARGET: cloneNode$j(target),
		          PROPERTY: cloneNode$j(property)
		        }).expression, cloneNode$j(target)]));
		      }
		      return acc;
		    }, []);
		    return sequenceExpression$8([assignmentExpression$d("=", cloneNode$j(name), path.node), sequenceExpression$8(exprs), cloneNode$j(name)]);
		  }
		  function decoratedClassToExpression(_ref) {
		    var node = _ref.node,
		      scope = _ref.scope;
		    if (!hasClassDecorators(node) && !hasMethodDecorators(node.body.body)) {
		      return;
		    }
		    var ref = node.id ? cloneNode$j(node.id) : scope.generateUidIdentifier("class");
		    return variableDeclaration$8("let", [variableDeclarator$8(ref, toExpression$1(node))]);
		  }
		  var visitor$1 = {
		    ExportDefaultDeclaration: function ExportDefaultDeclaration(path) {
		      var decl = path.get("declaration");
		      if (!decl.isClassDeclaration()) return;
		      var replacement = decoratedClassToExpression(decl);
		      if (replacement) {
		        var _path$replaceWithMult = path.replaceWithMultiple([replacement, exportNamedDeclaration$2(null, [exportSpecifier$2(cloneNode$j(replacement.declarations[0].id), identifier$j("default"))])]),
		          _path$replaceWithMult2 = _slicedToArray(_path$replaceWithMult, 1),
		          varDeclPath = _path$replaceWithMult2[0];
		        if (!decl.node.id) {
		          path.scope.registerDeclaration(varDeclPath);
		        }
		      }
		    },
		    ClassDeclaration: function ClassDeclaration(path) {
		      var replacement = decoratedClassToExpression(path);
		      if (replacement) {
		        var _path$replaceWith = path.replaceWith(replacement),
		          _path$replaceWith2 = _slicedToArray(_path$replaceWith, 1),
		          newPath = _path$replaceWith2[0];
		        var decl = newPath.get("declarations.0");
		        var id = decl.node.id;
		        var binding = path.scope.getOwnBinding(id.name);
		        binding.identifier = id;
		        binding.path = decl;
		      }
		    },
		    ClassExpression: function ClassExpression(path, state) {
		      var decoratedClass = applyEnsureOrdering(path) || applyClassDecorators(path) || applyMethodDecorators(path, state);
		      if (decoratedClass) path.replaceWith(decoratedClass);
		    },
		    ObjectExpression: function ObjectExpression(path, state) {
		      var decoratedObject = applyEnsureOrdering(path) || applyObjectDecorators(path, state);
		      if (decoratedObject) path.replaceWith(decoratedObject);
		    },
		    AssignmentExpression: function AssignmentExpression(path, state) {
		      if (!WARNING_CALLS.has(path.node.right)) return;
		      path.replaceWith(callExpression$d(state.addHelper("initializerDefineProperty"), [cloneNode$j(path.get("left.object").node), stringLiteral$8(path.get("left.property").node.name || path.get("left.property").node.value), cloneNode$j(path.get("right.arguments")[0].node), cloneNode$j(path.get("right.arguments")[1].node)]));
		    },
		    CallExpression: function CallExpression(path, state) {
		      if (path.node.arguments.length !== 3) return;
		      if (!WARNING_CALLS.has(path.node.arguments[2])) return;
		      if (path.node.callee.name !== state.addHelper("defineProperty").name) {
		        return;
		      }
		      path.replaceWith(callExpression$d(state.addHelper("initializerDefineProperty"), [cloneNode$j(path.get("arguments")[0].node), cloneNode$j(path.get("arguments")[1].node), cloneNode$j(path.get("arguments.2.arguments")[0].node), cloneNode$j(path.get("arguments.2.arguments")[1].node)]));
		    }
		  };

		  var proposalDecorators = declare(function (api, options) {
		    api.assertVersion("*");
		    {
		      var legacy = options.legacy;
		    }
		    var version = options.version;
		    if (legacy || version === "legacy") {
		      return {
		        name: "proposal-decorators",
		        inherits: syntaxDecorators,
		        visitor: visitor$1
		      };
		    } else if (!version || version === "2018-09" || version === "2021-12" || version === "2022-03" || version === "2023-01" || version === "2023-05" || version === "2023-11") {
		      api.assertVersion("*");
		      return createClassFeaturePlugin({
		        name: "proposal-decorators",
		        api: api,
		        feature: FEATURES$1.decorators,
		        inherits: syntaxDecorators,
		        decoratorVersion: version
		      });
		    } else {
		      throw new Error("The '.version' option must be one of 'legacy', '2023-11', '2023-05', '2023-01', '2022-03', or '2021-12'.");
		    }
		  });

		  function isPureVoid(node) {
		    return isUnaryExpression$1(node) && node.operator === "void" && isPureish$2(node.argument);
		  }
		  function unshiftForXStatementBody(statementPath, newStatements) {
		    statementPath.ensureBlock();
		    var scope = statementPath.scope,
		      node = statementPath.node;
		    var bodyScopeBindings = statementPath.get("body").scope.bindings;
		    var hasShadowedBlockScopedBindings = Object.keys(bodyScopeBindings).some(function (name) {
		      return scope.hasBinding(name);
		    });
		    if (hasShadowedBlockScopedBindings) {
		      node.body = blockStatement$6([].concat(_toConsumableArray(newStatements), [node.body]));
		    } else {
		      var _body;
		      (_body = node.body.body).unshift.apply(_body, _toConsumableArray(newStatements));
		    }
		  }
		  function hasArrayRest(pattern) {
		    return pattern.elements.some(function (elem) {
		      return isRestElement$2(elem);
		    });
		  }
		  function hasObjectRest(pattern) {
		    return pattern.properties.some(function (prop) {
		      return isRestElement$2(prop);
		    });
		  }
		  var STOP_TRAVERSAL = {};
		  var arrayUnpackVisitor = function arrayUnpackVisitor(node, ancestors, state) {
		    if (!ancestors.length) {
		      return;
		    }
		    if (isIdentifier$i(node) && isReferenced$2(node, ancestors[ancestors.length - 1].node) && state.bindings[node.name]) {
		      state.deopt = true;
		      throw STOP_TRAVERSAL;
		    }
		  };
		  var DestructuringTransformer = function () {
		    function DestructuringTransformer(opts) {
		      this.blockHoist = void 0;
		      this.operator = void 0;
		      this.arrayRefSet = void 0;
		      this.nodes = void 0;
		      this.scope = void 0;
		      this.kind = void 0;
		      this.iterableIsArray = void 0;
		      this.arrayLikeIsIterable = void 0;
		      this.objectRestNoSymbols = void 0;
		      this.useBuiltIns = void 0;
		      this.addHelper = void 0;
		      this.blockHoist = opts.blockHoist;
		      this.operator = opts.operator;
		      this.arrayRefSet = new Set();
		      this.nodes = opts.nodes || [];
		      this.scope = opts.scope;
		      this.kind = opts.kind;
		      this.iterableIsArray = opts.iterableIsArray;
		      this.arrayLikeIsIterable = opts.arrayLikeIsIterable;
		      this.objectRestNoSymbols = opts.objectRestNoSymbols;
		      this.useBuiltIns = opts.useBuiltIns;
		      this.addHelper = opts.addHelper;
		    }
		    var _proto = DestructuringTransformer.prototype;
		    _proto.getExtendsHelper = function getExtendsHelper() {
		      return this.useBuiltIns ? memberExpression$c(identifier$j("Object"), identifier$j("assign")) : this.addHelper("extends");
		    };
		    _proto.buildVariableAssignment = function buildVariableAssignment(id, init) {
		      var op = this.operator;
		      if (isMemberExpression$9(id) || isOptionalMemberExpression$3(id)) op = "=";
		      var node;
		      if (op) {
		        node = expressionStatement$a(assignmentExpression$d(op, id, cloneNode$j(init) || this.scope.buildUndefinedNode()));
		      } else {
		        var nodeInit;
		        if ((this.kind === "const" || this.kind === "using") && init === null) {
		          nodeInit = this.scope.buildUndefinedNode();
		        } else {
		          nodeInit = cloneNode$j(init);
		        }
		        node = variableDeclaration$8(this.kind, [variableDeclarator$8(id, nodeInit)]);
		      }
		      node._blockHoist = this.blockHoist;
		      return node;
		    };
		    _proto.buildVariableDeclaration = function buildVariableDeclaration(id, init) {
		      var declar = variableDeclaration$8("var", [variableDeclarator$8(cloneNode$j(id), cloneNode$j(init))]);
		      declar._blockHoist = this.blockHoist;
		      return declar;
		    };
		    _proto.push = function push(id, _init) {
		      var init = cloneNode$j(_init);
		      if (isObjectPattern$1(id)) {
		        this.pushObjectPattern(id, init);
		      } else if (isArrayPattern(id)) {
		        this.pushArrayPattern(id, init);
		      } else if (isAssignmentPattern$4(id)) {
		        this.pushAssignmentPattern(id, init);
		      } else {
		        this.nodes.push(this.buildVariableAssignment(id, init));
		      }
		    };
		    _proto.toArray = function toArray(node, count) {
		      if (this.iterableIsArray || isIdentifier$i(node) && this.arrayRefSet.has(node.name)) {
		        return node;
		      } else {
		        return this.scope.toArray(node, count, this.arrayLikeIsIterable);
		      }
		    };
		    _proto.pushAssignmentPattern = function pushAssignmentPattern(_ref, valueRef) {
		      var left = _ref.left,
		        right = _ref.right;
		      if (isPureVoid(valueRef)) {
		        this.push(left, right);
		        return;
		      }
		      var tempId = this.scope.generateUidIdentifierBasedOnNode(valueRef);
		      this.nodes.push(this.buildVariableDeclaration(tempId, valueRef));
		      var tempConditional = conditionalExpression$5(binaryExpression$5("===", cloneNode$j(tempId), this.scope.buildUndefinedNode()), right, cloneNode$j(tempId));
		      if (isPattern(left)) {
		        var patternId;
		        var node;
		        if (this.kind === "const" || this.kind === "let" || this.kind === "using") {
		          patternId = this.scope.generateUidIdentifier(tempId.name);
		          node = this.buildVariableDeclaration(patternId, tempConditional);
		        } else {
		          patternId = tempId;
		          node = expressionStatement$a(assignmentExpression$d("=", cloneNode$j(tempId), tempConditional));
		        }
		        this.nodes.push(node);
		        this.push(left, patternId);
		      } else {
		        this.nodes.push(this.buildVariableAssignment(left, tempConditional));
		      }
		    };
		    _proto.pushObjectRest = function pushObjectRest(pattern, objRef, spreadProp, spreadPropIndex) {
		      var _this = this;
		      var value = buildObjectExcludingKeys(pattern.properties.slice(0, spreadPropIndex), objRef, this.scope, function (name) {
		        return _this.addHelper(name);
		      }, this.objectRestNoSymbols, this.useBuiltIns);
		      this.nodes.push(this.buildVariableAssignment(spreadProp.argument, value));
		    };
		    _proto.pushObjectProperty = function pushObjectProperty(prop, propRef) {
		      if (isLiteral$6(prop.key)) prop.computed = true;
		      var pattern = prop.value;
		      var objRef = memberExpression$c(cloneNode$j(propRef), prop.key, prop.computed);
		      if (isPattern(pattern)) {
		        this.push(pattern, objRef);
		      } else {
		        this.nodes.push(this.buildVariableAssignment(pattern, objRef));
		      }
		    };
		    _proto.pushObjectPattern = function pushObjectPattern(pattern, objRef) {
		      if (!pattern.properties.length) {
		        this.nodes.push(expressionStatement$a(callExpression$d(this.addHelper("objectDestructuringEmpty"), isPureVoid(objRef) ? [] : [objRef])));
		        return;
		      }
		      if (pattern.properties.length > 1 && !this.scope.isStatic(objRef)) {
		        var temp = this.scope.generateUidIdentifierBasedOnNode(objRef);
		        this.nodes.push(this.buildVariableDeclaration(temp, objRef));
		        objRef = temp;
		      }
		      if (hasObjectRest(pattern)) {
		        var copiedPattern;
		        for (var i = 0; i < pattern.properties.length; i++) {
		          var prop = pattern.properties[i];
		          if (isRestElement$2(prop)) {
		            break;
		          }
		          var key = prop.key;
		          if (prop.computed && !this.scope.isPure(key)) {
		            var name = this.scope.generateUidIdentifierBasedOnNode(key);
		            this.nodes.push(this.buildVariableDeclaration(name, key));
		            if (!copiedPattern) {
		              copiedPattern = pattern = Object.assign({}, pattern, {
		                properties: pattern.properties.slice()
		              });
		            }
		            copiedPattern.properties[i] = Object.assign({}, prop, {
		              key: name
		            });
		          }
		        }
		      }
		      for (var _i = 0; _i < pattern.properties.length; _i++) {
		        var _prop = pattern.properties[_i];
		        if (isRestElement$2(_prop)) {
		          this.pushObjectRest(pattern, objRef, _prop, _i);
		        } else {
		          this.pushObjectProperty(_prop, objRef);
		        }
		      }
		    };
		    _proto.canUnpackArrayPattern = function canUnpackArrayPattern(pattern, arr) {
		      if (!isArrayExpression$2(arr)) return false;
		      if (pattern.elements.length > arr.elements.length) return;
		      if (pattern.elements.length < arr.elements.length && !hasArrayRest(pattern)) {
		        return false;
		      }
		      for (var _iterator = _createForOfIteratorHelperLoose(pattern.elements), _step; !(_step = _iterator()).done;) {
		        var elem = _step.value;
		        if (!elem) return false;
		        if (isMemberExpression$9(elem)) return false;
		      }
		      for (var _iterator2 = _createForOfIteratorHelperLoose(arr.elements), _step2; !(_step2 = _iterator2()).done;) {
		        var _elem = _step2.value;
		        if (isSpreadElement$1(_elem)) return false;
		        if (isCallExpression$8(_elem)) return false;
		        if (isMemberExpression$9(_elem)) return false;
		      }
		      var bindings = getBindingIdentifiers$4(pattern);
		      var state = {
		        deopt: false,
		        bindings: bindings
		      };
		      try {
		        traverse$2(arr, arrayUnpackVisitor, state);
		      } catch (e) {
		        if (e !== STOP_TRAVERSAL) throw e;
		      }
		      return !state.deopt;
		    };
		    _proto.pushUnpackedArrayPattern = function pushUnpackedArrayPattern(pattern, arr) {
		      var _this2 = this;
		      var holeToUndefined = function holeToUndefined(el) {
		        return el != null ? el : _this2.scope.buildUndefinedNode();
		      };
		      for (var i = 0; i < pattern.elements.length; i++) {
		        var elem = pattern.elements[i];
		        if (isRestElement$2(elem)) {
		          this.push(elem.argument, arrayExpression$1(arr.elements.slice(i).map(holeToUndefined)));
		        } else {
		          this.push(elem, holeToUndefined(arr.elements[i]));
		        }
		      }
		    };
		    _proto.pushArrayPattern = function pushArrayPattern(pattern, arrayRef) {
		      if (arrayRef === null) {
		        this.nodes.push(expressionStatement$a(callExpression$d(this.addHelper("objectDestructuringEmpty"), [])));
		        return;
		      }
		      if (!pattern.elements) return;
		      if (this.canUnpackArrayPattern(pattern, arrayRef)) {
		        this.pushUnpackedArrayPattern(pattern, arrayRef);
		        return;
		      }
		      var count = !hasArrayRest(pattern) && pattern.elements.length;
		      var toArray = this.toArray(arrayRef, count);
		      if (isIdentifier$i(toArray)) {
		        arrayRef = toArray;
		      } else {
		        arrayRef = this.scope.generateUidIdentifierBasedOnNode(arrayRef);
		        this.arrayRefSet.add(arrayRef.name);
		        this.nodes.push(this.buildVariableDeclaration(arrayRef, toArray));
		      }
		      for (var i = 0; i < pattern.elements.length; i++) {
		        var elem = pattern.elements[i];
		        if (!elem) continue;
		        var elemRef = void 0;
		        if (isRestElement$2(elem)) {
		          elemRef = this.toArray(arrayRef);
		          elemRef = callExpression$d(memberExpression$c(elemRef, identifier$j("slice")), [numericLiteral$8(i)]);
		          this.push(elem.argument, elemRef);
		        } else {
		          elemRef = memberExpression$c(arrayRef, numericLiteral$8(i), true);
		          this.push(elem, elemRef);
		        }
		      }
		    };
		    _proto.init = function init(pattern, ref) {
		      if (!isArrayExpression$2(ref) && !isMemberExpression$9(ref)) {
		        var memo = this.scope.maybeGenerateMemoised(ref, true);
		        if (memo) {
		          this.nodes.push(this.buildVariableDeclaration(memo, cloneNode$j(ref)));
		          ref = memo;
		        }
		      }
		      this.push(pattern, ref);
		      return this.nodes;
		    };
		    return _createClass(DestructuringTransformer);
		  }();
		  function buildObjectExcludingKeys(excludedKeys, objRef, scope, addHelper, objectRestNoSymbols, useBuiltIns) {
		    var keys = [];
		    var allLiteral = true;
		    var hasTemplateLiteral = false;
		    for (var i = 0; i < excludedKeys.length; i++) {
		      var prop = excludedKeys[i];
		      var key = prop.key;
		      if (isIdentifier$i(key) && !prop.computed) {
		        keys.push(stringLiteral$8(key.name));
		      } else if (isTemplateLiteral$2(key)) {
		        keys.push(cloneNode$j(key));
		        hasTemplateLiteral = true;
		      } else if (isLiteral$6(key)) {
		        keys.push(stringLiteral$8(String(key.value)));
		      } else if (isPrivateName$3(key)) ; else {
		        keys.push(cloneNode$j(key));
		        allLiteral = false;
		      }
		    }
		    var value;
		    if (keys.length === 0) {
		      var extendsHelper = useBuiltIns ? memberExpression$c(identifier$j("Object"), identifier$j("assign")) : addHelper("extends");
		      value = callExpression$d(extendsHelper, [objectExpression$3([]), sequenceExpression$8([callExpression$d(addHelper("objectDestructuringEmpty"), [cloneNode$j(objRef)]), cloneNode$j(objRef)])]);
		    } else {
		      var keyExpression = arrayExpression$1(keys);
		      if (!allLiteral) {
		        keyExpression = callExpression$d(memberExpression$c(keyExpression, identifier$j("map")), [addHelper("toPropertyKey")]);
		      } else if (!hasTemplateLiteral && !isProgram$1(scope.block)) {
		        var programScope = scope.getProgramParent();
		        var id = programScope.generateUidIdentifier("excluded");
		        programScope.push({
		          id: id,
		          init: keyExpression,
		          kind: "const"
		        });
		        keyExpression = cloneNode$j(id);
		      }
		      value = callExpression$d(addHelper("objectWithoutProperties" + (objectRestNoSymbols ? "Loose" : "")), [cloneNode$j(objRef), keyExpression]);
		    }
		    return value;
		  }
		  function convertVariableDeclaration(path, addHelper, arrayLikeIsIterable, iterableIsArray, objectRestNoSymbols, useBuiltIns) {
		    var node = path.node,
		      scope = path.scope;
		    var nodeKind = node.kind;
		    var nodeLoc = node.loc;
		    var nodes = [];
		    for (var i = 0; i < node.declarations.length; i++) {
		      var declar = node.declarations[i];
		      var patternId = declar.init;
		      var pattern = declar.id;
		      var destructuring = new DestructuringTransformer({
		        blockHoist: node._blockHoist,
		        nodes: nodes,
		        scope: scope,
		        kind: node.kind,
		        iterableIsArray: iterableIsArray,
		        arrayLikeIsIterable: arrayLikeIsIterable,
		        useBuiltIns: useBuiltIns,
		        objectRestNoSymbols: objectRestNoSymbols,
		        addHelper: addHelper
		      });
		      if (isPattern(pattern)) {
		        destructuring.init(pattern, patternId);
		        if (+i !== node.declarations.length - 1) {
		          inherits$3(nodes[nodes.length - 1], declar);
		        }
		      } else {
		        nodes.push(inherits$3(destructuring.buildVariableAssignment(pattern, patternId), declar));
		      }
		    }
		    var tail = null;
		    var nodesOut = [];
		    for (var _i2 = 0, _nodes = nodes; _i2 < _nodes.length; _i2++) {
		      var _node = _nodes[_i2];
		      if (isVariableDeclaration$4(_node)) {
		        if (tail !== null) {
		          var _tail$declarations;
		          (_tail$declarations = tail.declarations).push.apply(_tail$declarations, _toConsumableArray(_node.declarations));
		          continue;
		        } else {
		          _node.kind = nodeKind;
		          tail = _node;
		        }
		      } else {
		        tail = null;
		      }
		      if (!_node.loc) {
		        _node.loc = nodeLoc;
		      }
		      nodesOut.push(_node);
		    }
		    if (nodesOut.length === 2 && isVariableDeclaration$4(nodesOut[0]) && isExpressionStatement$2(nodesOut[1]) && isCallExpression$8(nodesOut[1].expression) && nodesOut[0].declarations.length === 1) {
		      var expr = nodesOut[1].expression;
		      expr.arguments = [nodesOut[0].declarations[0].init];
		      nodesOut = [expr];
		    } else {
		      if (isForStatement$2(path.parent, {
		        init: node
		      }) && !nodesOut.some(function (v) {
		        return isVariableDeclaration$4(v);
		      })) {
		        for (var _i3 = 0; _i3 < nodesOut.length; _i3++) {
		          var _node2 = nodesOut[_i3];
		          if (isExpressionStatement$2(_node2)) {
		            nodesOut[_i3] = _node2.expression;
		          }
		        }
		      }
		    }
		    if (nodesOut.length === 1) {
		      path.replaceWith(nodesOut[0]);
		    } else {
		      path.replaceWithMultiple(nodesOut);
		    }
		    scope.crawl();
		  }
		  function convertAssignmentExpression(path, addHelper, arrayLikeIsIterable, iterableIsArray, objectRestNoSymbols, useBuiltIns) {
		    var node = path.node,
		      scope = path.scope,
		      parentPath = path.parentPath;
		    var nodes = [];
		    var destructuring = new DestructuringTransformer({
		      operator: node.operator,
		      scope: scope,
		      nodes: nodes,
		      arrayLikeIsIterable: arrayLikeIsIterable,
		      iterableIsArray: iterableIsArray,
		      objectRestNoSymbols: objectRestNoSymbols,
		      useBuiltIns: useBuiltIns,
		      addHelper: addHelper
		    });
		    var ref;
		    if (!parentPath.isExpressionStatement() && !parentPath.isSequenceExpression() || path.isCompletionRecord()) {
		      ref = scope.generateUidIdentifierBasedOnNode(node.right, "ref");
		      nodes.push(variableDeclaration$8("var", [variableDeclarator$8(ref, node.right)]));
		      if (isArrayExpression$2(node.right)) {
		        destructuring.arrayRefSet.add(ref.name);
		      }
		    }
		    destructuring.init(node.left, ref || node.right);
		    if (ref) {
		      if (parentPath.isArrowFunctionExpression()) {
		        path.replaceWith(blockStatement$6([]));
		        nodes.push(returnStatement$3(cloneNode$j(ref)));
		      } else {
		        nodes.push(expressionStatement$a(cloneNode$j(ref)));
		      }
		    }
		    path.replaceWithMultiple(nodes);
		    scope.crawl();
		  }

		  function variableDeclarationHasPattern(node) {
		    for (var _iterator = _createForOfIteratorHelperLoose(node.declarations), _step; !(_step = _iterator()).done;) {
		      var declar = _step.value;
		      if (isPattern(declar.id)) {
		        return true;
		      }
		    }
		    return false;
		  }
		  var _transformDestructuring = declare(function (api, options) {
		    var _ref, _api$assumption, _ref2, _options$allowArrayLi, _ref3, _api$assumption2;
		    api.assertVersion("*");
		    var _options$useBuiltIns = options.useBuiltIns,
		      useBuiltIns = _options$useBuiltIns === void 0 ? false : _options$useBuiltIns;
		    var iterableIsArray = (_ref = (_api$assumption = api.assumption("iterableIsArray")) != null ? _api$assumption : options.loose) != null ? _ref : false;
		    var arrayLikeIsIterable = (_ref2 = (_options$allowArrayLi = options.allowArrayLike) != null ? _options$allowArrayLi : api.assumption("arrayLikeIsIterable")) != null ? _ref2 : false;
		    var objectRestNoSymbols = (_ref3 = (_api$assumption2 = api.assumption("objectRestNoSymbols")) != null ? _api$assumption2 : options.loose) != null ? _ref3 : false;
		    return {
		      name: "transform-destructuring",
		      visitor: {
		        ExportNamedDeclaration: function ExportNamedDeclaration(path) {
		          var declaration = path.get("declaration");
		          if (!declaration.isVariableDeclaration()) return;
		          if (!variableDeclarationHasPattern(declaration.node)) return;
		          var specifiers = [];
		          for (var _i = 0, _Object$keys = Object.keys(path.getOuterBindingIdentifiers()); _i < _Object$keys.length; _i++) {
		            var name = _Object$keys[_i];
		            specifiers.push(exportSpecifier$2(identifier$j(name), identifier$j(name)));
		          }
		          path.replaceWith(declaration.node);
		          path.insertAfter(exportNamedDeclaration$2(null, specifiers));
		          path.scope.crawl();
		        },
		        ForXStatement: function (_ForXStatement) {
		          function ForXStatement(_x) {
		            return _ForXStatement.apply(this, arguments);
		          }
		          ForXStatement.toString = function () {
		            return _ForXStatement.toString();
		          };
		          return ForXStatement;
		        }(function (path) {
		          var _this = this;
		          var node = path.node,
		            scope = path.scope;
		          var left = node.left;
		          if (isPattern(left)) {
		            var temp = scope.generateUidIdentifier("ref");
		            node.left = variableDeclaration$8("var", [variableDeclarator$8(temp)]);
		            path.ensureBlock();
		            var statementBody = path.node.body.body;
		            var _nodes = [];
		            if (statementBody.length === 0 && path.isCompletionRecord()) {
		              _nodes.unshift(expressionStatement$a(scope.buildUndefinedNode()));
		            }
		            _nodes.unshift(expressionStatement$a(assignmentExpression$d("=", left, cloneNode$j(temp))));
		            unshiftForXStatementBody(path, _nodes);
		            scope.crawl();
		            return;
		          }
		          if (!isVariableDeclaration$4(left)) return;
		          var pattern = left.declarations[0].id;
		          if (!isPattern(pattern)) return;
		          var key = scope.generateUidIdentifier("ref");
		          node.left = variableDeclaration$8(left.kind, [variableDeclarator$8(key, null)]);
		          var nodes = [];
		          var destructuring = new DestructuringTransformer({
		            kind: left.kind,
		            scope: scope,
		            nodes: nodes,
		            arrayLikeIsIterable: arrayLikeIsIterable,
		            iterableIsArray: iterableIsArray,
		            objectRestNoSymbols: objectRestNoSymbols,
		            useBuiltIns: useBuiltIns,
		            addHelper: function addHelper(name) {
		              return _this.addHelper(name);
		            }
		          });
		          destructuring.init(pattern, key);
		          unshiftForXStatementBody(path, nodes);
		          scope.crawl();
		        }),
		        CatchClause: function CatchClause(_ref4) {
		          var _this2 = this;
		          var node = _ref4.node,
		            scope = _ref4.scope;
		          var pattern = node.param;
		          if (!isPattern(pattern)) return;
		          var ref = scope.generateUidIdentifier("ref");
		          node.param = ref;
		          var nodes = [];
		          var destructuring = new DestructuringTransformer({
		            kind: "let",
		            scope: scope,
		            nodes: nodes,
		            arrayLikeIsIterable: arrayLikeIsIterable,
		            iterableIsArray: iterableIsArray,
		            objectRestNoSymbols: objectRestNoSymbols,
		            useBuiltIns: useBuiltIns,
		            addHelper: function addHelper(name) {
		              return _this2.addHelper(name);
		            }
		          });
		          destructuring.init(pattern, ref);
		          node.body.body = [].concat(nodes, _toConsumableArray(node.body.body));
		          scope.crawl();
		        },
		        AssignmentExpression: function (_AssignmentExpression) {
		          function AssignmentExpression(_x2, _x3) {
		            return _AssignmentExpression.apply(this, arguments);
		          }
		          AssignmentExpression.toString = function () {
		            return _AssignmentExpression.toString();
		          };
		          return AssignmentExpression;
		        }(function (path, state) {
		          if (!isPattern(path.node.left)) return;
		          convertAssignmentExpression(path, function (name) {
		            return state.addHelper(name);
		          }, arrayLikeIsIterable, iterableIsArray, objectRestNoSymbols, useBuiltIns);
		        }),
		        VariableDeclaration: function VariableDeclaration(path, state) {
		          var node = path.node,
		            parent = path.parent;
		          if (isForXStatement$1(parent)) return;
		          if (!parent || !path.container) return;
		          if (!variableDeclarationHasPattern(node)) return;
		          convertVariableDeclaration(path, function (name) {
		            return state.addHelper(name);
		          }, arrayLikeIsIterable, iterableIsArray, objectRestNoSymbols, useBuiltIns);
		        }
		      }
		    };
		  });

		  var _marked = _regeneratorRuntime().mark(traversePattern),
		    _marked2 = _regeneratorRuntime().mark(privateKeyPathIterator),
		    _marked3 = _regeneratorRuntime().mark(transformPrivateKeyDestructuring);
		  var assignmentExpression$2 = assignmentExpression$d,
		    binaryExpression = binaryExpression$5,
		    conditionalExpression = conditionalExpression$5,
		    cloneNode$1 = cloneNode$j,
		    isObjectProperty$1 = isObjectProperty$4,
		    isPrivateName$1 = isPrivateName$3,
		    memberExpression$2 = memberExpression$c,
		    numericLiteral = numericLiteral$8,
		    objectPattern = objectPattern$1,
		    restElement = restElement$2,
		    variableDeclarator = variableDeclarator$8,
		    variableDeclaration = variableDeclaration$8,
		    unaryExpression = unaryExpression$6;
		  function buildUndefinedNode() {
		    return unaryExpression("void", numericLiteral(0));
		  }
		  function transformAssignmentPattern(initializer, tempId) {
		    return conditionalExpression(binaryExpression("===", cloneNode$1(tempId), buildUndefinedNode()), initializer, cloneNode$1(tempId));
		  }
		  function initRestExcludingKeys(pattern) {
		    if (pattern.type === "ObjectPattern") {
		      var properties = pattern.properties;
		      if (properties[properties.length - 1].type === "RestElement") {
		        return [];
		      }
		    }
		    return null;
		  }
		  function growRestExcludingKeys(excludingKeys, properties, scope) {
		    if (excludingKeys === null) return;
		    for (var _iterator = _createForOfIteratorHelperLoose(properties), _step; !(_step = _iterator()).done;) {
		      var property = _step.value;
		      var propertyKey = property.key;
		      if (property.computed && !scope.isStatic(propertyKey)) {
		        var tempId = scope.generateDeclaredUidIdentifier("m");
		        property.key = assignmentExpression$2("=", tempId, propertyKey);
		        excludingKeys.push({
		          key: tempId,
		          computed: true
		        });
		      } else if (propertyKey.type !== "PrivateName") {
		        excludingKeys.push(property);
		      }
		    }
		  }
		  function buildVariableDeclarationFromParams(params, scope) {
		    var _buildAssignmentsFrom = buildAssignmentsFromPatternList(params, scope, false),
		      elements = _buildAssignmentsFrom.elements,
		      transformed = _buildAssignmentsFrom.transformed;
		    return {
		      params: elements,
		      variableDeclaration: variableDeclaration("var", transformed.map(function (_ref) {
		        var left = _ref.left,
		          right = _ref.right;
		        return variableDeclarator(left, right);
		      }))
		    };
		  }
		  function buildAssignmentsFromPatternList(elements, scope, isAssignment) {
		    var newElements = [],
		      transformed = [];
		    for (var _iterator2 = _createForOfIteratorHelperLoose(elements), _step2; !(_step2 = _iterator2()).done;) {
		      var element = _step2.value;
		      if (element === null) {
		        newElements.push(null);
		        transformed.push(null);
		        continue;
		      }
		      var tempId = scope.generateUidIdentifier("p");
		      if (isAssignment) {
		        scope.push({
		          id: cloneNode$1(tempId)
		        });
		      }
		      if (element.type === "RestElement") {
		        newElements.push(restElement(tempId));
		        element = element.argument;
		      } else {
		        newElements.push(tempId);
		      }
		      if (element.type === "AssignmentPattern") {
		        transformed.push({
		          left: element.left,
		          right: transformAssignmentPattern(element.right, tempId)
		        });
		      } else {
		        transformed.push({
		          left: element,
		          right: cloneNode$1(tempId)
		        });
		      }
		    }
		    return {
		      elements: newElements,
		      transformed: transformed
		    };
		  }
		  function traversePattern(root, visitor) {
		    var stack, item, _item, _node, _index, _depth, list, i, _list, _i;
		    return _regeneratorRuntime().wrap(function traversePattern$(_context) {
		      while (1) switch (_context.prev = _context.next) {
		        case 0:
		          stack = [];
		          stack.push({
		            node: root,
		            index: 0,
		            depth: 0
		          });
		        case 2:
		          if (!((item = stack.pop()) !== undefined)) {
		            _context.next = 25;
		            break;
		          }
		          _item = item, _node = _item.node, _index = _item.index;
		          if (!(_node === null)) {
		            _context.next = 6;
		            break;
		          }
		          return _context.abrupt("continue", 2);
		        case 6:
		          return _context.delegateYield(visitor(_node, _index, item.depth), "t0", 7);
		        case 7:
		          _depth = item.depth + 1;
		          _context.t1 = _node.type;
		          _context.next = _context.t1 === "AssignmentPattern" ? 11 : _context.t1 === "ObjectProperty" ? 13 : _context.t1 === "RestElement" ? 15 : _context.t1 === "ObjectPattern" ? 17 : _context.t1 === "ArrayPattern" ? 19 : _context.t1 === "TSParameterProperty" ? 21 : _context.t1 === "TSAsExpression" ? 21 : _context.t1 === "TSTypeAssertion" ? 21 : _context.t1 === "TSNonNullExpression" ? 21 : 22;
		          break;
		        case 11:
		          stack.push({
		            node: _node.left,
		            index: 0,
		            depth: _depth
		          });
		          return _context.abrupt("break", 23);
		        case 13:
		          stack.push({
		            node: _node.value,
		            index: _index,
		            depth: item.depth
		          });
		          return _context.abrupt("break", 23);
		        case 15:
		          stack.push({
		            node: _node.argument,
		            index: 0,
		            depth: _depth
		          });
		          return _context.abrupt("break", 23);
		        case 17:
		          for (list = _node.properties, i = list.length - 1; i >= 0; i--) {
		            stack.push({
		              node: list[i],
		              index: i,
		              depth: _depth
		            });
		          }
		          return _context.abrupt("break", 23);
		        case 19:
		          for (_list = _node.elements, _i = _list.length - 1; _i >= 0; _i--) {
		            stack.push({
		              node: _list[_i],
		              index: _i,
		              depth: _depth
		            });
		          }
		          return _context.abrupt("break", 23);
		        case 21:
		          throw new Error("TypeScript features must first be transformed by " + "@babel/plugin-transform-typescript.\n" + "If you have already enabled that plugin (or '@babel/preset-typescript'), make sure " + "that it runs before @babel/plugin-proposal-destructuring-private.");
		        case 22:
		          return _context.abrupt("break", 23);
		        case 23:
		          _context.next = 2;
		          break;
		        case 25:
		        case "end":
		          return _context.stop();
		      }
		    }, _marked);
		  }
		  function hasPrivateKeys(pattern) {
		    var result = false;
		    traversePattern(pattern, _regeneratorRuntime().mark(function _callee(node) {
		      return _regeneratorRuntime().wrap(function _callee$(_context2) {
		        while (1) switch (_context2.prev = _context2.next) {
		          case 0:
		            if (!(isObjectProperty$1(node) && isPrivateName$1(node.key))) {
		              _context2.next = 4;
		              break;
		            }
		            result = true;
		            _context2.next = 4;
		            return;
		          case 4:
		          case "end":
		            return _context2.stop();
		        }
		      }, _callee);
		    })).next();
		    return result;
		  }
		  function hasPrivateClassElement(node) {
		    return node.body.some(function (element) {
		      return isPrivateName$1(element.key);
		    });
		  }
		  function privateKeyPathIterator(pattern) {
		    var indexPath;
		    return _regeneratorRuntime().wrap(function privateKeyPathIterator$(_context4) {
		      while (1) switch (_context4.prev = _context4.next) {
		        case 0:
		          indexPath = [];
		          return _context4.delegateYield(traversePattern(pattern, _regeneratorRuntime().mark(function _callee2(node, index, depth) {
		            return _regeneratorRuntime().wrap(function _callee2$(_context3) {
		              while (1) switch (_context3.prev = _context3.next) {
		                case 0:
		                  indexPath[depth] = index;
		                  if (!(isObjectProperty$1(node) && isPrivateName$1(node.key))) {
		                    _context3.next = 4;
		                    break;
		                  }
		                  _context3.next = 4;
		                  return indexPath.slice(1, depth + 1);
		                case 4:
		                case "end":
		                  return _context3.stop();
		              }
		            }, _callee2);
		          })), "t0", 2);
		        case 2:
		        case "end":
		          return _context4.stop();
		      }
		    }, _marked2);
		  }
		  function rightWillBeReferencedOnce(left) {
		    switch (left.type) {
		      case "Identifier":
		      case "ArrayPattern":
		        return true;
		      case "ObjectPattern":
		        return left.properties.length === 1;
		      default:
		        return false;
		    }
		  }
		  function transformPrivateKeyDestructuring(left, right, scope, isAssignment, shouldPreserveCompletion, addHelper, objectRestNoSymbols, useBuiltIns) {
		    var stack, rootRight, item, _item2, restExcludingKeys, _item3, _left, _right, searchPrivateKey, _ref2, properties, indexPath, indexPathIndex, _index2, isRightSafeToReuse, tempId, _left2, _properties, propertiesSlice, nextRestExcludingKeys, property, key, computed, leftElements, leftElementsAfterIndex, _buildAssignmentsFrom2, elements, transformed, i, _transformed$;
		    return _regeneratorRuntime().wrap(function transformPrivateKeyDestructuring$(_context5) {
		      while (1) switch (_context5.prev = _context5.next) {
		        case 0:
		          stack = [];
		          rootRight = right;
		          stack.push({
		            left: left,
		            right: right,
		            restExcludingKeys: initRestExcludingKeys(left)
		          });
		        case 3:
		          if (!((item = stack.pop()) !== undefined)) {
		            _context5.next = 65;
		            break;
		          }
		          _item2 = item, restExcludingKeys = _item2.restExcludingKeys;
		          _item3 = item, _left = _item3.left, _right = _item3.right;
		          searchPrivateKey = privateKeyPathIterator(_left).next();
		          if (!searchPrivateKey.done) {
		            _context5.next = 19;
		            break;
		          }
		          if (!((restExcludingKeys == null ? void 0 : restExcludingKeys.length) > 0)) {
		            _context5.next = 15;
		            break;
		          }
		          _ref2 = _left, properties = _ref2.properties;
		          if (properties.length === 1) {
		            _left = properties[0].argument;
		          }
		          _context5.next = 13;
		          return {
		            left: _left,
		            right: buildObjectExcludingKeys(restExcludingKeys, _right, scope, addHelper, objectRestNoSymbols, useBuiltIns)
		          };
		        case 13:
		          _context5.next = 17;
		          break;
		        case 15:
		          _context5.next = 17;
		          return {
		            left: _left,
		            right: _right
		          };
		        case 17:
		          _context5.next = 63;
		          break;
		        case 19:
		          indexPath = searchPrivateKey.value;
		          indexPathIndex = 0;
		        case 21:
		          if (!(indexPathIndex < indexPath.length && (_index2 = indexPath[indexPathIndex]) !== undefined || _left.type === "AssignmentPattern")) {
		            _context5.next = 62;
		            break;
		          }
		          isRightSafeToReuse = !(shouldPreserveCompletion && _right === rootRight) && (rightWillBeReferencedOnce(_left) || scope.isStatic(_right));
		          if (isRightSafeToReuse) {
		            _context5.next = 29;
		            break;
		          }
		          tempId = scope.generateUidIdentifier("m");
		          if (isAssignment) {
		            scope.push({
		              id: cloneNode$1(tempId)
		            });
		          }
		          _context5.next = 28;
		          return {
		            left: tempId,
		            right: _right
		          };
		        case 28:
		          _right = cloneNode$1(tempId);
		        case 29:
		          _context5.t0 = _left.type;
		          _context5.next = _context5.t0 === "ObjectPattern" ? 32 : _context5.t0 === "AssignmentPattern" ? 44 : _context5.t0 === "ArrayPattern" ? 47 : 58;
		          break;
		        case 32:
		          _left2 = _left, _properties = _left2.properties;
		          if (!(_index2 > 0)) {
		            _context5.next = 37;
		            break;
		          }
		          propertiesSlice = _properties.slice(0, _index2);
		          _context5.next = 37;
		          return {
		            left: objectPattern(propertiesSlice),
		            right: cloneNode$1(_right)
		          };
		        case 37:
		          if (_index2 < _properties.length - 1) {
		            nextRestExcludingKeys = indexPathIndex === 0 ? restExcludingKeys : initRestExcludingKeys(_left);
		            growRestExcludingKeys(nextRestExcludingKeys, _properties.slice(0, _index2 + 1), scope);
		            stack.push({
		              left: objectPattern(_properties.slice(_index2 + 1)),
		              right: cloneNode$1(_right),
		              restExcludingKeys: nextRestExcludingKeys
		            });
		          }
		          property = _properties[_index2];
		          _left = property.value;
		          key = property.key;
		          computed = property.computed || key.type !== "Identifier" && key.type !== "PrivateName";
		          _right = memberExpression$2(_right, key, computed);
		          return _context5.abrupt("break", 59);
		        case 44:
		          _right = transformAssignmentPattern(_left.right, _right);
		          _left = _left.left;
		          return _context5.abrupt("break", 59);
		        case 47:
		          leftElements = _left.elements;
		          leftElementsAfterIndex = leftElements.splice(_index2);
		          _buildAssignmentsFrom2 = buildAssignmentsFromPatternList(leftElementsAfterIndex, scope, isAssignment), elements = _buildAssignmentsFrom2.elements, transformed = _buildAssignmentsFrom2.transformed;
		          leftElements.push.apply(leftElements, _toConsumableArray(elements));
		          _context5.next = 53;
		          return {
		            left: _left,
		            right: cloneNode$1(_right)
		          };
		        case 53:
		          for (i = transformed.length - 1; i > 0; i--) {
		            if (transformed[i] !== null) {
		              stack.push(transformed[i]);
		            }
		          }
		          _transformed$ = transformed[0];
		          _left = _transformed$.left;
		          _right = _transformed$.right;
		          return _context5.abrupt("break", 59);
		        case 58:
		          return _context5.abrupt("break", 59);
		        case 59:
		          indexPathIndex++;
		          _context5.next = 21;
		          break;
		        case 62:
		          stack.push({
		            left: _left,
		            right: _right,
		            restExcludingKeys: initRestExcludingKeys(_left)
		          });
		        case 63:
		          _context5.next = 3;
		          break;
		        case 65:
		        case "end":
		          return _context5.stop();
		      }
		    }, _marked3);
		  }

		  var iifeVisitor = {
		    "ReferencedIdentifier|BindingIdentifier": function ReferencedIdentifierBindingIdentifier(path, state) {
		      var scope = path.scope,
		        node = path.node;
		      var name = node.name;
		      if (name === "eval" || scope.getBinding(name) === state.scope.parent.getBinding(name) && state.scope.hasOwnBinding(name)) {
		        state.needsOuterBinding = true;
		        path.stop();
		      }
		    },
		    "TypeAnnotation|TSTypeAnnotation|TypeParameterDeclaration|TSTypeParameterDeclaration": function TypeAnnotationTSTypeAnnotationTypeParameterDeclarationTSTypeParameterDeclaration(path) {
		      return path.skip();
		    }
		  };
		  function collectShadowedParamsNames(param, functionScope, shadowedParams) {
		    for (var _i = 0, _Object$keys = Object.keys(param.getBindingIdentifiers()); _i < _Object$keys.length; _i++) {
		      var _functionScope$bindin;
		      var name = _Object$keys[_i];
		      var constantViolations = (_functionScope$bindin = functionScope.bindings[name]) == null ? void 0 : _functionScope$bindin.constantViolations;
		      if (constantViolations) {
		        for (var _iterator = _createForOfIteratorHelperLoose(constantViolations), _step; !(_step = _iterator()).done;) {
		          var redeclarator = _step.value;
		          var node = redeclarator.node;
		          switch (node.type) {
		            case "VariableDeclarator":
		              {
		                if (node.init === null) {
		                  var declaration = redeclarator.parentPath;
		                  if (!declaration.parentPath.isFor() || declaration.parentPath.get("body") === declaration) {
		                    redeclarator.remove();
		                    break;
		                  }
		                }
		                shadowedParams.add(name);
		                break;
		              }
		            case "FunctionDeclaration":
		              shadowedParams.add(name);
		              break;
		          }
		        }
		      }
		    }
		  }
		  function buildScopeIIFE(shadowedParams, body) {
		    var args = [];
		    var params = [];
		    for (var _iterator2 = _createForOfIteratorHelperLoose(shadowedParams), _step2; !(_step2 = _iterator2()).done;) {
		      var name = _step2.value;
		      args.push(identifier$j(name));
		      params.push(identifier$j(name));
		    }
		    return returnStatement$3(callExpression$d(arrowFunctionExpression$4(params, body), args));
		  }

		  var _templateObject$q;
		  var buildDefaultParam = template$1.statement("\n  let VARIABLE_NAME =\n    arguments.length > ARGUMENT_KEY && arguments[ARGUMENT_KEY] !== undefined ?\n      arguments[ARGUMENT_KEY]\n    :\n      DEFAULT_VALUE;\n");
		  var buildLooseDefaultParam = template$1.statement("\n  if (ASSIGNMENT_IDENTIFIER === UNDEFINED) {\n    ASSIGNMENT_IDENTIFIER = DEFAULT_VALUE;\n  }\n");
		  var buildLooseDestructuredDefaultParam = template$1.statement("\n  let ASSIGNMENT_IDENTIFIER = PARAMETER_NAME === UNDEFINED ? DEFAULT_VALUE : PARAMETER_NAME ;\n");
		  var buildSafeArgumentsAccess = template$1.statement("\n  let $0 = arguments.length > $1 ? arguments[$1] : undefined;\n");
		  function convertFunctionParams(path, ignoreFunctionLength, shouldTransformParam, replaceRestElement) {
		    var params = path.get("params");
		    var isSimpleParameterList = params.every(function (param) {
		      return param.isIdentifier();
		    });
		    if (isSimpleParameterList) return false;
		    var node = path.node,
		      scope = path.scope;
		    var body = [];
		    var shadowedParams = new Set();
		    for (var _iterator = _createForOfIteratorHelperLoose(params), _step; !(_step = _iterator()).done;) {
		      var _param2 = _step.value;
		      collectShadowedParamsNames(_param2, scope, shadowedParams);
		    }
		    var state = {
		      needsOuterBinding: false,
		      scope: scope
		    };
		    if (shadowedParams.size === 0) {
		      for (var _iterator2 = _createForOfIteratorHelperLoose(params), _step2; !(_step2 = _iterator2()).done;) {
		        var param = _step2.value;
		        if (!param.isIdentifier()) param.traverse(iifeVisitor, state);
		        if (state.needsOuterBinding) break;
		      }
		    }
		    var firstOptionalIndex = null;
		    for (var i = 0; i < params.length; i++) {
		      var _param = params[i];
		      if (shouldTransformParam && !shouldTransformParam(i)) {
		        continue;
		      }
		      var _transformedRestNodes = [];
		      if (replaceRestElement) {
		        replaceRestElement(path, _param, _transformedRestNodes);
		      }
		      var paramIsAssignmentPattern = _param.isAssignmentPattern();
		      if (paramIsAssignmentPattern && (ignoreFunctionLength || isMethod$1(node, {
		        kind: "set"
		      }))) {
		        var left = _param.get("left");
		        var right = _param.get("right");
		        var undefinedNode = scope.buildUndefinedNode();
		        if (left.isIdentifier()) {
		          body.push(buildLooseDefaultParam({
		            ASSIGNMENT_IDENTIFIER: cloneNode$j(left.node),
		            DEFAULT_VALUE: right.node,
		            UNDEFINED: undefinedNode
		          }));
		          _param.replaceWith(left.node);
		        } else if (left.isObjectPattern() || left.isArrayPattern()) {
		          var paramName = scope.generateUidIdentifier();
		          body.push(buildLooseDestructuredDefaultParam({
		            ASSIGNMENT_IDENTIFIER: left.node,
		            DEFAULT_VALUE: right.node,
		            PARAMETER_NAME: cloneNode$j(paramName),
		            UNDEFINED: undefinedNode
		          }));
		          _param.replaceWith(paramName);
		        }
		      } else if (paramIsAssignmentPattern) {
		        if (firstOptionalIndex === null) firstOptionalIndex = i;
		        var _left = _param.get("left");
		        var _right = _param.get("right");
		        var defNode = buildDefaultParam({
		          VARIABLE_NAME: _left.node,
		          DEFAULT_VALUE: _right.node,
		          ARGUMENT_KEY: numericLiteral$8(i)
		        });
		        body.push(defNode);
		      } else if (firstOptionalIndex !== null) {
		        var _defNode = buildSafeArgumentsAccess([_param.node, numericLiteral$8(i)]);
		        body.push(_defNode);
		      } else if (_param.isObjectPattern() || _param.isArrayPattern()) {
		        var uid = path.scope.generateUidIdentifier("ref");
		        uid.typeAnnotation = _param.node.typeAnnotation;
		        var _defNode2 = variableDeclaration$8("let", [variableDeclarator$8(_param.node, uid)]);
		        body.push(_defNode2);
		        _param.replaceWith(cloneNode$j(uid));
		      }
		      if (_transformedRestNodes) {
		        for (var _iterator3 = _createForOfIteratorHelperLoose(_transformedRestNodes), _step3; !(_step3 = _iterator3()).done;) {
		          var transformedNode = _step3.value;
		          body.push(transformedNode);
		        }
		      }
		    }
		    if (firstOptionalIndex !== null) {
		      node.params = node.params.slice(0, firstOptionalIndex);
		    }
		    path.ensureBlock();
		    var path2 = path;
		    var async = node.async,
		      generator = node.generator;
		    if (generator || state.needsOuterBinding || shadowedParams.size > 0) {
		      body.push(buildScopeIIFE(shadowedParams, path2.node.body));
		      path.set("body", blockStatement$6(body));
		      var bodyPath = path2.get("body.body");
		      var arrowPath = bodyPath[bodyPath.length - 1].get("argument.callee");
		      arrowPath.arrowFunctionToExpression();
		      arrowPath.node.generator = generator;
		      arrowPath.node.async = async;
		      node.generator = false;
		      node.async = false;
		      if (async) {
		        path2.node.body = template$1.statement.ast(_templateObject$q || (_templateObject$q = _taggedTemplateLiteralLoose(["{\n        try {\n          ", "\n        } catch (e) {\n          return Promise.reject(e);\n        }\n      }"])), path2.node.body.body);
		      }
		    } else {
		      path2.get("body").unshiftContainer("body", body);
		    }
		    return true;
		  }

		  var buildRest = template$1.statement("\n  for (var LEN = ARGUMENTS.length,\n           ARRAY = new Array(ARRAY_LEN),\n           KEY = START;\n       KEY < LEN;\n       KEY++) {\n    ARRAY[ARRAY_KEY] = ARGUMENTS[KEY];\n  }\n");
		  var restIndex = template$1.expression("\n  (INDEX < OFFSET || ARGUMENTS.length <= INDEX) ? undefined : ARGUMENTS[INDEX]\n");
		  var restIndexImpure = template$1.expression("\n  REF = INDEX, (REF < OFFSET || ARGUMENTS.length <= REF) ? undefined : ARGUMENTS[REF]\n");
		  var restLength = template$1.expression("\n  ARGUMENTS.length <= OFFSET ? 0 : ARGUMENTS.length - OFFSET\n");
		  function referencesRest(path, state) {
		    if (path.node.name === state.name) {
		      return path.scope.bindingIdentifierEquals(state.name, state.outerBinding);
		    }
		    return false;
		  }
		  var memberExpressionOptimisationVisitor = {
		    Scope: function Scope(path, state) {
		      if (!path.scope.bindingIdentifierEquals(state.name, state.outerBinding)) {
		        path.skip();
		      }
		    },
		    Flow: function (_Flow) {
		      function Flow(_x) {
		        return _Flow.apply(this, arguments);
		      }
		      Flow.toString = function () {
		        return _Flow.toString();
		      };
		      return Flow;
		    }(function (path) {
		      if (path.isTypeCastExpression()) return;
		      path.skip();
		    }),
		    Function: function Function(path, state) {
		      var oldNoOptimise = state.noOptimise;
		      state.noOptimise = true;
		      path.traverse(memberExpressionOptimisationVisitor, state);
		      state.noOptimise = oldNoOptimise;
		      path.skip();
		    },
		    ReferencedIdentifier: function ReferencedIdentifier(path, state) {
		      var node = path.node;
		      if (node.name === "arguments") {
		        state.deopted = true;
		      }
		      if (!referencesRest(path, state)) return;
		      if (state.noOptimise) {
		        state.deopted = true;
		      } else {
		        var parentPath = path.parentPath;
		        if (parentPath.listKey === "params" && parentPath.key < state.offset) {
		          return;
		        }
		        if (parentPath.isMemberExpression({
		          object: node
		        })) {
		          var grandparentPath = parentPath.parentPath;
		          var argsOptEligible = !state.deopted && !(grandparentPath.isAssignmentExpression() && parentPath.node === grandparentPath.node.left || grandparentPath.isLVal() || grandparentPath.isForXStatement() || grandparentPath.isUpdateExpression() || grandparentPath.isUnaryExpression({
		            operator: "delete"
		          }) || (grandparentPath.isCallExpression() || grandparentPath.isNewExpression()) && parentPath.node === grandparentPath.node.callee);
		          if (argsOptEligible) {
		            if (parentPath.node.computed) {
		              if (parentPath.get("property").isBaseType("number")) {
		                state.candidates.push({
		                  cause: "indexGetter",
		                  path: path
		                });
		                return;
		              }
		            } else if (parentPath.node.property.name === "length") {
		              state.candidates.push({
		                cause: "lengthGetter",
		                path: path
		              });
		              return;
		            }
		          }
		        }
		        if (state.offset === 0 && parentPath.isSpreadElement()) {
		          var call = parentPath.parentPath;
		          if (call.isCallExpression() && call.node.arguments.length === 1) {
		            state.candidates.push({
		              cause: "argSpread",
		              path: path
		            });
		            return;
		          }
		        }
		        state.references.push(path);
		      }
		    },
		    BindingIdentifier: function BindingIdentifier(path, state) {
		      if (referencesRest(path, state)) {
		        state.deopted = true;
		      }
		    }
		  };
		  function getParamsCount(node) {
		    var count = node.params.length;
		    if (count > 0 && isIdentifier$i(node.params[0], {
		      name: "this"
		    })) {
		      count -= 1;
		    }
		    return count;
		  }
		  function hasRest(node) {
		    var length = node.params.length;
		    return length > 0 && isRestElement$2(node.params[length - 1]);
		  }
		  function optimiseIndexGetter(path, argsId, offset) {
		    var offsetLiteral = numericLiteral$8(offset);
		    var index;
		    var parent = path.parent;
		    if (isNumericLiteral(parent.property)) {
		      index = numericLiteral$8(parent.property.value + offset);
		    } else if (offset === 0) {
		      index = parent.property;
		    } else {
		      index = binaryExpression$5("+", parent.property, cloneNode$j(offsetLiteral));
		    }
		    var scope = path.scope,
		      parentPath = path.parentPath;
		    if (!scope.isPure(index)) {
		      var temp = scope.generateUidIdentifierBasedOnNode(index);
		      scope.push({
		        id: temp,
		        kind: "var"
		      });
		      parentPath.replaceWith(restIndexImpure({
		        ARGUMENTS: argsId,
		        OFFSET: offsetLiteral,
		        INDEX: index,
		        REF: cloneNode$j(temp)
		      }));
		    } else {
		      parentPath.replaceWith(restIndex({
		        ARGUMENTS: argsId,
		        OFFSET: offsetLiteral,
		        INDEX: index
		      }));
		      var replacedParentPath = parentPath;
		      var offsetTestPath = replacedParentPath.get("test");
		      var valRes = offsetTestPath.get("left").evaluate();
		      if (valRes.confident) {
		        if (valRes.value === true) {
		          replacedParentPath.replaceWith(scope.buildUndefinedNode());
		        } else {
		          offsetTestPath.replaceWith(offsetTestPath.get("right"));
		        }
		      }
		    }
		  }
		  function optimiseLengthGetter(path, argsId, offset) {
		    if (offset) {
		      path.parentPath.replaceWith(restLength({
		        ARGUMENTS: argsId,
		        OFFSET: numericLiteral$8(offset)
		      }));
		    } else {
		      path.replaceWith(argsId);
		    }
		  }
		  function convertFunctionRest(path) {
		    var _state$references;
		    var node = path.node,
		      scope = path.scope;
		    if (!hasRest(node)) return false;
		    var restPath = path.get("params." + (node.params.length - 1) + ".argument");
		    if (!restPath.isIdentifier()) {
		      var shadowedParams = new Set();
		      collectShadowedParamsNames(restPath, path.scope, shadowedParams);
		      var needsIIFE = shadowedParams.size > 0;
		      if (!needsIIFE) {
		        var _state = {
		          needsOuterBinding: false,
		          scope: scope
		        };
		        restPath.traverse(iifeVisitor, _state);
		        needsIIFE = _state.needsOuterBinding;
		      }
		      if (needsIIFE) {
		        path.ensureBlock();
		        path.set("body", blockStatement$6([buildScopeIIFE(shadowedParams, path.node.body)]));
		      }
		    }
		    var rest = restPath.node;
		    node.params.pop();
		    if (isPattern(rest)) {
		      var pattern = rest;
		      rest = scope.generateUidIdentifier("ref");
		      var declar = variableDeclaration$8("let", [variableDeclarator$8(pattern, rest)]);
		      path.ensureBlock();
		      node.body.body.unshift(declar);
		    } else if (rest.name === "arguments") {
		      scope.rename(rest.name);
		    }
		    var argsId = identifier$j("arguments");
		    var paramsCount = getParamsCount(node);
		    var state = {
		      references: [],
		      offset: paramsCount,
		      argumentsNode: argsId,
		      outerBinding: scope.getBindingIdentifier(rest.name),
		      candidates: [],
		      name: rest.name,
		      deopted: false
		    };
		    path.traverse(memberExpressionOptimisationVisitor, state);
		    if (!state.deopted && !state.references.length) {
		      for (var _iterator = _createForOfIteratorHelperLoose(state.candidates), _step; !(_step = _iterator()).done;) {
		        var _step$value = _step.value,
		          _path = _step$value.path,
		          cause = _step$value.cause;
		        var clonedArgsId = cloneNode$j(argsId);
		        switch (cause) {
		          case "indexGetter":
		            optimiseIndexGetter(_path, clonedArgsId, state.offset);
		            break;
		          case "lengthGetter":
		            optimiseLengthGetter(_path, clonedArgsId, state.offset);
		            break;
		          default:
		            _path.replaceWith(clonedArgsId);
		        }
		      }
		      return true;
		    }
		    (_state$references = state.references).push.apply(_state$references, _toConsumableArray(state.candidates.map(function (_ref) {
		      var path = _ref.path;
		      return path;
		    })));
		    var start = numericLiteral$8(paramsCount);
		    var key = scope.generateUidIdentifier("key");
		    var len = scope.generateUidIdentifier("len");
		    var arrKey, arrLen;
		    if (paramsCount) {
		      arrKey = binaryExpression$5("-", cloneNode$j(key), cloneNode$j(start));
		      arrLen = conditionalExpression$5(binaryExpression$5(">", cloneNode$j(len), cloneNode$j(start)), binaryExpression$5("-", cloneNode$j(len), cloneNode$j(start)), numericLiteral$8(0));
		    } else {
		      arrKey = identifier$j(key.name);
		      arrLen = identifier$j(len.name);
		    }
		    var loop = buildRest({
		      ARGUMENTS: argsId,
		      ARRAY_KEY: arrKey,
		      ARRAY_LEN: arrLen,
		      START: start,
		      ARRAY: rest,
		      KEY: key,
		      LEN: len
		    });
		    if (state.deopted) {
		      node.body.body.unshift(loop);
		    } else {
		      var target = path.getEarliestCommonAncestorFrom(state.references).getStatementParent();
		      target.findParent(function (path) {
		        if (path.isLoop()) {
		          target = path;
		        } else {
		          return path.isFunction();
		        }
		      });
		      target.insertBefore(loop);
		    }
		    return true;
		  }

		  var _transformParameters = declare(function (api, options) {
		    var _api$assumption, _api$assumption2;
		    api.assertVersion("*");
		    var ignoreFunctionLength = (_api$assumption = api.assumption("ignoreFunctionLength")) != null ? _api$assumption : options.loose;
		    var noNewArrows = (_api$assumption2 = api.assumption("noNewArrows")) != null ? _api$assumption2 : true;
		    return {
		      name: "transform-parameters",
		      visitor: {
		        Function: function Function(path) {
		          if (path.isArrowFunctionExpression() && path.get("params").some(function (param) {
		            return param.isRestElement() || param.isAssignmentPattern();
		          })) {
		            path.arrowFunctionToExpression({
		              allowInsertArrowWithRest: false,
		              noNewArrows: noNewArrows
		            });
		            if (!path.isFunctionExpression()) return;
		          }
		          var convertedRest = convertFunctionRest(path);
		          var convertedParams = convertFunctionParams(path, ignoreFunctionLength);
		          if (convertedRest || convertedParams) {
		            path.scope.crawl();
		          }
		        }
		      }
		    };
		  });

		  var proposalDestructuringPrivate = declare(function (_ref) {
		    var assertVersion = _ref.assertVersion,
		      assumption = _ref.assumption,
		      t = _ref.types;
		    assertVersion("*");
		    var assignmentExpression = t.assignmentExpression,
		      assignmentPattern = t.assignmentPattern,
		      cloneNode = t.cloneNode,
		      expressionStatement = t.expressionStatement,
		      isExpressionStatement = t.isExpressionStatement,
		      isIdentifier = t.isIdentifier,
		      isSequenceExpression = t.isSequenceExpression,
		      sequenceExpression = t.sequenceExpression,
		      variableDeclaration = t.variableDeclaration,
		      variableDeclarator = t.variableDeclarator;
		    var ignoreFunctionLength = assumption("ignoreFunctionLength");
		    var objectRestNoSymbols = assumption("objectRestNoSymbols");
		    var privateKeyDestructuringVisitor = {
		      Function: function Function(path) {
		        var firstPrivateIndex = path.node.params.findIndex(function (param) {
		          return hasPrivateKeys(param);
		        });
		        if (firstPrivateIndex === -1) return;
		        convertFunctionParams(path, ignoreFunctionLength, function () {
		          return false;
		        });
		        var node = path.node,
		          scope = path.scope;
		        var params = node.params;
		        var firstAssignmentPatternIndex = ignoreFunctionLength ? -1 : params.findIndex(function (param) {
		          return param.type === "AssignmentPattern";
		        });
		        var paramsAfterIndex = params.splice(firstPrivateIndex);
		        var _buildVariableDeclara = buildVariableDeclarationFromParams(paramsAfterIndex, scope),
		          transformedParams = _buildVariableDeclara.params,
		          variableDeclaration = _buildVariableDeclara.variableDeclaration;
		        path.get("body").unshiftContainer("body", variableDeclaration);
		        params.push.apply(params, _toConsumableArray(transformedParams));
		        if (firstAssignmentPatternIndex >= firstPrivateIndex) {
		          params[firstAssignmentPatternIndex] = assignmentPattern(params[firstAssignmentPatternIndex], scope.buildUndefinedNode());
		        }
		        scope.crawl();
		      },
		      CatchClause: function CatchClause(path) {
		        var node = path.node,
		          scope = path.scope;
		        if (!hasPrivateKeys(node.param)) return;
		        var ref = scope.generateUidIdentifier("e");
		        path.get("body").unshiftContainer("body", variableDeclaration("let", [variableDeclarator(node.param, ref)]));
		        node.param = cloneNode(ref);
		        scope.crawl();
		      },
		      ForXStatement: function ForXStatement(path) {
		        var node = path.node,
		          scope = path.scope;
		        var leftPath = path.get("left");
		        if (leftPath.isVariableDeclaration()) {
		          var left = leftPath.node;
		          if (!hasPrivateKeys(left.declarations[0].id)) return;
		          var temp = scope.generateUidIdentifier("ref");
		          node.left = variableDeclaration(left.kind, [variableDeclarator(temp, null)]);
		          left.declarations[0].init = cloneNode(temp);
		          unshiftForXStatementBody(path, [left]);
		          scope.crawl();
		        } else if (leftPath.isPattern()) {
		          if (!hasPrivateKeys(leftPath.node)) return;
		          var _temp = scope.generateUidIdentifier("ref");
		          node.left = variableDeclaration("const", [variableDeclarator(_temp, null)]);
		          var assignExpr = expressionStatement(assignmentExpression("=", leftPath.node, cloneNode(_temp)));
		          unshiftForXStatementBody(path, [assignExpr]);
		          scope.crawl();
		        }
		      },
		      VariableDeclaration: function VariableDeclaration(path, state) {
		        var scope = path.scope,
		          node = path.node;
		        var declarations = node.declarations;
		        if (!declarations.some(function (declarator) {
		          return hasPrivateKeys(declarator.id);
		        })) {
		          return;
		        }
		        var newDeclarations = [];
		        for (var _iterator = _createForOfIteratorHelperLoose(declarations), _step; !(_step = _iterator()).done;) {
		          var declarator = _step.value;
		          for (var _iterator2 = _createForOfIteratorHelperLoose(transformPrivateKeyDestructuring(declarator.id, declarator.init, scope, false, false, function (name) {
		              return state.addHelper(name);
		            }, objectRestNoSymbols, true)), _step2; !(_step2 = _iterator2()).done;) {
		            var _step2$value = _step2.value,
		              left = _step2$value.left,
		              right = _step2$value.right;
		            newDeclarations.push(variableDeclarator(left, right));
		          }
		        }
		        node.declarations = newDeclarations;
		        scope.crawl();
		      },
		      AssignmentExpression: function AssignmentExpression(path, state) {
		        var node = path.node,
		          scope = path.scope,
		          parent = path.parent;
		        if (!hasPrivateKeys(node.left)) return;
		        var assignments = [];
		        var shouldPreserveCompletion = !isExpressionStatement(parent) && !isSequenceExpression(parent) || path.isCompletionRecord();
		        for (var _iterator3 = _createForOfIteratorHelperLoose(transformPrivateKeyDestructuring(node.left, node.right, scope, true, shouldPreserveCompletion, function (name) {
		            return state.addHelper(name);
		          }, objectRestNoSymbols, true)), _step3; !(_step3 = _iterator3()).done;) {
		          var _step3$value = _step3.value,
		            _left = _step3$value.left,
		            _right = _step3$value.right;
		          assignments.push(assignmentExpression("=", _left, _right));
		        }
		        if (shouldPreserveCompletion) {
		          var _assignments$ = assignments[0],
		            left = _assignments$.left,
		            right = _assignments$.right;
		          if (isIdentifier(left) && right === node.right) {
		            if (!isIdentifier(assignments[assignments.length - 1].right, {
		              name: left.name
		            })) {
		              assignments.push(cloneNode(left));
		            }
		          } else {
		            var tempId = scope.generateDeclaredUidIdentifier("m");
		            assignments.unshift(assignmentExpression("=", tempId, cloneNode(node.right)));
		            assignments.push(cloneNode(tempId));
		          }
		        }
		        path.replaceWith(sequenceExpression(assignments));
		        scope.crawl();
		      }
		    };
		    var visitor = {
		      Class: function Class(path, state) {
		        if (!hasPrivateClassElement(path.node.body)) return;
		        path.traverse(privateKeyDestructuringVisitor, state);
		      }
		    };
		    return {
		      name: "proposal-destructuring-private",
		      inherits: syntaxDestructuringPrivate,
		      visitor: visitor
		    };
		  });

		  var proposalDoExpressions = declare(function (api) {
		    api.assertVersion("*");
		    return {
		      name: "proposal-do-expressions",
		      inherits: syntaxDoExpressions,
		      visitor: {
		        DoExpression: {
		          exit: function exit(path) {
		            var node = path.node;
		            if (node.async) {
		              return;
		            }
		            var body = node.body.body;
		            if (body.length) {
		              path.replaceExpressionWithStatements(body);
		            } else {
		              path.replaceWith(path.scope.buildUndefinedNode());
		            }
		          }
		        }
		      }
		    };
		  });

		  var Alphabetic = {};

		  var regenerate$2 = {exports: {}};

		  regenerate$2.exports;
		  (function (module, exports) {
		    (function (root) {
		      var freeExports = exports;
		      var freeModule = module && module.exports == freeExports && module;
		      var freeGlobal = typeof commonjsGlobal$1 == 'object' && commonjsGlobal$1;
		      if (freeGlobal.global === freeGlobal || freeGlobal.window === freeGlobal) {
		        root = freeGlobal;
		      }
		      var ERRORS = {
		        'rangeOrder': "A range\u2019s `stop` value must be greater than or equal " + 'to the `start` value.',
		        'codePointRange': 'Invalid code point value. Code points range from ' + 'U+000000 to U+10FFFF.'
		      };
		      var HIGH_SURROGATE_MIN = 0xD800;
		      var HIGH_SURROGATE_MAX = 0xDBFF;
		      var LOW_SURROGATE_MIN = 0xDC00;
		      var LOW_SURROGATE_MAX = 0xDFFF;
		      var regexNull = /\\x00([^0123456789]|$)/g;
		      var object = {};
		      var hasOwnProperty = object.hasOwnProperty;
		      var extend = function extend(destination, source) {
		        var key;
		        for (key in source) {
		          if (hasOwnProperty.call(source, key)) {
		            destination[key] = source[key];
		          }
		        }
		        return destination;
		      };
		      var forEach = function forEach(array, callback) {
		        var index = -1;
		        var length = array.length;
		        while (++index < length) {
		          callback(array[index], index);
		        }
		      };
		      var toString = object.toString;
		      var isArray = function isArray(value) {
		        return toString.call(value) == '[object Array]';
		      };
		      var isNumber = function isNumber(value) {
		        return typeof value == 'number' || toString.call(value) == '[object Number]';
		      };
		      var zeroes = '0000';
		      var pad = function pad(number, totalCharacters) {
		        var string = String(number);
		        return string.length < totalCharacters ? (zeroes + string).slice(-totalCharacters) : string;
		      };
		      var hex = function hex(number) {
		        return Number(number).toString(16).toUpperCase();
		      };
		      var slice = [].slice;
		      var dataFromCodePoints = function dataFromCodePoints(codePoints) {
		        var index = -1;
		        var length = codePoints.length;
		        var max = length - 1;
		        var result = [];
		        var isStart = true;
		        var tmp;
		        var previous = 0;
		        while (++index < length) {
		          tmp = codePoints[index];
		          if (isStart) {
		            result.push(tmp);
		            previous = tmp;
		            isStart = false;
		          } else {
		            if (tmp == previous + 1) {
		              if (index != max) {
		                previous = tmp;
		                continue;
		              } else {
		                isStart = true;
		                result.push(tmp + 1);
		              }
		            } else {
		              result.push(previous + 1, tmp);
		              previous = tmp;
		            }
		          }
		        }
		        if (!isStart) {
		          result.push(tmp + 1);
		        }
		        return result;
		      };
		      var dataRemove = function dataRemove(data, codePoint) {
		        var index = 0;
		        var start;
		        var end;
		        var length = data.length;
		        while (index < length) {
		          start = data[index];
		          end = data[index + 1];
		          if (codePoint >= start && codePoint < end) {
		            if (codePoint == start) {
		              if (end == start + 1) {
		                data.splice(index, 2);
		                return data;
		              } else {
		                data[index] = codePoint + 1;
		                return data;
		              }
		            } else if (codePoint == end - 1) {
		              data[index + 1] = codePoint;
		              return data;
		            } else {
		              data.splice(index, 2, start, codePoint, codePoint + 1, end);
		              return data;
		            }
		          }
		          index += 2;
		        }
		        return data;
		      };
		      var dataRemoveRange = function dataRemoveRange(data, rangeStart, rangeEnd) {
		        if (rangeEnd < rangeStart) {
		          throw Error(ERRORS.rangeOrder);
		        }
		        var index = 0;
		        var start;
		        var end;
		        while (index < data.length) {
		          start = data[index];
		          end = data[index + 1] - 1;
		          if (start > rangeEnd) {
		            return data;
		          }
		          if (rangeStart <= start && rangeEnd >= end) {
		            data.splice(index, 2);
		            continue;
		          }
		          if (rangeStart >= start && rangeEnd < end) {
		            if (rangeStart == start) {
		              data[index] = rangeEnd + 1;
		              data[index + 1] = end + 1;
		              return data;
		            }
		            data.splice(index, 2, start, rangeStart, rangeEnd + 1, end + 1);
		            return data;
		          }
		          if (rangeStart >= start && rangeStart <= end) {
		            data[index + 1] = rangeStart;
		          } else if (rangeEnd >= start && rangeEnd <= end) {
		            data[index] = rangeEnd + 1;
		            return data;
		          }
		          index += 2;
		        }
		        return data;
		      };
		      var dataAdd = function dataAdd(data, codePoint) {
		        var index = 0;
		        var start;
		        var end;
		        var lastIndex = null;
		        var length = data.length;
		        if (codePoint < 0x0 || codePoint > 0x10FFFF) {
		          throw RangeError(ERRORS.codePointRange);
		        }
		        while (index < length) {
		          start = data[index];
		          end = data[index + 1];
		          if (codePoint >= start && codePoint < end) {
		            return data;
		          }
		          if (codePoint == start - 1) {
		            data[index] = codePoint;
		            return data;
		          }
		          if (start > codePoint) {
		            data.splice(lastIndex != null ? lastIndex + 2 : 0, 0, codePoint, codePoint + 1);
		            return data;
		          }
		          if (codePoint == end) {
		            if (codePoint + 1 == data[index + 2]) {
		              data.splice(index, 4, start, data[index + 3]);
		              return data;
		            }
		            data[index + 1] = codePoint + 1;
		            return data;
		          }
		          lastIndex = index;
		          index += 2;
		        }
		        data.push(codePoint, codePoint + 1);
		        return data;
		      };
		      var dataAddData = function dataAddData(dataA, dataB) {
		        var index = 0;
		        var start;
		        var end;
		        var data = dataA.slice();
		        var length = dataB.length;
		        while (index < length) {
		          start = dataB[index];
		          end = dataB[index + 1] - 1;
		          if (start == end) {
		            data = dataAdd(data, start);
		          } else {
		            data = dataAddRange(data, start, end);
		          }
		          index += 2;
		        }
		        return data;
		      };
		      var dataRemoveData = function dataRemoveData(dataA, dataB) {
		        var index = 0;
		        var start;
		        var end;
		        var data = dataA.slice();
		        var length = dataB.length;
		        while (index < length) {
		          start = dataB[index];
		          end = dataB[index + 1] - 1;
		          if (start == end) {
		            data = dataRemove(data, start);
		          } else {
		            data = dataRemoveRange(data, start, end);
		          }
		          index += 2;
		        }
		        return data;
		      };
		      var dataAddRange = function dataAddRange(data, rangeStart, rangeEnd) {
		        if (rangeEnd < rangeStart) {
		          throw Error(ERRORS.rangeOrder);
		        }
		        if (rangeStart < 0x0 || rangeStart > 0x10FFFF || rangeEnd < 0x0 || rangeEnd > 0x10FFFF) {
		          throw RangeError(ERRORS.codePointRange);
		        }
		        var index = 0;
		        var start;
		        var end;
		        var added = false;
		        var length = data.length;
		        while (index < length) {
		          start = data[index];
		          end = data[index + 1];
		          if (added) {
		            if (start == rangeEnd + 1) {
		              data.splice(index - 1, 2);
		              return data;
		            }
		            if (start > rangeEnd) {
		              return data;
		            }
		            if (start >= rangeStart && start <= rangeEnd) {
		              if (end > rangeStart && end - 1 <= rangeEnd) {
		                data.splice(index, 2);
		                index -= 2;
		              } else {
		                data.splice(index - 1, 2);
		                index -= 2;
		              }
		            }
		          } else if (start == rangeEnd + 1 || start == rangeEnd) {
		            data[index] = rangeStart;
		            return data;
		          } else if (start > rangeEnd) {
		            data.splice(index, 0, rangeStart, rangeEnd + 1);
		            return data;
		          } else if (rangeStart >= start && rangeStart < end && rangeEnd + 1 <= end) {
		            return data;
		          } else if (rangeStart >= start && rangeStart < end || end == rangeStart) {
		            data[index + 1] = rangeEnd + 1;
		            added = true;
		          } else if (rangeStart <= start && rangeEnd + 1 >= end) {
		            data[index] = rangeStart;
		            data[index + 1] = rangeEnd + 1;
		            added = true;
		          }
		          index += 2;
		        }
		        if (!added) {
		          data.push(rangeStart, rangeEnd + 1);
		        }
		        return data;
		      };
		      var dataContains = function dataContains(data, codePoint) {
		        var index = 0;
		        var length = data.length;
		        var start = data[index];
		        var end = data[length - 1];
		        if (length >= 2) {
		          if (codePoint < start || codePoint > end) {
		            return false;
		          }
		        }
		        while (index < length) {
		          start = data[index];
		          end = data[index + 1];
		          if (codePoint >= start && codePoint < end) {
		            return true;
		          }
		          index += 2;
		        }
		        return false;
		      };
		      var dataIntersection = function dataIntersection(data, codePoints) {
		        var index = 0;
		        var length = codePoints.length;
		        var codePoint;
		        var result = [];
		        while (index < length) {
		          codePoint = codePoints[index];
		          if (dataContains(data, codePoint)) {
		            result.push(codePoint);
		          }
		          ++index;
		        }
		        return dataFromCodePoints(result);
		      };
		      var dataIsEmpty = function dataIsEmpty(data) {
		        return !data.length;
		      };
		      var dataIsSingleton = function dataIsSingleton(data) {
		        return data.length == 2 && data[0] + 1 == data[1];
		      };
		      var dataToArray = function dataToArray(data) {
		        var index = 0;
		        var start;
		        var end;
		        var result = [];
		        var length = data.length;
		        while (index < length) {
		          start = data[index];
		          end = data[index + 1];
		          while (start < end) {
		            result.push(start);
		            ++start;
		          }
		          index += 2;
		        }
		        return result;
		      };
		      var floor = Math.floor;
		      var highSurrogate = function highSurrogate(codePoint) {
		        return parseInt(floor((codePoint - 0x10000) / 0x400) + HIGH_SURROGATE_MIN, 10);
		      };
		      var lowSurrogate = function lowSurrogate(codePoint) {
		        return parseInt((codePoint - 0x10000) % 0x400 + LOW_SURROGATE_MIN, 10);
		      };
		      var stringFromCharCode = String.fromCharCode;
		      var codePointToString = function codePointToString(codePoint) {
		        var string;
		        if (codePoint == 0x09) {
		          string = '\\t';
		        } else if (codePoint == 0x0A) {
		          string = '\\n';
		        } else if (codePoint == 0x0C) {
		          string = '\\f';
		        } else if (codePoint == 0x0D) {
		          string = '\\r';
		        } else if (codePoint == 0x2D) {
		          string = '\\x2D';
		        } else if (codePoint == 0x5C) {
		          string = '\\\\';
		        } else if (codePoint == 0x24 || codePoint >= 0x28 && codePoint <= 0x2B || codePoint == 0x2E || codePoint == 0x2F || codePoint == 0x3F || codePoint >= 0x5B && codePoint <= 0x5E || codePoint >= 0x7B && codePoint <= 0x7D) {
		          string = '\\' + stringFromCharCode(codePoint);
		        } else if (codePoint >= 0x20 && codePoint <= 0x7E) {
		          string = stringFromCharCode(codePoint);
		        } else if (codePoint <= 0xFF) {
		          string = '\\x' + pad(hex(codePoint), 2);
		        } else {
		          string = "\\u" + pad(hex(codePoint), 4);
		        }
		        return string;
		      };
		      var codePointToStringUnicode = function codePointToStringUnicode(codePoint) {
		        if (codePoint <= 0xFFFF) {
		          return codePointToString(codePoint);
		        }
		        return "\\u{" + codePoint.toString(16).toUpperCase() + '}';
		      };
		      var symbolToCodePoint = function symbolToCodePoint(symbol) {
		        var length = symbol.length;
		        var first = symbol.charCodeAt(0);
		        var second;
		        if (first >= HIGH_SURROGATE_MIN && first <= HIGH_SURROGATE_MAX && length > 1) {
		          second = symbol.charCodeAt(1);
		          return (first - HIGH_SURROGATE_MIN) * 0x400 + second - LOW_SURROGATE_MIN + 0x10000;
		        }
		        return first;
		      };
		      var createBMPCharacterClasses = function createBMPCharacterClasses(data) {
		        var result = '';
		        var index = 0;
		        var start;
		        var end;
		        var length = data.length;
		        if (dataIsSingleton(data)) {
		          return codePointToString(data[0]);
		        }
		        while (index < length) {
		          start = data[index];
		          end = data[index + 1] - 1;
		          if (start == end) {
		            result += codePointToString(start);
		          } else if (start + 1 == end) {
		            result += codePointToString(start) + codePointToString(end);
		          } else {
		            result += codePointToString(start) + '-' + codePointToString(end);
		          }
		          index += 2;
		        }
		        return '[' + result + ']';
		      };
		      var createUnicodeCharacterClasses = function createUnicodeCharacterClasses(data) {
		        var result = '';
		        var index = 0;
		        var start;
		        var end;
		        var length = data.length;
		        if (dataIsSingleton(data)) {
		          return codePointToStringUnicode(data[0]);
		        }
		        while (index < length) {
		          start = data[index];
		          end = data[index + 1] - 1;
		          if (start == end) {
		            result += codePointToStringUnicode(start);
		          } else if (start + 1 == end) {
		            result += codePointToStringUnicode(start) + codePointToStringUnicode(end);
		          } else {
		            result += codePointToStringUnicode(start) + '-' + codePointToStringUnicode(end);
		          }
		          index += 2;
		        }
		        return '[' + result + ']';
		      };
		      var splitAtBMP = function splitAtBMP(data) {
		        var loneHighSurrogates = [];
		        var loneLowSurrogates = [];
		        var bmp = [];
		        var astral = [];
		        var index = 0;
		        var start;
		        var end;
		        var length = data.length;
		        while (index < length) {
		          start = data[index];
		          end = data[index + 1] - 1;
		          if (start < HIGH_SURROGATE_MIN) {
		            if (end < HIGH_SURROGATE_MIN) {
		              bmp.push(start, end + 1);
		            }
		            if (end >= HIGH_SURROGATE_MIN && end <= HIGH_SURROGATE_MAX) {
		              bmp.push(start, HIGH_SURROGATE_MIN);
		              loneHighSurrogates.push(HIGH_SURROGATE_MIN, end + 1);
		            }
		            if (end >= LOW_SURROGATE_MIN && end <= LOW_SURROGATE_MAX) {
		              bmp.push(start, HIGH_SURROGATE_MIN);
		              loneHighSurrogates.push(HIGH_SURROGATE_MIN, HIGH_SURROGATE_MAX + 1);
		              loneLowSurrogates.push(LOW_SURROGATE_MIN, end + 1);
		            }
		            if (end > LOW_SURROGATE_MAX) {
		              bmp.push(start, HIGH_SURROGATE_MIN);
		              loneHighSurrogates.push(HIGH_SURROGATE_MIN, HIGH_SURROGATE_MAX + 1);
		              loneLowSurrogates.push(LOW_SURROGATE_MIN, LOW_SURROGATE_MAX + 1);
		              if (end <= 0xFFFF) {
		                bmp.push(LOW_SURROGATE_MAX + 1, end + 1);
		              } else {
		                bmp.push(LOW_SURROGATE_MAX + 1, 0xFFFF + 1);
		                astral.push(0xFFFF + 1, end + 1);
		              }
		            }
		          } else if (start >= HIGH_SURROGATE_MIN && start <= HIGH_SURROGATE_MAX) {
		            if (end >= HIGH_SURROGATE_MIN && end <= HIGH_SURROGATE_MAX) {
		              loneHighSurrogates.push(start, end + 1);
		            }
		            if (end >= LOW_SURROGATE_MIN && end <= LOW_SURROGATE_MAX) {
		              loneHighSurrogates.push(start, HIGH_SURROGATE_MAX + 1);
		              loneLowSurrogates.push(LOW_SURROGATE_MIN, end + 1);
		            }
		            if (end > LOW_SURROGATE_MAX) {
		              loneHighSurrogates.push(start, HIGH_SURROGATE_MAX + 1);
		              loneLowSurrogates.push(LOW_SURROGATE_MIN, LOW_SURROGATE_MAX + 1);
		              if (end <= 0xFFFF) {
		                bmp.push(LOW_SURROGATE_MAX + 1, end + 1);
		              } else {
		                bmp.push(LOW_SURROGATE_MAX + 1, 0xFFFF + 1);
		                astral.push(0xFFFF + 1, end + 1);
		              }
		            }
		          } else if (start >= LOW_SURROGATE_MIN && start <= LOW_SURROGATE_MAX) {
		            if (end >= LOW_SURROGATE_MIN && end <= LOW_SURROGATE_MAX) {
		              loneLowSurrogates.push(start, end + 1);
		            }
		            if (end > LOW_SURROGATE_MAX) {
		              loneLowSurrogates.push(start, LOW_SURROGATE_MAX + 1);
		              if (end <= 0xFFFF) {
		                bmp.push(LOW_SURROGATE_MAX + 1, end + 1);
		              } else {
		                bmp.push(LOW_SURROGATE_MAX + 1, 0xFFFF + 1);
		                astral.push(0xFFFF + 1, end + 1);
		              }
		            }
		          } else if (start > LOW_SURROGATE_MAX && start <= 0xFFFF) {
		            if (end <= 0xFFFF) {
		              bmp.push(start, end + 1);
		            } else {
		              bmp.push(start, 0xFFFF + 1);
		              astral.push(0xFFFF + 1, end + 1);
		            }
		          } else {
		            astral.push(start, end + 1);
		          }
		          index += 2;
		        }
		        return {
		          'loneHighSurrogates': loneHighSurrogates,
		          'loneLowSurrogates': loneLowSurrogates,
		          'bmp': bmp,
		          'astral': astral
		        };
		      };
		      var optimizeSurrogateMappings = function optimizeSurrogateMappings(surrogateMappings) {
		        var result = [];
		        var tmpLow = [];
		        var addLow = false;
		        var mapping;
		        var nextMapping;
		        var highSurrogates;
		        var lowSurrogates;
		        var nextHighSurrogates;
		        var nextLowSurrogates;
		        var index = -1;
		        var length = surrogateMappings.length;
		        while (++index < length) {
		          mapping = surrogateMappings[index];
		          nextMapping = surrogateMappings[index + 1];
		          if (!nextMapping) {
		            result.push(mapping);
		            continue;
		          }
		          highSurrogates = mapping[0];
		          lowSurrogates = mapping[1];
		          nextHighSurrogates = nextMapping[0];
		          nextLowSurrogates = nextMapping[1];
		          tmpLow = lowSurrogates;
		          while (nextHighSurrogates && highSurrogates[0] == nextHighSurrogates[0] && highSurrogates[1] == nextHighSurrogates[1]) {
		            if (dataIsSingleton(nextLowSurrogates)) {
		              tmpLow = dataAdd(tmpLow, nextLowSurrogates[0]);
		            } else {
		              tmpLow = dataAddRange(tmpLow, nextLowSurrogates[0], nextLowSurrogates[1] - 1);
		            }
		            ++index;
		            mapping = surrogateMappings[index];
		            highSurrogates = mapping[0];
		            lowSurrogates = mapping[1];
		            nextMapping = surrogateMappings[index + 1];
		            nextHighSurrogates = nextMapping && nextMapping[0];
		            nextLowSurrogates = nextMapping && nextMapping[1];
		            addLow = true;
		          }
		          result.push([highSurrogates, addLow ? tmpLow : lowSurrogates]);
		          addLow = false;
		        }
		        return optimizeByLowSurrogates(result);
		      };
		      var optimizeByLowSurrogates = function optimizeByLowSurrogates(surrogateMappings) {
		        if (surrogateMappings.length == 1) {
		          return surrogateMappings;
		        }
		        var index = -1;
		        var innerIndex = -1;
		        while (++index < surrogateMappings.length) {
		          var mapping = surrogateMappings[index];
		          var lowSurrogates = mapping[1];
		          var lowSurrogateStart = lowSurrogates[0];
		          var lowSurrogateEnd = lowSurrogates[1];
		          innerIndex = index;
		          while (++innerIndex < surrogateMappings.length) {
		            var otherMapping = surrogateMappings[innerIndex];
		            var otherLowSurrogates = otherMapping[1];
		            var otherLowSurrogateStart = otherLowSurrogates[0];
		            var otherLowSurrogateEnd = otherLowSurrogates[1];
		            if (lowSurrogateStart == otherLowSurrogateStart && lowSurrogateEnd == otherLowSurrogateEnd && otherLowSurrogates.length === 2) {
		              if (dataIsSingleton(otherMapping[0])) {
		                mapping[0] = dataAdd(mapping[0], otherMapping[0][0]);
		              } else {
		                mapping[0] = dataAddRange(mapping[0], otherMapping[0][0], otherMapping[0][1] - 1);
		              }
		              surrogateMappings.splice(innerIndex, 1);
		              --innerIndex;
		            }
		          }
		        }
		        return surrogateMappings;
		      };
		      var surrogateSet = function surrogateSet(data) {
		        if (!data.length) {
		          return [];
		        }
		        var index = 0;
		        var start;
		        var end;
		        var startHigh;
		        var startLow;
		        var endHigh;
		        var endLow;
		        var surrogateMappings = [];
		        var length = data.length;
		        while (index < length) {
		          start = data[index];
		          end = data[index + 1] - 1;
		          startHigh = highSurrogate(start);
		          startLow = lowSurrogate(start);
		          endHigh = highSurrogate(end);
		          endLow = lowSurrogate(end);
		          var startsWithLowestLowSurrogate = startLow == LOW_SURROGATE_MIN;
		          var endsWithHighestLowSurrogate = endLow == LOW_SURROGATE_MAX;
		          var complete = false;
		          if (startHigh == endHigh || startsWithLowestLowSurrogate && endsWithHighestLowSurrogate) {
		            surrogateMappings.push([[startHigh, endHigh + 1], [startLow, endLow + 1]]);
		            complete = true;
		          } else {
		            surrogateMappings.push([[startHigh, startHigh + 1], [startLow, LOW_SURROGATE_MAX + 1]]);
		          }
		          if (!complete && startHigh + 1 < endHigh) {
		            if (endsWithHighestLowSurrogate) {
		              surrogateMappings.push([[startHigh + 1, endHigh + 1], [LOW_SURROGATE_MIN, endLow + 1]]);
		              complete = true;
		            } else {
		              surrogateMappings.push([[startHigh + 1, endHigh], [LOW_SURROGATE_MIN, LOW_SURROGATE_MAX + 1]]);
		            }
		          }
		          if (!complete) {
		            surrogateMappings.push([[endHigh, endHigh + 1], [LOW_SURROGATE_MIN, endLow + 1]]);
		          }
		          index += 2;
		        }
		        return optimizeSurrogateMappings(surrogateMappings);
		      };
		      var createSurrogateCharacterClasses = function createSurrogateCharacterClasses(surrogateMappings) {
		        var result = [];
		        forEach(surrogateMappings, function (surrogateMapping) {
		          var highSurrogates = surrogateMapping[0];
		          var lowSurrogates = surrogateMapping[1];
		          result.push(createBMPCharacterClasses(highSurrogates) + createBMPCharacterClasses(lowSurrogates));
		        });
		        return result.join('|');
		      };
		      var createCharacterClassesFromData = function createCharacterClassesFromData(data, bmpOnly, hasUnicodeFlag) {
		        if (hasUnicodeFlag) {
		          return createUnicodeCharacterClasses(data);
		        }
		        var result = [];
		        var parts = splitAtBMP(data);
		        var loneHighSurrogates = parts.loneHighSurrogates;
		        var loneLowSurrogates = parts.loneLowSurrogates;
		        var bmp = parts.bmp;
		        var astral = parts.astral;
		        var hasLoneHighSurrogates = !dataIsEmpty(loneHighSurrogates);
		        var hasLoneLowSurrogates = !dataIsEmpty(loneLowSurrogates);
		        var surrogateMappings = surrogateSet(astral);
		        if (bmpOnly) {
		          bmp = dataAddData(bmp, loneHighSurrogates);
		          hasLoneHighSurrogates = false;
		          bmp = dataAddData(bmp, loneLowSurrogates);
		          hasLoneLowSurrogates = false;
		        }
		        if (!dataIsEmpty(bmp)) {
		          result.push(createBMPCharacterClasses(bmp));
		        }
		        if (surrogateMappings.length) {
		          result.push(createSurrogateCharacterClasses(surrogateMappings));
		        }
		        if (hasLoneHighSurrogates) {
		          result.push(createBMPCharacterClasses(loneHighSurrogates) + "(?![\\uDC00-\\uDFFF])");
		        }
		        if (hasLoneLowSurrogates) {
		          result.push("(?:[^\\uD800-\\uDBFF]|^)" + createBMPCharacterClasses(loneLowSurrogates));
		        }
		        return result.join('|');
		      };
		      var regenerate = function regenerate(value) {
		        if (arguments.length > 1) {
		          value = slice.call(arguments);
		        }
		        if (this instanceof regenerate) {
		          this.data = [];
		          return value ? this.add(value) : this;
		        }
		        return new regenerate().add(value);
		      };
		      regenerate.version = '1.4.2';
		      var proto = regenerate.prototype;
		      extend(proto, {
		        'add': function add(value) {
		          var $this = this;
		          if (value == null) {
		            return $this;
		          }
		          if (value instanceof regenerate) {
		            $this.data = dataAddData($this.data, value.data);
		            return $this;
		          }
		          if (arguments.length > 1) {
		            value = slice.call(arguments);
		          }
		          if (isArray(value)) {
		            forEach(value, function (item) {
		              $this.add(item);
		            });
		            return $this;
		          }
		          $this.data = dataAdd($this.data, isNumber(value) ? value : symbolToCodePoint(value));
		          return $this;
		        },
		        'remove': function remove(value) {
		          var $this = this;
		          if (value == null) {
		            return $this;
		          }
		          if (value instanceof regenerate) {
		            $this.data = dataRemoveData($this.data, value.data);
		            return $this;
		          }
		          if (arguments.length > 1) {
		            value = slice.call(arguments);
		          }
		          if (isArray(value)) {
		            forEach(value, function (item) {
		              $this.remove(item);
		            });
		            return $this;
		          }
		          $this.data = dataRemove($this.data, isNumber(value) ? value : symbolToCodePoint(value));
		          return $this;
		        },
		        'addRange': function addRange(start, end) {
		          var $this = this;
		          $this.data = dataAddRange($this.data, isNumber(start) ? start : symbolToCodePoint(start), isNumber(end) ? end : symbolToCodePoint(end));
		          return $this;
		        },
		        'removeRange': function removeRange(start, end) {
		          var $this = this;
		          var startCodePoint = isNumber(start) ? start : symbolToCodePoint(start);
		          var endCodePoint = isNumber(end) ? end : symbolToCodePoint(end);
		          $this.data = dataRemoveRange($this.data, startCodePoint, endCodePoint);
		          return $this;
		        },
		        'intersection': function intersection(argument) {
		          var $this = this;
		          var array = argument instanceof regenerate ? dataToArray(argument.data) : argument;
		          $this.data = dataIntersection($this.data, array);
		          return $this;
		        },
		        'contains': function contains(codePoint) {
		          return dataContains(this.data, isNumber(codePoint) ? codePoint : symbolToCodePoint(codePoint));
		        },
		        'clone': function clone() {
		          var set = new regenerate();
		          set.data = this.data.slice(0);
		          return set;
		        },
		        'toString': function toString(options) {
		          var result = createCharacterClassesFromData(this.data, options ? options.bmpOnly : false, options ? options.hasUnicodeFlag : false);
		          if (!result) {
		            return '[]';
		          }
		          return result.replace(regexNull, '\\0$1');
		        },
		        'toRegExp': function toRegExp(flags) {
		          var pattern = this.toString(flags && flags.indexOf('u') != -1 ? {
		            'hasUnicodeFlag': true
		          } : null);
		          return RegExp(pattern, flags || '');
		        },
		        'valueOf': function valueOf() {
		          return dataToArray(this.data);
		        }
		      });
		      proto.toArray = proto.valueOf;
		      if (freeExports && !freeExports.nodeType) {
		        if (freeModule) {
		          freeModule.exports = regenerate;
		        } else {
		          freeExports.regenerate = regenerate;
		        }
		      } else {
		        root.regenerate = regenerate;
		      }
		    })(commonjsGlobal$1);
		  })(regenerate$2, regenerate$2.exports);
		  var regenerateExports = regenerate$2.exports;

		  var hasRequiredAlphabetic;
		  function requireAlphabetic() {
		    if (hasRequiredAlphabetic) return Alphabetic;
		    hasRequiredAlphabetic = 1;
		    var set = regenerateExports(0xAA, 0xB5, 0xBA, 0x2EC, 0x2EE, 0x345, 0x37F, 0x386, 0x38C, 0x559, 0x5BF, 0x5C7, 0x6FF, 0x7FA, 0x9B2, 0x9CE, 0x9D7, 0x9FC, 0xA51, 0xA5E, 0xAD0, 0xB71, 0xB9C, 0xBD0, 0xBD7, 0xC5D, 0xD4E, 0xDBD, 0xDD6, 0xE4D, 0xE84, 0xEA5, 0xEC6, 0xECD, 0xF00, 0x1038, 0x10C7, 0x10CD, 0x1258, 0x12C0, 0x17D7, 0x17DC, 0x1AA7, 0x1CFA, 0x1F59, 0x1F5B, 0x1F5D, 0x1FBE, 0x2071, 0x207F, 0x2102, 0x2107, 0x2115, 0x2124, 0x2126, 0x2128, 0x214E, 0x2D27, 0x2D2D, 0x2D6F, 0x2E2F, 0xA7D3, 0xA8C5, 0xA8FB, 0xA9CF, 0xAAC0, 0xAAC2, 0xFB3E, 0x10808, 0x1083C, 0x10F27, 0x110C2, 0x11176, 0x111DA, 0x111DC, 0x11237, 0x11288, 0x11350, 0x11357, 0x114C7, 0x11640, 0x11644, 0x116B8, 0x11909, 0x119E1, 0x11A9D, 0x11C40, 0x11D3A, 0x11D43, 0x11D98, 0x11FB0, 0x16FE3, 0x1B132, 0x1B155, 0x1BC9E, 0x1D4A2, 0x1D4BB, 0x1D546, 0x1E08F, 0x1E14E, 0x1E947, 0x1E94B, 0x1EE24, 0x1EE27, 0x1EE39, 0x1EE3B, 0x1EE42, 0x1EE47, 0x1EE49, 0x1EE4B, 0x1EE54, 0x1EE57, 0x1EE59, 0x1EE5B, 0x1EE5D, 0x1EE5F, 0x1EE64, 0x1EE7E);
		    set.addRange(0x41, 0x5A).addRange(0x61, 0x7A).addRange(0xC0, 0xD6).addRange(0xD8, 0xF6).addRange(0xF8, 0x2C1).addRange(0x2C6, 0x2D1).addRange(0x2E0, 0x2E4).addRange(0x370, 0x374).addRange(0x376, 0x377).addRange(0x37A, 0x37D).addRange(0x388, 0x38A).addRange(0x38E, 0x3A1).addRange(0x3A3, 0x3F5).addRange(0x3F7, 0x481).addRange(0x48A, 0x52F).addRange(0x531, 0x556).addRange(0x560, 0x588).addRange(0x5B0, 0x5BD).addRange(0x5C1, 0x5C2).addRange(0x5C4, 0x5C5).addRange(0x5D0, 0x5EA).addRange(0x5EF, 0x5F2).addRange(0x610, 0x61A).addRange(0x620, 0x657).addRange(0x659, 0x65F).addRange(0x66E, 0x6D3).addRange(0x6D5, 0x6DC).addRange(0x6E1, 0x6E8).addRange(0x6ED, 0x6EF).addRange(0x6FA, 0x6FC).addRange(0x710, 0x73F).addRange(0x74D, 0x7B1).addRange(0x7CA, 0x7EA).addRange(0x7F4, 0x7F5).addRange(0x800, 0x817).addRange(0x81A, 0x82C).addRange(0x840, 0x858).addRange(0x860, 0x86A).addRange(0x870, 0x887).addRange(0x889, 0x88E).addRange(0x8A0, 0x8C9).addRange(0x8D4, 0x8DF).addRange(0x8E3, 0x8E9).addRange(0x8F0, 0x93B).addRange(0x93D, 0x94C).addRange(0x94E, 0x950).addRange(0x955, 0x963).addRange(0x971, 0x983).addRange(0x985, 0x98C).addRange(0x98F, 0x990).addRange(0x993, 0x9A8);
		    set.addRange(0x9AA, 0x9B0).addRange(0x9B6, 0x9B9).addRange(0x9BD, 0x9C4).addRange(0x9C7, 0x9C8).addRange(0x9CB, 0x9CC).addRange(0x9DC, 0x9DD).addRange(0x9DF, 0x9E3).addRange(0x9F0, 0x9F1).addRange(0xA01, 0xA03).addRange(0xA05, 0xA0A).addRange(0xA0F, 0xA10).addRange(0xA13, 0xA28).addRange(0xA2A, 0xA30).addRange(0xA32, 0xA33).addRange(0xA35, 0xA36).addRange(0xA38, 0xA39).addRange(0xA3E, 0xA42).addRange(0xA47, 0xA48).addRange(0xA4B, 0xA4C).addRange(0xA59, 0xA5C).addRange(0xA70, 0xA75).addRange(0xA81, 0xA83).addRange(0xA85, 0xA8D).addRange(0xA8F, 0xA91).addRange(0xA93, 0xAA8).addRange(0xAAA, 0xAB0).addRange(0xAB2, 0xAB3).addRange(0xAB5, 0xAB9).addRange(0xABD, 0xAC5).addRange(0xAC7, 0xAC9).addRange(0xACB, 0xACC).addRange(0xAE0, 0xAE3).addRange(0xAF9, 0xAFC).addRange(0xB01, 0xB03).addRange(0xB05, 0xB0C).addRange(0xB0F, 0xB10).addRange(0xB13, 0xB28).addRange(0xB2A, 0xB30).addRange(0xB32, 0xB33).addRange(0xB35, 0xB39).addRange(0xB3D, 0xB44).addRange(0xB47, 0xB48).addRange(0xB4B, 0xB4C).addRange(0xB56, 0xB57).addRange(0xB5C, 0xB5D).addRange(0xB5F, 0xB63).addRange(0xB82, 0xB83).addRange(0xB85, 0xB8A).addRange(0xB8E, 0xB90).addRange(0xB92, 0xB95).addRange(0xB99, 0xB9A);
		    set.addRange(0xB9E, 0xB9F).addRange(0xBA3, 0xBA4).addRange(0xBA8, 0xBAA).addRange(0xBAE, 0xBB9).addRange(0xBBE, 0xBC2).addRange(0xBC6, 0xBC8).addRange(0xBCA, 0xBCC).addRange(0xC00, 0xC0C).addRange(0xC0E, 0xC10).addRange(0xC12, 0xC28).addRange(0xC2A, 0xC39).addRange(0xC3D, 0xC44).addRange(0xC46, 0xC48).addRange(0xC4A, 0xC4C).addRange(0xC55, 0xC56).addRange(0xC58, 0xC5A).addRange(0xC60, 0xC63).addRange(0xC80, 0xC83).addRange(0xC85, 0xC8C).addRange(0xC8E, 0xC90).addRange(0xC92, 0xCA8).addRange(0xCAA, 0xCB3).addRange(0xCB5, 0xCB9).addRange(0xCBD, 0xCC4).addRange(0xCC6, 0xCC8).addRange(0xCCA, 0xCCC).addRange(0xCD5, 0xCD6).addRange(0xCDD, 0xCDE).addRange(0xCE0, 0xCE3).addRange(0xCF1, 0xCF3).addRange(0xD00, 0xD0C).addRange(0xD0E, 0xD10).addRange(0xD12, 0xD3A).addRange(0xD3D, 0xD44).addRange(0xD46, 0xD48).addRange(0xD4A, 0xD4C).addRange(0xD54, 0xD57).addRange(0xD5F, 0xD63).addRange(0xD7A, 0xD7F).addRange(0xD81, 0xD83).addRange(0xD85, 0xD96).addRange(0xD9A, 0xDB1).addRange(0xDB3, 0xDBB).addRange(0xDC0, 0xDC6).addRange(0xDCF, 0xDD4).addRange(0xDD8, 0xDDF).addRange(0xDF2, 0xDF3).addRange(0xE01, 0xE3A).addRange(0xE40, 0xE46).addRange(0xE81, 0xE82).addRange(0xE86, 0xE8A);
		    set.addRange(0xE8C, 0xEA3).addRange(0xEA7, 0xEB9).addRange(0xEBB, 0xEBD).addRange(0xEC0, 0xEC4).addRange(0xEDC, 0xEDF).addRange(0xF40, 0xF47).addRange(0xF49, 0xF6C).addRange(0xF71, 0xF83).addRange(0xF88, 0xF97).addRange(0xF99, 0xFBC).addRange(0x1000, 0x1036).addRange(0x103B, 0x103F).addRange(0x1050, 0x108F).addRange(0x109A, 0x109D).addRange(0x10A0, 0x10C5).addRange(0x10D0, 0x10FA).addRange(0x10FC, 0x1248).addRange(0x124A, 0x124D).addRange(0x1250, 0x1256).addRange(0x125A, 0x125D).addRange(0x1260, 0x1288).addRange(0x128A, 0x128D).addRange(0x1290, 0x12B0).addRange(0x12B2, 0x12B5).addRange(0x12B8, 0x12BE).addRange(0x12C2, 0x12C5).addRange(0x12C8, 0x12D6).addRange(0x12D8, 0x1310).addRange(0x1312, 0x1315).addRange(0x1318, 0x135A).addRange(0x1380, 0x138F).addRange(0x13A0, 0x13F5).addRange(0x13F8, 0x13FD).addRange(0x1401, 0x166C).addRange(0x166F, 0x167F).addRange(0x1681, 0x169A).addRange(0x16A0, 0x16EA).addRange(0x16EE, 0x16F8).addRange(0x1700, 0x1713).addRange(0x171F, 0x1733).addRange(0x1740, 0x1753).addRange(0x1760, 0x176C).addRange(0x176E, 0x1770).addRange(0x1772, 0x1773).addRange(0x1780, 0x17B3).addRange(0x17B6, 0x17C8).addRange(0x1820, 0x1878).addRange(0x1880, 0x18AA).addRange(0x18B0, 0x18F5).addRange(0x1900, 0x191E).addRange(0x1920, 0x192B);
		    set.addRange(0x1930, 0x1938).addRange(0x1950, 0x196D).addRange(0x1970, 0x1974).addRange(0x1980, 0x19AB).addRange(0x19B0, 0x19C9).addRange(0x1A00, 0x1A1B).addRange(0x1A20, 0x1A5E).addRange(0x1A61, 0x1A74).addRange(0x1ABF, 0x1AC0).addRange(0x1ACC, 0x1ACE).addRange(0x1B00, 0x1B33).addRange(0x1B35, 0x1B43).addRange(0x1B45, 0x1B4C).addRange(0x1B80, 0x1BA9).addRange(0x1BAC, 0x1BAF).addRange(0x1BBA, 0x1BE5).addRange(0x1BE7, 0x1BF1).addRange(0x1C00, 0x1C36).addRange(0x1C4D, 0x1C4F).addRange(0x1C5A, 0x1C7D).addRange(0x1C80, 0x1C88).addRange(0x1C90, 0x1CBA).addRange(0x1CBD, 0x1CBF).addRange(0x1CE9, 0x1CEC).addRange(0x1CEE, 0x1CF3).addRange(0x1CF5, 0x1CF6).addRange(0x1D00, 0x1DBF).addRange(0x1DE7, 0x1DF4).addRange(0x1E00, 0x1F15).addRange(0x1F18, 0x1F1D).addRange(0x1F20, 0x1F45).addRange(0x1F48, 0x1F4D).addRange(0x1F50, 0x1F57).addRange(0x1F5F, 0x1F7D).addRange(0x1F80, 0x1FB4).addRange(0x1FB6, 0x1FBC).addRange(0x1FC2, 0x1FC4).addRange(0x1FC6, 0x1FCC).addRange(0x1FD0, 0x1FD3).addRange(0x1FD6, 0x1FDB).addRange(0x1FE0, 0x1FEC).addRange(0x1FF2, 0x1FF4).addRange(0x1FF6, 0x1FFC).addRange(0x2090, 0x209C).addRange(0x210A, 0x2113).addRange(0x2119, 0x211D).addRange(0x212A, 0x212D).addRange(0x212F, 0x2139).addRange(0x213C, 0x213F).addRange(0x2145, 0x2149).addRange(0x2160, 0x2188);
		    set.addRange(0x24B6, 0x24E9).addRange(0x2C00, 0x2CE4).addRange(0x2CEB, 0x2CEE).addRange(0x2CF2, 0x2CF3).addRange(0x2D00, 0x2D25).addRange(0x2D30, 0x2D67).addRange(0x2D80, 0x2D96).addRange(0x2DA0, 0x2DA6).addRange(0x2DA8, 0x2DAE).addRange(0x2DB0, 0x2DB6).addRange(0x2DB8, 0x2DBE).addRange(0x2DC0, 0x2DC6).addRange(0x2DC8, 0x2DCE).addRange(0x2DD0, 0x2DD6).addRange(0x2DD8, 0x2DDE).addRange(0x2DE0, 0x2DFF).addRange(0x3005, 0x3007).addRange(0x3021, 0x3029).addRange(0x3031, 0x3035).addRange(0x3038, 0x303C).addRange(0x3041, 0x3096).addRange(0x309D, 0x309F).addRange(0x30A1, 0x30FA).addRange(0x30FC, 0x30FF).addRange(0x3105, 0x312F).addRange(0x3131, 0x318E).addRange(0x31A0, 0x31BF).addRange(0x31F0, 0x31FF).addRange(0x3400, 0x4DBF).addRange(0x4E00, 0xA48C).addRange(0xA4D0, 0xA4FD).addRange(0xA500, 0xA60C).addRange(0xA610, 0xA61F).addRange(0xA62A, 0xA62B).addRange(0xA640, 0xA66E).addRange(0xA674, 0xA67B).addRange(0xA67F, 0xA6EF).addRange(0xA717, 0xA71F).addRange(0xA722, 0xA788).addRange(0xA78B, 0xA7CA).addRange(0xA7D0, 0xA7D1).addRange(0xA7D5, 0xA7D9).addRange(0xA7F2, 0xA805).addRange(0xA807, 0xA827).addRange(0xA840, 0xA873).addRange(0xA880, 0xA8C3).addRange(0xA8F2, 0xA8F7).addRange(0xA8FD, 0xA8FF).addRange(0xA90A, 0xA92A).addRange(0xA930, 0xA952).addRange(0xA960, 0xA97C);
		    set.addRange(0xA980, 0xA9B2).addRange(0xA9B4, 0xA9BF).addRange(0xA9E0, 0xA9EF).addRange(0xA9FA, 0xA9FE).addRange(0xAA00, 0xAA36).addRange(0xAA40, 0xAA4D).addRange(0xAA60, 0xAA76).addRange(0xAA7A, 0xAABE).addRange(0xAADB, 0xAADD).addRange(0xAAE0, 0xAAEF).addRange(0xAAF2, 0xAAF5).addRange(0xAB01, 0xAB06).addRange(0xAB09, 0xAB0E).addRange(0xAB11, 0xAB16).addRange(0xAB20, 0xAB26).addRange(0xAB28, 0xAB2E).addRange(0xAB30, 0xAB5A).addRange(0xAB5C, 0xAB69).addRange(0xAB70, 0xABEA).addRange(0xAC00, 0xD7A3).addRange(0xD7B0, 0xD7C6).addRange(0xD7CB, 0xD7FB).addRange(0xF900, 0xFA6D).addRange(0xFA70, 0xFAD9).addRange(0xFB00, 0xFB06).addRange(0xFB13, 0xFB17).addRange(0xFB1D, 0xFB28).addRange(0xFB2A, 0xFB36).addRange(0xFB38, 0xFB3C).addRange(0xFB40, 0xFB41).addRange(0xFB43, 0xFB44).addRange(0xFB46, 0xFBB1).addRange(0xFBD3, 0xFD3D).addRange(0xFD50, 0xFD8F).addRange(0xFD92, 0xFDC7).addRange(0xFDF0, 0xFDFB).addRange(0xFE70, 0xFE74).addRange(0xFE76, 0xFEFC).addRange(0xFF21, 0xFF3A).addRange(0xFF41, 0xFF5A).addRange(0xFF66, 0xFFBE).addRange(0xFFC2, 0xFFC7).addRange(0xFFCA, 0xFFCF).addRange(0xFFD2, 0xFFD7).addRange(0xFFDA, 0xFFDC).addRange(0x10000, 0x1000B).addRange(0x1000D, 0x10026).addRange(0x10028, 0x1003A).addRange(0x1003C, 0x1003D).addRange(0x1003F, 0x1004D).addRange(0x10050, 0x1005D);
		    set.addRange(0x10080, 0x100FA).addRange(0x10140, 0x10174).addRange(0x10280, 0x1029C).addRange(0x102A0, 0x102D0).addRange(0x10300, 0x1031F).addRange(0x1032D, 0x1034A).addRange(0x10350, 0x1037A).addRange(0x10380, 0x1039D).addRange(0x103A0, 0x103C3).addRange(0x103C8, 0x103CF).addRange(0x103D1, 0x103D5).addRange(0x10400, 0x1049D).addRange(0x104B0, 0x104D3).addRange(0x104D8, 0x104FB).addRange(0x10500, 0x10527).addRange(0x10530, 0x10563).addRange(0x10570, 0x1057A).addRange(0x1057C, 0x1058A).addRange(0x1058C, 0x10592).addRange(0x10594, 0x10595).addRange(0x10597, 0x105A1).addRange(0x105A3, 0x105B1).addRange(0x105B3, 0x105B9).addRange(0x105BB, 0x105BC).addRange(0x10600, 0x10736).addRange(0x10740, 0x10755).addRange(0x10760, 0x10767).addRange(0x10780, 0x10785).addRange(0x10787, 0x107B0).addRange(0x107B2, 0x107BA).addRange(0x10800, 0x10805).addRange(0x1080A, 0x10835).addRange(0x10837, 0x10838).addRange(0x1083F, 0x10855).addRange(0x10860, 0x10876).addRange(0x10880, 0x1089E).addRange(0x108E0, 0x108F2).addRange(0x108F4, 0x108F5).addRange(0x10900, 0x10915).addRange(0x10920, 0x10939).addRange(0x10980, 0x109B7).addRange(0x109BE, 0x109BF).addRange(0x10A00, 0x10A03).addRange(0x10A05, 0x10A06).addRange(0x10A0C, 0x10A13).addRange(0x10A15, 0x10A17).addRange(0x10A19, 0x10A35).addRange(0x10A60, 0x10A7C).addRange(0x10A80, 0x10A9C).addRange(0x10AC0, 0x10AC7).addRange(0x10AC9, 0x10AE4);
		    set.addRange(0x10B00, 0x10B35).addRange(0x10B40, 0x10B55).addRange(0x10B60, 0x10B72).addRange(0x10B80, 0x10B91).addRange(0x10C00, 0x10C48).addRange(0x10C80, 0x10CB2).addRange(0x10CC0, 0x10CF2).addRange(0x10D00, 0x10D27).addRange(0x10E80, 0x10EA9).addRange(0x10EAB, 0x10EAC).addRange(0x10EB0, 0x10EB1).addRange(0x10F00, 0x10F1C).addRange(0x10F30, 0x10F45).addRange(0x10F70, 0x10F81).addRange(0x10FB0, 0x10FC4).addRange(0x10FE0, 0x10FF6).addRange(0x11000, 0x11045).addRange(0x11071, 0x11075).addRange(0x11080, 0x110B8).addRange(0x110D0, 0x110E8).addRange(0x11100, 0x11132).addRange(0x11144, 0x11147).addRange(0x11150, 0x11172).addRange(0x11180, 0x111BF).addRange(0x111C1, 0x111C4).addRange(0x111CE, 0x111CF).addRange(0x11200, 0x11211).addRange(0x11213, 0x11234).addRange(0x1123E, 0x11241).addRange(0x11280, 0x11286).addRange(0x1128A, 0x1128D).addRange(0x1128F, 0x1129D).addRange(0x1129F, 0x112A8).addRange(0x112B0, 0x112E8).addRange(0x11300, 0x11303).addRange(0x11305, 0x1130C).addRange(0x1130F, 0x11310).addRange(0x11313, 0x11328).addRange(0x1132A, 0x11330).addRange(0x11332, 0x11333).addRange(0x11335, 0x11339).addRange(0x1133D, 0x11344).addRange(0x11347, 0x11348).addRange(0x1134B, 0x1134C).addRange(0x1135D, 0x11363).addRange(0x11400, 0x11441).addRange(0x11443, 0x11445).addRange(0x11447, 0x1144A).addRange(0x1145F, 0x11461).addRange(0x11480, 0x114C1).addRange(0x114C4, 0x114C5);
		    set.addRange(0x11580, 0x115B5).addRange(0x115B8, 0x115BE).addRange(0x115D8, 0x115DD).addRange(0x11600, 0x1163E).addRange(0x11680, 0x116B5).addRange(0x11700, 0x1171A).addRange(0x1171D, 0x1172A).addRange(0x11740, 0x11746).addRange(0x11800, 0x11838).addRange(0x118A0, 0x118DF).addRange(0x118FF, 0x11906).addRange(0x1190C, 0x11913).addRange(0x11915, 0x11916).addRange(0x11918, 0x11935).addRange(0x11937, 0x11938).addRange(0x1193B, 0x1193C).addRange(0x1193F, 0x11942).addRange(0x119A0, 0x119A7).addRange(0x119AA, 0x119D7).addRange(0x119DA, 0x119DF).addRange(0x119E3, 0x119E4).addRange(0x11A00, 0x11A32).addRange(0x11A35, 0x11A3E).addRange(0x11A50, 0x11A97).addRange(0x11AB0, 0x11AF8).addRange(0x11C00, 0x11C08).addRange(0x11C0A, 0x11C36).addRange(0x11C38, 0x11C3E).addRange(0x11C72, 0x11C8F).addRange(0x11C92, 0x11CA7).addRange(0x11CA9, 0x11CB6).addRange(0x11D00, 0x11D06).addRange(0x11D08, 0x11D09).addRange(0x11D0B, 0x11D36).addRange(0x11D3C, 0x11D3D).addRange(0x11D3F, 0x11D41).addRange(0x11D46, 0x11D47).addRange(0x11D60, 0x11D65).addRange(0x11D67, 0x11D68).addRange(0x11D6A, 0x11D8E).addRange(0x11D90, 0x11D91).addRange(0x11D93, 0x11D96).addRange(0x11EE0, 0x11EF6).addRange(0x11F00, 0x11F10).addRange(0x11F12, 0x11F3A).addRange(0x11F3E, 0x11F40).addRange(0x12000, 0x12399).addRange(0x12400, 0x1246E).addRange(0x12480, 0x12543).addRange(0x12F90, 0x12FF0).addRange(0x13000, 0x1342F);
		    set.addRange(0x13441, 0x13446).addRange(0x14400, 0x14646).addRange(0x16800, 0x16A38).addRange(0x16A40, 0x16A5E).addRange(0x16A70, 0x16ABE).addRange(0x16AD0, 0x16AED).addRange(0x16B00, 0x16B2F).addRange(0x16B40, 0x16B43).addRange(0x16B63, 0x16B77).addRange(0x16B7D, 0x16B8F).addRange(0x16E40, 0x16E7F).addRange(0x16F00, 0x16F4A).addRange(0x16F4F, 0x16F87).addRange(0x16F8F, 0x16F9F).addRange(0x16FE0, 0x16FE1).addRange(0x16FF0, 0x16FF1).addRange(0x17000, 0x187F7).addRange(0x18800, 0x18CD5).addRange(0x18D00, 0x18D08).addRange(0x1AFF0, 0x1AFF3).addRange(0x1AFF5, 0x1AFFB).addRange(0x1AFFD, 0x1AFFE).addRange(0x1B000, 0x1B122).addRange(0x1B150, 0x1B152).addRange(0x1B164, 0x1B167).addRange(0x1B170, 0x1B2FB).addRange(0x1BC00, 0x1BC6A).addRange(0x1BC70, 0x1BC7C).addRange(0x1BC80, 0x1BC88).addRange(0x1BC90, 0x1BC99).addRange(0x1D400, 0x1D454).addRange(0x1D456, 0x1D49C).addRange(0x1D49E, 0x1D49F).addRange(0x1D4A5, 0x1D4A6).addRange(0x1D4A9, 0x1D4AC).addRange(0x1D4AE, 0x1D4B9).addRange(0x1D4BD, 0x1D4C3).addRange(0x1D4C5, 0x1D505).addRange(0x1D507, 0x1D50A).addRange(0x1D50D, 0x1D514).addRange(0x1D516, 0x1D51C).addRange(0x1D51E, 0x1D539).addRange(0x1D53B, 0x1D53E).addRange(0x1D540, 0x1D544).addRange(0x1D54A, 0x1D550).addRange(0x1D552, 0x1D6A5).addRange(0x1D6A8, 0x1D6C0).addRange(0x1D6C2, 0x1D6DA).addRange(0x1D6DC, 0x1D6FA).addRange(0x1D6FC, 0x1D714).addRange(0x1D716, 0x1D734);
		    set.addRange(0x1D736, 0x1D74E).addRange(0x1D750, 0x1D76E).addRange(0x1D770, 0x1D788).addRange(0x1D78A, 0x1D7A8).addRange(0x1D7AA, 0x1D7C2).addRange(0x1D7C4, 0x1D7CB).addRange(0x1DF00, 0x1DF1E).addRange(0x1DF25, 0x1DF2A).addRange(0x1E000, 0x1E006).addRange(0x1E008, 0x1E018).addRange(0x1E01B, 0x1E021).addRange(0x1E023, 0x1E024).addRange(0x1E026, 0x1E02A).addRange(0x1E030, 0x1E06D).addRange(0x1E100, 0x1E12C).addRange(0x1E137, 0x1E13D).addRange(0x1E290, 0x1E2AD).addRange(0x1E2C0, 0x1E2EB).addRange(0x1E4D0, 0x1E4EB).addRange(0x1E7E0, 0x1E7E6).addRange(0x1E7E8, 0x1E7EB).addRange(0x1E7ED, 0x1E7EE).addRange(0x1E7F0, 0x1E7FE).addRange(0x1E800, 0x1E8C4).addRange(0x1E900, 0x1E943).addRange(0x1EE00, 0x1EE03).addRange(0x1EE05, 0x1EE1F).addRange(0x1EE21, 0x1EE22).addRange(0x1EE29, 0x1EE32).addRange(0x1EE34, 0x1EE37).addRange(0x1EE4D, 0x1EE4F).addRange(0x1EE51, 0x1EE52).addRange(0x1EE61, 0x1EE62).addRange(0x1EE67, 0x1EE6A).addRange(0x1EE6C, 0x1EE72).addRange(0x1EE74, 0x1EE77).addRange(0x1EE79, 0x1EE7C).addRange(0x1EE80, 0x1EE89).addRange(0x1EE8B, 0x1EE9B).addRange(0x1EEA1, 0x1EEA3).addRange(0x1EEA5, 0x1EEA9).addRange(0x1EEAB, 0x1EEBB).addRange(0x1F130, 0x1F149).addRange(0x1F150, 0x1F169).addRange(0x1F170, 0x1F189).addRange(0x20000, 0x2A6DF).addRange(0x2A700, 0x2B739).addRange(0x2B740, 0x2B81D).addRange(0x2B820, 0x2CEA1).addRange(0x2CEB0, 0x2EBE0).addRange(0x2EBF0, 0x2EE5D);
		    set.addRange(0x2F800, 0x2FA1D).addRange(0x30000, 0x3134A).addRange(0x31350, 0x323AF);
		    Alphabetic.characters = set;
		    return Alphabetic;
		  }

		  var Any = {};

		  var hasRequiredAny;
		  function requireAny() {
		    if (hasRequiredAny) return Any;
		    hasRequiredAny = 1;
		    var set = regenerateExports();
		    set.addRange(0x0, 0x10FFFF);
		    Any.characters = set;
		    return Any;
		  }

		  var ASCII_Hex_Digit = {};

		  var hasRequiredASCII_Hex_Digit;
		  function requireASCII_Hex_Digit() {
		    if (hasRequiredASCII_Hex_Digit) return ASCII_Hex_Digit;
		    hasRequiredASCII_Hex_Digit = 1;
		    var set = regenerateExports();
		    set.addRange(0x30, 0x39).addRange(0x41, 0x46).addRange(0x61, 0x66);
		    ASCII_Hex_Digit.characters = set;
		    return ASCII_Hex_Digit;
		  }

		  var ASCII = {};

		  var hasRequiredASCII;
		  function requireASCII() {
		    if (hasRequiredASCII) return ASCII;
		    hasRequiredASCII = 1;
		    var set = regenerateExports();
		    set.addRange(0x0, 0x7F);
		    ASCII.characters = set;
		    return ASCII;
		  }

		  var Assigned = {};

		  var hasRequiredAssigned;
		  function requireAssigned() {
		    if (hasRequiredAssigned) return Assigned;
		    hasRequiredAssigned = 1;
		    var set = regenerateExports(0x38C, 0x85E, 0x9B2, 0x9D7, 0xA3C, 0xA51, 0xA5E, 0xAD0, 0xB9C, 0xBD0, 0xBD7, 0xC5D, 0xDBD, 0xDCA, 0xDD6, 0xE84, 0xEA5, 0xEC6, 0x10C7, 0x10CD, 0x1258, 0x12C0, 0x1940, 0x1F59, 0x1F5B, 0x1F5D, 0x2D27, 0x2D2D, 0xA7D3, 0xFB3E, 0xFDCF, 0xFEFF, 0x101A0, 0x10808, 0x1083C, 0x1093F, 0x110CD, 0x11288, 0x11350, 0x11357, 0x11909, 0x11D3A, 0x11FB0, 0x1B132, 0x1B155, 0x1D4A2, 0x1D4BB, 0x1D546, 0x1E08F, 0x1E2FF, 0x1EE24, 0x1EE27, 0x1EE39, 0x1EE3B, 0x1EE42, 0x1EE47, 0x1EE49, 0x1EE4B, 0x1EE54, 0x1EE57, 0x1EE59, 0x1EE5B, 0x1EE5D, 0x1EE5F, 0x1EE64, 0x1EE7E, 0x1F7F0, 0xE0001);
		    set.addRange(0x0, 0x377).addRange(0x37A, 0x37F).addRange(0x384, 0x38A).addRange(0x38E, 0x3A1).addRange(0x3A3, 0x52F).addRange(0x531, 0x556).addRange(0x559, 0x58A).addRange(0x58D, 0x58F).addRange(0x591, 0x5C7).addRange(0x5D0, 0x5EA).addRange(0x5EF, 0x5F4).addRange(0x600, 0x70D).addRange(0x70F, 0x74A).addRange(0x74D, 0x7B1).addRange(0x7C0, 0x7FA).addRange(0x7FD, 0x82D).addRange(0x830, 0x83E).addRange(0x840, 0x85B).addRange(0x860, 0x86A).addRange(0x870, 0x88E).addRange(0x890, 0x891).addRange(0x898, 0x983).addRange(0x985, 0x98C).addRange(0x98F, 0x990).addRange(0x993, 0x9A8).addRange(0x9AA, 0x9B0).addRange(0x9B6, 0x9B9).addRange(0x9BC, 0x9C4).addRange(0x9C7, 0x9C8).addRange(0x9CB, 0x9CE).addRange(0x9DC, 0x9DD).addRange(0x9DF, 0x9E3).addRange(0x9E6, 0x9FE).addRange(0xA01, 0xA03).addRange(0xA05, 0xA0A).addRange(0xA0F, 0xA10).addRange(0xA13, 0xA28).addRange(0xA2A, 0xA30).addRange(0xA32, 0xA33).addRange(0xA35, 0xA36).addRange(0xA38, 0xA39).addRange(0xA3E, 0xA42).addRange(0xA47, 0xA48).addRange(0xA4B, 0xA4D).addRange(0xA59, 0xA5C).addRange(0xA66, 0xA76).addRange(0xA81, 0xA83).addRange(0xA85, 0xA8D).addRange(0xA8F, 0xA91).addRange(0xA93, 0xAA8).addRange(0xAAA, 0xAB0);
		    set.addRange(0xAB2, 0xAB3).addRange(0xAB5, 0xAB9).addRange(0xABC, 0xAC5).addRange(0xAC7, 0xAC9).addRange(0xACB, 0xACD).addRange(0xAE0, 0xAE3).addRange(0xAE6, 0xAF1).addRange(0xAF9, 0xAFF).addRange(0xB01, 0xB03).addRange(0xB05, 0xB0C).addRange(0xB0F, 0xB10).addRange(0xB13, 0xB28).addRange(0xB2A, 0xB30).addRange(0xB32, 0xB33).addRange(0xB35, 0xB39).addRange(0xB3C, 0xB44).addRange(0xB47, 0xB48).addRange(0xB4B, 0xB4D).addRange(0xB55, 0xB57).addRange(0xB5C, 0xB5D).addRange(0xB5F, 0xB63).addRange(0xB66, 0xB77).addRange(0xB82, 0xB83).addRange(0xB85, 0xB8A).addRange(0xB8E, 0xB90).addRange(0xB92, 0xB95).addRange(0xB99, 0xB9A).addRange(0xB9E, 0xB9F).addRange(0xBA3, 0xBA4).addRange(0xBA8, 0xBAA).addRange(0xBAE, 0xBB9).addRange(0xBBE, 0xBC2).addRange(0xBC6, 0xBC8).addRange(0xBCA, 0xBCD).addRange(0xBE6, 0xBFA).addRange(0xC00, 0xC0C).addRange(0xC0E, 0xC10).addRange(0xC12, 0xC28).addRange(0xC2A, 0xC39).addRange(0xC3C, 0xC44).addRange(0xC46, 0xC48).addRange(0xC4A, 0xC4D).addRange(0xC55, 0xC56).addRange(0xC58, 0xC5A).addRange(0xC60, 0xC63).addRange(0xC66, 0xC6F).addRange(0xC77, 0xC8C).addRange(0xC8E, 0xC90).addRange(0xC92, 0xCA8).addRange(0xCAA, 0xCB3).addRange(0xCB5, 0xCB9);
		    set.addRange(0xCBC, 0xCC4).addRange(0xCC6, 0xCC8).addRange(0xCCA, 0xCCD).addRange(0xCD5, 0xCD6).addRange(0xCDD, 0xCDE).addRange(0xCE0, 0xCE3).addRange(0xCE6, 0xCEF).addRange(0xCF1, 0xCF3).addRange(0xD00, 0xD0C).addRange(0xD0E, 0xD10).addRange(0xD12, 0xD44).addRange(0xD46, 0xD48).addRange(0xD4A, 0xD4F).addRange(0xD54, 0xD63).addRange(0xD66, 0xD7F).addRange(0xD81, 0xD83).addRange(0xD85, 0xD96).addRange(0xD9A, 0xDB1).addRange(0xDB3, 0xDBB).addRange(0xDC0, 0xDC6).addRange(0xDCF, 0xDD4).addRange(0xDD8, 0xDDF).addRange(0xDE6, 0xDEF).addRange(0xDF2, 0xDF4).addRange(0xE01, 0xE3A).addRange(0xE3F, 0xE5B).addRange(0xE81, 0xE82).addRange(0xE86, 0xE8A).addRange(0xE8C, 0xEA3).addRange(0xEA7, 0xEBD).addRange(0xEC0, 0xEC4).addRange(0xEC8, 0xECE).addRange(0xED0, 0xED9).addRange(0xEDC, 0xEDF).addRange(0xF00, 0xF47).addRange(0xF49, 0xF6C).addRange(0xF71, 0xF97).addRange(0xF99, 0xFBC).addRange(0xFBE, 0xFCC).addRange(0xFCE, 0xFDA).addRange(0x1000, 0x10C5).addRange(0x10D0, 0x1248).addRange(0x124A, 0x124D).addRange(0x1250, 0x1256).addRange(0x125A, 0x125D).addRange(0x1260, 0x1288).addRange(0x128A, 0x128D).addRange(0x1290, 0x12B0).addRange(0x12B2, 0x12B5).addRange(0x12B8, 0x12BE).addRange(0x12C2, 0x12C5);
		    set.addRange(0x12C8, 0x12D6).addRange(0x12D8, 0x1310).addRange(0x1312, 0x1315).addRange(0x1318, 0x135A).addRange(0x135D, 0x137C).addRange(0x1380, 0x1399).addRange(0x13A0, 0x13F5).addRange(0x13F8, 0x13FD).addRange(0x1400, 0x169C).addRange(0x16A0, 0x16F8).addRange(0x1700, 0x1715).addRange(0x171F, 0x1736).addRange(0x1740, 0x1753).addRange(0x1760, 0x176C).addRange(0x176E, 0x1770).addRange(0x1772, 0x1773).addRange(0x1780, 0x17DD).addRange(0x17E0, 0x17E9).addRange(0x17F0, 0x17F9).addRange(0x1800, 0x1819).addRange(0x1820, 0x1878).addRange(0x1880, 0x18AA).addRange(0x18B0, 0x18F5).addRange(0x1900, 0x191E).addRange(0x1920, 0x192B).addRange(0x1930, 0x193B).addRange(0x1944, 0x196D).addRange(0x1970, 0x1974).addRange(0x1980, 0x19AB).addRange(0x19B0, 0x19C9).addRange(0x19D0, 0x19DA).addRange(0x19DE, 0x1A1B).addRange(0x1A1E, 0x1A5E).addRange(0x1A60, 0x1A7C).addRange(0x1A7F, 0x1A89).addRange(0x1A90, 0x1A99).addRange(0x1AA0, 0x1AAD).addRange(0x1AB0, 0x1ACE).addRange(0x1B00, 0x1B4C).addRange(0x1B50, 0x1B7E).addRange(0x1B80, 0x1BF3).addRange(0x1BFC, 0x1C37).addRange(0x1C3B, 0x1C49).addRange(0x1C4D, 0x1C88).addRange(0x1C90, 0x1CBA).addRange(0x1CBD, 0x1CC7).addRange(0x1CD0, 0x1CFA).addRange(0x1D00, 0x1F15).addRange(0x1F18, 0x1F1D).addRange(0x1F20, 0x1F45).addRange(0x1F48, 0x1F4D);
		    set.addRange(0x1F50, 0x1F57).addRange(0x1F5F, 0x1F7D).addRange(0x1F80, 0x1FB4).addRange(0x1FB6, 0x1FC4).addRange(0x1FC6, 0x1FD3).addRange(0x1FD6, 0x1FDB).addRange(0x1FDD, 0x1FEF).addRange(0x1FF2, 0x1FF4).addRange(0x1FF6, 0x1FFE).addRange(0x2000, 0x2064).addRange(0x2066, 0x2071).addRange(0x2074, 0x208E).addRange(0x2090, 0x209C).addRange(0x20A0, 0x20C0).addRange(0x20D0, 0x20F0).addRange(0x2100, 0x218B).addRange(0x2190, 0x2426).addRange(0x2440, 0x244A).addRange(0x2460, 0x2B73).addRange(0x2B76, 0x2B95).addRange(0x2B97, 0x2CF3).addRange(0x2CF9, 0x2D25).addRange(0x2D30, 0x2D67).addRange(0x2D6F, 0x2D70).addRange(0x2D7F, 0x2D96).addRange(0x2DA0, 0x2DA6).addRange(0x2DA8, 0x2DAE).addRange(0x2DB0, 0x2DB6).addRange(0x2DB8, 0x2DBE).addRange(0x2DC0, 0x2DC6).addRange(0x2DC8, 0x2DCE).addRange(0x2DD0, 0x2DD6).addRange(0x2DD8, 0x2DDE).addRange(0x2DE0, 0x2E5D).addRange(0x2E80, 0x2E99).addRange(0x2E9B, 0x2EF3).addRange(0x2F00, 0x2FD5).addRange(0x2FF0, 0x303F).addRange(0x3041, 0x3096).addRange(0x3099, 0x30FF).addRange(0x3105, 0x312F).addRange(0x3131, 0x318E).addRange(0x3190, 0x31E3).addRange(0x31EF, 0x321E).addRange(0x3220, 0xA48C).addRange(0xA490, 0xA4C6).addRange(0xA4D0, 0xA62B).addRange(0xA640, 0xA6F7).addRange(0xA700, 0xA7CA).addRange(0xA7D0, 0xA7D1).addRange(0xA7D5, 0xA7D9);
		    set.addRange(0xA7F2, 0xA82C).addRange(0xA830, 0xA839).addRange(0xA840, 0xA877).addRange(0xA880, 0xA8C5).addRange(0xA8CE, 0xA8D9).addRange(0xA8E0, 0xA953).addRange(0xA95F, 0xA97C).addRange(0xA980, 0xA9CD).addRange(0xA9CF, 0xA9D9).addRange(0xA9DE, 0xA9FE).addRange(0xAA00, 0xAA36).addRange(0xAA40, 0xAA4D).addRange(0xAA50, 0xAA59).addRange(0xAA5C, 0xAAC2).addRange(0xAADB, 0xAAF6).addRange(0xAB01, 0xAB06).addRange(0xAB09, 0xAB0E).addRange(0xAB11, 0xAB16).addRange(0xAB20, 0xAB26).addRange(0xAB28, 0xAB2E).addRange(0xAB30, 0xAB6B).addRange(0xAB70, 0xABED).addRange(0xABF0, 0xABF9).addRange(0xAC00, 0xD7A3).addRange(0xD7B0, 0xD7C6).addRange(0xD7CB, 0xD7FB).addRange(0xD800, 0xFA6D).addRange(0xFA70, 0xFAD9).addRange(0xFB00, 0xFB06).addRange(0xFB13, 0xFB17).addRange(0xFB1D, 0xFB36).addRange(0xFB38, 0xFB3C).addRange(0xFB40, 0xFB41).addRange(0xFB43, 0xFB44).addRange(0xFB46, 0xFBC2).addRange(0xFBD3, 0xFD8F).addRange(0xFD92, 0xFDC7).addRange(0xFDF0, 0xFE19).addRange(0xFE20, 0xFE52).addRange(0xFE54, 0xFE66).addRange(0xFE68, 0xFE6B).addRange(0xFE70, 0xFE74).addRange(0xFE76, 0xFEFC).addRange(0xFF01, 0xFFBE).addRange(0xFFC2, 0xFFC7).addRange(0xFFCA, 0xFFCF).addRange(0xFFD2, 0xFFD7).addRange(0xFFDA, 0xFFDC).addRange(0xFFE0, 0xFFE6).addRange(0xFFE8, 0xFFEE).addRange(0xFFF9, 0xFFFD);
		    set.addRange(0x10000, 0x1000B).addRange(0x1000D, 0x10026).addRange(0x10028, 0x1003A).addRange(0x1003C, 0x1003D).addRange(0x1003F, 0x1004D).addRange(0x10050, 0x1005D).addRange(0x10080, 0x100FA).addRange(0x10100, 0x10102).addRange(0x10107, 0x10133).addRange(0x10137, 0x1018E).addRange(0x10190, 0x1019C).addRange(0x101D0, 0x101FD).addRange(0x10280, 0x1029C).addRange(0x102A0, 0x102D0).addRange(0x102E0, 0x102FB).addRange(0x10300, 0x10323).addRange(0x1032D, 0x1034A).addRange(0x10350, 0x1037A).addRange(0x10380, 0x1039D).addRange(0x1039F, 0x103C3).addRange(0x103C8, 0x103D5).addRange(0x10400, 0x1049D).addRange(0x104A0, 0x104A9).addRange(0x104B0, 0x104D3).addRange(0x104D8, 0x104FB).addRange(0x10500, 0x10527).addRange(0x10530, 0x10563).addRange(0x1056F, 0x1057A).addRange(0x1057C, 0x1058A).addRange(0x1058C, 0x10592).addRange(0x10594, 0x10595).addRange(0x10597, 0x105A1).addRange(0x105A3, 0x105B1).addRange(0x105B3, 0x105B9).addRange(0x105BB, 0x105BC).addRange(0x10600, 0x10736).addRange(0x10740, 0x10755).addRange(0x10760, 0x10767).addRange(0x10780, 0x10785).addRange(0x10787, 0x107B0).addRange(0x107B2, 0x107BA).addRange(0x10800, 0x10805).addRange(0x1080A, 0x10835).addRange(0x10837, 0x10838).addRange(0x1083F, 0x10855).addRange(0x10857, 0x1089E).addRange(0x108A7, 0x108AF).addRange(0x108E0, 0x108F2).addRange(0x108F4, 0x108F5).addRange(0x108FB, 0x1091B).addRange(0x1091F, 0x10939);
		    set.addRange(0x10980, 0x109B7).addRange(0x109BC, 0x109CF).addRange(0x109D2, 0x10A03).addRange(0x10A05, 0x10A06).addRange(0x10A0C, 0x10A13).addRange(0x10A15, 0x10A17).addRange(0x10A19, 0x10A35).addRange(0x10A38, 0x10A3A).addRange(0x10A3F, 0x10A48).addRange(0x10A50, 0x10A58).addRange(0x10A60, 0x10A9F).addRange(0x10AC0, 0x10AE6).addRange(0x10AEB, 0x10AF6).addRange(0x10B00, 0x10B35).addRange(0x10B39, 0x10B55).addRange(0x10B58, 0x10B72).addRange(0x10B78, 0x10B91).addRange(0x10B99, 0x10B9C).addRange(0x10BA9, 0x10BAF).addRange(0x10C00, 0x10C48).addRange(0x10C80, 0x10CB2).addRange(0x10CC0, 0x10CF2).addRange(0x10CFA, 0x10D27).addRange(0x10D30, 0x10D39).addRange(0x10E60, 0x10E7E).addRange(0x10E80, 0x10EA9).addRange(0x10EAB, 0x10EAD).addRange(0x10EB0, 0x10EB1).addRange(0x10EFD, 0x10F27).addRange(0x10F30, 0x10F59).addRange(0x10F70, 0x10F89).addRange(0x10FB0, 0x10FCB).addRange(0x10FE0, 0x10FF6).addRange(0x11000, 0x1104D).addRange(0x11052, 0x11075).addRange(0x1107F, 0x110C2).addRange(0x110D0, 0x110E8).addRange(0x110F0, 0x110F9).addRange(0x11100, 0x11134).addRange(0x11136, 0x11147).addRange(0x11150, 0x11176).addRange(0x11180, 0x111DF).addRange(0x111E1, 0x111F4).addRange(0x11200, 0x11211).addRange(0x11213, 0x11241).addRange(0x11280, 0x11286).addRange(0x1128A, 0x1128D).addRange(0x1128F, 0x1129D).addRange(0x1129F, 0x112A9).addRange(0x112B0, 0x112EA).addRange(0x112F0, 0x112F9);
		    set.addRange(0x11300, 0x11303).addRange(0x11305, 0x1130C).addRange(0x1130F, 0x11310).addRange(0x11313, 0x11328).addRange(0x1132A, 0x11330).addRange(0x11332, 0x11333).addRange(0x11335, 0x11339).addRange(0x1133B, 0x11344).addRange(0x11347, 0x11348).addRange(0x1134B, 0x1134D).addRange(0x1135D, 0x11363).addRange(0x11366, 0x1136C).addRange(0x11370, 0x11374).addRange(0x11400, 0x1145B).addRange(0x1145D, 0x11461).addRange(0x11480, 0x114C7).addRange(0x114D0, 0x114D9).addRange(0x11580, 0x115B5).addRange(0x115B8, 0x115DD).addRange(0x11600, 0x11644).addRange(0x11650, 0x11659).addRange(0x11660, 0x1166C).addRange(0x11680, 0x116B9).addRange(0x116C0, 0x116C9).addRange(0x11700, 0x1171A).addRange(0x1171D, 0x1172B).addRange(0x11730, 0x11746).addRange(0x11800, 0x1183B).addRange(0x118A0, 0x118F2).addRange(0x118FF, 0x11906).addRange(0x1190C, 0x11913).addRange(0x11915, 0x11916).addRange(0x11918, 0x11935).addRange(0x11937, 0x11938).addRange(0x1193B, 0x11946).addRange(0x11950, 0x11959).addRange(0x119A0, 0x119A7).addRange(0x119AA, 0x119D7).addRange(0x119DA, 0x119E4).addRange(0x11A00, 0x11A47).addRange(0x11A50, 0x11AA2).addRange(0x11AB0, 0x11AF8).addRange(0x11B00, 0x11B09).addRange(0x11C00, 0x11C08).addRange(0x11C0A, 0x11C36).addRange(0x11C38, 0x11C45).addRange(0x11C50, 0x11C6C).addRange(0x11C70, 0x11C8F).addRange(0x11C92, 0x11CA7).addRange(0x11CA9, 0x11CB6).addRange(0x11D00, 0x11D06);
		    set.addRange(0x11D08, 0x11D09).addRange(0x11D0B, 0x11D36).addRange(0x11D3C, 0x11D3D).addRange(0x11D3F, 0x11D47).addRange(0x11D50, 0x11D59).addRange(0x11D60, 0x11D65).addRange(0x11D67, 0x11D68).addRange(0x11D6A, 0x11D8E).addRange(0x11D90, 0x11D91).addRange(0x11D93, 0x11D98).addRange(0x11DA0, 0x11DA9).addRange(0x11EE0, 0x11EF8).addRange(0x11F00, 0x11F10).addRange(0x11F12, 0x11F3A).addRange(0x11F3E, 0x11F59).addRange(0x11FC0, 0x11FF1).addRange(0x11FFF, 0x12399).addRange(0x12400, 0x1246E).addRange(0x12470, 0x12474).addRange(0x12480, 0x12543).addRange(0x12F90, 0x12FF2).addRange(0x13000, 0x13455).addRange(0x14400, 0x14646).addRange(0x16800, 0x16A38).addRange(0x16A40, 0x16A5E).addRange(0x16A60, 0x16A69).addRange(0x16A6E, 0x16ABE).addRange(0x16AC0, 0x16AC9).addRange(0x16AD0, 0x16AED).addRange(0x16AF0, 0x16AF5).addRange(0x16B00, 0x16B45).addRange(0x16B50, 0x16B59).addRange(0x16B5B, 0x16B61).addRange(0x16B63, 0x16B77).addRange(0x16B7D, 0x16B8F).addRange(0x16E40, 0x16E9A).addRange(0x16F00, 0x16F4A).addRange(0x16F4F, 0x16F87).addRange(0x16F8F, 0x16F9F).addRange(0x16FE0, 0x16FE4).addRange(0x16FF0, 0x16FF1).addRange(0x17000, 0x187F7).addRange(0x18800, 0x18CD5).addRange(0x18D00, 0x18D08).addRange(0x1AFF0, 0x1AFF3).addRange(0x1AFF5, 0x1AFFB).addRange(0x1AFFD, 0x1AFFE).addRange(0x1B000, 0x1B122).addRange(0x1B150, 0x1B152).addRange(0x1B164, 0x1B167).addRange(0x1B170, 0x1B2FB);
		    set.addRange(0x1BC00, 0x1BC6A).addRange(0x1BC70, 0x1BC7C).addRange(0x1BC80, 0x1BC88).addRange(0x1BC90, 0x1BC99).addRange(0x1BC9C, 0x1BCA3).addRange(0x1CF00, 0x1CF2D).addRange(0x1CF30, 0x1CF46).addRange(0x1CF50, 0x1CFC3).addRange(0x1D000, 0x1D0F5).addRange(0x1D100, 0x1D126).addRange(0x1D129, 0x1D1EA).addRange(0x1D200, 0x1D245).addRange(0x1D2C0, 0x1D2D3).addRange(0x1D2E0, 0x1D2F3).addRange(0x1D300, 0x1D356).addRange(0x1D360, 0x1D378).addRange(0x1D400, 0x1D454).addRange(0x1D456, 0x1D49C).addRange(0x1D49E, 0x1D49F).addRange(0x1D4A5, 0x1D4A6).addRange(0x1D4A9, 0x1D4AC).addRange(0x1D4AE, 0x1D4B9).addRange(0x1D4BD, 0x1D4C3).addRange(0x1D4C5, 0x1D505).addRange(0x1D507, 0x1D50A).addRange(0x1D50D, 0x1D514).addRange(0x1D516, 0x1D51C).addRange(0x1D51E, 0x1D539).addRange(0x1D53B, 0x1D53E).addRange(0x1D540, 0x1D544).addRange(0x1D54A, 0x1D550).addRange(0x1D552, 0x1D6A5).addRange(0x1D6A8, 0x1D7CB).addRange(0x1D7CE, 0x1DA8B).addRange(0x1DA9B, 0x1DA9F).addRange(0x1DAA1, 0x1DAAF).addRange(0x1DF00, 0x1DF1E).addRange(0x1DF25, 0x1DF2A).addRange(0x1E000, 0x1E006).addRange(0x1E008, 0x1E018).addRange(0x1E01B, 0x1E021).addRange(0x1E023, 0x1E024).addRange(0x1E026, 0x1E02A).addRange(0x1E030, 0x1E06D).addRange(0x1E100, 0x1E12C).addRange(0x1E130, 0x1E13D).addRange(0x1E140, 0x1E149).addRange(0x1E14E, 0x1E14F).addRange(0x1E290, 0x1E2AE).addRange(0x1E2C0, 0x1E2F9).addRange(0x1E4D0, 0x1E4F9);
		    set.addRange(0x1E7E0, 0x1E7E6).addRange(0x1E7E8, 0x1E7EB).addRange(0x1E7ED, 0x1E7EE).addRange(0x1E7F0, 0x1E7FE).addRange(0x1E800, 0x1E8C4).addRange(0x1E8C7, 0x1E8D6).addRange(0x1E900, 0x1E94B).addRange(0x1E950, 0x1E959).addRange(0x1E95E, 0x1E95F).addRange(0x1EC71, 0x1ECB4).addRange(0x1ED01, 0x1ED3D).addRange(0x1EE00, 0x1EE03).addRange(0x1EE05, 0x1EE1F).addRange(0x1EE21, 0x1EE22).addRange(0x1EE29, 0x1EE32).addRange(0x1EE34, 0x1EE37).addRange(0x1EE4D, 0x1EE4F).addRange(0x1EE51, 0x1EE52).addRange(0x1EE61, 0x1EE62).addRange(0x1EE67, 0x1EE6A).addRange(0x1EE6C, 0x1EE72).addRange(0x1EE74, 0x1EE77).addRange(0x1EE79, 0x1EE7C).addRange(0x1EE80, 0x1EE89).addRange(0x1EE8B, 0x1EE9B).addRange(0x1EEA1, 0x1EEA3).addRange(0x1EEA5, 0x1EEA9).addRange(0x1EEAB, 0x1EEBB).addRange(0x1EEF0, 0x1EEF1).addRange(0x1F000, 0x1F02B).addRange(0x1F030, 0x1F093).addRange(0x1F0A0, 0x1F0AE).addRange(0x1F0B1, 0x1F0BF).addRange(0x1F0C1, 0x1F0CF).addRange(0x1F0D1, 0x1F0F5).addRange(0x1F100, 0x1F1AD).addRange(0x1F1E6, 0x1F202).addRange(0x1F210, 0x1F23B).addRange(0x1F240, 0x1F248).addRange(0x1F250, 0x1F251).addRange(0x1F260, 0x1F265).addRange(0x1F300, 0x1F6D7).addRange(0x1F6DC, 0x1F6EC).addRange(0x1F6F0, 0x1F6FC).addRange(0x1F700, 0x1F776).addRange(0x1F77B, 0x1F7D9).addRange(0x1F7E0, 0x1F7EB).addRange(0x1F800, 0x1F80B).addRange(0x1F810, 0x1F847).addRange(0x1F850, 0x1F859).addRange(0x1F860, 0x1F887);
		    set.addRange(0x1F890, 0x1F8AD).addRange(0x1F8B0, 0x1F8B1).addRange(0x1F900, 0x1FA53).addRange(0x1FA60, 0x1FA6D).addRange(0x1FA70, 0x1FA7C).addRange(0x1FA80, 0x1FA88).addRange(0x1FA90, 0x1FABD).addRange(0x1FABF, 0x1FAC5).addRange(0x1FACE, 0x1FADB).addRange(0x1FAE0, 0x1FAE8).addRange(0x1FAF0, 0x1FAF8).addRange(0x1FB00, 0x1FB92).addRange(0x1FB94, 0x1FBCA).addRange(0x1FBF0, 0x1FBF9).addRange(0x20000, 0x2A6DF).addRange(0x2A700, 0x2B739).addRange(0x2B740, 0x2B81D).addRange(0x2B820, 0x2CEA1).addRange(0x2CEB0, 0x2EBE0).addRange(0x2EBF0, 0x2EE5D).addRange(0x2F800, 0x2FA1D).addRange(0x30000, 0x3134A).addRange(0x31350, 0x323AF).addRange(0xE0020, 0xE007F).addRange(0xE0100, 0xE01EF).addRange(0xF0000, 0xFFFFD).addRange(0x100000, 0x10FFFD);
		    Assigned.characters = set;
		    return Assigned;
		  }

		  var Bidi_Control = {};

		  var hasRequiredBidi_Control;
		  function requireBidi_Control() {
		    if (hasRequiredBidi_Control) return Bidi_Control;
		    hasRequiredBidi_Control = 1;
		    var set = regenerateExports(0x61C);
		    set.addRange(0x200E, 0x200F).addRange(0x202A, 0x202E).addRange(0x2066, 0x2069);
		    Bidi_Control.characters = set;
		    return Bidi_Control;
		  }

		  var Bidi_Mirrored = {};

		  var hasRequiredBidi_Mirrored;
		  function requireBidi_Mirrored() {
		    if (hasRequiredBidi_Mirrored) return Bidi_Mirrored;
		    hasRequiredBidi_Mirrored = 1;
		    var set = regenerateExports(0x3C, 0x3E, 0x5B, 0x5D, 0x7B, 0x7D, 0xAB, 0xBB, 0x2140, 0x2211, 0x2224, 0x2226, 0x2239, 0x2262, 0x2298, 0x27C0, 0x29B8, 0x29C9, 0x29E1, 0x2A24, 0x2A26, 0x2A29, 0x2ADC, 0x2ADE, 0x2AF3, 0x2AFD, 0x2BFE, 0xFF1C, 0xFF1E, 0xFF3B, 0xFF3D, 0xFF5B, 0xFF5D, 0x1D6DB, 0x1D715, 0x1D74F, 0x1D789, 0x1D7C3);
		    set.addRange(0x28, 0x29).addRange(0xF3A, 0xF3D).addRange(0x169B, 0x169C).addRange(0x2039, 0x203A).addRange(0x2045, 0x2046).addRange(0x207D, 0x207E).addRange(0x208D, 0x208E).addRange(0x2201, 0x2204).addRange(0x2208, 0x220D).addRange(0x2215, 0x2216).addRange(0x221A, 0x221D).addRange(0x221F, 0x2222).addRange(0x222B, 0x2233).addRange(0x223B, 0x224C).addRange(0x2252, 0x2255).addRange(0x225F, 0x2260).addRange(0x2264, 0x226B).addRange(0x226E, 0x228C).addRange(0x228F, 0x2292).addRange(0x22A2, 0x22A3).addRange(0x22A6, 0x22B8).addRange(0x22BE, 0x22BF).addRange(0x22C9, 0x22CD).addRange(0x22D0, 0x22D1).addRange(0x22D6, 0x22ED).addRange(0x22F0, 0x22FF).addRange(0x2308, 0x230B).addRange(0x2320, 0x2321).addRange(0x2329, 0x232A).addRange(0x2768, 0x2775).addRange(0x27C3, 0x27C6).addRange(0x27C8, 0x27C9).addRange(0x27CB, 0x27CD).addRange(0x27D3, 0x27D6).addRange(0x27DC, 0x27DE).addRange(0x27E2, 0x27EF).addRange(0x2983, 0x2998).addRange(0x299B, 0x29A0).addRange(0x29A2, 0x29AF).addRange(0x29C0, 0x29C5).addRange(0x29CE, 0x29D2).addRange(0x29D4, 0x29D5).addRange(0x29D8, 0x29DC).addRange(0x29E3, 0x29E5).addRange(0x29E8, 0x29E9).addRange(0x29F4, 0x29F9).addRange(0x29FC, 0x29FD).addRange(0x2A0A, 0x2A1C).addRange(0x2A1E, 0x2A21).addRange(0x2A2B, 0x2A2E).addRange(0x2A34, 0x2A35);
		    set.addRange(0x2A3C, 0x2A3E).addRange(0x2A57, 0x2A58).addRange(0x2A64, 0x2A65).addRange(0x2A6A, 0x2A6D).addRange(0x2A6F, 0x2A70).addRange(0x2A73, 0x2A74).addRange(0x2A79, 0x2AA3).addRange(0x2AA6, 0x2AAD).addRange(0x2AAF, 0x2AD6).addRange(0x2AE2, 0x2AE6).addRange(0x2AEC, 0x2AEE).addRange(0x2AF7, 0x2AFB).addRange(0x2E02, 0x2E05).addRange(0x2E09, 0x2E0A).addRange(0x2E0C, 0x2E0D).addRange(0x2E1C, 0x2E1D).addRange(0x2E20, 0x2E29).addRange(0x2E55, 0x2E5C).addRange(0x3008, 0x3011).addRange(0x3014, 0x301B).addRange(0xFE59, 0xFE5E).addRange(0xFE64, 0xFE65).addRange(0xFF08, 0xFF09).addRange(0xFF5F, 0xFF60).addRange(0xFF62, 0xFF63);
		    Bidi_Mirrored.characters = set;
		    return Bidi_Mirrored;
		  }

		  var Case_Ignorable = {};

		  var hasRequiredCase_Ignorable;
		  function requireCase_Ignorable() {
		    if (hasRequiredCase_Ignorable) return Case_Ignorable;
		    hasRequiredCase_Ignorable = 1;
		    var set = regenerateExports(0x27, 0x2E, 0x3A, 0x5E, 0x60, 0xA8, 0xAD, 0xAF, 0xB4, 0x37A, 0x387, 0x559, 0x55F, 0x5BF, 0x5C7, 0x5F4, 0x61C, 0x640, 0x670, 0x70F, 0x711, 0x7FA, 0x7FD, 0x888, 0x93A, 0x93C, 0x94D, 0x971, 0x981, 0x9BC, 0x9CD, 0x9FE, 0xA3C, 0xA51, 0xA75, 0xABC, 0xACD, 0xB01, 0xB3C, 0xB3F, 0xB4D, 0xB82, 0xBC0, 0xBCD, 0xC00, 0xC04, 0xC3C, 0xC81, 0xCBC, 0xCBF, 0xCC6, 0xD4D, 0xD81, 0xDCA, 0xDD6, 0xE31, 0xEB1, 0xEC6, 0xF35, 0xF37, 0xF39, 0xFC6, 0x1082, 0x108D, 0x109D, 0x10FC, 0x17C6, 0x17D7, 0x17DD, 0x1843, 0x18A9, 0x1932, 0x1A1B, 0x1A56, 0x1A60, 0x1A62, 0x1A7F, 0x1AA7, 0x1B34, 0x1B3C, 0x1B42, 0x1BE6, 0x1BED, 0x1CED, 0x1CF4, 0x1D78, 0x1FBD, 0x2024, 0x2027, 0x2071, 0x207F, 0x2D6F, 0x2D7F, 0x2E2F, 0x3005, 0x303B, 0xA015, 0xA60C, 0xA67F, 0xA770, 0xA802, 0xA806, 0xA80B, 0xA82C, 0xA8FF, 0xA9B3, 0xA9CF, 0xAA43, 0xAA4C, 0xAA70, 0xAA7C, 0xAAB0, 0xAAC1, 0xAADD, 0xAAF6, 0xABE5, 0xABE8, 0xABED, 0xFB1E, 0xFE13, 0xFE52, 0xFE55, 0xFEFF, 0xFF07, 0xFF0E, 0xFF1A, 0xFF3E, 0xFF40, 0xFF70, 0xFFE3, 0x101FD, 0x102E0, 0x10A3F, 0x11001, 0x11070, 0x110BD, 0x110C2, 0x110CD, 0x11173, 0x111CF, 0x11234, 0x1123E, 0x11241, 0x112DF, 0x11340, 0x11446, 0x1145E, 0x114BA, 0x1163D, 0x116AB, 0x116AD, 0x116B7, 0x1193E, 0x11943, 0x119E0, 0x11A47, 0x11C3F, 0x11D3A, 0x11D47, 0x11D95, 0x11D97, 0x11F40, 0x11F42, 0x16F4F, 0x1DA75, 0x1DA84, 0x1E08F, 0x1E2AE, 0xE0001);
		    set.addRange(0xB7, 0xB8).addRange(0x2B0, 0x36F).addRange(0x374, 0x375).addRange(0x384, 0x385).addRange(0x483, 0x489).addRange(0x591, 0x5BD).addRange(0x5C1, 0x5C2).addRange(0x5C4, 0x5C5).addRange(0x600, 0x605).addRange(0x610, 0x61A).addRange(0x64B, 0x65F).addRange(0x6D6, 0x6DD).addRange(0x6DF, 0x6E8).addRange(0x6EA, 0x6ED).addRange(0x730, 0x74A).addRange(0x7A6, 0x7B0).addRange(0x7EB, 0x7F5).addRange(0x816, 0x82D).addRange(0x859, 0x85B).addRange(0x890, 0x891).addRange(0x898, 0x89F).addRange(0x8C9, 0x902).addRange(0x941, 0x948).addRange(0x951, 0x957).addRange(0x962, 0x963).addRange(0x9C1, 0x9C4).addRange(0x9E2, 0x9E3).addRange(0xA01, 0xA02).addRange(0xA41, 0xA42).addRange(0xA47, 0xA48).addRange(0xA4B, 0xA4D).addRange(0xA70, 0xA71).addRange(0xA81, 0xA82).addRange(0xAC1, 0xAC5).addRange(0xAC7, 0xAC8).addRange(0xAE2, 0xAE3).addRange(0xAFA, 0xAFF).addRange(0xB41, 0xB44).addRange(0xB55, 0xB56).addRange(0xB62, 0xB63).addRange(0xC3E, 0xC40).addRange(0xC46, 0xC48).addRange(0xC4A, 0xC4D).addRange(0xC55, 0xC56).addRange(0xC62, 0xC63).addRange(0xCCC, 0xCCD).addRange(0xCE2, 0xCE3).addRange(0xD00, 0xD01).addRange(0xD3B, 0xD3C).addRange(0xD41, 0xD44).addRange(0xD62, 0xD63);
		    set.addRange(0xDD2, 0xDD4).addRange(0xE34, 0xE3A).addRange(0xE46, 0xE4E).addRange(0xEB4, 0xEBC).addRange(0xEC8, 0xECE).addRange(0xF18, 0xF19).addRange(0xF71, 0xF7E).addRange(0xF80, 0xF84).addRange(0xF86, 0xF87).addRange(0xF8D, 0xF97).addRange(0xF99, 0xFBC).addRange(0x102D, 0x1030).addRange(0x1032, 0x1037).addRange(0x1039, 0x103A).addRange(0x103D, 0x103E).addRange(0x1058, 0x1059).addRange(0x105E, 0x1060).addRange(0x1071, 0x1074).addRange(0x1085, 0x1086).addRange(0x135D, 0x135F).addRange(0x1712, 0x1714).addRange(0x1732, 0x1733).addRange(0x1752, 0x1753).addRange(0x1772, 0x1773).addRange(0x17B4, 0x17B5).addRange(0x17B7, 0x17BD).addRange(0x17C9, 0x17D3).addRange(0x180B, 0x180F).addRange(0x1885, 0x1886).addRange(0x1920, 0x1922).addRange(0x1927, 0x1928).addRange(0x1939, 0x193B).addRange(0x1A17, 0x1A18).addRange(0x1A58, 0x1A5E).addRange(0x1A65, 0x1A6C).addRange(0x1A73, 0x1A7C).addRange(0x1AB0, 0x1ACE).addRange(0x1B00, 0x1B03).addRange(0x1B36, 0x1B3A).addRange(0x1B6B, 0x1B73).addRange(0x1B80, 0x1B81).addRange(0x1BA2, 0x1BA5).addRange(0x1BA8, 0x1BA9).addRange(0x1BAB, 0x1BAD).addRange(0x1BE8, 0x1BE9).addRange(0x1BEF, 0x1BF1).addRange(0x1C2C, 0x1C33).addRange(0x1C36, 0x1C37).addRange(0x1C78, 0x1C7D).addRange(0x1CD0, 0x1CD2).addRange(0x1CD4, 0x1CE0);
		    set.addRange(0x1CE2, 0x1CE8).addRange(0x1CF8, 0x1CF9).addRange(0x1D2C, 0x1D6A).addRange(0x1D9B, 0x1DFF).addRange(0x1FBF, 0x1FC1).addRange(0x1FCD, 0x1FCF).addRange(0x1FDD, 0x1FDF).addRange(0x1FED, 0x1FEF).addRange(0x1FFD, 0x1FFE).addRange(0x200B, 0x200F).addRange(0x2018, 0x2019).addRange(0x202A, 0x202E).addRange(0x2060, 0x2064).addRange(0x2066, 0x206F).addRange(0x2090, 0x209C).addRange(0x20D0, 0x20F0).addRange(0x2C7C, 0x2C7D).addRange(0x2CEF, 0x2CF1).addRange(0x2DE0, 0x2DFF).addRange(0x302A, 0x302D).addRange(0x3031, 0x3035).addRange(0x3099, 0x309E).addRange(0x30FC, 0x30FE).addRange(0xA4F8, 0xA4FD).addRange(0xA66F, 0xA672).addRange(0xA674, 0xA67D).addRange(0xA69C, 0xA69F).addRange(0xA6F0, 0xA6F1).addRange(0xA700, 0xA721).addRange(0xA788, 0xA78A).addRange(0xA7F2, 0xA7F4).addRange(0xA7F8, 0xA7F9).addRange(0xA825, 0xA826).addRange(0xA8C4, 0xA8C5).addRange(0xA8E0, 0xA8F1).addRange(0xA926, 0xA92D).addRange(0xA947, 0xA951).addRange(0xA980, 0xA982).addRange(0xA9B6, 0xA9B9).addRange(0xA9BC, 0xA9BD).addRange(0xA9E5, 0xA9E6).addRange(0xAA29, 0xAA2E).addRange(0xAA31, 0xAA32).addRange(0xAA35, 0xAA36).addRange(0xAAB2, 0xAAB4).addRange(0xAAB7, 0xAAB8).addRange(0xAABE, 0xAABF).addRange(0xAAEC, 0xAAED).addRange(0xAAF3, 0xAAF4).addRange(0xAB5B, 0xAB5F).addRange(0xAB69, 0xAB6B);
		    set.addRange(0xFBB2, 0xFBC2).addRange(0xFE00, 0xFE0F).addRange(0xFE20, 0xFE2F).addRange(0xFF9E, 0xFF9F).addRange(0xFFF9, 0xFFFB).addRange(0x10376, 0x1037A).addRange(0x10780, 0x10785).addRange(0x10787, 0x107B0).addRange(0x107B2, 0x107BA).addRange(0x10A01, 0x10A03).addRange(0x10A05, 0x10A06).addRange(0x10A0C, 0x10A0F).addRange(0x10A38, 0x10A3A).addRange(0x10AE5, 0x10AE6).addRange(0x10D24, 0x10D27).addRange(0x10EAB, 0x10EAC).addRange(0x10EFD, 0x10EFF).addRange(0x10F46, 0x10F50).addRange(0x10F82, 0x10F85).addRange(0x11038, 0x11046).addRange(0x11073, 0x11074).addRange(0x1107F, 0x11081).addRange(0x110B3, 0x110B6).addRange(0x110B9, 0x110BA).addRange(0x11100, 0x11102).addRange(0x11127, 0x1112B).addRange(0x1112D, 0x11134).addRange(0x11180, 0x11181).addRange(0x111B6, 0x111BE).addRange(0x111C9, 0x111CC).addRange(0x1122F, 0x11231).addRange(0x11236, 0x11237).addRange(0x112E3, 0x112EA).addRange(0x11300, 0x11301).addRange(0x1133B, 0x1133C).addRange(0x11366, 0x1136C).addRange(0x11370, 0x11374).addRange(0x11438, 0x1143F).addRange(0x11442, 0x11444).addRange(0x114B3, 0x114B8).addRange(0x114BF, 0x114C0).addRange(0x114C2, 0x114C3).addRange(0x115B2, 0x115B5).addRange(0x115BC, 0x115BD).addRange(0x115BF, 0x115C0).addRange(0x115DC, 0x115DD).addRange(0x11633, 0x1163A).addRange(0x1163F, 0x11640).addRange(0x116B0, 0x116B5).addRange(0x1171D, 0x1171F).addRange(0x11722, 0x11725);
		    set.addRange(0x11727, 0x1172B).addRange(0x1182F, 0x11837).addRange(0x11839, 0x1183A).addRange(0x1193B, 0x1193C).addRange(0x119D4, 0x119D7).addRange(0x119DA, 0x119DB).addRange(0x11A01, 0x11A0A).addRange(0x11A33, 0x11A38).addRange(0x11A3B, 0x11A3E).addRange(0x11A51, 0x11A56).addRange(0x11A59, 0x11A5B).addRange(0x11A8A, 0x11A96).addRange(0x11A98, 0x11A99).addRange(0x11C30, 0x11C36).addRange(0x11C38, 0x11C3D).addRange(0x11C92, 0x11CA7).addRange(0x11CAA, 0x11CB0).addRange(0x11CB2, 0x11CB3).addRange(0x11CB5, 0x11CB6).addRange(0x11D31, 0x11D36).addRange(0x11D3C, 0x11D3D).addRange(0x11D3F, 0x11D45).addRange(0x11D90, 0x11D91).addRange(0x11EF3, 0x11EF4).addRange(0x11F00, 0x11F01).addRange(0x11F36, 0x11F3A).addRange(0x13430, 0x13440).addRange(0x13447, 0x13455).addRange(0x16AF0, 0x16AF4).addRange(0x16B30, 0x16B36).addRange(0x16B40, 0x16B43).addRange(0x16F8F, 0x16F9F).addRange(0x16FE0, 0x16FE1).addRange(0x16FE3, 0x16FE4).addRange(0x1AFF0, 0x1AFF3).addRange(0x1AFF5, 0x1AFFB).addRange(0x1AFFD, 0x1AFFE).addRange(0x1BC9D, 0x1BC9E).addRange(0x1BCA0, 0x1BCA3).addRange(0x1CF00, 0x1CF2D).addRange(0x1CF30, 0x1CF46).addRange(0x1D167, 0x1D169).addRange(0x1D173, 0x1D182).addRange(0x1D185, 0x1D18B).addRange(0x1D1AA, 0x1D1AD).addRange(0x1D242, 0x1D244).addRange(0x1DA00, 0x1DA36).addRange(0x1DA3B, 0x1DA6C).addRange(0x1DA9B, 0x1DA9F).addRange(0x1DAA1, 0x1DAAF).addRange(0x1E000, 0x1E006);
		    set.addRange(0x1E008, 0x1E018).addRange(0x1E01B, 0x1E021).addRange(0x1E023, 0x1E024).addRange(0x1E026, 0x1E02A).addRange(0x1E030, 0x1E06D).addRange(0x1E130, 0x1E13D).addRange(0x1E2EC, 0x1E2EF).addRange(0x1E4EB, 0x1E4EF).addRange(0x1E8D0, 0x1E8D6).addRange(0x1E944, 0x1E94B).addRange(0x1F3FB, 0x1F3FF).addRange(0xE0020, 0xE007F).addRange(0xE0100, 0xE01EF);
		    Case_Ignorable.characters = set;
		    return Case_Ignorable;
		  }

		  var Cased = {};

		  var hasRequiredCased;
		  function requireCased() {
		    if (hasRequiredCased) return Cased;
		    hasRequiredCased = 1;
		    var set = regenerateExports(0xAA, 0xB5, 0xBA, 0x345, 0x37F, 0x386, 0x38C, 0x10C7, 0x10CD, 0x1F59, 0x1F5B, 0x1F5D, 0x1FBE, 0x2071, 0x207F, 0x2102, 0x2107, 0x2115, 0x2124, 0x2126, 0x2128, 0x2139, 0x214E, 0x2D27, 0x2D2D, 0xA7D3, 0x10780, 0x1D4A2, 0x1D4BB, 0x1D546);
		    set.addRange(0x41, 0x5A).addRange(0x61, 0x7A).addRange(0xC0, 0xD6).addRange(0xD8, 0xF6).addRange(0xF8, 0x1BA).addRange(0x1BC, 0x1BF).addRange(0x1C4, 0x293).addRange(0x295, 0x2B8).addRange(0x2C0, 0x2C1).addRange(0x2E0, 0x2E4).addRange(0x370, 0x373).addRange(0x376, 0x377).addRange(0x37A, 0x37D).addRange(0x388, 0x38A).addRange(0x38E, 0x3A1).addRange(0x3A3, 0x3F5).addRange(0x3F7, 0x481).addRange(0x48A, 0x52F).addRange(0x531, 0x556).addRange(0x560, 0x588).addRange(0x10A0, 0x10C5).addRange(0x10D0, 0x10FA).addRange(0x10FC, 0x10FF).addRange(0x13A0, 0x13F5).addRange(0x13F8, 0x13FD).addRange(0x1C80, 0x1C88).addRange(0x1C90, 0x1CBA).addRange(0x1CBD, 0x1CBF).addRange(0x1D00, 0x1DBF).addRange(0x1E00, 0x1F15).addRange(0x1F18, 0x1F1D).addRange(0x1F20, 0x1F45).addRange(0x1F48, 0x1F4D).addRange(0x1F50, 0x1F57).addRange(0x1F5F, 0x1F7D).addRange(0x1F80, 0x1FB4).addRange(0x1FB6, 0x1FBC).addRange(0x1FC2, 0x1FC4).addRange(0x1FC6, 0x1FCC).addRange(0x1FD0, 0x1FD3).addRange(0x1FD6, 0x1FDB).addRange(0x1FE0, 0x1FEC).addRange(0x1FF2, 0x1FF4).addRange(0x1FF6, 0x1FFC).addRange(0x2090, 0x209C).addRange(0x210A, 0x2113).addRange(0x2119, 0x211D).addRange(0x212A, 0x212D).addRange(0x212F, 0x2134).addRange(0x213C, 0x213F).addRange(0x2145, 0x2149);
		    set.addRange(0x2160, 0x217F).addRange(0x2183, 0x2184).addRange(0x24B6, 0x24E9).addRange(0x2C00, 0x2CE4).addRange(0x2CEB, 0x2CEE).addRange(0x2CF2, 0x2CF3).addRange(0x2D00, 0x2D25).addRange(0xA640, 0xA66D).addRange(0xA680, 0xA69D).addRange(0xA722, 0xA787).addRange(0xA78B, 0xA78E).addRange(0xA790, 0xA7CA).addRange(0xA7D0, 0xA7D1).addRange(0xA7D5, 0xA7D9).addRange(0xA7F2, 0xA7F6).addRange(0xA7F8, 0xA7FA).addRange(0xAB30, 0xAB5A).addRange(0xAB5C, 0xAB69).addRange(0xAB70, 0xABBF).addRange(0xFB00, 0xFB06).addRange(0xFB13, 0xFB17).addRange(0xFF21, 0xFF3A).addRange(0xFF41, 0xFF5A).addRange(0x10400, 0x1044F).addRange(0x104B0, 0x104D3).addRange(0x104D8, 0x104FB).addRange(0x10570, 0x1057A).addRange(0x1057C, 0x1058A).addRange(0x1058C, 0x10592).addRange(0x10594, 0x10595).addRange(0x10597, 0x105A1).addRange(0x105A3, 0x105B1).addRange(0x105B3, 0x105B9).addRange(0x105BB, 0x105BC).addRange(0x10783, 0x10785).addRange(0x10787, 0x107B0).addRange(0x107B2, 0x107BA).addRange(0x10C80, 0x10CB2).addRange(0x10CC0, 0x10CF2).addRange(0x118A0, 0x118DF).addRange(0x16E40, 0x16E7F).addRange(0x1D400, 0x1D454).addRange(0x1D456, 0x1D49C).addRange(0x1D49E, 0x1D49F).addRange(0x1D4A5, 0x1D4A6).addRange(0x1D4A9, 0x1D4AC).addRange(0x1D4AE, 0x1D4B9).addRange(0x1D4BD, 0x1D4C3).addRange(0x1D4C5, 0x1D505).addRange(0x1D507, 0x1D50A).addRange(0x1D50D, 0x1D514);
		    set.addRange(0x1D516, 0x1D51C).addRange(0x1D51E, 0x1D539).addRange(0x1D53B, 0x1D53E).addRange(0x1D540, 0x1D544).addRange(0x1D54A, 0x1D550).addRange(0x1D552, 0x1D6A5).addRange(0x1D6A8, 0x1D6C0).addRange(0x1D6C2, 0x1D6DA).addRange(0x1D6DC, 0x1D6FA).addRange(0x1D6FC, 0x1D714).addRange(0x1D716, 0x1D734).addRange(0x1D736, 0x1D74E).addRange(0x1D750, 0x1D76E).addRange(0x1D770, 0x1D788).addRange(0x1D78A, 0x1D7A8).addRange(0x1D7AA, 0x1D7C2).addRange(0x1D7C4, 0x1D7CB).addRange(0x1DF00, 0x1DF09).addRange(0x1DF0B, 0x1DF1E).addRange(0x1DF25, 0x1DF2A).addRange(0x1E030, 0x1E06D).addRange(0x1E900, 0x1E943).addRange(0x1F130, 0x1F149).addRange(0x1F150, 0x1F169).addRange(0x1F170, 0x1F189);
		    Cased.characters = set;
		    return Cased;
		  }

		  var Changes_When_Casefolded = {};

		  var hasRequiredChanges_When_Casefolded;
		  function requireChanges_When_Casefolded() {
		    if (hasRequiredChanges_When_Casefolded) return Changes_When_Casefolded;
		    hasRequiredChanges_When_Casefolded = 1;
		    var set = regenerateExports(0xB5, 0x100, 0x102, 0x104, 0x106, 0x108, 0x10A, 0x10C, 0x10E, 0x110, 0x112, 0x114, 0x116, 0x118, 0x11A, 0x11C, 0x11E, 0x120, 0x122, 0x124, 0x126, 0x128, 0x12A, 0x12C, 0x12E, 0x130, 0x132, 0x134, 0x136, 0x139, 0x13B, 0x13D, 0x13F, 0x141, 0x143, 0x145, 0x147, 0x14C, 0x14E, 0x150, 0x152, 0x154, 0x156, 0x158, 0x15A, 0x15C, 0x15E, 0x160, 0x162, 0x164, 0x166, 0x168, 0x16A, 0x16C, 0x16E, 0x170, 0x172, 0x174, 0x176, 0x17B, 0x17D, 0x17F, 0x184, 0x1A2, 0x1A4, 0x1A9, 0x1AC, 0x1B5, 0x1BC, 0x1CD, 0x1CF, 0x1D1, 0x1D3, 0x1D5, 0x1D7, 0x1D9, 0x1DB, 0x1DE, 0x1E0, 0x1E2, 0x1E4, 0x1E6, 0x1E8, 0x1EA, 0x1EC, 0x1EE, 0x1F4, 0x1FA, 0x1FC, 0x1FE, 0x200, 0x202, 0x204, 0x206, 0x208, 0x20A, 0x20C, 0x20E, 0x210, 0x212, 0x214, 0x216, 0x218, 0x21A, 0x21C, 0x21E, 0x220, 0x222, 0x224, 0x226, 0x228, 0x22A, 0x22C, 0x22E, 0x230, 0x232, 0x241, 0x248, 0x24A, 0x24C, 0x24E, 0x345, 0x370, 0x372, 0x376, 0x37F, 0x386, 0x38C, 0x3C2, 0x3D8, 0x3DA, 0x3DC, 0x3DE, 0x3E0, 0x3E2, 0x3E4, 0x3E6, 0x3E8, 0x3EA, 0x3EC, 0x3EE, 0x3F7, 0x460, 0x462, 0x464, 0x466, 0x468, 0x46A, 0x46C, 0x46E, 0x470, 0x472, 0x474, 0x476, 0x478, 0x47A, 0x47C, 0x47E, 0x480, 0x48A, 0x48C, 0x48E, 0x490, 0x492, 0x494, 0x496, 0x498, 0x49A, 0x49C, 0x49E, 0x4A0, 0x4A2, 0x4A4, 0x4A6, 0x4A8, 0x4AA, 0x4AC, 0x4AE, 0x4B0, 0x4B2, 0x4B4, 0x4B6, 0x4B8, 0x4BA, 0x4BC, 0x4BE, 0x4C3, 0x4C5, 0x4C7, 0x4C9, 0x4CB, 0x4CD, 0x4D0, 0x4D2, 0x4D4, 0x4D6, 0x4D8, 0x4DA, 0x4DC, 0x4DE, 0x4E0, 0x4E2, 0x4E4, 0x4E6, 0x4E8, 0x4EA, 0x4EC, 0x4EE, 0x4F0, 0x4F2, 0x4F4, 0x4F6, 0x4F8, 0x4FA, 0x4FC, 0x4FE, 0x500, 0x502, 0x504, 0x506, 0x508, 0x50A, 0x50C, 0x50E, 0x510, 0x512, 0x514, 0x516, 0x518, 0x51A, 0x51C, 0x51E, 0x520, 0x522, 0x524, 0x526, 0x528, 0x52A, 0x52C, 0x52E, 0x587, 0x10C7, 0x10CD, 0x1E00, 0x1E02, 0x1E04, 0x1E06, 0x1E08, 0x1E0A, 0x1E0C, 0x1E0E, 0x1E10, 0x1E12, 0x1E14, 0x1E16, 0x1E18, 0x1E1A, 0x1E1C, 0x1E1E, 0x1E20, 0x1E22, 0x1E24, 0x1E26, 0x1E28, 0x1E2A, 0x1E2C, 0x1E2E, 0x1E30, 0x1E32, 0x1E34, 0x1E36, 0x1E38, 0x1E3A, 0x1E3C, 0x1E3E, 0x1E40, 0x1E42, 0x1E44, 0x1E46, 0x1E48, 0x1E4A, 0x1E4C, 0x1E4E, 0x1E50, 0x1E52, 0x1E54, 0x1E56, 0x1E58, 0x1E5A, 0x1E5C, 0x1E5E, 0x1E60, 0x1E62, 0x1E64, 0x1E66, 0x1E68, 0x1E6A, 0x1E6C, 0x1E6E, 0x1E70, 0x1E72, 0x1E74, 0x1E76, 0x1E78, 0x1E7A, 0x1E7C, 0x1E7E, 0x1E80, 0x1E82, 0x1E84, 0x1E86, 0x1E88, 0x1E8A, 0x1E8C, 0x1E8E, 0x1E90, 0x1E92, 0x1E94, 0x1E9E, 0x1EA0, 0x1EA2, 0x1EA4, 0x1EA6, 0x1EA8, 0x1EAA, 0x1EAC, 0x1EAE, 0x1EB0, 0x1EB2, 0x1EB4, 0x1EB6, 0x1EB8, 0x1EBA, 0x1EBC, 0x1EBE, 0x1EC0, 0x1EC2, 0x1EC4, 0x1EC6, 0x1EC8, 0x1ECA, 0x1ECC, 0x1ECE, 0x1ED0, 0x1ED2, 0x1ED4, 0x1ED6, 0x1ED8, 0x1EDA, 0x1EDC, 0x1EDE, 0x1EE0, 0x1EE2, 0x1EE4, 0x1EE6, 0x1EE8, 0x1EEA, 0x1EEC, 0x1EEE, 0x1EF0, 0x1EF2, 0x1EF4, 0x1EF6, 0x1EF8, 0x1EFA, 0x1EFC, 0x1EFE, 0x1F59, 0x1F5B, 0x1F5D, 0x1F5F, 0x2126, 0x2132, 0x2183, 0x2C60, 0x2C67, 0x2C69, 0x2C6B, 0x2C72, 0x2C75, 0x2C82, 0x2C84, 0x2C86, 0x2C88, 0x2C8A, 0x2C8C, 0x2C8E, 0x2C90, 0x2C92, 0x2C94, 0x2C96, 0x2C98, 0x2C9A, 0x2C9C, 0x2C9E, 0x2CA0, 0x2CA2, 0x2CA4, 0x2CA6, 0x2CA8, 0x2CAA, 0x2CAC, 0x2CAE, 0x2CB0, 0x2CB2, 0x2CB4, 0x2CB6, 0x2CB8, 0x2CBA, 0x2CBC, 0x2CBE, 0x2CC0, 0x2CC2, 0x2CC4, 0x2CC6, 0x2CC8, 0x2CCA, 0x2CCC, 0x2CCE, 0x2CD0, 0x2CD2, 0x2CD4, 0x2CD6, 0x2CD8, 0x2CDA, 0x2CDC, 0x2CDE, 0x2CE0, 0x2CE2, 0x2CEB, 0x2CED, 0x2CF2, 0xA640, 0xA642, 0xA644, 0xA646, 0xA648, 0xA64A, 0xA64C, 0xA64E, 0xA650, 0xA652, 0xA654, 0xA656, 0xA658, 0xA65A, 0xA65C, 0xA65E, 0xA660, 0xA662, 0xA664, 0xA666, 0xA668, 0xA66A, 0xA66C, 0xA680, 0xA682, 0xA684, 0xA686, 0xA688, 0xA68A, 0xA68C, 0xA68E, 0xA690, 0xA692, 0xA694, 0xA696, 0xA698, 0xA69A, 0xA722, 0xA724, 0xA726, 0xA728, 0xA72A, 0xA72C, 0xA72E, 0xA732, 0xA734, 0xA736, 0xA738, 0xA73A, 0xA73C, 0xA73E, 0xA740, 0xA742, 0xA744, 0xA746, 0xA748, 0xA74A, 0xA74C, 0xA74E, 0xA750, 0xA752, 0xA754, 0xA756, 0xA758, 0xA75A, 0xA75C, 0xA75E, 0xA760, 0xA762, 0xA764, 0xA766, 0xA768, 0xA76A, 0xA76C, 0xA76E, 0xA779, 0xA77B, 0xA780, 0xA782, 0xA784, 0xA786, 0xA78B, 0xA78D, 0xA790, 0xA792, 0xA796, 0xA798, 0xA79A, 0xA79C, 0xA79E, 0xA7A0, 0xA7A2, 0xA7A4, 0xA7A6, 0xA7A8, 0xA7B6, 0xA7B8, 0xA7BA, 0xA7BC, 0xA7BE, 0xA7C0, 0xA7C2, 0xA7C9, 0xA7D0, 0xA7D6, 0xA7D8, 0xA7F5);
		    set.addRange(0x41, 0x5A).addRange(0xC0, 0xD6).addRange(0xD8, 0xDF).addRange(0x149, 0x14A).addRange(0x178, 0x179).addRange(0x181, 0x182).addRange(0x186, 0x187).addRange(0x189, 0x18B).addRange(0x18E, 0x191).addRange(0x193, 0x194).addRange(0x196, 0x198).addRange(0x19C, 0x19D).addRange(0x19F, 0x1A0).addRange(0x1A6, 0x1A7).addRange(0x1AE, 0x1AF).addRange(0x1B1, 0x1B3).addRange(0x1B7, 0x1B8).addRange(0x1C4, 0x1C5).addRange(0x1C7, 0x1C8).addRange(0x1CA, 0x1CB).addRange(0x1F1, 0x1F2).addRange(0x1F6, 0x1F8).addRange(0x23A, 0x23B).addRange(0x23D, 0x23E).addRange(0x243, 0x246).addRange(0x388, 0x38A).addRange(0x38E, 0x38F).addRange(0x391, 0x3A1).addRange(0x3A3, 0x3AB).addRange(0x3CF, 0x3D1).addRange(0x3D5, 0x3D6).addRange(0x3F0, 0x3F1).addRange(0x3F4, 0x3F5).addRange(0x3F9, 0x3FA).addRange(0x3FD, 0x42F).addRange(0x4C0, 0x4C1).addRange(0x531, 0x556).addRange(0x10A0, 0x10C5).addRange(0x13F8, 0x13FD).addRange(0x1C80, 0x1C88).addRange(0x1C90, 0x1CBA).addRange(0x1CBD, 0x1CBF).addRange(0x1E9A, 0x1E9B).addRange(0x1F08, 0x1F0F).addRange(0x1F18, 0x1F1D).addRange(0x1F28, 0x1F2F).addRange(0x1F38, 0x1F3F).addRange(0x1F48, 0x1F4D).addRange(0x1F68, 0x1F6F).addRange(0x1F80, 0x1FAF).addRange(0x1FB2, 0x1FB4);
		    set.addRange(0x1FB7, 0x1FBC).addRange(0x1FC2, 0x1FC4).addRange(0x1FC7, 0x1FCC).addRange(0x1FD8, 0x1FDB).addRange(0x1FE8, 0x1FEC).addRange(0x1FF2, 0x1FF4).addRange(0x1FF7, 0x1FFC).addRange(0x212A, 0x212B).addRange(0x2160, 0x216F).addRange(0x24B6, 0x24CF).addRange(0x2C00, 0x2C2F).addRange(0x2C62, 0x2C64).addRange(0x2C6D, 0x2C70).addRange(0x2C7E, 0x2C80).addRange(0xA77D, 0xA77E).addRange(0xA7AA, 0xA7AE).addRange(0xA7B0, 0xA7B4).addRange(0xA7C4, 0xA7C7).addRange(0xAB70, 0xABBF).addRange(0xFB00, 0xFB06).addRange(0xFB13, 0xFB17).addRange(0xFF21, 0xFF3A).addRange(0x10400, 0x10427).addRange(0x104B0, 0x104D3).addRange(0x10570, 0x1057A).addRange(0x1057C, 0x1058A).addRange(0x1058C, 0x10592).addRange(0x10594, 0x10595).addRange(0x10C80, 0x10CB2).addRange(0x118A0, 0x118BF).addRange(0x16E40, 0x16E5F).addRange(0x1E900, 0x1E921);
		    Changes_When_Casefolded.characters = set;
		    return Changes_When_Casefolded;
		  }

		  var Changes_When_Casemapped = {};

		  var hasRequiredChanges_When_Casemapped;
		  function requireChanges_When_Casemapped() {
		    if (hasRequiredChanges_When_Casemapped) return Changes_When_Casemapped;
		    hasRequiredChanges_When_Casemapped = 1;
		    var set = regenerateExports(0xB5, 0x1BF, 0x259, 0x263, 0x26F, 0x275, 0x27D, 0x280, 0x292, 0x345, 0x37F, 0x386, 0x38C, 0x10C7, 0x10CD, 0x1D79, 0x1D7D, 0x1D8E, 0x1E9E, 0x1F59, 0x1F5B, 0x1F5D, 0x1FBE, 0x2126, 0x2132, 0x214E, 0x2D27, 0x2D2D, 0xAB53);
		    set.addRange(0x41, 0x5A).addRange(0x61, 0x7A).addRange(0xC0, 0xD6).addRange(0xD8, 0xF6).addRange(0xF8, 0x137).addRange(0x139, 0x18C).addRange(0x18E, 0x19A).addRange(0x19C, 0x1A9).addRange(0x1AC, 0x1B9).addRange(0x1BC, 0x1BD).addRange(0x1C4, 0x220).addRange(0x222, 0x233).addRange(0x23A, 0x254).addRange(0x256, 0x257).addRange(0x25B, 0x25C).addRange(0x260, 0x261).addRange(0x265, 0x266).addRange(0x268, 0x26C).addRange(0x271, 0x272).addRange(0x282, 0x283).addRange(0x287, 0x28C).addRange(0x29D, 0x29E).addRange(0x370, 0x373).addRange(0x376, 0x377).addRange(0x37B, 0x37D).addRange(0x388, 0x38A).addRange(0x38E, 0x3A1).addRange(0x3A3, 0x3D1).addRange(0x3D5, 0x3F5).addRange(0x3F7, 0x3FB).addRange(0x3FD, 0x481).addRange(0x48A, 0x52F).addRange(0x531, 0x556).addRange(0x561, 0x587).addRange(0x10A0, 0x10C5).addRange(0x10D0, 0x10FA).addRange(0x10FD, 0x10FF).addRange(0x13A0, 0x13F5).addRange(0x13F8, 0x13FD).addRange(0x1C80, 0x1C88).addRange(0x1C90, 0x1CBA).addRange(0x1CBD, 0x1CBF).addRange(0x1E00, 0x1E9B).addRange(0x1EA0, 0x1F15).addRange(0x1F18, 0x1F1D).addRange(0x1F20, 0x1F45).addRange(0x1F48, 0x1F4D).addRange(0x1F50, 0x1F57).addRange(0x1F5F, 0x1F7D).addRange(0x1F80, 0x1FB4).addRange(0x1FB6, 0x1FBC);
		    set.addRange(0x1FC2, 0x1FC4).addRange(0x1FC6, 0x1FCC).addRange(0x1FD0, 0x1FD3).addRange(0x1FD6, 0x1FDB).addRange(0x1FE0, 0x1FEC).addRange(0x1FF2, 0x1FF4).addRange(0x1FF6, 0x1FFC).addRange(0x212A, 0x212B).addRange(0x2160, 0x217F).addRange(0x2183, 0x2184).addRange(0x24B6, 0x24E9).addRange(0x2C00, 0x2C70).addRange(0x2C72, 0x2C73).addRange(0x2C75, 0x2C76).addRange(0x2C7E, 0x2CE3).addRange(0x2CEB, 0x2CEE).addRange(0x2CF2, 0x2CF3).addRange(0x2D00, 0x2D25).addRange(0xA640, 0xA66D).addRange(0xA680, 0xA69B).addRange(0xA722, 0xA72F).addRange(0xA732, 0xA76F).addRange(0xA779, 0xA787).addRange(0xA78B, 0xA78D).addRange(0xA790, 0xA794).addRange(0xA796, 0xA7AE).addRange(0xA7B0, 0xA7CA).addRange(0xA7D0, 0xA7D1).addRange(0xA7D6, 0xA7D9).addRange(0xA7F5, 0xA7F6).addRange(0xAB70, 0xABBF).addRange(0xFB00, 0xFB06).addRange(0xFB13, 0xFB17).addRange(0xFF21, 0xFF3A).addRange(0xFF41, 0xFF5A).addRange(0x10400, 0x1044F).addRange(0x104B0, 0x104D3).addRange(0x104D8, 0x104FB).addRange(0x10570, 0x1057A).addRange(0x1057C, 0x1058A).addRange(0x1058C, 0x10592).addRange(0x10594, 0x10595).addRange(0x10597, 0x105A1).addRange(0x105A3, 0x105B1).addRange(0x105B3, 0x105B9).addRange(0x105BB, 0x105BC).addRange(0x10C80, 0x10CB2).addRange(0x10CC0, 0x10CF2).addRange(0x118A0, 0x118DF).addRange(0x16E40, 0x16E7F).addRange(0x1E900, 0x1E943);
		    Changes_When_Casemapped.characters = set;
		    return Changes_When_Casemapped;
		  }

		  var Changes_When_Lowercased = {};

		  var hasRequiredChanges_When_Lowercased;
		  function requireChanges_When_Lowercased() {
		    if (hasRequiredChanges_When_Lowercased) return Changes_When_Lowercased;
		    hasRequiredChanges_When_Lowercased = 1;
		    var set = regenerateExports(0x100, 0x102, 0x104, 0x106, 0x108, 0x10A, 0x10C, 0x10E, 0x110, 0x112, 0x114, 0x116, 0x118, 0x11A, 0x11C, 0x11E, 0x120, 0x122, 0x124, 0x126, 0x128, 0x12A, 0x12C, 0x12E, 0x130, 0x132, 0x134, 0x136, 0x139, 0x13B, 0x13D, 0x13F, 0x141, 0x143, 0x145, 0x147, 0x14A, 0x14C, 0x14E, 0x150, 0x152, 0x154, 0x156, 0x158, 0x15A, 0x15C, 0x15E, 0x160, 0x162, 0x164, 0x166, 0x168, 0x16A, 0x16C, 0x16E, 0x170, 0x172, 0x174, 0x176, 0x17B, 0x17D, 0x184, 0x1A2, 0x1A4, 0x1A9, 0x1AC, 0x1B5, 0x1BC, 0x1CD, 0x1CF, 0x1D1, 0x1D3, 0x1D5, 0x1D7, 0x1D9, 0x1DB, 0x1DE, 0x1E0, 0x1E2, 0x1E4, 0x1E6, 0x1E8, 0x1EA, 0x1EC, 0x1EE, 0x1F4, 0x1FA, 0x1FC, 0x1FE, 0x200, 0x202, 0x204, 0x206, 0x208, 0x20A, 0x20C, 0x20E, 0x210, 0x212, 0x214, 0x216, 0x218, 0x21A, 0x21C, 0x21E, 0x220, 0x222, 0x224, 0x226, 0x228, 0x22A, 0x22C, 0x22E, 0x230, 0x232, 0x241, 0x248, 0x24A, 0x24C, 0x24E, 0x370, 0x372, 0x376, 0x37F, 0x386, 0x38C, 0x3CF, 0x3D8, 0x3DA, 0x3DC, 0x3DE, 0x3E0, 0x3E2, 0x3E4, 0x3E6, 0x3E8, 0x3EA, 0x3EC, 0x3EE, 0x3F4, 0x3F7, 0x460, 0x462, 0x464, 0x466, 0x468, 0x46A, 0x46C, 0x46E, 0x470, 0x472, 0x474, 0x476, 0x478, 0x47A, 0x47C, 0x47E, 0x480, 0x48A, 0x48C, 0x48E, 0x490, 0x492, 0x494, 0x496, 0x498, 0x49A, 0x49C, 0x49E, 0x4A0, 0x4A2, 0x4A4, 0x4A6, 0x4A8, 0x4AA, 0x4AC, 0x4AE, 0x4B0, 0x4B2, 0x4B4, 0x4B6, 0x4B8, 0x4BA, 0x4BC, 0x4BE, 0x4C3, 0x4C5, 0x4C7, 0x4C9, 0x4CB, 0x4CD, 0x4D0, 0x4D2, 0x4D4, 0x4D6, 0x4D8, 0x4DA, 0x4DC, 0x4DE, 0x4E0, 0x4E2, 0x4E4, 0x4E6, 0x4E8, 0x4EA, 0x4EC, 0x4EE, 0x4F0, 0x4F2, 0x4F4, 0x4F6, 0x4F8, 0x4FA, 0x4FC, 0x4FE, 0x500, 0x502, 0x504, 0x506, 0x508, 0x50A, 0x50C, 0x50E, 0x510, 0x512, 0x514, 0x516, 0x518, 0x51A, 0x51C, 0x51E, 0x520, 0x522, 0x524, 0x526, 0x528, 0x52A, 0x52C, 0x52E, 0x10C7, 0x10CD, 0x1E00, 0x1E02, 0x1E04, 0x1E06, 0x1E08, 0x1E0A, 0x1E0C, 0x1E0E, 0x1E10, 0x1E12, 0x1E14, 0x1E16, 0x1E18, 0x1E1A, 0x1E1C, 0x1E1E, 0x1E20, 0x1E22, 0x1E24, 0x1E26, 0x1E28, 0x1E2A, 0x1E2C, 0x1E2E, 0x1E30, 0x1E32, 0x1E34, 0x1E36, 0x1E38, 0x1E3A, 0x1E3C, 0x1E3E, 0x1E40, 0x1E42, 0x1E44, 0x1E46, 0x1E48, 0x1E4A, 0x1E4C, 0x1E4E, 0x1E50, 0x1E52, 0x1E54, 0x1E56, 0x1E58, 0x1E5A, 0x1E5C, 0x1E5E, 0x1E60, 0x1E62, 0x1E64, 0x1E66, 0x1E68, 0x1E6A, 0x1E6C, 0x1E6E, 0x1E70, 0x1E72, 0x1E74, 0x1E76, 0x1E78, 0x1E7A, 0x1E7C, 0x1E7E, 0x1E80, 0x1E82, 0x1E84, 0x1E86, 0x1E88, 0x1E8A, 0x1E8C, 0x1E8E, 0x1E90, 0x1E92, 0x1E94, 0x1E9E, 0x1EA0, 0x1EA2, 0x1EA4, 0x1EA6, 0x1EA8, 0x1EAA, 0x1EAC, 0x1EAE, 0x1EB0, 0x1EB2, 0x1EB4, 0x1EB6, 0x1EB8, 0x1EBA, 0x1EBC, 0x1EBE, 0x1EC0, 0x1EC2, 0x1EC4, 0x1EC6, 0x1EC8, 0x1ECA, 0x1ECC, 0x1ECE, 0x1ED0, 0x1ED2, 0x1ED4, 0x1ED6, 0x1ED8, 0x1EDA, 0x1EDC, 0x1EDE, 0x1EE0, 0x1EE2, 0x1EE4, 0x1EE6, 0x1EE8, 0x1EEA, 0x1EEC, 0x1EEE, 0x1EF0, 0x1EF2, 0x1EF4, 0x1EF6, 0x1EF8, 0x1EFA, 0x1EFC, 0x1EFE, 0x1F59, 0x1F5B, 0x1F5D, 0x1F5F, 0x2126, 0x2132, 0x2183, 0x2C60, 0x2C67, 0x2C69, 0x2C6B, 0x2C72, 0x2C75, 0x2C82, 0x2C84, 0x2C86, 0x2C88, 0x2C8A, 0x2C8C, 0x2C8E, 0x2C90, 0x2C92, 0x2C94, 0x2C96, 0x2C98, 0x2C9A, 0x2C9C, 0x2C9E, 0x2CA0, 0x2CA2, 0x2CA4, 0x2CA6, 0x2CA8, 0x2CAA, 0x2CAC, 0x2CAE, 0x2CB0, 0x2CB2, 0x2CB4, 0x2CB6, 0x2CB8, 0x2CBA, 0x2CBC, 0x2CBE, 0x2CC0, 0x2CC2, 0x2CC4, 0x2CC6, 0x2CC8, 0x2CCA, 0x2CCC, 0x2CCE, 0x2CD0, 0x2CD2, 0x2CD4, 0x2CD6, 0x2CD8, 0x2CDA, 0x2CDC, 0x2CDE, 0x2CE0, 0x2CE2, 0x2CEB, 0x2CED, 0x2CF2, 0xA640, 0xA642, 0xA644, 0xA646, 0xA648, 0xA64A, 0xA64C, 0xA64E, 0xA650, 0xA652, 0xA654, 0xA656, 0xA658, 0xA65A, 0xA65C, 0xA65E, 0xA660, 0xA662, 0xA664, 0xA666, 0xA668, 0xA66A, 0xA66C, 0xA680, 0xA682, 0xA684, 0xA686, 0xA688, 0xA68A, 0xA68C, 0xA68E, 0xA690, 0xA692, 0xA694, 0xA696, 0xA698, 0xA69A, 0xA722, 0xA724, 0xA726, 0xA728, 0xA72A, 0xA72C, 0xA72E, 0xA732, 0xA734, 0xA736, 0xA738, 0xA73A, 0xA73C, 0xA73E, 0xA740, 0xA742, 0xA744, 0xA746, 0xA748, 0xA74A, 0xA74C, 0xA74E, 0xA750, 0xA752, 0xA754, 0xA756, 0xA758, 0xA75A, 0xA75C, 0xA75E, 0xA760, 0xA762, 0xA764, 0xA766, 0xA768, 0xA76A, 0xA76C, 0xA76E, 0xA779, 0xA77B, 0xA780, 0xA782, 0xA784, 0xA786, 0xA78B, 0xA78D, 0xA790, 0xA792, 0xA796, 0xA798, 0xA79A, 0xA79C, 0xA79E, 0xA7A0, 0xA7A2, 0xA7A4, 0xA7A6, 0xA7A8, 0xA7B6, 0xA7B8, 0xA7BA, 0xA7BC, 0xA7BE, 0xA7C0, 0xA7C2, 0xA7C9, 0xA7D0, 0xA7D6, 0xA7D8, 0xA7F5);
		    set.addRange(0x41, 0x5A).addRange(0xC0, 0xD6).addRange(0xD8, 0xDE).addRange(0x178, 0x179).addRange(0x181, 0x182).addRange(0x186, 0x187).addRange(0x189, 0x18B).addRange(0x18E, 0x191).addRange(0x193, 0x194).addRange(0x196, 0x198).addRange(0x19C, 0x19D).addRange(0x19F, 0x1A0).addRange(0x1A6, 0x1A7).addRange(0x1AE, 0x1AF).addRange(0x1B1, 0x1B3).addRange(0x1B7, 0x1B8).addRange(0x1C4, 0x1C5).addRange(0x1C7, 0x1C8).addRange(0x1CA, 0x1CB).addRange(0x1F1, 0x1F2).addRange(0x1F6, 0x1F8).addRange(0x23A, 0x23B).addRange(0x23D, 0x23E).addRange(0x243, 0x246).addRange(0x388, 0x38A).addRange(0x38E, 0x38F).addRange(0x391, 0x3A1).addRange(0x3A3, 0x3AB).addRange(0x3F9, 0x3FA).addRange(0x3FD, 0x42F).addRange(0x4C0, 0x4C1).addRange(0x531, 0x556).addRange(0x10A0, 0x10C5).addRange(0x13A0, 0x13F5).addRange(0x1C90, 0x1CBA).addRange(0x1CBD, 0x1CBF).addRange(0x1F08, 0x1F0F).addRange(0x1F18, 0x1F1D).addRange(0x1F28, 0x1F2F).addRange(0x1F38, 0x1F3F).addRange(0x1F48, 0x1F4D).addRange(0x1F68, 0x1F6F).addRange(0x1F88, 0x1F8F).addRange(0x1F98, 0x1F9F).addRange(0x1FA8, 0x1FAF).addRange(0x1FB8, 0x1FBC).addRange(0x1FC8, 0x1FCC).addRange(0x1FD8, 0x1FDB).addRange(0x1FE8, 0x1FEC).addRange(0x1FF8, 0x1FFC).addRange(0x212A, 0x212B);
		    set.addRange(0x2160, 0x216F).addRange(0x24B6, 0x24CF).addRange(0x2C00, 0x2C2F).addRange(0x2C62, 0x2C64).addRange(0x2C6D, 0x2C70).addRange(0x2C7E, 0x2C80).addRange(0xA77D, 0xA77E).addRange(0xA7AA, 0xA7AE).addRange(0xA7B0, 0xA7B4).addRange(0xA7C4, 0xA7C7).addRange(0xFF21, 0xFF3A).addRange(0x10400, 0x10427).addRange(0x104B0, 0x104D3).addRange(0x10570, 0x1057A).addRange(0x1057C, 0x1058A).addRange(0x1058C, 0x10592).addRange(0x10594, 0x10595).addRange(0x10C80, 0x10CB2).addRange(0x118A0, 0x118BF).addRange(0x16E40, 0x16E5F).addRange(0x1E900, 0x1E921);
		    Changes_When_Lowercased.characters = set;
		    return Changes_When_Lowercased;
		  }

		  var Changes_When_NFKC_Casefolded = {};

		  var hasRequiredChanges_When_NFKC_Casefolded;
		  function requireChanges_When_NFKC_Casefolded() {
		    if (hasRequiredChanges_When_NFKC_Casefolded) return Changes_When_NFKC_Casefolded;
		    hasRequiredChanges_When_NFKC_Casefolded = 1;
		    var set = regenerateExports(0xA0, 0xA8, 0xAA, 0xAD, 0xAF, 0x100, 0x102, 0x104, 0x106, 0x108, 0x10A, 0x10C, 0x10E, 0x110, 0x112, 0x114, 0x116, 0x118, 0x11A, 0x11C, 0x11E, 0x120, 0x122, 0x124, 0x126, 0x128, 0x12A, 0x12C, 0x12E, 0x130, 0x136, 0x139, 0x13B, 0x13D, 0x143, 0x145, 0x147, 0x14C, 0x14E, 0x150, 0x152, 0x154, 0x156, 0x158, 0x15A, 0x15C, 0x15E, 0x160, 0x162, 0x164, 0x166, 0x168, 0x16A, 0x16C, 0x16E, 0x170, 0x172, 0x174, 0x176, 0x17B, 0x17D, 0x17F, 0x184, 0x1A2, 0x1A4, 0x1A9, 0x1AC, 0x1B5, 0x1BC, 0x1CF, 0x1D1, 0x1D3, 0x1D5, 0x1D7, 0x1D9, 0x1DB, 0x1DE, 0x1E0, 0x1E2, 0x1E4, 0x1E6, 0x1E8, 0x1EA, 0x1EC, 0x1EE, 0x1FA, 0x1FC, 0x1FE, 0x200, 0x202, 0x204, 0x206, 0x208, 0x20A, 0x20C, 0x20E, 0x210, 0x212, 0x214, 0x216, 0x218, 0x21A, 0x21C, 0x21E, 0x220, 0x222, 0x224, 0x226, 0x228, 0x22A, 0x22C, 0x22E, 0x230, 0x232, 0x241, 0x248, 0x24A, 0x24C, 0x24E, 0x34F, 0x370, 0x372, 0x374, 0x376, 0x37A, 0x38C, 0x3C2, 0x3D8, 0x3DA, 0x3DC, 0x3DE, 0x3E0, 0x3E2, 0x3E4, 0x3E6, 0x3E8, 0x3EA, 0x3EC, 0x3EE, 0x3F7, 0x460, 0x462, 0x464, 0x466, 0x468, 0x46A, 0x46C, 0x46E, 0x470, 0x472, 0x474, 0x476, 0x478, 0x47A, 0x47C, 0x47E, 0x480, 0x48A, 0x48C, 0x48E, 0x490, 0x492, 0x494, 0x496, 0x498, 0x49A, 0x49C, 0x49E, 0x4A0, 0x4A2, 0x4A4, 0x4A6, 0x4A8, 0x4AA, 0x4AC, 0x4AE, 0x4B0, 0x4B2, 0x4B4, 0x4B6, 0x4B8, 0x4BA, 0x4BC, 0x4BE, 0x4C3, 0x4C5, 0x4C7, 0x4C9, 0x4CB, 0x4CD, 0x4D0, 0x4D2, 0x4D4, 0x4D6, 0x4D8, 0x4DA, 0x4DC, 0x4DE, 0x4E0, 0x4E2, 0x4E4, 0x4E6, 0x4E8, 0x4EA, 0x4EC, 0x4EE, 0x4F0, 0x4F2, 0x4F4, 0x4F6, 0x4F8, 0x4FA, 0x4FC, 0x4FE, 0x500, 0x502, 0x504, 0x506, 0x508, 0x50A, 0x50C, 0x50E, 0x510, 0x512, 0x514, 0x516, 0x518, 0x51A, 0x51C, 0x51E, 0x520, 0x522, 0x524, 0x526, 0x528, 0x52A, 0x52C, 0x52E, 0x587, 0x61C, 0x9DF, 0xA33, 0xA36, 0xA5E, 0xE33, 0xEB3, 0xF0C, 0xF43, 0xF4D, 0xF52, 0xF57, 0xF5C, 0xF69, 0xF73, 0xF81, 0xF93, 0xF9D, 0xFA2, 0xFA7, 0xFAC, 0xFB9, 0x10C7, 0x10CD, 0x10FC, 0x1D78, 0x1E00, 0x1E02, 0x1E04, 0x1E06, 0x1E08, 0x1E0A, 0x1E0C, 0x1E0E, 0x1E10, 0x1E12, 0x1E14, 0x1E16, 0x1E18, 0x1E1A, 0x1E1C, 0x1E1E, 0x1E20, 0x1E22, 0x1E24, 0x1E26, 0x1E28, 0x1E2A, 0x1E2C, 0x1E2E, 0x1E30, 0x1E32, 0x1E34, 0x1E36, 0x1E38, 0x1E3A, 0x1E3C, 0x1E3E, 0x1E40, 0x1E42, 0x1E44, 0x1E46, 0x1E48, 0x1E4A, 0x1E4C, 0x1E4E, 0x1E50, 0x1E52, 0x1E54, 0x1E56, 0x1E58, 0x1E5A, 0x1E5C, 0x1E5E, 0x1E60, 0x1E62, 0x1E64, 0x1E66, 0x1E68, 0x1E6A, 0x1E6C, 0x1E6E, 0x1E70, 0x1E72, 0x1E74, 0x1E76, 0x1E78, 0x1E7A, 0x1E7C, 0x1E7E, 0x1E80, 0x1E82, 0x1E84, 0x1E86, 0x1E88, 0x1E8A, 0x1E8C, 0x1E8E, 0x1E90, 0x1E92, 0x1E94, 0x1E9E, 0x1EA0, 0x1EA2, 0x1EA4, 0x1EA6, 0x1EA8, 0x1EAA, 0x1EAC, 0x1EAE, 0x1EB0, 0x1EB2, 0x1EB4, 0x1EB6, 0x1EB8, 0x1EBA, 0x1EBC, 0x1EBE, 0x1EC0, 0x1EC2, 0x1EC4, 0x1EC6, 0x1EC8, 0x1ECA, 0x1ECC, 0x1ECE, 0x1ED0, 0x1ED2, 0x1ED4, 0x1ED6, 0x1ED8, 0x1EDA, 0x1EDC, 0x1EDE, 0x1EE0, 0x1EE2, 0x1EE4, 0x1EE6, 0x1EE8, 0x1EEA, 0x1EEC, 0x1EEE, 0x1EF0, 0x1EF2, 0x1EF4, 0x1EF6, 0x1EF8, 0x1EFA, 0x1EFC, 0x1EFE, 0x1F59, 0x1F5B, 0x1F5D, 0x1F5F, 0x1F71, 0x1F73, 0x1F75, 0x1F77, 0x1F79, 0x1F7B, 0x1F7D, 0x1FD3, 0x1FE3, 0x2011, 0x2017, 0x203C, 0x203E, 0x2057, 0x20A8, 0x2124, 0x2126, 0x2128, 0x2183, 0x2189, 0x2A0C, 0x2ADC, 0x2C60, 0x2C67, 0x2C69, 0x2C6B, 0x2C72, 0x2C75, 0x2C82, 0x2C84, 0x2C86, 0x2C88, 0x2C8A, 0x2C8C, 0x2C8E, 0x2C90, 0x2C92, 0x2C94, 0x2C96, 0x2C98, 0x2C9A, 0x2C9C, 0x2C9E, 0x2CA0, 0x2CA2, 0x2CA4, 0x2CA6, 0x2CA8, 0x2CAA, 0x2CAC, 0x2CAE, 0x2CB0, 0x2CB2, 0x2CB4, 0x2CB6, 0x2CB8, 0x2CBA, 0x2CBC, 0x2CBE, 0x2CC0, 0x2CC2, 0x2CC4, 0x2CC6, 0x2CC8, 0x2CCA, 0x2CCC, 0x2CCE, 0x2CD0, 0x2CD2, 0x2CD4, 0x2CD6, 0x2CD8, 0x2CDA, 0x2CDC, 0x2CDE, 0x2CE0, 0x2CE2, 0x2CEB, 0x2CED, 0x2CF2, 0x2D6F, 0x2E9F, 0x2EF3, 0x3000, 0x3036, 0x309F, 0x30FF, 0xA640, 0xA642, 0xA644, 0xA646, 0xA648, 0xA64A, 0xA64C, 0xA64E, 0xA650, 0xA652, 0xA654, 0xA656, 0xA658, 0xA65A, 0xA65C, 0xA65E, 0xA660, 0xA662, 0xA664, 0xA666, 0xA668, 0xA66A, 0xA66C, 0xA680, 0xA682, 0xA684, 0xA686, 0xA688, 0xA68A, 0xA68C, 0xA68E, 0xA690, 0xA692, 0xA694, 0xA696, 0xA698, 0xA69A, 0xA722, 0xA724, 0xA726, 0xA728, 0xA72A, 0xA72C, 0xA72E, 0xA732, 0xA734, 0xA736, 0xA738, 0xA73A, 0xA73C, 0xA73E, 0xA740, 0xA742, 0xA744, 0xA746, 0xA748, 0xA74A, 0xA74C, 0xA74E, 0xA750, 0xA752, 0xA754, 0xA756, 0xA758, 0xA75A, 0xA75C, 0xA75E, 0xA760, 0xA762, 0xA764, 0xA766, 0xA768, 0xA76A, 0xA76C, 0xA76E, 0xA770, 0xA779, 0xA77B, 0xA780, 0xA782, 0xA784, 0xA786, 0xA78B, 0xA78D, 0xA790, 0xA792, 0xA796, 0xA798, 0xA79A, 0xA79C, 0xA79E, 0xA7A0, 0xA7A2, 0xA7A4, 0xA7A6, 0xA7A8, 0xA7B6, 0xA7B8, 0xA7BA, 0xA7BC, 0xA7BE, 0xA7C0, 0xA7C2, 0xA7C9, 0xA7D0, 0xA7D6, 0xA7D8, 0xAB69, 0xFA10, 0xFA12, 0xFA20, 0xFA22, 0xFB1D, 0xFB3E, 0xFE74, 0xFEFF, 0x1D4A2, 0x1D4BB, 0x1D546, 0x1EE24, 0x1EE27, 0x1EE39, 0x1EE3B, 0x1EE42, 0x1EE47, 0x1EE49, 0x1EE4B, 0x1EE54, 0x1EE57, 0x1EE59, 0x1EE5B, 0x1EE5D, 0x1EE5F, 0x1EE64, 0x1EE7E, 0x1F190);
		    set.addRange(0x41, 0x5A).addRange(0xB2, 0xB5).addRange(0xB8, 0xBA).addRange(0xBC, 0xBE).addRange(0xC0, 0xD6).addRange(0xD8, 0xDF).addRange(0x132, 0x134).addRange(0x13F, 0x141).addRange(0x149, 0x14A).addRange(0x178, 0x179).addRange(0x181, 0x182).addRange(0x186, 0x187).addRange(0x189, 0x18B).addRange(0x18E, 0x191).addRange(0x193, 0x194).addRange(0x196, 0x198).addRange(0x19C, 0x19D).addRange(0x19F, 0x1A0).addRange(0x1A6, 0x1A7).addRange(0x1AE, 0x1AF).addRange(0x1B1, 0x1B3).addRange(0x1B7, 0x1B8).addRange(0x1C4, 0x1CD).addRange(0x1F1, 0x1F4).addRange(0x1F6, 0x1F8).addRange(0x23A, 0x23B).addRange(0x23D, 0x23E).addRange(0x243, 0x246).addRange(0x2B0, 0x2B8).addRange(0x2D8, 0x2DD).addRange(0x2E0, 0x2E4).addRange(0x340, 0x341).addRange(0x343, 0x345).addRange(0x37E, 0x37F).addRange(0x384, 0x38A).addRange(0x38E, 0x38F).addRange(0x391, 0x3A1).addRange(0x3A3, 0x3AB).addRange(0x3CF, 0x3D6).addRange(0x3F0, 0x3F2).addRange(0x3F4, 0x3F5).addRange(0x3F9, 0x3FA).addRange(0x3FD, 0x42F).addRange(0x4C0, 0x4C1).addRange(0x531, 0x556).addRange(0x675, 0x678).addRange(0x958, 0x95F).addRange(0x9DC, 0x9DD).addRange(0xA59, 0xA5B).addRange(0xB5C, 0xB5D).addRange(0xEDC, 0xEDD);
		    set.addRange(0xF75, 0xF79).addRange(0x10A0, 0x10C5).addRange(0x115F, 0x1160).addRange(0x13F8, 0x13FD).addRange(0x17B4, 0x17B5).addRange(0x180B, 0x180F).addRange(0x1C80, 0x1C88).addRange(0x1C90, 0x1CBA).addRange(0x1CBD, 0x1CBF).addRange(0x1D2C, 0x1D2E).addRange(0x1D30, 0x1D3A).addRange(0x1D3C, 0x1D4D).addRange(0x1D4F, 0x1D6A).addRange(0x1D9B, 0x1DBF).addRange(0x1E9A, 0x1E9B).addRange(0x1F08, 0x1F0F).addRange(0x1F18, 0x1F1D).addRange(0x1F28, 0x1F2F).addRange(0x1F38, 0x1F3F).addRange(0x1F48, 0x1F4D).addRange(0x1F68, 0x1F6F).addRange(0x1F80, 0x1FAF).addRange(0x1FB2, 0x1FB4).addRange(0x1FB7, 0x1FC4).addRange(0x1FC7, 0x1FCF).addRange(0x1FD8, 0x1FDB).addRange(0x1FDD, 0x1FDF).addRange(0x1FE8, 0x1FEF).addRange(0x1FF2, 0x1FF4).addRange(0x1FF7, 0x1FFE).addRange(0x2000, 0x200F).addRange(0x2024, 0x2026).addRange(0x202A, 0x202F).addRange(0x2033, 0x2034).addRange(0x2036, 0x2037).addRange(0x2047, 0x2049).addRange(0x205F, 0x2071).addRange(0x2074, 0x208E).addRange(0x2090, 0x209C).addRange(0x2100, 0x2103).addRange(0x2105, 0x2107).addRange(0x2109, 0x2113).addRange(0x2115, 0x2116).addRange(0x2119, 0x211D).addRange(0x2120, 0x2122).addRange(0x212A, 0x212D).addRange(0x212F, 0x2139).addRange(0x213B, 0x2140).addRange(0x2145, 0x2149).addRange(0x2150, 0x217F).addRange(0x222C, 0x222D);
		    set.addRange(0x222F, 0x2230).addRange(0x2329, 0x232A).addRange(0x2460, 0x24EA).addRange(0x2A74, 0x2A76).addRange(0x2C00, 0x2C2F).addRange(0x2C62, 0x2C64).addRange(0x2C6D, 0x2C70).addRange(0x2C7C, 0x2C80).addRange(0x2F00, 0x2FD5).addRange(0x3038, 0x303A).addRange(0x309B, 0x309C).addRange(0x3131, 0x318E).addRange(0x3192, 0x319F).addRange(0x3200, 0x321E).addRange(0x3220, 0x3247).addRange(0x3250, 0x327E).addRange(0x3280, 0x33FF).addRange(0xA69C, 0xA69D).addRange(0xA77D, 0xA77E).addRange(0xA7AA, 0xA7AE).addRange(0xA7B0, 0xA7B4).addRange(0xA7C4, 0xA7C7).addRange(0xA7F2, 0xA7F5).addRange(0xA7F8, 0xA7F9).addRange(0xAB5C, 0xAB5F).addRange(0xAB70, 0xABBF).addRange(0xF900, 0xFA0D).addRange(0xFA15, 0xFA1E).addRange(0xFA25, 0xFA26).addRange(0xFA2A, 0xFA6D).addRange(0xFA70, 0xFAD9).addRange(0xFB00, 0xFB06).addRange(0xFB13, 0xFB17).addRange(0xFB1F, 0xFB36).addRange(0xFB38, 0xFB3C).addRange(0xFB40, 0xFB41).addRange(0xFB43, 0xFB44).addRange(0xFB46, 0xFBB1).addRange(0xFBD3, 0xFD3D).addRange(0xFD50, 0xFD8F).addRange(0xFD92, 0xFDC7).addRange(0xFDF0, 0xFDFC).addRange(0xFE00, 0xFE19).addRange(0xFE30, 0xFE44).addRange(0xFE47, 0xFE52).addRange(0xFE54, 0xFE66).addRange(0xFE68, 0xFE6B).addRange(0xFE70, 0xFE72).addRange(0xFE76, 0xFEFC).addRange(0xFF01, 0xFFBE).addRange(0xFFC2, 0xFFC7);
		    set.addRange(0xFFCA, 0xFFCF).addRange(0xFFD2, 0xFFD7).addRange(0xFFDA, 0xFFDC).addRange(0xFFE0, 0xFFE6).addRange(0xFFE8, 0xFFEE).addRange(0xFFF0, 0xFFF8).addRange(0x10400, 0x10427).addRange(0x104B0, 0x104D3).addRange(0x10570, 0x1057A).addRange(0x1057C, 0x1058A).addRange(0x1058C, 0x10592).addRange(0x10594, 0x10595).addRange(0x10781, 0x10785).addRange(0x10787, 0x107B0).addRange(0x107B2, 0x107BA).addRange(0x10C80, 0x10CB2).addRange(0x118A0, 0x118BF).addRange(0x16E40, 0x16E5F).addRange(0x1BCA0, 0x1BCA3).addRange(0x1D15E, 0x1D164).addRange(0x1D173, 0x1D17A).addRange(0x1D1BB, 0x1D1C0).addRange(0x1D400, 0x1D454).addRange(0x1D456, 0x1D49C).addRange(0x1D49E, 0x1D49F).addRange(0x1D4A5, 0x1D4A6).addRange(0x1D4A9, 0x1D4AC).addRange(0x1D4AE, 0x1D4B9).addRange(0x1D4BD, 0x1D4C3).addRange(0x1D4C5, 0x1D505).addRange(0x1D507, 0x1D50A).addRange(0x1D50D, 0x1D514).addRange(0x1D516, 0x1D51C).addRange(0x1D51E, 0x1D539).addRange(0x1D53B, 0x1D53E).addRange(0x1D540, 0x1D544).addRange(0x1D54A, 0x1D550).addRange(0x1D552, 0x1D6A5).addRange(0x1D6A8, 0x1D7CB).addRange(0x1D7CE, 0x1D7FF).addRange(0x1E030, 0x1E06D).addRange(0x1E900, 0x1E921).addRange(0x1EE00, 0x1EE03).addRange(0x1EE05, 0x1EE1F).addRange(0x1EE21, 0x1EE22).addRange(0x1EE29, 0x1EE32).addRange(0x1EE34, 0x1EE37).addRange(0x1EE4D, 0x1EE4F).addRange(0x1EE51, 0x1EE52).addRange(0x1EE61, 0x1EE62).addRange(0x1EE67, 0x1EE6A);
		    set.addRange(0x1EE6C, 0x1EE72).addRange(0x1EE74, 0x1EE77).addRange(0x1EE79, 0x1EE7C).addRange(0x1EE80, 0x1EE89).addRange(0x1EE8B, 0x1EE9B).addRange(0x1EEA1, 0x1EEA3).addRange(0x1EEA5, 0x1EEA9).addRange(0x1EEAB, 0x1EEBB).addRange(0x1F100, 0x1F10A).addRange(0x1F110, 0x1F12E).addRange(0x1F130, 0x1F14F).addRange(0x1F16A, 0x1F16C).addRange(0x1F200, 0x1F202).addRange(0x1F210, 0x1F23B).addRange(0x1F240, 0x1F248).addRange(0x1F250, 0x1F251).addRange(0x1FBF0, 0x1FBF9).addRange(0x2F800, 0x2FA1D).addRange(0xE0000, 0xE0FFF);
		    Changes_When_NFKC_Casefolded.characters = set;
		    return Changes_When_NFKC_Casefolded;
		  }

		  var Changes_When_Titlecased = {};

		  var hasRequiredChanges_When_Titlecased;
		  function requireChanges_When_Titlecased() {
		    if (hasRequiredChanges_When_Titlecased) return Changes_When_Titlecased;
		    hasRequiredChanges_When_Titlecased = 1;
		    var set = regenerateExports(0xB5, 0x101, 0x103, 0x105, 0x107, 0x109, 0x10B, 0x10D, 0x10F, 0x111, 0x113, 0x115, 0x117, 0x119, 0x11B, 0x11D, 0x11F, 0x121, 0x123, 0x125, 0x127, 0x129, 0x12B, 0x12D, 0x12F, 0x131, 0x133, 0x135, 0x137, 0x13A, 0x13C, 0x13E, 0x140, 0x142, 0x144, 0x146, 0x14B, 0x14D, 0x14F, 0x151, 0x153, 0x155, 0x157, 0x159, 0x15B, 0x15D, 0x15F, 0x161, 0x163, 0x165, 0x167, 0x169, 0x16B, 0x16D, 0x16F, 0x171, 0x173, 0x175, 0x177, 0x17A, 0x17C, 0x183, 0x185, 0x188, 0x18C, 0x192, 0x195, 0x19E, 0x1A1, 0x1A3, 0x1A5, 0x1A8, 0x1AD, 0x1B0, 0x1B4, 0x1B6, 0x1B9, 0x1BD, 0x1BF, 0x1C4, 0x1CC, 0x1CE, 0x1D0, 0x1D2, 0x1D4, 0x1D6, 0x1D8, 0x1DA, 0x1DF, 0x1E1, 0x1E3, 0x1E5, 0x1E7, 0x1E9, 0x1EB, 0x1ED, 0x1F3, 0x1F5, 0x1F9, 0x1FB, 0x1FD, 0x1FF, 0x201, 0x203, 0x205, 0x207, 0x209, 0x20B, 0x20D, 0x20F, 0x211, 0x213, 0x215, 0x217, 0x219, 0x21B, 0x21D, 0x21F, 0x223, 0x225, 0x227, 0x229, 0x22B, 0x22D, 0x22F, 0x231, 0x233, 0x23C, 0x242, 0x247, 0x249, 0x24B, 0x24D, 0x259, 0x263, 0x26F, 0x275, 0x27D, 0x280, 0x292, 0x345, 0x371, 0x373, 0x377, 0x390, 0x3D9, 0x3DB, 0x3DD, 0x3DF, 0x3E1, 0x3E3, 0x3E5, 0x3E7, 0x3E9, 0x3EB, 0x3ED, 0x3F5, 0x3F8, 0x3FB, 0x461, 0x463, 0x465, 0x467, 0x469, 0x46B, 0x46D, 0x46F, 0x471, 0x473, 0x475, 0x477, 0x479, 0x47B, 0x47D, 0x47F, 0x481, 0x48B, 0x48D, 0x48F, 0x491, 0x493, 0x495, 0x497, 0x499, 0x49B, 0x49D, 0x49F, 0x4A1, 0x4A3, 0x4A5, 0x4A7, 0x4A9, 0x4AB, 0x4AD, 0x4AF, 0x4B1, 0x4B3, 0x4B5, 0x4B7, 0x4B9, 0x4BB, 0x4BD, 0x4BF, 0x4C2, 0x4C4, 0x4C6, 0x4C8, 0x4CA, 0x4CC, 0x4D1, 0x4D3, 0x4D5, 0x4D7, 0x4D9, 0x4DB, 0x4DD, 0x4DF, 0x4E1, 0x4E3, 0x4E5, 0x4E7, 0x4E9, 0x4EB, 0x4ED, 0x4EF, 0x4F1, 0x4F3, 0x4F5, 0x4F7, 0x4F9, 0x4FB, 0x4FD, 0x4FF, 0x501, 0x503, 0x505, 0x507, 0x509, 0x50B, 0x50D, 0x50F, 0x511, 0x513, 0x515, 0x517, 0x519, 0x51B, 0x51D, 0x51F, 0x521, 0x523, 0x525, 0x527, 0x529, 0x52B, 0x52D, 0x52F, 0x1D79, 0x1D7D, 0x1D8E, 0x1E01, 0x1E03, 0x1E05, 0x1E07, 0x1E09, 0x1E0B, 0x1E0D, 0x1E0F, 0x1E11, 0x1E13, 0x1E15, 0x1E17, 0x1E19, 0x1E1B, 0x1E1D, 0x1E1F, 0x1E21, 0x1E23, 0x1E25, 0x1E27, 0x1E29, 0x1E2B, 0x1E2D, 0x1E2F, 0x1E31, 0x1E33, 0x1E35, 0x1E37, 0x1E39, 0x1E3B, 0x1E3D, 0x1E3F, 0x1E41, 0x1E43, 0x1E45, 0x1E47, 0x1E49, 0x1E4B, 0x1E4D, 0x1E4F, 0x1E51, 0x1E53, 0x1E55, 0x1E57, 0x1E59, 0x1E5B, 0x1E5D, 0x1E5F, 0x1E61, 0x1E63, 0x1E65, 0x1E67, 0x1E69, 0x1E6B, 0x1E6D, 0x1E6F, 0x1E71, 0x1E73, 0x1E75, 0x1E77, 0x1E79, 0x1E7B, 0x1E7D, 0x1E7F, 0x1E81, 0x1E83, 0x1E85, 0x1E87, 0x1E89, 0x1E8B, 0x1E8D, 0x1E8F, 0x1E91, 0x1E93, 0x1EA1, 0x1EA3, 0x1EA5, 0x1EA7, 0x1EA9, 0x1EAB, 0x1EAD, 0x1EAF, 0x1EB1, 0x1EB3, 0x1EB5, 0x1EB7, 0x1EB9, 0x1EBB, 0x1EBD, 0x1EBF, 0x1EC1, 0x1EC3, 0x1EC5, 0x1EC7, 0x1EC9, 0x1ECB, 0x1ECD, 0x1ECF, 0x1ED1, 0x1ED3, 0x1ED5, 0x1ED7, 0x1ED9, 0x1EDB, 0x1EDD, 0x1EDF, 0x1EE1, 0x1EE3, 0x1EE5, 0x1EE7, 0x1EE9, 0x1EEB, 0x1EED, 0x1EEF, 0x1EF1, 0x1EF3, 0x1EF5, 0x1EF7, 0x1EF9, 0x1EFB, 0x1EFD, 0x1FBE, 0x214E, 0x2184, 0x2C61, 0x2C68, 0x2C6A, 0x2C6C, 0x2C73, 0x2C76, 0x2C81, 0x2C83, 0x2C85, 0x2C87, 0x2C89, 0x2C8B, 0x2C8D, 0x2C8F, 0x2C91, 0x2C93, 0x2C95, 0x2C97, 0x2C99, 0x2C9B, 0x2C9D, 0x2C9F, 0x2CA1, 0x2CA3, 0x2CA5, 0x2CA7, 0x2CA9, 0x2CAB, 0x2CAD, 0x2CAF, 0x2CB1, 0x2CB3, 0x2CB5, 0x2CB7, 0x2CB9, 0x2CBB, 0x2CBD, 0x2CBF, 0x2CC1, 0x2CC3, 0x2CC5, 0x2CC7, 0x2CC9, 0x2CCB, 0x2CCD, 0x2CCF, 0x2CD1, 0x2CD3, 0x2CD5, 0x2CD7, 0x2CD9, 0x2CDB, 0x2CDD, 0x2CDF, 0x2CE1, 0x2CE3, 0x2CEC, 0x2CEE, 0x2CF3, 0x2D27, 0x2D2D, 0xA641, 0xA643, 0xA645, 0xA647, 0xA649, 0xA64B, 0xA64D, 0xA64F, 0xA651, 0xA653, 0xA655, 0xA657, 0xA659, 0xA65B, 0xA65D, 0xA65F, 0xA661, 0xA663, 0xA665, 0xA667, 0xA669, 0xA66B, 0xA66D, 0xA681, 0xA683, 0xA685, 0xA687, 0xA689, 0xA68B, 0xA68D, 0xA68F, 0xA691, 0xA693, 0xA695, 0xA697, 0xA699, 0xA69B, 0xA723, 0xA725, 0xA727, 0xA729, 0xA72B, 0xA72D, 0xA72F, 0xA733, 0xA735, 0xA737, 0xA739, 0xA73B, 0xA73D, 0xA73F, 0xA741, 0xA743, 0xA745, 0xA747, 0xA749, 0xA74B, 0xA74D, 0xA74F, 0xA751, 0xA753, 0xA755, 0xA757, 0xA759, 0xA75B, 0xA75D, 0xA75F, 0xA761, 0xA763, 0xA765, 0xA767, 0xA769, 0xA76B, 0xA76D, 0xA76F, 0xA77A, 0xA77C, 0xA77F, 0xA781, 0xA783, 0xA785, 0xA787, 0xA78C, 0xA791, 0xA797, 0xA799, 0xA79B, 0xA79D, 0xA79F, 0xA7A1, 0xA7A3, 0xA7A5, 0xA7A7, 0xA7A9, 0xA7B5, 0xA7B7, 0xA7B9, 0xA7BB, 0xA7BD, 0xA7BF, 0xA7C1, 0xA7C3, 0xA7C8, 0xA7CA, 0xA7D1, 0xA7D7, 0xA7D9, 0xA7F6, 0xAB53);
		    set.addRange(0x61, 0x7A).addRange(0xDF, 0xF6).addRange(0xF8, 0xFF).addRange(0x148, 0x149).addRange(0x17E, 0x180).addRange(0x199, 0x19A).addRange(0x1C6, 0x1C7).addRange(0x1C9, 0x1CA).addRange(0x1DC, 0x1DD).addRange(0x1EF, 0x1F1).addRange(0x23F, 0x240).addRange(0x24F, 0x254).addRange(0x256, 0x257).addRange(0x25B, 0x25C).addRange(0x260, 0x261).addRange(0x265, 0x266).addRange(0x268, 0x26C).addRange(0x271, 0x272).addRange(0x282, 0x283).addRange(0x287, 0x28C).addRange(0x29D, 0x29E).addRange(0x37B, 0x37D).addRange(0x3AC, 0x3CE).addRange(0x3D0, 0x3D1).addRange(0x3D5, 0x3D7).addRange(0x3EF, 0x3F3).addRange(0x430, 0x45F).addRange(0x4CE, 0x4CF).addRange(0x561, 0x587).addRange(0x13F8, 0x13FD).addRange(0x1C80, 0x1C88).addRange(0x1E95, 0x1E9B).addRange(0x1EFF, 0x1F07).addRange(0x1F10, 0x1F15).addRange(0x1F20, 0x1F27).addRange(0x1F30, 0x1F37).addRange(0x1F40, 0x1F45).addRange(0x1F50, 0x1F57).addRange(0x1F60, 0x1F67).addRange(0x1F70, 0x1F7D).addRange(0x1F80, 0x1F87).addRange(0x1F90, 0x1F97).addRange(0x1FA0, 0x1FA7).addRange(0x1FB0, 0x1FB4).addRange(0x1FB6, 0x1FB7).addRange(0x1FC2, 0x1FC4).addRange(0x1FC6, 0x1FC7).addRange(0x1FD0, 0x1FD3).addRange(0x1FD6, 0x1FD7).addRange(0x1FE0, 0x1FE7).addRange(0x1FF2, 0x1FF4);
		    set.addRange(0x1FF6, 0x1FF7).addRange(0x2170, 0x217F).addRange(0x24D0, 0x24E9).addRange(0x2C30, 0x2C5F).addRange(0x2C65, 0x2C66).addRange(0x2D00, 0x2D25).addRange(0xA793, 0xA794).addRange(0xAB70, 0xABBF).addRange(0xFB00, 0xFB06).addRange(0xFB13, 0xFB17).addRange(0xFF41, 0xFF5A).addRange(0x10428, 0x1044F).addRange(0x104D8, 0x104FB).addRange(0x10597, 0x105A1).addRange(0x105A3, 0x105B1).addRange(0x105B3, 0x105B9).addRange(0x105BB, 0x105BC).addRange(0x10CC0, 0x10CF2).addRange(0x118C0, 0x118DF).addRange(0x16E60, 0x16E7F).addRange(0x1E922, 0x1E943);
		    Changes_When_Titlecased.characters = set;
		    return Changes_When_Titlecased;
		  }

		  var Changes_When_Uppercased = {};

		  var hasRequiredChanges_When_Uppercased;
		  function requireChanges_When_Uppercased() {
		    if (hasRequiredChanges_When_Uppercased) return Changes_When_Uppercased;
		    hasRequiredChanges_When_Uppercased = 1;
		    var set = regenerateExports(0xB5, 0x101, 0x103, 0x105, 0x107, 0x109, 0x10B, 0x10D, 0x10F, 0x111, 0x113, 0x115, 0x117, 0x119, 0x11B, 0x11D, 0x11F, 0x121, 0x123, 0x125, 0x127, 0x129, 0x12B, 0x12D, 0x12F, 0x131, 0x133, 0x135, 0x137, 0x13A, 0x13C, 0x13E, 0x140, 0x142, 0x144, 0x146, 0x14B, 0x14D, 0x14F, 0x151, 0x153, 0x155, 0x157, 0x159, 0x15B, 0x15D, 0x15F, 0x161, 0x163, 0x165, 0x167, 0x169, 0x16B, 0x16D, 0x16F, 0x171, 0x173, 0x175, 0x177, 0x17A, 0x17C, 0x183, 0x185, 0x188, 0x18C, 0x192, 0x195, 0x19E, 0x1A1, 0x1A3, 0x1A5, 0x1A8, 0x1AD, 0x1B0, 0x1B4, 0x1B6, 0x1B9, 0x1BD, 0x1BF, 0x1CE, 0x1D0, 0x1D2, 0x1D4, 0x1D6, 0x1D8, 0x1DA, 0x1DF, 0x1E1, 0x1E3, 0x1E5, 0x1E7, 0x1E9, 0x1EB, 0x1ED, 0x1F5, 0x1F9, 0x1FB, 0x1FD, 0x1FF, 0x201, 0x203, 0x205, 0x207, 0x209, 0x20B, 0x20D, 0x20F, 0x211, 0x213, 0x215, 0x217, 0x219, 0x21B, 0x21D, 0x21F, 0x223, 0x225, 0x227, 0x229, 0x22B, 0x22D, 0x22F, 0x231, 0x233, 0x23C, 0x242, 0x247, 0x249, 0x24B, 0x24D, 0x259, 0x263, 0x26F, 0x275, 0x27D, 0x280, 0x292, 0x345, 0x371, 0x373, 0x377, 0x390, 0x3D9, 0x3DB, 0x3DD, 0x3DF, 0x3E1, 0x3E3, 0x3E5, 0x3E7, 0x3E9, 0x3EB, 0x3ED, 0x3F5, 0x3F8, 0x3FB, 0x461, 0x463, 0x465, 0x467, 0x469, 0x46B, 0x46D, 0x46F, 0x471, 0x473, 0x475, 0x477, 0x479, 0x47B, 0x47D, 0x47F, 0x481, 0x48B, 0x48D, 0x48F, 0x491, 0x493, 0x495, 0x497, 0x499, 0x49B, 0x49D, 0x49F, 0x4A1, 0x4A3, 0x4A5, 0x4A7, 0x4A9, 0x4AB, 0x4AD, 0x4AF, 0x4B1, 0x4B3, 0x4B5, 0x4B7, 0x4B9, 0x4BB, 0x4BD, 0x4BF, 0x4C2, 0x4C4, 0x4C6, 0x4C8, 0x4CA, 0x4CC, 0x4D1, 0x4D3, 0x4D5, 0x4D7, 0x4D9, 0x4DB, 0x4DD, 0x4DF, 0x4E1, 0x4E3, 0x4E5, 0x4E7, 0x4E9, 0x4EB, 0x4ED, 0x4EF, 0x4F1, 0x4F3, 0x4F5, 0x4F7, 0x4F9, 0x4FB, 0x4FD, 0x4FF, 0x501, 0x503, 0x505, 0x507, 0x509, 0x50B, 0x50D, 0x50F, 0x511, 0x513, 0x515, 0x517, 0x519, 0x51B, 0x51D, 0x51F, 0x521, 0x523, 0x525, 0x527, 0x529, 0x52B, 0x52D, 0x52F, 0x1D79, 0x1D7D, 0x1D8E, 0x1E01, 0x1E03, 0x1E05, 0x1E07, 0x1E09, 0x1E0B, 0x1E0D, 0x1E0F, 0x1E11, 0x1E13, 0x1E15, 0x1E17, 0x1E19, 0x1E1B, 0x1E1D, 0x1E1F, 0x1E21, 0x1E23, 0x1E25, 0x1E27, 0x1E29, 0x1E2B, 0x1E2D, 0x1E2F, 0x1E31, 0x1E33, 0x1E35, 0x1E37, 0x1E39, 0x1E3B, 0x1E3D, 0x1E3F, 0x1E41, 0x1E43, 0x1E45, 0x1E47, 0x1E49, 0x1E4B, 0x1E4D, 0x1E4F, 0x1E51, 0x1E53, 0x1E55, 0x1E57, 0x1E59, 0x1E5B, 0x1E5D, 0x1E5F, 0x1E61, 0x1E63, 0x1E65, 0x1E67, 0x1E69, 0x1E6B, 0x1E6D, 0x1E6F, 0x1E71, 0x1E73, 0x1E75, 0x1E77, 0x1E79, 0x1E7B, 0x1E7D, 0x1E7F, 0x1E81, 0x1E83, 0x1E85, 0x1E87, 0x1E89, 0x1E8B, 0x1E8D, 0x1E8F, 0x1E91, 0x1E93, 0x1EA1, 0x1EA3, 0x1EA5, 0x1EA7, 0x1EA9, 0x1EAB, 0x1EAD, 0x1EAF, 0x1EB1, 0x1EB3, 0x1EB5, 0x1EB7, 0x1EB9, 0x1EBB, 0x1EBD, 0x1EBF, 0x1EC1, 0x1EC3, 0x1EC5, 0x1EC7, 0x1EC9, 0x1ECB, 0x1ECD, 0x1ECF, 0x1ED1, 0x1ED3, 0x1ED5, 0x1ED7, 0x1ED9, 0x1EDB, 0x1EDD, 0x1EDF, 0x1EE1, 0x1EE3, 0x1EE5, 0x1EE7, 0x1EE9, 0x1EEB, 0x1EED, 0x1EEF, 0x1EF1, 0x1EF3, 0x1EF5, 0x1EF7, 0x1EF9, 0x1EFB, 0x1EFD, 0x1FBC, 0x1FBE, 0x1FCC, 0x1FFC, 0x214E, 0x2184, 0x2C61, 0x2C68, 0x2C6A, 0x2C6C, 0x2C73, 0x2C76, 0x2C81, 0x2C83, 0x2C85, 0x2C87, 0x2C89, 0x2C8B, 0x2C8D, 0x2C8F, 0x2C91, 0x2C93, 0x2C95, 0x2C97, 0x2C99, 0x2C9B, 0x2C9D, 0x2C9F, 0x2CA1, 0x2CA3, 0x2CA5, 0x2CA7, 0x2CA9, 0x2CAB, 0x2CAD, 0x2CAF, 0x2CB1, 0x2CB3, 0x2CB5, 0x2CB7, 0x2CB9, 0x2CBB, 0x2CBD, 0x2CBF, 0x2CC1, 0x2CC3, 0x2CC5, 0x2CC7, 0x2CC9, 0x2CCB, 0x2CCD, 0x2CCF, 0x2CD1, 0x2CD3, 0x2CD5, 0x2CD7, 0x2CD9, 0x2CDB, 0x2CDD, 0x2CDF, 0x2CE1, 0x2CE3, 0x2CEC, 0x2CEE, 0x2CF3, 0x2D27, 0x2D2D, 0xA641, 0xA643, 0xA645, 0xA647, 0xA649, 0xA64B, 0xA64D, 0xA64F, 0xA651, 0xA653, 0xA655, 0xA657, 0xA659, 0xA65B, 0xA65D, 0xA65F, 0xA661, 0xA663, 0xA665, 0xA667, 0xA669, 0xA66B, 0xA66D, 0xA681, 0xA683, 0xA685, 0xA687, 0xA689, 0xA68B, 0xA68D, 0xA68F, 0xA691, 0xA693, 0xA695, 0xA697, 0xA699, 0xA69B, 0xA723, 0xA725, 0xA727, 0xA729, 0xA72B, 0xA72D, 0xA72F, 0xA733, 0xA735, 0xA737, 0xA739, 0xA73B, 0xA73D, 0xA73F, 0xA741, 0xA743, 0xA745, 0xA747, 0xA749, 0xA74B, 0xA74D, 0xA74F, 0xA751, 0xA753, 0xA755, 0xA757, 0xA759, 0xA75B, 0xA75D, 0xA75F, 0xA761, 0xA763, 0xA765, 0xA767, 0xA769, 0xA76B, 0xA76D, 0xA76F, 0xA77A, 0xA77C, 0xA77F, 0xA781, 0xA783, 0xA785, 0xA787, 0xA78C, 0xA791, 0xA797, 0xA799, 0xA79B, 0xA79D, 0xA79F, 0xA7A1, 0xA7A3, 0xA7A5, 0xA7A7, 0xA7A9, 0xA7B5, 0xA7B7, 0xA7B9, 0xA7BB, 0xA7BD, 0xA7BF, 0xA7C1, 0xA7C3, 0xA7C8, 0xA7CA, 0xA7D1, 0xA7D7, 0xA7D9, 0xA7F6, 0xAB53);
		    set.addRange(0x61, 0x7A).addRange(0xDF, 0xF6).addRange(0xF8, 0xFF).addRange(0x148, 0x149).addRange(0x17E, 0x180).addRange(0x199, 0x19A).addRange(0x1C5, 0x1C6).addRange(0x1C8, 0x1C9).addRange(0x1CB, 0x1CC).addRange(0x1DC, 0x1DD).addRange(0x1EF, 0x1F0).addRange(0x1F2, 0x1F3).addRange(0x23F, 0x240).addRange(0x24F, 0x254).addRange(0x256, 0x257).addRange(0x25B, 0x25C).addRange(0x260, 0x261).addRange(0x265, 0x266).addRange(0x268, 0x26C).addRange(0x271, 0x272).addRange(0x282, 0x283).addRange(0x287, 0x28C).addRange(0x29D, 0x29E).addRange(0x37B, 0x37D).addRange(0x3AC, 0x3CE).addRange(0x3D0, 0x3D1).addRange(0x3D5, 0x3D7).addRange(0x3EF, 0x3F3).addRange(0x430, 0x45F).addRange(0x4CE, 0x4CF).addRange(0x561, 0x587).addRange(0x10D0, 0x10FA).addRange(0x10FD, 0x10FF).addRange(0x13F8, 0x13FD).addRange(0x1C80, 0x1C88).addRange(0x1E95, 0x1E9B).addRange(0x1EFF, 0x1F07).addRange(0x1F10, 0x1F15).addRange(0x1F20, 0x1F27).addRange(0x1F30, 0x1F37).addRange(0x1F40, 0x1F45).addRange(0x1F50, 0x1F57).addRange(0x1F60, 0x1F67).addRange(0x1F70, 0x1F7D).addRange(0x1F80, 0x1FB4).addRange(0x1FB6, 0x1FB7).addRange(0x1FC2, 0x1FC4).addRange(0x1FC6, 0x1FC7).addRange(0x1FD0, 0x1FD3).addRange(0x1FD6, 0x1FD7).addRange(0x1FE0, 0x1FE7);
		    set.addRange(0x1FF2, 0x1FF4).addRange(0x1FF6, 0x1FF7).addRange(0x2170, 0x217F).addRange(0x24D0, 0x24E9).addRange(0x2C30, 0x2C5F).addRange(0x2C65, 0x2C66).addRange(0x2D00, 0x2D25).addRange(0xA793, 0xA794).addRange(0xAB70, 0xABBF).addRange(0xFB00, 0xFB06).addRange(0xFB13, 0xFB17).addRange(0xFF41, 0xFF5A).addRange(0x10428, 0x1044F).addRange(0x104D8, 0x104FB).addRange(0x10597, 0x105A1).addRange(0x105A3, 0x105B1).addRange(0x105B3, 0x105B9).addRange(0x105BB, 0x105BC).addRange(0x10CC0, 0x10CF2).addRange(0x118C0, 0x118DF).addRange(0x16E60, 0x16E7F).addRange(0x1E922, 0x1E943);
		    Changes_When_Uppercased.characters = set;
		    return Changes_When_Uppercased;
		  }

		  var Dash = {};

		  var hasRequiredDash;
		  function requireDash() {
		    if (hasRequiredDash) return Dash;
		    hasRequiredDash = 1;
		    var set = regenerateExports(0x2D, 0x58A, 0x5BE, 0x1400, 0x1806, 0x2053, 0x207B, 0x208B, 0x2212, 0x2E17, 0x2E1A, 0x2E40, 0x2E5D, 0x301C, 0x3030, 0x30A0, 0xFE58, 0xFE63, 0xFF0D, 0x10EAD);
		    set.addRange(0x2010, 0x2015).addRange(0x2E3A, 0x2E3B).addRange(0xFE31, 0xFE32);
		    Dash.characters = set;
		    return Dash;
		  }

		  var Default_Ignorable_Code_Point = {};

		  var hasRequiredDefault_Ignorable_Code_Point;
		  function requireDefault_Ignorable_Code_Point() {
		    if (hasRequiredDefault_Ignorable_Code_Point) return Default_Ignorable_Code_Point;
		    hasRequiredDefault_Ignorable_Code_Point = 1;
		    var set = regenerateExports(0xAD, 0x34F, 0x61C, 0x3164, 0xFEFF, 0xFFA0);
		    set.addRange(0x115F, 0x1160).addRange(0x17B4, 0x17B5).addRange(0x180B, 0x180F).addRange(0x200B, 0x200F).addRange(0x202A, 0x202E).addRange(0x2060, 0x206F).addRange(0xFE00, 0xFE0F).addRange(0xFFF0, 0xFFF8).addRange(0x1BCA0, 0x1BCA3).addRange(0x1D173, 0x1D17A).addRange(0xE0000, 0xE0FFF);
		    Default_Ignorable_Code_Point.characters = set;
		    return Default_Ignorable_Code_Point;
		  }

		  var Deprecated = {};

		  var hasRequiredDeprecated;
		  function requireDeprecated() {
		    if (hasRequiredDeprecated) return Deprecated;
		    hasRequiredDeprecated = 1;
		    var set = regenerateExports(0x149, 0x673, 0xF77, 0xF79, 0xE0001);
		    set.addRange(0x17A3, 0x17A4).addRange(0x206A, 0x206F).addRange(0x2329, 0x232A);
		    Deprecated.characters = set;
		    return Deprecated;
		  }

		  var Diacritic = {};

		  var hasRequiredDiacritic;
		  function requireDiacritic() {
		    if (hasRequiredDiacritic) return Diacritic;
		    hasRequiredDiacritic = 1;
		    var set = regenerateExports(0x5E, 0x60, 0xA8, 0xAF, 0xB4, 0x37A, 0x559, 0x5BF, 0x5C4, 0x93C, 0x94D, 0x971, 0x9BC, 0x9CD, 0xA3C, 0xA4D, 0xABC, 0xACD, 0xB3C, 0xB4D, 0xB55, 0xBCD, 0xC3C, 0xC4D, 0xCBC, 0xCCD, 0xD4D, 0xDCA, 0xE4E, 0xEBA, 0xF35, 0xF37, 0xF39, 0xFC6, 0x1037, 0x108F, 0x17DD, 0x1A7F, 0x1B34, 0x1B44, 0x1CED, 0x1CF4, 0x1FBD, 0x2E2F, 0x30FC, 0xA66F, 0xA67F, 0xA8C4, 0xA953, 0xA9B3, 0xA9C0, 0xA9E5, 0xAAF6, 0xFB1E, 0xFF3E, 0xFF40, 0xFF70, 0xFFE3, 0x102E0, 0x11046, 0x11070, 0x11173, 0x111C0, 0x1133C, 0x1134D, 0x11442, 0x11446, 0x1163F, 0x1172B, 0x11943, 0x119E0, 0x11A34, 0x11A47, 0x11A99, 0x11C3F, 0x11D42, 0x11D97, 0x1E2AE);
		    set.addRange(0xB7, 0xB8).addRange(0x2B0, 0x34E).addRange(0x350, 0x357).addRange(0x35D, 0x362).addRange(0x374, 0x375).addRange(0x384, 0x385).addRange(0x483, 0x487).addRange(0x591, 0x5A1).addRange(0x5A3, 0x5BD).addRange(0x5C1, 0x5C2).addRange(0x64B, 0x652).addRange(0x657, 0x658).addRange(0x6DF, 0x6E0).addRange(0x6E5, 0x6E6).addRange(0x6EA, 0x6EC).addRange(0x730, 0x74A).addRange(0x7A6, 0x7B0).addRange(0x7EB, 0x7F5).addRange(0x818, 0x819).addRange(0x898, 0x89F).addRange(0x8C9, 0x8D2).addRange(0x8E3, 0x8FE).addRange(0x951, 0x954).addRange(0xAFD, 0xAFF).addRange(0xD3B, 0xD3C).addRange(0xE47, 0xE4C).addRange(0xEC8, 0xECC).addRange(0xF18, 0xF19).addRange(0xF3E, 0xF3F).addRange(0xF82, 0xF84).addRange(0xF86, 0xF87).addRange(0x1039, 0x103A).addRange(0x1063, 0x1064).addRange(0x1069, 0x106D).addRange(0x1087, 0x108D).addRange(0x109A, 0x109B).addRange(0x135D, 0x135F).addRange(0x1714, 0x1715).addRange(0x17C9, 0x17D3).addRange(0x1939, 0x193B).addRange(0x1A75, 0x1A7C).addRange(0x1AB0, 0x1ABE).addRange(0x1AC1, 0x1ACB).addRange(0x1B6B, 0x1B73).addRange(0x1BAA, 0x1BAB).addRange(0x1C36, 0x1C37).addRange(0x1C78, 0x1C7D).addRange(0x1CD0, 0x1CE8).addRange(0x1CF7, 0x1CF9).addRange(0x1D2C, 0x1D6A).addRange(0x1DC4, 0x1DCF);
		    set.addRange(0x1DF5, 0x1DFF).addRange(0x1FBF, 0x1FC1).addRange(0x1FCD, 0x1FCF).addRange(0x1FDD, 0x1FDF).addRange(0x1FED, 0x1FEF).addRange(0x1FFD, 0x1FFE).addRange(0x2CEF, 0x2CF1).addRange(0x302A, 0x302F).addRange(0x3099, 0x309C).addRange(0xA67C, 0xA67D).addRange(0xA69C, 0xA69D).addRange(0xA6F0, 0xA6F1).addRange(0xA700, 0xA721).addRange(0xA788, 0xA78A).addRange(0xA7F8, 0xA7F9).addRange(0xA8E0, 0xA8F1).addRange(0xA92B, 0xA92E).addRange(0xAA7B, 0xAA7D).addRange(0xAABF, 0xAAC2).addRange(0xAB5B, 0xAB5F).addRange(0xAB69, 0xAB6B).addRange(0xABEC, 0xABED).addRange(0xFE20, 0xFE2F).addRange(0xFF9E, 0xFF9F).addRange(0x10780, 0x10785).addRange(0x10787, 0x107B0).addRange(0x107B2, 0x107BA).addRange(0x10AE5, 0x10AE6).addRange(0x10D22, 0x10D27).addRange(0x10EFD, 0x10EFF).addRange(0x10F46, 0x10F50).addRange(0x10F82, 0x10F85).addRange(0x110B9, 0x110BA).addRange(0x11133, 0x11134).addRange(0x111CA, 0x111CC).addRange(0x11235, 0x11236).addRange(0x112E9, 0x112EA).addRange(0x11366, 0x1136C).addRange(0x11370, 0x11374).addRange(0x114C2, 0x114C3).addRange(0x115BF, 0x115C0).addRange(0x116B6, 0x116B7).addRange(0x11839, 0x1183A).addRange(0x1193D, 0x1193E).addRange(0x11D44, 0x11D45).addRange(0x13447, 0x13455).addRange(0x16AF0, 0x16AF4).addRange(0x16B30, 0x16B36).addRange(0x16F8F, 0x16F9F).addRange(0x16FF0, 0x16FF1).addRange(0x1AFF0, 0x1AFF3);
		    set.addRange(0x1AFF5, 0x1AFFB).addRange(0x1AFFD, 0x1AFFE).addRange(0x1CF00, 0x1CF2D).addRange(0x1CF30, 0x1CF46).addRange(0x1D167, 0x1D169).addRange(0x1D16D, 0x1D172).addRange(0x1D17B, 0x1D182).addRange(0x1D185, 0x1D18B).addRange(0x1D1AA, 0x1D1AD).addRange(0x1E030, 0x1E06D).addRange(0x1E130, 0x1E136).addRange(0x1E2EC, 0x1E2EF).addRange(0x1E8D0, 0x1E8D6).addRange(0x1E944, 0x1E946).addRange(0x1E948, 0x1E94A);
		    Diacritic.characters = set;
		    return Diacritic;
		  }

		  var Emoji_Component = {};

		  var hasRequiredEmoji_Component;
		  function requireEmoji_Component() {
		    if (hasRequiredEmoji_Component) return Emoji_Component;
		    hasRequiredEmoji_Component = 1;
		    var set = regenerateExports(0x23, 0x2A, 0x200D, 0x20E3, 0xFE0F);
		    set.addRange(0x30, 0x39).addRange(0x1F1E6, 0x1F1FF).addRange(0x1F3FB, 0x1F3FF).addRange(0x1F9B0, 0x1F9B3).addRange(0xE0020, 0xE007F);
		    Emoji_Component.characters = set;
		    return Emoji_Component;
		  }

		  var Emoji_Modifier_Base = {};

		  var hasRequiredEmoji_Modifier_Base;
		  function requireEmoji_Modifier_Base() {
		    if (hasRequiredEmoji_Modifier_Base) return Emoji_Modifier_Base;
		    hasRequiredEmoji_Modifier_Base = 1;
		    var set = regenerateExports(0x261D, 0x26F9, 0x1F385, 0x1F3C7, 0x1F47C, 0x1F48F, 0x1F491, 0x1F4AA, 0x1F57A, 0x1F590, 0x1F6A3, 0x1F6C0, 0x1F6CC, 0x1F90C, 0x1F90F, 0x1F926, 0x1F977, 0x1F9BB);
		    set.addRange(0x270A, 0x270D).addRange(0x1F3C2, 0x1F3C4).addRange(0x1F3CA, 0x1F3CC).addRange(0x1F442, 0x1F443).addRange(0x1F446, 0x1F450).addRange(0x1F466, 0x1F478).addRange(0x1F481, 0x1F483).addRange(0x1F485, 0x1F487).addRange(0x1F574, 0x1F575).addRange(0x1F595, 0x1F596).addRange(0x1F645, 0x1F647).addRange(0x1F64B, 0x1F64F).addRange(0x1F6B4, 0x1F6B6).addRange(0x1F918, 0x1F91F).addRange(0x1F930, 0x1F939).addRange(0x1F93C, 0x1F93E).addRange(0x1F9B5, 0x1F9B6).addRange(0x1F9B8, 0x1F9B9).addRange(0x1F9CD, 0x1F9CF).addRange(0x1F9D1, 0x1F9DD).addRange(0x1FAC3, 0x1FAC5).addRange(0x1FAF0, 0x1FAF8);
		    Emoji_Modifier_Base.characters = set;
		    return Emoji_Modifier_Base;
		  }

		  var Emoji_Modifier = {};

		  var hasRequiredEmoji_Modifier;
		  function requireEmoji_Modifier() {
		    if (hasRequiredEmoji_Modifier) return Emoji_Modifier;
		    hasRequiredEmoji_Modifier = 1;
		    var set = regenerateExports();
		    set.addRange(0x1F3FB, 0x1F3FF);
		    Emoji_Modifier.characters = set;
		    return Emoji_Modifier;
		  }

		  var Emoji_Presentation = {};

		  var hasRequiredEmoji_Presentation;
		  function requireEmoji_Presentation() {
		    if (hasRequiredEmoji_Presentation) return Emoji_Presentation;
		    hasRequiredEmoji_Presentation = 1;
		    var set = regenerateExports(0x23F0, 0x23F3, 0x267F, 0x2693, 0x26A1, 0x26CE, 0x26D4, 0x26EA, 0x26F5, 0x26FA, 0x26FD, 0x2705, 0x2728, 0x274C, 0x274E, 0x2757, 0x27B0, 0x27BF, 0x2B50, 0x2B55, 0x1F004, 0x1F0CF, 0x1F18E, 0x1F201, 0x1F21A, 0x1F22F, 0x1F3F4, 0x1F440, 0x1F57A, 0x1F5A4, 0x1F6CC, 0x1F7F0);
		    set.addRange(0x231A, 0x231B).addRange(0x23E9, 0x23EC).addRange(0x25FD, 0x25FE).addRange(0x2614, 0x2615).addRange(0x2648, 0x2653).addRange(0x26AA, 0x26AB).addRange(0x26BD, 0x26BE).addRange(0x26C4, 0x26C5).addRange(0x26F2, 0x26F3).addRange(0x270A, 0x270B).addRange(0x2753, 0x2755).addRange(0x2795, 0x2797).addRange(0x2B1B, 0x2B1C).addRange(0x1F191, 0x1F19A).addRange(0x1F1E6, 0x1F1FF).addRange(0x1F232, 0x1F236).addRange(0x1F238, 0x1F23A).addRange(0x1F250, 0x1F251).addRange(0x1F300, 0x1F320).addRange(0x1F32D, 0x1F335).addRange(0x1F337, 0x1F37C).addRange(0x1F37E, 0x1F393).addRange(0x1F3A0, 0x1F3CA).addRange(0x1F3CF, 0x1F3D3).addRange(0x1F3E0, 0x1F3F0).addRange(0x1F3F8, 0x1F43E).addRange(0x1F442, 0x1F4FC).addRange(0x1F4FF, 0x1F53D).addRange(0x1F54B, 0x1F54E).addRange(0x1F550, 0x1F567).addRange(0x1F595, 0x1F596).addRange(0x1F5FB, 0x1F64F).addRange(0x1F680, 0x1F6C5).addRange(0x1F6D0, 0x1F6D2).addRange(0x1F6D5, 0x1F6D7).addRange(0x1F6DC, 0x1F6DF).addRange(0x1F6EB, 0x1F6EC).addRange(0x1F6F4, 0x1F6FC).addRange(0x1F7E0, 0x1F7EB).addRange(0x1F90C, 0x1F93A).addRange(0x1F93C, 0x1F945).addRange(0x1F947, 0x1F9FF).addRange(0x1FA70, 0x1FA7C).addRange(0x1FA80, 0x1FA88).addRange(0x1FA90, 0x1FABD).addRange(0x1FABF, 0x1FAC5).addRange(0x1FACE, 0x1FADB).addRange(0x1FAE0, 0x1FAE8).addRange(0x1FAF0, 0x1FAF8);
		    Emoji_Presentation.characters = set;
		    return Emoji_Presentation;
		  }

		  var Emoji = {};

		  var hasRequiredEmoji;
		  function requireEmoji() {
		    if (hasRequiredEmoji) return Emoji;
		    hasRequiredEmoji = 1;
		    var set = regenerateExports(0x23, 0x2A, 0xA9, 0xAE, 0x203C, 0x2049, 0x2122, 0x2139, 0x2328, 0x23CF, 0x24C2, 0x25B6, 0x25C0, 0x260E, 0x2611, 0x2618, 0x261D, 0x2620, 0x2626, 0x262A, 0x2640, 0x2642, 0x2663, 0x2668, 0x267B, 0x2699, 0x26A7, 0x26C8, 0x26D1, 0x26FD, 0x2702, 0x2705, 0x270F, 0x2712, 0x2714, 0x2716, 0x271D, 0x2721, 0x2728, 0x2744, 0x2747, 0x274C, 0x274E, 0x2757, 0x27A1, 0x27B0, 0x27BF, 0x2B50, 0x2B55, 0x3030, 0x303D, 0x3297, 0x3299, 0x1F004, 0x1F0CF, 0x1F18E, 0x1F21A, 0x1F22F, 0x1F587, 0x1F590, 0x1F5A8, 0x1F5BC, 0x1F5E1, 0x1F5E3, 0x1F5E8, 0x1F5EF, 0x1F5F3, 0x1F6E9, 0x1F6F0, 0x1F7F0);
		    set.addRange(0x30, 0x39).addRange(0x2194, 0x2199).addRange(0x21A9, 0x21AA).addRange(0x231A, 0x231B).addRange(0x23E9, 0x23F3).addRange(0x23F8, 0x23FA).addRange(0x25AA, 0x25AB).addRange(0x25FB, 0x25FE).addRange(0x2600, 0x2604).addRange(0x2614, 0x2615).addRange(0x2622, 0x2623).addRange(0x262E, 0x262F).addRange(0x2638, 0x263A).addRange(0x2648, 0x2653).addRange(0x265F, 0x2660).addRange(0x2665, 0x2666).addRange(0x267E, 0x267F).addRange(0x2692, 0x2697).addRange(0x269B, 0x269C).addRange(0x26A0, 0x26A1).addRange(0x26AA, 0x26AB).addRange(0x26B0, 0x26B1).addRange(0x26BD, 0x26BE).addRange(0x26C4, 0x26C5).addRange(0x26CE, 0x26CF).addRange(0x26D3, 0x26D4).addRange(0x26E9, 0x26EA).addRange(0x26F0, 0x26F5).addRange(0x26F7, 0x26FA).addRange(0x2708, 0x270D).addRange(0x2733, 0x2734).addRange(0x2753, 0x2755).addRange(0x2763, 0x2764).addRange(0x2795, 0x2797).addRange(0x2934, 0x2935).addRange(0x2B05, 0x2B07).addRange(0x2B1B, 0x2B1C).addRange(0x1F170, 0x1F171).addRange(0x1F17E, 0x1F17F).addRange(0x1F191, 0x1F19A).addRange(0x1F1E6, 0x1F1FF).addRange(0x1F201, 0x1F202).addRange(0x1F232, 0x1F23A).addRange(0x1F250, 0x1F251).addRange(0x1F300, 0x1F321).addRange(0x1F324, 0x1F393).addRange(0x1F396, 0x1F397).addRange(0x1F399, 0x1F39B).addRange(0x1F39E, 0x1F3F0).addRange(0x1F3F3, 0x1F3F5).addRange(0x1F3F7, 0x1F4FD);
		    set.addRange(0x1F4FF, 0x1F53D).addRange(0x1F549, 0x1F54E).addRange(0x1F550, 0x1F567).addRange(0x1F56F, 0x1F570).addRange(0x1F573, 0x1F57A).addRange(0x1F58A, 0x1F58D).addRange(0x1F595, 0x1F596).addRange(0x1F5A4, 0x1F5A5).addRange(0x1F5B1, 0x1F5B2).addRange(0x1F5C2, 0x1F5C4).addRange(0x1F5D1, 0x1F5D3).addRange(0x1F5DC, 0x1F5DE).addRange(0x1F5FA, 0x1F64F).addRange(0x1F680, 0x1F6C5).addRange(0x1F6CB, 0x1F6D2).addRange(0x1F6D5, 0x1F6D7).addRange(0x1F6DC, 0x1F6E5).addRange(0x1F6EB, 0x1F6EC).addRange(0x1F6F3, 0x1F6FC).addRange(0x1F7E0, 0x1F7EB).addRange(0x1F90C, 0x1F93A).addRange(0x1F93C, 0x1F945).addRange(0x1F947, 0x1F9FF).addRange(0x1FA70, 0x1FA7C).addRange(0x1FA80, 0x1FA88).addRange(0x1FA90, 0x1FABD).addRange(0x1FABF, 0x1FAC5).addRange(0x1FACE, 0x1FADB).addRange(0x1FAE0, 0x1FAE8).addRange(0x1FAF0, 0x1FAF8);
		    Emoji.characters = set;
		    return Emoji;
		  }

		  var Extended_Pictographic = {};

		  var hasRequiredExtended_Pictographic;
		  function requireExtended_Pictographic() {
		    if (hasRequiredExtended_Pictographic) return Extended_Pictographic;
		    hasRequiredExtended_Pictographic = 1;
		    var set = regenerateExports(0xA9, 0xAE, 0x203C, 0x2049, 0x2122, 0x2139, 0x2328, 0x2388, 0x23CF, 0x24C2, 0x25B6, 0x25C0, 0x2714, 0x2716, 0x271D, 0x2721, 0x2728, 0x2744, 0x2747, 0x274C, 0x274E, 0x2757, 0x27A1, 0x27B0, 0x27BF, 0x2B50, 0x2B55, 0x3030, 0x303D, 0x3297, 0x3299, 0x1F12F, 0x1F18E, 0x1F21A, 0x1F22F);
		    set.addRange(0x2194, 0x2199).addRange(0x21A9, 0x21AA).addRange(0x231A, 0x231B).addRange(0x23E9, 0x23F3).addRange(0x23F8, 0x23FA).addRange(0x25AA, 0x25AB).addRange(0x25FB, 0x25FE).addRange(0x2600, 0x2605).addRange(0x2607, 0x2612).addRange(0x2614, 0x2685).addRange(0x2690, 0x2705).addRange(0x2708, 0x2712).addRange(0x2733, 0x2734).addRange(0x2753, 0x2755).addRange(0x2763, 0x2767).addRange(0x2795, 0x2797).addRange(0x2934, 0x2935).addRange(0x2B05, 0x2B07).addRange(0x2B1B, 0x2B1C).addRange(0x1F000, 0x1F0FF).addRange(0x1F10D, 0x1F10F).addRange(0x1F16C, 0x1F171).addRange(0x1F17E, 0x1F17F).addRange(0x1F191, 0x1F19A).addRange(0x1F1AD, 0x1F1E5).addRange(0x1F201, 0x1F20F).addRange(0x1F232, 0x1F23A).addRange(0x1F23C, 0x1F23F).addRange(0x1F249, 0x1F3FA).addRange(0x1F400, 0x1F53D).addRange(0x1F546, 0x1F64F).addRange(0x1F680, 0x1F6FF).addRange(0x1F774, 0x1F77F).addRange(0x1F7D5, 0x1F7FF).addRange(0x1F80C, 0x1F80F).addRange(0x1F848, 0x1F84F).addRange(0x1F85A, 0x1F85F).addRange(0x1F888, 0x1F88F).addRange(0x1F8AE, 0x1F8FF).addRange(0x1F90C, 0x1F93A).addRange(0x1F93C, 0x1F945).addRange(0x1F947, 0x1FAFF).addRange(0x1FC00, 0x1FFFD);
		    Extended_Pictographic.characters = set;
		    return Extended_Pictographic;
		  }

		  var Extender = {};

		  var hasRequiredExtender;
		  function requireExtender() {
		    if (hasRequiredExtender) return Extender;
		    hasRequiredExtender = 1;
		    var set = regenerateExports(0xB7, 0x640, 0x7FA, 0xB55, 0xE46, 0xEC6, 0x180A, 0x1843, 0x1AA7, 0x1C36, 0x1C7B, 0x3005, 0xA015, 0xA60C, 0xA9CF, 0xA9E6, 0xAA70, 0xAADD, 0xFF70, 0x1135D, 0x11A98, 0x16FE3);
		    set.addRange(0x2D0, 0x2D1).addRange(0x3031, 0x3035).addRange(0x309D, 0x309E).addRange(0x30FC, 0x30FE).addRange(0xAAF3, 0xAAF4).addRange(0x10781, 0x10782).addRange(0x115C6, 0x115C8).addRange(0x16B42, 0x16B43).addRange(0x16FE0, 0x16FE1).addRange(0x1E13C, 0x1E13D).addRange(0x1E944, 0x1E946);
		    Extender.characters = set;
		    return Extender;
		  }

		  var Grapheme_Base = {};

		  var hasRequiredGrapheme_Base;
		  function requireGrapheme_Base() {
		    if (hasRequiredGrapheme_Base) return Grapheme_Base;
		    hasRequiredGrapheme_Base = 1;
		    var set = regenerateExports(0x38C, 0x5BE, 0x5C0, 0x5C3, 0x5C6, 0x61B, 0x6DE, 0x6E9, 0x710, 0x7B1, 0x81A, 0x824, 0x828, 0x85E, 0x93B, 0x9B2, 0x9BD, 0x9CE, 0xA03, 0xA5E, 0xA76, 0xA83, 0xAC9, 0xAD0, 0xAF9, 0xB3D, 0xB40, 0xB83, 0xB9C, 0xBBF, 0xBD0, 0xC3D, 0xC5D, 0xD3D, 0xDBD, 0xE84, 0xEA5, 0xEBD, 0xEC6, 0xF36, 0xF38, 0xF7F, 0xF85, 0x1031, 0x1038, 0x10C7, 0x10CD, 0x1258, 0x12C0, 0x1715, 0x17B6, 0x18AA, 0x1940, 0x1A57, 0x1A61, 0x1B3B, 0x1BAA, 0x1BE7, 0x1BEE, 0x1CD3, 0x1CE1, 0x1CFA, 0x1F59, 0x1F5B, 0x1F5D, 0x2D27, 0x2D2D, 0xA673, 0xA7D3, 0xAA4D, 0xAAB1, 0xAAC0, 0xAAC2, 0xFB1D, 0xFB3E, 0xFDCF, 0x101A0, 0x10808, 0x1083C, 0x1093F, 0x10EAD, 0x11000, 0x11075, 0x1112C, 0x11235, 0x11288, 0x1133D, 0x1133F, 0x11350, 0x11445, 0x1145D, 0x114B9, 0x114BE, 0x114C1, 0x115BE, 0x1163E, 0x116AC, 0x116B6, 0x11726, 0x11838, 0x1183B, 0x11909, 0x1193D, 0x11A00, 0x11A50, 0x11A97, 0x11C3E, 0x11CA9, 0x11CB1, 0x11CB4, 0x11D46, 0x11D96, 0x11D98, 0x11F41, 0x11FB0, 0x16AF5, 0x1B132, 0x1B155, 0x1BC9C, 0x1BC9F, 0x1D166, 0x1D245, 0x1D4A2, 0x1D4BB, 0x1D546, 0x1E2FF, 0x1E94B, 0x1EE24, 0x1EE27, 0x1EE39, 0x1EE3B, 0x1EE42, 0x1EE47, 0x1EE49, 0x1EE4B, 0x1EE54, 0x1EE57, 0x1EE59, 0x1EE5B, 0x1EE5D, 0x1EE5F, 0x1EE64, 0x1EE7E, 0x1F7F0);
		    set.addRange(0x20, 0x7E).addRange(0xA0, 0xAC).addRange(0xAE, 0x2FF).addRange(0x370, 0x377).addRange(0x37A, 0x37F).addRange(0x384, 0x38A).addRange(0x38E, 0x3A1).addRange(0x3A3, 0x482).addRange(0x48A, 0x52F).addRange(0x531, 0x556).addRange(0x559, 0x58A).addRange(0x58D, 0x58F).addRange(0x5D0, 0x5EA).addRange(0x5EF, 0x5F4).addRange(0x606, 0x60F).addRange(0x61D, 0x64A).addRange(0x660, 0x66F).addRange(0x671, 0x6D5).addRange(0x6E5, 0x6E6).addRange(0x6EE, 0x70D).addRange(0x712, 0x72F).addRange(0x74D, 0x7A5).addRange(0x7C0, 0x7EA).addRange(0x7F4, 0x7FA).addRange(0x7FE, 0x815).addRange(0x830, 0x83E).addRange(0x840, 0x858).addRange(0x860, 0x86A).addRange(0x870, 0x88E).addRange(0x8A0, 0x8C9).addRange(0x903, 0x939).addRange(0x93D, 0x940).addRange(0x949, 0x94C).addRange(0x94E, 0x950).addRange(0x958, 0x961).addRange(0x964, 0x980).addRange(0x982, 0x983).addRange(0x985, 0x98C).addRange(0x98F, 0x990).addRange(0x993, 0x9A8).addRange(0x9AA, 0x9B0).addRange(0x9B6, 0x9B9).addRange(0x9BF, 0x9C0).addRange(0x9C7, 0x9C8).addRange(0x9CB, 0x9CC).addRange(0x9DC, 0x9DD).addRange(0x9DF, 0x9E1).addRange(0x9E6, 0x9FD).addRange(0xA05, 0xA0A).addRange(0xA0F, 0xA10).addRange(0xA13, 0xA28);
		    set.addRange(0xA2A, 0xA30).addRange(0xA32, 0xA33).addRange(0xA35, 0xA36).addRange(0xA38, 0xA39).addRange(0xA3E, 0xA40).addRange(0xA59, 0xA5C).addRange(0xA66, 0xA6F).addRange(0xA72, 0xA74).addRange(0xA85, 0xA8D).addRange(0xA8F, 0xA91).addRange(0xA93, 0xAA8).addRange(0xAAA, 0xAB0).addRange(0xAB2, 0xAB3).addRange(0xAB5, 0xAB9).addRange(0xABD, 0xAC0).addRange(0xACB, 0xACC).addRange(0xAE0, 0xAE1).addRange(0xAE6, 0xAF1).addRange(0xB02, 0xB03).addRange(0xB05, 0xB0C).addRange(0xB0F, 0xB10).addRange(0xB13, 0xB28).addRange(0xB2A, 0xB30).addRange(0xB32, 0xB33).addRange(0xB35, 0xB39).addRange(0xB47, 0xB48).addRange(0xB4B, 0xB4C).addRange(0xB5C, 0xB5D).addRange(0xB5F, 0xB61).addRange(0xB66, 0xB77).addRange(0xB85, 0xB8A).addRange(0xB8E, 0xB90).addRange(0xB92, 0xB95).addRange(0xB99, 0xB9A).addRange(0xB9E, 0xB9F).addRange(0xBA3, 0xBA4).addRange(0xBA8, 0xBAA).addRange(0xBAE, 0xBB9).addRange(0xBC1, 0xBC2).addRange(0xBC6, 0xBC8).addRange(0xBCA, 0xBCC).addRange(0xBE6, 0xBFA).addRange(0xC01, 0xC03).addRange(0xC05, 0xC0C).addRange(0xC0E, 0xC10).addRange(0xC12, 0xC28).addRange(0xC2A, 0xC39).addRange(0xC41, 0xC44).addRange(0xC58, 0xC5A).addRange(0xC60, 0xC61).addRange(0xC66, 0xC6F);
		    set.addRange(0xC77, 0xC80).addRange(0xC82, 0xC8C).addRange(0xC8E, 0xC90).addRange(0xC92, 0xCA8).addRange(0xCAA, 0xCB3).addRange(0xCB5, 0xCB9).addRange(0xCBD, 0xCBE).addRange(0xCC0, 0xCC1).addRange(0xCC3, 0xCC4).addRange(0xCC7, 0xCC8).addRange(0xCCA, 0xCCB).addRange(0xCDD, 0xCDE).addRange(0xCE0, 0xCE1).addRange(0xCE6, 0xCEF).addRange(0xCF1, 0xCF3).addRange(0xD02, 0xD0C).addRange(0xD0E, 0xD10).addRange(0xD12, 0xD3A).addRange(0xD3F, 0xD40).addRange(0xD46, 0xD48).addRange(0xD4A, 0xD4C).addRange(0xD4E, 0xD4F).addRange(0xD54, 0xD56).addRange(0xD58, 0xD61).addRange(0xD66, 0xD7F).addRange(0xD82, 0xD83).addRange(0xD85, 0xD96).addRange(0xD9A, 0xDB1).addRange(0xDB3, 0xDBB).addRange(0xDC0, 0xDC6).addRange(0xDD0, 0xDD1).addRange(0xDD8, 0xDDE).addRange(0xDE6, 0xDEF).addRange(0xDF2, 0xDF4).addRange(0xE01, 0xE30).addRange(0xE32, 0xE33).addRange(0xE3F, 0xE46).addRange(0xE4F, 0xE5B).addRange(0xE81, 0xE82).addRange(0xE86, 0xE8A).addRange(0xE8C, 0xEA3).addRange(0xEA7, 0xEB0).addRange(0xEB2, 0xEB3).addRange(0xEC0, 0xEC4).addRange(0xED0, 0xED9).addRange(0xEDC, 0xEDF).addRange(0xF00, 0xF17).addRange(0xF1A, 0xF34).addRange(0xF3A, 0xF47).addRange(0xF49, 0xF6C).addRange(0xF88, 0xF8C);
		    set.addRange(0xFBE, 0xFC5).addRange(0xFC7, 0xFCC).addRange(0xFCE, 0xFDA).addRange(0x1000, 0x102C).addRange(0x103B, 0x103C).addRange(0x103F, 0x1057).addRange(0x105A, 0x105D).addRange(0x1061, 0x1070).addRange(0x1075, 0x1081).addRange(0x1083, 0x1084).addRange(0x1087, 0x108C).addRange(0x108E, 0x109C).addRange(0x109E, 0x10C5).addRange(0x10D0, 0x1248).addRange(0x124A, 0x124D).addRange(0x1250, 0x1256).addRange(0x125A, 0x125D).addRange(0x1260, 0x1288).addRange(0x128A, 0x128D).addRange(0x1290, 0x12B0).addRange(0x12B2, 0x12B5).addRange(0x12B8, 0x12BE).addRange(0x12C2, 0x12C5).addRange(0x12C8, 0x12D6).addRange(0x12D8, 0x1310).addRange(0x1312, 0x1315).addRange(0x1318, 0x135A).addRange(0x1360, 0x137C).addRange(0x1380, 0x1399).addRange(0x13A0, 0x13F5).addRange(0x13F8, 0x13FD).addRange(0x1400, 0x169C).addRange(0x16A0, 0x16F8).addRange(0x1700, 0x1711).addRange(0x171F, 0x1731).addRange(0x1734, 0x1736).addRange(0x1740, 0x1751).addRange(0x1760, 0x176C).addRange(0x176E, 0x1770).addRange(0x1780, 0x17B3).addRange(0x17BE, 0x17C5).addRange(0x17C7, 0x17C8).addRange(0x17D4, 0x17DC).addRange(0x17E0, 0x17E9).addRange(0x17F0, 0x17F9).addRange(0x1800, 0x180A).addRange(0x1810, 0x1819).addRange(0x1820, 0x1878).addRange(0x1880, 0x1884).addRange(0x1887, 0x18A8).addRange(0x18B0, 0x18F5);
		    set.addRange(0x1900, 0x191E).addRange(0x1923, 0x1926).addRange(0x1929, 0x192B).addRange(0x1930, 0x1931).addRange(0x1933, 0x1938).addRange(0x1944, 0x196D).addRange(0x1970, 0x1974).addRange(0x1980, 0x19AB).addRange(0x19B0, 0x19C9).addRange(0x19D0, 0x19DA).addRange(0x19DE, 0x1A16).addRange(0x1A19, 0x1A1A).addRange(0x1A1E, 0x1A55).addRange(0x1A63, 0x1A64).addRange(0x1A6D, 0x1A72).addRange(0x1A80, 0x1A89).addRange(0x1A90, 0x1A99).addRange(0x1AA0, 0x1AAD).addRange(0x1B04, 0x1B33).addRange(0x1B3D, 0x1B41).addRange(0x1B43, 0x1B4C).addRange(0x1B50, 0x1B6A).addRange(0x1B74, 0x1B7E).addRange(0x1B82, 0x1BA1).addRange(0x1BA6, 0x1BA7).addRange(0x1BAE, 0x1BE5).addRange(0x1BEA, 0x1BEC).addRange(0x1BF2, 0x1BF3).addRange(0x1BFC, 0x1C2B).addRange(0x1C34, 0x1C35).addRange(0x1C3B, 0x1C49).addRange(0x1C4D, 0x1C88).addRange(0x1C90, 0x1CBA).addRange(0x1CBD, 0x1CC7).addRange(0x1CE9, 0x1CEC).addRange(0x1CEE, 0x1CF3).addRange(0x1CF5, 0x1CF7).addRange(0x1D00, 0x1DBF).addRange(0x1E00, 0x1F15).addRange(0x1F18, 0x1F1D).addRange(0x1F20, 0x1F45).addRange(0x1F48, 0x1F4D).addRange(0x1F50, 0x1F57).addRange(0x1F5F, 0x1F7D).addRange(0x1F80, 0x1FB4).addRange(0x1FB6, 0x1FC4).addRange(0x1FC6, 0x1FD3).addRange(0x1FD6, 0x1FDB).addRange(0x1FDD, 0x1FEF).addRange(0x1FF2, 0x1FF4).addRange(0x1FF6, 0x1FFE);
		    set.addRange(0x2000, 0x200A).addRange(0x2010, 0x2027).addRange(0x202F, 0x205F).addRange(0x2070, 0x2071).addRange(0x2074, 0x208E).addRange(0x2090, 0x209C).addRange(0x20A0, 0x20C0).addRange(0x2100, 0x218B).addRange(0x2190, 0x2426).addRange(0x2440, 0x244A).addRange(0x2460, 0x2B73).addRange(0x2B76, 0x2B95).addRange(0x2B97, 0x2CEE).addRange(0x2CF2, 0x2CF3).addRange(0x2CF9, 0x2D25).addRange(0x2D30, 0x2D67).addRange(0x2D6F, 0x2D70).addRange(0x2D80, 0x2D96).addRange(0x2DA0, 0x2DA6).addRange(0x2DA8, 0x2DAE).addRange(0x2DB0, 0x2DB6).addRange(0x2DB8, 0x2DBE).addRange(0x2DC0, 0x2DC6).addRange(0x2DC8, 0x2DCE).addRange(0x2DD0, 0x2DD6).addRange(0x2DD8, 0x2DDE).addRange(0x2E00, 0x2E5D).addRange(0x2E80, 0x2E99).addRange(0x2E9B, 0x2EF3).addRange(0x2F00, 0x2FD5).addRange(0x2FF0, 0x3029).addRange(0x3030, 0x303F).addRange(0x3041, 0x3096).addRange(0x309B, 0x30FF).addRange(0x3105, 0x312F).addRange(0x3131, 0x318E).addRange(0x3190, 0x31E3).addRange(0x31EF, 0x321E).addRange(0x3220, 0xA48C).addRange(0xA490, 0xA4C6).addRange(0xA4D0, 0xA62B).addRange(0xA640, 0xA66E).addRange(0xA67E, 0xA69D).addRange(0xA6A0, 0xA6EF).addRange(0xA6F2, 0xA6F7).addRange(0xA700, 0xA7CA).addRange(0xA7D0, 0xA7D1).addRange(0xA7D5, 0xA7D9).addRange(0xA7F2, 0xA801).addRange(0xA803, 0xA805).addRange(0xA807, 0xA80A);
		    set.addRange(0xA80C, 0xA824).addRange(0xA827, 0xA82B).addRange(0xA830, 0xA839).addRange(0xA840, 0xA877).addRange(0xA880, 0xA8C3).addRange(0xA8CE, 0xA8D9).addRange(0xA8F2, 0xA8FE).addRange(0xA900, 0xA925).addRange(0xA92E, 0xA946).addRange(0xA952, 0xA953).addRange(0xA95F, 0xA97C).addRange(0xA983, 0xA9B2).addRange(0xA9B4, 0xA9B5).addRange(0xA9BA, 0xA9BB).addRange(0xA9BE, 0xA9CD).addRange(0xA9CF, 0xA9D9).addRange(0xA9DE, 0xA9E4).addRange(0xA9E6, 0xA9FE).addRange(0xAA00, 0xAA28).addRange(0xAA2F, 0xAA30).addRange(0xAA33, 0xAA34).addRange(0xAA40, 0xAA42).addRange(0xAA44, 0xAA4B).addRange(0xAA50, 0xAA59).addRange(0xAA5C, 0xAA7B).addRange(0xAA7D, 0xAAAF).addRange(0xAAB5, 0xAAB6).addRange(0xAAB9, 0xAABD).addRange(0xAADB, 0xAAEB).addRange(0xAAEE, 0xAAF5).addRange(0xAB01, 0xAB06).addRange(0xAB09, 0xAB0E).addRange(0xAB11, 0xAB16).addRange(0xAB20, 0xAB26).addRange(0xAB28, 0xAB2E).addRange(0xAB30, 0xAB6B).addRange(0xAB70, 0xABE4).addRange(0xABE6, 0xABE7).addRange(0xABE9, 0xABEC).addRange(0xABF0, 0xABF9).addRange(0xAC00, 0xD7A3).addRange(0xD7B0, 0xD7C6).addRange(0xD7CB, 0xD7FB).addRange(0xF900, 0xFA6D).addRange(0xFA70, 0xFAD9).addRange(0xFB00, 0xFB06).addRange(0xFB13, 0xFB17).addRange(0xFB1F, 0xFB36).addRange(0xFB38, 0xFB3C).addRange(0xFB40, 0xFB41).addRange(0xFB43, 0xFB44);
		    set.addRange(0xFB46, 0xFBC2).addRange(0xFBD3, 0xFD8F).addRange(0xFD92, 0xFDC7).addRange(0xFDF0, 0xFDFF).addRange(0xFE10, 0xFE19).addRange(0xFE30, 0xFE52).addRange(0xFE54, 0xFE66).addRange(0xFE68, 0xFE6B).addRange(0xFE70, 0xFE74).addRange(0xFE76, 0xFEFC).addRange(0xFF01, 0xFF9D).addRange(0xFFA0, 0xFFBE).addRange(0xFFC2, 0xFFC7).addRange(0xFFCA, 0xFFCF).addRange(0xFFD2, 0xFFD7).addRange(0xFFDA, 0xFFDC).addRange(0xFFE0, 0xFFE6).addRange(0xFFE8, 0xFFEE).addRange(0xFFFC, 0xFFFD).addRange(0x10000, 0x1000B).addRange(0x1000D, 0x10026).addRange(0x10028, 0x1003A).addRange(0x1003C, 0x1003D).addRange(0x1003F, 0x1004D).addRange(0x10050, 0x1005D).addRange(0x10080, 0x100FA).addRange(0x10100, 0x10102).addRange(0x10107, 0x10133).addRange(0x10137, 0x1018E).addRange(0x10190, 0x1019C).addRange(0x101D0, 0x101FC).addRange(0x10280, 0x1029C).addRange(0x102A0, 0x102D0).addRange(0x102E1, 0x102FB).addRange(0x10300, 0x10323).addRange(0x1032D, 0x1034A).addRange(0x10350, 0x10375).addRange(0x10380, 0x1039D).addRange(0x1039F, 0x103C3).addRange(0x103C8, 0x103D5).addRange(0x10400, 0x1049D).addRange(0x104A0, 0x104A9).addRange(0x104B0, 0x104D3).addRange(0x104D8, 0x104FB).addRange(0x10500, 0x10527).addRange(0x10530, 0x10563).addRange(0x1056F, 0x1057A).addRange(0x1057C, 0x1058A).addRange(0x1058C, 0x10592).addRange(0x10594, 0x10595).addRange(0x10597, 0x105A1);
		    set.addRange(0x105A3, 0x105B1).addRange(0x105B3, 0x105B9).addRange(0x105BB, 0x105BC).addRange(0x10600, 0x10736).addRange(0x10740, 0x10755).addRange(0x10760, 0x10767).addRange(0x10780, 0x10785).addRange(0x10787, 0x107B0).addRange(0x107B2, 0x107BA).addRange(0x10800, 0x10805).addRange(0x1080A, 0x10835).addRange(0x10837, 0x10838).addRange(0x1083F, 0x10855).addRange(0x10857, 0x1089E).addRange(0x108A7, 0x108AF).addRange(0x108E0, 0x108F2).addRange(0x108F4, 0x108F5).addRange(0x108FB, 0x1091B).addRange(0x1091F, 0x10939).addRange(0x10980, 0x109B7).addRange(0x109BC, 0x109CF).addRange(0x109D2, 0x10A00).addRange(0x10A10, 0x10A13).addRange(0x10A15, 0x10A17).addRange(0x10A19, 0x10A35).addRange(0x10A40, 0x10A48).addRange(0x10A50, 0x10A58).addRange(0x10A60, 0x10A9F).addRange(0x10AC0, 0x10AE4).addRange(0x10AEB, 0x10AF6).addRange(0x10B00, 0x10B35).addRange(0x10B39, 0x10B55).addRange(0x10B58, 0x10B72).addRange(0x10B78, 0x10B91).addRange(0x10B99, 0x10B9C).addRange(0x10BA9, 0x10BAF).addRange(0x10C00, 0x10C48).addRange(0x10C80, 0x10CB2).addRange(0x10CC0, 0x10CF2).addRange(0x10CFA, 0x10D23).addRange(0x10D30, 0x10D39).addRange(0x10E60, 0x10E7E).addRange(0x10E80, 0x10EA9).addRange(0x10EB0, 0x10EB1).addRange(0x10F00, 0x10F27).addRange(0x10F30, 0x10F45).addRange(0x10F51, 0x10F59).addRange(0x10F70, 0x10F81).addRange(0x10F86, 0x10F89).addRange(0x10FB0, 0x10FCB).addRange(0x10FE0, 0x10FF6);
		    set.addRange(0x11002, 0x11037).addRange(0x11047, 0x1104D).addRange(0x11052, 0x1106F).addRange(0x11071, 0x11072).addRange(0x11082, 0x110B2).addRange(0x110B7, 0x110B8).addRange(0x110BB, 0x110BC).addRange(0x110BE, 0x110C1).addRange(0x110D0, 0x110E8).addRange(0x110F0, 0x110F9).addRange(0x11103, 0x11126).addRange(0x11136, 0x11147).addRange(0x11150, 0x11172).addRange(0x11174, 0x11176).addRange(0x11182, 0x111B5).addRange(0x111BF, 0x111C8).addRange(0x111CD, 0x111CE).addRange(0x111D0, 0x111DF).addRange(0x111E1, 0x111F4).addRange(0x11200, 0x11211).addRange(0x11213, 0x1122E).addRange(0x11232, 0x11233).addRange(0x11238, 0x1123D).addRange(0x1123F, 0x11240).addRange(0x11280, 0x11286).addRange(0x1128A, 0x1128D).addRange(0x1128F, 0x1129D).addRange(0x1129F, 0x112A9).addRange(0x112B0, 0x112DE).addRange(0x112E0, 0x112E2).addRange(0x112F0, 0x112F9).addRange(0x11302, 0x11303).addRange(0x11305, 0x1130C).addRange(0x1130F, 0x11310).addRange(0x11313, 0x11328).addRange(0x1132A, 0x11330).addRange(0x11332, 0x11333).addRange(0x11335, 0x11339).addRange(0x11341, 0x11344).addRange(0x11347, 0x11348).addRange(0x1134B, 0x1134D).addRange(0x1135D, 0x11363).addRange(0x11400, 0x11437).addRange(0x11440, 0x11441).addRange(0x11447, 0x1145B).addRange(0x1145F, 0x11461).addRange(0x11480, 0x114AF).addRange(0x114B1, 0x114B2).addRange(0x114BB, 0x114BC).addRange(0x114C4, 0x114C7).addRange(0x114D0, 0x114D9);
		    set.addRange(0x11580, 0x115AE).addRange(0x115B0, 0x115B1).addRange(0x115B8, 0x115BB).addRange(0x115C1, 0x115DB).addRange(0x11600, 0x11632).addRange(0x1163B, 0x1163C).addRange(0x11641, 0x11644).addRange(0x11650, 0x11659).addRange(0x11660, 0x1166C).addRange(0x11680, 0x116AA).addRange(0x116AE, 0x116AF).addRange(0x116B8, 0x116B9).addRange(0x116C0, 0x116C9).addRange(0x11700, 0x1171A).addRange(0x11720, 0x11721).addRange(0x11730, 0x11746).addRange(0x11800, 0x1182E).addRange(0x118A0, 0x118F2).addRange(0x118FF, 0x11906).addRange(0x1190C, 0x11913).addRange(0x11915, 0x11916).addRange(0x11918, 0x1192F).addRange(0x11931, 0x11935).addRange(0x11937, 0x11938).addRange(0x1193F, 0x11942).addRange(0x11944, 0x11946).addRange(0x11950, 0x11959).addRange(0x119A0, 0x119A7).addRange(0x119AA, 0x119D3).addRange(0x119DC, 0x119DF).addRange(0x119E1, 0x119E4).addRange(0x11A0B, 0x11A32).addRange(0x11A39, 0x11A3A).addRange(0x11A3F, 0x11A46).addRange(0x11A57, 0x11A58).addRange(0x11A5C, 0x11A89).addRange(0x11A9A, 0x11AA2).addRange(0x11AB0, 0x11AF8).addRange(0x11B00, 0x11B09).addRange(0x11C00, 0x11C08).addRange(0x11C0A, 0x11C2F).addRange(0x11C40, 0x11C45).addRange(0x11C50, 0x11C6C).addRange(0x11C70, 0x11C8F).addRange(0x11D00, 0x11D06).addRange(0x11D08, 0x11D09).addRange(0x11D0B, 0x11D30).addRange(0x11D50, 0x11D59).addRange(0x11D60, 0x11D65).addRange(0x11D67, 0x11D68).addRange(0x11D6A, 0x11D8E);
		    set.addRange(0x11D93, 0x11D94).addRange(0x11DA0, 0x11DA9).addRange(0x11EE0, 0x11EF2).addRange(0x11EF5, 0x11EF8).addRange(0x11F02, 0x11F10).addRange(0x11F12, 0x11F35).addRange(0x11F3E, 0x11F3F).addRange(0x11F43, 0x11F59).addRange(0x11FC0, 0x11FF1).addRange(0x11FFF, 0x12399).addRange(0x12400, 0x1246E).addRange(0x12470, 0x12474).addRange(0x12480, 0x12543).addRange(0x12F90, 0x12FF2).addRange(0x13000, 0x1342F).addRange(0x13441, 0x13446).addRange(0x14400, 0x14646).addRange(0x16800, 0x16A38).addRange(0x16A40, 0x16A5E).addRange(0x16A60, 0x16A69).addRange(0x16A6E, 0x16ABE).addRange(0x16AC0, 0x16AC9).addRange(0x16AD0, 0x16AED).addRange(0x16B00, 0x16B2F).addRange(0x16B37, 0x16B45).addRange(0x16B50, 0x16B59).addRange(0x16B5B, 0x16B61).addRange(0x16B63, 0x16B77).addRange(0x16B7D, 0x16B8F).addRange(0x16E40, 0x16E9A).addRange(0x16F00, 0x16F4A).addRange(0x16F50, 0x16F87).addRange(0x16F93, 0x16F9F).addRange(0x16FE0, 0x16FE3).addRange(0x16FF0, 0x16FF1).addRange(0x17000, 0x187F7).addRange(0x18800, 0x18CD5).addRange(0x18D00, 0x18D08).addRange(0x1AFF0, 0x1AFF3).addRange(0x1AFF5, 0x1AFFB).addRange(0x1AFFD, 0x1AFFE).addRange(0x1B000, 0x1B122).addRange(0x1B150, 0x1B152).addRange(0x1B164, 0x1B167).addRange(0x1B170, 0x1B2FB).addRange(0x1BC00, 0x1BC6A).addRange(0x1BC70, 0x1BC7C).addRange(0x1BC80, 0x1BC88).addRange(0x1BC90, 0x1BC99).addRange(0x1CF50, 0x1CFC3).addRange(0x1D000, 0x1D0F5);
		    set.addRange(0x1D100, 0x1D126).addRange(0x1D129, 0x1D164).addRange(0x1D16A, 0x1D16D).addRange(0x1D183, 0x1D184).addRange(0x1D18C, 0x1D1A9).addRange(0x1D1AE, 0x1D1EA).addRange(0x1D200, 0x1D241).addRange(0x1D2C0, 0x1D2D3).addRange(0x1D2E0, 0x1D2F3).addRange(0x1D300, 0x1D356).addRange(0x1D360, 0x1D378).addRange(0x1D400, 0x1D454).addRange(0x1D456, 0x1D49C).addRange(0x1D49E, 0x1D49F).addRange(0x1D4A5, 0x1D4A6).addRange(0x1D4A9, 0x1D4AC).addRange(0x1D4AE, 0x1D4B9).addRange(0x1D4BD, 0x1D4C3).addRange(0x1D4C5, 0x1D505).addRange(0x1D507, 0x1D50A).addRange(0x1D50D, 0x1D514).addRange(0x1D516, 0x1D51C).addRange(0x1D51E, 0x1D539).addRange(0x1D53B, 0x1D53E).addRange(0x1D540, 0x1D544).addRange(0x1D54A, 0x1D550).addRange(0x1D552, 0x1D6A5).addRange(0x1D6A8, 0x1D7CB).addRange(0x1D7CE, 0x1D9FF).addRange(0x1DA37, 0x1DA3A).addRange(0x1DA6D, 0x1DA74).addRange(0x1DA76, 0x1DA83).addRange(0x1DA85, 0x1DA8B).addRange(0x1DF00, 0x1DF1E).addRange(0x1DF25, 0x1DF2A).addRange(0x1E030, 0x1E06D).addRange(0x1E100, 0x1E12C).addRange(0x1E137, 0x1E13D).addRange(0x1E140, 0x1E149).addRange(0x1E14E, 0x1E14F).addRange(0x1E290, 0x1E2AD).addRange(0x1E2C0, 0x1E2EB).addRange(0x1E2F0, 0x1E2F9).addRange(0x1E4D0, 0x1E4EB).addRange(0x1E4F0, 0x1E4F9).addRange(0x1E7E0, 0x1E7E6).addRange(0x1E7E8, 0x1E7EB).addRange(0x1E7ED, 0x1E7EE).addRange(0x1E7F0, 0x1E7FE).addRange(0x1E800, 0x1E8C4).addRange(0x1E8C7, 0x1E8CF);
		    set.addRange(0x1E900, 0x1E943).addRange(0x1E950, 0x1E959).addRange(0x1E95E, 0x1E95F).addRange(0x1EC71, 0x1ECB4).addRange(0x1ED01, 0x1ED3D).addRange(0x1EE00, 0x1EE03).addRange(0x1EE05, 0x1EE1F).addRange(0x1EE21, 0x1EE22).addRange(0x1EE29, 0x1EE32).addRange(0x1EE34, 0x1EE37).addRange(0x1EE4D, 0x1EE4F).addRange(0x1EE51, 0x1EE52).addRange(0x1EE61, 0x1EE62).addRange(0x1EE67, 0x1EE6A).addRange(0x1EE6C, 0x1EE72).addRange(0x1EE74, 0x1EE77).addRange(0x1EE79, 0x1EE7C).addRange(0x1EE80, 0x1EE89).addRange(0x1EE8B, 0x1EE9B).addRange(0x1EEA1, 0x1EEA3).addRange(0x1EEA5, 0x1EEA9).addRange(0x1EEAB, 0x1EEBB).addRange(0x1EEF0, 0x1EEF1).addRange(0x1F000, 0x1F02B).addRange(0x1F030, 0x1F093).addRange(0x1F0A0, 0x1F0AE).addRange(0x1F0B1, 0x1F0BF).addRange(0x1F0C1, 0x1F0CF).addRange(0x1F0D1, 0x1F0F5).addRange(0x1F100, 0x1F1AD).addRange(0x1F1E6, 0x1F202).addRange(0x1F210, 0x1F23B).addRange(0x1F240, 0x1F248).addRange(0x1F250, 0x1F251).addRange(0x1F260, 0x1F265).addRange(0x1F300, 0x1F6D7).addRange(0x1F6DC, 0x1F6EC).addRange(0x1F6F0, 0x1F6FC).addRange(0x1F700, 0x1F776).addRange(0x1F77B, 0x1F7D9).addRange(0x1F7E0, 0x1F7EB).addRange(0x1F800, 0x1F80B).addRange(0x1F810, 0x1F847).addRange(0x1F850, 0x1F859).addRange(0x1F860, 0x1F887).addRange(0x1F890, 0x1F8AD).addRange(0x1F8B0, 0x1F8B1).addRange(0x1F900, 0x1FA53).addRange(0x1FA60, 0x1FA6D).addRange(0x1FA70, 0x1FA7C).addRange(0x1FA80, 0x1FA88);
		    set.addRange(0x1FA90, 0x1FABD).addRange(0x1FABF, 0x1FAC5).addRange(0x1FACE, 0x1FADB).addRange(0x1FAE0, 0x1FAE8).addRange(0x1FAF0, 0x1FAF8).addRange(0x1FB00, 0x1FB92).addRange(0x1FB94, 0x1FBCA).addRange(0x1FBF0, 0x1FBF9).addRange(0x20000, 0x2A6DF).addRange(0x2A700, 0x2B739).addRange(0x2B740, 0x2B81D).addRange(0x2B820, 0x2CEA1).addRange(0x2CEB0, 0x2EBE0).addRange(0x2EBF0, 0x2EE5D).addRange(0x2F800, 0x2FA1D).addRange(0x30000, 0x3134A).addRange(0x31350, 0x323AF);
		    Grapheme_Base.characters = set;
		    return Grapheme_Base;
		  }

		  var Grapheme_Extend = {};

		  var hasRequiredGrapheme_Extend;
		  function requireGrapheme_Extend() {
		    if (hasRequiredGrapheme_Extend) return Grapheme_Extend;
		    hasRequiredGrapheme_Extend = 1;
		    var set = regenerateExports(0x5BF, 0x5C7, 0x670, 0x711, 0x7FD, 0x93A, 0x93C, 0x94D, 0x981, 0x9BC, 0x9BE, 0x9CD, 0x9D7, 0x9FE, 0xA3C, 0xA51, 0xA75, 0xABC, 0xACD, 0xB01, 0xB3C, 0xB4D, 0xB82, 0xBBE, 0xBC0, 0xBCD, 0xBD7, 0xC00, 0xC04, 0xC3C, 0xC81, 0xCBC, 0xCBF, 0xCC2, 0xCC6, 0xD3E, 0xD4D, 0xD57, 0xD81, 0xDCA, 0xDCF, 0xDD6, 0xDDF, 0xE31, 0xEB1, 0xF35, 0xF37, 0xF39, 0xFC6, 0x1082, 0x108D, 0x109D, 0x17C6, 0x17DD, 0x180F, 0x18A9, 0x1932, 0x1A1B, 0x1A56, 0x1A60, 0x1A62, 0x1A7F, 0x1B3C, 0x1B42, 0x1BE6, 0x1BED, 0x1CED, 0x1CF4, 0x200C, 0x2D7F, 0xA802, 0xA806, 0xA80B, 0xA82C, 0xA8FF, 0xA9B3, 0xA9E5, 0xAA43, 0xAA4C, 0xAA7C, 0xAAB0, 0xAAC1, 0xAAF6, 0xABE5, 0xABE8, 0xABED, 0xFB1E, 0x101FD, 0x102E0, 0x10A3F, 0x11001, 0x11070, 0x110C2, 0x11173, 0x111CF, 0x11234, 0x1123E, 0x11241, 0x112DF, 0x1133E, 0x11340, 0x11357, 0x11446, 0x1145E, 0x114B0, 0x114BA, 0x114BD, 0x115AF, 0x1163D, 0x116AB, 0x116AD, 0x116B7, 0x11930, 0x1193E, 0x11943, 0x119E0, 0x11A47, 0x11C3F, 0x11D3A, 0x11D47, 0x11D95, 0x11D97, 0x11F40, 0x11F42, 0x13440, 0x16F4F, 0x16FE4, 0x1D165, 0x1DA75, 0x1DA84, 0x1E08F, 0x1E2AE);
		    set.addRange(0x300, 0x36F).addRange(0x483, 0x489).addRange(0x591, 0x5BD).addRange(0x5C1, 0x5C2).addRange(0x5C4, 0x5C5).addRange(0x610, 0x61A).addRange(0x64B, 0x65F).addRange(0x6D6, 0x6DC).addRange(0x6DF, 0x6E4).addRange(0x6E7, 0x6E8).addRange(0x6EA, 0x6ED).addRange(0x730, 0x74A).addRange(0x7A6, 0x7B0).addRange(0x7EB, 0x7F3).addRange(0x816, 0x819).addRange(0x81B, 0x823).addRange(0x825, 0x827).addRange(0x829, 0x82D).addRange(0x859, 0x85B).addRange(0x898, 0x89F).addRange(0x8CA, 0x8E1).addRange(0x8E3, 0x902).addRange(0x941, 0x948).addRange(0x951, 0x957).addRange(0x962, 0x963).addRange(0x9C1, 0x9C4).addRange(0x9E2, 0x9E3).addRange(0xA01, 0xA02).addRange(0xA41, 0xA42).addRange(0xA47, 0xA48).addRange(0xA4B, 0xA4D).addRange(0xA70, 0xA71).addRange(0xA81, 0xA82).addRange(0xAC1, 0xAC5).addRange(0xAC7, 0xAC8).addRange(0xAE2, 0xAE3).addRange(0xAFA, 0xAFF).addRange(0xB3E, 0xB3F).addRange(0xB41, 0xB44).addRange(0xB55, 0xB57).addRange(0xB62, 0xB63).addRange(0xC3E, 0xC40).addRange(0xC46, 0xC48).addRange(0xC4A, 0xC4D).addRange(0xC55, 0xC56).addRange(0xC62, 0xC63).addRange(0xCCC, 0xCCD).addRange(0xCD5, 0xCD6).addRange(0xCE2, 0xCE3).addRange(0xD00, 0xD01).addRange(0xD3B, 0xD3C);
		    set.addRange(0xD41, 0xD44).addRange(0xD62, 0xD63).addRange(0xDD2, 0xDD4).addRange(0xE34, 0xE3A).addRange(0xE47, 0xE4E).addRange(0xEB4, 0xEBC).addRange(0xEC8, 0xECE).addRange(0xF18, 0xF19).addRange(0xF71, 0xF7E).addRange(0xF80, 0xF84).addRange(0xF86, 0xF87).addRange(0xF8D, 0xF97).addRange(0xF99, 0xFBC).addRange(0x102D, 0x1030).addRange(0x1032, 0x1037).addRange(0x1039, 0x103A).addRange(0x103D, 0x103E).addRange(0x1058, 0x1059).addRange(0x105E, 0x1060).addRange(0x1071, 0x1074).addRange(0x1085, 0x1086).addRange(0x135D, 0x135F).addRange(0x1712, 0x1714).addRange(0x1732, 0x1733).addRange(0x1752, 0x1753).addRange(0x1772, 0x1773).addRange(0x17B4, 0x17B5).addRange(0x17B7, 0x17BD).addRange(0x17C9, 0x17D3).addRange(0x180B, 0x180D).addRange(0x1885, 0x1886).addRange(0x1920, 0x1922).addRange(0x1927, 0x1928).addRange(0x1939, 0x193B).addRange(0x1A17, 0x1A18).addRange(0x1A58, 0x1A5E).addRange(0x1A65, 0x1A6C).addRange(0x1A73, 0x1A7C).addRange(0x1AB0, 0x1ACE).addRange(0x1B00, 0x1B03).addRange(0x1B34, 0x1B3A).addRange(0x1B6B, 0x1B73).addRange(0x1B80, 0x1B81).addRange(0x1BA2, 0x1BA5).addRange(0x1BA8, 0x1BA9).addRange(0x1BAB, 0x1BAD).addRange(0x1BE8, 0x1BE9).addRange(0x1BEF, 0x1BF1).addRange(0x1C2C, 0x1C33).addRange(0x1C36, 0x1C37).addRange(0x1CD0, 0x1CD2);
		    set.addRange(0x1CD4, 0x1CE0).addRange(0x1CE2, 0x1CE8).addRange(0x1CF8, 0x1CF9).addRange(0x1DC0, 0x1DFF).addRange(0x20D0, 0x20F0).addRange(0x2CEF, 0x2CF1).addRange(0x2DE0, 0x2DFF).addRange(0x302A, 0x302F).addRange(0x3099, 0x309A).addRange(0xA66F, 0xA672).addRange(0xA674, 0xA67D).addRange(0xA69E, 0xA69F).addRange(0xA6F0, 0xA6F1).addRange(0xA825, 0xA826).addRange(0xA8C4, 0xA8C5).addRange(0xA8E0, 0xA8F1).addRange(0xA926, 0xA92D).addRange(0xA947, 0xA951).addRange(0xA980, 0xA982).addRange(0xA9B6, 0xA9B9).addRange(0xA9BC, 0xA9BD).addRange(0xAA29, 0xAA2E).addRange(0xAA31, 0xAA32).addRange(0xAA35, 0xAA36).addRange(0xAAB2, 0xAAB4).addRange(0xAAB7, 0xAAB8).addRange(0xAABE, 0xAABF).addRange(0xAAEC, 0xAAED).addRange(0xFE00, 0xFE0F).addRange(0xFE20, 0xFE2F).addRange(0xFF9E, 0xFF9F).addRange(0x10376, 0x1037A).addRange(0x10A01, 0x10A03).addRange(0x10A05, 0x10A06).addRange(0x10A0C, 0x10A0F).addRange(0x10A38, 0x10A3A).addRange(0x10AE5, 0x10AE6).addRange(0x10D24, 0x10D27).addRange(0x10EAB, 0x10EAC).addRange(0x10EFD, 0x10EFF).addRange(0x10F46, 0x10F50).addRange(0x10F82, 0x10F85).addRange(0x11038, 0x11046).addRange(0x11073, 0x11074).addRange(0x1107F, 0x11081).addRange(0x110B3, 0x110B6).addRange(0x110B9, 0x110BA).addRange(0x11100, 0x11102).addRange(0x11127, 0x1112B).addRange(0x1112D, 0x11134).addRange(0x11180, 0x11181);
		    set.addRange(0x111B6, 0x111BE).addRange(0x111C9, 0x111CC).addRange(0x1122F, 0x11231).addRange(0x11236, 0x11237).addRange(0x112E3, 0x112EA).addRange(0x11300, 0x11301).addRange(0x1133B, 0x1133C).addRange(0x11366, 0x1136C).addRange(0x11370, 0x11374).addRange(0x11438, 0x1143F).addRange(0x11442, 0x11444).addRange(0x114B3, 0x114B8).addRange(0x114BF, 0x114C0).addRange(0x114C2, 0x114C3).addRange(0x115B2, 0x115B5).addRange(0x115BC, 0x115BD).addRange(0x115BF, 0x115C0).addRange(0x115DC, 0x115DD).addRange(0x11633, 0x1163A).addRange(0x1163F, 0x11640).addRange(0x116B0, 0x116B5).addRange(0x1171D, 0x1171F).addRange(0x11722, 0x11725).addRange(0x11727, 0x1172B).addRange(0x1182F, 0x11837).addRange(0x11839, 0x1183A).addRange(0x1193B, 0x1193C).addRange(0x119D4, 0x119D7).addRange(0x119DA, 0x119DB).addRange(0x11A01, 0x11A0A).addRange(0x11A33, 0x11A38).addRange(0x11A3B, 0x11A3E).addRange(0x11A51, 0x11A56).addRange(0x11A59, 0x11A5B).addRange(0x11A8A, 0x11A96).addRange(0x11A98, 0x11A99).addRange(0x11C30, 0x11C36).addRange(0x11C38, 0x11C3D).addRange(0x11C92, 0x11CA7).addRange(0x11CAA, 0x11CB0).addRange(0x11CB2, 0x11CB3).addRange(0x11CB5, 0x11CB6).addRange(0x11D31, 0x11D36).addRange(0x11D3C, 0x11D3D).addRange(0x11D3F, 0x11D45).addRange(0x11D90, 0x11D91).addRange(0x11EF3, 0x11EF4).addRange(0x11F00, 0x11F01).addRange(0x11F36, 0x11F3A).addRange(0x13447, 0x13455).addRange(0x16AF0, 0x16AF4);
		    set.addRange(0x16B30, 0x16B36).addRange(0x16F8F, 0x16F92).addRange(0x1BC9D, 0x1BC9E).addRange(0x1CF00, 0x1CF2D).addRange(0x1CF30, 0x1CF46).addRange(0x1D167, 0x1D169).addRange(0x1D16E, 0x1D172).addRange(0x1D17B, 0x1D182).addRange(0x1D185, 0x1D18B).addRange(0x1D1AA, 0x1D1AD).addRange(0x1D242, 0x1D244).addRange(0x1DA00, 0x1DA36).addRange(0x1DA3B, 0x1DA6C).addRange(0x1DA9B, 0x1DA9F).addRange(0x1DAA1, 0x1DAAF).addRange(0x1E000, 0x1E006).addRange(0x1E008, 0x1E018).addRange(0x1E01B, 0x1E021).addRange(0x1E023, 0x1E024).addRange(0x1E026, 0x1E02A).addRange(0x1E130, 0x1E136).addRange(0x1E2EC, 0x1E2EF).addRange(0x1E4EC, 0x1E4EF).addRange(0x1E8D0, 0x1E8D6).addRange(0x1E944, 0x1E94A).addRange(0xE0020, 0xE007F).addRange(0xE0100, 0xE01EF);
		    Grapheme_Extend.characters = set;
		    return Grapheme_Extend;
		  }

		  var Hex_Digit = {};

		  var hasRequiredHex_Digit;
		  function requireHex_Digit() {
		    if (hasRequiredHex_Digit) return Hex_Digit;
		    hasRequiredHex_Digit = 1;
		    var set = regenerateExports();
		    set.addRange(0x30, 0x39).addRange(0x41, 0x46).addRange(0x61, 0x66).addRange(0xFF10, 0xFF19).addRange(0xFF21, 0xFF26).addRange(0xFF41, 0xFF46);
		    Hex_Digit.characters = set;
		    return Hex_Digit;
		  }

		  var ID_Continue = {};

		  var hasRequiredID_Continue;
		  function requireID_Continue() {
		    if (hasRequiredID_Continue) return ID_Continue;
		    hasRequiredID_Continue = 1;
		    var set = regenerateExports(0x5F, 0xAA, 0xB5, 0xB7, 0xBA, 0x2EC, 0x2EE, 0x37F, 0x38C, 0x559, 0x5BF, 0x5C7, 0x6FF, 0x7FA, 0x7FD, 0x9B2, 0x9D7, 0x9FC, 0x9FE, 0xA3C, 0xA51, 0xA5E, 0xAD0, 0xB71, 0xB9C, 0xBD0, 0xBD7, 0xC5D, 0xDBD, 0xDCA, 0xDD6, 0xE84, 0xEA5, 0xEC6, 0xF00, 0xF35, 0xF37, 0xF39, 0xFC6, 0x10C7, 0x10CD, 0x1258, 0x12C0, 0x17D7, 0x1AA7, 0x1F59, 0x1F5B, 0x1F5D, 0x1FBE, 0x2054, 0x2071, 0x207F, 0x20E1, 0x2102, 0x2107, 0x2115, 0x2124, 0x2126, 0x2128, 0x214E, 0x2D27, 0x2D2D, 0x2D6F, 0xA7D3, 0xA82C, 0xA8FB, 0xFB3E, 0xFF3F, 0x101FD, 0x102E0, 0x10808, 0x1083C, 0x10A3F, 0x10F27, 0x110C2, 0x11176, 0x111DC, 0x11288, 0x11350, 0x11357, 0x114C7, 0x11644, 0x11909, 0x11A47, 0x11A9D, 0x11D3A, 0x11FB0, 0x1B132, 0x1B155, 0x1D4A2, 0x1D4BB, 0x1D546, 0x1DA75, 0x1DA84, 0x1E08F, 0x1E14E, 0x1EE24, 0x1EE27, 0x1EE39, 0x1EE3B, 0x1EE42, 0x1EE47, 0x1EE49, 0x1EE4B, 0x1EE54, 0x1EE57, 0x1EE59, 0x1EE5B, 0x1EE5D, 0x1EE5F, 0x1EE64, 0x1EE7E);
		    set.addRange(0x30, 0x39).addRange(0x41, 0x5A).addRange(0x61, 0x7A).addRange(0xC0, 0xD6).addRange(0xD8, 0xF6).addRange(0xF8, 0x2C1).addRange(0x2C6, 0x2D1).addRange(0x2E0, 0x2E4).addRange(0x300, 0x374).addRange(0x376, 0x377).addRange(0x37A, 0x37D).addRange(0x386, 0x38A).addRange(0x38E, 0x3A1).addRange(0x3A3, 0x3F5).addRange(0x3F7, 0x481).addRange(0x483, 0x487).addRange(0x48A, 0x52F).addRange(0x531, 0x556).addRange(0x560, 0x588).addRange(0x591, 0x5BD).addRange(0x5C1, 0x5C2).addRange(0x5C4, 0x5C5).addRange(0x5D0, 0x5EA).addRange(0x5EF, 0x5F2).addRange(0x610, 0x61A).addRange(0x620, 0x669).addRange(0x66E, 0x6D3).addRange(0x6D5, 0x6DC).addRange(0x6DF, 0x6E8).addRange(0x6EA, 0x6FC).addRange(0x710, 0x74A).addRange(0x74D, 0x7B1).addRange(0x7C0, 0x7F5).addRange(0x800, 0x82D).addRange(0x840, 0x85B).addRange(0x860, 0x86A).addRange(0x870, 0x887).addRange(0x889, 0x88E).addRange(0x898, 0x8E1).addRange(0x8E3, 0x963).addRange(0x966, 0x96F).addRange(0x971, 0x983).addRange(0x985, 0x98C).addRange(0x98F, 0x990).addRange(0x993, 0x9A8).addRange(0x9AA, 0x9B0).addRange(0x9B6, 0x9B9).addRange(0x9BC, 0x9C4).addRange(0x9C7, 0x9C8).addRange(0x9CB, 0x9CE).addRange(0x9DC, 0x9DD);
		    set.addRange(0x9DF, 0x9E3).addRange(0x9E6, 0x9F1).addRange(0xA01, 0xA03).addRange(0xA05, 0xA0A).addRange(0xA0F, 0xA10).addRange(0xA13, 0xA28).addRange(0xA2A, 0xA30).addRange(0xA32, 0xA33).addRange(0xA35, 0xA36).addRange(0xA38, 0xA39).addRange(0xA3E, 0xA42).addRange(0xA47, 0xA48).addRange(0xA4B, 0xA4D).addRange(0xA59, 0xA5C).addRange(0xA66, 0xA75).addRange(0xA81, 0xA83).addRange(0xA85, 0xA8D).addRange(0xA8F, 0xA91).addRange(0xA93, 0xAA8).addRange(0xAAA, 0xAB0).addRange(0xAB2, 0xAB3).addRange(0xAB5, 0xAB9).addRange(0xABC, 0xAC5).addRange(0xAC7, 0xAC9).addRange(0xACB, 0xACD).addRange(0xAE0, 0xAE3).addRange(0xAE6, 0xAEF).addRange(0xAF9, 0xAFF).addRange(0xB01, 0xB03).addRange(0xB05, 0xB0C).addRange(0xB0F, 0xB10).addRange(0xB13, 0xB28).addRange(0xB2A, 0xB30).addRange(0xB32, 0xB33).addRange(0xB35, 0xB39).addRange(0xB3C, 0xB44).addRange(0xB47, 0xB48).addRange(0xB4B, 0xB4D).addRange(0xB55, 0xB57).addRange(0xB5C, 0xB5D).addRange(0xB5F, 0xB63).addRange(0xB66, 0xB6F).addRange(0xB82, 0xB83).addRange(0xB85, 0xB8A).addRange(0xB8E, 0xB90).addRange(0xB92, 0xB95).addRange(0xB99, 0xB9A).addRange(0xB9E, 0xB9F).addRange(0xBA3, 0xBA4).addRange(0xBA8, 0xBAA).addRange(0xBAE, 0xBB9);
		    set.addRange(0xBBE, 0xBC2).addRange(0xBC6, 0xBC8).addRange(0xBCA, 0xBCD).addRange(0xBE6, 0xBEF).addRange(0xC00, 0xC0C).addRange(0xC0E, 0xC10).addRange(0xC12, 0xC28).addRange(0xC2A, 0xC39).addRange(0xC3C, 0xC44).addRange(0xC46, 0xC48).addRange(0xC4A, 0xC4D).addRange(0xC55, 0xC56).addRange(0xC58, 0xC5A).addRange(0xC60, 0xC63).addRange(0xC66, 0xC6F).addRange(0xC80, 0xC83).addRange(0xC85, 0xC8C).addRange(0xC8E, 0xC90).addRange(0xC92, 0xCA8).addRange(0xCAA, 0xCB3).addRange(0xCB5, 0xCB9).addRange(0xCBC, 0xCC4).addRange(0xCC6, 0xCC8).addRange(0xCCA, 0xCCD).addRange(0xCD5, 0xCD6).addRange(0xCDD, 0xCDE).addRange(0xCE0, 0xCE3).addRange(0xCE6, 0xCEF).addRange(0xCF1, 0xCF3).addRange(0xD00, 0xD0C).addRange(0xD0E, 0xD10).addRange(0xD12, 0xD44).addRange(0xD46, 0xD48).addRange(0xD4A, 0xD4E).addRange(0xD54, 0xD57).addRange(0xD5F, 0xD63).addRange(0xD66, 0xD6F).addRange(0xD7A, 0xD7F).addRange(0xD81, 0xD83).addRange(0xD85, 0xD96).addRange(0xD9A, 0xDB1).addRange(0xDB3, 0xDBB).addRange(0xDC0, 0xDC6).addRange(0xDCF, 0xDD4).addRange(0xDD8, 0xDDF).addRange(0xDE6, 0xDEF).addRange(0xDF2, 0xDF3).addRange(0xE01, 0xE3A).addRange(0xE40, 0xE4E).addRange(0xE50, 0xE59).addRange(0xE81, 0xE82);
		    set.addRange(0xE86, 0xE8A).addRange(0xE8C, 0xEA3).addRange(0xEA7, 0xEBD).addRange(0xEC0, 0xEC4).addRange(0xEC8, 0xECE).addRange(0xED0, 0xED9).addRange(0xEDC, 0xEDF).addRange(0xF18, 0xF19).addRange(0xF20, 0xF29).addRange(0xF3E, 0xF47).addRange(0xF49, 0xF6C).addRange(0xF71, 0xF84).addRange(0xF86, 0xF97).addRange(0xF99, 0xFBC).addRange(0x1000, 0x1049).addRange(0x1050, 0x109D).addRange(0x10A0, 0x10C5).addRange(0x10D0, 0x10FA).addRange(0x10FC, 0x1248).addRange(0x124A, 0x124D).addRange(0x1250, 0x1256).addRange(0x125A, 0x125D).addRange(0x1260, 0x1288).addRange(0x128A, 0x128D).addRange(0x1290, 0x12B0).addRange(0x12B2, 0x12B5).addRange(0x12B8, 0x12BE).addRange(0x12C2, 0x12C5).addRange(0x12C8, 0x12D6).addRange(0x12D8, 0x1310).addRange(0x1312, 0x1315).addRange(0x1318, 0x135A).addRange(0x135D, 0x135F).addRange(0x1369, 0x1371).addRange(0x1380, 0x138F).addRange(0x13A0, 0x13F5).addRange(0x13F8, 0x13FD).addRange(0x1401, 0x166C).addRange(0x166F, 0x167F).addRange(0x1681, 0x169A).addRange(0x16A0, 0x16EA).addRange(0x16EE, 0x16F8).addRange(0x1700, 0x1715).addRange(0x171F, 0x1734).addRange(0x1740, 0x1753).addRange(0x1760, 0x176C).addRange(0x176E, 0x1770).addRange(0x1772, 0x1773).addRange(0x1780, 0x17D3).addRange(0x17DC, 0x17DD).addRange(0x17E0, 0x17E9);
		    set.addRange(0x180B, 0x180D).addRange(0x180F, 0x1819).addRange(0x1820, 0x1878).addRange(0x1880, 0x18AA).addRange(0x18B0, 0x18F5).addRange(0x1900, 0x191E).addRange(0x1920, 0x192B).addRange(0x1930, 0x193B).addRange(0x1946, 0x196D).addRange(0x1970, 0x1974).addRange(0x1980, 0x19AB).addRange(0x19B0, 0x19C9).addRange(0x19D0, 0x19DA).addRange(0x1A00, 0x1A1B).addRange(0x1A20, 0x1A5E).addRange(0x1A60, 0x1A7C).addRange(0x1A7F, 0x1A89).addRange(0x1A90, 0x1A99).addRange(0x1AB0, 0x1ABD).addRange(0x1ABF, 0x1ACE).addRange(0x1B00, 0x1B4C).addRange(0x1B50, 0x1B59).addRange(0x1B6B, 0x1B73).addRange(0x1B80, 0x1BF3).addRange(0x1C00, 0x1C37).addRange(0x1C40, 0x1C49).addRange(0x1C4D, 0x1C7D).addRange(0x1C80, 0x1C88).addRange(0x1C90, 0x1CBA).addRange(0x1CBD, 0x1CBF).addRange(0x1CD0, 0x1CD2).addRange(0x1CD4, 0x1CFA).addRange(0x1D00, 0x1F15).addRange(0x1F18, 0x1F1D).addRange(0x1F20, 0x1F45).addRange(0x1F48, 0x1F4D).addRange(0x1F50, 0x1F57).addRange(0x1F5F, 0x1F7D).addRange(0x1F80, 0x1FB4).addRange(0x1FB6, 0x1FBC).addRange(0x1FC2, 0x1FC4).addRange(0x1FC6, 0x1FCC).addRange(0x1FD0, 0x1FD3).addRange(0x1FD6, 0x1FDB).addRange(0x1FE0, 0x1FEC).addRange(0x1FF2, 0x1FF4).addRange(0x1FF6, 0x1FFC).addRange(0x200C, 0x200D).addRange(0x203F, 0x2040).addRange(0x2090, 0x209C).addRange(0x20D0, 0x20DC);
		    set.addRange(0x20E5, 0x20F0).addRange(0x210A, 0x2113).addRange(0x2118, 0x211D).addRange(0x212A, 0x2139).addRange(0x213C, 0x213F).addRange(0x2145, 0x2149).addRange(0x2160, 0x2188).addRange(0x2C00, 0x2CE4).addRange(0x2CEB, 0x2CF3).addRange(0x2D00, 0x2D25).addRange(0x2D30, 0x2D67).addRange(0x2D7F, 0x2D96).addRange(0x2DA0, 0x2DA6).addRange(0x2DA8, 0x2DAE).addRange(0x2DB0, 0x2DB6).addRange(0x2DB8, 0x2DBE).addRange(0x2DC0, 0x2DC6).addRange(0x2DC8, 0x2DCE).addRange(0x2DD0, 0x2DD6).addRange(0x2DD8, 0x2DDE).addRange(0x2DE0, 0x2DFF).addRange(0x3005, 0x3007).addRange(0x3021, 0x302F).addRange(0x3031, 0x3035).addRange(0x3038, 0x303C).addRange(0x3041, 0x3096).addRange(0x3099, 0x309F).addRange(0x30A1, 0x30FF).addRange(0x3105, 0x312F).addRange(0x3131, 0x318E).addRange(0x31A0, 0x31BF).addRange(0x31F0, 0x31FF).addRange(0x3400, 0x4DBF).addRange(0x4E00, 0xA48C).addRange(0xA4D0, 0xA4FD).addRange(0xA500, 0xA60C).addRange(0xA610, 0xA62B).addRange(0xA640, 0xA66F).addRange(0xA674, 0xA67D).addRange(0xA67F, 0xA6F1).addRange(0xA717, 0xA71F).addRange(0xA722, 0xA788).addRange(0xA78B, 0xA7CA).addRange(0xA7D0, 0xA7D1).addRange(0xA7D5, 0xA7D9).addRange(0xA7F2, 0xA827).addRange(0xA840, 0xA873).addRange(0xA880, 0xA8C5).addRange(0xA8D0, 0xA8D9).addRange(0xA8E0, 0xA8F7).addRange(0xA8FD, 0xA92D);
		    set.addRange(0xA930, 0xA953).addRange(0xA960, 0xA97C).addRange(0xA980, 0xA9C0).addRange(0xA9CF, 0xA9D9).addRange(0xA9E0, 0xA9FE).addRange(0xAA00, 0xAA36).addRange(0xAA40, 0xAA4D).addRange(0xAA50, 0xAA59).addRange(0xAA60, 0xAA76).addRange(0xAA7A, 0xAAC2).addRange(0xAADB, 0xAADD).addRange(0xAAE0, 0xAAEF).addRange(0xAAF2, 0xAAF6).addRange(0xAB01, 0xAB06).addRange(0xAB09, 0xAB0E).addRange(0xAB11, 0xAB16).addRange(0xAB20, 0xAB26).addRange(0xAB28, 0xAB2E).addRange(0xAB30, 0xAB5A).addRange(0xAB5C, 0xAB69).addRange(0xAB70, 0xABEA).addRange(0xABEC, 0xABED).addRange(0xABF0, 0xABF9).addRange(0xAC00, 0xD7A3).addRange(0xD7B0, 0xD7C6).addRange(0xD7CB, 0xD7FB).addRange(0xF900, 0xFA6D).addRange(0xFA70, 0xFAD9).addRange(0xFB00, 0xFB06).addRange(0xFB13, 0xFB17).addRange(0xFB1D, 0xFB28).addRange(0xFB2A, 0xFB36).addRange(0xFB38, 0xFB3C).addRange(0xFB40, 0xFB41).addRange(0xFB43, 0xFB44).addRange(0xFB46, 0xFBB1).addRange(0xFBD3, 0xFD3D).addRange(0xFD50, 0xFD8F).addRange(0xFD92, 0xFDC7).addRange(0xFDF0, 0xFDFB).addRange(0xFE00, 0xFE0F).addRange(0xFE20, 0xFE2F).addRange(0xFE33, 0xFE34).addRange(0xFE4D, 0xFE4F).addRange(0xFE70, 0xFE74).addRange(0xFE76, 0xFEFC).addRange(0xFF10, 0xFF19).addRange(0xFF21, 0xFF3A).addRange(0xFF41, 0xFF5A).addRange(0xFF65, 0xFFBE).addRange(0xFFC2, 0xFFC7);
		    set.addRange(0xFFCA, 0xFFCF).addRange(0xFFD2, 0xFFD7).addRange(0xFFDA, 0xFFDC).addRange(0x10000, 0x1000B).addRange(0x1000D, 0x10026).addRange(0x10028, 0x1003A).addRange(0x1003C, 0x1003D).addRange(0x1003F, 0x1004D).addRange(0x10050, 0x1005D).addRange(0x10080, 0x100FA).addRange(0x10140, 0x10174).addRange(0x10280, 0x1029C).addRange(0x102A0, 0x102D0).addRange(0x10300, 0x1031F).addRange(0x1032D, 0x1034A).addRange(0x10350, 0x1037A).addRange(0x10380, 0x1039D).addRange(0x103A0, 0x103C3).addRange(0x103C8, 0x103CF).addRange(0x103D1, 0x103D5).addRange(0x10400, 0x1049D).addRange(0x104A0, 0x104A9).addRange(0x104B0, 0x104D3).addRange(0x104D8, 0x104FB).addRange(0x10500, 0x10527).addRange(0x10530, 0x10563).addRange(0x10570, 0x1057A).addRange(0x1057C, 0x1058A).addRange(0x1058C, 0x10592).addRange(0x10594, 0x10595).addRange(0x10597, 0x105A1).addRange(0x105A3, 0x105B1).addRange(0x105B3, 0x105B9).addRange(0x105BB, 0x105BC).addRange(0x10600, 0x10736).addRange(0x10740, 0x10755).addRange(0x10760, 0x10767).addRange(0x10780, 0x10785).addRange(0x10787, 0x107B0).addRange(0x107B2, 0x107BA).addRange(0x10800, 0x10805).addRange(0x1080A, 0x10835).addRange(0x10837, 0x10838).addRange(0x1083F, 0x10855).addRange(0x10860, 0x10876).addRange(0x10880, 0x1089E).addRange(0x108E0, 0x108F2).addRange(0x108F4, 0x108F5).addRange(0x10900, 0x10915).addRange(0x10920, 0x10939).addRange(0x10980, 0x109B7);
		    set.addRange(0x109BE, 0x109BF).addRange(0x10A00, 0x10A03).addRange(0x10A05, 0x10A06).addRange(0x10A0C, 0x10A13).addRange(0x10A15, 0x10A17).addRange(0x10A19, 0x10A35).addRange(0x10A38, 0x10A3A).addRange(0x10A60, 0x10A7C).addRange(0x10A80, 0x10A9C).addRange(0x10AC0, 0x10AC7).addRange(0x10AC9, 0x10AE6).addRange(0x10B00, 0x10B35).addRange(0x10B40, 0x10B55).addRange(0x10B60, 0x10B72).addRange(0x10B80, 0x10B91).addRange(0x10C00, 0x10C48).addRange(0x10C80, 0x10CB2).addRange(0x10CC0, 0x10CF2).addRange(0x10D00, 0x10D27).addRange(0x10D30, 0x10D39).addRange(0x10E80, 0x10EA9).addRange(0x10EAB, 0x10EAC).addRange(0x10EB0, 0x10EB1).addRange(0x10EFD, 0x10F1C).addRange(0x10F30, 0x10F50).addRange(0x10F70, 0x10F85).addRange(0x10FB0, 0x10FC4).addRange(0x10FE0, 0x10FF6).addRange(0x11000, 0x11046).addRange(0x11066, 0x11075).addRange(0x1107F, 0x110BA).addRange(0x110D0, 0x110E8).addRange(0x110F0, 0x110F9).addRange(0x11100, 0x11134).addRange(0x11136, 0x1113F).addRange(0x11144, 0x11147).addRange(0x11150, 0x11173).addRange(0x11180, 0x111C4).addRange(0x111C9, 0x111CC).addRange(0x111CE, 0x111DA).addRange(0x11200, 0x11211).addRange(0x11213, 0x11237).addRange(0x1123E, 0x11241).addRange(0x11280, 0x11286).addRange(0x1128A, 0x1128D).addRange(0x1128F, 0x1129D).addRange(0x1129F, 0x112A8).addRange(0x112B0, 0x112EA).addRange(0x112F0, 0x112F9).addRange(0x11300, 0x11303).addRange(0x11305, 0x1130C);
		    set.addRange(0x1130F, 0x11310).addRange(0x11313, 0x11328).addRange(0x1132A, 0x11330).addRange(0x11332, 0x11333).addRange(0x11335, 0x11339).addRange(0x1133B, 0x11344).addRange(0x11347, 0x11348).addRange(0x1134B, 0x1134D).addRange(0x1135D, 0x11363).addRange(0x11366, 0x1136C).addRange(0x11370, 0x11374).addRange(0x11400, 0x1144A).addRange(0x11450, 0x11459).addRange(0x1145E, 0x11461).addRange(0x11480, 0x114C5).addRange(0x114D0, 0x114D9).addRange(0x11580, 0x115B5).addRange(0x115B8, 0x115C0).addRange(0x115D8, 0x115DD).addRange(0x11600, 0x11640).addRange(0x11650, 0x11659).addRange(0x11680, 0x116B8).addRange(0x116C0, 0x116C9).addRange(0x11700, 0x1171A).addRange(0x1171D, 0x1172B).addRange(0x11730, 0x11739).addRange(0x11740, 0x11746).addRange(0x11800, 0x1183A).addRange(0x118A0, 0x118E9).addRange(0x118FF, 0x11906).addRange(0x1190C, 0x11913).addRange(0x11915, 0x11916).addRange(0x11918, 0x11935).addRange(0x11937, 0x11938).addRange(0x1193B, 0x11943).addRange(0x11950, 0x11959).addRange(0x119A0, 0x119A7).addRange(0x119AA, 0x119D7).addRange(0x119DA, 0x119E1).addRange(0x119E3, 0x119E4).addRange(0x11A00, 0x11A3E).addRange(0x11A50, 0x11A99).addRange(0x11AB0, 0x11AF8).addRange(0x11C00, 0x11C08).addRange(0x11C0A, 0x11C36).addRange(0x11C38, 0x11C40).addRange(0x11C50, 0x11C59).addRange(0x11C72, 0x11C8F).addRange(0x11C92, 0x11CA7).addRange(0x11CA9, 0x11CB6).addRange(0x11D00, 0x11D06);
		    set.addRange(0x11D08, 0x11D09).addRange(0x11D0B, 0x11D36).addRange(0x11D3C, 0x11D3D).addRange(0x11D3F, 0x11D47).addRange(0x11D50, 0x11D59).addRange(0x11D60, 0x11D65).addRange(0x11D67, 0x11D68).addRange(0x11D6A, 0x11D8E).addRange(0x11D90, 0x11D91).addRange(0x11D93, 0x11D98).addRange(0x11DA0, 0x11DA9).addRange(0x11EE0, 0x11EF6).addRange(0x11F00, 0x11F10).addRange(0x11F12, 0x11F3A).addRange(0x11F3E, 0x11F42).addRange(0x11F50, 0x11F59).addRange(0x12000, 0x12399).addRange(0x12400, 0x1246E).addRange(0x12480, 0x12543).addRange(0x12F90, 0x12FF0).addRange(0x13000, 0x1342F).addRange(0x13440, 0x13455).addRange(0x14400, 0x14646).addRange(0x16800, 0x16A38).addRange(0x16A40, 0x16A5E).addRange(0x16A60, 0x16A69).addRange(0x16A70, 0x16ABE).addRange(0x16AC0, 0x16AC9).addRange(0x16AD0, 0x16AED).addRange(0x16AF0, 0x16AF4).addRange(0x16B00, 0x16B36).addRange(0x16B40, 0x16B43).addRange(0x16B50, 0x16B59).addRange(0x16B63, 0x16B77).addRange(0x16B7D, 0x16B8F).addRange(0x16E40, 0x16E7F).addRange(0x16F00, 0x16F4A).addRange(0x16F4F, 0x16F87).addRange(0x16F8F, 0x16F9F).addRange(0x16FE0, 0x16FE1).addRange(0x16FE3, 0x16FE4).addRange(0x16FF0, 0x16FF1).addRange(0x17000, 0x187F7).addRange(0x18800, 0x18CD5).addRange(0x18D00, 0x18D08).addRange(0x1AFF0, 0x1AFF3).addRange(0x1AFF5, 0x1AFFB).addRange(0x1AFFD, 0x1AFFE).addRange(0x1B000, 0x1B122).addRange(0x1B150, 0x1B152).addRange(0x1B164, 0x1B167);
		    set.addRange(0x1B170, 0x1B2FB).addRange(0x1BC00, 0x1BC6A).addRange(0x1BC70, 0x1BC7C).addRange(0x1BC80, 0x1BC88).addRange(0x1BC90, 0x1BC99).addRange(0x1BC9D, 0x1BC9E).addRange(0x1CF00, 0x1CF2D).addRange(0x1CF30, 0x1CF46).addRange(0x1D165, 0x1D169).addRange(0x1D16D, 0x1D172).addRange(0x1D17B, 0x1D182).addRange(0x1D185, 0x1D18B).addRange(0x1D1AA, 0x1D1AD).addRange(0x1D242, 0x1D244).addRange(0x1D400, 0x1D454).addRange(0x1D456, 0x1D49C).addRange(0x1D49E, 0x1D49F).addRange(0x1D4A5, 0x1D4A6).addRange(0x1D4A9, 0x1D4AC).addRange(0x1D4AE, 0x1D4B9).addRange(0x1D4BD, 0x1D4C3).addRange(0x1D4C5, 0x1D505).addRange(0x1D507, 0x1D50A).addRange(0x1D50D, 0x1D514).addRange(0x1D516, 0x1D51C).addRange(0x1D51E, 0x1D539).addRange(0x1D53B, 0x1D53E).addRange(0x1D540, 0x1D544).addRange(0x1D54A, 0x1D550).addRange(0x1D552, 0x1D6A5).addRange(0x1D6A8, 0x1D6C0).addRange(0x1D6C2, 0x1D6DA).addRange(0x1D6DC, 0x1D6FA).addRange(0x1D6FC, 0x1D714).addRange(0x1D716, 0x1D734).addRange(0x1D736, 0x1D74E).addRange(0x1D750, 0x1D76E).addRange(0x1D770, 0x1D788).addRange(0x1D78A, 0x1D7A8).addRange(0x1D7AA, 0x1D7C2).addRange(0x1D7C4, 0x1D7CB).addRange(0x1D7CE, 0x1D7FF).addRange(0x1DA00, 0x1DA36).addRange(0x1DA3B, 0x1DA6C).addRange(0x1DA9B, 0x1DA9F).addRange(0x1DAA1, 0x1DAAF).addRange(0x1DF00, 0x1DF1E).addRange(0x1DF25, 0x1DF2A).addRange(0x1E000, 0x1E006).addRange(0x1E008, 0x1E018).addRange(0x1E01B, 0x1E021);
		    set.addRange(0x1E023, 0x1E024).addRange(0x1E026, 0x1E02A).addRange(0x1E030, 0x1E06D).addRange(0x1E100, 0x1E12C).addRange(0x1E130, 0x1E13D).addRange(0x1E140, 0x1E149).addRange(0x1E290, 0x1E2AE).addRange(0x1E2C0, 0x1E2F9).addRange(0x1E4D0, 0x1E4F9).addRange(0x1E7E0, 0x1E7E6).addRange(0x1E7E8, 0x1E7EB).addRange(0x1E7ED, 0x1E7EE).addRange(0x1E7F0, 0x1E7FE).addRange(0x1E800, 0x1E8C4).addRange(0x1E8D0, 0x1E8D6).addRange(0x1E900, 0x1E94B).addRange(0x1E950, 0x1E959).addRange(0x1EE00, 0x1EE03).addRange(0x1EE05, 0x1EE1F).addRange(0x1EE21, 0x1EE22).addRange(0x1EE29, 0x1EE32).addRange(0x1EE34, 0x1EE37).addRange(0x1EE4D, 0x1EE4F).addRange(0x1EE51, 0x1EE52).addRange(0x1EE61, 0x1EE62).addRange(0x1EE67, 0x1EE6A).addRange(0x1EE6C, 0x1EE72).addRange(0x1EE74, 0x1EE77).addRange(0x1EE79, 0x1EE7C).addRange(0x1EE80, 0x1EE89).addRange(0x1EE8B, 0x1EE9B).addRange(0x1EEA1, 0x1EEA3).addRange(0x1EEA5, 0x1EEA9).addRange(0x1EEAB, 0x1EEBB).addRange(0x1FBF0, 0x1FBF9).addRange(0x20000, 0x2A6DF).addRange(0x2A700, 0x2B739).addRange(0x2B740, 0x2B81D).addRange(0x2B820, 0x2CEA1).addRange(0x2CEB0, 0x2EBE0).addRange(0x2EBF0, 0x2EE5D).addRange(0x2F800, 0x2FA1D).addRange(0x30000, 0x3134A).addRange(0x31350, 0x323AF).addRange(0xE0100, 0xE01EF);
		    ID_Continue.characters = set;
		    return ID_Continue;
		  }

		  var ID_Start = {};

		  var hasRequiredID_Start;
		  function requireID_Start() {
		    if (hasRequiredID_Start) return ID_Start;
		    hasRequiredID_Start = 1;
		    var set = regenerateExports(0xAA, 0xB5, 0xBA, 0x2EC, 0x2EE, 0x37F, 0x386, 0x38C, 0x559, 0x6D5, 0x6FF, 0x710, 0x7B1, 0x7FA, 0x81A, 0x824, 0x828, 0x93D, 0x950, 0x9B2, 0x9BD, 0x9CE, 0x9FC, 0xA5E, 0xABD, 0xAD0, 0xAF9, 0xB3D, 0xB71, 0xB83, 0xB9C, 0xBD0, 0xC3D, 0xC5D, 0xC80, 0xCBD, 0xD3D, 0xD4E, 0xDBD, 0xE84, 0xEA5, 0xEBD, 0xEC6, 0xF00, 0x103F, 0x1061, 0x108E, 0x10C7, 0x10CD, 0x1258, 0x12C0, 0x17D7, 0x17DC, 0x18AA, 0x1AA7, 0x1CFA, 0x1F59, 0x1F5B, 0x1F5D, 0x1FBE, 0x2071, 0x207F, 0x2102, 0x2107, 0x2115, 0x2124, 0x2126, 0x2128, 0x214E, 0x2D27, 0x2D2D, 0x2D6F, 0xA7D3, 0xA8FB, 0xA9CF, 0xAA7A, 0xAAB1, 0xAAC0, 0xAAC2, 0xFB1D, 0xFB3E, 0x10808, 0x1083C, 0x10A00, 0x10F27, 0x11075, 0x11144, 0x11147, 0x11176, 0x111DA, 0x111DC, 0x11288, 0x1133D, 0x11350, 0x114C7, 0x11644, 0x116B8, 0x11909, 0x1193F, 0x11941, 0x119E1, 0x119E3, 0x11A00, 0x11A3A, 0x11A50, 0x11A9D, 0x11C40, 0x11D46, 0x11D98, 0x11F02, 0x11FB0, 0x16F50, 0x16FE3, 0x1B132, 0x1B155, 0x1D4A2, 0x1D4BB, 0x1D546, 0x1E14E, 0x1E94B, 0x1EE24, 0x1EE27, 0x1EE39, 0x1EE3B, 0x1EE42, 0x1EE47, 0x1EE49, 0x1EE4B, 0x1EE54, 0x1EE57, 0x1EE59, 0x1EE5B, 0x1EE5D, 0x1EE5F, 0x1EE64, 0x1EE7E);
		    set.addRange(0x41, 0x5A).addRange(0x61, 0x7A).addRange(0xC0, 0xD6).addRange(0xD8, 0xF6).addRange(0xF8, 0x2C1).addRange(0x2C6, 0x2D1).addRange(0x2E0, 0x2E4).addRange(0x370, 0x374).addRange(0x376, 0x377).addRange(0x37A, 0x37D).addRange(0x388, 0x38A).addRange(0x38E, 0x3A1).addRange(0x3A3, 0x3F5).addRange(0x3F7, 0x481).addRange(0x48A, 0x52F).addRange(0x531, 0x556).addRange(0x560, 0x588).addRange(0x5D0, 0x5EA).addRange(0x5EF, 0x5F2).addRange(0x620, 0x64A).addRange(0x66E, 0x66F).addRange(0x671, 0x6D3).addRange(0x6E5, 0x6E6).addRange(0x6EE, 0x6EF).addRange(0x6FA, 0x6FC).addRange(0x712, 0x72F).addRange(0x74D, 0x7A5).addRange(0x7CA, 0x7EA).addRange(0x7F4, 0x7F5).addRange(0x800, 0x815).addRange(0x840, 0x858).addRange(0x860, 0x86A).addRange(0x870, 0x887).addRange(0x889, 0x88E).addRange(0x8A0, 0x8C9).addRange(0x904, 0x939).addRange(0x958, 0x961).addRange(0x971, 0x980).addRange(0x985, 0x98C).addRange(0x98F, 0x990).addRange(0x993, 0x9A8).addRange(0x9AA, 0x9B0).addRange(0x9B6, 0x9B9).addRange(0x9DC, 0x9DD).addRange(0x9DF, 0x9E1).addRange(0x9F0, 0x9F1).addRange(0xA05, 0xA0A).addRange(0xA0F, 0xA10).addRange(0xA13, 0xA28).addRange(0xA2A, 0xA30).addRange(0xA32, 0xA33);
		    set.addRange(0xA35, 0xA36).addRange(0xA38, 0xA39).addRange(0xA59, 0xA5C).addRange(0xA72, 0xA74).addRange(0xA85, 0xA8D).addRange(0xA8F, 0xA91).addRange(0xA93, 0xAA8).addRange(0xAAA, 0xAB0).addRange(0xAB2, 0xAB3).addRange(0xAB5, 0xAB9).addRange(0xAE0, 0xAE1).addRange(0xB05, 0xB0C).addRange(0xB0F, 0xB10).addRange(0xB13, 0xB28).addRange(0xB2A, 0xB30).addRange(0xB32, 0xB33).addRange(0xB35, 0xB39).addRange(0xB5C, 0xB5D).addRange(0xB5F, 0xB61).addRange(0xB85, 0xB8A).addRange(0xB8E, 0xB90).addRange(0xB92, 0xB95).addRange(0xB99, 0xB9A).addRange(0xB9E, 0xB9F).addRange(0xBA3, 0xBA4).addRange(0xBA8, 0xBAA).addRange(0xBAE, 0xBB9).addRange(0xC05, 0xC0C).addRange(0xC0E, 0xC10).addRange(0xC12, 0xC28).addRange(0xC2A, 0xC39).addRange(0xC58, 0xC5A).addRange(0xC60, 0xC61).addRange(0xC85, 0xC8C).addRange(0xC8E, 0xC90).addRange(0xC92, 0xCA8).addRange(0xCAA, 0xCB3).addRange(0xCB5, 0xCB9).addRange(0xCDD, 0xCDE).addRange(0xCE0, 0xCE1).addRange(0xCF1, 0xCF2).addRange(0xD04, 0xD0C).addRange(0xD0E, 0xD10).addRange(0xD12, 0xD3A).addRange(0xD54, 0xD56).addRange(0xD5F, 0xD61).addRange(0xD7A, 0xD7F).addRange(0xD85, 0xD96).addRange(0xD9A, 0xDB1).addRange(0xDB3, 0xDBB).addRange(0xDC0, 0xDC6);
		    set.addRange(0xE01, 0xE30).addRange(0xE32, 0xE33).addRange(0xE40, 0xE46).addRange(0xE81, 0xE82).addRange(0xE86, 0xE8A).addRange(0xE8C, 0xEA3).addRange(0xEA7, 0xEB0).addRange(0xEB2, 0xEB3).addRange(0xEC0, 0xEC4).addRange(0xEDC, 0xEDF).addRange(0xF40, 0xF47).addRange(0xF49, 0xF6C).addRange(0xF88, 0xF8C).addRange(0x1000, 0x102A).addRange(0x1050, 0x1055).addRange(0x105A, 0x105D).addRange(0x1065, 0x1066).addRange(0x106E, 0x1070).addRange(0x1075, 0x1081).addRange(0x10A0, 0x10C5).addRange(0x10D0, 0x10FA).addRange(0x10FC, 0x1248).addRange(0x124A, 0x124D).addRange(0x1250, 0x1256).addRange(0x125A, 0x125D).addRange(0x1260, 0x1288).addRange(0x128A, 0x128D).addRange(0x1290, 0x12B0).addRange(0x12B2, 0x12B5).addRange(0x12B8, 0x12BE).addRange(0x12C2, 0x12C5).addRange(0x12C8, 0x12D6).addRange(0x12D8, 0x1310).addRange(0x1312, 0x1315).addRange(0x1318, 0x135A).addRange(0x1380, 0x138F).addRange(0x13A0, 0x13F5).addRange(0x13F8, 0x13FD).addRange(0x1401, 0x166C).addRange(0x166F, 0x167F).addRange(0x1681, 0x169A).addRange(0x16A0, 0x16EA).addRange(0x16EE, 0x16F8).addRange(0x1700, 0x1711).addRange(0x171F, 0x1731).addRange(0x1740, 0x1751).addRange(0x1760, 0x176C).addRange(0x176E, 0x1770).addRange(0x1780, 0x17B3).addRange(0x1820, 0x1878).addRange(0x1880, 0x18A8);
		    set.addRange(0x18B0, 0x18F5).addRange(0x1900, 0x191E).addRange(0x1950, 0x196D).addRange(0x1970, 0x1974).addRange(0x1980, 0x19AB).addRange(0x19B0, 0x19C9).addRange(0x1A00, 0x1A16).addRange(0x1A20, 0x1A54).addRange(0x1B05, 0x1B33).addRange(0x1B45, 0x1B4C).addRange(0x1B83, 0x1BA0).addRange(0x1BAE, 0x1BAF).addRange(0x1BBA, 0x1BE5).addRange(0x1C00, 0x1C23).addRange(0x1C4D, 0x1C4F).addRange(0x1C5A, 0x1C7D).addRange(0x1C80, 0x1C88).addRange(0x1C90, 0x1CBA).addRange(0x1CBD, 0x1CBF).addRange(0x1CE9, 0x1CEC).addRange(0x1CEE, 0x1CF3).addRange(0x1CF5, 0x1CF6).addRange(0x1D00, 0x1DBF).addRange(0x1E00, 0x1F15).addRange(0x1F18, 0x1F1D).addRange(0x1F20, 0x1F45).addRange(0x1F48, 0x1F4D).addRange(0x1F50, 0x1F57).addRange(0x1F5F, 0x1F7D).addRange(0x1F80, 0x1FB4).addRange(0x1FB6, 0x1FBC).addRange(0x1FC2, 0x1FC4).addRange(0x1FC6, 0x1FCC).addRange(0x1FD0, 0x1FD3).addRange(0x1FD6, 0x1FDB).addRange(0x1FE0, 0x1FEC).addRange(0x1FF2, 0x1FF4).addRange(0x1FF6, 0x1FFC).addRange(0x2090, 0x209C).addRange(0x210A, 0x2113).addRange(0x2118, 0x211D).addRange(0x212A, 0x2139).addRange(0x213C, 0x213F).addRange(0x2145, 0x2149).addRange(0x2160, 0x2188).addRange(0x2C00, 0x2CE4).addRange(0x2CEB, 0x2CEE).addRange(0x2CF2, 0x2CF3).addRange(0x2D00, 0x2D25).addRange(0x2D30, 0x2D67).addRange(0x2D80, 0x2D96);
		    set.addRange(0x2DA0, 0x2DA6).addRange(0x2DA8, 0x2DAE).addRange(0x2DB0, 0x2DB6).addRange(0x2DB8, 0x2DBE).addRange(0x2DC0, 0x2DC6).addRange(0x2DC8, 0x2DCE).addRange(0x2DD0, 0x2DD6).addRange(0x2DD8, 0x2DDE).addRange(0x3005, 0x3007).addRange(0x3021, 0x3029).addRange(0x3031, 0x3035).addRange(0x3038, 0x303C).addRange(0x3041, 0x3096).addRange(0x309B, 0x309F).addRange(0x30A1, 0x30FA).addRange(0x30FC, 0x30FF).addRange(0x3105, 0x312F).addRange(0x3131, 0x318E).addRange(0x31A0, 0x31BF).addRange(0x31F0, 0x31FF).addRange(0x3400, 0x4DBF).addRange(0x4E00, 0xA48C).addRange(0xA4D0, 0xA4FD).addRange(0xA500, 0xA60C).addRange(0xA610, 0xA61F).addRange(0xA62A, 0xA62B).addRange(0xA640, 0xA66E).addRange(0xA67F, 0xA69D).addRange(0xA6A0, 0xA6EF).addRange(0xA717, 0xA71F).addRange(0xA722, 0xA788).addRange(0xA78B, 0xA7CA).addRange(0xA7D0, 0xA7D1).addRange(0xA7D5, 0xA7D9).addRange(0xA7F2, 0xA801).addRange(0xA803, 0xA805).addRange(0xA807, 0xA80A).addRange(0xA80C, 0xA822).addRange(0xA840, 0xA873).addRange(0xA882, 0xA8B3).addRange(0xA8F2, 0xA8F7).addRange(0xA8FD, 0xA8FE).addRange(0xA90A, 0xA925).addRange(0xA930, 0xA946).addRange(0xA960, 0xA97C).addRange(0xA984, 0xA9B2).addRange(0xA9E0, 0xA9E4).addRange(0xA9E6, 0xA9EF).addRange(0xA9FA, 0xA9FE).addRange(0xAA00, 0xAA28).addRange(0xAA40, 0xAA42);
		    set.addRange(0xAA44, 0xAA4B).addRange(0xAA60, 0xAA76).addRange(0xAA7E, 0xAAAF).addRange(0xAAB5, 0xAAB6).addRange(0xAAB9, 0xAABD).addRange(0xAADB, 0xAADD).addRange(0xAAE0, 0xAAEA).addRange(0xAAF2, 0xAAF4).addRange(0xAB01, 0xAB06).addRange(0xAB09, 0xAB0E).addRange(0xAB11, 0xAB16).addRange(0xAB20, 0xAB26).addRange(0xAB28, 0xAB2E).addRange(0xAB30, 0xAB5A).addRange(0xAB5C, 0xAB69).addRange(0xAB70, 0xABE2).addRange(0xAC00, 0xD7A3).addRange(0xD7B0, 0xD7C6).addRange(0xD7CB, 0xD7FB).addRange(0xF900, 0xFA6D).addRange(0xFA70, 0xFAD9).addRange(0xFB00, 0xFB06).addRange(0xFB13, 0xFB17).addRange(0xFB1F, 0xFB28).addRange(0xFB2A, 0xFB36).addRange(0xFB38, 0xFB3C).addRange(0xFB40, 0xFB41).addRange(0xFB43, 0xFB44).addRange(0xFB46, 0xFBB1).addRange(0xFBD3, 0xFD3D).addRange(0xFD50, 0xFD8F).addRange(0xFD92, 0xFDC7).addRange(0xFDF0, 0xFDFB).addRange(0xFE70, 0xFE74).addRange(0xFE76, 0xFEFC).addRange(0xFF21, 0xFF3A).addRange(0xFF41, 0xFF5A).addRange(0xFF66, 0xFFBE).addRange(0xFFC2, 0xFFC7).addRange(0xFFCA, 0xFFCF).addRange(0xFFD2, 0xFFD7).addRange(0xFFDA, 0xFFDC).addRange(0x10000, 0x1000B).addRange(0x1000D, 0x10026).addRange(0x10028, 0x1003A).addRange(0x1003C, 0x1003D).addRange(0x1003F, 0x1004D).addRange(0x10050, 0x1005D).addRange(0x10080, 0x100FA).addRange(0x10140, 0x10174).addRange(0x10280, 0x1029C);
		    set.addRange(0x102A0, 0x102D0).addRange(0x10300, 0x1031F).addRange(0x1032D, 0x1034A).addRange(0x10350, 0x10375).addRange(0x10380, 0x1039D).addRange(0x103A0, 0x103C3).addRange(0x103C8, 0x103CF).addRange(0x103D1, 0x103D5).addRange(0x10400, 0x1049D).addRange(0x104B0, 0x104D3).addRange(0x104D8, 0x104FB).addRange(0x10500, 0x10527).addRange(0x10530, 0x10563).addRange(0x10570, 0x1057A).addRange(0x1057C, 0x1058A).addRange(0x1058C, 0x10592).addRange(0x10594, 0x10595).addRange(0x10597, 0x105A1).addRange(0x105A3, 0x105B1).addRange(0x105B3, 0x105B9).addRange(0x105BB, 0x105BC).addRange(0x10600, 0x10736).addRange(0x10740, 0x10755).addRange(0x10760, 0x10767).addRange(0x10780, 0x10785).addRange(0x10787, 0x107B0).addRange(0x107B2, 0x107BA).addRange(0x10800, 0x10805).addRange(0x1080A, 0x10835).addRange(0x10837, 0x10838).addRange(0x1083F, 0x10855).addRange(0x10860, 0x10876).addRange(0x10880, 0x1089E).addRange(0x108E0, 0x108F2).addRange(0x108F4, 0x108F5).addRange(0x10900, 0x10915).addRange(0x10920, 0x10939).addRange(0x10980, 0x109B7).addRange(0x109BE, 0x109BF).addRange(0x10A10, 0x10A13).addRange(0x10A15, 0x10A17).addRange(0x10A19, 0x10A35).addRange(0x10A60, 0x10A7C).addRange(0x10A80, 0x10A9C).addRange(0x10AC0, 0x10AC7).addRange(0x10AC9, 0x10AE4).addRange(0x10B00, 0x10B35).addRange(0x10B40, 0x10B55).addRange(0x10B60, 0x10B72).addRange(0x10B80, 0x10B91).addRange(0x10C00, 0x10C48);
		    set.addRange(0x10C80, 0x10CB2).addRange(0x10CC0, 0x10CF2).addRange(0x10D00, 0x10D23).addRange(0x10E80, 0x10EA9).addRange(0x10EB0, 0x10EB1).addRange(0x10F00, 0x10F1C).addRange(0x10F30, 0x10F45).addRange(0x10F70, 0x10F81).addRange(0x10FB0, 0x10FC4).addRange(0x10FE0, 0x10FF6).addRange(0x11003, 0x11037).addRange(0x11071, 0x11072).addRange(0x11083, 0x110AF).addRange(0x110D0, 0x110E8).addRange(0x11103, 0x11126).addRange(0x11150, 0x11172).addRange(0x11183, 0x111B2).addRange(0x111C1, 0x111C4).addRange(0x11200, 0x11211).addRange(0x11213, 0x1122B).addRange(0x1123F, 0x11240).addRange(0x11280, 0x11286).addRange(0x1128A, 0x1128D).addRange(0x1128F, 0x1129D).addRange(0x1129F, 0x112A8).addRange(0x112B0, 0x112DE).addRange(0x11305, 0x1130C).addRange(0x1130F, 0x11310).addRange(0x11313, 0x11328).addRange(0x1132A, 0x11330).addRange(0x11332, 0x11333).addRange(0x11335, 0x11339).addRange(0x1135D, 0x11361).addRange(0x11400, 0x11434).addRange(0x11447, 0x1144A).addRange(0x1145F, 0x11461).addRange(0x11480, 0x114AF).addRange(0x114C4, 0x114C5).addRange(0x11580, 0x115AE).addRange(0x115D8, 0x115DB).addRange(0x11600, 0x1162F).addRange(0x11680, 0x116AA).addRange(0x11700, 0x1171A).addRange(0x11740, 0x11746).addRange(0x11800, 0x1182B).addRange(0x118A0, 0x118DF).addRange(0x118FF, 0x11906).addRange(0x1190C, 0x11913).addRange(0x11915, 0x11916).addRange(0x11918, 0x1192F).addRange(0x119A0, 0x119A7);
		    set.addRange(0x119AA, 0x119D0).addRange(0x11A0B, 0x11A32).addRange(0x11A5C, 0x11A89).addRange(0x11AB0, 0x11AF8).addRange(0x11C00, 0x11C08).addRange(0x11C0A, 0x11C2E).addRange(0x11C72, 0x11C8F).addRange(0x11D00, 0x11D06).addRange(0x11D08, 0x11D09).addRange(0x11D0B, 0x11D30).addRange(0x11D60, 0x11D65).addRange(0x11D67, 0x11D68).addRange(0x11D6A, 0x11D89).addRange(0x11EE0, 0x11EF2).addRange(0x11F04, 0x11F10).addRange(0x11F12, 0x11F33).addRange(0x12000, 0x12399).addRange(0x12400, 0x1246E).addRange(0x12480, 0x12543).addRange(0x12F90, 0x12FF0).addRange(0x13000, 0x1342F).addRange(0x13441, 0x13446).addRange(0x14400, 0x14646).addRange(0x16800, 0x16A38).addRange(0x16A40, 0x16A5E).addRange(0x16A70, 0x16ABE).addRange(0x16AD0, 0x16AED).addRange(0x16B00, 0x16B2F).addRange(0x16B40, 0x16B43).addRange(0x16B63, 0x16B77).addRange(0x16B7D, 0x16B8F).addRange(0x16E40, 0x16E7F).addRange(0x16F00, 0x16F4A).addRange(0x16F93, 0x16F9F).addRange(0x16FE0, 0x16FE1).addRange(0x17000, 0x187F7).addRange(0x18800, 0x18CD5).addRange(0x18D00, 0x18D08).addRange(0x1AFF0, 0x1AFF3).addRange(0x1AFF5, 0x1AFFB).addRange(0x1AFFD, 0x1AFFE).addRange(0x1B000, 0x1B122).addRange(0x1B150, 0x1B152).addRange(0x1B164, 0x1B167).addRange(0x1B170, 0x1B2FB).addRange(0x1BC00, 0x1BC6A).addRange(0x1BC70, 0x1BC7C).addRange(0x1BC80, 0x1BC88).addRange(0x1BC90, 0x1BC99).addRange(0x1D400, 0x1D454).addRange(0x1D456, 0x1D49C);
		    set.addRange(0x1D49E, 0x1D49F).addRange(0x1D4A5, 0x1D4A6).addRange(0x1D4A9, 0x1D4AC).addRange(0x1D4AE, 0x1D4B9).addRange(0x1D4BD, 0x1D4C3).addRange(0x1D4C5, 0x1D505).addRange(0x1D507, 0x1D50A).addRange(0x1D50D, 0x1D514).addRange(0x1D516, 0x1D51C).addRange(0x1D51E, 0x1D539).addRange(0x1D53B, 0x1D53E).addRange(0x1D540, 0x1D544).addRange(0x1D54A, 0x1D550).addRange(0x1D552, 0x1D6A5).addRange(0x1D6A8, 0x1D6C0).addRange(0x1D6C2, 0x1D6DA).addRange(0x1D6DC, 0x1D6FA).addRange(0x1D6FC, 0x1D714).addRange(0x1D716, 0x1D734).addRange(0x1D736, 0x1D74E).addRange(0x1D750, 0x1D76E).addRange(0x1D770, 0x1D788).addRange(0x1D78A, 0x1D7A8).addRange(0x1D7AA, 0x1D7C2).addRange(0x1D7C4, 0x1D7CB).addRange(0x1DF00, 0x1DF1E).addRange(0x1DF25, 0x1DF2A).addRange(0x1E030, 0x1E06D).addRange(0x1E100, 0x1E12C).addRange(0x1E137, 0x1E13D).addRange(0x1E290, 0x1E2AD).addRange(0x1E2C0, 0x1E2EB).addRange(0x1E4D0, 0x1E4EB).addRange(0x1E7E0, 0x1E7E6).addRange(0x1E7E8, 0x1E7EB).addRange(0x1E7ED, 0x1E7EE).addRange(0x1E7F0, 0x1E7FE).addRange(0x1E800, 0x1E8C4).addRange(0x1E900, 0x1E943).addRange(0x1EE00, 0x1EE03).addRange(0x1EE05, 0x1EE1F).addRange(0x1EE21, 0x1EE22).addRange(0x1EE29, 0x1EE32).addRange(0x1EE34, 0x1EE37).addRange(0x1EE4D, 0x1EE4F).addRange(0x1EE51, 0x1EE52).addRange(0x1EE61, 0x1EE62).addRange(0x1EE67, 0x1EE6A).addRange(0x1EE6C, 0x1EE72).addRange(0x1EE74, 0x1EE77).addRange(0x1EE79, 0x1EE7C);
		    set.addRange(0x1EE80, 0x1EE89).addRange(0x1EE8B, 0x1EE9B).addRange(0x1EEA1, 0x1EEA3).addRange(0x1EEA5, 0x1EEA9).addRange(0x1EEAB, 0x1EEBB).addRange(0x20000, 0x2A6DF).addRange(0x2A700, 0x2B739).addRange(0x2B740, 0x2B81D).addRange(0x2B820, 0x2CEA1).addRange(0x2CEB0, 0x2EBE0).addRange(0x2EBF0, 0x2EE5D).addRange(0x2F800, 0x2FA1D).addRange(0x30000, 0x3134A).addRange(0x31350, 0x323AF);
		    ID_Start.characters = set;
		    return ID_Start;
		  }

		  var Ideographic = {};

		  var hasRequiredIdeographic;
		  function requireIdeographic() {
		    if (hasRequiredIdeographic) return Ideographic;
		    hasRequiredIdeographic = 1;
		    var set = regenerateExports(0x16FE4);
		    set.addRange(0x3006, 0x3007).addRange(0x3021, 0x3029).addRange(0x3038, 0x303A).addRange(0x3400, 0x4DBF).addRange(0x4E00, 0x9FFF).addRange(0xF900, 0xFA6D).addRange(0xFA70, 0xFAD9).addRange(0x17000, 0x187F7).addRange(0x18800, 0x18CD5).addRange(0x18D00, 0x18D08).addRange(0x1B170, 0x1B2FB).addRange(0x20000, 0x2A6DF).addRange(0x2A700, 0x2B739).addRange(0x2B740, 0x2B81D).addRange(0x2B820, 0x2CEA1).addRange(0x2CEB0, 0x2EBE0).addRange(0x2EBF0, 0x2EE5D).addRange(0x2F800, 0x2FA1D).addRange(0x30000, 0x3134A).addRange(0x31350, 0x323AF);
		    Ideographic.characters = set;
		    return Ideographic;
		  }

		  var IDS_Binary_Operator = {};

		  var hasRequiredIDS_Binary_Operator;
		  function requireIDS_Binary_Operator() {
		    if (hasRequiredIDS_Binary_Operator) return IDS_Binary_Operator;
		    hasRequiredIDS_Binary_Operator = 1;
		    var set = regenerateExports(0x31EF);
		    set.addRange(0x2FF0, 0x2FF1).addRange(0x2FF4, 0x2FFD);
		    IDS_Binary_Operator.characters = set;
		    return IDS_Binary_Operator;
		  }

		  var IDS_Trinary_Operator = {};

		  var hasRequiredIDS_Trinary_Operator;
		  function requireIDS_Trinary_Operator() {
		    if (hasRequiredIDS_Trinary_Operator) return IDS_Trinary_Operator;
		    hasRequiredIDS_Trinary_Operator = 1;
		    var set = regenerateExports();
		    set.addRange(0x2FF2, 0x2FF3);
		    IDS_Trinary_Operator.characters = set;
		    return IDS_Trinary_Operator;
		  }

		  var Join_Control = {};

		  var hasRequiredJoin_Control;
		  function requireJoin_Control() {
		    if (hasRequiredJoin_Control) return Join_Control;
		    hasRequiredJoin_Control = 1;
		    var set = regenerateExports();
		    set.addRange(0x200C, 0x200D);
		    Join_Control.characters = set;
		    return Join_Control;
		  }

		  var Logical_Order_Exception = {};

		  var hasRequiredLogical_Order_Exception;
		  function requireLogical_Order_Exception() {
		    if (hasRequiredLogical_Order_Exception) return Logical_Order_Exception;
		    hasRequiredLogical_Order_Exception = 1;
		    var set = regenerateExports(0x19BA, 0xAAB9);
		    set.addRange(0xE40, 0xE44).addRange(0xEC0, 0xEC4).addRange(0x19B5, 0x19B7).addRange(0xAAB5, 0xAAB6).addRange(0xAABB, 0xAABC);
		    Logical_Order_Exception.characters = set;
		    return Logical_Order_Exception;
		  }

		  var Lowercase = {};

		  var hasRequiredLowercase;
		  function requireLowercase() {
		    if (hasRequiredLowercase) return Lowercase;
		    hasRequiredLowercase = 1;
		    var set = regenerateExports(0xAA, 0xB5, 0xBA, 0x101, 0x103, 0x105, 0x107, 0x109, 0x10B, 0x10D, 0x10F, 0x111, 0x113, 0x115, 0x117, 0x119, 0x11B, 0x11D, 0x11F, 0x121, 0x123, 0x125, 0x127, 0x129, 0x12B, 0x12D, 0x12F, 0x131, 0x133, 0x135, 0x13A, 0x13C, 0x13E, 0x140, 0x142, 0x144, 0x146, 0x14B, 0x14D, 0x14F, 0x151, 0x153, 0x155, 0x157, 0x159, 0x15B, 0x15D, 0x15F, 0x161, 0x163, 0x165, 0x167, 0x169, 0x16B, 0x16D, 0x16F, 0x171, 0x173, 0x175, 0x177, 0x17A, 0x17C, 0x183, 0x185, 0x188, 0x192, 0x195, 0x19E, 0x1A1, 0x1A3, 0x1A5, 0x1A8, 0x1AD, 0x1B0, 0x1B4, 0x1B6, 0x1C6, 0x1C9, 0x1CC, 0x1CE, 0x1D0, 0x1D2, 0x1D4, 0x1D6, 0x1D8, 0x1DA, 0x1DF, 0x1E1, 0x1E3, 0x1E5, 0x1E7, 0x1E9, 0x1EB, 0x1ED, 0x1F3, 0x1F5, 0x1F9, 0x1FB, 0x1FD, 0x1FF, 0x201, 0x203, 0x205, 0x207, 0x209, 0x20B, 0x20D, 0x20F, 0x211, 0x213, 0x215, 0x217, 0x219, 0x21B, 0x21D, 0x21F, 0x221, 0x223, 0x225, 0x227, 0x229, 0x22B, 0x22D, 0x22F, 0x231, 0x23C, 0x242, 0x247, 0x249, 0x24B, 0x24D, 0x345, 0x371, 0x373, 0x377, 0x390, 0x3D9, 0x3DB, 0x3DD, 0x3DF, 0x3E1, 0x3E3, 0x3E5, 0x3E7, 0x3E9, 0x3EB, 0x3ED, 0x3F5, 0x3F8, 0x461, 0x463, 0x465, 0x467, 0x469, 0x46B, 0x46D, 0x46F, 0x471, 0x473, 0x475, 0x477, 0x479, 0x47B, 0x47D, 0x47F, 0x481, 0x48B, 0x48D, 0x48F, 0x491, 0x493, 0x495, 0x497, 0x499, 0x49B, 0x49D, 0x49F, 0x4A1, 0x4A3, 0x4A5, 0x4A7, 0x4A9, 0x4AB, 0x4AD, 0x4AF, 0x4B1, 0x4B3, 0x4B5, 0x4B7, 0x4B9, 0x4BB, 0x4BD, 0x4BF, 0x4C2, 0x4C4, 0x4C6, 0x4C8, 0x4CA, 0x4CC, 0x4D1, 0x4D3, 0x4D5, 0x4D7, 0x4D9, 0x4DB, 0x4DD, 0x4DF, 0x4E1, 0x4E3, 0x4E5, 0x4E7, 0x4E9, 0x4EB, 0x4ED, 0x4EF, 0x4F1, 0x4F3, 0x4F5, 0x4F7, 0x4F9, 0x4FB, 0x4FD, 0x4FF, 0x501, 0x503, 0x505, 0x507, 0x509, 0x50B, 0x50D, 0x50F, 0x511, 0x513, 0x515, 0x517, 0x519, 0x51B, 0x51D, 0x51F, 0x521, 0x523, 0x525, 0x527, 0x529, 0x52B, 0x52D, 0x52F, 0x1E01, 0x1E03, 0x1E05, 0x1E07, 0x1E09, 0x1E0B, 0x1E0D, 0x1E0F, 0x1E11, 0x1E13, 0x1E15, 0x1E17, 0x1E19, 0x1E1B, 0x1E1D, 0x1E1F, 0x1E21, 0x1E23, 0x1E25, 0x1E27, 0x1E29, 0x1E2B, 0x1E2D, 0x1E2F, 0x1E31, 0x1E33, 0x1E35, 0x1E37, 0x1E39, 0x1E3B, 0x1E3D, 0x1E3F, 0x1E41, 0x1E43, 0x1E45, 0x1E47, 0x1E49, 0x1E4B, 0x1E4D, 0x1E4F, 0x1E51, 0x1E53, 0x1E55, 0x1E57, 0x1E59, 0x1E5B, 0x1E5D, 0x1E5F, 0x1E61, 0x1E63, 0x1E65, 0x1E67, 0x1E69, 0x1E6B, 0x1E6D, 0x1E6F, 0x1E71, 0x1E73, 0x1E75, 0x1E77, 0x1E79, 0x1E7B, 0x1E7D, 0x1E7F, 0x1E81, 0x1E83, 0x1E85, 0x1E87, 0x1E89, 0x1E8B, 0x1E8D, 0x1E8F, 0x1E91, 0x1E93, 0x1E9F, 0x1EA1, 0x1EA3, 0x1EA5, 0x1EA7, 0x1EA9, 0x1EAB, 0x1EAD, 0x1EAF, 0x1EB1, 0x1EB3, 0x1EB5, 0x1EB7, 0x1EB9, 0x1EBB, 0x1EBD, 0x1EBF, 0x1EC1, 0x1EC3, 0x1EC5, 0x1EC7, 0x1EC9, 0x1ECB, 0x1ECD, 0x1ECF, 0x1ED1, 0x1ED3, 0x1ED5, 0x1ED7, 0x1ED9, 0x1EDB, 0x1EDD, 0x1EDF, 0x1EE1, 0x1EE3, 0x1EE5, 0x1EE7, 0x1EE9, 0x1EEB, 0x1EED, 0x1EEF, 0x1EF1, 0x1EF3, 0x1EF5, 0x1EF7, 0x1EF9, 0x1EFB, 0x1EFD, 0x1FBE, 0x2071, 0x207F, 0x210A, 0x2113, 0x212F, 0x2134, 0x2139, 0x214E, 0x2184, 0x2C61, 0x2C68, 0x2C6A, 0x2C6C, 0x2C71, 0x2C81, 0x2C83, 0x2C85, 0x2C87, 0x2C89, 0x2C8B, 0x2C8D, 0x2C8F, 0x2C91, 0x2C93, 0x2C95, 0x2C97, 0x2C99, 0x2C9B, 0x2C9D, 0x2C9F, 0x2CA1, 0x2CA3, 0x2CA5, 0x2CA7, 0x2CA9, 0x2CAB, 0x2CAD, 0x2CAF, 0x2CB1, 0x2CB3, 0x2CB5, 0x2CB7, 0x2CB9, 0x2CBB, 0x2CBD, 0x2CBF, 0x2CC1, 0x2CC3, 0x2CC5, 0x2CC7, 0x2CC9, 0x2CCB, 0x2CCD, 0x2CCF, 0x2CD1, 0x2CD3, 0x2CD5, 0x2CD7, 0x2CD9, 0x2CDB, 0x2CDD, 0x2CDF, 0x2CE1, 0x2CEC, 0x2CEE, 0x2CF3, 0x2D27, 0x2D2D, 0xA641, 0xA643, 0xA645, 0xA647, 0xA649, 0xA64B, 0xA64D, 0xA64F, 0xA651, 0xA653, 0xA655, 0xA657, 0xA659, 0xA65B, 0xA65D, 0xA65F, 0xA661, 0xA663, 0xA665, 0xA667, 0xA669, 0xA66B, 0xA66D, 0xA681, 0xA683, 0xA685, 0xA687, 0xA689, 0xA68B, 0xA68D, 0xA68F, 0xA691, 0xA693, 0xA695, 0xA697, 0xA699, 0xA723, 0xA725, 0xA727, 0xA729, 0xA72B, 0xA72D, 0xA733, 0xA735, 0xA737, 0xA739, 0xA73B, 0xA73D, 0xA73F, 0xA741, 0xA743, 0xA745, 0xA747, 0xA749, 0xA74B, 0xA74D, 0xA74F, 0xA751, 0xA753, 0xA755, 0xA757, 0xA759, 0xA75B, 0xA75D, 0xA75F, 0xA761, 0xA763, 0xA765, 0xA767, 0xA769, 0xA76B, 0xA76D, 0xA77A, 0xA77C, 0xA77F, 0xA781, 0xA783, 0xA785, 0xA787, 0xA78C, 0xA78E, 0xA791, 0xA797, 0xA799, 0xA79B, 0xA79D, 0xA79F, 0xA7A1, 0xA7A3, 0xA7A5, 0xA7A7, 0xA7A9, 0xA7AF, 0xA7B5, 0xA7B7, 0xA7B9, 0xA7BB, 0xA7BD, 0xA7BF, 0xA7C1, 0xA7C3, 0xA7C8, 0xA7CA, 0xA7D1, 0xA7D3, 0xA7D5, 0xA7D7, 0xA7D9, 0xA7F6, 0x10780, 0x1D4BB, 0x1D7CB);
		    set.addRange(0x61, 0x7A).addRange(0xDF, 0xF6).addRange(0xF8, 0xFF).addRange(0x137, 0x138).addRange(0x148, 0x149).addRange(0x17E, 0x180).addRange(0x18C, 0x18D).addRange(0x199, 0x19B).addRange(0x1AA, 0x1AB).addRange(0x1B9, 0x1BA).addRange(0x1BD, 0x1BF).addRange(0x1DC, 0x1DD).addRange(0x1EF, 0x1F0).addRange(0x233, 0x239).addRange(0x23F, 0x240).addRange(0x24F, 0x293).addRange(0x295, 0x2B8).addRange(0x2C0, 0x2C1).addRange(0x2E0, 0x2E4).addRange(0x37A, 0x37D).addRange(0x3AC, 0x3CE).addRange(0x3D0, 0x3D1).addRange(0x3D5, 0x3D7).addRange(0x3EF, 0x3F3).addRange(0x3FB, 0x3FC).addRange(0x430, 0x45F).addRange(0x4CE, 0x4CF).addRange(0x560, 0x588).addRange(0x10D0, 0x10FA).addRange(0x10FC, 0x10FF).addRange(0x13F8, 0x13FD).addRange(0x1C80, 0x1C88).addRange(0x1D00, 0x1DBF).addRange(0x1E95, 0x1E9D).addRange(0x1EFF, 0x1F07).addRange(0x1F10, 0x1F15).addRange(0x1F20, 0x1F27).addRange(0x1F30, 0x1F37).addRange(0x1F40, 0x1F45).addRange(0x1F50, 0x1F57).addRange(0x1F60, 0x1F67).addRange(0x1F70, 0x1F7D).addRange(0x1F80, 0x1F87).addRange(0x1F90, 0x1F97).addRange(0x1FA0, 0x1FA7).addRange(0x1FB0, 0x1FB4).addRange(0x1FB6, 0x1FB7).addRange(0x1FC2, 0x1FC4).addRange(0x1FC6, 0x1FC7).addRange(0x1FD0, 0x1FD3).addRange(0x1FD6, 0x1FD7);
		    set.addRange(0x1FE0, 0x1FE7).addRange(0x1FF2, 0x1FF4).addRange(0x1FF6, 0x1FF7).addRange(0x2090, 0x209C).addRange(0x210E, 0x210F).addRange(0x213C, 0x213D).addRange(0x2146, 0x2149).addRange(0x2170, 0x217F).addRange(0x24D0, 0x24E9).addRange(0x2C30, 0x2C5F).addRange(0x2C65, 0x2C66).addRange(0x2C73, 0x2C74).addRange(0x2C76, 0x2C7D).addRange(0x2CE3, 0x2CE4).addRange(0x2D00, 0x2D25).addRange(0xA69B, 0xA69D).addRange(0xA72F, 0xA731).addRange(0xA76F, 0xA778).addRange(0xA793, 0xA795).addRange(0xA7F2, 0xA7F4).addRange(0xA7F8, 0xA7FA).addRange(0xAB30, 0xAB5A).addRange(0xAB5C, 0xAB69).addRange(0xAB70, 0xABBF).addRange(0xFB00, 0xFB06).addRange(0xFB13, 0xFB17).addRange(0xFF41, 0xFF5A).addRange(0x10428, 0x1044F).addRange(0x104D8, 0x104FB).addRange(0x10597, 0x105A1).addRange(0x105A3, 0x105B1).addRange(0x105B3, 0x105B9).addRange(0x105BB, 0x105BC).addRange(0x10783, 0x10785).addRange(0x10787, 0x107B0).addRange(0x107B2, 0x107BA).addRange(0x10CC0, 0x10CF2).addRange(0x118C0, 0x118DF).addRange(0x16E60, 0x16E7F).addRange(0x1D41A, 0x1D433).addRange(0x1D44E, 0x1D454).addRange(0x1D456, 0x1D467).addRange(0x1D482, 0x1D49B).addRange(0x1D4B6, 0x1D4B9).addRange(0x1D4BD, 0x1D4C3).addRange(0x1D4C5, 0x1D4CF).addRange(0x1D4EA, 0x1D503).addRange(0x1D51E, 0x1D537).addRange(0x1D552, 0x1D56B).addRange(0x1D586, 0x1D59F).addRange(0x1D5BA, 0x1D5D3);
		    set.addRange(0x1D5EE, 0x1D607).addRange(0x1D622, 0x1D63B).addRange(0x1D656, 0x1D66F).addRange(0x1D68A, 0x1D6A5).addRange(0x1D6C2, 0x1D6DA).addRange(0x1D6DC, 0x1D6E1).addRange(0x1D6FC, 0x1D714).addRange(0x1D716, 0x1D71B).addRange(0x1D736, 0x1D74E).addRange(0x1D750, 0x1D755).addRange(0x1D770, 0x1D788).addRange(0x1D78A, 0x1D78F).addRange(0x1D7AA, 0x1D7C2).addRange(0x1D7C4, 0x1D7C9).addRange(0x1DF00, 0x1DF09).addRange(0x1DF0B, 0x1DF1E).addRange(0x1DF25, 0x1DF2A).addRange(0x1E030, 0x1E06D).addRange(0x1E922, 0x1E943);
		    Lowercase.characters = set;
		    return Lowercase;
		  }

		  var _Math = {};

		  var hasRequired_Math;
		  function require_Math() {
		    if (hasRequired_Math) return _Math;
		    hasRequired_Math = 1;
		    var set = regenerateExports(0x2B, 0x5E, 0x7C, 0x7E, 0xAC, 0xB1, 0xD7, 0xF7, 0x3D5, 0x2016, 0x2040, 0x2044, 0x2052, 0x20E1, 0x2102, 0x2107, 0x2115, 0x2124, 0x214B, 0x21DD, 0x237C, 0x23B7, 0x23D0, 0x25E2, 0x25E4, 0x2640, 0x2642, 0xFB29, 0xFE68, 0xFF0B, 0xFF3C, 0xFF3E, 0xFF5C, 0xFF5E, 0xFFE2, 0x1D4A2, 0x1D4BB, 0x1D546, 0x1EE24, 0x1EE27, 0x1EE39, 0x1EE3B, 0x1EE42, 0x1EE47, 0x1EE49, 0x1EE4B, 0x1EE54, 0x1EE57, 0x1EE59, 0x1EE5B, 0x1EE5D, 0x1EE5F, 0x1EE64, 0x1EE7E);
		    set.addRange(0x3C, 0x3E).addRange(0x3D0, 0x3D2).addRange(0x3F0, 0x3F1).addRange(0x3F4, 0x3F6).addRange(0x606, 0x608).addRange(0x2032, 0x2034).addRange(0x2061, 0x2064).addRange(0x207A, 0x207E).addRange(0x208A, 0x208E).addRange(0x20D0, 0x20DC).addRange(0x20E5, 0x20E6).addRange(0x20EB, 0x20EF).addRange(0x210A, 0x2113).addRange(0x2118, 0x211D).addRange(0x2128, 0x2129).addRange(0x212C, 0x212D).addRange(0x212F, 0x2131).addRange(0x2133, 0x2138).addRange(0x213C, 0x2149).addRange(0x2190, 0x21A7).addRange(0x21A9, 0x21AE).addRange(0x21B0, 0x21B1).addRange(0x21B6, 0x21B7).addRange(0x21BC, 0x21DB).addRange(0x21E4, 0x21E5).addRange(0x21F4, 0x22FF).addRange(0x2308, 0x230B).addRange(0x2320, 0x2321).addRange(0x239B, 0x23B5).addRange(0x23DC, 0x23E2).addRange(0x25A0, 0x25A1).addRange(0x25AE, 0x25B7).addRange(0x25BC, 0x25C1).addRange(0x25C6, 0x25C7).addRange(0x25CA, 0x25CB).addRange(0x25CF, 0x25D3).addRange(0x25E7, 0x25EC).addRange(0x25F8, 0x25FF).addRange(0x2605, 0x2606).addRange(0x2660, 0x2663).addRange(0x266D, 0x266F).addRange(0x27C0, 0x27FF).addRange(0x2900, 0x2AFF).addRange(0x2B30, 0x2B44).addRange(0x2B47, 0x2B4C).addRange(0xFE61, 0xFE66).addRange(0xFF1C, 0xFF1E).addRange(0xFFE9, 0xFFEC).addRange(0x1D400, 0x1D454).addRange(0x1D456, 0x1D49C).addRange(0x1D49E, 0x1D49F);
		    set.addRange(0x1D4A5, 0x1D4A6).addRange(0x1D4A9, 0x1D4AC).addRange(0x1D4AE, 0x1D4B9).addRange(0x1D4BD, 0x1D4C3).addRange(0x1D4C5, 0x1D505).addRange(0x1D507, 0x1D50A).addRange(0x1D50D, 0x1D514).addRange(0x1D516, 0x1D51C).addRange(0x1D51E, 0x1D539).addRange(0x1D53B, 0x1D53E).addRange(0x1D540, 0x1D544).addRange(0x1D54A, 0x1D550).addRange(0x1D552, 0x1D6A5).addRange(0x1D6A8, 0x1D7CB).addRange(0x1D7CE, 0x1D7FF).addRange(0x1EE00, 0x1EE03).addRange(0x1EE05, 0x1EE1F).addRange(0x1EE21, 0x1EE22).addRange(0x1EE29, 0x1EE32).addRange(0x1EE34, 0x1EE37).addRange(0x1EE4D, 0x1EE4F).addRange(0x1EE51, 0x1EE52).addRange(0x1EE61, 0x1EE62).addRange(0x1EE67, 0x1EE6A).addRange(0x1EE6C, 0x1EE72).addRange(0x1EE74, 0x1EE77).addRange(0x1EE79, 0x1EE7C).addRange(0x1EE80, 0x1EE89).addRange(0x1EE8B, 0x1EE9B).addRange(0x1EEA1, 0x1EEA3).addRange(0x1EEA5, 0x1EEA9).addRange(0x1EEAB, 0x1EEBB).addRange(0x1EEF0, 0x1EEF1);
		    _Math.characters = set;
		    return _Math;
		  }

		  var Noncharacter_Code_Point = {};

		  var hasRequiredNoncharacter_Code_Point;
		  function requireNoncharacter_Code_Point() {
		    if (hasRequiredNoncharacter_Code_Point) return Noncharacter_Code_Point;
		    hasRequiredNoncharacter_Code_Point = 1;
		    var set = regenerateExports();
		    set.addRange(0xFDD0, 0xFDEF).addRange(0xFFFE, 0xFFFF).addRange(0x1FFFE, 0x1FFFF).addRange(0x2FFFE, 0x2FFFF).addRange(0x3FFFE, 0x3FFFF).addRange(0x4FFFE, 0x4FFFF).addRange(0x5FFFE, 0x5FFFF).addRange(0x6FFFE, 0x6FFFF).addRange(0x7FFFE, 0x7FFFF).addRange(0x8FFFE, 0x8FFFF).addRange(0x9FFFE, 0x9FFFF).addRange(0xAFFFE, 0xAFFFF).addRange(0xBFFFE, 0xBFFFF).addRange(0xCFFFE, 0xCFFFF).addRange(0xDFFFE, 0xDFFFF).addRange(0xEFFFE, 0xEFFFF).addRange(0xFFFFE, 0xFFFFF).addRange(0x10FFFE, 0x10FFFF);
		    Noncharacter_Code_Point.characters = set;
		    return Noncharacter_Code_Point;
		  }

		  var Pattern_Syntax = {};

		  var hasRequiredPattern_Syntax;
		  function requirePattern_Syntax() {
		    if (hasRequiredPattern_Syntax) return Pattern_Syntax;
		    hasRequiredPattern_Syntax = 1;
		    var set = regenerateExports(0x60, 0xA9, 0xAE, 0xB6, 0xBB, 0xBF, 0xD7, 0xF7, 0x3030);
		    set.addRange(0x21, 0x2F).addRange(0x3A, 0x40).addRange(0x5B, 0x5E).addRange(0x7B, 0x7E).addRange(0xA1, 0xA7).addRange(0xAB, 0xAC).addRange(0xB0, 0xB1).addRange(0x2010, 0x2027).addRange(0x2030, 0x203E).addRange(0x2041, 0x2053).addRange(0x2055, 0x205E).addRange(0x2190, 0x245F).addRange(0x2500, 0x2775).addRange(0x2794, 0x2BFF).addRange(0x2E00, 0x2E7F).addRange(0x3001, 0x3003).addRange(0x3008, 0x3020).addRange(0xFD3E, 0xFD3F).addRange(0xFE45, 0xFE46);
		    Pattern_Syntax.characters = set;
		    return Pattern_Syntax;
		  }

		  var Pattern_White_Space = {};

		  var hasRequiredPattern_White_Space;
		  function requirePattern_White_Space() {
		    if (hasRequiredPattern_White_Space) return Pattern_White_Space;
		    hasRequiredPattern_White_Space = 1;
		    var set = regenerateExports(0x20, 0x85);
		    set.addRange(0x9, 0xD).addRange(0x200E, 0x200F).addRange(0x2028, 0x2029);
		    Pattern_White_Space.characters = set;
		    return Pattern_White_Space;
		  }

		  var Quotation_Mark = {};

		  var hasRequiredQuotation_Mark;
		  function requireQuotation_Mark() {
		    if (hasRequiredQuotation_Mark) return Quotation_Mark;
		    hasRequiredQuotation_Mark = 1;
		    var set = regenerateExports(0x22, 0x27, 0xAB, 0xBB, 0x2E42, 0xFF02, 0xFF07);
		    set.addRange(0x2018, 0x201F).addRange(0x2039, 0x203A).addRange(0x300C, 0x300F).addRange(0x301D, 0x301F).addRange(0xFE41, 0xFE44).addRange(0xFF62, 0xFF63);
		    Quotation_Mark.characters = set;
		    return Quotation_Mark;
		  }

		  var Radical = {};

		  var hasRequiredRadical;
		  function requireRadical() {
		    if (hasRequiredRadical) return Radical;
		    hasRequiredRadical = 1;
		    var set = regenerateExports();
		    set.addRange(0x2E80, 0x2E99).addRange(0x2E9B, 0x2EF3).addRange(0x2F00, 0x2FD5);
		    Radical.characters = set;
		    return Radical;
		  }

		  var Regional_Indicator = {};

		  var hasRequiredRegional_Indicator;
		  function requireRegional_Indicator() {
		    if (hasRequiredRegional_Indicator) return Regional_Indicator;
		    hasRequiredRegional_Indicator = 1;
		    var set = regenerateExports();
		    set.addRange(0x1F1E6, 0x1F1FF);
		    Regional_Indicator.characters = set;
		    return Regional_Indicator;
		  }

		  var Sentence_Terminal = {};

		  var hasRequiredSentence_Terminal;
		  function requireSentence_Terminal() {
		    if (hasRequiredSentence_Terminal) return Sentence_Terminal;
		    hasRequiredSentence_Terminal = 1;
		    var set = regenerateExports(0x21, 0x2E, 0x3F, 0x589, 0x6D4, 0x7F9, 0x837, 0x839, 0x1362, 0x166E, 0x1803, 0x1809, 0x2E2E, 0x2E3C, 0x3002, 0xA4FF, 0xA6F3, 0xA6F7, 0xA92F, 0xABEB, 0xFE52, 0xFF01, 0xFF0E, 0xFF1F, 0xFF61, 0x111CD, 0x112A9, 0x11944, 0x11946, 0x16AF5, 0x16B44, 0x16E98, 0x1BC9F, 0x1DA88);
		    set.addRange(0x61D, 0x61F).addRange(0x700, 0x702).addRange(0x83D, 0x83E).addRange(0x964, 0x965).addRange(0x104A, 0x104B).addRange(0x1367, 0x1368).addRange(0x1735, 0x1736).addRange(0x17D4, 0x17D5).addRange(0x1944, 0x1945).addRange(0x1AA8, 0x1AAB).addRange(0x1B5A, 0x1B5B).addRange(0x1B5E, 0x1B5F).addRange(0x1B7D, 0x1B7E).addRange(0x1C3B, 0x1C3C).addRange(0x1C7E, 0x1C7F).addRange(0x203C, 0x203D).addRange(0x2047, 0x2049).addRange(0x2E53, 0x2E54).addRange(0xA60E, 0xA60F).addRange(0xA876, 0xA877).addRange(0xA8CE, 0xA8CF).addRange(0xA9C8, 0xA9C9).addRange(0xAA5D, 0xAA5F).addRange(0xAAF0, 0xAAF1).addRange(0xFE56, 0xFE57).addRange(0x10A56, 0x10A57).addRange(0x10F55, 0x10F59).addRange(0x10F86, 0x10F89).addRange(0x11047, 0x11048).addRange(0x110BE, 0x110C1).addRange(0x11141, 0x11143).addRange(0x111C5, 0x111C6).addRange(0x111DE, 0x111DF).addRange(0x11238, 0x11239).addRange(0x1123B, 0x1123C).addRange(0x1144B, 0x1144C).addRange(0x115C2, 0x115C3).addRange(0x115C9, 0x115D7).addRange(0x11641, 0x11642).addRange(0x1173C, 0x1173E).addRange(0x11A42, 0x11A43).addRange(0x11A9B, 0x11A9C).addRange(0x11C41, 0x11C42).addRange(0x11EF7, 0x11EF8).addRange(0x11F43, 0x11F44).addRange(0x16A6E, 0x16A6F).addRange(0x16B37, 0x16B38);
		    Sentence_Terminal.characters = set;
		    return Sentence_Terminal;
		  }

		  var Soft_Dotted = {};

		  var hasRequiredSoft_Dotted;
		  function requireSoft_Dotted() {
		    if (hasRequiredSoft_Dotted) return Soft_Dotted;
		    hasRequiredSoft_Dotted = 1;
		    var set = regenerateExports(0x12F, 0x249, 0x268, 0x29D, 0x2B2, 0x3F3, 0x456, 0x458, 0x1D62, 0x1D96, 0x1DA4, 0x1DA8, 0x1E2D, 0x1ECB, 0x2071, 0x2C7C, 0x1DF1A, 0x1E068);
		    set.addRange(0x69, 0x6A).addRange(0x2148, 0x2149).addRange(0x1D422, 0x1D423).addRange(0x1D456, 0x1D457).addRange(0x1D48A, 0x1D48B).addRange(0x1D4BE, 0x1D4BF).addRange(0x1D4F2, 0x1D4F3).addRange(0x1D526, 0x1D527).addRange(0x1D55A, 0x1D55B).addRange(0x1D58E, 0x1D58F).addRange(0x1D5C2, 0x1D5C3).addRange(0x1D5F6, 0x1D5F7).addRange(0x1D62A, 0x1D62B).addRange(0x1D65E, 0x1D65F).addRange(0x1D692, 0x1D693).addRange(0x1E04C, 0x1E04D);
		    Soft_Dotted.characters = set;
		    return Soft_Dotted;
		  }

		  var Terminal_Punctuation = {};

		  var hasRequiredTerminal_Punctuation;
		  function requireTerminal_Punctuation() {
		    if (hasRequiredTerminal_Punctuation) return Terminal_Punctuation;
		    hasRequiredTerminal_Punctuation = 1;
		    var set = regenerateExports(0x21, 0x2C, 0x2E, 0x3F, 0x37E, 0x387, 0x589, 0x5C3, 0x60C, 0x61B, 0x6D4, 0x70C, 0x85E, 0xF08, 0x166E, 0x17DA, 0x2E2E, 0x2E3C, 0x2E41, 0x2E4C, 0xA92F, 0xAADF, 0xABEB, 0xFF01, 0xFF0C, 0xFF0E, 0xFF1F, 0xFF61, 0xFF64, 0x1039F, 0x103D0, 0x10857, 0x1091F, 0x111CD, 0x112A9, 0x11944, 0x11946, 0x11C71, 0x16AF5, 0x16B44, 0x1BC9F);
		    set.addRange(0x3A, 0x3B).addRange(0x61D, 0x61F).addRange(0x700, 0x70A).addRange(0x7F8, 0x7F9).addRange(0x830, 0x83E).addRange(0x964, 0x965).addRange(0xE5A, 0xE5B).addRange(0xF0D, 0xF12).addRange(0x104A, 0x104B).addRange(0x1361, 0x1368).addRange(0x16EB, 0x16ED).addRange(0x1735, 0x1736).addRange(0x17D4, 0x17D6).addRange(0x1802, 0x1805).addRange(0x1808, 0x1809).addRange(0x1944, 0x1945).addRange(0x1AA8, 0x1AAB).addRange(0x1B5A, 0x1B5B).addRange(0x1B5D, 0x1B5F).addRange(0x1B7D, 0x1B7E).addRange(0x1C3B, 0x1C3F).addRange(0x1C7E, 0x1C7F).addRange(0x203C, 0x203D).addRange(0x2047, 0x2049).addRange(0x2E4E, 0x2E4F).addRange(0x2E53, 0x2E54).addRange(0x3001, 0x3002).addRange(0xA4FE, 0xA4FF).addRange(0xA60D, 0xA60F).addRange(0xA6F3, 0xA6F7).addRange(0xA876, 0xA877).addRange(0xA8CE, 0xA8CF).addRange(0xA9C7, 0xA9C9).addRange(0xAA5D, 0xAA5F).addRange(0xAAF0, 0xAAF1).addRange(0xFE50, 0xFE52).addRange(0xFE54, 0xFE57).addRange(0xFF1A, 0xFF1B).addRange(0x10A56, 0x10A57).addRange(0x10AF0, 0x10AF5).addRange(0x10B3A, 0x10B3F).addRange(0x10B99, 0x10B9C).addRange(0x10F55, 0x10F59).addRange(0x10F86, 0x10F89).addRange(0x11047, 0x1104D).addRange(0x110BE, 0x110C1).addRange(0x11141, 0x11143).addRange(0x111C5, 0x111C6).addRange(0x111DE, 0x111DF).addRange(0x11238, 0x1123C).addRange(0x1144B, 0x1144D);
		    set.addRange(0x1145A, 0x1145B).addRange(0x115C2, 0x115C5).addRange(0x115C9, 0x115D7).addRange(0x11641, 0x11642).addRange(0x1173C, 0x1173E).addRange(0x11A42, 0x11A43).addRange(0x11A9B, 0x11A9C).addRange(0x11AA1, 0x11AA2).addRange(0x11C41, 0x11C43).addRange(0x11EF7, 0x11EF8).addRange(0x11F43, 0x11F44).addRange(0x12470, 0x12474).addRange(0x16A6E, 0x16A6F).addRange(0x16B37, 0x16B39).addRange(0x16E97, 0x16E98).addRange(0x1DA87, 0x1DA8A);
		    Terminal_Punctuation.characters = set;
		    return Terminal_Punctuation;
		  }

		  var Unified_Ideograph = {};

		  var hasRequiredUnified_Ideograph;
		  function requireUnified_Ideograph() {
		    if (hasRequiredUnified_Ideograph) return Unified_Ideograph;
		    hasRequiredUnified_Ideograph = 1;
		    var set = regenerateExports(0xFA11, 0xFA1F, 0xFA21);
		    set.addRange(0x3400, 0x4DBF).addRange(0x4E00, 0x9FFF).addRange(0xFA0E, 0xFA0F).addRange(0xFA13, 0xFA14).addRange(0xFA23, 0xFA24).addRange(0xFA27, 0xFA29).addRange(0x20000, 0x2A6DF).addRange(0x2A700, 0x2B739).addRange(0x2B740, 0x2B81D).addRange(0x2B820, 0x2CEA1).addRange(0x2CEB0, 0x2EBE0).addRange(0x2EBF0, 0x2EE5D).addRange(0x30000, 0x3134A).addRange(0x31350, 0x323AF);
		    Unified_Ideograph.characters = set;
		    return Unified_Ideograph;
		  }

		  var Uppercase = {};

		  var hasRequiredUppercase;
		  function requireUppercase() {
		    if (hasRequiredUppercase) return Uppercase;
		    hasRequiredUppercase = 1;
		    var set = regenerateExports(0x100, 0x102, 0x104, 0x106, 0x108, 0x10A, 0x10C, 0x10E, 0x110, 0x112, 0x114, 0x116, 0x118, 0x11A, 0x11C, 0x11E, 0x120, 0x122, 0x124, 0x126, 0x128, 0x12A, 0x12C, 0x12E, 0x130, 0x132, 0x134, 0x136, 0x139, 0x13B, 0x13D, 0x13F, 0x141, 0x143, 0x145, 0x147, 0x14A, 0x14C, 0x14E, 0x150, 0x152, 0x154, 0x156, 0x158, 0x15A, 0x15C, 0x15E, 0x160, 0x162, 0x164, 0x166, 0x168, 0x16A, 0x16C, 0x16E, 0x170, 0x172, 0x174, 0x176, 0x17B, 0x17D, 0x184, 0x1A2, 0x1A4, 0x1A9, 0x1AC, 0x1B5, 0x1BC, 0x1C4, 0x1C7, 0x1CA, 0x1CD, 0x1CF, 0x1D1, 0x1D3, 0x1D5, 0x1D7, 0x1D9, 0x1DB, 0x1DE, 0x1E0, 0x1E2, 0x1E4, 0x1E6, 0x1E8, 0x1EA, 0x1EC, 0x1EE, 0x1F1, 0x1F4, 0x1FA, 0x1FC, 0x1FE, 0x200, 0x202, 0x204, 0x206, 0x208, 0x20A, 0x20C, 0x20E, 0x210, 0x212, 0x214, 0x216, 0x218, 0x21A, 0x21C, 0x21E, 0x220, 0x222, 0x224, 0x226, 0x228, 0x22A, 0x22C, 0x22E, 0x230, 0x232, 0x241, 0x248, 0x24A, 0x24C, 0x24E, 0x370, 0x372, 0x376, 0x37F, 0x386, 0x38C, 0x3CF, 0x3D8, 0x3DA, 0x3DC, 0x3DE, 0x3E0, 0x3E2, 0x3E4, 0x3E6, 0x3E8, 0x3EA, 0x3EC, 0x3EE, 0x3F4, 0x3F7, 0x460, 0x462, 0x464, 0x466, 0x468, 0x46A, 0x46C, 0x46E, 0x470, 0x472, 0x474, 0x476, 0x478, 0x47A, 0x47C, 0x47E, 0x480, 0x48A, 0x48C, 0x48E, 0x490, 0x492, 0x494, 0x496, 0x498, 0x49A, 0x49C, 0x49E, 0x4A0, 0x4A2, 0x4A4, 0x4A6, 0x4A8, 0x4AA, 0x4AC, 0x4AE, 0x4B0, 0x4B2, 0x4B4, 0x4B6, 0x4B8, 0x4BA, 0x4BC, 0x4BE, 0x4C3, 0x4C5, 0x4C7, 0x4C9, 0x4CB, 0x4CD, 0x4D0, 0x4D2, 0x4D4, 0x4D6, 0x4D8, 0x4DA, 0x4DC, 0x4DE, 0x4E0, 0x4E2, 0x4E4, 0x4E6, 0x4E8, 0x4EA, 0x4EC, 0x4EE, 0x4F0, 0x4F2, 0x4F4, 0x4F6, 0x4F8, 0x4FA, 0x4FC, 0x4FE, 0x500, 0x502, 0x504, 0x506, 0x508, 0x50A, 0x50C, 0x50E, 0x510, 0x512, 0x514, 0x516, 0x518, 0x51A, 0x51C, 0x51E, 0x520, 0x522, 0x524, 0x526, 0x528, 0x52A, 0x52C, 0x52E, 0x10C7, 0x10CD, 0x1E00, 0x1E02, 0x1E04, 0x1E06, 0x1E08, 0x1E0A, 0x1E0C, 0x1E0E, 0x1E10, 0x1E12, 0x1E14, 0x1E16, 0x1E18, 0x1E1A, 0x1E1C, 0x1E1E, 0x1E20, 0x1E22, 0x1E24, 0x1E26, 0x1E28, 0x1E2A, 0x1E2C, 0x1E2E, 0x1E30, 0x1E32, 0x1E34, 0x1E36, 0x1E38, 0x1E3A, 0x1E3C, 0x1E3E, 0x1E40, 0x1E42, 0x1E44, 0x1E46, 0x1E48, 0x1E4A, 0x1E4C, 0x1E4E, 0x1E50, 0x1E52, 0x1E54, 0x1E56, 0x1E58, 0x1E5A, 0x1E5C, 0x1E5E, 0x1E60, 0x1E62, 0x1E64, 0x1E66, 0x1E68, 0x1E6A, 0x1E6C, 0x1E6E, 0x1E70, 0x1E72, 0x1E74, 0x1E76, 0x1E78, 0x1E7A, 0x1E7C, 0x1E7E, 0x1E80, 0x1E82, 0x1E84, 0x1E86, 0x1E88, 0x1E8A, 0x1E8C, 0x1E8E, 0x1E90, 0x1E92, 0x1E94, 0x1E9E, 0x1EA0, 0x1EA2, 0x1EA4, 0x1EA6, 0x1EA8, 0x1EAA, 0x1EAC, 0x1EAE, 0x1EB0, 0x1EB2, 0x1EB4, 0x1EB6, 0x1EB8, 0x1EBA, 0x1EBC, 0x1EBE, 0x1EC0, 0x1EC2, 0x1EC4, 0x1EC6, 0x1EC8, 0x1ECA, 0x1ECC, 0x1ECE, 0x1ED0, 0x1ED2, 0x1ED4, 0x1ED6, 0x1ED8, 0x1EDA, 0x1EDC, 0x1EDE, 0x1EE0, 0x1EE2, 0x1EE4, 0x1EE6, 0x1EE8, 0x1EEA, 0x1EEC, 0x1EEE, 0x1EF0, 0x1EF2, 0x1EF4, 0x1EF6, 0x1EF8, 0x1EFA, 0x1EFC, 0x1EFE, 0x1F59, 0x1F5B, 0x1F5D, 0x1F5F, 0x2102, 0x2107, 0x2115, 0x2124, 0x2126, 0x2128, 0x2145, 0x2183, 0x2C60, 0x2C67, 0x2C69, 0x2C6B, 0x2C72, 0x2C75, 0x2C82, 0x2C84, 0x2C86, 0x2C88, 0x2C8A, 0x2C8C, 0x2C8E, 0x2C90, 0x2C92, 0x2C94, 0x2C96, 0x2C98, 0x2C9A, 0x2C9C, 0x2C9E, 0x2CA0, 0x2CA2, 0x2CA4, 0x2CA6, 0x2CA8, 0x2CAA, 0x2CAC, 0x2CAE, 0x2CB0, 0x2CB2, 0x2CB4, 0x2CB6, 0x2CB8, 0x2CBA, 0x2CBC, 0x2CBE, 0x2CC0, 0x2CC2, 0x2CC4, 0x2CC6, 0x2CC8, 0x2CCA, 0x2CCC, 0x2CCE, 0x2CD0, 0x2CD2, 0x2CD4, 0x2CD6, 0x2CD8, 0x2CDA, 0x2CDC, 0x2CDE, 0x2CE0, 0x2CE2, 0x2CEB, 0x2CED, 0x2CF2, 0xA640, 0xA642, 0xA644, 0xA646, 0xA648, 0xA64A, 0xA64C, 0xA64E, 0xA650, 0xA652, 0xA654, 0xA656, 0xA658, 0xA65A, 0xA65C, 0xA65E, 0xA660, 0xA662, 0xA664, 0xA666, 0xA668, 0xA66A, 0xA66C, 0xA680, 0xA682, 0xA684, 0xA686, 0xA688, 0xA68A, 0xA68C, 0xA68E, 0xA690, 0xA692, 0xA694, 0xA696, 0xA698, 0xA69A, 0xA722, 0xA724, 0xA726, 0xA728, 0xA72A, 0xA72C, 0xA72E, 0xA732, 0xA734, 0xA736, 0xA738, 0xA73A, 0xA73C, 0xA73E, 0xA740, 0xA742, 0xA744, 0xA746, 0xA748, 0xA74A, 0xA74C, 0xA74E, 0xA750, 0xA752, 0xA754, 0xA756, 0xA758, 0xA75A, 0xA75C, 0xA75E, 0xA760, 0xA762, 0xA764, 0xA766, 0xA768, 0xA76A, 0xA76C, 0xA76E, 0xA779, 0xA77B, 0xA780, 0xA782, 0xA784, 0xA786, 0xA78B, 0xA78D, 0xA790, 0xA792, 0xA796, 0xA798, 0xA79A, 0xA79C, 0xA79E, 0xA7A0, 0xA7A2, 0xA7A4, 0xA7A6, 0xA7A8, 0xA7B6, 0xA7B8, 0xA7BA, 0xA7BC, 0xA7BE, 0xA7C0, 0xA7C2, 0xA7C9, 0xA7D0, 0xA7D6, 0xA7D8, 0xA7F5, 0x1D49C, 0x1D4A2, 0x1D546, 0x1D7CA);
		    set.addRange(0x41, 0x5A).addRange(0xC0, 0xD6).addRange(0xD8, 0xDE).addRange(0x178, 0x179).addRange(0x181, 0x182).addRange(0x186, 0x187).addRange(0x189, 0x18B).addRange(0x18E, 0x191).addRange(0x193, 0x194).addRange(0x196, 0x198).addRange(0x19C, 0x19D).addRange(0x19F, 0x1A0).addRange(0x1A6, 0x1A7).addRange(0x1AE, 0x1AF).addRange(0x1B1, 0x1B3).addRange(0x1B7, 0x1B8).addRange(0x1F6, 0x1F8).addRange(0x23A, 0x23B).addRange(0x23D, 0x23E).addRange(0x243, 0x246).addRange(0x388, 0x38A).addRange(0x38E, 0x38F).addRange(0x391, 0x3A1).addRange(0x3A3, 0x3AB).addRange(0x3D2, 0x3D4).addRange(0x3F9, 0x3FA).addRange(0x3FD, 0x42F).addRange(0x4C0, 0x4C1).addRange(0x531, 0x556).addRange(0x10A0, 0x10C5).addRange(0x13A0, 0x13F5).addRange(0x1C90, 0x1CBA).addRange(0x1CBD, 0x1CBF).addRange(0x1F08, 0x1F0F).addRange(0x1F18, 0x1F1D).addRange(0x1F28, 0x1F2F).addRange(0x1F38, 0x1F3F).addRange(0x1F48, 0x1F4D).addRange(0x1F68, 0x1F6F).addRange(0x1FB8, 0x1FBB).addRange(0x1FC8, 0x1FCB).addRange(0x1FD8, 0x1FDB).addRange(0x1FE8, 0x1FEC).addRange(0x1FF8, 0x1FFB).addRange(0x210B, 0x210D).addRange(0x2110, 0x2112).addRange(0x2119, 0x211D).addRange(0x212A, 0x212D).addRange(0x2130, 0x2133).addRange(0x213E, 0x213F).addRange(0x2160, 0x216F);
		    set.addRange(0x24B6, 0x24CF).addRange(0x2C00, 0x2C2F).addRange(0x2C62, 0x2C64).addRange(0x2C6D, 0x2C70).addRange(0x2C7E, 0x2C80).addRange(0xA77D, 0xA77E).addRange(0xA7AA, 0xA7AE).addRange(0xA7B0, 0xA7B4).addRange(0xA7C4, 0xA7C7).addRange(0xFF21, 0xFF3A).addRange(0x10400, 0x10427).addRange(0x104B0, 0x104D3).addRange(0x10570, 0x1057A).addRange(0x1057C, 0x1058A).addRange(0x1058C, 0x10592).addRange(0x10594, 0x10595).addRange(0x10C80, 0x10CB2).addRange(0x118A0, 0x118BF).addRange(0x16E40, 0x16E5F).addRange(0x1D400, 0x1D419).addRange(0x1D434, 0x1D44D).addRange(0x1D468, 0x1D481).addRange(0x1D49E, 0x1D49F).addRange(0x1D4A5, 0x1D4A6).addRange(0x1D4A9, 0x1D4AC).addRange(0x1D4AE, 0x1D4B5).addRange(0x1D4D0, 0x1D4E9).addRange(0x1D504, 0x1D505).addRange(0x1D507, 0x1D50A).addRange(0x1D50D, 0x1D514).addRange(0x1D516, 0x1D51C).addRange(0x1D538, 0x1D539).addRange(0x1D53B, 0x1D53E).addRange(0x1D540, 0x1D544).addRange(0x1D54A, 0x1D550).addRange(0x1D56C, 0x1D585).addRange(0x1D5A0, 0x1D5B9).addRange(0x1D5D4, 0x1D5ED).addRange(0x1D608, 0x1D621).addRange(0x1D63C, 0x1D655).addRange(0x1D670, 0x1D689).addRange(0x1D6A8, 0x1D6C0).addRange(0x1D6E2, 0x1D6FA).addRange(0x1D71C, 0x1D734).addRange(0x1D756, 0x1D76E).addRange(0x1D790, 0x1D7A8).addRange(0x1E900, 0x1E921).addRange(0x1F130, 0x1F149).addRange(0x1F150, 0x1F169).addRange(0x1F170, 0x1F189);
		    Uppercase.characters = set;
		    return Uppercase;
		  }

		  var Variation_Selector = {};

		  var hasRequiredVariation_Selector;
		  function requireVariation_Selector() {
		    if (hasRequiredVariation_Selector) return Variation_Selector;
		    hasRequiredVariation_Selector = 1;
		    var set = regenerateExports(0x180F);
		    set.addRange(0x180B, 0x180D).addRange(0xFE00, 0xFE0F).addRange(0xE0100, 0xE01EF);
		    Variation_Selector.characters = set;
		    return Variation_Selector;
		  }

		  var White_Space = {};

		  var hasRequiredWhite_Space;
		  function requireWhite_Space() {
		    if (hasRequiredWhite_Space) return White_Space;
		    hasRequiredWhite_Space = 1;
		    var set = regenerateExports(0x20, 0x85, 0xA0, 0x1680, 0x202F, 0x205F, 0x3000);
		    set.addRange(0x9, 0xD).addRange(0x2000, 0x200A).addRange(0x2028, 0x2029);
		    White_Space.characters = set;
		    return White_Space;
		  }

		  var XID_Continue = {};

		  var hasRequiredXID_Continue;
		  function requireXID_Continue() {
		    if (hasRequiredXID_Continue) return XID_Continue;
		    hasRequiredXID_Continue = 1;
		    var set = regenerateExports(0x5F, 0xAA, 0xB5, 0xB7, 0xBA, 0x2EC, 0x2EE, 0x37F, 0x38C, 0x559, 0x5BF, 0x5C7, 0x6FF, 0x7FA, 0x7FD, 0x9B2, 0x9D7, 0x9FC, 0x9FE, 0xA3C, 0xA51, 0xA5E, 0xAD0, 0xB71, 0xB9C, 0xBD0, 0xBD7, 0xC5D, 0xDBD, 0xDCA, 0xDD6, 0xE84, 0xEA5, 0xEC6, 0xF00, 0xF35, 0xF37, 0xF39, 0xFC6, 0x10C7, 0x10CD, 0x1258, 0x12C0, 0x17D7, 0x1AA7, 0x1F59, 0x1F5B, 0x1F5D, 0x1FBE, 0x2054, 0x2071, 0x207F, 0x20E1, 0x2102, 0x2107, 0x2115, 0x2124, 0x2126, 0x2128, 0x214E, 0x2D27, 0x2D2D, 0x2D6F, 0xA7D3, 0xA82C, 0xA8FB, 0xFB3E, 0xFE71, 0xFE73, 0xFE77, 0xFE79, 0xFE7B, 0xFE7D, 0xFF3F, 0x101FD, 0x102E0, 0x10808, 0x1083C, 0x10A3F, 0x10F27, 0x110C2, 0x11176, 0x111DC, 0x11288, 0x11350, 0x11357, 0x114C7, 0x11644, 0x11909, 0x11A47, 0x11A9D, 0x11D3A, 0x11FB0, 0x1B132, 0x1B155, 0x1D4A2, 0x1D4BB, 0x1D546, 0x1DA75, 0x1DA84, 0x1E08F, 0x1E14E, 0x1EE24, 0x1EE27, 0x1EE39, 0x1EE3B, 0x1EE42, 0x1EE47, 0x1EE49, 0x1EE4B, 0x1EE54, 0x1EE57, 0x1EE59, 0x1EE5B, 0x1EE5D, 0x1EE5F, 0x1EE64, 0x1EE7E);
		    set.addRange(0x30, 0x39).addRange(0x41, 0x5A).addRange(0x61, 0x7A).addRange(0xC0, 0xD6).addRange(0xD8, 0xF6).addRange(0xF8, 0x2C1).addRange(0x2C6, 0x2D1).addRange(0x2E0, 0x2E4).addRange(0x300, 0x374).addRange(0x376, 0x377).addRange(0x37B, 0x37D).addRange(0x386, 0x38A).addRange(0x38E, 0x3A1).addRange(0x3A3, 0x3F5).addRange(0x3F7, 0x481).addRange(0x483, 0x487).addRange(0x48A, 0x52F).addRange(0x531, 0x556).addRange(0x560, 0x588).addRange(0x591, 0x5BD).addRange(0x5C1, 0x5C2).addRange(0x5C4, 0x5C5).addRange(0x5D0, 0x5EA).addRange(0x5EF, 0x5F2).addRange(0x610, 0x61A).addRange(0x620, 0x669).addRange(0x66E, 0x6D3).addRange(0x6D5, 0x6DC).addRange(0x6DF, 0x6E8).addRange(0x6EA, 0x6FC).addRange(0x710, 0x74A).addRange(0x74D, 0x7B1).addRange(0x7C0, 0x7F5).addRange(0x800, 0x82D).addRange(0x840, 0x85B).addRange(0x860, 0x86A).addRange(0x870, 0x887).addRange(0x889, 0x88E).addRange(0x898, 0x8E1).addRange(0x8E3, 0x963).addRange(0x966, 0x96F).addRange(0x971, 0x983).addRange(0x985, 0x98C).addRange(0x98F, 0x990).addRange(0x993, 0x9A8).addRange(0x9AA, 0x9B0).addRange(0x9B6, 0x9B9).addRange(0x9BC, 0x9C4).addRange(0x9C7, 0x9C8).addRange(0x9CB, 0x9CE).addRange(0x9DC, 0x9DD);
		    set.addRange(0x9DF, 0x9E3).addRange(0x9E6, 0x9F1).addRange(0xA01, 0xA03).addRange(0xA05, 0xA0A).addRange(0xA0F, 0xA10).addRange(0xA13, 0xA28).addRange(0xA2A, 0xA30).addRange(0xA32, 0xA33).addRange(0xA35, 0xA36).addRange(0xA38, 0xA39).addRange(0xA3E, 0xA42).addRange(0xA47, 0xA48).addRange(0xA4B, 0xA4D).addRange(0xA59, 0xA5C).addRange(0xA66, 0xA75).addRange(0xA81, 0xA83).addRange(0xA85, 0xA8D).addRange(0xA8F, 0xA91).addRange(0xA93, 0xAA8).addRange(0xAAA, 0xAB0).addRange(0xAB2, 0xAB3).addRange(0xAB5, 0xAB9).addRange(0xABC, 0xAC5).addRange(0xAC7, 0xAC9).addRange(0xACB, 0xACD).addRange(0xAE0, 0xAE3).addRange(0xAE6, 0xAEF).addRange(0xAF9, 0xAFF).addRange(0xB01, 0xB03).addRange(0xB05, 0xB0C).addRange(0xB0F, 0xB10).addRange(0xB13, 0xB28).addRange(0xB2A, 0xB30).addRange(0xB32, 0xB33).addRange(0xB35, 0xB39).addRange(0xB3C, 0xB44).addRange(0xB47, 0xB48).addRange(0xB4B, 0xB4D).addRange(0xB55, 0xB57).addRange(0xB5C, 0xB5D).addRange(0xB5F, 0xB63).addRange(0xB66, 0xB6F).addRange(0xB82, 0xB83).addRange(0xB85, 0xB8A).addRange(0xB8E, 0xB90).addRange(0xB92, 0xB95).addRange(0xB99, 0xB9A).addRange(0xB9E, 0xB9F).addRange(0xBA3, 0xBA4).addRange(0xBA8, 0xBAA).addRange(0xBAE, 0xBB9);
		    set.addRange(0xBBE, 0xBC2).addRange(0xBC6, 0xBC8).addRange(0xBCA, 0xBCD).addRange(0xBE6, 0xBEF).addRange(0xC00, 0xC0C).addRange(0xC0E, 0xC10).addRange(0xC12, 0xC28).addRange(0xC2A, 0xC39).addRange(0xC3C, 0xC44).addRange(0xC46, 0xC48).addRange(0xC4A, 0xC4D).addRange(0xC55, 0xC56).addRange(0xC58, 0xC5A).addRange(0xC60, 0xC63).addRange(0xC66, 0xC6F).addRange(0xC80, 0xC83).addRange(0xC85, 0xC8C).addRange(0xC8E, 0xC90).addRange(0xC92, 0xCA8).addRange(0xCAA, 0xCB3).addRange(0xCB5, 0xCB9).addRange(0xCBC, 0xCC4).addRange(0xCC6, 0xCC8).addRange(0xCCA, 0xCCD).addRange(0xCD5, 0xCD6).addRange(0xCDD, 0xCDE).addRange(0xCE0, 0xCE3).addRange(0xCE6, 0xCEF).addRange(0xCF1, 0xCF3).addRange(0xD00, 0xD0C).addRange(0xD0E, 0xD10).addRange(0xD12, 0xD44).addRange(0xD46, 0xD48).addRange(0xD4A, 0xD4E).addRange(0xD54, 0xD57).addRange(0xD5F, 0xD63).addRange(0xD66, 0xD6F).addRange(0xD7A, 0xD7F).addRange(0xD81, 0xD83).addRange(0xD85, 0xD96).addRange(0xD9A, 0xDB1).addRange(0xDB3, 0xDBB).addRange(0xDC0, 0xDC6).addRange(0xDCF, 0xDD4).addRange(0xDD8, 0xDDF).addRange(0xDE6, 0xDEF).addRange(0xDF2, 0xDF3).addRange(0xE01, 0xE3A).addRange(0xE40, 0xE4E).addRange(0xE50, 0xE59).addRange(0xE81, 0xE82);
		    set.addRange(0xE86, 0xE8A).addRange(0xE8C, 0xEA3).addRange(0xEA7, 0xEBD).addRange(0xEC0, 0xEC4).addRange(0xEC8, 0xECE).addRange(0xED0, 0xED9).addRange(0xEDC, 0xEDF).addRange(0xF18, 0xF19).addRange(0xF20, 0xF29).addRange(0xF3E, 0xF47).addRange(0xF49, 0xF6C).addRange(0xF71, 0xF84).addRange(0xF86, 0xF97).addRange(0xF99, 0xFBC).addRange(0x1000, 0x1049).addRange(0x1050, 0x109D).addRange(0x10A0, 0x10C5).addRange(0x10D0, 0x10FA).addRange(0x10FC, 0x1248).addRange(0x124A, 0x124D).addRange(0x1250, 0x1256).addRange(0x125A, 0x125D).addRange(0x1260, 0x1288).addRange(0x128A, 0x128D).addRange(0x1290, 0x12B0).addRange(0x12B2, 0x12B5).addRange(0x12B8, 0x12BE).addRange(0x12C2, 0x12C5).addRange(0x12C8, 0x12D6).addRange(0x12D8, 0x1310).addRange(0x1312, 0x1315).addRange(0x1318, 0x135A).addRange(0x135D, 0x135F).addRange(0x1369, 0x1371).addRange(0x1380, 0x138F).addRange(0x13A0, 0x13F5).addRange(0x13F8, 0x13FD).addRange(0x1401, 0x166C).addRange(0x166F, 0x167F).addRange(0x1681, 0x169A).addRange(0x16A0, 0x16EA).addRange(0x16EE, 0x16F8).addRange(0x1700, 0x1715).addRange(0x171F, 0x1734).addRange(0x1740, 0x1753).addRange(0x1760, 0x176C).addRange(0x176E, 0x1770).addRange(0x1772, 0x1773).addRange(0x1780, 0x17D3).addRange(0x17DC, 0x17DD).addRange(0x17E0, 0x17E9);
		    set.addRange(0x180B, 0x180D).addRange(0x180F, 0x1819).addRange(0x1820, 0x1878).addRange(0x1880, 0x18AA).addRange(0x18B0, 0x18F5).addRange(0x1900, 0x191E).addRange(0x1920, 0x192B).addRange(0x1930, 0x193B).addRange(0x1946, 0x196D).addRange(0x1970, 0x1974).addRange(0x1980, 0x19AB).addRange(0x19B0, 0x19C9).addRange(0x19D0, 0x19DA).addRange(0x1A00, 0x1A1B).addRange(0x1A20, 0x1A5E).addRange(0x1A60, 0x1A7C).addRange(0x1A7F, 0x1A89).addRange(0x1A90, 0x1A99).addRange(0x1AB0, 0x1ABD).addRange(0x1ABF, 0x1ACE).addRange(0x1B00, 0x1B4C).addRange(0x1B50, 0x1B59).addRange(0x1B6B, 0x1B73).addRange(0x1B80, 0x1BF3).addRange(0x1C00, 0x1C37).addRange(0x1C40, 0x1C49).addRange(0x1C4D, 0x1C7D).addRange(0x1C80, 0x1C88).addRange(0x1C90, 0x1CBA).addRange(0x1CBD, 0x1CBF).addRange(0x1CD0, 0x1CD2).addRange(0x1CD4, 0x1CFA).addRange(0x1D00, 0x1F15).addRange(0x1F18, 0x1F1D).addRange(0x1F20, 0x1F45).addRange(0x1F48, 0x1F4D).addRange(0x1F50, 0x1F57).addRange(0x1F5F, 0x1F7D).addRange(0x1F80, 0x1FB4).addRange(0x1FB6, 0x1FBC).addRange(0x1FC2, 0x1FC4).addRange(0x1FC6, 0x1FCC).addRange(0x1FD0, 0x1FD3).addRange(0x1FD6, 0x1FDB).addRange(0x1FE0, 0x1FEC).addRange(0x1FF2, 0x1FF4).addRange(0x1FF6, 0x1FFC).addRange(0x200C, 0x200D).addRange(0x203F, 0x2040).addRange(0x2090, 0x209C).addRange(0x20D0, 0x20DC);
		    set.addRange(0x20E5, 0x20F0).addRange(0x210A, 0x2113).addRange(0x2118, 0x211D).addRange(0x212A, 0x2139).addRange(0x213C, 0x213F).addRange(0x2145, 0x2149).addRange(0x2160, 0x2188).addRange(0x2C00, 0x2CE4).addRange(0x2CEB, 0x2CF3).addRange(0x2D00, 0x2D25).addRange(0x2D30, 0x2D67).addRange(0x2D7F, 0x2D96).addRange(0x2DA0, 0x2DA6).addRange(0x2DA8, 0x2DAE).addRange(0x2DB0, 0x2DB6).addRange(0x2DB8, 0x2DBE).addRange(0x2DC0, 0x2DC6).addRange(0x2DC8, 0x2DCE).addRange(0x2DD0, 0x2DD6).addRange(0x2DD8, 0x2DDE).addRange(0x2DE0, 0x2DFF).addRange(0x3005, 0x3007).addRange(0x3021, 0x302F).addRange(0x3031, 0x3035).addRange(0x3038, 0x303C).addRange(0x3041, 0x3096).addRange(0x3099, 0x309A).addRange(0x309D, 0x309F).addRange(0x30A1, 0x30FF).addRange(0x3105, 0x312F).addRange(0x3131, 0x318E).addRange(0x31A0, 0x31BF).addRange(0x31F0, 0x31FF).addRange(0x3400, 0x4DBF).addRange(0x4E00, 0xA48C).addRange(0xA4D0, 0xA4FD).addRange(0xA500, 0xA60C).addRange(0xA610, 0xA62B).addRange(0xA640, 0xA66F).addRange(0xA674, 0xA67D).addRange(0xA67F, 0xA6F1).addRange(0xA717, 0xA71F).addRange(0xA722, 0xA788).addRange(0xA78B, 0xA7CA).addRange(0xA7D0, 0xA7D1).addRange(0xA7D5, 0xA7D9).addRange(0xA7F2, 0xA827).addRange(0xA840, 0xA873).addRange(0xA880, 0xA8C5).addRange(0xA8D0, 0xA8D9).addRange(0xA8E0, 0xA8F7);
		    set.addRange(0xA8FD, 0xA92D).addRange(0xA930, 0xA953).addRange(0xA960, 0xA97C).addRange(0xA980, 0xA9C0).addRange(0xA9CF, 0xA9D9).addRange(0xA9E0, 0xA9FE).addRange(0xAA00, 0xAA36).addRange(0xAA40, 0xAA4D).addRange(0xAA50, 0xAA59).addRange(0xAA60, 0xAA76).addRange(0xAA7A, 0xAAC2).addRange(0xAADB, 0xAADD).addRange(0xAAE0, 0xAAEF).addRange(0xAAF2, 0xAAF6).addRange(0xAB01, 0xAB06).addRange(0xAB09, 0xAB0E).addRange(0xAB11, 0xAB16).addRange(0xAB20, 0xAB26).addRange(0xAB28, 0xAB2E).addRange(0xAB30, 0xAB5A).addRange(0xAB5C, 0xAB69).addRange(0xAB70, 0xABEA).addRange(0xABEC, 0xABED).addRange(0xABF0, 0xABF9).addRange(0xAC00, 0xD7A3).addRange(0xD7B0, 0xD7C6).addRange(0xD7CB, 0xD7FB).addRange(0xF900, 0xFA6D).addRange(0xFA70, 0xFAD9).addRange(0xFB00, 0xFB06).addRange(0xFB13, 0xFB17).addRange(0xFB1D, 0xFB28).addRange(0xFB2A, 0xFB36).addRange(0xFB38, 0xFB3C).addRange(0xFB40, 0xFB41).addRange(0xFB43, 0xFB44).addRange(0xFB46, 0xFBB1).addRange(0xFBD3, 0xFC5D).addRange(0xFC64, 0xFD3D).addRange(0xFD50, 0xFD8F).addRange(0xFD92, 0xFDC7).addRange(0xFDF0, 0xFDF9).addRange(0xFE00, 0xFE0F).addRange(0xFE20, 0xFE2F).addRange(0xFE33, 0xFE34).addRange(0xFE4D, 0xFE4F).addRange(0xFE7F, 0xFEFC).addRange(0xFF10, 0xFF19).addRange(0xFF21, 0xFF3A).addRange(0xFF41, 0xFF5A).addRange(0xFF65, 0xFFBE);
		    set.addRange(0xFFC2, 0xFFC7).addRange(0xFFCA, 0xFFCF).addRange(0xFFD2, 0xFFD7).addRange(0xFFDA, 0xFFDC).addRange(0x10000, 0x1000B).addRange(0x1000D, 0x10026).addRange(0x10028, 0x1003A).addRange(0x1003C, 0x1003D).addRange(0x1003F, 0x1004D).addRange(0x10050, 0x1005D).addRange(0x10080, 0x100FA).addRange(0x10140, 0x10174).addRange(0x10280, 0x1029C).addRange(0x102A0, 0x102D0).addRange(0x10300, 0x1031F).addRange(0x1032D, 0x1034A).addRange(0x10350, 0x1037A).addRange(0x10380, 0x1039D).addRange(0x103A0, 0x103C3).addRange(0x103C8, 0x103CF).addRange(0x103D1, 0x103D5).addRange(0x10400, 0x1049D).addRange(0x104A0, 0x104A9).addRange(0x104B0, 0x104D3).addRange(0x104D8, 0x104FB).addRange(0x10500, 0x10527).addRange(0x10530, 0x10563).addRange(0x10570, 0x1057A).addRange(0x1057C, 0x1058A).addRange(0x1058C, 0x10592).addRange(0x10594, 0x10595).addRange(0x10597, 0x105A1).addRange(0x105A3, 0x105B1).addRange(0x105B3, 0x105B9).addRange(0x105BB, 0x105BC).addRange(0x10600, 0x10736).addRange(0x10740, 0x10755).addRange(0x10760, 0x10767).addRange(0x10780, 0x10785).addRange(0x10787, 0x107B0).addRange(0x107B2, 0x107BA).addRange(0x10800, 0x10805).addRange(0x1080A, 0x10835).addRange(0x10837, 0x10838).addRange(0x1083F, 0x10855).addRange(0x10860, 0x10876).addRange(0x10880, 0x1089E).addRange(0x108E0, 0x108F2).addRange(0x108F4, 0x108F5).addRange(0x10900, 0x10915).addRange(0x10920, 0x10939);
		    set.addRange(0x10980, 0x109B7).addRange(0x109BE, 0x109BF).addRange(0x10A00, 0x10A03).addRange(0x10A05, 0x10A06).addRange(0x10A0C, 0x10A13).addRange(0x10A15, 0x10A17).addRange(0x10A19, 0x10A35).addRange(0x10A38, 0x10A3A).addRange(0x10A60, 0x10A7C).addRange(0x10A80, 0x10A9C).addRange(0x10AC0, 0x10AC7).addRange(0x10AC9, 0x10AE6).addRange(0x10B00, 0x10B35).addRange(0x10B40, 0x10B55).addRange(0x10B60, 0x10B72).addRange(0x10B80, 0x10B91).addRange(0x10C00, 0x10C48).addRange(0x10C80, 0x10CB2).addRange(0x10CC0, 0x10CF2).addRange(0x10D00, 0x10D27).addRange(0x10D30, 0x10D39).addRange(0x10E80, 0x10EA9).addRange(0x10EAB, 0x10EAC).addRange(0x10EB0, 0x10EB1).addRange(0x10EFD, 0x10F1C).addRange(0x10F30, 0x10F50).addRange(0x10F70, 0x10F85).addRange(0x10FB0, 0x10FC4).addRange(0x10FE0, 0x10FF6).addRange(0x11000, 0x11046).addRange(0x11066, 0x11075).addRange(0x1107F, 0x110BA).addRange(0x110D0, 0x110E8).addRange(0x110F0, 0x110F9).addRange(0x11100, 0x11134).addRange(0x11136, 0x1113F).addRange(0x11144, 0x11147).addRange(0x11150, 0x11173).addRange(0x11180, 0x111C4).addRange(0x111C9, 0x111CC).addRange(0x111CE, 0x111DA).addRange(0x11200, 0x11211).addRange(0x11213, 0x11237).addRange(0x1123E, 0x11241).addRange(0x11280, 0x11286).addRange(0x1128A, 0x1128D).addRange(0x1128F, 0x1129D).addRange(0x1129F, 0x112A8).addRange(0x112B0, 0x112EA).addRange(0x112F0, 0x112F9).addRange(0x11300, 0x11303);
		    set.addRange(0x11305, 0x1130C).addRange(0x1130F, 0x11310).addRange(0x11313, 0x11328).addRange(0x1132A, 0x11330).addRange(0x11332, 0x11333).addRange(0x11335, 0x11339).addRange(0x1133B, 0x11344).addRange(0x11347, 0x11348).addRange(0x1134B, 0x1134D).addRange(0x1135D, 0x11363).addRange(0x11366, 0x1136C).addRange(0x11370, 0x11374).addRange(0x11400, 0x1144A).addRange(0x11450, 0x11459).addRange(0x1145E, 0x11461).addRange(0x11480, 0x114C5).addRange(0x114D0, 0x114D9).addRange(0x11580, 0x115B5).addRange(0x115B8, 0x115C0).addRange(0x115D8, 0x115DD).addRange(0x11600, 0x11640).addRange(0x11650, 0x11659).addRange(0x11680, 0x116B8).addRange(0x116C0, 0x116C9).addRange(0x11700, 0x1171A).addRange(0x1171D, 0x1172B).addRange(0x11730, 0x11739).addRange(0x11740, 0x11746).addRange(0x11800, 0x1183A).addRange(0x118A0, 0x118E9).addRange(0x118FF, 0x11906).addRange(0x1190C, 0x11913).addRange(0x11915, 0x11916).addRange(0x11918, 0x11935).addRange(0x11937, 0x11938).addRange(0x1193B, 0x11943).addRange(0x11950, 0x11959).addRange(0x119A0, 0x119A7).addRange(0x119AA, 0x119D7).addRange(0x119DA, 0x119E1).addRange(0x119E3, 0x119E4).addRange(0x11A00, 0x11A3E).addRange(0x11A50, 0x11A99).addRange(0x11AB0, 0x11AF8).addRange(0x11C00, 0x11C08).addRange(0x11C0A, 0x11C36).addRange(0x11C38, 0x11C40).addRange(0x11C50, 0x11C59).addRange(0x11C72, 0x11C8F).addRange(0x11C92, 0x11CA7).addRange(0x11CA9, 0x11CB6);
		    set.addRange(0x11D00, 0x11D06).addRange(0x11D08, 0x11D09).addRange(0x11D0B, 0x11D36).addRange(0x11D3C, 0x11D3D).addRange(0x11D3F, 0x11D47).addRange(0x11D50, 0x11D59).addRange(0x11D60, 0x11D65).addRange(0x11D67, 0x11D68).addRange(0x11D6A, 0x11D8E).addRange(0x11D90, 0x11D91).addRange(0x11D93, 0x11D98).addRange(0x11DA0, 0x11DA9).addRange(0x11EE0, 0x11EF6).addRange(0x11F00, 0x11F10).addRange(0x11F12, 0x11F3A).addRange(0x11F3E, 0x11F42).addRange(0x11F50, 0x11F59).addRange(0x12000, 0x12399).addRange(0x12400, 0x1246E).addRange(0x12480, 0x12543).addRange(0x12F90, 0x12FF0).addRange(0x13000, 0x1342F).addRange(0x13440, 0x13455).addRange(0x14400, 0x14646).addRange(0x16800, 0x16A38).addRange(0x16A40, 0x16A5E).addRange(0x16A60, 0x16A69).addRange(0x16A70, 0x16ABE).addRange(0x16AC0, 0x16AC9).addRange(0x16AD0, 0x16AED).addRange(0x16AF0, 0x16AF4).addRange(0x16B00, 0x16B36).addRange(0x16B40, 0x16B43).addRange(0x16B50, 0x16B59).addRange(0x16B63, 0x16B77).addRange(0x16B7D, 0x16B8F).addRange(0x16E40, 0x16E7F).addRange(0x16F00, 0x16F4A).addRange(0x16F4F, 0x16F87).addRange(0x16F8F, 0x16F9F).addRange(0x16FE0, 0x16FE1).addRange(0x16FE3, 0x16FE4).addRange(0x16FF0, 0x16FF1).addRange(0x17000, 0x187F7).addRange(0x18800, 0x18CD5).addRange(0x18D00, 0x18D08).addRange(0x1AFF0, 0x1AFF3).addRange(0x1AFF5, 0x1AFFB).addRange(0x1AFFD, 0x1AFFE).addRange(0x1B000, 0x1B122).addRange(0x1B150, 0x1B152);
		    set.addRange(0x1B164, 0x1B167).addRange(0x1B170, 0x1B2FB).addRange(0x1BC00, 0x1BC6A).addRange(0x1BC70, 0x1BC7C).addRange(0x1BC80, 0x1BC88).addRange(0x1BC90, 0x1BC99).addRange(0x1BC9D, 0x1BC9E).addRange(0x1CF00, 0x1CF2D).addRange(0x1CF30, 0x1CF46).addRange(0x1D165, 0x1D169).addRange(0x1D16D, 0x1D172).addRange(0x1D17B, 0x1D182).addRange(0x1D185, 0x1D18B).addRange(0x1D1AA, 0x1D1AD).addRange(0x1D242, 0x1D244).addRange(0x1D400, 0x1D454).addRange(0x1D456, 0x1D49C).addRange(0x1D49E, 0x1D49F).addRange(0x1D4A5, 0x1D4A6).addRange(0x1D4A9, 0x1D4AC).addRange(0x1D4AE, 0x1D4B9).addRange(0x1D4BD, 0x1D4C3).addRange(0x1D4C5, 0x1D505).addRange(0x1D507, 0x1D50A).addRange(0x1D50D, 0x1D514).addRange(0x1D516, 0x1D51C).addRange(0x1D51E, 0x1D539).addRange(0x1D53B, 0x1D53E).addRange(0x1D540, 0x1D544).addRange(0x1D54A, 0x1D550).addRange(0x1D552, 0x1D6A5).addRange(0x1D6A8, 0x1D6C0).addRange(0x1D6C2, 0x1D6DA).addRange(0x1D6DC, 0x1D6FA).addRange(0x1D6FC, 0x1D714).addRange(0x1D716, 0x1D734).addRange(0x1D736, 0x1D74E).addRange(0x1D750, 0x1D76E).addRange(0x1D770, 0x1D788).addRange(0x1D78A, 0x1D7A8).addRange(0x1D7AA, 0x1D7C2).addRange(0x1D7C4, 0x1D7CB).addRange(0x1D7CE, 0x1D7FF).addRange(0x1DA00, 0x1DA36).addRange(0x1DA3B, 0x1DA6C).addRange(0x1DA9B, 0x1DA9F).addRange(0x1DAA1, 0x1DAAF).addRange(0x1DF00, 0x1DF1E).addRange(0x1DF25, 0x1DF2A).addRange(0x1E000, 0x1E006).addRange(0x1E008, 0x1E018);
		    set.addRange(0x1E01B, 0x1E021).addRange(0x1E023, 0x1E024).addRange(0x1E026, 0x1E02A).addRange(0x1E030, 0x1E06D).addRange(0x1E100, 0x1E12C).addRange(0x1E130, 0x1E13D).addRange(0x1E140, 0x1E149).addRange(0x1E290, 0x1E2AE).addRange(0x1E2C0, 0x1E2F9).addRange(0x1E4D0, 0x1E4F9).addRange(0x1E7E0, 0x1E7E6).addRange(0x1E7E8, 0x1E7EB).addRange(0x1E7ED, 0x1E7EE).addRange(0x1E7F0, 0x1E7FE).addRange(0x1E800, 0x1E8C4).addRange(0x1E8D0, 0x1E8D6).addRange(0x1E900, 0x1E94B).addRange(0x1E950, 0x1E959).addRange(0x1EE00, 0x1EE03).addRange(0x1EE05, 0x1EE1F).addRange(0x1EE21, 0x1EE22).addRange(0x1EE29, 0x1EE32).addRange(0x1EE34, 0x1EE37).addRange(0x1EE4D, 0x1EE4F).addRange(0x1EE51, 0x1EE52).addRange(0x1EE61, 0x1EE62).addRange(0x1EE67, 0x1EE6A).addRange(0x1EE6C, 0x1EE72).addRange(0x1EE74, 0x1EE77).addRange(0x1EE79, 0x1EE7C).addRange(0x1EE80, 0x1EE89).addRange(0x1EE8B, 0x1EE9B).addRange(0x1EEA1, 0x1EEA3).addRange(0x1EEA5, 0x1EEA9).addRange(0x1EEAB, 0x1EEBB).addRange(0x1FBF0, 0x1FBF9).addRange(0x20000, 0x2A6DF).addRange(0x2A700, 0x2B739).addRange(0x2B740, 0x2B81D).addRange(0x2B820, 0x2CEA1).addRange(0x2CEB0, 0x2EBE0).addRange(0x2EBF0, 0x2EE5D).addRange(0x2F800, 0x2FA1D).addRange(0x30000, 0x3134A).addRange(0x31350, 0x323AF).addRange(0xE0100, 0xE01EF);
		    XID_Continue.characters = set;
		    return XID_Continue;
		  }

		  var XID_Start = {};

		  var hasRequiredXID_Start;
		  function requireXID_Start() {
		    if (hasRequiredXID_Start) return XID_Start;
		    hasRequiredXID_Start = 1;
		    var set = regenerateExports(0xAA, 0xB5, 0xBA, 0x2EC, 0x2EE, 0x37F, 0x386, 0x38C, 0x559, 0x6D5, 0x6FF, 0x710, 0x7B1, 0x7FA, 0x81A, 0x824, 0x828, 0x93D, 0x950, 0x9B2, 0x9BD, 0x9CE, 0x9FC, 0xA5E, 0xABD, 0xAD0, 0xAF9, 0xB3D, 0xB71, 0xB83, 0xB9C, 0xBD0, 0xC3D, 0xC5D, 0xC80, 0xCBD, 0xD3D, 0xD4E, 0xDBD, 0xE32, 0xE84, 0xEA5, 0xEB2, 0xEBD, 0xEC6, 0xF00, 0x103F, 0x1061, 0x108E, 0x10C7, 0x10CD, 0x1258, 0x12C0, 0x17D7, 0x17DC, 0x18AA, 0x1AA7, 0x1CFA, 0x1F59, 0x1F5B, 0x1F5D, 0x1FBE, 0x2071, 0x207F, 0x2102, 0x2107, 0x2115, 0x2124, 0x2126, 0x2128, 0x214E, 0x2D27, 0x2D2D, 0x2D6F, 0xA7D3, 0xA8FB, 0xA9CF, 0xAA7A, 0xAAB1, 0xAAC0, 0xAAC2, 0xFB1D, 0xFB3E, 0xFE71, 0xFE73, 0xFE77, 0xFE79, 0xFE7B, 0xFE7D, 0x10808, 0x1083C, 0x10A00, 0x10F27, 0x11075, 0x11144, 0x11147, 0x11176, 0x111DA, 0x111DC, 0x11288, 0x1133D, 0x11350, 0x114C7, 0x11644, 0x116B8, 0x11909, 0x1193F, 0x11941, 0x119E1, 0x119E3, 0x11A00, 0x11A3A, 0x11A50, 0x11A9D, 0x11C40, 0x11D46, 0x11D98, 0x11F02, 0x11FB0, 0x16F50, 0x16FE3, 0x1B132, 0x1B155, 0x1D4A2, 0x1D4BB, 0x1D546, 0x1E14E, 0x1E94B, 0x1EE24, 0x1EE27, 0x1EE39, 0x1EE3B, 0x1EE42, 0x1EE47, 0x1EE49, 0x1EE4B, 0x1EE54, 0x1EE57, 0x1EE59, 0x1EE5B, 0x1EE5D, 0x1EE5F, 0x1EE64, 0x1EE7E);
		    set.addRange(0x41, 0x5A).addRange(0x61, 0x7A).addRange(0xC0, 0xD6).addRange(0xD8, 0xF6).addRange(0xF8, 0x2C1).addRange(0x2C6, 0x2D1).addRange(0x2E0, 0x2E4).addRange(0x370, 0x374).addRange(0x376, 0x377).addRange(0x37B, 0x37D).addRange(0x388, 0x38A).addRange(0x38E, 0x3A1).addRange(0x3A3, 0x3F5).addRange(0x3F7, 0x481).addRange(0x48A, 0x52F).addRange(0x531, 0x556).addRange(0x560, 0x588).addRange(0x5D0, 0x5EA).addRange(0x5EF, 0x5F2).addRange(0x620, 0x64A).addRange(0x66E, 0x66F).addRange(0x671, 0x6D3).addRange(0x6E5, 0x6E6).addRange(0x6EE, 0x6EF).addRange(0x6FA, 0x6FC).addRange(0x712, 0x72F).addRange(0x74D, 0x7A5).addRange(0x7CA, 0x7EA).addRange(0x7F4, 0x7F5).addRange(0x800, 0x815).addRange(0x840, 0x858).addRange(0x860, 0x86A).addRange(0x870, 0x887).addRange(0x889, 0x88E).addRange(0x8A0, 0x8C9).addRange(0x904, 0x939).addRange(0x958, 0x961).addRange(0x971, 0x980).addRange(0x985, 0x98C).addRange(0x98F, 0x990).addRange(0x993, 0x9A8).addRange(0x9AA, 0x9B0).addRange(0x9B6, 0x9B9).addRange(0x9DC, 0x9DD).addRange(0x9DF, 0x9E1).addRange(0x9F0, 0x9F1).addRange(0xA05, 0xA0A).addRange(0xA0F, 0xA10).addRange(0xA13, 0xA28).addRange(0xA2A, 0xA30).addRange(0xA32, 0xA33);
		    set.addRange(0xA35, 0xA36).addRange(0xA38, 0xA39).addRange(0xA59, 0xA5C).addRange(0xA72, 0xA74).addRange(0xA85, 0xA8D).addRange(0xA8F, 0xA91).addRange(0xA93, 0xAA8).addRange(0xAAA, 0xAB0).addRange(0xAB2, 0xAB3).addRange(0xAB5, 0xAB9).addRange(0xAE0, 0xAE1).addRange(0xB05, 0xB0C).addRange(0xB0F, 0xB10).addRange(0xB13, 0xB28).addRange(0xB2A, 0xB30).addRange(0xB32, 0xB33).addRange(0xB35, 0xB39).addRange(0xB5C, 0xB5D).addRange(0xB5F, 0xB61).addRange(0xB85, 0xB8A).addRange(0xB8E, 0xB90).addRange(0xB92, 0xB95).addRange(0xB99, 0xB9A).addRange(0xB9E, 0xB9F).addRange(0xBA3, 0xBA4).addRange(0xBA8, 0xBAA).addRange(0xBAE, 0xBB9).addRange(0xC05, 0xC0C).addRange(0xC0E, 0xC10).addRange(0xC12, 0xC28).addRange(0xC2A, 0xC39).addRange(0xC58, 0xC5A).addRange(0xC60, 0xC61).addRange(0xC85, 0xC8C).addRange(0xC8E, 0xC90).addRange(0xC92, 0xCA8).addRange(0xCAA, 0xCB3).addRange(0xCB5, 0xCB9).addRange(0xCDD, 0xCDE).addRange(0xCE0, 0xCE1).addRange(0xCF1, 0xCF2).addRange(0xD04, 0xD0C).addRange(0xD0E, 0xD10).addRange(0xD12, 0xD3A).addRange(0xD54, 0xD56).addRange(0xD5F, 0xD61).addRange(0xD7A, 0xD7F).addRange(0xD85, 0xD96).addRange(0xD9A, 0xDB1).addRange(0xDB3, 0xDBB).addRange(0xDC0, 0xDC6);
		    set.addRange(0xE01, 0xE30).addRange(0xE40, 0xE46).addRange(0xE81, 0xE82).addRange(0xE86, 0xE8A).addRange(0xE8C, 0xEA3).addRange(0xEA7, 0xEB0).addRange(0xEC0, 0xEC4).addRange(0xEDC, 0xEDF).addRange(0xF40, 0xF47).addRange(0xF49, 0xF6C).addRange(0xF88, 0xF8C).addRange(0x1000, 0x102A).addRange(0x1050, 0x1055).addRange(0x105A, 0x105D).addRange(0x1065, 0x1066).addRange(0x106E, 0x1070).addRange(0x1075, 0x1081).addRange(0x10A0, 0x10C5).addRange(0x10D0, 0x10FA).addRange(0x10FC, 0x1248).addRange(0x124A, 0x124D).addRange(0x1250, 0x1256).addRange(0x125A, 0x125D).addRange(0x1260, 0x1288).addRange(0x128A, 0x128D).addRange(0x1290, 0x12B0).addRange(0x12B2, 0x12B5).addRange(0x12B8, 0x12BE).addRange(0x12C2, 0x12C5).addRange(0x12C8, 0x12D6).addRange(0x12D8, 0x1310).addRange(0x1312, 0x1315).addRange(0x1318, 0x135A).addRange(0x1380, 0x138F).addRange(0x13A0, 0x13F5).addRange(0x13F8, 0x13FD).addRange(0x1401, 0x166C).addRange(0x166F, 0x167F).addRange(0x1681, 0x169A).addRange(0x16A0, 0x16EA).addRange(0x16EE, 0x16F8).addRange(0x1700, 0x1711).addRange(0x171F, 0x1731).addRange(0x1740, 0x1751).addRange(0x1760, 0x176C).addRange(0x176E, 0x1770).addRange(0x1780, 0x17B3).addRange(0x1820, 0x1878).addRange(0x1880, 0x18A8).addRange(0x18B0, 0x18F5).addRange(0x1900, 0x191E);
		    set.addRange(0x1950, 0x196D).addRange(0x1970, 0x1974).addRange(0x1980, 0x19AB).addRange(0x19B0, 0x19C9).addRange(0x1A00, 0x1A16).addRange(0x1A20, 0x1A54).addRange(0x1B05, 0x1B33).addRange(0x1B45, 0x1B4C).addRange(0x1B83, 0x1BA0).addRange(0x1BAE, 0x1BAF).addRange(0x1BBA, 0x1BE5).addRange(0x1C00, 0x1C23).addRange(0x1C4D, 0x1C4F).addRange(0x1C5A, 0x1C7D).addRange(0x1C80, 0x1C88).addRange(0x1C90, 0x1CBA).addRange(0x1CBD, 0x1CBF).addRange(0x1CE9, 0x1CEC).addRange(0x1CEE, 0x1CF3).addRange(0x1CF5, 0x1CF6).addRange(0x1D00, 0x1DBF).addRange(0x1E00, 0x1F15).addRange(0x1F18, 0x1F1D).addRange(0x1F20, 0x1F45).addRange(0x1F48, 0x1F4D).addRange(0x1F50, 0x1F57).addRange(0x1F5F, 0x1F7D).addRange(0x1F80, 0x1FB4).addRange(0x1FB6, 0x1FBC).addRange(0x1FC2, 0x1FC4).addRange(0x1FC6, 0x1FCC).addRange(0x1FD0, 0x1FD3).addRange(0x1FD6, 0x1FDB).addRange(0x1FE0, 0x1FEC).addRange(0x1FF2, 0x1FF4).addRange(0x1FF6, 0x1FFC).addRange(0x2090, 0x209C).addRange(0x210A, 0x2113).addRange(0x2118, 0x211D).addRange(0x212A, 0x2139).addRange(0x213C, 0x213F).addRange(0x2145, 0x2149).addRange(0x2160, 0x2188).addRange(0x2C00, 0x2CE4).addRange(0x2CEB, 0x2CEE).addRange(0x2CF2, 0x2CF3).addRange(0x2D00, 0x2D25).addRange(0x2D30, 0x2D67).addRange(0x2D80, 0x2D96).addRange(0x2DA0, 0x2DA6).addRange(0x2DA8, 0x2DAE);
		    set.addRange(0x2DB0, 0x2DB6).addRange(0x2DB8, 0x2DBE).addRange(0x2DC0, 0x2DC6).addRange(0x2DC8, 0x2DCE).addRange(0x2DD0, 0x2DD6).addRange(0x2DD8, 0x2DDE).addRange(0x3005, 0x3007).addRange(0x3021, 0x3029).addRange(0x3031, 0x3035).addRange(0x3038, 0x303C).addRange(0x3041, 0x3096).addRange(0x309D, 0x309F).addRange(0x30A1, 0x30FA).addRange(0x30FC, 0x30FF).addRange(0x3105, 0x312F).addRange(0x3131, 0x318E).addRange(0x31A0, 0x31BF).addRange(0x31F0, 0x31FF).addRange(0x3400, 0x4DBF).addRange(0x4E00, 0xA48C).addRange(0xA4D0, 0xA4FD).addRange(0xA500, 0xA60C).addRange(0xA610, 0xA61F).addRange(0xA62A, 0xA62B).addRange(0xA640, 0xA66E).addRange(0xA67F, 0xA69D).addRange(0xA6A0, 0xA6EF).addRange(0xA717, 0xA71F).addRange(0xA722, 0xA788).addRange(0xA78B, 0xA7CA).addRange(0xA7D0, 0xA7D1).addRange(0xA7D5, 0xA7D9).addRange(0xA7F2, 0xA801).addRange(0xA803, 0xA805).addRange(0xA807, 0xA80A).addRange(0xA80C, 0xA822).addRange(0xA840, 0xA873).addRange(0xA882, 0xA8B3).addRange(0xA8F2, 0xA8F7).addRange(0xA8FD, 0xA8FE).addRange(0xA90A, 0xA925).addRange(0xA930, 0xA946).addRange(0xA960, 0xA97C).addRange(0xA984, 0xA9B2).addRange(0xA9E0, 0xA9E4).addRange(0xA9E6, 0xA9EF).addRange(0xA9FA, 0xA9FE).addRange(0xAA00, 0xAA28).addRange(0xAA40, 0xAA42).addRange(0xAA44, 0xAA4B).addRange(0xAA60, 0xAA76);
		    set.addRange(0xAA7E, 0xAAAF).addRange(0xAAB5, 0xAAB6).addRange(0xAAB9, 0xAABD).addRange(0xAADB, 0xAADD).addRange(0xAAE0, 0xAAEA).addRange(0xAAF2, 0xAAF4).addRange(0xAB01, 0xAB06).addRange(0xAB09, 0xAB0E).addRange(0xAB11, 0xAB16).addRange(0xAB20, 0xAB26).addRange(0xAB28, 0xAB2E).addRange(0xAB30, 0xAB5A).addRange(0xAB5C, 0xAB69).addRange(0xAB70, 0xABE2).addRange(0xAC00, 0xD7A3).addRange(0xD7B0, 0xD7C6).addRange(0xD7CB, 0xD7FB).addRange(0xF900, 0xFA6D).addRange(0xFA70, 0xFAD9).addRange(0xFB00, 0xFB06).addRange(0xFB13, 0xFB17).addRange(0xFB1F, 0xFB28).addRange(0xFB2A, 0xFB36).addRange(0xFB38, 0xFB3C).addRange(0xFB40, 0xFB41).addRange(0xFB43, 0xFB44).addRange(0xFB46, 0xFBB1).addRange(0xFBD3, 0xFC5D).addRange(0xFC64, 0xFD3D).addRange(0xFD50, 0xFD8F).addRange(0xFD92, 0xFDC7).addRange(0xFDF0, 0xFDF9).addRange(0xFE7F, 0xFEFC).addRange(0xFF21, 0xFF3A).addRange(0xFF41, 0xFF5A).addRange(0xFF66, 0xFF9D).addRange(0xFFA0, 0xFFBE).addRange(0xFFC2, 0xFFC7).addRange(0xFFCA, 0xFFCF).addRange(0xFFD2, 0xFFD7).addRange(0xFFDA, 0xFFDC).addRange(0x10000, 0x1000B).addRange(0x1000D, 0x10026).addRange(0x10028, 0x1003A).addRange(0x1003C, 0x1003D).addRange(0x1003F, 0x1004D).addRange(0x10050, 0x1005D).addRange(0x10080, 0x100FA).addRange(0x10140, 0x10174).addRange(0x10280, 0x1029C).addRange(0x102A0, 0x102D0);
		    set.addRange(0x10300, 0x1031F).addRange(0x1032D, 0x1034A).addRange(0x10350, 0x10375).addRange(0x10380, 0x1039D).addRange(0x103A0, 0x103C3).addRange(0x103C8, 0x103CF).addRange(0x103D1, 0x103D5).addRange(0x10400, 0x1049D).addRange(0x104B0, 0x104D3).addRange(0x104D8, 0x104FB).addRange(0x10500, 0x10527).addRange(0x10530, 0x10563).addRange(0x10570, 0x1057A).addRange(0x1057C, 0x1058A).addRange(0x1058C, 0x10592).addRange(0x10594, 0x10595).addRange(0x10597, 0x105A1).addRange(0x105A3, 0x105B1).addRange(0x105B3, 0x105B9).addRange(0x105BB, 0x105BC).addRange(0x10600, 0x10736).addRange(0x10740, 0x10755).addRange(0x10760, 0x10767).addRange(0x10780, 0x10785).addRange(0x10787, 0x107B0).addRange(0x107B2, 0x107BA).addRange(0x10800, 0x10805).addRange(0x1080A, 0x10835).addRange(0x10837, 0x10838).addRange(0x1083F, 0x10855).addRange(0x10860, 0x10876).addRange(0x10880, 0x1089E).addRange(0x108E0, 0x108F2).addRange(0x108F4, 0x108F5).addRange(0x10900, 0x10915).addRange(0x10920, 0x10939).addRange(0x10980, 0x109B7).addRange(0x109BE, 0x109BF).addRange(0x10A10, 0x10A13).addRange(0x10A15, 0x10A17).addRange(0x10A19, 0x10A35).addRange(0x10A60, 0x10A7C).addRange(0x10A80, 0x10A9C).addRange(0x10AC0, 0x10AC7).addRange(0x10AC9, 0x10AE4).addRange(0x10B00, 0x10B35).addRange(0x10B40, 0x10B55).addRange(0x10B60, 0x10B72).addRange(0x10B80, 0x10B91).addRange(0x10C00, 0x10C48).addRange(0x10C80, 0x10CB2);
		    set.addRange(0x10CC0, 0x10CF2).addRange(0x10D00, 0x10D23).addRange(0x10E80, 0x10EA9).addRange(0x10EB0, 0x10EB1).addRange(0x10F00, 0x10F1C).addRange(0x10F30, 0x10F45).addRange(0x10F70, 0x10F81).addRange(0x10FB0, 0x10FC4).addRange(0x10FE0, 0x10FF6).addRange(0x11003, 0x11037).addRange(0x11071, 0x11072).addRange(0x11083, 0x110AF).addRange(0x110D0, 0x110E8).addRange(0x11103, 0x11126).addRange(0x11150, 0x11172).addRange(0x11183, 0x111B2).addRange(0x111C1, 0x111C4).addRange(0x11200, 0x11211).addRange(0x11213, 0x1122B).addRange(0x1123F, 0x11240).addRange(0x11280, 0x11286).addRange(0x1128A, 0x1128D).addRange(0x1128F, 0x1129D).addRange(0x1129F, 0x112A8).addRange(0x112B0, 0x112DE).addRange(0x11305, 0x1130C).addRange(0x1130F, 0x11310).addRange(0x11313, 0x11328).addRange(0x1132A, 0x11330).addRange(0x11332, 0x11333).addRange(0x11335, 0x11339).addRange(0x1135D, 0x11361).addRange(0x11400, 0x11434).addRange(0x11447, 0x1144A).addRange(0x1145F, 0x11461).addRange(0x11480, 0x114AF).addRange(0x114C4, 0x114C5).addRange(0x11580, 0x115AE).addRange(0x115D8, 0x115DB).addRange(0x11600, 0x1162F).addRange(0x11680, 0x116AA).addRange(0x11700, 0x1171A).addRange(0x11740, 0x11746).addRange(0x11800, 0x1182B).addRange(0x118A0, 0x118DF).addRange(0x118FF, 0x11906).addRange(0x1190C, 0x11913).addRange(0x11915, 0x11916).addRange(0x11918, 0x1192F).addRange(0x119A0, 0x119A7).addRange(0x119AA, 0x119D0);
		    set.addRange(0x11A0B, 0x11A32).addRange(0x11A5C, 0x11A89).addRange(0x11AB0, 0x11AF8).addRange(0x11C00, 0x11C08).addRange(0x11C0A, 0x11C2E).addRange(0x11C72, 0x11C8F).addRange(0x11D00, 0x11D06).addRange(0x11D08, 0x11D09).addRange(0x11D0B, 0x11D30).addRange(0x11D60, 0x11D65).addRange(0x11D67, 0x11D68).addRange(0x11D6A, 0x11D89).addRange(0x11EE0, 0x11EF2).addRange(0x11F04, 0x11F10).addRange(0x11F12, 0x11F33).addRange(0x12000, 0x12399).addRange(0x12400, 0x1246E).addRange(0x12480, 0x12543).addRange(0x12F90, 0x12FF0).addRange(0x13000, 0x1342F).addRange(0x13441, 0x13446).addRange(0x14400, 0x14646).addRange(0x16800, 0x16A38).addRange(0x16A40, 0x16A5E).addRange(0x16A70, 0x16ABE).addRange(0x16AD0, 0x16AED).addRange(0x16B00, 0x16B2F).addRange(0x16B40, 0x16B43).addRange(0x16B63, 0x16B77).addRange(0x16B7D, 0x16B8F).addRange(0x16E40, 0x16E7F).addRange(0x16F00, 0x16F4A).addRange(0x16F93, 0x16F9F).addRange(0x16FE0, 0x16FE1).addRange(0x17000, 0x187F7).addRange(0x18800, 0x18CD5).addRange(0x18D00, 0x18D08).addRange(0x1AFF0, 0x1AFF3).addRange(0x1AFF5, 0x1AFFB).addRange(0x1AFFD, 0x1AFFE).addRange(0x1B000, 0x1B122).addRange(0x1B150, 0x1B152).addRange(0x1B164, 0x1B167).addRange(0x1B170, 0x1B2FB).addRange(0x1BC00, 0x1BC6A).addRange(0x1BC70, 0x1BC7C).addRange(0x1BC80, 0x1BC88).addRange(0x1BC90, 0x1BC99).addRange(0x1D400, 0x1D454).addRange(0x1D456, 0x1D49C).addRange(0x1D49E, 0x1D49F);
		    set.addRange(0x1D4A5, 0x1D4A6).addRange(0x1D4A9, 0x1D4AC).addRange(0x1D4AE, 0x1D4B9).addRange(0x1D4BD, 0x1D4C3).addRange(0x1D4C5, 0x1D505).addRange(0x1D507, 0x1D50A).addRange(0x1D50D, 0x1D514).addRange(0x1D516, 0x1D51C).addRange(0x1D51E, 0x1D539).addRange(0x1D53B, 0x1D53E).addRange(0x1D540, 0x1D544).addRange(0x1D54A, 0x1D550).addRange(0x1D552, 0x1D6A5).addRange(0x1D6A8, 0x1D6C0).addRange(0x1D6C2, 0x1D6DA).addRange(0x1D6DC, 0x1D6FA).addRange(0x1D6FC, 0x1D714).addRange(0x1D716, 0x1D734).addRange(0x1D736, 0x1D74E).addRange(0x1D750, 0x1D76E).addRange(0x1D770, 0x1D788).addRange(0x1D78A, 0x1D7A8).addRange(0x1D7AA, 0x1D7C2).addRange(0x1D7C4, 0x1D7CB).addRange(0x1DF00, 0x1DF1E).addRange(0x1DF25, 0x1DF2A).addRange(0x1E030, 0x1E06D).addRange(0x1E100, 0x1E12C).addRange(0x1E137, 0x1E13D).addRange(0x1E290, 0x1E2AD).addRange(0x1E2C0, 0x1E2EB).addRange(0x1E4D0, 0x1E4EB).addRange(0x1E7E0, 0x1E7E6).addRange(0x1E7E8, 0x1E7EB).addRange(0x1E7ED, 0x1E7EE).addRange(0x1E7F0, 0x1E7FE).addRange(0x1E800, 0x1E8C4).addRange(0x1E900, 0x1E943).addRange(0x1EE00, 0x1EE03).addRange(0x1EE05, 0x1EE1F).addRange(0x1EE21, 0x1EE22).addRange(0x1EE29, 0x1EE32).addRange(0x1EE34, 0x1EE37).addRange(0x1EE4D, 0x1EE4F).addRange(0x1EE51, 0x1EE52).addRange(0x1EE61, 0x1EE62).addRange(0x1EE67, 0x1EE6A).addRange(0x1EE6C, 0x1EE72).addRange(0x1EE74, 0x1EE77).addRange(0x1EE79, 0x1EE7C).addRange(0x1EE80, 0x1EE89);
		    set.addRange(0x1EE8B, 0x1EE9B).addRange(0x1EEA1, 0x1EEA3).addRange(0x1EEA5, 0x1EEA9).addRange(0x1EEAB, 0x1EEBB).addRange(0x20000, 0x2A6DF).addRange(0x2A700, 0x2B739).addRange(0x2B740, 0x2B81D).addRange(0x2B820, 0x2CEA1).addRange(0x2CEB0, 0x2EBE0).addRange(0x2EBF0, 0x2EE5D).addRange(0x2F800, 0x2FA1D).addRange(0x30000, 0x3134A).addRange(0x31350, 0x323AF);
		    XID_Start.characters = set;
		    return XID_Start;
		  }

		  var Cased_Letter = {};

		  var hasRequiredCased_Letter;
		  function requireCased_Letter() {
		    if (hasRequiredCased_Letter) return Cased_Letter;
		    hasRequiredCased_Letter = 1;
		    var set = regenerateExports(0xB5, 0x37F, 0x386, 0x38C, 0x10C7, 0x10CD, 0x1F59, 0x1F5B, 0x1F5D, 0x1FBE, 0x2102, 0x2107, 0x2115, 0x2124, 0x2126, 0x2128, 0x2139, 0x214E, 0x2D27, 0x2D2D, 0xA7D3, 0xA7FA, 0x1D4A2, 0x1D4BB, 0x1D546);
		    set.addRange(0x41, 0x5A).addRange(0x61, 0x7A).addRange(0xC0, 0xD6).addRange(0xD8, 0xF6).addRange(0xF8, 0x1BA).addRange(0x1BC, 0x1BF).addRange(0x1C4, 0x293).addRange(0x295, 0x2AF).addRange(0x370, 0x373).addRange(0x376, 0x377).addRange(0x37B, 0x37D).addRange(0x388, 0x38A).addRange(0x38E, 0x3A1).addRange(0x3A3, 0x3F5).addRange(0x3F7, 0x481).addRange(0x48A, 0x52F).addRange(0x531, 0x556).addRange(0x560, 0x588).addRange(0x10A0, 0x10C5).addRange(0x10D0, 0x10FA).addRange(0x10FD, 0x10FF).addRange(0x13A0, 0x13F5).addRange(0x13F8, 0x13FD).addRange(0x1C80, 0x1C88).addRange(0x1C90, 0x1CBA).addRange(0x1CBD, 0x1CBF).addRange(0x1D00, 0x1D2B).addRange(0x1D6B, 0x1D77).addRange(0x1D79, 0x1D9A).addRange(0x1E00, 0x1F15).addRange(0x1F18, 0x1F1D).addRange(0x1F20, 0x1F45).addRange(0x1F48, 0x1F4D).addRange(0x1F50, 0x1F57).addRange(0x1F5F, 0x1F7D).addRange(0x1F80, 0x1FB4).addRange(0x1FB6, 0x1FBC).addRange(0x1FC2, 0x1FC4).addRange(0x1FC6, 0x1FCC).addRange(0x1FD0, 0x1FD3).addRange(0x1FD6, 0x1FDB).addRange(0x1FE0, 0x1FEC).addRange(0x1FF2, 0x1FF4).addRange(0x1FF6, 0x1FFC).addRange(0x210A, 0x2113).addRange(0x2119, 0x211D).addRange(0x212A, 0x212D).addRange(0x212F, 0x2134).addRange(0x213C, 0x213F).addRange(0x2145, 0x2149).addRange(0x2183, 0x2184);
		    set.addRange(0x2C00, 0x2C7B).addRange(0x2C7E, 0x2CE4).addRange(0x2CEB, 0x2CEE).addRange(0x2CF2, 0x2CF3).addRange(0x2D00, 0x2D25).addRange(0xA640, 0xA66D).addRange(0xA680, 0xA69B).addRange(0xA722, 0xA76F).addRange(0xA771, 0xA787).addRange(0xA78B, 0xA78E).addRange(0xA790, 0xA7CA).addRange(0xA7D0, 0xA7D1).addRange(0xA7D5, 0xA7D9).addRange(0xA7F5, 0xA7F6).addRange(0xAB30, 0xAB5A).addRange(0xAB60, 0xAB68).addRange(0xAB70, 0xABBF).addRange(0xFB00, 0xFB06).addRange(0xFB13, 0xFB17).addRange(0xFF21, 0xFF3A).addRange(0xFF41, 0xFF5A).addRange(0x10400, 0x1044F).addRange(0x104B0, 0x104D3).addRange(0x104D8, 0x104FB).addRange(0x10570, 0x1057A).addRange(0x1057C, 0x1058A).addRange(0x1058C, 0x10592).addRange(0x10594, 0x10595).addRange(0x10597, 0x105A1).addRange(0x105A3, 0x105B1).addRange(0x105B3, 0x105B9).addRange(0x105BB, 0x105BC).addRange(0x10C80, 0x10CB2).addRange(0x10CC0, 0x10CF2).addRange(0x118A0, 0x118DF).addRange(0x16E40, 0x16E7F).addRange(0x1D400, 0x1D454).addRange(0x1D456, 0x1D49C).addRange(0x1D49E, 0x1D49F).addRange(0x1D4A5, 0x1D4A6).addRange(0x1D4A9, 0x1D4AC).addRange(0x1D4AE, 0x1D4B9).addRange(0x1D4BD, 0x1D4C3).addRange(0x1D4C5, 0x1D505).addRange(0x1D507, 0x1D50A).addRange(0x1D50D, 0x1D514).addRange(0x1D516, 0x1D51C).addRange(0x1D51E, 0x1D539).addRange(0x1D53B, 0x1D53E).addRange(0x1D540, 0x1D544).addRange(0x1D54A, 0x1D550);
		    set.addRange(0x1D552, 0x1D6A5).addRange(0x1D6A8, 0x1D6C0).addRange(0x1D6C2, 0x1D6DA).addRange(0x1D6DC, 0x1D6FA).addRange(0x1D6FC, 0x1D714).addRange(0x1D716, 0x1D734).addRange(0x1D736, 0x1D74E).addRange(0x1D750, 0x1D76E).addRange(0x1D770, 0x1D788).addRange(0x1D78A, 0x1D7A8).addRange(0x1D7AA, 0x1D7C2).addRange(0x1D7C4, 0x1D7CB).addRange(0x1DF00, 0x1DF09).addRange(0x1DF0B, 0x1DF1E).addRange(0x1DF25, 0x1DF2A).addRange(0x1E900, 0x1E943);
		    Cased_Letter.characters = set;
		    return Cased_Letter;
		  }

		  var Close_Punctuation = {};

		  var hasRequiredClose_Punctuation;
		  function requireClose_Punctuation() {
		    if (hasRequiredClose_Punctuation) return Close_Punctuation;
		    hasRequiredClose_Punctuation = 1;
		    var set = regenerateExports(0x29, 0x5D, 0x7D, 0xF3B, 0xF3D, 0x169C, 0x2046, 0x207E, 0x208E, 0x2309, 0x230B, 0x232A, 0x2769, 0x276B, 0x276D, 0x276F, 0x2771, 0x2773, 0x2775, 0x27C6, 0x27E7, 0x27E9, 0x27EB, 0x27ED, 0x27EF, 0x2984, 0x2986, 0x2988, 0x298A, 0x298C, 0x298E, 0x2990, 0x2992, 0x2994, 0x2996, 0x2998, 0x29D9, 0x29DB, 0x29FD, 0x2E23, 0x2E25, 0x2E27, 0x2E29, 0x2E56, 0x2E58, 0x2E5A, 0x2E5C, 0x3009, 0x300B, 0x300D, 0x300F, 0x3011, 0x3015, 0x3017, 0x3019, 0x301B, 0xFD3E, 0xFE18, 0xFE36, 0xFE38, 0xFE3A, 0xFE3C, 0xFE3E, 0xFE40, 0xFE42, 0xFE44, 0xFE48, 0xFE5A, 0xFE5C, 0xFE5E, 0xFF09, 0xFF3D, 0xFF5D, 0xFF60, 0xFF63);
		    set.addRange(0x301E, 0x301F);
		    Close_Punctuation.characters = set;
		    return Close_Punctuation;
		  }

		  var Connector_Punctuation = {};

		  var hasRequiredConnector_Punctuation;
		  function requireConnector_Punctuation() {
		    if (hasRequiredConnector_Punctuation) return Connector_Punctuation;
		    hasRequiredConnector_Punctuation = 1;
		    var set = regenerateExports(0x5F, 0x2054, 0xFF3F);
		    set.addRange(0x203F, 0x2040).addRange(0xFE33, 0xFE34).addRange(0xFE4D, 0xFE4F);
		    Connector_Punctuation.characters = set;
		    return Connector_Punctuation;
		  }

		  var Control = {};

		  var hasRequiredControl;
		  function requireControl() {
		    if (hasRequiredControl) return Control;
		    hasRequiredControl = 1;
		    var set = regenerateExports();
		    set.addRange(0x0, 0x1F).addRange(0x7F, 0x9F);
		    Control.characters = set;
		    return Control;
		  }

		  var Currency_Symbol = {};

		  var hasRequiredCurrency_Symbol;
		  function requireCurrency_Symbol() {
		    if (hasRequiredCurrency_Symbol) return Currency_Symbol;
		    hasRequiredCurrency_Symbol = 1;
		    var set = regenerateExports(0x24, 0x58F, 0x60B, 0x9FB, 0xAF1, 0xBF9, 0xE3F, 0x17DB, 0xA838, 0xFDFC, 0xFE69, 0xFF04, 0x1E2FF, 0x1ECB0);
		    set.addRange(0xA2, 0xA5).addRange(0x7FE, 0x7FF).addRange(0x9F2, 0x9F3).addRange(0x20A0, 0x20C0).addRange(0xFFE0, 0xFFE1).addRange(0xFFE5, 0xFFE6).addRange(0x11FDD, 0x11FE0);
		    Currency_Symbol.characters = set;
		    return Currency_Symbol;
		  }

		  var Dash_Punctuation = {};

		  var hasRequiredDash_Punctuation;
		  function requireDash_Punctuation() {
		    if (hasRequiredDash_Punctuation) return Dash_Punctuation;
		    hasRequiredDash_Punctuation = 1;
		    var set = regenerateExports(0x2D, 0x58A, 0x5BE, 0x1400, 0x1806, 0x2E17, 0x2E1A, 0x2E40, 0x2E5D, 0x301C, 0x3030, 0x30A0, 0xFE58, 0xFE63, 0xFF0D, 0x10EAD);
		    set.addRange(0x2010, 0x2015).addRange(0x2E3A, 0x2E3B).addRange(0xFE31, 0xFE32);
		    Dash_Punctuation.characters = set;
		    return Dash_Punctuation;
		  }

		  var Decimal_Number = {};

		  var hasRequiredDecimal_Number;
		  function requireDecimal_Number() {
		    if (hasRequiredDecimal_Number) return Decimal_Number;
		    hasRequiredDecimal_Number = 1;
		    var set = regenerateExports();
		    set.addRange(0x30, 0x39).addRange(0x660, 0x669).addRange(0x6F0, 0x6F9).addRange(0x7C0, 0x7C9).addRange(0x966, 0x96F).addRange(0x9E6, 0x9EF).addRange(0xA66, 0xA6F).addRange(0xAE6, 0xAEF).addRange(0xB66, 0xB6F).addRange(0xBE6, 0xBEF).addRange(0xC66, 0xC6F).addRange(0xCE6, 0xCEF).addRange(0xD66, 0xD6F).addRange(0xDE6, 0xDEF).addRange(0xE50, 0xE59).addRange(0xED0, 0xED9).addRange(0xF20, 0xF29).addRange(0x1040, 0x1049).addRange(0x1090, 0x1099).addRange(0x17E0, 0x17E9).addRange(0x1810, 0x1819).addRange(0x1946, 0x194F).addRange(0x19D0, 0x19D9).addRange(0x1A80, 0x1A89).addRange(0x1A90, 0x1A99).addRange(0x1B50, 0x1B59).addRange(0x1BB0, 0x1BB9).addRange(0x1C40, 0x1C49).addRange(0x1C50, 0x1C59).addRange(0xA620, 0xA629).addRange(0xA8D0, 0xA8D9).addRange(0xA900, 0xA909).addRange(0xA9D0, 0xA9D9).addRange(0xA9F0, 0xA9F9).addRange(0xAA50, 0xAA59).addRange(0xABF0, 0xABF9).addRange(0xFF10, 0xFF19).addRange(0x104A0, 0x104A9).addRange(0x10D30, 0x10D39).addRange(0x11066, 0x1106F).addRange(0x110F0, 0x110F9).addRange(0x11136, 0x1113F).addRange(0x111D0, 0x111D9).addRange(0x112F0, 0x112F9).addRange(0x11450, 0x11459).addRange(0x114D0, 0x114D9).addRange(0x11650, 0x11659).addRange(0x116C0, 0x116C9).addRange(0x11730, 0x11739).addRange(0x118E0, 0x118E9).addRange(0x11950, 0x11959);
		    set.addRange(0x11C50, 0x11C59).addRange(0x11D50, 0x11D59).addRange(0x11DA0, 0x11DA9).addRange(0x11F50, 0x11F59).addRange(0x16A60, 0x16A69).addRange(0x16AC0, 0x16AC9).addRange(0x16B50, 0x16B59).addRange(0x1D7CE, 0x1D7FF).addRange(0x1E140, 0x1E149).addRange(0x1E2F0, 0x1E2F9).addRange(0x1E4F0, 0x1E4F9).addRange(0x1E950, 0x1E959).addRange(0x1FBF0, 0x1FBF9);
		    Decimal_Number.characters = set;
		    return Decimal_Number;
		  }

		  var Enclosing_Mark = {};

		  var hasRequiredEnclosing_Mark;
		  function requireEnclosing_Mark() {
		    if (hasRequiredEnclosing_Mark) return Enclosing_Mark;
		    hasRequiredEnclosing_Mark = 1;
		    var set = regenerateExports(0x1ABE);
		    set.addRange(0x488, 0x489).addRange(0x20DD, 0x20E0).addRange(0x20E2, 0x20E4).addRange(0xA670, 0xA672);
		    Enclosing_Mark.characters = set;
		    return Enclosing_Mark;
		  }

		  var Final_Punctuation = {};

		  var hasRequiredFinal_Punctuation;
		  function requireFinal_Punctuation() {
		    if (hasRequiredFinal_Punctuation) return Final_Punctuation;
		    hasRequiredFinal_Punctuation = 1;
		    var set = regenerateExports(0xBB, 0x2019, 0x201D, 0x203A, 0x2E03, 0x2E05, 0x2E0A, 0x2E0D, 0x2E1D, 0x2E21);
		    Final_Punctuation.characters = set;
		    return Final_Punctuation;
		  }

		  var Format = {};

		  var hasRequiredFormat;
		  function requireFormat() {
		    if (hasRequiredFormat) return Format;
		    hasRequiredFormat = 1;
		    var set = regenerateExports(0xAD, 0x61C, 0x6DD, 0x70F, 0x8E2, 0x180E, 0xFEFF, 0x110BD, 0x110CD, 0xE0001);
		    set.addRange(0x600, 0x605).addRange(0x890, 0x891).addRange(0x200B, 0x200F).addRange(0x202A, 0x202E).addRange(0x2060, 0x2064).addRange(0x2066, 0x206F).addRange(0xFFF9, 0xFFFB).addRange(0x13430, 0x1343F).addRange(0x1BCA0, 0x1BCA3).addRange(0x1D173, 0x1D17A).addRange(0xE0020, 0xE007F);
		    Format.characters = set;
		    return Format;
		  }

		  var Initial_Punctuation = {};

		  var hasRequiredInitial_Punctuation;
		  function requireInitial_Punctuation() {
		    if (hasRequiredInitial_Punctuation) return Initial_Punctuation;
		    hasRequiredInitial_Punctuation = 1;
		    var set = regenerateExports(0xAB, 0x2018, 0x201F, 0x2039, 0x2E02, 0x2E04, 0x2E09, 0x2E0C, 0x2E1C, 0x2E20);
		    set.addRange(0x201B, 0x201C);
		    Initial_Punctuation.characters = set;
		    return Initial_Punctuation;
		  }

		  var Letter_Number = {};

		  var hasRequiredLetter_Number;
		  function requireLetter_Number() {
		    if (hasRequiredLetter_Number) return Letter_Number;
		    hasRequiredLetter_Number = 1;
		    var set = regenerateExports(0x3007, 0x10341, 0x1034A);
		    set.addRange(0x16EE, 0x16F0).addRange(0x2160, 0x2182).addRange(0x2185, 0x2188).addRange(0x3021, 0x3029).addRange(0x3038, 0x303A).addRange(0xA6E6, 0xA6EF).addRange(0x10140, 0x10174).addRange(0x103D1, 0x103D5).addRange(0x12400, 0x1246E);
		    Letter_Number.characters = set;
		    return Letter_Number;
		  }

		  var Letter = {};

		  var hasRequiredLetter;
		  function requireLetter() {
		    if (hasRequiredLetter) return Letter;
		    hasRequiredLetter = 1;
		    var set = regenerateExports(0xAA, 0xB5, 0xBA, 0x2EC, 0x2EE, 0x37F, 0x386, 0x38C, 0x559, 0x6D5, 0x6FF, 0x710, 0x7B1, 0x7FA, 0x81A, 0x824, 0x828, 0x93D, 0x950, 0x9B2, 0x9BD, 0x9CE, 0x9FC, 0xA5E, 0xABD, 0xAD0, 0xAF9, 0xB3D, 0xB71, 0xB83, 0xB9C, 0xBD0, 0xC3D, 0xC5D, 0xC80, 0xCBD, 0xD3D, 0xD4E, 0xDBD, 0xE84, 0xEA5, 0xEBD, 0xEC6, 0xF00, 0x103F, 0x1061, 0x108E, 0x10C7, 0x10CD, 0x1258, 0x12C0, 0x17D7, 0x17DC, 0x18AA, 0x1AA7, 0x1CFA, 0x1F59, 0x1F5B, 0x1F5D, 0x1FBE, 0x2071, 0x207F, 0x2102, 0x2107, 0x2115, 0x2124, 0x2126, 0x2128, 0x214E, 0x2D27, 0x2D2D, 0x2D6F, 0x2E2F, 0xA7D3, 0xA8FB, 0xA9CF, 0xAA7A, 0xAAB1, 0xAAC0, 0xAAC2, 0xFB1D, 0xFB3E, 0x10808, 0x1083C, 0x10A00, 0x10F27, 0x11075, 0x11144, 0x11147, 0x11176, 0x111DA, 0x111DC, 0x11288, 0x1133D, 0x11350, 0x114C7, 0x11644, 0x116B8, 0x11909, 0x1193F, 0x11941, 0x119E1, 0x119E3, 0x11A00, 0x11A3A, 0x11A50, 0x11A9D, 0x11C40, 0x11D46, 0x11D98, 0x11F02, 0x11FB0, 0x16F50, 0x16FE3, 0x1B132, 0x1B155, 0x1D4A2, 0x1D4BB, 0x1D546, 0x1E14E, 0x1E94B, 0x1EE24, 0x1EE27, 0x1EE39, 0x1EE3B, 0x1EE42, 0x1EE47, 0x1EE49, 0x1EE4B, 0x1EE54, 0x1EE57, 0x1EE59, 0x1EE5B, 0x1EE5D, 0x1EE5F, 0x1EE64, 0x1EE7E);
		    set.addRange(0x41, 0x5A).addRange(0x61, 0x7A).addRange(0xC0, 0xD6).addRange(0xD8, 0xF6).addRange(0xF8, 0x2C1).addRange(0x2C6, 0x2D1).addRange(0x2E0, 0x2E4).addRange(0x370, 0x374).addRange(0x376, 0x377).addRange(0x37A, 0x37D).addRange(0x388, 0x38A).addRange(0x38E, 0x3A1).addRange(0x3A3, 0x3F5).addRange(0x3F7, 0x481).addRange(0x48A, 0x52F).addRange(0x531, 0x556).addRange(0x560, 0x588).addRange(0x5D0, 0x5EA).addRange(0x5EF, 0x5F2).addRange(0x620, 0x64A).addRange(0x66E, 0x66F).addRange(0x671, 0x6D3).addRange(0x6E5, 0x6E6).addRange(0x6EE, 0x6EF).addRange(0x6FA, 0x6FC).addRange(0x712, 0x72F).addRange(0x74D, 0x7A5).addRange(0x7CA, 0x7EA).addRange(0x7F4, 0x7F5).addRange(0x800, 0x815).addRange(0x840, 0x858).addRange(0x860, 0x86A).addRange(0x870, 0x887).addRange(0x889, 0x88E).addRange(0x8A0, 0x8C9).addRange(0x904, 0x939).addRange(0x958, 0x961).addRange(0x971, 0x980).addRange(0x985, 0x98C).addRange(0x98F, 0x990).addRange(0x993, 0x9A8).addRange(0x9AA, 0x9B0).addRange(0x9B6, 0x9B9).addRange(0x9DC, 0x9DD).addRange(0x9DF, 0x9E1).addRange(0x9F0, 0x9F1).addRange(0xA05, 0xA0A).addRange(0xA0F, 0xA10).addRange(0xA13, 0xA28).addRange(0xA2A, 0xA30).addRange(0xA32, 0xA33);
		    set.addRange(0xA35, 0xA36).addRange(0xA38, 0xA39).addRange(0xA59, 0xA5C).addRange(0xA72, 0xA74).addRange(0xA85, 0xA8D).addRange(0xA8F, 0xA91).addRange(0xA93, 0xAA8).addRange(0xAAA, 0xAB0).addRange(0xAB2, 0xAB3).addRange(0xAB5, 0xAB9).addRange(0xAE0, 0xAE1).addRange(0xB05, 0xB0C).addRange(0xB0F, 0xB10).addRange(0xB13, 0xB28).addRange(0xB2A, 0xB30).addRange(0xB32, 0xB33).addRange(0xB35, 0xB39).addRange(0xB5C, 0xB5D).addRange(0xB5F, 0xB61).addRange(0xB85, 0xB8A).addRange(0xB8E, 0xB90).addRange(0xB92, 0xB95).addRange(0xB99, 0xB9A).addRange(0xB9E, 0xB9F).addRange(0xBA3, 0xBA4).addRange(0xBA8, 0xBAA).addRange(0xBAE, 0xBB9).addRange(0xC05, 0xC0C).addRange(0xC0E, 0xC10).addRange(0xC12, 0xC28).addRange(0xC2A, 0xC39).addRange(0xC58, 0xC5A).addRange(0xC60, 0xC61).addRange(0xC85, 0xC8C).addRange(0xC8E, 0xC90).addRange(0xC92, 0xCA8).addRange(0xCAA, 0xCB3).addRange(0xCB5, 0xCB9).addRange(0xCDD, 0xCDE).addRange(0xCE0, 0xCE1).addRange(0xCF1, 0xCF2).addRange(0xD04, 0xD0C).addRange(0xD0E, 0xD10).addRange(0xD12, 0xD3A).addRange(0xD54, 0xD56).addRange(0xD5F, 0xD61).addRange(0xD7A, 0xD7F).addRange(0xD85, 0xD96).addRange(0xD9A, 0xDB1).addRange(0xDB3, 0xDBB).addRange(0xDC0, 0xDC6);
		    set.addRange(0xE01, 0xE30).addRange(0xE32, 0xE33).addRange(0xE40, 0xE46).addRange(0xE81, 0xE82).addRange(0xE86, 0xE8A).addRange(0xE8C, 0xEA3).addRange(0xEA7, 0xEB0).addRange(0xEB2, 0xEB3).addRange(0xEC0, 0xEC4).addRange(0xEDC, 0xEDF).addRange(0xF40, 0xF47).addRange(0xF49, 0xF6C).addRange(0xF88, 0xF8C).addRange(0x1000, 0x102A).addRange(0x1050, 0x1055).addRange(0x105A, 0x105D).addRange(0x1065, 0x1066).addRange(0x106E, 0x1070).addRange(0x1075, 0x1081).addRange(0x10A0, 0x10C5).addRange(0x10D0, 0x10FA).addRange(0x10FC, 0x1248).addRange(0x124A, 0x124D).addRange(0x1250, 0x1256).addRange(0x125A, 0x125D).addRange(0x1260, 0x1288).addRange(0x128A, 0x128D).addRange(0x1290, 0x12B0).addRange(0x12B2, 0x12B5).addRange(0x12B8, 0x12BE).addRange(0x12C2, 0x12C5).addRange(0x12C8, 0x12D6).addRange(0x12D8, 0x1310).addRange(0x1312, 0x1315).addRange(0x1318, 0x135A).addRange(0x1380, 0x138F).addRange(0x13A0, 0x13F5).addRange(0x13F8, 0x13FD).addRange(0x1401, 0x166C).addRange(0x166F, 0x167F).addRange(0x1681, 0x169A).addRange(0x16A0, 0x16EA).addRange(0x16F1, 0x16F8).addRange(0x1700, 0x1711).addRange(0x171F, 0x1731).addRange(0x1740, 0x1751).addRange(0x1760, 0x176C).addRange(0x176E, 0x1770).addRange(0x1780, 0x17B3).addRange(0x1820, 0x1878).addRange(0x1880, 0x1884);
		    set.addRange(0x1887, 0x18A8).addRange(0x18B0, 0x18F5).addRange(0x1900, 0x191E).addRange(0x1950, 0x196D).addRange(0x1970, 0x1974).addRange(0x1980, 0x19AB).addRange(0x19B0, 0x19C9).addRange(0x1A00, 0x1A16).addRange(0x1A20, 0x1A54).addRange(0x1B05, 0x1B33).addRange(0x1B45, 0x1B4C).addRange(0x1B83, 0x1BA0).addRange(0x1BAE, 0x1BAF).addRange(0x1BBA, 0x1BE5).addRange(0x1C00, 0x1C23).addRange(0x1C4D, 0x1C4F).addRange(0x1C5A, 0x1C7D).addRange(0x1C80, 0x1C88).addRange(0x1C90, 0x1CBA).addRange(0x1CBD, 0x1CBF).addRange(0x1CE9, 0x1CEC).addRange(0x1CEE, 0x1CF3).addRange(0x1CF5, 0x1CF6).addRange(0x1D00, 0x1DBF).addRange(0x1E00, 0x1F15).addRange(0x1F18, 0x1F1D).addRange(0x1F20, 0x1F45).addRange(0x1F48, 0x1F4D).addRange(0x1F50, 0x1F57).addRange(0x1F5F, 0x1F7D).addRange(0x1F80, 0x1FB4).addRange(0x1FB6, 0x1FBC).addRange(0x1FC2, 0x1FC4).addRange(0x1FC6, 0x1FCC).addRange(0x1FD0, 0x1FD3).addRange(0x1FD6, 0x1FDB).addRange(0x1FE0, 0x1FEC).addRange(0x1FF2, 0x1FF4).addRange(0x1FF6, 0x1FFC).addRange(0x2090, 0x209C).addRange(0x210A, 0x2113).addRange(0x2119, 0x211D).addRange(0x212A, 0x212D).addRange(0x212F, 0x2139).addRange(0x213C, 0x213F).addRange(0x2145, 0x2149).addRange(0x2183, 0x2184).addRange(0x2C00, 0x2CE4).addRange(0x2CEB, 0x2CEE).addRange(0x2CF2, 0x2CF3).addRange(0x2D00, 0x2D25);
		    set.addRange(0x2D30, 0x2D67).addRange(0x2D80, 0x2D96).addRange(0x2DA0, 0x2DA6).addRange(0x2DA8, 0x2DAE).addRange(0x2DB0, 0x2DB6).addRange(0x2DB8, 0x2DBE).addRange(0x2DC0, 0x2DC6).addRange(0x2DC8, 0x2DCE).addRange(0x2DD0, 0x2DD6).addRange(0x2DD8, 0x2DDE).addRange(0x3005, 0x3006).addRange(0x3031, 0x3035).addRange(0x303B, 0x303C).addRange(0x3041, 0x3096).addRange(0x309D, 0x309F).addRange(0x30A1, 0x30FA).addRange(0x30FC, 0x30FF).addRange(0x3105, 0x312F).addRange(0x3131, 0x318E).addRange(0x31A0, 0x31BF).addRange(0x31F0, 0x31FF).addRange(0x3400, 0x4DBF).addRange(0x4E00, 0xA48C).addRange(0xA4D0, 0xA4FD).addRange(0xA500, 0xA60C).addRange(0xA610, 0xA61F).addRange(0xA62A, 0xA62B).addRange(0xA640, 0xA66E).addRange(0xA67F, 0xA69D).addRange(0xA6A0, 0xA6E5).addRange(0xA717, 0xA71F).addRange(0xA722, 0xA788).addRange(0xA78B, 0xA7CA).addRange(0xA7D0, 0xA7D1).addRange(0xA7D5, 0xA7D9).addRange(0xA7F2, 0xA801).addRange(0xA803, 0xA805).addRange(0xA807, 0xA80A).addRange(0xA80C, 0xA822).addRange(0xA840, 0xA873).addRange(0xA882, 0xA8B3).addRange(0xA8F2, 0xA8F7).addRange(0xA8FD, 0xA8FE).addRange(0xA90A, 0xA925).addRange(0xA930, 0xA946).addRange(0xA960, 0xA97C).addRange(0xA984, 0xA9B2).addRange(0xA9E0, 0xA9E4).addRange(0xA9E6, 0xA9EF).addRange(0xA9FA, 0xA9FE).addRange(0xAA00, 0xAA28);
		    set.addRange(0xAA40, 0xAA42).addRange(0xAA44, 0xAA4B).addRange(0xAA60, 0xAA76).addRange(0xAA7E, 0xAAAF).addRange(0xAAB5, 0xAAB6).addRange(0xAAB9, 0xAABD).addRange(0xAADB, 0xAADD).addRange(0xAAE0, 0xAAEA).addRange(0xAAF2, 0xAAF4).addRange(0xAB01, 0xAB06).addRange(0xAB09, 0xAB0E).addRange(0xAB11, 0xAB16).addRange(0xAB20, 0xAB26).addRange(0xAB28, 0xAB2E).addRange(0xAB30, 0xAB5A).addRange(0xAB5C, 0xAB69).addRange(0xAB70, 0xABE2).addRange(0xAC00, 0xD7A3).addRange(0xD7B0, 0xD7C6).addRange(0xD7CB, 0xD7FB).addRange(0xF900, 0xFA6D).addRange(0xFA70, 0xFAD9).addRange(0xFB00, 0xFB06).addRange(0xFB13, 0xFB17).addRange(0xFB1F, 0xFB28).addRange(0xFB2A, 0xFB36).addRange(0xFB38, 0xFB3C).addRange(0xFB40, 0xFB41).addRange(0xFB43, 0xFB44).addRange(0xFB46, 0xFBB1).addRange(0xFBD3, 0xFD3D).addRange(0xFD50, 0xFD8F).addRange(0xFD92, 0xFDC7).addRange(0xFDF0, 0xFDFB).addRange(0xFE70, 0xFE74).addRange(0xFE76, 0xFEFC).addRange(0xFF21, 0xFF3A).addRange(0xFF41, 0xFF5A).addRange(0xFF66, 0xFFBE).addRange(0xFFC2, 0xFFC7).addRange(0xFFCA, 0xFFCF).addRange(0xFFD2, 0xFFD7).addRange(0xFFDA, 0xFFDC).addRange(0x10000, 0x1000B).addRange(0x1000D, 0x10026).addRange(0x10028, 0x1003A).addRange(0x1003C, 0x1003D).addRange(0x1003F, 0x1004D).addRange(0x10050, 0x1005D).addRange(0x10080, 0x100FA).addRange(0x10280, 0x1029C);
		    set.addRange(0x102A0, 0x102D0).addRange(0x10300, 0x1031F).addRange(0x1032D, 0x10340).addRange(0x10342, 0x10349).addRange(0x10350, 0x10375).addRange(0x10380, 0x1039D).addRange(0x103A0, 0x103C3).addRange(0x103C8, 0x103CF).addRange(0x10400, 0x1049D).addRange(0x104B0, 0x104D3).addRange(0x104D8, 0x104FB).addRange(0x10500, 0x10527).addRange(0x10530, 0x10563).addRange(0x10570, 0x1057A).addRange(0x1057C, 0x1058A).addRange(0x1058C, 0x10592).addRange(0x10594, 0x10595).addRange(0x10597, 0x105A1).addRange(0x105A3, 0x105B1).addRange(0x105B3, 0x105B9).addRange(0x105BB, 0x105BC).addRange(0x10600, 0x10736).addRange(0x10740, 0x10755).addRange(0x10760, 0x10767).addRange(0x10780, 0x10785).addRange(0x10787, 0x107B0).addRange(0x107B2, 0x107BA).addRange(0x10800, 0x10805).addRange(0x1080A, 0x10835).addRange(0x10837, 0x10838).addRange(0x1083F, 0x10855).addRange(0x10860, 0x10876).addRange(0x10880, 0x1089E).addRange(0x108E0, 0x108F2).addRange(0x108F4, 0x108F5).addRange(0x10900, 0x10915).addRange(0x10920, 0x10939).addRange(0x10980, 0x109B7).addRange(0x109BE, 0x109BF).addRange(0x10A10, 0x10A13).addRange(0x10A15, 0x10A17).addRange(0x10A19, 0x10A35).addRange(0x10A60, 0x10A7C).addRange(0x10A80, 0x10A9C).addRange(0x10AC0, 0x10AC7).addRange(0x10AC9, 0x10AE4).addRange(0x10B00, 0x10B35).addRange(0x10B40, 0x10B55).addRange(0x10B60, 0x10B72).addRange(0x10B80, 0x10B91).addRange(0x10C00, 0x10C48);
		    set.addRange(0x10C80, 0x10CB2).addRange(0x10CC0, 0x10CF2).addRange(0x10D00, 0x10D23).addRange(0x10E80, 0x10EA9).addRange(0x10EB0, 0x10EB1).addRange(0x10F00, 0x10F1C).addRange(0x10F30, 0x10F45).addRange(0x10F70, 0x10F81).addRange(0x10FB0, 0x10FC4).addRange(0x10FE0, 0x10FF6).addRange(0x11003, 0x11037).addRange(0x11071, 0x11072).addRange(0x11083, 0x110AF).addRange(0x110D0, 0x110E8).addRange(0x11103, 0x11126).addRange(0x11150, 0x11172).addRange(0x11183, 0x111B2).addRange(0x111C1, 0x111C4).addRange(0x11200, 0x11211).addRange(0x11213, 0x1122B).addRange(0x1123F, 0x11240).addRange(0x11280, 0x11286).addRange(0x1128A, 0x1128D).addRange(0x1128F, 0x1129D).addRange(0x1129F, 0x112A8).addRange(0x112B0, 0x112DE).addRange(0x11305, 0x1130C).addRange(0x1130F, 0x11310).addRange(0x11313, 0x11328).addRange(0x1132A, 0x11330).addRange(0x11332, 0x11333).addRange(0x11335, 0x11339).addRange(0x1135D, 0x11361).addRange(0x11400, 0x11434).addRange(0x11447, 0x1144A).addRange(0x1145F, 0x11461).addRange(0x11480, 0x114AF).addRange(0x114C4, 0x114C5).addRange(0x11580, 0x115AE).addRange(0x115D8, 0x115DB).addRange(0x11600, 0x1162F).addRange(0x11680, 0x116AA).addRange(0x11700, 0x1171A).addRange(0x11740, 0x11746).addRange(0x11800, 0x1182B).addRange(0x118A0, 0x118DF).addRange(0x118FF, 0x11906).addRange(0x1190C, 0x11913).addRange(0x11915, 0x11916).addRange(0x11918, 0x1192F).addRange(0x119A0, 0x119A7);
		    set.addRange(0x119AA, 0x119D0).addRange(0x11A0B, 0x11A32).addRange(0x11A5C, 0x11A89).addRange(0x11AB0, 0x11AF8).addRange(0x11C00, 0x11C08).addRange(0x11C0A, 0x11C2E).addRange(0x11C72, 0x11C8F).addRange(0x11D00, 0x11D06).addRange(0x11D08, 0x11D09).addRange(0x11D0B, 0x11D30).addRange(0x11D60, 0x11D65).addRange(0x11D67, 0x11D68).addRange(0x11D6A, 0x11D89).addRange(0x11EE0, 0x11EF2).addRange(0x11F04, 0x11F10).addRange(0x11F12, 0x11F33).addRange(0x12000, 0x12399).addRange(0x12480, 0x12543).addRange(0x12F90, 0x12FF0).addRange(0x13000, 0x1342F).addRange(0x13441, 0x13446).addRange(0x14400, 0x14646).addRange(0x16800, 0x16A38).addRange(0x16A40, 0x16A5E).addRange(0x16A70, 0x16ABE).addRange(0x16AD0, 0x16AED).addRange(0x16B00, 0x16B2F).addRange(0x16B40, 0x16B43).addRange(0x16B63, 0x16B77).addRange(0x16B7D, 0x16B8F).addRange(0x16E40, 0x16E7F).addRange(0x16F00, 0x16F4A).addRange(0x16F93, 0x16F9F).addRange(0x16FE0, 0x16FE1).addRange(0x17000, 0x187F7).addRange(0x18800, 0x18CD5).addRange(0x18D00, 0x18D08).addRange(0x1AFF0, 0x1AFF3).addRange(0x1AFF5, 0x1AFFB).addRange(0x1AFFD, 0x1AFFE).addRange(0x1B000, 0x1B122).addRange(0x1B150, 0x1B152).addRange(0x1B164, 0x1B167).addRange(0x1B170, 0x1B2FB).addRange(0x1BC00, 0x1BC6A).addRange(0x1BC70, 0x1BC7C).addRange(0x1BC80, 0x1BC88).addRange(0x1BC90, 0x1BC99).addRange(0x1D400, 0x1D454).addRange(0x1D456, 0x1D49C).addRange(0x1D49E, 0x1D49F);
		    set.addRange(0x1D4A5, 0x1D4A6).addRange(0x1D4A9, 0x1D4AC).addRange(0x1D4AE, 0x1D4B9).addRange(0x1D4BD, 0x1D4C3).addRange(0x1D4C5, 0x1D505).addRange(0x1D507, 0x1D50A).addRange(0x1D50D, 0x1D514).addRange(0x1D516, 0x1D51C).addRange(0x1D51E, 0x1D539).addRange(0x1D53B, 0x1D53E).addRange(0x1D540, 0x1D544).addRange(0x1D54A, 0x1D550).addRange(0x1D552, 0x1D6A5).addRange(0x1D6A8, 0x1D6C0).addRange(0x1D6C2, 0x1D6DA).addRange(0x1D6DC, 0x1D6FA).addRange(0x1D6FC, 0x1D714).addRange(0x1D716, 0x1D734).addRange(0x1D736, 0x1D74E).addRange(0x1D750, 0x1D76E).addRange(0x1D770, 0x1D788).addRange(0x1D78A, 0x1D7A8).addRange(0x1D7AA, 0x1D7C2).addRange(0x1D7C4, 0x1D7CB).addRange(0x1DF00, 0x1DF1E).addRange(0x1DF25, 0x1DF2A).addRange(0x1E030, 0x1E06D).addRange(0x1E100, 0x1E12C).addRange(0x1E137, 0x1E13D).addRange(0x1E290, 0x1E2AD).addRange(0x1E2C0, 0x1E2EB).addRange(0x1E4D0, 0x1E4EB).addRange(0x1E7E0, 0x1E7E6).addRange(0x1E7E8, 0x1E7EB).addRange(0x1E7ED, 0x1E7EE).addRange(0x1E7F0, 0x1E7FE).addRange(0x1E800, 0x1E8C4).addRange(0x1E900, 0x1E943).addRange(0x1EE00, 0x1EE03).addRange(0x1EE05, 0x1EE1F).addRange(0x1EE21, 0x1EE22).addRange(0x1EE29, 0x1EE32).addRange(0x1EE34, 0x1EE37).addRange(0x1EE4D, 0x1EE4F).addRange(0x1EE51, 0x1EE52).addRange(0x1EE61, 0x1EE62).addRange(0x1EE67, 0x1EE6A).addRange(0x1EE6C, 0x1EE72).addRange(0x1EE74, 0x1EE77).addRange(0x1EE79, 0x1EE7C).addRange(0x1EE80, 0x1EE89);
		    set.addRange(0x1EE8B, 0x1EE9B).addRange(0x1EEA1, 0x1EEA3).addRange(0x1EEA5, 0x1EEA9).addRange(0x1EEAB, 0x1EEBB).addRange(0x20000, 0x2A6DF).addRange(0x2A700, 0x2B739).addRange(0x2B740, 0x2B81D).addRange(0x2B820, 0x2CEA1).addRange(0x2CEB0, 0x2EBE0).addRange(0x2EBF0, 0x2EE5D).addRange(0x2F800, 0x2FA1D).addRange(0x30000, 0x3134A).addRange(0x31350, 0x323AF);
		    Letter.characters = set;
		    return Letter;
		  }

		  var Line_Separator = {};

		  var hasRequiredLine_Separator;
		  function requireLine_Separator() {
		    if (hasRequiredLine_Separator) return Line_Separator;
		    hasRequiredLine_Separator = 1;
		    var set = regenerateExports(0x2028);
		    Line_Separator.characters = set;
		    return Line_Separator;
		  }

		  var Lowercase_Letter = {};

		  var hasRequiredLowercase_Letter;
		  function requireLowercase_Letter() {
		    if (hasRequiredLowercase_Letter) return Lowercase_Letter;
		    hasRequiredLowercase_Letter = 1;
		    var set = regenerateExports(0xB5, 0x101, 0x103, 0x105, 0x107, 0x109, 0x10B, 0x10D, 0x10F, 0x111, 0x113, 0x115, 0x117, 0x119, 0x11B, 0x11D, 0x11F, 0x121, 0x123, 0x125, 0x127, 0x129, 0x12B, 0x12D, 0x12F, 0x131, 0x133, 0x135, 0x13A, 0x13C, 0x13E, 0x140, 0x142, 0x144, 0x146, 0x14B, 0x14D, 0x14F, 0x151, 0x153, 0x155, 0x157, 0x159, 0x15B, 0x15D, 0x15F, 0x161, 0x163, 0x165, 0x167, 0x169, 0x16B, 0x16D, 0x16F, 0x171, 0x173, 0x175, 0x177, 0x17A, 0x17C, 0x183, 0x185, 0x188, 0x192, 0x195, 0x19E, 0x1A1, 0x1A3, 0x1A5, 0x1A8, 0x1AD, 0x1B0, 0x1B4, 0x1B6, 0x1C6, 0x1C9, 0x1CC, 0x1CE, 0x1D0, 0x1D2, 0x1D4, 0x1D6, 0x1D8, 0x1DA, 0x1DF, 0x1E1, 0x1E3, 0x1E5, 0x1E7, 0x1E9, 0x1EB, 0x1ED, 0x1F3, 0x1F5, 0x1F9, 0x1FB, 0x1FD, 0x1FF, 0x201, 0x203, 0x205, 0x207, 0x209, 0x20B, 0x20D, 0x20F, 0x211, 0x213, 0x215, 0x217, 0x219, 0x21B, 0x21D, 0x21F, 0x221, 0x223, 0x225, 0x227, 0x229, 0x22B, 0x22D, 0x22F, 0x231, 0x23C, 0x242, 0x247, 0x249, 0x24B, 0x24D, 0x371, 0x373, 0x377, 0x390, 0x3D9, 0x3DB, 0x3DD, 0x3DF, 0x3E1, 0x3E3, 0x3E5, 0x3E7, 0x3E9, 0x3EB, 0x3ED, 0x3F5, 0x3F8, 0x461, 0x463, 0x465, 0x467, 0x469, 0x46B, 0x46D, 0x46F, 0x471, 0x473, 0x475, 0x477, 0x479, 0x47B, 0x47D, 0x47F, 0x481, 0x48B, 0x48D, 0x48F, 0x491, 0x493, 0x495, 0x497, 0x499, 0x49B, 0x49D, 0x49F, 0x4A1, 0x4A3, 0x4A5, 0x4A7, 0x4A9, 0x4AB, 0x4AD, 0x4AF, 0x4B1, 0x4B3, 0x4B5, 0x4B7, 0x4B9, 0x4BB, 0x4BD, 0x4BF, 0x4C2, 0x4C4, 0x4C6, 0x4C8, 0x4CA, 0x4CC, 0x4D1, 0x4D3, 0x4D5, 0x4D7, 0x4D9, 0x4DB, 0x4DD, 0x4DF, 0x4E1, 0x4E3, 0x4E5, 0x4E7, 0x4E9, 0x4EB, 0x4ED, 0x4EF, 0x4F1, 0x4F3, 0x4F5, 0x4F7, 0x4F9, 0x4FB, 0x4FD, 0x4FF, 0x501, 0x503, 0x505, 0x507, 0x509, 0x50B, 0x50D, 0x50F, 0x511, 0x513, 0x515, 0x517, 0x519, 0x51B, 0x51D, 0x51F, 0x521, 0x523, 0x525, 0x527, 0x529, 0x52B, 0x52D, 0x52F, 0x1E01, 0x1E03, 0x1E05, 0x1E07, 0x1E09, 0x1E0B, 0x1E0D, 0x1E0F, 0x1E11, 0x1E13, 0x1E15, 0x1E17, 0x1E19, 0x1E1B, 0x1E1D, 0x1E1F, 0x1E21, 0x1E23, 0x1E25, 0x1E27, 0x1E29, 0x1E2B, 0x1E2D, 0x1E2F, 0x1E31, 0x1E33, 0x1E35, 0x1E37, 0x1E39, 0x1E3B, 0x1E3D, 0x1E3F, 0x1E41, 0x1E43, 0x1E45, 0x1E47, 0x1E49, 0x1E4B, 0x1E4D, 0x1E4F, 0x1E51, 0x1E53, 0x1E55, 0x1E57, 0x1E59, 0x1E5B, 0x1E5D, 0x1E5F, 0x1E61, 0x1E63, 0x1E65, 0x1E67, 0x1E69, 0x1E6B, 0x1E6D, 0x1E6F, 0x1E71, 0x1E73, 0x1E75, 0x1E77, 0x1E79, 0x1E7B, 0x1E7D, 0x1E7F, 0x1E81, 0x1E83, 0x1E85, 0x1E87, 0x1E89, 0x1E8B, 0x1E8D, 0x1E8F, 0x1E91, 0x1E93, 0x1E9F, 0x1EA1, 0x1EA3, 0x1EA5, 0x1EA7, 0x1EA9, 0x1EAB, 0x1EAD, 0x1EAF, 0x1EB1, 0x1EB3, 0x1EB5, 0x1EB7, 0x1EB9, 0x1EBB, 0x1EBD, 0x1EBF, 0x1EC1, 0x1EC3, 0x1EC5, 0x1EC7, 0x1EC9, 0x1ECB, 0x1ECD, 0x1ECF, 0x1ED1, 0x1ED3, 0x1ED5, 0x1ED7, 0x1ED9, 0x1EDB, 0x1EDD, 0x1EDF, 0x1EE1, 0x1EE3, 0x1EE5, 0x1EE7, 0x1EE9, 0x1EEB, 0x1EED, 0x1EEF, 0x1EF1, 0x1EF3, 0x1EF5, 0x1EF7, 0x1EF9, 0x1EFB, 0x1EFD, 0x1FBE, 0x210A, 0x2113, 0x212F, 0x2134, 0x2139, 0x214E, 0x2184, 0x2C61, 0x2C68, 0x2C6A, 0x2C6C, 0x2C71, 0x2C81, 0x2C83, 0x2C85, 0x2C87, 0x2C89, 0x2C8B, 0x2C8D, 0x2C8F, 0x2C91, 0x2C93, 0x2C95, 0x2C97, 0x2C99, 0x2C9B, 0x2C9D, 0x2C9F, 0x2CA1, 0x2CA3, 0x2CA5, 0x2CA7, 0x2CA9, 0x2CAB, 0x2CAD, 0x2CAF, 0x2CB1, 0x2CB3, 0x2CB5, 0x2CB7, 0x2CB9, 0x2CBB, 0x2CBD, 0x2CBF, 0x2CC1, 0x2CC3, 0x2CC5, 0x2CC7, 0x2CC9, 0x2CCB, 0x2CCD, 0x2CCF, 0x2CD1, 0x2CD3, 0x2CD5, 0x2CD7, 0x2CD9, 0x2CDB, 0x2CDD, 0x2CDF, 0x2CE1, 0x2CEC, 0x2CEE, 0x2CF3, 0x2D27, 0x2D2D, 0xA641, 0xA643, 0xA645, 0xA647, 0xA649, 0xA64B, 0xA64D, 0xA64F, 0xA651, 0xA653, 0xA655, 0xA657, 0xA659, 0xA65B, 0xA65D, 0xA65F, 0xA661, 0xA663, 0xA665, 0xA667, 0xA669, 0xA66B, 0xA66D, 0xA681, 0xA683, 0xA685, 0xA687, 0xA689, 0xA68B, 0xA68D, 0xA68F, 0xA691, 0xA693, 0xA695, 0xA697, 0xA699, 0xA69B, 0xA723, 0xA725, 0xA727, 0xA729, 0xA72B, 0xA72D, 0xA733, 0xA735, 0xA737, 0xA739, 0xA73B, 0xA73D, 0xA73F, 0xA741, 0xA743, 0xA745, 0xA747, 0xA749, 0xA74B, 0xA74D, 0xA74F, 0xA751, 0xA753, 0xA755, 0xA757, 0xA759, 0xA75B, 0xA75D, 0xA75F, 0xA761, 0xA763, 0xA765, 0xA767, 0xA769, 0xA76B, 0xA76D, 0xA76F, 0xA77A, 0xA77C, 0xA77F, 0xA781, 0xA783, 0xA785, 0xA787, 0xA78C, 0xA78E, 0xA791, 0xA797, 0xA799, 0xA79B, 0xA79D, 0xA79F, 0xA7A1, 0xA7A3, 0xA7A5, 0xA7A7, 0xA7A9, 0xA7AF, 0xA7B5, 0xA7B7, 0xA7B9, 0xA7BB, 0xA7BD, 0xA7BF, 0xA7C1, 0xA7C3, 0xA7C8, 0xA7CA, 0xA7D1, 0xA7D3, 0xA7D5, 0xA7D7, 0xA7D9, 0xA7F6, 0xA7FA, 0x1D4BB, 0x1D7CB);
		    set.addRange(0x61, 0x7A).addRange(0xDF, 0xF6).addRange(0xF8, 0xFF).addRange(0x137, 0x138).addRange(0x148, 0x149).addRange(0x17E, 0x180).addRange(0x18C, 0x18D).addRange(0x199, 0x19B).addRange(0x1AA, 0x1AB).addRange(0x1B9, 0x1BA).addRange(0x1BD, 0x1BF).addRange(0x1DC, 0x1DD).addRange(0x1EF, 0x1F0).addRange(0x233, 0x239).addRange(0x23F, 0x240).addRange(0x24F, 0x293).addRange(0x295, 0x2AF).addRange(0x37B, 0x37D).addRange(0x3AC, 0x3CE).addRange(0x3D0, 0x3D1).addRange(0x3D5, 0x3D7).addRange(0x3EF, 0x3F3).addRange(0x3FB, 0x3FC).addRange(0x430, 0x45F).addRange(0x4CE, 0x4CF).addRange(0x560, 0x588).addRange(0x10D0, 0x10FA).addRange(0x10FD, 0x10FF).addRange(0x13F8, 0x13FD).addRange(0x1C80, 0x1C88).addRange(0x1D00, 0x1D2B).addRange(0x1D6B, 0x1D77).addRange(0x1D79, 0x1D9A).addRange(0x1E95, 0x1E9D).addRange(0x1EFF, 0x1F07).addRange(0x1F10, 0x1F15).addRange(0x1F20, 0x1F27).addRange(0x1F30, 0x1F37).addRange(0x1F40, 0x1F45).addRange(0x1F50, 0x1F57).addRange(0x1F60, 0x1F67).addRange(0x1F70, 0x1F7D).addRange(0x1F80, 0x1F87).addRange(0x1F90, 0x1F97).addRange(0x1FA0, 0x1FA7).addRange(0x1FB0, 0x1FB4).addRange(0x1FB6, 0x1FB7).addRange(0x1FC2, 0x1FC4).addRange(0x1FC6, 0x1FC7).addRange(0x1FD0, 0x1FD3).addRange(0x1FD6, 0x1FD7);
		    set.addRange(0x1FE0, 0x1FE7).addRange(0x1FF2, 0x1FF4).addRange(0x1FF6, 0x1FF7).addRange(0x210E, 0x210F).addRange(0x213C, 0x213D).addRange(0x2146, 0x2149).addRange(0x2C30, 0x2C5F).addRange(0x2C65, 0x2C66).addRange(0x2C73, 0x2C74).addRange(0x2C76, 0x2C7B).addRange(0x2CE3, 0x2CE4).addRange(0x2D00, 0x2D25).addRange(0xA72F, 0xA731).addRange(0xA771, 0xA778).addRange(0xA793, 0xA795).addRange(0xAB30, 0xAB5A).addRange(0xAB60, 0xAB68).addRange(0xAB70, 0xABBF).addRange(0xFB00, 0xFB06).addRange(0xFB13, 0xFB17).addRange(0xFF41, 0xFF5A).addRange(0x10428, 0x1044F).addRange(0x104D8, 0x104FB).addRange(0x10597, 0x105A1).addRange(0x105A3, 0x105B1).addRange(0x105B3, 0x105B9).addRange(0x105BB, 0x105BC).addRange(0x10CC0, 0x10CF2).addRange(0x118C0, 0x118DF).addRange(0x16E60, 0x16E7F).addRange(0x1D41A, 0x1D433).addRange(0x1D44E, 0x1D454).addRange(0x1D456, 0x1D467).addRange(0x1D482, 0x1D49B).addRange(0x1D4B6, 0x1D4B9).addRange(0x1D4BD, 0x1D4C3).addRange(0x1D4C5, 0x1D4CF).addRange(0x1D4EA, 0x1D503).addRange(0x1D51E, 0x1D537).addRange(0x1D552, 0x1D56B).addRange(0x1D586, 0x1D59F).addRange(0x1D5BA, 0x1D5D3).addRange(0x1D5EE, 0x1D607).addRange(0x1D622, 0x1D63B).addRange(0x1D656, 0x1D66F).addRange(0x1D68A, 0x1D6A5).addRange(0x1D6C2, 0x1D6DA).addRange(0x1D6DC, 0x1D6E1).addRange(0x1D6FC, 0x1D714).addRange(0x1D716, 0x1D71B).addRange(0x1D736, 0x1D74E);
		    set.addRange(0x1D750, 0x1D755).addRange(0x1D770, 0x1D788).addRange(0x1D78A, 0x1D78F).addRange(0x1D7AA, 0x1D7C2).addRange(0x1D7C4, 0x1D7C9).addRange(0x1DF00, 0x1DF09).addRange(0x1DF0B, 0x1DF1E).addRange(0x1DF25, 0x1DF2A).addRange(0x1E922, 0x1E943);
		    Lowercase_Letter.characters = set;
		    return Lowercase_Letter;
		  }

		  var Mark = {};

		  var hasRequiredMark;
		  function requireMark() {
		    if (hasRequiredMark) return Mark;
		    hasRequiredMark = 1;
		    var set = regenerateExports(0x5BF, 0x5C7, 0x670, 0x711, 0x7FD, 0x9BC, 0x9D7, 0x9FE, 0xA3C, 0xA51, 0xA75, 0xABC, 0xB3C, 0xB82, 0xBD7, 0xC3C, 0xCBC, 0xCF3, 0xD57, 0xDCA, 0xDD6, 0xE31, 0xEB1, 0xF35, 0xF37, 0xF39, 0xFC6, 0x108F, 0x17DD, 0x180F, 0x18A9, 0x1A7F, 0x1CED, 0x1CF4, 0x2D7F, 0xA802, 0xA806, 0xA80B, 0xA82C, 0xA8FF, 0xA9E5, 0xAA43, 0xAAB0, 0xAAC1, 0xFB1E, 0x101FD, 0x102E0, 0x10A3F, 0x11070, 0x110C2, 0x11173, 0x1123E, 0x11241, 0x11357, 0x1145E, 0x11940, 0x119E4, 0x11A47, 0x11D3A, 0x11D47, 0x11F03, 0x13440, 0x16F4F, 0x16FE4, 0x1DA75, 0x1DA84, 0x1E08F, 0x1E2AE);
		    set.addRange(0x300, 0x36F).addRange(0x483, 0x489).addRange(0x591, 0x5BD).addRange(0x5C1, 0x5C2).addRange(0x5C4, 0x5C5).addRange(0x610, 0x61A).addRange(0x64B, 0x65F).addRange(0x6D6, 0x6DC).addRange(0x6DF, 0x6E4).addRange(0x6E7, 0x6E8).addRange(0x6EA, 0x6ED).addRange(0x730, 0x74A).addRange(0x7A6, 0x7B0).addRange(0x7EB, 0x7F3).addRange(0x816, 0x819).addRange(0x81B, 0x823).addRange(0x825, 0x827).addRange(0x829, 0x82D).addRange(0x859, 0x85B).addRange(0x898, 0x89F).addRange(0x8CA, 0x8E1).addRange(0x8E3, 0x903).addRange(0x93A, 0x93C).addRange(0x93E, 0x94F).addRange(0x951, 0x957).addRange(0x962, 0x963).addRange(0x981, 0x983).addRange(0x9BE, 0x9C4).addRange(0x9C7, 0x9C8).addRange(0x9CB, 0x9CD).addRange(0x9E2, 0x9E3).addRange(0xA01, 0xA03).addRange(0xA3E, 0xA42).addRange(0xA47, 0xA48).addRange(0xA4B, 0xA4D).addRange(0xA70, 0xA71).addRange(0xA81, 0xA83).addRange(0xABE, 0xAC5).addRange(0xAC7, 0xAC9).addRange(0xACB, 0xACD).addRange(0xAE2, 0xAE3).addRange(0xAFA, 0xAFF).addRange(0xB01, 0xB03).addRange(0xB3E, 0xB44).addRange(0xB47, 0xB48).addRange(0xB4B, 0xB4D).addRange(0xB55, 0xB57).addRange(0xB62, 0xB63).addRange(0xBBE, 0xBC2).addRange(0xBC6, 0xBC8).addRange(0xBCA, 0xBCD);
		    set.addRange(0xC00, 0xC04).addRange(0xC3E, 0xC44).addRange(0xC46, 0xC48).addRange(0xC4A, 0xC4D).addRange(0xC55, 0xC56).addRange(0xC62, 0xC63).addRange(0xC81, 0xC83).addRange(0xCBE, 0xCC4).addRange(0xCC6, 0xCC8).addRange(0xCCA, 0xCCD).addRange(0xCD5, 0xCD6).addRange(0xCE2, 0xCE3).addRange(0xD00, 0xD03).addRange(0xD3B, 0xD3C).addRange(0xD3E, 0xD44).addRange(0xD46, 0xD48).addRange(0xD4A, 0xD4D).addRange(0xD62, 0xD63).addRange(0xD81, 0xD83).addRange(0xDCF, 0xDD4).addRange(0xDD8, 0xDDF).addRange(0xDF2, 0xDF3).addRange(0xE34, 0xE3A).addRange(0xE47, 0xE4E).addRange(0xEB4, 0xEBC).addRange(0xEC8, 0xECE).addRange(0xF18, 0xF19).addRange(0xF3E, 0xF3F).addRange(0xF71, 0xF84).addRange(0xF86, 0xF87).addRange(0xF8D, 0xF97).addRange(0xF99, 0xFBC).addRange(0x102B, 0x103E).addRange(0x1056, 0x1059).addRange(0x105E, 0x1060).addRange(0x1062, 0x1064).addRange(0x1067, 0x106D).addRange(0x1071, 0x1074).addRange(0x1082, 0x108D).addRange(0x109A, 0x109D).addRange(0x135D, 0x135F).addRange(0x1712, 0x1715).addRange(0x1732, 0x1734).addRange(0x1752, 0x1753).addRange(0x1772, 0x1773).addRange(0x17B4, 0x17D3).addRange(0x180B, 0x180D).addRange(0x1885, 0x1886).addRange(0x1920, 0x192B).addRange(0x1930, 0x193B).addRange(0x1A17, 0x1A1B);
		    set.addRange(0x1A55, 0x1A5E).addRange(0x1A60, 0x1A7C).addRange(0x1AB0, 0x1ACE).addRange(0x1B00, 0x1B04).addRange(0x1B34, 0x1B44).addRange(0x1B6B, 0x1B73).addRange(0x1B80, 0x1B82).addRange(0x1BA1, 0x1BAD).addRange(0x1BE6, 0x1BF3).addRange(0x1C24, 0x1C37).addRange(0x1CD0, 0x1CD2).addRange(0x1CD4, 0x1CE8).addRange(0x1CF7, 0x1CF9).addRange(0x1DC0, 0x1DFF).addRange(0x20D0, 0x20F0).addRange(0x2CEF, 0x2CF1).addRange(0x2DE0, 0x2DFF).addRange(0x302A, 0x302F).addRange(0x3099, 0x309A).addRange(0xA66F, 0xA672).addRange(0xA674, 0xA67D).addRange(0xA69E, 0xA69F).addRange(0xA6F0, 0xA6F1).addRange(0xA823, 0xA827).addRange(0xA880, 0xA881).addRange(0xA8B4, 0xA8C5).addRange(0xA8E0, 0xA8F1).addRange(0xA926, 0xA92D).addRange(0xA947, 0xA953).addRange(0xA980, 0xA983).addRange(0xA9B3, 0xA9C0).addRange(0xAA29, 0xAA36).addRange(0xAA4C, 0xAA4D).addRange(0xAA7B, 0xAA7D).addRange(0xAAB2, 0xAAB4).addRange(0xAAB7, 0xAAB8).addRange(0xAABE, 0xAABF).addRange(0xAAEB, 0xAAEF).addRange(0xAAF5, 0xAAF6).addRange(0xABE3, 0xABEA).addRange(0xABEC, 0xABED).addRange(0xFE00, 0xFE0F).addRange(0xFE20, 0xFE2F).addRange(0x10376, 0x1037A).addRange(0x10A01, 0x10A03).addRange(0x10A05, 0x10A06).addRange(0x10A0C, 0x10A0F).addRange(0x10A38, 0x10A3A).addRange(0x10AE5, 0x10AE6).addRange(0x10D24, 0x10D27).addRange(0x10EAB, 0x10EAC);
		    set.addRange(0x10EFD, 0x10EFF).addRange(0x10F46, 0x10F50).addRange(0x10F82, 0x10F85).addRange(0x11000, 0x11002).addRange(0x11038, 0x11046).addRange(0x11073, 0x11074).addRange(0x1107F, 0x11082).addRange(0x110B0, 0x110BA).addRange(0x11100, 0x11102).addRange(0x11127, 0x11134).addRange(0x11145, 0x11146).addRange(0x11180, 0x11182).addRange(0x111B3, 0x111C0).addRange(0x111C9, 0x111CC).addRange(0x111CE, 0x111CF).addRange(0x1122C, 0x11237).addRange(0x112DF, 0x112EA).addRange(0x11300, 0x11303).addRange(0x1133B, 0x1133C).addRange(0x1133E, 0x11344).addRange(0x11347, 0x11348).addRange(0x1134B, 0x1134D).addRange(0x11362, 0x11363).addRange(0x11366, 0x1136C).addRange(0x11370, 0x11374).addRange(0x11435, 0x11446).addRange(0x114B0, 0x114C3).addRange(0x115AF, 0x115B5).addRange(0x115B8, 0x115C0).addRange(0x115DC, 0x115DD).addRange(0x11630, 0x11640).addRange(0x116AB, 0x116B7).addRange(0x1171D, 0x1172B).addRange(0x1182C, 0x1183A).addRange(0x11930, 0x11935).addRange(0x11937, 0x11938).addRange(0x1193B, 0x1193E).addRange(0x11942, 0x11943).addRange(0x119D1, 0x119D7).addRange(0x119DA, 0x119E0).addRange(0x11A01, 0x11A0A).addRange(0x11A33, 0x11A39).addRange(0x11A3B, 0x11A3E).addRange(0x11A51, 0x11A5B).addRange(0x11A8A, 0x11A99).addRange(0x11C2F, 0x11C36).addRange(0x11C38, 0x11C3F).addRange(0x11C92, 0x11CA7).addRange(0x11CA9, 0x11CB6).addRange(0x11D31, 0x11D36).addRange(0x11D3C, 0x11D3D);
		    set.addRange(0x11D3F, 0x11D45).addRange(0x11D8A, 0x11D8E).addRange(0x11D90, 0x11D91).addRange(0x11D93, 0x11D97).addRange(0x11EF3, 0x11EF6).addRange(0x11F00, 0x11F01).addRange(0x11F34, 0x11F3A).addRange(0x11F3E, 0x11F42).addRange(0x13447, 0x13455).addRange(0x16AF0, 0x16AF4).addRange(0x16B30, 0x16B36).addRange(0x16F51, 0x16F87).addRange(0x16F8F, 0x16F92).addRange(0x16FF0, 0x16FF1).addRange(0x1BC9D, 0x1BC9E).addRange(0x1CF00, 0x1CF2D).addRange(0x1CF30, 0x1CF46).addRange(0x1D165, 0x1D169).addRange(0x1D16D, 0x1D172).addRange(0x1D17B, 0x1D182).addRange(0x1D185, 0x1D18B).addRange(0x1D1AA, 0x1D1AD).addRange(0x1D242, 0x1D244).addRange(0x1DA00, 0x1DA36).addRange(0x1DA3B, 0x1DA6C).addRange(0x1DA9B, 0x1DA9F).addRange(0x1DAA1, 0x1DAAF).addRange(0x1E000, 0x1E006).addRange(0x1E008, 0x1E018).addRange(0x1E01B, 0x1E021).addRange(0x1E023, 0x1E024).addRange(0x1E026, 0x1E02A).addRange(0x1E130, 0x1E136).addRange(0x1E2EC, 0x1E2EF).addRange(0x1E4EC, 0x1E4EF).addRange(0x1E8D0, 0x1E8D6).addRange(0x1E944, 0x1E94A).addRange(0xE0100, 0xE01EF);
		    Mark.characters = set;
		    return Mark;
		  }

		  var Math_Symbol = {};

		  var hasRequiredMath_Symbol;
		  function requireMath_Symbol() {
		    if (hasRequiredMath_Symbol) return Math_Symbol;
		    hasRequiredMath_Symbol = 1;
		    var set = regenerateExports(0x2B, 0x7C, 0x7E, 0xAC, 0xB1, 0xD7, 0xF7, 0x3F6, 0x2044, 0x2052, 0x2118, 0x214B, 0x21A0, 0x21A3, 0x21A6, 0x21AE, 0x21D2, 0x21D4, 0x237C, 0x25B7, 0x25C1, 0x266F, 0xFB29, 0xFE62, 0xFF0B, 0xFF5C, 0xFF5E, 0xFFE2, 0x1D6C1, 0x1D6DB, 0x1D6FB, 0x1D715, 0x1D735, 0x1D74F, 0x1D76F, 0x1D789, 0x1D7A9, 0x1D7C3);
		    set.addRange(0x3C, 0x3E).addRange(0x606, 0x608).addRange(0x207A, 0x207C).addRange(0x208A, 0x208C).addRange(0x2140, 0x2144).addRange(0x2190, 0x2194).addRange(0x219A, 0x219B).addRange(0x21CE, 0x21CF).addRange(0x21F4, 0x22FF).addRange(0x2320, 0x2321).addRange(0x239B, 0x23B3).addRange(0x23DC, 0x23E1).addRange(0x25F8, 0x25FF).addRange(0x27C0, 0x27C4).addRange(0x27C7, 0x27E5).addRange(0x27F0, 0x27FF).addRange(0x2900, 0x2982).addRange(0x2999, 0x29D7).addRange(0x29DC, 0x29FB).addRange(0x29FE, 0x2AFF).addRange(0x2B30, 0x2B44).addRange(0x2B47, 0x2B4C).addRange(0xFE64, 0xFE66).addRange(0xFF1C, 0xFF1E).addRange(0xFFE9, 0xFFEC).addRange(0x1EEF0, 0x1EEF1);
		    Math_Symbol.characters = set;
		    return Math_Symbol;
		  }

		  var Modifier_Letter = {};

		  var hasRequiredModifier_Letter;
		  function requireModifier_Letter() {
		    if (hasRequiredModifier_Letter) return Modifier_Letter;
		    hasRequiredModifier_Letter = 1;
		    var set = regenerateExports(0x2EC, 0x2EE, 0x374, 0x37A, 0x559, 0x640, 0x7FA, 0x81A, 0x824, 0x828, 0x8C9, 0x971, 0xE46, 0xEC6, 0x10FC, 0x17D7, 0x1843, 0x1AA7, 0x1D78, 0x2071, 0x207F, 0x2D6F, 0x2E2F, 0x3005, 0x303B, 0xA015, 0xA60C, 0xA67F, 0xA770, 0xA788, 0xA9CF, 0xA9E6, 0xAA70, 0xAADD, 0xAB69, 0xFF70, 0x16FE3, 0x1E4EB, 0x1E94B);
		    set.addRange(0x2B0, 0x2C1).addRange(0x2C6, 0x2D1).addRange(0x2E0, 0x2E4).addRange(0x6E5, 0x6E6).addRange(0x7F4, 0x7F5).addRange(0x1C78, 0x1C7D).addRange(0x1D2C, 0x1D6A).addRange(0x1D9B, 0x1DBF).addRange(0x2090, 0x209C).addRange(0x2C7C, 0x2C7D).addRange(0x3031, 0x3035).addRange(0x309D, 0x309E).addRange(0x30FC, 0x30FE).addRange(0xA4F8, 0xA4FD).addRange(0xA69C, 0xA69D).addRange(0xA717, 0xA71F).addRange(0xA7F2, 0xA7F4).addRange(0xA7F8, 0xA7F9).addRange(0xAAF3, 0xAAF4).addRange(0xAB5C, 0xAB5F).addRange(0xFF9E, 0xFF9F).addRange(0x10780, 0x10785).addRange(0x10787, 0x107B0).addRange(0x107B2, 0x107BA).addRange(0x16B40, 0x16B43).addRange(0x16F93, 0x16F9F).addRange(0x16FE0, 0x16FE1).addRange(0x1AFF0, 0x1AFF3).addRange(0x1AFF5, 0x1AFFB).addRange(0x1AFFD, 0x1AFFE).addRange(0x1E030, 0x1E06D).addRange(0x1E137, 0x1E13D);
		    Modifier_Letter.characters = set;
		    return Modifier_Letter;
		  }

		  var Modifier_Symbol = {};

		  var hasRequiredModifier_Symbol;
		  function requireModifier_Symbol() {
		    if (hasRequiredModifier_Symbol) return Modifier_Symbol;
		    hasRequiredModifier_Symbol = 1;
		    var set = regenerateExports(0x5E, 0x60, 0xA8, 0xAF, 0xB4, 0xB8, 0x2ED, 0x375, 0x888, 0x1FBD, 0xAB5B, 0xFF3E, 0xFF40, 0xFFE3);
		    set.addRange(0x2C2, 0x2C5).addRange(0x2D2, 0x2DF).addRange(0x2E5, 0x2EB).addRange(0x2EF, 0x2FF).addRange(0x384, 0x385).addRange(0x1FBF, 0x1FC1).addRange(0x1FCD, 0x1FCF).addRange(0x1FDD, 0x1FDF).addRange(0x1FED, 0x1FEF).addRange(0x1FFD, 0x1FFE).addRange(0x309B, 0x309C).addRange(0xA700, 0xA716).addRange(0xA720, 0xA721).addRange(0xA789, 0xA78A).addRange(0xAB6A, 0xAB6B).addRange(0xFBB2, 0xFBC2).addRange(0x1F3FB, 0x1F3FF);
		    Modifier_Symbol.characters = set;
		    return Modifier_Symbol;
		  }

		  var Nonspacing_Mark = {};

		  var hasRequiredNonspacing_Mark;
		  function requireNonspacing_Mark() {
		    if (hasRequiredNonspacing_Mark) return Nonspacing_Mark;
		    hasRequiredNonspacing_Mark = 1;
		    var set = regenerateExports(0x5BF, 0x5C7, 0x670, 0x711, 0x7FD, 0x93A, 0x93C, 0x94D, 0x981, 0x9BC, 0x9CD, 0x9FE, 0xA3C, 0xA51, 0xA75, 0xABC, 0xACD, 0xB01, 0xB3C, 0xB3F, 0xB4D, 0xB82, 0xBC0, 0xBCD, 0xC00, 0xC04, 0xC3C, 0xC81, 0xCBC, 0xCBF, 0xCC6, 0xD4D, 0xD81, 0xDCA, 0xDD6, 0xE31, 0xEB1, 0xF35, 0xF37, 0xF39, 0xFC6, 0x1082, 0x108D, 0x109D, 0x17C6, 0x17DD, 0x180F, 0x18A9, 0x1932, 0x1A1B, 0x1A56, 0x1A60, 0x1A62, 0x1A7F, 0x1B34, 0x1B3C, 0x1B42, 0x1BE6, 0x1BED, 0x1CED, 0x1CF4, 0x20E1, 0x2D7F, 0xA66F, 0xA802, 0xA806, 0xA80B, 0xA82C, 0xA8FF, 0xA9B3, 0xA9E5, 0xAA43, 0xAA4C, 0xAA7C, 0xAAB0, 0xAAC1, 0xAAF6, 0xABE5, 0xABE8, 0xABED, 0xFB1E, 0x101FD, 0x102E0, 0x10A3F, 0x11001, 0x11070, 0x110C2, 0x11173, 0x111CF, 0x11234, 0x1123E, 0x11241, 0x112DF, 0x11340, 0x11446, 0x1145E, 0x114BA, 0x1163D, 0x116AB, 0x116AD, 0x116B7, 0x1193E, 0x11943, 0x119E0, 0x11A47, 0x11C3F, 0x11D3A, 0x11D47, 0x11D95, 0x11D97, 0x11F40, 0x11F42, 0x13440, 0x16F4F, 0x16FE4, 0x1DA75, 0x1DA84, 0x1E08F, 0x1E2AE);
		    set.addRange(0x300, 0x36F).addRange(0x483, 0x487).addRange(0x591, 0x5BD).addRange(0x5C1, 0x5C2).addRange(0x5C4, 0x5C5).addRange(0x610, 0x61A).addRange(0x64B, 0x65F).addRange(0x6D6, 0x6DC).addRange(0x6DF, 0x6E4).addRange(0x6E7, 0x6E8).addRange(0x6EA, 0x6ED).addRange(0x730, 0x74A).addRange(0x7A6, 0x7B0).addRange(0x7EB, 0x7F3).addRange(0x816, 0x819).addRange(0x81B, 0x823).addRange(0x825, 0x827).addRange(0x829, 0x82D).addRange(0x859, 0x85B).addRange(0x898, 0x89F).addRange(0x8CA, 0x8E1).addRange(0x8E3, 0x902).addRange(0x941, 0x948).addRange(0x951, 0x957).addRange(0x962, 0x963).addRange(0x9C1, 0x9C4).addRange(0x9E2, 0x9E3).addRange(0xA01, 0xA02).addRange(0xA41, 0xA42).addRange(0xA47, 0xA48).addRange(0xA4B, 0xA4D).addRange(0xA70, 0xA71).addRange(0xA81, 0xA82).addRange(0xAC1, 0xAC5).addRange(0xAC7, 0xAC8).addRange(0xAE2, 0xAE3).addRange(0xAFA, 0xAFF).addRange(0xB41, 0xB44).addRange(0xB55, 0xB56).addRange(0xB62, 0xB63).addRange(0xC3E, 0xC40).addRange(0xC46, 0xC48).addRange(0xC4A, 0xC4D).addRange(0xC55, 0xC56).addRange(0xC62, 0xC63).addRange(0xCCC, 0xCCD).addRange(0xCE2, 0xCE3).addRange(0xD00, 0xD01).addRange(0xD3B, 0xD3C).addRange(0xD41, 0xD44).addRange(0xD62, 0xD63);
		    set.addRange(0xDD2, 0xDD4).addRange(0xE34, 0xE3A).addRange(0xE47, 0xE4E).addRange(0xEB4, 0xEBC).addRange(0xEC8, 0xECE).addRange(0xF18, 0xF19).addRange(0xF71, 0xF7E).addRange(0xF80, 0xF84).addRange(0xF86, 0xF87).addRange(0xF8D, 0xF97).addRange(0xF99, 0xFBC).addRange(0x102D, 0x1030).addRange(0x1032, 0x1037).addRange(0x1039, 0x103A).addRange(0x103D, 0x103E).addRange(0x1058, 0x1059).addRange(0x105E, 0x1060).addRange(0x1071, 0x1074).addRange(0x1085, 0x1086).addRange(0x135D, 0x135F).addRange(0x1712, 0x1714).addRange(0x1732, 0x1733).addRange(0x1752, 0x1753).addRange(0x1772, 0x1773).addRange(0x17B4, 0x17B5).addRange(0x17B7, 0x17BD).addRange(0x17C9, 0x17D3).addRange(0x180B, 0x180D).addRange(0x1885, 0x1886).addRange(0x1920, 0x1922).addRange(0x1927, 0x1928).addRange(0x1939, 0x193B).addRange(0x1A17, 0x1A18).addRange(0x1A58, 0x1A5E).addRange(0x1A65, 0x1A6C).addRange(0x1A73, 0x1A7C).addRange(0x1AB0, 0x1ABD).addRange(0x1ABF, 0x1ACE).addRange(0x1B00, 0x1B03).addRange(0x1B36, 0x1B3A).addRange(0x1B6B, 0x1B73).addRange(0x1B80, 0x1B81).addRange(0x1BA2, 0x1BA5).addRange(0x1BA8, 0x1BA9).addRange(0x1BAB, 0x1BAD).addRange(0x1BE8, 0x1BE9).addRange(0x1BEF, 0x1BF1).addRange(0x1C2C, 0x1C33).addRange(0x1C36, 0x1C37).addRange(0x1CD0, 0x1CD2).addRange(0x1CD4, 0x1CE0);
		    set.addRange(0x1CE2, 0x1CE8).addRange(0x1CF8, 0x1CF9).addRange(0x1DC0, 0x1DFF).addRange(0x20D0, 0x20DC).addRange(0x20E5, 0x20F0).addRange(0x2CEF, 0x2CF1).addRange(0x2DE0, 0x2DFF).addRange(0x302A, 0x302D).addRange(0x3099, 0x309A).addRange(0xA674, 0xA67D).addRange(0xA69E, 0xA69F).addRange(0xA6F0, 0xA6F1).addRange(0xA825, 0xA826).addRange(0xA8C4, 0xA8C5).addRange(0xA8E0, 0xA8F1).addRange(0xA926, 0xA92D).addRange(0xA947, 0xA951).addRange(0xA980, 0xA982).addRange(0xA9B6, 0xA9B9).addRange(0xA9BC, 0xA9BD).addRange(0xAA29, 0xAA2E).addRange(0xAA31, 0xAA32).addRange(0xAA35, 0xAA36).addRange(0xAAB2, 0xAAB4).addRange(0xAAB7, 0xAAB8).addRange(0xAABE, 0xAABF).addRange(0xAAEC, 0xAAED).addRange(0xFE00, 0xFE0F).addRange(0xFE20, 0xFE2F).addRange(0x10376, 0x1037A).addRange(0x10A01, 0x10A03).addRange(0x10A05, 0x10A06).addRange(0x10A0C, 0x10A0F).addRange(0x10A38, 0x10A3A).addRange(0x10AE5, 0x10AE6).addRange(0x10D24, 0x10D27).addRange(0x10EAB, 0x10EAC).addRange(0x10EFD, 0x10EFF).addRange(0x10F46, 0x10F50).addRange(0x10F82, 0x10F85).addRange(0x11038, 0x11046).addRange(0x11073, 0x11074).addRange(0x1107F, 0x11081).addRange(0x110B3, 0x110B6).addRange(0x110B9, 0x110BA).addRange(0x11100, 0x11102).addRange(0x11127, 0x1112B).addRange(0x1112D, 0x11134).addRange(0x11180, 0x11181).addRange(0x111B6, 0x111BE).addRange(0x111C9, 0x111CC);
		    set.addRange(0x1122F, 0x11231).addRange(0x11236, 0x11237).addRange(0x112E3, 0x112EA).addRange(0x11300, 0x11301).addRange(0x1133B, 0x1133C).addRange(0x11366, 0x1136C).addRange(0x11370, 0x11374).addRange(0x11438, 0x1143F).addRange(0x11442, 0x11444).addRange(0x114B3, 0x114B8).addRange(0x114BF, 0x114C0).addRange(0x114C2, 0x114C3).addRange(0x115B2, 0x115B5).addRange(0x115BC, 0x115BD).addRange(0x115BF, 0x115C0).addRange(0x115DC, 0x115DD).addRange(0x11633, 0x1163A).addRange(0x1163F, 0x11640).addRange(0x116B0, 0x116B5).addRange(0x1171D, 0x1171F).addRange(0x11722, 0x11725).addRange(0x11727, 0x1172B).addRange(0x1182F, 0x11837).addRange(0x11839, 0x1183A).addRange(0x1193B, 0x1193C).addRange(0x119D4, 0x119D7).addRange(0x119DA, 0x119DB).addRange(0x11A01, 0x11A0A).addRange(0x11A33, 0x11A38).addRange(0x11A3B, 0x11A3E).addRange(0x11A51, 0x11A56).addRange(0x11A59, 0x11A5B).addRange(0x11A8A, 0x11A96).addRange(0x11A98, 0x11A99).addRange(0x11C30, 0x11C36).addRange(0x11C38, 0x11C3D).addRange(0x11C92, 0x11CA7).addRange(0x11CAA, 0x11CB0).addRange(0x11CB2, 0x11CB3).addRange(0x11CB5, 0x11CB6).addRange(0x11D31, 0x11D36).addRange(0x11D3C, 0x11D3D).addRange(0x11D3F, 0x11D45).addRange(0x11D90, 0x11D91).addRange(0x11EF3, 0x11EF4).addRange(0x11F00, 0x11F01).addRange(0x11F36, 0x11F3A).addRange(0x13447, 0x13455).addRange(0x16AF0, 0x16AF4).addRange(0x16B30, 0x16B36).addRange(0x16F8F, 0x16F92);
		    set.addRange(0x1BC9D, 0x1BC9E).addRange(0x1CF00, 0x1CF2D).addRange(0x1CF30, 0x1CF46).addRange(0x1D167, 0x1D169).addRange(0x1D17B, 0x1D182).addRange(0x1D185, 0x1D18B).addRange(0x1D1AA, 0x1D1AD).addRange(0x1D242, 0x1D244).addRange(0x1DA00, 0x1DA36).addRange(0x1DA3B, 0x1DA6C).addRange(0x1DA9B, 0x1DA9F).addRange(0x1DAA1, 0x1DAAF).addRange(0x1E000, 0x1E006).addRange(0x1E008, 0x1E018).addRange(0x1E01B, 0x1E021).addRange(0x1E023, 0x1E024).addRange(0x1E026, 0x1E02A).addRange(0x1E130, 0x1E136).addRange(0x1E2EC, 0x1E2EF).addRange(0x1E4EC, 0x1E4EF).addRange(0x1E8D0, 0x1E8D6).addRange(0x1E944, 0x1E94A).addRange(0xE0100, 0xE01EF);
		    Nonspacing_Mark.characters = set;
		    return Nonspacing_Mark;
		  }

		  var _Number = {};

		  var hasRequired_Number;
		  function require_Number() {
		    if (hasRequired_Number) return _Number;
		    hasRequired_Number = 1;
		    var set = regenerateExports(0xB9, 0x2070, 0x2CFD, 0x3007, 0x10341, 0x1034A);
		    set.addRange(0x30, 0x39).addRange(0xB2, 0xB3).addRange(0xBC, 0xBE).addRange(0x660, 0x669).addRange(0x6F0, 0x6F9).addRange(0x7C0, 0x7C9).addRange(0x966, 0x96F).addRange(0x9E6, 0x9EF).addRange(0x9F4, 0x9F9).addRange(0xA66, 0xA6F).addRange(0xAE6, 0xAEF).addRange(0xB66, 0xB6F).addRange(0xB72, 0xB77).addRange(0xBE6, 0xBF2).addRange(0xC66, 0xC6F).addRange(0xC78, 0xC7E).addRange(0xCE6, 0xCEF).addRange(0xD58, 0xD5E).addRange(0xD66, 0xD78).addRange(0xDE6, 0xDEF).addRange(0xE50, 0xE59).addRange(0xED0, 0xED9).addRange(0xF20, 0xF33).addRange(0x1040, 0x1049).addRange(0x1090, 0x1099).addRange(0x1369, 0x137C).addRange(0x16EE, 0x16F0).addRange(0x17E0, 0x17E9).addRange(0x17F0, 0x17F9).addRange(0x1810, 0x1819).addRange(0x1946, 0x194F).addRange(0x19D0, 0x19DA).addRange(0x1A80, 0x1A89).addRange(0x1A90, 0x1A99).addRange(0x1B50, 0x1B59).addRange(0x1BB0, 0x1BB9).addRange(0x1C40, 0x1C49).addRange(0x1C50, 0x1C59).addRange(0x2074, 0x2079).addRange(0x2080, 0x2089).addRange(0x2150, 0x2182).addRange(0x2185, 0x2189).addRange(0x2460, 0x249B).addRange(0x24EA, 0x24FF).addRange(0x2776, 0x2793).addRange(0x3021, 0x3029).addRange(0x3038, 0x303A).addRange(0x3192, 0x3195).addRange(0x3220, 0x3229).addRange(0x3248, 0x324F).addRange(0x3251, 0x325F);
		    set.addRange(0x3280, 0x3289).addRange(0x32B1, 0x32BF).addRange(0xA620, 0xA629).addRange(0xA6E6, 0xA6EF).addRange(0xA830, 0xA835).addRange(0xA8D0, 0xA8D9).addRange(0xA900, 0xA909).addRange(0xA9D0, 0xA9D9).addRange(0xA9F0, 0xA9F9).addRange(0xAA50, 0xAA59).addRange(0xABF0, 0xABF9).addRange(0xFF10, 0xFF19).addRange(0x10107, 0x10133).addRange(0x10140, 0x10178).addRange(0x1018A, 0x1018B).addRange(0x102E1, 0x102FB).addRange(0x10320, 0x10323).addRange(0x103D1, 0x103D5).addRange(0x104A0, 0x104A9).addRange(0x10858, 0x1085F).addRange(0x10879, 0x1087F).addRange(0x108A7, 0x108AF).addRange(0x108FB, 0x108FF).addRange(0x10916, 0x1091B).addRange(0x109BC, 0x109BD).addRange(0x109C0, 0x109CF).addRange(0x109D2, 0x109FF).addRange(0x10A40, 0x10A48).addRange(0x10A7D, 0x10A7E).addRange(0x10A9D, 0x10A9F).addRange(0x10AEB, 0x10AEF).addRange(0x10B58, 0x10B5F).addRange(0x10B78, 0x10B7F).addRange(0x10BA9, 0x10BAF).addRange(0x10CFA, 0x10CFF).addRange(0x10D30, 0x10D39).addRange(0x10E60, 0x10E7E).addRange(0x10F1D, 0x10F26).addRange(0x10F51, 0x10F54).addRange(0x10FC5, 0x10FCB).addRange(0x11052, 0x1106F).addRange(0x110F0, 0x110F9).addRange(0x11136, 0x1113F).addRange(0x111D0, 0x111D9).addRange(0x111E1, 0x111F4).addRange(0x112F0, 0x112F9).addRange(0x11450, 0x11459).addRange(0x114D0, 0x114D9).addRange(0x11650, 0x11659).addRange(0x116C0, 0x116C9).addRange(0x11730, 0x1173B);
		    set.addRange(0x118E0, 0x118F2).addRange(0x11950, 0x11959).addRange(0x11C50, 0x11C6C).addRange(0x11D50, 0x11D59).addRange(0x11DA0, 0x11DA9).addRange(0x11F50, 0x11F59).addRange(0x11FC0, 0x11FD4).addRange(0x12400, 0x1246E).addRange(0x16A60, 0x16A69).addRange(0x16AC0, 0x16AC9).addRange(0x16B50, 0x16B59).addRange(0x16B5B, 0x16B61).addRange(0x16E80, 0x16E96).addRange(0x1D2C0, 0x1D2D3).addRange(0x1D2E0, 0x1D2F3).addRange(0x1D360, 0x1D378).addRange(0x1D7CE, 0x1D7FF).addRange(0x1E140, 0x1E149).addRange(0x1E2F0, 0x1E2F9).addRange(0x1E4F0, 0x1E4F9).addRange(0x1E8C7, 0x1E8CF).addRange(0x1E950, 0x1E959).addRange(0x1EC71, 0x1ECAB).addRange(0x1ECAD, 0x1ECAF).addRange(0x1ECB1, 0x1ECB4).addRange(0x1ED01, 0x1ED2D).addRange(0x1ED2F, 0x1ED3D).addRange(0x1F100, 0x1F10C).addRange(0x1FBF0, 0x1FBF9);
		    _Number.characters = set;
		    return _Number;
		  }

		  var Open_Punctuation = {};

		  var hasRequiredOpen_Punctuation;
		  function requireOpen_Punctuation() {
		    if (hasRequiredOpen_Punctuation) return Open_Punctuation;
		    hasRequiredOpen_Punctuation = 1;
		    var set = regenerateExports(0x28, 0x5B, 0x7B, 0xF3A, 0xF3C, 0x169B, 0x201A, 0x201E, 0x2045, 0x207D, 0x208D, 0x2308, 0x230A, 0x2329, 0x2768, 0x276A, 0x276C, 0x276E, 0x2770, 0x2772, 0x2774, 0x27C5, 0x27E6, 0x27E8, 0x27EA, 0x27EC, 0x27EE, 0x2983, 0x2985, 0x2987, 0x2989, 0x298B, 0x298D, 0x298F, 0x2991, 0x2993, 0x2995, 0x2997, 0x29D8, 0x29DA, 0x29FC, 0x2E22, 0x2E24, 0x2E26, 0x2E28, 0x2E42, 0x2E55, 0x2E57, 0x2E59, 0x2E5B, 0x3008, 0x300A, 0x300C, 0x300E, 0x3010, 0x3014, 0x3016, 0x3018, 0x301A, 0x301D, 0xFD3F, 0xFE17, 0xFE35, 0xFE37, 0xFE39, 0xFE3B, 0xFE3D, 0xFE3F, 0xFE41, 0xFE43, 0xFE47, 0xFE59, 0xFE5B, 0xFE5D, 0xFF08, 0xFF3B, 0xFF5B, 0xFF5F, 0xFF62);
		    Open_Punctuation.characters = set;
		    return Open_Punctuation;
		  }

		  var Other_Letter = {};

		  var hasRequiredOther_Letter;
		  function requireOther_Letter() {
		    if (hasRequiredOther_Letter) return Other_Letter;
		    hasRequiredOther_Letter = 1;
		    var set = regenerateExports(0xAA, 0xBA, 0x1BB, 0x294, 0x6D5, 0x6FF, 0x710, 0x7B1, 0x93D, 0x950, 0x9B2, 0x9BD, 0x9CE, 0x9FC, 0xA5E, 0xABD, 0xAD0, 0xAF9, 0xB3D, 0xB71, 0xB83, 0xB9C, 0xBD0, 0xC3D, 0xC5D, 0xC80, 0xCBD, 0xD3D, 0xD4E, 0xDBD, 0xE84, 0xEA5, 0xEBD, 0xF00, 0x103F, 0x1061, 0x108E, 0x1258, 0x12C0, 0x17DC, 0x18AA, 0x1CFA, 0x3006, 0x303C, 0x309F, 0x30FF, 0xA66E, 0xA78F, 0xA7F7, 0xA8FB, 0xAA7A, 0xAAB1, 0xAAC0, 0xAAC2, 0xAAF2, 0xFB1D, 0xFB3E, 0x10808, 0x1083C, 0x10A00, 0x10F27, 0x11075, 0x11144, 0x11147, 0x11176, 0x111DA, 0x111DC, 0x11288, 0x1133D, 0x11350, 0x114C7, 0x11644, 0x116B8, 0x11909, 0x1193F, 0x11941, 0x119E1, 0x119E3, 0x11A00, 0x11A3A, 0x11A50, 0x11A9D, 0x11C40, 0x11D46, 0x11D98, 0x11F02, 0x11FB0, 0x16F50, 0x1B132, 0x1B155, 0x1DF0A, 0x1E14E, 0x1EE24, 0x1EE27, 0x1EE39, 0x1EE3B, 0x1EE42, 0x1EE47, 0x1EE49, 0x1EE4B, 0x1EE54, 0x1EE57, 0x1EE59, 0x1EE5B, 0x1EE5D, 0x1EE5F, 0x1EE64, 0x1EE7E);
		    set.addRange(0x1C0, 0x1C3).addRange(0x5D0, 0x5EA).addRange(0x5EF, 0x5F2).addRange(0x620, 0x63F).addRange(0x641, 0x64A).addRange(0x66E, 0x66F).addRange(0x671, 0x6D3).addRange(0x6EE, 0x6EF).addRange(0x6FA, 0x6FC).addRange(0x712, 0x72F).addRange(0x74D, 0x7A5).addRange(0x7CA, 0x7EA).addRange(0x800, 0x815).addRange(0x840, 0x858).addRange(0x860, 0x86A).addRange(0x870, 0x887).addRange(0x889, 0x88E).addRange(0x8A0, 0x8C8).addRange(0x904, 0x939).addRange(0x958, 0x961).addRange(0x972, 0x980).addRange(0x985, 0x98C).addRange(0x98F, 0x990).addRange(0x993, 0x9A8).addRange(0x9AA, 0x9B0).addRange(0x9B6, 0x9B9).addRange(0x9DC, 0x9DD).addRange(0x9DF, 0x9E1).addRange(0x9F0, 0x9F1).addRange(0xA05, 0xA0A).addRange(0xA0F, 0xA10).addRange(0xA13, 0xA28).addRange(0xA2A, 0xA30).addRange(0xA32, 0xA33).addRange(0xA35, 0xA36).addRange(0xA38, 0xA39).addRange(0xA59, 0xA5C).addRange(0xA72, 0xA74).addRange(0xA85, 0xA8D).addRange(0xA8F, 0xA91).addRange(0xA93, 0xAA8).addRange(0xAAA, 0xAB0).addRange(0xAB2, 0xAB3).addRange(0xAB5, 0xAB9).addRange(0xAE0, 0xAE1).addRange(0xB05, 0xB0C).addRange(0xB0F, 0xB10).addRange(0xB13, 0xB28).addRange(0xB2A, 0xB30).addRange(0xB32, 0xB33).addRange(0xB35, 0xB39);
		    set.addRange(0xB5C, 0xB5D).addRange(0xB5F, 0xB61).addRange(0xB85, 0xB8A).addRange(0xB8E, 0xB90).addRange(0xB92, 0xB95).addRange(0xB99, 0xB9A).addRange(0xB9E, 0xB9F).addRange(0xBA3, 0xBA4).addRange(0xBA8, 0xBAA).addRange(0xBAE, 0xBB9).addRange(0xC05, 0xC0C).addRange(0xC0E, 0xC10).addRange(0xC12, 0xC28).addRange(0xC2A, 0xC39).addRange(0xC58, 0xC5A).addRange(0xC60, 0xC61).addRange(0xC85, 0xC8C).addRange(0xC8E, 0xC90).addRange(0xC92, 0xCA8).addRange(0xCAA, 0xCB3).addRange(0xCB5, 0xCB9).addRange(0xCDD, 0xCDE).addRange(0xCE0, 0xCE1).addRange(0xCF1, 0xCF2).addRange(0xD04, 0xD0C).addRange(0xD0E, 0xD10).addRange(0xD12, 0xD3A).addRange(0xD54, 0xD56).addRange(0xD5F, 0xD61).addRange(0xD7A, 0xD7F).addRange(0xD85, 0xD96).addRange(0xD9A, 0xDB1).addRange(0xDB3, 0xDBB).addRange(0xDC0, 0xDC6).addRange(0xE01, 0xE30).addRange(0xE32, 0xE33).addRange(0xE40, 0xE45).addRange(0xE81, 0xE82).addRange(0xE86, 0xE8A).addRange(0xE8C, 0xEA3).addRange(0xEA7, 0xEB0).addRange(0xEB2, 0xEB3).addRange(0xEC0, 0xEC4).addRange(0xEDC, 0xEDF).addRange(0xF40, 0xF47).addRange(0xF49, 0xF6C).addRange(0xF88, 0xF8C).addRange(0x1000, 0x102A).addRange(0x1050, 0x1055).addRange(0x105A, 0x105D).addRange(0x1065, 0x1066);
		    set.addRange(0x106E, 0x1070).addRange(0x1075, 0x1081).addRange(0x1100, 0x1248).addRange(0x124A, 0x124D).addRange(0x1250, 0x1256).addRange(0x125A, 0x125D).addRange(0x1260, 0x1288).addRange(0x128A, 0x128D).addRange(0x1290, 0x12B0).addRange(0x12B2, 0x12B5).addRange(0x12B8, 0x12BE).addRange(0x12C2, 0x12C5).addRange(0x12C8, 0x12D6).addRange(0x12D8, 0x1310).addRange(0x1312, 0x1315).addRange(0x1318, 0x135A).addRange(0x1380, 0x138F).addRange(0x1401, 0x166C).addRange(0x166F, 0x167F).addRange(0x1681, 0x169A).addRange(0x16A0, 0x16EA).addRange(0x16F1, 0x16F8).addRange(0x1700, 0x1711).addRange(0x171F, 0x1731).addRange(0x1740, 0x1751).addRange(0x1760, 0x176C).addRange(0x176E, 0x1770).addRange(0x1780, 0x17B3).addRange(0x1820, 0x1842).addRange(0x1844, 0x1878).addRange(0x1880, 0x1884).addRange(0x1887, 0x18A8).addRange(0x18B0, 0x18F5).addRange(0x1900, 0x191E).addRange(0x1950, 0x196D).addRange(0x1970, 0x1974).addRange(0x1980, 0x19AB).addRange(0x19B0, 0x19C9).addRange(0x1A00, 0x1A16).addRange(0x1A20, 0x1A54).addRange(0x1B05, 0x1B33).addRange(0x1B45, 0x1B4C).addRange(0x1B83, 0x1BA0).addRange(0x1BAE, 0x1BAF).addRange(0x1BBA, 0x1BE5).addRange(0x1C00, 0x1C23).addRange(0x1C4D, 0x1C4F).addRange(0x1C5A, 0x1C77).addRange(0x1CE9, 0x1CEC).addRange(0x1CEE, 0x1CF3).addRange(0x1CF5, 0x1CF6);
		    set.addRange(0x2135, 0x2138).addRange(0x2D30, 0x2D67).addRange(0x2D80, 0x2D96).addRange(0x2DA0, 0x2DA6).addRange(0x2DA8, 0x2DAE).addRange(0x2DB0, 0x2DB6).addRange(0x2DB8, 0x2DBE).addRange(0x2DC0, 0x2DC6).addRange(0x2DC8, 0x2DCE).addRange(0x2DD0, 0x2DD6).addRange(0x2DD8, 0x2DDE).addRange(0x3041, 0x3096).addRange(0x30A1, 0x30FA).addRange(0x3105, 0x312F).addRange(0x3131, 0x318E).addRange(0x31A0, 0x31BF).addRange(0x31F0, 0x31FF).addRange(0x3400, 0x4DBF).addRange(0x4E00, 0xA014).addRange(0xA016, 0xA48C).addRange(0xA4D0, 0xA4F7).addRange(0xA500, 0xA60B).addRange(0xA610, 0xA61F).addRange(0xA62A, 0xA62B).addRange(0xA6A0, 0xA6E5).addRange(0xA7FB, 0xA801).addRange(0xA803, 0xA805).addRange(0xA807, 0xA80A).addRange(0xA80C, 0xA822).addRange(0xA840, 0xA873).addRange(0xA882, 0xA8B3).addRange(0xA8F2, 0xA8F7).addRange(0xA8FD, 0xA8FE).addRange(0xA90A, 0xA925).addRange(0xA930, 0xA946).addRange(0xA960, 0xA97C).addRange(0xA984, 0xA9B2).addRange(0xA9E0, 0xA9E4).addRange(0xA9E7, 0xA9EF).addRange(0xA9FA, 0xA9FE).addRange(0xAA00, 0xAA28).addRange(0xAA40, 0xAA42).addRange(0xAA44, 0xAA4B).addRange(0xAA60, 0xAA6F).addRange(0xAA71, 0xAA76).addRange(0xAA7E, 0xAAAF).addRange(0xAAB5, 0xAAB6).addRange(0xAAB9, 0xAABD).addRange(0xAADB, 0xAADC).addRange(0xAAE0, 0xAAEA).addRange(0xAB01, 0xAB06);
		    set.addRange(0xAB09, 0xAB0E).addRange(0xAB11, 0xAB16).addRange(0xAB20, 0xAB26).addRange(0xAB28, 0xAB2E).addRange(0xABC0, 0xABE2).addRange(0xAC00, 0xD7A3).addRange(0xD7B0, 0xD7C6).addRange(0xD7CB, 0xD7FB).addRange(0xF900, 0xFA6D).addRange(0xFA70, 0xFAD9).addRange(0xFB1F, 0xFB28).addRange(0xFB2A, 0xFB36).addRange(0xFB38, 0xFB3C).addRange(0xFB40, 0xFB41).addRange(0xFB43, 0xFB44).addRange(0xFB46, 0xFBB1).addRange(0xFBD3, 0xFD3D).addRange(0xFD50, 0xFD8F).addRange(0xFD92, 0xFDC7).addRange(0xFDF0, 0xFDFB).addRange(0xFE70, 0xFE74).addRange(0xFE76, 0xFEFC).addRange(0xFF66, 0xFF6F).addRange(0xFF71, 0xFF9D).addRange(0xFFA0, 0xFFBE).addRange(0xFFC2, 0xFFC7).addRange(0xFFCA, 0xFFCF).addRange(0xFFD2, 0xFFD7).addRange(0xFFDA, 0xFFDC).addRange(0x10000, 0x1000B).addRange(0x1000D, 0x10026).addRange(0x10028, 0x1003A).addRange(0x1003C, 0x1003D).addRange(0x1003F, 0x1004D).addRange(0x10050, 0x1005D).addRange(0x10080, 0x100FA).addRange(0x10280, 0x1029C).addRange(0x102A0, 0x102D0).addRange(0x10300, 0x1031F).addRange(0x1032D, 0x10340).addRange(0x10342, 0x10349).addRange(0x10350, 0x10375).addRange(0x10380, 0x1039D).addRange(0x103A0, 0x103C3).addRange(0x103C8, 0x103CF).addRange(0x10450, 0x1049D).addRange(0x10500, 0x10527).addRange(0x10530, 0x10563).addRange(0x10600, 0x10736).addRange(0x10740, 0x10755).addRange(0x10760, 0x10767);
		    set.addRange(0x10800, 0x10805).addRange(0x1080A, 0x10835).addRange(0x10837, 0x10838).addRange(0x1083F, 0x10855).addRange(0x10860, 0x10876).addRange(0x10880, 0x1089E).addRange(0x108E0, 0x108F2).addRange(0x108F4, 0x108F5).addRange(0x10900, 0x10915).addRange(0x10920, 0x10939).addRange(0x10980, 0x109B7).addRange(0x109BE, 0x109BF).addRange(0x10A10, 0x10A13).addRange(0x10A15, 0x10A17).addRange(0x10A19, 0x10A35).addRange(0x10A60, 0x10A7C).addRange(0x10A80, 0x10A9C).addRange(0x10AC0, 0x10AC7).addRange(0x10AC9, 0x10AE4).addRange(0x10B00, 0x10B35).addRange(0x10B40, 0x10B55).addRange(0x10B60, 0x10B72).addRange(0x10B80, 0x10B91).addRange(0x10C00, 0x10C48).addRange(0x10D00, 0x10D23).addRange(0x10E80, 0x10EA9).addRange(0x10EB0, 0x10EB1).addRange(0x10F00, 0x10F1C).addRange(0x10F30, 0x10F45).addRange(0x10F70, 0x10F81).addRange(0x10FB0, 0x10FC4).addRange(0x10FE0, 0x10FF6).addRange(0x11003, 0x11037).addRange(0x11071, 0x11072).addRange(0x11083, 0x110AF).addRange(0x110D0, 0x110E8).addRange(0x11103, 0x11126).addRange(0x11150, 0x11172).addRange(0x11183, 0x111B2).addRange(0x111C1, 0x111C4).addRange(0x11200, 0x11211).addRange(0x11213, 0x1122B).addRange(0x1123F, 0x11240).addRange(0x11280, 0x11286).addRange(0x1128A, 0x1128D).addRange(0x1128F, 0x1129D).addRange(0x1129F, 0x112A8).addRange(0x112B0, 0x112DE).addRange(0x11305, 0x1130C).addRange(0x1130F, 0x11310).addRange(0x11313, 0x11328);
		    set.addRange(0x1132A, 0x11330).addRange(0x11332, 0x11333).addRange(0x11335, 0x11339).addRange(0x1135D, 0x11361).addRange(0x11400, 0x11434).addRange(0x11447, 0x1144A).addRange(0x1145F, 0x11461).addRange(0x11480, 0x114AF).addRange(0x114C4, 0x114C5).addRange(0x11580, 0x115AE).addRange(0x115D8, 0x115DB).addRange(0x11600, 0x1162F).addRange(0x11680, 0x116AA).addRange(0x11700, 0x1171A).addRange(0x11740, 0x11746).addRange(0x11800, 0x1182B).addRange(0x118FF, 0x11906).addRange(0x1190C, 0x11913).addRange(0x11915, 0x11916).addRange(0x11918, 0x1192F).addRange(0x119A0, 0x119A7).addRange(0x119AA, 0x119D0).addRange(0x11A0B, 0x11A32).addRange(0x11A5C, 0x11A89).addRange(0x11AB0, 0x11AF8).addRange(0x11C00, 0x11C08).addRange(0x11C0A, 0x11C2E).addRange(0x11C72, 0x11C8F).addRange(0x11D00, 0x11D06).addRange(0x11D08, 0x11D09).addRange(0x11D0B, 0x11D30).addRange(0x11D60, 0x11D65).addRange(0x11D67, 0x11D68).addRange(0x11D6A, 0x11D89).addRange(0x11EE0, 0x11EF2).addRange(0x11F04, 0x11F10).addRange(0x11F12, 0x11F33).addRange(0x12000, 0x12399).addRange(0x12480, 0x12543).addRange(0x12F90, 0x12FF0).addRange(0x13000, 0x1342F).addRange(0x13441, 0x13446).addRange(0x14400, 0x14646).addRange(0x16800, 0x16A38).addRange(0x16A40, 0x16A5E).addRange(0x16A70, 0x16ABE).addRange(0x16AD0, 0x16AED).addRange(0x16B00, 0x16B2F).addRange(0x16B63, 0x16B77).addRange(0x16B7D, 0x16B8F).addRange(0x16F00, 0x16F4A);
		    set.addRange(0x17000, 0x187F7).addRange(0x18800, 0x18CD5).addRange(0x18D00, 0x18D08).addRange(0x1B000, 0x1B122).addRange(0x1B150, 0x1B152).addRange(0x1B164, 0x1B167).addRange(0x1B170, 0x1B2FB).addRange(0x1BC00, 0x1BC6A).addRange(0x1BC70, 0x1BC7C).addRange(0x1BC80, 0x1BC88).addRange(0x1BC90, 0x1BC99).addRange(0x1E100, 0x1E12C).addRange(0x1E290, 0x1E2AD).addRange(0x1E2C0, 0x1E2EB).addRange(0x1E4D0, 0x1E4EA).addRange(0x1E7E0, 0x1E7E6).addRange(0x1E7E8, 0x1E7EB).addRange(0x1E7ED, 0x1E7EE).addRange(0x1E7F0, 0x1E7FE).addRange(0x1E800, 0x1E8C4).addRange(0x1EE00, 0x1EE03).addRange(0x1EE05, 0x1EE1F).addRange(0x1EE21, 0x1EE22).addRange(0x1EE29, 0x1EE32).addRange(0x1EE34, 0x1EE37).addRange(0x1EE4D, 0x1EE4F).addRange(0x1EE51, 0x1EE52).addRange(0x1EE61, 0x1EE62).addRange(0x1EE67, 0x1EE6A).addRange(0x1EE6C, 0x1EE72).addRange(0x1EE74, 0x1EE77).addRange(0x1EE79, 0x1EE7C).addRange(0x1EE80, 0x1EE89).addRange(0x1EE8B, 0x1EE9B).addRange(0x1EEA1, 0x1EEA3).addRange(0x1EEA5, 0x1EEA9).addRange(0x1EEAB, 0x1EEBB).addRange(0x20000, 0x2A6DF).addRange(0x2A700, 0x2B739).addRange(0x2B740, 0x2B81D).addRange(0x2B820, 0x2CEA1).addRange(0x2CEB0, 0x2EBE0).addRange(0x2EBF0, 0x2EE5D).addRange(0x2F800, 0x2FA1D).addRange(0x30000, 0x3134A).addRange(0x31350, 0x323AF);
		    Other_Letter.characters = set;
		    return Other_Letter;
		  }

		  var Other_Number = {};

		  var hasRequiredOther_Number;
		  function requireOther_Number() {
		    if (hasRequiredOther_Number) return Other_Number;
		    hasRequiredOther_Number = 1;
		    var set = regenerateExports(0xB9, 0x19DA, 0x2070, 0x2189, 0x2CFD);
		    set.addRange(0xB2, 0xB3).addRange(0xBC, 0xBE).addRange(0x9F4, 0x9F9).addRange(0xB72, 0xB77).addRange(0xBF0, 0xBF2).addRange(0xC78, 0xC7E).addRange(0xD58, 0xD5E).addRange(0xD70, 0xD78).addRange(0xF2A, 0xF33).addRange(0x1369, 0x137C).addRange(0x17F0, 0x17F9).addRange(0x2074, 0x2079).addRange(0x2080, 0x2089).addRange(0x2150, 0x215F).addRange(0x2460, 0x249B).addRange(0x24EA, 0x24FF).addRange(0x2776, 0x2793).addRange(0x3192, 0x3195).addRange(0x3220, 0x3229).addRange(0x3248, 0x324F).addRange(0x3251, 0x325F).addRange(0x3280, 0x3289).addRange(0x32B1, 0x32BF).addRange(0xA830, 0xA835).addRange(0x10107, 0x10133).addRange(0x10175, 0x10178).addRange(0x1018A, 0x1018B).addRange(0x102E1, 0x102FB).addRange(0x10320, 0x10323).addRange(0x10858, 0x1085F).addRange(0x10879, 0x1087F).addRange(0x108A7, 0x108AF).addRange(0x108FB, 0x108FF).addRange(0x10916, 0x1091B).addRange(0x109BC, 0x109BD).addRange(0x109C0, 0x109CF).addRange(0x109D2, 0x109FF).addRange(0x10A40, 0x10A48).addRange(0x10A7D, 0x10A7E).addRange(0x10A9D, 0x10A9F).addRange(0x10AEB, 0x10AEF).addRange(0x10B58, 0x10B5F).addRange(0x10B78, 0x10B7F).addRange(0x10BA9, 0x10BAF).addRange(0x10CFA, 0x10CFF).addRange(0x10E60, 0x10E7E).addRange(0x10F1D, 0x10F26).addRange(0x10F51, 0x10F54).addRange(0x10FC5, 0x10FCB).addRange(0x11052, 0x11065).addRange(0x111E1, 0x111F4);
		    set.addRange(0x1173A, 0x1173B).addRange(0x118EA, 0x118F2).addRange(0x11C5A, 0x11C6C).addRange(0x11FC0, 0x11FD4).addRange(0x16B5B, 0x16B61).addRange(0x16E80, 0x16E96).addRange(0x1D2C0, 0x1D2D3).addRange(0x1D2E0, 0x1D2F3).addRange(0x1D360, 0x1D378).addRange(0x1E8C7, 0x1E8CF).addRange(0x1EC71, 0x1ECAB).addRange(0x1ECAD, 0x1ECAF).addRange(0x1ECB1, 0x1ECB4).addRange(0x1ED01, 0x1ED2D).addRange(0x1ED2F, 0x1ED3D).addRange(0x1F100, 0x1F10C);
		    Other_Number.characters = set;
		    return Other_Number;
		  }

		  var Other_Punctuation = {};

		  var hasRequiredOther_Punctuation;
		  function requireOther_Punctuation() {
		    if (hasRequiredOther_Punctuation) return Other_Punctuation;
		    hasRequiredOther_Punctuation = 1;
		    var set = regenerateExports(0x2A, 0x2C, 0x5C, 0xA1, 0xA7, 0xBF, 0x37E, 0x387, 0x589, 0x5C0, 0x5C3, 0x5C6, 0x61B, 0x6D4, 0x85E, 0x970, 0x9FD, 0xA76, 0xAF0, 0xC77, 0xC84, 0xDF4, 0xE4F, 0xF14, 0xF85, 0x10FB, 0x166E, 0x1CD3, 0x2053, 0x2D70, 0x2E0B, 0x2E1B, 0x2E41, 0x303D, 0x30FB, 0xA673, 0xA67E, 0xA8FC, 0xA95F, 0xABEB, 0xFE19, 0xFE30, 0xFE68, 0xFF0A, 0xFF0C, 0xFF3C, 0xFF61, 0x1039F, 0x103D0, 0x1056F, 0x10857, 0x1091F, 0x1093F, 0x10A7F, 0x111CD, 0x111DB, 0x112A9, 0x1145D, 0x114C6, 0x116B9, 0x1183B, 0x119E2, 0x11FFF, 0x16AF5, 0x16B44, 0x16FE2, 0x1BC9F);
		    set.addRange(0x21, 0x23).addRange(0x25, 0x27).addRange(0x2E, 0x2F).addRange(0x3A, 0x3B).addRange(0x3F, 0x40).addRange(0xB6, 0xB7).addRange(0x55A, 0x55F).addRange(0x5F3, 0x5F4).addRange(0x609, 0x60A).addRange(0x60C, 0x60D).addRange(0x61D, 0x61F).addRange(0x66A, 0x66D).addRange(0x700, 0x70D).addRange(0x7F7, 0x7F9).addRange(0x830, 0x83E).addRange(0x964, 0x965).addRange(0xE5A, 0xE5B).addRange(0xF04, 0xF12).addRange(0xFD0, 0xFD4).addRange(0xFD9, 0xFDA).addRange(0x104A, 0x104F).addRange(0x1360, 0x1368).addRange(0x16EB, 0x16ED).addRange(0x1735, 0x1736).addRange(0x17D4, 0x17D6).addRange(0x17D8, 0x17DA).addRange(0x1800, 0x1805).addRange(0x1807, 0x180A).addRange(0x1944, 0x1945).addRange(0x1A1E, 0x1A1F).addRange(0x1AA0, 0x1AA6).addRange(0x1AA8, 0x1AAD).addRange(0x1B5A, 0x1B60).addRange(0x1B7D, 0x1B7E).addRange(0x1BFC, 0x1BFF).addRange(0x1C3B, 0x1C3F).addRange(0x1C7E, 0x1C7F).addRange(0x1CC0, 0x1CC7).addRange(0x2016, 0x2017).addRange(0x2020, 0x2027).addRange(0x2030, 0x2038).addRange(0x203B, 0x203E).addRange(0x2041, 0x2043).addRange(0x2047, 0x2051).addRange(0x2055, 0x205E).addRange(0x2CF9, 0x2CFC).addRange(0x2CFE, 0x2CFF).addRange(0x2E00, 0x2E01).addRange(0x2E06, 0x2E08).addRange(0x2E0E, 0x2E16).addRange(0x2E18, 0x2E19);
		    set.addRange(0x2E1E, 0x2E1F).addRange(0x2E2A, 0x2E2E).addRange(0x2E30, 0x2E39).addRange(0x2E3C, 0x2E3F).addRange(0x2E43, 0x2E4F).addRange(0x2E52, 0x2E54).addRange(0x3001, 0x3003).addRange(0xA4FE, 0xA4FF).addRange(0xA60D, 0xA60F).addRange(0xA6F2, 0xA6F7).addRange(0xA874, 0xA877).addRange(0xA8CE, 0xA8CF).addRange(0xA8F8, 0xA8FA).addRange(0xA92E, 0xA92F).addRange(0xA9C1, 0xA9CD).addRange(0xA9DE, 0xA9DF).addRange(0xAA5C, 0xAA5F).addRange(0xAADE, 0xAADF).addRange(0xAAF0, 0xAAF1).addRange(0xFE10, 0xFE16).addRange(0xFE45, 0xFE46).addRange(0xFE49, 0xFE4C).addRange(0xFE50, 0xFE52).addRange(0xFE54, 0xFE57).addRange(0xFE5F, 0xFE61).addRange(0xFE6A, 0xFE6B).addRange(0xFF01, 0xFF03).addRange(0xFF05, 0xFF07).addRange(0xFF0E, 0xFF0F).addRange(0xFF1A, 0xFF1B).addRange(0xFF1F, 0xFF20).addRange(0xFF64, 0xFF65).addRange(0x10100, 0x10102).addRange(0x10A50, 0x10A58).addRange(0x10AF0, 0x10AF6).addRange(0x10B39, 0x10B3F).addRange(0x10B99, 0x10B9C).addRange(0x10F55, 0x10F59).addRange(0x10F86, 0x10F89).addRange(0x11047, 0x1104D).addRange(0x110BB, 0x110BC).addRange(0x110BE, 0x110C1).addRange(0x11140, 0x11143).addRange(0x11174, 0x11175).addRange(0x111C5, 0x111C8).addRange(0x111DD, 0x111DF).addRange(0x11238, 0x1123D).addRange(0x1144B, 0x1144F).addRange(0x1145A, 0x1145B).addRange(0x115C1, 0x115D7).addRange(0x11641, 0x11643);
		    set.addRange(0x11660, 0x1166C).addRange(0x1173C, 0x1173E).addRange(0x11944, 0x11946).addRange(0x11A3F, 0x11A46).addRange(0x11A9A, 0x11A9C).addRange(0x11A9E, 0x11AA2).addRange(0x11B00, 0x11B09).addRange(0x11C41, 0x11C45).addRange(0x11C70, 0x11C71).addRange(0x11EF7, 0x11EF8).addRange(0x11F43, 0x11F4F).addRange(0x12470, 0x12474).addRange(0x12FF1, 0x12FF2).addRange(0x16A6E, 0x16A6F).addRange(0x16B37, 0x16B3B).addRange(0x16E97, 0x16E9A).addRange(0x1DA87, 0x1DA8B).addRange(0x1E95E, 0x1E95F);
		    Other_Punctuation.characters = set;
		    return Other_Punctuation;
		  }

		  var Other_Symbol = {};

		  var hasRequiredOther_Symbol;
		  function requireOther_Symbol() {
		    if (hasRequiredOther_Symbol) return Other_Symbol;
		    hasRequiredOther_Symbol = 1;
		    var set = regenerateExports(0xA6, 0xA9, 0xAE, 0xB0, 0x482, 0x6DE, 0x6E9, 0x7F6, 0x9FA, 0xB70, 0xBFA, 0xC7F, 0xD4F, 0xD79, 0xF13, 0xF34, 0xF36, 0xF38, 0x166D, 0x1940, 0x2114, 0x2125, 0x2127, 0x2129, 0x212E, 0x214A, 0x214F, 0x21D3, 0x3004, 0x3020, 0x31EF, 0x3250, 0xA839, 0xFDCF, 0xFFE4, 0xFFE8, 0x101A0, 0x10AC8, 0x1173F, 0x16B45, 0x1BC9C, 0x1D245, 0x1E14F, 0x1ECAC, 0x1ED2E, 0x1F7F0);
		    set.addRange(0x58D, 0x58E).addRange(0x60E, 0x60F).addRange(0x6FD, 0x6FE).addRange(0xBF3, 0xBF8).addRange(0xF01, 0xF03).addRange(0xF15, 0xF17).addRange(0xF1A, 0xF1F).addRange(0xFBE, 0xFC5).addRange(0xFC7, 0xFCC).addRange(0xFCE, 0xFCF).addRange(0xFD5, 0xFD8).addRange(0x109E, 0x109F).addRange(0x1390, 0x1399).addRange(0x19DE, 0x19FF).addRange(0x1B61, 0x1B6A).addRange(0x1B74, 0x1B7C).addRange(0x2100, 0x2101).addRange(0x2103, 0x2106).addRange(0x2108, 0x2109).addRange(0x2116, 0x2117).addRange(0x211E, 0x2123).addRange(0x213A, 0x213B).addRange(0x214C, 0x214D).addRange(0x218A, 0x218B).addRange(0x2195, 0x2199).addRange(0x219C, 0x219F).addRange(0x21A1, 0x21A2).addRange(0x21A4, 0x21A5).addRange(0x21A7, 0x21AD).addRange(0x21AF, 0x21CD).addRange(0x21D0, 0x21D1).addRange(0x21D5, 0x21F3).addRange(0x2300, 0x2307).addRange(0x230C, 0x231F).addRange(0x2322, 0x2328).addRange(0x232B, 0x237B).addRange(0x237D, 0x239A).addRange(0x23B4, 0x23DB).addRange(0x23E2, 0x2426).addRange(0x2440, 0x244A).addRange(0x249C, 0x24E9).addRange(0x2500, 0x25B6).addRange(0x25B8, 0x25C0).addRange(0x25C2, 0x25F7).addRange(0x2600, 0x266E).addRange(0x2670, 0x2767).addRange(0x2794, 0x27BF).addRange(0x2800, 0x28FF).addRange(0x2B00, 0x2B2F).addRange(0x2B45, 0x2B46).addRange(0x2B4D, 0x2B73);
		    set.addRange(0x2B76, 0x2B95).addRange(0x2B97, 0x2BFF).addRange(0x2CE5, 0x2CEA).addRange(0x2E50, 0x2E51).addRange(0x2E80, 0x2E99).addRange(0x2E9B, 0x2EF3).addRange(0x2F00, 0x2FD5).addRange(0x2FF0, 0x2FFF).addRange(0x3012, 0x3013).addRange(0x3036, 0x3037).addRange(0x303E, 0x303F).addRange(0x3190, 0x3191).addRange(0x3196, 0x319F).addRange(0x31C0, 0x31E3).addRange(0x3200, 0x321E).addRange(0x322A, 0x3247).addRange(0x3260, 0x327F).addRange(0x328A, 0x32B0).addRange(0x32C0, 0x33FF).addRange(0x4DC0, 0x4DFF).addRange(0xA490, 0xA4C6).addRange(0xA828, 0xA82B).addRange(0xA836, 0xA837).addRange(0xAA77, 0xAA79).addRange(0xFD40, 0xFD4F).addRange(0xFDFD, 0xFDFF).addRange(0xFFED, 0xFFEE).addRange(0xFFFC, 0xFFFD).addRange(0x10137, 0x1013F).addRange(0x10179, 0x10189).addRange(0x1018C, 0x1018E).addRange(0x10190, 0x1019C).addRange(0x101D0, 0x101FC).addRange(0x10877, 0x10878).addRange(0x11FD5, 0x11FDC).addRange(0x11FE1, 0x11FF1).addRange(0x16B3C, 0x16B3F).addRange(0x1CF50, 0x1CFC3).addRange(0x1D000, 0x1D0F5).addRange(0x1D100, 0x1D126).addRange(0x1D129, 0x1D164).addRange(0x1D16A, 0x1D16C).addRange(0x1D183, 0x1D184).addRange(0x1D18C, 0x1D1A9).addRange(0x1D1AE, 0x1D1EA).addRange(0x1D200, 0x1D241).addRange(0x1D300, 0x1D356).addRange(0x1D800, 0x1D9FF).addRange(0x1DA37, 0x1DA3A).addRange(0x1DA6D, 0x1DA74).addRange(0x1DA76, 0x1DA83);
		    set.addRange(0x1DA85, 0x1DA86).addRange(0x1F000, 0x1F02B).addRange(0x1F030, 0x1F093).addRange(0x1F0A0, 0x1F0AE).addRange(0x1F0B1, 0x1F0BF).addRange(0x1F0C1, 0x1F0CF).addRange(0x1F0D1, 0x1F0F5).addRange(0x1F10D, 0x1F1AD).addRange(0x1F1E6, 0x1F202).addRange(0x1F210, 0x1F23B).addRange(0x1F240, 0x1F248).addRange(0x1F250, 0x1F251).addRange(0x1F260, 0x1F265).addRange(0x1F300, 0x1F3FA).addRange(0x1F400, 0x1F6D7).addRange(0x1F6DC, 0x1F6EC).addRange(0x1F6F0, 0x1F6FC).addRange(0x1F700, 0x1F776).addRange(0x1F77B, 0x1F7D9).addRange(0x1F7E0, 0x1F7EB).addRange(0x1F800, 0x1F80B).addRange(0x1F810, 0x1F847).addRange(0x1F850, 0x1F859).addRange(0x1F860, 0x1F887).addRange(0x1F890, 0x1F8AD).addRange(0x1F8B0, 0x1F8B1).addRange(0x1F900, 0x1FA53).addRange(0x1FA60, 0x1FA6D).addRange(0x1FA70, 0x1FA7C).addRange(0x1FA80, 0x1FA88).addRange(0x1FA90, 0x1FABD).addRange(0x1FABF, 0x1FAC5).addRange(0x1FACE, 0x1FADB).addRange(0x1FAE0, 0x1FAE8).addRange(0x1FAF0, 0x1FAF8).addRange(0x1FB00, 0x1FB92).addRange(0x1FB94, 0x1FBCA);
		    Other_Symbol.characters = set;
		    return Other_Symbol;
		  }

		  var Other = {};

		  var hasRequiredOther;
		  function requireOther() {
		    if (hasRequiredOther) return Other;
		    hasRequiredOther = 1;
		    var set = regenerateExports(0xAD, 0x38B, 0x38D, 0x3A2, 0x530, 0x590, 0x61C, 0x6DD, 0x83F, 0x85F, 0x8E2, 0x984, 0x9A9, 0x9B1, 0x9DE, 0xA04, 0xA29, 0xA31, 0xA34, 0xA37, 0xA3D, 0xA5D, 0xA84, 0xA8E, 0xA92, 0xAA9, 0xAB1, 0xAB4, 0xAC6, 0xACA, 0xB00, 0xB04, 0xB29, 0xB31, 0xB34, 0xB5E, 0xB84, 0xB91, 0xB9B, 0xB9D, 0xBC9, 0xC0D, 0xC11, 0xC29, 0xC45, 0xC49, 0xC57, 0xC8D, 0xC91, 0xCA9, 0xCB4, 0xCC5, 0xCC9, 0xCDF, 0xCF0, 0xD0D, 0xD11, 0xD45, 0xD49, 0xD80, 0xD84, 0xDB2, 0xDBC, 0xDD5, 0xDD7, 0xE83, 0xE85, 0xE8B, 0xEA4, 0xEA6, 0xEC5, 0xEC7, 0xECF, 0xF48, 0xF98, 0xFBD, 0xFCD, 0x10C6, 0x1249, 0x1257, 0x1259, 0x1289, 0x12B1, 0x12BF, 0x12C1, 0x12D7, 0x1311, 0x176D, 0x1771, 0x180E, 0x191F, 0x1A5F, 0x1B7F, 0x1F58, 0x1F5A, 0x1F5C, 0x1F5E, 0x1FB5, 0x1FC5, 0x1FDC, 0x1FF5, 0x1FFF, 0x208F, 0x2B96, 0x2D26, 0x2DA7, 0x2DAF, 0x2DB7, 0x2DBF, 0x2DC7, 0x2DCF, 0x2DD7, 0x2DDF, 0x2E9A, 0x3040, 0x3130, 0x318F, 0x321F, 0xA7D2, 0xA7D4, 0xA9CE, 0xA9FF, 0xAB27, 0xAB2F, 0xFB37, 0xFB3D, 0xFB3F, 0xFB42, 0xFB45, 0xFE53, 0xFE67, 0xFE75, 0xFFE7, 0x1000C, 0x10027, 0x1003B, 0x1003E, 0x1018F, 0x1039E, 0x1057B, 0x1058B, 0x10593, 0x10596, 0x105A2, 0x105B2, 0x105BA, 0x10786, 0x107B1, 0x10809, 0x10836, 0x10856, 0x108F3, 0x10A04, 0x10A14, 0x10A18, 0x10E7F, 0x10EAA, 0x110BD, 0x11135, 0x111E0, 0x11212, 0x11287, 0x11289, 0x1128E, 0x1129E, 0x11304, 0x11329, 0x11331, 0x11334, 0x1133A, 0x1145C, 0x11914, 0x11917, 0x11936, 0x11C09, 0x11C37, 0x11CA8, 0x11D07, 0x11D0A, 0x11D3B, 0x11D3E, 0x11D66, 0x11D69, 0x11D8F, 0x11D92, 0x11F11, 0x1246F, 0x16A5F, 0x16ABF, 0x16B5A, 0x16B62, 0x1AFF4, 0x1AFFC, 0x1AFFF, 0x1D455, 0x1D49D, 0x1D4AD, 0x1D4BA, 0x1D4BC, 0x1D4C4, 0x1D506, 0x1D515, 0x1D51D, 0x1D53A, 0x1D53F, 0x1D545, 0x1D551, 0x1DAA0, 0x1E007, 0x1E022, 0x1E025, 0x1E7E7, 0x1E7EC, 0x1E7EF, 0x1E7FF, 0x1EE04, 0x1EE20, 0x1EE23, 0x1EE28, 0x1EE33, 0x1EE38, 0x1EE3A, 0x1EE48, 0x1EE4A, 0x1EE4C, 0x1EE50, 0x1EE53, 0x1EE58, 0x1EE5A, 0x1EE5C, 0x1EE5E, 0x1EE60, 0x1EE63, 0x1EE6B, 0x1EE73, 0x1EE78, 0x1EE7D, 0x1EE7F, 0x1EE8A, 0x1EEA4, 0x1EEAA, 0x1F0C0, 0x1F0D0, 0x1FABE, 0x1FB93);
		    set.addRange(0x0, 0x1F).addRange(0x7F, 0x9F).addRange(0x378, 0x379).addRange(0x380, 0x383).addRange(0x557, 0x558).addRange(0x58B, 0x58C).addRange(0x5C8, 0x5CF).addRange(0x5EB, 0x5EE).addRange(0x5F5, 0x605).addRange(0x70E, 0x70F).addRange(0x74B, 0x74C).addRange(0x7B2, 0x7BF).addRange(0x7FB, 0x7FC).addRange(0x82E, 0x82F).addRange(0x85C, 0x85D).addRange(0x86B, 0x86F).addRange(0x88F, 0x897).addRange(0x98D, 0x98E).addRange(0x991, 0x992).addRange(0x9B3, 0x9B5).addRange(0x9BA, 0x9BB).addRange(0x9C5, 0x9C6).addRange(0x9C9, 0x9CA).addRange(0x9CF, 0x9D6).addRange(0x9D8, 0x9DB).addRange(0x9E4, 0x9E5).addRange(0x9FF, 0xA00).addRange(0xA0B, 0xA0E).addRange(0xA11, 0xA12).addRange(0xA3A, 0xA3B).addRange(0xA43, 0xA46).addRange(0xA49, 0xA4A).addRange(0xA4E, 0xA50).addRange(0xA52, 0xA58).addRange(0xA5F, 0xA65).addRange(0xA77, 0xA80).addRange(0xABA, 0xABB).addRange(0xACE, 0xACF).addRange(0xAD1, 0xADF).addRange(0xAE4, 0xAE5).addRange(0xAF2, 0xAF8).addRange(0xB0D, 0xB0E).addRange(0xB11, 0xB12).addRange(0xB3A, 0xB3B).addRange(0xB45, 0xB46).addRange(0xB49, 0xB4A).addRange(0xB4E, 0xB54).addRange(0xB58, 0xB5B).addRange(0xB64, 0xB65).addRange(0xB78, 0xB81).addRange(0xB8B, 0xB8D);
		    set.addRange(0xB96, 0xB98).addRange(0xBA0, 0xBA2).addRange(0xBA5, 0xBA7).addRange(0xBAB, 0xBAD).addRange(0xBBA, 0xBBD).addRange(0xBC3, 0xBC5).addRange(0xBCE, 0xBCF).addRange(0xBD1, 0xBD6).addRange(0xBD8, 0xBE5).addRange(0xBFB, 0xBFF).addRange(0xC3A, 0xC3B).addRange(0xC4E, 0xC54).addRange(0xC5B, 0xC5C).addRange(0xC5E, 0xC5F).addRange(0xC64, 0xC65).addRange(0xC70, 0xC76).addRange(0xCBA, 0xCBB).addRange(0xCCE, 0xCD4).addRange(0xCD7, 0xCDC).addRange(0xCE4, 0xCE5).addRange(0xCF4, 0xCFF).addRange(0xD50, 0xD53).addRange(0xD64, 0xD65).addRange(0xD97, 0xD99).addRange(0xDBE, 0xDBF).addRange(0xDC7, 0xDC9).addRange(0xDCB, 0xDCE).addRange(0xDE0, 0xDE5).addRange(0xDF0, 0xDF1).addRange(0xDF5, 0xE00).addRange(0xE3B, 0xE3E).addRange(0xE5C, 0xE80).addRange(0xEBE, 0xEBF).addRange(0xEDA, 0xEDB).addRange(0xEE0, 0xEFF).addRange(0xF6D, 0xF70).addRange(0xFDB, 0xFFF).addRange(0x10C8, 0x10CC).addRange(0x10CE, 0x10CF).addRange(0x124E, 0x124F).addRange(0x125E, 0x125F).addRange(0x128E, 0x128F).addRange(0x12B6, 0x12B7).addRange(0x12C6, 0x12C7).addRange(0x1316, 0x1317).addRange(0x135B, 0x135C).addRange(0x137D, 0x137F).addRange(0x139A, 0x139F).addRange(0x13F6, 0x13F7).addRange(0x13FE, 0x13FF).addRange(0x169D, 0x169F);
		    set.addRange(0x16F9, 0x16FF).addRange(0x1716, 0x171E).addRange(0x1737, 0x173F).addRange(0x1754, 0x175F).addRange(0x1774, 0x177F).addRange(0x17DE, 0x17DF).addRange(0x17EA, 0x17EF).addRange(0x17FA, 0x17FF).addRange(0x181A, 0x181F).addRange(0x1879, 0x187F).addRange(0x18AB, 0x18AF).addRange(0x18F6, 0x18FF).addRange(0x192C, 0x192F).addRange(0x193C, 0x193F).addRange(0x1941, 0x1943).addRange(0x196E, 0x196F).addRange(0x1975, 0x197F).addRange(0x19AC, 0x19AF).addRange(0x19CA, 0x19CF).addRange(0x19DB, 0x19DD).addRange(0x1A1C, 0x1A1D).addRange(0x1A7D, 0x1A7E).addRange(0x1A8A, 0x1A8F).addRange(0x1A9A, 0x1A9F).addRange(0x1AAE, 0x1AAF).addRange(0x1ACF, 0x1AFF).addRange(0x1B4D, 0x1B4F).addRange(0x1BF4, 0x1BFB).addRange(0x1C38, 0x1C3A).addRange(0x1C4A, 0x1C4C).addRange(0x1C89, 0x1C8F).addRange(0x1CBB, 0x1CBC).addRange(0x1CC8, 0x1CCF).addRange(0x1CFB, 0x1CFF).addRange(0x1F16, 0x1F17).addRange(0x1F1E, 0x1F1F).addRange(0x1F46, 0x1F47).addRange(0x1F4E, 0x1F4F).addRange(0x1F7E, 0x1F7F).addRange(0x1FD4, 0x1FD5).addRange(0x1FF0, 0x1FF1).addRange(0x200B, 0x200F).addRange(0x202A, 0x202E).addRange(0x2060, 0x206F).addRange(0x2072, 0x2073).addRange(0x209D, 0x209F).addRange(0x20C1, 0x20CF).addRange(0x20F1, 0x20FF).addRange(0x218C, 0x218F).addRange(0x2427, 0x243F).addRange(0x244B, 0x245F);
		    set.addRange(0x2B74, 0x2B75).addRange(0x2CF4, 0x2CF8).addRange(0x2D28, 0x2D2C).addRange(0x2D2E, 0x2D2F).addRange(0x2D68, 0x2D6E).addRange(0x2D71, 0x2D7E).addRange(0x2D97, 0x2D9F).addRange(0x2E5E, 0x2E7F).addRange(0x2EF4, 0x2EFF).addRange(0x2FD6, 0x2FEF).addRange(0x3097, 0x3098).addRange(0x3100, 0x3104).addRange(0x31E4, 0x31EE).addRange(0xA48D, 0xA48F).addRange(0xA4C7, 0xA4CF).addRange(0xA62C, 0xA63F).addRange(0xA6F8, 0xA6FF).addRange(0xA7CB, 0xA7CF).addRange(0xA7DA, 0xA7F1).addRange(0xA82D, 0xA82F).addRange(0xA83A, 0xA83F).addRange(0xA878, 0xA87F).addRange(0xA8C6, 0xA8CD).addRange(0xA8DA, 0xA8DF).addRange(0xA954, 0xA95E).addRange(0xA97D, 0xA97F).addRange(0xA9DA, 0xA9DD).addRange(0xAA37, 0xAA3F).addRange(0xAA4E, 0xAA4F).addRange(0xAA5A, 0xAA5B).addRange(0xAAC3, 0xAADA).addRange(0xAAF7, 0xAB00).addRange(0xAB07, 0xAB08).addRange(0xAB0F, 0xAB10).addRange(0xAB17, 0xAB1F).addRange(0xAB6C, 0xAB6F).addRange(0xABEE, 0xABEF).addRange(0xABFA, 0xABFF).addRange(0xD7A4, 0xD7AF).addRange(0xD7C7, 0xD7CA).addRange(0xD7FC, 0xF8FF).addRange(0xFA6E, 0xFA6F).addRange(0xFADA, 0xFAFF).addRange(0xFB07, 0xFB12).addRange(0xFB18, 0xFB1C).addRange(0xFBC3, 0xFBD2).addRange(0xFD90, 0xFD91).addRange(0xFDC8, 0xFDCE).addRange(0xFDD0, 0xFDEF).addRange(0xFE1A, 0xFE1F).addRange(0xFE6C, 0xFE6F);
		    set.addRange(0xFEFD, 0xFF00).addRange(0xFFBF, 0xFFC1).addRange(0xFFC8, 0xFFC9).addRange(0xFFD0, 0xFFD1).addRange(0xFFD8, 0xFFD9).addRange(0xFFDD, 0xFFDF).addRange(0xFFEF, 0xFFFB).addRange(0xFFFE, 0xFFFF).addRange(0x1004E, 0x1004F).addRange(0x1005E, 0x1007F).addRange(0x100FB, 0x100FF).addRange(0x10103, 0x10106).addRange(0x10134, 0x10136).addRange(0x1019D, 0x1019F).addRange(0x101A1, 0x101CF).addRange(0x101FE, 0x1027F).addRange(0x1029D, 0x1029F).addRange(0x102D1, 0x102DF).addRange(0x102FC, 0x102FF).addRange(0x10324, 0x1032C).addRange(0x1034B, 0x1034F).addRange(0x1037B, 0x1037F).addRange(0x103C4, 0x103C7).addRange(0x103D6, 0x103FF).addRange(0x1049E, 0x1049F).addRange(0x104AA, 0x104AF).addRange(0x104D4, 0x104D7).addRange(0x104FC, 0x104FF).addRange(0x10528, 0x1052F).addRange(0x10564, 0x1056E).addRange(0x105BD, 0x105FF).addRange(0x10737, 0x1073F).addRange(0x10756, 0x1075F).addRange(0x10768, 0x1077F).addRange(0x107BB, 0x107FF).addRange(0x10806, 0x10807).addRange(0x10839, 0x1083B).addRange(0x1083D, 0x1083E).addRange(0x1089F, 0x108A6).addRange(0x108B0, 0x108DF).addRange(0x108F6, 0x108FA).addRange(0x1091C, 0x1091E).addRange(0x1093A, 0x1093E).addRange(0x10940, 0x1097F).addRange(0x109B8, 0x109BB).addRange(0x109D0, 0x109D1).addRange(0x10A07, 0x10A0B).addRange(0x10A36, 0x10A37).addRange(0x10A3B, 0x10A3E).addRange(0x10A49, 0x10A4F).addRange(0x10A59, 0x10A5F);
		    set.addRange(0x10AA0, 0x10ABF).addRange(0x10AE7, 0x10AEA).addRange(0x10AF7, 0x10AFF).addRange(0x10B36, 0x10B38).addRange(0x10B56, 0x10B57).addRange(0x10B73, 0x10B77).addRange(0x10B92, 0x10B98).addRange(0x10B9D, 0x10BA8).addRange(0x10BB0, 0x10BFF).addRange(0x10C49, 0x10C7F).addRange(0x10CB3, 0x10CBF).addRange(0x10CF3, 0x10CF9).addRange(0x10D28, 0x10D2F).addRange(0x10D3A, 0x10E5F).addRange(0x10EAE, 0x10EAF).addRange(0x10EB2, 0x10EFC).addRange(0x10F28, 0x10F2F).addRange(0x10F5A, 0x10F6F).addRange(0x10F8A, 0x10FAF).addRange(0x10FCC, 0x10FDF).addRange(0x10FF7, 0x10FFF).addRange(0x1104E, 0x11051).addRange(0x11076, 0x1107E).addRange(0x110C3, 0x110CF).addRange(0x110E9, 0x110EF).addRange(0x110FA, 0x110FF).addRange(0x11148, 0x1114F).addRange(0x11177, 0x1117F).addRange(0x111F5, 0x111FF).addRange(0x11242, 0x1127F).addRange(0x112AA, 0x112AF).addRange(0x112EB, 0x112EF).addRange(0x112FA, 0x112FF).addRange(0x1130D, 0x1130E).addRange(0x11311, 0x11312).addRange(0x11345, 0x11346).addRange(0x11349, 0x1134A).addRange(0x1134E, 0x1134F).addRange(0x11351, 0x11356).addRange(0x11358, 0x1135C).addRange(0x11364, 0x11365).addRange(0x1136D, 0x1136F).addRange(0x11375, 0x113FF).addRange(0x11462, 0x1147F).addRange(0x114C8, 0x114CF).addRange(0x114DA, 0x1157F).addRange(0x115B6, 0x115B7).addRange(0x115DE, 0x115FF).addRange(0x11645, 0x1164F).addRange(0x1165A, 0x1165F).addRange(0x1166D, 0x1167F);
		    set.addRange(0x116BA, 0x116BF).addRange(0x116CA, 0x116FF).addRange(0x1171B, 0x1171C).addRange(0x1172C, 0x1172F).addRange(0x11747, 0x117FF).addRange(0x1183C, 0x1189F).addRange(0x118F3, 0x118FE).addRange(0x11907, 0x11908).addRange(0x1190A, 0x1190B).addRange(0x11939, 0x1193A).addRange(0x11947, 0x1194F).addRange(0x1195A, 0x1199F).addRange(0x119A8, 0x119A9).addRange(0x119D8, 0x119D9).addRange(0x119E5, 0x119FF).addRange(0x11A48, 0x11A4F).addRange(0x11AA3, 0x11AAF).addRange(0x11AF9, 0x11AFF).addRange(0x11B0A, 0x11BFF).addRange(0x11C46, 0x11C4F).addRange(0x11C6D, 0x11C6F).addRange(0x11C90, 0x11C91).addRange(0x11CB7, 0x11CFF).addRange(0x11D37, 0x11D39).addRange(0x11D48, 0x11D4F).addRange(0x11D5A, 0x11D5F).addRange(0x11D99, 0x11D9F).addRange(0x11DAA, 0x11EDF).addRange(0x11EF9, 0x11EFF).addRange(0x11F3B, 0x11F3D).addRange(0x11F5A, 0x11FAF).addRange(0x11FB1, 0x11FBF).addRange(0x11FF2, 0x11FFE).addRange(0x1239A, 0x123FF).addRange(0x12475, 0x1247F).addRange(0x12544, 0x12F8F).addRange(0x12FF3, 0x12FFF).addRange(0x13430, 0x1343F).addRange(0x13456, 0x143FF).addRange(0x14647, 0x167FF).addRange(0x16A39, 0x16A3F).addRange(0x16A6A, 0x16A6D).addRange(0x16ACA, 0x16ACF).addRange(0x16AEE, 0x16AEF).addRange(0x16AF6, 0x16AFF).addRange(0x16B46, 0x16B4F).addRange(0x16B78, 0x16B7C).addRange(0x16B90, 0x16E3F).addRange(0x16E9B, 0x16EFF).addRange(0x16F4B, 0x16F4E).addRange(0x16F88, 0x16F8E);
		    set.addRange(0x16FA0, 0x16FDF).addRange(0x16FE5, 0x16FEF).addRange(0x16FF2, 0x16FFF).addRange(0x187F8, 0x187FF).addRange(0x18CD6, 0x18CFF).addRange(0x18D09, 0x1AFEF).addRange(0x1B123, 0x1B131).addRange(0x1B133, 0x1B14F).addRange(0x1B153, 0x1B154).addRange(0x1B156, 0x1B163).addRange(0x1B168, 0x1B16F).addRange(0x1B2FC, 0x1BBFF).addRange(0x1BC6B, 0x1BC6F).addRange(0x1BC7D, 0x1BC7F).addRange(0x1BC89, 0x1BC8F).addRange(0x1BC9A, 0x1BC9B).addRange(0x1BCA0, 0x1CEFF).addRange(0x1CF2E, 0x1CF2F).addRange(0x1CF47, 0x1CF4F).addRange(0x1CFC4, 0x1CFFF).addRange(0x1D0F6, 0x1D0FF).addRange(0x1D127, 0x1D128).addRange(0x1D173, 0x1D17A).addRange(0x1D1EB, 0x1D1FF).addRange(0x1D246, 0x1D2BF).addRange(0x1D2D4, 0x1D2DF).addRange(0x1D2F4, 0x1D2FF).addRange(0x1D357, 0x1D35F).addRange(0x1D379, 0x1D3FF).addRange(0x1D4A0, 0x1D4A1).addRange(0x1D4A3, 0x1D4A4).addRange(0x1D4A7, 0x1D4A8).addRange(0x1D50B, 0x1D50C).addRange(0x1D547, 0x1D549).addRange(0x1D6A6, 0x1D6A7).addRange(0x1D7CC, 0x1D7CD).addRange(0x1DA8C, 0x1DA9A).addRange(0x1DAB0, 0x1DEFF).addRange(0x1DF1F, 0x1DF24).addRange(0x1DF2B, 0x1DFFF).addRange(0x1E019, 0x1E01A).addRange(0x1E02B, 0x1E02F).addRange(0x1E06E, 0x1E08E).addRange(0x1E090, 0x1E0FF).addRange(0x1E12D, 0x1E12F).addRange(0x1E13E, 0x1E13F).addRange(0x1E14A, 0x1E14D).addRange(0x1E150, 0x1E28F).addRange(0x1E2AF, 0x1E2BF).addRange(0x1E2FA, 0x1E2FE).addRange(0x1E300, 0x1E4CF);
		    set.addRange(0x1E4FA, 0x1E7DF).addRange(0x1E8C5, 0x1E8C6).addRange(0x1E8D7, 0x1E8FF).addRange(0x1E94C, 0x1E94F).addRange(0x1E95A, 0x1E95D).addRange(0x1E960, 0x1EC70).addRange(0x1ECB5, 0x1ED00).addRange(0x1ED3E, 0x1EDFF).addRange(0x1EE25, 0x1EE26).addRange(0x1EE3C, 0x1EE41).addRange(0x1EE43, 0x1EE46).addRange(0x1EE55, 0x1EE56).addRange(0x1EE65, 0x1EE66).addRange(0x1EE9C, 0x1EEA0).addRange(0x1EEBC, 0x1EEEF).addRange(0x1EEF2, 0x1EFFF).addRange(0x1F02C, 0x1F02F).addRange(0x1F094, 0x1F09F).addRange(0x1F0AF, 0x1F0B0).addRange(0x1F0F6, 0x1F0FF).addRange(0x1F1AE, 0x1F1E5).addRange(0x1F203, 0x1F20F).addRange(0x1F23C, 0x1F23F).addRange(0x1F249, 0x1F24F).addRange(0x1F252, 0x1F25F).addRange(0x1F266, 0x1F2FF).addRange(0x1F6D8, 0x1F6DB).addRange(0x1F6ED, 0x1F6EF).addRange(0x1F6FD, 0x1F6FF).addRange(0x1F777, 0x1F77A).addRange(0x1F7DA, 0x1F7DF).addRange(0x1F7EC, 0x1F7EF).addRange(0x1F7F1, 0x1F7FF).addRange(0x1F80C, 0x1F80F).addRange(0x1F848, 0x1F84F).addRange(0x1F85A, 0x1F85F).addRange(0x1F888, 0x1F88F).addRange(0x1F8AE, 0x1F8AF).addRange(0x1F8B2, 0x1F8FF).addRange(0x1FA54, 0x1FA5F).addRange(0x1FA6E, 0x1FA6F).addRange(0x1FA7D, 0x1FA7F).addRange(0x1FA89, 0x1FA8F).addRange(0x1FAC6, 0x1FACD).addRange(0x1FADC, 0x1FADF).addRange(0x1FAE9, 0x1FAEF).addRange(0x1FAF9, 0x1FAFF).addRange(0x1FBCB, 0x1FBEF).addRange(0x1FBFA, 0x1FFFF).addRange(0x2A6E0, 0x2A6FF).addRange(0x2B73A, 0x2B73F);
		    set.addRange(0x2B81E, 0x2B81F).addRange(0x2CEA2, 0x2CEAF).addRange(0x2EBE1, 0x2EBEF).addRange(0x2EE5E, 0x2F7FF).addRange(0x2FA1E, 0x2FFFF).addRange(0x3134B, 0x3134F).addRange(0x323B0, 0xE00FF).addRange(0xE01F0, 0x10FFFF);
		    Other.characters = set;
		    return Other;
		  }

		  var Paragraph_Separator = {};

		  var hasRequiredParagraph_Separator;
		  function requireParagraph_Separator() {
		    if (hasRequiredParagraph_Separator) return Paragraph_Separator;
		    hasRequiredParagraph_Separator = 1;
		    var set = regenerateExports(0x2029);
		    Paragraph_Separator.characters = set;
		    return Paragraph_Separator;
		  }

		  var Private_Use = {};

		  var hasRequiredPrivate_Use;
		  function requirePrivate_Use() {
		    if (hasRequiredPrivate_Use) return Private_Use;
		    hasRequiredPrivate_Use = 1;
		    var set = regenerateExports();
		    set.addRange(0xE000, 0xF8FF).addRange(0xF0000, 0xFFFFD).addRange(0x100000, 0x10FFFD);
		    Private_Use.characters = set;
		    return Private_Use;
		  }

		  var Punctuation = {};

		  var hasRequiredPunctuation;
		  function requirePunctuation() {
		    if (hasRequiredPunctuation) return Punctuation;
		    hasRequiredPunctuation = 1;
		    var set = regenerateExports(0x5F, 0x7B, 0x7D, 0xA1, 0xA7, 0xAB, 0xBB, 0xBF, 0x37E, 0x387, 0x5BE, 0x5C0, 0x5C3, 0x5C6, 0x61B, 0x6D4, 0x85E, 0x970, 0x9FD, 0xA76, 0xAF0, 0xC77, 0xC84, 0xDF4, 0xE4F, 0xF14, 0xF85, 0x10FB, 0x1400, 0x166E, 0x1CD3, 0x2D70, 0x3030, 0x303D, 0x30A0, 0x30FB, 0xA673, 0xA67E, 0xA8FC, 0xA95F, 0xABEB, 0xFE63, 0xFE68, 0xFF3F, 0xFF5B, 0xFF5D, 0x1039F, 0x103D0, 0x1056F, 0x10857, 0x1091F, 0x1093F, 0x10A7F, 0x10EAD, 0x111CD, 0x111DB, 0x112A9, 0x1145D, 0x114C6, 0x116B9, 0x1183B, 0x119E2, 0x11FFF, 0x16AF5, 0x16B44, 0x16FE2, 0x1BC9F);
		    set.addRange(0x21, 0x23).addRange(0x25, 0x2A).addRange(0x2C, 0x2F).addRange(0x3A, 0x3B).addRange(0x3F, 0x40).addRange(0x5B, 0x5D).addRange(0xB6, 0xB7).addRange(0x55A, 0x55F).addRange(0x589, 0x58A).addRange(0x5F3, 0x5F4).addRange(0x609, 0x60A).addRange(0x60C, 0x60D).addRange(0x61D, 0x61F).addRange(0x66A, 0x66D).addRange(0x700, 0x70D).addRange(0x7F7, 0x7F9).addRange(0x830, 0x83E).addRange(0x964, 0x965).addRange(0xE5A, 0xE5B).addRange(0xF04, 0xF12).addRange(0xF3A, 0xF3D).addRange(0xFD0, 0xFD4).addRange(0xFD9, 0xFDA).addRange(0x104A, 0x104F).addRange(0x1360, 0x1368).addRange(0x169B, 0x169C).addRange(0x16EB, 0x16ED).addRange(0x1735, 0x1736).addRange(0x17D4, 0x17D6).addRange(0x17D8, 0x17DA).addRange(0x1800, 0x180A).addRange(0x1944, 0x1945).addRange(0x1A1E, 0x1A1F).addRange(0x1AA0, 0x1AA6).addRange(0x1AA8, 0x1AAD).addRange(0x1B5A, 0x1B60).addRange(0x1B7D, 0x1B7E).addRange(0x1BFC, 0x1BFF).addRange(0x1C3B, 0x1C3F).addRange(0x1C7E, 0x1C7F).addRange(0x1CC0, 0x1CC7).addRange(0x2010, 0x2027).addRange(0x2030, 0x2043).addRange(0x2045, 0x2051).addRange(0x2053, 0x205E).addRange(0x207D, 0x207E).addRange(0x208D, 0x208E).addRange(0x2308, 0x230B).addRange(0x2329, 0x232A).addRange(0x2768, 0x2775).addRange(0x27C5, 0x27C6);
		    set.addRange(0x27E6, 0x27EF).addRange(0x2983, 0x2998).addRange(0x29D8, 0x29DB).addRange(0x29FC, 0x29FD).addRange(0x2CF9, 0x2CFC).addRange(0x2CFE, 0x2CFF).addRange(0x2E00, 0x2E2E).addRange(0x2E30, 0x2E4F).addRange(0x2E52, 0x2E5D).addRange(0x3001, 0x3003).addRange(0x3008, 0x3011).addRange(0x3014, 0x301F).addRange(0xA4FE, 0xA4FF).addRange(0xA60D, 0xA60F).addRange(0xA6F2, 0xA6F7).addRange(0xA874, 0xA877).addRange(0xA8CE, 0xA8CF).addRange(0xA8F8, 0xA8FA).addRange(0xA92E, 0xA92F).addRange(0xA9C1, 0xA9CD).addRange(0xA9DE, 0xA9DF).addRange(0xAA5C, 0xAA5F).addRange(0xAADE, 0xAADF).addRange(0xAAF0, 0xAAF1).addRange(0xFD3E, 0xFD3F).addRange(0xFE10, 0xFE19).addRange(0xFE30, 0xFE52).addRange(0xFE54, 0xFE61).addRange(0xFE6A, 0xFE6B).addRange(0xFF01, 0xFF03).addRange(0xFF05, 0xFF0A).addRange(0xFF0C, 0xFF0F).addRange(0xFF1A, 0xFF1B).addRange(0xFF1F, 0xFF20).addRange(0xFF3B, 0xFF3D).addRange(0xFF5F, 0xFF65).addRange(0x10100, 0x10102).addRange(0x10A50, 0x10A58).addRange(0x10AF0, 0x10AF6).addRange(0x10B39, 0x10B3F).addRange(0x10B99, 0x10B9C).addRange(0x10F55, 0x10F59).addRange(0x10F86, 0x10F89).addRange(0x11047, 0x1104D).addRange(0x110BB, 0x110BC).addRange(0x110BE, 0x110C1).addRange(0x11140, 0x11143).addRange(0x11174, 0x11175).addRange(0x111C5, 0x111C8).addRange(0x111DD, 0x111DF).addRange(0x11238, 0x1123D);
		    set.addRange(0x1144B, 0x1144F).addRange(0x1145A, 0x1145B).addRange(0x115C1, 0x115D7).addRange(0x11641, 0x11643).addRange(0x11660, 0x1166C).addRange(0x1173C, 0x1173E).addRange(0x11944, 0x11946).addRange(0x11A3F, 0x11A46).addRange(0x11A9A, 0x11A9C).addRange(0x11A9E, 0x11AA2).addRange(0x11B00, 0x11B09).addRange(0x11C41, 0x11C45).addRange(0x11C70, 0x11C71).addRange(0x11EF7, 0x11EF8).addRange(0x11F43, 0x11F4F).addRange(0x12470, 0x12474).addRange(0x12FF1, 0x12FF2).addRange(0x16A6E, 0x16A6F).addRange(0x16B37, 0x16B3B).addRange(0x16E97, 0x16E9A).addRange(0x1DA87, 0x1DA8B).addRange(0x1E95E, 0x1E95F);
		    Punctuation.characters = set;
		    return Punctuation;
		  }

		  var Separator = {};

		  var hasRequiredSeparator;
		  function requireSeparator() {
		    if (hasRequiredSeparator) return Separator;
		    hasRequiredSeparator = 1;
		    var set = regenerateExports(0x20, 0xA0, 0x1680, 0x202F, 0x205F, 0x3000);
		    set.addRange(0x2000, 0x200A).addRange(0x2028, 0x2029);
		    Separator.characters = set;
		    return Separator;
		  }

		  var Space_Separator = {};

		  var hasRequiredSpace_Separator;
		  function requireSpace_Separator() {
		    if (hasRequiredSpace_Separator) return Space_Separator;
		    hasRequiredSpace_Separator = 1;
		    var set = regenerateExports(0x20, 0xA0, 0x1680, 0x202F, 0x205F, 0x3000);
		    set.addRange(0x2000, 0x200A);
		    Space_Separator.characters = set;
		    return Space_Separator;
		  }

		  var Spacing_Mark = {};

		  var hasRequiredSpacing_Mark;
		  function requireSpacing_Mark() {
		    if (hasRequiredSpacing_Mark) return Spacing_Mark;
		    hasRequiredSpacing_Mark = 1;
		    var set = regenerateExports(0x903, 0x93B, 0x9D7, 0xA03, 0xA83, 0xAC9, 0xB3E, 0xB40, 0xB57, 0xBD7, 0xCBE, 0xCF3, 0xD57, 0xF7F, 0x1031, 0x1038, 0x108F, 0x1715, 0x1734, 0x17B6, 0x1A55, 0x1A57, 0x1A61, 0x1B04, 0x1B35, 0x1B3B, 0x1B82, 0x1BA1, 0x1BAA, 0x1BE7, 0x1BEE, 0x1CE1, 0x1CF7, 0xA827, 0xA983, 0xAA4D, 0xAA7B, 0xAA7D, 0xAAEB, 0xAAF5, 0xABEC, 0x11000, 0x11002, 0x11082, 0x1112C, 0x11182, 0x111CE, 0x11235, 0x11357, 0x11445, 0x114B9, 0x114C1, 0x115BE, 0x1163E, 0x116AC, 0x116B6, 0x11726, 0x11838, 0x1193D, 0x11940, 0x11942, 0x119E4, 0x11A39, 0x11A97, 0x11C2F, 0x11C3E, 0x11CA9, 0x11CB1, 0x11CB4, 0x11D96, 0x11F03, 0x11F41);
		    set.addRange(0x93E, 0x940).addRange(0x949, 0x94C).addRange(0x94E, 0x94F).addRange(0x982, 0x983).addRange(0x9BE, 0x9C0).addRange(0x9C7, 0x9C8).addRange(0x9CB, 0x9CC).addRange(0xA3E, 0xA40).addRange(0xABE, 0xAC0).addRange(0xACB, 0xACC).addRange(0xB02, 0xB03).addRange(0xB47, 0xB48).addRange(0xB4B, 0xB4C).addRange(0xBBE, 0xBBF).addRange(0xBC1, 0xBC2).addRange(0xBC6, 0xBC8).addRange(0xBCA, 0xBCC).addRange(0xC01, 0xC03).addRange(0xC41, 0xC44).addRange(0xC82, 0xC83).addRange(0xCC0, 0xCC4).addRange(0xCC7, 0xCC8).addRange(0xCCA, 0xCCB).addRange(0xCD5, 0xCD6).addRange(0xD02, 0xD03).addRange(0xD3E, 0xD40).addRange(0xD46, 0xD48).addRange(0xD4A, 0xD4C).addRange(0xD82, 0xD83).addRange(0xDCF, 0xDD1).addRange(0xDD8, 0xDDF).addRange(0xDF2, 0xDF3).addRange(0xF3E, 0xF3F).addRange(0x102B, 0x102C).addRange(0x103B, 0x103C).addRange(0x1056, 0x1057).addRange(0x1062, 0x1064).addRange(0x1067, 0x106D).addRange(0x1083, 0x1084).addRange(0x1087, 0x108C).addRange(0x109A, 0x109C).addRange(0x17BE, 0x17C5).addRange(0x17C7, 0x17C8).addRange(0x1923, 0x1926).addRange(0x1929, 0x192B).addRange(0x1930, 0x1931).addRange(0x1933, 0x1938).addRange(0x1A19, 0x1A1A).addRange(0x1A63, 0x1A64).addRange(0x1A6D, 0x1A72).addRange(0x1B3D, 0x1B41);
		    set.addRange(0x1B43, 0x1B44).addRange(0x1BA6, 0x1BA7).addRange(0x1BEA, 0x1BEC).addRange(0x1BF2, 0x1BF3).addRange(0x1C24, 0x1C2B).addRange(0x1C34, 0x1C35).addRange(0x302E, 0x302F).addRange(0xA823, 0xA824).addRange(0xA880, 0xA881).addRange(0xA8B4, 0xA8C3).addRange(0xA952, 0xA953).addRange(0xA9B4, 0xA9B5).addRange(0xA9BA, 0xA9BB).addRange(0xA9BE, 0xA9C0).addRange(0xAA2F, 0xAA30).addRange(0xAA33, 0xAA34).addRange(0xAAEE, 0xAAEF).addRange(0xABE3, 0xABE4).addRange(0xABE6, 0xABE7).addRange(0xABE9, 0xABEA).addRange(0x110B0, 0x110B2).addRange(0x110B7, 0x110B8).addRange(0x11145, 0x11146).addRange(0x111B3, 0x111B5).addRange(0x111BF, 0x111C0).addRange(0x1122C, 0x1122E).addRange(0x11232, 0x11233).addRange(0x112E0, 0x112E2).addRange(0x11302, 0x11303).addRange(0x1133E, 0x1133F).addRange(0x11341, 0x11344).addRange(0x11347, 0x11348).addRange(0x1134B, 0x1134D).addRange(0x11362, 0x11363).addRange(0x11435, 0x11437).addRange(0x11440, 0x11441).addRange(0x114B0, 0x114B2).addRange(0x114BB, 0x114BE).addRange(0x115AF, 0x115B1).addRange(0x115B8, 0x115BB).addRange(0x11630, 0x11632).addRange(0x1163B, 0x1163C).addRange(0x116AE, 0x116AF).addRange(0x11720, 0x11721).addRange(0x1182C, 0x1182E).addRange(0x11930, 0x11935).addRange(0x11937, 0x11938).addRange(0x119D1, 0x119D3).addRange(0x119DC, 0x119DF).addRange(0x11A57, 0x11A58).addRange(0x11D8A, 0x11D8E);
		    set.addRange(0x11D93, 0x11D94).addRange(0x11EF5, 0x11EF6).addRange(0x11F34, 0x11F35).addRange(0x11F3E, 0x11F3F).addRange(0x16F51, 0x16F87).addRange(0x16FF0, 0x16FF1).addRange(0x1D165, 0x1D166).addRange(0x1D16D, 0x1D172);
		    Spacing_Mark.characters = set;
		    return Spacing_Mark;
		  }

		  var Surrogate = {};

		  var hasRequiredSurrogate;
		  function requireSurrogate() {
		    if (hasRequiredSurrogate) return Surrogate;
		    hasRequiredSurrogate = 1;
		    var set = regenerateExports();
		    set.addRange(0xD800, 0xDFFF);
		    Surrogate.characters = set;
		    return Surrogate;
		  }

		  var _Symbol = {};

		  var hasRequired_Symbol;
		  function require_Symbol() {
		    if (hasRequired_Symbol) return _Symbol;
		    hasRequired_Symbol = 1;
		    var set = regenerateExports(0x24, 0x2B, 0x5E, 0x60, 0x7C, 0x7E, 0xAC, 0xB4, 0xB8, 0xD7, 0xF7, 0x2ED, 0x375, 0x3F6, 0x482, 0x60B, 0x6DE, 0x6E9, 0x7F6, 0x888, 0xAF1, 0xB70, 0xC7F, 0xD4F, 0xD79, 0xE3F, 0xF13, 0xF34, 0xF36, 0xF38, 0x166D, 0x17DB, 0x1940, 0x1FBD, 0x2044, 0x2052, 0x2114, 0x2125, 0x2127, 0x2129, 0x212E, 0x214F, 0x3004, 0x3020, 0x31EF, 0x3250, 0xAB5B, 0xFB29, 0xFDCF, 0xFE62, 0xFE69, 0xFF04, 0xFF0B, 0xFF3E, 0xFF40, 0xFF5C, 0xFF5E, 0x101A0, 0x10AC8, 0x1173F, 0x16B45, 0x1BC9C, 0x1D245, 0x1D6C1, 0x1D6DB, 0x1D6FB, 0x1D715, 0x1D735, 0x1D74F, 0x1D76F, 0x1D789, 0x1D7A9, 0x1D7C3, 0x1E14F, 0x1E2FF, 0x1ECAC, 0x1ECB0, 0x1ED2E, 0x1F7F0);
		    set.addRange(0x3C, 0x3E).addRange(0xA2, 0xA6).addRange(0xA8, 0xA9).addRange(0xAE, 0xB1).addRange(0x2C2, 0x2C5).addRange(0x2D2, 0x2DF).addRange(0x2E5, 0x2EB).addRange(0x2EF, 0x2FF).addRange(0x384, 0x385).addRange(0x58D, 0x58F).addRange(0x606, 0x608).addRange(0x60E, 0x60F).addRange(0x6FD, 0x6FE).addRange(0x7FE, 0x7FF).addRange(0x9F2, 0x9F3).addRange(0x9FA, 0x9FB).addRange(0xBF3, 0xBFA).addRange(0xF01, 0xF03).addRange(0xF15, 0xF17).addRange(0xF1A, 0xF1F).addRange(0xFBE, 0xFC5).addRange(0xFC7, 0xFCC).addRange(0xFCE, 0xFCF).addRange(0xFD5, 0xFD8).addRange(0x109E, 0x109F).addRange(0x1390, 0x1399).addRange(0x19DE, 0x19FF).addRange(0x1B61, 0x1B6A).addRange(0x1B74, 0x1B7C).addRange(0x1FBF, 0x1FC1).addRange(0x1FCD, 0x1FCF).addRange(0x1FDD, 0x1FDF).addRange(0x1FED, 0x1FEF).addRange(0x1FFD, 0x1FFE).addRange(0x207A, 0x207C).addRange(0x208A, 0x208C).addRange(0x20A0, 0x20C0).addRange(0x2100, 0x2101).addRange(0x2103, 0x2106).addRange(0x2108, 0x2109).addRange(0x2116, 0x2118).addRange(0x211E, 0x2123).addRange(0x213A, 0x213B).addRange(0x2140, 0x2144).addRange(0x214A, 0x214D).addRange(0x218A, 0x218B).addRange(0x2190, 0x2307).addRange(0x230C, 0x2328).addRange(0x232B, 0x2426).addRange(0x2440, 0x244A).addRange(0x249C, 0x24E9);
		    set.addRange(0x2500, 0x2767).addRange(0x2794, 0x27C4).addRange(0x27C7, 0x27E5).addRange(0x27F0, 0x2982).addRange(0x2999, 0x29D7).addRange(0x29DC, 0x29FB).addRange(0x29FE, 0x2B73).addRange(0x2B76, 0x2B95).addRange(0x2B97, 0x2BFF).addRange(0x2CE5, 0x2CEA).addRange(0x2E50, 0x2E51).addRange(0x2E80, 0x2E99).addRange(0x2E9B, 0x2EF3).addRange(0x2F00, 0x2FD5).addRange(0x2FF0, 0x2FFF).addRange(0x3012, 0x3013).addRange(0x3036, 0x3037).addRange(0x303E, 0x303F).addRange(0x309B, 0x309C).addRange(0x3190, 0x3191).addRange(0x3196, 0x319F).addRange(0x31C0, 0x31E3).addRange(0x3200, 0x321E).addRange(0x322A, 0x3247).addRange(0x3260, 0x327F).addRange(0x328A, 0x32B0).addRange(0x32C0, 0x33FF).addRange(0x4DC0, 0x4DFF).addRange(0xA490, 0xA4C6).addRange(0xA700, 0xA716).addRange(0xA720, 0xA721).addRange(0xA789, 0xA78A).addRange(0xA828, 0xA82B).addRange(0xA836, 0xA839).addRange(0xAA77, 0xAA79).addRange(0xAB6A, 0xAB6B).addRange(0xFBB2, 0xFBC2).addRange(0xFD40, 0xFD4F).addRange(0xFDFC, 0xFDFF).addRange(0xFE64, 0xFE66).addRange(0xFF1C, 0xFF1E).addRange(0xFFE0, 0xFFE6).addRange(0xFFE8, 0xFFEE).addRange(0xFFFC, 0xFFFD).addRange(0x10137, 0x1013F).addRange(0x10179, 0x10189).addRange(0x1018C, 0x1018E).addRange(0x10190, 0x1019C).addRange(0x101D0, 0x101FC).addRange(0x10877, 0x10878).addRange(0x11FD5, 0x11FF1);
		    set.addRange(0x16B3C, 0x16B3F).addRange(0x1CF50, 0x1CFC3).addRange(0x1D000, 0x1D0F5).addRange(0x1D100, 0x1D126).addRange(0x1D129, 0x1D164).addRange(0x1D16A, 0x1D16C).addRange(0x1D183, 0x1D184).addRange(0x1D18C, 0x1D1A9).addRange(0x1D1AE, 0x1D1EA).addRange(0x1D200, 0x1D241).addRange(0x1D300, 0x1D356).addRange(0x1D800, 0x1D9FF).addRange(0x1DA37, 0x1DA3A).addRange(0x1DA6D, 0x1DA74).addRange(0x1DA76, 0x1DA83).addRange(0x1DA85, 0x1DA86).addRange(0x1EEF0, 0x1EEF1).addRange(0x1F000, 0x1F02B).addRange(0x1F030, 0x1F093).addRange(0x1F0A0, 0x1F0AE).addRange(0x1F0B1, 0x1F0BF).addRange(0x1F0C1, 0x1F0CF).addRange(0x1F0D1, 0x1F0F5).addRange(0x1F10D, 0x1F1AD).addRange(0x1F1E6, 0x1F202).addRange(0x1F210, 0x1F23B).addRange(0x1F240, 0x1F248).addRange(0x1F250, 0x1F251).addRange(0x1F260, 0x1F265).addRange(0x1F300, 0x1F6D7).addRange(0x1F6DC, 0x1F6EC).addRange(0x1F6F0, 0x1F6FC).addRange(0x1F700, 0x1F776).addRange(0x1F77B, 0x1F7D9).addRange(0x1F7E0, 0x1F7EB).addRange(0x1F800, 0x1F80B).addRange(0x1F810, 0x1F847).addRange(0x1F850, 0x1F859).addRange(0x1F860, 0x1F887).addRange(0x1F890, 0x1F8AD).addRange(0x1F8B0, 0x1F8B1).addRange(0x1F900, 0x1FA53).addRange(0x1FA60, 0x1FA6D).addRange(0x1FA70, 0x1FA7C).addRange(0x1FA80, 0x1FA88).addRange(0x1FA90, 0x1FABD).addRange(0x1FABF, 0x1FAC5).addRange(0x1FACE, 0x1FADB).addRange(0x1FAE0, 0x1FAE8).addRange(0x1FAF0, 0x1FAF8).addRange(0x1FB00, 0x1FB92);
		    set.addRange(0x1FB94, 0x1FBCA);
		    _Symbol.characters = set;
		    return _Symbol;
		  }

		  var Titlecase_Letter = {};

		  var hasRequiredTitlecase_Letter;
		  function requireTitlecase_Letter() {
		    if (hasRequiredTitlecase_Letter) return Titlecase_Letter;
		    hasRequiredTitlecase_Letter = 1;
		    var set = regenerateExports(0x1C5, 0x1C8, 0x1CB, 0x1F2, 0x1FBC, 0x1FCC, 0x1FFC);
		    set.addRange(0x1F88, 0x1F8F).addRange(0x1F98, 0x1F9F).addRange(0x1FA8, 0x1FAF);
		    Titlecase_Letter.characters = set;
		    return Titlecase_Letter;
		  }

		  var Unassigned = {};

		  var hasRequiredUnassigned;
		  function requireUnassigned() {
		    if (hasRequiredUnassigned) return Unassigned;
		    hasRequiredUnassigned = 1;
		    var set = regenerateExports(0x38B, 0x38D, 0x3A2, 0x530, 0x590, 0x70E, 0x83F, 0x85F, 0x88F, 0x984, 0x9A9, 0x9B1, 0x9DE, 0xA04, 0xA29, 0xA31, 0xA34, 0xA37, 0xA3D, 0xA5D, 0xA84, 0xA8E, 0xA92, 0xAA9, 0xAB1, 0xAB4, 0xAC6, 0xACA, 0xB00, 0xB04, 0xB29, 0xB31, 0xB34, 0xB5E, 0xB84, 0xB91, 0xB9B, 0xB9D, 0xBC9, 0xC0D, 0xC11, 0xC29, 0xC45, 0xC49, 0xC57, 0xC8D, 0xC91, 0xCA9, 0xCB4, 0xCC5, 0xCC9, 0xCDF, 0xCF0, 0xD0D, 0xD11, 0xD45, 0xD49, 0xD80, 0xD84, 0xDB2, 0xDBC, 0xDD5, 0xDD7, 0xE83, 0xE85, 0xE8B, 0xEA4, 0xEA6, 0xEC5, 0xEC7, 0xECF, 0xF48, 0xF98, 0xFBD, 0xFCD, 0x10C6, 0x1249, 0x1257, 0x1259, 0x1289, 0x12B1, 0x12BF, 0x12C1, 0x12D7, 0x1311, 0x176D, 0x1771, 0x191F, 0x1A5F, 0x1B7F, 0x1F58, 0x1F5A, 0x1F5C, 0x1F5E, 0x1FB5, 0x1FC5, 0x1FDC, 0x1FF5, 0x1FFF, 0x2065, 0x208F, 0x2B96, 0x2D26, 0x2DA7, 0x2DAF, 0x2DB7, 0x2DBF, 0x2DC7, 0x2DCF, 0x2DD7, 0x2DDF, 0x2E9A, 0x3040, 0x3130, 0x318F, 0x321F, 0xA7D2, 0xA7D4, 0xA9CE, 0xA9FF, 0xAB27, 0xAB2F, 0xFB37, 0xFB3D, 0xFB3F, 0xFB42, 0xFB45, 0xFE53, 0xFE67, 0xFE75, 0xFF00, 0xFFE7, 0x1000C, 0x10027, 0x1003B, 0x1003E, 0x1018F, 0x1039E, 0x1057B, 0x1058B, 0x10593, 0x10596, 0x105A2, 0x105B2, 0x105BA, 0x10786, 0x107B1, 0x10809, 0x10836, 0x10856, 0x108F3, 0x10A04, 0x10A14, 0x10A18, 0x10E7F, 0x10EAA, 0x11135, 0x111E0, 0x11212, 0x11287, 0x11289, 0x1128E, 0x1129E, 0x11304, 0x11329, 0x11331, 0x11334, 0x1133A, 0x1145C, 0x11914, 0x11917, 0x11936, 0x11C09, 0x11C37, 0x11CA8, 0x11D07, 0x11D0A, 0x11D3B, 0x11D3E, 0x11D66, 0x11D69, 0x11D8F, 0x11D92, 0x11F11, 0x1246F, 0x16A5F, 0x16ABF, 0x16B5A, 0x16B62, 0x1AFF4, 0x1AFFC, 0x1AFFF, 0x1D455, 0x1D49D, 0x1D4AD, 0x1D4BA, 0x1D4BC, 0x1D4C4, 0x1D506, 0x1D515, 0x1D51D, 0x1D53A, 0x1D53F, 0x1D545, 0x1D551, 0x1DAA0, 0x1E007, 0x1E022, 0x1E025, 0x1E7E7, 0x1E7EC, 0x1E7EF, 0x1E7FF, 0x1EE04, 0x1EE20, 0x1EE23, 0x1EE28, 0x1EE33, 0x1EE38, 0x1EE3A, 0x1EE48, 0x1EE4A, 0x1EE4C, 0x1EE50, 0x1EE53, 0x1EE58, 0x1EE5A, 0x1EE5C, 0x1EE5E, 0x1EE60, 0x1EE63, 0x1EE6B, 0x1EE73, 0x1EE78, 0x1EE7D, 0x1EE7F, 0x1EE8A, 0x1EEA4, 0x1EEAA, 0x1F0C0, 0x1F0D0, 0x1FABE, 0x1FB93);
		    set.addRange(0x378, 0x379).addRange(0x380, 0x383).addRange(0x557, 0x558).addRange(0x58B, 0x58C).addRange(0x5C8, 0x5CF).addRange(0x5EB, 0x5EE).addRange(0x5F5, 0x5FF).addRange(0x74B, 0x74C).addRange(0x7B2, 0x7BF).addRange(0x7FB, 0x7FC).addRange(0x82E, 0x82F).addRange(0x85C, 0x85D).addRange(0x86B, 0x86F).addRange(0x892, 0x897).addRange(0x98D, 0x98E).addRange(0x991, 0x992).addRange(0x9B3, 0x9B5).addRange(0x9BA, 0x9BB).addRange(0x9C5, 0x9C6).addRange(0x9C9, 0x9CA).addRange(0x9CF, 0x9D6).addRange(0x9D8, 0x9DB).addRange(0x9E4, 0x9E5).addRange(0x9FF, 0xA00).addRange(0xA0B, 0xA0E).addRange(0xA11, 0xA12).addRange(0xA3A, 0xA3B).addRange(0xA43, 0xA46).addRange(0xA49, 0xA4A).addRange(0xA4E, 0xA50).addRange(0xA52, 0xA58).addRange(0xA5F, 0xA65).addRange(0xA77, 0xA80).addRange(0xABA, 0xABB).addRange(0xACE, 0xACF).addRange(0xAD1, 0xADF).addRange(0xAE4, 0xAE5).addRange(0xAF2, 0xAF8).addRange(0xB0D, 0xB0E).addRange(0xB11, 0xB12).addRange(0xB3A, 0xB3B).addRange(0xB45, 0xB46).addRange(0xB49, 0xB4A).addRange(0xB4E, 0xB54).addRange(0xB58, 0xB5B).addRange(0xB64, 0xB65).addRange(0xB78, 0xB81).addRange(0xB8B, 0xB8D).addRange(0xB96, 0xB98).addRange(0xBA0, 0xBA2).addRange(0xBA5, 0xBA7);
		    set.addRange(0xBAB, 0xBAD).addRange(0xBBA, 0xBBD).addRange(0xBC3, 0xBC5).addRange(0xBCE, 0xBCF).addRange(0xBD1, 0xBD6).addRange(0xBD8, 0xBE5).addRange(0xBFB, 0xBFF).addRange(0xC3A, 0xC3B).addRange(0xC4E, 0xC54).addRange(0xC5B, 0xC5C).addRange(0xC5E, 0xC5F).addRange(0xC64, 0xC65).addRange(0xC70, 0xC76).addRange(0xCBA, 0xCBB).addRange(0xCCE, 0xCD4).addRange(0xCD7, 0xCDC).addRange(0xCE4, 0xCE5).addRange(0xCF4, 0xCFF).addRange(0xD50, 0xD53).addRange(0xD64, 0xD65).addRange(0xD97, 0xD99).addRange(0xDBE, 0xDBF).addRange(0xDC7, 0xDC9).addRange(0xDCB, 0xDCE).addRange(0xDE0, 0xDE5).addRange(0xDF0, 0xDF1).addRange(0xDF5, 0xE00).addRange(0xE3B, 0xE3E).addRange(0xE5C, 0xE80).addRange(0xEBE, 0xEBF).addRange(0xEDA, 0xEDB).addRange(0xEE0, 0xEFF).addRange(0xF6D, 0xF70).addRange(0xFDB, 0xFFF).addRange(0x10C8, 0x10CC).addRange(0x10CE, 0x10CF).addRange(0x124E, 0x124F).addRange(0x125E, 0x125F).addRange(0x128E, 0x128F).addRange(0x12B6, 0x12B7).addRange(0x12C6, 0x12C7).addRange(0x1316, 0x1317).addRange(0x135B, 0x135C).addRange(0x137D, 0x137F).addRange(0x139A, 0x139F).addRange(0x13F6, 0x13F7).addRange(0x13FE, 0x13FF).addRange(0x169D, 0x169F).addRange(0x16F9, 0x16FF).addRange(0x1716, 0x171E).addRange(0x1737, 0x173F);
		    set.addRange(0x1754, 0x175F).addRange(0x1774, 0x177F).addRange(0x17DE, 0x17DF).addRange(0x17EA, 0x17EF).addRange(0x17FA, 0x17FF).addRange(0x181A, 0x181F).addRange(0x1879, 0x187F).addRange(0x18AB, 0x18AF).addRange(0x18F6, 0x18FF).addRange(0x192C, 0x192F).addRange(0x193C, 0x193F).addRange(0x1941, 0x1943).addRange(0x196E, 0x196F).addRange(0x1975, 0x197F).addRange(0x19AC, 0x19AF).addRange(0x19CA, 0x19CF).addRange(0x19DB, 0x19DD).addRange(0x1A1C, 0x1A1D).addRange(0x1A7D, 0x1A7E).addRange(0x1A8A, 0x1A8F).addRange(0x1A9A, 0x1A9F).addRange(0x1AAE, 0x1AAF).addRange(0x1ACF, 0x1AFF).addRange(0x1B4D, 0x1B4F).addRange(0x1BF4, 0x1BFB).addRange(0x1C38, 0x1C3A).addRange(0x1C4A, 0x1C4C).addRange(0x1C89, 0x1C8F).addRange(0x1CBB, 0x1CBC).addRange(0x1CC8, 0x1CCF).addRange(0x1CFB, 0x1CFF).addRange(0x1F16, 0x1F17).addRange(0x1F1E, 0x1F1F).addRange(0x1F46, 0x1F47).addRange(0x1F4E, 0x1F4F).addRange(0x1F7E, 0x1F7F).addRange(0x1FD4, 0x1FD5).addRange(0x1FF0, 0x1FF1).addRange(0x2072, 0x2073).addRange(0x209D, 0x209F).addRange(0x20C1, 0x20CF).addRange(0x20F1, 0x20FF).addRange(0x218C, 0x218F).addRange(0x2427, 0x243F).addRange(0x244B, 0x245F).addRange(0x2B74, 0x2B75).addRange(0x2CF4, 0x2CF8).addRange(0x2D28, 0x2D2C).addRange(0x2D2E, 0x2D2F).addRange(0x2D68, 0x2D6E).addRange(0x2D71, 0x2D7E);
		    set.addRange(0x2D97, 0x2D9F).addRange(0x2E5E, 0x2E7F).addRange(0x2EF4, 0x2EFF).addRange(0x2FD6, 0x2FEF).addRange(0x3097, 0x3098).addRange(0x3100, 0x3104).addRange(0x31E4, 0x31EE).addRange(0xA48D, 0xA48F).addRange(0xA4C7, 0xA4CF).addRange(0xA62C, 0xA63F).addRange(0xA6F8, 0xA6FF).addRange(0xA7CB, 0xA7CF).addRange(0xA7DA, 0xA7F1).addRange(0xA82D, 0xA82F).addRange(0xA83A, 0xA83F).addRange(0xA878, 0xA87F).addRange(0xA8C6, 0xA8CD).addRange(0xA8DA, 0xA8DF).addRange(0xA954, 0xA95E).addRange(0xA97D, 0xA97F).addRange(0xA9DA, 0xA9DD).addRange(0xAA37, 0xAA3F).addRange(0xAA4E, 0xAA4F).addRange(0xAA5A, 0xAA5B).addRange(0xAAC3, 0xAADA).addRange(0xAAF7, 0xAB00).addRange(0xAB07, 0xAB08).addRange(0xAB0F, 0xAB10).addRange(0xAB17, 0xAB1F).addRange(0xAB6C, 0xAB6F).addRange(0xABEE, 0xABEF).addRange(0xABFA, 0xABFF).addRange(0xD7A4, 0xD7AF).addRange(0xD7C7, 0xD7CA).addRange(0xD7FC, 0xD7FF).addRange(0xFA6E, 0xFA6F).addRange(0xFADA, 0xFAFF).addRange(0xFB07, 0xFB12).addRange(0xFB18, 0xFB1C).addRange(0xFBC3, 0xFBD2).addRange(0xFD90, 0xFD91).addRange(0xFDC8, 0xFDCE).addRange(0xFDD0, 0xFDEF).addRange(0xFE1A, 0xFE1F).addRange(0xFE6C, 0xFE6F).addRange(0xFEFD, 0xFEFE).addRange(0xFFBF, 0xFFC1).addRange(0xFFC8, 0xFFC9).addRange(0xFFD0, 0xFFD1).addRange(0xFFD8, 0xFFD9).addRange(0xFFDD, 0xFFDF);
		    set.addRange(0xFFEF, 0xFFF8).addRange(0xFFFE, 0xFFFF).addRange(0x1004E, 0x1004F).addRange(0x1005E, 0x1007F).addRange(0x100FB, 0x100FF).addRange(0x10103, 0x10106).addRange(0x10134, 0x10136).addRange(0x1019D, 0x1019F).addRange(0x101A1, 0x101CF).addRange(0x101FE, 0x1027F).addRange(0x1029D, 0x1029F).addRange(0x102D1, 0x102DF).addRange(0x102FC, 0x102FF).addRange(0x10324, 0x1032C).addRange(0x1034B, 0x1034F).addRange(0x1037B, 0x1037F).addRange(0x103C4, 0x103C7).addRange(0x103D6, 0x103FF).addRange(0x1049E, 0x1049F).addRange(0x104AA, 0x104AF).addRange(0x104D4, 0x104D7).addRange(0x104FC, 0x104FF).addRange(0x10528, 0x1052F).addRange(0x10564, 0x1056E).addRange(0x105BD, 0x105FF).addRange(0x10737, 0x1073F).addRange(0x10756, 0x1075F).addRange(0x10768, 0x1077F).addRange(0x107BB, 0x107FF).addRange(0x10806, 0x10807).addRange(0x10839, 0x1083B).addRange(0x1083D, 0x1083E).addRange(0x1089F, 0x108A6).addRange(0x108B0, 0x108DF).addRange(0x108F6, 0x108FA).addRange(0x1091C, 0x1091E).addRange(0x1093A, 0x1093E).addRange(0x10940, 0x1097F).addRange(0x109B8, 0x109BB).addRange(0x109D0, 0x109D1).addRange(0x10A07, 0x10A0B).addRange(0x10A36, 0x10A37).addRange(0x10A3B, 0x10A3E).addRange(0x10A49, 0x10A4F).addRange(0x10A59, 0x10A5F).addRange(0x10AA0, 0x10ABF).addRange(0x10AE7, 0x10AEA).addRange(0x10AF7, 0x10AFF).addRange(0x10B36, 0x10B38).addRange(0x10B56, 0x10B57).addRange(0x10B73, 0x10B77);
		    set.addRange(0x10B92, 0x10B98).addRange(0x10B9D, 0x10BA8).addRange(0x10BB0, 0x10BFF).addRange(0x10C49, 0x10C7F).addRange(0x10CB3, 0x10CBF).addRange(0x10CF3, 0x10CF9).addRange(0x10D28, 0x10D2F).addRange(0x10D3A, 0x10E5F).addRange(0x10EAE, 0x10EAF).addRange(0x10EB2, 0x10EFC).addRange(0x10F28, 0x10F2F).addRange(0x10F5A, 0x10F6F).addRange(0x10F8A, 0x10FAF).addRange(0x10FCC, 0x10FDF).addRange(0x10FF7, 0x10FFF).addRange(0x1104E, 0x11051).addRange(0x11076, 0x1107E).addRange(0x110C3, 0x110CC).addRange(0x110CE, 0x110CF).addRange(0x110E9, 0x110EF).addRange(0x110FA, 0x110FF).addRange(0x11148, 0x1114F).addRange(0x11177, 0x1117F).addRange(0x111F5, 0x111FF).addRange(0x11242, 0x1127F).addRange(0x112AA, 0x112AF).addRange(0x112EB, 0x112EF).addRange(0x112FA, 0x112FF).addRange(0x1130D, 0x1130E).addRange(0x11311, 0x11312).addRange(0x11345, 0x11346).addRange(0x11349, 0x1134A).addRange(0x1134E, 0x1134F).addRange(0x11351, 0x11356).addRange(0x11358, 0x1135C).addRange(0x11364, 0x11365).addRange(0x1136D, 0x1136F).addRange(0x11375, 0x113FF).addRange(0x11462, 0x1147F).addRange(0x114C8, 0x114CF).addRange(0x114DA, 0x1157F).addRange(0x115B6, 0x115B7).addRange(0x115DE, 0x115FF).addRange(0x11645, 0x1164F).addRange(0x1165A, 0x1165F).addRange(0x1166D, 0x1167F).addRange(0x116BA, 0x116BF).addRange(0x116CA, 0x116FF).addRange(0x1171B, 0x1171C).addRange(0x1172C, 0x1172F).addRange(0x11747, 0x117FF);
		    set.addRange(0x1183C, 0x1189F).addRange(0x118F3, 0x118FE).addRange(0x11907, 0x11908).addRange(0x1190A, 0x1190B).addRange(0x11939, 0x1193A).addRange(0x11947, 0x1194F).addRange(0x1195A, 0x1199F).addRange(0x119A8, 0x119A9).addRange(0x119D8, 0x119D9).addRange(0x119E5, 0x119FF).addRange(0x11A48, 0x11A4F).addRange(0x11AA3, 0x11AAF).addRange(0x11AF9, 0x11AFF).addRange(0x11B0A, 0x11BFF).addRange(0x11C46, 0x11C4F).addRange(0x11C6D, 0x11C6F).addRange(0x11C90, 0x11C91).addRange(0x11CB7, 0x11CFF).addRange(0x11D37, 0x11D39).addRange(0x11D48, 0x11D4F).addRange(0x11D5A, 0x11D5F).addRange(0x11D99, 0x11D9F).addRange(0x11DAA, 0x11EDF).addRange(0x11EF9, 0x11EFF).addRange(0x11F3B, 0x11F3D).addRange(0x11F5A, 0x11FAF).addRange(0x11FB1, 0x11FBF).addRange(0x11FF2, 0x11FFE).addRange(0x1239A, 0x123FF).addRange(0x12475, 0x1247F).addRange(0x12544, 0x12F8F).addRange(0x12FF3, 0x12FFF).addRange(0x13456, 0x143FF).addRange(0x14647, 0x167FF).addRange(0x16A39, 0x16A3F).addRange(0x16A6A, 0x16A6D).addRange(0x16ACA, 0x16ACF).addRange(0x16AEE, 0x16AEF).addRange(0x16AF6, 0x16AFF).addRange(0x16B46, 0x16B4F).addRange(0x16B78, 0x16B7C).addRange(0x16B90, 0x16E3F).addRange(0x16E9B, 0x16EFF).addRange(0x16F4B, 0x16F4E).addRange(0x16F88, 0x16F8E).addRange(0x16FA0, 0x16FDF).addRange(0x16FE5, 0x16FEF).addRange(0x16FF2, 0x16FFF).addRange(0x187F8, 0x187FF).addRange(0x18CD6, 0x18CFF).addRange(0x18D09, 0x1AFEF);
		    set.addRange(0x1B123, 0x1B131).addRange(0x1B133, 0x1B14F).addRange(0x1B153, 0x1B154).addRange(0x1B156, 0x1B163).addRange(0x1B168, 0x1B16F).addRange(0x1B2FC, 0x1BBFF).addRange(0x1BC6B, 0x1BC6F).addRange(0x1BC7D, 0x1BC7F).addRange(0x1BC89, 0x1BC8F).addRange(0x1BC9A, 0x1BC9B).addRange(0x1BCA4, 0x1CEFF).addRange(0x1CF2E, 0x1CF2F).addRange(0x1CF47, 0x1CF4F).addRange(0x1CFC4, 0x1CFFF).addRange(0x1D0F6, 0x1D0FF).addRange(0x1D127, 0x1D128).addRange(0x1D1EB, 0x1D1FF).addRange(0x1D246, 0x1D2BF).addRange(0x1D2D4, 0x1D2DF).addRange(0x1D2F4, 0x1D2FF).addRange(0x1D357, 0x1D35F).addRange(0x1D379, 0x1D3FF).addRange(0x1D4A0, 0x1D4A1).addRange(0x1D4A3, 0x1D4A4).addRange(0x1D4A7, 0x1D4A8).addRange(0x1D50B, 0x1D50C).addRange(0x1D547, 0x1D549).addRange(0x1D6A6, 0x1D6A7).addRange(0x1D7CC, 0x1D7CD).addRange(0x1DA8C, 0x1DA9A).addRange(0x1DAB0, 0x1DEFF).addRange(0x1DF1F, 0x1DF24).addRange(0x1DF2B, 0x1DFFF).addRange(0x1E019, 0x1E01A).addRange(0x1E02B, 0x1E02F).addRange(0x1E06E, 0x1E08E).addRange(0x1E090, 0x1E0FF).addRange(0x1E12D, 0x1E12F).addRange(0x1E13E, 0x1E13F).addRange(0x1E14A, 0x1E14D).addRange(0x1E150, 0x1E28F).addRange(0x1E2AF, 0x1E2BF).addRange(0x1E2FA, 0x1E2FE).addRange(0x1E300, 0x1E4CF).addRange(0x1E4FA, 0x1E7DF).addRange(0x1E8C5, 0x1E8C6).addRange(0x1E8D7, 0x1E8FF).addRange(0x1E94C, 0x1E94F).addRange(0x1E95A, 0x1E95D).addRange(0x1E960, 0x1EC70).addRange(0x1ECB5, 0x1ED00);
		    set.addRange(0x1ED3E, 0x1EDFF).addRange(0x1EE25, 0x1EE26).addRange(0x1EE3C, 0x1EE41).addRange(0x1EE43, 0x1EE46).addRange(0x1EE55, 0x1EE56).addRange(0x1EE65, 0x1EE66).addRange(0x1EE9C, 0x1EEA0).addRange(0x1EEBC, 0x1EEEF).addRange(0x1EEF2, 0x1EFFF).addRange(0x1F02C, 0x1F02F).addRange(0x1F094, 0x1F09F).addRange(0x1F0AF, 0x1F0B0).addRange(0x1F0F6, 0x1F0FF).addRange(0x1F1AE, 0x1F1E5).addRange(0x1F203, 0x1F20F).addRange(0x1F23C, 0x1F23F).addRange(0x1F249, 0x1F24F).addRange(0x1F252, 0x1F25F).addRange(0x1F266, 0x1F2FF).addRange(0x1F6D8, 0x1F6DB).addRange(0x1F6ED, 0x1F6EF).addRange(0x1F6FD, 0x1F6FF).addRange(0x1F777, 0x1F77A).addRange(0x1F7DA, 0x1F7DF).addRange(0x1F7EC, 0x1F7EF).addRange(0x1F7F1, 0x1F7FF).addRange(0x1F80C, 0x1F80F).addRange(0x1F848, 0x1F84F).addRange(0x1F85A, 0x1F85F).addRange(0x1F888, 0x1F88F).addRange(0x1F8AE, 0x1F8AF).addRange(0x1F8B2, 0x1F8FF).addRange(0x1FA54, 0x1FA5F).addRange(0x1FA6E, 0x1FA6F).addRange(0x1FA7D, 0x1FA7F).addRange(0x1FA89, 0x1FA8F).addRange(0x1FAC6, 0x1FACD).addRange(0x1FADC, 0x1FADF).addRange(0x1FAE9, 0x1FAEF).addRange(0x1FAF9, 0x1FAFF).addRange(0x1FBCB, 0x1FBEF).addRange(0x1FBFA, 0x1FFFF).addRange(0x2A6E0, 0x2A6FF).addRange(0x2B73A, 0x2B73F).addRange(0x2B81E, 0x2B81F).addRange(0x2CEA2, 0x2CEAF).addRange(0x2EBE1, 0x2EBEF).addRange(0x2EE5E, 0x2F7FF).addRange(0x2FA1E, 0x2FFFF).addRange(0x3134B, 0x3134F).addRange(0x323B0, 0xE0000);
		    set.addRange(0xE0002, 0xE001F).addRange(0xE0080, 0xE00FF).addRange(0xE01F0, 0xEFFFF).addRange(0xFFFFE, 0xFFFFF).addRange(0x10FFFE, 0x10FFFF);
		    Unassigned.characters = set;
		    return Unassigned;
		  }

		  var Uppercase_Letter = {};

		  var hasRequiredUppercase_Letter;
		  function requireUppercase_Letter() {
		    if (hasRequiredUppercase_Letter) return Uppercase_Letter;
		    hasRequiredUppercase_Letter = 1;
		    var set = regenerateExports(0x100, 0x102, 0x104, 0x106, 0x108, 0x10A, 0x10C, 0x10E, 0x110, 0x112, 0x114, 0x116, 0x118, 0x11A, 0x11C, 0x11E, 0x120, 0x122, 0x124, 0x126, 0x128, 0x12A, 0x12C, 0x12E, 0x130, 0x132, 0x134, 0x136, 0x139, 0x13B, 0x13D, 0x13F, 0x141, 0x143, 0x145, 0x147, 0x14A, 0x14C, 0x14E, 0x150, 0x152, 0x154, 0x156, 0x158, 0x15A, 0x15C, 0x15E, 0x160, 0x162, 0x164, 0x166, 0x168, 0x16A, 0x16C, 0x16E, 0x170, 0x172, 0x174, 0x176, 0x17B, 0x17D, 0x184, 0x1A2, 0x1A4, 0x1A9, 0x1AC, 0x1B5, 0x1BC, 0x1C4, 0x1C7, 0x1CA, 0x1CD, 0x1CF, 0x1D1, 0x1D3, 0x1D5, 0x1D7, 0x1D9, 0x1DB, 0x1DE, 0x1E0, 0x1E2, 0x1E4, 0x1E6, 0x1E8, 0x1EA, 0x1EC, 0x1EE, 0x1F1, 0x1F4, 0x1FA, 0x1FC, 0x1FE, 0x200, 0x202, 0x204, 0x206, 0x208, 0x20A, 0x20C, 0x20E, 0x210, 0x212, 0x214, 0x216, 0x218, 0x21A, 0x21C, 0x21E, 0x220, 0x222, 0x224, 0x226, 0x228, 0x22A, 0x22C, 0x22E, 0x230, 0x232, 0x241, 0x248, 0x24A, 0x24C, 0x24E, 0x370, 0x372, 0x376, 0x37F, 0x386, 0x38C, 0x3CF, 0x3D8, 0x3DA, 0x3DC, 0x3DE, 0x3E0, 0x3E2, 0x3E4, 0x3E6, 0x3E8, 0x3EA, 0x3EC, 0x3EE, 0x3F4, 0x3F7, 0x460, 0x462, 0x464, 0x466, 0x468, 0x46A, 0x46C, 0x46E, 0x470, 0x472, 0x474, 0x476, 0x478, 0x47A, 0x47C, 0x47E, 0x480, 0x48A, 0x48C, 0x48E, 0x490, 0x492, 0x494, 0x496, 0x498, 0x49A, 0x49C, 0x49E, 0x4A0, 0x4A2, 0x4A4, 0x4A6, 0x4A8, 0x4AA, 0x4AC, 0x4AE, 0x4B0, 0x4B2, 0x4B4, 0x4B6, 0x4B8, 0x4BA, 0x4BC, 0x4BE, 0x4C3, 0x4C5, 0x4C7, 0x4C9, 0x4CB, 0x4CD, 0x4D0, 0x4D2, 0x4D4, 0x4D6, 0x4D8, 0x4DA, 0x4DC, 0x4DE, 0x4E0, 0x4E2, 0x4E4, 0x4E6, 0x4E8, 0x4EA, 0x4EC, 0x4EE, 0x4F0, 0x4F2, 0x4F4, 0x4F6, 0x4F8, 0x4FA, 0x4FC, 0x4FE, 0x500, 0x502, 0x504, 0x506, 0x508, 0x50A, 0x50C, 0x50E, 0x510, 0x512, 0x514, 0x516, 0x518, 0x51A, 0x51C, 0x51E, 0x520, 0x522, 0x524, 0x526, 0x528, 0x52A, 0x52C, 0x52E, 0x10C7, 0x10CD, 0x1E00, 0x1E02, 0x1E04, 0x1E06, 0x1E08, 0x1E0A, 0x1E0C, 0x1E0E, 0x1E10, 0x1E12, 0x1E14, 0x1E16, 0x1E18, 0x1E1A, 0x1E1C, 0x1E1E, 0x1E20, 0x1E22, 0x1E24, 0x1E26, 0x1E28, 0x1E2A, 0x1E2C, 0x1E2E, 0x1E30, 0x1E32, 0x1E34, 0x1E36, 0x1E38, 0x1E3A, 0x1E3C, 0x1E3E, 0x1E40, 0x1E42, 0x1E44, 0x1E46, 0x1E48, 0x1E4A, 0x1E4C, 0x1E4E, 0x1E50, 0x1E52, 0x1E54, 0x1E56, 0x1E58, 0x1E5A, 0x1E5C, 0x1E5E, 0x1E60, 0x1E62, 0x1E64, 0x1E66, 0x1E68, 0x1E6A, 0x1E6C, 0x1E6E, 0x1E70, 0x1E72, 0x1E74, 0x1E76, 0x1E78, 0x1E7A, 0x1E7C, 0x1E7E, 0x1E80, 0x1E82, 0x1E84, 0x1E86, 0x1E88, 0x1E8A, 0x1E8C, 0x1E8E, 0x1E90, 0x1E92, 0x1E94, 0x1E9E, 0x1EA0, 0x1EA2, 0x1EA4, 0x1EA6, 0x1EA8, 0x1EAA, 0x1EAC, 0x1EAE, 0x1EB0, 0x1EB2, 0x1EB4, 0x1EB6, 0x1EB8, 0x1EBA, 0x1EBC, 0x1EBE, 0x1EC0, 0x1EC2, 0x1EC4, 0x1EC6, 0x1EC8, 0x1ECA, 0x1ECC, 0x1ECE, 0x1ED0, 0x1ED2, 0x1ED4, 0x1ED6, 0x1ED8, 0x1EDA, 0x1EDC, 0x1EDE, 0x1EE0, 0x1EE2, 0x1EE4, 0x1EE6, 0x1EE8, 0x1EEA, 0x1EEC, 0x1EEE, 0x1EF0, 0x1EF2, 0x1EF4, 0x1EF6, 0x1EF8, 0x1EFA, 0x1EFC, 0x1EFE, 0x1F59, 0x1F5B, 0x1F5D, 0x1F5F, 0x2102, 0x2107, 0x2115, 0x2124, 0x2126, 0x2128, 0x2145, 0x2183, 0x2C60, 0x2C67, 0x2C69, 0x2C6B, 0x2C72, 0x2C75, 0x2C82, 0x2C84, 0x2C86, 0x2C88, 0x2C8A, 0x2C8C, 0x2C8E, 0x2C90, 0x2C92, 0x2C94, 0x2C96, 0x2C98, 0x2C9A, 0x2C9C, 0x2C9E, 0x2CA0, 0x2CA2, 0x2CA4, 0x2CA6, 0x2CA8, 0x2CAA, 0x2CAC, 0x2CAE, 0x2CB0, 0x2CB2, 0x2CB4, 0x2CB6, 0x2CB8, 0x2CBA, 0x2CBC, 0x2CBE, 0x2CC0, 0x2CC2, 0x2CC4, 0x2CC6, 0x2CC8, 0x2CCA, 0x2CCC, 0x2CCE, 0x2CD0, 0x2CD2, 0x2CD4, 0x2CD6, 0x2CD8, 0x2CDA, 0x2CDC, 0x2CDE, 0x2CE0, 0x2CE2, 0x2CEB, 0x2CED, 0x2CF2, 0xA640, 0xA642, 0xA644, 0xA646, 0xA648, 0xA64A, 0xA64C, 0xA64E, 0xA650, 0xA652, 0xA654, 0xA656, 0xA658, 0xA65A, 0xA65C, 0xA65E, 0xA660, 0xA662, 0xA664, 0xA666, 0xA668, 0xA66A, 0xA66C, 0xA680, 0xA682, 0xA684, 0xA686, 0xA688, 0xA68A, 0xA68C, 0xA68E, 0xA690, 0xA692, 0xA694, 0xA696, 0xA698, 0xA69A, 0xA722, 0xA724, 0xA726, 0xA728, 0xA72A, 0xA72C, 0xA72E, 0xA732, 0xA734, 0xA736, 0xA738, 0xA73A, 0xA73C, 0xA73E, 0xA740, 0xA742, 0xA744, 0xA746, 0xA748, 0xA74A, 0xA74C, 0xA74E, 0xA750, 0xA752, 0xA754, 0xA756, 0xA758, 0xA75A, 0xA75C, 0xA75E, 0xA760, 0xA762, 0xA764, 0xA766, 0xA768, 0xA76A, 0xA76C, 0xA76E, 0xA779, 0xA77B, 0xA780, 0xA782, 0xA784, 0xA786, 0xA78B, 0xA78D, 0xA790, 0xA792, 0xA796, 0xA798, 0xA79A, 0xA79C, 0xA79E, 0xA7A0, 0xA7A2, 0xA7A4, 0xA7A6, 0xA7A8, 0xA7B6, 0xA7B8, 0xA7BA, 0xA7BC, 0xA7BE, 0xA7C0, 0xA7C2, 0xA7C9, 0xA7D0, 0xA7D6, 0xA7D8, 0xA7F5, 0x1D49C, 0x1D4A2, 0x1D546, 0x1D7CA);
		    set.addRange(0x41, 0x5A).addRange(0xC0, 0xD6).addRange(0xD8, 0xDE).addRange(0x178, 0x179).addRange(0x181, 0x182).addRange(0x186, 0x187).addRange(0x189, 0x18B).addRange(0x18E, 0x191).addRange(0x193, 0x194).addRange(0x196, 0x198).addRange(0x19C, 0x19D).addRange(0x19F, 0x1A0).addRange(0x1A6, 0x1A7).addRange(0x1AE, 0x1AF).addRange(0x1B1, 0x1B3).addRange(0x1B7, 0x1B8).addRange(0x1F6, 0x1F8).addRange(0x23A, 0x23B).addRange(0x23D, 0x23E).addRange(0x243, 0x246).addRange(0x388, 0x38A).addRange(0x38E, 0x38F).addRange(0x391, 0x3A1).addRange(0x3A3, 0x3AB).addRange(0x3D2, 0x3D4).addRange(0x3F9, 0x3FA).addRange(0x3FD, 0x42F).addRange(0x4C0, 0x4C1).addRange(0x531, 0x556).addRange(0x10A0, 0x10C5).addRange(0x13A0, 0x13F5).addRange(0x1C90, 0x1CBA).addRange(0x1CBD, 0x1CBF).addRange(0x1F08, 0x1F0F).addRange(0x1F18, 0x1F1D).addRange(0x1F28, 0x1F2F).addRange(0x1F38, 0x1F3F).addRange(0x1F48, 0x1F4D).addRange(0x1F68, 0x1F6F).addRange(0x1FB8, 0x1FBB).addRange(0x1FC8, 0x1FCB).addRange(0x1FD8, 0x1FDB).addRange(0x1FE8, 0x1FEC).addRange(0x1FF8, 0x1FFB).addRange(0x210B, 0x210D).addRange(0x2110, 0x2112).addRange(0x2119, 0x211D).addRange(0x212A, 0x212D).addRange(0x2130, 0x2133).addRange(0x213E, 0x213F).addRange(0x2C00, 0x2C2F);
		    set.addRange(0x2C62, 0x2C64).addRange(0x2C6D, 0x2C70).addRange(0x2C7E, 0x2C80).addRange(0xA77D, 0xA77E).addRange(0xA7AA, 0xA7AE).addRange(0xA7B0, 0xA7B4).addRange(0xA7C4, 0xA7C7).addRange(0xFF21, 0xFF3A).addRange(0x10400, 0x10427).addRange(0x104B0, 0x104D3).addRange(0x10570, 0x1057A).addRange(0x1057C, 0x1058A).addRange(0x1058C, 0x10592).addRange(0x10594, 0x10595).addRange(0x10C80, 0x10CB2).addRange(0x118A0, 0x118BF).addRange(0x16E40, 0x16E5F).addRange(0x1D400, 0x1D419).addRange(0x1D434, 0x1D44D).addRange(0x1D468, 0x1D481).addRange(0x1D49E, 0x1D49F).addRange(0x1D4A5, 0x1D4A6).addRange(0x1D4A9, 0x1D4AC).addRange(0x1D4AE, 0x1D4B5).addRange(0x1D4D0, 0x1D4E9).addRange(0x1D504, 0x1D505).addRange(0x1D507, 0x1D50A).addRange(0x1D50D, 0x1D514).addRange(0x1D516, 0x1D51C).addRange(0x1D538, 0x1D539).addRange(0x1D53B, 0x1D53E).addRange(0x1D540, 0x1D544).addRange(0x1D54A, 0x1D550).addRange(0x1D56C, 0x1D585).addRange(0x1D5A0, 0x1D5B9).addRange(0x1D5D4, 0x1D5ED).addRange(0x1D608, 0x1D621).addRange(0x1D63C, 0x1D655).addRange(0x1D670, 0x1D689).addRange(0x1D6A8, 0x1D6C0).addRange(0x1D6E2, 0x1D6FA).addRange(0x1D71C, 0x1D734).addRange(0x1D756, 0x1D76E).addRange(0x1D790, 0x1D7A8).addRange(0x1E900, 0x1E921);
		    Uppercase_Letter.characters = set;
		    return Uppercase_Letter;
		  }

		  var regenerateUnicodeProperties;
		  var hasRequiredRegenerateUnicodeProperties;
		  function requireRegenerateUnicodeProperties() {
		    if (hasRequiredRegenerateUnicodeProperties) return regenerateUnicodeProperties;
		    hasRequiredRegenerateUnicodeProperties = 1;
		    regenerateUnicodeProperties = new Map([['General_Category', ['Cased_Letter', 'Close_Punctuation', 'Connector_Punctuation', 'Control', 'Currency_Symbol', 'Dash_Punctuation', 'Decimal_Number', 'Enclosing_Mark', 'Final_Punctuation', 'Format', 'Initial_Punctuation', 'Letter', 'Letter_Number', 'Line_Separator', 'Lowercase_Letter', 'Mark', 'Math_Symbol', 'Modifier_Letter', 'Modifier_Symbol', 'Nonspacing_Mark', 'Number', 'Open_Punctuation', 'Other', 'Other_Letter', 'Other_Number', 'Other_Punctuation', 'Other_Symbol', 'Paragraph_Separator', 'Private_Use', 'Punctuation', 'Separator', 'Space_Separator', 'Spacing_Mark', 'Surrogate', 'Symbol', 'Titlecase_Letter', 'Unassigned', 'Uppercase_Letter']], ['Script', ['Adlam', 'Ahom', 'Anatolian_Hieroglyphs', 'Arabic', 'Armenian', 'Avestan', 'Balinese', 'Bamum', 'Bassa_Vah', 'Batak', 'Bengali', 'Bhaiksuki', 'Bopomofo', 'Brahmi', 'Braille', 'Buginese', 'Buhid', 'Canadian_Aboriginal', 'Carian', 'Caucasian_Albanian', 'Chakma', 'Cham', 'Cherokee', 'Chorasmian', 'Common', 'Coptic', 'Cuneiform', 'Cypriot', 'Cypro_Minoan', 'Cyrillic', 'Deseret', 'Devanagari', 'Dives_Akuru', 'Dogra', 'Duployan', 'Egyptian_Hieroglyphs', 'Elbasan', 'Elymaic', 'Ethiopic', 'Georgian', 'Glagolitic', 'Gothic', 'Grantha', 'Greek', 'Gujarati', 'Gunjala_Gondi', 'Gurmukhi', 'Han', 'Hangul', 'Hanifi_Rohingya', 'Hanunoo', 'Hatran', 'Hebrew', 'Hiragana', 'Imperial_Aramaic', 'Inherited', 'Inscriptional_Pahlavi', 'Inscriptional_Parthian', 'Javanese', 'Kaithi', 'Kannada', 'Katakana', 'Kawi', 'Kayah_Li', 'Kharoshthi', 'Khitan_Small_Script', 'Khmer', 'Khojki', 'Khudawadi', 'Lao', 'Latin', 'Lepcha', 'Limbu', 'Linear_A', 'Linear_B', 'Lisu', 'Lycian', 'Lydian', 'Mahajani', 'Makasar', 'Malayalam', 'Mandaic', 'Manichaean', 'Marchen', 'Masaram_Gondi', 'Medefaidrin', 'Meetei_Mayek', 'Mende_Kikakui', 'Meroitic_Cursive', 'Meroitic_Hieroglyphs', 'Miao', 'Modi', 'Mongolian', 'Mro', 'Multani', 'Myanmar', 'Nabataean', 'Nag_Mundari', 'Nandinagari', 'New_Tai_Lue', 'Newa', 'Nko', 'Nushu', 'Nyiakeng_Puachue_Hmong', 'Ogham', 'Ol_Chiki', 'Old_Hungarian', 'Old_Italic', 'Old_North_Arabian', 'Old_Permic', 'Old_Persian', 'Old_Sogdian', 'Old_South_Arabian', 'Old_Turkic', 'Old_Uyghur', 'Oriya', 'Osage', 'Osmanya', 'Pahawh_Hmong', 'Palmyrene', 'Pau_Cin_Hau', 'Phags_Pa', 'Phoenician', 'Psalter_Pahlavi', 'Rejang', 'Runic', 'Samaritan', 'Saurashtra', 'Sharada', 'Shavian', 'Siddham', 'SignWriting', 'Sinhala', 'Sogdian', 'Sora_Sompeng', 'Soyombo', 'Sundanese', 'Syloti_Nagri', 'Syriac', 'Tagalog', 'Tagbanwa', 'Tai_Le', 'Tai_Tham', 'Tai_Viet', 'Takri', 'Tamil', 'Tangsa', 'Tangut', 'Telugu', 'Thaana', 'Thai', 'Tibetan', 'Tifinagh', 'Tirhuta', 'Toto', 'Ugaritic', 'Vai', 'Vithkuqi', 'Wancho', 'Warang_Citi', 'Yezidi', 'Yi', 'Zanabazar_Square']], ['Script_Extensions', ['Adlam', 'Ahom', 'Anatolian_Hieroglyphs', 'Arabic', 'Armenian', 'Avestan', 'Balinese', 'Bamum', 'Bassa_Vah', 'Batak', 'Bengali', 'Bhaiksuki', 'Bopomofo', 'Brahmi', 'Braille', 'Buginese', 'Buhid', 'Canadian_Aboriginal', 'Carian', 'Caucasian_Albanian', 'Chakma', 'Cham', 'Cherokee', 'Chorasmian', 'Common', 'Coptic', 'Cuneiform', 'Cypriot', 'Cypro_Minoan', 'Cyrillic', 'Deseret', 'Devanagari', 'Dives_Akuru', 'Dogra', 'Duployan', 'Egyptian_Hieroglyphs', 'Elbasan', 'Elymaic', 'Ethiopic', 'Georgian', 'Glagolitic', 'Gothic', 'Grantha', 'Greek', 'Gujarati', 'Gunjala_Gondi', 'Gurmukhi', 'Han', 'Hangul', 'Hanifi_Rohingya', 'Hanunoo', 'Hatran', 'Hebrew', 'Hiragana', 'Imperial_Aramaic', 'Inherited', 'Inscriptional_Pahlavi', 'Inscriptional_Parthian', 'Javanese', 'Kaithi', 'Kannada', 'Katakana', 'Kawi', 'Kayah_Li', 'Kharoshthi', 'Khitan_Small_Script', 'Khmer', 'Khojki', 'Khudawadi', 'Lao', 'Latin', 'Lepcha', 'Limbu', 'Linear_A', 'Linear_B', 'Lisu', 'Lycian', 'Lydian', 'Mahajani', 'Makasar', 'Malayalam', 'Mandaic', 'Manichaean', 'Marchen', 'Masaram_Gondi', 'Medefaidrin', 'Meetei_Mayek', 'Mende_Kikakui', 'Meroitic_Cursive', 'Meroitic_Hieroglyphs', 'Miao', 'Modi', 'Mongolian', 'Mro', 'Multani', 'Myanmar', 'Nabataean', 'Nag_Mundari', 'Nandinagari', 'New_Tai_Lue', 'Newa', 'Nko', 'Nushu', 'Nyiakeng_Puachue_Hmong', 'Ogham', 'Ol_Chiki', 'Old_Hungarian', 'Old_Italic', 'Old_North_Arabian', 'Old_Permic', 'Old_Persian', 'Old_Sogdian', 'Old_South_Arabian', 'Old_Turkic', 'Old_Uyghur', 'Oriya', 'Osage', 'Osmanya', 'Pahawh_Hmong', 'Palmyrene', 'Pau_Cin_Hau', 'Phags_Pa', 'Phoenician', 'Psalter_Pahlavi', 'Rejang', 'Runic', 'Samaritan', 'Saurashtra', 'Sharada', 'Shavian', 'Siddham', 'SignWriting', 'Sinhala', 'Sogdian', 'Sora_Sompeng', 'Soyombo', 'Sundanese', 'Syloti_Nagri', 'Syriac', 'Tagalog', 'Tagbanwa', 'Tai_Le', 'Tai_Tham', 'Tai_Viet', 'Takri', 'Tamil', 'Tangsa', 'Tangut', 'Telugu', 'Thaana', 'Thai', 'Tibetan', 'Tifinagh', 'Tirhuta', 'Toto', 'Ugaritic', 'Vai', 'Vithkuqi', 'Wancho', 'Warang_Citi', 'Yezidi', 'Yi', 'Zanabazar_Square']], ['Binary_Property', ['ASCII', 'ASCII_Hex_Digit', 'Alphabetic', 'Any', 'Assigned', 'Bidi_Control', 'Bidi_Mirrored', 'Case_Ignorable', 'Cased', 'Changes_When_Casefolded', 'Changes_When_Casemapped', 'Changes_When_Lowercased', 'Changes_When_NFKC_Casefolded', 'Changes_When_Titlecased', 'Changes_When_Uppercased', 'Dash', 'Default_Ignorable_Code_Point', 'Deprecated', 'Diacritic', 'Emoji', 'Emoji_Component', 'Emoji_Modifier', 'Emoji_Modifier_Base', 'Emoji_Presentation', 'Extended_Pictographic', 'Extender', 'Grapheme_Base', 'Grapheme_Extend', 'Hex_Digit', 'IDS_Binary_Operator', 'IDS_Trinary_Operator', 'ID_Continue', 'ID_Start', 'Ideographic', 'Join_Control', 'Logical_Order_Exception', 'Lowercase', 'Math', 'Noncharacter_Code_Point', 'Pattern_Syntax', 'Pattern_White_Space', 'Quotation_Mark', 'Radical', 'Regional_Indicator', 'Sentence_Terminal', 'Soft_Dotted', 'Terminal_Punctuation', 'Unified_Ideograph', 'Uppercase', 'Variation_Selector', 'White_Space', 'XID_Continue', 'XID_Start']], ['Property_of_Strings', ['Basic_Emoji', 'Emoji_Keycap_Sequence', 'RGI_Emoji', 'RGI_Emoji_Flag_Sequence', 'RGI_Emoji_Modifier_Sequence', 'RGI_Emoji_Tag_Sequence', 'RGI_Emoji_ZWJ_Sequence']]]);
		    return regenerateUnicodeProperties;
		  }

		  var Basic_Emoji = {};

		  var hasRequiredBasic_Emoji;
		  function requireBasic_Emoji() {
		    if (hasRequiredBasic_Emoji) return Basic_Emoji;
		    hasRequiredBasic_Emoji = 1;
		    var set = regenerateExports(0x23F0, 0x23F3, 0x267F, 0x2693, 0x26A1, 0x26CE, 0x26D4, 0x26EA, 0x26F5, 0x26FA, 0x26FD, 0x2705, 0x2728, 0x274C, 0x274E, 0x2757, 0x27B0, 0x27BF, 0x2B50, 0x2B55, 0x1F004, 0x1F0CF, 0x1F18E, 0x1F201, 0x1F21A, 0x1F22F, 0x1F3F4, 0x1F440, 0x1F57A, 0x1F5A4, 0x1F6CC, 0x1F7F0);
		    set.addRange(0x231A, 0x231B).addRange(0x23E9, 0x23EC).addRange(0x25FD, 0x25FE).addRange(0x2614, 0x2615).addRange(0x2648, 0x2653).addRange(0x26AA, 0x26AB).addRange(0x26BD, 0x26BE).addRange(0x26C4, 0x26C5).addRange(0x26F2, 0x26F3).addRange(0x270A, 0x270B).addRange(0x2753, 0x2755).addRange(0x2795, 0x2797).addRange(0x2B1B, 0x2B1C).addRange(0x1F191, 0x1F19A).addRange(0x1F232, 0x1F236).addRange(0x1F238, 0x1F23A).addRange(0x1F250, 0x1F251).addRange(0x1F300, 0x1F320).addRange(0x1F32D, 0x1F335).addRange(0x1F337, 0x1F37C).addRange(0x1F37E, 0x1F393).addRange(0x1F3A0, 0x1F3CA).addRange(0x1F3CF, 0x1F3D3).addRange(0x1F3E0, 0x1F3F0).addRange(0x1F3F8, 0x1F43E).addRange(0x1F442, 0x1F4FC).addRange(0x1F4FF, 0x1F53D).addRange(0x1F54B, 0x1F54E).addRange(0x1F550, 0x1F567).addRange(0x1F595, 0x1F596).addRange(0x1F5FB, 0x1F64F).addRange(0x1F680, 0x1F6C5).addRange(0x1F6D0, 0x1F6D2).addRange(0x1F6D5, 0x1F6D7).addRange(0x1F6DC, 0x1F6DF).addRange(0x1F6EB, 0x1F6EC).addRange(0x1F6F4, 0x1F6FC).addRange(0x1F7E0, 0x1F7EB).addRange(0x1F90C, 0x1F93A).addRange(0x1F93C, 0x1F945).addRange(0x1F947, 0x1F9FF).addRange(0x1FA70, 0x1FA7C).addRange(0x1FA80, 0x1FA88).addRange(0x1FA90, 0x1FABD).addRange(0x1FABF, 0x1FAC5).addRange(0x1FACE, 0x1FADB).addRange(0x1FAE0, 0x1FAE8).addRange(0x1FAF0, 0x1FAF8);
		    Basic_Emoji.characters = set;
		    Basic_Emoji.strings = ["\xA9\uFE0F", "\xAE\uFE0F", "\u203C\uFE0F", "\u2049\uFE0F", "\u2122\uFE0F", "\u2139\uFE0F", "\u2194\uFE0F", "\u2195\uFE0F", "\u2196\uFE0F", "\u2197\uFE0F", "\u2198\uFE0F", "\u2199\uFE0F", "\u21A9\uFE0F", "\u21AA\uFE0F", "\u2328\uFE0F", "\u23CF\uFE0F", "\u23ED\uFE0F", "\u23EE\uFE0F", "\u23EF\uFE0F", "\u23F1\uFE0F", "\u23F2\uFE0F", "\u23F8\uFE0F", "\u23F9\uFE0F", "\u23FA\uFE0F", "\u24C2\uFE0F", "\u25AA\uFE0F", "\u25AB\uFE0F", "\u25B6\uFE0F", "\u25C0\uFE0F", "\u25FB\uFE0F", "\u25FC\uFE0F", "\u2600\uFE0F", "\u2601\uFE0F", "\u2602\uFE0F", "\u2603\uFE0F", "\u2604\uFE0F", "\u260E\uFE0F", "\u2611\uFE0F", "\u2618\uFE0F", "\u261D\uFE0F", "\u2620\uFE0F", "\u2622\uFE0F", "\u2623\uFE0F", "\u2626\uFE0F", "\u262A\uFE0F", "\u262E\uFE0F", "\u262F\uFE0F", "\u2638\uFE0F", "\u2639\uFE0F", "\u263A\uFE0F", "\u2640\uFE0F", "\u2642\uFE0F", "\u265F\uFE0F", "\u2660\uFE0F", "\u2663\uFE0F", "\u2665\uFE0F", "\u2666\uFE0F", "\u2668\uFE0F", "\u267B\uFE0F", "\u267E\uFE0F", "\u2692\uFE0F", "\u2694\uFE0F", "\u2695\uFE0F", "\u2696\uFE0F", "\u2697\uFE0F", "\u2699\uFE0F", "\u269B\uFE0F", "\u269C\uFE0F", "\u26A0\uFE0F", "\u26A7\uFE0F", "\u26B0\uFE0F", "\u26B1\uFE0F", "\u26C8\uFE0F", "\u26CF\uFE0F", "\u26D1\uFE0F", "\u26D3\uFE0F", "\u26E9\uFE0F", "\u26F0\uFE0F", "\u26F1\uFE0F", "\u26F4\uFE0F", "\u26F7\uFE0F", "\u26F8\uFE0F", "\u26F9\uFE0F", "\u2702\uFE0F", "\u2708\uFE0F", "\u2709\uFE0F", "\u270C\uFE0F", "\u270D\uFE0F", "\u270F\uFE0F", "\u2712\uFE0F", "\u2714\uFE0F", "\u2716\uFE0F", "\u271D\uFE0F", "\u2721\uFE0F", "\u2733\uFE0F", "\u2734\uFE0F", "\u2744\uFE0F", "\u2747\uFE0F", "\u2763\uFE0F", "\u2764\uFE0F", "\u27A1\uFE0F", "\u2934\uFE0F", "\u2935\uFE0F", "\u2B05\uFE0F", "\u2B06\uFE0F", "\u2B07\uFE0F", "\u3030\uFE0F", "\u303D\uFE0F", "\u3297\uFE0F", "\u3299\uFE0F", "\uD83C\uDD70\uFE0F", "\uD83C\uDD71\uFE0F", "\uD83C\uDD7E\uFE0F", "\uD83C\uDD7F\uFE0F", "\uD83C\uDE02\uFE0F", "\uD83C\uDE37\uFE0F", "\uD83C\uDF21\uFE0F", "\uD83C\uDF24\uFE0F", "\uD83C\uDF25\uFE0F", "\uD83C\uDF26\uFE0F", "\uD83C\uDF27\uFE0F", "\uD83C\uDF28\uFE0F", "\uD83C\uDF29\uFE0F", "\uD83C\uDF2A\uFE0F", "\uD83C\uDF2B\uFE0F", "\uD83C\uDF2C\uFE0F", "\uD83C\uDF36\uFE0F", "\uD83C\uDF7D\uFE0F", "\uD83C\uDF96\uFE0F", "\uD83C\uDF97\uFE0F", "\uD83C\uDF99\uFE0F", "\uD83C\uDF9A\uFE0F", "\uD83C\uDF9B\uFE0F", "\uD83C\uDF9E\uFE0F", "\uD83C\uDF9F\uFE0F", "\uD83C\uDFCB\uFE0F", "\uD83C\uDFCC\uFE0F", "\uD83C\uDFCD\uFE0F", "\uD83C\uDFCE\uFE0F", "\uD83C\uDFD4\uFE0F", "\uD83C\uDFD5\uFE0F", "\uD83C\uDFD6\uFE0F", "\uD83C\uDFD7\uFE0F", "\uD83C\uDFD8\uFE0F", "\uD83C\uDFD9\uFE0F", "\uD83C\uDFDA\uFE0F", "\uD83C\uDFDB\uFE0F", "\uD83C\uDFDC\uFE0F", "\uD83C\uDFDD\uFE0F", "\uD83C\uDFDE\uFE0F", "\uD83C\uDFDF\uFE0F", "\uD83C\uDFF3\uFE0F", "\uD83C\uDFF5\uFE0F", "\uD83C\uDFF7\uFE0F", "\uD83D\uDC3F\uFE0F", "\uD83D\uDC41\uFE0F", "\uD83D\uDCFD\uFE0F", "\uD83D\uDD49\uFE0F", "\uD83D\uDD4A\uFE0F", "\uD83D\uDD6F\uFE0F", "\uD83D\uDD70\uFE0F", "\uD83D\uDD73\uFE0F", "\uD83D\uDD74\uFE0F", "\uD83D\uDD75\uFE0F", "\uD83D\uDD76\uFE0F", "\uD83D\uDD77\uFE0F", "\uD83D\uDD78\uFE0F", "\uD83D\uDD79\uFE0F", "\uD83D\uDD87\uFE0F", "\uD83D\uDD8A\uFE0F", "\uD83D\uDD8B\uFE0F", "\uD83D\uDD8C\uFE0F", "\uD83D\uDD8D\uFE0F", "\uD83D\uDD90\uFE0F", "\uD83D\uDDA5\uFE0F", "\uD83D\uDDA8\uFE0F", "\uD83D\uDDB1\uFE0F", "\uD83D\uDDB2\uFE0F", "\uD83D\uDDBC\uFE0F", "\uD83D\uDDC2\uFE0F", "\uD83D\uDDC3\uFE0F", "\uD83D\uDDC4\uFE0F", "\uD83D\uDDD1\uFE0F", "\uD83D\uDDD2\uFE0F", "\uD83D\uDDD3\uFE0F", "\uD83D\uDDDC\uFE0F", "\uD83D\uDDDD\uFE0F", "\uD83D\uDDDE\uFE0F", "\uD83D\uDDE1\uFE0F", "\uD83D\uDDE3\uFE0F", "\uD83D\uDDE8\uFE0F", "\uD83D\uDDEF\uFE0F", "\uD83D\uDDF3\uFE0F", "\uD83D\uDDFA\uFE0F", "\uD83D\uDECB\uFE0F", "\uD83D\uDECD\uFE0F", "\uD83D\uDECE\uFE0F", "\uD83D\uDECF\uFE0F", "\uD83D\uDEE0\uFE0F", "\uD83D\uDEE1\uFE0F", "\uD83D\uDEE2\uFE0F", "\uD83D\uDEE3\uFE0F", "\uD83D\uDEE4\uFE0F", "\uD83D\uDEE5\uFE0F", "\uD83D\uDEE9\uFE0F", "\uD83D\uDEF0\uFE0F", "\uD83D\uDEF3\uFE0F"];
		    return Basic_Emoji;
		  }

		  var Emoji_Keycap_Sequence = {};

		  var hasRequiredEmoji_Keycap_Sequence;
		  function requireEmoji_Keycap_Sequence() {
		    if (hasRequiredEmoji_Keycap_Sequence) return Emoji_Keycap_Sequence;
		    hasRequiredEmoji_Keycap_Sequence = 1;
		    var set = regenerateExports();
		    Emoji_Keycap_Sequence.characters = set;
		    Emoji_Keycap_Sequence.strings = ["#\uFE0F\u20E3", "*\uFE0F\u20E3", "0\uFE0F\u20E3", "1\uFE0F\u20E3", "2\uFE0F\u20E3", "3\uFE0F\u20E3", "4\uFE0F\u20E3", "5\uFE0F\u20E3", "6\uFE0F\u20E3", "7\uFE0F\u20E3", "8\uFE0F\u20E3", "9\uFE0F\u20E3"];
		    return Emoji_Keycap_Sequence;
		  }

		  var RGI_Emoji_Flag_Sequence = {};

		  var hasRequiredRGI_Emoji_Flag_Sequence;
		  function requireRGI_Emoji_Flag_Sequence() {
		    if (hasRequiredRGI_Emoji_Flag_Sequence) return RGI_Emoji_Flag_Sequence;
		    hasRequiredRGI_Emoji_Flag_Sequence = 1;
		    var set = regenerateExports();
		    RGI_Emoji_Flag_Sequence.characters = set;
		    RGI_Emoji_Flag_Sequence.strings = ["\uD83C\uDDE6\uD83C\uDDE8", "\uD83C\uDDE6\uD83C\uDDE9", "\uD83C\uDDE6\uD83C\uDDEA", "\uD83C\uDDE6\uD83C\uDDEB", "\uD83C\uDDE6\uD83C\uDDEC", "\uD83C\uDDE6\uD83C\uDDEE", "\uD83C\uDDE6\uD83C\uDDF1", "\uD83C\uDDE6\uD83C\uDDF2", "\uD83C\uDDE6\uD83C\uDDF4", "\uD83C\uDDE6\uD83C\uDDF6", "\uD83C\uDDE6\uD83C\uDDF7", "\uD83C\uDDE6\uD83C\uDDF8", "\uD83C\uDDE6\uD83C\uDDF9", "\uD83C\uDDE6\uD83C\uDDFA", "\uD83C\uDDE6\uD83C\uDDFC", "\uD83C\uDDE6\uD83C\uDDFD", "\uD83C\uDDE6\uD83C\uDDFF", "\uD83C\uDDE7\uD83C\uDDE6", "\uD83C\uDDE7\uD83C\uDDE7", "\uD83C\uDDE7\uD83C\uDDE9", "\uD83C\uDDE7\uD83C\uDDEA", "\uD83C\uDDE7\uD83C\uDDEB", "\uD83C\uDDE7\uD83C\uDDEC", "\uD83C\uDDE7\uD83C\uDDED", "\uD83C\uDDE7\uD83C\uDDEE", "\uD83C\uDDE7\uD83C\uDDEF", "\uD83C\uDDE7\uD83C\uDDF1", "\uD83C\uDDE7\uD83C\uDDF2", "\uD83C\uDDE7\uD83C\uDDF3", "\uD83C\uDDE7\uD83C\uDDF4", "\uD83C\uDDE7\uD83C\uDDF6", "\uD83C\uDDE7\uD83C\uDDF7", "\uD83C\uDDE7\uD83C\uDDF8", "\uD83C\uDDE7\uD83C\uDDF9", "\uD83C\uDDE7\uD83C\uDDFB", "\uD83C\uDDE7\uD83C\uDDFC", "\uD83C\uDDE7\uD83C\uDDFE", "\uD83C\uDDE7\uD83C\uDDFF", "\uD83C\uDDE8\uD83C\uDDE6", "\uD83C\uDDE8\uD83C\uDDE8", "\uD83C\uDDE8\uD83C\uDDE9", "\uD83C\uDDE8\uD83C\uDDEB", "\uD83C\uDDE8\uD83C\uDDEC", "\uD83C\uDDE8\uD83C\uDDED", "\uD83C\uDDE8\uD83C\uDDEE", "\uD83C\uDDE8\uD83C\uDDF0", "\uD83C\uDDE8\uD83C\uDDF1", "\uD83C\uDDE8\uD83C\uDDF2", "\uD83C\uDDE8\uD83C\uDDF3", "\uD83C\uDDE8\uD83C\uDDF4", "\uD83C\uDDE8\uD83C\uDDF5", "\uD83C\uDDE8\uD83C\uDDF7", "\uD83C\uDDE8\uD83C\uDDFA", "\uD83C\uDDE8\uD83C\uDDFB", "\uD83C\uDDE8\uD83C\uDDFC", "\uD83C\uDDE8\uD83C\uDDFD", "\uD83C\uDDE8\uD83C\uDDFE", "\uD83C\uDDE8\uD83C\uDDFF", "\uD83C\uDDE9\uD83C\uDDEA", "\uD83C\uDDE9\uD83C\uDDEC", "\uD83C\uDDE9\uD83C\uDDEF", "\uD83C\uDDE9\uD83C\uDDF0", "\uD83C\uDDE9\uD83C\uDDF2", "\uD83C\uDDE9\uD83C\uDDF4", "\uD83C\uDDE9\uD83C\uDDFF", "\uD83C\uDDEA\uD83C\uDDE6", "\uD83C\uDDEA\uD83C\uDDE8", "\uD83C\uDDEA\uD83C\uDDEA", "\uD83C\uDDEA\uD83C\uDDEC", "\uD83C\uDDEA\uD83C\uDDED", "\uD83C\uDDEA\uD83C\uDDF7", "\uD83C\uDDEA\uD83C\uDDF8", "\uD83C\uDDEA\uD83C\uDDF9", "\uD83C\uDDEA\uD83C\uDDFA", "\uD83C\uDDEB\uD83C\uDDEE", "\uD83C\uDDEB\uD83C\uDDEF", "\uD83C\uDDEB\uD83C\uDDF0", "\uD83C\uDDEB\uD83C\uDDF2", "\uD83C\uDDEB\uD83C\uDDF4", "\uD83C\uDDEB\uD83C\uDDF7", "\uD83C\uDDEC\uD83C\uDDE6", "\uD83C\uDDEC\uD83C\uDDE7", "\uD83C\uDDEC\uD83C\uDDE9", "\uD83C\uDDEC\uD83C\uDDEA", "\uD83C\uDDEC\uD83C\uDDEB", "\uD83C\uDDEC\uD83C\uDDEC", "\uD83C\uDDEC\uD83C\uDDED", "\uD83C\uDDEC\uD83C\uDDEE", "\uD83C\uDDEC\uD83C\uDDF1", "\uD83C\uDDEC\uD83C\uDDF2", "\uD83C\uDDEC\uD83C\uDDF3", "\uD83C\uDDEC\uD83C\uDDF5", "\uD83C\uDDEC\uD83C\uDDF6", "\uD83C\uDDEC\uD83C\uDDF7", "\uD83C\uDDEC\uD83C\uDDF8", "\uD83C\uDDEC\uD83C\uDDF9", "\uD83C\uDDEC\uD83C\uDDFA", "\uD83C\uDDEC\uD83C\uDDFC", "\uD83C\uDDEC\uD83C\uDDFE", "\uD83C\uDDED\uD83C\uDDF0", "\uD83C\uDDED\uD83C\uDDF2", "\uD83C\uDDED\uD83C\uDDF3", "\uD83C\uDDED\uD83C\uDDF7", "\uD83C\uDDED\uD83C\uDDF9", "\uD83C\uDDED\uD83C\uDDFA", "\uD83C\uDDEE\uD83C\uDDE8", "\uD83C\uDDEE\uD83C\uDDE9", "\uD83C\uDDEE\uD83C\uDDEA", "\uD83C\uDDEE\uD83C\uDDF1", "\uD83C\uDDEE\uD83C\uDDF2", "\uD83C\uDDEE\uD83C\uDDF3", "\uD83C\uDDEE\uD83C\uDDF4", "\uD83C\uDDEE\uD83C\uDDF6", "\uD83C\uDDEE\uD83C\uDDF7", "\uD83C\uDDEE\uD83C\uDDF8", "\uD83C\uDDEE\uD83C\uDDF9", "\uD83C\uDDEF\uD83C\uDDEA", "\uD83C\uDDEF\uD83C\uDDF2", "\uD83C\uDDEF\uD83C\uDDF4", "\uD83C\uDDEF\uD83C\uDDF5", "\uD83C\uDDF0\uD83C\uDDEA", "\uD83C\uDDF0\uD83C\uDDEC", "\uD83C\uDDF0\uD83C\uDDED", "\uD83C\uDDF0\uD83C\uDDEE", "\uD83C\uDDF0\uD83C\uDDF2", "\uD83C\uDDF0\uD83C\uDDF3", "\uD83C\uDDF0\uD83C\uDDF5", "\uD83C\uDDF0\uD83C\uDDF7", "\uD83C\uDDF0\uD83C\uDDFC", "\uD83C\uDDF0\uD83C\uDDFE", "\uD83C\uDDF0\uD83C\uDDFF", "\uD83C\uDDF1\uD83C\uDDE6", "\uD83C\uDDF1\uD83C\uDDE7", "\uD83C\uDDF1\uD83C\uDDE8", "\uD83C\uDDF1\uD83C\uDDEE", "\uD83C\uDDF1\uD83C\uDDF0", "\uD83C\uDDF1\uD83C\uDDF7", "\uD83C\uDDF1\uD83C\uDDF8", "\uD83C\uDDF1\uD83C\uDDF9", "\uD83C\uDDF1\uD83C\uDDFA", "\uD83C\uDDF1\uD83C\uDDFB", "\uD83C\uDDF1\uD83C\uDDFE", "\uD83C\uDDF2\uD83C\uDDE6", "\uD83C\uDDF2\uD83C\uDDE8", "\uD83C\uDDF2\uD83C\uDDE9", "\uD83C\uDDF2\uD83C\uDDEA", "\uD83C\uDDF2\uD83C\uDDEB", "\uD83C\uDDF2\uD83C\uDDEC", "\uD83C\uDDF2\uD83C\uDDED", "\uD83C\uDDF2\uD83C\uDDF0", "\uD83C\uDDF2\uD83C\uDDF1", "\uD83C\uDDF2\uD83C\uDDF2", "\uD83C\uDDF2\uD83C\uDDF3", "\uD83C\uDDF2\uD83C\uDDF4", "\uD83C\uDDF2\uD83C\uDDF5", "\uD83C\uDDF2\uD83C\uDDF6", "\uD83C\uDDF2\uD83C\uDDF7", "\uD83C\uDDF2\uD83C\uDDF8", "\uD83C\uDDF2\uD83C\uDDF9", "\uD83C\uDDF2\uD83C\uDDFA", "\uD83C\uDDF2\uD83C\uDDFB", "\uD83C\uDDF2\uD83C\uDDFC", "\uD83C\uDDF2\uD83C\uDDFD", "\uD83C\uDDF2\uD83C\uDDFE", "\uD83C\uDDF2\uD83C\uDDFF", "\uD83C\uDDF3\uD83C\uDDE6", "\uD83C\uDDF3\uD83C\uDDE8", "\uD83C\uDDF3\uD83C\uDDEA", "\uD83C\uDDF3\uD83C\uDDEB", "\uD83C\uDDF3\uD83C\uDDEC", "\uD83C\uDDF3\uD83C\uDDEE", "\uD83C\uDDF3\uD83C\uDDF1", "\uD83C\uDDF3\uD83C\uDDF4", "\uD83C\uDDF3\uD83C\uDDF5", "\uD83C\uDDF3\uD83C\uDDF7", "\uD83C\uDDF3\uD83C\uDDFA", "\uD83C\uDDF3\uD83C\uDDFF", "\uD83C\uDDF4\uD83C\uDDF2", "\uD83C\uDDF5\uD83C\uDDE6", "\uD83C\uDDF5\uD83C\uDDEA", "\uD83C\uDDF5\uD83C\uDDEB", "\uD83C\uDDF5\uD83C\uDDEC", "\uD83C\uDDF5\uD83C\uDDED", "\uD83C\uDDF5\uD83C\uDDF0", "\uD83C\uDDF5\uD83C\uDDF1", "\uD83C\uDDF5\uD83C\uDDF2", "\uD83C\uDDF5\uD83C\uDDF3", "\uD83C\uDDF5\uD83C\uDDF7", "\uD83C\uDDF5\uD83C\uDDF8", "\uD83C\uDDF5\uD83C\uDDF9", "\uD83C\uDDF5\uD83C\uDDFC", "\uD83C\uDDF5\uD83C\uDDFE", "\uD83C\uDDF6\uD83C\uDDE6", "\uD83C\uDDF7\uD83C\uDDEA", "\uD83C\uDDF7\uD83C\uDDF4", "\uD83C\uDDF7\uD83C\uDDF8", "\uD83C\uDDF7\uD83C\uDDFA", "\uD83C\uDDF7\uD83C\uDDFC", "\uD83C\uDDF8\uD83C\uDDE6", "\uD83C\uDDF8\uD83C\uDDE7", "\uD83C\uDDF8\uD83C\uDDE8", "\uD83C\uDDF8\uD83C\uDDE9", "\uD83C\uDDF8\uD83C\uDDEA", "\uD83C\uDDF8\uD83C\uDDEC", "\uD83C\uDDF8\uD83C\uDDED", "\uD83C\uDDF8\uD83C\uDDEE", "\uD83C\uDDF8\uD83C\uDDEF", "\uD83C\uDDF8\uD83C\uDDF0", "\uD83C\uDDF8\uD83C\uDDF1", "\uD83C\uDDF8\uD83C\uDDF2", "\uD83C\uDDF8\uD83C\uDDF3", "\uD83C\uDDF8\uD83C\uDDF4", "\uD83C\uDDF8\uD83C\uDDF7", "\uD83C\uDDF8\uD83C\uDDF8", "\uD83C\uDDF8\uD83C\uDDF9", "\uD83C\uDDF8\uD83C\uDDFB", "\uD83C\uDDF8\uD83C\uDDFD", "\uD83C\uDDF8\uD83C\uDDFE", "\uD83C\uDDF8\uD83C\uDDFF", "\uD83C\uDDF9\uD83C\uDDE6", "\uD83C\uDDF9\uD83C\uDDE8", "\uD83C\uDDF9\uD83C\uDDE9", "\uD83C\uDDF9\uD83C\uDDEB", "\uD83C\uDDF9\uD83C\uDDEC", "\uD83C\uDDF9\uD83C\uDDED", "\uD83C\uDDF9\uD83C\uDDEF", "\uD83C\uDDF9\uD83C\uDDF0", "\uD83C\uDDF9\uD83C\uDDF1", "\uD83C\uDDF9\uD83C\uDDF2", "\uD83C\uDDF9\uD83C\uDDF3", "\uD83C\uDDF9\uD83C\uDDF4", "\uD83C\uDDF9\uD83C\uDDF7", "\uD83C\uDDF9\uD83C\uDDF9", "\uD83C\uDDF9\uD83C\uDDFB", "\uD83C\uDDF9\uD83C\uDDFC", "\uD83C\uDDF9\uD83C\uDDFF", "\uD83C\uDDFA\uD83C\uDDE6", "\uD83C\uDDFA\uD83C\uDDEC", "\uD83C\uDDFA\uD83C\uDDF2", "\uD83C\uDDFA\uD83C\uDDF3", "\uD83C\uDDFA\uD83C\uDDF8", "\uD83C\uDDFA\uD83C\uDDFE", "\uD83C\uDDFA\uD83C\uDDFF", "\uD83C\uDDFB\uD83C\uDDE6", "\uD83C\uDDFB\uD83C\uDDE8", "\uD83C\uDDFB\uD83C\uDDEA", "\uD83C\uDDFB\uD83C\uDDEC", "\uD83C\uDDFB\uD83C\uDDEE", "\uD83C\uDDFB\uD83C\uDDF3", "\uD83C\uDDFB\uD83C\uDDFA", "\uD83C\uDDFC\uD83C\uDDEB", "\uD83C\uDDFC\uD83C\uDDF8", "\uD83C\uDDFD\uD83C\uDDF0", "\uD83C\uDDFE\uD83C\uDDEA", "\uD83C\uDDFE\uD83C\uDDF9", "\uD83C\uDDFF\uD83C\uDDE6", "\uD83C\uDDFF\uD83C\uDDF2", "\uD83C\uDDFF\uD83C\uDDFC"];
		    return RGI_Emoji_Flag_Sequence;
		  }

		  var RGI_Emoji_Modifier_Sequence = {};

		  var hasRequiredRGI_Emoji_Modifier_Sequence;
		  function requireRGI_Emoji_Modifier_Sequence() {
		    if (hasRequiredRGI_Emoji_Modifier_Sequence) return RGI_Emoji_Modifier_Sequence;
		    hasRequiredRGI_Emoji_Modifier_Sequence = 1;
		    var set = regenerateExports();
		    RGI_Emoji_Modifier_Sequence.characters = set;
		    RGI_Emoji_Modifier_Sequence.strings = ["\u261D\uD83C\uDFFB", "\u261D\uD83C\uDFFC", "\u261D\uD83C\uDFFD", "\u261D\uD83C\uDFFE", "\u261D\uD83C\uDFFF", "\u26F9\uD83C\uDFFB", "\u26F9\uD83C\uDFFC", "\u26F9\uD83C\uDFFD", "\u26F9\uD83C\uDFFE", "\u26F9\uD83C\uDFFF", "\u270A\uD83C\uDFFB", "\u270A\uD83C\uDFFC", "\u270A\uD83C\uDFFD", "\u270A\uD83C\uDFFE", "\u270A\uD83C\uDFFF", "\u270B\uD83C\uDFFB", "\u270B\uD83C\uDFFC", "\u270B\uD83C\uDFFD", "\u270B\uD83C\uDFFE", "\u270B\uD83C\uDFFF", "\u270C\uD83C\uDFFB", "\u270C\uD83C\uDFFC", "\u270C\uD83C\uDFFD", "\u270C\uD83C\uDFFE", "\u270C\uD83C\uDFFF", "\u270D\uD83C\uDFFB", "\u270D\uD83C\uDFFC", "\u270D\uD83C\uDFFD", "\u270D\uD83C\uDFFE", "\u270D\uD83C\uDFFF", "\uD83C\uDF85\uD83C\uDFFB", "\uD83C\uDF85\uD83C\uDFFC", "\uD83C\uDF85\uD83C\uDFFD", "\uD83C\uDF85\uD83C\uDFFE", "\uD83C\uDF85\uD83C\uDFFF", "\uD83C\uDFC2\uD83C\uDFFB", "\uD83C\uDFC2\uD83C\uDFFC", "\uD83C\uDFC2\uD83C\uDFFD", "\uD83C\uDFC2\uD83C\uDFFE", "\uD83C\uDFC2\uD83C\uDFFF", "\uD83C\uDFC3\uD83C\uDFFB", "\uD83C\uDFC3\uD83C\uDFFC", "\uD83C\uDFC3\uD83C\uDFFD", "\uD83C\uDFC3\uD83C\uDFFE", "\uD83C\uDFC3\uD83C\uDFFF", "\uD83C\uDFC4\uD83C\uDFFB", "\uD83C\uDFC4\uD83C\uDFFC", "\uD83C\uDFC4\uD83C\uDFFD", "\uD83C\uDFC4\uD83C\uDFFE", "\uD83C\uDFC4\uD83C\uDFFF", "\uD83C\uDFC7\uD83C\uDFFB", "\uD83C\uDFC7\uD83C\uDFFC", "\uD83C\uDFC7\uD83C\uDFFD", "\uD83C\uDFC7\uD83C\uDFFE", "\uD83C\uDFC7\uD83C\uDFFF", "\uD83C\uDFCA\uD83C\uDFFB", "\uD83C\uDFCA\uD83C\uDFFC", "\uD83C\uDFCA\uD83C\uDFFD", "\uD83C\uDFCA\uD83C\uDFFE", "\uD83C\uDFCA\uD83C\uDFFF", "\uD83C\uDFCB\uD83C\uDFFB", "\uD83C\uDFCB\uD83C\uDFFC", "\uD83C\uDFCB\uD83C\uDFFD", "\uD83C\uDFCB\uD83C\uDFFE", "\uD83C\uDFCB\uD83C\uDFFF", "\uD83C\uDFCC\uD83C\uDFFB", "\uD83C\uDFCC\uD83C\uDFFC", "\uD83C\uDFCC\uD83C\uDFFD", "\uD83C\uDFCC\uD83C\uDFFE", "\uD83C\uDFCC\uD83C\uDFFF", "\uD83D\uDC42\uD83C\uDFFB", "\uD83D\uDC42\uD83C\uDFFC", "\uD83D\uDC42\uD83C\uDFFD", "\uD83D\uDC42\uD83C\uDFFE", "\uD83D\uDC42\uD83C\uDFFF", "\uD83D\uDC43\uD83C\uDFFB", "\uD83D\uDC43\uD83C\uDFFC", "\uD83D\uDC43\uD83C\uDFFD", "\uD83D\uDC43\uD83C\uDFFE", "\uD83D\uDC43\uD83C\uDFFF", "\uD83D\uDC46\uD83C\uDFFB", "\uD83D\uDC46\uD83C\uDFFC", "\uD83D\uDC46\uD83C\uDFFD", "\uD83D\uDC46\uD83C\uDFFE", "\uD83D\uDC46\uD83C\uDFFF", "\uD83D\uDC47\uD83C\uDFFB", "\uD83D\uDC47\uD83C\uDFFC", "\uD83D\uDC47\uD83C\uDFFD", "\uD83D\uDC47\uD83C\uDFFE", "\uD83D\uDC47\uD83C\uDFFF", "\uD83D\uDC48\uD83C\uDFFB", "\uD83D\uDC48\uD83C\uDFFC", "\uD83D\uDC48\uD83C\uDFFD", "\uD83D\uDC48\uD83C\uDFFE", "\uD83D\uDC48\uD83C\uDFFF", "\uD83D\uDC49\uD83C\uDFFB", "\uD83D\uDC49\uD83C\uDFFC", "\uD83D\uDC49\uD83C\uDFFD", "\uD83D\uDC49\uD83C\uDFFE", "\uD83D\uDC49\uD83C\uDFFF", "\uD83D\uDC4A\uD83C\uDFFB", "\uD83D\uDC4A\uD83C\uDFFC", "\uD83D\uDC4A\uD83C\uDFFD", "\uD83D\uDC4A\uD83C\uDFFE", "\uD83D\uDC4A\uD83C\uDFFF", "\uD83D\uDC4B\uD83C\uDFFB", "\uD83D\uDC4B\uD83C\uDFFC", "\uD83D\uDC4B\uD83C\uDFFD", "\uD83D\uDC4B\uD83C\uDFFE", "\uD83D\uDC4B\uD83C\uDFFF", "\uD83D\uDC4C\uD83C\uDFFB", "\uD83D\uDC4C\uD83C\uDFFC", "\uD83D\uDC4C\uD83C\uDFFD", "\uD83D\uDC4C\uD83C\uDFFE", "\uD83D\uDC4C\uD83C\uDFFF", "\uD83D\uDC4D\uD83C\uDFFB", "\uD83D\uDC4D\uD83C\uDFFC", "\uD83D\uDC4D\uD83C\uDFFD", "\uD83D\uDC4D\uD83C\uDFFE", "\uD83D\uDC4D\uD83C\uDFFF", "\uD83D\uDC4E\uD83C\uDFFB", "\uD83D\uDC4E\uD83C\uDFFC", "\uD83D\uDC4E\uD83C\uDFFD", "\uD83D\uDC4E\uD83C\uDFFE", "\uD83D\uDC4E\uD83C\uDFFF", "\uD83D\uDC4F\uD83C\uDFFB", "\uD83D\uDC4F\uD83C\uDFFC", "\uD83D\uDC4F\uD83C\uDFFD", "\uD83D\uDC4F\uD83C\uDFFE", "\uD83D\uDC4F\uD83C\uDFFF", "\uD83D\uDC50\uD83C\uDFFB", "\uD83D\uDC50\uD83C\uDFFC", "\uD83D\uDC50\uD83C\uDFFD", "\uD83D\uDC50\uD83C\uDFFE", "\uD83D\uDC50\uD83C\uDFFF", "\uD83D\uDC66\uD83C\uDFFB", "\uD83D\uDC66\uD83C\uDFFC", "\uD83D\uDC66\uD83C\uDFFD", "\uD83D\uDC66\uD83C\uDFFE", "\uD83D\uDC66\uD83C\uDFFF", "\uD83D\uDC67\uD83C\uDFFB", "\uD83D\uDC67\uD83C\uDFFC", "\uD83D\uDC67\uD83C\uDFFD", "\uD83D\uDC67\uD83C\uDFFE", "\uD83D\uDC67\uD83C\uDFFF", "\uD83D\uDC68\uD83C\uDFFB", "\uD83D\uDC68\uD83C\uDFFC", "\uD83D\uDC68\uD83C\uDFFD", "\uD83D\uDC68\uD83C\uDFFE", "\uD83D\uDC68\uD83C\uDFFF", "\uD83D\uDC69\uD83C\uDFFB", "\uD83D\uDC69\uD83C\uDFFC", "\uD83D\uDC69\uD83C\uDFFD", "\uD83D\uDC69\uD83C\uDFFE", "\uD83D\uDC69\uD83C\uDFFF", "\uD83D\uDC6B\uD83C\uDFFB", "\uD83D\uDC6B\uD83C\uDFFC", "\uD83D\uDC6B\uD83C\uDFFD", "\uD83D\uDC6B\uD83C\uDFFE", "\uD83D\uDC6B\uD83C\uDFFF", "\uD83D\uDC6C\uD83C\uDFFB", "\uD83D\uDC6C\uD83C\uDFFC", "\uD83D\uDC6C\uD83C\uDFFD", "\uD83D\uDC6C\uD83C\uDFFE", "\uD83D\uDC6C\uD83C\uDFFF", "\uD83D\uDC6D\uD83C\uDFFB", "\uD83D\uDC6D\uD83C\uDFFC", "\uD83D\uDC6D\uD83C\uDFFD", "\uD83D\uDC6D\uD83C\uDFFE", "\uD83D\uDC6D\uD83C\uDFFF", "\uD83D\uDC6E\uD83C\uDFFB", "\uD83D\uDC6E\uD83C\uDFFC", "\uD83D\uDC6E\uD83C\uDFFD", "\uD83D\uDC6E\uD83C\uDFFE", "\uD83D\uDC6E\uD83C\uDFFF", "\uD83D\uDC70\uD83C\uDFFB", "\uD83D\uDC70\uD83C\uDFFC", "\uD83D\uDC70\uD83C\uDFFD", "\uD83D\uDC70\uD83C\uDFFE", "\uD83D\uDC70\uD83C\uDFFF", "\uD83D\uDC71\uD83C\uDFFB", "\uD83D\uDC71\uD83C\uDFFC", "\uD83D\uDC71\uD83C\uDFFD", "\uD83D\uDC71\uD83C\uDFFE", "\uD83D\uDC71\uD83C\uDFFF", "\uD83D\uDC72\uD83C\uDFFB", "\uD83D\uDC72\uD83C\uDFFC", "\uD83D\uDC72\uD83C\uDFFD", "\uD83D\uDC72\uD83C\uDFFE", "\uD83D\uDC72\uD83C\uDFFF", "\uD83D\uDC73\uD83C\uDFFB", "\uD83D\uDC73\uD83C\uDFFC", "\uD83D\uDC73\uD83C\uDFFD", "\uD83D\uDC73\uD83C\uDFFE", "\uD83D\uDC73\uD83C\uDFFF", "\uD83D\uDC74\uD83C\uDFFB", "\uD83D\uDC74\uD83C\uDFFC", "\uD83D\uDC74\uD83C\uDFFD", "\uD83D\uDC74\uD83C\uDFFE", "\uD83D\uDC74\uD83C\uDFFF", "\uD83D\uDC75\uD83C\uDFFB", "\uD83D\uDC75\uD83C\uDFFC", "\uD83D\uDC75\uD83C\uDFFD", "\uD83D\uDC75\uD83C\uDFFE", "\uD83D\uDC75\uD83C\uDFFF", "\uD83D\uDC76\uD83C\uDFFB", "\uD83D\uDC76\uD83C\uDFFC", "\uD83D\uDC76\uD83C\uDFFD", "\uD83D\uDC76\uD83C\uDFFE", "\uD83D\uDC76\uD83C\uDFFF", "\uD83D\uDC77\uD83C\uDFFB", "\uD83D\uDC77\uD83C\uDFFC", "\uD83D\uDC77\uD83C\uDFFD", "\uD83D\uDC77\uD83C\uDFFE", "\uD83D\uDC77\uD83C\uDFFF", "\uD83D\uDC78\uD83C\uDFFB", "\uD83D\uDC78\uD83C\uDFFC", "\uD83D\uDC78\uD83C\uDFFD", "\uD83D\uDC78\uD83C\uDFFE", "\uD83D\uDC78\uD83C\uDFFF", "\uD83D\uDC7C\uD83C\uDFFB", "\uD83D\uDC7C\uD83C\uDFFC", "\uD83D\uDC7C\uD83C\uDFFD", "\uD83D\uDC7C\uD83C\uDFFE", "\uD83D\uDC7C\uD83C\uDFFF", "\uD83D\uDC81\uD83C\uDFFB", "\uD83D\uDC81\uD83C\uDFFC", "\uD83D\uDC81\uD83C\uDFFD", "\uD83D\uDC81\uD83C\uDFFE", "\uD83D\uDC81\uD83C\uDFFF", "\uD83D\uDC82\uD83C\uDFFB", "\uD83D\uDC82\uD83C\uDFFC", "\uD83D\uDC82\uD83C\uDFFD", "\uD83D\uDC82\uD83C\uDFFE", "\uD83D\uDC82\uD83C\uDFFF", "\uD83D\uDC83\uD83C\uDFFB", "\uD83D\uDC83\uD83C\uDFFC", "\uD83D\uDC83\uD83C\uDFFD", "\uD83D\uDC83\uD83C\uDFFE", "\uD83D\uDC83\uD83C\uDFFF", "\uD83D\uDC85\uD83C\uDFFB", "\uD83D\uDC85\uD83C\uDFFC", "\uD83D\uDC85\uD83C\uDFFD", "\uD83D\uDC85\uD83C\uDFFE", "\uD83D\uDC85\uD83C\uDFFF", "\uD83D\uDC86\uD83C\uDFFB", "\uD83D\uDC86\uD83C\uDFFC", "\uD83D\uDC86\uD83C\uDFFD", "\uD83D\uDC86\uD83C\uDFFE", "\uD83D\uDC86\uD83C\uDFFF", "\uD83D\uDC87\uD83C\uDFFB", "\uD83D\uDC87\uD83C\uDFFC", "\uD83D\uDC87\uD83C\uDFFD", "\uD83D\uDC87\uD83C\uDFFE", "\uD83D\uDC87\uD83C\uDFFF", "\uD83D\uDC8F\uD83C\uDFFB", "\uD83D\uDC8F\uD83C\uDFFC", "\uD83D\uDC8F\uD83C\uDFFD", "\uD83D\uDC8F\uD83C\uDFFE", "\uD83D\uDC8F\uD83C\uDFFF", "\uD83D\uDC91\uD83C\uDFFB", "\uD83D\uDC91\uD83C\uDFFC", "\uD83D\uDC91\uD83C\uDFFD", "\uD83D\uDC91\uD83C\uDFFE", "\uD83D\uDC91\uD83C\uDFFF", "\uD83D\uDCAA\uD83C\uDFFB", "\uD83D\uDCAA\uD83C\uDFFC", "\uD83D\uDCAA\uD83C\uDFFD", "\uD83D\uDCAA\uD83C\uDFFE", "\uD83D\uDCAA\uD83C\uDFFF", "\uD83D\uDD74\uD83C\uDFFB", "\uD83D\uDD74\uD83C\uDFFC", "\uD83D\uDD74\uD83C\uDFFD", "\uD83D\uDD74\uD83C\uDFFE", "\uD83D\uDD74\uD83C\uDFFF", "\uD83D\uDD75\uD83C\uDFFB", "\uD83D\uDD75\uD83C\uDFFC", "\uD83D\uDD75\uD83C\uDFFD", "\uD83D\uDD75\uD83C\uDFFE", "\uD83D\uDD75\uD83C\uDFFF", "\uD83D\uDD7A\uD83C\uDFFB", "\uD83D\uDD7A\uD83C\uDFFC", "\uD83D\uDD7A\uD83C\uDFFD", "\uD83D\uDD7A\uD83C\uDFFE", "\uD83D\uDD7A\uD83C\uDFFF", "\uD83D\uDD90\uD83C\uDFFB", "\uD83D\uDD90\uD83C\uDFFC", "\uD83D\uDD90\uD83C\uDFFD", "\uD83D\uDD90\uD83C\uDFFE", "\uD83D\uDD90\uD83C\uDFFF", "\uD83D\uDD95\uD83C\uDFFB", "\uD83D\uDD95\uD83C\uDFFC", "\uD83D\uDD95\uD83C\uDFFD", "\uD83D\uDD95\uD83C\uDFFE", "\uD83D\uDD95\uD83C\uDFFF", "\uD83D\uDD96\uD83C\uDFFB", "\uD83D\uDD96\uD83C\uDFFC", "\uD83D\uDD96\uD83C\uDFFD", "\uD83D\uDD96\uD83C\uDFFE", "\uD83D\uDD96\uD83C\uDFFF", "\uD83D\uDE45\uD83C\uDFFB", "\uD83D\uDE45\uD83C\uDFFC", "\uD83D\uDE45\uD83C\uDFFD", "\uD83D\uDE45\uD83C\uDFFE", "\uD83D\uDE45\uD83C\uDFFF", "\uD83D\uDE46\uD83C\uDFFB", "\uD83D\uDE46\uD83C\uDFFC", "\uD83D\uDE46\uD83C\uDFFD", "\uD83D\uDE46\uD83C\uDFFE", "\uD83D\uDE46\uD83C\uDFFF", "\uD83D\uDE47\uD83C\uDFFB", "\uD83D\uDE47\uD83C\uDFFC", "\uD83D\uDE47\uD83C\uDFFD", "\uD83D\uDE47\uD83C\uDFFE", "\uD83D\uDE47\uD83C\uDFFF", "\uD83D\uDE4B\uD83C\uDFFB", "\uD83D\uDE4B\uD83C\uDFFC", "\uD83D\uDE4B\uD83C\uDFFD", "\uD83D\uDE4B\uD83C\uDFFE", "\uD83D\uDE4B\uD83C\uDFFF", "\uD83D\uDE4C\uD83C\uDFFB", "\uD83D\uDE4C\uD83C\uDFFC", "\uD83D\uDE4C\uD83C\uDFFD", "\uD83D\uDE4C\uD83C\uDFFE", "\uD83D\uDE4C\uD83C\uDFFF", "\uD83D\uDE4D\uD83C\uDFFB", "\uD83D\uDE4D\uD83C\uDFFC", "\uD83D\uDE4D\uD83C\uDFFD", "\uD83D\uDE4D\uD83C\uDFFE", "\uD83D\uDE4D\uD83C\uDFFF", "\uD83D\uDE4E\uD83C\uDFFB", "\uD83D\uDE4E\uD83C\uDFFC", "\uD83D\uDE4E\uD83C\uDFFD", "\uD83D\uDE4E\uD83C\uDFFE", "\uD83D\uDE4E\uD83C\uDFFF", "\uD83D\uDE4F\uD83C\uDFFB", "\uD83D\uDE4F\uD83C\uDFFC", "\uD83D\uDE4F\uD83C\uDFFD", "\uD83D\uDE4F\uD83C\uDFFE", "\uD83D\uDE4F\uD83C\uDFFF", "\uD83D\uDEA3\uD83C\uDFFB", "\uD83D\uDEA3\uD83C\uDFFC", "\uD83D\uDEA3\uD83C\uDFFD", "\uD83D\uDEA3\uD83C\uDFFE", "\uD83D\uDEA3\uD83C\uDFFF", "\uD83D\uDEB4\uD83C\uDFFB", "\uD83D\uDEB4\uD83C\uDFFC", "\uD83D\uDEB4\uD83C\uDFFD", "\uD83D\uDEB4\uD83C\uDFFE", "\uD83D\uDEB4\uD83C\uDFFF", "\uD83D\uDEB5\uD83C\uDFFB", "\uD83D\uDEB5\uD83C\uDFFC", "\uD83D\uDEB5\uD83C\uDFFD", "\uD83D\uDEB5\uD83C\uDFFE", "\uD83D\uDEB5\uD83C\uDFFF", "\uD83D\uDEB6\uD83C\uDFFB", "\uD83D\uDEB6\uD83C\uDFFC", "\uD83D\uDEB6\uD83C\uDFFD", "\uD83D\uDEB6\uD83C\uDFFE", "\uD83D\uDEB6\uD83C\uDFFF", "\uD83D\uDEC0\uD83C\uDFFB", "\uD83D\uDEC0\uD83C\uDFFC", "\uD83D\uDEC0\uD83C\uDFFD", "\uD83D\uDEC0\uD83C\uDFFE", "\uD83D\uDEC0\uD83C\uDFFF", "\uD83D\uDECC\uD83C\uDFFB", "\uD83D\uDECC\uD83C\uDFFC", "\uD83D\uDECC\uD83C\uDFFD", "\uD83D\uDECC\uD83C\uDFFE", "\uD83D\uDECC\uD83C\uDFFF", "\uD83E\uDD0C\uD83C\uDFFB", "\uD83E\uDD0C\uD83C\uDFFC", "\uD83E\uDD0C\uD83C\uDFFD", "\uD83E\uDD0C\uD83C\uDFFE", "\uD83E\uDD0C\uD83C\uDFFF", "\uD83E\uDD0F\uD83C\uDFFB", "\uD83E\uDD0F\uD83C\uDFFC", "\uD83E\uDD0F\uD83C\uDFFD", "\uD83E\uDD0F\uD83C\uDFFE", "\uD83E\uDD0F\uD83C\uDFFF", "\uD83E\uDD18\uD83C\uDFFB", "\uD83E\uDD18\uD83C\uDFFC", "\uD83E\uDD18\uD83C\uDFFD", "\uD83E\uDD18\uD83C\uDFFE", "\uD83E\uDD18\uD83C\uDFFF", "\uD83E\uDD19\uD83C\uDFFB", "\uD83E\uDD19\uD83C\uDFFC", "\uD83E\uDD19\uD83C\uDFFD", "\uD83E\uDD19\uD83C\uDFFE", "\uD83E\uDD19\uD83C\uDFFF", "\uD83E\uDD1A\uD83C\uDFFB", "\uD83E\uDD1A\uD83C\uDFFC", "\uD83E\uDD1A\uD83C\uDFFD", "\uD83E\uDD1A\uD83C\uDFFE", "\uD83E\uDD1A\uD83C\uDFFF", "\uD83E\uDD1B\uD83C\uDFFB", "\uD83E\uDD1B\uD83C\uDFFC", "\uD83E\uDD1B\uD83C\uDFFD", "\uD83E\uDD1B\uD83C\uDFFE", "\uD83E\uDD1B\uD83C\uDFFF", "\uD83E\uDD1C\uD83C\uDFFB", "\uD83E\uDD1C\uD83C\uDFFC", "\uD83E\uDD1C\uD83C\uDFFD", "\uD83E\uDD1C\uD83C\uDFFE", "\uD83E\uDD1C\uD83C\uDFFF", "\uD83E\uDD1D\uD83C\uDFFB", "\uD83E\uDD1D\uD83C\uDFFC", "\uD83E\uDD1D\uD83C\uDFFD", "\uD83E\uDD1D\uD83C\uDFFE", "\uD83E\uDD1D\uD83C\uDFFF", "\uD83E\uDD1E\uD83C\uDFFB", "\uD83E\uDD1E\uD83C\uDFFC", "\uD83E\uDD1E\uD83C\uDFFD", "\uD83E\uDD1E\uD83C\uDFFE", "\uD83E\uDD1E\uD83C\uDFFF", "\uD83E\uDD1F\uD83C\uDFFB", "\uD83E\uDD1F\uD83C\uDFFC", "\uD83E\uDD1F\uD83C\uDFFD", "\uD83E\uDD1F\uD83C\uDFFE", "\uD83E\uDD1F\uD83C\uDFFF", "\uD83E\uDD26\uD83C\uDFFB", "\uD83E\uDD26\uD83C\uDFFC", "\uD83E\uDD26\uD83C\uDFFD", "\uD83E\uDD26\uD83C\uDFFE", "\uD83E\uDD26\uD83C\uDFFF", "\uD83E\uDD30\uD83C\uDFFB", "\uD83E\uDD30\uD83C\uDFFC", "\uD83E\uDD30\uD83C\uDFFD", "\uD83E\uDD30\uD83C\uDFFE", "\uD83E\uDD30\uD83C\uDFFF", "\uD83E\uDD31\uD83C\uDFFB", "\uD83E\uDD31\uD83C\uDFFC", "\uD83E\uDD31\uD83C\uDFFD", "\uD83E\uDD31\uD83C\uDFFE", "\uD83E\uDD31\uD83C\uDFFF", "\uD83E\uDD32\uD83C\uDFFB", "\uD83E\uDD32\uD83C\uDFFC", "\uD83E\uDD32\uD83C\uDFFD", "\uD83E\uDD32\uD83C\uDFFE", "\uD83E\uDD32\uD83C\uDFFF", "\uD83E\uDD33\uD83C\uDFFB", "\uD83E\uDD33\uD83C\uDFFC", "\uD83E\uDD33\uD83C\uDFFD", "\uD83E\uDD33\uD83C\uDFFE", "\uD83E\uDD33\uD83C\uDFFF", "\uD83E\uDD34\uD83C\uDFFB", "\uD83E\uDD34\uD83C\uDFFC", "\uD83E\uDD34\uD83C\uDFFD", "\uD83E\uDD34\uD83C\uDFFE", "\uD83E\uDD34\uD83C\uDFFF", "\uD83E\uDD35\uD83C\uDFFB", "\uD83E\uDD35\uD83C\uDFFC", "\uD83E\uDD35\uD83C\uDFFD", "\uD83E\uDD35\uD83C\uDFFE", "\uD83E\uDD35\uD83C\uDFFF", "\uD83E\uDD36\uD83C\uDFFB", "\uD83E\uDD36\uD83C\uDFFC", "\uD83E\uDD36\uD83C\uDFFD", "\uD83E\uDD36\uD83C\uDFFE", "\uD83E\uDD36\uD83C\uDFFF", "\uD83E\uDD37\uD83C\uDFFB", "\uD83E\uDD37\uD83C\uDFFC", "\uD83E\uDD37\uD83C\uDFFD", "\uD83E\uDD37\uD83C\uDFFE", "\uD83E\uDD37\uD83C\uDFFF", "\uD83E\uDD38\uD83C\uDFFB", "\uD83E\uDD38\uD83C\uDFFC", "\uD83E\uDD38\uD83C\uDFFD", "\uD83E\uDD38\uD83C\uDFFE", "\uD83E\uDD38\uD83C\uDFFF", "\uD83E\uDD39\uD83C\uDFFB", "\uD83E\uDD39\uD83C\uDFFC", "\uD83E\uDD39\uD83C\uDFFD", "\uD83E\uDD39\uD83C\uDFFE", "\uD83E\uDD39\uD83C\uDFFF", "\uD83E\uDD3D\uD83C\uDFFB", "\uD83E\uDD3D\uD83C\uDFFC", "\uD83E\uDD3D\uD83C\uDFFD", "\uD83E\uDD3D\uD83C\uDFFE", "\uD83E\uDD3D\uD83C\uDFFF", "\uD83E\uDD3E\uD83C\uDFFB", "\uD83E\uDD3E\uD83C\uDFFC", "\uD83E\uDD3E\uD83C\uDFFD", "\uD83E\uDD3E\uD83C\uDFFE", "\uD83E\uDD3E\uD83C\uDFFF", "\uD83E\uDD77\uD83C\uDFFB", "\uD83E\uDD77\uD83C\uDFFC", "\uD83E\uDD77\uD83C\uDFFD", "\uD83E\uDD77\uD83C\uDFFE", "\uD83E\uDD77\uD83C\uDFFF", "\uD83E\uDDB5\uD83C\uDFFB", "\uD83E\uDDB5\uD83C\uDFFC", "\uD83E\uDDB5\uD83C\uDFFD", "\uD83E\uDDB5\uD83C\uDFFE", "\uD83E\uDDB5\uD83C\uDFFF", "\uD83E\uDDB6\uD83C\uDFFB", "\uD83E\uDDB6\uD83C\uDFFC", "\uD83E\uDDB6\uD83C\uDFFD", "\uD83E\uDDB6\uD83C\uDFFE", "\uD83E\uDDB6\uD83C\uDFFF", "\uD83E\uDDB8\uD83C\uDFFB", "\uD83E\uDDB8\uD83C\uDFFC", "\uD83E\uDDB8\uD83C\uDFFD", "\uD83E\uDDB8\uD83C\uDFFE", "\uD83E\uDDB8\uD83C\uDFFF", "\uD83E\uDDB9\uD83C\uDFFB", "\uD83E\uDDB9\uD83C\uDFFC", "\uD83E\uDDB9\uD83C\uDFFD", "\uD83E\uDDB9\uD83C\uDFFE", "\uD83E\uDDB9\uD83C\uDFFF", "\uD83E\uDDBB\uD83C\uDFFB", "\uD83E\uDDBB\uD83C\uDFFC", "\uD83E\uDDBB\uD83C\uDFFD", "\uD83E\uDDBB\uD83C\uDFFE", "\uD83E\uDDBB\uD83C\uDFFF", "\uD83E\uDDCD\uD83C\uDFFB", "\uD83E\uDDCD\uD83C\uDFFC", "\uD83E\uDDCD\uD83C\uDFFD", "\uD83E\uDDCD\uD83C\uDFFE", "\uD83E\uDDCD\uD83C\uDFFF", "\uD83E\uDDCE\uD83C\uDFFB", "\uD83E\uDDCE\uD83C\uDFFC", "\uD83E\uDDCE\uD83C\uDFFD", "\uD83E\uDDCE\uD83C\uDFFE", "\uD83E\uDDCE\uD83C\uDFFF", "\uD83E\uDDCF\uD83C\uDFFB", "\uD83E\uDDCF\uD83C\uDFFC", "\uD83E\uDDCF\uD83C\uDFFD", "\uD83E\uDDCF\uD83C\uDFFE", "\uD83E\uDDCF\uD83C\uDFFF", "\uD83E\uDDD1\uD83C\uDFFB", "\uD83E\uDDD1\uD83C\uDFFC", "\uD83E\uDDD1\uD83C\uDFFD", "\uD83E\uDDD1\uD83C\uDFFE", "\uD83E\uDDD1\uD83C\uDFFF", "\uD83E\uDDD2\uD83C\uDFFB", "\uD83E\uDDD2\uD83C\uDFFC", "\uD83E\uDDD2\uD83C\uDFFD", "\uD83E\uDDD2\uD83C\uDFFE", "\uD83E\uDDD2\uD83C\uDFFF", "\uD83E\uDDD3\uD83C\uDFFB", "\uD83E\uDDD3\uD83C\uDFFC", "\uD83E\uDDD3\uD83C\uDFFD", "\uD83E\uDDD3\uD83C\uDFFE", "\uD83E\uDDD3\uD83C\uDFFF", "\uD83E\uDDD4\uD83C\uDFFB", "\uD83E\uDDD4\uD83C\uDFFC", "\uD83E\uDDD4\uD83C\uDFFD", "\uD83E\uDDD4\uD83C\uDFFE", "\uD83E\uDDD4\uD83C\uDFFF", "\uD83E\uDDD5\uD83C\uDFFB", "\uD83E\uDDD5\uD83C\uDFFC", "\uD83E\uDDD5\uD83C\uDFFD", "\uD83E\uDDD5\uD83C\uDFFE", "\uD83E\uDDD5\uD83C\uDFFF", "\uD83E\uDDD6\uD83C\uDFFB", "\uD83E\uDDD6\uD83C\uDFFC", "\uD83E\uDDD6\uD83C\uDFFD", "\uD83E\uDDD6\uD83C\uDFFE", "\uD83E\uDDD6\uD83C\uDFFF", "\uD83E\uDDD7\uD83C\uDFFB", "\uD83E\uDDD7\uD83C\uDFFC", "\uD83E\uDDD7\uD83C\uDFFD", "\uD83E\uDDD7\uD83C\uDFFE", "\uD83E\uDDD7\uD83C\uDFFF", "\uD83E\uDDD8\uD83C\uDFFB", "\uD83E\uDDD8\uD83C\uDFFC", "\uD83E\uDDD8\uD83C\uDFFD", "\uD83E\uDDD8\uD83C\uDFFE", "\uD83E\uDDD8\uD83C\uDFFF", "\uD83E\uDDD9\uD83C\uDFFB", "\uD83E\uDDD9\uD83C\uDFFC", "\uD83E\uDDD9\uD83C\uDFFD", "\uD83E\uDDD9\uD83C\uDFFE", "\uD83E\uDDD9\uD83C\uDFFF", "\uD83E\uDDDA\uD83C\uDFFB", "\uD83E\uDDDA\uD83C\uDFFC", "\uD83E\uDDDA\uD83C\uDFFD", "\uD83E\uDDDA\uD83C\uDFFE", "\uD83E\uDDDA\uD83C\uDFFF", "\uD83E\uDDDB\uD83C\uDFFB", "\uD83E\uDDDB\uD83C\uDFFC", "\uD83E\uDDDB\uD83C\uDFFD", "\uD83E\uDDDB\uD83C\uDFFE", "\uD83E\uDDDB\uD83C\uDFFF", "\uD83E\uDDDC\uD83C\uDFFB", "\uD83E\uDDDC\uD83C\uDFFC", "\uD83E\uDDDC\uD83C\uDFFD", "\uD83E\uDDDC\uD83C\uDFFE", "\uD83E\uDDDC\uD83C\uDFFF", "\uD83E\uDDDD\uD83C\uDFFB", "\uD83E\uDDDD\uD83C\uDFFC", "\uD83E\uDDDD\uD83C\uDFFD", "\uD83E\uDDDD\uD83C\uDFFE", "\uD83E\uDDDD\uD83C\uDFFF", "\uD83E\uDEC3\uD83C\uDFFB", "\uD83E\uDEC3\uD83C\uDFFC", "\uD83E\uDEC3\uD83C\uDFFD", "\uD83E\uDEC3\uD83C\uDFFE", "\uD83E\uDEC3\uD83C\uDFFF", "\uD83E\uDEC4\uD83C\uDFFB", "\uD83E\uDEC4\uD83C\uDFFC", "\uD83E\uDEC4\uD83C\uDFFD", "\uD83E\uDEC4\uD83C\uDFFE", "\uD83E\uDEC4\uD83C\uDFFF", "\uD83E\uDEC5\uD83C\uDFFB", "\uD83E\uDEC5\uD83C\uDFFC", "\uD83E\uDEC5\uD83C\uDFFD", "\uD83E\uDEC5\uD83C\uDFFE", "\uD83E\uDEC5\uD83C\uDFFF", "\uD83E\uDEF0\uD83C\uDFFB", "\uD83E\uDEF0\uD83C\uDFFC", "\uD83E\uDEF0\uD83C\uDFFD", "\uD83E\uDEF0\uD83C\uDFFE", "\uD83E\uDEF0\uD83C\uDFFF", "\uD83E\uDEF1\uD83C\uDFFB", "\uD83E\uDEF1\uD83C\uDFFC", "\uD83E\uDEF1\uD83C\uDFFD", "\uD83E\uDEF1\uD83C\uDFFE", "\uD83E\uDEF1\uD83C\uDFFF", "\uD83E\uDEF2\uD83C\uDFFB", "\uD83E\uDEF2\uD83C\uDFFC", "\uD83E\uDEF2\uD83C\uDFFD", "\uD83E\uDEF2\uD83C\uDFFE", "\uD83E\uDEF2\uD83C\uDFFF", "\uD83E\uDEF3\uD83C\uDFFB", "\uD83E\uDEF3\uD83C\uDFFC", "\uD83E\uDEF3\uD83C\uDFFD", "\uD83E\uDEF3\uD83C\uDFFE", "\uD83E\uDEF3\uD83C\uDFFF", "\uD83E\uDEF4\uD83C\uDFFB", "\uD83E\uDEF4\uD83C\uDFFC", "\uD83E\uDEF4\uD83C\uDFFD", "\uD83E\uDEF4\uD83C\uDFFE", "\uD83E\uDEF4\uD83C\uDFFF", "\uD83E\uDEF5\uD83C\uDFFB", "\uD83E\uDEF5\uD83C\uDFFC", "\uD83E\uDEF5\uD83C\uDFFD", "\uD83E\uDEF5\uD83C\uDFFE", "\uD83E\uDEF5\uD83C\uDFFF", "\uD83E\uDEF6\uD83C\uDFFB", "\uD83E\uDEF6\uD83C\uDFFC", "\uD83E\uDEF6\uD83C\uDFFD", "\uD83E\uDEF6\uD83C\uDFFE", "\uD83E\uDEF6\uD83C\uDFFF", "\uD83E\uDEF7\uD83C\uDFFB", "\uD83E\uDEF7\uD83C\uDFFC", "\uD83E\uDEF7\uD83C\uDFFD", "\uD83E\uDEF7\uD83C\uDFFE", "\uD83E\uDEF7\uD83C\uDFFF", "\uD83E\uDEF8\uD83C\uDFFB", "\uD83E\uDEF8\uD83C\uDFFC", "\uD83E\uDEF8\uD83C\uDFFD", "\uD83E\uDEF8\uD83C\uDFFE", "\uD83E\uDEF8\uD83C\uDFFF"];
		    return RGI_Emoji_Modifier_Sequence;
		  }

		  var RGI_Emoji_Tag_Sequence = {};

		  var hasRequiredRGI_Emoji_Tag_Sequence;
		  function requireRGI_Emoji_Tag_Sequence() {
		    if (hasRequiredRGI_Emoji_Tag_Sequence) return RGI_Emoji_Tag_Sequence;
		    hasRequiredRGI_Emoji_Tag_Sequence = 1;
		    var set = regenerateExports();
		    RGI_Emoji_Tag_Sequence.characters = set;
		    RGI_Emoji_Tag_Sequence.strings = ["\uD83C\uDFF4\uDB40\uDC67\uDB40\uDC62\uDB40\uDC65\uDB40\uDC6E\uDB40\uDC67\uDB40\uDC7F", "\uD83C\uDFF4\uDB40\uDC67\uDB40\uDC62\uDB40\uDC73\uDB40\uDC63\uDB40\uDC74\uDB40\uDC7F", "\uD83C\uDFF4\uDB40\uDC67\uDB40\uDC62\uDB40\uDC77\uDB40\uDC6C\uDB40\uDC73\uDB40\uDC7F"];
		    return RGI_Emoji_Tag_Sequence;
		  }

		  var RGI_Emoji_ZWJ_Sequence = {};

		  var hasRequiredRGI_Emoji_ZWJ_Sequence;
		  function requireRGI_Emoji_ZWJ_Sequence() {
		    if (hasRequiredRGI_Emoji_ZWJ_Sequence) return RGI_Emoji_ZWJ_Sequence;
		    hasRequiredRGI_Emoji_ZWJ_Sequence = 1;
		    var set = regenerateExports();
		    RGI_Emoji_ZWJ_Sequence.characters = set;
		    RGI_Emoji_ZWJ_Sequence.strings = ["\uD83D\uDC68\u200D\u2764\uFE0F\u200D\uD83D\uDC68", "\uD83D\uDC68\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68", "\uD83D\uDC68\u200D\uD83D\uDC66", "\uD83D\uDC68\u200D\uD83D\uDC66\u200D\uD83D\uDC66", "\uD83D\uDC68\u200D\uD83D\uDC67", "\uD83D\uDC68\u200D\uD83D\uDC67\u200D\uD83D\uDC66", "\uD83D\uDC68\u200D\uD83D\uDC67\u200D\uD83D\uDC67", "\uD83D\uDC68\u200D\uD83D\uDC68\u200D\uD83D\uDC66", "\uD83D\uDC68\u200D\uD83D\uDC68\u200D\uD83D\uDC66\u200D\uD83D\uDC66", "\uD83D\uDC68\u200D\uD83D\uDC68\u200D\uD83D\uDC67", "\uD83D\uDC68\u200D\uD83D\uDC68\u200D\uD83D\uDC67\u200D\uD83D\uDC66", "\uD83D\uDC68\u200D\uD83D\uDC68\u200D\uD83D\uDC67\u200D\uD83D\uDC67", "\uD83D\uDC68\u200D\uD83D\uDC69\u200D\uD83D\uDC66", "\uD83D\uDC68\u200D\uD83D\uDC69\u200D\uD83D\uDC66\u200D\uD83D\uDC66", "\uD83D\uDC68\u200D\uD83D\uDC69\u200D\uD83D\uDC67", "\uD83D\uDC68\u200D\uD83D\uDC69\u200D\uD83D\uDC67\u200D\uD83D\uDC66", "\uD83D\uDC68\u200D\uD83D\uDC69\u200D\uD83D\uDC67\u200D\uD83D\uDC67", "\uD83D\uDC68\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFB", "\uD83D\uDC68\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFC", "\uD83D\uDC68\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFD", "\uD83D\uDC68\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFE", "\uD83D\uDC68\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFF", "\uD83D\uDC68\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFB", "\uD83D\uDC68\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFC", "\uD83D\uDC68\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFD", "\uD83D\uDC68\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFE", "\uD83D\uDC68\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFF", "\uD83D\uDC68\uD83C\uDFFB\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFC", "\uD83D\uDC68\uD83C\uDFFB\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFD", "\uD83D\uDC68\uD83C\uDFFB\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFE", "\uD83D\uDC68\uD83C\uDFFB\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFF", "\uD83D\uDC68\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFB", "\uD83D\uDC68\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFC", "\uD83D\uDC68\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFD", "\uD83D\uDC68\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFE", "\uD83D\uDC68\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFF", "\uD83D\uDC68\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFB", "\uD83D\uDC68\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFC", "\uD83D\uDC68\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFD", "\uD83D\uDC68\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFE", "\uD83D\uDC68\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFF", "\uD83D\uDC68\uD83C\uDFFC\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFB", "\uD83D\uDC68\uD83C\uDFFC\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFD", "\uD83D\uDC68\uD83C\uDFFC\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFE", "\uD83D\uDC68\uD83C\uDFFC\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFF", "\uD83D\uDC68\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFB", "\uD83D\uDC68\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFC", "\uD83D\uDC68\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFD", "\uD83D\uDC68\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFE", "\uD83D\uDC68\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFF", "\uD83D\uDC68\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFB", "\uD83D\uDC68\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFC", "\uD83D\uDC68\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFD", "\uD83D\uDC68\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFE", "\uD83D\uDC68\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFF", "\uD83D\uDC68\uD83C\uDFFD\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFB", "\uD83D\uDC68\uD83C\uDFFD\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFC", "\uD83D\uDC68\uD83C\uDFFD\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFE", "\uD83D\uDC68\uD83C\uDFFD\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFF", "\uD83D\uDC68\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFB", "\uD83D\uDC68\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFC", "\uD83D\uDC68\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFD", "\uD83D\uDC68\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFE", "\uD83D\uDC68\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFF", "\uD83D\uDC68\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFB", "\uD83D\uDC68\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFC", "\uD83D\uDC68\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFD", "\uD83D\uDC68\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFE", "\uD83D\uDC68\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFF", "\uD83D\uDC68\uD83C\uDFFE\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFB", "\uD83D\uDC68\uD83C\uDFFE\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFC", "\uD83D\uDC68\uD83C\uDFFE\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFD", "\uD83D\uDC68\uD83C\uDFFE\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFF", "\uD83D\uDC68\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFB", "\uD83D\uDC68\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFC", "\uD83D\uDC68\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFD", "\uD83D\uDC68\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFE", "\uD83D\uDC68\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFF", "\uD83D\uDC68\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFB", "\uD83D\uDC68\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFC", "\uD83D\uDC68\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFD", "\uD83D\uDC68\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFE", "\uD83D\uDC68\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFF", "\uD83D\uDC68\uD83C\uDFFF\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFB", "\uD83D\uDC68\uD83C\uDFFF\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFC", "\uD83D\uDC68\uD83C\uDFFF\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFD", "\uD83D\uDC68\uD83C\uDFFF\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFE", "\uD83D\uDC69\u200D\u2764\uFE0F\u200D\uD83D\uDC68", "\uD83D\uDC69\u200D\u2764\uFE0F\u200D\uD83D\uDC69", "\uD83D\uDC69\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68", "\uD83D\uDC69\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC69", "\uD83D\uDC69\u200D\uD83D\uDC66", "\uD83D\uDC69\u200D\uD83D\uDC66\u200D\uD83D\uDC66", "\uD83D\uDC69\u200D\uD83D\uDC67", "\uD83D\uDC69\u200D\uD83D\uDC67\u200D\uD83D\uDC66", "\uD83D\uDC69\u200D\uD83D\uDC67\u200D\uD83D\uDC67", "\uD83D\uDC69\u200D\uD83D\uDC69\u200D\uD83D\uDC66", "\uD83D\uDC69\u200D\uD83D\uDC69\u200D\uD83D\uDC66\u200D\uD83D\uDC66", "\uD83D\uDC69\u200D\uD83D\uDC69\u200D\uD83D\uDC67", "\uD83D\uDC69\u200D\uD83D\uDC69\u200D\uD83D\uDC67\u200D\uD83D\uDC66", "\uD83D\uDC69\u200D\uD83D\uDC69\u200D\uD83D\uDC67\u200D\uD83D\uDC67", "\uD83D\uDC69\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFB", "\uD83D\uDC69\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFC", "\uD83D\uDC69\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFD", "\uD83D\uDC69\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFE", "\uD83D\uDC69\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFF", "\uD83D\uDC69\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC69\uD83C\uDFFB", "\uD83D\uDC69\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC69\uD83C\uDFFC", "\uD83D\uDC69\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC69\uD83C\uDFFD", "\uD83D\uDC69\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC69\uD83C\uDFFE", "\uD83D\uDC69\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC69\uD83C\uDFFF", "\uD83D\uDC69\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFB", "\uD83D\uDC69\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFC", "\uD83D\uDC69\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFD", "\uD83D\uDC69\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFE", "\uD83D\uDC69\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFF", "\uD83D\uDC69\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC69\uD83C\uDFFB", "\uD83D\uDC69\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC69\uD83C\uDFFC", "\uD83D\uDC69\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC69\uD83C\uDFFD", "\uD83D\uDC69\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC69\uD83C\uDFFE", "\uD83D\uDC69\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC69\uD83C\uDFFF", "\uD83D\uDC69\uD83C\uDFFB\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFC", "\uD83D\uDC69\uD83C\uDFFB\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFD", "\uD83D\uDC69\uD83C\uDFFB\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFE", "\uD83D\uDC69\uD83C\uDFFB\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFF", "\uD83D\uDC69\uD83C\uDFFB\u200D\uD83E\uDD1D\u200D\uD83D\uDC69\uD83C\uDFFC", "\uD83D\uDC69\uD83C\uDFFB\u200D\uD83E\uDD1D\u200D\uD83D\uDC69\uD83C\uDFFD", "\uD83D\uDC69\uD83C\uDFFB\u200D\uD83E\uDD1D\u200D\uD83D\uDC69\uD83C\uDFFE", "\uD83D\uDC69\uD83C\uDFFB\u200D\uD83E\uDD1D\u200D\uD83D\uDC69\uD83C\uDFFF", "\uD83D\uDC69\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFB", "\uD83D\uDC69\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFC", "\uD83D\uDC69\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFD", "\uD83D\uDC69\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFE", "\uD83D\uDC69\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFF", "\uD83D\uDC69\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC69\uD83C\uDFFB", "\uD83D\uDC69\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC69\uD83C\uDFFC", "\uD83D\uDC69\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC69\uD83C\uDFFD", "\uD83D\uDC69\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC69\uD83C\uDFFE", "\uD83D\uDC69\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC69\uD83C\uDFFF", "\uD83D\uDC69\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFB", "\uD83D\uDC69\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFC", "\uD83D\uDC69\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFD", "\uD83D\uDC69\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFE", "\uD83D\uDC69\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFF", "\uD83D\uDC69\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC69\uD83C\uDFFB", "\uD83D\uDC69\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC69\uD83C\uDFFC", "\uD83D\uDC69\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC69\uD83C\uDFFD", "\uD83D\uDC69\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC69\uD83C\uDFFE", "\uD83D\uDC69\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC69\uD83C\uDFFF", "\uD83D\uDC69\uD83C\uDFFC\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFB", "\uD83D\uDC69\uD83C\uDFFC\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFD", "\uD83D\uDC69\uD83C\uDFFC\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFE", "\uD83D\uDC69\uD83C\uDFFC\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFF", "\uD83D\uDC69\uD83C\uDFFC\u200D\uD83E\uDD1D\u200D\uD83D\uDC69\uD83C\uDFFB", "\uD83D\uDC69\uD83C\uDFFC\u200D\uD83E\uDD1D\u200D\uD83D\uDC69\uD83C\uDFFD", "\uD83D\uDC69\uD83C\uDFFC\u200D\uD83E\uDD1D\u200D\uD83D\uDC69\uD83C\uDFFE", "\uD83D\uDC69\uD83C\uDFFC\u200D\uD83E\uDD1D\u200D\uD83D\uDC69\uD83C\uDFFF", "\uD83D\uDC69\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFB", "\uD83D\uDC69\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFC", "\uD83D\uDC69\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFD", "\uD83D\uDC69\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFE", "\uD83D\uDC69\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFF", "\uD83D\uDC69\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC69\uD83C\uDFFB", "\uD83D\uDC69\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC69\uD83C\uDFFC", "\uD83D\uDC69\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC69\uD83C\uDFFD", "\uD83D\uDC69\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC69\uD83C\uDFFE", "\uD83D\uDC69\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC69\uD83C\uDFFF", "\uD83D\uDC69\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFB", "\uD83D\uDC69\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFC", "\uD83D\uDC69\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFD", "\uD83D\uDC69\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFE", "\uD83D\uDC69\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFF", "\uD83D\uDC69\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC69\uD83C\uDFFB", "\uD83D\uDC69\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC69\uD83C\uDFFC", "\uD83D\uDC69\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC69\uD83C\uDFFD", "\uD83D\uDC69\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC69\uD83C\uDFFE", "\uD83D\uDC69\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC69\uD83C\uDFFF", "\uD83D\uDC69\uD83C\uDFFD\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFB", "\uD83D\uDC69\uD83C\uDFFD\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFC", "\uD83D\uDC69\uD83C\uDFFD\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFE", "\uD83D\uDC69\uD83C\uDFFD\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFF", "\uD83D\uDC69\uD83C\uDFFD\u200D\uD83E\uDD1D\u200D\uD83D\uDC69\uD83C\uDFFB", "\uD83D\uDC69\uD83C\uDFFD\u200D\uD83E\uDD1D\u200D\uD83D\uDC69\uD83C\uDFFC", "\uD83D\uDC69\uD83C\uDFFD\u200D\uD83E\uDD1D\u200D\uD83D\uDC69\uD83C\uDFFE", "\uD83D\uDC69\uD83C\uDFFD\u200D\uD83E\uDD1D\u200D\uD83D\uDC69\uD83C\uDFFF", "\uD83D\uDC69\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFB", "\uD83D\uDC69\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFC", "\uD83D\uDC69\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFD", "\uD83D\uDC69\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFE", "\uD83D\uDC69\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFF", "\uD83D\uDC69\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC69\uD83C\uDFFB", "\uD83D\uDC69\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC69\uD83C\uDFFC", "\uD83D\uDC69\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC69\uD83C\uDFFD", "\uD83D\uDC69\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC69\uD83C\uDFFE", "\uD83D\uDC69\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC69\uD83C\uDFFF", "\uD83D\uDC69\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFB", "\uD83D\uDC69\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFC", "\uD83D\uDC69\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFD", "\uD83D\uDC69\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFE", "\uD83D\uDC69\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFF", "\uD83D\uDC69\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC69\uD83C\uDFFB", "\uD83D\uDC69\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC69\uD83C\uDFFC", "\uD83D\uDC69\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC69\uD83C\uDFFD", "\uD83D\uDC69\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC69\uD83C\uDFFE", "\uD83D\uDC69\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC69\uD83C\uDFFF", "\uD83D\uDC69\uD83C\uDFFE\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFB", "\uD83D\uDC69\uD83C\uDFFE\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFC", "\uD83D\uDC69\uD83C\uDFFE\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFD", "\uD83D\uDC69\uD83C\uDFFE\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFF", "\uD83D\uDC69\uD83C\uDFFE\u200D\uD83E\uDD1D\u200D\uD83D\uDC69\uD83C\uDFFB", "\uD83D\uDC69\uD83C\uDFFE\u200D\uD83E\uDD1D\u200D\uD83D\uDC69\uD83C\uDFFC", "\uD83D\uDC69\uD83C\uDFFE\u200D\uD83E\uDD1D\u200D\uD83D\uDC69\uD83C\uDFFD", "\uD83D\uDC69\uD83C\uDFFE\u200D\uD83E\uDD1D\u200D\uD83D\uDC69\uD83C\uDFFF", "\uD83D\uDC69\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFB", "\uD83D\uDC69\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFC", "\uD83D\uDC69\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFD", "\uD83D\uDC69\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFE", "\uD83D\uDC69\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFF", "\uD83D\uDC69\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC69\uD83C\uDFFB", "\uD83D\uDC69\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC69\uD83C\uDFFC", "\uD83D\uDC69\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC69\uD83C\uDFFD", "\uD83D\uDC69\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC69\uD83C\uDFFE", "\uD83D\uDC69\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC69\uD83C\uDFFF", "\uD83D\uDC69\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFB", "\uD83D\uDC69\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFC", "\uD83D\uDC69\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFD", "\uD83D\uDC69\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFE", "\uD83D\uDC69\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFF", "\uD83D\uDC69\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC69\uD83C\uDFFB", "\uD83D\uDC69\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC69\uD83C\uDFFC", "\uD83D\uDC69\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC69\uD83C\uDFFD", "\uD83D\uDC69\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC69\uD83C\uDFFE", "\uD83D\uDC69\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC69\uD83C\uDFFF", "\uD83D\uDC69\uD83C\uDFFF\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFB", "\uD83D\uDC69\uD83C\uDFFF\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFC", "\uD83D\uDC69\uD83C\uDFFF\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFD", "\uD83D\uDC69\uD83C\uDFFF\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFE", "\uD83D\uDC69\uD83C\uDFFF\u200D\uD83E\uDD1D\u200D\uD83D\uDC69\uD83C\uDFFB", "\uD83D\uDC69\uD83C\uDFFF\u200D\uD83E\uDD1D\u200D\uD83D\uDC69\uD83C\uDFFC", "\uD83D\uDC69\uD83C\uDFFF\u200D\uD83E\uDD1D\u200D\uD83D\uDC69\uD83C\uDFFD", "\uD83D\uDC69\uD83C\uDFFF\u200D\uD83E\uDD1D\u200D\uD83D\uDC69\uD83C\uDFFE", "\uD83E\uDDD1\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1", "\uD83E\uDDD1\u200D\uD83E\uDDD1\u200D\uD83E\uDDD2", "\uD83E\uDDD1\u200D\uD83E\uDDD1\u200D\uD83E\uDDD2\u200D\uD83E\uDDD2", "\uD83E\uDDD1\u200D\uD83E\uDDD2", "\uD83E\uDDD1\u200D\uD83E\uDDD2\u200D\uD83E\uDDD2", "\uD83E\uDDD1\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83E\uDDD1\uD83C\uDFFC", "\uD83E\uDDD1\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83E\uDDD1\uD83C\uDFFD", "\uD83E\uDDD1\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83E\uDDD1\uD83C\uDFFE", "\uD83E\uDDD1\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83E\uDDD1\uD83C\uDFFF", "\uD83E\uDDD1\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83E\uDDD1\uD83C\uDFFC", "\uD83E\uDDD1\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83E\uDDD1\uD83C\uDFFD", "\uD83E\uDDD1\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83E\uDDD1\uD83C\uDFFE", "\uD83E\uDDD1\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83E\uDDD1\uD83C\uDFFF", "\uD83E\uDDD1\uD83C\uDFFB\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1\uD83C\uDFFB", "\uD83E\uDDD1\uD83C\uDFFB\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1\uD83C\uDFFC", "\uD83E\uDDD1\uD83C\uDFFB\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1\uD83C\uDFFD", "\uD83E\uDDD1\uD83C\uDFFB\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1\uD83C\uDFFE", "\uD83E\uDDD1\uD83C\uDFFB\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1\uD83C\uDFFF", "\uD83E\uDDD1\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83E\uDDD1\uD83C\uDFFB", "\uD83E\uDDD1\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83E\uDDD1\uD83C\uDFFD", "\uD83E\uDDD1\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83E\uDDD1\uD83C\uDFFE", "\uD83E\uDDD1\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83E\uDDD1\uD83C\uDFFF", "\uD83E\uDDD1\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83E\uDDD1\uD83C\uDFFB", "\uD83E\uDDD1\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83E\uDDD1\uD83C\uDFFD", "\uD83E\uDDD1\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83E\uDDD1\uD83C\uDFFE", "\uD83E\uDDD1\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83E\uDDD1\uD83C\uDFFF", "\uD83E\uDDD1\uD83C\uDFFC\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1\uD83C\uDFFB", "\uD83E\uDDD1\uD83C\uDFFC\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1\uD83C\uDFFC", "\uD83E\uDDD1\uD83C\uDFFC\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1\uD83C\uDFFD", "\uD83E\uDDD1\uD83C\uDFFC\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1\uD83C\uDFFE", "\uD83E\uDDD1\uD83C\uDFFC\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1\uD83C\uDFFF", "\uD83E\uDDD1\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83E\uDDD1\uD83C\uDFFB", "\uD83E\uDDD1\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83E\uDDD1\uD83C\uDFFC", "\uD83E\uDDD1\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83E\uDDD1\uD83C\uDFFE", "\uD83E\uDDD1\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83E\uDDD1\uD83C\uDFFF", "\uD83E\uDDD1\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83E\uDDD1\uD83C\uDFFB", "\uD83E\uDDD1\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83E\uDDD1\uD83C\uDFFC", "\uD83E\uDDD1\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83E\uDDD1\uD83C\uDFFE", "\uD83E\uDDD1\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83E\uDDD1\uD83C\uDFFF", "\uD83E\uDDD1\uD83C\uDFFD\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1\uD83C\uDFFB", "\uD83E\uDDD1\uD83C\uDFFD\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1\uD83C\uDFFC", "\uD83E\uDDD1\uD83C\uDFFD\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1\uD83C\uDFFD", "\uD83E\uDDD1\uD83C\uDFFD\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1\uD83C\uDFFE", "\uD83E\uDDD1\uD83C\uDFFD\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1\uD83C\uDFFF", "\uD83E\uDDD1\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83E\uDDD1\uD83C\uDFFB", "\uD83E\uDDD1\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83E\uDDD1\uD83C\uDFFC", "\uD83E\uDDD1\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83E\uDDD1\uD83C\uDFFD", "\uD83E\uDDD1\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83E\uDDD1\uD83C\uDFFF", "\uD83E\uDDD1\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83E\uDDD1\uD83C\uDFFB", "\uD83E\uDDD1\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83E\uDDD1\uD83C\uDFFC", "\uD83E\uDDD1\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83E\uDDD1\uD83C\uDFFD", "\uD83E\uDDD1\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83E\uDDD1\uD83C\uDFFF", "\uD83E\uDDD1\uD83C\uDFFE\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1\uD83C\uDFFB", "\uD83E\uDDD1\uD83C\uDFFE\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1\uD83C\uDFFC", "\uD83E\uDDD1\uD83C\uDFFE\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1\uD83C\uDFFD", "\uD83E\uDDD1\uD83C\uDFFE\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1\uD83C\uDFFE", "\uD83E\uDDD1\uD83C\uDFFE\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1\uD83C\uDFFF", "\uD83E\uDDD1\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83E\uDDD1\uD83C\uDFFB", "\uD83E\uDDD1\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83E\uDDD1\uD83C\uDFFC", "\uD83E\uDDD1\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83E\uDDD1\uD83C\uDFFD", "\uD83E\uDDD1\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83E\uDDD1\uD83C\uDFFE", "\uD83E\uDDD1\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83E\uDDD1\uD83C\uDFFB", "\uD83E\uDDD1\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83E\uDDD1\uD83C\uDFFC", "\uD83E\uDDD1\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83E\uDDD1\uD83C\uDFFD", "\uD83E\uDDD1\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83E\uDDD1\uD83C\uDFFE", "\uD83E\uDDD1\uD83C\uDFFF\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1\uD83C\uDFFB", "\uD83E\uDDD1\uD83C\uDFFF\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1\uD83C\uDFFC", "\uD83E\uDDD1\uD83C\uDFFF\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1\uD83C\uDFFD", "\uD83E\uDDD1\uD83C\uDFFF\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1\uD83C\uDFFE", "\uD83E\uDDD1\uD83C\uDFFF\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1\uD83C\uDFFF", "\uD83E\uDEF1\uD83C\uDFFB\u200D\uD83E\uDEF2\uD83C\uDFFC", "\uD83E\uDEF1\uD83C\uDFFB\u200D\uD83E\uDEF2\uD83C\uDFFD", "\uD83E\uDEF1\uD83C\uDFFB\u200D\uD83E\uDEF2\uD83C\uDFFE", "\uD83E\uDEF1\uD83C\uDFFB\u200D\uD83E\uDEF2\uD83C\uDFFF", "\uD83E\uDEF1\uD83C\uDFFC\u200D\uD83E\uDEF2\uD83C\uDFFB", "\uD83E\uDEF1\uD83C\uDFFC\u200D\uD83E\uDEF2\uD83C\uDFFD", "\uD83E\uDEF1\uD83C\uDFFC\u200D\uD83E\uDEF2\uD83C\uDFFE", "\uD83E\uDEF1\uD83C\uDFFC\u200D\uD83E\uDEF2\uD83C\uDFFF", "\uD83E\uDEF1\uD83C\uDFFD\u200D\uD83E\uDEF2\uD83C\uDFFB", "\uD83E\uDEF1\uD83C\uDFFD\u200D\uD83E\uDEF2\uD83C\uDFFC", "\uD83E\uDEF1\uD83C\uDFFD\u200D\uD83E\uDEF2\uD83C\uDFFE", "\uD83E\uDEF1\uD83C\uDFFD\u200D\uD83E\uDEF2\uD83C\uDFFF", "\uD83E\uDEF1\uD83C\uDFFE\u200D\uD83E\uDEF2\uD83C\uDFFB", "\uD83E\uDEF1\uD83C\uDFFE\u200D\uD83E\uDEF2\uD83C\uDFFC", "\uD83E\uDEF1\uD83C\uDFFE\u200D\uD83E\uDEF2\uD83C\uDFFD", "\uD83E\uDEF1\uD83C\uDFFE\u200D\uD83E\uDEF2\uD83C\uDFFF", "\uD83E\uDEF1\uD83C\uDFFF\u200D\uD83E\uDEF2\uD83C\uDFFB", "\uD83E\uDEF1\uD83C\uDFFF\u200D\uD83E\uDEF2\uD83C\uDFFC", "\uD83E\uDEF1\uD83C\uDFFF\u200D\uD83E\uDEF2\uD83C\uDFFD", "\uD83E\uDEF1\uD83C\uDFFF\u200D\uD83E\uDEF2\uD83C\uDFFE", "\uD83C\uDFC3\u200D\u27A1\uFE0F", "\uD83C\uDFC3\uD83C\uDFFB\u200D\u27A1\uFE0F", "\uD83C\uDFC3\uD83C\uDFFC\u200D\u27A1\uFE0F", "\uD83C\uDFC3\uD83C\uDFFD\u200D\u27A1\uFE0F", "\uD83C\uDFC3\uD83C\uDFFE\u200D\u27A1\uFE0F", "\uD83C\uDFC3\uD83C\uDFFF\u200D\u27A1\uFE0F", "\uD83D\uDC68\u200D\u2695\uFE0F", "\uD83D\uDC68\u200D\u2696\uFE0F", "\uD83D\uDC68\u200D\u2708\uFE0F", "\uD83D\uDC68\u200D\uD83C\uDF3E", "\uD83D\uDC68\u200D\uD83C\uDF73", "\uD83D\uDC68\u200D\uD83C\uDF7C", "\uD83D\uDC68\u200D\uD83C\uDF93", "\uD83D\uDC68\u200D\uD83C\uDFA4", "\uD83D\uDC68\u200D\uD83C\uDFA8", "\uD83D\uDC68\u200D\uD83C\uDFEB", "\uD83D\uDC68\u200D\uD83C\uDFED", "\uD83D\uDC68\u200D\uD83D\uDCBB", "\uD83D\uDC68\u200D\uD83D\uDCBC", "\uD83D\uDC68\u200D\uD83D\uDD27", "\uD83D\uDC68\u200D\uD83D\uDD2C", "\uD83D\uDC68\u200D\uD83D\uDE80", "\uD83D\uDC68\u200D\uD83D\uDE92", "\uD83D\uDC68\u200D\uD83E\uDDAF", "\uD83D\uDC68\u200D\uD83E\uDDAF\u200D\u27A1\uFE0F", "\uD83D\uDC68\u200D\uD83E\uDDBC", "\uD83D\uDC68\u200D\uD83E\uDDBC\u200D\u27A1\uFE0F", "\uD83D\uDC68\u200D\uD83E\uDDBD", "\uD83D\uDC68\u200D\uD83E\uDDBD\u200D\u27A1\uFE0F", "\uD83D\uDC68\uD83C\uDFFB\u200D\u2695\uFE0F", "\uD83D\uDC68\uD83C\uDFFB\u200D\u2696\uFE0F", "\uD83D\uDC68\uD83C\uDFFB\u200D\u2708\uFE0F", "\uD83D\uDC68\uD83C\uDFFB\u200D\uD83C\uDF3E", "\uD83D\uDC68\uD83C\uDFFB\u200D\uD83C\uDF73", "\uD83D\uDC68\uD83C\uDFFB\u200D\uD83C\uDF7C", "\uD83D\uDC68\uD83C\uDFFB\u200D\uD83C\uDF93", "\uD83D\uDC68\uD83C\uDFFB\u200D\uD83C\uDFA4", "\uD83D\uDC68\uD83C\uDFFB\u200D\uD83C\uDFA8", "\uD83D\uDC68\uD83C\uDFFB\u200D\uD83C\uDFEB", "\uD83D\uDC68\uD83C\uDFFB\u200D\uD83C\uDFED", "\uD83D\uDC68\uD83C\uDFFB\u200D\uD83D\uDCBB", "\uD83D\uDC68\uD83C\uDFFB\u200D\uD83D\uDCBC", "\uD83D\uDC68\uD83C\uDFFB\u200D\uD83D\uDD27", "\uD83D\uDC68\uD83C\uDFFB\u200D\uD83D\uDD2C", "\uD83D\uDC68\uD83C\uDFFB\u200D\uD83D\uDE80", "\uD83D\uDC68\uD83C\uDFFB\u200D\uD83D\uDE92", "\uD83D\uDC68\uD83C\uDFFB\u200D\uD83E\uDDAF", "\uD83D\uDC68\uD83C\uDFFB\u200D\uD83E\uDDAF\u200D\u27A1\uFE0F", "\uD83D\uDC68\uD83C\uDFFB\u200D\uD83E\uDDBC", "\uD83D\uDC68\uD83C\uDFFB\u200D\uD83E\uDDBC\u200D\u27A1\uFE0F", "\uD83D\uDC68\uD83C\uDFFB\u200D\uD83E\uDDBD", "\uD83D\uDC68\uD83C\uDFFB\u200D\uD83E\uDDBD\u200D\u27A1\uFE0F", "\uD83D\uDC68\uD83C\uDFFC\u200D\u2695\uFE0F", "\uD83D\uDC68\uD83C\uDFFC\u200D\u2696\uFE0F", "\uD83D\uDC68\uD83C\uDFFC\u200D\u2708\uFE0F", "\uD83D\uDC68\uD83C\uDFFC\u200D\uD83C\uDF3E", "\uD83D\uDC68\uD83C\uDFFC\u200D\uD83C\uDF73", "\uD83D\uDC68\uD83C\uDFFC\u200D\uD83C\uDF7C", "\uD83D\uDC68\uD83C\uDFFC\u200D\uD83C\uDF93", "\uD83D\uDC68\uD83C\uDFFC\u200D\uD83C\uDFA4", "\uD83D\uDC68\uD83C\uDFFC\u200D\uD83C\uDFA8", "\uD83D\uDC68\uD83C\uDFFC\u200D\uD83C\uDFEB", "\uD83D\uDC68\uD83C\uDFFC\u200D\uD83C\uDFED", "\uD83D\uDC68\uD83C\uDFFC\u200D\uD83D\uDCBB", "\uD83D\uDC68\uD83C\uDFFC\u200D\uD83D\uDCBC", "\uD83D\uDC68\uD83C\uDFFC\u200D\uD83D\uDD27", "\uD83D\uDC68\uD83C\uDFFC\u200D\uD83D\uDD2C", "\uD83D\uDC68\uD83C\uDFFC\u200D\uD83D\uDE80", "\uD83D\uDC68\uD83C\uDFFC\u200D\uD83D\uDE92", "\uD83D\uDC68\uD83C\uDFFC\u200D\uD83E\uDDAF", "\uD83D\uDC68\uD83C\uDFFC\u200D\uD83E\uDDAF\u200D\u27A1\uFE0F", "\uD83D\uDC68\uD83C\uDFFC\u200D\uD83E\uDDBC", "\uD83D\uDC68\uD83C\uDFFC\u200D\uD83E\uDDBC\u200D\u27A1\uFE0F", "\uD83D\uDC68\uD83C\uDFFC\u200D\uD83E\uDDBD", "\uD83D\uDC68\uD83C\uDFFC\u200D\uD83E\uDDBD\u200D\u27A1\uFE0F", "\uD83D\uDC68\uD83C\uDFFD\u200D\u2695\uFE0F", "\uD83D\uDC68\uD83C\uDFFD\u200D\u2696\uFE0F", "\uD83D\uDC68\uD83C\uDFFD\u200D\u2708\uFE0F", "\uD83D\uDC68\uD83C\uDFFD\u200D\uD83C\uDF3E", "\uD83D\uDC68\uD83C\uDFFD\u200D\uD83C\uDF73", "\uD83D\uDC68\uD83C\uDFFD\u200D\uD83C\uDF7C", "\uD83D\uDC68\uD83C\uDFFD\u200D\uD83C\uDF93", "\uD83D\uDC68\uD83C\uDFFD\u200D\uD83C\uDFA4", "\uD83D\uDC68\uD83C\uDFFD\u200D\uD83C\uDFA8", "\uD83D\uDC68\uD83C\uDFFD\u200D\uD83C\uDFEB", "\uD83D\uDC68\uD83C\uDFFD\u200D\uD83C\uDFED", "\uD83D\uDC68\uD83C\uDFFD\u200D\uD83D\uDCBB", "\uD83D\uDC68\uD83C\uDFFD\u200D\uD83D\uDCBC", "\uD83D\uDC68\uD83C\uDFFD\u200D\uD83D\uDD27", "\uD83D\uDC68\uD83C\uDFFD\u200D\uD83D\uDD2C", "\uD83D\uDC68\uD83C\uDFFD\u200D\uD83D\uDE80", "\uD83D\uDC68\uD83C\uDFFD\u200D\uD83D\uDE92", "\uD83D\uDC68\uD83C\uDFFD\u200D\uD83E\uDDAF", "\uD83D\uDC68\uD83C\uDFFD\u200D\uD83E\uDDAF\u200D\u27A1\uFE0F", "\uD83D\uDC68\uD83C\uDFFD\u200D\uD83E\uDDBC", "\uD83D\uDC68\uD83C\uDFFD\u200D\uD83E\uDDBC\u200D\u27A1\uFE0F", "\uD83D\uDC68\uD83C\uDFFD\u200D\uD83E\uDDBD", "\uD83D\uDC68\uD83C\uDFFD\u200D\uD83E\uDDBD\u200D\u27A1\uFE0F", "\uD83D\uDC68\uD83C\uDFFE\u200D\u2695\uFE0F", "\uD83D\uDC68\uD83C\uDFFE\u200D\u2696\uFE0F", "\uD83D\uDC68\uD83C\uDFFE\u200D\u2708\uFE0F", "\uD83D\uDC68\uD83C\uDFFE\u200D\uD83C\uDF3E", "\uD83D\uDC68\uD83C\uDFFE\u200D\uD83C\uDF73", "\uD83D\uDC68\uD83C\uDFFE\u200D\uD83C\uDF7C", "\uD83D\uDC68\uD83C\uDFFE\u200D\uD83C\uDF93", "\uD83D\uDC68\uD83C\uDFFE\u200D\uD83C\uDFA4", "\uD83D\uDC68\uD83C\uDFFE\u200D\uD83C\uDFA8", "\uD83D\uDC68\uD83C\uDFFE\u200D\uD83C\uDFEB", "\uD83D\uDC68\uD83C\uDFFE\u200D\uD83C\uDFED", "\uD83D\uDC68\uD83C\uDFFE\u200D\uD83D\uDCBB", "\uD83D\uDC68\uD83C\uDFFE\u200D\uD83D\uDCBC", "\uD83D\uDC68\uD83C\uDFFE\u200D\uD83D\uDD27", "\uD83D\uDC68\uD83C\uDFFE\u200D\uD83D\uDD2C", "\uD83D\uDC68\uD83C\uDFFE\u200D\uD83D\uDE80", "\uD83D\uDC68\uD83C\uDFFE\u200D\uD83D\uDE92", "\uD83D\uDC68\uD83C\uDFFE\u200D\uD83E\uDDAF", "\uD83D\uDC68\uD83C\uDFFE\u200D\uD83E\uDDAF\u200D\u27A1\uFE0F", "\uD83D\uDC68\uD83C\uDFFE\u200D\uD83E\uDDBC", "\uD83D\uDC68\uD83C\uDFFE\u200D\uD83E\uDDBC\u200D\u27A1\uFE0F", "\uD83D\uDC68\uD83C\uDFFE\u200D\uD83E\uDDBD", "\uD83D\uDC68\uD83C\uDFFE\u200D\uD83E\uDDBD\u200D\u27A1\uFE0F", "\uD83D\uDC68\uD83C\uDFFF\u200D\u2695\uFE0F", "\uD83D\uDC68\uD83C\uDFFF\u200D\u2696\uFE0F", "\uD83D\uDC68\uD83C\uDFFF\u200D\u2708\uFE0F", "\uD83D\uDC68\uD83C\uDFFF\u200D\uD83C\uDF3E", "\uD83D\uDC68\uD83C\uDFFF\u200D\uD83C\uDF73", "\uD83D\uDC68\uD83C\uDFFF\u200D\uD83C\uDF7C", "\uD83D\uDC68\uD83C\uDFFF\u200D\uD83C\uDF93", "\uD83D\uDC68\uD83C\uDFFF\u200D\uD83C\uDFA4", "\uD83D\uDC68\uD83C\uDFFF\u200D\uD83C\uDFA8", "\uD83D\uDC68\uD83C\uDFFF\u200D\uD83C\uDFEB", "\uD83D\uDC68\uD83C\uDFFF\u200D\uD83C\uDFED", "\uD83D\uDC68\uD83C\uDFFF\u200D\uD83D\uDCBB", "\uD83D\uDC68\uD83C\uDFFF\u200D\uD83D\uDCBC", "\uD83D\uDC68\uD83C\uDFFF\u200D\uD83D\uDD27", "\uD83D\uDC68\uD83C\uDFFF\u200D\uD83D\uDD2C", "\uD83D\uDC68\uD83C\uDFFF\u200D\uD83D\uDE80", "\uD83D\uDC68\uD83C\uDFFF\u200D\uD83D\uDE92", "\uD83D\uDC68\uD83C\uDFFF\u200D\uD83E\uDDAF", "\uD83D\uDC68\uD83C\uDFFF\u200D\uD83E\uDDAF\u200D\u27A1\uFE0F", "\uD83D\uDC68\uD83C\uDFFF\u200D\uD83E\uDDBC", "\uD83D\uDC68\uD83C\uDFFF\u200D\uD83E\uDDBC\u200D\u27A1\uFE0F", "\uD83D\uDC68\uD83C\uDFFF\u200D\uD83E\uDDBD", "\uD83D\uDC68\uD83C\uDFFF\u200D\uD83E\uDDBD\u200D\u27A1\uFE0F", "\uD83D\uDC69\u200D\u2695\uFE0F", "\uD83D\uDC69\u200D\u2696\uFE0F", "\uD83D\uDC69\u200D\u2708\uFE0F", "\uD83D\uDC69\u200D\uD83C\uDF3E", "\uD83D\uDC69\u200D\uD83C\uDF73", "\uD83D\uDC69\u200D\uD83C\uDF7C", "\uD83D\uDC69\u200D\uD83C\uDF93", "\uD83D\uDC69\u200D\uD83C\uDFA4", "\uD83D\uDC69\u200D\uD83C\uDFA8", "\uD83D\uDC69\u200D\uD83C\uDFEB", "\uD83D\uDC69\u200D\uD83C\uDFED", "\uD83D\uDC69\u200D\uD83D\uDCBB", "\uD83D\uDC69\u200D\uD83D\uDCBC", "\uD83D\uDC69\u200D\uD83D\uDD27", "\uD83D\uDC69\u200D\uD83D\uDD2C", "\uD83D\uDC69\u200D\uD83D\uDE80", "\uD83D\uDC69\u200D\uD83D\uDE92", "\uD83D\uDC69\u200D\uD83E\uDDAF", "\uD83D\uDC69\u200D\uD83E\uDDAF\u200D\u27A1\uFE0F", "\uD83D\uDC69\u200D\uD83E\uDDBC", "\uD83D\uDC69\u200D\uD83E\uDDBC\u200D\u27A1\uFE0F", "\uD83D\uDC69\u200D\uD83E\uDDBD", "\uD83D\uDC69\u200D\uD83E\uDDBD\u200D\u27A1\uFE0F", "\uD83D\uDC69\uD83C\uDFFB\u200D\u2695\uFE0F", "\uD83D\uDC69\uD83C\uDFFB\u200D\u2696\uFE0F", "\uD83D\uDC69\uD83C\uDFFB\u200D\u2708\uFE0F", "\uD83D\uDC69\uD83C\uDFFB\u200D\uD83C\uDF3E", "\uD83D\uDC69\uD83C\uDFFB\u200D\uD83C\uDF73", "\uD83D\uDC69\uD83C\uDFFB\u200D\uD83C\uDF7C", "\uD83D\uDC69\uD83C\uDFFB\u200D\uD83C\uDF93", "\uD83D\uDC69\uD83C\uDFFB\u200D\uD83C\uDFA4", "\uD83D\uDC69\uD83C\uDFFB\u200D\uD83C\uDFA8", "\uD83D\uDC69\uD83C\uDFFB\u200D\uD83C\uDFEB", "\uD83D\uDC69\uD83C\uDFFB\u200D\uD83C\uDFED", "\uD83D\uDC69\uD83C\uDFFB\u200D\uD83D\uDCBB", "\uD83D\uDC69\uD83C\uDFFB\u200D\uD83D\uDCBC", "\uD83D\uDC69\uD83C\uDFFB\u200D\uD83D\uDD27", "\uD83D\uDC69\uD83C\uDFFB\u200D\uD83D\uDD2C", "\uD83D\uDC69\uD83C\uDFFB\u200D\uD83D\uDE80", "\uD83D\uDC69\uD83C\uDFFB\u200D\uD83D\uDE92", "\uD83D\uDC69\uD83C\uDFFB\u200D\uD83E\uDDAF", "\uD83D\uDC69\uD83C\uDFFB\u200D\uD83E\uDDAF\u200D\u27A1\uFE0F", "\uD83D\uDC69\uD83C\uDFFB\u200D\uD83E\uDDBC", "\uD83D\uDC69\uD83C\uDFFB\u200D\uD83E\uDDBC\u200D\u27A1\uFE0F", "\uD83D\uDC69\uD83C\uDFFB\u200D\uD83E\uDDBD", "\uD83D\uDC69\uD83C\uDFFB\u200D\uD83E\uDDBD\u200D\u27A1\uFE0F", "\uD83D\uDC69\uD83C\uDFFC\u200D\u2695\uFE0F", "\uD83D\uDC69\uD83C\uDFFC\u200D\u2696\uFE0F", "\uD83D\uDC69\uD83C\uDFFC\u200D\u2708\uFE0F", "\uD83D\uDC69\uD83C\uDFFC\u200D\uD83C\uDF3E", "\uD83D\uDC69\uD83C\uDFFC\u200D\uD83C\uDF73", "\uD83D\uDC69\uD83C\uDFFC\u200D\uD83C\uDF7C", "\uD83D\uDC69\uD83C\uDFFC\u200D\uD83C\uDF93", "\uD83D\uDC69\uD83C\uDFFC\u200D\uD83C\uDFA4", "\uD83D\uDC69\uD83C\uDFFC\u200D\uD83C\uDFA8", "\uD83D\uDC69\uD83C\uDFFC\u200D\uD83C\uDFEB", "\uD83D\uDC69\uD83C\uDFFC\u200D\uD83C\uDFED", "\uD83D\uDC69\uD83C\uDFFC\u200D\uD83D\uDCBB", "\uD83D\uDC69\uD83C\uDFFC\u200D\uD83D\uDCBC", "\uD83D\uDC69\uD83C\uDFFC\u200D\uD83D\uDD27", "\uD83D\uDC69\uD83C\uDFFC\u200D\uD83D\uDD2C", "\uD83D\uDC69\uD83C\uDFFC\u200D\uD83D\uDE80", "\uD83D\uDC69\uD83C\uDFFC\u200D\uD83D\uDE92", "\uD83D\uDC69\uD83C\uDFFC\u200D\uD83E\uDDAF", "\uD83D\uDC69\uD83C\uDFFC\u200D\uD83E\uDDAF\u200D\u27A1\uFE0F", "\uD83D\uDC69\uD83C\uDFFC\u200D\uD83E\uDDBC", "\uD83D\uDC69\uD83C\uDFFC\u200D\uD83E\uDDBC\u200D\u27A1\uFE0F", "\uD83D\uDC69\uD83C\uDFFC\u200D\uD83E\uDDBD", "\uD83D\uDC69\uD83C\uDFFC\u200D\uD83E\uDDBD\u200D\u27A1\uFE0F", "\uD83D\uDC69\uD83C\uDFFD\u200D\u2695\uFE0F", "\uD83D\uDC69\uD83C\uDFFD\u200D\u2696\uFE0F", "\uD83D\uDC69\uD83C\uDFFD\u200D\u2708\uFE0F", "\uD83D\uDC69\uD83C\uDFFD\u200D\uD83C\uDF3E", "\uD83D\uDC69\uD83C\uDFFD\u200D\uD83C\uDF73", "\uD83D\uDC69\uD83C\uDFFD\u200D\uD83C\uDF7C", "\uD83D\uDC69\uD83C\uDFFD\u200D\uD83C\uDF93", "\uD83D\uDC69\uD83C\uDFFD\u200D\uD83C\uDFA4", "\uD83D\uDC69\uD83C\uDFFD\u200D\uD83C\uDFA8", "\uD83D\uDC69\uD83C\uDFFD\u200D\uD83C\uDFEB", "\uD83D\uDC69\uD83C\uDFFD\u200D\uD83C\uDFED", "\uD83D\uDC69\uD83C\uDFFD\u200D\uD83D\uDCBB", "\uD83D\uDC69\uD83C\uDFFD\u200D\uD83D\uDCBC", "\uD83D\uDC69\uD83C\uDFFD\u200D\uD83D\uDD27", "\uD83D\uDC69\uD83C\uDFFD\u200D\uD83D\uDD2C", "\uD83D\uDC69\uD83C\uDFFD\u200D\uD83D\uDE80", "\uD83D\uDC69\uD83C\uDFFD\u200D\uD83D\uDE92", "\uD83D\uDC69\uD83C\uDFFD\u200D\uD83E\uDDAF", "\uD83D\uDC69\uD83C\uDFFD\u200D\uD83E\uDDAF\u200D\u27A1\uFE0F", "\uD83D\uDC69\uD83C\uDFFD\u200D\uD83E\uDDBC", "\uD83D\uDC69\uD83C\uDFFD\u200D\uD83E\uDDBC\u200D\u27A1\uFE0F", "\uD83D\uDC69\uD83C\uDFFD\u200D\uD83E\uDDBD", "\uD83D\uDC69\uD83C\uDFFD\u200D\uD83E\uDDBD\u200D\u27A1\uFE0F", "\uD83D\uDC69\uD83C\uDFFE\u200D\u2695\uFE0F", "\uD83D\uDC69\uD83C\uDFFE\u200D\u2696\uFE0F", "\uD83D\uDC69\uD83C\uDFFE\u200D\u2708\uFE0F", "\uD83D\uDC69\uD83C\uDFFE\u200D\uD83C\uDF3E", "\uD83D\uDC69\uD83C\uDFFE\u200D\uD83C\uDF73", "\uD83D\uDC69\uD83C\uDFFE\u200D\uD83C\uDF7C", "\uD83D\uDC69\uD83C\uDFFE\u200D\uD83C\uDF93", "\uD83D\uDC69\uD83C\uDFFE\u200D\uD83C\uDFA4", "\uD83D\uDC69\uD83C\uDFFE\u200D\uD83C\uDFA8", "\uD83D\uDC69\uD83C\uDFFE\u200D\uD83C\uDFEB", "\uD83D\uDC69\uD83C\uDFFE\u200D\uD83C\uDFED", "\uD83D\uDC69\uD83C\uDFFE\u200D\uD83D\uDCBB", "\uD83D\uDC69\uD83C\uDFFE\u200D\uD83D\uDCBC", "\uD83D\uDC69\uD83C\uDFFE\u200D\uD83D\uDD27", "\uD83D\uDC69\uD83C\uDFFE\u200D\uD83D\uDD2C", "\uD83D\uDC69\uD83C\uDFFE\u200D\uD83D\uDE80", "\uD83D\uDC69\uD83C\uDFFE\u200D\uD83D\uDE92", "\uD83D\uDC69\uD83C\uDFFE\u200D\uD83E\uDDAF", "\uD83D\uDC69\uD83C\uDFFE\u200D\uD83E\uDDAF\u200D\u27A1\uFE0F", "\uD83D\uDC69\uD83C\uDFFE\u200D\uD83E\uDDBC", "\uD83D\uDC69\uD83C\uDFFE\u200D\uD83E\uDDBC\u200D\u27A1\uFE0F", "\uD83D\uDC69\uD83C\uDFFE\u200D\uD83E\uDDBD", "\uD83D\uDC69\uD83C\uDFFE\u200D\uD83E\uDDBD\u200D\u27A1\uFE0F", "\uD83D\uDC69\uD83C\uDFFF\u200D\u2695\uFE0F", "\uD83D\uDC69\uD83C\uDFFF\u200D\u2696\uFE0F", "\uD83D\uDC69\uD83C\uDFFF\u200D\u2708\uFE0F", "\uD83D\uDC69\uD83C\uDFFF\u200D\uD83C\uDF3E", "\uD83D\uDC69\uD83C\uDFFF\u200D\uD83C\uDF73", "\uD83D\uDC69\uD83C\uDFFF\u200D\uD83C\uDF7C", "\uD83D\uDC69\uD83C\uDFFF\u200D\uD83C\uDF93", "\uD83D\uDC69\uD83C\uDFFF\u200D\uD83C\uDFA4", "\uD83D\uDC69\uD83C\uDFFF\u200D\uD83C\uDFA8", "\uD83D\uDC69\uD83C\uDFFF\u200D\uD83C\uDFEB", "\uD83D\uDC69\uD83C\uDFFF\u200D\uD83C\uDFED", "\uD83D\uDC69\uD83C\uDFFF\u200D\uD83D\uDCBB", "\uD83D\uDC69\uD83C\uDFFF\u200D\uD83D\uDCBC", "\uD83D\uDC69\uD83C\uDFFF\u200D\uD83D\uDD27", "\uD83D\uDC69\uD83C\uDFFF\u200D\uD83D\uDD2C", "\uD83D\uDC69\uD83C\uDFFF\u200D\uD83D\uDE80", "\uD83D\uDC69\uD83C\uDFFF\u200D\uD83D\uDE92", "\uD83D\uDC69\uD83C\uDFFF\u200D\uD83E\uDDAF", "\uD83D\uDC69\uD83C\uDFFF\u200D\uD83E\uDDAF\u200D\u27A1\uFE0F", "\uD83D\uDC69\uD83C\uDFFF\u200D\uD83E\uDDBC", "\uD83D\uDC69\uD83C\uDFFF\u200D\uD83E\uDDBC\u200D\u27A1\uFE0F", "\uD83D\uDC69\uD83C\uDFFF\u200D\uD83E\uDDBD", "\uD83D\uDC69\uD83C\uDFFF\u200D\uD83E\uDDBD\u200D\u27A1\uFE0F", "\uD83D\uDEB6\u200D\u27A1\uFE0F", "\uD83D\uDEB6\uD83C\uDFFB\u200D\u27A1\uFE0F", "\uD83D\uDEB6\uD83C\uDFFC\u200D\u27A1\uFE0F", "\uD83D\uDEB6\uD83C\uDFFD\u200D\u27A1\uFE0F", "\uD83D\uDEB6\uD83C\uDFFE\u200D\u27A1\uFE0F", "\uD83D\uDEB6\uD83C\uDFFF\u200D\u27A1\uFE0F", "\uD83E\uDDCE\u200D\u27A1\uFE0F", "\uD83E\uDDCE\uD83C\uDFFB\u200D\u27A1\uFE0F", "\uD83E\uDDCE\uD83C\uDFFC\u200D\u27A1\uFE0F", "\uD83E\uDDCE\uD83C\uDFFD\u200D\u27A1\uFE0F", "\uD83E\uDDCE\uD83C\uDFFE\u200D\u27A1\uFE0F", "\uD83E\uDDCE\uD83C\uDFFF\u200D\u27A1\uFE0F", "\uD83E\uDDD1\u200D\u2695\uFE0F", "\uD83E\uDDD1\u200D\u2696\uFE0F", "\uD83E\uDDD1\u200D\u2708\uFE0F", "\uD83E\uDDD1\u200D\uD83C\uDF3E", "\uD83E\uDDD1\u200D\uD83C\uDF73", "\uD83E\uDDD1\u200D\uD83C\uDF7C", "\uD83E\uDDD1\u200D\uD83C\uDF84", "\uD83E\uDDD1\u200D\uD83C\uDF93", "\uD83E\uDDD1\u200D\uD83C\uDFA4", "\uD83E\uDDD1\u200D\uD83C\uDFA8", "\uD83E\uDDD1\u200D\uD83C\uDFEB", "\uD83E\uDDD1\u200D\uD83C\uDFED", "\uD83E\uDDD1\u200D\uD83D\uDCBB", "\uD83E\uDDD1\u200D\uD83D\uDCBC", "\uD83E\uDDD1\u200D\uD83D\uDD27", "\uD83E\uDDD1\u200D\uD83D\uDD2C", "\uD83E\uDDD1\u200D\uD83D\uDE80", "\uD83E\uDDD1\u200D\uD83D\uDE92", "\uD83E\uDDD1\u200D\uD83E\uDDAF", "\uD83E\uDDD1\u200D\uD83E\uDDAF\u200D\u27A1\uFE0F", "\uD83E\uDDD1\u200D\uD83E\uDDBC", "\uD83E\uDDD1\u200D\uD83E\uDDBC\u200D\u27A1\uFE0F", "\uD83E\uDDD1\u200D\uD83E\uDDBD", "\uD83E\uDDD1\u200D\uD83E\uDDBD\u200D\u27A1\uFE0F", "\uD83E\uDDD1\uD83C\uDFFB\u200D\u2695\uFE0F", "\uD83E\uDDD1\uD83C\uDFFB\u200D\u2696\uFE0F", "\uD83E\uDDD1\uD83C\uDFFB\u200D\u2708\uFE0F", "\uD83E\uDDD1\uD83C\uDFFB\u200D\uD83C\uDF3E", "\uD83E\uDDD1\uD83C\uDFFB\u200D\uD83C\uDF73", "\uD83E\uDDD1\uD83C\uDFFB\u200D\uD83C\uDF7C", "\uD83E\uDDD1\uD83C\uDFFB\u200D\uD83C\uDF84", "\uD83E\uDDD1\uD83C\uDFFB\u200D\uD83C\uDF93", "\uD83E\uDDD1\uD83C\uDFFB\u200D\uD83C\uDFA4", "\uD83E\uDDD1\uD83C\uDFFB\u200D\uD83C\uDFA8", "\uD83E\uDDD1\uD83C\uDFFB\u200D\uD83C\uDFEB", "\uD83E\uDDD1\uD83C\uDFFB\u200D\uD83C\uDFED", "\uD83E\uDDD1\uD83C\uDFFB\u200D\uD83D\uDCBB", "\uD83E\uDDD1\uD83C\uDFFB\u200D\uD83D\uDCBC", "\uD83E\uDDD1\uD83C\uDFFB\u200D\uD83D\uDD27", "\uD83E\uDDD1\uD83C\uDFFB\u200D\uD83D\uDD2C", "\uD83E\uDDD1\uD83C\uDFFB\u200D\uD83D\uDE80", "\uD83E\uDDD1\uD83C\uDFFB\u200D\uD83D\uDE92", "\uD83E\uDDD1\uD83C\uDFFB\u200D\uD83E\uDDAF", "\uD83E\uDDD1\uD83C\uDFFB\u200D\uD83E\uDDAF\u200D\u27A1\uFE0F", "\uD83E\uDDD1\uD83C\uDFFB\u200D\uD83E\uDDBC", "\uD83E\uDDD1\uD83C\uDFFB\u200D\uD83E\uDDBC\u200D\u27A1\uFE0F", "\uD83E\uDDD1\uD83C\uDFFB\u200D\uD83E\uDDBD", "\uD83E\uDDD1\uD83C\uDFFB\u200D\uD83E\uDDBD\u200D\u27A1\uFE0F", "\uD83E\uDDD1\uD83C\uDFFC\u200D\u2695\uFE0F", "\uD83E\uDDD1\uD83C\uDFFC\u200D\u2696\uFE0F", "\uD83E\uDDD1\uD83C\uDFFC\u200D\u2708\uFE0F", "\uD83E\uDDD1\uD83C\uDFFC\u200D\uD83C\uDF3E", "\uD83E\uDDD1\uD83C\uDFFC\u200D\uD83C\uDF73", "\uD83E\uDDD1\uD83C\uDFFC\u200D\uD83C\uDF7C", "\uD83E\uDDD1\uD83C\uDFFC\u200D\uD83C\uDF84", "\uD83E\uDDD1\uD83C\uDFFC\u200D\uD83C\uDF93", "\uD83E\uDDD1\uD83C\uDFFC\u200D\uD83C\uDFA4", "\uD83E\uDDD1\uD83C\uDFFC\u200D\uD83C\uDFA8", "\uD83E\uDDD1\uD83C\uDFFC\u200D\uD83C\uDFEB", "\uD83E\uDDD1\uD83C\uDFFC\u200D\uD83C\uDFED", "\uD83E\uDDD1\uD83C\uDFFC\u200D\uD83D\uDCBB", "\uD83E\uDDD1\uD83C\uDFFC\u200D\uD83D\uDCBC", "\uD83E\uDDD1\uD83C\uDFFC\u200D\uD83D\uDD27", "\uD83E\uDDD1\uD83C\uDFFC\u200D\uD83D\uDD2C", "\uD83E\uDDD1\uD83C\uDFFC\u200D\uD83D\uDE80", "\uD83E\uDDD1\uD83C\uDFFC\u200D\uD83D\uDE92", "\uD83E\uDDD1\uD83C\uDFFC\u200D\uD83E\uDDAF", "\uD83E\uDDD1\uD83C\uDFFC\u200D\uD83E\uDDAF\u200D\u27A1\uFE0F", "\uD83E\uDDD1\uD83C\uDFFC\u200D\uD83E\uDDBC", "\uD83E\uDDD1\uD83C\uDFFC\u200D\uD83E\uDDBC\u200D\u27A1\uFE0F", "\uD83E\uDDD1\uD83C\uDFFC\u200D\uD83E\uDDBD", "\uD83E\uDDD1\uD83C\uDFFC\u200D\uD83E\uDDBD\u200D\u27A1\uFE0F", "\uD83E\uDDD1\uD83C\uDFFD\u200D\u2695\uFE0F", "\uD83E\uDDD1\uD83C\uDFFD\u200D\u2696\uFE0F", "\uD83E\uDDD1\uD83C\uDFFD\u200D\u2708\uFE0F", "\uD83E\uDDD1\uD83C\uDFFD\u200D\uD83C\uDF3E", "\uD83E\uDDD1\uD83C\uDFFD\u200D\uD83C\uDF73", "\uD83E\uDDD1\uD83C\uDFFD\u200D\uD83C\uDF7C", "\uD83E\uDDD1\uD83C\uDFFD\u200D\uD83C\uDF84", "\uD83E\uDDD1\uD83C\uDFFD\u200D\uD83C\uDF93", "\uD83E\uDDD1\uD83C\uDFFD\u200D\uD83C\uDFA4", "\uD83E\uDDD1\uD83C\uDFFD\u200D\uD83C\uDFA8", "\uD83E\uDDD1\uD83C\uDFFD\u200D\uD83C\uDFEB", "\uD83E\uDDD1\uD83C\uDFFD\u200D\uD83C\uDFED", "\uD83E\uDDD1\uD83C\uDFFD\u200D\uD83D\uDCBB", "\uD83E\uDDD1\uD83C\uDFFD\u200D\uD83D\uDCBC", "\uD83E\uDDD1\uD83C\uDFFD\u200D\uD83D\uDD27", "\uD83E\uDDD1\uD83C\uDFFD\u200D\uD83D\uDD2C", "\uD83E\uDDD1\uD83C\uDFFD\u200D\uD83D\uDE80", "\uD83E\uDDD1\uD83C\uDFFD\u200D\uD83D\uDE92", "\uD83E\uDDD1\uD83C\uDFFD\u200D\uD83E\uDDAF", "\uD83E\uDDD1\uD83C\uDFFD\u200D\uD83E\uDDAF\u200D\u27A1\uFE0F", "\uD83E\uDDD1\uD83C\uDFFD\u200D\uD83E\uDDBC", "\uD83E\uDDD1\uD83C\uDFFD\u200D\uD83E\uDDBC\u200D\u27A1\uFE0F", "\uD83E\uDDD1\uD83C\uDFFD\u200D\uD83E\uDDBD", "\uD83E\uDDD1\uD83C\uDFFD\u200D\uD83E\uDDBD\u200D\u27A1\uFE0F", "\uD83E\uDDD1\uD83C\uDFFE\u200D\u2695\uFE0F", "\uD83E\uDDD1\uD83C\uDFFE\u200D\u2696\uFE0F", "\uD83E\uDDD1\uD83C\uDFFE\u200D\u2708\uFE0F", "\uD83E\uDDD1\uD83C\uDFFE\u200D\uD83C\uDF3E", "\uD83E\uDDD1\uD83C\uDFFE\u200D\uD83C\uDF73", "\uD83E\uDDD1\uD83C\uDFFE\u200D\uD83C\uDF7C", "\uD83E\uDDD1\uD83C\uDFFE\u200D\uD83C\uDF84", "\uD83E\uDDD1\uD83C\uDFFE\u200D\uD83C\uDF93", "\uD83E\uDDD1\uD83C\uDFFE\u200D\uD83C\uDFA4", "\uD83E\uDDD1\uD83C\uDFFE\u200D\uD83C\uDFA8", "\uD83E\uDDD1\uD83C\uDFFE\u200D\uD83C\uDFEB", "\uD83E\uDDD1\uD83C\uDFFE\u200D\uD83C\uDFED", "\uD83E\uDDD1\uD83C\uDFFE\u200D\uD83D\uDCBB", "\uD83E\uDDD1\uD83C\uDFFE\u200D\uD83D\uDCBC", "\uD83E\uDDD1\uD83C\uDFFE\u200D\uD83D\uDD27", "\uD83E\uDDD1\uD83C\uDFFE\u200D\uD83D\uDD2C", "\uD83E\uDDD1\uD83C\uDFFE\u200D\uD83D\uDE80", "\uD83E\uDDD1\uD83C\uDFFE\u200D\uD83D\uDE92", "\uD83E\uDDD1\uD83C\uDFFE\u200D\uD83E\uDDAF", "\uD83E\uDDD1\uD83C\uDFFE\u200D\uD83E\uDDAF\u200D\u27A1\uFE0F", "\uD83E\uDDD1\uD83C\uDFFE\u200D\uD83E\uDDBC", "\uD83E\uDDD1\uD83C\uDFFE\u200D\uD83E\uDDBC\u200D\u27A1\uFE0F", "\uD83E\uDDD1\uD83C\uDFFE\u200D\uD83E\uDDBD", "\uD83E\uDDD1\uD83C\uDFFE\u200D\uD83E\uDDBD\u200D\u27A1\uFE0F", "\uD83E\uDDD1\uD83C\uDFFF\u200D\u2695\uFE0F", "\uD83E\uDDD1\uD83C\uDFFF\u200D\u2696\uFE0F", "\uD83E\uDDD1\uD83C\uDFFF\u200D\u2708\uFE0F", "\uD83E\uDDD1\uD83C\uDFFF\u200D\uD83C\uDF3E", "\uD83E\uDDD1\uD83C\uDFFF\u200D\uD83C\uDF73", "\uD83E\uDDD1\uD83C\uDFFF\u200D\uD83C\uDF7C", "\uD83E\uDDD1\uD83C\uDFFF\u200D\uD83C\uDF84", "\uD83E\uDDD1\uD83C\uDFFF\u200D\uD83C\uDF93", "\uD83E\uDDD1\uD83C\uDFFF\u200D\uD83C\uDFA4", "\uD83E\uDDD1\uD83C\uDFFF\u200D\uD83C\uDFA8", "\uD83E\uDDD1\uD83C\uDFFF\u200D\uD83C\uDFEB", "\uD83E\uDDD1\uD83C\uDFFF\u200D\uD83C\uDFED", "\uD83E\uDDD1\uD83C\uDFFF\u200D\uD83D\uDCBB", "\uD83E\uDDD1\uD83C\uDFFF\u200D\uD83D\uDCBC", "\uD83E\uDDD1\uD83C\uDFFF\u200D\uD83D\uDD27", "\uD83E\uDDD1\uD83C\uDFFF\u200D\uD83D\uDD2C", "\uD83E\uDDD1\uD83C\uDFFF\u200D\uD83D\uDE80", "\uD83E\uDDD1\uD83C\uDFFF\u200D\uD83D\uDE92", "\uD83E\uDDD1\uD83C\uDFFF\u200D\uD83E\uDDAF", "\uD83E\uDDD1\uD83C\uDFFF\u200D\uD83E\uDDAF\u200D\u27A1\uFE0F", "\uD83E\uDDD1\uD83C\uDFFF\u200D\uD83E\uDDBC", "\uD83E\uDDD1\uD83C\uDFFF\u200D\uD83E\uDDBC\u200D\u27A1\uFE0F", "\uD83E\uDDD1\uD83C\uDFFF\u200D\uD83E\uDDBD", "\uD83E\uDDD1\uD83C\uDFFF\u200D\uD83E\uDDBD\u200D\u27A1\uFE0F", "\u26F9\uD83C\uDFFB\u200D\u2640\uFE0F", "\u26F9\uD83C\uDFFB\u200D\u2642\uFE0F", "\u26F9\uD83C\uDFFC\u200D\u2640\uFE0F", "\u26F9\uD83C\uDFFC\u200D\u2642\uFE0F", "\u26F9\uD83C\uDFFD\u200D\u2640\uFE0F", "\u26F9\uD83C\uDFFD\u200D\u2642\uFE0F", "\u26F9\uD83C\uDFFE\u200D\u2640\uFE0F", "\u26F9\uD83C\uDFFE\u200D\u2642\uFE0F", "\u26F9\uD83C\uDFFF\u200D\u2640\uFE0F", "\u26F9\uD83C\uDFFF\u200D\u2642\uFE0F", "\u26F9\uFE0F\u200D\u2640\uFE0F", "\u26F9\uFE0F\u200D\u2642\uFE0F", "\uD83C\uDFC3\u200D\u2640\uFE0F", "\uD83C\uDFC3\u200D\u2640\uFE0F\u200D\u27A1\uFE0F", "\uD83C\uDFC3\u200D\u2642\uFE0F", "\uD83C\uDFC3\u200D\u2642\uFE0F\u200D\u27A1\uFE0F", "\uD83C\uDFC3\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83C\uDFC3\uD83C\uDFFB\u200D\u2640\uFE0F\u200D\u27A1\uFE0F", "\uD83C\uDFC3\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83C\uDFC3\uD83C\uDFFB\u200D\u2642\uFE0F\u200D\u27A1\uFE0F", "\uD83C\uDFC3\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83C\uDFC3\uD83C\uDFFC\u200D\u2640\uFE0F\u200D\u27A1\uFE0F", "\uD83C\uDFC3\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83C\uDFC3\uD83C\uDFFC\u200D\u2642\uFE0F\u200D\u27A1\uFE0F", "\uD83C\uDFC3\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83C\uDFC3\uD83C\uDFFD\u200D\u2640\uFE0F\u200D\u27A1\uFE0F", "\uD83C\uDFC3\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83C\uDFC3\uD83C\uDFFD\u200D\u2642\uFE0F\u200D\u27A1\uFE0F", "\uD83C\uDFC3\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83C\uDFC3\uD83C\uDFFE\u200D\u2640\uFE0F\u200D\u27A1\uFE0F", "\uD83C\uDFC3\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83C\uDFC3\uD83C\uDFFE\u200D\u2642\uFE0F\u200D\u27A1\uFE0F", "\uD83C\uDFC3\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83C\uDFC3\uD83C\uDFFF\u200D\u2640\uFE0F\u200D\u27A1\uFE0F", "\uD83C\uDFC3\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83C\uDFC3\uD83C\uDFFF\u200D\u2642\uFE0F\u200D\u27A1\uFE0F", "\uD83C\uDFC4\u200D\u2640\uFE0F", "\uD83C\uDFC4\u200D\u2642\uFE0F", "\uD83C\uDFC4\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83C\uDFC4\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83C\uDFC4\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83C\uDFC4\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83C\uDFC4\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83C\uDFC4\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83C\uDFC4\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83C\uDFC4\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83C\uDFC4\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83C\uDFC4\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83C\uDFCA\u200D\u2640\uFE0F", "\uD83C\uDFCA\u200D\u2642\uFE0F", "\uD83C\uDFCA\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83C\uDFCA\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83C\uDFCA\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83C\uDFCA\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83C\uDFCA\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83C\uDFCA\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83C\uDFCA\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83C\uDFCA\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83C\uDFCA\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83C\uDFCA\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83C\uDFCB\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83C\uDFCB\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83C\uDFCB\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83C\uDFCB\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83C\uDFCB\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83C\uDFCB\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83C\uDFCB\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83C\uDFCB\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83C\uDFCB\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83C\uDFCB\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83C\uDFCB\uFE0F\u200D\u2640\uFE0F", "\uD83C\uDFCB\uFE0F\u200D\u2642\uFE0F", "\uD83C\uDFCC\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83C\uDFCC\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83C\uDFCC\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83C\uDFCC\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83C\uDFCC\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83C\uDFCC\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83C\uDFCC\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83C\uDFCC\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83C\uDFCC\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83C\uDFCC\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83C\uDFCC\uFE0F\u200D\u2640\uFE0F", "\uD83C\uDFCC\uFE0F\u200D\u2642\uFE0F", "\uD83D\uDC6E\u200D\u2640\uFE0F", "\uD83D\uDC6E\u200D\u2642\uFE0F", "\uD83D\uDC6E\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83D\uDC6E\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83D\uDC6E\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83D\uDC6E\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83D\uDC6E\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83D\uDC6E\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83D\uDC6E\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83D\uDC6E\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83D\uDC6E\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83D\uDC6E\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83D\uDC6F\u200D\u2640\uFE0F", "\uD83D\uDC6F\u200D\u2642\uFE0F", "\uD83D\uDC70\u200D\u2640\uFE0F", "\uD83D\uDC70\u200D\u2642\uFE0F", "\uD83D\uDC70\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83D\uDC70\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83D\uDC70\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83D\uDC70\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83D\uDC70\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83D\uDC70\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83D\uDC70\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83D\uDC70\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83D\uDC70\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83D\uDC70\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83D\uDC71\u200D\u2640\uFE0F", "\uD83D\uDC71\u200D\u2642\uFE0F", "\uD83D\uDC71\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83D\uDC71\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83D\uDC71\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83D\uDC71\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83D\uDC71\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83D\uDC71\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83D\uDC71\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83D\uDC71\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83D\uDC71\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83D\uDC71\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83D\uDC73\u200D\u2640\uFE0F", "\uD83D\uDC73\u200D\u2642\uFE0F", "\uD83D\uDC73\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83D\uDC73\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83D\uDC73\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83D\uDC73\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83D\uDC73\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83D\uDC73\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83D\uDC73\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83D\uDC73\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83D\uDC73\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83D\uDC73\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83D\uDC77\u200D\u2640\uFE0F", "\uD83D\uDC77\u200D\u2642\uFE0F", "\uD83D\uDC77\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83D\uDC77\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83D\uDC77\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83D\uDC77\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83D\uDC77\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83D\uDC77\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83D\uDC77\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83D\uDC77\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83D\uDC77\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83D\uDC77\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83D\uDC81\u200D\u2640\uFE0F", "\uD83D\uDC81\u200D\u2642\uFE0F", "\uD83D\uDC81\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83D\uDC81\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83D\uDC81\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83D\uDC81\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83D\uDC81\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83D\uDC81\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83D\uDC81\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83D\uDC81\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83D\uDC81\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83D\uDC81\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83D\uDC82\u200D\u2640\uFE0F", "\uD83D\uDC82\u200D\u2642\uFE0F", "\uD83D\uDC82\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83D\uDC82\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83D\uDC82\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83D\uDC82\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83D\uDC82\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83D\uDC82\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83D\uDC82\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83D\uDC82\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83D\uDC82\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83D\uDC82\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83D\uDC86\u200D\u2640\uFE0F", "\uD83D\uDC86\u200D\u2642\uFE0F", "\uD83D\uDC86\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83D\uDC86\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83D\uDC86\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83D\uDC86\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83D\uDC86\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83D\uDC86\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83D\uDC86\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83D\uDC86\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83D\uDC86\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83D\uDC86\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83D\uDC87\u200D\u2640\uFE0F", "\uD83D\uDC87\u200D\u2642\uFE0F", "\uD83D\uDC87\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83D\uDC87\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83D\uDC87\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83D\uDC87\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83D\uDC87\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83D\uDC87\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83D\uDC87\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83D\uDC87\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83D\uDC87\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83D\uDC87\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83D\uDD75\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83D\uDD75\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83D\uDD75\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83D\uDD75\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83D\uDD75\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83D\uDD75\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83D\uDD75\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83D\uDD75\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83D\uDD75\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83D\uDD75\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83D\uDD75\uFE0F\u200D\u2640\uFE0F", "\uD83D\uDD75\uFE0F\u200D\u2642\uFE0F", "\uD83D\uDE45\u200D\u2640\uFE0F", "\uD83D\uDE45\u200D\u2642\uFE0F", "\uD83D\uDE45\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83D\uDE45\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83D\uDE45\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83D\uDE45\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83D\uDE45\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83D\uDE45\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83D\uDE45\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83D\uDE45\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83D\uDE45\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83D\uDE45\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83D\uDE46\u200D\u2640\uFE0F", "\uD83D\uDE46\u200D\u2642\uFE0F", "\uD83D\uDE46\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83D\uDE46\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83D\uDE46\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83D\uDE46\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83D\uDE46\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83D\uDE46\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83D\uDE46\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83D\uDE46\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83D\uDE46\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83D\uDE46\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83D\uDE47\u200D\u2640\uFE0F", "\uD83D\uDE47\u200D\u2642\uFE0F", "\uD83D\uDE47\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83D\uDE47\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83D\uDE47\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83D\uDE47\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83D\uDE47\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83D\uDE47\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83D\uDE47\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83D\uDE47\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83D\uDE47\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83D\uDE47\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83D\uDE4B\u200D\u2640\uFE0F", "\uD83D\uDE4B\u200D\u2642\uFE0F", "\uD83D\uDE4B\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83D\uDE4B\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83D\uDE4B\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83D\uDE4B\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83D\uDE4B\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83D\uDE4B\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83D\uDE4B\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83D\uDE4B\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83D\uDE4B\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83D\uDE4B\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83D\uDE4D\u200D\u2640\uFE0F", "\uD83D\uDE4D\u200D\u2642\uFE0F", "\uD83D\uDE4D\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83D\uDE4D\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83D\uDE4D\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83D\uDE4D\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83D\uDE4D\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83D\uDE4D\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83D\uDE4D\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83D\uDE4D\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83D\uDE4D\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83D\uDE4D\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83D\uDE4E\u200D\u2640\uFE0F", "\uD83D\uDE4E\u200D\u2642\uFE0F", "\uD83D\uDE4E\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83D\uDE4E\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83D\uDE4E\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83D\uDE4E\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83D\uDE4E\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83D\uDE4E\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83D\uDE4E\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83D\uDE4E\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83D\uDE4E\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83D\uDE4E\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83D\uDEA3\u200D\u2640\uFE0F", "\uD83D\uDEA3\u200D\u2642\uFE0F", "\uD83D\uDEA3\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83D\uDEA3\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83D\uDEA3\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83D\uDEA3\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83D\uDEA3\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83D\uDEA3\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83D\uDEA3\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83D\uDEA3\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83D\uDEA3\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83D\uDEA3\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83D\uDEB4\u200D\u2640\uFE0F", "\uD83D\uDEB4\u200D\u2642\uFE0F", "\uD83D\uDEB4\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83D\uDEB4\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83D\uDEB4\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83D\uDEB4\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83D\uDEB4\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83D\uDEB4\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83D\uDEB4\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83D\uDEB4\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83D\uDEB4\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83D\uDEB4\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83D\uDEB5\u200D\u2640\uFE0F", "\uD83D\uDEB5\u200D\u2642\uFE0F", "\uD83D\uDEB5\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83D\uDEB5\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83D\uDEB5\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83D\uDEB5\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83D\uDEB5\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83D\uDEB5\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83D\uDEB5\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83D\uDEB5\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83D\uDEB5\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83D\uDEB5\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83D\uDEB6\u200D\u2640\uFE0F", "\uD83D\uDEB6\u200D\u2640\uFE0F\u200D\u27A1\uFE0F", "\uD83D\uDEB6\u200D\u2642\uFE0F", "\uD83D\uDEB6\u200D\u2642\uFE0F\u200D\u27A1\uFE0F", "\uD83D\uDEB6\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83D\uDEB6\uD83C\uDFFB\u200D\u2640\uFE0F\u200D\u27A1\uFE0F", "\uD83D\uDEB6\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83D\uDEB6\uD83C\uDFFB\u200D\u2642\uFE0F\u200D\u27A1\uFE0F", "\uD83D\uDEB6\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83D\uDEB6\uD83C\uDFFC\u200D\u2640\uFE0F\u200D\u27A1\uFE0F", "\uD83D\uDEB6\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83D\uDEB6\uD83C\uDFFC\u200D\u2642\uFE0F\u200D\u27A1\uFE0F", "\uD83D\uDEB6\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83D\uDEB6\uD83C\uDFFD\u200D\u2640\uFE0F\u200D\u27A1\uFE0F", "\uD83D\uDEB6\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83D\uDEB6\uD83C\uDFFD\u200D\u2642\uFE0F\u200D\u27A1\uFE0F", "\uD83D\uDEB6\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83D\uDEB6\uD83C\uDFFE\u200D\u2640\uFE0F\u200D\u27A1\uFE0F", "\uD83D\uDEB6\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83D\uDEB6\uD83C\uDFFE\u200D\u2642\uFE0F\u200D\u27A1\uFE0F", "\uD83D\uDEB6\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83D\uDEB6\uD83C\uDFFF\u200D\u2640\uFE0F\u200D\u27A1\uFE0F", "\uD83D\uDEB6\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83D\uDEB6\uD83C\uDFFF\u200D\u2642\uFE0F\u200D\u27A1\uFE0F", "\uD83E\uDD26\u200D\u2640\uFE0F", "\uD83E\uDD26\u200D\u2642\uFE0F", "\uD83E\uDD26\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83E\uDD26\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83E\uDD26\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83E\uDD26\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83E\uDD26\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83E\uDD26\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83E\uDD26\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83E\uDD26\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83E\uDD26\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83E\uDD26\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83E\uDD35\u200D\u2640\uFE0F", "\uD83E\uDD35\u200D\u2642\uFE0F", "\uD83E\uDD35\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83E\uDD35\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83E\uDD35\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83E\uDD35\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83E\uDD35\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83E\uDD35\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83E\uDD35\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83E\uDD35\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83E\uDD35\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83E\uDD35\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83E\uDD37\u200D\u2640\uFE0F", "\uD83E\uDD37\u200D\u2642\uFE0F", "\uD83E\uDD37\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83E\uDD37\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83E\uDD37\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83E\uDD37\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83E\uDD37\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83E\uDD37\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83E\uDD37\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83E\uDD37\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83E\uDD37\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83E\uDD37\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83E\uDD38\u200D\u2640\uFE0F", "\uD83E\uDD38\u200D\u2642\uFE0F", "\uD83E\uDD38\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83E\uDD38\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83E\uDD38\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83E\uDD38\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83E\uDD38\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83E\uDD38\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83E\uDD38\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83E\uDD38\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83E\uDD38\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83E\uDD38\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83E\uDD39\u200D\u2640\uFE0F", "\uD83E\uDD39\u200D\u2642\uFE0F", "\uD83E\uDD39\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83E\uDD39\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83E\uDD39\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83E\uDD39\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83E\uDD39\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83E\uDD39\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83E\uDD39\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83E\uDD39\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83E\uDD39\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83E\uDD39\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83E\uDD3C\u200D\u2640\uFE0F", "\uD83E\uDD3C\u200D\u2642\uFE0F", "\uD83E\uDD3D\u200D\u2640\uFE0F", "\uD83E\uDD3D\u200D\u2642\uFE0F", "\uD83E\uDD3D\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83E\uDD3D\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83E\uDD3D\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83E\uDD3D\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83E\uDD3D\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83E\uDD3D\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83E\uDD3D\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83E\uDD3D\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83E\uDD3D\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83E\uDD3D\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83E\uDD3E\u200D\u2640\uFE0F", "\uD83E\uDD3E\u200D\u2642\uFE0F", "\uD83E\uDD3E\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83E\uDD3E\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83E\uDD3E\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83E\uDD3E\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83E\uDD3E\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83E\uDD3E\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83E\uDD3E\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83E\uDD3E\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83E\uDD3E\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83E\uDD3E\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83E\uDDB8\u200D\u2640\uFE0F", "\uD83E\uDDB8\u200D\u2642\uFE0F", "\uD83E\uDDB8\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83E\uDDB8\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83E\uDDB8\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83E\uDDB8\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83E\uDDB8\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83E\uDDB8\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83E\uDDB8\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83E\uDDB8\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83E\uDDB8\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83E\uDDB8\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83E\uDDB9\u200D\u2640\uFE0F", "\uD83E\uDDB9\u200D\u2642\uFE0F", "\uD83E\uDDB9\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83E\uDDB9\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83E\uDDB9\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83E\uDDB9\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83E\uDDB9\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83E\uDDB9\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83E\uDDB9\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83E\uDDB9\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83E\uDDB9\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83E\uDDB9\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83E\uDDCD\u200D\u2640\uFE0F", "\uD83E\uDDCD\u200D\u2642\uFE0F", "\uD83E\uDDCD\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83E\uDDCD\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83E\uDDCD\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83E\uDDCD\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83E\uDDCD\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83E\uDDCD\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83E\uDDCD\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83E\uDDCD\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83E\uDDCD\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83E\uDDCD\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83E\uDDCE\u200D\u2640\uFE0F", "\uD83E\uDDCE\u200D\u2640\uFE0F\u200D\u27A1\uFE0F", "\uD83E\uDDCE\u200D\u2642\uFE0F", "\uD83E\uDDCE\u200D\u2642\uFE0F\u200D\u27A1\uFE0F", "\uD83E\uDDCE\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83E\uDDCE\uD83C\uDFFB\u200D\u2640\uFE0F\u200D\u27A1\uFE0F", "\uD83E\uDDCE\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83E\uDDCE\uD83C\uDFFB\u200D\u2642\uFE0F\u200D\u27A1\uFE0F", "\uD83E\uDDCE\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83E\uDDCE\uD83C\uDFFC\u200D\u2640\uFE0F\u200D\u27A1\uFE0F", "\uD83E\uDDCE\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83E\uDDCE\uD83C\uDFFC\u200D\u2642\uFE0F\u200D\u27A1\uFE0F", "\uD83E\uDDCE\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83E\uDDCE\uD83C\uDFFD\u200D\u2640\uFE0F\u200D\u27A1\uFE0F", "\uD83E\uDDCE\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83E\uDDCE\uD83C\uDFFD\u200D\u2642\uFE0F\u200D\u27A1\uFE0F", "\uD83E\uDDCE\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83E\uDDCE\uD83C\uDFFE\u200D\u2640\uFE0F\u200D\u27A1\uFE0F", "\uD83E\uDDCE\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83E\uDDCE\uD83C\uDFFE\u200D\u2642\uFE0F\u200D\u27A1\uFE0F", "\uD83E\uDDCE\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83E\uDDCE\uD83C\uDFFF\u200D\u2640\uFE0F\u200D\u27A1\uFE0F", "\uD83E\uDDCE\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83E\uDDCE\uD83C\uDFFF\u200D\u2642\uFE0F\u200D\u27A1\uFE0F", "\uD83E\uDDCF\u200D\u2640\uFE0F", "\uD83E\uDDCF\u200D\u2642\uFE0F", "\uD83E\uDDCF\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83E\uDDCF\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83E\uDDCF\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83E\uDDCF\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83E\uDDCF\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83E\uDDCF\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83E\uDDCF\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83E\uDDCF\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83E\uDDCF\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83E\uDDCF\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83E\uDDD4\u200D\u2640\uFE0F", "\uD83E\uDDD4\u200D\u2642\uFE0F", "\uD83E\uDDD4\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83E\uDDD4\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83E\uDDD4\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83E\uDDD4\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83E\uDDD4\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83E\uDDD4\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83E\uDDD4\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83E\uDDD4\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83E\uDDD4\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83E\uDDD4\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83E\uDDD6\u200D\u2640\uFE0F", "\uD83E\uDDD6\u200D\u2642\uFE0F", "\uD83E\uDDD6\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83E\uDDD6\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83E\uDDD6\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83E\uDDD6\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83E\uDDD6\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83E\uDDD6\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83E\uDDD6\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83E\uDDD6\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83E\uDDD6\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83E\uDDD6\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83E\uDDD7\u200D\u2640\uFE0F", "\uD83E\uDDD7\u200D\u2642\uFE0F", "\uD83E\uDDD7\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83E\uDDD7\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83E\uDDD7\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83E\uDDD7\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83E\uDDD7\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83E\uDDD7\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83E\uDDD7\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83E\uDDD7\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83E\uDDD7\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83E\uDDD7\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83E\uDDD8\u200D\u2640\uFE0F", "\uD83E\uDDD8\u200D\u2642\uFE0F", "\uD83E\uDDD8\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83E\uDDD8\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83E\uDDD8\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83E\uDDD8\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83E\uDDD8\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83E\uDDD8\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83E\uDDD8\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83E\uDDD8\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83E\uDDD8\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83E\uDDD8\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83E\uDDD9\u200D\u2640\uFE0F", "\uD83E\uDDD9\u200D\u2642\uFE0F", "\uD83E\uDDD9\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83E\uDDD9\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83E\uDDD9\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83E\uDDD9\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83E\uDDD9\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83E\uDDD9\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83E\uDDD9\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83E\uDDD9\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83E\uDDD9\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83E\uDDD9\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83E\uDDDA\u200D\u2640\uFE0F", "\uD83E\uDDDA\u200D\u2642\uFE0F", "\uD83E\uDDDA\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83E\uDDDA\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83E\uDDDA\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83E\uDDDA\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83E\uDDDA\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83E\uDDDA\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83E\uDDDA\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83E\uDDDA\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83E\uDDDA\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83E\uDDDA\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83E\uDDDB\u200D\u2640\uFE0F", "\uD83E\uDDDB\u200D\u2642\uFE0F", "\uD83E\uDDDB\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83E\uDDDB\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83E\uDDDB\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83E\uDDDB\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83E\uDDDB\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83E\uDDDB\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83E\uDDDB\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83E\uDDDB\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83E\uDDDB\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83E\uDDDB\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83E\uDDDC\u200D\u2640\uFE0F", "\uD83E\uDDDC\u200D\u2642\uFE0F", "\uD83E\uDDDC\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83E\uDDDC\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83E\uDDDC\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83E\uDDDC\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83E\uDDDC\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83E\uDDDC\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83E\uDDDC\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83E\uDDDC\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83E\uDDDC\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83E\uDDDC\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83E\uDDDD\u200D\u2640\uFE0F", "\uD83E\uDDDD\u200D\u2642\uFE0F", "\uD83E\uDDDD\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83E\uDDDD\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83E\uDDDD\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83E\uDDDD\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83E\uDDDD\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83E\uDDDD\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83E\uDDDD\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83E\uDDDD\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83E\uDDDD\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83E\uDDDD\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83E\uDDDE\u200D\u2640\uFE0F", "\uD83E\uDDDE\u200D\u2642\uFE0F", "\uD83E\uDDDF\u200D\u2640\uFE0F", "\uD83E\uDDDF\u200D\u2642\uFE0F", "\uD83D\uDC68\u200D\uD83E\uDDB0", "\uD83D\uDC68\u200D\uD83E\uDDB1", "\uD83D\uDC68\u200D\uD83E\uDDB2", "\uD83D\uDC68\u200D\uD83E\uDDB3", "\uD83D\uDC68\uD83C\uDFFB\u200D\uD83E\uDDB0", "\uD83D\uDC68\uD83C\uDFFB\u200D\uD83E\uDDB1", "\uD83D\uDC68\uD83C\uDFFB\u200D\uD83E\uDDB2", "\uD83D\uDC68\uD83C\uDFFB\u200D\uD83E\uDDB3", "\uD83D\uDC68\uD83C\uDFFC\u200D\uD83E\uDDB0", "\uD83D\uDC68\uD83C\uDFFC\u200D\uD83E\uDDB1", "\uD83D\uDC68\uD83C\uDFFC\u200D\uD83E\uDDB2", "\uD83D\uDC68\uD83C\uDFFC\u200D\uD83E\uDDB3", "\uD83D\uDC68\uD83C\uDFFD\u200D\uD83E\uDDB0", "\uD83D\uDC68\uD83C\uDFFD\u200D\uD83E\uDDB1", "\uD83D\uDC68\uD83C\uDFFD\u200D\uD83E\uDDB2", "\uD83D\uDC68\uD83C\uDFFD\u200D\uD83E\uDDB3", "\uD83D\uDC68\uD83C\uDFFE\u200D\uD83E\uDDB0", "\uD83D\uDC68\uD83C\uDFFE\u200D\uD83E\uDDB1", "\uD83D\uDC68\uD83C\uDFFE\u200D\uD83E\uDDB2", "\uD83D\uDC68\uD83C\uDFFE\u200D\uD83E\uDDB3", "\uD83D\uDC68\uD83C\uDFFF\u200D\uD83E\uDDB0", "\uD83D\uDC68\uD83C\uDFFF\u200D\uD83E\uDDB1", "\uD83D\uDC68\uD83C\uDFFF\u200D\uD83E\uDDB2", "\uD83D\uDC68\uD83C\uDFFF\u200D\uD83E\uDDB3", "\uD83D\uDC69\u200D\uD83E\uDDB0", "\uD83D\uDC69\u200D\uD83E\uDDB1", "\uD83D\uDC69\u200D\uD83E\uDDB2", "\uD83D\uDC69\u200D\uD83E\uDDB3", "\uD83D\uDC69\uD83C\uDFFB\u200D\uD83E\uDDB0", "\uD83D\uDC69\uD83C\uDFFB\u200D\uD83E\uDDB1", "\uD83D\uDC69\uD83C\uDFFB\u200D\uD83E\uDDB2", "\uD83D\uDC69\uD83C\uDFFB\u200D\uD83E\uDDB3", "\uD83D\uDC69\uD83C\uDFFC\u200D\uD83E\uDDB0", "\uD83D\uDC69\uD83C\uDFFC\u200D\uD83E\uDDB1", "\uD83D\uDC69\uD83C\uDFFC\u200D\uD83E\uDDB2", "\uD83D\uDC69\uD83C\uDFFC\u200D\uD83E\uDDB3", "\uD83D\uDC69\uD83C\uDFFD\u200D\uD83E\uDDB0", "\uD83D\uDC69\uD83C\uDFFD\u200D\uD83E\uDDB1", "\uD83D\uDC69\uD83C\uDFFD\u200D\uD83E\uDDB2", "\uD83D\uDC69\uD83C\uDFFD\u200D\uD83E\uDDB3", "\uD83D\uDC69\uD83C\uDFFE\u200D\uD83E\uDDB0", "\uD83D\uDC69\uD83C\uDFFE\u200D\uD83E\uDDB1", "\uD83D\uDC69\uD83C\uDFFE\u200D\uD83E\uDDB2", "\uD83D\uDC69\uD83C\uDFFE\u200D\uD83E\uDDB3", "\uD83D\uDC69\uD83C\uDFFF\u200D\uD83E\uDDB0", "\uD83D\uDC69\uD83C\uDFFF\u200D\uD83E\uDDB1", "\uD83D\uDC69\uD83C\uDFFF\u200D\uD83E\uDDB2", "\uD83D\uDC69\uD83C\uDFFF\u200D\uD83E\uDDB3", "\uD83E\uDDD1\u200D\uD83E\uDDB0", "\uD83E\uDDD1\u200D\uD83E\uDDB1", "\uD83E\uDDD1\u200D\uD83E\uDDB2", "\uD83E\uDDD1\u200D\uD83E\uDDB3", "\uD83E\uDDD1\uD83C\uDFFB\u200D\uD83E\uDDB0", "\uD83E\uDDD1\uD83C\uDFFB\u200D\uD83E\uDDB1", "\uD83E\uDDD1\uD83C\uDFFB\u200D\uD83E\uDDB2", "\uD83E\uDDD1\uD83C\uDFFB\u200D\uD83E\uDDB3", "\uD83E\uDDD1\uD83C\uDFFC\u200D\uD83E\uDDB0", "\uD83E\uDDD1\uD83C\uDFFC\u200D\uD83E\uDDB1", "\uD83E\uDDD1\uD83C\uDFFC\u200D\uD83E\uDDB2", "\uD83E\uDDD1\uD83C\uDFFC\u200D\uD83E\uDDB3", "\uD83E\uDDD1\uD83C\uDFFD\u200D\uD83E\uDDB0", "\uD83E\uDDD1\uD83C\uDFFD\u200D\uD83E\uDDB1", "\uD83E\uDDD1\uD83C\uDFFD\u200D\uD83E\uDDB2", "\uD83E\uDDD1\uD83C\uDFFD\u200D\uD83E\uDDB3", "\uD83E\uDDD1\uD83C\uDFFE\u200D\uD83E\uDDB0", "\uD83E\uDDD1\uD83C\uDFFE\u200D\uD83E\uDDB1", "\uD83E\uDDD1\uD83C\uDFFE\u200D\uD83E\uDDB2", "\uD83E\uDDD1\uD83C\uDFFE\u200D\uD83E\uDDB3", "\uD83E\uDDD1\uD83C\uDFFF\u200D\uD83E\uDDB0", "\uD83E\uDDD1\uD83C\uDFFF\u200D\uD83E\uDDB1", "\uD83E\uDDD1\uD83C\uDFFF\u200D\uD83E\uDDB2", "\uD83E\uDDD1\uD83C\uDFFF\u200D\uD83E\uDDB3", "\u26D3\uFE0F\u200D\uD83D\uDCA5", "\u2764\uFE0F\u200D\uD83D\uDD25", "\u2764\uFE0F\u200D\uD83E\uDE79", "\uD83C\uDF44\u200D\uD83D\uDFEB", "\uD83C\uDF4B\u200D\uD83D\uDFE9", "\uD83C\uDFF3\uFE0F\u200D\u26A7\uFE0F", "\uD83C\uDFF3\uFE0F\u200D\uD83C\uDF08", "\uD83C\uDFF4\u200D\u2620\uFE0F", "\uD83D\uDC08\u200D\u2B1B", "\uD83D\uDC15\u200D\uD83E\uDDBA", "\uD83D\uDC26\u200D\u2B1B", "\uD83D\uDC26\u200D\uD83D\uDD25", "\uD83D\uDC3B\u200D\u2744\uFE0F", "\uD83D\uDC41\uFE0F\u200D\uD83D\uDDE8\uFE0F", "\uD83D\uDE2E\u200D\uD83D\uDCA8", "\uD83D\uDE35\u200D\uD83D\uDCAB", "\uD83D\uDE36\u200D\uD83C\uDF2B\uFE0F", "\uD83D\uDE42\u200D\u2194\uFE0F", "\uD83D\uDE42\u200D\u2195\uFE0F"];
		    return RGI_Emoji_ZWJ_Sequence;
		  }

		  var RGI_Emoji = {};

		  var hasRequiredRGI_Emoji;
		  function requireRGI_Emoji() {
		    if (hasRequiredRGI_Emoji) return RGI_Emoji;
		    hasRequiredRGI_Emoji = 1;
		    var set = regenerateExports(0x23F0, 0x23F3, 0x267F, 0x2693, 0x26A1, 0x26CE, 0x26D4, 0x26EA, 0x26F5, 0x26FA, 0x26FD, 0x2705, 0x2728, 0x274C, 0x274E, 0x2757, 0x27B0, 0x27BF, 0x2B50, 0x2B55, 0x1F004, 0x1F0CF, 0x1F18E, 0x1F201, 0x1F21A, 0x1F22F, 0x1F3F4, 0x1F440, 0x1F57A, 0x1F5A4, 0x1F6CC, 0x1F7F0);
		    set.addRange(0x231A, 0x231B).addRange(0x23E9, 0x23EC).addRange(0x25FD, 0x25FE).addRange(0x2614, 0x2615).addRange(0x2648, 0x2653).addRange(0x26AA, 0x26AB).addRange(0x26BD, 0x26BE).addRange(0x26C4, 0x26C5).addRange(0x26F2, 0x26F3).addRange(0x270A, 0x270B).addRange(0x2753, 0x2755).addRange(0x2795, 0x2797).addRange(0x2B1B, 0x2B1C).addRange(0x1F191, 0x1F19A).addRange(0x1F232, 0x1F236).addRange(0x1F238, 0x1F23A).addRange(0x1F250, 0x1F251).addRange(0x1F300, 0x1F320).addRange(0x1F32D, 0x1F335).addRange(0x1F337, 0x1F37C).addRange(0x1F37E, 0x1F393).addRange(0x1F3A0, 0x1F3CA).addRange(0x1F3CF, 0x1F3D3).addRange(0x1F3E0, 0x1F3F0).addRange(0x1F3F8, 0x1F43E).addRange(0x1F442, 0x1F4FC).addRange(0x1F4FF, 0x1F53D).addRange(0x1F54B, 0x1F54E).addRange(0x1F550, 0x1F567).addRange(0x1F595, 0x1F596).addRange(0x1F5FB, 0x1F64F).addRange(0x1F680, 0x1F6C5).addRange(0x1F6D0, 0x1F6D2).addRange(0x1F6D5, 0x1F6D7).addRange(0x1F6DC, 0x1F6DF).addRange(0x1F6EB, 0x1F6EC).addRange(0x1F6F4, 0x1F6FC).addRange(0x1F7E0, 0x1F7EB).addRange(0x1F90C, 0x1F93A).addRange(0x1F93C, 0x1F945).addRange(0x1F947, 0x1F9FF).addRange(0x1FA70, 0x1FA7C).addRange(0x1FA80, 0x1FA88).addRange(0x1FA90, 0x1FABD).addRange(0x1FABF, 0x1FAC5).addRange(0x1FACE, 0x1FADB).addRange(0x1FAE0, 0x1FAE8).addRange(0x1FAF0, 0x1FAF8);
		    RGI_Emoji.characters = set;
		    RGI_Emoji.strings = ["#\uFE0F\u20E3", "*\uFE0F\u20E3", "0\uFE0F\u20E3", "1\uFE0F\u20E3", "2\uFE0F\u20E3", "3\uFE0F\u20E3", "4\uFE0F\u20E3", "5\uFE0F\u20E3", "6\uFE0F\u20E3", "7\uFE0F\u20E3", "8\uFE0F\u20E3", "9\uFE0F\u20E3", "\xA9\uFE0F", "\xAE\uFE0F", "\u203C\uFE0F", "\u2049\uFE0F", "\u2122\uFE0F", "\u2139\uFE0F", "\u2194\uFE0F", "\u2195\uFE0F", "\u2196\uFE0F", "\u2197\uFE0F", "\u2198\uFE0F", "\u2199\uFE0F", "\u21A9\uFE0F", "\u21AA\uFE0F", "\u2328\uFE0F", "\u23CF\uFE0F", "\u23ED\uFE0F", "\u23EE\uFE0F", "\u23EF\uFE0F", "\u23F1\uFE0F", "\u23F2\uFE0F", "\u23F8\uFE0F", "\u23F9\uFE0F", "\u23FA\uFE0F", "\u24C2\uFE0F", "\u25AA\uFE0F", "\u25AB\uFE0F", "\u25B6\uFE0F", "\u25C0\uFE0F", "\u25FB\uFE0F", "\u25FC\uFE0F", "\u2600\uFE0F", "\u2601\uFE0F", "\u2602\uFE0F", "\u2603\uFE0F", "\u2604\uFE0F", "\u260E\uFE0F", "\u2611\uFE0F", "\u2618\uFE0F", "\u261D\uD83C\uDFFB", "\u261D\uD83C\uDFFC", "\u261D\uD83C\uDFFD", "\u261D\uD83C\uDFFE", "\u261D\uD83C\uDFFF", "\u261D\uFE0F", "\u2620\uFE0F", "\u2622\uFE0F", "\u2623\uFE0F", "\u2626\uFE0F", "\u262A\uFE0F", "\u262E\uFE0F", "\u262F\uFE0F", "\u2638\uFE0F", "\u2639\uFE0F", "\u263A\uFE0F", "\u2640\uFE0F", "\u2642\uFE0F", "\u265F\uFE0F", "\u2660\uFE0F", "\u2663\uFE0F", "\u2665\uFE0F", "\u2666\uFE0F", "\u2668\uFE0F", "\u267B\uFE0F", "\u267E\uFE0F", "\u2692\uFE0F", "\u2694\uFE0F", "\u2695\uFE0F", "\u2696\uFE0F", "\u2697\uFE0F", "\u2699\uFE0F", "\u269B\uFE0F", "\u269C\uFE0F", "\u26A0\uFE0F", "\u26A7\uFE0F", "\u26B0\uFE0F", "\u26B1\uFE0F", "\u26C8\uFE0F", "\u26CF\uFE0F", "\u26D1\uFE0F", "\u26D3\uFE0F", "\u26D3\uFE0F\u200D\uD83D\uDCA5", "\u26E9\uFE0F", "\u26F0\uFE0F", "\u26F1\uFE0F", "\u26F4\uFE0F", "\u26F7\uFE0F", "\u26F8\uFE0F", "\u26F9\uD83C\uDFFB", "\u26F9\uD83C\uDFFB\u200D\u2640\uFE0F", "\u26F9\uD83C\uDFFB\u200D\u2642\uFE0F", "\u26F9\uD83C\uDFFC", "\u26F9\uD83C\uDFFC\u200D\u2640\uFE0F", "\u26F9\uD83C\uDFFC\u200D\u2642\uFE0F", "\u26F9\uD83C\uDFFD", "\u26F9\uD83C\uDFFD\u200D\u2640\uFE0F", "\u26F9\uD83C\uDFFD\u200D\u2642\uFE0F", "\u26F9\uD83C\uDFFE", "\u26F9\uD83C\uDFFE\u200D\u2640\uFE0F", "\u26F9\uD83C\uDFFE\u200D\u2642\uFE0F", "\u26F9\uD83C\uDFFF", "\u26F9\uD83C\uDFFF\u200D\u2640\uFE0F", "\u26F9\uD83C\uDFFF\u200D\u2642\uFE0F", "\u26F9\uFE0F", "\u26F9\uFE0F\u200D\u2640\uFE0F", "\u26F9\uFE0F\u200D\u2642\uFE0F", "\u2702\uFE0F", "\u2708\uFE0F", "\u2709\uFE0F", "\u270A\uD83C\uDFFB", "\u270A\uD83C\uDFFC", "\u270A\uD83C\uDFFD", "\u270A\uD83C\uDFFE", "\u270A\uD83C\uDFFF", "\u270B\uD83C\uDFFB", "\u270B\uD83C\uDFFC", "\u270B\uD83C\uDFFD", "\u270B\uD83C\uDFFE", "\u270B\uD83C\uDFFF", "\u270C\uD83C\uDFFB", "\u270C\uD83C\uDFFC", "\u270C\uD83C\uDFFD", "\u270C\uD83C\uDFFE", "\u270C\uD83C\uDFFF", "\u270C\uFE0F", "\u270D\uD83C\uDFFB", "\u270D\uD83C\uDFFC", "\u270D\uD83C\uDFFD", "\u270D\uD83C\uDFFE", "\u270D\uD83C\uDFFF", "\u270D\uFE0F", "\u270F\uFE0F", "\u2712\uFE0F", "\u2714\uFE0F", "\u2716\uFE0F", "\u271D\uFE0F", "\u2721\uFE0F", "\u2733\uFE0F", "\u2734\uFE0F", "\u2744\uFE0F", "\u2747\uFE0F", "\u2763\uFE0F", "\u2764\uFE0F", "\u2764\uFE0F\u200D\uD83D\uDD25", "\u2764\uFE0F\u200D\uD83E\uDE79", "\u27A1\uFE0F", "\u2934\uFE0F", "\u2935\uFE0F", "\u2B05\uFE0F", "\u2B06\uFE0F", "\u2B07\uFE0F", "\u3030\uFE0F", "\u303D\uFE0F", "\u3297\uFE0F", "\u3299\uFE0F", "\uD83C\uDD70\uFE0F", "\uD83C\uDD71\uFE0F", "\uD83C\uDD7E\uFE0F", "\uD83C\uDD7F\uFE0F", "\uD83C\uDDE6\uD83C\uDDE8", "\uD83C\uDDE6\uD83C\uDDE9", "\uD83C\uDDE6\uD83C\uDDEA", "\uD83C\uDDE6\uD83C\uDDEB", "\uD83C\uDDE6\uD83C\uDDEC", "\uD83C\uDDE6\uD83C\uDDEE", "\uD83C\uDDE6\uD83C\uDDF1", "\uD83C\uDDE6\uD83C\uDDF2", "\uD83C\uDDE6\uD83C\uDDF4", "\uD83C\uDDE6\uD83C\uDDF6", "\uD83C\uDDE6\uD83C\uDDF7", "\uD83C\uDDE6\uD83C\uDDF8", "\uD83C\uDDE6\uD83C\uDDF9", "\uD83C\uDDE6\uD83C\uDDFA", "\uD83C\uDDE6\uD83C\uDDFC", "\uD83C\uDDE6\uD83C\uDDFD", "\uD83C\uDDE6\uD83C\uDDFF", "\uD83C\uDDE7\uD83C\uDDE6", "\uD83C\uDDE7\uD83C\uDDE7", "\uD83C\uDDE7\uD83C\uDDE9", "\uD83C\uDDE7\uD83C\uDDEA", "\uD83C\uDDE7\uD83C\uDDEB", "\uD83C\uDDE7\uD83C\uDDEC", "\uD83C\uDDE7\uD83C\uDDED", "\uD83C\uDDE7\uD83C\uDDEE", "\uD83C\uDDE7\uD83C\uDDEF", "\uD83C\uDDE7\uD83C\uDDF1", "\uD83C\uDDE7\uD83C\uDDF2", "\uD83C\uDDE7\uD83C\uDDF3", "\uD83C\uDDE7\uD83C\uDDF4", "\uD83C\uDDE7\uD83C\uDDF6", "\uD83C\uDDE7\uD83C\uDDF7", "\uD83C\uDDE7\uD83C\uDDF8", "\uD83C\uDDE7\uD83C\uDDF9", "\uD83C\uDDE7\uD83C\uDDFB", "\uD83C\uDDE7\uD83C\uDDFC", "\uD83C\uDDE7\uD83C\uDDFE", "\uD83C\uDDE7\uD83C\uDDFF", "\uD83C\uDDE8\uD83C\uDDE6", "\uD83C\uDDE8\uD83C\uDDE8", "\uD83C\uDDE8\uD83C\uDDE9", "\uD83C\uDDE8\uD83C\uDDEB", "\uD83C\uDDE8\uD83C\uDDEC", "\uD83C\uDDE8\uD83C\uDDED", "\uD83C\uDDE8\uD83C\uDDEE", "\uD83C\uDDE8\uD83C\uDDF0", "\uD83C\uDDE8\uD83C\uDDF1", "\uD83C\uDDE8\uD83C\uDDF2", "\uD83C\uDDE8\uD83C\uDDF3", "\uD83C\uDDE8\uD83C\uDDF4", "\uD83C\uDDE8\uD83C\uDDF5", "\uD83C\uDDE8\uD83C\uDDF7", "\uD83C\uDDE8\uD83C\uDDFA", "\uD83C\uDDE8\uD83C\uDDFB", "\uD83C\uDDE8\uD83C\uDDFC", "\uD83C\uDDE8\uD83C\uDDFD", "\uD83C\uDDE8\uD83C\uDDFE", "\uD83C\uDDE8\uD83C\uDDFF", "\uD83C\uDDE9\uD83C\uDDEA", "\uD83C\uDDE9\uD83C\uDDEC", "\uD83C\uDDE9\uD83C\uDDEF", "\uD83C\uDDE9\uD83C\uDDF0", "\uD83C\uDDE9\uD83C\uDDF2", "\uD83C\uDDE9\uD83C\uDDF4", "\uD83C\uDDE9\uD83C\uDDFF", "\uD83C\uDDEA\uD83C\uDDE6", "\uD83C\uDDEA\uD83C\uDDE8", "\uD83C\uDDEA\uD83C\uDDEA", "\uD83C\uDDEA\uD83C\uDDEC", "\uD83C\uDDEA\uD83C\uDDED", "\uD83C\uDDEA\uD83C\uDDF7", "\uD83C\uDDEA\uD83C\uDDF8", "\uD83C\uDDEA\uD83C\uDDF9", "\uD83C\uDDEA\uD83C\uDDFA", "\uD83C\uDDEB\uD83C\uDDEE", "\uD83C\uDDEB\uD83C\uDDEF", "\uD83C\uDDEB\uD83C\uDDF0", "\uD83C\uDDEB\uD83C\uDDF2", "\uD83C\uDDEB\uD83C\uDDF4", "\uD83C\uDDEB\uD83C\uDDF7", "\uD83C\uDDEC\uD83C\uDDE6", "\uD83C\uDDEC\uD83C\uDDE7", "\uD83C\uDDEC\uD83C\uDDE9", "\uD83C\uDDEC\uD83C\uDDEA", "\uD83C\uDDEC\uD83C\uDDEB", "\uD83C\uDDEC\uD83C\uDDEC", "\uD83C\uDDEC\uD83C\uDDED", "\uD83C\uDDEC\uD83C\uDDEE", "\uD83C\uDDEC\uD83C\uDDF1", "\uD83C\uDDEC\uD83C\uDDF2", "\uD83C\uDDEC\uD83C\uDDF3", "\uD83C\uDDEC\uD83C\uDDF5", "\uD83C\uDDEC\uD83C\uDDF6", "\uD83C\uDDEC\uD83C\uDDF7", "\uD83C\uDDEC\uD83C\uDDF8", "\uD83C\uDDEC\uD83C\uDDF9", "\uD83C\uDDEC\uD83C\uDDFA", "\uD83C\uDDEC\uD83C\uDDFC", "\uD83C\uDDEC\uD83C\uDDFE", "\uD83C\uDDED\uD83C\uDDF0", "\uD83C\uDDED\uD83C\uDDF2", "\uD83C\uDDED\uD83C\uDDF3", "\uD83C\uDDED\uD83C\uDDF7", "\uD83C\uDDED\uD83C\uDDF9", "\uD83C\uDDED\uD83C\uDDFA", "\uD83C\uDDEE\uD83C\uDDE8", "\uD83C\uDDEE\uD83C\uDDE9", "\uD83C\uDDEE\uD83C\uDDEA", "\uD83C\uDDEE\uD83C\uDDF1", "\uD83C\uDDEE\uD83C\uDDF2", "\uD83C\uDDEE\uD83C\uDDF3", "\uD83C\uDDEE\uD83C\uDDF4", "\uD83C\uDDEE\uD83C\uDDF6", "\uD83C\uDDEE\uD83C\uDDF7", "\uD83C\uDDEE\uD83C\uDDF8", "\uD83C\uDDEE\uD83C\uDDF9", "\uD83C\uDDEF\uD83C\uDDEA", "\uD83C\uDDEF\uD83C\uDDF2", "\uD83C\uDDEF\uD83C\uDDF4", "\uD83C\uDDEF\uD83C\uDDF5", "\uD83C\uDDF0\uD83C\uDDEA", "\uD83C\uDDF0\uD83C\uDDEC", "\uD83C\uDDF0\uD83C\uDDED", "\uD83C\uDDF0\uD83C\uDDEE", "\uD83C\uDDF0\uD83C\uDDF2", "\uD83C\uDDF0\uD83C\uDDF3", "\uD83C\uDDF0\uD83C\uDDF5", "\uD83C\uDDF0\uD83C\uDDF7", "\uD83C\uDDF0\uD83C\uDDFC", "\uD83C\uDDF0\uD83C\uDDFE", "\uD83C\uDDF0\uD83C\uDDFF", "\uD83C\uDDF1\uD83C\uDDE6", "\uD83C\uDDF1\uD83C\uDDE7", "\uD83C\uDDF1\uD83C\uDDE8", "\uD83C\uDDF1\uD83C\uDDEE", "\uD83C\uDDF1\uD83C\uDDF0", "\uD83C\uDDF1\uD83C\uDDF7", "\uD83C\uDDF1\uD83C\uDDF8", "\uD83C\uDDF1\uD83C\uDDF9", "\uD83C\uDDF1\uD83C\uDDFA", "\uD83C\uDDF1\uD83C\uDDFB", "\uD83C\uDDF1\uD83C\uDDFE", "\uD83C\uDDF2\uD83C\uDDE6", "\uD83C\uDDF2\uD83C\uDDE8", "\uD83C\uDDF2\uD83C\uDDE9", "\uD83C\uDDF2\uD83C\uDDEA", "\uD83C\uDDF2\uD83C\uDDEB", "\uD83C\uDDF2\uD83C\uDDEC", "\uD83C\uDDF2\uD83C\uDDED", "\uD83C\uDDF2\uD83C\uDDF0", "\uD83C\uDDF2\uD83C\uDDF1", "\uD83C\uDDF2\uD83C\uDDF2", "\uD83C\uDDF2\uD83C\uDDF3", "\uD83C\uDDF2\uD83C\uDDF4", "\uD83C\uDDF2\uD83C\uDDF5", "\uD83C\uDDF2\uD83C\uDDF6", "\uD83C\uDDF2\uD83C\uDDF7", "\uD83C\uDDF2\uD83C\uDDF8", "\uD83C\uDDF2\uD83C\uDDF9", "\uD83C\uDDF2\uD83C\uDDFA", "\uD83C\uDDF2\uD83C\uDDFB", "\uD83C\uDDF2\uD83C\uDDFC", "\uD83C\uDDF2\uD83C\uDDFD", "\uD83C\uDDF2\uD83C\uDDFE", "\uD83C\uDDF2\uD83C\uDDFF", "\uD83C\uDDF3\uD83C\uDDE6", "\uD83C\uDDF3\uD83C\uDDE8", "\uD83C\uDDF3\uD83C\uDDEA", "\uD83C\uDDF3\uD83C\uDDEB", "\uD83C\uDDF3\uD83C\uDDEC", "\uD83C\uDDF3\uD83C\uDDEE", "\uD83C\uDDF3\uD83C\uDDF1", "\uD83C\uDDF3\uD83C\uDDF4", "\uD83C\uDDF3\uD83C\uDDF5", "\uD83C\uDDF3\uD83C\uDDF7", "\uD83C\uDDF3\uD83C\uDDFA", "\uD83C\uDDF3\uD83C\uDDFF", "\uD83C\uDDF4\uD83C\uDDF2", "\uD83C\uDDF5\uD83C\uDDE6", "\uD83C\uDDF5\uD83C\uDDEA", "\uD83C\uDDF5\uD83C\uDDEB", "\uD83C\uDDF5\uD83C\uDDEC", "\uD83C\uDDF5\uD83C\uDDED", "\uD83C\uDDF5\uD83C\uDDF0", "\uD83C\uDDF5\uD83C\uDDF1", "\uD83C\uDDF5\uD83C\uDDF2", "\uD83C\uDDF5\uD83C\uDDF3", "\uD83C\uDDF5\uD83C\uDDF7", "\uD83C\uDDF5\uD83C\uDDF8", "\uD83C\uDDF5\uD83C\uDDF9", "\uD83C\uDDF5\uD83C\uDDFC", "\uD83C\uDDF5\uD83C\uDDFE", "\uD83C\uDDF6\uD83C\uDDE6", "\uD83C\uDDF7\uD83C\uDDEA", "\uD83C\uDDF7\uD83C\uDDF4", "\uD83C\uDDF7\uD83C\uDDF8", "\uD83C\uDDF7\uD83C\uDDFA", "\uD83C\uDDF7\uD83C\uDDFC", "\uD83C\uDDF8\uD83C\uDDE6", "\uD83C\uDDF8\uD83C\uDDE7", "\uD83C\uDDF8\uD83C\uDDE8", "\uD83C\uDDF8\uD83C\uDDE9", "\uD83C\uDDF8\uD83C\uDDEA", "\uD83C\uDDF8\uD83C\uDDEC", "\uD83C\uDDF8\uD83C\uDDED", "\uD83C\uDDF8\uD83C\uDDEE", "\uD83C\uDDF8\uD83C\uDDEF", "\uD83C\uDDF8\uD83C\uDDF0", "\uD83C\uDDF8\uD83C\uDDF1", "\uD83C\uDDF8\uD83C\uDDF2", "\uD83C\uDDF8\uD83C\uDDF3", "\uD83C\uDDF8\uD83C\uDDF4", "\uD83C\uDDF8\uD83C\uDDF7", "\uD83C\uDDF8\uD83C\uDDF8", "\uD83C\uDDF8\uD83C\uDDF9", "\uD83C\uDDF8\uD83C\uDDFB", "\uD83C\uDDF8\uD83C\uDDFD", "\uD83C\uDDF8\uD83C\uDDFE", "\uD83C\uDDF8\uD83C\uDDFF", "\uD83C\uDDF9\uD83C\uDDE6", "\uD83C\uDDF9\uD83C\uDDE8", "\uD83C\uDDF9\uD83C\uDDE9", "\uD83C\uDDF9\uD83C\uDDEB", "\uD83C\uDDF9\uD83C\uDDEC", "\uD83C\uDDF9\uD83C\uDDED", "\uD83C\uDDF9\uD83C\uDDEF", "\uD83C\uDDF9\uD83C\uDDF0", "\uD83C\uDDF9\uD83C\uDDF1", "\uD83C\uDDF9\uD83C\uDDF2", "\uD83C\uDDF9\uD83C\uDDF3", "\uD83C\uDDF9\uD83C\uDDF4", "\uD83C\uDDF9\uD83C\uDDF7", "\uD83C\uDDF9\uD83C\uDDF9", "\uD83C\uDDF9\uD83C\uDDFB", "\uD83C\uDDF9\uD83C\uDDFC", "\uD83C\uDDF9\uD83C\uDDFF", "\uD83C\uDDFA\uD83C\uDDE6", "\uD83C\uDDFA\uD83C\uDDEC", "\uD83C\uDDFA\uD83C\uDDF2", "\uD83C\uDDFA\uD83C\uDDF3", "\uD83C\uDDFA\uD83C\uDDF8", "\uD83C\uDDFA\uD83C\uDDFE", "\uD83C\uDDFA\uD83C\uDDFF", "\uD83C\uDDFB\uD83C\uDDE6", "\uD83C\uDDFB\uD83C\uDDE8", "\uD83C\uDDFB\uD83C\uDDEA", "\uD83C\uDDFB\uD83C\uDDEC", "\uD83C\uDDFB\uD83C\uDDEE", "\uD83C\uDDFB\uD83C\uDDF3", "\uD83C\uDDFB\uD83C\uDDFA", "\uD83C\uDDFC\uD83C\uDDEB", "\uD83C\uDDFC\uD83C\uDDF8", "\uD83C\uDDFD\uD83C\uDDF0", "\uD83C\uDDFE\uD83C\uDDEA", "\uD83C\uDDFE\uD83C\uDDF9", "\uD83C\uDDFF\uD83C\uDDE6", "\uD83C\uDDFF\uD83C\uDDF2", "\uD83C\uDDFF\uD83C\uDDFC", "\uD83C\uDE02\uFE0F", "\uD83C\uDE37\uFE0F", "\uD83C\uDF21\uFE0F", "\uD83C\uDF24\uFE0F", "\uD83C\uDF25\uFE0F", "\uD83C\uDF26\uFE0F", "\uD83C\uDF27\uFE0F", "\uD83C\uDF28\uFE0F", "\uD83C\uDF29\uFE0F", "\uD83C\uDF2A\uFE0F", "\uD83C\uDF2B\uFE0F", "\uD83C\uDF2C\uFE0F", "\uD83C\uDF36\uFE0F", "\uD83C\uDF44\u200D\uD83D\uDFEB", "\uD83C\uDF4B\u200D\uD83D\uDFE9", "\uD83C\uDF7D\uFE0F", "\uD83C\uDF85\uD83C\uDFFB", "\uD83C\uDF85\uD83C\uDFFC", "\uD83C\uDF85\uD83C\uDFFD", "\uD83C\uDF85\uD83C\uDFFE", "\uD83C\uDF85\uD83C\uDFFF", "\uD83C\uDF96\uFE0F", "\uD83C\uDF97\uFE0F", "\uD83C\uDF99\uFE0F", "\uD83C\uDF9A\uFE0F", "\uD83C\uDF9B\uFE0F", "\uD83C\uDF9E\uFE0F", "\uD83C\uDF9F\uFE0F", "\uD83C\uDFC2\uD83C\uDFFB", "\uD83C\uDFC2\uD83C\uDFFC", "\uD83C\uDFC2\uD83C\uDFFD", "\uD83C\uDFC2\uD83C\uDFFE", "\uD83C\uDFC2\uD83C\uDFFF", "\uD83C\uDFC3\u200D\u2640\uFE0F", "\uD83C\uDFC3\u200D\u2640\uFE0F\u200D\u27A1\uFE0F", "\uD83C\uDFC3\u200D\u2642\uFE0F", "\uD83C\uDFC3\u200D\u2642\uFE0F\u200D\u27A1\uFE0F", "\uD83C\uDFC3\u200D\u27A1\uFE0F", "\uD83C\uDFC3\uD83C\uDFFB", "\uD83C\uDFC3\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83C\uDFC3\uD83C\uDFFB\u200D\u2640\uFE0F\u200D\u27A1\uFE0F", "\uD83C\uDFC3\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83C\uDFC3\uD83C\uDFFB\u200D\u2642\uFE0F\u200D\u27A1\uFE0F", "\uD83C\uDFC3\uD83C\uDFFB\u200D\u27A1\uFE0F", "\uD83C\uDFC3\uD83C\uDFFC", "\uD83C\uDFC3\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83C\uDFC3\uD83C\uDFFC\u200D\u2640\uFE0F\u200D\u27A1\uFE0F", "\uD83C\uDFC3\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83C\uDFC3\uD83C\uDFFC\u200D\u2642\uFE0F\u200D\u27A1\uFE0F", "\uD83C\uDFC3\uD83C\uDFFC\u200D\u27A1\uFE0F", "\uD83C\uDFC3\uD83C\uDFFD", "\uD83C\uDFC3\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83C\uDFC3\uD83C\uDFFD\u200D\u2640\uFE0F\u200D\u27A1\uFE0F", "\uD83C\uDFC3\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83C\uDFC3\uD83C\uDFFD\u200D\u2642\uFE0F\u200D\u27A1\uFE0F", "\uD83C\uDFC3\uD83C\uDFFD\u200D\u27A1\uFE0F", "\uD83C\uDFC3\uD83C\uDFFE", "\uD83C\uDFC3\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83C\uDFC3\uD83C\uDFFE\u200D\u2640\uFE0F\u200D\u27A1\uFE0F", "\uD83C\uDFC3\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83C\uDFC3\uD83C\uDFFE\u200D\u2642\uFE0F\u200D\u27A1\uFE0F", "\uD83C\uDFC3\uD83C\uDFFE\u200D\u27A1\uFE0F", "\uD83C\uDFC3\uD83C\uDFFF", "\uD83C\uDFC3\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83C\uDFC3\uD83C\uDFFF\u200D\u2640\uFE0F\u200D\u27A1\uFE0F", "\uD83C\uDFC3\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83C\uDFC3\uD83C\uDFFF\u200D\u2642\uFE0F\u200D\u27A1\uFE0F", "\uD83C\uDFC3\uD83C\uDFFF\u200D\u27A1\uFE0F", "\uD83C\uDFC4\u200D\u2640\uFE0F", "\uD83C\uDFC4\u200D\u2642\uFE0F", "\uD83C\uDFC4\uD83C\uDFFB", "\uD83C\uDFC4\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83C\uDFC4\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83C\uDFC4\uD83C\uDFFC", "\uD83C\uDFC4\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83C\uDFC4\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83C\uDFC4\uD83C\uDFFD", "\uD83C\uDFC4\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83C\uDFC4\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83C\uDFC4\uD83C\uDFFE", "\uD83C\uDFC4\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83C\uDFC4\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83C\uDFC4\uD83C\uDFFF", "\uD83C\uDFC4\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83C\uDFC4\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83C\uDFC7\uD83C\uDFFB", "\uD83C\uDFC7\uD83C\uDFFC", "\uD83C\uDFC7\uD83C\uDFFD", "\uD83C\uDFC7\uD83C\uDFFE", "\uD83C\uDFC7\uD83C\uDFFF", "\uD83C\uDFCA\u200D\u2640\uFE0F", "\uD83C\uDFCA\u200D\u2642\uFE0F", "\uD83C\uDFCA\uD83C\uDFFB", "\uD83C\uDFCA\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83C\uDFCA\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83C\uDFCA\uD83C\uDFFC", "\uD83C\uDFCA\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83C\uDFCA\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83C\uDFCA\uD83C\uDFFD", "\uD83C\uDFCA\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83C\uDFCA\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83C\uDFCA\uD83C\uDFFE", "\uD83C\uDFCA\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83C\uDFCA\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83C\uDFCA\uD83C\uDFFF", "\uD83C\uDFCA\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83C\uDFCA\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83C\uDFCB\uD83C\uDFFB", "\uD83C\uDFCB\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83C\uDFCB\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83C\uDFCB\uD83C\uDFFC", "\uD83C\uDFCB\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83C\uDFCB\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83C\uDFCB\uD83C\uDFFD", "\uD83C\uDFCB\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83C\uDFCB\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83C\uDFCB\uD83C\uDFFE", "\uD83C\uDFCB\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83C\uDFCB\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83C\uDFCB\uD83C\uDFFF", "\uD83C\uDFCB\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83C\uDFCB\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83C\uDFCB\uFE0F", "\uD83C\uDFCB\uFE0F\u200D\u2640\uFE0F", "\uD83C\uDFCB\uFE0F\u200D\u2642\uFE0F", "\uD83C\uDFCC\uD83C\uDFFB", "\uD83C\uDFCC\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83C\uDFCC\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83C\uDFCC\uD83C\uDFFC", "\uD83C\uDFCC\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83C\uDFCC\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83C\uDFCC\uD83C\uDFFD", "\uD83C\uDFCC\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83C\uDFCC\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83C\uDFCC\uD83C\uDFFE", "\uD83C\uDFCC\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83C\uDFCC\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83C\uDFCC\uD83C\uDFFF", "\uD83C\uDFCC\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83C\uDFCC\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83C\uDFCC\uFE0F", "\uD83C\uDFCC\uFE0F\u200D\u2640\uFE0F", "\uD83C\uDFCC\uFE0F\u200D\u2642\uFE0F", "\uD83C\uDFCD\uFE0F", "\uD83C\uDFCE\uFE0F", "\uD83C\uDFD4\uFE0F", "\uD83C\uDFD5\uFE0F", "\uD83C\uDFD6\uFE0F", "\uD83C\uDFD7\uFE0F", "\uD83C\uDFD8\uFE0F", "\uD83C\uDFD9\uFE0F", "\uD83C\uDFDA\uFE0F", "\uD83C\uDFDB\uFE0F", "\uD83C\uDFDC\uFE0F", "\uD83C\uDFDD\uFE0F", "\uD83C\uDFDE\uFE0F", "\uD83C\uDFDF\uFE0F", "\uD83C\uDFF3\uFE0F", "\uD83C\uDFF3\uFE0F\u200D\u26A7\uFE0F", "\uD83C\uDFF3\uFE0F\u200D\uD83C\uDF08", "\uD83C\uDFF4\u200D\u2620\uFE0F", "\uD83C\uDFF4\uDB40\uDC67\uDB40\uDC62\uDB40\uDC65\uDB40\uDC6E\uDB40\uDC67\uDB40\uDC7F", "\uD83C\uDFF4\uDB40\uDC67\uDB40\uDC62\uDB40\uDC73\uDB40\uDC63\uDB40\uDC74\uDB40\uDC7F", "\uD83C\uDFF4\uDB40\uDC67\uDB40\uDC62\uDB40\uDC77\uDB40\uDC6C\uDB40\uDC73\uDB40\uDC7F", "\uD83C\uDFF5\uFE0F", "\uD83C\uDFF7\uFE0F", "\uD83D\uDC08\u200D\u2B1B", "\uD83D\uDC15\u200D\uD83E\uDDBA", "\uD83D\uDC26\u200D\u2B1B", "\uD83D\uDC26\u200D\uD83D\uDD25", "\uD83D\uDC3B\u200D\u2744\uFE0F", "\uD83D\uDC3F\uFE0F", "\uD83D\uDC41\uFE0F", "\uD83D\uDC41\uFE0F\u200D\uD83D\uDDE8\uFE0F", "\uD83D\uDC42\uD83C\uDFFB", "\uD83D\uDC42\uD83C\uDFFC", "\uD83D\uDC42\uD83C\uDFFD", "\uD83D\uDC42\uD83C\uDFFE", "\uD83D\uDC42\uD83C\uDFFF", "\uD83D\uDC43\uD83C\uDFFB", "\uD83D\uDC43\uD83C\uDFFC", "\uD83D\uDC43\uD83C\uDFFD", "\uD83D\uDC43\uD83C\uDFFE", "\uD83D\uDC43\uD83C\uDFFF", "\uD83D\uDC46\uD83C\uDFFB", "\uD83D\uDC46\uD83C\uDFFC", "\uD83D\uDC46\uD83C\uDFFD", "\uD83D\uDC46\uD83C\uDFFE", "\uD83D\uDC46\uD83C\uDFFF", "\uD83D\uDC47\uD83C\uDFFB", "\uD83D\uDC47\uD83C\uDFFC", "\uD83D\uDC47\uD83C\uDFFD", "\uD83D\uDC47\uD83C\uDFFE", "\uD83D\uDC47\uD83C\uDFFF", "\uD83D\uDC48\uD83C\uDFFB", "\uD83D\uDC48\uD83C\uDFFC", "\uD83D\uDC48\uD83C\uDFFD", "\uD83D\uDC48\uD83C\uDFFE", "\uD83D\uDC48\uD83C\uDFFF", "\uD83D\uDC49\uD83C\uDFFB", "\uD83D\uDC49\uD83C\uDFFC", "\uD83D\uDC49\uD83C\uDFFD", "\uD83D\uDC49\uD83C\uDFFE", "\uD83D\uDC49\uD83C\uDFFF", "\uD83D\uDC4A\uD83C\uDFFB", "\uD83D\uDC4A\uD83C\uDFFC", "\uD83D\uDC4A\uD83C\uDFFD", "\uD83D\uDC4A\uD83C\uDFFE", "\uD83D\uDC4A\uD83C\uDFFF", "\uD83D\uDC4B\uD83C\uDFFB", "\uD83D\uDC4B\uD83C\uDFFC", "\uD83D\uDC4B\uD83C\uDFFD", "\uD83D\uDC4B\uD83C\uDFFE", "\uD83D\uDC4B\uD83C\uDFFF", "\uD83D\uDC4C\uD83C\uDFFB", "\uD83D\uDC4C\uD83C\uDFFC", "\uD83D\uDC4C\uD83C\uDFFD", "\uD83D\uDC4C\uD83C\uDFFE", "\uD83D\uDC4C\uD83C\uDFFF", "\uD83D\uDC4D\uD83C\uDFFB", "\uD83D\uDC4D\uD83C\uDFFC", "\uD83D\uDC4D\uD83C\uDFFD", "\uD83D\uDC4D\uD83C\uDFFE", "\uD83D\uDC4D\uD83C\uDFFF", "\uD83D\uDC4E\uD83C\uDFFB", "\uD83D\uDC4E\uD83C\uDFFC", "\uD83D\uDC4E\uD83C\uDFFD", "\uD83D\uDC4E\uD83C\uDFFE", "\uD83D\uDC4E\uD83C\uDFFF", "\uD83D\uDC4F\uD83C\uDFFB", "\uD83D\uDC4F\uD83C\uDFFC", "\uD83D\uDC4F\uD83C\uDFFD", "\uD83D\uDC4F\uD83C\uDFFE", "\uD83D\uDC4F\uD83C\uDFFF", "\uD83D\uDC50\uD83C\uDFFB", "\uD83D\uDC50\uD83C\uDFFC", "\uD83D\uDC50\uD83C\uDFFD", "\uD83D\uDC50\uD83C\uDFFE", "\uD83D\uDC50\uD83C\uDFFF", "\uD83D\uDC66\uD83C\uDFFB", "\uD83D\uDC66\uD83C\uDFFC", "\uD83D\uDC66\uD83C\uDFFD", "\uD83D\uDC66\uD83C\uDFFE", "\uD83D\uDC66\uD83C\uDFFF", "\uD83D\uDC67\uD83C\uDFFB", "\uD83D\uDC67\uD83C\uDFFC", "\uD83D\uDC67\uD83C\uDFFD", "\uD83D\uDC67\uD83C\uDFFE", "\uD83D\uDC67\uD83C\uDFFF", "\uD83D\uDC68\u200D\u2695\uFE0F", "\uD83D\uDC68\u200D\u2696\uFE0F", "\uD83D\uDC68\u200D\u2708\uFE0F", "\uD83D\uDC68\u200D\u2764\uFE0F\u200D\uD83D\uDC68", "\uD83D\uDC68\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68", "\uD83D\uDC68\u200D\uD83C\uDF3E", "\uD83D\uDC68\u200D\uD83C\uDF73", "\uD83D\uDC68\u200D\uD83C\uDF7C", "\uD83D\uDC68\u200D\uD83C\uDF93", "\uD83D\uDC68\u200D\uD83C\uDFA4", "\uD83D\uDC68\u200D\uD83C\uDFA8", "\uD83D\uDC68\u200D\uD83C\uDFEB", "\uD83D\uDC68\u200D\uD83C\uDFED", "\uD83D\uDC68\u200D\uD83D\uDC66", "\uD83D\uDC68\u200D\uD83D\uDC66\u200D\uD83D\uDC66", "\uD83D\uDC68\u200D\uD83D\uDC67", "\uD83D\uDC68\u200D\uD83D\uDC67\u200D\uD83D\uDC66", "\uD83D\uDC68\u200D\uD83D\uDC67\u200D\uD83D\uDC67", "\uD83D\uDC68\u200D\uD83D\uDC68\u200D\uD83D\uDC66", "\uD83D\uDC68\u200D\uD83D\uDC68\u200D\uD83D\uDC66\u200D\uD83D\uDC66", "\uD83D\uDC68\u200D\uD83D\uDC68\u200D\uD83D\uDC67", "\uD83D\uDC68\u200D\uD83D\uDC68\u200D\uD83D\uDC67\u200D\uD83D\uDC66", "\uD83D\uDC68\u200D\uD83D\uDC68\u200D\uD83D\uDC67\u200D\uD83D\uDC67", "\uD83D\uDC68\u200D\uD83D\uDC69\u200D\uD83D\uDC66", "\uD83D\uDC68\u200D\uD83D\uDC69\u200D\uD83D\uDC66\u200D\uD83D\uDC66", "\uD83D\uDC68\u200D\uD83D\uDC69\u200D\uD83D\uDC67", "\uD83D\uDC68\u200D\uD83D\uDC69\u200D\uD83D\uDC67\u200D\uD83D\uDC66", "\uD83D\uDC68\u200D\uD83D\uDC69\u200D\uD83D\uDC67\u200D\uD83D\uDC67", "\uD83D\uDC68\u200D\uD83D\uDCBB", "\uD83D\uDC68\u200D\uD83D\uDCBC", "\uD83D\uDC68\u200D\uD83D\uDD27", "\uD83D\uDC68\u200D\uD83D\uDD2C", "\uD83D\uDC68\u200D\uD83D\uDE80", "\uD83D\uDC68\u200D\uD83D\uDE92", "\uD83D\uDC68\u200D\uD83E\uDDAF", "\uD83D\uDC68\u200D\uD83E\uDDAF\u200D\u27A1\uFE0F", "\uD83D\uDC68\u200D\uD83E\uDDB0", "\uD83D\uDC68\u200D\uD83E\uDDB1", "\uD83D\uDC68\u200D\uD83E\uDDB2", "\uD83D\uDC68\u200D\uD83E\uDDB3", "\uD83D\uDC68\u200D\uD83E\uDDBC", "\uD83D\uDC68\u200D\uD83E\uDDBC\u200D\u27A1\uFE0F", "\uD83D\uDC68\u200D\uD83E\uDDBD", "\uD83D\uDC68\u200D\uD83E\uDDBD\u200D\u27A1\uFE0F", "\uD83D\uDC68\uD83C\uDFFB", "\uD83D\uDC68\uD83C\uDFFB\u200D\u2695\uFE0F", "\uD83D\uDC68\uD83C\uDFFB\u200D\u2696\uFE0F", "\uD83D\uDC68\uD83C\uDFFB\u200D\u2708\uFE0F", "\uD83D\uDC68\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFB", "\uD83D\uDC68\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFC", "\uD83D\uDC68\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFD", "\uD83D\uDC68\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFE", "\uD83D\uDC68\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFF", "\uD83D\uDC68\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFB", "\uD83D\uDC68\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFC", "\uD83D\uDC68\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFD", "\uD83D\uDC68\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFE", "\uD83D\uDC68\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFF", "\uD83D\uDC68\uD83C\uDFFB\u200D\uD83C\uDF3E", "\uD83D\uDC68\uD83C\uDFFB\u200D\uD83C\uDF73", "\uD83D\uDC68\uD83C\uDFFB\u200D\uD83C\uDF7C", "\uD83D\uDC68\uD83C\uDFFB\u200D\uD83C\uDF93", "\uD83D\uDC68\uD83C\uDFFB\u200D\uD83C\uDFA4", "\uD83D\uDC68\uD83C\uDFFB\u200D\uD83C\uDFA8", "\uD83D\uDC68\uD83C\uDFFB\u200D\uD83C\uDFEB", "\uD83D\uDC68\uD83C\uDFFB\u200D\uD83C\uDFED", "\uD83D\uDC68\uD83C\uDFFB\u200D\uD83D\uDCBB", "\uD83D\uDC68\uD83C\uDFFB\u200D\uD83D\uDCBC", "\uD83D\uDC68\uD83C\uDFFB\u200D\uD83D\uDD27", "\uD83D\uDC68\uD83C\uDFFB\u200D\uD83D\uDD2C", "\uD83D\uDC68\uD83C\uDFFB\u200D\uD83D\uDE80", "\uD83D\uDC68\uD83C\uDFFB\u200D\uD83D\uDE92", "\uD83D\uDC68\uD83C\uDFFB\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFC", "\uD83D\uDC68\uD83C\uDFFB\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFD", "\uD83D\uDC68\uD83C\uDFFB\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFE", "\uD83D\uDC68\uD83C\uDFFB\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFF", "\uD83D\uDC68\uD83C\uDFFB\u200D\uD83E\uDDAF", "\uD83D\uDC68\uD83C\uDFFB\u200D\uD83E\uDDAF\u200D\u27A1\uFE0F", "\uD83D\uDC68\uD83C\uDFFB\u200D\uD83E\uDDB0", "\uD83D\uDC68\uD83C\uDFFB\u200D\uD83E\uDDB1", "\uD83D\uDC68\uD83C\uDFFB\u200D\uD83E\uDDB2", "\uD83D\uDC68\uD83C\uDFFB\u200D\uD83E\uDDB3", "\uD83D\uDC68\uD83C\uDFFB\u200D\uD83E\uDDBC", "\uD83D\uDC68\uD83C\uDFFB\u200D\uD83E\uDDBC\u200D\u27A1\uFE0F", "\uD83D\uDC68\uD83C\uDFFB\u200D\uD83E\uDDBD", "\uD83D\uDC68\uD83C\uDFFB\u200D\uD83E\uDDBD\u200D\u27A1\uFE0F", "\uD83D\uDC68\uD83C\uDFFC", "\uD83D\uDC68\uD83C\uDFFC\u200D\u2695\uFE0F", "\uD83D\uDC68\uD83C\uDFFC\u200D\u2696\uFE0F", "\uD83D\uDC68\uD83C\uDFFC\u200D\u2708\uFE0F", "\uD83D\uDC68\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFB", "\uD83D\uDC68\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFC", "\uD83D\uDC68\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFD", "\uD83D\uDC68\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFE", "\uD83D\uDC68\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFF", "\uD83D\uDC68\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFB", "\uD83D\uDC68\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFC", "\uD83D\uDC68\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFD", "\uD83D\uDC68\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFE", "\uD83D\uDC68\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFF", "\uD83D\uDC68\uD83C\uDFFC\u200D\uD83C\uDF3E", "\uD83D\uDC68\uD83C\uDFFC\u200D\uD83C\uDF73", "\uD83D\uDC68\uD83C\uDFFC\u200D\uD83C\uDF7C", "\uD83D\uDC68\uD83C\uDFFC\u200D\uD83C\uDF93", "\uD83D\uDC68\uD83C\uDFFC\u200D\uD83C\uDFA4", "\uD83D\uDC68\uD83C\uDFFC\u200D\uD83C\uDFA8", "\uD83D\uDC68\uD83C\uDFFC\u200D\uD83C\uDFEB", "\uD83D\uDC68\uD83C\uDFFC\u200D\uD83C\uDFED", "\uD83D\uDC68\uD83C\uDFFC\u200D\uD83D\uDCBB", "\uD83D\uDC68\uD83C\uDFFC\u200D\uD83D\uDCBC", "\uD83D\uDC68\uD83C\uDFFC\u200D\uD83D\uDD27", "\uD83D\uDC68\uD83C\uDFFC\u200D\uD83D\uDD2C", "\uD83D\uDC68\uD83C\uDFFC\u200D\uD83D\uDE80", "\uD83D\uDC68\uD83C\uDFFC\u200D\uD83D\uDE92", "\uD83D\uDC68\uD83C\uDFFC\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFB", "\uD83D\uDC68\uD83C\uDFFC\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFD", "\uD83D\uDC68\uD83C\uDFFC\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFE", "\uD83D\uDC68\uD83C\uDFFC\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFF", "\uD83D\uDC68\uD83C\uDFFC\u200D\uD83E\uDDAF", "\uD83D\uDC68\uD83C\uDFFC\u200D\uD83E\uDDAF\u200D\u27A1\uFE0F", "\uD83D\uDC68\uD83C\uDFFC\u200D\uD83E\uDDB0", "\uD83D\uDC68\uD83C\uDFFC\u200D\uD83E\uDDB1", "\uD83D\uDC68\uD83C\uDFFC\u200D\uD83E\uDDB2", "\uD83D\uDC68\uD83C\uDFFC\u200D\uD83E\uDDB3", "\uD83D\uDC68\uD83C\uDFFC\u200D\uD83E\uDDBC", "\uD83D\uDC68\uD83C\uDFFC\u200D\uD83E\uDDBC\u200D\u27A1\uFE0F", "\uD83D\uDC68\uD83C\uDFFC\u200D\uD83E\uDDBD", "\uD83D\uDC68\uD83C\uDFFC\u200D\uD83E\uDDBD\u200D\u27A1\uFE0F", "\uD83D\uDC68\uD83C\uDFFD", "\uD83D\uDC68\uD83C\uDFFD\u200D\u2695\uFE0F", "\uD83D\uDC68\uD83C\uDFFD\u200D\u2696\uFE0F", "\uD83D\uDC68\uD83C\uDFFD\u200D\u2708\uFE0F", "\uD83D\uDC68\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFB", "\uD83D\uDC68\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFC", "\uD83D\uDC68\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFD", "\uD83D\uDC68\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFE", "\uD83D\uDC68\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFF", "\uD83D\uDC68\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFB", "\uD83D\uDC68\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFC", "\uD83D\uDC68\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFD", "\uD83D\uDC68\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFE", "\uD83D\uDC68\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFF", "\uD83D\uDC68\uD83C\uDFFD\u200D\uD83C\uDF3E", "\uD83D\uDC68\uD83C\uDFFD\u200D\uD83C\uDF73", "\uD83D\uDC68\uD83C\uDFFD\u200D\uD83C\uDF7C", "\uD83D\uDC68\uD83C\uDFFD\u200D\uD83C\uDF93", "\uD83D\uDC68\uD83C\uDFFD\u200D\uD83C\uDFA4", "\uD83D\uDC68\uD83C\uDFFD\u200D\uD83C\uDFA8", "\uD83D\uDC68\uD83C\uDFFD\u200D\uD83C\uDFEB", "\uD83D\uDC68\uD83C\uDFFD\u200D\uD83C\uDFED", "\uD83D\uDC68\uD83C\uDFFD\u200D\uD83D\uDCBB", "\uD83D\uDC68\uD83C\uDFFD\u200D\uD83D\uDCBC", "\uD83D\uDC68\uD83C\uDFFD\u200D\uD83D\uDD27", "\uD83D\uDC68\uD83C\uDFFD\u200D\uD83D\uDD2C", "\uD83D\uDC68\uD83C\uDFFD\u200D\uD83D\uDE80", "\uD83D\uDC68\uD83C\uDFFD\u200D\uD83D\uDE92", "\uD83D\uDC68\uD83C\uDFFD\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFB", "\uD83D\uDC68\uD83C\uDFFD\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFC", "\uD83D\uDC68\uD83C\uDFFD\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFE", "\uD83D\uDC68\uD83C\uDFFD\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFF", "\uD83D\uDC68\uD83C\uDFFD\u200D\uD83E\uDDAF", "\uD83D\uDC68\uD83C\uDFFD\u200D\uD83E\uDDAF\u200D\u27A1\uFE0F", "\uD83D\uDC68\uD83C\uDFFD\u200D\uD83E\uDDB0", "\uD83D\uDC68\uD83C\uDFFD\u200D\uD83E\uDDB1", "\uD83D\uDC68\uD83C\uDFFD\u200D\uD83E\uDDB2", "\uD83D\uDC68\uD83C\uDFFD\u200D\uD83E\uDDB3", "\uD83D\uDC68\uD83C\uDFFD\u200D\uD83E\uDDBC", "\uD83D\uDC68\uD83C\uDFFD\u200D\uD83E\uDDBC\u200D\u27A1\uFE0F", "\uD83D\uDC68\uD83C\uDFFD\u200D\uD83E\uDDBD", "\uD83D\uDC68\uD83C\uDFFD\u200D\uD83E\uDDBD\u200D\u27A1\uFE0F", "\uD83D\uDC68\uD83C\uDFFE", "\uD83D\uDC68\uD83C\uDFFE\u200D\u2695\uFE0F", "\uD83D\uDC68\uD83C\uDFFE\u200D\u2696\uFE0F", "\uD83D\uDC68\uD83C\uDFFE\u200D\u2708\uFE0F", "\uD83D\uDC68\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFB", "\uD83D\uDC68\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFC", "\uD83D\uDC68\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFD", "\uD83D\uDC68\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFE", "\uD83D\uDC68\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFF", "\uD83D\uDC68\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFB", "\uD83D\uDC68\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFC", "\uD83D\uDC68\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFD", "\uD83D\uDC68\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFE", "\uD83D\uDC68\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFF", "\uD83D\uDC68\uD83C\uDFFE\u200D\uD83C\uDF3E", "\uD83D\uDC68\uD83C\uDFFE\u200D\uD83C\uDF73", "\uD83D\uDC68\uD83C\uDFFE\u200D\uD83C\uDF7C", "\uD83D\uDC68\uD83C\uDFFE\u200D\uD83C\uDF93", "\uD83D\uDC68\uD83C\uDFFE\u200D\uD83C\uDFA4", "\uD83D\uDC68\uD83C\uDFFE\u200D\uD83C\uDFA8", "\uD83D\uDC68\uD83C\uDFFE\u200D\uD83C\uDFEB", "\uD83D\uDC68\uD83C\uDFFE\u200D\uD83C\uDFED", "\uD83D\uDC68\uD83C\uDFFE\u200D\uD83D\uDCBB", "\uD83D\uDC68\uD83C\uDFFE\u200D\uD83D\uDCBC", "\uD83D\uDC68\uD83C\uDFFE\u200D\uD83D\uDD27", "\uD83D\uDC68\uD83C\uDFFE\u200D\uD83D\uDD2C", "\uD83D\uDC68\uD83C\uDFFE\u200D\uD83D\uDE80", "\uD83D\uDC68\uD83C\uDFFE\u200D\uD83D\uDE92", "\uD83D\uDC68\uD83C\uDFFE\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFB", "\uD83D\uDC68\uD83C\uDFFE\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFC", "\uD83D\uDC68\uD83C\uDFFE\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFD", "\uD83D\uDC68\uD83C\uDFFE\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFF", "\uD83D\uDC68\uD83C\uDFFE\u200D\uD83E\uDDAF", "\uD83D\uDC68\uD83C\uDFFE\u200D\uD83E\uDDAF\u200D\u27A1\uFE0F", "\uD83D\uDC68\uD83C\uDFFE\u200D\uD83E\uDDB0", "\uD83D\uDC68\uD83C\uDFFE\u200D\uD83E\uDDB1", "\uD83D\uDC68\uD83C\uDFFE\u200D\uD83E\uDDB2", "\uD83D\uDC68\uD83C\uDFFE\u200D\uD83E\uDDB3", "\uD83D\uDC68\uD83C\uDFFE\u200D\uD83E\uDDBC", "\uD83D\uDC68\uD83C\uDFFE\u200D\uD83E\uDDBC\u200D\u27A1\uFE0F", "\uD83D\uDC68\uD83C\uDFFE\u200D\uD83E\uDDBD", "\uD83D\uDC68\uD83C\uDFFE\u200D\uD83E\uDDBD\u200D\u27A1\uFE0F", "\uD83D\uDC68\uD83C\uDFFF", "\uD83D\uDC68\uD83C\uDFFF\u200D\u2695\uFE0F", "\uD83D\uDC68\uD83C\uDFFF\u200D\u2696\uFE0F", "\uD83D\uDC68\uD83C\uDFFF\u200D\u2708\uFE0F", "\uD83D\uDC68\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFB", "\uD83D\uDC68\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFC", "\uD83D\uDC68\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFD", "\uD83D\uDC68\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFE", "\uD83D\uDC68\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFF", "\uD83D\uDC68\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFB", "\uD83D\uDC68\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFC", "\uD83D\uDC68\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFD", "\uD83D\uDC68\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFE", "\uD83D\uDC68\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFF", "\uD83D\uDC68\uD83C\uDFFF\u200D\uD83C\uDF3E", "\uD83D\uDC68\uD83C\uDFFF\u200D\uD83C\uDF73", "\uD83D\uDC68\uD83C\uDFFF\u200D\uD83C\uDF7C", "\uD83D\uDC68\uD83C\uDFFF\u200D\uD83C\uDF93", "\uD83D\uDC68\uD83C\uDFFF\u200D\uD83C\uDFA4", "\uD83D\uDC68\uD83C\uDFFF\u200D\uD83C\uDFA8", "\uD83D\uDC68\uD83C\uDFFF\u200D\uD83C\uDFEB", "\uD83D\uDC68\uD83C\uDFFF\u200D\uD83C\uDFED", "\uD83D\uDC68\uD83C\uDFFF\u200D\uD83D\uDCBB", "\uD83D\uDC68\uD83C\uDFFF\u200D\uD83D\uDCBC", "\uD83D\uDC68\uD83C\uDFFF\u200D\uD83D\uDD27", "\uD83D\uDC68\uD83C\uDFFF\u200D\uD83D\uDD2C", "\uD83D\uDC68\uD83C\uDFFF\u200D\uD83D\uDE80", "\uD83D\uDC68\uD83C\uDFFF\u200D\uD83D\uDE92", "\uD83D\uDC68\uD83C\uDFFF\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFB", "\uD83D\uDC68\uD83C\uDFFF\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFC", "\uD83D\uDC68\uD83C\uDFFF\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFD", "\uD83D\uDC68\uD83C\uDFFF\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFE", "\uD83D\uDC68\uD83C\uDFFF\u200D\uD83E\uDDAF", "\uD83D\uDC68\uD83C\uDFFF\u200D\uD83E\uDDAF\u200D\u27A1\uFE0F", "\uD83D\uDC68\uD83C\uDFFF\u200D\uD83E\uDDB0", "\uD83D\uDC68\uD83C\uDFFF\u200D\uD83E\uDDB1", "\uD83D\uDC68\uD83C\uDFFF\u200D\uD83E\uDDB2", "\uD83D\uDC68\uD83C\uDFFF\u200D\uD83E\uDDB3", "\uD83D\uDC68\uD83C\uDFFF\u200D\uD83E\uDDBC", "\uD83D\uDC68\uD83C\uDFFF\u200D\uD83E\uDDBC\u200D\u27A1\uFE0F", "\uD83D\uDC68\uD83C\uDFFF\u200D\uD83E\uDDBD", "\uD83D\uDC68\uD83C\uDFFF\u200D\uD83E\uDDBD\u200D\u27A1\uFE0F", "\uD83D\uDC69\u200D\u2695\uFE0F", "\uD83D\uDC69\u200D\u2696\uFE0F", "\uD83D\uDC69\u200D\u2708\uFE0F", "\uD83D\uDC69\u200D\u2764\uFE0F\u200D\uD83D\uDC68", "\uD83D\uDC69\u200D\u2764\uFE0F\u200D\uD83D\uDC69", "\uD83D\uDC69\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68", "\uD83D\uDC69\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC69", "\uD83D\uDC69\u200D\uD83C\uDF3E", "\uD83D\uDC69\u200D\uD83C\uDF73", "\uD83D\uDC69\u200D\uD83C\uDF7C", "\uD83D\uDC69\u200D\uD83C\uDF93", "\uD83D\uDC69\u200D\uD83C\uDFA4", "\uD83D\uDC69\u200D\uD83C\uDFA8", "\uD83D\uDC69\u200D\uD83C\uDFEB", "\uD83D\uDC69\u200D\uD83C\uDFED", "\uD83D\uDC69\u200D\uD83D\uDC66", "\uD83D\uDC69\u200D\uD83D\uDC66\u200D\uD83D\uDC66", "\uD83D\uDC69\u200D\uD83D\uDC67", "\uD83D\uDC69\u200D\uD83D\uDC67\u200D\uD83D\uDC66", "\uD83D\uDC69\u200D\uD83D\uDC67\u200D\uD83D\uDC67", "\uD83D\uDC69\u200D\uD83D\uDC69\u200D\uD83D\uDC66", "\uD83D\uDC69\u200D\uD83D\uDC69\u200D\uD83D\uDC66\u200D\uD83D\uDC66", "\uD83D\uDC69\u200D\uD83D\uDC69\u200D\uD83D\uDC67", "\uD83D\uDC69\u200D\uD83D\uDC69\u200D\uD83D\uDC67\u200D\uD83D\uDC66", "\uD83D\uDC69\u200D\uD83D\uDC69\u200D\uD83D\uDC67\u200D\uD83D\uDC67", "\uD83D\uDC69\u200D\uD83D\uDCBB", "\uD83D\uDC69\u200D\uD83D\uDCBC", "\uD83D\uDC69\u200D\uD83D\uDD27", "\uD83D\uDC69\u200D\uD83D\uDD2C", "\uD83D\uDC69\u200D\uD83D\uDE80", "\uD83D\uDC69\u200D\uD83D\uDE92", "\uD83D\uDC69\u200D\uD83E\uDDAF", "\uD83D\uDC69\u200D\uD83E\uDDAF\u200D\u27A1\uFE0F", "\uD83D\uDC69\u200D\uD83E\uDDB0", "\uD83D\uDC69\u200D\uD83E\uDDB1", "\uD83D\uDC69\u200D\uD83E\uDDB2", "\uD83D\uDC69\u200D\uD83E\uDDB3", "\uD83D\uDC69\u200D\uD83E\uDDBC", "\uD83D\uDC69\u200D\uD83E\uDDBC\u200D\u27A1\uFE0F", "\uD83D\uDC69\u200D\uD83E\uDDBD", "\uD83D\uDC69\u200D\uD83E\uDDBD\u200D\u27A1\uFE0F", "\uD83D\uDC69\uD83C\uDFFB", "\uD83D\uDC69\uD83C\uDFFB\u200D\u2695\uFE0F", "\uD83D\uDC69\uD83C\uDFFB\u200D\u2696\uFE0F", "\uD83D\uDC69\uD83C\uDFFB\u200D\u2708\uFE0F", "\uD83D\uDC69\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFB", "\uD83D\uDC69\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFC", "\uD83D\uDC69\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFD", "\uD83D\uDC69\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFE", "\uD83D\uDC69\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFF", "\uD83D\uDC69\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC69\uD83C\uDFFB", "\uD83D\uDC69\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC69\uD83C\uDFFC", "\uD83D\uDC69\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC69\uD83C\uDFFD", "\uD83D\uDC69\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC69\uD83C\uDFFE", "\uD83D\uDC69\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC69\uD83C\uDFFF", "\uD83D\uDC69\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFB", "\uD83D\uDC69\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFC", "\uD83D\uDC69\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFD", "\uD83D\uDC69\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFE", "\uD83D\uDC69\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFF", "\uD83D\uDC69\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC69\uD83C\uDFFB", "\uD83D\uDC69\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC69\uD83C\uDFFC", "\uD83D\uDC69\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC69\uD83C\uDFFD", "\uD83D\uDC69\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC69\uD83C\uDFFE", "\uD83D\uDC69\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC69\uD83C\uDFFF", "\uD83D\uDC69\uD83C\uDFFB\u200D\uD83C\uDF3E", "\uD83D\uDC69\uD83C\uDFFB\u200D\uD83C\uDF73", "\uD83D\uDC69\uD83C\uDFFB\u200D\uD83C\uDF7C", "\uD83D\uDC69\uD83C\uDFFB\u200D\uD83C\uDF93", "\uD83D\uDC69\uD83C\uDFFB\u200D\uD83C\uDFA4", "\uD83D\uDC69\uD83C\uDFFB\u200D\uD83C\uDFA8", "\uD83D\uDC69\uD83C\uDFFB\u200D\uD83C\uDFEB", "\uD83D\uDC69\uD83C\uDFFB\u200D\uD83C\uDFED", "\uD83D\uDC69\uD83C\uDFFB\u200D\uD83D\uDCBB", "\uD83D\uDC69\uD83C\uDFFB\u200D\uD83D\uDCBC", "\uD83D\uDC69\uD83C\uDFFB\u200D\uD83D\uDD27", "\uD83D\uDC69\uD83C\uDFFB\u200D\uD83D\uDD2C", "\uD83D\uDC69\uD83C\uDFFB\u200D\uD83D\uDE80", "\uD83D\uDC69\uD83C\uDFFB\u200D\uD83D\uDE92", "\uD83D\uDC69\uD83C\uDFFB\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFC", "\uD83D\uDC69\uD83C\uDFFB\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFD", "\uD83D\uDC69\uD83C\uDFFB\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFE", "\uD83D\uDC69\uD83C\uDFFB\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFF", "\uD83D\uDC69\uD83C\uDFFB\u200D\uD83E\uDD1D\u200D\uD83D\uDC69\uD83C\uDFFC", "\uD83D\uDC69\uD83C\uDFFB\u200D\uD83E\uDD1D\u200D\uD83D\uDC69\uD83C\uDFFD", "\uD83D\uDC69\uD83C\uDFFB\u200D\uD83E\uDD1D\u200D\uD83D\uDC69\uD83C\uDFFE", "\uD83D\uDC69\uD83C\uDFFB\u200D\uD83E\uDD1D\u200D\uD83D\uDC69\uD83C\uDFFF", "\uD83D\uDC69\uD83C\uDFFB\u200D\uD83E\uDDAF", "\uD83D\uDC69\uD83C\uDFFB\u200D\uD83E\uDDAF\u200D\u27A1\uFE0F", "\uD83D\uDC69\uD83C\uDFFB\u200D\uD83E\uDDB0", "\uD83D\uDC69\uD83C\uDFFB\u200D\uD83E\uDDB1", "\uD83D\uDC69\uD83C\uDFFB\u200D\uD83E\uDDB2", "\uD83D\uDC69\uD83C\uDFFB\u200D\uD83E\uDDB3", "\uD83D\uDC69\uD83C\uDFFB\u200D\uD83E\uDDBC", "\uD83D\uDC69\uD83C\uDFFB\u200D\uD83E\uDDBC\u200D\u27A1\uFE0F", "\uD83D\uDC69\uD83C\uDFFB\u200D\uD83E\uDDBD", "\uD83D\uDC69\uD83C\uDFFB\u200D\uD83E\uDDBD\u200D\u27A1\uFE0F", "\uD83D\uDC69\uD83C\uDFFC", "\uD83D\uDC69\uD83C\uDFFC\u200D\u2695\uFE0F", "\uD83D\uDC69\uD83C\uDFFC\u200D\u2696\uFE0F", "\uD83D\uDC69\uD83C\uDFFC\u200D\u2708\uFE0F", "\uD83D\uDC69\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFB", "\uD83D\uDC69\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFC", "\uD83D\uDC69\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFD", "\uD83D\uDC69\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFE", "\uD83D\uDC69\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFF", "\uD83D\uDC69\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC69\uD83C\uDFFB", "\uD83D\uDC69\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC69\uD83C\uDFFC", "\uD83D\uDC69\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC69\uD83C\uDFFD", "\uD83D\uDC69\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC69\uD83C\uDFFE", "\uD83D\uDC69\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC69\uD83C\uDFFF", "\uD83D\uDC69\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFB", "\uD83D\uDC69\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFC", "\uD83D\uDC69\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFD", "\uD83D\uDC69\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFE", "\uD83D\uDC69\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFF", "\uD83D\uDC69\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC69\uD83C\uDFFB", "\uD83D\uDC69\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC69\uD83C\uDFFC", "\uD83D\uDC69\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC69\uD83C\uDFFD", "\uD83D\uDC69\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC69\uD83C\uDFFE", "\uD83D\uDC69\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC69\uD83C\uDFFF", "\uD83D\uDC69\uD83C\uDFFC\u200D\uD83C\uDF3E", "\uD83D\uDC69\uD83C\uDFFC\u200D\uD83C\uDF73", "\uD83D\uDC69\uD83C\uDFFC\u200D\uD83C\uDF7C", "\uD83D\uDC69\uD83C\uDFFC\u200D\uD83C\uDF93", "\uD83D\uDC69\uD83C\uDFFC\u200D\uD83C\uDFA4", "\uD83D\uDC69\uD83C\uDFFC\u200D\uD83C\uDFA8", "\uD83D\uDC69\uD83C\uDFFC\u200D\uD83C\uDFEB", "\uD83D\uDC69\uD83C\uDFFC\u200D\uD83C\uDFED", "\uD83D\uDC69\uD83C\uDFFC\u200D\uD83D\uDCBB", "\uD83D\uDC69\uD83C\uDFFC\u200D\uD83D\uDCBC", "\uD83D\uDC69\uD83C\uDFFC\u200D\uD83D\uDD27", "\uD83D\uDC69\uD83C\uDFFC\u200D\uD83D\uDD2C", "\uD83D\uDC69\uD83C\uDFFC\u200D\uD83D\uDE80", "\uD83D\uDC69\uD83C\uDFFC\u200D\uD83D\uDE92", "\uD83D\uDC69\uD83C\uDFFC\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFB", "\uD83D\uDC69\uD83C\uDFFC\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFD", "\uD83D\uDC69\uD83C\uDFFC\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFE", "\uD83D\uDC69\uD83C\uDFFC\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFF", "\uD83D\uDC69\uD83C\uDFFC\u200D\uD83E\uDD1D\u200D\uD83D\uDC69\uD83C\uDFFB", "\uD83D\uDC69\uD83C\uDFFC\u200D\uD83E\uDD1D\u200D\uD83D\uDC69\uD83C\uDFFD", "\uD83D\uDC69\uD83C\uDFFC\u200D\uD83E\uDD1D\u200D\uD83D\uDC69\uD83C\uDFFE", "\uD83D\uDC69\uD83C\uDFFC\u200D\uD83E\uDD1D\u200D\uD83D\uDC69\uD83C\uDFFF", "\uD83D\uDC69\uD83C\uDFFC\u200D\uD83E\uDDAF", "\uD83D\uDC69\uD83C\uDFFC\u200D\uD83E\uDDAF\u200D\u27A1\uFE0F", "\uD83D\uDC69\uD83C\uDFFC\u200D\uD83E\uDDB0", "\uD83D\uDC69\uD83C\uDFFC\u200D\uD83E\uDDB1", "\uD83D\uDC69\uD83C\uDFFC\u200D\uD83E\uDDB2", "\uD83D\uDC69\uD83C\uDFFC\u200D\uD83E\uDDB3", "\uD83D\uDC69\uD83C\uDFFC\u200D\uD83E\uDDBC", "\uD83D\uDC69\uD83C\uDFFC\u200D\uD83E\uDDBC\u200D\u27A1\uFE0F", "\uD83D\uDC69\uD83C\uDFFC\u200D\uD83E\uDDBD", "\uD83D\uDC69\uD83C\uDFFC\u200D\uD83E\uDDBD\u200D\u27A1\uFE0F", "\uD83D\uDC69\uD83C\uDFFD", "\uD83D\uDC69\uD83C\uDFFD\u200D\u2695\uFE0F", "\uD83D\uDC69\uD83C\uDFFD\u200D\u2696\uFE0F", "\uD83D\uDC69\uD83C\uDFFD\u200D\u2708\uFE0F", "\uD83D\uDC69\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFB", "\uD83D\uDC69\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFC", "\uD83D\uDC69\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFD", "\uD83D\uDC69\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFE", "\uD83D\uDC69\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFF", "\uD83D\uDC69\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC69\uD83C\uDFFB", "\uD83D\uDC69\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC69\uD83C\uDFFC", "\uD83D\uDC69\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC69\uD83C\uDFFD", "\uD83D\uDC69\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC69\uD83C\uDFFE", "\uD83D\uDC69\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC69\uD83C\uDFFF", "\uD83D\uDC69\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFB", "\uD83D\uDC69\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFC", "\uD83D\uDC69\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFD", "\uD83D\uDC69\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFE", "\uD83D\uDC69\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFF", "\uD83D\uDC69\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC69\uD83C\uDFFB", "\uD83D\uDC69\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC69\uD83C\uDFFC", "\uD83D\uDC69\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC69\uD83C\uDFFD", "\uD83D\uDC69\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC69\uD83C\uDFFE", "\uD83D\uDC69\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC69\uD83C\uDFFF", "\uD83D\uDC69\uD83C\uDFFD\u200D\uD83C\uDF3E", "\uD83D\uDC69\uD83C\uDFFD\u200D\uD83C\uDF73", "\uD83D\uDC69\uD83C\uDFFD\u200D\uD83C\uDF7C", "\uD83D\uDC69\uD83C\uDFFD\u200D\uD83C\uDF93", "\uD83D\uDC69\uD83C\uDFFD\u200D\uD83C\uDFA4", "\uD83D\uDC69\uD83C\uDFFD\u200D\uD83C\uDFA8", "\uD83D\uDC69\uD83C\uDFFD\u200D\uD83C\uDFEB", "\uD83D\uDC69\uD83C\uDFFD\u200D\uD83C\uDFED", "\uD83D\uDC69\uD83C\uDFFD\u200D\uD83D\uDCBB", "\uD83D\uDC69\uD83C\uDFFD\u200D\uD83D\uDCBC", "\uD83D\uDC69\uD83C\uDFFD\u200D\uD83D\uDD27", "\uD83D\uDC69\uD83C\uDFFD\u200D\uD83D\uDD2C", "\uD83D\uDC69\uD83C\uDFFD\u200D\uD83D\uDE80", "\uD83D\uDC69\uD83C\uDFFD\u200D\uD83D\uDE92", "\uD83D\uDC69\uD83C\uDFFD\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFB", "\uD83D\uDC69\uD83C\uDFFD\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFC", "\uD83D\uDC69\uD83C\uDFFD\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFE", "\uD83D\uDC69\uD83C\uDFFD\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFF", "\uD83D\uDC69\uD83C\uDFFD\u200D\uD83E\uDD1D\u200D\uD83D\uDC69\uD83C\uDFFB", "\uD83D\uDC69\uD83C\uDFFD\u200D\uD83E\uDD1D\u200D\uD83D\uDC69\uD83C\uDFFC", "\uD83D\uDC69\uD83C\uDFFD\u200D\uD83E\uDD1D\u200D\uD83D\uDC69\uD83C\uDFFE", "\uD83D\uDC69\uD83C\uDFFD\u200D\uD83E\uDD1D\u200D\uD83D\uDC69\uD83C\uDFFF", "\uD83D\uDC69\uD83C\uDFFD\u200D\uD83E\uDDAF", "\uD83D\uDC69\uD83C\uDFFD\u200D\uD83E\uDDAF\u200D\u27A1\uFE0F", "\uD83D\uDC69\uD83C\uDFFD\u200D\uD83E\uDDB0", "\uD83D\uDC69\uD83C\uDFFD\u200D\uD83E\uDDB1", "\uD83D\uDC69\uD83C\uDFFD\u200D\uD83E\uDDB2", "\uD83D\uDC69\uD83C\uDFFD\u200D\uD83E\uDDB3", "\uD83D\uDC69\uD83C\uDFFD\u200D\uD83E\uDDBC", "\uD83D\uDC69\uD83C\uDFFD\u200D\uD83E\uDDBC\u200D\u27A1\uFE0F", "\uD83D\uDC69\uD83C\uDFFD\u200D\uD83E\uDDBD", "\uD83D\uDC69\uD83C\uDFFD\u200D\uD83E\uDDBD\u200D\u27A1\uFE0F", "\uD83D\uDC69\uD83C\uDFFE", "\uD83D\uDC69\uD83C\uDFFE\u200D\u2695\uFE0F", "\uD83D\uDC69\uD83C\uDFFE\u200D\u2696\uFE0F", "\uD83D\uDC69\uD83C\uDFFE\u200D\u2708\uFE0F", "\uD83D\uDC69\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFB", "\uD83D\uDC69\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFC", "\uD83D\uDC69\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFD", "\uD83D\uDC69\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFE", "\uD83D\uDC69\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFF", "\uD83D\uDC69\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC69\uD83C\uDFFB", "\uD83D\uDC69\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC69\uD83C\uDFFC", "\uD83D\uDC69\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC69\uD83C\uDFFD", "\uD83D\uDC69\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC69\uD83C\uDFFE", "\uD83D\uDC69\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC69\uD83C\uDFFF", "\uD83D\uDC69\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFB", "\uD83D\uDC69\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFC", "\uD83D\uDC69\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFD", "\uD83D\uDC69\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFE", "\uD83D\uDC69\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFF", "\uD83D\uDC69\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC69\uD83C\uDFFB", "\uD83D\uDC69\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC69\uD83C\uDFFC", "\uD83D\uDC69\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC69\uD83C\uDFFD", "\uD83D\uDC69\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC69\uD83C\uDFFE", "\uD83D\uDC69\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC69\uD83C\uDFFF", "\uD83D\uDC69\uD83C\uDFFE\u200D\uD83C\uDF3E", "\uD83D\uDC69\uD83C\uDFFE\u200D\uD83C\uDF73", "\uD83D\uDC69\uD83C\uDFFE\u200D\uD83C\uDF7C", "\uD83D\uDC69\uD83C\uDFFE\u200D\uD83C\uDF93", "\uD83D\uDC69\uD83C\uDFFE\u200D\uD83C\uDFA4", "\uD83D\uDC69\uD83C\uDFFE\u200D\uD83C\uDFA8", "\uD83D\uDC69\uD83C\uDFFE\u200D\uD83C\uDFEB", "\uD83D\uDC69\uD83C\uDFFE\u200D\uD83C\uDFED", "\uD83D\uDC69\uD83C\uDFFE\u200D\uD83D\uDCBB", "\uD83D\uDC69\uD83C\uDFFE\u200D\uD83D\uDCBC", "\uD83D\uDC69\uD83C\uDFFE\u200D\uD83D\uDD27", "\uD83D\uDC69\uD83C\uDFFE\u200D\uD83D\uDD2C", "\uD83D\uDC69\uD83C\uDFFE\u200D\uD83D\uDE80", "\uD83D\uDC69\uD83C\uDFFE\u200D\uD83D\uDE92", "\uD83D\uDC69\uD83C\uDFFE\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFB", "\uD83D\uDC69\uD83C\uDFFE\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFC", "\uD83D\uDC69\uD83C\uDFFE\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFD", "\uD83D\uDC69\uD83C\uDFFE\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFF", "\uD83D\uDC69\uD83C\uDFFE\u200D\uD83E\uDD1D\u200D\uD83D\uDC69\uD83C\uDFFB", "\uD83D\uDC69\uD83C\uDFFE\u200D\uD83E\uDD1D\u200D\uD83D\uDC69\uD83C\uDFFC", "\uD83D\uDC69\uD83C\uDFFE\u200D\uD83E\uDD1D\u200D\uD83D\uDC69\uD83C\uDFFD", "\uD83D\uDC69\uD83C\uDFFE\u200D\uD83E\uDD1D\u200D\uD83D\uDC69\uD83C\uDFFF", "\uD83D\uDC69\uD83C\uDFFE\u200D\uD83E\uDDAF", "\uD83D\uDC69\uD83C\uDFFE\u200D\uD83E\uDDAF\u200D\u27A1\uFE0F", "\uD83D\uDC69\uD83C\uDFFE\u200D\uD83E\uDDB0", "\uD83D\uDC69\uD83C\uDFFE\u200D\uD83E\uDDB1", "\uD83D\uDC69\uD83C\uDFFE\u200D\uD83E\uDDB2", "\uD83D\uDC69\uD83C\uDFFE\u200D\uD83E\uDDB3", "\uD83D\uDC69\uD83C\uDFFE\u200D\uD83E\uDDBC", "\uD83D\uDC69\uD83C\uDFFE\u200D\uD83E\uDDBC\u200D\u27A1\uFE0F", "\uD83D\uDC69\uD83C\uDFFE\u200D\uD83E\uDDBD", "\uD83D\uDC69\uD83C\uDFFE\u200D\uD83E\uDDBD\u200D\u27A1\uFE0F", "\uD83D\uDC69\uD83C\uDFFF", "\uD83D\uDC69\uD83C\uDFFF\u200D\u2695\uFE0F", "\uD83D\uDC69\uD83C\uDFFF\u200D\u2696\uFE0F", "\uD83D\uDC69\uD83C\uDFFF\u200D\u2708\uFE0F", "\uD83D\uDC69\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFB", "\uD83D\uDC69\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFC", "\uD83D\uDC69\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFD", "\uD83D\uDC69\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFE", "\uD83D\uDC69\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC68\uD83C\uDFFF", "\uD83D\uDC69\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC69\uD83C\uDFFB", "\uD83D\uDC69\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC69\uD83C\uDFFC", "\uD83D\uDC69\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC69\uD83C\uDFFD", "\uD83D\uDC69\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC69\uD83C\uDFFE", "\uD83D\uDC69\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC69\uD83C\uDFFF", "\uD83D\uDC69\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFB", "\uD83D\uDC69\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFC", "\uD83D\uDC69\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFD", "\uD83D\uDC69\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFE", "\uD83D\uDC69\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC68\uD83C\uDFFF", "\uD83D\uDC69\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC69\uD83C\uDFFB", "\uD83D\uDC69\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC69\uD83C\uDFFC", "\uD83D\uDC69\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC69\uD83C\uDFFD", "\uD83D\uDC69\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC69\uD83C\uDFFE", "\uD83D\uDC69\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83D\uDC69\uD83C\uDFFF", "\uD83D\uDC69\uD83C\uDFFF\u200D\uD83C\uDF3E", "\uD83D\uDC69\uD83C\uDFFF\u200D\uD83C\uDF73", "\uD83D\uDC69\uD83C\uDFFF\u200D\uD83C\uDF7C", "\uD83D\uDC69\uD83C\uDFFF\u200D\uD83C\uDF93", "\uD83D\uDC69\uD83C\uDFFF\u200D\uD83C\uDFA4", "\uD83D\uDC69\uD83C\uDFFF\u200D\uD83C\uDFA8", "\uD83D\uDC69\uD83C\uDFFF\u200D\uD83C\uDFEB", "\uD83D\uDC69\uD83C\uDFFF\u200D\uD83C\uDFED", "\uD83D\uDC69\uD83C\uDFFF\u200D\uD83D\uDCBB", "\uD83D\uDC69\uD83C\uDFFF\u200D\uD83D\uDCBC", "\uD83D\uDC69\uD83C\uDFFF\u200D\uD83D\uDD27", "\uD83D\uDC69\uD83C\uDFFF\u200D\uD83D\uDD2C", "\uD83D\uDC69\uD83C\uDFFF\u200D\uD83D\uDE80", "\uD83D\uDC69\uD83C\uDFFF\u200D\uD83D\uDE92", "\uD83D\uDC69\uD83C\uDFFF\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFB", "\uD83D\uDC69\uD83C\uDFFF\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFC", "\uD83D\uDC69\uD83C\uDFFF\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFD", "\uD83D\uDC69\uD83C\uDFFF\u200D\uD83E\uDD1D\u200D\uD83D\uDC68\uD83C\uDFFE", "\uD83D\uDC69\uD83C\uDFFF\u200D\uD83E\uDD1D\u200D\uD83D\uDC69\uD83C\uDFFB", "\uD83D\uDC69\uD83C\uDFFF\u200D\uD83E\uDD1D\u200D\uD83D\uDC69\uD83C\uDFFC", "\uD83D\uDC69\uD83C\uDFFF\u200D\uD83E\uDD1D\u200D\uD83D\uDC69\uD83C\uDFFD", "\uD83D\uDC69\uD83C\uDFFF\u200D\uD83E\uDD1D\u200D\uD83D\uDC69\uD83C\uDFFE", "\uD83D\uDC69\uD83C\uDFFF\u200D\uD83E\uDDAF", "\uD83D\uDC69\uD83C\uDFFF\u200D\uD83E\uDDAF\u200D\u27A1\uFE0F", "\uD83D\uDC69\uD83C\uDFFF\u200D\uD83E\uDDB0", "\uD83D\uDC69\uD83C\uDFFF\u200D\uD83E\uDDB1", "\uD83D\uDC69\uD83C\uDFFF\u200D\uD83E\uDDB2", "\uD83D\uDC69\uD83C\uDFFF\u200D\uD83E\uDDB3", "\uD83D\uDC69\uD83C\uDFFF\u200D\uD83E\uDDBC", "\uD83D\uDC69\uD83C\uDFFF\u200D\uD83E\uDDBC\u200D\u27A1\uFE0F", "\uD83D\uDC69\uD83C\uDFFF\u200D\uD83E\uDDBD", "\uD83D\uDC69\uD83C\uDFFF\u200D\uD83E\uDDBD\u200D\u27A1\uFE0F", "\uD83D\uDC6B\uD83C\uDFFB", "\uD83D\uDC6B\uD83C\uDFFC", "\uD83D\uDC6B\uD83C\uDFFD", "\uD83D\uDC6B\uD83C\uDFFE", "\uD83D\uDC6B\uD83C\uDFFF", "\uD83D\uDC6C\uD83C\uDFFB", "\uD83D\uDC6C\uD83C\uDFFC", "\uD83D\uDC6C\uD83C\uDFFD", "\uD83D\uDC6C\uD83C\uDFFE", "\uD83D\uDC6C\uD83C\uDFFF", "\uD83D\uDC6D\uD83C\uDFFB", "\uD83D\uDC6D\uD83C\uDFFC", "\uD83D\uDC6D\uD83C\uDFFD", "\uD83D\uDC6D\uD83C\uDFFE", "\uD83D\uDC6D\uD83C\uDFFF", "\uD83D\uDC6E\u200D\u2640\uFE0F", "\uD83D\uDC6E\u200D\u2642\uFE0F", "\uD83D\uDC6E\uD83C\uDFFB", "\uD83D\uDC6E\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83D\uDC6E\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83D\uDC6E\uD83C\uDFFC", "\uD83D\uDC6E\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83D\uDC6E\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83D\uDC6E\uD83C\uDFFD", "\uD83D\uDC6E\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83D\uDC6E\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83D\uDC6E\uD83C\uDFFE", "\uD83D\uDC6E\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83D\uDC6E\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83D\uDC6E\uD83C\uDFFF", "\uD83D\uDC6E\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83D\uDC6E\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83D\uDC6F\u200D\u2640\uFE0F", "\uD83D\uDC6F\u200D\u2642\uFE0F", "\uD83D\uDC70\u200D\u2640\uFE0F", "\uD83D\uDC70\u200D\u2642\uFE0F", "\uD83D\uDC70\uD83C\uDFFB", "\uD83D\uDC70\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83D\uDC70\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83D\uDC70\uD83C\uDFFC", "\uD83D\uDC70\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83D\uDC70\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83D\uDC70\uD83C\uDFFD", "\uD83D\uDC70\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83D\uDC70\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83D\uDC70\uD83C\uDFFE", "\uD83D\uDC70\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83D\uDC70\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83D\uDC70\uD83C\uDFFF", "\uD83D\uDC70\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83D\uDC70\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83D\uDC71\u200D\u2640\uFE0F", "\uD83D\uDC71\u200D\u2642\uFE0F", "\uD83D\uDC71\uD83C\uDFFB", "\uD83D\uDC71\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83D\uDC71\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83D\uDC71\uD83C\uDFFC", "\uD83D\uDC71\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83D\uDC71\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83D\uDC71\uD83C\uDFFD", "\uD83D\uDC71\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83D\uDC71\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83D\uDC71\uD83C\uDFFE", "\uD83D\uDC71\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83D\uDC71\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83D\uDC71\uD83C\uDFFF", "\uD83D\uDC71\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83D\uDC71\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83D\uDC72\uD83C\uDFFB", "\uD83D\uDC72\uD83C\uDFFC", "\uD83D\uDC72\uD83C\uDFFD", "\uD83D\uDC72\uD83C\uDFFE", "\uD83D\uDC72\uD83C\uDFFF", "\uD83D\uDC73\u200D\u2640\uFE0F", "\uD83D\uDC73\u200D\u2642\uFE0F", "\uD83D\uDC73\uD83C\uDFFB", "\uD83D\uDC73\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83D\uDC73\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83D\uDC73\uD83C\uDFFC", "\uD83D\uDC73\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83D\uDC73\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83D\uDC73\uD83C\uDFFD", "\uD83D\uDC73\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83D\uDC73\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83D\uDC73\uD83C\uDFFE", "\uD83D\uDC73\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83D\uDC73\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83D\uDC73\uD83C\uDFFF", "\uD83D\uDC73\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83D\uDC73\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83D\uDC74\uD83C\uDFFB", "\uD83D\uDC74\uD83C\uDFFC", "\uD83D\uDC74\uD83C\uDFFD", "\uD83D\uDC74\uD83C\uDFFE", "\uD83D\uDC74\uD83C\uDFFF", "\uD83D\uDC75\uD83C\uDFFB", "\uD83D\uDC75\uD83C\uDFFC", "\uD83D\uDC75\uD83C\uDFFD", "\uD83D\uDC75\uD83C\uDFFE", "\uD83D\uDC75\uD83C\uDFFF", "\uD83D\uDC76\uD83C\uDFFB", "\uD83D\uDC76\uD83C\uDFFC", "\uD83D\uDC76\uD83C\uDFFD", "\uD83D\uDC76\uD83C\uDFFE", "\uD83D\uDC76\uD83C\uDFFF", "\uD83D\uDC77\u200D\u2640\uFE0F", "\uD83D\uDC77\u200D\u2642\uFE0F", "\uD83D\uDC77\uD83C\uDFFB", "\uD83D\uDC77\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83D\uDC77\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83D\uDC77\uD83C\uDFFC", "\uD83D\uDC77\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83D\uDC77\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83D\uDC77\uD83C\uDFFD", "\uD83D\uDC77\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83D\uDC77\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83D\uDC77\uD83C\uDFFE", "\uD83D\uDC77\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83D\uDC77\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83D\uDC77\uD83C\uDFFF", "\uD83D\uDC77\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83D\uDC77\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83D\uDC78\uD83C\uDFFB", "\uD83D\uDC78\uD83C\uDFFC", "\uD83D\uDC78\uD83C\uDFFD", "\uD83D\uDC78\uD83C\uDFFE", "\uD83D\uDC78\uD83C\uDFFF", "\uD83D\uDC7C\uD83C\uDFFB", "\uD83D\uDC7C\uD83C\uDFFC", "\uD83D\uDC7C\uD83C\uDFFD", "\uD83D\uDC7C\uD83C\uDFFE", "\uD83D\uDC7C\uD83C\uDFFF", "\uD83D\uDC81\u200D\u2640\uFE0F", "\uD83D\uDC81\u200D\u2642\uFE0F", "\uD83D\uDC81\uD83C\uDFFB", "\uD83D\uDC81\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83D\uDC81\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83D\uDC81\uD83C\uDFFC", "\uD83D\uDC81\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83D\uDC81\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83D\uDC81\uD83C\uDFFD", "\uD83D\uDC81\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83D\uDC81\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83D\uDC81\uD83C\uDFFE", "\uD83D\uDC81\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83D\uDC81\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83D\uDC81\uD83C\uDFFF", "\uD83D\uDC81\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83D\uDC81\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83D\uDC82\u200D\u2640\uFE0F", "\uD83D\uDC82\u200D\u2642\uFE0F", "\uD83D\uDC82\uD83C\uDFFB", "\uD83D\uDC82\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83D\uDC82\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83D\uDC82\uD83C\uDFFC", "\uD83D\uDC82\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83D\uDC82\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83D\uDC82\uD83C\uDFFD", "\uD83D\uDC82\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83D\uDC82\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83D\uDC82\uD83C\uDFFE", "\uD83D\uDC82\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83D\uDC82\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83D\uDC82\uD83C\uDFFF", "\uD83D\uDC82\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83D\uDC82\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83D\uDC83\uD83C\uDFFB", "\uD83D\uDC83\uD83C\uDFFC", "\uD83D\uDC83\uD83C\uDFFD", "\uD83D\uDC83\uD83C\uDFFE", "\uD83D\uDC83\uD83C\uDFFF", "\uD83D\uDC85\uD83C\uDFFB", "\uD83D\uDC85\uD83C\uDFFC", "\uD83D\uDC85\uD83C\uDFFD", "\uD83D\uDC85\uD83C\uDFFE", "\uD83D\uDC85\uD83C\uDFFF", "\uD83D\uDC86\u200D\u2640\uFE0F", "\uD83D\uDC86\u200D\u2642\uFE0F", "\uD83D\uDC86\uD83C\uDFFB", "\uD83D\uDC86\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83D\uDC86\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83D\uDC86\uD83C\uDFFC", "\uD83D\uDC86\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83D\uDC86\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83D\uDC86\uD83C\uDFFD", "\uD83D\uDC86\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83D\uDC86\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83D\uDC86\uD83C\uDFFE", "\uD83D\uDC86\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83D\uDC86\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83D\uDC86\uD83C\uDFFF", "\uD83D\uDC86\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83D\uDC86\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83D\uDC87\u200D\u2640\uFE0F", "\uD83D\uDC87\u200D\u2642\uFE0F", "\uD83D\uDC87\uD83C\uDFFB", "\uD83D\uDC87\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83D\uDC87\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83D\uDC87\uD83C\uDFFC", "\uD83D\uDC87\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83D\uDC87\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83D\uDC87\uD83C\uDFFD", "\uD83D\uDC87\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83D\uDC87\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83D\uDC87\uD83C\uDFFE", "\uD83D\uDC87\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83D\uDC87\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83D\uDC87\uD83C\uDFFF", "\uD83D\uDC87\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83D\uDC87\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83D\uDC8F\uD83C\uDFFB", "\uD83D\uDC8F\uD83C\uDFFC", "\uD83D\uDC8F\uD83C\uDFFD", "\uD83D\uDC8F\uD83C\uDFFE", "\uD83D\uDC8F\uD83C\uDFFF", "\uD83D\uDC91\uD83C\uDFFB", "\uD83D\uDC91\uD83C\uDFFC", "\uD83D\uDC91\uD83C\uDFFD", "\uD83D\uDC91\uD83C\uDFFE", "\uD83D\uDC91\uD83C\uDFFF", "\uD83D\uDCAA\uD83C\uDFFB", "\uD83D\uDCAA\uD83C\uDFFC", "\uD83D\uDCAA\uD83C\uDFFD", "\uD83D\uDCAA\uD83C\uDFFE", "\uD83D\uDCAA\uD83C\uDFFF", "\uD83D\uDCFD\uFE0F", "\uD83D\uDD49\uFE0F", "\uD83D\uDD4A\uFE0F", "\uD83D\uDD6F\uFE0F", "\uD83D\uDD70\uFE0F", "\uD83D\uDD73\uFE0F", "\uD83D\uDD74\uD83C\uDFFB", "\uD83D\uDD74\uD83C\uDFFC", "\uD83D\uDD74\uD83C\uDFFD", "\uD83D\uDD74\uD83C\uDFFE", "\uD83D\uDD74\uD83C\uDFFF", "\uD83D\uDD74\uFE0F", "\uD83D\uDD75\uD83C\uDFFB", "\uD83D\uDD75\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83D\uDD75\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83D\uDD75\uD83C\uDFFC", "\uD83D\uDD75\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83D\uDD75\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83D\uDD75\uD83C\uDFFD", "\uD83D\uDD75\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83D\uDD75\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83D\uDD75\uD83C\uDFFE", "\uD83D\uDD75\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83D\uDD75\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83D\uDD75\uD83C\uDFFF", "\uD83D\uDD75\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83D\uDD75\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83D\uDD75\uFE0F", "\uD83D\uDD75\uFE0F\u200D\u2640\uFE0F", "\uD83D\uDD75\uFE0F\u200D\u2642\uFE0F", "\uD83D\uDD76\uFE0F", "\uD83D\uDD77\uFE0F", "\uD83D\uDD78\uFE0F", "\uD83D\uDD79\uFE0F", "\uD83D\uDD7A\uD83C\uDFFB", "\uD83D\uDD7A\uD83C\uDFFC", "\uD83D\uDD7A\uD83C\uDFFD", "\uD83D\uDD7A\uD83C\uDFFE", "\uD83D\uDD7A\uD83C\uDFFF", "\uD83D\uDD87\uFE0F", "\uD83D\uDD8A\uFE0F", "\uD83D\uDD8B\uFE0F", "\uD83D\uDD8C\uFE0F", "\uD83D\uDD8D\uFE0F", "\uD83D\uDD90\uD83C\uDFFB", "\uD83D\uDD90\uD83C\uDFFC", "\uD83D\uDD90\uD83C\uDFFD", "\uD83D\uDD90\uD83C\uDFFE", "\uD83D\uDD90\uD83C\uDFFF", "\uD83D\uDD90\uFE0F", "\uD83D\uDD95\uD83C\uDFFB", "\uD83D\uDD95\uD83C\uDFFC", "\uD83D\uDD95\uD83C\uDFFD", "\uD83D\uDD95\uD83C\uDFFE", "\uD83D\uDD95\uD83C\uDFFF", "\uD83D\uDD96\uD83C\uDFFB", "\uD83D\uDD96\uD83C\uDFFC", "\uD83D\uDD96\uD83C\uDFFD", "\uD83D\uDD96\uD83C\uDFFE", "\uD83D\uDD96\uD83C\uDFFF", "\uD83D\uDDA5\uFE0F", "\uD83D\uDDA8\uFE0F", "\uD83D\uDDB1\uFE0F", "\uD83D\uDDB2\uFE0F", "\uD83D\uDDBC\uFE0F", "\uD83D\uDDC2\uFE0F", "\uD83D\uDDC3\uFE0F", "\uD83D\uDDC4\uFE0F", "\uD83D\uDDD1\uFE0F", "\uD83D\uDDD2\uFE0F", "\uD83D\uDDD3\uFE0F", "\uD83D\uDDDC\uFE0F", "\uD83D\uDDDD\uFE0F", "\uD83D\uDDDE\uFE0F", "\uD83D\uDDE1\uFE0F", "\uD83D\uDDE3\uFE0F", "\uD83D\uDDE8\uFE0F", "\uD83D\uDDEF\uFE0F", "\uD83D\uDDF3\uFE0F", "\uD83D\uDDFA\uFE0F", "\uD83D\uDE2E\u200D\uD83D\uDCA8", "\uD83D\uDE35\u200D\uD83D\uDCAB", "\uD83D\uDE36\u200D\uD83C\uDF2B\uFE0F", "\uD83D\uDE42\u200D\u2194\uFE0F", "\uD83D\uDE42\u200D\u2195\uFE0F", "\uD83D\uDE45\u200D\u2640\uFE0F", "\uD83D\uDE45\u200D\u2642\uFE0F", "\uD83D\uDE45\uD83C\uDFFB", "\uD83D\uDE45\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83D\uDE45\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83D\uDE45\uD83C\uDFFC", "\uD83D\uDE45\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83D\uDE45\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83D\uDE45\uD83C\uDFFD", "\uD83D\uDE45\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83D\uDE45\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83D\uDE45\uD83C\uDFFE", "\uD83D\uDE45\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83D\uDE45\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83D\uDE45\uD83C\uDFFF", "\uD83D\uDE45\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83D\uDE45\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83D\uDE46\u200D\u2640\uFE0F", "\uD83D\uDE46\u200D\u2642\uFE0F", "\uD83D\uDE46\uD83C\uDFFB", "\uD83D\uDE46\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83D\uDE46\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83D\uDE46\uD83C\uDFFC", "\uD83D\uDE46\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83D\uDE46\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83D\uDE46\uD83C\uDFFD", "\uD83D\uDE46\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83D\uDE46\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83D\uDE46\uD83C\uDFFE", "\uD83D\uDE46\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83D\uDE46\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83D\uDE46\uD83C\uDFFF", "\uD83D\uDE46\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83D\uDE46\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83D\uDE47\u200D\u2640\uFE0F", "\uD83D\uDE47\u200D\u2642\uFE0F", "\uD83D\uDE47\uD83C\uDFFB", "\uD83D\uDE47\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83D\uDE47\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83D\uDE47\uD83C\uDFFC", "\uD83D\uDE47\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83D\uDE47\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83D\uDE47\uD83C\uDFFD", "\uD83D\uDE47\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83D\uDE47\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83D\uDE47\uD83C\uDFFE", "\uD83D\uDE47\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83D\uDE47\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83D\uDE47\uD83C\uDFFF", "\uD83D\uDE47\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83D\uDE47\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83D\uDE4B\u200D\u2640\uFE0F", "\uD83D\uDE4B\u200D\u2642\uFE0F", "\uD83D\uDE4B\uD83C\uDFFB", "\uD83D\uDE4B\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83D\uDE4B\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83D\uDE4B\uD83C\uDFFC", "\uD83D\uDE4B\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83D\uDE4B\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83D\uDE4B\uD83C\uDFFD", "\uD83D\uDE4B\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83D\uDE4B\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83D\uDE4B\uD83C\uDFFE", "\uD83D\uDE4B\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83D\uDE4B\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83D\uDE4B\uD83C\uDFFF", "\uD83D\uDE4B\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83D\uDE4B\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83D\uDE4C\uD83C\uDFFB", "\uD83D\uDE4C\uD83C\uDFFC", "\uD83D\uDE4C\uD83C\uDFFD", "\uD83D\uDE4C\uD83C\uDFFE", "\uD83D\uDE4C\uD83C\uDFFF", "\uD83D\uDE4D\u200D\u2640\uFE0F", "\uD83D\uDE4D\u200D\u2642\uFE0F", "\uD83D\uDE4D\uD83C\uDFFB", "\uD83D\uDE4D\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83D\uDE4D\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83D\uDE4D\uD83C\uDFFC", "\uD83D\uDE4D\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83D\uDE4D\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83D\uDE4D\uD83C\uDFFD", "\uD83D\uDE4D\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83D\uDE4D\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83D\uDE4D\uD83C\uDFFE", "\uD83D\uDE4D\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83D\uDE4D\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83D\uDE4D\uD83C\uDFFF", "\uD83D\uDE4D\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83D\uDE4D\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83D\uDE4E\u200D\u2640\uFE0F", "\uD83D\uDE4E\u200D\u2642\uFE0F", "\uD83D\uDE4E\uD83C\uDFFB", "\uD83D\uDE4E\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83D\uDE4E\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83D\uDE4E\uD83C\uDFFC", "\uD83D\uDE4E\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83D\uDE4E\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83D\uDE4E\uD83C\uDFFD", "\uD83D\uDE4E\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83D\uDE4E\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83D\uDE4E\uD83C\uDFFE", "\uD83D\uDE4E\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83D\uDE4E\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83D\uDE4E\uD83C\uDFFF", "\uD83D\uDE4E\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83D\uDE4E\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83D\uDE4F\uD83C\uDFFB", "\uD83D\uDE4F\uD83C\uDFFC", "\uD83D\uDE4F\uD83C\uDFFD", "\uD83D\uDE4F\uD83C\uDFFE", "\uD83D\uDE4F\uD83C\uDFFF", "\uD83D\uDEA3\u200D\u2640\uFE0F", "\uD83D\uDEA3\u200D\u2642\uFE0F", "\uD83D\uDEA3\uD83C\uDFFB", "\uD83D\uDEA3\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83D\uDEA3\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83D\uDEA3\uD83C\uDFFC", "\uD83D\uDEA3\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83D\uDEA3\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83D\uDEA3\uD83C\uDFFD", "\uD83D\uDEA3\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83D\uDEA3\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83D\uDEA3\uD83C\uDFFE", "\uD83D\uDEA3\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83D\uDEA3\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83D\uDEA3\uD83C\uDFFF", "\uD83D\uDEA3\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83D\uDEA3\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83D\uDEB4\u200D\u2640\uFE0F", "\uD83D\uDEB4\u200D\u2642\uFE0F", "\uD83D\uDEB4\uD83C\uDFFB", "\uD83D\uDEB4\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83D\uDEB4\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83D\uDEB4\uD83C\uDFFC", "\uD83D\uDEB4\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83D\uDEB4\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83D\uDEB4\uD83C\uDFFD", "\uD83D\uDEB4\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83D\uDEB4\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83D\uDEB4\uD83C\uDFFE", "\uD83D\uDEB4\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83D\uDEB4\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83D\uDEB4\uD83C\uDFFF", "\uD83D\uDEB4\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83D\uDEB4\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83D\uDEB5\u200D\u2640\uFE0F", "\uD83D\uDEB5\u200D\u2642\uFE0F", "\uD83D\uDEB5\uD83C\uDFFB", "\uD83D\uDEB5\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83D\uDEB5\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83D\uDEB5\uD83C\uDFFC", "\uD83D\uDEB5\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83D\uDEB5\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83D\uDEB5\uD83C\uDFFD", "\uD83D\uDEB5\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83D\uDEB5\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83D\uDEB5\uD83C\uDFFE", "\uD83D\uDEB5\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83D\uDEB5\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83D\uDEB5\uD83C\uDFFF", "\uD83D\uDEB5\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83D\uDEB5\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83D\uDEB6\u200D\u2640\uFE0F", "\uD83D\uDEB6\u200D\u2640\uFE0F\u200D\u27A1\uFE0F", "\uD83D\uDEB6\u200D\u2642\uFE0F", "\uD83D\uDEB6\u200D\u2642\uFE0F\u200D\u27A1\uFE0F", "\uD83D\uDEB6\u200D\u27A1\uFE0F", "\uD83D\uDEB6\uD83C\uDFFB", "\uD83D\uDEB6\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83D\uDEB6\uD83C\uDFFB\u200D\u2640\uFE0F\u200D\u27A1\uFE0F", "\uD83D\uDEB6\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83D\uDEB6\uD83C\uDFFB\u200D\u2642\uFE0F\u200D\u27A1\uFE0F", "\uD83D\uDEB6\uD83C\uDFFB\u200D\u27A1\uFE0F", "\uD83D\uDEB6\uD83C\uDFFC", "\uD83D\uDEB6\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83D\uDEB6\uD83C\uDFFC\u200D\u2640\uFE0F\u200D\u27A1\uFE0F", "\uD83D\uDEB6\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83D\uDEB6\uD83C\uDFFC\u200D\u2642\uFE0F\u200D\u27A1\uFE0F", "\uD83D\uDEB6\uD83C\uDFFC\u200D\u27A1\uFE0F", "\uD83D\uDEB6\uD83C\uDFFD", "\uD83D\uDEB6\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83D\uDEB6\uD83C\uDFFD\u200D\u2640\uFE0F\u200D\u27A1\uFE0F", "\uD83D\uDEB6\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83D\uDEB6\uD83C\uDFFD\u200D\u2642\uFE0F\u200D\u27A1\uFE0F", "\uD83D\uDEB6\uD83C\uDFFD\u200D\u27A1\uFE0F", "\uD83D\uDEB6\uD83C\uDFFE", "\uD83D\uDEB6\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83D\uDEB6\uD83C\uDFFE\u200D\u2640\uFE0F\u200D\u27A1\uFE0F", "\uD83D\uDEB6\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83D\uDEB6\uD83C\uDFFE\u200D\u2642\uFE0F\u200D\u27A1\uFE0F", "\uD83D\uDEB6\uD83C\uDFFE\u200D\u27A1\uFE0F", "\uD83D\uDEB6\uD83C\uDFFF", "\uD83D\uDEB6\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83D\uDEB6\uD83C\uDFFF\u200D\u2640\uFE0F\u200D\u27A1\uFE0F", "\uD83D\uDEB6\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83D\uDEB6\uD83C\uDFFF\u200D\u2642\uFE0F\u200D\u27A1\uFE0F", "\uD83D\uDEB6\uD83C\uDFFF\u200D\u27A1\uFE0F", "\uD83D\uDEC0\uD83C\uDFFB", "\uD83D\uDEC0\uD83C\uDFFC", "\uD83D\uDEC0\uD83C\uDFFD", "\uD83D\uDEC0\uD83C\uDFFE", "\uD83D\uDEC0\uD83C\uDFFF", "\uD83D\uDECB\uFE0F", "\uD83D\uDECC\uD83C\uDFFB", "\uD83D\uDECC\uD83C\uDFFC", "\uD83D\uDECC\uD83C\uDFFD", "\uD83D\uDECC\uD83C\uDFFE", "\uD83D\uDECC\uD83C\uDFFF", "\uD83D\uDECD\uFE0F", "\uD83D\uDECE\uFE0F", "\uD83D\uDECF\uFE0F", "\uD83D\uDEE0\uFE0F", "\uD83D\uDEE1\uFE0F", "\uD83D\uDEE2\uFE0F", "\uD83D\uDEE3\uFE0F", "\uD83D\uDEE4\uFE0F", "\uD83D\uDEE5\uFE0F", "\uD83D\uDEE9\uFE0F", "\uD83D\uDEF0\uFE0F", "\uD83D\uDEF3\uFE0F", "\uD83E\uDD0C\uD83C\uDFFB", "\uD83E\uDD0C\uD83C\uDFFC", "\uD83E\uDD0C\uD83C\uDFFD", "\uD83E\uDD0C\uD83C\uDFFE", "\uD83E\uDD0C\uD83C\uDFFF", "\uD83E\uDD0F\uD83C\uDFFB", "\uD83E\uDD0F\uD83C\uDFFC", "\uD83E\uDD0F\uD83C\uDFFD", "\uD83E\uDD0F\uD83C\uDFFE", "\uD83E\uDD0F\uD83C\uDFFF", "\uD83E\uDD18\uD83C\uDFFB", "\uD83E\uDD18\uD83C\uDFFC", "\uD83E\uDD18\uD83C\uDFFD", "\uD83E\uDD18\uD83C\uDFFE", "\uD83E\uDD18\uD83C\uDFFF", "\uD83E\uDD19\uD83C\uDFFB", "\uD83E\uDD19\uD83C\uDFFC", "\uD83E\uDD19\uD83C\uDFFD", "\uD83E\uDD19\uD83C\uDFFE", "\uD83E\uDD19\uD83C\uDFFF", "\uD83E\uDD1A\uD83C\uDFFB", "\uD83E\uDD1A\uD83C\uDFFC", "\uD83E\uDD1A\uD83C\uDFFD", "\uD83E\uDD1A\uD83C\uDFFE", "\uD83E\uDD1A\uD83C\uDFFF", "\uD83E\uDD1B\uD83C\uDFFB", "\uD83E\uDD1B\uD83C\uDFFC", "\uD83E\uDD1B\uD83C\uDFFD", "\uD83E\uDD1B\uD83C\uDFFE", "\uD83E\uDD1B\uD83C\uDFFF", "\uD83E\uDD1C\uD83C\uDFFB", "\uD83E\uDD1C\uD83C\uDFFC", "\uD83E\uDD1C\uD83C\uDFFD", "\uD83E\uDD1C\uD83C\uDFFE", "\uD83E\uDD1C\uD83C\uDFFF", "\uD83E\uDD1D\uD83C\uDFFB", "\uD83E\uDD1D\uD83C\uDFFC", "\uD83E\uDD1D\uD83C\uDFFD", "\uD83E\uDD1D\uD83C\uDFFE", "\uD83E\uDD1D\uD83C\uDFFF", "\uD83E\uDD1E\uD83C\uDFFB", "\uD83E\uDD1E\uD83C\uDFFC", "\uD83E\uDD1E\uD83C\uDFFD", "\uD83E\uDD1E\uD83C\uDFFE", "\uD83E\uDD1E\uD83C\uDFFF", "\uD83E\uDD1F\uD83C\uDFFB", "\uD83E\uDD1F\uD83C\uDFFC", "\uD83E\uDD1F\uD83C\uDFFD", "\uD83E\uDD1F\uD83C\uDFFE", "\uD83E\uDD1F\uD83C\uDFFF", "\uD83E\uDD26\u200D\u2640\uFE0F", "\uD83E\uDD26\u200D\u2642\uFE0F", "\uD83E\uDD26\uD83C\uDFFB", "\uD83E\uDD26\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83E\uDD26\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83E\uDD26\uD83C\uDFFC", "\uD83E\uDD26\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83E\uDD26\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83E\uDD26\uD83C\uDFFD", "\uD83E\uDD26\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83E\uDD26\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83E\uDD26\uD83C\uDFFE", "\uD83E\uDD26\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83E\uDD26\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83E\uDD26\uD83C\uDFFF", "\uD83E\uDD26\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83E\uDD26\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83E\uDD30\uD83C\uDFFB", "\uD83E\uDD30\uD83C\uDFFC", "\uD83E\uDD30\uD83C\uDFFD", "\uD83E\uDD30\uD83C\uDFFE", "\uD83E\uDD30\uD83C\uDFFF", "\uD83E\uDD31\uD83C\uDFFB", "\uD83E\uDD31\uD83C\uDFFC", "\uD83E\uDD31\uD83C\uDFFD", "\uD83E\uDD31\uD83C\uDFFE", "\uD83E\uDD31\uD83C\uDFFF", "\uD83E\uDD32\uD83C\uDFFB", "\uD83E\uDD32\uD83C\uDFFC", "\uD83E\uDD32\uD83C\uDFFD", "\uD83E\uDD32\uD83C\uDFFE", "\uD83E\uDD32\uD83C\uDFFF", "\uD83E\uDD33\uD83C\uDFFB", "\uD83E\uDD33\uD83C\uDFFC", "\uD83E\uDD33\uD83C\uDFFD", "\uD83E\uDD33\uD83C\uDFFE", "\uD83E\uDD33\uD83C\uDFFF", "\uD83E\uDD34\uD83C\uDFFB", "\uD83E\uDD34\uD83C\uDFFC", "\uD83E\uDD34\uD83C\uDFFD", "\uD83E\uDD34\uD83C\uDFFE", "\uD83E\uDD34\uD83C\uDFFF", "\uD83E\uDD35\u200D\u2640\uFE0F", "\uD83E\uDD35\u200D\u2642\uFE0F", "\uD83E\uDD35\uD83C\uDFFB", "\uD83E\uDD35\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83E\uDD35\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83E\uDD35\uD83C\uDFFC", "\uD83E\uDD35\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83E\uDD35\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83E\uDD35\uD83C\uDFFD", "\uD83E\uDD35\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83E\uDD35\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83E\uDD35\uD83C\uDFFE", "\uD83E\uDD35\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83E\uDD35\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83E\uDD35\uD83C\uDFFF", "\uD83E\uDD35\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83E\uDD35\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83E\uDD36\uD83C\uDFFB", "\uD83E\uDD36\uD83C\uDFFC", "\uD83E\uDD36\uD83C\uDFFD", "\uD83E\uDD36\uD83C\uDFFE", "\uD83E\uDD36\uD83C\uDFFF", "\uD83E\uDD37\u200D\u2640\uFE0F", "\uD83E\uDD37\u200D\u2642\uFE0F", "\uD83E\uDD37\uD83C\uDFFB", "\uD83E\uDD37\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83E\uDD37\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83E\uDD37\uD83C\uDFFC", "\uD83E\uDD37\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83E\uDD37\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83E\uDD37\uD83C\uDFFD", "\uD83E\uDD37\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83E\uDD37\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83E\uDD37\uD83C\uDFFE", "\uD83E\uDD37\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83E\uDD37\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83E\uDD37\uD83C\uDFFF", "\uD83E\uDD37\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83E\uDD37\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83E\uDD38\u200D\u2640\uFE0F", "\uD83E\uDD38\u200D\u2642\uFE0F", "\uD83E\uDD38\uD83C\uDFFB", "\uD83E\uDD38\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83E\uDD38\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83E\uDD38\uD83C\uDFFC", "\uD83E\uDD38\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83E\uDD38\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83E\uDD38\uD83C\uDFFD", "\uD83E\uDD38\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83E\uDD38\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83E\uDD38\uD83C\uDFFE", "\uD83E\uDD38\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83E\uDD38\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83E\uDD38\uD83C\uDFFF", "\uD83E\uDD38\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83E\uDD38\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83E\uDD39\u200D\u2640\uFE0F", "\uD83E\uDD39\u200D\u2642\uFE0F", "\uD83E\uDD39\uD83C\uDFFB", "\uD83E\uDD39\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83E\uDD39\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83E\uDD39\uD83C\uDFFC", "\uD83E\uDD39\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83E\uDD39\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83E\uDD39\uD83C\uDFFD", "\uD83E\uDD39\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83E\uDD39\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83E\uDD39\uD83C\uDFFE", "\uD83E\uDD39\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83E\uDD39\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83E\uDD39\uD83C\uDFFF", "\uD83E\uDD39\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83E\uDD39\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83E\uDD3C\u200D\u2640\uFE0F", "\uD83E\uDD3C\u200D\u2642\uFE0F", "\uD83E\uDD3D\u200D\u2640\uFE0F", "\uD83E\uDD3D\u200D\u2642\uFE0F", "\uD83E\uDD3D\uD83C\uDFFB", "\uD83E\uDD3D\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83E\uDD3D\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83E\uDD3D\uD83C\uDFFC", "\uD83E\uDD3D\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83E\uDD3D\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83E\uDD3D\uD83C\uDFFD", "\uD83E\uDD3D\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83E\uDD3D\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83E\uDD3D\uD83C\uDFFE", "\uD83E\uDD3D\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83E\uDD3D\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83E\uDD3D\uD83C\uDFFF", "\uD83E\uDD3D\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83E\uDD3D\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83E\uDD3E\u200D\u2640\uFE0F", "\uD83E\uDD3E\u200D\u2642\uFE0F", "\uD83E\uDD3E\uD83C\uDFFB", "\uD83E\uDD3E\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83E\uDD3E\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83E\uDD3E\uD83C\uDFFC", "\uD83E\uDD3E\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83E\uDD3E\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83E\uDD3E\uD83C\uDFFD", "\uD83E\uDD3E\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83E\uDD3E\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83E\uDD3E\uD83C\uDFFE", "\uD83E\uDD3E\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83E\uDD3E\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83E\uDD3E\uD83C\uDFFF", "\uD83E\uDD3E\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83E\uDD3E\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83E\uDD77\uD83C\uDFFB", "\uD83E\uDD77\uD83C\uDFFC", "\uD83E\uDD77\uD83C\uDFFD", "\uD83E\uDD77\uD83C\uDFFE", "\uD83E\uDD77\uD83C\uDFFF", "\uD83E\uDDB5\uD83C\uDFFB", "\uD83E\uDDB5\uD83C\uDFFC", "\uD83E\uDDB5\uD83C\uDFFD", "\uD83E\uDDB5\uD83C\uDFFE", "\uD83E\uDDB5\uD83C\uDFFF", "\uD83E\uDDB6\uD83C\uDFFB", "\uD83E\uDDB6\uD83C\uDFFC", "\uD83E\uDDB6\uD83C\uDFFD", "\uD83E\uDDB6\uD83C\uDFFE", "\uD83E\uDDB6\uD83C\uDFFF", "\uD83E\uDDB8\u200D\u2640\uFE0F", "\uD83E\uDDB8\u200D\u2642\uFE0F", "\uD83E\uDDB8\uD83C\uDFFB", "\uD83E\uDDB8\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83E\uDDB8\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83E\uDDB8\uD83C\uDFFC", "\uD83E\uDDB8\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83E\uDDB8\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83E\uDDB8\uD83C\uDFFD", "\uD83E\uDDB8\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83E\uDDB8\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83E\uDDB8\uD83C\uDFFE", "\uD83E\uDDB8\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83E\uDDB8\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83E\uDDB8\uD83C\uDFFF", "\uD83E\uDDB8\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83E\uDDB8\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83E\uDDB9\u200D\u2640\uFE0F", "\uD83E\uDDB9\u200D\u2642\uFE0F", "\uD83E\uDDB9\uD83C\uDFFB", "\uD83E\uDDB9\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83E\uDDB9\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83E\uDDB9\uD83C\uDFFC", "\uD83E\uDDB9\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83E\uDDB9\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83E\uDDB9\uD83C\uDFFD", "\uD83E\uDDB9\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83E\uDDB9\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83E\uDDB9\uD83C\uDFFE", "\uD83E\uDDB9\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83E\uDDB9\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83E\uDDB9\uD83C\uDFFF", "\uD83E\uDDB9\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83E\uDDB9\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83E\uDDBB\uD83C\uDFFB", "\uD83E\uDDBB\uD83C\uDFFC", "\uD83E\uDDBB\uD83C\uDFFD", "\uD83E\uDDBB\uD83C\uDFFE", "\uD83E\uDDBB\uD83C\uDFFF", "\uD83E\uDDCD\u200D\u2640\uFE0F", "\uD83E\uDDCD\u200D\u2642\uFE0F", "\uD83E\uDDCD\uD83C\uDFFB", "\uD83E\uDDCD\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83E\uDDCD\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83E\uDDCD\uD83C\uDFFC", "\uD83E\uDDCD\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83E\uDDCD\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83E\uDDCD\uD83C\uDFFD", "\uD83E\uDDCD\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83E\uDDCD\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83E\uDDCD\uD83C\uDFFE", "\uD83E\uDDCD\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83E\uDDCD\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83E\uDDCD\uD83C\uDFFF", "\uD83E\uDDCD\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83E\uDDCD\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83E\uDDCE\u200D\u2640\uFE0F", "\uD83E\uDDCE\u200D\u2640\uFE0F\u200D\u27A1\uFE0F", "\uD83E\uDDCE\u200D\u2642\uFE0F", "\uD83E\uDDCE\u200D\u2642\uFE0F\u200D\u27A1\uFE0F", "\uD83E\uDDCE\u200D\u27A1\uFE0F", "\uD83E\uDDCE\uD83C\uDFFB", "\uD83E\uDDCE\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83E\uDDCE\uD83C\uDFFB\u200D\u2640\uFE0F\u200D\u27A1\uFE0F", "\uD83E\uDDCE\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83E\uDDCE\uD83C\uDFFB\u200D\u2642\uFE0F\u200D\u27A1\uFE0F", "\uD83E\uDDCE\uD83C\uDFFB\u200D\u27A1\uFE0F", "\uD83E\uDDCE\uD83C\uDFFC", "\uD83E\uDDCE\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83E\uDDCE\uD83C\uDFFC\u200D\u2640\uFE0F\u200D\u27A1\uFE0F", "\uD83E\uDDCE\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83E\uDDCE\uD83C\uDFFC\u200D\u2642\uFE0F\u200D\u27A1\uFE0F", "\uD83E\uDDCE\uD83C\uDFFC\u200D\u27A1\uFE0F", "\uD83E\uDDCE\uD83C\uDFFD", "\uD83E\uDDCE\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83E\uDDCE\uD83C\uDFFD\u200D\u2640\uFE0F\u200D\u27A1\uFE0F", "\uD83E\uDDCE\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83E\uDDCE\uD83C\uDFFD\u200D\u2642\uFE0F\u200D\u27A1\uFE0F", "\uD83E\uDDCE\uD83C\uDFFD\u200D\u27A1\uFE0F", "\uD83E\uDDCE\uD83C\uDFFE", "\uD83E\uDDCE\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83E\uDDCE\uD83C\uDFFE\u200D\u2640\uFE0F\u200D\u27A1\uFE0F", "\uD83E\uDDCE\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83E\uDDCE\uD83C\uDFFE\u200D\u2642\uFE0F\u200D\u27A1\uFE0F", "\uD83E\uDDCE\uD83C\uDFFE\u200D\u27A1\uFE0F", "\uD83E\uDDCE\uD83C\uDFFF", "\uD83E\uDDCE\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83E\uDDCE\uD83C\uDFFF\u200D\u2640\uFE0F\u200D\u27A1\uFE0F", "\uD83E\uDDCE\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83E\uDDCE\uD83C\uDFFF\u200D\u2642\uFE0F\u200D\u27A1\uFE0F", "\uD83E\uDDCE\uD83C\uDFFF\u200D\u27A1\uFE0F", "\uD83E\uDDCF\u200D\u2640\uFE0F", "\uD83E\uDDCF\u200D\u2642\uFE0F", "\uD83E\uDDCF\uD83C\uDFFB", "\uD83E\uDDCF\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83E\uDDCF\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83E\uDDCF\uD83C\uDFFC", "\uD83E\uDDCF\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83E\uDDCF\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83E\uDDCF\uD83C\uDFFD", "\uD83E\uDDCF\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83E\uDDCF\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83E\uDDCF\uD83C\uDFFE", "\uD83E\uDDCF\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83E\uDDCF\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83E\uDDCF\uD83C\uDFFF", "\uD83E\uDDCF\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83E\uDDCF\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83E\uDDD1\u200D\u2695\uFE0F", "\uD83E\uDDD1\u200D\u2696\uFE0F", "\uD83E\uDDD1\u200D\u2708\uFE0F", "\uD83E\uDDD1\u200D\uD83C\uDF3E", "\uD83E\uDDD1\u200D\uD83C\uDF73", "\uD83E\uDDD1\u200D\uD83C\uDF7C", "\uD83E\uDDD1\u200D\uD83C\uDF84", "\uD83E\uDDD1\u200D\uD83C\uDF93", "\uD83E\uDDD1\u200D\uD83C\uDFA4", "\uD83E\uDDD1\u200D\uD83C\uDFA8", "\uD83E\uDDD1\u200D\uD83C\uDFEB", "\uD83E\uDDD1\u200D\uD83C\uDFED", "\uD83E\uDDD1\u200D\uD83D\uDCBB", "\uD83E\uDDD1\u200D\uD83D\uDCBC", "\uD83E\uDDD1\u200D\uD83D\uDD27", "\uD83E\uDDD1\u200D\uD83D\uDD2C", "\uD83E\uDDD1\u200D\uD83D\uDE80", "\uD83E\uDDD1\u200D\uD83D\uDE92", "\uD83E\uDDD1\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1", "\uD83E\uDDD1\u200D\uD83E\uDDAF", "\uD83E\uDDD1\u200D\uD83E\uDDAF\u200D\u27A1\uFE0F", "\uD83E\uDDD1\u200D\uD83E\uDDB0", "\uD83E\uDDD1\u200D\uD83E\uDDB1", "\uD83E\uDDD1\u200D\uD83E\uDDB2", "\uD83E\uDDD1\u200D\uD83E\uDDB3", "\uD83E\uDDD1\u200D\uD83E\uDDBC", "\uD83E\uDDD1\u200D\uD83E\uDDBC\u200D\u27A1\uFE0F", "\uD83E\uDDD1\u200D\uD83E\uDDBD", "\uD83E\uDDD1\u200D\uD83E\uDDBD\u200D\u27A1\uFE0F", "\uD83E\uDDD1\u200D\uD83E\uDDD1\u200D\uD83E\uDDD2", "\uD83E\uDDD1\u200D\uD83E\uDDD1\u200D\uD83E\uDDD2\u200D\uD83E\uDDD2", "\uD83E\uDDD1\u200D\uD83E\uDDD2", "\uD83E\uDDD1\u200D\uD83E\uDDD2\u200D\uD83E\uDDD2", "\uD83E\uDDD1\uD83C\uDFFB", "\uD83E\uDDD1\uD83C\uDFFB\u200D\u2695\uFE0F", "\uD83E\uDDD1\uD83C\uDFFB\u200D\u2696\uFE0F", "\uD83E\uDDD1\uD83C\uDFFB\u200D\u2708\uFE0F", "\uD83E\uDDD1\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83E\uDDD1\uD83C\uDFFC", "\uD83E\uDDD1\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83E\uDDD1\uD83C\uDFFD", "\uD83E\uDDD1\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83E\uDDD1\uD83C\uDFFE", "\uD83E\uDDD1\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83E\uDDD1\uD83C\uDFFF", "\uD83E\uDDD1\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83E\uDDD1\uD83C\uDFFC", "\uD83E\uDDD1\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83E\uDDD1\uD83C\uDFFD", "\uD83E\uDDD1\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83E\uDDD1\uD83C\uDFFE", "\uD83E\uDDD1\uD83C\uDFFB\u200D\u2764\uFE0F\u200D\uD83E\uDDD1\uD83C\uDFFF", "\uD83E\uDDD1\uD83C\uDFFB\u200D\uD83C\uDF3E", "\uD83E\uDDD1\uD83C\uDFFB\u200D\uD83C\uDF73", "\uD83E\uDDD1\uD83C\uDFFB\u200D\uD83C\uDF7C", "\uD83E\uDDD1\uD83C\uDFFB\u200D\uD83C\uDF84", "\uD83E\uDDD1\uD83C\uDFFB\u200D\uD83C\uDF93", "\uD83E\uDDD1\uD83C\uDFFB\u200D\uD83C\uDFA4", "\uD83E\uDDD1\uD83C\uDFFB\u200D\uD83C\uDFA8", "\uD83E\uDDD1\uD83C\uDFFB\u200D\uD83C\uDFEB", "\uD83E\uDDD1\uD83C\uDFFB\u200D\uD83C\uDFED", "\uD83E\uDDD1\uD83C\uDFFB\u200D\uD83D\uDCBB", "\uD83E\uDDD1\uD83C\uDFFB\u200D\uD83D\uDCBC", "\uD83E\uDDD1\uD83C\uDFFB\u200D\uD83D\uDD27", "\uD83E\uDDD1\uD83C\uDFFB\u200D\uD83D\uDD2C", "\uD83E\uDDD1\uD83C\uDFFB\u200D\uD83D\uDE80", "\uD83E\uDDD1\uD83C\uDFFB\u200D\uD83D\uDE92", "\uD83E\uDDD1\uD83C\uDFFB\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1\uD83C\uDFFB", "\uD83E\uDDD1\uD83C\uDFFB\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1\uD83C\uDFFC", "\uD83E\uDDD1\uD83C\uDFFB\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1\uD83C\uDFFD", "\uD83E\uDDD1\uD83C\uDFFB\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1\uD83C\uDFFE", "\uD83E\uDDD1\uD83C\uDFFB\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1\uD83C\uDFFF", "\uD83E\uDDD1\uD83C\uDFFB\u200D\uD83E\uDDAF", "\uD83E\uDDD1\uD83C\uDFFB\u200D\uD83E\uDDAF\u200D\u27A1\uFE0F", "\uD83E\uDDD1\uD83C\uDFFB\u200D\uD83E\uDDB0", "\uD83E\uDDD1\uD83C\uDFFB\u200D\uD83E\uDDB1", "\uD83E\uDDD1\uD83C\uDFFB\u200D\uD83E\uDDB2", "\uD83E\uDDD1\uD83C\uDFFB\u200D\uD83E\uDDB3", "\uD83E\uDDD1\uD83C\uDFFB\u200D\uD83E\uDDBC", "\uD83E\uDDD1\uD83C\uDFFB\u200D\uD83E\uDDBC\u200D\u27A1\uFE0F", "\uD83E\uDDD1\uD83C\uDFFB\u200D\uD83E\uDDBD", "\uD83E\uDDD1\uD83C\uDFFB\u200D\uD83E\uDDBD\u200D\u27A1\uFE0F", "\uD83E\uDDD1\uD83C\uDFFC", "\uD83E\uDDD1\uD83C\uDFFC\u200D\u2695\uFE0F", "\uD83E\uDDD1\uD83C\uDFFC\u200D\u2696\uFE0F", "\uD83E\uDDD1\uD83C\uDFFC\u200D\u2708\uFE0F", "\uD83E\uDDD1\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83E\uDDD1\uD83C\uDFFB", "\uD83E\uDDD1\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83E\uDDD1\uD83C\uDFFD", "\uD83E\uDDD1\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83E\uDDD1\uD83C\uDFFE", "\uD83E\uDDD1\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83E\uDDD1\uD83C\uDFFF", "\uD83E\uDDD1\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83E\uDDD1\uD83C\uDFFB", "\uD83E\uDDD1\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83E\uDDD1\uD83C\uDFFD", "\uD83E\uDDD1\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83E\uDDD1\uD83C\uDFFE", "\uD83E\uDDD1\uD83C\uDFFC\u200D\u2764\uFE0F\u200D\uD83E\uDDD1\uD83C\uDFFF", "\uD83E\uDDD1\uD83C\uDFFC\u200D\uD83C\uDF3E", "\uD83E\uDDD1\uD83C\uDFFC\u200D\uD83C\uDF73", "\uD83E\uDDD1\uD83C\uDFFC\u200D\uD83C\uDF7C", "\uD83E\uDDD1\uD83C\uDFFC\u200D\uD83C\uDF84", "\uD83E\uDDD1\uD83C\uDFFC\u200D\uD83C\uDF93", "\uD83E\uDDD1\uD83C\uDFFC\u200D\uD83C\uDFA4", "\uD83E\uDDD1\uD83C\uDFFC\u200D\uD83C\uDFA8", "\uD83E\uDDD1\uD83C\uDFFC\u200D\uD83C\uDFEB", "\uD83E\uDDD1\uD83C\uDFFC\u200D\uD83C\uDFED", "\uD83E\uDDD1\uD83C\uDFFC\u200D\uD83D\uDCBB", "\uD83E\uDDD1\uD83C\uDFFC\u200D\uD83D\uDCBC", "\uD83E\uDDD1\uD83C\uDFFC\u200D\uD83D\uDD27", "\uD83E\uDDD1\uD83C\uDFFC\u200D\uD83D\uDD2C", "\uD83E\uDDD1\uD83C\uDFFC\u200D\uD83D\uDE80", "\uD83E\uDDD1\uD83C\uDFFC\u200D\uD83D\uDE92", "\uD83E\uDDD1\uD83C\uDFFC\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1\uD83C\uDFFB", "\uD83E\uDDD1\uD83C\uDFFC\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1\uD83C\uDFFC", "\uD83E\uDDD1\uD83C\uDFFC\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1\uD83C\uDFFD", "\uD83E\uDDD1\uD83C\uDFFC\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1\uD83C\uDFFE", "\uD83E\uDDD1\uD83C\uDFFC\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1\uD83C\uDFFF", "\uD83E\uDDD1\uD83C\uDFFC\u200D\uD83E\uDDAF", "\uD83E\uDDD1\uD83C\uDFFC\u200D\uD83E\uDDAF\u200D\u27A1\uFE0F", "\uD83E\uDDD1\uD83C\uDFFC\u200D\uD83E\uDDB0", "\uD83E\uDDD1\uD83C\uDFFC\u200D\uD83E\uDDB1", "\uD83E\uDDD1\uD83C\uDFFC\u200D\uD83E\uDDB2", "\uD83E\uDDD1\uD83C\uDFFC\u200D\uD83E\uDDB3", "\uD83E\uDDD1\uD83C\uDFFC\u200D\uD83E\uDDBC", "\uD83E\uDDD1\uD83C\uDFFC\u200D\uD83E\uDDBC\u200D\u27A1\uFE0F", "\uD83E\uDDD1\uD83C\uDFFC\u200D\uD83E\uDDBD", "\uD83E\uDDD1\uD83C\uDFFC\u200D\uD83E\uDDBD\u200D\u27A1\uFE0F", "\uD83E\uDDD1\uD83C\uDFFD", "\uD83E\uDDD1\uD83C\uDFFD\u200D\u2695\uFE0F", "\uD83E\uDDD1\uD83C\uDFFD\u200D\u2696\uFE0F", "\uD83E\uDDD1\uD83C\uDFFD\u200D\u2708\uFE0F", "\uD83E\uDDD1\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83E\uDDD1\uD83C\uDFFB", "\uD83E\uDDD1\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83E\uDDD1\uD83C\uDFFC", "\uD83E\uDDD1\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83E\uDDD1\uD83C\uDFFE", "\uD83E\uDDD1\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83E\uDDD1\uD83C\uDFFF", "\uD83E\uDDD1\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83E\uDDD1\uD83C\uDFFB", "\uD83E\uDDD1\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83E\uDDD1\uD83C\uDFFC", "\uD83E\uDDD1\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83E\uDDD1\uD83C\uDFFE", "\uD83E\uDDD1\uD83C\uDFFD\u200D\u2764\uFE0F\u200D\uD83E\uDDD1\uD83C\uDFFF", "\uD83E\uDDD1\uD83C\uDFFD\u200D\uD83C\uDF3E", "\uD83E\uDDD1\uD83C\uDFFD\u200D\uD83C\uDF73", "\uD83E\uDDD1\uD83C\uDFFD\u200D\uD83C\uDF7C", "\uD83E\uDDD1\uD83C\uDFFD\u200D\uD83C\uDF84", "\uD83E\uDDD1\uD83C\uDFFD\u200D\uD83C\uDF93", "\uD83E\uDDD1\uD83C\uDFFD\u200D\uD83C\uDFA4", "\uD83E\uDDD1\uD83C\uDFFD\u200D\uD83C\uDFA8", "\uD83E\uDDD1\uD83C\uDFFD\u200D\uD83C\uDFEB", "\uD83E\uDDD1\uD83C\uDFFD\u200D\uD83C\uDFED", "\uD83E\uDDD1\uD83C\uDFFD\u200D\uD83D\uDCBB", "\uD83E\uDDD1\uD83C\uDFFD\u200D\uD83D\uDCBC", "\uD83E\uDDD1\uD83C\uDFFD\u200D\uD83D\uDD27", "\uD83E\uDDD1\uD83C\uDFFD\u200D\uD83D\uDD2C", "\uD83E\uDDD1\uD83C\uDFFD\u200D\uD83D\uDE80", "\uD83E\uDDD1\uD83C\uDFFD\u200D\uD83D\uDE92", "\uD83E\uDDD1\uD83C\uDFFD\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1\uD83C\uDFFB", "\uD83E\uDDD1\uD83C\uDFFD\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1\uD83C\uDFFC", "\uD83E\uDDD1\uD83C\uDFFD\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1\uD83C\uDFFD", "\uD83E\uDDD1\uD83C\uDFFD\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1\uD83C\uDFFE", "\uD83E\uDDD1\uD83C\uDFFD\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1\uD83C\uDFFF", "\uD83E\uDDD1\uD83C\uDFFD\u200D\uD83E\uDDAF", "\uD83E\uDDD1\uD83C\uDFFD\u200D\uD83E\uDDAF\u200D\u27A1\uFE0F", "\uD83E\uDDD1\uD83C\uDFFD\u200D\uD83E\uDDB0", "\uD83E\uDDD1\uD83C\uDFFD\u200D\uD83E\uDDB1", "\uD83E\uDDD1\uD83C\uDFFD\u200D\uD83E\uDDB2", "\uD83E\uDDD1\uD83C\uDFFD\u200D\uD83E\uDDB3", "\uD83E\uDDD1\uD83C\uDFFD\u200D\uD83E\uDDBC", "\uD83E\uDDD1\uD83C\uDFFD\u200D\uD83E\uDDBC\u200D\u27A1\uFE0F", "\uD83E\uDDD1\uD83C\uDFFD\u200D\uD83E\uDDBD", "\uD83E\uDDD1\uD83C\uDFFD\u200D\uD83E\uDDBD\u200D\u27A1\uFE0F", "\uD83E\uDDD1\uD83C\uDFFE", "\uD83E\uDDD1\uD83C\uDFFE\u200D\u2695\uFE0F", "\uD83E\uDDD1\uD83C\uDFFE\u200D\u2696\uFE0F", "\uD83E\uDDD1\uD83C\uDFFE\u200D\u2708\uFE0F", "\uD83E\uDDD1\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83E\uDDD1\uD83C\uDFFB", "\uD83E\uDDD1\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83E\uDDD1\uD83C\uDFFC", "\uD83E\uDDD1\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83E\uDDD1\uD83C\uDFFD", "\uD83E\uDDD1\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83E\uDDD1\uD83C\uDFFF", "\uD83E\uDDD1\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83E\uDDD1\uD83C\uDFFB", "\uD83E\uDDD1\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83E\uDDD1\uD83C\uDFFC", "\uD83E\uDDD1\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83E\uDDD1\uD83C\uDFFD", "\uD83E\uDDD1\uD83C\uDFFE\u200D\u2764\uFE0F\u200D\uD83E\uDDD1\uD83C\uDFFF", "\uD83E\uDDD1\uD83C\uDFFE\u200D\uD83C\uDF3E", "\uD83E\uDDD1\uD83C\uDFFE\u200D\uD83C\uDF73", "\uD83E\uDDD1\uD83C\uDFFE\u200D\uD83C\uDF7C", "\uD83E\uDDD1\uD83C\uDFFE\u200D\uD83C\uDF84", "\uD83E\uDDD1\uD83C\uDFFE\u200D\uD83C\uDF93", "\uD83E\uDDD1\uD83C\uDFFE\u200D\uD83C\uDFA4", "\uD83E\uDDD1\uD83C\uDFFE\u200D\uD83C\uDFA8", "\uD83E\uDDD1\uD83C\uDFFE\u200D\uD83C\uDFEB", "\uD83E\uDDD1\uD83C\uDFFE\u200D\uD83C\uDFED", "\uD83E\uDDD1\uD83C\uDFFE\u200D\uD83D\uDCBB", "\uD83E\uDDD1\uD83C\uDFFE\u200D\uD83D\uDCBC", "\uD83E\uDDD1\uD83C\uDFFE\u200D\uD83D\uDD27", "\uD83E\uDDD1\uD83C\uDFFE\u200D\uD83D\uDD2C", "\uD83E\uDDD1\uD83C\uDFFE\u200D\uD83D\uDE80", "\uD83E\uDDD1\uD83C\uDFFE\u200D\uD83D\uDE92", "\uD83E\uDDD1\uD83C\uDFFE\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1\uD83C\uDFFB", "\uD83E\uDDD1\uD83C\uDFFE\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1\uD83C\uDFFC", "\uD83E\uDDD1\uD83C\uDFFE\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1\uD83C\uDFFD", "\uD83E\uDDD1\uD83C\uDFFE\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1\uD83C\uDFFE", "\uD83E\uDDD1\uD83C\uDFFE\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1\uD83C\uDFFF", "\uD83E\uDDD1\uD83C\uDFFE\u200D\uD83E\uDDAF", "\uD83E\uDDD1\uD83C\uDFFE\u200D\uD83E\uDDAF\u200D\u27A1\uFE0F", "\uD83E\uDDD1\uD83C\uDFFE\u200D\uD83E\uDDB0", "\uD83E\uDDD1\uD83C\uDFFE\u200D\uD83E\uDDB1", "\uD83E\uDDD1\uD83C\uDFFE\u200D\uD83E\uDDB2", "\uD83E\uDDD1\uD83C\uDFFE\u200D\uD83E\uDDB3", "\uD83E\uDDD1\uD83C\uDFFE\u200D\uD83E\uDDBC", "\uD83E\uDDD1\uD83C\uDFFE\u200D\uD83E\uDDBC\u200D\u27A1\uFE0F", "\uD83E\uDDD1\uD83C\uDFFE\u200D\uD83E\uDDBD", "\uD83E\uDDD1\uD83C\uDFFE\u200D\uD83E\uDDBD\u200D\u27A1\uFE0F", "\uD83E\uDDD1\uD83C\uDFFF", "\uD83E\uDDD1\uD83C\uDFFF\u200D\u2695\uFE0F", "\uD83E\uDDD1\uD83C\uDFFF\u200D\u2696\uFE0F", "\uD83E\uDDD1\uD83C\uDFFF\u200D\u2708\uFE0F", "\uD83E\uDDD1\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83E\uDDD1\uD83C\uDFFB", "\uD83E\uDDD1\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83E\uDDD1\uD83C\uDFFC", "\uD83E\uDDD1\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83E\uDDD1\uD83C\uDFFD", "\uD83E\uDDD1\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83D\uDC8B\u200D\uD83E\uDDD1\uD83C\uDFFE", "\uD83E\uDDD1\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83E\uDDD1\uD83C\uDFFB", "\uD83E\uDDD1\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83E\uDDD1\uD83C\uDFFC", "\uD83E\uDDD1\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83E\uDDD1\uD83C\uDFFD", "\uD83E\uDDD1\uD83C\uDFFF\u200D\u2764\uFE0F\u200D\uD83E\uDDD1\uD83C\uDFFE", "\uD83E\uDDD1\uD83C\uDFFF\u200D\uD83C\uDF3E", "\uD83E\uDDD1\uD83C\uDFFF\u200D\uD83C\uDF73", "\uD83E\uDDD1\uD83C\uDFFF\u200D\uD83C\uDF7C", "\uD83E\uDDD1\uD83C\uDFFF\u200D\uD83C\uDF84", "\uD83E\uDDD1\uD83C\uDFFF\u200D\uD83C\uDF93", "\uD83E\uDDD1\uD83C\uDFFF\u200D\uD83C\uDFA4", "\uD83E\uDDD1\uD83C\uDFFF\u200D\uD83C\uDFA8", "\uD83E\uDDD1\uD83C\uDFFF\u200D\uD83C\uDFEB", "\uD83E\uDDD1\uD83C\uDFFF\u200D\uD83C\uDFED", "\uD83E\uDDD1\uD83C\uDFFF\u200D\uD83D\uDCBB", "\uD83E\uDDD1\uD83C\uDFFF\u200D\uD83D\uDCBC", "\uD83E\uDDD1\uD83C\uDFFF\u200D\uD83D\uDD27", "\uD83E\uDDD1\uD83C\uDFFF\u200D\uD83D\uDD2C", "\uD83E\uDDD1\uD83C\uDFFF\u200D\uD83D\uDE80", "\uD83E\uDDD1\uD83C\uDFFF\u200D\uD83D\uDE92", "\uD83E\uDDD1\uD83C\uDFFF\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1\uD83C\uDFFB", "\uD83E\uDDD1\uD83C\uDFFF\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1\uD83C\uDFFC", "\uD83E\uDDD1\uD83C\uDFFF\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1\uD83C\uDFFD", "\uD83E\uDDD1\uD83C\uDFFF\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1\uD83C\uDFFE", "\uD83E\uDDD1\uD83C\uDFFF\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1\uD83C\uDFFF", "\uD83E\uDDD1\uD83C\uDFFF\u200D\uD83E\uDDAF", "\uD83E\uDDD1\uD83C\uDFFF\u200D\uD83E\uDDAF\u200D\u27A1\uFE0F", "\uD83E\uDDD1\uD83C\uDFFF\u200D\uD83E\uDDB0", "\uD83E\uDDD1\uD83C\uDFFF\u200D\uD83E\uDDB1", "\uD83E\uDDD1\uD83C\uDFFF\u200D\uD83E\uDDB2", "\uD83E\uDDD1\uD83C\uDFFF\u200D\uD83E\uDDB3", "\uD83E\uDDD1\uD83C\uDFFF\u200D\uD83E\uDDBC", "\uD83E\uDDD1\uD83C\uDFFF\u200D\uD83E\uDDBC\u200D\u27A1\uFE0F", "\uD83E\uDDD1\uD83C\uDFFF\u200D\uD83E\uDDBD", "\uD83E\uDDD1\uD83C\uDFFF\u200D\uD83E\uDDBD\u200D\u27A1\uFE0F", "\uD83E\uDDD2\uD83C\uDFFB", "\uD83E\uDDD2\uD83C\uDFFC", "\uD83E\uDDD2\uD83C\uDFFD", "\uD83E\uDDD2\uD83C\uDFFE", "\uD83E\uDDD2\uD83C\uDFFF", "\uD83E\uDDD3\uD83C\uDFFB", "\uD83E\uDDD3\uD83C\uDFFC", "\uD83E\uDDD3\uD83C\uDFFD", "\uD83E\uDDD3\uD83C\uDFFE", "\uD83E\uDDD3\uD83C\uDFFF", "\uD83E\uDDD4\u200D\u2640\uFE0F", "\uD83E\uDDD4\u200D\u2642\uFE0F", "\uD83E\uDDD4\uD83C\uDFFB", "\uD83E\uDDD4\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83E\uDDD4\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83E\uDDD4\uD83C\uDFFC", "\uD83E\uDDD4\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83E\uDDD4\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83E\uDDD4\uD83C\uDFFD", "\uD83E\uDDD4\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83E\uDDD4\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83E\uDDD4\uD83C\uDFFE", "\uD83E\uDDD4\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83E\uDDD4\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83E\uDDD4\uD83C\uDFFF", "\uD83E\uDDD4\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83E\uDDD4\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83E\uDDD5\uD83C\uDFFB", "\uD83E\uDDD5\uD83C\uDFFC", "\uD83E\uDDD5\uD83C\uDFFD", "\uD83E\uDDD5\uD83C\uDFFE", "\uD83E\uDDD5\uD83C\uDFFF", "\uD83E\uDDD6\u200D\u2640\uFE0F", "\uD83E\uDDD6\u200D\u2642\uFE0F", "\uD83E\uDDD6\uD83C\uDFFB", "\uD83E\uDDD6\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83E\uDDD6\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83E\uDDD6\uD83C\uDFFC", "\uD83E\uDDD6\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83E\uDDD6\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83E\uDDD6\uD83C\uDFFD", "\uD83E\uDDD6\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83E\uDDD6\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83E\uDDD6\uD83C\uDFFE", "\uD83E\uDDD6\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83E\uDDD6\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83E\uDDD6\uD83C\uDFFF", "\uD83E\uDDD6\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83E\uDDD6\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83E\uDDD7\u200D\u2640\uFE0F", "\uD83E\uDDD7\u200D\u2642\uFE0F", "\uD83E\uDDD7\uD83C\uDFFB", "\uD83E\uDDD7\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83E\uDDD7\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83E\uDDD7\uD83C\uDFFC", "\uD83E\uDDD7\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83E\uDDD7\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83E\uDDD7\uD83C\uDFFD", "\uD83E\uDDD7\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83E\uDDD7\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83E\uDDD7\uD83C\uDFFE", "\uD83E\uDDD7\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83E\uDDD7\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83E\uDDD7\uD83C\uDFFF", "\uD83E\uDDD7\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83E\uDDD7\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83E\uDDD8\u200D\u2640\uFE0F", "\uD83E\uDDD8\u200D\u2642\uFE0F", "\uD83E\uDDD8\uD83C\uDFFB", "\uD83E\uDDD8\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83E\uDDD8\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83E\uDDD8\uD83C\uDFFC", "\uD83E\uDDD8\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83E\uDDD8\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83E\uDDD8\uD83C\uDFFD", "\uD83E\uDDD8\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83E\uDDD8\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83E\uDDD8\uD83C\uDFFE", "\uD83E\uDDD8\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83E\uDDD8\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83E\uDDD8\uD83C\uDFFF", "\uD83E\uDDD8\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83E\uDDD8\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83E\uDDD9\u200D\u2640\uFE0F", "\uD83E\uDDD9\u200D\u2642\uFE0F", "\uD83E\uDDD9\uD83C\uDFFB", "\uD83E\uDDD9\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83E\uDDD9\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83E\uDDD9\uD83C\uDFFC", "\uD83E\uDDD9\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83E\uDDD9\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83E\uDDD9\uD83C\uDFFD", "\uD83E\uDDD9\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83E\uDDD9\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83E\uDDD9\uD83C\uDFFE", "\uD83E\uDDD9\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83E\uDDD9\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83E\uDDD9\uD83C\uDFFF", "\uD83E\uDDD9\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83E\uDDD9\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83E\uDDDA\u200D\u2640\uFE0F", "\uD83E\uDDDA\u200D\u2642\uFE0F", "\uD83E\uDDDA\uD83C\uDFFB", "\uD83E\uDDDA\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83E\uDDDA\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83E\uDDDA\uD83C\uDFFC", "\uD83E\uDDDA\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83E\uDDDA\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83E\uDDDA\uD83C\uDFFD", "\uD83E\uDDDA\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83E\uDDDA\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83E\uDDDA\uD83C\uDFFE", "\uD83E\uDDDA\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83E\uDDDA\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83E\uDDDA\uD83C\uDFFF", "\uD83E\uDDDA\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83E\uDDDA\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83E\uDDDB\u200D\u2640\uFE0F", "\uD83E\uDDDB\u200D\u2642\uFE0F", "\uD83E\uDDDB\uD83C\uDFFB", "\uD83E\uDDDB\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83E\uDDDB\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83E\uDDDB\uD83C\uDFFC", "\uD83E\uDDDB\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83E\uDDDB\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83E\uDDDB\uD83C\uDFFD", "\uD83E\uDDDB\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83E\uDDDB\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83E\uDDDB\uD83C\uDFFE", "\uD83E\uDDDB\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83E\uDDDB\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83E\uDDDB\uD83C\uDFFF", "\uD83E\uDDDB\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83E\uDDDB\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83E\uDDDC\u200D\u2640\uFE0F", "\uD83E\uDDDC\u200D\u2642\uFE0F", "\uD83E\uDDDC\uD83C\uDFFB", "\uD83E\uDDDC\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83E\uDDDC\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83E\uDDDC\uD83C\uDFFC", "\uD83E\uDDDC\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83E\uDDDC\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83E\uDDDC\uD83C\uDFFD", "\uD83E\uDDDC\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83E\uDDDC\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83E\uDDDC\uD83C\uDFFE", "\uD83E\uDDDC\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83E\uDDDC\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83E\uDDDC\uD83C\uDFFF", "\uD83E\uDDDC\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83E\uDDDC\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83E\uDDDD\u200D\u2640\uFE0F", "\uD83E\uDDDD\u200D\u2642\uFE0F", "\uD83E\uDDDD\uD83C\uDFFB", "\uD83E\uDDDD\uD83C\uDFFB\u200D\u2640\uFE0F", "\uD83E\uDDDD\uD83C\uDFFB\u200D\u2642\uFE0F", "\uD83E\uDDDD\uD83C\uDFFC", "\uD83E\uDDDD\uD83C\uDFFC\u200D\u2640\uFE0F", "\uD83E\uDDDD\uD83C\uDFFC\u200D\u2642\uFE0F", "\uD83E\uDDDD\uD83C\uDFFD", "\uD83E\uDDDD\uD83C\uDFFD\u200D\u2640\uFE0F", "\uD83E\uDDDD\uD83C\uDFFD\u200D\u2642\uFE0F", "\uD83E\uDDDD\uD83C\uDFFE", "\uD83E\uDDDD\uD83C\uDFFE\u200D\u2640\uFE0F", "\uD83E\uDDDD\uD83C\uDFFE\u200D\u2642\uFE0F", "\uD83E\uDDDD\uD83C\uDFFF", "\uD83E\uDDDD\uD83C\uDFFF\u200D\u2640\uFE0F", "\uD83E\uDDDD\uD83C\uDFFF\u200D\u2642\uFE0F", "\uD83E\uDDDE\u200D\u2640\uFE0F", "\uD83E\uDDDE\u200D\u2642\uFE0F", "\uD83E\uDDDF\u200D\u2640\uFE0F", "\uD83E\uDDDF\u200D\u2642\uFE0F", "\uD83E\uDEC3\uD83C\uDFFB", "\uD83E\uDEC3\uD83C\uDFFC", "\uD83E\uDEC3\uD83C\uDFFD", "\uD83E\uDEC3\uD83C\uDFFE", "\uD83E\uDEC3\uD83C\uDFFF", "\uD83E\uDEC4\uD83C\uDFFB", "\uD83E\uDEC4\uD83C\uDFFC", "\uD83E\uDEC4\uD83C\uDFFD", "\uD83E\uDEC4\uD83C\uDFFE", "\uD83E\uDEC4\uD83C\uDFFF", "\uD83E\uDEC5\uD83C\uDFFB", "\uD83E\uDEC5\uD83C\uDFFC", "\uD83E\uDEC5\uD83C\uDFFD", "\uD83E\uDEC5\uD83C\uDFFE", "\uD83E\uDEC5\uD83C\uDFFF", "\uD83E\uDEF0\uD83C\uDFFB", "\uD83E\uDEF0\uD83C\uDFFC", "\uD83E\uDEF0\uD83C\uDFFD", "\uD83E\uDEF0\uD83C\uDFFE", "\uD83E\uDEF0\uD83C\uDFFF", "\uD83E\uDEF1\uD83C\uDFFB", "\uD83E\uDEF1\uD83C\uDFFB\u200D\uD83E\uDEF2\uD83C\uDFFC", "\uD83E\uDEF1\uD83C\uDFFB\u200D\uD83E\uDEF2\uD83C\uDFFD", "\uD83E\uDEF1\uD83C\uDFFB\u200D\uD83E\uDEF2\uD83C\uDFFE", "\uD83E\uDEF1\uD83C\uDFFB\u200D\uD83E\uDEF2\uD83C\uDFFF", "\uD83E\uDEF1\uD83C\uDFFC", "\uD83E\uDEF1\uD83C\uDFFC\u200D\uD83E\uDEF2\uD83C\uDFFB", "\uD83E\uDEF1\uD83C\uDFFC\u200D\uD83E\uDEF2\uD83C\uDFFD", "\uD83E\uDEF1\uD83C\uDFFC\u200D\uD83E\uDEF2\uD83C\uDFFE", "\uD83E\uDEF1\uD83C\uDFFC\u200D\uD83E\uDEF2\uD83C\uDFFF", "\uD83E\uDEF1\uD83C\uDFFD", "\uD83E\uDEF1\uD83C\uDFFD\u200D\uD83E\uDEF2\uD83C\uDFFB", "\uD83E\uDEF1\uD83C\uDFFD\u200D\uD83E\uDEF2\uD83C\uDFFC", "\uD83E\uDEF1\uD83C\uDFFD\u200D\uD83E\uDEF2\uD83C\uDFFE", "\uD83E\uDEF1\uD83C\uDFFD\u200D\uD83E\uDEF2\uD83C\uDFFF", "\uD83E\uDEF1\uD83C\uDFFE", "\uD83E\uDEF1\uD83C\uDFFE\u200D\uD83E\uDEF2\uD83C\uDFFB", "\uD83E\uDEF1\uD83C\uDFFE\u200D\uD83E\uDEF2\uD83C\uDFFC", "\uD83E\uDEF1\uD83C\uDFFE\u200D\uD83E\uDEF2\uD83C\uDFFD", "\uD83E\uDEF1\uD83C\uDFFE\u200D\uD83E\uDEF2\uD83C\uDFFF", "\uD83E\uDEF1\uD83C\uDFFF", "\uD83E\uDEF1\uD83C\uDFFF\u200D\uD83E\uDEF2\uD83C\uDFFB", "\uD83E\uDEF1\uD83C\uDFFF\u200D\uD83E\uDEF2\uD83C\uDFFC", "\uD83E\uDEF1\uD83C\uDFFF\u200D\uD83E\uDEF2\uD83C\uDFFD", "\uD83E\uDEF1\uD83C\uDFFF\u200D\uD83E\uDEF2\uD83C\uDFFE", "\uD83E\uDEF2\uD83C\uDFFB", "\uD83E\uDEF2\uD83C\uDFFC", "\uD83E\uDEF2\uD83C\uDFFD", "\uD83E\uDEF2\uD83C\uDFFE", "\uD83E\uDEF2\uD83C\uDFFF", "\uD83E\uDEF3\uD83C\uDFFB", "\uD83E\uDEF3\uD83C\uDFFC", "\uD83E\uDEF3\uD83C\uDFFD", "\uD83E\uDEF3\uD83C\uDFFE", "\uD83E\uDEF3\uD83C\uDFFF", "\uD83E\uDEF4\uD83C\uDFFB", "\uD83E\uDEF4\uD83C\uDFFC", "\uD83E\uDEF4\uD83C\uDFFD", "\uD83E\uDEF4\uD83C\uDFFE", "\uD83E\uDEF4\uD83C\uDFFF", "\uD83E\uDEF5\uD83C\uDFFB", "\uD83E\uDEF5\uD83C\uDFFC", "\uD83E\uDEF5\uD83C\uDFFD", "\uD83E\uDEF5\uD83C\uDFFE", "\uD83E\uDEF5\uD83C\uDFFF", "\uD83E\uDEF6\uD83C\uDFFB", "\uD83E\uDEF6\uD83C\uDFFC", "\uD83E\uDEF6\uD83C\uDFFD", "\uD83E\uDEF6\uD83C\uDFFE", "\uD83E\uDEF6\uD83C\uDFFF", "\uD83E\uDEF7\uD83C\uDFFB", "\uD83E\uDEF7\uD83C\uDFFC", "\uD83E\uDEF7\uD83C\uDFFD", "\uD83E\uDEF7\uD83C\uDFFE", "\uD83E\uDEF7\uD83C\uDFFF", "\uD83E\uDEF8\uD83C\uDFFB", "\uD83E\uDEF8\uD83C\uDFFC", "\uD83E\uDEF8\uD83C\uDFFD", "\uD83E\uDEF8\uD83C\uDFFE", "\uD83E\uDEF8\uD83C\uDFFF"];
		    return RGI_Emoji;
		  }

		  var Adlam$1 = {};

		  var hasRequiredAdlam$1;
		  function requireAdlam$1() {
		    if (hasRequiredAdlam$1) return Adlam$1;
		    hasRequiredAdlam$1 = 1;
		    var set = regenerateExports(0x61F, 0x640);
		    set.addRange(0x1E900, 0x1E94B).addRange(0x1E950, 0x1E959).addRange(0x1E95E, 0x1E95F);
		    Adlam$1.characters = set;
		    return Adlam$1;
		  }

		  var Ahom$1 = {};

		  var hasRequiredAhom$1;
		  function requireAhom$1() {
		    if (hasRequiredAhom$1) return Ahom$1;
		    hasRequiredAhom$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x11700, 0x1171A).addRange(0x1171D, 0x1172B).addRange(0x11730, 0x11746);
		    Ahom$1.characters = set;
		    return Ahom$1;
		  }

		  var Anatolian_Hieroglyphs$1 = {};

		  var hasRequiredAnatolian_Hieroglyphs$1;
		  function requireAnatolian_Hieroglyphs$1() {
		    if (hasRequiredAnatolian_Hieroglyphs$1) return Anatolian_Hieroglyphs$1;
		    hasRequiredAnatolian_Hieroglyphs$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x14400, 0x14646);
		    Anatolian_Hieroglyphs$1.characters = set;
		    return Anatolian_Hieroglyphs$1;
		  }

		  var Arabic$1 = {};

		  var hasRequiredArabic$1;
		  function requireArabic$1() {
		    if (hasRequiredArabic$1) return Arabic$1;
		    hasRequiredArabic$1 = 1;
		    var set = regenerateExports(0xFDCF, 0x1EE24, 0x1EE27, 0x1EE39, 0x1EE3B, 0x1EE42, 0x1EE47, 0x1EE49, 0x1EE4B, 0x1EE54, 0x1EE57, 0x1EE59, 0x1EE5B, 0x1EE5D, 0x1EE5F, 0x1EE64, 0x1EE7E);
		    set.addRange(0x600, 0x604).addRange(0x606, 0x6DC).addRange(0x6DE, 0x6FF).addRange(0x750, 0x77F).addRange(0x870, 0x88E).addRange(0x890, 0x891).addRange(0x898, 0x8E1).addRange(0x8E3, 0x8FF).addRange(0xFB50, 0xFBC2).addRange(0xFBD3, 0xFD8F).addRange(0xFD92, 0xFDC7).addRange(0xFDF0, 0xFDFF).addRange(0xFE70, 0xFE74).addRange(0xFE76, 0xFEFC).addRange(0x102E0, 0x102FB).addRange(0x10E60, 0x10E7E).addRange(0x10EFD, 0x10EFF).addRange(0x1EE00, 0x1EE03).addRange(0x1EE05, 0x1EE1F).addRange(0x1EE21, 0x1EE22).addRange(0x1EE29, 0x1EE32).addRange(0x1EE34, 0x1EE37).addRange(0x1EE4D, 0x1EE4F).addRange(0x1EE51, 0x1EE52).addRange(0x1EE61, 0x1EE62).addRange(0x1EE67, 0x1EE6A).addRange(0x1EE6C, 0x1EE72).addRange(0x1EE74, 0x1EE77).addRange(0x1EE79, 0x1EE7C).addRange(0x1EE80, 0x1EE89).addRange(0x1EE8B, 0x1EE9B).addRange(0x1EEA1, 0x1EEA3).addRange(0x1EEA5, 0x1EEA9).addRange(0x1EEAB, 0x1EEBB).addRange(0x1EEF0, 0x1EEF1);
		    Arabic$1.characters = set;
		    return Arabic$1;
		  }

		  var Armenian$1 = {};

		  var hasRequiredArmenian$1;
		  function requireArmenian$1() {
		    if (hasRequiredArmenian$1) return Armenian$1;
		    hasRequiredArmenian$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x531, 0x556).addRange(0x559, 0x58A).addRange(0x58D, 0x58F).addRange(0xFB13, 0xFB17);
		    Armenian$1.characters = set;
		    return Armenian$1;
		  }

		  var Avestan$1 = {};

		  var hasRequiredAvestan$1;
		  function requireAvestan$1() {
		    if (hasRequiredAvestan$1) return Avestan$1;
		    hasRequiredAvestan$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x10B00, 0x10B35).addRange(0x10B39, 0x10B3F);
		    Avestan$1.characters = set;
		    return Avestan$1;
		  }

		  var Balinese$1 = {};

		  var hasRequiredBalinese$1;
		  function requireBalinese$1() {
		    if (hasRequiredBalinese$1) return Balinese$1;
		    hasRequiredBalinese$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x1B00, 0x1B4C).addRange(0x1B50, 0x1B7E);
		    Balinese$1.characters = set;
		    return Balinese$1;
		  }

		  var Bamum$1 = {};

		  var hasRequiredBamum$1;
		  function requireBamum$1() {
		    if (hasRequiredBamum$1) return Bamum$1;
		    hasRequiredBamum$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0xA6A0, 0xA6F7).addRange(0x16800, 0x16A38);
		    Bamum$1.characters = set;
		    return Bamum$1;
		  }

		  var Bassa_Vah$1 = {};

		  var hasRequiredBassa_Vah$1;
		  function requireBassa_Vah$1() {
		    if (hasRequiredBassa_Vah$1) return Bassa_Vah$1;
		    hasRequiredBassa_Vah$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x16AD0, 0x16AED).addRange(0x16AF0, 0x16AF5);
		    Bassa_Vah$1.characters = set;
		    return Bassa_Vah$1;
		  }

		  var Batak$1 = {};

		  var hasRequiredBatak$1;
		  function requireBatak$1() {
		    if (hasRequiredBatak$1) return Batak$1;
		    hasRequiredBatak$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x1BC0, 0x1BF3).addRange(0x1BFC, 0x1BFF);
		    Batak$1.characters = set;
		    return Batak$1;
		  }

		  var Bengali$1 = {};

		  var hasRequiredBengali$1;
		  function requireBengali$1() {
		    if (hasRequiredBengali$1) return Bengali$1;
		    hasRequiredBengali$1 = 1;
		    var set = regenerateExports(0x9B2, 0x9D7, 0x1CD0, 0x1CD2, 0x1CD8, 0x1CE1, 0x1CEA, 0x1CED, 0x1CF2, 0xA8F1);
		    set.addRange(0x951, 0x952).addRange(0x964, 0x965).addRange(0x980, 0x983).addRange(0x985, 0x98C).addRange(0x98F, 0x990).addRange(0x993, 0x9A8).addRange(0x9AA, 0x9B0).addRange(0x9B6, 0x9B9).addRange(0x9BC, 0x9C4).addRange(0x9C7, 0x9C8).addRange(0x9CB, 0x9CE).addRange(0x9DC, 0x9DD).addRange(0x9DF, 0x9E3).addRange(0x9E6, 0x9FE).addRange(0x1CD5, 0x1CD6).addRange(0x1CF5, 0x1CF7);
		    Bengali$1.characters = set;
		    return Bengali$1;
		  }

		  var Bhaiksuki$1 = {};

		  var hasRequiredBhaiksuki$1;
		  function requireBhaiksuki$1() {
		    if (hasRequiredBhaiksuki$1) return Bhaiksuki$1;
		    hasRequiredBhaiksuki$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x11C00, 0x11C08).addRange(0x11C0A, 0x11C36).addRange(0x11C38, 0x11C45).addRange(0x11C50, 0x11C6C);
		    Bhaiksuki$1.characters = set;
		    return Bhaiksuki$1;
		  }

		  var Bopomofo$1 = {};

		  var hasRequiredBopomofo$1;
		  function requireBopomofo$1() {
		    if (hasRequiredBopomofo$1) return Bopomofo$1;
		    hasRequiredBopomofo$1 = 1;
		    var set = regenerateExports(0x3030, 0x3037, 0x30FB);
		    set.addRange(0x2EA, 0x2EB).addRange(0x3001, 0x3003).addRange(0x3008, 0x3011).addRange(0x3013, 0x301F).addRange(0x302A, 0x302D).addRange(0x3105, 0x312F).addRange(0x31A0, 0x31BF).addRange(0xFE45, 0xFE46).addRange(0xFF61, 0xFF65);
		    Bopomofo$1.characters = set;
		    return Bopomofo$1;
		  }

		  var Brahmi$1 = {};

		  var hasRequiredBrahmi$1;
		  function requireBrahmi$1() {
		    if (hasRequiredBrahmi$1) return Brahmi$1;
		    hasRequiredBrahmi$1 = 1;
		    var set = regenerateExports(0x1107F);
		    set.addRange(0x11000, 0x1104D).addRange(0x11052, 0x11075);
		    Brahmi$1.characters = set;
		    return Brahmi$1;
		  }

		  var Braille$1 = {};

		  var hasRequiredBraille$1;
		  function requireBraille$1() {
		    if (hasRequiredBraille$1) return Braille$1;
		    hasRequiredBraille$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x2800, 0x28FF);
		    Braille$1.characters = set;
		    return Braille$1;
		  }

		  var Buginese$1 = {};

		  var hasRequiredBuginese$1;
		  function requireBuginese$1() {
		    if (hasRequiredBuginese$1) return Buginese$1;
		    hasRequiredBuginese$1 = 1;
		    var set = regenerateExports(0xA9CF);
		    set.addRange(0x1A00, 0x1A1B).addRange(0x1A1E, 0x1A1F);
		    Buginese$1.characters = set;
		    return Buginese$1;
		  }

		  var Buhid$1 = {};

		  var hasRequiredBuhid$1;
		  function requireBuhid$1() {
		    if (hasRequiredBuhid$1) return Buhid$1;
		    hasRequiredBuhid$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x1735, 0x1736).addRange(0x1740, 0x1753);
		    Buhid$1.characters = set;
		    return Buhid$1;
		  }

		  var Canadian_Aboriginal$1 = {};

		  var hasRequiredCanadian_Aboriginal$1;
		  function requireCanadian_Aboriginal$1() {
		    if (hasRequiredCanadian_Aboriginal$1) return Canadian_Aboriginal$1;
		    hasRequiredCanadian_Aboriginal$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x1400, 0x167F).addRange(0x18B0, 0x18F5).addRange(0x11AB0, 0x11ABF);
		    Canadian_Aboriginal$1.characters = set;
		    return Canadian_Aboriginal$1;
		  }

		  var Carian$1 = {};

		  var hasRequiredCarian$1;
		  function requireCarian$1() {
		    if (hasRequiredCarian$1) return Carian$1;
		    hasRequiredCarian$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x102A0, 0x102D0);
		    Carian$1.characters = set;
		    return Carian$1;
		  }

		  var Caucasian_Albanian$1 = {};

		  var hasRequiredCaucasian_Albanian$1;
		  function requireCaucasian_Albanian$1() {
		    if (hasRequiredCaucasian_Albanian$1) return Caucasian_Albanian$1;
		    hasRequiredCaucasian_Albanian$1 = 1;
		    var set = regenerateExports(0x1056F);
		    set.addRange(0x10530, 0x10563);
		    Caucasian_Albanian$1.characters = set;
		    return Caucasian_Albanian$1;
		  }

		  var Chakma$1 = {};

		  var hasRequiredChakma$1;
		  function requireChakma$1() {
		    if (hasRequiredChakma$1) return Chakma$1;
		    hasRequiredChakma$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x9E6, 0x9EF).addRange(0x1040, 0x1049).addRange(0x11100, 0x11134).addRange(0x11136, 0x11147);
		    Chakma$1.characters = set;
		    return Chakma$1;
		  }

		  var Cham$1 = {};

		  var hasRequiredCham$1;
		  function requireCham$1() {
		    if (hasRequiredCham$1) return Cham$1;
		    hasRequiredCham$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0xAA00, 0xAA36).addRange(0xAA40, 0xAA4D).addRange(0xAA50, 0xAA59).addRange(0xAA5C, 0xAA5F);
		    Cham$1.characters = set;
		    return Cham$1;
		  }

		  var Cherokee$1 = {};

		  var hasRequiredCherokee$1;
		  function requireCherokee$1() {
		    if (hasRequiredCherokee$1) return Cherokee$1;
		    hasRequiredCherokee$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x13A0, 0x13F5).addRange(0x13F8, 0x13FD).addRange(0xAB70, 0xABBF);
		    Cherokee$1.characters = set;
		    return Cherokee$1;
		  }

		  var Chorasmian$1 = {};

		  var hasRequiredChorasmian$1;
		  function requireChorasmian$1() {
		    if (hasRequiredChorasmian$1) return Chorasmian$1;
		    hasRequiredChorasmian$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x10FB0, 0x10FCB);
		    Chorasmian$1.characters = set;
		    return Chorasmian$1;
		  }

		  var Common$1 = {};

		  var hasRequiredCommon$1;
		  function requireCommon$1() {
		    if (hasRequiredCommon$1) return Common$1;
		    hasRequiredCommon$1 = 1;
		    var set = regenerateExports(0xD7, 0xF7, 0x374, 0x37E, 0x385, 0x387, 0x605, 0x6DD, 0x8E2, 0xE3F, 0x3004, 0x3012, 0x3020, 0x3036, 0x31EF, 0x327F, 0x33FF, 0xAB5B, 0xFEFF, 0x1D4A2, 0x1D4BB, 0x1D546, 0x1F7F0, 0xE0001);
		    set.addRange(0x0, 0x40).addRange(0x5B, 0x60).addRange(0x7B, 0xA9).addRange(0xAB, 0xB9).addRange(0xBB, 0xBF).addRange(0x2B9, 0x2DF).addRange(0x2E5, 0x2E9).addRange(0x2EC, 0x2FF).addRange(0xFD5, 0xFD8).addRange(0x16EB, 0x16ED).addRange(0x2000, 0x200B).addRange(0x200E, 0x202E).addRange(0x2030, 0x2064).addRange(0x2066, 0x2070).addRange(0x2074, 0x207E).addRange(0x2080, 0x208E).addRange(0x20A0, 0x20C0).addRange(0x2100, 0x2125).addRange(0x2127, 0x2129).addRange(0x212C, 0x2131).addRange(0x2133, 0x214D).addRange(0x214F, 0x215F).addRange(0x2189, 0x218B).addRange(0x2190, 0x2426).addRange(0x2440, 0x244A).addRange(0x2460, 0x27FF).addRange(0x2900, 0x2B73).addRange(0x2B76, 0x2B95).addRange(0x2B97, 0x2BFF).addRange(0x2E00, 0x2E42).addRange(0x2E44, 0x2E5D).addRange(0x2FF0, 0x3000).addRange(0x3248, 0x325F).addRange(0x32B1, 0x32BF).addRange(0x32CC, 0x32CF).addRange(0x3371, 0x337A).addRange(0x3380, 0x33DF).addRange(0x4DC0, 0x4DFF).addRange(0xA708, 0xA721).addRange(0xA788, 0xA78A).addRange(0xAB6A, 0xAB6B).addRange(0xFE10, 0xFE19).addRange(0xFE30, 0xFE44).addRange(0xFE47, 0xFE52).addRange(0xFE54, 0xFE66).addRange(0xFE68, 0xFE6B).addRange(0xFF01, 0xFF20).addRange(0xFF3B, 0xFF40).addRange(0xFF5B, 0xFF60).addRange(0xFFE0, 0xFFE6).addRange(0xFFE8, 0xFFEE);
		    set.addRange(0xFFF9, 0xFFFD).addRange(0x10190, 0x1019C).addRange(0x101D0, 0x101FC).addRange(0x1CF50, 0x1CFC3).addRange(0x1D000, 0x1D0F5).addRange(0x1D100, 0x1D126).addRange(0x1D129, 0x1D166).addRange(0x1D16A, 0x1D17A).addRange(0x1D183, 0x1D184).addRange(0x1D18C, 0x1D1A9).addRange(0x1D1AE, 0x1D1EA).addRange(0x1D2C0, 0x1D2D3).addRange(0x1D2E0, 0x1D2F3).addRange(0x1D300, 0x1D356).addRange(0x1D372, 0x1D378).addRange(0x1D400, 0x1D454).addRange(0x1D456, 0x1D49C).addRange(0x1D49E, 0x1D49F).addRange(0x1D4A5, 0x1D4A6).addRange(0x1D4A9, 0x1D4AC).addRange(0x1D4AE, 0x1D4B9).addRange(0x1D4BD, 0x1D4C3).addRange(0x1D4C5, 0x1D505).addRange(0x1D507, 0x1D50A).addRange(0x1D50D, 0x1D514).addRange(0x1D516, 0x1D51C).addRange(0x1D51E, 0x1D539).addRange(0x1D53B, 0x1D53E).addRange(0x1D540, 0x1D544).addRange(0x1D54A, 0x1D550).addRange(0x1D552, 0x1D6A5).addRange(0x1D6A8, 0x1D7CB).addRange(0x1D7CE, 0x1D7FF).addRange(0x1EC71, 0x1ECB4).addRange(0x1ED01, 0x1ED3D).addRange(0x1F000, 0x1F02B).addRange(0x1F030, 0x1F093).addRange(0x1F0A0, 0x1F0AE).addRange(0x1F0B1, 0x1F0BF).addRange(0x1F0C1, 0x1F0CF).addRange(0x1F0D1, 0x1F0F5).addRange(0x1F100, 0x1F1AD).addRange(0x1F1E6, 0x1F1FF).addRange(0x1F201, 0x1F202).addRange(0x1F210, 0x1F23B).addRange(0x1F240, 0x1F248).addRange(0x1F260, 0x1F265).addRange(0x1F300, 0x1F6D7).addRange(0x1F6DC, 0x1F6EC).addRange(0x1F6F0, 0x1F6FC).addRange(0x1F700, 0x1F776);
		    set.addRange(0x1F77B, 0x1F7D9).addRange(0x1F7E0, 0x1F7EB).addRange(0x1F800, 0x1F80B).addRange(0x1F810, 0x1F847).addRange(0x1F850, 0x1F859).addRange(0x1F860, 0x1F887).addRange(0x1F890, 0x1F8AD).addRange(0x1F8B0, 0x1F8B1).addRange(0x1F900, 0x1FA53).addRange(0x1FA60, 0x1FA6D).addRange(0x1FA70, 0x1FA7C).addRange(0x1FA80, 0x1FA88).addRange(0x1FA90, 0x1FABD).addRange(0x1FABF, 0x1FAC5).addRange(0x1FACE, 0x1FADB).addRange(0x1FAE0, 0x1FAE8).addRange(0x1FAF0, 0x1FAF8).addRange(0x1FB00, 0x1FB92).addRange(0x1FB94, 0x1FBCA).addRange(0x1FBF0, 0x1FBF9).addRange(0xE0020, 0xE007F);
		    Common$1.characters = set;
		    return Common$1;
		  }

		  var Coptic$1 = {};

		  var hasRequiredCoptic$1;
		  function requireCoptic$1() {
		    if (hasRequiredCoptic$1) return Coptic$1;
		    hasRequiredCoptic$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x3E2, 0x3EF).addRange(0x2C80, 0x2CF3).addRange(0x2CF9, 0x2CFF).addRange(0x102E0, 0x102FB);
		    Coptic$1.characters = set;
		    return Coptic$1;
		  }

		  var Cuneiform$1 = {};

		  var hasRequiredCuneiform$1;
		  function requireCuneiform$1() {
		    if (hasRequiredCuneiform$1) return Cuneiform$1;
		    hasRequiredCuneiform$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x12000, 0x12399).addRange(0x12400, 0x1246E).addRange(0x12470, 0x12474).addRange(0x12480, 0x12543);
		    Cuneiform$1.characters = set;
		    return Cuneiform$1;
		  }

		  var Cypriot$1 = {};

		  var hasRequiredCypriot$1;
		  function requireCypriot$1() {
		    if (hasRequiredCypriot$1) return Cypriot$1;
		    hasRequiredCypriot$1 = 1;
		    var set = regenerateExports(0x10808, 0x1083C, 0x1083F);
		    set.addRange(0x10100, 0x10102).addRange(0x10107, 0x10133).addRange(0x10137, 0x1013F).addRange(0x10800, 0x10805).addRange(0x1080A, 0x10835).addRange(0x10837, 0x10838);
		    Cypriot$1.characters = set;
		    return Cypriot$1;
		  }

		  var Cypro_Minoan$1 = {};

		  var hasRequiredCypro_Minoan$1;
		  function requireCypro_Minoan$1() {
		    if (hasRequiredCypro_Minoan$1) return Cypro_Minoan$1;
		    hasRequiredCypro_Minoan$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x10100, 0x10101).addRange(0x12F90, 0x12FF2);
		    Cypro_Minoan$1.characters = set;
		    return Cypro_Minoan$1;
		  }

		  var Cyrillic$1 = {};

		  var hasRequiredCyrillic$1;
		  function requireCyrillic$1() {
		    if (hasRequiredCyrillic$1) return Cyrillic$1;
		    hasRequiredCyrillic$1 = 1;
		    var set = regenerateExports(0x1D2B, 0x1D78, 0x1DF8, 0x2E43, 0x1E08F);
		    set.addRange(0x400, 0x52F).addRange(0x1C80, 0x1C88).addRange(0x2DE0, 0x2DFF).addRange(0xA640, 0xA69F).addRange(0xFE2E, 0xFE2F).addRange(0x1E030, 0x1E06D);
		    Cyrillic$1.characters = set;
		    return Cyrillic$1;
		  }

		  var Deseret$1 = {};

		  var hasRequiredDeseret$1;
		  function requireDeseret$1() {
		    if (hasRequiredDeseret$1) return Deseret$1;
		    hasRequiredDeseret$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x10400, 0x1044F);
		    Deseret$1.characters = set;
		    return Deseret$1;
		  }

		  var Devanagari$1 = {};

		  var hasRequiredDevanagari$1;
		  function requireDevanagari$1() {
		    if (hasRequiredDevanagari$1) return Devanagari$1;
		    hasRequiredDevanagari$1 = 1;
		    var set = regenerateExports(0x20F0);
		    set.addRange(0x900, 0x952).addRange(0x955, 0x97F).addRange(0x1CD0, 0x1CF6).addRange(0x1CF8, 0x1CF9).addRange(0xA830, 0xA839).addRange(0xA8E0, 0xA8FF).addRange(0x11B00, 0x11B09);
		    Devanagari$1.characters = set;
		    return Devanagari$1;
		  }

		  var Dives_Akuru$1 = {};

		  var hasRequiredDives_Akuru$1;
		  function requireDives_Akuru$1() {
		    if (hasRequiredDives_Akuru$1) return Dives_Akuru$1;
		    hasRequiredDives_Akuru$1 = 1;
		    var set = regenerateExports(0x11909);
		    set.addRange(0x11900, 0x11906).addRange(0x1190C, 0x11913).addRange(0x11915, 0x11916).addRange(0x11918, 0x11935).addRange(0x11937, 0x11938).addRange(0x1193B, 0x11946).addRange(0x11950, 0x11959);
		    Dives_Akuru$1.characters = set;
		    return Dives_Akuru$1;
		  }

		  var Dogra$1 = {};

		  var hasRequiredDogra$1;
		  function requireDogra$1() {
		    if (hasRequiredDogra$1) return Dogra$1;
		    hasRequiredDogra$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x964, 0x96F).addRange(0xA830, 0xA839).addRange(0x11800, 0x1183B);
		    Dogra$1.characters = set;
		    return Dogra$1;
		  }

		  var Duployan$1 = {};

		  var hasRequiredDuployan$1;
		  function requireDuployan$1() {
		    if (hasRequiredDuployan$1) return Duployan$1;
		    hasRequiredDuployan$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x1BC00, 0x1BC6A).addRange(0x1BC70, 0x1BC7C).addRange(0x1BC80, 0x1BC88).addRange(0x1BC90, 0x1BC99).addRange(0x1BC9C, 0x1BCA3);
		    Duployan$1.characters = set;
		    return Duployan$1;
		  }

		  var Egyptian_Hieroglyphs$1 = {};

		  var hasRequiredEgyptian_Hieroglyphs$1;
		  function requireEgyptian_Hieroglyphs$1() {
		    if (hasRequiredEgyptian_Hieroglyphs$1) return Egyptian_Hieroglyphs$1;
		    hasRequiredEgyptian_Hieroglyphs$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x13000, 0x13455);
		    Egyptian_Hieroglyphs$1.characters = set;
		    return Egyptian_Hieroglyphs$1;
		  }

		  var Elbasan$1 = {};

		  var hasRequiredElbasan$1;
		  function requireElbasan$1() {
		    if (hasRequiredElbasan$1) return Elbasan$1;
		    hasRequiredElbasan$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x10500, 0x10527);
		    Elbasan$1.characters = set;
		    return Elbasan$1;
		  }

		  var Elymaic$1 = {};

		  var hasRequiredElymaic$1;
		  function requireElymaic$1() {
		    if (hasRequiredElymaic$1) return Elymaic$1;
		    hasRequiredElymaic$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x10FE0, 0x10FF6);
		    Elymaic$1.characters = set;
		    return Elymaic$1;
		  }

		  var Ethiopic$1 = {};

		  var hasRequiredEthiopic$1;
		  function requireEthiopic$1() {
		    if (hasRequiredEthiopic$1) return Ethiopic$1;
		    hasRequiredEthiopic$1 = 1;
		    var set = regenerateExports(0x1258, 0x12C0);
		    set.addRange(0x1200, 0x1248).addRange(0x124A, 0x124D).addRange(0x1250, 0x1256).addRange(0x125A, 0x125D).addRange(0x1260, 0x1288).addRange(0x128A, 0x128D).addRange(0x1290, 0x12B0).addRange(0x12B2, 0x12B5).addRange(0x12B8, 0x12BE).addRange(0x12C2, 0x12C5).addRange(0x12C8, 0x12D6).addRange(0x12D8, 0x1310).addRange(0x1312, 0x1315).addRange(0x1318, 0x135A).addRange(0x135D, 0x137C).addRange(0x1380, 0x1399).addRange(0x2D80, 0x2D96).addRange(0x2DA0, 0x2DA6).addRange(0x2DA8, 0x2DAE).addRange(0x2DB0, 0x2DB6).addRange(0x2DB8, 0x2DBE).addRange(0x2DC0, 0x2DC6).addRange(0x2DC8, 0x2DCE).addRange(0x2DD0, 0x2DD6).addRange(0x2DD8, 0x2DDE).addRange(0xAB01, 0xAB06).addRange(0xAB09, 0xAB0E).addRange(0xAB11, 0xAB16).addRange(0xAB20, 0xAB26).addRange(0xAB28, 0xAB2E).addRange(0x1E7E0, 0x1E7E6).addRange(0x1E7E8, 0x1E7EB).addRange(0x1E7ED, 0x1E7EE).addRange(0x1E7F0, 0x1E7FE);
		    Ethiopic$1.characters = set;
		    return Ethiopic$1;
		  }

		  var Georgian$1 = {};

		  var hasRequiredGeorgian$1;
		  function requireGeorgian$1() {
		    if (hasRequiredGeorgian$1) return Georgian$1;
		    hasRequiredGeorgian$1 = 1;
		    var set = regenerateExports(0x10C7, 0x10CD, 0x2D27, 0x2D2D);
		    set.addRange(0x10A0, 0x10C5).addRange(0x10D0, 0x10FF).addRange(0x1C90, 0x1CBA).addRange(0x1CBD, 0x1CBF).addRange(0x2D00, 0x2D25);
		    Georgian$1.characters = set;
		    return Georgian$1;
		  }

		  var Glagolitic$1 = {};

		  var hasRequiredGlagolitic$1;
		  function requireGlagolitic$1() {
		    if (hasRequiredGlagolitic$1) return Glagolitic$1;
		    hasRequiredGlagolitic$1 = 1;
		    var set = regenerateExports(0x484, 0x487, 0x2E43, 0xA66F);
		    set.addRange(0x2C00, 0x2C5F).addRange(0x1E000, 0x1E006).addRange(0x1E008, 0x1E018).addRange(0x1E01B, 0x1E021).addRange(0x1E023, 0x1E024).addRange(0x1E026, 0x1E02A);
		    Glagolitic$1.characters = set;
		    return Glagolitic$1;
		  }

		  var Gothic$1 = {};

		  var hasRequiredGothic$1;
		  function requireGothic$1() {
		    if (hasRequiredGothic$1) return Gothic$1;
		    hasRequiredGothic$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x10330, 0x1034A);
		    Gothic$1.characters = set;
		    return Gothic$1;
		  }

		  var Grantha$1 = {};

		  var hasRequiredGrantha$1;
		  function requireGrantha$1() {
		    if (hasRequiredGrantha$1) return Grantha$1;
		    hasRequiredGrantha$1 = 1;
		    var set = regenerateExports(0x1CD0, 0x20F0, 0x11350, 0x11357, 0x11FD3);
		    set.addRange(0x951, 0x952).addRange(0x964, 0x965).addRange(0xBE6, 0xBF3).addRange(0x1CD2, 0x1CD3).addRange(0x1CF2, 0x1CF4).addRange(0x1CF8, 0x1CF9).addRange(0x11300, 0x11303).addRange(0x11305, 0x1130C).addRange(0x1130F, 0x11310).addRange(0x11313, 0x11328).addRange(0x1132A, 0x11330).addRange(0x11332, 0x11333).addRange(0x11335, 0x11339).addRange(0x1133B, 0x11344).addRange(0x11347, 0x11348).addRange(0x1134B, 0x1134D).addRange(0x1135D, 0x11363).addRange(0x11366, 0x1136C).addRange(0x11370, 0x11374).addRange(0x11FD0, 0x11FD1);
		    Grantha$1.characters = set;
		    return Grantha$1;
		  }

		  var Greek$1 = {};

		  var hasRequiredGreek$1;
		  function requireGreek$1() {
		    if (hasRequiredGreek$1) return Greek$1;
		    hasRequiredGreek$1 = 1;
		    var set = regenerateExports(0x342, 0x345, 0x37F, 0x384, 0x386, 0x38C, 0x1F59, 0x1F5B, 0x1F5D, 0x2126, 0xAB65, 0x101A0);
		    set.addRange(0x370, 0x373).addRange(0x375, 0x377).addRange(0x37A, 0x37D).addRange(0x388, 0x38A).addRange(0x38E, 0x3A1).addRange(0x3A3, 0x3E1).addRange(0x3F0, 0x3FF).addRange(0x1D26, 0x1D2A).addRange(0x1D5D, 0x1D61).addRange(0x1D66, 0x1D6A).addRange(0x1DBF, 0x1DC1).addRange(0x1F00, 0x1F15).addRange(0x1F18, 0x1F1D).addRange(0x1F20, 0x1F45).addRange(0x1F48, 0x1F4D).addRange(0x1F50, 0x1F57).addRange(0x1F5F, 0x1F7D).addRange(0x1F80, 0x1FB4).addRange(0x1FB6, 0x1FC4).addRange(0x1FC6, 0x1FD3).addRange(0x1FD6, 0x1FDB).addRange(0x1FDD, 0x1FEF).addRange(0x1FF2, 0x1FF4).addRange(0x1FF6, 0x1FFE).addRange(0x10140, 0x1018E).addRange(0x1D200, 0x1D245);
		    Greek$1.characters = set;
		    return Greek$1;
		  }

		  var Gujarati$1 = {};

		  var hasRequiredGujarati$1;
		  function requireGujarati$1() {
		    if (hasRequiredGujarati$1) return Gujarati$1;
		    hasRequiredGujarati$1 = 1;
		    var set = regenerateExports(0xAD0);
		    set.addRange(0x951, 0x952).addRange(0x964, 0x965).addRange(0xA81, 0xA83).addRange(0xA85, 0xA8D).addRange(0xA8F, 0xA91).addRange(0xA93, 0xAA8).addRange(0xAAA, 0xAB0).addRange(0xAB2, 0xAB3).addRange(0xAB5, 0xAB9).addRange(0xABC, 0xAC5).addRange(0xAC7, 0xAC9).addRange(0xACB, 0xACD).addRange(0xAE0, 0xAE3).addRange(0xAE6, 0xAF1).addRange(0xAF9, 0xAFF).addRange(0xA830, 0xA839);
		    Gujarati$1.characters = set;
		    return Gujarati$1;
		  }

		  var Gunjala_Gondi$1 = {};

		  var hasRequiredGunjala_Gondi$1;
		  function requireGunjala_Gondi$1() {
		    if (hasRequiredGunjala_Gondi$1) return Gunjala_Gondi$1;
		    hasRequiredGunjala_Gondi$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x964, 0x965).addRange(0x11D60, 0x11D65).addRange(0x11D67, 0x11D68).addRange(0x11D6A, 0x11D8E).addRange(0x11D90, 0x11D91).addRange(0x11D93, 0x11D98).addRange(0x11DA0, 0x11DA9);
		    Gunjala_Gondi$1.characters = set;
		    return Gunjala_Gondi$1;
		  }

		  var Gurmukhi$1 = {};

		  var hasRequiredGurmukhi$1;
		  function requireGurmukhi$1() {
		    if (hasRequiredGurmukhi$1) return Gurmukhi$1;
		    hasRequiredGurmukhi$1 = 1;
		    var set = regenerateExports(0xA3C, 0xA51, 0xA5E);
		    set.addRange(0x951, 0x952).addRange(0x964, 0x965).addRange(0xA01, 0xA03).addRange(0xA05, 0xA0A).addRange(0xA0F, 0xA10).addRange(0xA13, 0xA28).addRange(0xA2A, 0xA30).addRange(0xA32, 0xA33).addRange(0xA35, 0xA36).addRange(0xA38, 0xA39).addRange(0xA3E, 0xA42).addRange(0xA47, 0xA48).addRange(0xA4B, 0xA4D).addRange(0xA59, 0xA5C).addRange(0xA66, 0xA76).addRange(0xA830, 0xA839);
		    Gurmukhi$1.characters = set;
		    return Gurmukhi$1;
		  }

		  var Han$1 = {};

		  var hasRequiredHan$1;
		  function requireHan$1() {
		    if (hasRequiredHan$1) return Han$1;
		    hasRequiredHan$1 = 1;
		    var set = regenerateExports(0x3030, 0x30FB, 0x32FF);
		    set.addRange(0x2E80, 0x2E99).addRange(0x2E9B, 0x2EF3).addRange(0x2F00, 0x2FD5).addRange(0x3001, 0x3003).addRange(0x3005, 0x3011).addRange(0x3013, 0x301F).addRange(0x3021, 0x302D).addRange(0x3037, 0x303F).addRange(0x3190, 0x319F).addRange(0x31C0, 0x31E3).addRange(0x3220, 0x3247).addRange(0x3280, 0x32B0).addRange(0x32C0, 0x32CB).addRange(0x3358, 0x3370).addRange(0x337B, 0x337F).addRange(0x33E0, 0x33FE).addRange(0x3400, 0x4DBF).addRange(0x4E00, 0x9FFF).addRange(0xA700, 0xA707).addRange(0xF900, 0xFA6D).addRange(0xFA70, 0xFAD9).addRange(0xFE45, 0xFE46).addRange(0xFF61, 0xFF65).addRange(0x16FE2, 0x16FE3).addRange(0x16FF0, 0x16FF1).addRange(0x1D360, 0x1D371).addRange(0x1F250, 0x1F251).addRange(0x20000, 0x2A6DF).addRange(0x2A700, 0x2B739).addRange(0x2B740, 0x2B81D).addRange(0x2B820, 0x2CEA1).addRange(0x2CEB0, 0x2EBE0).addRange(0x2EBF0, 0x2EE5D).addRange(0x2F800, 0x2FA1D).addRange(0x30000, 0x3134A).addRange(0x31350, 0x323AF);
		    Han$1.characters = set;
		    return Han$1;
		  }

		  var Hangul$1 = {};

		  var hasRequiredHangul$1;
		  function requireHangul$1() {
		    if (hasRequiredHangul$1) return Hangul$1;
		    hasRequiredHangul$1 = 1;
		    var set = regenerateExports(0x3037, 0x30FB);
		    set.addRange(0x1100, 0x11FF).addRange(0x3001, 0x3003).addRange(0x3008, 0x3011).addRange(0x3013, 0x301F).addRange(0x302E, 0x3030).addRange(0x3131, 0x318E).addRange(0x3200, 0x321E).addRange(0x3260, 0x327E).addRange(0xA960, 0xA97C).addRange(0xAC00, 0xD7A3).addRange(0xD7B0, 0xD7C6).addRange(0xD7CB, 0xD7FB).addRange(0xFE45, 0xFE46).addRange(0xFF61, 0xFF65).addRange(0xFFA0, 0xFFBE).addRange(0xFFC2, 0xFFC7).addRange(0xFFCA, 0xFFCF).addRange(0xFFD2, 0xFFD7).addRange(0xFFDA, 0xFFDC);
		    Hangul$1.characters = set;
		    return Hangul$1;
		  }

		  var Hanifi_Rohingya$1 = {};

		  var hasRequiredHanifi_Rohingya$1;
		  function requireHanifi_Rohingya$1() {
		    if (hasRequiredHanifi_Rohingya$1) return Hanifi_Rohingya$1;
		    hasRequiredHanifi_Rohingya$1 = 1;
		    var set = regenerateExports(0x60C, 0x61B, 0x61F, 0x640, 0x6D4);
		    set.addRange(0x10D00, 0x10D27).addRange(0x10D30, 0x10D39);
		    Hanifi_Rohingya$1.characters = set;
		    return Hanifi_Rohingya$1;
		  }

		  var Hanunoo$1 = {};

		  var hasRequiredHanunoo$1;
		  function requireHanunoo$1() {
		    if (hasRequiredHanunoo$1) return Hanunoo$1;
		    hasRequiredHanunoo$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x1720, 0x1736);
		    Hanunoo$1.characters = set;
		    return Hanunoo$1;
		  }

		  var Hatran$1 = {};

		  var hasRequiredHatran$1;
		  function requireHatran$1() {
		    if (hasRequiredHatran$1) return Hatran$1;
		    hasRequiredHatran$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x108E0, 0x108F2).addRange(0x108F4, 0x108F5).addRange(0x108FB, 0x108FF);
		    Hatran$1.characters = set;
		    return Hatran$1;
		  }

		  var Hebrew$1 = {};

		  var hasRequiredHebrew$1;
		  function requireHebrew$1() {
		    if (hasRequiredHebrew$1) return Hebrew$1;
		    hasRequiredHebrew$1 = 1;
		    var set = regenerateExports(0xFB3E);
		    set.addRange(0x591, 0x5C7).addRange(0x5D0, 0x5EA).addRange(0x5EF, 0x5F4).addRange(0xFB1D, 0xFB36).addRange(0xFB38, 0xFB3C).addRange(0xFB40, 0xFB41).addRange(0xFB43, 0xFB44).addRange(0xFB46, 0xFB4F);
		    Hebrew$1.characters = set;
		    return Hebrew$1;
		  }

		  var Hiragana$1 = {};

		  var hasRequiredHiragana$1;
		  function requireHiragana$1() {
		    if (hasRequiredHiragana$1) return Hiragana$1;
		    hasRequiredHiragana$1 = 1;
		    var set = regenerateExports(0x3037, 0xFF70, 0x1B132, 0x1F200);
		    set.addRange(0x3001, 0x3003).addRange(0x3008, 0x3011).addRange(0x3013, 0x301F).addRange(0x3030, 0x3035).addRange(0x303C, 0x303D).addRange(0x3041, 0x3096).addRange(0x3099, 0x30A0).addRange(0x30FB, 0x30FC).addRange(0xFE45, 0xFE46).addRange(0xFF61, 0xFF65).addRange(0xFF9E, 0xFF9F).addRange(0x1B001, 0x1B11F).addRange(0x1B150, 0x1B152);
		    Hiragana$1.characters = set;
		    return Hiragana$1;
		  }

		  var Imperial_Aramaic$1 = {};

		  var hasRequiredImperial_Aramaic$1;
		  function requireImperial_Aramaic$1() {
		    if (hasRequiredImperial_Aramaic$1) return Imperial_Aramaic$1;
		    hasRequiredImperial_Aramaic$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x10840, 0x10855).addRange(0x10857, 0x1085F);
		    Imperial_Aramaic$1.characters = set;
		    return Imperial_Aramaic$1;
		  }

		  var Inherited$1 = {};

		  var hasRequiredInherited$1;
		  function requireInherited$1() {
		    if (hasRequiredInherited$1) return Inherited$1;
		    hasRequiredInherited$1 = 1;
		    var set = regenerateExports(0x1DF9, 0x101FD);
		    set.addRange(0x300, 0x341).addRange(0x343, 0x344).addRange(0x346, 0x362).addRange(0x953, 0x954).addRange(0x1AB0, 0x1ACE).addRange(0x1DC2, 0x1DF7).addRange(0x1DFB, 0x1DFF).addRange(0x200C, 0x200D).addRange(0x20D0, 0x20EF).addRange(0xFE00, 0xFE0F).addRange(0xFE20, 0xFE2D).addRange(0x1CF00, 0x1CF2D).addRange(0x1CF30, 0x1CF46).addRange(0x1D167, 0x1D169).addRange(0x1D17B, 0x1D182).addRange(0x1D185, 0x1D18B).addRange(0x1D1AA, 0x1D1AD).addRange(0xE0100, 0xE01EF);
		    Inherited$1.characters = set;
		    return Inherited$1;
		  }

		  var Inscriptional_Pahlavi$1 = {};

		  var hasRequiredInscriptional_Pahlavi$1;
		  function requireInscriptional_Pahlavi$1() {
		    if (hasRequiredInscriptional_Pahlavi$1) return Inscriptional_Pahlavi$1;
		    hasRequiredInscriptional_Pahlavi$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x10B60, 0x10B72).addRange(0x10B78, 0x10B7F);
		    Inscriptional_Pahlavi$1.characters = set;
		    return Inscriptional_Pahlavi$1;
		  }

		  var Inscriptional_Parthian$1 = {};

		  var hasRequiredInscriptional_Parthian$1;
		  function requireInscriptional_Parthian$1() {
		    if (hasRequiredInscriptional_Parthian$1) return Inscriptional_Parthian$1;
		    hasRequiredInscriptional_Parthian$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x10B40, 0x10B55).addRange(0x10B58, 0x10B5F);
		    Inscriptional_Parthian$1.characters = set;
		    return Inscriptional_Parthian$1;
		  }

		  var Javanese$1 = {};

		  var hasRequiredJavanese$1;
		  function requireJavanese$1() {
		    if (hasRequiredJavanese$1) return Javanese$1;
		    hasRequiredJavanese$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0xA980, 0xA9CD).addRange(0xA9CF, 0xA9D9).addRange(0xA9DE, 0xA9DF);
		    Javanese$1.characters = set;
		    return Javanese$1;
		  }

		  var Kaithi$1 = {};

		  var hasRequiredKaithi$1;
		  function requireKaithi$1() {
		    if (hasRequiredKaithi$1) return Kaithi$1;
		    hasRequiredKaithi$1 = 1;
		    var set = regenerateExports(0x110CD);
		    set.addRange(0x966, 0x96F).addRange(0xA830, 0xA839).addRange(0x11080, 0x110C2);
		    Kaithi$1.characters = set;
		    return Kaithi$1;
		  }

		  var Kannada$1 = {};

		  var hasRequiredKannada$1;
		  function requireKannada$1() {
		    if (hasRequiredKannada$1) return Kannada$1;
		    hasRequiredKannada$1 = 1;
		    var set = regenerateExports(0x1CD0, 0x1CD2, 0x1CDA, 0x1CF2, 0x1CF4);
		    set.addRange(0x951, 0x952).addRange(0x964, 0x965).addRange(0xC80, 0xC8C).addRange(0xC8E, 0xC90).addRange(0xC92, 0xCA8).addRange(0xCAA, 0xCB3).addRange(0xCB5, 0xCB9).addRange(0xCBC, 0xCC4).addRange(0xCC6, 0xCC8).addRange(0xCCA, 0xCCD).addRange(0xCD5, 0xCD6).addRange(0xCDD, 0xCDE).addRange(0xCE0, 0xCE3).addRange(0xCE6, 0xCEF).addRange(0xCF1, 0xCF3).addRange(0xA830, 0xA835);
		    Kannada$1.characters = set;
		    return Kannada$1;
		  }

		  var Katakana$1 = {};

		  var hasRequiredKatakana$1;
		  function requireKatakana$1() {
		    if (hasRequiredKatakana$1) return Katakana$1;
		    hasRequiredKatakana$1 = 1;
		    var set = regenerateExports(0x3037, 0x1B000, 0x1B155);
		    set.addRange(0x3001, 0x3003).addRange(0x3008, 0x3011).addRange(0x3013, 0x301F).addRange(0x3030, 0x3035).addRange(0x303C, 0x303D).addRange(0x3099, 0x309C).addRange(0x30A0, 0x30FF).addRange(0x31F0, 0x31FF).addRange(0x32D0, 0x32FE).addRange(0x3300, 0x3357).addRange(0xFE45, 0xFE46).addRange(0xFF61, 0xFF9F).addRange(0x1AFF0, 0x1AFF3).addRange(0x1AFF5, 0x1AFFB).addRange(0x1AFFD, 0x1AFFE).addRange(0x1B120, 0x1B122).addRange(0x1B164, 0x1B167);
		    Katakana$1.characters = set;
		    return Katakana$1;
		  }

		  var Kawi$1 = {};

		  var hasRequiredKawi$1;
		  function requireKawi$1() {
		    if (hasRequiredKawi$1) return Kawi$1;
		    hasRequiredKawi$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x11F00, 0x11F10).addRange(0x11F12, 0x11F3A).addRange(0x11F3E, 0x11F59);
		    Kawi$1.characters = set;
		    return Kawi$1;
		  }

		  var Kayah_Li$1 = {};

		  var hasRequiredKayah_Li$1;
		  function requireKayah_Li$1() {
		    if (hasRequiredKayah_Li$1) return Kayah_Li$1;
		    hasRequiredKayah_Li$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0xA900, 0xA92F);
		    Kayah_Li$1.characters = set;
		    return Kayah_Li$1;
		  }

		  var Kharoshthi$1 = {};

		  var hasRequiredKharoshthi$1;
		  function requireKharoshthi$1() {
		    if (hasRequiredKharoshthi$1) return Kharoshthi$1;
		    hasRequiredKharoshthi$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x10A00, 0x10A03).addRange(0x10A05, 0x10A06).addRange(0x10A0C, 0x10A13).addRange(0x10A15, 0x10A17).addRange(0x10A19, 0x10A35).addRange(0x10A38, 0x10A3A).addRange(0x10A3F, 0x10A48).addRange(0x10A50, 0x10A58);
		    Kharoshthi$1.characters = set;
		    return Kharoshthi$1;
		  }

		  var Khitan_Small_Script$1 = {};

		  var hasRequiredKhitan_Small_Script$1;
		  function requireKhitan_Small_Script$1() {
		    if (hasRequiredKhitan_Small_Script$1) return Khitan_Small_Script$1;
		    hasRequiredKhitan_Small_Script$1 = 1;
		    var set = regenerateExports(0x16FE4);
		    set.addRange(0x18B00, 0x18CD5);
		    Khitan_Small_Script$1.characters = set;
		    return Khitan_Small_Script$1;
		  }

		  var Khmer$1 = {};

		  var hasRequiredKhmer$1;
		  function requireKhmer$1() {
		    if (hasRequiredKhmer$1) return Khmer$1;
		    hasRequiredKhmer$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x1780, 0x17DD).addRange(0x17E0, 0x17E9).addRange(0x17F0, 0x17F9).addRange(0x19E0, 0x19FF);
		    Khmer$1.characters = set;
		    return Khmer$1;
		  }

		  var Khojki$1 = {};

		  var hasRequiredKhojki$1;
		  function requireKhojki$1() {
		    if (hasRequiredKhojki$1) return Khojki$1;
		    hasRequiredKhojki$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0xAE6, 0xAEF).addRange(0xA830, 0xA839).addRange(0x11200, 0x11211).addRange(0x11213, 0x11241);
		    Khojki$1.characters = set;
		    return Khojki$1;
		  }

		  var Khudawadi$1 = {};

		  var hasRequiredKhudawadi$1;
		  function requireKhudawadi$1() {
		    if (hasRequiredKhudawadi$1) return Khudawadi$1;
		    hasRequiredKhudawadi$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x964, 0x965).addRange(0xA830, 0xA839).addRange(0x112B0, 0x112EA).addRange(0x112F0, 0x112F9);
		    Khudawadi$1.characters = set;
		    return Khudawadi$1;
		  }

		  var Lao$1 = {};

		  var hasRequiredLao$1;
		  function requireLao$1() {
		    if (hasRequiredLao$1) return Lao$1;
		    hasRequiredLao$1 = 1;
		    var set = regenerateExports(0xE84, 0xEA5, 0xEC6);
		    set.addRange(0xE81, 0xE82).addRange(0xE86, 0xE8A).addRange(0xE8C, 0xEA3).addRange(0xEA7, 0xEBD).addRange(0xEC0, 0xEC4).addRange(0xEC8, 0xECE).addRange(0xED0, 0xED9).addRange(0xEDC, 0xEDF);
		    Lao$1.characters = set;
		    return Lao$1;
		  }

		  var Latin$1 = {};

		  var hasRequiredLatin$1;
		  function requireLatin$1() {
		    if (hasRequiredLatin$1) return Latin$1;
		    hasRequiredLatin$1 = 1;
		    var set = regenerateExports(0xAA, 0xBA, 0x10FB, 0x202F, 0x2071, 0x207F, 0x20F0, 0x2132, 0x214E, 0xA7D3, 0xA92E);
		    set.addRange(0x41, 0x5A).addRange(0x61, 0x7A).addRange(0xC0, 0xD6).addRange(0xD8, 0xF6).addRange(0xF8, 0x2B8).addRange(0x2E0, 0x2E4).addRange(0x363, 0x36F).addRange(0x485, 0x486).addRange(0x951, 0x952).addRange(0x1D00, 0x1D25).addRange(0x1D2C, 0x1D5C).addRange(0x1D62, 0x1D65).addRange(0x1D6B, 0x1D77).addRange(0x1D79, 0x1DBE).addRange(0x1E00, 0x1EFF).addRange(0x2090, 0x209C).addRange(0x212A, 0x212B).addRange(0x2160, 0x2188).addRange(0x2C60, 0x2C7F).addRange(0xA700, 0xA707).addRange(0xA722, 0xA787).addRange(0xA78B, 0xA7CA).addRange(0xA7D0, 0xA7D1).addRange(0xA7D5, 0xA7D9).addRange(0xA7F2, 0xA7FF).addRange(0xAB30, 0xAB5A).addRange(0xAB5C, 0xAB64).addRange(0xAB66, 0xAB69).addRange(0xFB00, 0xFB06).addRange(0xFF21, 0xFF3A).addRange(0xFF41, 0xFF5A).addRange(0x10780, 0x10785).addRange(0x10787, 0x107B0).addRange(0x107B2, 0x107BA).addRange(0x1DF00, 0x1DF1E).addRange(0x1DF25, 0x1DF2A);
		    Latin$1.characters = set;
		    return Latin$1;
		  }

		  var Lepcha$1 = {};

		  var hasRequiredLepcha$1;
		  function requireLepcha$1() {
		    if (hasRequiredLepcha$1) return Lepcha$1;
		    hasRequiredLepcha$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x1C00, 0x1C37).addRange(0x1C3B, 0x1C49).addRange(0x1C4D, 0x1C4F);
		    Lepcha$1.characters = set;
		    return Lepcha$1;
		  }

		  var Limbu$1 = {};

		  var hasRequiredLimbu$1;
		  function requireLimbu$1() {
		    if (hasRequiredLimbu$1) return Limbu$1;
		    hasRequiredLimbu$1 = 1;
		    var set = regenerateExports(0x965, 0x1940);
		    set.addRange(0x1900, 0x191E).addRange(0x1920, 0x192B).addRange(0x1930, 0x193B).addRange(0x1944, 0x194F);
		    Limbu$1.characters = set;
		    return Limbu$1;
		  }

		  var Linear_A$1 = {};

		  var hasRequiredLinear_A$1;
		  function requireLinear_A$1() {
		    if (hasRequiredLinear_A$1) return Linear_A$1;
		    hasRequiredLinear_A$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x10107, 0x10133).addRange(0x10600, 0x10736).addRange(0x10740, 0x10755).addRange(0x10760, 0x10767);
		    Linear_A$1.characters = set;
		    return Linear_A$1;
		  }

		  var Linear_B$1 = {};

		  var hasRequiredLinear_B$1;
		  function requireLinear_B$1() {
		    if (hasRequiredLinear_B$1) return Linear_B$1;
		    hasRequiredLinear_B$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x10000, 0x1000B).addRange(0x1000D, 0x10026).addRange(0x10028, 0x1003A).addRange(0x1003C, 0x1003D).addRange(0x1003F, 0x1004D).addRange(0x10050, 0x1005D).addRange(0x10080, 0x100FA).addRange(0x10100, 0x10102).addRange(0x10107, 0x10133).addRange(0x10137, 0x1013F);
		    Linear_B$1.characters = set;
		    return Linear_B$1;
		  }

		  var Lisu$1 = {};

		  var hasRequiredLisu$1;
		  function requireLisu$1() {
		    if (hasRequiredLisu$1) return Lisu$1;
		    hasRequiredLisu$1 = 1;
		    var set = regenerateExports(0x11FB0);
		    set.addRange(0xA4D0, 0xA4FF);
		    Lisu$1.characters = set;
		    return Lisu$1;
		  }

		  var Lycian$1 = {};

		  var hasRequiredLycian$1;
		  function requireLycian$1() {
		    if (hasRequiredLycian$1) return Lycian$1;
		    hasRequiredLycian$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x10280, 0x1029C);
		    Lycian$1.characters = set;
		    return Lycian$1;
		  }

		  var Lydian$1 = {};

		  var hasRequiredLydian$1;
		  function requireLydian$1() {
		    if (hasRequiredLydian$1) return Lydian$1;
		    hasRequiredLydian$1 = 1;
		    var set = regenerateExports(0x1093F);
		    set.addRange(0x10920, 0x10939);
		    Lydian$1.characters = set;
		    return Lydian$1;
		  }

		  var Mahajani$1 = {};

		  var hasRequiredMahajani$1;
		  function requireMahajani$1() {
		    if (hasRequiredMahajani$1) return Mahajani$1;
		    hasRequiredMahajani$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x964, 0x96F).addRange(0xA830, 0xA839).addRange(0x11150, 0x11176);
		    Mahajani$1.characters = set;
		    return Mahajani$1;
		  }

		  var Makasar$1 = {};

		  var hasRequiredMakasar$1;
		  function requireMakasar$1() {
		    if (hasRequiredMakasar$1) return Makasar$1;
		    hasRequiredMakasar$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x11EE0, 0x11EF8);
		    Makasar$1.characters = set;
		    return Makasar$1;
		  }

		  var Malayalam$1 = {};

		  var hasRequiredMalayalam$1;
		  function requireMalayalam$1() {
		    if (hasRequiredMalayalam$1) return Malayalam$1;
		    hasRequiredMalayalam$1 = 1;
		    var set = regenerateExports(0x1CDA, 0x1CF2);
		    set.addRange(0x951, 0x952).addRange(0x964, 0x965).addRange(0xD00, 0xD0C).addRange(0xD0E, 0xD10).addRange(0xD12, 0xD44).addRange(0xD46, 0xD48).addRange(0xD4A, 0xD4F).addRange(0xD54, 0xD63).addRange(0xD66, 0xD7F).addRange(0xA830, 0xA832);
		    Malayalam$1.characters = set;
		    return Malayalam$1;
		  }

		  var Mandaic$1 = {};

		  var hasRequiredMandaic$1;
		  function requireMandaic$1() {
		    if (hasRequiredMandaic$1) return Mandaic$1;
		    hasRequiredMandaic$1 = 1;
		    var set = regenerateExports(0x640, 0x85E);
		    set.addRange(0x840, 0x85B);
		    Mandaic$1.characters = set;
		    return Mandaic$1;
		  }

		  var Manichaean$1 = {};

		  var hasRequiredManichaean$1;
		  function requireManichaean$1() {
		    if (hasRequiredManichaean$1) return Manichaean$1;
		    hasRequiredManichaean$1 = 1;
		    var set = regenerateExports(0x640);
		    set.addRange(0x10AC0, 0x10AE6).addRange(0x10AEB, 0x10AF6);
		    Manichaean$1.characters = set;
		    return Manichaean$1;
		  }

		  var Marchen$1 = {};

		  var hasRequiredMarchen$1;
		  function requireMarchen$1() {
		    if (hasRequiredMarchen$1) return Marchen$1;
		    hasRequiredMarchen$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x11C70, 0x11C8F).addRange(0x11C92, 0x11CA7).addRange(0x11CA9, 0x11CB6);
		    Marchen$1.characters = set;
		    return Marchen$1;
		  }

		  var Masaram_Gondi$1 = {};

		  var hasRequiredMasaram_Gondi$1;
		  function requireMasaram_Gondi$1() {
		    if (hasRequiredMasaram_Gondi$1) return Masaram_Gondi$1;
		    hasRequiredMasaram_Gondi$1 = 1;
		    var set = regenerateExports(0x11D3A);
		    set.addRange(0x964, 0x965).addRange(0x11D00, 0x11D06).addRange(0x11D08, 0x11D09).addRange(0x11D0B, 0x11D36).addRange(0x11D3C, 0x11D3D).addRange(0x11D3F, 0x11D47).addRange(0x11D50, 0x11D59);
		    Masaram_Gondi$1.characters = set;
		    return Masaram_Gondi$1;
		  }

		  var Medefaidrin$1 = {};

		  var hasRequiredMedefaidrin$1;
		  function requireMedefaidrin$1() {
		    if (hasRequiredMedefaidrin$1) return Medefaidrin$1;
		    hasRequiredMedefaidrin$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x16E40, 0x16E9A);
		    Medefaidrin$1.characters = set;
		    return Medefaidrin$1;
		  }

		  var Meetei_Mayek$1 = {};

		  var hasRequiredMeetei_Mayek$1;
		  function requireMeetei_Mayek$1() {
		    if (hasRequiredMeetei_Mayek$1) return Meetei_Mayek$1;
		    hasRequiredMeetei_Mayek$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0xAAE0, 0xAAF6).addRange(0xABC0, 0xABED).addRange(0xABF0, 0xABF9);
		    Meetei_Mayek$1.characters = set;
		    return Meetei_Mayek$1;
		  }

		  var Mende_Kikakui$1 = {};

		  var hasRequiredMende_Kikakui$1;
		  function requireMende_Kikakui$1() {
		    if (hasRequiredMende_Kikakui$1) return Mende_Kikakui$1;
		    hasRequiredMende_Kikakui$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x1E800, 0x1E8C4).addRange(0x1E8C7, 0x1E8D6);
		    Mende_Kikakui$1.characters = set;
		    return Mende_Kikakui$1;
		  }

		  var Meroitic_Cursive$1 = {};

		  var hasRequiredMeroitic_Cursive$1;
		  function requireMeroitic_Cursive$1() {
		    if (hasRequiredMeroitic_Cursive$1) return Meroitic_Cursive$1;
		    hasRequiredMeroitic_Cursive$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x109A0, 0x109B7).addRange(0x109BC, 0x109CF).addRange(0x109D2, 0x109FF);
		    Meroitic_Cursive$1.characters = set;
		    return Meroitic_Cursive$1;
		  }

		  var Meroitic_Hieroglyphs$1 = {};

		  var hasRequiredMeroitic_Hieroglyphs$1;
		  function requireMeroitic_Hieroglyphs$1() {
		    if (hasRequiredMeroitic_Hieroglyphs$1) return Meroitic_Hieroglyphs$1;
		    hasRequiredMeroitic_Hieroglyphs$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x10980, 0x1099F);
		    Meroitic_Hieroglyphs$1.characters = set;
		    return Meroitic_Hieroglyphs$1;
		  }

		  var Miao$1 = {};

		  var hasRequiredMiao$1;
		  function requireMiao$1() {
		    if (hasRequiredMiao$1) return Miao$1;
		    hasRequiredMiao$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x16F00, 0x16F4A).addRange(0x16F4F, 0x16F87).addRange(0x16F8F, 0x16F9F);
		    Miao$1.characters = set;
		    return Miao$1;
		  }

		  var Modi$1 = {};

		  var hasRequiredModi$1;
		  function requireModi$1() {
		    if (hasRequiredModi$1) return Modi$1;
		    hasRequiredModi$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0xA830, 0xA839).addRange(0x11600, 0x11644).addRange(0x11650, 0x11659);
		    Modi$1.characters = set;
		    return Modi$1;
		  }

		  var Mongolian$1 = {};

		  var hasRequiredMongolian$1;
		  function requireMongolian$1() {
		    if (hasRequiredMongolian$1) return Mongolian$1;
		    hasRequiredMongolian$1 = 1;
		    var set = regenerateExports(0x202F);
		    set.addRange(0x1800, 0x1819).addRange(0x1820, 0x1878).addRange(0x1880, 0x18AA).addRange(0x11660, 0x1166C);
		    Mongolian$1.characters = set;
		    return Mongolian$1;
		  }

		  var Mro$1 = {};

		  var hasRequiredMro$1;
		  function requireMro$1() {
		    if (hasRequiredMro$1) return Mro$1;
		    hasRequiredMro$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x16A40, 0x16A5E).addRange(0x16A60, 0x16A69).addRange(0x16A6E, 0x16A6F);
		    Mro$1.characters = set;
		    return Mro$1;
		  }

		  var Multani$1 = {};

		  var hasRequiredMultani$1;
		  function requireMultani$1() {
		    if (hasRequiredMultani$1) return Multani$1;
		    hasRequiredMultani$1 = 1;
		    var set = regenerateExports(0x11288);
		    set.addRange(0xA66, 0xA6F).addRange(0x11280, 0x11286).addRange(0x1128A, 0x1128D).addRange(0x1128F, 0x1129D).addRange(0x1129F, 0x112A9);
		    Multani$1.characters = set;
		    return Multani$1;
		  }

		  var Myanmar$1 = {};

		  var hasRequiredMyanmar$1;
		  function requireMyanmar$1() {
		    if (hasRequiredMyanmar$1) return Myanmar$1;
		    hasRequiredMyanmar$1 = 1;
		    var set = regenerateExports(0xA92E);
		    set.addRange(0x1000, 0x109F).addRange(0xA9E0, 0xA9FE).addRange(0xAA60, 0xAA7F);
		    Myanmar$1.characters = set;
		    return Myanmar$1;
		  }

		  var Nabataean$1 = {};

		  var hasRequiredNabataean$1;
		  function requireNabataean$1() {
		    if (hasRequiredNabataean$1) return Nabataean$1;
		    hasRequiredNabataean$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x10880, 0x1089E).addRange(0x108A7, 0x108AF);
		    Nabataean$1.characters = set;
		    return Nabataean$1;
		  }

		  var Nag_Mundari$1 = {};

		  var hasRequiredNag_Mundari$1;
		  function requireNag_Mundari$1() {
		    if (hasRequiredNag_Mundari$1) return Nag_Mundari$1;
		    hasRequiredNag_Mundari$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x1E4D0, 0x1E4F9);
		    Nag_Mundari$1.characters = set;
		    return Nag_Mundari$1;
		  }

		  var Nandinagari$1 = {};

		  var hasRequiredNandinagari$1;
		  function requireNandinagari$1() {
		    if (hasRequiredNandinagari$1) return Nandinagari$1;
		    hasRequiredNandinagari$1 = 1;
		    var set = regenerateExports(0x1CE9, 0x1CF2, 0x1CFA);
		    set.addRange(0x964, 0x965).addRange(0xCE6, 0xCEF).addRange(0xA830, 0xA835).addRange(0x119A0, 0x119A7).addRange(0x119AA, 0x119D7).addRange(0x119DA, 0x119E4);
		    Nandinagari$1.characters = set;
		    return Nandinagari$1;
		  }

		  var New_Tai_Lue$1 = {};

		  var hasRequiredNew_Tai_Lue$1;
		  function requireNew_Tai_Lue$1() {
		    if (hasRequiredNew_Tai_Lue$1) return New_Tai_Lue$1;
		    hasRequiredNew_Tai_Lue$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x1980, 0x19AB).addRange(0x19B0, 0x19C9).addRange(0x19D0, 0x19DA).addRange(0x19DE, 0x19DF);
		    New_Tai_Lue$1.characters = set;
		    return New_Tai_Lue$1;
		  }

		  var Newa$1 = {};

		  var hasRequiredNewa$1;
		  function requireNewa$1() {
		    if (hasRequiredNewa$1) return Newa$1;
		    hasRequiredNewa$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x11400, 0x1145B).addRange(0x1145D, 0x11461);
		    Newa$1.characters = set;
		    return Newa$1;
		  }

		  var Nko$1 = {};

		  var hasRequiredNko$1;
		  function requireNko$1() {
		    if (hasRequiredNko$1) return Nko$1;
		    hasRequiredNko$1 = 1;
		    var set = regenerateExports(0x60C, 0x61B, 0x61F);
		    set.addRange(0x7C0, 0x7FA).addRange(0x7FD, 0x7FF).addRange(0xFD3E, 0xFD3F);
		    Nko$1.characters = set;
		    return Nko$1;
		  }

		  var Nushu$1 = {};

		  var hasRequiredNushu$1;
		  function requireNushu$1() {
		    if (hasRequiredNushu$1) return Nushu$1;
		    hasRequiredNushu$1 = 1;
		    var set = regenerateExports(0x16FE1);
		    set.addRange(0x1B170, 0x1B2FB);
		    Nushu$1.characters = set;
		    return Nushu$1;
		  }

		  var Nyiakeng_Puachue_Hmong$1 = {};

		  var hasRequiredNyiakeng_Puachue_Hmong$1;
		  function requireNyiakeng_Puachue_Hmong$1() {
		    if (hasRequiredNyiakeng_Puachue_Hmong$1) return Nyiakeng_Puachue_Hmong$1;
		    hasRequiredNyiakeng_Puachue_Hmong$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x1E100, 0x1E12C).addRange(0x1E130, 0x1E13D).addRange(0x1E140, 0x1E149).addRange(0x1E14E, 0x1E14F);
		    Nyiakeng_Puachue_Hmong$1.characters = set;
		    return Nyiakeng_Puachue_Hmong$1;
		  }

		  var Ogham$1 = {};

		  var hasRequiredOgham$1;
		  function requireOgham$1() {
		    if (hasRequiredOgham$1) return Ogham$1;
		    hasRequiredOgham$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x1680, 0x169C);
		    Ogham$1.characters = set;
		    return Ogham$1;
		  }

		  var Ol_Chiki$1 = {};

		  var hasRequiredOl_Chiki$1;
		  function requireOl_Chiki$1() {
		    if (hasRequiredOl_Chiki$1) return Ol_Chiki$1;
		    hasRequiredOl_Chiki$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x1C50, 0x1C7F);
		    Ol_Chiki$1.characters = set;
		    return Ol_Chiki$1;
		  }

		  var Old_Hungarian$1 = {};

		  var hasRequiredOld_Hungarian$1;
		  function requireOld_Hungarian$1() {
		    if (hasRequiredOld_Hungarian$1) return Old_Hungarian$1;
		    hasRequiredOld_Hungarian$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x10C80, 0x10CB2).addRange(0x10CC0, 0x10CF2).addRange(0x10CFA, 0x10CFF);
		    Old_Hungarian$1.characters = set;
		    return Old_Hungarian$1;
		  }

		  var Old_Italic$1 = {};

		  var hasRequiredOld_Italic$1;
		  function requireOld_Italic$1() {
		    if (hasRequiredOld_Italic$1) return Old_Italic$1;
		    hasRequiredOld_Italic$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x10300, 0x10323).addRange(0x1032D, 0x1032F);
		    Old_Italic$1.characters = set;
		    return Old_Italic$1;
		  }

		  var Old_North_Arabian$1 = {};

		  var hasRequiredOld_North_Arabian$1;
		  function requireOld_North_Arabian$1() {
		    if (hasRequiredOld_North_Arabian$1) return Old_North_Arabian$1;
		    hasRequiredOld_North_Arabian$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x10A80, 0x10A9F);
		    Old_North_Arabian$1.characters = set;
		    return Old_North_Arabian$1;
		  }

		  var Old_Permic$1 = {};

		  var hasRequiredOld_Permic$1;
		  function requireOld_Permic$1() {
		    if (hasRequiredOld_Permic$1) return Old_Permic$1;
		    hasRequiredOld_Permic$1 = 1;
		    var set = regenerateExports(0x483);
		    set.addRange(0x10350, 0x1037A);
		    Old_Permic$1.characters = set;
		    return Old_Permic$1;
		  }

		  var Old_Persian$1 = {};

		  var hasRequiredOld_Persian$1;
		  function requireOld_Persian$1() {
		    if (hasRequiredOld_Persian$1) return Old_Persian$1;
		    hasRequiredOld_Persian$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x103A0, 0x103C3).addRange(0x103C8, 0x103D5);
		    Old_Persian$1.characters = set;
		    return Old_Persian$1;
		  }

		  var Old_Sogdian$1 = {};

		  var hasRequiredOld_Sogdian$1;
		  function requireOld_Sogdian$1() {
		    if (hasRequiredOld_Sogdian$1) return Old_Sogdian$1;
		    hasRequiredOld_Sogdian$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x10F00, 0x10F27);
		    Old_Sogdian$1.characters = set;
		    return Old_Sogdian$1;
		  }

		  var Old_South_Arabian$1 = {};

		  var hasRequiredOld_South_Arabian$1;
		  function requireOld_South_Arabian$1() {
		    if (hasRequiredOld_South_Arabian$1) return Old_South_Arabian$1;
		    hasRequiredOld_South_Arabian$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x10A60, 0x10A7F);
		    Old_South_Arabian$1.characters = set;
		    return Old_South_Arabian$1;
		  }

		  var Old_Turkic$1 = {};

		  var hasRequiredOld_Turkic$1;
		  function requireOld_Turkic$1() {
		    if (hasRequiredOld_Turkic$1) return Old_Turkic$1;
		    hasRequiredOld_Turkic$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x10C00, 0x10C48);
		    Old_Turkic$1.characters = set;
		    return Old_Turkic$1;
		  }

		  var Old_Uyghur$1 = {};

		  var hasRequiredOld_Uyghur$1;
		  function requireOld_Uyghur$1() {
		    if (hasRequiredOld_Uyghur$1) return Old_Uyghur$1;
		    hasRequiredOld_Uyghur$1 = 1;
		    var set = regenerateExports(0x640, 0x10AF2);
		    set.addRange(0x10F70, 0x10F89);
		    Old_Uyghur$1.characters = set;
		    return Old_Uyghur$1;
		  }

		  var Oriya$1 = {};

		  var hasRequiredOriya$1;
		  function requireOriya$1() {
		    if (hasRequiredOriya$1) return Oriya$1;
		    hasRequiredOriya$1 = 1;
		    var set = regenerateExports(0x1CDA, 0x1CF2);
		    set.addRange(0x951, 0x952).addRange(0x964, 0x965).addRange(0xB01, 0xB03).addRange(0xB05, 0xB0C).addRange(0xB0F, 0xB10).addRange(0xB13, 0xB28).addRange(0xB2A, 0xB30).addRange(0xB32, 0xB33).addRange(0xB35, 0xB39).addRange(0xB3C, 0xB44).addRange(0xB47, 0xB48).addRange(0xB4B, 0xB4D).addRange(0xB55, 0xB57).addRange(0xB5C, 0xB5D).addRange(0xB5F, 0xB63).addRange(0xB66, 0xB77);
		    Oriya$1.characters = set;
		    return Oriya$1;
		  }

		  var Osage$1 = {};

		  var hasRequiredOsage$1;
		  function requireOsage$1() {
		    if (hasRequiredOsage$1) return Osage$1;
		    hasRequiredOsage$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x104B0, 0x104D3).addRange(0x104D8, 0x104FB);
		    Osage$1.characters = set;
		    return Osage$1;
		  }

		  var Osmanya$1 = {};

		  var hasRequiredOsmanya$1;
		  function requireOsmanya$1() {
		    if (hasRequiredOsmanya$1) return Osmanya$1;
		    hasRequiredOsmanya$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x10480, 0x1049D).addRange(0x104A0, 0x104A9);
		    Osmanya$1.characters = set;
		    return Osmanya$1;
		  }

		  var Pahawh_Hmong$1 = {};

		  var hasRequiredPahawh_Hmong$1;
		  function requirePahawh_Hmong$1() {
		    if (hasRequiredPahawh_Hmong$1) return Pahawh_Hmong$1;
		    hasRequiredPahawh_Hmong$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x16B00, 0x16B45).addRange(0x16B50, 0x16B59).addRange(0x16B5B, 0x16B61).addRange(0x16B63, 0x16B77).addRange(0x16B7D, 0x16B8F);
		    Pahawh_Hmong$1.characters = set;
		    return Pahawh_Hmong$1;
		  }

		  var Palmyrene$1 = {};

		  var hasRequiredPalmyrene$1;
		  function requirePalmyrene$1() {
		    if (hasRequiredPalmyrene$1) return Palmyrene$1;
		    hasRequiredPalmyrene$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x10860, 0x1087F);
		    Palmyrene$1.characters = set;
		    return Palmyrene$1;
		  }

		  var Pau_Cin_Hau$1 = {};

		  var hasRequiredPau_Cin_Hau$1;
		  function requirePau_Cin_Hau$1() {
		    if (hasRequiredPau_Cin_Hau$1) return Pau_Cin_Hau$1;
		    hasRequiredPau_Cin_Hau$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x11AC0, 0x11AF8);
		    Pau_Cin_Hau$1.characters = set;
		    return Pau_Cin_Hau$1;
		  }

		  var Phags_Pa$1 = {};

		  var hasRequiredPhags_Pa$1;
		  function requirePhags_Pa$1() {
		    if (hasRequiredPhags_Pa$1) return Phags_Pa$1;
		    hasRequiredPhags_Pa$1 = 1;
		    var set = regenerateExports(0x1805);
		    set.addRange(0x1802, 0x1803).addRange(0xA840, 0xA877);
		    Phags_Pa$1.characters = set;
		    return Phags_Pa$1;
		  }

		  var Phoenician$1 = {};

		  var hasRequiredPhoenician$1;
		  function requirePhoenician$1() {
		    if (hasRequiredPhoenician$1) return Phoenician$1;
		    hasRequiredPhoenician$1 = 1;
		    var set = regenerateExports(0x1091F);
		    set.addRange(0x10900, 0x1091B);
		    Phoenician$1.characters = set;
		    return Phoenician$1;
		  }

		  var Psalter_Pahlavi$1 = {};

		  var hasRequiredPsalter_Pahlavi$1;
		  function requirePsalter_Pahlavi$1() {
		    if (hasRequiredPsalter_Pahlavi$1) return Psalter_Pahlavi$1;
		    hasRequiredPsalter_Pahlavi$1 = 1;
		    var set = regenerateExports(0x640);
		    set.addRange(0x10B80, 0x10B91).addRange(0x10B99, 0x10B9C).addRange(0x10BA9, 0x10BAF);
		    Psalter_Pahlavi$1.characters = set;
		    return Psalter_Pahlavi$1;
		  }

		  var Rejang$1 = {};

		  var hasRequiredRejang$1;
		  function requireRejang$1() {
		    if (hasRequiredRejang$1) return Rejang$1;
		    hasRequiredRejang$1 = 1;
		    var set = regenerateExports(0xA95F);
		    set.addRange(0xA930, 0xA953);
		    Rejang$1.characters = set;
		    return Rejang$1;
		  }

		  var Runic$1 = {};

		  var hasRequiredRunic$1;
		  function requireRunic$1() {
		    if (hasRequiredRunic$1) return Runic$1;
		    hasRequiredRunic$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x16A0, 0x16EA).addRange(0x16EE, 0x16F8);
		    Runic$1.characters = set;
		    return Runic$1;
		  }

		  var Samaritan$1 = {};

		  var hasRequiredSamaritan$1;
		  function requireSamaritan$1() {
		    if (hasRequiredSamaritan$1) return Samaritan$1;
		    hasRequiredSamaritan$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x800, 0x82D).addRange(0x830, 0x83E);
		    Samaritan$1.characters = set;
		    return Samaritan$1;
		  }

		  var Saurashtra$1 = {};

		  var hasRequiredSaurashtra$1;
		  function requireSaurashtra$1() {
		    if (hasRequiredSaurashtra$1) return Saurashtra$1;
		    hasRequiredSaurashtra$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0xA880, 0xA8C5).addRange(0xA8CE, 0xA8D9);
		    Saurashtra$1.characters = set;
		    return Saurashtra$1;
		  }

		  var Sharada$1 = {};

		  var hasRequiredSharada$1;
		  function requireSharada$1() {
		    if (hasRequiredSharada$1) return Sharada$1;
		    hasRequiredSharada$1 = 1;
		    var set = regenerateExports(0x951, 0x1CD7, 0x1CD9, 0x1CE0, 0xA838);
		    set.addRange(0x1CDC, 0x1CDD).addRange(0xA830, 0xA835).addRange(0x11180, 0x111DF);
		    Sharada$1.characters = set;
		    return Sharada$1;
		  }

		  var Shavian$1 = {};

		  var hasRequiredShavian$1;
		  function requireShavian$1() {
		    if (hasRequiredShavian$1) return Shavian$1;
		    hasRequiredShavian$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x10450, 0x1047F);
		    Shavian$1.characters = set;
		    return Shavian$1;
		  }

		  var Siddham$1 = {};

		  var hasRequiredSiddham$1;
		  function requireSiddham$1() {
		    if (hasRequiredSiddham$1) return Siddham$1;
		    hasRequiredSiddham$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x11580, 0x115B5).addRange(0x115B8, 0x115DD);
		    Siddham$1.characters = set;
		    return Siddham$1;
		  }

		  var SignWriting$1 = {};

		  var hasRequiredSignWriting$1;
		  function requireSignWriting$1() {
		    if (hasRequiredSignWriting$1) return SignWriting$1;
		    hasRequiredSignWriting$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x1D800, 0x1DA8B).addRange(0x1DA9B, 0x1DA9F).addRange(0x1DAA1, 0x1DAAF);
		    SignWriting$1.characters = set;
		    return SignWriting$1;
		  }

		  var Sinhala$1 = {};

		  var hasRequiredSinhala$1;
		  function requireSinhala$1() {
		    if (hasRequiredSinhala$1) return Sinhala$1;
		    hasRequiredSinhala$1 = 1;
		    var set = regenerateExports(0xDBD, 0xDCA, 0xDD6, 0x1CF2);
		    set.addRange(0x964, 0x965).addRange(0xD81, 0xD83).addRange(0xD85, 0xD96).addRange(0xD9A, 0xDB1).addRange(0xDB3, 0xDBB).addRange(0xDC0, 0xDC6).addRange(0xDCF, 0xDD4).addRange(0xDD8, 0xDDF).addRange(0xDE6, 0xDEF).addRange(0xDF2, 0xDF4).addRange(0x111E1, 0x111F4);
		    Sinhala$1.characters = set;
		    return Sinhala$1;
		  }

		  var Sogdian$1 = {};

		  var hasRequiredSogdian$1;
		  function requireSogdian$1() {
		    if (hasRequiredSogdian$1) return Sogdian$1;
		    hasRequiredSogdian$1 = 1;
		    var set = regenerateExports(0x640);
		    set.addRange(0x10F30, 0x10F59);
		    Sogdian$1.characters = set;
		    return Sogdian$1;
		  }

		  var Sora_Sompeng$1 = {};

		  var hasRequiredSora_Sompeng$1;
		  function requireSora_Sompeng$1() {
		    if (hasRequiredSora_Sompeng$1) return Sora_Sompeng$1;
		    hasRequiredSora_Sompeng$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x110D0, 0x110E8).addRange(0x110F0, 0x110F9);
		    Sora_Sompeng$1.characters = set;
		    return Sora_Sompeng$1;
		  }

		  var Soyombo$1 = {};

		  var hasRequiredSoyombo$1;
		  function requireSoyombo$1() {
		    if (hasRequiredSoyombo$1) return Soyombo$1;
		    hasRequiredSoyombo$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x11A50, 0x11AA2);
		    Soyombo$1.characters = set;
		    return Soyombo$1;
		  }

		  var Sundanese$1 = {};

		  var hasRequiredSundanese$1;
		  function requireSundanese$1() {
		    if (hasRequiredSundanese$1) return Sundanese$1;
		    hasRequiredSundanese$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x1B80, 0x1BBF).addRange(0x1CC0, 0x1CC7);
		    Sundanese$1.characters = set;
		    return Sundanese$1;
		  }

		  var Syloti_Nagri$1 = {};

		  var hasRequiredSyloti_Nagri$1;
		  function requireSyloti_Nagri$1() {
		    if (hasRequiredSyloti_Nagri$1) return Syloti_Nagri$1;
		    hasRequiredSyloti_Nagri$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x964, 0x965).addRange(0x9E6, 0x9EF).addRange(0xA800, 0xA82C);
		    Syloti_Nagri$1.characters = set;
		    return Syloti_Nagri$1;
		  }

		  var Syriac$1 = {};

		  var hasRequiredSyriac$1;
		  function requireSyriac$1() {
		    if (hasRequiredSyriac$1) return Syriac$1;
		    hasRequiredSyriac$1 = 1;
		    var set = regenerateExports(0x60C, 0x61F, 0x640, 0x670, 0x1DF8, 0x1DFA);
		    set.addRange(0x61B, 0x61C).addRange(0x64B, 0x655).addRange(0x700, 0x70D).addRange(0x70F, 0x74A).addRange(0x74D, 0x74F).addRange(0x860, 0x86A);
		    Syriac$1.characters = set;
		    return Syriac$1;
		  }

		  var Tagalog$1 = {};

		  var hasRequiredTagalog$1;
		  function requireTagalog$1() {
		    if (hasRequiredTagalog$1) return Tagalog$1;
		    hasRequiredTagalog$1 = 1;
		    var set = regenerateExports(0x171F);
		    set.addRange(0x1700, 0x1715).addRange(0x1735, 0x1736);
		    Tagalog$1.characters = set;
		    return Tagalog$1;
		  }

		  var Tagbanwa$1 = {};

		  var hasRequiredTagbanwa$1;
		  function requireTagbanwa$1() {
		    if (hasRequiredTagbanwa$1) return Tagbanwa$1;
		    hasRequiredTagbanwa$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x1735, 0x1736).addRange(0x1760, 0x176C).addRange(0x176E, 0x1770).addRange(0x1772, 0x1773);
		    Tagbanwa$1.characters = set;
		    return Tagbanwa$1;
		  }

		  var Tai_Le$1 = {};

		  var hasRequiredTai_Le$1;
		  function requireTai_Le$1() {
		    if (hasRequiredTai_Le$1) return Tai_Le$1;
		    hasRequiredTai_Le$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x1040, 0x1049).addRange(0x1950, 0x196D).addRange(0x1970, 0x1974);
		    Tai_Le$1.characters = set;
		    return Tai_Le$1;
		  }

		  var Tai_Tham$1 = {};

		  var hasRequiredTai_Tham$1;
		  function requireTai_Tham$1() {
		    if (hasRequiredTai_Tham$1) return Tai_Tham$1;
		    hasRequiredTai_Tham$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x1A20, 0x1A5E).addRange(0x1A60, 0x1A7C).addRange(0x1A7F, 0x1A89).addRange(0x1A90, 0x1A99).addRange(0x1AA0, 0x1AAD);
		    Tai_Tham$1.characters = set;
		    return Tai_Tham$1;
		  }

		  var Tai_Viet$1 = {};

		  var hasRequiredTai_Viet$1;
		  function requireTai_Viet$1() {
		    if (hasRequiredTai_Viet$1) return Tai_Viet$1;
		    hasRequiredTai_Viet$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0xAA80, 0xAAC2).addRange(0xAADB, 0xAADF);
		    Tai_Viet$1.characters = set;
		    return Tai_Viet$1;
		  }

		  var Takri$1 = {};

		  var hasRequiredTakri$1;
		  function requireTakri$1() {
		    if (hasRequiredTakri$1) return Takri$1;
		    hasRequiredTakri$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x964, 0x965).addRange(0xA830, 0xA839).addRange(0x11680, 0x116B9).addRange(0x116C0, 0x116C9);
		    Takri$1.characters = set;
		    return Takri$1;
		  }

		  var Tamil$1 = {};

		  var hasRequiredTamil$1;
		  function requireTamil$1() {
		    if (hasRequiredTamil$1) return Tamil$1;
		    hasRequiredTamil$1 = 1;
		    var set = regenerateExports(0xB9C, 0xBD0, 0xBD7, 0x1CDA, 0xA8F3, 0x11301, 0x11303, 0x11FFF);
		    set.addRange(0x951, 0x952).addRange(0x964, 0x965).addRange(0xB82, 0xB83).addRange(0xB85, 0xB8A).addRange(0xB8E, 0xB90).addRange(0xB92, 0xB95).addRange(0xB99, 0xB9A).addRange(0xB9E, 0xB9F).addRange(0xBA3, 0xBA4).addRange(0xBA8, 0xBAA).addRange(0xBAE, 0xBB9).addRange(0xBBE, 0xBC2).addRange(0xBC6, 0xBC8).addRange(0xBCA, 0xBCD).addRange(0xBE6, 0xBFA).addRange(0x1133B, 0x1133C).addRange(0x11FC0, 0x11FF1);
		    Tamil$1.characters = set;
		    return Tamil$1;
		  }

		  var Tangsa$1 = {};

		  var hasRequiredTangsa$1;
		  function requireTangsa$1() {
		    if (hasRequiredTangsa$1) return Tangsa$1;
		    hasRequiredTangsa$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x16A70, 0x16ABE).addRange(0x16AC0, 0x16AC9);
		    Tangsa$1.characters = set;
		    return Tangsa$1;
		  }

		  var Tangut$1 = {};

		  var hasRequiredTangut$1;
		  function requireTangut$1() {
		    if (hasRequiredTangut$1) return Tangut$1;
		    hasRequiredTangut$1 = 1;
		    var set = regenerateExports(0x16FE0);
		    set.addRange(0x17000, 0x187F7).addRange(0x18800, 0x18AFF).addRange(0x18D00, 0x18D08);
		    Tangut$1.characters = set;
		    return Tangut$1;
		  }

		  var Telugu$1 = {};

		  var hasRequiredTelugu$1;
		  function requireTelugu$1() {
		    if (hasRequiredTelugu$1) return Telugu$1;
		    hasRequiredTelugu$1 = 1;
		    var set = regenerateExports(0xC5D, 0x1CDA, 0x1CF2);
		    set.addRange(0x951, 0x952).addRange(0x964, 0x965).addRange(0xC00, 0xC0C).addRange(0xC0E, 0xC10).addRange(0xC12, 0xC28).addRange(0xC2A, 0xC39).addRange(0xC3C, 0xC44).addRange(0xC46, 0xC48).addRange(0xC4A, 0xC4D).addRange(0xC55, 0xC56).addRange(0xC58, 0xC5A).addRange(0xC60, 0xC63).addRange(0xC66, 0xC6F).addRange(0xC77, 0xC7F);
		    Telugu$1.characters = set;
		    return Telugu$1;
		  }

		  var Thaana$1 = {};

		  var hasRequiredThaana$1;
		  function requireThaana$1() {
		    if (hasRequiredThaana$1) return Thaana$1;
		    hasRequiredThaana$1 = 1;
		    var set = regenerateExports(0x60C, 0x61F, 0xFDF2, 0xFDFD);
		    set.addRange(0x61B, 0x61C).addRange(0x660, 0x669).addRange(0x780, 0x7B1);
		    Thaana$1.characters = set;
		    return Thaana$1;
		  }

		  var Thai$1 = {};

		  var hasRequiredThai$1;
		  function requireThai$1() {
		    if (hasRequiredThai$1) return Thai$1;
		    hasRequiredThai$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0xE01, 0xE3A).addRange(0xE40, 0xE5B);
		    Thai$1.characters = set;
		    return Thai$1;
		  }

		  var Tibetan$1 = {};

		  var hasRequiredTibetan$1;
		  function requireTibetan$1() {
		    if (hasRequiredTibetan$1) return Tibetan$1;
		    hasRequiredTibetan$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0xF00, 0xF47).addRange(0xF49, 0xF6C).addRange(0xF71, 0xF97).addRange(0xF99, 0xFBC).addRange(0xFBE, 0xFCC).addRange(0xFCE, 0xFD4).addRange(0xFD9, 0xFDA);
		    Tibetan$1.characters = set;
		    return Tibetan$1;
		  }

		  var Tifinagh$1 = {};

		  var hasRequiredTifinagh$1;
		  function requireTifinagh$1() {
		    if (hasRequiredTifinagh$1) return Tifinagh$1;
		    hasRequiredTifinagh$1 = 1;
		    var set = regenerateExports(0x2D7F);
		    set.addRange(0x2D30, 0x2D67).addRange(0x2D6F, 0x2D70);
		    Tifinagh$1.characters = set;
		    return Tifinagh$1;
		  }

		  var Tirhuta$1 = {};

		  var hasRequiredTirhuta$1;
		  function requireTirhuta$1() {
		    if (hasRequiredTirhuta$1) return Tirhuta$1;
		    hasRequiredTirhuta$1 = 1;
		    var set = regenerateExports(0x1CF2);
		    set.addRange(0x951, 0x952).addRange(0x964, 0x965).addRange(0xA830, 0xA839).addRange(0x11480, 0x114C7).addRange(0x114D0, 0x114D9);
		    Tirhuta$1.characters = set;
		    return Tirhuta$1;
		  }

		  var Toto$1 = {};

		  var hasRequiredToto$1;
		  function requireToto$1() {
		    if (hasRequiredToto$1) return Toto$1;
		    hasRequiredToto$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x1E290, 0x1E2AE);
		    Toto$1.characters = set;
		    return Toto$1;
		  }

		  var Ugaritic$1 = {};

		  var hasRequiredUgaritic$1;
		  function requireUgaritic$1() {
		    if (hasRequiredUgaritic$1) return Ugaritic$1;
		    hasRequiredUgaritic$1 = 1;
		    var set = regenerateExports(0x1039F);
		    set.addRange(0x10380, 0x1039D);
		    Ugaritic$1.characters = set;
		    return Ugaritic$1;
		  }

		  var Vai$1 = {};

		  var hasRequiredVai$1;
		  function requireVai$1() {
		    if (hasRequiredVai$1) return Vai$1;
		    hasRequiredVai$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0xA500, 0xA62B);
		    Vai$1.characters = set;
		    return Vai$1;
		  }

		  var Vithkuqi$1 = {};

		  var hasRequiredVithkuqi$1;
		  function requireVithkuqi$1() {
		    if (hasRequiredVithkuqi$1) return Vithkuqi$1;
		    hasRequiredVithkuqi$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x10570, 0x1057A).addRange(0x1057C, 0x1058A).addRange(0x1058C, 0x10592).addRange(0x10594, 0x10595).addRange(0x10597, 0x105A1).addRange(0x105A3, 0x105B1).addRange(0x105B3, 0x105B9).addRange(0x105BB, 0x105BC);
		    Vithkuqi$1.characters = set;
		    return Vithkuqi$1;
		  }

		  var Wancho$1 = {};

		  var hasRequiredWancho$1;
		  function requireWancho$1() {
		    if (hasRequiredWancho$1) return Wancho$1;
		    hasRequiredWancho$1 = 1;
		    var set = regenerateExports(0x1E2FF);
		    set.addRange(0x1E2C0, 0x1E2F9);
		    Wancho$1.characters = set;
		    return Wancho$1;
		  }

		  var Warang_Citi$1 = {};

		  var hasRequiredWarang_Citi$1;
		  function requireWarang_Citi$1() {
		    if (hasRequiredWarang_Citi$1) return Warang_Citi$1;
		    hasRequiredWarang_Citi$1 = 1;
		    var set = regenerateExports(0x118FF);
		    set.addRange(0x118A0, 0x118F2);
		    Warang_Citi$1.characters = set;
		    return Warang_Citi$1;
		  }

		  var Yezidi$1 = {};

		  var hasRequiredYezidi$1;
		  function requireYezidi$1() {
		    if (hasRequiredYezidi$1) return Yezidi$1;
		    hasRequiredYezidi$1 = 1;
		    var set = regenerateExports(0x60C, 0x61B, 0x61F);
		    set.addRange(0x660, 0x669).addRange(0x10E80, 0x10EA9).addRange(0x10EAB, 0x10EAD).addRange(0x10EB0, 0x10EB1);
		    Yezidi$1.characters = set;
		    return Yezidi$1;
		  }

		  var Yi$1 = {};

		  var hasRequiredYi$1;
		  function requireYi$1() {
		    if (hasRequiredYi$1) return Yi$1;
		    hasRequiredYi$1 = 1;
		    var set = regenerateExports(0x30FB);
		    set.addRange(0x3001, 0x3002).addRange(0x3008, 0x3011).addRange(0x3014, 0x301B).addRange(0xA000, 0xA48C).addRange(0xA490, 0xA4C6).addRange(0xFF61, 0xFF65);
		    Yi$1.characters = set;
		    return Yi$1;
		  }

		  var Zanabazar_Square$1 = {};

		  var hasRequiredZanabazar_Square$1;
		  function requireZanabazar_Square$1() {
		    if (hasRequiredZanabazar_Square$1) return Zanabazar_Square$1;
		    hasRequiredZanabazar_Square$1 = 1;
		    var set = regenerateExports();
		    set.addRange(0x11A00, 0x11A47);
		    Zanabazar_Square$1.characters = set;
		    return Zanabazar_Square$1;
		  }

		  var Adlam = {};

		  var hasRequiredAdlam;
		  function requireAdlam() {
		    if (hasRequiredAdlam) return Adlam;
		    hasRequiredAdlam = 1;
		    var set = regenerateExports();
		    set.addRange(0x1E900, 0x1E94B).addRange(0x1E950, 0x1E959).addRange(0x1E95E, 0x1E95F);
		    Adlam.characters = set;
		    return Adlam;
		  }

		  var Ahom = {};

		  var hasRequiredAhom;
		  function requireAhom() {
		    if (hasRequiredAhom) return Ahom;
		    hasRequiredAhom = 1;
		    var set = regenerateExports();
		    set.addRange(0x11700, 0x1171A).addRange(0x1171D, 0x1172B).addRange(0x11730, 0x11746);
		    Ahom.characters = set;
		    return Ahom;
		  }

		  var Anatolian_Hieroglyphs = {};

		  var hasRequiredAnatolian_Hieroglyphs;
		  function requireAnatolian_Hieroglyphs() {
		    if (hasRequiredAnatolian_Hieroglyphs) return Anatolian_Hieroglyphs;
		    hasRequiredAnatolian_Hieroglyphs = 1;
		    var set = regenerateExports();
		    set.addRange(0x14400, 0x14646);
		    Anatolian_Hieroglyphs.characters = set;
		    return Anatolian_Hieroglyphs;
		  }

		  var Arabic = {};

		  var hasRequiredArabic;
		  function requireArabic() {
		    if (hasRequiredArabic) return Arabic;
		    hasRequiredArabic = 1;
		    var set = regenerateExports(0xFDCF, 0x1EE24, 0x1EE27, 0x1EE39, 0x1EE3B, 0x1EE42, 0x1EE47, 0x1EE49, 0x1EE4B, 0x1EE54, 0x1EE57, 0x1EE59, 0x1EE5B, 0x1EE5D, 0x1EE5F, 0x1EE64, 0x1EE7E);
		    set.addRange(0x600, 0x604).addRange(0x606, 0x60B).addRange(0x60D, 0x61A).addRange(0x61C, 0x61E).addRange(0x620, 0x63F).addRange(0x641, 0x64A).addRange(0x656, 0x66F).addRange(0x671, 0x6DC).addRange(0x6DE, 0x6FF).addRange(0x750, 0x77F).addRange(0x870, 0x88E).addRange(0x890, 0x891).addRange(0x898, 0x8E1).addRange(0x8E3, 0x8FF).addRange(0xFB50, 0xFBC2).addRange(0xFBD3, 0xFD3D).addRange(0xFD40, 0xFD8F).addRange(0xFD92, 0xFDC7).addRange(0xFDF0, 0xFDFF).addRange(0xFE70, 0xFE74).addRange(0xFE76, 0xFEFC).addRange(0x10E60, 0x10E7E).addRange(0x10EFD, 0x10EFF).addRange(0x1EE00, 0x1EE03).addRange(0x1EE05, 0x1EE1F).addRange(0x1EE21, 0x1EE22).addRange(0x1EE29, 0x1EE32).addRange(0x1EE34, 0x1EE37).addRange(0x1EE4D, 0x1EE4F).addRange(0x1EE51, 0x1EE52).addRange(0x1EE61, 0x1EE62).addRange(0x1EE67, 0x1EE6A).addRange(0x1EE6C, 0x1EE72).addRange(0x1EE74, 0x1EE77).addRange(0x1EE79, 0x1EE7C).addRange(0x1EE80, 0x1EE89).addRange(0x1EE8B, 0x1EE9B).addRange(0x1EEA1, 0x1EEA3).addRange(0x1EEA5, 0x1EEA9).addRange(0x1EEAB, 0x1EEBB).addRange(0x1EEF0, 0x1EEF1);
		    Arabic.characters = set;
		    return Arabic;
		  }

		  var Armenian = {};

		  var hasRequiredArmenian;
		  function requireArmenian() {
		    if (hasRequiredArmenian) return Armenian;
		    hasRequiredArmenian = 1;
		    var set = regenerateExports();
		    set.addRange(0x531, 0x556).addRange(0x559, 0x58A).addRange(0x58D, 0x58F).addRange(0xFB13, 0xFB17);
		    Armenian.characters = set;
		    return Armenian;
		  }

		  var Avestan = {};

		  var hasRequiredAvestan;
		  function requireAvestan() {
		    if (hasRequiredAvestan) return Avestan;
		    hasRequiredAvestan = 1;
		    var set = regenerateExports();
		    set.addRange(0x10B00, 0x10B35).addRange(0x10B39, 0x10B3F);
		    Avestan.characters = set;
		    return Avestan;
		  }

		  var Balinese = {};

		  var hasRequiredBalinese;
		  function requireBalinese() {
		    if (hasRequiredBalinese) return Balinese;
		    hasRequiredBalinese = 1;
		    var set = regenerateExports();
		    set.addRange(0x1B00, 0x1B4C).addRange(0x1B50, 0x1B7E);
		    Balinese.characters = set;
		    return Balinese;
		  }

		  var Bamum = {};

		  var hasRequiredBamum;
		  function requireBamum() {
		    if (hasRequiredBamum) return Bamum;
		    hasRequiredBamum = 1;
		    var set = regenerateExports();
		    set.addRange(0xA6A0, 0xA6F7).addRange(0x16800, 0x16A38);
		    Bamum.characters = set;
		    return Bamum;
		  }

		  var Bassa_Vah = {};

		  var hasRequiredBassa_Vah;
		  function requireBassa_Vah() {
		    if (hasRequiredBassa_Vah) return Bassa_Vah;
		    hasRequiredBassa_Vah = 1;
		    var set = regenerateExports();
		    set.addRange(0x16AD0, 0x16AED).addRange(0x16AF0, 0x16AF5);
		    Bassa_Vah.characters = set;
		    return Bassa_Vah;
		  }

		  var Batak = {};

		  var hasRequiredBatak;
		  function requireBatak() {
		    if (hasRequiredBatak) return Batak;
		    hasRequiredBatak = 1;
		    var set = regenerateExports();
		    set.addRange(0x1BC0, 0x1BF3).addRange(0x1BFC, 0x1BFF);
		    Batak.characters = set;
		    return Batak;
		  }

		  var Bengali = {};

		  var hasRequiredBengali;
		  function requireBengali() {
		    if (hasRequiredBengali) return Bengali;
		    hasRequiredBengali = 1;
		    var set = regenerateExports(0x9B2, 0x9D7);
		    set.addRange(0x980, 0x983).addRange(0x985, 0x98C).addRange(0x98F, 0x990).addRange(0x993, 0x9A8).addRange(0x9AA, 0x9B0).addRange(0x9B6, 0x9B9).addRange(0x9BC, 0x9C4).addRange(0x9C7, 0x9C8).addRange(0x9CB, 0x9CE).addRange(0x9DC, 0x9DD).addRange(0x9DF, 0x9E3).addRange(0x9E6, 0x9FE);
		    Bengali.characters = set;
		    return Bengali;
		  }

		  var Bhaiksuki = {};

		  var hasRequiredBhaiksuki;
		  function requireBhaiksuki() {
		    if (hasRequiredBhaiksuki) return Bhaiksuki;
		    hasRequiredBhaiksuki = 1;
		    var set = regenerateExports();
		    set.addRange(0x11C00, 0x11C08).addRange(0x11C0A, 0x11C36).addRange(0x11C38, 0x11C45).addRange(0x11C50, 0x11C6C);
		    Bhaiksuki.characters = set;
		    return Bhaiksuki;
		  }

		  var Bopomofo = {};

		  var hasRequiredBopomofo;
		  function requireBopomofo() {
		    if (hasRequiredBopomofo) return Bopomofo;
		    hasRequiredBopomofo = 1;
		    var set = regenerateExports();
		    set.addRange(0x2EA, 0x2EB).addRange(0x3105, 0x312F).addRange(0x31A0, 0x31BF);
		    Bopomofo.characters = set;
		    return Bopomofo;
		  }

		  var Brahmi = {};

		  var hasRequiredBrahmi;
		  function requireBrahmi() {
		    if (hasRequiredBrahmi) return Brahmi;
		    hasRequiredBrahmi = 1;
		    var set = regenerateExports(0x1107F);
		    set.addRange(0x11000, 0x1104D).addRange(0x11052, 0x11075);
		    Brahmi.characters = set;
		    return Brahmi;
		  }

		  var Braille = {};

		  var hasRequiredBraille;
		  function requireBraille() {
		    if (hasRequiredBraille) return Braille;
		    hasRequiredBraille = 1;
		    var set = regenerateExports();
		    set.addRange(0x2800, 0x28FF);
		    Braille.characters = set;
		    return Braille;
		  }

		  var Buginese = {};

		  var hasRequiredBuginese;
		  function requireBuginese() {
		    if (hasRequiredBuginese) return Buginese;
		    hasRequiredBuginese = 1;
		    var set = regenerateExports();
		    set.addRange(0x1A00, 0x1A1B).addRange(0x1A1E, 0x1A1F);
		    Buginese.characters = set;
		    return Buginese;
		  }

		  var Buhid = {};

		  var hasRequiredBuhid;
		  function requireBuhid() {
		    if (hasRequiredBuhid) return Buhid;
		    hasRequiredBuhid = 1;
		    var set = regenerateExports();
		    set.addRange(0x1740, 0x1753);
		    Buhid.characters = set;
		    return Buhid;
		  }

		  var Canadian_Aboriginal = {};

		  var hasRequiredCanadian_Aboriginal;
		  function requireCanadian_Aboriginal() {
		    if (hasRequiredCanadian_Aboriginal) return Canadian_Aboriginal;
		    hasRequiredCanadian_Aboriginal = 1;
		    var set = regenerateExports();
		    set.addRange(0x1400, 0x167F).addRange(0x18B0, 0x18F5).addRange(0x11AB0, 0x11ABF);
		    Canadian_Aboriginal.characters = set;
		    return Canadian_Aboriginal;
		  }

		  var Carian = {};

		  var hasRequiredCarian;
		  function requireCarian() {
		    if (hasRequiredCarian) return Carian;
		    hasRequiredCarian = 1;
		    var set = regenerateExports();
		    set.addRange(0x102A0, 0x102D0);
		    Carian.characters = set;
		    return Carian;
		  }

		  var Caucasian_Albanian = {};

		  var hasRequiredCaucasian_Albanian;
		  function requireCaucasian_Albanian() {
		    if (hasRequiredCaucasian_Albanian) return Caucasian_Albanian;
		    hasRequiredCaucasian_Albanian = 1;
		    var set = regenerateExports(0x1056F);
		    set.addRange(0x10530, 0x10563);
		    Caucasian_Albanian.characters = set;
		    return Caucasian_Albanian;
		  }

		  var Chakma = {};

		  var hasRequiredChakma;
		  function requireChakma() {
		    if (hasRequiredChakma) return Chakma;
		    hasRequiredChakma = 1;
		    var set = regenerateExports();
		    set.addRange(0x11100, 0x11134).addRange(0x11136, 0x11147);
		    Chakma.characters = set;
		    return Chakma;
		  }

		  var Cham = {};

		  var hasRequiredCham;
		  function requireCham() {
		    if (hasRequiredCham) return Cham;
		    hasRequiredCham = 1;
		    var set = regenerateExports();
		    set.addRange(0xAA00, 0xAA36).addRange(0xAA40, 0xAA4D).addRange(0xAA50, 0xAA59).addRange(0xAA5C, 0xAA5F);
		    Cham.characters = set;
		    return Cham;
		  }

		  var Cherokee = {};

		  var hasRequiredCherokee;
		  function requireCherokee() {
		    if (hasRequiredCherokee) return Cherokee;
		    hasRequiredCherokee = 1;
		    var set = regenerateExports();
		    set.addRange(0x13A0, 0x13F5).addRange(0x13F8, 0x13FD).addRange(0xAB70, 0xABBF);
		    Cherokee.characters = set;
		    return Cherokee;
		  }

		  var Chorasmian = {};

		  var hasRequiredChorasmian;
		  function requireChorasmian() {
		    if (hasRequiredChorasmian) return Chorasmian;
		    hasRequiredChorasmian = 1;
		    var set = regenerateExports();
		    set.addRange(0x10FB0, 0x10FCB);
		    Chorasmian.characters = set;
		    return Chorasmian;
		  }

		  var Common = {};

		  var hasRequiredCommon;
		  function requireCommon() {
		    if (hasRequiredCommon) return Common;
		    hasRequiredCommon = 1;
		    var set = regenerateExports(0xD7, 0xF7, 0x374, 0x37E, 0x385, 0x387, 0x605, 0x60C, 0x61B, 0x61F, 0x640, 0x6DD, 0x8E2, 0xE3F, 0x10FB, 0x1805, 0x1CD3, 0x1CE1, 0x1CFA, 0x3006, 0x30A0, 0x31EF, 0x32FF, 0xA92E, 0xA9CF, 0xAB5B, 0xFEFF, 0xFF70, 0x1D4A2, 0x1D4BB, 0x1D546, 0x1F7F0, 0xE0001);
		    set.addRange(0x0, 0x40).addRange(0x5B, 0x60).addRange(0x7B, 0xA9).addRange(0xAB, 0xB9).addRange(0xBB, 0xBF).addRange(0x2B9, 0x2DF).addRange(0x2E5, 0x2E9).addRange(0x2EC, 0x2FF).addRange(0x964, 0x965).addRange(0xFD5, 0xFD8).addRange(0x16EB, 0x16ED).addRange(0x1735, 0x1736).addRange(0x1802, 0x1803).addRange(0x1CE9, 0x1CEC).addRange(0x1CEE, 0x1CF3).addRange(0x1CF5, 0x1CF7).addRange(0x2000, 0x200B).addRange(0x200E, 0x2064).addRange(0x2066, 0x2070).addRange(0x2074, 0x207E).addRange(0x2080, 0x208E).addRange(0x20A0, 0x20C0).addRange(0x2100, 0x2125).addRange(0x2127, 0x2129).addRange(0x212C, 0x2131).addRange(0x2133, 0x214D).addRange(0x214F, 0x215F).addRange(0x2189, 0x218B).addRange(0x2190, 0x2426).addRange(0x2440, 0x244A).addRange(0x2460, 0x27FF).addRange(0x2900, 0x2B73).addRange(0x2B76, 0x2B95).addRange(0x2B97, 0x2BFF).addRange(0x2E00, 0x2E5D).addRange(0x2FF0, 0x3004).addRange(0x3008, 0x3020).addRange(0x3030, 0x3037).addRange(0x303C, 0x303F).addRange(0x309B, 0x309C).addRange(0x30FB, 0x30FC).addRange(0x3190, 0x319F).addRange(0x31C0, 0x31E3).addRange(0x3220, 0x325F).addRange(0x327F, 0x32CF).addRange(0x3358, 0x33FF).addRange(0x4DC0, 0x4DFF).addRange(0xA700, 0xA721).addRange(0xA788, 0xA78A).addRange(0xA830, 0xA839).addRange(0xAB6A, 0xAB6B);
		    set.addRange(0xFD3E, 0xFD3F).addRange(0xFE10, 0xFE19).addRange(0xFE30, 0xFE52).addRange(0xFE54, 0xFE66).addRange(0xFE68, 0xFE6B).addRange(0xFF01, 0xFF20).addRange(0xFF3B, 0xFF40).addRange(0xFF5B, 0xFF65).addRange(0xFF9E, 0xFF9F).addRange(0xFFE0, 0xFFE6).addRange(0xFFE8, 0xFFEE).addRange(0xFFF9, 0xFFFD).addRange(0x10100, 0x10102).addRange(0x10107, 0x10133).addRange(0x10137, 0x1013F).addRange(0x10190, 0x1019C).addRange(0x101D0, 0x101FC).addRange(0x102E1, 0x102FB).addRange(0x1BCA0, 0x1BCA3).addRange(0x1CF50, 0x1CFC3).addRange(0x1D000, 0x1D0F5).addRange(0x1D100, 0x1D126).addRange(0x1D129, 0x1D166).addRange(0x1D16A, 0x1D17A).addRange(0x1D183, 0x1D184).addRange(0x1D18C, 0x1D1A9).addRange(0x1D1AE, 0x1D1EA).addRange(0x1D2C0, 0x1D2D3).addRange(0x1D2E0, 0x1D2F3).addRange(0x1D300, 0x1D356).addRange(0x1D360, 0x1D378).addRange(0x1D400, 0x1D454).addRange(0x1D456, 0x1D49C).addRange(0x1D49E, 0x1D49F).addRange(0x1D4A5, 0x1D4A6).addRange(0x1D4A9, 0x1D4AC).addRange(0x1D4AE, 0x1D4B9).addRange(0x1D4BD, 0x1D4C3).addRange(0x1D4C5, 0x1D505).addRange(0x1D507, 0x1D50A).addRange(0x1D50D, 0x1D514).addRange(0x1D516, 0x1D51C).addRange(0x1D51E, 0x1D539).addRange(0x1D53B, 0x1D53E).addRange(0x1D540, 0x1D544).addRange(0x1D54A, 0x1D550).addRange(0x1D552, 0x1D6A5).addRange(0x1D6A8, 0x1D7CB).addRange(0x1D7CE, 0x1D7FF).addRange(0x1EC71, 0x1ECB4).addRange(0x1ED01, 0x1ED3D);
		    set.addRange(0x1F000, 0x1F02B).addRange(0x1F030, 0x1F093).addRange(0x1F0A0, 0x1F0AE).addRange(0x1F0B1, 0x1F0BF).addRange(0x1F0C1, 0x1F0CF).addRange(0x1F0D1, 0x1F0F5).addRange(0x1F100, 0x1F1AD).addRange(0x1F1E6, 0x1F1FF).addRange(0x1F201, 0x1F202).addRange(0x1F210, 0x1F23B).addRange(0x1F240, 0x1F248).addRange(0x1F250, 0x1F251).addRange(0x1F260, 0x1F265).addRange(0x1F300, 0x1F6D7).addRange(0x1F6DC, 0x1F6EC).addRange(0x1F6F0, 0x1F6FC).addRange(0x1F700, 0x1F776).addRange(0x1F77B, 0x1F7D9).addRange(0x1F7E0, 0x1F7EB).addRange(0x1F800, 0x1F80B).addRange(0x1F810, 0x1F847).addRange(0x1F850, 0x1F859).addRange(0x1F860, 0x1F887).addRange(0x1F890, 0x1F8AD).addRange(0x1F8B0, 0x1F8B1).addRange(0x1F900, 0x1FA53).addRange(0x1FA60, 0x1FA6D).addRange(0x1FA70, 0x1FA7C).addRange(0x1FA80, 0x1FA88).addRange(0x1FA90, 0x1FABD).addRange(0x1FABF, 0x1FAC5).addRange(0x1FACE, 0x1FADB).addRange(0x1FAE0, 0x1FAE8).addRange(0x1FAF0, 0x1FAF8).addRange(0x1FB00, 0x1FB92).addRange(0x1FB94, 0x1FBCA).addRange(0x1FBF0, 0x1FBF9).addRange(0xE0020, 0xE007F);
		    Common.characters = set;
		    return Common;
		  }

		  var Coptic = {};

		  var hasRequiredCoptic;
		  function requireCoptic() {
		    if (hasRequiredCoptic) return Coptic;
		    hasRequiredCoptic = 1;
		    var set = regenerateExports();
		    set.addRange(0x3E2, 0x3EF).addRange(0x2C80, 0x2CF3).addRange(0x2CF9, 0x2CFF);
		    Coptic.characters = set;
		    return Coptic;
		  }

		  var Cuneiform = {};

		  var hasRequiredCuneiform;
		  function requireCuneiform() {
		    if (hasRequiredCuneiform) return Cuneiform;
		    hasRequiredCuneiform = 1;
		    var set = regenerateExports();
		    set.addRange(0x12000, 0x12399).addRange(0x12400, 0x1246E).addRange(0x12470, 0x12474).addRange(0x12480, 0x12543);
		    Cuneiform.characters = set;
		    return Cuneiform;
		  }

		  var Cypriot = {};

		  var hasRequiredCypriot;
		  function requireCypriot() {
		    if (hasRequiredCypriot) return Cypriot;
		    hasRequiredCypriot = 1;
		    var set = regenerateExports(0x10808, 0x1083C, 0x1083F);
		    set.addRange(0x10800, 0x10805).addRange(0x1080A, 0x10835).addRange(0x10837, 0x10838);
		    Cypriot.characters = set;
		    return Cypriot;
		  }

		  var Cypro_Minoan = {};

		  var hasRequiredCypro_Minoan;
		  function requireCypro_Minoan() {
		    if (hasRequiredCypro_Minoan) return Cypro_Minoan;
		    hasRequiredCypro_Minoan = 1;
		    var set = regenerateExports();
		    set.addRange(0x12F90, 0x12FF2);
		    Cypro_Minoan.characters = set;
		    return Cypro_Minoan;
		  }

		  var Cyrillic = {};

		  var hasRequiredCyrillic;
		  function requireCyrillic() {
		    if (hasRequiredCyrillic) return Cyrillic;
		    hasRequiredCyrillic = 1;
		    var set = regenerateExports(0x1D2B, 0x1D78, 0x1E08F);
		    set.addRange(0x400, 0x484).addRange(0x487, 0x52F).addRange(0x1C80, 0x1C88).addRange(0x2DE0, 0x2DFF).addRange(0xA640, 0xA69F).addRange(0xFE2E, 0xFE2F).addRange(0x1E030, 0x1E06D);
		    Cyrillic.characters = set;
		    return Cyrillic;
		  }

		  var Deseret = {};

		  var hasRequiredDeseret;
		  function requireDeseret() {
		    if (hasRequiredDeseret) return Deseret;
		    hasRequiredDeseret = 1;
		    var set = regenerateExports();
		    set.addRange(0x10400, 0x1044F);
		    Deseret.characters = set;
		    return Deseret;
		  }

		  var Devanagari = {};

		  var hasRequiredDevanagari;
		  function requireDevanagari() {
		    if (hasRequiredDevanagari) return Devanagari;
		    hasRequiredDevanagari = 1;
		    var set = regenerateExports();
		    set.addRange(0x900, 0x950).addRange(0x955, 0x963).addRange(0x966, 0x97F).addRange(0xA8E0, 0xA8FF).addRange(0x11B00, 0x11B09);
		    Devanagari.characters = set;
		    return Devanagari;
		  }

		  var Dives_Akuru = {};

		  var hasRequiredDives_Akuru;
		  function requireDives_Akuru() {
		    if (hasRequiredDives_Akuru) return Dives_Akuru;
		    hasRequiredDives_Akuru = 1;
		    var set = regenerateExports(0x11909);
		    set.addRange(0x11900, 0x11906).addRange(0x1190C, 0x11913).addRange(0x11915, 0x11916).addRange(0x11918, 0x11935).addRange(0x11937, 0x11938).addRange(0x1193B, 0x11946).addRange(0x11950, 0x11959);
		    Dives_Akuru.characters = set;
		    return Dives_Akuru;
		  }

		  var Dogra = {};

		  var hasRequiredDogra;
		  function requireDogra() {
		    if (hasRequiredDogra) return Dogra;
		    hasRequiredDogra = 1;
		    var set = regenerateExports();
		    set.addRange(0x11800, 0x1183B);
		    Dogra.characters = set;
		    return Dogra;
		  }

		  var Duployan = {};

		  var hasRequiredDuployan;
		  function requireDuployan() {
		    if (hasRequiredDuployan) return Duployan;
		    hasRequiredDuployan = 1;
		    var set = regenerateExports();
		    set.addRange(0x1BC00, 0x1BC6A).addRange(0x1BC70, 0x1BC7C).addRange(0x1BC80, 0x1BC88).addRange(0x1BC90, 0x1BC99).addRange(0x1BC9C, 0x1BC9F);
		    Duployan.characters = set;
		    return Duployan;
		  }

		  var Egyptian_Hieroglyphs = {};

		  var hasRequiredEgyptian_Hieroglyphs;
		  function requireEgyptian_Hieroglyphs() {
		    if (hasRequiredEgyptian_Hieroglyphs) return Egyptian_Hieroglyphs;
		    hasRequiredEgyptian_Hieroglyphs = 1;
		    var set = regenerateExports();
		    set.addRange(0x13000, 0x13455);
		    Egyptian_Hieroglyphs.characters = set;
		    return Egyptian_Hieroglyphs;
		  }

		  var Elbasan = {};

		  var hasRequiredElbasan;
		  function requireElbasan() {
		    if (hasRequiredElbasan) return Elbasan;
		    hasRequiredElbasan = 1;
		    var set = regenerateExports();
		    set.addRange(0x10500, 0x10527);
		    Elbasan.characters = set;
		    return Elbasan;
		  }

		  var Elymaic = {};

		  var hasRequiredElymaic;
		  function requireElymaic() {
		    if (hasRequiredElymaic) return Elymaic;
		    hasRequiredElymaic = 1;
		    var set = regenerateExports();
		    set.addRange(0x10FE0, 0x10FF6);
		    Elymaic.characters = set;
		    return Elymaic;
		  }

		  var Ethiopic = {};

		  var hasRequiredEthiopic;
		  function requireEthiopic() {
		    if (hasRequiredEthiopic) return Ethiopic;
		    hasRequiredEthiopic = 1;
		    var set = regenerateExports(0x1258, 0x12C0);
		    set.addRange(0x1200, 0x1248).addRange(0x124A, 0x124D).addRange(0x1250, 0x1256).addRange(0x125A, 0x125D).addRange(0x1260, 0x1288).addRange(0x128A, 0x128D).addRange(0x1290, 0x12B0).addRange(0x12B2, 0x12B5).addRange(0x12B8, 0x12BE).addRange(0x12C2, 0x12C5).addRange(0x12C8, 0x12D6).addRange(0x12D8, 0x1310).addRange(0x1312, 0x1315).addRange(0x1318, 0x135A).addRange(0x135D, 0x137C).addRange(0x1380, 0x1399).addRange(0x2D80, 0x2D96).addRange(0x2DA0, 0x2DA6).addRange(0x2DA8, 0x2DAE).addRange(0x2DB0, 0x2DB6).addRange(0x2DB8, 0x2DBE).addRange(0x2DC0, 0x2DC6).addRange(0x2DC8, 0x2DCE).addRange(0x2DD0, 0x2DD6).addRange(0x2DD8, 0x2DDE).addRange(0xAB01, 0xAB06).addRange(0xAB09, 0xAB0E).addRange(0xAB11, 0xAB16).addRange(0xAB20, 0xAB26).addRange(0xAB28, 0xAB2E).addRange(0x1E7E0, 0x1E7E6).addRange(0x1E7E8, 0x1E7EB).addRange(0x1E7ED, 0x1E7EE).addRange(0x1E7F0, 0x1E7FE);
		    Ethiopic.characters = set;
		    return Ethiopic;
		  }

		  var Georgian = {};

		  var hasRequiredGeorgian;
		  function requireGeorgian() {
		    if (hasRequiredGeorgian) return Georgian;
		    hasRequiredGeorgian = 1;
		    var set = regenerateExports(0x10C7, 0x10CD, 0x2D27, 0x2D2D);
		    set.addRange(0x10A0, 0x10C5).addRange(0x10D0, 0x10FA).addRange(0x10FC, 0x10FF).addRange(0x1C90, 0x1CBA).addRange(0x1CBD, 0x1CBF).addRange(0x2D00, 0x2D25);
		    Georgian.characters = set;
		    return Georgian;
		  }

		  var Glagolitic = {};

		  var hasRequiredGlagolitic;
		  function requireGlagolitic() {
		    if (hasRequiredGlagolitic) return Glagolitic;
		    hasRequiredGlagolitic = 1;
		    var set = regenerateExports();
		    set.addRange(0x2C00, 0x2C5F).addRange(0x1E000, 0x1E006).addRange(0x1E008, 0x1E018).addRange(0x1E01B, 0x1E021).addRange(0x1E023, 0x1E024).addRange(0x1E026, 0x1E02A);
		    Glagolitic.characters = set;
		    return Glagolitic;
		  }

		  var Gothic = {};

		  var hasRequiredGothic;
		  function requireGothic() {
		    if (hasRequiredGothic) return Gothic;
		    hasRequiredGothic = 1;
		    var set = regenerateExports();
		    set.addRange(0x10330, 0x1034A);
		    Gothic.characters = set;
		    return Gothic;
		  }

		  var Grantha = {};

		  var hasRequiredGrantha;
		  function requireGrantha() {
		    if (hasRequiredGrantha) return Grantha;
		    hasRequiredGrantha = 1;
		    var set = regenerateExports(0x11350, 0x11357);
		    set.addRange(0x11300, 0x11303).addRange(0x11305, 0x1130C).addRange(0x1130F, 0x11310).addRange(0x11313, 0x11328).addRange(0x1132A, 0x11330).addRange(0x11332, 0x11333).addRange(0x11335, 0x11339).addRange(0x1133C, 0x11344).addRange(0x11347, 0x11348).addRange(0x1134B, 0x1134D).addRange(0x1135D, 0x11363).addRange(0x11366, 0x1136C).addRange(0x11370, 0x11374);
		    Grantha.characters = set;
		    return Grantha;
		  }

		  var Greek = {};

		  var hasRequiredGreek;
		  function requireGreek() {
		    if (hasRequiredGreek) return Greek;
		    hasRequiredGreek = 1;
		    var set = regenerateExports(0x37F, 0x384, 0x386, 0x38C, 0x1DBF, 0x1F59, 0x1F5B, 0x1F5D, 0x2126, 0xAB65, 0x101A0);
		    set.addRange(0x370, 0x373).addRange(0x375, 0x377).addRange(0x37A, 0x37D).addRange(0x388, 0x38A).addRange(0x38E, 0x3A1).addRange(0x3A3, 0x3E1).addRange(0x3F0, 0x3FF).addRange(0x1D26, 0x1D2A).addRange(0x1D5D, 0x1D61).addRange(0x1D66, 0x1D6A).addRange(0x1F00, 0x1F15).addRange(0x1F18, 0x1F1D).addRange(0x1F20, 0x1F45).addRange(0x1F48, 0x1F4D).addRange(0x1F50, 0x1F57).addRange(0x1F5F, 0x1F7D).addRange(0x1F80, 0x1FB4).addRange(0x1FB6, 0x1FC4).addRange(0x1FC6, 0x1FD3).addRange(0x1FD6, 0x1FDB).addRange(0x1FDD, 0x1FEF).addRange(0x1FF2, 0x1FF4).addRange(0x1FF6, 0x1FFE).addRange(0x10140, 0x1018E).addRange(0x1D200, 0x1D245);
		    Greek.characters = set;
		    return Greek;
		  }

		  var Gujarati = {};

		  var hasRequiredGujarati;
		  function requireGujarati() {
		    if (hasRequiredGujarati) return Gujarati;
		    hasRequiredGujarati = 1;
		    var set = regenerateExports(0xAD0);
		    set.addRange(0xA81, 0xA83).addRange(0xA85, 0xA8D).addRange(0xA8F, 0xA91).addRange(0xA93, 0xAA8).addRange(0xAAA, 0xAB0).addRange(0xAB2, 0xAB3).addRange(0xAB5, 0xAB9).addRange(0xABC, 0xAC5).addRange(0xAC7, 0xAC9).addRange(0xACB, 0xACD).addRange(0xAE0, 0xAE3).addRange(0xAE6, 0xAF1).addRange(0xAF9, 0xAFF);
		    Gujarati.characters = set;
		    return Gujarati;
		  }

		  var Gunjala_Gondi = {};

		  var hasRequiredGunjala_Gondi;
		  function requireGunjala_Gondi() {
		    if (hasRequiredGunjala_Gondi) return Gunjala_Gondi;
		    hasRequiredGunjala_Gondi = 1;
		    var set = regenerateExports();
		    set.addRange(0x11D60, 0x11D65).addRange(0x11D67, 0x11D68).addRange(0x11D6A, 0x11D8E).addRange(0x11D90, 0x11D91).addRange(0x11D93, 0x11D98).addRange(0x11DA0, 0x11DA9);
		    Gunjala_Gondi.characters = set;
		    return Gunjala_Gondi;
		  }

		  var Gurmukhi = {};

		  var hasRequiredGurmukhi;
		  function requireGurmukhi() {
		    if (hasRequiredGurmukhi) return Gurmukhi;
		    hasRequiredGurmukhi = 1;
		    var set = regenerateExports(0xA3C, 0xA51, 0xA5E);
		    set.addRange(0xA01, 0xA03).addRange(0xA05, 0xA0A).addRange(0xA0F, 0xA10).addRange(0xA13, 0xA28).addRange(0xA2A, 0xA30).addRange(0xA32, 0xA33).addRange(0xA35, 0xA36).addRange(0xA38, 0xA39).addRange(0xA3E, 0xA42).addRange(0xA47, 0xA48).addRange(0xA4B, 0xA4D).addRange(0xA59, 0xA5C).addRange(0xA66, 0xA76);
		    Gurmukhi.characters = set;
		    return Gurmukhi;
		  }

		  var Han = {};

		  var hasRequiredHan;
		  function requireHan() {
		    if (hasRequiredHan) return Han;
		    hasRequiredHan = 1;
		    var set = regenerateExports(0x3005, 0x3007);
		    set.addRange(0x2E80, 0x2E99).addRange(0x2E9B, 0x2EF3).addRange(0x2F00, 0x2FD5).addRange(0x3021, 0x3029).addRange(0x3038, 0x303B).addRange(0x3400, 0x4DBF).addRange(0x4E00, 0x9FFF).addRange(0xF900, 0xFA6D).addRange(0xFA70, 0xFAD9).addRange(0x16FE2, 0x16FE3).addRange(0x16FF0, 0x16FF1).addRange(0x20000, 0x2A6DF).addRange(0x2A700, 0x2B739).addRange(0x2B740, 0x2B81D).addRange(0x2B820, 0x2CEA1).addRange(0x2CEB0, 0x2EBE0).addRange(0x2EBF0, 0x2EE5D).addRange(0x2F800, 0x2FA1D).addRange(0x30000, 0x3134A).addRange(0x31350, 0x323AF);
		    Han.characters = set;
		    return Han;
		  }

		  var Hangul = {};

		  var hasRequiredHangul;
		  function requireHangul() {
		    if (hasRequiredHangul) return Hangul;
		    hasRequiredHangul = 1;
		    var set = regenerateExports();
		    set.addRange(0x1100, 0x11FF).addRange(0x302E, 0x302F).addRange(0x3131, 0x318E).addRange(0x3200, 0x321E).addRange(0x3260, 0x327E).addRange(0xA960, 0xA97C).addRange(0xAC00, 0xD7A3).addRange(0xD7B0, 0xD7C6).addRange(0xD7CB, 0xD7FB).addRange(0xFFA0, 0xFFBE).addRange(0xFFC2, 0xFFC7).addRange(0xFFCA, 0xFFCF).addRange(0xFFD2, 0xFFD7).addRange(0xFFDA, 0xFFDC);
		    Hangul.characters = set;
		    return Hangul;
		  }

		  var Hanifi_Rohingya = {};

		  var hasRequiredHanifi_Rohingya;
		  function requireHanifi_Rohingya() {
		    if (hasRequiredHanifi_Rohingya) return Hanifi_Rohingya;
		    hasRequiredHanifi_Rohingya = 1;
		    var set = regenerateExports();
		    set.addRange(0x10D00, 0x10D27).addRange(0x10D30, 0x10D39);
		    Hanifi_Rohingya.characters = set;
		    return Hanifi_Rohingya;
		  }

		  var Hanunoo = {};

		  var hasRequiredHanunoo;
		  function requireHanunoo() {
		    if (hasRequiredHanunoo) return Hanunoo;
		    hasRequiredHanunoo = 1;
		    var set = regenerateExports();
		    set.addRange(0x1720, 0x1734);
		    Hanunoo.characters = set;
		    return Hanunoo;
		  }

		  var Hatran = {};

		  var hasRequiredHatran;
		  function requireHatran() {
		    if (hasRequiredHatran) return Hatran;
		    hasRequiredHatran = 1;
		    var set = regenerateExports();
		    set.addRange(0x108E0, 0x108F2).addRange(0x108F4, 0x108F5).addRange(0x108FB, 0x108FF);
		    Hatran.characters = set;
		    return Hatran;
		  }

		  var Hebrew = {};

		  var hasRequiredHebrew;
		  function requireHebrew() {
		    if (hasRequiredHebrew) return Hebrew;
		    hasRequiredHebrew = 1;
		    var set = regenerateExports(0xFB3E);
		    set.addRange(0x591, 0x5C7).addRange(0x5D0, 0x5EA).addRange(0x5EF, 0x5F4).addRange(0xFB1D, 0xFB36).addRange(0xFB38, 0xFB3C).addRange(0xFB40, 0xFB41).addRange(0xFB43, 0xFB44).addRange(0xFB46, 0xFB4F);
		    Hebrew.characters = set;
		    return Hebrew;
		  }

		  var Hiragana = {};

		  var hasRequiredHiragana;
		  function requireHiragana() {
		    if (hasRequiredHiragana) return Hiragana;
		    hasRequiredHiragana = 1;
		    var set = regenerateExports(0x1B132, 0x1F200);
		    set.addRange(0x3041, 0x3096).addRange(0x309D, 0x309F).addRange(0x1B001, 0x1B11F).addRange(0x1B150, 0x1B152);
		    Hiragana.characters = set;
		    return Hiragana;
		  }

		  var Imperial_Aramaic = {};

		  var hasRequiredImperial_Aramaic;
		  function requireImperial_Aramaic() {
		    if (hasRequiredImperial_Aramaic) return Imperial_Aramaic;
		    hasRequiredImperial_Aramaic = 1;
		    var set = regenerateExports();
		    set.addRange(0x10840, 0x10855).addRange(0x10857, 0x1085F);
		    Imperial_Aramaic.characters = set;
		    return Imperial_Aramaic;
		  }

		  var Inherited = {};

		  var hasRequiredInherited;
		  function requireInherited() {
		    if (hasRequiredInherited) return Inherited;
		    hasRequiredInherited = 1;
		    var set = regenerateExports(0x670, 0x1CED, 0x1CF4, 0x101FD, 0x102E0, 0x1133B);
		    set.addRange(0x300, 0x36F).addRange(0x485, 0x486).addRange(0x64B, 0x655).addRange(0x951, 0x954).addRange(0x1AB0, 0x1ACE).addRange(0x1CD0, 0x1CD2).addRange(0x1CD4, 0x1CE0).addRange(0x1CE2, 0x1CE8).addRange(0x1CF8, 0x1CF9).addRange(0x1DC0, 0x1DFF).addRange(0x200C, 0x200D).addRange(0x20D0, 0x20F0).addRange(0x302A, 0x302D).addRange(0x3099, 0x309A).addRange(0xFE00, 0xFE0F).addRange(0xFE20, 0xFE2D).addRange(0x1CF00, 0x1CF2D).addRange(0x1CF30, 0x1CF46).addRange(0x1D167, 0x1D169).addRange(0x1D17B, 0x1D182).addRange(0x1D185, 0x1D18B).addRange(0x1D1AA, 0x1D1AD).addRange(0xE0100, 0xE01EF);
		    Inherited.characters = set;
		    return Inherited;
		  }

		  var Inscriptional_Pahlavi = {};

		  var hasRequiredInscriptional_Pahlavi;
		  function requireInscriptional_Pahlavi() {
		    if (hasRequiredInscriptional_Pahlavi) return Inscriptional_Pahlavi;
		    hasRequiredInscriptional_Pahlavi = 1;
		    var set = regenerateExports();
		    set.addRange(0x10B60, 0x10B72).addRange(0x10B78, 0x10B7F);
		    Inscriptional_Pahlavi.characters = set;
		    return Inscriptional_Pahlavi;
		  }

		  var Inscriptional_Parthian = {};

		  var hasRequiredInscriptional_Parthian;
		  function requireInscriptional_Parthian() {
		    if (hasRequiredInscriptional_Parthian) return Inscriptional_Parthian;
		    hasRequiredInscriptional_Parthian = 1;
		    var set = regenerateExports();
		    set.addRange(0x10B40, 0x10B55).addRange(0x10B58, 0x10B5F);
		    Inscriptional_Parthian.characters = set;
		    return Inscriptional_Parthian;
		  }

		  var Javanese = {};

		  var hasRequiredJavanese;
		  function requireJavanese() {
		    if (hasRequiredJavanese) return Javanese;
		    hasRequiredJavanese = 1;
		    var set = regenerateExports();
		    set.addRange(0xA980, 0xA9CD).addRange(0xA9D0, 0xA9D9).addRange(0xA9DE, 0xA9DF);
		    Javanese.characters = set;
		    return Javanese;
		  }

		  var Kaithi = {};

		  var hasRequiredKaithi;
		  function requireKaithi() {
		    if (hasRequiredKaithi) return Kaithi;
		    hasRequiredKaithi = 1;
		    var set = regenerateExports(0x110CD);
		    set.addRange(0x11080, 0x110C2);
		    Kaithi.characters = set;
		    return Kaithi;
		  }

		  var Kannada = {};

		  var hasRequiredKannada;
		  function requireKannada() {
		    if (hasRequiredKannada) return Kannada;
		    hasRequiredKannada = 1;
		    var set = regenerateExports();
		    set.addRange(0xC80, 0xC8C).addRange(0xC8E, 0xC90).addRange(0xC92, 0xCA8).addRange(0xCAA, 0xCB3).addRange(0xCB5, 0xCB9).addRange(0xCBC, 0xCC4).addRange(0xCC6, 0xCC8).addRange(0xCCA, 0xCCD).addRange(0xCD5, 0xCD6).addRange(0xCDD, 0xCDE).addRange(0xCE0, 0xCE3).addRange(0xCE6, 0xCEF).addRange(0xCF1, 0xCF3);
		    Kannada.characters = set;
		    return Kannada;
		  }

		  var Katakana = {};

		  var hasRequiredKatakana;
		  function requireKatakana() {
		    if (hasRequiredKatakana) return Katakana;
		    hasRequiredKatakana = 1;
		    var set = regenerateExports(0x1B000, 0x1B155);
		    set.addRange(0x30A1, 0x30FA).addRange(0x30FD, 0x30FF).addRange(0x31F0, 0x31FF).addRange(0x32D0, 0x32FE).addRange(0x3300, 0x3357).addRange(0xFF66, 0xFF6F).addRange(0xFF71, 0xFF9D).addRange(0x1AFF0, 0x1AFF3).addRange(0x1AFF5, 0x1AFFB).addRange(0x1AFFD, 0x1AFFE).addRange(0x1B120, 0x1B122).addRange(0x1B164, 0x1B167);
		    Katakana.characters = set;
		    return Katakana;
		  }

		  var Kawi = {};

		  var hasRequiredKawi;
		  function requireKawi() {
		    if (hasRequiredKawi) return Kawi;
		    hasRequiredKawi = 1;
		    var set = regenerateExports();
		    set.addRange(0x11F00, 0x11F10).addRange(0x11F12, 0x11F3A).addRange(0x11F3E, 0x11F59);
		    Kawi.characters = set;
		    return Kawi;
		  }

		  var Kayah_Li = {};

		  var hasRequiredKayah_Li;
		  function requireKayah_Li() {
		    if (hasRequiredKayah_Li) return Kayah_Li;
		    hasRequiredKayah_Li = 1;
		    var set = regenerateExports(0xA92F);
		    set.addRange(0xA900, 0xA92D);
		    Kayah_Li.characters = set;
		    return Kayah_Li;
		  }

		  var Kharoshthi = {};

		  var hasRequiredKharoshthi;
		  function requireKharoshthi() {
		    if (hasRequiredKharoshthi) return Kharoshthi;
		    hasRequiredKharoshthi = 1;
		    var set = regenerateExports();
		    set.addRange(0x10A00, 0x10A03).addRange(0x10A05, 0x10A06).addRange(0x10A0C, 0x10A13).addRange(0x10A15, 0x10A17).addRange(0x10A19, 0x10A35).addRange(0x10A38, 0x10A3A).addRange(0x10A3F, 0x10A48).addRange(0x10A50, 0x10A58);
		    Kharoshthi.characters = set;
		    return Kharoshthi;
		  }

		  var Khitan_Small_Script = {};

		  var hasRequiredKhitan_Small_Script;
		  function requireKhitan_Small_Script() {
		    if (hasRequiredKhitan_Small_Script) return Khitan_Small_Script;
		    hasRequiredKhitan_Small_Script = 1;
		    var set = regenerateExports(0x16FE4);
		    set.addRange(0x18B00, 0x18CD5);
		    Khitan_Small_Script.characters = set;
		    return Khitan_Small_Script;
		  }

		  var Khmer = {};

		  var hasRequiredKhmer;
		  function requireKhmer() {
		    if (hasRequiredKhmer) return Khmer;
		    hasRequiredKhmer = 1;
		    var set = regenerateExports();
		    set.addRange(0x1780, 0x17DD).addRange(0x17E0, 0x17E9).addRange(0x17F0, 0x17F9).addRange(0x19E0, 0x19FF);
		    Khmer.characters = set;
		    return Khmer;
		  }

		  var Khojki = {};

		  var hasRequiredKhojki;
		  function requireKhojki() {
		    if (hasRequiredKhojki) return Khojki;
		    hasRequiredKhojki = 1;
		    var set = regenerateExports();
		    set.addRange(0x11200, 0x11211).addRange(0x11213, 0x11241);
		    Khojki.characters = set;
		    return Khojki;
		  }

		  var Khudawadi = {};

		  var hasRequiredKhudawadi;
		  function requireKhudawadi() {
		    if (hasRequiredKhudawadi) return Khudawadi;
		    hasRequiredKhudawadi = 1;
		    var set = regenerateExports();
		    set.addRange(0x112B0, 0x112EA).addRange(0x112F0, 0x112F9);
		    Khudawadi.characters = set;
		    return Khudawadi;
		  }

		  var Lao = {};

		  var hasRequiredLao;
		  function requireLao() {
		    if (hasRequiredLao) return Lao;
		    hasRequiredLao = 1;
		    var set = regenerateExports(0xE84, 0xEA5, 0xEC6);
		    set.addRange(0xE81, 0xE82).addRange(0xE86, 0xE8A).addRange(0xE8C, 0xEA3).addRange(0xEA7, 0xEBD).addRange(0xEC0, 0xEC4).addRange(0xEC8, 0xECE).addRange(0xED0, 0xED9).addRange(0xEDC, 0xEDF);
		    Lao.characters = set;
		    return Lao;
		  }

		  var Latin = {};

		  var hasRequiredLatin;
		  function requireLatin() {
		    if (hasRequiredLatin) return Latin;
		    hasRequiredLatin = 1;
		    var set = regenerateExports(0xAA, 0xBA, 0x2071, 0x207F, 0x2132, 0x214E, 0xA7D3);
		    set.addRange(0x41, 0x5A).addRange(0x61, 0x7A).addRange(0xC0, 0xD6).addRange(0xD8, 0xF6).addRange(0xF8, 0x2B8).addRange(0x2E0, 0x2E4).addRange(0x1D00, 0x1D25).addRange(0x1D2C, 0x1D5C).addRange(0x1D62, 0x1D65).addRange(0x1D6B, 0x1D77).addRange(0x1D79, 0x1DBE).addRange(0x1E00, 0x1EFF).addRange(0x2090, 0x209C).addRange(0x212A, 0x212B).addRange(0x2160, 0x2188).addRange(0x2C60, 0x2C7F).addRange(0xA722, 0xA787).addRange(0xA78B, 0xA7CA).addRange(0xA7D0, 0xA7D1).addRange(0xA7D5, 0xA7D9).addRange(0xA7F2, 0xA7FF).addRange(0xAB30, 0xAB5A).addRange(0xAB5C, 0xAB64).addRange(0xAB66, 0xAB69).addRange(0xFB00, 0xFB06).addRange(0xFF21, 0xFF3A).addRange(0xFF41, 0xFF5A).addRange(0x10780, 0x10785).addRange(0x10787, 0x107B0).addRange(0x107B2, 0x107BA).addRange(0x1DF00, 0x1DF1E).addRange(0x1DF25, 0x1DF2A);
		    Latin.characters = set;
		    return Latin;
		  }

		  var Lepcha = {};

		  var hasRequiredLepcha;
		  function requireLepcha() {
		    if (hasRequiredLepcha) return Lepcha;
		    hasRequiredLepcha = 1;
		    var set = regenerateExports();
		    set.addRange(0x1C00, 0x1C37).addRange(0x1C3B, 0x1C49).addRange(0x1C4D, 0x1C4F);
		    Lepcha.characters = set;
		    return Lepcha;
		  }

		  var Limbu = {};

		  var hasRequiredLimbu;
		  function requireLimbu() {
		    if (hasRequiredLimbu) return Limbu;
		    hasRequiredLimbu = 1;
		    var set = regenerateExports(0x1940);
		    set.addRange(0x1900, 0x191E).addRange(0x1920, 0x192B).addRange(0x1930, 0x193B).addRange(0x1944, 0x194F);
		    Limbu.characters = set;
		    return Limbu;
		  }

		  var Linear_A = {};

		  var hasRequiredLinear_A;
		  function requireLinear_A() {
		    if (hasRequiredLinear_A) return Linear_A;
		    hasRequiredLinear_A = 1;
		    var set = regenerateExports();
		    set.addRange(0x10600, 0x10736).addRange(0x10740, 0x10755).addRange(0x10760, 0x10767);
		    Linear_A.characters = set;
		    return Linear_A;
		  }

		  var Linear_B = {};

		  var hasRequiredLinear_B;
		  function requireLinear_B() {
		    if (hasRequiredLinear_B) return Linear_B;
		    hasRequiredLinear_B = 1;
		    var set = regenerateExports();
		    set.addRange(0x10000, 0x1000B).addRange(0x1000D, 0x10026).addRange(0x10028, 0x1003A).addRange(0x1003C, 0x1003D).addRange(0x1003F, 0x1004D).addRange(0x10050, 0x1005D).addRange(0x10080, 0x100FA);
		    Linear_B.characters = set;
		    return Linear_B;
		  }

		  var Lisu = {};

		  var hasRequiredLisu;
		  function requireLisu() {
		    if (hasRequiredLisu) return Lisu;
		    hasRequiredLisu = 1;
		    var set = regenerateExports(0x11FB0);
		    set.addRange(0xA4D0, 0xA4FF);
		    Lisu.characters = set;
		    return Lisu;
		  }

		  var Lycian = {};

		  var hasRequiredLycian;
		  function requireLycian() {
		    if (hasRequiredLycian) return Lycian;
		    hasRequiredLycian = 1;
		    var set = regenerateExports();
		    set.addRange(0x10280, 0x1029C);
		    Lycian.characters = set;
		    return Lycian;
		  }

		  var Lydian = {};

		  var hasRequiredLydian;
		  function requireLydian() {
		    if (hasRequiredLydian) return Lydian;
		    hasRequiredLydian = 1;
		    var set = regenerateExports(0x1093F);
		    set.addRange(0x10920, 0x10939);
		    Lydian.characters = set;
		    return Lydian;
		  }

		  var Mahajani = {};

		  var hasRequiredMahajani;
		  function requireMahajani() {
		    if (hasRequiredMahajani) return Mahajani;
		    hasRequiredMahajani = 1;
		    var set = regenerateExports();
		    set.addRange(0x11150, 0x11176);
		    Mahajani.characters = set;
		    return Mahajani;
		  }

		  var Makasar = {};

		  var hasRequiredMakasar;
		  function requireMakasar() {
		    if (hasRequiredMakasar) return Makasar;
		    hasRequiredMakasar = 1;
		    var set = regenerateExports();
		    set.addRange(0x11EE0, 0x11EF8);
		    Makasar.characters = set;
		    return Makasar;
		  }

		  var Malayalam = {};

		  var hasRequiredMalayalam;
		  function requireMalayalam() {
		    if (hasRequiredMalayalam) return Malayalam;
		    hasRequiredMalayalam = 1;
		    var set = regenerateExports();
		    set.addRange(0xD00, 0xD0C).addRange(0xD0E, 0xD10).addRange(0xD12, 0xD44).addRange(0xD46, 0xD48).addRange(0xD4A, 0xD4F).addRange(0xD54, 0xD63).addRange(0xD66, 0xD7F);
		    Malayalam.characters = set;
		    return Malayalam;
		  }

		  var Mandaic = {};

		  var hasRequiredMandaic;
		  function requireMandaic() {
		    if (hasRequiredMandaic) return Mandaic;
		    hasRequiredMandaic = 1;
		    var set = regenerateExports(0x85E);
		    set.addRange(0x840, 0x85B);
		    Mandaic.characters = set;
		    return Mandaic;
		  }

		  var Manichaean = {};

		  var hasRequiredManichaean;
		  function requireManichaean() {
		    if (hasRequiredManichaean) return Manichaean;
		    hasRequiredManichaean = 1;
		    var set = regenerateExports();
		    set.addRange(0x10AC0, 0x10AE6).addRange(0x10AEB, 0x10AF6);
		    Manichaean.characters = set;
		    return Manichaean;
		  }

		  var Marchen = {};

		  var hasRequiredMarchen;
		  function requireMarchen() {
		    if (hasRequiredMarchen) return Marchen;
		    hasRequiredMarchen = 1;
		    var set = regenerateExports();
		    set.addRange(0x11C70, 0x11C8F).addRange(0x11C92, 0x11CA7).addRange(0x11CA9, 0x11CB6);
		    Marchen.characters = set;
		    return Marchen;
		  }

		  var Masaram_Gondi = {};

		  var hasRequiredMasaram_Gondi;
		  function requireMasaram_Gondi() {
		    if (hasRequiredMasaram_Gondi) return Masaram_Gondi;
		    hasRequiredMasaram_Gondi = 1;
		    var set = regenerateExports(0x11D3A);
		    set.addRange(0x11D00, 0x11D06).addRange(0x11D08, 0x11D09).addRange(0x11D0B, 0x11D36).addRange(0x11D3C, 0x11D3D).addRange(0x11D3F, 0x11D47).addRange(0x11D50, 0x11D59);
		    Masaram_Gondi.characters = set;
		    return Masaram_Gondi;
		  }

		  var Medefaidrin = {};

		  var hasRequiredMedefaidrin;
		  function requireMedefaidrin() {
		    if (hasRequiredMedefaidrin) return Medefaidrin;
		    hasRequiredMedefaidrin = 1;
		    var set = regenerateExports();
		    set.addRange(0x16E40, 0x16E9A);
		    Medefaidrin.characters = set;
		    return Medefaidrin;
		  }

		  var Meetei_Mayek = {};

		  var hasRequiredMeetei_Mayek;
		  function requireMeetei_Mayek() {
		    if (hasRequiredMeetei_Mayek) return Meetei_Mayek;
		    hasRequiredMeetei_Mayek = 1;
		    var set = regenerateExports();
		    set.addRange(0xAAE0, 0xAAF6).addRange(0xABC0, 0xABED).addRange(0xABF0, 0xABF9);
		    Meetei_Mayek.characters = set;
		    return Meetei_Mayek;
		  }

		  var Mende_Kikakui = {};

		  var hasRequiredMende_Kikakui;
		  function requireMende_Kikakui() {
		    if (hasRequiredMende_Kikakui) return Mende_Kikakui;
		    hasRequiredMende_Kikakui = 1;
		    var set = regenerateExports();
		    set.addRange(0x1E800, 0x1E8C4).addRange(0x1E8C7, 0x1E8D6);
		    Mende_Kikakui.characters = set;
		    return Mende_Kikakui;
		  }

		  var Meroitic_Cursive = {};

		  var hasRequiredMeroitic_Cursive;
		  function requireMeroitic_Cursive() {
		    if (hasRequiredMeroitic_Cursive) return Meroitic_Cursive;
		    hasRequiredMeroitic_Cursive = 1;
		    var set = regenerateExports();
		    set.addRange(0x109A0, 0x109B7).addRange(0x109BC, 0x109CF).addRange(0x109D2, 0x109FF);
		    Meroitic_Cursive.characters = set;
		    return Meroitic_Cursive;
		  }

		  var Meroitic_Hieroglyphs = {};

		  var hasRequiredMeroitic_Hieroglyphs;
		  function requireMeroitic_Hieroglyphs() {
		    if (hasRequiredMeroitic_Hieroglyphs) return Meroitic_Hieroglyphs;
		    hasRequiredMeroitic_Hieroglyphs = 1;
		    var set = regenerateExports();
		    set.addRange(0x10980, 0x1099F);
		    Meroitic_Hieroglyphs.characters = set;
		    return Meroitic_Hieroglyphs;
		  }

		  var Miao = {};

		  var hasRequiredMiao;
		  function requireMiao() {
		    if (hasRequiredMiao) return Miao;
		    hasRequiredMiao = 1;
		    var set = regenerateExports();
		    set.addRange(0x16F00, 0x16F4A).addRange(0x16F4F, 0x16F87).addRange(0x16F8F, 0x16F9F);
		    Miao.characters = set;
		    return Miao;
		  }

		  var Modi = {};

		  var hasRequiredModi;
		  function requireModi() {
		    if (hasRequiredModi) return Modi;
		    hasRequiredModi = 1;
		    var set = regenerateExports();
		    set.addRange(0x11600, 0x11644).addRange(0x11650, 0x11659);
		    Modi.characters = set;
		    return Modi;
		  }

		  var Mongolian = {};

		  var hasRequiredMongolian;
		  function requireMongolian() {
		    if (hasRequiredMongolian) return Mongolian;
		    hasRequiredMongolian = 1;
		    var set = regenerateExports(0x1804);
		    set.addRange(0x1800, 0x1801).addRange(0x1806, 0x1819).addRange(0x1820, 0x1878).addRange(0x1880, 0x18AA).addRange(0x11660, 0x1166C);
		    Mongolian.characters = set;
		    return Mongolian;
		  }

		  var Mro = {};

		  var hasRequiredMro;
		  function requireMro() {
		    if (hasRequiredMro) return Mro;
		    hasRequiredMro = 1;
		    var set = regenerateExports();
		    set.addRange(0x16A40, 0x16A5E).addRange(0x16A60, 0x16A69).addRange(0x16A6E, 0x16A6F);
		    Mro.characters = set;
		    return Mro;
		  }

		  var Multani = {};

		  var hasRequiredMultani;
		  function requireMultani() {
		    if (hasRequiredMultani) return Multani;
		    hasRequiredMultani = 1;
		    var set = regenerateExports(0x11288);
		    set.addRange(0x11280, 0x11286).addRange(0x1128A, 0x1128D).addRange(0x1128F, 0x1129D).addRange(0x1129F, 0x112A9);
		    Multani.characters = set;
		    return Multani;
		  }

		  var Myanmar = {};

		  var hasRequiredMyanmar;
		  function requireMyanmar() {
		    if (hasRequiredMyanmar) return Myanmar;
		    hasRequiredMyanmar = 1;
		    var set = regenerateExports();
		    set.addRange(0x1000, 0x109F).addRange(0xA9E0, 0xA9FE).addRange(0xAA60, 0xAA7F);
		    Myanmar.characters = set;
		    return Myanmar;
		  }

		  var Nabataean = {};

		  var hasRequiredNabataean;
		  function requireNabataean() {
		    if (hasRequiredNabataean) return Nabataean;
		    hasRequiredNabataean = 1;
		    var set = regenerateExports();
		    set.addRange(0x10880, 0x1089E).addRange(0x108A7, 0x108AF);
		    Nabataean.characters = set;
		    return Nabataean;
		  }

		  var Nag_Mundari = {};

		  var hasRequiredNag_Mundari;
		  function requireNag_Mundari() {
		    if (hasRequiredNag_Mundari) return Nag_Mundari;
		    hasRequiredNag_Mundari = 1;
		    var set = regenerateExports();
		    set.addRange(0x1E4D0, 0x1E4F9);
		    Nag_Mundari.characters = set;
		    return Nag_Mundari;
		  }

		  var Nandinagari = {};

		  var hasRequiredNandinagari;
		  function requireNandinagari() {
		    if (hasRequiredNandinagari) return Nandinagari;
		    hasRequiredNandinagari = 1;
		    var set = regenerateExports();
		    set.addRange(0x119A0, 0x119A7).addRange(0x119AA, 0x119D7).addRange(0x119DA, 0x119E4);
		    Nandinagari.characters = set;
		    return Nandinagari;
		  }

		  var New_Tai_Lue = {};

		  var hasRequiredNew_Tai_Lue;
		  function requireNew_Tai_Lue() {
		    if (hasRequiredNew_Tai_Lue) return New_Tai_Lue;
		    hasRequiredNew_Tai_Lue = 1;
		    var set = regenerateExports();
		    set.addRange(0x1980, 0x19AB).addRange(0x19B0, 0x19C9).addRange(0x19D0, 0x19DA).addRange(0x19DE, 0x19DF);
		    New_Tai_Lue.characters = set;
		    return New_Tai_Lue;
		  }

		  var Newa = {};

		  var hasRequiredNewa;
		  function requireNewa() {
		    if (hasRequiredNewa) return Newa;
		    hasRequiredNewa = 1;
		    var set = regenerateExports();
		    set.addRange(0x11400, 0x1145B).addRange(0x1145D, 0x11461);
		    Newa.characters = set;
		    return Newa;
		  }

		  var Nko = {};

		  var hasRequiredNko;
		  function requireNko() {
		    if (hasRequiredNko) return Nko;
		    hasRequiredNko = 1;
		    var set = regenerateExports();
		    set.addRange(0x7C0, 0x7FA).addRange(0x7FD, 0x7FF);
		    Nko.characters = set;
		    return Nko;
		  }

		  var Nushu = {};

		  var hasRequiredNushu;
		  function requireNushu() {
		    if (hasRequiredNushu) return Nushu;
		    hasRequiredNushu = 1;
		    var set = regenerateExports(0x16FE1);
		    set.addRange(0x1B170, 0x1B2FB);
		    Nushu.characters = set;
		    return Nushu;
		  }

		  var Nyiakeng_Puachue_Hmong = {};

		  var hasRequiredNyiakeng_Puachue_Hmong;
		  function requireNyiakeng_Puachue_Hmong() {
		    if (hasRequiredNyiakeng_Puachue_Hmong) return Nyiakeng_Puachue_Hmong;
		    hasRequiredNyiakeng_Puachue_Hmong = 1;
		    var set = regenerateExports();
		    set.addRange(0x1E100, 0x1E12C).addRange(0x1E130, 0x1E13D).addRange(0x1E140, 0x1E149).addRange(0x1E14E, 0x1E14F);
		    Nyiakeng_Puachue_Hmong.characters = set;
		    return Nyiakeng_Puachue_Hmong;
		  }

		  var Ogham = {};

		  var hasRequiredOgham;
		  function requireOgham() {
		    if (hasRequiredOgham) return Ogham;
		    hasRequiredOgham = 1;
		    var set = regenerateExports();
		    set.addRange(0x1680, 0x169C);
		    Ogham.characters = set;
		    return Ogham;
		  }

		  var Ol_Chiki = {};

		  var hasRequiredOl_Chiki;
		  function requireOl_Chiki() {
		    if (hasRequiredOl_Chiki) return Ol_Chiki;
		    hasRequiredOl_Chiki = 1;
		    var set = regenerateExports();
		    set.addRange(0x1C50, 0x1C7F);
		    Ol_Chiki.characters = set;
		    return Ol_Chiki;
		  }

		  var Old_Hungarian = {};

		  var hasRequiredOld_Hungarian;
		  function requireOld_Hungarian() {
		    if (hasRequiredOld_Hungarian) return Old_Hungarian;
		    hasRequiredOld_Hungarian = 1;
		    var set = regenerateExports();
		    set.addRange(0x10C80, 0x10CB2).addRange(0x10CC0, 0x10CF2).addRange(0x10CFA, 0x10CFF);
		    Old_Hungarian.characters = set;
		    return Old_Hungarian;
		  }

		  var Old_Italic = {};

		  var hasRequiredOld_Italic;
		  function requireOld_Italic() {
		    if (hasRequiredOld_Italic) return Old_Italic;
		    hasRequiredOld_Italic = 1;
		    var set = regenerateExports();
		    set.addRange(0x10300, 0x10323).addRange(0x1032D, 0x1032F);
		    Old_Italic.characters = set;
		    return Old_Italic;
		  }

		  var Old_North_Arabian = {};

		  var hasRequiredOld_North_Arabian;
		  function requireOld_North_Arabian() {
		    if (hasRequiredOld_North_Arabian) return Old_North_Arabian;
		    hasRequiredOld_North_Arabian = 1;
		    var set = regenerateExports();
		    set.addRange(0x10A80, 0x10A9F);
		    Old_North_Arabian.characters = set;
		    return Old_North_Arabian;
		  }

		  var Old_Permic = {};

		  var hasRequiredOld_Permic;
		  function requireOld_Permic() {
		    if (hasRequiredOld_Permic) return Old_Permic;
		    hasRequiredOld_Permic = 1;
		    var set = regenerateExports();
		    set.addRange(0x10350, 0x1037A);
		    Old_Permic.characters = set;
		    return Old_Permic;
		  }

		  var Old_Persian = {};

		  var hasRequiredOld_Persian;
		  function requireOld_Persian() {
		    if (hasRequiredOld_Persian) return Old_Persian;
		    hasRequiredOld_Persian = 1;
		    var set = regenerateExports();
		    set.addRange(0x103A0, 0x103C3).addRange(0x103C8, 0x103D5);
		    Old_Persian.characters = set;
		    return Old_Persian;
		  }

		  var Old_Sogdian = {};

		  var hasRequiredOld_Sogdian;
		  function requireOld_Sogdian() {
		    if (hasRequiredOld_Sogdian) return Old_Sogdian;
		    hasRequiredOld_Sogdian = 1;
		    var set = regenerateExports();
		    set.addRange(0x10F00, 0x10F27);
		    Old_Sogdian.characters = set;
		    return Old_Sogdian;
		  }

		  var Old_South_Arabian = {};

		  var hasRequiredOld_South_Arabian;
		  function requireOld_South_Arabian() {
		    if (hasRequiredOld_South_Arabian) return Old_South_Arabian;
		    hasRequiredOld_South_Arabian = 1;
		    var set = regenerateExports();
		    set.addRange(0x10A60, 0x10A7F);
		    Old_South_Arabian.characters = set;
		    return Old_South_Arabian;
		  }

		  var Old_Turkic = {};

		  var hasRequiredOld_Turkic;
		  function requireOld_Turkic() {
		    if (hasRequiredOld_Turkic) return Old_Turkic;
		    hasRequiredOld_Turkic = 1;
		    var set = regenerateExports();
		    set.addRange(0x10C00, 0x10C48);
		    Old_Turkic.characters = set;
		    return Old_Turkic;
		  }

		  var Old_Uyghur = {};

		  var hasRequiredOld_Uyghur;
		  function requireOld_Uyghur() {
		    if (hasRequiredOld_Uyghur) return Old_Uyghur;
		    hasRequiredOld_Uyghur = 1;
		    var set = regenerateExports();
		    set.addRange(0x10F70, 0x10F89);
		    Old_Uyghur.characters = set;
		    return Old_Uyghur;
		  }

		  var Oriya = {};

		  var hasRequiredOriya;
		  function requireOriya() {
		    if (hasRequiredOriya) return Oriya;
		    hasRequiredOriya = 1;
		    var set = regenerateExports();
		    set.addRange(0xB01, 0xB03).addRange(0xB05, 0xB0C).addRange(0xB0F, 0xB10).addRange(0xB13, 0xB28).addRange(0xB2A, 0xB30).addRange(0xB32, 0xB33).addRange(0xB35, 0xB39).addRange(0xB3C, 0xB44).addRange(0xB47, 0xB48).addRange(0xB4B, 0xB4D).addRange(0xB55, 0xB57).addRange(0xB5C, 0xB5D).addRange(0xB5F, 0xB63).addRange(0xB66, 0xB77);
		    Oriya.characters = set;
		    return Oriya;
		  }

		  var Osage = {};

		  var hasRequiredOsage;
		  function requireOsage() {
		    if (hasRequiredOsage) return Osage;
		    hasRequiredOsage = 1;
		    var set = regenerateExports();
		    set.addRange(0x104B0, 0x104D3).addRange(0x104D8, 0x104FB);
		    Osage.characters = set;
		    return Osage;
		  }

		  var Osmanya = {};

		  var hasRequiredOsmanya;
		  function requireOsmanya() {
		    if (hasRequiredOsmanya) return Osmanya;
		    hasRequiredOsmanya = 1;
		    var set = regenerateExports();
		    set.addRange(0x10480, 0x1049D).addRange(0x104A0, 0x104A9);
		    Osmanya.characters = set;
		    return Osmanya;
		  }

		  var Pahawh_Hmong = {};

		  var hasRequiredPahawh_Hmong;
		  function requirePahawh_Hmong() {
		    if (hasRequiredPahawh_Hmong) return Pahawh_Hmong;
		    hasRequiredPahawh_Hmong = 1;
		    var set = regenerateExports();
		    set.addRange(0x16B00, 0x16B45).addRange(0x16B50, 0x16B59).addRange(0x16B5B, 0x16B61).addRange(0x16B63, 0x16B77).addRange(0x16B7D, 0x16B8F);
		    Pahawh_Hmong.characters = set;
		    return Pahawh_Hmong;
		  }

		  var Palmyrene = {};

		  var hasRequiredPalmyrene;
		  function requirePalmyrene() {
		    if (hasRequiredPalmyrene) return Palmyrene;
		    hasRequiredPalmyrene = 1;
		    var set = regenerateExports();
		    set.addRange(0x10860, 0x1087F);
		    Palmyrene.characters = set;
		    return Palmyrene;
		  }

		  var Pau_Cin_Hau = {};

		  var hasRequiredPau_Cin_Hau;
		  function requirePau_Cin_Hau() {
		    if (hasRequiredPau_Cin_Hau) return Pau_Cin_Hau;
		    hasRequiredPau_Cin_Hau = 1;
		    var set = regenerateExports();
		    set.addRange(0x11AC0, 0x11AF8);
		    Pau_Cin_Hau.characters = set;
		    return Pau_Cin_Hau;
		  }

		  var Phags_Pa = {};

		  var hasRequiredPhags_Pa;
		  function requirePhags_Pa() {
		    if (hasRequiredPhags_Pa) return Phags_Pa;
		    hasRequiredPhags_Pa = 1;
		    var set = regenerateExports();
		    set.addRange(0xA840, 0xA877);
		    Phags_Pa.characters = set;
		    return Phags_Pa;
		  }

		  var Phoenician = {};

		  var hasRequiredPhoenician;
		  function requirePhoenician() {
		    if (hasRequiredPhoenician) return Phoenician;
		    hasRequiredPhoenician = 1;
		    var set = regenerateExports(0x1091F);
		    set.addRange(0x10900, 0x1091B);
		    Phoenician.characters = set;
		    return Phoenician;
		  }

		  var Psalter_Pahlavi = {};

		  var hasRequiredPsalter_Pahlavi;
		  function requirePsalter_Pahlavi() {
		    if (hasRequiredPsalter_Pahlavi) return Psalter_Pahlavi;
		    hasRequiredPsalter_Pahlavi = 1;
		    var set = regenerateExports();
		    set.addRange(0x10B80, 0x10B91).addRange(0x10B99, 0x10B9C).addRange(0x10BA9, 0x10BAF);
		    Psalter_Pahlavi.characters = set;
		    return Psalter_Pahlavi;
		  }

		  var Rejang = {};

		  var hasRequiredRejang;
		  function requireRejang() {
		    if (hasRequiredRejang) return Rejang;
		    hasRequiredRejang = 1;
		    var set = regenerateExports(0xA95F);
		    set.addRange(0xA930, 0xA953);
		    Rejang.characters = set;
		    return Rejang;
		  }

		  var Runic = {};

		  var hasRequiredRunic;
		  function requireRunic() {
		    if (hasRequiredRunic) return Runic;
		    hasRequiredRunic = 1;
		    var set = regenerateExports();
		    set.addRange(0x16A0, 0x16EA).addRange(0x16EE, 0x16F8);
		    Runic.characters = set;
		    return Runic;
		  }

		  var Samaritan = {};

		  var hasRequiredSamaritan;
		  function requireSamaritan() {
		    if (hasRequiredSamaritan) return Samaritan;
		    hasRequiredSamaritan = 1;
		    var set = regenerateExports();
		    set.addRange(0x800, 0x82D).addRange(0x830, 0x83E);
		    Samaritan.characters = set;
		    return Samaritan;
		  }

		  var Saurashtra = {};

		  var hasRequiredSaurashtra;
		  function requireSaurashtra() {
		    if (hasRequiredSaurashtra) return Saurashtra;
		    hasRequiredSaurashtra = 1;
		    var set = regenerateExports();
		    set.addRange(0xA880, 0xA8C5).addRange(0xA8CE, 0xA8D9);
		    Saurashtra.characters = set;
		    return Saurashtra;
		  }

		  var Sharada = {};

		  var hasRequiredSharada;
		  function requireSharada() {
		    if (hasRequiredSharada) return Sharada;
		    hasRequiredSharada = 1;
		    var set = regenerateExports();
		    set.addRange(0x11180, 0x111DF);
		    Sharada.characters = set;
		    return Sharada;
		  }

		  var Shavian = {};

		  var hasRequiredShavian;
		  function requireShavian() {
		    if (hasRequiredShavian) return Shavian;
		    hasRequiredShavian = 1;
		    var set = regenerateExports();
		    set.addRange(0x10450, 0x1047F);
		    Shavian.characters = set;
		    return Shavian;
		  }

		  var Siddham = {};

		  var hasRequiredSiddham;
		  function requireSiddham() {
		    if (hasRequiredSiddham) return Siddham;
		    hasRequiredSiddham = 1;
		    var set = regenerateExports();
		    set.addRange(0x11580, 0x115B5).addRange(0x115B8, 0x115DD);
		    Siddham.characters = set;
		    return Siddham;
		  }

		  var SignWriting = {};

		  var hasRequiredSignWriting;
		  function requireSignWriting() {
		    if (hasRequiredSignWriting) return SignWriting;
		    hasRequiredSignWriting = 1;
		    var set = regenerateExports();
		    set.addRange(0x1D800, 0x1DA8B).addRange(0x1DA9B, 0x1DA9F).addRange(0x1DAA1, 0x1DAAF);
		    SignWriting.characters = set;
		    return SignWriting;
		  }

		  var Sinhala = {};

		  var hasRequiredSinhala;
		  function requireSinhala() {
		    if (hasRequiredSinhala) return Sinhala;
		    hasRequiredSinhala = 1;
		    var set = regenerateExports(0xDBD, 0xDCA, 0xDD6);
		    set.addRange(0xD81, 0xD83).addRange(0xD85, 0xD96).addRange(0xD9A, 0xDB1).addRange(0xDB3, 0xDBB).addRange(0xDC0, 0xDC6).addRange(0xDCF, 0xDD4).addRange(0xDD8, 0xDDF).addRange(0xDE6, 0xDEF).addRange(0xDF2, 0xDF4).addRange(0x111E1, 0x111F4);
		    Sinhala.characters = set;
		    return Sinhala;
		  }

		  var Sogdian = {};

		  var hasRequiredSogdian;
		  function requireSogdian() {
		    if (hasRequiredSogdian) return Sogdian;
		    hasRequiredSogdian = 1;
		    var set = regenerateExports();
		    set.addRange(0x10F30, 0x10F59);
		    Sogdian.characters = set;
		    return Sogdian;
		  }

		  var Sora_Sompeng = {};

		  var hasRequiredSora_Sompeng;
		  function requireSora_Sompeng() {
		    if (hasRequiredSora_Sompeng) return Sora_Sompeng;
		    hasRequiredSora_Sompeng = 1;
		    var set = regenerateExports();
		    set.addRange(0x110D0, 0x110E8).addRange(0x110F0, 0x110F9);
		    Sora_Sompeng.characters = set;
		    return Sora_Sompeng;
		  }

		  var Soyombo = {};

		  var hasRequiredSoyombo;
		  function requireSoyombo() {
		    if (hasRequiredSoyombo) return Soyombo;
		    hasRequiredSoyombo = 1;
		    var set = regenerateExports();
		    set.addRange(0x11A50, 0x11AA2);
		    Soyombo.characters = set;
		    return Soyombo;
		  }

		  var Sundanese = {};

		  var hasRequiredSundanese;
		  function requireSundanese() {
		    if (hasRequiredSundanese) return Sundanese;
		    hasRequiredSundanese = 1;
		    var set = regenerateExports();
		    set.addRange(0x1B80, 0x1BBF).addRange(0x1CC0, 0x1CC7);
		    Sundanese.characters = set;
		    return Sundanese;
		  }

		  var Syloti_Nagri = {};

		  var hasRequiredSyloti_Nagri;
		  function requireSyloti_Nagri() {
		    if (hasRequiredSyloti_Nagri) return Syloti_Nagri;
		    hasRequiredSyloti_Nagri = 1;
		    var set = regenerateExports();
		    set.addRange(0xA800, 0xA82C);
		    Syloti_Nagri.characters = set;
		    return Syloti_Nagri;
		  }

		  var Syriac = {};

		  var hasRequiredSyriac;
		  function requireSyriac() {
		    if (hasRequiredSyriac) return Syriac;
		    hasRequiredSyriac = 1;
		    var set = regenerateExports();
		    set.addRange(0x700, 0x70D).addRange(0x70F, 0x74A).addRange(0x74D, 0x74F).addRange(0x860, 0x86A);
		    Syriac.characters = set;
		    return Syriac;
		  }

		  var Tagalog = {};

		  var hasRequiredTagalog;
		  function requireTagalog() {
		    if (hasRequiredTagalog) return Tagalog;
		    hasRequiredTagalog = 1;
		    var set = regenerateExports(0x171F);
		    set.addRange(0x1700, 0x1715);
		    Tagalog.characters = set;
		    return Tagalog;
		  }

		  var Tagbanwa = {};

		  var hasRequiredTagbanwa;
		  function requireTagbanwa() {
		    if (hasRequiredTagbanwa) return Tagbanwa;
		    hasRequiredTagbanwa = 1;
		    var set = regenerateExports();
		    set.addRange(0x1760, 0x176C).addRange(0x176E, 0x1770).addRange(0x1772, 0x1773);
		    Tagbanwa.characters = set;
		    return Tagbanwa;
		  }

		  var Tai_Le = {};

		  var hasRequiredTai_Le;
		  function requireTai_Le() {
		    if (hasRequiredTai_Le) return Tai_Le;
		    hasRequiredTai_Le = 1;
		    var set = regenerateExports();
		    set.addRange(0x1950, 0x196D).addRange(0x1970, 0x1974);
		    Tai_Le.characters = set;
		    return Tai_Le;
		  }

		  var Tai_Tham = {};

		  var hasRequiredTai_Tham;
		  function requireTai_Tham() {
		    if (hasRequiredTai_Tham) return Tai_Tham;
		    hasRequiredTai_Tham = 1;
		    var set = regenerateExports();
		    set.addRange(0x1A20, 0x1A5E).addRange(0x1A60, 0x1A7C).addRange(0x1A7F, 0x1A89).addRange(0x1A90, 0x1A99).addRange(0x1AA0, 0x1AAD);
		    Tai_Tham.characters = set;
		    return Tai_Tham;
		  }

		  var Tai_Viet = {};

		  var hasRequiredTai_Viet;
		  function requireTai_Viet() {
		    if (hasRequiredTai_Viet) return Tai_Viet;
		    hasRequiredTai_Viet = 1;
		    var set = regenerateExports();
		    set.addRange(0xAA80, 0xAAC2).addRange(0xAADB, 0xAADF);
		    Tai_Viet.characters = set;
		    return Tai_Viet;
		  }

		  var Takri = {};

		  var hasRequiredTakri;
		  function requireTakri() {
		    if (hasRequiredTakri) return Takri;
		    hasRequiredTakri = 1;
		    var set = regenerateExports();
		    set.addRange(0x11680, 0x116B9).addRange(0x116C0, 0x116C9);
		    Takri.characters = set;
		    return Takri;
		  }

		  var Tamil = {};

		  var hasRequiredTamil;
		  function requireTamil() {
		    if (hasRequiredTamil) return Tamil;
		    hasRequiredTamil = 1;
		    var set = regenerateExports(0xB9C, 0xBD0, 0xBD7, 0x11FFF);
		    set.addRange(0xB82, 0xB83).addRange(0xB85, 0xB8A).addRange(0xB8E, 0xB90).addRange(0xB92, 0xB95).addRange(0xB99, 0xB9A).addRange(0xB9E, 0xB9F).addRange(0xBA3, 0xBA4).addRange(0xBA8, 0xBAA).addRange(0xBAE, 0xBB9).addRange(0xBBE, 0xBC2).addRange(0xBC6, 0xBC8).addRange(0xBCA, 0xBCD).addRange(0xBE6, 0xBFA).addRange(0x11FC0, 0x11FF1);
		    Tamil.characters = set;
		    return Tamil;
		  }

		  var Tangsa = {};

		  var hasRequiredTangsa;
		  function requireTangsa() {
		    if (hasRequiredTangsa) return Tangsa;
		    hasRequiredTangsa = 1;
		    var set = regenerateExports();
		    set.addRange(0x16A70, 0x16ABE).addRange(0x16AC0, 0x16AC9);
		    Tangsa.characters = set;
		    return Tangsa;
		  }

		  var Tangut = {};

		  var hasRequiredTangut;
		  function requireTangut() {
		    if (hasRequiredTangut) return Tangut;
		    hasRequiredTangut = 1;
		    var set = regenerateExports(0x16FE0);
		    set.addRange(0x17000, 0x187F7).addRange(0x18800, 0x18AFF).addRange(0x18D00, 0x18D08);
		    Tangut.characters = set;
		    return Tangut;
		  }

		  var Telugu = {};

		  var hasRequiredTelugu;
		  function requireTelugu() {
		    if (hasRequiredTelugu) return Telugu;
		    hasRequiredTelugu = 1;
		    var set = regenerateExports(0xC5D);
		    set.addRange(0xC00, 0xC0C).addRange(0xC0E, 0xC10).addRange(0xC12, 0xC28).addRange(0xC2A, 0xC39).addRange(0xC3C, 0xC44).addRange(0xC46, 0xC48).addRange(0xC4A, 0xC4D).addRange(0xC55, 0xC56).addRange(0xC58, 0xC5A).addRange(0xC60, 0xC63).addRange(0xC66, 0xC6F).addRange(0xC77, 0xC7F);
		    Telugu.characters = set;
		    return Telugu;
		  }

		  var Thaana = {};

		  var hasRequiredThaana;
		  function requireThaana() {
		    if (hasRequiredThaana) return Thaana;
		    hasRequiredThaana = 1;
		    var set = regenerateExports();
		    set.addRange(0x780, 0x7B1);
		    Thaana.characters = set;
		    return Thaana;
		  }

		  var Thai = {};

		  var hasRequiredThai;
		  function requireThai() {
		    if (hasRequiredThai) return Thai;
		    hasRequiredThai = 1;
		    var set = regenerateExports();
		    set.addRange(0xE01, 0xE3A).addRange(0xE40, 0xE5B);
		    Thai.characters = set;
		    return Thai;
		  }

		  var Tibetan = {};

		  var hasRequiredTibetan;
		  function requireTibetan() {
		    if (hasRequiredTibetan) return Tibetan;
		    hasRequiredTibetan = 1;
		    var set = regenerateExports();
		    set.addRange(0xF00, 0xF47).addRange(0xF49, 0xF6C).addRange(0xF71, 0xF97).addRange(0xF99, 0xFBC).addRange(0xFBE, 0xFCC).addRange(0xFCE, 0xFD4).addRange(0xFD9, 0xFDA);
		    Tibetan.characters = set;
		    return Tibetan;
		  }

		  var Tifinagh = {};

		  var hasRequiredTifinagh;
		  function requireTifinagh() {
		    if (hasRequiredTifinagh) return Tifinagh;
		    hasRequiredTifinagh = 1;
		    var set = regenerateExports(0x2D7F);
		    set.addRange(0x2D30, 0x2D67).addRange(0x2D6F, 0x2D70);
		    Tifinagh.characters = set;
		    return Tifinagh;
		  }

		  var Tirhuta = {};

		  var hasRequiredTirhuta;
		  function requireTirhuta() {
		    if (hasRequiredTirhuta) return Tirhuta;
		    hasRequiredTirhuta = 1;
		    var set = regenerateExports();
		    set.addRange(0x11480, 0x114C7).addRange(0x114D0, 0x114D9);
		    Tirhuta.characters = set;
		    return Tirhuta;
		  }

		  var Toto = {};

		  var hasRequiredToto;
		  function requireToto() {
		    if (hasRequiredToto) return Toto;
		    hasRequiredToto = 1;
		    var set = regenerateExports();
		    set.addRange(0x1E290, 0x1E2AE);
		    Toto.characters = set;
		    return Toto;
		  }

		  var Ugaritic = {};

		  var hasRequiredUgaritic;
		  function requireUgaritic() {
		    if (hasRequiredUgaritic) return Ugaritic;
		    hasRequiredUgaritic = 1;
		    var set = regenerateExports(0x1039F);
		    set.addRange(0x10380, 0x1039D);
		    Ugaritic.characters = set;
		    return Ugaritic;
		  }

		  var Vai = {};

		  var hasRequiredVai;
		  function requireVai() {
		    if (hasRequiredVai) return Vai;
		    hasRequiredVai = 1;
		    var set = regenerateExports();
		    set.addRange(0xA500, 0xA62B);
		    Vai.characters = set;
		    return Vai;
		  }

		  var Vithkuqi = {};

		  var hasRequiredVithkuqi;
		  function requireVithkuqi() {
		    if (hasRequiredVithkuqi) return Vithkuqi;
		    hasRequiredVithkuqi = 1;
		    var set = regenerateExports();
		    set.addRange(0x10570, 0x1057A).addRange(0x1057C, 0x1058A).addRange(0x1058C, 0x10592).addRange(0x10594, 0x10595).addRange(0x10597, 0x105A1).addRange(0x105A3, 0x105B1).addRange(0x105B3, 0x105B9).addRange(0x105BB, 0x105BC);
		    Vithkuqi.characters = set;
		    return Vithkuqi;
		  }

		  var Wancho = {};

		  var hasRequiredWancho;
		  function requireWancho() {
		    if (hasRequiredWancho) return Wancho;
		    hasRequiredWancho = 1;
		    var set = regenerateExports(0x1E2FF);
		    set.addRange(0x1E2C0, 0x1E2F9);
		    Wancho.characters = set;
		    return Wancho;
		  }

		  var Warang_Citi = {};

		  var hasRequiredWarang_Citi;
		  function requireWarang_Citi() {
		    if (hasRequiredWarang_Citi) return Warang_Citi;
		    hasRequiredWarang_Citi = 1;
		    var set = regenerateExports(0x118FF);
		    set.addRange(0x118A0, 0x118F2);
		    Warang_Citi.characters = set;
		    return Warang_Citi;
		  }

		  var Yezidi = {};

		  var hasRequiredYezidi;
		  function requireYezidi() {
		    if (hasRequiredYezidi) return Yezidi;
		    hasRequiredYezidi = 1;
		    var set = regenerateExports();
		    set.addRange(0x10E80, 0x10EA9).addRange(0x10EAB, 0x10EAD).addRange(0x10EB0, 0x10EB1);
		    Yezidi.characters = set;
		    return Yezidi;
		  }

		  var Yi = {};

		  var hasRequiredYi;
		  function requireYi() {
		    if (hasRequiredYi) return Yi;
		    hasRequiredYi = 1;
		    var set = regenerateExports();
		    set.addRange(0xA000, 0xA48C).addRange(0xA490, 0xA4C6);
		    Yi.characters = set;
		    return Yi;
		  }

		  var Zanabazar_Square = {};

		  var hasRequiredZanabazar_Square;
		  function requireZanabazar_Square() {
		    if (hasRequiredZanabazar_Square) return Zanabazar_Square;
		    hasRequiredZanabazar_Square = 1;
		    var set = regenerateExports();
		    set.addRange(0x11A00, 0x11A47);
		    Zanabazar_Square.characters = set;
		    return Zanabazar_Square;
		  }

		  var unicodeVersion;
		  var hasRequiredUnicodeVersion;
		  function requireUnicodeVersion() {
		    if (hasRequiredUnicodeVersion) return unicodeVersion;
		    hasRequiredUnicodeVersion = 1;
		    unicodeVersion = '15.1.0';
		    return unicodeVersion;
		  }

		  var dynamicModules;

		  function getDynamicModules() {
		  	return dynamicModules || (dynamicModules = {
		  		"/node_modules/regenerate-unicode-properties/Binary_Property/Alphabetic.js": requireAlphabetic,
		  		"/node_modules/regenerate-unicode-properties/Binary_Property/Any.js": requireAny,
		  		"/node_modules/regenerate-unicode-properties/Binary_Property/ASCII_Hex_Digit.js": requireASCII_Hex_Digit,
		  		"/node_modules/regenerate-unicode-properties/Binary_Property/ASCII.js": requireASCII,
		  		"/node_modules/regenerate-unicode-properties/Binary_Property/Assigned.js": requireAssigned,
		  		"/node_modules/regenerate-unicode-properties/Binary_Property/Bidi_Control.js": requireBidi_Control,
		  		"/node_modules/regenerate-unicode-properties/Binary_Property/Bidi_Mirrored.js": requireBidi_Mirrored,
		  		"/node_modules/regenerate-unicode-properties/Binary_Property/Case_Ignorable.js": requireCase_Ignorable,
		  		"/node_modules/regenerate-unicode-properties/Binary_Property/Cased.js": requireCased,
		  		"/node_modules/regenerate-unicode-properties/Binary_Property/Changes_When_Casefolded.js": requireChanges_When_Casefolded,
		  		"/node_modules/regenerate-unicode-properties/Binary_Property/Changes_When_Casemapped.js": requireChanges_When_Casemapped,
		  		"/node_modules/regenerate-unicode-properties/Binary_Property/Changes_When_Lowercased.js": requireChanges_When_Lowercased,
		  		"/node_modules/regenerate-unicode-properties/Binary_Property/Changes_When_NFKC_Casefolded.js": requireChanges_When_NFKC_Casefolded,
		  		"/node_modules/regenerate-unicode-properties/Binary_Property/Changes_When_Titlecased.js": requireChanges_When_Titlecased,
		  		"/node_modules/regenerate-unicode-properties/Binary_Property/Changes_When_Uppercased.js": requireChanges_When_Uppercased,
		  		"/node_modules/regenerate-unicode-properties/Binary_Property/Dash.js": requireDash,
		  		"/node_modules/regenerate-unicode-properties/Binary_Property/Default_Ignorable_Code_Point.js": requireDefault_Ignorable_Code_Point,
		  		"/node_modules/regenerate-unicode-properties/Binary_Property/Deprecated.js": requireDeprecated,
		  		"/node_modules/regenerate-unicode-properties/Binary_Property/Diacritic.js": requireDiacritic,
		  		"/node_modules/regenerate-unicode-properties/Binary_Property/Emoji_Component.js": requireEmoji_Component,
		  		"/node_modules/regenerate-unicode-properties/Binary_Property/Emoji_Modifier_Base.js": requireEmoji_Modifier_Base,
		  		"/node_modules/regenerate-unicode-properties/Binary_Property/Emoji_Modifier.js": requireEmoji_Modifier,
		  		"/node_modules/regenerate-unicode-properties/Binary_Property/Emoji_Presentation.js": requireEmoji_Presentation,
		  		"/node_modules/regenerate-unicode-properties/Binary_Property/Emoji.js": requireEmoji,
		  		"/node_modules/regenerate-unicode-properties/Binary_Property/Extended_Pictographic.js": requireExtended_Pictographic,
		  		"/node_modules/regenerate-unicode-properties/Binary_Property/Extender.js": requireExtender,
		  		"/node_modules/regenerate-unicode-properties/Binary_Property/Grapheme_Base.js": requireGrapheme_Base,
		  		"/node_modules/regenerate-unicode-properties/Binary_Property/Grapheme_Extend.js": requireGrapheme_Extend,
		  		"/node_modules/regenerate-unicode-properties/Binary_Property/Hex_Digit.js": requireHex_Digit,
		  		"/node_modules/regenerate-unicode-properties/Binary_Property/ID_Continue.js": requireID_Continue,
		  		"/node_modules/regenerate-unicode-properties/Binary_Property/ID_Start.js": requireID_Start,
		  		"/node_modules/regenerate-unicode-properties/Binary_Property/Ideographic.js": requireIdeographic,
		  		"/node_modules/regenerate-unicode-properties/Binary_Property/IDS_Binary_Operator.js": requireIDS_Binary_Operator,
		  		"/node_modules/regenerate-unicode-properties/Binary_Property/IDS_Trinary_Operator.js": requireIDS_Trinary_Operator,
		  		"/node_modules/regenerate-unicode-properties/Binary_Property/Join_Control.js": requireJoin_Control,
		  		"/node_modules/regenerate-unicode-properties/Binary_Property/Logical_Order_Exception.js": requireLogical_Order_Exception,
		  		"/node_modules/regenerate-unicode-properties/Binary_Property/Lowercase.js": requireLowercase,
		  		"/node_modules/regenerate-unicode-properties/Binary_Property/Math.js": require_Math,
		  		"/node_modules/regenerate-unicode-properties/Binary_Property/Noncharacter_Code_Point.js": requireNoncharacter_Code_Point,
		  		"/node_modules/regenerate-unicode-properties/Binary_Property/Pattern_Syntax.js": requirePattern_Syntax,
		  		"/node_modules/regenerate-unicode-properties/Binary_Property/Pattern_White_Space.js": requirePattern_White_Space,
		  		"/node_modules/regenerate-unicode-properties/Binary_Property/Quotation_Mark.js": requireQuotation_Mark,
		  		"/node_modules/regenerate-unicode-properties/Binary_Property/Radical.js": requireRadical,
		  		"/node_modules/regenerate-unicode-properties/Binary_Property/Regional_Indicator.js": requireRegional_Indicator,
		  		"/node_modules/regenerate-unicode-properties/Binary_Property/Sentence_Terminal.js": requireSentence_Terminal,
		  		"/node_modules/regenerate-unicode-properties/Binary_Property/Soft_Dotted.js": requireSoft_Dotted,
		  		"/node_modules/regenerate-unicode-properties/Binary_Property/Terminal_Punctuation.js": requireTerminal_Punctuation,
		  		"/node_modules/regenerate-unicode-properties/Binary_Property/Unified_Ideograph.js": requireUnified_Ideograph,
		  		"/node_modules/regenerate-unicode-properties/Binary_Property/Uppercase.js": requireUppercase,
		  		"/node_modules/regenerate-unicode-properties/Binary_Property/Variation_Selector.js": requireVariation_Selector,
		  		"/node_modules/regenerate-unicode-properties/Binary_Property/White_Space.js": requireWhite_Space,
		  		"/node_modules/regenerate-unicode-properties/Binary_Property/XID_Continue.js": requireXID_Continue,
		  		"/node_modules/regenerate-unicode-properties/Binary_Property/XID_Start.js": requireXID_Start,
		  		"/node_modules/regenerate-unicode-properties/General_Category/Cased_Letter.js": requireCased_Letter,
		  		"/node_modules/regenerate-unicode-properties/General_Category/Close_Punctuation.js": requireClose_Punctuation,
		  		"/node_modules/regenerate-unicode-properties/General_Category/Connector_Punctuation.js": requireConnector_Punctuation,
		  		"/node_modules/regenerate-unicode-properties/General_Category/Control.js": requireControl,
		  		"/node_modules/regenerate-unicode-properties/General_Category/Currency_Symbol.js": requireCurrency_Symbol,
		  		"/node_modules/regenerate-unicode-properties/General_Category/Dash_Punctuation.js": requireDash_Punctuation,
		  		"/node_modules/regenerate-unicode-properties/General_Category/Decimal_Number.js": requireDecimal_Number,
		  		"/node_modules/regenerate-unicode-properties/General_Category/Enclosing_Mark.js": requireEnclosing_Mark,
		  		"/node_modules/regenerate-unicode-properties/General_Category/Final_Punctuation.js": requireFinal_Punctuation,
		  		"/node_modules/regenerate-unicode-properties/General_Category/Format.js": requireFormat,
		  		"/node_modules/regenerate-unicode-properties/General_Category/Initial_Punctuation.js": requireInitial_Punctuation,
		  		"/node_modules/regenerate-unicode-properties/General_Category/Letter_Number.js": requireLetter_Number,
		  		"/node_modules/regenerate-unicode-properties/General_Category/Letter.js": requireLetter,
		  		"/node_modules/regenerate-unicode-properties/General_Category/Line_Separator.js": requireLine_Separator,
		  		"/node_modules/regenerate-unicode-properties/General_Category/Lowercase_Letter.js": requireLowercase_Letter,
		  		"/node_modules/regenerate-unicode-properties/General_Category/Mark.js": requireMark,
		  		"/node_modules/regenerate-unicode-properties/General_Category/Math_Symbol.js": requireMath_Symbol,
		  		"/node_modules/regenerate-unicode-properties/General_Category/Modifier_Letter.js": requireModifier_Letter,
		  		"/node_modules/regenerate-unicode-properties/General_Category/Modifier_Symbol.js": requireModifier_Symbol,
		  		"/node_modules/regenerate-unicode-properties/General_Category/Nonspacing_Mark.js": requireNonspacing_Mark,
		  		"/node_modules/regenerate-unicode-properties/General_Category/Number.js": require_Number,
		  		"/node_modules/regenerate-unicode-properties/General_Category/Open_Punctuation.js": requireOpen_Punctuation,
		  		"/node_modules/regenerate-unicode-properties/General_Category/Other_Letter.js": requireOther_Letter,
		  		"/node_modules/regenerate-unicode-properties/General_Category/Other_Number.js": requireOther_Number,
		  		"/node_modules/regenerate-unicode-properties/General_Category/Other_Punctuation.js": requireOther_Punctuation,
		  		"/node_modules/regenerate-unicode-properties/General_Category/Other_Symbol.js": requireOther_Symbol,
		  		"/node_modules/regenerate-unicode-properties/General_Category/Other.js": requireOther,
		  		"/node_modules/regenerate-unicode-properties/General_Category/Paragraph_Separator.js": requireParagraph_Separator,
		  		"/node_modules/regenerate-unicode-properties/General_Category/Private_Use.js": requirePrivate_Use,
		  		"/node_modules/regenerate-unicode-properties/General_Category/Punctuation.js": requirePunctuation,
		  		"/node_modules/regenerate-unicode-properties/General_Category/Separator.js": requireSeparator,
		  		"/node_modules/regenerate-unicode-properties/General_Category/Space_Separator.js": requireSpace_Separator,
		  		"/node_modules/regenerate-unicode-properties/General_Category/Spacing_Mark.js": requireSpacing_Mark,
		  		"/node_modules/regenerate-unicode-properties/General_Category/Surrogate.js": requireSurrogate,
		  		"/node_modules/regenerate-unicode-properties/General_Category/Symbol.js": require_Symbol,
		  		"/node_modules/regenerate-unicode-properties/General_Category/Titlecase_Letter.js": requireTitlecase_Letter,
		  		"/node_modules/regenerate-unicode-properties/General_Category/Unassigned.js": requireUnassigned,
		  		"/node_modules/regenerate-unicode-properties/General_Category/Uppercase_Letter.js": requireUppercase_Letter,
		  		"/node_modules/regenerate-unicode-properties/index.js": requireRegenerateUnicodeProperties,
		  		"/node_modules/regenerate-unicode-properties/Property_of_Strings/Basic_Emoji.js": requireBasic_Emoji,
		  		"/node_modules/regenerate-unicode-properties/Property_of_Strings/Emoji_Keycap_Sequence.js": requireEmoji_Keycap_Sequence,
		  		"/node_modules/regenerate-unicode-properties/Property_of_Strings/RGI_Emoji_Flag_Sequence.js": requireRGI_Emoji_Flag_Sequence,
		  		"/node_modules/regenerate-unicode-properties/Property_of_Strings/RGI_Emoji_Modifier_Sequence.js": requireRGI_Emoji_Modifier_Sequence,
		  		"/node_modules/regenerate-unicode-properties/Property_of_Strings/RGI_Emoji_Tag_Sequence.js": requireRGI_Emoji_Tag_Sequence,
		  		"/node_modules/regenerate-unicode-properties/Property_of_Strings/RGI_Emoji_ZWJ_Sequence.js": requireRGI_Emoji_ZWJ_Sequence,
		  		"/node_modules/regenerate-unicode-properties/Property_of_Strings/RGI_Emoji.js": requireRGI_Emoji,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Adlam.js": requireAdlam$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Ahom.js": requireAhom$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Anatolian_Hieroglyphs.js": requireAnatolian_Hieroglyphs$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Arabic.js": requireArabic$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Armenian.js": requireArmenian$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Avestan.js": requireAvestan$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Balinese.js": requireBalinese$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Bamum.js": requireBamum$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Bassa_Vah.js": requireBassa_Vah$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Batak.js": requireBatak$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Bengali.js": requireBengali$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Bhaiksuki.js": requireBhaiksuki$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Bopomofo.js": requireBopomofo$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Brahmi.js": requireBrahmi$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Braille.js": requireBraille$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Buginese.js": requireBuginese$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Buhid.js": requireBuhid$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Canadian_Aboriginal.js": requireCanadian_Aboriginal$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Carian.js": requireCarian$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Caucasian_Albanian.js": requireCaucasian_Albanian$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Chakma.js": requireChakma$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Cham.js": requireCham$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Cherokee.js": requireCherokee$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Chorasmian.js": requireChorasmian$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Common.js": requireCommon$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Coptic.js": requireCoptic$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Cuneiform.js": requireCuneiform$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Cypriot.js": requireCypriot$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Cypro_Minoan.js": requireCypro_Minoan$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Cyrillic.js": requireCyrillic$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Deseret.js": requireDeseret$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Devanagari.js": requireDevanagari$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Dives_Akuru.js": requireDives_Akuru$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Dogra.js": requireDogra$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Duployan.js": requireDuployan$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Egyptian_Hieroglyphs.js": requireEgyptian_Hieroglyphs$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Elbasan.js": requireElbasan$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Elymaic.js": requireElymaic$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Ethiopic.js": requireEthiopic$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Georgian.js": requireGeorgian$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Glagolitic.js": requireGlagolitic$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Gothic.js": requireGothic$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Grantha.js": requireGrantha$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Greek.js": requireGreek$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Gujarati.js": requireGujarati$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Gunjala_Gondi.js": requireGunjala_Gondi$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Gurmukhi.js": requireGurmukhi$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Han.js": requireHan$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Hangul.js": requireHangul$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Hanifi_Rohingya.js": requireHanifi_Rohingya$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Hanunoo.js": requireHanunoo$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Hatran.js": requireHatran$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Hebrew.js": requireHebrew$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Hiragana.js": requireHiragana$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Imperial_Aramaic.js": requireImperial_Aramaic$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Inherited.js": requireInherited$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Inscriptional_Pahlavi.js": requireInscriptional_Pahlavi$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Inscriptional_Parthian.js": requireInscriptional_Parthian$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Javanese.js": requireJavanese$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Kaithi.js": requireKaithi$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Kannada.js": requireKannada$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Katakana.js": requireKatakana$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Kawi.js": requireKawi$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Kayah_Li.js": requireKayah_Li$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Kharoshthi.js": requireKharoshthi$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Khitan_Small_Script.js": requireKhitan_Small_Script$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Khmer.js": requireKhmer$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Khojki.js": requireKhojki$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Khudawadi.js": requireKhudawadi$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Lao.js": requireLao$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Latin.js": requireLatin$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Lepcha.js": requireLepcha$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Limbu.js": requireLimbu$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Linear_A.js": requireLinear_A$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Linear_B.js": requireLinear_B$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Lisu.js": requireLisu$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Lycian.js": requireLycian$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Lydian.js": requireLydian$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Mahajani.js": requireMahajani$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Makasar.js": requireMakasar$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Malayalam.js": requireMalayalam$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Mandaic.js": requireMandaic$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Manichaean.js": requireManichaean$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Marchen.js": requireMarchen$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Masaram_Gondi.js": requireMasaram_Gondi$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Medefaidrin.js": requireMedefaidrin$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Meetei_Mayek.js": requireMeetei_Mayek$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Mende_Kikakui.js": requireMende_Kikakui$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Meroitic_Cursive.js": requireMeroitic_Cursive$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Meroitic_Hieroglyphs.js": requireMeroitic_Hieroglyphs$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Miao.js": requireMiao$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Modi.js": requireModi$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Mongolian.js": requireMongolian$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Mro.js": requireMro$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Multani.js": requireMultani$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Myanmar.js": requireMyanmar$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Nabataean.js": requireNabataean$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Nag_Mundari.js": requireNag_Mundari$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Nandinagari.js": requireNandinagari$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/New_Tai_Lue.js": requireNew_Tai_Lue$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Newa.js": requireNewa$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Nko.js": requireNko$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Nushu.js": requireNushu$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Nyiakeng_Puachue_Hmong.js": requireNyiakeng_Puachue_Hmong$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Ogham.js": requireOgham$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Ol_Chiki.js": requireOl_Chiki$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Old_Hungarian.js": requireOld_Hungarian$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Old_Italic.js": requireOld_Italic$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Old_North_Arabian.js": requireOld_North_Arabian$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Old_Permic.js": requireOld_Permic$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Old_Persian.js": requireOld_Persian$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Old_Sogdian.js": requireOld_Sogdian$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Old_South_Arabian.js": requireOld_South_Arabian$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Old_Turkic.js": requireOld_Turkic$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Old_Uyghur.js": requireOld_Uyghur$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Oriya.js": requireOriya$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Osage.js": requireOsage$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Osmanya.js": requireOsmanya$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Pahawh_Hmong.js": requirePahawh_Hmong$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Palmyrene.js": requirePalmyrene$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Pau_Cin_Hau.js": requirePau_Cin_Hau$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Phags_Pa.js": requirePhags_Pa$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Phoenician.js": requirePhoenician$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Psalter_Pahlavi.js": requirePsalter_Pahlavi$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Rejang.js": requireRejang$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Runic.js": requireRunic$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Samaritan.js": requireSamaritan$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Saurashtra.js": requireSaurashtra$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Sharada.js": requireSharada$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Shavian.js": requireShavian$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Siddham.js": requireSiddham$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/SignWriting.js": requireSignWriting$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Sinhala.js": requireSinhala$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Sogdian.js": requireSogdian$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Sora_Sompeng.js": requireSora_Sompeng$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Soyombo.js": requireSoyombo$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Sundanese.js": requireSundanese$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Syloti_Nagri.js": requireSyloti_Nagri$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Syriac.js": requireSyriac$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Tagalog.js": requireTagalog$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Tagbanwa.js": requireTagbanwa$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Tai_Le.js": requireTai_Le$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Tai_Tham.js": requireTai_Tham$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Tai_Viet.js": requireTai_Viet$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Takri.js": requireTakri$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Tamil.js": requireTamil$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Tangsa.js": requireTangsa$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Tangut.js": requireTangut$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Telugu.js": requireTelugu$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Thaana.js": requireThaana$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Thai.js": requireThai$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Tibetan.js": requireTibetan$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Tifinagh.js": requireTifinagh$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Tirhuta.js": requireTirhuta$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Toto.js": requireToto$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Ugaritic.js": requireUgaritic$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Vai.js": requireVai$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Vithkuqi.js": requireVithkuqi$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Wancho.js": requireWancho$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Warang_Citi.js": requireWarang_Citi$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Yezidi.js": requireYezidi$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Yi.js": requireYi$1,
		  		"/node_modules/regenerate-unicode-properties/Script_Extensions/Zanabazar_Square.js": requireZanabazar_Square$1,
		  		"/node_modules/regenerate-unicode-properties/Script/Adlam.js": requireAdlam,
		  		"/node_modules/regenerate-unicode-properties/Script/Ahom.js": requireAhom,
		  		"/node_modules/regenerate-unicode-properties/Script/Anatolian_Hieroglyphs.js": requireAnatolian_Hieroglyphs,
		  		"/node_modules/regenerate-unicode-properties/Script/Arabic.js": requireArabic,
		  		"/node_modules/regenerate-unicode-properties/Script/Armenian.js": requireArmenian,
		  		"/node_modules/regenerate-unicode-properties/Script/Avestan.js": requireAvestan,
		  		"/node_modules/regenerate-unicode-properties/Script/Balinese.js": requireBalinese,
		  		"/node_modules/regenerate-unicode-properties/Script/Bamum.js": requireBamum,
		  		"/node_modules/regenerate-unicode-properties/Script/Bassa_Vah.js": requireBassa_Vah,
		  		"/node_modules/regenerate-unicode-properties/Script/Batak.js": requireBatak,
		  		"/node_modules/regenerate-unicode-properties/Script/Bengali.js": requireBengali,
		  		"/node_modules/regenerate-unicode-properties/Script/Bhaiksuki.js": requireBhaiksuki,
		  		"/node_modules/regenerate-unicode-properties/Script/Bopomofo.js": requireBopomofo,
		  		"/node_modules/regenerate-unicode-properties/Script/Brahmi.js": requireBrahmi,
		  		"/node_modules/regenerate-unicode-properties/Script/Braille.js": requireBraille,
		  		"/node_modules/regenerate-unicode-properties/Script/Buginese.js": requireBuginese,
		  		"/node_modules/regenerate-unicode-properties/Script/Buhid.js": requireBuhid,
		  		"/node_modules/regenerate-unicode-properties/Script/Canadian_Aboriginal.js": requireCanadian_Aboriginal,
		  		"/node_modules/regenerate-unicode-properties/Script/Carian.js": requireCarian,
		  		"/node_modules/regenerate-unicode-properties/Script/Caucasian_Albanian.js": requireCaucasian_Albanian,
		  		"/node_modules/regenerate-unicode-properties/Script/Chakma.js": requireChakma,
		  		"/node_modules/regenerate-unicode-properties/Script/Cham.js": requireCham,
		  		"/node_modules/regenerate-unicode-properties/Script/Cherokee.js": requireCherokee,
		  		"/node_modules/regenerate-unicode-properties/Script/Chorasmian.js": requireChorasmian,
		  		"/node_modules/regenerate-unicode-properties/Script/Common.js": requireCommon,
		  		"/node_modules/regenerate-unicode-properties/Script/Coptic.js": requireCoptic,
		  		"/node_modules/regenerate-unicode-properties/Script/Cuneiform.js": requireCuneiform,
		  		"/node_modules/regenerate-unicode-properties/Script/Cypriot.js": requireCypriot,
		  		"/node_modules/regenerate-unicode-properties/Script/Cypro_Minoan.js": requireCypro_Minoan,
		  		"/node_modules/regenerate-unicode-properties/Script/Cyrillic.js": requireCyrillic,
		  		"/node_modules/regenerate-unicode-properties/Script/Deseret.js": requireDeseret,
		  		"/node_modules/regenerate-unicode-properties/Script/Devanagari.js": requireDevanagari,
		  		"/node_modules/regenerate-unicode-properties/Script/Dives_Akuru.js": requireDives_Akuru,
		  		"/node_modules/regenerate-unicode-properties/Script/Dogra.js": requireDogra,
		  		"/node_modules/regenerate-unicode-properties/Script/Duployan.js": requireDuployan,
		  		"/node_modules/regenerate-unicode-properties/Script/Egyptian_Hieroglyphs.js": requireEgyptian_Hieroglyphs,
		  		"/node_modules/regenerate-unicode-properties/Script/Elbasan.js": requireElbasan,
		  		"/node_modules/regenerate-unicode-properties/Script/Elymaic.js": requireElymaic,
		  		"/node_modules/regenerate-unicode-properties/Script/Ethiopic.js": requireEthiopic,
		  		"/node_modules/regenerate-unicode-properties/Script/Georgian.js": requireGeorgian,
		  		"/node_modules/regenerate-unicode-properties/Script/Glagolitic.js": requireGlagolitic,
		  		"/node_modules/regenerate-unicode-properties/Script/Gothic.js": requireGothic,
		  		"/node_modules/regenerate-unicode-properties/Script/Grantha.js": requireGrantha,
		  		"/node_modules/regenerate-unicode-properties/Script/Greek.js": requireGreek,
		  		"/node_modules/regenerate-unicode-properties/Script/Gujarati.js": requireGujarati,
		  		"/node_modules/regenerate-unicode-properties/Script/Gunjala_Gondi.js": requireGunjala_Gondi,
		  		"/node_modules/regenerate-unicode-properties/Script/Gurmukhi.js": requireGurmukhi,
		  		"/node_modules/regenerate-unicode-properties/Script/Han.js": requireHan,
		  		"/node_modules/regenerate-unicode-properties/Script/Hangul.js": requireHangul,
		  		"/node_modules/regenerate-unicode-properties/Script/Hanifi_Rohingya.js": requireHanifi_Rohingya,
		  		"/node_modules/regenerate-unicode-properties/Script/Hanunoo.js": requireHanunoo,
		  		"/node_modules/regenerate-unicode-properties/Script/Hatran.js": requireHatran,
		  		"/node_modules/regenerate-unicode-properties/Script/Hebrew.js": requireHebrew,
		  		"/node_modules/regenerate-unicode-properties/Script/Hiragana.js": requireHiragana,
		  		"/node_modules/regenerate-unicode-properties/Script/Imperial_Aramaic.js": requireImperial_Aramaic,
		  		"/node_modules/regenerate-unicode-properties/Script/Inherited.js": requireInherited,
		  		"/node_modules/regenerate-unicode-properties/Script/Inscriptional_Pahlavi.js": requireInscriptional_Pahlavi,
		  		"/node_modules/regenerate-unicode-properties/Script/Inscriptional_Parthian.js": requireInscriptional_Parthian,
		  		"/node_modules/regenerate-unicode-properties/Script/Javanese.js": requireJavanese,
		  		"/node_modules/regenerate-unicode-properties/Script/Kaithi.js": requireKaithi,
		  		"/node_modules/regenerate-unicode-properties/Script/Kannada.js": requireKannada,
		  		"/node_modules/regenerate-unicode-properties/Script/Katakana.js": requireKatakana,
		  		"/node_modules/regenerate-unicode-properties/Script/Kawi.js": requireKawi,
		  		"/node_modules/regenerate-unicode-properties/Script/Kayah_Li.js": requireKayah_Li,
		  		"/node_modules/regenerate-unicode-properties/Script/Kharoshthi.js": requireKharoshthi,
		  		"/node_modules/regenerate-unicode-properties/Script/Khitan_Small_Script.js": requireKhitan_Small_Script,
		  		"/node_modules/regenerate-unicode-properties/Script/Khmer.js": requireKhmer,
		  		"/node_modules/regenerate-unicode-properties/Script/Khojki.js": requireKhojki,
		  		"/node_modules/regenerate-unicode-properties/Script/Khudawadi.js": requireKhudawadi,
		  		"/node_modules/regenerate-unicode-properties/Script/Lao.js": requireLao,
		  		"/node_modules/regenerate-unicode-properties/Script/Latin.js": requireLatin,
		  		"/node_modules/regenerate-unicode-properties/Script/Lepcha.js": requireLepcha,
		  		"/node_modules/regenerate-unicode-properties/Script/Limbu.js": requireLimbu,
		  		"/node_modules/regenerate-unicode-properties/Script/Linear_A.js": requireLinear_A,
		  		"/node_modules/regenerate-unicode-properties/Script/Linear_B.js": requireLinear_B,
		  		"/node_modules/regenerate-unicode-properties/Script/Lisu.js": requireLisu,
		  		"/node_modules/regenerate-unicode-properties/Script/Lycian.js": requireLycian,
		  		"/node_modules/regenerate-unicode-properties/Script/Lydian.js": requireLydian,
		  		"/node_modules/regenerate-unicode-properties/Script/Mahajani.js": requireMahajani,
		  		"/node_modules/regenerate-unicode-properties/Script/Makasar.js": requireMakasar,
		  		"/node_modules/regenerate-unicode-properties/Script/Malayalam.js": requireMalayalam,
		  		"/node_modules/regenerate-unicode-properties/Script/Mandaic.js": requireMandaic,
		  		"/node_modules/regenerate-unicode-properties/Script/Manichaean.js": requireManichaean,
		  		"/node_modules/regenerate-unicode-properties/Script/Marchen.js": requireMarchen,
		  		"/node_modules/regenerate-unicode-properties/Script/Masaram_Gondi.js": requireMasaram_Gondi,
		  		"/node_modules/regenerate-unicode-properties/Script/Medefaidrin.js": requireMedefaidrin,
		  		"/node_modules/regenerate-unicode-properties/Script/Meetei_Mayek.js": requireMeetei_Mayek,
		  		"/node_modules/regenerate-unicode-properties/Script/Mende_Kikakui.js": requireMende_Kikakui,
		  		"/node_modules/regenerate-unicode-properties/Script/Meroitic_Cursive.js": requireMeroitic_Cursive,
		  		"/node_modules/regenerate-unicode-properties/Script/Meroitic_Hieroglyphs.js": requireMeroitic_Hieroglyphs,
		  		"/node_modules/regenerate-unicode-properties/Script/Miao.js": requireMiao,
		  		"/node_modules/regenerate-unicode-properties/Script/Modi.js": requireModi,
		  		"/node_modules/regenerate-unicode-properties/Script/Mongolian.js": requireMongolian,
		  		"/node_modules/regenerate-unicode-properties/Script/Mro.js": requireMro,
		  		"/node_modules/regenerate-unicode-properties/Script/Multani.js": requireMultani,
		  		"/node_modules/regenerate-unicode-properties/Script/Myanmar.js": requireMyanmar,
		  		"/node_modules/regenerate-unicode-properties/Script/Nabataean.js": requireNabataean,
		  		"/node_modules/regenerate-unicode-properties/Script/Nag_Mundari.js": requireNag_Mundari,
		  		"/node_modules/regenerate-unicode-properties/Script/Nandinagari.js": requireNandinagari,
		  		"/node_modules/regenerate-unicode-properties/Script/New_Tai_Lue.js": requireNew_Tai_Lue,
		  		"/node_modules/regenerate-unicode-properties/Script/Newa.js": requireNewa,
		  		"/node_modules/regenerate-unicode-properties/Script/Nko.js": requireNko,
		  		"/node_modules/regenerate-unicode-properties/Script/Nushu.js": requireNushu,
		  		"/node_modules/regenerate-unicode-properties/Script/Nyiakeng_Puachue_Hmong.js": requireNyiakeng_Puachue_Hmong,
		  		"/node_modules/regenerate-unicode-properties/Script/Ogham.js": requireOgham,
		  		"/node_modules/regenerate-unicode-properties/Script/Ol_Chiki.js": requireOl_Chiki,
		  		"/node_modules/regenerate-unicode-properties/Script/Old_Hungarian.js": requireOld_Hungarian,
		  		"/node_modules/regenerate-unicode-properties/Script/Old_Italic.js": requireOld_Italic,
		  		"/node_modules/regenerate-unicode-properties/Script/Old_North_Arabian.js": requireOld_North_Arabian,
		  		"/node_modules/regenerate-unicode-properties/Script/Old_Permic.js": requireOld_Permic,
		  		"/node_modules/regenerate-unicode-properties/Script/Old_Persian.js": requireOld_Persian,
		  		"/node_modules/regenerate-unicode-properties/Script/Old_Sogdian.js": requireOld_Sogdian,
		  		"/node_modules/regenerate-unicode-properties/Script/Old_South_Arabian.js": requireOld_South_Arabian,
		  		"/node_modules/regenerate-unicode-properties/Script/Old_Turkic.js": requireOld_Turkic,
		  		"/node_modules/regenerate-unicode-properties/Script/Old_Uyghur.js": requireOld_Uyghur,
		  		"/node_modules/regenerate-unicode-properties/Script/Oriya.js": requireOriya,
		  		"/node_modules/regenerate-unicode-properties/Script/Osage.js": requireOsage,
		  		"/node_modules/regenerate-unicode-properties/Script/Osmanya.js": requireOsmanya,
		  		"/node_modules/regenerate-unicode-properties/Script/Pahawh_Hmong.js": requirePahawh_Hmong,
		  		"/node_modules/regenerate-unicode-properties/Script/Palmyrene.js": requirePalmyrene,
		  		"/node_modules/regenerate-unicode-properties/Script/Pau_Cin_Hau.js": requirePau_Cin_Hau,
		  		"/node_modules/regenerate-unicode-properties/Script/Phags_Pa.js": requirePhags_Pa,
		  		"/node_modules/regenerate-unicode-properties/Script/Phoenician.js": requirePhoenician,
		  		"/node_modules/regenerate-unicode-properties/Script/Psalter_Pahlavi.js": requirePsalter_Pahlavi,
		  		"/node_modules/regenerate-unicode-properties/Script/Rejang.js": requireRejang,
		  		"/node_modules/regenerate-unicode-properties/Script/Runic.js": requireRunic,
		  		"/node_modules/regenerate-unicode-properties/Script/Samaritan.js": requireSamaritan,
		  		"/node_modules/regenerate-unicode-properties/Script/Saurashtra.js": requireSaurashtra,
		  		"/node_modules/regenerate-unicode-properties/Script/Sharada.js": requireSharada,
		  		"/node_modules/regenerate-unicode-properties/Script/Shavian.js": requireShavian,
		  		"/node_modules/regenerate-unicode-properties/Script/Siddham.js": requireSiddham,
		  		"/node_modules/regenerate-unicode-properties/Script/SignWriting.js": requireSignWriting,
		  		"/node_modules/regenerate-unicode-properties/Script/Sinhala.js": requireSinhala,
		  		"/node_modules/regenerate-unicode-properties/Script/Sogdian.js": requireSogdian,
		  		"/node_modules/regenerate-unicode-properties/Script/Sora_Sompeng.js": requireSora_Sompeng,
		  		"/node_modules/regenerate-unicode-properties/Script/Soyombo.js": requireSoyombo,
		  		"/node_modules/regenerate-unicode-properties/Script/Sundanese.js": requireSundanese,
		  		"/node_modules/regenerate-unicode-properties/Script/Syloti_Nagri.js": requireSyloti_Nagri,
		  		"/node_modules/regenerate-unicode-properties/Script/Syriac.js": requireSyriac,
		  		"/node_modules/regenerate-unicode-properties/Script/Tagalog.js": requireTagalog,
		  		"/node_modules/regenerate-unicode-properties/Script/Tagbanwa.js": requireTagbanwa,
		  		"/node_modules/regenerate-unicode-properties/Script/Tai_Le.js": requireTai_Le,
		  		"/node_modules/regenerate-unicode-properties/Script/Tai_Tham.js": requireTai_Tham,
		  		"/node_modules/regenerate-unicode-properties/Script/Tai_Viet.js": requireTai_Viet,
		  		"/node_modules/regenerate-unicode-properties/Script/Takri.js": requireTakri,
		  		"/node_modules/regenerate-unicode-properties/Script/Tamil.js": requireTamil,
		  		"/node_modules/regenerate-unicode-properties/Script/Tangsa.js": requireTangsa,
		  		"/node_modules/regenerate-unicode-properties/Script/Tangut.js": requireTangut,
		  		"/node_modules/regenerate-unicode-properties/Script/Telugu.js": requireTelugu,
		  		"/node_modules/regenerate-unicode-properties/Script/Thaana.js": requireThaana,
		  		"/node_modules/regenerate-unicode-properties/Script/Thai.js": requireThai,
		  		"/node_modules/regenerate-unicode-properties/Script/Tibetan.js": requireTibetan,
		  		"/node_modules/regenerate-unicode-properties/Script/Tifinagh.js": requireTifinagh,
		  		"/node_modules/regenerate-unicode-properties/Script/Tirhuta.js": requireTirhuta,
		  		"/node_modules/regenerate-unicode-properties/Script/Toto.js": requireToto,
		  		"/node_modules/regenerate-unicode-properties/Script/Ugaritic.js": requireUgaritic,
		  		"/node_modules/regenerate-unicode-properties/Script/Vai.js": requireVai,
		  		"/node_modules/regenerate-unicode-properties/Script/Vithkuqi.js": requireVithkuqi,
		  		"/node_modules/regenerate-unicode-properties/Script/Wancho.js": requireWancho,
		  		"/node_modules/regenerate-unicode-properties/Script/Warang_Citi.js": requireWarang_Citi,
		  		"/node_modules/regenerate-unicode-properties/Script/Yezidi.js": requireYezidi,
		  		"/node_modules/regenerate-unicode-properties/Script/Yi.js": requireYi,
		  		"/node_modules/regenerate-unicode-properties/Script/Zanabazar_Square.js": requireZanabazar_Square,
		  		"/node_modules/regenerate-unicode-properties/unicode-version.js": requireUnicodeVersion
		  	});
		  }

		  function createCommonjsRequire(originalModuleDir) {
		  	function handleRequire(path) {
		  		var resolvedPath = commonjsResolve(path, originalModuleDir);
		  		if (resolvedPath !== null) {
		  			return getDynamicModules()[resolvedPath]();
		  		}
		  		throw new Error('Could not dynamically require "' + path + '". Please configure the dynamicRequireTargets or/and ignoreDynamicRequires option of @rollup/plugin-commonjs appropriately for this require call to work.');
		  	}
		  	handleRequire.resolve = function (path) {
		  		var resolvedPath = commonjsResolve(path, originalModuleDir);
		  		if (resolvedPath !== null) {
		  			return resolvedPath;
		  		}
		  		return require.resolve(path);
		  	};
		  	return handleRequire;
		  }

		  function commonjsResolve (path, originalModuleDir) {
		  	var shouldTryNodeModules = isPossibleNodeModulesPath(path);
		  	path = normalize(path);
		  	var relPath;
		  	if (path[0] === '/') {
		  		originalModuleDir = '';
		  	}
		  	var modules = getDynamicModules();
		  	var checkedExtensions = ['', '.js', '.json'];
		  	while (true) {
		  		if (!shouldTryNodeModules) {
		  			relPath = normalize(originalModuleDir + '/' + path);
		  		} else {
		  			relPath = normalize(originalModuleDir + '/node_modules/' + path);
		  		}

		  		if (relPath.endsWith('/..')) {
		  			break; // Travelled too far up, avoid infinite loop
		  		}

		  		for (var extensionIndex = 0; extensionIndex < checkedExtensions.length; extensionIndex++) {
		  			var resolvedPath = relPath + checkedExtensions[extensionIndex];
		  			if (modules[resolvedPath]) {
		  				return resolvedPath;
		  			}
		  		}
		  		if (!shouldTryNodeModules) break;
		  		var nextDir = normalize(originalModuleDir + '/..');
		  		if (nextDir === originalModuleDir) break;
		  		originalModuleDir = nextDir;
		  	}
		  	return null;
		  }

		  function isPossibleNodeModulesPath (modulePath) {
		  	var c0 = modulePath[0];
		  	if (c0 === '/' || c0 === '\\') return false;
		  	var c1 = modulePath[1], c2 = modulePath[2];
		  	if ((c0 === '.' && (!c1 || c1 === '/' || c1 === '\\')) ||
		  		(c0 === '.' && c1 === '.' && (!c2 || c2 === '/' || c2 === '\\'))) return false;
		  	if (c1 === ':' && (c2 === '/' || c2 === '\\')) return false;
		  	return true;
		  }

		  function normalize (path) {
		  	path = path.replace(/\\/g, '/');
		  	var parts = path.split('/');
		  	var slashed = parts[0] === '';
		  	for (var i = 1; i < parts.length; i++) {
		  		if (parts[i] === '.' || parts[i] === '') {
		  			parts.splice(i--, 1);
		  		}
		  	}
		  	for (var i = 1; i < parts.length; i++) {
		  		if (parts[i] !== '..') continue;
		  		if (i > 0 && parts[i - 1] !== '..' && parts[i - 1] !== '.') {
		  			parts.splice(--i, 2);
		  			i--;
		  		}
		  	}
		  	path = parts.join('/');
		  	if (slashed && path[0] !== '/') path = '/' + path;
		  	else if (path.length === 0) path = '.';
		  	return path;
		  }

		  var regjsgen = {exports: {}};

		  regjsgen.exports;
		  (function (module, exports) {
		    (function () {
		      var objectTypes = {
		        'function': true,
		        'object': true
		      };
		      var root = objectTypes[typeof window] && window || this;
		      var freeExports = exports && !exports.nodeType && exports;
		      var hasFreeModule = module && !module.nodeType;
		      var freeGlobal = freeExports && hasFreeModule && typeof commonjsGlobal$1 == 'object' && commonjsGlobal$1;
		      if (freeGlobal && (freeGlobal.global === freeGlobal || freeGlobal.window === freeGlobal || freeGlobal.self === freeGlobal)) {
		        root = freeGlobal;
		      }
		      var hasOwnProperty = Object.prototype.hasOwnProperty;
		      function fromCodePoint() {
		        var codePoint = Number(arguments[0]);
		        if (!isFinite(codePoint) || codePoint < 0 || codePoint > 0x10FFFF || Math.floor(codePoint) != codePoint) {
		          throw RangeError('Invalid code point: ' + codePoint);
		        }
		        if (codePoint <= 0xFFFF) {
		          return String.fromCharCode(codePoint);
		        } else {
		          codePoint -= 0x10000;
		          var highSurrogate = (codePoint >> 10) + 0xD800;
		          var lowSurrogate = codePoint % 0x400 + 0xDC00;
		          return String.fromCharCode(highSurrogate, lowSurrogate);
		        }
		      }
		      var assertTypeRegexMap = {};
		      function assertType(type, expected) {
		        if (expected.indexOf('|') == -1) {
		          if (type == expected) {
		            return;
		          }
		          throw Error('Invalid node type: ' + type + '; expected type: ' + expected);
		        }
		        expected = hasOwnProperty.call(assertTypeRegexMap, expected) ? assertTypeRegexMap[expected] : assertTypeRegexMap[expected] = RegExp('^(?:' + expected + ')$');
		        if (expected.test(type)) {
		          return;
		        }
		        throw Error('Invalid node type: ' + type + '; expected types: ' + expected);
		      }
		      function generate(node) {
		        var type = node.type;
		        if (hasOwnProperty.call(generators, type)) {
		          return generators[type](node);
		        }
		        throw Error('Invalid node type: ' + type);
		      }
		      function generateSequence(generator, terms, separator) {
		        var i = -1,
		          length = terms.length,
		          result = '',
		          term;
		        while (++i < length) {
		          term = terms[i];
		          if (separator && i > 0) result += separator;
		          if (i + 1 < length && terms[i].type == 'value' && terms[i].kind == 'null' && terms[i + 1].type == 'value' && terms[i + 1].kind == 'symbol' && terms[i + 1].codePoint >= 48 && terms[i + 1].codePoint <= 57) {
		            result += '\\000';
		            continue;
		          }
		          result += generator(term);
		        }
		        return result;
		      }
		      function generateAlternative(node) {
		        assertType(node.type, 'alternative');
		        return generateSequence(generateTerm, node.body);
		      }
		      function generateAnchor(node) {
		        assertType(node.type, 'anchor');
		        switch (node.kind) {
		          case 'start':
		            return '^';
		          case 'end':
		            return '$';
		          case 'boundary':
		            return '\\b';
		          case 'not-boundary':
		            return '\\B';
		          default:
		            throw Error('Invalid assertion');
		        }
		      }
		      var atomType = 'anchor|characterClass|characterClassEscape|dot|group|reference|unicodePropertyEscape|value';
		      function generateAtom(node) {
		        assertType(node.type, atomType);
		        return generate(node);
		      }
		      function generateCharacterClass(node) {
		        assertType(node.type, 'characterClass');
		        var kind = node.kind;
		        var separator = kind === 'intersection' ? '&&' : kind === 'subtraction' ? '--' : '';
		        return '[' + (node.negative ? '^' : '') + generateSequence(generateClassAtom, node.body, separator) + ']';
		      }
		      function generateCharacterClassEscape(node) {
		        assertType(node.type, 'characterClassEscape');
		        return '\\' + node.value;
		      }
		      function generateCharacterClassRange(node) {
		        assertType(node.type, 'characterClassRange');
		        var min = node.min,
		          max = node.max;
		        if (min.type == 'characterClassRange' || max.type == 'characterClassRange') {
		          throw Error('Invalid character class range');
		        }
		        return generateClassAtom(min) + '-' + generateClassAtom(max);
		      }
		      function generateClassAtom(node) {
		        assertType(node.type, 'anchor|characterClass|characterClassEscape|characterClassRange|dot|value|unicodePropertyEscape|classStrings');
		        return generate(node);
		      }
		      function generateClassStrings(node) {
		        assertType(node.type, 'classStrings');
		        return '\\q{' + generateSequence(generateClassString, node.strings, '|') + '}';
		      }
		      function generateClassString(node) {
		        assertType(node.type, 'classString');
		        return generateSequence(generate, node.characters);
		      }
		      function generateDisjunction(node) {
		        assertType(node.type, 'disjunction');
		        return generateSequence(generate, node.body, '|');
		      }
		      function generateDot(node) {
		        assertType(node.type, 'dot');
		        return '.';
		      }
		      function generateGroup(node) {
		        assertType(node.type, 'group');
		        var result = '';
		        switch (node.behavior) {
		          case 'normal':
		            if (node.name) {
		              result += '?<' + generateIdentifier(node.name) + '>';
		            }
		            break;
		          case 'ignore':
		            if (node.modifierFlags) {
		              result += '?';
		              if (node.modifierFlags.enabling) result += node.modifierFlags.enabling;
		              if (node.modifierFlags.disabling) result += "-" + node.modifierFlags.disabling;
		              result += ':';
		            } else {
		              result += '?:';
		            }
		            break;
		          case 'lookahead':
		            result += '?=';
		            break;
		          case 'negativeLookahead':
		            result += '?!';
		            break;
		          case 'lookbehind':
		            result += '?<=';
		            break;
		          case 'negativeLookbehind':
		            result += '?<!';
		            break;
		          default:
		            throw Error('Invalid behaviour: ' + node.behaviour);
		        }
		        result += generateSequence(generate, node.body);
		        return '(' + result + ')';
		      }
		      function generateIdentifier(node) {
		        assertType(node.type, 'identifier');
		        return node.value;
		      }
		      function generateQuantifier(node) {
		        assertType(node.type, 'quantifier');
		        var quantifier = '',
		          min = node.min,
		          max = node.max;
		        if (max == null) {
		          if (min == 0) {
		            quantifier = '*';
		          } else if (min == 1) {
		            quantifier = '+';
		          } else {
		            quantifier = '{' + min + ',}';
		          }
		        } else if (min == max) {
		          quantifier = '{' + min + '}';
		        } else if (min == 0 && max == 1) {
		          quantifier = '?';
		        } else {
		          quantifier = '{' + min + ',' + max + '}';
		        }
		        if (!node.greedy) {
		          quantifier += '?';
		        }
		        return generateAtom(node.body[0]) + quantifier;
		      }
		      function generateReference(node) {
		        assertType(node.type, 'reference');
		        if (node.matchIndex) {
		          return '\\' + node.matchIndex;
		        }
		        if (node.name) {
		          return '\\k<' + generateIdentifier(node.name) + '>';
		        }
		        throw new Error('Unknown reference type');
		      }
		      function generateTerm(node) {
		        assertType(node.type, atomType + '|empty|quantifier');
		        return generate(node);
		      }
		      function generateUnicodePropertyEscape(node) {
		        assertType(node.type, 'unicodePropertyEscape');
		        return '\\' + (node.negative ? 'P' : 'p') + '{' + node.value + '}';
		      }
		      function generateValue(node) {
		        assertType(node.type, 'value');
		        var kind = node.kind,
		          codePoint = node.codePoint;
		        if (typeof codePoint != 'number') {
		          throw new Error('Invalid code point: ' + codePoint);
		        }
		        switch (kind) {
		          case 'controlLetter':
		            return '\\c' + fromCodePoint(codePoint + 64);
		          case 'hexadecimalEscape':
		            return '\\x' + ('00' + codePoint.toString(16).toUpperCase()).slice(-2);
		          case 'identifier':
		            return '\\' + fromCodePoint(codePoint);
		          case 'null':
		            return '\\' + codePoint;
		          case 'octal':
		            return '\\' + ('000' + codePoint.toString(8)).slice(-3);
		          case 'singleEscape':
		            switch (codePoint) {
		              case 0x0008:
		                return '\\b';
		              case 0x0009:
		                return '\\t';
		              case 0x000A:
		                return '\\n';
		              case 0x000B:
		                return '\\v';
		              case 0x000C:
		                return '\\f';
		              case 0x000D:
		                return '\\r';
		              case 0x002D:
		                return '\\-';
		              default:
		                throw Error('Invalid code point: ' + codePoint);
		            }
		          case 'symbol':
		            return fromCodePoint(codePoint);
		          case 'unicodeEscape':
		            return "\\u" + ('0000' + codePoint.toString(16).toUpperCase()).slice(-4);
		          case 'unicodeCodePointEscape':
		            return "\\u{" + codePoint.toString(16).toUpperCase() + '}';
		          default:
		            throw Error('Unsupported node kind: ' + kind);
		        }
		      }
		      var generators = {
		        'alternative': generateAlternative,
		        'anchor': generateAnchor,
		        'characterClass': generateCharacterClass,
		        'characterClassEscape': generateCharacterClassEscape,
		        'characterClassRange': generateCharacterClassRange,
		        'classStrings': generateClassStrings,
		        'disjunction': generateDisjunction,
		        'dot': generateDot,
		        'group': generateGroup,
		        'quantifier': generateQuantifier,
		        'reference': generateReference,
		        'unicodePropertyEscape': generateUnicodePropertyEscape,
		        'value': generateValue
		      };
		      var regjsgen = {
		        'generate': generate
		      };
		      if (freeExports && hasFreeModule) {
		        freeExports.generate = generate;
		      } else {
		        root.regjsgen = regjsgen;
		      }
		    }).call(commonjsGlobal$1);
		  })(regjsgen, regjsgen.exports);
		  var regjsgenExports = regjsgen.exports;

		  var parser = {exports: {}};

		  (function (module) {

		    (function () {
		      var fromCodePoint = String.fromCodePoint || function () {
		        var stringFromCharCode = String.fromCharCode;
		        var floor = Math.floor;
		        return function fromCodePoint() {
		          var MAX_SIZE = 0x4000;
		          var codeUnits = [];
		          var highSurrogate;
		          var lowSurrogate;
		          var index = -1;
		          var length = arguments.length;
		          if (!length) {
		            return '';
		          }
		          var result = '';
		          while (++index < length) {
		            var codePoint = Number(arguments[index]);
		            if (!isFinite(codePoint) || codePoint < 0 || codePoint > 0x10FFFF || floor(codePoint) != codePoint) {
		              throw RangeError('Invalid code point: ' + codePoint);
		            }
		            if (codePoint <= 0xFFFF) {
		              codeUnits.push(codePoint);
		            } else {
		              codePoint -= 0x10000;
		              highSurrogate = (codePoint >> 10) + 0xD800;
		              lowSurrogate = codePoint % 0x400 + 0xDC00;
		              codeUnits.push(highSurrogate, lowSurrogate);
		            }
		            if (index + 1 == length || codeUnits.length > MAX_SIZE) {
		              result += stringFromCharCode.apply(null, codeUnits);
		              codeUnits.length = 0;
		            }
		          }
		          return result;
		        };
		      }();
		      function parse(str, flags, features) {
		        if (!features) {
		          features = {};
		        }
		        function addRaw(node) {
		          node.raw = str.substring(node.range[0], node.range[1]);
		          return node;
		        }
		        function updateRawStart(node, start) {
		          node.range[0] = start;
		          return addRaw(node);
		        }
		        function createAnchor(kind, rawLength) {
		          return addRaw({
		            type: 'anchor',
		            kind: kind,
		            range: [pos - rawLength, pos]
		          });
		        }
		        function createValue(kind, codePoint, from, to) {
		          return addRaw({
		            type: 'value',
		            kind: kind,
		            codePoint: codePoint,
		            range: [from, to]
		          });
		        }
		        function createEscaped(kind, codePoint, value, fromOffset) {
		          fromOffset = fromOffset || 0;
		          return createValue(kind, codePoint, pos - (value.length + fromOffset), pos);
		        }
		        function createCharacter(matches) {
		          var _char = matches[0];
		          var first = _char.charCodeAt(0);
		          if (isUnicodeMode) {
		            var second;
		            if (_char.length === 1 && first >= 0xD800 && first <= 0xDBFF) {
		              second = lookahead().charCodeAt(0);
		              if (second >= 0xDC00 && second <= 0xDFFF) {
		                pos++;
		                return createValue('symbol', (first - 0xD800) * 0x400 + second - 0xDC00 + 0x10000, pos - 2, pos);
		              }
		            }
		          }
		          return createValue('symbol', first, pos - 1, pos);
		        }
		        function createDisjunction(alternatives, from, to) {
		          return addRaw({
		            type: 'disjunction',
		            body: alternatives,
		            range: [from, to]
		          });
		        }
		        function createDot() {
		          return addRaw({
		            type: 'dot',
		            range: [pos - 1, pos]
		          });
		        }
		        function createCharacterClassEscape(value) {
		          return addRaw({
		            type: 'characterClassEscape',
		            value: value,
		            range: [pos - 2, pos]
		          });
		        }
		        function createReference(matchIndex) {
		          return addRaw({
		            type: 'reference',
		            matchIndex: parseInt(matchIndex, 10),
		            range: [pos - 1 - matchIndex.length, pos]
		          });
		        }
		        function createNamedReference(name) {
		          return addRaw({
		            type: 'reference',
		            name: name,
		            range: [name.range[0] - 3, pos]
		          });
		        }
		        function createGroup(behavior, disjunction, from, to) {
		          return addRaw({
		            type: 'group',
		            behavior: behavior,
		            body: disjunction,
		            range: [from, to]
		          });
		        }
		        function createQuantifier(min, max, from, to, symbol) {
		          if (to == null) {
		            from = pos - 1;
		            to = pos;
		          }
		          return addRaw({
		            type: 'quantifier',
		            min: min,
		            max: max,
		            greedy: true,
		            body: null,
		            symbol: symbol,
		            range: [from, to]
		          });
		        }
		        function createAlternative(terms, from, to) {
		          return addRaw({
		            type: 'alternative',
		            body: terms,
		            range: [from, to]
		          });
		        }
		        function createCharacterClass(contents, negative, from, to) {
		          return addRaw({
		            type: 'characterClass',
		            kind: contents.kind,
		            body: contents.body,
		            negative: negative,
		            range: [from, to]
		          });
		        }
		        function createClassRange(min, max, from, to) {
		          if (min.codePoint > max.codePoint) {
		            bail('invalid range in character class', min.raw + '-' + max.raw, from, to);
		          }
		          return addRaw({
		            type: 'characterClassRange',
		            min: min,
		            max: max,
		            range: [from, to]
		          });
		        }
		        function createClassStrings(strings, from, to) {
		          return addRaw({
		            type: 'classStrings',
		            strings: strings,
		            range: [from, to]
		          });
		        }
		        function createClassString(characters, from, to) {
		          return addRaw({
		            type: 'classString',
		            characters: characters,
		            range: [from, to]
		          });
		        }
		        function flattenBody(body) {
		          if (body.type === 'alternative') {
		            return body.body;
		          } else {
		            return [body];
		          }
		        }
		        function incr(amount) {
		          amount = amount || 1;
		          var res = str.substring(pos, pos + amount);
		          pos += amount || 1;
		          return res;
		        }
		        function skip(value) {
		          if (!match(value)) {
		            bail('character', value);
		          }
		        }
		        function match(value) {
		          if (str.indexOf(value, pos) === pos) {
		            return incr(value.length);
		          }
		        }
		        function lookahead() {
		          return str[pos];
		        }
		        function current(value) {
		          return str.indexOf(value, pos) === pos;
		        }
		        function next(value) {
		          return str[pos + 1] === value;
		        }
		        function matchReg(regExp) {
		          var subStr = str.substring(pos);
		          var res = subStr.match(regExp);
		          if (res) {
		            res.range = [];
		            res.range[0] = pos;
		            incr(res[0].length);
		            res.range[1] = pos;
		          }
		          return res;
		        }
		        function parseDisjunction() {
		          var res = [],
		            from = pos;
		          res.push(parseAlternative());
		          while (match('|')) {
		            res.push(parseAlternative());
		          }
		          if (res.length === 1) {
		            return res[0];
		          }
		          return createDisjunction(res, from, pos);
		        }
		        function parseAlternative() {
		          var res = [],
		            from = pos;
		          var term;
		          while (term = parseTerm()) {
		            res.push(term);
		          }
		          if (res.length === 1) {
		            return res[0];
		          }
		          return createAlternative(res, from, pos);
		        }
		        function parseTerm() {
		          if (pos >= str.length || current('|') || current(')')) {
		            return null;
		          }
		          var anchor = parseAnchor();
		          if (anchor) {
		            return anchor;
		          }
		          var atom = parseAtomAndExtendedAtom();
		          var quantifier;
		          if (!atom) {
		            var pos_backup = pos;
		            quantifier = parseQuantifier() || false;
		            if (quantifier) {
		              pos = pos_backup;
		              bail('Expected atom');
		            }
		            var res;
		            if (!isUnicodeMode && (res = matchReg(/^{/))) {
		              atom = createCharacter(res);
		            } else {
		              bail('Expected atom');
		            }
		          }
		          quantifier = parseQuantifier() || false;
		          if (quantifier) {
		            quantifier.body = flattenBody(atom);
		            updateRawStart(quantifier, atom.range[0]);
		            return quantifier;
		          }
		          return atom;
		        }
		        function parseGroup(matchA, typeA, matchB, typeB) {
		          var type = null,
		            from = pos;
		          if (match(matchA)) {
		            type = typeA;
		          } else if (match(matchB)) {
		            type = typeB;
		          } else {
		            return false;
		          }
		          return finishGroup(type, from);
		        }
		        function finishGroup(type, from) {
		          var body = parseDisjunction();
		          if (!body) {
		            bail('Expected disjunction');
		          }
		          skip(')');
		          var group = createGroup(type, flattenBody(body), from, pos);
		          if (type == 'normal') {
		            if (firstIteration) {
		              closedCaptureCounter++;
		            }
		          }
		          return group;
		        }
		        function parseAnchor() {
		          if (match('^')) {
		            return createAnchor('start', 1);
		          } else if (match('$')) {
		            return createAnchor('end', 1);
		          } else if (match('\\b')) {
		            return createAnchor('boundary', 2);
		          } else if (match('\\B')) {
		            return createAnchor('not-boundary', 2);
		          } else {
		            return parseGroup('(?=', 'lookahead', '(?!', 'negativeLookahead');
		          }
		        }
		        function parseQuantifier() {
		          var res,
		            from = pos;
		          var quantifier;
		          var min, max;
		          if (match('*')) {
		            quantifier = createQuantifier(0, undefined, undefined, undefined, '*');
		          } else if (match('+')) {
		            quantifier = createQuantifier(1, undefined, undefined, undefined, "+");
		          } else if (match('?')) {
		            quantifier = createQuantifier(0, 1, undefined, undefined, "?");
		          } else if (res = matchReg(/^\{([0-9]+)\}/)) {
		            min = parseInt(res[1], 10);
		            quantifier = createQuantifier(min, min, res.range[0], res.range[1]);
		          } else if (res = matchReg(/^\{([0-9]+),\}/)) {
		            min = parseInt(res[1], 10);
		            quantifier = createQuantifier(min, undefined, res.range[0], res.range[1]);
		          } else if (res = matchReg(/^\{([0-9]+),([0-9]+)\}/)) {
		            min = parseInt(res[1], 10);
		            max = parseInt(res[2], 10);
		            if (min > max) {
		              bail('numbers out of order in {} quantifier', '', from, pos);
		            }
		            quantifier = createQuantifier(min, max, res.range[0], res.range[1]);
		          }
		          if (min && !Number.isSafeInteger(min) || max && !Number.isSafeInteger(max)) {
		            bail("iterations outside JS safe integer range in quantifier", "", from, pos);
		          }
		          if (quantifier) {
		            if (match('?')) {
		              quantifier.greedy = false;
		              quantifier.range[1] += 1;
		            }
		          }
		          return quantifier;
		        }
		        function parseAtomAndExtendedAtom() {
		          var res;
		          if (res = matchReg(/^[^^$\\.*+?()[\]{}|]/)) {
		            return createCharacter(res);
		          } else if (!isUnicodeMode && (res = matchReg(/^(?:]|})/))) {
		            return createCharacter(res);
		          } else if (match('.')) {
		            return createDot();
		          } else if (match('\\')) {
		            res = parseAtomEscape();
		            if (!res) {
		              if (!isUnicodeMode && lookahead() == 'c') {
		                return createValue('symbol', 92, pos - 1, pos);
		              }
		              bail('atomEscape');
		            }
		            return res;
		          } else if (res = parseCharacterClass()) {
		            return res;
		          } else if (features.lookbehind && (res = parseGroup('(?<=', 'lookbehind', '(?<!', 'negativeLookbehind'))) {
		            return res;
		          } else if (features.namedGroups && match("(?<")) {
		            var name = parseIdentifier();
		            skip(">");
		            var group = finishGroup("normal", name.range[0] - 3);
		            group.name = name;
		            return group;
		          } else if (features.modifiers && str.indexOf("(?") == pos && str[pos + 2] != ":") {
		            return parseModifiersGroup();
		          } else {
		            return parseGroup('(?:', 'ignore', '(', 'normal');
		          }
		        }
		        function parseModifiersGroup() {
		          function hasDupChar(str) {
		            var i = 0;
		            while (i < str.length) {
		              if (str.indexOf(str[i], i + 1) != -1) {
		                return true;
		              }
		              i++;
		            }
		            return false;
		          }
		          var from = pos;
		          incr(2);
		          var enablingFlags = matchReg(/^[sim]+/);
		          var disablingFlags;
		          if (match("-")) {
		            disablingFlags = matchReg(/^[sim]+/);
		            if (!disablingFlags) {
		              bail('Invalid flags for modifiers group');
		            }
		          } else if (!enablingFlags) {
		            bail('Invalid flags for modifiers group');
		          }
		          enablingFlags = enablingFlags ? enablingFlags[0] : "";
		          disablingFlags = disablingFlags ? disablingFlags[0] : "";
		          var flags = enablingFlags + disablingFlags;
		          if (flags.length > 3 || hasDupChar(flags)) {
		            bail('flags cannot be duplicated for modifiers group');
		          }
		          skip(":");
		          var modifiersGroup = finishGroup("ignore", from);
		          modifiersGroup.modifierFlags = {
		            enabling: enablingFlags,
		            disabling: disablingFlags
		          };
		          return modifiersGroup;
		        }
		        function parseUnicodeSurrogatePairEscape(firstEscape) {
		          if (isUnicodeMode) {
		            var first, second;
		            if (firstEscape.kind == 'unicodeEscape' && (first = firstEscape.codePoint) >= 0xD800 && first <= 0xDBFF && current('\\') && next('u')) {
		              var prevPos = pos;
		              pos++;
		              var secondEscape = parseClassEscape();
		              if (secondEscape.kind == 'unicodeEscape' && (second = secondEscape.codePoint) >= 0xDC00 && second <= 0xDFFF) {
		                firstEscape.range[1] = secondEscape.range[1];
		                firstEscape.codePoint = (first - 0xD800) * 0x400 + second - 0xDC00 + 0x10000;
		                firstEscape.type = 'value';
		                firstEscape.kind = 'unicodeCodePointEscape';
		                addRaw(firstEscape);
		              } else {
		                pos = prevPos;
		              }
		            }
		          }
		          return firstEscape;
		        }
		        function parseClassEscape() {
		          return parseAtomEscape(true);
		        }
		        function parseAtomEscape(insideCharacterClass) {
		          var res,
		            from = pos;
		          res = parseDecimalEscape(insideCharacterClass) || parseNamedReference();
		          if (res) {
		            return res;
		          }
		          if (insideCharacterClass) {
		            if (match('b')) {
		              return createEscaped('singleEscape', 0x0008, '\\b');
		            } else if (match('B')) {
		              bail('\\B not possible inside of CharacterClass', '', from);
		            } else if (!isUnicodeMode && (res = matchReg(/^c([0-9])/))) {
		              return createEscaped('controlLetter', res[1] + 16, res[1], 2);
		            } else if (!isUnicodeMode && (res = matchReg(/^c_/))) {
		              return createEscaped('controlLetter', 31, '_', 2);
		            }
		            if (isUnicodeMode && match('-')) {
		              return createEscaped('singleEscape', 0x002d, '\\-');
		            }
		          }
		          res = parseCharacterClassEscape() || parseCharacterEscape();
		          return res;
		        }
		        function parseDecimalEscape(insideCharacterClass) {
		          var res,
		            match,
		            from = pos;
		          if (res = matchReg(/^(?!0)\d+/)) {
		            match = res[0];
		            var refIdx = parseInt(res[0], 10);
		            if (refIdx <= closedCaptureCounter && !insideCharacterClass) {
		              return createReference(res[0]);
		            } else {
		              backrefDenied.push(refIdx);
		              if (firstIteration) {
		                shouldReparse = true;
		              } else {
		                bailOctalEscapeIfUnicode(from, pos);
		              }
		              incr(-res[0].length);
		              if (res = matchReg(/^[0-7]{1,3}/)) {
		                return createEscaped('octal', parseInt(res[0], 8), res[0], 1);
		              } else {
		                res = createCharacter(matchReg(/^[89]/));
		                return updateRawStart(res, res.range[0] - 1);
		              }
		            }
		          } else if (res = matchReg(/^[0-7]{1,3}/)) {
		            match = res[0];
		            if (match !== '0') {
		              bailOctalEscapeIfUnicode(from, pos);
		            }
		            if (/^0{1,3}$/.test(match)) {
		              return createEscaped('null', 0x0000, '0', match.length);
		            } else {
		              return createEscaped('octal', parseInt(match, 8), match, 1);
		            }
		          }
		          return false;
		        }
		        function bailOctalEscapeIfUnicode(from, pos) {
		          if (isUnicodeMode) {
		            bail("Invalid decimal escape in unicode mode", null, from, pos);
		          }
		        }
		        function parseCharacterClassEscape() {
		          var res;
		          if (res = matchReg(/^[dDsSwW]/)) {
		            return createCharacterClassEscape(res[0]);
		          } else if (features.unicodePropertyEscape && isUnicodeMode && (res = matchReg(/^([pP])\{([^\}]+)\}/))) {
		            return addRaw({
		              type: 'unicodePropertyEscape',
		              negative: res[1] === 'P',
		              value: res[2],
		              range: [res.range[0] - 1, res.range[1]],
		              raw: res[0]
		            });
		          } else if (features.unicodeSet && hasUnicodeSetFlag && match('q{')) {
		            return parseClassStrings();
		          }
		          return false;
		        }
		        function parseNamedReference() {
		          if (features.namedGroups && matchReg(/^k<(?=.*?>)/)) {
		            var name = parseIdentifier();
		            skip('>');
		            return createNamedReference(name);
		          }
		        }
		        function parseRegExpUnicodeEscapeSequence() {
		          var res;
		          if (res = matchReg(/^u([0-9a-fA-F]{4})/)) {
		            return parseUnicodeSurrogatePairEscape(createEscaped('unicodeEscape', parseInt(res[1], 16), res[1], 2));
		          } else if (isUnicodeMode && (res = matchReg(/^u\{([0-9a-fA-F]+)\}/))) {
		            return createEscaped('unicodeCodePointEscape', parseInt(res[1], 16), res[1], 4);
		          }
		        }
		        function parseCharacterEscape() {
		          var res;
		          var from = pos;
		          if (res = matchReg(/^[fnrtv]/)) {
		            var codePoint = 0;
		            switch (res[0]) {
		              case 't':
		                codePoint = 0x009;
		                break;
		              case 'n':
		                codePoint = 0x00A;
		                break;
		              case 'v':
		                codePoint = 0x00B;
		                break;
		              case 'f':
		                codePoint = 0x00C;
		                break;
		              case 'r':
		                codePoint = 0x00D;
		                break;
		            }
		            return createEscaped('singleEscape', codePoint, '\\' + res[0]);
		          } else if (res = matchReg(/^c([a-zA-Z])/)) {
		            return createEscaped('controlLetter', res[1].charCodeAt(0) % 32, res[1], 2);
		          } else if (res = matchReg(/^x([0-9a-fA-F]{2})/)) {
		            return createEscaped('hexadecimalEscape', parseInt(res[1], 16), res[1], 2);
		          } else if (res = parseRegExpUnicodeEscapeSequence()) {
		            if (!res || res.codePoint > 0x10FFFF) {
		              bail('Invalid escape sequence', null, from, pos);
		            }
		            return res;
		          } else {
		            return parseIdentityEscape();
		          }
		        }
		        function parseIdentifierAtom(check) {
		          var ch = lookahead();
		          var from = pos;
		          if (ch === '\\') {
		            incr();
		            var esc = parseRegExpUnicodeEscapeSequence();
		            if (!esc || !check(esc.codePoint)) {
		              bail('Invalid escape sequence', null, from, pos);
		            }
		            return fromCodePoint(esc.codePoint);
		          }
		          var code = ch.charCodeAt(0);
		          if (code >= 0xD800 && code <= 0xDBFF) {
		            ch += str[pos + 1];
		            var second = ch.charCodeAt(1);
		            if (second >= 0xDC00 && second <= 0xDFFF) {
		              code = (code - 0xD800) * 0x400 + second - 0xDC00 + 0x10000;
		            }
		          }
		          if (!check(code)) return;
		          incr();
		          if (code > 0xFFFF) incr();
		          return ch;
		        }
		        function parseIdentifier() {
		          var start = pos;
		          var res = parseIdentifierAtom(isIdentifierStart);
		          if (!res) {
		            bail('Invalid identifier');
		          }
		          var ch;
		          while (ch = parseIdentifierAtom(isIdentifierPart)) {
		            res += ch;
		          }
		          return addRaw({
		            type: 'identifier',
		            value: res,
		            range: [start, pos]
		          });
		        }
		        function isIdentifierStart(ch) {
		          var NonAsciiIdentifierStart = /[\$A-Z_a-z\xAA\xB5\xBA\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07CA-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08BD\u0904-\u0939\u093D\u0950\u0958-\u0961\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09F0\u09F1\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B71\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CF1\u0CF2\u0D05-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D5F-\u0D61\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E81\u0E82\u0E84\u0E87\u0E88\u0E8A\u0E8D\u0E94-\u0E97\u0E99-\u0E9F\u0EA1-\u0EA3\u0EA5\u0EA7\u0EAA\u0EAB\u0EAD-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0EDC-\u0EDF\u0F00\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u1820-\u1878\u1880-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1950-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u1A00-\u1A16\u1A20-\u1A54\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B83-\u1BA0\u1BAE\u1BAF\u1BBA-\u1BE5\u1C00-\u1C23\u1C4D-\u1C4F\u1C5A-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF1\u1CF5\u1CF6\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2071\u207F\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2118-\u211D\u2124\u2126\u2128\u212A-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2160-\u2188\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309B-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u31A0-\u31BA\u31F0-\u31FF\u3400-\u4DB5\u4E00-\u9FEF\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA61F\uA62A\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7B9\uA7F7-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA840-\uA873\uA882-\uA8B3\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA90A-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF\uA9E0-\uA9E4\uA9E6-\uA9EF\uA9FA-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB65\uAB70-\uABE2\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD40-\uDD74\uDE80-\uDE9C\uDEA0-\uDED0\uDF00-\uDF1F\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC60-\uDC76\uDC80-\uDC9E\uDCE0-\uDCF2\uDCF4\uDCF5\uDD00-\uDD15\uDD20-\uDD39\uDD80-\uDDB7\uDDBE\uDDBF\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE60-\uDE7C\uDE80-\uDE9C\uDEC0-\uDEC7\uDEC9-\uDEE4\uDF00-\uDF35\uDF40-\uDF55\uDF60-\uDF72\uDF80-\uDF91]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDD00-\uDD23\uDF00-\uDF1C\uDF27\uDF30-\uDF45]|\uD804[\uDC03-\uDC37\uDC83-\uDCAF\uDCD0-\uDCE8\uDD03-\uDD26\uDD44\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDDA\uDDDC\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE80-\uDEAA\uDF00-\uDF1A]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCDF\uDCFF\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE83\uDE86-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDEE0-\uDEF2]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE7F\uDF00-\uDF44\uDF50\uDF93-\uDF9F\uDFE0\uDFE1]|\uD821[\uDC00-\uDFF1]|\uD822[\uDC00-\uDEF2]|\uD82C[\uDC00-\uDD1E\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB]|\uD83A[\uDC00-\uDCC4\uDD00-\uDD43]|\uD83B[\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD869[\uDC00-\uDED6\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]/;
		          return ch === 36 || ch === 95 || ch >= 65 && ch <= 90 || ch >= 97 && ch <= 122 || ch >= 0x80 && NonAsciiIdentifierStart.test(fromCodePoint(ch));
		        }
		        function isIdentifierPart(ch) {
		          var NonAsciiIdentifierPartOnly = /[0-9_\xB7\u0300-\u036F\u0387\u0483-\u0487\u0591-\u05BD\u05BF\u05C1\u05C2\u05C4\u05C5\u05C7\u0610-\u061A\u064B-\u0669\u0670\u06D6-\u06DC\u06DF-\u06E4\u06E7\u06E8\u06EA-\u06ED\u06F0-\u06F9\u0711\u0730-\u074A\u07A6-\u07B0\u07C0-\u07C9\u07EB-\u07F3\u07FD\u0816-\u0819\u081B-\u0823\u0825-\u0827\u0829-\u082D\u0859-\u085B\u08D3-\u08E1\u08E3-\u0903\u093A-\u093C\u093E-\u094F\u0951-\u0957\u0962\u0963\u0966-\u096F\u0981-\u0983\u09BC\u09BE-\u09C4\u09C7\u09C8\u09CB-\u09CD\u09D7\u09E2\u09E3\u09E6-\u09EF\u09FE\u0A01-\u0A03\u0A3C\u0A3E-\u0A42\u0A47\u0A48\u0A4B-\u0A4D\u0A51\u0A66-\u0A71\u0A75\u0A81-\u0A83\u0ABC\u0ABE-\u0AC5\u0AC7-\u0AC9\u0ACB-\u0ACD\u0AE2\u0AE3\u0AE6-\u0AEF\u0AFA-\u0AFF\u0B01-\u0B03\u0B3C\u0B3E-\u0B44\u0B47\u0B48\u0B4B-\u0B4D\u0B56\u0B57\u0B62\u0B63\u0B66-\u0B6F\u0B82\u0BBE-\u0BC2\u0BC6-\u0BC8\u0BCA-\u0BCD\u0BD7\u0BE6-\u0BEF\u0C00-\u0C04\u0C3E-\u0C44\u0C46-\u0C48\u0C4A-\u0C4D\u0C55\u0C56\u0C62\u0C63\u0C66-\u0C6F\u0C81-\u0C83\u0CBC\u0CBE-\u0CC4\u0CC6-\u0CC8\u0CCA-\u0CCD\u0CD5\u0CD6\u0CE2\u0CE3\u0CE6-\u0CEF\u0D00-\u0D03\u0D3B\u0D3C\u0D3E-\u0D44\u0D46-\u0D48\u0D4A-\u0D4D\u0D57\u0D62\u0D63\u0D66-\u0D6F\u0D82\u0D83\u0DCA\u0DCF-\u0DD4\u0DD6\u0DD8-\u0DDF\u0DE6-\u0DEF\u0DF2\u0DF3\u0E31\u0E34-\u0E3A\u0E47-\u0E4E\u0E50-\u0E59\u0EB1\u0EB4-\u0EB9\u0EBB\u0EBC\u0EC8-\u0ECD\u0ED0-\u0ED9\u0F18\u0F19\u0F20-\u0F29\u0F35\u0F37\u0F39\u0F3E\u0F3F\u0F71-\u0F84\u0F86\u0F87\u0F8D-\u0F97\u0F99-\u0FBC\u0FC6\u102B-\u103E\u1040-\u1049\u1056-\u1059\u105E-\u1060\u1062-\u1064\u1067-\u106D\u1071-\u1074\u1082-\u108D\u108F-\u109D\u135D-\u135F\u1369-\u1371\u1712-\u1714\u1732-\u1734\u1752\u1753\u1772\u1773\u17B4-\u17D3\u17DD\u17E0-\u17E9\u180B-\u180D\u1810-\u1819\u18A9\u1920-\u192B\u1930-\u193B\u1946-\u194F\u19D0-\u19DA\u1A17-\u1A1B\u1A55-\u1A5E\u1A60-\u1A7C\u1A7F-\u1A89\u1A90-\u1A99\u1AB0-\u1ABD\u1B00-\u1B04\u1B34-\u1B44\u1B50-\u1B59\u1B6B-\u1B73\u1B80-\u1B82\u1BA1-\u1BAD\u1BB0-\u1BB9\u1BE6-\u1BF3\u1C24-\u1C37\u1C40-\u1C49\u1C50-\u1C59\u1CD0-\u1CD2\u1CD4-\u1CE8\u1CED\u1CF2-\u1CF4\u1CF7-\u1CF9\u1DC0-\u1DF9\u1DFB-\u1DFF\u200C\u200D\u203F\u2040\u2054\u20D0-\u20DC\u20E1\u20E5-\u20F0\u2CEF-\u2CF1\u2D7F\u2DE0-\u2DFF\u302A-\u302F\u3099\u309A\uA620-\uA629\uA66F\uA674-\uA67D\uA69E\uA69F\uA6F0\uA6F1\uA802\uA806\uA80B\uA823-\uA827\uA880\uA881\uA8B4-\uA8C5\uA8D0-\uA8D9\uA8E0-\uA8F1\uA8FF-\uA909\uA926-\uA92D\uA947-\uA953\uA980-\uA983\uA9B3-\uA9C0\uA9D0-\uA9D9\uA9E5\uA9F0-\uA9F9\uAA29-\uAA36\uAA43\uAA4C\uAA4D\uAA50-\uAA59\uAA7B-\uAA7D\uAAB0\uAAB2-\uAAB4\uAAB7\uAAB8\uAABE\uAABF\uAAC1\uAAEB-\uAAEF\uAAF5\uAAF6\uABE3-\uABEA\uABEC\uABED\uABF0-\uABF9\uFB1E\uFE00-\uFE0F\uFE20-\uFE2F\uFE33\uFE34\uFE4D-\uFE4F\uFF10-\uFF19\uFF3F]|\uD800[\uDDFD\uDEE0\uDF76-\uDF7A]|\uD801[\uDCA0-\uDCA9]|\uD802[\uDE01-\uDE03\uDE05\uDE06\uDE0C-\uDE0F\uDE38-\uDE3A\uDE3F\uDEE5\uDEE6]|\uD803[\uDD24-\uDD27\uDD30-\uDD39\uDF46-\uDF50]|\uD804[\uDC00-\uDC02\uDC38-\uDC46\uDC66-\uDC6F\uDC7F-\uDC82\uDCB0-\uDCBA\uDCF0-\uDCF9\uDD00-\uDD02\uDD27-\uDD34\uDD36-\uDD3F\uDD45\uDD46\uDD73\uDD80-\uDD82\uDDB3-\uDDC0\uDDC9-\uDDCC\uDDD0-\uDDD9\uDE2C-\uDE37\uDE3E\uDEDF-\uDEEA\uDEF0-\uDEF9\uDF00-\uDF03\uDF3B\uDF3C\uDF3E-\uDF44\uDF47\uDF48\uDF4B-\uDF4D\uDF57\uDF62\uDF63\uDF66-\uDF6C\uDF70-\uDF74]|\uD805[\uDC35-\uDC46\uDC50-\uDC59\uDC5E\uDCB0-\uDCC3\uDCD0-\uDCD9\uDDAF-\uDDB5\uDDB8-\uDDC0\uDDDC\uDDDD\uDE30-\uDE40\uDE50-\uDE59\uDEAB-\uDEB7\uDEC0-\uDEC9\uDF1D-\uDF2B\uDF30-\uDF39]|\uD806[\uDC2C-\uDC3A\uDCE0-\uDCE9\uDE01-\uDE0A\uDE33-\uDE39\uDE3B-\uDE3E\uDE47\uDE51-\uDE5B\uDE8A-\uDE99]|\uD807[\uDC2F-\uDC36\uDC38-\uDC3F\uDC50-\uDC59\uDC92-\uDCA7\uDCA9-\uDCB6\uDD31-\uDD36\uDD3A\uDD3C\uDD3D\uDD3F-\uDD45\uDD47\uDD50-\uDD59\uDD8A-\uDD8E\uDD90\uDD91\uDD93-\uDD97\uDDA0-\uDDA9\uDEF3-\uDEF6]|\uD81A[\uDE60-\uDE69\uDEF0-\uDEF4\uDF30-\uDF36\uDF50-\uDF59]|\uD81B[\uDF51-\uDF7E\uDF8F-\uDF92]|\uD82F[\uDC9D\uDC9E]|\uD834[\uDD65-\uDD69\uDD6D-\uDD72\uDD7B-\uDD82\uDD85-\uDD8B\uDDAA-\uDDAD\uDE42-\uDE44]|\uD835[\uDFCE-\uDFFF]|\uD836[\uDE00-\uDE36\uDE3B-\uDE6C\uDE75\uDE84\uDE9B-\uDE9F\uDEA1-\uDEAF]|\uD838[\uDC00-\uDC06\uDC08-\uDC18\uDC1B-\uDC21\uDC23\uDC24\uDC26-\uDC2A]|\uD83A[\uDCD0-\uDCD6\uDD44-\uDD4A\uDD50-\uDD59]|\uDB40[\uDD00-\uDDEF]/;
		          return isIdentifierStart(ch) || ch >= 48 && ch <= 57 || ch >= 0x80 && NonAsciiIdentifierPartOnly.test(fromCodePoint(ch));
		        }
		        function parseIdentityEscape() {
		          var tmp;
		          var l = lookahead();
		          if (isUnicodeMode && /[\^\$\.\*\+\?\(\)\\\[\]\{\}\|\/]/.test(l) || !isUnicodeMode && l !== "c") {
		            if (l === "k" && features.lookbehind) {
		              return null;
		            }
		            tmp = incr();
		            return createEscaped('identifier', tmp.charCodeAt(0), tmp, 1);
		          }
		          return null;
		        }
		        function parseCharacterClass() {
		          var res,
		            from = pos;
		          if (res = matchReg(/^\[\^/)) {
		            res = parseClassRanges();
		            skip(']');
		            return createCharacterClass(res, true, from, pos);
		          } else if (match('[')) {
		            res = parseClassRanges();
		            skip(']');
		            return createCharacterClass(res, false, from, pos);
		          }
		          return null;
		        }
		        function parseClassRanges() {
		          var res;
		          if (current(']')) {
		            return {
		              kind: 'union',
		              body: []
		            };
		          } else if (hasUnicodeSetFlag) {
		            return parseClassContents();
		          } else {
		            res = parseNonemptyClassRanges();
		            if (!res) {
		              bail('nonEmptyClassRanges');
		            }
		            return {
		              kind: 'union',
		              body: res
		            };
		          }
		        }
		        function parseHelperClassRanges(atom) {
		          var from, to, res, atomTo, dash;
		          if (current('-') && !next(']')) {
		            from = atom.range[0];
		            dash = createCharacter(match('-'));
		            atomTo = parseClassAtom();
		            if (!atomTo) {
		              bail('classAtom');
		            }
		            to = pos;
		            var classRanges = parseClassRanges();
		            if (!classRanges) {
		              bail('classRanges');
		            }
		            if (!('codePoint' in atom) || !('codePoint' in atomTo)) {
		              if (!isUnicodeMode) {
		                res = [atom, dash, atomTo];
		              } else {
		                bail('invalid character class');
		              }
		            } else {
		              res = [createClassRange(atom, atomTo, from, to)];
		            }
		            if (classRanges.type === 'empty') {
		              return res;
		            }
		            return res.concat(classRanges.body);
		          }
		          res = parseNonemptyClassRangesNoDash();
		          if (!res) {
		            bail('nonEmptyClassRangesNoDash');
		          }
		          return [atom].concat(res);
		        }
		        function parseNonemptyClassRanges() {
		          var atom = parseClassAtom();
		          if (!atom) {
		            bail('classAtom');
		          }
		          if (current(']')) {
		            return [atom];
		          }
		          return parseHelperClassRanges(atom);
		        }
		        function parseNonemptyClassRangesNoDash() {
		          var res = parseClassAtom();
		          if (!res) {
		            bail('classAtom');
		          }
		          if (current(']')) {
		            return res;
		          }
		          return parseHelperClassRanges(res);
		        }
		        function parseClassAtom() {
		          if (match('-')) {
		            return createCharacter('-');
		          } else {
		            return parseClassAtomNoDash();
		          }
		        }
		        function parseClassAtomNoDash() {
		          var res;
		          if (res = matchReg(/^[^\\\]-]/)) {
		            return createCharacter(res[0]);
		          } else if (match('\\')) {
		            res = parseClassEscape();
		            if (!res) {
		              bail('classEscape');
		            }
		            return parseUnicodeSurrogatePairEscape(res);
		          }
		        }
		        function parseClassContents() {
		          var body = [];
		          var kind;
		          var operand = parseClassOperand(true);
		          body.push(operand);
		          if (operand.type === 'classRange') {
		            kind = 'union';
		          } else if (current('&')) {
		            kind = 'intersection';
		          } else if (current('-')) {
		            kind = 'subtraction';
		          } else {
		            kind = 'union';
		          }
		          while (!current(']')) {
		            if (kind === 'intersection') {
		              skip('&');
		              skip('&');
		              if (current('&')) {
		                bail('&& cannot be followed by &. Wrap it in brackets: &&[&].');
		              }
		            } else if (kind === 'subtraction') {
		              skip('-');
		              skip('-');
		            }
		            operand = parseClassOperand(kind === 'union');
		            body.push(operand);
		          }
		          return {
		            kind: kind,
		            body: body
		          };
		        }
		        function parseClassOperand(allowRanges) {
		          var from = pos;
		          var start, res;
		          if (match('\\')) {
		            if (res = parseClassEscape()) {
		              start = res;
		            } else if (res = parseClassCharacterEscapedHelper()) {
		              return res;
		            } else {
		              bail('Invalid escape', '\\' + lookahead(), from);
		            }
		          } else if (res = parseClassCharacterUnescapedHelper()) {
		            start = res;
		          } else if (res = parseCharacterClass()) {
		            return res;
		          } else {
		            bail('Invalid character', lookahead());
		          }
		          if (allowRanges && current('-') && !next('-')) {
		            skip('-');
		            if (res = parseClassCharacter()) {
		              return createClassRange(start, res, from, pos);
		            }
		            bail('Invalid range end', lookahead());
		          }
		          return start;
		        }
		        function parseClassCharacter() {
		          if (match('\\')) {
		            var res,
		              from = pos;
		            if (res = parseClassCharacterEscapedHelper()) {
		              return res;
		            } else {
		              bail('Invalid escape', '\\' + lookahead(), from);
		            }
		          }
		          return parseClassCharacterUnescapedHelper();
		        }
		        function parseClassCharacterUnescapedHelper() {
		          var res;
		          if (res = matchReg(/^[^()[\]{}/\-\\|]/)) {
		            return createCharacter(res);
		          }
		        }
		        function parseClassCharacterEscapedHelper() {
		          var res;
		          if (match('b')) {
		            return createEscaped('singleEscape', 0x0008, '\\b');
		          } else if (match('B')) {
		            bail('\\B not possible inside of ClassContents', '', pos - 2);
		          } else if (res = matchReg(/^[&\-!#%,:;<=>@_`~]/)) {
		            return createEscaped('identifier', res[0].codePointAt(0), res[0]);
		          } else if (res = parseCharacterEscape()) {
		            return res;
		          } else {
		            return null;
		          }
		        }
		        function parseClassStrings() {
		          var from = pos - 3;
		          var res = [];
		          do {
		            res.push(parseClassString());
		          } while (match('|'));
		          skip('}');
		          return createClassStrings(res, from, pos);
		        }
		        function parseClassString() {
		          var res = [],
		            from = pos;
		          var _char2;
		          while (_char2 = parseClassCharacter()) {
		            res.push(_char2);
		          }
		          return createClassString(res, from, pos);
		        }
		        function bail(message, details, from, to) {
		          from = from == null ? pos : from;
		          to = to == null ? from : to;
		          var contextStart = Math.max(0, from - 10);
		          var contextEnd = Math.min(to + 10, str.length);
		          var context = '    ' + str.substring(contextStart, contextEnd);
		          var pointer = '    ' + new Array(from - contextStart + 1).join(' ') + '^';
		          throw SyntaxError(message + ' at position ' + from + (details ? ': ' + details : '') + '\n' + context + '\n' + pointer);
		        }
		        var backrefDenied = [];
		        var closedCaptureCounter = 0;
		        var firstIteration = true;
		        var shouldReparse = false;
		        var hasUnicodeFlag = (flags || "").indexOf("u") !== -1;
		        var hasUnicodeSetFlag = (flags || "").indexOf("v") !== -1;
		        var isUnicodeMode = hasUnicodeFlag || hasUnicodeSetFlag;
		        var pos = 0;
		        if (hasUnicodeSetFlag && !features.unicodeSet) {
		          throw new Error('The "v" flag is only supported when the .unicodeSet option is enabled.');
		        }
		        if (hasUnicodeFlag && hasUnicodeSetFlag) {
		          throw new Error('The "u" and "v" flags are mutually exclusive.');
		        }
		        str = String(str);
		        if (str === '') {
		          str = '(?:)';
		        }
		        var result = parseDisjunction();
		        if (result.range[1] !== str.length) {
		          bail('Could not parse entire input - got stuck', '', result.range[1]);
		        }
		        shouldReparse = shouldReparse || backrefDenied.some(function (ref) {
		          return ref <= closedCaptureCounter;
		        });
		        if (shouldReparse) {
		          pos = 0;
		          firstIteration = false;
		          return parseDisjunction();
		        }
		        return result;
		      }
		      var regjsparser = {
		        parse: parse
		      };
		      if (module.exports) {
		        module.exports = regjsparser;
		      } else {
		        window.regjsparser = regjsparser;
		      }
		    })();
		  })(parser);
		  var parserExports = parser.exports;

		  var unicodeCanonicalPropertyNamesEcmascript = new Set(['General_Category', 'Script', 'Script_Extensions', 'Alphabetic', 'Any', 'ASCII', 'ASCII_Hex_Digit', 'Assigned', 'Bidi_Control', 'Bidi_Mirrored', 'Case_Ignorable', 'Cased', 'Changes_When_Casefolded', 'Changes_When_Casemapped', 'Changes_When_Lowercased', 'Changes_When_NFKC_Casefolded', 'Changes_When_Titlecased', 'Changes_When_Uppercased', 'Dash', 'Default_Ignorable_Code_Point', 'Deprecated', 'Diacritic', 'Emoji', 'Emoji_Component', 'Emoji_Modifier', 'Emoji_Modifier_Base', 'Emoji_Presentation', 'Extended_Pictographic', 'Extender', 'Grapheme_Base', 'Grapheme_Extend', 'Hex_Digit', 'ID_Continue', 'ID_Start', 'Ideographic', 'IDS_Binary_Operator', 'IDS_Trinary_Operator', 'Join_Control', 'Logical_Order_Exception', 'Lowercase', 'Math', 'Noncharacter_Code_Point', 'Pattern_Syntax', 'Pattern_White_Space', 'Quotation_Mark', 'Radical', 'Regional_Indicator', 'Sentence_Terminal', 'Soft_Dotted', 'Terminal_Punctuation', 'Unified_Ideograph', 'Uppercase', 'Variation_Selector', 'White_Space', 'XID_Continue', 'XID_Start']);

		  var unicodePropertyAliasesEcmascript = new Map([['scx', 'Script_Extensions'], ['sc', 'Script'], ['gc', 'General_Category'], ['AHex', 'ASCII_Hex_Digit'], ['Alpha', 'Alphabetic'], ['Bidi_C', 'Bidi_Control'], ['Bidi_M', 'Bidi_Mirrored'], ['Cased', 'Cased'], ['CI', 'Case_Ignorable'], ['CWCF', 'Changes_When_Casefolded'], ['CWCM', 'Changes_When_Casemapped'], ['CWKCF', 'Changes_When_NFKC_Casefolded'], ['CWL', 'Changes_When_Lowercased'], ['CWT', 'Changes_When_Titlecased'], ['CWU', 'Changes_When_Uppercased'], ['Dash', 'Dash'], ['Dep', 'Deprecated'], ['DI', 'Default_Ignorable_Code_Point'], ['Dia', 'Diacritic'], ['EBase', 'Emoji_Modifier_Base'], ['EComp', 'Emoji_Component'], ['EMod', 'Emoji_Modifier'], ['Emoji', 'Emoji'], ['EPres', 'Emoji_Presentation'], ['Ext', 'Extender'], ['ExtPict', 'Extended_Pictographic'], ['Gr_Base', 'Grapheme_Base'], ['Gr_Ext', 'Grapheme_Extend'], ['Hex', 'Hex_Digit'], ['IDC', 'ID_Continue'], ['Ideo', 'Ideographic'], ['IDS', 'ID_Start'], ['IDSB', 'IDS_Binary_Operator'], ['IDST', 'IDS_Trinary_Operator'], ['Join_C', 'Join_Control'], ['LOE', 'Logical_Order_Exception'], ['Lower', 'Lowercase'], ['Math', 'Math'], ['NChar', 'Noncharacter_Code_Point'], ['Pat_Syn', 'Pattern_Syntax'], ['Pat_WS', 'Pattern_White_Space'], ['QMark', 'Quotation_Mark'], ['Radical', 'Radical'], ['RI', 'Regional_Indicator'], ['SD', 'Soft_Dotted'], ['STerm', 'Sentence_Terminal'], ['Term', 'Terminal_Punctuation'], ['UIdeo', 'Unified_Ideograph'], ['Upper', 'Uppercase'], ['VS', 'Variation_Selector'], ['WSpace', 'White_Space'], ['space', 'White_Space'], ['XIDC', 'XID_Continue'], ['XIDS', 'XID_Start']]);

		  var canonicalProperties = unicodeCanonicalPropertyNamesEcmascript;
		  var propertyAliases = unicodePropertyAliasesEcmascript;
		  var matchProperty = function matchProperty(property) {
		    if (canonicalProperties.has(property)) {
		      return property;
		    }
		    if (propertyAliases.has(property)) {
		      return propertyAliases.get(property);
		    }
		    throw new Error("Unknown property: " + property);
		  };
		  var unicodeMatchPropertyEcmascript = matchProperty;

		  var mappings = new Map([['General_Category', new Map([['C', 'Other'], ['Cc', 'Control'], ['cntrl', 'Control'], ['Cf', 'Format'], ['Cn', 'Unassigned'], ['Co', 'Private_Use'], ['Cs', 'Surrogate'], ['L', 'Letter'], ['LC', 'Cased_Letter'], ['Ll', 'Lowercase_Letter'], ['Lm', 'Modifier_Letter'], ['Lo', 'Other_Letter'], ['Lt', 'Titlecase_Letter'], ['Lu', 'Uppercase_Letter'], ['M', 'Mark'], ['Combining_Mark', 'Mark'], ['Mc', 'Spacing_Mark'], ['Me', 'Enclosing_Mark'], ['Mn', 'Nonspacing_Mark'], ['N', 'Number'], ['Nd', 'Decimal_Number'], ['digit', 'Decimal_Number'], ['Nl', 'Letter_Number'], ['No', 'Other_Number'], ['P', 'Punctuation'], ['punct', 'Punctuation'], ['Pc', 'Connector_Punctuation'], ['Pd', 'Dash_Punctuation'], ['Pe', 'Close_Punctuation'], ['Pf', 'Final_Punctuation'], ['Pi', 'Initial_Punctuation'], ['Po', 'Other_Punctuation'], ['Ps', 'Open_Punctuation'], ['S', 'Symbol'], ['Sc', 'Currency_Symbol'], ['Sk', 'Modifier_Symbol'], ['Sm', 'Math_Symbol'], ['So', 'Other_Symbol'], ['Z', 'Separator'], ['Zl', 'Line_Separator'], ['Zp', 'Paragraph_Separator'], ['Zs', 'Space_Separator'], ['Other', 'Other'], ['Control', 'Control'], ['Format', 'Format'], ['Unassigned', 'Unassigned'], ['Private_Use', 'Private_Use'], ['Surrogate', 'Surrogate'], ['Letter', 'Letter'], ['Cased_Letter', 'Cased_Letter'], ['Lowercase_Letter', 'Lowercase_Letter'], ['Modifier_Letter', 'Modifier_Letter'], ['Other_Letter', 'Other_Letter'], ['Titlecase_Letter', 'Titlecase_Letter'], ['Uppercase_Letter', 'Uppercase_Letter'], ['Mark', 'Mark'], ['Spacing_Mark', 'Spacing_Mark'], ['Enclosing_Mark', 'Enclosing_Mark'], ['Nonspacing_Mark', 'Nonspacing_Mark'], ['Number', 'Number'], ['Decimal_Number', 'Decimal_Number'], ['Letter_Number', 'Letter_Number'], ['Other_Number', 'Other_Number'], ['Punctuation', 'Punctuation'], ['Connector_Punctuation', 'Connector_Punctuation'], ['Dash_Punctuation', 'Dash_Punctuation'], ['Close_Punctuation', 'Close_Punctuation'], ['Final_Punctuation', 'Final_Punctuation'], ['Initial_Punctuation', 'Initial_Punctuation'], ['Other_Punctuation', 'Other_Punctuation'], ['Open_Punctuation', 'Open_Punctuation'], ['Symbol', 'Symbol'], ['Currency_Symbol', 'Currency_Symbol'], ['Modifier_Symbol', 'Modifier_Symbol'], ['Math_Symbol', 'Math_Symbol'], ['Other_Symbol', 'Other_Symbol'], ['Separator', 'Separator'], ['Line_Separator', 'Line_Separator'], ['Paragraph_Separator', 'Paragraph_Separator'], ['Space_Separator', 'Space_Separator']])], ['Script', new Map([['Adlm', 'Adlam'], ['Aghb', 'Caucasian_Albanian'], ['Ahom', 'Ahom'], ['Arab', 'Arabic'], ['Armi', 'Imperial_Aramaic'], ['Armn', 'Armenian'], ['Avst', 'Avestan'], ['Bali', 'Balinese'], ['Bamu', 'Bamum'], ['Bass', 'Bassa_Vah'], ['Batk', 'Batak'], ['Beng', 'Bengali'], ['Bhks', 'Bhaiksuki'], ['Bopo', 'Bopomofo'], ['Brah', 'Brahmi'], ['Brai', 'Braille'], ['Bugi', 'Buginese'], ['Buhd', 'Buhid'], ['Cakm', 'Chakma'], ['Cans', 'Canadian_Aboriginal'], ['Cari', 'Carian'], ['Cham', 'Cham'], ['Cher', 'Cherokee'], ['Chrs', 'Chorasmian'], ['Copt', 'Coptic'], ['Qaac', 'Coptic'], ['Cpmn', 'Cypro_Minoan'], ['Cprt', 'Cypriot'], ['Cyrl', 'Cyrillic'], ['Deva', 'Devanagari'], ['Diak', 'Dives_Akuru'], ['Dogr', 'Dogra'], ['Dsrt', 'Deseret'], ['Dupl', 'Duployan'], ['Egyp', 'Egyptian_Hieroglyphs'], ['Elba', 'Elbasan'], ['Elym', 'Elymaic'], ['Ethi', 'Ethiopic'], ['Geor', 'Georgian'], ['Glag', 'Glagolitic'], ['Gong', 'Gunjala_Gondi'], ['Gonm', 'Masaram_Gondi'], ['Goth', 'Gothic'], ['Gran', 'Grantha'], ['Grek', 'Greek'], ['Gujr', 'Gujarati'], ['Guru', 'Gurmukhi'], ['Hang', 'Hangul'], ['Hani', 'Han'], ['Hano', 'Hanunoo'], ['Hatr', 'Hatran'], ['Hebr', 'Hebrew'], ['Hira', 'Hiragana'], ['Hluw', 'Anatolian_Hieroglyphs'], ['Hmng', 'Pahawh_Hmong'], ['Hmnp', 'Nyiakeng_Puachue_Hmong'], ['Hrkt', 'Katakana_Or_Hiragana'], ['Hung', 'Old_Hungarian'], ['Ital', 'Old_Italic'], ['Java', 'Javanese'], ['Kali', 'Kayah_Li'], ['Kana', 'Katakana'], ['Kawi', 'Kawi'], ['Khar', 'Kharoshthi'], ['Khmr', 'Khmer'], ['Khoj', 'Khojki'], ['Kits', 'Khitan_Small_Script'], ['Knda', 'Kannada'], ['Kthi', 'Kaithi'], ['Lana', 'Tai_Tham'], ['Laoo', 'Lao'], ['Latn', 'Latin'], ['Lepc', 'Lepcha'], ['Limb', 'Limbu'], ['Lina', 'Linear_A'], ['Linb', 'Linear_B'], ['Lisu', 'Lisu'], ['Lyci', 'Lycian'], ['Lydi', 'Lydian'], ['Mahj', 'Mahajani'], ['Maka', 'Makasar'], ['Mand', 'Mandaic'], ['Mani', 'Manichaean'], ['Marc', 'Marchen'], ['Medf', 'Medefaidrin'], ['Mend', 'Mende_Kikakui'], ['Merc', 'Meroitic_Cursive'], ['Mero', 'Meroitic_Hieroglyphs'], ['Mlym', 'Malayalam'], ['Modi', 'Modi'], ['Mong', 'Mongolian'], ['Mroo', 'Mro'], ['Mtei', 'Meetei_Mayek'], ['Mult', 'Multani'], ['Mymr', 'Myanmar'], ['Nagm', 'Nag_Mundari'], ['Nand', 'Nandinagari'], ['Narb', 'Old_North_Arabian'], ['Nbat', 'Nabataean'], ['Newa', 'Newa'], ['Nkoo', 'Nko'], ['Nshu', 'Nushu'], ['Ogam', 'Ogham'], ['Olck', 'Ol_Chiki'], ['Orkh', 'Old_Turkic'], ['Orya', 'Oriya'], ['Osge', 'Osage'], ['Osma', 'Osmanya'], ['Ougr', 'Old_Uyghur'], ['Palm', 'Palmyrene'], ['Pauc', 'Pau_Cin_Hau'], ['Perm', 'Old_Permic'], ['Phag', 'Phags_Pa'], ['Phli', 'Inscriptional_Pahlavi'], ['Phlp', 'Psalter_Pahlavi'], ['Phnx', 'Phoenician'], ['Plrd', 'Miao'], ['Prti', 'Inscriptional_Parthian'], ['Rjng', 'Rejang'], ['Rohg', 'Hanifi_Rohingya'], ['Runr', 'Runic'], ['Samr', 'Samaritan'], ['Sarb', 'Old_South_Arabian'], ['Saur', 'Saurashtra'], ['Sgnw', 'SignWriting'], ['Shaw', 'Shavian'], ['Shrd', 'Sharada'], ['Sidd', 'Siddham'], ['Sind', 'Khudawadi'], ['Sinh', 'Sinhala'], ['Sogd', 'Sogdian'], ['Sogo', 'Old_Sogdian'], ['Sora', 'Sora_Sompeng'], ['Soyo', 'Soyombo'], ['Sund', 'Sundanese'], ['Sylo', 'Syloti_Nagri'], ['Syrc', 'Syriac'], ['Tagb', 'Tagbanwa'], ['Takr', 'Takri'], ['Tale', 'Tai_Le'], ['Talu', 'New_Tai_Lue'], ['Taml', 'Tamil'], ['Tang', 'Tangut'], ['Tavt', 'Tai_Viet'], ['Telu', 'Telugu'], ['Tfng', 'Tifinagh'], ['Tglg', 'Tagalog'], ['Thaa', 'Thaana'], ['Thai', 'Thai'], ['Tibt', 'Tibetan'], ['Tirh', 'Tirhuta'], ['Tnsa', 'Tangsa'], ['Toto', 'Toto'], ['Ugar', 'Ugaritic'], ['Vaii', 'Vai'], ['Vith', 'Vithkuqi'], ['Wara', 'Warang_Citi'], ['Wcho', 'Wancho'], ['Xpeo', 'Old_Persian'], ['Xsux', 'Cuneiform'], ['Yezi', 'Yezidi'], ['Yiii', 'Yi'], ['Zanb', 'Zanabazar_Square'], ['Zinh', 'Inherited'], ['Qaai', 'Inherited'], ['Zyyy', 'Common'], ['Zzzz', 'Unknown'], ['Adlam', 'Adlam'], ['Caucasian_Albanian', 'Caucasian_Albanian'], ['Arabic', 'Arabic'], ['Imperial_Aramaic', 'Imperial_Aramaic'], ['Armenian', 'Armenian'], ['Avestan', 'Avestan'], ['Balinese', 'Balinese'], ['Bamum', 'Bamum'], ['Bassa_Vah', 'Bassa_Vah'], ['Batak', 'Batak'], ['Bengali', 'Bengali'], ['Bhaiksuki', 'Bhaiksuki'], ['Bopomofo', 'Bopomofo'], ['Brahmi', 'Brahmi'], ['Braille', 'Braille'], ['Buginese', 'Buginese'], ['Buhid', 'Buhid'], ['Chakma', 'Chakma'], ['Canadian_Aboriginal', 'Canadian_Aboriginal'], ['Carian', 'Carian'], ['Cherokee', 'Cherokee'], ['Chorasmian', 'Chorasmian'], ['Coptic', 'Coptic'], ['Cypro_Minoan', 'Cypro_Minoan'], ['Cypriot', 'Cypriot'], ['Cyrillic', 'Cyrillic'], ['Devanagari', 'Devanagari'], ['Dives_Akuru', 'Dives_Akuru'], ['Dogra', 'Dogra'], ['Deseret', 'Deseret'], ['Duployan', 'Duployan'], ['Egyptian_Hieroglyphs', 'Egyptian_Hieroglyphs'], ['Elbasan', 'Elbasan'], ['Elymaic', 'Elymaic'], ['Ethiopic', 'Ethiopic'], ['Georgian', 'Georgian'], ['Glagolitic', 'Glagolitic'], ['Gunjala_Gondi', 'Gunjala_Gondi'], ['Masaram_Gondi', 'Masaram_Gondi'], ['Gothic', 'Gothic'], ['Grantha', 'Grantha'], ['Greek', 'Greek'], ['Gujarati', 'Gujarati'], ['Gurmukhi', 'Gurmukhi'], ['Hangul', 'Hangul'], ['Han', 'Han'], ['Hanunoo', 'Hanunoo'], ['Hatran', 'Hatran'], ['Hebrew', 'Hebrew'], ['Hiragana', 'Hiragana'], ['Anatolian_Hieroglyphs', 'Anatolian_Hieroglyphs'], ['Pahawh_Hmong', 'Pahawh_Hmong'], ['Nyiakeng_Puachue_Hmong', 'Nyiakeng_Puachue_Hmong'], ['Katakana_Or_Hiragana', 'Katakana_Or_Hiragana'], ['Old_Hungarian', 'Old_Hungarian'], ['Old_Italic', 'Old_Italic'], ['Javanese', 'Javanese'], ['Kayah_Li', 'Kayah_Li'], ['Katakana', 'Katakana'], ['Kharoshthi', 'Kharoshthi'], ['Khmer', 'Khmer'], ['Khojki', 'Khojki'], ['Khitan_Small_Script', 'Khitan_Small_Script'], ['Kannada', 'Kannada'], ['Kaithi', 'Kaithi'], ['Tai_Tham', 'Tai_Tham'], ['Lao', 'Lao'], ['Latin', 'Latin'], ['Lepcha', 'Lepcha'], ['Limbu', 'Limbu'], ['Linear_A', 'Linear_A'], ['Linear_B', 'Linear_B'], ['Lycian', 'Lycian'], ['Lydian', 'Lydian'], ['Mahajani', 'Mahajani'], ['Makasar', 'Makasar'], ['Mandaic', 'Mandaic'], ['Manichaean', 'Manichaean'], ['Marchen', 'Marchen'], ['Medefaidrin', 'Medefaidrin'], ['Mende_Kikakui', 'Mende_Kikakui'], ['Meroitic_Cursive', 'Meroitic_Cursive'], ['Meroitic_Hieroglyphs', 'Meroitic_Hieroglyphs'], ['Malayalam', 'Malayalam'], ['Mongolian', 'Mongolian'], ['Mro', 'Mro'], ['Meetei_Mayek', 'Meetei_Mayek'], ['Multani', 'Multani'], ['Myanmar', 'Myanmar'], ['Nag_Mundari', 'Nag_Mundari'], ['Nandinagari', 'Nandinagari'], ['Old_North_Arabian', 'Old_North_Arabian'], ['Nabataean', 'Nabataean'], ['Nko', 'Nko'], ['Nushu', 'Nushu'], ['Ogham', 'Ogham'], ['Ol_Chiki', 'Ol_Chiki'], ['Old_Turkic', 'Old_Turkic'], ['Oriya', 'Oriya'], ['Osage', 'Osage'], ['Osmanya', 'Osmanya'], ['Old_Uyghur', 'Old_Uyghur'], ['Palmyrene', 'Palmyrene'], ['Pau_Cin_Hau', 'Pau_Cin_Hau'], ['Old_Permic', 'Old_Permic'], ['Phags_Pa', 'Phags_Pa'], ['Inscriptional_Pahlavi', 'Inscriptional_Pahlavi'], ['Psalter_Pahlavi', 'Psalter_Pahlavi'], ['Phoenician', 'Phoenician'], ['Miao', 'Miao'], ['Inscriptional_Parthian', 'Inscriptional_Parthian'], ['Rejang', 'Rejang'], ['Hanifi_Rohingya', 'Hanifi_Rohingya'], ['Runic', 'Runic'], ['Samaritan', 'Samaritan'], ['Old_South_Arabian', 'Old_South_Arabian'], ['Saurashtra', 'Saurashtra'], ['SignWriting', 'SignWriting'], ['Shavian', 'Shavian'], ['Sharada', 'Sharada'], ['Siddham', 'Siddham'], ['Khudawadi', 'Khudawadi'], ['Sinhala', 'Sinhala'], ['Sogdian', 'Sogdian'], ['Old_Sogdian', 'Old_Sogdian'], ['Sora_Sompeng', 'Sora_Sompeng'], ['Soyombo', 'Soyombo'], ['Sundanese', 'Sundanese'], ['Syloti_Nagri', 'Syloti_Nagri'], ['Syriac', 'Syriac'], ['Tagbanwa', 'Tagbanwa'], ['Takri', 'Takri'], ['Tai_Le', 'Tai_Le'], ['New_Tai_Lue', 'New_Tai_Lue'], ['Tamil', 'Tamil'], ['Tangut', 'Tangut'], ['Tai_Viet', 'Tai_Viet'], ['Telugu', 'Telugu'], ['Tifinagh', 'Tifinagh'], ['Tagalog', 'Tagalog'], ['Thaana', 'Thaana'], ['Tibetan', 'Tibetan'], ['Tirhuta', 'Tirhuta'], ['Tangsa', 'Tangsa'], ['Ugaritic', 'Ugaritic'], ['Vai', 'Vai'], ['Vithkuqi', 'Vithkuqi'], ['Warang_Citi', 'Warang_Citi'], ['Wancho', 'Wancho'], ['Old_Persian', 'Old_Persian'], ['Cuneiform', 'Cuneiform'], ['Yezidi', 'Yezidi'], ['Yi', 'Yi'], ['Zanabazar_Square', 'Zanabazar_Square'], ['Inherited', 'Inherited'], ['Common', 'Common'], ['Unknown', 'Unknown']])], ['Script_Extensions', new Map([['Adlm', 'Adlam'], ['Aghb', 'Caucasian_Albanian'], ['Ahom', 'Ahom'], ['Arab', 'Arabic'], ['Armi', 'Imperial_Aramaic'], ['Armn', 'Armenian'], ['Avst', 'Avestan'], ['Bali', 'Balinese'], ['Bamu', 'Bamum'], ['Bass', 'Bassa_Vah'], ['Batk', 'Batak'], ['Beng', 'Bengali'], ['Bhks', 'Bhaiksuki'], ['Bopo', 'Bopomofo'], ['Brah', 'Brahmi'], ['Brai', 'Braille'], ['Bugi', 'Buginese'], ['Buhd', 'Buhid'], ['Cakm', 'Chakma'], ['Cans', 'Canadian_Aboriginal'], ['Cari', 'Carian'], ['Cham', 'Cham'], ['Cher', 'Cherokee'], ['Chrs', 'Chorasmian'], ['Copt', 'Coptic'], ['Qaac', 'Coptic'], ['Cpmn', 'Cypro_Minoan'], ['Cprt', 'Cypriot'], ['Cyrl', 'Cyrillic'], ['Deva', 'Devanagari'], ['Diak', 'Dives_Akuru'], ['Dogr', 'Dogra'], ['Dsrt', 'Deseret'], ['Dupl', 'Duployan'], ['Egyp', 'Egyptian_Hieroglyphs'], ['Elba', 'Elbasan'], ['Elym', 'Elymaic'], ['Ethi', 'Ethiopic'], ['Geor', 'Georgian'], ['Glag', 'Glagolitic'], ['Gong', 'Gunjala_Gondi'], ['Gonm', 'Masaram_Gondi'], ['Goth', 'Gothic'], ['Gran', 'Grantha'], ['Grek', 'Greek'], ['Gujr', 'Gujarati'], ['Guru', 'Gurmukhi'], ['Hang', 'Hangul'], ['Hani', 'Han'], ['Hano', 'Hanunoo'], ['Hatr', 'Hatran'], ['Hebr', 'Hebrew'], ['Hira', 'Hiragana'], ['Hluw', 'Anatolian_Hieroglyphs'], ['Hmng', 'Pahawh_Hmong'], ['Hmnp', 'Nyiakeng_Puachue_Hmong'], ['Hrkt', 'Katakana_Or_Hiragana'], ['Hung', 'Old_Hungarian'], ['Ital', 'Old_Italic'], ['Java', 'Javanese'], ['Kali', 'Kayah_Li'], ['Kana', 'Katakana'], ['Kawi', 'Kawi'], ['Khar', 'Kharoshthi'], ['Khmr', 'Khmer'], ['Khoj', 'Khojki'], ['Kits', 'Khitan_Small_Script'], ['Knda', 'Kannada'], ['Kthi', 'Kaithi'], ['Lana', 'Tai_Tham'], ['Laoo', 'Lao'], ['Latn', 'Latin'], ['Lepc', 'Lepcha'], ['Limb', 'Limbu'], ['Lina', 'Linear_A'], ['Linb', 'Linear_B'], ['Lisu', 'Lisu'], ['Lyci', 'Lycian'], ['Lydi', 'Lydian'], ['Mahj', 'Mahajani'], ['Maka', 'Makasar'], ['Mand', 'Mandaic'], ['Mani', 'Manichaean'], ['Marc', 'Marchen'], ['Medf', 'Medefaidrin'], ['Mend', 'Mende_Kikakui'], ['Merc', 'Meroitic_Cursive'], ['Mero', 'Meroitic_Hieroglyphs'], ['Mlym', 'Malayalam'], ['Modi', 'Modi'], ['Mong', 'Mongolian'], ['Mroo', 'Mro'], ['Mtei', 'Meetei_Mayek'], ['Mult', 'Multani'], ['Mymr', 'Myanmar'], ['Nagm', 'Nag_Mundari'], ['Nand', 'Nandinagari'], ['Narb', 'Old_North_Arabian'], ['Nbat', 'Nabataean'], ['Newa', 'Newa'], ['Nkoo', 'Nko'], ['Nshu', 'Nushu'], ['Ogam', 'Ogham'], ['Olck', 'Ol_Chiki'], ['Orkh', 'Old_Turkic'], ['Orya', 'Oriya'], ['Osge', 'Osage'], ['Osma', 'Osmanya'], ['Ougr', 'Old_Uyghur'], ['Palm', 'Palmyrene'], ['Pauc', 'Pau_Cin_Hau'], ['Perm', 'Old_Permic'], ['Phag', 'Phags_Pa'], ['Phli', 'Inscriptional_Pahlavi'], ['Phlp', 'Psalter_Pahlavi'], ['Phnx', 'Phoenician'], ['Plrd', 'Miao'], ['Prti', 'Inscriptional_Parthian'], ['Rjng', 'Rejang'], ['Rohg', 'Hanifi_Rohingya'], ['Runr', 'Runic'], ['Samr', 'Samaritan'], ['Sarb', 'Old_South_Arabian'], ['Saur', 'Saurashtra'], ['Sgnw', 'SignWriting'], ['Shaw', 'Shavian'], ['Shrd', 'Sharada'], ['Sidd', 'Siddham'], ['Sind', 'Khudawadi'], ['Sinh', 'Sinhala'], ['Sogd', 'Sogdian'], ['Sogo', 'Old_Sogdian'], ['Sora', 'Sora_Sompeng'], ['Soyo', 'Soyombo'], ['Sund', 'Sundanese'], ['Sylo', 'Syloti_Nagri'], ['Syrc', 'Syriac'], ['Tagb', 'Tagbanwa'], ['Takr', 'Takri'], ['Tale', 'Tai_Le'], ['Talu', 'New_Tai_Lue'], ['Taml', 'Tamil'], ['Tang', 'Tangut'], ['Tavt', 'Tai_Viet'], ['Telu', 'Telugu'], ['Tfng', 'Tifinagh'], ['Tglg', 'Tagalog'], ['Thaa', 'Thaana'], ['Thai', 'Thai'], ['Tibt', 'Tibetan'], ['Tirh', 'Tirhuta'], ['Tnsa', 'Tangsa'], ['Toto', 'Toto'], ['Ugar', 'Ugaritic'], ['Vaii', 'Vai'], ['Vith', 'Vithkuqi'], ['Wara', 'Warang_Citi'], ['Wcho', 'Wancho'], ['Xpeo', 'Old_Persian'], ['Xsux', 'Cuneiform'], ['Yezi', 'Yezidi'], ['Yiii', 'Yi'], ['Zanb', 'Zanabazar_Square'], ['Zinh', 'Inherited'], ['Qaai', 'Inherited'], ['Zyyy', 'Common'], ['Zzzz', 'Unknown'], ['Adlam', 'Adlam'], ['Caucasian_Albanian', 'Caucasian_Albanian'], ['Arabic', 'Arabic'], ['Imperial_Aramaic', 'Imperial_Aramaic'], ['Armenian', 'Armenian'], ['Avestan', 'Avestan'], ['Balinese', 'Balinese'], ['Bamum', 'Bamum'], ['Bassa_Vah', 'Bassa_Vah'], ['Batak', 'Batak'], ['Bengali', 'Bengali'], ['Bhaiksuki', 'Bhaiksuki'], ['Bopomofo', 'Bopomofo'], ['Brahmi', 'Brahmi'], ['Braille', 'Braille'], ['Buginese', 'Buginese'], ['Buhid', 'Buhid'], ['Chakma', 'Chakma'], ['Canadian_Aboriginal', 'Canadian_Aboriginal'], ['Carian', 'Carian'], ['Cherokee', 'Cherokee'], ['Chorasmian', 'Chorasmian'], ['Coptic', 'Coptic'], ['Cypro_Minoan', 'Cypro_Minoan'], ['Cypriot', 'Cypriot'], ['Cyrillic', 'Cyrillic'], ['Devanagari', 'Devanagari'], ['Dives_Akuru', 'Dives_Akuru'], ['Dogra', 'Dogra'], ['Deseret', 'Deseret'], ['Duployan', 'Duployan'], ['Egyptian_Hieroglyphs', 'Egyptian_Hieroglyphs'], ['Elbasan', 'Elbasan'], ['Elymaic', 'Elymaic'], ['Ethiopic', 'Ethiopic'], ['Georgian', 'Georgian'], ['Glagolitic', 'Glagolitic'], ['Gunjala_Gondi', 'Gunjala_Gondi'], ['Masaram_Gondi', 'Masaram_Gondi'], ['Gothic', 'Gothic'], ['Grantha', 'Grantha'], ['Greek', 'Greek'], ['Gujarati', 'Gujarati'], ['Gurmukhi', 'Gurmukhi'], ['Hangul', 'Hangul'], ['Han', 'Han'], ['Hanunoo', 'Hanunoo'], ['Hatran', 'Hatran'], ['Hebrew', 'Hebrew'], ['Hiragana', 'Hiragana'], ['Anatolian_Hieroglyphs', 'Anatolian_Hieroglyphs'], ['Pahawh_Hmong', 'Pahawh_Hmong'], ['Nyiakeng_Puachue_Hmong', 'Nyiakeng_Puachue_Hmong'], ['Katakana_Or_Hiragana', 'Katakana_Or_Hiragana'], ['Old_Hungarian', 'Old_Hungarian'], ['Old_Italic', 'Old_Italic'], ['Javanese', 'Javanese'], ['Kayah_Li', 'Kayah_Li'], ['Katakana', 'Katakana'], ['Kharoshthi', 'Kharoshthi'], ['Khmer', 'Khmer'], ['Khojki', 'Khojki'], ['Khitan_Small_Script', 'Khitan_Small_Script'], ['Kannada', 'Kannada'], ['Kaithi', 'Kaithi'], ['Tai_Tham', 'Tai_Tham'], ['Lao', 'Lao'], ['Latin', 'Latin'], ['Lepcha', 'Lepcha'], ['Limbu', 'Limbu'], ['Linear_A', 'Linear_A'], ['Linear_B', 'Linear_B'], ['Lycian', 'Lycian'], ['Lydian', 'Lydian'], ['Mahajani', 'Mahajani'], ['Makasar', 'Makasar'], ['Mandaic', 'Mandaic'], ['Manichaean', 'Manichaean'], ['Marchen', 'Marchen'], ['Medefaidrin', 'Medefaidrin'], ['Mende_Kikakui', 'Mende_Kikakui'], ['Meroitic_Cursive', 'Meroitic_Cursive'], ['Meroitic_Hieroglyphs', 'Meroitic_Hieroglyphs'], ['Malayalam', 'Malayalam'], ['Mongolian', 'Mongolian'], ['Mro', 'Mro'], ['Meetei_Mayek', 'Meetei_Mayek'], ['Multani', 'Multani'], ['Myanmar', 'Myanmar'], ['Nag_Mundari', 'Nag_Mundari'], ['Nandinagari', 'Nandinagari'], ['Old_North_Arabian', 'Old_North_Arabian'], ['Nabataean', 'Nabataean'], ['Nko', 'Nko'], ['Nushu', 'Nushu'], ['Ogham', 'Ogham'], ['Ol_Chiki', 'Ol_Chiki'], ['Old_Turkic', 'Old_Turkic'], ['Oriya', 'Oriya'], ['Osage', 'Osage'], ['Osmanya', 'Osmanya'], ['Old_Uyghur', 'Old_Uyghur'], ['Palmyrene', 'Palmyrene'], ['Pau_Cin_Hau', 'Pau_Cin_Hau'], ['Old_Permic', 'Old_Permic'], ['Phags_Pa', 'Phags_Pa'], ['Inscriptional_Pahlavi', 'Inscriptional_Pahlavi'], ['Psalter_Pahlavi', 'Psalter_Pahlavi'], ['Phoenician', 'Phoenician'], ['Miao', 'Miao'], ['Inscriptional_Parthian', 'Inscriptional_Parthian'], ['Rejang', 'Rejang'], ['Hanifi_Rohingya', 'Hanifi_Rohingya'], ['Runic', 'Runic'], ['Samaritan', 'Samaritan'], ['Old_South_Arabian', 'Old_South_Arabian'], ['Saurashtra', 'Saurashtra'], ['SignWriting', 'SignWriting'], ['Shavian', 'Shavian'], ['Sharada', 'Sharada'], ['Siddham', 'Siddham'], ['Khudawadi', 'Khudawadi'], ['Sinhala', 'Sinhala'], ['Sogdian', 'Sogdian'], ['Old_Sogdian', 'Old_Sogdian'], ['Sora_Sompeng', 'Sora_Sompeng'], ['Soyombo', 'Soyombo'], ['Sundanese', 'Sundanese'], ['Syloti_Nagri', 'Syloti_Nagri'], ['Syriac', 'Syriac'], ['Tagbanwa', 'Tagbanwa'], ['Takri', 'Takri'], ['Tai_Le', 'Tai_Le'], ['New_Tai_Lue', 'New_Tai_Lue'], ['Tamil', 'Tamil'], ['Tangut', 'Tangut'], ['Tai_Viet', 'Tai_Viet'], ['Telugu', 'Telugu'], ['Tifinagh', 'Tifinagh'], ['Tagalog', 'Tagalog'], ['Thaana', 'Thaana'], ['Tibetan', 'Tibetan'], ['Tirhuta', 'Tirhuta'], ['Tangsa', 'Tangsa'], ['Ugaritic', 'Ugaritic'], ['Vai', 'Vai'], ['Vithkuqi', 'Vithkuqi'], ['Warang_Citi', 'Warang_Citi'], ['Wancho', 'Wancho'], ['Old_Persian', 'Old_Persian'], ['Cuneiform', 'Cuneiform'], ['Yezidi', 'Yezidi'], ['Yi', 'Yi'], ['Zanabazar_Square', 'Zanabazar_Square'], ['Inherited', 'Inherited'], ['Common', 'Common'], ['Unknown', 'Unknown']])]]);

		  var propertyToValueAliases = mappings;
		  var matchPropertyValue = function matchPropertyValue(property, value) {
		    var aliasToValue = propertyToValueAliases.get(property);
		    if (!aliasToValue) {
		      throw new Error("Unknown property `" + property + "`.");
		    }
		    var canonicalValue = aliasToValue.get(value);
		    if (canonicalValue) {
		      return canonicalValue;
		    }
		    throw new Error("Unknown value `" + value + "` for property `" + property + "`.");
		  };
		  var unicodeMatchPropertyValueEcmascript = matchPropertyValue;

		  var iuMappings$1 = new Map([[0x4B, 0x212A], [0x53, 0x17F], [0x6B, 0x212A], [0x73, 0x17F], [0xB5, 0x39C], [0xC5, 0x212B], [0xDF, 0x1E9E], [0xE5, 0x212B], [0x17F, 0x53], [0x1C4, 0x1C5], [0x1C5, 0x1C4], [0x1C7, 0x1C8], [0x1C8, 0x1C7], [0x1CA, 0x1CB], [0x1CB, 0x1CA], [0x1F1, 0x1F2], [0x1F2, 0x1F1], [0x345, 0x1FBE], [0x392, 0x3D0], [0x395, 0x3F5], [0x398, 0x3F4], [0x399, 0x1FBE], [0x39A, 0x3F0], [0x39C, 0xB5], [0x3A0, 0x3D6], [0x3A1, 0x3F1], [0x3A3, 0x3C2], [0x3A6, 0x3D5], [0x3A9, 0x2126], [0x3B8, 0x3F4], [0x3C2, 0x3A3], [0x3C9, 0x2126], [0x3D0, 0x392], [0x3D1, 0x3F4], [0x3D5, 0x3A6], [0x3D6, 0x3A0], [0x3F0, 0x39A], [0x3F1, 0x3A1], [0x3F4, [0x398, 0x3D1, 0x3B8]], [0x3F5, 0x395], [0x412, 0x1C80], [0x414, 0x1C81], [0x41E, 0x1C82], [0x421, 0x1C83], [0x422, 0x1C85], [0x42A, 0x1C86], [0x462, 0x1C87], [0x1C80, 0x412], [0x1C81, 0x414], [0x1C82, 0x41E], [0x1C83, 0x421], [0x1C84, 0x1C85], [0x1C85, [0x422, 0x1C84]], [0x1C86, 0x42A], [0x1C87, 0x462], [0x1C88, 0xA64A], [0x1E60, 0x1E9B], [0x1E9B, 0x1E60], [0x1E9E, 0xDF], [0x1F80, 0x1F88], [0x1F81, 0x1F89], [0x1F82, 0x1F8A], [0x1F83, 0x1F8B], [0x1F84, 0x1F8C], [0x1F85, 0x1F8D], [0x1F86, 0x1F8E], [0x1F87, 0x1F8F], [0x1F88, 0x1F80], [0x1F89, 0x1F81], [0x1F8A, 0x1F82], [0x1F8B, 0x1F83], [0x1F8C, 0x1F84], [0x1F8D, 0x1F85], [0x1F8E, 0x1F86], [0x1F8F, 0x1F87], [0x1F90, 0x1F98], [0x1F91, 0x1F99], [0x1F92, 0x1F9A], [0x1F93, 0x1F9B], [0x1F94, 0x1F9C], [0x1F95, 0x1F9D], [0x1F96, 0x1F9E], [0x1F97, 0x1F9F], [0x1F98, 0x1F90], [0x1F99, 0x1F91], [0x1F9A, 0x1F92], [0x1F9B, 0x1F93], [0x1F9C, 0x1F94], [0x1F9D, 0x1F95], [0x1F9E, 0x1F96], [0x1F9F, 0x1F97], [0x1FA0, 0x1FA8], [0x1FA1, 0x1FA9], [0x1FA2, 0x1FAA], [0x1FA3, 0x1FAB], [0x1FA4, 0x1FAC], [0x1FA5, 0x1FAD], [0x1FA6, 0x1FAE], [0x1FA7, 0x1FAF], [0x1FA8, 0x1FA0], [0x1FA9, 0x1FA1], [0x1FAA, 0x1FA2], [0x1FAB, 0x1FA3], [0x1FAC, 0x1FA4], [0x1FAD, 0x1FA5], [0x1FAE, 0x1FA6], [0x1FAF, 0x1FA7], [0x1FB3, 0x1FBC], [0x1FBC, 0x1FB3], [0x1FBE, [0x345, 0x399]], [0x1FC3, 0x1FCC], [0x1FCC, 0x1FC3], [0x1FF3, 0x1FFC], [0x1FFC, 0x1FF3], [0x2126, [0x3A9, 0x3C9]], [0x212A, 0x4B], [0x212B, [0xC5, 0xE5]], [0xA64A, 0x1C88], [0x10400, 0x10428], [0x10401, 0x10429], [0x10402, 0x1042A], [0x10403, 0x1042B], [0x10404, 0x1042C], [0x10405, 0x1042D], [0x10406, 0x1042E], [0x10407, 0x1042F], [0x10408, 0x10430], [0x10409, 0x10431], [0x1040A, 0x10432], [0x1040B, 0x10433], [0x1040C, 0x10434], [0x1040D, 0x10435], [0x1040E, 0x10436], [0x1040F, 0x10437], [0x10410, 0x10438], [0x10411, 0x10439], [0x10412, 0x1043A], [0x10413, 0x1043B], [0x10414, 0x1043C], [0x10415, 0x1043D], [0x10416, 0x1043E], [0x10417, 0x1043F], [0x10418, 0x10440], [0x10419, 0x10441], [0x1041A, 0x10442], [0x1041B, 0x10443], [0x1041C, 0x10444], [0x1041D, 0x10445], [0x1041E, 0x10446], [0x1041F, 0x10447], [0x10420, 0x10448], [0x10421, 0x10449], [0x10422, 0x1044A], [0x10423, 0x1044B], [0x10424, 0x1044C], [0x10425, 0x1044D], [0x10426, 0x1044E], [0x10427, 0x1044F], [0x10428, 0x10400], [0x10429, 0x10401], [0x1042A, 0x10402], [0x1042B, 0x10403], [0x1042C, 0x10404], [0x1042D, 0x10405], [0x1042E, 0x10406], [0x1042F, 0x10407], [0x10430, 0x10408], [0x10431, 0x10409], [0x10432, 0x1040A], [0x10433, 0x1040B], [0x10434, 0x1040C], [0x10435, 0x1040D], [0x10436, 0x1040E], [0x10437, 0x1040F], [0x10438, 0x10410], [0x10439, 0x10411], [0x1043A, 0x10412], [0x1043B, 0x10413], [0x1043C, 0x10414], [0x1043D, 0x10415], [0x1043E, 0x10416], [0x1043F, 0x10417], [0x10440, 0x10418], [0x10441, 0x10419], [0x10442, 0x1041A], [0x10443, 0x1041B], [0x10444, 0x1041C], [0x10445, 0x1041D], [0x10446, 0x1041E], [0x10447, 0x1041F], [0x10448, 0x10420], [0x10449, 0x10421], [0x1044A, 0x10422], [0x1044B, 0x10423], [0x1044C, 0x10424], [0x1044D, 0x10425], [0x1044E, 0x10426], [0x1044F, 0x10427], [0x104B0, 0x104D8], [0x104B1, 0x104D9], [0x104B2, 0x104DA], [0x104B3, 0x104DB], [0x104B4, 0x104DC], [0x104B5, 0x104DD], [0x104B6, 0x104DE], [0x104B7, 0x104DF], [0x104B8, 0x104E0], [0x104B9, 0x104E1], [0x104BA, 0x104E2], [0x104BB, 0x104E3], [0x104BC, 0x104E4], [0x104BD, 0x104E5], [0x104BE, 0x104E6], [0x104BF, 0x104E7], [0x104C0, 0x104E8], [0x104C1, 0x104E9], [0x104C2, 0x104EA], [0x104C3, 0x104EB], [0x104C4, 0x104EC], [0x104C5, 0x104ED], [0x104C6, 0x104EE], [0x104C7, 0x104EF], [0x104C8, 0x104F0], [0x104C9, 0x104F1], [0x104CA, 0x104F2], [0x104CB, 0x104F3], [0x104CC, 0x104F4], [0x104CD, 0x104F5], [0x104CE, 0x104F6], [0x104CF, 0x104F7], [0x104D0, 0x104F8], [0x104D1, 0x104F9], [0x104D2, 0x104FA], [0x104D3, 0x104FB], [0x104D8, 0x104B0], [0x104D9, 0x104B1], [0x104DA, 0x104B2], [0x104DB, 0x104B3], [0x104DC, 0x104B4], [0x104DD, 0x104B5], [0x104DE, 0x104B6], [0x104DF, 0x104B7], [0x104E0, 0x104B8], [0x104E1, 0x104B9], [0x104E2, 0x104BA], [0x104E3, 0x104BB], [0x104E4, 0x104BC], [0x104E5, 0x104BD], [0x104E6, 0x104BE], [0x104E7, 0x104BF], [0x104E8, 0x104C0], [0x104E9, 0x104C1], [0x104EA, 0x104C2], [0x104EB, 0x104C3], [0x104EC, 0x104C4], [0x104ED, 0x104C5], [0x104EE, 0x104C6], [0x104EF, 0x104C7], [0x104F0, 0x104C8], [0x104F1, 0x104C9], [0x104F2, 0x104CA], [0x104F3, 0x104CB], [0x104F4, 0x104CC], [0x104F5, 0x104CD], [0x104F6, 0x104CE], [0x104F7, 0x104CF], [0x104F8, 0x104D0], [0x104F9, 0x104D1], [0x104FA, 0x104D2], [0x104FB, 0x104D3], [0x10570, 0x10597], [0x10571, 0x10598], [0x10572, 0x10599], [0x10573, 0x1059A], [0x10574, 0x1059B], [0x10575, 0x1059C], [0x10576, 0x1059D], [0x10577, 0x1059E], [0x10578, 0x1059F], [0x10579, 0x105A0], [0x1057A, 0x105A1], [0x1057C, 0x105A3], [0x1057D, 0x105A4], [0x1057E, 0x105A5], [0x1057F, 0x105A6], [0x10580, 0x105A7], [0x10581, 0x105A8], [0x10582, 0x105A9], [0x10583, 0x105AA], [0x10584, 0x105AB], [0x10585, 0x105AC], [0x10586, 0x105AD], [0x10587, 0x105AE], [0x10588, 0x105AF], [0x10589, 0x105B0], [0x1058A, 0x105B1], [0x1058C, 0x105B3], [0x1058D, 0x105B4], [0x1058E, 0x105B5], [0x1058F, 0x105B6], [0x10590, 0x105B7], [0x10591, 0x105B8], [0x10592, 0x105B9], [0x10594, 0x105BB], [0x10595, 0x105BC], [0x10597, 0x10570], [0x10598, 0x10571], [0x10599, 0x10572], [0x1059A, 0x10573], [0x1059B, 0x10574], [0x1059C, 0x10575], [0x1059D, 0x10576], [0x1059E, 0x10577], [0x1059F, 0x10578], [0x105A0, 0x10579], [0x105A1, 0x1057A], [0x105A3, 0x1057C], [0x105A4, 0x1057D], [0x105A5, 0x1057E], [0x105A6, 0x1057F], [0x105A7, 0x10580], [0x105A8, 0x10581], [0x105A9, 0x10582], [0x105AA, 0x10583], [0x105AB, 0x10584], [0x105AC, 0x10585], [0x105AD, 0x10586], [0x105AE, 0x10587], [0x105AF, 0x10588], [0x105B0, 0x10589], [0x105B1, 0x1058A], [0x105B3, 0x1058C], [0x105B4, 0x1058D], [0x105B5, 0x1058E], [0x105B6, 0x1058F], [0x105B7, 0x10590], [0x105B8, 0x10591], [0x105B9, 0x10592], [0x105BB, 0x10594], [0x105BC, 0x10595], [0x10C80, 0x10CC0], [0x10C81, 0x10CC1], [0x10C82, 0x10CC2], [0x10C83, 0x10CC3], [0x10C84, 0x10CC4], [0x10C85, 0x10CC5], [0x10C86, 0x10CC6], [0x10C87, 0x10CC7], [0x10C88, 0x10CC8], [0x10C89, 0x10CC9], [0x10C8A, 0x10CCA], [0x10C8B, 0x10CCB], [0x10C8C, 0x10CCC], [0x10C8D, 0x10CCD], [0x10C8E, 0x10CCE], [0x10C8F, 0x10CCF], [0x10C90, 0x10CD0], [0x10C91, 0x10CD1], [0x10C92, 0x10CD2], [0x10C93, 0x10CD3], [0x10C94, 0x10CD4], [0x10C95, 0x10CD5], [0x10C96, 0x10CD6], [0x10C97, 0x10CD7], [0x10C98, 0x10CD8], [0x10C99, 0x10CD9], [0x10C9A, 0x10CDA], [0x10C9B, 0x10CDB], [0x10C9C, 0x10CDC], [0x10C9D, 0x10CDD], [0x10C9E, 0x10CDE], [0x10C9F, 0x10CDF], [0x10CA0, 0x10CE0], [0x10CA1, 0x10CE1], [0x10CA2, 0x10CE2], [0x10CA3, 0x10CE3], [0x10CA4, 0x10CE4], [0x10CA5, 0x10CE5], [0x10CA6, 0x10CE6], [0x10CA7, 0x10CE7], [0x10CA8, 0x10CE8], [0x10CA9, 0x10CE9], [0x10CAA, 0x10CEA], [0x10CAB, 0x10CEB], [0x10CAC, 0x10CEC], [0x10CAD, 0x10CED], [0x10CAE, 0x10CEE], [0x10CAF, 0x10CEF], [0x10CB0, 0x10CF0], [0x10CB1, 0x10CF1], [0x10CB2, 0x10CF2], [0x10CC0, 0x10C80], [0x10CC1, 0x10C81], [0x10CC2, 0x10C82], [0x10CC3, 0x10C83], [0x10CC4, 0x10C84], [0x10CC5, 0x10C85], [0x10CC6, 0x10C86], [0x10CC7, 0x10C87], [0x10CC8, 0x10C88], [0x10CC9, 0x10C89], [0x10CCA, 0x10C8A], [0x10CCB, 0x10C8B], [0x10CCC, 0x10C8C], [0x10CCD, 0x10C8D], [0x10CCE, 0x10C8E], [0x10CCF, 0x10C8F], [0x10CD0, 0x10C90], [0x10CD1, 0x10C91], [0x10CD2, 0x10C92], [0x10CD3, 0x10C93], [0x10CD4, 0x10C94], [0x10CD5, 0x10C95], [0x10CD6, 0x10C96], [0x10CD7, 0x10C97], [0x10CD8, 0x10C98], [0x10CD9, 0x10C99], [0x10CDA, 0x10C9A], [0x10CDB, 0x10C9B], [0x10CDC, 0x10C9C], [0x10CDD, 0x10C9D], [0x10CDE, 0x10C9E], [0x10CDF, 0x10C9F], [0x10CE0, 0x10CA0], [0x10CE1, 0x10CA1], [0x10CE2, 0x10CA2], [0x10CE3, 0x10CA3], [0x10CE4, 0x10CA4], [0x10CE5, 0x10CA5], [0x10CE6, 0x10CA6], [0x10CE7, 0x10CA7], [0x10CE8, 0x10CA8], [0x10CE9, 0x10CA9], [0x10CEA, 0x10CAA], [0x10CEB, 0x10CAB], [0x10CEC, 0x10CAC], [0x10CED, 0x10CAD], [0x10CEE, 0x10CAE], [0x10CEF, 0x10CAF], [0x10CF0, 0x10CB0], [0x10CF1, 0x10CB1], [0x10CF2, 0x10CB2], [0x118A0, 0x118C0], [0x118A1, 0x118C1], [0x118A2, 0x118C2], [0x118A3, 0x118C3], [0x118A4, 0x118C4], [0x118A5, 0x118C5], [0x118A6, 0x118C6], [0x118A7, 0x118C7], [0x118A8, 0x118C8], [0x118A9, 0x118C9], [0x118AA, 0x118CA], [0x118AB, 0x118CB], [0x118AC, 0x118CC], [0x118AD, 0x118CD], [0x118AE, 0x118CE], [0x118AF, 0x118CF], [0x118B0, 0x118D0], [0x118B1, 0x118D1], [0x118B2, 0x118D2], [0x118B3, 0x118D3], [0x118B4, 0x118D4], [0x118B5, 0x118D5], [0x118B6, 0x118D6], [0x118B7, 0x118D7], [0x118B8, 0x118D8], [0x118B9, 0x118D9], [0x118BA, 0x118DA], [0x118BB, 0x118DB], [0x118BC, 0x118DC], [0x118BD, 0x118DD], [0x118BE, 0x118DE], [0x118BF, 0x118DF], [0x118C0, 0x118A0], [0x118C1, 0x118A1], [0x118C2, 0x118A2], [0x118C3, 0x118A3], [0x118C4, 0x118A4], [0x118C5, 0x118A5], [0x118C6, 0x118A6], [0x118C7, 0x118A7], [0x118C8, 0x118A8], [0x118C9, 0x118A9], [0x118CA, 0x118AA], [0x118CB, 0x118AB], [0x118CC, 0x118AC], [0x118CD, 0x118AD], [0x118CE, 0x118AE], [0x118CF, 0x118AF], [0x118D0, 0x118B0], [0x118D1, 0x118B1], [0x118D2, 0x118B2], [0x118D3, 0x118B3], [0x118D4, 0x118B4], [0x118D5, 0x118B5], [0x118D6, 0x118B6], [0x118D7, 0x118B7], [0x118D8, 0x118B8], [0x118D9, 0x118B9], [0x118DA, 0x118BA], [0x118DB, 0x118BB], [0x118DC, 0x118BC], [0x118DD, 0x118BD], [0x118DE, 0x118BE], [0x118DF, 0x118BF], [0x16E40, 0x16E60], [0x16E41, 0x16E61], [0x16E42, 0x16E62], [0x16E43, 0x16E63], [0x16E44, 0x16E64], [0x16E45, 0x16E65], [0x16E46, 0x16E66], [0x16E47, 0x16E67], [0x16E48, 0x16E68], [0x16E49, 0x16E69], [0x16E4A, 0x16E6A], [0x16E4B, 0x16E6B], [0x16E4C, 0x16E6C], [0x16E4D, 0x16E6D], [0x16E4E, 0x16E6E], [0x16E4F, 0x16E6F], [0x16E50, 0x16E70], [0x16E51, 0x16E71], [0x16E52, 0x16E72], [0x16E53, 0x16E73], [0x16E54, 0x16E74], [0x16E55, 0x16E75], [0x16E56, 0x16E76], [0x16E57, 0x16E77], [0x16E58, 0x16E78], [0x16E59, 0x16E79], [0x16E5A, 0x16E7A], [0x16E5B, 0x16E7B], [0x16E5C, 0x16E7C], [0x16E5D, 0x16E7D], [0x16E5E, 0x16E7E], [0x16E5F, 0x16E7F], [0x16E60, 0x16E40], [0x16E61, 0x16E41], [0x16E62, 0x16E42], [0x16E63, 0x16E43], [0x16E64, 0x16E44], [0x16E65, 0x16E45], [0x16E66, 0x16E46], [0x16E67, 0x16E47], [0x16E68, 0x16E48], [0x16E69, 0x16E49], [0x16E6A, 0x16E4A], [0x16E6B, 0x16E4B], [0x16E6C, 0x16E4C], [0x16E6D, 0x16E4D], [0x16E6E, 0x16E4E], [0x16E6F, 0x16E4F], [0x16E70, 0x16E50], [0x16E71, 0x16E51], [0x16E72, 0x16E52], [0x16E73, 0x16E53], [0x16E74, 0x16E54], [0x16E75, 0x16E55], [0x16E76, 0x16E56], [0x16E77, 0x16E57], [0x16E78, 0x16E58], [0x16E79, 0x16E59], [0x16E7A, 0x16E5A], [0x16E7B, 0x16E5B], [0x16E7C, 0x16E5C], [0x16E7D, 0x16E5D], [0x16E7E, 0x16E5E], [0x16E7F, 0x16E5F], [0x1E900, 0x1E922], [0x1E901, 0x1E923], [0x1E902, 0x1E924], [0x1E903, 0x1E925], [0x1E904, 0x1E926], [0x1E905, 0x1E927], [0x1E906, 0x1E928], [0x1E907, 0x1E929], [0x1E908, 0x1E92A], [0x1E909, 0x1E92B], [0x1E90A, 0x1E92C], [0x1E90B, 0x1E92D], [0x1E90C, 0x1E92E], [0x1E90D, 0x1E92F], [0x1E90E, 0x1E930], [0x1E90F, 0x1E931], [0x1E910, 0x1E932], [0x1E911, 0x1E933], [0x1E912, 0x1E934], [0x1E913, 0x1E935], [0x1E914, 0x1E936], [0x1E915, 0x1E937], [0x1E916, 0x1E938], [0x1E917, 0x1E939], [0x1E918, 0x1E93A], [0x1E919, 0x1E93B], [0x1E91A, 0x1E93C], [0x1E91B, 0x1E93D], [0x1E91C, 0x1E93E], [0x1E91D, 0x1E93F], [0x1E91E, 0x1E940], [0x1E91F, 0x1E941], [0x1E920, 0x1E942], [0x1E921, 0x1E943], [0x1E922, 0x1E900], [0x1E923, 0x1E901], [0x1E924, 0x1E902], [0x1E925, 0x1E903], [0x1E926, 0x1E904], [0x1E927, 0x1E905], [0x1E928, 0x1E906], [0x1E929, 0x1E907], [0x1E92A, 0x1E908], [0x1E92B, 0x1E909], [0x1E92C, 0x1E90A], [0x1E92D, 0x1E90B], [0x1E92E, 0x1E90C], [0x1E92F, 0x1E90D], [0x1E930, 0x1E90E], [0x1E931, 0x1E90F], [0x1E932, 0x1E910], [0x1E933, 0x1E911], [0x1E934, 0x1E912], [0x1E935, 0x1E913], [0x1E936, 0x1E914], [0x1E937, 0x1E915], [0x1E938, 0x1E916], [0x1E939, 0x1E917], [0x1E93A, 0x1E918], [0x1E93B, 0x1E919], [0x1E93C, 0x1E91A], [0x1E93D, 0x1E91B], [0x1E93E, 0x1E91C], [0x1E93F, 0x1E91D], [0x1E940, 0x1E91E], [0x1E941, 0x1E91F], [0x1E942, 0x1E920], [0x1E943, 0x1E921]]);

		  var characterClassEscapeSets = {};

		  var regenerate$1 = regenerateExports;
		  characterClassEscapeSets.REGULAR = new Map([['d', regenerate$1().addRange(0x30, 0x39)], ['D', regenerate$1().addRange(0x0, 0x2F).addRange(0x3A, 0xFFFF)], ['s', regenerate$1(0x20, 0xA0, 0x1680, 0x202F, 0x205F, 0x3000, 0xFEFF).addRange(0x9, 0xD).addRange(0x2000, 0x200A).addRange(0x2028, 0x2029)], ['S', regenerate$1().addRange(0x0, 0x8).addRange(0xE, 0x1F).addRange(0x21, 0x9F).addRange(0xA1, 0x167F).addRange(0x1681, 0x1FFF).addRange(0x200B, 0x2027).addRange(0x202A, 0x202E).addRange(0x2030, 0x205E).addRange(0x2060, 0x2FFF).addRange(0x3001, 0xFEFE).addRange(0xFF00, 0xFFFF)], ['w', regenerate$1(0x5F).addRange(0x30, 0x39).addRange(0x41, 0x5A).addRange(0x61, 0x7A)], ['W', regenerate$1(0x60).addRange(0x0, 0x2F).addRange(0x3A, 0x40).addRange(0x5B, 0x5E).addRange(0x7B, 0xFFFF)]]);
		  characterClassEscapeSets.UNICODE = new Map([['d', regenerate$1().addRange(0x30, 0x39)], ['D', regenerate$1().addRange(0x0, 0x2F).addRange(0x3A, 0x10FFFF)], ['s', regenerate$1(0x20, 0xA0, 0x1680, 0x202F, 0x205F, 0x3000, 0xFEFF).addRange(0x9, 0xD).addRange(0x2000, 0x200A).addRange(0x2028, 0x2029)], ['S', regenerate$1().addRange(0x0, 0x8).addRange(0xE, 0x1F).addRange(0x21, 0x9F).addRange(0xA1, 0x167F).addRange(0x1681, 0x1FFF).addRange(0x200B, 0x2027).addRange(0x202A, 0x202E).addRange(0x2030, 0x205E).addRange(0x2060, 0x2FFF).addRange(0x3001, 0xFEFE).addRange(0xFF00, 0x10FFFF)], ['w', regenerate$1(0x5F).addRange(0x30, 0x39).addRange(0x41, 0x5A).addRange(0x61, 0x7A)], ['W', regenerate$1(0x60).addRange(0x0, 0x2F).addRange(0x3A, 0x40).addRange(0x5B, 0x5E).addRange(0x7B, 0x10FFFF)]]);
		  characterClassEscapeSets.UNICODE_IGNORE_CASE = new Map([['d', regenerate$1().addRange(0x30, 0x39)], ['D', regenerate$1().addRange(0x0, 0x2F).addRange(0x3A, 0x10FFFF)], ['s', regenerate$1(0x20, 0xA0, 0x1680, 0x202F, 0x205F, 0x3000, 0xFEFF).addRange(0x9, 0xD).addRange(0x2000, 0x200A).addRange(0x2028, 0x2029)], ['S', regenerate$1().addRange(0x0, 0x8).addRange(0xE, 0x1F).addRange(0x21, 0x9F).addRange(0xA1, 0x167F).addRange(0x1681, 0x1FFF).addRange(0x200B, 0x2027).addRange(0x202A, 0x202E).addRange(0x2030, 0x205E).addRange(0x2060, 0x2FFF).addRange(0x3001, 0xFEFE).addRange(0xFF00, 0x10FFFF)], ['w', regenerate$1(0x5F, 0x17F, 0x212A).addRange(0x30, 0x39).addRange(0x41, 0x5A).addRange(0x61, 0x7A)], ['W', regenerate$1(0x60).addRange(0x0, 0x2F).addRange(0x3A, 0x40).addRange(0x5B, 0x5E).addRange(0x7B, 0x17E).addRange(0x180, 0x2129).addRange(0x212B, 0x10FFFF)]]);

		  var generate = regjsgenExports.generate;
		  var parse = parserExports.parse;
		  var regenerate = regenerateExports;
		  var unicodeMatchProperty = unicodeMatchPropertyEcmascript;
		  var unicodeMatchPropertyValue = unicodeMatchPropertyValueEcmascript;
		  var iuMappings = iuMappings$1;
		  var ESCAPE_SETS = characterClassEscapeSets;
		  function flatMap$1(array, callback) {
		    var result = [];
		    array.forEach(function (item) {
		      var res = callback(item);
		      if (Array.isArray(res)) {
		        result.push.apply(result, res);
		      } else {
		        result.push(res);
		      }
		    });
		    return result;
		  }
		  var SPECIAL_CHARS = /([\\^$.*+?()[\]{}|])/g;
		  var UNICODE_SET = regenerate().addRange(0x0, 0x10FFFF);
		  var ASTRAL_SET = regenerate().addRange(0x10000, 0x10FFFF);
		  var NEWLINE_SET = regenerate().add(0x000A, 0x000D, 0x2028, 0x2029);
		  var DOT_SET_UNICODE = UNICODE_SET.clone().remove(NEWLINE_SET);
		  var getCharacterClassEscapeSet = function getCharacterClassEscapeSet(character, unicode, ignoreCase) {
		    if (unicode) {
		      if (ignoreCase) {
		        return ESCAPE_SETS.UNICODE_IGNORE_CASE.get(character);
		      }
		      return ESCAPE_SETS.UNICODE.get(character);
		    }
		    return ESCAPE_SETS.REGULAR.get(character);
		  };
		  var getUnicodeDotSet = function getUnicodeDotSet(dotAll) {
		    return dotAll ? UNICODE_SET : DOT_SET_UNICODE;
		  };
		  var getUnicodePropertyValueSet = function getUnicodePropertyValueSet(property, value) {
		    var path = value ? property + "/" + value : "Binary_Property/" + property;
		    try {
		      return createCommonjsRequire("/node_modules/regexpu-core")("regenerate-unicode-properties/" + path + ".js");
		    } catch (exception) {
		      throw new Error("Failed to recognize value `" + value + "` for property " + ("`" + property + "`."));
		    }
		  };
		  var handleLoneUnicodePropertyNameOrValue = function handleLoneUnicodePropertyNameOrValue(value) {
		    try {
		      var _property = 'General_Category';
		      var category = unicodeMatchPropertyValue(_property, value);
		      return getUnicodePropertyValueSet(_property, category);
		    } catch (exception) {}
		    try {
		      return getUnicodePropertyValueSet('Property_of_Strings', value);
		    } catch (exception) {}
		    var property = unicodeMatchProperty(value);
		    return getUnicodePropertyValueSet(property);
		  };
		  var getUnicodePropertyEscapeSet = function getUnicodePropertyEscapeSet(value, isNegative) {
		    var parts = value.split('=');
		    var firstPart = parts[0];
		    var set;
		    if (parts.length == 1) {
		      set = handleLoneUnicodePropertyNameOrValue(firstPart);
		    } else {
		      var property = unicodeMatchProperty(firstPart);
		      var _value = unicodeMatchPropertyValue(property, parts[1]);
		      set = getUnicodePropertyValueSet(property, _value);
		    }
		    if (isNegative) {
		      if (set.strings) {
		        throw new Error('Cannot negate Unicode property of strings');
		      }
		      return {
		        characters: UNICODE_SET.clone().remove(set.characters),
		        strings: new Set()
		      };
		    }
		    return {
		      characters: set.characters.clone(),
		      strings: set.strings ? new Set(set.strings.map(function (str) {
		        return str.replace(SPECIAL_CHARS, '\\$1');
		      })) : new Set()
		    };
		  };
		  var getUnicodePropertyEscapeCharacterClassData = function getUnicodePropertyEscapeCharacterClassData(property, isNegative) {
		    var set = getUnicodePropertyEscapeSet(property, isNegative);
		    var data = getCharacterClassEmptyData();
		    data.singleChars = set.characters;
		    if (set.strings.size > 0) {
		      data.longStrings = set.strings;
		      data.maybeIncludesStrings = true;
		    }
		    return data;
		  };
		  function configNeedCaseFoldAscii() {
		    return !!config.modifiersData.i;
		  }
		  function configNeedCaseFoldUnicode() {
		    if (config.modifiersData.i === false) return false;
		    if (!config.transform.unicodeFlag) return false;
		    return Boolean(config.modifiersData.i || config.flags.ignoreCase);
		  }
		  regenerate.prototype.iuAddRange = function (min, max) {
		    var $this = this;
		    do {
		      var folded = caseFold(min, configNeedCaseFoldAscii(), configNeedCaseFoldUnicode());
		      if (folded) {
		        $this.add(folded);
		      }
		    } while (++min <= max);
		    return $this;
		  };
		  regenerate.prototype.iuRemoveRange = function (min, max) {
		    var $this = this;
		    do {
		      var folded = caseFold(min, configNeedCaseFoldAscii(), configNeedCaseFoldUnicode());
		      if (folded) {
		        $this.remove(folded);
		      }
		    } while (++min <= max);
		    return $this;
		  };
		  var update = function update(item, pattern) {
		    var tree = parse(pattern, config.useUnicodeFlag ? 'u' : '', {
		      lookbehind: true,
		      namedGroups: true,
		      unicodePropertyEscape: true,
		      unicodeSet: true,
		      modifiers: true
		    });
		    switch (tree.type) {
		      case 'characterClass':
		      case 'group':
		      case 'value':
		        break;
		      default:
		        tree = wrap(tree, pattern);
		    }
		    Object.assign(item, tree);
		  };
		  var wrap = function wrap(tree, pattern) {
		    return {
		      'type': 'group',
		      'behavior': 'ignore',
		      'body': [tree],
		      'raw': "(?:" + pattern + ")"
		    };
		  };
		  var caseFold = function caseFold(codePoint, includeAscii, includeUnicode) {
		    var folded = (includeUnicode ? iuMappings.get(codePoint) : undefined) || [];
		    if (typeof folded === 'number') folded = [folded];
		    if (includeAscii) {
		      if (codePoint >= 0x41 && codePoint <= 0x5A) {
		        folded.push(codePoint + 0x20);
		      } else if (codePoint >= 0x61 && codePoint <= 0x7A) {
		        folded.push(codePoint - 0x20);
		      }
		    }
		    return folded.length == 0 ? false : folded;
		  };
		  var buildHandler = function buildHandler(action) {
		    switch (action) {
		      case 'union':
		        return {
		          single: function single(data, cp) {
		            data.singleChars.add(cp);
		          },
		          regSet: function regSet(data, set2) {
		            data.singleChars.add(set2);
		          },
		          range: function range(data, start, end) {
		            data.singleChars.addRange(start, end);
		          },
		          iuRange: function iuRange(data, start, end) {
		            data.singleChars.iuAddRange(start, end);
		          },
		          nested: function nested(data, nestedData) {
		            data.singleChars.add(nestedData.singleChars);
		            for (var _iterator = _createForOfIteratorHelperLoose(nestedData.longStrings), _step; !(_step = _iterator()).done;) {
		              var str = _step.value;
		              data.longStrings.add(str);
		            }
		            if (nestedData.maybeIncludesStrings) data.maybeIncludesStrings = true;
		          }
		        };
		      case 'union-negative':
		        {
		          var regSet = function regSet(data, set2) {
		            data.singleChars = UNICODE_SET.clone().remove(set2).add(data.singleChars);
		          };
		          return {
		            single: function single(data, cp) {
		              var unicode = UNICODE_SET.clone();
		              data.singleChars = data.singleChars.contains(cp) ? unicode : unicode.remove(cp);
		            },
		            regSet: regSet,
		            range: function range(data, start, end) {
		              data.singleChars = UNICODE_SET.clone().removeRange(start, end).add(data.singleChars);
		            },
		            iuRange: function iuRange(data, start, end) {
		              data.singleChars = UNICODE_SET.clone().iuRemoveRange(start, end).add(data.singleChars);
		            },
		            nested: function nested(data, nestedData) {
		              regSet(data, nestedData.singleChars);
		              if (nestedData.maybeIncludesStrings) throw new Error('ASSERTION ERROR');
		            }
		          };
		        }
		      case 'intersection':
		        {
		          var _regSet = function _regSet(data, set2) {
		            if (data.first) data.singleChars = set2;else data.singleChars.intersection(set2);
		          };
		          return {
		            single: function single(data, cp) {
		              data.singleChars = data.first || data.singleChars.contains(cp) ? regenerate(cp) : regenerate();
		              data.longStrings.clear();
		              data.maybeIncludesStrings = false;
		            },
		            regSet: function regSet(data, set) {
		              _regSet(data, set);
		              data.longStrings.clear();
		              data.maybeIncludesStrings = false;
		            },
		            range: function range(data, start, end) {
		              if (data.first) data.singleChars.addRange(start, end);else data.singleChars.intersection(regenerate().addRange(start, end));
		              data.longStrings.clear();
		              data.maybeIncludesStrings = false;
		            },
		            iuRange: function iuRange(data, start, end) {
		              if (data.first) data.singleChars.iuAddRange(start, end);else data.singleChars.intersection(regenerate().iuAddRange(start, end));
		              data.longStrings.clear();
		              data.maybeIncludesStrings = false;
		            },
		            nested: function nested(data, nestedData) {
		              _regSet(data, nestedData.singleChars);
		              if (data.first) {
		                data.longStrings = nestedData.longStrings;
		                data.maybeIncludesStrings = nestedData.maybeIncludesStrings;
		              } else {
		                for (var _iterator2 = _createForOfIteratorHelperLoose(data.longStrings), _step2; !(_step2 = _iterator2()).done;) {
		                  var str = _step2.value;
		                  if (!nestedData.longStrings.has(str)) data.longStrings["delete"](str);
		                }
		                if (!nestedData.maybeIncludesStrings) data.maybeIncludesStrings = false;
		              }
		            }
		          };
		        }
		      case 'subtraction':
		        {
		          var _regSet2 = function _regSet2(data, set2) {
		            if (data.first) data.singleChars.add(set2);else data.singleChars.remove(set2);
		          };
		          return {
		            single: function single(data, cp) {
		              if (data.first) data.singleChars.add(cp);else data.singleChars.remove(cp);
		            },
		            regSet: _regSet2,
		            range: function range(data, start, end) {
		              if (data.first) data.singleChars.addRange(start, end);else data.singleChars.removeRange(start, end);
		            },
		            iuRange: function iuRange(data, start, end) {
		              if (data.first) data.singleChars.iuAddRange(start, end);else data.singleChars.iuRemoveRange(start, end);
		            },
		            nested: function nested(data, nestedData) {
		              _regSet2(data, nestedData.singleChars);
		              if (data.first) {
		                data.longStrings = nestedData.longStrings;
		                data.maybeIncludesStrings = nestedData.maybeIncludesStrings;
		              } else {
		                for (var _iterator3 = _createForOfIteratorHelperLoose(data.longStrings), _step3; !(_step3 = _iterator3()).done;) {
		                  var str = _step3.value;
		                  if (nestedData.longStrings.has(str)) data.longStrings["delete"](str);
		                }
		              }
		            }
		          };
		        }
		      default:
		        throw new Error("Unknown set action: " + characterClassItem.kind);
		    }
		  };
		  var getCharacterClassEmptyData = function getCharacterClassEmptyData() {
		    return {
		      transformed: config.transform.unicodeFlag,
		      singleChars: regenerate(),
		      longStrings: new Set(),
		      hasEmptyString: false,
		      first: true,
		      maybeIncludesStrings: false
		    };
		  };
		  var maybeFold = function maybeFold(codePoint) {
		    var caseFoldAscii = configNeedCaseFoldAscii();
		    var caseFoldUnicode = configNeedCaseFoldUnicode();
		    if (caseFoldAscii || caseFoldUnicode) {
		      var folded = caseFold(codePoint, caseFoldAscii, caseFoldUnicode);
		      if (folded) {
		        return [codePoint, folded];
		      }
		    }
		    return [codePoint];
		  };
		  var computeClassStrings = function computeClassStrings(classStrings, regenerateOptions) {
		    var data = getCharacterClassEmptyData();
		    var caseFoldAscii = configNeedCaseFoldAscii();
		    var caseFoldUnicode = configNeedCaseFoldUnicode();
		    for (var _iterator4 = _createForOfIteratorHelperLoose(classStrings.strings), _step4; !(_step4 = _iterator4()).done;) {
		      var string = _step4.value;
		      if (string.characters.length === 1) {
		        maybeFold(string.characters[0].codePoint).forEach(function (cp) {
		          data.singleChars.add(cp);
		        });
		      } else {
		        var stringifiedString = void 0;
		        if (caseFoldUnicode || caseFoldAscii) {
		          stringifiedString = '';
		          for (var _iterator5 = _createForOfIteratorHelperLoose(string.characters), _step5; !(_step5 = _iterator5()).done;) {
		            var ch = _step5.value;
		            var set = regenerate(ch.codePoint);
		            var folded = maybeFold(ch.codePoint);
		            if (folded) set.add(folded);
		            stringifiedString += set.toString(regenerateOptions);
		          }
		        } else {
		          stringifiedString = string.characters.map(function (ch) {
		            return generate(ch);
		          }).join('');
		        }
		        data.longStrings.add(stringifiedString);
		        data.maybeIncludesStrings = true;
		      }
		    }
		    return data;
		  };
		  var computeCharacterClass = function computeCharacterClass(characterClassItem, regenerateOptions) {
		    var data = getCharacterClassEmptyData();
		    var handlePositive;
		    var handleNegative;
		    switch (characterClassItem.kind) {
		      case 'union':
		        handlePositive = buildHandler('union');
		        handleNegative = buildHandler('union-negative');
		        break;
		      case 'intersection':
		        handlePositive = buildHandler('intersection');
		        handleNegative = buildHandler('subtraction');
		        break;
		      case 'subtraction':
		        handlePositive = buildHandler('subtraction');
		        handleNegative = buildHandler('intersection');
		        break;
		      default:
		        throw new Error("Unknown character class kind: " + characterClassItem.kind);
		    }
		    var caseFoldAscii = configNeedCaseFoldAscii();
		    var caseFoldUnicode = configNeedCaseFoldUnicode();
		    for (var _iterator6 = _createForOfIteratorHelperLoose(characterClassItem.body), _step6; !(_step6 = _iterator6()).done;) {
		      var item = _step6.value;
		      switch (item.type) {
		        case 'value':
		          maybeFold(item.codePoint).forEach(function (cp) {
		            handlePositive.single(data, cp);
		          });
		          break;
		        case 'characterClassRange':
		          var min = item.min.codePoint;
		          var max = item.max.codePoint;
		          handlePositive.range(data, min, max);
		          if (caseFoldAscii || caseFoldUnicode) {
		            handlePositive.iuRange(data, min, max);
		            data.transformed = true;
		          }
		          break;
		        case 'characterClassEscape':
		          handlePositive.regSet(data, getCharacterClassEscapeSet(item.value, config.flags.unicode, config.flags.ignoreCase));
		          break;
		        case 'unicodePropertyEscape':
		          var nestedData = getUnicodePropertyEscapeCharacterClassData(item.value, item.negative);
		          handlePositive.nested(data, nestedData);
		          data.transformed = data.transformed || config.transform.unicodePropertyEscapes || config.transform.unicodeSetsFlag && nestedData.maybeIncludesStrings;
		          break;
		        case 'characterClass':
		          var handler = item.negative ? handleNegative : handlePositive;
		          var res = computeCharacterClass(item, regenerateOptions);
		          handler.nested(data, res);
		          data.transformed = true;
		          break;
		        case 'classStrings':
		          handlePositive.nested(data, computeClassStrings(item, regenerateOptions));
		          data.transformed = true;
		          break;
		        default:
		          throw new Error("Unknown term type: " + item.type);
		      }
		      data.first = false;
		    }
		    if (characterClassItem.negative && data.maybeIncludesStrings) {
		      throw new SyntaxError('Cannot negate set containing strings');
		    }
		    return data;
		  };
		  var processCharacterClass = function processCharacterClass(characterClassItem, regenerateOptions, computed) {
		    if (computed === void 0) {
		      computed = computeCharacterClass(characterClassItem, regenerateOptions);
		    }
		    var negative = characterClassItem.negative;
		    var _computed = computed,
		      singleChars = _computed.singleChars,
		      transformed = _computed.transformed,
		      longStrings = _computed.longStrings;
		    if (transformed) {
		      var setStr = singleChars.toString(regenerateOptions);
		      if (negative) {
		        if (config.useUnicodeFlag) {
		          update(characterClassItem, "[^" + (setStr[0] === '[' ? setStr.slice(1, -1) : setStr) + "]");
		        } else {
		          if (config.flags.unicode) {
		            if (config.flags.ignoreCase) {
		              var astralCharsSet = singleChars.clone().intersection(ASTRAL_SET);
		              var surrogateOrBMPSetStr = singleChars.clone().remove(astralCharsSet).addRange(0xd800, 0xdfff).toString({
		                bmpOnly: true
		              });
		              var astralNegativeSetStr = ASTRAL_SET.clone().remove(astralCharsSet).toString(regenerateOptions);
		              update(characterClassItem, "(?!" + surrogateOrBMPSetStr + ")[\\s\\S]|" + astralNegativeSetStr);
		            } else {
		              update(characterClassItem, UNICODE_SET.clone().remove(singleChars).toString(regenerateOptions));
		            }
		          } else {
		            update(characterClassItem, "(?!" + setStr + ")[\\s\\S]");
		          }
		        }
		      } else {
		        var hasEmptyString = longStrings.has('');
		        var pieces = Array.from(longStrings).sort(function (a, b) {
		          return b.length - a.length;
		        });
		        if (setStr !== '[]' || longStrings.size === 0) {
		          pieces.splice(pieces.length - (hasEmptyString ? 1 : 0), 0, setStr);
		        }
		        update(characterClassItem, pieces.join('|'));
		      }
		    }
		    return characterClassItem;
		  };
		  var assertNoUnmatchedReferences = function assertNoUnmatchedReferences(groups) {
		    var unmatchedReferencesNames = Object.keys(groups.unmatchedReferences);
		    if (unmatchedReferencesNames.length > 0) {
		      throw new Error("Unknown group names: " + unmatchedReferencesNames);
		    }
		  };
		  var processModifiers = function processModifiers(item, regenerateOptions, groups) {
		    var enabling = item.modifierFlags.enabling;
		    var disabling = item.modifierFlags.disabling;
		    delete item.modifierFlags;
		    item.behavior = 'ignore';
		    var oldData = Object.assign({}, config.modifiersData);
		    enabling.split('').forEach(function (flag) {
		      config.modifiersData[flag] = true;
		    });
		    disabling.split('').forEach(function (flag) {
		      config.modifiersData[flag] = false;
		    });
		    item.body = item.body.map(function (term) {
		      return processTerm(term, regenerateOptions, groups);
		    });
		    config.modifiersData = oldData;
		    return item;
		  };
		  var processTerm = function processTerm(item, regenerateOptions, groups) {
		    switch (item.type) {
		      case 'dot':
		        if (config.transform.unicodeFlag) {
		          update(item, getUnicodeDotSet(config.flags.dotAll || config.modifiersData.s).toString(regenerateOptions));
		        } else if (config.transform.dotAllFlag || config.modifiersData.s) {
		          update(item, '[\\s\\S]');
		        }
		        break;
		      case 'characterClass':
		        item = processCharacterClass(item, regenerateOptions);
		        break;
		      case 'unicodePropertyEscape':
		        var data = getUnicodePropertyEscapeCharacterClassData(item.value, item.negative);
		        if (data.maybeIncludesStrings) {
		          if (!config.flags.unicodeSets) {
		            throw new Error('Properties of strings are only supported when using the unicodeSets (v) flag.');
		          }
		          if (config.transform.unicodeSetsFlag) {
		            data.transformed = true;
		            item = processCharacterClass(item, regenerateOptions, data);
		          }
		        } else if (config.transform.unicodePropertyEscapes) {
		          update(item, data.singleChars.toString(regenerateOptions));
		        }
		        break;
		      case 'characterClassEscape':
		        if (config.transform.unicodeFlag) {
		          update(item, getCharacterClassEscapeSet(item.value, true, config.flags.ignoreCase).toString(regenerateOptions));
		        }
		        break;
		      case 'group':
		        if (item.behavior == 'normal') {
		          groups.lastIndex++;
		        }
		        if (item.name) {
		          var name = item.name.value;
		          if (groups.namesConflicts[name]) {
		            throw new Error("Group '" + name + "' has already been defined in this context.");
		          }
		          groups.namesConflicts[name] = true;
		          if (config.transform.namedGroups) {
		            delete item.name;
		          }
		          var index = groups.lastIndex;
		          if (!groups.names[name]) {
		            groups.names[name] = [];
		          }
		          groups.names[name].push(index);
		          if (groups.onNamedGroup) {
		            groups.onNamedGroup.call(null, name, index);
		          }
		          if (groups.unmatchedReferences[name]) {
		            delete groups.unmatchedReferences[name];
		          }
		        }
		        if (item.modifierFlags && config.transform.modifiers) {
		          return processModifiers(item, regenerateOptions, groups);
		        }
		      case 'quantifier':
		        item.body = item.body.map(function (term) {
		          return processTerm(term, regenerateOptions, groups);
		        });
		        break;
		      case 'disjunction':
		        var outerNamesConflicts = groups.namesConflicts;
		        item.body = item.body.map(function (term) {
		          groups.namesConflicts = Object.create(outerNamesConflicts);
		          return processTerm(term, regenerateOptions, groups);
		        });
		        break;
		      case 'alternative':
		        item.body = flatMap$1(item.body, function (term) {
		          var res = processTerm(term, regenerateOptions, groups);
		          return res.type === 'alternative' ? res.body : res;
		        });
		        break;
		      case 'value':
		        var codePoint = item.codePoint;
		        var set = regenerate(codePoint);
		        var folded = maybeFold(codePoint);
		        set.add(folded);
		        update(item, set.toString(regenerateOptions));
		        break;
		      case 'reference':
		        if (item.name) {
		          var _name = item.name.value;
		          var indexes = groups.names[_name];
		          if (!indexes) {
		            groups.unmatchedReferences[_name] = true;
		          }
		          if (config.transform.namedGroups) {
		            if (indexes) {
		              var body = indexes.map(function (index) {
		                return {
		                  'type': 'reference',
		                  'matchIndex': index,
		                  'raw': '\\' + index
		                };
		              });
		              if (body.length === 1) {
		                return body[0];
		              }
		              return {
		                'type': 'alternative',
		                'body': body,
		                'raw': body.map(function (term) {
		                  return term.raw;
		                }).join('')
		              };
		            }
		            return {
		              'type': 'group',
		              'behavior': 'ignore',
		              'body': [],
		              'raw': '(?:)'
		            };
		          }
		        }
		        break;
		      case 'anchor':
		        if (config.modifiersData.m) {
		          if (item.kind == 'start') {
		            update(item, "(?:^|(?<=" + NEWLINE_SET.toString() + "))");
		          } else if (item.kind == 'end') {
		            update(item, "(?:$|(?=" + NEWLINE_SET.toString() + "))");
		          }
		        }
		      case 'empty':
		        break;
		      default:
		        throw new Error("Unknown term type: " + item.type);
		    }
		    return item;
		  };
		  var config = {
		    'flags': {
		      'ignoreCase': false,
		      'unicode': false,
		      'unicodeSets': false,
		      'dotAll': false,
		      'multiline': false
		    },
		    'transform': {
		      'dotAllFlag': false,
		      'unicodeFlag': false,
		      'unicodeSetsFlag': false,
		      'unicodePropertyEscapes': false,
		      'namedGroups': false,
		      'modifiers': false
		    },
		    'modifiersData': {
		      'i': undefined,
		      's': undefined,
		      'm': undefined
		    },
		    get useUnicodeFlag() {
		      return (this.flags.unicode || this.flags.unicodeSets) && !this.transform.unicodeFlag;
		    }
		  };
		  var validateOptions = function validateOptions(options) {
		    if (!options) return;
		    for (var _i = 0, _Object$keys = Object.keys(options); _i < _Object$keys.length; _i++) {
		      var key = _Object$keys[_i];
		      var value = options[key];
		      switch (key) {
		        case 'dotAllFlag':
		        case 'unicodeFlag':
		        case 'unicodePropertyEscapes':
		        case 'namedGroups':
		          if (value != null && value !== false && value !== 'transform') {
		            throw new Error("." + key + " must be false (default) or 'transform'.");
		          }
		          break;
		        case 'modifiers':
		        case 'unicodeSetsFlag':
		          if (value != null && value !== false && value !== 'parse' && value !== 'transform') {
		            throw new Error("." + key + " must be false (default), 'parse' or 'transform'.");
		          }
		          break;
		        case 'onNamedGroup':
		        case 'onNewFlags':
		          if (value != null && typeof value !== 'function') {
		            throw new Error("." + key + " must be a function.");
		          }
		          break;
		        default:
		          throw new Error("." + key + " is not a valid regexpu-core option.");
		      }
		    }
		  };
		  var hasFlag = function hasFlag(flags, flag) {
		    return flags ? flags.includes(flag) : false;
		  };
		  var transform$2 = function transform(options, name) {
		    return options ? options[name] === 'transform' : false;
		  };
		  var rewritePattern = function rewritePattern(pattern, flags, options) {
		    validateOptions(options);
		    config.flags.unicode = hasFlag(flags, 'u');
		    config.flags.unicodeSets = hasFlag(flags, 'v');
		    config.flags.ignoreCase = hasFlag(flags, 'i');
		    config.flags.dotAll = hasFlag(flags, 's');
		    config.flags.multiline = hasFlag(flags, 'm');
		    config.transform.dotAllFlag = config.flags.dotAll && transform$2(options, 'dotAllFlag');
		    config.transform.unicodeFlag = (config.flags.unicode || config.flags.unicodeSets) && transform$2(options, 'unicodeFlag');
		    config.transform.unicodeSetsFlag = config.flags.unicodeSets && transform$2(options, 'unicodeSetsFlag');
		    config.transform.unicodePropertyEscapes = config.flags.unicode && (transform$2(options, 'unicodeFlag') || transform$2(options, 'unicodePropertyEscapes'));
		    config.transform.namedGroups = transform$2(options, 'namedGroups');
		    config.transform.modifiers = transform$2(options, 'modifiers');
		    config.modifiersData.i = undefined;
		    config.modifiersData.s = undefined;
		    config.modifiersData.m = undefined;
		    var regjsparserFeatures = {
		      'unicodeSet': Boolean(options && options.unicodeSetsFlag),
		      'modifiers': Boolean(options && options.modifiers),
		      'unicodePropertyEscape': true,
		      'namedGroups': true,
		      'lookbehind': true
		    };
		    var regenerateOptions = {
		      'hasUnicodeFlag': config.useUnicodeFlag,
		      'bmpOnly': !config.flags.unicode
		    };
		    var groups = {
		      'onNamedGroup': options && options.onNamedGroup,
		      'lastIndex': 0,
		      'names': Object.create(null),
		      'namesConflicts': Object.create(null),
		      'unmatchedReferences': Object.create(null)
		    };
		    var tree = parse(pattern, flags, regjsparserFeatures);
		    if (config.transform.modifiers) {
		      if (/\(\?[a-z]*-[a-z]+:/.test(pattern)) {
		        var allDisabledModifiers = Object.create(null);
		        var itemStack = [tree];
		        var node;
		        while (node = itemStack.pop(), node != undefined) {
		          if (Array.isArray(node)) {
		            Array.prototype.push.apply(itemStack, node);
		          } else if (typeof node == 'object' && node != null) {
		            for (var _i2 = 0, _Object$keys2 = Object.keys(node); _i2 < _Object$keys2.length; _i2++) {
		              var key = _Object$keys2[_i2];
		              var value = node[key];
		              if (key == 'modifierFlags') {
		                if (value.disabling.length > 0) {
		                  value.disabling.split('').forEach(function (flag) {
		                    allDisabledModifiers[flag] = true;
		                  });
		                }
		              } else if (typeof value == 'object' && value != null) {
		                itemStack.push(value);
		              }
		            }
		          }
		        }
		        for (var _i3 = 0, _Object$keys3 = Object.keys(allDisabledModifiers); _i3 < _Object$keys3.length; _i3++) {
		          var flag = _Object$keys3[_i3];
		          config.modifiersData[flag] = true;
		        }
		      }
		    }
		    processTerm(tree, regenerateOptions, groups);
		    assertNoUnmatchedReferences(groups);
		    var onNewFlags = options && options.onNewFlags;
		    if (onNewFlags) {
		      var newFlags = flags.split('').filter(function (flag) {
		        return !config.modifiersData[flag];
		      }).join('');
		      if (config.transform.unicodeSetsFlag) {
		        newFlags = newFlags.replace('v', 'u');
		      }
		      if (config.transform.unicodeFlag) {
		        newFlags = newFlags.replace('u', '');
		      }
		      if (config.transform.dotAllFlag === 'transform') {
		        newFlags = newFlags.replace('s', '');
		      }
		      onNewFlags(newFlags);
		    }
		    return generate(tree);
		  };
		  var rewritePattern_1 = rewritePattern;

		  function bool$3(value) {
		    if (value == null) return false;
		    return value && value !== "false" && value !== "0";
		  }
		  var semver$6 = bool$3(browser$1$1.env["BABEL_8_BREAKING"]) ? requireSemver$2() : requireSemver$2();

		  var FEATURES = Object.freeze({
		    unicodeFlag: 1 << 0,
		    dotAllFlag: 1 << 1,
		    unicodePropertyEscape: 1 << 2,
		    namedCaptureGroups: 1 << 3,
		    unicodeSetsFlag_syntax: 1 << 4,
		    unicodeSetsFlag: 1 << 5,
		    duplicateNamedCaptureGroups: 1 << 6,
		    modifiers: 1 << 7
		  });
		  var featuresKey = "@babel/plugin-regexp-features/featuresKey";
		  var runtimeKey = "@babel/plugin-regexp-features/runtimeKey";
		  function enableFeature(features, feature) {
		    return features | feature;
		  }
		  function hasFeature(features, feature) {
		    return !!(features & feature);
		  }

		  function generateRegexpuOptions(pattern, toTransform) {
		    var feat = function feat(name, ok) {
		      if (ok === void 0) {
		        ok = "transform";
		      }
		      return hasFeature(toTransform, FEATURES[name]) ? ok : false;
		    };
		    var featDuplicateNamedGroups = function featDuplicateNamedGroups() {
		      if (!feat("duplicateNamedCaptureGroups")) return false;
		      var regex = /\(\?<([^>]+)>/g;
		      var seen = new Set();
		      for (var match; match = regex.exec(pattern); seen.add(match[1])) {
		        if (seen.has(match[1])) return "transform";
		      }
		      return false;
		    };
		    return {
		      unicodeFlag: feat("unicodeFlag"),
		      unicodeSetsFlag: feat("unicodeSetsFlag") || "parse",
		      dotAllFlag: feat("dotAllFlag"),
		      unicodePropertyEscapes: feat("unicodePropertyEscape"),
		      namedGroups: feat("namedCaptureGroups") || featDuplicateNamedGroups(),
		      onNamedGroup: function onNamedGroup() {},
		      modifiers: feat("modifiers")
		    };
		  }
		  function canSkipRegexpu(node, options) {
		    var flags = node.flags,
		      pattern = node.pattern;
		    if (flags.includes("v")) {
		      if (options.unicodeSetsFlag === "transform") return false;
		    }
		    if (flags.includes("u")) {
		      if (options.unicodeFlag === "transform") return false;
		      if (options.unicodePropertyEscapes === "transform" && /\\[pP]{/.test(pattern)) {
		        return false;
		      }
		    }
		    if (flags.includes("s")) {
		      if (options.dotAllFlag === "transform") return false;
		    }
		    if (options.namedGroups === "transform" && /\(\?<(?![=!])/.test(pattern)) {
		      return false;
		    }
		    if (options.modifiers === "transform" && /\(\?[\w-]+:/.test(pattern)) {
		      return false;
		    }
		    return true;
		  }
		  function transformFlags(regexpuOptions, flags) {
		    if (regexpuOptions.unicodeSetsFlag === "transform") {
		      flags = flags.replace("v", "u");
		    }
		    if (regexpuOptions.unicodeFlag === "transform") {
		      flags = flags.replace("u", "");
		    }
		    if (regexpuOptions.dotAllFlag === "transform") {
		      flags = flags.replace("s", "");
		    }
		    return flags;
		  }

		  var versionKey = "@babel/plugin-regexp-features/version";
		  function createRegExpFeaturePlugin(_ref) {
		    var name = _ref.name,
		      feature = _ref.feature,
		      _ref$options = _ref.options,
		      options = _ref$options === void 0 ? {} : _ref$options,
		      _ref$manipulateOption = _ref.manipulateOptions,
		      manipulateOptions = _ref$manipulateOption === void 0 ? function () {} : _ref$manipulateOption;
		    return {
		      name: name,
		      manipulateOptions: manipulateOptions,
		      pre: function pre() {
		        var _file$get;
		        var file = this.file;
		        var features = (_file$get = file.get(featuresKey)) != null ? _file$get : 0;
		        var newFeatures = enableFeature(features, FEATURES[feature]);
		        var useUnicodeFlag = options.useUnicodeFlag,
		          runtime = options.runtime;
		        if (useUnicodeFlag === false) {
		          newFeatures = enableFeature(newFeatures, FEATURES.unicodeFlag);
		        }
		        if (newFeatures !== features) {
		          file.set(featuresKey, newFeatures);
		        }
		        if (runtime !== undefined) {
		          if (file.has(runtimeKey) && file.get(runtimeKey) !== runtime && hasFeature(newFeatures, FEATURES.duplicateNamedCaptureGroups)) {
		            throw new Error("The 'runtime' option must be the same for " + "'@babel/plugin-transform-named-capturing-groups-regex' and " + "'@babel/plugin-proposal-duplicate-named-capturing-groups-regex'.");
		          }
		          if (feature === "namedCaptureGroups") {
		            if (!runtime || !file.has(runtimeKey)) file.set(runtimeKey, runtime);
		          } else {
		            file.set(runtimeKey, runtime);
		          }
		        }
		        {
		          if (typeof file.get(versionKey) === "number") {
		            file.set(versionKey, "7.22.15");
		            return;
		          }
		        }
		        if (!file.get(versionKey) || semver$6.lt(file.get(versionKey), "7.22.15")) {
		          file.set(versionKey, "7.22.15");
		        }
		      },
		      visitor: {
		        RegExpLiteral: function RegExpLiteral(path) {
		          var _file$get2, _newFlags;
		          var node = path.node;
		          var file = this.file;
		          var features = file.get(featuresKey);
		          var runtime = (_file$get2 = file.get(runtimeKey)) != null ? _file$get2 : true;
		          var regexpuOptions = generateRegexpuOptions(node.pattern, features);
		          if (canSkipRegexpu(node, regexpuOptions)) {
		            return;
		          }
		          var namedCaptureGroups = {
		            __proto__: null
		          };
		          if (regexpuOptions.namedGroups === "transform") {
		            regexpuOptions.onNamedGroup = function (name, index) {
		              var prev = namedCaptureGroups[name];
		              if (typeof prev === "number") {
		                namedCaptureGroups[name] = [prev, index];
		              } else if (Array.isArray(prev)) {
		                prev.push(index);
		              } else {
		                namedCaptureGroups[name] = index;
		              }
		            };
		          }
		          var newFlags;
		          if (regexpuOptions.modifiers === "transform") {
		            regexpuOptions.onNewFlags = function (flags) {
		              newFlags = flags;
		            };
		          }
		          node.pattern = rewritePattern_1(node.pattern, node.flags, regexpuOptions);
		          if (regexpuOptions.namedGroups === "transform" && Object.keys(namedCaptureGroups).length > 0 && runtime && !isRegExpTest(path)) {
		            var call = callExpression$d(this.addHelper("wrapRegExp"), [node, valueToNode$1(namedCaptureGroups)]);
		            annotateAsPure(call);
		            path.replaceWith(call);
		          }
		          node.flags = transformFlags(regexpuOptions, (_newFlags = newFlags) != null ? _newFlags : node.flags);
		        }
		      }
		    };
		  }
		  function isRegExpTest(path) {
		    return path.parentPath.isMemberExpression({
		      object: path.node,
		      computed: false
		    }) && path.parentPath.get("property").isIdentifier({
		      name: "test"
		    });
		  }

		  var proposalDuplicateNamedCapturingGroupsRegex = declare(function (api, options) {
		    api.assertVersion("*");
		    var runtime = options.runtime;
		    if (runtime !== undefined && typeof runtime !== "boolean") {
		      throw new Error("The 'runtime' option must be boolean");
		    }
		    return createRegExpFeaturePlugin({
		      name: "proposal-duplicate-named-capturing-groups-regex",
		      feature: "duplicateNamedCaptureGroups",
		      options: {
		        runtime: runtime
		      }
		    });
		  });

		  var SUPPORTED_MODULES = ["commonjs", "amd", "systemjs"];
		  var MODULES_NOT_FOUND = "@babel/plugin-transform-dynamic-import depends on a modules\ntransform plugin. Supported plugins are:\n - @babel/plugin-transform-modules-commonjs ^7.4.0\n - @babel/plugin-transform-modules-amd ^7.4.0\n - @babel/plugin-transform-modules-systemjs ^7.4.0\n\nIf you are using Webpack or Rollup and thus don't want\nBabel to transpile your imports and exports, you can use\nthe @babel/plugin-syntax-dynamic-import plugin and let your\nbundler handle dynamic imports.\n";
		  var proposalDynamicImport = declare(function (api) {
		    api.assertVersion("*");
		    return {
		      name: "transform-dynamic-import",
		      inherits: undefined,
		      pre: function pre() {
		        this.file.set("@babel/plugin-proposal-dynamic-import", "7.24.1");
		      },
		      visitor: {
		        Program: function Program() {
		          var modules = this.file.get("@babel/plugin-transform-modules-*");
		          if (!SUPPORTED_MODULES.includes(modules)) {
		            throw new Error(MODULES_NOT_FOUND);
		          }
		        }
		      }
		    };
		  });

		  var proposalExportDefaultFrom = declare(function (api) {
		    api.assertVersion("*");
		    return {
		      name: "proposal-export-default-from",
		      inherits: syntaxExportDefaultFrom,
		      visitor: {
		        ExportNamedDeclaration: function ExportNamedDeclaration(path) {
		          var node = path.node;
		          var specifiers = node.specifiers,
		            source = node.source;
		          if (!isExportDefaultSpecifier$1(specifiers[0])) return;
		          var _specifiers$shift = specifiers.shift(),
		            exported = _specifiers$shift.exported;
		          if (specifiers.every(function (s) {
		            return isExportSpecifier(s);
		          })) {
		            specifiers.unshift(exportSpecifier$2(identifier$j("default"), exported));
		            return;
		          }
		          path.insertBefore(exportNamedDeclaration$2(null, [exportSpecifier$2(identifier$j("default"), exported)], cloneNode$j(source)));
		        }
		      }
		    };
		  });

		  var proposalExportNamespaceFrom = declare(function (api) {
		    api.assertVersion("*");
		    return {
		      name: "transform-export-namespace-from",
		      inherits: undefined,
		      visitor: {
		        ExportNamedDeclaration: function ExportNamedDeclaration(path) {
		          var _exported$name;
		          var node = path.node,
		            scope = path.scope;
		          var specifiers = node.specifiers;
		          var index = isExportDefaultSpecifier$1(specifiers[0]) ? 1 : 0;
		          if (!isExportNamespaceSpecifier$1(specifiers[index])) return;
		          var nodes = [];
		          if (index === 1) {
		            nodes.push(exportNamedDeclaration$2(null, [specifiers.shift()], node.source));
		          }
		          var specifier = specifiers.shift();
		          var exported = specifier.exported;
		          var uid = scope.generateUidIdentifier((_exported$name = exported.name) != null ? _exported$name : exported.value);
		          nodes.push(importDeclaration$1([importNamespaceSpecifier$1(uid)], cloneNode$j(node.source)), exportNamedDeclaration$2(null, [exportSpecifier$2(cloneNode$j(uid), exported)]));
		          if (node.specifiers.length >= 1) {
		            nodes.push(node);
		          }
		          var _path$replaceWithMult = path.replaceWithMultiple(nodes),
		            _path$replaceWithMult2 = _slicedToArray(_path$replaceWithMult, 1),
		            importDeclaration = _path$replaceWithMult2[0];
		          path.scope.registerDeclaration(importDeclaration);
		        }
		      }
		    };
		  });

		  var proposalFunctionBind = declare(function (api) {
		    api.assertVersion("*");
		    function getTempId(scope) {
		      var id = scope.path.getData("functionBind");
		      if (id) return cloneNode$j(id);
		      id = scope.generateDeclaredUidIdentifier("context");
		      return scope.path.setData("functionBind", id);
		    }
		    function getObject(bind) {
		      if (isExpression$4(bind.object)) {
		        return bind.object;
		      }
		      return bind.callee.object;
		    }
		    function getStaticContext(bind, scope) {
		      var object = getObject(bind);
		      return scope.isStatic(object) && (isSuper$3(object) ? thisExpression$4() : object);
		    }
		    function inferBindContext(bind, scope) {
		      var staticContext = getStaticContext(bind, scope);
		      if (staticContext) return cloneNode$j(staticContext);
		      var tempId = getTempId(scope);
		      if (bind.object) {
		        bind.callee = sequenceExpression$8([assignmentExpression$d("=", tempId, bind.object), bind.callee]);
		      } else if (isMemberExpression$9(bind.callee)) {
		        bind.callee.object = assignmentExpression$d("=", tempId, bind.callee.object);
		      }
		      return cloneNode$j(tempId);
		    }
		    return {
		      name: "proposal-function-bind",
		      inherits: syntaxFunctionBind,
		      visitor: {
		        CallExpression: function CallExpression(_ref) {
		          var node = _ref.node,
		            scope = _ref.scope;
		          var bind = node.callee;
		          if (!isBindExpression(bind)) return;
		          var context = inferBindContext(bind, scope);
		          node.callee = memberExpression$c(bind.callee, identifier$j("call"));
		          node.arguments.unshift(context);
		        },
		        BindExpression: function BindExpression(path) {
		          var node = path.node,
		            scope = path.scope;
		          var context = inferBindContext(node, scope);
		          path.replaceWith(callExpression$d(memberExpression$c(node.callee, identifier$j("bind")), [context]));
		        }
		      }
		    };
		  });

		  var proposalFunctionSent = declare(function (api) {
		    api.assertVersion("*");
		    var isFunctionSent = function isFunctionSent(node) {
		      return isIdentifier$i(node.meta, {
		        name: "function"
		      }) && isIdentifier$i(node.property, {
		        name: "sent"
		      });
		    };
		    var hasBeenReplaced = function hasBeenReplaced(node, sentId) {
		      return isAssignmentExpression$3(node) && isIdentifier$i(node.left, {
		        name: sentId
		      });
		    };
		    var yieldVisitor = {
		      Function: function Function(path) {
		        path.skip();
		      },
		      YieldExpression: function YieldExpression(path) {
		        if (!hasBeenReplaced(path.parent, this.sentId)) {
		          path.replaceWith(assignmentExpression$d("=", identifier$j(this.sentId), path.node));
		        }
		      },
		      MetaProperty: function MetaProperty(path) {
		        if (isFunctionSent(path.node)) {
		          path.replaceWith(identifier$j(this.sentId));
		        }
		      }
		    };
		    return {
		      name: "proposal-function-sent",
		      inherits: syntaxFunctionSent,
		      visitor: {
		        MetaProperty: function MetaProperty(path, state) {
		          if (!isFunctionSent(path.node)) return;
		          var fnPath = path.getFunctionParent();
		          if (!fnPath.node.generator) {
		            throw new Error("Parent generator function not found");
		          }
		          var sentId = path.scope.generateUid("function.sent");
		          fnPath.traverse(yieldVisitor, {
		            sentId: sentId
		          });
		          fnPath.node.body.body.unshift(variableDeclaration$8("let", [variableDeclarator$8(identifier$j(sentId), yieldExpression$2())]));
		          wrapFunction(fnPath, state.addHelper("skipFirstGeneratorNext"));
		        }
		      }
		    };
		  });

		  var proposalJsonStrings = declare(function (api) {
		    api.assertVersion("*");
		    var regex = /(\\*)([\u2028\u2029])/g;
		    function replace(match, escapes, separator) {
		      var isEscaped = escapes.length % 2 === 1;
		      if (isEscaped) return match;
		      return escapes + "\\u" + separator.charCodeAt(0).toString(16);
		    }
		    return {
		      name: "transform-json-strings",
		      inherits: undefined,
		      visitor: {
		        "DirectiveLiteral|StringLiteral": function DirectiveLiteralStringLiteral(_ref) {
		          var node = _ref.node;
		          var extra = node.extra;
		          if (!(extra != null && extra.raw)) return;
		          extra.raw = extra.raw.replace(regex, replace);
		        }
		      }
		    };
		  });

		  var proposalLogicalAssignmentOperators = declare(function (api) {
		    api.assertVersion("*");
		    return {
		      name: "transform-logical-assignment-operators",
		      inherits: undefined,
		      visitor: {
		        AssignmentExpression: function AssignmentExpression(path) {
		          var node = path.node,
		            scope = path.scope;
		          var operator = node.operator,
		            left = node.left,
		            right = node.right;
		          var operatorTrunc = operator.slice(0, -1);
		          if (!LOGICAL_OPERATORS$3.includes(operatorTrunc)) {
		            return;
		          }
		          var lhs = cloneNode$j(left);
		          if (isMemberExpression$9(left)) {
		            var object = left.object,
		              property = left.property,
		              computed = left.computed;
		            var memo = scope.maybeGenerateMemoised(object);
		            if (memo) {
		              left.object = memo;
		              lhs.object = assignmentExpression$d("=", cloneNode$j(memo), object);
		            }
		            if (computed) {
		              var _memo = scope.maybeGenerateMemoised(property);
		              if (_memo) {
		                left.property = _memo;
		                lhs.property = assignmentExpression$d("=", cloneNode$j(_memo), property);
		              }
		            }
		          }
		          path.replaceWith(logicalExpression$3(operatorTrunc, lhs, assignmentExpression$d("=", left, right)));
		        }
		      }
		    };
		  });

		  var _templateObject$p;
		  var proposalNullishCoalescingOperator = declare(function (api, _ref) {
		    var _api$assumption;
		    var _ref$loose = _ref.loose,
		      loose = _ref$loose === void 0 ? false : _ref$loose;
		    api.assertVersion("*");
		    var noDocumentAll = (_api$assumption = api.assumption("noDocumentAll")) != null ? _api$assumption : loose;
		    return {
		      name: "transform-nullish-coalescing-operator",
		      inherits: undefined,
		      visitor: {
		        LogicalExpression: function LogicalExpression(path) {
		          var node = path.node,
		            scope = path.scope;
		          if (node.operator !== "??") {
		            return;
		          }
		          var ref;
		          var assignment;
		          if (scope.isStatic(node.left)) {
		            ref = node.left;
		            assignment = cloneNode$j(node.left);
		          } else if (scope.path.isPattern()) {
		            path.replaceWith(template$1.statement.ast(_templateObject$p || (_templateObject$p = _taggedTemplateLiteralLoose(["(() => ", ")()"])), path.node));
		            return;
		          } else {
		            ref = scope.generateUidIdentifierBasedOnNode(node.left);
		            scope.push({
		              id: cloneNode$j(ref)
		            });
		            assignment = assignmentExpression$d("=", ref, node.left);
		          }
		          path.replaceWith(conditionalExpression$5(noDocumentAll ? binaryExpression$5("!=", assignment, nullLiteral$2()) : logicalExpression$3("&&", binaryExpression$5("!==", assignment, nullLiteral$2()), binaryExpression$5("!==", cloneNode$j(ref), scope.buildUndefinedNode())), cloneNode$j(ref), node.right));
		        }
		      }
		    };
		  });

		  function remover(_ref) {
		    var _extra$raw;
		    var node = _ref.node;
		    var extra = node.extra;
		    if (extra != null && (_extra$raw = extra.raw) != null && _extra$raw.includes("_")) {
		      extra.raw = extra.raw.replace(/_/g, "");
		    }
		  }
		  var proposalNumericSeparator = declare(function (api) {
		    api.assertVersion("*");
		    return {
		      name: "transform-numeric-separator",
		      inherits: undefined,
		      visitor: {
		        NumericLiteral: remover,
		        BigIntLiteral: remover
		      }
		    };
		  });

		  function shouldStoreRHSInTemporaryVariable(node) {
		    if (!node) return false;
		    if (node.type === "ArrayPattern") {
		      var nonNullElements = node.elements.filter(function (element) {
		        return element !== null;
		      });
		      if (nonNullElements.length > 1) return true;else return shouldStoreRHSInTemporaryVariable(nonNullElements[0]);
		    } else if (node.type === "ObjectPattern") {
		      var properties = node.properties;
		      if (properties.length > 1) return true;else if (properties.length === 0) return false;else {
		        var firstProperty = properties[0];
		        if (firstProperty.type === "ObjectProperty") {
		          return shouldStoreRHSInTemporaryVariable(firstProperty.value);
		        } else {
		          return shouldStoreRHSInTemporaryVariable(firstProperty);
		        }
		      }
		    } else if (node.type === "AssignmentPattern") {
		      return shouldStoreRHSInTemporaryVariable(node.left);
		    } else if (node.type === "RestElement") {
		      if (node.argument.type === "Identifier") return true;
		      return shouldStoreRHSInTemporaryVariable(node.argument);
		    } else {
		      return false;
		    }
		  }

		  var compatData = {
		    "Object.assign": {
		      chrome: "49",
		      opera: "36",
		      edge: "13",
		      firefox: "36",
		      safari: "10",
		      node: "6",
		      deno: "1",
		      ios: "10",
		      samsung: "5",
		      opera_mobile: "36",
		      electron: "0.37"
		    }
		  };

		  var isAssignmentPattern = isAssignmentPattern$4,
		    isObjectProperty = isObjectProperty$4;
		  {
		    var node = identifier$j("a");
		    var property = objectProperty$1(identifier$j("key"), node);
		    var pattern = objectPattern$1([property]);
		    var ZERO_REFS = isReferenced$2(node, property, pattern) ? 1 : 0;
		  }
		  var proposalObjectRestSpread = declare(function (api, opts) {
		    var _api$assumption, _api$assumption2, _api$assumption3, _api$assumption4;
		    api.assertVersion("*");
		    var targets = api.targets();
		    var supportsObjectAssign = !isRequired("Object.assign", targets, {
		      compatData: compatData
		    });
		    var _opts$useBuiltIns = opts.useBuiltIns,
		      useBuiltIns = _opts$useBuiltIns === void 0 ? supportsObjectAssign : _opts$useBuiltIns,
		      _opts$loose = opts.loose,
		      loose = _opts$loose === void 0 ? false : _opts$loose;
		    if (typeof loose !== "boolean") {
		      throw new Error(".loose must be a boolean, or undefined");
		    }
		    var ignoreFunctionLength = (_api$assumption = api.assumption("ignoreFunctionLength")) != null ? _api$assumption : loose;
		    var objectRestNoSymbols = (_api$assumption2 = api.assumption("objectRestNoSymbols")) != null ? _api$assumption2 : loose;
		    var pureGetters = (_api$assumption3 = api.assumption("pureGetters")) != null ? _api$assumption3 : loose;
		    var setSpreadProperties = (_api$assumption4 = api.assumption("setSpreadProperties")) != null ? _api$assumption4 : loose;
		    function getExtendsHelper(file) {
		      return useBuiltIns ? memberExpression$c(identifier$j("Object"), identifier$j("assign")) : file.addHelper("extends");
		    }
		    function hasRestElement(path) {
		      var foundRestElement = false;
		      visitRestElements(path, function (restElement) {
		        foundRestElement = true;
		        restElement.stop();
		      });
		      return foundRestElement;
		    }
		    function hasObjectPatternRestElement(path) {
		      var foundRestElement = false;
		      visitRestElements(path, function (restElement) {
		        if (restElement.parentPath.isObjectPattern()) {
		          foundRestElement = true;
		          restElement.stop();
		        }
		      });
		      return foundRestElement;
		    }
		    function visitRestElements(path, visitor) {
		      path.traverse({
		        Expression: function Expression(path) {
		          var parent = path.parent,
		            key = path.key;
		          if (isAssignmentPattern(parent) && key === "right" || isObjectProperty(parent) && parent.computed && key === "key") {
		            path.skip();
		          }
		        },
		        RestElement: visitor
		      });
		    }
		    function hasSpread(node) {
		      for (var _iterator = _createForOfIteratorHelperLoose(node.properties), _step; !(_step = _iterator()).done;) {
		        var prop = _step.value;
		        if (isSpreadElement$1(prop)) {
		          return true;
		        }
		      }
		      return false;
		    }
		    function extractNormalizedKeys(node) {
		      var props = node.properties;
		      var keys = [];
		      var allPrimitives = true;
		      var hasTemplateLiteral = false;
		      for (var _iterator2 = _createForOfIteratorHelperLoose(props), _step2; !(_step2 = _iterator2()).done;) {
		        var prop = _step2.value;
		        var key = prop.key;
		        if (isIdentifier$i(key) && !prop.computed) {
		          keys.push(stringLiteral$8(key.name));
		        } else if (isTemplateLiteral$2(key)) {
		          keys.push(cloneNode$j(key));
		          hasTemplateLiteral = true;
		        } else if (isLiteral$6(key)) {
		          keys.push(stringLiteral$8(String(key.value)));
		        } else {
		          keys.push(cloneNode$j(key));
		          if (isMemberExpression$9(key, {
		            computed: false
		          }) && isIdentifier$i(key.object, {
		            name: "Symbol"
		          }) || isCallExpression$8(key) && matchesPattern$2(key.callee, "Symbol.for")) ; else {
		            allPrimitives = false;
		          }
		        }
		      }
		      return {
		        keys: keys,
		        allPrimitives: allPrimitives,
		        hasTemplateLiteral: hasTemplateLiteral
		      };
		    }
		    function replaceImpureComputedKeys(properties, scope) {
		      var impureComputedPropertyDeclarators = [];
		      for (var _iterator3 = _createForOfIteratorHelperLoose(properties), _step3; !(_step3 = _iterator3()).done;) {
		        var propPath = _step3.value;
		        var key = propPath.get("key");
		        if (propPath.node.computed && !key.isPure()) {
		          var name = scope.generateUidBasedOnNode(key.node);
		          var declarator = variableDeclarator$8(identifier$j(name), key.node);
		          impureComputedPropertyDeclarators.push(declarator);
		          key.replaceWith(identifier$j(name));
		        }
		      }
		      return impureComputedPropertyDeclarators;
		    }
		    function removeUnusedExcludedKeys(path) {
		      var bindings = path.getOuterBindingIdentifierPaths();
		      Object.keys(bindings).forEach(function (bindingName) {
		        var bindingParentPath = bindings[bindingName].parentPath;
		        if (path.scope.getBinding(bindingName).references > ZERO_REFS || !bindingParentPath.isObjectProperty()) {
		          return;
		        }
		        bindingParentPath.remove();
		      });
		    }
		    function createObjectRest(path, file, objRef) {
		      var props = path.get("properties");
		      var last = props[props.length - 1];
		      assertRestElement(last.node);
		      var restElement = cloneNode$j(last.node);
		      last.remove();
		      var impureComputedPropertyDeclarators = replaceImpureComputedKeys(path.get("properties"), path.scope);
		      var _extractNormalizedKey = extractNormalizedKeys(path.node),
		        keys = _extractNormalizedKey.keys,
		        allPrimitives = _extractNormalizedKey.allPrimitives,
		        hasTemplateLiteral = _extractNormalizedKey.hasTemplateLiteral;
		      if (keys.length === 0) {
		        return [impureComputedPropertyDeclarators, restElement.argument, callExpression$d(getExtendsHelper(file), [objectExpression$3([]), sequenceExpression$8([callExpression$d(file.addHelper("objectDestructuringEmpty"), [cloneNode$j(objRef)]), cloneNode$j(objRef)])])];
		      }
		      var keyExpression;
		      if (!allPrimitives) {
		        keyExpression = callExpression$d(memberExpression$c(arrayExpression$1(keys), identifier$j("map")), [file.addHelper("toPropertyKey")]);
		      } else {
		        keyExpression = arrayExpression$1(keys);
		        if (!hasTemplateLiteral && !isProgram$1(path.scope.block)) {
		          var program = path.findParent(function (path) {
		            return path.isProgram();
		          });
		          var id = path.scope.generateUidIdentifier("excluded");
		          program.scope.push({
		            id: id,
		            init: keyExpression,
		            kind: "const"
		          });
		          keyExpression = cloneNode$j(id);
		        }
		      }
		      return [impureComputedPropertyDeclarators, restElement.argument, callExpression$d(file.addHelper("objectWithoutProperties" + (objectRestNoSymbols ? "Loose" : "")), [cloneNode$j(objRef), keyExpression])];
		    }
		    function replaceRestElement(parentPath, paramPath, container) {
		      if (paramPath.isAssignmentPattern()) {
		        replaceRestElement(parentPath, paramPath.get("left"), container);
		        return;
		      }
		      if (paramPath.isArrayPattern() && hasRestElement(paramPath)) {
		        var elements = paramPath.get("elements");
		        for (var i = 0; i < elements.length; i++) {
		          replaceRestElement(parentPath, elements[i], container);
		        }
		      }
		      if (paramPath.isObjectPattern() && hasRestElement(paramPath)) {
		        var uid = parentPath.scope.generateUidIdentifier("ref");
		        var declar = variableDeclaration$8("let", [variableDeclarator$8(paramPath.node, uid)]);
		        if (container) {
		          container.push(declar);
		        } else {
		          parentPath.ensureBlock();
		          parentPath.get("body").unshiftContainer("body", declar);
		        }
		        paramPath.replaceWith(cloneNode$j(uid));
		      }
		    }
		    return {
		      name: "transform-object-rest-spread",
		      inherits: undefined,
		      visitor: {
		        Function: function Function(path) {
		          var params = path.get("params");
		          var paramsWithRestElement = new Set();
		          var idsInRestParams = new Set();
		          for (var _i = 0; _i < params.length; ++_i) {
		            var param = params[_i];
		            if (hasRestElement(param)) {
		              paramsWithRestElement.add(_i);
		              for (var _i2 = 0, _Object$keys = Object.keys(param.getBindingIdentifiers()); _i2 < _Object$keys.length; _i2++) {
		                var name = _Object$keys[_i2];
		                idsInRestParams.add(name);
		              }
		            }
		          }
		          var idInRest = false;
		          var IdentifierHandler = function IdentifierHandler(path, functionScope) {
		            var name = path.node.name;
		            if (path.scope.getBinding(name) === functionScope.getBinding(name) && idsInRestParams.has(name)) {
		              idInRest = true;
		              path.stop();
		            }
		          };
		          var i;
		          for (i = 0; i < params.length && !idInRest; ++i) {
		            var _param = params[i];
		            if (!paramsWithRestElement.has(i)) {
		              if (_param.isReferencedIdentifier() || _param.isBindingIdentifier()) {
		                IdentifierHandler(_param, path.scope);
		              } else {
		                _param.traverse({
		                  "Scope|TypeAnnotation|TSTypeAnnotation": function ScopeTypeAnnotationTSTypeAnnotation(path) {
		                    return path.skip();
		                  },
		                  "ReferencedIdentifier|BindingIdentifier": IdentifierHandler
		                }, path.scope);
		              }
		            }
		          }
		          if (!idInRest) {
		            for (var _i3 = 0; _i3 < params.length; ++_i3) {
		              var _param2 = params[_i3];
		              if (paramsWithRestElement.has(_i3)) {
		                replaceRestElement(path, _param2);
		              }
		            }
		          } else {
		            var shouldTransformParam = function shouldTransformParam(idx) {
		              return idx >= i - 1 || paramsWithRestElement.has(idx);
		            };
		            convertFunctionParams(path, ignoreFunctionLength, shouldTransformParam, replaceRestElement);
		          }
		        },
		        VariableDeclarator: function (_VariableDeclarator) {
		          function VariableDeclarator(_x, _x2) {
		            return _VariableDeclarator.apply(this, arguments);
		          }
		          VariableDeclarator.toString = function () {
		            return _VariableDeclarator.toString();
		          };
		          return VariableDeclarator;
		        }(function (path, file) {
		          if (!path.get("id").isObjectPattern()) {
		            return;
		          }
		          var insertionPath = path;
		          var originalPath = path;
		          visitRestElements(path.get("id"), function (path) {
		            if (!path.parentPath.isObjectPattern()) {
		              return;
		            }
		            if (shouldStoreRHSInTemporaryVariable(originalPath.node.id) && !isIdentifier$i(originalPath.node.init)) {
		              var initRef = path.scope.generateUidIdentifierBasedOnNode(originalPath.node.init, "ref");
		              originalPath.insertBefore(variableDeclarator$8(initRef, originalPath.node.init));
		              originalPath.replaceWith(variableDeclarator$8(originalPath.node.id, cloneNode$j(initRef)));
		              return;
		            }
		            var ref = originalPath.node.init;
		            var refPropertyPath = [];
		            var kind;
		            path.findParent(function (path) {
		              if (path.isObjectProperty()) {
		                refPropertyPath.unshift(path);
		              } else if (path.isVariableDeclarator()) {
		                kind = path.parentPath.node.kind;
		                return true;
		              }
		            });
		            var impureObjRefComputedDeclarators = replaceImpureComputedKeys(refPropertyPath, path.scope);
		            refPropertyPath.forEach(function (prop) {
		              var node = prop.node;
		              ref = memberExpression$c(ref, cloneNode$j(node.key), node.computed || isLiteral$6(node.key));
		            });
		            var objectPatternPath = path.findParent(function (path) {
		              return path.isObjectPattern();
		            });
		            var _createObjectRest = createObjectRest(objectPatternPath, file, ref),
		              _createObjectRest2 = _slicedToArray(_createObjectRest, 3),
		              impureComputedPropertyDeclarators = _createObjectRest2[0],
		              argument = _createObjectRest2[1],
		              callExpression = _createObjectRest2[2];
		            if (pureGetters) {
		              removeUnusedExcludedKeys(objectPatternPath);
		            }
		            assertIdentifier(argument);
		            insertionPath.insertBefore(impureComputedPropertyDeclarators);
		            insertionPath.insertBefore(impureObjRefComputedDeclarators);
		            insertionPath = insertionPath.insertAfter(variableDeclarator$8(argument, callExpression))[0];
		            path.scope.registerBinding(kind, insertionPath);
		            if (objectPatternPath.node.properties.length === 0) {
		              objectPatternPath.findParent(function (path) {
		                return path.isObjectProperty() || path.isVariableDeclarator();
		              }).remove();
		            }
		          });
		        }),
		        ExportNamedDeclaration: function ExportNamedDeclaration(path) {
		          var declaration = path.get("declaration");
		          if (!declaration.isVariableDeclaration()) return;
		          var hasRest = declaration.get("declarations").some(function (path) {
		            return hasObjectPatternRestElement(path.get("id"));
		          });
		          if (!hasRest) return;
		          var specifiers = [];
		          for (var _i4 = 0, _Object$keys2 = Object.keys(path.getOuterBindingIdentifiers(true)); _i4 < _Object$keys2.length; _i4++) {
		            var name = _Object$keys2[_i4];
		            specifiers.push(exportSpecifier$2(identifier$j(name), identifier$j(name)));
		          }
		          path.replaceWith(declaration.node);
		          path.insertAfter(exportNamedDeclaration$2(null, specifiers));
		        },
		        CatchClause: function CatchClause(path) {
		          var paramPath = path.get("param");
		          replaceRestElement(path, paramPath);
		        },
		        AssignmentExpression: function AssignmentExpression(path, file) {
		          var leftPath = path.get("left");
		          if (leftPath.isObjectPattern() && hasRestElement(leftPath)) {
		            var nodes = [];
		            var refName = path.scope.generateUidBasedOnNode(path.node.right, "ref");
		            nodes.push(variableDeclaration$8("var", [variableDeclarator$8(identifier$j(refName), path.node.right)]));
		            var _createObjectRest3 = createObjectRest(leftPath, file, identifier$j(refName)),
		              _createObjectRest4 = _slicedToArray(_createObjectRest3, 3),
		              impureComputedPropertyDeclarators = _createObjectRest4[0],
		              argument = _createObjectRest4[1],
		              callExpression = _createObjectRest4[2];
		            if (impureComputedPropertyDeclarators.length > 0) {
		              nodes.push(variableDeclaration$8("var", impureComputedPropertyDeclarators));
		            }
		            var nodeWithoutSpread = cloneNode$j(path.node);
		            nodeWithoutSpread.right = identifier$j(refName);
		            nodes.push(expressionStatement$a(nodeWithoutSpread));
		            nodes.push(expressionStatement$a(assignmentExpression$d("=", argument, callExpression)));
		            nodes.push(expressionStatement$a(identifier$j(refName)));
		            path.replaceWithMultiple(nodes);
		          }
		        },
		        ForXStatement: function (_ForXStatement) {
		          function ForXStatement(_x3) {
		            return _ForXStatement.apply(this, arguments);
		          }
		          ForXStatement.toString = function () {
		            return _ForXStatement.toString();
		          };
		          return ForXStatement;
		        }(function (path) {
		          var node = path.node,
		            scope = path.scope;
		          var leftPath = path.get("left");
		          var left = node.left;
		          if (!hasObjectPatternRestElement(leftPath)) {
		            return;
		          }
		          if (!isVariableDeclaration$4(left)) {
		            var temp = scope.generateUidIdentifier("ref");
		            node.left = variableDeclaration$8("var", [variableDeclarator$8(temp)]);
		            path.ensureBlock();
		            var body = path.node.body;
		            if (body.body.length === 0 && path.isCompletionRecord()) {
		              body.body.unshift(expressionStatement$a(scope.buildUndefinedNode()));
		            }
		            body.body.unshift(expressionStatement$a(assignmentExpression$d("=", left, cloneNode$j(temp))));
		          } else {
		            var _pattern = left.declarations[0].id;
		            var key = scope.generateUidIdentifier("ref");
		            node.left = variableDeclaration$8(left.kind, [variableDeclarator$8(key, null)]);
		            path.ensureBlock();
		            var _body = node.body;
		            _body.body.unshift(variableDeclaration$8(node.left.kind, [variableDeclarator$8(_pattern, cloneNode$j(key))]));
		          }
		        }),
		        ArrayPattern: function ArrayPattern(path) {
		          var objectPatterns = [];
		          visitRestElements(path, function (path) {
		            if (!path.parentPath.isObjectPattern()) {
		              return;
		            }
		            var objectPattern = path.parentPath;
		            var uid = path.scope.generateUidIdentifier("ref");
		            objectPatterns.push(variableDeclarator$8(objectPattern.node, uid));
		            objectPattern.replaceWith(cloneNode$j(uid));
		            path.skip();
		          });
		          if (objectPatterns.length > 0) {
		            var statementPath = path.getStatementParent();
		            var statementNode = statementPath.node;
		            var kind = statementNode.type === "VariableDeclaration" ? statementNode.kind : "var";
		            statementPath.insertAfter(variableDeclaration$8(kind, objectPatterns));
		          }
		        },
		        ObjectExpression: function ObjectExpression(path, file) {
		          if (!hasSpread(path.node)) return;
		          var helper;
		          if (setSpreadProperties) {
		            helper = getExtendsHelper(file);
		          } else {
		            {
		              try {
		                helper = file.addHelper("objectSpread2");
		              } catch (_unused) {
		                this.file.declarations["objectSpread2"] = null;
		                helper = file.addHelper("objectSpread");
		              }
		            }
		          }
		          var exp = null;
		          var props = [];
		          function make() {
		            var hadProps = props.length > 0;
		            var obj = objectExpression$3(props);
		            props = [];
		            if (!exp) {
		              exp = callExpression$d(helper, [obj]);
		              return;
		            }
		            if (pureGetters) {
		              if (hadProps) {
		                exp.arguments.push(obj);
		              }
		              return;
		            }
		            exp = callExpression$d(cloneNode$j(helper), [exp].concat(_toConsumableArray(hadProps ? [objectExpression$3([]), obj] : [])));
		          }
		          for (var _iterator4 = _createForOfIteratorHelperLoose(path.node.properties), _step4; !(_step4 = _iterator4()).done;) {
		            var prop = _step4.value;
		            if (isSpreadElement$1(prop)) {
		              make();
		              exp.arguments.push(prop.argument);
		            } else {
		              props.push(prop);
		            }
		          }
		          if (props.length) make();
		          path.replaceWith(exp);
		        }
		      }
		    };
		  });

		  var proposalOptionalCatchBinding = declare(function (api) {
		    api.assertVersion("*");
		    return {
		      name: "transform-optional-catch-binding",
		      inherits: undefined,
		      visitor: {
		        CatchClause: function CatchClause(path) {
		          if (!path.node.param) {
		            var uid = path.scope.generateUidIdentifier("unused");
		            var paramPath = path.get("param");
		            paramPath.replaceWith(uid);
		          }
		        }
		      }
		    };
		  });

		  function willPathCastToBoolean(path) {
		    var maybeWrapped = findOutermostTransparentParent(path);
		    var node = maybeWrapped.node,
		      parentPath = maybeWrapped.parentPath;
		    if (parentPath.isLogicalExpression()) {
		      var _parentPath$node = parentPath.node,
		        operator = _parentPath$node.operator,
		        right = _parentPath$node.right;
		      if (operator === "&&" || operator === "||" || operator === "??" && node === right) {
		        return willPathCastToBoolean(parentPath);
		      }
		    }
		    if (parentPath.isSequenceExpression()) {
		      var expressions = parentPath.node.expressions;
		      if (expressions[expressions.length - 1] === node) {
		        return willPathCastToBoolean(parentPath);
		      } else {
		        return true;
		      }
		    }
		    return parentPath.isConditional({
		      test: node
		    }) || parentPath.isUnaryExpression({
		      operator: "!"
		    }) || parentPath.isLoop({
		      test: node
		    });
		  }
		  function findOutermostTransparentParent(path) {
		    var maybeWrapped = path;
		    path.findParent(function (p) {
		      if (!isTransparentExprWrapper(p.node)) return true;
		      maybeWrapped = p;
		    });
		    return maybeWrapped;
		  }

		  var _templateObject$o;
		  var last = function last(arr) {
		    return arr[arr.length - 1];
		  };
		  function isSimpleMemberExpression(expression) {
		    expression = skipTransparentExprWrapperNodes(expression);
		    return isIdentifier$i(expression) || isSuper$3(expression) || isMemberExpression$9(expression) && !expression.computed && isSimpleMemberExpression(expression.object);
		  }
		  function needsMemoize(path) {
		    var optionalPath = path;
		    var scope = path.scope;
		    while (optionalPath.isOptionalMemberExpression() || optionalPath.isOptionalCallExpression()) {
		      var _optionalPath = optionalPath,
		        node = _optionalPath.node;
		      var childPath = skipTransparentExprWrappers(optionalPath.isOptionalMemberExpression() ? optionalPath.get("object") : optionalPath.get("callee"));
		      if (node.optional) {
		        return !scope.isStatic(childPath.node);
		      }
		      optionalPath = childPath;
		    }
		  }
		  var NULLISH_CHECK = template$1.expression("%%check%% === null || %%ref%% === void 0");
		  var NULLISH_CHECK_NO_DDA = template$1.expression("%%check%% == null");
		  var NULLISH_CHECK_NEG = template$1.expression("%%check%% !== null && %%ref%% !== void 0");
		  var NULLISH_CHECK_NO_DDA_NEG = template$1.expression("%%check%% != null");
		  function transformOptionalChain(path, _ref, replacementPath, ifNullish, wrapLast) {
		    var pureGetters = _ref.pureGetters,
		      noDocumentAll = _ref.noDocumentAll;
		    var scope = path.scope;
		    if (scope.path.isPattern() && needsMemoize(path)) {
		      replacementPath.replaceWith(template$1.expression.ast(_templateObject$o || (_templateObject$o = _taggedTemplateLiteralLoose(["(() => ", ")()"])), replacementPath.node));
		      return;
		    }
		    var optionals = [];
		    var optionalPath = path;
		    while (optionalPath.isOptionalMemberExpression() || optionalPath.isOptionalCallExpression()) {
		      var _optionalPath2 = optionalPath,
		        node = _optionalPath2.node;
		      if (node.optional) {
		        optionals.push(node);
		      }
		      if (optionalPath.isOptionalMemberExpression()) {
		        optionalPath.node.type = "MemberExpression";
		        optionalPath = skipTransparentExprWrappers(optionalPath.get("object"));
		      } else if (optionalPath.isOptionalCallExpression()) {
		        optionalPath.node.type = "CallExpression";
		        optionalPath = skipTransparentExprWrappers(optionalPath.get("callee"));
		      }
		    }
		    if (optionals.length === 0) {
		      return;
		    }
		    var checks = [];
		    var tmpVar;
		    for (var i = optionals.length - 1; i >= 0; i--) {
		      var _node = optionals[i];
		      var isCall = isCallExpression$8(_node);
		      var chainWithTypes = isCall ? _node.callee : _node.object;
		      var chain = skipTransparentExprWrapperNodes(chainWithTypes);
		      var ref = void 0;
		      var _check = void 0;
		      if (isCall && isIdentifier$i(chain, {
		        name: "eval"
		      })) {
		        _check = ref = chain;
		        _node.callee = sequenceExpression$8([numericLiteral$8(0), ref]);
		      } else if (pureGetters && isCall && isSimpleMemberExpression(chain)) {
		        _check = ref = _node.callee;
		      } else if (scope.isStatic(chain)) {
		        _check = ref = chainWithTypes;
		      } else {
		        if (!tmpVar || isCall) {
		          tmpVar = scope.generateUidIdentifierBasedOnNode(chain);
		          scope.push({
		            id: cloneNode$j(tmpVar)
		          });
		        }
		        ref = tmpVar;
		        _check = assignmentExpression$d("=", cloneNode$j(tmpVar), chainWithTypes);
		        isCall ? _node.callee = ref : _node.object = ref;
		      }
		      if (isCall && isMemberExpression$9(chain)) {
		        if (pureGetters && isSimpleMemberExpression(chain)) {
		          _node.callee = chainWithTypes;
		        } else {
		          var object = chain.object;
		          var context = void 0;
		          if (isSuper$3(object)) {
		            context = thisExpression$4();
		          } else {
		            var memoized = scope.maybeGenerateMemoised(object);
		            if (memoized) {
		              context = memoized;
		              chain.object = assignmentExpression$d("=", memoized, object);
		            } else {
		              context = object;
		            }
		          }
		          _node.arguments.unshift(cloneNode$j(context));
		          _node.callee = memberExpression$c(_node.callee, identifier$j("call"));
		        }
		      }
		      var data = {
		        check: cloneNode$j(_check),
		        ref: cloneNode$j(ref)
		      };
		      Object.defineProperty(data, "ref", {
		        enumerable: false
		      });
		      checks.push(data);
		    }
		    var result = replacementPath.node;
		    if (wrapLast) result = wrapLast(result);
		    var ifNullishBoolean = isBooleanLiteral(ifNullish);
		    var ifNullishFalse = ifNullishBoolean && ifNullish.value === false;
		    var ifNullishVoid = !ifNullishBoolean && isUnaryExpression$1(ifNullish, {
		      operator: "void"
		    });
		    var isEvaluationValueIgnored = isExpressionStatement$2(replacementPath.parent) && !replacementPath.isCompletionRecord() || isSequenceExpression$1(replacementPath.parent) && last(replacementPath.parent.expressions) !== replacementPath.node;
		    var tpl = ifNullishFalse ? noDocumentAll ? NULLISH_CHECK_NO_DDA_NEG : NULLISH_CHECK_NEG : noDocumentAll ? NULLISH_CHECK_NO_DDA : NULLISH_CHECK;
		    var logicalOp = ifNullishFalse ? "&&" : "||";
		    var check = checks.map(tpl).reduce(function (expr, check) {
		      return logicalExpression$3(logicalOp, expr, check);
		    });
		    replacementPath.replaceWith(ifNullishBoolean || ifNullishVoid && isEvaluationValueIgnored ? logicalExpression$3(logicalOp, check, result) : conditionalExpression$5(check, ifNullish, result));
		  }
		  function transform$1(path, assumptions) {
		    var scope = path.scope;
		    var maybeWrapped = findOutermostTransparentParent(path);
		    var parentPath = maybeWrapped.parentPath;
		    if (parentPath.isUnaryExpression({
		      operator: "delete"
		    })) {
		      transformOptionalChain(path, assumptions, parentPath, booleanLiteral$4(true));
		    } else {
		      var wrapLast;
		      if (parentPath.isCallExpression({
		        callee: maybeWrapped.node
		      }) && path.isOptionalMemberExpression()) {
		        wrapLast = function wrapLast(replacement) {
		          var _baseRef;
		          var object = skipTransparentExprWrapperNodes(replacement.object);
		          var baseRef;
		          if (!assumptions.pureGetters || !isSimpleMemberExpression(object)) {
		            baseRef = scope.maybeGenerateMemoised(object);
		            if (baseRef) {
		              replacement.object = assignmentExpression$d("=", baseRef, object);
		            }
		          }
		          return callExpression$d(memberExpression$c(replacement, identifier$j("bind")), [cloneNode$j((_baseRef = baseRef) != null ? _baseRef : object)]);
		        };
		      }
		      transformOptionalChain(path, assumptions, path, willPathCastToBoolean(maybeWrapped) ? booleanLiteral$4(false) : scope.buildUndefinedNode(), wrapLast);
		    }
		  }

		  var proposalOptionalChaining = declare(function (api, options) {
		    var _api$assumption, _api$assumption2;
		    api.assertVersion("*");
		    var _options$loose = options.loose,
		      loose = _options$loose === void 0 ? false : _options$loose;
		    var noDocumentAll = (_api$assumption = api.assumption("noDocumentAll")) != null ? _api$assumption : loose;
		    var pureGetters = (_api$assumption2 = api.assumption("pureGetters")) != null ? _api$assumption2 : loose;
		    return {
		      name: "transform-optional-chaining",
		      inherits: undefined,
		      visitor: {
		        "OptionalCallExpression|OptionalMemberExpression": function OptionalCallExpressionOptionalMemberExpression(path) {
		          transform$1(path, {
		            noDocumentAll: noDocumentAll,
		            pureGetters: pureGetters
		          });
		        }
		      }
		    };
		  });

		  var proposalOptionalChainingAssign = declare(function (api) {
		    var _api$assumption, _api$assumption2;
		    api.assertVersion("*");
		    var assumptions = {
		      noDocumentAll: (_api$assumption = api.assumption("noDocumentAll")) != null ? _api$assumption : false,
		      pureGetters: (_api$assumption2 = api.assumption("pureGetters")) != null ? _api$assumption2 : false
		    };
		    var t = api.types;
		    return {
		      name: "transform-optional-chaining-assign",
		      inherits: syntaxOptionalChainingAssign,
		      visitor: {
		        AssignmentExpression: function AssignmentExpression(path, state) {
		          var _lhs$node$extra;
		          var lhs = path.get("left");
		          if (!lhs.isExpression()) return;
		          var isParenthesized = ((_lhs$node$extra = lhs.node.extra) == null ? void 0 : _lhs$node$extra.parenthesized) || t.isParenthesizedExpression(lhs.node);
		          lhs = skipTransparentExprWrappers(lhs);
		          if (!lhs.isOptionalMemberExpression()) return;
		          var ifNullish = path.scope.buildUndefinedNode();
		          if (isParenthesized) {
		            ifNullish = t.callExpression(state.addHelper("nullishReceiverError"), []);
		            if (path.node.operator === "=") {
		              ifNullish = t.sequenceExpression([t.cloneNode(path.node.right), ifNullish]);
		            }
		          }
		          transformOptionalChain(lhs, assumptions, path, ifNullish);
		        }
		      }
		    };
		  });

		  function isConciseArrowExpression(node) {
		    return isArrowFunctionExpression$2(node) && isExpression$4(node.body) && !node.async;
		  }
		  var buildOptimizedSequenceExpression = function buildOptimizedSequenceExpression(_ref) {
		    var call = _ref.call,
		      path = _ref.path,
		      placeholder = _ref.placeholder;
		    var calledExpression = call.callee;
		    var pipelineLeft = path.node.left;
		    var assign = assignmentExpression$d("=", cloneNode$j(placeholder), pipelineLeft);
		    var expressionIsArrow = isConciseArrowExpression(calledExpression);
		    if (expressionIsArrow) {
		      var param;
		      var optimizeArrow = true;
		      var params = calledExpression.params;
		      if (params.length === 1 && isIdentifier$i(params[0])) {
		        param = params[0];
		      } else if (params.length > 0) {
		        optimizeArrow = false;
		      }
		      if (optimizeArrow && !param) {
		        return sequenceExpression$8([pipelineLeft, calledExpression.body]);
		      } else if (param) {
		        path.scope.push({
		          id: cloneNode$j(placeholder)
		        });
		        path.get("right").scope.rename(param.name, placeholder.name);
		        return sequenceExpression$8([assign, calledExpression.body]);
		      }
		    } else if (isIdentifier$i(calledExpression, {
		      name: "eval"
		    })) {
		      var evalSequence = sequenceExpression$8([numericLiteral$8(0), calledExpression]);
		      call.callee = evalSequence;
		    }
		    path.scope.push({
		      id: cloneNode$j(placeholder)
		    });
		    return sequenceExpression$8([assign, call]);
		  };

		  var minimalVisitor = {
		    BinaryExpression: function (_BinaryExpression) {
		      function BinaryExpression(_x) {
		        return _BinaryExpression.apply(this, arguments);
		      }
		      BinaryExpression.toString = function () {
		        return _BinaryExpression.toString();
		      };
		      return BinaryExpression;
		    }(function (path) {
		      var scope = path.scope,
		        node = path.node;
		      var operator = node.operator,
		        left = node.left,
		        right = node.right;
		      if (operator !== "|>") return;
		      var placeholder = scope.generateUidIdentifierBasedOnNode(left);
		      var call = callExpression$d(right, [cloneNode$j(placeholder)]);
		      path.replaceWith(buildOptimizedSequenceExpression({
		        placeholder: placeholder,
		        call: call,
		        path: path
		      }));
		    })
		  };

		  var topicReferenceVisitor = {
		    exit: function exit(path, state) {
		      if (path.isTopicReference()) {
		        state.topicReferences.push(path);
		      } else {
		        if (state.topicReferences.length === 0 && !state.sideEffectsBeforeFirstTopicReference && !path.isPure()) {
		          state.sideEffectsBeforeFirstTopicReference = true;
		        }
		      }
		    },
		    "ClassBody|Function": function ClassBodyFunction(_, state) {
		      if (state.topicReferences.length === 0) {
		        state.sideEffectsBeforeFirstTopicReference = true;
		      }
		    }
		  };
		  var visitor = {
		    BinaryExpression: {
		      exit: function exit(path) {
		        var scope = path.scope,
		          node = path.node;
		        if (node.operator !== "|>") {
		          return;
		        }
		        var pipeBodyPath = path.get("right");
		        if (pipeBodyPath.node.type === "TopicReference") {
		          path.replaceWith(node.left);
		          return;
		        }
		        var visitorState = {
		          topicReferences: [],
		          sideEffectsBeforeFirstTopicReference: pipeBodyPath.isFunction()
		        };
		        pipeBodyPath.traverse(topicReferenceVisitor, visitorState);
		        if (visitorState.topicReferences.length === 1 && (!visitorState.sideEffectsBeforeFirstTopicReference || path.scope.isPure(node.left, true))) {
		          visitorState.topicReferences[0].replaceWith(node.left);
		          path.replaceWith(node.right);
		          return;
		        }
		        var topicVariable = scope.generateUidIdentifierBasedOnNode(node);
		        scope.push({
		          id: topicVariable
		        });
		        visitorState.topicReferences.forEach(function (path) {
		          return path.replaceWith(cloneNode$j(topicVariable));
		        });
		        path.replaceWith(sequenceExpression$8([assignmentExpression$d("=", cloneNode$j(topicVariable), node.left), node.right]));
		      }
		    }
		  };

		  var fsharpVisitor = {
		    BinaryExpression: function (_BinaryExpression) {
		      function BinaryExpression(_x) {
		        return _BinaryExpression.apply(this, arguments);
		      }
		      BinaryExpression.toString = function () {
		        return _BinaryExpression.toString();
		      };
		      return BinaryExpression;
		    }(function (path) {
		      var scope = path.scope,
		        node = path.node;
		      var operator = node.operator,
		        left = node.left,
		        right = node.right;
		      if (operator !== "|>") return;
		      var placeholder = scope.generateUidIdentifierBasedOnNode(left);
		      var call = right.type === "AwaitExpression" ? awaitExpression$1(cloneNode$j(placeholder)) : callExpression$d(right, [cloneNode$j(placeholder)]);
		      var sequence = buildOptimizedSequenceExpression({
		        placeholder: placeholder,
		        call: call,
		        path: path
		      });
		      path.replaceWith(sequence);
		    })
		  };

		  var updateTopicReferenceVisitor = {
		    PipelinePrimaryTopicReference: function PipelinePrimaryTopicReference(path) {
		      path.replaceWith(cloneNode$j(this.topicId));
		    },
		    PipelineTopicExpression: function PipelineTopicExpression(path) {
		      path.skip();
		    }
		  };
		  var smartVisitor = {
		    BinaryExpression: function BinaryExpression(path) {
		      var scope = path.scope;
		      var node = path.node;
		      var operator = node.operator,
		        left = node.left,
		        right = node.right;
		      if (operator !== "|>") return;
		      var placeholder = scope.generateUidIdentifierBasedOnNode(left);
		      scope.push({
		        id: placeholder
		      });
		      var call;
		      if (isPipelineTopicExpression(right)) {
		        path.get("right").traverse(updateTopicReferenceVisitor, {
		          topicId: placeholder
		        });
		        call = right.expression;
		      } else {
		        var callee = right.callee;
		        if (isIdentifier$i(callee, {
		          name: "eval"
		        })) {
		          callee = sequenceExpression$8([numericLiteral$8(0), callee]);
		        }
		        call = callExpression$d(callee, [cloneNode$j(placeholder)]);
		      }
		      path.replaceWith(sequenceExpression$8([assignmentExpression$d("=", cloneNode$j(placeholder), left), call]));
		    }
		  };

		  var visitorsPerProposal = {
		    minimal: minimalVisitor,
		    hack: visitor,
		    fsharp: fsharpVisitor,
		    smart: smartVisitor
		  };
		  var proposalPipelineOperator = declare(function (api, options) {
		    api.assertVersion("*");
		    var proposal = options.proposal;
		    if (proposal === "smart") {
		      console.warn("The smart-mix pipe operator is deprecated. Use \"proposal\": \"hack\" instead.");
		    }
		    return {
		      name: "proposal-pipeline-operator",
		      inherits: syntaxPipelineOperator,
		      visitor: visitorsPerProposal[options.proposal]
		    };
		  });

		  var proposalPrivateMethods = declare(function (api, options) {
		    api.assertVersion("*");
		    return createClassFeaturePlugin({
		      name: "transform-private-methods",
		      api: api,
		      feature: FEATURES$1.privateMethods,
		      loose: options.loose,
		      manipulateOptions: function manipulateOptions(opts, parserOpts) {
		        parserOpts.plugins.push("classPrivateMethods");
		      }
		    });
		  });

		  var _templateObject$n, _templateObject2$d, _templateObject3$8, _templateObject4$4, _templateObject5$2, _templateObject6$1;
		  var proposalPrivatePropertyInObject = declare(function (api, opt) {
		    api.assertVersion("*");
		    var t = api.types,
		      template = api.template;
		    var loose = opt.loose;
		    var classWeakSets = new WeakMap();
		    var fieldsWeakSets = new WeakMap();
		    function unshadow(name, targetScope, scope) {
		      while (scope !== targetScope) {
		        if (scope.hasOwnBinding(name)) scope.rename(name);
		        scope = scope.parent;
		      }
		    }
		    function injectToFieldInit(fieldPath, expr, before) {
		      if (before === void 0) {
		        before = false;
		      }
		      if (fieldPath.node.value) {
		        var value = fieldPath.get("value");
		        if (before) {
		          value.insertBefore(expr);
		        } else {
		          value.insertAfter(expr);
		        }
		      } else {
		        fieldPath.set("value", t.unaryExpression("void", expr));
		      }
		    }
		    function injectInitialization$1(classPath, init) {
		      var firstFieldPath;
		      var constructorPath;
		      for (var _iterator = _createForOfIteratorHelperLoose(classPath.get("body.body")), _step; !(_step = _iterator()).done;) {
		        var el = _step.value;
		        if ((el.isClassProperty() || el.isClassPrivateProperty()) && !el.node["static"]) {
		          firstFieldPath = el;
		          break;
		        }
		        if (!constructorPath && el.isClassMethod({
		          kind: "constructor"
		        })) {
		          constructorPath = el;
		        }
		      }
		      if (firstFieldPath) {
		        injectToFieldInit(firstFieldPath, init, true);
		      } else {
		        injectInitialization(classPath, constructorPath, [t.expressionStatement(init)]);
		      }
		    }
		    function getWeakSetId(weakSets, outerClass, reference, name, inject) {
		      if (name === void 0) {
		        name = "";
		      }
		      var id = weakSets.get(reference.node);
		      if (!id) {
		        id = outerClass.scope.generateUidIdentifier((name || "") + " brandCheck");
		        weakSets.set(reference.node, id);
		        inject(reference, template.expression.ast(_templateObject$n || (_templateObject$n = _taggedTemplateLiteralLoose(["", ".add(this)"])), t.cloneNode(id)));
		        var newExpr = t.newExpression(t.identifier("WeakSet"), []);
		        annotateAsPure(newExpr);
		        outerClass.insertBefore(template.ast(_templateObject2$d || (_templateObject2$d = _taggedTemplateLiteralLoose(["var ", " = ", ""])), id, newExpr));
		      }
		      return t.cloneNode(id);
		    }
		    return {
		      name: "transform-private-property-in-object",
		      inherits: undefined,
		      pre: function pre() {
		        enableFeature$1(this.file, FEATURES$1.privateIn, loose);
		      },
		      visitor: {
		        BinaryExpression: function BinaryExpression(path, state) {
		          var node = path.node;
		          var file = state.file;
		          if (node.operator !== "in") return;
		          if (!t.isPrivateName(node.left)) return;
		          var name = node.left.id.name;
		          var privateElement;
		          var outerClass = path.findParent(function (path) {
		            if (!path.isClass()) return false;
		            privateElement = path.get("body.body").find(function (_ref) {
		              var node = _ref.node;
		              return t.isPrivate(node) && node.key.id.name === name;
		            });
		            return !!privateElement;
		          });
		          if (outerClass.parentPath.scope.path.isPattern()) {
		            outerClass.replaceWith(template.ast(_templateObject3$8 || (_templateObject3$8 = _taggedTemplateLiteralLoose(["(() => ", ")()"])), outerClass.node));
		            return;
		          }
		          if (privateElement.node.type === "ClassPrivateMethod") {
		            if (privateElement.node["static"]) {
		              if (outerClass.node.id) {
		                unshadow(outerClass.node.id.name, outerClass.scope, path.scope);
		              } else {
		                outerClass.set("id", path.scope.generateUidIdentifier("class"));
		              }
		              path.replaceWith(template.expression.ast(_templateObject4$4 || (_templateObject4$4 = _taggedTemplateLiteralLoose(["\n                ", " === ", "\n              "])), t.cloneNode(outerClass.node.id), buildCheckInRHS(node.right, file)));
		            } else {
		              var _outerClass$node$id;
		              var id = getWeakSetId(classWeakSets, outerClass, outerClass, (_outerClass$node$id = outerClass.node.id) == null ? void 0 : _outerClass$node$id.name, injectInitialization$1);
		              path.replaceWith(template.expression.ast(_templateObject5$2 || (_templateObject5$2 = _taggedTemplateLiteralLoose(["", ".has(", ")"])), id, buildCheckInRHS(node.right, file)));
		            }
		          } else {
		            var _id = getWeakSetId(fieldsWeakSets, outerClass, privateElement, privateElement.node.key.id.name, injectToFieldInit);
		            path.replaceWith(template.expression.ast(_templateObject6$1 || (_templateObject6$1 = _taggedTemplateLiteralLoose(["", ".has(", ")"])), _id, buildCheckInRHS(node.right, file)));
		          }
		        }
		      }
		    };
		  });

		  var v$2 = new OptionValidator("@babel/plugin-proposal-record-and-tuple");
		  var proposalRecordAndTuple = declare(function (api, options) {
		    api.assertVersion("*");
		    var polyfillModuleName = v$2.validateStringOption("polyfillModuleName", options.polyfillModuleName, "@bloomberg/record-tuple-polyfill");
		    var shouldImportPolyfill = v$2.validateBooleanOption("importPolyfill", options.importPolyfill, !!options.polyfillModuleName);
		    var importCaches = new WeakMap();
		    function getOr(map, key, getDefault) {
		      var value = map.get(key);
		      if (!value) map.set(key, value = getDefault());
		      return value;
		    }
		    function getBuiltIn(name, programPath) {
		      if (!shouldImportPolyfill) return identifier$j(name);
		      if (!programPath) {
		        throw new Error("Internal error: unable to find the Program node.");
		      }
		      var cacheKey = name + ":" + isModule(programPath);
		      var cache = getOr(importCaches, programPath.node, function () {
		        return new Map();
		      });
		      var localBindingName = getOr(cache, cacheKey, function () {
		        return addNamed(programPath, name, polyfillModuleName, {
		          importedInterop: "uncompiled"
		        }).name;
		      });
		      return identifier$j(localBindingName);
		    }
		    return {
		      name: "proposal-record-and-tuple",
		      inherits: syntaxRecordAndTuple,
		      visitor: {
		        Program: function Program(path, state) {
		          state.programPath = path;
		        },
		        RecordExpression: function RecordExpression(path, state) {
		          var record = getBuiltIn("Record", state.programPath);
		          var object = objectExpression$3(path.node.properties);
		          var wrapped = callExpression$d(record, [object]);
		          path.replaceWith(wrapped);
		        },
		        TupleExpression: function TupleExpression(path, state) {
		          var tuple = getBuiltIn("Tuple", state.programPath);
		          var wrapped = callExpression$d(tuple, path.node.elements);
		          path.replaceWith(wrapped);
		        }
		      }
		    };
		  });

		  var proposalRegexpModifiers = declare(function (api) {
		    api.assertVersion("*");
		    return createRegExpFeaturePlugin({
		      name: "proposal-regexp-modifiers",
		      feature: "modifiers"
		    });
		  });

		  var syntaxThrowExpressions = declare(function (api) {
		    api.assertVersion("*");
		    return {
		      name: "syntax-throw-expressions",
		      manipulateOptions: function manipulateOptions(opts, parserOpts) {
		        parserOpts.plugins.push("throwExpressions");
		      }
		    };
		  });

		  var proposalThrowExpressions = declare(function (api) {
		    api.assertVersion("*");
		    return {
		      name: "proposal-throw-expressions",
		      inherits: syntaxThrowExpressions,
		      visitor: {
		        UnaryExpression: function UnaryExpression(path) {
		          var _path$node = path.node,
		            operator = _path$node.operator,
		            argument = _path$node.argument;
		          if (operator !== "throw") return;
		          var arrow = functionExpression$2(null, [identifier$j("e")], blockStatement$6([throwStatement(identifier$j("e"))]));
		          path.replaceWith(callExpression$d(arrow, [argument]));
		        }
		      }
		    };
		  });

		  var proposalUnicodePropertyRegex = declare(function (api, options) {
		    api.assertVersion("*");
		    var _options$useUnicodeFl = options.useUnicodeFlag,
		      useUnicodeFlag = _options$useUnicodeFl === void 0 ? true : _options$useUnicodeFl;
		    if (typeof useUnicodeFlag !== "boolean") {
		      throw new Error(".useUnicodeFlag must be a boolean, or undefined");
		    }
		    return createRegExpFeaturePlugin({
		      name: "transform-unicode-property-regex",
		      feature: "unicodePropertyEscape",
		      options: {
		        useUnicodeFlag: useUnicodeFlag
		      }
		    });
		  });

		  var _transformUnicodeSetsRegex = declare(function (api) {
		    api.assertVersion("*");
		    return createRegExpFeaturePlugin({
		      name: "transform-unicode-sets-regex",
		      feature: "unicodeSetsFlag",
		      manipulateOptions: function manipulateOptions(opts, parserOpts) {
		        parserOpts.plugins.push("regexpUnicodeSets");
		      }
		    });
		  });

		  var _transformAsyncToGenerator = declare(function (api, options) {
		    var _api$assumption, _api$assumption2;
		    api.assertVersion("*");
		    var method = options.method,
		      module = options.module;
		    var noNewArrows = (_api$assumption = api.assumption("noNewArrows")) != null ? _api$assumption : true;
		    var ignoreFunctionLength = (_api$assumption2 = api.assumption("ignoreFunctionLength")) != null ? _api$assumption2 : false;
		    if (method && module) {
		      return {
		        name: "transform-async-to-generator",
		        visitor: {
		          Function: function Function(path, state) {
		            if (!path.node.async || path.node.generator) return;
		            var wrapAsync = state.methodWrapper;
		            if (wrapAsync) {
		              wrapAsync = cloneNode$j(wrapAsync);
		            } else {
		              wrapAsync = state.methodWrapper = addNamed(path, method, module);
		            }
		            remapAsyncToGenerator(path, {
		              wrapAsync: wrapAsync
		            }, noNewArrows, ignoreFunctionLength);
		          }
		        }
		      };
		    }
		    return {
		      name: "transform-async-to-generator",
		      visitor: {
		        Function: function Function(path, state) {
		          if (!path.node.async || path.node.generator) return;
		          remapAsyncToGenerator(path, {
		            wrapAsync: state.addHelper("asyncToGenerator")
		          }, noNewArrows, ignoreFunctionLength);
		        }
		      }
		    };
		  });

		  var _transformArrowFunctions = declare(function (api, options) {
		    var _api$assumption;
		    api.assertVersion("*");
		    var noNewArrows = (_api$assumption = api.assumption("noNewArrows")) != null ? _api$assumption : !options.spec;
		    return {
		      name: "transform-arrow-functions",
		      visitor: {
		        ArrowFunctionExpression: function ArrowFunctionExpression(path) {
		          if (!path.isArrowFunctionExpression()) return;
		          {
		            path.arrowFunctionToExpression({
		              allowInsertArrow: false,
		              noNewArrows: noNewArrows,
		              specCompliant: !noNewArrows
		            });
		          }
		        }
		      }
		    };
		  });

		  var _transformBlockScopedFunctions = declare(function (api) {
		    api.assertVersion("*");
		    function transformStatementList(paths) {
		      for (var _iterator = _createForOfIteratorHelperLoose(paths), _step; !(_step = _iterator()).done;) {
		        var path = _step.value;
		        if (!path.isFunctionDeclaration()) continue;
		        var func = path.node;
		        var declar = variableDeclaration$8("let", [variableDeclarator$8(func.id, toExpression$1(func))]);
		        declar._blockHoist = 2;
		        func.id = null;
		        path.replaceWith(declar);
		      }
		    }
		    return {
		      name: "transform-block-scoped-functions",
		      visitor: {
		        BlockStatement: function BlockStatement(path) {
		          var node = path.node,
		            parent = path.parent;
		          if (isFunction$5(parent, {
		            body: node
		          }) || isExportDeclaration$3(parent)) {
		            return;
		          }
		          transformStatementList(path.get("body"));
		        },
		        SwitchCase: function SwitchCase(path) {
		          transformStatementList(path.get("consequent"));
		        }
		      }
		    };
		  });

		  var _templateObject$m, _templateObject2$c, _templateObject3$7, _templateObject4$3;
		  var collectLoopBodyBindingsVisitor = {
		    "Expression|Declaration|Loop": function ExpressionDeclarationLoop(path) {
		      path.skip();
		    },
		    Scope: function Scope(path, state) {
		      if (path.isFunctionParent()) path.skip();
		      var bindings = path.scope.bindings;
		      for (var _i = 0, _Object$keys = Object.keys(bindings); _i < _Object$keys.length; _i++) {
		        var name = _Object$keys[_i];
		        var binding = bindings[name];
		        if (binding.kind === "let" || binding.kind === "const" || binding.kind === "hoisted") {
		          state.blockScoped.push(binding);
		        }
		      }
		    }
		  };
		  function getLoopBodyBindings(loopPath) {
		    var state = {
		      blockScoped: []
		    };
		    loopPath.traverse(collectLoopBodyBindingsVisitor, state);
		    return state.blockScoped;
		  }
		  function getUsageInBody(binding, loopPath) {
		    var seen = new WeakSet();
		    var capturedInClosure = false;
		    var constantViolations = filterMap(binding.constantViolations, function (path) {
		      var _relativeLoopLocation = relativeLoopLocation(path, loopPath),
		        inBody = _relativeLoopLocation.inBody,
		        inClosure = _relativeLoopLocation.inClosure;
		      if (!inBody) return null;
		      capturedInClosure || (capturedInClosure = inClosure);
		      var id = path.isUpdateExpression() ? path.get("argument") : path.isAssignmentExpression() ? path.get("left") : null;
		      if (id) seen.add(id.node);
		      return id;
		    });
		    var references = filterMap(binding.referencePaths, function (path) {
		      if (seen.has(path.node)) return null;
		      var _relativeLoopLocation2 = relativeLoopLocation(path, loopPath),
		        inBody = _relativeLoopLocation2.inBody,
		        inClosure = _relativeLoopLocation2.inClosure;
		      if (!inBody) return null;
		      capturedInClosure || (capturedInClosure = inClosure);
		      return path;
		    });
		    return {
		      capturedInClosure: capturedInClosure,
		      hasConstantViolations: constantViolations.length > 0,
		      usages: references.concat(constantViolations)
		    };
		  }
		  function relativeLoopLocation(path, loopPath) {
		    var bodyPath = loopPath.get("body");
		    var inClosure = false;
		    for (var currPath = path; currPath; currPath = currPath.parentPath) {
		      if (currPath.isFunction() || currPath.isClass() || currPath.isMethod()) {
		        inClosure = true;
		      }
		      if (currPath === bodyPath) {
		        return {
		          inBody: true,
		          inClosure: inClosure
		        };
		      } else if (currPath === loopPath) {
		        return {
		          inBody: false,
		          inClosure: inClosure
		        };
		      }
		    }
		    throw new Error("Internal Babel error: path is not in loop. Please report this as a bug.");
		  }
		  var collectCompletionsAndVarsVisitor = {
		    Function: function Function(path) {
		      path.skip();
		    },
		    LabeledStatement: {
		      enter: function enter(_ref, state) {
		        var node = _ref.node;
		        state.labelsStack.push(node.label.name);
		      },
		      exit: function exit(_ref2, state) {
		        var node = _ref2.node;
		        var popped = state.labelsStack.pop();
		        if (popped !== node.label.name) {
		          throw new Error("Assertion failure. Please report this bug to Babel.");
		        }
		      }
		    },
		    Loop: {
		      enter: function enter(_, state) {
		        state.labellessContinueTargets++;
		        state.labellessBreakTargets++;
		      },
		      exit: function exit(_, state) {
		        state.labellessContinueTargets--;
		        state.labellessBreakTargets--;
		      }
		    },
		    SwitchStatement: {
		      enter: function enter(_, state) {
		        state.labellessBreakTargets++;
		      },
		      exit: function exit(_, state) {
		        state.labellessBreakTargets--;
		      }
		    },
		    "BreakStatement|ContinueStatement": function BreakStatementContinueStatement(path, state) {
		      var label = path.node.label;
		      if (label) {
		        if (state.labelsStack.includes(label.name)) return;
		      } else if (path.isBreakStatement() ? state.labellessBreakTargets > 0 : state.labellessContinueTargets > 0) {
		        return;
		      }
		      state.breaksContinues.push(path);
		    },
		    ReturnStatement: function ReturnStatement(path, state) {
		      state.returns.push(path);
		    },
		    VariableDeclaration: function VariableDeclaration(path, state) {
		      if (path.parent === state.loopNode && isVarInLoopHead(path)) return;
		      if (path.node.kind === "var") state.vars.push(path);
		    }
		  };
		  function wrapLoopBody(loopPath, captured, updatedBindingsUsages) {
		    var loopNode = loopPath.node;
		    var state = {
		      breaksContinues: [],
		      returns: [],
		      labelsStack: [],
		      labellessBreakTargets: 0,
		      labellessContinueTargets: 0,
		      vars: [],
		      loopNode: loopNode
		    };
		    loopPath.traverse(collectCompletionsAndVarsVisitor, state);
		    var callArgs = [];
		    var closureParams = [];
		    var updater = [];
		    for (var _iterator = _createForOfIteratorHelperLoose(updatedBindingsUsages), _step; !(_step = _iterator()).done;) {
		      var _step$value = _slicedToArray(_step.value, 2),
		        _name2 = _step$value[0],
		        updatedUsage = _step$value[1];
		      callArgs.push(identifier$j(_name2));
		      var innerName = loopPath.scope.generateUid(_name2);
		      closureParams.push(identifier$j(innerName));
		      updater.push(assignmentExpression$d("=", identifier$j(_name2), identifier$j(innerName)));
		      for (var _iterator7 = _createForOfIteratorHelperLoose(updatedUsage), _step7; !(_step7 = _iterator7()).done;) {
		        var _path3 = _step7.value;
		        _path3.replaceWith(identifier$j(innerName));
		      }
		    }
		    for (var _iterator2 = _createForOfIteratorHelperLoose(captured), _step2; !(_step2 = _iterator2()).done;) {
		      var _name3 = _step2.value;
		      if (updatedBindingsUsages.has(_name3)) continue;
		      callArgs.push(identifier$j(_name3));
		      closureParams.push(identifier$j(_name3));
		    }
		    var id = loopPath.scope.generateUid("loop");
		    var fn = functionExpression$2(null, closureParams, toBlock(loopNode.body));
		    var call = callExpression$d(identifier$j(id), callArgs);
		    var fnParent = loopPath.findParent(function (p) {
		      return p.isFunction();
		    });
		    if (fnParent) {
		      var _ref3 = fnParent.node,
		        async = _ref3.async,
		        generator = _ref3.generator;
		      fn.async = async;
		      fn.generator = generator;
		      if (generator) call = yieldExpression$2(call, true);else if (async) call = awaitExpression$1(call);
		    }
		    var updaterNode = updater.length > 0 ? expressionStatement$a(sequenceExpression$8(updater)) : null;
		    if (updaterNode) fn.body.body.push(updaterNode);
		    var _ref4 = loopPath.insertBefore(variableDeclaration$8("var", [variableDeclarator$8(identifier$j(id), fn)])),
		      _ref5 = _slicedToArray(_ref4, 1),
		      varPath = _ref5[0];
		    var bodyStmts = [];
		    var varNames = [];
		    for (var _iterator3 = _createForOfIteratorHelperLoose(state.vars), _step3; !(_step3 = _iterator3()).done;) {
		      var _varPath = _step3.value;
		      var assign = [];
		      for (var _iterator8 = _createForOfIteratorHelperLoose(_varPath.node.declarations), _step8; !(_step8 = _iterator8()).done;) {
		        var decl = _step8.value;
		        varNames.push.apply(varNames, _toConsumableArray(Object.keys(getBindingIdentifiers$4(decl.id))));
		        if (decl.init) {
		          assign.push(assignmentExpression$d("=", decl.id, decl.init));
		        } else if (isForXStatement$1(_varPath.parent, {
		          left: _varPath.node
		        })) {
		          assign.push(decl.id);
		        }
		      }
		      if (assign.length > 0) {
		        var replacement = assign.length === 1 ? assign[0] : sequenceExpression$8(assign);
		        _varPath.replaceWith(replacement);
		      } else {
		        _varPath.remove();
		      }
		    }
		    if (varNames.length) {
		      varPath.pushContainer("declarations", varNames.map(function (name) {
		        return variableDeclarator$8(identifier$j(name));
		      }));
		    }
		    var labelNum = state.breaksContinues.length;
		    var returnNum = state.returns.length;
		    if (labelNum + returnNum === 0) {
		      bodyStmts.push(expressionStatement$a(call));
		    } else if (labelNum === 1 && returnNum === 0) {
		      for (var _iterator4 = _createForOfIteratorHelperLoose(state.breaksContinues), _step4; !(_step4 = _iterator4()).done;) {
		        var path = _step4.value;
		        var node = path.node;
		        var type = node.type,
		          label = node.label;
		        var name = type === "BreakStatement" ? "break" : "continue";
		        if (label) name += " " + label.name;
		        path.replaceWith(addComment$2(returnStatement$3(numericLiteral$8(1)), "trailing", " " + name, true));
		        if (updaterNode) path.insertBefore(cloneNode$j(updaterNode));
		        bodyStmts.push(template$1.statement.ast(_templateObject$m || (_templateObject$m = _taggedTemplateLiteralLoose(["\n        if (", ") ", "\n      "])), call, node));
		      }
		    } else {
		      var completionId = loopPath.scope.generateUid("ret");
		      if (varPath.isVariableDeclaration()) {
		        varPath.pushContainer("declarations", [variableDeclarator$8(identifier$j(completionId))]);
		        bodyStmts.push(expressionStatement$a(assignmentExpression$d("=", identifier$j(completionId), call)));
		      } else {
		        bodyStmts.push(variableDeclaration$8("var", [variableDeclarator$8(identifier$j(completionId), call)]));
		      }
		      var injected = [];
		      for (var _iterator5 = _createForOfIteratorHelperLoose(state.breaksContinues), _step5; !(_step5 = _iterator5()).done;) {
		        var _path2 = _step5.value;
		        var _node = _path2.node;
		        var _type = _node.type,
		          _label = _node.label;
		        var _name = _type === "BreakStatement" ? "break" : "continue";
		        if (_label) _name += " " + _label.name;
		        var i = injected.indexOf(_name);
		        var hasInjected = i !== -1;
		        if (!hasInjected) {
		          injected.push(_name);
		          i = injected.length - 1;
		        }
		        _path2.replaceWith(addComment$2(returnStatement$3(numericLiteral$8(i)), "trailing", " " + _name, true));
		        if (updaterNode) _path2.insertBefore(cloneNode$j(updaterNode));
		        if (hasInjected) continue;
		        bodyStmts.push(template$1.statement.ast(_templateObject4$3 || (_templateObject4$3 = _taggedTemplateLiteralLoose(["\n        if (", " === ", ") ", "\n      "])), identifier$j(completionId), numericLiteral$8(i), _node));
		      }
		      if (returnNum) {
		        for (var _iterator6 = _createForOfIteratorHelperLoose(state.returns), _step6; !(_step6 = _iterator6()).done;) {
		          var _path = _step6.value;
		          var arg = _path.node.argument || _path.scope.buildUndefinedNode();
		          _path.replaceWith(template$1.statement.ast(_templateObject3$7 || (_templateObject3$7 = _taggedTemplateLiteralLoose(["\n          return { v: ", " };\n        "])), arg));
		        }
		        bodyStmts.push(template$1.statement.ast(_templateObject2$c || (_templateObject2$c = _taggedTemplateLiteralLoose(["\n          if (", ") return ", ".v;\n        "])), identifier$j(completionId), identifier$j(completionId)));
		      }
		    }
		    loopNode.body = blockStatement$6(bodyStmts);
		    return varPath;
		  }
		  function isVarInLoopHead(path) {
		    if (isForStatement$2(path.parent)) return path.key === "init";
		    if (isForXStatement$1(path.parent)) return path.key === "left";
		    return false;
		  }
		  function filterMap(list, fn) {
		    var result = [];
		    for (var _iterator9 = _createForOfIteratorHelperLoose(list), _step9; !(_step9 = _iterator9()).done;) {
		      var _item = _step9.value;
		      var mapped = fn(_item);
		      if (mapped) result.push(mapped);
		    }
		    return result;
		  }

		  function validateUsage(path, state, tdzEnabled) {
		    var dynamicTDZNames = [];
		    for (var _i = 0, _Object$keys = Object.keys(path.getBindingIdentifiers()); _i < _Object$keys.length; _i++) {
		      var name = _Object$keys[_i];
		      var binding = path.scope.getBinding(name);
		      if (!binding) continue;
		      if (tdzEnabled) {
		        if (injectTDZChecks(binding, state)) dynamicTDZNames.push(name);
		      }
		      if (path.node.kind === "const") {
		        disallowConstantViolations(name, binding, state);
		      }
		    }
		    return dynamicTDZNames;
		  }
		  function disallowConstantViolations(name, binding, state) {
		    for (var _iterator = _createForOfIteratorHelperLoose(binding.constantViolations), _step; !(_step = _iterator()).done;) {
		      var violation = _step.value;
		      var readOnlyError = state.addHelper("readOnlyError");
		      var throwNode = callExpression$d(readOnlyError, [stringLiteral$8(name)]);
		      if (violation.isAssignmentExpression()) {
		        var _violation$node = violation.node,
		          operator = _violation$node.operator,
		          left = _violation$node.left,
		          right = _violation$node.right;
		        if (operator === "=") {
		          var exprs = [right];
		          exprs.push(throwNode);
		          violation.replaceWith(sequenceExpression$8(exprs));
		        } else if (["&&=", "||=", "??="].includes(operator)) {
		          violation.replaceWith(logicalExpression$3(operator.slice(0, -1), left, sequenceExpression$8([right, throwNode])));
		        } else {
		          violation.replaceWith(sequenceExpression$8([binaryExpression$5(operator.slice(0, -1), left, right), throwNode]));
		        }
		      } else if (violation.isUpdateExpression()) {
		        violation.replaceWith(sequenceExpression$8([unaryExpression$6("+", violation.get("argument").node), throwNode]));
		      } else if (violation.isForXStatement()) {
		        violation.ensureBlock();
		        violation.get("left").replaceWith(variableDeclaration$8("var", [variableDeclarator$8(violation.scope.generateUidIdentifier(name))]));
		        violation.node.body.body.unshift(expressionStatement$a(throwNode));
		      }
		    }
		  }
		  function getTDZStatus(refPath, bindingPath) {
		    var executionStatus = bindingPath._guessExecutionStatusRelativeTo(refPath);
		    if (executionStatus === "before") {
		      return "outside";
		    } else if (executionStatus === "after") {
		      return "inside";
		    } else {
		      return "maybe";
		    }
		  }
		  var skipTDZChecks = new WeakSet();
		  function buildTDZAssert(status, node, state) {
		    if (status === "maybe") {
		      var clone = cloneNode$j(node);
		      skipTDZChecks.add(clone);
		      return callExpression$d(state.addHelper("temporalRef"), [clone, stringLiteral$8(node.name)]);
		    } else {
		      return callExpression$d(state.addHelper("tdz"), [stringLiteral$8(node.name)]);
		    }
		  }
		  function getTDZReplacement(path, state, id) {
		    var _path$scope$getBindin;
		    if (id === void 0) {
		      id = path.node;
		    }
		    if (skipTDZChecks.has(id)) return;
		    skipTDZChecks.add(id);
		    var bindingPath = (_path$scope$getBindin = path.scope.getBinding(id.name)) == null ? void 0 : _path$scope$getBindin.path;
		    if (!bindingPath || bindingPath.isFunctionDeclaration()) return;
		    var status = getTDZStatus(path, bindingPath);
		    if (status === "outside") return;
		    if (status === "maybe") {
		      bindingPath.parent._tdzThis = true;
		    }
		    return {
		      status: status,
		      node: buildTDZAssert(status, id, state)
		    };
		  }
		  function injectTDZChecks(binding, state) {
		    var allUsages = new Set(binding.referencePaths);
		    binding.constantViolations.forEach(allUsages.add, allUsages);
		    var dynamicTdz = false;
		    for (var _iterator2 = _createForOfIteratorHelperLoose(binding.constantViolations), _step2; !(_step2 = _iterator2()).done;) {
		      var _path2 = _step2.value;
		      var node = _path2.node;
		      if (skipTDZChecks.has(node)) continue;
		      skipTDZChecks.add(node);
		      if (_path2.isUpdateExpression()) {
		        var arg = _path2.get("argument");
		        var _replacement = getTDZReplacement(_path2, state, arg.node);
		        if (!_replacement) continue;
		        if (_replacement.status === "maybe") {
		          dynamicTdz = true;
		          _path2.insertBefore(_replacement.node);
		        } else {
		          _path2.replaceWith(_replacement.node);
		        }
		      } else if (_path2.isAssignmentExpression()) {
		        var nodes = [];
		        var ids = _path2.getBindingIdentifiers();
		        for (var _i3 = 0, _Object$keys2 = Object.keys(ids); _i3 < _Object$keys2.length; _i3++) {
		          var name = _Object$keys2[_i3];
		          var _replacement2 = getTDZReplacement(_path2, state, ids[name]);
		          if (_replacement2) {
		            nodes.push(expressionStatement$a(_replacement2.node));
		            if (_replacement2.status === "inside") break;
		            if (_replacement2.status === "maybe") dynamicTdz = true;
		          }
		        }
		        if (nodes.length > 0) _path2.insertBefore(nodes);
		      }
		    }
		    for (var _i2 = 0, _arr = binding.referencePaths; _i2 < _arr.length; _i2++) {
		      var _path = _arr[_i2];
		      if (_path.parentPath.isUpdateExpression()) continue;
		      if (_path.parentPath.isFor({
		        left: _path.node
		      })) continue;
		      var replacement = getTDZReplacement(_path, state);
		      if (!replacement) continue;
		      if (replacement.status === "maybe") dynamicTdz = true;
		      _path.replaceWith(replacement.node);
		    }
		    return dynamicTdz;
		  }

		  var annexB33FunctionsVisitor = {
		    VariableDeclaration: function VariableDeclaration(path) {
		      if (isStrict(path)) return;
		      if (path.node.kind !== "var") return;
		      var varScope = path.scope.getFunctionParent() || path.scope.getProgramParent();
		      varScope.path.traverse(functionsToVarVisitor, {
		        names: Object.keys(path.getBindingIdentifiers())
		      });
		    },
		    BlockStatement: function BlockStatement(path) {
		      if (isStrict(path)) return;
		      if (isFunction$5(path.parent, {
		        body: path.node
		      })) return;
		      transformStatementList(path.get("body"));
		    },
		    SwitchCase: function SwitchCase(path) {
		      if (isStrict(path)) return;
		      transformStatementList(path.get("consequent"));
		    }
		  };
		  function transformStatementList(paths) {
		    outer: for (var _iterator = _createForOfIteratorHelperLoose(paths), _step; !(_step = _iterator()).done;) {
		      var path = _step.value;
		      if (!path.isFunctionDeclaration()) continue;
		      if (path.node.async || path.node.generator) return;
		      var scope = path.parentPath.scope;
		      if (isVarScope(scope)) return;
		      var name = path.node.id.name;
		      var currScope = scope;
		      do {
		        if (currScope.parent.hasOwnBinding(name)) continue outer;
		        currScope = currScope.parent;
		      } while (!isVarScope(currScope));
		      maybeTransformBlockScopedFunction(path);
		    }
		  }
		  function maybeTransformBlockScopedFunction(path) {
		    var node = path.node,
		      scope = path.parentPath.scope;
		    var id = node.id;
		    scope.removeOwnBinding(id.name);
		    node.id = null;
		    var varNode = variableDeclaration$8("var", [variableDeclarator$8(id, toExpression$1(node))]);
		    varNode._blockHoist = 2;
		    var _path$replaceWith = path.replaceWith(varNode),
		      _path$replaceWith2 = _slicedToArray(_path$replaceWith, 1),
		      varPath = _path$replaceWith2[0];
		    scope.registerDeclaration(varPath);
		  }
		  var functionsToVarVisitor = {
		    Scope: function Scope(path, _ref) {
		      var names = _ref.names;
		      for (var _iterator2 = _createForOfIteratorHelperLoose(names), _step2; !(_step2 = _iterator2()).done;) {
		        var name = _step2.value;
		        var binding = path.scope.getOwnBinding(name);
		        if (binding && binding.kind === "hoisted") {
		          maybeTransformBlockScopedFunction(binding.path);
		        }
		      }
		    },
		    "Expression|Declaration": function ExpressionDeclaration(path) {
		      path.skip();
		    }
		  };
		  function isVarScope(scope) {
		    return scope.path.isFunctionParent() || scope.path.isProgram();
		  }
		  function isStrict(path) {
		    return !!path.find(function (_ref2) {
		      var _node$directives;
		      var node = _ref2.node;
		      if (isProgram$1(node)) {
		        if (node.sourceType === "module") return true;
		      } else if (isClass$1(node)) {
		        return true;
		      } else if (!isBlockStatement$3(node)) {
		        return false;
		      }
		      return (_node$directives = node.directives) == null ? void 0 : _node$directives.some(function (directive) {
		        return directive.value.value === "use strict";
		      });
		    });
		  }

		  var _transformBlockScoping = declare(function (api, opts) {
		    api.assertVersion("*");
		    var _opts$throwIfClosureR = opts.throwIfClosureRequired,
		      throwIfClosureRequired = _opts$throwIfClosureR === void 0 ? false : _opts$throwIfClosureR,
		      _opts$tdz = opts.tdz,
		      tdzEnabled = _opts$tdz === void 0 ? false : _opts$tdz;
		    if (typeof throwIfClosureRequired !== "boolean") {
		      throw new Error(".throwIfClosureRequired must be a boolean, or undefined");
		    }
		    if (typeof tdzEnabled !== "boolean") {
		      throw new Error(".tdz must be a boolean, or undefined");
		    }
		    return {
		      name: "transform-block-scoping",
		      visitor: traverse.visitors.merge([annexB33FunctionsVisitor, {
		        Loop: function (_Loop) {
		          function Loop(_x, _x2) {
		            return _Loop.apply(this, arguments);
		          }
		          Loop.toString = function () {
		            return _Loop.toString();
		          };
		          return Loop;
		        }(function (path, state) {
		          var isForStatement = path.isForStatement();
		          var headPath = isForStatement ? path.get("init") : path.isForXStatement() ? path.get("left") : null;
		          var needsBodyWrap = false;
		          var markNeedsBodyWrap = function markNeedsBodyWrap() {
		            if (throwIfClosureRequired) {
		              throw path.buildCodeFrameError("Compiling let/const in this block would add a closure " + "(throwIfClosureRequired).");
		            }
		            needsBodyWrap = true;
		          };
		          var body = path.get("body");
		          var bodyScope;
		          if (body.isBlockStatement()) {
		            bodyScope = body.scope;
		          }
		          var bindings = getLoopBodyBindings(path);
		          for (var _iterator = _createForOfIteratorHelperLoose(bindings), _step; !(_step = _iterator()).done;) {
		            var _binding = _step.value;
		            var _getUsageInBody2 = getUsageInBody(_binding, path),
		              _capturedInClosure = _getUsageInBody2.capturedInClosure;
		            if (_capturedInClosure) markNeedsBodyWrap();
		          }
		          var captured = [];
		          var updatedBindingsUsages = new Map();
		          if (headPath && isBlockScoped(headPath.node)) {
		            var names = Object.keys(headPath.getBindingIdentifiers());
		            var headScope = headPath.scope;
		            for (var _i = 0, _names = names; _i < _names.length; _i++) {
		              var _bodyScope;
		              var name = _names[_i];
		              if ((_bodyScope = bodyScope) != null && _bodyScope.hasOwnBinding(name)) continue;
		              var binding = headScope.getOwnBinding(name);
		              if (!binding) {
		                headScope.crawl();
		                binding = headScope.getOwnBinding(name);
		              }
		              var _getUsageInBody = getUsageInBody(binding, path),
		                usages = _getUsageInBody.usages,
		                capturedInClosure = _getUsageInBody.capturedInClosure,
		                hasConstantViolations = _getUsageInBody.hasConstantViolations;
		              if (headScope.parent.hasBinding(name) || headScope.parent.hasGlobal(name)) {
		                var newName = headScope.generateUid(name);
		                headScope.rename(name, newName);
		                name = newName;
		              }
		              if (capturedInClosure) {
		                markNeedsBodyWrap();
		                captured.push(name);
		              }
		              if (isForStatement && hasConstantViolations) {
		                updatedBindingsUsages.set(name, usages);
		              }
		            }
		          }
		          if (needsBodyWrap) {
		            var varPath = wrapLoopBody(path, captured, updatedBindingsUsages);
		            if (headPath != null && headPath.isVariableDeclaration()) {
		              transformBlockScopedVariable(headPath, state, tdzEnabled);
		            }
		            varPath.get("declarations.0.init").unwrapFunctionEnvironment();
		          }
		        }),
		        VariableDeclaration: function VariableDeclaration(path, state) {
		          transformBlockScopedVariable(path, state, tdzEnabled);
		        },
		        ClassDeclaration: function ClassDeclaration(path) {
		          var id = path.node.id;
		          if (!id) return;
		          var scope = path.parentPath.scope;
		          if (!isVarScope(scope) && scope.parent.hasBinding(id.name, {
		            noUids: true
		          })) {
		            path.scope.rename(id.name);
		          }
		        }
		      }])
		    };
		  });
		  var conflictingFunctionsVisitor = {
		    Scope: function Scope(path, _ref) {
		      var names = _ref.names;
		      for (var _iterator2 = _createForOfIteratorHelperLoose(names), _step2; !(_step2 = _iterator2()).done;) {
		        var name = _step2.value;
		        var binding = path.scope.getOwnBinding(name);
		        if (binding && binding.kind === "hoisted") {
		          path.scope.rename(name);
		        }
		      }
		    },
		    "Expression|Declaration": function ExpressionDeclaration(path) {
		      path.skip();
		    }
		  };
		  function transformBlockScopedVariable(path, state, tdzEnabled) {
		    if (!isBlockScoped(path.node)) return;
		    var dynamicTDZNames = validateUsage(path, state, tdzEnabled);
		    path.node.kind = "var";
		    var bindingNames = Object.keys(path.getBindingIdentifiers());
		    for (var _i2 = 0, _bindingNames = bindingNames; _i2 < _bindingNames.length; _i2++) {
		      var name = _bindingNames[_i2];
		      var binding = path.scope.getOwnBinding(name);
		      if (!binding) continue;
		      binding.kind = "var";
		    }
		    if (isInLoop(path) && !isVarInLoopHead(path) || dynamicTDZNames.length > 0) {
		      for (var _iterator3 = _createForOfIteratorHelperLoose(path.node.declarations), _step3; !(_step3 = _iterator3()).done;) {
		        var _decl$init;
		        var decl = _step3.value;
		        (_decl$init = decl.init) != null ? _decl$init : decl.init = path.scope.buildUndefinedNode();
		      }
		    }
		    var blockScope = path.scope;
		    var varScope = blockScope.getFunctionParent() || blockScope.getProgramParent();
		    if (varScope !== blockScope) {
		      for (var _iterator4 = _createForOfIteratorHelperLoose(bindingNames), _step4; !(_step4 = _iterator4()).done;) {
		        var _name = _step4.value;
		        var newName = _name;
		        if (blockScope.parent.hasBinding(_name, {
		          noUids: true
		        }) || blockScope.parent.hasGlobal(_name)) {
		          newName = blockScope.generateUid(_name);
		          blockScope.rename(_name, newName);
		        }
		        blockScope.moveBindingTo(newName, varScope);
		      }
		    }
		    blockScope.path.traverse(conflictingFunctionsVisitor, {
		      names: bindingNames
		    });
		    for (var _iterator5 = _createForOfIteratorHelperLoose(dynamicTDZNames), _step5; !(_step5 = _iterator5()).done;) {
		      var _name2 = _step5.value;
		      path.scope.push({
		        id: identifier$j(_name2),
		        init: state.addHelper("temporalUndefined")
		      });
		    }
		  }
		  function isLetOrConst(kind) {
		    return kind === "let" || kind === "const";
		  }
		  function isInLoop(path) {
		    if (!path.parentPath) return false;
		    if (path.parentPath.isLoop()) return true;
		    if (path.parentPath.isFunctionParent()) return false;
		    return isInLoop(path.parentPath);
		  }
		  function isBlockScoped(node) {
		    if (!isVariableDeclaration$4(node)) return false;
		    if (node[BLOCK_SCOPED_SYMBOL]) {
		      return true;
		    }
		    if (!isLetOrConst(node.kind) && node.kind !== "using") {
		      return false;
		    }
		    return true;
		  }

		  function bool$2(value) {
		    if (value == null) return false;
		    return value && value !== "false" && value !== "0";
		  }
		  var globals = bool$2(browser$1$1.env["BABEL_8_BREAKING"]) ? requireGlobalsBABEL_8_BREAKINGFalse() : requireGlobalsBABEL_8_BREAKINGFalse();

		  var _templateObject$l;
		  var helper$1 = template$1.statement(_templateObject$l || (_templateObject$l = _taggedTemplateLiteralLoose(["\n  function CALL_SUPER(\n    _this,\n    derived,\n    args,\n  ) {\n    function isNativeReflectConstruct() {\n      if (typeof Reflect === \"undefined\" || !Reflect.construct) return false;\n\n      // core-js@3\n      if (Reflect.construct.sham) return false;\n\n      // Proxy can't be polyfilled. Every browser implemented\n      // proxies before or at the same time as Reflect.construct,\n      // so if they support Proxy they also support Reflect.construct.\n      if (typeof Proxy === \"function\") return true;\n\n      // Since Reflect.construct can't be properly polyfilled, some\n      // implementations (e.g. core-js@2) don't set the correct internal slots.\n      // Those polyfills don't allow us to subclass built-ins, so we need to\n      // use our fallback implementation.\n      try {\n        // If the internal slots aren't set, this throws an error similar to\n        //   TypeError: this is not a Boolean object.\n        return !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {}),);\n      } catch (e) {\n        return false;\n      }\n    }\n\n    // Super\n    derived = GET_PROTOTYPE_OF(derived);\n    return POSSIBLE_CONSTRUCTOR_RETURN(\n      _this,\n      isNativeReflectConstruct()\n        ? // NOTE: This doesn't work if this.__proto__.constructor has been modified.\n          Reflect.construct(\n            derived,\n            args || [],\n            GET_PROTOTYPE_OF(_this).constructor,\n          )\n        : derived.apply(_this, args),\n    );\n  }\n"])));
		  var helperIDs = new WeakMap();
		  function addCallSuperHelper(file) {
		    if (helperIDs.has(file)) {
		      return (cloneNode$j || clone)(helperIDs.get(file));
		    }
		    try {
		      return file.addHelper("callSuper");
		    } catch (_unused) {}
		    var id = file.scope.generateUidIdentifier("callSuper");
		    helperIDs.set(file, id);
		    var fn = helper$1({
		      CALL_SUPER: id,
		      GET_PROTOTYPE_OF: file.addHelper("getPrototypeOf"),
		      POSSIBLE_CONSTRUCTOR_RETURN: file.addHelper("possibleConstructorReturn")
		    });
		    file.path.unshiftContainer("body", [fn]);
		    file.scope.registerDeclaration(file.path.get("body.0"));
		    return cloneNode$j(id);
		  }

		  var _templateObject$k;
		  function buildConstructor(classRef, constructorBody, node) {
		    var func = functionDeclaration(cloneNode$j(classRef), [], constructorBody);
		    inherits$3(func, node);
		    return func;
		  }
		  function transformClass(path, file, builtinClasses, isLoose, assumptions, supportUnicodeId) {
		    var classState = {
		      parent: undefined,
		      scope: undefined,
		      node: undefined,
		      path: undefined,
		      file: undefined,
		      classId: undefined,
		      classRef: undefined,
		      superName: null,
		      superReturns: [],
		      isDerived: false,
		      extendsNative: false,
		      construct: undefined,
		      constructorBody: undefined,
		      userConstructor: undefined,
		      userConstructorPath: undefined,
		      hasConstructor: false,
		      body: [],
		      superThises: [],
		      pushedInherits: false,
		      pushedCreateClass: false,
		      protoAlias: null,
		      isLoose: false,
		      dynamicKeys: new Map(),
		      methods: {
		        instance: {
		          hasComputed: false,
		          list: [],
		          map: new Map()
		        },
		        "static": {
		          hasComputed: false,
		          list: [],
		          map: new Map()
		        }
		      }
		    };
		    var setState = function setState(newState) {
		      Object.assign(classState, newState);
		    };
		    var findThisesVisitor = traverse.visitors.merge([visitor$5, {
		      ThisExpression: function ThisExpression(path) {
		        classState.superThises.push(path);
		      }
		    }]);
		    function createClassHelper(args) {
		      return callExpression$d(classState.file.addHelper("createClass"), args);
		    }
		    function maybeCreateConstructor() {
		      var classBodyPath = classState.path.get("body");
		      for (var _iterator = _createForOfIteratorHelperLoose(classBodyPath.get("body")), _step; !(_step = _iterator()).done;) {
		        var _path = _step.value;
		        if (_path.isClassMethod({
		          kind: "constructor"
		        })) return;
		      }
		      var params, body;
		      if (classState.isDerived) {
		        var _constructor = template$1.expression.ast(_templateObject$k || (_templateObject$k = _taggedTemplateLiteralLoose(["\n        (function () {\n          super(...arguments);\n        })\n      "])));
		        params = _constructor.params;
		        body = _constructor.body;
		      } else {
		        params = [];
		        body = blockStatement$6([]);
		      }
		      classBodyPath.unshiftContainer("body", classMethod("constructor", identifier$j("constructor"), params, body));
		    }
		    function buildBody() {
		      maybeCreateConstructor();
		      pushBody();
		      verifyConstructor();
		      if (classState.userConstructor) {
		        var _constructorBody$body;
		        var constructorBody = classState.constructorBody,
		          userConstructor = classState.userConstructor,
		          construct = classState.construct;
		        (_constructorBody$body = constructorBody.body).push.apply(_constructorBody$body, _toConsumableArray(userConstructor.body.body));
		        inherits$3(construct, userConstructor);
		        inherits$3(constructorBody, userConstructor.body);
		      }
		      pushDescriptors();
		    }
		    function pushBody() {
		      var classBodyPaths = classState.path.get("body.body");
		      var _loop = function _loop() {
		        var path = _step2.value;
		        var node = path.node;
		        if (path.isClassProperty() || path.isClassPrivateProperty()) {
		          throw path.buildCodeFrameError("Missing class properties transform.");
		        }
		        if (node.decorators) {
		          throw path.buildCodeFrameError("Method has decorators, put the decorator plugin before the classes one.");
		        }
		        if (isClassMethod(node)) {
		          var isConstructor = node.kind === "constructor";
		          var replaceSupers = new ReplaceSupers({
		            methodPath: path,
		            objectRef: classState.classRef,
		            superRef: classState.superName,
		            constantSuper: assumptions.constantSuper,
		            file: classState.file,
		            refToPreserve: classState.classRef
		          });
		          replaceSupers.replace();
		          var superReturns = [];
		          path.traverse(traverse.visitors.merge([visitor$5, {
		            ReturnStatement: function ReturnStatement(path) {
		              if (!path.getFunctionParent().isArrowFunctionExpression()) {
		                superReturns.push(path);
		              }
		            }
		          }]));
		          if (isConstructor) {
		            pushConstructor(superReturns, node, path);
		          } else {
		            pushMethod(node, path);
		          }
		        }
		      };
		      for (var _iterator2 = _createForOfIteratorHelperLoose(classBodyPaths), _step2; !(_step2 = _iterator2()).done;) {
		        _loop();
		      }
		    }
		    function pushDescriptors() {
		      pushInheritsToBody();
		      var body = classState.body;
		      var props = {
		        instance: null,
		        "static": null
		      };
		      for (var _iterator3 = _createForOfIteratorHelperLoose(["static", "instance"]), _step3; !(_step3 = _iterator3()).done;) {
		        var placement = _step3.value;
		        if (classState.methods[placement].list.length) {
		          props[placement] = classState.methods[placement].list.map(function (desc) {
		            var obj = objectExpression$3([objectProperty$1(identifier$j("key"), desc.key)]);
		            for (var _iterator4 = _createForOfIteratorHelperLoose(["get", "set", "value"]), _step4; !(_step4 = _iterator4()).done;) {
		              var kind = _step4.value;
		              if (desc[kind] != null) {
		                obj.properties.push(objectProperty$1(identifier$j(kind), desc[kind]));
		              }
		            }
		            return obj;
		          });
		        }
		      }
		      if (props.instance || props["static"]) {
		        var args = [cloneNode$j(classState.classRef), props.instance ? arrayExpression$1(props.instance) : nullLiteral$2(), props["static"] ? arrayExpression$1(props["static"]) : nullLiteral$2()];
		        var lastNonNullIndex = 0;
		        for (var i = 0; i < args.length; i++) {
		          if (!isNullLiteral$2(args[i])) lastNonNullIndex = i;
		        }
		        args = args.slice(0, lastNonNullIndex + 1);
		        body.push(returnStatement$3(createClassHelper(args)));
		        classState.pushedCreateClass = true;
		      }
		    }
		    function wrapSuperCall(bareSuper, superRef, thisRef, body) {
		      var bareSuperNode = bareSuper.node;
		      var call;
		      if (assumptions.superIsCallableConstructor) {
		        bareSuperNode.arguments.unshift(thisExpression$4());
		        if (bareSuperNode.arguments.length === 2 && isSpreadElement$1(bareSuperNode.arguments[1]) && isIdentifier$i(bareSuperNode.arguments[1].argument, {
		          name: "arguments"
		        })) {
		          bareSuperNode.arguments[1] = bareSuperNode.arguments[1].argument;
		          bareSuperNode.callee = memberExpression$c(cloneNode$j(superRef), identifier$j("apply"));
		        } else {
		          bareSuperNode.callee = memberExpression$c(cloneNode$j(superRef), identifier$j("call"));
		        }
		        call = logicalExpression$3("||", bareSuperNode, thisExpression$4());
		      } else {
		        var _bareSuperNode$argume;
		        var args = [thisExpression$4(), cloneNode$j(classState.classRef)];
		        if ((_bareSuperNode$argume = bareSuperNode.arguments) != null && _bareSuperNode$argume.length) {
		          var bareSuperNodeArguments = bareSuperNode.arguments;
		          if (bareSuperNodeArguments.length === 1 && isSpreadElement$1(bareSuperNodeArguments[0]) && isIdentifier$i(bareSuperNodeArguments[0].argument, {
		            name: "arguments"
		          })) {
		            args.push(bareSuperNodeArguments[0].argument);
		          } else {
		            args.push(arrayExpression$1(bareSuperNodeArguments));
		          }
		        }
		        call = callExpression$d(addCallSuperHelper(classState.file), args);
		      }
		      if (bareSuper.parentPath.isExpressionStatement() && bareSuper.parentPath.container === body.node.body && body.node.body.length - 1 === bareSuper.parentPath.key) {
		        if (classState.superThises.length) {
		          call = assignmentExpression$d("=", thisRef(), call);
		        }
		        bareSuper.parentPath.replaceWith(returnStatement$3(call));
		      } else {
		        bareSuper.replaceWith(assignmentExpression$d("=", thisRef(), call));
		      }
		    }
		    function verifyConstructor() {
		      if (!classState.isDerived) return;
		      var path = classState.userConstructorPath;
		      var body = path.get("body");
		      var constructorBody = path.get("body");
		      var maxGuaranteedSuperBeforeIndex = constructorBody.node.body.length;
		      path.traverse(findThisesVisitor);
		      var _thisRef = function thisRef() {
		        var ref = path.scope.generateDeclaredUidIdentifier("this");
		        maxGuaranteedSuperBeforeIndex++;
		        _thisRef = function thisRef() {
		          return cloneNode$j(ref);
		        };
		        return ref;
		      };
		      var buildAssertThisInitialized = function buildAssertThisInitialized() {
		        return callExpression$d(classState.file.addHelper("assertThisInitialized"), [_thisRef()]);
		      };
		      var bareSupers = [];
		      path.traverse(traverse.visitors.merge([visitor$5, {
		        Super: function Super(path) {
		          var node = path.node,
		            parentPath = path.parentPath;
		          if (parentPath.isCallExpression({
		            callee: node
		          })) {
		            bareSupers.unshift(parentPath);
		          }
		        }
		      }]));
		      var _loop2 = function _loop2() {
		        var bareSuper = _bareSupers[_i];
		        wrapSuperCall(bareSuper, classState.superName, _thisRef, body);
		        if (maxGuaranteedSuperBeforeIndex >= 0) {
		          var lastParentPath;
		          bareSuper.find(function (parentPath) {
		            if (parentPath === constructorBody) {
		              maxGuaranteedSuperBeforeIndex = Math.min(maxGuaranteedSuperBeforeIndex, lastParentPath.key);
		              return true;
		            }
		            if (parentPath.isLoop() || parentPath.isConditional() || parentPath.isArrowFunctionExpression()) {
		              maxGuaranteedSuperBeforeIndex = -1;
		              return true;
		            }
		            lastParentPath = parentPath;
		          });
		        }
		      };
		      for (var _i = 0, _bareSupers = bareSupers; _i < _bareSupers.length; _i++) {
		        _loop2();
		      }
		      var _loop3 = function _loop3() {
		        var thisPath = _step5.value;
		        var node = thisPath.node,
		          parentPath = thisPath.parentPath;
		        if (parentPath.isMemberExpression({
		          object: node
		        })) {
		          thisPath.replaceWith(_thisRef());
		          return 1;
		        }
		        var thisIndex;
		        thisPath.find(function (parentPath) {
		          if (parentPath.parentPath === constructorBody) {
		            thisIndex = parentPath.key;
		            return true;
		          }
		        });
		        if (maxGuaranteedSuperBeforeIndex !== -1 && thisIndex > maxGuaranteedSuperBeforeIndex) {
		          thisPath.replaceWith(_thisRef());
		        } else {
		          thisPath.replaceWith(buildAssertThisInitialized());
		        }
		      };
		      for (var _iterator5 = _createForOfIteratorHelperLoose(classState.superThises), _step5; !(_step5 = _iterator5()).done;) {
		        if (_loop3()) continue;
		      }
		      var wrapReturn;
		      if (classState.isLoose) {
		        wrapReturn = function wrapReturn(returnArg) {
		          var thisExpr = buildAssertThisInitialized();
		          return returnArg ? logicalExpression$3("||", returnArg, thisExpr) : thisExpr;
		        };
		      } else {
		        wrapReturn = function wrapReturn(returnArg) {
		          var returnParams = [_thisRef()];
		          if (returnArg != null) {
		            returnParams.push(returnArg);
		          }
		          return callExpression$d(classState.file.addHelper("possibleConstructorReturn"), returnParams);
		        };
		      }
		      var bodyPaths = body.get("body");
		      var guaranteedSuperBeforeFinish = maxGuaranteedSuperBeforeIndex !== -1 && maxGuaranteedSuperBeforeIndex < bodyPaths.length;
		      if (!bodyPaths.length || !bodyPaths.pop().isReturnStatement()) {
		        body.pushContainer("body", returnStatement$3(guaranteedSuperBeforeFinish ? _thisRef() : buildAssertThisInitialized()));
		      }
		      for (var _iterator6 = _createForOfIteratorHelperLoose(classState.superReturns), _step6; !(_step6 = _iterator6()).done;) {
		        var returnPath = _step6.value;
		        returnPath.get("argument").replaceWith(wrapReturn(returnPath.node.argument));
		      }
		    }
		    function pushMethod(node, path) {
		      var scope = path ? path.scope : classState.scope;
		      if (node.kind === "method") {
		        if (processMethod(node, scope)) return;
		      }
		      var placement = node["static"] ? "static" : "instance";
		      var methods = classState.methods[placement];
		      var descKey = node.kind === "method" ? "value" : node.kind;
		      var key = isNumericLiteral(node.key) || isBigIntLiteral(node.key) ? stringLiteral$8(String(node.key.value)) : toComputedKey$2(node);
		      var fn = toExpression$1(node);
		      if (isStringLiteral$5(key)) {
		        if (node.kind === "method") {
		          var _nameFunction;
		          fn = (_nameFunction = nameFunction({
		            id: key,
		            node: node,
		            scope: scope
		          }, undefined, supportUnicodeId)) != null ? _nameFunction : fn;
		        }
		      } else {
		        methods.hasComputed = true;
		      }
		      var descriptor;
		      if (!methods.hasComputed && methods.map.has(key.value)) {
		        descriptor = methods.map.get(key.value);
		        descriptor[descKey] = fn;
		        if (descKey === "value") {
		          descriptor.get = null;
		          descriptor.set = null;
		        } else {
		          descriptor.value = null;
		        }
		      } else {
		        var _descriptor;
		        descriptor = (_descriptor = {
		          key: key
		        }, _descriptor[descKey] = fn, _descriptor);
		        methods.list.push(descriptor);
		        if (!methods.hasComputed) {
		          methods.map.set(key.value, descriptor);
		        }
		      }
		    }
		    function processMethod(node, scope) {
		      if (assumptions.setClassMethods && !node.decorators) {
		        var classRef = classState.classRef;
		        if (!node["static"]) {
		          insertProtoAliasOnce();
		          classRef = classState.protoAlias;
		        }
		        var methodName = memberExpression$c(cloneNode$j(classRef), node.key, node.computed || isLiteral$6(node.key));
		        var func = functionExpression$2(null, node.params, node.body, node.generator, node.async);
		        inherits$3(func, node);
		        var key = toComputedKey$2(node, node.key);
		        if (isStringLiteral$5(key)) {
		          var _nameFunction2;
		          func = (_nameFunction2 = nameFunction({
		            node: func,
		            id: key,
		            scope: scope
		          }, undefined, supportUnicodeId)) != null ? _nameFunction2 : func;
		        }
		        var expr = expressionStatement$a(assignmentExpression$d("=", methodName, func));
		        inheritsComments$1(expr, node);
		        classState.body.push(expr);
		        return true;
		      }
		      return false;
		    }
		    function insertProtoAliasOnce() {
		      if (classState.protoAlias === null) {
		        setState({
		          protoAlias: classState.scope.generateUidIdentifier("proto")
		        });
		        var classProto = memberExpression$c(classState.classRef, identifier$j("prototype"));
		        var protoDeclaration = variableDeclaration$8("var", [variableDeclarator$8(classState.protoAlias, classProto)]);
		        classState.body.push(protoDeclaration);
		      }
		    }
		    function pushConstructor(superReturns, method, path) {
		      setState({
		        userConstructorPath: path,
		        userConstructor: method,
		        hasConstructor: true,
		        superReturns: superReturns
		      });
		      var construct = classState.construct;
		      inheritsComments$1(construct, method);
		      construct.params = method.params;
		      inherits$3(construct.body, method.body);
		      construct.body.directives = method.body.directives;
		      if (classState.hasInstanceDescriptors || classState.hasStaticDescriptors) {
		        pushDescriptors();
		      }
		      pushInheritsToBody();
		    }
		    function pushInheritsToBody() {
		      if (!classState.isDerived || classState.pushedInherits) return;
		      classState.pushedInherits = true;
		      classState.body.unshift(expressionStatement$a(callExpression$d(classState.file.addHelper(classState.isLoose ? "inheritsLoose" : "inherits"), [cloneNode$j(classState.classRef), cloneNode$j(classState.superName)])));
		    }
		    function extractDynamicKeys() {
		      var dynamicKeys = classState.dynamicKeys,
		        node = classState.node,
		        scope = classState.scope;
		      for (var _iterator7 = _createForOfIteratorHelperLoose(node.body.body), _step7; !(_step7 = _iterator7()).done;) {
		        var elem = _step7.value;
		        if (!isClassMethod(elem) || !elem.computed) continue;
		        if (scope.isPure(elem.key, true)) continue;
		        var id = scope.generateUidIdentifierBasedOnNode(elem.key);
		        dynamicKeys.set(id.name, elem.key);
		        elem.key = id;
		      }
		    }
		    function setupClosureParamsArgs() {
		      var superName = classState.superName,
		        dynamicKeys = classState.dynamicKeys;
		      var closureParams = [];
		      var closureArgs = [];
		      if (classState.isDerived) {
		        var arg = cloneNode$j(superName);
		        if (classState.extendsNative) {
		          arg = callExpression$d(classState.file.addHelper("wrapNativeSuper"), [arg]);
		          annotateAsPure(arg);
		        }
		        var param = classState.scope.generateUidIdentifierBasedOnNode(superName);
		        closureParams.push(param);
		        closureArgs.push(arg);
		        setState({
		          superName: cloneNode$j(param)
		        });
		      }
		      for (var _iterator8 = _createForOfIteratorHelperLoose(dynamicKeys), _step8; !(_step8 = _iterator8()).done;) {
		        var _step8$value = _slicedToArray(_step8.value, 2),
		          name = _step8$value[0],
		          value = _step8$value[1];
		        closureParams.push(identifier$j(name));
		        closureArgs.push(value);
		      }
		      return {
		        closureParams: closureParams,
		        closureArgs: closureArgs
		      };
		    }
		    function classTransformer(path, file, builtinClasses, isLoose) {
		      setState({
		        parent: path.parent,
		        scope: path.scope,
		        node: path.node,
		        path: path,
		        file: file,
		        isLoose: isLoose
		      });
		      setState({
		        classId: classState.node.id,
		        classRef: classState.node.id ? identifier$j(classState.node.id.name) : classState.scope.generateUidIdentifier("class"),
		        superName: classState.node.superClass,
		        isDerived: !!classState.node.superClass,
		        constructorBody: blockStatement$6([])
		      });
		      setState({
		        extendsNative: isIdentifier$i(classState.superName) && builtinClasses.has(classState.superName.name) && !classState.scope.hasBinding(classState.superName.name, true)
		      });
		      var classRef = classState.classRef,
		        node = classState.node,
		        constructorBody = classState.constructorBody;
		      setState({
		        construct: buildConstructor(classRef, constructorBody, node)
		      });
		      extractDynamicKeys();
		      var body = classState.body;
		      var _setupClosureParamsAr = setupClosureParamsArgs(),
		        closureParams = _setupClosureParamsAr.closureParams,
		        closureArgs = _setupClosureParamsAr.closureArgs;
		      buildBody();
		      if (!assumptions.noClassCalls) {
		        constructorBody.body.unshift(expressionStatement$a(callExpression$d(classState.file.addHelper("classCallCheck"), [thisExpression$4(), cloneNode$j(classState.classRef)])));
		      }
		      var isStrict = path.isInStrictMode();
		      var constructorOnly = classState.classId && body.length === 0;
		      if (constructorOnly && !isStrict) {
		        for (var _iterator9 = _createForOfIteratorHelperLoose(classState.construct.params), _step9; !(_step9 = _iterator9()).done;) {
		          var param = _step9.value;
		          if (!isIdentifier$i(param)) {
		            constructorOnly = false;
		            break;
		          }
		        }
		      }
		      var directives = constructorOnly ? classState.construct.body.directives : [];
		      if (!isStrict) {
		        directives.push(directive$1(directiveLiteral$1("use strict")));
		      }
		      if (constructorOnly) {
		        var expr = toExpression$1(classState.construct);
		        return classState.isLoose ? expr : createClassHelper([expr]);
		      }
		      if (!classState.pushedCreateClass) {
		        body.push(returnStatement$3(classState.isLoose ? cloneNode$j(classState.classRef) : createClassHelper([cloneNode$j(classState.classRef)])));
		      }
		      body.unshift(classState.construct);
		      var container = arrowFunctionExpression$4(closureParams, blockStatement$6(body, directives));
		      return callExpression$d(container, closureArgs);
		    }
		    return classTransformer(path, file, builtinClasses, isLoose);
		  }

		  var getBuiltinClasses = function getBuiltinClasses(category) {
		    return Object.keys(globals[category]).filter(function (name) {
		      return /^[A-Z]/.test(name);
		    });
		  };
		  var builtinClasses = new Set([].concat(_toConsumableArray(getBuiltinClasses("builtin")), _toConsumableArray(getBuiltinClasses("browser"))));
		  var _transformClasses = declare(function (api, options) {
		    var _api$assumption, _api$assumption2, _api$assumption3, _api$assumption4;
		    api.assertVersion("*");
		    var _options$loose = options.loose,
		      loose = _options$loose === void 0 ? false : _options$loose;
		    var setClassMethods = (_api$assumption = api.assumption("setClassMethods")) != null ? _api$assumption : loose;
		    var constantSuper = (_api$assumption2 = api.assumption("constantSuper")) != null ? _api$assumption2 : loose;
		    var superIsCallableConstructor = (_api$assumption3 = api.assumption("superIsCallableConstructor")) != null ? _api$assumption3 : loose;
		    var noClassCalls = (_api$assumption4 = api.assumption("noClassCalls")) != null ? _api$assumption4 : loose;
		    var supportUnicodeId = !isRequired("transform-unicode-escapes", api.targets());
		    var VISITED = new WeakSet();
		    return {
		      name: "transform-classes",
		      visitor: {
		        ExportDefaultDeclaration: function ExportDefaultDeclaration(path) {
		          if (!path.get("declaration").isClassDeclaration()) return;
		          splitExportDeclaration(path);
		        },
		        ClassDeclaration: function ClassDeclaration(path) {
		          var node = path.node;
		          var ref = node.id || path.scope.generateUidIdentifier("class");
		          path.replaceWith(variableDeclaration$8("let", [variableDeclarator$8(ref, toExpression$1(node))]));
		        },
		        ClassExpression: function ClassExpression(path, state) {
		          var node = path.node;
		          if (VISITED.has(node)) return;
		          var inferred = nameFunction(path, undefined, supportUnicodeId);
		          if (inferred && inferred !== node) {
		            path.replaceWith(inferred);
		            return;
		          }
		          VISITED.add(node);
		          var _path$replaceWith = path.replaceWith(transformClass(path, state.file, builtinClasses, loose, {
		              setClassMethods: setClassMethods,
		              constantSuper: constantSuper,
		              superIsCallableConstructor: superIsCallableConstructor,
		              noClassCalls: noClassCalls
		            }, supportUnicodeId)),
		            _path$replaceWith2 = _slicedToArray(_path$replaceWith, 1),
		            replacedPath = _path$replaceWith2[0];
		          if (replacedPath.isCallExpression()) {
		            annotateAsPure(replacedPath);
		            var callee = replacedPath.get("callee");
		            if (callee.isArrowFunctionExpression()) {
		              callee.arrowFunctionToExpression();
		            }
		          }
		        }
		      }
		    };
		  });

		  var _templateObject$j;
		  {
		    var DefineAccessorHelper = template$1.expression.ast(_templateObject$j || (_templateObject$j = _taggedTemplateLiteralLoose(["\n    function (type, obj, key, fn) {\n      var desc = { configurable: true, enumerable: true };\n      desc[type] = fn;\n      return Object.defineProperty(obj, key, desc);\n    }\n  "])));
		    DefineAccessorHelper._compact = true;
		  }
		  var _transformComputedProperties = declare(function (api, options) {
		    var _api$assumption;
		    api.assertVersion("*");
		    var setComputedProperties = (_api$assumption = api.assumption("setComputedProperties")) != null ? _api$assumption : options.loose;
		    var pushComputedProps = setComputedProperties ? pushComputedPropsLoose : pushComputedPropsSpec;
		    function buildDefineAccessor(state, obj, prop) {
		      var type = prop.kind;
		      var key = !prop.computed && isIdentifier$i(prop.key) ? stringLiteral$8(prop.key.name) : prop.key;
		      var fn = getValue(prop);
		      {
		        var helper;
		        if (state.availableHelper("defineAccessor")) {
		          helper = state.addHelper("defineAccessor");
		        } else {
		          var file = state.file;
		          helper = file.get("fallbackDefineAccessorHelper");
		          if (!helper) {
		            var id = file.scope.generateUidIdentifier("defineAccessor");
		            file.scope.push({
		              id: id,
		              init: DefineAccessorHelper
		            });
		            file.set("fallbackDefineAccessorHelper", helper = id);
		          }
		          helper = cloneNode$j(helper);
		        }
		        return callExpression$d(helper, [stringLiteral$8(type), obj, key, fn]);
		      }
		    }
		    function getValue(prop) {
		      if (isObjectProperty$4(prop)) {
		        return prop.value;
		      } else if (isObjectMethod$1(prop)) {
		        return functionExpression$2(null, prop.params, prop.body, prop.generator, prop.async);
		      }
		    }
		    function pushAssign(objId, prop, body) {
		      body.push(expressionStatement$a(assignmentExpression$d("=", memberExpression$c(cloneNode$j(objId), prop.key, prop.computed || isLiteral$6(prop.key)), getValue(prop))));
		    }
		    function pushComputedPropsLoose(info) {
		      var computedProps = info.computedProps,
		        state = info.state,
		        initPropExpression = info.initPropExpression,
		        objId = info.objId,
		        body = info.body;
		      for (var _iterator = _createForOfIteratorHelperLoose(computedProps), _step; !(_step = _iterator()).done;) {
		        var prop = _step.value;
		        if (isObjectMethod$1(prop) && (prop.kind === "get" || prop.kind === "set")) {
		          if (computedProps.length === 1) {
		            return buildDefineAccessor(state, initPropExpression, prop);
		          } else {
		            body.push(expressionStatement$a(buildDefineAccessor(state, cloneNode$j(objId), prop)));
		          }
		        } else {
		          pushAssign(cloneNode$j(objId), prop, body);
		        }
		      }
		    }
		    function pushComputedPropsSpec(info) {
		      var objId = info.objId,
		        body = info.body,
		        computedProps = info.computedProps,
		        state = info.state;
		      var CHUNK_LENGTH_CAP = 10;
		      var currentChunk = null;
		      var computedPropsChunks = [];
		      for (var _iterator2 = _createForOfIteratorHelperLoose(computedProps), _step2; !(_step2 = _iterator2()).done;) {
		        var _prop = _step2.value;
		        if (!currentChunk || currentChunk.length === CHUNK_LENGTH_CAP) {
		          currentChunk = [];
		          computedPropsChunks.push(currentChunk);
		        }
		        currentChunk.push(_prop);
		      }
		      for (var _i = 0, _computedPropsChunks = computedPropsChunks; _i < _computedPropsChunks.length; _i++) {
		        var chunk = _computedPropsChunks[_i];
		        var single = computedPropsChunks.length === 1;
		        var node = single ? info.initPropExpression : cloneNode$j(objId);
		        for (var _iterator3 = _createForOfIteratorHelperLoose(chunk), _step3; !(_step3 = _iterator3()).done;) {
		          var prop = _step3.value;
		          if (isObjectMethod$1(prop) && (prop.kind === "get" || prop.kind === "set")) {
		            node = buildDefineAccessor(info.state, node, prop);
		          } else {
		            node = callExpression$d(state.addHelper("defineProperty"), [node, toComputedKey$2(prop), getValue(prop)]);
		          }
		        }
		        if (single) return node;
		        body.push(expressionStatement$a(node));
		      }
		    }
		    return {
		      name: "transform-computed-properties",
		      visitor: {
		        ObjectExpression: {
		          exit: function exit(path, state) {
		            var node = path.node,
		              parent = path.parent,
		              scope = path.scope;
		            var hasComputed = false;
		            for (var _iterator4 = _createForOfIteratorHelperLoose(node.properties), _step4; !(_step4 = _iterator4()).done;) {
		              var prop = _step4.value;
		              hasComputed = prop.computed === true;
		              if (hasComputed) break;
		            }
		            if (!hasComputed) return;
		            var initProps = [];
		            var computedProps = [];
		            var foundComputed = false;
		            for (var _iterator5 = _createForOfIteratorHelperLoose(node.properties), _step5; !(_step5 = _iterator5()).done;) {
		              var _prop2 = _step5.value;
		              if (isSpreadElement$1(_prop2)) {
		                continue;
		              }
		              if (_prop2.computed) {
		                foundComputed = true;
		              }
		              if (foundComputed) {
		                computedProps.push(_prop2);
		              } else {
		                initProps.push(_prop2);
		              }
		            }
		            var objId = scope.generateUidIdentifierBasedOnNode(parent);
		            var initPropExpression = objectExpression$3(initProps);
		            var body = [];
		            body.push(variableDeclaration$8("var", [variableDeclarator$8(objId, initPropExpression)]));
		            var single = pushComputedProps({
		              scope: scope,
		              objId: objId,
		              body: body,
		              computedProps: computedProps,
		              initPropExpression: initPropExpression,
		              state: state
		            });
		            if (single) {
		              path.replaceWith(single);
		            } else {
		              if (setComputedProperties) {
		                body.push(expressionStatement$a(cloneNode$j(objId)));
		              }
		              path.replaceWithMultiple(body);
		            }
		          }
		        }
		      }
		    };
		  });

		  var _transformDotallRegex = declare(function (api) {
		    api.assertVersion("*");
		    return createRegExpFeaturePlugin({
		      name: "transform-dotall-regex",
		      feature: "dotAllFlag"
		    });
		  });

		  function getName(key) {
		    if (isIdentifier$i(key)) {
		      return key.name;
		    }
		    return key.value.toString();
		  }
		  var _transformDuplicateKeys = declare(function (api) {
		    api.assertVersion("*");
		    return {
		      name: "transform-duplicate-keys",
		      visitor: {
		        ObjectExpression: function ObjectExpression(path) {
		          var node = path.node;
		          var plainProps = node.properties.filter(function (prop) {
		            return !isSpreadElement$1(prop) && !prop.computed;
		          });
		          var alreadySeenData = Object.create(null);
		          var alreadySeenGetters = Object.create(null);
		          var alreadySeenSetters = Object.create(null);
		          for (var _iterator = _createForOfIteratorHelperLoose(plainProps), _step; !(_step = _iterator()).done;) {
		            var prop = _step.value;
		            var name = getName(prop.key);
		            var isDuplicate = false;
		            switch (prop.kind) {
		              case "get":
		                if (alreadySeenData[name] || alreadySeenGetters[name]) {
		                  isDuplicate = true;
		                }
		                alreadySeenGetters[name] = true;
		                break;
		              case "set":
		                if (alreadySeenData[name] || alreadySeenSetters[name]) {
		                  isDuplicate = true;
		                }
		                alreadySeenSetters[name] = true;
		                break;
		              default:
		                if (alreadySeenData[name] || alreadySeenGetters[name] || alreadySeenSetters[name]) {
		                  isDuplicate = true;
		                }
		                alreadySeenData[name] = true;
		            }
		            if (isDuplicate) {
		              prop.computed = true;
		              prop.key = stringLiteral$8(name);
		            }
		          }
		        }
		      }
		    };
		  });

		  var assignmentExpression$1 = assignmentExpression$d,
		    cloneNode = cloneNode$j,
		    isIdentifier$1 = isIdentifier$i,
		    isLiteral = isLiteral$6,
		    isMemberExpression = isMemberExpression$9,
		    isPrivateName = isPrivateName$3,
		    isPureish = isPureish$2,
		    isSuper = isSuper$3,
		    memberExpression$1 = memberExpression$c,
		    toComputedKey = toComputedKey$2;
		  function getObjRef(node, nodes, scope) {
		    var ref;
		    if (isIdentifier$1(node)) {
		      if (scope.hasBinding(node.name)) {
		        return node;
		      } else {
		        ref = node;
		      }
		    } else if (isMemberExpression(node)) {
		      ref = node.object;
		      if (isSuper(ref) || isIdentifier$1(ref) && scope.hasBinding(ref.name)) {
		        return ref;
		      }
		    } else {
		      throw new Error("We can't explode this node type " + node["type"]);
		    }
		    var temp = scope.generateUidIdentifierBasedOnNode(ref);
		    scope.push({
		      id: temp
		    });
		    nodes.push(assignmentExpression$1("=", cloneNode(temp), cloneNode(ref)));
		    return temp;
		  }
		  function getPropRef(node, nodes, scope) {
		    var prop = node.property;
		    if (isPrivateName(prop)) {
		      throw new Error("We can't generate property ref for private name, please install `@babel/plugin-transform-class-properties`");
		    }
		    var key = toComputedKey(node, prop);
		    if (isLiteral(key) && isPureish(key)) return key;
		    var temp = scope.generateUidIdentifierBasedOnNode(prop);
		    scope.push({
		      id: temp
		    });
		    nodes.push(assignmentExpression$1("=", cloneNode(temp), cloneNode(prop)));
		    return temp;
		  }
		  function explode(node, nodes, scope) {
		    var obj = getObjRef(node, nodes, scope);
		    var ref, uid;
		    if (isIdentifier$1(node)) {
		      ref = cloneNode(node);
		      uid = obj;
		    } else {
		      var prop = getPropRef(node, nodes, scope);
		      var computed = node.computed || isLiteral(prop);
		      uid = memberExpression$1(cloneNode(obj), cloneNode(prop), computed);
		      ref = memberExpression$1(cloneNode(obj), cloneNode(prop), computed);
		    }
		    return {
		      uid: uid,
		      ref: ref
		    };
		  }

		  var assignmentExpression = assignmentExpression$d,
		    sequenceExpression = sequenceExpression$8;
		  function build (opts) {
		    var build = opts.build,
		      operator = opts.operator;
		    var visitor = {
		      AssignmentExpression: function (_AssignmentExpression) {
		        function AssignmentExpression(_x) {
		          return _AssignmentExpression.apply(this, arguments);
		        }
		        AssignmentExpression.toString = function () {
		          return _AssignmentExpression.toString();
		        };
		        return AssignmentExpression;
		      }(function (path) {
		        var node = path.node,
		          scope = path.scope;
		        if (node.operator !== operator + "=") return;
		        var nodes = [];
		        var exploded = explode(node.left, nodes, scope);
		        nodes.push(assignmentExpression("=", exploded.ref, build(exploded.uid, node.right)));
		        path.replaceWith(sequenceExpression(nodes));
		      }),
		      BinaryExpression: function BinaryExpression(path) {
		        var node = path.node;
		        if (node.operator === operator) {
		          path.replaceWith(build(node.left, node.right));
		        }
		      }
		    };
		    return visitor;
		  }

		  var transformExponentialOperator = declare(function (api) {
		    api.assertVersion("*");
		    return {
		      name: "transform-exponentiation-operator",
		      visitor: build({
		        operator: "**",
		        build: function build(left, right) {
		          return callExpression$d(memberExpression$c(identifier$j("Math"), identifier$j("pow")), [left, right]);
		        }
		      })
		    };
		  });

		  var transformFlowComments = declare(function (api) {
		    api.assertVersion("*");
		    function commentFromString(comment) {
		      return typeof comment === "string" ? {
		        type: "CommentBlock",
		        value: comment
		      } : comment;
		    }
		    function attachComment(_ref) {
		      var _toPath;
		      var ofPath = _ref.ofPath,
		        toPath = _ref.toPath,
		        _ref$where = _ref.where,
		        where = _ref$where === void 0 ? "trailing" : _ref$where,
		        _ref$optional = _ref.optional,
		        optional = _ref$optional === void 0 ? false : _ref$optional,
		        _ref$comments = _ref.comments,
		        comments = _ref$comments === void 0 ? generateComment(ofPath, optional) : _ref$comments,
		        _ref$keepType = _ref.keepType,
		        keepType = _ref$keepType === void 0 ? false : _ref$keepType;
		      if (!((_toPath = toPath) != null && _toPath.node)) {
		        toPath = ofPath.getPrevSibling();
		        where = "trailing";
		      }
		      if (!toPath.node) {
		        toPath = ofPath.getNextSibling();
		        where = "leading";
		      }
		      if (!toPath.node) {
		        toPath = ofPath.parentPath;
		        where = "inner";
		      }
		      if (!Array.isArray(comments)) {
		        comments = [comments];
		      }
		      var newComments = comments.map(commentFromString);
		      if (!keepType && ofPath != null && ofPath.node) {
		        var node = ofPath.node;
		        var parent = ofPath.parentPath;
		        var prev = ofPath.getPrevSibling();
		        var next = ofPath.getNextSibling();
		        var isSingleChild = !(prev.node || next.node);
		        var leading = node.leadingComments;
		        var trailing = node.trailingComments;
		        if (isSingleChild && leading) {
		          parent.addComments("inner", leading);
		        }
		        toPath.addComments(where, newComments);
		        ofPath.remove();
		        if (isSingleChild && trailing) {
		          parent.addComments("inner", trailing);
		        }
		      } else {
		        toPath.addComments(where, newComments);
		      }
		    }
		    function wrapInFlowComment(path) {
		      attachComment({
		        ofPath: path,
		        comments: generateComment(path, path.parent.optional)
		      });
		    }
		    function generateComment(path, optional) {
		      var comment = path.getSource().replace(/\*-\//g, "*-ESCAPED/").replace(/\*\//g, "*-/");
		      if (optional) comment = "?" + comment;
		      if (comment[0] !== ":") comment = ":: " + comment;
		      return comment;
		    }
		    function isTypeImport(importKind) {
		      return importKind === "type" || importKind === "typeof";
		    }
		    return {
		      name: "transform-flow-comments",
		      inherits: syntaxFlow,
		      visitor: {
		        TypeCastExpression: function TypeCastExpression(path) {
		          var node = path.node;
		          attachComment({
		            ofPath: path.get("typeAnnotation"),
		            toPath: path.get("expression"),
		            keepType: true
		          });
		          path.replaceWith(parenthesizedExpression(node.expression));
		        },
		        Identifier: function Identifier(path) {
		          if (path.parentPath.isFlow()) return;
		          var node = path.node;
		          if (node.typeAnnotation) {
		            attachComment({
		              ofPath: path.get("typeAnnotation"),
		              toPath: path,
		              optional: node.optional || node.typeAnnotation.optional
		            });
		            if (node.optional) {
		              node.optional = false;
		            }
		          } else if (node.optional) {
		            attachComment({
		              toPath: path,
		              comments: ":: ?"
		            });
		            node.optional = false;
		          }
		        },
		        AssignmentPattern: {
		          exit: function exit(_ref2) {
		            var node = _ref2.node;
		            var left = node.left;
		            if (left.optional) {
		              left.optional = false;
		            }
		          }
		        },
		        Function: function Function(path) {
		          if (path.isDeclareFunction()) return;
		          var node = path.node;
		          if (node.typeParameters) {
		            attachComment({
		              ofPath: path.get("typeParameters"),
		              toPath: path.get("id"),
		              optional: node.typeParameters.optional
		            });
		          }
		          if (node.returnType) {
		            attachComment({
		              ofPath: path.get("returnType"),
		              toPath: path.get("body"),
		              where: "leading",
		              optional: node.returnType.typeAnnotation.optional
		            });
		          }
		        },
		        ClassProperty: function ClassProperty(path) {
		          var node = path.node;
		          if (!node.value) {
		            wrapInFlowComment(path);
		          } else if (node.typeAnnotation) {
		            attachComment({
		              ofPath: path.get("typeAnnotation"),
		              toPath: path.get("key"),
		              optional: node.typeAnnotation.optional
		            });
		          }
		        },
		        ExportNamedDeclaration: function ExportNamedDeclaration(path) {
		          var node = path.node;
		          if (node.exportKind !== "type" && !isFlow$1(node.declaration)) {
		            return;
		          }
		          wrapInFlowComment(path);
		        },
		        ImportDeclaration: function ImportDeclaration(path) {
		          var node = path.node;
		          if (isTypeImport(node.importKind)) {
		            wrapInFlowComment(path);
		            return;
		          }
		          var typeSpecifiers = node.specifiers.filter(function (specifier) {
		            return specifier.type === "ImportSpecifier" && isTypeImport(specifier.importKind);
		          });
		          var nonTypeSpecifiers = node.specifiers.filter(function (specifier) {
		            return specifier.type !== "ImportSpecifier" || !isTypeImport(specifier.importKind);
		          });
		          node.specifiers = nonTypeSpecifiers;
		          if (typeSpecifiers.length > 0) {
		            var typeImportNode = cloneNode$j(node);
		            typeImportNode.specifiers = typeSpecifiers;
		            var comment = ":: " + generate$1(typeImportNode).code;
		            if (nonTypeSpecifiers.length > 0) {
		              attachComment({
		                toPath: path,
		                comments: comment
		              });
		            } else {
		              attachComment({
		                ofPath: path,
		                comments: comment
		              });
		            }
		          }
		        },
		        ObjectPattern: function ObjectPattern(path) {
		          var node = path.node;
		          if (node.typeAnnotation) {
		            attachComment({
		              ofPath: path.get("typeAnnotation"),
		              toPath: path,
		              optional: node.optional || node.typeAnnotation.optional
		            });
		          }
		        },
		        Flow: function (_Flow) {
		          function Flow(_x) {
		            return _Flow.apply(this, arguments);
		          }
		          Flow.toString = function () {
		            return _Flow.toString();
		          };
		          return Flow;
		        }(function (path) {
		          wrapInFlowComment(path);
		        }),
		        Class: function Class(path) {
		          var node = path.node;
		          var comments = [];
		          if (node.typeParameters) {
		            var typeParameters = path.get("typeParameters");
		            comments.push(generateComment(typeParameters, node.typeParameters.optional));
		            var trailingComments = node.typeParameters.trailingComments;
		            if (trailingComments) {
		              var _comments;
		              (_comments = comments).push.apply(_comments, _toConsumableArray(trailingComments));
		            }
		            typeParameters.remove();
		          }
		          if (node.superClass) {
		            if (comments.length > 0) {
		              attachComment({
		                toPath: path.get("id"),
		                comments: comments
		              });
		              comments = [];
		            }
		            if (node.superTypeParameters) {
		              var superTypeParameters = path.get("superTypeParameters");
		              comments.push(generateComment(superTypeParameters, superTypeParameters.node.optional));
		              superTypeParameters.remove();
		            }
		          }
		          if (node["implements"]) {
		            var impls = path.get("implements");
		            var comment = "implements " + impls.map(function (impl) {
		              return generateComment(impl).replace(/^:: /, "");
		            }).join(", ");
		            delete node["implements"];
		            if (comments.length === 1) {
		              comments[0] += " " + comment;
		            } else {
		              comments.push(":: " + comment);
		            }
		          }
		          if (comments.length > 0) {
		            attachComment({
		              toPath: path.get("body"),
		              where: "leading",
		              comments: comments
		            });
		          }
		        }
		      }
		    };
		  });

		  var transformFlowStripTypes = declare(function (api, opts) {
		    api.assertVersion("*");
		    var FLOW_DIRECTIVE = /(@flow(\s+(strict(-local)?|weak))?|@noflow)/;
		    var skipStrip = false;
		    var _opts$requireDirectiv = opts.requireDirective,
		      requireDirective = _opts$requireDirectiv === void 0 ? false : _opts$requireDirectiv;
		    {
		      var _opts$allowDeclareFie = opts.allowDeclareFields,
		        allowDeclareFields = _opts$allowDeclareFie === void 0 ? false : _opts$allowDeclareFie;
		    }
		    return {
		      name: "transform-flow-strip-types",
		      inherits: syntaxFlow,
		      visitor: {
		        Program: function Program(path, _ref) {
		          var comments = _ref.file.ast.comments;
		          skipStrip = false;
		          var directiveFound = false;
		          if (comments) {
		            for (var _iterator = _createForOfIteratorHelperLoose(comments), _step; !(_step = _iterator()).done;) {
		              var comment = _step.value;
		              if (FLOW_DIRECTIVE.test(comment.value)) {
		                directiveFound = true;
		                comment.value = comment.value.replace(FLOW_DIRECTIVE, "");
		                if (!comment.value.replace(/\*/g, "").trim()) {
		                  comment.ignore = true;
		                }
		              }
		            }
		          }
		          if (!directiveFound && requireDirective) {
		            skipStrip = true;
		          }
		        },
		        ImportDeclaration: function ImportDeclaration(path) {
		          if (skipStrip) return;
		          if (!path.node.specifiers.length) return;
		          var typeCount = 0;
		          path.node.specifiers.forEach(function (_ref2) {
		            var importKind = _ref2.importKind;
		            if (importKind === "type" || importKind === "typeof") {
		              typeCount++;
		            }
		          });
		          if (typeCount === path.node.specifiers.length) {
		            path.remove();
		          }
		        },
		        Flow: function (_Flow) {
		          function Flow(_x) {
		            return _Flow.apply(this, arguments);
		          }
		          Flow.toString = function () {
		            return _Flow.toString();
		          };
		          return Flow;
		        }(function (path) {
		          if (skipStrip) {
		            throw path.buildCodeFrameError("A @flow directive is required when using Flow annotations with " + "the `requireDirective` option.");
		          }
		          path.remove();
		        }),
		        ClassPrivateProperty: function ClassPrivateProperty(path) {
		          if (skipStrip) return;
		          path.node.typeAnnotation = null;
		        },
		        Class: function Class(path) {
		          if (skipStrip) return;
		          path.node["implements"] = null;
		          path.get("body.body").forEach(function (child) {
		            if (child.isClassProperty()) {
		              var node = child.node;
		              {
		                if (!allowDeclareFields && node.declare) {
		                  throw child.buildCodeFrameError("The 'declare' modifier is only allowed when the " + "'allowDeclareFields' option of " + "@babel/plugin-transform-flow-strip-types or " + "@babel/preset-flow is enabled.");
		                }
		              }
		              if (node.declare) {
		                child.remove();
		              } else {
		                {
		                  if (!allowDeclareFields && !node.value && !node.decorators) {
		                    child.remove();
		                    return;
		                  }
		                }
		                node.variance = null;
		                node.typeAnnotation = null;
		              }
		            }
		          });
		        },
		        AssignmentPattern: function AssignmentPattern(_ref3) {
		          var node = _ref3.node;
		          if (skipStrip) return;
		          if (node.left.optional) {
		            node.left.optional = false;
		          }
		        },
		        Function: function Function(_ref4) {
		          var node = _ref4.node;
		          if (skipStrip) return;
		          if (node.params.length > 0 && node.params[0].type === "Identifier" && node.params[0].name === "this") {
		            node.params.shift();
		          }
		          for (var i = 0; i < node.params.length; i++) {
		            var param = node.params[i];
		            if (param.type === "AssignmentPattern") {
		              param = param.left;
		            }
		            if (param.optional) {
		              param.optional = false;
		            }
		          }
		          if (!isMethod$1(node)) {
		            node.predicate = null;
		          }
		        },
		        TypeCastExpression: function TypeCastExpression(path) {
		          if (skipStrip) return;
		          var node = path.node;
		          do {
		            node = node.expression;
		          } while (isTypeCastExpression$1(node));
		          path.replaceWith(node);
		        },
		        CallExpression: function CallExpression(_ref5) {
		          var node = _ref5.node;
		          if (skipStrip) return;
		          node.typeArguments = null;
		        },
		        OptionalCallExpression: function OptionalCallExpression(_ref6) {
		          var node = _ref6.node;
		          if (skipStrip) return;
		          node.typeArguments = null;
		        },
		        NewExpression: function NewExpression(_ref7) {
		          var node = _ref7.node;
		          if (skipStrip) return;
		          node.typeArguments = null;
		        }
		      }
		    };
		  });

		  function transformWithoutHelper(loose, path, state) {
		    var _block$body;
		    var pushComputedProps = loose ? pushComputedPropsLoose : pushComputedPropsSpec;
		    var node = path.node;
		    var build = pushComputedProps(path, state);
		    var declar = build.declar;
		    var loop = build.loop;
		    var block = loop.body;
		    path.ensureBlock();
		    if (declar) {
		      block.body.push(declar);
		    }
		    (_block$body = block.body).push.apply(_block$body, _toConsumableArray(node.body.body));
		    inherits$3(loop, node);
		    inherits$3(loop.body, node.body);
		    if (build.replaceParent) {
		      path.parentPath.replaceWithMultiple(build.node);
		      path.remove();
		    } else {
		      path.replaceWithMultiple(build.node);
		    }
		  }
		  var buildForOfLoose = template$1.statement("\n  for (var LOOP_OBJECT = OBJECT,\n          IS_ARRAY = Array.isArray(LOOP_OBJECT),\n          INDEX = 0,\n          LOOP_OBJECT = IS_ARRAY ? LOOP_OBJECT : LOOP_OBJECT[Symbol.iterator]();;) {\n    INTERMEDIATE;\n    if (IS_ARRAY) {\n      if (INDEX >= LOOP_OBJECT.length) break;\n      ID = LOOP_OBJECT[INDEX++];\n    } else {\n      INDEX = LOOP_OBJECT.next();\n      if (INDEX.done) break;\n      ID = INDEX.value;\n    }\n  }\n");
		  var buildForOf = template$1.statements("\n  var ITERATOR_COMPLETION = true;\n  var ITERATOR_HAD_ERROR_KEY = false;\n  var ITERATOR_ERROR_KEY = undefined;\n  try {\n    for (\n      var ITERATOR_KEY = OBJECT[Symbol.iterator](), STEP_KEY;\n      !(ITERATOR_COMPLETION = (STEP_KEY = ITERATOR_KEY.next()).done);\n      ITERATOR_COMPLETION = true\n    ) {}\n  } catch (err) {\n    ITERATOR_HAD_ERROR_KEY = true;\n    ITERATOR_ERROR_KEY = err;\n  } finally {\n    try {\n      if (!ITERATOR_COMPLETION && ITERATOR_KEY.return != null) {\n        ITERATOR_KEY.return();\n      }\n    } finally {\n      if (ITERATOR_HAD_ERROR_KEY) {\n        throw ITERATOR_ERROR_KEY;\n      }\n    }\n  }\n");
		  function pushComputedPropsLoose(path, state) {
		    var node = path.node,
		      scope = path.scope,
		      parent = path.parent;
		    var left = node.left;
		    var declar, id, intermediate;
		    if (isIdentifier$i(left) || isPattern(left) || isMemberExpression$9(left)) {
		      id = left;
		      intermediate = null;
		    } else if (isVariableDeclaration$4(left)) {
		      id = scope.generateUidIdentifier("ref");
		      declar = variableDeclaration$8(left.kind, [variableDeclarator$8(left.declarations[0].id, identifier$j(id.name))]);
		      intermediate = variableDeclaration$8("var", [variableDeclarator$8(identifier$j(id.name))]);
		    } else {
		      throw state.buildCodeFrameError(left, "Unknown node type " + left.type + " in ForStatement");
		    }
		    var iteratorKey = scope.generateUidIdentifier("iterator");
		    var isArrayKey = scope.generateUidIdentifier("isArray");
		    var loop = buildForOfLoose({
		      LOOP_OBJECT: iteratorKey,
		      IS_ARRAY: isArrayKey,
		      OBJECT: node.right,
		      INDEX: scope.generateUidIdentifier("i"),
		      ID: id,
		      INTERMEDIATE: intermediate
		    });
		    var isLabeledParent = isLabeledStatement(parent);
		    var labeled;
		    if (isLabeledParent) {
		      labeled = labeledStatement(parent.label, loop);
		    }
		    return {
		      replaceParent: isLabeledParent,
		      declar: declar,
		      node: labeled || loop,
		      loop: loop
		    };
		  }
		  function pushComputedPropsSpec(path, state) {
		    var node = path.node,
		      scope = path.scope,
		      parent = path.parent;
		    var left = node.left;
		    var declar;
		    var stepKey = scope.generateUid("step");
		    var stepValue = memberExpression$c(identifier$j(stepKey), identifier$j("value"));
		    if (isIdentifier$i(left) || isPattern(left) || isMemberExpression$9(left)) {
		      declar = expressionStatement$a(assignmentExpression$d("=", left, stepValue));
		    } else if (isVariableDeclaration$4(left)) {
		      declar = variableDeclaration$8(left.kind, [variableDeclarator$8(left.declarations[0].id, stepValue)]);
		    } else {
		      throw state.buildCodeFrameError(left, "Unknown node type " + left.type + " in ForStatement");
		    }
		    var template = buildForOf({
		      ITERATOR_HAD_ERROR_KEY: scope.generateUidIdentifier("didIteratorError"),
		      ITERATOR_COMPLETION: scope.generateUidIdentifier("iteratorNormalCompletion"),
		      ITERATOR_ERROR_KEY: scope.generateUidIdentifier("iteratorError"),
		      ITERATOR_KEY: scope.generateUidIdentifier("iterator"),
		      STEP_KEY: identifier$j(stepKey),
		      OBJECT: node.right
		    });
		    var isLabeledParent = isLabeledStatement(parent);
		    var tryBody = template[3].block.body;
		    var loop = tryBody[0];
		    if (isLabeledParent) {
		      tryBody[0] = labeledStatement(parent.label, loop);
		    }
		    return {
		      replaceParent: isLabeledParent,
		      declar: declar,
		      loop: loop,
		      node: template
		    };
		  }

		  var _templateObject$i, _templateObject2$b, _templateObject3$6;
		  function buildLoopBody(path, declar, newBody) {
		    var block;
		    var bodyPath = path.get("body");
		    var body = newBody != null ? newBody : bodyPath.node;
		    if (isBlockStatement$3(body) && Object.keys(path.getBindingIdentifiers()).some(function (id) {
		      return bodyPath.scope.hasOwnBinding(id);
		    })) {
		      block = blockStatement$6([declar, body]);
		    } else {
		      block = toBlock(body);
		      block.body.unshift(declar);
		    }
		    return block;
		  }
		  var _transformForOf = declare(function (api, options) {
		    var _options$assumeArray, _options$allowArrayLi, _api$assumption;
		    api.assertVersion("*");
		    {
		      var assumeArray = options.assumeArray,
		        allowArrayLike = options.allowArrayLike,
		        loose = options.loose;
		      if (loose === true && assumeArray === true) {
		        throw new Error("The loose and assumeArray options cannot be used together in @babel/plugin-transform-for-of");
		      }
		      if (assumeArray === true && allowArrayLike === true) {
		        throw new Error("The assumeArray and allowArrayLike options cannot be used together in @babel/plugin-transform-for-of");
		      }
		      {
		        if (allowArrayLike && /^7\.\d\./.test(api.version)) {
		          throw new Error("The allowArrayLike is only supported when using @babel/core@^7.10.0");
		        }
		      }
		    }
		    var iterableIsArray = (_options$assumeArray = options.assumeArray) != null ? _options$assumeArray : !options.loose && api.assumption("iterableIsArray");
		    var arrayLikeIsIterable = (_options$allowArrayLi = options.allowArrayLike) != null ? _options$allowArrayLi : api.assumption("arrayLikeIsIterable");
		    var skipIteratorClosing = (_api$assumption = api.assumption("skipForOfIteratorClosing")) != null ? _api$assumption : options.loose;
		    if (iterableIsArray && arrayLikeIsIterable) {
		      throw new Error("The \"iterableIsArray\" and \"arrayLikeIsIterable\" assumptions are not compatible.");
		    }
		    if (iterableIsArray) {
		      return {
		        name: "transform-for-of",
		        visitor: {
		          ForOfStatement: function ForOfStatement(path) {
		            var scope = path.scope;
		            var _path$node = path.node,
		              left = _path$node.left,
		              isAwait = _path$node["await"];
		            if (isAwait) {
		              return;
		            }
		            var right = skipTransparentExprWrapperNodes(path.node.right);
		            var i = scope.generateUidIdentifier("i");
		            var array = scope.maybeGenerateMemoised(right, true);
		            if (!array && isIdentifier$i(right) && path.get("body").scope.hasOwnBinding(right.name)) {
		              array = scope.generateUidIdentifier("arr");
		            }
		            var inits = [variableDeclarator$8(i, numericLiteral$8(0))];
		            if (array) {
		              inits.push(variableDeclarator$8(array, right));
		            } else {
		              array = right;
		            }
		            var item = memberExpression$c(cloneNode$j(array), cloneNode$j(i), true);
		            var assignment;
		            if (isVariableDeclaration$4(left)) {
		              assignment = left;
		              assignment.declarations[0].init = item;
		            } else {
		              assignment = expressionStatement$a(assignmentExpression$d("=", left, item));
		            }
		            path.replaceWith(forStatement(variableDeclaration$8("let", inits), binaryExpression$5("<", cloneNode$j(i), memberExpression$c(cloneNode$j(array), identifier$j("length"))), updateExpression$1("++", cloneNode$j(i)), buildLoopBody(path, assignment)));
		          }
		        }
		      };
		    }
		    var buildForOfArray = template$1(_templateObject$i || (_templateObject$i = _taggedTemplateLiteralLoose(["\n    for (var KEY = 0, NAME = ARR; KEY < NAME.length; KEY++) BODY;\n  "])));
		    var buildForOfNoIteratorClosing = template$1.statements(_templateObject2$b || (_templateObject2$b = _taggedTemplateLiteralLoose(["\n    for (var ITERATOR_HELPER = CREATE_ITERATOR_HELPER(OBJECT, ARRAY_LIKE_IS_ITERABLE), STEP_KEY;\n        !(STEP_KEY = ITERATOR_HELPER()).done;) BODY;\n  "])));
		    var buildForOf = template$1.statements(_templateObject3$6 || (_templateObject3$6 = _taggedTemplateLiteralLoose(["\n    var ITERATOR_HELPER = CREATE_ITERATOR_HELPER(OBJECT, ARRAY_LIKE_IS_ITERABLE), STEP_KEY;\n    try {\n      for (ITERATOR_HELPER.s(); !(STEP_KEY = ITERATOR_HELPER.n()).done;) BODY;\n    } catch (err) {\n      ITERATOR_HELPER.e(err);\n    } finally {\n      ITERATOR_HELPER.f();\n    }\n  "])));
		    var builder = skipIteratorClosing ? {
		      build: buildForOfNoIteratorClosing,
		      helper: "createForOfIteratorHelperLoose",
		      getContainer: function getContainer(nodes) {
		        return nodes;
		      }
		    } : {
		      build: buildForOf,
		      helper: "createForOfIteratorHelper",
		      getContainer: function getContainer(nodes) {
		        return nodes[1].block.body;
		      }
		    };
		    function _ForOfStatementArray(path) {
		      var node = path.node,
		        scope = path.scope;
		      var right = scope.generateUidIdentifierBasedOnNode(node.right, "arr");
		      var iterationKey = scope.generateUidIdentifier("i");
		      var loop = buildForOfArray({
		        BODY: node.body,
		        KEY: iterationKey,
		        NAME: right,
		        ARR: node.right
		      });
		      inherits$3(loop, node);
		      var iterationValue = memberExpression$c(cloneNode$j(right), cloneNode$j(iterationKey), true);
		      var declar;
		      var left = node.left;
		      if (isVariableDeclaration$4(left)) {
		        left.declarations[0].init = iterationValue;
		        declar = left;
		      } else {
		        declar = expressionStatement$a(assignmentExpression$d("=", left, iterationValue));
		      }
		      loop.body = buildLoopBody(path, declar, loop.body);
		      return loop;
		    }
		    return {
		      name: "transform-for-of",
		      visitor: {
		        ForOfStatement: function ForOfStatement(path, state) {
		          var right = path.get("right");
		          if (right.isArrayExpression() || right.isGenericType("Array") || isArrayTypeAnnotation$2(right.getTypeAnnotation())) {
		            path.replaceWith(_ForOfStatementArray(path));
		            return;
		          }
		          {
		            if (!state.availableHelper(builder.helper)) {
		              transformWithoutHelper(skipIteratorClosing, path, state);
		              return;
		            }
		          }
		          var node = path.node,
		            parent = path.parent,
		            scope = path.scope;
		          var left = node.left;
		          var declar;
		          var stepKey = scope.generateUid("step");
		          var stepValue = memberExpression$c(identifier$j(stepKey), identifier$j("value"));
		          if (isVariableDeclaration$4(left)) {
		            declar = variableDeclaration$8(left.kind, [variableDeclarator$8(left.declarations[0].id, stepValue)]);
		          } else {
		            declar = expressionStatement$a(assignmentExpression$d("=", left, stepValue));
		          }
		          var nodes = builder.build({
		            CREATE_ITERATOR_HELPER: state.addHelper(builder.helper),
		            ITERATOR_HELPER: scope.generateUidIdentifier("iterator"),
		            ARRAY_LIKE_IS_ITERABLE: arrayLikeIsIterable ? booleanLiteral$4(true) : null,
		            STEP_KEY: identifier$j(stepKey),
		            OBJECT: node.right,
		            BODY: buildLoopBody(path, declar)
		          });
		          var container = builder.getContainer(nodes);
		          inherits$3(container[0], node);
		          inherits$3(container[0].body, node.body);
		          if (isLabeledStatement(parent)) {
		            container[0] = labeledStatement(parent.label, container[0]);
		            path.parentPath.replaceWithMultiple(nodes);
		            path.skip();
		          } else {
		            path.replaceWithMultiple(nodes);
		          }
		        }
		      }
		    };
		  });

		  var _transformFunctionName = declare(function (api) {
		    api.assertVersion("*");
		    var supportUnicodeId = !isRequired("transform-unicode-escapes", api.targets());
		    return {
		      name: "transform-function-name",
		      visitor: {
		        FunctionExpression: {
		          exit: function exit(path) {
		            if (path.key !== "value" && !path.parentPath.isObjectProperty()) {
		              var replacement = nameFunction(path);
		              if (replacement) path.replaceWith(replacement);
		            }
		          }
		        },
		        ObjectProperty: function ObjectProperty(path) {
		          var value = path.get("value");
		          if (value.isFunction()) {
		            var newNode = nameFunction(value, false, supportUnicodeId);
		            if (newNode) value.replaceWith(newNode);
		          }
		        }
		      }
		    };
		  });

		  var transformInstanceof = declare(function (api) {
		    api.assertVersion("*");
		    return {
		      name: "transform-instanceof",
		      visitor: {
		        BinaryExpression: function BinaryExpression(path) {
		          var node = path.node;
		          if (node.operator === "instanceof") {
		            var helper = this.addHelper("instanceof");
		            var isUnderHelper = path.findParent(function (path) {
		              return path.isVariableDeclarator() && path.node.id === helper || path.isFunctionDeclaration() && path.node.id && path.node.id.name === helper.name;
		            });
		            if (isUnderHelper) {
		              return;
		            } else {
		              path.replaceWith(callExpression$d(helper, [node.left, node.right]));
		            }
		          }
		        }
		      }
		    };
		  });

		  var transformJscript = declare(function (api) {
		    api.assertVersion("*");
		    return {
		      name: "transform-jscript",
		      visitor: {
		        FunctionExpression: {
		          exit: function exit(path) {
		            var node = path.node;
		            if (!node.id) return;
		            path.replaceWith(callExpression$d(functionExpression$2(null, [], blockStatement$6([toStatement(node), returnStatement$3(cloneNode$j(node.id))])), []));
		          }
		        }
		      }
		    };
		  });

		  var _transformLiterals = declare(function (api) {
		    api.assertVersion("*");
		    return {
		      name: "transform-literals",
		      visitor: {
		        NumericLiteral: function NumericLiteral(_ref) {
		          var node = _ref.node;
		          if (node.extra && /^0[ob]/i.test(node.extra.raw)) {
		            node.extra = undefined;
		          }
		        },
		        StringLiteral: function StringLiteral(_ref2) {
		          var node = _ref2.node;
		          if (node.extra && /\\[u]/gi.test(node.extra.raw)) {
		            node.extra = undefined;
		          }
		        }
		      }
		    };
		  });

		  var _transformMemberExpressionLiterals = declare(function (api) {
		    api.assertVersion("*");
		    return {
		      name: "transform-member-expression-literals",
		      visitor: {
		        MemberExpression: {
		          exit: function exit(_ref) {
		            var node = _ref.node;
		            var prop = node.property;
		            if (!node.computed && isIdentifier$i(prop) && !isValidES3Identifier(prop.name)) {
		              node.property = stringLiteral$8(prop.name);
		              node.computed = true;
		            }
		          }
		        }
		      }
		    };
		  });

		  var _templateObject$h;
		  var buildWrapper$1 = template$1.statement("\n  define(MODULE_NAME, AMD_ARGUMENTS, function(IMPORT_NAMES) {\n  })\n");
		  var buildAnonymousWrapper = template$1.statement("\n  define([\"require\"], function(REQUIRE) {\n  })\n");
		  function injectWrapper(path, wrapper) {
		    var _path$node = path.node,
		      body = _path$node.body,
		      directives = _path$node.directives;
		    path.node.directives = [];
		    path.node.body = [];
		    var amdFactoryCall = path.pushContainer("body", wrapper)[0].get("expression");
		    var amdFactoryCallArgs = amdFactoryCall.get("arguments");
		    var amdFactory = amdFactoryCallArgs[amdFactoryCallArgs.length - 1].get("body");
		    amdFactory.pushContainer("directives", directives);
		    amdFactory.pushContainer("body", body);
		  }
		  var _transformModulesAmd = declare(function (api, options) {
		    var _api$assumption, _api$assumption2, _visitor;
		    api.assertVersion("*");
		    var allowTopLevelThis = options.allowTopLevelThis,
		      strict = options.strict,
		      strictMode = options.strictMode,
		      importInterop = options.importInterop,
		      noInterop = options.noInterop;
		    var constantReexports = (_api$assumption = api.assumption("constantReexports")) != null ? _api$assumption : options.loose;
		    var enumerableModuleMeta = (_api$assumption2 = api.assumption("enumerableModuleMeta")) != null ? _api$assumption2 : options.loose;
		    return {
		      name: "transform-modules-amd",
		      pre: function pre() {
		        this.file.set("@babel/plugin-transform-modules-*", "amd");
		      },
		      visitor: (_visitor = {}, _visitor["CallExpression" + (api.types.importExpression ? "|ImportExpression" : "")] = function (path, state) {
		        if (!this.file.has("@babel/plugin-proposal-dynamic-import")) return;
		        if (path.isCallExpression() && !path.get("callee").isImport()) return;
		        var requireId = state.requireId,
		          resolveId = state.resolveId,
		          rejectId = state.rejectId;
		        if (!requireId) {
		          requireId = path.scope.generateUidIdentifier("require");
		          state.requireId = requireId;
		        }
		        if (!resolveId || !rejectId) {
		          resolveId = path.scope.generateUidIdentifier("resolve");
		          rejectId = path.scope.generateUidIdentifier("reject");
		          state.resolveId = resolveId;
		          state.rejectId = rejectId;
		        }
		        var result = identifier$j("imported");
		        if (!noInterop) {
		          result = wrapInterop(this.file.path, result, "namespace");
		        }
		        path.replaceWith(buildDynamicImport(path.node, false, false, function (specifier) {
		          return template$1.expression.ast(_templateObject$h || (_templateObject$h = _taggedTemplateLiteralLoose(["\n              new Promise((", ", ", ") =>\n                ", "(\n                  [", "],\n                  imported => ", "(", "),\n                  ", "\n                )\n              )\n            "])), resolveId, rejectId, requireId, specifier, cloneNode$j(resolveId), result, cloneNode$j(rejectId));
		        }));
		      }, _visitor.Program = {
		        exit: function exit(path, _ref) {
		          var requireId = _ref.requireId;
		          if (!isModule(path)) {
		            if (requireId) {
		              injectWrapper(path, buildAnonymousWrapper({
		                REQUIRE: cloneNode$j(requireId)
		              }));
		            }
		            return;
		          }
		          var amdArgs = [];
		          var importNames = [];
		          if (requireId) {
		            amdArgs.push(stringLiteral$8("require"));
		            importNames.push(cloneNode$j(requireId));
		          }
		          var moduleName = getModuleName(this.file.opts, options);
		          if (moduleName) moduleName = stringLiteral$8(moduleName);
		          var _rewriteModuleStateme = rewriteModuleStatementsAndPrepareHeader(path, {
		              enumerableModuleMeta: enumerableModuleMeta,
		              constantReexports: constantReexports,
		              strict: strict,
		              strictMode: strictMode,
		              allowTopLevelThis: allowTopLevelThis,
		              importInterop: importInterop,
		              noInterop: noInterop,
		              filename: this.file.opts.filename
		            }),
		            meta = _rewriteModuleStateme.meta,
		            headers = _rewriteModuleStateme.headers;
		          if (hasExports(meta)) {
		            amdArgs.push(stringLiteral$8("exports"));
		            importNames.push(identifier$j(meta.exportName));
		          }
		          for (var _iterator = _createForOfIteratorHelperLoose(meta.source), _step; !(_step = _iterator()).done;) {
		            var _step$value = _slicedToArray(_step.value, 2),
		              source = _step$value[0],
		              metadata = _step$value[1];
		            amdArgs.push(stringLiteral$8(source));
		            importNames.push(identifier$j(metadata.name));
		            if (!isSideEffectImport(metadata)) {
		              var interop = wrapInterop(path, identifier$j(metadata.name), metadata.interop);
		              if (interop) {
		                var header = expressionStatement$a(assignmentExpression$d("=", identifier$j(metadata.name), interop));
		                header.loc = metadata.loc;
		                headers.push(header);
		              }
		            }
		            headers.push.apply(headers, _toConsumableArray(buildNamespaceInitStatements(meta, metadata, constantReexports)));
		          }
		          ensureStatementsHoisted(headers);
		          path.unshiftContainer("body", headers);
		          injectWrapper(path, buildWrapper$1({
		            MODULE_NAME: moduleName,
		            AMD_ARGUMENTS: arrayExpression$1(amdArgs),
		            IMPORT_NAMES: importNames
		          }));
		        }
		      }, _visitor)
		    };
		  });

		  var _templateObject$g;
		  var requireNoInterop = function requireNoInterop(source) {
		    return template$1.expression.ast(_templateObject$g || (_templateObject$g = _taggedTemplateLiteralLoose(["require(", ")"])), source);
		  };
		  var requireInterop = function requireInterop(source, file) {
		    return callExpression$d(file.addHelper("interopRequireWildcard"), [requireNoInterop(source)]);
		  };
		  function transformDynamicImport(path, noInterop, file) {
		    var buildRequire = noInterop ? requireNoInterop : requireInterop;
		    path.replaceWith(buildDynamicImport(path.node, true, false, function (specifier) {
		      return buildRequire(specifier, file);
		    }));
		  }

		  var _templateObject$f;
		  var lazyImportsHook = function lazyImportsHook(lazy) {
		    return {
		      name: "@babel/plugin-transform-modules-commonjs" + "/lazy",
		      version: "7.24.1",
		      getWrapperPayload: function getWrapperPayload(source, metadata) {
		        if (isSideEffectImport(metadata) || metadata.reexportAll) {
		          return null;
		        }
		        if (lazy === true) {
		          return /\./.test(source) ? null : "lazy/function";
		        }
		        if (Array.isArray(lazy)) {
		          return lazy.indexOf(source) === -1 ? null : "lazy/function";
		        }
		        if (typeof lazy === "function") {
		          return lazy(source) ? "lazy/function" : null;
		        }
		      },
		      buildRequireWrapper: function buildRequireWrapper(name, init, payload, referenced) {
		        if (payload === "lazy/function") {
		          if (!referenced) return false;
		          return template$1.statement.ast(_templateObject$f || (_templateObject$f = _taggedTemplateLiteralLoose(["\n        function ", "() {\n          const data = ", ";\n          ", " = function(){ return data; };\n          return data;\n        }\n      "])), name, init, name);
		        }
		      },
		      wrapReference: function wrapReference(ref, payload) {
		        if (payload === "lazy/function") return callExpression$d(ref, []);
		      }
		    };
		  };

		  var commonJSHooksKey = "@babel/plugin-transform-modules-commonjs/customWrapperPlugin";
		  function defineCommonJSHook(file, hook) {
		    var hooks = file.get(commonJSHooksKey);
		    if (!hooks) file.set(commonJSHooksKey, hooks = []);
		    hooks.push(hook);
		  }
		  function findMap(arr, cb) {
		    if (arr) {
		      for (var _iterator = _createForOfIteratorHelperLoose(arr), _step; !(_step = _iterator()).done;) {
		        var _el = _step.value;
		        var res = cb(_el);
		        if (res != null) return res;
		      }
		    }
		  }
		  function makeInvokers(file) {
		    var hooks = file.get(commonJSHooksKey);
		    return {
		      getWrapperPayload: function getWrapperPayload() {
		        for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
		          args[_key] = arguments[_key];
		        }
		        return findMap(hooks, function (hook) {
		          return hook.getWrapperPayload == null ? void 0 : hook.getWrapperPayload.apply(hook, args);
		        });
		      },
		      wrapReference: function wrapReference() {
		        for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
		          args[_key2] = arguments[_key2];
		        }
		        return findMap(hooks, function (hook) {
		          return hook.wrapReference == null ? void 0 : hook.wrapReference.apply(hook, args);
		        });
		      },
		      buildRequireWrapper: function buildRequireWrapper() {
		        for (var _len3 = arguments.length, args = new Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
		          args[_key3] = arguments[_key3];
		        }
		        return findMap(hooks, function (hook) {
		          return hook.buildRequireWrapper == null ? void 0 : hook.buildRequireWrapper.apply(hook, args);
		        });
		      }
		    };
		  }

		  var _templateObject$e, _templateObject2$a;
		  var transformModulesCommonJS = declare(function (api, options) {
		    var _api$assumption, _api$assumption2, _api$assumption3, _visitor;
		    api.assertVersion("*");
		    var _options$strictNamesp = options.strictNamespace,
		      strictNamespace = _options$strictNamesp === void 0 ? false : _options$strictNamesp,
		      _options$mjsStrictNam = options.mjsStrictNamespace,
		      mjsStrictNamespace = _options$mjsStrictNam === void 0 ? strictNamespace : _options$mjsStrictNam,
		      allowTopLevelThis = options.allowTopLevelThis,
		      strict = options.strict,
		      strictMode = options.strictMode,
		      noInterop = options.noInterop,
		      importInterop = options.importInterop,
		      _options$lazy = options.lazy,
		      lazy = _options$lazy === void 0 ? false : _options$lazy,
		      _options$allowCommonJ = options.allowCommonJSExports,
		      allowCommonJSExports = _options$allowCommonJ === void 0 ? true : _options$allowCommonJ,
		      _options$loose = options.loose,
		      loose = _options$loose === void 0 ? false : _options$loose;
		    var constantReexports = (_api$assumption = api.assumption("constantReexports")) != null ? _api$assumption : loose;
		    var enumerableModuleMeta = (_api$assumption2 = api.assumption("enumerableModuleMeta")) != null ? _api$assumption2 : loose;
		    var noIncompleteNsImportDetection = (_api$assumption3 = api.assumption("noIncompleteNsImportDetection")) != null ? _api$assumption3 : false;
		    if (typeof lazy !== "boolean" && typeof lazy !== "function" && (!Array.isArray(lazy) || !lazy.every(function (item) {
		      return typeof item === "string";
		    }))) {
		      throw new Error(".lazy must be a boolean, array of strings, or a function");
		    }
		    if (typeof strictNamespace !== "boolean") {
		      throw new Error(".strictNamespace must be a boolean, or undefined");
		    }
		    if (typeof mjsStrictNamespace !== "boolean") {
		      throw new Error(".mjsStrictNamespace must be a boolean, or undefined");
		    }
		    var getAssertion = function getAssertion(localName) {
		      return template$1.expression.ast(_templateObject$e || (_templateObject$e = _taggedTemplateLiteralLoose(["\n    (function(){\n      throw new Error(\n        \"The CommonJS '\" + \"", "\" + \"' variable is not available in ES6 modules.\" +\n        \"Consider setting setting sourceType:script or sourceType:unambiguous in your \" +\n        \"Babel config for this file.\");\n    })()\n  "])), localName);
		    };
		    var moduleExportsVisitor = {
		      ReferencedIdentifier: function ReferencedIdentifier(path) {
		        var localName = path.node.name;
		        if (localName !== "module" && localName !== "exports") return;
		        var localBinding = path.scope.getBinding(localName);
		        var rootBinding = this.scope.getBinding(localName);
		        if (rootBinding !== localBinding || path.parentPath.isObjectProperty({
		          value: path.node
		        }) && path.parentPath.parentPath.isObjectPattern() || path.parentPath.isAssignmentExpression({
		          left: path.node
		        }) || path.isAssignmentExpression({
		          left: path.node
		        })) {
		          return;
		        }
		        path.replaceWith(getAssertion(localName));
		      },
		      UpdateExpression: function UpdateExpression(path) {
		        var arg = path.get("argument");
		        if (!arg.isIdentifier()) return;
		        var localName = arg.node.name;
		        if (localName !== "module" && localName !== "exports") return;
		        var localBinding = path.scope.getBinding(localName);
		        var rootBinding = this.scope.getBinding(localName);
		        if (rootBinding !== localBinding) return;
		        path.replaceWith(assignmentExpression$d(path.node.operator[0] + "=", arg.node, getAssertion(localName)));
		      },
		      AssignmentExpression: function AssignmentExpression(path) {
		        var _this = this;
		        var left = path.get("left");
		        if (left.isIdentifier()) {
		          var localName = left.node.name;
		          if (localName !== "module" && localName !== "exports") return;
		          var localBinding = path.scope.getBinding(localName);
		          var rootBinding = this.scope.getBinding(localName);
		          if (rootBinding !== localBinding) return;
		          var right = path.get("right");
		          right.replaceWith(sequenceExpression$8([right.node, getAssertion(localName)]));
		        } else if (left.isPattern()) {
		          var ids = left.getOuterBindingIdentifiers();
		          var _localName = Object.keys(ids).filter(function (localName) {
		            if (localName !== "module" && localName !== "exports") return false;
		            return _this.scope.getBinding(localName) === path.scope.getBinding(localName);
		          })[0];
		          if (_localName) {
		            var _right = path.get("right");
		            _right.replaceWith(sequenceExpression$8([_right.node, getAssertion(_localName)]));
		          }
		        }
		      }
		    };
		    return {
		      name: "transform-modules-commonjs",
		      pre: function pre() {
		        this.file.set("@babel/plugin-transform-modules-*", "commonjs");
		        if (lazy) defineCommonJSHook(this.file, lazyImportsHook(lazy));
		      },
		      visitor: (_visitor = {}, _visitor["CallExpression" + (api.types.importExpression ? "|ImportExpression" : "")] = function (path) {
		        if (!this.file.has("@babel/plugin-proposal-dynamic-import")) return;
		        if (path.isCallExpression() && !isImport(path.node.callee)) return;
		        var scope = path.scope;
		        do {
		          scope.rename("require");
		        } while (scope = scope.parent);
		        transformDynamicImport(path, noInterop, this.file);
		      }, _visitor.Program = {
		        exit: function exit(path, state) {
		          if (!isModule(path)) return;
		          path.scope.rename("exports");
		          path.scope.rename("module");
		          path.scope.rename("require");
		          path.scope.rename("__filename");
		          path.scope.rename("__dirname");
		          if (!allowCommonJSExports) {
		            {
		              simplifyAccess(path, new Set(["module", "exports"]), false);
		            }
		            path.traverse(moduleExportsVisitor, {
		              scope: path.scope
		            });
		          }
		          var moduleName = getModuleName(this.file.opts, options);
		          if (moduleName) moduleName = stringLiteral$8(moduleName);
		          var hooks = makeInvokers(this.file);
		          var _rewriteModuleStateme = rewriteModuleStatementsAndPrepareHeader(path, {
		              exportName: "exports",
		              constantReexports: constantReexports,
		              enumerableModuleMeta: enumerableModuleMeta,
		              strict: strict,
		              strictMode: strictMode,
		              allowTopLevelThis: allowTopLevelThis,
		              noInterop: noInterop,
		              importInterop: importInterop,
		              wrapReference: hooks.wrapReference,
		              getWrapperPayload: hooks.getWrapperPayload,
		              esNamespaceOnly: typeof state.filename === "string" && /\.mjs$/.test(state.filename) ? mjsStrictNamespace : strictNamespace,
		              noIncompleteNsImportDetection: noIncompleteNsImportDetection,
		              filename: this.file.opts.filename
		            }),
		            meta = _rewriteModuleStateme.meta,
		            headers = _rewriteModuleStateme.headers;
		          for (var _iterator = _createForOfIteratorHelperLoose(meta.source), _step; !(_step = _iterator()).done;) {
		            var _step$value = _slicedToArray(_step.value, 2),
		              source = _step$value[0],
		              metadata = _step$value[1];
		            var loadExpr = callExpression$d(identifier$j("require"), [stringLiteral$8(source)]);
		            var header = void 0;
		            if (isSideEffectImport(metadata)) {
		              if (lazy && metadata.wrap === "function") {
		                throw new Error("Assertion failure");
		              }
		              header = expressionStatement$a(loadExpr);
		            } else {
		              var _header;
		              var init = wrapInterop(path, loadExpr, metadata.interop) || loadExpr;
		              if (metadata.wrap) {
		                var res = hooks.buildRequireWrapper(metadata.name, init, metadata.wrap, metadata.referenced);
		                if (res === false) continue;else header = res;
		              }
		              (_header = header) != null ? _header : header = template$1.statement.ast(_templateObject2$a || (_templateObject2$a = _taggedTemplateLiteralLoose(["\n                var ", " = ", ";\n              "])), metadata.name, init);
		            }
		            header.loc = metadata.loc;
		            headers.push(header);
		            headers.push.apply(headers, _toConsumableArray(buildNamespaceInitStatements(meta, metadata, constantReexports, hooks.wrapReference)));
		          }
		          ensureStatementsHoisted(headers);
		          path.unshiftContainer("body", headers);
		          path.get("body").forEach(function (path) {
		            if (headers.indexOf(path.node) === -1) return;
		            if (path.isVariableDeclaration()) {
		              path.scope.registerDeclaration(path);
		            }
		          });
		        }
		      }, _visitor)
		    };
		  });

		  var buildTemplate = template$1.statement("\n  SYSTEM_REGISTER(MODULE_NAME, SOURCES, function (EXPORT_IDENTIFIER, CONTEXT_IDENTIFIER) {\n    \"use strict\";\n    BEFORE_BODY;\n    return {\n      setters: SETTERS,\n      execute: EXECUTE,\n    };\n  });\n");
		  var buildExportAll = template$1.statement("\n  for (var KEY in TARGET) {\n    if (KEY !== \"default\" && KEY !== \"__esModule\") EXPORT_OBJ[KEY] = TARGET[KEY];\n  }\n");
		  var MISSING_PLUGIN_WARNING = "WARNING: Dynamic import() transformation must be enabled using the\n         @babel/plugin-transform-dynamic-import plugin. Babel 8 will\n         no longer transform import() without using that plugin.\n";
		  var MISSING_PLUGIN_ERROR = "ERROR: Dynamic import() transformation must be enabled using the\n       @babel/plugin-transform-dynamic-import plugin. Babel 8\n       no longer transforms import() without using that plugin.\n";
		  function getExportSpecifierName(node, stringSpecifiers) {
		    if (node.type === "Identifier") {
		      return node.name;
		    } else if (node.type === "StringLiteral") {
		      var stringValue = node.value;
		      if (!isIdentifierName(stringValue)) {
		        stringSpecifiers.add(stringValue);
		      }
		      return stringValue;
		    } else {
		      throw new Error("Expected export specifier to be either Identifier or StringLiteral, got " + node.type);
		    }
		  }
		  function constructExportCall(path, exportIdent, exportNames, exportValues, exportStarTarget, stringSpecifiers) {
		    var statements = [];
		    if (!exportStarTarget) {
		      if (exportNames.length === 1) {
		        statements.push(expressionStatement$a(callExpression$d(exportIdent, [stringLiteral$8(exportNames[0]), exportValues[0]])));
		      } else {
		        var objectProperties = [];
		        for (var i = 0; i < exportNames.length; i++) {
		          var exportName = exportNames[i];
		          var exportValue = exportValues[i];
		          objectProperties.push(objectProperty$1(stringSpecifiers.has(exportName) ? stringLiteral$8(exportName) : identifier$j(exportName), exportValue));
		        }
		        statements.push(expressionStatement$a(callExpression$d(exportIdent, [objectExpression$3(objectProperties)])));
		      }
		    } else {
		      var exportObj = path.scope.generateUid("exportObj");
		      statements.push(variableDeclaration$8("var", [variableDeclarator$8(identifier$j(exportObj), objectExpression$3([]))]));
		      statements.push(buildExportAll({
		        KEY: path.scope.generateUidIdentifier("key"),
		        EXPORT_OBJ: identifier$j(exportObj),
		        TARGET: exportStarTarget
		      }));
		      for (var _i = 0; _i < exportNames.length; _i++) {
		        var _exportName = exportNames[_i];
		        var _exportValue = exportValues[_i];
		        statements.push(expressionStatement$a(assignmentExpression$d("=", memberExpression$c(identifier$j(exportObj), identifier$j(_exportName)), _exportValue)));
		      }
		      statements.push(expressionStatement$a(callExpression$d(exportIdent, [identifier$j(exportObj)])));
		    }
		    return statements;
		  }
		  var _transformModulesSystemjs = declare(function (api, options) {
		    var _visitor;
		    api.assertVersion("*");
		    var _options$systemGlobal = options.systemGlobal,
		      systemGlobal = _options$systemGlobal === void 0 ? "System" : _options$systemGlobal,
		      _options$allowTopLeve = options.allowTopLevelThis,
		      allowTopLevelThis = _options$allowTopLeve === void 0 ? false : _options$allowTopLeve;
		    var reassignmentVisited = new WeakSet();
		    var reassignmentVisitor = {
		      "AssignmentExpression|UpdateExpression": function AssignmentExpressionUpdateExpression(path) {
		        if (reassignmentVisited.has(path.node)) return;
		        reassignmentVisited.add(path.node);
		        var arg = path.isAssignmentExpression() ? path.get("left") : path.get("argument");
		        if (arg.isObjectPattern() || arg.isArrayPattern()) {
		          var exprs = [path.node];
		          for (var _i2 = 0, _Object$keys = Object.keys(arg.getBindingIdentifiers()); _i2 < _Object$keys.length; _i2++) {
		            var _name = _Object$keys[_i2];
		            if (this.scope.getBinding(_name) !== path.scope.getBinding(_name)) {
		              return;
		            }
		            var _exportedNames = this.exports[_name];
		            if (!_exportedNames) continue;
		            for (var _iterator = _createForOfIteratorHelperLoose(_exportedNames), _step; !(_step = _iterator()).done;) {
		              var exportedName = _step.value;
		              exprs.push(this.buildCall(exportedName, identifier$j(_name)).expression);
		            }
		          }
		          path.replaceWith(sequenceExpression$8(exprs));
		          return;
		        }
		        if (!arg.isIdentifier()) return;
		        var name = arg.node.name;
		        if (this.scope.getBinding(name) !== path.scope.getBinding(name)) return;
		        var exportedNames = this.exports[name];
		        if (!exportedNames) return;
		        var node = path.node;
		        var isPostUpdateExpression = isUpdateExpression$1(node, {
		          prefix: false
		        });
		        if (isPostUpdateExpression) {
		          node = binaryExpression$5(node.operator[0], unaryExpression$6("+", cloneNode$j(node.argument)), numericLiteral$8(1));
		        }
		        for (var _iterator2 = _createForOfIteratorHelperLoose(exportedNames), _step2; !(_step2 = _iterator2()).done;) {
		          var _exportedName = _step2.value;
		          node = this.buildCall(_exportedName, node).expression;
		        }
		        if (isPostUpdateExpression) {
		          node = sequenceExpression$8([node, path.node]);
		        }
		        path.replaceWith(node);
		      }
		    };
		    return {
		      name: "transform-modules-systemjs",
		      pre: function pre() {
		        this.file.set("@babel/plugin-transform-modules-*", "systemjs");
		      },
		      visitor: (_visitor = {}, _visitor["CallExpression" + (api.types.importExpression ? "|ImportExpression" : "")] = function (path, state) {
		        if (path.isCallExpression() && !isImport(path.node.callee)) return;
		        if (path.isCallExpression()) {
		          if (!this.file.has("@babel/plugin-proposal-dynamic-import")) {
		            {
		              console.warn(MISSING_PLUGIN_WARNING);
		            }
		          }
		        } else {
		          if (!this.file.has("@babel/plugin-proposal-dynamic-import")) {
		            throw new Error(MISSING_PLUGIN_ERROR);
		          }
		        }
		        path.replaceWith(buildDynamicImport(path.node, false, true, function (specifier) {
		          return callExpression$d(memberExpression$c(identifier$j(state.contextIdent), identifier$j("import")), [specifier]);
		        }));
		      }, _visitor.MetaProperty = function MetaProperty(path, state) {
		        if (path.node.meta.name === "import" && path.node.property.name === "meta") {
		          path.replaceWith(memberExpression$c(identifier$j(state.contextIdent), identifier$j("meta")));
		        }
		      }, _visitor.ReferencedIdentifier = function ReferencedIdentifier(path, state) {
		        if (path.node.name === "__moduleName" && !path.scope.hasBinding("__moduleName")) {
		          path.replaceWith(memberExpression$c(identifier$j(state.contextIdent), identifier$j("id")));
		        }
		      }, _visitor.Program = {
		        enter: function enter(path, state) {
		          state.contextIdent = path.scope.generateUid("context");
		          state.stringSpecifiers = new Set();
		          if (!allowTopLevelThis) {
		            rewriteThis(path);
		          }
		        },
		        exit: function exit(path, state) {
		          var scope = path.scope;
		          var exportIdent = scope.generateUid("export");
		          var contextIdent = state.contextIdent,
		            stringSpecifiers = state.stringSpecifiers;
		          var exportMap = Object.create(null);
		          var modules = [];
		          var beforeBody = [];
		          var setters = [];
		          var sources = [];
		          var variableIds = [];
		          var removedPaths = [];
		          function addExportName(key, val) {
		            exportMap[key] = exportMap[key] || [];
		            exportMap[key].push(val);
		          }
		          function pushModule(source, key, specifiers) {
		            var module;
		            modules.forEach(function (m) {
		              if (m.key === source) {
		                module = m;
		              }
		            });
		            if (!module) {
		              modules.push(module = {
		                key: source,
		                imports: [],
		                exports: []
		              });
		            }
		            module[key] = module[key].concat(specifiers);
		          }
		          function buildExportCall(name, val) {
		            return expressionStatement$a(callExpression$d(identifier$j(exportIdent), [stringLiteral$8(name), val]));
		          }
		          var exportNames = [];
		          var exportValues = [];
		          var body = path.get("body");
		          for (var _iterator3 = _createForOfIteratorHelperLoose(body), _step3; !(_step3 = _iterator3()).done;) {
		            var _path2 = _step3.value;
		            if (_path2.isFunctionDeclaration()) {
		              beforeBody.push(_path2.node);
		              removedPaths.push(_path2);
		            } else if (_path2.isClassDeclaration()) {
		              variableIds.push(cloneNode$j(_path2.node.id));
		              _path2.replaceWith(expressionStatement$a(assignmentExpression$d("=", cloneNode$j(_path2.node.id), toExpression$1(_path2.node))));
		            } else if (_path2.isVariableDeclaration()) {
		              _path2.node.kind = "var";
		            } else if (_path2.isImportDeclaration()) {
		              var source = _path2.node.source.value;
		              pushModule(source, "imports", _path2.node.specifiers);
		              for (var _i4 = 0, _Object$keys2 = Object.keys(_path2.getBindingIdentifiers()); _i4 < _Object$keys2.length; _i4++) {
		                var _name2 = _Object$keys2[_i4];
		                scope.removeBinding(_name2);
		                variableIds.push(identifier$j(_name2));
		              }
		              _path2.remove();
		            } else if (_path2.isExportAllDeclaration()) {
		              pushModule(_path2.node.source.value, "exports", _path2.node);
		              _path2.remove();
		            } else if (_path2.isExportDefaultDeclaration()) {
		              var declar = _path2.node.declaration;
		              if (isClassDeclaration$2(declar)) {
		                var id = declar.id;
		                if (id) {
		                  exportNames.push("default");
		                  exportValues.push(scope.buildUndefinedNode());
		                  variableIds.push(cloneNode$j(id));
		                  addExportName(id.name, "default");
		                  _path2.replaceWith(expressionStatement$a(assignmentExpression$d("=", cloneNode$j(id), toExpression$1(declar))));
		                } else {
		                  exportNames.push("default");
		                  exportValues.push(toExpression$1(declar));
		                  removedPaths.push(_path2);
		                }
		              } else if (isFunctionDeclaration$2(declar)) {
		                var _id = declar.id;
		                if (_id) {
		                  beforeBody.push(declar);
		                  exportNames.push("default");
		                  exportValues.push(cloneNode$j(_id));
		                  addExportName(_id.name, "default");
		                } else {
		                  exportNames.push("default");
		                  exportValues.push(toExpression$1(declar));
		                }
		                removedPaths.push(_path2);
		              } else {
		                _path2.replaceWith(buildExportCall("default", declar));
		              }
		            } else if (_path2.isExportNamedDeclaration()) {
		              var _declar = _path2.node.declaration;
		              if (_declar) {
		                _path2.replaceWith(_declar);
		                if (isFunction$5(_declar)) {
		                  var _name3 = _declar.id.name;
		                  addExportName(_name3, _name3);
		                  beforeBody.push(_declar);
		                  exportNames.push(_name3);
		                  exportValues.push(cloneNode$j(_declar.id));
		                  removedPaths.push(_path2);
		                } else if (isClass$1(_declar)) {
		                  var _name4 = _declar.id.name;
		                  exportNames.push(_name4);
		                  exportValues.push(scope.buildUndefinedNode());
		                  variableIds.push(cloneNode$j(_declar.id));
		                  _path2.replaceWith(expressionStatement$a(assignmentExpression$d("=", cloneNode$j(_declar.id), toExpression$1(_declar))));
		                  addExportName(_name4, _name4);
		                } else {
		                  if (isVariableDeclaration$4(_declar)) {
		                    _declar.kind = "var";
		                  }
		                  for (var _i5 = 0, _Object$keys3 = Object.keys(getBindingIdentifiers$4(_declar)); _i5 < _Object$keys3.length; _i5++) {
		                    var _name5 = _Object$keys3[_i5];
		                    addExportName(_name5, _name5);
		                  }
		                }
		              } else {
		                var specifiers = _path2.node.specifiers;
		                if (specifiers != null && specifiers.length) {
		                  if (_path2.node.source) {
		                    pushModule(_path2.node.source.value, "exports", specifiers);
		                    _path2.remove();
		                  } else {
		                    var nodes = [];
		                    for (var _iterator7 = _createForOfIteratorHelperLoose(specifiers), _step7; !(_step7 = _iterator7()).done;) {
		                      var specifier = _step7.value;
		                      var local = specifier.local,
		                        exported = specifier.exported;
		                      var binding = scope.getBinding(local.name);
		                      var exportedName = getExportSpecifierName(exported, stringSpecifiers);
		                      if (binding && isFunctionDeclaration$2(binding.path.node)) {
		                        exportNames.push(exportedName);
		                        exportValues.push(cloneNode$j(local));
		                      } else if (!binding) {
		                        nodes.push(buildExportCall(exportedName, local));
		                      }
		                      addExportName(local.name, exportedName);
		                    }
		                    _path2.replaceWithMultiple(nodes);
		                  }
		                } else {
		                  _path2.remove();
		                }
		              }
		            }
		          }
		          modules.forEach(function (specifiers) {
		            var setterBody = [];
		            var target = scope.generateUid(specifiers.key);
		            for (var _iterator4 = _createForOfIteratorHelperLoose(specifiers.imports), _step4; !(_step4 = _iterator4()).done;) {
		              var specifier = _step4.value;
		              if (isImportNamespaceSpecifier$1(specifier)) {
		                setterBody.push(expressionStatement$a(assignmentExpression$d("=", specifier.local, identifier$j(target))));
		              } else if (isImportDefaultSpecifier$1(specifier)) {
		                specifier = importSpecifier$2(specifier.local, identifier$j("default"));
		              }
		              if (isImportSpecifier$1(specifier)) {
		                var _specifier = specifier,
		                  imported = _specifier.imported;
		                setterBody.push(expressionStatement$a(assignmentExpression$d("=", specifier.local, memberExpression$c(identifier$j(target), specifier.imported, imported.type === "StringLiteral"))));
		              }
		            }
		            if (specifiers.exports.length) {
		              var _exportNames = [];
		              var _exportValues = [];
		              var hasExportStar = false;
		              for (var _iterator5 = _createForOfIteratorHelperLoose(specifiers.exports), _step5; !(_step5 = _iterator5()).done;) {
		                var node = _step5.value;
		                if (isExportAllDeclaration$1(node)) {
		                  hasExportStar = true;
		                } else if (isExportSpecifier(node)) {
		                  var exportedName = getExportSpecifierName(node.exported, stringSpecifiers);
		                  _exportNames.push(exportedName);
		                  _exportValues.push(memberExpression$c(identifier$j(target), node.local, isStringLiteral$5(node.local)));
		                } else ;
		              }
		              setterBody.push.apply(setterBody, _toConsumableArray(constructExportCall(path, identifier$j(exportIdent), _exportNames, _exportValues, hasExportStar ? identifier$j(target) : null, stringSpecifiers)));
		            }
		            sources.push(stringLiteral$8(specifiers.key));
		            setters.push(functionExpression$2(null, [identifier$j(target)], blockStatement$6(setterBody)));
		          });
		          var moduleName = getModuleName(this.file.opts, options);
		          if (moduleName) moduleName = stringLiteral$8(moduleName);
		          hoistVariables(path, function (id, name, hasInit) {
		            variableIds.push(id);
		            if (!hasInit && name in exportMap) {
		              for (var _iterator6 = _createForOfIteratorHelperLoose(exportMap[name]), _step6; !(_step6 = _iterator6()).done;) {
		                var exported = _step6.value;
		                exportNames.push(exported);
		                exportValues.push(scope.buildUndefinedNode());
		              }
		            }
		          });
		          if (variableIds.length) {
		            beforeBody.unshift(variableDeclaration$8("var", variableIds.map(function (id) {
		              return variableDeclarator$8(id);
		            })));
		          }
		          if (exportNames.length) {
		            beforeBody.push.apply(beforeBody, _toConsumableArray(constructExportCall(path, identifier$j(exportIdent), exportNames, exportValues, null, stringSpecifiers)));
		          }
		          path.traverse(reassignmentVisitor, {
		            exports: exportMap,
		            buildCall: buildExportCall,
		            scope: scope
		          });
		          for (var _i3 = 0, _removedPaths = removedPaths; _i3 < _removedPaths.length; _i3++) {
		            var _path = _removedPaths[_i3];
		            _path.remove();
		          }
		          var hasTLA = false;
		          path.traverse({
		            AwaitExpression: function AwaitExpression(path) {
		              hasTLA = true;
		              path.stop();
		            },
		            Function: function Function(path) {
		              path.skip();
		            },
		            noScope: true
		          });
		          path.node.body = [buildTemplate({
		            SYSTEM_REGISTER: memberExpression$c(identifier$j(systemGlobal), identifier$j("register")),
		            BEFORE_BODY: beforeBody,
		            MODULE_NAME: moduleName,
		            SETTERS: arrayExpression$1(setters),
		            EXECUTE: functionExpression$2(null, [], blockStatement$6(path.node.body), false, hasTLA),
		            SOURCES: arrayExpression$1(sources),
		            EXPORT_IDENTIFIER: identifier$j(exportIdent),
		            CONTEXT_IDENTIFIER: identifier$j(contextIdent)
		          })];
		          path.requeue(path.get("body.0"));
		        }
		      }, _visitor)
		    };
		  });

		  var buildPrerequisiteAssignment = template$1("\n  GLOBAL_REFERENCE = GLOBAL_REFERENCE || {}\n");
		  var buildWrapper = template$1("\n  (function (global, factory) {\n    if (typeof define === \"function\" && define.amd) {\n      define(MODULE_NAME, AMD_ARGUMENTS, factory);\n    } else if (typeof exports !== \"undefined\") {\n      factory(COMMONJS_ARGUMENTS);\n    } else {\n      var mod = { exports: {} };\n      factory(BROWSER_ARGUMENTS);\n\n      GLOBAL_TO_ASSIGN;\n    }\n  })(\n    typeof globalThis !== \"undefined\" ? globalThis\n      : typeof self !== \"undefined\" ? self\n      : this,\n    function(IMPORT_NAMES) {\n  })\n");
		  var _transformModulesUmd = declare(function (api, options) {
		    var _api$assumption, _api$assumption2;
		    api.assertVersion("*");
		    var globals = options.globals,
		      exactGlobals = options.exactGlobals,
		      allowTopLevelThis = options.allowTopLevelThis,
		      strict = options.strict,
		      strictMode = options.strictMode,
		      noInterop = options.noInterop,
		      importInterop = options.importInterop;
		    var constantReexports = (_api$assumption = api.assumption("constantReexports")) != null ? _api$assumption : options.loose;
		    var enumerableModuleMeta = (_api$assumption2 = api.assumption("enumerableModuleMeta")) != null ? _api$assumption2 : options.loose;
		    function buildBrowserInit(browserGlobals, exactGlobals, filename, moduleName) {
		      var moduleNameOrBasename = moduleName ? moduleName.value : basename(filename, extname(filename));
		      var globalToAssign = memberExpression$c(identifier$j("global"), identifier$j(toIdentifier$1(moduleNameOrBasename)));
		      var initAssignments = [];
		      if (exactGlobals) {
		        var globalName = browserGlobals[moduleNameOrBasename];
		        if (globalName) {
		          initAssignments = [];
		          var members = globalName.split(".");
		          globalToAssign = members.slice(1).reduce(function (accum, curr) {
		            initAssignments.push(buildPrerequisiteAssignment({
		              GLOBAL_REFERENCE: cloneNode$j(accum)
		            }));
		            return memberExpression$c(accum, identifier$j(curr));
		          }, memberExpression$c(identifier$j("global"), identifier$j(members[0])));
		        }
		      }
		      initAssignments.push(expressionStatement$a(assignmentExpression$d("=", globalToAssign, memberExpression$c(identifier$j("mod"), identifier$j("exports")))));
		      return initAssignments;
		    }
		    function buildBrowserArg(browserGlobals, exactGlobals, source) {
		      var memberExpression;
		      if (exactGlobals) {
		        var globalRef = browserGlobals[source];
		        if (globalRef) {
		          memberExpression = globalRef.split(".").reduce(function (accum, curr) {
		            return memberExpression$c(accum, identifier$j(curr));
		          }, identifier$j("global"));
		        } else {
		          memberExpression = memberExpression$c(identifier$j("global"), identifier$j(toIdentifier$1(source)));
		        }
		      } else {
		        var requireName = basename(source, extname(source));
		        var globalName = browserGlobals[requireName] || requireName;
		        memberExpression = memberExpression$c(identifier$j("global"), identifier$j(toIdentifier$1(globalName)));
		      }
		      return memberExpression;
		    }
		    return {
		      name: "transform-modules-umd",
		      visitor: {
		        Program: {
		          exit: function exit(path) {
		            if (!isModule(path)) return;
		            var browserGlobals = globals || {};
		            var moduleName = getModuleName(this.file.opts, options);
		            var moduleNameLiteral;
		            if (moduleName) moduleNameLiteral = stringLiteral$8(moduleName);
		            var _rewriteModuleStateme = rewriteModuleStatementsAndPrepareHeader(path, {
		                constantReexports: constantReexports,
		                enumerableModuleMeta: enumerableModuleMeta,
		                strict: strict,
		                strictMode: strictMode,
		                allowTopLevelThis: allowTopLevelThis,
		                noInterop: noInterop,
		                importInterop: importInterop,
		                filename: this.file.opts.filename
		              }),
		              meta = _rewriteModuleStateme.meta,
		              headers = _rewriteModuleStateme.headers;
		            var amdArgs = [];
		            var commonjsArgs = [];
		            var browserArgs = [];
		            var importNames = [];
		            if (hasExports(meta)) {
		              amdArgs.push(stringLiteral$8("exports"));
		              commonjsArgs.push(identifier$j("exports"));
		              browserArgs.push(memberExpression$c(identifier$j("mod"), identifier$j("exports")));
		              importNames.push(identifier$j(meta.exportName));
		            }
		            for (var _iterator = _createForOfIteratorHelperLoose(meta.source), _step; !(_step = _iterator()).done;) {
		              var _step$value = _slicedToArray(_step.value, 2),
		                source = _step$value[0],
		                metadata = _step$value[1];
		              amdArgs.push(stringLiteral$8(source));
		              commonjsArgs.push(callExpression$d(identifier$j("require"), [stringLiteral$8(source)]));
		              browserArgs.push(buildBrowserArg(browserGlobals, exactGlobals, source));
		              importNames.push(identifier$j(metadata.name));
		              if (!isSideEffectImport(metadata)) {
		                var interop = wrapInterop(path, identifier$j(metadata.name), metadata.interop);
		                if (interop) {
		                  var header = expressionStatement$a(assignmentExpression$d("=", identifier$j(metadata.name), interop));
		                  header.loc = meta.loc;
		                  headers.push(header);
		                }
		              }
		              headers.push.apply(headers, _toConsumableArray(buildNamespaceInitStatements(meta, metadata, constantReexports)));
		            }
		            ensureStatementsHoisted(headers);
		            path.unshiftContainer("body", headers);
		            var _path$node = path.node,
		              body = _path$node.body,
		              directives = _path$node.directives;
		            path.node.directives = [];
		            path.node.body = [];
		            var umdWrapper = path.pushContainer("body", [buildWrapper({
		              MODULE_NAME: moduleNameLiteral,
		              AMD_ARGUMENTS: arrayExpression$1(amdArgs),
		              COMMONJS_ARGUMENTS: commonjsArgs,
		              BROWSER_ARGUMENTS: browserArgs,
		              IMPORT_NAMES: importNames,
		              GLOBAL_TO_ASSIGN: buildBrowserInit(browserGlobals, exactGlobals, this.filename || "unknown", moduleNameLiteral)
		            })])[0];
		            var umdFactory = umdWrapper.get("expression.arguments")[1].get("body");
		            umdFactory.pushContainer("directives", directives);
		            umdFactory.pushContainer("body", body);
		          }
		        }
		      }
		    };
		  });

		  var _transformNamedCapturingGroupsRegex = declare(function (api, options) {
		    var runtime = options.runtime;
		    if (runtime !== undefined && typeof runtime !== "boolean") {
		      throw new Error("The 'runtime' option must be boolean");
		    }
		    return createRegExpFeaturePlugin({
		      name: "transform-named-capturing-groups-regex",
		      feature: "namedCaptureGroups",
		      options: {
		        runtime: runtime
		      }
		    });
		  });

		  var _transformNewTarget = declare(function (api) {
		    api.assertVersion("*");
		    return {
		      name: "transform-new-target",
		      visitor: {
		        MetaProperty: function MetaProperty(path) {
		          var meta = path.get("meta");
		          var property = path.get("property");
		          var scope = path.scope;
		          if (meta.isIdentifier({
		            name: "new"
		          }) && property.isIdentifier({
		            name: "target"
		          })) {
		            var func = path.findParent(function (path) {
		              if (path.isClass()) return true;
		              if (path.isFunction() && !path.isArrowFunctionExpression()) {
		                if (path.isClassMethod({
		                  kind: "constructor"
		                })) {
		                  return false;
		                }
		                return true;
		              }
		              return false;
		            });
		            if (!func) {
		              throw path.buildCodeFrameError("new.target must be under a (non-arrow) function or a class.");
		            }
		            var node = func.node;
		            if (isMethod$1(node)) {
		              path.replaceWith(scope.buildUndefinedNode());
		              return;
		            }
		            var _constructor = memberExpression$c(thisExpression$4(), identifier$j("constructor"));
		            if (func.isClass()) {
		              path.replaceWith(_constructor);
		              return;
		            }
		            if (!node.id) {
		              node.id = scope.generateUidIdentifier("target");
		            } else {
		              var _scope = path.scope;
		              var name = node.id.name;
		              while (_scope !== func.parentPath.scope) {
		                if (_scope.hasOwnBinding(name) && !_scope.bindingIdentifierEquals(name, node.id)) {
		                  _scope.rename(name);
		                }
		                _scope = _scope.parent;
		              }
		            }
		            path.replaceWith(conditionalExpression$5(binaryExpression$5("instanceof", thisExpression$4(), cloneNode$j(node.id)), _constructor, scope.buildUndefinedNode()));
		          }
		        }
		      }
		    };
		  });

		  var transformObjectAssign = declare(function (api) {
		    api.assertVersion("*");
		    return {
		      name: "transform-object-assign",
		      visitor: {
		        CallExpression: function CallExpression(path, file) {
		          if (path.get("callee").matchesPattern("Object.assign")) {
		            path.node.callee = file.addHelper("extends");
		          }
		        }
		      }
		    };
		  });

		  function replacePropertySuper(path, getObjectRef, file) {
		    var replaceSupers = new ReplaceSupers({
		      getObjectRef: getObjectRef,
		      methodPath: path,
		      file: file
		    });
		    replaceSupers.replace();
		  }
		  var _transformObjectSuper = declare(function (api) {
		    api.assertVersion("*");
		    var newLets = new Set();
		    return {
		      name: "transform-object-super",
		      visitor: {
		        Loop: {
		          exit: function exit(path) {
		            newLets.forEach(function (v) {
		              if (v.scopePath === path) {
		                path.scope.push({
		                  id: v.id,
		                  kind: "let"
		                });
		                path.scope.crawl();
		                path.requeue();
		                newLets["delete"](v);
		              }
		            });
		          }
		        },
		        ObjectExpression: function ObjectExpression(path, state) {
		          var objectRef;
		          var getObjectRef = function getObjectRef() {
		            return objectRef = objectRef || path.scope.generateUidIdentifier("obj");
		          };
		          path.get("properties").forEach(function (propPath) {
		            if (!propPath.isMethod()) return;
		            replacePropertySuper(propPath, getObjectRef, state.file);
		          });
		          if (objectRef) {
		            var scopePath = path.findParent(function (p) {
		              return p.isFunction() || p.isProgram() || p.isLoop();
		            });
		            var useLet = scopePath.isLoop();
		            if (useLet) {
		              newLets.add({
		                scopePath: scopePath,
		                id: cloneNode$j(objectRef)
		              });
		            } else {
		              path.scope.push({
		                id: cloneNode$j(objectRef),
		                kind: "var"
		              });
		            }
		            path.replaceWith(assignmentExpression$d("=", cloneNode$j(objectRef), path.node));
		          }
		        }
		      }
		    };
		  });

		  var transformObjectSetPrototypeOfToAssign = declare(function (api) {
		    api.assertVersion("*");
		    return {
		      name: "transform-object-set-prototype-of-to-assign",
		      visitor: {
		        CallExpression: function CallExpression(path, file) {
		          if (path.get("callee").matchesPattern("Object.setPrototypeOf")) {
		            path.node.callee = file.addHelper("defaults");
		          }
		        }
		      }
		    };
		  });

		  var _transformPropertyLiterals = declare(function (api) {
		    api.assertVersion("*");
		    return {
		      name: "transform-property-literals",
		      visitor: {
		        ObjectProperty: {
		          exit: function exit(_ref) {
		            var node = _ref.node;
		            var key = node.key;
		            if (!node.computed && isIdentifier$i(key) && !isValidES3Identifier(key.name)) {
		              node.key = stringLiteral$8(key.name);
		            }
		          }
		        }
		      }
		    };
		  });

		  function pushAccessor(mutatorMap, node) {
		    var _mutatorMap$alias;
		    var alias = toKeyAlias(node);
		    var map = (_mutatorMap$alias = mutatorMap[alias]) != null ? _mutatorMap$alias : mutatorMap[alias] = {
		      _inherits: [],
		      _key: node.key
		    };
		    map._inherits.push(node);
		    var value = functionExpression$2(null, node.params, node.body, node.generator, node.async);
		    value.returnType = node.returnType;
		    inheritsComments$1(value, node);
		    map[node.kind] = value;
		    return map;
		  }
		  function toDefineObject(mutatorMap) {
		    var objExpr = objectExpression$3([]);
		    Object.keys(mutatorMap).forEach(function (mutatorMapKey) {
		      var map = mutatorMap[mutatorMapKey];
		      map.configurable = booleanLiteral$4(true);
		      map.enumerable = booleanLiteral$4(true);
		      var mapNode = objectExpression$3([]);
		      var propNode = objectProperty$1(map._key, mapNode, map._computed);
		      Object.keys(map).forEach(function (key) {
		        var node = map[key];
		        if (key[0] === "_") return;
		        var prop = objectProperty$1(identifier$j(key), node);
		        inheritsComments$1(prop, node);
		        removeComments$1(node);
		        mapNode.properties.push(prop);
		      });
		      objExpr.properties.push(propNode);
		    });
		    return objExpr;
		  }

		  var transformPropertyMutators = declare(function (api) {
		    api.assertVersion("*");
		    return {
		      name: "transform-property-mutators",
		      visitor: {
		        ObjectExpression: function ObjectExpression(path) {
		          var node = path.node;
		          var mutatorMap;
		          var newProperties = node.properties.filter(function (prop) {
		            if (isObjectMethod$1(prop) && !prop.computed && (prop.kind === "get" || prop.kind === "set")) {
		              var _mutatorMap;
		              pushAccessor((_mutatorMap = mutatorMap) != null ? _mutatorMap : mutatorMap = {}, prop);
		              return false;
		            }
		            return true;
		          });
		          if (mutatorMap === undefined) {
		            return;
		          }
		          node.properties = newProperties;
		          path.replaceWith(callExpression$d(memberExpression$c(identifier$j("Object"), identifier$j("defineProperties")), [node, toDefineObject(mutatorMap)]));
		        }
		      }
		    };
		  });

		  var transformProtoToAssign = declare(function (api) {
		    api.assertVersion("*");
		    function isProtoKey(node) {
		      return !isSpreadElement$1(node) && isStringLiteral$5(toComputedKey$2(node, node.key), {
		        value: "__proto__"
		      });
		    }
		    function isProtoAssignmentExpression(node) {
		      var left = node;
		      return isMemberExpression$9(left) && isStringLiteral$5(toComputedKey$2(left, left.property), {
		        value: "__proto__"
		      });
		    }
		    function buildDefaultsCallExpression(expr, ref, file) {
		      return expressionStatement$a(callExpression$d(file.addHelper("defaults"), [ref, expr.right]));
		    }
		    return {
		      name: "transform-proto-to-assign",
		      visitor: {
		        AssignmentExpression: function AssignmentExpression(path, _ref) {
		          var file = _ref.file;
		          if (!isProtoAssignmentExpression(path.node.left)) return;
		          var nodes = [];
		          var left = path.node.left.object;
		          var temp = path.scope.maybeGenerateMemoised(left);
		          if (temp) {
		            nodes.push(expressionStatement$a(assignmentExpression$d("=", temp, left)));
		          }
		          nodes.push(buildDefaultsCallExpression(path.node, cloneNode$j(temp || left), file));
		          if (temp) nodes.push(cloneNode$j(temp));
		          path.replaceWithMultiple(nodes);
		        },
		        ExpressionStatement: function ExpressionStatement(path, _ref2) {
		          var file = _ref2.file;
		          var expr = path.node.expression;
		          if (!isAssignmentExpression$3(expr, {
		            operator: "="
		          })) return;
		          if (isProtoAssignmentExpression(expr.left)) {
		            path.replaceWith(buildDefaultsCallExpression(expr, expr.left.object, file));
		          }
		        },
		        ObjectExpression: function ObjectExpression(path, _ref3) {
		          var file = _ref3.file;
		          var proto;
		          var node = path.node;
		          var properties = node.properties;
		          for (var i = 0; i < properties.length; i++) {
		            var prop = properties[i];
		            if (isProtoKey(prop)) {
		              proto = prop.value;
		              properties.splice(i, 1);
		              break;
		            }
		          }
		          if (proto) {
		            var args = [objectExpression$3([]), proto];
		            if (node.properties.length) args.push(node);
		            path.replaceWith(callExpression$d(file.addHelper("extends"), args));
		          }
		        }
		      }
		    };
		  });

		  var _templateObject$d;
		  var transformReactConstantElements = declare(function (api, options) {
		    api.assertVersion("*");
		    var allowMutablePropsOnTags = options.allowMutablePropsOnTags;
		    if (allowMutablePropsOnTags != null && !Array.isArray(allowMutablePropsOnTags)) {
		      throw new Error(".allowMutablePropsOnTags must be an array, null, or undefined.");
		    }
		    var HOISTED = new WeakMap();
		    function declares(node, scope) {
		      if (isJSXIdentifier$3(node, {
		        name: "this"
		      }) || isJSXIdentifier$3(node, {
		        name: "arguments"
		      }) || isJSXIdentifier$3(node, {
		        name: "super"
		      }) || isJSXIdentifier$3(node, {
		        name: "new"
		      })) {
		        var path = scope.path;
		        return path.isFunctionParent() && !path.isArrowFunctionExpression();
		      }
		      return scope.hasOwnBinding(node.name);
		    }
		    function isHoistingScope(_ref) {
		      var path = _ref.path;
		      return path.isFunctionParent() || path.isLoop() || path.isProgram();
		    }
		    function getHoistingScope(scope) {
		      while (!isHoistingScope(scope)) scope = scope.parent;
		      return scope;
		    }
		    var targetScopeVisitor = {
		      ReferencedIdentifier: function ReferencedIdentifier(path, state) {
		        var node = path.node;
		        var scope = path.scope;
		        while (scope !== state.jsxScope) {
		          if (declares(node, scope)) return;
		          scope = scope.parent;
		        }
		        while (scope) {
		          if (scope === state.targetScope) return;
		          if (declares(node, scope)) break;
		          scope = scope.parent;
		        }
		        state.targetScope = getHoistingScope(scope);
		      }
		    };
		    var immutabilityVisitor = {
		      enter: function enter(path, state) {
		        var _expressionResult$deo;
		        var stop = function stop() {
		          state.isImmutable = false;
		          path.stop();
		        };
		        var skip = function skip() {
		          path.skip();
		        };
		        if (path.isJSXClosingElement()) {
		          skip();
		          return;
		        }
		        if (path.isJSXIdentifier({
		          name: "ref"
		        }) && path.parentPath.isJSXAttribute({
		          name: path.node
		        })) {
		          stop();
		          return;
		        }
		        if (path.isJSXIdentifier() || path.isJSXMemberExpression() || path.isJSXNamespacedName() || path.isImmutable()) {
		          return;
		        }
		        if (path.isIdentifier()) {
		          var binding = path.scope.getBinding(path.node.name);
		          if (binding && binding.constant) return;
		        }
		        var mutablePropsAllowed = state.mutablePropsAllowed;
		        if (mutablePropsAllowed && path.isFunction()) {
		          path.traverse(targetScopeVisitor, state);
		          skip();
		          return;
		        }
		        if (!path.isPure()) {
		          stop();
		          return;
		        }
		        var expressionResult = path.evaluate();
		        if (expressionResult.confident) {
		          var value = expressionResult.value;
		          if (mutablePropsAllowed || value === null || typeof value !== "object" && typeof value !== "function") {
		            skip();
		            return;
		          }
		        } else if ((_expressionResult$deo = expressionResult.deopt) != null && _expressionResult$deo.isIdentifier()) {
		          return;
		        }
		        stop();
		      }
		    };
		    var hoistingVisitor = Object.assign({}, immutabilityVisitor, targetScopeVisitor);
		    return {
		      name: "transform-react-constant-elements",
		      visitor: {
		        JSXElement: function JSXElement(path) {
		          var _jsxScope;
		          if (HOISTED.has(path.node)) return;
		          var name = path.node.openingElement.name;
		          var mutablePropsAllowed = false;
		          if (allowMutablePropsOnTags != null) {
		            var lastSegment = name;
		            while (isJSXMemberExpression$2(lastSegment)) {
		              lastSegment = lastSegment.property;
		            }
		            var elementName = lastSegment.name;
		            mutablePropsAllowed = allowMutablePropsOnTags.includes(elementName);
		          }
		          var jsxScope;
		          var current = path;
		          while (!jsxScope && current.parentPath.isJSX()) {
		            current = current.parentPath;
		            jsxScope = HOISTED.get(current.node);
		          }
		          (_jsxScope = jsxScope) != null ? _jsxScope : jsxScope = path.scope;
		          HOISTED.set(path.node, jsxScope);
		          var visitorState = {
		            isImmutable: true,
		            mutablePropsAllowed: mutablePropsAllowed,
		            jsxScope: jsxScope,
		            targetScope: path.scope.getProgramParent()
		          };
		          path.traverse(hoistingVisitor, visitorState);
		          if (!visitorState.isImmutable) return;
		          var targetScope = visitorState.targetScope;
		          for (var currentScope = jsxScope;;) {
		            if (targetScope === currentScope) return;
		            if (isHoistingScope(currentScope)) break;
		            currentScope = currentScope.parent;
		            if (!currentScope) {
		              throw new Error("Internal @babel/plugin-transform-react-constant-elements error: " + "targetScope must be an ancestor of jsxScope. " + "This is a Babel bug, please report it.");
		            }
		          }
		          var id = path.scope.generateUidBasedOnNode(name);
		          targetScope.push({
		            id: identifier$j(id)
		          });
		          HOISTED.set(path.node, targetScope);
		          var replacement = template$1.expression.ast(_templateObject$d || (_templateObject$d = _taggedTemplateLiteralLoose(["\n          ", " || (", " = ", ")\n        "])), identifier$j(id), identifier$j(id), path.node);
		          if (path.parentPath.isJSXElement() || path.parentPath.isJSXAttribute()) {
		            replacement = jsxExpressionContainer$1(replacement);
		          }
		          path.replaceWith(replacement);
		        }
		      }
		    };
		  });

		  var transformReactDisplayName = declare(function (api) {
		    api.assertVersion("*");
		    function addDisplayName(id, call) {
		      var props = call.arguments[0].properties;
		      var safe = true;
		      for (var i = 0; i < props.length; i++) {
		        var prop = props[i];
		        if (isSpreadElement$1(prop)) {
		          continue;
		        }
		        var key = toComputedKey$2(prop);
		        if (isStringLiteral$5(key, {
		          value: "displayName"
		        })) {
		          safe = false;
		          break;
		        }
		      }
		      if (safe) {
		        props.unshift(objectProperty$1(identifier$j("displayName"), stringLiteral$8(id)));
		      }
		    }
		    var isCreateClassCallExpression = buildMatchMemberExpression$1("React.createClass");
		    var isCreateClassAddon = function isCreateClassAddon(callee) {
		      return isIdentifier$i(callee, {
		        name: "createReactClass"
		      });
		    };
		    function isCreateClass(node) {
		      if (!node || !isCallExpression$8(node)) return false;
		      if (!isCreateClassCallExpression(node.callee) && !isCreateClassAddon(node.callee)) {
		        return false;
		      }
		      var args = node.arguments;
		      if (args.length !== 1) return false;
		      var first = args[0];
		      if (!isObjectExpression$3(first)) return false;
		      return true;
		    }
		    return {
		      name: "transform-react-display-name",
		      visitor: {
		        ExportDefaultDeclaration: function ExportDefaultDeclaration(_ref, state) {
		          var node = _ref.node;
		          if (isCreateClass(node.declaration)) {
		            var filename = state.filename || "unknown";
		            var displayName = path$1.basename(filename, path$1.extname(filename));
		            if (displayName === "index") {
		              displayName = path$1.basename(path$1.dirname(filename));
		            }
		            addDisplayName(displayName, node.declaration);
		          }
		        },
		        CallExpression: function CallExpression(path) {
		          var node = path.node;
		          if (!isCreateClass(node)) return;
		          var id;
		          path.find(function (path) {
		            if (path.isAssignmentExpression()) {
		              id = path.node.left;
		            } else if (path.isObjectProperty()) {
		              id = path.node.key;
		            } else if (path.isVariableDeclarator()) {
		              id = path.node.id;
		            } else if (path.isStatement()) {
		              return true;
		            }
		            if (id) return true;
		          });
		          if (!id) return;
		          if (isMemberExpression$9(id)) {
		            id = id.property;
		          }
		          if (isIdentifier$i(id)) {
		            addDisplayName(id.name, node);
		          }
		        }
		      }
		    };
		  });

		  var booleanLiteral = booleanLiteral$4,
		    callExpression = callExpression$d,
		    identifier = identifier$j,
		    inherits = inherits$3,
		    isIdentifier = isIdentifier$i,
		    isJSXExpressionContainer = isJSXExpressionContainer$1,
		    isJSXIdentifier = isJSXIdentifier$3,
		    isJSXMemberExpression = isJSXMemberExpression$2,
		    isJSXNamespacedName = isJSXNamespacedName$1,
		    isJSXSpreadAttribute = isJSXSpreadAttribute$1,
		    isObjectExpression = isObjectExpression$3,
		    isReferenced = isReferenced$2,
		    isStringLiteral = isStringLiteral$5,
		    isValidIdentifier = isValidIdentifier$1,
		    memberExpression = memberExpression$c,
		    nullLiteral = nullLiteral$2,
		    objectExpression = objectExpression$3,
		    objectProperty = objectProperty$1,
		    react = react$3,
		    spreadElement = spreadElement$2,
		    stringLiteral = stringLiteral$8,
		    thisExpression = thisExpression$4;
		  function helper (opts) {
		    var visitor = {};
		    visitor.JSXNamespacedName = function (path) {
		      if (opts.throwIfNamespace) {
		        throw path.buildCodeFrameError("Namespace tags are not supported by default. React's JSX doesn't support namespace tags. You can set `throwIfNamespace: false` to bypass this warning.");
		      }
		    };
		    visitor.JSXSpreadChild = function (path) {
		      throw path.buildCodeFrameError("Spread children are not supported in React.");
		    };
		    visitor.JSXElement = {
		      exit: function exit(path, state) {
		        var callExpr = buildElementCall(path, state);
		        if (callExpr) {
		          path.replaceWith(inherits(callExpr, path.node));
		        }
		      }
		    };
		    visitor.JSXFragment = {
		      exit: function exit(path, state) {
		        if (opts.compat) {
		          throw path.buildCodeFrameError("Fragment tags are only supported in React 16 and up.");
		        }
		        var callExpr = buildFragmentCall(path, state);
		        if (callExpr) {
		          path.replaceWith(inherits(callExpr, path.node));
		        }
		      }
		    };
		    return visitor;
		    function convertJSXIdentifier(node, parent) {
		      if (isJSXIdentifier(node)) {
		        if (node.name === "this" && isReferenced(node, parent)) {
		          return thisExpression();
		        } else if (isValidIdentifier(node.name, false)) {
		          node.type = "Identifier";
		          return node;
		        } else {
		          return stringLiteral(node.name);
		        }
		      } else if (isJSXMemberExpression(node)) {
		        return memberExpression(convertJSXIdentifier(node.object, node), convertJSXIdentifier(node.property, node));
		      } else if (isJSXNamespacedName(node)) {
		        return stringLiteral(node.namespace.name + ":" + node.name.name);
		      }
		      return node;
		    }
		    function convertAttributeValue(node) {
		      if (isJSXExpressionContainer(node)) {
		        return node.expression;
		      } else {
		        return node;
		      }
		    }
		    function convertAttribute(node) {
		      if (isJSXSpreadAttribute(node)) {
		        return spreadElement(node.argument);
		      }
		      var value = convertAttributeValue(node.value || booleanLiteral(true));
		      if (isStringLiteral(value) && !isJSXExpressionContainer(node.value)) {
		        var _value$extra;
		        value.value = value.value.replace(/\n\s+/g, " ");
		        (_value$extra = value.extra) == null || delete _value$extra.raw;
		      }
		      if (isJSXNamespacedName(node.name)) {
		        node.name = stringLiteral(node.name.namespace.name + ":" + node.name.name.name);
		      } else if (isValidIdentifier(node.name.name, false)) {
		        node.name.type = "Identifier";
		      } else {
		        node.name = stringLiteral(node.name.name);
		      }
		      return inherits(objectProperty(node.name, value), node);
		    }
		    function buildElementCall(path, pass) {
		      if (opts.filter && !opts.filter(path.node, pass)) return;
		      var openingPath = path.get("openingElement");
		      path.node.children = react.buildChildren(path.node);
		      var tagExpr = convertJSXIdentifier(openingPath.node.name, openingPath.node);
		      var args = [];
		      var tagName;
		      if (isIdentifier(tagExpr)) {
		        tagName = tagExpr.name;
		      } else if (isStringLiteral(tagExpr)) {
		        tagName = tagExpr.value;
		      }
		      var state = {
		        tagExpr: tagExpr,
		        tagName: tagName,
		        args: args,
		        pure: false
		      };
		      if (opts.pre) {
		        opts.pre(state, pass);
		      }
		      var attribs = openingPath.node.attributes;
		      var convertedAttributes;
		      if (attribs.length) {
		        {
		          convertedAttributes = buildOpeningElementAttributes(attribs, pass);
		        }
		      } else {
		        convertedAttributes = nullLiteral();
		      }
		      args.push.apply(args, [convertedAttributes].concat(_toConsumableArray(path.node.children)));
		      if (opts.post) {
		        opts.post(state, pass);
		      }
		      var call = state.call || callExpression(state.callee, args);
		      if (state.pure) annotateAsPure(call);
		      return call;
		    }
		    function pushProps(_props, objs) {
		      if (!_props.length) return _props;
		      objs.push(objectExpression(_props));
		      return [];
		    }
		    function buildOpeningElementAttributes(attribs, pass) {
		      var _props = [];
		      var objs = [];
		      var _pass$opts$useSpread = pass.opts.useSpread,
		        useSpread = _pass$opts$useSpread === void 0 ? false : _pass$opts$useSpread;
		      if (typeof useSpread !== "boolean") {
		        throw new Error("transform-react-jsx currently only accepts a boolean option for " + "useSpread (defaults to false)");
		      }
		      var useBuiltIns = pass.opts.useBuiltIns || false;
		      if (typeof useBuiltIns !== "boolean") {
		        throw new Error("transform-react-jsx currently only accepts a boolean option for " + "useBuiltIns (defaults to false)");
		      }
		      if (useSpread && useBuiltIns) {
		        throw new Error("transform-react-jsx currently only accepts useBuiltIns or useSpread " + "but not both");
		      }
		      if (useSpread) {
		        var props = attribs.map(convertAttribute);
		        return objectExpression(props);
		      }
		      while (attribs.length) {
		        var prop = attribs.shift();
		        if (isJSXSpreadAttribute(prop)) {
		          _props = pushProps(_props, objs);
		          objs.push(prop.argument);
		        } else {
		          _props.push(convertAttribute(prop));
		        }
		      }
		      pushProps(_props, objs);
		      var convertedAttribs;
		      if (objs.length === 1) {
		        convertedAttribs = objs[0];
		      } else {
		        if (!isObjectExpression(objs[0])) {
		          objs.unshift(objectExpression([]));
		        }
		        var helper = useBuiltIns ? memberExpression(identifier("Object"), identifier("assign")) : pass.addHelper("extends");
		        convertedAttribs = callExpression(helper, objs);
		      }
		      return convertedAttribs;
		    }
		    function buildFragmentCall(path, pass) {
		      if (opts.filter && !opts.filter(path.node, pass)) return;
		      path.node.children = react.buildChildren(path.node);
		      var args = [];
		      var tagName = null;
		      var tagExpr = pass.get("jsxFragIdentifier")();
		      var state = {
		        tagExpr: tagExpr,
		        tagName: tagName,
		        args: args,
		        pure: false
		      };
		      if (opts.pre) {
		        opts.pre(state, pass);
		      }
		      args.push.apply(args, [nullLiteral()].concat(_toConsumableArray(path.node.children)));
		      if (opts.post) {
		        opts.post(state, pass);
		      }
		      pass.set("usedFragment", true);
		      var call = state.call || callExpression(state.callee, args);
		      if (state.pure) annotateAsPure(call);
		      return call;
		    }
		  }

		  var transformReactInlineElements = declare(function (api) {
		    api.assertVersion("*");
		    function hasRefOrSpread(attrs) {
		      for (var i = 0; i < attrs.length; i++) {
		        var attr = attrs[i];
		        if (isJSXSpreadAttribute$1(attr)) return true;
		        if (isJSXAttributeOfName(attr, "ref")) return true;
		      }
		      return false;
		    }
		    function isJSXAttributeOfName(attr, name) {
		      return isJSXAttribute(attr) && isJSXIdentifier$3(attr.name, {
		        name: name
		      });
		    }
		    var visitor = helper({
		      filter: function filter(node) {
		        return node.type === "JSXElement" && !hasRefOrSpread(node.openingElement.attributes);
		      },
		      pre: function pre(state) {
		        var tagName = state.tagName;
		        var args = state.args;
		        if (react$3.isCompatTag(tagName)) {
		          args.push(stringLiteral$8(tagName));
		        } else {
		          args.push(state.tagExpr);
		        }
		      },
		      post: function post(state, pass) {
		        state.callee = pass.addHelper("jsx");
		        var props = state.args[1];
		        var hasKey = false;
		        if (isObjectExpression$3(props)) {
		          var keyIndex = props.properties.findIndex(function (prop) {
		            return isIdentifier$i(prop.key, {
		              name: "key"
		            });
		          });
		          if (keyIndex > -1) {
		            state.args.splice(2, 0, props.properties[keyIndex].value);
		            props.properties.splice(keyIndex, 1);
		            hasKey = true;
		          }
		        } else if (isNullLiteral$2(props)) {
		          state.args.splice(1, 1, objectExpression$3([]));
		        }
		        if (!hasKey && state.args.length > 2) {
		          state.args.splice(2, 0, unaryExpression$6("void", numericLiteral$8(0)));
		        }
		        state.pure = true;
		      }
		    });
		    return {
		      name: "transform-react-inline-elements",
		      visitor: visitor
		    };
		  });

		  var _templateObject$c;
		  var DEFAULT = {
		    importSource: "react",
		    runtime: "automatic",
		    pragma: "React.createElement",
		    pragmaFrag: "React.Fragment"
		  };
		  var JSX_SOURCE_ANNOTATION_REGEX = /^\s*\*?\s*@jsxImportSource\s+([^\s]+)\s*$/m;
		  var JSX_RUNTIME_ANNOTATION_REGEX = /^\s*\*?\s*@jsxRuntime\s+([^\s]+)\s*$/m;
		  var JSX_ANNOTATION_REGEX = /^\s*\*?\s*@jsx\s+([^\s]+)\s*$/m;
		  var JSX_FRAG_ANNOTATION_REGEX = /^\s*\*?\s*@jsxFrag\s+([^\s]+)\s*$/m;
		  var get = function get(pass, name) {
		    return pass.get("@babel/plugin-react-jsx/" + name);
		  };
		  var set = function set(pass, name, v) {
		    return pass.set("@babel/plugin-react-jsx/" + name, v);
		  };
		  function hasProto(node) {
		    return node.properties.some(function (value) {
		      return isObjectProperty$4(value, {
		        computed: false,
		        shorthand: false
		      }) && (isIdentifier$i(value.key, {
		        name: "__proto__"
		      }) || isStringLiteral$5(value.key, {
		        value: "__proto__"
		      }));
		    });
		  }
		  function createPlugin(_ref) {
		    var name = _ref.name,
		      development = _ref.development;
		    return declare(function (_, options) {
		      var PURE_ANNOTATION = options.pure,
		        _options$throwIfNames = options.throwIfNamespace,
		        throwIfNamespace = _options$throwIfNames === void 0 ? true : _options$throwIfNames,
		        filter = options.filter,
		        _options$runtime = options.runtime,
		        RUNTIME_DEFAULT = _options$runtime === void 0 ? development ? "automatic" : "classic" : _options$runtime,
		        _options$importSource = options.importSource,
		        IMPORT_SOURCE_DEFAULT = _options$importSource === void 0 ? DEFAULT.importSource : _options$importSource,
		        _options$pragma = options.pragma,
		        PRAGMA_DEFAULT = _options$pragma === void 0 ? DEFAULT.pragma : _options$pragma,
		        _options$pragmaFrag = options.pragmaFrag,
		        PRAGMA_FRAG_DEFAULT = _options$pragmaFrag === void 0 ? DEFAULT.pragmaFrag : _options$pragmaFrag;
		      {
		        var _options$useSpread = options.useSpread,
		          useSpread = _options$useSpread === void 0 ? false : _options$useSpread,
		          _options$useBuiltIns = options.useBuiltIns,
		          useBuiltIns = _options$useBuiltIns === void 0 ? false : _options$useBuiltIns;
		        if (RUNTIME_DEFAULT === "classic") {
		          if (typeof useSpread !== "boolean") {
		            throw new Error("transform-react-jsx currently only accepts a boolean option for " + "useSpread (defaults to false)");
		          }
		          if (typeof useBuiltIns !== "boolean") {
		            throw new Error("transform-react-jsx currently only accepts a boolean option for " + "useBuiltIns (defaults to false)");
		          }
		          if (useSpread && useBuiltIns) {
		            throw new Error("transform-react-jsx currently only accepts useBuiltIns or useSpread " + "but not both");
		          }
		        }
		      }
		      var injectMetaPropertiesVisitor = {
		        JSXOpeningElement: function JSXOpeningElement(path, state) {
		          var attributes = [];
		          if (isThisAllowed(path.scope)) {
		            attributes.push(jsxAttribute(jsxIdentifier$2("__self"), jsxExpressionContainer$1(thisExpression$4())));
		          }
		          attributes.push(jsxAttribute(jsxIdentifier$2("__source"), jsxExpressionContainer$1(makeSource(path, state))));
		          path.pushContainer("attributes", attributes);
		        }
		      };
		      return {
		        name: name,
		        inherits: syntaxJsx,
		        visitor: {
		          JSXNamespacedName: function JSXNamespacedName(path) {
		            if (throwIfNamespace) {
		              throw path.buildCodeFrameError("Namespace tags are not supported by default. React's JSX doesn't support namespace tags. You can set `throwIfNamespace: false` to bypass this warning.");
		            }
		          },
		          JSXSpreadChild: function JSXSpreadChild(path) {
		            throw path.buildCodeFrameError("Spread children are not supported in React.");
		          },
		          Program: {
		            enter: function enter(path, state) {
		              var file = state.file;
		              var runtime = RUNTIME_DEFAULT;
		              var source = IMPORT_SOURCE_DEFAULT;
		              var pragma = PRAGMA_DEFAULT;
		              var pragmaFrag = PRAGMA_FRAG_DEFAULT;
		              var sourceSet = !!options.importSource;
		              var pragmaSet = !!options.pragma;
		              var pragmaFragSet = !!options.pragmaFrag;
		              if (file.ast.comments) {
		                for (var _iterator = _createForOfIteratorHelperLoose(file.ast.comments), _step; !(_step = _iterator()).done;) {
		                  var comment = _step.value;
		                  var sourceMatches = JSX_SOURCE_ANNOTATION_REGEX.exec(comment.value);
		                  if (sourceMatches) {
		                    source = sourceMatches[1];
		                    sourceSet = true;
		                  }
		                  var runtimeMatches = JSX_RUNTIME_ANNOTATION_REGEX.exec(comment.value);
		                  if (runtimeMatches) {
		                    runtime = runtimeMatches[1];
		                  }
		                  var jsxMatches = JSX_ANNOTATION_REGEX.exec(comment.value);
		                  if (jsxMatches) {
		                    pragma = jsxMatches[1];
		                    pragmaSet = true;
		                  }
		                  var jsxFragMatches = JSX_FRAG_ANNOTATION_REGEX.exec(comment.value);
		                  if (jsxFragMatches) {
		                    pragmaFrag = jsxFragMatches[1];
		                    pragmaFragSet = true;
		                  }
		                }
		              }
		              set(state, "runtime", runtime);
		              if (runtime === "classic") {
		                if (sourceSet) {
		                  throw path.buildCodeFrameError("importSource cannot be set when runtime is classic.");
		                }
		                var createElement = toMemberExpression(pragma);
		                var fragment = toMemberExpression(pragmaFrag);
		                set(state, "id/createElement", function () {
		                  return cloneNode$j(createElement);
		                });
		                set(state, "id/fragment", function () {
		                  return cloneNode$j(fragment);
		                });
		                set(state, "defaultPure", pragma === DEFAULT.pragma);
		              } else if (runtime === "automatic") {
		                if (pragmaSet || pragmaFragSet) {
		                  throw path.buildCodeFrameError("pragma and pragmaFrag cannot be set when runtime is automatic.");
		                }
		                var define = function define(name, id) {
		                  return set(state, name, createImportLazily(state, path, id, source));
		                };
		                define("id/jsx", development ? "jsxDEV" : "jsx");
		                define("id/jsxs", development ? "jsxDEV" : "jsxs");
		                define("id/createElement", "createElement");
		                define("id/fragment", "Fragment");
		                set(state, "defaultPure", source === DEFAULT.importSource);
		              } else {
		                throw path.buildCodeFrameError("Runtime must be either \"classic\" or \"automatic\".");
		              }
		              if (development) {
		                path.traverse(injectMetaPropertiesVisitor, state);
		              }
		            }
		          },
		          JSXFragment: {
		            exit: function exit(path, file) {
		              var callExpr;
		              if (get(file, "runtime") === "classic") {
		                callExpr = buildCreateElementFragmentCall(path, file);
		              } else {
		                callExpr = buildJSXFragmentCall(path, file);
		              }
		              path.replaceWith(inherits$3(callExpr, path.node));
		            }
		          },
		          JSXElement: {
		            exit: function exit(path, file) {
		              var callExpr;
		              if (get(file, "runtime") === "classic" || shouldUseCreateElement(path)) {
		                callExpr = buildCreateElementCall(path, file);
		              } else {
		                callExpr = buildJSXElementCall(path, file);
		              }
		              path.replaceWith(inherits$3(callExpr, path.node));
		            }
		          },
		          JSXAttribute: function JSXAttribute(path) {
		            if (isJSXElement(path.node.value)) {
		              path.node.value = jsxExpressionContainer$1(path.node.value);
		            }
		          }
		        }
		      };
		      function isDerivedClass(classPath) {
		        return classPath.node.superClass !== null;
		      }
		      function isThisAllowed(scope) {
		        do {
		          var _scope = scope,
		            path = _scope.path;
		          if (path.isFunctionParent() && !path.isArrowFunctionExpression()) {
		            if (!path.isMethod()) {
		              return true;
		            }
		            if (path.node.kind !== "constructor") {
		              return true;
		            }
		            return !isDerivedClass(path.parentPath.parentPath);
		          }
		          if (path.isTSModuleBlock()) {
		            return false;
		          }
		        } while (scope = scope.parent);
		        return true;
		      }
		      function call(pass, name, args) {
		        var node = callExpression$d(get(pass, "id/" + name)(), args);
		        if (PURE_ANNOTATION != null ? PURE_ANNOTATION : get(pass, "defaultPure")) annotateAsPure(node);
		        return node;
		      }
		      function shouldUseCreateElement(path) {
		        var openingPath = path.get("openingElement");
		        var attributes = openingPath.node.attributes;
		        var seenPropsSpread = false;
		        for (var i = 0; i < attributes.length; i++) {
		          var attr = attributes[i];
		          if (seenPropsSpread && isJSXAttribute(attr) && attr.name.name === "key") {
		            return true;
		          } else if (isJSXSpreadAttribute$1(attr)) {
		            seenPropsSpread = true;
		          }
		        }
		        return false;
		      }
		      function convertJSXIdentifier(node, parent) {
		        if (isJSXIdentifier$3(node)) {
		          if (node.name === "this" && isReferenced$2(node, parent)) {
		            return thisExpression$4();
		          } else if (isValidIdentifier$1(node.name, false)) {
		            node.type = "Identifier";
		            return node;
		          } else {
		            return stringLiteral$8(node.name);
		          }
		        } else if (isJSXMemberExpression$2(node)) {
		          return memberExpression$c(convertJSXIdentifier(node.object, node), convertJSXIdentifier(node.property, node));
		        } else if (isJSXNamespacedName$1(node)) {
		          return stringLiteral$8(node.namespace.name + ":" + node.name.name);
		        }
		        return node;
		      }
		      function convertAttributeValue(node) {
		        if (isJSXExpressionContainer$1(node)) {
		          return node.expression;
		        } else {
		          return node;
		        }
		      }
		      function accumulateAttribute(array, attribute) {
		        if (isJSXSpreadAttribute$1(attribute.node)) {
		          var arg = attribute.node.argument;
		          if (isObjectExpression$3(arg) && !hasProto(arg)) {
		            array.push.apply(array, _toConsumableArray(arg.properties));
		          } else {
		            array.push(spreadElement$2(arg));
		          }
		          return array;
		        }
		        var value = convertAttributeValue(attribute.node.name.name !== "key" ? attribute.node.value || booleanLiteral$4(true) : attribute.node.value);
		        if (attribute.node.name.name === "key" && value === null) {
		          throw attribute.buildCodeFrameError('Please provide an explicit key value. Using "key" as a shorthand for "key={true}" is not allowed.');
		        }
		        if (isStringLiteral$5(value) && !isJSXExpressionContainer$1(attribute.node.value)) {
		          var _value$extra;
		          value.value = value.value.replace(/\n\s+/g, " ");
		          (_value$extra = value.extra) == null || delete _value$extra.raw;
		        }
		        if (isJSXNamespacedName$1(attribute.node.name)) {
		          attribute.node.name = stringLiteral$8(attribute.node.name.namespace.name + ":" + attribute.node.name.name.name);
		        } else if (isValidIdentifier$1(attribute.node.name.name, false)) {
		          attribute.node.name.type = "Identifier";
		        } else {
		          attribute.node.name = stringLiteral$8(attribute.node.name.name);
		        }
		        array.push(inherits$3(objectProperty$1(attribute.node.name, value), attribute.node));
		        return array;
		      }
		      function buildChildrenProperty(children) {
		        var childrenNode;
		        if (children.length === 1) {
		          childrenNode = children[0];
		        } else if (children.length > 1) {
		          childrenNode = arrayExpression$1(children);
		        } else {
		          return undefined;
		        }
		        return objectProperty$1(identifier$j("children"), childrenNode);
		      }
		      function buildJSXElementCall(path, file) {
		        var openingPath = path.get("openingElement");
		        var args = [getTag(openingPath)];
		        var attribsArray = [];
		        var extracted = Object.create(null);
		        for (var _iterator2 = _createForOfIteratorHelperLoose(openingPath.get("attributes")), _step2; !(_step2 = _iterator2()).done;) {
		          var attr = _step2.value;
		          if (attr.isJSXAttribute() && isJSXIdentifier$3(attr.node.name)) {
		            var _name = attr.node.name.name;
		            switch (_name) {
		              case "__source":
		              case "__self":
		                if (extracted[_name]) throw sourceSelfError(path, _name);
		              case "key":
		                {
		                  var keyValue = convertAttributeValue(attr.node.value);
		                  if (keyValue === null) {
		                    throw attr.buildCodeFrameError('Please provide an explicit key value. Using "key" as a shorthand for "key={true}" is not allowed.');
		                  }
		                  extracted[_name] = keyValue;
		                  break;
		                }
		              default:
		                attribsArray.push(attr);
		            }
		          } else {
		            attribsArray.push(attr);
		          }
		        }
		        var children = react$3.buildChildren(path.node);
		        var attribs;
		        if (attribsArray.length || children.length) {
		          attribs = buildJSXOpeningElementAttributes(attribsArray, children);
		        } else {
		          attribs = objectExpression$3([]);
		        }
		        args.push(attribs);
		        if (development) {
		          var _extracted$key;
		          args.push((_extracted$key = extracted.key) != null ? _extracted$key : path.scope.buildUndefinedNode(), booleanLiteral$4(children.length > 1));
		          if (extracted.__source) {
		            args.push(extracted.__source);
		            if (extracted.__self) args.push(extracted.__self);
		          } else if (extracted.__self) {
		            args.push(path.scope.buildUndefinedNode(), extracted.__self);
		          }
		        } else if (extracted.key !== undefined) {
		          args.push(extracted.key);
		        }
		        return call(file, children.length > 1 ? "jsxs" : "jsx", args);
		      }
		      function buildJSXOpeningElementAttributes(attribs, children) {
		        var props = attribs.reduce(accumulateAttribute, []);
		        if ((children == null ? void 0 : children.length) > 0) {
		          props.push(buildChildrenProperty(children));
		        }
		        return objectExpression$3(props);
		      }
		      function buildJSXFragmentCall(path, file) {
		        var args = [get(file, "id/fragment")()];
		        var children = react$3.buildChildren(path.node);
		        args.push(objectExpression$3(children.length > 0 ? [buildChildrenProperty(children)] : []));
		        if (development) {
		          args.push(path.scope.buildUndefinedNode(), booleanLiteral$4(children.length > 1));
		        }
		        return call(file, children.length > 1 ? "jsxs" : "jsx", args);
		      }
		      function buildCreateElementFragmentCall(path, file) {
		        if (filter && !filter(path.node, file)) return;
		        return call(file, "createElement", [get(file, "id/fragment")(), nullLiteral$2()].concat(_toConsumableArray(react$3.buildChildren(path.node))));
		      }
		      function buildCreateElementCall(path, file) {
		        var openingPath = path.get("openingElement");
		        return call(file, "createElement", [getTag(openingPath), buildCreateElementOpeningElementAttributes(file, path, openingPath.get("attributes"))].concat(_toConsumableArray(react$3.buildChildren(path.node))));
		      }
		      function getTag(openingPath) {
		        var tagExpr = convertJSXIdentifier(openingPath.node.name, openingPath.node);
		        var tagName;
		        if (isIdentifier$i(tagExpr)) {
		          tagName = tagExpr.name;
		        } else if (isStringLiteral$5(tagExpr)) {
		          tagName = tagExpr.value;
		        }
		        if (react$3.isCompatTag(tagName)) {
		          return stringLiteral$8(tagName);
		        } else {
		          return tagExpr;
		        }
		      }
		      function buildCreateElementOpeningElementAttributes(file, path, attribs) {
		        var runtime = get(file, "runtime");
		        {
		          if (runtime !== "automatic") {
		            var objs = [];
		            var _props = attribs.reduce(accumulateAttribute, []);
		            if (!useSpread) {
		              var start = 0;
		              _props.forEach(function (prop, i) {
		                if (isSpreadElement$1(prop)) {
		                  if (i > start) {
		                    objs.push(objectExpression$3(_props.slice(start, i)));
		                  }
		                  objs.push(prop.argument);
		                  start = i + 1;
		                }
		              });
		              if (_props.length > start) {
		                objs.push(objectExpression$3(_props.slice(start)));
		              }
		            } else if (_props.length) {
		              objs.push(objectExpression$3(_props));
		            }
		            if (!objs.length) {
		              return nullLiteral$2();
		            }
		            if (objs.length === 1) {
		              if (!(isSpreadElement$1(_props[0]) && isObjectExpression$3(_props[0].argument))) {
		                return objs[0];
		              }
		            }
		            if (!isObjectExpression$3(objs[0])) {
		              objs.unshift(objectExpression$3([]));
		            }
		            var helper = useBuiltIns ? memberExpression$c(identifier$j("Object"), identifier$j("assign")) : file.addHelper("extends");
		            return callExpression$d(helper, objs);
		          }
		        }
		        var props = [];
		        var found = Object.create(null);
		        for (var _iterator3 = _createForOfIteratorHelperLoose(attribs), _step3; !(_step3 = _iterator3()).done;) {
		          var attr = _step3.value;
		          var _node = attr.node;
		          var _name2 = isJSXAttribute(_node) && isJSXIdentifier$3(_node.name) && _node.name.name;
		          if (runtime === "automatic" && (_name2 === "__source" || _name2 === "__self")) {
		            if (found[_name2]) throw sourceSelfError(path, _name2);
		            found[_name2] = true;
		          }
		          accumulateAttribute(props, attr);
		        }
		        return props.length === 1 && isSpreadElement$1(props[0]) && !isObjectExpression$3(props[0].argument) ? props[0].argument : props.length > 0 ? objectExpression$3(props) : nullLiteral$2();
		      }
		    });
		    function getSource(source, importName) {
		      switch (importName) {
		        case "Fragment":
		          return source + "/" + (development ? "jsx-dev-runtime" : "jsx-runtime");
		        case "jsxDEV":
		          return source + "/jsx-dev-runtime";
		        case "jsx":
		        case "jsxs":
		          return source + "/jsx-runtime";
		        case "createElement":
		          return source;
		      }
		    }
		    function createImportLazily(pass, path, importName, source) {
		      return function () {
		        var actualSource = getSource(source, importName);
		        if (isModule(path)) {
		          var reference = get(pass, "imports/" + importName);
		          if (reference) return cloneNode$j(reference);
		          reference = addNamed(path, importName, actualSource, {
		            importedInterop: "uncompiled",
		            importPosition: "after"
		          });
		          set(pass, "imports/" + importName, reference);
		          return reference;
		        } else {
		          var _reference = get(pass, "requires/" + actualSource);
		          if (_reference) {
		            _reference = cloneNode$j(_reference);
		          } else {
		            _reference = addNamespace(path, actualSource, {
		              importedInterop: "uncompiled"
		            });
		            set(pass, "requires/" + actualSource, _reference);
		          }
		          return memberExpression$c(_reference, identifier$j(importName));
		        }
		      };
		    }
		  }
		  function toMemberExpression(id) {
		    return id.split(".").map(function (name) {
		      return identifier$j(name);
		    }).reduce(function (object, property) {
		      return memberExpression$c(object, property);
		    });
		  }
		  function makeSource(path, state) {
		    var location = path.node.loc;
		    if (!location) {
		      return path.scope.buildUndefinedNode();
		    }
		    if (!state.fileNameIdentifier) {
		      var _state$filename = state.filename,
		        filename = _state$filename === void 0 ? "" : _state$filename;
		      var fileNameIdentifier = path.scope.generateUidIdentifier("_jsxFileName");
		      path.scope.getProgramParent().push({
		        id: fileNameIdentifier,
		        init: stringLiteral$8(filename)
		      });
		      state.fileNameIdentifier = fileNameIdentifier;
		    }
		    return makeTrace(cloneNode$j(state.fileNameIdentifier), location.start.line, location.start.column);
		  }
		  function makeTrace(fileNameIdentifier, lineNumber, column0Based) {
		    var fileLineLiteral = lineNumber != null ? numericLiteral$8(lineNumber) : nullLiteral$2();
		    var fileColumnLiteral = column0Based != null ? numericLiteral$8(column0Based + 1) : nullLiteral$2();
		    return template$1.expression.ast(_templateObject$c || (_templateObject$c = _taggedTemplateLiteralLoose(["{\n    fileName: ", ",\n    lineNumber: ", ",\n    columnNumber: ", ",\n  }"])), fileNameIdentifier, fileLineLiteral, fileColumnLiteral);
		  }
		  function sourceSelfError(path, name) {
		    var pluginName = "transform-react-jsx-" + name.slice(2);
		    return path.buildCodeFrameError("Duplicate " + name + " prop found. You are most likely using the deprecated " + pluginName + " Babel plugin. Both __source and __self are automatically set when using the automatic runtime. Please remove transform-react-jsx-source and transform-react-jsx-self from your Babel config.");
		  }

		  var transformReactJSX = createPlugin({
		    name: "transform-react-jsx",
		    development: false
		  });

		  var transformReactJsxCompat = declare(function (api) {
		    api.assertVersion("*");
		    return {
		      name: "transform-react-jsx-compat",
		      manipulateOptions: function manipulateOptions(_, parserOpts) {
		        parserOpts.plugins.push("jsx");
		      },
		      visitor: helper({
		        pre: function pre(state) {
		          state.callee = state.tagExpr;
		        },
		        post: function post(state) {
		          if (react$3.isCompatTag(state.tagName)) {
		            state.call = callExpression$d(memberExpression$c(memberExpression$c(identifier$j("React"), identifier$j("DOM")), state.tagExpr, isLiteral$6(state.tagExpr)), state.args);
		          }
		        },
		        compat: true
		      })
		    };
		  });

		  var transformReactJSXDevelopment = createPlugin({
		    name: "transform-react-jsx/development",
		    development: true
		  });

		  var TRACE_ID$1 = "__self";
		  function getThisFunctionParent(path) {
		    var scope = path.scope;
		    do {
		      var _scope = scope,
		        _path = _scope.path;
		      if (_path.isFunctionParent() && !_path.isArrowFunctionExpression()) {
		        return _path;
		      }
		    } while (scope = scope.parent);
		    return null;
		  }
		  function isDerivedClass(classPath) {
		    return classPath.node.superClass !== null;
		  }
		  function isThisAllowed(path) {
		    var parentMethodOrFunction = getThisFunctionParent(path);
		    if (parentMethodOrFunction === null) {
		      return true;
		    }
		    if (!parentMethodOrFunction.isMethod()) {
		      return true;
		    }
		    if (parentMethodOrFunction.node.kind !== "constructor") {
		      return true;
		    }
		    return !isDerivedClass(parentMethodOrFunction.parentPath.parentPath);
		  }
		  var transformReactJsxSelf = declare(function (api) {
		    api.assertVersion("*");
		    var visitor = {
		      JSXOpeningElement: function JSXOpeningElement(path) {
		        if (!isThisAllowed(path)) {
		          return;
		        }
		        var node = path.node;
		        var id = jsxIdentifier$2(TRACE_ID$1);
		        var trace = thisExpression$4();
		        node.attributes.push(jsxAttribute(id, jsxExpressionContainer$1(trace)));
		      }
		    };
		    return {
		      name: "transform-react-jsx-self",
		      visitor: {
		        Program: function Program(path) {
		          path.traverse(visitor);
		        }
		      }
		    };
		  });

		  var _templateObject$b;
		  var TRACE_ID = "__source";
		  var FILE_NAME_VAR = "_jsxFileName";
		  var createNodeFromNullish = function createNodeFromNullish(val, fn) {
		    return val == null ? nullLiteral$2() : fn(val);
		  };
		  var transformReactJsxSource = declare(function (api) {
		    api.assertVersion("*");
		    function makeTrace(fileNameIdentifier, _ref) {
		      var line = _ref.line,
		        column = _ref.column;
		      var fileLineLiteral = createNodeFromNullish(line, numericLiteral$8);
		      var fileColumnLiteral = createNodeFromNullish(column, function (c) {
		        return numericLiteral$8(c + 1);
		      });
		      return template$1.expression.ast(_templateObject$b || (_templateObject$b = _taggedTemplateLiteralLoose(["{\n      fileName: ", ",\n      lineNumber: ", ",\n      columnNumber: ", ",\n    }"])), fileNameIdentifier, fileLineLiteral, fileColumnLiteral);
		    }
		    var isSourceAttr = function isSourceAttr(attr) {
		      return isJSXAttribute(attr) && attr.name.name === TRACE_ID;
		    };
		    return {
		      name: "transform-react-jsx-source",
		      visitor: {
		        JSXOpeningElement: function JSXOpeningElement(path, state) {
		          var node = path.node;
		          if (!node.loc || path.node.attributes.some(isSourceAttr)) {
		            return;
		          }
		          if (!state.fileNameIdentifier) {
		            var fileNameId = path.scope.generateUidIdentifier(FILE_NAME_VAR);
		            state.fileNameIdentifier = fileNameId;
		            path.scope.getProgramParent().push({
		              id: fileNameId,
		              init: stringLiteral$8(state.filename || "")
		            });
		          }
		          node.attributes.push(jsxAttribute(jsxIdentifier$2(TRACE_ID), jsxExpressionContainer$1(makeTrace(cloneNode$j(state.fileNameIdentifier), node.loc.start))));
		        }
		      }
		    };
		  });

		  var lib$7 = {};

		  var visit = {};

		  var interopRequireDefault = {exports: {}};

		  (function (module) {
		    function _interopRequireDefault(obj) {
		      return obj && obj.__esModule ? obj : {
		        "default": obj
		      };
		    }
		    module.exports = _interopRequireDefault, module.exports.__esModule = true, module.exports["default"] = module.exports;
		  })(interopRequireDefault);
		  var interopRequireDefaultExports = interopRequireDefault.exports;

		  var require$$1$2 = /*@__PURE__*/getAugmentedNamespace(_polyfillNode_assert);

		  var hoist$1 = {};

		  var util$1 = {};

		  var hasRequiredUtil;
		  function requireUtil() {
		    if (hasRequiredUtil) return util$1;
		    hasRequiredUtil = 1;
		    util$1.__esModule = true;
		    util$1.getTypes = getTypes;
		    util$1.isReference = isReference;
		    util$1.replaceWithOrRemove = replaceWithOrRemove;
		    util$1.runtimeProperty = runtimeProperty;
		    util$1.wrapWithTypes = wrapWithTypes;
		    var currentTypes = null;
		    function wrapWithTypes(types, fn) {
		      return function () {
		        var oldTypes = currentTypes;
		        currentTypes = types;
		        try {
		          for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
		            args[_key] = arguments[_key];
		          }
		          return fn.apply(this, args);
		        } finally {
		          currentTypes = oldTypes;
		        }
		      };
		    }
		    function getTypes() {
		      return currentTypes;
		    }
		    function runtimeProperty(name) {
		      var t = getTypes();
		      return t.memberExpression(t.identifier("regeneratorRuntime"), t.identifier(name), false);
		    }
		    function isReference(path) {
		      return path.isReferenced() || path.parentPath.isAssignmentExpression({
		        left: path.node
		      });
		    }
		    function replaceWithOrRemove(path, replacement) {
		      if (replacement) {
		        path.replaceWith(replacement);
		      } else {
		        path.remove();
		      }
		    }
		    return util$1;
		  }

		  var hasRequiredHoist;
		  function requireHoist() {
		    if (hasRequiredHoist) return hoist$1;
		    hasRequiredHoist = 1;
		    var util = _interopRequireWildcard(requireUtil());
		    function _getRequireWildcardCache(nodeInterop) {
		      if (typeof WeakMap !== "function") return null;
		      var cacheBabelInterop = new WeakMap();
		      var cacheNodeInterop = new WeakMap();
		      return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) {
		        return nodeInterop ? cacheNodeInterop : cacheBabelInterop;
		      })(nodeInterop);
		    }
		    function _interopRequireWildcard(obj, nodeInterop) {
		      if (!nodeInterop && obj && obj.__esModule) {
		        return obj;
		      }
		      if (obj === null || typeof obj !== "object" && typeof obj !== "function") {
		        return {
		          "default": obj
		        };
		      }
		      var cache = _getRequireWildcardCache(nodeInterop);
		      if (cache && cache.has(obj)) {
		        return cache.get(obj);
		      }
		      var newObj = {};
		      var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
		      for (var key in obj) {
		        if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) {
		          var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
		          if (desc && (desc.get || desc.set)) {
		            Object.defineProperty(newObj, key, desc);
		          } else {
		            newObj[key] = obj[key];
		          }
		        }
		      }
		      newObj["default"] = obj;
		      if (cache) {
		        cache.set(obj, newObj);
		      }
		      return newObj;
		    }
		    var hasOwn = Object.prototype.hasOwnProperty;
		    hoist$1.hoist = function (funPath) {
		      var t = util.getTypes();
		      t.assertFunction(funPath.node);
		      var vars = {};
		      function varDeclToExpr(_ref, includeIdentifiers) {
		        var vdec = _ref.node,
		          scope = _ref.scope;
		        t.assertVariableDeclaration(vdec);
		        var exprs = [];
		        vdec.declarations.forEach(function (dec) {
		          vars[dec.id.name] = t.identifier(dec.id.name);
		          scope.removeBinding(dec.id.name);
		          if (dec.init) {
		            exprs.push(t.assignmentExpression("=", dec.id, dec.init));
		          } else if (includeIdentifiers) {
		            exprs.push(dec.id);
		          }
		        });
		        if (exprs.length === 0) return null;
		        if (exprs.length === 1) return exprs[0];
		        return t.sequenceExpression(exprs);
		      }
		      funPath.get("body").traverse({
		        VariableDeclaration: {
		          exit: function exit(path) {
		            var expr = varDeclToExpr(path, false);
		            if (expr === null) {
		              path.remove();
		            } else {
		              util.replaceWithOrRemove(path, t.expressionStatement(expr));
		            }
		            path.skip();
		          }
		        },
		        ForStatement: function ForStatement(path) {
		          var init = path.get("init");
		          if (init.isVariableDeclaration()) {
		            util.replaceWithOrRemove(init, varDeclToExpr(init, false));
		          }
		        },
		        ForXStatement: function ForXStatement(path) {
		          var left = path.get("left");
		          if (left.isVariableDeclaration()) {
		            util.replaceWithOrRemove(left, varDeclToExpr(left, true));
		          }
		        },
		        FunctionDeclaration: function FunctionDeclaration(path) {
		          var node = path.node;
		          vars[node.id.name] = node.id;
		          var assignment = t.expressionStatement(t.assignmentExpression("=", t.clone(node.id), t.functionExpression(path.scope.generateUidIdentifierBasedOnNode(node), node.params, node.body, node.generator, node.expression)));
		          if (path.parentPath.isBlockStatement()) {
		            path.parentPath.unshiftContainer("body", assignment);
		            path.remove();
		          } else {
		            util.replaceWithOrRemove(path, assignment);
		          }
		          path.scope.removeBinding(node.id.name);
		          path.skip();
		        },
		        FunctionExpression: function FunctionExpression(path) {
		          path.skip();
		        },
		        ArrowFunctionExpression: function ArrowFunctionExpression(path) {
		          path.skip();
		        }
		      });
		      var paramNames = {};
		      funPath.get("params").forEach(function (paramPath) {
		        var param = paramPath.node;
		        if (t.isIdentifier(param)) {
		          paramNames[param.name] = param;
		        }
		      });
		      var declarations = [];
		      Object.keys(vars).forEach(function (name) {
		        if (!hasOwn.call(paramNames, name)) {
		          declarations.push(t.variableDeclarator(vars[name], null));
		        }
		      });
		      if (declarations.length === 0) {
		        return null;
		      }
		      return t.variableDeclaration("var", declarations);
		    };
		    return hoist$1;
		  }

		  var emit = {};

		  var leap = {};

		  var require$$3 = /*@__PURE__*/getAugmentedNamespace(_polyfillNode_util$1);

		  var hasRequiredLeap;
		  function requireLeap() {
		    if (hasRequiredLeap) return leap;
		    hasRequiredLeap = 1;
		    var _interopRequireDefault = interopRequireDefaultExports;
		    var _assert = _interopRequireDefault(require$$1$2);
		    var _emit = requireEmit();
		    var _util = require$$3;
		    var _util2 = requireUtil();
		    function Entry() {
		      _assert["default"].ok(this instanceof Entry);
		    }
		    function FunctionEntry(returnLoc) {
		      Entry.call(this);
		      (0, _util2.getTypes)().assertLiteral(returnLoc);
		      this.returnLoc = returnLoc;
		    }
		    (0, _util.inherits)(FunctionEntry, Entry);
		    leap.FunctionEntry = FunctionEntry;
		    function LoopEntry(breakLoc, continueLoc, label) {
		      Entry.call(this);
		      var t = (0, _util2.getTypes)();
		      t.assertLiteral(breakLoc);
		      t.assertLiteral(continueLoc);
		      if (label) {
		        t.assertIdentifier(label);
		      } else {
		        label = null;
		      }
		      this.breakLoc = breakLoc;
		      this.continueLoc = continueLoc;
		      this.label = label;
		    }
		    (0, _util.inherits)(LoopEntry, Entry);
		    leap.LoopEntry = LoopEntry;
		    function SwitchEntry(breakLoc) {
		      Entry.call(this);
		      (0, _util2.getTypes)().assertLiteral(breakLoc);
		      this.breakLoc = breakLoc;
		    }
		    (0, _util.inherits)(SwitchEntry, Entry);
		    leap.SwitchEntry = SwitchEntry;
		    function TryEntry(firstLoc, catchEntry, finallyEntry) {
		      Entry.call(this);
		      var t = (0, _util2.getTypes)();
		      t.assertLiteral(firstLoc);
		      if (catchEntry) {
		        _assert["default"].ok(catchEntry instanceof CatchEntry);
		      } else {
		        catchEntry = null;
		      }
		      if (finallyEntry) {
		        _assert["default"].ok(finallyEntry instanceof FinallyEntry);
		      } else {
		        finallyEntry = null;
		      }
		      _assert["default"].ok(catchEntry || finallyEntry);
		      this.firstLoc = firstLoc;
		      this.catchEntry = catchEntry;
		      this.finallyEntry = finallyEntry;
		    }
		    (0, _util.inherits)(TryEntry, Entry);
		    leap.TryEntry = TryEntry;
		    function CatchEntry(firstLoc, paramId) {
		      Entry.call(this);
		      var t = (0, _util2.getTypes)();
		      t.assertLiteral(firstLoc);
		      t.assertIdentifier(paramId);
		      this.firstLoc = firstLoc;
		      this.paramId = paramId;
		    }
		    (0, _util.inherits)(CatchEntry, Entry);
		    leap.CatchEntry = CatchEntry;
		    function FinallyEntry(firstLoc, afterLoc) {
		      Entry.call(this);
		      var t = (0, _util2.getTypes)();
		      t.assertLiteral(firstLoc);
		      t.assertLiteral(afterLoc);
		      this.firstLoc = firstLoc;
		      this.afterLoc = afterLoc;
		    }
		    (0, _util.inherits)(FinallyEntry, Entry);
		    leap.FinallyEntry = FinallyEntry;
		    function LabeledEntry(breakLoc, label) {
		      Entry.call(this);
		      var t = (0, _util2.getTypes)();
		      t.assertLiteral(breakLoc);
		      t.assertIdentifier(label);
		      this.breakLoc = breakLoc;
		      this.label = label;
		    }
		    (0, _util.inherits)(LabeledEntry, Entry);
		    leap.LabeledEntry = LabeledEntry;
		    function LeapManager(emitter) {
		      _assert["default"].ok(this instanceof LeapManager);
		      _assert["default"].ok(emitter instanceof _emit.Emitter);
		      this.emitter = emitter;
		      this.entryStack = [new FunctionEntry(emitter.finalLoc)];
		    }
		    var LMp = LeapManager.prototype;
		    leap.LeapManager = LeapManager;
		    LMp.withEntry = function (entry, callback) {
		      _assert["default"].ok(entry instanceof Entry);
		      this.entryStack.push(entry);
		      try {
		        callback.call(this.emitter);
		      } finally {
		        var popped = this.entryStack.pop();
		        _assert["default"].strictEqual(popped, entry);
		      }
		    };
		    LMp._findLeapLocation = function (property, label) {
		      for (var i = this.entryStack.length - 1; i >= 0; --i) {
		        var entry = this.entryStack[i];
		        var loc = entry[property];
		        if (loc) {
		          if (label) {
		            if (entry.label && entry.label.name === label.name) {
		              return loc;
		            }
		          } else if (entry instanceof LabeledEntry) ; else {
		            return loc;
		          }
		        }
		      }
		      return null;
		    };
		    LMp.getBreakLoc = function (label) {
		      return this._findLeapLocation("breakLoc", label);
		    };
		    LMp.getContinueLoc = function (label) {
		      return this._findLeapLocation("continueLoc", label);
		    };
		    return leap;
		  }

		  var meta = {};

		  var hasRequiredMeta;
		  function requireMeta() {
		    if (hasRequiredMeta) return meta;
		    hasRequiredMeta = 1;
		    var _interopRequireDefault = interopRequireDefaultExports;
		    var _assert = _interopRequireDefault(require$$1$2);
		    var _util = requireUtil();
		    var mMap = new WeakMap();
		    function m(node) {
		      if (!mMap.has(node)) {
		        mMap.set(node, {});
		      }
		      return mMap.get(node);
		    }
		    var hasOwn = Object.prototype.hasOwnProperty;
		    function makePredicate(propertyName, knownTypes) {
		      function onlyChildren(node) {
		        var t = (0, _util.getTypes)();
		        t.assertNode(node);
		        var result = false;
		        function check(child) {
		          if (result) ; else if (Array.isArray(child)) {
		            child.some(check);
		          } else if (t.isNode(child)) {
		            _assert["default"].strictEqual(result, false);
		            result = predicate(child);
		          }
		          return result;
		        }
		        var keys = t.VISITOR_KEYS[node.type];
		        if (keys) {
		          for (var i = 0; i < keys.length; i++) {
		            var key = keys[i];
		            var child = node[key];
		            check(child);
		          }
		        }
		        return result;
		      }
		      function predicate(node) {
		        (0, _util.getTypes)().assertNode(node);
		        var meta = m(node);
		        if (hasOwn.call(meta, propertyName)) return meta[propertyName];
		        if (hasOwn.call(opaqueTypes, node.type)) return meta[propertyName] = false;
		        if (hasOwn.call(knownTypes, node.type)) return meta[propertyName] = true;
		        return meta[propertyName] = onlyChildren(node);
		      }
		      predicate.onlyChildren = onlyChildren;
		      return predicate;
		    }
		    var opaqueTypes = {
		      FunctionExpression: true,
		      ArrowFunctionExpression: true
		    };
		    var sideEffectTypes = {
		      CallExpression: true,
		      ForInStatement: true,
		      UnaryExpression: true,
		      BinaryExpression: true,
		      AssignmentExpression: true,
		      UpdateExpression: true,
		      NewExpression: true
		    };
		    var leapTypes = {
		      YieldExpression: true,
		      BreakStatement: true,
		      ContinueStatement: true,
		      ReturnStatement: true,
		      ThrowStatement: true
		    };
		    for (var type in leapTypes) {
		      if (hasOwn.call(leapTypes, type)) {
		        sideEffectTypes[type] = leapTypes[type];
		      }
		    }
		    meta.hasSideEffects = makePredicate("hasSideEffects", sideEffectTypes);
		    meta.containsLeap = makePredicate("containsLeap", leapTypes);
		    return meta;
		  }

		  var hasRequiredEmit;
		  function requireEmit() {
		    if (hasRequiredEmit) return emit;
		    hasRequiredEmit = 1;
		    var _interopRequireDefault = interopRequireDefaultExports;
		    var _assert = _interopRequireDefault(require$$1$2);
		    var leap = _interopRequireWildcard(requireLeap());
		    var meta = _interopRequireWildcard(requireMeta());
		    var util = _interopRequireWildcard(requireUtil());
		    function _getRequireWildcardCache(nodeInterop) {
		      if (typeof WeakMap !== "function") return null;
		      var cacheBabelInterop = new WeakMap();
		      var cacheNodeInterop = new WeakMap();
		      return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) {
		        return nodeInterop ? cacheNodeInterop : cacheBabelInterop;
		      })(nodeInterop);
		    }
		    function _interopRequireWildcard(obj, nodeInterop) {
		      if (!nodeInterop && obj && obj.__esModule) {
		        return obj;
		      }
		      if (obj === null || typeof obj !== "object" && typeof obj !== "function") {
		        return {
		          "default": obj
		        };
		      }
		      var cache = _getRequireWildcardCache(nodeInterop);
		      if (cache && cache.has(obj)) {
		        return cache.get(obj);
		      }
		      var newObj = {};
		      var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
		      for (var key in obj) {
		        if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) {
		          var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
		          if (desc && (desc.get || desc.set)) {
		            Object.defineProperty(newObj, key, desc);
		          } else {
		            newObj[key] = obj[key];
		          }
		        }
		      }
		      newObj["default"] = obj;
		      if (cache) {
		        cache.set(obj, newObj);
		      }
		      return newObj;
		    }
		    var hasOwn = Object.prototype.hasOwnProperty;
		    function Emitter(contextId) {
		      _assert["default"].ok(this instanceof Emitter);
		      util.getTypes().assertIdentifier(contextId);
		      this.nextTempId = 0;
		      this.contextId = contextId;
		      this.listing = [];
		      this.marked = [true];
		      this.insertedLocs = new Set();
		      this.finalLoc = this.loc();
		      this.tryEntries = [];
		      this.leapManager = new leap.LeapManager(this);
		    }
		    var Ep = Emitter.prototype;
		    emit.Emitter = Emitter;
		    var PENDING_LOCATION = Number.MAX_VALUE;
		    Ep.loc = function () {
		      var l = util.getTypes().numericLiteral(PENDING_LOCATION);
		      this.insertedLocs.add(l);
		      return l;
		    };
		    Ep.getInsertedLocs = function () {
		      return this.insertedLocs;
		    };
		    Ep.getContextId = function () {
		      return util.getTypes().clone(this.contextId);
		    };
		    Ep.mark = function (loc) {
		      util.getTypes().assertLiteral(loc);
		      var index = this.listing.length;
		      if (loc.value === PENDING_LOCATION) {
		        loc.value = index;
		      } else {
		        _assert["default"].strictEqual(loc.value, index);
		      }
		      this.marked[index] = true;
		      return loc;
		    };
		    Ep.emit = function (node) {
		      var t = util.getTypes();
		      if (t.isExpression(node)) {
		        node = t.expressionStatement(node);
		      }
		      t.assertStatement(node);
		      this.listing.push(node);
		    };
		    Ep.emitAssign = function (lhs, rhs) {
		      this.emit(this.assign(lhs, rhs));
		      return lhs;
		    };
		    Ep.assign = function (lhs, rhs) {
		      var t = util.getTypes();
		      return t.expressionStatement(t.assignmentExpression("=", t.cloneDeep(lhs), rhs));
		    };
		    Ep.contextProperty = function (name, computed) {
		      var t = util.getTypes();
		      return t.memberExpression(this.getContextId(), computed ? t.stringLiteral(name) : t.identifier(name), !!computed);
		    };
		    Ep.stop = function (rval) {
		      if (rval) {
		        this.setReturnValue(rval);
		      }
		      this.jump(this.finalLoc);
		    };
		    Ep.setReturnValue = function (valuePath) {
		      util.getTypes().assertExpression(valuePath.value);
		      this.emitAssign(this.contextProperty("rval"), this.explodeExpression(valuePath));
		    };
		    Ep.clearPendingException = function (tryLoc, assignee) {
		      var t = util.getTypes();
		      t.assertLiteral(tryLoc);
		      var catchCall = t.callExpression(this.contextProperty("catch", true), [t.clone(tryLoc)]);
		      if (assignee) {
		        this.emitAssign(assignee, catchCall);
		      } else {
		        this.emit(catchCall);
		      }
		    };
		    Ep.jump = function (toLoc) {
		      this.emitAssign(this.contextProperty("next"), toLoc);
		      this.emit(util.getTypes().breakStatement());
		    };
		    Ep.jumpIf = function (test, toLoc) {
		      var t = util.getTypes();
		      t.assertExpression(test);
		      t.assertLiteral(toLoc);
		      this.emit(t.ifStatement(test, t.blockStatement([this.assign(this.contextProperty("next"), toLoc), t.breakStatement()])));
		    };
		    Ep.jumpIfNot = function (test, toLoc) {
		      var t = util.getTypes();
		      t.assertExpression(test);
		      t.assertLiteral(toLoc);
		      var negatedTest;
		      if (t.isUnaryExpression(test) && test.operator === "!") {
		        negatedTest = test.argument;
		      } else {
		        negatedTest = t.unaryExpression("!", test);
		      }
		      this.emit(t.ifStatement(negatedTest, t.blockStatement([this.assign(this.contextProperty("next"), toLoc), t.breakStatement()])));
		    };
		    Ep.makeTempVar = function () {
		      return this.contextProperty("t" + this.nextTempId++);
		    };
		    Ep.getContextFunction = function (id) {
		      var t = util.getTypes();
		      return t.functionExpression(id || null, [this.getContextId()], t.blockStatement([this.getDispatchLoop()]), false, false);
		    };
		    Ep.getDispatchLoop = function () {
		      var self = this;
		      var t = util.getTypes();
		      var cases = [];
		      var current;
		      var alreadyEnded = false;
		      self.listing.forEach(function (stmt, i) {
		        if (self.marked.hasOwnProperty(i)) {
		          cases.push(t.switchCase(t.numericLiteral(i), current = []));
		          alreadyEnded = false;
		        }
		        if (!alreadyEnded) {
		          current.push(stmt);
		          if (t.isCompletionStatement(stmt)) alreadyEnded = true;
		        }
		      });
		      this.finalLoc.value = this.listing.length;
		      cases.push(t.switchCase(this.finalLoc, []), t.switchCase(t.stringLiteral("end"), [t.returnStatement(t.callExpression(this.contextProperty("stop"), []))]));
		      return t.whileStatement(t.numericLiteral(1), t.switchStatement(t.assignmentExpression("=", this.contextProperty("prev"), this.contextProperty("next")), cases));
		    };
		    Ep.getTryLocsList = function () {
		      if (this.tryEntries.length === 0) {
		        return null;
		      }
		      var t = util.getTypes();
		      var lastLocValue = 0;
		      return t.arrayExpression(this.tryEntries.map(function (tryEntry) {
		        var thisLocValue = tryEntry.firstLoc.value;
		        _assert["default"].ok(thisLocValue >= lastLocValue, "try entries out of order");
		        lastLocValue = thisLocValue;
		        var ce = tryEntry.catchEntry;
		        var fe = tryEntry.finallyEntry;
		        var locs = [tryEntry.firstLoc, ce ? ce.firstLoc : null];
		        if (fe) {
		          locs[2] = fe.firstLoc;
		          locs[3] = fe.afterLoc;
		        }
		        return t.arrayExpression(locs.map(function (loc) {
		          return loc && t.clone(loc);
		        }));
		      }));
		    };
		    Ep.explode = function (path, ignoreResult) {
		      var t = util.getTypes();
		      var node = path.node;
		      var self = this;
		      t.assertNode(node);
		      if (t.isDeclaration(node)) throw getDeclError(node);
		      if (t.isStatement(node)) return self.explodeStatement(path);
		      if (t.isExpression(node)) return self.explodeExpression(path, ignoreResult);
		      switch (node.type) {
		        case "Program":
		          return path.get("body").map(self.explodeStatement, self);
		        case "VariableDeclarator":
		          throw getDeclError(node);
		        case "Property":
		        case "SwitchCase":
		        case "CatchClause":
		          throw new Error(node.type + " nodes should be handled by their parents");
		        default:
		          throw new Error("unknown Node of type " + JSON.stringify(node.type));
		      }
		    };
		    function getDeclError(node) {
		      return new Error("all declarations should have been transformed into " + "assignments before the Exploder began its work: " + JSON.stringify(node));
		    }
		    Ep.explodeStatement = function (path, labelId) {
		      var t = util.getTypes();
		      var stmt = path.node;
		      var self = this;
		      var before, after, head;
		      t.assertStatement(stmt);
		      if (labelId) {
		        t.assertIdentifier(labelId);
		      } else {
		        labelId = null;
		      }
		      if (t.isBlockStatement(stmt)) {
		        path.get("body").forEach(function (path) {
		          self.explodeStatement(path);
		        });
		        return;
		      }
		      if (!meta.containsLeap(stmt)) {
		        self.emit(stmt);
		        return;
		      }
		      switch (stmt.type) {
		        case "ExpressionStatement":
		          self.explodeExpression(path.get("expression"), true);
		          break;
		        case "LabeledStatement":
		          after = this.loc();
		          self.leapManager.withEntry(new leap.LabeledEntry(after, stmt.label), function () {
		            self.explodeStatement(path.get("body"), stmt.label);
		          });
		          self.mark(after);
		          break;
		        case "WhileStatement":
		          before = this.loc();
		          after = this.loc();
		          self.mark(before);
		          self.jumpIfNot(self.explodeExpression(path.get("test")), after);
		          self.leapManager.withEntry(new leap.LoopEntry(after, before, labelId), function () {
		            self.explodeStatement(path.get("body"));
		          });
		          self.jump(before);
		          self.mark(after);
		          break;
		        case "DoWhileStatement":
		          var first = this.loc();
		          var test = this.loc();
		          after = this.loc();
		          self.mark(first);
		          self.leapManager.withEntry(new leap.LoopEntry(after, test, labelId), function () {
		            self.explode(path.get("body"));
		          });
		          self.mark(test);
		          self.jumpIf(self.explodeExpression(path.get("test")), first);
		          self.mark(after);
		          break;
		        case "ForStatement":
		          head = this.loc();
		          var update = this.loc();
		          after = this.loc();
		          if (stmt.init) {
		            self.explode(path.get("init"), true);
		          }
		          self.mark(head);
		          if (stmt.test) {
		            self.jumpIfNot(self.explodeExpression(path.get("test")), after);
		          }
		          self.leapManager.withEntry(new leap.LoopEntry(after, update, labelId), function () {
		            self.explodeStatement(path.get("body"));
		          });
		          self.mark(update);
		          if (stmt.update) {
		            self.explode(path.get("update"), true);
		          }
		          self.jump(head);
		          self.mark(after);
		          break;
		        case "TypeCastExpression":
		          return self.explodeExpression(path.get("expression"));
		        case "ForInStatement":
		          head = this.loc();
		          after = this.loc();
		          var keyIterNextFn = self.makeTempVar();
		          self.emitAssign(keyIterNextFn, t.callExpression(util.runtimeProperty("keys"), [self.explodeExpression(path.get("right"))]));
		          self.mark(head);
		          var keyInfoTmpVar = self.makeTempVar();
		          self.jumpIf(t.memberExpression(t.assignmentExpression("=", keyInfoTmpVar, t.callExpression(t.cloneDeep(keyIterNextFn), [])), t.identifier("done"), false), after);
		          self.emitAssign(stmt.left, t.memberExpression(t.cloneDeep(keyInfoTmpVar), t.identifier("value"), false));
		          self.leapManager.withEntry(new leap.LoopEntry(after, head, labelId), function () {
		            self.explodeStatement(path.get("body"));
		          });
		          self.jump(head);
		          self.mark(after);
		          break;
		        case "BreakStatement":
		          self.emitAbruptCompletion({
		            type: "break",
		            target: self.leapManager.getBreakLoc(stmt.label)
		          });
		          break;
		        case "ContinueStatement":
		          self.emitAbruptCompletion({
		            type: "continue",
		            target: self.leapManager.getContinueLoc(stmt.label)
		          });
		          break;
		        case "SwitchStatement":
		          var disc = self.emitAssign(self.makeTempVar(), self.explodeExpression(path.get("discriminant")));
		          after = this.loc();
		          var defaultLoc = this.loc();
		          var condition = defaultLoc;
		          var caseLocs = [];
		          var cases = stmt.cases || [];
		          for (var i = cases.length - 1; i >= 0; --i) {
		            var c = cases[i];
		            t.assertSwitchCase(c);
		            if (c.test) {
		              condition = t.conditionalExpression(t.binaryExpression("===", t.cloneDeep(disc), c.test), caseLocs[i] = this.loc(), condition);
		            } else {
		              caseLocs[i] = defaultLoc;
		            }
		          }
		          var discriminant = path.get("discriminant");
		          util.replaceWithOrRemove(discriminant, condition);
		          self.jump(self.explodeExpression(discriminant));
		          self.leapManager.withEntry(new leap.SwitchEntry(after), function () {
		            path.get("cases").forEach(function (casePath) {
		              var i = casePath.key;
		              self.mark(caseLocs[i]);
		              casePath.get("consequent").forEach(function (path) {
		                self.explodeStatement(path);
		              });
		            });
		          });
		          self.mark(after);
		          if (defaultLoc.value === PENDING_LOCATION) {
		            self.mark(defaultLoc);
		            _assert["default"].strictEqual(after.value, defaultLoc.value);
		          }
		          break;
		        case "IfStatement":
		          var elseLoc = stmt.alternate && this.loc();
		          after = this.loc();
		          self.jumpIfNot(self.explodeExpression(path.get("test")), elseLoc || after);
		          self.explodeStatement(path.get("consequent"));
		          if (elseLoc) {
		            self.jump(after);
		            self.mark(elseLoc);
		            self.explodeStatement(path.get("alternate"));
		          }
		          self.mark(after);
		          break;
		        case "ReturnStatement":
		          self.emitAbruptCompletion({
		            type: "return",
		            value: self.explodeExpression(path.get("argument"))
		          });
		          break;
		        case "WithStatement":
		          throw new Error("WithStatement not supported in generator functions.");
		        case "TryStatement":
		          after = this.loc();
		          var handler = stmt.handler;
		          var catchLoc = handler && this.loc();
		          var catchEntry = catchLoc && new leap.CatchEntry(catchLoc, handler.param);
		          var finallyLoc = stmt.finalizer && this.loc();
		          var finallyEntry = finallyLoc && new leap.FinallyEntry(finallyLoc, after);
		          var tryEntry = new leap.TryEntry(self.getUnmarkedCurrentLoc(), catchEntry, finallyEntry);
		          self.tryEntries.push(tryEntry);
		          self.updateContextPrevLoc(tryEntry.firstLoc);
		          self.leapManager.withEntry(tryEntry, function () {
		            self.explodeStatement(path.get("block"));
		            if (catchLoc) {
		              if (finallyLoc) {
		                self.jump(finallyLoc);
		              } else {
		                self.jump(after);
		              }
		              self.updateContextPrevLoc(self.mark(catchLoc));
		              var bodyPath = path.get("handler.body");
		              var safeParam = self.makeTempVar();
		              self.clearPendingException(tryEntry.firstLoc, safeParam);
		              bodyPath.traverse(catchParamVisitor, {
		                getSafeParam: function getSafeParam() {
		                  return t.cloneDeep(safeParam);
		                },
		                catchParamName: handler.param.name
		              });
		              self.leapManager.withEntry(catchEntry, function () {
		                self.explodeStatement(bodyPath);
		              });
		            }
		            if (finallyLoc) {
		              self.updateContextPrevLoc(self.mark(finallyLoc));
		              self.leapManager.withEntry(finallyEntry, function () {
		                self.explodeStatement(path.get("finalizer"));
		              });
		              self.emit(t.returnStatement(t.callExpression(self.contextProperty("finish"), [finallyEntry.firstLoc])));
		            }
		          });
		          self.mark(after);
		          break;
		        case "ThrowStatement":
		          self.emit(t.throwStatement(self.explodeExpression(path.get("argument"))));
		          break;
		        case "ClassDeclaration":
		          self.emit(self.explodeClass(path));
		          break;
		        default:
		          throw new Error("unknown Statement of type " + JSON.stringify(stmt.type));
		      }
		    };
		    var catchParamVisitor = {
		      Identifier: function Identifier(path, state) {
		        if (path.node.name === state.catchParamName && util.isReference(path)) {
		          util.replaceWithOrRemove(path, state.getSafeParam());
		        }
		      },
		      Scope: function Scope(path, state) {
		        if (path.scope.hasOwnBinding(state.catchParamName)) {
		          path.skip();
		        }
		      }
		    };
		    Ep.emitAbruptCompletion = function (record) {
		      if (!isValidCompletion(record)) {
		        _assert["default"].ok(false, "invalid completion record: " + JSON.stringify(record));
		      }
		      _assert["default"].notStrictEqual(record.type, "normal", "normal completions are not abrupt");
		      var t = util.getTypes();
		      var abruptArgs = [t.stringLiteral(record.type)];
		      if (record.type === "break" || record.type === "continue") {
		        t.assertLiteral(record.target);
		        abruptArgs[1] = this.insertedLocs.has(record.target) ? record.target : t.cloneDeep(record.target);
		      } else if (record.type === "return" || record.type === "throw") {
		        if (record.value) {
		          t.assertExpression(record.value);
		          abruptArgs[1] = this.insertedLocs.has(record.value) ? record.value : t.cloneDeep(record.value);
		        }
		      }
		      this.emit(t.returnStatement(t.callExpression(this.contextProperty("abrupt"), abruptArgs)));
		    };
		    function isValidCompletion(record) {
		      var type = record.type;
		      if (type === "normal") {
		        return !hasOwn.call(record, "target");
		      }
		      if (type === "break" || type === "continue") {
		        return !hasOwn.call(record, "value") && util.getTypes().isLiteral(record.target);
		      }
		      if (type === "return" || type === "throw") {
		        return hasOwn.call(record, "value") && !hasOwn.call(record, "target");
		      }
		      return false;
		    }
		    Ep.getUnmarkedCurrentLoc = function () {
		      return util.getTypes().numericLiteral(this.listing.length);
		    };
		    Ep.updateContextPrevLoc = function (loc) {
		      var t = util.getTypes();
		      if (loc) {
		        t.assertLiteral(loc);
		        if (loc.value === PENDING_LOCATION) {
		          loc.value = this.listing.length;
		        } else {
		          _assert["default"].strictEqual(loc.value, this.listing.length);
		        }
		      } else {
		        loc = this.getUnmarkedCurrentLoc();
		      }
		      this.emitAssign(this.contextProperty("prev"), loc);
		    };
		    Ep.explodeViaTempVar = function (tempVar, childPath, hasLeapingChildren, ignoreChildResult) {
		      _assert["default"].ok(!ignoreChildResult || !tempVar, "Ignoring the result of a child expression but forcing it to " + "be assigned to a temporary variable?");
		      var t = util.getTypes();
		      var result = this.explodeExpression(childPath, ignoreChildResult);
		      if (ignoreChildResult) ; else if (tempVar || hasLeapingChildren && !t.isLiteral(result)) {
		        result = this.emitAssign(tempVar || this.makeTempVar(), result);
		      }
		      return result;
		    };
		    Ep.explodeExpression = function (path, ignoreResult) {
		      var t = util.getTypes();
		      var expr = path.node;
		      if (expr) {
		        t.assertExpression(expr);
		      } else {
		        return expr;
		      }
		      var self = this;
		      var result;
		      var after;
		      function finish(expr) {
		        t.assertExpression(expr);
		        if (ignoreResult) {
		          self.emit(expr);
		        }
		        return expr;
		      }
		      if (!meta.containsLeap(expr)) {
		        return finish(expr);
		      }
		      var hasLeapingChildren = meta.containsLeap.onlyChildren(expr);
		      switch (expr.type) {
		        case "MemberExpression":
		          return finish(t.memberExpression(self.explodeExpression(path.get("object")), expr.computed ? self.explodeViaTempVar(null, path.get("property"), hasLeapingChildren) : expr.property, expr.computed));
		        case "CallExpression":
		          var calleePath = path.get("callee");
		          var argsPath = path.get("arguments");
		          var newCallee;
		          var newArgs;
		          var hasLeapingArgs = argsPath.some(function (argPath) {
		            return meta.containsLeap(argPath.node);
		          });
		          var injectFirstArg = null;
		          if (t.isMemberExpression(calleePath.node)) {
		            if (hasLeapingArgs) {
		              var newObject = self.explodeViaTempVar(self.makeTempVar(), calleePath.get("object"), hasLeapingChildren);
		              var newProperty = calleePath.node.computed ? self.explodeViaTempVar(null, calleePath.get("property"), hasLeapingChildren) : calleePath.node.property;
		              injectFirstArg = newObject;
		              newCallee = t.memberExpression(t.memberExpression(t.cloneDeep(newObject), newProperty, calleePath.node.computed), t.identifier("call"), false);
		            } else {
		              newCallee = self.explodeExpression(calleePath);
		            }
		          } else {
		            newCallee = self.explodeViaTempVar(null, calleePath, hasLeapingChildren);
		            if (t.isMemberExpression(newCallee)) {
		              newCallee = t.sequenceExpression([t.numericLiteral(0), t.cloneDeep(newCallee)]);
		            }
		          }
		          if (hasLeapingArgs) {
		            newArgs = argsPath.map(function (argPath) {
		              return self.explodeViaTempVar(null, argPath, hasLeapingChildren);
		            });
		            if (injectFirstArg) newArgs.unshift(injectFirstArg);
		            newArgs = newArgs.map(function (arg) {
		              return t.cloneDeep(arg);
		            });
		          } else {
		            newArgs = path.node.arguments;
		          }
		          return finish(t.callExpression(newCallee, newArgs));
		        case "NewExpression":
		          return finish(t.newExpression(self.explodeViaTempVar(null, path.get("callee"), hasLeapingChildren), path.get("arguments").map(function (argPath) {
		            return self.explodeViaTempVar(null, argPath, hasLeapingChildren);
		          })));
		        case "ObjectExpression":
		          return finish(t.objectExpression(path.get("properties").map(function (propPath) {
		            if (propPath.isObjectProperty()) {
		              return t.objectProperty(propPath.node.key, self.explodeViaTempVar(null, propPath.get("value"), hasLeapingChildren), propPath.node.computed);
		            } else {
		              return propPath.node;
		            }
		          })));
		        case "ArrayExpression":
		          return finish(t.arrayExpression(path.get("elements").map(function (elemPath) {
		            if (!elemPath.node) {
		              return null;
		            }
		            if (elemPath.isSpreadElement()) {
		              return t.spreadElement(self.explodeViaTempVar(null, elemPath.get("argument"), hasLeapingChildren));
		            } else {
		              return self.explodeViaTempVar(null, elemPath, hasLeapingChildren);
		            }
		          })));
		        case "SequenceExpression":
		          var lastIndex = expr.expressions.length - 1;
		          path.get("expressions").forEach(function (exprPath) {
		            if (exprPath.key === lastIndex) {
		              result = self.explodeExpression(exprPath, ignoreResult);
		            } else {
		              self.explodeExpression(exprPath, true);
		            }
		          });
		          return result;
		        case "LogicalExpression":
		          after = this.loc();
		          if (!ignoreResult) {
		            result = self.makeTempVar();
		          }
		          var left = self.explodeViaTempVar(result, path.get("left"), hasLeapingChildren);
		          if (expr.operator === "&&") {
		            self.jumpIfNot(left, after);
		          } else {
		            _assert["default"].strictEqual(expr.operator, "||");
		            self.jumpIf(left, after);
		          }
		          self.explodeViaTempVar(result, path.get("right"), hasLeapingChildren, ignoreResult);
		          self.mark(after);
		          return result;
		        case "ConditionalExpression":
		          var elseLoc = this.loc();
		          after = this.loc();
		          var test = self.explodeExpression(path.get("test"));
		          self.jumpIfNot(test, elseLoc);
		          if (!ignoreResult) {
		            result = self.makeTempVar();
		          }
		          self.explodeViaTempVar(result, path.get("consequent"), hasLeapingChildren, ignoreResult);
		          self.jump(after);
		          self.mark(elseLoc);
		          self.explodeViaTempVar(result, path.get("alternate"), hasLeapingChildren, ignoreResult);
		          self.mark(after);
		          return result;
		        case "UnaryExpression":
		          return finish(t.unaryExpression(expr.operator, self.explodeExpression(path.get("argument")), !!expr.prefix));
		        case "BinaryExpression":
		          return finish(t.binaryExpression(expr.operator, self.explodeViaTempVar(null, path.get("left"), hasLeapingChildren), self.explodeViaTempVar(null, path.get("right"), hasLeapingChildren)));
		        case "AssignmentExpression":
		          if (expr.operator === "=") {
		            return finish(t.assignmentExpression(expr.operator, self.explodeExpression(path.get("left")), self.explodeExpression(path.get("right"))));
		          }
		          var lhs = self.explodeExpression(path.get("left"));
		          var temp = self.emitAssign(self.makeTempVar(), lhs);
		          return finish(t.assignmentExpression("=", t.cloneDeep(lhs), t.assignmentExpression(expr.operator, t.cloneDeep(temp), self.explodeExpression(path.get("right")))));
		        case "UpdateExpression":
		          return finish(t.updateExpression(expr.operator, self.explodeExpression(path.get("argument")), expr.prefix));
		        case "YieldExpression":
		          after = this.loc();
		          var arg = expr.argument && self.explodeExpression(path.get("argument"));
		          if (arg && expr.delegate) {
		            var _result = self.makeTempVar();
		            var _ret = t.returnStatement(t.callExpression(self.contextProperty("delegateYield"), [arg, t.stringLiteral(_result.property.name), after]));
		            _ret.loc = expr.loc;
		            self.emit(_ret);
		            self.mark(after);
		            return _result;
		          }
		          self.emitAssign(self.contextProperty("next"), after);
		          var ret = t.returnStatement(t.cloneDeep(arg) || null);
		          ret.loc = expr.loc;
		          self.emit(ret);
		          self.mark(after);
		          return self.contextProperty("sent");
		        case "ClassExpression":
		          return finish(self.explodeClass(path));
		        default:
		          throw new Error("unknown Expression of type " + JSON.stringify(expr.type));
		      }
		    };
		    Ep.explodeClass = function (path) {
		      var explodingChildren = [];
		      if (path.node.superClass) {
		        explodingChildren.push(path.get("superClass"));
		      }
		      path.get("body.body").forEach(function (member) {
		        if (member.node.computed) {
		          explodingChildren.push(member.get("key"));
		        }
		      });
		      var hasLeapingChildren = explodingChildren.some(function (child) {
		        return meta.containsLeap(child);
		      });
		      for (var i = 0; i < explodingChildren.length; i++) {
		        var child = explodingChildren[i];
		        var isLast = i === explodingChildren.length - 1;
		        if (isLast) {
		          child.replaceWith(this.explodeExpression(child));
		        } else {
		          child.replaceWith(this.explodeViaTempVar(null, child, hasLeapingChildren));
		        }
		      }
		      return path.node;
		    };
		    return emit;
		  }

		  var replaceShorthandObjectMethod = {};

		  var hasRequiredReplaceShorthandObjectMethod;
		  function requireReplaceShorthandObjectMethod() {
		    if (hasRequiredReplaceShorthandObjectMethod) return replaceShorthandObjectMethod;
		    hasRequiredReplaceShorthandObjectMethod = 1;
		    (function (exports) {

		      exports.__esModule = true;
		      exports["default"] = replaceShorthandObjectMethod;
		      var util = _interopRequireWildcard(requireUtil());
		      function _getRequireWildcardCache(nodeInterop) {
		        if (typeof WeakMap !== "function") return null;
		        var cacheBabelInterop = new WeakMap();
		        var cacheNodeInterop = new WeakMap();
		        return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) {
		          return nodeInterop ? cacheNodeInterop : cacheBabelInterop;
		        })(nodeInterop);
		      }
		      function _interopRequireWildcard(obj, nodeInterop) {
		        if (!nodeInterop && obj && obj.__esModule) {
		          return obj;
		        }
		        if (obj === null || typeof obj !== "object" && typeof obj !== "function") {
		          return {
		            "default": obj
		          };
		        }
		        var cache = _getRequireWildcardCache(nodeInterop);
		        if (cache && cache.has(obj)) {
		          return cache.get(obj);
		        }
		        var newObj = {};
		        var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
		        for (var key in obj) {
		          if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) {
		            var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
		            if (desc && (desc.get || desc.set)) {
		              Object.defineProperty(newObj, key, desc);
		            } else {
		              newObj[key] = obj[key];
		            }
		          }
		        }
		        newObj["default"] = obj;
		        if (cache) {
		          cache.set(obj, newObj);
		        }
		        return newObj;
		      }
		      function replaceShorthandObjectMethod(path) {
		        var t = util.getTypes();
		        if (!path.node || !t.isFunction(path.node)) {
		          throw new Error("replaceShorthandObjectMethod can only be called on Function AST node paths.");
		        }
		        if (!t.isObjectMethod(path.node)) {
		          return path;
		        }
		        if (!path.node.generator) {
		          return path;
		        }
		        var parameters = path.node.params.map(function (param) {
		          return t.cloneDeep(param);
		        });
		        var functionExpression = t.functionExpression(null, parameters, t.cloneDeep(path.node.body), path.node.generator, path.node.async);
		        util.replaceWithOrRemove(path, t.objectProperty(t.cloneDeep(path.node.key), functionExpression, path.node.computed, false));
		        return path.get("value");
		      }
		    })(replaceShorthandObjectMethod);
		    return replaceShorthandObjectMethod;
		  }

		  var _interopRequireDefault = interopRequireDefaultExports;
		  var _assert = _interopRequireDefault(require$$1$2);
		  var _hoist = requireHoist();
		  var _emit = requireEmit();
		  var _replaceShorthandObjectMethod = _interopRequireDefault(requireReplaceShorthandObjectMethod());
		  var util = _interopRequireWildcard(requireUtil());
		  function _getRequireWildcardCache(nodeInterop) {
		    if (typeof WeakMap !== "function") return null;
		    var cacheBabelInterop = new WeakMap();
		    var cacheNodeInterop = new WeakMap();
		    return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) {
		      return nodeInterop ? cacheNodeInterop : cacheBabelInterop;
		    })(nodeInterop);
		  }
		  function _interopRequireWildcard(obj, nodeInterop) {
		    if (!nodeInterop && obj && obj.__esModule) {
		      return obj;
		    }
		    if (obj === null || typeof obj !== "object" && typeof obj !== "function") {
		      return {
		        "default": obj
		      };
		    }
		    var cache = _getRequireWildcardCache(nodeInterop);
		    if (cache && cache.has(obj)) {
		      return cache.get(obj);
		    }
		    var newObj = {};
		    var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
		    for (var key in obj) {
		      if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) {
		        var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
		        if (desc && (desc.get || desc.set)) {
		          Object.defineProperty(newObj, key, desc);
		        } else {
		          newObj[key] = obj[key];
		        }
		      }
		    }
		    newObj["default"] = obj;
		    if (cache) {
		      cache.set(obj, newObj);
		    }
		    return newObj;
		  }
		  visit.getVisitor = function (_ref) {
		    var t = _ref.types;
		    return {
		      Method: function Method(path, state) {
		        var node = path.node;
		        if (!shouldRegenerate(node, state)) return;
		        var container = t.functionExpression(null, [], t.cloneNode(node.body, false), node.generator, node.async);
		        path.get("body").set("body", [t.returnStatement(t.callExpression(container, []))]);
		        node.async = false;
		        node.generator = false;
		        path.get("body.body.0.argument.callee").unwrapFunctionEnvironment();
		      },
		      Function: {
		        exit: util.wrapWithTypes(t, function (path, state) {
		          var node = path.node;
		          if (!shouldRegenerate(node, state)) return;
		          path = (0, _replaceShorthandObjectMethod["default"])(path);
		          node = path.node;
		          var contextId = path.scope.generateUidIdentifier("context");
		          var argsId = path.scope.generateUidIdentifier("args");
		          path.ensureBlock();
		          var bodyBlockPath = path.get("body");
		          if (node.async) {
		            bodyBlockPath.traverse(awaitVisitor);
		          }
		          bodyBlockPath.traverse(functionSentVisitor, {
		            context: contextId
		          });
		          var outerBody = [];
		          var innerBody = [];
		          bodyBlockPath.get("body").forEach(function (childPath) {
		            var node = childPath.node;
		            if (t.isExpressionStatement(node) && t.isStringLiteral(node.expression)) {
		              outerBody.push(node);
		            } else if (node && node._blockHoist != null) {
		              outerBody.push(node);
		            } else {
		              innerBody.push(node);
		            }
		          });
		          if (outerBody.length > 0) {
		            bodyBlockPath.node.body = innerBody;
		          }
		          var outerFnExpr = getOuterFnExpr(path);
		          t.assertIdentifier(node.id);
		          var innerFnId = t.identifier(node.id.name + "$");
		          var vars = (0, _hoist.hoist)(path);
		          var context = {
		            usesThis: false,
		            usesArguments: false,
		            getArgsId: function getArgsId() {
		              return t.clone(argsId);
		            }
		          };
		          path.traverse(argumentsThisVisitor, context);
		          if (context.usesArguments) {
		            vars = vars || t.variableDeclaration("var", []);
		            vars.declarations.push(t.variableDeclarator(t.clone(argsId), t.identifier("arguments")));
		          }
		          var emitter = new _emit.Emitter(contextId);
		          emitter.explode(path.get("body"));
		          if (vars && vars.declarations.length > 0) {
		            outerBody.push(vars);
		          }
		          var wrapArgs = [emitter.getContextFunction(innerFnId)];
		          var tryLocsList = emitter.getTryLocsList();
		          if (node.generator) {
		            wrapArgs.push(outerFnExpr);
		          } else if (context.usesThis || tryLocsList || node.async) {
		            wrapArgs.push(t.nullLiteral());
		          }
		          if (context.usesThis) {
		            wrapArgs.push(t.thisExpression());
		          } else if (tryLocsList || node.async) {
		            wrapArgs.push(t.nullLiteral());
		          }
		          if (tryLocsList) {
		            wrapArgs.push(tryLocsList);
		          } else if (node.async) {
		            wrapArgs.push(t.nullLiteral());
		          }
		          if (node.async) {
		            var currentScope = path.scope;
		            do {
		              if (currentScope.hasOwnBinding("Promise")) currentScope.rename("Promise");
		            } while (currentScope = currentScope.parent);
		            wrapArgs.push(t.identifier("Promise"));
		          }
		          var wrapCall = t.callExpression(util.runtimeProperty(node.async ? "async" : "wrap"), wrapArgs);
		          outerBody.push(t.returnStatement(wrapCall));
		          node.body = t.blockStatement(outerBody);
		          path.get("body.body").forEach(function (p) {
		            return p.scope.registerDeclaration(p);
		          });
		          var oldDirectives = bodyBlockPath.node.directives;
		          if (oldDirectives) {
		            node.body.directives = oldDirectives;
		          }
		          var wasGeneratorFunction = node.generator;
		          if (wasGeneratorFunction) {
		            node.generator = false;
		          }
		          if (node.async) {
		            node.async = false;
		          }
		          if (wasGeneratorFunction && t.isExpression(node)) {
		            util.replaceWithOrRemove(path, t.callExpression(util.runtimeProperty("mark"), [node]));
		            path.addComment("leading", "#__PURE__");
		          }
		          var insertedLocs = emitter.getInsertedLocs();
		          path.traverse({
		            NumericLiteral: function NumericLiteral(path) {
		              if (!insertedLocs.has(path.node)) {
		                return;
		              }
		              path.replaceWith(t.numericLiteral(path.node.value));
		            }
		          });
		          path.requeue();
		        })
		      }
		    };
		  };
		  function shouldRegenerate(node, state) {
		    if (node.generator) {
		      if (node.async) {
		        return state.opts.asyncGenerators !== false;
		      } else {
		        return state.opts.generators !== false;
		      }
		    } else if (node.async) {
		      return state.opts.async !== false;
		    } else {
		      return false;
		    }
		  }
		  function getOuterFnExpr(funPath) {
		    var t = util.getTypes();
		    var node = funPath.node;
		    t.assertFunction(node);
		    if (!node.id) {
		      node.id = funPath.scope.parent.generateUidIdentifier("callee");
		    }
		    if (node.generator && t.isFunctionDeclaration(node)) {
		      return getMarkedFunctionId(funPath);
		    }
		    return t.clone(node.id);
		  }
		  var markInfo = new WeakMap();
		  function getMarkInfo(node) {
		    if (!markInfo.has(node)) {
		      markInfo.set(node, {});
		    }
		    return markInfo.get(node);
		  }
		  function getMarkedFunctionId(funPath) {
		    var t = util.getTypes();
		    var node = funPath.node;
		    t.assertIdentifier(node.id);
		    var blockPath = funPath.findParent(function (path) {
		      return path.isProgram() || path.isBlockStatement();
		    });
		    if (!blockPath) {
		      return node.id;
		    }
		    var block = blockPath.node;
		    _assert["default"].ok(Array.isArray(block.body));
		    var info = getMarkInfo(block);
		    if (!info.decl) {
		      info.decl = t.variableDeclaration("var", []);
		      blockPath.unshiftContainer("body", info.decl);
		      info.declPath = blockPath.get("body.0");
		    }
		    _assert["default"].strictEqual(info.declPath.node, info.decl);
		    var markedId = blockPath.scope.generateUidIdentifier("marked");
		    var markCallExp = t.callExpression(util.runtimeProperty("mark"), [t.clone(node.id)]);
		    var index = info.decl.declarations.push(t.variableDeclarator(markedId, markCallExp)) - 1;
		    var markCallExpPath = info.declPath.get("declarations." + index + ".init");
		    _assert["default"].strictEqual(markCallExpPath.node, markCallExp);
		    markCallExpPath.addComment("leading", "#__PURE__");
		    return t.clone(markedId);
		  }
		  var argumentsThisVisitor = {
		    "FunctionExpression|FunctionDeclaration|Method": function FunctionExpressionFunctionDeclarationMethod(path) {
		      path.skip();
		    },
		    Identifier: function Identifier(path, state) {
		      if (path.node.name === "arguments" && util.isReference(path)) {
		        util.replaceWithOrRemove(path, state.getArgsId());
		        state.usesArguments = true;
		      }
		    },
		    ThisExpression: function ThisExpression(path, state) {
		      state.usesThis = true;
		    }
		  };
		  var functionSentVisitor = {
		    MetaProperty: function MetaProperty(path) {
		      var node = path.node;
		      if (node.meta.name === "function" && node.property.name === "sent") {
		        var t = util.getTypes();
		        util.replaceWithOrRemove(path, t.memberExpression(t.clone(this.context), t.identifier("_sent")));
		      }
		    }
		  };
		  var awaitVisitor = {
		    Function: function Function(path) {
		      path.skip();
		    },
		    AwaitExpression: function AwaitExpression(path) {
		      var t = util.getTypes();
		      var argument = path.node.argument;
		      util.replaceWithOrRemove(path, t.yieldExpression(t.callExpression(util.runtimeProperty("awrap"), [argument]), false));
		    }
		  };

		  (function (exports) {

		    exports.__esModule = true;
		    exports["default"] = _default;
		    var _visit = visit;
		    function _default(context) {
		      var plugin = {
		        visitor: (0, _visit.getVisitor)(context)
		      };
		      var version = context && context.version;
		      if (version && parseInt(version, 10) >= 7) {
		        plugin.name = "regenerator-transform";
		      }
		      return plugin;
		    }
		  })(lib$7);

		  var _transformRegenerator = declare(function (_ref) {
		    var t = _ref.types,
		      assertVersion = _ref.assertVersion;
		    assertVersion("*");
		    return {
		      name: "transform-regenerator",
		      inherits: lib$7["default"],
		      visitor: {
		        CallExpression: function CallExpression(path) {
		          {
		            var _this$availableHelper;
		            if (!((_this$availableHelper = this.availableHelper) != null && _this$availableHelper.call(this, "regeneratorRuntime"))) {
		              return;
		            }
		          }
		          var callee = path.get("callee");
		          if (!callee.isMemberExpression()) return;
		          var obj = callee.get("object");
		          if (obj.isIdentifier({
		            name: "regeneratorRuntime"
		          })) {
		            var helper = this.addHelper("regeneratorRuntime");
		            {
		              if (t.isArrowFunctionExpression(helper)) {
		                obj.replaceWith(helper.body);
		                return;
		              }
		            }
		            obj.replaceWith(t.callExpression(helper, []));
		          }
		        }
		      }
		    };
		  });

		  var _transformReservedWords = declare(function (api) {
		    api.assertVersion("*");
		    return {
		      name: "transform-reserved-words",
		      visitor: {
		        "BindingIdentifier|ReferencedIdentifier": function BindingIdentifierReferencedIdentifier(path) {
		          if (!isValidES3Identifier(path.node.name)) {
		            path.scope.rename(path.node.name);
		          }
		        }
		      }
		    };
		  });

		  function bool$1(value) {
		    if (value == null) return false;
		    return value && value !== "false" && value !== "0";
		  }
		  var semver$5 = bool$1(browser$1$1.env["BABEL_8_BREAKING"]) ? requireSemver$2() : requireSemver$2();

		  function hasMinVersion(minVersion, runtimeVersion) {
		    if (!runtimeVersion) return true;
		    if (semver$5.valid(runtimeVersion)) runtimeVersion = "^" + runtimeVersion;
		    return !semver$5.intersects("<" + minVersion, runtimeVersion) && !semver$5.intersects(">=8.0.0", runtimeVersion);
		  }

		  function getRuntimePath (moduleName, dirname, absoluteRuntime) {
		    if (absoluteRuntime === false) return moduleName;
		    resolveFSPath();
		  }
		  function resolveFSPath() {
		    throw new Error("The 'absoluteRuntime' option is not supported when using @babel/standalone.");
		  }

		  var babel7 = {};

		  var lib$6 = {};

		  var require$$0$5 = {
		  	"es6.array.copy-within": {
		  	chrome: "45",
		  	opera: "32",
		  	edge: "12",
		  	firefox: "32",
		  	safari: "9",
		  	node: "4",
		  	deno: "1",
		  	ios: "9",
		  	samsung: "5",
		  	rhino: "1.7.13",
		  	opera_mobile: "32",
		  	electron: "0.31"
		  },
		  	"es6.array.every": {
		  	chrome: "5",
		  	opera: "10.10",
		  	edge: "12",
		  	firefox: "2",
		  	safari: "3.1",
		  	node: "0.4",
		  	deno: "1",
		  	ie: "9",
		  	android: "4",
		  	ios: "6",
		  	phantom: "1.9",
		  	samsung: "1",
		  	rhino: "1.7.13",
		  	opera_mobile: "10.1",
		  	electron: "0.20"
		  },
		  	"es6.array.fill": {
		  	chrome: "45",
		  	opera: "32",
		  	edge: "12",
		  	firefox: "31",
		  	safari: "7.1",
		  	node: "4",
		  	deno: "1",
		  	ios: "8",
		  	samsung: "5",
		  	rhino: "1.7.13",
		  	opera_mobile: "32",
		  	electron: "0.31"
		  },
		  	"es6.array.filter": {
		  	chrome: "51",
		  	opera: "38",
		  	edge: "13",
		  	firefox: "48",
		  	safari: "10",
		  	node: "6.5",
		  	deno: "1",
		  	ios: "10",
		  	samsung: "5",
		  	opera_mobile: "41",
		  	electron: "1.2"
		  },
		  	"es6.array.find": {
		  	chrome: "45",
		  	opera: "32",
		  	edge: "12",
		  	firefox: "25",
		  	safari: "7.1",
		  	node: "4",
		  	deno: "1",
		  	ios: "8",
		  	samsung: "5",
		  	rhino: "1.7.13",
		  	opera_mobile: "32",
		  	electron: "0.31"
		  },
		  	"es6.array.find-index": {
		  	chrome: "45",
		  	opera: "32",
		  	edge: "12",
		  	firefox: "25",
		  	safari: "7.1",
		  	node: "4",
		  	deno: "1",
		  	ios: "8",
		  	samsung: "5",
		  	rhino: "1.7.13",
		  	opera_mobile: "32",
		  	electron: "0.31"
		  },
		  	"es7.array.flat-map": {
		  	chrome: "69",
		  	opera: "56",
		  	edge: "79",
		  	firefox: "62",
		  	safari: "12",
		  	node: "11",
		  	deno: "1",
		  	ios: "12",
		  	samsung: "10",
		  	opera_mobile: "48",
		  	electron: "4.0"
		  },
		  	"es6.array.for-each": {
		  	chrome: "5",
		  	opera: "10.10",
		  	edge: "12",
		  	firefox: "2",
		  	safari: "3.1",
		  	node: "0.4",
		  	deno: "1",
		  	ie: "9",
		  	android: "4",
		  	ios: "6",
		  	phantom: "1.9",
		  	samsung: "1",
		  	rhino: "1.7.13",
		  	opera_mobile: "10.1",
		  	electron: "0.20"
		  },
		  	"es6.array.from": {
		  	chrome: "51",
		  	opera: "38",
		  	edge: "15",
		  	firefox: "36",
		  	safari: "10",
		  	node: "6.5",
		  	deno: "1",
		  	ios: "10",
		  	samsung: "5",
		  	opera_mobile: "41",
		  	electron: "1.2"
		  },
		  	"es7.array.includes": {
		  	chrome: "47",
		  	opera: "34",
		  	edge: "14",
		  	firefox: "102",
		  	safari: "10",
		  	node: "6",
		  	deno: "1",
		  	ios: "10",
		  	samsung: "5",
		  	opera_mobile: "34",
		  	electron: "0.36"
		  },
		  	"es6.array.index-of": {
		  	chrome: "5",
		  	opera: "10.10",
		  	edge: "12",
		  	firefox: "2",
		  	safari: "3.1",
		  	node: "0.4",
		  	deno: "1",
		  	ie: "9",
		  	android: "4",
		  	ios: "6",
		  	phantom: "1.9",
		  	samsung: "1",
		  	rhino: "1.7.13",
		  	opera_mobile: "10.1",
		  	electron: "0.20"
		  },
		  	"es6.array.is-array": {
		  	chrome: "5",
		  	opera: "10.50",
		  	edge: "12",
		  	firefox: "4",
		  	safari: "4",
		  	node: "0.4",
		  	deno: "1",
		  	ie: "9",
		  	android: "4",
		  	ios: "6",
		  	phantom: "1.9",
		  	samsung: "1",
		  	rhino: "1.7.13",
		  	opera_mobile: "10.1",
		  	electron: "0.20"
		  },
		  	"es6.array.iterator": {
		  	chrome: "66",
		  	opera: "53",
		  	edge: "12",
		  	firefox: "60",
		  	safari: "9",
		  	node: "10",
		  	deno: "1",
		  	ios: "9",
		  	samsung: "9",
		  	rhino: "1.7.13",
		  	opera_mobile: "47",
		  	electron: "3.0"
		  },
		  	"es6.array.last-index-of": {
		  	chrome: "5",
		  	opera: "10.10",
		  	edge: "12",
		  	firefox: "2",
		  	safari: "3.1",
		  	node: "0.4",
		  	deno: "1",
		  	ie: "9",
		  	android: "4",
		  	ios: "6",
		  	phantom: "1.9",
		  	samsung: "1",
		  	rhino: "1.7.13",
		  	opera_mobile: "10.1",
		  	electron: "0.20"
		  },
		  	"es6.array.map": {
		  	chrome: "51",
		  	opera: "38",
		  	edge: "13",
		  	firefox: "48",
		  	safari: "10",
		  	node: "6.5",
		  	deno: "1",
		  	ios: "10",
		  	samsung: "5",
		  	opera_mobile: "41",
		  	electron: "1.2"
		  },
		  	"es6.array.of": {
		  	chrome: "45",
		  	opera: "32",
		  	edge: "12",
		  	firefox: "25",
		  	safari: "9",
		  	node: "4",
		  	deno: "1",
		  	ios: "9",
		  	samsung: "5",
		  	rhino: "1.7.13",
		  	opera_mobile: "32",
		  	electron: "0.31"
		  },
		  	"es6.array.reduce": {
		  	chrome: "5",
		  	opera: "10.50",
		  	edge: "12",
		  	firefox: "3",
		  	safari: "4",
		  	node: "0.4",
		  	deno: "1",
		  	ie: "9",
		  	android: "4",
		  	ios: "6",
		  	phantom: "1.9",
		  	samsung: "1",
		  	rhino: "1.7.13",
		  	opera_mobile: "10.1",
		  	electron: "0.20"
		  },
		  	"es6.array.reduce-right": {
		  	chrome: "5",
		  	opera: "10.50",
		  	edge: "12",
		  	firefox: "3",
		  	safari: "4",
		  	node: "0.4",
		  	deno: "1",
		  	ie: "9",
		  	android: "4",
		  	ios: "6",
		  	phantom: "1.9",
		  	samsung: "1",
		  	rhino: "1.7.13",
		  	opera_mobile: "10.1",
		  	electron: "0.20"
		  },
		  	"es6.array.slice": {
		  	chrome: "51",
		  	opera: "38",
		  	edge: "13",
		  	firefox: "48",
		  	safari: "10",
		  	node: "6.5",
		  	deno: "1",
		  	ios: "10",
		  	samsung: "5",
		  	opera_mobile: "41",
		  	electron: "1.2"
		  },
		  	"es6.array.some": {
		  	chrome: "5",
		  	opera: "10.10",
		  	edge: "12",
		  	firefox: "2",
		  	safari: "3.1",
		  	node: "0.4",
		  	deno: "1",
		  	ie: "9",
		  	android: "4",
		  	ios: "6",
		  	phantom: "1.9",
		  	samsung: "1",
		  	rhino: "1.7.13",
		  	opera_mobile: "10.1",
		  	electron: "0.20"
		  },
		  	"es6.array.sort": {
		  	chrome: "63",
		  	opera: "50",
		  	edge: "12",
		  	firefox: "5",
		  	safari: "12",
		  	node: "10",
		  	deno: "1",
		  	ie: "9",
		  	ios: "12",
		  	samsung: "8",
		  	rhino: "1.7.13",
		  	opera_mobile: "46",
		  	electron: "3.0"
		  },
		  	"es6.array.species": {
		  	chrome: "51",
		  	opera: "38",
		  	edge: "13",
		  	firefox: "48",
		  	safari: "10",
		  	node: "6.5",
		  	deno: "1",
		  	ios: "10",
		  	samsung: "5",
		  	opera_mobile: "41",
		  	electron: "1.2"
		  },
		  	"es6.date.now": {
		  	chrome: "5",
		  	opera: "10.50",
		  	edge: "12",
		  	firefox: "2",
		  	safari: "4",
		  	node: "0.4",
		  	deno: "1",
		  	ie: "9",
		  	android: "4",
		  	ios: "6",
		  	phantom: "1.9",
		  	samsung: "1",
		  	rhino: "1.7.13",
		  	opera_mobile: "10.1",
		  	electron: "0.20"
		  },
		  	"es6.date.to-iso-string": {
		  	chrome: "5",
		  	opera: "10.50",
		  	edge: "12",
		  	firefox: "3.5",
		  	safari: "4",
		  	node: "0.4",
		  	deno: "1",
		  	ie: "9",
		  	android: "4",
		  	ios: "6",
		  	phantom: "1.9",
		  	samsung: "1",
		  	rhino: "1.7.13",
		  	opera_mobile: "10.1",
		  	electron: "0.20"
		  },
		  	"es6.date.to-json": {
		  	chrome: "5",
		  	opera: "12.10",
		  	edge: "12",
		  	firefox: "4",
		  	safari: "10",
		  	node: "0.4",
		  	deno: "1",
		  	ie: "9",
		  	android: "4",
		  	ios: "10",
		  	samsung: "1",
		  	rhino: "1.7.13",
		  	opera_mobile: "12.1",
		  	electron: "0.20"
		  },
		  	"es6.date.to-primitive": {
		  	chrome: "47",
		  	opera: "34",
		  	edge: "15",
		  	firefox: "44",
		  	safari: "10",
		  	node: "6",
		  	deno: "1",
		  	ios: "10",
		  	samsung: "5",
		  	opera_mobile: "34",
		  	electron: "0.36"
		  },
		  	"es6.date.to-string": {
		  	chrome: "5",
		  	opera: "10.50",
		  	edge: "12",
		  	firefox: "2",
		  	safari: "3.1",
		  	node: "0.4",
		  	deno: "1",
		  	ie: "10",
		  	android: "4",
		  	ios: "6",
		  	phantom: "1.9",
		  	samsung: "1",
		  	rhino: "1.7.13",
		  	opera_mobile: "10.1",
		  	electron: "0.20"
		  },
		  	"es6.function.bind": {
		  	chrome: "7",
		  	opera: "12",
		  	edge: "12",
		  	firefox: "4",
		  	safari: "5.1",
		  	node: "0.4",
		  	deno: "1",
		  	ie: "9",
		  	android: "4",
		  	ios: "6",
		  	phantom: "1.9",
		  	samsung: "1",
		  	rhino: "1.7.13",
		  	opera_mobile: "12",
		  	electron: "0.20"
		  },
		  	"es6.function.has-instance": {
		  	chrome: "51",
		  	opera: "38",
		  	edge: "15",
		  	firefox: "50",
		  	safari: "10",
		  	node: "6.5",
		  	deno: "1",
		  	ios: "10",
		  	samsung: "5",
		  	opera_mobile: "41",
		  	electron: "1.2"
		  },
		  	"es6.function.name": {
		  	chrome: "5",
		  	opera: "10.50",
		  	edge: "14",
		  	firefox: "2",
		  	safari: "4",
		  	node: "0.4",
		  	deno: "1",
		  	android: "4",
		  	ios: "6",
		  	phantom: "1.9",
		  	samsung: "1",
		  	rhino: "1.7.13",
		  	opera_mobile: "10.1",
		  	electron: "0.20"
		  },
		  	"es6.map": {
		  	chrome: "51",
		  	opera: "38",
		  	edge: "15",
		  	firefox: "53",
		  	safari: "10",
		  	node: "6.5",
		  	deno: "1",
		  	ios: "10",
		  	samsung: "5",
		  	opera_mobile: "41",
		  	electron: "1.2"
		  },
		  	"es6.math.acosh": {
		  	chrome: "38",
		  	opera: "25",
		  	edge: "12",
		  	firefox: "25",
		  	safari: "7.1",
		  	node: "0.12",
		  	deno: "1",
		  	ios: "8",
		  	samsung: "3",
		  	rhino: "1.7.13",
		  	opera_mobile: "25",
		  	electron: "0.20"
		  },
		  	"es6.math.asinh": {
		  	chrome: "38",
		  	opera: "25",
		  	edge: "12",
		  	firefox: "25",
		  	safari: "7.1",
		  	node: "0.12",
		  	deno: "1",
		  	ios: "8",
		  	samsung: "3",
		  	rhino: "1.7.13",
		  	opera_mobile: "25",
		  	electron: "0.20"
		  },
		  	"es6.math.atanh": {
		  	chrome: "38",
		  	opera: "25",
		  	edge: "12",
		  	firefox: "25",
		  	safari: "7.1",
		  	node: "0.12",
		  	deno: "1",
		  	ios: "8",
		  	samsung: "3",
		  	rhino: "1.7.13",
		  	opera_mobile: "25",
		  	electron: "0.20"
		  },
		  	"es6.math.cbrt": {
		  	chrome: "38",
		  	opera: "25",
		  	edge: "12",
		  	firefox: "25",
		  	safari: "7.1",
		  	node: "0.12",
		  	deno: "1",
		  	ios: "8",
		  	samsung: "3",
		  	rhino: "1.7.13",
		  	opera_mobile: "25",
		  	electron: "0.20"
		  },
		  	"es6.math.clz32": {
		  	chrome: "38",
		  	opera: "25",
		  	edge: "12",
		  	firefox: "31",
		  	safari: "9",
		  	node: "0.12",
		  	deno: "1",
		  	ios: "9",
		  	samsung: "3",
		  	rhino: "1.7.13",
		  	opera_mobile: "25",
		  	electron: "0.20"
		  },
		  	"es6.math.cosh": {
		  	chrome: "38",
		  	opera: "25",
		  	edge: "12",
		  	firefox: "25",
		  	safari: "7.1",
		  	node: "0.12",
		  	deno: "1",
		  	ios: "8",
		  	samsung: "3",
		  	rhino: "1.7.13",
		  	opera_mobile: "25",
		  	electron: "0.20"
		  },
		  	"es6.math.expm1": {
		  	chrome: "38",
		  	opera: "25",
		  	edge: "12",
		  	firefox: "25",
		  	safari: "7.1",
		  	node: "0.12",
		  	deno: "1",
		  	ios: "8",
		  	samsung: "3",
		  	rhino: "1.7.13",
		  	opera_mobile: "25",
		  	electron: "0.20"
		  },
		  	"es6.math.fround": {
		  	chrome: "38",
		  	opera: "25",
		  	edge: "12",
		  	firefox: "26",
		  	safari: "7.1",
		  	node: "0.12",
		  	deno: "1",
		  	ios: "8",
		  	samsung: "3",
		  	rhino: "1.7.13",
		  	opera_mobile: "25",
		  	electron: "0.20"
		  },
		  	"es6.math.hypot": {
		  	chrome: "38",
		  	opera: "25",
		  	edge: "12",
		  	firefox: "27",
		  	safari: "7.1",
		  	node: "0.12",
		  	deno: "1",
		  	ios: "8",
		  	samsung: "3",
		  	rhino: "1.7.13",
		  	opera_mobile: "25",
		  	electron: "0.20"
		  },
		  	"es6.math.imul": {
		  	chrome: "30",
		  	opera: "17",
		  	edge: "12",
		  	firefox: "23",
		  	safari: "7",
		  	node: "0.12",
		  	deno: "1",
		  	android: "4.4",
		  	ios: "7",
		  	samsung: "2",
		  	rhino: "1.7.13",
		  	opera_mobile: "18",
		  	electron: "0.20"
		  },
		  	"es6.math.log1p": {
		  	chrome: "38",
		  	opera: "25",
		  	edge: "12",
		  	firefox: "25",
		  	safari: "7.1",
		  	node: "0.12",
		  	deno: "1",
		  	ios: "8",
		  	samsung: "3",
		  	rhino: "1.7.13",
		  	opera_mobile: "25",
		  	electron: "0.20"
		  },
		  	"es6.math.log10": {
		  	chrome: "38",
		  	opera: "25",
		  	edge: "12",
		  	firefox: "25",
		  	safari: "7.1",
		  	node: "0.12",
		  	deno: "1",
		  	ios: "8",
		  	samsung: "3",
		  	rhino: "1.7.13",
		  	opera_mobile: "25",
		  	electron: "0.20"
		  },
		  	"es6.math.log2": {
		  	chrome: "38",
		  	opera: "25",
		  	edge: "12",
		  	firefox: "25",
		  	safari: "7.1",
		  	node: "0.12",
		  	deno: "1",
		  	ios: "8",
		  	samsung: "3",
		  	rhino: "1.7.13",
		  	opera_mobile: "25",
		  	electron: "0.20"
		  },
		  	"es6.math.sign": {
		  	chrome: "38",
		  	opera: "25",
		  	edge: "12",
		  	firefox: "25",
		  	safari: "9",
		  	node: "0.12",
		  	deno: "1",
		  	ios: "9",
		  	samsung: "3",
		  	rhino: "1.7.13",
		  	opera_mobile: "25",
		  	electron: "0.20"
		  },
		  	"es6.math.sinh": {
		  	chrome: "38",
		  	opera: "25",
		  	edge: "12",
		  	firefox: "25",
		  	safari: "7.1",
		  	node: "0.12",
		  	deno: "1",
		  	ios: "8",
		  	samsung: "3",
		  	rhino: "1.7.13",
		  	opera_mobile: "25",
		  	electron: "0.20"
		  },
		  	"es6.math.tanh": {
		  	chrome: "38",
		  	opera: "25",
		  	edge: "12",
		  	firefox: "25",
		  	safari: "7.1",
		  	node: "0.12",
		  	deno: "1",
		  	ios: "8",
		  	samsung: "3",
		  	rhino: "1.7.13",
		  	opera_mobile: "25",
		  	electron: "0.20"
		  },
		  	"es6.math.trunc": {
		  	chrome: "38",
		  	opera: "25",
		  	edge: "12",
		  	firefox: "25",
		  	safari: "7.1",
		  	node: "0.12",
		  	deno: "1",
		  	ios: "8",
		  	samsung: "3",
		  	rhino: "1.7.13",
		  	opera_mobile: "25",
		  	electron: "0.20"
		  },
		  	"es6.number.constructor": {
		  	chrome: "41",
		  	opera: "28",
		  	edge: "12",
		  	firefox: "36",
		  	safari: "9",
		  	node: "4",
		  	deno: "1",
		  	ios: "9",
		  	samsung: "3.4",
		  	rhino: "1.7.13",
		  	opera_mobile: "28",
		  	electron: "0.21"
		  },
		  	"es6.number.epsilon": {
		  	chrome: "34",
		  	opera: "21",
		  	edge: "12",
		  	firefox: "25",
		  	safari: "9",
		  	node: "0.12",
		  	deno: "1",
		  	ios: "9",
		  	samsung: "2",
		  	rhino: "1.7.14",
		  	opera_mobile: "21",
		  	electron: "0.20"
		  },
		  	"es6.number.is-finite": {
		  	chrome: "19",
		  	opera: "15",
		  	edge: "12",
		  	firefox: "16",
		  	safari: "9",
		  	node: "0.8",
		  	deno: "1",
		  	android: "4.1",
		  	ios: "9",
		  	samsung: "1.5",
		  	rhino: "1.7.13",
		  	opera_mobile: "14",
		  	electron: "0.20"
		  },
		  	"es6.number.is-integer": {
		  	chrome: "34",
		  	opera: "21",
		  	edge: "12",
		  	firefox: "16",
		  	safari: "9",
		  	node: "0.12",
		  	deno: "1",
		  	ios: "9",
		  	samsung: "2",
		  	rhino: "1.7.13",
		  	opera_mobile: "21",
		  	electron: "0.20"
		  },
		  	"es6.number.is-nan": {
		  	chrome: "19",
		  	opera: "15",
		  	edge: "12",
		  	firefox: "15",
		  	safari: "9",
		  	node: "0.8",
		  	deno: "1",
		  	android: "4.1",
		  	ios: "9",
		  	samsung: "1.5",
		  	rhino: "1.7.13",
		  	opera_mobile: "14",
		  	electron: "0.20"
		  },
		  	"es6.number.is-safe-integer": {
		  	chrome: "34",
		  	opera: "21",
		  	edge: "12",
		  	firefox: "32",
		  	safari: "9",
		  	node: "0.12",
		  	deno: "1",
		  	ios: "9",
		  	samsung: "2",
		  	rhino: "1.7.13",
		  	opera_mobile: "21",
		  	electron: "0.20"
		  },
		  	"es6.number.max-safe-integer": {
		  	chrome: "34",
		  	opera: "21",
		  	edge: "12",
		  	firefox: "31",
		  	safari: "9",
		  	node: "0.12",
		  	deno: "1",
		  	ios: "9",
		  	samsung: "2",
		  	rhino: "1.7.13",
		  	opera_mobile: "21",
		  	electron: "0.20"
		  },
		  	"es6.number.min-safe-integer": {
		  	chrome: "34",
		  	opera: "21",
		  	edge: "12",
		  	firefox: "31",
		  	safari: "9",
		  	node: "0.12",
		  	deno: "1",
		  	ios: "9",
		  	samsung: "2",
		  	rhino: "1.7.13",
		  	opera_mobile: "21",
		  	electron: "0.20"
		  },
		  	"es6.number.parse-float": {
		  	chrome: "34",
		  	opera: "21",
		  	edge: "12",
		  	firefox: "25",
		  	safari: "9",
		  	node: "0.12",
		  	deno: "1",
		  	ios: "9",
		  	samsung: "2",
		  	rhino: "1.7.14",
		  	opera_mobile: "21",
		  	electron: "0.20"
		  },
		  	"es6.number.parse-int": {
		  	chrome: "34",
		  	opera: "21",
		  	edge: "12",
		  	firefox: "25",
		  	safari: "9",
		  	node: "0.12",
		  	deno: "1",
		  	ios: "9",
		  	samsung: "2",
		  	rhino: "1.7.14",
		  	opera_mobile: "21",
		  	electron: "0.20"
		  },
		  	"es6.object.assign": {
		  	chrome: "49",
		  	opera: "36",
		  	edge: "13",
		  	firefox: "36",
		  	safari: "10",
		  	node: "6",
		  	deno: "1",
		  	ios: "10",
		  	samsung: "5",
		  	opera_mobile: "36",
		  	electron: "0.37"
		  },
		  	"es6.object.create": {
		  	chrome: "5",
		  	opera: "12",
		  	edge: "12",
		  	firefox: "4",
		  	safari: "4",
		  	node: "0.4",
		  	deno: "1",
		  	ie: "9",
		  	android: "4",
		  	ios: "6",
		  	phantom: "1.9",
		  	samsung: "1",
		  	rhino: "1.7.13",
		  	opera_mobile: "12",
		  	electron: "0.20"
		  },
		  	"es7.object.define-getter": {
		  	chrome: "62",
		  	opera: "49",
		  	edge: "16",
		  	firefox: "48",
		  	safari: "9",
		  	node: "8.10",
		  	deno: "1",
		  	ios: "9",
		  	samsung: "8",
		  	opera_mobile: "46",
		  	electron: "3.0"
		  },
		  	"es7.object.define-setter": {
		  	chrome: "62",
		  	opera: "49",
		  	edge: "16",
		  	firefox: "48",
		  	safari: "9",
		  	node: "8.10",
		  	deno: "1",
		  	ios: "9",
		  	samsung: "8",
		  	opera_mobile: "46",
		  	electron: "3.0"
		  },
		  	"es6.object.define-property": {
		  	chrome: "5",
		  	opera: "12",
		  	edge: "12",
		  	firefox: "4",
		  	safari: "5.1",
		  	node: "0.4",
		  	deno: "1",
		  	ie: "9",
		  	android: "4",
		  	ios: "6",
		  	phantom: "1.9",
		  	samsung: "1",
		  	rhino: "1.7.13",
		  	opera_mobile: "12",
		  	electron: "0.20"
		  },
		  	"es6.object.define-properties": {
		  	chrome: "5",
		  	opera: "12",
		  	edge: "12",
		  	firefox: "4",
		  	safari: "4",
		  	node: "0.4",
		  	deno: "1",
		  	ie: "9",
		  	android: "4",
		  	ios: "6",
		  	phantom: "1.9",
		  	samsung: "1",
		  	rhino: "1.7.13",
		  	opera_mobile: "12",
		  	electron: "0.20"
		  },
		  	"es7.object.entries": {
		  	chrome: "54",
		  	opera: "41",
		  	edge: "14",
		  	firefox: "47",
		  	safari: "10.1",
		  	node: "7",
		  	deno: "1",
		  	ios: "10.3",
		  	samsung: "6",
		  	rhino: "1.7.14",
		  	opera_mobile: "41",
		  	electron: "1.4"
		  },
		  	"es6.object.freeze": {
		  	chrome: "44",
		  	opera: "31",
		  	edge: "12",
		  	firefox: "35",
		  	safari: "9",
		  	node: "4",
		  	deno: "1",
		  	ios: "9",
		  	samsung: "4",
		  	rhino: "1.7.13",
		  	opera_mobile: "32",
		  	electron: "0.30"
		  },
		  	"es6.object.get-own-property-descriptor": {
		  	chrome: "44",
		  	opera: "31",
		  	edge: "12",
		  	firefox: "35",
		  	safari: "9",
		  	node: "4",
		  	deno: "1",
		  	ios: "9",
		  	samsung: "4",
		  	rhino: "1.7.13",
		  	opera_mobile: "32",
		  	electron: "0.30"
		  },
		  	"es7.object.get-own-property-descriptors": {
		  	chrome: "54",
		  	opera: "41",
		  	edge: "15",
		  	firefox: "50",
		  	safari: "10.1",
		  	node: "7",
		  	deno: "1",
		  	ios: "10.3",
		  	samsung: "6",
		  	opera_mobile: "41",
		  	electron: "1.4"
		  },
		  	"es6.object.get-own-property-names": {
		  	chrome: "40",
		  	opera: "27",
		  	edge: "12",
		  	firefox: "33",
		  	safari: "9",
		  	node: "4",
		  	deno: "1",
		  	ios: "9",
		  	samsung: "3.4",
		  	rhino: "1.7.13",
		  	opera_mobile: "27",
		  	electron: "0.21"
		  },
		  	"es6.object.get-prototype-of": {
		  	chrome: "44",
		  	opera: "31",
		  	edge: "12",
		  	firefox: "35",
		  	safari: "9",
		  	node: "4",
		  	deno: "1",
		  	ios: "9",
		  	samsung: "4",
		  	rhino: "1.7.13",
		  	opera_mobile: "32",
		  	electron: "0.30"
		  },
		  	"es7.object.lookup-getter": {
		  	chrome: "62",
		  	opera: "49",
		  	edge: "79",
		  	firefox: "36",
		  	safari: "9",
		  	node: "8.10",
		  	deno: "1",
		  	ios: "9",
		  	samsung: "8",
		  	opera_mobile: "46",
		  	electron: "3.0"
		  },
		  	"es7.object.lookup-setter": {
		  	chrome: "62",
		  	opera: "49",
		  	edge: "79",
		  	firefox: "36",
		  	safari: "9",
		  	node: "8.10",
		  	deno: "1",
		  	ios: "9",
		  	samsung: "8",
		  	opera_mobile: "46",
		  	electron: "3.0"
		  },
		  	"es6.object.prevent-extensions": {
		  	chrome: "44",
		  	opera: "31",
		  	edge: "12",
		  	firefox: "35",
		  	safari: "9",
		  	node: "4",
		  	deno: "1",
		  	ios: "9",
		  	samsung: "4",
		  	rhino: "1.7.13",
		  	opera_mobile: "32",
		  	electron: "0.30"
		  },
		  	"es6.object.to-string": {
		  	chrome: "57",
		  	opera: "44",
		  	edge: "15",
		  	firefox: "51",
		  	safari: "10",
		  	node: "8",
		  	deno: "1",
		  	ios: "10",
		  	samsung: "7",
		  	opera_mobile: "43",
		  	electron: "1.7"
		  },
		  	"es6.object.is": {
		  	chrome: "19",
		  	opera: "15",
		  	edge: "12",
		  	firefox: "22",
		  	safari: "9",
		  	node: "0.8",
		  	deno: "1",
		  	android: "4.1",
		  	ios: "9",
		  	samsung: "1.5",
		  	rhino: "1.7.13",
		  	opera_mobile: "14",
		  	electron: "0.20"
		  },
		  	"es6.object.is-frozen": {
		  	chrome: "44",
		  	opera: "31",
		  	edge: "12",
		  	firefox: "35",
		  	safari: "9",
		  	node: "4",
		  	deno: "1",
		  	ios: "9",
		  	samsung: "4",
		  	rhino: "1.7.13",
		  	opera_mobile: "32",
		  	electron: "0.30"
		  },
		  	"es6.object.is-sealed": {
		  	chrome: "44",
		  	opera: "31",
		  	edge: "12",
		  	firefox: "35",
		  	safari: "9",
		  	node: "4",
		  	deno: "1",
		  	ios: "9",
		  	samsung: "4",
		  	rhino: "1.7.13",
		  	opera_mobile: "32",
		  	electron: "0.30"
		  },
		  	"es6.object.is-extensible": {
		  	chrome: "44",
		  	opera: "31",
		  	edge: "12",
		  	firefox: "35",
		  	safari: "9",
		  	node: "4",
		  	deno: "1",
		  	ios: "9",
		  	samsung: "4",
		  	rhino: "1.7.13",
		  	opera_mobile: "32",
		  	electron: "0.30"
		  },
		  	"es6.object.keys": {
		  	chrome: "40",
		  	opera: "27",
		  	edge: "12",
		  	firefox: "35",
		  	safari: "9",
		  	node: "4",
		  	deno: "1",
		  	ios: "9",
		  	samsung: "3.4",
		  	rhino: "1.7.13",
		  	opera_mobile: "27",
		  	electron: "0.21"
		  },
		  	"es6.object.seal": {
		  	chrome: "44",
		  	opera: "31",
		  	edge: "12",
		  	firefox: "35",
		  	safari: "9",
		  	node: "4",
		  	deno: "1",
		  	ios: "9",
		  	samsung: "4",
		  	rhino: "1.7.13",
		  	opera_mobile: "32",
		  	electron: "0.30"
		  },
		  	"es6.object.set-prototype-of": {
		  	chrome: "34",
		  	opera: "21",
		  	edge: "12",
		  	firefox: "31",
		  	safari: "9",
		  	node: "0.12",
		  	deno: "1",
		  	ie: "11",
		  	ios: "9",
		  	samsung: "2",
		  	rhino: "1.7.13",
		  	opera_mobile: "21",
		  	electron: "0.20"
		  },
		  	"es7.object.values": {
		  	chrome: "54",
		  	opera: "41",
		  	edge: "14",
		  	firefox: "47",
		  	safari: "10.1",
		  	node: "7",
		  	deno: "1",
		  	ios: "10.3",
		  	samsung: "6",
		  	rhino: "1.7.14",
		  	opera_mobile: "41",
		  	electron: "1.4"
		  },
		  	"es6.promise": {
		  	chrome: "51",
		  	opera: "38",
		  	edge: "14",
		  	firefox: "45",
		  	safari: "10",
		  	node: "6.5",
		  	deno: "1",
		  	ios: "10",
		  	samsung: "5",
		  	opera_mobile: "41",
		  	electron: "1.2"
		  },
		  	"es7.promise.finally": {
		  	chrome: "63",
		  	opera: "50",
		  	edge: "18",
		  	firefox: "58",
		  	safari: "11.1",
		  	node: "10",
		  	deno: "1",
		  	ios: "11.3",
		  	samsung: "8",
		  	opera_mobile: "46",
		  	electron: "3.0"
		  },
		  	"es6.reflect.apply": {
		  	chrome: "49",
		  	opera: "36",
		  	edge: "12",
		  	firefox: "42",
		  	safari: "10",
		  	node: "6",
		  	deno: "1",
		  	ios: "10",
		  	samsung: "5",
		  	opera_mobile: "36",
		  	electron: "0.37"
		  },
		  	"es6.reflect.construct": {
		  	chrome: "49",
		  	opera: "36",
		  	edge: "13",
		  	firefox: "49",
		  	safari: "10",
		  	node: "6",
		  	deno: "1",
		  	ios: "10",
		  	samsung: "5",
		  	opera_mobile: "36",
		  	electron: "0.37"
		  },
		  	"es6.reflect.define-property": {
		  	chrome: "49",
		  	opera: "36",
		  	edge: "13",
		  	firefox: "42",
		  	safari: "10",
		  	node: "6",
		  	deno: "1",
		  	ios: "10",
		  	samsung: "5",
		  	opera_mobile: "36",
		  	electron: "0.37"
		  },
		  	"es6.reflect.delete-property": {
		  	chrome: "49",
		  	opera: "36",
		  	edge: "12",
		  	firefox: "42",
		  	safari: "10",
		  	node: "6",
		  	deno: "1",
		  	ios: "10",
		  	samsung: "5",
		  	opera_mobile: "36",
		  	electron: "0.37"
		  },
		  	"es6.reflect.get": {
		  	chrome: "49",
		  	opera: "36",
		  	edge: "12",
		  	firefox: "42",
		  	safari: "10",
		  	node: "6",
		  	deno: "1",
		  	ios: "10",
		  	samsung: "5",
		  	opera_mobile: "36",
		  	electron: "0.37"
		  },
		  	"es6.reflect.get-own-property-descriptor": {
		  	chrome: "49",
		  	opera: "36",
		  	edge: "12",
		  	firefox: "42",
		  	safari: "10",
		  	node: "6",
		  	deno: "1",
		  	ios: "10",
		  	samsung: "5",
		  	opera_mobile: "36",
		  	electron: "0.37"
		  },
		  	"es6.reflect.get-prototype-of": {
		  	chrome: "49",
		  	opera: "36",
		  	edge: "12",
		  	firefox: "42",
		  	safari: "10",
		  	node: "6",
		  	deno: "1",
		  	ios: "10",
		  	samsung: "5",
		  	opera_mobile: "36",
		  	electron: "0.37"
		  },
		  	"es6.reflect.has": {
		  	chrome: "49",
		  	opera: "36",
		  	edge: "12",
		  	firefox: "42",
		  	safari: "10",
		  	node: "6",
		  	deno: "1",
		  	ios: "10",
		  	samsung: "5",
		  	opera_mobile: "36",
		  	electron: "0.37"
		  },
		  	"es6.reflect.is-extensible": {
		  	chrome: "49",
		  	opera: "36",
		  	edge: "12",
		  	firefox: "42",
		  	safari: "10",
		  	node: "6",
		  	deno: "1",
		  	ios: "10",
		  	samsung: "5",
		  	opera_mobile: "36",
		  	electron: "0.37"
		  },
		  	"es6.reflect.own-keys": {
		  	chrome: "49",
		  	opera: "36",
		  	edge: "12",
		  	firefox: "42",
		  	safari: "10",
		  	node: "6",
		  	deno: "1",
		  	ios: "10",
		  	samsung: "5",
		  	opera_mobile: "36",
		  	electron: "0.37"
		  },
		  	"es6.reflect.prevent-extensions": {
		  	chrome: "49",
		  	opera: "36",
		  	edge: "12",
		  	firefox: "42",
		  	safari: "10",
		  	node: "6",
		  	deno: "1",
		  	ios: "10",
		  	samsung: "5",
		  	opera_mobile: "36",
		  	electron: "0.37"
		  },
		  	"es6.reflect.set": {
		  	chrome: "49",
		  	opera: "36",
		  	edge: "12",
		  	firefox: "42",
		  	safari: "10",
		  	node: "6",
		  	deno: "1",
		  	ios: "10",
		  	samsung: "5",
		  	opera_mobile: "36",
		  	electron: "0.37"
		  },
		  	"es6.reflect.set-prototype-of": {
		  	chrome: "49",
		  	opera: "36",
		  	edge: "12",
		  	firefox: "42",
		  	safari: "10",
		  	node: "6",
		  	deno: "1",
		  	ios: "10",
		  	samsung: "5",
		  	opera_mobile: "36",
		  	electron: "0.37"
		  },
		  	"es6.regexp.constructor": {
		  	chrome: "50",
		  	opera: "37",
		  	edge: "79",
		  	firefox: "40",
		  	safari: "10",
		  	node: "6",
		  	deno: "1",
		  	ios: "10",
		  	samsung: "5",
		  	opera_mobile: "37",
		  	electron: "1.1"
		  },
		  	"es6.regexp.flags": {
		  	chrome: "49",
		  	opera: "36",
		  	edge: "79",
		  	firefox: "37",
		  	safari: "9",
		  	node: "6",
		  	deno: "1",
		  	ios: "9",
		  	samsung: "5",
		  	opera_mobile: "36",
		  	electron: "0.37"
		  },
		  	"es6.regexp.match": {
		  	chrome: "50",
		  	opera: "37",
		  	edge: "79",
		  	firefox: "49",
		  	safari: "10",
		  	node: "6",
		  	deno: "1",
		  	ios: "10",
		  	samsung: "5",
		  	rhino: "1.7.13",
		  	opera_mobile: "37",
		  	electron: "1.1"
		  },
		  	"es6.regexp.replace": {
		  	chrome: "50",
		  	opera: "37",
		  	edge: "79",
		  	firefox: "49",
		  	safari: "10",
		  	node: "6",
		  	deno: "1",
		  	ios: "10",
		  	samsung: "5",
		  	opera_mobile: "37",
		  	electron: "1.1"
		  },
		  	"es6.regexp.split": {
		  	chrome: "50",
		  	opera: "37",
		  	edge: "79",
		  	firefox: "49",
		  	safari: "10",
		  	node: "6",
		  	deno: "1",
		  	ios: "10",
		  	samsung: "5",
		  	opera_mobile: "37",
		  	electron: "1.1"
		  },
		  	"es6.regexp.search": {
		  	chrome: "50",
		  	opera: "37",
		  	edge: "79",
		  	firefox: "49",
		  	safari: "10",
		  	node: "6",
		  	deno: "1",
		  	ios: "10",
		  	samsung: "5",
		  	rhino: "1.7.13",
		  	opera_mobile: "37",
		  	electron: "1.1"
		  },
		  	"es6.regexp.to-string": {
		  	chrome: "50",
		  	opera: "37",
		  	edge: "79",
		  	firefox: "39",
		  	safari: "10",
		  	node: "6",
		  	deno: "1",
		  	ios: "10",
		  	samsung: "5",
		  	opera_mobile: "37",
		  	electron: "1.1"
		  },
		  	"es6.set": {
		  	chrome: "51",
		  	opera: "38",
		  	edge: "15",
		  	firefox: "53",
		  	safari: "10",
		  	node: "6.5",
		  	deno: "1",
		  	ios: "10",
		  	samsung: "5",
		  	opera_mobile: "41",
		  	electron: "1.2"
		  },
		  	"es6.symbol": {
		  	chrome: "51",
		  	opera: "38",
		  	edge: "79",
		  	firefox: "51",
		  	safari: "10",
		  	node: "6.5",
		  	deno: "1",
		  	ios: "10",
		  	samsung: "5",
		  	opera_mobile: "41",
		  	electron: "1.2"
		  },
		  	"es7.symbol.async-iterator": {
		  	chrome: "63",
		  	opera: "50",
		  	edge: "79",
		  	firefox: "57",
		  	safari: "12",
		  	node: "10",
		  	deno: "1",
		  	ios: "12",
		  	samsung: "8",
		  	opera_mobile: "46",
		  	electron: "3.0"
		  },
		  	"es6.string.anchor": {
		  	chrome: "5",
		  	opera: "15",
		  	edge: "12",
		  	firefox: "17",
		  	safari: "6",
		  	node: "0.4",
		  	deno: "1",
		  	android: "4",
		  	ios: "7",
		  	phantom: "1.9",
		  	samsung: "1",
		  	rhino: "1.7.14",
		  	opera_mobile: "14",
		  	electron: "0.20"
		  },
		  	"es6.string.big": {
		  	chrome: "5",
		  	opera: "15",
		  	edge: "12",
		  	firefox: "17",
		  	safari: "6",
		  	node: "0.4",
		  	deno: "1",
		  	android: "4",
		  	ios: "7",
		  	phantom: "1.9",
		  	samsung: "1",
		  	rhino: "1.7.14",
		  	opera_mobile: "14",
		  	electron: "0.20"
		  },
		  	"es6.string.blink": {
		  	chrome: "5",
		  	opera: "15",
		  	edge: "12",
		  	firefox: "17",
		  	safari: "6",
		  	node: "0.4",
		  	deno: "1",
		  	android: "4",
		  	ios: "7",
		  	phantom: "1.9",
		  	samsung: "1",
		  	rhino: "1.7.14",
		  	opera_mobile: "14",
		  	electron: "0.20"
		  },
		  	"es6.string.bold": {
		  	chrome: "5",
		  	opera: "15",
		  	edge: "12",
		  	firefox: "17",
		  	safari: "6",
		  	node: "0.4",
		  	deno: "1",
		  	android: "4",
		  	ios: "7",
		  	phantom: "1.9",
		  	samsung: "1",
		  	rhino: "1.7.14",
		  	opera_mobile: "14",
		  	electron: "0.20"
		  },
		  	"es6.string.code-point-at": {
		  	chrome: "41",
		  	opera: "28",
		  	edge: "12",
		  	firefox: "29",
		  	safari: "9",
		  	node: "4",
		  	deno: "1",
		  	ios: "9",
		  	samsung: "3.4",
		  	rhino: "1.7.13",
		  	opera_mobile: "28",
		  	electron: "0.21"
		  },
		  	"es6.string.ends-with": {
		  	chrome: "41",
		  	opera: "28",
		  	edge: "12",
		  	firefox: "29",
		  	safari: "9",
		  	node: "4",
		  	deno: "1",
		  	ios: "9",
		  	samsung: "3.4",
		  	rhino: "1.7.13",
		  	opera_mobile: "28",
		  	electron: "0.21"
		  },
		  	"es6.string.fixed": {
		  	chrome: "5",
		  	opera: "15",
		  	edge: "12",
		  	firefox: "17",
		  	safari: "6",
		  	node: "0.4",
		  	deno: "1",
		  	android: "4",
		  	ios: "7",
		  	phantom: "1.9",
		  	samsung: "1",
		  	rhino: "1.7.14",
		  	opera_mobile: "14",
		  	electron: "0.20"
		  },
		  	"es6.string.fontcolor": {
		  	chrome: "5",
		  	opera: "15",
		  	edge: "12",
		  	firefox: "17",
		  	safari: "6",
		  	node: "0.4",
		  	deno: "1",
		  	android: "4",
		  	ios: "7",
		  	phantom: "1.9",
		  	samsung: "1",
		  	rhino: "1.7.14",
		  	opera_mobile: "14",
		  	electron: "0.20"
		  },
		  	"es6.string.fontsize": {
		  	chrome: "5",
		  	opera: "15",
		  	edge: "12",
		  	firefox: "17",
		  	safari: "6",
		  	node: "0.4",
		  	deno: "1",
		  	android: "4",
		  	ios: "7",
		  	phantom: "1.9",
		  	samsung: "1",
		  	rhino: "1.7.14",
		  	opera_mobile: "14",
		  	electron: "0.20"
		  },
		  	"es6.string.from-code-point": {
		  	chrome: "41",
		  	opera: "28",
		  	edge: "12",
		  	firefox: "29",
		  	safari: "9",
		  	node: "4",
		  	deno: "1",
		  	ios: "9",
		  	samsung: "3.4",
		  	rhino: "1.7.13",
		  	opera_mobile: "28",
		  	electron: "0.21"
		  },
		  	"es6.string.includes": {
		  	chrome: "41",
		  	opera: "28",
		  	edge: "12",
		  	firefox: "40",
		  	safari: "9",
		  	node: "4",
		  	deno: "1",
		  	ios: "9",
		  	samsung: "3.4",
		  	rhino: "1.7.13",
		  	opera_mobile: "28",
		  	electron: "0.21"
		  },
		  	"es6.string.italics": {
		  	chrome: "5",
		  	opera: "15",
		  	edge: "12",
		  	firefox: "17",
		  	safari: "6",
		  	node: "0.4",
		  	deno: "1",
		  	android: "4",
		  	ios: "7",
		  	phantom: "1.9",
		  	samsung: "1",
		  	rhino: "1.7.14",
		  	opera_mobile: "14",
		  	electron: "0.20"
		  },
		  	"es6.string.iterator": {
		  	chrome: "38",
		  	opera: "25",
		  	edge: "12",
		  	firefox: "36",
		  	safari: "9",
		  	node: "0.12",
		  	deno: "1",
		  	ios: "9",
		  	samsung: "3",
		  	rhino: "1.7.13",
		  	opera_mobile: "25",
		  	electron: "0.20"
		  },
		  	"es6.string.link": {
		  	chrome: "5",
		  	opera: "15",
		  	edge: "12",
		  	firefox: "17",
		  	safari: "6",
		  	node: "0.4",
		  	deno: "1",
		  	android: "4",
		  	ios: "7",
		  	phantom: "1.9",
		  	samsung: "1",
		  	rhino: "1.7.14",
		  	opera_mobile: "14",
		  	electron: "0.20"
		  },
		  	"es7.string.pad-start": {
		  	chrome: "57",
		  	opera: "44",
		  	edge: "15",
		  	firefox: "48",
		  	safari: "10",
		  	node: "8",
		  	deno: "1",
		  	ios: "10",
		  	samsung: "7",
		  	rhino: "1.7.13",
		  	opera_mobile: "43",
		  	electron: "1.7"
		  },
		  	"es7.string.pad-end": {
		  	chrome: "57",
		  	opera: "44",
		  	edge: "15",
		  	firefox: "48",
		  	safari: "10",
		  	node: "8",
		  	deno: "1",
		  	ios: "10",
		  	samsung: "7",
		  	rhino: "1.7.13",
		  	opera_mobile: "43",
		  	electron: "1.7"
		  },
		  	"es6.string.raw": {
		  	chrome: "41",
		  	opera: "28",
		  	edge: "12",
		  	firefox: "34",
		  	safari: "9",
		  	node: "4",
		  	deno: "1",
		  	ios: "9",
		  	samsung: "3.4",
		  	rhino: "1.7.14",
		  	opera_mobile: "28",
		  	electron: "0.21"
		  },
		  	"es6.string.repeat": {
		  	chrome: "41",
		  	opera: "28",
		  	edge: "12",
		  	firefox: "24",
		  	safari: "9",
		  	node: "4",
		  	deno: "1",
		  	ios: "9",
		  	samsung: "3.4",
		  	rhino: "1.7.13",
		  	opera_mobile: "28",
		  	electron: "0.21"
		  },
		  	"es6.string.small": {
		  	chrome: "5",
		  	opera: "15",
		  	edge: "12",
		  	firefox: "17",
		  	safari: "6",
		  	node: "0.4",
		  	deno: "1",
		  	android: "4",
		  	ios: "7",
		  	phantom: "1.9",
		  	samsung: "1",
		  	rhino: "1.7.14",
		  	opera_mobile: "14",
		  	electron: "0.20"
		  },
		  	"es6.string.starts-with": {
		  	chrome: "41",
		  	opera: "28",
		  	edge: "12",
		  	firefox: "29",
		  	safari: "9",
		  	node: "4",
		  	deno: "1",
		  	ios: "9",
		  	samsung: "3.4",
		  	rhino: "1.7.13",
		  	opera_mobile: "28",
		  	electron: "0.21"
		  },
		  	"es6.string.strike": {
		  	chrome: "5",
		  	opera: "15",
		  	edge: "12",
		  	firefox: "17",
		  	safari: "6",
		  	node: "0.4",
		  	deno: "1",
		  	android: "4",
		  	ios: "7",
		  	phantom: "1.9",
		  	samsung: "1",
		  	rhino: "1.7.14",
		  	opera_mobile: "14",
		  	electron: "0.20"
		  },
		  	"es6.string.sub": {
		  	chrome: "5",
		  	opera: "15",
		  	edge: "12",
		  	firefox: "17",
		  	safari: "6",
		  	node: "0.4",
		  	deno: "1",
		  	android: "4",
		  	ios: "7",
		  	phantom: "1.9",
		  	samsung: "1",
		  	rhino: "1.7.14",
		  	opera_mobile: "14",
		  	electron: "0.20"
		  },
		  	"es6.string.sup": {
		  	chrome: "5",
		  	opera: "15",
		  	edge: "12",
		  	firefox: "17",
		  	safari: "6",
		  	node: "0.4",
		  	deno: "1",
		  	android: "4",
		  	ios: "7",
		  	phantom: "1.9",
		  	samsung: "1",
		  	rhino: "1.7.14",
		  	opera_mobile: "14",
		  	electron: "0.20"
		  },
		  	"es6.string.trim": {
		  	chrome: "5",
		  	opera: "10.50",
		  	edge: "12",
		  	firefox: "3.5",
		  	safari: "4",
		  	node: "0.4",
		  	deno: "1",
		  	ie: "9",
		  	android: "4",
		  	ios: "6",
		  	phantom: "1.9",
		  	samsung: "1",
		  	rhino: "1.7.13",
		  	opera_mobile: "10.1",
		  	electron: "0.20"
		  },
		  	"es7.string.trim-left": {
		  	chrome: "66",
		  	opera: "53",
		  	edge: "79",
		  	firefox: "61",
		  	safari: "12",
		  	node: "10",
		  	deno: "1",
		  	ios: "12",
		  	samsung: "9",
		  	rhino: "1.7.13",
		  	opera_mobile: "47",
		  	electron: "3.0"
		  },
		  	"es7.string.trim-right": {
		  	chrome: "66",
		  	opera: "53",
		  	edge: "79",
		  	firefox: "61",
		  	safari: "12",
		  	node: "10",
		  	deno: "1",
		  	ios: "12",
		  	samsung: "9",
		  	rhino: "1.7.13",
		  	opera_mobile: "47",
		  	electron: "3.0"
		  },
		  	"es6.typed.array-buffer": {
		  	chrome: "51",
		  	opera: "38",
		  	edge: "13",
		  	firefox: "48",
		  	safari: "10",
		  	node: "6.5",
		  	deno: "1",
		  	ios: "10",
		  	samsung: "5",
		  	opera_mobile: "41",
		  	electron: "1.2"
		  },
		  	"es6.typed.data-view": {
		  	chrome: "5",
		  	opera: "12",
		  	edge: "12",
		  	firefox: "15",
		  	safari: "5.1",
		  	node: "0.4",
		  	deno: "1",
		  	ie: "10",
		  	android: "4",
		  	ios: "6",
		  	phantom: "1.9",
		  	samsung: "1",
		  	rhino: "1.7.13",
		  	opera_mobile: "12",
		  	electron: "0.20"
		  },
		  	"es6.typed.int8-array": {
		  	chrome: "51",
		  	opera: "38",
		  	edge: "13",
		  	firefox: "48",
		  	safari: "10",
		  	node: "6.5",
		  	deno: "1",
		  	ios: "10",
		  	samsung: "5",
		  	opera_mobile: "41",
		  	electron: "1.2"
		  },
		  	"es6.typed.uint8-array": {
		  	chrome: "51",
		  	opera: "38",
		  	edge: "13",
		  	firefox: "48",
		  	safari: "10",
		  	node: "6.5",
		  	deno: "1",
		  	ios: "10",
		  	samsung: "5",
		  	opera_mobile: "41",
		  	electron: "1.2"
		  },
		  	"es6.typed.uint8-clamped-array": {
		  	chrome: "51",
		  	opera: "38",
		  	edge: "13",
		  	firefox: "48",
		  	safari: "10",
		  	node: "6.5",
		  	deno: "1",
		  	ios: "10",
		  	samsung: "5",
		  	opera_mobile: "41",
		  	electron: "1.2"
		  },
		  	"es6.typed.int16-array": {
		  	chrome: "51",
		  	opera: "38",
		  	edge: "13",
		  	firefox: "48",
		  	safari: "10",
		  	node: "6.5",
		  	deno: "1",
		  	ios: "10",
		  	samsung: "5",
		  	opera_mobile: "41",
		  	electron: "1.2"
		  },
		  	"es6.typed.uint16-array": {
		  	chrome: "51",
		  	opera: "38",
		  	edge: "13",
		  	firefox: "48",
		  	safari: "10",
		  	node: "6.5",
		  	deno: "1",
		  	ios: "10",
		  	samsung: "5",
		  	opera_mobile: "41",
		  	electron: "1.2"
		  },
		  	"es6.typed.int32-array": {
		  	chrome: "51",
		  	opera: "38",
		  	edge: "13",
		  	firefox: "48",
		  	safari: "10",
		  	node: "6.5",
		  	deno: "1",
		  	ios: "10",
		  	samsung: "5",
		  	opera_mobile: "41",
		  	electron: "1.2"
		  },
		  	"es6.typed.uint32-array": {
		  	chrome: "51",
		  	opera: "38",
		  	edge: "13",
		  	firefox: "48",
		  	safari: "10",
		  	node: "6.5",
		  	deno: "1",
		  	ios: "10",
		  	samsung: "5",
		  	opera_mobile: "41",
		  	electron: "1.2"
		  },
		  	"es6.typed.float32-array": {
		  	chrome: "51",
		  	opera: "38",
		  	edge: "13",
		  	firefox: "48",
		  	safari: "10",
		  	node: "6.5",
		  	deno: "1",
		  	ios: "10",
		  	samsung: "5",
		  	opera_mobile: "41",
		  	electron: "1.2"
		  },
		  	"es6.typed.float64-array": {
		  	chrome: "51",
		  	opera: "38",
		  	edge: "13",
		  	firefox: "48",
		  	safari: "10",
		  	node: "6.5",
		  	deno: "1",
		  	ios: "10",
		  	samsung: "5",
		  	opera_mobile: "41",
		  	electron: "1.2"
		  },
		  	"es6.weak-map": {
		  	chrome: "51",
		  	opera: "38",
		  	edge: "15",
		  	firefox: "53",
		  	safari: "9",
		  	node: "6.5",
		  	deno: "1",
		  	ios: "9",
		  	samsung: "5",
		  	opera_mobile: "41",
		  	electron: "1.2"
		  },
		  	"es6.weak-set": {
		  	chrome: "51",
		  	opera: "38",
		  	edge: "15",
		  	firefox: "53",
		  	safari: "9",
		  	node: "6.5",
		  	deno: "1",
		  	ios: "9",
		  	samsung: "5",
		  	opera_mobile: "41",
		  	electron: "1.2"
		  }
		  };

		  var corejs2BuiltIns;
		  var hasRequiredCorejs2BuiltIns;
		  function requireCorejs2BuiltIns() {
		    if (hasRequiredCorejs2BuiltIns) return corejs2BuiltIns;
		    hasRequiredCorejs2BuiltIns = 1;
		    corejs2BuiltIns = require$$0$5;
		    return corejs2BuiltIns;
		  }

		  var builtInDefinitions$2 = {};

		  var hasRequiredBuiltInDefinitions$2;
		  function requireBuiltInDefinitions$2() {
		    if (hasRequiredBuiltInDefinitions$2) return builtInDefinitions$2;
		    hasRequiredBuiltInDefinitions$2 = 1;
		    builtInDefinitions$2.__esModule = true;
		    builtInDefinitions$2.StaticProperties = builtInDefinitions$2.InstanceProperties = builtInDefinitions$2.CommonIterators = builtInDefinitions$2.BuiltIns = void 0;
		    var _corejs2BuiltIns = _interopRequireDefault(requireCorejs2BuiltIns());
		    function _interopRequireDefault(obj) {
		      return obj && obj.__esModule ? obj : {
		        "default": obj
		      };
		    }
		    var define = function define(name, pure, global, meta) {
		      if (global === void 0) {
		        global = [];
		      }
		      return {
		        name: name,
		        pure: pure,
		        global: global,
		        meta: meta
		      };
		    };
		    var pureAndGlobal = function pureAndGlobal(pure, global, minRuntimeVersion) {
		      if (minRuntimeVersion === void 0) {
		        minRuntimeVersion = null;
		      }
		      return define(global[0], pure, global, {
		        minRuntimeVersion: minRuntimeVersion
		      });
		    };
		    var globalOnly = function globalOnly(global) {
		      return define(global[0], null, global);
		    };
		    var pureOnly = function pureOnly(pure, name) {
		      return define(name, pure, []);
		    };
		    var ArrayNatureIterators = ["es6.object.to-string", "es6.array.iterator", "web.dom.iterable"];
		    var CommonIterators = ["es6.string.iterator"].concat(ArrayNatureIterators);
		    builtInDefinitions$2.CommonIterators = CommonIterators;
		    var PromiseDependencies = ["es6.object.to-string", "es6.promise"];
		    var BuiltIns = {
		      DataView: globalOnly(["es6.typed.data-view"]),
		      Float32Array: globalOnly(["es6.typed.float32-array"]),
		      Float64Array: globalOnly(["es6.typed.float64-array"]),
		      Int8Array: globalOnly(["es6.typed.int8-array"]),
		      Int16Array: globalOnly(["es6.typed.int16-array"]),
		      Int32Array: globalOnly(["es6.typed.int32-array"]),
		      Map: pureAndGlobal("map", ["es6.map"].concat(_toConsumableArray(CommonIterators))),
		      Number: globalOnly(["es6.number.constructor"]),
		      Promise: pureAndGlobal("promise", PromiseDependencies),
		      RegExp: globalOnly(["es6.regexp.constructor"]),
		      Set: pureAndGlobal("set", ["es6.set"].concat(_toConsumableArray(CommonIterators))),
		      Symbol: pureAndGlobal("symbol/index", ["es6.symbol"]),
		      Uint8Array: globalOnly(["es6.typed.uint8-array"]),
		      Uint8ClampedArray: globalOnly(["es6.typed.uint8-clamped-array"]),
		      Uint16Array: globalOnly(["es6.typed.uint16-array"]),
		      Uint32Array: globalOnly(["es6.typed.uint32-array"]),
		      WeakMap: pureAndGlobal("weak-map", ["es6.weak-map"].concat(_toConsumableArray(CommonIterators))),
		      WeakSet: pureAndGlobal("weak-set", ["es6.weak-set"].concat(_toConsumableArray(CommonIterators))),
		      setImmediate: pureOnly("set-immediate", "web.immediate"),
		      clearImmediate: pureOnly("clear-immediate", "web.immediate"),
		      parseFloat: pureOnly("parse-float", "es6.parse-float"),
		      parseInt: pureOnly("parse-int", "es6.parse-int")
		    };
		    builtInDefinitions$2.BuiltIns = BuiltIns;
		    var InstanceProperties = {
		      __defineGetter__: globalOnly(["es7.object.define-getter"]),
		      __defineSetter__: globalOnly(["es7.object.define-setter"]),
		      __lookupGetter__: globalOnly(["es7.object.lookup-getter"]),
		      __lookupSetter__: globalOnly(["es7.object.lookup-setter"]),
		      anchor: globalOnly(["es6.string.anchor"]),
		      big: globalOnly(["es6.string.big"]),
		      bind: globalOnly(["es6.function.bind"]),
		      blink: globalOnly(["es6.string.blink"]),
		      bold: globalOnly(["es6.string.bold"]),
		      codePointAt: globalOnly(["es6.string.code-point-at"]),
		      copyWithin: globalOnly(["es6.array.copy-within"]),
		      endsWith: globalOnly(["es6.string.ends-with"]),
		      entries: globalOnly(ArrayNatureIterators),
		      every: globalOnly(["es6.array.every"]),
		      fill: globalOnly(["es6.array.fill"]),
		      filter: globalOnly(["es6.array.filter"]),
		      "finally": globalOnly(["es7.promise.finally"].concat(PromiseDependencies)),
		      find: globalOnly(["es6.array.find"]),
		      findIndex: globalOnly(["es6.array.find-index"]),
		      fixed: globalOnly(["es6.string.fixed"]),
		      flags: globalOnly(["es6.regexp.flags"]),
		      flatMap: globalOnly(["es7.array.flat-map"]),
		      fontcolor: globalOnly(["es6.string.fontcolor"]),
		      fontsize: globalOnly(["es6.string.fontsize"]),
		      forEach: globalOnly(["es6.array.for-each"]),
		      includes: globalOnly(["es6.string.includes", "es7.array.includes"]),
		      indexOf: globalOnly(["es6.array.index-of"]),
		      italics: globalOnly(["es6.string.italics"]),
		      keys: globalOnly(ArrayNatureIterators),
		      lastIndexOf: globalOnly(["es6.array.last-index-of"]),
		      link: globalOnly(["es6.string.link"]),
		      map: globalOnly(["es6.array.map"]),
		      match: globalOnly(["es6.regexp.match"]),
		      name: globalOnly(["es6.function.name"]),
		      padStart: globalOnly(["es7.string.pad-start"]),
		      padEnd: globalOnly(["es7.string.pad-end"]),
		      reduce: globalOnly(["es6.array.reduce"]),
		      reduceRight: globalOnly(["es6.array.reduce-right"]),
		      repeat: globalOnly(["es6.string.repeat"]),
		      replace: globalOnly(["es6.regexp.replace"]),
		      search: globalOnly(["es6.regexp.search"]),
		      small: globalOnly(["es6.string.small"]),
		      some: globalOnly(["es6.array.some"]),
		      sort: globalOnly(["es6.array.sort"]),
		      split: globalOnly(["es6.regexp.split"]),
		      startsWith: globalOnly(["es6.string.starts-with"]),
		      strike: globalOnly(["es6.string.strike"]),
		      sub: globalOnly(["es6.string.sub"]),
		      sup: globalOnly(["es6.string.sup"]),
		      toISOString: globalOnly(["es6.date.to-iso-string"]),
		      toJSON: globalOnly(["es6.date.to-json"]),
		      toString: globalOnly(["es6.object.to-string", "es6.date.to-string", "es6.regexp.to-string"]),
		      trim: globalOnly(["es6.string.trim"]),
		      trimEnd: globalOnly(["es7.string.trim-right"]),
		      trimLeft: globalOnly(["es7.string.trim-left"]),
		      trimRight: globalOnly(["es7.string.trim-right"]),
		      trimStart: globalOnly(["es7.string.trim-left"]),
		      values: globalOnly(ArrayNatureIterators)
		    };
		    builtInDefinitions$2.InstanceProperties = InstanceProperties;
		    if ("es6.array.slice" in _corejs2BuiltIns["default"]) {
		      InstanceProperties.slice = globalOnly(["es6.array.slice"]);
		    }
		    var StaticProperties = {
		      Array: {
		        from: pureAndGlobal("array/from", ["es6.symbol", "es6.array.from"].concat(_toConsumableArray(CommonIterators))),
		        isArray: pureAndGlobal("array/is-array", ["es6.array.is-array"]),
		        of: pureAndGlobal("array/of", ["es6.array.of"])
		      },
		      Date: {
		        now: pureAndGlobal("date/now", ["es6.date.now"])
		      },
		      JSON: {
		        stringify: pureOnly("json/stringify", "es6.symbol")
		      },
		      Math: {
		        acosh: pureAndGlobal("math/acosh", ["es6.math.acosh"], "7.0.1"),
		        asinh: pureAndGlobal("math/asinh", ["es6.math.asinh"], "7.0.1"),
		        atanh: pureAndGlobal("math/atanh", ["es6.math.atanh"], "7.0.1"),
		        cbrt: pureAndGlobal("math/cbrt", ["es6.math.cbrt"], "7.0.1"),
		        clz32: pureAndGlobal("math/clz32", ["es6.math.clz32"], "7.0.1"),
		        cosh: pureAndGlobal("math/cosh", ["es6.math.cosh"], "7.0.1"),
		        expm1: pureAndGlobal("math/expm1", ["es6.math.expm1"], "7.0.1"),
		        fround: pureAndGlobal("math/fround", ["es6.math.fround"], "7.0.1"),
		        hypot: pureAndGlobal("math/hypot", ["es6.math.hypot"], "7.0.1"),
		        imul: pureAndGlobal("math/imul", ["es6.math.imul"], "7.0.1"),
		        log1p: pureAndGlobal("math/log1p", ["es6.math.log1p"], "7.0.1"),
		        log10: pureAndGlobal("math/log10", ["es6.math.log10"], "7.0.1"),
		        log2: pureAndGlobal("math/log2", ["es6.math.log2"], "7.0.1"),
		        sign: pureAndGlobal("math/sign", ["es6.math.sign"], "7.0.1"),
		        sinh: pureAndGlobal("math/sinh", ["es6.math.sinh"], "7.0.1"),
		        tanh: pureAndGlobal("math/tanh", ["es6.math.tanh"], "7.0.1"),
		        trunc: pureAndGlobal("math/trunc", ["es6.math.trunc"], "7.0.1")
		      },
		      Number: {
		        EPSILON: pureAndGlobal("number/epsilon", ["es6.number.epsilon"]),
		        MIN_SAFE_INTEGER: pureAndGlobal("number/min-safe-integer", ["es6.number.min-safe-integer"]),
		        MAX_SAFE_INTEGER: pureAndGlobal("number/max-safe-integer", ["es6.number.max-safe-integer"]),
		        isFinite: pureAndGlobal("number/is-finite", ["es6.number.is-finite"]),
		        isInteger: pureAndGlobal("number/is-integer", ["es6.number.is-integer"]),
		        isSafeInteger: pureAndGlobal("number/is-safe-integer", ["es6.number.is-safe-integer"]),
		        isNaN: pureAndGlobal("number/is-nan", ["es6.number.is-nan"]),
		        parseFloat: pureAndGlobal("number/parse-float", ["es6.number.parse-float"]),
		        parseInt: pureAndGlobal("number/parse-int", ["es6.number.parse-int"])
		      },
		      Object: {
		        assign: pureAndGlobal("object/assign", ["es6.object.assign"]),
		        create: pureAndGlobal("object/create", ["es6.object.create"]),
		        defineProperties: pureAndGlobal("object/define-properties", ["es6.object.define-properties"]),
		        defineProperty: pureAndGlobal("object/define-property", ["es6.object.define-property"]),
		        entries: pureAndGlobal("object/entries", ["es7.object.entries"]),
		        freeze: pureAndGlobal("object/freeze", ["es6.object.freeze"]),
		        getOwnPropertyDescriptor: pureAndGlobal("object/get-own-property-descriptor", ["es6.object.get-own-property-descriptor"]),
		        getOwnPropertyDescriptors: pureAndGlobal("object/get-own-property-descriptors", ["es7.object.get-own-property-descriptors"]),
		        getOwnPropertyNames: pureAndGlobal("object/get-own-property-names", ["es6.object.get-own-property-names"]),
		        getOwnPropertySymbols: pureAndGlobal("object/get-own-property-symbols", ["es6.symbol"]),
		        getPrototypeOf: pureAndGlobal("object/get-prototype-of", ["es6.object.get-prototype-of"]),
		        is: pureAndGlobal("object/is", ["es6.object.is"]),
		        isExtensible: pureAndGlobal("object/is-extensible", ["es6.object.is-extensible"]),
		        isFrozen: pureAndGlobal("object/is-frozen", ["es6.object.is-frozen"]),
		        isSealed: pureAndGlobal("object/is-sealed", ["es6.object.is-sealed"]),
		        keys: pureAndGlobal("object/keys", ["es6.object.keys"]),
		        preventExtensions: pureAndGlobal("object/prevent-extensions", ["es6.object.prevent-extensions"]),
		        seal: pureAndGlobal("object/seal", ["es6.object.seal"]),
		        setPrototypeOf: pureAndGlobal("object/set-prototype-of", ["es6.object.set-prototype-of"]),
		        values: pureAndGlobal("object/values", ["es7.object.values"])
		      },
		      Promise: {
		        all: globalOnly(CommonIterators),
		        race: globalOnly(CommonIterators)
		      },
		      Reflect: {
		        apply: pureAndGlobal("reflect/apply", ["es6.reflect.apply"]),
		        construct: pureAndGlobal("reflect/construct", ["es6.reflect.construct"]),
		        defineProperty: pureAndGlobal("reflect/define-property", ["es6.reflect.define-property"]),
		        deleteProperty: pureAndGlobal("reflect/delete-property", ["es6.reflect.delete-property"]),
		        get: pureAndGlobal("reflect/get", ["es6.reflect.get"]),
		        getOwnPropertyDescriptor: pureAndGlobal("reflect/get-own-property-descriptor", ["es6.reflect.get-own-property-descriptor"]),
		        getPrototypeOf: pureAndGlobal("reflect/get-prototype-of", ["es6.reflect.get-prototype-of"]),
		        has: pureAndGlobal("reflect/has", ["es6.reflect.has"]),
		        isExtensible: pureAndGlobal("reflect/is-extensible", ["es6.reflect.is-extensible"]),
		        ownKeys: pureAndGlobal("reflect/own-keys", ["es6.reflect.own-keys"]),
		        preventExtensions: pureAndGlobal("reflect/prevent-extensions", ["es6.reflect.prevent-extensions"]),
		        set: pureAndGlobal("reflect/set", ["es6.reflect.set"]),
		        setPrototypeOf: pureAndGlobal("reflect/set-prototype-of", ["es6.reflect.set-prototype-of"])
		      },
		      String: {
		        at: pureOnly("string/at", "es7.string.at"),
		        fromCodePoint: pureAndGlobal("string/from-code-point", ["es6.string.from-code-point"]),
		        raw: pureAndGlobal("string/raw", ["es6.string.raw"])
		      },
		      Symbol: {
		        asyncIterator: globalOnly(["es6.symbol", "es7.symbol.async-iterator"]),
		        "for": pureOnly("symbol/for", "es6.symbol"),
		        hasInstance: pureOnly("symbol/has-instance", "es6.symbol"),
		        isConcatSpreadable: pureOnly("symbol/is-concat-spreadable", "es6.symbol"),
		        iterator: define("es6.symbol", "symbol/iterator", CommonIterators),
		        keyFor: pureOnly("symbol/key-for", "es6.symbol"),
		        match: pureAndGlobal("symbol/match", ["es6.regexp.match"]),
		        replace: pureOnly("symbol/replace", "es6.symbol"),
		        search: pureOnly("symbol/search", "es6.symbol"),
		        species: pureOnly("symbol/species", "es6.symbol"),
		        split: pureOnly("symbol/split", "es6.symbol"),
		        toPrimitive: pureOnly("symbol/to-primitive", "es6.symbol"),
		        toStringTag: pureOnly("symbol/to-string-tag", "es6.symbol"),
		        unscopables: pureOnly("symbol/unscopables", "es6.symbol")
		      }
		    };
		    builtInDefinitions$2.StaticProperties = StaticProperties;
		    return builtInDefinitions$2;
		  }

		  var addPlatformSpecificPolyfills$1 = {};

		  var hasRequiredAddPlatformSpecificPolyfills$1;
		  function requireAddPlatformSpecificPolyfills$1() {
		    if (hasRequiredAddPlatformSpecificPolyfills$1) return addPlatformSpecificPolyfills$1;
		    hasRequiredAddPlatformSpecificPolyfills$1 = 1;
		    addPlatformSpecificPolyfills$1.__esModule = true;
		    addPlatformSpecificPolyfills$1["default"] = _default;
		    function _extends() {
		      _extends = Object.assign ? Object.assign.bind() : function (target) {
		        for (var i = 1; i < arguments.length; i++) {
		          var source = arguments[i];
		          for (var key in source) {
		            if (Object.prototype.hasOwnProperty.call(source, key)) {
		              target[key] = source[key];
		            }
		          }
		        }
		        return target;
		      };
		      return _extends.apply(this, arguments);
		    }
		    var webPolyfills = {
		      "web.timers": {},
		      "web.immediate": {},
		      "web.dom.iterable": {}
		    };
		    var purePolyfills = {
		      "es6.parse-float": {},
		      "es6.parse-int": {},
		      "es7.string.at": {}
		    };
		    function _default(targets, method, polyfills) {
		      var targetNames = Object.keys(targets);
		      var isAnyTarget = !targetNames.length;
		      var isWebTarget = targetNames.some(function (name) {
		        return name !== "node";
		      });
		      return _extends({}, polyfills, method === "usage-pure" ? purePolyfills : null, isAnyTarget || isWebTarget ? webPolyfills : null);
		    }
		    return addPlatformSpecificPolyfills$1;
		  }

		  var helpers$2 = {};

		  var semver$4 = {exports: {}};

		  var hasRequiredSemver$1;
		  function requireSemver$1() {
		    if (hasRequiredSemver$1) return semver$4.exports;
		    hasRequiredSemver$1 = 1;
		    (function (module, exports) {
		      exports = module.exports = SemVer;
		      var debug;
		      if (typeof browser$1$1 === 'object' && browser$1$1.env && browser$1$1.env.NODE_DEBUG && /\bsemver\b/i.test(browser$1$1.env.NODE_DEBUG)) {
		        debug = function debug() {
		          var args = Array.prototype.slice.call(arguments, 0);
		          args.unshift('SEMVER');
		          console.log.apply(console, args);
		        };
		      } else {
		        debug = function debug() {};
		      }
		      exports.SEMVER_SPEC_VERSION = '2.0.0';
		      var MAX_LENGTH = 256;
		      var MAX_SAFE_INTEGER = Number.MAX_SAFE_INTEGER || 9007199254740991;
		      var MAX_SAFE_COMPONENT_LENGTH = 16;
		      var MAX_SAFE_BUILD_LENGTH = MAX_LENGTH - 6;
		      var re = exports.re = [];
		      var safeRe = exports.safeRe = [];
		      var src = exports.src = [];
		      var t = exports.tokens = {};
		      var R = 0;
		      function tok(n) {
		        t[n] = R++;
		      }
		      var LETTERDASHNUMBER = '[a-zA-Z0-9-]';
		      var safeRegexReplacements = [['\\s', 1], ['\\d', MAX_LENGTH], [LETTERDASHNUMBER, MAX_SAFE_BUILD_LENGTH]];
		      function makeSafeRe(value) {
		        for (var i = 0; i < safeRegexReplacements.length; i++) {
		          var token = safeRegexReplacements[i][0];
		          var max = safeRegexReplacements[i][1];
		          value = value.split(token + '*').join(token + '{0,' + max + '}').split(token + '+').join(token + '{1,' + max + '}');
		        }
		        return value;
		      }
		      tok('NUMERICIDENTIFIER');
		      src[t.NUMERICIDENTIFIER] = '0|[1-9]\\d*';
		      tok('NUMERICIDENTIFIERLOOSE');
		      src[t.NUMERICIDENTIFIERLOOSE] = '\\d+';
		      tok('NONNUMERICIDENTIFIER');
		      src[t.NONNUMERICIDENTIFIER] = '\\d*[a-zA-Z-]' + LETTERDASHNUMBER + '*';
		      tok('MAINVERSION');
		      src[t.MAINVERSION] = '(' + src[t.NUMERICIDENTIFIER] + ')\\.' + '(' + src[t.NUMERICIDENTIFIER] + ')\\.' + '(' + src[t.NUMERICIDENTIFIER] + ')';
		      tok('MAINVERSIONLOOSE');
		      src[t.MAINVERSIONLOOSE] = '(' + src[t.NUMERICIDENTIFIERLOOSE] + ')\\.' + '(' + src[t.NUMERICIDENTIFIERLOOSE] + ')\\.' + '(' + src[t.NUMERICIDENTIFIERLOOSE] + ')';
		      tok('PRERELEASEIDENTIFIER');
		      src[t.PRERELEASEIDENTIFIER] = '(?:' + src[t.NUMERICIDENTIFIER] + '|' + src[t.NONNUMERICIDENTIFIER] + ')';
		      tok('PRERELEASEIDENTIFIERLOOSE');
		      src[t.PRERELEASEIDENTIFIERLOOSE] = '(?:' + src[t.NUMERICIDENTIFIERLOOSE] + '|' + src[t.NONNUMERICIDENTIFIER] + ')';
		      tok('PRERELEASE');
		      src[t.PRERELEASE] = '(?:-(' + src[t.PRERELEASEIDENTIFIER] + '(?:\\.' + src[t.PRERELEASEIDENTIFIER] + ')*))';
		      tok('PRERELEASELOOSE');
		      src[t.PRERELEASELOOSE] = '(?:-?(' + src[t.PRERELEASEIDENTIFIERLOOSE] + '(?:\\.' + src[t.PRERELEASEIDENTIFIERLOOSE] + ')*))';
		      tok('BUILDIDENTIFIER');
		      src[t.BUILDIDENTIFIER] = LETTERDASHNUMBER + '+';
		      tok('BUILD');
		      src[t.BUILD] = '(?:\\+(' + src[t.BUILDIDENTIFIER] + '(?:\\.' + src[t.BUILDIDENTIFIER] + ')*))';
		      tok('FULL');
		      tok('FULLPLAIN');
		      src[t.FULLPLAIN] = 'v?' + src[t.MAINVERSION] + src[t.PRERELEASE] + '?' + src[t.BUILD] + '?';
		      src[t.FULL] = '^' + src[t.FULLPLAIN] + '$';
		      tok('LOOSEPLAIN');
		      src[t.LOOSEPLAIN] = '[v=\\s]*' + src[t.MAINVERSIONLOOSE] + src[t.PRERELEASELOOSE] + '?' + src[t.BUILD] + '?';
		      tok('LOOSE');
		      src[t.LOOSE] = '^' + src[t.LOOSEPLAIN] + '$';
		      tok('GTLT');
		      src[t.GTLT] = '((?:<|>)?=?)';
		      tok('XRANGEIDENTIFIERLOOSE');
		      src[t.XRANGEIDENTIFIERLOOSE] = src[t.NUMERICIDENTIFIERLOOSE] + '|x|X|\\*';
		      tok('XRANGEIDENTIFIER');
		      src[t.XRANGEIDENTIFIER] = src[t.NUMERICIDENTIFIER] + '|x|X|\\*';
		      tok('XRANGEPLAIN');
		      src[t.XRANGEPLAIN] = '[v=\\s]*(' + src[t.XRANGEIDENTIFIER] + ')' + '(?:\\.(' + src[t.XRANGEIDENTIFIER] + ')' + '(?:\\.(' + src[t.XRANGEIDENTIFIER] + ')' + '(?:' + src[t.PRERELEASE] + ')?' + src[t.BUILD] + '?' + ')?)?';
		      tok('XRANGEPLAINLOOSE');
		      src[t.XRANGEPLAINLOOSE] = '[v=\\s]*(' + src[t.XRANGEIDENTIFIERLOOSE] + ')' + '(?:\\.(' + src[t.XRANGEIDENTIFIERLOOSE] + ')' + '(?:\\.(' + src[t.XRANGEIDENTIFIERLOOSE] + ')' + '(?:' + src[t.PRERELEASELOOSE] + ')?' + src[t.BUILD] + '?' + ')?)?';
		      tok('XRANGE');
		      src[t.XRANGE] = '^' + src[t.GTLT] + '\\s*' + src[t.XRANGEPLAIN] + '$';
		      tok('XRANGELOOSE');
		      src[t.XRANGELOOSE] = '^' + src[t.GTLT] + '\\s*' + src[t.XRANGEPLAINLOOSE] + '$';
		      tok('COERCE');
		      src[t.COERCE] = '(^|[^\\d])' + '(\\d{1,' + MAX_SAFE_COMPONENT_LENGTH + '})' + '(?:\\.(\\d{1,' + MAX_SAFE_COMPONENT_LENGTH + '}))?' + '(?:\\.(\\d{1,' + MAX_SAFE_COMPONENT_LENGTH + '}))?' + '(?:$|[^\\d])';
		      tok('COERCERTL');
		      re[t.COERCERTL] = new RegExp(src[t.COERCE], 'g');
		      safeRe[t.COERCERTL] = new RegExp(makeSafeRe(src[t.COERCE]), 'g');
		      tok('LONETILDE');
		      src[t.LONETILDE] = '(?:~>?)';
		      tok('TILDETRIM');
		      src[t.TILDETRIM] = '(\\s*)' + src[t.LONETILDE] + '\\s+';
		      re[t.TILDETRIM] = new RegExp(src[t.TILDETRIM], 'g');
		      safeRe[t.TILDETRIM] = new RegExp(makeSafeRe(src[t.TILDETRIM]), 'g');
		      var tildeTrimReplace = '$1~';
		      tok('TILDE');
		      src[t.TILDE] = '^' + src[t.LONETILDE] + src[t.XRANGEPLAIN] + '$';
		      tok('TILDELOOSE');
		      src[t.TILDELOOSE] = '^' + src[t.LONETILDE] + src[t.XRANGEPLAINLOOSE] + '$';
		      tok('LONECARET');
		      src[t.LONECARET] = '(?:\\^)';
		      tok('CARETTRIM');
		      src[t.CARETTRIM] = '(\\s*)' + src[t.LONECARET] + '\\s+';
		      re[t.CARETTRIM] = new RegExp(src[t.CARETTRIM], 'g');
		      safeRe[t.CARETTRIM] = new RegExp(makeSafeRe(src[t.CARETTRIM]), 'g');
		      var caretTrimReplace = '$1^';
		      tok('CARET');
		      src[t.CARET] = '^' + src[t.LONECARET] + src[t.XRANGEPLAIN] + '$';
		      tok('CARETLOOSE');
		      src[t.CARETLOOSE] = '^' + src[t.LONECARET] + src[t.XRANGEPLAINLOOSE] + '$';
		      tok('COMPARATORLOOSE');
		      src[t.COMPARATORLOOSE] = '^' + src[t.GTLT] + '\\s*(' + src[t.LOOSEPLAIN] + ')$|^$';
		      tok('COMPARATOR');
		      src[t.COMPARATOR] = '^' + src[t.GTLT] + '\\s*(' + src[t.FULLPLAIN] + ')$|^$';
		      tok('COMPARATORTRIM');
		      src[t.COMPARATORTRIM] = '(\\s*)' + src[t.GTLT] + '\\s*(' + src[t.LOOSEPLAIN] + '|' + src[t.XRANGEPLAIN] + ')';
		      re[t.COMPARATORTRIM] = new RegExp(src[t.COMPARATORTRIM], 'g');
		      safeRe[t.COMPARATORTRIM] = new RegExp(makeSafeRe(src[t.COMPARATORTRIM]), 'g');
		      var comparatorTrimReplace = '$1$2$3';
		      tok('HYPHENRANGE');
		      src[t.HYPHENRANGE] = '^\\s*(' + src[t.XRANGEPLAIN] + ')' + '\\s+-\\s+' + '(' + src[t.XRANGEPLAIN] + ')' + '\\s*$';
		      tok('HYPHENRANGELOOSE');
		      src[t.HYPHENRANGELOOSE] = '^\\s*(' + src[t.XRANGEPLAINLOOSE] + ')' + '\\s+-\\s+' + '(' + src[t.XRANGEPLAINLOOSE] + ')' + '\\s*$';
		      tok('STAR');
		      src[t.STAR] = '(<|>)?=?\\s*\\*';
		      for (var i = 0; i < R; i++) {
		        debug(i, src[i]);
		        if (!re[i]) {
		          re[i] = new RegExp(src[i]);
		          safeRe[i] = new RegExp(makeSafeRe(src[i]));
		        }
		      }
		      exports.parse = parse;
		      function parse(version, options) {
		        if (!options || typeof options !== 'object') {
		          options = {
		            loose: !!options,
		            includePrerelease: false
		          };
		        }
		        if (version instanceof SemVer) {
		          return version;
		        }
		        if (typeof version !== 'string') {
		          return null;
		        }
		        if (version.length > MAX_LENGTH) {
		          return null;
		        }
		        var r = options.loose ? safeRe[t.LOOSE] : safeRe[t.FULL];
		        if (!r.test(version)) {
		          return null;
		        }
		        try {
		          return new SemVer(version, options);
		        } catch (er) {
		          return null;
		        }
		      }
		      exports.valid = valid;
		      function valid(version, options) {
		        var v = parse(version, options);
		        return v ? v.version : null;
		      }
		      exports.clean = clean;
		      function clean(version, options) {
		        var s = parse(version.trim().replace(/^[=v]+/, ''), options);
		        return s ? s.version : null;
		      }
		      exports.SemVer = SemVer;
		      function SemVer(version, options) {
		        if (!options || typeof options !== 'object') {
		          options = {
		            loose: !!options,
		            includePrerelease: false
		          };
		        }
		        if (version instanceof SemVer) {
		          if (version.loose === options.loose) {
		            return version;
		          } else {
		            version = version.version;
		          }
		        } else if (typeof version !== 'string') {
		          throw new TypeError('Invalid Version: ' + version);
		        }
		        if (version.length > MAX_LENGTH) {
		          throw new TypeError('version is longer than ' + MAX_LENGTH + ' characters');
		        }
		        if (!(this instanceof SemVer)) {
		          return new SemVer(version, options);
		        }
		        debug('SemVer', version, options);
		        this.options = options;
		        this.loose = !!options.loose;
		        var m = version.trim().match(options.loose ? safeRe[t.LOOSE] : safeRe[t.FULL]);
		        if (!m) {
		          throw new TypeError('Invalid Version: ' + version);
		        }
		        this.raw = version;
		        this.major = +m[1];
		        this.minor = +m[2];
		        this.patch = +m[3];
		        if (this.major > MAX_SAFE_INTEGER || this.major < 0) {
		          throw new TypeError('Invalid major version');
		        }
		        if (this.minor > MAX_SAFE_INTEGER || this.minor < 0) {
		          throw new TypeError('Invalid minor version');
		        }
		        if (this.patch > MAX_SAFE_INTEGER || this.patch < 0) {
		          throw new TypeError('Invalid patch version');
		        }
		        if (!m[4]) {
		          this.prerelease = [];
		        } else {
		          this.prerelease = m[4].split('.').map(function (id) {
		            if (/^[0-9]+$/.test(id)) {
		              var num = +id;
		              if (num >= 0 && num < MAX_SAFE_INTEGER) {
		                return num;
		              }
		            }
		            return id;
		          });
		        }
		        this.build = m[5] ? m[5].split('.') : [];
		        this.format();
		      }
		      SemVer.prototype.format = function () {
		        this.version = this.major + '.' + this.minor + '.' + this.patch;
		        if (this.prerelease.length) {
		          this.version += '-' + this.prerelease.join('.');
		        }
		        return this.version;
		      };
		      SemVer.prototype.toString = function () {
		        return this.version;
		      };
		      SemVer.prototype.compare = function (other) {
		        debug('SemVer.compare', this.version, this.options, other);
		        if (!(other instanceof SemVer)) {
		          other = new SemVer(other, this.options);
		        }
		        return this.compareMain(other) || this.comparePre(other);
		      };
		      SemVer.prototype.compareMain = function (other) {
		        if (!(other instanceof SemVer)) {
		          other = new SemVer(other, this.options);
		        }
		        return compareIdentifiers(this.major, other.major) || compareIdentifiers(this.minor, other.minor) || compareIdentifiers(this.patch, other.patch);
		      };
		      SemVer.prototype.comparePre = function (other) {
		        if (!(other instanceof SemVer)) {
		          other = new SemVer(other, this.options);
		        }
		        if (this.prerelease.length && !other.prerelease.length) {
		          return -1;
		        } else if (!this.prerelease.length && other.prerelease.length) {
		          return 1;
		        } else if (!this.prerelease.length && !other.prerelease.length) {
		          return 0;
		        }
		        var i = 0;
		        do {
		          var a = this.prerelease[i];
		          var b = other.prerelease[i];
		          debug('prerelease compare', i, a, b);
		          if (a === undefined && b === undefined) {
		            return 0;
		          } else if (b === undefined) {
		            return 1;
		          } else if (a === undefined) {
		            return -1;
		          } else if (a === b) {
		            continue;
		          } else {
		            return compareIdentifiers(a, b);
		          }
		        } while (++i);
		      };
		      SemVer.prototype.compareBuild = function (other) {
		        if (!(other instanceof SemVer)) {
		          other = new SemVer(other, this.options);
		        }
		        var i = 0;
		        do {
		          var a = this.build[i];
		          var b = other.build[i];
		          debug('prerelease compare', i, a, b);
		          if (a === undefined && b === undefined) {
		            return 0;
		          } else if (b === undefined) {
		            return 1;
		          } else if (a === undefined) {
		            return -1;
		          } else if (a === b) {
		            continue;
		          } else {
		            return compareIdentifiers(a, b);
		          }
		        } while (++i);
		      };
		      SemVer.prototype.inc = function (release, identifier) {
		        switch (release) {
		          case 'premajor':
		            this.prerelease.length = 0;
		            this.patch = 0;
		            this.minor = 0;
		            this.major++;
		            this.inc('pre', identifier);
		            break;
		          case 'preminor':
		            this.prerelease.length = 0;
		            this.patch = 0;
		            this.minor++;
		            this.inc('pre', identifier);
		            break;
		          case 'prepatch':
		            this.prerelease.length = 0;
		            this.inc('patch', identifier);
		            this.inc('pre', identifier);
		            break;
		          case 'prerelease':
		            if (this.prerelease.length === 0) {
		              this.inc('patch', identifier);
		            }
		            this.inc('pre', identifier);
		            break;
		          case 'major':
		            if (this.minor !== 0 || this.patch !== 0 || this.prerelease.length === 0) {
		              this.major++;
		            }
		            this.minor = 0;
		            this.patch = 0;
		            this.prerelease = [];
		            break;
		          case 'minor':
		            if (this.patch !== 0 || this.prerelease.length === 0) {
		              this.minor++;
		            }
		            this.patch = 0;
		            this.prerelease = [];
		            break;
		          case 'patch':
		            if (this.prerelease.length === 0) {
		              this.patch++;
		            }
		            this.prerelease = [];
		            break;
		          case 'pre':
		            if (this.prerelease.length === 0) {
		              this.prerelease = [0];
		            } else {
		              var i = this.prerelease.length;
		              while (--i >= 0) {
		                if (typeof this.prerelease[i] === 'number') {
		                  this.prerelease[i]++;
		                  i = -2;
		                }
		              }
		              if (i === -1) {
		                this.prerelease.push(0);
		              }
		            }
		            if (identifier) {
		              if (this.prerelease[0] === identifier) {
		                if (isNaN(this.prerelease[1])) {
		                  this.prerelease = [identifier, 0];
		                }
		              } else {
		                this.prerelease = [identifier, 0];
		              }
		            }
		            break;
		          default:
		            throw new Error('invalid increment argument: ' + release);
		        }
		        this.format();
		        this.raw = this.version;
		        return this;
		      };
		      exports.inc = inc;
		      function inc(version, release, loose, identifier) {
		        if (typeof loose === 'string') {
		          identifier = loose;
		          loose = undefined;
		        }
		        try {
		          return new SemVer(version, loose).inc(release, identifier).version;
		        } catch (er) {
		          return null;
		        }
		      }
		      exports.diff = diff;
		      function diff(version1, version2) {
		        if (eq(version1, version2)) {
		          return null;
		        } else {
		          var v1 = parse(version1);
		          var v2 = parse(version2);
		          var prefix = '';
		          if (v1.prerelease.length || v2.prerelease.length) {
		            prefix = 'pre';
		            var defaultResult = 'prerelease';
		          }
		          for (var key in v1) {
		            if (key === 'major' || key === 'minor' || key === 'patch') {
		              if (v1[key] !== v2[key]) {
		                return prefix + key;
		              }
		            }
		          }
		          return defaultResult;
		        }
		      }
		      exports.compareIdentifiers = compareIdentifiers;
		      var numeric = /^[0-9]+$/;
		      function compareIdentifiers(a, b) {
		        var anum = numeric.test(a);
		        var bnum = numeric.test(b);
		        if (anum && bnum) {
		          a = +a;
		          b = +b;
		        }
		        return a === b ? 0 : anum && !bnum ? -1 : bnum && !anum ? 1 : a < b ? -1 : 1;
		      }
		      exports.rcompareIdentifiers = rcompareIdentifiers;
		      function rcompareIdentifiers(a, b) {
		        return compareIdentifiers(b, a);
		      }
		      exports.major = major;
		      function major(a, loose) {
		        return new SemVer(a, loose).major;
		      }
		      exports.minor = minor;
		      function minor(a, loose) {
		        return new SemVer(a, loose).minor;
		      }
		      exports.patch = patch;
		      function patch(a, loose) {
		        return new SemVer(a, loose).patch;
		      }
		      exports.compare = compare;
		      function compare(a, b, loose) {
		        return new SemVer(a, loose).compare(new SemVer(b, loose));
		      }
		      exports.compareLoose = compareLoose;
		      function compareLoose(a, b) {
		        return compare(a, b, true);
		      }
		      exports.compareBuild = compareBuild;
		      function compareBuild(a, b, loose) {
		        var versionA = new SemVer(a, loose);
		        var versionB = new SemVer(b, loose);
		        return versionA.compare(versionB) || versionA.compareBuild(versionB);
		      }
		      exports.rcompare = rcompare;
		      function rcompare(a, b, loose) {
		        return compare(b, a, loose);
		      }
		      exports.sort = sort;
		      function sort(list, loose) {
		        return list.sort(function (a, b) {
		          return exports.compareBuild(a, b, loose);
		        });
		      }
		      exports.rsort = rsort;
		      function rsort(list, loose) {
		        return list.sort(function (a, b) {
		          return exports.compareBuild(b, a, loose);
		        });
		      }
		      exports.gt = gt;
		      function gt(a, b, loose) {
		        return compare(a, b, loose) > 0;
		      }
		      exports.lt = lt;
		      function lt(a, b, loose) {
		        return compare(a, b, loose) < 0;
		      }
		      exports.eq = eq;
		      function eq(a, b, loose) {
		        return compare(a, b, loose) === 0;
		      }
		      exports.neq = neq;
		      function neq(a, b, loose) {
		        return compare(a, b, loose) !== 0;
		      }
		      exports.gte = gte;
		      function gte(a, b, loose) {
		        return compare(a, b, loose) >= 0;
		      }
		      exports.lte = lte;
		      function lte(a, b, loose) {
		        return compare(a, b, loose) <= 0;
		      }
		      exports.cmp = cmp;
		      function cmp(a, op, b, loose) {
		        switch (op) {
		          case '===':
		            if (typeof a === 'object') a = a.version;
		            if (typeof b === 'object') b = b.version;
		            return a === b;
		          case '!==':
		            if (typeof a === 'object') a = a.version;
		            if (typeof b === 'object') b = b.version;
		            return a !== b;
		          case '':
		          case '=':
		          case '==':
		            return eq(a, b, loose);
		          case '!=':
		            return neq(a, b, loose);
		          case '>':
		            return gt(a, b, loose);
		          case '>=':
		            return gte(a, b, loose);
		          case '<':
		            return lt(a, b, loose);
		          case '<=':
		            return lte(a, b, loose);
		          default:
		            throw new TypeError('Invalid operator: ' + op);
		        }
		      }
		      exports.Comparator = Comparator;
		      function Comparator(comp, options) {
		        if (!options || typeof options !== 'object') {
		          options = {
		            loose: !!options,
		            includePrerelease: false
		          };
		        }
		        if (comp instanceof Comparator) {
		          if (comp.loose === !!options.loose) {
		            return comp;
		          } else {
		            comp = comp.value;
		          }
		        }
		        if (!(this instanceof Comparator)) {
		          return new Comparator(comp, options);
		        }
		        comp = comp.trim().split(/\s+/).join(' ');
		        debug('comparator', comp, options);
		        this.options = options;
		        this.loose = !!options.loose;
		        this.parse(comp);
		        if (this.semver === ANY) {
		          this.value = '';
		        } else {
		          this.value = this.operator + this.semver.version;
		        }
		        debug('comp', this);
		      }
		      var ANY = {};
		      Comparator.prototype.parse = function (comp) {
		        var r = this.options.loose ? safeRe[t.COMPARATORLOOSE] : safeRe[t.COMPARATOR];
		        var m = comp.match(r);
		        if (!m) {
		          throw new TypeError('Invalid comparator: ' + comp);
		        }
		        this.operator = m[1] !== undefined ? m[1] : '';
		        if (this.operator === '=') {
		          this.operator = '';
		        }
		        if (!m[2]) {
		          this.semver = ANY;
		        } else {
		          this.semver = new SemVer(m[2], this.options.loose);
		        }
		      };
		      Comparator.prototype.toString = function () {
		        return this.value;
		      };
		      Comparator.prototype.test = function (version) {
		        debug('Comparator.test', version, this.options.loose);
		        if (this.semver === ANY || version === ANY) {
		          return true;
		        }
		        if (typeof version === 'string') {
		          try {
		            version = new SemVer(version, this.options);
		          } catch (er) {
		            return false;
		          }
		        }
		        return cmp(version, this.operator, this.semver, this.options);
		      };
		      Comparator.prototype.intersects = function (comp, options) {
		        if (!(comp instanceof Comparator)) {
		          throw new TypeError('a Comparator is required');
		        }
		        if (!options || typeof options !== 'object') {
		          options = {
		            loose: !!options,
		            includePrerelease: false
		          };
		        }
		        var rangeTmp;
		        if (this.operator === '') {
		          if (this.value === '') {
		            return true;
		          }
		          rangeTmp = new Range(comp.value, options);
		          return satisfies(this.value, rangeTmp, options);
		        } else if (comp.operator === '') {
		          if (comp.value === '') {
		            return true;
		          }
		          rangeTmp = new Range(this.value, options);
		          return satisfies(comp.semver, rangeTmp, options);
		        }
		        var sameDirectionIncreasing = (this.operator === '>=' || this.operator === '>') && (comp.operator === '>=' || comp.operator === '>');
		        var sameDirectionDecreasing = (this.operator === '<=' || this.operator === '<') && (comp.operator === '<=' || comp.operator === '<');
		        var sameSemVer = this.semver.version === comp.semver.version;
		        var differentDirectionsInclusive = (this.operator === '>=' || this.operator === '<=') && (comp.operator === '>=' || comp.operator === '<=');
		        var oppositeDirectionsLessThan = cmp(this.semver, '<', comp.semver, options) && (this.operator === '>=' || this.operator === '>') && (comp.operator === '<=' || comp.operator === '<');
		        var oppositeDirectionsGreaterThan = cmp(this.semver, '>', comp.semver, options) && (this.operator === '<=' || this.operator === '<') && (comp.operator === '>=' || comp.operator === '>');
		        return sameDirectionIncreasing || sameDirectionDecreasing || sameSemVer && differentDirectionsInclusive || oppositeDirectionsLessThan || oppositeDirectionsGreaterThan;
		      };
		      exports.Range = Range;
		      function Range(range, options) {
		        if (!options || typeof options !== 'object') {
		          options = {
		            loose: !!options,
		            includePrerelease: false
		          };
		        }
		        if (range instanceof Range) {
		          if (range.loose === !!options.loose && range.includePrerelease === !!options.includePrerelease) {
		            return range;
		          } else {
		            return new Range(range.raw, options);
		          }
		        }
		        if (range instanceof Comparator) {
		          return new Range(range.value, options);
		        }
		        if (!(this instanceof Range)) {
		          return new Range(range, options);
		        }
		        this.options = options;
		        this.loose = !!options.loose;
		        this.includePrerelease = !!options.includePrerelease;
		        this.raw = range.trim().split(/\s+/).join(' ');
		        this.set = this.raw.split('||').map(function (range) {
		          return this.parseRange(range.trim());
		        }, this).filter(function (c) {
		          return c.length;
		        });
		        if (!this.set.length) {
		          throw new TypeError('Invalid SemVer Range: ' + this.raw);
		        }
		        this.format();
		      }
		      Range.prototype.format = function () {
		        this.range = this.set.map(function (comps) {
		          return comps.join(' ').trim();
		        }).join('||').trim();
		        return this.range;
		      };
		      Range.prototype.toString = function () {
		        return this.range;
		      };
		      Range.prototype.parseRange = function (range) {
		        var loose = this.options.loose;
		        var hr = loose ? safeRe[t.HYPHENRANGELOOSE] : safeRe[t.HYPHENRANGE];
		        range = range.replace(hr, hyphenReplace);
		        debug('hyphen replace', range);
		        range = range.replace(safeRe[t.COMPARATORTRIM], comparatorTrimReplace);
		        debug('comparator trim', range, safeRe[t.COMPARATORTRIM]);
		        range = range.replace(safeRe[t.TILDETRIM], tildeTrimReplace);
		        range = range.replace(safeRe[t.CARETTRIM], caretTrimReplace);
		        range = range.split(/\s+/).join(' ');
		        var compRe = loose ? safeRe[t.COMPARATORLOOSE] : safeRe[t.COMPARATOR];
		        var set = range.split(' ').map(function (comp) {
		          return parseComparator(comp, this.options);
		        }, this).join(' ').split(/\s+/);
		        if (this.options.loose) {
		          set = set.filter(function (comp) {
		            return !!comp.match(compRe);
		          });
		        }
		        set = set.map(function (comp) {
		          return new Comparator(comp, this.options);
		        }, this);
		        return set;
		      };
		      Range.prototype.intersects = function (range, options) {
		        if (!(range instanceof Range)) {
		          throw new TypeError('a Range is required');
		        }
		        return this.set.some(function (thisComparators) {
		          return isSatisfiable(thisComparators, options) && range.set.some(function (rangeComparators) {
		            return isSatisfiable(rangeComparators, options) && thisComparators.every(function (thisComparator) {
		              return rangeComparators.every(function (rangeComparator) {
		                return thisComparator.intersects(rangeComparator, options);
		              });
		            });
		          });
		        });
		      };
		      function isSatisfiable(comparators, options) {
		        var result = true;
		        var remainingComparators = comparators.slice();
		        var testComparator = remainingComparators.pop();
		        while (result && remainingComparators.length) {
		          result = remainingComparators.every(function (otherComparator) {
		            return testComparator.intersects(otherComparator, options);
		          });
		          testComparator = remainingComparators.pop();
		        }
		        return result;
		      }
		      exports.toComparators = toComparators;
		      function toComparators(range, options) {
		        return new Range(range, options).set.map(function (comp) {
		          return comp.map(function (c) {
		            return c.value;
		          }).join(' ').trim().split(' ');
		        });
		      }
		      function parseComparator(comp, options) {
		        debug('comp', comp, options);
		        comp = replaceCarets(comp, options);
		        debug('caret', comp);
		        comp = replaceTildes(comp, options);
		        debug('tildes', comp);
		        comp = replaceXRanges(comp, options);
		        debug('xrange', comp);
		        comp = replaceStars(comp, options);
		        debug('stars', comp);
		        return comp;
		      }
		      function isX(id) {
		        return !id || id.toLowerCase() === 'x' || id === '*';
		      }
		      function replaceTildes(comp, options) {
		        return comp.trim().split(/\s+/).map(function (comp) {
		          return replaceTilde(comp, options);
		        }).join(' ');
		      }
		      function replaceTilde(comp, options) {
		        var r = options.loose ? safeRe[t.TILDELOOSE] : safeRe[t.TILDE];
		        return comp.replace(r, function (_, M, m, p, pr) {
		          debug('tilde', comp, _, M, m, p, pr);
		          var ret;
		          if (isX(M)) {
		            ret = '';
		          } else if (isX(m)) {
		            ret = '>=' + M + '.0.0 <' + (+M + 1) + '.0.0';
		          } else if (isX(p)) {
		            ret = '>=' + M + '.' + m + '.0 <' + M + '.' + (+m + 1) + '.0';
		          } else if (pr) {
		            debug('replaceTilde pr', pr);
		            ret = '>=' + M + '.' + m + '.' + p + '-' + pr + ' <' + M + '.' + (+m + 1) + '.0';
		          } else {
		            ret = '>=' + M + '.' + m + '.' + p + ' <' + M + '.' + (+m + 1) + '.0';
		          }
		          debug('tilde return', ret);
		          return ret;
		        });
		      }
		      function replaceCarets(comp, options) {
		        return comp.trim().split(/\s+/).map(function (comp) {
		          return replaceCaret(comp, options);
		        }).join(' ');
		      }
		      function replaceCaret(comp, options) {
		        debug('caret', comp, options);
		        var r = options.loose ? safeRe[t.CARETLOOSE] : safeRe[t.CARET];
		        return comp.replace(r, function (_, M, m, p, pr) {
		          debug('caret', comp, _, M, m, p, pr);
		          var ret;
		          if (isX(M)) {
		            ret = '';
		          } else if (isX(m)) {
		            ret = '>=' + M + '.0.0 <' + (+M + 1) + '.0.0';
		          } else if (isX(p)) {
		            if (M === '0') {
		              ret = '>=' + M + '.' + m + '.0 <' + M + '.' + (+m + 1) + '.0';
		            } else {
		              ret = '>=' + M + '.' + m + '.0 <' + (+M + 1) + '.0.0';
		            }
		          } else if (pr) {
		            debug('replaceCaret pr', pr);
		            if (M === '0') {
		              if (m === '0') {
		                ret = '>=' + M + '.' + m + '.' + p + '-' + pr + ' <' + M + '.' + m + '.' + (+p + 1);
		              } else {
		                ret = '>=' + M + '.' + m + '.' + p + '-' + pr + ' <' + M + '.' + (+m + 1) + '.0';
		              }
		            } else {
		              ret = '>=' + M + '.' + m + '.' + p + '-' + pr + ' <' + (+M + 1) + '.0.0';
		            }
		          } else {
		            debug('no pr');
		            if (M === '0') {
		              if (m === '0') {
		                ret = '>=' + M + '.' + m + '.' + p + ' <' + M + '.' + m + '.' + (+p + 1);
		              } else {
		                ret = '>=' + M + '.' + m + '.' + p + ' <' + M + '.' + (+m + 1) + '.0';
		              }
		            } else {
		              ret = '>=' + M + '.' + m + '.' + p + ' <' + (+M + 1) + '.0.0';
		            }
		          }
		          debug('caret return', ret);
		          return ret;
		        });
		      }
		      function replaceXRanges(comp, options) {
		        debug('replaceXRanges', comp, options);
		        return comp.split(/\s+/).map(function (comp) {
		          return replaceXRange(comp, options);
		        }).join(' ');
		      }
		      function replaceXRange(comp, options) {
		        comp = comp.trim();
		        var r = options.loose ? safeRe[t.XRANGELOOSE] : safeRe[t.XRANGE];
		        return comp.replace(r, function (ret, gtlt, M, m, p, pr) {
		          debug('xRange', comp, ret, gtlt, M, m, p, pr);
		          var xM = isX(M);
		          var xm = xM || isX(m);
		          var xp = xm || isX(p);
		          var anyX = xp;
		          if (gtlt === '=' && anyX) {
		            gtlt = '';
		          }
		          pr = options.includePrerelease ? '-0' : '';
		          if (xM) {
		            if (gtlt === '>' || gtlt === '<') {
		              ret = '<0.0.0-0';
		            } else {
		              ret = '*';
		            }
		          } else if (gtlt && anyX) {
		            if (xm) {
		              m = 0;
		            }
		            p = 0;
		            if (gtlt === '>') {
		              gtlt = '>=';
		              if (xm) {
		                M = +M + 1;
		                m = 0;
		                p = 0;
		              } else {
		                m = +m + 1;
		                p = 0;
		              }
		            } else if (gtlt === '<=') {
		              gtlt = '<';
		              if (xm) {
		                M = +M + 1;
		              } else {
		                m = +m + 1;
		              }
		            }
		            ret = gtlt + M + '.' + m + '.' + p + pr;
		          } else if (xm) {
		            ret = '>=' + M + '.0.0' + pr + ' <' + (+M + 1) + '.0.0' + pr;
		          } else if (xp) {
		            ret = '>=' + M + '.' + m + '.0' + pr + ' <' + M + '.' + (+m + 1) + '.0' + pr;
		          }
		          debug('xRange return', ret);
		          return ret;
		        });
		      }
		      function replaceStars(comp, options) {
		        debug('replaceStars', comp, options);
		        return comp.trim().replace(safeRe[t.STAR], '');
		      }
		      function hyphenReplace($0, from, fM, fm, fp, fpr, fb, to, tM, tm, tp, tpr, tb) {
		        if (isX(fM)) {
		          from = '';
		        } else if (isX(fm)) {
		          from = '>=' + fM + '.0.0';
		        } else if (isX(fp)) {
		          from = '>=' + fM + '.' + fm + '.0';
		        } else {
		          from = '>=' + from;
		        }
		        if (isX(tM)) {
		          to = '';
		        } else if (isX(tm)) {
		          to = '<' + (+tM + 1) + '.0.0';
		        } else if (isX(tp)) {
		          to = '<' + tM + '.' + (+tm + 1) + '.0';
		        } else if (tpr) {
		          to = '<=' + tM + '.' + tm + '.' + tp + '-' + tpr;
		        } else {
		          to = '<=' + to;
		        }
		        return (from + ' ' + to).trim();
		      }
		      Range.prototype.test = function (version) {
		        if (!version) {
		          return false;
		        }
		        if (typeof version === 'string') {
		          try {
		            version = new SemVer(version, this.options);
		          } catch (er) {
		            return false;
		          }
		        }
		        for (var i = 0; i < this.set.length; i++) {
		          if (testSet(this.set[i], version, this.options)) {
		            return true;
		          }
		        }
		        return false;
		      };
		      function testSet(set, version, options) {
		        for (var i = 0; i < set.length; i++) {
		          if (!set[i].test(version)) {
		            return false;
		          }
		        }
		        if (version.prerelease.length && !options.includePrerelease) {
		          for (i = 0; i < set.length; i++) {
		            debug(set[i].semver);
		            if (set[i].semver === ANY) {
		              continue;
		            }
		            if (set[i].semver.prerelease.length > 0) {
		              var allowed = set[i].semver;
		              if (allowed.major === version.major && allowed.minor === version.minor && allowed.patch === version.patch) {
		                return true;
		              }
		            }
		          }
		          return false;
		        }
		        return true;
		      }
		      exports.satisfies = satisfies;
		      function satisfies(version, range, options) {
		        try {
		          range = new Range(range, options);
		        } catch (er) {
		          return false;
		        }
		        return range.test(version);
		      }
		      exports.maxSatisfying = maxSatisfying;
		      function maxSatisfying(versions, range, options) {
		        var max = null;
		        var maxSV = null;
		        try {
		          var rangeObj = new Range(range, options);
		        } catch (er) {
		          return null;
		        }
		        versions.forEach(function (v) {
		          if (rangeObj.test(v)) {
		            if (!max || maxSV.compare(v) === -1) {
		              max = v;
		              maxSV = new SemVer(max, options);
		            }
		          }
		        });
		        return max;
		      }
		      exports.minSatisfying = minSatisfying;
		      function minSatisfying(versions, range, options) {
		        var min = null;
		        var minSV = null;
		        try {
		          var rangeObj = new Range(range, options);
		        } catch (er) {
		          return null;
		        }
		        versions.forEach(function (v) {
		          if (rangeObj.test(v)) {
		            if (!min || minSV.compare(v) === 1) {
		              min = v;
		              minSV = new SemVer(min, options);
		            }
		          }
		        });
		        return min;
		      }
		      exports.minVersion = minVersion;
		      function minVersion(range, loose) {
		        range = new Range(range, loose);
		        var minver = new SemVer('0.0.0');
		        if (range.test(minver)) {
		          return minver;
		        }
		        minver = new SemVer('0.0.0-0');
		        if (range.test(minver)) {
		          return minver;
		        }
		        minver = null;
		        for (var i = 0; i < range.set.length; ++i) {
		          var comparators = range.set[i];
		          comparators.forEach(function (comparator) {
		            var compver = new SemVer(comparator.semver.version);
		            switch (comparator.operator) {
		              case '>':
		                if (compver.prerelease.length === 0) {
		                  compver.patch++;
		                } else {
		                  compver.prerelease.push(0);
		                }
		                compver.raw = compver.format();
		              case '':
		              case '>=':
		                if (!minver || gt(minver, compver)) {
		                  minver = compver;
		                }
		                break;
		              case '<':
		              case '<=':
		                break;
		              default:
		                throw new Error('Unexpected operation: ' + comparator.operator);
		            }
		          });
		        }
		        if (minver && range.test(minver)) {
		          return minver;
		        }
		        return null;
		      }
		      exports.validRange = validRange;
		      function validRange(range, options) {
		        try {
		          return new Range(range, options).range || '*';
		        } catch (er) {
		          return null;
		        }
		      }
		      exports.ltr = ltr;
		      function ltr(version, range, options) {
		        return outside(version, range, '<', options);
		      }
		      exports.gtr = gtr;
		      function gtr(version, range, options) {
		        return outside(version, range, '>', options);
		      }
		      exports.outside = outside;
		      function outside(version, range, hilo, options) {
		        version = new SemVer(version, options);
		        range = new Range(range, options);
		        var gtfn, ltefn, ltfn, comp, ecomp;
		        switch (hilo) {
		          case '>':
		            gtfn = gt;
		            ltefn = lte;
		            ltfn = lt;
		            comp = '>';
		            ecomp = '>=';
		            break;
		          case '<':
		            gtfn = lt;
		            ltefn = gte;
		            ltfn = gt;
		            comp = '<';
		            ecomp = '<=';
		            break;
		          default:
		            throw new TypeError('Must provide a hilo val of "<" or ">"');
		        }
		        if (satisfies(version, range, options)) {
		          return false;
		        }
		        for (var i = 0; i < range.set.length; ++i) {
		          var comparators = range.set[i];
		          var high = null;
		          var low = null;
		          comparators.forEach(function (comparator) {
		            if (comparator.semver === ANY) {
		              comparator = new Comparator('>=0.0.0');
		            }
		            high = high || comparator;
		            low = low || comparator;
		            if (gtfn(comparator.semver, high.semver, options)) {
		              high = comparator;
		            } else if (ltfn(comparator.semver, low.semver, options)) {
		              low = comparator;
		            }
		          });
		          if (high.operator === comp || high.operator === ecomp) {
		            return false;
		          }
		          if ((!low.operator || low.operator === comp) && ltefn(version, low.semver)) {
		            return false;
		          } else if (low.operator === ecomp && ltfn(version, low.semver)) {
		            return false;
		          }
		        }
		        return true;
		      }
		      exports.prerelease = prerelease;
		      function prerelease(version, options) {
		        var parsed = parse(version, options);
		        return parsed && parsed.prerelease.length ? parsed.prerelease : null;
		      }
		      exports.intersects = intersects;
		      function intersects(r1, r2, options) {
		        r1 = new Range(r1, options);
		        r2 = new Range(r2, options);
		        return r1.intersects(r2);
		      }
		      exports.coerce = coerce;
		      function coerce(version, options) {
		        if (version instanceof SemVer) {
		          return version;
		        }
		        if (typeof version === 'number') {
		          version = String(version);
		        }
		        if (typeof version !== 'string') {
		          return null;
		        }
		        options = options || {};
		        var match = null;
		        if (!options.rtl) {
		          match = version.match(safeRe[t.COERCE]);
		        } else {
		          var next;
		          while ((next = safeRe[t.COERCERTL].exec(version)) && (!match || match.index + match[0].length !== version.length)) {
		            if (!match || next.index + next[0].length !== match.index + match[0].length) {
		              match = next;
		            }
		            safeRe[t.COERCERTL].lastIndex = next.index + next[1].length + next[2].length;
		          }
		          safeRe[t.COERCERTL].lastIndex = -1;
		        }
		        if (match === null) {
		          return null;
		        }
		        return parse(match[2] + '.' + (match[3] || '0') + '.' + (match[4] || '0'), options);
		      }
		    })(semver$4, semver$4.exports);
		    return semver$4.exports;
		  }

		  var hasRequiredHelpers$1;
		  function requireHelpers$1() {
		    if (hasRequiredHelpers$1) return helpers$2;
		    hasRequiredHelpers$1 = 1;
		    helpers$2.__esModule = true;
		    helpers$2.hasMinVersion = hasMinVersion;
		    var _semver = _interopRequireDefault(requireSemver$1());
		    function _interopRequireDefault(obj) {
		      return obj && obj.__esModule ? obj : {
		        "default": obj
		      };
		    }
		    function hasMinVersion(minVersion, runtimeVersion) {
		      if (!runtimeVersion || !minVersion) return true;
		      runtimeVersion = String(runtimeVersion);
		      if (_semver["default"].valid(runtimeVersion)) runtimeVersion = "^" + runtimeVersion;
		      return !_semver["default"].intersects("<" + minVersion, runtimeVersion) && !_semver["default"].intersects(">=8.0.0", runtimeVersion);
		    }
		    return helpers$2;
		  }

		  var lib$5 = {};

		  var require$$0$4 = /*@__PURE__*/getAugmentedNamespace(pluginUtilsShim);

		  var require$$1$1 = /*@__PURE__*/getAugmentedNamespace(src);

		  var utils$3 = {};

		  var require$$5 = /*@__PURE__*/getAugmentedNamespace(_babel);

		  var _templateObject$a, _templateObject2$9, _templateObject3$5;
		  var hasRequiredUtils$3;
		  function requireUtils$3() {
		    if (hasRequiredUtils$3) return utils$3;
		    hasRequiredUtils$3 = 1;
		    utils$3.__esModule = true;
		    utils$3.createUtilsGetter = createUtilsGetter;
		    utils$3.getImportSource = getImportSource;
		    utils$3.getRequireSource = getRequireSource;
		    utils$3.has = has;
		    utils$3.intersection = intersection;
		    utils$3.resolveKey = resolveKey;
		    utils$3.resolveSource = resolveSource;
		    var _babel = _interopRequireWildcard(require$$5);
		    function _getRequireWildcardCache(nodeInterop) {
		      if (typeof WeakMap !== "function") return null;
		      var cacheBabelInterop = new WeakMap();
		      var cacheNodeInterop = new WeakMap();
		      return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) {
		        return nodeInterop ? cacheNodeInterop : cacheBabelInterop;
		      })(nodeInterop);
		    }
		    function _interopRequireWildcard(obj, nodeInterop) {
		      if (!nodeInterop && obj && obj.__esModule) {
		        return obj;
		      }
		      if (obj === null || typeof obj !== "object" && typeof obj !== "function") {
		        return {
		          "default": obj
		        };
		      }
		      var cache = _getRequireWildcardCache(nodeInterop);
		      if (cache && cache.has(obj)) {
		        return cache.get(obj);
		      }
		      var newObj = {};
		      var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
		      for (var key in obj) {
		        if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) {
		          var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
		          if (desc && (desc.get || desc.set)) {
		            Object.defineProperty(newObj, key, desc);
		          } else {
		            newObj[key] = obj[key];
		          }
		        }
		      }
		      newObj["default"] = obj;
		      if (cache) {
		        cache.set(obj, newObj);
		      }
		      return newObj;
		    }
		    var _ref = _babel["default"] || _babel,
		      t = _ref.types,
		      template = _ref.template;
		    function intersection(a, b) {
		      var result = new Set();
		      a.forEach(function (v) {
		        return b.has(v) && result.add(v);
		      });
		      return result;
		    }
		    function has(object, key) {
		      return Object.prototype.hasOwnProperty.call(object, key);
		    }
		    function getType(target) {
		      return Object.prototype.toString.call(target).slice(8, -1);
		    }
		    function resolveId(path) {
		      if (path.isIdentifier() && !path.scope.hasBinding(path.node.name, true)) {
		        return path.node.name;
		      }
		      if (path.isPure()) {
		        var _path$evaluate = path.evaluate(),
		          deopt = _path$evaluate.deopt;
		        if (deopt && deopt.isIdentifier()) {
		          return deopt.node.name;
		        }
		      }
		    }
		    function resolveKey(path, computed) {
		      if (computed === void 0) {
		        computed = false;
		      }
		      var scope = path.scope;
		      if (path.isStringLiteral()) return path.node.value;
		      var isIdentifier = path.isIdentifier();
		      if (isIdentifier && !(computed || path.parent.computed)) {
		        return path.node.name;
		      }
		      if (computed && path.isMemberExpression() && path.get("object").isIdentifier({
		        name: "Symbol"
		      }) && !scope.hasBinding("Symbol", true)) {
		        var sym = resolveKey(path.get("property"), path.node.computed);
		        if (sym) return "Symbol." + sym;
		      }
		      if (isIdentifier ? scope.hasBinding(path.node.name, true) : path.isPure()) {
		        var _path$evaluate2 = path.evaluate(),
		          value = _path$evaluate2.value;
		        if (typeof value === "string") return value;
		      }
		    }
		    function resolveSource(obj) {
		      if (obj.isMemberExpression() && obj.get("property").isIdentifier({
		        name: "prototype"
		      })) {
		        var _id = resolveId(obj.get("object"));
		        if (_id) {
		          return {
		            id: _id,
		            placement: "prototype"
		          };
		        }
		        return {
		          id: null,
		          placement: null
		        };
		      }
		      var id = resolveId(obj);
		      if (id) {
		        return {
		          id: id,
		          placement: "static"
		        };
		      }
		      if (obj.isRegExpLiteral()) {
		        return {
		          id: "RegExp",
		          placement: "prototype"
		        };
		      } else if (obj.isFunction()) {
		        return {
		          id: "Function",
		          placement: "prototype"
		        };
		      } else if (obj.isPure()) {
		        var _obj$evaluate = obj.evaluate(),
		          value = _obj$evaluate.value;
		        if (value !== undefined) {
		          return {
		            id: getType(value),
		            placement: "prototype"
		          };
		        }
		      }
		      return {
		        id: null,
		        placement: null
		      };
		    }
		    function getImportSource(_ref2) {
		      var node = _ref2.node;
		      if (node.specifiers.length === 0) return node.source.value;
		    }
		    function getRequireSource(_ref3) {
		      var node = _ref3.node;
		      if (!t.isExpressionStatement(node)) return;
		      var expression = node.expression;
		      if (t.isCallExpression(expression) && t.isIdentifier(expression.callee) && expression.callee.name === "require" && expression.arguments.length === 1 && t.isStringLiteral(expression.arguments[0])) {
		        return expression.arguments[0].value;
		      }
		    }
		    function hoist(node) {
		      node._blockHoist = 3;
		      return node;
		    }
		    function createUtilsGetter(cache) {
		      return function (path) {
		        var prog = path.findParent(function (p) {
		          return p.isProgram();
		        });
		        return {
		          injectGlobalImport: function injectGlobalImport(url, moduleName) {
		            cache.storeAnonymous(prog, url, moduleName, function (isScript, source) {
		              return isScript ? template.statement.ast(_templateObject$a || (_templateObject$a = _taggedTemplateLiteralLoose(["require(", ")"])), source) : t.importDeclaration([], source);
		            });
		          },
		          injectNamedImport: function injectNamedImport(url, name, hint, moduleName) {
		            if (hint === void 0) {
		              hint = name;
		            }
		            return cache.storeNamed(prog, url, name, moduleName, function (isScript, source, name) {
		              var id = prog.scope.generateUidIdentifier(hint);
		              return {
		                node: isScript ? hoist(template.statement.ast(_templateObject2$9 || (_templateObject2$9 = _taggedTemplateLiteralLoose(["\n                  var ", " = require(", ").", "\n                "])), id, source, name)) : t.importDeclaration([t.importSpecifier(id, name)], source),
		                name: id.name
		              };
		            });
		          },
		          injectDefaultImport: function injectDefaultImport(url, hint, moduleName) {
		            if (hint === void 0) {
		              hint = url;
		            }
		            return cache.storeNamed(prog, url, "default", moduleName, function (isScript, source) {
		              var id = prog.scope.generateUidIdentifier(hint);
		              return {
		                node: isScript ? hoist(template.statement.ast(_templateObject3$5 || (_templateObject3$5 = _taggedTemplateLiteralLoose(["var ", " = require(", ")"])), id, source)) : t.importDeclaration([t.importDefaultSpecifier(id)], source),
		                name: id.name
		              };
		            });
		          }
		        };
		      };
		    }
		    return utils$3;
		  }

		  var importsInjector$1 = {};

		  var hasRequiredImportsInjector$1;
		  function requireImportsInjector$1() {
		    if (hasRequiredImportsInjector$1) return importsInjector$1;
		    hasRequiredImportsInjector$1 = 1;
		    importsInjector$1.__esModule = true;
		    importsInjector$1["default"] = void 0;
		    var _babel = _interopRequireWildcard(require$$5);
		    function _getRequireWildcardCache(nodeInterop) {
		      if (typeof WeakMap !== "function") return null;
		      var cacheBabelInterop = new WeakMap();
		      var cacheNodeInterop = new WeakMap();
		      return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) {
		        return nodeInterop ? cacheNodeInterop : cacheBabelInterop;
		      })(nodeInterop);
		    }
		    function _interopRequireWildcard(obj, nodeInterop) {
		      if (!nodeInterop && obj && obj.__esModule) {
		        return obj;
		      }
		      if (obj === null || typeof obj !== "object" && typeof obj !== "function") {
		        return {
		          "default": obj
		        };
		      }
		      var cache = _getRequireWildcardCache(nodeInterop);
		      if (cache && cache.has(obj)) {
		        return cache.get(obj);
		      }
		      var newObj = {};
		      var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
		      for (var key in obj) {
		        if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) {
		          var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
		          if (desc && (desc.get || desc.set)) {
		            Object.defineProperty(newObj, key, desc);
		          } else {
		            newObj[key] = obj[key];
		          }
		        }
		      }
		      newObj["default"] = obj;
		      if (cache) {
		        cache.set(obj, newObj);
		      }
		      return newObj;
		    }
		    var _ref = _babel["default"] || _babel,
		      t = _ref.types;
		    var ImportsCachedInjector = function () {
		      function ImportsCachedInjector(resolver, getPreferredIndex) {
		        this._imports = new WeakMap();
		        this._anonymousImports = new WeakMap();
		        this._lastImports = new WeakMap();
		        this._resolver = resolver;
		        this._getPreferredIndex = getPreferredIndex;
		      }
		      var _proto = ImportsCachedInjector.prototype;
		      _proto.storeAnonymous = function storeAnonymous(programPath, url, moduleName, getVal) {
		        var key = this._normalizeKey(programPath, url);
		        var imports = this._ensure(this._anonymousImports, programPath, Set);
		        if (imports.has(key)) return;
		        var node = getVal(programPath.node.sourceType === "script", t.stringLiteral(this._resolver(url)));
		        imports.add(key);
		        this._injectImport(programPath, node, moduleName);
		      };
		      _proto.storeNamed = function storeNamed(programPath, url, name, moduleName, getVal) {
		        var key = this._normalizeKey(programPath, url, name);
		        var imports = this._ensure(this._imports, programPath, Map);
		        if (!imports.has(key)) {
		          var _getVal = getVal(programPath.node.sourceType === "script", t.stringLiteral(this._resolver(url)), t.identifier(name)),
		            node = _getVal.node,
		            id = _getVal.name;
		          imports.set(key, id);
		          this._injectImport(programPath, node, moduleName);
		        }
		        return t.identifier(imports.get(key));
		      };
		      _proto._injectImport = function _injectImport(programPath, node, moduleName) {
		        var _this$_lastImports$ge;
		        var newIndex = this._getPreferredIndex(moduleName);
		        var lastImports = (_this$_lastImports$ge = this._lastImports.get(programPath)) != null ? _this$_lastImports$ge : [];
		        var isPathStillValid = function isPathStillValid(path) {
		          return path.node && path.parent === programPath.node && path.container === programPath.node.body;
		        };
		        var last;
		        if (newIndex === Infinity) {
		          if (lastImports.length > 0) {
		            last = lastImports[lastImports.length - 1].path;
		            if (!isPathStillValid(last)) last = undefined;
		          }
		        } else {
		          for (var _iterator = _createForOfIteratorHelperLoose(lastImports.entries()), _step; !(_step = _iterator()).done;) {
		            var _step$value = _slicedToArray(_step.value, 2),
		              i = _step$value[0],
		              data = _step$value[1];
		            var path = data.path,
		              index = data.index;
		            if (isPathStillValid(path)) {
		              if (newIndex < index) {
		                var _path$insertBefore = path.insertBefore(node),
		                  _path$insertBefore2 = _slicedToArray(_path$insertBefore, 1),
		                  newPath = _path$insertBefore2[0];
		                lastImports.splice(i, 0, {
		                  path: newPath,
		                  index: newIndex
		                });
		                return;
		              }
		              last = path;
		            }
		          }
		        }
		        if (last) {
		          var _last$insertAfter = last.insertAfter(node),
		            _last$insertAfter2 = _slicedToArray(_last$insertAfter, 1),
		            _newPath = _last$insertAfter2[0];
		          lastImports.push({
		            path: _newPath,
		            index: newIndex
		          });
		        } else {
		          var _programPath$unshiftC = programPath.unshiftContainer("body", node),
		            _programPath$unshiftC2 = _slicedToArray(_programPath$unshiftC, 1),
		            _newPath2 = _programPath$unshiftC2[0];
		          this._lastImports.set(programPath, [{
		            path: _newPath2,
		            index: newIndex
		          }]);
		        }
		      };
		      _proto._ensure = function _ensure(map, programPath, Collection) {
		        var collection = map.get(programPath);
		        if (!collection) {
		          collection = new Collection();
		          map.set(programPath, collection);
		        }
		        return collection;
		      };
		      _proto._normalizeKey = function _normalizeKey(programPath, url, name) {
		        if (name === void 0) {
		          name = "";
		        }
		        var sourceType = programPath.node.sourceType;
		        return (name && sourceType) + "::" + url + "::" + name;
		      };
		      return _createClass(ImportsCachedInjector);
		    }();
		    importsInjector$1["default"] = ImportsCachedInjector;
		    return importsInjector$1;
		  }

		  var debugUtils$1 = {};

		  var hasRequiredDebugUtils$1;
		  function requireDebugUtils$1() {
		    if (hasRequiredDebugUtils$1) return debugUtils$1;
		    hasRequiredDebugUtils$1 = 1;
		    debugUtils$1.__esModule = true;
		    debugUtils$1.presetEnvSilentDebugHeader = void 0;
		    debugUtils$1.stringifyTargets = stringifyTargets;
		    debugUtils$1.stringifyTargetsMultiline = stringifyTargetsMultiline;
		    var _helperCompilationTargets = require$$1$1;
		    var presetEnvSilentDebugHeader = "#__secret_key__@babel/preset-env__don't_log_debug_header_and_resolved_targets";
		    debugUtils$1.presetEnvSilentDebugHeader = presetEnvSilentDebugHeader;
		    function stringifyTargetsMultiline(targets) {
		      return JSON.stringify((0, _helperCompilationTargets.prettifyTargets)(targets), null, 2);
		    }
		    function stringifyTargets(targets) {
		      return JSON.stringify(targets).replace(/,/g, ", ").replace(/^\{"/, '{ "').replace(/"\}$/, '" }');
		    }
		    return debugUtils$1;
		  }

		  var normalizeOptions$5 = {};

		  var hasRequiredNormalizeOptions$1;
		  function requireNormalizeOptions$1() {
		    if (hasRequiredNormalizeOptions$1) return normalizeOptions$5;
		    hasRequiredNormalizeOptions$1 = 1;
		    normalizeOptions$5.__esModule = true;
		    normalizeOptions$5.applyMissingDependenciesDefaults = applyMissingDependenciesDefaults;
		    normalizeOptions$5.validateIncludeExclude = validateIncludeExclude;
		    var _utils = requireUtils$3();
		    function patternToRegExp(pattern) {
		      if (pattern instanceof RegExp) return pattern;
		      try {
		        return new RegExp("^" + pattern + "$");
		      } catch (_unused) {
		        return null;
		      }
		    }
		    function buildUnusedError(label, unused) {
		      if (!unused.length) return "";
		      return "  - The following \"" + label + "\" patterns didn't match any polyfill:\n" + unused.map(function (original) {
		        return "    " + String(original) + "\n";
		      }).join("");
		    }
		    function buldDuplicatesError(duplicates) {
		      if (!duplicates.size) return "";
		      return "  - The following polyfills were matched both by \"include\" and \"exclude\" patterns:\n" + Array.from(duplicates, function (name) {
		        return "    " + name + "\n";
		      }).join("");
		    }
		    function validateIncludeExclude(provider, polyfills, includePatterns, excludePatterns) {
		      var current;
		      var filter = function filter(pattern) {
		        var regexp = patternToRegExp(pattern);
		        if (!regexp) return false;
		        var matched = false;
		        for (var _iterator = _createForOfIteratorHelperLoose(polyfills.keys()), _step; !(_step = _iterator()).done;) {
		          var polyfill = _step.value;
		          if (regexp.test(polyfill)) {
		            matched = true;
		            current.add(polyfill);
		          }
		        }
		        return !matched;
		      };
		      var include = current = new Set();
		      var unusedInclude = Array.from(includePatterns).filter(filter);
		      var exclude = current = new Set();
		      var unusedExclude = Array.from(excludePatterns).filter(filter);
		      var duplicates = (0, _utils.intersection)(include, exclude);
		      if (duplicates.size > 0 || unusedInclude.length > 0 || unusedExclude.length > 0) {
		        throw new Error("Error while validating the \"" + provider + "\" provider options:\n" + buildUnusedError("include", unusedInclude) + buildUnusedError("exclude", unusedExclude) + buldDuplicatesError(duplicates));
		      }
		      return {
		        include: include,
		        exclude: exclude
		      };
		    }
		    function applyMissingDependenciesDefaults(options, babelApi) {
		      var _options$missingDepen = options.missingDependencies,
		        missingDependencies = _options$missingDepen === void 0 ? {} : _options$missingDepen;
		      if (missingDependencies === false) return false;
		      var caller = babelApi.caller(function (caller) {
		        return caller == null ? void 0 : caller.name;
		      });
		      var _missingDependencies$ = missingDependencies.log,
		        log = _missingDependencies$ === void 0 ? "deferred" : _missingDependencies$,
		        _missingDependencies$2 = missingDependencies.inject,
		        inject = _missingDependencies$2 === void 0 ? caller === "rollup-plugin-babel" ? "throw" : "import" : _missingDependencies$2,
		        _missingDependencies$3 = missingDependencies.all,
		        all = _missingDependencies$3 === void 0 ? false : _missingDependencies$3;
		      return {
		        log: log,
		        inject: inject,
		        all: all
		      };
		    }
		    return normalizeOptions$5;
		  }

		  var visitors$1 = {};

		  var usage$2 = {};

		  var hasRequiredUsage$1;
		  function requireUsage$1() {
		    if (hasRequiredUsage$1) return usage$2;
		    hasRequiredUsage$1 = 1;
		    usage$2.__esModule = true;
		    usage$2["default"] = void 0;
		    var _utils = requireUtils$3();
		    function isRemoved(path) {
		      if (path.removed) return true;
		      if (!path.parentPath) return false;
		      if (path.listKey) {
		        if (!path.parentPath.node[path.listKey].includes(path.node)) return true;
		      } else {
		        if (path.parentPath.node[path.key] !== path.node) return true;
		      }
		      return isRemoved(path.parentPath);
		    }
		    var _default = function _default(callProvider) {
		      function property(object, key, placement, path) {
		        return callProvider({
		          kind: "property",
		          object: object,
		          key: key,
		          placement: placement
		        }, path);
		      }
		      function handleReferencedIdentifier(path) {
		        var name = path.node.name,
		          scope = path.scope;
		        if (scope.getBindingIdentifier(name)) return;
		        callProvider({
		          kind: "global",
		          name: name
		        }, path);
		      }
		      function analyzeMemberExpression(path) {
		        var key = (0, _utils.resolveKey)(path.get("property"), path.node.computed);
		        return {
		          key: key,
		          handleAsMemberExpression: !!key && key !== "prototype"
		        };
		      }
		      return {
		        ReferencedIdentifier: function ReferencedIdentifier(path) {
		          var parentPath = path.parentPath;
		          if (parentPath.isMemberExpression({
		            object: path.node
		          }) && analyzeMemberExpression(parentPath).handleAsMemberExpression) {
		            return;
		          }
		          handleReferencedIdentifier(path);
		        },
		        MemberExpression: function MemberExpression(path) {
		          var _analyzeMemberExpress = analyzeMemberExpression(path),
		            key = _analyzeMemberExpress.key,
		            handleAsMemberExpression = _analyzeMemberExpress.handleAsMemberExpression;
		          if (!handleAsMemberExpression) return;
		          var object = path.get("object");
		          var objectIsGlobalIdentifier = object.isIdentifier();
		          if (objectIsGlobalIdentifier) {
		            var binding = object.scope.getBinding(object.node.name);
		            if (binding) {
		              if (binding.path.isImportNamespaceSpecifier()) return;
		              objectIsGlobalIdentifier = false;
		            }
		          }
		          var source = (0, _utils.resolveSource)(object);
		          var skipObject = property(source.id, key, source.placement, path);
		          skipObject || (skipObject = !objectIsGlobalIdentifier || path.shouldSkip || object.shouldSkip || isRemoved(object));
		          if (!skipObject) handleReferencedIdentifier(object);
		        },
		        ObjectPattern: function ObjectPattern(path) {
		          var parentPath = path.parentPath,
		            parent = path.parent;
		          var obj;
		          if (parentPath.isVariableDeclarator()) {
		            obj = parentPath.get("init");
		          } else if (parentPath.isAssignmentExpression()) {
		            obj = parentPath.get("right");
		          } else if (parentPath.isFunction()) {
		            var grand = parentPath.parentPath;
		            if (grand.isCallExpression() || grand.isNewExpression()) {
		              if (grand.node.callee === parent) {
		                obj = grand.get("arguments")[path.key];
		              }
		            }
		          }
		          var id = null;
		          var placement = null;
		          if (obj) {
		            var _ref = (0, _utils.resolveSource)(obj);
		            id = _ref.id;
		            placement = _ref.placement;
		          }
		          for (var _iterator = _createForOfIteratorHelperLoose(path.get("properties")), _step; !(_step = _iterator()).done;) {
		            var prop = _step.value;
		            if (prop.isObjectProperty()) {
		              var key = (0, _utils.resolveKey)(prop.get("key"));
		              if (key) property(id, key, placement, prop);
		            }
		          }
		        },
		        BinaryExpression: function BinaryExpression(path) {
		          if (path.node.operator !== "in") return;
		          var source = (0, _utils.resolveSource)(path.get("right"));
		          var key = (0, _utils.resolveKey)(path.get("left"), true);
		          if (!key) return;
		          callProvider({
		            kind: "in",
		            object: source.id,
		            key: key,
		            placement: source.placement
		          }, path);
		        }
		      };
		    };
		    usage$2["default"] = _default;
		    return usage$2;
		  }

		  var entry$2 = {};

		  var hasRequiredEntry$1;
		  function requireEntry$1() {
		    if (hasRequiredEntry$1) return entry$2;
		    hasRequiredEntry$1 = 1;
		    entry$2.__esModule = true;
		    entry$2["default"] = void 0;
		    var _utils = requireUtils$3();
		    var _default = function _default(callProvider) {
		      return {
		        ImportDeclaration: function ImportDeclaration(path) {
		          var source = (0, _utils.getImportSource)(path);
		          if (!source) return;
		          callProvider({
		            kind: "import",
		            source: source
		          }, path);
		        },
		        Program: function Program(path) {
		          path.get("body").forEach(function (bodyPath) {
		            var source = (0, _utils.getRequireSource)(bodyPath);
		            if (!source) return;
		            callProvider({
		              kind: "import",
		              source: source
		            }, bodyPath);
		          });
		        }
		      };
		    };
		    entry$2["default"] = _default;
		    return entry$2;
		  }

		  var hasRequiredVisitors$1;
		  function requireVisitors$1() {
		    if (hasRequiredVisitors$1) return visitors$1;
		    hasRequiredVisitors$1 = 1;
		    visitors$1.__esModule = true;
		    visitors$1.usage = visitors$1.entry = void 0;
		    var _usage = _interopRequireDefault(requireUsage$1());
		    visitors$1.usage = _usage["default"];
		    var _entry = _interopRequireDefault(requireEntry$1());
		    visitors$1.entry = _entry["default"];
		    function _interopRequireDefault(obj) {
		      return obj && obj.__esModule ? obj : {
		        "default": obj
		      };
		    }
		    return visitors$1;
		  }

		  var dependencies$1 = {};

		  var hasRequiredDependencies$1;
		  function requireDependencies$1() {
		    if (hasRequiredDependencies$1) return dependencies$1;
		    hasRequiredDependencies$1 = 1;
		    dependencies$1.__esModule = true;
		    dependencies$1.has = has;
		    dependencies$1.laterLogMissing = laterLogMissing;
		    dependencies$1.logMissing = logMissing;
		    dependencies$1.resolve = resolve;
		    function resolve(dirname, moduleName, absoluteImports) {
		      if (absoluteImports === false) return moduleName;
		      throw new Error("\"absoluteImports\" is not supported in bundles prepared for the browser.");
		    }
		    function has(basedir, name) {
		      return true;
		    }
		    function logMissing(missingDeps) {}
		    function laterLogMissing(missingDeps) {}
		    return dependencies$1;
		  }

		  var metaResolver$1 = {};

		  var hasRequiredMetaResolver$1;
		  function requireMetaResolver$1() {
		    if (hasRequiredMetaResolver$1) return metaResolver$1;
		    hasRequiredMetaResolver$1 = 1;
		    metaResolver$1.__esModule = true;
		    metaResolver$1["default"] = createMetaResolver;
		    var _utils = requireUtils$3();
		    var PossibleGlobalObjects = new Set(["global", "globalThis", "self", "window"]);
		    function createMetaResolver(polyfills) {
		      var staticP = polyfills["static"],
		        instanceP = polyfills.instance,
		        globalP = polyfills.global;
		      return function (meta) {
		        if (meta.kind === "global" && globalP && (0, _utils.has)(globalP, meta.name)) {
		          return {
		            kind: "global",
		            desc: globalP[meta.name],
		            name: meta.name
		          };
		        }
		        if (meta.kind === "property" || meta.kind === "in") {
		          var placement = meta.placement,
		            object = meta.object,
		            key = meta.key;
		          if (object && placement === "static") {
		            if (globalP && PossibleGlobalObjects.has(object) && (0, _utils.has)(globalP, key)) {
		              return {
		                kind: "global",
		                desc: globalP[key],
		                name: key
		              };
		            }
		            if (staticP && (0, _utils.has)(staticP, object) && (0, _utils.has)(staticP[object], key)) {
		              return {
		                kind: "static",
		                desc: staticP[object][key],
		                name: object + "$" + key
		              };
		            }
		          }
		          if (instanceP && (0, _utils.has)(instanceP, key)) {
		            return {
		              kind: "instance",
		              desc: instanceP[key],
		              name: "" + key
		            };
		          }
		        }
		      };
		    }
		    return metaResolver$1;
		  }

		  var hasRequiredLib$6;
		  function requireLib$6() {
		    if (hasRequiredLib$6) return lib$5;
		    hasRequiredLib$6 = 1;
		    lib$5.__esModule = true;
		    lib$5["default"] = definePolyfillProvider;
		    var _helperPluginUtils = require$$0$4;
		    var _helperCompilationTargets = _interopRequireWildcard(require$$1$1);
		    var _utils = requireUtils$3();
		    var _importsInjector = _interopRequireDefault(requireImportsInjector$1());
		    var _debugUtils = requireDebugUtils$1();
		    var _normalizeOptions = requireNormalizeOptions$1();
		    var v = _interopRequireWildcard(requireVisitors$1());
		    var deps = _interopRequireWildcard(requireDependencies$1());
		    var _metaResolver = _interopRequireDefault(requireMetaResolver$1());
		    var _excluded = ["method", "targets", "ignoreBrowserslistConfig", "configPath", "debug", "shouldInjectPolyfill", "absoluteImports"];
		    function _interopRequireDefault(obj) {
		      return obj && obj.__esModule ? obj : {
		        "default": obj
		      };
		    }
		    function _getRequireWildcardCache(nodeInterop) {
		      if (typeof WeakMap !== "function") return null;
		      var cacheBabelInterop = new WeakMap();
		      var cacheNodeInterop = new WeakMap();
		      return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) {
		        return nodeInterop ? cacheNodeInterop : cacheBabelInterop;
		      })(nodeInterop);
		    }
		    function _interopRequireWildcard(obj, nodeInterop) {
		      if (!nodeInterop && obj && obj.__esModule) {
		        return obj;
		      }
		      if (obj === null || typeof obj !== "object" && typeof obj !== "function") {
		        return {
		          "default": obj
		        };
		      }
		      var cache = _getRequireWildcardCache(nodeInterop);
		      if (cache && cache.has(obj)) {
		        return cache.get(obj);
		      }
		      var newObj = {};
		      var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
		      for (var key in obj) {
		        if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) {
		          var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
		          if (desc && (desc.get || desc.set)) {
		            Object.defineProperty(newObj, key, desc);
		          } else {
		            newObj[key] = obj[key];
		          }
		        }
		      }
		      newObj["default"] = obj;
		      if (cache) {
		        cache.set(obj, newObj);
		      }
		      return newObj;
		    }
		    function _objectWithoutPropertiesLoose(source, excluded) {
		      if (source == null) return {};
		      var target = {};
		      var sourceKeys = Object.keys(source);
		      var key, i;
		      for (i = 0; i < sourceKeys.length; i++) {
		        key = sourceKeys[i];
		        if (excluded.indexOf(key) >= 0) continue;
		        target[key] = source[key];
		      }
		      return target;
		    }
		    var getTargets = _helperCompilationTargets["default"]["default"] || _helperCompilationTargets["default"];
		    function resolveOptions(options, babelApi) {
		      var method = options.method,
		        targetsOption = options.targets,
		        ignoreBrowserslistConfig = options.ignoreBrowserslistConfig,
		        configPath = options.configPath,
		        debug = options.debug,
		        shouldInjectPolyfill = options.shouldInjectPolyfill,
		        absoluteImports = options.absoluteImports,
		        providerOptions = _objectWithoutPropertiesLoose(options, _excluded);
		      if (isEmpty(options)) {
		        throw new Error("This plugin requires options, for example:\n    {\n      \"plugins\": [\n        [\"<plugin name>\", { method: \"usage-pure\" }]\n      ]\n    }\n\nSee more options at https://github.com/babel/babel-polyfills/blob/main/docs/usage.md");
		      }
		      var methodName;
		      if (method === "usage-global") methodName = "usageGlobal";else if (method === "entry-global") methodName = "entryGlobal";else if (method === "usage-pure") methodName = "usagePure";else if (typeof method !== "string") {
		        throw new Error(".method must be a string");
		      } else {
		        throw new Error(".method must be one of \"entry-global\", \"usage-global\"" + (" or \"usage-pure\" (received " + JSON.stringify(method) + ")"));
		      }
		      if (typeof shouldInjectPolyfill === "function") {
		        if (options.include || options.exclude) {
		          throw new Error(".include and .exclude are not supported when using the" + " .shouldInjectPolyfill function.");
		        }
		      } else if (shouldInjectPolyfill != null) {
		        throw new Error(".shouldInjectPolyfill must be a function, or undefined" + (" (received " + JSON.stringify(shouldInjectPolyfill) + ")"));
		      }
		      if (absoluteImports != null && typeof absoluteImports !== "boolean" && typeof absoluteImports !== "string") {
		        throw new Error(".absoluteImports must be a boolean, a string, or undefined" + (" (received " + JSON.stringify(absoluteImports) + ")"));
		      }
		      var targets;
		      if (targetsOption || configPath || ignoreBrowserslistConfig) {
		        var targetsObj = typeof targetsOption === "string" || Array.isArray(targetsOption) ? {
		          browsers: targetsOption
		        } : targetsOption;
		        targets = getTargets(targetsObj, {
		          ignoreBrowserslistConfig: ignoreBrowserslistConfig,
		          configPath: configPath
		        });
		      } else {
		        targets = babelApi.targets();
		      }
		      return {
		        method: method,
		        methodName: methodName,
		        targets: targets,
		        absoluteImports: absoluteImports != null ? absoluteImports : false,
		        shouldInjectPolyfill: shouldInjectPolyfill,
		        debug: !!debug,
		        providerOptions: providerOptions
		      };
		    }
		    function instantiateProvider(factory, options, missingDependencies, dirname, debugLog, babelApi) {
		      var _resolveOptions = resolveOptions(options, babelApi),
		        method = _resolveOptions.method,
		        methodName = _resolveOptions.methodName,
		        targets = _resolveOptions.targets,
		        _debug = _resolveOptions.debug,
		        _shouldInjectPolyfill = _resolveOptions.shouldInjectPolyfill,
		        providerOptions = _resolveOptions.providerOptions,
		        absoluteImports = _resolveOptions.absoluteImports;
		      var include, exclude;
		      var polyfillsSupport;
		      var polyfillsNames;
		      var filterPolyfills;
		      var getUtils = (0, _utils.createUtilsGetter)(new _importsInjector["default"](function (moduleName) {
		        return deps.resolve(dirname, moduleName, absoluteImports);
		      }, function (name) {
		        var _polyfillsNames$get, _polyfillsNames;
		        return (_polyfillsNames$get = (_polyfillsNames = polyfillsNames) == null ? void 0 : _polyfillsNames.get(name)) != null ? _polyfillsNames$get : Infinity;
		      }));
		      var depsCache = new Map();
		      var api = {
		        babel: babelApi,
		        getUtils: getUtils,
		        method: options.method,
		        targets: targets,
		        createMetaResolver: _metaResolver["default"],
		        shouldInjectPolyfill: function shouldInjectPolyfill(name) {
		          if (polyfillsNames === undefined) {
		            throw new Error("Internal error in the " + factory.name + " provider: " + "shouldInjectPolyfill() can't be called during initialization.");
		          }
		          if (!polyfillsNames.has(name)) {
		            console.warn("Internal error in the " + providerName + " provider: " + ("unknown polyfill \"" + name + "\"."));
		          }
		          if (filterPolyfills && !filterPolyfills(name)) return false;
		          var shouldInject = (0, _helperCompilationTargets.isRequired)(name, targets, {
		            compatData: polyfillsSupport,
		            includes: include,
		            excludes: exclude
		          });
		          if (_shouldInjectPolyfill) {
		            shouldInject = _shouldInjectPolyfill(name, shouldInject);
		            if (typeof shouldInject !== "boolean") {
		              throw new Error(".shouldInjectPolyfill must return a boolean.");
		            }
		          }
		          return shouldInject;
		        },
		        debug: function debug(name) {
		          var _debugLog, _debugLog$polyfillsSu;
		          debugLog().found = true;
		          if (!_debug || !name) return;
		          if (debugLog().polyfills.has(providerName)) return;
		          debugLog().polyfills.add(name);
		          (_debugLog$polyfillsSu = (_debugLog = debugLog()).polyfillsSupport) != null ? _debugLog$polyfillsSu : _debugLog.polyfillsSupport = polyfillsSupport;
		        },
		        assertDependency: function assertDependency(name, version) {
		          if (version === void 0) {
		            version = "*";
		          }
		          if (missingDependencies === false) return;
		          if (absoluteImports) {
		            return;
		          }
		          var dep = version === "*" ? name : name + "@^" + version;
		          var found = missingDependencies.all ? false : mapGetOr(depsCache, name + " :: " + dirname, function () {
		            return deps.has(dirname, name);
		          });
		          if (!found) {
		            debugLog().missingDeps.add(dep);
		          }
		        }
		      };
		      var provider = factory(api, providerOptions, dirname);
		      var providerName = provider.name || factory.name;
		      if (typeof provider[methodName] !== "function") {
		        throw new Error("The \"" + providerName + "\" provider doesn't support the \"" + method + "\" polyfilling method.");
		      }
		      if (Array.isArray(provider.polyfills)) {
		        polyfillsNames = new Map(provider.polyfills.map(function (name, index) {
		          return [name, index];
		        }));
		        filterPolyfills = provider.filterPolyfills;
		      } else if (provider.polyfills) {
		        polyfillsNames = new Map(Object.keys(provider.polyfills).map(function (name, index) {
		          return [name, index];
		        }));
		        polyfillsSupport = provider.polyfills;
		        filterPolyfills = provider.filterPolyfills;
		      } else {
		        polyfillsNames = new Map();
		      }
		      var _ref2 = (0, _normalizeOptions.validateIncludeExclude)(providerName, polyfillsNames, providerOptions.include || [], providerOptions.exclude || []);
		      include = _ref2.include;
		      exclude = _ref2.exclude;
		      var callProvider;
		      if (methodName === "usageGlobal") {
		        callProvider = function callProvider(payload, path) {
		          var _ref;
		          var utils = getUtils(path);
		          return (_ref = provider[methodName](payload, utils, path)) != null ? _ref : false;
		        };
		      } else {
		        callProvider = function callProvider(payload, path) {
		          var utils = getUtils(path);
		          provider[methodName](payload, utils, path);
		          return false;
		        };
		      }
		      return {
		        debug: _debug,
		        method: method,
		        targets: targets,
		        provider: provider,
		        providerName: providerName,
		        callProvider: callProvider
		      };
		    }
		    function definePolyfillProvider(factory) {
		      return (0, _helperPluginUtils.declare)(function (babelApi, options, dirname) {
		        babelApi.assertVersion("^7.0.0 || ^8.0.0-alpha.0");
		        var traverse = babelApi.traverse;
		        var debugLog;
		        var missingDependencies = (0, _normalizeOptions.applyMissingDependenciesDefaults)(options, babelApi);
		        var _instantiateProvider = instantiateProvider(factory, options, missingDependencies, dirname, function () {
		            return debugLog;
		          }, babelApi),
		          debug = _instantiateProvider.debug,
		          method = _instantiateProvider.method,
		          targets = _instantiateProvider.targets,
		          provider = _instantiateProvider.provider,
		          providerName = _instantiateProvider.providerName,
		          callProvider = _instantiateProvider.callProvider;
		        var createVisitor = method === "entry-global" ? v.entry : v.usage;
		        var visitor = provider.visitor ? traverse.visitors.merge([createVisitor(callProvider), provider.visitor]) : createVisitor(callProvider);
		        if (debug && debug !== _debugUtils.presetEnvSilentDebugHeader) {
		          console.log(providerName + ": `DEBUG` option");
		          console.log("\nUsing targets: " + (0, _debugUtils.stringifyTargetsMultiline)(targets));
		          console.log("\nUsing polyfills with `" + method + "` method:");
		        }
		        var runtimeName = provider.runtimeName;
		        return {
		          name: "inject-polyfills",
		          visitor: visitor,
		          pre: function pre(file) {
		            var _provider$pre;
		            if (runtimeName) {
		              if (file.get("runtimeHelpersModuleName") && file.get("runtimeHelpersModuleName") !== runtimeName) {
		                console.warn("Two different polyfill providers" + (" (" + file.get("runtimeHelpersModuleProvider")) + (" and " + providerName + ") are trying to define two") + " conflicting @babel/runtime alternatives:" + (" " + file.get("runtimeHelpersModuleName") + " and " + runtimeName + ".") + " The second one will be ignored.");
		              } else {
		                file.set("runtimeHelpersModuleName", runtimeName);
		                file.set("runtimeHelpersModuleProvider", providerName);
		              }
		            }
		            debugLog = {
		              polyfills: new Set(),
		              polyfillsSupport: undefined,
		              found: false,
		              providers: new Set(),
		              missingDeps: new Set()
		            };
		            (_provider$pre = provider.pre) == null ? void 0 : _provider$pre.apply(this, arguments);
		          },
		          post: function post() {
		            var _provider$post;
		            (_provider$post = provider.post) == null ? void 0 : _provider$post.apply(this, arguments);
		            if (missingDependencies !== false) {
		              if (missingDependencies.log === "per-file") {
		                deps.logMissing(debugLog.missingDeps);
		              } else {
		                deps.laterLogMissing(debugLog.missingDeps);
		              }
		            }
		            if (!debug) return;
		            if (this.filename) console.log("\n[" + this.filename + "]");
		            if (debugLog.polyfills.size === 0) {
		              console.log(method === "entry-global" ? debugLog.found ? "Based on your targets, the " + providerName + " polyfill did not add any polyfill." : "The entry point for the " + providerName + " polyfill has not been found." : "Based on your code and targets, the " + providerName + " polyfill did not add any polyfill.");
		              return;
		            }
		            if (method === "entry-global") {
		              console.log("The " + providerName + " polyfill entry has been replaced with " + "the following polyfills:");
		            } else {
		              console.log("The " + providerName + " polyfill added the following polyfills:");
		            }
		            for (var _iterator = _createForOfIteratorHelperLoose(debugLog.polyfills), _step; !(_step = _iterator()).done;) {
		              var name = _step.value;
		              var _debugLog$polyfillsSu2;
		              if ((_debugLog$polyfillsSu2 = debugLog.polyfillsSupport) != null && _debugLog$polyfillsSu2[name]) {
		                var filteredTargets = (0, _helperCompilationTargets.getInclusionReasons)(name, targets, debugLog.polyfillsSupport);
		                var formattedTargets = JSON.stringify(filteredTargets).replace(/,/g, ", ").replace(/^\{"/, '{ "').replace(/"\}$/, '" }');
		                console.log("  " + name + " " + formattedTargets);
		              } else {
		                console.log("  " + name);
		              }
		            }
		          }
		        };
		      });
		    }
		    function mapGetOr(map, key, getDefault) {
		      var val = map.get(key);
		      if (val === undefined) {
		        val = getDefault();
		        map.set(key, val);
		      }
		      return val;
		    }
		    function isEmpty(obj) {
		      return Object.keys(obj).length === 0;
		    }
		    return lib$5;
		  }

		  var hasRequiredLib$5;
		  function requireLib$5() {
		    if (hasRequiredLib$5) return lib$6;
		    hasRequiredLib$5 = 1;
		    lib$6.__esModule = true;
		    lib$6["default"] = void 0;
		    var _corejs2BuiltIns = _interopRequireDefault(requireCorejs2BuiltIns());
		    var _builtInDefinitions = requireBuiltInDefinitions$2();
		    var _addPlatformSpecificPolyfills = _interopRequireDefault(requireAddPlatformSpecificPolyfills$1());
		    var _helpers = requireHelpers$1();
		    var _helperDefinePolyfillProvider = _interopRequireDefault(requireLib$6());
		    var _babel = _interopRequireWildcard(require$$5);
		    function _getRequireWildcardCache(nodeInterop) {
		      if (typeof WeakMap !== "function") return null;
		      var cacheBabelInterop = new WeakMap();
		      var cacheNodeInterop = new WeakMap();
		      return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) {
		        return nodeInterop ? cacheNodeInterop : cacheBabelInterop;
		      })(nodeInterop);
		    }
		    function _interopRequireWildcard(obj, nodeInterop) {
		      if (!nodeInterop && obj && obj.__esModule) {
		        return obj;
		      }
		      if (obj === null || typeof obj !== "object" && typeof obj !== "function") {
		        return {
		          "default": obj
		        };
		      }
		      var cache = _getRequireWildcardCache(nodeInterop);
		      if (cache && cache.has(obj)) {
		        return cache.get(obj);
		      }
		      var newObj = {};
		      var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
		      for (var key in obj) {
		        if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) {
		          var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
		          if (desc && (desc.get || desc.set)) {
		            Object.defineProperty(newObj, key, desc);
		          } else {
		            newObj[key] = obj[key];
		          }
		        }
		      }
		      newObj["default"] = obj;
		      if (cache) {
		        cache.set(obj, newObj);
		      }
		      return newObj;
		    }
		    function _interopRequireDefault(obj) {
		      return obj && obj.__esModule ? obj : {
		        "default": obj
		      };
		    }
		    var _ref = _babel["default"] || _babel,
		      t = _ref.types;
		    var BABEL_RUNTIME = "@babel/runtime-corejs2";
		    var presetEnvCompat = "#__secret_key__@babel/preset-env__compatibility";
		    var runtimeCompat = "#__secret_key__@babel/runtime__compatibility";
		    var has = Function.call.bind(Object.hasOwnProperty);
		    var _default = (0, _helperDefinePolyfillProvider["default"])(function (api, _ref2) {
		      var _ref2$presetEnvCompat = _ref2[presetEnvCompat],
		        _ref2$presetEnvCompat2 = _ref2$presetEnvCompat === void 0 ? {} : _ref2$presetEnvCompat,
		        _ref2$presetEnvCompat3 = _ref2$presetEnvCompat2.entryInjectRegenerator,
		        entryInjectRegenerator = _ref2$presetEnvCompat3 === void 0 ? false : _ref2$presetEnvCompat3,
		        _ref2$presetEnvCompat4 = _ref2$presetEnvCompat2.noRuntimeName,
		        noRuntimeName = _ref2$presetEnvCompat4 === void 0 ? false : _ref2$presetEnvCompat4,
		        _ref2$runtimeCompat = _ref2[runtimeCompat],
		        _ref2$runtimeCompat2 = _ref2$runtimeCompat === void 0 ? {} : _ref2$runtimeCompat,
		        _ref2$runtimeCompat2$ = _ref2$runtimeCompat2.useBabelRuntime,
		        useBabelRuntime = _ref2$runtimeCompat2$ === void 0 ? false : _ref2$runtimeCompat2$,
		        _ref2$runtimeCompat2$2 = _ref2$runtimeCompat2.runtimeVersion,
		        runtimeVersion = _ref2$runtimeCompat2$2 === void 0 ? "" : _ref2$runtimeCompat2$2,
		        _ref2$runtimeCompat2$3 = _ref2$runtimeCompat2.ext,
		        ext = _ref2$runtimeCompat2$3 === void 0 ? ".js" : _ref2$runtimeCompat2$3;
		      var resolve = api.createMetaResolver({
		        global: _builtInDefinitions.BuiltIns,
		        "static": _builtInDefinitions.StaticProperties,
		        instance: _builtInDefinitions.InstanceProperties
		      });
		      var debug = api.debug,
		        shouldInjectPolyfill = api.shouldInjectPolyfill,
		        method = api.method;
		      var polyfills = (0, _addPlatformSpecificPolyfills["default"])(api.targets, method, _corejs2BuiltIns["default"]);
		      var coreJSBase = useBabelRuntime ? BABEL_RUNTIME + "/core-js" : method === "usage-pure" ? "core-js/library/fn" : "core-js/modules";
		      function inject(name, utils) {
		        if (typeof name === "string") {
		          if (has(polyfills, name) && shouldInjectPolyfill(name)) {
		            debug(name);
		            utils.injectGlobalImport(coreJSBase + "/" + name + ".js");
		          }
		          return;
		        }
		        name.forEach(function (name) {
		          return inject(name, utils);
		        });
		      }
		      function maybeInjectPure(desc, hint, utils) {
		        var pure = desc.pure,
		          meta = desc.meta,
		          name = desc.name;
		        if (!pure || !shouldInjectPolyfill(name)) return;
		        if (runtimeVersion && meta && meta.minRuntimeVersion && !(0, _helpers.hasMinVersion)(meta && meta.minRuntimeVersion, runtimeVersion)) {
		          return;
		        }
		        if (useBabelRuntime && pure === "symbol/index") pure = "symbol";
		        return utils.injectDefaultImport(coreJSBase + "/" + pure + ext, hint);
		      }
		      return {
		        name: "corejs2",
		        runtimeName: noRuntimeName ? null : BABEL_RUNTIME,
		        polyfills: polyfills,
		        entryGlobal: function entryGlobal(meta, utils, path) {
		          if (meta.kind === "import" && meta.source === "core-js") {
		            debug(null);
		            inject(Object.keys(polyfills), utils);
		            if (entryInjectRegenerator) {
		              utils.injectGlobalImport("regenerator-runtime/runtime.js");
		            }
		            path.remove();
		          }
		        },
		        usageGlobal: function usageGlobal(meta, utils) {
		          var resolved = resolve(meta);
		          if (!resolved) return;
		          var deps = resolved.desc.global;
		          if (resolved.kind !== "global" && "object" in meta && meta.object && meta.placement === "prototype") {
		            var low = meta.object.toLowerCase();
		            deps = deps.filter(function (m) {
		              return m.includes(low);
		            });
		          }
		          inject(deps, utils);
		        },
		        usagePure: function usagePure(meta, utils, path) {
		          if (meta.kind === "in") {
		            if (meta.key === "Symbol.iterator") {
		              path.replaceWith(t.callExpression(utils.injectDefaultImport(coreJSBase + "/is-iterable" + ext, "isIterable"), [path.node.right]));
		            }
		            return;
		          }
		          if (path.parentPath.isUnaryExpression({
		            operator: "delete"
		          })) return;
		          if (meta.kind === "property") {
		            if (!path.isMemberExpression()) return;
		            if (!path.isReferenced()) return;
		            if (meta.key === "Symbol.iterator" && shouldInjectPolyfill("es6.symbol") && path.parentPath.isCallExpression({
		              callee: path.node
		            }) && path.parentPath.node.arguments.length === 0) {
		              path.parentPath.replaceWith(t.callExpression(utils.injectDefaultImport(coreJSBase + "/get-iterator" + ext, "getIterator"), [path.node.object]));
		              path.skip();
		              return;
		            }
		          }
		          var resolved = resolve(meta);
		          if (!resolved) return;
		          var id = maybeInjectPure(resolved.desc, resolved.name, utils);
		          if (id) path.replaceWith(id);
		        },
		        visitor: method === "usage-global" && {
		          YieldExpression: function YieldExpression(path) {
		            if (path.node.delegate) {
		              inject("web.dom.iterable", api.getUtils(path));
		            }
		          },
		          "ForOfStatement|ArrayPattern": function ForOfStatementArrayPattern(path) {
		            _builtInDefinitions.CommonIterators.forEach(function (name) {
		              return inject(name, api.getUtils(path));
		            });
		          }
		        }
		      };
		    });
		    lib$6["default"] = _default;
		    return lib$6;
		  }

		  var babelPluginPolyfillCorejs2$1;
		  var hasRequiredBabelPluginPolyfillCorejs2$1;
		  function requireBabelPluginPolyfillCorejs2$1() {
		    if (hasRequiredBabelPluginPolyfillCorejs2$1) return babelPluginPolyfillCorejs2$1;
		    hasRequiredBabelPluginPolyfillCorejs2$1 = 1;
		    function bool(value) {
		      if (value == null) return false;
		      return value && value !== "false" && value !== "0";
		    }
		    babelPluginPolyfillCorejs2$1 = bool(browser$1$1.env["BABEL_8_BREAKING"]) ? null : requireLib$5();
		    return babelPluginPolyfillCorejs2$1;
		  }

		  var lib$4 = {};

		  var require$$0$3 = {
		  	"es.symbol": {
		  	android: "49",
		  	bun: "0.1.1",
		  	chrome: "49",
		  	"chrome-android": "49",
		  	deno: "1.0",
		  	edge: "15",
		  	electron: "0.37",
		  	firefox: "51",
		  	"firefox-android": "51",
		  	hermes: "0.1",
		  	ios: "10.0",
		  	node: "6.0",
		  	oculus: "3.0",
		  	opera: "36",
		  	"opera-android": "36",
		  	opera_mobile: "36",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	safari: "10.0",
		  	samsung: "5.0"
		  },
		  	"es.symbol.description": {
		  	android: "70",
		  	bun: "0.1.1",
		  	chrome: "70",
		  	"chrome-android": "70",
		  	deno: "1.0",
		  	edge: "79",
		  	electron: "5.0",
		  	firefox: "63",
		  	"firefox-android": "63",
		  	ios: "12.2",
		  	node: "11.0",
		  	oculus: "6.0",
		  	opera: "57",
		  	"opera-android": "49",
		  	opera_mobile: "49",
		  	quest: "6.0",
		  	safari: "12.1",
		  	samsung: "10.0"
		  },
		  	"es.symbol.async-iterator": {
		  	android: "63",
		  	bun: "0.1.1",
		  	chrome: "63",
		  	"chrome-android": "63",
		  	deno: "1.0",
		  	edge: "79",
		  	electron: "3.0",
		  	firefox: "55",
		  	"firefox-android": "55",
		  	ios: "12.0",
		  	node: "10.0",
		  	oculus: "5.0",
		  	opera: "50",
		  	"opera-android": "46",
		  	opera_mobile: "46",
		  	quest: "5.0",
		  	safari: "12.0",
		  	samsung: "8.0"
		  },
		  	"es.symbol.has-instance": {
		  	android: "50",
		  	bun: "0.1.1",
		  	chrome: "50",
		  	"chrome-android": "50",
		  	deno: "1.0",
		  	edge: "15",
		  	electron: "1.1",
		  	firefox: "49",
		  	"firefox-android": "49",
		  	hermes: "0.1",
		  	ios: "10.0",
		  	node: "6.0",
		  	oculus: "3.0",
		  	opera: "37",
		  	"opera-android": "37",
		  	opera_mobile: "37",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "10.0",
		  	samsung: "5.0"
		  },
		  	"es.symbol.is-concat-spreadable": {
		  	android: "48",
		  	bun: "0.1.1",
		  	chrome: "48",
		  	"chrome-android": "48",
		  	deno: "1.0",
		  	edge: "15",
		  	electron: "0.37",
		  	firefox: "48",
		  	"firefox-android": "48",
		  	hermes: "0.1",
		  	ios: "10.0",
		  	node: "6.0",
		  	oculus: "3.0",
		  	opera: "35",
		  	"opera-android": "35",
		  	opera_mobile: "35",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "10.0",
		  	samsung: "5.0"
		  },
		  	"es.symbol.iterator": {
		  	android: "41",
		  	bun: "0.1.1",
		  	chrome: "41",
		  	"chrome-android": "41",
		  	deno: "1.0",
		  	edge: "13",
		  	electron: "0.21",
		  	firefox: "36",
		  	"firefox-android": "36",
		  	hermes: "0.1",
		  	ios: "9.0",
		  	node: "1.0",
		  	oculus: "3.0",
		  	opera: "28",
		  	"opera-android": "28",
		  	opera_mobile: "28",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "9.0",
		  	samsung: "3.4"
		  },
		  	"es.symbol.match": {
		  	android: "50",
		  	bun: "0.1.1",
		  	chrome: "50",
		  	"chrome-android": "50",
		  	deno: "1.0",
		  	edge: "79",
		  	electron: "1.1",
		  	firefox: "40",
		  	"firefox-android": "40",
		  	hermes: "0.1",
		  	ios: "10.0",
		  	node: "6.0",
		  	oculus: "3.0",
		  	opera: "37",
		  	"opera-android": "37",
		  	opera_mobile: "37",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "10.0",
		  	samsung: "5.0"
		  },
		  	"es.symbol.match-all": {
		  	android: "73",
		  	bun: "0.1.1",
		  	chrome: "73",
		  	"chrome-android": "73",
		  	deno: "1.0",
		  	edge: "79",
		  	electron: "5.0",
		  	firefox: "67",
		  	"firefox-android": "67",
		  	hermes: "0.6",
		  	ios: "13.0",
		  	node: "12.0",
		  	oculus: "6.0",
		  	opera: "60",
		  	"opera-android": "52",
		  	opera_mobile: "52",
		  	quest: "6.0",
		  	"react-native": "0.69",
		  	safari: "13",
		  	samsung: "11.0"
		  },
		  	"es.symbol.replace": {
		  	android: "50",
		  	bun: "0.1.1",
		  	chrome: "50",
		  	"chrome-android": "50",
		  	deno: "1.0",
		  	edge: "79",
		  	electron: "1.1",
		  	firefox: "49",
		  	"firefox-android": "49",
		  	hermes: "0.1",
		  	ios: "10.0",
		  	node: "6.0",
		  	oculus: "3.0",
		  	opera: "37",
		  	"opera-android": "37",
		  	opera_mobile: "37",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "10.0",
		  	samsung: "5.0"
		  },
		  	"es.symbol.search": {
		  	android: "50",
		  	bun: "0.1.1",
		  	chrome: "50",
		  	"chrome-android": "50",
		  	deno: "1.0",
		  	edge: "79",
		  	electron: "1.1",
		  	firefox: "49",
		  	"firefox-android": "49",
		  	hermes: "0.1",
		  	ios: "10.0",
		  	node: "6.0",
		  	oculus: "3.0",
		  	opera: "37",
		  	"opera-android": "37",
		  	opera_mobile: "37",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "10.0",
		  	samsung: "5.0"
		  },
		  	"es.symbol.species": {
		  	android: "51",
		  	bun: "0.1.1",
		  	chrome: "51",
		  	"chrome-android": "51",
		  	deno: "1.0",
		  	edge: "13",
		  	electron: "1.2",
		  	firefox: "41",
		  	"firefox-android": "41",
		  	ios: "10.0",
		  	node: "6.5",
		  	oculus: "3.0",
		  	opera: "38",
		  	"opera-android": "38",
		  	opera_mobile: "38",
		  	quest: "3.0",
		  	rhino: "1.7.13",
		  	safari: "10.0",
		  	samsung: "5.0"
		  },
		  	"es.symbol.split": {
		  	android: "50",
		  	bun: "0.1.1",
		  	chrome: "50",
		  	"chrome-android": "50",
		  	deno: "1.0",
		  	edge: "79",
		  	electron: "1.1",
		  	firefox: "49",
		  	"firefox-android": "49",
		  	hermes: "0.1",
		  	ios: "10.0",
		  	node: "6.0",
		  	oculus: "3.0",
		  	opera: "37",
		  	"opera-android": "37",
		  	opera_mobile: "37",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "10.0",
		  	samsung: "5.0"
		  },
		  	"es.symbol.to-primitive": {
		  	android: "47",
		  	bun: "0.1.1",
		  	chrome: "47",
		  	"chrome-android": "47",
		  	deno: "1.0",
		  	edge: "15",
		  	electron: "0.36",
		  	firefox: "44",
		  	"firefox-android": "44",
		  	hermes: "0.1",
		  	ios: "10.0",
		  	node: "6.0",
		  	oculus: "3.0",
		  	opera: "34",
		  	"opera-android": "34",
		  	opera_mobile: "34",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "10.0",
		  	samsung: "5.0"
		  },
		  	"es.symbol.to-string-tag": {
		  	android: "49",
		  	bun: "0.1.1",
		  	chrome: "49",
		  	"chrome-android": "49",
		  	deno: "1.0",
		  	edge: "15",
		  	electron: "0.37",
		  	firefox: "51",
		  	"firefox-android": "51",
		  	hermes: "0.1",
		  	ios: "10.0",
		  	node: "6.0",
		  	oculus: "3.0",
		  	opera: "36",
		  	"opera-android": "36",
		  	opera_mobile: "36",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "10.0",
		  	samsung: "5.0"
		  },
		  	"es.symbol.unscopables": {
		  	android: "41",
		  	bun: "0.1.1",
		  	chrome: "41",
		  	"chrome-android": "41",
		  	deno: "1.0",
		  	edge: "13",
		  	electron: "0.21",
		  	firefox: "48",
		  	"firefox-android": "48",
		  	ios: "9.0",
		  	node: "1.0",
		  	oculus: "3.0",
		  	opera: "28",
		  	"opera-android": "28",
		  	opera_mobile: "28",
		  	quest: "3.0",
		  	rhino: "1.7.13",
		  	safari: "9.0",
		  	samsung: "3.4"
		  },
		  	"es.error.cause": {
		  	android: "94",
		  	bun: "0.1.1",
		  	chrome: "94",
		  	"chrome-android": "94",
		  	deno: "1.14",
		  	edge: "94",
		  	electron: "15.0",
		  	firefox: "91",
		  	"firefox-android": "91",
		  	hermes: "0.8",
		  	ios: "15.0",
		  	node: "16.11",
		  	oculus: "18.0",
		  	opera: "80",
		  	"opera-android": "66",
		  	opera_mobile: "66",
		  	quest: "18.0",
		  	"react-native": "0.69",
		  	safari: "15.0",
		  	samsung: "17.0"
		  },
		  	"es.error.to-string": {
		  	android: "4.4.3",
		  	bun: "0.1.1",
		  	chrome: "33",
		  	"chrome-android": "33",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.20",
		  	firefox: "11",
		  	"firefox-android": "11",
		  	hermes: "0.1",
		  	ie: "9",
		  	ios: "9.0",
		  	node: "0.11.13",
		  	oculus: "3.0",
		  	opera: "20",
		  	"opera-android": "20",
		  	opera_mobile: "20",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.14",
		  	safari: "8.0",
		  	samsung: "2.0"
		  },
		  	"es.aggregate-error": {
		  	android: "85",
		  	bun: "0.1.1",
		  	chrome: "85",
		  	"chrome-android": "85",
		  	deno: "1.2",
		  	edge: "85",
		  	electron: "10.0",
		  	firefox: "79",
		  	"firefox-android": "79",
		  	ios: "14.0",
		  	node: "15.0",
		  	oculus: "12.0",
		  	opera: "71",
		  	"opera-android": "60",
		  	opera_mobile: "60",
		  	quest: "12.0",
		  	"react-native": "0.72",
		  	safari: "14.0",
		  	samsung: "14.0"
		  },
		  	"es.aggregate-error.cause": {
		  	android: "94",
		  	bun: "0.1.1",
		  	chrome: "94",
		  	"chrome-android": "94",
		  	deno: "1.14",
		  	edge: "94",
		  	electron: "15.0",
		  	firefox: "91",
		  	"firefox-android": "91",
		  	ios: "15.0",
		  	node: "16.11",
		  	oculus: "18.0",
		  	opera: "80",
		  	"opera-android": "66",
		  	opera_mobile: "66",
		  	quest: "18.0",
		  	"react-native": "0.72",
		  	safari: "15.0",
		  	samsung: "17.0"
		  },
		  	"es.array.at": {
		  	android: "92",
		  	bun: "0.1.1",
		  	chrome: "92",
		  	"chrome-android": "92",
		  	deno: "1.12",
		  	edge: "92",
		  	electron: "14.0",
		  	firefox: "90",
		  	"firefox-android": "90",
		  	ios: "15.4",
		  	node: "16.6",
		  	oculus: "17.0",
		  	opera: "78",
		  	"opera-android": "65",
		  	opera_mobile: "65",
		  	quest: "17.0",
		  	"react-native": "0.71",
		  	safari: "15.4",
		  	samsung: "16.0"
		  },
		  	"es.array.concat": {
		  	android: "51",
		  	bun: "0.1.1",
		  	chrome: "51",
		  	"chrome-android": "51",
		  	deno: "1.0",
		  	edge: "15",
		  	electron: "1.2",
		  	firefox: "48",
		  	"firefox-android": "48",
		  	ios: "10.0",
		  	node: "6.5",
		  	oculus: "3.0",
		  	opera: "38",
		  	"opera-android": "38",
		  	opera_mobile: "38",
		  	quest: "3.0",
		  	safari: "10.0",
		  	samsung: "5.0"
		  },
		  	"es.array.copy-within": {
		  	android: "45",
		  	bun: "0.1.1",
		  	chrome: "45",
		  	"chrome-android": "45",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.31",
		  	firefox: "48",
		  	"firefox-android": "48",
		  	ios: "9.0",
		  	node: "4.0",
		  	oculus: "3.0",
		  	opera: "32",
		  	"opera-android": "32",
		  	opera_mobile: "32",
		  	quest: "3.0",
		  	safari: "9.0",
		  	samsung: "5.0"
		  },
		  	"es.array.every": {
		  	android: "4.4",
		  	bun: "0.1.1",
		  	chrome: "26",
		  	"chrome-android": "26",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.20",
		  	firefox: "4",
		  	"firefox-android": "4",
		  	hermes: "0.1",
		  	ie: "9",
		  	ios: "8.0",
		  	node: "0.11.0",
		  	oculus: "3.0",
		  	opera: "15",
		  	"opera-android": "15",
		  	opera_mobile: "15",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "7.1",
		  	samsung: "1.5"
		  },
		  	"es.array.fill": {
		  	android: "45",
		  	bun: "0.1.1",
		  	chrome: "45",
		  	"chrome-android": "45",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.31",
		  	firefox: "48",
		  	"firefox-android": "48",
		  	ios: "9.0",
		  	node: "4.0",
		  	oculus: "3.0",
		  	opera: "32",
		  	"opera-android": "32",
		  	opera_mobile: "32",
		  	quest: "3.0",
		  	safari: "9.0",
		  	samsung: "5.0"
		  },
		  	"es.array.filter": {
		  	android: "51",
		  	bun: "0.1.1",
		  	chrome: "51",
		  	"chrome-android": "51",
		  	deno: "1.0",
		  	edge: "15",
		  	electron: "1.2",
		  	firefox: "48",
		  	"firefox-android": "48",
		  	ios: "10.0",
		  	node: "6.5",
		  	oculus: "3.0",
		  	opera: "38",
		  	"opera-android": "38",
		  	opera_mobile: "38",
		  	quest: "3.0",
		  	safari: "10.0",
		  	samsung: "5.0"
		  },
		  	"es.array.find": {
		  	android: "45",
		  	bun: "0.1.1",
		  	chrome: "45",
		  	"chrome-android": "45",
		  	deno: "1.0",
		  	edge: "13",
		  	electron: "0.31",
		  	firefox: "48",
		  	"firefox-android": "48",
		  	ios: "9.0",
		  	node: "4.0",
		  	oculus: "3.0",
		  	opera: "32",
		  	"opera-android": "32",
		  	opera_mobile: "32",
		  	quest: "3.0",
		  	safari: "9.0",
		  	samsung: "5.0"
		  },
		  	"es.array.find-index": {
		  	android: "45",
		  	bun: "0.1.1",
		  	chrome: "45",
		  	"chrome-android": "45",
		  	deno: "1.0",
		  	edge: "13",
		  	electron: "0.31",
		  	firefox: "48",
		  	"firefox-android": "48",
		  	ios: "9.0",
		  	node: "4.0",
		  	oculus: "3.0",
		  	opera: "32",
		  	"opera-android": "32",
		  	opera_mobile: "32",
		  	quest: "3.0",
		  	safari: "9.0",
		  	samsung: "5.0"
		  },
		  	"es.array.find-last": {
		  	android: "97",
		  	bun: "0.1.1",
		  	chrome: "97",
		  	"chrome-android": "97",
		  	deno: "1.16",
		  	edge: "97",
		  	electron: "17.0",
		  	firefox: "104",
		  	"firefox-android": "104",
		  	hermes: "0.11",
		  	ios: "15.4",
		  	node: "18.0",
		  	oculus: "20.0",
		  	opera: "83",
		  	"opera-android": "68",
		  	opera_mobile: "68",
		  	quest: "20.0",
		  	"react-native": "0.69",
		  	safari: "15.4",
		  	samsung: "18.0"
		  },
		  	"es.array.find-last-index": {
		  	android: "97",
		  	bun: "0.1.1",
		  	chrome: "97",
		  	"chrome-android": "97",
		  	deno: "1.16",
		  	edge: "97",
		  	electron: "17.0",
		  	firefox: "104",
		  	"firefox-android": "104",
		  	hermes: "0.11",
		  	ios: "15.4",
		  	node: "18.0",
		  	oculus: "20.0",
		  	opera: "83",
		  	"opera-android": "68",
		  	opera_mobile: "68",
		  	quest: "20.0",
		  	"react-native": "0.69",
		  	safari: "15.4",
		  	samsung: "18.0"
		  },
		  	"es.array.flat": {
		  	android: "69",
		  	bun: "0.1.1",
		  	chrome: "69",
		  	"chrome-android": "69",
		  	deno: "1.0",
		  	edge: "79",
		  	electron: "4.0",
		  	firefox: "62",
		  	"firefox-android": "62",
		  	hermes: "0.4",
		  	ios: "12.0",
		  	node: "11.0",
		  	oculus: "6.0",
		  	opera: "56",
		  	"opera-android": "48",
		  	opera_mobile: "48",
		  	quest: "6.0",
		  	"react-native": "0.69",
		  	safari: "12.0",
		  	samsung: "10.0"
		  },
		  	"es.array.flat-map": {
		  	android: "69",
		  	bun: "0.1.1",
		  	chrome: "69",
		  	"chrome-android": "69",
		  	deno: "1.0",
		  	edge: "79",
		  	electron: "4.0",
		  	firefox: "62",
		  	"firefox-android": "62",
		  	hermes: "0.4",
		  	ios: "12.0",
		  	node: "11.0",
		  	oculus: "6.0",
		  	opera: "56",
		  	"opera-android": "48",
		  	opera_mobile: "48",
		  	quest: "6.0",
		  	"react-native": "0.69",
		  	safari: "12.0",
		  	samsung: "10.0"
		  },
		  	"es.array.for-each": {
		  	android: "4.4",
		  	bun: "0.1.1",
		  	chrome: "26",
		  	"chrome-android": "26",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.20",
		  	firefox: "4",
		  	"firefox-android": "4",
		  	hermes: "0.1",
		  	ie: "9",
		  	ios: "8.0",
		  	node: "0.11.0",
		  	oculus: "3.0",
		  	opera: "15",
		  	"opera-android": "15",
		  	opera_mobile: "15",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "7.1",
		  	samsung: "1.5"
		  },
		  	"es.array.from": {
		  	android: "51",
		  	bun: "0.1.1",
		  	chrome: "51",
		  	"chrome-android": "51",
		  	deno: "1.0",
		  	edge: "15",
		  	electron: "1.2",
		  	firefox: "53",
		  	"firefox-android": "53",
		  	ios: "9.0",
		  	node: "6.5",
		  	oculus: "3.0",
		  	opera: "38",
		  	"opera-android": "38",
		  	opera_mobile: "38",
		  	quest: "3.0",
		  	"react-native": "0.73",
		  	rhino: "1.7.13",
		  	safari: "9.0",
		  	samsung: "5.0"
		  },
		  	"es.array.includes": {
		  	android: "53",
		  	bun: "0.1.1",
		  	chrome: "53",
		  	"chrome-android": "53",
		  	deno: "1.0",
		  	edge: "14",
		  	electron: "1.4",
		  	firefox: "102",
		  	"firefox-android": "102",
		  	ios: "10.0",
		  	node: "7.0",
		  	oculus: "3.0",
		  	opera: "40",
		  	"opera-android": "40",
		  	opera_mobile: "40",
		  	quest: "3.0",
		  	safari: "10.0",
		  	samsung: "6.0"
		  },
		  	"es.array.index-of": {
		  	android: "51",
		  	bun: "0.1.1",
		  	chrome: "51",
		  	"chrome-android": "51",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "1.2",
		  	firefox: "47",
		  	"firefox-android": "47",
		  	hermes: "0.1",
		  	ie: "9",
		  	ios: "8.0",
		  	node: "6.5",
		  	oculus: "3.0",
		  	opera: "38",
		  	"opera-android": "38",
		  	opera_mobile: "38",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "7.1",
		  	samsung: "5.0"
		  },
		  	"es.array.is-array": {
		  	android: "3.0",
		  	bun: "0.1.1",
		  	chrome: "5",
		  	"chrome-android": "18",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.20",
		  	firefox: "4",
		  	"firefox-android": "4",
		  	hermes: "0.1",
		  	ie: "9",
		  	ios: "3.0",
		  	node: "0.1.27",
		  	oculus: "3.0",
		  	opera: "10.50",
		  	"opera-android": "10.50",
		  	opera_mobile: "10.50",
		  	phantom: "1.9",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "4.0",
		  	samsung: "1.0"
		  },
		  	"es.array.iterator": {
		  	android: "66",
		  	bun: "0.1.1",
		  	chrome: "66",
		  	"chrome-android": "66",
		  	deno: "1.0",
		  	edge: "15",
		  	electron: "3.0",
		  	firefox: "60",
		  	"firefox-android": "60",
		  	ios: "10.0",
		  	node: "10.0",
		  	oculus: "5.0",
		  	opera: "53",
		  	"opera-android": "47",
		  	opera_mobile: "47",
		  	quest: "5.0",
		  	safari: "10.0",
		  	samsung: "9.0"
		  },
		  	"es.array.join": {
		  	android: "4.4",
		  	bun: "0.1.1",
		  	chrome: "26",
		  	"chrome-android": "26",
		  	deno: "1.0",
		  	edge: "13",
		  	electron: "0.20",
		  	firefox: "4",
		  	"firefox-android": "4",
		  	hermes: "0.1",
		  	ios: "8.0",
		  	node: "0.11.0",
		  	oculus: "3.0",
		  	opera: "15",
		  	"opera-android": "15",
		  	opera_mobile: "15",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "7.1",
		  	samsung: "1.5"
		  },
		  	"es.array.last-index-of": {
		  	android: "51",
		  	bun: "0.1.1",
		  	chrome: "51",
		  	"chrome-android": "51",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "1.2",
		  	firefox: "47",
		  	"firefox-android": "47",
		  	hermes: "0.1",
		  	ie: "9",
		  	ios: "8.0",
		  	node: "6.5",
		  	oculus: "3.0",
		  	opera: "38",
		  	"opera-android": "38",
		  	opera_mobile: "38",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "7.1",
		  	samsung: "5.0"
		  },
		  	"es.array.map": {
		  	android: "51",
		  	bun: "0.1.1",
		  	chrome: "51",
		  	"chrome-android": "51",
		  	deno: "1.0",
		  	edge: "13",
		  	electron: "1.2",
		  	firefox: "50",
		  	"firefox-android": "50",
		  	ios: "10.0",
		  	node: "6.5",
		  	oculus: "3.0",
		  	opera: "38",
		  	"opera-android": "38",
		  	opera_mobile: "38",
		  	quest: "3.0",
		  	safari: "10.0",
		  	samsung: "5.0"
		  },
		  	"es.array.of": {
		  	android: "45",
		  	bun: "0.1.1",
		  	chrome: "45",
		  	"chrome-android": "45",
		  	deno: "1.0",
		  	edge: "13",
		  	electron: "0.31",
		  	firefox: "25",
		  	"firefox-android": "25",
		  	hermes: "0.1",
		  	ios: "9.0",
		  	node: "4.0",
		  	oculus: "3.0",
		  	opera: "32",
		  	"opera-android": "32",
		  	opera_mobile: "32",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "9.0",
		  	samsung: "5.0"
		  },
		  	"es.array.push": {
		  	android: "122",
		  	bun: "0.1.1",
		  	chrome: "122",
		  	"chrome-android": "122",
		  	deno: "1.41.3",
		  	edge: "122",
		  	electron: "29.0",
		  	firefox: "55",
		  	"firefox-android": "55",
		  	hermes: "0.2",
		  	ios: "16.0",
		  	oculus: "32.0",
		  	opera: "108",
		  	"opera-android": "81",
		  	opera_mobile: "81",
		  	quest: "32.0",
		  	"react-native": "0.69",
		  	safari: "16.0"
		  },
		  	"es.array.reduce": {
		  	android: "83",
		  	bun: "0.1.1",
		  	chrome: "83",
		  	"chrome-android": "83",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "9.0",
		  	firefox: "4",
		  	"firefox-android": "4",
		  	hermes: "0.1",
		  	ie: "9",
		  	ios: "8.0",
		  	node: "6.0",
		  	oculus: "10.0",
		  	opera: "69",
		  	"opera-android": "59",
		  	opera_mobile: "59",
		  	quest: "10.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "7.1",
		  	samsung: "13.0"
		  },
		  	"es.array.reduce-right": {
		  	android: "83",
		  	bun: "0.1.1",
		  	chrome: "83",
		  	"chrome-android": "83",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "9.0",
		  	firefox: "4",
		  	"firefox-android": "4",
		  	hermes: "0.1",
		  	ie: "9",
		  	ios: "8.0",
		  	node: "6.0",
		  	oculus: "10.0",
		  	opera: "69",
		  	"opera-android": "59",
		  	opera_mobile: "59",
		  	quest: "10.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "7.1",
		  	samsung: "13.0"
		  },
		  	"es.array.reverse": {
		  	android: "3.0",
		  	bun: "0.1.1",
		  	chrome: "1",
		  	"chrome-android": "18",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.20",
		  	firefox: "1",
		  	"firefox-android": "4",
		  	hermes: "0.1",
		  	ie: "5.5",
		  	ios: "12.2",
		  	node: "0.0.3",
		  	oculus: "3.0",
		  	opera: "10.50",
		  	"opera-android": "10.50",
		  	opera_mobile: "10.50",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "12.0.2",
		  	samsung: "1.0"
		  },
		  	"es.array.slice": {
		  	android: "51",
		  	bun: "0.1.1",
		  	chrome: "51",
		  	"chrome-android": "51",
		  	deno: "1.0",
		  	edge: "13",
		  	electron: "1.2",
		  	firefox: "48",
		  	"firefox-android": "48",
		  	ios: "10.0",
		  	node: "6.5",
		  	oculus: "3.0",
		  	opera: "38",
		  	"opera-android": "38",
		  	opera_mobile: "38",
		  	quest: "3.0",
		  	safari: "10.0",
		  	samsung: "5.0"
		  },
		  	"es.array.some": {
		  	android: "4.4",
		  	bun: "0.1.1",
		  	chrome: "26",
		  	"chrome-android": "26",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.20",
		  	firefox: "4",
		  	"firefox-android": "4",
		  	hermes: "0.1",
		  	ie: "9",
		  	ios: "8.0",
		  	node: "0.11.0",
		  	oculus: "3.0",
		  	opera: "15",
		  	"opera-android": "15",
		  	opera_mobile: "15",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "7.1",
		  	samsung: "1.5"
		  },
		  	"es.array.sort": {
		  	android: "70",
		  	bun: "0.1.1",
		  	chrome: "70",
		  	"chrome-android": "70",
		  	deno: "1.0",
		  	edge: "79",
		  	electron: "5.0",
		  	firefox: "4",
		  	"firefox-android": "4",
		  	hermes: "0.10",
		  	ios: "12.0",
		  	node: "11.0",
		  	oculus: "6.0",
		  	opera: "57",
		  	"opera-android": "49",
		  	opera_mobile: "49",
		  	quest: "6.0",
		  	"react-native": "0.69",
		  	safari: "12.0",
		  	samsung: "10.0"
		  },
		  	"es.array.species": {
		  	android: "51",
		  	bun: "0.1.1",
		  	chrome: "51",
		  	"chrome-android": "51",
		  	deno: "1.0",
		  	edge: "13",
		  	electron: "1.2",
		  	firefox: "48",
		  	"firefox-android": "48",
		  	ios: "10.0",
		  	node: "6.5",
		  	oculus: "3.0",
		  	opera: "38",
		  	"opera-android": "38",
		  	opera_mobile: "38",
		  	quest: "3.0",
		  	safari: "10.0",
		  	samsung: "5.0"
		  },
		  	"es.array.splice": {
		  	android: "51",
		  	bun: "0.1.1",
		  	chrome: "51",
		  	"chrome-android": "51",
		  	deno: "1.0",
		  	edge: "13",
		  	electron: "1.2",
		  	firefox: "49",
		  	"firefox-android": "49",
		  	ios: "10.0",
		  	node: "6.5",
		  	oculus: "3.0",
		  	opera: "38",
		  	"opera-android": "38",
		  	opera_mobile: "38",
		  	quest: "3.0",
		  	safari: "10.0",
		  	samsung: "5.0"
		  },
		  	"es.array.to-reversed": {
		  	android: "110",
		  	bun: "0.1.1",
		  	chrome: "110",
		  	"chrome-android": "110",
		  	deno: "1.27",
		  	edge: "110",
		  	electron: "23.0",
		  	firefox: "115",
		  	"firefox-android": "115",
		  	ios: "16.0",
		  	node: "20.0",
		  	oculus: "26.0",
		  	opera: "96",
		  	"opera-android": "74",
		  	opera_mobile: "74",
		  	quest: "26.0",
		  	"react-native": "0.74",
		  	safari: "16.0",
		  	samsung: "21.0"
		  },
		  	"es.array.to-sorted": {
		  	android: "110",
		  	bun: "0.1.1",
		  	chrome: "110",
		  	"chrome-android": "110",
		  	deno: "1.27",
		  	edge: "110",
		  	electron: "23.0",
		  	firefox: "115",
		  	"firefox-android": "115",
		  	ios: "16.0",
		  	node: "20.0",
		  	oculus: "26.0",
		  	opera: "96",
		  	"opera-android": "74",
		  	opera_mobile: "74",
		  	quest: "26.0",
		  	safari: "16.0",
		  	samsung: "21.0"
		  },
		  	"es.array.to-spliced": {
		  	android: "110",
		  	bun: "0.1.1",
		  	chrome: "110",
		  	"chrome-android": "110",
		  	deno: "1.27",
		  	edge: "110",
		  	electron: "23.0",
		  	firefox: "115",
		  	"firefox-android": "115",
		  	ios: "16.0",
		  	node: "20.0",
		  	oculus: "26.0",
		  	opera: "96",
		  	"opera-android": "74",
		  	opera_mobile: "74",
		  	quest: "26.0",
		  	"react-native": "0.74",
		  	safari: "16.0",
		  	samsung: "21.0"
		  },
		  	"es.array.unscopables.flat": {
		  	android: "73",
		  	bun: "0.1.1",
		  	chrome: "73",
		  	"chrome-android": "73",
		  	deno: "1.0",
		  	edge: "79",
		  	electron: "5.0",
		  	firefox: "67",
		  	"firefox-android": "67",
		  	ios: "13.0",
		  	node: "12.0",
		  	oculus: "6.0",
		  	opera: "60",
		  	"opera-android": "52",
		  	opera_mobile: "52",
		  	quest: "6.0",
		  	safari: "13",
		  	samsung: "11.0"
		  },
		  	"es.array.unscopables.flat-map": {
		  	android: "73",
		  	bun: "0.1.1",
		  	chrome: "73",
		  	"chrome-android": "73",
		  	deno: "1.0",
		  	edge: "79",
		  	electron: "5.0",
		  	firefox: "67",
		  	"firefox-android": "67",
		  	ios: "13.0",
		  	node: "12.0",
		  	oculus: "6.0",
		  	opera: "60",
		  	"opera-android": "52",
		  	opera_mobile: "52",
		  	quest: "6.0",
		  	safari: "13",
		  	samsung: "11.0"
		  },
		  	"es.array.unshift": {
		  	android: "71",
		  	bun: "0.1.1",
		  	chrome: "71",
		  	"chrome-android": "71",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "5.0",
		  	firefox: "23",
		  	"firefox-android": "23",
		  	hermes: "0.1",
		  	ie: "9",
		  	ios: "16.0",
		  	node: "12.0",
		  	oculus: "6.0",
		  	opera: "58",
		  	"opera-android": "50",
		  	opera_mobile: "50",
		  	quest: "6.0",
		  	"react-native": "0.69",
		  	safari: "16.0",
		  	samsung: "10.0"
		  },
		  	"es.array.with": {
		  	android: "110",
		  	bun: "0.1.1",
		  	chrome: "110",
		  	"chrome-android": "110",
		  	deno: "1.27",
		  	edge: "110",
		  	electron: "23.0",
		  	firefox: "115",
		  	"firefox-android": "115",
		  	ios: "16.0",
		  	node: "20.0",
		  	oculus: "26.0",
		  	opera: "96",
		  	"opera-android": "74",
		  	opera_mobile: "74",
		  	quest: "26.0",
		  	"react-native": "0.74",
		  	safari: "16.0",
		  	samsung: "21.0"
		  },
		  	"es.array-buffer.constructor": {
		  	android: "4.4",
		  	bun: "0.1.1",
		  	chrome: "28",
		  	"chrome-android": "28",
		  	deno: "1.0",
		  	edge: "14",
		  	electron: "0.20",
		  	firefox: "44",
		  	"firefox-android": "44",
		  	hermes: "0.1",
		  	ios: "12.0",
		  	node: "0.11.1",
		  	oculus: "3.0",
		  	opera: "15",
		  	"opera-android": "15",
		  	opera_mobile: "15",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	safari: "12.0",
		  	samsung: "1.5"
		  },
		  	"es.array-buffer.is-view": {
		  	android: "4.4.3",
		  	bun: "0.1.1",
		  	chrome: "32",
		  	"chrome-android": "32",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.20",
		  	firefox: "29",
		  	"firefox-android": "29",
		  	hermes: "0.1",
		  	ie: "11",
		  	ios: "8.0",
		  	node: "0.11.9",
		  	oculus: "3.0",
		  	opera: "19",
		  	"opera-android": "19",
		  	opera_mobile: "19",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	safari: "7.1",
		  	samsung: "2.0"
		  },
		  	"es.array-buffer.slice": {
		  	android: "4.4.3",
		  	bun: "0.1.1",
		  	chrome: "31",
		  	"chrome-android": "31",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.20",
		  	firefox: "46",
		  	"firefox-android": "46",
		  	hermes: "0.1",
		  	ie: "11",
		  	ios: "12.2",
		  	node: "0.11.8",
		  	oculus: "3.0",
		  	opera: "18",
		  	"opera-android": "18",
		  	opera_mobile: "18",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "12.1",
		  	samsung: "2.0"
		  },
		  	"es.data-view": {
		  	android: "4.4",
		  	bun: "0.1.1",
		  	chrome: "26",
		  	"chrome-android": "26",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.20",
		  	firefox: "15",
		  	"firefox-android": "15",
		  	hermes: "0.1",
		  	ie: "10",
		  	ios: "8.0",
		  	node: "0.11.0",
		  	oculus: "3.0",
		  	opera: "15",
		  	"opera-android": "15",
		  	opera_mobile: "15",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "7.1",
		  	samsung: "1.5"
		  },
		  	"es.array-buffer.detached": {
		  	android: "114",
		  	bun: "1.0.19",
		  	chrome: "114",
		  	"chrome-android": "114",
		  	deno: "1.33",
		  	edge: "114",
		  	electron: "25.0",
		  	firefox: "122",
		  	"firefox-android": "122",
		  	ios: "17.4",
		  	node: "21.0",
		  	oculus: "28.0",
		  	opera: "100",
		  	"opera-android": "76",
		  	opera_mobile: "76",
		  	quest: "28.0",
		  	safari: "17.4",
		  	samsung: "23.0"
		  },
		  	"es.array-buffer.transfer": {
		  	android: "114",
		  	bun: "1.0.19",
		  	chrome: "114",
		  	"chrome-android": "114",
		  	deno: "1.33",
		  	edge: "114",
		  	electron: "25.0",
		  	firefox: "122",
		  	"firefox-android": "122",
		  	ios: "17.4",
		  	node: "21.0",
		  	oculus: "28.0",
		  	opera: "100",
		  	"opera-android": "76",
		  	opera_mobile: "76",
		  	quest: "28.0",
		  	safari: "17.4",
		  	samsung: "23.0"
		  },
		  	"es.array-buffer.transfer-to-fixed-length": {
		  	android: "114",
		  	bun: "1.0.19",
		  	chrome: "114",
		  	"chrome-android": "114",
		  	deno: "1.33",
		  	edge: "114",
		  	electron: "25.0",
		  	firefox: "122",
		  	"firefox-android": "122",
		  	ios: "17.4",
		  	node: "21.0",
		  	oculus: "28.0",
		  	opera: "100",
		  	"opera-android": "76",
		  	opera_mobile: "76",
		  	quest: "28.0",
		  	safari: "17.4",
		  	samsung: "23.0"
		  },
		  	"es.date.get-year": {
		  	android: "3.0",
		  	bun: "0.1.1",
		  	chrome: "1",
		  	"chrome-android": "18",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.20",
		  	firefox: "1",
		  	"firefox-android": "4",
		  	hermes: "0.1",
		  	ie: "9",
		  	ios: "1.0",
		  	node: "0.0.3",
		  	oculus: "3.0",
		  	opera: "3",
		  	"opera-android": "3",
		  	opera_mobile: "3",
		  	phantom: "1.9",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "1",
		  	samsung: "1.0"
		  },
		  	"es.date.now": {
		  	android: "3.0",
		  	bun: "0.1.1",
		  	chrome: "5",
		  	"chrome-android": "18",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.20",
		  	firefox: "2",
		  	"firefox-android": "4",
		  	hermes: "0.1",
		  	ie: "9",
		  	ios: "3.0",
		  	node: "0.1.27",
		  	oculus: "3.0",
		  	opera: "10.50",
		  	"opera-android": "10.50",
		  	opera_mobile: "10.50",
		  	phantom: "1.9",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "4.0",
		  	samsung: "1.0"
		  },
		  	"es.date.set-year": {
		  	android: "3.0",
		  	bun: "0.1.1",
		  	chrome: "1",
		  	"chrome-android": "18",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.20",
		  	firefox: "1",
		  	"firefox-android": "4",
		  	hermes: "0.1",
		  	ie: "3",
		  	ios: "1.0",
		  	node: "0.0.3",
		  	oculus: "3.0",
		  	opera: "3",
		  	"opera-android": "3",
		  	opera_mobile: "3",
		  	phantom: "1.9",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "1",
		  	samsung: "1.0"
		  },
		  	"es.date.to-gmt-string": {
		  	android: "3.0",
		  	bun: "0.1.1",
		  	chrome: "1",
		  	"chrome-android": "18",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.20",
		  	firefox: "1",
		  	"firefox-android": "4",
		  	hermes: "0.1",
		  	ie: "3",
		  	ios: "1.0",
		  	node: "0.0.3",
		  	oculus: "3.0",
		  	opera: "3",
		  	"opera-android": "3",
		  	opera_mobile: "3",
		  	phantom: "1.9",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "1",
		  	samsung: "1.0"
		  },
		  	"es.date.to-iso-string": {
		  	android: "4.4",
		  	bun: "0.1.1",
		  	chrome: "26",
		  	"chrome-android": "26",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.20",
		  	firefox: "7",
		  	"firefox-android": "7",
		  	hermes: "0.1",
		  	ie: "9",
		  	ios: "8.0",
		  	node: "0.11.0",
		  	oculus: "3.0",
		  	opera: "15",
		  	"opera-android": "15",
		  	opera_mobile: "15",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "7.1",
		  	samsung: "1.5"
		  },
		  	"es.date.to-json": {
		  	android: "4.4",
		  	bun: "0.1.1",
		  	chrome: "26",
		  	"chrome-android": "26",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.20",
		  	firefox: "4",
		  	"firefox-android": "4",
		  	hermes: "0.1",
		  	ie: "9",
		  	ios: "10.0",
		  	node: "0.11.0",
		  	oculus: "3.0",
		  	opera: "15",
		  	"opera-android": "15",
		  	opera_mobile: "15",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "10.0",
		  	samsung: "1.5"
		  },
		  	"es.date.to-primitive": {
		  	android: "47",
		  	bun: "0.1.1",
		  	chrome: "47",
		  	"chrome-android": "47",
		  	deno: "1.0",
		  	edge: "15",
		  	electron: "0.36",
		  	firefox: "44",
		  	"firefox-android": "44",
		  	hermes: "0.1",
		  	ios: "10.0",
		  	node: "6.0",
		  	oculus: "3.0",
		  	opera: "34",
		  	"opera-android": "34",
		  	opera_mobile: "34",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	safari: "10.0",
		  	samsung: "5.0"
		  },
		  	"es.date.to-string": {
		  	android: "3.0",
		  	bun: "0.1.1",
		  	chrome: "5",
		  	"chrome-android": "18",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.20",
		  	firefox: "2",
		  	"firefox-android": "4",
		  	hermes: "0.1",
		  	ie: "9",
		  	ios: "2.0",
		  	node: "0.1.27",
		  	oculus: "3.0",
		  	opera: "10.50",
		  	"opera-android": "10.50",
		  	opera_mobile: "10.50",
		  	phantom: "1.9",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "3.1",
		  	samsung: "1.0"
		  },
		  	"es.escape": {
		  	android: "3.0",
		  	bun: "0.1.1",
		  	chrome: "1",
		  	"chrome-android": "18",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.20",
		  	firefox: "1",
		  	"firefox-android": "4",
		  	hermes: "0.1",
		  	ie: "3",
		  	ios: "1.0",
		  	node: "0.0.3",
		  	oculus: "3.0",
		  	opera: "3",
		  	"opera-android": "3",
		  	opera_mobile: "3",
		  	phantom: "1.9",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "1",
		  	samsung: "1.0"
		  },
		  	"es.function.bind": {
		  	android: "3.0",
		  	bun: "0.1.1",
		  	chrome: "7",
		  	"chrome-android": "18",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.20",
		  	firefox: "4",
		  	"firefox-android": "4",
		  	hermes: "0.1",
		  	ie: "9",
		  	ios: "5.0",
		  	node: "0.1.101",
		  	oculus: "3.0",
		  	opera: "12",
		  	"opera-android": "12",
		  	opera_mobile: "12",
		  	phantom: "2.0",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "5.1",
		  	samsung: "1.0"
		  },
		  	"es.function.has-instance": {
		  	android: "51",
		  	bun: "0.1.1",
		  	chrome: "51",
		  	"chrome-android": "51",
		  	deno: "1.0",
		  	edge: "15",
		  	electron: "1.2",
		  	firefox: "50",
		  	"firefox-android": "50",
		  	hermes: "0.1",
		  	ios: "10.0",
		  	node: "6.5",
		  	oculus: "3.0",
		  	opera: "38",
		  	"opera-android": "38",
		  	opera_mobile: "38",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	safari: "10.0",
		  	samsung: "5.0"
		  },
		  	"es.function.name": {
		  	android: "3.0",
		  	bun: "0.1.1",
		  	chrome: "5",
		  	"chrome-android": "18",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.20",
		  	firefox: "2",
		  	"firefox-android": "4",
		  	hermes: "0.1",
		  	ios: "3.0",
		  	node: "0.1.27",
		  	oculus: "3.0",
		  	opera: "10.50",
		  	"opera-android": "10.50",
		  	opera_mobile: "10.50",
		  	phantom: "1.9",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "4.0",
		  	samsung: "1.0"
		  },
		  	"es.global-this": {
		  	android: "71",
		  	bun: "0.1.1",
		  	chrome: "71",
		  	"chrome-android": "71",
		  	deno: "1.0",
		  	edge: "79",
		  	electron: "5.0",
		  	firefox: "65",
		  	"firefox-android": "65",
		  	hermes: "0.2",
		  	ios: "12.2",
		  	node: "12.0",
		  	oculus: "6.0",
		  	opera: "58",
		  	"opera-android": "50",
		  	opera_mobile: "50",
		  	quest: "6.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.14",
		  	safari: "12.1",
		  	samsung: "10.0"
		  },
		  	"es.json.stringify": {
		  	android: "72",
		  	bun: "0.1.1",
		  	chrome: "72",
		  	"chrome-android": "72",
		  	deno: "1.0",
		  	edge: "79",
		  	electron: "5.0",
		  	firefox: "64",
		  	"firefox-android": "64",
		  	ios: "12.2",
		  	node: "12.0",
		  	oculus: "6.0",
		  	opera: "59",
		  	"opera-android": "51",
		  	opera_mobile: "51",
		  	quest: "6.0",
		  	"react-native": "0.72",
		  	safari: "12.1",
		  	samsung: "11.0"
		  },
		  	"es.json.to-string-tag": {
		  	android: "50",
		  	bun: "0.1.1",
		  	chrome: "50",
		  	"chrome-android": "50",
		  	deno: "1.0",
		  	edge: "15",
		  	electron: "1.1",
		  	firefox: "51",
		  	"firefox-android": "51",
		  	hermes: "0.1",
		  	ios: "10.0",
		  	node: "6.0",
		  	oculus: "3.0",
		  	opera: "37",
		  	"opera-android": "37",
		  	opera_mobile: "37",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	safari: "10.0",
		  	samsung: "5.0"
		  },
		  	"es.map": {
		  	android: "51",
		  	bun: "0.1.1",
		  	chrome: "51",
		  	"chrome-android": "51",
		  	deno: "1.0",
		  	edge: "15",
		  	electron: "1.2",
		  	firefox: "53",
		  	"firefox-android": "53",
		  	ios: "10.0",
		  	node: "6.5",
		  	oculus: "3.0",
		  	opera: "38",
		  	"opera-android": "38",
		  	opera_mobile: "38",
		  	quest: "3.0",
		  	"react-native": "0.73",
		  	rhino: "1.7.13",
		  	safari: "10.0",
		  	samsung: "5.0"
		  },
		  	"es.map.group-by": {
		  	android: "117",
		  	bun: "1.0.19",
		  	chrome: "117",
		  	"chrome-android": "117",
		  	deno: "1.37",
		  	edge: "117",
		  	electron: "27.0",
		  	firefox: "119",
		  	"firefox-android": "119",
		  	ios: "17.4",
		  	node: "21.0",
		  	oculus: "30.0",
		  	opera: "103",
		  	"opera-android": "78",
		  	opera_mobile: "78",
		  	quest: "30.0",
		  	safari: "17.4",
		  	samsung: "24.0"
		  },
		  	"es.math.acosh": {
		  	android: "54",
		  	bun: "0.1.1",
		  	chrome: "54",
		  	"chrome-android": "54",
		  	deno: "1.0",
		  	edge: "13",
		  	electron: "1.4",
		  	firefox: "25",
		  	"firefox-android": "25",
		  	hermes: "0.1",
		  	ios: "8.0",
		  	node: "7.0",
		  	oculus: "3.0",
		  	opera: "41",
		  	"opera-android": "41",
		  	opera_mobile: "41",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	safari: "7.1",
		  	samsung: "6.0"
		  },
		  	"es.math.asinh": {
		  	android: "38",
		  	bun: "0.1.1",
		  	chrome: "38",
		  	"chrome-android": "38",
		  	deno: "1.0",
		  	edge: "13",
		  	electron: "0.20",
		  	firefox: "25",
		  	"firefox-android": "25",
		  	hermes: "0.1",
		  	ios: "8.0",
		  	node: "0.11.15",
		  	oculus: "3.0",
		  	opera: "25",
		  	"opera-android": "25",
		  	opera_mobile: "25",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "7.1",
		  	samsung: "3.0"
		  },
		  	"es.math.atanh": {
		  	android: "38",
		  	bun: "0.1.1",
		  	chrome: "38",
		  	"chrome-android": "38",
		  	deno: "1.0",
		  	edge: "13",
		  	electron: "0.20",
		  	firefox: "25",
		  	"firefox-android": "25",
		  	hermes: "0.1",
		  	ios: "8.0",
		  	node: "0.11.15",
		  	oculus: "3.0",
		  	opera: "25",
		  	"opera-android": "25",
		  	opera_mobile: "25",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "7.1",
		  	samsung: "3.0"
		  },
		  	"es.math.cbrt": {
		  	android: "38",
		  	bun: "0.1.1",
		  	chrome: "38",
		  	"chrome-android": "38",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.20",
		  	firefox: "25",
		  	"firefox-android": "25",
		  	hermes: "0.1",
		  	ios: "8.0",
		  	node: "0.11.15",
		  	oculus: "3.0",
		  	opera: "25",
		  	"opera-android": "25",
		  	opera_mobile: "25",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "7.1",
		  	samsung: "3.0"
		  },
		  	"es.math.clz32": {
		  	android: "38",
		  	bun: "0.1.1",
		  	chrome: "38",
		  	"chrome-android": "38",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.20",
		  	firefox: "31",
		  	"firefox-android": "31",
		  	hermes: "0.1",
		  	ios: "9.0",
		  	node: "0.11.15",
		  	oculus: "3.0",
		  	opera: "25",
		  	"opera-android": "25",
		  	opera_mobile: "25",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "9.0",
		  	samsung: "3.0"
		  },
		  	"es.math.cosh": {
		  	android: "39",
		  	bun: "0.1.1",
		  	chrome: "39",
		  	"chrome-android": "39",
		  	deno: "1.0",
		  	edge: "13",
		  	electron: "0.20",
		  	firefox: "25",
		  	"firefox-android": "25",
		  	hermes: "0.1",
		  	ios: "8.0",
		  	node: "1.0",
		  	oculus: "3.0",
		  	opera: "26",
		  	"opera-android": "26",
		  	opera_mobile: "26",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "7.1",
		  	samsung: "3.4"
		  },
		  	"es.math.expm1": {
		  	android: "39",
		  	bun: "0.1.1",
		  	chrome: "39",
		  	"chrome-android": "39",
		  	deno: "1.0",
		  	edge: "13",
		  	electron: "0.20",
		  	firefox: "46",
		  	"firefox-android": "46",
		  	hermes: "0.1",
		  	ios: "8.0",
		  	node: "1.0",
		  	oculus: "3.0",
		  	opera: "26",
		  	"opera-android": "26",
		  	opera_mobile: "26",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "7.1",
		  	samsung: "3.4"
		  },
		  	"es.math.fround": {
		  	android: "38",
		  	bun: "0.1.1",
		  	chrome: "38",
		  	"chrome-android": "38",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.20",
		  	firefox: "26",
		  	"firefox-android": "26",
		  	hermes: "0.1",
		  	ios: "8.0",
		  	node: "0.11.15",
		  	oculus: "3.0",
		  	opera: "25",
		  	"opera-android": "25",
		  	opera_mobile: "25",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "7.1",
		  	samsung: "3.0"
		  },
		  	"es.math.hypot": {
		  	android: "78",
		  	bun: "0.1.1",
		  	chrome: "78",
		  	"chrome-android": "78",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "7.0",
		  	firefox: "27",
		  	"firefox-android": "27",
		  	hermes: "0.1",
		  	ios: "8.0",
		  	node: "12.16",
		  	oculus: "8.0",
		  	opera: "65",
		  	"opera-android": "56",
		  	opera_mobile: "56",
		  	quest: "8.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "7.1",
		  	samsung: "12.0"
		  },
		  	"es.math.imul": {
		  	android: "4.4",
		  	bun: "0.1.1",
		  	chrome: "28",
		  	"chrome-android": "28",
		  	deno: "1.0",
		  	edge: "13",
		  	electron: "0.20",
		  	firefox: "20",
		  	"firefox-android": "20",
		  	hermes: "0.1",
		  	ios: "9.0",
		  	node: "0.11.1",
		  	oculus: "3.0",
		  	opera: "15",
		  	"opera-android": "15",
		  	opera_mobile: "15",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "9.0",
		  	samsung: "1.5"
		  },
		  	"es.math.log10": {
		  	android: "38",
		  	bun: "0.1.1",
		  	chrome: "38",
		  	"chrome-android": "38",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.20",
		  	firefox: "25",
		  	"firefox-android": "25",
		  	hermes: "0.1",
		  	ios: "8.0",
		  	node: "0.11.15",
		  	oculus: "3.0",
		  	opera: "25",
		  	"opera-android": "25",
		  	opera_mobile: "25",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "7.1",
		  	samsung: "3.0"
		  },
		  	"es.math.log1p": {
		  	android: "38",
		  	bun: "0.1.1",
		  	chrome: "38",
		  	"chrome-android": "38",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.20",
		  	firefox: "25",
		  	"firefox-android": "25",
		  	hermes: "0.1",
		  	ios: "8.0",
		  	node: "0.11.15",
		  	oculus: "3.0",
		  	opera: "25",
		  	"opera-android": "25",
		  	opera_mobile: "25",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "7.1",
		  	samsung: "3.0"
		  },
		  	"es.math.log2": {
		  	android: "38",
		  	bun: "0.1.1",
		  	chrome: "38",
		  	"chrome-android": "38",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.20",
		  	firefox: "25",
		  	"firefox-android": "25",
		  	hermes: "0.1",
		  	ios: "8.0",
		  	node: "0.11.15",
		  	oculus: "3.0",
		  	opera: "25",
		  	"opera-android": "25",
		  	opera_mobile: "25",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "7.1",
		  	samsung: "3.0"
		  },
		  	"es.math.sign": {
		  	android: "38",
		  	bun: "0.1.1",
		  	chrome: "38",
		  	"chrome-android": "38",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.20",
		  	firefox: "25",
		  	"firefox-android": "25",
		  	hermes: "0.1",
		  	ios: "9.0",
		  	node: "0.11.15",
		  	oculus: "3.0",
		  	opera: "25",
		  	"opera-android": "25",
		  	opera_mobile: "25",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "9.0",
		  	samsung: "3.0"
		  },
		  	"es.math.sinh": {
		  	android: "39",
		  	bun: "0.1.1",
		  	chrome: "39",
		  	"chrome-android": "39",
		  	deno: "1.0",
		  	edge: "13",
		  	electron: "0.20",
		  	firefox: "25",
		  	"firefox-android": "25",
		  	hermes: "0.1",
		  	ios: "8.0",
		  	node: "1.0",
		  	oculus: "3.0",
		  	opera: "26",
		  	"opera-android": "26",
		  	opera_mobile: "26",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "7.1",
		  	samsung: "3.4"
		  },
		  	"es.math.tanh": {
		  	android: "38",
		  	bun: "0.1.1",
		  	chrome: "38",
		  	"chrome-android": "38",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.20",
		  	firefox: "25",
		  	"firefox-android": "25",
		  	hermes: "0.1",
		  	ios: "8.0",
		  	node: "0.11.15",
		  	oculus: "3.0",
		  	opera: "25",
		  	"opera-android": "25",
		  	opera_mobile: "25",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "7.1",
		  	samsung: "3.0"
		  },
		  	"es.math.to-string-tag": {
		  	android: "50",
		  	bun: "0.1.1",
		  	chrome: "50",
		  	"chrome-android": "50",
		  	deno: "1.0",
		  	edge: "15",
		  	electron: "1.1",
		  	firefox: "51",
		  	"firefox-android": "51",
		  	hermes: "0.1",
		  	ios: "10.0",
		  	node: "6.0",
		  	oculus: "3.0",
		  	opera: "37",
		  	"opera-android": "37",
		  	opera_mobile: "37",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	safari: "10.0",
		  	samsung: "5.0"
		  },
		  	"es.math.trunc": {
		  	android: "38",
		  	bun: "0.1.1",
		  	chrome: "38",
		  	"chrome-android": "38",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.20",
		  	firefox: "25",
		  	"firefox-android": "25",
		  	hermes: "0.1",
		  	ios: "8.0",
		  	node: "0.11.15",
		  	oculus: "3.0",
		  	opera: "25",
		  	"opera-android": "25",
		  	opera_mobile: "25",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "7.1",
		  	samsung: "3.0"
		  },
		  	"es.number.constructor": {
		  	android: "41",
		  	bun: "0.1.1",
		  	chrome: "41",
		  	"chrome-android": "41",
		  	deno: "1.0",
		  	edge: "13",
		  	electron: "0.21",
		  	firefox: "46",
		  	"firefox-android": "46",
		  	hermes: "0.5",
		  	ios: "9.0",
		  	node: "1.0",
		  	oculus: "3.0",
		  	opera: "28",
		  	"opera-android": "28",
		  	opera_mobile: "28",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "9.0",
		  	samsung: "3.4"
		  },
		  	"es.number.epsilon": {
		  	android: "37",
		  	bun: "0.1.1",
		  	chrome: "34",
		  	"chrome-android": "34",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.20",
		  	firefox: "25",
		  	"firefox-android": "25",
		  	hermes: "0.1",
		  	ios: "9.0",
		  	node: "0.11.13",
		  	oculus: "3.0",
		  	opera: "21",
		  	"opera-android": "21",
		  	opera_mobile: "21",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.14",
		  	safari: "9.0",
		  	samsung: "2.0"
		  },
		  	"es.number.is-finite": {
		  	android: "4.1",
		  	bun: "0.1.1",
		  	chrome: "19",
		  	"chrome-android": "25",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.20",
		  	firefox: "16",
		  	"firefox-android": "16",
		  	hermes: "0.1",
		  	ios: "9.0",
		  	node: "0.7.3",
		  	oculus: "3.0",
		  	opera: "15",
		  	"opera-android": "15",
		  	opera_mobile: "15",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "9.0",
		  	samsung: "1.5"
		  },
		  	"es.number.is-integer": {
		  	android: "37",
		  	bun: "0.1.1",
		  	chrome: "34",
		  	"chrome-android": "34",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.20",
		  	firefox: "16",
		  	"firefox-android": "16",
		  	hermes: "0.1",
		  	ios: "9.0",
		  	node: "0.11.13",
		  	oculus: "3.0",
		  	opera: "21",
		  	"opera-android": "21",
		  	opera_mobile: "21",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "9.0",
		  	samsung: "2.0"
		  },
		  	"es.number.is-nan": {
		  	android: "4.1",
		  	bun: "0.1.1",
		  	chrome: "19",
		  	"chrome-android": "25",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.20",
		  	firefox: "15",
		  	"firefox-android": "15",
		  	hermes: "0.1",
		  	ios: "9.0",
		  	node: "0.7.3",
		  	oculus: "3.0",
		  	opera: "15",
		  	"opera-android": "15",
		  	opera_mobile: "15",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "9.0",
		  	samsung: "1.5"
		  },
		  	"es.number.is-safe-integer": {
		  	android: "37",
		  	bun: "0.1.1",
		  	chrome: "34",
		  	"chrome-android": "34",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.20",
		  	firefox: "32",
		  	"firefox-android": "32",
		  	hermes: "0.1",
		  	ios: "9.0",
		  	node: "0.11.13",
		  	oculus: "3.0",
		  	opera: "21",
		  	"opera-android": "21",
		  	opera_mobile: "21",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "9.0",
		  	samsung: "2.0"
		  },
		  	"es.number.max-safe-integer": {
		  	android: "37",
		  	bun: "0.1.1",
		  	chrome: "34",
		  	"chrome-android": "34",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.20",
		  	firefox: "31",
		  	"firefox-android": "31",
		  	hermes: "0.1",
		  	ios: "9.0",
		  	node: "0.11.13",
		  	oculus: "3.0",
		  	opera: "21",
		  	"opera-android": "21",
		  	opera_mobile: "21",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "9.0",
		  	samsung: "2.0"
		  },
		  	"es.number.min-safe-integer": {
		  	android: "37",
		  	bun: "0.1.1",
		  	chrome: "34",
		  	"chrome-android": "34",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.20",
		  	firefox: "31",
		  	"firefox-android": "31",
		  	hermes: "0.1",
		  	ios: "9.0",
		  	node: "0.11.13",
		  	oculus: "3.0",
		  	opera: "21",
		  	"opera-android": "21",
		  	opera_mobile: "21",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "9.0",
		  	samsung: "2.0"
		  },
		  	"es.number.parse-float": {
		  	android: "37",
		  	bun: "0.1.1",
		  	chrome: "35",
		  	"chrome-android": "35",
		  	deno: "1.0",
		  	edge: "79",
		  	electron: "0.20",
		  	firefox: "39",
		  	"firefox-android": "39",
		  	hermes: "0.1",
		  	ios: "11.0",
		  	node: "0.11.13",
		  	oculus: "3.0",
		  	opera: "22",
		  	"opera-android": "22",
		  	opera_mobile: "22",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.14",
		  	safari: "11.0",
		  	samsung: "3.0"
		  },
		  	"es.number.parse-int": {
		  	android: "37",
		  	bun: "0.1.1",
		  	chrome: "35",
		  	"chrome-android": "35",
		  	deno: "1.0",
		  	edge: "79",
		  	electron: "0.20",
		  	firefox: "39",
		  	"firefox-android": "39",
		  	hermes: "0.1",
		  	ios: "9.0",
		  	node: "0.11.13",
		  	oculus: "3.0",
		  	opera: "22",
		  	"opera-android": "22",
		  	opera_mobile: "22",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.14",
		  	safari: "9.0",
		  	samsung: "3.0"
		  },
		  	"es.number.to-exponential": {
		  	android: "51",
		  	bun: "0.1.1",
		  	chrome: "51",
		  	"chrome-android": "51",
		  	deno: "1.0",
		  	edge: "18",
		  	electron: "1.2",
		  	firefox: "87",
		  	"firefox-android": "87",
		  	hermes: "0.1",
		  	ios: "11.0",
		  	node: "6.5",
		  	oculus: "3.0",
		  	opera: "38",
		  	"opera-android": "38",
		  	opera_mobile: "38",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.14",
		  	safari: "11",
		  	samsung: "5.0"
		  },
		  	"es.number.to-fixed": {
		  	android: "4.4",
		  	bun: "0.1.1",
		  	chrome: "26",
		  	"chrome-android": "26",
		  	deno: "1.0",
		  	edge: "79",
		  	electron: "0.20",
		  	firefox: "4",
		  	"firefox-android": "4",
		  	hermes: "0.1",
		  	ios: "8.0",
		  	node: "0.11.0",
		  	oculus: "3.0",
		  	opera: "15",
		  	"opera-android": "15",
		  	opera_mobile: "15",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "7.1",
		  	samsung: "1.5"
		  },
		  	"es.number.to-precision": {
		  	android: "4.4",
		  	bun: "0.1.1",
		  	chrome: "26",
		  	"chrome-android": "26",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.20",
		  	firefox: "4",
		  	"firefox-android": "4",
		  	hermes: "0.1",
		  	ie: "8",
		  	ios: "8.0",
		  	node: "0.11.0",
		  	oculus: "3.0",
		  	opera: "15",
		  	"opera-android": "15",
		  	opera_mobile: "15",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "7.1",
		  	samsung: "1.5"
		  },
		  	"es.object.assign": {
		  	android: "49",
		  	bun: "0.1.1",
		  	chrome: "49",
		  	"chrome-android": "49",
		  	deno: "1.0",
		  	edge: "79",
		  	electron: "0.37",
		  	firefox: "36",
		  	"firefox-android": "36",
		  	hermes: "0.4",
		  	ios: "9.0",
		  	node: "6.0",
		  	oculus: "3.0",
		  	opera: "36",
		  	"opera-android": "36",
		  	opera_mobile: "36",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	safari: "9.0",
		  	samsung: "5.0"
		  },
		  	"es.object.create": {
		  	android: "3.0",
		  	bun: "0.1.1",
		  	chrome: "5",
		  	"chrome-android": "18",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.20",
		  	firefox: "4",
		  	"firefox-android": "4",
		  	hermes: "0.1",
		  	ie: "9",
		  	ios: "3.0",
		  	node: "0.1.27",
		  	oculus: "3.0",
		  	opera: "12",
		  	"opera-android": "12",
		  	opera_mobile: "12",
		  	phantom: "1.9",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "4.0",
		  	samsung: "1.0"
		  },
		  	"es.object.define-getter": {
		  	android: "62",
		  	bun: "0.1.1",
		  	chrome: "62",
		  	"chrome-android": "62",
		  	deno: "1.0",
		  	edge: "16",
		  	electron: "3.0",
		  	firefox: "48",
		  	"firefox-android": "48",
		  	hermes: "0.1",
		  	ios: "8.0",
		  	node: "8.10",
		  	oculus: "5.0",
		  	opera: "49",
		  	"opera-android": "46",
		  	opera_mobile: "46",
		  	quest: "5.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "7.1",
		  	samsung: "8.0"
		  },
		  	"es.object.define-properties": {
		  	android: "37",
		  	bun: "0.1.1",
		  	chrome: "37",
		  	"chrome-android": "37",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.20",
		  	firefox: "4",
		  	"firefox-android": "4",
		  	hermes: "0.1",
		  	ie: "9",
		  	ios: "5.0",
		  	node: "0.11.15",
		  	oculus: "3.0",
		  	opera: "12",
		  	"opera-android": "12",
		  	opera_mobile: "12",
		  	phantom: "2.0",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "5.1",
		  	samsung: "3.0"
		  },
		  	"es.object.define-property": {
		  	android: "37",
		  	bun: "0.1.1",
		  	chrome: "37",
		  	"chrome-android": "37",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.20",
		  	firefox: "4",
		  	"firefox-android": "4",
		  	hermes: "0.1",
		  	ie: "9",
		  	ios: "5.0",
		  	node: "0.11.15",
		  	oculus: "3.0",
		  	opera: "12",
		  	"opera-android": "12",
		  	opera_mobile: "12",
		  	phantom: "2.0",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "5.1",
		  	samsung: "3.0"
		  },
		  	"es.object.define-setter": {
		  	android: "62",
		  	bun: "0.1.1",
		  	chrome: "62",
		  	"chrome-android": "62",
		  	deno: "1.0",
		  	edge: "16",
		  	electron: "3.0",
		  	firefox: "48",
		  	"firefox-android": "48",
		  	hermes: "0.1",
		  	ios: "8.0",
		  	node: "8.10",
		  	oculus: "5.0",
		  	opera: "49",
		  	"opera-android": "46",
		  	opera_mobile: "46",
		  	quest: "5.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "7.1",
		  	samsung: "8.0"
		  },
		  	"es.object.entries": {
		  	android: "54",
		  	bun: "0.1.1",
		  	chrome: "54",
		  	"chrome-android": "54",
		  	deno: "1.0",
		  	edge: "14",
		  	electron: "1.4",
		  	firefox: "47",
		  	"firefox-android": "47",
		  	hermes: "0.1",
		  	ios: "10.3",
		  	node: "7.0",
		  	oculus: "3.0",
		  	opera: "41",
		  	"opera-android": "41",
		  	opera_mobile: "41",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.14",
		  	safari: "10.1",
		  	samsung: "6.0"
		  },
		  	"es.object.freeze": {
		  	android: "44",
		  	bun: "0.1.1",
		  	chrome: "44",
		  	"chrome-android": "44",
		  	deno: "1.0",
		  	edge: "13",
		  	electron: "0.30",
		  	firefox: "35",
		  	"firefox-android": "35",
		  	hermes: "0.1",
		  	ios: "9.0",
		  	node: "3.0",
		  	oculus: "3.0",
		  	opera: "31",
		  	"opera-android": "31",
		  	opera_mobile: "31",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "9.0",
		  	samsung: "4.0"
		  },
		  	"es.object.from-entries": {
		  	android: "73",
		  	bun: "0.1.1",
		  	chrome: "73",
		  	"chrome-android": "73",
		  	deno: "1.0",
		  	edge: "79",
		  	electron: "5.0",
		  	firefox: "63",
		  	"firefox-android": "63",
		  	hermes: "0.4",
		  	ios: "12.2",
		  	node: "12.0",
		  	oculus: "6.0",
		  	opera: "60",
		  	"opera-android": "52",
		  	opera_mobile: "52",
		  	quest: "6.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.14",
		  	safari: "12.1",
		  	samsung: "11.0"
		  },
		  	"es.object.get-own-property-descriptor": {
		  	android: "44",
		  	bun: "0.1.1",
		  	chrome: "44",
		  	"chrome-android": "44",
		  	deno: "1.0",
		  	edge: "13",
		  	electron: "0.30",
		  	firefox: "35",
		  	"firefox-android": "35",
		  	hermes: "0.1",
		  	ios: "9.0",
		  	node: "3.0",
		  	oculus: "3.0",
		  	opera: "31",
		  	"opera-android": "31",
		  	opera_mobile: "31",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "9.0",
		  	samsung: "4.0"
		  },
		  	"es.object.get-own-property-descriptors": {
		  	android: "54",
		  	bun: "0.1.1",
		  	chrome: "54",
		  	"chrome-android": "54",
		  	deno: "1.0",
		  	edge: "15",
		  	electron: "1.4",
		  	firefox: "50",
		  	"firefox-android": "50",
		  	hermes: "0.6",
		  	ios: "10.0",
		  	node: "7.0",
		  	oculus: "3.0",
		  	opera: "41",
		  	"opera-android": "41",
		  	opera_mobile: "41",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	safari: "10.0",
		  	samsung: "6.0"
		  },
		  	"es.object.get-own-property-names": {
		  	android: "40",
		  	bun: "0.1.1",
		  	chrome: "40",
		  	"chrome-android": "40",
		  	deno: "1.0",
		  	edge: "13",
		  	electron: "0.21",
		  	firefox: "34",
		  	"firefox-android": "34",
		  	hermes: "0.1",
		  	ios: "9.0",
		  	node: "1.0",
		  	oculus: "3.0",
		  	opera: "27",
		  	"opera-android": "27",
		  	opera_mobile: "27",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "9.0",
		  	samsung: "3.4"
		  },
		  	"es.object.get-prototype-of": {
		  	android: "44",
		  	bun: "0.1.1",
		  	chrome: "44",
		  	"chrome-android": "44",
		  	deno: "1.0",
		  	edge: "13",
		  	electron: "0.30",
		  	firefox: "35",
		  	"firefox-android": "35",
		  	hermes: "0.1",
		  	ios: "9.0",
		  	node: "3.0",
		  	oculus: "3.0",
		  	opera: "31",
		  	"opera-android": "31",
		  	opera_mobile: "31",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "9.0",
		  	samsung: "4.0"
		  },
		  	"es.object.group-by": {
		  	android: "117",
		  	bun: "1.0.19",
		  	chrome: "117",
		  	"chrome-android": "117",
		  	deno: "1.37",
		  	edge: "117",
		  	electron: "27.0",
		  	firefox: "119",
		  	"firefox-android": "119",
		  	ios: "17.4",
		  	node: "21.0",
		  	oculus: "30.0",
		  	opera: "103",
		  	"opera-android": "78",
		  	opera_mobile: "78",
		  	quest: "30.0",
		  	safari: "17.4",
		  	samsung: "24.0"
		  },
		  	"es.object.has-own": {
		  	android: "93",
		  	bun: "0.1.1",
		  	chrome: "93",
		  	"chrome-android": "93",
		  	deno: "1.13",
		  	edge: "93",
		  	electron: "14.0",
		  	firefox: "92",
		  	"firefox-android": "92",
		  	hermes: "0.10",
		  	ios: "15.4",
		  	node: "16.9",
		  	oculus: "17.0",
		  	opera: "79",
		  	"opera-android": "66",
		  	opera_mobile: "66",
		  	quest: "17.0",
		  	"react-native": "0.69",
		  	safari: "15.4",
		  	samsung: "17.0"
		  },
		  	"es.object.is": {
		  	android: "4.1",
		  	bun: "0.1.1",
		  	chrome: "19",
		  	"chrome-android": "25",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.20",
		  	firefox: "22",
		  	"firefox-android": "22",
		  	hermes: "0.1",
		  	ios: "9.0",
		  	node: "0.7.3",
		  	oculus: "3.0",
		  	opera: "15",
		  	"opera-android": "15",
		  	opera_mobile: "15",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "9.0",
		  	samsung: "1.5"
		  },
		  	"es.object.is-extensible": {
		  	android: "44",
		  	bun: "0.1.1",
		  	chrome: "44",
		  	"chrome-android": "44",
		  	deno: "1.0",
		  	edge: "13",
		  	electron: "0.30",
		  	firefox: "35",
		  	"firefox-android": "35",
		  	hermes: "0.1",
		  	ios: "9.0",
		  	node: "3.0",
		  	oculus: "3.0",
		  	opera: "31",
		  	"opera-android": "31",
		  	opera_mobile: "31",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "9.0",
		  	samsung: "4.0"
		  },
		  	"es.object.is-frozen": {
		  	android: "44",
		  	bun: "0.1.1",
		  	chrome: "44",
		  	"chrome-android": "44",
		  	deno: "1.0",
		  	edge: "13",
		  	electron: "0.30",
		  	firefox: "35",
		  	"firefox-android": "35",
		  	hermes: "0.1",
		  	ios: "9.0",
		  	node: "3.0",
		  	oculus: "3.0",
		  	opera: "31",
		  	"opera-android": "31",
		  	opera_mobile: "31",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "9.0",
		  	samsung: "4.0"
		  },
		  	"es.object.is-sealed": {
		  	android: "44",
		  	bun: "0.1.1",
		  	chrome: "44",
		  	"chrome-android": "44",
		  	deno: "1.0",
		  	edge: "13",
		  	electron: "0.30",
		  	firefox: "35",
		  	"firefox-android": "35",
		  	hermes: "0.1",
		  	ios: "9.0",
		  	node: "3.0",
		  	oculus: "3.0",
		  	opera: "31",
		  	"opera-android": "31",
		  	opera_mobile: "31",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "9.0",
		  	samsung: "4.0"
		  },
		  	"es.object.keys": {
		  	android: "40",
		  	bun: "0.1.1",
		  	chrome: "40",
		  	"chrome-android": "40",
		  	deno: "1.0",
		  	edge: "13",
		  	electron: "0.21",
		  	firefox: "35",
		  	"firefox-android": "35",
		  	hermes: "0.1",
		  	ios: "9.0",
		  	node: "1.0",
		  	oculus: "3.0",
		  	opera: "27",
		  	"opera-android": "27",
		  	opera_mobile: "27",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "9.0",
		  	samsung: "3.4"
		  },
		  	"es.object.lookup-getter": {
		  	android: "62",
		  	bun: "0.1.1",
		  	chrome: "62",
		  	"chrome-android": "62",
		  	deno: "1.0",
		  	edge: "16",
		  	electron: "3.0",
		  	firefox: "48",
		  	"firefox-android": "48",
		  	hermes: "0.1",
		  	ios: "8.0",
		  	node: "8.10",
		  	oculus: "5.0",
		  	opera: "49",
		  	"opera-android": "46",
		  	opera_mobile: "46",
		  	quest: "5.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "7.1",
		  	samsung: "8.0"
		  },
		  	"es.object.lookup-setter": {
		  	android: "62",
		  	bun: "0.1.1",
		  	chrome: "62",
		  	"chrome-android": "62",
		  	deno: "1.0",
		  	edge: "16",
		  	electron: "3.0",
		  	firefox: "48",
		  	"firefox-android": "48",
		  	hermes: "0.1",
		  	ios: "8.0",
		  	node: "8.10",
		  	oculus: "5.0",
		  	opera: "49",
		  	"opera-android": "46",
		  	opera_mobile: "46",
		  	quest: "5.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "7.1",
		  	samsung: "8.0"
		  },
		  	"es.object.prevent-extensions": {
		  	android: "44",
		  	bun: "0.1.1",
		  	chrome: "44",
		  	"chrome-android": "44",
		  	deno: "1.0",
		  	edge: "13",
		  	electron: "0.30",
		  	firefox: "35",
		  	"firefox-android": "35",
		  	hermes: "0.1",
		  	ios: "9.0",
		  	node: "3.0",
		  	oculus: "3.0",
		  	opera: "31",
		  	"opera-android": "31",
		  	opera_mobile: "31",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "9.0",
		  	samsung: "4.0"
		  },
		  	"es.object.proto": {
		  	android: "3.0",
		  	bun: "0.1.1",
		  	chrome: "5",
		  	"chrome-android": "18",
		  	edge: "12",
		  	electron: "0.20",
		  	firefox: "2",
		  	"firefox-android": "4",
		  	hermes: "0.1",
		  	ie: "11",
		  	ios: "2.0",
		  	node: "0.1.27",
		  	oculus: "3.0",
		  	opera: "10.50",
		  	"opera-android": "10.50",
		  	opera_mobile: "10.50",
		  	phantom: "1.9",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	safari: "3.1",
		  	samsung: "1.0"
		  },
		  	"es.object.seal": {
		  	android: "44",
		  	bun: "0.1.1",
		  	chrome: "44",
		  	"chrome-android": "44",
		  	deno: "1.0",
		  	edge: "13",
		  	electron: "0.30",
		  	firefox: "35",
		  	"firefox-android": "35",
		  	hermes: "0.1",
		  	ios: "9.0",
		  	node: "3.0",
		  	oculus: "3.0",
		  	opera: "31",
		  	"opera-android": "31",
		  	opera_mobile: "31",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "9.0",
		  	samsung: "4.0"
		  },
		  	"es.object.set-prototype-of": {
		  	android: "37",
		  	bun: "0.1.1",
		  	chrome: "34",
		  	"chrome-android": "34",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.20",
		  	firefox: "31",
		  	"firefox-android": "31",
		  	hermes: "0.1",
		  	ie: "11",
		  	ios: "9.0",
		  	node: "0.11.13",
		  	oculus: "3.0",
		  	opera: "21",
		  	"opera-android": "21",
		  	opera_mobile: "21",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "9.0",
		  	samsung: "2.0"
		  },
		  	"es.object.to-string": {
		  	android: "49",
		  	bun: "0.1.1",
		  	chrome: "49",
		  	"chrome-android": "49",
		  	deno: "1.0",
		  	edge: "15",
		  	electron: "0.37",
		  	firefox: "51",
		  	"firefox-android": "51",
		  	hermes: "0.1",
		  	ios: "10.0",
		  	node: "6.0",
		  	oculus: "3.0",
		  	opera: "36",
		  	"opera-android": "36",
		  	opera_mobile: "36",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	safari: "10.0",
		  	samsung: "5.0"
		  },
		  	"es.object.values": {
		  	android: "54",
		  	bun: "0.1.1",
		  	chrome: "54",
		  	"chrome-android": "54",
		  	deno: "1.0",
		  	edge: "14",
		  	electron: "1.4",
		  	firefox: "47",
		  	"firefox-android": "47",
		  	hermes: "0.1",
		  	ios: "10.3",
		  	node: "7.0",
		  	oculus: "3.0",
		  	opera: "41",
		  	"opera-android": "41",
		  	opera_mobile: "41",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.14",
		  	safari: "10.1",
		  	samsung: "6.0"
		  },
		  	"es.parse-float": {
		  	android: "37",
		  	bun: "0.1.1",
		  	chrome: "35",
		  	"chrome-android": "35",
		  	deno: "1.0",
		  	edge: "74",
		  	electron: "0.20",
		  	firefox: "8",
		  	"firefox-android": "8",
		  	hermes: "0.1",
		  	ie: "8",
		  	ios: "8.0",
		  	node: "0.11.13",
		  	oculus: "3.0",
		  	opera: "22",
		  	"opera-android": "22",
		  	opera_mobile: "22",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "7.1",
		  	samsung: "3.0"
		  },
		  	"es.parse-int": {
		  	android: "37",
		  	bun: "0.1.1",
		  	chrome: "35",
		  	"chrome-android": "35",
		  	deno: "1.0",
		  	edge: "74",
		  	electron: "0.20",
		  	firefox: "21",
		  	"firefox-android": "21",
		  	hermes: "0.1",
		  	ie: "9",
		  	ios: "8.0",
		  	node: "0.11.13",
		  	oculus: "3.0",
		  	opera: "22",
		  	"opera-android": "22",
		  	opera_mobile: "22",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "7.1",
		  	samsung: "3.0"
		  },
		  	"es.promise": {
		  	android: "67",
		  	bun: "0.1.1",
		  	chrome: "67",
		  	"chrome-android": "67",
		  	deno: "1.24",
		  	edge: "79",
		  	electron: "4.0",
		  	firefox: "69",
		  	"firefox-android": "69",
		  	ios: "11.0",
		  	node: "10.4",
		  	oculus: "6.0",
		  	opera: "54",
		  	"opera-android": "48",
		  	opera_mobile: "48",
		  	quest: "6.0",
		  	rhino: "1.7.14",
		  	safari: "11.0",
		  	samsung: "9.0"
		  },
		  	"es.promise.all-settled": {
		  	android: "76",
		  	bun: "0.1.1",
		  	chrome: "76",
		  	"chrome-android": "76",
		  	deno: "1.24",
		  	edge: "79",
		  	electron: "6.0",
		  	firefox: "71",
		  	"firefox-android": "71",
		  	ios: "13.0",
		  	node: "12.9",
		  	oculus: "7.0",
		  	opera: "63",
		  	"opera-android": "54",
		  	opera_mobile: "54",
		  	quest: "7.0",
		  	safari: "13",
		  	samsung: "12.0"
		  },
		  	"es.promise.any": {
		  	android: "85",
		  	bun: "0.1.1",
		  	chrome: "85",
		  	"chrome-android": "85",
		  	deno: "1.24",
		  	edge: "85",
		  	electron: "10.0",
		  	firefox: "79",
		  	"firefox-android": "79",
		  	ios: "14.0",
		  	node: "15.0",
		  	oculus: "12.0",
		  	opera: "71",
		  	"opera-android": "60",
		  	opera_mobile: "60",
		  	quest: "12.0",
		  	safari: "14.0",
		  	samsung: "14.0"
		  },
		  	"es.promise.finally": {
		  	android: "67",
		  	bun: "0.1.1",
		  	chrome: "67",
		  	"chrome-android": "67",
		  	deno: "1.24",
		  	edge: "79",
		  	electron: "4.0",
		  	firefox: "69",
		  	"firefox-android": "69",
		  	ios: "13.2.3",
		  	node: "10.4",
		  	oculus: "6.0",
		  	opera: "54",
		  	"opera-android": "48",
		  	opera_mobile: "48",
		  	quest: "6.0",
		  	rhino: "1.7.14",
		  	safari: "13.0.3",
		  	samsung: "9.0"
		  },
		  	"es.promise.with-resolvers": {
		  	android: "119",
		  	bun: "0.7.1",
		  	chrome: "119",
		  	"chrome-android": "119",
		  	deno: "1.38",
		  	edge: "119",
		  	electron: "28.0",
		  	firefox: "121",
		  	"firefox-android": "121",
		  	ios: "17.4",
		  	oculus: "31.0",
		  	opera: "105",
		  	"opera-android": "79",
		  	opera_mobile: "79",
		  	quest: "31.0",
		  	safari: "17.4",
		  	samsung: "25.0"
		  },
		  	"es.reflect.apply": {
		  	android: "49",
		  	bun: "0.1.1",
		  	chrome: "49",
		  	"chrome-android": "49",
		  	deno: "1.0",
		  	edge: "15",
		  	electron: "0.37",
		  	firefox: "42",
		  	"firefox-android": "42",
		  	hermes: "0.7",
		  	ios: "10.0",
		  	node: "6.0",
		  	oculus: "3.0",
		  	opera: "36",
		  	"opera-android": "36",
		  	opera_mobile: "36",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	safari: "10.0",
		  	samsung: "5.0"
		  },
		  	"es.reflect.construct": {
		  	android: "49",
		  	bun: "0.1.1",
		  	chrome: "49",
		  	"chrome-android": "49",
		  	deno: "1.0",
		  	edge: "15",
		  	electron: "0.37",
		  	firefox: "44",
		  	"firefox-android": "44",
		  	hermes: "0.7",
		  	ios: "10.0",
		  	node: "6.0",
		  	oculus: "3.0",
		  	opera: "36",
		  	"opera-android": "36",
		  	opera_mobile: "36",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	safari: "10.0",
		  	samsung: "5.0"
		  },
		  	"es.reflect.define-property": {
		  	android: "49",
		  	bun: "0.1.1",
		  	chrome: "49",
		  	"chrome-android": "49",
		  	deno: "1.0",
		  	edge: "13",
		  	electron: "0.37",
		  	firefox: "42",
		  	"firefox-android": "42",
		  	hermes: "0.7",
		  	ios: "10.0",
		  	node: "6.0",
		  	oculus: "3.0",
		  	opera: "36",
		  	"opera-android": "36",
		  	opera_mobile: "36",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	safari: "10.0",
		  	samsung: "5.0"
		  },
		  	"es.reflect.delete-property": {
		  	android: "49",
		  	bun: "0.1.1",
		  	chrome: "49",
		  	"chrome-android": "49",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.37",
		  	firefox: "42",
		  	"firefox-android": "42",
		  	hermes: "0.7",
		  	ios: "10.0",
		  	node: "6.0",
		  	oculus: "3.0",
		  	opera: "36",
		  	"opera-android": "36",
		  	opera_mobile: "36",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	safari: "10.0",
		  	samsung: "5.0"
		  },
		  	"es.reflect.get": {
		  	android: "49",
		  	bun: "0.1.1",
		  	chrome: "49",
		  	"chrome-android": "49",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.37",
		  	firefox: "42",
		  	"firefox-android": "42",
		  	hermes: "0.7",
		  	ios: "10.0",
		  	node: "6.0",
		  	oculus: "3.0",
		  	opera: "36",
		  	"opera-android": "36",
		  	opera_mobile: "36",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	safari: "10.0",
		  	samsung: "5.0"
		  },
		  	"es.reflect.get-own-property-descriptor": {
		  	android: "49",
		  	bun: "0.1.1",
		  	chrome: "49",
		  	"chrome-android": "49",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.37",
		  	firefox: "42",
		  	"firefox-android": "42",
		  	hermes: "0.7",
		  	ios: "10.0",
		  	node: "6.0",
		  	oculus: "3.0",
		  	opera: "36",
		  	"opera-android": "36",
		  	opera_mobile: "36",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	safari: "10.0",
		  	samsung: "5.0"
		  },
		  	"es.reflect.get-prototype-of": {
		  	android: "49",
		  	bun: "0.1.1",
		  	chrome: "49",
		  	"chrome-android": "49",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.37",
		  	firefox: "42",
		  	"firefox-android": "42",
		  	hermes: "0.7",
		  	ios: "10.0",
		  	node: "6.0",
		  	oculus: "3.0",
		  	opera: "36",
		  	"opera-android": "36",
		  	opera_mobile: "36",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	safari: "10.0",
		  	samsung: "5.0"
		  },
		  	"es.reflect.has": {
		  	android: "49",
		  	bun: "0.1.1",
		  	chrome: "49",
		  	"chrome-android": "49",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.37",
		  	firefox: "42",
		  	"firefox-android": "42",
		  	hermes: "0.7",
		  	ios: "10.0",
		  	node: "6.0",
		  	oculus: "3.0",
		  	opera: "36",
		  	"opera-android": "36",
		  	opera_mobile: "36",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	safari: "10.0",
		  	samsung: "5.0"
		  },
		  	"es.reflect.is-extensible": {
		  	android: "49",
		  	bun: "0.1.1",
		  	chrome: "49",
		  	"chrome-android": "49",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.37",
		  	firefox: "42",
		  	"firefox-android": "42",
		  	hermes: "0.7",
		  	ios: "10.0",
		  	node: "6.0",
		  	oculus: "3.0",
		  	opera: "36",
		  	"opera-android": "36",
		  	opera_mobile: "36",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	safari: "10.0",
		  	samsung: "5.0"
		  },
		  	"es.reflect.own-keys": {
		  	android: "49",
		  	bun: "0.1.1",
		  	chrome: "49",
		  	"chrome-android": "49",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.37",
		  	firefox: "42",
		  	"firefox-android": "42",
		  	hermes: "0.7",
		  	ios: "10.0",
		  	node: "6.0",
		  	oculus: "3.0",
		  	opera: "36",
		  	"opera-android": "36",
		  	opera_mobile: "36",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	safari: "10.0",
		  	samsung: "5.0"
		  },
		  	"es.reflect.prevent-extensions": {
		  	android: "49",
		  	bun: "0.1.1",
		  	chrome: "49",
		  	"chrome-android": "49",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.37",
		  	firefox: "42",
		  	"firefox-android": "42",
		  	hermes: "0.7",
		  	ios: "10.0",
		  	node: "6.0",
		  	oculus: "3.0",
		  	opera: "36",
		  	"opera-android": "36",
		  	opera_mobile: "36",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	safari: "10.0",
		  	samsung: "5.0"
		  },
		  	"es.reflect.set": {
		  	android: "49",
		  	bun: "0.1.1",
		  	chrome: "49",
		  	"chrome-android": "49",
		  	deno: "1.0",
		  	edge: "79",
		  	electron: "0.37",
		  	firefox: "42",
		  	"firefox-android": "42",
		  	hermes: "0.7",
		  	ios: "10.0",
		  	node: "6.0",
		  	oculus: "3.0",
		  	opera: "36",
		  	"opera-android": "36",
		  	opera_mobile: "36",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	safari: "10.0",
		  	samsung: "5.0"
		  },
		  	"es.reflect.set-prototype-of": {
		  	android: "49",
		  	bun: "0.1.1",
		  	chrome: "49",
		  	"chrome-android": "49",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.37",
		  	firefox: "42",
		  	"firefox-android": "42",
		  	hermes: "0.7",
		  	ios: "10.0",
		  	node: "6.0",
		  	oculus: "3.0",
		  	opera: "36",
		  	"opera-android": "36",
		  	opera_mobile: "36",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	safari: "10.0",
		  	samsung: "5.0"
		  },
		  	"es.reflect.to-string-tag": {
		  	android: "86",
		  	bun: "0.1.1",
		  	chrome: "86",
		  	"chrome-android": "86",
		  	deno: "1.3",
		  	edge: "86",
		  	electron: "11.0",
		  	firefox: "82",
		  	"firefox-android": "82",
		  	hermes: "0.7",
		  	ios: "14.0",
		  	node: "15.0",
		  	oculus: "12.0",
		  	opera: "72",
		  	"opera-android": "61",
		  	opera_mobile: "61",
		  	quest: "12.0",
		  	"react-native": "0.69",
		  	safari: "14.0",
		  	samsung: "14.0"
		  },
		  	"es.regexp.constructor": {
		  	android: "64",
		  	bun: "0.1.1",
		  	chrome: "64",
		  	"chrome-android": "64",
		  	deno: "1.0",
		  	edge: "79",
		  	electron: "3.0",
		  	firefox: "78",
		  	"firefox-android": "78",
		  	ios: "11.3",
		  	node: "10.0",
		  	oculus: "5.0",
		  	opera: "51",
		  	"opera-android": "47",
		  	opera_mobile: "47",
		  	quest: "5.0",
		  	safari: "11.1",
		  	samsung: "9.0"
		  },
		  	"es.regexp.dot-all": {
		  	android: "62",
		  	bun: "0.1.1",
		  	chrome: "62",
		  	"chrome-android": "62",
		  	deno: "1.0",
		  	edge: "79",
		  	electron: "3.0",
		  	firefox: "78",
		  	"firefox-android": "78",
		  	hermes: "0.4",
		  	ios: "11.3",
		  	node: "8.10",
		  	oculus: "5.0",
		  	opera: "49",
		  	"opera-android": "46",
		  	opera_mobile: "46",
		  	quest: "5.0",
		  	"react-native": "0.69",
		  	safari: "11.1",
		  	samsung: "8.0"
		  },
		  	"es.regexp.exec": {
		  	android: "64",
		  	bun: "0.1.1",
		  	chrome: "64",
		  	"chrome-android": "64",
		  	deno: "1.0",
		  	edge: "79",
		  	electron: "3.0",
		  	firefox: "78",
		  	"firefox-android": "78",
		  	ios: "11.3",
		  	node: "10.0",
		  	oculus: "5.0",
		  	opera: "51",
		  	"opera-android": "47",
		  	opera_mobile: "47",
		  	quest: "5.0",
		  	"react-native": "0.71",
		  	safari: "11.1",
		  	samsung: "9.0"
		  },
		  	"es.regexp.flags": {
		  	android: "111",
		  	bun: "0.1.1",
		  	chrome: "111",
		  	"chrome-android": "111",
		  	deno: "1.32",
		  	edge: "111",
		  	electron: "24.0",
		  	firefox: "78",
		  	"firefox-android": "78",
		  	hermes: "0.4",
		  	ios: "11.3",
		  	node: "20.0",
		  	oculus: "27.0",
		  	opera: "97",
		  	"opera-android": "75",
		  	opera_mobile: "75",
		  	quest: "27.0",
		  	"react-native": "0.69",
		  	safari: "11.1",
		  	samsung: "22.0"
		  },
		  	"es.regexp.sticky": {
		  	android: "49",
		  	bun: "0.1.1",
		  	chrome: "49",
		  	"chrome-android": "49",
		  	deno: "1.0",
		  	edge: "13",
		  	electron: "0.37",
		  	firefox: "3",
		  	"firefox-android": "4",
		  	hermes: "0.3",
		  	ios: "10.0",
		  	node: "6.0",
		  	oculus: "3.0",
		  	opera: "36",
		  	"opera-android": "36",
		  	opera_mobile: "36",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	safari: "10.0",
		  	samsung: "5.0"
		  },
		  	"es.regexp.test": {
		  	android: "51",
		  	bun: "0.1.1",
		  	chrome: "51",
		  	"chrome-android": "51",
		  	deno: "1.0",
		  	edge: "79",
		  	electron: "1.2",
		  	firefox: "46",
		  	"firefox-android": "46",
		  	ios: "10.0",
		  	node: "6.5",
		  	oculus: "3.0",
		  	opera: "38",
		  	"opera-android": "38",
		  	opera_mobile: "38",
		  	quest: "3.0",
		  	safari: "10.0",
		  	samsung: "5.0"
		  },
		  	"es.regexp.to-string": {
		  	android: "50",
		  	bun: "0.1.1",
		  	chrome: "50",
		  	"chrome-android": "50",
		  	deno: "1.0",
		  	edge: "79",
		  	electron: "1.1",
		  	firefox: "46",
		  	"firefox-android": "46",
		  	hermes: "0.1",
		  	ios: "10.0",
		  	node: "6.0",
		  	oculus: "3.0",
		  	opera: "37",
		  	"opera-android": "37",
		  	opera_mobile: "37",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	safari: "10.0",
		  	samsung: "5.0"
		  },
		  	"es.set": {
		  	android: "51",
		  	bun: "0.1.1",
		  	chrome: "51",
		  	"chrome-android": "51",
		  	deno: "1.0",
		  	edge: "15",
		  	electron: "1.2",
		  	firefox: "53",
		  	"firefox-android": "53",
		  	ios: "10.0",
		  	node: "6.5",
		  	oculus: "3.0",
		  	opera: "38",
		  	"opera-android": "38",
		  	opera_mobile: "38",
		  	quest: "3.0",
		  	"react-native": "0.73",
		  	rhino: "1.7.13",
		  	safari: "10.0",
		  	samsung: "5.0"
		  },
		  	"es.string.at-alternative": {
		  	android: "92",
		  	bun: "0.1.1",
		  	chrome: "92",
		  	"chrome-android": "92",
		  	deno: "1.12",
		  	edge: "92",
		  	electron: "14.0",
		  	firefox: "90",
		  	"firefox-android": "90",
		  	ios: "15.4",
		  	node: "16.6",
		  	oculus: "17.0",
		  	opera: "78",
		  	"opera-android": "65",
		  	opera_mobile: "65",
		  	quest: "17.0",
		  	"react-native": "0.71",
		  	safari: "15.4",
		  	samsung: "16.0"
		  },
		  	"es.string.code-point-at": {
		  	android: "41",
		  	bun: "0.1.1",
		  	chrome: "41",
		  	"chrome-android": "41",
		  	deno: "1.0",
		  	edge: "13",
		  	electron: "0.21",
		  	firefox: "29",
		  	"firefox-android": "29",
		  	hermes: "0.1",
		  	ios: "9.0",
		  	node: "1.0",
		  	oculus: "3.0",
		  	opera: "28",
		  	"opera-android": "28",
		  	opera_mobile: "28",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "9.0",
		  	samsung: "3.4"
		  },
		  	"es.string.ends-with": {
		  	android: "51",
		  	bun: "0.1.1",
		  	chrome: "51",
		  	"chrome-android": "51",
		  	deno: "1.0",
		  	edge: "79",
		  	electron: "1.2",
		  	firefox: "40",
		  	"firefox-android": "40",
		  	hermes: "0.1",
		  	ios: "10.0",
		  	node: "6.5",
		  	oculus: "3.0",
		  	opera: "38",
		  	"opera-android": "38",
		  	opera_mobile: "38",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	safari: "10.0",
		  	samsung: "5.0"
		  },
		  	"es.string.from-code-point": {
		  	android: "41",
		  	bun: "0.1.1",
		  	chrome: "41",
		  	"chrome-android": "41",
		  	deno: "1.0",
		  	edge: "13",
		  	electron: "0.21",
		  	firefox: "29",
		  	"firefox-android": "29",
		  	hermes: "0.1",
		  	ios: "9.0",
		  	node: "1.0",
		  	oculus: "3.0",
		  	opera: "28",
		  	"opera-android": "28",
		  	opera_mobile: "28",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "9.0",
		  	samsung: "3.4"
		  },
		  	"es.string.includes": {
		  	android: "51",
		  	bun: "0.1.1",
		  	chrome: "51",
		  	"chrome-android": "51",
		  	deno: "1.0",
		  	edge: "79",
		  	electron: "1.2",
		  	firefox: "40",
		  	"firefox-android": "40",
		  	hermes: "0.1",
		  	ios: "10.0",
		  	node: "6.5",
		  	oculus: "3.0",
		  	opera: "38",
		  	"opera-android": "38",
		  	opera_mobile: "38",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	safari: "10.0",
		  	samsung: "5.0"
		  },
		  	"es.string.is-well-formed": {
		  	android: "111",
		  	bun: "0.4.0",
		  	chrome: "111",
		  	"chrome-android": "111",
		  	deno: "1.32",
		  	edge: "111",
		  	electron: "24.0",
		  	firefox: "119",
		  	"firefox-android": "119",
		  	ios: "16.4",
		  	node: "20.0",
		  	oculus: "27.0",
		  	opera: "97",
		  	"opera-android": "75",
		  	opera_mobile: "75",
		  	quest: "27.0",
		  	safari: "16.4",
		  	samsung: "22.0"
		  },
		  	"es.string.iterator": {
		  	android: "41",
		  	bun: "0.1.1",
		  	chrome: "41",
		  	"chrome-android": "41",
		  	deno: "1.0",
		  	edge: "13",
		  	electron: "0.21",
		  	firefox: "36",
		  	"firefox-android": "36",
		  	hermes: "0.1",
		  	ios: "9.0",
		  	node: "1.0",
		  	oculus: "3.0",
		  	opera: "28",
		  	"opera-android": "28",
		  	opera_mobile: "28",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "9.0",
		  	samsung: "3.4"
		  },
		  	"es.string.match": {
		  	android: "51",
		  	bun: "0.1.1",
		  	chrome: "51",
		  	"chrome-android": "51",
		  	deno: "1.0",
		  	edge: "79",
		  	electron: "1.2",
		  	firefox: "49",
		  	"firefox-android": "49",
		  	hermes: "0.1",
		  	ios: "10.0",
		  	node: "6.5",
		  	oculus: "3.0",
		  	opera: "38",
		  	"opera-android": "38",
		  	opera_mobile: "38",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	safari: "10.0",
		  	samsung: "5.0"
		  },
		  	"es.string.match-all": {
		  	android: "80",
		  	bun: "0.1.1",
		  	chrome: "80",
		  	"chrome-android": "80",
		  	deno: "1.0",
		  	edge: "80",
		  	electron: "8.0",
		  	firefox: "73",
		  	"firefox-android": "73",
		  	hermes: "0.6",
		  	ios: "13.4",
		  	node: "14.0",
		  	oculus: "9.0",
		  	opera: "67",
		  	"opera-android": "57",
		  	opera_mobile: "57",
		  	quest: "9.0",
		  	"react-native": "0.69",
		  	safari: "13.1",
		  	samsung: "13.0"
		  },
		  	"es.string.pad-end": {
		  	android: "57",
		  	bun: "0.1.1",
		  	chrome: "57",
		  	"chrome-android": "57",
		  	deno: "1.0",
		  	edge: "15",
		  	electron: "1.7",
		  	firefox: "48",
		  	"firefox-android": "48",
		  	hermes: "0.1",
		  	ios: "11.0",
		  	node: "8.0",
		  	oculus: "3.0",
		  	opera: "44",
		  	"opera-android": "43",
		  	opera_mobile: "43",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "11.0",
		  	samsung: "7.0"
		  },
		  	"es.string.pad-start": {
		  	android: "57",
		  	bun: "0.1.1",
		  	chrome: "57",
		  	"chrome-android": "57",
		  	deno: "1.0",
		  	edge: "15",
		  	electron: "1.7",
		  	firefox: "48",
		  	"firefox-android": "48",
		  	hermes: "0.1",
		  	ios: "11.0",
		  	node: "8.0",
		  	oculus: "3.0",
		  	opera: "44",
		  	"opera-android": "43",
		  	opera_mobile: "43",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "11.0",
		  	samsung: "7.0"
		  },
		  	"es.string.raw": {
		  	android: "41",
		  	bun: "0.1.1",
		  	chrome: "41",
		  	"chrome-android": "41",
		  	deno: "1.0",
		  	edge: "13",
		  	electron: "0.21",
		  	firefox: "34",
		  	"firefox-android": "34",
		  	hermes: "0.1",
		  	ios: "9.0",
		  	node: "1.0",
		  	oculus: "3.0",
		  	opera: "28",
		  	"opera-android": "28",
		  	opera_mobile: "28",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.14",
		  	safari: "9.0",
		  	samsung: "3.4"
		  },
		  	"es.string.repeat": {
		  	android: "41",
		  	bun: "0.1.1",
		  	chrome: "41",
		  	"chrome-android": "41",
		  	deno: "1.0",
		  	edge: "13",
		  	electron: "0.21",
		  	firefox: "24",
		  	"firefox-android": "24",
		  	hermes: "0.1",
		  	ios: "9.0",
		  	node: "1.0",
		  	oculus: "3.0",
		  	opera: "28",
		  	"opera-android": "28",
		  	opera_mobile: "28",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "9.0",
		  	samsung: "3.4"
		  },
		  	"es.string.replace": {
		  	android: "64",
		  	bun: "0.1.1",
		  	chrome: "64",
		  	"chrome-android": "64",
		  	deno: "1.0",
		  	edge: "79",
		  	electron: "3.0",
		  	firefox: "78",
		  	"firefox-android": "78",
		  	ios: "14.0",
		  	node: "10.0",
		  	oculus: "5.0",
		  	opera: "51",
		  	"opera-android": "47",
		  	opera_mobile: "47",
		  	quest: "5.0",
		  	"react-native": "0.71",
		  	safari: "14.0",
		  	samsung: "9.0"
		  },
		  	"es.string.replace-all": {
		  	android: "85",
		  	bun: "0.1.1",
		  	chrome: "85",
		  	"chrome-android": "85",
		  	deno: "1.2",
		  	edge: "85",
		  	electron: "10.0",
		  	firefox: "77",
		  	"firefox-android": "77",
		  	hermes: "0.7",
		  	ios: "13.4",
		  	node: "15.0",
		  	oculus: "12.0",
		  	opera: "71",
		  	"opera-android": "60",
		  	opera_mobile: "60",
		  	quest: "12.0",
		  	"react-native": "0.69",
		  	safari: "13.1",
		  	samsung: "14.0"
		  },
		  	"es.string.search": {
		  	android: "51",
		  	bun: "0.1.1",
		  	chrome: "51",
		  	"chrome-android": "51",
		  	deno: "1.0",
		  	edge: "79",
		  	electron: "1.2",
		  	firefox: "49",
		  	"firefox-android": "49",
		  	hermes: "0.1",
		  	ios: "10.0",
		  	node: "6.5",
		  	oculus: "3.0",
		  	opera: "38",
		  	"opera-android": "38",
		  	opera_mobile: "38",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	safari: "10.0",
		  	samsung: "5.0"
		  },
		  	"es.string.split": {
		  	android: "54",
		  	bun: "0.1.1",
		  	chrome: "54",
		  	"chrome-android": "54",
		  	deno: "1.0",
		  	edge: "79",
		  	electron: "1.4",
		  	firefox: "49",
		  	"firefox-android": "49",
		  	ios: "10.0",
		  	node: "7.0",
		  	oculus: "3.0",
		  	opera: "41",
		  	"opera-android": "41",
		  	opera_mobile: "41",
		  	quest: "3.0",
		  	safari: "10.0",
		  	samsung: "6.0"
		  },
		  	"es.string.starts-with": {
		  	android: "51",
		  	bun: "0.1.1",
		  	chrome: "51",
		  	"chrome-android": "51",
		  	deno: "1.0",
		  	edge: "79",
		  	electron: "1.2",
		  	firefox: "40",
		  	"firefox-android": "40",
		  	hermes: "0.1",
		  	ios: "10.0",
		  	node: "6.5",
		  	oculus: "3.0",
		  	opera: "38",
		  	"opera-android": "38",
		  	opera_mobile: "38",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	safari: "10.0",
		  	samsung: "5.0"
		  },
		  	"es.string.substr": {
		  	android: "3.0",
		  	bun: "0.1.1",
		  	chrome: "1",
		  	"chrome-android": "18",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.20",
		  	firefox: "1",
		  	"firefox-android": "4",
		  	hermes: "0.1",
		  	ie: "9",
		  	ios: "1.0",
		  	node: "0.0.3",
		  	oculus: "3.0",
		  	opera: "4",
		  	"opera-android": "4",
		  	opera_mobile: "4",
		  	phantom: "1.9",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "1",
		  	samsung: "1.0"
		  },
		  	"es.string.to-well-formed": {
		  	android: "111",
		  	bun: "0.5.7",
		  	chrome: "111",
		  	"chrome-android": "111",
		  	deno: "1.32",
		  	edge: "111",
		  	electron: "24.0",
		  	firefox: "119",
		  	"firefox-android": "119",
		  	ios: "16.4",
		  	node: "20.0",
		  	oculus: "27.0",
		  	opera: "97",
		  	"opera-android": "75",
		  	opera_mobile: "75",
		  	quest: "27.0",
		  	safari: "16.4",
		  	samsung: "22.0"
		  },
		  	"es.string.trim": {
		  	android: "59",
		  	bun: "0.1.1",
		  	chrome: "59",
		  	"chrome-android": "59",
		  	deno: "1.0",
		  	edge: "15",
		  	electron: "1.8",
		  	firefox: "52",
		  	"firefox-android": "52",
		  	hermes: "0.1",
		  	ios: "12.2",
		  	node: "8.3",
		  	oculus: "4.0",
		  	opera: "46",
		  	"opera-android": "43",
		  	opera_mobile: "43",
		  	quest: "4.0",
		  	"react-native": "0.69",
		  	safari: "12.1",
		  	samsung: "7.0"
		  },
		  	"es.string.trim-end": {
		  	android: "66",
		  	bun: "0.1.1",
		  	chrome: "66",
		  	"chrome-android": "66",
		  	deno: "1.0",
		  	edge: "79",
		  	electron: "3.0",
		  	firefox: "61",
		  	"firefox-android": "61",
		  	hermes: "0.3",
		  	ios: "12.2",
		  	node: "10.0",
		  	oculus: "5.0",
		  	opera: "53",
		  	"opera-android": "47",
		  	opera_mobile: "47",
		  	quest: "5.0",
		  	"react-native": "0.69",
		  	safari: "12.1",
		  	samsung: "9.0"
		  },
		  	"es.string.trim-start": {
		  	android: "66",
		  	bun: "0.1.1",
		  	chrome: "66",
		  	"chrome-android": "66",
		  	deno: "1.0",
		  	edge: "79",
		  	electron: "3.0",
		  	firefox: "61",
		  	"firefox-android": "61",
		  	hermes: "0.3",
		  	ios: "12.0",
		  	node: "10.0",
		  	oculus: "5.0",
		  	opera: "53",
		  	"opera-android": "47",
		  	opera_mobile: "47",
		  	quest: "5.0",
		  	"react-native": "0.69",
		  	safari: "12.0",
		  	samsung: "9.0"
		  },
		  	"es.string.anchor": {
		  	android: "3.0",
		  	bun: "0.1.1",
		  	chrome: "5",
		  	"chrome-android": "18",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.20",
		  	firefox: "17",
		  	"firefox-android": "17",
		  	ios: "6.0",
		  	node: "0.1.27",
		  	oculus: "3.0",
		  	opera: "15",
		  	"opera-android": "15",
		  	opera_mobile: "15",
		  	phantom: "2.0",
		  	quest: "3.0",
		  	rhino: "1.7.14",
		  	safari: "6.0",
		  	samsung: "1.0"
		  },
		  	"es.string.big": {
		  	android: "3.0",
		  	bun: "0.1.1",
		  	chrome: "5",
		  	"chrome-android": "18",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.20",
		  	firefox: "2",
		  	"firefox-android": "4",
		  	ios: "2.0",
		  	node: "0.1.27",
		  	oculus: "3.0",
		  	opera: "10.50",
		  	"opera-android": "10.50",
		  	opera_mobile: "10.50",
		  	phantom: "1.9",
		  	quest: "3.0",
		  	rhino: "1.7.13",
		  	safari: "3.1",
		  	samsung: "1.0"
		  },
		  	"es.string.blink": {
		  	android: "3.0",
		  	bun: "0.1.1",
		  	chrome: "5",
		  	"chrome-android": "18",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.20",
		  	firefox: "2",
		  	"firefox-android": "4",
		  	ios: "2.0",
		  	node: "0.1.27",
		  	oculus: "3.0",
		  	opera: "10.50",
		  	"opera-android": "10.50",
		  	opera_mobile: "10.50",
		  	phantom: "1.9",
		  	quest: "3.0",
		  	rhino: "1.7.13",
		  	safari: "3.1",
		  	samsung: "1.0"
		  },
		  	"es.string.bold": {
		  	android: "3.0",
		  	bun: "0.1.1",
		  	chrome: "5",
		  	"chrome-android": "18",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.20",
		  	firefox: "2",
		  	"firefox-android": "4",
		  	ios: "2.0",
		  	node: "0.1.27",
		  	oculus: "3.0",
		  	opera: "10.50",
		  	"opera-android": "10.50",
		  	opera_mobile: "10.50",
		  	phantom: "1.9",
		  	quest: "3.0",
		  	rhino: "1.7.13",
		  	safari: "3.1",
		  	samsung: "1.0"
		  },
		  	"es.string.fixed": {
		  	android: "3.0",
		  	bun: "0.1.1",
		  	chrome: "5",
		  	"chrome-android": "18",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.20",
		  	firefox: "2",
		  	"firefox-android": "4",
		  	ios: "2.0",
		  	node: "0.1.27",
		  	oculus: "3.0",
		  	opera: "10.50",
		  	"opera-android": "10.50",
		  	opera_mobile: "10.50",
		  	phantom: "1.9",
		  	quest: "3.0",
		  	rhino: "1.7.13",
		  	safari: "3.1",
		  	samsung: "1.0"
		  },
		  	"es.string.fontcolor": {
		  	android: "3.0",
		  	bun: "0.1.1",
		  	chrome: "5",
		  	"chrome-android": "18",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.20",
		  	firefox: "17",
		  	"firefox-android": "17",
		  	ios: "6.0",
		  	node: "0.1.27",
		  	oculus: "3.0",
		  	opera: "15",
		  	"opera-android": "15",
		  	opera_mobile: "15",
		  	phantom: "2.0",
		  	quest: "3.0",
		  	rhino: "1.7.14",
		  	safari: "6.0",
		  	samsung: "1.0"
		  },
		  	"es.string.fontsize": {
		  	android: "3.0",
		  	bun: "0.1.1",
		  	chrome: "5",
		  	"chrome-android": "18",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.20",
		  	firefox: "17",
		  	"firefox-android": "17",
		  	ios: "6.0",
		  	node: "0.1.27",
		  	oculus: "3.0",
		  	opera: "15",
		  	"opera-android": "15",
		  	opera_mobile: "15",
		  	phantom: "2.0",
		  	quest: "3.0",
		  	rhino: "1.7.14",
		  	safari: "6.0",
		  	samsung: "1.0"
		  },
		  	"es.string.italics": {
		  	android: "3.0",
		  	bun: "0.1.1",
		  	chrome: "5",
		  	"chrome-android": "18",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.20",
		  	firefox: "2",
		  	"firefox-android": "4",
		  	ios: "2.0",
		  	node: "0.1.27",
		  	oculus: "3.0",
		  	opera: "10.50",
		  	"opera-android": "10.50",
		  	opera_mobile: "10.50",
		  	phantom: "1.9",
		  	quest: "3.0",
		  	rhino: "1.7.13",
		  	safari: "3.1",
		  	samsung: "1.0"
		  },
		  	"es.string.link": {
		  	android: "3.0",
		  	bun: "0.1.1",
		  	chrome: "5",
		  	"chrome-android": "18",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.20",
		  	firefox: "17",
		  	"firefox-android": "17",
		  	ios: "6.0",
		  	node: "0.1.27",
		  	oculus: "3.0",
		  	opera: "15",
		  	"opera-android": "15",
		  	opera_mobile: "15",
		  	phantom: "2.0",
		  	quest: "3.0",
		  	rhino: "1.7.14",
		  	safari: "6.0",
		  	samsung: "1.0"
		  },
		  	"es.string.small": {
		  	android: "3.0",
		  	bun: "0.1.1",
		  	chrome: "5",
		  	"chrome-android": "18",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.20",
		  	firefox: "2",
		  	"firefox-android": "4",
		  	ios: "2.0",
		  	node: "0.1.27",
		  	oculus: "3.0",
		  	opera: "10.50",
		  	"opera-android": "10.50",
		  	opera_mobile: "10.50",
		  	phantom: "1.9",
		  	quest: "3.0",
		  	rhino: "1.7.13",
		  	safari: "3.1",
		  	samsung: "1.0"
		  },
		  	"es.string.strike": {
		  	android: "3.0",
		  	bun: "0.1.1",
		  	chrome: "5",
		  	"chrome-android": "18",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.20",
		  	firefox: "2",
		  	"firefox-android": "4",
		  	ios: "2.0",
		  	node: "0.1.27",
		  	oculus: "3.0",
		  	opera: "10.50",
		  	"opera-android": "10.50",
		  	opera_mobile: "10.50",
		  	phantom: "1.9",
		  	quest: "3.0",
		  	rhino: "1.7.13",
		  	safari: "3.1",
		  	samsung: "1.0"
		  },
		  	"es.string.sub": {
		  	android: "3.0",
		  	bun: "0.1.1",
		  	chrome: "5",
		  	"chrome-android": "18",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.20",
		  	firefox: "2",
		  	"firefox-android": "4",
		  	ios: "2.0",
		  	node: "0.1.27",
		  	oculus: "3.0",
		  	opera: "10.50",
		  	"opera-android": "10.50",
		  	opera_mobile: "10.50",
		  	phantom: "1.9",
		  	quest: "3.0",
		  	rhino: "1.7.13",
		  	safari: "3.1",
		  	samsung: "1.0"
		  },
		  	"es.string.sup": {
		  	android: "3.0",
		  	bun: "0.1.1",
		  	chrome: "5",
		  	"chrome-android": "18",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.20",
		  	firefox: "2",
		  	"firefox-android": "4",
		  	ios: "2.0",
		  	node: "0.1.27",
		  	oculus: "3.0",
		  	opera: "10.50",
		  	"opera-android": "10.50",
		  	opera_mobile: "10.50",
		  	phantom: "1.9",
		  	quest: "3.0",
		  	rhino: "1.7.13",
		  	safari: "3.1",
		  	samsung: "1.0"
		  },
		  	"es.typed-array.float32-array": {
		  	android: "54",
		  	bun: "0.1.1",
		  	chrome: "54",
		  	"chrome-android": "54",
		  	deno: "1.0",
		  	edge: "15",
		  	electron: "1.4",
		  	firefox: "55",
		  	"firefox-android": "55",
		  	ios: "14.0",
		  	node: "7.0",
		  	oculus: "3.0",
		  	opera: "41",
		  	"opera-android": "41",
		  	opera_mobile: "41",
		  	quest: "3.0",
		  	safari: "14.0",
		  	samsung: "6.0"
		  },
		  	"es.typed-array.float64-array": {
		  	android: "54",
		  	bun: "0.1.1",
		  	chrome: "54",
		  	"chrome-android": "54",
		  	deno: "1.0",
		  	edge: "15",
		  	electron: "1.4",
		  	firefox: "55",
		  	"firefox-android": "55",
		  	ios: "14.0",
		  	node: "7.0",
		  	oculus: "3.0",
		  	opera: "41",
		  	"opera-android": "41",
		  	opera_mobile: "41",
		  	quest: "3.0",
		  	safari: "14.0",
		  	samsung: "6.0"
		  },
		  	"es.typed-array.int8-array": {
		  	android: "54",
		  	bun: "0.1.1",
		  	chrome: "54",
		  	"chrome-android": "54",
		  	deno: "1.0",
		  	edge: "15",
		  	electron: "1.4",
		  	firefox: "55",
		  	"firefox-android": "55",
		  	ios: "14.0",
		  	node: "7.0",
		  	oculus: "3.0",
		  	opera: "41",
		  	"opera-android": "41",
		  	opera_mobile: "41",
		  	quest: "3.0",
		  	safari: "14.0",
		  	samsung: "6.0"
		  },
		  	"es.typed-array.int16-array": {
		  	android: "54",
		  	bun: "0.1.1",
		  	chrome: "54",
		  	"chrome-android": "54",
		  	deno: "1.0",
		  	edge: "15",
		  	electron: "1.4",
		  	firefox: "55",
		  	"firefox-android": "55",
		  	ios: "14.0",
		  	node: "7.0",
		  	oculus: "3.0",
		  	opera: "41",
		  	"opera-android": "41",
		  	opera_mobile: "41",
		  	quest: "3.0",
		  	safari: "14.0",
		  	samsung: "6.0"
		  },
		  	"es.typed-array.int32-array": {
		  	android: "54",
		  	bun: "0.1.1",
		  	chrome: "54",
		  	"chrome-android": "54",
		  	deno: "1.0",
		  	edge: "15",
		  	electron: "1.4",
		  	firefox: "55",
		  	"firefox-android": "55",
		  	ios: "14.0",
		  	node: "7.0",
		  	oculus: "3.0",
		  	opera: "41",
		  	"opera-android": "41",
		  	opera_mobile: "41",
		  	quest: "3.0",
		  	safari: "14.0",
		  	samsung: "6.0"
		  },
		  	"es.typed-array.uint8-array": {
		  	android: "54",
		  	bun: "0.1.1",
		  	chrome: "54",
		  	"chrome-android": "54",
		  	deno: "1.0",
		  	edge: "15",
		  	electron: "1.4",
		  	firefox: "55",
		  	"firefox-android": "55",
		  	ios: "14.0",
		  	node: "7.0",
		  	oculus: "3.0",
		  	opera: "41",
		  	"opera-android": "41",
		  	opera_mobile: "41",
		  	quest: "3.0",
		  	safari: "14.0",
		  	samsung: "6.0"
		  },
		  	"es.typed-array.uint8-clamped-array": {
		  	android: "54",
		  	bun: "0.1.1",
		  	chrome: "54",
		  	"chrome-android": "54",
		  	deno: "1.0",
		  	edge: "15",
		  	electron: "1.4",
		  	firefox: "55",
		  	"firefox-android": "55",
		  	ios: "14.0",
		  	node: "7.0",
		  	oculus: "3.0",
		  	opera: "41",
		  	"opera-android": "41",
		  	opera_mobile: "41",
		  	quest: "3.0",
		  	safari: "14.0",
		  	samsung: "6.0"
		  },
		  	"es.typed-array.uint16-array": {
		  	android: "54",
		  	bun: "0.1.1",
		  	chrome: "54",
		  	"chrome-android": "54",
		  	deno: "1.0",
		  	edge: "15",
		  	electron: "1.4",
		  	firefox: "55",
		  	"firefox-android": "55",
		  	ios: "14.0",
		  	node: "7.0",
		  	oculus: "3.0",
		  	opera: "41",
		  	"opera-android": "41",
		  	opera_mobile: "41",
		  	quest: "3.0",
		  	safari: "14.0",
		  	samsung: "6.0"
		  },
		  	"es.typed-array.uint32-array": {
		  	android: "54",
		  	bun: "0.1.1",
		  	chrome: "54",
		  	"chrome-android": "54",
		  	deno: "1.0",
		  	edge: "15",
		  	electron: "1.4",
		  	firefox: "55",
		  	"firefox-android": "55",
		  	ios: "14.0",
		  	node: "7.0",
		  	oculus: "3.0",
		  	opera: "41",
		  	"opera-android": "41",
		  	opera_mobile: "41",
		  	quest: "3.0",
		  	safari: "14.0",
		  	samsung: "6.0"
		  },
		  	"es.typed-array.at": {
		  	android: "92",
		  	bun: "0.1.1",
		  	chrome: "92",
		  	"chrome-android": "92",
		  	deno: "1.12",
		  	edge: "92",
		  	electron: "14.0",
		  	firefox: "90",
		  	"firefox-android": "90",
		  	ios: "15.4",
		  	node: "16.6",
		  	oculus: "17.0",
		  	opera: "78",
		  	"opera-android": "65",
		  	opera_mobile: "65",
		  	quest: "17.0",
		  	"react-native": "0.71",
		  	safari: "15.4",
		  	samsung: "16.0"
		  },
		  	"es.typed-array.copy-within": {
		  	android: "45",
		  	bun: "0.1.1",
		  	chrome: "45",
		  	"chrome-android": "45",
		  	deno: "1.0",
		  	edge: "13",
		  	electron: "0.31",
		  	firefox: "34",
		  	"firefox-android": "34",
		  	hermes: "0.1",
		  	ios: "10.0",
		  	node: "4.0",
		  	oculus: "3.0",
		  	opera: "32",
		  	"opera-android": "32",
		  	opera_mobile: "32",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	safari: "10.0",
		  	samsung: "5.0"
		  },
		  	"es.typed-array.every": {
		  	android: "45",
		  	bun: "0.1.1",
		  	chrome: "45",
		  	"chrome-android": "45",
		  	deno: "1.0",
		  	edge: "13",
		  	electron: "0.31",
		  	firefox: "37",
		  	"firefox-android": "37",
		  	hermes: "0.1",
		  	ios: "10.0",
		  	node: "4.0",
		  	oculus: "3.0",
		  	opera: "32",
		  	"opera-android": "32",
		  	opera_mobile: "32",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	safari: "10.0",
		  	samsung: "5.0"
		  },
		  	"es.typed-array.fill": {
		  	android: "58",
		  	bun: "0.1.1",
		  	chrome: "58",
		  	"chrome-android": "58",
		  	deno: "1.0",
		  	edge: "79",
		  	electron: "1.7",
		  	firefox: "55",
		  	"firefox-android": "55",
		  	hermes: "0.1",
		  	ios: "14.5",
		  	node: "8.0",
		  	oculus: "4.0",
		  	opera: "45",
		  	"opera-android": "43",
		  	opera_mobile: "43",
		  	quest: "4.0",
		  	"react-native": "0.69",
		  	safari: "14.1",
		  	samsung: "7.0"
		  },
		  	"es.typed-array.filter": {
		  	android: "45",
		  	bun: "0.1.1",
		  	chrome: "45",
		  	"chrome-android": "45",
		  	deno: "1.0",
		  	edge: "13",
		  	electron: "0.31",
		  	firefox: "38",
		  	"firefox-android": "38",
		  	hermes: "0.1",
		  	ios: "10.0",
		  	node: "4.0",
		  	oculus: "3.0",
		  	opera: "32",
		  	"opera-android": "32",
		  	opera_mobile: "32",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	safari: "10.0",
		  	samsung: "5.0"
		  },
		  	"es.typed-array.find": {
		  	android: "45",
		  	bun: "0.1.1",
		  	chrome: "45",
		  	"chrome-android": "45",
		  	deno: "1.0",
		  	edge: "13",
		  	electron: "0.31",
		  	firefox: "37",
		  	"firefox-android": "37",
		  	hermes: "0.1",
		  	ios: "10.0",
		  	node: "4.0",
		  	oculus: "3.0",
		  	opera: "32",
		  	"opera-android": "32",
		  	opera_mobile: "32",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	safari: "10.0",
		  	samsung: "5.0"
		  },
		  	"es.typed-array.find-index": {
		  	android: "45",
		  	bun: "0.1.1",
		  	chrome: "45",
		  	"chrome-android": "45",
		  	deno: "1.0",
		  	edge: "13",
		  	electron: "0.31",
		  	firefox: "37",
		  	"firefox-android": "37",
		  	hermes: "0.1",
		  	ios: "10.0",
		  	node: "4.0",
		  	oculus: "3.0",
		  	opera: "32",
		  	"opera-android": "32",
		  	opera_mobile: "32",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	safari: "10.0",
		  	samsung: "5.0"
		  },
		  	"es.typed-array.find-last": {
		  	android: "97",
		  	bun: "0.1.1",
		  	chrome: "97",
		  	"chrome-android": "97",
		  	deno: "1.16",
		  	edge: "97",
		  	electron: "17.0",
		  	firefox: "104",
		  	"firefox-android": "104",
		  	hermes: "0.11",
		  	ios: "15.4",
		  	node: "18.0",
		  	oculus: "20.0",
		  	opera: "83",
		  	"opera-android": "68",
		  	opera_mobile: "68",
		  	quest: "20.0",
		  	"react-native": "0.69",
		  	safari: "15.4",
		  	samsung: "18.0"
		  },
		  	"es.typed-array.find-last-index": {
		  	android: "97",
		  	bun: "0.1.1",
		  	chrome: "97",
		  	"chrome-android": "97",
		  	deno: "1.16",
		  	edge: "97",
		  	electron: "17.0",
		  	firefox: "104",
		  	"firefox-android": "104",
		  	hermes: "0.11",
		  	ios: "15.4",
		  	node: "18.0",
		  	oculus: "20.0",
		  	opera: "83",
		  	"opera-android": "68",
		  	opera_mobile: "68",
		  	quest: "20.0",
		  	"react-native": "0.69",
		  	safari: "15.4",
		  	samsung: "18.0"
		  },
		  	"es.typed-array.for-each": {
		  	android: "45",
		  	bun: "0.1.1",
		  	chrome: "45",
		  	"chrome-android": "45",
		  	deno: "1.0",
		  	edge: "13",
		  	electron: "0.31",
		  	firefox: "38",
		  	"firefox-android": "38",
		  	hermes: "0.1",
		  	ios: "10.0",
		  	node: "4.0",
		  	oculus: "3.0",
		  	opera: "32",
		  	"opera-android": "32",
		  	opera_mobile: "32",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	safari: "10.0",
		  	samsung: "5.0"
		  },
		  	"es.typed-array.from": {
		  	android: "54",
		  	bun: "0.1.1",
		  	chrome: "54",
		  	"chrome-android": "54",
		  	deno: "1.0",
		  	edge: "15",
		  	electron: "1.4",
		  	firefox: "55",
		  	"firefox-android": "55",
		  	ios: "14.0",
		  	node: "7.0",
		  	oculus: "3.0",
		  	opera: "41",
		  	"opera-android": "41",
		  	opera_mobile: "41",
		  	quest: "3.0",
		  	safari: "14.0",
		  	samsung: "6.0"
		  },
		  	"es.typed-array.includes": {
		  	android: "49",
		  	bun: "0.1.1",
		  	chrome: "49",
		  	"chrome-android": "49",
		  	deno: "1.0",
		  	edge: "14",
		  	electron: "0.37",
		  	firefox: "43",
		  	"firefox-android": "43",
		  	hermes: "0.1",
		  	ios: "10.0",
		  	node: "6.0",
		  	oculus: "3.0",
		  	opera: "36",
		  	"opera-android": "36",
		  	opera_mobile: "36",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	safari: "10.0",
		  	samsung: "5.0"
		  },
		  	"es.typed-array.index-of": {
		  	android: "45",
		  	bun: "0.1.1",
		  	chrome: "45",
		  	"chrome-android": "45",
		  	deno: "1.0",
		  	edge: "13",
		  	electron: "0.31",
		  	firefox: "37",
		  	"firefox-android": "37",
		  	hermes: "0.1",
		  	ios: "10.0",
		  	node: "4.0",
		  	oculus: "3.0",
		  	opera: "32",
		  	"opera-android": "32",
		  	opera_mobile: "32",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	safari: "10.0",
		  	samsung: "5.0"
		  },
		  	"es.typed-array.iterator": {
		  	android: "51",
		  	bun: "0.1.1",
		  	chrome: "51",
		  	"chrome-android": "51",
		  	deno: "1.0",
		  	edge: "13",
		  	electron: "1.2",
		  	firefox: "37",
		  	"firefox-android": "37",
		  	hermes: "0.1",
		  	ios: "10.0",
		  	node: "6.5",
		  	oculus: "3.0",
		  	opera: "38",
		  	"opera-android": "38",
		  	opera_mobile: "38",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	safari: "10.0",
		  	samsung: "5.0"
		  },
		  	"es.typed-array.join": {
		  	android: "45",
		  	bun: "0.1.1",
		  	chrome: "45",
		  	"chrome-android": "45",
		  	deno: "1.0",
		  	edge: "13",
		  	electron: "0.31",
		  	firefox: "37",
		  	"firefox-android": "37",
		  	hermes: "0.1",
		  	ios: "10.0",
		  	node: "4.0",
		  	oculus: "3.0",
		  	opera: "32",
		  	"opera-android": "32",
		  	opera_mobile: "32",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	safari: "10.0",
		  	samsung: "5.0"
		  },
		  	"es.typed-array.last-index-of": {
		  	android: "45",
		  	bun: "0.1.1",
		  	chrome: "45",
		  	"chrome-android": "45",
		  	deno: "1.0",
		  	edge: "13",
		  	electron: "0.31",
		  	firefox: "37",
		  	"firefox-android": "37",
		  	hermes: "0.1",
		  	ios: "10.0",
		  	node: "4.0",
		  	oculus: "3.0",
		  	opera: "32",
		  	"opera-android": "32",
		  	opera_mobile: "32",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	safari: "10.0",
		  	samsung: "5.0"
		  },
		  	"es.typed-array.map": {
		  	android: "45",
		  	bun: "0.1.1",
		  	chrome: "45",
		  	"chrome-android": "45",
		  	deno: "1.0",
		  	edge: "13",
		  	electron: "0.31",
		  	firefox: "38",
		  	"firefox-android": "38",
		  	hermes: "0.1",
		  	ios: "10.0",
		  	node: "4.0",
		  	oculus: "3.0",
		  	opera: "32",
		  	"opera-android": "32",
		  	opera_mobile: "32",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	safari: "10.0",
		  	samsung: "5.0"
		  },
		  	"es.typed-array.of": {
		  	android: "54",
		  	bun: "0.1.1",
		  	chrome: "54",
		  	"chrome-android": "54",
		  	deno: "1.0",
		  	edge: "15",
		  	electron: "1.4",
		  	firefox: "55",
		  	"firefox-android": "55",
		  	ios: "14.0",
		  	node: "7.0",
		  	oculus: "3.0",
		  	opera: "41",
		  	"opera-android": "41",
		  	opera_mobile: "41",
		  	quest: "3.0",
		  	safari: "14.0",
		  	samsung: "6.0"
		  },
		  	"es.typed-array.reduce": {
		  	android: "45",
		  	bun: "0.1.1",
		  	chrome: "45",
		  	"chrome-android": "45",
		  	deno: "1.0",
		  	edge: "13",
		  	electron: "0.31",
		  	firefox: "37",
		  	"firefox-android": "37",
		  	hermes: "0.1",
		  	ios: "10.0",
		  	node: "4.0",
		  	oculus: "3.0",
		  	opera: "32",
		  	"opera-android": "32",
		  	opera_mobile: "32",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	safari: "10.0",
		  	samsung: "5.0"
		  },
		  	"es.typed-array.reduce-right": {
		  	android: "45",
		  	bun: "0.1.1",
		  	chrome: "45",
		  	"chrome-android": "45",
		  	deno: "1.0",
		  	edge: "13",
		  	electron: "0.31",
		  	firefox: "37",
		  	"firefox-android": "37",
		  	hermes: "0.1",
		  	ios: "10.0",
		  	node: "4.0",
		  	oculus: "3.0",
		  	opera: "32",
		  	"opera-android": "32",
		  	opera_mobile: "32",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	safari: "10.0",
		  	samsung: "5.0"
		  },
		  	"es.typed-array.reverse": {
		  	android: "45",
		  	bun: "0.1.1",
		  	chrome: "45",
		  	"chrome-android": "45",
		  	deno: "1.0",
		  	edge: "13",
		  	electron: "0.31",
		  	firefox: "37",
		  	"firefox-android": "37",
		  	hermes: "0.1",
		  	ios: "10.0",
		  	node: "4.0",
		  	oculus: "3.0",
		  	opera: "32",
		  	"opera-android": "32",
		  	opera_mobile: "32",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	safari: "10.0",
		  	samsung: "5.0"
		  },
		  	"es.typed-array.set": {
		  	android: "95",
		  	bun: "0.1.1",
		  	chrome: "95",
		  	"chrome-android": "95",
		  	deno: "1.15",
		  	edge: "95",
		  	electron: "16.0",
		  	firefox: "54",
		  	"firefox-android": "54",
		  	hermes: "0.1",
		  	ios: "14.5",
		  	node: "17.0",
		  	oculus: "18.0",
		  	opera: "81",
		  	"opera-android": "67",
		  	opera_mobile: "67",
		  	quest: "18.0",
		  	"react-native": "0.69",
		  	safari: "14.1",
		  	samsung: "17.0"
		  },
		  	"es.typed-array.slice": {
		  	android: "45",
		  	bun: "0.1.1",
		  	chrome: "45",
		  	"chrome-android": "45",
		  	deno: "1.0",
		  	edge: "13",
		  	electron: "0.31",
		  	firefox: "38",
		  	"firefox-android": "38",
		  	hermes: "0.1",
		  	ios: "10.0",
		  	node: "4.0",
		  	oculus: "3.0",
		  	opera: "32",
		  	"opera-android": "32",
		  	opera_mobile: "32",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	safari: "10.0",
		  	samsung: "5.0"
		  },
		  	"es.typed-array.some": {
		  	android: "45",
		  	bun: "0.1.1",
		  	chrome: "45",
		  	"chrome-android": "45",
		  	deno: "1.0",
		  	edge: "13",
		  	electron: "0.31",
		  	firefox: "37",
		  	"firefox-android": "37",
		  	hermes: "0.1",
		  	ios: "10.0",
		  	node: "4.0",
		  	oculus: "3.0",
		  	opera: "32",
		  	"opera-android": "32",
		  	opera_mobile: "32",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	safari: "10.0",
		  	samsung: "5.0"
		  },
		  	"es.typed-array.sort": {
		  	android: "74",
		  	bun: "0.1.1",
		  	chrome: "74",
		  	"chrome-android": "74",
		  	deno: "1.0",
		  	edge: "79",
		  	electron: "6.0",
		  	firefox: "67",
		  	"firefox-android": "67",
		  	hermes: "0.10",
		  	ios: "14.5",
		  	node: "12.0",
		  	oculus: "6.0",
		  	opera: "61",
		  	"opera-android": "53",
		  	opera_mobile: "53",
		  	quest: "6.0",
		  	"react-native": "0.69",
		  	safari: "14.1",
		  	samsung: "11.0"
		  },
		  	"es.typed-array.subarray": {
		  	android: "4.4",
		  	bun: "0.1.1",
		  	chrome: "26",
		  	"chrome-android": "26",
		  	deno: "1.0",
		  	edge: "13",
		  	electron: "0.20",
		  	firefox: "15",
		  	"firefox-android": "15",
		  	hermes: "0.1",
		  	ios: "8.0",
		  	node: "0.11.0",
		  	oculus: "3.0",
		  	opera: "15",
		  	"opera-android": "15",
		  	opera_mobile: "15",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	safari: "7.1",
		  	samsung: "1.5"
		  },
		  	"es.typed-array.to-locale-string": {
		  	android: "45",
		  	bun: "0.1.1",
		  	chrome: "45",
		  	"chrome-android": "45",
		  	deno: "1.0",
		  	edge: "79",
		  	electron: "0.31",
		  	firefox: "51",
		  	"firefox-android": "51",
		  	hermes: "0.1",
		  	ios: "10.0",
		  	node: "4.0",
		  	oculus: "3.0",
		  	opera: "32",
		  	"opera-android": "32",
		  	opera_mobile: "32",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	safari: "10.0",
		  	samsung: "5.0"
		  },
		  	"es.typed-array.to-reversed": {
		  	android: "110",
		  	bun: "0.1.1",
		  	chrome: "110",
		  	"chrome-android": "110",
		  	deno: "1.27",
		  	edge: "110",
		  	electron: "23.0",
		  	firefox: "115",
		  	"firefox-android": "115",
		  	ios: "16.0",
		  	node: "20.0",
		  	oculus: "26.0",
		  	opera: "96",
		  	"opera-android": "74",
		  	opera_mobile: "74",
		  	quest: "26.0",
		  	safari: "16.0",
		  	samsung: "21.0"
		  },
		  	"es.typed-array.to-sorted": {
		  	android: "110",
		  	bun: "0.1.1",
		  	chrome: "110",
		  	"chrome-android": "110",
		  	deno: "1.27",
		  	edge: "110",
		  	electron: "23.0",
		  	firefox: "115",
		  	"firefox-android": "115",
		  	ios: "16.0",
		  	node: "20.0",
		  	oculus: "26.0",
		  	opera: "96",
		  	"opera-android": "74",
		  	opera_mobile: "74",
		  	quest: "26.0",
		  	safari: "16.0",
		  	samsung: "21.0"
		  },
		  	"es.typed-array.to-string": {
		  	android: "51",
		  	bun: "0.1.1",
		  	chrome: "51",
		  	"chrome-android": "51",
		  	deno: "1.0",
		  	edge: "13",
		  	electron: "1.2",
		  	firefox: "51",
		  	"firefox-android": "51",
		  	hermes: "0.1",
		  	ios: "10.0",
		  	node: "6.5",
		  	oculus: "3.0",
		  	opera: "38",
		  	"opera-android": "38",
		  	opera_mobile: "38",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	safari: "10.0",
		  	samsung: "5.0"
		  },
		  	"es.typed-array.with": {
		  	android: "110",
		  	bun: "0.1.9",
		  	chrome: "110",
		  	"chrome-android": "110",
		  	deno: "1.27",
		  	edge: "110",
		  	electron: "23.0",
		  	firefox: "115",
		  	"firefox-android": "115",
		  	ios: "16.4",
		  	node: "20.0",
		  	oculus: "26.0",
		  	opera: "96",
		  	"opera-android": "74",
		  	opera_mobile: "74",
		  	quest: "26.0",
		  	safari: "16.4",
		  	samsung: "21.0"
		  },
		  	"es.unescape": {
		  	android: "3.0",
		  	bun: "0.1.1",
		  	chrome: "1",
		  	"chrome-android": "18",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.20",
		  	firefox: "1",
		  	"firefox-android": "4",
		  	hermes: "0.1",
		  	ie: "3",
		  	ios: "1.0",
		  	node: "0.0.3",
		  	oculus: "3.0",
		  	opera: "3",
		  	"opera-android": "3",
		  	opera_mobile: "3",
		  	phantom: "1.9",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "1",
		  	samsung: "1.0"
		  },
		  	"es.weak-map": {
		  	android: "51",
		  	bun: "0.1.1",
		  	chrome: "51",
		  	"chrome-android": "51",
		  	deno: "1.0",
		  	edge: "79",
		  	electron: "1.2",
		  	firefox: "53",
		  	"firefox-android": "53",
		  	ios: "10.0",
		  	node: "6.5",
		  	oculus: "3.0",
		  	opera: "38",
		  	"opera-android": "38",
		  	opera_mobile: "38",
		  	quest: "3.0",
		  	"react-native": "0.73",
		  	rhino: "1.7.13",
		  	safari: "10.0",
		  	samsung: "5.0"
		  },
		  	"es.weak-set": {
		  	android: "51",
		  	bun: "0.1.1",
		  	chrome: "51",
		  	"chrome-android": "51",
		  	deno: "1.0",
		  	edge: "15",
		  	electron: "1.2",
		  	firefox: "53",
		  	"firefox-android": "53",
		  	ios: "10.0",
		  	node: "6.5",
		  	oculus: "3.0",
		  	opera: "38",
		  	"opera-android": "38",
		  	opera_mobile: "38",
		  	quest: "3.0",
		  	"react-native": "0.73",
		  	rhino: "1.7.13",
		  	safari: "10.0",
		  	samsung: "5.0"
		  },
		  	"esnext.aggregate-error": {
		  	android: "85",
		  	bun: "0.1.1",
		  	chrome: "85",
		  	"chrome-android": "85",
		  	deno: "1.2",
		  	edge: "85",
		  	electron: "10.0",
		  	firefox: "79",
		  	"firefox-android": "79",
		  	ios: "14.0",
		  	node: "15.0",
		  	oculus: "12.0",
		  	opera: "71",
		  	"opera-android": "60",
		  	opera_mobile: "60",
		  	quest: "12.0",
		  	"react-native": "0.72",
		  	safari: "14.0",
		  	samsung: "14.0"
		  },
		  	"esnext.suppressed-error.constructor": {
		  },
		  	"esnext.array.from-async": {
		  	android: "121",
		  	bun: "0.3.0",
		  	chrome: "121",
		  	"chrome-android": "121",
		  	deno: "1.38",
		  	edge: "121",
		  	electron: "29.0",
		  	firefox: "115",
		  	"firefox-android": "115",
		  	ios: "16.4",
		  	oculus: "32.0",
		  	opera: "107",
		  	"opera-android": "81",
		  	opera_mobile: "81",
		  	quest: "32.0",
		  	safari: "16.4",
		  	samsung: "25.0"
		  },
		  	"esnext.array.at": {
		  	android: "92",
		  	bun: "0.1.1",
		  	chrome: "92",
		  	"chrome-android": "92",
		  	deno: "1.12",
		  	edge: "92",
		  	electron: "14.0",
		  	firefox: "90",
		  	"firefox-android": "90",
		  	ios: "15.4",
		  	node: "16.6",
		  	oculus: "17.0",
		  	opera: "78",
		  	"opera-android": "65",
		  	opera_mobile: "65",
		  	quest: "17.0",
		  	"react-native": "0.71",
		  	safari: "15.4",
		  	samsung: "16.0"
		  },
		  	"esnext.array.filter-out": {
		  },
		  	"esnext.array.filter-reject": {
		  },
		  	"esnext.array.find-last": {
		  	android: "97",
		  	bun: "0.1.1",
		  	chrome: "97",
		  	"chrome-android": "97",
		  	deno: "1.16",
		  	edge: "97",
		  	electron: "17.0",
		  	firefox: "104",
		  	"firefox-android": "104",
		  	hermes: "0.11",
		  	ios: "15.4",
		  	node: "18.0",
		  	oculus: "20.0",
		  	opera: "83",
		  	"opera-android": "68",
		  	opera_mobile: "68",
		  	quest: "20.0",
		  	"react-native": "0.69",
		  	safari: "15.4",
		  	samsung: "18.0"
		  },
		  	"esnext.array.find-last-index": {
		  	android: "97",
		  	bun: "0.1.1",
		  	chrome: "97",
		  	"chrome-android": "97",
		  	deno: "1.16",
		  	edge: "97",
		  	electron: "17.0",
		  	firefox: "104",
		  	"firefox-android": "104",
		  	hermes: "0.11",
		  	ios: "15.4",
		  	node: "18.0",
		  	oculus: "20.0",
		  	opera: "83",
		  	"opera-android": "68",
		  	opera_mobile: "68",
		  	quest: "20.0",
		  	"react-native": "0.69",
		  	safari: "15.4",
		  	samsung: "18.0"
		  },
		  	"esnext.array.group": {
		  },
		  	"esnext.array.group-by": {
		  },
		  	"esnext.array.group-by-to-map": {
		  },
		  	"esnext.array.group-to-map": {
		  },
		  	"esnext.array.is-template-object": {
		  },
		  	"esnext.array.last-index": {
		  },
		  	"esnext.array.last-item": {
		  },
		  	"esnext.array.to-reversed": {
		  	android: "110",
		  	bun: "0.1.1",
		  	chrome: "110",
		  	"chrome-android": "110",
		  	deno: "1.27",
		  	edge: "110",
		  	electron: "23.0",
		  	firefox: "115",
		  	"firefox-android": "115",
		  	ios: "16.0",
		  	node: "20.0",
		  	oculus: "26.0",
		  	opera: "96",
		  	"opera-android": "74",
		  	opera_mobile: "74",
		  	quest: "26.0",
		  	"react-native": "0.74",
		  	safari: "16.0",
		  	samsung: "21.0"
		  },
		  	"esnext.array.to-sorted": {
		  	android: "110",
		  	bun: "0.1.1",
		  	chrome: "110",
		  	"chrome-android": "110",
		  	deno: "1.27",
		  	edge: "110",
		  	electron: "23.0",
		  	firefox: "115",
		  	"firefox-android": "115",
		  	ios: "16.0",
		  	node: "20.0",
		  	oculus: "26.0",
		  	opera: "96",
		  	"opera-android": "74",
		  	opera_mobile: "74",
		  	quest: "26.0",
		  	safari: "16.0",
		  	samsung: "21.0"
		  },
		  	"esnext.array.to-spliced": {
		  	android: "110",
		  	bun: "0.1.1",
		  	chrome: "110",
		  	"chrome-android": "110",
		  	deno: "1.27",
		  	edge: "110",
		  	electron: "23.0",
		  	firefox: "115",
		  	"firefox-android": "115",
		  	ios: "16.0",
		  	node: "20.0",
		  	oculus: "26.0",
		  	opera: "96",
		  	"opera-android": "74",
		  	opera_mobile: "74",
		  	quest: "26.0",
		  	"react-native": "0.74",
		  	safari: "16.0",
		  	samsung: "21.0"
		  },
		  	"esnext.array.unique-by": {
		  },
		  	"esnext.array.with": {
		  	android: "110",
		  	bun: "0.1.1",
		  	chrome: "110",
		  	"chrome-android": "110",
		  	deno: "1.27",
		  	edge: "110",
		  	electron: "23.0",
		  	firefox: "115",
		  	"firefox-android": "115",
		  	ios: "16.0",
		  	node: "20.0",
		  	oculus: "26.0",
		  	opera: "96",
		  	"opera-android": "74",
		  	opera_mobile: "74",
		  	quest: "26.0",
		  	"react-native": "0.74",
		  	safari: "16.0",
		  	samsung: "21.0"
		  },
		  	"esnext.array-buffer.detached": {
		  	android: "114",
		  	bun: "1.0.19",
		  	chrome: "114",
		  	"chrome-android": "114",
		  	deno: "1.33",
		  	edge: "114",
		  	electron: "25.0",
		  	firefox: "122",
		  	"firefox-android": "122",
		  	ios: "17.4",
		  	node: "21.0",
		  	oculus: "28.0",
		  	opera: "100",
		  	"opera-android": "76",
		  	opera_mobile: "76",
		  	quest: "28.0",
		  	safari: "17.4",
		  	samsung: "23.0"
		  },
		  	"esnext.array-buffer.transfer": {
		  	android: "114",
		  	bun: "1.0.19",
		  	chrome: "114",
		  	"chrome-android": "114",
		  	deno: "1.33",
		  	edge: "114",
		  	electron: "25.0",
		  	firefox: "122",
		  	"firefox-android": "122",
		  	ios: "17.4",
		  	node: "21.0",
		  	oculus: "28.0",
		  	opera: "100",
		  	"opera-android": "76",
		  	opera_mobile: "76",
		  	quest: "28.0",
		  	safari: "17.4",
		  	samsung: "23.0"
		  },
		  	"esnext.array-buffer.transfer-to-fixed-length": {
		  	android: "114",
		  	bun: "1.0.19",
		  	chrome: "114",
		  	"chrome-android": "114",
		  	deno: "1.33",
		  	edge: "114",
		  	electron: "25.0",
		  	firefox: "122",
		  	"firefox-android": "122",
		  	ios: "17.4",
		  	node: "21.0",
		  	oculus: "28.0",
		  	opera: "100",
		  	"opera-android": "76",
		  	opera_mobile: "76",
		  	quest: "28.0",
		  	safari: "17.4",
		  	samsung: "23.0"
		  },
		  	"esnext.async-disposable-stack.constructor": {
		  },
		  	"esnext.async-iterator.constructor": {
		  },
		  	"esnext.async-iterator.as-indexed-pairs": {
		  },
		  	"esnext.async-iterator.async-dispose": {
		  },
		  	"esnext.async-iterator.drop": {
		  },
		  	"esnext.async-iterator.every": {
		  },
		  	"esnext.async-iterator.filter": {
		  },
		  	"esnext.async-iterator.find": {
		  },
		  	"esnext.async-iterator.flat-map": {
		  },
		  	"esnext.async-iterator.for-each": {
		  },
		  	"esnext.async-iterator.from": {
		  },
		  	"esnext.async-iterator.indexed": {
		  },
		  	"esnext.async-iterator.map": {
		  },
		  	"esnext.async-iterator.reduce": {
		  },
		  	"esnext.async-iterator.some": {
		  },
		  	"esnext.async-iterator.take": {
		  },
		  	"esnext.async-iterator.to-array": {
		  },
		  	"esnext.bigint.range": {
		  },
		  	"esnext.composite-key": {
		  },
		  	"esnext.composite-symbol": {
		  },
		  	"esnext.data-view.get-float16": {
		  },
		  	"esnext.data-view.get-uint8-clamped": {
		  },
		  	"esnext.data-view.set-float16": {
		  },
		  	"esnext.data-view.set-uint8-clamped": {
		  },
		  	"esnext.disposable-stack.constructor": {
		  },
		  	"esnext.function.demethodize": {
		  },
		  	"esnext.function.is-callable": {
		  },
		  	"esnext.function.is-constructor": {
		  },
		  	"esnext.function.metadata": {
		  },
		  	"esnext.function.un-this": {
		  },
		  	"esnext.global-this": {
		  	android: "71",
		  	bun: "0.1.1",
		  	chrome: "71",
		  	"chrome-android": "71",
		  	deno: "1.0",
		  	edge: "79",
		  	electron: "5.0",
		  	firefox: "65",
		  	"firefox-android": "65",
		  	hermes: "0.2",
		  	ios: "12.2",
		  	node: "12.0",
		  	oculus: "6.0",
		  	opera: "58",
		  	"opera-android": "50",
		  	opera_mobile: "50",
		  	quest: "6.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.14",
		  	safari: "12.1",
		  	samsung: "10.0"
		  },
		  	"esnext.iterator.constructor": {
		  	android: "122",
		  	chrome: "122",
		  	"chrome-android": "122",
		  	deno: "1.37",
		  	edge: "122",
		  	electron: "29.0",
		  	oculus: "32.0",
		  	opera: "108",
		  	"opera-android": "81",
		  	opera_mobile: "81",
		  	quest: "32.0"
		  },
		  	"esnext.iterator.as-indexed-pairs": {
		  },
		  	"esnext.iterator.dispose": {
		  },
		  	"esnext.iterator.drop": {
		  	android: "122",
		  	chrome: "122",
		  	"chrome-android": "122",
		  	deno: "1.37",
		  	edge: "122",
		  	electron: "29.0",
		  	oculus: "32.0",
		  	opera: "108",
		  	"opera-android": "81",
		  	opera_mobile: "81",
		  	quest: "32.0"
		  },
		  	"esnext.iterator.every": {
		  	android: "122",
		  	chrome: "122",
		  	"chrome-android": "122",
		  	deno: "1.37",
		  	edge: "122",
		  	electron: "29.0",
		  	oculus: "32.0",
		  	opera: "108",
		  	"opera-android": "81",
		  	opera_mobile: "81",
		  	quest: "32.0"
		  },
		  	"esnext.iterator.filter": {
		  	android: "122",
		  	chrome: "122",
		  	"chrome-android": "122",
		  	deno: "1.37",
		  	edge: "122",
		  	electron: "29.0",
		  	oculus: "32.0",
		  	opera: "108",
		  	"opera-android": "81",
		  	opera_mobile: "81",
		  	quest: "32.0"
		  },
		  	"esnext.iterator.find": {
		  	android: "122",
		  	chrome: "122",
		  	"chrome-android": "122",
		  	deno: "1.37",
		  	edge: "122",
		  	electron: "29.0",
		  	oculus: "32.0",
		  	opera: "108",
		  	"opera-android": "81",
		  	opera_mobile: "81",
		  	quest: "32.0"
		  },
		  	"esnext.iterator.flat-map": {
		  	android: "122",
		  	chrome: "122",
		  	"chrome-android": "122",
		  	deno: "1.37",
		  	edge: "122",
		  	electron: "29.0",
		  	oculus: "32.0",
		  	opera: "108",
		  	"opera-android": "81",
		  	opera_mobile: "81",
		  	quest: "32.0"
		  },
		  	"esnext.iterator.for-each": {
		  	android: "122",
		  	chrome: "122",
		  	"chrome-android": "122",
		  	deno: "1.37",
		  	edge: "122",
		  	electron: "29.0",
		  	oculus: "32.0",
		  	opera: "108",
		  	"opera-android": "81",
		  	opera_mobile: "81",
		  	quest: "32.0"
		  },
		  	"esnext.iterator.from": {
		  	android: "122",
		  	chrome: "122",
		  	"chrome-android": "122",
		  	deno: "1.37",
		  	edge: "122",
		  	electron: "29.0",
		  	oculus: "32.0",
		  	opera: "108",
		  	"opera-android": "81",
		  	opera_mobile: "81",
		  	quest: "32.0"
		  },
		  	"esnext.iterator.indexed": {
		  },
		  	"esnext.iterator.map": {
		  	android: "122",
		  	chrome: "122",
		  	"chrome-android": "122",
		  	deno: "1.37",
		  	edge: "122",
		  	electron: "29.0",
		  	oculus: "32.0",
		  	opera: "108",
		  	"opera-android": "81",
		  	opera_mobile: "81",
		  	quest: "32.0"
		  },
		  	"esnext.iterator.range": {
		  },
		  	"esnext.iterator.reduce": {
		  	android: "122",
		  	chrome: "122",
		  	"chrome-android": "122",
		  	deno: "1.37",
		  	edge: "122",
		  	electron: "29.0",
		  	oculus: "32.0",
		  	opera: "108",
		  	"opera-android": "81",
		  	opera_mobile: "81",
		  	quest: "32.0"
		  },
		  	"esnext.iterator.some": {
		  	android: "122",
		  	chrome: "122",
		  	"chrome-android": "122",
		  	deno: "1.37",
		  	edge: "122",
		  	electron: "29.0",
		  	oculus: "32.0",
		  	opera: "108",
		  	"opera-android": "81",
		  	opera_mobile: "81",
		  	quest: "32.0"
		  },
		  	"esnext.iterator.take": {
		  	android: "122",
		  	chrome: "122",
		  	"chrome-android": "122",
		  	deno: "1.37",
		  	edge: "122",
		  	electron: "29.0",
		  	oculus: "32.0",
		  	opera: "108",
		  	"opera-android": "81",
		  	opera_mobile: "81",
		  	quest: "32.0"
		  },
		  	"esnext.iterator.to-array": {
		  	android: "122",
		  	chrome: "122",
		  	"chrome-android": "122",
		  	deno: "1.37",
		  	edge: "122",
		  	electron: "29.0",
		  	oculus: "32.0",
		  	opera: "108",
		  	"opera-android": "81",
		  	opera_mobile: "81",
		  	quest: "32.0"
		  },
		  	"esnext.iterator.to-async": {
		  },
		  	"esnext.json.is-raw-json": {
		  	android: "114",
		  	chrome: "114",
		  	"chrome-android": "114",
		  	deno: "1.33",
		  	edge: "114",
		  	electron: "25.0",
		  	node: "21.0",
		  	oculus: "28.0",
		  	opera: "100",
		  	"opera-android": "76",
		  	opera_mobile: "76",
		  	quest: "28.0",
		  	samsung: "23.0"
		  },
		  	"esnext.json.parse": {
		  	android: "114",
		  	chrome: "114",
		  	"chrome-android": "114",
		  	deno: "1.33",
		  	edge: "114",
		  	electron: "25.0",
		  	node: "21.0",
		  	oculus: "28.0",
		  	opera: "100",
		  	"opera-android": "76",
		  	opera_mobile: "76",
		  	quest: "28.0",
		  	samsung: "23.0"
		  },
		  	"esnext.json.raw-json": {
		  	android: "114",
		  	chrome: "114",
		  	"chrome-android": "114",
		  	deno: "1.33",
		  	edge: "114",
		  	electron: "25.0",
		  	node: "21.0",
		  	oculus: "28.0",
		  	opera: "100",
		  	"opera-android": "76",
		  	opera_mobile: "76",
		  	quest: "28.0",
		  	samsung: "23.0"
		  },
		  	"esnext.map.delete-all": {
		  },
		  	"esnext.map.emplace": {
		  },
		  	"esnext.map.every": {
		  },
		  	"esnext.map.filter": {
		  },
		  	"esnext.map.find": {
		  },
		  	"esnext.map.find-key": {
		  },
		  	"esnext.map.from": {
		  },
		  	"esnext.map.group-by": {
		  	android: "117",
		  	bun: "1.0.19",
		  	chrome: "117",
		  	"chrome-android": "117",
		  	deno: "1.37",
		  	edge: "117",
		  	electron: "27.0",
		  	firefox: "119",
		  	"firefox-android": "119",
		  	ios: "17.4",
		  	node: "21.0",
		  	oculus: "30.0",
		  	opera: "103",
		  	"opera-android": "78",
		  	opera_mobile: "78",
		  	quest: "30.0",
		  	safari: "17.4",
		  	samsung: "24.0"
		  },
		  	"esnext.map.includes": {
		  },
		  	"esnext.map.key-by": {
		  },
		  	"esnext.map.key-of": {
		  },
		  	"esnext.map.map-keys": {
		  },
		  	"esnext.map.map-values": {
		  },
		  	"esnext.map.merge": {
		  },
		  	"esnext.map.of": {
		  },
		  	"esnext.map.reduce": {
		  },
		  	"esnext.map.some": {
		  },
		  	"esnext.map.update": {
		  },
		  	"esnext.map.update-or-insert": {
		  },
		  	"esnext.map.upsert": {
		  },
		  	"esnext.math.clamp": {
		  },
		  	"esnext.math.deg-per-rad": {
		  },
		  	"esnext.math.degrees": {
		  },
		  	"esnext.math.fscale": {
		  },
		  	"esnext.math.f16round": {
		  },
		  	"esnext.math.iaddh": {
		  },
		  	"esnext.math.imulh": {
		  },
		  	"esnext.math.isubh": {
		  },
		  	"esnext.math.rad-per-deg": {
		  },
		  	"esnext.math.radians": {
		  },
		  	"esnext.math.scale": {
		  },
		  	"esnext.math.seeded-prng": {
		  },
		  	"esnext.math.signbit": {
		  },
		  	"esnext.math.umulh": {
		  },
		  	"esnext.number.from-string": {
		  },
		  	"esnext.number.range": {
		  },
		  	"esnext.object.has-own": {
		  	android: "93",
		  	bun: "0.1.1",
		  	chrome: "93",
		  	"chrome-android": "93",
		  	deno: "1.13",
		  	edge: "93",
		  	electron: "14.0",
		  	firefox: "92",
		  	"firefox-android": "92",
		  	hermes: "0.10",
		  	ios: "15.4",
		  	node: "16.9",
		  	oculus: "17.0",
		  	opera: "79",
		  	"opera-android": "66",
		  	opera_mobile: "66",
		  	quest: "17.0",
		  	"react-native": "0.69",
		  	safari: "15.4",
		  	samsung: "17.0"
		  },
		  	"esnext.object.iterate-entries": {
		  },
		  	"esnext.object.iterate-keys": {
		  },
		  	"esnext.object.iterate-values": {
		  },
		  	"esnext.object.group-by": {
		  	android: "117",
		  	bun: "1.0.19",
		  	chrome: "117",
		  	"chrome-android": "117",
		  	deno: "1.37",
		  	edge: "117",
		  	electron: "27.0",
		  	firefox: "119",
		  	"firefox-android": "119",
		  	ios: "17.4",
		  	node: "21.0",
		  	oculus: "30.0",
		  	opera: "103",
		  	"opera-android": "78",
		  	opera_mobile: "78",
		  	quest: "30.0",
		  	safari: "17.4",
		  	samsung: "24.0"
		  },
		  	"esnext.observable": {
		  },
		  	"esnext.promise.all-settled": {
		  	android: "76",
		  	bun: "0.1.1",
		  	chrome: "76",
		  	"chrome-android": "76",
		  	deno: "1.24",
		  	edge: "79",
		  	electron: "6.0",
		  	firefox: "71",
		  	"firefox-android": "71",
		  	ios: "13.0",
		  	node: "12.9",
		  	oculus: "7.0",
		  	opera: "63",
		  	"opera-android": "54",
		  	opera_mobile: "54",
		  	quest: "7.0",
		  	safari: "13",
		  	samsung: "12.0"
		  },
		  	"esnext.promise.any": {
		  	android: "85",
		  	bun: "0.1.1",
		  	chrome: "85",
		  	"chrome-android": "85",
		  	deno: "1.24",
		  	edge: "85",
		  	electron: "10.0",
		  	firefox: "79",
		  	"firefox-android": "79",
		  	ios: "14.0",
		  	node: "15.0",
		  	oculus: "12.0",
		  	opera: "71",
		  	"opera-android": "60",
		  	opera_mobile: "60",
		  	quest: "12.0",
		  	safari: "14.0",
		  	samsung: "14.0"
		  },
		  	"esnext.promise.try": {
		  },
		  	"esnext.promise.with-resolvers": {
		  	android: "119",
		  	bun: "0.7.1",
		  	chrome: "119",
		  	"chrome-android": "119",
		  	deno: "1.38",
		  	edge: "119",
		  	electron: "28.0",
		  	firefox: "121",
		  	"firefox-android": "121",
		  	ios: "17.4",
		  	oculus: "31.0",
		  	opera: "105",
		  	"opera-android": "79",
		  	opera_mobile: "79",
		  	quest: "31.0",
		  	safari: "17.4",
		  	samsung: "25.0"
		  },
		  	"esnext.reflect.define-metadata": {
		  },
		  	"esnext.reflect.delete-metadata": {
		  },
		  	"esnext.reflect.get-metadata": {
		  },
		  	"esnext.reflect.get-metadata-keys": {
		  },
		  	"esnext.reflect.get-own-metadata": {
		  },
		  	"esnext.reflect.get-own-metadata-keys": {
		  },
		  	"esnext.reflect.has-metadata": {
		  },
		  	"esnext.reflect.has-own-metadata": {
		  },
		  	"esnext.reflect.metadata": {
		  },
		  	"esnext.regexp.escape": {
		  },
		  	"esnext.set.add-all": {
		  },
		  	"esnext.set.delete-all": {
		  },
		  	"esnext.set.difference.v2": {
		  	android: "123",
		  	chrome: "123",
		  	"chrome-android": "123",
		  	deno: "1.41.3",
		  	edge: "123",
		  	electron: "30.0",
		  	opera: "109"
		  },
		  	"esnext.set.difference": {
		  },
		  	"esnext.set.every": {
		  },
		  	"esnext.set.filter": {
		  },
		  	"esnext.set.find": {
		  },
		  	"esnext.set.from": {
		  },
		  	"esnext.set.intersection.v2": {
		  	android: "123",
		  	chrome: "123",
		  	"chrome-android": "123",
		  	deno: "1.41.3",
		  	edge: "123",
		  	electron: "30.0",
		  	opera: "109"
		  },
		  	"esnext.set.intersection": {
		  },
		  	"esnext.set.is-disjoint-from.v2": {
		  	android: "123",
		  	chrome: "123",
		  	"chrome-android": "123",
		  	deno: "1.41.3",
		  	edge: "123",
		  	electron: "30.0",
		  	opera: "109"
		  },
		  	"esnext.set.is-disjoint-from": {
		  },
		  	"esnext.set.is-subset-of.v2": {
		  	android: "123",
		  	chrome: "123",
		  	"chrome-android": "123",
		  	deno: "1.41.3",
		  	edge: "123",
		  	electron: "30.0",
		  	opera: "109"
		  },
		  	"esnext.set.is-subset-of": {
		  },
		  	"esnext.set.is-superset-of.v2": {
		  	android: "123",
		  	chrome: "123",
		  	"chrome-android": "123",
		  	deno: "1.41.3",
		  	edge: "123",
		  	electron: "30.0",
		  	opera: "109"
		  },
		  	"esnext.set.is-superset-of": {
		  },
		  	"esnext.set.join": {
		  },
		  	"esnext.set.map": {
		  },
		  	"esnext.set.of": {
		  },
		  	"esnext.set.reduce": {
		  },
		  	"esnext.set.some": {
		  },
		  	"esnext.set.symmetric-difference.v2": {
		  	android: "123",
		  	chrome: "123",
		  	"chrome-android": "123",
		  	deno: "1.41.3",
		  	edge: "123",
		  	electron: "30.0",
		  	opera: "109"
		  },
		  	"esnext.set.symmetric-difference": {
		  },
		  	"esnext.set.union.v2": {
		  	android: "123",
		  	chrome: "123",
		  	"chrome-android": "123",
		  	deno: "1.41.3",
		  	edge: "123",
		  	electron: "30.0",
		  	opera: "109"
		  },
		  	"esnext.set.union": {
		  },
		  	"esnext.string.at": {
		  },
		  	"esnext.string.cooked": {
		  },
		  	"esnext.string.code-points": {
		  },
		  	"esnext.string.dedent": {
		  },
		  	"esnext.string.is-well-formed": {
		  	android: "111",
		  	bun: "0.4.0",
		  	chrome: "111",
		  	"chrome-android": "111",
		  	deno: "1.32",
		  	edge: "111",
		  	electron: "24.0",
		  	firefox: "119",
		  	"firefox-android": "119",
		  	ios: "16.4",
		  	node: "20.0",
		  	oculus: "27.0",
		  	opera: "97",
		  	"opera-android": "75",
		  	opera_mobile: "75",
		  	quest: "27.0",
		  	safari: "16.4",
		  	samsung: "22.0"
		  },
		  	"esnext.string.match-all": {
		  	android: "80",
		  	bun: "0.1.1",
		  	chrome: "80",
		  	"chrome-android": "80",
		  	deno: "1.0",
		  	edge: "80",
		  	electron: "8.0",
		  	firefox: "73",
		  	"firefox-android": "73",
		  	hermes: "0.6",
		  	ios: "13.4",
		  	node: "14.0",
		  	oculus: "9.0",
		  	opera: "67",
		  	"opera-android": "57",
		  	opera_mobile: "57",
		  	quest: "9.0",
		  	"react-native": "0.69",
		  	safari: "13.1",
		  	samsung: "13.0"
		  },
		  	"esnext.string.replace-all": {
		  	android: "85",
		  	bun: "0.1.1",
		  	chrome: "85",
		  	"chrome-android": "85",
		  	deno: "1.2",
		  	edge: "85",
		  	electron: "10.0",
		  	firefox: "77",
		  	"firefox-android": "77",
		  	hermes: "0.7",
		  	ios: "13.4",
		  	node: "15.0",
		  	oculus: "12.0",
		  	opera: "71",
		  	"opera-android": "60",
		  	opera_mobile: "60",
		  	quest: "12.0",
		  	"react-native": "0.69",
		  	safari: "13.1",
		  	samsung: "14.0"
		  },
		  	"esnext.string.to-well-formed": {
		  	android: "111",
		  	bun: "0.5.7",
		  	chrome: "111",
		  	"chrome-android": "111",
		  	deno: "1.32",
		  	edge: "111",
		  	electron: "24.0",
		  	firefox: "119",
		  	"firefox-android": "119",
		  	ios: "16.4",
		  	node: "20.0",
		  	oculus: "27.0",
		  	opera: "97",
		  	"opera-android": "75",
		  	opera_mobile: "75",
		  	quest: "27.0",
		  	safari: "16.4",
		  	samsung: "22.0"
		  },
		  	"esnext.symbol.async-dispose": {
		  	bun: "1.0.23",
		  	deno: "1.38",
		  	node: "20.5.0"
		  },
		  	"esnext.symbol.dispose": {
		  	bun: "1.0.23",
		  	deno: "1.38",
		  	node: "20.5.0"
		  },
		  	"esnext.symbol.is-registered-symbol": {
		  },
		  	"esnext.symbol.is-registered": {
		  },
		  	"esnext.symbol.is-well-known-symbol": {
		  },
		  	"esnext.symbol.is-well-known": {
		  },
		  	"esnext.symbol.matcher": {
		  },
		  	"esnext.symbol.metadata": {
		  	deno: "1.40.4"
		  },
		  	"esnext.symbol.metadata-key": {
		  },
		  	"esnext.symbol.observable": {
		  },
		  	"esnext.symbol.pattern-match": {
		  },
		  	"esnext.symbol.replace-all": {
		  },
		  	"esnext.typed-array.from-async": {
		  },
		  	"esnext.typed-array.at": {
		  	android: "92",
		  	bun: "0.1.1",
		  	chrome: "92",
		  	"chrome-android": "92",
		  	deno: "1.12",
		  	edge: "92",
		  	electron: "14.0",
		  	firefox: "90",
		  	"firefox-android": "90",
		  	ios: "15.4",
		  	node: "16.6",
		  	oculus: "17.0",
		  	opera: "78",
		  	"opera-android": "65",
		  	opera_mobile: "65",
		  	quest: "17.0",
		  	"react-native": "0.71",
		  	safari: "15.4",
		  	samsung: "16.0"
		  },
		  	"esnext.typed-array.filter-out": {
		  },
		  	"esnext.typed-array.filter-reject": {
		  },
		  	"esnext.typed-array.find-last": {
		  	android: "97",
		  	bun: "0.1.1",
		  	chrome: "97",
		  	"chrome-android": "97",
		  	deno: "1.16",
		  	edge: "97",
		  	electron: "17.0",
		  	firefox: "104",
		  	"firefox-android": "104",
		  	hermes: "0.11",
		  	ios: "15.4",
		  	node: "18.0",
		  	oculus: "20.0",
		  	opera: "83",
		  	"opera-android": "68",
		  	opera_mobile: "68",
		  	quest: "20.0",
		  	"react-native": "0.69",
		  	safari: "15.4",
		  	samsung: "18.0"
		  },
		  	"esnext.typed-array.find-last-index": {
		  	android: "97",
		  	bun: "0.1.1",
		  	chrome: "97",
		  	"chrome-android": "97",
		  	deno: "1.16",
		  	edge: "97",
		  	electron: "17.0",
		  	firefox: "104",
		  	"firefox-android": "104",
		  	hermes: "0.11",
		  	ios: "15.4",
		  	node: "18.0",
		  	oculus: "20.0",
		  	opera: "83",
		  	"opera-android": "68",
		  	opera_mobile: "68",
		  	quest: "20.0",
		  	"react-native": "0.69",
		  	safari: "15.4",
		  	samsung: "18.0"
		  },
		  	"esnext.typed-array.group-by": {
		  },
		  	"esnext.typed-array.to-reversed": {
		  	android: "110",
		  	bun: "0.1.1",
		  	chrome: "110",
		  	"chrome-android": "110",
		  	deno: "1.27",
		  	edge: "110",
		  	electron: "23.0",
		  	firefox: "115",
		  	"firefox-android": "115",
		  	ios: "16.0",
		  	node: "20.0",
		  	oculus: "26.0",
		  	opera: "96",
		  	"opera-android": "74",
		  	opera_mobile: "74",
		  	quest: "26.0",
		  	safari: "16.0",
		  	samsung: "21.0"
		  },
		  	"esnext.typed-array.to-sorted": {
		  	android: "110",
		  	bun: "0.1.1",
		  	chrome: "110",
		  	"chrome-android": "110",
		  	deno: "1.27",
		  	edge: "110",
		  	electron: "23.0",
		  	firefox: "115",
		  	"firefox-android": "115",
		  	ios: "16.0",
		  	node: "20.0",
		  	oculus: "26.0",
		  	opera: "96",
		  	"opera-android": "74",
		  	opera_mobile: "74",
		  	quest: "26.0",
		  	safari: "16.0",
		  	samsung: "21.0"
		  },
		  	"esnext.typed-array.to-spliced": {
		  },
		  	"esnext.typed-array.unique-by": {
		  },
		  	"esnext.typed-array.with": {
		  	android: "110",
		  	bun: "0.1.9",
		  	chrome: "110",
		  	"chrome-android": "110",
		  	deno: "1.27",
		  	edge: "110",
		  	electron: "23.0",
		  	firefox: "115",
		  	"firefox-android": "115",
		  	ios: "16.4",
		  	node: "20.0",
		  	oculus: "26.0",
		  	opera: "96",
		  	"opera-android": "74",
		  	opera_mobile: "74",
		  	quest: "26.0",
		  	safari: "16.4",
		  	samsung: "21.0"
		  },
		  	"esnext.uint8-array.from-base64": {
		  },
		  	"esnext.uint8-array.from-hex": {
		  },
		  	"esnext.uint8-array.to-base64": {
		  },
		  	"esnext.uint8-array.to-hex": {
		  },
		  	"esnext.weak-map.delete-all": {
		  },
		  	"esnext.weak-map.from": {
		  },
		  	"esnext.weak-map.of": {
		  },
		  	"esnext.weak-map.emplace": {
		  },
		  	"esnext.weak-map.upsert": {
		  },
		  	"esnext.weak-set.add-all": {
		  },
		  	"esnext.weak-set.delete-all": {
		  },
		  	"esnext.weak-set.from": {
		  },
		  	"esnext.weak-set.of": {
		  },
		  	"web.atob": {
		  	android: "37",
		  	bun: "0.1.1",
		  	chrome: "34",
		  	"chrome-android": "34",
		  	deno: "1.0",
		  	edge: "16",
		  	electron: "0.20",
		  	firefox: "27",
		  	"firefox-android": "27",
		  	ios: "10.3",
		  	node: "18.0",
		  	oculus: "3.0",
		  	opera: "10.5",
		  	"opera-android": "10.5",
		  	opera_mobile: "10.5",
		  	quest: "3.0",
		  	"react-native": "0.74",
		  	safari: "10.1",
		  	samsung: "2.0"
		  },
		  	"web.btoa": {
		  	android: "3.0",
		  	bun: "0.1.1",
		  	chrome: "4",
		  	"chrome-android": "18",
		  	deno: "1.0",
		  	edge: "16",
		  	electron: "0.20",
		  	firefox: "27",
		  	"firefox-android": "27",
		  	ios: "1.0",
		  	node: "17.5",
		  	oculus: "3.0",
		  	opera: "10.5",
		  	"opera-android": "10.5",
		  	opera_mobile: "10.5",
		  	phantom: "1.9",
		  	quest: "3.0",
		  	safari: "3.0",
		  	samsung: "1.0"
		  },
		  	"web.dom-collections.for-each": {
		  	android: "58",
		  	bun: "0.1.1",
		  	chrome: "58",
		  	"chrome-android": "58",
		  	deno: "1.0",
		  	edge: "16",
		  	electron: "1.7",
		  	firefox: "50",
		  	"firefox-android": "50",
		  	hermes: "0.1",
		  	ios: "10.0",
		  	node: "0.0.1",
		  	oculus: "4.0",
		  	opera: "45",
		  	"opera-android": "43",
		  	opera_mobile: "43",
		  	quest: "4.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "10.0",
		  	samsung: "7.0"
		  },
		  	"web.dom-collections.iterator": {
		  	android: "66",
		  	bun: "0.1.1",
		  	chrome: "66",
		  	"chrome-android": "66",
		  	deno: "1.0",
		  	edge: "79",
		  	electron: "3.0",
		  	firefox: "60",
		  	"firefox-android": "60",
		  	hermes: "0.1",
		  	ios: "13.4",
		  	node: "0.0.1",
		  	oculus: "5.0",
		  	opera: "53",
		  	"opera-android": "47",
		  	opera_mobile: "47",
		  	quest: "5.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "13.1",
		  	samsung: "9.0"
		  },
		  	"web.dom-exception.constructor": {
		  	android: "46",
		  	bun: "0.1.1",
		  	chrome: "46",
		  	"chrome-android": "46",
		  	deno: "1.7",
		  	edge: "79",
		  	electron: "0.36",
		  	firefox: "37",
		  	"firefox-android": "37",
		  	ios: "11.3",
		  	node: "17.0",
		  	oculus: "3.0",
		  	opera: "33",
		  	"opera-android": "33",
		  	opera_mobile: "33",
		  	quest: "3.0",
		  	safari: "11.1",
		  	samsung: "5.0"
		  },
		  	"web.dom-exception.stack": {
		  	deno: "1.15",
		  	firefox: "37",
		  	"firefox-android": "37",
		  	node: "17.0"
		  },
		  	"web.dom-exception.to-string-tag": {
		  	android: "49",
		  	bun: "0.1.1",
		  	chrome: "49",
		  	"chrome-android": "49",
		  	deno: "1.7",
		  	edge: "79",
		  	electron: "0.37",
		  	firefox: "51",
		  	"firefox-android": "51",
		  	ios: "11.3",
		  	node: "17.0",
		  	oculus: "3.0",
		  	opera: "36",
		  	"opera-android": "36",
		  	opera_mobile: "36",
		  	quest: "3.0",
		  	safari: "11.1",
		  	samsung: "5.0"
		  },
		  	"web.immediate": {
		  	bun: "0.4.0",
		  	ie: "10",
		  	node: "0.9.1"
		  },
		  	"web.queue-microtask": {
		  	android: "71",
		  	chrome: "71",
		  	"chrome-android": "71",
		  	deno: "1.0",
		  	edge: "79",
		  	electron: "5.0",
		  	firefox: "69",
		  	"firefox-android": "69",
		  	ios: "12.2",
		  	node: "12.0",
		  	oculus: "6.0",
		  	opera: "58",
		  	"opera-android": "50",
		  	opera_mobile: "50",
		  	quest: "6.0",
		  	safari: "12.1",
		  	samsung: "10.0"
		  },
		  	"web.self": {
		  	android: "86",
		  	bun: "1.0.22",
		  	chrome: "86",
		  	"chrome-android": "86",
		  	deno: "1.29.3",
		  	edge: "86",
		  	electron: "11.0",
		  	firefox: "31",
		  	"firefox-android": "31",
		  	ios: "10.0",
		  	oculus: "12.0",
		  	opera: "72",
		  	"opera-android": "61",
		  	opera_mobile: "61",
		  	quest: "12.0",
		  	safari: "10",
		  	samsung: "14.0"
		  },
		  	"web.structured-clone": {
		  },
		  	"web.timers": {
		  	android: "1.5",
		  	bun: "0.4.0",
		  	chrome: "1",
		  	"chrome-android": "18",
		  	deno: "1.0",
		  	edge: "12",
		  	electron: "0.20",
		  	firefox: "1",
		  	"firefox-android": "4",
		  	hermes: "0.1",
		  	ie: "10",
		  	ios: "1.0",
		  	node: "0.0.1",
		  	oculus: "3.0",
		  	opera: "7",
		  	"opera-android": "7",
		  	opera_mobile: "7",
		  	phantom: "1.9",
		  	quest: "3.0",
		  	"react-native": "0.69",
		  	rhino: "1.7.13",
		  	safari: "1.0",
		  	samsung: "1.0"
		  },
		  	"web.url": {
		  	android: "67",
		  	bun: "0.1.1",
		  	chrome: "67",
		  	"chrome-android": "67",
		  	deno: "1.0",
		  	edge: "79",
		  	electron: "4.0",
		  	firefox: "57",
		  	"firefox-android": "57",
		  	ios: "14.0",
		  	node: "10.0",
		  	oculus: "6.0",
		  	opera: "54",
		  	"opera-android": "48",
		  	opera_mobile: "48",
		  	quest: "6.0",
		  	safari: "14.0",
		  	samsung: "9.0"
		  },
		  	"web.url.can-parse": {
		  	android: "120",
		  	chrome: "120",
		  	"chrome-android": "120",
		  	deno: "1.33.2",
		  	edge: "120",
		  	electron: "28.0",
		  	firefox: "115",
		  	"firefox-android": "115",
		  	ios: "17.0",
		  	node: "20.1.0",
		  	oculus: "31.0",
		  	opera: "106",
		  	"opera-android": "80",
		  	opera_mobile: "80",
		  	quest: "31.0",
		  	safari: "17.0",
		  	samsung: "25.0"
		  },
		  	"web.url.to-json": {
		  	android: "71",
		  	bun: "0.1.1",
		  	chrome: "71",
		  	"chrome-android": "71",
		  	deno: "1.0",
		  	edge: "79",
		  	electron: "5.0",
		  	firefox: "57",
		  	"firefox-android": "57",
		  	ios: "14.0",
		  	node: "10.0",
		  	oculus: "6.0",
		  	opera: "58",
		  	"opera-android": "50",
		  	opera_mobile: "50",
		  	quest: "6.0",
		  	safari: "14.0",
		  	samsung: "10.0"
		  },
		  	"web.url-search-params": {
		  	android: "67",
		  	bun: "0.1.1",
		  	chrome: "67",
		  	"chrome-android": "67",
		  	deno: "1.0",
		  	edge: "79",
		  	electron: "4.0",
		  	firefox: "57",
		  	"firefox-android": "57",
		  	ios: "14.0",
		  	node: "10.0",
		  	oculus: "6.0",
		  	opera: "54",
		  	"opera-android": "48",
		  	opera_mobile: "48",
		  	quest: "6.0",
		  	safari: "14.0",
		  	samsung: "9.0"
		  },
		  	"web.url-search-params.delete": {
		  	android: "118",
		  	bun: "1.0.31",
		  	chrome: "118",
		  	"chrome-android": "118",
		  	deno: "1.35",
		  	edge: "118",
		  	electron: "27.0",
		  	firefox: "115",
		  	"firefox-android": "115",
		  	ios: "17.0",
		  	node: "20.2.0",
		  	oculus: "30.0",
		  	opera: "104",
		  	"opera-android": "79",
		  	opera_mobile: "79",
		  	quest: "30.0",
		  	safari: "17.0",
		  	samsung: "25.0"
		  },
		  	"web.url-search-params.has": {
		  	android: "118",
		  	bun: "1.0.31",
		  	chrome: "118",
		  	"chrome-android": "118",
		  	deno: "1.35",
		  	edge: "118",
		  	electron: "27.0",
		  	firefox: "115",
		  	"firefox-android": "115",
		  	ios: "17.0",
		  	node: "20.2.0",
		  	oculus: "30.0",
		  	opera: "104",
		  	"opera-android": "79",
		  	opera_mobile: "79",
		  	quest: "30.0",
		  	safari: "17.0",
		  	samsung: "25.0"
		  },
		  	"web.url-search-params.size": {
		  	android: "113",
		  	bun: "1.0.2",
		  	chrome: "113",
		  	"chrome-android": "113",
		  	deno: "1.32",
		  	edge: "113",
		  	electron: "25.0",
		  	firefox: "112",
		  	"firefox-android": "112",
		  	ios: "17.0",
		  	node: "19.8.0",
		  	oculus: "28.0",
		  	opera: "99",
		  	"opera-android": "76",
		  	opera_mobile: "76",
		  	quest: "28.0",
		  	safari: "17.0",
		  	samsung: "23.0"
		  }
		  };

		  var data$1;
		  var hasRequiredData;
		  function requireData() {
		    if (hasRequiredData) return data$1;
		    hasRequiredData = 1;
		    data$1 = require$$0$3;
		    return data$1;
		  }

		  var shippedProposals = {};

		  var hasRequiredShippedProposals;
		  function requireShippedProposals() {
		    if (hasRequiredShippedProposals) return shippedProposals;
		    hasRequiredShippedProposals = 1;
		    shippedProposals.__esModule = true;
		    shippedProposals["default"] = void 0;
		    var _default = new Set(["esnext.suppressed-error.constructor", "esnext.array.from-async", "esnext.array.group", "esnext.array.group-to-map", "esnext.iterator.constructor", "esnext.iterator.drop", "esnext.iterator.every", "esnext.iterator.filter", "esnext.iterator.find", "esnext.iterator.flat-map", "esnext.iterator.for-each", "esnext.iterator.from", "esnext.iterator.map", "esnext.iterator.reduce", "esnext.iterator.some", "esnext.iterator.take", "esnext.iterator.to-array", "esnext.json.is-raw-json", "esnext.json.parse", "esnext.json.raw-json", "esnext.set.difference.v2", "esnext.set.intersection.v2", "esnext.set.is-disjoint-from.v2", "esnext.set.is-subset-of.v2", "esnext.set.is-superset-of.v2", "esnext.set.symmetric-difference.v2", "esnext.set.union.v2", "esnext.symbol.async-dispose", "esnext.symbol.dispose", "esnext.symbol.metadata"]);
		    shippedProposals["default"] = _default;
		    return shippedProposals;
		  }

		  var has$2 = Object.hasOwn || Function.call.bind({}.hasOwnProperty);
		  function semver$3(input) {
		    if (input instanceof semver$3) return input;
		    if (!(this instanceof semver$3)) return new semver$3(input);
		    var match = /(\d+)(?:\.(\d+))?(?:\.(\d+))?/.exec(input);
		    if (!match) throw new TypeError("Invalid version: " + input);
		    var _match = _slicedToArray(match, 4),
		      $major = _match[1],
		      $minor = _match[2],
		      $patch = _match[3];
		    this.major = +$major;
		    this.minor = $minor ? +$minor : 0;
		    this.patch = $patch ? +$patch : 0;
		  }
		  semver$3.prototype.toString = function () {
		    return this.major + "." + this.minor + "." + this.patch;
		  };
		  function compare$1($a, operator, $b) {
		    var a = semver$3($a);
		    var b = semver$3($b);
		    for (var _i = 0, _arr = ['major', 'minor', 'patch']; _i < _arr.length; _i++) {
		      var component = _arr[_i];
		      if (a[component] < b[component]) return operator === '<' || operator === '<=' || operator === '!=';
		      if (a[component] > b[component]) return operator === '>' || operator === '>=' || operator === '!=';
		    }
		    return operator === '==' || operator === '<=' || operator === '>=';
		  }
		  function filterOutStabilizedProposals(modules) {
		    var modulesSet = new Set(modules);
		    for (var _iterator = _createForOfIteratorHelperLoose(modulesSet), _step; !(_step = _iterator()).done;) {
		      var $module = _step.value;
		      if ($module.startsWith('esnext.') && modulesSet.has($module.replace(/^esnext\./, 'es.'))) {
		        modulesSet["delete"]($module);
		      }
		    }
		    return _toConsumableArray(modulesSet);
		  }
		  function intersection$2(list, order) {
		    var set = list instanceof Set ? list : new Set(list);
		    return order.filter(function (name) {
		      return set.has(name);
		    });
		  }
		  function sortObjectByKey(object, fn) {
		    return Object.keys(object).sort(fn).reduce(function (memo, key) {
		      memo[key] = object[key];
		      return memo;
		    }, {});
		  }
		  var helpers$1 = {
		    compare: compare$1,
		    filterOutStabilizedProposals: filterOutStabilizedProposals,
		    has: has$2,
		    intersection: intersection$2,
		    semver: semver$3,
		    sortObjectByKey: sortObjectByKey
		  };

		  var require$$1 = {
		  	"3.0": [
		  	"es.symbol",
		  	"es.symbol.description",
		  	"es.symbol.async-iterator",
		  	"es.symbol.has-instance",
		  	"es.symbol.is-concat-spreadable",
		  	"es.symbol.iterator",
		  	"es.symbol.match",
		  	"es.symbol.replace",
		  	"es.symbol.search",
		  	"es.symbol.species",
		  	"es.symbol.split",
		  	"es.symbol.to-primitive",
		  	"es.symbol.to-string-tag",
		  	"es.symbol.unscopables",
		  	"es.array.concat",
		  	"es.array.copy-within",
		  	"es.array.every",
		  	"es.array.fill",
		  	"es.array.filter",
		  	"es.array.find",
		  	"es.array.find-index",
		  	"es.array.flat",
		  	"es.array.flat-map",
		  	"es.array.for-each",
		  	"es.array.from",
		  	"es.array.includes",
		  	"es.array.index-of",
		  	"es.array.is-array",
		  	"es.array.iterator",
		  	"es.array.join",
		  	"es.array.last-index-of",
		  	"es.array.map",
		  	"es.array.of",
		  	"es.array.reduce",
		  	"es.array.reduce-right",
		  	"es.array.reverse",
		  	"es.array.slice",
		  	"es.array.some",
		  	"es.array.sort",
		  	"es.array.species",
		  	"es.array.splice",
		  	"es.array.unscopables.flat",
		  	"es.array.unscopables.flat-map",
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.is-view",
		  	"es.array-buffer.slice",
		  	"es.data-view",
		  	"es.date.now",
		  	"es.date.to-iso-string",
		  	"es.date.to-json",
		  	"es.date.to-primitive",
		  	"es.date.to-string",
		  	"es.function.bind",
		  	"es.function.has-instance",
		  	"es.function.name",
		  	"es.json.to-string-tag",
		  	"es.map",
		  	"es.math.acosh",
		  	"es.math.asinh",
		  	"es.math.atanh",
		  	"es.math.cbrt",
		  	"es.math.clz32",
		  	"es.math.cosh",
		  	"es.math.expm1",
		  	"es.math.fround",
		  	"es.math.hypot",
		  	"es.math.imul",
		  	"es.math.log10",
		  	"es.math.log1p",
		  	"es.math.log2",
		  	"es.math.sign",
		  	"es.math.sinh",
		  	"es.math.tanh",
		  	"es.math.to-string-tag",
		  	"es.math.trunc",
		  	"es.number.constructor",
		  	"es.number.epsilon",
		  	"es.number.is-finite",
		  	"es.number.is-integer",
		  	"es.number.is-nan",
		  	"es.number.is-safe-integer",
		  	"es.number.max-safe-integer",
		  	"es.number.min-safe-integer",
		  	"es.number.parse-float",
		  	"es.number.parse-int",
		  	"es.number.to-fixed",
		  	"es.number.to-precision",
		  	"es.object.assign",
		  	"es.object.create",
		  	"es.object.define-getter",
		  	"es.object.define-properties",
		  	"es.object.define-property",
		  	"es.object.define-setter",
		  	"es.object.entries",
		  	"es.object.freeze",
		  	"es.object.from-entries",
		  	"es.object.get-own-property-descriptor",
		  	"es.object.get-own-property-descriptors",
		  	"es.object.get-own-property-names",
		  	"es.object.get-prototype-of",
		  	"es.object.is",
		  	"es.object.is-extensible",
		  	"es.object.is-frozen",
		  	"es.object.is-sealed",
		  	"es.object.keys",
		  	"es.object.lookup-getter",
		  	"es.object.lookup-setter",
		  	"es.object.prevent-extensions",
		  	"es.object.seal",
		  	"es.object.set-prototype-of",
		  	"es.object.to-string",
		  	"es.object.values",
		  	"es.parse-float",
		  	"es.parse-int",
		  	"es.promise",
		  	"es.promise.finally",
		  	"es.reflect.apply",
		  	"es.reflect.construct",
		  	"es.reflect.define-property",
		  	"es.reflect.delete-property",
		  	"es.reflect.get",
		  	"es.reflect.get-own-property-descriptor",
		  	"es.reflect.get-prototype-of",
		  	"es.reflect.has",
		  	"es.reflect.is-extensible",
		  	"es.reflect.own-keys",
		  	"es.reflect.prevent-extensions",
		  	"es.reflect.set",
		  	"es.reflect.set-prototype-of",
		  	"es.regexp.constructor",
		  	"es.regexp.exec",
		  	"es.regexp.flags",
		  	"es.regexp.to-string",
		  	"es.set",
		  	"es.string.code-point-at",
		  	"es.string.ends-with",
		  	"es.string.from-code-point",
		  	"es.string.includes",
		  	"es.string.iterator",
		  	"es.string.match",
		  	"es.string.pad-end",
		  	"es.string.pad-start",
		  	"es.string.raw",
		  	"es.string.repeat",
		  	"es.string.replace",
		  	"es.string.search",
		  	"es.string.split",
		  	"es.string.starts-with",
		  	"es.string.trim",
		  	"es.string.trim-end",
		  	"es.string.trim-start",
		  	"es.string.anchor",
		  	"es.string.big",
		  	"es.string.blink",
		  	"es.string.bold",
		  	"es.string.fixed",
		  	"es.string.fontcolor",
		  	"es.string.fontsize",
		  	"es.string.italics",
		  	"es.string.link",
		  	"es.string.small",
		  	"es.string.strike",
		  	"es.string.sub",
		  	"es.string.sup",
		  	"es.typed-array.float32-array",
		  	"es.typed-array.float64-array",
		  	"es.typed-array.int8-array",
		  	"es.typed-array.int16-array",
		  	"es.typed-array.int32-array",
		  	"es.typed-array.uint8-array",
		  	"es.typed-array.uint8-clamped-array",
		  	"es.typed-array.uint16-array",
		  	"es.typed-array.uint32-array",
		  	"es.typed-array.copy-within",
		  	"es.typed-array.every",
		  	"es.typed-array.fill",
		  	"es.typed-array.filter",
		  	"es.typed-array.find",
		  	"es.typed-array.find-index",
		  	"es.typed-array.for-each",
		  	"es.typed-array.from",
		  	"es.typed-array.includes",
		  	"es.typed-array.index-of",
		  	"es.typed-array.iterator",
		  	"es.typed-array.join",
		  	"es.typed-array.last-index-of",
		  	"es.typed-array.map",
		  	"es.typed-array.of",
		  	"es.typed-array.reduce",
		  	"es.typed-array.reduce-right",
		  	"es.typed-array.reverse",
		  	"es.typed-array.set",
		  	"es.typed-array.slice",
		  	"es.typed-array.some",
		  	"es.typed-array.sort",
		  	"es.typed-array.subarray",
		  	"es.typed-array.to-locale-string",
		  	"es.typed-array.to-string",
		  	"es.weak-map",
		  	"es.weak-set",
		  	"esnext.aggregate-error",
		  	"esnext.array.last-index",
		  	"esnext.array.last-item",
		  	"esnext.composite-key",
		  	"esnext.composite-symbol",
		  	"esnext.global-this",
		  	"esnext.map.delete-all",
		  	"esnext.map.every",
		  	"esnext.map.filter",
		  	"esnext.map.find",
		  	"esnext.map.find-key",
		  	"esnext.map.from",
		  	"esnext.map.group-by",
		  	"esnext.map.includes",
		  	"esnext.map.key-by",
		  	"esnext.map.key-of",
		  	"esnext.map.map-keys",
		  	"esnext.map.map-values",
		  	"esnext.map.merge",
		  	"esnext.map.of",
		  	"esnext.map.reduce",
		  	"esnext.map.some",
		  	"esnext.map.update",
		  	"esnext.math.clamp",
		  	"esnext.math.deg-per-rad",
		  	"esnext.math.degrees",
		  	"esnext.math.fscale",
		  	"esnext.math.iaddh",
		  	"esnext.math.imulh",
		  	"esnext.math.isubh",
		  	"esnext.math.rad-per-deg",
		  	"esnext.math.radians",
		  	"esnext.math.scale",
		  	"esnext.math.seeded-prng",
		  	"esnext.math.signbit",
		  	"esnext.math.umulh",
		  	"esnext.number.from-string",
		  	"esnext.observable",
		  	"esnext.promise.all-settled",
		  	"esnext.promise.any",
		  	"esnext.promise.try",
		  	"esnext.reflect.define-metadata",
		  	"esnext.reflect.delete-metadata",
		  	"esnext.reflect.get-metadata",
		  	"esnext.reflect.get-metadata-keys",
		  	"esnext.reflect.get-own-metadata",
		  	"esnext.reflect.get-own-metadata-keys",
		  	"esnext.reflect.has-metadata",
		  	"esnext.reflect.has-own-metadata",
		  	"esnext.reflect.metadata",
		  	"esnext.set.add-all",
		  	"esnext.set.delete-all",
		  	"esnext.set.difference",
		  	"esnext.set.every",
		  	"esnext.set.filter",
		  	"esnext.set.find",
		  	"esnext.set.from",
		  	"esnext.set.intersection",
		  	"esnext.set.is-disjoint-from",
		  	"esnext.set.is-subset-of",
		  	"esnext.set.is-superset-of",
		  	"esnext.set.join",
		  	"esnext.set.map",
		  	"esnext.set.of",
		  	"esnext.set.reduce",
		  	"esnext.set.some",
		  	"esnext.set.symmetric-difference",
		  	"esnext.set.union",
		  	"esnext.string.at",
		  	"esnext.string.code-points",
		  	"esnext.string.match-all",
		  	"esnext.string.replace-all",
		  	"esnext.symbol.dispose",
		  	"esnext.symbol.observable",
		  	"esnext.symbol.pattern-match",
		  	"esnext.weak-map.delete-all",
		  	"esnext.weak-map.from",
		  	"esnext.weak-map.of",
		  	"esnext.weak-set.add-all",
		  	"esnext.weak-set.delete-all",
		  	"esnext.weak-set.from",
		  	"esnext.weak-set.of",
		  	"web.dom-collections.for-each",
		  	"web.dom-collections.iterator",
		  	"web.immediate",
		  	"web.queue-microtask",
		  	"web.timers",
		  	"web.url",
		  	"web.url.to-json",
		  	"web.url-search-params"
		  ],
		  	"3.1": [
		  	"es.string.match-all",
		  	"es.symbol.match-all",
		  	"esnext.symbol.replace-all"
		  ],
		  	"3.2": [
		  	"es.promise.all-settled",
		  	"esnext.array.is-template-object",
		  	"esnext.map.update-or-insert",
		  	"esnext.symbol.async-dispose"
		  ],
		  	"3.3": [
		  	"es.global-this",
		  	"esnext.async-iterator.constructor",
		  	"esnext.async-iterator.as-indexed-pairs",
		  	"esnext.async-iterator.drop",
		  	"esnext.async-iterator.every",
		  	"esnext.async-iterator.filter",
		  	"esnext.async-iterator.find",
		  	"esnext.async-iterator.flat-map",
		  	"esnext.async-iterator.for-each",
		  	"esnext.async-iterator.from",
		  	"esnext.async-iterator.map",
		  	"esnext.async-iterator.reduce",
		  	"esnext.async-iterator.some",
		  	"esnext.async-iterator.take",
		  	"esnext.async-iterator.to-array",
		  	"esnext.iterator.constructor",
		  	"esnext.iterator.as-indexed-pairs",
		  	"esnext.iterator.drop",
		  	"esnext.iterator.every",
		  	"esnext.iterator.filter",
		  	"esnext.iterator.find",
		  	"esnext.iterator.flat-map",
		  	"esnext.iterator.for-each",
		  	"esnext.iterator.from",
		  	"esnext.iterator.map",
		  	"esnext.iterator.reduce",
		  	"esnext.iterator.some",
		  	"esnext.iterator.take",
		  	"esnext.iterator.to-array",
		  	"esnext.map.upsert",
		  	"esnext.weak-map.upsert"
		  ],
		  	"3.4": [
		  	"es.json.stringify"
		  ],
		  	"3.5": [
		  	"esnext.object.iterate-entries",
		  	"esnext.object.iterate-keys",
		  	"esnext.object.iterate-values"
		  ],
		  	"3.6": [
		  	"es.regexp.sticky",
		  	"es.regexp.test"
		  ],
		  	"3.7": [
		  	"es.aggregate-error",
		  	"es.promise.any",
		  	"es.reflect.to-string-tag",
		  	"es.string.replace-all",
		  	"esnext.map.emplace",
		  	"esnext.weak-map.emplace"
		  ],
		  	"3.8": [
		  	"esnext.array.at",
		  	"esnext.array.filter-out",
		  	"esnext.array.unique-by",
		  	"esnext.bigint.range",
		  	"esnext.number.range",
		  	"esnext.typed-array.at",
		  	"esnext.typed-array.filter-out"
		  ],
		  	"3.9": [
		  	"esnext.array.find-last",
		  	"esnext.array.find-last-index",
		  	"esnext.typed-array.find-last",
		  	"esnext.typed-array.find-last-index",
		  	"esnext.typed-array.unique-by"
		  ],
		  	"3.11": [
		  	"esnext.object.has-own"
		  ],
		  	"3.12": [
		  	"esnext.symbol.matcher",
		  	"esnext.symbol.metadata"
		  ],
		  	"3.15": [
		  	"es.date.get-year",
		  	"es.date.set-year",
		  	"es.date.to-gmt-string",
		  	"es.escape",
		  	"es.regexp.dot-all",
		  	"es.string.substr",
		  	"es.unescape"
		  ],
		  	"3.16": [
		  	"esnext.array.filter-reject",
		  	"esnext.array.group-by",
		  	"esnext.typed-array.filter-reject",
		  	"esnext.typed-array.group-by"
		  ],
		  	"3.17": [
		  	"es.array.at",
		  	"es.object.has-own",
		  	"es.string.at-alternative",
		  	"es.typed-array.at"
		  ],
		  	"3.18": [
		  	"esnext.array.from-async",
		  	"esnext.typed-array.from-async"
		  ],
		  	"3.20": [
		  	"es.error.cause",
		  	"es.error.to-string",
		  	"es.aggregate-error.cause",
		  	"es.number.to-exponential",
		  	"esnext.array.group-by-to-map",
		  	"esnext.array.to-reversed",
		  	"esnext.array.to-sorted",
		  	"esnext.array.to-spliced",
		  	"esnext.array.with",
		  	"esnext.function.is-callable",
		  	"esnext.function.is-constructor",
		  	"esnext.function.un-this",
		  	"esnext.iterator.to-async",
		  	"esnext.string.cooked",
		  	"esnext.typed-array.to-reversed",
		  	"esnext.typed-array.to-sorted",
		  	"esnext.typed-array.to-spliced",
		  	"esnext.typed-array.with",
		  	"web.dom-exception.constructor",
		  	"web.dom-exception.stack",
		  	"web.dom-exception.to-string-tag",
		  	"web.structured-clone"
		  ],
		  	"3.21": [
		  	"web.atob",
		  	"web.btoa"
		  ],
		  	"3.23": [
		  	"es.array.find-last",
		  	"es.array.find-last-index",
		  	"es.array.push",
		  	"es.array.unshift",
		  	"es.typed-array.find-last",
		  	"es.typed-array.find-last-index",
		  	"esnext.array.group",
		  	"esnext.array.group-to-map",
		  	"esnext.symbol.metadata-key"
		  ],
		  	"3.24": [
		  	"esnext.async-iterator.indexed",
		  	"esnext.iterator.indexed"
		  ],
		  	"3.25": [
		  	"es.object.proto"
		  ],
		  	"3.26": [
		  	"esnext.string.is-well-formed",
		  	"esnext.string.to-well-formed",
		  	"web.self"
		  ],
		  	"3.27": [
		  	"esnext.suppressed-error.constructor",
		  	"esnext.async-disposable-stack.constructor",
		  	"esnext.async-iterator.async-dispose",
		  	"esnext.disposable-stack.constructor",
		  	"esnext.iterator.dispose",
		  	"esnext.set.difference.v2",
		  	"esnext.set.intersection.v2",
		  	"esnext.set.is-disjoint-from.v2",
		  	"esnext.set.is-subset-of.v2",
		  	"esnext.set.is-superset-of.v2",
		  	"esnext.set.symmetric-difference.v2",
		  	"esnext.set.union.v2",
		  	"esnext.string.dedent"
		  ],
		  	"3.28": [
		  	"es.array.to-reversed",
		  	"es.array.to-sorted",
		  	"es.array.to-spliced",
		  	"es.array.with",
		  	"es.typed-array.to-reversed",
		  	"es.typed-array.to-sorted",
		  	"es.typed-array.with",
		  	"esnext.array-buffer.detached",
		  	"esnext.array-buffer.transfer",
		  	"esnext.array-buffer.transfer-to-fixed-length",
		  	"esnext.function.demethodize",
		  	"esnext.iterator.range",
		  	"esnext.json.is-raw-json",
		  	"esnext.json.parse",
		  	"esnext.json.raw-json",
		  	"esnext.symbol.is-registered",
		  	"esnext.symbol.is-well-known"
		  ],
		  	"3.29": [
		  	"web.url-search-params.size"
		  ],
		  	"3.30": [
		  	"web.url.can-parse"
		  ],
		  	"3.31": [
		  	"es.string.is-well-formed",
		  	"es.string.to-well-formed",
		  	"esnext.function.metadata",
		  	"esnext.object.group-by",
		  	"esnext.promise.with-resolvers",
		  	"esnext.symbol.is-registered-symbol",
		  	"esnext.symbol.is-well-known-symbol",
		  	"web.url-search-params.delete",
		  	"web.url-search-params.has"
		  ],
		  	"3.32": [
		  	"esnext.data-view.get-float16",
		  	"esnext.data-view.get-uint8-clamped",
		  	"esnext.data-view.set-float16",
		  	"esnext.data-view.set-uint8-clamped",
		  	"esnext.math.f16round"
		  ],
		  	"3.33": [
		  	"esnext.regexp.escape"
		  ],
		  	"3.34": [
		  	"es.map.group-by",
		  	"es.object.group-by",
		  	"es.promise.with-resolvers",
		  	"esnext.uint8-array.from-base64",
		  	"esnext.uint8-array.from-hex",
		  	"esnext.uint8-array.to-base64",
		  	"esnext.uint8-array.to-hex"
		  ],
		  	"3.36": [
		  	"es.array-buffer.detached",
		  	"es.array-buffer.transfer",
		  	"es.array-buffer.transfer-to-fixed-length"
		  ]
		  };

		  var require$$2 = [
		  	"es.symbol",
		  	"es.symbol.description",
		  	"es.symbol.async-iterator",
		  	"es.symbol.has-instance",
		  	"es.symbol.is-concat-spreadable",
		  	"es.symbol.iterator",
		  	"es.symbol.match",
		  	"es.symbol.match-all",
		  	"es.symbol.replace",
		  	"es.symbol.search",
		  	"es.symbol.species",
		  	"es.symbol.split",
		  	"es.symbol.to-primitive",
		  	"es.symbol.to-string-tag",
		  	"es.symbol.unscopables",
		  	"es.error.cause",
		  	"es.error.to-string",
		  	"es.aggregate-error",
		  	"es.aggregate-error.cause",
		  	"es.array.at",
		  	"es.array.concat",
		  	"es.array.copy-within",
		  	"es.array.every",
		  	"es.array.fill",
		  	"es.array.filter",
		  	"es.array.find",
		  	"es.array.find-index",
		  	"es.array.find-last",
		  	"es.array.find-last-index",
		  	"es.array.flat",
		  	"es.array.flat-map",
		  	"es.array.for-each",
		  	"es.array.from",
		  	"es.array.includes",
		  	"es.array.index-of",
		  	"es.array.is-array",
		  	"es.array.iterator",
		  	"es.array.join",
		  	"es.array.last-index-of",
		  	"es.array.map",
		  	"es.array.of",
		  	"es.array.push",
		  	"es.array.reduce",
		  	"es.array.reduce-right",
		  	"es.array.reverse",
		  	"es.array.slice",
		  	"es.array.some",
		  	"es.array.sort",
		  	"es.array.species",
		  	"es.array.splice",
		  	"es.array.to-reversed",
		  	"es.array.to-sorted",
		  	"es.array.to-spliced",
		  	"es.array.unscopables.flat",
		  	"es.array.unscopables.flat-map",
		  	"es.array.unshift",
		  	"es.array.with",
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.is-view",
		  	"es.array-buffer.slice",
		  	"es.data-view",
		  	"es.array-buffer.detached",
		  	"es.array-buffer.transfer",
		  	"es.array-buffer.transfer-to-fixed-length",
		  	"es.date.get-year",
		  	"es.date.now",
		  	"es.date.set-year",
		  	"es.date.to-gmt-string",
		  	"es.date.to-iso-string",
		  	"es.date.to-json",
		  	"es.date.to-primitive",
		  	"es.date.to-string",
		  	"es.escape",
		  	"es.function.bind",
		  	"es.function.has-instance",
		  	"es.function.name",
		  	"es.global-this",
		  	"es.json.stringify",
		  	"es.json.to-string-tag",
		  	"es.map",
		  	"es.map.group-by",
		  	"es.math.acosh",
		  	"es.math.asinh",
		  	"es.math.atanh",
		  	"es.math.cbrt",
		  	"es.math.clz32",
		  	"es.math.cosh",
		  	"es.math.expm1",
		  	"es.math.fround",
		  	"es.math.hypot",
		  	"es.math.imul",
		  	"es.math.log10",
		  	"es.math.log1p",
		  	"es.math.log2",
		  	"es.math.sign",
		  	"es.math.sinh",
		  	"es.math.tanh",
		  	"es.math.to-string-tag",
		  	"es.math.trunc",
		  	"es.number.constructor",
		  	"es.number.epsilon",
		  	"es.number.is-finite",
		  	"es.number.is-integer",
		  	"es.number.is-nan",
		  	"es.number.is-safe-integer",
		  	"es.number.max-safe-integer",
		  	"es.number.min-safe-integer",
		  	"es.number.parse-float",
		  	"es.number.parse-int",
		  	"es.number.to-exponential",
		  	"es.number.to-fixed",
		  	"es.number.to-precision",
		  	"es.object.assign",
		  	"es.object.create",
		  	"es.object.define-getter",
		  	"es.object.define-properties",
		  	"es.object.define-property",
		  	"es.object.define-setter",
		  	"es.object.entries",
		  	"es.object.freeze",
		  	"es.object.from-entries",
		  	"es.object.get-own-property-descriptor",
		  	"es.object.get-own-property-descriptors",
		  	"es.object.get-own-property-names",
		  	"es.object.get-prototype-of",
		  	"es.object.group-by",
		  	"es.object.has-own",
		  	"es.object.is",
		  	"es.object.is-extensible",
		  	"es.object.is-frozen",
		  	"es.object.is-sealed",
		  	"es.object.keys",
		  	"es.object.lookup-getter",
		  	"es.object.lookup-setter",
		  	"es.object.prevent-extensions",
		  	"es.object.proto",
		  	"es.object.seal",
		  	"es.object.set-prototype-of",
		  	"es.object.to-string",
		  	"es.object.values",
		  	"es.parse-float",
		  	"es.parse-int",
		  	"es.promise",
		  	"es.promise.all-settled",
		  	"es.promise.any",
		  	"es.promise.finally",
		  	"es.promise.with-resolvers",
		  	"es.reflect.apply",
		  	"es.reflect.construct",
		  	"es.reflect.define-property",
		  	"es.reflect.delete-property",
		  	"es.reflect.get",
		  	"es.reflect.get-own-property-descriptor",
		  	"es.reflect.get-prototype-of",
		  	"es.reflect.has",
		  	"es.reflect.is-extensible",
		  	"es.reflect.own-keys",
		  	"es.reflect.prevent-extensions",
		  	"es.reflect.set",
		  	"es.reflect.set-prototype-of",
		  	"es.reflect.to-string-tag",
		  	"es.regexp.constructor",
		  	"es.regexp.dot-all",
		  	"es.regexp.exec",
		  	"es.regexp.flags",
		  	"es.regexp.sticky",
		  	"es.regexp.test",
		  	"es.regexp.to-string",
		  	"es.set",
		  	"es.string.at-alternative",
		  	"es.string.code-point-at",
		  	"es.string.ends-with",
		  	"es.string.from-code-point",
		  	"es.string.includes",
		  	"es.string.is-well-formed",
		  	"es.string.iterator",
		  	"es.string.match",
		  	"es.string.match-all",
		  	"es.string.pad-end",
		  	"es.string.pad-start",
		  	"es.string.raw",
		  	"es.string.repeat",
		  	"es.string.replace",
		  	"es.string.replace-all",
		  	"es.string.search",
		  	"es.string.split",
		  	"es.string.starts-with",
		  	"es.string.substr",
		  	"es.string.to-well-formed",
		  	"es.string.trim",
		  	"es.string.trim-end",
		  	"es.string.trim-start",
		  	"es.string.anchor",
		  	"es.string.big",
		  	"es.string.blink",
		  	"es.string.bold",
		  	"es.string.fixed",
		  	"es.string.fontcolor",
		  	"es.string.fontsize",
		  	"es.string.italics",
		  	"es.string.link",
		  	"es.string.small",
		  	"es.string.strike",
		  	"es.string.sub",
		  	"es.string.sup",
		  	"es.typed-array.float32-array",
		  	"es.typed-array.float64-array",
		  	"es.typed-array.int8-array",
		  	"es.typed-array.int16-array",
		  	"es.typed-array.int32-array",
		  	"es.typed-array.uint8-array",
		  	"es.typed-array.uint8-clamped-array",
		  	"es.typed-array.uint16-array",
		  	"es.typed-array.uint32-array",
		  	"es.typed-array.at",
		  	"es.typed-array.copy-within",
		  	"es.typed-array.every",
		  	"es.typed-array.fill",
		  	"es.typed-array.filter",
		  	"es.typed-array.find",
		  	"es.typed-array.find-index",
		  	"es.typed-array.find-last",
		  	"es.typed-array.find-last-index",
		  	"es.typed-array.for-each",
		  	"es.typed-array.from",
		  	"es.typed-array.includes",
		  	"es.typed-array.index-of",
		  	"es.typed-array.iterator",
		  	"es.typed-array.join",
		  	"es.typed-array.last-index-of",
		  	"es.typed-array.map",
		  	"es.typed-array.of",
		  	"es.typed-array.reduce",
		  	"es.typed-array.reduce-right",
		  	"es.typed-array.reverse",
		  	"es.typed-array.set",
		  	"es.typed-array.slice",
		  	"es.typed-array.some",
		  	"es.typed-array.sort",
		  	"es.typed-array.subarray",
		  	"es.typed-array.to-locale-string",
		  	"es.typed-array.to-reversed",
		  	"es.typed-array.to-sorted",
		  	"es.typed-array.to-string",
		  	"es.typed-array.with",
		  	"es.unescape",
		  	"es.weak-map",
		  	"es.weak-set",
		  	"esnext.aggregate-error",
		  	"esnext.suppressed-error.constructor",
		  	"esnext.array.from-async",
		  	"esnext.array.at",
		  	"esnext.array.filter-out",
		  	"esnext.array.filter-reject",
		  	"esnext.array.find-last",
		  	"esnext.array.find-last-index",
		  	"esnext.array.group",
		  	"esnext.array.group-by",
		  	"esnext.array.group-by-to-map",
		  	"esnext.array.group-to-map",
		  	"esnext.array.is-template-object",
		  	"esnext.array.last-index",
		  	"esnext.array.last-item",
		  	"esnext.array.to-reversed",
		  	"esnext.array.to-sorted",
		  	"esnext.array.to-spliced",
		  	"esnext.array.unique-by",
		  	"esnext.array.with",
		  	"esnext.array-buffer.detached",
		  	"esnext.array-buffer.transfer",
		  	"esnext.array-buffer.transfer-to-fixed-length",
		  	"esnext.async-disposable-stack.constructor",
		  	"esnext.async-iterator.constructor",
		  	"esnext.async-iterator.as-indexed-pairs",
		  	"esnext.async-iterator.async-dispose",
		  	"esnext.async-iterator.drop",
		  	"esnext.async-iterator.every",
		  	"esnext.async-iterator.filter",
		  	"esnext.async-iterator.find",
		  	"esnext.async-iterator.flat-map",
		  	"esnext.async-iterator.for-each",
		  	"esnext.async-iterator.from",
		  	"esnext.async-iterator.indexed",
		  	"esnext.async-iterator.map",
		  	"esnext.async-iterator.reduce",
		  	"esnext.async-iterator.some",
		  	"esnext.async-iterator.take",
		  	"esnext.async-iterator.to-array",
		  	"esnext.bigint.range",
		  	"esnext.composite-key",
		  	"esnext.composite-symbol",
		  	"esnext.data-view.get-float16",
		  	"esnext.data-view.get-uint8-clamped",
		  	"esnext.data-view.set-float16",
		  	"esnext.data-view.set-uint8-clamped",
		  	"esnext.disposable-stack.constructor",
		  	"esnext.function.demethodize",
		  	"esnext.function.is-callable",
		  	"esnext.function.is-constructor",
		  	"esnext.function.metadata",
		  	"esnext.function.un-this",
		  	"esnext.global-this",
		  	"esnext.iterator.constructor",
		  	"esnext.iterator.as-indexed-pairs",
		  	"esnext.iterator.dispose",
		  	"esnext.iterator.drop",
		  	"esnext.iterator.every",
		  	"esnext.iterator.filter",
		  	"esnext.iterator.find",
		  	"esnext.iterator.flat-map",
		  	"esnext.iterator.for-each",
		  	"esnext.iterator.from",
		  	"esnext.iterator.indexed",
		  	"esnext.iterator.map",
		  	"esnext.iterator.range",
		  	"esnext.iterator.reduce",
		  	"esnext.iterator.some",
		  	"esnext.iterator.take",
		  	"esnext.iterator.to-array",
		  	"esnext.iterator.to-async",
		  	"esnext.json.is-raw-json",
		  	"esnext.json.parse",
		  	"esnext.json.raw-json",
		  	"esnext.map.delete-all",
		  	"esnext.map.emplace",
		  	"esnext.map.every",
		  	"esnext.map.filter",
		  	"esnext.map.find",
		  	"esnext.map.find-key",
		  	"esnext.map.from",
		  	"esnext.map.group-by",
		  	"esnext.map.includes",
		  	"esnext.map.key-by",
		  	"esnext.map.key-of",
		  	"esnext.map.map-keys",
		  	"esnext.map.map-values",
		  	"esnext.map.merge",
		  	"esnext.map.of",
		  	"esnext.map.reduce",
		  	"esnext.map.some",
		  	"esnext.map.update",
		  	"esnext.map.update-or-insert",
		  	"esnext.map.upsert",
		  	"esnext.math.clamp",
		  	"esnext.math.deg-per-rad",
		  	"esnext.math.degrees",
		  	"esnext.math.fscale",
		  	"esnext.math.f16round",
		  	"esnext.math.iaddh",
		  	"esnext.math.imulh",
		  	"esnext.math.isubh",
		  	"esnext.math.rad-per-deg",
		  	"esnext.math.radians",
		  	"esnext.math.scale",
		  	"esnext.math.seeded-prng",
		  	"esnext.math.signbit",
		  	"esnext.math.umulh",
		  	"esnext.number.from-string",
		  	"esnext.number.range",
		  	"esnext.object.has-own",
		  	"esnext.object.iterate-entries",
		  	"esnext.object.iterate-keys",
		  	"esnext.object.iterate-values",
		  	"esnext.object.group-by",
		  	"esnext.observable",
		  	"esnext.promise.all-settled",
		  	"esnext.promise.any",
		  	"esnext.promise.try",
		  	"esnext.promise.with-resolvers",
		  	"esnext.reflect.define-metadata",
		  	"esnext.reflect.delete-metadata",
		  	"esnext.reflect.get-metadata",
		  	"esnext.reflect.get-metadata-keys",
		  	"esnext.reflect.get-own-metadata",
		  	"esnext.reflect.get-own-metadata-keys",
		  	"esnext.reflect.has-metadata",
		  	"esnext.reflect.has-own-metadata",
		  	"esnext.reflect.metadata",
		  	"esnext.regexp.escape",
		  	"esnext.set.add-all",
		  	"esnext.set.delete-all",
		  	"esnext.set.difference.v2",
		  	"esnext.set.difference",
		  	"esnext.set.every",
		  	"esnext.set.filter",
		  	"esnext.set.find",
		  	"esnext.set.from",
		  	"esnext.set.intersection.v2",
		  	"esnext.set.intersection",
		  	"esnext.set.is-disjoint-from.v2",
		  	"esnext.set.is-disjoint-from",
		  	"esnext.set.is-subset-of.v2",
		  	"esnext.set.is-subset-of",
		  	"esnext.set.is-superset-of.v2",
		  	"esnext.set.is-superset-of",
		  	"esnext.set.join",
		  	"esnext.set.map",
		  	"esnext.set.of",
		  	"esnext.set.reduce",
		  	"esnext.set.some",
		  	"esnext.set.symmetric-difference.v2",
		  	"esnext.set.symmetric-difference",
		  	"esnext.set.union.v2",
		  	"esnext.set.union",
		  	"esnext.string.at",
		  	"esnext.string.cooked",
		  	"esnext.string.code-points",
		  	"esnext.string.dedent",
		  	"esnext.string.is-well-formed",
		  	"esnext.string.match-all",
		  	"esnext.string.replace-all",
		  	"esnext.string.to-well-formed",
		  	"esnext.symbol.async-dispose",
		  	"esnext.symbol.dispose",
		  	"esnext.symbol.is-registered-symbol",
		  	"esnext.symbol.is-registered",
		  	"esnext.symbol.is-well-known-symbol",
		  	"esnext.symbol.is-well-known",
		  	"esnext.symbol.matcher",
		  	"esnext.symbol.metadata",
		  	"esnext.symbol.metadata-key",
		  	"esnext.symbol.observable",
		  	"esnext.symbol.pattern-match",
		  	"esnext.symbol.replace-all",
		  	"esnext.typed-array.from-async",
		  	"esnext.typed-array.at",
		  	"esnext.typed-array.filter-out",
		  	"esnext.typed-array.filter-reject",
		  	"esnext.typed-array.find-last",
		  	"esnext.typed-array.find-last-index",
		  	"esnext.typed-array.group-by",
		  	"esnext.typed-array.to-reversed",
		  	"esnext.typed-array.to-sorted",
		  	"esnext.typed-array.to-spliced",
		  	"esnext.typed-array.unique-by",
		  	"esnext.typed-array.with",
		  	"esnext.uint8-array.from-base64",
		  	"esnext.uint8-array.from-hex",
		  	"esnext.uint8-array.to-base64",
		  	"esnext.uint8-array.to-hex",
		  	"esnext.weak-map.delete-all",
		  	"esnext.weak-map.from",
		  	"esnext.weak-map.of",
		  	"esnext.weak-map.emplace",
		  	"esnext.weak-map.upsert",
		  	"esnext.weak-set.add-all",
		  	"esnext.weak-set.delete-all",
		  	"esnext.weak-set.from",
		  	"esnext.weak-set.of",
		  	"web.atob",
		  	"web.btoa",
		  	"web.dom-collections.for-each",
		  	"web.dom-collections.iterator",
		  	"web.dom-exception.constructor",
		  	"web.dom-exception.stack",
		  	"web.dom-exception.to-string-tag",
		  	"web.immediate",
		  	"web.queue-microtask",
		  	"web.self",
		  	"web.structured-clone",
		  	"web.timers",
		  	"web.url",
		  	"web.url.can-parse",
		  	"web.url.to-json",
		  	"web.url-search-params",
		  	"web.url-search-params.delete",
		  	"web.url-search-params.has",
		  	"web.url-search-params.size"
		  ];

		  var compare = helpers$1.compare,
		    intersection$1 = helpers$1.intersection,
		    semver$2 = helpers$1.semver;
		  var modulesByVersions = require$$1;
		  var modules = require$$2;
		  var getModulesListForTargetVersion$2 = function getModulesListForTargetVersion(raw) {
		    var corejs = semver$2(raw);
		    if (corejs.major !== 3) {
		      throw new RangeError('This version of `core-js-compat` works only with `core-js@3`.');
		    }
		    var result = [];
		    for (var _i = 0, _Object$keys = Object.keys(modulesByVersions); _i < _Object$keys.length; _i++) {
		      var version = _Object$keys[_i];
		      if (compare(version, '<=', corejs)) {
		        result.push.apply(result, _toConsumableArray(modulesByVersions[version]));
		      }
		    }
		    return intersection$1(result, modules);
		  };

		  var getModulesListForTargetVersion$1;
		  var hasRequiredGetModulesListForTargetVersion;
		  function requireGetModulesListForTargetVersion() {
		    if (hasRequiredGetModulesListForTargetVersion) return getModulesListForTargetVersion$1;
		    hasRequiredGetModulesListForTargetVersion = 1;
		    getModulesListForTargetVersion$1 = getModulesListForTargetVersion$2;
		    return getModulesListForTargetVersion$1;
		  }

		  var builtInDefinitions$1 = {};

		  var hasRequiredBuiltInDefinitions$1;
		  function requireBuiltInDefinitions$1() {
		    var _InstanceProperties;
		    if (hasRequiredBuiltInDefinitions$1) return builtInDefinitions$1;
		    hasRequiredBuiltInDefinitions$1 = 1;
		    builtInDefinitions$1.__esModule = true;
		    builtInDefinitions$1.StaticProperties = builtInDefinitions$1.PromiseDependenciesWithIterators = builtInDefinitions$1.PromiseDependencies = builtInDefinitions$1.InstanceProperties = builtInDefinitions$1.DecoratorMetadataDependencies = builtInDefinitions$1.CommonIterators = builtInDefinitions$1.BuiltIns = void 0;
		    var _data = _interopRequireDefault(requireData());
		    function _interopRequireDefault(obj) {
		      return obj && obj.__esModule ? obj : {
		        "default": obj
		      };
		    }
		    function _extends() {
		      _extends = Object.assign ? Object.assign.bind() : function (target) {
		        for (var i = 1; i < arguments.length; i++) {
		          var source = arguments[i];
		          for (var key in source) {
		            if (Object.prototype.hasOwnProperty.call(source, key)) {
		              target[key] = source[key];
		            }
		          }
		        }
		        return target;
		      };
		      return _extends.apply(this, arguments);
		    }
		    var polyfillsOrder = {};
		    Object.keys(_data["default"]).forEach(function (name, index) {
		      polyfillsOrder[name] = index;
		    });
		    var define = function define(pure, global, name, exclude) {
		      if (name === void 0) {
		        name = global[0];
		      }
		      return {
		        name: name,
		        pure: pure,
		        global: global.sort(function (a, b) {
		          return polyfillsOrder[a] - polyfillsOrder[b];
		        }),
		        exclude: exclude
		      };
		    };
		    var typed = function typed() {
		      for (var _len = arguments.length, modules = new Array(_len), _key = 0; _key < _len; _key++) {
		        modules[_key] = arguments[_key];
		      }
		      return define(null, [].concat(modules, TypedArrayDependencies));
		    };
		    var ArrayNatureIterators = ["es.array.iterator", "web.dom-collections.iterator"];
		    var CommonIterators = ["es.string.iterator"].concat(ArrayNatureIterators);
		    builtInDefinitions$1.CommonIterators = CommonIterators;
		    var ArrayNatureIteratorsWithTag = ["es.object.to-string"].concat(ArrayNatureIterators);
		    var CommonIteratorsWithTag = ["es.object.to-string"].concat(_toConsumableArray(CommonIterators));
		    var ErrorDependencies = ["es.error.cause", "es.error.to-string"];
		    var SuppressedErrorDependencies = ["esnext.suppressed-error.constructor"].concat(ErrorDependencies);
		    var TypedArrayDependencies = ["es.typed-array.at", "es.typed-array.copy-within", "es.typed-array.every", "es.typed-array.fill", "es.typed-array.filter", "es.typed-array.find", "es.typed-array.find-index", "es.typed-array.find-last", "es.typed-array.find-last-index", "es.typed-array.for-each", "es.typed-array.includes", "es.typed-array.index-of", "es.typed-array.iterator", "es.typed-array.join", "es.typed-array.last-index-of", "es.typed-array.map", "es.typed-array.reduce", "es.typed-array.reduce-right", "es.typed-array.reverse", "es.typed-array.set", "es.typed-array.slice", "es.typed-array.some", "es.typed-array.sort", "es.typed-array.subarray", "es.typed-array.to-locale-string", "es.typed-array.to-reversed", "es.typed-array.to-sorted", "es.typed-array.to-string", "es.typed-array.with", "es.object.to-string", "es.array.iterator", "es.array-buffer.slice", "es.data-view", "es.array-buffer.detached", "es.array-buffer.transfer", "es.array-buffer.transfer-to-fixed-length", "esnext.typed-array.filter-reject", "esnext.typed-array.group-by", "esnext.typed-array.to-spliced", "esnext.typed-array.unique-by"];
		    var PromiseDependencies = ["es.promise", "es.object.to-string"];
		    builtInDefinitions$1.PromiseDependencies = PromiseDependencies;
		    var PromiseDependenciesWithIterators = [].concat(PromiseDependencies, _toConsumableArray(CommonIterators));
		    builtInDefinitions$1.PromiseDependenciesWithIterators = PromiseDependenciesWithIterators;
		    var SymbolDependencies = ["es.symbol", "es.symbol.description", "es.object.to-string"];
		    var MapDependencies = ["es.map", "esnext.map.delete-all", "esnext.map.emplace", "esnext.map.every", "esnext.map.filter", "esnext.map.find", "esnext.map.find-key", "esnext.map.includes", "esnext.map.key-of", "esnext.map.map-keys", "esnext.map.map-values", "esnext.map.merge", "esnext.map.reduce", "esnext.map.some", "esnext.map.update"].concat(_toConsumableArray(CommonIteratorsWithTag));
		    var SetDependencies = ["es.set", "esnext.set.add-all", "esnext.set.delete-all", "esnext.set.difference", "esnext.set.difference.v2", "esnext.set.every", "esnext.set.filter", "esnext.set.find", "esnext.set.intersection", "esnext.set.intersection.v2", "esnext.set.is-disjoint-from", "esnext.set.is-disjoint-from.v2", "esnext.set.is-subset-of", "esnext.set.is-subset-of.v2", "esnext.set.is-superset-of", "esnext.set.is-superset-of.v2", "esnext.set.join", "esnext.set.map", "esnext.set.reduce", "esnext.set.some", "esnext.set.symmetric-difference", "esnext.set.symmetric-difference.v2", "esnext.set.union", "esnext.set.union.v2"].concat(_toConsumableArray(CommonIteratorsWithTag));
		    var WeakMapDependencies = ["es.weak-map", "esnext.weak-map.delete-all", "esnext.weak-map.emplace"].concat(_toConsumableArray(CommonIteratorsWithTag));
		    var WeakSetDependencies = ["es.weak-set", "esnext.weak-set.add-all", "esnext.weak-set.delete-all"].concat(_toConsumableArray(CommonIteratorsWithTag));
		    var DOMExceptionDependencies = ["web.dom-exception.constructor", "web.dom-exception.stack", "web.dom-exception.to-string-tag", "es.error.to-string"];
		    var URLSearchParamsDependencies = ["web.url-search-params", "web.url-search-params.delete", "web.url-search-params.has", "web.url-search-params.size"].concat(_toConsumableArray(CommonIteratorsWithTag));
		    var AsyncIteratorDependencies = ["esnext.async-iterator.constructor"].concat(PromiseDependencies);
		    var AsyncIteratorProblemMethods = ["esnext.async-iterator.every", "esnext.async-iterator.filter", "esnext.async-iterator.find", "esnext.async-iterator.flat-map", "esnext.async-iterator.for-each", "esnext.async-iterator.map", "esnext.async-iterator.reduce", "esnext.async-iterator.some"];
		    var IteratorDependencies = ["esnext.iterator.constructor", "es.object.to-string"];
		    var DecoratorMetadataDependencies = ["esnext.symbol.metadata", "esnext.function.metadata"];
		    builtInDefinitions$1.DecoratorMetadataDependencies = DecoratorMetadataDependencies;
		    var TypedArrayStaticMethods = function TypedArrayStaticMethods(base) {
		      return {
		        from: define(null, ["es.typed-array.from", base].concat(TypedArrayDependencies)),
		        fromAsync: define(null, ["esnext.typed-array.from-async", base].concat(_toConsumableArray(PromiseDependenciesWithIterators), TypedArrayDependencies)),
		        of: define(null, ["es.typed-array.of", base].concat(TypedArrayDependencies))
		      };
		    };
		    var DataViewDependencies = ["es.data-view", "es.array-buffer.constructor", "es.array-buffer.slice", "es.array-buffer.detached", "es.array-buffer.transfer", "es.array-buffer.transfer-to-fixed-length", "es.object.to-string"];
		    var BuiltIns = {
		      AsyncDisposableStack: define("async-disposable-stack/index", ["esnext.async-disposable-stack.constructor", "es.object.to-string", "esnext.async-iterator.async-dispose", "esnext.iterator.dispose"].concat(PromiseDependencies, _toConsumableArray(SuppressedErrorDependencies))),
		      AsyncIterator: define("async-iterator/index", AsyncIteratorDependencies),
		      AggregateError: define("aggregate-error", ["es.aggregate-error"].concat(ErrorDependencies, _toConsumableArray(CommonIteratorsWithTag), ["es.aggregate-error.cause"])),
		      ArrayBuffer: define(null, ["es.array-buffer.constructor", "es.array-buffer.slice", "es.data-view", "es.array-buffer.detached", "es.array-buffer.transfer", "es.array-buffer.transfer-to-fixed-length", "es.object.to-string"]),
		      DataView: define(null, DataViewDependencies),
		      Date: define(null, ["es.date.to-string"]),
		      DOMException: define("dom-exception/index", DOMExceptionDependencies),
		      DisposableStack: define("disposable-stack/index", ["esnext.disposable-stack.constructor", "es.object.to-string", "esnext.iterator.dispose"].concat(_toConsumableArray(SuppressedErrorDependencies))),
		      Error: define(null, ErrorDependencies),
		      EvalError: define(null, ErrorDependencies),
		      Float32Array: typed("es.typed-array.float32-array"),
		      Float64Array: typed("es.typed-array.float64-array"),
		      Int8Array: typed("es.typed-array.int8-array"),
		      Int16Array: typed("es.typed-array.int16-array"),
		      Int32Array: typed("es.typed-array.int32-array"),
		      Iterator: define("iterator/index", IteratorDependencies),
		      Uint8Array: typed("es.typed-array.uint8-array", "esnext.uint8-array.to-base64", "esnext.uint8-array.to-hex"),
		      Uint8ClampedArray: typed("es.typed-array.uint8-clamped-array"),
		      Uint16Array: typed("es.typed-array.uint16-array"),
		      Uint32Array: typed("es.typed-array.uint32-array"),
		      Map: define("map/index", MapDependencies),
		      Number: define(null, ["es.number.constructor"]),
		      Observable: define("observable/index", ["esnext.observable", "esnext.symbol.observable", "es.object.to-string"].concat(_toConsumableArray(CommonIteratorsWithTag))),
		      Promise: define("promise/index", PromiseDependencies),
		      RangeError: define(null, ErrorDependencies),
		      ReferenceError: define(null, ErrorDependencies),
		      Reflect: define(null, ["es.reflect.to-string-tag", "es.object.to-string"]),
		      RegExp: define(null, ["es.regexp.constructor", "es.regexp.dot-all", "es.regexp.exec", "es.regexp.sticky", "es.regexp.to-string"]),
		      Set: define("set/index", SetDependencies),
		      SuppressedError: define("suppressed-error", SuppressedErrorDependencies),
		      Symbol: define("symbol/index", SymbolDependencies),
		      SyntaxError: define(null, ErrorDependencies),
		      TypeError: define(null, ErrorDependencies),
		      URIError: define(null, ErrorDependencies),
		      URL: define("url/index", ["web.url", "web.url.to-json"].concat(_toConsumableArray(URLSearchParamsDependencies))),
		      URLSearchParams: define("url-search-params/index", URLSearchParamsDependencies),
		      WeakMap: define("weak-map/index", WeakMapDependencies),
		      WeakSet: define("weak-set/index", WeakSetDependencies),
		      atob: define("atob", ["web.atob"].concat(DOMExceptionDependencies)),
		      btoa: define("btoa", ["web.btoa"].concat(DOMExceptionDependencies)),
		      clearImmediate: define("clear-immediate", ["web.immediate"]),
		      compositeKey: define("composite-key", ["esnext.composite-key"]),
		      compositeSymbol: define("composite-symbol", ["esnext.composite-symbol"]),
		      escape: define("escape", ["es.escape"]),
		      fetch: define(null, PromiseDependencies),
		      globalThis: define("global-this", ["es.global-this"]),
		      parseFloat: define("parse-float", ["es.parse-float"]),
		      parseInt: define("parse-int", ["es.parse-int"]),
		      queueMicrotask: define("queue-microtask", ["web.queue-microtask"]),
		      self: define("self", ["web.self"]),
		      setImmediate: define("set-immediate", ["web.immediate"]),
		      setInterval: define("set-interval", ["web.timers"]),
		      setTimeout: define("set-timeout", ["web.timers"]),
		      structuredClone: define("structured-clone", ["web.structured-clone"].concat(DOMExceptionDependencies, ["es.array.iterator", "es.object.keys", "es.object.to-string", "es.map", "es.set"])),
		      unescape: define("unescape", ["es.unescape"])
		    };
		    builtInDefinitions$1.BuiltIns = BuiltIns;
		    var StaticProperties = {
		      AsyncIterator: {
		        from: define("async-iterator/from", ["esnext.async-iterator.from"].concat(_toConsumableArray(AsyncIteratorDependencies), AsyncIteratorProblemMethods, _toConsumableArray(CommonIterators)))
		      },
		      Array: {
		        from: define("array/from", ["es.array.from", "es.string.iterator"]),
		        fromAsync: define("array/from-async", ["esnext.array.from-async"].concat(_toConsumableArray(PromiseDependenciesWithIterators))),
		        isArray: define("array/is-array", ["es.array.is-array"]),
		        isTemplateObject: define("array/is-template-object", ["esnext.array.is-template-object"]),
		        of: define("array/of", ["es.array.of"])
		      },
		      ArrayBuffer: {
		        isView: define(null, ["es.array-buffer.is-view"])
		      },
		      BigInt: {
		        range: define("bigint/range", ["esnext.bigint.range", "es.object.to-string"])
		      },
		      Date: {
		        now: define("date/now", ["es.date.now"])
		      },
		      Function: {
		        isCallable: define("function/is-callable", ["esnext.function.is-callable"]),
		        isConstructor: define("function/is-constructor", ["esnext.function.is-constructor"])
		      },
		      Iterator: {
		        from: define("iterator/from", ["esnext.iterator.from"].concat(IteratorDependencies, _toConsumableArray(CommonIterators))),
		        range: define("iterator/range", ["esnext.iterator.range", "es.object.to-string"])
		      },
		      JSON: {
		        isRawJSON: define("json/is-raw-json", ["esnext.json.is-raw-json"]),
		        parse: define("json/parse", ["esnext.json.parse", "es.object.keys"]),
		        rawJSON: define("json/raw-json", ["esnext.json.raw-json", "es.object.create", "es.object.freeze"]),
		        stringify: define("json/stringify", ["es.json.stringify", "es.date.to-json"], "es.symbol")
		      },
		      Math: {
		        DEG_PER_RAD: define("math/deg-per-rad", ["esnext.math.deg-per-rad"]),
		        RAD_PER_DEG: define("math/rad-per-deg", ["esnext.math.rad-per-deg"]),
		        acosh: define("math/acosh", ["es.math.acosh"]),
		        asinh: define("math/asinh", ["es.math.asinh"]),
		        atanh: define("math/atanh", ["es.math.atanh"]),
		        cbrt: define("math/cbrt", ["es.math.cbrt"]),
		        clamp: define("math/clamp", ["esnext.math.clamp"]),
		        clz32: define("math/clz32", ["es.math.clz32"]),
		        cosh: define("math/cosh", ["es.math.cosh"]),
		        degrees: define("math/degrees", ["esnext.math.degrees"]),
		        expm1: define("math/expm1", ["es.math.expm1"]),
		        fround: define("math/fround", ["es.math.fround"]),
		        f16round: define("math/f16round", ["esnext.math.f16round"]),
		        fscale: define("math/fscale", ["esnext.math.fscale"]),
		        hypot: define("math/hypot", ["es.math.hypot"]),
		        iaddh: define("math/iaddh", ["esnext.math.iaddh"]),
		        imul: define("math/imul", ["es.math.imul"]),
		        imulh: define("math/imulh", ["esnext.math.imulh"]),
		        isubh: define("math/isubh", ["esnext.math.isubh"]),
		        log10: define("math/log10", ["es.math.log10"]),
		        log1p: define("math/log1p", ["es.math.log1p"]),
		        log2: define("math/log2", ["es.math.log2"]),
		        radians: define("math/radians", ["esnext.math.radians"]),
		        scale: define("math/scale", ["esnext.math.scale"]),
		        seededPRNG: define("math/seeded-prng", ["esnext.math.seeded-prng"]),
		        sign: define("math/sign", ["es.math.sign"]),
		        signbit: define("math/signbit", ["esnext.math.signbit"]),
		        sinh: define("math/sinh", ["es.math.sinh"]),
		        tanh: define("math/tanh", ["es.math.tanh"]),
		        trunc: define("math/trunc", ["es.math.trunc"]),
		        umulh: define("math/umulh", ["esnext.math.umulh"])
		      },
		      Map: {
		        from: define(null, ["esnext.map.from"].concat(_toConsumableArray(MapDependencies))),
		        groupBy: define("map/group-by", ["es.map.group-by"].concat(_toConsumableArray(MapDependencies))),
		        keyBy: define("map/key-by", ["esnext.map.key-by"].concat(_toConsumableArray(MapDependencies))),
		        of: define(null, ["esnext.map.of"].concat(_toConsumableArray(MapDependencies)))
		      },
		      Number: {
		        EPSILON: define("number/epsilon", ["es.number.epsilon"]),
		        MAX_SAFE_INTEGER: define("number/max-safe-integer", ["es.number.max-safe-integer"]),
		        MIN_SAFE_INTEGER: define("number/min-safe-integer", ["es.number.min-safe-integer"]),
		        fromString: define("number/from-string", ["esnext.number.from-string"]),
		        isFinite: define("number/is-finite", ["es.number.is-finite"]),
		        isInteger: define("number/is-integer", ["es.number.is-integer"]),
		        isNaN: define("number/is-nan", ["es.number.is-nan"]),
		        isSafeInteger: define("number/is-safe-integer", ["es.number.is-safe-integer"]),
		        parseFloat: define("number/parse-float", ["es.number.parse-float"]),
		        parseInt: define("number/parse-int", ["es.number.parse-int"]),
		        range: define("number/range", ["esnext.number.range", "es.object.to-string"])
		      },
		      Object: {
		        assign: define("object/assign", ["es.object.assign"]),
		        create: define("object/create", ["es.object.create"]),
		        defineProperties: define("object/define-properties", ["es.object.define-properties"]),
		        defineProperty: define("object/define-property", ["es.object.define-property"]),
		        entries: define("object/entries", ["es.object.entries"]),
		        freeze: define("object/freeze", ["es.object.freeze"]),
		        fromEntries: define("object/from-entries", ["es.object.from-entries", "es.array.iterator"]),
		        getOwnPropertyDescriptor: define("object/get-own-property-descriptor", ["es.object.get-own-property-descriptor"]),
		        getOwnPropertyDescriptors: define("object/get-own-property-descriptors", ["es.object.get-own-property-descriptors"]),
		        getOwnPropertyNames: define("object/get-own-property-names", ["es.object.get-own-property-names"]),
		        getOwnPropertySymbols: define("object/get-own-property-symbols", ["es.symbol"]),
		        getPrototypeOf: define("object/get-prototype-of", ["es.object.get-prototype-of"]),
		        groupBy: define("object/group-by", ["es.object.group-by", "es.object.create"]),
		        hasOwn: define("object/has-own", ["es.object.has-own"]),
		        is: define("object/is", ["es.object.is"]),
		        isExtensible: define("object/is-extensible", ["es.object.is-extensible"]),
		        isFrozen: define("object/is-frozen", ["es.object.is-frozen"]),
		        isSealed: define("object/is-sealed", ["es.object.is-sealed"]),
		        keys: define("object/keys", ["es.object.keys"]),
		        preventExtensions: define("object/prevent-extensions", ["es.object.prevent-extensions"]),
		        seal: define("object/seal", ["es.object.seal"]),
		        setPrototypeOf: define("object/set-prototype-of", ["es.object.set-prototype-of"]),
		        values: define("object/values", ["es.object.values"])
		      },
		      Promise: {
		        all: define(null, PromiseDependenciesWithIterators),
		        allSettled: define("promise/all-settled", ["es.promise.all-settled"].concat(_toConsumableArray(PromiseDependenciesWithIterators))),
		        any: define("promise/any", ["es.promise.any", "es.aggregate-error"].concat(_toConsumableArray(PromiseDependenciesWithIterators))),
		        race: define(null, PromiseDependenciesWithIterators),
		        "try": define("promise/try", ["esnext.promise.try"].concat(PromiseDependencies)),
		        withResolvers: define("promise/with-resolvers", ["es.promise.with-resolvers"].concat(PromiseDependencies))
		      },
		      Reflect: {
		        apply: define("reflect/apply", ["es.reflect.apply"]),
		        construct: define("reflect/construct", ["es.reflect.construct"]),
		        defineMetadata: define("reflect/define-metadata", ["esnext.reflect.define-metadata"]),
		        defineProperty: define("reflect/define-property", ["es.reflect.define-property"]),
		        deleteMetadata: define("reflect/delete-metadata", ["esnext.reflect.delete-metadata"]),
		        deleteProperty: define("reflect/delete-property", ["es.reflect.delete-property"]),
		        get: define("reflect/get", ["es.reflect.get"]),
		        getMetadata: define("reflect/get-metadata", ["esnext.reflect.get-metadata"]),
		        getMetadataKeys: define("reflect/get-metadata-keys", ["esnext.reflect.get-metadata-keys"]),
		        getOwnMetadata: define("reflect/get-own-metadata", ["esnext.reflect.get-own-metadata"]),
		        getOwnMetadataKeys: define("reflect/get-own-metadata-keys", ["esnext.reflect.get-own-metadata-keys"]),
		        getOwnPropertyDescriptor: define("reflect/get-own-property-descriptor", ["es.reflect.get-own-property-descriptor"]),
		        getPrototypeOf: define("reflect/get-prototype-of", ["es.reflect.get-prototype-of"]),
		        has: define("reflect/has", ["es.reflect.has"]),
		        hasMetadata: define("reflect/has-metadata", ["esnext.reflect.has-metadata"]),
		        hasOwnMetadata: define("reflect/has-own-metadata", ["esnext.reflect.has-own-metadata"]),
		        isExtensible: define("reflect/is-extensible", ["es.reflect.is-extensible"]),
		        metadata: define("reflect/metadata", ["esnext.reflect.metadata"]),
		        ownKeys: define("reflect/own-keys", ["es.reflect.own-keys"]),
		        preventExtensions: define("reflect/prevent-extensions", ["es.reflect.prevent-extensions"]),
		        set: define("reflect/set", ["es.reflect.set"]),
		        setPrototypeOf: define("reflect/set-prototype-of", ["es.reflect.set-prototype-of"])
		      },
		      RegExp: {
		        escape: define("regexp/escape", ["esnext.regexp.escape"])
		      },
		      Set: {
		        from: define(null, ["esnext.set.from"].concat(_toConsumableArray(SetDependencies))),
		        of: define(null, ["esnext.set.of"].concat(_toConsumableArray(SetDependencies)))
		      },
		      String: {
		        cooked: define("string/cooked", ["esnext.string.cooked"]),
		        dedent: define("string/dedent", ["esnext.string.dedent", "es.string.from-code-point", "es.weak-map"]),
		        fromCodePoint: define("string/from-code-point", ["es.string.from-code-point"]),
		        raw: define("string/raw", ["es.string.raw"])
		      },
		      Symbol: {
		        asyncDispose: define("symbol/async-dispose", ["esnext.symbol.async-dispose", "esnext.async-iterator.async-dispose"]),
		        asyncIterator: define("symbol/async-iterator", ["es.symbol.async-iterator"]),
		        dispose: define("symbol/dispose", ["esnext.symbol.dispose", "esnext.iterator.dispose"]),
		        "for": define("symbol/for", [], "es.symbol"),
		        hasInstance: define("symbol/has-instance", ["es.symbol.has-instance", "es.function.has-instance"]),
		        isConcatSpreadable: define("symbol/is-concat-spreadable", ["es.symbol.is-concat-spreadable", "es.array.concat"]),
		        isRegistered: define("symbol/is-registered", ["esnext.symbol.is-registered", "es.symbol"]),
		        isRegisteredSymbol: define("symbol/is-registered-symbol", ["esnext.symbol.is-registered-symbol", "es.symbol"]),
		        isWellKnown: define("symbol/is-well-known", ["esnext.symbol.is-well-known", "es.symbol"]),
		        isWellKnownSymbol: define("symbol/is-well-known-symbol", ["esnext.symbol.is-well-known-symbol", "es.symbol"]),
		        iterator: define("symbol/iterator", ["es.symbol.iterator"].concat(_toConsumableArray(CommonIteratorsWithTag))),
		        keyFor: define("symbol/key-for", [], "es.symbol"),
		        match: define("symbol/match", ["es.symbol.match", "es.string.match"]),
		        matcher: define("symbol/matcher", ["esnext.symbol.matcher"]),
		        matchAll: define("symbol/match-all", ["es.symbol.match-all", "es.string.match-all"]),
		        metadata: define("symbol/metadata", DecoratorMetadataDependencies),
		        metadataKey: define("symbol/metadata-key", ["esnext.symbol.metadata-key"]),
		        observable: define("symbol/observable", ["esnext.symbol.observable"]),
		        patternMatch: define("symbol/pattern-match", ["esnext.symbol.pattern-match"]),
		        replace: define("symbol/replace", ["es.symbol.replace", "es.string.replace"]),
		        search: define("symbol/search", ["es.symbol.search", "es.string.search"]),
		        species: define("symbol/species", ["es.symbol.species", "es.array.species"]),
		        split: define("symbol/split", ["es.symbol.split", "es.string.split"]),
		        toPrimitive: define("symbol/to-primitive", ["es.symbol.to-primitive", "es.date.to-primitive"]),
		        toStringTag: define("symbol/to-string-tag", ["es.symbol.to-string-tag", "es.object.to-string", "es.math.to-string-tag", "es.json.to-string-tag"]),
		        unscopables: define("symbol/unscopables", ["es.symbol.unscopables"])
		      },
		      URL: {
		        canParse: define("url/can-parse", ["web.url.can-parse", "web.url"])
		      },
		      WeakMap: {
		        from: define(null, ["esnext.weak-map.from"].concat(_toConsumableArray(WeakMapDependencies))),
		        of: define(null, ["esnext.weak-map.of"].concat(_toConsumableArray(WeakMapDependencies)))
		      },
		      WeakSet: {
		        from: define(null, ["esnext.weak-set.from"].concat(_toConsumableArray(WeakSetDependencies))),
		        of: define(null, ["esnext.weak-set.of"].concat(_toConsumableArray(WeakSetDependencies)))
		      },
		      Int8Array: TypedArrayStaticMethods("es.typed-array.int8-array"),
		      Uint8Array: _extends({
		        fromBase64: define(null, ["esnext.uint8-array.from-base64"].concat(TypedArrayDependencies)),
		        fromHex: define(null, ["esnext.uint8-array.from-hex"].concat(TypedArrayDependencies))
		      }, TypedArrayStaticMethods("es.typed-array.uint8-array")),
		      Uint8ClampedArray: TypedArrayStaticMethods("es.typed-array.uint8-clamped-array"),
		      Int16Array: TypedArrayStaticMethods("es.typed-array.int16-array"),
		      Uint16Array: TypedArrayStaticMethods("es.typed-array.uint16-array"),
		      Int32Array: TypedArrayStaticMethods("es.typed-array.int32-array"),
		      Uint32Array: TypedArrayStaticMethods("es.typed-array.uint32-array"),
		      Float32Array: TypedArrayStaticMethods("es.typed-array.float32-array"),
		      Float64Array: TypedArrayStaticMethods("es.typed-array.float64-array"),
		      WebAssembly: {
		        CompileError: define(null, ErrorDependencies),
		        LinkError: define(null, ErrorDependencies),
		        RuntimeError: define(null, ErrorDependencies)
		      }
		    };
		    builtInDefinitions$1.StaticProperties = StaticProperties;
		    var InstanceProperties = (_InstanceProperties = {
		      asIndexedPairs: define("instance/asIndexedPairs", ["esnext.async-iterator.as-indexed-pairs"].concat(_toConsumableArray(AsyncIteratorDependencies), ["esnext.iterator.as-indexed-pairs"], IteratorDependencies)),
		      at: define("instance/at", ["esnext.string.at", "es.string.at-alternative", "es.array.at"]),
		      anchor: define(null, ["es.string.anchor"]),
		      big: define(null, ["es.string.big"]),
		      bind: define("instance/bind", ["es.function.bind"]),
		      blink: define(null, ["es.string.blink"]),
		      bold: define(null, ["es.string.bold"]),
		      codePointAt: define("instance/code-point-at", ["es.string.code-point-at"]),
		      codePoints: define("instance/code-points", ["esnext.string.code-points"]),
		      concat: define("instance/concat", ["es.array.concat"], undefined, ["String"]),
		      copyWithin: define("instance/copy-within", ["es.array.copy-within"]),
		      demethodize: define("instance/demethodize", ["esnext.function.demethodize"]),
		      description: define(null, ["es.symbol", "es.symbol.description"]),
		      dotAll: define(null, ["es.regexp.dot-all"]),
		      drop: define(null, ["esnext.async-iterator.drop"].concat(_toConsumableArray(AsyncIteratorDependencies), ["esnext.iterator.drop"], IteratorDependencies)),
		      emplace: define("instance/emplace", ["esnext.map.emplace", "esnext.weak-map.emplace"]),
		      endsWith: define("instance/ends-with", ["es.string.ends-with"]),
		      entries: define("instance/entries", ArrayNatureIteratorsWithTag),
		      every: define("instance/every", ["es.array.every", "esnext.async-iterator.every", "esnext.iterator.every"].concat(IteratorDependencies)),
		      exec: define(null, ["es.regexp.exec"]),
		      fill: define("instance/fill", ["es.array.fill"]),
		      filter: define("instance/filter", ["es.array.filter", "esnext.async-iterator.filter", "esnext.iterator.filter"].concat(IteratorDependencies)),
		      filterReject: define("instance/filterReject", ["esnext.array.filter-reject"]),
		      "finally": define(null, ["es.promise.finally"].concat(PromiseDependencies)),
		      find: define("instance/find", ["es.array.find", "esnext.async-iterator.find", "esnext.iterator.find"].concat(IteratorDependencies)),
		      findIndex: define("instance/find-index", ["es.array.find-index"]),
		      findLast: define("instance/find-last", ["es.array.find-last"]),
		      findLastIndex: define("instance/find-last-index", ["es.array.find-last-index"]),
		      fixed: define(null, ["es.string.fixed"]),
		      flags: define("instance/flags", ["es.regexp.flags"]),
		      flatMap: define("instance/flat-map", ["es.array.flat-map", "es.array.unscopables.flat-map", "esnext.async-iterator.flat-map", "esnext.iterator.flat-map"].concat(IteratorDependencies)),
		      flat: define("instance/flat", ["es.array.flat", "es.array.unscopables.flat"]),
		      getFloat16: define(null, ["esnext.data-view.get-float16"].concat(DataViewDependencies)),
		      getUint8Clamped: define(null, ["esnext.data-view.get-uint8-clamped"].concat(DataViewDependencies)),
		      getYear: define(null, ["es.date.get-year"]),
		      group: define("instance/group", ["esnext.array.group"]),
		      groupBy: define("instance/group-by", ["esnext.array.group-by"]),
		      groupByToMap: define("instance/group-by-to-map", ["esnext.array.group-by-to-map", "es.map", "es.object.to-string"]),
		      groupToMap: define("instance/group-to-map", ["esnext.array.group-to-map", "es.map", "es.object.to-string"]),
		      fontcolor: define(null, ["es.string.fontcolor"]),
		      fontsize: define(null, ["es.string.fontsize"]),
		      forEach: define("instance/for-each", ["es.array.for-each", "esnext.async-iterator.for-each", "esnext.iterator.for-each"].concat(IteratorDependencies, ["web.dom-collections.for-each"])),
		      includes: define("instance/includes", ["es.array.includes", "es.string.includes"]),
		      indexed: define(null, ["esnext.async-iterator.indexed"].concat(_toConsumableArray(AsyncIteratorDependencies), ["esnext.iterator.indexed"], IteratorDependencies)),
		      indexOf: define("instance/index-of", ["es.array.index-of"]),
		      isWellFormed: define("instance/is-well-formed", ["es.string.is-well-formed"]),
		      italic: define(null, ["es.string.italics"]),
		      join: define(null, ["es.array.join"]),
		      keys: define("instance/keys", ArrayNatureIteratorsWithTag),
		      lastIndex: define(null, ["esnext.array.last-index"]),
		      lastIndexOf: define("instance/last-index-of", ["es.array.last-index-of"]),
		      lastItem: define(null, ["esnext.array.last-item"]),
		      link: define(null, ["es.string.link"]),
		      map: define("instance/map", ["es.array.map", "esnext.async-iterator.map", "esnext.iterator.map"]),
		      match: define(null, ["es.string.match", "es.regexp.exec"]),
		      matchAll: define("instance/match-all", ["es.string.match-all", "es.regexp.exec"]),
		      name: define(null, ["es.function.name"]),
		      padEnd: define("instance/pad-end", ["es.string.pad-end"]),
		      padStart: define("instance/pad-start", ["es.string.pad-start"]),
		      push: define("instance/push", ["es.array.push"]),
		      reduce: define("instance/reduce", ["es.array.reduce", "esnext.async-iterator.reduce", "esnext.iterator.reduce"].concat(IteratorDependencies)),
		      reduceRight: define("instance/reduce-right", ["es.array.reduce-right"]),
		      repeat: define("instance/repeat", ["es.string.repeat"]),
		      replace: define(null, ["es.string.replace", "es.regexp.exec"]),
		      replaceAll: define("instance/replace-all", ["es.string.replace-all", "es.string.replace", "es.regexp.exec"]),
		      reverse: define("instance/reverse", ["es.array.reverse"]),
		      search: define(null, ["es.string.search", "es.regexp.exec"]),
		      setFloat16: define(null, ["esnext.data-view.set-float16"].concat(DataViewDependencies)),
		      setUint8Clamped: define(null, ["esnext.data-view.set-uint8-clamped"].concat(DataViewDependencies)),
		      setYear: define(null, ["es.date.set-year"]),
		      slice: define("instance/slice", ["es.array.slice"]),
		      small: define(null, ["es.string.small"]),
		      some: define("instance/some", ["es.array.some", "esnext.async-iterator.some", "esnext.iterator.some"].concat(IteratorDependencies)),
		      sort: define("instance/sort", ["es.array.sort"]),
		      splice: define("instance/splice", ["es.array.splice"]),
		      split: define(null, ["es.string.split", "es.regexp.exec"]),
		      startsWith: define("instance/starts-with", ["es.string.starts-with"]),
		      sticky: define(null, ["es.regexp.sticky"]),
		      strike: define(null, ["es.string.strike"]),
		      sub: define(null, ["es.string.sub"]),
		      substr: define(null, ["es.string.substr"]),
		      sup: define(null, ["es.string.sup"]),
		      take: define(null, ["esnext.async-iterator.take"].concat(_toConsumableArray(AsyncIteratorDependencies), ["esnext.iterator.take"], IteratorDependencies)),
		      test: define(null, ["es.regexp.test", "es.regexp.exec"]),
		      toArray: define(null, ["esnext.async-iterator.to-array"].concat(_toConsumableArray(AsyncIteratorDependencies), ["esnext.iterator.to-array"], IteratorDependencies)),
		      toAsync: define(null, ["esnext.iterator.to-async"].concat(IteratorDependencies, _toConsumableArray(AsyncIteratorDependencies), AsyncIteratorProblemMethods)),
		      toExponential: define(null, ["es.number.to-exponential"]),
		      toFixed: define(null, ["es.number.to-fixed"]),
		      toGMTString: define(null, ["es.date.to-gmt-string"]),
		      toISOString: define(null, ["es.date.to-iso-string"]),
		      toJSON: define(null, ["es.date.to-json"]),
		      toPrecision: define(null, ["es.number.to-precision"]),
		      toReversed: define("instance/to-reversed", ["es.array.to-reversed"]),
		      toSorted: define("instance/to-sorted", ["es.array.to-sorted", "es.array.sort"]),
		      toSpliced: define("instance/to-spliced", ["es.array.to-spliced"]),
		      toString: define(null, ["es.object.to-string", "es.error.to-string", "es.date.to-string", "es.regexp.to-string"]),
		      toWellFormed: define("instance/to-well-formed", ["es.string.to-well-formed"]),
		      trim: define("instance/trim", ["es.string.trim"]),
		      trimEnd: define("instance/trim-end", ["es.string.trim-end"]),
		      trimLeft: define("instance/trim-left", ["es.string.trim-start"]),
		      trimRight: define("instance/trim-right", ["es.string.trim-end"]),
		      trimStart: define("instance/trim-start", ["es.string.trim-start"]),
		      uniqueBy: define("instance/unique-by", ["esnext.array.unique-by", "es.map"]),
		      unshift: define("instance/unshift", ["es.array.unshift"]),
		      unThis: define("instance/un-this", ["esnext.function.un-this"]),
		      values: define("instance/values", ArrayNatureIteratorsWithTag),
		      "with": define("instance/with", ["es.array.with"]),
		      __defineGetter__: define(null, ["es.object.define-getter"]),
		      __defineSetter__: define(null, ["es.object.define-setter"]),
		      __lookupGetter__: define(null, ["es.object.lookup-getter"]),
		      __lookupSetter__: define(null, ["es.object.lookup-setter"])
		    }, _InstanceProperties["__proto__"] = define(null, ["es.object.proto"]), _InstanceProperties);
		    builtInDefinitions$1.InstanceProperties = InstanceProperties;
		    return builtInDefinitions$1;
		  }

		  var babelRuntimeCorejs3Paths = {};

		  var hasRequiredBabelRuntimeCorejs3Paths;
		  function requireBabelRuntimeCorejs3Paths() {
		    if (hasRequiredBabelRuntimeCorejs3Paths) return babelRuntimeCorejs3Paths;
		    hasRequiredBabelRuntimeCorejs3Paths = 1;
		    babelRuntimeCorejs3Paths.__esModule = true;
		    babelRuntimeCorejs3Paths.stable = babelRuntimeCorejs3Paths.proposals = void 0;
		    var stable = new Set(["array", "array/from", "array/is-array", "array/of", "clear-immediate", "date/now", "instance/bind", "instance/code-point-at", "instance/concat", "instance/copy-within", "instance/ends-with", "instance/entries", "instance/every", "instance/fill", "instance/filter", "instance/find", "instance/find-index", "instance/flags", "instance/flat", "instance/flat-map", "instance/for-each", "instance/includes", "instance/index-of", "instance/keys", "instance/last-index-of", "instance/map", "instance/pad-end", "instance/pad-start", "instance/reduce", "instance/reduce-right", "instance/repeat", "instance/reverse", "instance/slice", "instance/some", "instance/sort", "instance/splice", "instance/starts-with", "instance/trim", "instance/trim-end", "instance/trim-left", "instance/trim-right", "instance/trim-start", "instance/values", "json/stringify", "map", "math/acosh", "math/asinh", "math/atanh", "math/cbrt", "math/clz32", "math/cosh", "math/expm1", "math/fround", "math/hypot", "math/imul", "math/log10", "math/log1p", "math/log2", "math/sign", "math/sinh", "math/tanh", "math/trunc", "number/epsilon", "number/is-finite", "number/is-integer", "number/is-nan", "number/is-safe-integer", "number/max-safe-integer", "number/min-safe-integer", "number/parse-float", "number/parse-int", "object/assign", "object/create", "object/define-properties", "object/define-property", "object/entries", "object/freeze", "object/from-entries", "object/get-own-property-descriptor", "object/get-own-property-descriptors", "object/get-own-property-names", "object/get-own-property-symbols", "object/get-prototype-of", "object/is", "object/is-extensible", "object/is-frozen", "object/is-sealed", "object/keys", "object/prevent-extensions", "object/seal", "object/set-prototype-of", "object/values", "parse-float", "parse-int", "promise", "queue-microtask", "reflect/apply", "reflect/construct", "reflect/define-property", "reflect/delete-property", "reflect/get", "reflect/get-own-property-descriptor", "reflect/get-prototype-of", "reflect/has", "reflect/is-extensible", "reflect/own-keys", "reflect/prevent-extensions", "reflect/set", "reflect/set-prototype-of", "set", "set-immediate", "set-interval", "set-timeout", "string/from-code-point", "string/raw", "symbol", "symbol/async-iterator", "symbol/for", "symbol/has-instance", "symbol/is-concat-spreadable", "symbol/iterator", "symbol/key-for", "symbol/match", "symbol/replace", "symbol/search", "symbol/species", "symbol/split", "symbol/to-primitive", "symbol/to-string-tag", "symbol/unscopables", "url", "url-search-params", "weak-map", "weak-set"]);
		    babelRuntimeCorejs3Paths.stable = stable;
		    var proposals = new Set([].concat(_toConsumableArray(stable), ["aggregate-error", "composite-key", "composite-symbol", "global-this", "instance/at", "instance/code-points", "instance/match-all", "instance/replace-all", "math/clamp", "math/degrees", "math/deg-per-rad", "math/fscale", "math/iaddh", "math/imulh", "math/isubh", "math/rad-per-deg", "math/radians", "math/scale", "math/seeded-prng", "math/signbit", "math/umulh", "number/from-string", "observable", "reflect/define-metadata", "reflect/delete-metadata", "reflect/get-metadata", "reflect/get-metadata-keys", "reflect/get-own-metadata", "reflect/get-own-metadata-keys", "reflect/has-metadata", "reflect/has-own-metadata", "reflect/metadata", "symbol/dispose", "symbol/observable", "symbol/pattern-match"]));
		    babelRuntimeCorejs3Paths.proposals = proposals;
		    return babelRuntimeCorejs3Paths;
		  }

		  var usageFilters = {};

		  var hasRequiredUsageFilters;
		  function requireUsageFilters() {
		    if (hasRequiredUsageFilters) return usageFilters;
		    hasRequiredUsageFilters = 1;
		    usageFilters.__esModule = true;
		    usageFilters["default"] = canSkipPolyfill;
		    var _babel = _interopRequireWildcard(require$$5);
		    function _getRequireWildcardCache(nodeInterop) {
		      if (typeof WeakMap !== "function") return null;
		      var cacheBabelInterop = new WeakMap();
		      var cacheNodeInterop = new WeakMap();
		      return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) {
		        return nodeInterop ? cacheNodeInterop : cacheBabelInterop;
		      })(nodeInterop);
		    }
		    function _interopRequireWildcard(obj, nodeInterop) {
		      if (!nodeInterop && obj && obj.__esModule) {
		        return obj;
		      }
		      if (obj === null || typeof obj !== "object" && typeof obj !== "function") {
		        return {
		          "default": obj
		        };
		      }
		      var cache = _getRequireWildcardCache(nodeInterop);
		      if (cache && cache.has(obj)) {
		        return cache.get(obj);
		      }
		      var newObj = {};
		      var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
		      for (var key in obj) {
		        if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) {
		          var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
		          if (desc && (desc.get || desc.set)) {
		            Object.defineProperty(newObj, key, desc);
		          } else {
		            newObj[key] = obj[key];
		          }
		        }
		      }
		      newObj["default"] = obj;
		      if (cache) {
		        cache.set(obj, newObj);
		      }
		      return newObj;
		    }
		    var _ref = _babel["default"] || _babel,
		      t = _ref.types;
		    function canSkipPolyfill(desc, path) {
		      var node = path.node,
		        parent = path.parent;
		      switch (desc.name) {
		        case "es.string.split":
		          {
		            if (!t.isCallExpression(parent, {
		              callee: node
		            })) return false;
		            if (parent.arguments.length < 1) return true;
		            var splitter = parent.arguments[0];
		            return t.isStringLiteral(splitter) || t.isTemplateLiteral(splitter);
		          }
		      }
		    }
		    return usageFilters;
		  }

		  var utils$2 = {};

		  var require$$0$2 = {
		  	"core-js": [
		  	"es.symbol",
		  	"es.symbol.description",
		  	"es.symbol.async-iterator",
		  	"es.symbol.has-instance",
		  	"es.symbol.is-concat-spreadable",
		  	"es.symbol.iterator",
		  	"es.symbol.match",
		  	"es.symbol.match-all",
		  	"es.symbol.replace",
		  	"es.symbol.search",
		  	"es.symbol.species",
		  	"es.symbol.split",
		  	"es.symbol.to-primitive",
		  	"es.symbol.to-string-tag",
		  	"es.symbol.unscopables",
		  	"es.error.cause",
		  	"es.error.to-string",
		  	"es.aggregate-error",
		  	"es.aggregate-error.cause",
		  	"es.array.at",
		  	"es.array.concat",
		  	"es.array.copy-within",
		  	"es.array.every",
		  	"es.array.fill",
		  	"es.array.filter",
		  	"es.array.find",
		  	"es.array.find-index",
		  	"es.array.find-last",
		  	"es.array.find-last-index",
		  	"es.array.flat",
		  	"es.array.flat-map",
		  	"es.array.for-each",
		  	"es.array.from",
		  	"es.array.includes",
		  	"es.array.index-of",
		  	"es.array.is-array",
		  	"es.array.iterator",
		  	"es.array.join",
		  	"es.array.last-index-of",
		  	"es.array.map",
		  	"es.array.of",
		  	"es.array.push",
		  	"es.array.reduce",
		  	"es.array.reduce-right",
		  	"es.array.reverse",
		  	"es.array.slice",
		  	"es.array.some",
		  	"es.array.sort",
		  	"es.array.species",
		  	"es.array.splice",
		  	"es.array.to-reversed",
		  	"es.array.to-sorted",
		  	"es.array.to-spliced",
		  	"es.array.unscopables.flat",
		  	"es.array.unscopables.flat-map",
		  	"es.array.unshift",
		  	"es.array.with",
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.is-view",
		  	"es.array-buffer.slice",
		  	"es.data-view",
		  	"es.array-buffer.detached",
		  	"es.array-buffer.transfer",
		  	"es.array-buffer.transfer-to-fixed-length",
		  	"es.date.get-year",
		  	"es.date.now",
		  	"es.date.set-year",
		  	"es.date.to-gmt-string",
		  	"es.date.to-iso-string",
		  	"es.date.to-json",
		  	"es.date.to-primitive",
		  	"es.date.to-string",
		  	"es.escape",
		  	"es.function.bind",
		  	"es.function.has-instance",
		  	"es.function.name",
		  	"es.global-this",
		  	"es.json.stringify",
		  	"es.json.to-string-tag",
		  	"es.map",
		  	"es.map.group-by",
		  	"es.math.acosh",
		  	"es.math.asinh",
		  	"es.math.atanh",
		  	"es.math.cbrt",
		  	"es.math.clz32",
		  	"es.math.cosh",
		  	"es.math.expm1",
		  	"es.math.fround",
		  	"es.math.hypot",
		  	"es.math.imul",
		  	"es.math.log10",
		  	"es.math.log1p",
		  	"es.math.log2",
		  	"es.math.sign",
		  	"es.math.sinh",
		  	"es.math.tanh",
		  	"es.math.to-string-tag",
		  	"es.math.trunc",
		  	"es.number.constructor",
		  	"es.number.epsilon",
		  	"es.number.is-finite",
		  	"es.number.is-integer",
		  	"es.number.is-nan",
		  	"es.number.is-safe-integer",
		  	"es.number.max-safe-integer",
		  	"es.number.min-safe-integer",
		  	"es.number.parse-float",
		  	"es.number.parse-int",
		  	"es.number.to-exponential",
		  	"es.number.to-fixed",
		  	"es.number.to-precision",
		  	"es.object.assign",
		  	"es.object.create",
		  	"es.object.define-getter",
		  	"es.object.define-properties",
		  	"es.object.define-property",
		  	"es.object.define-setter",
		  	"es.object.entries",
		  	"es.object.freeze",
		  	"es.object.from-entries",
		  	"es.object.get-own-property-descriptor",
		  	"es.object.get-own-property-descriptors",
		  	"es.object.get-own-property-names",
		  	"es.object.get-prototype-of",
		  	"es.object.group-by",
		  	"es.object.has-own",
		  	"es.object.is",
		  	"es.object.is-extensible",
		  	"es.object.is-frozen",
		  	"es.object.is-sealed",
		  	"es.object.keys",
		  	"es.object.lookup-getter",
		  	"es.object.lookup-setter",
		  	"es.object.prevent-extensions",
		  	"es.object.proto",
		  	"es.object.seal",
		  	"es.object.set-prototype-of",
		  	"es.object.to-string",
		  	"es.object.values",
		  	"es.parse-float",
		  	"es.parse-int",
		  	"es.promise",
		  	"es.promise.all-settled",
		  	"es.promise.any",
		  	"es.promise.finally",
		  	"es.promise.with-resolvers",
		  	"es.reflect.apply",
		  	"es.reflect.construct",
		  	"es.reflect.define-property",
		  	"es.reflect.delete-property",
		  	"es.reflect.get",
		  	"es.reflect.get-own-property-descriptor",
		  	"es.reflect.get-prototype-of",
		  	"es.reflect.has",
		  	"es.reflect.is-extensible",
		  	"es.reflect.own-keys",
		  	"es.reflect.prevent-extensions",
		  	"es.reflect.set",
		  	"es.reflect.set-prototype-of",
		  	"es.reflect.to-string-tag",
		  	"es.regexp.constructor",
		  	"es.regexp.dot-all",
		  	"es.regexp.exec",
		  	"es.regexp.flags",
		  	"es.regexp.sticky",
		  	"es.regexp.test",
		  	"es.regexp.to-string",
		  	"es.set",
		  	"es.string.at-alternative",
		  	"es.string.code-point-at",
		  	"es.string.ends-with",
		  	"es.string.from-code-point",
		  	"es.string.includes",
		  	"es.string.is-well-formed",
		  	"es.string.iterator",
		  	"es.string.match",
		  	"es.string.match-all",
		  	"es.string.pad-end",
		  	"es.string.pad-start",
		  	"es.string.raw",
		  	"es.string.repeat",
		  	"es.string.replace",
		  	"es.string.replace-all",
		  	"es.string.search",
		  	"es.string.split",
		  	"es.string.starts-with",
		  	"es.string.substr",
		  	"es.string.to-well-formed",
		  	"es.string.trim",
		  	"es.string.trim-end",
		  	"es.string.trim-start",
		  	"es.string.anchor",
		  	"es.string.big",
		  	"es.string.blink",
		  	"es.string.bold",
		  	"es.string.fixed",
		  	"es.string.fontcolor",
		  	"es.string.fontsize",
		  	"es.string.italics",
		  	"es.string.link",
		  	"es.string.small",
		  	"es.string.strike",
		  	"es.string.sub",
		  	"es.string.sup",
		  	"es.typed-array.float32-array",
		  	"es.typed-array.float64-array",
		  	"es.typed-array.int8-array",
		  	"es.typed-array.int16-array",
		  	"es.typed-array.int32-array",
		  	"es.typed-array.uint8-array",
		  	"es.typed-array.uint8-clamped-array",
		  	"es.typed-array.uint16-array",
		  	"es.typed-array.uint32-array",
		  	"es.typed-array.at",
		  	"es.typed-array.copy-within",
		  	"es.typed-array.every",
		  	"es.typed-array.fill",
		  	"es.typed-array.filter",
		  	"es.typed-array.find",
		  	"es.typed-array.find-index",
		  	"es.typed-array.find-last",
		  	"es.typed-array.find-last-index",
		  	"es.typed-array.for-each",
		  	"es.typed-array.from",
		  	"es.typed-array.includes",
		  	"es.typed-array.index-of",
		  	"es.typed-array.iterator",
		  	"es.typed-array.join",
		  	"es.typed-array.last-index-of",
		  	"es.typed-array.map",
		  	"es.typed-array.of",
		  	"es.typed-array.reduce",
		  	"es.typed-array.reduce-right",
		  	"es.typed-array.reverse",
		  	"es.typed-array.set",
		  	"es.typed-array.slice",
		  	"es.typed-array.some",
		  	"es.typed-array.sort",
		  	"es.typed-array.subarray",
		  	"es.typed-array.to-locale-string",
		  	"es.typed-array.to-reversed",
		  	"es.typed-array.to-sorted",
		  	"es.typed-array.to-string",
		  	"es.typed-array.with",
		  	"es.unescape",
		  	"es.weak-map",
		  	"es.weak-set",
		  	"esnext.aggregate-error",
		  	"esnext.suppressed-error.constructor",
		  	"esnext.array.from-async",
		  	"esnext.array.at",
		  	"esnext.array.filter-out",
		  	"esnext.array.filter-reject",
		  	"esnext.array.find-last",
		  	"esnext.array.find-last-index",
		  	"esnext.array.group",
		  	"esnext.array.group-by",
		  	"esnext.array.group-by-to-map",
		  	"esnext.array.group-to-map",
		  	"esnext.array.is-template-object",
		  	"esnext.array.last-index",
		  	"esnext.array.last-item",
		  	"esnext.array.to-reversed",
		  	"esnext.array.to-sorted",
		  	"esnext.array.to-spliced",
		  	"esnext.array.unique-by",
		  	"esnext.array.with",
		  	"esnext.array-buffer.detached",
		  	"esnext.array-buffer.transfer",
		  	"esnext.array-buffer.transfer-to-fixed-length",
		  	"esnext.async-disposable-stack.constructor",
		  	"esnext.async-iterator.constructor",
		  	"esnext.async-iterator.as-indexed-pairs",
		  	"esnext.async-iterator.async-dispose",
		  	"esnext.async-iterator.drop",
		  	"esnext.async-iterator.every",
		  	"esnext.async-iterator.filter",
		  	"esnext.async-iterator.find",
		  	"esnext.async-iterator.flat-map",
		  	"esnext.async-iterator.for-each",
		  	"esnext.async-iterator.from",
		  	"esnext.async-iterator.indexed",
		  	"esnext.async-iterator.map",
		  	"esnext.async-iterator.reduce",
		  	"esnext.async-iterator.some",
		  	"esnext.async-iterator.take",
		  	"esnext.async-iterator.to-array",
		  	"esnext.bigint.range",
		  	"esnext.composite-key",
		  	"esnext.composite-symbol",
		  	"esnext.data-view.get-float16",
		  	"esnext.data-view.get-uint8-clamped",
		  	"esnext.data-view.set-float16",
		  	"esnext.data-view.set-uint8-clamped",
		  	"esnext.disposable-stack.constructor",
		  	"esnext.function.demethodize",
		  	"esnext.function.is-callable",
		  	"esnext.function.is-constructor",
		  	"esnext.function.metadata",
		  	"esnext.function.un-this",
		  	"esnext.global-this",
		  	"esnext.iterator.constructor",
		  	"esnext.iterator.as-indexed-pairs",
		  	"esnext.iterator.dispose",
		  	"esnext.iterator.drop",
		  	"esnext.iterator.every",
		  	"esnext.iterator.filter",
		  	"esnext.iterator.find",
		  	"esnext.iterator.flat-map",
		  	"esnext.iterator.for-each",
		  	"esnext.iterator.from",
		  	"esnext.iterator.indexed",
		  	"esnext.iterator.map",
		  	"esnext.iterator.range",
		  	"esnext.iterator.reduce",
		  	"esnext.iterator.some",
		  	"esnext.iterator.take",
		  	"esnext.iterator.to-array",
		  	"esnext.iterator.to-async",
		  	"esnext.json.is-raw-json",
		  	"esnext.json.parse",
		  	"esnext.json.raw-json",
		  	"esnext.map.delete-all",
		  	"esnext.map.emplace",
		  	"esnext.map.every",
		  	"esnext.map.filter",
		  	"esnext.map.find",
		  	"esnext.map.find-key",
		  	"esnext.map.from",
		  	"esnext.map.group-by",
		  	"esnext.map.includes",
		  	"esnext.map.key-by",
		  	"esnext.map.key-of",
		  	"esnext.map.map-keys",
		  	"esnext.map.map-values",
		  	"esnext.map.merge",
		  	"esnext.map.of",
		  	"esnext.map.reduce",
		  	"esnext.map.some",
		  	"esnext.map.update",
		  	"esnext.map.update-or-insert",
		  	"esnext.map.upsert",
		  	"esnext.math.clamp",
		  	"esnext.math.deg-per-rad",
		  	"esnext.math.degrees",
		  	"esnext.math.fscale",
		  	"esnext.math.f16round",
		  	"esnext.math.iaddh",
		  	"esnext.math.imulh",
		  	"esnext.math.isubh",
		  	"esnext.math.rad-per-deg",
		  	"esnext.math.radians",
		  	"esnext.math.scale",
		  	"esnext.math.seeded-prng",
		  	"esnext.math.signbit",
		  	"esnext.math.umulh",
		  	"esnext.number.from-string",
		  	"esnext.number.range",
		  	"esnext.object.has-own",
		  	"esnext.object.iterate-entries",
		  	"esnext.object.iterate-keys",
		  	"esnext.object.iterate-values",
		  	"esnext.object.group-by",
		  	"esnext.observable",
		  	"esnext.promise.all-settled",
		  	"esnext.promise.any",
		  	"esnext.promise.try",
		  	"esnext.promise.with-resolvers",
		  	"esnext.reflect.define-metadata",
		  	"esnext.reflect.delete-metadata",
		  	"esnext.reflect.get-metadata",
		  	"esnext.reflect.get-metadata-keys",
		  	"esnext.reflect.get-own-metadata",
		  	"esnext.reflect.get-own-metadata-keys",
		  	"esnext.reflect.has-metadata",
		  	"esnext.reflect.has-own-metadata",
		  	"esnext.reflect.metadata",
		  	"esnext.regexp.escape",
		  	"esnext.set.add-all",
		  	"esnext.set.delete-all",
		  	"esnext.set.difference.v2",
		  	"esnext.set.difference",
		  	"esnext.set.every",
		  	"esnext.set.filter",
		  	"esnext.set.find",
		  	"esnext.set.from",
		  	"esnext.set.intersection.v2",
		  	"esnext.set.intersection",
		  	"esnext.set.is-disjoint-from.v2",
		  	"esnext.set.is-disjoint-from",
		  	"esnext.set.is-subset-of.v2",
		  	"esnext.set.is-subset-of",
		  	"esnext.set.is-superset-of.v2",
		  	"esnext.set.is-superset-of",
		  	"esnext.set.join",
		  	"esnext.set.map",
		  	"esnext.set.of",
		  	"esnext.set.reduce",
		  	"esnext.set.some",
		  	"esnext.set.symmetric-difference.v2",
		  	"esnext.set.symmetric-difference",
		  	"esnext.set.union.v2",
		  	"esnext.set.union",
		  	"esnext.string.at",
		  	"esnext.string.cooked",
		  	"esnext.string.code-points",
		  	"esnext.string.dedent",
		  	"esnext.string.is-well-formed",
		  	"esnext.string.match-all",
		  	"esnext.string.replace-all",
		  	"esnext.string.to-well-formed",
		  	"esnext.symbol.async-dispose",
		  	"esnext.symbol.dispose",
		  	"esnext.symbol.is-registered-symbol",
		  	"esnext.symbol.is-registered",
		  	"esnext.symbol.is-well-known-symbol",
		  	"esnext.symbol.is-well-known",
		  	"esnext.symbol.matcher",
		  	"esnext.symbol.metadata",
		  	"esnext.symbol.metadata-key",
		  	"esnext.symbol.observable",
		  	"esnext.symbol.pattern-match",
		  	"esnext.symbol.replace-all",
		  	"esnext.typed-array.from-async",
		  	"esnext.typed-array.at",
		  	"esnext.typed-array.filter-out",
		  	"esnext.typed-array.filter-reject",
		  	"esnext.typed-array.find-last",
		  	"esnext.typed-array.find-last-index",
		  	"esnext.typed-array.group-by",
		  	"esnext.typed-array.to-reversed",
		  	"esnext.typed-array.to-sorted",
		  	"esnext.typed-array.to-spliced",
		  	"esnext.typed-array.unique-by",
		  	"esnext.typed-array.with",
		  	"esnext.uint8-array.from-base64",
		  	"esnext.uint8-array.from-hex",
		  	"esnext.uint8-array.to-base64",
		  	"esnext.uint8-array.to-hex",
		  	"esnext.weak-map.delete-all",
		  	"esnext.weak-map.from",
		  	"esnext.weak-map.of",
		  	"esnext.weak-map.emplace",
		  	"esnext.weak-map.upsert",
		  	"esnext.weak-set.add-all",
		  	"esnext.weak-set.delete-all",
		  	"esnext.weak-set.from",
		  	"esnext.weak-set.of",
		  	"web.atob",
		  	"web.btoa",
		  	"web.dom-collections.for-each",
		  	"web.dom-collections.iterator",
		  	"web.dom-exception.constructor",
		  	"web.dom-exception.stack",
		  	"web.dom-exception.to-string-tag",
		  	"web.immediate",
		  	"web.queue-microtask",
		  	"web.self",
		  	"web.structured-clone",
		  	"web.timers",
		  	"web.url",
		  	"web.url.can-parse",
		  	"web.url.to-json",
		  	"web.url-search-params",
		  	"web.url-search-params.delete",
		  	"web.url-search-params.has",
		  	"web.url-search-params.size"
		  ],
		  	"core-js/actual": [
		  	"es.symbol",
		  	"es.symbol.description",
		  	"es.symbol.async-iterator",
		  	"es.symbol.has-instance",
		  	"es.symbol.is-concat-spreadable",
		  	"es.symbol.iterator",
		  	"es.symbol.match",
		  	"es.symbol.match-all",
		  	"es.symbol.replace",
		  	"es.symbol.search",
		  	"es.symbol.species",
		  	"es.symbol.split",
		  	"es.symbol.to-primitive",
		  	"es.symbol.to-string-tag",
		  	"es.symbol.unscopables",
		  	"es.error.cause",
		  	"es.error.to-string",
		  	"es.aggregate-error",
		  	"es.aggregate-error.cause",
		  	"es.array.at",
		  	"es.array.concat",
		  	"es.array.copy-within",
		  	"es.array.every",
		  	"es.array.fill",
		  	"es.array.filter",
		  	"es.array.find",
		  	"es.array.find-index",
		  	"es.array.find-last",
		  	"es.array.find-last-index",
		  	"es.array.flat",
		  	"es.array.flat-map",
		  	"es.array.for-each",
		  	"es.array.from",
		  	"es.array.includes",
		  	"es.array.index-of",
		  	"es.array.is-array",
		  	"es.array.iterator",
		  	"es.array.join",
		  	"es.array.last-index-of",
		  	"es.array.map",
		  	"es.array.of",
		  	"es.array.push",
		  	"es.array.reduce",
		  	"es.array.reduce-right",
		  	"es.array.reverse",
		  	"es.array.slice",
		  	"es.array.some",
		  	"es.array.sort",
		  	"es.array.species",
		  	"es.array.splice",
		  	"es.array.to-reversed",
		  	"es.array.to-sorted",
		  	"es.array.to-spliced",
		  	"es.array.unscopables.flat",
		  	"es.array.unscopables.flat-map",
		  	"es.array.unshift",
		  	"es.array.with",
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.is-view",
		  	"es.array-buffer.slice",
		  	"es.data-view",
		  	"es.array-buffer.detached",
		  	"es.array-buffer.transfer",
		  	"es.array-buffer.transfer-to-fixed-length",
		  	"es.date.get-year",
		  	"es.date.now",
		  	"es.date.set-year",
		  	"es.date.to-gmt-string",
		  	"es.date.to-iso-string",
		  	"es.date.to-json",
		  	"es.date.to-primitive",
		  	"es.date.to-string",
		  	"es.escape",
		  	"es.function.bind",
		  	"es.function.has-instance",
		  	"es.function.name",
		  	"es.global-this",
		  	"es.json.stringify",
		  	"es.json.to-string-tag",
		  	"es.map",
		  	"es.map.group-by",
		  	"es.math.acosh",
		  	"es.math.asinh",
		  	"es.math.atanh",
		  	"es.math.cbrt",
		  	"es.math.clz32",
		  	"es.math.cosh",
		  	"es.math.expm1",
		  	"es.math.fround",
		  	"es.math.hypot",
		  	"es.math.imul",
		  	"es.math.log10",
		  	"es.math.log1p",
		  	"es.math.log2",
		  	"es.math.sign",
		  	"es.math.sinh",
		  	"es.math.tanh",
		  	"es.math.to-string-tag",
		  	"es.math.trunc",
		  	"es.number.constructor",
		  	"es.number.epsilon",
		  	"es.number.is-finite",
		  	"es.number.is-integer",
		  	"es.number.is-nan",
		  	"es.number.is-safe-integer",
		  	"es.number.max-safe-integer",
		  	"es.number.min-safe-integer",
		  	"es.number.parse-float",
		  	"es.number.parse-int",
		  	"es.number.to-exponential",
		  	"es.number.to-fixed",
		  	"es.number.to-precision",
		  	"es.object.assign",
		  	"es.object.create",
		  	"es.object.define-getter",
		  	"es.object.define-properties",
		  	"es.object.define-property",
		  	"es.object.define-setter",
		  	"es.object.entries",
		  	"es.object.freeze",
		  	"es.object.from-entries",
		  	"es.object.get-own-property-descriptor",
		  	"es.object.get-own-property-descriptors",
		  	"es.object.get-own-property-names",
		  	"es.object.get-prototype-of",
		  	"es.object.group-by",
		  	"es.object.has-own",
		  	"es.object.is",
		  	"es.object.is-extensible",
		  	"es.object.is-frozen",
		  	"es.object.is-sealed",
		  	"es.object.keys",
		  	"es.object.lookup-getter",
		  	"es.object.lookup-setter",
		  	"es.object.prevent-extensions",
		  	"es.object.proto",
		  	"es.object.seal",
		  	"es.object.set-prototype-of",
		  	"es.object.to-string",
		  	"es.object.values",
		  	"es.parse-float",
		  	"es.parse-int",
		  	"es.promise",
		  	"es.promise.all-settled",
		  	"es.promise.any",
		  	"es.promise.finally",
		  	"es.promise.with-resolvers",
		  	"es.reflect.apply",
		  	"es.reflect.construct",
		  	"es.reflect.define-property",
		  	"es.reflect.delete-property",
		  	"es.reflect.get",
		  	"es.reflect.get-own-property-descriptor",
		  	"es.reflect.get-prototype-of",
		  	"es.reflect.has",
		  	"es.reflect.is-extensible",
		  	"es.reflect.own-keys",
		  	"es.reflect.prevent-extensions",
		  	"es.reflect.set",
		  	"es.reflect.set-prototype-of",
		  	"es.reflect.to-string-tag",
		  	"es.regexp.constructor",
		  	"es.regexp.dot-all",
		  	"es.regexp.exec",
		  	"es.regexp.flags",
		  	"es.regexp.sticky",
		  	"es.regexp.test",
		  	"es.regexp.to-string",
		  	"es.set",
		  	"es.string.at-alternative",
		  	"es.string.code-point-at",
		  	"es.string.ends-with",
		  	"es.string.from-code-point",
		  	"es.string.includes",
		  	"es.string.is-well-formed",
		  	"es.string.iterator",
		  	"es.string.match",
		  	"es.string.match-all",
		  	"es.string.pad-end",
		  	"es.string.pad-start",
		  	"es.string.raw",
		  	"es.string.repeat",
		  	"es.string.replace",
		  	"es.string.replace-all",
		  	"es.string.search",
		  	"es.string.split",
		  	"es.string.starts-with",
		  	"es.string.substr",
		  	"es.string.to-well-formed",
		  	"es.string.trim",
		  	"es.string.trim-end",
		  	"es.string.trim-start",
		  	"es.string.anchor",
		  	"es.string.big",
		  	"es.string.blink",
		  	"es.string.bold",
		  	"es.string.fixed",
		  	"es.string.fontcolor",
		  	"es.string.fontsize",
		  	"es.string.italics",
		  	"es.string.link",
		  	"es.string.small",
		  	"es.string.strike",
		  	"es.string.sub",
		  	"es.string.sup",
		  	"es.typed-array.float32-array",
		  	"es.typed-array.float64-array",
		  	"es.typed-array.int8-array",
		  	"es.typed-array.int16-array",
		  	"es.typed-array.int32-array",
		  	"es.typed-array.uint8-array",
		  	"es.typed-array.uint8-clamped-array",
		  	"es.typed-array.uint16-array",
		  	"es.typed-array.uint32-array",
		  	"es.typed-array.at",
		  	"es.typed-array.copy-within",
		  	"es.typed-array.every",
		  	"es.typed-array.fill",
		  	"es.typed-array.filter",
		  	"es.typed-array.find",
		  	"es.typed-array.find-index",
		  	"es.typed-array.find-last",
		  	"es.typed-array.find-last-index",
		  	"es.typed-array.for-each",
		  	"es.typed-array.from",
		  	"es.typed-array.includes",
		  	"es.typed-array.index-of",
		  	"es.typed-array.iterator",
		  	"es.typed-array.join",
		  	"es.typed-array.last-index-of",
		  	"es.typed-array.map",
		  	"es.typed-array.of",
		  	"es.typed-array.reduce",
		  	"es.typed-array.reduce-right",
		  	"es.typed-array.reverse",
		  	"es.typed-array.set",
		  	"es.typed-array.slice",
		  	"es.typed-array.some",
		  	"es.typed-array.sort",
		  	"es.typed-array.subarray",
		  	"es.typed-array.to-locale-string",
		  	"es.typed-array.to-reversed",
		  	"es.typed-array.to-sorted",
		  	"es.typed-array.to-string",
		  	"es.typed-array.with",
		  	"es.unescape",
		  	"es.weak-map",
		  	"es.weak-set",
		  	"esnext.aggregate-error",
		  	"esnext.suppressed-error.constructor",
		  	"esnext.array.from-async",
		  	"esnext.array.at",
		  	"esnext.array.find-last",
		  	"esnext.array.find-last-index",
		  	"esnext.array.group",
		  	"esnext.array.group-by",
		  	"esnext.array.group-by-to-map",
		  	"esnext.array.group-to-map",
		  	"esnext.array.to-reversed",
		  	"esnext.array.to-sorted",
		  	"esnext.array.to-spliced",
		  	"esnext.array.with",
		  	"esnext.array-buffer.detached",
		  	"esnext.array-buffer.transfer",
		  	"esnext.array-buffer.transfer-to-fixed-length",
		  	"esnext.async-disposable-stack.constructor",
		  	"esnext.async-iterator.constructor",
		  	"esnext.async-iterator.async-dispose",
		  	"esnext.async-iterator.drop",
		  	"esnext.async-iterator.every",
		  	"esnext.async-iterator.filter",
		  	"esnext.async-iterator.find",
		  	"esnext.async-iterator.flat-map",
		  	"esnext.async-iterator.for-each",
		  	"esnext.async-iterator.from",
		  	"esnext.async-iterator.map",
		  	"esnext.async-iterator.reduce",
		  	"esnext.async-iterator.some",
		  	"esnext.async-iterator.take",
		  	"esnext.async-iterator.to-array",
		  	"esnext.data-view.get-float16",
		  	"esnext.data-view.set-float16",
		  	"esnext.disposable-stack.constructor",
		  	"esnext.function.metadata",
		  	"esnext.global-this",
		  	"esnext.iterator.constructor",
		  	"esnext.iterator.dispose",
		  	"esnext.iterator.drop",
		  	"esnext.iterator.every",
		  	"esnext.iterator.filter",
		  	"esnext.iterator.find",
		  	"esnext.iterator.flat-map",
		  	"esnext.iterator.for-each",
		  	"esnext.iterator.from",
		  	"esnext.iterator.map",
		  	"esnext.iterator.reduce",
		  	"esnext.iterator.some",
		  	"esnext.iterator.take",
		  	"esnext.iterator.to-array",
		  	"esnext.iterator.to-async",
		  	"esnext.json.is-raw-json",
		  	"esnext.json.parse",
		  	"esnext.json.raw-json",
		  	"esnext.map.group-by",
		  	"esnext.math.f16round",
		  	"esnext.object.has-own",
		  	"esnext.object.group-by",
		  	"esnext.promise.all-settled",
		  	"esnext.promise.any",
		  	"esnext.promise.with-resolvers",
		  	"esnext.set.difference.v2",
		  	"esnext.set.intersection.v2",
		  	"esnext.set.is-disjoint-from.v2",
		  	"esnext.set.is-subset-of.v2",
		  	"esnext.set.is-superset-of.v2",
		  	"esnext.set.symmetric-difference.v2",
		  	"esnext.set.union.v2",
		  	"esnext.string.is-well-formed",
		  	"esnext.string.match-all",
		  	"esnext.string.replace-all",
		  	"esnext.string.to-well-formed",
		  	"esnext.symbol.async-dispose",
		  	"esnext.symbol.dispose",
		  	"esnext.symbol.metadata",
		  	"esnext.typed-array.at",
		  	"esnext.typed-array.find-last",
		  	"esnext.typed-array.find-last-index",
		  	"esnext.typed-array.to-reversed",
		  	"esnext.typed-array.to-sorted",
		  	"esnext.typed-array.to-spliced",
		  	"esnext.typed-array.with",
		  	"esnext.uint8-array.from-base64",
		  	"esnext.uint8-array.from-hex",
		  	"esnext.uint8-array.to-base64",
		  	"esnext.uint8-array.to-hex",
		  	"web.atob",
		  	"web.btoa",
		  	"web.dom-collections.for-each",
		  	"web.dom-collections.iterator",
		  	"web.dom-exception.constructor",
		  	"web.dom-exception.stack",
		  	"web.dom-exception.to-string-tag",
		  	"web.immediate",
		  	"web.queue-microtask",
		  	"web.self",
		  	"web.structured-clone",
		  	"web.timers",
		  	"web.url",
		  	"web.url.can-parse",
		  	"web.url.to-json",
		  	"web.url-search-params",
		  	"web.url-search-params.delete",
		  	"web.url-search-params.has",
		  	"web.url-search-params.size"
		  ],
		  	"core-js/actual/aggregate-error": [
		  ],
		  	"core-js/actual/array": [
		  	"es.array.at",
		  	"es.array.concat",
		  	"es.array.copy-within",
		  	"es.array.every",
		  	"es.array.fill",
		  	"es.array.filter",
		  	"es.array.find",
		  	"es.array.find-index",
		  	"es.array.find-last",
		  	"es.array.find-last-index",
		  	"es.array.flat",
		  	"es.array.flat-map",
		  	"es.array.for-each",
		  	"es.array.from",
		  	"es.array.includes",
		  	"es.array.index-of",
		  	"es.array.is-array",
		  	"es.array.iterator",
		  	"es.array.join",
		  	"es.array.last-index-of",
		  	"es.array.map",
		  	"es.array.of",
		  	"es.array.push",
		  	"es.array.reduce",
		  	"es.array.reduce-right",
		  	"es.array.reverse",
		  	"es.array.slice",
		  	"es.array.some",
		  	"es.array.sort",
		  	"es.array.species",
		  	"es.array.splice",
		  	"es.array.to-reversed",
		  	"es.array.to-sorted",
		  	"es.array.to-spliced",
		  	"es.array.unscopables.flat",
		  	"es.array.unscopables.flat-map",
		  	"es.array.unshift",
		  	"es.array.with",
		  	"es.object.to-string",
		  	"es.promise",
		  	"es.string.iterator",
		  	"esnext.array.from-async",
		  	"esnext.array.find-last",
		  	"esnext.array.find-last-index",
		  	"esnext.array.group",
		  	"esnext.array.group-by",
		  	"esnext.array.group-by-to-map",
		  	"esnext.array.group-to-map",
		  	"esnext.array.to-reversed",
		  	"esnext.array.to-sorted",
		  	"esnext.array.to-spliced",
		  	"esnext.array.with"
		  ],
		  	"core-js/actual/array-buffer": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.is-view",
		  	"es.array-buffer.slice",
		  	"es.data-view",
		  	"es.array-buffer.detached",
		  	"es.array-buffer.transfer",
		  	"es.array-buffer.transfer-to-fixed-length",
		  	"es.object.to-string",
		  	"esnext.array-buffer.detached",
		  	"esnext.array-buffer.transfer",
		  	"esnext.array-buffer.transfer-to-fixed-length"
		  ],
		  	"core-js/actual/array-buffer/constructor": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.array-buffer.detached",
		  	"es.array-buffer.transfer",
		  	"es.array-buffer.transfer-to-fixed-length",
		  	"es.object.to-string",
		  	"esnext.array-buffer.detached",
		  	"esnext.array-buffer.transfer",
		  	"esnext.array-buffer.transfer-to-fixed-length"
		  ],
		  	"core-js/actual/array-buffer/detached": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.array-buffer.detached",
		  	"esnext.array-buffer.detached"
		  ],
		  	"core-js/actual/array-buffer/is-view": [
		  	"es.array-buffer.is-view"
		  ],
		  	"core-js/actual/array-buffer/slice": [
		  	"es.array-buffer.slice"
		  ],
		  	"core-js/actual/array-buffer/transfer": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.data-view",
		  	"es.array-buffer.transfer",
		  	"esnext.array-buffer.transfer"
		  ],
		  	"core-js/actual/array-buffer/transfer-to-fixed-length": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.data-view",
		  	"es.array-buffer.transfer-to-fixed-length",
		  	"esnext.array-buffer.transfer-to-fixed-length"
		  ],
		  	"core-js/actual/array/at": [
		  	"es.array.at"
		  ],
		  	"core-js/actual/array/concat": [
		  	"es.array.concat"
		  ],
		  	"core-js/actual/array/copy-within": [
		  	"es.array.copy-within"
		  ],
		  	"core-js/actual/array/entries": [
		  	"es.array.iterator",
		  	"es.object.to-string"
		  ],
		  	"core-js/actual/array/every": [
		  	"es.array.every"
		  ],
		  	"core-js/actual/array/fill": [
		  	"es.array.fill"
		  ],
		  	"core-js/actual/array/filter": [
		  	"es.array.filter"
		  ],
		  	"core-js/actual/array/find": [
		  	"es.array.find"
		  ],
		  	"core-js/actual/array/find-index": [
		  	"es.array.find-index"
		  ],
		  	"core-js/actual/array/find-last": [
		  	"es.array.find-last",
		  	"esnext.array.find-last"
		  ],
		  	"core-js/actual/array/find-last-index": [
		  	"es.array.find-last-index",
		  	"esnext.array.find-last-index"
		  ],
		  	"core-js/actual/array/flat": [
		  	"es.array.flat",
		  	"es.array.unscopables.flat"
		  ],
		  	"core-js/actual/array/flat-map": [
		  	"es.array.flat-map",
		  	"es.array.unscopables.flat-map"
		  ],
		  	"core-js/actual/array/for-each": [
		  	"es.array.for-each"
		  ],
		  	"core-js/actual/array/from": [
		  	"es.array.from",
		  	"es.string.iterator"
		  ],
		  	"core-js/actual/array/from-async": [
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"es.promise",
		  	"es.string.iterator",
		  	"esnext.array.from-async"
		  ],
		  	"core-js/actual/array/group": [
		  	"esnext.array.group"
		  ],
		  	"core-js/actual/array/group-by": [
		  	"esnext.array.group-by"
		  ],
		  	"core-js/actual/array/group-by-to-map": [
		  	"es.map",
		  	"es.object.to-string",
		  	"esnext.array.group-by-to-map"
		  ],
		  	"core-js/actual/array/group-to-map": [
		  	"es.map",
		  	"es.object.to-string",
		  	"esnext.array.group-to-map"
		  ],
		  	"core-js/actual/array/includes": [
		  	"es.array.includes"
		  ],
		  	"core-js/actual/array/index-of": [
		  	"es.array.index-of"
		  ],
		  	"core-js/actual/array/is-array": [
		  	"es.array.is-array"
		  ],
		  	"core-js/actual/array/iterator": [
		  	"es.array.iterator",
		  	"es.object.to-string"
		  ],
		  	"core-js/actual/array/join": [
		  	"es.array.join"
		  ],
		  	"core-js/actual/array/keys": [
		  	"es.array.iterator",
		  	"es.object.to-string"
		  ],
		  	"core-js/actual/array/last-index-of": [
		  	"es.array.last-index-of"
		  ],
		  	"core-js/actual/array/map": [
		  	"es.array.map"
		  ],
		  	"core-js/actual/array/of": [
		  	"es.array.of"
		  ],
		  	"core-js/actual/array/push": [
		  	"es.array.push"
		  ],
		  	"core-js/actual/array/reduce": [
		  	"es.array.reduce"
		  ],
		  	"core-js/actual/array/reduce-right": [
		  	"es.array.reduce-right"
		  ],
		  	"core-js/actual/array/reverse": [
		  	"es.array.reverse"
		  ],
		  	"core-js/actual/array/slice": [
		  	"es.array.slice"
		  ],
		  	"core-js/actual/array/some": [
		  	"es.array.some"
		  ],
		  	"core-js/actual/array/sort": [
		  	"es.array.sort"
		  ],
		  	"core-js/actual/array/splice": [
		  	"es.array.splice"
		  ],
		  	"core-js/actual/array/to-reversed": [
		  	"es.array.to-reversed",
		  	"esnext.array.to-reversed"
		  ],
		  	"core-js/actual/array/to-sorted": [
		  	"es.array.sort",
		  	"es.array.to-sorted",
		  	"esnext.array.to-sorted"
		  ],
		  	"core-js/actual/array/to-spliced": [
		  	"es.array.to-spliced",
		  	"esnext.array.to-spliced"
		  ],
		  	"core-js/actual/array/unshift": [
		  	"es.array.unshift"
		  ],
		  	"core-js/actual/array/values": [
		  	"es.array.iterator",
		  	"es.object.to-string"
		  ],
		  	"core-js/actual/array/virtual": [
		  	"es.array.at",
		  	"es.array.concat",
		  	"es.array.copy-within",
		  	"es.array.every",
		  	"es.array.fill",
		  	"es.array.filter",
		  	"es.array.find",
		  	"es.array.find-index",
		  	"es.array.find-last",
		  	"es.array.find-last-index",
		  	"es.array.flat",
		  	"es.array.flat-map",
		  	"es.array.for-each",
		  	"es.array.includes",
		  	"es.array.index-of",
		  	"es.array.iterator",
		  	"es.array.join",
		  	"es.array.last-index-of",
		  	"es.array.map",
		  	"es.array.push",
		  	"es.array.reduce",
		  	"es.array.reduce-right",
		  	"es.array.reverse",
		  	"es.array.slice",
		  	"es.array.some",
		  	"es.array.sort",
		  	"es.array.species",
		  	"es.array.splice",
		  	"es.array.to-reversed",
		  	"es.array.to-sorted",
		  	"es.array.to-spliced",
		  	"es.array.unscopables.flat",
		  	"es.array.unscopables.flat-map",
		  	"es.array.unshift",
		  	"es.array.with",
		  	"es.map",
		  	"es.object.to-string",
		  	"esnext.array.find-last",
		  	"esnext.array.find-last-index",
		  	"esnext.array.group",
		  	"esnext.array.group-by",
		  	"esnext.array.group-by-to-map",
		  	"esnext.array.group-to-map",
		  	"esnext.array.to-reversed",
		  	"esnext.array.to-sorted",
		  	"esnext.array.to-spliced",
		  	"esnext.array.with"
		  ],
		  	"core-js/actual/array/virtual/at": [
		  	"es.array.at"
		  ],
		  	"core-js/actual/array/virtual/concat": [
		  	"es.array.concat"
		  ],
		  	"core-js/actual/array/virtual/copy-within": [
		  	"es.array.copy-within"
		  ],
		  	"core-js/actual/array/virtual/entries": [
		  	"es.array.iterator",
		  	"es.object.to-string"
		  ],
		  	"core-js/actual/array/virtual/every": [
		  	"es.array.every"
		  ],
		  	"core-js/actual/array/virtual/fill": [
		  	"es.array.fill"
		  ],
		  	"core-js/actual/array/virtual/filter": [
		  	"es.array.filter"
		  ],
		  	"core-js/actual/array/virtual/find": [
		  	"es.array.find"
		  ],
		  	"core-js/actual/array/virtual/find-index": [
		  	"es.array.find-index"
		  ],
		  	"core-js/actual/array/virtual/find-last": [
		  	"es.array.find-last",
		  	"esnext.array.find-last"
		  ],
		  	"core-js/actual/array/virtual/find-last-index": [
		  	"es.array.find-last-index",
		  	"esnext.array.find-last-index"
		  ],
		  	"core-js/actual/array/virtual/flat": [
		  	"es.array.flat",
		  	"es.array.unscopables.flat"
		  ],
		  	"core-js/actual/array/virtual/flat-map": [
		  	"es.array.flat-map",
		  	"es.array.unscopables.flat-map"
		  ],
		  	"core-js/actual/array/virtual/for-each": [
		  	"es.array.for-each"
		  ],
		  	"core-js/actual/array/virtual/group": [
		  	"esnext.array.group"
		  ],
		  	"core-js/actual/array/virtual/group-by": [
		  	"esnext.array.group-by"
		  ],
		  	"core-js/actual/array/virtual/group-by-to-map": [
		  	"es.map",
		  	"es.object.to-string",
		  	"esnext.array.group-by-to-map"
		  ],
		  	"core-js/actual/array/virtual/group-to-map": [
		  	"es.map",
		  	"es.object.to-string",
		  	"esnext.array.group-to-map"
		  ],
		  	"core-js/actual/array/virtual/includes": [
		  	"es.array.includes"
		  ],
		  	"core-js/actual/array/virtual/index-of": [
		  	"es.array.index-of"
		  ],
		  	"core-js/actual/array/virtual/iterator": [
		  	"es.array.iterator",
		  	"es.object.to-string"
		  ],
		  	"core-js/actual/array/virtual/join": [
		  	"es.array.join"
		  ],
		  	"core-js/actual/array/virtual/keys": [
		  	"es.array.iterator",
		  	"es.object.to-string"
		  ],
		  	"core-js/actual/array/virtual/last-index-of": [
		  	"es.array.last-index-of"
		  ],
		  	"core-js/actual/array/virtual/map": [
		  	"es.array.map"
		  ],
		  	"core-js/actual/array/virtual/push": [
		  	"es.array.push"
		  ],
		  	"core-js/actual/array/virtual/reduce": [
		  	"es.array.reduce"
		  ],
		  	"core-js/actual/array/virtual/reduce-right": [
		  	"es.array.reduce-right"
		  ],
		  	"core-js/actual/array/virtual/reverse": [
		  	"es.array.reverse"
		  ],
		  	"core-js/actual/array/virtual/slice": [
		  	"es.array.slice"
		  ],
		  	"core-js/actual/array/virtual/some": [
		  	"es.array.some"
		  ],
		  	"core-js/actual/array/virtual/sort": [
		  	"es.array.sort"
		  ],
		  	"core-js/actual/array/virtual/splice": [
		  	"es.array.splice"
		  ],
		  	"core-js/actual/array/virtual/to-reversed": [
		  	"es.array.to-reversed",
		  	"esnext.array.to-reversed"
		  ],
		  	"core-js/actual/array/virtual/to-sorted": [
		  	"es.array.sort",
		  	"es.array.to-sorted",
		  	"esnext.array.to-sorted"
		  ],
		  	"core-js/actual/array/virtual/to-spliced": [
		  	"es.array.to-spliced",
		  	"esnext.array.to-spliced"
		  ],
		  	"core-js/actual/array/virtual/unshift": [
		  	"es.array.unshift"
		  ],
		  	"core-js/actual/array/virtual/values": [
		  	"es.array.iterator",
		  	"es.object.to-string"
		  ],
		  	"core-js/actual/array/virtual/with": [
		  	"es.array.with",
		  	"esnext.array.with"
		  ],
		  	"core-js/actual/array/with": [
		  	"es.array.with",
		  	"esnext.array.with"
		  ],
		  	"core-js/actual/async-disposable-stack": [
		  	"es.error.cause",
		  	"es.error.to-string",
		  	"es.object.to-string",
		  	"es.promise",
		  	"esnext.suppressed-error.constructor",
		  	"esnext.async-disposable-stack.constructor",
		  	"esnext.async-iterator.async-dispose",
		  	"esnext.iterator.dispose"
		  ],
		  	"core-js/actual/async-disposable-stack/constructor": [
		  	"es.error.cause",
		  	"es.error.to-string",
		  	"es.object.to-string",
		  	"es.promise",
		  	"esnext.suppressed-error.constructor",
		  	"esnext.async-disposable-stack.constructor",
		  	"esnext.async-iterator.async-dispose",
		  	"esnext.iterator.dispose"
		  ],
		  	"core-js/actual/async-iterator": [
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"es.promise",
		  	"es.string.iterator",
		  	"esnext.async-iterator.constructor",
		  	"esnext.async-iterator.async-dispose",
		  	"esnext.async-iterator.drop",
		  	"esnext.async-iterator.every",
		  	"esnext.async-iterator.filter",
		  	"esnext.async-iterator.find",
		  	"esnext.async-iterator.flat-map",
		  	"esnext.async-iterator.for-each",
		  	"esnext.async-iterator.from",
		  	"esnext.async-iterator.map",
		  	"esnext.async-iterator.reduce",
		  	"esnext.async-iterator.some",
		  	"esnext.async-iterator.take",
		  	"esnext.async-iterator.to-array",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/actual/async-iterator/async-dispose": [
		  	"es.object.to-string",
		  	"es.promise",
		  	"esnext.async-iterator.async-dispose"
		  ],
		  	"core-js/actual/async-iterator/drop": [
		  	"es.object.to-string",
		  	"es.promise",
		  	"esnext.async-iterator.constructor",
		  	"esnext.async-iterator.drop"
		  ],
		  	"core-js/actual/async-iterator/every": [
		  	"es.object.to-string",
		  	"es.promise",
		  	"esnext.async-iterator.constructor",
		  	"esnext.async-iterator.every"
		  ],
		  	"core-js/actual/async-iterator/filter": [
		  	"es.object.to-string",
		  	"es.promise",
		  	"esnext.async-iterator.constructor",
		  	"esnext.async-iterator.filter"
		  ],
		  	"core-js/actual/async-iterator/find": [
		  	"es.object.to-string",
		  	"es.promise",
		  	"esnext.async-iterator.constructor",
		  	"esnext.async-iterator.find"
		  ],
		  	"core-js/actual/async-iterator/flat-map": [
		  	"es.object.to-string",
		  	"es.promise",
		  	"esnext.async-iterator.constructor",
		  	"esnext.async-iterator.flat-map"
		  ],
		  	"core-js/actual/async-iterator/for-each": [
		  	"es.object.to-string",
		  	"es.promise",
		  	"esnext.async-iterator.constructor",
		  	"esnext.async-iterator.for-each"
		  ],
		  	"core-js/actual/async-iterator/from": [
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"es.promise",
		  	"es.string.iterator",
		  	"esnext.async-iterator.constructor",
		  	"esnext.async-iterator.drop",
		  	"esnext.async-iterator.every",
		  	"esnext.async-iterator.filter",
		  	"esnext.async-iterator.find",
		  	"esnext.async-iterator.flat-map",
		  	"esnext.async-iterator.for-each",
		  	"esnext.async-iterator.from",
		  	"esnext.async-iterator.map",
		  	"esnext.async-iterator.reduce",
		  	"esnext.async-iterator.some",
		  	"esnext.async-iterator.take",
		  	"esnext.async-iterator.to-array",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/actual/async-iterator/map": [
		  	"es.object.to-string",
		  	"es.promise",
		  	"esnext.async-iterator.constructor",
		  	"esnext.async-iterator.map"
		  ],
		  	"core-js/actual/async-iterator/reduce": [
		  	"es.object.to-string",
		  	"es.promise",
		  	"esnext.async-iterator.constructor",
		  	"esnext.async-iterator.reduce"
		  ],
		  	"core-js/actual/async-iterator/some": [
		  	"es.object.to-string",
		  	"es.promise",
		  	"esnext.async-iterator.constructor",
		  	"esnext.async-iterator.some"
		  ],
		  	"core-js/actual/async-iterator/take": [
		  	"es.object.to-string",
		  	"es.promise",
		  	"esnext.async-iterator.constructor",
		  	"esnext.async-iterator.take"
		  ],
		  	"core-js/actual/async-iterator/to-array": [
		  	"es.object.to-string",
		  	"es.promise",
		  	"esnext.async-iterator.constructor",
		  	"esnext.async-iterator.to-array"
		  ],
		  	"core-js/actual/atob": [
		  	"es.error.to-string",
		  	"es.object.to-string",
		  	"web.atob",
		  	"web.dom-exception.constructor",
		  	"web.dom-exception.stack",
		  	"web.dom-exception.to-string-tag"
		  ],
		  	"core-js/actual/btoa": [
		  	"es.error.to-string",
		  	"es.object.to-string",
		  	"web.btoa",
		  	"web.dom-exception.constructor",
		  	"web.dom-exception.stack",
		  	"web.dom-exception.to-string-tag"
		  ],
		  	"core-js/actual/clear-immediate": [
		  	"web.immediate"
		  ],
		  	"core-js/actual/data-view": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.data-view",
		  	"es.object.to-string",
		  	"esnext.data-view.get-float16",
		  	"esnext.data-view.set-float16"
		  ],
		  	"core-js/actual/data-view/get-float16": [
		  	"esnext.data-view.get-float16"
		  ],
		  	"core-js/actual/data-view/set-float16": [
		  	"esnext.data-view.set-float16"
		  ],
		  	"core-js/actual/date": [
		  	"es.date.get-year",
		  	"es.date.now",
		  	"es.date.set-year",
		  	"es.date.to-gmt-string",
		  	"es.date.to-iso-string",
		  	"es.date.to-json",
		  	"es.date.to-primitive",
		  	"es.date.to-string"
		  ],
		  	"core-js/actual/date/get-year": [
		  	"es.date.get-year"
		  ],
		  	"core-js/actual/date/now": [
		  	"es.date.now"
		  ],
		  	"core-js/actual/date/set-year": [
		  	"es.date.set-year"
		  ],
		  	"core-js/actual/date/to-gmt-string": [
		  	"es.date.to-gmt-string"
		  ],
		  	"core-js/actual/date/to-iso-string": [
		  	"es.date.to-iso-string",
		  	"es.date.to-json"
		  ],
		  	"core-js/actual/date/to-json": [
		  	"es.date.to-json"
		  ],
		  	"core-js/actual/date/to-primitive": [
		  	"es.date.to-primitive"
		  ],
		  	"core-js/actual/date/to-string": [
		  	"es.date.to-string"
		  ],
		  	"core-js/actual/disposable-stack": [
		  	"es.error.cause",
		  	"es.error.to-string",
		  	"es.object.to-string",
		  	"esnext.suppressed-error.constructor",
		  	"esnext.disposable-stack.constructor",
		  	"esnext.iterator.dispose"
		  ],
		  	"core-js/actual/disposable-stack/constructor": [
		  	"es.error.cause",
		  	"es.error.to-string",
		  	"es.object.to-string",
		  	"esnext.suppressed-error.constructor",
		  	"esnext.disposable-stack.constructor",
		  	"esnext.iterator.dispose"
		  ],
		  	"core-js/actual/dom-collections": [
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"web.dom-collections.for-each",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/actual/dom-collections/for-each": [
		  	"web.dom-collections.for-each"
		  ],
		  	"core-js/actual/dom-collections/iterator": [
		  	"es.object.to-string",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/actual/dom-exception": [
		  	"es.error.to-string",
		  	"web.dom-exception.constructor",
		  	"web.dom-exception.stack",
		  	"web.dom-exception.to-string-tag"
		  ],
		  	"core-js/actual/dom-exception/constructor": [
		  	"es.error.to-string",
		  	"web.dom-exception.constructor",
		  	"web.dom-exception.stack"
		  ],
		  	"core-js/actual/dom-exception/to-string-tag": [
		  	"web.dom-exception.to-string-tag"
		  ],
		  	"core-js/actual/error": [
		  	"es.error.cause",
		  	"es.error.to-string"
		  ],
		  	"core-js/actual/error/constructor": [
		  	"es.error.cause"
		  ],
		  	"core-js/actual/error/to-string": [
		  	"es.error.to-string"
		  ],
		  	"core-js/actual/escape": [
		  	"es.escape"
		  ],
		  	"core-js/actual/function": [
		  	"es.function.bind",
		  	"es.function.has-instance",
		  	"es.function.name",
		  	"esnext.function.metadata"
		  ],
		  	"core-js/actual/function/bind": [
		  	"es.function.bind"
		  ],
		  	"core-js/actual/function/has-instance": [
		  	"es.function.has-instance"
		  ],
		  	"core-js/actual/function/metadata": [
		  	"esnext.function.metadata"
		  ],
		  	"core-js/actual/function/name": [
		  	"es.function.name"
		  ],
		  	"core-js/actual/function/virtual": [
		  	"es.function.bind"
		  ],
		  	"core-js/actual/function/virtual/bind": [
		  	"es.function.bind"
		  ],
		  	"core-js/actual/get-iterator": [
		  	"es.array.iterator",
		  	"es.string.iterator",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/actual/get-iterator-method": [
		  	"es.array.iterator",
		  	"es.string.iterator",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/actual/global-this": [
		  	"es.global-this"
		  ],
		  	"core-js/actual/instance/at": [
		  	"es.array.at",
		  	"es.string.at-alternative"
		  ],
		  	"core-js/actual/instance/bind": [
		  	"es.function.bind"
		  ],
		  	"core-js/actual/instance/code-point-at": [
		  	"es.string.code-point-at"
		  ],
		  	"core-js/actual/instance/concat": [
		  	"es.array.concat"
		  ],
		  	"core-js/actual/instance/copy-within": [
		  	"es.array.copy-within"
		  ],
		  	"core-js/actual/instance/ends-with": [
		  	"es.string.ends-with"
		  ],
		  	"core-js/actual/instance/entries": [
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/actual/instance/every": [
		  	"es.array.every"
		  ],
		  	"core-js/actual/instance/fill": [
		  	"es.array.fill"
		  ],
		  	"core-js/actual/instance/filter": [
		  	"es.array.filter"
		  ],
		  	"core-js/actual/instance/find": [
		  	"es.array.find"
		  ],
		  	"core-js/actual/instance/find-index": [
		  	"es.array.find-index"
		  ],
		  	"core-js/actual/instance/find-last": [
		  	"es.array.find-last",
		  	"esnext.array.find-last"
		  ],
		  	"core-js/actual/instance/find-last-index": [
		  	"es.array.find-last-index",
		  	"esnext.array.find-last-index"
		  ],
		  	"core-js/actual/instance/flags": [
		  	"es.regexp.flags"
		  ],
		  	"core-js/actual/instance/flat": [
		  	"es.array.flat",
		  	"es.array.unscopables.flat"
		  ],
		  	"core-js/actual/instance/flat-map": [
		  	"es.array.flat-map",
		  	"es.array.unscopables.flat-map"
		  ],
		  	"core-js/actual/instance/for-each": [
		  	"es.array.for-each",
		  	"web.dom-collections.for-each"
		  ],
		  	"core-js/actual/instance/group": [
		  	"esnext.array.group"
		  ],
		  	"core-js/actual/instance/group-by": [
		  	"esnext.array.group-by"
		  ],
		  	"core-js/actual/instance/group-by-to-map": [
		  	"es.map",
		  	"es.object.to-string",
		  	"esnext.array.group-by-to-map"
		  ],
		  	"core-js/actual/instance/group-to-map": [
		  	"es.map",
		  	"es.object.to-string",
		  	"esnext.array.group-to-map"
		  ],
		  	"core-js/actual/instance/includes": [
		  	"es.array.includes",
		  	"es.string.includes"
		  ],
		  	"core-js/actual/instance/index-of": [
		  	"es.array.index-of"
		  ],
		  	"core-js/actual/instance/is-well-formed": [
		  	"es.string.is-well-formed"
		  ],
		  	"core-js/actual/instance/keys": [
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/actual/instance/last-index-of": [
		  	"es.array.last-index-of"
		  ],
		  	"core-js/actual/instance/map": [
		  	"es.array.map"
		  ],
		  	"core-js/actual/instance/match-all": [
		  	"es.object.to-string",
		  	"es.regexp.exec",
		  	"es.string.match-all"
		  ],
		  	"core-js/actual/instance/pad-end": [
		  	"es.string.pad-end"
		  ],
		  	"core-js/actual/instance/pad-start": [
		  	"es.string.pad-start"
		  ],
		  	"core-js/actual/instance/push": [
		  	"es.array.push"
		  ],
		  	"core-js/actual/instance/reduce": [
		  	"es.array.reduce"
		  ],
		  	"core-js/actual/instance/reduce-right": [
		  	"es.array.reduce-right"
		  ],
		  	"core-js/actual/instance/repeat": [
		  	"es.string.repeat"
		  ],
		  	"core-js/actual/instance/replace-all": [
		  	"es.regexp.exec",
		  	"es.string.replace",
		  	"es.string.replace-all"
		  ],
		  	"core-js/actual/instance/reverse": [
		  	"es.array.reverse"
		  ],
		  	"core-js/actual/instance/slice": [
		  	"es.array.slice"
		  ],
		  	"core-js/actual/instance/some": [
		  	"es.array.some"
		  ],
		  	"core-js/actual/instance/sort": [
		  	"es.array.sort"
		  ],
		  	"core-js/actual/instance/splice": [
		  	"es.array.splice"
		  ],
		  	"core-js/actual/instance/starts-with": [
		  	"es.string.starts-with"
		  ],
		  	"core-js/actual/instance/to-reversed": [
		  	"es.array.to-reversed",
		  	"esnext.array.to-reversed"
		  ],
		  	"core-js/actual/instance/to-sorted": [
		  	"es.array.sort",
		  	"es.array.to-sorted",
		  	"esnext.array.to-sorted"
		  ],
		  	"core-js/actual/instance/to-spliced": [
		  	"es.array.to-spliced",
		  	"esnext.array.to-spliced"
		  ],
		  	"core-js/actual/instance/to-well-formed": [
		  	"es.string.to-well-formed"
		  ],
		  	"core-js/actual/instance/trim": [
		  	"es.string.trim"
		  ],
		  	"core-js/actual/instance/trim-end": [
		  	"es.string.trim-end"
		  ],
		  	"core-js/actual/instance/trim-left": [
		  	"es.string.trim-start"
		  ],
		  	"core-js/actual/instance/trim-right": [
		  	"es.string.trim-end"
		  ],
		  	"core-js/actual/instance/trim-start": [
		  	"es.string.trim-start"
		  ],
		  	"core-js/actual/instance/unshift": [
		  	"es.array.unshift"
		  ],
		  	"core-js/actual/instance/values": [
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/actual/instance/with": [
		  	"es.array.with",
		  	"esnext.array.with"
		  ],
		  	"core-js/actual/is-iterable": [
		  	"es.array.iterator",
		  	"es.string.iterator",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/actual/iterator": [
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"es.promise",
		  	"es.string.iterator",
		  	"esnext.iterator.constructor",
		  	"esnext.iterator.dispose",
		  	"esnext.iterator.drop",
		  	"esnext.iterator.every",
		  	"esnext.iterator.filter",
		  	"esnext.iterator.find",
		  	"esnext.iterator.flat-map",
		  	"esnext.iterator.for-each",
		  	"esnext.iterator.from",
		  	"esnext.iterator.map",
		  	"esnext.iterator.reduce",
		  	"esnext.iterator.some",
		  	"esnext.iterator.take",
		  	"esnext.iterator.to-array",
		  	"esnext.iterator.to-async",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/actual/iterator/dispose": [
		  	"esnext.iterator.dispose"
		  ],
		  	"core-js/actual/iterator/drop": [
		  	"es.object.to-string",
		  	"esnext.iterator.constructor",
		  	"esnext.iterator.drop"
		  ],
		  	"core-js/actual/iterator/every": [
		  	"es.object.to-string",
		  	"esnext.iterator.constructor",
		  	"esnext.iterator.every"
		  ],
		  	"core-js/actual/iterator/filter": [
		  	"es.object.to-string",
		  	"esnext.iterator.constructor",
		  	"esnext.iterator.filter"
		  ],
		  	"core-js/actual/iterator/find": [
		  	"es.object.to-string",
		  	"esnext.iterator.constructor",
		  	"esnext.iterator.find"
		  ],
		  	"core-js/actual/iterator/flat-map": [
		  	"es.object.to-string",
		  	"esnext.iterator.constructor",
		  	"esnext.iterator.flat-map"
		  ],
		  	"core-js/actual/iterator/for-each": [
		  	"es.object.to-string",
		  	"esnext.iterator.constructor",
		  	"esnext.iterator.for-each"
		  ],
		  	"core-js/actual/iterator/from": [
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"es.promise",
		  	"es.string.iterator",
		  	"esnext.iterator.constructor",
		  	"esnext.iterator.dispose",
		  	"esnext.iterator.drop",
		  	"esnext.iterator.every",
		  	"esnext.iterator.filter",
		  	"esnext.iterator.find",
		  	"esnext.iterator.flat-map",
		  	"esnext.iterator.for-each",
		  	"esnext.iterator.from",
		  	"esnext.iterator.map",
		  	"esnext.iterator.reduce",
		  	"esnext.iterator.some",
		  	"esnext.iterator.take",
		  	"esnext.iterator.to-array",
		  	"esnext.iterator.to-async",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/actual/iterator/map": [
		  	"es.object.to-string",
		  	"esnext.iterator.constructor",
		  	"esnext.iterator.map"
		  ],
		  	"core-js/actual/iterator/reduce": [
		  	"es.object.to-string",
		  	"esnext.iterator.constructor",
		  	"esnext.iterator.reduce"
		  ],
		  	"core-js/actual/iterator/some": [
		  	"es.object.to-string",
		  	"esnext.iterator.constructor",
		  	"esnext.iterator.some"
		  ],
		  	"core-js/actual/iterator/take": [
		  	"es.object.to-string",
		  	"esnext.iterator.constructor",
		  	"esnext.iterator.take"
		  ],
		  	"core-js/actual/iterator/to-array": [
		  	"es.object.to-string",
		  	"esnext.iterator.constructor",
		  	"esnext.iterator.to-array"
		  ],
		  	"core-js/actual/iterator/to-async": [
		  	"es.object.to-string",
		  	"es.promise",
		  	"esnext.iterator.constructor",
		  	"esnext.iterator.to-async"
		  ],
		  	"core-js/actual/json": [
		  	"es.date.to-json",
		  	"es.json.stringify",
		  	"es.json.to-string-tag",
		  	"es.object.create",
		  	"es.object.freeze",
		  	"es.object.keys",
		  	"esnext.json.is-raw-json",
		  	"esnext.json.parse",
		  	"esnext.json.raw-json"
		  ],
		  	"core-js/actual/json/is-raw-json": [
		  	"esnext.json.is-raw-json"
		  ],
		  	"core-js/actual/json/parse": [
		  	"es.object.keys",
		  	"esnext.json.parse"
		  ],
		  	"core-js/actual/json/raw-json": [
		  	"es.object.create",
		  	"es.object.freeze",
		  	"esnext.json.raw-json"
		  ],
		  	"core-js/actual/json/stringify": [
		  	"es.date.to-json",
		  	"es.json.stringify"
		  ],
		  	"core-js/actual/json/to-string-tag": [
		  	"es.json.to-string-tag"
		  ],
		  	"core-js/actual/map": [
		  	"es.array.iterator",
		  	"es.map",
		  	"es.map.group-by",
		  	"es.object.to-string",
		  	"es.string.iterator",
		  	"esnext.map.group-by",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/actual/map/group-by": [
		  	"es.map",
		  	"es.map.group-by",
		  	"es.object.to-string",
		  	"esnext.map.group-by"
		  ],
		  	"core-js/actual/math": [
		  	"es.math.acosh",
		  	"es.math.asinh",
		  	"es.math.atanh",
		  	"es.math.cbrt",
		  	"es.math.clz32",
		  	"es.math.cosh",
		  	"es.math.expm1",
		  	"es.math.fround",
		  	"es.math.hypot",
		  	"es.math.imul",
		  	"es.math.log10",
		  	"es.math.log1p",
		  	"es.math.log2",
		  	"es.math.sign",
		  	"es.math.sinh",
		  	"es.math.tanh",
		  	"es.math.to-string-tag",
		  	"es.math.trunc",
		  	"esnext.math.f16round"
		  ],
		  	"core-js/actual/math/acosh": [
		  	"es.math.acosh"
		  ],
		  	"core-js/actual/math/asinh": [
		  	"es.math.asinh"
		  ],
		  	"core-js/actual/math/atanh": [
		  	"es.math.atanh"
		  ],
		  	"core-js/actual/math/cbrt": [
		  	"es.math.cbrt"
		  ],
		  	"core-js/actual/math/clz32": [
		  	"es.math.clz32"
		  ],
		  	"core-js/actual/math/cosh": [
		  	"es.math.cosh"
		  ],
		  	"core-js/actual/math/expm1": [
		  	"es.math.expm1"
		  ],
		  	"core-js/actual/math/f16round": [
		  	"esnext.math.f16round"
		  ],
		  	"core-js/actual/math/fround": [
		  	"es.math.fround"
		  ],
		  	"core-js/actual/math/hypot": [
		  	"es.math.hypot"
		  ],
		  	"core-js/actual/math/imul": [
		  	"es.math.imul"
		  ],
		  	"core-js/actual/math/log10": [
		  	"es.math.log10"
		  ],
		  	"core-js/actual/math/log1p": [
		  	"es.math.log1p"
		  ],
		  	"core-js/actual/math/log2": [
		  	"es.math.log2"
		  ],
		  	"core-js/actual/math/sign": [
		  	"es.math.sign"
		  ],
		  	"core-js/actual/math/sinh": [
		  	"es.math.sinh"
		  ],
		  	"core-js/actual/math/tanh": [
		  	"es.math.tanh"
		  ],
		  	"core-js/actual/math/to-string-tag": [
		  	"es.math.to-string-tag"
		  ],
		  	"core-js/actual/math/trunc": [
		  	"es.math.trunc"
		  ],
		  	"core-js/actual/number": [
		  	"es.number.constructor",
		  	"es.number.epsilon",
		  	"es.number.is-finite",
		  	"es.number.is-integer",
		  	"es.number.is-nan",
		  	"es.number.is-safe-integer",
		  	"es.number.max-safe-integer",
		  	"es.number.min-safe-integer",
		  	"es.number.parse-float",
		  	"es.number.parse-int",
		  	"es.number.to-exponential",
		  	"es.number.to-fixed",
		  	"es.number.to-precision"
		  ],
		  	"core-js/actual/number/constructor": [
		  	"es.number.constructor"
		  ],
		  	"core-js/actual/number/epsilon": [
		  	"es.number.epsilon"
		  ],
		  	"core-js/actual/number/is-finite": [
		  	"es.number.is-finite"
		  ],
		  	"core-js/actual/number/is-integer": [
		  	"es.number.is-integer"
		  ],
		  	"core-js/actual/number/is-nan": [
		  	"es.number.is-nan"
		  ],
		  	"core-js/actual/number/is-safe-integer": [
		  	"es.number.is-safe-integer"
		  ],
		  	"core-js/actual/number/max-safe-integer": [
		  	"es.number.max-safe-integer"
		  ],
		  	"core-js/actual/number/min-safe-integer": [
		  	"es.number.min-safe-integer"
		  ],
		  	"core-js/actual/number/parse-float": [
		  	"es.number.parse-float"
		  ],
		  	"core-js/actual/number/parse-int": [
		  	"es.number.parse-int"
		  ],
		  	"core-js/actual/number/to-exponential": [
		  	"es.number.to-exponential"
		  ],
		  	"core-js/actual/number/to-fixed": [
		  	"es.number.to-fixed"
		  ],
		  	"core-js/actual/number/to-precision": [
		  	"es.number.to-precision"
		  ],
		  	"core-js/actual/number/virtual": [
		  	"es.number.to-exponential",
		  	"es.number.to-fixed",
		  	"es.number.to-precision"
		  ],
		  	"core-js/actual/number/virtual/to-exponential": [
		  	"es.number.to-exponential"
		  ],
		  	"core-js/actual/number/virtual/to-fixed": [
		  	"es.number.to-fixed"
		  ],
		  	"core-js/actual/number/virtual/to-precision": [
		  	"es.number.to-precision"
		  ],
		  	"core-js/actual/object": [
		  	"es.symbol",
		  	"es.json.to-string-tag",
		  	"es.math.to-string-tag",
		  	"es.object.assign",
		  	"es.object.create",
		  	"es.object.define-getter",
		  	"es.object.define-properties",
		  	"es.object.define-property",
		  	"es.object.define-setter",
		  	"es.object.entries",
		  	"es.object.freeze",
		  	"es.object.from-entries",
		  	"es.object.get-own-property-descriptor",
		  	"es.object.get-own-property-descriptors",
		  	"es.object.get-own-property-names",
		  	"es.object.get-prototype-of",
		  	"es.object.group-by",
		  	"es.object.has-own",
		  	"es.object.is",
		  	"es.object.is-extensible",
		  	"es.object.is-frozen",
		  	"es.object.is-sealed",
		  	"es.object.keys",
		  	"es.object.lookup-getter",
		  	"es.object.lookup-setter",
		  	"es.object.prevent-extensions",
		  	"es.object.proto",
		  	"es.object.seal",
		  	"es.object.set-prototype-of",
		  	"es.object.to-string",
		  	"es.object.values",
		  	"es.reflect.to-string-tag",
		  	"esnext.object.group-by",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/actual/object/assign": [
		  	"es.object.assign"
		  ],
		  	"core-js/actual/object/create": [
		  	"es.object.create"
		  ],
		  	"core-js/actual/object/define-getter": [
		  	"es.object.define-getter"
		  ],
		  	"core-js/actual/object/define-properties": [
		  	"es.object.define-properties"
		  ],
		  	"core-js/actual/object/define-property": [
		  	"es.object.define-property"
		  ],
		  	"core-js/actual/object/define-setter": [
		  	"es.object.define-setter"
		  ],
		  	"core-js/actual/object/entries": [
		  	"es.object.entries"
		  ],
		  	"core-js/actual/object/freeze": [
		  	"es.object.freeze"
		  ],
		  	"core-js/actual/object/from-entries": [
		  	"es.array.iterator",
		  	"es.object.from-entries",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/actual/object/get-own-property-descriptor": [
		  	"es.object.get-own-property-descriptor"
		  ],
		  	"core-js/actual/object/get-own-property-descriptors": [
		  	"es.object.get-own-property-descriptors"
		  ],
		  	"core-js/actual/object/get-own-property-names": [
		  	"es.object.get-own-property-names"
		  ],
		  	"core-js/actual/object/get-own-property-symbols": [
		  	"es.symbol"
		  ],
		  	"core-js/actual/object/get-prototype-of": [
		  	"es.object.get-prototype-of"
		  ],
		  	"core-js/actual/object/group-by": [
		  	"es.object.create",
		  	"es.object.group-by",
		  	"esnext.object.group-by"
		  ],
		  	"core-js/actual/object/has-own": [
		  	"es.object.has-own"
		  ],
		  	"core-js/actual/object/is": [
		  	"es.object.is"
		  ],
		  	"core-js/actual/object/is-extensible": [
		  	"es.object.is-extensible"
		  ],
		  	"core-js/actual/object/is-frozen": [
		  	"es.object.is-frozen"
		  ],
		  	"core-js/actual/object/is-sealed": [
		  	"es.object.is-sealed"
		  ],
		  	"core-js/actual/object/keys": [
		  	"es.object.keys"
		  ],
		  	"core-js/actual/object/lookup-getter": [
		  	"es.object.lookup-getter"
		  ],
		  	"core-js/actual/object/lookup-setter": [
		  	"es.object.lookup-setter"
		  ],
		  	"core-js/actual/object/prevent-extensions": [
		  	"es.object.prevent-extensions"
		  ],
		  	"core-js/actual/object/proto": [
		  	"es.object.proto"
		  ],
		  	"core-js/actual/object/seal": [
		  	"es.object.seal"
		  ],
		  	"core-js/actual/object/set-prototype-of": [
		  	"es.object.set-prototype-of"
		  ],
		  	"core-js/actual/object/to-string": [
		  	"es.json.to-string-tag",
		  	"es.math.to-string-tag",
		  	"es.object.to-string",
		  	"es.reflect.to-string-tag"
		  ],
		  	"core-js/actual/object/values": [
		  	"es.object.values"
		  ],
		  	"core-js/actual/parse-float": [
		  	"es.parse-float"
		  ],
		  	"core-js/actual/parse-int": [
		  	"es.parse-int"
		  ],
		  	"core-js/actual/promise": [
		  	"es.aggregate-error",
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"es.promise",
		  	"es.promise.all-settled",
		  	"es.promise.any",
		  	"es.promise.finally",
		  	"es.promise.with-resolvers",
		  	"es.string.iterator",
		  	"esnext.promise.with-resolvers",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/actual/promise/all-settled": [
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"es.promise",
		  	"es.promise.all-settled",
		  	"es.string.iterator",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/actual/promise/any": [
		  	"es.aggregate-error",
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"es.promise",
		  	"es.promise.any",
		  	"es.string.iterator",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/actual/promise/finally": [
		  	"es.object.to-string",
		  	"es.promise",
		  	"es.promise.finally"
		  ],
		  	"core-js/actual/promise/with-resolvers": [
		  	"es.promise",
		  	"es.promise.with-resolvers",
		  	"esnext.promise.with-resolvers"
		  ],
		  	"core-js/actual/queue-microtask": [
		  	"web.queue-microtask"
		  ],
		  	"core-js/actual/reflect": [
		  	"es.object.to-string",
		  	"es.reflect.apply",
		  	"es.reflect.construct",
		  	"es.reflect.define-property",
		  	"es.reflect.delete-property",
		  	"es.reflect.get",
		  	"es.reflect.get-own-property-descriptor",
		  	"es.reflect.get-prototype-of",
		  	"es.reflect.has",
		  	"es.reflect.is-extensible",
		  	"es.reflect.own-keys",
		  	"es.reflect.prevent-extensions",
		  	"es.reflect.set",
		  	"es.reflect.set-prototype-of",
		  	"es.reflect.to-string-tag"
		  ],
		  	"core-js/actual/reflect/apply": [
		  	"es.reflect.apply"
		  ],
		  	"core-js/actual/reflect/construct": [
		  	"es.reflect.construct"
		  ],
		  	"core-js/actual/reflect/define-property": [
		  	"es.reflect.define-property"
		  ],
		  	"core-js/actual/reflect/delete-property": [
		  	"es.reflect.delete-property"
		  ],
		  	"core-js/actual/reflect/get": [
		  	"es.reflect.get"
		  ],
		  	"core-js/actual/reflect/get-own-property-descriptor": [
		  	"es.reflect.get-own-property-descriptor"
		  ],
		  	"core-js/actual/reflect/get-prototype-of": [
		  	"es.reflect.get-prototype-of"
		  ],
		  	"core-js/actual/reflect/has": [
		  	"es.reflect.has"
		  ],
		  	"core-js/actual/reflect/is-extensible": [
		  	"es.reflect.is-extensible"
		  ],
		  	"core-js/actual/reflect/own-keys": [
		  	"es.reflect.own-keys"
		  ],
		  	"core-js/actual/reflect/prevent-extensions": [
		  	"es.reflect.prevent-extensions"
		  ],
		  	"core-js/actual/reflect/set": [
		  	"es.reflect.set"
		  ],
		  	"core-js/actual/reflect/set-prototype-of": [
		  	"es.reflect.set-prototype-of"
		  ],
		  	"core-js/actual/reflect/to-string-tag": [
		  	"es.reflect.to-string-tag"
		  ],
		  	"core-js/actual/regexp": [
		  	"es.regexp.constructor",
		  	"es.regexp.dot-all",
		  	"es.regexp.exec",
		  	"es.regexp.flags",
		  	"es.regexp.sticky",
		  	"es.regexp.test",
		  	"es.regexp.to-string",
		  	"es.string.match",
		  	"es.string.replace",
		  	"es.string.search",
		  	"es.string.split"
		  ],
		  	"core-js/actual/regexp/constructor": [
		  	"es.regexp.constructor",
		  	"es.regexp.dot-all",
		  	"es.regexp.exec",
		  	"es.regexp.sticky"
		  ],
		  	"core-js/actual/regexp/dot-all": [
		  	"es.regexp.constructor",
		  	"es.regexp.dot-all",
		  	"es.regexp.exec"
		  ],
		  	"core-js/actual/regexp/flags": [
		  	"es.regexp.flags"
		  ],
		  	"core-js/actual/regexp/match": [
		  	"es.regexp.exec",
		  	"es.string.match"
		  ],
		  	"core-js/actual/regexp/replace": [
		  	"es.regexp.exec",
		  	"es.string.replace"
		  ],
		  	"core-js/actual/regexp/search": [
		  	"es.regexp.exec",
		  	"es.string.search"
		  ],
		  	"core-js/actual/regexp/split": [
		  	"es.regexp.exec",
		  	"es.string.split"
		  ],
		  	"core-js/actual/regexp/sticky": [
		  	"es.regexp.constructor",
		  	"es.regexp.exec",
		  	"es.regexp.sticky"
		  ],
		  	"core-js/actual/regexp/test": [
		  	"es.regexp.exec",
		  	"es.regexp.test"
		  ],
		  	"core-js/actual/regexp/to-string": [
		  	"es.regexp.to-string"
		  ],
		  	"core-js/actual/self": [
		  	"web.self"
		  ],
		  	"core-js/actual/set": [
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"es.set",
		  	"es.string.iterator",
		  	"esnext.set.difference.v2",
		  	"esnext.set.intersection.v2",
		  	"esnext.set.is-disjoint-from.v2",
		  	"esnext.set.is-subset-of.v2",
		  	"esnext.set.is-superset-of.v2",
		  	"esnext.set.symmetric-difference.v2",
		  	"esnext.set.union.v2",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/actual/set-immediate": [
		  	"web.immediate"
		  ],
		  	"core-js/actual/set-interval": [
		  	"web.timers"
		  ],
		  	"core-js/actual/set-timeout": [
		  	"web.timers"
		  ],
		  	"core-js/actual/set/difference": [
		  	"es.set",
		  	"esnext.set.difference.v2"
		  ],
		  	"core-js/actual/set/intersection": [
		  	"es.set",
		  	"esnext.set.intersection.v2"
		  ],
		  	"core-js/actual/set/is-disjoint-from": [
		  	"es.set",
		  	"esnext.set.is-disjoint-from.v2"
		  ],
		  	"core-js/actual/set/is-subset-of": [
		  	"es.set",
		  	"esnext.set.is-subset-of.v2"
		  ],
		  	"core-js/actual/set/is-superset-of": [
		  	"es.set",
		  	"esnext.set.is-superset-of.v2"
		  ],
		  	"core-js/actual/set/symmetric-difference": [
		  	"es.set",
		  	"esnext.set.symmetric-difference.v2"
		  ],
		  	"core-js/actual/set/union": [
		  	"es.set",
		  	"esnext.set.union.v2"
		  ],
		  	"core-js/actual/string": [
		  	"es.object.to-string",
		  	"es.regexp.exec",
		  	"es.string.at-alternative",
		  	"es.string.code-point-at",
		  	"es.string.ends-with",
		  	"es.string.from-code-point",
		  	"es.string.includes",
		  	"es.string.is-well-formed",
		  	"es.string.iterator",
		  	"es.string.match",
		  	"es.string.match-all",
		  	"es.string.pad-end",
		  	"es.string.pad-start",
		  	"es.string.raw",
		  	"es.string.repeat",
		  	"es.string.replace",
		  	"es.string.replace-all",
		  	"es.string.search",
		  	"es.string.split",
		  	"es.string.starts-with",
		  	"es.string.substr",
		  	"es.string.to-well-formed",
		  	"es.string.trim",
		  	"es.string.trim-end",
		  	"es.string.trim-start",
		  	"es.string.anchor",
		  	"es.string.big",
		  	"es.string.blink",
		  	"es.string.bold",
		  	"es.string.fixed",
		  	"es.string.fontcolor",
		  	"es.string.fontsize",
		  	"es.string.italics",
		  	"es.string.link",
		  	"es.string.small",
		  	"es.string.strike",
		  	"es.string.sub",
		  	"es.string.sup",
		  	"esnext.string.is-well-formed",
		  	"esnext.string.to-well-formed"
		  ],
		  	"core-js/actual/string/anchor": [
		  	"es.string.anchor"
		  ],
		  	"core-js/actual/string/at": [
		  	"es.string.at-alternative"
		  ],
		  	"core-js/actual/string/big": [
		  	"es.string.big"
		  ],
		  	"core-js/actual/string/blink": [
		  	"es.string.blink"
		  ],
		  	"core-js/actual/string/bold": [
		  	"es.string.bold"
		  ],
		  	"core-js/actual/string/code-point-at": [
		  	"es.string.code-point-at"
		  ],
		  	"core-js/actual/string/ends-with": [
		  	"es.string.ends-with"
		  ],
		  	"core-js/actual/string/fixed": [
		  	"es.string.fixed"
		  ],
		  	"core-js/actual/string/fontcolor": [
		  	"es.string.fontcolor"
		  ],
		  	"core-js/actual/string/fontsize": [
		  	"es.string.fontsize"
		  ],
		  	"core-js/actual/string/from-code-point": [
		  	"es.string.from-code-point"
		  ],
		  	"core-js/actual/string/includes": [
		  	"es.string.includes"
		  ],
		  	"core-js/actual/string/is-well-formed": [
		  	"es.string.is-well-formed",
		  	"esnext.string.is-well-formed"
		  ],
		  	"core-js/actual/string/italics": [
		  	"es.string.italics"
		  ],
		  	"core-js/actual/string/iterator": [
		  	"es.object.to-string",
		  	"es.string.iterator"
		  ],
		  	"core-js/actual/string/link": [
		  	"es.string.link"
		  ],
		  	"core-js/actual/string/match": [
		  	"es.regexp.exec",
		  	"es.string.match"
		  ],
		  	"core-js/actual/string/match-all": [
		  	"es.object.to-string",
		  	"es.regexp.exec",
		  	"es.string.match-all"
		  ],
		  	"core-js/actual/string/pad-end": [
		  	"es.string.pad-end"
		  ],
		  	"core-js/actual/string/pad-start": [
		  	"es.string.pad-start"
		  ],
		  	"core-js/actual/string/raw": [
		  	"es.string.raw"
		  ],
		  	"core-js/actual/string/repeat": [
		  	"es.string.repeat"
		  ],
		  	"core-js/actual/string/replace": [
		  	"es.regexp.exec",
		  	"es.string.replace"
		  ],
		  	"core-js/actual/string/replace-all": [
		  	"es.regexp.exec",
		  	"es.string.replace",
		  	"es.string.replace-all"
		  ],
		  	"core-js/actual/string/search": [
		  	"es.regexp.exec",
		  	"es.string.search"
		  ],
		  	"core-js/actual/string/small": [
		  	"es.string.small"
		  ],
		  	"core-js/actual/string/split": [
		  	"es.regexp.exec",
		  	"es.string.split"
		  ],
		  	"core-js/actual/string/starts-with": [
		  	"es.string.starts-with"
		  ],
		  	"core-js/actual/string/strike": [
		  	"es.string.strike"
		  ],
		  	"core-js/actual/string/sub": [
		  	"es.string.sub"
		  ],
		  	"core-js/actual/string/substr": [
		  	"es.string.substr"
		  ],
		  	"core-js/actual/string/sup": [
		  	"es.string.sup"
		  ],
		  	"core-js/actual/string/to-well-formed": [
		  	"es.string.to-well-formed",
		  	"esnext.string.to-well-formed"
		  ],
		  	"core-js/actual/string/trim": [
		  	"es.string.trim"
		  ],
		  	"core-js/actual/string/trim-end": [
		  	"es.string.trim-end"
		  ],
		  	"core-js/actual/string/trim-left": [
		  	"es.string.trim-start"
		  ],
		  	"core-js/actual/string/trim-right": [
		  	"es.string.trim-end"
		  ],
		  	"core-js/actual/string/trim-start": [
		  	"es.string.trim-start"
		  ],
		  	"core-js/actual/string/virtual": [
		  	"es.object.to-string",
		  	"es.regexp.exec",
		  	"es.string.at-alternative",
		  	"es.string.code-point-at",
		  	"es.string.ends-with",
		  	"es.string.includes",
		  	"es.string.iterator",
		  	"es.string.match",
		  	"es.string.match-all",
		  	"es.string.pad-end",
		  	"es.string.pad-start",
		  	"es.string.repeat",
		  	"es.string.replace",
		  	"es.string.replace-all",
		  	"es.string.search",
		  	"es.string.split",
		  	"es.string.starts-with",
		  	"es.string.substr",
		  	"es.string.trim",
		  	"es.string.trim-end",
		  	"es.string.trim-start",
		  	"es.string.anchor",
		  	"es.string.big",
		  	"es.string.blink",
		  	"es.string.bold",
		  	"es.string.fixed",
		  	"es.string.fontcolor",
		  	"es.string.fontsize",
		  	"es.string.italics",
		  	"es.string.link",
		  	"es.string.small",
		  	"es.string.strike",
		  	"es.string.sub",
		  	"es.string.sup",
		  	"esnext.string.is-well-formed",
		  	"esnext.string.to-well-formed"
		  ],
		  	"core-js/actual/string/virtual/anchor": [
		  	"es.string.anchor"
		  ],
		  	"core-js/actual/string/virtual/at": [
		  	"es.string.at-alternative"
		  ],
		  	"core-js/actual/string/virtual/big": [
		  	"es.string.big"
		  ],
		  	"core-js/actual/string/virtual/blink": [
		  	"es.string.blink"
		  ],
		  	"core-js/actual/string/virtual/bold": [
		  	"es.string.bold"
		  ],
		  	"core-js/actual/string/virtual/code-point-at": [
		  	"es.string.code-point-at"
		  ],
		  	"core-js/actual/string/virtual/ends-with": [
		  	"es.string.ends-with"
		  ],
		  	"core-js/actual/string/virtual/fixed": [
		  	"es.string.fixed"
		  ],
		  	"core-js/actual/string/virtual/fontcolor": [
		  	"es.string.fontcolor"
		  ],
		  	"core-js/actual/string/virtual/fontsize": [
		  	"es.string.fontsize"
		  ],
		  	"core-js/actual/string/virtual/includes": [
		  	"es.string.includes"
		  ],
		  	"core-js/actual/string/virtual/is-well-formed": [
		  	"es.string.is-well-formed",
		  	"esnext.string.is-well-formed"
		  ],
		  	"core-js/actual/string/virtual/italics": [
		  	"es.string.italics"
		  ],
		  	"core-js/actual/string/virtual/iterator": [
		  	"es.object.to-string",
		  	"es.string.iterator"
		  ],
		  	"core-js/actual/string/virtual/link": [
		  	"es.string.link"
		  ],
		  	"core-js/actual/string/virtual/match-all": [
		  	"es.object.to-string",
		  	"es.regexp.exec",
		  	"es.string.match-all"
		  ],
		  	"core-js/actual/string/virtual/pad-end": [
		  	"es.string.pad-end"
		  ],
		  	"core-js/actual/string/virtual/pad-start": [
		  	"es.string.pad-start"
		  ],
		  	"core-js/actual/string/virtual/repeat": [
		  	"es.string.repeat"
		  ],
		  	"core-js/actual/string/virtual/replace-all": [
		  	"es.regexp.exec",
		  	"es.string.replace",
		  	"es.string.replace-all"
		  ],
		  	"core-js/actual/string/virtual/small": [
		  	"es.string.small"
		  ],
		  	"core-js/actual/string/virtual/starts-with": [
		  	"es.string.starts-with"
		  ],
		  	"core-js/actual/string/virtual/strike": [
		  	"es.string.strike"
		  ],
		  	"core-js/actual/string/virtual/sub": [
		  	"es.string.sub"
		  ],
		  	"core-js/actual/string/virtual/substr": [
		  	"es.string.substr"
		  ],
		  	"core-js/actual/string/virtual/sup": [
		  	"es.string.sup"
		  ],
		  	"core-js/actual/string/virtual/to-well-formed": [
		  	"es.string.to-well-formed",
		  	"esnext.string.to-well-formed"
		  ],
		  	"core-js/actual/string/virtual/trim": [
		  	"es.string.trim"
		  ],
		  	"core-js/actual/string/virtual/trim-end": [
		  	"es.string.trim-end"
		  ],
		  	"core-js/actual/string/virtual/trim-left": [
		  	"es.string.trim-start"
		  ],
		  	"core-js/actual/string/virtual/trim-right": [
		  	"es.string.trim-end"
		  ],
		  	"core-js/actual/string/virtual/trim-start": [
		  	"es.string.trim-start"
		  ],
		  	"core-js/actual/structured-clone": [
		  	"es.error.to-string",
		  	"es.array.iterator",
		  	"es.map",
		  	"es.object.keys",
		  	"es.object.to-string",
		  	"es.set",
		  	"web.dom-exception.constructor",
		  	"web.dom-exception.stack",
		  	"web.dom-exception.to-string-tag",
		  	"web.structured-clone"
		  ],
		  	"core-js/actual/suppressed-error": [
		  ],
		  	"core-js/actual/symbol": [
		  	"es.symbol",
		  	"es.symbol.description",
		  	"es.symbol.async-iterator",
		  	"es.symbol.has-instance",
		  	"es.symbol.is-concat-spreadable",
		  	"es.symbol.iterator",
		  	"es.symbol.match",
		  	"es.symbol.match-all",
		  	"es.symbol.replace",
		  	"es.symbol.search",
		  	"es.symbol.species",
		  	"es.symbol.split",
		  	"es.symbol.to-primitive",
		  	"es.symbol.to-string-tag",
		  	"es.symbol.unscopables",
		  	"es.array.concat",
		  	"es.json.to-string-tag",
		  	"es.math.to-string-tag",
		  	"es.object.to-string",
		  	"es.reflect.to-string-tag",
		  	"esnext.function.metadata",
		  	"esnext.symbol.async-dispose",
		  	"esnext.symbol.dispose",
		  	"esnext.symbol.metadata",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/actual/symbol/async-dispose": [
		  	"esnext.symbol.async-dispose"
		  ],
		  	"core-js/actual/symbol/async-iterator": [
		  	"es.symbol.async-iterator"
		  ],
		  	"core-js/actual/symbol/description": [
		  	"es.symbol.description"
		  ],
		  	"core-js/actual/symbol/dispose": [
		  	"esnext.symbol.dispose"
		  ],
		  	"core-js/actual/symbol/for": [
		  	"es.symbol"
		  ],
		  	"core-js/actual/symbol/has-instance": [
		  	"es.symbol.has-instance",
		  	"es.function.has-instance"
		  ],
		  	"core-js/actual/symbol/is-concat-spreadable": [
		  	"es.symbol.is-concat-spreadable",
		  	"es.array.concat"
		  ],
		  	"core-js/actual/symbol/iterator": [
		  	"es.symbol.iterator",
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"es.string.iterator",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/actual/symbol/key-for": [
		  	"es.symbol"
		  ],
		  	"core-js/actual/symbol/match": [
		  	"es.symbol.match",
		  	"es.regexp.exec",
		  	"es.string.match"
		  ],
		  	"core-js/actual/symbol/match-all": [
		  	"es.symbol.match-all",
		  	"es.object.to-string",
		  	"es.regexp.exec",
		  	"es.string.match-all"
		  ],
		  	"core-js/actual/symbol/metadata": [
		  	"esnext.function.metadata",
		  	"esnext.symbol.metadata"
		  ],
		  	"core-js/actual/symbol/replace": [
		  	"es.symbol.replace",
		  	"es.regexp.exec",
		  	"es.string.replace"
		  ],
		  	"core-js/actual/symbol/search": [
		  	"es.symbol.search",
		  	"es.regexp.exec",
		  	"es.string.search"
		  ],
		  	"core-js/actual/symbol/species": [
		  	"es.symbol.species"
		  ],
		  	"core-js/actual/symbol/split": [
		  	"es.symbol.split",
		  	"es.regexp.exec",
		  	"es.string.split"
		  ],
		  	"core-js/actual/symbol/to-primitive": [
		  	"es.symbol.to-primitive",
		  	"es.date.to-primitive"
		  ],
		  	"core-js/actual/symbol/to-string-tag": [
		  	"es.symbol.to-string-tag",
		  	"es.json.to-string-tag",
		  	"es.math.to-string-tag",
		  	"es.object.to-string",
		  	"es.reflect.to-string-tag"
		  ],
		  	"core-js/actual/symbol/unscopables": [
		  	"es.symbol.unscopables"
		  ],
		  	"core-js/actual/typed-array": [
		  	"es.object.to-string",
		  	"es.string.iterator",
		  	"es.typed-array.float32-array",
		  	"es.typed-array.float64-array",
		  	"es.typed-array.int8-array",
		  	"es.typed-array.int16-array",
		  	"es.typed-array.int32-array",
		  	"es.typed-array.uint8-array",
		  	"es.typed-array.uint8-clamped-array",
		  	"es.typed-array.uint16-array",
		  	"es.typed-array.uint32-array",
		  	"es.typed-array.at",
		  	"es.typed-array.copy-within",
		  	"es.typed-array.every",
		  	"es.typed-array.fill",
		  	"es.typed-array.filter",
		  	"es.typed-array.find",
		  	"es.typed-array.find-index",
		  	"es.typed-array.find-last",
		  	"es.typed-array.find-last-index",
		  	"es.typed-array.for-each",
		  	"es.typed-array.from",
		  	"es.typed-array.includes",
		  	"es.typed-array.index-of",
		  	"es.typed-array.iterator",
		  	"es.typed-array.join",
		  	"es.typed-array.last-index-of",
		  	"es.typed-array.map",
		  	"es.typed-array.of",
		  	"es.typed-array.reduce",
		  	"es.typed-array.reduce-right",
		  	"es.typed-array.reverse",
		  	"es.typed-array.set",
		  	"es.typed-array.slice",
		  	"es.typed-array.some",
		  	"es.typed-array.sort",
		  	"es.typed-array.subarray",
		  	"es.typed-array.to-locale-string",
		  	"es.typed-array.to-reversed",
		  	"es.typed-array.to-sorted",
		  	"es.typed-array.to-string",
		  	"es.typed-array.with",
		  	"esnext.typed-array.find-last",
		  	"esnext.typed-array.find-last-index",
		  	"esnext.typed-array.to-reversed",
		  	"esnext.typed-array.to-sorted",
		  	"esnext.typed-array.to-spliced",
		  	"esnext.typed-array.with",
		  	"esnext.uint8-array.from-base64",
		  	"esnext.uint8-array.from-hex",
		  	"esnext.uint8-array.to-base64",
		  	"esnext.uint8-array.to-hex"
		  ],
		  	"core-js/actual/typed-array/at": [
		  	"es.typed-array.at"
		  ],
		  	"core-js/actual/typed-array/copy-within": [
		  	"es.typed-array.copy-within"
		  ],
		  	"core-js/actual/typed-array/entries": [
		  	"es.object.to-string",
		  	"es.typed-array.iterator"
		  ],
		  	"core-js/actual/typed-array/every": [
		  	"es.typed-array.every"
		  ],
		  	"core-js/actual/typed-array/fill": [
		  	"es.typed-array.fill"
		  ],
		  	"core-js/actual/typed-array/filter": [
		  	"es.typed-array.filter"
		  ],
		  	"core-js/actual/typed-array/find": [
		  	"es.typed-array.find"
		  ],
		  	"core-js/actual/typed-array/find-index": [
		  	"es.typed-array.find-index"
		  ],
		  	"core-js/actual/typed-array/find-last": [
		  	"es.typed-array.find-last",
		  	"esnext.typed-array.find-last"
		  ],
		  	"core-js/actual/typed-array/find-last-index": [
		  	"es.typed-array.find-last-index",
		  	"esnext.typed-array.find-last-index"
		  ],
		  	"core-js/actual/typed-array/float32-array": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.object.to-string",
		  	"es.string.iterator",
		  	"es.typed-array.float32-array",
		  	"es.typed-array.at",
		  	"es.typed-array.copy-within",
		  	"es.typed-array.every",
		  	"es.typed-array.fill",
		  	"es.typed-array.filter",
		  	"es.typed-array.find",
		  	"es.typed-array.find-index",
		  	"es.typed-array.find-last",
		  	"es.typed-array.find-last-index",
		  	"es.typed-array.for-each",
		  	"es.typed-array.from",
		  	"es.typed-array.includes",
		  	"es.typed-array.index-of",
		  	"es.typed-array.iterator",
		  	"es.typed-array.join",
		  	"es.typed-array.last-index-of",
		  	"es.typed-array.map",
		  	"es.typed-array.of",
		  	"es.typed-array.reduce",
		  	"es.typed-array.reduce-right",
		  	"es.typed-array.reverse",
		  	"es.typed-array.set",
		  	"es.typed-array.slice",
		  	"es.typed-array.some",
		  	"es.typed-array.sort",
		  	"es.typed-array.subarray",
		  	"es.typed-array.to-locale-string",
		  	"es.typed-array.to-reversed",
		  	"es.typed-array.to-sorted",
		  	"es.typed-array.to-string",
		  	"es.typed-array.with",
		  	"esnext.typed-array.find-last",
		  	"esnext.typed-array.find-last-index",
		  	"esnext.typed-array.to-reversed",
		  	"esnext.typed-array.to-sorted",
		  	"esnext.typed-array.to-spliced",
		  	"esnext.typed-array.with",
		  	"esnext.uint8-array.from-base64",
		  	"esnext.uint8-array.from-hex",
		  	"esnext.uint8-array.to-base64",
		  	"esnext.uint8-array.to-hex"
		  ],
		  	"core-js/actual/typed-array/float64-array": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.object.to-string",
		  	"es.string.iterator",
		  	"es.typed-array.float64-array",
		  	"es.typed-array.at",
		  	"es.typed-array.copy-within",
		  	"es.typed-array.every",
		  	"es.typed-array.fill",
		  	"es.typed-array.filter",
		  	"es.typed-array.find",
		  	"es.typed-array.find-index",
		  	"es.typed-array.find-last",
		  	"es.typed-array.find-last-index",
		  	"es.typed-array.for-each",
		  	"es.typed-array.from",
		  	"es.typed-array.includes",
		  	"es.typed-array.index-of",
		  	"es.typed-array.iterator",
		  	"es.typed-array.join",
		  	"es.typed-array.last-index-of",
		  	"es.typed-array.map",
		  	"es.typed-array.of",
		  	"es.typed-array.reduce",
		  	"es.typed-array.reduce-right",
		  	"es.typed-array.reverse",
		  	"es.typed-array.set",
		  	"es.typed-array.slice",
		  	"es.typed-array.some",
		  	"es.typed-array.sort",
		  	"es.typed-array.subarray",
		  	"es.typed-array.to-locale-string",
		  	"es.typed-array.to-reversed",
		  	"es.typed-array.to-sorted",
		  	"es.typed-array.to-string",
		  	"es.typed-array.with",
		  	"esnext.typed-array.find-last",
		  	"esnext.typed-array.find-last-index",
		  	"esnext.typed-array.to-reversed",
		  	"esnext.typed-array.to-sorted",
		  	"esnext.typed-array.to-spliced",
		  	"esnext.typed-array.with",
		  	"esnext.uint8-array.from-base64",
		  	"esnext.uint8-array.from-hex",
		  	"esnext.uint8-array.to-base64",
		  	"esnext.uint8-array.to-hex"
		  ],
		  	"core-js/actual/typed-array/for-each": [
		  	"es.typed-array.for-each"
		  ],
		  	"core-js/actual/typed-array/from": [
		  	"es.typed-array.from"
		  ],
		  	"core-js/actual/typed-array/from-base64": [
		  	"esnext.uint8-array.from-base64"
		  ],
		  	"core-js/actual/typed-array/from-hex": [
		  	"esnext.uint8-array.from-hex"
		  ],
		  	"core-js/actual/typed-array/includes": [
		  	"es.typed-array.includes"
		  ],
		  	"core-js/actual/typed-array/index-of": [
		  	"es.typed-array.index-of"
		  ],
		  	"core-js/actual/typed-array/int16-array": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.object.to-string",
		  	"es.string.iterator",
		  	"es.typed-array.int16-array",
		  	"es.typed-array.at",
		  	"es.typed-array.copy-within",
		  	"es.typed-array.every",
		  	"es.typed-array.fill",
		  	"es.typed-array.filter",
		  	"es.typed-array.find",
		  	"es.typed-array.find-index",
		  	"es.typed-array.find-last",
		  	"es.typed-array.find-last-index",
		  	"es.typed-array.for-each",
		  	"es.typed-array.from",
		  	"es.typed-array.includes",
		  	"es.typed-array.index-of",
		  	"es.typed-array.iterator",
		  	"es.typed-array.join",
		  	"es.typed-array.last-index-of",
		  	"es.typed-array.map",
		  	"es.typed-array.of",
		  	"es.typed-array.reduce",
		  	"es.typed-array.reduce-right",
		  	"es.typed-array.reverse",
		  	"es.typed-array.set",
		  	"es.typed-array.slice",
		  	"es.typed-array.some",
		  	"es.typed-array.sort",
		  	"es.typed-array.subarray",
		  	"es.typed-array.to-locale-string",
		  	"es.typed-array.to-reversed",
		  	"es.typed-array.to-sorted",
		  	"es.typed-array.to-string",
		  	"es.typed-array.with",
		  	"esnext.typed-array.find-last",
		  	"esnext.typed-array.find-last-index",
		  	"esnext.typed-array.to-reversed",
		  	"esnext.typed-array.to-sorted",
		  	"esnext.typed-array.to-spliced",
		  	"esnext.typed-array.with",
		  	"esnext.uint8-array.from-base64",
		  	"esnext.uint8-array.from-hex",
		  	"esnext.uint8-array.to-base64",
		  	"esnext.uint8-array.to-hex"
		  ],
		  	"core-js/actual/typed-array/int32-array": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.object.to-string",
		  	"es.string.iterator",
		  	"es.typed-array.int32-array",
		  	"es.typed-array.at",
		  	"es.typed-array.copy-within",
		  	"es.typed-array.every",
		  	"es.typed-array.fill",
		  	"es.typed-array.filter",
		  	"es.typed-array.find",
		  	"es.typed-array.find-index",
		  	"es.typed-array.find-last",
		  	"es.typed-array.find-last-index",
		  	"es.typed-array.for-each",
		  	"es.typed-array.from",
		  	"es.typed-array.includes",
		  	"es.typed-array.index-of",
		  	"es.typed-array.iterator",
		  	"es.typed-array.join",
		  	"es.typed-array.last-index-of",
		  	"es.typed-array.map",
		  	"es.typed-array.of",
		  	"es.typed-array.reduce",
		  	"es.typed-array.reduce-right",
		  	"es.typed-array.reverse",
		  	"es.typed-array.set",
		  	"es.typed-array.slice",
		  	"es.typed-array.some",
		  	"es.typed-array.sort",
		  	"es.typed-array.subarray",
		  	"es.typed-array.to-locale-string",
		  	"es.typed-array.to-reversed",
		  	"es.typed-array.to-sorted",
		  	"es.typed-array.to-string",
		  	"es.typed-array.with",
		  	"esnext.typed-array.find-last",
		  	"esnext.typed-array.find-last-index",
		  	"esnext.typed-array.to-reversed",
		  	"esnext.typed-array.to-sorted",
		  	"esnext.typed-array.to-spliced",
		  	"esnext.typed-array.with",
		  	"esnext.uint8-array.from-base64",
		  	"esnext.uint8-array.from-hex",
		  	"esnext.uint8-array.to-base64",
		  	"esnext.uint8-array.to-hex"
		  ],
		  	"core-js/actual/typed-array/int8-array": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.object.to-string",
		  	"es.string.iterator",
		  	"es.typed-array.int8-array",
		  	"es.typed-array.at",
		  	"es.typed-array.copy-within",
		  	"es.typed-array.every",
		  	"es.typed-array.fill",
		  	"es.typed-array.filter",
		  	"es.typed-array.find",
		  	"es.typed-array.find-index",
		  	"es.typed-array.find-last",
		  	"es.typed-array.find-last-index",
		  	"es.typed-array.for-each",
		  	"es.typed-array.from",
		  	"es.typed-array.includes",
		  	"es.typed-array.index-of",
		  	"es.typed-array.iterator",
		  	"es.typed-array.join",
		  	"es.typed-array.last-index-of",
		  	"es.typed-array.map",
		  	"es.typed-array.of",
		  	"es.typed-array.reduce",
		  	"es.typed-array.reduce-right",
		  	"es.typed-array.reverse",
		  	"es.typed-array.set",
		  	"es.typed-array.slice",
		  	"es.typed-array.some",
		  	"es.typed-array.sort",
		  	"es.typed-array.subarray",
		  	"es.typed-array.to-locale-string",
		  	"es.typed-array.to-reversed",
		  	"es.typed-array.to-sorted",
		  	"es.typed-array.to-string",
		  	"es.typed-array.with",
		  	"esnext.typed-array.find-last",
		  	"esnext.typed-array.find-last-index",
		  	"esnext.typed-array.to-reversed",
		  	"esnext.typed-array.to-sorted",
		  	"esnext.typed-array.to-spliced",
		  	"esnext.typed-array.with",
		  	"esnext.uint8-array.from-base64",
		  	"esnext.uint8-array.from-hex",
		  	"esnext.uint8-array.to-base64",
		  	"esnext.uint8-array.to-hex"
		  ],
		  	"core-js/actual/typed-array/iterator": [
		  	"es.object.to-string",
		  	"es.typed-array.iterator"
		  ],
		  	"core-js/actual/typed-array/join": [
		  	"es.typed-array.join"
		  ],
		  	"core-js/actual/typed-array/keys": [
		  	"es.object.to-string",
		  	"es.typed-array.iterator"
		  ],
		  	"core-js/actual/typed-array/last-index-of": [
		  	"es.typed-array.last-index-of"
		  ],
		  	"core-js/actual/typed-array/map": [
		  	"es.typed-array.map"
		  ],
		  	"core-js/actual/typed-array/methods": [
		  	"es.object.to-string",
		  	"es.string.iterator",
		  	"es.typed-array.at",
		  	"es.typed-array.copy-within",
		  	"es.typed-array.every",
		  	"es.typed-array.fill",
		  	"es.typed-array.filter",
		  	"es.typed-array.find",
		  	"es.typed-array.find-index",
		  	"es.typed-array.find-last",
		  	"es.typed-array.find-last-index",
		  	"es.typed-array.for-each",
		  	"es.typed-array.from",
		  	"es.typed-array.includes",
		  	"es.typed-array.index-of",
		  	"es.typed-array.iterator",
		  	"es.typed-array.join",
		  	"es.typed-array.last-index-of",
		  	"es.typed-array.map",
		  	"es.typed-array.of",
		  	"es.typed-array.reduce",
		  	"es.typed-array.reduce-right",
		  	"es.typed-array.reverse",
		  	"es.typed-array.set",
		  	"es.typed-array.slice",
		  	"es.typed-array.some",
		  	"es.typed-array.sort",
		  	"es.typed-array.subarray",
		  	"es.typed-array.to-locale-string",
		  	"es.typed-array.to-reversed",
		  	"es.typed-array.to-sorted",
		  	"es.typed-array.to-string",
		  	"es.typed-array.with",
		  	"esnext.typed-array.find-last",
		  	"esnext.typed-array.find-last-index",
		  	"esnext.typed-array.to-reversed",
		  	"esnext.typed-array.to-sorted",
		  	"esnext.typed-array.to-spliced",
		  	"esnext.typed-array.with",
		  	"esnext.uint8-array.from-base64",
		  	"esnext.uint8-array.from-hex",
		  	"esnext.uint8-array.to-base64",
		  	"esnext.uint8-array.to-hex"
		  ],
		  	"core-js/actual/typed-array/of": [
		  	"es.typed-array.of"
		  ],
		  	"core-js/actual/typed-array/reduce": [
		  	"es.typed-array.reduce"
		  ],
		  	"core-js/actual/typed-array/reduce-right": [
		  	"es.typed-array.reduce-right"
		  ],
		  	"core-js/actual/typed-array/reverse": [
		  	"es.typed-array.reverse"
		  ],
		  	"core-js/actual/typed-array/set": [
		  	"es.typed-array.set"
		  ],
		  	"core-js/actual/typed-array/slice": [
		  	"es.typed-array.slice"
		  ],
		  	"core-js/actual/typed-array/some": [
		  	"es.typed-array.some"
		  ],
		  	"core-js/actual/typed-array/sort": [
		  	"es.typed-array.sort"
		  ],
		  	"core-js/actual/typed-array/subarray": [
		  	"es.typed-array.subarray"
		  ],
		  	"core-js/actual/typed-array/to-base64": [
		  	"esnext.uint8-array.to-base64"
		  ],
		  	"core-js/actual/typed-array/to-hex": [
		  	"esnext.uint8-array.to-hex"
		  ],
		  	"core-js/actual/typed-array/to-locale-string": [
		  	"es.typed-array.to-locale-string"
		  ],
		  	"core-js/actual/typed-array/to-reversed": [
		  	"es.typed-array.to-reversed",
		  	"esnext.typed-array.to-reversed"
		  ],
		  	"core-js/actual/typed-array/to-sorted": [
		  	"es.typed-array.sort",
		  	"es.typed-array.to-sorted",
		  	"esnext.typed-array.to-sorted"
		  ],
		  	"core-js/actual/typed-array/to-spliced": [
		  	"esnext.typed-array.to-spliced"
		  ],
		  	"core-js/actual/typed-array/to-string": [
		  	"es.typed-array.to-string"
		  ],
		  	"core-js/actual/typed-array/uint16-array": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.object.to-string",
		  	"es.string.iterator",
		  	"es.typed-array.uint16-array",
		  	"es.typed-array.at",
		  	"es.typed-array.copy-within",
		  	"es.typed-array.every",
		  	"es.typed-array.fill",
		  	"es.typed-array.filter",
		  	"es.typed-array.find",
		  	"es.typed-array.find-index",
		  	"es.typed-array.find-last",
		  	"es.typed-array.find-last-index",
		  	"es.typed-array.for-each",
		  	"es.typed-array.from",
		  	"es.typed-array.includes",
		  	"es.typed-array.index-of",
		  	"es.typed-array.iterator",
		  	"es.typed-array.join",
		  	"es.typed-array.last-index-of",
		  	"es.typed-array.map",
		  	"es.typed-array.of",
		  	"es.typed-array.reduce",
		  	"es.typed-array.reduce-right",
		  	"es.typed-array.reverse",
		  	"es.typed-array.set",
		  	"es.typed-array.slice",
		  	"es.typed-array.some",
		  	"es.typed-array.sort",
		  	"es.typed-array.subarray",
		  	"es.typed-array.to-locale-string",
		  	"es.typed-array.to-reversed",
		  	"es.typed-array.to-sorted",
		  	"es.typed-array.to-string",
		  	"es.typed-array.with",
		  	"esnext.typed-array.find-last",
		  	"esnext.typed-array.find-last-index",
		  	"esnext.typed-array.to-reversed",
		  	"esnext.typed-array.to-sorted",
		  	"esnext.typed-array.to-spliced",
		  	"esnext.typed-array.with",
		  	"esnext.uint8-array.from-base64",
		  	"esnext.uint8-array.from-hex",
		  	"esnext.uint8-array.to-base64",
		  	"esnext.uint8-array.to-hex"
		  ],
		  	"core-js/actual/typed-array/uint32-array": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.object.to-string",
		  	"es.string.iterator",
		  	"es.typed-array.uint32-array",
		  	"es.typed-array.at",
		  	"es.typed-array.copy-within",
		  	"es.typed-array.every",
		  	"es.typed-array.fill",
		  	"es.typed-array.filter",
		  	"es.typed-array.find",
		  	"es.typed-array.find-index",
		  	"es.typed-array.find-last",
		  	"es.typed-array.find-last-index",
		  	"es.typed-array.for-each",
		  	"es.typed-array.from",
		  	"es.typed-array.includes",
		  	"es.typed-array.index-of",
		  	"es.typed-array.iterator",
		  	"es.typed-array.join",
		  	"es.typed-array.last-index-of",
		  	"es.typed-array.map",
		  	"es.typed-array.of",
		  	"es.typed-array.reduce",
		  	"es.typed-array.reduce-right",
		  	"es.typed-array.reverse",
		  	"es.typed-array.set",
		  	"es.typed-array.slice",
		  	"es.typed-array.some",
		  	"es.typed-array.sort",
		  	"es.typed-array.subarray",
		  	"es.typed-array.to-locale-string",
		  	"es.typed-array.to-reversed",
		  	"es.typed-array.to-sorted",
		  	"es.typed-array.to-string",
		  	"es.typed-array.with",
		  	"esnext.typed-array.find-last",
		  	"esnext.typed-array.find-last-index",
		  	"esnext.typed-array.to-reversed",
		  	"esnext.typed-array.to-sorted",
		  	"esnext.typed-array.to-spliced",
		  	"esnext.typed-array.with",
		  	"esnext.uint8-array.from-base64",
		  	"esnext.uint8-array.from-hex",
		  	"esnext.uint8-array.to-base64",
		  	"esnext.uint8-array.to-hex"
		  ],
		  	"core-js/actual/typed-array/uint8-array": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.object.to-string",
		  	"es.string.iterator",
		  	"es.typed-array.uint8-array",
		  	"es.typed-array.at",
		  	"es.typed-array.copy-within",
		  	"es.typed-array.every",
		  	"es.typed-array.fill",
		  	"es.typed-array.filter",
		  	"es.typed-array.find",
		  	"es.typed-array.find-index",
		  	"es.typed-array.find-last",
		  	"es.typed-array.find-last-index",
		  	"es.typed-array.for-each",
		  	"es.typed-array.from",
		  	"es.typed-array.includes",
		  	"es.typed-array.index-of",
		  	"es.typed-array.iterator",
		  	"es.typed-array.join",
		  	"es.typed-array.last-index-of",
		  	"es.typed-array.map",
		  	"es.typed-array.of",
		  	"es.typed-array.reduce",
		  	"es.typed-array.reduce-right",
		  	"es.typed-array.reverse",
		  	"es.typed-array.set",
		  	"es.typed-array.slice",
		  	"es.typed-array.some",
		  	"es.typed-array.sort",
		  	"es.typed-array.subarray",
		  	"es.typed-array.to-locale-string",
		  	"es.typed-array.to-reversed",
		  	"es.typed-array.to-sorted",
		  	"es.typed-array.to-string",
		  	"es.typed-array.with",
		  	"esnext.typed-array.find-last",
		  	"esnext.typed-array.find-last-index",
		  	"esnext.typed-array.to-reversed",
		  	"esnext.typed-array.to-sorted",
		  	"esnext.typed-array.to-spliced",
		  	"esnext.typed-array.with",
		  	"esnext.uint8-array.from-base64",
		  	"esnext.uint8-array.from-hex",
		  	"esnext.uint8-array.to-base64",
		  	"esnext.uint8-array.to-hex"
		  ],
		  	"core-js/actual/typed-array/uint8-clamped-array": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.object.to-string",
		  	"es.string.iterator",
		  	"es.typed-array.uint8-clamped-array",
		  	"es.typed-array.at",
		  	"es.typed-array.copy-within",
		  	"es.typed-array.every",
		  	"es.typed-array.fill",
		  	"es.typed-array.filter",
		  	"es.typed-array.find",
		  	"es.typed-array.find-index",
		  	"es.typed-array.find-last",
		  	"es.typed-array.find-last-index",
		  	"es.typed-array.for-each",
		  	"es.typed-array.from",
		  	"es.typed-array.includes",
		  	"es.typed-array.index-of",
		  	"es.typed-array.iterator",
		  	"es.typed-array.join",
		  	"es.typed-array.last-index-of",
		  	"es.typed-array.map",
		  	"es.typed-array.of",
		  	"es.typed-array.reduce",
		  	"es.typed-array.reduce-right",
		  	"es.typed-array.reverse",
		  	"es.typed-array.set",
		  	"es.typed-array.slice",
		  	"es.typed-array.some",
		  	"es.typed-array.sort",
		  	"es.typed-array.subarray",
		  	"es.typed-array.to-locale-string",
		  	"es.typed-array.to-reversed",
		  	"es.typed-array.to-sorted",
		  	"es.typed-array.to-string",
		  	"es.typed-array.with",
		  	"esnext.typed-array.find-last",
		  	"esnext.typed-array.find-last-index",
		  	"esnext.typed-array.to-reversed",
		  	"esnext.typed-array.to-sorted",
		  	"esnext.typed-array.to-spliced",
		  	"esnext.typed-array.with",
		  	"esnext.uint8-array.from-base64",
		  	"esnext.uint8-array.from-hex",
		  	"esnext.uint8-array.to-base64",
		  	"esnext.uint8-array.to-hex"
		  ],
		  	"core-js/actual/typed-array/values": [
		  	"es.object.to-string",
		  	"es.typed-array.iterator"
		  ],
		  	"core-js/actual/typed-array/with": [
		  	"es.typed-array.with",
		  	"esnext.typed-array.with"
		  ],
		  	"core-js/actual/unescape": [
		  	"es.unescape"
		  ],
		  	"core-js/actual/url": [
		  	"web.url",
		  	"web.url.can-parse",
		  	"web.url.to-json",
		  	"web.url-search-params",
		  	"web.url-search-params.delete",
		  	"web.url-search-params.has",
		  	"web.url-search-params.size"
		  ],
		  	"core-js/actual/url-search-params": [
		  	"web.dom-collections.iterator",
		  	"web.url-search-params",
		  	"web.url-search-params.delete",
		  	"web.url-search-params.has",
		  	"web.url-search-params.size"
		  ],
		  	"core-js/actual/url/can-parse": [
		  	"web.url",
		  	"web.url.can-parse"
		  ],
		  	"core-js/actual/url/to-json": [
		  	"web.url.to-json"
		  ],
		  	"core-js/actual/weak-map": [
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"es.weak-map",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/actual/weak-set": [
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"es.weak-set",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/es": [
		  	"es.symbol",
		  	"es.symbol.description",
		  	"es.symbol.async-iterator",
		  	"es.symbol.has-instance",
		  	"es.symbol.is-concat-spreadable",
		  	"es.symbol.iterator",
		  	"es.symbol.match",
		  	"es.symbol.match-all",
		  	"es.symbol.replace",
		  	"es.symbol.search",
		  	"es.symbol.species",
		  	"es.symbol.split",
		  	"es.symbol.to-primitive",
		  	"es.symbol.to-string-tag",
		  	"es.symbol.unscopables",
		  	"es.error.cause",
		  	"es.error.to-string",
		  	"es.aggregate-error",
		  	"es.aggregate-error.cause",
		  	"es.array.at",
		  	"es.array.concat",
		  	"es.array.copy-within",
		  	"es.array.every",
		  	"es.array.fill",
		  	"es.array.filter",
		  	"es.array.find",
		  	"es.array.find-index",
		  	"es.array.find-last",
		  	"es.array.find-last-index",
		  	"es.array.flat",
		  	"es.array.flat-map",
		  	"es.array.for-each",
		  	"es.array.from",
		  	"es.array.includes",
		  	"es.array.index-of",
		  	"es.array.is-array",
		  	"es.array.iterator",
		  	"es.array.join",
		  	"es.array.last-index-of",
		  	"es.array.map",
		  	"es.array.of",
		  	"es.array.push",
		  	"es.array.reduce",
		  	"es.array.reduce-right",
		  	"es.array.reverse",
		  	"es.array.slice",
		  	"es.array.some",
		  	"es.array.sort",
		  	"es.array.species",
		  	"es.array.splice",
		  	"es.array.to-reversed",
		  	"es.array.to-sorted",
		  	"es.array.to-spliced",
		  	"es.array.unscopables.flat",
		  	"es.array.unscopables.flat-map",
		  	"es.array.unshift",
		  	"es.array.with",
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.is-view",
		  	"es.array-buffer.slice",
		  	"es.data-view",
		  	"es.array-buffer.detached",
		  	"es.array-buffer.transfer",
		  	"es.array-buffer.transfer-to-fixed-length",
		  	"es.date.get-year",
		  	"es.date.now",
		  	"es.date.set-year",
		  	"es.date.to-gmt-string",
		  	"es.date.to-iso-string",
		  	"es.date.to-json",
		  	"es.date.to-primitive",
		  	"es.date.to-string",
		  	"es.escape",
		  	"es.function.bind",
		  	"es.function.has-instance",
		  	"es.function.name",
		  	"es.global-this",
		  	"es.json.stringify",
		  	"es.json.to-string-tag",
		  	"es.map",
		  	"es.map.group-by",
		  	"es.math.acosh",
		  	"es.math.asinh",
		  	"es.math.atanh",
		  	"es.math.cbrt",
		  	"es.math.clz32",
		  	"es.math.cosh",
		  	"es.math.expm1",
		  	"es.math.fround",
		  	"es.math.hypot",
		  	"es.math.imul",
		  	"es.math.log10",
		  	"es.math.log1p",
		  	"es.math.log2",
		  	"es.math.sign",
		  	"es.math.sinh",
		  	"es.math.tanh",
		  	"es.math.to-string-tag",
		  	"es.math.trunc",
		  	"es.number.constructor",
		  	"es.number.epsilon",
		  	"es.number.is-finite",
		  	"es.number.is-integer",
		  	"es.number.is-nan",
		  	"es.number.is-safe-integer",
		  	"es.number.max-safe-integer",
		  	"es.number.min-safe-integer",
		  	"es.number.parse-float",
		  	"es.number.parse-int",
		  	"es.number.to-exponential",
		  	"es.number.to-fixed",
		  	"es.number.to-precision",
		  	"es.object.assign",
		  	"es.object.create",
		  	"es.object.define-getter",
		  	"es.object.define-properties",
		  	"es.object.define-property",
		  	"es.object.define-setter",
		  	"es.object.entries",
		  	"es.object.freeze",
		  	"es.object.from-entries",
		  	"es.object.get-own-property-descriptor",
		  	"es.object.get-own-property-descriptors",
		  	"es.object.get-own-property-names",
		  	"es.object.get-prototype-of",
		  	"es.object.group-by",
		  	"es.object.has-own",
		  	"es.object.is",
		  	"es.object.is-extensible",
		  	"es.object.is-frozen",
		  	"es.object.is-sealed",
		  	"es.object.keys",
		  	"es.object.lookup-getter",
		  	"es.object.lookup-setter",
		  	"es.object.prevent-extensions",
		  	"es.object.proto",
		  	"es.object.seal",
		  	"es.object.set-prototype-of",
		  	"es.object.to-string",
		  	"es.object.values",
		  	"es.parse-float",
		  	"es.parse-int",
		  	"es.promise",
		  	"es.promise.all-settled",
		  	"es.promise.any",
		  	"es.promise.finally",
		  	"es.promise.with-resolvers",
		  	"es.reflect.apply",
		  	"es.reflect.construct",
		  	"es.reflect.define-property",
		  	"es.reflect.delete-property",
		  	"es.reflect.get",
		  	"es.reflect.get-own-property-descriptor",
		  	"es.reflect.get-prototype-of",
		  	"es.reflect.has",
		  	"es.reflect.is-extensible",
		  	"es.reflect.own-keys",
		  	"es.reflect.prevent-extensions",
		  	"es.reflect.set",
		  	"es.reflect.set-prototype-of",
		  	"es.reflect.to-string-tag",
		  	"es.regexp.constructor",
		  	"es.regexp.dot-all",
		  	"es.regexp.exec",
		  	"es.regexp.flags",
		  	"es.regexp.sticky",
		  	"es.regexp.test",
		  	"es.regexp.to-string",
		  	"es.set",
		  	"es.string.at-alternative",
		  	"es.string.code-point-at",
		  	"es.string.ends-with",
		  	"es.string.from-code-point",
		  	"es.string.includes",
		  	"es.string.is-well-formed",
		  	"es.string.iterator",
		  	"es.string.match",
		  	"es.string.match-all",
		  	"es.string.pad-end",
		  	"es.string.pad-start",
		  	"es.string.raw",
		  	"es.string.repeat",
		  	"es.string.replace",
		  	"es.string.replace-all",
		  	"es.string.search",
		  	"es.string.split",
		  	"es.string.starts-with",
		  	"es.string.substr",
		  	"es.string.to-well-formed",
		  	"es.string.trim",
		  	"es.string.trim-end",
		  	"es.string.trim-start",
		  	"es.string.anchor",
		  	"es.string.big",
		  	"es.string.blink",
		  	"es.string.bold",
		  	"es.string.fixed",
		  	"es.string.fontcolor",
		  	"es.string.fontsize",
		  	"es.string.italics",
		  	"es.string.link",
		  	"es.string.small",
		  	"es.string.strike",
		  	"es.string.sub",
		  	"es.string.sup",
		  	"es.typed-array.float32-array",
		  	"es.typed-array.float64-array",
		  	"es.typed-array.int8-array",
		  	"es.typed-array.int16-array",
		  	"es.typed-array.int32-array",
		  	"es.typed-array.uint8-array",
		  	"es.typed-array.uint8-clamped-array",
		  	"es.typed-array.uint16-array",
		  	"es.typed-array.uint32-array",
		  	"es.typed-array.at",
		  	"es.typed-array.copy-within",
		  	"es.typed-array.every",
		  	"es.typed-array.fill",
		  	"es.typed-array.filter",
		  	"es.typed-array.find",
		  	"es.typed-array.find-index",
		  	"es.typed-array.find-last",
		  	"es.typed-array.find-last-index",
		  	"es.typed-array.for-each",
		  	"es.typed-array.from",
		  	"es.typed-array.includes",
		  	"es.typed-array.index-of",
		  	"es.typed-array.iterator",
		  	"es.typed-array.join",
		  	"es.typed-array.last-index-of",
		  	"es.typed-array.map",
		  	"es.typed-array.of",
		  	"es.typed-array.reduce",
		  	"es.typed-array.reduce-right",
		  	"es.typed-array.reverse",
		  	"es.typed-array.set",
		  	"es.typed-array.slice",
		  	"es.typed-array.some",
		  	"es.typed-array.sort",
		  	"es.typed-array.subarray",
		  	"es.typed-array.to-locale-string",
		  	"es.typed-array.to-reversed",
		  	"es.typed-array.to-sorted",
		  	"es.typed-array.to-string",
		  	"es.typed-array.with",
		  	"es.unescape",
		  	"es.weak-map",
		  	"es.weak-set"
		  ],
		  	"core-js/es/aggregate-error": [
		  ],
		  	"core-js/es/array": [
		  	"es.array.at",
		  	"es.array.concat",
		  	"es.array.copy-within",
		  	"es.array.every",
		  	"es.array.fill",
		  	"es.array.filter",
		  	"es.array.find",
		  	"es.array.find-index",
		  	"es.array.find-last",
		  	"es.array.find-last-index",
		  	"es.array.flat",
		  	"es.array.flat-map",
		  	"es.array.for-each",
		  	"es.array.from",
		  	"es.array.includes",
		  	"es.array.index-of",
		  	"es.array.is-array",
		  	"es.array.iterator",
		  	"es.array.join",
		  	"es.array.last-index-of",
		  	"es.array.map",
		  	"es.array.of",
		  	"es.array.push",
		  	"es.array.reduce",
		  	"es.array.reduce-right",
		  	"es.array.reverse",
		  	"es.array.slice",
		  	"es.array.some",
		  	"es.array.sort",
		  	"es.array.species",
		  	"es.array.splice",
		  	"es.array.to-reversed",
		  	"es.array.to-sorted",
		  	"es.array.to-spliced",
		  	"es.array.unscopables.flat",
		  	"es.array.unscopables.flat-map",
		  	"es.array.unshift",
		  	"es.array.with",
		  	"es.object.to-string",
		  	"es.string.iterator"
		  ],
		  	"core-js/es/array-buffer": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.is-view",
		  	"es.array-buffer.slice",
		  	"es.data-view",
		  	"es.array-buffer.detached",
		  	"es.array-buffer.transfer",
		  	"es.array-buffer.transfer-to-fixed-length",
		  	"es.object.to-string"
		  ],
		  	"core-js/es/array-buffer/constructor": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.array-buffer.detached",
		  	"es.array-buffer.transfer",
		  	"es.array-buffer.transfer-to-fixed-length",
		  	"es.object.to-string"
		  ],
		  	"core-js/es/array-buffer/detached": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.array-buffer.detached"
		  ],
		  	"core-js/es/array-buffer/is-view": [
		  	"es.array-buffer.is-view"
		  ],
		  	"core-js/es/array-buffer/slice": [
		  	"es.array-buffer.slice"
		  ],
		  	"core-js/es/array-buffer/transfer": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.data-view",
		  	"es.array-buffer.transfer"
		  ],
		  	"core-js/es/array-buffer/transfer-to-fixed-length": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.data-view",
		  	"es.array-buffer.transfer-to-fixed-length"
		  ],
		  	"core-js/es/array/at": [
		  	"es.array.at"
		  ],
		  	"core-js/es/array/concat": [
		  	"es.array.concat"
		  ],
		  	"core-js/es/array/copy-within": [
		  	"es.array.copy-within"
		  ],
		  	"core-js/es/array/entries": [
		  	"es.array.iterator",
		  	"es.object.to-string"
		  ],
		  	"core-js/es/array/every": [
		  	"es.array.every"
		  ],
		  	"core-js/es/array/fill": [
		  	"es.array.fill"
		  ],
		  	"core-js/es/array/filter": [
		  	"es.array.filter"
		  ],
		  	"core-js/es/array/find": [
		  	"es.array.find"
		  ],
		  	"core-js/es/array/find-index": [
		  	"es.array.find-index"
		  ],
		  	"core-js/es/array/find-last": [
		  	"es.array.find-last"
		  ],
		  	"core-js/es/array/find-last-index": [
		  	"es.array.find-last-index"
		  ],
		  	"core-js/es/array/flat": [
		  	"es.array.flat",
		  	"es.array.unscopables.flat"
		  ],
		  	"core-js/es/array/flat-map": [
		  	"es.array.flat-map",
		  	"es.array.unscopables.flat-map"
		  ],
		  	"core-js/es/array/for-each": [
		  	"es.array.for-each"
		  ],
		  	"core-js/es/array/from": [
		  	"es.array.from",
		  	"es.string.iterator"
		  ],
		  	"core-js/es/array/includes": [
		  	"es.array.includes"
		  ],
		  	"core-js/es/array/index-of": [
		  	"es.array.index-of"
		  ],
		  	"core-js/es/array/is-array": [
		  	"es.array.is-array"
		  ],
		  	"core-js/es/array/iterator": [
		  	"es.array.iterator",
		  	"es.object.to-string"
		  ],
		  	"core-js/es/array/join": [
		  	"es.array.join"
		  ],
		  	"core-js/es/array/keys": [
		  	"es.array.iterator",
		  	"es.object.to-string"
		  ],
		  	"core-js/es/array/last-index-of": [
		  	"es.array.last-index-of"
		  ],
		  	"core-js/es/array/map": [
		  	"es.array.map"
		  ],
		  	"core-js/es/array/of": [
		  	"es.array.of"
		  ],
		  	"core-js/es/array/push": [
		  	"es.array.push"
		  ],
		  	"core-js/es/array/reduce": [
		  	"es.array.reduce"
		  ],
		  	"core-js/es/array/reduce-right": [
		  	"es.array.reduce-right"
		  ],
		  	"core-js/es/array/reverse": [
		  	"es.array.reverse"
		  ],
		  	"core-js/es/array/slice": [
		  	"es.array.slice"
		  ],
		  	"core-js/es/array/some": [
		  	"es.array.some"
		  ],
		  	"core-js/es/array/sort": [
		  	"es.array.sort"
		  ],
		  	"core-js/es/array/splice": [
		  	"es.array.splice"
		  ],
		  	"core-js/es/array/to-reversed": [
		  	"es.array.to-reversed"
		  ],
		  	"core-js/es/array/to-sorted": [
		  	"es.array.sort",
		  	"es.array.to-sorted"
		  ],
		  	"core-js/es/array/to-spliced": [
		  	"es.array.to-spliced"
		  ],
		  	"core-js/es/array/unshift": [
		  	"es.array.unshift"
		  ],
		  	"core-js/es/array/values": [
		  	"es.array.iterator",
		  	"es.object.to-string"
		  ],
		  	"core-js/es/array/virtual": [
		  	"es.array.at",
		  	"es.array.concat",
		  	"es.array.copy-within",
		  	"es.array.every",
		  	"es.array.fill",
		  	"es.array.filter",
		  	"es.array.find",
		  	"es.array.find-index",
		  	"es.array.find-last",
		  	"es.array.find-last-index",
		  	"es.array.flat",
		  	"es.array.flat-map",
		  	"es.array.for-each",
		  	"es.array.includes",
		  	"es.array.index-of",
		  	"es.array.iterator",
		  	"es.array.join",
		  	"es.array.last-index-of",
		  	"es.array.map",
		  	"es.array.push",
		  	"es.array.reduce",
		  	"es.array.reduce-right",
		  	"es.array.reverse",
		  	"es.array.slice",
		  	"es.array.some",
		  	"es.array.sort",
		  	"es.array.species",
		  	"es.array.splice",
		  	"es.array.to-reversed",
		  	"es.array.to-sorted",
		  	"es.array.to-spliced",
		  	"es.array.unscopables.flat",
		  	"es.array.unscopables.flat-map",
		  	"es.array.unshift",
		  	"es.array.with",
		  	"es.object.to-string"
		  ],
		  	"core-js/es/array/virtual/at": [
		  	"es.array.at"
		  ],
		  	"core-js/es/array/virtual/concat": [
		  	"es.array.concat"
		  ],
		  	"core-js/es/array/virtual/copy-within": [
		  	"es.array.copy-within"
		  ],
		  	"core-js/es/array/virtual/entries": [
		  	"es.array.iterator",
		  	"es.object.to-string"
		  ],
		  	"core-js/es/array/virtual/every": [
		  	"es.array.every"
		  ],
		  	"core-js/es/array/virtual/fill": [
		  	"es.array.fill"
		  ],
		  	"core-js/es/array/virtual/filter": [
		  	"es.array.filter"
		  ],
		  	"core-js/es/array/virtual/find": [
		  	"es.array.find"
		  ],
		  	"core-js/es/array/virtual/find-index": [
		  	"es.array.find-index"
		  ],
		  	"core-js/es/array/virtual/find-last": [
		  	"es.array.find-last"
		  ],
		  	"core-js/es/array/virtual/find-last-index": [
		  	"es.array.find-last-index"
		  ],
		  	"core-js/es/array/virtual/flat": [
		  	"es.array.flat",
		  	"es.array.unscopables.flat"
		  ],
		  	"core-js/es/array/virtual/flat-map": [
		  	"es.array.flat-map",
		  	"es.array.unscopables.flat-map"
		  ],
		  	"core-js/es/array/virtual/for-each": [
		  	"es.array.for-each"
		  ],
		  	"core-js/es/array/virtual/includes": [
		  	"es.array.includes"
		  ],
		  	"core-js/es/array/virtual/index-of": [
		  	"es.array.index-of"
		  ],
		  	"core-js/es/array/virtual/iterator": [
		  	"es.array.iterator",
		  	"es.object.to-string"
		  ],
		  	"core-js/es/array/virtual/join": [
		  	"es.array.join"
		  ],
		  	"core-js/es/array/virtual/keys": [
		  	"es.array.iterator",
		  	"es.object.to-string"
		  ],
		  	"core-js/es/array/virtual/last-index-of": [
		  	"es.array.last-index-of"
		  ],
		  	"core-js/es/array/virtual/map": [
		  	"es.array.map"
		  ],
		  	"core-js/es/array/virtual/push": [
		  	"es.array.push"
		  ],
		  	"core-js/es/array/virtual/reduce": [
		  	"es.array.reduce"
		  ],
		  	"core-js/es/array/virtual/reduce-right": [
		  	"es.array.reduce-right"
		  ],
		  	"core-js/es/array/virtual/reverse": [
		  	"es.array.reverse"
		  ],
		  	"core-js/es/array/virtual/slice": [
		  	"es.array.slice"
		  ],
		  	"core-js/es/array/virtual/some": [
		  	"es.array.some"
		  ],
		  	"core-js/es/array/virtual/sort": [
		  	"es.array.sort"
		  ],
		  	"core-js/es/array/virtual/splice": [
		  	"es.array.splice"
		  ],
		  	"core-js/es/array/virtual/to-reversed": [
		  	"es.array.to-reversed"
		  ],
		  	"core-js/es/array/virtual/to-sorted": [
		  	"es.array.sort",
		  	"es.array.to-sorted"
		  ],
		  	"core-js/es/array/virtual/to-spliced": [
		  	"es.array.to-spliced"
		  ],
		  	"core-js/es/array/virtual/unshift": [
		  	"es.array.unshift"
		  ],
		  	"core-js/es/array/virtual/values": [
		  	"es.array.iterator",
		  	"es.object.to-string"
		  ],
		  	"core-js/es/array/virtual/with": [
		  	"es.array.with"
		  ],
		  	"core-js/es/array/with": [
		  	"es.array.with"
		  ],
		  	"core-js/es/data-view": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.data-view",
		  	"es.object.to-string"
		  ],
		  	"core-js/es/date": [
		  	"es.date.get-year",
		  	"es.date.now",
		  	"es.date.set-year",
		  	"es.date.to-gmt-string",
		  	"es.date.to-iso-string",
		  	"es.date.to-json",
		  	"es.date.to-primitive",
		  	"es.date.to-string"
		  ],
		  	"core-js/es/date/get-year": [
		  	"es.date.get-year"
		  ],
		  	"core-js/es/date/now": [
		  	"es.date.now"
		  ],
		  	"core-js/es/date/set-year": [
		  	"es.date.set-year"
		  ],
		  	"core-js/es/date/to-gmt-string": [
		  	"es.date.to-gmt-string"
		  ],
		  	"core-js/es/date/to-iso-string": [
		  	"es.date.to-iso-string",
		  	"es.date.to-json"
		  ],
		  	"core-js/es/date/to-json": [
		  	"es.date.to-json"
		  ],
		  	"core-js/es/date/to-primitive": [
		  	"es.date.to-primitive"
		  ],
		  	"core-js/es/date/to-string": [
		  	"es.date.to-string"
		  ],
		  	"core-js/es/error": [
		  	"es.error.cause",
		  	"es.error.to-string"
		  ],
		  	"core-js/es/error/constructor": [
		  	"es.error.cause"
		  ],
		  	"core-js/es/error/to-string": [
		  	"es.error.to-string"
		  ],
		  	"core-js/es/escape": [
		  	"es.escape"
		  ],
		  	"core-js/es/function": [
		  	"es.function.bind",
		  	"es.function.has-instance",
		  	"es.function.name"
		  ],
		  	"core-js/es/function/bind": [
		  	"es.function.bind"
		  ],
		  	"core-js/es/function/has-instance": [
		  	"es.function.has-instance"
		  ],
		  	"core-js/es/function/name": [
		  	"es.function.name"
		  ],
		  	"core-js/es/function/virtual": [
		  	"es.function.bind"
		  ],
		  	"core-js/es/function/virtual/bind": [
		  	"es.function.bind"
		  ],
		  	"core-js/es/get-iterator": [
		  	"es.array.iterator",
		  	"es.string.iterator"
		  ],
		  	"core-js/es/get-iterator-method": [
		  	"es.array.iterator",
		  	"es.string.iterator"
		  ],
		  	"core-js/es/global-this": [
		  	"es.global-this"
		  ],
		  	"core-js/es/instance/at": [
		  	"es.array.at",
		  	"es.string.at-alternative"
		  ],
		  	"core-js/es/instance/bind": [
		  	"es.function.bind"
		  ],
		  	"core-js/es/instance/code-point-at": [
		  	"es.string.code-point-at"
		  ],
		  	"core-js/es/instance/concat": [
		  	"es.array.concat"
		  ],
		  	"core-js/es/instance/copy-within": [
		  	"es.array.copy-within"
		  ],
		  	"core-js/es/instance/ends-with": [
		  	"es.string.ends-with"
		  ],
		  	"core-js/es/instance/entries": [
		  	"es.array.iterator",
		  	"es.object.to-string"
		  ],
		  	"core-js/es/instance/every": [
		  	"es.array.every"
		  ],
		  	"core-js/es/instance/fill": [
		  	"es.array.fill"
		  ],
		  	"core-js/es/instance/filter": [
		  	"es.array.filter"
		  ],
		  	"core-js/es/instance/find": [
		  	"es.array.find"
		  ],
		  	"core-js/es/instance/find-index": [
		  	"es.array.find-index"
		  ],
		  	"core-js/es/instance/find-last": [
		  	"es.array.find-last"
		  ],
		  	"core-js/es/instance/find-last-index": [
		  	"es.array.find-last-index"
		  ],
		  	"core-js/es/instance/flags": [
		  	"es.regexp.flags"
		  ],
		  	"core-js/es/instance/flat": [
		  	"es.array.flat",
		  	"es.array.unscopables.flat"
		  ],
		  	"core-js/es/instance/flat-map": [
		  	"es.array.flat-map",
		  	"es.array.unscopables.flat-map"
		  ],
		  	"core-js/es/instance/for-each": [
		  	"es.array.for-each"
		  ],
		  	"core-js/es/instance/includes": [
		  	"es.array.includes",
		  	"es.string.includes"
		  ],
		  	"core-js/es/instance/index-of": [
		  	"es.array.index-of"
		  ],
		  	"core-js/es/instance/is-well-formed": [
		  	"es.string.is-well-formed"
		  ],
		  	"core-js/es/instance/keys": [
		  	"es.array.iterator",
		  	"es.object.to-string"
		  ],
		  	"core-js/es/instance/last-index-of": [
		  	"es.array.last-index-of"
		  ],
		  	"core-js/es/instance/map": [
		  	"es.array.map"
		  ],
		  	"core-js/es/instance/match-all": [
		  	"es.object.to-string",
		  	"es.regexp.exec",
		  	"es.string.match-all"
		  ],
		  	"core-js/es/instance/pad-end": [
		  	"es.string.pad-end"
		  ],
		  	"core-js/es/instance/pad-start": [
		  	"es.string.pad-start"
		  ],
		  	"core-js/es/instance/push": [
		  	"es.array.push"
		  ],
		  	"core-js/es/instance/reduce": [
		  	"es.array.reduce"
		  ],
		  	"core-js/es/instance/reduce-right": [
		  	"es.array.reduce-right"
		  ],
		  	"core-js/es/instance/repeat": [
		  	"es.string.repeat"
		  ],
		  	"core-js/es/instance/replace-all": [
		  	"es.regexp.exec",
		  	"es.string.replace",
		  	"es.string.replace-all"
		  ],
		  	"core-js/es/instance/reverse": [
		  	"es.array.reverse"
		  ],
		  	"core-js/es/instance/slice": [
		  	"es.array.slice"
		  ],
		  	"core-js/es/instance/some": [
		  	"es.array.some"
		  ],
		  	"core-js/es/instance/sort": [
		  	"es.array.sort"
		  ],
		  	"core-js/es/instance/splice": [
		  	"es.array.splice"
		  ],
		  	"core-js/es/instance/starts-with": [
		  	"es.string.starts-with"
		  ],
		  	"core-js/es/instance/to-reversed": [
		  	"es.array.to-reversed"
		  ],
		  	"core-js/es/instance/to-sorted": [
		  	"es.array.sort",
		  	"es.array.to-sorted"
		  ],
		  	"core-js/es/instance/to-spliced": [
		  	"es.array.to-spliced"
		  ],
		  	"core-js/es/instance/to-well-formed": [
		  	"es.string.to-well-formed"
		  ],
		  	"core-js/es/instance/trim": [
		  	"es.string.trim"
		  ],
		  	"core-js/es/instance/trim-end": [
		  	"es.string.trim-end"
		  ],
		  	"core-js/es/instance/trim-left": [
		  	"es.string.trim-start"
		  ],
		  	"core-js/es/instance/trim-right": [
		  	"es.string.trim-end"
		  ],
		  	"core-js/es/instance/trim-start": [
		  	"es.string.trim-start"
		  ],
		  	"core-js/es/instance/unshift": [
		  	"es.array.unshift"
		  ],
		  	"core-js/es/instance/values": [
		  	"es.array.iterator",
		  	"es.object.to-string"
		  ],
		  	"core-js/es/instance/with": [
		  	"es.array.with"
		  ],
		  	"core-js/es/is-iterable": [
		  	"es.array.iterator",
		  	"es.string.iterator"
		  ],
		  	"core-js/es/json": [
		  	"es.date.to-json",
		  	"es.json.stringify",
		  	"es.json.to-string-tag"
		  ],
		  	"core-js/es/json/stringify": [
		  	"es.date.to-json",
		  	"es.json.stringify"
		  ],
		  	"core-js/es/json/to-string-tag": [
		  	"es.json.to-string-tag"
		  ],
		  	"core-js/es/map": [
		  	"es.array.iterator",
		  	"es.map",
		  	"es.map.group-by",
		  	"es.object.to-string",
		  	"es.string.iterator"
		  ],
		  	"core-js/es/map/group-by": [
		  	"es.map",
		  	"es.map.group-by",
		  	"es.object.to-string"
		  ],
		  	"core-js/es/math": [
		  	"es.math.acosh",
		  	"es.math.asinh",
		  	"es.math.atanh",
		  	"es.math.cbrt",
		  	"es.math.clz32",
		  	"es.math.cosh",
		  	"es.math.expm1",
		  	"es.math.fround",
		  	"es.math.hypot",
		  	"es.math.imul",
		  	"es.math.log10",
		  	"es.math.log1p",
		  	"es.math.log2",
		  	"es.math.sign",
		  	"es.math.sinh",
		  	"es.math.tanh",
		  	"es.math.to-string-tag",
		  	"es.math.trunc"
		  ],
		  	"core-js/es/math/acosh": [
		  	"es.math.acosh"
		  ],
		  	"core-js/es/math/asinh": [
		  	"es.math.asinh"
		  ],
		  	"core-js/es/math/atanh": [
		  	"es.math.atanh"
		  ],
		  	"core-js/es/math/cbrt": [
		  	"es.math.cbrt"
		  ],
		  	"core-js/es/math/clz32": [
		  	"es.math.clz32"
		  ],
		  	"core-js/es/math/cosh": [
		  	"es.math.cosh"
		  ],
		  	"core-js/es/math/expm1": [
		  	"es.math.expm1"
		  ],
		  	"core-js/es/math/fround": [
		  	"es.math.fround"
		  ],
		  	"core-js/es/math/hypot": [
		  	"es.math.hypot"
		  ],
		  	"core-js/es/math/imul": [
		  	"es.math.imul"
		  ],
		  	"core-js/es/math/log10": [
		  	"es.math.log10"
		  ],
		  	"core-js/es/math/log1p": [
		  	"es.math.log1p"
		  ],
		  	"core-js/es/math/log2": [
		  	"es.math.log2"
		  ],
		  	"core-js/es/math/sign": [
		  	"es.math.sign"
		  ],
		  	"core-js/es/math/sinh": [
		  	"es.math.sinh"
		  ],
		  	"core-js/es/math/tanh": [
		  	"es.math.tanh"
		  ],
		  	"core-js/es/math/to-string-tag": [
		  	"es.math.to-string-tag"
		  ],
		  	"core-js/es/math/trunc": [
		  	"es.math.trunc"
		  ],
		  	"core-js/es/number": [
		  	"es.number.constructor",
		  	"es.number.epsilon",
		  	"es.number.is-finite",
		  	"es.number.is-integer",
		  	"es.number.is-nan",
		  	"es.number.is-safe-integer",
		  	"es.number.max-safe-integer",
		  	"es.number.min-safe-integer",
		  	"es.number.parse-float",
		  	"es.number.parse-int",
		  	"es.number.to-exponential",
		  	"es.number.to-fixed",
		  	"es.number.to-precision"
		  ],
		  	"core-js/es/number/constructor": [
		  	"es.number.constructor"
		  ],
		  	"core-js/es/number/epsilon": [
		  	"es.number.epsilon"
		  ],
		  	"core-js/es/number/is-finite": [
		  	"es.number.is-finite"
		  ],
		  	"core-js/es/number/is-integer": [
		  	"es.number.is-integer"
		  ],
		  	"core-js/es/number/is-nan": [
		  	"es.number.is-nan"
		  ],
		  	"core-js/es/number/is-safe-integer": [
		  	"es.number.is-safe-integer"
		  ],
		  	"core-js/es/number/max-safe-integer": [
		  	"es.number.max-safe-integer"
		  ],
		  	"core-js/es/number/min-safe-integer": [
		  	"es.number.min-safe-integer"
		  ],
		  	"core-js/es/number/parse-float": [
		  	"es.number.parse-float"
		  ],
		  	"core-js/es/number/parse-int": [
		  	"es.number.parse-int"
		  ],
		  	"core-js/es/number/to-exponential": [
		  	"es.number.to-exponential"
		  ],
		  	"core-js/es/number/to-fixed": [
		  	"es.number.to-fixed"
		  ],
		  	"core-js/es/number/to-precision": [
		  	"es.number.to-precision"
		  ],
		  	"core-js/es/number/virtual": [
		  	"es.number.to-exponential",
		  	"es.number.to-fixed",
		  	"es.number.to-precision"
		  ],
		  	"core-js/es/number/virtual/to-exponential": [
		  	"es.number.to-exponential"
		  ],
		  	"core-js/es/number/virtual/to-fixed": [
		  	"es.number.to-fixed"
		  ],
		  	"core-js/es/number/virtual/to-precision": [
		  	"es.number.to-precision"
		  ],
		  	"core-js/es/object": [
		  	"es.symbol",
		  	"es.json.to-string-tag",
		  	"es.math.to-string-tag",
		  	"es.object.assign",
		  	"es.object.create",
		  	"es.object.define-getter",
		  	"es.object.define-properties",
		  	"es.object.define-property",
		  	"es.object.define-setter",
		  	"es.object.entries",
		  	"es.object.freeze",
		  	"es.object.from-entries",
		  	"es.object.get-own-property-descriptor",
		  	"es.object.get-own-property-descriptors",
		  	"es.object.get-own-property-names",
		  	"es.object.get-prototype-of",
		  	"es.object.group-by",
		  	"es.object.has-own",
		  	"es.object.is",
		  	"es.object.is-extensible",
		  	"es.object.is-frozen",
		  	"es.object.is-sealed",
		  	"es.object.keys",
		  	"es.object.lookup-getter",
		  	"es.object.lookup-setter",
		  	"es.object.prevent-extensions",
		  	"es.object.proto",
		  	"es.object.seal",
		  	"es.object.set-prototype-of",
		  	"es.object.to-string",
		  	"es.object.values",
		  	"es.reflect.to-string-tag"
		  ],
		  	"core-js/es/object/assign": [
		  	"es.object.assign"
		  ],
		  	"core-js/es/object/create": [
		  	"es.object.create"
		  ],
		  	"core-js/es/object/define-getter": [
		  	"es.object.define-getter"
		  ],
		  	"core-js/es/object/define-properties": [
		  	"es.object.define-properties"
		  ],
		  	"core-js/es/object/define-property": [
		  	"es.object.define-property"
		  ],
		  	"core-js/es/object/define-setter": [
		  	"es.object.define-setter"
		  ],
		  	"core-js/es/object/entries": [
		  	"es.object.entries"
		  ],
		  	"core-js/es/object/freeze": [
		  	"es.object.freeze"
		  ],
		  	"core-js/es/object/from-entries": [
		  	"es.array.iterator",
		  	"es.object.from-entries"
		  ],
		  	"core-js/es/object/get-own-property-descriptor": [
		  	"es.object.get-own-property-descriptor"
		  ],
		  	"core-js/es/object/get-own-property-descriptors": [
		  	"es.object.get-own-property-descriptors"
		  ],
		  	"core-js/es/object/get-own-property-names": [
		  	"es.object.get-own-property-names"
		  ],
		  	"core-js/es/object/get-own-property-symbols": [
		  	"es.symbol"
		  ],
		  	"core-js/es/object/get-prototype-of": [
		  	"es.object.get-prototype-of"
		  ],
		  	"core-js/es/object/group-by": [
		  	"es.object.create",
		  	"es.object.group-by"
		  ],
		  	"core-js/es/object/has-own": [
		  	"es.object.has-own"
		  ],
		  	"core-js/es/object/is": [
		  	"es.object.is"
		  ],
		  	"core-js/es/object/is-extensible": [
		  	"es.object.is-extensible"
		  ],
		  	"core-js/es/object/is-frozen": [
		  	"es.object.is-frozen"
		  ],
		  	"core-js/es/object/is-sealed": [
		  	"es.object.is-sealed"
		  ],
		  	"core-js/es/object/keys": [
		  	"es.object.keys"
		  ],
		  	"core-js/es/object/lookup-getter": [
		  	"es.object.lookup-getter"
		  ],
		  	"core-js/es/object/lookup-setter": [
		  	"es.object.lookup-setter"
		  ],
		  	"core-js/es/object/prevent-extensions": [
		  	"es.object.prevent-extensions"
		  ],
		  	"core-js/es/object/proto": [
		  	"es.object.proto"
		  ],
		  	"core-js/es/object/seal": [
		  	"es.object.seal"
		  ],
		  	"core-js/es/object/set-prototype-of": [
		  	"es.object.set-prototype-of"
		  ],
		  	"core-js/es/object/to-string": [
		  	"es.json.to-string-tag",
		  	"es.math.to-string-tag",
		  	"es.object.to-string",
		  	"es.reflect.to-string-tag"
		  ],
		  	"core-js/es/object/values": [
		  	"es.object.values"
		  ],
		  	"core-js/es/parse-float": [
		  	"es.parse-float"
		  ],
		  	"core-js/es/parse-int": [
		  	"es.parse-int"
		  ],
		  	"core-js/es/promise": [
		  	"es.aggregate-error",
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"es.promise",
		  	"es.promise.all-settled",
		  	"es.promise.any",
		  	"es.promise.finally",
		  	"es.promise.with-resolvers",
		  	"es.string.iterator"
		  ],
		  	"core-js/es/promise/all-settled": [
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"es.promise",
		  	"es.promise.all-settled",
		  	"es.string.iterator"
		  ],
		  	"core-js/es/promise/any": [
		  	"es.aggregate-error",
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"es.promise",
		  	"es.promise.any",
		  	"es.string.iterator"
		  ],
		  	"core-js/es/promise/finally": [
		  	"es.object.to-string",
		  	"es.promise",
		  	"es.promise.finally"
		  ],
		  	"core-js/es/promise/with-resolvers": [
		  	"es.promise",
		  	"es.promise.with-resolvers"
		  ],
		  	"core-js/es/reflect": [
		  	"es.object.to-string",
		  	"es.reflect.apply",
		  	"es.reflect.construct",
		  	"es.reflect.define-property",
		  	"es.reflect.delete-property",
		  	"es.reflect.get",
		  	"es.reflect.get-own-property-descriptor",
		  	"es.reflect.get-prototype-of",
		  	"es.reflect.has",
		  	"es.reflect.is-extensible",
		  	"es.reflect.own-keys",
		  	"es.reflect.prevent-extensions",
		  	"es.reflect.set",
		  	"es.reflect.set-prototype-of",
		  	"es.reflect.to-string-tag"
		  ],
		  	"core-js/es/reflect/apply": [
		  	"es.reflect.apply"
		  ],
		  	"core-js/es/reflect/construct": [
		  	"es.reflect.construct"
		  ],
		  	"core-js/es/reflect/define-property": [
		  	"es.reflect.define-property"
		  ],
		  	"core-js/es/reflect/delete-property": [
		  	"es.reflect.delete-property"
		  ],
		  	"core-js/es/reflect/get": [
		  	"es.reflect.get"
		  ],
		  	"core-js/es/reflect/get-own-property-descriptor": [
		  	"es.reflect.get-own-property-descriptor"
		  ],
		  	"core-js/es/reflect/get-prototype-of": [
		  	"es.reflect.get-prototype-of"
		  ],
		  	"core-js/es/reflect/has": [
		  	"es.reflect.has"
		  ],
		  	"core-js/es/reflect/is-extensible": [
		  	"es.reflect.is-extensible"
		  ],
		  	"core-js/es/reflect/own-keys": [
		  	"es.reflect.own-keys"
		  ],
		  	"core-js/es/reflect/prevent-extensions": [
		  	"es.reflect.prevent-extensions"
		  ],
		  	"core-js/es/reflect/set": [
		  	"es.reflect.set"
		  ],
		  	"core-js/es/reflect/set-prototype-of": [
		  	"es.reflect.set-prototype-of"
		  ],
		  	"core-js/es/reflect/to-string-tag": [
		  	"es.object.to-string",
		  	"es.reflect.to-string-tag"
		  ],
		  	"core-js/es/regexp": [
		  	"es.regexp.constructor",
		  	"es.regexp.dot-all",
		  	"es.regexp.exec",
		  	"es.regexp.flags",
		  	"es.regexp.sticky",
		  	"es.regexp.test",
		  	"es.regexp.to-string",
		  	"es.string.match",
		  	"es.string.replace",
		  	"es.string.search",
		  	"es.string.split"
		  ],
		  	"core-js/es/regexp/constructor": [
		  	"es.regexp.constructor",
		  	"es.regexp.dot-all",
		  	"es.regexp.exec",
		  	"es.regexp.sticky"
		  ],
		  	"core-js/es/regexp/dot-all": [
		  	"es.regexp.constructor",
		  	"es.regexp.dot-all",
		  	"es.regexp.exec"
		  ],
		  	"core-js/es/regexp/flags": [
		  	"es.regexp.flags"
		  ],
		  	"core-js/es/regexp/match": [
		  	"es.regexp.exec",
		  	"es.string.match"
		  ],
		  	"core-js/es/regexp/replace": [
		  	"es.regexp.exec",
		  	"es.string.replace"
		  ],
		  	"core-js/es/regexp/search": [
		  	"es.regexp.exec",
		  	"es.string.search"
		  ],
		  	"core-js/es/regexp/split": [
		  	"es.regexp.exec",
		  	"es.string.split"
		  ],
		  	"core-js/es/regexp/sticky": [
		  	"es.regexp.constructor",
		  	"es.regexp.exec",
		  	"es.regexp.sticky"
		  ],
		  	"core-js/es/regexp/test": [
		  	"es.regexp.exec",
		  	"es.regexp.test"
		  ],
		  	"core-js/es/regexp/to-string": [
		  	"es.regexp.to-string"
		  ],
		  	"core-js/es/set": [
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"es.set",
		  	"es.string.iterator"
		  ],
		  	"core-js/es/string": [
		  	"es.object.to-string",
		  	"es.regexp.exec",
		  	"es.string.at-alternative",
		  	"es.string.code-point-at",
		  	"es.string.ends-with",
		  	"es.string.from-code-point",
		  	"es.string.includes",
		  	"es.string.is-well-formed",
		  	"es.string.iterator",
		  	"es.string.match",
		  	"es.string.match-all",
		  	"es.string.pad-end",
		  	"es.string.pad-start",
		  	"es.string.raw",
		  	"es.string.repeat",
		  	"es.string.replace",
		  	"es.string.replace-all",
		  	"es.string.search",
		  	"es.string.split",
		  	"es.string.starts-with",
		  	"es.string.substr",
		  	"es.string.to-well-formed",
		  	"es.string.trim",
		  	"es.string.trim-end",
		  	"es.string.trim-start",
		  	"es.string.anchor",
		  	"es.string.big",
		  	"es.string.blink",
		  	"es.string.bold",
		  	"es.string.fixed",
		  	"es.string.fontcolor",
		  	"es.string.fontsize",
		  	"es.string.italics",
		  	"es.string.link",
		  	"es.string.small",
		  	"es.string.strike",
		  	"es.string.sub",
		  	"es.string.sup"
		  ],
		  	"core-js/es/string/anchor": [
		  	"es.string.anchor"
		  ],
		  	"core-js/es/string/at": [
		  	"es.string.at-alternative"
		  ],
		  	"core-js/es/string/big": [
		  	"es.string.big"
		  ],
		  	"core-js/es/string/blink": [
		  	"es.string.blink"
		  ],
		  	"core-js/es/string/bold": [
		  	"es.string.bold"
		  ],
		  	"core-js/es/string/code-point-at": [
		  	"es.string.code-point-at"
		  ],
		  	"core-js/es/string/ends-with": [
		  	"es.string.ends-with"
		  ],
		  	"core-js/es/string/fixed": [
		  	"es.string.fixed"
		  ],
		  	"core-js/es/string/fontcolor": [
		  	"es.string.fontcolor"
		  ],
		  	"core-js/es/string/fontsize": [
		  	"es.string.fontsize"
		  ],
		  	"core-js/es/string/from-code-point": [
		  	"es.string.from-code-point"
		  ],
		  	"core-js/es/string/includes": [
		  	"es.string.includes"
		  ],
		  	"core-js/es/string/is-well-formed": [
		  	"es.string.is-well-formed"
		  ],
		  	"core-js/es/string/italics": [
		  	"es.string.italics"
		  ],
		  	"core-js/es/string/iterator": [
		  	"es.object.to-string",
		  	"es.string.iterator"
		  ],
		  	"core-js/es/string/link": [
		  	"es.string.link"
		  ],
		  	"core-js/es/string/match": [
		  	"es.regexp.exec",
		  	"es.string.match"
		  ],
		  	"core-js/es/string/match-all": [
		  	"es.object.to-string",
		  	"es.regexp.exec",
		  	"es.string.match-all"
		  ],
		  	"core-js/es/string/pad-end": [
		  	"es.string.pad-end"
		  ],
		  	"core-js/es/string/pad-start": [
		  	"es.string.pad-start"
		  ],
		  	"core-js/es/string/raw": [
		  	"es.string.raw"
		  ],
		  	"core-js/es/string/repeat": [
		  	"es.string.repeat"
		  ],
		  	"core-js/es/string/replace": [
		  	"es.regexp.exec",
		  	"es.string.replace"
		  ],
		  	"core-js/es/string/replace-all": [
		  	"es.regexp.exec",
		  	"es.string.replace",
		  	"es.string.replace-all"
		  ],
		  	"core-js/es/string/search": [
		  	"es.regexp.exec",
		  	"es.string.search"
		  ],
		  	"core-js/es/string/small": [
		  	"es.string.small"
		  ],
		  	"core-js/es/string/split": [
		  	"es.regexp.exec",
		  	"es.string.split"
		  ],
		  	"core-js/es/string/starts-with": [
		  	"es.string.starts-with"
		  ],
		  	"core-js/es/string/strike": [
		  	"es.string.strike"
		  ],
		  	"core-js/es/string/sub": [
		  	"es.string.sub"
		  ],
		  	"core-js/es/string/substr": [
		  	"es.string.substr"
		  ],
		  	"core-js/es/string/sup": [
		  	"es.string.sup"
		  ],
		  	"core-js/es/string/to-well-formed": [
		  	"es.string.to-well-formed"
		  ],
		  	"core-js/es/string/trim": [
		  	"es.string.trim"
		  ],
		  	"core-js/es/string/trim-end": [
		  	"es.string.trim-end"
		  ],
		  	"core-js/es/string/trim-left": [
		  	"es.string.trim-start"
		  ],
		  	"core-js/es/string/trim-right": [
		  	"es.string.trim-end"
		  ],
		  	"core-js/es/string/trim-start": [
		  	"es.string.trim-start"
		  ],
		  	"core-js/es/string/virtual": [
		  	"es.object.to-string",
		  	"es.regexp.exec",
		  	"es.string.at-alternative",
		  	"es.string.code-point-at",
		  	"es.string.ends-with",
		  	"es.string.includes",
		  	"es.string.iterator",
		  	"es.string.match",
		  	"es.string.match-all",
		  	"es.string.pad-end",
		  	"es.string.pad-start",
		  	"es.string.repeat",
		  	"es.string.replace",
		  	"es.string.replace-all",
		  	"es.string.search",
		  	"es.string.split",
		  	"es.string.starts-with",
		  	"es.string.substr",
		  	"es.string.trim",
		  	"es.string.trim-end",
		  	"es.string.trim-start",
		  	"es.string.anchor",
		  	"es.string.big",
		  	"es.string.blink",
		  	"es.string.bold",
		  	"es.string.fixed",
		  	"es.string.fontcolor",
		  	"es.string.fontsize",
		  	"es.string.italics",
		  	"es.string.link",
		  	"es.string.small",
		  	"es.string.strike",
		  	"es.string.sub",
		  	"es.string.sup"
		  ],
		  	"core-js/es/string/virtual/anchor": [
		  	"es.string.anchor"
		  ],
		  	"core-js/es/string/virtual/at": [
		  	"es.string.at-alternative"
		  ],
		  	"core-js/es/string/virtual/big": [
		  	"es.string.big"
		  ],
		  	"core-js/es/string/virtual/blink": [
		  	"es.string.blink"
		  ],
		  	"core-js/es/string/virtual/bold": [
		  	"es.string.bold"
		  ],
		  	"core-js/es/string/virtual/code-point-at": [
		  	"es.string.code-point-at"
		  ],
		  	"core-js/es/string/virtual/ends-with": [
		  	"es.string.ends-with"
		  ],
		  	"core-js/es/string/virtual/fixed": [
		  	"es.string.fixed"
		  ],
		  	"core-js/es/string/virtual/fontcolor": [
		  	"es.string.fontcolor"
		  ],
		  	"core-js/es/string/virtual/fontsize": [
		  	"es.string.fontsize"
		  ],
		  	"core-js/es/string/virtual/includes": [
		  	"es.string.includes"
		  ],
		  	"core-js/es/string/virtual/is-well-formed": [
		  	"es.string.is-well-formed"
		  ],
		  	"core-js/es/string/virtual/italics": [
		  	"es.string.italics"
		  ],
		  	"core-js/es/string/virtual/iterator": [
		  	"es.object.to-string",
		  	"es.string.iterator"
		  ],
		  	"core-js/es/string/virtual/link": [
		  	"es.string.link"
		  ],
		  	"core-js/es/string/virtual/match-all": [
		  	"es.object.to-string",
		  	"es.regexp.exec",
		  	"es.string.match-all"
		  ],
		  	"core-js/es/string/virtual/pad-end": [
		  	"es.string.pad-end"
		  ],
		  	"core-js/es/string/virtual/pad-start": [
		  	"es.string.pad-start"
		  ],
		  	"core-js/es/string/virtual/repeat": [
		  	"es.string.repeat"
		  ],
		  	"core-js/es/string/virtual/replace-all": [
		  	"es.regexp.exec",
		  	"es.string.replace",
		  	"es.string.replace-all"
		  ],
		  	"core-js/es/string/virtual/small": [
		  	"es.string.small"
		  ],
		  	"core-js/es/string/virtual/starts-with": [
		  	"es.string.starts-with"
		  ],
		  	"core-js/es/string/virtual/strike": [
		  	"es.string.strike"
		  ],
		  	"core-js/es/string/virtual/sub": [
		  	"es.string.sub"
		  ],
		  	"core-js/es/string/virtual/substr": [
		  	"es.string.substr"
		  ],
		  	"core-js/es/string/virtual/sup": [
		  	"es.string.sup"
		  ],
		  	"core-js/es/string/virtual/to-well-formed": [
		  	"es.string.to-well-formed"
		  ],
		  	"core-js/es/string/virtual/trim": [
		  	"es.string.trim"
		  ],
		  	"core-js/es/string/virtual/trim-end": [
		  	"es.string.trim-end"
		  ],
		  	"core-js/es/string/virtual/trim-left": [
		  	"es.string.trim-start"
		  ],
		  	"core-js/es/string/virtual/trim-right": [
		  	"es.string.trim-end"
		  ],
		  	"core-js/es/string/virtual/trim-start": [
		  	"es.string.trim-start"
		  ],
		  	"core-js/es/symbol": [
		  	"es.symbol",
		  	"es.symbol.description",
		  	"es.symbol.async-iterator",
		  	"es.symbol.has-instance",
		  	"es.symbol.is-concat-spreadable",
		  	"es.symbol.iterator",
		  	"es.symbol.match",
		  	"es.symbol.match-all",
		  	"es.symbol.replace",
		  	"es.symbol.search",
		  	"es.symbol.species",
		  	"es.symbol.split",
		  	"es.symbol.to-primitive",
		  	"es.symbol.to-string-tag",
		  	"es.symbol.unscopables",
		  	"es.array.concat",
		  	"es.json.to-string-tag",
		  	"es.math.to-string-tag",
		  	"es.object.to-string",
		  	"es.reflect.to-string-tag"
		  ],
		  	"core-js/es/symbol/async-iterator": [
		  	"es.symbol.async-iterator"
		  ],
		  	"core-js/es/symbol/description": [
		  	"es.symbol.description"
		  ],
		  	"core-js/es/symbol/for": [
		  	"es.symbol"
		  ],
		  	"core-js/es/symbol/has-instance": [
		  	"es.symbol.has-instance",
		  	"es.function.has-instance"
		  ],
		  	"core-js/es/symbol/is-concat-spreadable": [
		  	"es.symbol.is-concat-spreadable",
		  	"es.array.concat"
		  ],
		  	"core-js/es/symbol/iterator": [
		  	"es.symbol.iterator",
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"es.string.iterator"
		  ],
		  	"core-js/es/symbol/key-for": [
		  	"es.symbol"
		  ],
		  	"core-js/es/symbol/match": [
		  	"es.symbol.match",
		  	"es.regexp.exec",
		  	"es.string.match"
		  ],
		  	"core-js/es/symbol/match-all": [
		  	"es.symbol.match-all",
		  	"es.object.to-string",
		  	"es.regexp.exec",
		  	"es.string.match-all"
		  ],
		  	"core-js/es/symbol/replace": [
		  	"es.symbol.replace",
		  	"es.regexp.exec",
		  	"es.string.replace"
		  ],
		  	"core-js/es/symbol/search": [
		  	"es.symbol.search",
		  	"es.regexp.exec",
		  	"es.string.search"
		  ],
		  	"core-js/es/symbol/species": [
		  	"es.symbol.species"
		  ],
		  	"core-js/es/symbol/split": [
		  	"es.symbol.split",
		  	"es.regexp.exec",
		  	"es.string.split"
		  ],
		  	"core-js/es/symbol/to-primitive": [
		  	"es.symbol.to-primitive",
		  	"es.date.to-primitive"
		  ],
		  	"core-js/es/symbol/to-string-tag": [
		  	"es.symbol.to-string-tag",
		  	"es.json.to-string-tag",
		  	"es.math.to-string-tag",
		  	"es.object.to-string",
		  	"es.reflect.to-string-tag"
		  ],
		  	"core-js/es/symbol/unscopables": [
		  	"es.symbol.unscopables"
		  ],
		  	"core-js/es/typed-array": [
		  	"es.object.to-string",
		  	"es.string.iterator",
		  	"es.typed-array.float32-array",
		  	"es.typed-array.float64-array",
		  	"es.typed-array.int8-array",
		  	"es.typed-array.int16-array",
		  	"es.typed-array.int32-array",
		  	"es.typed-array.uint8-array",
		  	"es.typed-array.uint8-clamped-array",
		  	"es.typed-array.uint16-array",
		  	"es.typed-array.uint32-array",
		  	"es.typed-array.at",
		  	"es.typed-array.copy-within",
		  	"es.typed-array.every",
		  	"es.typed-array.fill",
		  	"es.typed-array.filter",
		  	"es.typed-array.find",
		  	"es.typed-array.find-index",
		  	"es.typed-array.find-last",
		  	"es.typed-array.find-last-index",
		  	"es.typed-array.for-each",
		  	"es.typed-array.from",
		  	"es.typed-array.includes",
		  	"es.typed-array.index-of",
		  	"es.typed-array.iterator",
		  	"es.typed-array.join",
		  	"es.typed-array.last-index-of",
		  	"es.typed-array.map",
		  	"es.typed-array.of",
		  	"es.typed-array.reduce",
		  	"es.typed-array.reduce-right",
		  	"es.typed-array.reverse",
		  	"es.typed-array.set",
		  	"es.typed-array.slice",
		  	"es.typed-array.some",
		  	"es.typed-array.sort",
		  	"es.typed-array.subarray",
		  	"es.typed-array.to-locale-string",
		  	"es.typed-array.to-reversed",
		  	"es.typed-array.to-sorted",
		  	"es.typed-array.to-string",
		  	"es.typed-array.with"
		  ],
		  	"core-js/es/typed-array/at": [
		  	"es.typed-array.at"
		  ],
		  	"core-js/es/typed-array/copy-within": [
		  	"es.typed-array.copy-within"
		  ],
		  	"core-js/es/typed-array/entries": [
		  	"es.object.to-string",
		  	"es.typed-array.iterator"
		  ],
		  	"core-js/es/typed-array/every": [
		  	"es.typed-array.every"
		  ],
		  	"core-js/es/typed-array/fill": [
		  	"es.typed-array.fill"
		  ],
		  	"core-js/es/typed-array/filter": [
		  	"es.typed-array.filter"
		  ],
		  	"core-js/es/typed-array/find": [
		  	"es.typed-array.find"
		  ],
		  	"core-js/es/typed-array/find-index": [
		  	"es.typed-array.find-index"
		  ],
		  	"core-js/es/typed-array/find-last": [
		  	"es.typed-array.find-last"
		  ],
		  	"core-js/es/typed-array/find-last-index": [
		  	"es.typed-array.find-last-index"
		  ],
		  	"core-js/es/typed-array/float32-array": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.object.to-string",
		  	"es.string.iterator",
		  	"es.typed-array.float32-array",
		  	"es.typed-array.at",
		  	"es.typed-array.copy-within",
		  	"es.typed-array.every",
		  	"es.typed-array.fill",
		  	"es.typed-array.filter",
		  	"es.typed-array.find",
		  	"es.typed-array.find-index",
		  	"es.typed-array.find-last",
		  	"es.typed-array.find-last-index",
		  	"es.typed-array.for-each",
		  	"es.typed-array.from",
		  	"es.typed-array.includes",
		  	"es.typed-array.index-of",
		  	"es.typed-array.iterator",
		  	"es.typed-array.join",
		  	"es.typed-array.last-index-of",
		  	"es.typed-array.map",
		  	"es.typed-array.of",
		  	"es.typed-array.reduce",
		  	"es.typed-array.reduce-right",
		  	"es.typed-array.reverse",
		  	"es.typed-array.set",
		  	"es.typed-array.slice",
		  	"es.typed-array.some",
		  	"es.typed-array.sort",
		  	"es.typed-array.subarray",
		  	"es.typed-array.to-locale-string",
		  	"es.typed-array.to-reversed",
		  	"es.typed-array.to-sorted",
		  	"es.typed-array.to-string",
		  	"es.typed-array.with"
		  ],
		  	"core-js/es/typed-array/float64-array": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.object.to-string",
		  	"es.string.iterator",
		  	"es.typed-array.float64-array",
		  	"es.typed-array.at",
		  	"es.typed-array.copy-within",
		  	"es.typed-array.every",
		  	"es.typed-array.fill",
		  	"es.typed-array.filter",
		  	"es.typed-array.find",
		  	"es.typed-array.find-index",
		  	"es.typed-array.find-last",
		  	"es.typed-array.find-last-index",
		  	"es.typed-array.for-each",
		  	"es.typed-array.from",
		  	"es.typed-array.includes",
		  	"es.typed-array.index-of",
		  	"es.typed-array.iterator",
		  	"es.typed-array.join",
		  	"es.typed-array.last-index-of",
		  	"es.typed-array.map",
		  	"es.typed-array.of",
		  	"es.typed-array.reduce",
		  	"es.typed-array.reduce-right",
		  	"es.typed-array.reverse",
		  	"es.typed-array.set",
		  	"es.typed-array.slice",
		  	"es.typed-array.some",
		  	"es.typed-array.sort",
		  	"es.typed-array.subarray",
		  	"es.typed-array.to-locale-string",
		  	"es.typed-array.to-reversed",
		  	"es.typed-array.to-sorted",
		  	"es.typed-array.to-string",
		  	"es.typed-array.with"
		  ],
		  	"core-js/es/typed-array/for-each": [
		  	"es.typed-array.for-each"
		  ],
		  	"core-js/es/typed-array/from": [
		  	"es.typed-array.from"
		  ],
		  	"core-js/es/typed-array/includes": [
		  	"es.typed-array.includes"
		  ],
		  	"core-js/es/typed-array/index-of": [
		  	"es.typed-array.index-of"
		  ],
		  	"core-js/es/typed-array/int16-array": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.object.to-string",
		  	"es.string.iterator",
		  	"es.typed-array.int16-array",
		  	"es.typed-array.at",
		  	"es.typed-array.copy-within",
		  	"es.typed-array.every",
		  	"es.typed-array.fill",
		  	"es.typed-array.filter",
		  	"es.typed-array.find",
		  	"es.typed-array.find-index",
		  	"es.typed-array.find-last",
		  	"es.typed-array.find-last-index",
		  	"es.typed-array.for-each",
		  	"es.typed-array.from",
		  	"es.typed-array.includes",
		  	"es.typed-array.index-of",
		  	"es.typed-array.iterator",
		  	"es.typed-array.join",
		  	"es.typed-array.last-index-of",
		  	"es.typed-array.map",
		  	"es.typed-array.of",
		  	"es.typed-array.reduce",
		  	"es.typed-array.reduce-right",
		  	"es.typed-array.reverse",
		  	"es.typed-array.set",
		  	"es.typed-array.slice",
		  	"es.typed-array.some",
		  	"es.typed-array.sort",
		  	"es.typed-array.subarray",
		  	"es.typed-array.to-locale-string",
		  	"es.typed-array.to-reversed",
		  	"es.typed-array.to-sorted",
		  	"es.typed-array.to-string",
		  	"es.typed-array.with"
		  ],
		  	"core-js/es/typed-array/int32-array": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.object.to-string",
		  	"es.string.iterator",
		  	"es.typed-array.int32-array",
		  	"es.typed-array.at",
		  	"es.typed-array.copy-within",
		  	"es.typed-array.every",
		  	"es.typed-array.fill",
		  	"es.typed-array.filter",
		  	"es.typed-array.find",
		  	"es.typed-array.find-index",
		  	"es.typed-array.find-last",
		  	"es.typed-array.find-last-index",
		  	"es.typed-array.for-each",
		  	"es.typed-array.from",
		  	"es.typed-array.includes",
		  	"es.typed-array.index-of",
		  	"es.typed-array.iterator",
		  	"es.typed-array.join",
		  	"es.typed-array.last-index-of",
		  	"es.typed-array.map",
		  	"es.typed-array.of",
		  	"es.typed-array.reduce",
		  	"es.typed-array.reduce-right",
		  	"es.typed-array.reverse",
		  	"es.typed-array.set",
		  	"es.typed-array.slice",
		  	"es.typed-array.some",
		  	"es.typed-array.sort",
		  	"es.typed-array.subarray",
		  	"es.typed-array.to-locale-string",
		  	"es.typed-array.to-reversed",
		  	"es.typed-array.to-sorted",
		  	"es.typed-array.to-string",
		  	"es.typed-array.with"
		  ],
		  	"core-js/es/typed-array/int8-array": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.object.to-string",
		  	"es.string.iterator",
		  	"es.typed-array.int8-array",
		  	"es.typed-array.at",
		  	"es.typed-array.copy-within",
		  	"es.typed-array.every",
		  	"es.typed-array.fill",
		  	"es.typed-array.filter",
		  	"es.typed-array.find",
		  	"es.typed-array.find-index",
		  	"es.typed-array.find-last",
		  	"es.typed-array.find-last-index",
		  	"es.typed-array.for-each",
		  	"es.typed-array.from",
		  	"es.typed-array.includes",
		  	"es.typed-array.index-of",
		  	"es.typed-array.iterator",
		  	"es.typed-array.join",
		  	"es.typed-array.last-index-of",
		  	"es.typed-array.map",
		  	"es.typed-array.of",
		  	"es.typed-array.reduce",
		  	"es.typed-array.reduce-right",
		  	"es.typed-array.reverse",
		  	"es.typed-array.set",
		  	"es.typed-array.slice",
		  	"es.typed-array.some",
		  	"es.typed-array.sort",
		  	"es.typed-array.subarray",
		  	"es.typed-array.to-locale-string",
		  	"es.typed-array.to-reversed",
		  	"es.typed-array.to-sorted",
		  	"es.typed-array.to-string",
		  	"es.typed-array.with"
		  ],
		  	"core-js/es/typed-array/iterator": [
		  	"es.object.to-string",
		  	"es.typed-array.iterator"
		  ],
		  	"core-js/es/typed-array/join": [
		  	"es.typed-array.join"
		  ],
		  	"core-js/es/typed-array/keys": [
		  	"es.object.to-string",
		  	"es.typed-array.iterator"
		  ],
		  	"core-js/es/typed-array/last-index-of": [
		  	"es.typed-array.last-index-of"
		  ],
		  	"core-js/es/typed-array/map": [
		  	"es.typed-array.map"
		  ],
		  	"core-js/es/typed-array/methods": [
		  	"es.object.to-string",
		  	"es.string.iterator",
		  	"es.typed-array.at",
		  	"es.typed-array.copy-within",
		  	"es.typed-array.every",
		  	"es.typed-array.fill",
		  	"es.typed-array.filter",
		  	"es.typed-array.find",
		  	"es.typed-array.find-index",
		  	"es.typed-array.find-last",
		  	"es.typed-array.find-last-index",
		  	"es.typed-array.for-each",
		  	"es.typed-array.from",
		  	"es.typed-array.includes",
		  	"es.typed-array.index-of",
		  	"es.typed-array.iterator",
		  	"es.typed-array.join",
		  	"es.typed-array.last-index-of",
		  	"es.typed-array.map",
		  	"es.typed-array.of",
		  	"es.typed-array.reduce",
		  	"es.typed-array.reduce-right",
		  	"es.typed-array.reverse",
		  	"es.typed-array.set",
		  	"es.typed-array.slice",
		  	"es.typed-array.some",
		  	"es.typed-array.sort",
		  	"es.typed-array.subarray",
		  	"es.typed-array.to-locale-string",
		  	"es.typed-array.to-reversed",
		  	"es.typed-array.to-sorted",
		  	"es.typed-array.to-string",
		  	"es.typed-array.with"
		  ],
		  	"core-js/es/typed-array/of": [
		  	"es.typed-array.of"
		  ],
		  	"core-js/es/typed-array/reduce": [
		  	"es.typed-array.reduce"
		  ],
		  	"core-js/es/typed-array/reduce-right": [
		  	"es.typed-array.reduce-right"
		  ],
		  	"core-js/es/typed-array/reverse": [
		  	"es.typed-array.reverse"
		  ],
		  	"core-js/es/typed-array/set": [
		  	"es.typed-array.set"
		  ],
		  	"core-js/es/typed-array/slice": [
		  	"es.typed-array.slice"
		  ],
		  	"core-js/es/typed-array/some": [
		  	"es.typed-array.some"
		  ],
		  	"core-js/es/typed-array/sort": [
		  	"es.typed-array.sort"
		  ],
		  	"core-js/es/typed-array/subarray": [
		  	"es.typed-array.subarray"
		  ],
		  	"core-js/es/typed-array/to-locale-string": [
		  	"es.typed-array.to-locale-string"
		  ],
		  	"core-js/es/typed-array/to-reversed": [
		  	"es.typed-array.to-reversed"
		  ],
		  	"core-js/es/typed-array/to-sorted": [
		  	"es.typed-array.sort",
		  	"es.typed-array.to-sorted"
		  ],
		  	"core-js/es/typed-array/to-string": [
		  	"es.typed-array.to-string"
		  ],
		  	"core-js/es/typed-array/uint16-array": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.object.to-string",
		  	"es.string.iterator",
		  	"es.typed-array.uint16-array",
		  	"es.typed-array.at",
		  	"es.typed-array.copy-within",
		  	"es.typed-array.every",
		  	"es.typed-array.fill",
		  	"es.typed-array.filter",
		  	"es.typed-array.find",
		  	"es.typed-array.find-index",
		  	"es.typed-array.find-last",
		  	"es.typed-array.find-last-index",
		  	"es.typed-array.for-each",
		  	"es.typed-array.from",
		  	"es.typed-array.includes",
		  	"es.typed-array.index-of",
		  	"es.typed-array.iterator",
		  	"es.typed-array.join",
		  	"es.typed-array.last-index-of",
		  	"es.typed-array.map",
		  	"es.typed-array.of",
		  	"es.typed-array.reduce",
		  	"es.typed-array.reduce-right",
		  	"es.typed-array.reverse",
		  	"es.typed-array.set",
		  	"es.typed-array.slice",
		  	"es.typed-array.some",
		  	"es.typed-array.sort",
		  	"es.typed-array.subarray",
		  	"es.typed-array.to-locale-string",
		  	"es.typed-array.to-reversed",
		  	"es.typed-array.to-sorted",
		  	"es.typed-array.to-string",
		  	"es.typed-array.with"
		  ],
		  	"core-js/es/typed-array/uint32-array": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.object.to-string",
		  	"es.string.iterator",
		  	"es.typed-array.uint32-array",
		  	"es.typed-array.at",
		  	"es.typed-array.copy-within",
		  	"es.typed-array.every",
		  	"es.typed-array.fill",
		  	"es.typed-array.filter",
		  	"es.typed-array.find",
		  	"es.typed-array.find-index",
		  	"es.typed-array.find-last",
		  	"es.typed-array.find-last-index",
		  	"es.typed-array.for-each",
		  	"es.typed-array.from",
		  	"es.typed-array.includes",
		  	"es.typed-array.index-of",
		  	"es.typed-array.iterator",
		  	"es.typed-array.join",
		  	"es.typed-array.last-index-of",
		  	"es.typed-array.map",
		  	"es.typed-array.of",
		  	"es.typed-array.reduce",
		  	"es.typed-array.reduce-right",
		  	"es.typed-array.reverse",
		  	"es.typed-array.set",
		  	"es.typed-array.slice",
		  	"es.typed-array.some",
		  	"es.typed-array.sort",
		  	"es.typed-array.subarray",
		  	"es.typed-array.to-locale-string",
		  	"es.typed-array.to-reversed",
		  	"es.typed-array.to-sorted",
		  	"es.typed-array.to-string",
		  	"es.typed-array.with"
		  ],
		  	"core-js/es/typed-array/uint8-array": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.object.to-string",
		  	"es.string.iterator",
		  	"es.typed-array.uint8-array",
		  	"es.typed-array.at",
		  	"es.typed-array.copy-within",
		  	"es.typed-array.every",
		  	"es.typed-array.fill",
		  	"es.typed-array.filter",
		  	"es.typed-array.find",
		  	"es.typed-array.find-index",
		  	"es.typed-array.find-last",
		  	"es.typed-array.find-last-index",
		  	"es.typed-array.for-each",
		  	"es.typed-array.from",
		  	"es.typed-array.includes",
		  	"es.typed-array.index-of",
		  	"es.typed-array.iterator",
		  	"es.typed-array.join",
		  	"es.typed-array.last-index-of",
		  	"es.typed-array.map",
		  	"es.typed-array.of",
		  	"es.typed-array.reduce",
		  	"es.typed-array.reduce-right",
		  	"es.typed-array.reverse",
		  	"es.typed-array.set",
		  	"es.typed-array.slice",
		  	"es.typed-array.some",
		  	"es.typed-array.sort",
		  	"es.typed-array.subarray",
		  	"es.typed-array.to-locale-string",
		  	"es.typed-array.to-reversed",
		  	"es.typed-array.to-sorted",
		  	"es.typed-array.to-string",
		  	"es.typed-array.with"
		  ],
		  	"core-js/es/typed-array/uint8-clamped-array": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.object.to-string",
		  	"es.string.iterator",
		  	"es.typed-array.uint8-clamped-array",
		  	"es.typed-array.at",
		  	"es.typed-array.copy-within",
		  	"es.typed-array.every",
		  	"es.typed-array.fill",
		  	"es.typed-array.filter",
		  	"es.typed-array.find",
		  	"es.typed-array.find-index",
		  	"es.typed-array.find-last",
		  	"es.typed-array.find-last-index",
		  	"es.typed-array.for-each",
		  	"es.typed-array.from",
		  	"es.typed-array.includes",
		  	"es.typed-array.index-of",
		  	"es.typed-array.iterator",
		  	"es.typed-array.join",
		  	"es.typed-array.last-index-of",
		  	"es.typed-array.map",
		  	"es.typed-array.of",
		  	"es.typed-array.reduce",
		  	"es.typed-array.reduce-right",
		  	"es.typed-array.reverse",
		  	"es.typed-array.set",
		  	"es.typed-array.slice",
		  	"es.typed-array.some",
		  	"es.typed-array.sort",
		  	"es.typed-array.subarray",
		  	"es.typed-array.to-locale-string",
		  	"es.typed-array.to-reversed",
		  	"es.typed-array.to-sorted",
		  	"es.typed-array.to-string",
		  	"es.typed-array.with"
		  ],
		  	"core-js/es/typed-array/values": [
		  	"es.object.to-string",
		  	"es.typed-array.iterator"
		  ],
		  	"core-js/es/typed-array/with": [
		  	"es.typed-array.with"
		  ],
		  	"core-js/es/unescape": [
		  	"es.unescape"
		  ],
		  	"core-js/es/weak-map": [
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"es.weak-map"
		  ],
		  	"core-js/es/weak-set": [
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"es.weak-set"
		  ],
		  	"core-js/features": [
		  	"es.symbol",
		  	"es.symbol.description",
		  	"es.symbol.async-iterator",
		  	"es.symbol.has-instance",
		  	"es.symbol.is-concat-spreadable",
		  	"es.symbol.iterator",
		  	"es.symbol.match",
		  	"es.symbol.match-all",
		  	"es.symbol.replace",
		  	"es.symbol.search",
		  	"es.symbol.species",
		  	"es.symbol.split",
		  	"es.symbol.to-primitive",
		  	"es.symbol.to-string-tag",
		  	"es.symbol.unscopables",
		  	"es.error.cause",
		  	"es.error.to-string",
		  	"es.aggregate-error",
		  	"es.aggregate-error.cause",
		  	"es.array.at",
		  	"es.array.concat",
		  	"es.array.copy-within",
		  	"es.array.every",
		  	"es.array.fill",
		  	"es.array.filter",
		  	"es.array.find",
		  	"es.array.find-index",
		  	"es.array.find-last",
		  	"es.array.find-last-index",
		  	"es.array.flat",
		  	"es.array.flat-map",
		  	"es.array.for-each",
		  	"es.array.from",
		  	"es.array.includes",
		  	"es.array.index-of",
		  	"es.array.is-array",
		  	"es.array.iterator",
		  	"es.array.join",
		  	"es.array.last-index-of",
		  	"es.array.map",
		  	"es.array.of",
		  	"es.array.push",
		  	"es.array.reduce",
		  	"es.array.reduce-right",
		  	"es.array.reverse",
		  	"es.array.slice",
		  	"es.array.some",
		  	"es.array.sort",
		  	"es.array.species",
		  	"es.array.splice",
		  	"es.array.to-reversed",
		  	"es.array.to-sorted",
		  	"es.array.to-spliced",
		  	"es.array.unscopables.flat",
		  	"es.array.unscopables.flat-map",
		  	"es.array.unshift",
		  	"es.array.with",
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.is-view",
		  	"es.array-buffer.slice",
		  	"es.data-view",
		  	"es.array-buffer.detached",
		  	"es.array-buffer.transfer",
		  	"es.array-buffer.transfer-to-fixed-length",
		  	"es.date.get-year",
		  	"es.date.now",
		  	"es.date.set-year",
		  	"es.date.to-gmt-string",
		  	"es.date.to-iso-string",
		  	"es.date.to-json",
		  	"es.date.to-primitive",
		  	"es.date.to-string",
		  	"es.escape",
		  	"es.function.bind",
		  	"es.function.has-instance",
		  	"es.function.name",
		  	"es.global-this",
		  	"es.json.stringify",
		  	"es.json.to-string-tag",
		  	"es.map",
		  	"es.map.group-by",
		  	"es.math.acosh",
		  	"es.math.asinh",
		  	"es.math.atanh",
		  	"es.math.cbrt",
		  	"es.math.clz32",
		  	"es.math.cosh",
		  	"es.math.expm1",
		  	"es.math.fround",
		  	"es.math.hypot",
		  	"es.math.imul",
		  	"es.math.log10",
		  	"es.math.log1p",
		  	"es.math.log2",
		  	"es.math.sign",
		  	"es.math.sinh",
		  	"es.math.tanh",
		  	"es.math.to-string-tag",
		  	"es.math.trunc",
		  	"es.number.constructor",
		  	"es.number.epsilon",
		  	"es.number.is-finite",
		  	"es.number.is-integer",
		  	"es.number.is-nan",
		  	"es.number.is-safe-integer",
		  	"es.number.max-safe-integer",
		  	"es.number.min-safe-integer",
		  	"es.number.parse-float",
		  	"es.number.parse-int",
		  	"es.number.to-exponential",
		  	"es.number.to-fixed",
		  	"es.number.to-precision",
		  	"es.object.assign",
		  	"es.object.create",
		  	"es.object.define-getter",
		  	"es.object.define-properties",
		  	"es.object.define-property",
		  	"es.object.define-setter",
		  	"es.object.entries",
		  	"es.object.freeze",
		  	"es.object.from-entries",
		  	"es.object.get-own-property-descriptor",
		  	"es.object.get-own-property-descriptors",
		  	"es.object.get-own-property-names",
		  	"es.object.get-prototype-of",
		  	"es.object.group-by",
		  	"es.object.has-own",
		  	"es.object.is",
		  	"es.object.is-extensible",
		  	"es.object.is-frozen",
		  	"es.object.is-sealed",
		  	"es.object.keys",
		  	"es.object.lookup-getter",
		  	"es.object.lookup-setter",
		  	"es.object.prevent-extensions",
		  	"es.object.proto",
		  	"es.object.seal",
		  	"es.object.set-prototype-of",
		  	"es.object.to-string",
		  	"es.object.values",
		  	"es.parse-float",
		  	"es.parse-int",
		  	"es.promise",
		  	"es.promise.all-settled",
		  	"es.promise.any",
		  	"es.promise.finally",
		  	"es.promise.with-resolvers",
		  	"es.reflect.apply",
		  	"es.reflect.construct",
		  	"es.reflect.define-property",
		  	"es.reflect.delete-property",
		  	"es.reflect.get",
		  	"es.reflect.get-own-property-descriptor",
		  	"es.reflect.get-prototype-of",
		  	"es.reflect.has",
		  	"es.reflect.is-extensible",
		  	"es.reflect.own-keys",
		  	"es.reflect.prevent-extensions",
		  	"es.reflect.set",
		  	"es.reflect.set-prototype-of",
		  	"es.reflect.to-string-tag",
		  	"es.regexp.constructor",
		  	"es.regexp.dot-all",
		  	"es.regexp.exec",
		  	"es.regexp.flags",
		  	"es.regexp.sticky",
		  	"es.regexp.test",
		  	"es.regexp.to-string",
		  	"es.set",
		  	"es.string.at-alternative",
		  	"es.string.code-point-at",
		  	"es.string.ends-with",
		  	"es.string.from-code-point",
		  	"es.string.includes",
		  	"es.string.is-well-formed",
		  	"es.string.iterator",
		  	"es.string.match",
		  	"es.string.match-all",
		  	"es.string.pad-end",
		  	"es.string.pad-start",
		  	"es.string.raw",
		  	"es.string.repeat",
		  	"es.string.replace",
		  	"es.string.replace-all",
		  	"es.string.search",
		  	"es.string.split",
		  	"es.string.starts-with",
		  	"es.string.substr",
		  	"es.string.to-well-formed",
		  	"es.string.trim",
		  	"es.string.trim-end",
		  	"es.string.trim-start",
		  	"es.string.anchor",
		  	"es.string.big",
		  	"es.string.blink",
		  	"es.string.bold",
		  	"es.string.fixed",
		  	"es.string.fontcolor",
		  	"es.string.fontsize",
		  	"es.string.italics",
		  	"es.string.link",
		  	"es.string.small",
		  	"es.string.strike",
		  	"es.string.sub",
		  	"es.string.sup",
		  	"es.typed-array.float32-array",
		  	"es.typed-array.float64-array",
		  	"es.typed-array.int8-array",
		  	"es.typed-array.int16-array",
		  	"es.typed-array.int32-array",
		  	"es.typed-array.uint8-array",
		  	"es.typed-array.uint8-clamped-array",
		  	"es.typed-array.uint16-array",
		  	"es.typed-array.uint32-array",
		  	"es.typed-array.at",
		  	"es.typed-array.copy-within",
		  	"es.typed-array.every",
		  	"es.typed-array.fill",
		  	"es.typed-array.filter",
		  	"es.typed-array.find",
		  	"es.typed-array.find-index",
		  	"es.typed-array.find-last",
		  	"es.typed-array.find-last-index",
		  	"es.typed-array.for-each",
		  	"es.typed-array.from",
		  	"es.typed-array.includes",
		  	"es.typed-array.index-of",
		  	"es.typed-array.iterator",
		  	"es.typed-array.join",
		  	"es.typed-array.last-index-of",
		  	"es.typed-array.map",
		  	"es.typed-array.of",
		  	"es.typed-array.reduce",
		  	"es.typed-array.reduce-right",
		  	"es.typed-array.reverse",
		  	"es.typed-array.set",
		  	"es.typed-array.slice",
		  	"es.typed-array.some",
		  	"es.typed-array.sort",
		  	"es.typed-array.subarray",
		  	"es.typed-array.to-locale-string",
		  	"es.typed-array.to-reversed",
		  	"es.typed-array.to-sorted",
		  	"es.typed-array.to-string",
		  	"es.typed-array.with",
		  	"es.unescape",
		  	"es.weak-map",
		  	"es.weak-set",
		  	"esnext.aggregate-error",
		  	"esnext.suppressed-error.constructor",
		  	"esnext.array.from-async",
		  	"esnext.array.at",
		  	"esnext.array.filter-out",
		  	"esnext.array.filter-reject",
		  	"esnext.array.find-last",
		  	"esnext.array.find-last-index",
		  	"esnext.array.group",
		  	"esnext.array.group-by",
		  	"esnext.array.group-by-to-map",
		  	"esnext.array.group-to-map",
		  	"esnext.array.is-template-object",
		  	"esnext.array.last-index",
		  	"esnext.array.last-item",
		  	"esnext.array.to-reversed",
		  	"esnext.array.to-sorted",
		  	"esnext.array.to-spliced",
		  	"esnext.array.unique-by",
		  	"esnext.array.with",
		  	"esnext.array-buffer.detached",
		  	"esnext.array-buffer.transfer",
		  	"esnext.array-buffer.transfer-to-fixed-length",
		  	"esnext.async-disposable-stack.constructor",
		  	"esnext.async-iterator.constructor",
		  	"esnext.async-iterator.as-indexed-pairs",
		  	"esnext.async-iterator.async-dispose",
		  	"esnext.async-iterator.drop",
		  	"esnext.async-iterator.every",
		  	"esnext.async-iterator.filter",
		  	"esnext.async-iterator.find",
		  	"esnext.async-iterator.flat-map",
		  	"esnext.async-iterator.for-each",
		  	"esnext.async-iterator.from",
		  	"esnext.async-iterator.indexed",
		  	"esnext.async-iterator.map",
		  	"esnext.async-iterator.reduce",
		  	"esnext.async-iterator.some",
		  	"esnext.async-iterator.take",
		  	"esnext.async-iterator.to-array",
		  	"esnext.bigint.range",
		  	"esnext.composite-key",
		  	"esnext.composite-symbol",
		  	"esnext.data-view.get-float16",
		  	"esnext.data-view.get-uint8-clamped",
		  	"esnext.data-view.set-float16",
		  	"esnext.data-view.set-uint8-clamped",
		  	"esnext.disposable-stack.constructor",
		  	"esnext.function.demethodize",
		  	"esnext.function.is-callable",
		  	"esnext.function.is-constructor",
		  	"esnext.function.metadata",
		  	"esnext.function.un-this",
		  	"esnext.global-this",
		  	"esnext.iterator.constructor",
		  	"esnext.iterator.as-indexed-pairs",
		  	"esnext.iterator.dispose",
		  	"esnext.iterator.drop",
		  	"esnext.iterator.every",
		  	"esnext.iterator.filter",
		  	"esnext.iterator.find",
		  	"esnext.iterator.flat-map",
		  	"esnext.iterator.for-each",
		  	"esnext.iterator.from",
		  	"esnext.iterator.indexed",
		  	"esnext.iterator.map",
		  	"esnext.iterator.range",
		  	"esnext.iterator.reduce",
		  	"esnext.iterator.some",
		  	"esnext.iterator.take",
		  	"esnext.iterator.to-array",
		  	"esnext.iterator.to-async",
		  	"esnext.json.is-raw-json",
		  	"esnext.json.parse",
		  	"esnext.json.raw-json",
		  	"esnext.map.delete-all",
		  	"esnext.map.emplace",
		  	"esnext.map.every",
		  	"esnext.map.filter",
		  	"esnext.map.find",
		  	"esnext.map.find-key",
		  	"esnext.map.from",
		  	"esnext.map.group-by",
		  	"esnext.map.includes",
		  	"esnext.map.key-by",
		  	"esnext.map.key-of",
		  	"esnext.map.map-keys",
		  	"esnext.map.map-values",
		  	"esnext.map.merge",
		  	"esnext.map.of",
		  	"esnext.map.reduce",
		  	"esnext.map.some",
		  	"esnext.map.update",
		  	"esnext.map.update-or-insert",
		  	"esnext.map.upsert",
		  	"esnext.math.clamp",
		  	"esnext.math.deg-per-rad",
		  	"esnext.math.degrees",
		  	"esnext.math.fscale",
		  	"esnext.math.f16round",
		  	"esnext.math.iaddh",
		  	"esnext.math.imulh",
		  	"esnext.math.isubh",
		  	"esnext.math.rad-per-deg",
		  	"esnext.math.radians",
		  	"esnext.math.scale",
		  	"esnext.math.seeded-prng",
		  	"esnext.math.signbit",
		  	"esnext.math.umulh",
		  	"esnext.number.from-string",
		  	"esnext.number.range",
		  	"esnext.object.has-own",
		  	"esnext.object.iterate-entries",
		  	"esnext.object.iterate-keys",
		  	"esnext.object.iterate-values",
		  	"esnext.object.group-by",
		  	"esnext.observable",
		  	"esnext.promise.all-settled",
		  	"esnext.promise.any",
		  	"esnext.promise.try",
		  	"esnext.promise.with-resolvers",
		  	"esnext.reflect.define-metadata",
		  	"esnext.reflect.delete-metadata",
		  	"esnext.reflect.get-metadata",
		  	"esnext.reflect.get-metadata-keys",
		  	"esnext.reflect.get-own-metadata",
		  	"esnext.reflect.get-own-metadata-keys",
		  	"esnext.reflect.has-metadata",
		  	"esnext.reflect.has-own-metadata",
		  	"esnext.reflect.metadata",
		  	"esnext.regexp.escape",
		  	"esnext.set.add-all",
		  	"esnext.set.delete-all",
		  	"esnext.set.difference.v2",
		  	"esnext.set.difference",
		  	"esnext.set.every",
		  	"esnext.set.filter",
		  	"esnext.set.find",
		  	"esnext.set.from",
		  	"esnext.set.intersection.v2",
		  	"esnext.set.intersection",
		  	"esnext.set.is-disjoint-from.v2",
		  	"esnext.set.is-disjoint-from",
		  	"esnext.set.is-subset-of.v2",
		  	"esnext.set.is-subset-of",
		  	"esnext.set.is-superset-of.v2",
		  	"esnext.set.is-superset-of",
		  	"esnext.set.join",
		  	"esnext.set.map",
		  	"esnext.set.of",
		  	"esnext.set.reduce",
		  	"esnext.set.some",
		  	"esnext.set.symmetric-difference.v2",
		  	"esnext.set.symmetric-difference",
		  	"esnext.set.union.v2",
		  	"esnext.set.union",
		  	"esnext.string.at",
		  	"esnext.string.cooked",
		  	"esnext.string.code-points",
		  	"esnext.string.dedent",
		  	"esnext.string.is-well-formed",
		  	"esnext.string.match-all",
		  	"esnext.string.replace-all",
		  	"esnext.string.to-well-formed",
		  	"esnext.symbol.async-dispose",
		  	"esnext.symbol.dispose",
		  	"esnext.symbol.is-registered-symbol",
		  	"esnext.symbol.is-registered",
		  	"esnext.symbol.is-well-known-symbol",
		  	"esnext.symbol.is-well-known",
		  	"esnext.symbol.matcher",
		  	"esnext.symbol.metadata",
		  	"esnext.symbol.metadata-key",
		  	"esnext.symbol.observable",
		  	"esnext.symbol.pattern-match",
		  	"esnext.symbol.replace-all",
		  	"esnext.typed-array.from-async",
		  	"esnext.typed-array.at",
		  	"esnext.typed-array.filter-out",
		  	"esnext.typed-array.filter-reject",
		  	"esnext.typed-array.find-last",
		  	"esnext.typed-array.find-last-index",
		  	"esnext.typed-array.group-by",
		  	"esnext.typed-array.to-reversed",
		  	"esnext.typed-array.to-sorted",
		  	"esnext.typed-array.to-spliced",
		  	"esnext.typed-array.unique-by",
		  	"esnext.typed-array.with",
		  	"esnext.uint8-array.from-base64",
		  	"esnext.uint8-array.from-hex",
		  	"esnext.uint8-array.to-base64",
		  	"esnext.uint8-array.to-hex",
		  	"esnext.weak-map.delete-all",
		  	"esnext.weak-map.from",
		  	"esnext.weak-map.of",
		  	"esnext.weak-map.emplace",
		  	"esnext.weak-map.upsert",
		  	"esnext.weak-set.add-all",
		  	"esnext.weak-set.delete-all",
		  	"esnext.weak-set.from",
		  	"esnext.weak-set.of",
		  	"web.atob",
		  	"web.btoa",
		  	"web.dom-collections.for-each",
		  	"web.dom-collections.iterator",
		  	"web.dom-exception.constructor",
		  	"web.dom-exception.stack",
		  	"web.dom-exception.to-string-tag",
		  	"web.immediate",
		  	"web.queue-microtask",
		  	"web.self",
		  	"web.structured-clone",
		  	"web.timers",
		  	"web.url",
		  	"web.url.can-parse",
		  	"web.url.to-json",
		  	"web.url-search-params",
		  	"web.url-search-params.delete",
		  	"web.url-search-params.has",
		  	"web.url-search-params.size"
		  ],
		  	"core-js/features/aggregate-error": [
		  ],
		  	"core-js/features/array": [
		  	"es.array.at",
		  	"es.array.concat",
		  	"es.array.copy-within",
		  	"es.array.every",
		  	"es.array.fill",
		  	"es.array.filter",
		  	"es.array.find",
		  	"es.array.find-index",
		  	"es.array.find-last",
		  	"es.array.find-last-index",
		  	"es.array.flat",
		  	"es.array.flat-map",
		  	"es.array.for-each",
		  	"es.array.from",
		  	"es.array.includes",
		  	"es.array.index-of",
		  	"es.array.is-array",
		  	"es.array.iterator",
		  	"es.array.join",
		  	"es.array.last-index-of",
		  	"es.array.map",
		  	"es.array.of",
		  	"es.array.push",
		  	"es.array.reduce",
		  	"es.array.reduce-right",
		  	"es.array.reverse",
		  	"es.array.slice",
		  	"es.array.some",
		  	"es.array.sort",
		  	"es.array.species",
		  	"es.array.splice",
		  	"es.array.to-reversed",
		  	"es.array.to-sorted",
		  	"es.array.to-spliced",
		  	"es.array.unscopables.flat",
		  	"es.array.unscopables.flat-map",
		  	"es.array.unshift",
		  	"es.array.with",
		  	"es.map",
		  	"es.object.to-string",
		  	"es.promise",
		  	"es.string.iterator",
		  	"esnext.array.from-async",
		  	"esnext.array.at",
		  	"esnext.array.filter-out",
		  	"esnext.array.filter-reject",
		  	"esnext.array.find-last",
		  	"esnext.array.find-last-index",
		  	"esnext.array.group",
		  	"esnext.array.group-by",
		  	"esnext.array.group-by-to-map",
		  	"esnext.array.group-to-map",
		  	"esnext.array.is-template-object",
		  	"esnext.array.last-index",
		  	"esnext.array.last-item",
		  	"esnext.array.to-reversed",
		  	"esnext.array.to-sorted",
		  	"esnext.array.to-spliced",
		  	"esnext.array.unique-by",
		  	"esnext.array.with"
		  ],
		  	"core-js/features/array-buffer": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.is-view",
		  	"es.array-buffer.slice",
		  	"es.data-view",
		  	"es.array-buffer.detached",
		  	"es.array-buffer.transfer",
		  	"es.array-buffer.transfer-to-fixed-length",
		  	"es.object.to-string",
		  	"esnext.array-buffer.detached",
		  	"esnext.array-buffer.transfer",
		  	"esnext.array-buffer.transfer-to-fixed-length"
		  ],
		  	"core-js/features/array-buffer/constructor": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.array-buffer.detached",
		  	"es.array-buffer.transfer",
		  	"es.array-buffer.transfer-to-fixed-length",
		  	"es.object.to-string",
		  	"esnext.array-buffer.detached",
		  	"esnext.array-buffer.transfer",
		  	"esnext.array-buffer.transfer-to-fixed-length"
		  ],
		  	"core-js/features/array-buffer/detached": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.array-buffer.detached",
		  	"esnext.array-buffer.detached"
		  ],
		  	"core-js/features/array-buffer/is-view": [
		  	"es.array-buffer.is-view"
		  ],
		  	"core-js/features/array-buffer/slice": [
		  	"es.array-buffer.slice"
		  ],
		  	"core-js/features/array-buffer/transfer": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.data-view",
		  	"es.array-buffer.transfer",
		  	"esnext.array-buffer.transfer"
		  ],
		  	"core-js/features/array-buffer/transfer-to-fixed-length": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.data-view",
		  	"es.array-buffer.transfer-to-fixed-length",
		  	"esnext.array-buffer.transfer-to-fixed-length"
		  ],
		  	"core-js/features/array/at": [
		  	"es.array.at",
		  	"esnext.array.at"
		  ],
		  	"core-js/features/array/concat": [
		  	"es.array.concat"
		  ],
		  	"core-js/features/array/copy-within": [
		  	"es.array.copy-within"
		  ],
		  	"core-js/features/array/entries": [
		  	"es.array.iterator",
		  	"es.object.to-string"
		  ],
		  	"core-js/features/array/every": [
		  	"es.array.every"
		  ],
		  	"core-js/features/array/fill": [
		  	"es.array.fill"
		  ],
		  	"core-js/features/array/filter": [
		  	"es.array.filter"
		  ],
		  	"core-js/features/array/filter-out": [
		  	"esnext.array.filter-out"
		  ],
		  	"core-js/features/array/filter-reject": [
		  	"esnext.array.filter-reject"
		  ],
		  	"core-js/features/array/find": [
		  	"es.array.find"
		  ],
		  	"core-js/features/array/find-index": [
		  	"es.array.find-index"
		  ],
		  	"core-js/features/array/find-last": [
		  	"es.array.find-last",
		  	"esnext.array.find-last"
		  ],
		  	"core-js/features/array/find-last-index": [
		  	"es.array.find-last-index",
		  	"esnext.array.find-last-index"
		  ],
		  	"core-js/features/array/flat": [
		  	"es.array.flat",
		  	"es.array.unscopables.flat"
		  ],
		  	"core-js/features/array/flat-map": [
		  	"es.array.flat-map",
		  	"es.array.unscopables.flat-map"
		  ],
		  	"core-js/features/array/for-each": [
		  	"es.array.for-each"
		  ],
		  	"core-js/features/array/from": [
		  	"es.array.from",
		  	"es.string.iterator"
		  ],
		  	"core-js/features/array/from-async": [
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"es.promise",
		  	"es.string.iterator",
		  	"esnext.array.from-async"
		  ],
		  	"core-js/features/array/group": [
		  	"esnext.array.group"
		  ],
		  	"core-js/features/array/group-by": [
		  	"esnext.array.group-by"
		  ],
		  	"core-js/features/array/group-by-to-map": [
		  	"es.map",
		  	"es.object.to-string",
		  	"esnext.array.group-by-to-map"
		  ],
		  	"core-js/features/array/group-to-map": [
		  	"es.map",
		  	"es.object.to-string",
		  	"esnext.array.group-to-map"
		  ],
		  	"core-js/features/array/includes": [
		  	"es.array.includes"
		  ],
		  	"core-js/features/array/index-of": [
		  	"es.array.index-of"
		  ],
		  	"core-js/features/array/is-array": [
		  	"es.array.is-array"
		  ],
		  	"core-js/features/array/is-template-object": [
		  	"esnext.array.is-template-object"
		  ],
		  	"core-js/features/array/iterator": [
		  	"es.array.iterator",
		  	"es.object.to-string"
		  ],
		  	"core-js/features/array/join": [
		  	"es.array.join"
		  ],
		  	"core-js/features/array/keys": [
		  	"es.array.iterator",
		  	"es.object.to-string"
		  ],
		  	"core-js/features/array/last-index": [
		  	"esnext.array.last-index"
		  ],
		  	"core-js/features/array/last-index-of": [
		  	"es.array.last-index-of"
		  ],
		  	"core-js/features/array/last-item": [
		  	"esnext.array.last-item"
		  ],
		  	"core-js/features/array/map": [
		  	"es.array.map"
		  ],
		  	"core-js/features/array/of": [
		  	"es.array.of"
		  ],
		  	"core-js/features/array/push": [
		  	"es.array.push"
		  ],
		  	"core-js/features/array/reduce": [
		  	"es.array.reduce"
		  ],
		  	"core-js/features/array/reduce-right": [
		  	"es.array.reduce-right"
		  ],
		  	"core-js/features/array/reverse": [
		  	"es.array.reverse"
		  ],
		  	"core-js/features/array/slice": [
		  	"es.array.slice"
		  ],
		  	"core-js/features/array/some": [
		  	"es.array.some"
		  ],
		  	"core-js/features/array/sort": [
		  	"es.array.sort"
		  ],
		  	"core-js/features/array/splice": [
		  	"es.array.splice"
		  ],
		  	"core-js/features/array/to-reversed": [
		  	"es.array.to-reversed",
		  	"esnext.array.to-reversed"
		  ],
		  	"core-js/features/array/to-sorted": [
		  	"es.array.sort",
		  	"es.array.to-sorted",
		  	"esnext.array.to-sorted"
		  ],
		  	"core-js/features/array/to-spliced": [
		  	"es.array.to-spliced",
		  	"esnext.array.to-spliced"
		  ],
		  	"core-js/features/array/unique-by": [
		  	"es.map",
		  	"esnext.array.unique-by"
		  ],
		  	"core-js/features/array/unshift": [
		  	"es.array.unshift"
		  ],
		  	"core-js/features/array/values": [
		  	"es.array.iterator",
		  	"es.object.to-string"
		  ],
		  	"core-js/features/array/virtual": [
		  	"es.array.at",
		  	"es.array.concat",
		  	"es.array.copy-within",
		  	"es.array.every",
		  	"es.array.fill",
		  	"es.array.filter",
		  	"es.array.find",
		  	"es.array.find-index",
		  	"es.array.find-last",
		  	"es.array.find-last-index",
		  	"es.array.flat",
		  	"es.array.flat-map",
		  	"es.array.for-each",
		  	"es.array.includes",
		  	"es.array.index-of",
		  	"es.array.iterator",
		  	"es.array.join",
		  	"es.array.last-index-of",
		  	"es.array.map",
		  	"es.array.push",
		  	"es.array.reduce",
		  	"es.array.reduce-right",
		  	"es.array.reverse",
		  	"es.array.slice",
		  	"es.array.some",
		  	"es.array.sort",
		  	"es.array.species",
		  	"es.array.splice",
		  	"es.array.to-reversed",
		  	"es.array.to-sorted",
		  	"es.array.to-spliced",
		  	"es.array.unscopables.flat",
		  	"es.array.unscopables.flat-map",
		  	"es.array.unshift",
		  	"es.array.with",
		  	"es.map",
		  	"es.object.to-string",
		  	"esnext.array.at",
		  	"esnext.array.filter-out",
		  	"esnext.array.filter-reject",
		  	"esnext.array.find-last",
		  	"esnext.array.find-last-index",
		  	"esnext.array.group",
		  	"esnext.array.group-by",
		  	"esnext.array.group-by-to-map",
		  	"esnext.array.group-to-map",
		  	"esnext.array.to-reversed",
		  	"esnext.array.to-sorted",
		  	"esnext.array.to-spliced",
		  	"esnext.array.unique-by",
		  	"esnext.array.with"
		  ],
		  	"core-js/features/array/virtual/at": [
		  	"es.array.at",
		  	"esnext.array.at"
		  ],
		  	"core-js/features/array/virtual/concat": [
		  	"es.array.concat"
		  ],
		  	"core-js/features/array/virtual/copy-within": [
		  	"es.array.copy-within"
		  ],
		  	"core-js/features/array/virtual/entries": [
		  	"es.array.iterator",
		  	"es.object.to-string"
		  ],
		  	"core-js/features/array/virtual/every": [
		  	"es.array.every"
		  ],
		  	"core-js/features/array/virtual/fill": [
		  	"es.array.fill"
		  ],
		  	"core-js/features/array/virtual/filter": [
		  	"es.array.filter"
		  ],
		  	"core-js/features/array/virtual/filter-out": [
		  	"esnext.array.filter-out"
		  ],
		  	"core-js/features/array/virtual/filter-reject": [
		  	"esnext.array.filter-reject"
		  ],
		  	"core-js/features/array/virtual/find": [
		  	"es.array.find"
		  ],
		  	"core-js/features/array/virtual/find-index": [
		  	"es.array.find-index"
		  ],
		  	"core-js/features/array/virtual/find-last": [
		  	"es.array.find-last",
		  	"esnext.array.find-last"
		  ],
		  	"core-js/features/array/virtual/find-last-index": [
		  	"es.array.find-last-index",
		  	"esnext.array.find-last-index"
		  ],
		  	"core-js/features/array/virtual/flat": [
		  	"es.array.flat",
		  	"es.array.unscopables.flat"
		  ],
		  	"core-js/features/array/virtual/flat-map": [
		  	"es.array.flat-map",
		  	"es.array.unscopables.flat-map"
		  ],
		  	"core-js/features/array/virtual/for-each": [
		  	"es.array.for-each"
		  ],
		  	"core-js/features/array/virtual/group": [
		  	"esnext.array.group"
		  ],
		  	"core-js/features/array/virtual/group-by": [
		  	"esnext.array.group-by"
		  ],
		  	"core-js/features/array/virtual/group-by-to-map": [
		  	"es.map",
		  	"es.object.to-string",
		  	"esnext.array.group-by-to-map"
		  ],
		  	"core-js/features/array/virtual/group-to-map": [
		  	"es.map",
		  	"es.object.to-string",
		  	"esnext.array.group-to-map"
		  ],
		  	"core-js/features/array/virtual/includes": [
		  	"es.array.includes"
		  ],
		  	"core-js/features/array/virtual/index-of": [
		  	"es.array.index-of"
		  ],
		  	"core-js/features/array/virtual/iterator": [
		  	"es.array.iterator",
		  	"es.object.to-string"
		  ],
		  	"core-js/features/array/virtual/join": [
		  	"es.array.join"
		  ],
		  	"core-js/features/array/virtual/keys": [
		  	"es.array.iterator",
		  	"es.object.to-string"
		  ],
		  	"core-js/features/array/virtual/last-index-of": [
		  	"es.array.last-index-of"
		  ],
		  	"core-js/features/array/virtual/map": [
		  	"es.array.map"
		  ],
		  	"core-js/features/array/virtual/push": [
		  	"es.array.push"
		  ],
		  	"core-js/features/array/virtual/reduce": [
		  	"es.array.reduce"
		  ],
		  	"core-js/features/array/virtual/reduce-right": [
		  	"es.array.reduce-right"
		  ],
		  	"core-js/features/array/virtual/reverse": [
		  	"es.array.reverse"
		  ],
		  	"core-js/features/array/virtual/slice": [
		  	"es.array.slice"
		  ],
		  	"core-js/features/array/virtual/some": [
		  	"es.array.some"
		  ],
		  	"core-js/features/array/virtual/sort": [
		  	"es.array.sort"
		  ],
		  	"core-js/features/array/virtual/splice": [
		  	"es.array.splice"
		  ],
		  	"core-js/features/array/virtual/to-reversed": [
		  	"es.array.to-reversed",
		  	"esnext.array.to-reversed"
		  ],
		  	"core-js/features/array/virtual/to-sorted": [
		  	"es.array.sort",
		  	"es.array.to-sorted",
		  	"esnext.array.to-sorted"
		  ],
		  	"core-js/features/array/virtual/to-spliced": [
		  	"es.array.to-spliced",
		  	"esnext.array.to-spliced"
		  ],
		  	"core-js/features/array/virtual/unique-by": [
		  	"es.map",
		  	"esnext.array.unique-by"
		  ],
		  	"core-js/features/array/virtual/unshift": [
		  	"es.array.unshift"
		  ],
		  	"core-js/features/array/virtual/values": [
		  	"es.array.iterator",
		  	"es.object.to-string"
		  ],
		  	"core-js/features/array/virtual/with": [
		  	"es.array.with",
		  	"esnext.array.with"
		  ],
		  	"core-js/features/array/with": [
		  	"es.array.with",
		  	"esnext.array.with"
		  ],
		  	"core-js/features/async-disposable-stack": [
		  	"es.error.cause",
		  	"es.error.to-string",
		  	"es.object.to-string",
		  	"es.promise",
		  	"esnext.suppressed-error.constructor",
		  	"esnext.async-disposable-stack.constructor",
		  	"esnext.async-iterator.async-dispose",
		  	"esnext.iterator.dispose"
		  ],
		  	"core-js/features/async-disposable-stack/constructor": [
		  	"es.error.cause",
		  	"es.error.to-string",
		  	"es.object.to-string",
		  	"es.promise",
		  	"esnext.suppressed-error.constructor",
		  	"esnext.async-disposable-stack.constructor",
		  	"esnext.async-iterator.async-dispose",
		  	"esnext.iterator.dispose"
		  ],
		  	"core-js/features/async-iterator": [
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"es.promise",
		  	"es.string.iterator",
		  	"esnext.async-iterator.constructor",
		  	"esnext.async-iterator.as-indexed-pairs",
		  	"esnext.async-iterator.async-dispose",
		  	"esnext.async-iterator.drop",
		  	"esnext.async-iterator.every",
		  	"esnext.async-iterator.filter",
		  	"esnext.async-iterator.find",
		  	"esnext.async-iterator.flat-map",
		  	"esnext.async-iterator.for-each",
		  	"esnext.async-iterator.from",
		  	"esnext.async-iterator.indexed",
		  	"esnext.async-iterator.map",
		  	"esnext.async-iterator.reduce",
		  	"esnext.async-iterator.some",
		  	"esnext.async-iterator.take",
		  	"esnext.async-iterator.to-array",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/features/async-iterator/as-indexed-pairs": [
		  	"es.object.to-string",
		  	"es.promise",
		  	"esnext.async-iterator.constructor",
		  	"esnext.async-iterator.as-indexed-pairs"
		  ],
		  	"core-js/features/async-iterator/async-dispose": [
		  	"es.object.to-string",
		  	"es.promise",
		  	"esnext.async-iterator.async-dispose"
		  ],
		  	"core-js/features/async-iterator/drop": [
		  	"es.object.to-string",
		  	"es.promise",
		  	"esnext.async-iterator.constructor",
		  	"esnext.async-iterator.drop"
		  ],
		  	"core-js/features/async-iterator/every": [
		  	"es.object.to-string",
		  	"es.promise",
		  	"esnext.async-iterator.constructor",
		  	"esnext.async-iterator.every"
		  ],
		  	"core-js/features/async-iterator/filter": [
		  	"es.object.to-string",
		  	"es.promise",
		  	"esnext.async-iterator.constructor",
		  	"esnext.async-iterator.filter"
		  ],
		  	"core-js/features/async-iterator/find": [
		  	"es.object.to-string",
		  	"es.promise",
		  	"esnext.async-iterator.constructor",
		  	"esnext.async-iterator.find"
		  ],
		  	"core-js/features/async-iterator/flat-map": [
		  	"es.object.to-string",
		  	"es.promise",
		  	"esnext.async-iterator.constructor",
		  	"esnext.async-iterator.flat-map"
		  ],
		  	"core-js/features/async-iterator/for-each": [
		  	"es.object.to-string",
		  	"es.promise",
		  	"esnext.async-iterator.constructor",
		  	"esnext.async-iterator.for-each"
		  ],
		  	"core-js/features/async-iterator/from": [
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"es.promise",
		  	"es.string.iterator",
		  	"esnext.async-iterator.constructor",
		  	"esnext.async-iterator.drop",
		  	"esnext.async-iterator.every",
		  	"esnext.async-iterator.filter",
		  	"esnext.async-iterator.find",
		  	"esnext.async-iterator.flat-map",
		  	"esnext.async-iterator.for-each",
		  	"esnext.async-iterator.from",
		  	"esnext.async-iterator.map",
		  	"esnext.async-iterator.reduce",
		  	"esnext.async-iterator.some",
		  	"esnext.async-iterator.take",
		  	"esnext.async-iterator.to-array",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/features/async-iterator/indexed": [
		  	"es.object.to-string",
		  	"es.promise",
		  	"esnext.async-iterator.constructor",
		  	"esnext.async-iterator.indexed"
		  ],
		  	"core-js/features/async-iterator/map": [
		  	"es.object.to-string",
		  	"es.promise",
		  	"esnext.async-iterator.constructor",
		  	"esnext.async-iterator.map"
		  ],
		  	"core-js/features/async-iterator/reduce": [
		  	"es.object.to-string",
		  	"es.promise",
		  	"esnext.async-iterator.constructor",
		  	"esnext.async-iterator.reduce"
		  ],
		  	"core-js/features/async-iterator/some": [
		  	"es.object.to-string",
		  	"es.promise",
		  	"esnext.async-iterator.constructor",
		  	"esnext.async-iterator.some"
		  ],
		  	"core-js/features/async-iterator/take": [
		  	"es.object.to-string",
		  	"es.promise",
		  	"esnext.async-iterator.constructor",
		  	"esnext.async-iterator.take"
		  ],
		  	"core-js/features/async-iterator/to-array": [
		  	"es.object.to-string",
		  	"es.promise",
		  	"esnext.async-iterator.constructor",
		  	"esnext.async-iterator.to-array"
		  ],
		  	"core-js/features/atob": [
		  	"es.error.to-string",
		  	"es.object.to-string",
		  	"web.atob",
		  	"web.dom-exception.constructor",
		  	"web.dom-exception.stack",
		  	"web.dom-exception.to-string-tag"
		  ],
		  	"core-js/features/bigint": [
		  	"es.object.to-string",
		  	"esnext.bigint.range"
		  ],
		  	"core-js/features/bigint/range": [
		  	"es.object.to-string",
		  	"esnext.bigint.range"
		  ],
		  	"core-js/features/btoa": [
		  	"es.error.to-string",
		  	"es.object.to-string",
		  	"web.btoa",
		  	"web.dom-exception.constructor",
		  	"web.dom-exception.stack",
		  	"web.dom-exception.to-string-tag"
		  ],
		  	"core-js/features/clear-immediate": [
		  	"web.immediate"
		  ],
		  	"core-js/features/composite-key": [
		  	"esnext.composite-key"
		  ],
		  	"core-js/features/composite-symbol": [
		  	"es.symbol",
		  	"esnext.composite-symbol"
		  ],
		  	"core-js/features/data-view": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.data-view",
		  	"es.object.to-string",
		  	"esnext.data-view.get-float16",
		  	"esnext.data-view.get-uint8-clamped",
		  	"esnext.data-view.set-float16",
		  	"esnext.data-view.set-uint8-clamped"
		  ],
		  	"core-js/features/data-view/get-float16": [
		  	"esnext.data-view.get-float16"
		  ],
		  	"core-js/features/data-view/get-uint8-clamped": [
		  	"esnext.data-view.get-uint8-clamped"
		  ],
		  	"core-js/features/data-view/set-float16": [
		  	"esnext.data-view.set-float16"
		  ],
		  	"core-js/features/data-view/set-uint8-clamped": [
		  	"esnext.data-view.set-uint8-clamped"
		  ],
		  	"core-js/features/date": [
		  	"es.date.get-year",
		  	"es.date.now",
		  	"es.date.set-year",
		  	"es.date.to-gmt-string",
		  	"es.date.to-iso-string",
		  	"es.date.to-json",
		  	"es.date.to-primitive",
		  	"es.date.to-string"
		  ],
		  	"core-js/features/date/get-year": [
		  	"es.date.get-year"
		  ],
		  	"core-js/features/date/now": [
		  	"es.date.now"
		  ],
		  	"core-js/features/date/set-year": [
		  	"es.date.set-year"
		  ],
		  	"core-js/features/date/to-gmt-string": [
		  	"es.date.to-gmt-string"
		  ],
		  	"core-js/features/date/to-iso-string": [
		  	"es.date.to-iso-string",
		  	"es.date.to-json"
		  ],
		  	"core-js/features/date/to-json": [
		  	"es.date.to-json"
		  ],
		  	"core-js/features/date/to-primitive": [
		  	"es.date.to-primitive"
		  ],
		  	"core-js/features/date/to-string": [
		  	"es.date.to-string"
		  ],
		  	"core-js/features/disposable-stack": [
		  	"es.error.cause",
		  	"es.error.to-string",
		  	"es.object.to-string",
		  	"esnext.suppressed-error.constructor",
		  	"esnext.disposable-stack.constructor",
		  	"esnext.iterator.dispose"
		  ],
		  	"core-js/features/disposable-stack/constructor": [
		  	"es.error.cause",
		  	"es.error.to-string",
		  	"es.object.to-string",
		  	"esnext.suppressed-error.constructor",
		  	"esnext.disposable-stack.constructor",
		  	"esnext.iterator.dispose"
		  ],
		  	"core-js/features/dom-collections": [
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"web.dom-collections.for-each",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/features/dom-collections/for-each": [
		  	"web.dom-collections.for-each"
		  ],
		  	"core-js/features/dom-collections/iterator": [
		  	"es.object.to-string",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/features/dom-exception": [
		  	"es.error.to-string",
		  	"web.dom-exception.constructor",
		  	"web.dom-exception.stack",
		  	"web.dom-exception.to-string-tag"
		  ],
		  	"core-js/features/dom-exception/constructor": [
		  	"es.error.to-string",
		  	"web.dom-exception.constructor",
		  	"web.dom-exception.stack"
		  ],
		  	"core-js/features/dom-exception/to-string-tag": [
		  	"web.dom-exception.to-string-tag"
		  ],
		  	"core-js/features/error": [
		  	"es.error.cause",
		  	"es.error.to-string"
		  ],
		  	"core-js/features/error/constructor": [
		  	"es.error.cause"
		  ],
		  	"core-js/features/error/to-string": [
		  	"es.error.to-string"
		  ],
		  	"core-js/features/escape": [
		  	"es.escape"
		  ],
		  	"core-js/features/function": [
		  	"es.function.bind",
		  	"es.function.has-instance",
		  	"es.function.name",
		  	"esnext.function.demethodize",
		  	"esnext.function.is-callable",
		  	"esnext.function.is-constructor",
		  	"esnext.function.metadata",
		  	"esnext.function.un-this"
		  ],
		  	"core-js/features/function/bind": [
		  	"es.function.bind"
		  ],
		  	"core-js/features/function/demethodize": [
		  	"esnext.function.demethodize"
		  ],
		  	"core-js/features/function/has-instance": [
		  	"es.function.has-instance"
		  ],
		  	"core-js/features/function/is-callable": [
		  	"esnext.function.is-callable"
		  ],
		  	"core-js/features/function/is-constructor": [
		  	"esnext.function.is-constructor"
		  ],
		  	"core-js/features/function/metadata": [
		  	"esnext.function.metadata"
		  ],
		  	"core-js/features/function/name": [
		  	"es.function.name"
		  ],
		  	"core-js/features/function/un-this": [
		  	"esnext.function.un-this"
		  ],
		  	"core-js/features/function/virtual": [
		  	"es.function.bind",
		  	"esnext.function.demethodize",
		  	"esnext.function.un-this"
		  ],
		  	"core-js/features/function/virtual/bind": [
		  	"es.function.bind"
		  ],
		  	"core-js/features/function/virtual/demethodize": [
		  	"esnext.function.demethodize"
		  ],
		  	"core-js/features/function/virtual/un-this": [
		  	"esnext.function.un-this"
		  ],
		  	"core-js/features/get-iterator": [
		  	"es.array.iterator",
		  	"es.string.iterator",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/features/get-iterator-method": [
		  	"es.array.iterator",
		  	"es.string.iterator",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/features/global-this": [
		  	"es.global-this",
		  	"esnext.global-this"
		  ],
		  	"core-js/features/instance/at": [
		  	"es.array.at",
		  	"es.string.at-alternative",
		  	"esnext.array.at",
		  	"esnext.string.at"
		  ],
		  	"core-js/features/instance/bind": [
		  	"es.function.bind"
		  ],
		  	"core-js/features/instance/code-point-at": [
		  	"es.string.code-point-at"
		  ],
		  	"core-js/features/instance/code-points": [
		  	"es.object.to-string",
		  	"esnext.string.code-points"
		  ],
		  	"core-js/features/instance/concat": [
		  	"es.array.concat"
		  ],
		  	"core-js/features/instance/copy-within": [
		  	"es.array.copy-within"
		  ],
		  	"core-js/features/instance/demethodize": [
		  	"esnext.function.demethodize"
		  ],
		  	"core-js/features/instance/ends-with": [
		  	"es.string.ends-with"
		  ],
		  	"core-js/features/instance/entries": [
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/features/instance/every": [
		  	"es.array.every"
		  ],
		  	"core-js/features/instance/fill": [
		  	"es.array.fill"
		  ],
		  	"core-js/features/instance/filter": [
		  	"es.array.filter"
		  ],
		  	"core-js/features/instance/filter-out": [
		  	"esnext.array.filter-out"
		  ],
		  	"core-js/features/instance/filter-reject": [
		  	"esnext.array.filter-reject"
		  ],
		  	"core-js/features/instance/find": [
		  	"es.array.find"
		  ],
		  	"core-js/features/instance/find-index": [
		  	"es.array.find-index"
		  ],
		  	"core-js/features/instance/find-last": [
		  	"es.array.find-last",
		  	"esnext.array.find-last"
		  ],
		  	"core-js/features/instance/find-last-index": [
		  	"es.array.find-last-index",
		  	"esnext.array.find-last-index"
		  ],
		  	"core-js/features/instance/flags": [
		  	"es.regexp.flags"
		  ],
		  	"core-js/features/instance/flat": [
		  	"es.array.flat",
		  	"es.array.unscopables.flat"
		  ],
		  	"core-js/features/instance/flat-map": [
		  	"es.array.flat-map",
		  	"es.array.unscopables.flat-map"
		  ],
		  	"core-js/features/instance/for-each": [
		  	"es.array.for-each",
		  	"web.dom-collections.for-each"
		  ],
		  	"core-js/features/instance/group": [
		  	"esnext.array.group"
		  ],
		  	"core-js/features/instance/group-by": [
		  	"esnext.array.group-by"
		  ],
		  	"core-js/features/instance/group-by-to-map": [
		  	"es.map",
		  	"es.object.to-string",
		  	"esnext.array.group-by-to-map"
		  ],
		  	"core-js/features/instance/group-to-map": [
		  	"es.map",
		  	"es.object.to-string",
		  	"esnext.array.group-to-map"
		  ],
		  	"core-js/features/instance/includes": [
		  	"es.array.includes",
		  	"es.string.includes"
		  ],
		  	"core-js/features/instance/index-of": [
		  	"es.array.index-of"
		  ],
		  	"core-js/features/instance/is-well-formed": [
		  	"es.string.is-well-formed"
		  ],
		  	"core-js/features/instance/keys": [
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/features/instance/last-index-of": [
		  	"es.array.last-index-of"
		  ],
		  	"core-js/features/instance/map": [
		  	"es.array.map"
		  ],
		  	"core-js/features/instance/match-all": [
		  	"es.object.to-string",
		  	"es.regexp.exec",
		  	"es.string.match-all",
		  	"esnext.string.match-all"
		  ],
		  	"core-js/features/instance/pad-end": [
		  	"es.string.pad-end"
		  ],
		  	"core-js/features/instance/pad-start": [
		  	"es.string.pad-start"
		  ],
		  	"core-js/features/instance/push": [
		  	"es.array.push"
		  ],
		  	"core-js/features/instance/reduce": [
		  	"es.array.reduce"
		  ],
		  	"core-js/features/instance/reduce-right": [
		  	"es.array.reduce-right"
		  ],
		  	"core-js/features/instance/repeat": [
		  	"es.string.repeat"
		  ],
		  	"core-js/features/instance/replace-all": [
		  	"es.regexp.exec",
		  	"es.string.replace",
		  	"es.string.replace-all",
		  	"esnext.string.replace-all"
		  ],
		  	"core-js/features/instance/reverse": [
		  	"es.array.reverse"
		  ],
		  	"core-js/features/instance/slice": [
		  	"es.array.slice"
		  ],
		  	"core-js/features/instance/some": [
		  	"es.array.some"
		  ],
		  	"core-js/features/instance/sort": [
		  	"es.array.sort"
		  ],
		  	"core-js/features/instance/splice": [
		  	"es.array.splice"
		  ],
		  	"core-js/features/instance/starts-with": [
		  	"es.string.starts-with"
		  ],
		  	"core-js/features/instance/to-reversed": [
		  	"es.array.to-reversed",
		  	"esnext.array.to-reversed"
		  ],
		  	"core-js/features/instance/to-sorted": [
		  	"es.array.sort",
		  	"es.array.to-sorted",
		  	"esnext.array.to-sorted"
		  ],
		  	"core-js/features/instance/to-spliced": [
		  	"es.array.to-spliced",
		  	"esnext.array.to-spliced"
		  ],
		  	"core-js/features/instance/to-well-formed": [
		  	"es.string.to-well-formed"
		  ],
		  	"core-js/features/instance/trim": [
		  	"es.string.trim"
		  ],
		  	"core-js/features/instance/trim-end": [
		  	"es.string.trim-end"
		  ],
		  	"core-js/features/instance/trim-left": [
		  	"es.string.trim-start"
		  ],
		  	"core-js/features/instance/trim-right": [
		  	"es.string.trim-end"
		  ],
		  	"core-js/features/instance/trim-start": [
		  	"es.string.trim-start"
		  ],
		  	"core-js/features/instance/un-this": [
		  	"esnext.function.un-this"
		  ],
		  	"core-js/features/instance/unique-by": [
		  	"es.map",
		  	"esnext.array.unique-by"
		  ],
		  	"core-js/features/instance/unshift": [
		  	"es.array.unshift"
		  ],
		  	"core-js/features/instance/values": [
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/features/instance/with": [
		  	"es.array.with",
		  	"esnext.array.with"
		  ],
		  	"core-js/features/is-iterable": [
		  	"es.array.iterator",
		  	"es.string.iterator",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/features/iterator": [
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"es.promise",
		  	"es.string.iterator",
		  	"esnext.iterator.constructor",
		  	"esnext.iterator.as-indexed-pairs",
		  	"esnext.iterator.dispose",
		  	"esnext.iterator.drop",
		  	"esnext.iterator.every",
		  	"esnext.iterator.filter",
		  	"esnext.iterator.find",
		  	"esnext.iterator.flat-map",
		  	"esnext.iterator.for-each",
		  	"esnext.iterator.from",
		  	"esnext.iterator.indexed",
		  	"esnext.iterator.map",
		  	"esnext.iterator.range",
		  	"esnext.iterator.reduce",
		  	"esnext.iterator.some",
		  	"esnext.iterator.take",
		  	"esnext.iterator.to-array",
		  	"esnext.iterator.to-async",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/features/iterator/as-indexed-pairs": [
		  	"es.object.to-string",
		  	"esnext.iterator.constructor",
		  	"esnext.iterator.as-indexed-pairs"
		  ],
		  	"core-js/features/iterator/dispose": [
		  	"esnext.iterator.dispose"
		  ],
		  	"core-js/features/iterator/drop": [
		  	"es.object.to-string",
		  	"esnext.iterator.constructor",
		  	"esnext.iterator.drop"
		  ],
		  	"core-js/features/iterator/every": [
		  	"es.object.to-string",
		  	"esnext.iterator.constructor",
		  	"esnext.iterator.every"
		  ],
		  	"core-js/features/iterator/filter": [
		  	"es.object.to-string",
		  	"esnext.iterator.constructor",
		  	"esnext.iterator.filter"
		  ],
		  	"core-js/features/iterator/find": [
		  	"es.object.to-string",
		  	"esnext.iterator.constructor",
		  	"esnext.iterator.find"
		  ],
		  	"core-js/features/iterator/flat-map": [
		  	"es.object.to-string",
		  	"esnext.iterator.constructor",
		  	"esnext.iterator.flat-map"
		  ],
		  	"core-js/features/iterator/for-each": [
		  	"es.object.to-string",
		  	"esnext.iterator.constructor",
		  	"esnext.iterator.for-each"
		  ],
		  	"core-js/features/iterator/from": [
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"es.promise",
		  	"es.string.iterator",
		  	"esnext.iterator.constructor",
		  	"esnext.iterator.dispose",
		  	"esnext.iterator.drop",
		  	"esnext.iterator.every",
		  	"esnext.iterator.filter",
		  	"esnext.iterator.find",
		  	"esnext.iterator.flat-map",
		  	"esnext.iterator.for-each",
		  	"esnext.iterator.from",
		  	"esnext.iterator.map",
		  	"esnext.iterator.reduce",
		  	"esnext.iterator.some",
		  	"esnext.iterator.take",
		  	"esnext.iterator.to-array",
		  	"esnext.iterator.to-async",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/features/iterator/indexed": [
		  	"es.object.to-string",
		  	"esnext.iterator.constructor",
		  	"esnext.iterator.indexed"
		  ],
		  	"core-js/features/iterator/map": [
		  	"es.object.to-string",
		  	"esnext.iterator.constructor",
		  	"esnext.iterator.map"
		  ],
		  	"core-js/features/iterator/range": [
		  	"es.object.to-string",
		  	"esnext.iterator.constructor",
		  	"esnext.iterator.range"
		  ],
		  	"core-js/features/iterator/reduce": [
		  	"es.object.to-string",
		  	"esnext.iterator.constructor",
		  	"esnext.iterator.reduce"
		  ],
		  	"core-js/features/iterator/some": [
		  	"es.object.to-string",
		  	"esnext.iterator.constructor",
		  	"esnext.iterator.some"
		  ],
		  	"core-js/features/iterator/take": [
		  	"es.object.to-string",
		  	"esnext.iterator.constructor",
		  	"esnext.iterator.take"
		  ],
		  	"core-js/features/iterator/to-array": [
		  	"es.object.to-string",
		  	"esnext.iterator.constructor",
		  	"esnext.iterator.to-array"
		  ],
		  	"core-js/features/iterator/to-async": [
		  	"es.object.to-string",
		  	"es.promise",
		  	"esnext.iterator.constructor",
		  	"esnext.iterator.to-async"
		  ],
		  	"core-js/features/json": [
		  	"es.date.to-json",
		  	"es.json.stringify",
		  	"es.json.to-string-tag",
		  	"es.object.create",
		  	"es.object.freeze",
		  	"es.object.keys",
		  	"esnext.json.is-raw-json",
		  	"esnext.json.parse",
		  	"esnext.json.raw-json"
		  ],
		  	"core-js/features/json/is-raw-json": [
		  	"esnext.json.is-raw-json"
		  ],
		  	"core-js/features/json/parse": [
		  	"es.object.keys",
		  	"esnext.json.parse"
		  ],
		  	"core-js/features/json/raw-json": [
		  	"es.object.create",
		  	"es.object.freeze",
		  	"esnext.json.raw-json"
		  ],
		  	"core-js/features/json/stringify": [
		  	"es.date.to-json",
		  	"es.json.stringify"
		  ],
		  	"core-js/features/json/to-string-tag": [
		  	"es.json.to-string-tag"
		  ],
		  	"core-js/features/map": [
		  	"es.array.iterator",
		  	"es.map",
		  	"es.map.group-by",
		  	"es.object.to-string",
		  	"es.string.iterator",
		  	"esnext.map.delete-all",
		  	"esnext.map.emplace",
		  	"esnext.map.every",
		  	"esnext.map.filter",
		  	"esnext.map.find",
		  	"esnext.map.find-key",
		  	"esnext.map.from",
		  	"esnext.map.group-by",
		  	"esnext.map.includes",
		  	"esnext.map.key-by",
		  	"esnext.map.key-of",
		  	"esnext.map.map-keys",
		  	"esnext.map.map-values",
		  	"esnext.map.merge",
		  	"esnext.map.of",
		  	"esnext.map.reduce",
		  	"esnext.map.some",
		  	"esnext.map.update",
		  	"esnext.map.update-or-insert",
		  	"esnext.map.upsert",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/features/map/delete-all": [
		  	"es.map",
		  	"esnext.map.delete-all"
		  ],
		  	"core-js/features/map/emplace": [
		  	"es.map",
		  	"esnext.map.emplace"
		  ],
		  	"core-js/features/map/every": [
		  	"es.map",
		  	"esnext.map.every"
		  ],
		  	"core-js/features/map/filter": [
		  	"es.map",
		  	"esnext.map.filter"
		  ],
		  	"core-js/features/map/find": [
		  	"es.map",
		  	"esnext.map.find"
		  ],
		  	"core-js/features/map/find-key": [
		  	"es.map",
		  	"esnext.map.find-key"
		  ],
		  	"core-js/features/map/from": [
		  	"es.array.iterator",
		  	"es.map",
		  	"es.object.to-string",
		  	"es.string.iterator",
		  	"esnext.map.delete-all",
		  	"esnext.map.emplace",
		  	"esnext.map.every",
		  	"esnext.map.filter",
		  	"esnext.map.find",
		  	"esnext.map.find-key",
		  	"esnext.map.from",
		  	"esnext.map.includes",
		  	"esnext.map.key-of",
		  	"esnext.map.map-keys",
		  	"esnext.map.map-values",
		  	"esnext.map.merge",
		  	"esnext.map.reduce",
		  	"esnext.map.some",
		  	"esnext.map.update",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/features/map/group-by": [
		  	"es.map",
		  	"es.map.group-by",
		  	"es.object.to-string",
		  	"esnext.map.delete-all",
		  	"esnext.map.emplace",
		  	"esnext.map.every",
		  	"esnext.map.filter",
		  	"esnext.map.find",
		  	"esnext.map.find-key",
		  	"esnext.map.group-by",
		  	"esnext.map.includes",
		  	"esnext.map.key-of",
		  	"esnext.map.map-keys",
		  	"esnext.map.map-values",
		  	"esnext.map.merge",
		  	"esnext.map.reduce",
		  	"esnext.map.some",
		  	"esnext.map.update"
		  ],
		  	"core-js/features/map/includes": [
		  	"es.map",
		  	"esnext.map.includes"
		  ],
		  	"core-js/features/map/key-by": [
		  	"es.map",
		  	"es.object.to-string",
		  	"esnext.map.delete-all",
		  	"esnext.map.emplace",
		  	"esnext.map.every",
		  	"esnext.map.filter",
		  	"esnext.map.find",
		  	"esnext.map.find-key",
		  	"esnext.map.includes",
		  	"esnext.map.key-by",
		  	"esnext.map.key-of",
		  	"esnext.map.map-keys",
		  	"esnext.map.map-values",
		  	"esnext.map.merge",
		  	"esnext.map.reduce",
		  	"esnext.map.some",
		  	"esnext.map.update"
		  ],
		  	"core-js/features/map/key-of": [
		  	"es.map",
		  	"esnext.map.key-of"
		  ],
		  	"core-js/features/map/map-keys": [
		  	"es.map",
		  	"esnext.map.map-keys"
		  ],
		  	"core-js/features/map/map-values": [
		  	"es.map",
		  	"esnext.map.map-values"
		  ],
		  	"core-js/features/map/merge": [
		  	"es.map",
		  	"esnext.map.merge"
		  ],
		  	"core-js/features/map/of": [
		  	"es.array.iterator",
		  	"es.map",
		  	"es.object.to-string",
		  	"esnext.map.delete-all",
		  	"esnext.map.emplace",
		  	"esnext.map.every",
		  	"esnext.map.filter",
		  	"esnext.map.find",
		  	"esnext.map.find-key",
		  	"esnext.map.includes",
		  	"esnext.map.key-of",
		  	"esnext.map.map-keys",
		  	"esnext.map.map-values",
		  	"esnext.map.merge",
		  	"esnext.map.of",
		  	"esnext.map.reduce",
		  	"esnext.map.some",
		  	"esnext.map.update"
		  ],
		  	"core-js/features/map/reduce": [
		  	"es.map",
		  	"esnext.map.reduce"
		  ],
		  	"core-js/features/map/some": [
		  	"es.map",
		  	"esnext.map.some"
		  ],
		  	"core-js/features/map/update": [
		  	"es.map",
		  	"esnext.map.update"
		  ],
		  	"core-js/features/map/update-or-insert": [
		  	"es.map",
		  	"esnext.map.update-or-insert"
		  ],
		  	"core-js/features/map/upsert": [
		  	"es.map",
		  	"esnext.map.upsert"
		  ],
		  	"core-js/features/math": [
		  	"es.math.acosh",
		  	"es.math.asinh",
		  	"es.math.atanh",
		  	"es.math.cbrt",
		  	"es.math.clz32",
		  	"es.math.cosh",
		  	"es.math.expm1",
		  	"es.math.fround",
		  	"es.math.hypot",
		  	"es.math.imul",
		  	"es.math.log10",
		  	"es.math.log1p",
		  	"es.math.log2",
		  	"es.math.sign",
		  	"es.math.sinh",
		  	"es.math.tanh",
		  	"es.math.to-string-tag",
		  	"es.math.trunc",
		  	"esnext.math.clamp",
		  	"esnext.math.deg-per-rad",
		  	"esnext.math.degrees",
		  	"esnext.math.fscale",
		  	"esnext.math.f16round",
		  	"esnext.math.iaddh",
		  	"esnext.math.imulh",
		  	"esnext.math.isubh",
		  	"esnext.math.rad-per-deg",
		  	"esnext.math.radians",
		  	"esnext.math.scale",
		  	"esnext.math.seeded-prng",
		  	"esnext.math.signbit",
		  	"esnext.math.umulh"
		  ],
		  	"core-js/features/math/acosh": [
		  	"es.math.acosh"
		  ],
		  	"core-js/features/math/asinh": [
		  	"es.math.asinh"
		  ],
		  	"core-js/features/math/atanh": [
		  	"es.math.atanh"
		  ],
		  	"core-js/features/math/cbrt": [
		  	"es.math.cbrt"
		  ],
		  	"core-js/features/math/clamp": [
		  	"esnext.math.clamp"
		  ],
		  	"core-js/features/math/clz32": [
		  	"es.math.clz32"
		  ],
		  	"core-js/features/math/cosh": [
		  	"es.math.cosh"
		  ],
		  	"core-js/features/math/deg-per-rad": [
		  	"esnext.math.deg-per-rad"
		  ],
		  	"core-js/features/math/degrees": [
		  	"esnext.math.degrees"
		  ],
		  	"core-js/features/math/expm1": [
		  	"es.math.expm1"
		  ],
		  	"core-js/features/math/f16round": [
		  	"esnext.math.f16round"
		  ],
		  	"core-js/features/math/fround": [
		  	"es.math.fround"
		  ],
		  	"core-js/features/math/fscale": [
		  	"esnext.math.fscale"
		  ],
		  	"core-js/features/math/hypot": [
		  	"es.math.hypot"
		  ],
		  	"core-js/features/math/iaddh": [
		  	"esnext.math.iaddh"
		  ],
		  	"core-js/features/math/imul": [
		  	"es.math.imul"
		  ],
		  	"core-js/features/math/imulh": [
		  	"esnext.math.imulh"
		  ],
		  	"core-js/features/math/isubh": [
		  	"esnext.math.isubh"
		  ],
		  	"core-js/features/math/log10": [
		  	"es.math.log10"
		  ],
		  	"core-js/features/math/log1p": [
		  	"es.math.log1p"
		  ],
		  	"core-js/features/math/log2": [
		  	"es.math.log2"
		  ],
		  	"core-js/features/math/rad-per-deg": [
		  	"esnext.math.rad-per-deg"
		  ],
		  	"core-js/features/math/radians": [
		  	"esnext.math.radians"
		  ],
		  	"core-js/features/math/scale": [
		  	"esnext.math.scale"
		  ],
		  	"core-js/features/math/seeded-prng": [
		  	"esnext.math.seeded-prng"
		  ],
		  	"core-js/features/math/sign": [
		  	"es.math.sign"
		  ],
		  	"core-js/features/math/signbit": [
		  	"esnext.math.signbit"
		  ],
		  	"core-js/features/math/sinh": [
		  	"es.math.sinh"
		  ],
		  	"core-js/features/math/tanh": [
		  	"es.math.tanh"
		  ],
		  	"core-js/features/math/to-string-tag": [
		  	"es.math.to-string-tag"
		  ],
		  	"core-js/features/math/trunc": [
		  	"es.math.trunc"
		  ],
		  	"core-js/features/math/umulh": [
		  	"esnext.math.umulh"
		  ],
		  	"core-js/features/number": [
		  	"es.number.constructor",
		  	"es.number.epsilon",
		  	"es.number.is-finite",
		  	"es.number.is-integer",
		  	"es.number.is-nan",
		  	"es.number.is-safe-integer",
		  	"es.number.max-safe-integer",
		  	"es.number.min-safe-integer",
		  	"es.number.parse-float",
		  	"es.number.parse-int",
		  	"es.number.to-exponential",
		  	"es.number.to-fixed",
		  	"es.number.to-precision",
		  	"es.object.to-string",
		  	"esnext.number.from-string",
		  	"esnext.number.range"
		  ],
		  	"core-js/features/number/constructor": [
		  	"es.number.constructor"
		  ],
		  	"core-js/features/number/epsilon": [
		  	"es.number.epsilon"
		  ],
		  	"core-js/features/number/from-string": [
		  	"esnext.number.from-string"
		  ],
		  	"core-js/features/number/is-finite": [
		  	"es.number.is-finite"
		  ],
		  	"core-js/features/number/is-integer": [
		  	"es.number.is-integer"
		  ],
		  	"core-js/features/number/is-nan": [
		  	"es.number.is-nan"
		  ],
		  	"core-js/features/number/is-safe-integer": [
		  	"es.number.is-safe-integer"
		  ],
		  	"core-js/features/number/max-safe-integer": [
		  	"es.number.max-safe-integer"
		  ],
		  	"core-js/features/number/min-safe-integer": [
		  	"es.number.min-safe-integer"
		  ],
		  	"core-js/features/number/parse-float": [
		  	"es.number.parse-float"
		  ],
		  	"core-js/features/number/parse-int": [
		  	"es.number.parse-int"
		  ],
		  	"core-js/features/number/range": [
		  	"es.object.to-string",
		  	"esnext.number.range"
		  ],
		  	"core-js/features/number/to-exponential": [
		  	"es.number.to-exponential"
		  ],
		  	"core-js/features/number/to-fixed": [
		  	"es.number.to-fixed"
		  ],
		  	"core-js/features/number/to-precision": [
		  	"es.number.to-precision"
		  ],
		  	"core-js/features/number/virtual": [
		  	"es.number.to-exponential",
		  	"es.number.to-fixed",
		  	"es.number.to-precision"
		  ],
		  	"core-js/features/number/virtual/to-exponential": [
		  	"es.number.to-exponential"
		  ],
		  	"core-js/features/number/virtual/to-fixed": [
		  	"es.number.to-fixed"
		  ],
		  	"core-js/features/number/virtual/to-precision": [
		  	"es.number.to-precision"
		  ],
		  	"core-js/features/object": [
		  	"es.symbol",
		  	"es.json.to-string-tag",
		  	"es.math.to-string-tag",
		  	"es.object.assign",
		  	"es.object.create",
		  	"es.object.define-getter",
		  	"es.object.define-properties",
		  	"es.object.define-property",
		  	"es.object.define-setter",
		  	"es.object.entries",
		  	"es.object.freeze",
		  	"es.object.from-entries",
		  	"es.object.get-own-property-descriptor",
		  	"es.object.get-own-property-descriptors",
		  	"es.object.get-own-property-names",
		  	"es.object.get-prototype-of",
		  	"es.object.group-by",
		  	"es.object.has-own",
		  	"es.object.is",
		  	"es.object.is-extensible",
		  	"es.object.is-frozen",
		  	"es.object.is-sealed",
		  	"es.object.keys",
		  	"es.object.lookup-getter",
		  	"es.object.lookup-setter",
		  	"es.object.prevent-extensions",
		  	"es.object.proto",
		  	"es.object.seal",
		  	"es.object.set-prototype-of",
		  	"es.object.to-string",
		  	"es.object.values",
		  	"es.reflect.to-string-tag",
		  	"esnext.object.has-own",
		  	"esnext.object.iterate-entries",
		  	"esnext.object.iterate-keys",
		  	"esnext.object.iterate-values",
		  	"esnext.object.group-by",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/features/object/assign": [
		  	"es.object.assign"
		  ],
		  	"core-js/features/object/create": [
		  	"es.object.create"
		  ],
		  	"core-js/features/object/define-getter": [
		  	"es.object.define-getter"
		  ],
		  	"core-js/features/object/define-properties": [
		  	"es.object.define-properties"
		  ],
		  	"core-js/features/object/define-property": [
		  	"es.object.define-property"
		  ],
		  	"core-js/features/object/define-setter": [
		  	"es.object.define-setter"
		  ],
		  	"core-js/features/object/entries": [
		  	"es.object.entries"
		  ],
		  	"core-js/features/object/freeze": [
		  	"es.object.freeze"
		  ],
		  	"core-js/features/object/from-entries": [
		  	"es.array.iterator",
		  	"es.object.from-entries",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/features/object/get-own-property-descriptor": [
		  	"es.object.get-own-property-descriptor"
		  ],
		  	"core-js/features/object/get-own-property-descriptors": [
		  	"es.object.get-own-property-descriptors"
		  ],
		  	"core-js/features/object/get-own-property-names": [
		  	"es.object.get-own-property-names"
		  ],
		  	"core-js/features/object/get-own-property-symbols": [
		  	"es.symbol"
		  ],
		  	"core-js/features/object/get-prototype-of": [
		  	"es.object.get-prototype-of"
		  ],
		  	"core-js/features/object/group-by": [
		  	"es.object.create",
		  	"es.object.group-by",
		  	"esnext.object.group-by"
		  ],
		  	"core-js/features/object/has-own": [
		  	"es.object.has-own",
		  	"esnext.object.has-own"
		  ],
		  	"core-js/features/object/is": [
		  	"es.object.is"
		  ],
		  	"core-js/features/object/is-extensible": [
		  	"es.object.is-extensible"
		  ],
		  	"core-js/features/object/is-frozen": [
		  	"es.object.is-frozen"
		  ],
		  	"core-js/features/object/is-sealed": [
		  	"es.object.is-sealed"
		  ],
		  	"core-js/features/object/iterate-entries": [
		  	"esnext.object.iterate-entries"
		  ],
		  	"core-js/features/object/iterate-keys": [
		  	"esnext.object.iterate-keys"
		  ],
		  	"core-js/features/object/iterate-values": [
		  	"esnext.object.iterate-values"
		  ],
		  	"core-js/features/object/keys": [
		  	"es.object.keys"
		  ],
		  	"core-js/features/object/lookup-getter": [
		  	"es.object.lookup-getter"
		  ],
		  	"core-js/features/object/lookup-setter": [
		  	"es.object.lookup-setter"
		  ],
		  	"core-js/features/object/prevent-extensions": [
		  	"es.object.prevent-extensions"
		  ],
		  	"core-js/features/object/proto": [
		  	"es.object.proto"
		  ],
		  	"core-js/features/object/seal": [
		  	"es.object.seal"
		  ],
		  	"core-js/features/object/set-prototype-of": [
		  	"es.object.set-prototype-of"
		  ],
		  	"core-js/features/object/to-string": [
		  	"es.json.to-string-tag",
		  	"es.math.to-string-tag",
		  	"es.object.to-string",
		  	"es.reflect.to-string-tag"
		  ],
		  	"core-js/features/object/values": [
		  	"es.object.values"
		  ],
		  	"core-js/features/observable": [
		  	"es.object.to-string",
		  	"es.string.iterator",
		  	"esnext.observable",
		  	"esnext.symbol.observable",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/features/parse-float": [
		  	"es.parse-float"
		  ],
		  	"core-js/features/parse-int": [
		  	"es.parse-int"
		  ],
		  	"core-js/features/promise": [
		  	"es.aggregate-error",
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"es.promise",
		  	"es.promise.all-settled",
		  	"es.promise.any",
		  	"es.promise.finally",
		  	"es.promise.with-resolvers",
		  	"es.string.iterator",
		  	"esnext.aggregate-error",
		  	"esnext.promise.all-settled",
		  	"esnext.promise.any",
		  	"esnext.promise.try",
		  	"esnext.promise.with-resolvers",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/features/promise/all-settled": [
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"es.promise",
		  	"es.promise.all-settled",
		  	"es.string.iterator",
		  	"esnext.promise.all-settled",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/features/promise/any": [
		  	"es.aggregate-error",
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"es.promise",
		  	"es.promise.any",
		  	"es.string.iterator",
		  	"esnext.aggregate-error",
		  	"esnext.promise.any",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/features/promise/finally": [
		  	"es.object.to-string",
		  	"es.promise",
		  	"es.promise.finally"
		  ],
		  	"core-js/features/promise/try": [
		  	"es.promise",
		  	"esnext.promise.try"
		  ],
		  	"core-js/features/promise/with-resolvers": [
		  	"es.promise",
		  	"es.promise.with-resolvers",
		  	"esnext.promise.with-resolvers"
		  ],
		  	"core-js/features/queue-microtask": [
		  	"web.queue-microtask"
		  ],
		  	"core-js/features/reflect": [
		  	"es.object.to-string",
		  	"es.reflect.apply",
		  	"es.reflect.construct",
		  	"es.reflect.define-property",
		  	"es.reflect.delete-property",
		  	"es.reflect.get",
		  	"es.reflect.get-own-property-descriptor",
		  	"es.reflect.get-prototype-of",
		  	"es.reflect.has",
		  	"es.reflect.is-extensible",
		  	"es.reflect.own-keys",
		  	"es.reflect.prevent-extensions",
		  	"es.reflect.set",
		  	"es.reflect.set-prototype-of",
		  	"es.reflect.to-string-tag",
		  	"esnext.reflect.define-metadata",
		  	"esnext.reflect.delete-metadata",
		  	"esnext.reflect.get-metadata",
		  	"esnext.reflect.get-metadata-keys",
		  	"esnext.reflect.get-own-metadata",
		  	"esnext.reflect.get-own-metadata-keys",
		  	"esnext.reflect.has-metadata",
		  	"esnext.reflect.has-own-metadata",
		  	"esnext.reflect.metadata"
		  ],
		  	"core-js/features/reflect/apply": [
		  	"es.reflect.apply"
		  ],
		  	"core-js/features/reflect/construct": [
		  	"es.reflect.construct"
		  ],
		  	"core-js/features/reflect/define-metadata": [
		  	"esnext.reflect.define-metadata"
		  ],
		  	"core-js/features/reflect/define-property": [
		  	"es.reflect.define-property"
		  ],
		  	"core-js/features/reflect/delete-metadata": [
		  	"esnext.reflect.delete-metadata"
		  ],
		  	"core-js/features/reflect/delete-property": [
		  	"es.reflect.delete-property"
		  ],
		  	"core-js/features/reflect/get": [
		  	"es.reflect.get"
		  ],
		  	"core-js/features/reflect/get-metadata": [
		  	"esnext.reflect.get-metadata"
		  ],
		  	"core-js/features/reflect/get-metadata-keys": [
		  	"esnext.reflect.get-metadata-keys"
		  ],
		  	"core-js/features/reflect/get-own-metadata": [
		  	"esnext.reflect.get-own-metadata"
		  ],
		  	"core-js/features/reflect/get-own-metadata-keys": [
		  	"esnext.reflect.get-own-metadata-keys"
		  ],
		  	"core-js/features/reflect/get-own-property-descriptor": [
		  	"es.reflect.get-own-property-descriptor"
		  ],
		  	"core-js/features/reflect/get-prototype-of": [
		  	"es.reflect.get-prototype-of"
		  ],
		  	"core-js/features/reflect/has": [
		  	"es.reflect.has"
		  ],
		  	"core-js/features/reflect/has-metadata": [
		  	"esnext.reflect.has-metadata"
		  ],
		  	"core-js/features/reflect/has-own-metadata": [
		  	"esnext.reflect.has-own-metadata"
		  ],
		  	"core-js/features/reflect/is-extensible": [
		  	"es.reflect.is-extensible"
		  ],
		  	"core-js/features/reflect/metadata": [
		  	"esnext.reflect.metadata"
		  ],
		  	"core-js/features/reflect/own-keys": [
		  	"es.reflect.own-keys"
		  ],
		  	"core-js/features/reflect/prevent-extensions": [
		  	"es.reflect.prevent-extensions"
		  ],
		  	"core-js/features/reflect/set": [
		  	"es.reflect.set"
		  ],
		  	"core-js/features/reflect/set-prototype-of": [
		  	"es.reflect.set-prototype-of"
		  ],
		  	"core-js/features/reflect/to-string-tag": [
		  	"es.reflect.to-string-tag"
		  ],
		  	"core-js/features/regexp": [
		  	"es.regexp.constructor",
		  	"es.regexp.dot-all",
		  	"es.regexp.exec",
		  	"es.regexp.flags",
		  	"es.regexp.sticky",
		  	"es.regexp.test",
		  	"es.regexp.to-string",
		  	"es.string.match",
		  	"es.string.replace",
		  	"es.string.search",
		  	"es.string.split",
		  	"esnext.regexp.escape"
		  ],
		  	"core-js/features/regexp/constructor": [
		  	"es.regexp.constructor",
		  	"es.regexp.dot-all",
		  	"es.regexp.exec",
		  	"es.regexp.sticky"
		  ],
		  	"core-js/features/regexp/dot-all": [
		  	"es.regexp.constructor",
		  	"es.regexp.dot-all",
		  	"es.regexp.exec"
		  ],
		  	"core-js/features/regexp/escape": [
		  	"esnext.regexp.escape"
		  ],
		  	"core-js/features/regexp/flags": [
		  	"es.regexp.flags"
		  ],
		  	"core-js/features/regexp/match": [
		  	"es.regexp.exec",
		  	"es.string.match"
		  ],
		  	"core-js/features/regexp/replace": [
		  	"es.regexp.exec",
		  	"es.string.replace"
		  ],
		  	"core-js/features/regexp/search": [
		  	"es.regexp.exec",
		  	"es.string.search"
		  ],
		  	"core-js/features/regexp/split": [
		  	"es.regexp.exec",
		  	"es.string.split"
		  ],
		  	"core-js/features/regexp/sticky": [
		  	"es.regexp.constructor",
		  	"es.regexp.exec",
		  	"es.regexp.sticky"
		  ],
		  	"core-js/features/regexp/test": [
		  	"es.regexp.exec",
		  	"es.regexp.test"
		  ],
		  	"core-js/features/regexp/to-string": [
		  	"es.regexp.to-string"
		  ],
		  	"core-js/features/self": [
		  	"web.self"
		  ],
		  	"core-js/features/set": [
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"es.set",
		  	"es.string.iterator",
		  	"esnext.set.add-all",
		  	"esnext.set.delete-all",
		  	"esnext.set.difference.v2",
		  	"esnext.set.difference",
		  	"esnext.set.every",
		  	"esnext.set.filter",
		  	"esnext.set.find",
		  	"esnext.set.from",
		  	"esnext.set.intersection.v2",
		  	"esnext.set.intersection",
		  	"esnext.set.is-disjoint-from.v2",
		  	"esnext.set.is-disjoint-from",
		  	"esnext.set.is-subset-of.v2",
		  	"esnext.set.is-subset-of",
		  	"esnext.set.is-superset-of.v2",
		  	"esnext.set.is-superset-of",
		  	"esnext.set.join",
		  	"esnext.set.map",
		  	"esnext.set.of",
		  	"esnext.set.reduce",
		  	"esnext.set.some",
		  	"esnext.set.symmetric-difference.v2",
		  	"esnext.set.symmetric-difference",
		  	"esnext.set.union.v2",
		  	"esnext.set.union",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/features/set-immediate": [
		  	"web.immediate"
		  ],
		  	"core-js/features/set-interval": [
		  	"web.timers"
		  ],
		  	"core-js/features/set-timeout": [
		  	"web.timers"
		  ],
		  	"core-js/features/set/add-all": [
		  	"es.set",
		  	"esnext.set.add-all"
		  ],
		  	"core-js/features/set/delete-all": [
		  	"es.set",
		  	"esnext.set.delete-all"
		  ],
		  	"core-js/features/set/difference": [
		  	"es.array.iterator",
		  	"es.set",
		  	"es.string.iterator",
		  	"esnext.set.difference.v2",
		  	"esnext.set.difference",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/features/set/every": [
		  	"es.set",
		  	"esnext.set.every"
		  ],
		  	"core-js/features/set/filter": [
		  	"es.set",
		  	"esnext.set.filter"
		  ],
		  	"core-js/features/set/find": [
		  	"es.set",
		  	"esnext.set.find"
		  ],
		  	"core-js/features/set/from": [
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"es.set",
		  	"es.string.iterator",
		  	"esnext.set.add-all",
		  	"esnext.set.delete-all",
		  	"esnext.set.difference.v2",
		  	"esnext.set.every",
		  	"esnext.set.filter",
		  	"esnext.set.find",
		  	"esnext.set.from",
		  	"esnext.set.intersection.v2",
		  	"esnext.set.is-disjoint-from.v2",
		  	"esnext.set.is-subset-of.v2",
		  	"esnext.set.is-superset-of.v2",
		  	"esnext.set.join",
		  	"esnext.set.map",
		  	"esnext.set.reduce",
		  	"esnext.set.some",
		  	"esnext.set.symmetric-difference.v2",
		  	"esnext.set.union.v2",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/features/set/intersection": [
		  	"es.array.iterator",
		  	"es.set",
		  	"es.string.iterator",
		  	"esnext.set.intersection.v2",
		  	"esnext.set.intersection",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/features/set/is-disjoint-from": [
		  	"es.array.iterator",
		  	"es.set",
		  	"es.string.iterator",
		  	"esnext.set.is-disjoint-from.v2",
		  	"esnext.set.is-disjoint-from",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/features/set/is-subset-of": [
		  	"es.array.iterator",
		  	"es.set",
		  	"es.string.iterator",
		  	"esnext.set.is-subset-of.v2",
		  	"esnext.set.is-subset-of",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/features/set/is-superset-of": [
		  	"es.array.iterator",
		  	"es.set",
		  	"es.string.iterator",
		  	"esnext.set.is-superset-of.v2",
		  	"esnext.set.is-superset-of",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/features/set/join": [
		  	"es.set",
		  	"esnext.set.join"
		  ],
		  	"core-js/features/set/map": [
		  	"es.set",
		  	"esnext.set.map"
		  ],
		  	"core-js/features/set/of": [
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"es.set",
		  	"esnext.set.add-all",
		  	"esnext.set.delete-all",
		  	"esnext.set.difference.v2",
		  	"esnext.set.every",
		  	"esnext.set.filter",
		  	"esnext.set.find",
		  	"esnext.set.intersection.v2",
		  	"esnext.set.is-disjoint-from.v2",
		  	"esnext.set.is-subset-of.v2",
		  	"esnext.set.is-superset-of.v2",
		  	"esnext.set.join",
		  	"esnext.set.map",
		  	"esnext.set.of",
		  	"esnext.set.reduce",
		  	"esnext.set.some",
		  	"esnext.set.symmetric-difference.v2",
		  	"esnext.set.union.v2"
		  ],
		  	"core-js/features/set/reduce": [
		  	"es.set",
		  	"esnext.set.reduce"
		  ],
		  	"core-js/features/set/some": [
		  	"es.set",
		  	"esnext.set.some"
		  ],
		  	"core-js/features/set/symmetric-difference": [
		  	"es.array.iterator",
		  	"es.set",
		  	"es.string.iterator",
		  	"esnext.set.symmetric-difference.v2",
		  	"esnext.set.symmetric-difference",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/features/set/union": [
		  	"es.array.iterator",
		  	"es.set",
		  	"es.string.iterator",
		  	"esnext.set.union.v2",
		  	"esnext.set.union",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/features/string": [
		  	"es.object.to-string",
		  	"es.regexp.exec",
		  	"es.string.at-alternative",
		  	"es.string.code-point-at",
		  	"es.string.ends-with",
		  	"es.string.from-code-point",
		  	"es.string.includes",
		  	"es.string.is-well-formed",
		  	"es.string.iterator",
		  	"es.string.match",
		  	"es.string.match-all",
		  	"es.string.pad-end",
		  	"es.string.pad-start",
		  	"es.string.raw",
		  	"es.string.repeat",
		  	"es.string.replace",
		  	"es.string.replace-all",
		  	"es.string.search",
		  	"es.string.split",
		  	"es.string.starts-with",
		  	"es.string.substr",
		  	"es.string.to-well-formed",
		  	"es.string.trim",
		  	"es.string.trim-end",
		  	"es.string.trim-start",
		  	"es.string.anchor",
		  	"es.string.big",
		  	"es.string.blink",
		  	"es.string.bold",
		  	"es.string.fixed",
		  	"es.string.fontcolor",
		  	"es.string.fontsize",
		  	"es.string.italics",
		  	"es.string.link",
		  	"es.string.small",
		  	"es.string.strike",
		  	"es.string.sub",
		  	"es.string.sup",
		  	"es.weak-map",
		  	"esnext.string.at",
		  	"esnext.string.cooked",
		  	"esnext.string.code-points",
		  	"esnext.string.dedent",
		  	"esnext.string.is-well-formed",
		  	"esnext.string.match-all",
		  	"esnext.string.replace-all",
		  	"esnext.string.to-well-formed"
		  ],
		  	"core-js/features/string/anchor": [
		  	"es.string.anchor"
		  ],
		  	"core-js/features/string/at": [
		  	"es.string.at-alternative",
		  	"esnext.string.at"
		  ],
		  	"core-js/features/string/big": [
		  	"es.string.big"
		  ],
		  	"core-js/features/string/blink": [
		  	"es.string.blink"
		  ],
		  	"core-js/features/string/bold": [
		  	"es.string.bold"
		  ],
		  	"core-js/features/string/code-point-at": [
		  	"es.string.code-point-at"
		  ],
		  	"core-js/features/string/code-points": [
		  	"es.object.to-string",
		  	"esnext.string.code-points"
		  ],
		  	"core-js/features/string/cooked": [
		  	"esnext.string.cooked"
		  ],
		  	"core-js/features/string/dedent": [
		  	"es.string.from-code-point",
		  	"es.weak-map",
		  	"esnext.string.dedent"
		  ],
		  	"core-js/features/string/ends-with": [
		  	"es.string.ends-with"
		  ],
		  	"core-js/features/string/fixed": [
		  	"es.string.fixed"
		  ],
		  	"core-js/features/string/fontcolor": [
		  	"es.string.fontcolor"
		  ],
		  	"core-js/features/string/fontsize": [
		  	"es.string.fontsize"
		  ],
		  	"core-js/features/string/from-code-point": [
		  	"es.string.from-code-point"
		  ],
		  	"core-js/features/string/includes": [
		  	"es.string.includes"
		  ],
		  	"core-js/features/string/is-well-formed": [
		  	"es.string.is-well-formed",
		  	"esnext.string.is-well-formed"
		  ],
		  	"core-js/features/string/italics": [
		  	"es.string.italics"
		  ],
		  	"core-js/features/string/iterator": [
		  	"es.object.to-string",
		  	"es.string.iterator"
		  ],
		  	"core-js/features/string/link": [
		  	"es.string.link"
		  ],
		  	"core-js/features/string/match": [
		  	"es.regexp.exec",
		  	"es.string.match"
		  ],
		  	"core-js/features/string/match-all": [
		  	"es.object.to-string",
		  	"es.regexp.exec",
		  	"es.string.match-all",
		  	"esnext.string.match-all"
		  ],
		  	"core-js/features/string/pad-end": [
		  	"es.string.pad-end"
		  ],
		  	"core-js/features/string/pad-start": [
		  	"es.string.pad-start"
		  ],
		  	"core-js/features/string/raw": [
		  	"es.string.raw"
		  ],
		  	"core-js/features/string/repeat": [
		  	"es.string.repeat"
		  ],
		  	"core-js/features/string/replace": [
		  	"es.regexp.exec",
		  	"es.string.replace"
		  ],
		  	"core-js/features/string/replace-all": [
		  	"es.regexp.exec",
		  	"es.string.replace",
		  	"es.string.replace-all",
		  	"esnext.string.replace-all"
		  ],
		  	"core-js/features/string/search": [
		  	"es.regexp.exec",
		  	"es.string.search"
		  ],
		  	"core-js/features/string/small": [
		  	"es.string.small"
		  ],
		  	"core-js/features/string/split": [
		  	"es.regexp.exec",
		  	"es.string.split"
		  ],
		  	"core-js/features/string/starts-with": [
		  	"es.string.starts-with"
		  ],
		  	"core-js/features/string/strike": [
		  	"es.string.strike"
		  ],
		  	"core-js/features/string/sub": [
		  	"es.string.sub"
		  ],
		  	"core-js/features/string/substr": [
		  	"es.string.substr"
		  ],
		  	"core-js/features/string/sup": [
		  	"es.string.sup"
		  ],
		  	"core-js/features/string/to-well-formed": [
		  	"es.string.to-well-formed",
		  	"esnext.string.to-well-formed"
		  ],
		  	"core-js/features/string/trim": [
		  	"es.string.trim"
		  ],
		  	"core-js/features/string/trim-end": [
		  	"es.string.trim-end"
		  ],
		  	"core-js/features/string/trim-left": [
		  	"es.string.trim-start"
		  ],
		  	"core-js/features/string/trim-right": [
		  	"es.string.trim-end"
		  ],
		  	"core-js/features/string/trim-start": [
		  	"es.string.trim-start"
		  ],
		  	"core-js/features/string/virtual": [
		  	"es.object.to-string",
		  	"es.regexp.exec",
		  	"es.string.at-alternative",
		  	"es.string.code-point-at",
		  	"es.string.ends-with",
		  	"es.string.includes",
		  	"es.string.iterator",
		  	"es.string.match",
		  	"es.string.match-all",
		  	"es.string.pad-end",
		  	"es.string.pad-start",
		  	"es.string.repeat",
		  	"es.string.replace",
		  	"es.string.replace-all",
		  	"es.string.search",
		  	"es.string.split",
		  	"es.string.starts-with",
		  	"es.string.substr",
		  	"es.string.trim",
		  	"es.string.trim-end",
		  	"es.string.trim-start",
		  	"es.string.anchor",
		  	"es.string.big",
		  	"es.string.blink",
		  	"es.string.bold",
		  	"es.string.fixed",
		  	"es.string.fontcolor",
		  	"es.string.fontsize",
		  	"es.string.italics",
		  	"es.string.link",
		  	"es.string.small",
		  	"es.string.strike",
		  	"es.string.sub",
		  	"es.string.sup",
		  	"esnext.string.at",
		  	"esnext.string.code-points",
		  	"esnext.string.is-well-formed",
		  	"esnext.string.match-all",
		  	"esnext.string.replace-all",
		  	"esnext.string.to-well-formed"
		  ],
		  	"core-js/features/string/virtual/anchor": [
		  	"es.string.anchor"
		  ],
		  	"core-js/features/string/virtual/at": [
		  	"es.string.at-alternative",
		  	"esnext.string.at"
		  ],
		  	"core-js/features/string/virtual/big": [
		  	"es.string.big"
		  ],
		  	"core-js/features/string/virtual/blink": [
		  	"es.string.blink"
		  ],
		  	"core-js/features/string/virtual/bold": [
		  	"es.string.bold"
		  ],
		  	"core-js/features/string/virtual/code-point-at": [
		  	"es.string.code-point-at"
		  ],
		  	"core-js/features/string/virtual/code-points": [
		  	"es.object.to-string",
		  	"esnext.string.code-points"
		  ],
		  	"core-js/features/string/virtual/ends-with": [
		  	"es.string.ends-with"
		  ],
		  	"core-js/features/string/virtual/fixed": [
		  	"es.string.fixed"
		  ],
		  	"core-js/features/string/virtual/fontcolor": [
		  	"es.string.fontcolor"
		  ],
		  	"core-js/features/string/virtual/fontsize": [
		  	"es.string.fontsize"
		  ],
		  	"core-js/features/string/virtual/includes": [
		  	"es.string.includes"
		  ],
		  	"core-js/features/string/virtual/is-well-formed": [
		  	"es.string.is-well-formed",
		  	"esnext.string.is-well-formed"
		  ],
		  	"core-js/features/string/virtual/italics": [
		  	"es.string.italics"
		  ],
		  	"core-js/features/string/virtual/iterator": [
		  	"es.object.to-string",
		  	"es.string.iterator"
		  ],
		  	"core-js/features/string/virtual/link": [
		  	"es.string.link"
		  ],
		  	"core-js/features/string/virtual/match-all": [
		  	"es.object.to-string",
		  	"es.regexp.exec",
		  	"es.string.match-all",
		  	"esnext.string.match-all"
		  ],
		  	"core-js/features/string/virtual/pad-end": [
		  	"es.string.pad-end"
		  ],
		  	"core-js/features/string/virtual/pad-start": [
		  	"es.string.pad-start"
		  ],
		  	"core-js/features/string/virtual/repeat": [
		  	"es.string.repeat"
		  ],
		  	"core-js/features/string/virtual/replace-all": [
		  	"es.regexp.exec",
		  	"es.string.replace",
		  	"es.string.replace-all",
		  	"esnext.string.replace-all"
		  ],
		  	"core-js/features/string/virtual/small": [
		  	"es.string.small"
		  ],
		  	"core-js/features/string/virtual/starts-with": [
		  	"es.string.starts-with"
		  ],
		  	"core-js/features/string/virtual/strike": [
		  	"es.string.strike"
		  ],
		  	"core-js/features/string/virtual/sub": [
		  	"es.string.sub"
		  ],
		  	"core-js/features/string/virtual/substr": [
		  	"es.string.substr"
		  ],
		  	"core-js/features/string/virtual/sup": [
		  	"es.string.sup"
		  ],
		  	"core-js/features/string/virtual/to-well-formed": [
		  	"es.string.to-well-formed",
		  	"esnext.string.to-well-formed"
		  ],
		  	"core-js/features/string/virtual/trim": [
		  	"es.string.trim"
		  ],
		  	"core-js/features/string/virtual/trim-end": [
		  	"es.string.trim-end"
		  ],
		  	"core-js/features/string/virtual/trim-left": [
		  	"es.string.trim-start"
		  ],
		  	"core-js/features/string/virtual/trim-right": [
		  	"es.string.trim-end"
		  ],
		  	"core-js/features/string/virtual/trim-start": [
		  	"es.string.trim-start"
		  ],
		  	"core-js/features/structured-clone": [
		  	"es.error.to-string",
		  	"es.array.iterator",
		  	"es.map",
		  	"es.object.keys",
		  	"es.object.to-string",
		  	"es.set",
		  	"web.dom-exception.constructor",
		  	"web.dom-exception.stack",
		  	"web.dom-exception.to-string-tag",
		  	"web.structured-clone"
		  ],
		  	"core-js/features/suppressed-error": [
		  ],
		  	"core-js/features/symbol": [
		  	"es.symbol",
		  	"es.symbol.description",
		  	"es.symbol.async-iterator",
		  	"es.symbol.has-instance",
		  	"es.symbol.is-concat-spreadable",
		  	"es.symbol.iterator",
		  	"es.symbol.match",
		  	"es.symbol.match-all",
		  	"es.symbol.replace",
		  	"es.symbol.search",
		  	"es.symbol.species",
		  	"es.symbol.split",
		  	"es.symbol.to-primitive",
		  	"es.symbol.to-string-tag",
		  	"es.symbol.unscopables",
		  	"es.array.concat",
		  	"es.json.to-string-tag",
		  	"es.math.to-string-tag",
		  	"es.object.to-string",
		  	"es.reflect.to-string-tag",
		  	"esnext.function.metadata",
		  	"esnext.symbol.async-dispose",
		  	"esnext.symbol.dispose",
		  	"esnext.symbol.is-registered-symbol",
		  	"esnext.symbol.is-registered",
		  	"esnext.symbol.is-well-known-symbol",
		  	"esnext.symbol.is-well-known",
		  	"esnext.symbol.matcher",
		  	"esnext.symbol.metadata",
		  	"esnext.symbol.metadata-key",
		  	"esnext.symbol.observable",
		  	"esnext.symbol.pattern-match",
		  	"esnext.symbol.replace-all",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/features/symbol/async-dispose": [
		  	"esnext.symbol.async-dispose"
		  ],
		  	"core-js/features/symbol/async-iterator": [
		  	"es.symbol.async-iterator"
		  ],
		  	"core-js/features/symbol/description": [
		  	"es.symbol.description"
		  ],
		  	"core-js/features/symbol/dispose": [
		  	"esnext.symbol.dispose"
		  ],
		  	"core-js/features/symbol/for": [
		  	"es.symbol"
		  ],
		  	"core-js/features/symbol/has-instance": [
		  	"es.symbol.has-instance",
		  	"es.function.has-instance"
		  ],
		  	"core-js/features/symbol/is-concat-spreadable": [
		  	"es.symbol.is-concat-spreadable",
		  	"es.array.concat"
		  ],
		  	"core-js/features/symbol/is-registered": [
		  	"es.symbol",
		  	"esnext.symbol.is-registered"
		  ],
		  	"core-js/features/symbol/is-registered-symbol": [
		  	"es.symbol",
		  	"esnext.symbol.is-registered-symbol"
		  ],
		  	"core-js/features/symbol/is-well-known": [
		  	"es.symbol",
		  	"esnext.symbol.is-well-known"
		  ],
		  	"core-js/features/symbol/is-well-known-symbol": [
		  	"es.symbol",
		  	"esnext.symbol.is-well-known-symbol"
		  ],
		  	"core-js/features/symbol/iterator": [
		  	"es.symbol.iterator",
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"es.string.iterator",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/features/symbol/key-for": [
		  	"es.symbol"
		  ],
		  	"core-js/features/symbol/match": [
		  	"es.symbol.match",
		  	"es.regexp.exec",
		  	"es.string.match"
		  ],
		  	"core-js/features/symbol/match-all": [
		  	"es.symbol.match-all",
		  	"es.object.to-string",
		  	"es.regexp.exec",
		  	"es.string.match-all"
		  ],
		  	"core-js/features/symbol/matcher": [
		  	"esnext.symbol.matcher"
		  ],
		  	"core-js/features/symbol/metadata": [
		  	"esnext.function.metadata",
		  	"esnext.symbol.metadata"
		  ],
		  	"core-js/features/symbol/metadata-key": [
		  	"esnext.symbol.metadata-key"
		  ],
		  	"core-js/features/symbol/observable": [
		  	"esnext.symbol.observable"
		  ],
		  	"core-js/features/symbol/pattern-match": [
		  	"esnext.symbol.pattern-match"
		  ],
		  	"core-js/features/symbol/replace": [
		  	"es.symbol.replace",
		  	"es.regexp.exec",
		  	"es.string.replace"
		  ],
		  	"core-js/features/symbol/replace-all": [
		  	"esnext.symbol.replace-all"
		  ],
		  	"core-js/features/symbol/search": [
		  	"es.symbol.search",
		  	"es.regexp.exec",
		  	"es.string.search"
		  ],
		  	"core-js/features/symbol/species": [
		  	"es.symbol.species"
		  ],
		  	"core-js/features/symbol/split": [
		  	"es.symbol.split",
		  	"es.regexp.exec",
		  	"es.string.split"
		  ],
		  	"core-js/features/symbol/to-primitive": [
		  	"es.symbol.to-primitive",
		  	"es.date.to-primitive"
		  ],
		  	"core-js/features/symbol/to-string-tag": [
		  	"es.symbol.to-string-tag",
		  	"es.json.to-string-tag",
		  	"es.math.to-string-tag",
		  	"es.object.to-string",
		  	"es.reflect.to-string-tag"
		  ],
		  	"core-js/features/symbol/unscopables": [
		  	"es.symbol.unscopables"
		  ],
		  	"core-js/features/typed-array": [
		  	"es.map",
		  	"es.object.to-string",
		  	"es.promise",
		  	"es.string.iterator",
		  	"es.typed-array.float32-array",
		  	"es.typed-array.float64-array",
		  	"es.typed-array.int8-array",
		  	"es.typed-array.int16-array",
		  	"es.typed-array.int32-array",
		  	"es.typed-array.uint8-array",
		  	"es.typed-array.uint8-clamped-array",
		  	"es.typed-array.uint16-array",
		  	"es.typed-array.uint32-array",
		  	"es.typed-array.at",
		  	"es.typed-array.copy-within",
		  	"es.typed-array.every",
		  	"es.typed-array.fill",
		  	"es.typed-array.filter",
		  	"es.typed-array.find",
		  	"es.typed-array.find-index",
		  	"es.typed-array.find-last",
		  	"es.typed-array.find-last-index",
		  	"es.typed-array.for-each",
		  	"es.typed-array.from",
		  	"es.typed-array.includes",
		  	"es.typed-array.index-of",
		  	"es.typed-array.iterator",
		  	"es.typed-array.join",
		  	"es.typed-array.last-index-of",
		  	"es.typed-array.map",
		  	"es.typed-array.of",
		  	"es.typed-array.reduce",
		  	"es.typed-array.reduce-right",
		  	"es.typed-array.reverse",
		  	"es.typed-array.set",
		  	"es.typed-array.slice",
		  	"es.typed-array.some",
		  	"es.typed-array.sort",
		  	"es.typed-array.subarray",
		  	"es.typed-array.to-locale-string",
		  	"es.typed-array.to-reversed",
		  	"es.typed-array.to-sorted",
		  	"es.typed-array.to-string",
		  	"es.typed-array.with",
		  	"esnext.typed-array.from-async",
		  	"esnext.typed-array.at",
		  	"esnext.typed-array.filter-out",
		  	"esnext.typed-array.filter-reject",
		  	"esnext.typed-array.find-last",
		  	"esnext.typed-array.find-last-index",
		  	"esnext.typed-array.group-by",
		  	"esnext.typed-array.to-reversed",
		  	"esnext.typed-array.to-sorted",
		  	"esnext.typed-array.to-spliced",
		  	"esnext.typed-array.unique-by",
		  	"esnext.typed-array.with",
		  	"esnext.uint8-array.from-base64",
		  	"esnext.uint8-array.from-hex",
		  	"esnext.uint8-array.to-base64",
		  	"esnext.uint8-array.to-hex"
		  ],
		  	"core-js/features/typed-array/at": [
		  	"es.typed-array.at",
		  	"esnext.typed-array.at"
		  ],
		  	"core-js/features/typed-array/copy-within": [
		  	"es.typed-array.copy-within"
		  ],
		  	"core-js/features/typed-array/entries": [
		  	"es.object.to-string",
		  	"es.typed-array.iterator"
		  ],
		  	"core-js/features/typed-array/every": [
		  	"es.typed-array.every"
		  ],
		  	"core-js/features/typed-array/fill": [
		  	"es.typed-array.fill"
		  ],
		  	"core-js/features/typed-array/filter": [
		  	"es.typed-array.filter"
		  ],
		  	"core-js/features/typed-array/filter-out": [
		  	"esnext.typed-array.filter-out"
		  ],
		  	"core-js/features/typed-array/filter-reject": [
		  	"esnext.typed-array.filter-reject"
		  ],
		  	"core-js/features/typed-array/find": [
		  	"es.typed-array.find"
		  ],
		  	"core-js/features/typed-array/find-index": [
		  	"es.typed-array.find-index"
		  ],
		  	"core-js/features/typed-array/find-last": [
		  	"es.typed-array.find-last",
		  	"esnext.typed-array.find-last"
		  ],
		  	"core-js/features/typed-array/find-last-index": [
		  	"es.typed-array.find-last-index",
		  	"esnext.typed-array.find-last-index"
		  ],
		  	"core-js/features/typed-array/float32-array": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.map",
		  	"es.object.to-string",
		  	"es.promise",
		  	"es.string.iterator",
		  	"es.typed-array.float32-array",
		  	"es.typed-array.at",
		  	"es.typed-array.copy-within",
		  	"es.typed-array.every",
		  	"es.typed-array.fill",
		  	"es.typed-array.filter",
		  	"es.typed-array.find",
		  	"es.typed-array.find-index",
		  	"es.typed-array.find-last",
		  	"es.typed-array.find-last-index",
		  	"es.typed-array.for-each",
		  	"es.typed-array.from",
		  	"es.typed-array.includes",
		  	"es.typed-array.index-of",
		  	"es.typed-array.iterator",
		  	"es.typed-array.join",
		  	"es.typed-array.last-index-of",
		  	"es.typed-array.map",
		  	"es.typed-array.of",
		  	"es.typed-array.reduce",
		  	"es.typed-array.reduce-right",
		  	"es.typed-array.reverse",
		  	"es.typed-array.set",
		  	"es.typed-array.slice",
		  	"es.typed-array.some",
		  	"es.typed-array.sort",
		  	"es.typed-array.subarray",
		  	"es.typed-array.to-locale-string",
		  	"es.typed-array.to-reversed",
		  	"es.typed-array.to-sorted",
		  	"es.typed-array.to-string",
		  	"es.typed-array.with",
		  	"esnext.typed-array.from-async",
		  	"esnext.typed-array.at",
		  	"esnext.typed-array.filter-out",
		  	"esnext.typed-array.filter-reject",
		  	"esnext.typed-array.find-last",
		  	"esnext.typed-array.find-last-index",
		  	"esnext.typed-array.group-by",
		  	"esnext.typed-array.to-reversed",
		  	"esnext.typed-array.to-sorted",
		  	"esnext.typed-array.to-spliced",
		  	"esnext.typed-array.unique-by",
		  	"esnext.typed-array.with",
		  	"esnext.uint8-array.from-base64",
		  	"esnext.uint8-array.from-hex",
		  	"esnext.uint8-array.to-base64",
		  	"esnext.uint8-array.to-hex"
		  ],
		  	"core-js/features/typed-array/float64-array": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.map",
		  	"es.object.to-string",
		  	"es.promise",
		  	"es.string.iterator",
		  	"es.typed-array.float64-array",
		  	"es.typed-array.at",
		  	"es.typed-array.copy-within",
		  	"es.typed-array.every",
		  	"es.typed-array.fill",
		  	"es.typed-array.filter",
		  	"es.typed-array.find",
		  	"es.typed-array.find-index",
		  	"es.typed-array.find-last",
		  	"es.typed-array.find-last-index",
		  	"es.typed-array.for-each",
		  	"es.typed-array.from",
		  	"es.typed-array.includes",
		  	"es.typed-array.index-of",
		  	"es.typed-array.iterator",
		  	"es.typed-array.join",
		  	"es.typed-array.last-index-of",
		  	"es.typed-array.map",
		  	"es.typed-array.of",
		  	"es.typed-array.reduce",
		  	"es.typed-array.reduce-right",
		  	"es.typed-array.reverse",
		  	"es.typed-array.set",
		  	"es.typed-array.slice",
		  	"es.typed-array.some",
		  	"es.typed-array.sort",
		  	"es.typed-array.subarray",
		  	"es.typed-array.to-locale-string",
		  	"es.typed-array.to-reversed",
		  	"es.typed-array.to-sorted",
		  	"es.typed-array.to-string",
		  	"es.typed-array.with",
		  	"esnext.typed-array.from-async",
		  	"esnext.typed-array.at",
		  	"esnext.typed-array.filter-out",
		  	"esnext.typed-array.filter-reject",
		  	"esnext.typed-array.find-last",
		  	"esnext.typed-array.find-last-index",
		  	"esnext.typed-array.group-by",
		  	"esnext.typed-array.to-reversed",
		  	"esnext.typed-array.to-sorted",
		  	"esnext.typed-array.to-spliced",
		  	"esnext.typed-array.unique-by",
		  	"esnext.typed-array.with",
		  	"esnext.uint8-array.from-base64",
		  	"esnext.uint8-array.from-hex",
		  	"esnext.uint8-array.to-base64",
		  	"esnext.uint8-array.to-hex"
		  ],
		  	"core-js/features/typed-array/for-each": [
		  	"es.typed-array.for-each"
		  ],
		  	"core-js/features/typed-array/from": [
		  	"es.typed-array.from"
		  ],
		  	"core-js/features/typed-array/from-async": [
		  	"esnext.typed-array.from-async"
		  ],
		  	"core-js/features/typed-array/from-base64": [
		  	"esnext.uint8-array.from-base64"
		  ],
		  	"core-js/features/typed-array/from-hex": [
		  	"esnext.uint8-array.from-hex"
		  ],
		  	"core-js/features/typed-array/group-by": [
		  	"esnext.typed-array.group-by"
		  ],
		  	"core-js/features/typed-array/includes": [
		  	"es.typed-array.includes"
		  ],
		  	"core-js/features/typed-array/index-of": [
		  	"es.typed-array.index-of"
		  ],
		  	"core-js/features/typed-array/int16-array": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.map",
		  	"es.object.to-string",
		  	"es.promise",
		  	"es.string.iterator",
		  	"es.typed-array.int16-array",
		  	"es.typed-array.at",
		  	"es.typed-array.copy-within",
		  	"es.typed-array.every",
		  	"es.typed-array.fill",
		  	"es.typed-array.filter",
		  	"es.typed-array.find",
		  	"es.typed-array.find-index",
		  	"es.typed-array.find-last",
		  	"es.typed-array.find-last-index",
		  	"es.typed-array.for-each",
		  	"es.typed-array.from",
		  	"es.typed-array.includes",
		  	"es.typed-array.index-of",
		  	"es.typed-array.iterator",
		  	"es.typed-array.join",
		  	"es.typed-array.last-index-of",
		  	"es.typed-array.map",
		  	"es.typed-array.of",
		  	"es.typed-array.reduce",
		  	"es.typed-array.reduce-right",
		  	"es.typed-array.reverse",
		  	"es.typed-array.set",
		  	"es.typed-array.slice",
		  	"es.typed-array.some",
		  	"es.typed-array.sort",
		  	"es.typed-array.subarray",
		  	"es.typed-array.to-locale-string",
		  	"es.typed-array.to-reversed",
		  	"es.typed-array.to-sorted",
		  	"es.typed-array.to-string",
		  	"es.typed-array.with",
		  	"esnext.typed-array.from-async",
		  	"esnext.typed-array.at",
		  	"esnext.typed-array.filter-out",
		  	"esnext.typed-array.filter-reject",
		  	"esnext.typed-array.find-last",
		  	"esnext.typed-array.find-last-index",
		  	"esnext.typed-array.group-by",
		  	"esnext.typed-array.to-reversed",
		  	"esnext.typed-array.to-sorted",
		  	"esnext.typed-array.to-spliced",
		  	"esnext.typed-array.unique-by",
		  	"esnext.typed-array.with",
		  	"esnext.uint8-array.from-base64",
		  	"esnext.uint8-array.from-hex",
		  	"esnext.uint8-array.to-base64",
		  	"esnext.uint8-array.to-hex"
		  ],
		  	"core-js/features/typed-array/int32-array": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.map",
		  	"es.object.to-string",
		  	"es.promise",
		  	"es.string.iterator",
		  	"es.typed-array.int32-array",
		  	"es.typed-array.at",
		  	"es.typed-array.copy-within",
		  	"es.typed-array.every",
		  	"es.typed-array.fill",
		  	"es.typed-array.filter",
		  	"es.typed-array.find",
		  	"es.typed-array.find-index",
		  	"es.typed-array.find-last",
		  	"es.typed-array.find-last-index",
		  	"es.typed-array.for-each",
		  	"es.typed-array.from",
		  	"es.typed-array.includes",
		  	"es.typed-array.index-of",
		  	"es.typed-array.iterator",
		  	"es.typed-array.join",
		  	"es.typed-array.last-index-of",
		  	"es.typed-array.map",
		  	"es.typed-array.of",
		  	"es.typed-array.reduce",
		  	"es.typed-array.reduce-right",
		  	"es.typed-array.reverse",
		  	"es.typed-array.set",
		  	"es.typed-array.slice",
		  	"es.typed-array.some",
		  	"es.typed-array.sort",
		  	"es.typed-array.subarray",
		  	"es.typed-array.to-locale-string",
		  	"es.typed-array.to-reversed",
		  	"es.typed-array.to-sorted",
		  	"es.typed-array.to-string",
		  	"es.typed-array.with",
		  	"esnext.typed-array.from-async",
		  	"esnext.typed-array.at",
		  	"esnext.typed-array.filter-out",
		  	"esnext.typed-array.filter-reject",
		  	"esnext.typed-array.find-last",
		  	"esnext.typed-array.find-last-index",
		  	"esnext.typed-array.group-by",
		  	"esnext.typed-array.to-reversed",
		  	"esnext.typed-array.to-sorted",
		  	"esnext.typed-array.to-spliced",
		  	"esnext.typed-array.unique-by",
		  	"esnext.typed-array.with",
		  	"esnext.uint8-array.from-base64",
		  	"esnext.uint8-array.from-hex",
		  	"esnext.uint8-array.to-base64",
		  	"esnext.uint8-array.to-hex"
		  ],
		  	"core-js/features/typed-array/int8-array": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.map",
		  	"es.object.to-string",
		  	"es.promise",
		  	"es.string.iterator",
		  	"es.typed-array.int8-array",
		  	"es.typed-array.at",
		  	"es.typed-array.copy-within",
		  	"es.typed-array.every",
		  	"es.typed-array.fill",
		  	"es.typed-array.filter",
		  	"es.typed-array.find",
		  	"es.typed-array.find-index",
		  	"es.typed-array.find-last",
		  	"es.typed-array.find-last-index",
		  	"es.typed-array.for-each",
		  	"es.typed-array.from",
		  	"es.typed-array.includes",
		  	"es.typed-array.index-of",
		  	"es.typed-array.iterator",
		  	"es.typed-array.join",
		  	"es.typed-array.last-index-of",
		  	"es.typed-array.map",
		  	"es.typed-array.of",
		  	"es.typed-array.reduce",
		  	"es.typed-array.reduce-right",
		  	"es.typed-array.reverse",
		  	"es.typed-array.set",
		  	"es.typed-array.slice",
		  	"es.typed-array.some",
		  	"es.typed-array.sort",
		  	"es.typed-array.subarray",
		  	"es.typed-array.to-locale-string",
		  	"es.typed-array.to-reversed",
		  	"es.typed-array.to-sorted",
		  	"es.typed-array.to-string",
		  	"es.typed-array.with",
		  	"esnext.typed-array.from-async",
		  	"esnext.typed-array.at",
		  	"esnext.typed-array.filter-out",
		  	"esnext.typed-array.filter-reject",
		  	"esnext.typed-array.find-last",
		  	"esnext.typed-array.find-last-index",
		  	"esnext.typed-array.group-by",
		  	"esnext.typed-array.to-reversed",
		  	"esnext.typed-array.to-sorted",
		  	"esnext.typed-array.to-spliced",
		  	"esnext.typed-array.unique-by",
		  	"esnext.typed-array.with",
		  	"esnext.uint8-array.from-base64",
		  	"esnext.uint8-array.from-hex",
		  	"esnext.uint8-array.to-base64",
		  	"esnext.uint8-array.to-hex"
		  ],
		  	"core-js/features/typed-array/iterator": [
		  	"es.object.to-string",
		  	"es.typed-array.iterator"
		  ],
		  	"core-js/features/typed-array/join": [
		  	"es.typed-array.join"
		  ],
		  	"core-js/features/typed-array/keys": [
		  	"es.object.to-string",
		  	"es.typed-array.iterator"
		  ],
		  	"core-js/features/typed-array/last-index-of": [
		  	"es.typed-array.last-index-of"
		  ],
		  	"core-js/features/typed-array/map": [
		  	"es.typed-array.map"
		  ],
		  	"core-js/features/typed-array/methods": [
		  	"es.map",
		  	"es.object.to-string",
		  	"es.promise",
		  	"es.string.iterator",
		  	"es.typed-array.at",
		  	"es.typed-array.copy-within",
		  	"es.typed-array.every",
		  	"es.typed-array.fill",
		  	"es.typed-array.filter",
		  	"es.typed-array.find",
		  	"es.typed-array.find-index",
		  	"es.typed-array.find-last",
		  	"es.typed-array.find-last-index",
		  	"es.typed-array.for-each",
		  	"es.typed-array.from",
		  	"es.typed-array.includes",
		  	"es.typed-array.index-of",
		  	"es.typed-array.iterator",
		  	"es.typed-array.join",
		  	"es.typed-array.last-index-of",
		  	"es.typed-array.map",
		  	"es.typed-array.of",
		  	"es.typed-array.reduce",
		  	"es.typed-array.reduce-right",
		  	"es.typed-array.reverse",
		  	"es.typed-array.set",
		  	"es.typed-array.slice",
		  	"es.typed-array.some",
		  	"es.typed-array.sort",
		  	"es.typed-array.subarray",
		  	"es.typed-array.to-locale-string",
		  	"es.typed-array.to-reversed",
		  	"es.typed-array.to-sorted",
		  	"es.typed-array.to-string",
		  	"es.typed-array.with",
		  	"esnext.typed-array.from-async",
		  	"esnext.typed-array.at",
		  	"esnext.typed-array.filter-out",
		  	"esnext.typed-array.filter-reject",
		  	"esnext.typed-array.find-last",
		  	"esnext.typed-array.find-last-index",
		  	"esnext.typed-array.group-by",
		  	"esnext.typed-array.to-reversed",
		  	"esnext.typed-array.to-sorted",
		  	"esnext.typed-array.to-spliced",
		  	"esnext.typed-array.unique-by",
		  	"esnext.typed-array.with",
		  	"esnext.uint8-array.from-base64",
		  	"esnext.uint8-array.from-hex",
		  	"esnext.uint8-array.to-base64",
		  	"esnext.uint8-array.to-hex"
		  ],
		  	"core-js/features/typed-array/of": [
		  	"es.typed-array.of"
		  ],
		  	"core-js/features/typed-array/reduce": [
		  	"es.typed-array.reduce"
		  ],
		  	"core-js/features/typed-array/reduce-right": [
		  	"es.typed-array.reduce-right"
		  ],
		  	"core-js/features/typed-array/reverse": [
		  	"es.typed-array.reverse"
		  ],
		  	"core-js/features/typed-array/set": [
		  	"es.typed-array.set"
		  ],
		  	"core-js/features/typed-array/slice": [
		  	"es.typed-array.slice"
		  ],
		  	"core-js/features/typed-array/some": [
		  	"es.typed-array.some"
		  ],
		  	"core-js/features/typed-array/sort": [
		  	"es.typed-array.sort"
		  ],
		  	"core-js/features/typed-array/subarray": [
		  	"es.typed-array.subarray"
		  ],
		  	"core-js/features/typed-array/to-base64": [
		  	"esnext.uint8-array.to-base64"
		  ],
		  	"core-js/features/typed-array/to-hex": [
		  	"esnext.uint8-array.to-hex"
		  ],
		  	"core-js/features/typed-array/to-locale-string": [
		  	"es.typed-array.to-locale-string"
		  ],
		  	"core-js/features/typed-array/to-reversed": [
		  	"es.typed-array.to-reversed",
		  	"esnext.typed-array.to-reversed"
		  ],
		  	"core-js/features/typed-array/to-sorted": [
		  	"es.typed-array.sort",
		  	"es.typed-array.to-sorted",
		  	"esnext.typed-array.to-sorted"
		  ],
		  	"core-js/features/typed-array/to-spliced": [
		  	"esnext.typed-array.to-spliced"
		  ],
		  	"core-js/features/typed-array/to-string": [
		  	"es.typed-array.to-string"
		  ],
		  	"core-js/features/typed-array/uint16-array": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.map",
		  	"es.object.to-string",
		  	"es.promise",
		  	"es.string.iterator",
		  	"es.typed-array.uint16-array",
		  	"es.typed-array.at",
		  	"es.typed-array.copy-within",
		  	"es.typed-array.every",
		  	"es.typed-array.fill",
		  	"es.typed-array.filter",
		  	"es.typed-array.find",
		  	"es.typed-array.find-index",
		  	"es.typed-array.find-last",
		  	"es.typed-array.find-last-index",
		  	"es.typed-array.for-each",
		  	"es.typed-array.from",
		  	"es.typed-array.includes",
		  	"es.typed-array.index-of",
		  	"es.typed-array.iterator",
		  	"es.typed-array.join",
		  	"es.typed-array.last-index-of",
		  	"es.typed-array.map",
		  	"es.typed-array.of",
		  	"es.typed-array.reduce",
		  	"es.typed-array.reduce-right",
		  	"es.typed-array.reverse",
		  	"es.typed-array.set",
		  	"es.typed-array.slice",
		  	"es.typed-array.some",
		  	"es.typed-array.sort",
		  	"es.typed-array.subarray",
		  	"es.typed-array.to-locale-string",
		  	"es.typed-array.to-reversed",
		  	"es.typed-array.to-sorted",
		  	"es.typed-array.to-string",
		  	"es.typed-array.with",
		  	"esnext.typed-array.from-async",
		  	"esnext.typed-array.at",
		  	"esnext.typed-array.filter-out",
		  	"esnext.typed-array.filter-reject",
		  	"esnext.typed-array.find-last",
		  	"esnext.typed-array.find-last-index",
		  	"esnext.typed-array.group-by",
		  	"esnext.typed-array.to-reversed",
		  	"esnext.typed-array.to-sorted",
		  	"esnext.typed-array.to-spliced",
		  	"esnext.typed-array.unique-by",
		  	"esnext.typed-array.with",
		  	"esnext.uint8-array.from-base64",
		  	"esnext.uint8-array.from-hex",
		  	"esnext.uint8-array.to-base64",
		  	"esnext.uint8-array.to-hex"
		  ],
		  	"core-js/features/typed-array/uint32-array": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.map",
		  	"es.object.to-string",
		  	"es.promise",
		  	"es.string.iterator",
		  	"es.typed-array.uint32-array",
		  	"es.typed-array.at",
		  	"es.typed-array.copy-within",
		  	"es.typed-array.every",
		  	"es.typed-array.fill",
		  	"es.typed-array.filter",
		  	"es.typed-array.find",
		  	"es.typed-array.find-index",
		  	"es.typed-array.find-last",
		  	"es.typed-array.find-last-index",
		  	"es.typed-array.for-each",
		  	"es.typed-array.from",
		  	"es.typed-array.includes",
		  	"es.typed-array.index-of",
		  	"es.typed-array.iterator",
		  	"es.typed-array.join",
		  	"es.typed-array.last-index-of",
		  	"es.typed-array.map",
		  	"es.typed-array.of",
		  	"es.typed-array.reduce",
		  	"es.typed-array.reduce-right",
		  	"es.typed-array.reverse",
		  	"es.typed-array.set",
		  	"es.typed-array.slice",
		  	"es.typed-array.some",
		  	"es.typed-array.sort",
		  	"es.typed-array.subarray",
		  	"es.typed-array.to-locale-string",
		  	"es.typed-array.to-reversed",
		  	"es.typed-array.to-sorted",
		  	"es.typed-array.to-string",
		  	"es.typed-array.with",
		  	"esnext.typed-array.from-async",
		  	"esnext.typed-array.at",
		  	"esnext.typed-array.filter-out",
		  	"esnext.typed-array.filter-reject",
		  	"esnext.typed-array.find-last",
		  	"esnext.typed-array.find-last-index",
		  	"esnext.typed-array.group-by",
		  	"esnext.typed-array.to-reversed",
		  	"esnext.typed-array.to-sorted",
		  	"esnext.typed-array.to-spliced",
		  	"esnext.typed-array.unique-by",
		  	"esnext.typed-array.with",
		  	"esnext.uint8-array.from-base64",
		  	"esnext.uint8-array.from-hex",
		  	"esnext.uint8-array.to-base64",
		  	"esnext.uint8-array.to-hex"
		  ],
		  	"core-js/features/typed-array/uint8-array": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.map",
		  	"es.object.to-string",
		  	"es.promise",
		  	"es.string.iterator",
		  	"es.typed-array.uint8-array",
		  	"es.typed-array.at",
		  	"es.typed-array.copy-within",
		  	"es.typed-array.every",
		  	"es.typed-array.fill",
		  	"es.typed-array.filter",
		  	"es.typed-array.find",
		  	"es.typed-array.find-index",
		  	"es.typed-array.find-last",
		  	"es.typed-array.find-last-index",
		  	"es.typed-array.for-each",
		  	"es.typed-array.from",
		  	"es.typed-array.includes",
		  	"es.typed-array.index-of",
		  	"es.typed-array.iterator",
		  	"es.typed-array.join",
		  	"es.typed-array.last-index-of",
		  	"es.typed-array.map",
		  	"es.typed-array.of",
		  	"es.typed-array.reduce",
		  	"es.typed-array.reduce-right",
		  	"es.typed-array.reverse",
		  	"es.typed-array.set",
		  	"es.typed-array.slice",
		  	"es.typed-array.some",
		  	"es.typed-array.sort",
		  	"es.typed-array.subarray",
		  	"es.typed-array.to-locale-string",
		  	"es.typed-array.to-reversed",
		  	"es.typed-array.to-sorted",
		  	"es.typed-array.to-string",
		  	"es.typed-array.with",
		  	"esnext.typed-array.from-async",
		  	"esnext.typed-array.at",
		  	"esnext.typed-array.filter-out",
		  	"esnext.typed-array.filter-reject",
		  	"esnext.typed-array.find-last",
		  	"esnext.typed-array.find-last-index",
		  	"esnext.typed-array.group-by",
		  	"esnext.typed-array.to-reversed",
		  	"esnext.typed-array.to-sorted",
		  	"esnext.typed-array.to-spliced",
		  	"esnext.typed-array.unique-by",
		  	"esnext.typed-array.with",
		  	"esnext.uint8-array.from-base64",
		  	"esnext.uint8-array.from-hex",
		  	"esnext.uint8-array.to-base64",
		  	"esnext.uint8-array.to-hex"
		  ],
		  	"core-js/features/typed-array/uint8-clamped-array": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.map",
		  	"es.object.to-string",
		  	"es.promise",
		  	"es.string.iterator",
		  	"es.typed-array.uint8-clamped-array",
		  	"es.typed-array.at",
		  	"es.typed-array.copy-within",
		  	"es.typed-array.every",
		  	"es.typed-array.fill",
		  	"es.typed-array.filter",
		  	"es.typed-array.find",
		  	"es.typed-array.find-index",
		  	"es.typed-array.find-last",
		  	"es.typed-array.find-last-index",
		  	"es.typed-array.for-each",
		  	"es.typed-array.from",
		  	"es.typed-array.includes",
		  	"es.typed-array.index-of",
		  	"es.typed-array.iterator",
		  	"es.typed-array.join",
		  	"es.typed-array.last-index-of",
		  	"es.typed-array.map",
		  	"es.typed-array.of",
		  	"es.typed-array.reduce",
		  	"es.typed-array.reduce-right",
		  	"es.typed-array.reverse",
		  	"es.typed-array.set",
		  	"es.typed-array.slice",
		  	"es.typed-array.some",
		  	"es.typed-array.sort",
		  	"es.typed-array.subarray",
		  	"es.typed-array.to-locale-string",
		  	"es.typed-array.to-reversed",
		  	"es.typed-array.to-sorted",
		  	"es.typed-array.to-string",
		  	"es.typed-array.with",
		  	"esnext.typed-array.from-async",
		  	"esnext.typed-array.at",
		  	"esnext.typed-array.filter-out",
		  	"esnext.typed-array.filter-reject",
		  	"esnext.typed-array.find-last",
		  	"esnext.typed-array.find-last-index",
		  	"esnext.typed-array.group-by",
		  	"esnext.typed-array.to-reversed",
		  	"esnext.typed-array.to-sorted",
		  	"esnext.typed-array.to-spliced",
		  	"esnext.typed-array.unique-by",
		  	"esnext.typed-array.with",
		  	"esnext.uint8-array.from-base64",
		  	"esnext.uint8-array.from-hex",
		  	"esnext.uint8-array.to-base64",
		  	"esnext.uint8-array.to-hex"
		  ],
		  	"core-js/features/typed-array/unique-by": [
		  	"es.map",
		  	"esnext.typed-array.unique-by"
		  ],
		  	"core-js/features/typed-array/values": [
		  	"es.object.to-string",
		  	"es.typed-array.iterator"
		  ],
		  	"core-js/features/typed-array/with": [
		  	"es.typed-array.with",
		  	"esnext.typed-array.with"
		  ],
		  	"core-js/features/unescape": [
		  	"es.unescape"
		  ],
		  	"core-js/features/url": [
		  	"web.url",
		  	"web.url.can-parse",
		  	"web.url.to-json",
		  	"web.url-search-params",
		  	"web.url-search-params.delete",
		  	"web.url-search-params.has",
		  	"web.url-search-params.size"
		  ],
		  	"core-js/features/url-search-params": [
		  	"web.dom-collections.iterator",
		  	"web.url-search-params",
		  	"web.url-search-params.delete",
		  	"web.url-search-params.has",
		  	"web.url-search-params.size"
		  ],
		  	"core-js/features/url/can-parse": [
		  	"web.url",
		  	"web.url.can-parse"
		  ],
		  	"core-js/features/url/to-json": [
		  	"web.url.to-json"
		  ],
		  	"core-js/features/weak-map": [
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"es.string.iterator",
		  	"es.weak-map",
		  	"esnext.weak-map.delete-all",
		  	"esnext.weak-map.from",
		  	"esnext.weak-map.of",
		  	"esnext.weak-map.emplace",
		  	"esnext.weak-map.upsert",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/features/weak-map/delete-all": [
		  	"es.weak-map",
		  	"esnext.weak-map.delete-all"
		  ],
		  	"core-js/features/weak-map/emplace": [
		  	"es.weak-map",
		  	"esnext.weak-map.emplace"
		  ],
		  	"core-js/features/weak-map/from": [
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"es.string.iterator",
		  	"es.weak-map",
		  	"esnext.weak-map.delete-all",
		  	"esnext.weak-map.from",
		  	"esnext.weak-map.emplace",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/features/weak-map/of": [
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"es.weak-map",
		  	"esnext.weak-map.delete-all",
		  	"esnext.weak-map.of",
		  	"esnext.weak-map.emplace"
		  ],
		  	"core-js/features/weak-map/upsert": [
		  	"es.weak-map",
		  	"esnext.weak-map.upsert"
		  ],
		  	"core-js/features/weak-set": [
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"es.string.iterator",
		  	"es.weak-set",
		  	"esnext.weak-set.add-all",
		  	"esnext.weak-set.delete-all",
		  	"esnext.weak-set.from",
		  	"esnext.weak-set.of",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/features/weak-set/add-all": [
		  	"es.weak-set",
		  	"esnext.weak-set.add-all"
		  ],
		  	"core-js/features/weak-set/delete-all": [
		  	"es.weak-set",
		  	"esnext.weak-set.delete-all"
		  ],
		  	"core-js/features/weak-set/from": [
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"es.string.iterator",
		  	"es.weak-set",
		  	"esnext.weak-set.add-all",
		  	"esnext.weak-set.delete-all",
		  	"esnext.weak-set.from",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/features/weak-set/of": [
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"es.weak-set",
		  	"esnext.weak-set.add-all",
		  	"esnext.weak-set.delete-all",
		  	"esnext.weak-set.of"
		  ],
		  	"core-js/full": [
		  	"es.symbol",
		  	"es.symbol.description",
		  	"es.symbol.async-iterator",
		  	"es.symbol.has-instance",
		  	"es.symbol.is-concat-spreadable",
		  	"es.symbol.iterator",
		  	"es.symbol.match",
		  	"es.symbol.match-all",
		  	"es.symbol.replace",
		  	"es.symbol.search",
		  	"es.symbol.species",
		  	"es.symbol.split",
		  	"es.symbol.to-primitive",
		  	"es.symbol.to-string-tag",
		  	"es.symbol.unscopables",
		  	"es.error.cause",
		  	"es.error.to-string",
		  	"es.aggregate-error",
		  	"es.aggregate-error.cause",
		  	"es.array.at",
		  	"es.array.concat",
		  	"es.array.copy-within",
		  	"es.array.every",
		  	"es.array.fill",
		  	"es.array.filter",
		  	"es.array.find",
		  	"es.array.find-index",
		  	"es.array.find-last",
		  	"es.array.find-last-index",
		  	"es.array.flat",
		  	"es.array.flat-map",
		  	"es.array.for-each",
		  	"es.array.from",
		  	"es.array.includes",
		  	"es.array.index-of",
		  	"es.array.is-array",
		  	"es.array.iterator",
		  	"es.array.join",
		  	"es.array.last-index-of",
		  	"es.array.map",
		  	"es.array.of",
		  	"es.array.push",
		  	"es.array.reduce",
		  	"es.array.reduce-right",
		  	"es.array.reverse",
		  	"es.array.slice",
		  	"es.array.some",
		  	"es.array.sort",
		  	"es.array.species",
		  	"es.array.splice",
		  	"es.array.to-reversed",
		  	"es.array.to-sorted",
		  	"es.array.to-spliced",
		  	"es.array.unscopables.flat",
		  	"es.array.unscopables.flat-map",
		  	"es.array.unshift",
		  	"es.array.with",
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.is-view",
		  	"es.array-buffer.slice",
		  	"es.data-view",
		  	"es.array-buffer.detached",
		  	"es.array-buffer.transfer",
		  	"es.array-buffer.transfer-to-fixed-length",
		  	"es.date.get-year",
		  	"es.date.now",
		  	"es.date.set-year",
		  	"es.date.to-gmt-string",
		  	"es.date.to-iso-string",
		  	"es.date.to-json",
		  	"es.date.to-primitive",
		  	"es.date.to-string",
		  	"es.escape",
		  	"es.function.bind",
		  	"es.function.has-instance",
		  	"es.function.name",
		  	"es.global-this",
		  	"es.json.stringify",
		  	"es.json.to-string-tag",
		  	"es.map",
		  	"es.map.group-by",
		  	"es.math.acosh",
		  	"es.math.asinh",
		  	"es.math.atanh",
		  	"es.math.cbrt",
		  	"es.math.clz32",
		  	"es.math.cosh",
		  	"es.math.expm1",
		  	"es.math.fround",
		  	"es.math.hypot",
		  	"es.math.imul",
		  	"es.math.log10",
		  	"es.math.log1p",
		  	"es.math.log2",
		  	"es.math.sign",
		  	"es.math.sinh",
		  	"es.math.tanh",
		  	"es.math.to-string-tag",
		  	"es.math.trunc",
		  	"es.number.constructor",
		  	"es.number.epsilon",
		  	"es.number.is-finite",
		  	"es.number.is-integer",
		  	"es.number.is-nan",
		  	"es.number.is-safe-integer",
		  	"es.number.max-safe-integer",
		  	"es.number.min-safe-integer",
		  	"es.number.parse-float",
		  	"es.number.parse-int",
		  	"es.number.to-exponential",
		  	"es.number.to-fixed",
		  	"es.number.to-precision",
		  	"es.object.assign",
		  	"es.object.create",
		  	"es.object.define-getter",
		  	"es.object.define-properties",
		  	"es.object.define-property",
		  	"es.object.define-setter",
		  	"es.object.entries",
		  	"es.object.freeze",
		  	"es.object.from-entries",
		  	"es.object.get-own-property-descriptor",
		  	"es.object.get-own-property-descriptors",
		  	"es.object.get-own-property-names",
		  	"es.object.get-prototype-of",
		  	"es.object.group-by",
		  	"es.object.has-own",
		  	"es.object.is",
		  	"es.object.is-extensible",
		  	"es.object.is-frozen",
		  	"es.object.is-sealed",
		  	"es.object.keys",
		  	"es.object.lookup-getter",
		  	"es.object.lookup-setter",
		  	"es.object.prevent-extensions",
		  	"es.object.proto",
		  	"es.object.seal",
		  	"es.object.set-prototype-of",
		  	"es.object.to-string",
		  	"es.object.values",
		  	"es.parse-float",
		  	"es.parse-int",
		  	"es.promise",
		  	"es.promise.all-settled",
		  	"es.promise.any",
		  	"es.promise.finally",
		  	"es.promise.with-resolvers",
		  	"es.reflect.apply",
		  	"es.reflect.construct",
		  	"es.reflect.define-property",
		  	"es.reflect.delete-property",
		  	"es.reflect.get",
		  	"es.reflect.get-own-property-descriptor",
		  	"es.reflect.get-prototype-of",
		  	"es.reflect.has",
		  	"es.reflect.is-extensible",
		  	"es.reflect.own-keys",
		  	"es.reflect.prevent-extensions",
		  	"es.reflect.set",
		  	"es.reflect.set-prototype-of",
		  	"es.reflect.to-string-tag",
		  	"es.regexp.constructor",
		  	"es.regexp.dot-all",
		  	"es.regexp.exec",
		  	"es.regexp.flags",
		  	"es.regexp.sticky",
		  	"es.regexp.test",
		  	"es.regexp.to-string",
		  	"es.set",
		  	"es.string.at-alternative",
		  	"es.string.code-point-at",
		  	"es.string.ends-with",
		  	"es.string.from-code-point",
		  	"es.string.includes",
		  	"es.string.is-well-formed",
		  	"es.string.iterator",
		  	"es.string.match",
		  	"es.string.match-all",
		  	"es.string.pad-end",
		  	"es.string.pad-start",
		  	"es.string.raw",
		  	"es.string.repeat",
		  	"es.string.replace",
		  	"es.string.replace-all",
		  	"es.string.search",
		  	"es.string.split",
		  	"es.string.starts-with",
		  	"es.string.substr",
		  	"es.string.to-well-formed",
		  	"es.string.trim",
		  	"es.string.trim-end",
		  	"es.string.trim-start",
		  	"es.string.anchor",
		  	"es.string.big",
		  	"es.string.blink",
		  	"es.string.bold",
		  	"es.string.fixed",
		  	"es.string.fontcolor",
		  	"es.string.fontsize",
		  	"es.string.italics",
		  	"es.string.link",
		  	"es.string.small",
		  	"es.string.strike",
		  	"es.string.sub",
		  	"es.string.sup",
		  	"es.typed-array.float32-array",
		  	"es.typed-array.float64-array",
		  	"es.typed-array.int8-array",
		  	"es.typed-array.int16-array",
		  	"es.typed-array.int32-array",
		  	"es.typed-array.uint8-array",
		  	"es.typed-array.uint8-clamped-array",
		  	"es.typed-array.uint16-array",
		  	"es.typed-array.uint32-array",
		  	"es.typed-array.at",
		  	"es.typed-array.copy-within",
		  	"es.typed-array.every",
		  	"es.typed-array.fill",
		  	"es.typed-array.filter",
		  	"es.typed-array.find",
		  	"es.typed-array.find-index",
		  	"es.typed-array.find-last",
		  	"es.typed-array.find-last-index",
		  	"es.typed-array.for-each",
		  	"es.typed-array.from",
		  	"es.typed-array.includes",
		  	"es.typed-array.index-of",
		  	"es.typed-array.iterator",
		  	"es.typed-array.join",
		  	"es.typed-array.last-index-of",
		  	"es.typed-array.map",
		  	"es.typed-array.of",
		  	"es.typed-array.reduce",
		  	"es.typed-array.reduce-right",
		  	"es.typed-array.reverse",
		  	"es.typed-array.set",
		  	"es.typed-array.slice",
		  	"es.typed-array.some",
		  	"es.typed-array.sort",
		  	"es.typed-array.subarray",
		  	"es.typed-array.to-locale-string",
		  	"es.typed-array.to-reversed",
		  	"es.typed-array.to-sorted",
		  	"es.typed-array.to-string",
		  	"es.typed-array.with",
		  	"es.unescape",
		  	"es.weak-map",
		  	"es.weak-set",
		  	"esnext.aggregate-error",
		  	"esnext.suppressed-error.constructor",
		  	"esnext.array.from-async",
		  	"esnext.array.at",
		  	"esnext.array.filter-out",
		  	"esnext.array.filter-reject",
		  	"esnext.array.find-last",
		  	"esnext.array.find-last-index",
		  	"esnext.array.group",
		  	"esnext.array.group-by",
		  	"esnext.array.group-by-to-map",
		  	"esnext.array.group-to-map",
		  	"esnext.array.is-template-object",
		  	"esnext.array.last-index",
		  	"esnext.array.last-item",
		  	"esnext.array.to-reversed",
		  	"esnext.array.to-sorted",
		  	"esnext.array.to-spliced",
		  	"esnext.array.unique-by",
		  	"esnext.array.with",
		  	"esnext.array-buffer.detached",
		  	"esnext.array-buffer.transfer",
		  	"esnext.array-buffer.transfer-to-fixed-length",
		  	"esnext.async-disposable-stack.constructor",
		  	"esnext.async-iterator.constructor",
		  	"esnext.async-iterator.as-indexed-pairs",
		  	"esnext.async-iterator.async-dispose",
		  	"esnext.async-iterator.drop",
		  	"esnext.async-iterator.every",
		  	"esnext.async-iterator.filter",
		  	"esnext.async-iterator.find",
		  	"esnext.async-iterator.flat-map",
		  	"esnext.async-iterator.for-each",
		  	"esnext.async-iterator.from",
		  	"esnext.async-iterator.indexed",
		  	"esnext.async-iterator.map",
		  	"esnext.async-iterator.reduce",
		  	"esnext.async-iterator.some",
		  	"esnext.async-iterator.take",
		  	"esnext.async-iterator.to-array",
		  	"esnext.bigint.range",
		  	"esnext.composite-key",
		  	"esnext.composite-symbol",
		  	"esnext.data-view.get-float16",
		  	"esnext.data-view.get-uint8-clamped",
		  	"esnext.data-view.set-float16",
		  	"esnext.data-view.set-uint8-clamped",
		  	"esnext.disposable-stack.constructor",
		  	"esnext.function.demethodize",
		  	"esnext.function.is-callable",
		  	"esnext.function.is-constructor",
		  	"esnext.function.metadata",
		  	"esnext.function.un-this",
		  	"esnext.global-this",
		  	"esnext.iterator.constructor",
		  	"esnext.iterator.as-indexed-pairs",
		  	"esnext.iterator.dispose",
		  	"esnext.iterator.drop",
		  	"esnext.iterator.every",
		  	"esnext.iterator.filter",
		  	"esnext.iterator.find",
		  	"esnext.iterator.flat-map",
		  	"esnext.iterator.for-each",
		  	"esnext.iterator.from",
		  	"esnext.iterator.indexed",
		  	"esnext.iterator.map",
		  	"esnext.iterator.range",
		  	"esnext.iterator.reduce",
		  	"esnext.iterator.some",
		  	"esnext.iterator.take",
		  	"esnext.iterator.to-array",
		  	"esnext.iterator.to-async",
		  	"esnext.json.is-raw-json",
		  	"esnext.json.parse",
		  	"esnext.json.raw-json",
		  	"esnext.map.delete-all",
		  	"esnext.map.emplace",
		  	"esnext.map.every",
		  	"esnext.map.filter",
		  	"esnext.map.find",
		  	"esnext.map.find-key",
		  	"esnext.map.from",
		  	"esnext.map.group-by",
		  	"esnext.map.includes",
		  	"esnext.map.key-by",
		  	"esnext.map.key-of",
		  	"esnext.map.map-keys",
		  	"esnext.map.map-values",
		  	"esnext.map.merge",
		  	"esnext.map.of",
		  	"esnext.map.reduce",
		  	"esnext.map.some",
		  	"esnext.map.update",
		  	"esnext.map.update-or-insert",
		  	"esnext.map.upsert",
		  	"esnext.math.clamp",
		  	"esnext.math.deg-per-rad",
		  	"esnext.math.degrees",
		  	"esnext.math.fscale",
		  	"esnext.math.f16round",
		  	"esnext.math.iaddh",
		  	"esnext.math.imulh",
		  	"esnext.math.isubh",
		  	"esnext.math.rad-per-deg",
		  	"esnext.math.radians",
		  	"esnext.math.scale",
		  	"esnext.math.seeded-prng",
		  	"esnext.math.signbit",
		  	"esnext.math.umulh",
		  	"esnext.number.from-string",
		  	"esnext.number.range",
		  	"esnext.object.has-own",
		  	"esnext.object.iterate-entries",
		  	"esnext.object.iterate-keys",
		  	"esnext.object.iterate-values",
		  	"esnext.object.group-by",
		  	"esnext.observable",
		  	"esnext.promise.all-settled",
		  	"esnext.promise.any",
		  	"esnext.promise.try",
		  	"esnext.promise.with-resolvers",
		  	"esnext.reflect.define-metadata",
		  	"esnext.reflect.delete-metadata",
		  	"esnext.reflect.get-metadata",
		  	"esnext.reflect.get-metadata-keys",
		  	"esnext.reflect.get-own-metadata",
		  	"esnext.reflect.get-own-metadata-keys",
		  	"esnext.reflect.has-metadata",
		  	"esnext.reflect.has-own-metadata",
		  	"esnext.reflect.metadata",
		  	"esnext.regexp.escape",
		  	"esnext.set.add-all",
		  	"esnext.set.delete-all",
		  	"esnext.set.difference.v2",
		  	"esnext.set.difference",
		  	"esnext.set.every",
		  	"esnext.set.filter",
		  	"esnext.set.find",
		  	"esnext.set.from",
		  	"esnext.set.intersection.v2",
		  	"esnext.set.intersection",
		  	"esnext.set.is-disjoint-from.v2",
		  	"esnext.set.is-disjoint-from",
		  	"esnext.set.is-subset-of.v2",
		  	"esnext.set.is-subset-of",
		  	"esnext.set.is-superset-of.v2",
		  	"esnext.set.is-superset-of",
		  	"esnext.set.join",
		  	"esnext.set.map",
		  	"esnext.set.of",
		  	"esnext.set.reduce",
		  	"esnext.set.some",
		  	"esnext.set.symmetric-difference.v2",
		  	"esnext.set.symmetric-difference",
		  	"esnext.set.union.v2",
		  	"esnext.set.union",
		  	"esnext.string.at",
		  	"esnext.string.cooked",
		  	"esnext.string.code-points",
		  	"esnext.string.dedent",
		  	"esnext.string.is-well-formed",
		  	"esnext.string.match-all",
		  	"esnext.string.replace-all",
		  	"esnext.string.to-well-formed",
		  	"esnext.symbol.async-dispose",
		  	"esnext.symbol.dispose",
		  	"esnext.symbol.is-registered-symbol",
		  	"esnext.symbol.is-registered",
		  	"esnext.symbol.is-well-known-symbol",
		  	"esnext.symbol.is-well-known",
		  	"esnext.symbol.matcher",
		  	"esnext.symbol.metadata",
		  	"esnext.symbol.metadata-key",
		  	"esnext.symbol.observable",
		  	"esnext.symbol.pattern-match",
		  	"esnext.symbol.replace-all",
		  	"esnext.typed-array.from-async",
		  	"esnext.typed-array.at",
		  	"esnext.typed-array.filter-out",
		  	"esnext.typed-array.filter-reject",
		  	"esnext.typed-array.find-last",
		  	"esnext.typed-array.find-last-index",
		  	"esnext.typed-array.group-by",
		  	"esnext.typed-array.to-reversed",
		  	"esnext.typed-array.to-sorted",
		  	"esnext.typed-array.to-spliced",
		  	"esnext.typed-array.unique-by",
		  	"esnext.typed-array.with",
		  	"esnext.uint8-array.from-base64",
		  	"esnext.uint8-array.from-hex",
		  	"esnext.uint8-array.to-base64",
		  	"esnext.uint8-array.to-hex",
		  	"esnext.weak-map.delete-all",
		  	"esnext.weak-map.from",
		  	"esnext.weak-map.of",
		  	"esnext.weak-map.emplace",
		  	"esnext.weak-map.upsert",
		  	"esnext.weak-set.add-all",
		  	"esnext.weak-set.delete-all",
		  	"esnext.weak-set.from",
		  	"esnext.weak-set.of",
		  	"web.atob",
		  	"web.btoa",
		  	"web.dom-collections.for-each",
		  	"web.dom-collections.iterator",
		  	"web.dom-exception.constructor",
		  	"web.dom-exception.stack",
		  	"web.dom-exception.to-string-tag",
		  	"web.immediate",
		  	"web.queue-microtask",
		  	"web.self",
		  	"web.structured-clone",
		  	"web.timers",
		  	"web.url",
		  	"web.url.can-parse",
		  	"web.url.to-json",
		  	"web.url-search-params",
		  	"web.url-search-params.delete",
		  	"web.url-search-params.has",
		  	"web.url-search-params.size"
		  ],
		  	"core-js/full/aggregate-error": [
		  ],
		  	"core-js/full/array": [
		  	"es.array.at",
		  	"es.array.concat",
		  	"es.array.copy-within",
		  	"es.array.every",
		  	"es.array.fill",
		  	"es.array.filter",
		  	"es.array.find",
		  	"es.array.find-index",
		  	"es.array.find-last",
		  	"es.array.find-last-index",
		  	"es.array.flat",
		  	"es.array.flat-map",
		  	"es.array.for-each",
		  	"es.array.from",
		  	"es.array.includes",
		  	"es.array.index-of",
		  	"es.array.is-array",
		  	"es.array.iterator",
		  	"es.array.join",
		  	"es.array.last-index-of",
		  	"es.array.map",
		  	"es.array.of",
		  	"es.array.push",
		  	"es.array.reduce",
		  	"es.array.reduce-right",
		  	"es.array.reverse",
		  	"es.array.slice",
		  	"es.array.some",
		  	"es.array.sort",
		  	"es.array.species",
		  	"es.array.splice",
		  	"es.array.to-reversed",
		  	"es.array.to-sorted",
		  	"es.array.to-spliced",
		  	"es.array.unscopables.flat",
		  	"es.array.unscopables.flat-map",
		  	"es.array.unshift",
		  	"es.array.with",
		  	"es.map",
		  	"es.object.to-string",
		  	"es.promise",
		  	"es.string.iterator",
		  	"esnext.array.from-async",
		  	"esnext.array.at",
		  	"esnext.array.filter-out",
		  	"esnext.array.filter-reject",
		  	"esnext.array.find-last",
		  	"esnext.array.find-last-index",
		  	"esnext.array.group",
		  	"esnext.array.group-by",
		  	"esnext.array.group-by-to-map",
		  	"esnext.array.group-to-map",
		  	"esnext.array.is-template-object",
		  	"esnext.array.last-index",
		  	"esnext.array.last-item",
		  	"esnext.array.to-reversed",
		  	"esnext.array.to-sorted",
		  	"esnext.array.to-spliced",
		  	"esnext.array.unique-by",
		  	"esnext.array.with"
		  ],
		  	"core-js/full/array-buffer": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.is-view",
		  	"es.array-buffer.slice",
		  	"es.data-view",
		  	"es.array-buffer.detached",
		  	"es.array-buffer.transfer",
		  	"es.array-buffer.transfer-to-fixed-length",
		  	"es.object.to-string",
		  	"esnext.array-buffer.detached",
		  	"esnext.array-buffer.transfer",
		  	"esnext.array-buffer.transfer-to-fixed-length"
		  ],
		  	"core-js/full/array-buffer/constructor": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.array-buffer.detached",
		  	"es.array-buffer.transfer",
		  	"es.array-buffer.transfer-to-fixed-length",
		  	"es.object.to-string",
		  	"esnext.array-buffer.detached",
		  	"esnext.array-buffer.transfer",
		  	"esnext.array-buffer.transfer-to-fixed-length"
		  ],
		  	"core-js/full/array-buffer/detached": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.array-buffer.detached",
		  	"esnext.array-buffer.detached"
		  ],
		  	"core-js/full/array-buffer/is-view": [
		  	"es.array-buffer.is-view"
		  ],
		  	"core-js/full/array-buffer/slice": [
		  	"es.array-buffer.slice"
		  ],
		  	"core-js/full/array-buffer/transfer": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.data-view",
		  	"es.array-buffer.transfer",
		  	"esnext.array-buffer.transfer"
		  ],
		  	"core-js/full/array-buffer/transfer-to-fixed-length": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.data-view",
		  	"es.array-buffer.transfer-to-fixed-length",
		  	"esnext.array-buffer.transfer-to-fixed-length"
		  ],
		  	"core-js/full/array/at": [
		  	"es.array.at",
		  	"esnext.array.at"
		  ],
		  	"core-js/full/array/concat": [
		  	"es.array.concat"
		  ],
		  	"core-js/full/array/copy-within": [
		  	"es.array.copy-within"
		  ],
		  	"core-js/full/array/entries": [
		  	"es.array.iterator",
		  	"es.object.to-string"
		  ],
		  	"core-js/full/array/every": [
		  	"es.array.every"
		  ],
		  	"core-js/full/array/fill": [
		  	"es.array.fill"
		  ],
		  	"core-js/full/array/filter": [
		  	"es.array.filter"
		  ],
		  	"core-js/full/array/filter-out": [
		  	"esnext.array.filter-out"
		  ],
		  	"core-js/full/array/filter-reject": [
		  	"esnext.array.filter-reject"
		  ],
		  	"core-js/full/array/find": [
		  	"es.array.find"
		  ],
		  	"core-js/full/array/find-index": [
		  	"es.array.find-index"
		  ],
		  	"core-js/full/array/find-last": [
		  	"es.array.find-last",
		  	"esnext.array.find-last"
		  ],
		  	"core-js/full/array/find-last-index": [
		  	"es.array.find-last-index",
		  	"esnext.array.find-last-index"
		  ],
		  	"core-js/full/array/flat": [
		  	"es.array.flat",
		  	"es.array.unscopables.flat"
		  ],
		  	"core-js/full/array/flat-map": [
		  	"es.array.flat-map",
		  	"es.array.unscopables.flat-map"
		  ],
		  	"core-js/full/array/for-each": [
		  	"es.array.for-each"
		  ],
		  	"core-js/full/array/from": [
		  	"es.array.from",
		  	"es.string.iterator"
		  ],
		  	"core-js/full/array/from-async": [
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"es.promise",
		  	"es.string.iterator",
		  	"esnext.array.from-async"
		  ],
		  	"core-js/full/array/group": [
		  	"esnext.array.group"
		  ],
		  	"core-js/full/array/group-by": [
		  	"esnext.array.group-by"
		  ],
		  	"core-js/full/array/group-by-to-map": [
		  	"es.map",
		  	"es.object.to-string",
		  	"esnext.array.group-by-to-map"
		  ],
		  	"core-js/full/array/group-to-map": [
		  	"es.map",
		  	"es.object.to-string",
		  	"esnext.array.group-to-map"
		  ],
		  	"core-js/full/array/includes": [
		  	"es.array.includes"
		  ],
		  	"core-js/full/array/index-of": [
		  	"es.array.index-of"
		  ],
		  	"core-js/full/array/is-array": [
		  	"es.array.is-array"
		  ],
		  	"core-js/full/array/is-template-object": [
		  	"esnext.array.is-template-object"
		  ],
		  	"core-js/full/array/iterator": [
		  	"es.array.iterator",
		  	"es.object.to-string"
		  ],
		  	"core-js/full/array/join": [
		  	"es.array.join"
		  ],
		  	"core-js/full/array/keys": [
		  	"es.array.iterator",
		  	"es.object.to-string"
		  ],
		  	"core-js/full/array/last-index": [
		  	"esnext.array.last-index"
		  ],
		  	"core-js/full/array/last-index-of": [
		  	"es.array.last-index-of"
		  ],
		  	"core-js/full/array/last-item": [
		  	"esnext.array.last-item"
		  ],
		  	"core-js/full/array/map": [
		  	"es.array.map"
		  ],
		  	"core-js/full/array/of": [
		  	"es.array.of"
		  ],
		  	"core-js/full/array/push": [
		  	"es.array.push"
		  ],
		  	"core-js/full/array/reduce": [
		  	"es.array.reduce"
		  ],
		  	"core-js/full/array/reduce-right": [
		  	"es.array.reduce-right"
		  ],
		  	"core-js/full/array/reverse": [
		  	"es.array.reverse"
		  ],
		  	"core-js/full/array/slice": [
		  	"es.array.slice"
		  ],
		  	"core-js/full/array/some": [
		  	"es.array.some"
		  ],
		  	"core-js/full/array/sort": [
		  	"es.array.sort"
		  ],
		  	"core-js/full/array/splice": [
		  	"es.array.splice"
		  ],
		  	"core-js/full/array/to-reversed": [
		  	"es.array.to-reversed",
		  	"esnext.array.to-reversed"
		  ],
		  	"core-js/full/array/to-sorted": [
		  	"es.array.sort",
		  	"es.array.to-sorted",
		  	"esnext.array.to-sorted"
		  ],
		  	"core-js/full/array/to-spliced": [
		  	"es.array.to-spliced",
		  	"esnext.array.to-spliced"
		  ],
		  	"core-js/full/array/unique-by": [
		  	"es.map",
		  	"esnext.array.unique-by"
		  ],
		  	"core-js/full/array/unshift": [
		  	"es.array.unshift"
		  ],
		  	"core-js/full/array/values": [
		  	"es.array.iterator",
		  	"es.object.to-string"
		  ],
		  	"core-js/full/array/virtual": [
		  	"es.array.at",
		  	"es.array.concat",
		  	"es.array.copy-within",
		  	"es.array.every",
		  	"es.array.fill",
		  	"es.array.filter",
		  	"es.array.find",
		  	"es.array.find-index",
		  	"es.array.find-last",
		  	"es.array.find-last-index",
		  	"es.array.flat",
		  	"es.array.flat-map",
		  	"es.array.for-each",
		  	"es.array.includes",
		  	"es.array.index-of",
		  	"es.array.iterator",
		  	"es.array.join",
		  	"es.array.last-index-of",
		  	"es.array.map",
		  	"es.array.push",
		  	"es.array.reduce",
		  	"es.array.reduce-right",
		  	"es.array.reverse",
		  	"es.array.slice",
		  	"es.array.some",
		  	"es.array.sort",
		  	"es.array.species",
		  	"es.array.splice",
		  	"es.array.to-reversed",
		  	"es.array.to-sorted",
		  	"es.array.to-spliced",
		  	"es.array.unscopables.flat",
		  	"es.array.unscopables.flat-map",
		  	"es.array.unshift",
		  	"es.array.with",
		  	"es.map",
		  	"es.object.to-string",
		  	"esnext.array.at",
		  	"esnext.array.filter-out",
		  	"esnext.array.filter-reject",
		  	"esnext.array.find-last",
		  	"esnext.array.find-last-index",
		  	"esnext.array.group",
		  	"esnext.array.group-by",
		  	"esnext.array.group-by-to-map",
		  	"esnext.array.group-to-map",
		  	"esnext.array.to-reversed",
		  	"esnext.array.to-sorted",
		  	"esnext.array.to-spliced",
		  	"esnext.array.unique-by",
		  	"esnext.array.with"
		  ],
		  	"core-js/full/array/virtual/at": [
		  	"es.array.at",
		  	"esnext.array.at"
		  ],
		  	"core-js/full/array/virtual/concat": [
		  	"es.array.concat"
		  ],
		  	"core-js/full/array/virtual/copy-within": [
		  	"es.array.copy-within"
		  ],
		  	"core-js/full/array/virtual/entries": [
		  	"es.array.iterator",
		  	"es.object.to-string"
		  ],
		  	"core-js/full/array/virtual/every": [
		  	"es.array.every"
		  ],
		  	"core-js/full/array/virtual/fill": [
		  	"es.array.fill"
		  ],
		  	"core-js/full/array/virtual/filter": [
		  	"es.array.filter"
		  ],
		  	"core-js/full/array/virtual/filter-out": [
		  	"esnext.array.filter-out"
		  ],
		  	"core-js/full/array/virtual/filter-reject": [
		  	"esnext.array.filter-reject"
		  ],
		  	"core-js/full/array/virtual/find": [
		  	"es.array.find"
		  ],
		  	"core-js/full/array/virtual/find-index": [
		  	"es.array.find-index"
		  ],
		  	"core-js/full/array/virtual/find-last": [
		  	"es.array.find-last",
		  	"esnext.array.find-last"
		  ],
		  	"core-js/full/array/virtual/find-last-index": [
		  	"es.array.find-last-index",
		  	"esnext.array.find-last-index"
		  ],
		  	"core-js/full/array/virtual/flat": [
		  	"es.array.flat",
		  	"es.array.unscopables.flat"
		  ],
		  	"core-js/full/array/virtual/flat-map": [
		  	"es.array.flat-map",
		  	"es.array.unscopables.flat-map"
		  ],
		  	"core-js/full/array/virtual/for-each": [
		  	"es.array.for-each"
		  ],
		  	"core-js/full/array/virtual/group": [
		  	"esnext.array.group"
		  ],
		  	"core-js/full/array/virtual/group-by": [
		  	"esnext.array.group-by"
		  ],
		  	"core-js/full/array/virtual/group-by-to-map": [
		  	"es.map",
		  	"es.object.to-string",
		  	"esnext.array.group-by-to-map"
		  ],
		  	"core-js/full/array/virtual/group-to-map": [
		  	"es.map",
		  	"es.object.to-string",
		  	"esnext.array.group-to-map"
		  ],
		  	"core-js/full/array/virtual/includes": [
		  	"es.array.includes"
		  ],
		  	"core-js/full/array/virtual/index-of": [
		  	"es.array.index-of"
		  ],
		  	"core-js/full/array/virtual/iterator": [
		  	"es.array.iterator",
		  	"es.object.to-string"
		  ],
		  	"core-js/full/array/virtual/join": [
		  	"es.array.join"
		  ],
		  	"core-js/full/array/virtual/keys": [
		  	"es.array.iterator",
		  	"es.object.to-string"
		  ],
		  	"core-js/full/array/virtual/last-index-of": [
		  	"es.array.last-index-of"
		  ],
		  	"core-js/full/array/virtual/map": [
		  	"es.array.map"
		  ],
		  	"core-js/full/array/virtual/push": [
		  	"es.array.push"
		  ],
		  	"core-js/full/array/virtual/reduce": [
		  	"es.array.reduce"
		  ],
		  	"core-js/full/array/virtual/reduce-right": [
		  	"es.array.reduce-right"
		  ],
		  	"core-js/full/array/virtual/reverse": [
		  	"es.array.reverse"
		  ],
		  	"core-js/full/array/virtual/slice": [
		  	"es.array.slice"
		  ],
		  	"core-js/full/array/virtual/some": [
		  	"es.array.some"
		  ],
		  	"core-js/full/array/virtual/sort": [
		  	"es.array.sort"
		  ],
		  	"core-js/full/array/virtual/splice": [
		  	"es.array.splice"
		  ],
		  	"core-js/full/array/virtual/to-reversed": [
		  	"es.array.to-reversed",
		  	"esnext.array.to-reversed"
		  ],
		  	"core-js/full/array/virtual/to-sorted": [
		  	"es.array.sort",
		  	"es.array.to-sorted",
		  	"esnext.array.to-sorted"
		  ],
		  	"core-js/full/array/virtual/to-spliced": [
		  	"es.array.to-spliced",
		  	"esnext.array.to-spliced"
		  ],
		  	"core-js/full/array/virtual/unique-by": [
		  	"es.map",
		  	"esnext.array.unique-by"
		  ],
		  	"core-js/full/array/virtual/unshift": [
		  	"es.array.unshift"
		  ],
		  	"core-js/full/array/virtual/values": [
		  	"es.array.iterator",
		  	"es.object.to-string"
		  ],
		  	"core-js/full/array/virtual/with": [
		  	"es.array.with",
		  	"esnext.array.with"
		  ],
		  	"core-js/full/array/with": [
		  	"es.array.with",
		  	"esnext.array.with"
		  ],
		  	"core-js/full/async-disposable-stack": [
		  	"es.error.cause",
		  	"es.error.to-string",
		  	"es.object.to-string",
		  	"es.promise",
		  	"esnext.suppressed-error.constructor",
		  	"esnext.async-disposable-stack.constructor",
		  	"esnext.async-iterator.async-dispose",
		  	"esnext.iterator.dispose"
		  ],
		  	"core-js/full/async-disposable-stack/constructor": [
		  	"es.error.cause",
		  	"es.error.to-string",
		  	"es.object.to-string",
		  	"es.promise",
		  	"esnext.suppressed-error.constructor",
		  	"esnext.async-disposable-stack.constructor",
		  	"esnext.async-iterator.async-dispose",
		  	"esnext.iterator.dispose"
		  ],
		  	"core-js/full/async-iterator": [
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"es.promise",
		  	"es.string.iterator",
		  	"esnext.async-iterator.constructor",
		  	"esnext.async-iterator.as-indexed-pairs",
		  	"esnext.async-iterator.async-dispose",
		  	"esnext.async-iterator.drop",
		  	"esnext.async-iterator.every",
		  	"esnext.async-iterator.filter",
		  	"esnext.async-iterator.find",
		  	"esnext.async-iterator.flat-map",
		  	"esnext.async-iterator.for-each",
		  	"esnext.async-iterator.from",
		  	"esnext.async-iterator.indexed",
		  	"esnext.async-iterator.map",
		  	"esnext.async-iterator.reduce",
		  	"esnext.async-iterator.some",
		  	"esnext.async-iterator.take",
		  	"esnext.async-iterator.to-array",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/full/async-iterator/as-indexed-pairs": [
		  	"es.object.to-string",
		  	"es.promise",
		  	"esnext.async-iterator.constructor",
		  	"esnext.async-iterator.as-indexed-pairs"
		  ],
		  	"core-js/full/async-iterator/async-dispose": [
		  	"es.object.to-string",
		  	"es.promise",
		  	"esnext.async-iterator.async-dispose"
		  ],
		  	"core-js/full/async-iterator/drop": [
		  	"es.object.to-string",
		  	"es.promise",
		  	"esnext.async-iterator.constructor",
		  	"esnext.async-iterator.drop"
		  ],
		  	"core-js/full/async-iterator/every": [
		  	"es.object.to-string",
		  	"es.promise",
		  	"esnext.async-iterator.constructor",
		  	"esnext.async-iterator.every"
		  ],
		  	"core-js/full/async-iterator/filter": [
		  	"es.object.to-string",
		  	"es.promise",
		  	"esnext.async-iterator.constructor",
		  	"esnext.async-iterator.filter"
		  ],
		  	"core-js/full/async-iterator/find": [
		  	"es.object.to-string",
		  	"es.promise",
		  	"esnext.async-iterator.constructor",
		  	"esnext.async-iterator.find"
		  ],
		  	"core-js/full/async-iterator/flat-map": [
		  	"es.object.to-string",
		  	"es.promise",
		  	"esnext.async-iterator.constructor",
		  	"esnext.async-iterator.flat-map"
		  ],
		  	"core-js/full/async-iterator/for-each": [
		  	"es.object.to-string",
		  	"es.promise",
		  	"esnext.async-iterator.constructor",
		  	"esnext.async-iterator.for-each"
		  ],
		  	"core-js/full/async-iterator/from": [
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"es.promise",
		  	"es.string.iterator",
		  	"esnext.async-iterator.constructor",
		  	"esnext.async-iterator.drop",
		  	"esnext.async-iterator.every",
		  	"esnext.async-iterator.filter",
		  	"esnext.async-iterator.find",
		  	"esnext.async-iterator.flat-map",
		  	"esnext.async-iterator.for-each",
		  	"esnext.async-iterator.from",
		  	"esnext.async-iterator.map",
		  	"esnext.async-iterator.reduce",
		  	"esnext.async-iterator.some",
		  	"esnext.async-iterator.take",
		  	"esnext.async-iterator.to-array",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/full/async-iterator/indexed": [
		  	"es.object.to-string",
		  	"es.promise",
		  	"esnext.async-iterator.constructor",
		  	"esnext.async-iterator.indexed"
		  ],
		  	"core-js/full/async-iterator/map": [
		  	"es.object.to-string",
		  	"es.promise",
		  	"esnext.async-iterator.constructor",
		  	"esnext.async-iterator.map"
		  ],
		  	"core-js/full/async-iterator/reduce": [
		  	"es.object.to-string",
		  	"es.promise",
		  	"esnext.async-iterator.constructor",
		  	"esnext.async-iterator.reduce"
		  ],
		  	"core-js/full/async-iterator/some": [
		  	"es.object.to-string",
		  	"es.promise",
		  	"esnext.async-iterator.constructor",
		  	"esnext.async-iterator.some"
		  ],
		  	"core-js/full/async-iterator/take": [
		  	"es.object.to-string",
		  	"es.promise",
		  	"esnext.async-iterator.constructor",
		  	"esnext.async-iterator.take"
		  ],
		  	"core-js/full/async-iterator/to-array": [
		  	"es.object.to-string",
		  	"es.promise",
		  	"esnext.async-iterator.constructor",
		  	"esnext.async-iterator.to-array"
		  ],
		  	"core-js/full/atob": [
		  	"es.error.to-string",
		  	"es.object.to-string",
		  	"web.atob",
		  	"web.dom-exception.constructor",
		  	"web.dom-exception.stack",
		  	"web.dom-exception.to-string-tag"
		  ],
		  	"core-js/full/bigint": [
		  	"es.object.to-string",
		  	"esnext.bigint.range"
		  ],
		  	"core-js/full/bigint/range": [
		  	"es.object.to-string",
		  	"esnext.bigint.range"
		  ],
		  	"core-js/full/btoa": [
		  	"es.error.to-string",
		  	"es.object.to-string",
		  	"web.btoa",
		  	"web.dom-exception.constructor",
		  	"web.dom-exception.stack",
		  	"web.dom-exception.to-string-tag"
		  ],
		  	"core-js/full/clear-immediate": [
		  	"web.immediate"
		  ],
		  	"core-js/full/composite-key": [
		  	"esnext.composite-key"
		  ],
		  	"core-js/full/composite-symbol": [
		  	"es.symbol",
		  	"esnext.composite-symbol"
		  ],
		  	"core-js/full/data-view": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.data-view",
		  	"es.object.to-string",
		  	"esnext.data-view.get-float16",
		  	"esnext.data-view.get-uint8-clamped",
		  	"esnext.data-view.set-float16",
		  	"esnext.data-view.set-uint8-clamped"
		  ],
		  	"core-js/full/data-view/get-float16": [
		  	"esnext.data-view.get-float16"
		  ],
		  	"core-js/full/data-view/get-uint8-clamped": [
		  	"esnext.data-view.get-uint8-clamped"
		  ],
		  	"core-js/full/data-view/set-float16": [
		  	"esnext.data-view.set-float16"
		  ],
		  	"core-js/full/data-view/set-uint8-clamped": [
		  	"esnext.data-view.set-uint8-clamped"
		  ],
		  	"core-js/full/date": [
		  	"es.date.get-year",
		  	"es.date.now",
		  	"es.date.set-year",
		  	"es.date.to-gmt-string",
		  	"es.date.to-iso-string",
		  	"es.date.to-json",
		  	"es.date.to-primitive",
		  	"es.date.to-string"
		  ],
		  	"core-js/full/date/get-year": [
		  	"es.date.get-year"
		  ],
		  	"core-js/full/date/now": [
		  	"es.date.now"
		  ],
		  	"core-js/full/date/set-year": [
		  	"es.date.set-year"
		  ],
		  	"core-js/full/date/to-gmt-string": [
		  	"es.date.to-gmt-string"
		  ],
		  	"core-js/full/date/to-iso-string": [
		  	"es.date.to-iso-string",
		  	"es.date.to-json"
		  ],
		  	"core-js/full/date/to-json": [
		  	"es.date.to-json"
		  ],
		  	"core-js/full/date/to-primitive": [
		  	"es.date.to-primitive"
		  ],
		  	"core-js/full/date/to-string": [
		  	"es.date.to-string"
		  ],
		  	"core-js/full/disposable-stack": [
		  	"es.error.cause",
		  	"es.error.to-string",
		  	"es.object.to-string",
		  	"esnext.suppressed-error.constructor",
		  	"esnext.disposable-stack.constructor",
		  	"esnext.iterator.dispose"
		  ],
		  	"core-js/full/disposable-stack/constructor": [
		  	"es.error.cause",
		  	"es.error.to-string",
		  	"es.object.to-string",
		  	"esnext.suppressed-error.constructor",
		  	"esnext.disposable-stack.constructor",
		  	"esnext.iterator.dispose"
		  ],
		  	"core-js/full/dom-collections": [
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"web.dom-collections.for-each",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/full/dom-collections/for-each": [
		  	"web.dom-collections.for-each"
		  ],
		  	"core-js/full/dom-collections/iterator": [
		  	"es.object.to-string",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/full/dom-exception": [
		  	"es.error.to-string",
		  	"web.dom-exception.constructor",
		  	"web.dom-exception.stack",
		  	"web.dom-exception.to-string-tag"
		  ],
		  	"core-js/full/dom-exception/constructor": [
		  	"es.error.to-string",
		  	"web.dom-exception.constructor",
		  	"web.dom-exception.stack"
		  ],
		  	"core-js/full/dom-exception/to-string-tag": [
		  	"web.dom-exception.to-string-tag"
		  ],
		  	"core-js/full/error": [
		  	"es.error.cause",
		  	"es.error.to-string"
		  ],
		  	"core-js/full/error/constructor": [
		  	"es.error.cause"
		  ],
		  	"core-js/full/error/to-string": [
		  	"es.error.to-string"
		  ],
		  	"core-js/full/escape": [
		  	"es.escape"
		  ],
		  	"core-js/full/function": [
		  	"es.function.bind",
		  	"es.function.has-instance",
		  	"es.function.name",
		  	"esnext.function.demethodize",
		  	"esnext.function.is-callable",
		  	"esnext.function.is-constructor",
		  	"esnext.function.metadata",
		  	"esnext.function.un-this"
		  ],
		  	"core-js/full/function/bind": [
		  	"es.function.bind"
		  ],
		  	"core-js/full/function/demethodize": [
		  	"esnext.function.demethodize"
		  ],
		  	"core-js/full/function/has-instance": [
		  	"es.function.has-instance"
		  ],
		  	"core-js/full/function/is-callable": [
		  	"esnext.function.is-callable"
		  ],
		  	"core-js/full/function/is-constructor": [
		  	"esnext.function.is-constructor"
		  ],
		  	"core-js/full/function/metadata": [
		  	"esnext.function.metadata"
		  ],
		  	"core-js/full/function/name": [
		  	"es.function.name"
		  ],
		  	"core-js/full/function/un-this": [
		  	"esnext.function.un-this"
		  ],
		  	"core-js/full/function/virtual": [
		  	"es.function.bind",
		  	"esnext.function.demethodize",
		  	"esnext.function.un-this"
		  ],
		  	"core-js/full/function/virtual/bind": [
		  	"es.function.bind"
		  ],
		  	"core-js/full/function/virtual/demethodize": [
		  	"esnext.function.demethodize"
		  ],
		  	"core-js/full/function/virtual/un-this": [
		  	"esnext.function.un-this"
		  ],
		  	"core-js/full/get-iterator": [
		  	"es.array.iterator",
		  	"es.string.iterator",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/full/get-iterator-method": [
		  	"es.array.iterator",
		  	"es.string.iterator",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/full/global-this": [
		  	"es.global-this",
		  	"esnext.global-this"
		  ],
		  	"core-js/full/instance/at": [
		  	"es.array.at",
		  	"es.string.at-alternative",
		  	"esnext.array.at",
		  	"esnext.string.at"
		  ],
		  	"core-js/full/instance/bind": [
		  	"es.function.bind"
		  ],
		  	"core-js/full/instance/code-point-at": [
		  	"es.string.code-point-at"
		  ],
		  	"core-js/full/instance/code-points": [
		  	"es.object.to-string",
		  	"esnext.string.code-points"
		  ],
		  	"core-js/full/instance/concat": [
		  	"es.array.concat"
		  ],
		  	"core-js/full/instance/copy-within": [
		  	"es.array.copy-within"
		  ],
		  	"core-js/full/instance/demethodize": [
		  	"esnext.function.demethodize"
		  ],
		  	"core-js/full/instance/ends-with": [
		  	"es.string.ends-with"
		  ],
		  	"core-js/full/instance/entries": [
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/full/instance/every": [
		  	"es.array.every"
		  ],
		  	"core-js/full/instance/fill": [
		  	"es.array.fill"
		  ],
		  	"core-js/full/instance/filter": [
		  	"es.array.filter"
		  ],
		  	"core-js/full/instance/filter-out": [
		  	"esnext.array.filter-out"
		  ],
		  	"core-js/full/instance/filter-reject": [
		  	"esnext.array.filter-reject"
		  ],
		  	"core-js/full/instance/find": [
		  	"es.array.find"
		  ],
		  	"core-js/full/instance/find-index": [
		  	"es.array.find-index"
		  ],
		  	"core-js/full/instance/find-last": [
		  	"es.array.find-last",
		  	"esnext.array.find-last"
		  ],
		  	"core-js/full/instance/find-last-index": [
		  	"es.array.find-last-index",
		  	"esnext.array.find-last-index"
		  ],
		  	"core-js/full/instance/flags": [
		  	"es.regexp.flags"
		  ],
		  	"core-js/full/instance/flat": [
		  	"es.array.flat",
		  	"es.array.unscopables.flat"
		  ],
		  	"core-js/full/instance/flat-map": [
		  	"es.array.flat-map",
		  	"es.array.unscopables.flat-map"
		  ],
		  	"core-js/full/instance/for-each": [
		  	"es.array.for-each",
		  	"web.dom-collections.for-each"
		  ],
		  	"core-js/full/instance/group": [
		  	"esnext.array.group"
		  ],
		  	"core-js/full/instance/group-by": [
		  	"esnext.array.group-by"
		  ],
		  	"core-js/full/instance/group-by-to-map": [
		  	"es.map",
		  	"es.object.to-string",
		  	"esnext.array.group-by-to-map"
		  ],
		  	"core-js/full/instance/group-to-map": [
		  	"es.map",
		  	"es.object.to-string",
		  	"esnext.array.group-to-map"
		  ],
		  	"core-js/full/instance/includes": [
		  	"es.array.includes",
		  	"es.string.includes"
		  ],
		  	"core-js/full/instance/index-of": [
		  	"es.array.index-of"
		  ],
		  	"core-js/full/instance/is-well-formed": [
		  	"es.string.is-well-formed"
		  ],
		  	"core-js/full/instance/keys": [
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/full/instance/last-index-of": [
		  	"es.array.last-index-of"
		  ],
		  	"core-js/full/instance/map": [
		  	"es.array.map"
		  ],
		  	"core-js/full/instance/match-all": [
		  	"es.object.to-string",
		  	"es.regexp.exec",
		  	"es.string.match-all",
		  	"esnext.string.match-all"
		  ],
		  	"core-js/full/instance/pad-end": [
		  	"es.string.pad-end"
		  ],
		  	"core-js/full/instance/pad-start": [
		  	"es.string.pad-start"
		  ],
		  	"core-js/full/instance/push": [
		  	"es.array.push"
		  ],
		  	"core-js/full/instance/reduce": [
		  	"es.array.reduce"
		  ],
		  	"core-js/full/instance/reduce-right": [
		  	"es.array.reduce-right"
		  ],
		  	"core-js/full/instance/repeat": [
		  	"es.string.repeat"
		  ],
		  	"core-js/full/instance/replace-all": [
		  	"es.regexp.exec",
		  	"es.string.replace",
		  	"es.string.replace-all",
		  	"esnext.string.replace-all"
		  ],
		  	"core-js/full/instance/reverse": [
		  	"es.array.reverse"
		  ],
		  	"core-js/full/instance/slice": [
		  	"es.array.slice"
		  ],
		  	"core-js/full/instance/some": [
		  	"es.array.some"
		  ],
		  	"core-js/full/instance/sort": [
		  	"es.array.sort"
		  ],
		  	"core-js/full/instance/splice": [
		  	"es.array.splice"
		  ],
		  	"core-js/full/instance/starts-with": [
		  	"es.string.starts-with"
		  ],
		  	"core-js/full/instance/to-reversed": [
		  	"es.array.to-reversed",
		  	"esnext.array.to-reversed"
		  ],
		  	"core-js/full/instance/to-sorted": [
		  	"es.array.sort",
		  	"es.array.to-sorted",
		  	"esnext.array.to-sorted"
		  ],
		  	"core-js/full/instance/to-spliced": [
		  	"es.array.to-spliced",
		  	"esnext.array.to-spliced"
		  ],
		  	"core-js/full/instance/to-well-formed": [
		  	"es.string.to-well-formed"
		  ],
		  	"core-js/full/instance/trim": [
		  	"es.string.trim"
		  ],
		  	"core-js/full/instance/trim-end": [
		  	"es.string.trim-end"
		  ],
		  	"core-js/full/instance/trim-left": [
		  	"es.string.trim-start"
		  ],
		  	"core-js/full/instance/trim-right": [
		  	"es.string.trim-end"
		  ],
		  	"core-js/full/instance/trim-start": [
		  	"es.string.trim-start"
		  ],
		  	"core-js/full/instance/un-this": [
		  	"esnext.function.un-this"
		  ],
		  	"core-js/full/instance/unique-by": [
		  	"es.map",
		  	"esnext.array.unique-by"
		  ],
		  	"core-js/full/instance/unshift": [
		  	"es.array.unshift"
		  ],
		  	"core-js/full/instance/values": [
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/full/instance/with": [
		  	"es.array.with",
		  	"esnext.array.with"
		  ],
		  	"core-js/full/is-iterable": [
		  	"es.array.iterator",
		  	"es.string.iterator",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/full/iterator": [
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"es.promise",
		  	"es.string.iterator",
		  	"esnext.iterator.constructor",
		  	"esnext.iterator.as-indexed-pairs",
		  	"esnext.iterator.dispose",
		  	"esnext.iterator.drop",
		  	"esnext.iterator.every",
		  	"esnext.iterator.filter",
		  	"esnext.iterator.find",
		  	"esnext.iterator.flat-map",
		  	"esnext.iterator.for-each",
		  	"esnext.iterator.from",
		  	"esnext.iterator.indexed",
		  	"esnext.iterator.map",
		  	"esnext.iterator.range",
		  	"esnext.iterator.reduce",
		  	"esnext.iterator.some",
		  	"esnext.iterator.take",
		  	"esnext.iterator.to-array",
		  	"esnext.iterator.to-async",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/full/iterator/as-indexed-pairs": [
		  	"es.object.to-string",
		  	"esnext.iterator.constructor",
		  	"esnext.iterator.as-indexed-pairs"
		  ],
		  	"core-js/full/iterator/dispose": [
		  	"esnext.iterator.dispose"
		  ],
		  	"core-js/full/iterator/drop": [
		  	"es.object.to-string",
		  	"esnext.iterator.constructor",
		  	"esnext.iterator.drop"
		  ],
		  	"core-js/full/iterator/every": [
		  	"es.object.to-string",
		  	"esnext.iterator.constructor",
		  	"esnext.iterator.every"
		  ],
		  	"core-js/full/iterator/filter": [
		  	"es.object.to-string",
		  	"esnext.iterator.constructor",
		  	"esnext.iterator.filter"
		  ],
		  	"core-js/full/iterator/find": [
		  	"es.object.to-string",
		  	"esnext.iterator.constructor",
		  	"esnext.iterator.find"
		  ],
		  	"core-js/full/iterator/flat-map": [
		  	"es.object.to-string",
		  	"esnext.iterator.constructor",
		  	"esnext.iterator.flat-map"
		  ],
		  	"core-js/full/iterator/for-each": [
		  	"es.object.to-string",
		  	"esnext.iterator.constructor",
		  	"esnext.iterator.for-each"
		  ],
		  	"core-js/full/iterator/from": [
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"es.promise",
		  	"es.string.iterator",
		  	"esnext.iterator.constructor",
		  	"esnext.iterator.dispose",
		  	"esnext.iterator.drop",
		  	"esnext.iterator.every",
		  	"esnext.iterator.filter",
		  	"esnext.iterator.find",
		  	"esnext.iterator.flat-map",
		  	"esnext.iterator.for-each",
		  	"esnext.iterator.from",
		  	"esnext.iterator.map",
		  	"esnext.iterator.reduce",
		  	"esnext.iterator.some",
		  	"esnext.iterator.take",
		  	"esnext.iterator.to-array",
		  	"esnext.iterator.to-async",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/full/iterator/indexed": [
		  	"es.object.to-string",
		  	"esnext.iterator.constructor",
		  	"esnext.iterator.indexed"
		  ],
		  	"core-js/full/iterator/map": [
		  	"es.object.to-string",
		  	"esnext.iterator.constructor",
		  	"esnext.iterator.map"
		  ],
		  	"core-js/full/iterator/range": [
		  	"es.object.to-string",
		  	"esnext.iterator.constructor",
		  	"esnext.iterator.range"
		  ],
		  	"core-js/full/iterator/reduce": [
		  	"es.object.to-string",
		  	"esnext.iterator.constructor",
		  	"esnext.iterator.reduce"
		  ],
		  	"core-js/full/iterator/some": [
		  	"es.object.to-string",
		  	"esnext.iterator.constructor",
		  	"esnext.iterator.some"
		  ],
		  	"core-js/full/iterator/take": [
		  	"es.object.to-string",
		  	"esnext.iterator.constructor",
		  	"esnext.iterator.take"
		  ],
		  	"core-js/full/iterator/to-array": [
		  	"es.object.to-string",
		  	"esnext.iterator.constructor",
		  	"esnext.iterator.to-array"
		  ],
		  	"core-js/full/iterator/to-async": [
		  	"es.object.to-string",
		  	"es.promise",
		  	"esnext.iterator.constructor",
		  	"esnext.iterator.to-async"
		  ],
		  	"core-js/full/json": [
		  	"es.date.to-json",
		  	"es.json.stringify",
		  	"es.json.to-string-tag",
		  	"es.object.create",
		  	"es.object.freeze",
		  	"es.object.keys",
		  	"esnext.json.is-raw-json",
		  	"esnext.json.parse",
		  	"esnext.json.raw-json"
		  ],
		  	"core-js/full/json/is-raw-json": [
		  	"esnext.json.is-raw-json"
		  ],
		  	"core-js/full/json/parse": [
		  	"es.object.keys",
		  	"esnext.json.parse"
		  ],
		  	"core-js/full/json/raw-json": [
		  	"es.object.create",
		  	"es.object.freeze",
		  	"esnext.json.raw-json"
		  ],
		  	"core-js/full/json/stringify": [
		  	"es.date.to-json",
		  	"es.json.stringify"
		  ],
		  	"core-js/full/json/to-string-tag": [
		  	"es.json.to-string-tag"
		  ],
		  	"core-js/full/map": [
		  	"es.array.iterator",
		  	"es.map",
		  	"es.map.group-by",
		  	"es.object.to-string",
		  	"es.string.iterator",
		  	"esnext.map.delete-all",
		  	"esnext.map.emplace",
		  	"esnext.map.every",
		  	"esnext.map.filter",
		  	"esnext.map.find",
		  	"esnext.map.find-key",
		  	"esnext.map.from",
		  	"esnext.map.group-by",
		  	"esnext.map.includes",
		  	"esnext.map.key-by",
		  	"esnext.map.key-of",
		  	"esnext.map.map-keys",
		  	"esnext.map.map-values",
		  	"esnext.map.merge",
		  	"esnext.map.of",
		  	"esnext.map.reduce",
		  	"esnext.map.some",
		  	"esnext.map.update",
		  	"esnext.map.update-or-insert",
		  	"esnext.map.upsert",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/full/map/delete-all": [
		  	"es.map",
		  	"esnext.map.delete-all"
		  ],
		  	"core-js/full/map/emplace": [
		  	"es.map",
		  	"esnext.map.emplace"
		  ],
		  	"core-js/full/map/every": [
		  	"es.map",
		  	"esnext.map.every"
		  ],
		  	"core-js/full/map/filter": [
		  	"es.map",
		  	"esnext.map.filter"
		  ],
		  	"core-js/full/map/find": [
		  	"es.map",
		  	"esnext.map.find"
		  ],
		  	"core-js/full/map/find-key": [
		  	"es.map",
		  	"esnext.map.find-key"
		  ],
		  	"core-js/full/map/from": [
		  	"es.array.iterator",
		  	"es.map",
		  	"es.object.to-string",
		  	"es.string.iterator",
		  	"esnext.map.delete-all",
		  	"esnext.map.emplace",
		  	"esnext.map.every",
		  	"esnext.map.filter",
		  	"esnext.map.find",
		  	"esnext.map.find-key",
		  	"esnext.map.from",
		  	"esnext.map.includes",
		  	"esnext.map.key-of",
		  	"esnext.map.map-keys",
		  	"esnext.map.map-values",
		  	"esnext.map.merge",
		  	"esnext.map.reduce",
		  	"esnext.map.some",
		  	"esnext.map.update",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/full/map/group-by": [
		  	"es.map",
		  	"es.map.group-by",
		  	"es.object.to-string",
		  	"esnext.map.delete-all",
		  	"esnext.map.emplace",
		  	"esnext.map.every",
		  	"esnext.map.filter",
		  	"esnext.map.find",
		  	"esnext.map.find-key",
		  	"esnext.map.group-by",
		  	"esnext.map.includes",
		  	"esnext.map.key-of",
		  	"esnext.map.map-keys",
		  	"esnext.map.map-values",
		  	"esnext.map.merge",
		  	"esnext.map.reduce",
		  	"esnext.map.some",
		  	"esnext.map.update"
		  ],
		  	"core-js/full/map/includes": [
		  	"es.map",
		  	"esnext.map.includes"
		  ],
		  	"core-js/full/map/key-by": [
		  	"es.map",
		  	"es.object.to-string",
		  	"esnext.map.delete-all",
		  	"esnext.map.emplace",
		  	"esnext.map.every",
		  	"esnext.map.filter",
		  	"esnext.map.find",
		  	"esnext.map.find-key",
		  	"esnext.map.includes",
		  	"esnext.map.key-by",
		  	"esnext.map.key-of",
		  	"esnext.map.map-keys",
		  	"esnext.map.map-values",
		  	"esnext.map.merge",
		  	"esnext.map.reduce",
		  	"esnext.map.some",
		  	"esnext.map.update"
		  ],
		  	"core-js/full/map/key-of": [
		  	"es.map",
		  	"esnext.map.key-of"
		  ],
		  	"core-js/full/map/map-keys": [
		  	"es.map",
		  	"esnext.map.map-keys"
		  ],
		  	"core-js/full/map/map-values": [
		  	"es.map",
		  	"esnext.map.map-values"
		  ],
		  	"core-js/full/map/merge": [
		  	"es.map",
		  	"esnext.map.merge"
		  ],
		  	"core-js/full/map/of": [
		  	"es.array.iterator",
		  	"es.map",
		  	"es.object.to-string",
		  	"esnext.map.delete-all",
		  	"esnext.map.emplace",
		  	"esnext.map.every",
		  	"esnext.map.filter",
		  	"esnext.map.find",
		  	"esnext.map.find-key",
		  	"esnext.map.includes",
		  	"esnext.map.key-of",
		  	"esnext.map.map-keys",
		  	"esnext.map.map-values",
		  	"esnext.map.merge",
		  	"esnext.map.of",
		  	"esnext.map.reduce",
		  	"esnext.map.some",
		  	"esnext.map.update"
		  ],
		  	"core-js/full/map/reduce": [
		  	"es.map",
		  	"esnext.map.reduce"
		  ],
		  	"core-js/full/map/some": [
		  	"es.map",
		  	"esnext.map.some"
		  ],
		  	"core-js/full/map/update": [
		  	"es.map",
		  	"esnext.map.update"
		  ],
		  	"core-js/full/map/update-or-insert": [
		  	"es.map",
		  	"esnext.map.update-or-insert"
		  ],
		  	"core-js/full/map/upsert": [
		  	"es.map",
		  	"esnext.map.upsert"
		  ],
		  	"core-js/full/math": [
		  	"es.math.acosh",
		  	"es.math.asinh",
		  	"es.math.atanh",
		  	"es.math.cbrt",
		  	"es.math.clz32",
		  	"es.math.cosh",
		  	"es.math.expm1",
		  	"es.math.fround",
		  	"es.math.hypot",
		  	"es.math.imul",
		  	"es.math.log10",
		  	"es.math.log1p",
		  	"es.math.log2",
		  	"es.math.sign",
		  	"es.math.sinh",
		  	"es.math.tanh",
		  	"es.math.to-string-tag",
		  	"es.math.trunc",
		  	"esnext.math.clamp",
		  	"esnext.math.deg-per-rad",
		  	"esnext.math.degrees",
		  	"esnext.math.fscale",
		  	"esnext.math.f16round",
		  	"esnext.math.iaddh",
		  	"esnext.math.imulh",
		  	"esnext.math.isubh",
		  	"esnext.math.rad-per-deg",
		  	"esnext.math.radians",
		  	"esnext.math.scale",
		  	"esnext.math.seeded-prng",
		  	"esnext.math.signbit",
		  	"esnext.math.umulh"
		  ],
		  	"core-js/full/math/acosh": [
		  	"es.math.acosh"
		  ],
		  	"core-js/full/math/asinh": [
		  	"es.math.asinh"
		  ],
		  	"core-js/full/math/atanh": [
		  	"es.math.atanh"
		  ],
		  	"core-js/full/math/cbrt": [
		  	"es.math.cbrt"
		  ],
		  	"core-js/full/math/clamp": [
		  	"esnext.math.clamp"
		  ],
		  	"core-js/full/math/clz32": [
		  	"es.math.clz32"
		  ],
		  	"core-js/full/math/cosh": [
		  	"es.math.cosh"
		  ],
		  	"core-js/full/math/deg-per-rad": [
		  	"esnext.math.deg-per-rad"
		  ],
		  	"core-js/full/math/degrees": [
		  	"esnext.math.degrees"
		  ],
		  	"core-js/full/math/expm1": [
		  	"es.math.expm1"
		  ],
		  	"core-js/full/math/f16round": [
		  	"esnext.math.f16round"
		  ],
		  	"core-js/full/math/fround": [
		  	"es.math.fround"
		  ],
		  	"core-js/full/math/fscale": [
		  	"esnext.math.fscale"
		  ],
		  	"core-js/full/math/hypot": [
		  	"es.math.hypot"
		  ],
		  	"core-js/full/math/iaddh": [
		  	"esnext.math.iaddh"
		  ],
		  	"core-js/full/math/imul": [
		  	"es.math.imul"
		  ],
		  	"core-js/full/math/imulh": [
		  	"esnext.math.imulh"
		  ],
		  	"core-js/full/math/isubh": [
		  	"esnext.math.isubh"
		  ],
		  	"core-js/full/math/log10": [
		  	"es.math.log10"
		  ],
		  	"core-js/full/math/log1p": [
		  	"es.math.log1p"
		  ],
		  	"core-js/full/math/log2": [
		  	"es.math.log2"
		  ],
		  	"core-js/full/math/rad-per-deg": [
		  	"esnext.math.rad-per-deg"
		  ],
		  	"core-js/full/math/radians": [
		  	"esnext.math.radians"
		  ],
		  	"core-js/full/math/scale": [
		  	"esnext.math.scale"
		  ],
		  	"core-js/full/math/seeded-prng": [
		  	"esnext.math.seeded-prng"
		  ],
		  	"core-js/full/math/sign": [
		  	"es.math.sign"
		  ],
		  	"core-js/full/math/signbit": [
		  	"esnext.math.signbit"
		  ],
		  	"core-js/full/math/sinh": [
		  	"es.math.sinh"
		  ],
		  	"core-js/full/math/tanh": [
		  	"es.math.tanh"
		  ],
		  	"core-js/full/math/to-string-tag": [
		  	"es.math.to-string-tag"
		  ],
		  	"core-js/full/math/trunc": [
		  	"es.math.trunc"
		  ],
		  	"core-js/full/math/umulh": [
		  	"esnext.math.umulh"
		  ],
		  	"core-js/full/number": [
		  	"es.number.constructor",
		  	"es.number.epsilon",
		  	"es.number.is-finite",
		  	"es.number.is-integer",
		  	"es.number.is-nan",
		  	"es.number.is-safe-integer",
		  	"es.number.max-safe-integer",
		  	"es.number.min-safe-integer",
		  	"es.number.parse-float",
		  	"es.number.parse-int",
		  	"es.number.to-exponential",
		  	"es.number.to-fixed",
		  	"es.number.to-precision",
		  	"es.object.to-string",
		  	"esnext.number.from-string",
		  	"esnext.number.range"
		  ],
		  	"core-js/full/number/constructor": [
		  	"es.number.constructor"
		  ],
		  	"core-js/full/number/epsilon": [
		  	"es.number.epsilon"
		  ],
		  	"core-js/full/number/from-string": [
		  	"esnext.number.from-string"
		  ],
		  	"core-js/full/number/is-finite": [
		  	"es.number.is-finite"
		  ],
		  	"core-js/full/number/is-integer": [
		  	"es.number.is-integer"
		  ],
		  	"core-js/full/number/is-nan": [
		  	"es.number.is-nan"
		  ],
		  	"core-js/full/number/is-safe-integer": [
		  	"es.number.is-safe-integer"
		  ],
		  	"core-js/full/number/max-safe-integer": [
		  	"es.number.max-safe-integer"
		  ],
		  	"core-js/full/number/min-safe-integer": [
		  	"es.number.min-safe-integer"
		  ],
		  	"core-js/full/number/parse-float": [
		  	"es.number.parse-float"
		  ],
		  	"core-js/full/number/parse-int": [
		  	"es.number.parse-int"
		  ],
		  	"core-js/full/number/range": [
		  	"es.object.to-string",
		  	"esnext.number.range"
		  ],
		  	"core-js/full/number/to-exponential": [
		  	"es.number.to-exponential"
		  ],
		  	"core-js/full/number/to-fixed": [
		  	"es.number.to-fixed"
		  ],
		  	"core-js/full/number/to-precision": [
		  	"es.number.to-precision"
		  ],
		  	"core-js/full/number/virtual": [
		  	"es.number.to-exponential",
		  	"es.number.to-fixed",
		  	"es.number.to-precision"
		  ],
		  	"core-js/full/number/virtual/to-exponential": [
		  	"es.number.to-exponential"
		  ],
		  	"core-js/full/number/virtual/to-fixed": [
		  	"es.number.to-fixed"
		  ],
		  	"core-js/full/number/virtual/to-precision": [
		  	"es.number.to-precision"
		  ],
		  	"core-js/full/object": [
		  	"es.symbol",
		  	"es.json.to-string-tag",
		  	"es.math.to-string-tag",
		  	"es.object.assign",
		  	"es.object.create",
		  	"es.object.define-getter",
		  	"es.object.define-properties",
		  	"es.object.define-property",
		  	"es.object.define-setter",
		  	"es.object.entries",
		  	"es.object.freeze",
		  	"es.object.from-entries",
		  	"es.object.get-own-property-descriptor",
		  	"es.object.get-own-property-descriptors",
		  	"es.object.get-own-property-names",
		  	"es.object.get-prototype-of",
		  	"es.object.group-by",
		  	"es.object.has-own",
		  	"es.object.is",
		  	"es.object.is-extensible",
		  	"es.object.is-frozen",
		  	"es.object.is-sealed",
		  	"es.object.keys",
		  	"es.object.lookup-getter",
		  	"es.object.lookup-setter",
		  	"es.object.prevent-extensions",
		  	"es.object.proto",
		  	"es.object.seal",
		  	"es.object.set-prototype-of",
		  	"es.object.to-string",
		  	"es.object.values",
		  	"es.reflect.to-string-tag",
		  	"esnext.object.has-own",
		  	"esnext.object.iterate-entries",
		  	"esnext.object.iterate-keys",
		  	"esnext.object.iterate-values",
		  	"esnext.object.group-by",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/full/object/assign": [
		  	"es.object.assign"
		  ],
		  	"core-js/full/object/create": [
		  	"es.object.create"
		  ],
		  	"core-js/full/object/define-getter": [
		  	"es.object.define-getter"
		  ],
		  	"core-js/full/object/define-properties": [
		  	"es.object.define-properties"
		  ],
		  	"core-js/full/object/define-property": [
		  	"es.object.define-property"
		  ],
		  	"core-js/full/object/define-setter": [
		  	"es.object.define-setter"
		  ],
		  	"core-js/full/object/entries": [
		  	"es.object.entries"
		  ],
		  	"core-js/full/object/freeze": [
		  	"es.object.freeze"
		  ],
		  	"core-js/full/object/from-entries": [
		  	"es.array.iterator",
		  	"es.object.from-entries",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/full/object/get-own-property-descriptor": [
		  	"es.object.get-own-property-descriptor"
		  ],
		  	"core-js/full/object/get-own-property-descriptors": [
		  	"es.object.get-own-property-descriptors"
		  ],
		  	"core-js/full/object/get-own-property-names": [
		  	"es.object.get-own-property-names"
		  ],
		  	"core-js/full/object/get-own-property-symbols": [
		  	"es.symbol"
		  ],
		  	"core-js/full/object/get-prototype-of": [
		  	"es.object.get-prototype-of"
		  ],
		  	"core-js/full/object/group-by": [
		  	"es.object.create",
		  	"es.object.group-by",
		  	"esnext.object.group-by"
		  ],
		  	"core-js/full/object/has-own": [
		  	"es.object.has-own",
		  	"esnext.object.has-own"
		  ],
		  	"core-js/full/object/is": [
		  	"es.object.is"
		  ],
		  	"core-js/full/object/is-extensible": [
		  	"es.object.is-extensible"
		  ],
		  	"core-js/full/object/is-frozen": [
		  	"es.object.is-frozen"
		  ],
		  	"core-js/full/object/is-sealed": [
		  	"es.object.is-sealed"
		  ],
		  	"core-js/full/object/iterate-entries": [
		  	"esnext.object.iterate-entries"
		  ],
		  	"core-js/full/object/iterate-keys": [
		  	"esnext.object.iterate-keys"
		  ],
		  	"core-js/full/object/iterate-values": [
		  	"esnext.object.iterate-values"
		  ],
		  	"core-js/full/object/keys": [
		  	"es.object.keys"
		  ],
		  	"core-js/full/object/lookup-getter": [
		  	"es.object.lookup-getter"
		  ],
		  	"core-js/full/object/lookup-setter": [
		  	"es.object.lookup-setter"
		  ],
		  	"core-js/full/object/prevent-extensions": [
		  	"es.object.prevent-extensions"
		  ],
		  	"core-js/full/object/proto": [
		  	"es.object.proto"
		  ],
		  	"core-js/full/object/seal": [
		  	"es.object.seal"
		  ],
		  	"core-js/full/object/set-prototype-of": [
		  	"es.object.set-prototype-of"
		  ],
		  	"core-js/full/object/to-string": [
		  	"es.json.to-string-tag",
		  	"es.math.to-string-tag",
		  	"es.object.to-string",
		  	"es.reflect.to-string-tag"
		  ],
		  	"core-js/full/object/values": [
		  	"es.object.values"
		  ],
		  	"core-js/full/observable": [
		  	"es.object.to-string",
		  	"es.string.iterator",
		  	"esnext.observable",
		  	"esnext.symbol.observable",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/full/parse-float": [
		  	"es.parse-float"
		  ],
		  	"core-js/full/parse-int": [
		  	"es.parse-int"
		  ],
		  	"core-js/full/promise": [
		  	"es.aggregate-error",
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"es.promise",
		  	"es.promise.all-settled",
		  	"es.promise.any",
		  	"es.promise.finally",
		  	"es.promise.with-resolvers",
		  	"es.string.iterator",
		  	"esnext.aggregate-error",
		  	"esnext.promise.all-settled",
		  	"esnext.promise.any",
		  	"esnext.promise.try",
		  	"esnext.promise.with-resolvers",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/full/promise/all-settled": [
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"es.promise",
		  	"es.promise.all-settled",
		  	"es.string.iterator",
		  	"esnext.promise.all-settled",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/full/promise/any": [
		  	"es.aggregate-error",
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"es.promise",
		  	"es.promise.any",
		  	"es.string.iterator",
		  	"esnext.aggregate-error",
		  	"esnext.promise.any",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/full/promise/finally": [
		  	"es.object.to-string",
		  	"es.promise",
		  	"es.promise.finally"
		  ],
		  	"core-js/full/promise/try": [
		  	"es.promise",
		  	"esnext.promise.try"
		  ],
		  	"core-js/full/promise/with-resolvers": [
		  	"es.promise",
		  	"es.promise.with-resolvers",
		  	"esnext.promise.with-resolvers"
		  ],
		  	"core-js/full/queue-microtask": [
		  	"web.queue-microtask"
		  ],
		  	"core-js/full/reflect": [
		  	"es.object.to-string",
		  	"es.reflect.apply",
		  	"es.reflect.construct",
		  	"es.reflect.define-property",
		  	"es.reflect.delete-property",
		  	"es.reflect.get",
		  	"es.reflect.get-own-property-descriptor",
		  	"es.reflect.get-prototype-of",
		  	"es.reflect.has",
		  	"es.reflect.is-extensible",
		  	"es.reflect.own-keys",
		  	"es.reflect.prevent-extensions",
		  	"es.reflect.set",
		  	"es.reflect.set-prototype-of",
		  	"es.reflect.to-string-tag",
		  	"esnext.reflect.define-metadata",
		  	"esnext.reflect.delete-metadata",
		  	"esnext.reflect.get-metadata",
		  	"esnext.reflect.get-metadata-keys",
		  	"esnext.reflect.get-own-metadata",
		  	"esnext.reflect.get-own-metadata-keys",
		  	"esnext.reflect.has-metadata",
		  	"esnext.reflect.has-own-metadata",
		  	"esnext.reflect.metadata"
		  ],
		  	"core-js/full/reflect/apply": [
		  	"es.reflect.apply"
		  ],
		  	"core-js/full/reflect/construct": [
		  	"es.reflect.construct"
		  ],
		  	"core-js/full/reflect/define-metadata": [
		  	"esnext.reflect.define-metadata"
		  ],
		  	"core-js/full/reflect/define-property": [
		  	"es.reflect.define-property"
		  ],
		  	"core-js/full/reflect/delete-metadata": [
		  	"esnext.reflect.delete-metadata"
		  ],
		  	"core-js/full/reflect/delete-property": [
		  	"es.reflect.delete-property"
		  ],
		  	"core-js/full/reflect/get": [
		  	"es.reflect.get"
		  ],
		  	"core-js/full/reflect/get-metadata": [
		  	"esnext.reflect.get-metadata"
		  ],
		  	"core-js/full/reflect/get-metadata-keys": [
		  	"esnext.reflect.get-metadata-keys"
		  ],
		  	"core-js/full/reflect/get-own-metadata": [
		  	"esnext.reflect.get-own-metadata"
		  ],
		  	"core-js/full/reflect/get-own-metadata-keys": [
		  	"esnext.reflect.get-own-metadata-keys"
		  ],
		  	"core-js/full/reflect/get-own-property-descriptor": [
		  	"es.reflect.get-own-property-descriptor"
		  ],
		  	"core-js/full/reflect/get-prototype-of": [
		  	"es.reflect.get-prototype-of"
		  ],
		  	"core-js/full/reflect/has": [
		  	"es.reflect.has"
		  ],
		  	"core-js/full/reflect/has-metadata": [
		  	"esnext.reflect.has-metadata"
		  ],
		  	"core-js/full/reflect/has-own-metadata": [
		  	"esnext.reflect.has-own-metadata"
		  ],
		  	"core-js/full/reflect/is-extensible": [
		  	"es.reflect.is-extensible"
		  ],
		  	"core-js/full/reflect/metadata": [
		  	"esnext.reflect.metadata"
		  ],
		  	"core-js/full/reflect/own-keys": [
		  	"es.reflect.own-keys"
		  ],
		  	"core-js/full/reflect/prevent-extensions": [
		  	"es.reflect.prevent-extensions"
		  ],
		  	"core-js/full/reflect/set": [
		  	"es.reflect.set"
		  ],
		  	"core-js/full/reflect/set-prototype-of": [
		  	"es.reflect.set-prototype-of"
		  ],
		  	"core-js/full/reflect/to-string-tag": [
		  	"es.reflect.to-string-tag"
		  ],
		  	"core-js/full/regexp": [
		  	"es.regexp.constructor",
		  	"es.regexp.dot-all",
		  	"es.regexp.exec",
		  	"es.regexp.flags",
		  	"es.regexp.sticky",
		  	"es.regexp.test",
		  	"es.regexp.to-string",
		  	"es.string.match",
		  	"es.string.replace",
		  	"es.string.search",
		  	"es.string.split",
		  	"esnext.regexp.escape"
		  ],
		  	"core-js/full/regexp/constructor": [
		  	"es.regexp.constructor",
		  	"es.regexp.dot-all",
		  	"es.regexp.exec",
		  	"es.regexp.sticky"
		  ],
		  	"core-js/full/regexp/dot-all": [
		  	"es.regexp.constructor",
		  	"es.regexp.dot-all",
		  	"es.regexp.exec"
		  ],
		  	"core-js/full/regexp/escape": [
		  	"esnext.regexp.escape"
		  ],
		  	"core-js/full/regexp/flags": [
		  	"es.regexp.flags"
		  ],
		  	"core-js/full/regexp/match": [
		  	"es.regexp.exec",
		  	"es.string.match"
		  ],
		  	"core-js/full/regexp/replace": [
		  	"es.regexp.exec",
		  	"es.string.replace"
		  ],
		  	"core-js/full/regexp/search": [
		  	"es.regexp.exec",
		  	"es.string.search"
		  ],
		  	"core-js/full/regexp/split": [
		  	"es.regexp.exec",
		  	"es.string.split"
		  ],
		  	"core-js/full/regexp/sticky": [
		  	"es.regexp.constructor",
		  	"es.regexp.exec",
		  	"es.regexp.sticky"
		  ],
		  	"core-js/full/regexp/test": [
		  	"es.regexp.exec",
		  	"es.regexp.test"
		  ],
		  	"core-js/full/regexp/to-string": [
		  	"es.regexp.to-string"
		  ],
		  	"core-js/full/self": [
		  	"web.self"
		  ],
		  	"core-js/full/set": [
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"es.set",
		  	"es.string.iterator",
		  	"esnext.set.add-all",
		  	"esnext.set.delete-all",
		  	"esnext.set.difference.v2",
		  	"esnext.set.difference",
		  	"esnext.set.every",
		  	"esnext.set.filter",
		  	"esnext.set.find",
		  	"esnext.set.from",
		  	"esnext.set.intersection.v2",
		  	"esnext.set.intersection",
		  	"esnext.set.is-disjoint-from.v2",
		  	"esnext.set.is-disjoint-from",
		  	"esnext.set.is-subset-of.v2",
		  	"esnext.set.is-subset-of",
		  	"esnext.set.is-superset-of.v2",
		  	"esnext.set.is-superset-of",
		  	"esnext.set.join",
		  	"esnext.set.map",
		  	"esnext.set.of",
		  	"esnext.set.reduce",
		  	"esnext.set.some",
		  	"esnext.set.symmetric-difference.v2",
		  	"esnext.set.symmetric-difference",
		  	"esnext.set.union.v2",
		  	"esnext.set.union",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/full/set-immediate": [
		  	"web.immediate"
		  ],
		  	"core-js/full/set-interval": [
		  	"web.timers"
		  ],
		  	"core-js/full/set-timeout": [
		  	"web.timers"
		  ],
		  	"core-js/full/set/add-all": [
		  	"es.set",
		  	"esnext.set.add-all"
		  ],
		  	"core-js/full/set/delete-all": [
		  	"es.set",
		  	"esnext.set.delete-all"
		  ],
		  	"core-js/full/set/difference": [
		  	"es.array.iterator",
		  	"es.set",
		  	"es.string.iterator",
		  	"esnext.set.difference.v2",
		  	"esnext.set.difference",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/full/set/every": [
		  	"es.set",
		  	"esnext.set.every"
		  ],
		  	"core-js/full/set/filter": [
		  	"es.set",
		  	"esnext.set.filter"
		  ],
		  	"core-js/full/set/find": [
		  	"es.set",
		  	"esnext.set.find"
		  ],
		  	"core-js/full/set/from": [
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"es.set",
		  	"es.string.iterator",
		  	"esnext.set.add-all",
		  	"esnext.set.delete-all",
		  	"esnext.set.difference.v2",
		  	"esnext.set.every",
		  	"esnext.set.filter",
		  	"esnext.set.find",
		  	"esnext.set.from",
		  	"esnext.set.intersection.v2",
		  	"esnext.set.is-disjoint-from.v2",
		  	"esnext.set.is-subset-of.v2",
		  	"esnext.set.is-superset-of.v2",
		  	"esnext.set.join",
		  	"esnext.set.map",
		  	"esnext.set.reduce",
		  	"esnext.set.some",
		  	"esnext.set.symmetric-difference.v2",
		  	"esnext.set.union.v2",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/full/set/intersection": [
		  	"es.array.iterator",
		  	"es.set",
		  	"es.string.iterator",
		  	"esnext.set.intersection.v2",
		  	"esnext.set.intersection",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/full/set/is-disjoint-from": [
		  	"es.array.iterator",
		  	"es.set",
		  	"es.string.iterator",
		  	"esnext.set.is-disjoint-from.v2",
		  	"esnext.set.is-disjoint-from",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/full/set/is-subset-of": [
		  	"es.array.iterator",
		  	"es.set",
		  	"es.string.iterator",
		  	"esnext.set.is-subset-of.v2",
		  	"esnext.set.is-subset-of",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/full/set/is-superset-of": [
		  	"es.array.iterator",
		  	"es.set",
		  	"es.string.iterator",
		  	"esnext.set.is-superset-of.v2",
		  	"esnext.set.is-superset-of",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/full/set/join": [
		  	"es.set",
		  	"esnext.set.join"
		  ],
		  	"core-js/full/set/map": [
		  	"es.set",
		  	"esnext.set.map"
		  ],
		  	"core-js/full/set/of": [
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"es.set",
		  	"esnext.set.add-all",
		  	"esnext.set.delete-all",
		  	"esnext.set.difference.v2",
		  	"esnext.set.every",
		  	"esnext.set.filter",
		  	"esnext.set.find",
		  	"esnext.set.intersection.v2",
		  	"esnext.set.is-disjoint-from.v2",
		  	"esnext.set.is-subset-of.v2",
		  	"esnext.set.is-superset-of.v2",
		  	"esnext.set.join",
		  	"esnext.set.map",
		  	"esnext.set.of",
		  	"esnext.set.reduce",
		  	"esnext.set.some",
		  	"esnext.set.symmetric-difference.v2",
		  	"esnext.set.union.v2"
		  ],
		  	"core-js/full/set/reduce": [
		  	"es.set",
		  	"esnext.set.reduce"
		  ],
		  	"core-js/full/set/some": [
		  	"es.set",
		  	"esnext.set.some"
		  ],
		  	"core-js/full/set/symmetric-difference": [
		  	"es.array.iterator",
		  	"es.set",
		  	"es.string.iterator",
		  	"esnext.set.symmetric-difference.v2",
		  	"esnext.set.symmetric-difference",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/full/set/union": [
		  	"es.array.iterator",
		  	"es.set",
		  	"es.string.iterator",
		  	"esnext.set.union.v2",
		  	"esnext.set.union",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/full/string": [
		  	"es.object.to-string",
		  	"es.regexp.exec",
		  	"es.string.at-alternative",
		  	"es.string.code-point-at",
		  	"es.string.ends-with",
		  	"es.string.from-code-point",
		  	"es.string.includes",
		  	"es.string.is-well-formed",
		  	"es.string.iterator",
		  	"es.string.match",
		  	"es.string.match-all",
		  	"es.string.pad-end",
		  	"es.string.pad-start",
		  	"es.string.raw",
		  	"es.string.repeat",
		  	"es.string.replace",
		  	"es.string.replace-all",
		  	"es.string.search",
		  	"es.string.split",
		  	"es.string.starts-with",
		  	"es.string.substr",
		  	"es.string.to-well-formed",
		  	"es.string.trim",
		  	"es.string.trim-end",
		  	"es.string.trim-start",
		  	"es.string.anchor",
		  	"es.string.big",
		  	"es.string.blink",
		  	"es.string.bold",
		  	"es.string.fixed",
		  	"es.string.fontcolor",
		  	"es.string.fontsize",
		  	"es.string.italics",
		  	"es.string.link",
		  	"es.string.small",
		  	"es.string.strike",
		  	"es.string.sub",
		  	"es.string.sup",
		  	"es.weak-map",
		  	"esnext.string.at",
		  	"esnext.string.cooked",
		  	"esnext.string.code-points",
		  	"esnext.string.dedent",
		  	"esnext.string.is-well-formed",
		  	"esnext.string.match-all",
		  	"esnext.string.replace-all",
		  	"esnext.string.to-well-formed"
		  ],
		  	"core-js/full/string/anchor": [
		  	"es.string.anchor"
		  ],
		  	"core-js/full/string/at": [
		  	"es.string.at-alternative",
		  	"esnext.string.at"
		  ],
		  	"core-js/full/string/big": [
		  	"es.string.big"
		  ],
		  	"core-js/full/string/blink": [
		  	"es.string.blink"
		  ],
		  	"core-js/full/string/bold": [
		  	"es.string.bold"
		  ],
		  	"core-js/full/string/code-point-at": [
		  	"es.string.code-point-at"
		  ],
		  	"core-js/full/string/code-points": [
		  	"es.object.to-string",
		  	"esnext.string.code-points"
		  ],
		  	"core-js/full/string/cooked": [
		  	"esnext.string.cooked"
		  ],
		  	"core-js/full/string/dedent": [
		  	"es.string.from-code-point",
		  	"es.weak-map",
		  	"esnext.string.dedent"
		  ],
		  	"core-js/full/string/ends-with": [
		  	"es.string.ends-with"
		  ],
		  	"core-js/full/string/fixed": [
		  	"es.string.fixed"
		  ],
		  	"core-js/full/string/fontcolor": [
		  	"es.string.fontcolor"
		  ],
		  	"core-js/full/string/fontsize": [
		  	"es.string.fontsize"
		  ],
		  	"core-js/full/string/from-code-point": [
		  	"es.string.from-code-point"
		  ],
		  	"core-js/full/string/includes": [
		  	"es.string.includes"
		  ],
		  	"core-js/full/string/is-well-formed": [
		  	"es.string.is-well-formed",
		  	"esnext.string.is-well-formed"
		  ],
		  	"core-js/full/string/italics": [
		  	"es.string.italics"
		  ],
		  	"core-js/full/string/iterator": [
		  	"es.object.to-string",
		  	"es.string.iterator"
		  ],
		  	"core-js/full/string/link": [
		  	"es.string.link"
		  ],
		  	"core-js/full/string/match": [
		  	"es.regexp.exec",
		  	"es.string.match"
		  ],
		  	"core-js/full/string/match-all": [
		  	"es.object.to-string",
		  	"es.regexp.exec",
		  	"es.string.match-all",
		  	"esnext.string.match-all"
		  ],
		  	"core-js/full/string/pad-end": [
		  	"es.string.pad-end"
		  ],
		  	"core-js/full/string/pad-start": [
		  	"es.string.pad-start"
		  ],
		  	"core-js/full/string/raw": [
		  	"es.string.raw"
		  ],
		  	"core-js/full/string/repeat": [
		  	"es.string.repeat"
		  ],
		  	"core-js/full/string/replace": [
		  	"es.regexp.exec",
		  	"es.string.replace"
		  ],
		  	"core-js/full/string/replace-all": [
		  	"es.regexp.exec",
		  	"es.string.replace",
		  	"es.string.replace-all",
		  	"esnext.string.replace-all"
		  ],
		  	"core-js/full/string/search": [
		  	"es.regexp.exec",
		  	"es.string.search"
		  ],
		  	"core-js/full/string/small": [
		  	"es.string.small"
		  ],
		  	"core-js/full/string/split": [
		  	"es.regexp.exec",
		  	"es.string.split"
		  ],
		  	"core-js/full/string/starts-with": [
		  	"es.string.starts-with"
		  ],
		  	"core-js/full/string/strike": [
		  	"es.string.strike"
		  ],
		  	"core-js/full/string/sub": [
		  	"es.string.sub"
		  ],
		  	"core-js/full/string/substr": [
		  	"es.string.substr"
		  ],
		  	"core-js/full/string/sup": [
		  	"es.string.sup"
		  ],
		  	"core-js/full/string/to-well-formed": [
		  	"es.string.to-well-formed",
		  	"esnext.string.to-well-formed"
		  ],
		  	"core-js/full/string/trim": [
		  	"es.string.trim"
		  ],
		  	"core-js/full/string/trim-end": [
		  	"es.string.trim-end"
		  ],
		  	"core-js/full/string/trim-left": [
		  	"es.string.trim-start"
		  ],
		  	"core-js/full/string/trim-right": [
		  	"es.string.trim-end"
		  ],
		  	"core-js/full/string/trim-start": [
		  	"es.string.trim-start"
		  ],
		  	"core-js/full/string/virtual": [
		  	"es.object.to-string",
		  	"es.regexp.exec",
		  	"es.string.at-alternative",
		  	"es.string.code-point-at",
		  	"es.string.ends-with",
		  	"es.string.includes",
		  	"es.string.iterator",
		  	"es.string.match",
		  	"es.string.match-all",
		  	"es.string.pad-end",
		  	"es.string.pad-start",
		  	"es.string.repeat",
		  	"es.string.replace",
		  	"es.string.replace-all",
		  	"es.string.search",
		  	"es.string.split",
		  	"es.string.starts-with",
		  	"es.string.substr",
		  	"es.string.trim",
		  	"es.string.trim-end",
		  	"es.string.trim-start",
		  	"es.string.anchor",
		  	"es.string.big",
		  	"es.string.blink",
		  	"es.string.bold",
		  	"es.string.fixed",
		  	"es.string.fontcolor",
		  	"es.string.fontsize",
		  	"es.string.italics",
		  	"es.string.link",
		  	"es.string.small",
		  	"es.string.strike",
		  	"es.string.sub",
		  	"es.string.sup",
		  	"esnext.string.at",
		  	"esnext.string.code-points",
		  	"esnext.string.is-well-formed",
		  	"esnext.string.match-all",
		  	"esnext.string.replace-all",
		  	"esnext.string.to-well-formed"
		  ],
		  	"core-js/full/string/virtual/anchor": [
		  	"es.string.anchor"
		  ],
		  	"core-js/full/string/virtual/at": [
		  	"es.string.at-alternative",
		  	"esnext.string.at"
		  ],
		  	"core-js/full/string/virtual/big": [
		  	"es.string.big"
		  ],
		  	"core-js/full/string/virtual/blink": [
		  	"es.string.blink"
		  ],
		  	"core-js/full/string/virtual/bold": [
		  	"es.string.bold"
		  ],
		  	"core-js/full/string/virtual/code-point-at": [
		  	"es.string.code-point-at"
		  ],
		  	"core-js/full/string/virtual/code-points": [
		  	"es.object.to-string",
		  	"esnext.string.code-points"
		  ],
		  	"core-js/full/string/virtual/ends-with": [
		  	"es.string.ends-with"
		  ],
		  	"core-js/full/string/virtual/fixed": [
		  	"es.string.fixed"
		  ],
		  	"core-js/full/string/virtual/fontcolor": [
		  	"es.string.fontcolor"
		  ],
		  	"core-js/full/string/virtual/fontsize": [
		  	"es.string.fontsize"
		  ],
		  	"core-js/full/string/virtual/includes": [
		  	"es.string.includes"
		  ],
		  	"core-js/full/string/virtual/is-well-formed": [
		  	"es.string.is-well-formed",
		  	"esnext.string.is-well-formed"
		  ],
		  	"core-js/full/string/virtual/italics": [
		  	"es.string.italics"
		  ],
		  	"core-js/full/string/virtual/iterator": [
		  	"es.object.to-string",
		  	"es.string.iterator"
		  ],
		  	"core-js/full/string/virtual/link": [
		  	"es.string.link"
		  ],
		  	"core-js/full/string/virtual/match-all": [
		  	"es.object.to-string",
		  	"es.regexp.exec",
		  	"es.string.match-all",
		  	"esnext.string.match-all"
		  ],
		  	"core-js/full/string/virtual/pad-end": [
		  	"es.string.pad-end"
		  ],
		  	"core-js/full/string/virtual/pad-start": [
		  	"es.string.pad-start"
		  ],
		  	"core-js/full/string/virtual/repeat": [
		  	"es.string.repeat"
		  ],
		  	"core-js/full/string/virtual/replace-all": [
		  	"es.regexp.exec",
		  	"es.string.replace",
		  	"es.string.replace-all",
		  	"esnext.string.replace-all"
		  ],
		  	"core-js/full/string/virtual/small": [
		  	"es.string.small"
		  ],
		  	"core-js/full/string/virtual/starts-with": [
		  	"es.string.starts-with"
		  ],
		  	"core-js/full/string/virtual/strike": [
		  	"es.string.strike"
		  ],
		  	"core-js/full/string/virtual/sub": [
		  	"es.string.sub"
		  ],
		  	"core-js/full/string/virtual/substr": [
		  	"es.string.substr"
		  ],
		  	"core-js/full/string/virtual/sup": [
		  	"es.string.sup"
		  ],
		  	"core-js/full/string/virtual/to-well-formed": [
		  	"es.string.to-well-formed",
		  	"esnext.string.to-well-formed"
		  ],
		  	"core-js/full/string/virtual/trim": [
		  	"es.string.trim"
		  ],
		  	"core-js/full/string/virtual/trim-end": [
		  	"es.string.trim-end"
		  ],
		  	"core-js/full/string/virtual/trim-left": [
		  	"es.string.trim-start"
		  ],
		  	"core-js/full/string/virtual/trim-right": [
		  	"es.string.trim-end"
		  ],
		  	"core-js/full/string/virtual/trim-start": [
		  	"es.string.trim-start"
		  ],
		  	"core-js/full/structured-clone": [
		  	"es.error.to-string",
		  	"es.array.iterator",
		  	"es.map",
		  	"es.object.keys",
		  	"es.object.to-string",
		  	"es.set",
		  	"web.dom-exception.constructor",
		  	"web.dom-exception.stack",
		  	"web.dom-exception.to-string-tag",
		  	"web.structured-clone"
		  ],
		  	"core-js/full/suppressed-error": [
		  ],
		  	"core-js/full/symbol": [
		  	"es.symbol",
		  	"es.symbol.description",
		  	"es.symbol.async-iterator",
		  	"es.symbol.has-instance",
		  	"es.symbol.is-concat-spreadable",
		  	"es.symbol.iterator",
		  	"es.symbol.match",
		  	"es.symbol.match-all",
		  	"es.symbol.replace",
		  	"es.symbol.search",
		  	"es.symbol.species",
		  	"es.symbol.split",
		  	"es.symbol.to-primitive",
		  	"es.symbol.to-string-tag",
		  	"es.symbol.unscopables",
		  	"es.array.concat",
		  	"es.json.to-string-tag",
		  	"es.math.to-string-tag",
		  	"es.object.to-string",
		  	"es.reflect.to-string-tag",
		  	"esnext.function.metadata",
		  	"esnext.symbol.async-dispose",
		  	"esnext.symbol.dispose",
		  	"esnext.symbol.is-registered-symbol",
		  	"esnext.symbol.is-registered",
		  	"esnext.symbol.is-well-known-symbol",
		  	"esnext.symbol.is-well-known",
		  	"esnext.symbol.matcher",
		  	"esnext.symbol.metadata",
		  	"esnext.symbol.metadata-key",
		  	"esnext.symbol.observable",
		  	"esnext.symbol.pattern-match",
		  	"esnext.symbol.replace-all",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/full/symbol/async-dispose": [
		  	"esnext.symbol.async-dispose"
		  ],
		  	"core-js/full/symbol/async-iterator": [
		  	"es.symbol.async-iterator"
		  ],
		  	"core-js/full/symbol/description": [
		  	"es.symbol.description"
		  ],
		  	"core-js/full/symbol/dispose": [
		  	"esnext.symbol.dispose"
		  ],
		  	"core-js/full/symbol/for": [
		  	"es.symbol"
		  ],
		  	"core-js/full/symbol/has-instance": [
		  	"es.symbol.has-instance",
		  	"es.function.has-instance"
		  ],
		  	"core-js/full/symbol/is-concat-spreadable": [
		  	"es.symbol.is-concat-spreadable",
		  	"es.array.concat"
		  ],
		  	"core-js/full/symbol/is-registered": [
		  	"es.symbol",
		  	"esnext.symbol.is-registered"
		  ],
		  	"core-js/full/symbol/is-registered-symbol": [
		  	"es.symbol",
		  	"esnext.symbol.is-registered-symbol"
		  ],
		  	"core-js/full/symbol/is-well-known": [
		  	"es.symbol",
		  	"esnext.symbol.is-well-known"
		  ],
		  	"core-js/full/symbol/is-well-known-symbol": [
		  	"es.symbol",
		  	"esnext.symbol.is-well-known-symbol"
		  ],
		  	"core-js/full/symbol/iterator": [
		  	"es.symbol.iterator",
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"es.string.iterator",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/full/symbol/key-for": [
		  	"es.symbol"
		  ],
		  	"core-js/full/symbol/match": [
		  	"es.symbol.match",
		  	"es.regexp.exec",
		  	"es.string.match"
		  ],
		  	"core-js/full/symbol/match-all": [
		  	"es.symbol.match-all",
		  	"es.object.to-string",
		  	"es.regexp.exec",
		  	"es.string.match-all"
		  ],
		  	"core-js/full/symbol/matcher": [
		  	"esnext.symbol.matcher"
		  ],
		  	"core-js/full/symbol/metadata": [
		  	"esnext.function.metadata",
		  	"esnext.symbol.metadata"
		  ],
		  	"core-js/full/symbol/metadata-key": [
		  	"esnext.symbol.metadata-key"
		  ],
		  	"core-js/full/symbol/observable": [
		  	"esnext.symbol.observable"
		  ],
		  	"core-js/full/symbol/pattern-match": [
		  	"esnext.symbol.pattern-match"
		  ],
		  	"core-js/full/symbol/replace": [
		  	"es.symbol.replace",
		  	"es.regexp.exec",
		  	"es.string.replace"
		  ],
		  	"core-js/full/symbol/replace-all": [
		  	"esnext.symbol.replace-all"
		  ],
		  	"core-js/full/symbol/search": [
		  	"es.symbol.search",
		  	"es.regexp.exec",
		  	"es.string.search"
		  ],
		  	"core-js/full/symbol/species": [
		  	"es.symbol.species"
		  ],
		  	"core-js/full/symbol/split": [
		  	"es.symbol.split",
		  	"es.regexp.exec",
		  	"es.string.split"
		  ],
		  	"core-js/full/symbol/to-primitive": [
		  	"es.symbol.to-primitive",
		  	"es.date.to-primitive"
		  ],
		  	"core-js/full/symbol/to-string-tag": [
		  	"es.symbol.to-string-tag",
		  	"es.json.to-string-tag",
		  	"es.math.to-string-tag",
		  	"es.object.to-string",
		  	"es.reflect.to-string-tag"
		  ],
		  	"core-js/full/symbol/unscopables": [
		  	"es.symbol.unscopables"
		  ],
		  	"core-js/full/typed-array": [
		  	"es.map",
		  	"es.object.to-string",
		  	"es.promise",
		  	"es.string.iterator",
		  	"es.typed-array.float32-array",
		  	"es.typed-array.float64-array",
		  	"es.typed-array.int8-array",
		  	"es.typed-array.int16-array",
		  	"es.typed-array.int32-array",
		  	"es.typed-array.uint8-array",
		  	"es.typed-array.uint8-clamped-array",
		  	"es.typed-array.uint16-array",
		  	"es.typed-array.uint32-array",
		  	"es.typed-array.at",
		  	"es.typed-array.copy-within",
		  	"es.typed-array.every",
		  	"es.typed-array.fill",
		  	"es.typed-array.filter",
		  	"es.typed-array.find",
		  	"es.typed-array.find-index",
		  	"es.typed-array.find-last",
		  	"es.typed-array.find-last-index",
		  	"es.typed-array.for-each",
		  	"es.typed-array.from",
		  	"es.typed-array.includes",
		  	"es.typed-array.index-of",
		  	"es.typed-array.iterator",
		  	"es.typed-array.join",
		  	"es.typed-array.last-index-of",
		  	"es.typed-array.map",
		  	"es.typed-array.of",
		  	"es.typed-array.reduce",
		  	"es.typed-array.reduce-right",
		  	"es.typed-array.reverse",
		  	"es.typed-array.set",
		  	"es.typed-array.slice",
		  	"es.typed-array.some",
		  	"es.typed-array.sort",
		  	"es.typed-array.subarray",
		  	"es.typed-array.to-locale-string",
		  	"es.typed-array.to-reversed",
		  	"es.typed-array.to-sorted",
		  	"es.typed-array.to-string",
		  	"es.typed-array.with",
		  	"esnext.typed-array.from-async",
		  	"esnext.typed-array.at",
		  	"esnext.typed-array.filter-out",
		  	"esnext.typed-array.filter-reject",
		  	"esnext.typed-array.find-last",
		  	"esnext.typed-array.find-last-index",
		  	"esnext.typed-array.group-by",
		  	"esnext.typed-array.to-reversed",
		  	"esnext.typed-array.to-sorted",
		  	"esnext.typed-array.to-spliced",
		  	"esnext.typed-array.unique-by",
		  	"esnext.typed-array.with",
		  	"esnext.uint8-array.from-base64",
		  	"esnext.uint8-array.from-hex",
		  	"esnext.uint8-array.to-base64",
		  	"esnext.uint8-array.to-hex"
		  ],
		  	"core-js/full/typed-array/at": [
		  	"es.typed-array.at",
		  	"esnext.typed-array.at"
		  ],
		  	"core-js/full/typed-array/copy-within": [
		  	"es.typed-array.copy-within"
		  ],
		  	"core-js/full/typed-array/entries": [
		  	"es.object.to-string",
		  	"es.typed-array.iterator"
		  ],
		  	"core-js/full/typed-array/every": [
		  	"es.typed-array.every"
		  ],
		  	"core-js/full/typed-array/fill": [
		  	"es.typed-array.fill"
		  ],
		  	"core-js/full/typed-array/filter": [
		  	"es.typed-array.filter"
		  ],
		  	"core-js/full/typed-array/filter-out": [
		  	"esnext.typed-array.filter-out"
		  ],
		  	"core-js/full/typed-array/filter-reject": [
		  	"esnext.typed-array.filter-reject"
		  ],
		  	"core-js/full/typed-array/find": [
		  	"es.typed-array.find"
		  ],
		  	"core-js/full/typed-array/find-index": [
		  	"es.typed-array.find-index"
		  ],
		  	"core-js/full/typed-array/find-last": [
		  	"es.typed-array.find-last",
		  	"esnext.typed-array.find-last"
		  ],
		  	"core-js/full/typed-array/find-last-index": [
		  	"es.typed-array.find-last-index",
		  	"esnext.typed-array.find-last-index"
		  ],
		  	"core-js/full/typed-array/float32-array": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.map",
		  	"es.object.to-string",
		  	"es.promise",
		  	"es.string.iterator",
		  	"es.typed-array.float32-array",
		  	"es.typed-array.at",
		  	"es.typed-array.copy-within",
		  	"es.typed-array.every",
		  	"es.typed-array.fill",
		  	"es.typed-array.filter",
		  	"es.typed-array.find",
		  	"es.typed-array.find-index",
		  	"es.typed-array.find-last",
		  	"es.typed-array.find-last-index",
		  	"es.typed-array.for-each",
		  	"es.typed-array.from",
		  	"es.typed-array.includes",
		  	"es.typed-array.index-of",
		  	"es.typed-array.iterator",
		  	"es.typed-array.join",
		  	"es.typed-array.last-index-of",
		  	"es.typed-array.map",
		  	"es.typed-array.of",
		  	"es.typed-array.reduce",
		  	"es.typed-array.reduce-right",
		  	"es.typed-array.reverse",
		  	"es.typed-array.set",
		  	"es.typed-array.slice",
		  	"es.typed-array.some",
		  	"es.typed-array.sort",
		  	"es.typed-array.subarray",
		  	"es.typed-array.to-locale-string",
		  	"es.typed-array.to-reversed",
		  	"es.typed-array.to-sorted",
		  	"es.typed-array.to-string",
		  	"es.typed-array.with",
		  	"esnext.typed-array.from-async",
		  	"esnext.typed-array.at",
		  	"esnext.typed-array.filter-out",
		  	"esnext.typed-array.filter-reject",
		  	"esnext.typed-array.find-last",
		  	"esnext.typed-array.find-last-index",
		  	"esnext.typed-array.group-by",
		  	"esnext.typed-array.to-reversed",
		  	"esnext.typed-array.to-sorted",
		  	"esnext.typed-array.to-spliced",
		  	"esnext.typed-array.unique-by",
		  	"esnext.typed-array.with",
		  	"esnext.uint8-array.from-base64",
		  	"esnext.uint8-array.from-hex",
		  	"esnext.uint8-array.to-base64",
		  	"esnext.uint8-array.to-hex"
		  ],
		  	"core-js/full/typed-array/float64-array": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.map",
		  	"es.object.to-string",
		  	"es.promise",
		  	"es.string.iterator",
		  	"es.typed-array.float64-array",
		  	"es.typed-array.at",
		  	"es.typed-array.copy-within",
		  	"es.typed-array.every",
		  	"es.typed-array.fill",
		  	"es.typed-array.filter",
		  	"es.typed-array.find",
		  	"es.typed-array.find-index",
		  	"es.typed-array.find-last",
		  	"es.typed-array.find-last-index",
		  	"es.typed-array.for-each",
		  	"es.typed-array.from",
		  	"es.typed-array.includes",
		  	"es.typed-array.index-of",
		  	"es.typed-array.iterator",
		  	"es.typed-array.join",
		  	"es.typed-array.last-index-of",
		  	"es.typed-array.map",
		  	"es.typed-array.of",
		  	"es.typed-array.reduce",
		  	"es.typed-array.reduce-right",
		  	"es.typed-array.reverse",
		  	"es.typed-array.set",
		  	"es.typed-array.slice",
		  	"es.typed-array.some",
		  	"es.typed-array.sort",
		  	"es.typed-array.subarray",
		  	"es.typed-array.to-locale-string",
		  	"es.typed-array.to-reversed",
		  	"es.typed-array.to-sorted",
		  	"es.typed-array.to-string",
		  	"es.typed-array.with",
		  	"esnext.typed-array.from-async",
		  	"esnext.typed-array.at",
		  	"esnext.typed-array.filter-out",
		  	"esnext.typed-array.filter-reject",
		  	"esnext.typed-array.find-last",
		  	"esnext.typed-array.find-last-index",
		  	"esnext.typed-array.group-by",
		  	"esnext.typed-array.to-reversed",
		  	"esnext.typed-array.to-sorted",
		  	"esnext.typed-array.to-spliced",
		  	"esnext.typed-array.unique-by",
		  	"esnext.typed-array.with",
		  	"esnext.uint8-array.from-base64",
		  	"esnext.uint8-array.from-hex",
		  	"esnext.uint8-array.to-base64",
		  	"esnext.uint8-array.to-hex"
		  ],
		  	"core-js/full/typed-array/for-each": [
		  	"es.typed-array.for-each"
		  ],
		  	"core-js/full/typed-array/from": [
		  	"es.typed-array.from"
		  ],
		  	"core-js/full/typed-array/from-async": [
		  	"esnext.typed-array.from-async"
		  ],
		  	"core-js/full/typed-array/from-base64": [
		  	"esnext.uint8-array.from-base64"
		  ],
		  	"core-js/full/typed-array/from-hex": [
		  	"esnext.uint8-array.from-hex"
		  ],
		  	"core-js/full/typed-array/group-by": [
		  	"esnext.typed-array.group-by"
		  ],
		  	"core-js/full/typed-array/includes": [
		  	"es.typed-array.includes"
		  ],
		  	"core-js/full/typed-array/index-of": [
		  	"es.typed-array.index-of"
		  ],
		  	"core-js/full/typed-array/int16-array": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.map",
		  	"es.object.to-string",
		  	"es.promise",
		  	"es.string.iterator",
		  	"es.typed-array.int16-array",
		  	"es.typed-array.at",
		  	"es.typed-array.copy-within",
		  	"es.typed-array.every",
		  	"es.typed-array.fill",
		  	"es.typed-array.filter",
		  	"es.typed-array.find",
		  	"es.typed-array.find-index",
		  	"es.typed-array.find-last",
		  	"es.typed-array.find-last-index",
		  	"es.typed-array.for-each",
		  	"es.typed-array.from",
		  	"es.typed-array.includes",
		  	"es.typed-array.index-of",
		  	"es.typed-array.iterator",
		  	"es.typed-array.join",
		  	"es.typed-array.last-index-of",
		  	"es.typed-array.map",
		  	"es.typed-array.of",
		  	"es.typed-array.reduce",
		  	"es.typed-array.reduce-right",
		  	"es.typed-array.reverse",
		  	"es.typed-array.set",
		  	"es.typed-array.slice",
		  	"es.typed-array.some",
		  	"es.typed-array.sort",
		  	"es.typed-array.subarray",
		  	"es.typed-array.to-locale-string",
		  	"es.typed-array.to-reversed",
		  	"es.typed-array.to-sorted",
		  	"es.typed-array.to-string",
		  	"es.typed-array.with",
		  	"esnext.typed-array.from-async",
		  	"esnext.typed-array.at",
		  	"esnext.typed-array.filter-out",
		  	"esnext.typed-array.filter-reject",
		  	"esnext.typed-array.find-last",
		  	"esnext.typed-array.find-last-index",
		  	"esnext.typed-array.group-by",
		  	"esnext.typed-array.to-reversed",
		  	"esnext.typed-array.to-sorted",
		  	"esnext.typed-array.to-spliced",
		  	"esnext.typed-array.unique-by",
		  	"esnext.typed-array.with",
		  	"esnext.uint8-array.from-base64",
		  	"esnext.uint8-array.from-hex",
		  	"esnext.uint8-array.to-base64",
		  	"esnext.uint8-array.to-hex"
		  ],
		  	"core-js/full/typed-array/int32-array": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.map",
		  	"es.object.to-string",
		  	"es.promise",
		  	"es.string.iterator",
		  	"es.typed-array.int32-array",
		  	"es.typed-array.at",
		  	"es.typed-array.copy-within",
		  	"es.typed-array.every",
		  	"es.typed-array.fill",
		  	"es.typed-array.filter",
		  	"es.typed-array.find",
		  	"es.typed-array.find-index",
		  	"es.typed-array.find-last",
		  	"es.typed-array.find-last-index",
		  	"es.typed-array.for-each",
		  	"es.typed-array.from",
		  	"es.typed-array.includes",
		  	"es.typed-array.index-of",
		  	"es.typed-array.iterator",
		  	"es.typed-array.join",
		  	"es.typed-array.last-index-of",
		  	"es.typed-array.map",
		  	"es.typed-array.of",
		  	"es.typed-array.reduce",
		  	"es.typed-array.reduce-right",
		  	"es.typed-array.reverse",
		  	"es.typed-array.set",
		  	"es.typed-array.slice",
		  	"es.typed-array.some",
		  	"es.typed-array.sort",
		  	"es.typed-array.subarray",
		  	"es.typed-array.to-locale-string",
		  	"es.typed-array.to-reversed",
		  	"es.typed-array.to-sorted",
		  	"es.typed-array.to-string",
		  	"es.typed-array.with",
		  	"esnext.typed-array.from-async",
		  	"esnext.typed-array.at",
		  	"esnext.typed-array.filter-out",
		  	"esnext.typed-array.filter-reject",
		  	"esnext.typed-array.find-last",
		  	"esnext.typed-array.find-last-index",
		  	"esnext.typed-array.group-by",
		  	"esnext.typed-array.to-reversed",
		  	"esnext.typed-array.to-sorted",
		  	"esnext.typed-array.to-spliced",
		  	"esnext.typed-array.unique-by",
		  	"esnext.typed-array.with",
		  	"esnext.uint8-array.from-base64",
		  	"esnext.uint8-array.from-hex",
		  	"esnext.uint8-array.to-base64",
		  	"esnext.uint8-array.to-hex"
		  ],
		  	"core-js/full/typed-array/int8-array": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.map",
		  	"es.object.to-string",
		  	"es.promise",
		  	"es.string.iterator",
		  	"es.typed-array.int8-array",
		  	"es.typed-array.at",
		  	"es.typed-array.copy-within",
		  	"es.typed-array.every",
		  	"es.typed-array.fill",
		  	"es.typed-array.filter",
		  	"es.typed-array.find",
		  	"es.typed-array.find-index",
		  	"es.typed-array.find-last",
		  	"es.typed-array.find-last-index",
		  	"es.typed-array.for-each",
		  	"es.typed-array.from",
		  	"es.typed-array.includes",
		  	"es.typed-array.index-of",
		  	"es.typed-array.iterator",
		  	"es.typed-array.join",
		  	"es.typed-array.last-index-of",
		  	"es.typed-array.map",
		  	"es.typed-array.of",
		  	"es.typed-array.reduce",
		  	"es.typed-array.reduce-right",
		  	"es.typed-array.reverse",
		  	"es.typed-array.set",
		  	"es.typed-array.slice",
		  	"es.typed-array.some",
		  	"es.typed-array.sort",
		  	"es.typed-array.subarray",
		  	"es.typed-array.to-locale-string",
		  	"es.typed-array.to-reversed",
		  	"es.typed-array.to-sorted",
		  	"es.typed-array.to-string",
		  	"es.typed-array.with",
		  	"esnext.typed-array.from-async",
		  	"esnext.typed-array.at",
		  	"esnext.typed-array.filter-out",
		  	"esnext.typed-array.filter-reject",
		  	"esnext.typed-array.find-last",
		  	"esnext.typed-array.find-last-index",
		  	"esnext.typed-array.group-by",
		  	"esnext.typed-array.to-reversed",
		  	"esnext.typed-array.to-sorted",
		  	"esnext.typed-array.to-spliced",
		  	"esnext.typed-array.unique-by",
		  	"esnext.typed-array.with",
		  	"esnext.uint8-array.from-base64",
		  	"esnext.uint8-array.from-hex",
		  	"esnext.uint8-array.to-base64",
		  	"esnext.uint8-array.to-hex"
		  ],
		  	"core-js/full/typed-array/iterator": [
		  	"es.object.to-string",
		  	"es.typed-array.iterator"
		  ],
		  	"core-js/full/typed-array/join": [
		  	"es.typed-array.join"
		  ],
		  	"core-js/full/typed-array/keys": [
		  	"es.object.to-string",
		  	"es.typed-array.iterator"
		  ],
		  	"core-js/full/typed-array/last-index-of": [
		  	"es.typed-array.last-index-of"
		  ],
		  	"core-js/full/typed-array/map": [
		  	"es.typed-array.map"
		  ],
		  	"core-js/full/typed-array/methods": [
		  	"es.map",
		  	"es.object.to-string",
		  	"es.promise",
		  	"es.string.iterator",
		  	"es.typed-array.at",
		  	"es.typed-array.copy-within",
		  	"es.typed-array.every",
		  	"es.typed-array.fill",
		  	"es.typed-array.filter",
		  	"es.typed-array.find",
		  	"es.typed-array.find-index",
		  	"es.typed-array.find-last",
		  	"es.typed-array.find-last-index",
		  	"es.typed-array.for-each",
		  	"es.typed-array.from",
		  	"es.typed-array.includes",
		  	"es.typed-array.index-of",
		  	"es.typed-array.iterator",
		  	"es.typed-array.join",
		  	"es.typed-array.last-index-of",
		  	"es.typed-array.map",
		  	"es.typed-array.of",
		  	"es.typed-array.reduce",
		  	"es.typed-array.reduce-right",
		  	"es.typed-array.reverse",
		  	"es.typed-array.set",
		  	"es.typed-array.slice",
		  	"es.typed-array.some",
		  	"es.typed-array.sort",
		  	"es.typed-array.subarray",
		  	"es.typed-array.to-locale-string",
		  	"es.typed-array.to-reversed",
		  	"es.typed-array.to-sorted",
		  	"es.typed-array.to-string",
		  	"es.typed-array.with",
		  	"esnext.typed-array.from-async",
		  	"esnext.typed-array.at",
		  	"esnext.typed-array.filter-out",
		  	"esnext.typed-array.filter-reject",
		  	"esnext.typed-array.find-last",
		  	"esnext.typed-array.find-last-index",
		  	"esnext.typed-array.group-by",
		  	"esnext.typed-array.to-reversed",
		  	"esnext.typed-array.to-sorted",
		  	"esnext.typed-array.to-spliced",
		  	"esnext.typed-array.unique-by",
		  	"esnext.typed-array.with",
		  	"esnext.uint8-array.from-base64",
		  	"esnext.uint8-array.from-hex",
		  	"esnext.uint8-array.to-base64",
		  	"esnext.uint8-array.to-hex"
		  ],
		  	"core-js/full/typed-array/of": [
		  	"es.typed-array.of"
		  ],
		  	"core-js/full/typed-array/reduce": [
		  	"es.typed-array.reduce"
		  ],
		  	"core-js/full/typed-array/reduce-right": [
		  	"es.typed-array.reduce-right"
		  ],
		  	"core-js/full/typed-array/reverse": [
		  	"es.typed-array.reverse"
		  ],
		  	"core-js/full/typed-array/set": [
		  	"es.typed-array.set"
		  ],
		  	"core-js/full/typed-array/slice": [
		  	"es.typed-array.slice"
		  ],
		  	"core-js/full/typed-array/some": [
		  	"es.typed-array.some"
		  ],
		  	"core-js/full/typed-array/sort": [
		  	"es.typed-array.sort"
		  ],
		  	"core-js/full/typed-array/subarray": [
		  	"es.typed-array.subarray"
		  ],
		  	"core-js/full/typed-array/to-base64": [
		  	"esnext.uint8-array.to-base64"
		  ],
		  	"core-js/full/typed-array/to-hex": [
		  	"esnext.uint8-array.to-hex"
		  ],
		  	"core-js/full/typed-array/to-locale-string": [
		  	"es.typed-array.to-locale-string"
		  ],
		  	"core-js/full/typed-array/to-reversed": [
		  	"es.typed-array.to-reversed",
		  	"esnext.typed-array.to-reversed"
		  ],
		  	"core-js/full/typed-array/to-sorted": [
		  	"es.typed-array.sort",
		  	"es.typed-array.to-sorted",
		  	"esnext.typed-array.to-sorted"
		  ],
		  	"core-js/full/typed-array/to-spliced": [
		  	"esnext.typed-array.to-spliced"
		  ],
		  	"core-js/full/typed-array/to-string": [
		  	"es.typed-array.to-string"
		  ],
		  	"core-js/full/typed-array/uint16-array": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.map",
		  	"es.object.to-string",
		  	"es.promise",
		  	"es.string.iterator",
		  	"es.typed-array.uint16-array",
		  	"es.typed-array.at",
		  	"es.typed-array.copy-within",
		  	"es.typed-array.every",
		  	"es.typed-array.fill",
		  	"es.typed-array.filter",
		  	"es.typed-array.find",
		  	"es.typed-array.find-index",
		  	"es.typed-array.find-last",
		  	"es.typed-array.find-last-index",
		  	"es.typed-array.for-each",
		  	"es.typed-array.from",
		  	"es.typed-array.includes",
		  	"es.typed-array.index-of",
		  	"es.typed-array.iterator",
		  	"es.typed-array.join",
		  	"es.typed-array.last-index-of",
		  	"es.typed-array.map",
		  	"es.typed-array.of",
		  	"es.typed-array.reduce",
		  	"es.typed-array.reduce-right",
		  	"es.typed-array.reverse",
		  	"es.typed-array.set",
		  	"es.typed-array.slice",
		  	"es.typed-array.some",
		  	"es.typed-array.sort",
		  	"es.typed-array.subarray",
		  	"es.typed-array.to-locale-string",
		  	"es.typed-array.to-reversed",
		  	"es.typed-array.to-sorted",
		  	"es.typed-array.to-string",
		  	"es.typed-array.with",
		  	"esnext.typed-array.from-async",
		  	"esnext.typed-array.at",
		  	"esnext.typed-array.filter-out",
		  	"esnext.typed-array.filter-reject",
		  	"esnext.typed-array.find-last",
		  	"esnext.typed-array.find-last-index",
		  	"esnext.typed-array.group-by",
		  	"esnext.typed-array.to-reversed",
		  	"esnext.typed-array.to-sorted",
		  	"esnext.typed-array.to-spliced",
		  	"esnext.typed-array.unique-by",
		  	"esnext.typed-array.with",
		  	"esnext.uint8-array.from-base64",
		  	"esnext.uint8-array.from-hex",
		  	"esnext.uint8-array.to-base64",
		  	"esnext.uint8-array.to-hex"
		  ],
		  	"core-js/full/typed-array/uint32-array": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.map",
		  	"es.object.to-string",
		  	"es.promise",
		  	"es.string.iterator",
		  	"es.typed-array.uint32-array",
		  	"es.typed-array.at",
		  	"es.typed-array.copy-within",
		  	"es.typed-array.every",
		  	"es.typed-array.fill",
		  	"es.typed-array.filter",
		  	"es.typed-array.find",
		  	"es.typed-array.find-index",
		  	"es.typed-array.find-last",
		  	"es.typed-array.find-last-index",
		  	"es.typed-array.for-each",
		  	"es.typed-array.from",
		  	"es.typed-array.includes",
		  	"es.typed-array.index-of",
		  	"es.typed-array.iterator",
		  	"es.typed-array.join",
		  	"es.typed-array.last-index-of",
		  	"es.typed-array.map",
		  	"es.typed-array.of",
		  	"es.typed-array.reduce",
		  	"es.typed-array.reduce-right",
		  	"es.typed-array.reverse",
		  	"es.typed-array.set",
		  	"es.typed-array.slice",
		  	"es.typed-array.some",
		  	"es.typed-array.sort",
		  	"es.typed-array.subarray",
		  	"es.typed-array.to-locale-string",
		  	"es.typed-array.to-reversed",
		  	"es.typed-array.to-sorted",
		  	"es.typed-array.to-string",
		  	"es.typed-array.with",
		  	"esnext.typed-array.from-async",
		  	"esnext.typed-array.at",
		  	"esnext.typed-array.filter-out",
		  	"esnext.typed-array.filter-reject",
		  	"esnext.typed-array.find-last",
		  	"esnext.typed-array.find-last-index",
		  	"esnext.typed-array.group-by",
		  	"esnext.typed-array.to-reversed",
		  	"esnext.typed-array.to-sorted",
		  	"esnext.typed-array.to-spliced",
		  	"esnext.typed-array.unique-by",
		  	"esnext.typed-array.with",
		  	"esnext.uint8-array.from-base64",
		  	"esnext.uint8-array.from-hex",
		  	"esnext.uint8-array.to-base64",
		  	"esnext.uint8-array.to-hex"
		  ],
		  	"core-js/full/typed-array/uint8-array": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.map",
		  	"es.object.to-string",
		  	"es.promise",
		  	"es.string.iterator",
		  	"es.typed-array.uint8-array",
		  	"es.typed-array.at",
		  	"es.typed-array.copy-within",
		  	"es.typed-array.every",
		  	"es.typed-array.fill",
		  	"es.typed-array.filter",
		  	"es.typed-array.find",
		  	"es.typed-array.find-index",
		  	"es.typed-array.find-last",
		  	"es.typed-array.find-last-index",
		  	"es.typed-array.for-each",
		  	"es.typed-array.from",
		  	"es.typed-array.includes",
		  	"es.typed-array.index-of",
		  	"es.typed-array.iterator",
		  	"es.typed-array.join",
		  	"es.typed-array.last-index-of",
		  	"es.typed-array.map",
		  	"es.typed-array.of",
		  	"es.typed-array.reduce",
		  	"es.typed-array.reduce-right",
		  	"es.typed-array.reverse",
		  	"es.typed-array.set",
		  	"es.typed-array.slice",
		  	"es.typed-array.some",
		  	"es.typed-array.sort",
		  	"es.typed-array.subarray",
		  	"es.typed-array.to-locale-string",
		  	"es.typed-array.to-reversed",
		  	"es.typed-array.to-sorted",
		  	"es.typed-array.to-string",
		  	"es.typed-array.with",
		  	"esnext.typed-array.from-async",
		  	"esnext.typed-array.at",
		  	"esnext.typed-array.filter-out",
		  	"esnext.typed-array.filter-reject",
		  	"esnext.typed-array.find-last",
		  	"esnext.typed-array.find-last-index",
		  	"esnext.typed-array.group-by",
		  	"esnext.typed-array.to-reversed",
		  	"esnext.typed-array.to-sorted",
		  	"esnext.typed-array.to-spliced",
		  	"esnext.typed-array.unique-by",
		  	"esnext.typed-array.with",
		  	"esnext.uint8-array.from-base64",
		  	"esnext.uint8-array.from-hex",
		  	"esnext.uint8-array.to-base64",
		  	"esnext.uint8-array.to-hex"
		  ],
		  	"core-js/full/typed-array/uint8-clamped-array": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.map",
		  	"es.object.to-string",
		  	"es.promise",
		  	"es.string.iterator",
		  	"es.typed-array.uint8-clamped-array",
		  	"es.typed-array.at",
		  	"es.typed-array.copy-within",
		  	"es.typed-array.every",
		  	"es.typed-array.fill",
		  	"es.typed-array.filter",
		  	"es.typed-array.find",
		  	"es.typed-array.find-index",
		  	"es.typed-array.find-last",
		  	"es.typed-array.find-last-index",
		  	"es.typed-array.for-each",
		  	"es.typed-array.from",
		  	"es.typed-array.includes",
		  	"es.typed-array.index-of",
		  	"es.typed-array.iterator",
		  	"es.typed-array.join",
		  	"es.typed-array.last-index-of",
		  	"es.typed-array.map",
		  	"es.typed-array.of",
		  	"es.typed-array.reduce",
		  	"es.typed-array.reduce-right",
		  	"es.typed-array.reverse",
		  	"es.typed-array.set",
		  	"es.typed-array.slice",
		  	"es.typed-array.some",
		  	"es.typed-array.sort",
		  	"es.typed-array.subarray",
		  	"es.typed-array.to-locale-string",
		  	"es.typed-array.to-reversed",
		  	"es.typed-array.to-sorted",
		  	"es.typed-array.to-string",
		  	"es.typed-array.with",
		  	"esnext.typed-array.from-async",
		  	"esnext.typed-array.at",
		  	"esnext.typed-array.filter-out",
		  	"esnext.typed-array.filter-reject",
		  	"esnext.typed-array.find-last",
		  	"esnext.typed-array.find-last-index",
		  	"esnext.typed-array.group-by",
		  	"esnext.typed-array.to-reversed",
		  	"esnext.typed-array.to-sorted",
		  	"esnext.typed-array.to-spliced",
		  	"esnext.typed-array.unique-by",
		  	"esnext.typed-array.with",
		  	"esnext.uint8-array.from-base64",
		  	"esnext.uint8-array.from-hex",
		  	"esnext.uint8-array.to-base64",
		  	"esnext.uint8-array.to-hex"
		  ],
		  	"core-js/full/typed-array/unique-by": [
		  	"es.map",
		  	"esnext.typed-array.unique-by"
		  ],
		  	"core-js/full/typed-array/values": [
		  	"es.object.to-string",
		  	"es.typed-array.iterator"
		  ],
		  	"core-js/full/typed-array/with": [
		  	"es.typed-array.with",
		  	"esnext.typed-array.with"
		  ],
		  	"core-js/full/unescape": [
		  	"es.unescape"
		  ],
		  	"core-js/full/url": [
		  	"web.url",
		  	"web.url.can-parse",
		  	"web.url.to-json",
		  	"web.url-search-params",
		  	"web.url-search-params.delete",
		  	"web.url-search-params.has",
		  	"web.url-search-params.size"
		  ],
		  	"core-js/full/url-search-params": [
		  	"web.dom-collections.iterator",
		  	"web.url-search-params",
		  	"web.url-search-params.delete",
		  	"web.url-search-params.has",
		  	"web.url-search-params.size"
		  ],
		  	"core-js/full/url/can-parse": [
		  	"web.url",
		  	"web.url.can-parse"
		  ],
		  	"core-js/full/url/to-json": [
		  	"web.url.to-json"
		  ],
		  	"core-js/full/weak-map": [
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"es.string.iterator",
		  	"es.weak-map",
		  	"esnext.weak-map.delete-all",
		  	"esnext.weak-map.from",
		  	"esnext.weak-map.of",
		  	"esnext.weak-map.emplace",
		  	"esnext.weak-map.upsert",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/full/weak-map/delete-all": [
		  	"es.weak-map",
		  	"esnext.weak-map.delete-all"
		  ],
		  	"core-js/full/weak-map/emplace": [
		  	"es.weak-map",
		  	"esnext.weak-map.emplace"
		  ],
		  	"core-js/full/weak-map/from": [
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"es.string.iterator",
		  	"es.weak-map",
		  	"esnext.weak-map.delete-all",
		  	"esnext.weak-map.from",
		  	"esnext.weak-map.emplace",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/full/weak-map/of": [
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"es.weak-map",
		  	"esnext.weak-map.delete-all",
		  	"esnext.weak-map.of",
		  	"esnext.weak-map.emplace"
		  ],
		  	"core-js/full/weak-map/upsert": [
		  	"es.weak-map",
		  	"esnext.weak-map.upsert"
		  ],
		  	"core-js/full/weak-set": [
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"es.string.iterator",
		  	"es.weak-set",
		  	"esnext.weak-set.add-all",
		  	"esnext.weak-set.delete-all",
		  	"esnext.weak-set.from",
		  	"esnext.weak-set.of",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/full/weak-set/add-all": [
		  	"es.weak-set",
		  	"esnext.weak-set.add-all"
		  ],
		  	"core-js/full/weak-set/delete-all": [
		  	"es.weak-set",
		  	"esnext.weak-set.delete-all"
		  ],
		  	"core-js/full/weak-set/from": [
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"es.string.iterator",
		  	"es.weak-set",
		  	"esnext.weak-set.add-all",
		  	"esnext.weak-set.delete-all",
		  	"esnext.weak-set.from",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/full/weak-set/of": [
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"es.weak-set",
		  	"esnext.weak-set.add-all",
		  	"esnext.weak-set.delete-all",
		  	"esnext.weak-set.of"
		  ],
		  	"core-js/modules/es.aggregate-error": [
		  	"es.aggregate-error"
		  ],
		  	"core-js/modules/es.aggregate-error.cause": [
		  	"es.aggregate-error.cause"
		  ],
		  	"core-js/modules/es.aggregate-error.constructor": [
		  	"es.aggregate-error.constructor"
		  ],
		  	"core-js/modules/es.array-buffer.constructor": [
		  	"es.array-buffer.constructor"
		  ],
		  	"core-js/modules/es.array-buffer.detached": [
		  	"es.array-buffer.detached"
		  ],
		  	"core-js/modules/es.array-buffer.is-view": [
		  	"es.array-buffer.is-view"
		  ],
		  	"core-js/modules/es.array-buffer.slice": [
		  	"es.array-buffer.slice"
		  ],
		  	"core-js/modules/es.array-buffer.transfer": [
		  	"es.array-buffer.transfer"
		  ],
		  	"core-js/modules/es.array-buffer.transfer-to-fixed-length": [
		  	"es.array-buffer.transfer-to-fixed-length"
		  ],
		  	"core-js/modules/es.array.at": [
		  	"es.array.at"
		  ],
		  	"core-js/modules/es.array.concat": [
		  	"es.array.concat"
		  ],
		  	"core-js/modules/es.array.copy-within": [
		  	"es.array.copy-within"
		  ],
		  	"core-js/modules/es.array.every": [
		  	"es.array.every"
		  ],
		  	"core-js/modules/es.array.fill": [
		  	"es.array.fill"
		  ],
		  	"core-js/modules/es.array.filter": [
		  	"es.array.filter"
		  ],
		  	"core-js/modules/es.array.find": [
		  	"es.array.find"
		  ],
		  	"core-js/modules/es.array.find-index": [
		  	"es.array.find-index"
		  ],
		  	"core-js/modules/es.array.find-last": [
		  	"es.array.find-last"
		  ],
		  	"core-js/modules/es.array.find-last-index": [
		  	"es.array.find-last-index"
		  ],
		  	"core-js/modules/es.array.flat": [
		  	"es.array.flat"
		  ],
		  	"core-js/modules/es.array.flat-map": [
		  	"es.array.flat-map"
		  ],
		  	"core-js/modules/es.array.for-each": [
		  	"es.array.for-each"
		  ],
		  	"core-js/modules/es.array.from": [
		  	"es.array.from"
		  ],
		  	"core-js/modules/es.array.includes": [
		  	"es.array.includes"
		  ],
		  	"core-js/modules/es.array.index-of": [
		  	"es.array.index-of"
		  ],
		  	"core-js/modules/es.array.is-array": [
		  	"es.array.is-array"
		  ],
		  	"core-js/modules/es.array.iterator": [
		  	"es.array.iterator"
		  ],
		  	"core-js/modules/es.array.join": [
		  	"es.array.join"
		  ],
		  	"core-js/modules/es.array.last-index-of": [
		  	"es.array.last-index-of"
		  ],
		  	"core-js/modules/es.array.map": [
		  	"es.array.map"
		  ],
		  	"core-js/modules/es.array.of": [
		  	"es.array.of"
		  ],
		  	"core-js/modules/es.array.push": [
		  	"es.array.push"
		  ],
		  	"core-js/modules/es.array.reduce": [
		  	"es.array.reduce"
		  ],
		  	"core-js/modules/es.array.reduce-right": [
		  	"es.array.reduce-right"
		  ],
		  	"core-js/modules/es.array.reverse": [
		  	"es.array.reverse"
		  ],
		  	"core-js/modules/es.array.slice": [
		  	"es.array.slice"
		  ],
		  	"core-js/modules/es.array.some": [
		  	"es.array.some"
		  ],
		  	"core-js/modules/es.array.sort": [
		  	"es.array.sort"
		  ],
		  	"core-js/modules/es.array.species": [
		  	"es.array.species"
		  ],
		  	"core-js/modules/es.array.splice": [
		  	"es.array.splice"
		  ],
		  	"core-js/modules/es.array.to-reversed": [
		  	"es.array.to-reversed"
		  ],
		  	"core-js/modules/es.array.to-sorted": [
		  	"es.array.to-sorted"
		  ],
		  	"core-js/modules/es.array.to-spliced": [
		  	"es.array.to-spliced"
		  ],
		  	"core-js/modules/es.array.unscopables.flat": [
		  	"es.array.unscopables.flat"
		  ],
		  	"core-js/modules/es.array.unscopables.flat-map": [
		  	"es.array.unscopables.flat-map"
		  ],
		  	"core-js/modules/es.array.unshift": [
		  	"es.array.unshift"
		  ],
		  	"core-js/modules/es.array.with": [
		  	"es.array.with"
		  ],
		  	"core-js/modules/es.data-view": [
		  	"es.data-view"
		  ],
		  	"core-js/modules/es.data-view.constructor": [
		  	"es.data-view.constructor"
		  ],
		  	"core-js/modules/es.date.get-year": [
		  	"es.date.get-year"
		  ],
		  	"core-js/modules/es.date.now": [
		  	"es.date.now"
		  ],
		  	"core-js/modules/es.date.set-year": [
		  	"es.date.set-year"
		  ],
		  	"core-js/modules/es.date.to-gmt-string": [
		  	"es.date.to-gmt-string"
		  ],
		  	"core-js/modules/es.date.to-iso-string": [
		  	"es.date.to-iso-string"
		  ],
		  	"core-js/modules/es.date.to-json": [
		  	"es.date.to-json"
		  ],
		  	"core-js/modules/es.date.to-primitive": [
		  	"es.date.to-primitive"
		  ],
		  	"core-js/modules/es.date.to-string": [
		  	"es.date.to-string"
		  ],
		  	"core-js/modules/es.error.cause": [
		  	"es.error.cause"
		  ],
		  	"core-js/modules/es.error.to-string": [
		  	"es.error.to-string"
		  ],
		  	"core-js/modules/es.escape": [
		  	"es.escape"
		  ],
		  	"core-js/modules/es.function.bind": [
		  	"es.function.bind"
		  ],
		  	"core-js/modules/es.function.has-instance": [
		  	"es.function.has-instance"
		  ],
		  	"core-js/modules/es.function.name": [
		  	"es.function.name"
		  ],
		  	"core-js/modules/es.global-this": [
		  	"es.global-this"
		  ],
		  	"core-js/modules/es.json.stringify": [
		  	"es.json.stringify"
		  ],
		  	"core-js/modules/es.json.to-string-tag": [
		  	"es.json.to-string-tag"
		  ],
		  	"core-js/modules/es.map": [
		  	"es.map"
		  ],
		  	"core-js/modules/es.map.constructor": [
		  	"es.map.constructor"
		  ],
		  	"core-js/modules/es.map.group-by": [
		  	"es.map.group-by"
		  ],
		  	"core-js/modules/es.math.acosh": [
		  	"es.math.acosh"
		  ],
		  	"core-js/modules/es.math.asinh": [
		  	"es.math.asinh"
		  ],
		  	"core-js/modules/es.math.atanh": [
		  	"es.math.atanh"
		  ],
		  	"core-js/modules/es.math.cbrt": [
		  	"es.math.cbrt"
		  ],
		  	"core-js/modules/es.math.clz32": [
		  	"es.math.clz32"
		  ],
		  	"core-js/modules/es.math.cosh": [
		  	"es.math.cosh"
		  ],
		  	"core-js/modules/es.math.expm1": [
		  	"es.math.expm1"
		  ],
		  	"core-js/modules/es.math.fround": [
		  	"es.math.fround"
		  ],
		  	"core-js/modules/es.math.hypot": [
		  	"es.math.hypot"
		  ],
		  	"core-js/modules/es.math.imul": [
		  	"es.math.imul"
		  ],
		  	"core-js/modules/es.math.log10": [
		  	"es.math.log10"
		  ],
		  	"core-js/modules/es.math.log1p": [
		  	"es.math.log1p"
		  ],
		  	"core-js/modules/es.math.log2": [
		  	"es.math.log2"
		  ],
		  	"core-js/modules/es.math.sign": [
		  	"es.math.sign"
		  ],
		  	"core-js/modules/es.math.sinh": [
		  	"es.math.sinh"
		  ],
		  	"core-js/modules/es.math.tanh": [
		  	"es.math.tanh"
		  ],
		  	"core-js/modules/es.math.to-string-tag": [
		  	"es.math.to-string-tag"
		  ],
		  	"core-js/modules/es.math.trunc": [
		  	"es.math.trunc"
		  ],
		  	"core-js/modules/es.number.constructor": [
		  	"es.number.constructor"
		  ],
		  	"core-js/modules/es.number.epsilon": [
		  	"es.number.epsilon"
		  ],
		  	"core-js/modules/es.number.is-finite": [
		  	"es.number.is-finite"
		  ],
		  	"core-js/modules/es.number.is-integer": [
		  	"es.number.is-integer"
		  ],
		  	"core-js/modules/es.number.is-nan": [
		  	"es.number.is-nan"
		  ],
		  	"core-js/modules/es.number.is-safe-integer": [
		  	"es.number.is-safe-integer"
		  ],
		  	"core-js/modules/es.number.max-safe-integer": [
		  	"es.number.max-safe-integer"
		  ],
		  	"core-js/modules/es.number.min-safe-integer": [
		  	"es.number.min-safe-integer"
		  ],
		  	"core-js/modules/es.number.parse-float": [
		  	"es.number.parse-float"
		  ],
		  	"core-js/modules/es.number.parse-int": [
		  	"es.number.parse-int"
		  ],
		  	"core-js/modules/es.number.to-exponential": [
		  	"es.number.to-exponential"
		  ],
		  	"core-js/modules/es.number.to-fixed": [
		  	"es.number.to-fixed"
		  ],
		  	"core-js/modules/es.number.to-precision": [
		  	"es.number.to-precision"
		  ],
		  	"core-js/modules/es.object.assign": [
		  	"es.object.assign"
		  ],
		  	"core-js/modules/es.object.create": [
		  	"es.object.create"
		  ],
		  	"core-js/modules/es.object.define-getter": [
		  	"es.object.define-getter"
		  ],
		  	"core-js/modules/es.object.define-properties": [
		  	"es.object.define-properties"
		  ],
		  	"core-js/modules/es.object.define-property": [
		  	"es.object.define-property"
		  ],
		  	"core-js/modules/es.object.define-setter": [
		  	"es.object.define-setter"
		  ],
		  	"core-js/modules/es.object.entries": [
		  	"es.object.entries"
		  ],
		  	"core-js/modules/es.object.freeze": [
		  	"es.object.freeze"
		  ],
		  	"core-js/modules/es.object.from-entries": [
		  	"es.object.from-entries"
		  ],
		  	"core-js/modules/es.object.get-own-property-descriptor": [
		  	"es.object.get-own-property-descriptor"
		  ],
		  	"core-js/modules/es.object.get-own-property-descriptors": [
		  	"es.object.get-own-property-descriptors"
		  ],
		  	"core-js/modules/es.object.get-own-property-names": [
		  	"es.object.get-own-property-names"
		  ],
		  	"core-js/modules/es.object.get-own-property-symbols": [
		  	"es.object.get-own-property-symbols"
		  ],
		  	"core-js/modules/es.object.get-prototype-of": [
		  	"es.object.get-prototype-of"
		  ],
		  	"core-js/modules/es.object.group-by": [
		  	"es.object.group-by"
		  ],
		  	"core-js/modules/es.object.has-own": [
		  	"es.object.has-own"
		  ],
		  	"core-js/modules/es.object.is": [
		  	"es.object.is"
		  ],
		  	"core-js/modules/es.object.is-extensible": [
		  	"es.object.is-extensible"
		  ],
		  	"core-js/modules/es.object.is-frozen": [
		  	"es.object.is-frozen"
		  ],
		  	"core-js/modules/es.object.is-sealed": [
		  	"es.object.is-sealed"
		  ],
		  	"core-js/modules/es.object.keys": [
		  	"es.object.keys"
		  ],
		  	"core-js/modules/es.object.lookup-getter": [
		  	"es.object.lookup-getter"
		  ],
		  	"core-js/modules/es.object.lookup-setter": [
		  	"es.object.lookup-setter"
		  ],
		  	"core-js/modules/es.object.prevent-extensions": [
		  	"es.object.prevent-extensions"
		  ],
		  	"core-js/modules/es.object.proto": [
		  	"es.object.proto"
		  ],
		  	"core-js/modules/es.object.seal": [
		  	"es.object.seal"
		  ],
		  	"core-js/modules/es.object.set-prototype-of": [
		  	"es.object.set-prototype-of"
		  ],
		  	"core-js/modules/es.object.to-string": [
		  	"es.object.to-string"
		  ],
		  	"core-js/modules/es.object.values": [
		  	"es.object.values"
		  ],
		  	"core-js/modules/es.parse-float": [
		  	"es.parse-float"
		  ],
		  	"core-js/modules/es.parse-int": [
		  	"es.parse-int"
		  ],
		  	"core-js/modules/es.promise": [
		  	"es.promise"
		  ],
		  	"core-js/modules/es.promise.all": [
		  	"es.promise.all"
		  ],
		  	"core-js/modules/es.promise.all-settled": [
		  	"es.promise.all-settled"
		  ],
		  	"core-js/modules/es.promise.any": [
		  	"es.promise.any"
		  ],
		  	"core-js/modules/es.promise.catch": [
		  	"es.promise.catch"
		  ],
		  	"core-js/modules/es.promise.constructor": [
		  	"es.promise.constructor"
		  ],
		  	"core-js/modules/es.promise.finally": [
		  	"es.promise.finally"
		  ],
		  	"core-js/modules/es.promise.race": [
		  	"es.promise.race"
		  ],
		  	"core-js/modules/es.promise.reject": [
		  	"es.promise.reject"
		  ],
		  	"core-js/modules/es.promise.resolve": [
		  	"es.promise.resolve"
		  ],
		  	"core-js/modules/es.promise.with-resolvers": [
		  	"es.promise.with-resolvers"
		  ],
		  	"core-js/modules/es.reflect.apply": [
		  	"es.reflect.apply"
		  ],
		  	"core-js/modules/es.reflect.construct": [
		  	"es.reflect.construct"
		  ],
		  	"core-js/modules/es.reflect.define-property": [
		  	"es.reflect.define-property"
		  ],
		  	"core-js/modules/es.reflect.delete-property": [
		  	"es.reflect.delete-property"
		  ],
		  	"core-js/modules/es.reflect.get": [
		  	"es.reflect.get"
		  ],
		  	"core-js/modules/es.reflect.get-own-property-descriptor": [
		  	"es.reflect.get-own-property-descriptor"
		  ],
		  	"core-js/modules/es.reflect.get-prototype-of": [
		  	"es.reflect.get-prototype-of"
		  ],
		  	"core-js/modules/es.reflect.has": [
		  	"es.reflect.has"
		  ],
		  	"core-js/modules/es.reflect.is-extensible": [
		  	"es.reflect.is-extensible"
		  ],
		  	"core-js/modules/es.reflect.own-keys": [
		  	"es.reflect.own-keys"
		  ],
		  	"core-js/modules/es.reflect.prevent-extensions": [
		  	"es.reflect.prevent-extensions"
		  ],
		  	"core-js/modules/es.reflect.set": [
		  	"es.reflect.set"
		  ],
		  	"core-js/modules/es.reflect.set-prototype-of": [
		  	"es.reflect.set-prototype-of"
		  ],
		  	"core-js/modules/es.reflect.to-string-tag": [
		  	"es.reflect.to-string-tag"
		  ],
		  	"core-js/modules/es.regexp.constructor": [
		  	"es.regexp.constructor"
		  ],
		  	"core-js/modules/es.regexp.dot-all": [
		  	"es.regexp.dot-all"
		  ],
		  	"core-js/modules/es.regexp.exec": [
		  	"es.regexp.exec"
		  ],
		  	"core-js/modules/es.regexp.flags": [
		  	"es.regexp.flags"
		  ],
		  	"core-js/modules/es.regexp.sticky": [
		  	"es.regexp.sticky"
		  ],
		  	"core-js/modules/es.regexp.test": [
		  	"es.regexp.test"
		  ],
		  	"core-js/modules/es.regexp.to-string": [
		  	"es.regexp.to-string"
		  ],
		  	"core-js/modules/es.set": [
		  	"es.set"
		  ],
		  	"core-js/modules/es.set.constructor": [
		  	"es.set.constructor"
		  ],
		  	"core-js/modules/es.string.anchor": [
		  	"es.string.anchor"
		  ],
		  	"core-js/modules/es.string.at-alternative": [
		  	"es.string.at-alternative"
		  ],
		  	"core-js/modules/es.string.big": [
		  	"es.string.big"
		  ],
		  	"core-js/modules/es.string.blink": [
		  	"es.string.blink"
		  ],
		  	"core-js/modules/es.string.bold": [
		  	"es.string.bold"
		  ],
		  	"core-js/modules/es.string.code-point-at": [
		  	"es.string.code-point-at"
		  ],
		  	"core-js/modules/es.string.ends-with": [
		  	"es.string.ends-with"
		  ],
		  	"core-js/modules/es.string.fixed": [
		  	"es.string.fixed"
		  ],
		  	"core-js/modules/es.string.fontcolor": [
		  	"es.string.fontcolor"
		  ],
		  	"core-js/modules/es.string.fontsize": [
		  	"es.string.fontsize"
		  ],
		  	"core-js/modules/es.string.from-code-point": [
		  	"es.string.from-code-point"
		  ],
		  	"core-js/modules/es.string.includes": [
		  	"es.string.includes"
		  ],
		  	"core-js/modules/es.string.is-well-formed": [
		  	"es.string.is-well-formed"
		  ],
		  	"core-js/modules/es.string.italics": [
		  	"es.string.italics"
		  ],
		  	"core-js/modules/es.string.iterator": [
		  	"es.string.iterator"
		  ],
		  	"core-js/modules/es.string.link": [
		  	"es.string.link"
		  ],
		  	"core-js/modules/es.string.match": [
		  	"es.string.match"
		  ],
		  	"core-js/modules/es.string.match-all": [
		  	"es.string.match-all"
		  ],
		  	"core-js/modules/es.string.pad-end": [
		  	"es.string.pad-end"
		  ],
		  	"core-js/modules/es.string.pad-start": [
		  	"es.string.pad-start"
		  ],
		  	"core-js/modules/es.string.raw": [
		  	"es.string.raw"
		  ],
		  	"core-js/modules/es.string.repeat": [
		  	"es.string.repeat"
		  ],
		  	"core-js/modules/es.string.replace": [
		  	"es.string.replace"
		  ],
		  	"core-js/modules/es.string.replace-all": [
		  	"es.string.replace-all"
		  ],
		  	"core-js/modules/es.string.search": [
		  	"es.string.search"
		  ],
		  	"core-js/modules/es.string.small": [
		  	"es.string.small"
		  ],
		  	"core-js/modules/es.string.split": [
		  	"es.string.split"
		  ],
		  	"core-js/modules/es.string.starts-with": [
		  	"es.string.starts-with"
		  ],
		  	"core-js/modules/es.string.strike": [
		  	"es.string.strike"
		  ],
		  	"core-js/modules/es.string.sub": [
		  	"es.string.sub"
		  ],
		  	"core-js/modules/es.string.substr": [
		  	"es.string.substr"
		  ],
		  	"core-js/modules/es.string.sup": [
		  	"es.string.sup"
		  ],
		  	"core-js/modules/es.string.to-well-formed": [
		  	"es.string.to-well-formed"
		  ],
		  	"core-js/modules/es.string.trim": [
		  	"es.string.trim"
		  ],
		  	"core-js/modules/es.string.trim-end": [
		  	"es.string.trim-end"
		  ],
		  	"core-js/modules/es.string.trim-left": [
		  	"es.string.trim-left"
		  ],
		  	"core-js/modules/es.string.trim-right": [
		  	"es.string.trim-right"
		  ],
		  	"core-js/modules/es.string.trim-start": [
		  	"es.string.trim-start"
		  ],
		  	"core-js/modules/es.symbol": [
		  	"es.symbol"
		  ],
		  	"core-js/modules/es.symbol.async-iterator": [
		  	"es.symbol.async-iterator"
		  ],
		  	"core-js/modules/es.symbol.constructor": [
		  	"es.symbol.constructor"
		  ],
		  	"core-js/modules/es.symbol.description": [
		  	"es.symbol.description"
		  ],
		  	"core-js/modules/es.symbol.for": [
		  	"es.symbol.for"
		  ],
		  	"core-js/modules/es.symbol.has-instance": [
		  	"es.symbol.has-instance"
		  ],
		  	"core-js/modules/es.symbol.is-concat-spreadable": [
		  	"es.symbol.is-concat-spreadable"
		  ],
		  	"core-js/modules/es.symbol.iterator": [
		  	"es.symbol.iterator"
		  ],
		  	"core-js/modules/es.symbol.key-for": [
		  	"es.symbol.key-for"
		  ],
		  	"core-js/modules/es.symbol.match": [
		  	"es.symbol.match"
		  ],
		  	"core-js/modules/es.symbol.match-all": [
		  	"es.symbol.match-all"
		  ],
		  	"core-js/modules/es.symbol.replace": [
		  	"es.symbol.replace"
		  ],
		  	"core-js/modules/es.symbol.search": [
		  	"es.symbol.search"
		  ],
		  	"core-js/modules/es.symbol.species": [
		  	"es.symbol.species"
		  ],
		  	"core-js/modules/es.symbol.split": [
		  	"es.symbol.split"
		  ],
		  	"core-js/modules/es.symbol.to-primitive": [
		  	"es.symbol.to-primitive"
		  ],
		  	"core-js/modules/es.symbol.to-string-tag": [
		  	"es.symbol.to-string-tag"
		  ],
		  	"core-js/modules/es.symbol.unscopables": [
		  	"es.symbol.unscopables"
		  ],
		  	"core-js/modules/es.typed-array.at": [
		  	"es.typed-array.at"
		  ],
		  	"core-js/modules/es.typed-array.copy-within": [
		  	"es.typed-array.copy-within"
		  ],
		  	"core-js/modules/es.typed-array.every": [
		  	"es.typed-array.every"
		  ],
		  	"core-js/modules/es.typed-array.fill": [
		  	"es.typed-array.fill"
		  ],
		  	"core-js/modules/es.typed-array.filter": [
		  	"es.typed-array.filter"
		  ],
		  	"core-js/modules/es.typed-array.find": [
		  	"es.typed-array.find"
		  ],
		  	"core-js/modules/es.typed-array.find-index": [
		  	"es.typed-array.find-index"
		  ],
		  	"core-js/modules/es.typed-array.find-last": [
		  	"es.typed-array.find-last"
		  ],
		  	"core-js/modules/es.typed-array.find-last-index": [
		  	"es.typed-array.find-last-index"
		  ],
		  	"core-js/modules/es.typed-array.float32-array": [
		  	"es.typed-array.float32-array"
		  ],
		  	"core-js/modules/es.typed-array.float64-array": [
		  	"es.typed-array.float64-array"
		  ],
		  	"core-js/modules/es.typed-array.for-each": [
		  	"es.typed-array.for-each"
		  ],
		  	"core-js/modules/es.typed-array.from": [
		  	"es.typed-array.from"
		  ],
		  	"core-js/modules/es.typed-array.includes": [
		  	"es.typed-array.includes"
		  ],
		  	"core-js/modules/es.typed-array.index-of": [
		  	"es.typed-array.index-of"
		  ],
		  	"core-js/modules/es.typed-array.int16-array": [
		  	"es.typed-array.int16-array"
		  ],
		  	"core-js/modules/es.typed-array.int32-array": [
		  	"es.typed-array.int32-array"
		  ],
		  	"core-js/modules/es.typed-array.int8-array": [
		  	"es.typed-array.int8-array"
		  ],
		  	"core-js/modules/es.typed-array.iterator": [
		  	"es.typed-array.iterator"
		  ],
		  	"core-js/modules/es.typed-array.join": [
		  	"es.typed-array.join"
		  ],
		  	"core-js/modules/es.typed-array.last-index-of": [
		  	"es.typed-array.last-index-of"
		  ],
		  	"core-js/modules/es.typed-array.map": [
		  	"es.typed-array.map"
		  ],
		  	"core-js/modules/es.typed-array.of": [
		  	"es.typed-array.of"
		  ],
		  	"core-js/modules/es.typed-array.reduce": [
		  	"es.typed-array.reduce"
		  ],
		  	"core-js/modules/es.typed-array.reduce-right": [
		  	"es.typed-array.reduce-right"
		  ],
		  	"core-js/modules/es.typed-array.reverse": [
		  	"es.typed-array.reverse"
		  ],
		  	"core-js/modules/es.typed-array.set": [
		  	"es.typed-array.set"
		  ],
		  	"core-js/modules/es.typed-array.slice": [
		  	"es.typed-array.slice"
		  ],
		  	"core-js/modules/es.typed-array.some": [
		  	"es.typed-array.some"
		  ],
		  	"core-js/modules/es.typed-array.sort": [
		  	"es.typed-array.sort"
		  ],
		  	"core-js/modules/es.typed-array.subarray": [
		  	"es.typed-array.subarray"
		  ],
		  	"core-js/modules/es.typed-array.to-locale-string": [
		  	"es.typed-array.to-locale-string"
		  ],
		  	"core-js/modules/es.typed-array.to-reversed": [
		  	"es.typed-array.to-reversed"
		  ],
		  	"core-js/modules/es.typed-array.to-sorted": [
		  	"es.typed-array.to-sorted"
		  ],
		  	"core-js/modules/es.typed-array.to-string": [
		  	"es.typed-array.to-string"
		  ],
		  	"core-js/modules/es.typed-array.uint16-array": [
		  	"es.typed-array.uint16-array"
		  ],
		  	"core-js/modules/es.typed-array.uint32-array": [
		  	"es.typed-array.uint32-array"
		  ],
		  	"core-js/modules/es.typed-array.uint8-array": [
		  	"es.typed-array.uint8-array"
		  ],
		  	"core-js/modules/es.typed-array.uint8-clamped-array": [
		  	"es.typed-array.uint8-clamped-array"
		  ],
		  	"core-js/modules/es.typed-array.with": [
		  	"es.typed-array.with"
		  ],
		  	"core-js/modules/es.unescape": [
		  	"es.unescape"
		  ],
		  	"core-js/modules/es.weak-map": [
		  	"es.weak-map"
		  ],
		  	"core-js/modules/es.weak-map.constructor": [
		  	"es.weak-map.constructor"
		  ],
		  	"core-js/modules/es.weak-set": [
		  	"es.weak-set"
		  ],
		  	"core-js/modules/es.weak-set.constructor": [
		  	"es.weak-set.constructor"
		  ],
		  	"core-js/modules/esnext.aggregate-error": [
		  	"esnext.aggregate-error"
		  ],
		  	"core-js/modules/esnext.array-buffer.detached": [
		  	"esnext.array-buffer.detached"
		  ],
		  	"core-js/modules/esnext.array-buffer.transfer": [
		  	"esnext.array-buffer.transfer"
		  ],
		  	"core-js/modules/esnext.array-buffer.transfer-to-fixed-length": [
		  	"esnext.array-buffer.transfer-to-fixed-length"
		  ],
		  	"core-js/modules/esnext.array.at": [
		  	"esnext.array.at"
		  ],
		  	"core-js/modules/esnext.array.filter-out": [
		  	"esnext.array.filter-out"
		  ],
		  	"core-js/modules/esnext.array.filter-reject": [
		  	"esnext.array.filter-reject"
		  ],
		  	"core-js/modules/esnext.array.find-last": [
		  	"esnext.array.find-last"
		  ],
		  	"core-js/modules/esnext.array.find-last-index": [
		  	"esnext.array.find-last-index"
		  ],
		  	"core-js/modules/esnext.array.from-async": [
		  	"esnext.array.from-async"
		  ],
		  	"core-js/modules/esnext.array.group": [
		  	"esnext.array.group"
		  ],
		  	"core-js/modules/esnext.array.group-by": [
		  	"esnext.array.group-by"
		  ],
		  	"core-js/modules/esnext.array.group-by-to-map": [
		  	"esnext.array.group-by-to-map"
		  ],
		  	"core-js/modules/esnext.array.group-to-map": [
		  	"esnext.array.group-to-map"
		  ],
		  	"core-js/modules/esnext.array.is-template-object": [
		  	"esnext.array.is-template-object"
		  ],
		  	"core-js/modules/esnext.array.last-index": [
		  	"esnext.array.last-index"
		  ],
		  	"core-js/modules/esnext.array.last-item": [
		  	"esnext.array.last-item"
		  ],
		  	"core-js/modules/esnext.array.to-reversed": [
		  	"esnext.array.to-reversed"
		  ],
		  	"core-js/modules/esnext.array.to-sorted": [
		  	"esnext.array.to-sorted"
		  ],
		  	"core-js/modules/esnext.array.to-spliced": [
		  	"esnext.array.to-spliced"
		  ],
		  	"core-js/modules/esnext.array.unique-by": [
		  	"esnext.array.unique-by"
		  ],
		  	"core-js/modules/esnext.array.with": [
		  	"esnext.array.with"
		  ],
		  	"core-js/modules/esnext.async-disposable-stack.constructor": [
		  	"esnext.async-disposable-stack.constructor"
		  ],
		  	"core-js/modules/esnext.async-iterator.as-indexed-pairs": [
		  	"esnext.async-iterator.as-indexed-pairs"
		  ],
		  	"core-js/modules/esnext.async-iterator.async-dispose": [
		  	"esnext.async-iterator.async-dispose"
		  ],
		  	"core-js/modules/esnext.async-iterator.constructor": [
		  	"esnext.async-iterator.constructor"
		  ],
		  	"core-js/modules/esnext.async-iterator.drop": [
		  	"esnext.async-iterator.drop"
		  ],
		  	"core-js/modules/esnext.async-iterator.every": [
		  	"esnext.async-iterator.every"
		  ],
		  	"core-js/modules/esnext.async-iterator.filter": [
		  	"esnext.async-iterator.filter"
		  ],
		  	"core-js/modules/esnext.async-iterator.find": [
		  	"esnext.async-iterator.find"
		  ],
		  	"core-js/modules/esnext.async-iterator.flat-map": [
		  	"esnext.async-iterator.flat-map"
		  ],
		  	"core-js/modules/esnext.async-iterator.for-each": [
		  	"esnext.async-iterator.for-each"
		  ],
		  	"core-js/modules/esnext.async-iterator.from": [
		  	"esnext.async-iterator.from"
		  ],
		  	"core-js/modules/esnext.async-iterator.indexed": [
		  	"esnext.async-iterator.indexed"
		  ],
		  	"core-js/modules/esnext.async-iterator.map": [
		  	"esnext.async-iterator.map"
		  ],
		  	"core-js/modules/esnext.async-iterator.reduce": [
		  	"esnext.async-iterator.reduce"
		  ],
		  	"core-js/modules/esnext.async-iterator.some": [
		  	"esnext.async-iterator.some"
		  ],
		  	"core-js/modules/esnext.async-iterator.take": [
		  	"esnext.async-iterator.take"
		  ],
		  	"core-js/modules/esnext.async-iterator.to-array": [
		  	"esnext.async-iterator.to-array"
		  ],
		  	"core-js/modules/esnext.bigint.range": [
		  	"esnext.bigint.range"
		  ],
		  	"core-js/modules/esnext.composite-key": [
		  	"esnext.composite-key"
		  ],
		  	"core-js/modules/esnext.composite-symbol": [
		  	"esnext.composite-symbol"
		  ],
		  	"core-js/modules/esnext.data-view.get-float16": [
		  	"esnext.data-view.get-float16"
		  ],
		  	"core-js/modules/esnext.data-view.get-uint8-clamped": [
		  	"esnext.data-view.get-uint8-clamped"
		  ],
		  	"core-js/modules/esnext.data-view.set-float16": [
		  	"esnext.data-view.set-float16"
		  ],
		  	"core-js/modules/esnext.data-view.set-uint8-clamped": [
		  	"esnext.data-view.set-uint8-clamped"
		  ],
		  	"core-js/modules/esnext.disposable-stack.constructor": [
		  	"esnext.disposable-stack.constructor"
		  ],
		  	"core-js/modules/esnext.function.demethodize": [
		  	"esnext.function.demethodize"
		  ],
		  	"core-js/modules/esnext.function.is-callable": [
		  	"esnext.function.is-callable"
		  ],
		  	"core-js/modules/esnext.function.is-constructor": [
		  	"esnext.function.is-constructor"
		  ],
		  	"core-js/modules/esnext.function.metadata": [
		  	"esnext.function.metadata"
		  ],
		  	"core-js/modules/esnext.function.un-this": [
		  	"esnext.function.un-this"
		  ],
		  	"core-js/modules/esnext.global-this": [
		  	"esnext.global-this"
		  ],
		  	"core-js/modules/esnext.iterator.as-indexed-pairs": [
		  	"esnext.iterator.as-indexed-pairs"
		  ],
		  	"core-js/modules/esnext.iterator.constructor": [
		  	"esnext.iterator.constructor"
		  ],
		  	"core-js/modules/esnext.iterator.dispose": [
		  	"esnext.iterator.dispose"
		  ],
		  	"core-js/modules/esnext.iterator.drop": [
		  	"esnext.iterator.drop"
		  ],
		  	"core-js/modules/esnext.iterator.every": [
		  	"esnext.iterator.every"
		  ],
		  	"core-js/modules/esnext.iterator.filter": [
		  	"esnext.iterator.filter"
		  ],
		  	"core-js/modules/esnext.iterator.find": [
		  	"esnext.iterator.find"
		  ],
		  	"core-js/modules/esnext.iterator.flat-map": [
		  	"esnext.iterator.flat-map"
		  ],
		  	"core-js/modules/esnext.iterator.for-each": [
		  	"esnext.iterator.for-each"
		  ],
		  	"core-js/modules/esnext.iterator.from": [
		  	"esnext.iterator.from"
		  ],
		  	"core-js/modules/esnext.iterator.indexed": [
		  	"esnext.iterator.indexed"
		  ],
		  	"core-js/modules/esnext.iterator.map": [
		  	"esnext.iterator.map"
		  ],
		  	"core-js/modules/esnext.iterator.range": [
		  	"esnext.iterator.range"
		  ],
		  	"core-js/modules/esnext.iterator.reduce": [
		  	"esnext.iterator.reduce"
		  ],
		  	"core-js/modules/esnext.iterator.some": [
		  	"esnext.iterator.some"
		  ],
		  	"core-js/modules/esnext.iterator.take": [
		  	"esnext.iterator.take"
		  ],
		  	"core-js/modules/esnext.iterator.to-array": [
		  	"esnext.iterator.to-array"
		  ],
		  	"core-js/modules/esnext.iterator.to-async": [
		  	"esnext.iterator.to-async"
		  ],
		  	"core-js/modules/esnext.json.is-raw-json": [
		  	"esnext.json.is-raw-json"
		  ],
		  	"core-js/modules/esnext.json.parse": [
		  	"esnext.json.parse"
		  ],
		  	"core-js/modules/esnext.json.raw-json": [
		  	"esnext.json.raw-json"
		  ],
		  	"core-js/modules/esnext.map.delete-all": [
		  	"esnext.map.delete-all"
		  ],
		  	"core-js/modules/esnext.map.emplace": [
		  	"esnext.map.emplace"
		  ],
		  	"core-js/modules/esnext.map.every": [
		  	"esnext.map.every"
		  ],
		  	"core-js/modules/esnext.map.filter": [
		  	"esnext.map.filter"
		  ],
		  	"core-js/modules/esnext.map.find": [
		  	"esnext.map.find"
		  ],
		  	"core-js/modules/esnext.map.find-key": [
		  	"esnext.map.find-key"
		  ],
		  	"core-js/modules/esnext.map.from": [
		  	"esnext.map.from"
		  ],
		  	"core-js/modules/esnext.map.group-by": [
		  	"esnext.map.group-by"
		  ],
		  	"core-js/modules/esnext.map.includes": [
		  	"esnext.map.includes"
		  ],
		  	"core-js/modules/esnext.map.key-by": [
		  	"esnext.map.key-by"
		  ],
		  	"core-js/modules/esnext.map.key-of": [
		  	"esnext.map.key-of"
		  ],
		  	"core-js/modules/esnext.map.map-keys": [
		  	"esnext.map.map-keys"
		  ],
		  	"core-js/modules/esnext.map.map-values": [
		  	"esnext.map.map-values"
		  ],
		  	"core-js/modules/esnext.map.merge": [
		  	"esnext.map.merge"
		  ],
		  	"core-js/modules/esnext.map.of": [
		  	"esnext.map.of"
		  ],
		  	"core-js/modules/esnext.map.reduce": [
		  	"esnext.map.reduce"
		  ],
		  	"core-js/modules/esnext.map.some": [
		  	"esnext.map.some"
		  ],
		  	"core-js/modules/esnext.map.update": [
		  	"esnext.map.update"
		  ],
		  	"core-js/modules/esnext.map.update-or-insert": [
		  	"esnext.map.update-or-insert"
		  ],
		  	"core-js/modules/esnext.map.upsert": [
		  	"esnext.map.upsert"
		  ],
		  	"core-js/modules/esnext.math.clamp": [
		  	"esnext.math.clamp"
		  ],
		  	"core-js/modules/esnext.math.deg-per-rad": [
		  	"esnext.math.deg-per-rad"
		  ],
		  	"core-js/modules/esnext.math.degrees": [
		  	"esnext.math.degrees"
		  ],
		  	"core-js/modules/esnext.math.f16round": [
		  	"esnext.math.f16round"
		  ],
		  	"core-js/modules/esnext.math.fscale": [
		  	"esnext.math.fscale"
		  ],
		  	"core-js/modules/esnext.math.iaddh": [
		  	"esnext.math.iaddh"
		  ],
		  	"core-js/modules/esnext.math.imulh": [
		  	"esnext.math.imulh"
		  ],
		  	"core-js/modules/esnext.math.isubh": [
		  	"esnext.math.isubh"
		  ],
		  	"core-js/modules/esnext.math.rad-per-deg": [
		  	"esnext.math.rad-per-deg"
		  ],
		  	"core-js/modules/esnext.math.radians": [
		  	"esnext.math.radians"
		  ],
		  	"core-js/modules/esnext.math.scale": [
		  	"esnext.math.scale"
		  ],
		  	"core-js/modules/esnext.math.seeded-prng": [
		  	"esnext.math.seeded-prng"
		  ],
		  	"core-js/modules/esnext.math.signbit": [
		  	"esnext.math.signbit"
		  ],
		  	"core-js/modules/esnext.math.umulh": [
		  	"esnext.math.umulh"
		  ],
		  	"core-js/modules/esnext.number.from-string": [
		  	"esnext.number.from-string"
		  ],
		  	"core-js/modules/esnext.number.range": [
		  	"esnext.number.range"
		  ],
		  	"core-js/modules/esnext.object.group-by": [
		  	"esnext.object.group-by"
		  ],
		  	"core-js/modules/esnext.object.has-own": [
		  	"esnext.object.has-own"
		  ],
		  	"core-js/modules/esnext.object.iterate-entries": [
		  	"esnext.object.iterate-entries"
		  ],
		  	"core-js/modules/esnext.object.iterate-keys": [
		  	"esnext.object.iterate-keys"
		  ],
		  	"core-js/modules/esnext.object.iterate-values": [
		  	"esnext.object.iterate-values"
		  ],
		  	"core-js/modules/esnext.observable": [
		  	"esnext.observable"
		  ],
		  	"core-js/modules/esnext.observable.constructor": [
		  	"esnext.observable.constructor"
		  ],
		  	"core-js/modules/esnext.observable.from": [
		  	"esnext.observable.from"
		  ],
		  	"core-js/modules/esnext.observable.of": [
		  	"esnext.observable.of"
		  ],
		  	"core-js/modules/esnext.promise.all-settled": [
		  	"esnext.promise.all-settled"
		  ],
		  	"core-js/modules/esnext.promise.any": [
		  	"esnext.promise.any"
		  ],
		  	"core-js/modules/esnext.promise.try": [
		  	"esnext.promise.try"
		  ],
		  	"core-js/modules/esnext.promise.with-resolvers": [
		  	"esnext.promise.with-resolvers"
		  ],
		  	"core-js/modules/esnext.reflect.define-metadata": [
		  	"esnext.reflect.define-metadata"
		  ],
		  	"core-js/modules/esnext.reflect.delete-metadata": [
		  	"esnext.reflect.delete-metadata"
		  ],
		  	"core-js/modules/esnext.reflect.get-metadata": [
		  	"esnext.reflect.get-metadata"
		  ],
		  	"core-js/modules/esnext.reflect.get-metadata-keys": [
		  	"esnext.reflect.get-metadata-keys"
		  ],
		  	"core-js/modules/esnext.reflect.get-own-metadata": [
		  	"esnext.reflect.get-own-metadata"
		  ],
		  	"core-js/modules/esnext.reflect.get-own-metadata-keys": [
		  	"esnext.reflect.get-own-metadata-keys"
		  ],
		  	"core-js/modules/esnext.reflect.has-metadata": [
		  	"esnext.reflect.has-metadata"
		  ],
		  	"core-js/modules/esnext.reflect.has-own-metadata": [
		  	"esnext.reflect.has-own-metadata"
		  ],
		  	"core-js/modules/esnext.reflect.metadata": [
		  	"esnext.reflect.metadata"
		  ],
		  	"core-js/modules/esnext.regexp.escape": [
		  	"esnext.regexp.escape"
		  ],
		  	"core-js/modules/esnext.set.add-all": [
		  	"esnext.set.add-all"
		  ],
		  	"core-js/modules/esnext.set.delete-all": [
		  	"esnext.set.delete-all"
		  ],
		  	"core-js/modules/esnext.set.difference": [
		  	"esnext.set.difference"
		  ],
		  	"core-js/modules/esnext.set.difference.v2": [
		  	"esnext.set.difference.v2"
		  ],
		  	"core-js/modules/esnext.set.every": [
		  	"esnext.set.every"
		  ],
		  	"core-js/modules/esnext.set.filter": [
		  	"esnext.set.filter"
		  ],
		  	"core-js/modules/esnext.set.find": [
		  	"esnext.set.find"
		  ],
		  	"core-js/modules/esnext.set.from": [
		  	"esnext.set.from"
		  ],
		  	"core-js/modules/esnext.set.intersection": [
		  	"esnext.set.intersection"
		  ],
		  	"core-js/modules/esnext.set.intersection.v2": [
		  	"esnext.set.intersection.v2"
		  ],
		  	"core-js/modules/esnext.set.is-disjoint-from": [
		  	"esnext.set.is-disjoint-from"
		  ],
		  	"core-js/modules/esnext.set.is-disjoint-from.v2": [
		  	"esnext.set.is-disjoint-from.v2"
		  ],
		  	"core-js/modules/esnext.set.is-subset-of": [
		  	"esnext.set.is-subset-of"
		  ],
		  	"core-js/modules/esnext.set.is-subset-of.v2": [
		  	"esnext.set.is-subset-of.v2"
		  ],
		  	"core-js/modules/esnext.set.is-superset-of": [
		  	"esnext.set.is-superset-of"
		  ],
		  	"core-js/modules/esnext.set.is-superset-of.v2": [
		  	"esnext.set.is-superset-of.v2"
		  ],
		  	"core-js/modules/esnext.set.join": [
		  	"esnext.set.join"
		  ],
		  	"core-js/modules/esnext.set.map": [
		  	"esnext.set.map"
		  ],
		  	"core-js/modules/esnext.set.of": [
		  	"esnext.set.of"
		  ],
		  	"core-js/modules/esnext.set.reduce": [
		  	"esnext.set.reduce"
		  ],
		  	"core-js/modules/esnext.set.some": [
		  	"esnext.set.some"
		  ],
		  	"core-js/modules/esnext.set.symmetric-difference": [
		  	"esnext.set.symmetric-difference"
		  ],
		  	"core-js/modules/esnext.set.symmetric-difference.v2": [
		  	"esnext.set.symmetric-difference.v2"
		  ],
		  	"core-js/modules/esnext.set.union": [
		  	"esnext.set.union"
		  ],
		  	"core-js/modules/esnext.set.union.v2": [
		  	"esnext.set.union.v2"
		  ],
		  	"core-js/modules/esnext.string.at": [
		  	"esnext.string.at"
		  ],
		  	"core-js/modules/esnext.string.at-alternative": [
		  	"esnext.string.at-alternative"
		  ],
		  	"core-js/modules/esnext.string.code-points": [
		  	"esnext.string.code-points"
		  ],
		  	"core-js/modules/esnext.string.cooked": [
		  	"esnext.string.cooked"
		  ],
		  	"core-js/modules/esnext.string.dedent": [
		  	"esnext.string.dedent"
		  ],
		  	"core-js/modules/esnext.string.is-well-formed": [
		  	"esnext.string.is-well-formed"
		  ],
		  	"core-js/modules/esnext.string.match-all": [
		  	"esnext.string.match-all"
		  ],
		  	"core-js/modules/esnext.string.replace-all": [
		  	"esnext.string.replace-all"
		  ],
		  	"core-js/modules/esnext.string.to-well-formed": [
		  	"esnext.string.to-well-formed"
		  ],
		  	"core-js/modules/esnext.suppressed-error.constructor": [
		  	"esnext.suppressed-error.constructor"
		  ],
		  	"core-js/modules/esnext.symbol.async-dispose": [
		  	"esnext.symbol.async-dispose"
		  ],
		  	"core-js/modules/esnext.symbol.dispose": [
		  	"esnext.symbol.dispose"
		  ],
		  	"core-js/modules/esnext.symbol.is-registered": [
		  	"esnext.symbol.is-registered"
		  ],
		  	"core-js/modules/esnext.symbol.is-registered-symbol": [
		  	"esnext.symbol.is-registered-symbol"
		  ],
		  	"core-js/modules/esnext.symbol.is-well-known": [
		  	"esnext.symbol.is-well-known"
		  ],
		  	"core-js/modules/esnext.symbol.is-well-known-symbol": [
		  	"esnext.symbol.is-well-known-symbol"
		  ],
		  	"core-js/modules/esnext.symbol.matcher": [
		  	"esnext.symbol.matcher"
		  ],
		  	"core-js/modules/esnext.symbol.metadata": [
		  	"esnext.symbol.metadata"
		  ],
		  	"core-js/modules/esnext.symbol.metadata-key": [
		  	"esnext.symbol.metadata-key"
		  ],
		  	"core-js/modules/esnext.symbol.observable": [
		  	"esnext.symbol.observable"
		  ],
		  	"core-js/modules/esnext.symbol.pattern-match": [
		  	"esnext.symbol.pattern-match"
		  ],
		  	"core-js/modules/esnext.symbol.replace-all": [
		  	"esnext.symbol.replace-all"
		  ],
		  	"core-js/modules/esnext.typed-array.at": [
		  	"esnext.typed-array.at"
		  ],
		  	"core-js/modules/esnext.typed-array.filter-out": [
		  	"esnext.typed-array.filter-out"
		  ],
		  	"core-js/modules/esnext.typed-array.filter-reject": [
		  	"esnext.typed-array.filter-reject"
		  ],
		  	"core-js/modules/esnext.typed-array.find-last": [
		  	"esnext.typed-array.find-last"
		  ],
		  	"core-js/modules/esnext.typed-array.find-last-index": [
		  	"esnext.typed-array.find-last-index"
		  ],
		  	"core-js/modules/esnext.typed-array.from-async": [
		  	"esnext.typed-array.from-async"
		  ],
		  	"core-js/modules/esnext.typed-array.group-by": [
		  	"esnext.typed-array.group-by"
		  ],
		  	"core-js/modules/esnext.typed-array.to-reversed": [
		  	"esnext.typed-array.to-reversed"
		  ],
		  	"core-js/modules/esnext.typed-array.to-sorted": [
		  	"esnext.typed-array.to-sorted"
		  ],
		  	"core-js/modules/esnext.typed-array.to-spliced": [
		  	"esnext.typed-array.to-spliced"
		  ],
		  	"core-js/modules/esnext.typed-array.unique-by": [
		  	"esnext.typed-array.unique-by"
		  ],
		  	"core-js/modules/esnext.typed-array.with": [
		  	"esnext.typed-array.with"
		  ],
		  	"core-js/modules/esnext.uint8-array.from-base64": [
		  	"esnext.uint8-array.from-base64"
		  ],
		  	"core-js/modules/esnext.uint8-array.from-hex": [
		  	"esnext.uint8-array.from-hex"
		  ],
		  	"core-js/modules/esnext.uint8-array.to-base64": [
		  	"esnext.uint8-array.to-base64"
		  ],
		  	"core-js/modules/esnext.uint8-array.to-hex": [
		  	"esnext.uint8-array.to-hex"
		  ],
		  	"core-js/modules/esnext.weak-map.delete-all": [
		  	"esnext.weak-map.delete-all"
		  ],
		  	"core-js/modules/esnext.weak-map.emplace": [
		  	"esnext.weak-map.emplace"
		  ],
		  	"core-js/modules/esnext.weak-map.from": [
		  	"esnext.weak-map.from"
		  ],
		  	"core-js/modules/esnext.weak-map.of": [
		  	"esnext.weak-map.of"
		  ],
		  	"core-js/modules/esnext.weak-map.upsert": [
		  	"esnext.weak-map.upsert"
		  ],
		  	"core-js/modules/esnext.weak-set.add-all": [
		  	"esnext.weak-set.add-all"
		  ],
		  	"core-js/modules/esnext.weak-set.delete-all": [
		  	"esnext.weak-set.delete-all"
		  ],
		  	"core-js/modules/esnext.weak-set.from": [
		  	"esnext.weak-set.from"
		  ],
		  	"core-js/modules/esnext.weak-set.of": [
		  	"esnext.weak-set.of"
		  ],
		  	"core-js/modules/web.atob": [
		  	"web.atob"
		  ],
		  	"core-js/modules/web.btoa": [
		  	"web.btoa"
		  ],
		  	"core-js/modules/web.clear-immediate": [
		  	"web.clear-immediate"
		  ],
		  	"core-js/modules/web.dom-collections.for-each": [
		  	"web.dom-collections.for-each"
		  ],
		  	"core-js/modules/web.dom-collections.iterator": [
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/modules/web.dom-exception.constructor": [
		  	"web.dom-exception.constructor"
		  ],
		  	"core-js/modules/web.dom-exception.stack": [
		  	"web.dom-exception.stack"
		  ],
		  	"core-js/modules/web.dom-exception.to-string-tag": [
		  	"web.dom-exception.to-string-tag"
		  ],
		  	"core-js/modules/web.immediate": [
		  	"web.immediate"
		  ],
		  	"core-js/modules/web.queue-microtask": [
		  	"web.queue-microtask"
		  ],
		  	"core-js/modules/web.self": [
		  	"web.self"
		  ],
		  	"core-js/modules/web.set-immediate": [
		  	"web.set-immediate"
		  ],
		  	"core-js/modules/web.set-interval": [
		  	"web.set-interval"
		  ],
		  	"core-js/modules/web.set-timeout": [
		  	"web.set-timeout"
		  ],
		  	"core-js/modules/web.structured-clone": [
		  	"web.structured-clone"
		  ],
		  	"core-js/modules/web.timers": [
		  	"web.timers"
		  ],
		  	"core-js/modules/web.url": [
		  	"web.url"
		  ],
		  	"core-js/modules/web.url-search-params": [
		  	"web.url-search-params"
		  ],
		  	"core-js/modules/web.url-search-params.constructor": [
		  	"web.url-search-params.constructor"
		  ],
		  	"core-js/modules/web.url-search-params.delete": [
		  	"web.url-search-params.delete"
		  ],
		  	"core-js/modules/web.url-search-params.has": [
		  	"web.url-search-params.has"
		  ],
		  	"core-js/modules/web.url-search-params.size": [
		  	"web.url-search-params.size"
		  ],
		  	"core-js/modules/web.url.can-parse": [
		  	"web.url.can-parse"
		  ],
		  	"core-js/modules/web.url.constructor": [
		  	"web.url.constructor"
		  ],
		  	"core-js/modules/web.url.to-json": [
		  	"web.url.to-json"
		  ],
		  	"core-js/proposals": [
		  	"es.map",
		  	"es.string.at-alternative",
		  	"esnext.aggregate-error",
		  	"esnext.suppressed-error.constructor",
		  	"esnext.array.from-async",
		  	"esnext.array.at",
		  	"esnext.array.filter-out",
		  	"esnext.array.filter-reject",
		  	"esnext.array.find-last",
		  	"esnext.array.find-last-index",
		  	"esnext.array.group",
		  	"esnext.array.group-by",
		  	"esnext.array.group-by-to-map",
		  	"esnext.array.group-to-map",
		  	"esnext.array.is-template-object",
		  	"esnext.array.last-index",
		  	"esnext.array.last-item",
		  	"esnext.array.to-reversed",
		  	"esnext.array.to-sorted",
		  	"esnext.array.to-spliced",
		  	"esnext.array.unique-by",
		  	"esnext.array.with",
		  	"esnext.array-buffer.detached",
		  	"esnext.array-buffer.transfer",
		  	"esnext.array-buffer.transfer-to-fixed-length",
		  	"esnext.async-disposable-stack.constructor",
		  	"esnext.async-iterator.constructor",
		  	"esnext.async-iterator.as-indexed-pairs",
		  	"esnext.async-iterator.async-dispose",
		  	"esnext.async-iterator.drop",
		  	"esnext.async-iterator.every",
		  	"esnext.async-iterator.filter",
		  	"esnext.async-iterator.find",
		  	"esnext.async-iterator.flat-map",
		  	"esnext.async-iterator.for-each",
		  	"esnext.async-iterator.from",
		  	"esnext.async-iterator.indexed",
		  	"esnext.async-iterator.map",
		  	"esnext.async-iterator.reduce",
		  	"esnext.async-iterator.some",
		  	"esnext.async-iterator.take",
		  	"esnext.async-iterator.to-array",
		  	"esnext.bigint.range",
		  	"esnext.composite-key",
		  	"esnext.composite-symbol",
		  	"esnext.data-view.get-float16",
		  	"esnext.data-view.get-uint8-clamped",
		  	"esnext.data-view.set-float16",
		  	"esnext.data-view.set-uint8-clamped",
		  	"esnext.disposable-stack.constructor",
		  	"esnext.function.demethodize",
		  	"esnext.function.is-callable",
		  	"esnext.function.is-constructor",
		  	"esnext.function.metadata",
		  	"esnext.function.un-this",
		  	"esnext.global-this",
		  	"esnext.iterator.constructor",
		  	"esnext.iterator.as-indexed-pairs",
		  	"esnext.iterator.dispose",
		  	"esnext.iterator.drop",
		  	"esnext.iterator.every",
		  	"esnext.iterator.filter",
		  	"esnext.iterator.find",
		  	"esnext.iterator.flat-map",
		  	"esnext.iterator.for-each",
		  	"esnext.iterator.from",
		  	"esnext.iterator.indexed",
		  	"esnext.iterator.map",
		  	"esnext.iterator.range",
		  	"esnext.iterator.reduce",
		  	"esnext.iterator.some",
		  	"esnext.iterator.take",
		  	"esnext.iterator.to-array",
		  	"esnext.iterator.to-async",
		  	"esnext.json.is-raw-json",
		  	"esnext.json.parse",
		  	"esnext.json.raw-json",
		  	"esnext.map.delete-all",
		  	"esnext.map.emplace",
		  	"esnext.map.every",
		  	"esnext.map.filter",
		  	"esnext.map.find",
		  	"esnext.map.find-key",
		  	"esnext.map.from",
		  	"esnext.map.group-by",
		  	"esnext.map.includes",
		  	"esnext.map.key-by",
		  	"esnext.map.key-of",
		  	"esnext.map.map-keys",
		  	"esnext.map.map-values",
		  	"esnext.map.merge",
		  	"esnext.map.of",
		  	"esnext.map.reduce",
		  	"esnext.map.some",
		  	"esnext.map.update",
		  	"esnext.map.update-or-insert",
		  	"esnext.map.upsert",
		  	"esnext.math.clamp",
		  	"esnext.math.deg-per-rad",
		  	"esnext.math.degrees",
		  	"esnext.math.fscale",
		  	"esnext.math.f16round",
		  	"esnext.math.iaddh",
		  	"esnext.math.imulh",
		  	"esnext.math.isubh",
		  	"esnext.math.rad-per-deg",
		  	"esnext.math.radians",
		  	"esnext.math.scale",
		  	"esnext.math.seeded-prng",
		  	"esnext.math.signbit",
		  	"esnext.math.umulh",
		  	"esnext.number.from-string",
		  	"esnext.number.range",
		  	"esnext.object.has-own",
		  	"esnext.object.iterate-entries",
		  	"esnext.object.iterate-keys",
		  	"esnext.object.iterate-values",
		  	"esnext.object.group-by",
		  	"esnext.observable",
		  	"esnext.promise.all-settled",
		  	"esnext.promise.any",
		  	"esnext.promise.try",
		  	"esnext.promise.with-resolvers",
		  	"esnext.reflect.define-metadata",
		  	"esnext.reflect.delete-metadata",
		  	"esnext.reflect.get-metadata",
		  	"esnext.reflect.get-metadata-keys",
		  	"esnext.reflect.get-own-metadata",
		  	"esnext.reflect.get-own-metadata-keys",
		  	"esnext.reflect.has-metadata",
		  	"esnext.reflect.has-own-metadata",
		  	"esnext.reflect.metadata",
		  	"esnext.regexp.escape",
		  	"esnext.set.add-all",
		  	"esnext.set.delete-all",
		  	"esnext.set.difference.v2",
		  	"esnext.set.difference",
		  	"esnext.set.every",
		  	"esnext.set.filter",
		  	"esnext.set.find",
		  	"esnext.set.from",
		  	"esnext.set.intersection.v2",
		  	"esnext.set.intersection",
		  	"esnext.set.is-disjoint-from.v2",
		  	"esnext.set.is-disjoint-from",
		  	"esnext.set.is-subset-of.v2",
		  	"esnext.set.is-subset-of",
		  	"esnext.set.is-superset-of.v2",
		  	"esnext.set.is-superset-of",
		  	"esnext.set.join",
		  	"esnext.set.map",
		  	"esnext.set.of",
		  	"esnext.set.reduce",
		  	"esnext.set.some",
		  	"esnext.set.symmetric-difference.v2",
		  	"esnext.set.symmetric-difference",
		  	"esnext.set.union.v2",
		  	"esnext.set.union",
		  	"esnext.string.at",
		  	"esnext.string.cooked",
		  	"esnext.string.code-points",
		  	"esnext.string.dedent",
		  	"esnext.string.is-well-formed",
		  	"esnext.string.match-all",
		  	"esnext.string.replace-all",
		  	"esnext.string.to-well-formed",
		  	"esnext.symbol.async-dispose",
		  	"esnext.symbol.dispose",
		  	"esnext.symbol.is-registered-symbol",
		  	"esnext.symbol.is-registered",
		  	"esnext.symbol.is-well-known-symbol",
		  	"esnext.symbol.is-well-known",
		  	"esnext.symbol.matcher",
		  	"esnext.symbol.metadata",
		  	"esnext.symbol.metadata-key",
		  	"esnext.symbol.observable",
		  	"esnext.symbol.pattern-match",
		  	"esnext.symbol.replace-all",
		  	"esnext.typed-array.from-async",
		  	"esnext.typed-array.at",
		  	"esnext.typed-array.filter-out",
		  	"esnext.typed-array.filter-reject",
		  	"esnext.typed-array.find-last",
		  	"esnext.typed-array.find-last-index",
		  	"esnext.typed-array.group-by",
		  	"esnext.typed-array.to-reversed",
		  	"esnext.typed-array.to-sorted",
		  	"esnext.typed-array.to-spliced",
		  	"esnext.typed-array.unique-by",
		  	"esnext.typed-array.with",
		  	"esnext.uint8-array.from-base64",
		  	"esnext.uint8-array.from-hex",
		  	"esnext.uint8-array.to-base64",
		  	"esnext.uint8-array.to-hex",
		  	"esnext.weak-map.delete-all",
		  	"esnext.weak-map.from",
		  	"esnext.weak-map.of",
		  	"esnext.weak-map.emplace",
		  	"esnext.weak-map.upsert",
		  	"esnext.weak-set.add-all",
		  	"esnext.weak-set.delete-all",
		  	"esnext.weak-set.from",
		  	"esnext.weak-set.of",
		  	"web.url",
		  	"web.url.can-parse",
		  	"web.url.to-json",
		  	"web.url-search-params",
		  	"web.url-search-params.delete",
		  	"web.url-search-params.has",
		  	"web.url-search-params.size"
		  ],
		  	"core-js/proposals/accessible-object-hasownproperty": [
		  	"esnext.object.has-own"
		  ],
		  	"core-js/proposals/array-buffer-base64": [
		  	"esnext.uint8-array.from-base64",
		  	"esnext.uint8-array.from-hex",
		  	"esnext.uint8-array.to-base64",
		  	"esnext.uint8-array.to-hex"
		  ],
		  	"core-js/proposals/array-buffer-transfer": [
		  	"esnext.array-buffer.detached",
		  	"esnext.array-buffer.transfer",
		  	"esnext.array-buffer.transfer-to-fixed-length"
		  ],
		  	"core-js/proposals/array-filtering": [
		  	"esnext.array.filter-out",
		  	"esnext.array.filter-reject",
		  	"esnext.typed-array.filter-out",
		  	"esnext.typed-array.filter-reject"
		  ],
		  	"core-js/proposals/array-filtering-stage-1": [
		  	"esnext.array.filter-reject",
		  	"esnext.typed-array.filter-reject"
		  ],
		  	"core-js/proposals/array-find-from-last": [
		  	"esnext.array.find-last",
		  	"esnext.array.find-last-index",
		  	"esnext.typed-array.find-last",
		  	"esnext.typed-array.find-last-index"
		  ],
		  	"core-js/proposals/array-flat-map": [
		  	"es.array.flat",
		  	"es.array.flat-map",
		  	"es.array.unscopables.flat",
		  	"es.array.unscopables.flat-map"
		  ],
		  	"core-js/proposals/array-from-async": [
		  	"esnext.array.from-async",
		  	"esnext.typed-array.from-async"
		  ],
		  	"core-js/proposals/array-from-async-stage-2": [
		  	"esnext.array.from-async"
		  ],
		  	"core-js/proposals/array-grouping": [
		  	"esnext.array.group-by",
		  	"esnext.array.group-by-to-map",
		  	"esnext.typed-array.group-by"
		  ],
		  	"core-js/proposals/array-grouping-stage-3": [
		  	"esnext.array.group-by",
		  	"esnext.array.group-by-to-map"
		  ],
		  	"core-js/proposals/array-grouping-stage-3-2": [
		  	"esnext.array.group",
		  	"esnext.array.group-to-map"
		  ],
		  	"core-js/proposals/array-grouping-v2": [
		  	"esnext.map.group-by",
		  	"esnext.object.group-by"
		  ],
		  	"core-js/proposals/array-includes": [
		  	"es.array.includes",
		  	"es.typed-array.includes"
		  ],
		  	"core-js/proposals/array-is-template-object": [
		  	"esnext.array.is-template-object"
		  ],
		  	"core-js/proposals/array-last": [
		  	"esnext.array.last-index",
		  	"esnext.array.last-item"
		  ],
		  	"core-js/proposals/array-unique": [
		  	"es.map",
		  	"esnext.array.unique-by",
		  	"esnext.typed-array.unique-by"
		  ],
		  	"core-js/proposals/async-explicit-resource-management": [
		  	"esnext.suppressed-error.constructor",
		  	"esnext.async-disposable-stack.constructor",
		  	"esnext.async-iterator.async-dispose",
		  	"esnext.symbol.async-dispose"
		  ],
		  	"core-js/proposals/async-iteration": [
		  	"es.symbol.async-iterator"
		  ],
		  	"core-js/proposals/async-iterator-helpers": [
		  	"esnext.async-iterator.constructor",
		  	"esnext.async-iterator.drop",
		  	"esnext.async-iterator.every",
		  	"esnext.async-iterator.filter",
		  	"esnext.async-iterator.find",
		  	"esnext.async-iterator.flat-map",
		  	"esnext.async-iterator.for-each",
		  	"esnext.async-iterator.from",
		  	"esnext.async-iterator.map",
		  	"esnext.async-iterator.reduce",
		  	"esnext.async-iterator.some",
		  	"esnext.async-iterator.take",
		  	"esnext.async-iterator.to-array",
		  	"esnext.iterator.to-async"
		  ],
		  	"core-js/proposals/change-array-by-copy": [
		  	"esnext.array.to-reversed",
		  	"esnext.array.to-sorted",
		  	"esnext.array.to-spliced",
		  	"esnext.array.with",
		  	"esnext.typed-array.to-reversed",
		  	"esnext.typed-array.to-sorted",
		  	"esnext.typed-array.to-spliced",
		  	"esnext.typed-array.with"
		  ],
		  	"core-js/proposals/change-array-by-copy-stage-4": [
		  	"esnext.array.to-reversed",
		  	"esnext.array.to-sorted",
		  	"esnext.array.to-spliced",
		  	"esnext.array.with",
		  	"esnext.typed-array.to-reversed",
		  	"esnext.typed-array.to-sorted",
		  	"esnext.typed-array.with"
		  ],
		  	"core-js/proposals/collection-methods": [
		  	"esnext.map.delete-all",
		  	"esnext.map.every",
		  	"esnext.map.filter",
		  	"esnext.map.find",
		  	"esnext.map.find-key",
		  	"esnext.map.group-by",
		  	"esnext.map.includes",
		  	"esnext.map.key-by",
		  	"esnext.map.key-of",
		  	"esnext.map.map-keys",
		  	"esnext.map.map-values",
		  	"esnext.map.merge",
		  	"esnext.map.reduce",
		  	"esnext.map.some",
		  	"esnext.map.update",
		  	"esnext.set.add-all",
		  	"esnext.set.delete-all",
		  	"esnext.set.every",
		  	"esnext.set.filter",
		  	"esnext.set.find",
		  	"esnext.set.join",
		  	"esnext.set.map",
		  	"esnext.set.reduce",
		  	"esnext.set.some",
		  	"esnext.weak-map.delete-all",
		  	"esnext.weak-set.add-all",
		  	"esnext.weak-set.delete-all"
		  ],
		  	"core-js/proposals/collection-of-from": [
		  	"esnext.map.from",
		  	"esnext.map.of",
		  	"esnext.set.from",
		  	"esnext.set.of",
		  	"esnext.weak-map.from",
		  	"esnext.weak-map.of",
		  	"esnext.weak-set.from",
		  	"esnext.weak-set.of"
		  ],
		  	"core-js/proposals/data-view-get-set-uint8-clamped": [
		  	"esnext.data-view.get-uint8-clamped",
		  	"esnext.data-view.set-uint8-clamped"
		  ],
		  	"core-js/proposals/decorator-metadata": [
		  	"esnext.symbol.metadata-key"
		  ],
		  	"core-js/proposals/decorator-metadata-v2": [
		  	"esnext.function.metadata",
		  	"esnext.symbol.metadata"
		  ],
		  	"core-js/proposals/decorators": [
		  	"esnext.symbol.metadata"
		  ],
		  	"core-js/proposals/efficient-64-bit-arithmetic": [
		  	"esnext.math.iaddh",
		  	"esnext.math.imulh",
		  	"esnext.math.isubh",
		  	"esnext.math.umulh"
		  ],
		  	"core-js/proposals/error-cause": [
		  	"es.error.cause",
		  	"es.aggregate-error.cause"
		  ],
		  	"core-js/proposals/explicit-resource-management": [
		  	"esnext.suppressed-error.constructor",
		  	"esnext.async-disposable-stack.constructor",
		  	"esnext.async-iterator.async-dispose",
		  	"esnext.disposable-stack.constructor",
		  	"esnext.iterator.dispose",
		  	"esnext.symbol.async-dispose",
		  	"esnext.symbol.dispose"
		  ],
		  	"core-js/proposals/float16": [
		  	"esnext.data-view.get-float16",
		  	"esnext.data-view.set-float16",
		  	"esnext.math.f16round"
		  ],
		  	"core-js/proposals/function-demethodize": [
		  	"esnext.function.demethodize"
		  ],
		  	"core-js/proposals/function-is-callable-is-constructor": [
		  	"esnext.function.is-callable",
		  	"esnext.function.is-constructor"
		  ],
		  	"core-js/proposals/function-un-this": [
		  	"esnext.function.un-this"
		  ],
		  	"core-js/proposals/global-this": [
		  	"esnext.global-this"
		  ],
		  	"core-js/proposals/iterator-helpers": [
		  	"esnext.async-iterator.constructor",
		  	"esnext.async-iterator.as-indexed-pairs",
		  	"esnext.async-iterator.drop",
		  	"esnext.async-iterator.every",
		  	"esnext.async-iterator.filter",
		  	"esnext.async-iterator.find",
		  	"esnext.async-iterator.flat-map",
		  	"esnext.async-iterator.for-each",
		  	"esnext.async-iterator.from",
		  	"esnext.async-iterator.indexed",
		  	"esnext.async-iterator.map",
		  	"esnext.async-iterator.reduce",
		  	"esnext.async-iterator.some",
		  	"esnext.async-iterator.take",
		  	"esnext.async-iterator.to-array",
		  	"esnext.iterator.constructor",
		  	"esnext.iterator.as-indexed-pairs",
		  	"esnext.iterator.drop",
		  	"esnext.iterator.every",
		  	"esnext.iterator.filter",
		  	"esnext.iterator.find",
		  	"esnext.iterator.flat-map",
		  	"esnext.iterator.for-each",
		  	"esnext.iterator.from",
		  	"esnext.iterator.indexed",
		  	"esnext.iterator.map",
		  	"esnext.iterator.reduce",
		  	"esnext.iterator.some",
		  	"esnext.iterator.take",
		  	"esnext.iterator.to-array",
		  	"esnext.iterator.to-async"
		  ],
		  	"core-js/proposals/iterator-helpers-stage-3": [
		  	"esnext.async-iterator.constructor",
		  	"esnext.async-iterator.drop",
		  	"esnext.async-iterator.every",
		  	"esnext.async-iterator.filter",
		  	"esnext.async-iterator.find",
		  	"esnext.async-iterator.flat-map",
		  	"esnext.async-iterator.for-each",
		  	"esnext.async-iterator.from",
		  	"esnext.async-iterator.map",
		  	"esnext.async-iterator.reduce",
		  	"esnext.async-iterator.some",
		  	"esnext.async-iterator.take",
		  	"esnext.async-iterator.to-array",
		  	"esnext.iterator.constructor",
		  	"esnext.iterator.drop",
		  	"esnext.iterator.every",
		  	"esnext.iterator.filter",
		  	"esnext.iterator.find",
		  	"esnext.iterator.flat-map",
		  	"esnext.iterator.for-each",
		  	"esnext.iterator.from",
		  	"esnext.iterator.map",
		  	"esnext.iterator.reduce",
		  	"esnext.iterator.some",
		  	"esnext.iterator.take",
		  	"esnext.iterator.to-array",
		  	"esnext.iterator.to-async"
		  ],
		  	"core-js/proposals/iterator-helpers-stage-3-2": [
		  	"esnext.iterator.constructor",
		  	"esnext.iterator.drop",
		  	"esnext.iterator.every",
		  	"esnext.iterator.filter",
		  	"esnext.iterator.find",
		  	"esnext.iterator.flat-map",
		  	"esnext.iterator.for-each",
		  	"esnext.iterator.from",
		  	"esnext.iterator.map",
		  	"esnext.iterator.reduce",
		  	"esnext.iterator.some",
		  	"esnext.iterator.take",
		  	"esnext.iterator.to-array"
		  ],
		  	"core-js/proposals/iterator-range": [
		  	"esnext.iterator.constructor",
		  	"esnext.iterator.range"
		  ],
		  	"core-js/proposals/json-parse-with-source": [
		  	"esnext.json.is-raw-json",
		  	"esnext.json.parse",
		  	"esnext.json.raw-json"
		  ],
		  	"core-js/proposals/keys-composition": [
		  	"esnext.composite-key",
		  	"esnext.composite-symbol"
		  ],
		  	"core-js/proposals/map-update-or-insert": [
		  	"esnext.map.emplace",
		  	"esnext.map.update-or-insert",
		  	"esnext.map.upsert",
		  	"esnext.weak-map.emplace",
		  	"esnext.weak-map.upsert"
		  ],
		  	"core-js/proposals/map-upsert": [
		  	"esnext.map.emplace",
		  	"esnext.map.update-or-insert",
		  	"esnext.map.upsert",
		  	"esnext.weak-map.emplace",
		  	"esnext.weak-map.upsert"
		  ],
		  	"core-js/proposals/map-upsert-stage-2": [
		  	"esnext.map.emplace",
		  	"esnext.weak-map.emplace"
		  ],
		  	"core-js/proposals/math-extensions": [
		  	"esnext.math.clamp",
		  	"esnext.math.deg-per-rad",
		  	"esnext.math.degrees",
		  	"esnext.math.fscale",
		  	"esnext.math.rad-per-deg",
		  	"esnext.math.radians",
		  	"esnext.math.scale"
		  ],
		  	"core-js/proposals/math-signbit": [
		  	"esnext.math.signbit"
		  ],
		  	"core-js/proposals/number-from-string": [
		  	"esnext.number.from-string"
		  ],
		  	"core-js/proposals/number-range": [
		  	"esnext.bigint.range",
		  	"esnext.number.range"
		  ],
		  	"core-js/proposals/object-from-entries": [
		  	"es.object.from-entries"
		  ],
		  	"core-js/proposals/object-getownpropertydescriptors": [
		  	"es.object.get-own-property-descriptors"
		  ],
		  	"core-js/proposals/object-iteration": [
		  	"esnext.object.iterate-entries",
		  	"esnext.object.iterate-keys",
		  	"esnext.object.iterate-values"
		  ],
		  	"core-js/proposals/object-values-entries": [
		  	"es.object.entries",
		  	"es.object.values"
		  ],
		  	"core-js/proposals/observable": [
		  	"esnext.observable",
		  	"esnext.symbol.observable"
		  ],
		  	"core-js/proposals/pattern-matching": [
		  	"esnext.symbol.matcher",
		  	"esnext.symbol.pattern-match"
		  ],
		  	"core-js/proposals/promise-all-settled": [
		  	"esnext.promise.all-settled"
		  ],
		  	"core-js/proposals/promise-any": [
		  	"esnext.aggregate-error",
		  	"esnext.promise.any"
		  ],
		  	"core-js/proposals/promise-finally": [
		  	"es.promise.finally"
		  ],
		  	"core-js/proposals/promise-try": [
		  	"esnext.promise.try"
		  ],
		  	"core-js/proposals/promise-with-resolvers": [
		  	"esnext.promise.with-resolvers"
		  ],
		  	"core-js/proposals/reflect-metadata": [
		  	"esnext.reflect.define-metadata",
		  	"esnext.reflect.delete-metadata",
		  	"esnext.reflect.get-metadata",
		  	"esnext.reflect.get-metadata-keys",
		  	"esnext.reflect.get-own-metadata",
		  	"esnext.reflect.get-own-metadata-keys",
		  	"esnext.reflect.has-metadata",
		  	"esnext.reflect.has-own-metadata",
		  	"esnext.reflect.metadata"
		  ],
		  	"core-js/proposals/regexp-dotall-flag": [
		  	"es.regexp.constructor",
		  	"es.regexp.dot-all",
		  	"es.regexp.exec",
		  	"es.regexp.flags"
		  ],
		  	"core-js/proposals/regexp-escaping": [
		  	"esnext.regexp.escape"
		  ],
		  	"core-js/proposals/regexp-named-groups": [
		  	"es.regexp.constructor",
		  	"es.regexp.exec",
		  	"es.string.replace"
		  ],
		  	"core-js/proposals/relative-indexing-method": [
		  	"es.string.at-alternative",
		  	"esnext.array.at",
		  	"esnext.typed-array.at"
		  ],
		  	"core-js/proposals/seeded-random": [
		  	"esnext.math.seeded-prng"
		  ],
		  	"core-js/proposals/set-methods": [
		  	"esnext.set.difference.v2",
		  	"esnext.set.difference",
		  	"esnext.set.intersection.v2",
		  	"esnext.set.intersection",
		  	"esnext.set.is-disjoint-from.v2",
		  	"esnext.set.is-disjoint-from",
		  	"esnext.set.is-subset-of.v2",
		  	"esnext.set.is-subset-of",
		  	"esnext.set.is-superset-of.v2",
		  	"esnext.set.is-superset-of",
		  	"esnext.set.symmetric-difference.v2",
		  	"esnext.set.symmetric-difference",
		  	"esnext.set.union.v2",
		  	"esnext.set.union"
		  ],
		  	"core-js/proposals/set-methods-v2": [
		  	"esnext.set.difference.v2",
		  	"esnext.set.intersection.v2",
		  	"esnext.set.is-disjoint-from.v2",
		  	"esnext.set.is-subset-of.v2",
		  	"esnext.set.is-superset-of.v2",
		  	"esnext.set.symmetric-difference.v2",
		  	"esnext.set.union.v2"
		  ],
		  	"core-js/proposals/string-at": [
		  	"esnext.string.at"
		  ],
		  	"core-js/proposals/string-code-points": [
		  	"esnext.string.code-points"
		  ],
		  	"core-js/proposals/string-cooked": [
		  	"esnext.string.cooked"
		  ],
		  	"core-js/proposals/string-dedent": [
		  	"esnext.string.dedent"
		  ],
		  	"core-js/proposals/string-left-right-trim": [
		  	"es.string.trim-end",
		  	"es.string.trim-start"
		  ],
		  	"core-js/proposals/string-match-all": [
		  	"esnext.string.match-all"
		  ],
		  	"core-js/proposals/string-padding": [
		  	"es.string.pad-end",
		  	"es.string.pad-start"
		  ],
		  	"core-js/proposals/string-replace-all": [
		  	"esnext.string.replace-all",
		  	"esnext.symbol.replace-all"
		  ],
		  	"core-js/proposals/string-replace-all-stage-4": [
		  	"esnext.string.replace-all"
		  ],
		  	"core-js/proposals/symbol-description": [
		  	"es.symbol.description"
		  ],
		  	"core-js/proposals/symbol-predicates": [
		  	"esnext.symbol.is-registered",
		  	"esnext.symbol.is-well-known"
		  ],
		  	"core-js/proposals/symbol-predicates-v2": [
		  	"esnext.symbol.is-registered-symbol",
		  	"esnext.symbol.is-well-known-symbol"
		  ],
		  	"core-js/proposals/url": [
		  	"web.url",
		  	"web.url.can-parse",
		  	"web.url.to-json",
		  	"web.url-search-params",
		  	"web.url-search-params.delete",
		  	"web.url-search-params.has",
		  	"web.url-search-params.size"
		  ],
		  	"core-js/proposals/using-statement": [
		  	"esnext.symbol.async-dispose",
		  	"esnext.symbol.dispose"
		  ],
		  	"core-js/proposals/well-formed-stringify": [
		  	"es.json.stringify"
		  ],
		  	"core-js/proposals/well-formed-unicode-strings": [
		  	"esnext.string.is-well-formed",
		  	"esnext.string.to-well-formed"
		  ],
		  	"core-js/stable": [
		  	"es.symbol",
		  	"es.symbol.description",
		  	"es.symbol.async-iterator",
		  	"es.symbol.has-instance",
		  	"es.symbol.is-concat-spreadable",
		  	"es.symbol.iterator",
		  	"es.symbol.match",
		  	"es.symbol.match-all",
		  	"es.symbol.replace",
		  	"es.symbol.search",
		  	"es.symbol.species",
		  	"es.symbol.split",
		  	"es.symbol.to-primitive",
		  	"es.symbol.to-string-tag",
		  	"es.symbol.unscopables",
		  	"es.error.cause",
		  	"es.error.to-string",
		  	"es.aggregate-error",
		  	"es.aggregate-error.cause",
		  	"es.array.at",
		  	"es.array.concat",
		  	"es.array.copy-within",
		  	"es.array.every",
		  	"es.array.fill",
		  	"es.array.filter",
		  	"es.array.find",
		  	"es.array.find-index",
		  	"es.array.find-last",
		  	"es.array.find-last-index",
		  	"es.array.flat",
		  	"es.array.flat-map",
		  	"es.array.for-each",
		  	"es.array.from",
		  	"es.array.includes",
		  	"es.array.index-of",
		  	"es.array.is-array",
		  	"es.array.iterator",
		  	"es.array.join",
		  	"es.array.last-index-of",
		  	"es.array.map",
		  	"es.array.of",
		  	"es.array.push",
		  	"es.array.reduce",
		  	"es.array.reduce-right",
		  	"es.array.reverse",
		  	"es.array.slice",
		  	"es.array.some",
		  	"es.array.sort",
		  	"es.array.species",
		  	"es.array.splice",
		  	"es.array.to-reversed",
		  	"es.array.to-sorted",
		  	"es.array.to-spliced",
		  	"es.array.unscopables.flat",
		  	"es.array.unscopables.flat-map",
		  	"es.array.unshift",
		  	"es.array.with",
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.is-view",
		  	"es.array-buffer.slice",
		  	"es.data-view",
		  	"es.array-buffer.detached",
		  	"es.array-buffer.transfer",
		  	"es.array-buffer.transfer-to-fixed-length",
		  	"es.date.get-year",
		  	"es.date.now",
		  	"es.date.set-year",
		  	"es.date.to-gmt-string",
		  	"es.date.to-iso-string",
		  	"es.date.to-json",
		  	"es.date.to-primitive",
		  	"es.date.to-string",
		  	"es.escape",
		  	"es.function.bind",
		  	"es.function.has-instance",
		  	"es.function.name",
		  	"es.global-this",
		  	"es.json.stringify",
		  	"es.json.to-string-tag",
		  	"es.map",
		  	"es.map.group-by",
		  	"es.math.acosh",
		  	"es.math.asinh",
		  	"es.math.atanh",
		  	"es.math.cbrt",
		  	"es.math.clz32",
		  	"es.math.cosh",
		  	"es.math.expm1",
		  	"es.math.fround",
		  	"es.math.hypot",
		  	"es.math.imul",
		  	"es.math.log10",
		  	"es.math.log1p",
		  	"es.math.log2",
		  	"es.math.sign",
		  	"es.math.sinh",
		  	"es.math.tanh",
		  	"es.math.to-string-tag",
		  	"es.math.trunc",
		  	"es.number.constructor",
		  	"es.number.epsilon",
		  	"es.number.is-finite",
		  	"es.number.is-integer",
		  	"es.number.is-nan",
		  	"es.number.is-safe-integer",
		  	"es.number.max-safe-integer",
		  	"es.number.min-safe-integer",
		  	"es.number.parse-float",
		  	"es.number.parse-int",
		  	"es.number.to-exponential",
		  	"es.number.to-fixed",
		  	"es.number.to-precision",
		  	"es.object.assign",
		  	"es.object.create",
		  	"es.object.define-getter",
		  	"es.object.define-properties",
		  	"es.object.define-property",
		  	"es.object.define-setter",
		  	"es.object.entries",
		  	"es.object.freeze",
		  	"es.object.from-entries",
		  	"es.object.get-own-property-descriptor",
		  	"es.object.get-own-property-descriptors",
		  	"es.object.get-own-property-names",
		  	"es.object.get-prototype-of",
		  	"es.object.group-by",
		  	"es.object.has-own",
		  	"es.object.is",
		  	"es.object.is-extensible",
		  	"es.object.is-frozen",
		  	"es.object.is-sealed",
		  	"es.object.keys",
		  	"es.object.lookup-getter",
		  	"es.object.lookup-setter",
		  	"es.object.prevent-extensions",
		  	"es.object.proto",
		  	"es.object.seal",
		  	"es.object.set-prototype-of",
		  	"es.object.to-string",
		  	"es.object.values",
		  	"es.parse-float",
		  	"es.parse-int",
		  	"es.promise",
		  	"es.promise.all-settled",
		  	"es.promise.any",
		  	"es.promise.finally",
		  	"es.promise.with-resolvers",
		  	"es.reflect.apply",
		  	"es.reflect.construct",
		  	"es.reflect.define-property",
		  	"es.reflect.delete-property",
		  	"es.reflect.get",
		  	"es.reflect.get-own-property-descriptor",
		  	"es.reflect.get-prototype-of",
		  	"es.reflect.has",
		  	"es.reflect.is-extensible",
		  	"es.reflect.own-keys",
		  	"es.reflect.prevent-extensions",
		  	"es.reflect.set",
		  	"es.reflect.set-prototype-of",
		  	"es.reflect.to-string-tag",
		  	"es.regexp.constructor",
		  	"es.regexp.dot-all",
		  	"es.regexp.exec",
		  	"es.regexp.flags",
		  	"es.regexp.sticky",
		  	"es.regexp.test",
		  	"es.regexp.to-string",
		  	"es.set",
		  	"es.string.at-alternative",
		  	"es.string.code-point-at",
		  	"es.string.ends-with",
		  	"es.string.from-code-point",
		  	"es.string.includes",
		  	"es.string.is-well-formed",
		  	"es.string.iterator",
		  	"es.string.match",
		  	"es.string.match-all",
		  	"es.string.pad-end",
		  	"es.string.pad-start",
		  	"es.string.raw",
		  	"es.string.repeat",
		  	"es.string.replace",
		  	"es.string.replace-all",
		  	"es.string.search",
		  	"es.string.split",
		  	"es.string.starts-with",
		  	"es.string.substr",
		  	"es.string.to-well-formed",
		  	"es.string.trim",
		  	"es.string.trim-end",
		  	"es.string.trim-start",
		  	"es.string.anchor",
		  	"es.string.big",
		  	"es.string.blink",
		  	"es.string.bold",
		  	"es.string.fixed",
		  	"es.string.fontcolor",
		  	"es.string.fontsize",
		  	"es.string.italics",
		  	"es.string.link",
		  	"es.string.small",
		  	"es.string.strike",
		  	"es.string.sub",
		  	"es.string.sup",
		  	"es.typed-array.float32-array",
		  	"es.typed-array.float64-array",
		  	"es.typed-array.int8-array",
		  	"es.typed-array.int16-array",
		  	"es.typed-array.int32-array",
		  	"es.typed-array.uint8-array",
		  	"es.typed-array.uint8-clamped-array",
		  	"es.typed-array.uint16-array",
		  	"es.typed-array.uint32-array",
		  	"es.typed-array.at",
		  	"es.typed-array.copy-within",
		  	"es.typed-array.every",
		  	"es.typed-array.fill",
		  	"es.typed-array.filter",
		  	"es.typed-array.find",
		  	"es.typed-array.find-index",
		  	"es.typed-array.find-last",
		  	"es.typed-array.find-last-index",
		  	"es.typed-array.for-each",
		  	"es.typed-array.from",
		  	"es.typed-array.includes",
		  	"es.typed-array.index-of",
		  	"es.typed-array.iterator",
		  	"es.typed-array.join",
		  	"es.typed-array.last-index-of",
		  	"es.typed-array.map",
		  	"es.typed-array.of",
		  	"es.typed-array.reduce",
		  	"es.typed-array.reduce-right",
		  	"es.typed-array.reverse",
		  	"es.typed-array.set",
		  	"es.typed-array.slice",
		  	"es.typed-array.some",
		  	"es.typed-array.sort",
		  	"es.typed-array.subarray",
		  	"es.typed-array.to-locale-string",
		  	"es.typed-array.to-reversed",
		  	"es.typed-array.to-sorted",
		  	"es.typed-array.to-string",
		  	"es.typed-array.with",
		  	"es.unescape",
		  	"es.weak-map",
		  	"es.weak-set",
		  	"web.atob",
		  	"web.btoa",
		  	"web.dom-collections.for-each",
		  	"web.dom-collections.iterator",
		  	"web.dom-exception.constructor",
		  	"web.dom-exception.stack",
		  	"web.dom-exception.to-string-tag",
		  	"web.immediate",
		  	"web.queue-microtask",
		  	"web.self",
		  	"web.structured-clone",
		  	"web.timers",
		  	"web.url",
		  	"web.url.can-parse",
		  	"web.url.to-json",
		  	"web.url-search-params",
		  	"web.url-search-params.delete",
		  	"web.url-search-params.has",
		  	"web.url-search-params.size"
		  ],
		  	"core-js/stable/aggregate-error": [
		  ],
		  	"core-js/stable/array": [
		  	"es.array.at",
		  	"es.array.concat",
		  	"es.array.copy-within",
		  	"es.array.every",
		  	"es.array.fill",
		  	"es.array.filter",
		  	"es.array.find",
		  	"es.array.find-index",
		  	"es.array.find-last",
		  	"es.array.find-last-index",
		  	"es.array.flat",
		  	"es.array.flat-map",
		  	"es.array.for-each",
		  	"es.array.from",
		  	"es.array.includes",
		  	"es.array.index-of",
		  	"es.array.is-array",
		  	"es.array.iterator",
		  	"es.array.join",
		  	"es.array.last-index-of",
		  	"es.array.map",
		  	"es.array.of",
		  	"es.array.push",
		  	"es.array.reduce",
		  	"es.array.reduce-right",
		  	"es.array.reverse",
		  	"es.array.slice",
		  	"es.array.some",
		  	"es.array.sort",
		  	"es.array.species",
		  	"es.array.splice",
		  	"es.array.to-reversed",
		  	"es.array.to-sorted",
		  	"es.array.to-spliced",
		  	"es.array.unscopables.flat",
		  	"es.array.unscopables.flat-map",
		  	"es.array.unshift",
		  	"es.array.with",
		  	"es.object.to-string",
		  	"es.string.iterator"
		  ],
		  	"core-js/stable/array-buffer": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.is-view",
		  	"es.array-buffer.slice",
		  	"es.data-view",
		  	"es.array-buffer.detached",
		  	"es.array-buffer.transfer",
		  	"es.array-buffer.transfer-to-fixed-length",
		  	"es.object.to-string"
		  ],
		  	"core-js/stable/array-buffer/constructor": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.array-buffer.detached",
		  	"es.array-buffer.transfer",
		  	"es.array-buffer.transfer-to-fixed-length",
		  	"es.object.to-string"
		  ],
		  	"core-js/stable/array-buffer/detached": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.array-buffer.detached"
		  ],
		  	"core-js/stable/array-buffer/is-view": [
		  	"es.array-buffer.is-view"
		  ],
		  	"core-js/stable/array-buffer/slice": [
		  	"es.array-buffer.slice"
		  ],
		  	"core-js/stable/array-buffer/transfer": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.data-view",
		  	"es.array-buffer.transfer"
		  ],
		  	"core-js/stable/array-buffer/transfer-to-fixed-length": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.data-view",
		  	"es.array-buffer.transfer-to-fixed-length"
		  ],
		  	"core-js/stable/array/at": [
		  	"es.array.at"
		  ],
		  	"core-js/stable/array/concat": [
		  	"es.array.concat"
		  ],
		  	"core-js/stable/array/copy-within": [
		  	"es.array.copy-within"
		  ],
		  	"core-js/stable/array/entries": [
		  	"es.array.iterator",
		  	"es.object.to-string"
		  ],
		  	"core-js/stable/array/every": [
		  	"es.array.every"
		  ],
		  	"core-js/stable/array/fill": [
		  	"es.array.fill"
		  ],
		  	"core-js/stable/array/filter": [
		  	"es.array.filter"
		  ],
		  	"core-js/stable/array/find": [
		  	"es.array.find"
		  ],
		  	"core-js/stable/array/find-index": [
		  	"es.array.find-index"
		  ],
		  	"core-js/stable/array/find-last": [
		  	"es.array.find-last"
		  ],
		  	"core-js/stable/array/find-last-index": [
		  	"es.array.find-last-index"
		  ],
		  	"core-js/stable/array/flat": [
		  	"es.array.flat",
		  	"es.array.unscopables.flat"
		  ],
		  	"core-js/stable/array/flat-map": [
		  	"es.array.flat-map",
		  	"es.array.unscopables.flat-map"
		  ],
		  	"core-js/stable/array/for-each": [
		  	"es.array.for-each"
		  ],
		  	"core-js/stable/array/from": [
		  	"es.array.from",
		  	"es.string.iterator"
		  ],
		  	"core-js/stable/array/includes": [
		  	"es.array.includes"
		  ],
		  	"core-js/stable/array/index-of": [
		  	"es.array.index-of"
		  ],
		  	"core-js/stable/array/is-array": [
		  	"es.array.is-array"
		  ],
		  	"core-js/stable/array/iterator": [
		  	"es.array.iterator",
		  	"es.object.to-string"
		  ],
		  	"core-js/stable/array/join": [
		  	"es.array.join"
		  ],
		  	"core-js/stable/array/keys": [
		  	"es.array.iterator",
		  	"es.object.to-string"
		  ],
		  	"core-js/stable/array/last-index-of": [
		  	"es.array.last-index-of"
		  ],
		  	"core-js/stable/array/map": [
		  	"es.array.map"
		  ],
		  	"core-js/stable/array/of": [
		  	"es.array.of"
		  ],
		  	"core-js/stable/array/push": [
		  	"es.array.push"
		  ],
		  	"core-js/stable/array/reduce": [
		  	"es.array.reduce"
		  ],
		  	"core-js/stable/array/reduce-right": [
		  	"es.array.reduce-right"
		  ],
		  	"core-js/stable/array/reverse": [
		  	"es.array.reverse"
		  ],
		  	"core-js/stable/array/slice": [
		  	"es.array.slice"
		  ],
		  	"core-js/stable/array/some": [
		  	"es.array.some"
		  ],
		  	"core-js/stable/array/sort": [
		  	"es.array.sort"
		  ],
		  	"core-js/stable/array/splice": [
		  	"es.array.splice"
		  ],
		  	"core-js/stable/array/to-reversed": [
		  	"es.array.to-reversed"
		  ],
		  	"core-js/stable/array/to-sorted": [
		  	"es.array.sort",
		  	"es.array.to-sorted"
		  ],
		  	"core-js/stable/array/to-spliced": [
		  	"es.array.to-spliced"
		  ],
		  	"core-js/stable/array/unshift": [
		  	"es.array.unshift"
		  ],
		  	"core-js/stable/array/values": [
		  	"es.array.iterator",
		  	"es.object.to-string"
		  ],
		  	"core-js/stable/array/virtual": [
		  	"es.array.at",
		  	"es.array.concat",
		  	"es.array.copy-within",
		  	"es.array.every",
		  	"es.array.fill",
		  	"es.array.filter",
		  	"es.array.find",
		  	"es.array.find-index",
		  	"es.array.find-last",
		  	"es.array.find-last-index",
		  	"es.array.flat",
		  	"es.array.flat-map",
		  	"es.array.for-each",
		  	"es.array.includes",
		  	"es.array.index-of",
		  	"es.array.iterator",
		  	"es.array.join",
		  	"es.array.last-index-of",
		  	"es.array.map",
		  	"es.array.push",
		  	"es.array.reduce",
		  	"es.array.reduce-right",
		  	"es.array.reverse",
		  	"es.array.slice",
		  	"es.array.some",
		  	"es.array.sort",
		  	"es.array.species",
		  	"es.array.splice",
		  	"es.array.to-reversed",
		  	"es.array.to-sorted",
		  	"es.array.to-spliced",
		  	"es.array.unscopables.flat",
		  	"es.array.unscopables.flat-map",
		  	"es.array.unshift",
		  	"es.array.with",
		  	"es.object.to-string"
		  ],
		  	"core-js/stable/array/virtual/at": [
		  	"es.array.at"
		  ],
		  	"core-js/stable/array/virtual/concat": [
		  	"es.array.concat"
		  ],
		  	"core-js/stable/array/virtual/copy-within": [
		  	"es.array.copy-within"
		  ],
		  	"core-js/stable/array/virtual/entries": [
		  	"es.array.iterator",
		  	"es.object.to-string"
		  ],
		  	"core-js/stable/array/virtual/every": [
		  	"es.array.every"
		  ],
		  	"core-js/stable/array/virtual/fill": [
		  	"es.array.fill"
		  ],
		  	"core-js/stable/array/virtual/filter": [
		  	"es.array.filter"
		  ],
		  	"core-js/stable/array/virtual/find": [
		  	"es.array.find"
		  ],
		  	"core-js/stable/array/virtual/find-index": [
		  	"es.array.find-index"
		  ],
		  	"core-js/stable/array/virtual/find-last": [
		  	"es.array.find-last"
		  ],
		  	"core-js/stable/array/virtual/find-last-index": [
		  	"es.array.find-last-index"
		  ],
		  	"core-js/stable/array/virtual/flat": [
		  	"es.array.flat",
		  	"es.array.unscopables.flat"
		  ],
		  	"core-js/stable/array/virtual/flat-map": [
		  	"es.array.flat-map",
		  	"es.array.unscopables.flat-map"
		  ],
		  	"core-js/stable/array/virtual/for-each": [
		  	"es.array.for-each"
		  ],
		  	"core-js/stable/array/virtual/includes": [
		  	"es.array.includes"
		  ],
		  	"core-js/stable/array/virtual/index-of": [
		  	"es.array.index-of"
		  ],
		  	"core-js/stable/array/virtual/iterator": [
		  	"es.array.iterator",
		  	"es.object.to-string"
		  ],
		  	"core-js/stable/array/virtual/join": [
		  	"es.array.join"
		  ],
		  	"core-js/stable/array/virtual/keys": [
		  	"es.array.iterator",
		  	"es.object.to-string"
		  ],
		  	"core-js/stable/array/virtual/last-index-of": [
		  	"es.array.last-index-of"
		  ],
		  	"core-js/stable/array/virtual/map": [
		  	"es.array.map"
		  ],
		  	"core-js/stable/array/virtual/push": [
		  	"es.array.push"
		  ],
		  	"core-js/stable/array/virtual/reduce": [
		  	"es.array.reduce"
		  ],
		  	"core-js/stable/array/virtual/reduce-right": [
		  	"es.array.reduce-right"
		  ],
		  	"core-js/stable/array/virtual/reverse": [
		  	"es.array.reverse"
		  ],
		  	"core-js/stable/array/virtual/slice": [
		  	"es.array.slice"
		  ],
		  	"core-js/stable/array/virtual/some": [
		  	"es.array.some"
		  ],
		  	"core-js/stable/array/virtual/sort": [
		  	"es.array.sort"
		  ],
		  	"core-js/stable/array/virtual/splice": [
		  	"es.array.splice"
		  ],
		  	"core-js/stable/array/virtual/to-reversed": [
		  	"es.array.to-reversed"
		  ],
		  	"core-js/stable/array/virtual/to-sorted": [
		  	"es.array.sort",
		  	"es.array.to-sorted"
		  ],
		  	"core-js/stable/array/virtual/to-spliced": [
		  	"es.array.to-spliced"
		  ],
		  	"core-js/stable/array/virtual/unshift": [
		  	"es.array.unshift"
		  ],
		  	"core-js/stable/array/virtual/values": [
		  	"es.array.iterator",
		  	"es.object.to-string"
		  ],
		  	"core-js/stable/array/virtual/with": [
		  	"es.array.with"
		  ],
		  	"core-js/stable/array/with": [
		  	"es.array.with"
		  ],
		  	"core-js/stable/atob": [
		  	"es.error.to-string",
		  	"es.object.to-string",
		  	"web.atob",
		  	"web.dom-exception.constructor",
		  	"web.dom-exception.stack",
		  	"web.dom-exception.to-string-tag"
		  ],
		  	"core-js/stable/btoa": [
		  	"es.error.to-string",
		  	"es.object.to-string",
		  	"web.btoa",
		  	"web.dom-exception.constructor",
		  	"web.dom-exception.stack",
		  	"web.dom-exception.to-string-tag"
		  ],
		  	"core-js/stable/clear-immediate": [
		  	"web.immediate"
		  ],
		  	"core-js/stable/data-view": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.data-view",
		  	"es.object.to-string"
		  ],
		  	"core-js/stable/date": [
		  	"es.date.get-year",
		  	"es.date.now",
		  	"es.date.set-year",
		  	"es.date.to-gmt-string",
		  	"es.date.to-iso-string",
		  	"es.date.to-json",
		  	"es.date.to-primitive",
		  	"es.date.to-string"
		  ],
		  	"core-js/stable/date/get-year": [
		  	"es.date.get-year"
		  ],
		  	"core-js/stable/date/now": [
		  	"es.date.now"
		  ],
		  	"core-js/stable/date/set-year": [
		  	"es.date.set-year"
		  ],
		  	"core-js/stable/date/to-gmt-string": [
		  	"es.date.to-gmt-string"
		  ],
		  	"core-js/stable/date/to-iso-string": [
		  	"es.date.to-iso-string",
		  	"es.date.to-json"
		  ],
		  	"core-js/stable/date/to-json": [
		  	"es.date.to-json"
		  ],
		  	"core-js/stable/date/to-primitive": [
		  	"es.date.to-primitive"
		  ],
		  	"core-js/stable/date/to-string": [
		  	"es.date.to-string"
		  ],
		  	"core-js/stable/dom-collections": [
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"web.dom-collections.for-each",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/stable/dom-collections/for-each": [
		  	"web.dom-collections.for-each"
		  ],
		  	"core-js/stable/dom-collections/iterator": [
		  	"es.object.to-string",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/stable/dom-exception": [
		  	"es.error.to-string",
		  	"web.dom-exception.constructor",
		  	"web.dom-exception.stack",
		  	"web.dom-exception.to-string-tag"
		  ],
		  	"core-js/stable/dom-exception/constructor": [
		  	"es.error.to-string",
		  	"web.dom-exception.constructor",
		  	"web.dom-exception.stack"
		  ],
		  	"core-js/stable/dom-exception/to-string-tag": [
		  	"web.dom-exception.to-string-tag"
		  ],
		  	"core-js/stable/error": [
		  	"es.error.cause",
		  	"es.error.to-string"
		  ],
		  	"core-js/stable/error/constructor": [
		  	"es.error.cause"
		  ],
		  	"core-js/stable/error/to-string": [
		  	"es.error.to-string"
		  ],
		  	"core-js/stable/escape": [
		  	"es.escape"
		  ],
		  	"core-js/stable/function": [
		  	"es.function.bind",
		  	"es.function.has-instance",
		  	"es.function.name"
		  ],
		  	"core-js/stable/function/bind": [
		  	"es.function.bind"
		  ],
		  	"core-js/stable/function/has-instance": [
		  	"es.function.has-instance"
		  ],
		  	"core-js/stable/function/name": [
		  	"es.function.name"
		  ],
		  	"core-js/stable/function/virtual": [
		  	"es.function.bind"
		  ],
		  	"core-js/stable/function/virtual/bind": [
		  	"es.function.bind"
		  ],
		  	"core-js/stable/get-iterator": [
		  	"es.array.iterator",
		  	"es.string.iterator",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/stable/get-iterator-method": [
		  	"es.array.iterator",
		  	"es.string.iterator",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/stable/global-this": [
		  	"es.global-this"
		  ],
		  	"core-js/stable/instance/at": [
		  	"es.array.at",
		  	"es.string.at-alternative"
		  ],
		  	"core-js/stable/instance/bind": [
		  	"es.function.bind"
		  ],
		  	"core-js/stable/instance/code-point-at": [
		  	"es.string.code-point-at"
		  ],
		  	"core-js/stable/instance/concat": [
		  	"es.array.concat"
		  ],
		  	"core-js/stable/instance/copy-within": [
		  	"es.array.copy-within"
		  ],
		  	"core-js/stable/instance/ends-with": [
		  	"es.string.ends-with"
		  ],
		  	"core-js/stable/instance/entries": [
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/stable/instance/every": [
		  	"es.array.every"
		  ],
		  	"core-js/stable/instance/fill": [
		  	"es.array.fill"
		  ],
		  	"core-js/stable/instance/filter": [
		  	"es.array.filter"
		  ],
		  	"core-js/stable/instance/find": [
		  	"es.array.find"
		  ],
		  	"core-js/stable/instance/find-index": [
		  	"es.array.find-index"
		  ],
		  	"core-js/stable/instance/find-last": [
		  	"es.array.find-last"
		  ],
		  	"core-js/stable/instance/find-last-index": [
		  	"es.array.find-last-index"
		  ],
		  	"core-js/stable/instance/flags": [
		  	"es.regexp.flags"
		  ],
		  	"core-js/stable/instance/flat": [
		  	"es.array.flat",
		  	"es.array.unscopables.flat"
		  ],
		  	"core-js/stable/instance/flat-map": [
		  	"es.array.flat-map",
		  	"es.array.unscopables.flat-map"
		  ],
		  	"core-js/stable/instance/for-each": [
		  	"es.array.for-each",
		  	"web.dom-collections.for-each"
		  ],
		  	"core-js/stable/instance/includes": [
		  	"es.array.includes",
		  	"es.string.includes"
		  ],
		  	"core-js/stable/instance/index-of": [
		  	"es.array.index-of"
		  ],
		  	"core-js/stable/instance/is-well-formed": [
		  	"es.string.is-well-formed"
		  ],
		  	"core-js/stable/instance/keys": [
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/stable/instance/last-index-of": [
		  	"es.array.last-index-of"
		  ],
		  	"core-js/stable/instance/map": [
		  	"es.array.map"
		  ],
		  	"core-js/stable/instance/match-all": [
		  	"es.object.to-string",
		  	"es.regexp.exec",
		  	"es.string.match-all"
		  ],
		  	"core-js/stable/instance/pad-end": [
		  	"es.string.pad-end"
		  ],
		  	"core-js/stable/instance/pad-start": [
		  	"es.string.pad-start"
		  ],
		  	"core-js/stable/instance/push": [
		  	"es.array.push"
		  ],
		  	"core-js/stable/instance/reduce": [
		  	"es.array.reduce"
		  ],
		  	"core-js/stable/instance/reduce-right": [
		  	"es.array.reduce-right"
		  ],
		  	"core-js/stable/instance/repeat": [
		  	"es.string.repeat"
		  ],
		  	"core-js/stable/instance/replace-all": [
		  	"es.regexp.exec",
		  	"es.string.replace",
		  	"es.string.replace-all"
		  ],
		  	"core-js/stable/instance/reverse": [
		  	"es.array.reverse"
		  ],
		  	"core-js/stable/instance/slice": [
		  	"es.array.slice"
		  ],
		  	"core-js/stable/instance/some": [
		  	"es.array.some"
		  ],
		  	"core-js/stable/instance/sort": [
		  	"es.array.sort"
		  ],
		  	"core-js/stable/instance/splice": [
		  	"es.array.splice"
		  ],
		  	"core-js/stable/instance/starts-with": [
		  	"es.string.starts-with"
		  ],
		  	"core-js/stable/instance/to-reversed": [
		  	"es.array.to-reversed"
		  ],
		  	"core-js/stable/instance/to-sorted": [
		  	"es.array.sort",
		  	"es.array.to-sorted"
		  ],
		  	"core-js/stable/instance/to-spliced": [
		  	"es.array.to-spliced"
		  ],
		  	"core-js/stable/instance/to-well-formed": [
		  	"es.string.to-well-formed"
		  ],
		  	"core-js/stable/instance/trim": [
		  	"es.string.trim"
		  ],
		  	"core-js/stable/instance/trim-end": [
		  	"es.string.trim-end"
		  ],
		  	"core-js/stable/instance/trim-left": [
		  	"es.string.trim-start"
		  ],
		  	"core-js/stable/instance/trim-right": [
		  	"es.string.trim-end"
		  ],
		  	"core-js/stable/instance/trim-start": [
		  	"es.string.trim-start"
		  ],
		  	"core-js/stable/instance/unshift": [
		  	"es.array.unshift"
		  ],
		  	"core-js/stable/instance/values": [
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/stable/instance/with": [
		  	"es.array.with"
		  ],
		  	"core-js/stable/is-iterable": [
		  	"es.array.iterator",
		  	"es.string.iterator",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/stable/json": [
		  	"es.date.to-json",
		  	"es.json.stringify",
		  	"es.json.to-string-tag"
		  ],
		  	"core-js/stable/json/stringify": [
		  	"es.date.to-json",
		  	"es.json.stringify"
		  ],
		  	"core-js/stable/json/to-string-tag": [
		  	"es.json.to-string-tag"
		  ],
		  	"core-js/stable/map": [
		  	"es.array.iterator",
		  	"es.map",
		  	"es.map.group-by",
		  	"es.object.to-string",
		  	"es.string.iterator",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/stable/map/group-by": [
		  	"es.map",
		  	"es.map.group-by",
		  	"es.object.to-string"
		  ],
		  	"core-js/stable/math": [
		  	"es.math.acosh",
		  	"es.math.asinh",
		  	"es.math.atanh",
		  	"es.math.cbrt",
		  	"es.math.clz32",
		  	"es.math.cosh",
		  	"es.math.expm1",
		  	"es.math.fround",
		  	"es.math.hypot",
		  	"es.math.imul",
		  	"es.math.log10",
		  	"es.math.log1p",
		  	"es.math.log2",
		  	"es.math.sign",
		  	"es.math.sinh",
		  	"es.math.tanh",
		  	"es.math.to-string-tag",
		  	"es.math.trunc"
		  ],
		  	"core-js/stable/math/acosh": [
		  	"es.math.acosh"
		  ],
		  	"core-js/stable/math/asinh": [
		  	"es.math.asinh"
		  ],
		  	"core-js/stable/math/atanh": [
		  	"es.math.atanh"
		  ],
		  	"core-js/stable/math/cbrt": [
		  	"es.math.cbrt"
		  ],
		  	"core-js/stable/math/clz32": [
		  	"es.math.clz32"
		  ],
		  	"core-js/stable/math/cosh": [
		  	"es.math.cosh"
		  ],
		  	"core-js/stable/math/expm1": [
		  	"es.math.expm1"
		  ],
		  	"core-js/stable/math/fround": [
		  	"es.math.fround"
		  ],
		  	"core-js/stable/math/hypot": [
		  	"es.math.hypot"
		  ],
		  	"core-js/stable/math/imul": [
		  	"es.math.imul"
		  ],
		  	"core-js/stable/math/log10": [
		  	"es.math.log10"
		  ],
		  	"core-js/stable/math/log1p": [
		  	"es.math.log1p"
		  ],
		  	"core-js/stable/math/log2": [
		  	"es.math.log2"
		  ],
		  	"core-js/stable/math/sign": [
		  	"es.math.sign"
		  ],
		  	"core-js/stable/math/sinh": [
		  	"es.math.sinh"
		  ],
		  	"core-js/stable/math/tanh": [
		  	"es.math.tanh"
		  ],
		  	"core-js/stable/math/to-string-tag": [
		  	"es.math.to-string-tag"
		  ],
		  	"core-js/stable/math/trunc": [
		  	"es.math.trunc"
		  ],
		  	"core-js/stable/number": [
		  	"es.number.constructor",
		  	"es.number.epsilon",
		  	"es.number.is-finite",
		  	"es.number.is-integer",
		  	"es.number.is-nan",
		  	"es.number.is-safe-integer",
		  	"es.number.max-safe-integer",
		  	"es.number.min-safe-integer",
		  	"es.number.parse-float",
		  	"es.number.parse-int",
		  	"es.number.to-exponential",
		  	"es.number.to-fixed",
		  	"es.number.to-precision"
		  ],
		  	"core-js/stable/number/constructor": [
		  	"es.number.constructor"
		  ],
		  	"core-js/stable/number/epsilon": [
		  	"es.number.epsilon"
		  ],
		  	"core-js/stable/number/is-finite": [
		  	"es.number.is-finite"
		  ],
		  	"core-js/stable/number/is-integer": [
		  	"es.number.is-integer"
		  ],
		  	"core-js/stable/number/is-nan": [
		  	"es.number.is-nan"
		  ],
		  	"core-js/stable/number/is-safe-integer": [
		  	"es.number.is-safe-integer"
		  ],
		  	"core-js/stable/number/max-safe-integer": [
		  	"es.number.max-safe-integer"
		  ],
		  	"core-js/stable/number/min-safe-integer": [
		  	"es.number.min-safe-integer"
		  ],
		  	"core-js/stable/number/parse-float": [
		  	"es.number.parse-float"
		  ],
		  	"core-js/stable/number/parse-int": [
		  	"es.number.parse-int"
		  ],
		  	"core-js/stable/number/to-exponential": [
		  	"es.number.to-exponential"
		  ],
		  	"core-js/stable/number/to-fixed": [
		  	"es.number.to-fixed"
		  ],
		  	"core-js/stable/number/to-precision": [
		  	"es.number.to-precision"
		  ],
		  	"core-js/stable/number/virtual": [
		  	"es.number.to-exponential",
		  	"es.number.to-fixed",
		  	"es.number.to-precision"
		  ],
		  	"core-js/stable/number/virtual/to-exponential": [
		  	"es.number.to-exponential"
		  ],
		  	"core-js/stable/number/virtual/to-fixed": [
		  	"es.number.to-fixed"
		  ],
		  	"core-js/stable/number/virtual/to-precision": [
		  	"es.number.to-precision"
		  ],
		  	"core-js/stable/object": [
		  	"es.symbol",
		  	"es.json.to-string-tag",
		  	"es.math.to-string-tag",
		  	"es.object.assign",
		  	"es.object.create",
		  	"es.object.define-getter",
		  	"es.object.define-properties",
		  	"es.object.define-property",
		  	"es.object.define-setter",
		  	"es.object.entries",
		  	"es.object.freeze",
		  	"es.object.from-entries",
		  	"es.object.get-own-property-descriptor",
		  	"es.object.get-own-property-descriptors",
		  	"es.object.get-own-property-names",
		  	"es.object.get-prototype-of",
		  	"es.object.group-by",
		  	"es.object.has-own",
		  	"es.object.is",
		  	"es.object.is-extensible",
		  	"es.object.is-frozen",
		  	"es.object.is-sealed",
		  	"es.object.keys",
		  	"es.object.lookup-getter",
		  	"es.object.lookup-setter",
		  	"es.object.prevent-extensions",
		  	"es.object.proto",
		  	"es.object.seal",
		  	"es.object.set-prototype-of",
		  	"es.object.to-string",
		  	"es.object.values",
		  	"es.reflect.to-string-tag",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/stable/object/assign": [
		  	"es.object.assign"
		  ],
		  	"core-js/stable/object/create": [
		  	"es.object.create"
		  ],
		  	"core-js/stable/object/define-getter": [
		  	"es.object.define-getter"
		  ],
		  	"core-js/stable/object/define-properties": [
		  	"es.object.define-properties"
		  ],
		  	"core-js/stable/object/define-property": [
		  	"es.object.define-property"
		  ],
		  	"core-js/stable/object/define-setter": [
		  	"es.object.define-setter"
		  ],
		  	"core-js/stable/object/entries": [
		  	"es.object.entries"
		  ],
		  	"core-js/stable/object/freeze": [
		  	"es.object.freeze"
		  ],
		  	"core-js/stable/object/from-entries": [
		  	"es.array.iterator",
		  	"es.object.from-entries",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/stable/object/get-own-property-descriptor": [
		  	"es.object.get-own-property-descriptor"
		  ],
		  	"core-js/stable/object/get-own-property-descriptors": [
		  	"es.object.get-own-property-descriptors"
		  ],
		  	"core-js/stable/object/get-own-property-names": [
		  	"es.object.get-own-property-names"
		  ],
		  	"core-js/stable/object/get-own-property-symbols": [
		  	"es.symbol"
		  ],
		  	"core-js/stable/object/get-prototype-of": [
		  	"es.object.get-prototype-of"
		  ],
		  	"core-js/stable/object/group-by": [
		  	"es.object.create",
		  	"es.object.group-by"
		  ],
		  	"core-js/stable/object/has-own": [
		  	"es.object.has-own"
		  ],
		  	"core-js/stable/object/is": [
		  	"es.object.is"
		  ],
		  	"core-js/stable/object/is-extensible": [
		  	"es.object.is-extensible"
		  ],
		  	"core-js/stable/object/is-frozen": [
		  	"es.object.is-frozen"
		  ],
		  	"core-js/stable/object/is-sealed": [
		  	"es.object.is-sealed"
		  ],
		  	"core-js/stable/object/keys": [
		  	"es.object.keys"
		  ],
		  	"core-js/stable/object/lookup-getter": [
		  	"es.object.lookup-getter"
		  ],
		  	"core-js/stable/object/lookup-setter": [
		  	"es.object.lookup-setter"
		  ],
		  	"core-js/stable/object/prevent-extensions": [
		  	"es.object.prevent-extensions"
		  ],
		  	"core-js/stable/object/proto": [
		  	"es.object.proto"
		  ],
		  	"core-js/stable/object/seal": [
		  	"es.object.seal"
		  ],
		  	"core-js/stable/object/set-prototype-of": [
		  	"es.object.set-prototype-of"
		  ],
		  	"core-js/stable/object/to-string": [
		  	"es.json.to-string-tag",
		  	"es.math.to-string-tag",
		  	"es.object.to-string",
		  	"es.reflect.to-string-tag"
		  ],
		  	"core-js/stable/object/values": [
		  	"es.object.values"
		  ],
		  	"core-js/stable/parse-float": [
		  	"es.parse-float"
		  ],
		  	"core-js/stable/parse-int": [
		  	"es.parse-int"
		  ],
		  	"core-js/stable/promise": [
		  	"es.aggregate-error",
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"es.promise",
		  	"es.promise.all-settled",
		  	"es.promise.any",
		  	"es.promise.finally",
		  	"es.promise.with-resolvers",
		  	"es.string.iterator",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/stable/promise/all-settled": [
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"es.promise",
		  	"es.promise.all-settled",
		  	"es.string.iterator",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/stable/promise/any": [
		  	"es.aggregate-error",
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"es.promise",
		  	"es.promise.any",
		  	"es.string.iterator",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/stable/promise/finally": [
		  	"es.object.to-string",
		  	"es.promise",
		  	"es.promise.finally"
		  ],
		  	"core-js/stable/promise/with-resolvers": [
		  	"es.promise",
		  	"es.promise.with-resolvers"
		  ],
		  	"core-js/stable/queue-microtask": [
		  	"web.queue-microtask"
		  ],
		  	"core-js/stable/reflect": [
		  	"es.object.to-string",
		  	"es.reflect.apply",
		  	"es.reflect.construct",
		  	"es.reflect.define-property",
		  	"es.reflect.delete-property",
		  	"es.reflect.get",
		  	"es.reflect.get-own-property-descriptor",
		  	"es.reflect.get-prototype-of",
		  	"es.reflect.has",
		  	"es.reflect.is-extensible",
		  	"es.reflect.own-keys",
		  	"es.reflect.prevent-extensions",
		  	"es.reflect.set",
		  	"es.reflect.set-prototype-of",
		  	"es.reflect.to-string-tag"
		  ],
		  	"core-js/stable/reflect/apply": [
		  	"es.reflect.apply"
		  ],
		  	"core-js/stable/reflect/construct": [
		  	"es.reflect.construct"
		  ],
		  	"core-js/stable/reflect/define-property": [
		  	"es.reflect.define-property"
		  ],
		  	"core-js/stable/reflect/delete-property": [
		  	"es.reflect.delete-property"
		  ],
		  	"core-js/stable/reflect/get": [
		  	"es.reflect.get"
		  ],
		  	"core-js/stable/reflect/get-own-property-descriptor": [
		  	"es.reflect.get-own-property-descriptor"
		  ],
		  	"core-js/stable/reflect/get-prototype-of": [
		  	"es.reflect.get-prototype-of"
		  ],
		  	"core-js/stable/reflect/has": [
		  	"es.reflect.has"
		  ],
		  	"core-js/stable/reflect/is-extensible": [
		  	"es.reflect.is-extensible"
		  ],
		  	"core-js/stable/reflect/own-keys": [
		  	"es.reflect.own-keys"
		  ],
		  	"core-js/stable/reflect/prevent-extensions": [
		  	"es.reflect.prevent-extensions"
		  ],
		  	"core-js/stable/reflect/set": [
		  	"es.reflect.set"
		  ],
		  	"core-js/stable/reflect/set-prototype-of": [
		  	"es.reflect.set-prototype-of"
		  ],
		  	"core-js/stable/reflect/to-string-tag": [
		  	"es.reflect.to-string-tag"
		  ],
		  	"core-js/stable/regexp": [
		  	"es.regexp.constructor",
		  	"es.regexp.dot-all",
		  	"es.regexp.exec",
		  	"es.regexp.flags",
		  	"es.regexp.sticky",
		  	"es.regexp.test",
		  	"es.regexp.to-string",
		  	"es.string.match",
		  	"es.string.replace",
		  	"es.string.search",
		  	"es.string.split"
		  ],
		  	"core-js/stable/regexp/constructor": [
		  	"es.regexp.constructor",
		  	"es.regexp.dot-all",
		  	"es.regexp.exec",
		  	"es.regexp.sticky"
		  ],
		  	"core-js/stable/regexp/dot-all": [
		  	"es.regexp.constructor",
		  	"es.regexp.dot-all",
		  	"es.regexp.exec"
		  ],
		  	"core-js/stable/regexp/flags": [
		  	"es.regexp.flags"
		  ],
		  	"core-js/stable/regexp/match": [
		  	"es.regexp.exec",
		  	"es.string.match"
		  ],
		  	"core-js/stable/regexp/replace": [
		  	"es.regexp.exec",
		  	"es.string.replace"
		  ],
		  	"core-js/stable/regexp/search": [
		  	"es.regexp.exec",
		  	"es.string.search"
		  ],
		  	"core-js/stable/regexp/split": [
		  	"es.regexp.exec",
		  	"es.string.split"
		  ],
		  	"core-js/stable/regexp/sticky": [
		  	"es.regexp.constructor",
		  	"es.regexp.exec",
		  	"es.regexp.sticky"
		  ],
		  	"core-js/stable/regexp/test": [
		  	"es.regexp.exec",
		  	"es.regexp.test"
		  ],
		  	"core-js/stable/regexp/to-string": [
		  	"es.regexp.to-string"
		  ],
		  	"core-js/stable/self": [
		  	"web.self"
		  ],
		  	"core-js/stable/set": [
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"es.set",
		  	"es.string.iterator",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/stable/set-immediate": [
		  	"web.immediate"
		  ],
		  	"core-js/stable/set-interval": [
		  	"web.timers"
		  ],
		  	"core-js/stable/set-timeout": [
		  	"web.timers"
		  ],
		  	"core-js/stable/string": [
		  	"es.object.to-string",
		  	"es.regexp.exec",
		  	"es.string.at-alternative",
		  	"es.string.code-point-at",
		  	"es.string.ends-with",
		  	"es.string.from-code-point",
		  	"es.string.includes",
		  	"es.string.is-well-formed",
		  	"es.string.iterator",
		  	"es.string.match",
		  	"es.string.match-all",
		  	"es.string.pad-end",
		  	"es.string.pad-start",
		  	"es.string.raw",
		  	"es.string.repeat",
		  	"es.string.replace",
		  	"es.string.replace-all",
		  	"es.string.search",
		  	"es.string.split",
		  	"es.string.starts-with",
		  	"es.string.substr",
		  	"es.string.to-well-formed",
		  	"es.string.trim",
		  	"es.string.trim-end",
		  	"es.string.trim-start",
		  	"es.string.anchor",
		  	"es.string.big",
		  	"es.string.blink",
		  	"es.string.bold",
		  	"es.string.fixed",
		  	"es.string.fontcolor",
		  	"es.string.fontsize",
		  	"es.string.italics",
		  	"es.string.link",
		  	"es.string.small",
		  	"es.string.strike",
		  	"es.string.sub",
		  	"es.string.sup"
		  ],
		  	"core-js/stable/string/anchor": [
		  	"es.string.anchor"
		  ],
		  	"core-js/stable/string/at": [
		  	"es.string.at-alternative"
		  ],
		  	"core-js/stable/string/big": [
		  	"es.string.big"
		  ],
		  	"core-js/stable/string/blink": [
		  	"es.string.blink"
		  ],
		  	"core-js/stable/string/bold": [
		  	"es.string.bold"
		  ],
		  	"core-js/stable/string/code-point-at": [
		  	"es.string.code-point-at"
		  ],
		  	"core-js/stable/string/ends-with": [
		  	"es.string.ends-with"
		  ],
		  	"core-js/stable/string/fixed": [
		  	"es.string.fixed"
		  ],
		  	"core-js/stable/string/fontcolor": [
		  	"es.string.fontcolor"
		  ],
		  	"core-js/stable/string/fontsize": [
		  	"es.string.fontsize"
		  ],
		  	"core-js/stable/string/from-code-point": [
		  	"es.string.from-code-point"
		  ],
		  	"core-js/stable/string/includes": [
		  	"es.string.includes"
		  ],
		  	"core-js/stable/string/is-well-formed": [
		  	"es.string.is-well-formed"
		  ],
		  	"core-js/stable/string/italics": [
		  	"es.string.italics"
		  ],
		  	"core-js/stable/string/iterator": [
		  	"es.object.to-string",
		  	"es.string.iterator"
		  ],
		  	"core-js/stable/string/link": [
		  	"es.string.link"
		  ],
		  	"core-js/stable/string/match": [
		  	"es.regexp.exec",
		  	"es.string.match"
		  ],
		  	"core-js/stable/string/match-all": [
		  	"es.object.to-string",
		  	"es.regexp.exec",
		  	"es.string.match-all"
		  ],
		  	"core-js/stable/string/pad-end": [
		  	"es.string.pad-end"
		  ],
		  	"core-js/stable/string/pad-start": [
		  	"es.string.pad-start"
		  ],
		  	"core-js/stable/string/raw": [
		  	"es.string.raw"
		  ],
		  	"core-js/stable/string/repeat": [
		  	"es.string.repeat"
		  ],
		  	"core-js/stable/string/replace": [
		  	"es.regexp.exec",
		  	"es.string.replace"
		  ],
		  	"core-js/stable/string/replace-all": [
		  	"es.regexp.exec",
		  	"es.string.replace",
		  	"es.string.replace-all"
		  ],
		  	"core-js/stable/string/search": [
		  	"es.regexp.exec",
		  	"es.string.search"
		  ],
		  	"core-js/stable/string/small": [
		  	"es.string.small"
		  ],
		  	"core-js/stable/string/split": [
		  	"es.regexp.exec",
		  	"es.string.split"
		  ],
		  	"core-js/stable/string/starts-with": [
		  	"es.string.starts-with"
		  ],
		  	"core-js/stable/string/strike": [
		  	"es.string.strike"
		  ],
		  	"core-js/stable/string/sub": [
		  	"es.string.sub"
		  ],
		  	"core-js/stable/string/substr": [
		  	"es.string.substr"
		  ],
		  	"core-js/stable/string/sup": [
		  	"es.string.sup"
		  ],
		  	"core-js/stable/string/to-well-formed": [
		  	"es.string.to-well-formed"
		  ],
		  	"core-js/stable/string/trim": [
		  	"es.string.trim"
		  ],
		  	"core-js/stable/string/trim-end": [
		  	"es.string.trim-end"
		  ],
		  	"core-js/stable/string/trim-left": [
		  	"es.string.trim-start"
		  ],
		  	"core-js/stable/string/trim-right": [
		  	"es.string.trim-end"
		  ],
		  	"core-js/stable/string/trim-start": [
		  	"es.string.trim-start"
		  ],
		  	"core-js/stable/string/virtual": [
		  	"es.object.to-string",
		  	"es.regexp.exec",
		  	"es.string.at-alternative",
		  	"es.string.code-point-at",
		  	"es.string.ends-with",
		  	"es.string.includes",
		  	"es.string.iterator",
		  	"es.string.match",
		  	"es.string.match-all",
		  	"es.string.pad-end",
		  	"es.string.pad-start",
		  	"es.string.repeat",
		  	"es.string.replace",
		  	"es.string.replace-all",
		  	"es.string.search",
		  	"es.string.split",
		  	"es.string.starts-with",
		  	"es.string.substr",
		  	"es.string.trim",
		  	"es.string.trim-end",
		  	"es.string.trim-start",
		  	"es.string.anchor",
		  	"es.string.big",
		  	"es.string.blink",
		  	"es.string.bold",
		  	"es.string.fixed",
		  	"es.string.fontcolor",
		  	"es.string.fontsize",
		  	"es.string.italics",
		  	"es.string.link",
		  	"es.string.small",
		  	"es.string.strike",
		  	"es.string.sub",
		  	"es.string.sup"
		  ],
		  	"core-js/stable/string/virtual/anchor": [
		  	"es.string.anchor"
		  ],
		  	"core-js/stable/string/virtual/at": [
		  	"es.string.at-alternative"
		  ],
		  	"core-js/stable/string/virtual/big": [
		  	"es.string.big"
		  ],
		  	"core-js/stable/string/virtual/blink": [
		  	"es.string.blink"
		  ],
		  	"core-js/stable/string/virtual/bold": [
		  	"es.string.bold"
		  ],
		  	"core-js/stable/string/virtual/code-point-at": [
		  	"es.string.code-point-at"
		  ],
		  	"core-js/stable/string/virtual/ends-with": [
		  	"es.string.ends-with"
		  ],
		  	"core-js/stable/string/virtual/fixed": [
		  	"es.string.fixed"
		  ],
		  	"core-js/stable/string/virtual/fontcolor": [
		  	"es.string.fontcolor"
		  ],
		  	"core-js/stable/string/virtual/fontsize": [
		  	"es.string.fontsize"
		  ],
		  	"core-js/stable/string/virtual/includes": [
		  	"es.string.includes"
		  ],
		  	"core-js/stable/string/virtual/is-well-formed": [
		  	"es.string.is-well-formed"
		  ],
		  	"core-js/stable/string/virtual/italics": [
		  	"es.string.italics"
		  ],
		  	"core-js/stable/string/virtual/iterator": [
		  	"es.object.to-string",
		  	"es.string.iterator"
		  ],
		  	"core-js/stable/string/virtual/link": [
		  	"es.string.link"
		  ],
		  	"core-js/stable/string/virtual/match-all": [
		  	"es.object.to-string",
		  	"es.regexp.exec",
		  	"es.string.match-all"
		  ],
		  	"core-js/stable/string/virtual/pad-end": [
		  	"es.string.pad-end"
		  ],
		  	"core-js/stable/string/virtual/pad-start": [
		  	"es.string.pad-start"
		  ],
		  	"core-js/stable/string/virtual/repeat": [
		  	"es.string.repeat"
		  ],
		  	"core-js/stable/string/virtual/replace-all": [
		  	"es.regexp.exec",
		  	"es.string.replace",
		  	"es.string.replace-all"
		  ],
		  	"core-js/stable/string/virtual/small": [
		  	"es.string.small"
		  ],
		  	"core-js/stable/string/virtual/starts-with": [
		  	"es.string.starts-with"
		  ],
		  	"core-js/stable/string/virtual/strike": [
		  	"es.string.strike"
		  ],
		  	"core-js/stable/string/virtual/sub": [
		  	"es.string.sub"
		  ],
		  	"core-js/stable/string/virtual/substr": [
		  	"es.string.substr"
		  ],
		  	"core-js/stable/string/virtual/sup": [
		  	"es.string.sup"
		  ],
		  	"core-js/stable/string/virtual/to-well-formed": [
		  	"es.string.to-well-formed"
		  ],
		  	"core-js/stable/string/virtual/trim": [
		  	"es.string.trim"
		  ],
		  	"core-js/stable/string/virtual/trim-end": [
		  	"es.string.trim-end"
		  ],
		  	"core-js/stable/string/virtual/trim-left": [
		  	"es.string.trim-start"
		  ],
		  	"core-js/stable/string/virtual/trim-right": [
		  	"es.string.trim-end"
		  ],
		  	"core-js/stable/string/virtual/trim-start": [
		  	"es.string.trim-start"
		  ],
		  	"core-js/stable/structured-clone": [
		  	"es.error.to-string",
		  	"es.array.iterator",
		  	"es.map",
		  	"es.object.keys",
		  	"es.object.to-string",
		  	"es.set",
		  	"web.dom-exception.constructor",
		  	"web.dom-exception.stack",
		  	"web.dom-exception.to-string-tag",
		  	"web.structured-clone"
		  ],
		  	"core-js/stable/symbol": [
		  	"es.symbol",
		  	"es.symbol.description",
		  	"es.symbol.async-iterator",
		  	"es.symbol.has-instance",
		  	"es.symbol.is-concat-spreadable",
		  	"es.symbol.iterator",
		  	"es.symbol.match",
		  	"es.symbol.match-all",
		  	"es.symbol.replace",
		  	"es.symbol.search",
		  	"es.symbol.species",
		  	"es.symbol.split",
		  	"es.symbol.to-primitive",
		  	"es.symbol.to-string-tag",
		  	"es.symbol.unscopables",
		  	"es.array.concat",
		  	"es.json.to-string-tag",
		  	"es.math.to-string-tag",
		  	"es.object.to-string",
		  	"es.reflect.to-string-tag",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/stable/symbol/async-iterator": [
		  	"es.symbol.async-iterator"
		  ],
		  	"core-js/stable/symbol/description": [
		  	"es.symbol.description"
		  ],
		  	"core-js/stable/symbol/for": [
		  	"es.symbol"
		  ],
		  	"core-js/stable/symbol/has-instance": [
		  	"es.symbol.has-instance",
		  	"es.function.has-instance"
		  ],
		  	"core-js/stable/symbol/is-concat-spreadable": [
		  	"es.symbol.is-concat-spreadable",
		  	"es.array.concat"
		  ],
		  	"core-js/stable/symbol/iterator": [
		  	"es.symbol.iterator",
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"es.string.iterator",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/stable/symbol/key-for": [
		  	"es.symbol"
		  ],
		  	"core-js/stable/symbol/match": [
		  	"es.symbol.match",
		  	"es.regexp.exec",
		  	"es.string.match"
		  ],
		  	"core-js/stable/symbol/match-all": [
		  	"es.symbol.match-all",
		  	"es.object.to-string",
		  	"es.regexp.exec",
		  	"es.string.match-all"
		  ],
		  	"core-js/stable/symbol/replace": [
		  	"es.symbol.replace",
		  	"es.regexp.exec",
		  	"es.string.replace"
		  ],
		  	"core-js/stable/symbol/search": [
		  	"es.symbol.search",
		  	"es.regexp.exec",
		  	"es.string.search"
		  ],
		  	"core-js/stable/symbol/species": [
		  	"es.symbol.species"
		  ],
		  	"core-js/stable/symbol/split": [
		  	"es.symbol.split",
		  	"es.regexp.exec",
		  	"es.string.split"
		  ],
		  	"core-js/stable/symbol/to-primitive": [
		  	"es.symbol.to-primitive",
		  	"es.date.to-primitive"
		  ],
		  	"core-js/stable/symbol/to-string-tag": [
		  	"es.symbol.to-string-tag",
		  	"es.json.to-string-tag",
		  	"es.math.to-string-tag",
		  	"es.object.to-string",
		  	"es.reflect.to-string-tag"
		  ],
		  	"core-js/stable/symbol/unscopables": [
		  	"es.symbol.unscopables"
		  ],
		  	"core-js/stable/typed-array": [
		  	"es.object.to-string",
		  	"es.string.iterator",
		  	"es.typed-array.float32-array",
		  	"es.typed-array.float64-array",
		  	"es.typed-array.int8-array",
		  	"es.typed-array.int16-array",
		  	"es.typed-array.int32-array",
		  	"es.typed-array.uint8-array",
		  	"es.typed-array.uint8-clamped-array",
		  	"es.typed-array.uint16-array",
		  	"es.typed-array.uint32-array",
		  	"es.typed-array.at",
		  	"es.typed-array.copy-within",
		  	"es.typed-array.every",
		  	"es.typed-array.fill",
		  	"es.typed-array.filter",
		  	"es.typed-array.find",
		  	"es.typed-array.find-index",
		  	"es.typed-array.find-last",
		  	"es.typed-array.find-last-index",
		  	"es.typed-array.for-each",
		  	"es.typed-array.from",
		  	"es.typed-array.includes",
		  	"es.typed-array.index-of",
		  	"es.typed-array.iterator",
		  	"es.typed-array.join",
		  	"es.typed-array.last-index-of",
		  	"es.typed-array.map",
		  	"es.typed-array.of",
		  	"es.typed-array.reduce",
		  	"es.typed-array.reduce-right",
		  	"es.typed-array.reverse",
		  	"es.typed-array.set",
		  	"es.typed-array.slice",
		  	"es.typed-array.some",
		  	"es.typed-array.sort",
		  	"es.typed-array.subarray",
		  	"es.typed-array.to-locale-string",
		  	"es.typed-array.to-reversed",
		  	"es.typed-array.to-sorted",
		  	"es.typed-array.to-string",
		  	"es.typed-array.with"
		  ],
		  	"core-js/stable/typed-array/at": [
		  	"es.typed-array.at"
		  ],
		  	"core-js/stable/typed-array/copy-within": [
		  	"es.typed-array.copy-within"
		  ],
		  	"core-js/stable/typed-array/entries": [
		  	"es.object.to-string",
		  	"es.typed-array.iterator"
		  ],
		  	"core-js/stable/typed-array/every": [
		  	"es.typed-array.every"
		  ],
		  	"core-js/stable/typed-array/fill": [
		  	"es.typed-array.fill"
		  ],
		  	"core-js/stable/typed-array/filter": [
		  	"es.typed-array.filter"
		  ],
		  	"core-js/stable/typed-array/find": [
		  	"es.typed-array.find"
		  ],
		  	"core-js/stable/typed-array/find-index": [
		  	"es.typed-array.find-index"
		  ],
		  	"core-js/stable/typed-array/find-last": [
		  	"es.typed-array.find-last"
		  ],
		  	"core-js/stable/typed-array/find-last-index": [
		  	"es.typed-array.find-last-index"
		  ],
		  	"core-js/stable/typed-array/float32-array": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.object.to-string",
		  	"es.string.iterator",
		  	"es.typed-array.float32-array",
		  	"es.typed-array.at",
		  	"es.typed-array.copy-within",
		  	"es.typed-array.every",
		  	"es.typed-array.fill",
		  	"es.typed-array.filter",
		  	"es.typed-array.find",
		  	"es.typed-array.find-index",
		  	"es.typed-array.find-last",
		  	"es.typed-array.find-last-index",
		  	"es.typed-array.for-each",
		  	"es.typed-array.from",
		  	"es.typed-array.includes",
		  	"es.typed-array.index-of",
		  	"es.typed-array.iterator",
		  	"es.typed-array.join",
		  	"es.typed-array.last-index-of",
		  	"es.typed-array.map",
		  	"es.typed-array.of",
		  	"es.typed-array.reduce",
		  	"es.typed-array.reduce-right",
		  	"es.typed-array.reverse",
		  	"es.typed-array.set",
		  	"es.typed-array.slice",
		  	"es.typed-array.some",
		  	"es.typed-array.sort",
		  	"es.typed-array.subarray",
		  	"es.typed-array.to-locale-string",
		  	"es.typed-array.to-reversed",
		  	"es.typed-array.to-sorted",
		  	"es.typed-array.to-string",
		  	"es.typed-array.with"
		  ],
		  	"core-js/stable/typed-array/float64-array": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.object.to-string",
		  	"es.string.iterator",
		  	"es.typed-array.float64-array",
		  	"es.typed-array.at",
		  	"es.typed-array.copy-within",
		  	"es.typed-array.every",
		  	"es.typed-array.fill",
		  	"es.typed-array.filter",
		  	"es.typed-array.find",
		  	"es.typed-array.find-index",
		  	"es.typed-array.find-last",
		  	"es.typed-array.find-last-index",
		  	"es.typed-array.for-each",
		  	"es.typed-array.from",
		  	"es.typed-array.includes",
		  	"es.typed-array.index-of",
		  	"es.typed-array.iterator",
		  	"es.typed-array.join",
		  	"es.typed-array.last-index-of",
		  	"es.typed-array.map",
		  	"es.typed-array.of",
		  	"es.typed-array.reduce",
		  	"es.typed-array.reduce-right",
		  	"es.typed-array.reverse",
		  	"es.typed-array.set",
		  	"es.typed-array.slice",
		  	"es.typed-array.some",
		  	"es.typed-array.sort",
		  	"es.typed-array.subarray",
		  	"es.typed-array.to-locale-string",
		  	"es.typed-array.to-reversed",
		  	"es.typed-array.to-sorted",
		  	"es.typed-array.to-string",
		  	"es.typed-array.with"
		  ],
		  	"core-js/stable/typed-array/for-each": [
		  	"es.typed-array.for-each"
		  ],
		  	"core-js/stable/typed-array/from": [
		  	"es.typed-array.from"
		  ],
		  	"core-js/stable/typed-array/includes": [
		  	"es.typed-array.includes"
		  ],
		  	"core-js/stable/typed-array/index-of": [
		  	"es.typed-array.index-of"
		  ],
		  	"core-js/stable/typed-array/int16-array": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.object.to-string",
		  	"es.string.iterator",
		  	"es.typed-array.int16-array",
		  	"es.typed-array.at",
		  	"es.typed-array.copy-within",
		  	"es.typed-array.every",
		  	"es.typed-array.fill",
		  	"es.typed-array.filter",
		  	"es.typed-array.find",
		  	"es.typed-array.find-index",
		  	"es.typed-array.find-last",
		  	"es.typed-array.find-last-index",
		  	"es.typed-array.for-each",
		  	"es.typed-array.from",
		  	"es.typed-array.includes",
		  	"es.typed-array.index-of",
		  	"es.typed-array.iterator",
		  	"es.typed-array.join",
		  	"es.typed-array.last-index-of",
		  	"es.typed-array.map",
		  	"es.typed-array.of",
		  	"es.typed-array.reduce",
		  	"es.typed-array.reduce-right",
		  	"es.typed-array.reverse",
		  	"es.typed-array.set",
		  	"es.typed-array.slice",
		  	"es.typed-array.some",
		  	"es.typed-array.sort",
		  	"es.typed-array.subarray",
		  	"es.typed-array.to-locale-string",
		  	"es.typed-array.to-reversed",
		  	"es.typed-array.to-sorted",
		  	"es.typed-array.to-string",
		  	"es.typed-array.with"
		  ],
		  	"core-js/stable/typed-array/int32-array": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.object.to-string",
		  	"es.string.iterator",
		  	"es.typed-array.int32-array",
		  	"es.typed-array.at",
		  	"es.typed-array.copy-within",
		  	"es.typed-array.every",
		  	"es.typed-array.fill",
		  	"es.typed-array.filter",
		  	"es.typed-array.find",
		  	"es.typed-array.find-index",
		  	"es.typed-array.find-last",
		  	"es.typed-array.find-last-index",
		  	"es.typed-array.for-each",
		  	"es.typed-array.from",
		  	"es.typed-array.includes",
		  	"es.typed-array.index-of",
		  	"es.typed-array.iterator",
		  	"es.typed-array.join",
		  	"es.typed-array.last-index-of",
		  	"es.typed-array.map",
		  	"es.typed-array.of",
		  	"es.typed-array.reduce",
		  	"es.typed-array.reduce-right",
		  	"es.typed-array.reverse",
		  	"es.typed-array.set",
		  	"es.typed-array.slice",
		  	"es.typed-array.some",
		  	"es.typed-array.sort",
		  	"es.typed-array.subarray",
		  	"es.typed-array.to-locale-string",
		  	"es.typed-array.to-reversed",
		  	"es.typed-array.to-sorted",
		  	"es.typed-array.to-string",
		  	"es.typed-array.with"
		  ],
		  	"core-js/stable/typed-array/int8-array": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.object.to-string",
		  	"es.string.iterator",
		  	"es.typed-array.int8-array",
		  	"es.typed-array.at",
		  	"es.typed-array.copy-within",
		  	"es.typed-array.every",
		  	"es.typed-array.fill",
		  	"es.typed-array.filter",
		  	"es.typed-array.find",
		  	"es.typed-array.find-index",
		  	"es.typed-array.find-last",
		  	"es.typed-array.find-last-index",
		  	"es.typed-array.for-each",
		  	"es.typed-array.from",
		  	"es.typed-array.includes",
		  	"es.typed-array.index-of",
		  	"es.typed-array.iterator",
		  	"es.typed-array.join",
		  	"es.typed-array.last-index-of",
		  	"es.typed-array.map",
		  	"es.typed-array.of",
		  	"es.typed-array.reduce",
		  	"es.typed-array.reduce-right",
		  	"es.typed-array.reverse",
		  	"es.typed-array.set",
		  	"es.typed-array.slice",
		  	"es.typed-array.some",
		  	"es.typed-array.sort",
		  	"es.typed-array.subarray",
		  	"es.typed-array.to-locale-string",
		  	"es.typed-array.to-reversed",
		  	"es.typed-array.to-sorted",
		  	"es.typed-array.to-string",
		  	"es.typed-array.with"
		  ],
		  	"core-js/stable/typed-array/iterator": [
		  	"es.object.to-string",
		  	"es.typed-array.iterator"
		  ],
		  	"core-js/stable/typed-array/join": [
		  	"es.typed-array.join"
		  ],
		  	"core-js/stable/typed-array/keys": [
		  	"es.object.to-string",
		  	"es.typed-array.iterator"
		  ],
		  	"core-js/stable/typed-array/last-index-of": [
		  	"es.typed-array.last-index-of"
		  ],
		  	"core-js/stable/typed-array/map": [
		  	"es.typed-array.map"
		  ],
		  	"core-js/stable/typed-array/methods": [
		  	"es.object.to-string",
		  	"es.string.iterator",
		  	"es.typed-array.at",
		  	"es.typed-array.copy-within",
		  	"es.typed-array.every",
		  	"es.typed-array.fill",
		  	"es.typed-array.filter",
		  	"es.typed-array.find",
		  	"es.typed-array.find-index",
		  	"es.typed-array.find-last",
		  	"es.typed-array.find-last-index",
		  	"es.typed-array.for-each",
		  	"es.typed-array.from",
		  	"es.typed-array.includes",
		  	"es.typed-array.index-of",
		  	"es.typed-array.iterator",
		  	"es.typed-array.join",
		  	"es.typed-array.last-index-of",
		  	"es.typed-array.map",
		  	"es.typed-array.of",
		  	"es.typed-array.reduce",
		  	"es.typed-array.reduce-right",
		  	"es.typed-array.reverse",
		  	"es.typed-array.set",
		  	"es.typed-array.slice",
		  	"es.typed-array.some",
		  	"es.typed-array.sort",
		  	"es.typed-array.subarray",
		  	"es.typed-array.to-locale-string",
		  	"es.typed-array.to-reversed",
		  	"es.typed-array.to-sorted",
		  	"es.typed-array.to-string",
		  	"es.typed-array.with"
		  ],
		  	"core-js/stable/typed-array/of": [
		  	"es.typed-array.of"
		  ],
		  	"core-js/stable/typed-array/reduce": [
		  	"es.typed-array.reduce"
		  ],
		  	"core-js/stable/typed-array/reduce-right": [
		  	"es.typed-array.reduce-right"
		  ],
		  	"core-js/stable/typed-array/reverse": [
		  	"es.typed-array.reverse"
		  ],
		  	"core-js/stable/typed-array/set": [
		  	"es.typed-array.set"
		  ],
		  	"core-js/stable/typed-array/slice": [
		  	"es.typed-array.slice"
		  ],
		  	"core-js/stable/typed-array/some": [
		  	"es.typed-array.some"
		  ],
		  	"core-js/stable/typed-array/sort": [
		  	"es.typed-array.sort"
		  ],
		  	"core-js/stable/typed-array/subarray": [
		  	"es.typed-array.subarray"
		  ],
		  	"core-js/stable/typed-array/to-locale-string": [
		  	"es.typed-array.to-locale-string"
		  ],
		  	"core-js/stable/typed-array/to-reversed": [
		  	"es.typed-array.to-reversed"
		  ],
		  	"core-js/stable/typed-array/to-sorted": [
		  	"es.typed-array.sort",
		  	"es.typed-array.to-sorted"
		  ],
		  	"core-js/stable/typed-array/to-string": [
		  	"es.typed-array.to-string"
		  ],
		  	"core-js/stable/typed-array/uint16-array": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.object.to-string",
		  	"es.string.iterator",
		  	"es.typed-array.uint16-array",
		  	"es.typed-array.at",
		  	"es.typed-array.copy-within",
		  	"es.typed-array.every",
		  	"es.typed-array.fill",
		  	"es.typed-array.filter",
		  	"es.typed-array.find",
		  	"es.typed-array.find-index",
		  	"es.typed-array.find-last",
		  	"es.typed-array.find-last-index",
		  	"es.typed-array.for-each",
		  	"es.typed-array.from",
		  	"es.typed-array.includes",
		  	"es.typed-array.index-of",
		  	"es.typed-array.iterator",
		  	"es.typed-array.join",
		  	"es.typed-array.last-index-of",
		  	"es.typed-array.map",
		  	"es.typed-array.of",
		  	"es.typed-array.reduce",
		  	"es.typed-array.reduce-right",
		  	"es.typed-array.reverse",
		  	"es.typed-array.set",
		  	"es.typed-array.slice",
		  	"es.typed-array.some",
		  	"es.typed-array.sort",
		  	"es.typed-array.subarray",
		  	"es.typed-array.to-locale-string",
		  	"es.typed-array.to-reversed",
		  	"es.typed-array.to-sorted",
		  	"es.typed-array.to-string",
		  	"es.typed-array.with"
		  ],
		  	"core-js/stable/typed-array/uint32-array": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.object.to-string",
		  	"es.string.iterator",
		  	"es.typed-array.uint32-array",
		  	"es.typed-array.at",
		  	"es.typed-array.copy-within",
		  	"es.typed-array.every",
		  	"es.typed-array.fill",
		  	"es.typed-array.filter",
		  	"es.typed-array.find",
		  	"es.typed-array.find-index",
		  	"es.typed-array.find-last",
		  	"es.typed-array.find-last-index",
		  	"es.typed-array.for-each",
		  	"es.typed-array.from",
		  	"es.typed-array.includes",
		  	"es.typed-array.index-of",
		  	"es.typed-array.iterator",
		  	"es.typed-array.join",
		  	"es.typed-array.last-index-of",
		  	"es.typed-array.map",
		  	"es.typed-array.of",
		  	"es.typed-array.reduce",
		  	"es.typed-array.reduce-right",
		  	"es.typed-array.reverse",
		  	"es.typed-array.set",
		  	"es.typed-array.slice",
		  	"es.typed-array.some",
		  	"es.typed-array.sort",
		  	"es.typed-array.subarray",
		  	"es.typed-array.to-locale-string",
		  	"es.typed-array.to-reversed",
		  	"es.typed-array.to-sorted",
		  	"es.typed-array.to-string",
		  	"es.typed-array.with"
		  ],
		  	"core-js/stable/typed-array/uint8-array": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.object.to-string",
		  	"es.string.iterator",
		  	"es.typed-array.uint8-array",
		  	"es.typed-array.at",
		  	"es.typed-array.copy-within",
		  	"es.typed-array.every",
		  	"es.typed-array.fill",
		  	"es.typed-array.filter",
		  	"es.typed-array.find",
		  	"es.typed-array.find-index",
		  	"es.typed-array.find-last",
		  	"es.typed-array.find-last-index",
		  	"es.typed-array.for-each",
		  	"es.typed-array.from",
		  	"es.typed-array.includes",
		  	"es.typed-array.index-of",
		  	"es.typed-array.iterator",
		  	"es.typed-array.join",
		  	"es.typed-array.last-index-of",
		  	"es.typed-array.map",
		  	"es.typed-array.of",
		  	"es.typed-array.reduce",
		  	"es.typed-array.reduce-right",
		  	"es.typed-array.reverse",
		  	"es.typed-array.set",
		  	"es.typed-array.slice",
		  	"es.typed-array.some",
		  	"es.typed-array.sort",
		  	"es.typed-array.subarray",
		  	"es.typed-array.to-locale-string",
		  	"es.typed-array.to-reversed",
		  	"es.typed-array.to-sorted",
		  	"es.typed-array.to-string",
		  	"es.typed-array.with"
		  ],
		  	"core-js/stable/typed-array/uint8-clamped-array": [
		  	"es.array-buffer.constructor",
		  	"es.array-buffer.slice",
		  	"es.object.to-string",
		  	"es.string.iterator",
		  	"es.typed-array.uint8-clamped-array",
		  	"es.typed-array.at",
		  	"es.typed-array.copy-within",
		  	"es.typed-array.every",
		  	"es.typed-array.fill",
		  	"es.typed-array.filter",
		  	"es.typed-array.find",
		  	"es.typed-array.find-index",
		  	"es.typed-array.find-last",
		  	"es.typed-array.find-last-index",
		  	"es.typed-array.for-each",
		  	"es.typed-array.from",
		  	"es.typed-array.includes",
		  	"es.typed-array.index-of",
		  	"es.typed-array.iterator",
		  	"es.typed-array.join",
		  	"es.typed-array.last-index-of",
		  	"es.typed-array.map",
		  	"es.typed-array.of",
		  	"es.typed-array.reduce",
		  	"es.typed-array.reduce-right",
		  	"es.typed-array.reverse",
		  	"es.typed-array.set",
		  	"es.typed-array.slice",
		  	"es.typed-array.some",
		  	"es.typed-array.sort",
		  	"es.typed-array.subarray",
		  	"es.typed-array.to-locale-string",
		  	"es.typed-array.to-reversed",
		  	"es.typed-array.to-sorted",
		  	"es.typed-array.to-string",
		  	"es.typed-array.with"
		  ],
		  	"core-js/stable/typed-array/values": [
		  	"es.object.to-string",
		  	"es.typed-array.iterator"
		  ],
		  	"core-js/stable/typed-array/with": [
		  	"es.typed-array.with"
		  ],
		  	"core-js/stable/unescape": [
		  	"es.unescape"
		  ],
		  	"core-js/stable/url": [
		  	"web.url",
		  	"web.url.can-parse",
		  	"web.url.to-json",
		  	"web.url-search-params",
		  	"web.url-search-params.delete",
		  	"web.url-search-params.has",
		  	"web.url-search-params.size"
		  ],
		  	"core-js/stable/url-search-params": [
		  	"web.dom-collections.iterator",
		  	"web.url-search-params",
		  	"web.url-search-params.delete",
		  	"web.url-search-params.has",
		  	"web.url-search-params.size"
		  ],
		  	"core-js/stable/url/can-parse": [
		  	"web.url",
		  	"web.url.can-parse"
		  ],
		  	"core-js/stable/url/to-json": [
		  	"web.url.to-json"
		  ],
		  	"core-js/stable/weak-map": [
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"es.weak-map",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/stable/weak-set": [
		  	"es.array.iterator",
		  	"es.object.to-string",
		  	"es.weak-set",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/stage": [
		  	"es.map",
		  	"es.string.at-alternative",
		  	"esnext.aggregate-error",
		  	"esnext.suppressed-error.constructor",
		  	"esnext.array.from-async",
		  	"esnext.array.at",
		  	"esnext.array.filter-out",
		  	"esnext.array.filter-reject",
		  	"esnext.array.find-last",
		  	"esnext.array.find-last-index",
		  	"esnext.array.group",
		  	"esnext.array.group-by",
		  	"esnext.array.group-by-to-map",
		  	"esnext.array.group-to-map",
		  	"esnext.array.is-template-object",
		  	"esnext.array.last-index",
		  	"esnext.array.last-item",
		  	"esnext.array.to-reversed",
		  	"esnext.array.to-sorted",
		  	"esnext.array.to-spliced",
		  	"esnext.array.unique-by",
		  	"esnext.array.with",
		  	"esnext.array-buffer.detached",
		  	"esnext.array-buffer.transfer",
		  	"esnext.array-buffer.transfer-to-fixed-length",
		  	"esnext.async-disposable-stack.constructor",
		  	"esnext.async-iterator.constructor",
		  	"esnext.async-iterator.as-indexed-pairs",
		  	"esnext.async-iterator.async-dispose",
		  	"esnext.async-iterator.drop",
		  	"esnext.async-iterator.every",
		  	"esnext.async-iterator.filter",
		  	"esnext.async-iterator.find",
		  	"esnext.async-iterator.flat-map",
		  	"esnext.async-iterator.for-each",
		  	"esnext.async-iterator.from",
		  	"esnext.async-iterator.indexed",
		  	"esnext.async-iterator.map",
		  	"esnext.async-iterator.reduce",
		  	"esnext.async-iterator.some",
		  	"esnext.async-iterator.take",
		  	"esnext.async-iterator.to-array",
		  	"esnext.bigint.range",
		  	"esnext.composite-key",
		  	"esnext.composite-symbol",
		  	"esnext.data-view.get-float16",
		  	"esnext.data-view.get-uint8-clamped",
		  	"esnext.data-view.set-float16",
		  	"esnext.data-view.set-uint8-clamped",
		  	"esnext.disposable-stack.constructor",
		  	"esnext.function.demethodize",
		  	"esnext.function.is-callable",
		  	"esnext.function.is-constructor",
		  	"esnext.function.metadata",
		  	"esnext.function.un-this",
		  	"esnext.global-this",
		  	"esnext.iterator.constructor",
		  	"esnext.iterator.as-indexed-pairs",
		  	"esnext.iterator.dispose",
		  	"esnext.iterator.drop",
		  	"esnext.iterator.every",
		  	"esnext.iterator.filter",
		  	"esnext.iterator.find",
		  	"esnext.iterator.flat-map",
		  	"esnext.iterator.for-each",
		  	"esnext.iterator.from",
		  	"esnext.iterator.indexed",
		  	"esnext.iterator.map",
		  	"esnext.iterator.range",
		  	"esnext.iterator.reduce",
		  	"esnext.iterator.some",
		  	"esnext.iterator.take",
		  	"esnext.iterator.to-array",
		  	"esnext.iterator.to-async",
		  	"esnext.json.is-raw-json",
		  	"esnext.json.parse",
		  	"esnext.json.raw-json",
		  	"esnext.map.delete-all",
		  	"esnext.map.emplace",
		  	"esnext.map.every",
		  	"esnext.map.filter",
		  	"esnext.map.find",
		  	"esnext.map.find-key",
		  	"esnext.map.from",
		  	"esnext.map.group-by",
		  	"esnext.map.includes",
		  	"esnext.map.key-by",
		  	"esnext.map.key-of",
		  	"esnext.map.map-keys",
		  	"esnext.map.map-values",
		  	"esnext.map.merge",
		  	"esnext.map.of",
		  	"esnext.map.reduce",
		  	"esnext.map.some",
		  	"esnext.map.update",
		  	"esnext.map.update-or-insert",
		  	"esnext.map.upsert",
		  	"esnext.math.clamp",
		  	"esnext.math.deg-per-rad",
		  	"esnext.math.degrees",
		  	"esnext.math.fscale",
		  	"esnext.math.f16round",
		  	"esnext.math.iaddh",
		  	"esnext.math.imulh",
		  	"esnext.math.isubh",
		  	"esnext.math.rad-per-deg",
		  	"esnext.math.radians",
		  	"esnext.math.scale",
		  	"esnext.math.seeded-prng",
		  	"esnext.math.signbit",
		  	"esnext.math.umulh",
		  	"esnext.number.from-string",
		  	"esnext.number.range",
		  	"esnext.object.has-own",
		  	"esnext.object.iterate-entries",
		  	"esnext.object.iterate-keys",
		  	"esnext.object.iterate-values",
		  	"esnext.object.group-by",
		  	"esnext.observable",
		  	"esnext.promise.all-settled",
		  	"esnext.promise.any",
		  	"esnext.promise.try",
		  	"esnext.promise.with-resolvers",
		  	"esnext.reflect.define-metadata",
		  	"esnext.reflect.delete-metadata",
		  	"esnext.reflect.get-metadata",
		  	"esnext.reflect.get-metadata-keys",
		  	"esnext.reflect.get-own-metadata",
		  	"esnext.reflect.get-own-metadata-keys",
		  	"esnext.reflect.has-metadata",
		  	"esnext.reflect.has-own-metadata",
		  	"esnext.reflect.metadata",
		  	"esnext.regexp.escape",
		  	"esnext.set.add-all",
		  	"esnext.set.delete-all",
		  	"esnext.set.difference.v2",
		  	"esnext.set.difference",
		  	"esnext.set.every",
		  	"esnext.set.filter",
		  	"esnext.set.find",
		  	"esnext.set.from",
		  	"esnext.set.intersection.v2",
		  	"esnext.set.intersection",
		  	"esnext.set.is-disjoint-from.v2",
		  	"esnext.set.is-disjoint-from",
		  	"esnext.set.is-subset-of.v2",
		  	"esnext.set.is-subset-of",
		  	"esnext.set.is-superset-of.v2",
		  	"esnext.set.is-superset-of",
		  	"esnext.set.join",
		  	"esnext.set.map",
		  	"esnext.set.of",
		  	"esnext.set.reduce",
		  	"esnext.set.some",
		  	"esnext.set.symmetric-difference.v2",
		  	"esnext.set.symmetric-difference",
		  	"esnext.set.union.v2",
		  	"esnext.set.union",
		  	"esnext.string.at",
		  	"esnext.string.cooked",
		  	"esnext.string.code-points",
		  	"esnext.string.dedent",
		  	"esnext.string.is-well-formed",
		  	"esnext.string.match-all",
		  	"esnext.string.replace-all",
		  	"esnext.string.to-well-formed",
		  	"esnext.symbol.async-dispose",
		  	"esnext.symbol.dispose",
		  	"esnext.symbol.is-registered-symbol",
		  	"esnext.symbol.is-registered",
		  	"esnext.symbol.is-well-known-symbol",
		  	"esnext.symbol.is-well-known",
		  	"esnext.symbol.matcher",
		  	"esnext.symbol.metadata",
		  	"esnext.symbol.metadata-key",
		  	"esnext.symbol.observable",
		  	"esnext.symbol.pattern-match",
		  	"esnext.symbol.replace-all",
		  	"esnext.typed-array.from-async",
		  	"esnext.typed-array.at",
		  	"esnext.typed-array.filter-out",
		  	"esnext.typed-array.filter-reject",
		  	"esnext.typed-array.find-last",
		  	"esnext.typed-array.find-last-index",
		  	"esnext.typed-array.group-by",
		  	"esnext.typed-array.to-reversed",
		  	"esnext.typed-array.to-sorted",
		  	"esnext.typed-array.to-spliced",
		  	"esnext.typed-array.unique-by",
		  	"esnext.typed-array.with",
		  	"esnext.uint8-array.from-base64",
		  	"esnext.uint8-array.from-hex",
		  	"esnext.uint8-array.to-base64",
		  	"esnext.uint8-array.to-hex",
		  	"esnext.weak-map.delete-all",
		  	"esnext.weak-map.from",
		  	"esnext.weak-map.of",
		  	"esnext.weak-map.emplace",
		  	"esnext.weak-map.upsert",
		  	"esnext.weak-set.add-all",
		  	"esnext.weak-set.delete-all",
		  	"esnext.weak-set.from",
		  	"esnext.weak-set.of",
		  	"web.url",
		  	"web.url.can-parse",
		  	"web.url.to-json",
		  	"web.url-search-params",
		  	"web.url-search-params.delete",
		  	"web.url-search-params.has",
		  	"web.url-search-params.size"
		  ],
		  	"core-js/stage/0": [
		  	"es.map",
		  	"es.string.at-alternative",
		  	"esnext.aggregate-error",
		  	"esnext.suppressed-error.constructor",
		  	"esnext.array.from-async",
		  	"esnext.array.at",
		  	"esnext.array.filter-out",
		  	"esnext.array.filter-reject",
		  	"esnext.array.find-last",
		  	"esnext.array.find-last-index",
		  	"esnext.array.group",
		  	"esnext.array.group-by",
		  	"esnext.array.group-by-to-map",
		  	"esnext.array.group-to-map",
		  	"esnext.array.is-template-object",
		  	"esnext.array.last-index",
		  	"esnext.array.last-item",
		  	"esnext.array.to-reversed",
		  	"esnext.array.to-sorted",
		  	"esnext.array.to-spliced",
		  	"esnext.array.unique-by",
		  	"esnext.array.with",
		  	"esnext.array-buffer.detached",
		  	"esnext.array-buffer.transfer",
		  	"esnext.array-buffer.transfer-to-fixed-length",
		  	"esnext.async-disposable-stack.constructor",
		  	"esnext.async-iterator.constructor",
		  	"esnext.async-iterator.as-indexed-pairs",
		  	"esnext.async-iterator.async-dispose",
		  	"esnext.async-iterator.drop",
		  	"esnext.async-iterator.every",
		  	"esnext.async-iterator.filter",
		  	"esnext.async-iterator.find",
		  	"esnext.async-iterator.flat-map",
		  	"esnext.async-iterator.for-each",
		  	"esnext.async-iterator.from",
		  	"esnext.async-iterator.indexed",
		  	"esnext.async-iterator.map",
		  	"esnext.async-iterator.reduce",
		  	"esnext.async-iterator.some",
		  	"esnext.async-iterator.take",
		  	"esnext.async-iterator.to-array",
		  	"esnext.bigint.range",
		  	"esnext.composite-key",
		  	"esnext.composite-symbol",
		  	"esnext.data-view.get-float16",
		  	"esnext.data-view.get-uint8-clamped",
		  	"esnext.data-view.set-float16",
		  	"esnext.data-view.set-uint8-clamped",
		  	"esnext.disposable-stack.constructor",
		  	"esnext.function.demethodize",
		  	"esnext.function.is-callable",
		  	"esnext.function.is-constructor",
		  	"esnext.function.metadata",
		  	"esnext.function.un-this",
		  	"esnext.global-this",
		  	"esnext.iterator.constructor",
		  	"esnext.iterator.as-indexed-pairs",
		  	"esnext.iterator.dispose",
		  	"esnext.iterator.drop",
		  	"esnext.iterator.every",
		  	"esnext.iterator.filter",
		  	"esnext.iterator.find",
		  	"esnext.iterator.flat-map",
		  	"esnext.iterator.for-each",
		  	"esnext.iterator.from",
		  	"esnext.iterator.indexed",
		  	"esnext.iterator.map",
		  	"esnext.iterator.range",
		  	"esnext.iterator.reduce",
		  	"esnext.iterator.some",
		  	"esnext.iterator.take",
		  	"esnext.iterator.to-array",
		  	"esnext.iterator.to-async",
		  	"esnext.json.is-raw-json",
		  	"esnext.json.parse",
		  	"esnext.json.raw-json",
		  	"esnext.map.delete-all",
		  	"esnext.map.emplace",
		  	"esnext.map.every",
		  	"esnext.map.filter",
		  	"esnext.map.find",
		  	"esnext.map.find-key",
		  	"esnext.map.from",
		  	"esnext.map.group-by",
		  	"esnext.map.includes",
		  	"esnext.map.key-by",
		  	"esnext.map.key-of",
		  	"esnext.map.map-keys",
		  	"esnext.map.map-values",
		  	"esnext.map.merge",
		  	"esnext.map.of",
		  	"esnext.map.reduce",
		  	"esnext.map.some",
		  	"esnext.map.update",
		  	"esnext.map.update-or-insert",
		  	"esnext.map.upsert",
		  	"esnext.math.clamp",
		  	"esnext.math.deg-per-rad",
		  	"esnext.math.degrees",
		  	"esnext.math.fscale",
		  	"esnext.math.f16round",
		  	"esnext.math.iaddh",
		  	"esnext.math.imulh",
		  	"esnext.math.isubh",
		  	"esnext.math.rad-per-deg",
		  	"esnext.math.radians",
		  	"esnext.math.scale",
		  	"esnext.math.seeded-prng",
		  	"esnext.math.signbit",
		  	"esnext.math.umulh",
		  	"esnext.number.from-string",
		  	"esnext.number.range",
		  	"esnext.object.has-own",
		  	"esnext.object.iterate-entries",
		  	"esnext.object.iterate-keys",
		  	"esnext.object.iterate-values",
		  	"esnext.object.group-by",
		  	"esnext.observable",
		  	"esnext.promise.all-settled",
		  	"esnext.promise.any",
		  	"esnext.promise.try",
		  	"esnext.promise.with-resolvers",
		  	"esnext.regexp.escape",
		  	"esnext.set.add-all",
		  	"esnext.set.delete-all",
		  	"esnext.set.difference.v2",
		  	"esnext.set.difference",
		  	"esnext.set.every",
		  	"esnext.set.filter",
		  	"esnext.set.find",
		  	"esnext.set.from",
		  	"esnext.set.intersection.v2",
		  	"esnext.set.intersection",
		  	"esnext.set.is-disjoint-from.v2",
		  	"esnext.set.is-disjoint-from",
		  	"esnext.set.is-subset-of.v2",
		  	"esnext.set.is-subset-of",
		  	"esnext.set.is-superset-of.v2",
		  	"esnext.set.is-superset-of",
		  	"esnext.set.join",
		  	"esnext.set.map",
		  	"esnext.set.of",
		  	"esnext.set.reduce",
		  	"esnext.set.some",
		  	"esnext.set.symmetric-difference.v2",
		  	"esnext.set.symmetric-difference",
		  	"esnext.set.union.v2",
		  	"esnext.set.union",
		  	"esnext.string.at",
		  	"esnext.string.cooked",
		  	"esnext.string.code-points",
		  	"esnext.string.dedent",
		  	"esnext.string.is-well-formed",
		  	"esnext.string.match-all",
		  	"esnext.string.replace-all",
		  	"esnext.string.to-well-formed",
		  	"esnext.symbol.async-dispose",
		  	"esnext.symbol.dispose",
		  	"esnext.symbol.is-registered-symbol",
		  	"esnext.symbol.is-registered",
		  	"esnext.symbol.is-well-known-symbol",
		  	"esnext.symbol.is-well-known",
		  	"esnext.symbol.matcher",
		  	"esnext.symbol.metadata",
		  	"esnext.symbol.metadata-key",
		  	"esnext.symbol.observable",
		  	"esnext.symbol.pattern-match",
		  	"esnext.symbol.replace-all",
		  	"esnext.typed-array.from-async",
		  	"esnext.typed-array.at",
		  	"esnext.typed-array.filter-out",
		  	"esnext.typed-array.filter-reject",
		  	"esnext.typed-array.find-last",
		  	"esnext.typed-array.find-last-index",
		  	"esnext.typed-array.group-by",
		  	"esnext.typed-array.to-reversed",
		  	"esnext.typed-array.to-sorted",
		  	"esnext.typed-array.to-spliced",
		  	"esnext.typed-array.unique-by",
		  	"esnext.typed-array.with",
		  	"esnext.uint8-array.from-base64",
		  	"esnext.uint8-array.from-hex",
		  	"esnext.uint8-array.to-base64",
		  	"esnext.uint8-array.to-hex",
		  	"esnext.weak-map.delete-all",
		  	"esnext.weak-map.from",
		  	"esnext.weak-map.of",
		  	"esnext.weak-map.emplace",
		  	"esnext.weak-map.upsert",
		  	"esnext.weak-set.add-all",
		  	"esnext.weak-set.delete-all",
		  	"esnext.weak-set.from",
		  	"esnext.weak-set.of",
		  	"web.url",
		  	"web.url.can-parse",
		  	"web.url.to-json",
		  	"web.url-search-params",
		  	"web.url-search-params.delete",
		  	"web.url-search-params.has",
		  	"web.url-search-params.size"
		  ],
		  	"core-js/stage/1": [
		  	"es.map",
		  	"es.string.at-alternative",
		  	"esnext.aggregate-error",
		  	"esnext.suppressed-error.constructor",
		  	"esnext.array.from-async",
		  	"esnext.array.at",
		  	"esnext.array.filter-reject",
		  	"esnext.array.find-last",
		  	"esnext.array.find-last-index",
		  	"esnext.array.group",
		  	"esnext.array.group-by",
		  	"esnext.array.group-by-to-map",
		  	"esnext.array.group-to-map",
		  	"esnext.array.is-template-object",
		  	"esnext.array.last-index",
		  	"esnext.array.last-item",
		  	"esnext.array.to-reversed",
		  	"esnext.array.to-sorted",
		  	"esnext.array.to-spliced",
		  	"esnext.array.unique-by",
		  	"esnext.array.with",
		  	"esnext.array-buffer.detached",
		  	"esnext.array-buffer.transfer",
		  	"esnext.array-buffer.transfer-to-fixed-length",
		  	"esnext.async-disposable-stack.constructor",
		  	"esnext.async-iterator.constructor",
		  	"esnext.async-iterator.as-indexed-pairs",
		  	"esnext.async-iterator.async-dispose",
		  	"esnext.async-iterator.drop",
		  	"esnext.async-iterator.every",
		  	"esnext.async-iterator.filter",
		  	"esnext.async-iterator.find",
		  	"esnext.async-iterator.flat-map",
		  	"esnext.async-iterator.for-each",
		  	"esnext.async-iterator.from",
		  	"esnext.async-iterator.indexed",
		  	"esnext.async-iterator.map",
		  	"esnext.async-iterator.reduce",
		  	"esnext.async-iterator.some",
		  	"esnext.async-iterator.take",
		  	"esnext.async-iterator.to-array",
		  	"esnext.bigint.range",
		  	"esnext.composite-key",
		  	"esnext.composite-symbol",
		  	"esnext.data-view.get-float16",
		  	"esnext.data-view.get-uint8-clamped",
		  	"esnext.data-view.set-float16",
		  	"esnext.data-view.set-uint8-clamped",
		  	"esnext.disposable-stack.constructor",
		  	"esnext.function.metadata",
		  	"esnext.global-this",
		  	"esnext.iterator.constructor",
		  	"esnext.iterator.as-indexed-pairs",
		  	"esnext.iterator.dispose",
		  	"esnext.iterator.drop",
		  	"esnext.iterator.every",
		  	"esnext.iterator.filter",
		  	"esnext.iterator.find",
		  	"esnext.iterator.flat-map",
		  	"esnext.iterator.for-each",
		  	"esnext.iterator.from",
		  	"esnext.iterator.indexed",
		  	"esnext.iterator.map",
		  	"esnext.iterator.range",
		  	"esnext.iterator.reduce",
		  	"esnext.iterator.some",
		  	"esnext.iterator.take",
		  	"esnext.iterator.to-array",
		  	"esnext.iterator.to-async",
		  	"esnext.json.is-raw-json",
		  	"esnext.json.parse",
		  	"esnext.json.raw-json",
		  	"esnext.map.delete-all",
		  	"esnext.map.emplace",
		  	"esnext.map.every",
		  	"esnext.map.filter",
		  	"esnext.map.find",
		  	"esnext.map.find-key",
		  	"esnext.map.from",
		  	"esnext.map.group-by",
		  	"esnext.map.includes",
		  	"esnext.map.key-by",
		  	"esnext.map.key-of",
		  	"esnext.map.map-keys",
		  	"esnext.map.map-values",
		  	"esnext.map.merge",
		  	"esnext.map.of",
		  	"esnext.map.reduce",
		  	"esnext.map.some",
		  	"esnext.map.update",
		  	"esnext.map.update-or-insert",
		  	"esnext.map.upsert",
		  	"esnext.math.clamp",
		  	"esnext.math.deg-per-rad",
		  	"esnext.math.degrees",
		  	"esnext.math.fscale",
		  	"esnext.math.f16round",
		  	"esnext.math.rad-per-deg",
		  	"esnext.math.radians",
		  	"esnext.math.scale",
		  	"esnext.math.seeded-prng",
		  	"esnext.math.signbit",
		  	"esnext.number.from-string",
		  	"esnext.number.range",
		  	"esnext.object.has-own",
		  	"esnext.object.iterate-entries",
		  	"esnext.object.iterate-keys",
		  	"esnext.object.iterate-values",
		  	"esnext.object.group-by",
		  	"esnext.observable",
		  	"esnext.promise.all-settled",
		  	"esnext.promise.any",
		  	"esnext.promise.try",
		  	"esnext.promise.with-resolvers",
		  	"esnext.regexp.escape",
		  	"esnext.set.add-all",
		  	"esnext.set.delete-all",
		  	"esnext.set.difference.v2",
		  	"esnext.set.difference",
		  	"esnext.set.every",
		  	"esnext.set.filter",
		  	"esnext.set.find",
		  	"esnext.set.from",
		  	"esnext.set.intersection.v2",
		  	"esnext.set.intersection",
		  	"esnext.set.is-disjoint-from.v2",
		  	"esnext.set.is-disjoint-from",
		  	"esnext.set.is-subset-of.v2",
		  	"esnext.set.is-subset-of",
		  	"esnext.set.is-superset-of.v2",
		  	"esnext.set.is-superset-of",
		  	"esnext.set.join",
		  	"esnext.set.map",
		  	"esnext.set.of",
		  	"esnext.set.reduce",
		  	"esnext.set.some",
		  	"esnext.set.symmetric-difference.v2",
		  	"esnext.set.symmetric-difference",
		  	"esnext.set.union.v2",
		  	"esnext.set.union",
		  	"esnext.string.cooked",
		  	"esnext.string.code-points",
		  	"esnext.string.dedent",
		  	"esnext.string.is-well-formed",
		  	"esnext.string.match-all",
		  	"esnext.string.replace-all",
		  	"esnext.string.to-well-formed",
		  	"esnext.symbol.async-dispose",
		  	"esnext.symbol.dispose",
		  	"esnext.symbol.is-registered-symbol",
		  	"esnext.symbol.is-registered",
		  	"esnext.symbol.is-well-known-symbol",
		  	"esnext.symbol.is-well-known",
		  	"esnext.symbol.matcher",
		  	"esnext.symbol.metadata",
		  	"esnext.symbol.metadata-key",
		  	"esnext.symbol.observable",
		  	"esnext.symbol.pattern-match",
		  	"esnext.symbol.replace-all",
		  	"esnext.typed-array.from-async",
		  	"esnext.typed-array.at",
		  	"esnext.typed-array.filter-reject",
		  	"esnext.typed-array.find-last",
		  	"esnext.typed-array.find-last-index",
		  	"esnext.typed-array.group-by",
		  	"esnext.typed-array.to-reversed",
		  	"esnext.typed-array.to-sorted",
		  	"esnext.typed-array.to-spliced",
		  	"esnext.typed-array.unique-by",
		  	"esnext.typed-array.with",
		  	"esnext.uint8-array.from-base64",
		  	"esnext.uint8-array.from-hex",
		  	"esnext.uint8-array.to-base64",
		  	"esnext.uint8-array.to-hex",
		  	"esnext.weak-map.delete-all",
		  	"esnext.weak-map.from",
		  	"esnext.weak-map.of",
		  	"esnext.weak-map.emplace",
		  	"esnext.weak-map.upsert",
		  	"esnext.weak-set.add-all",
		  	"esnext.weak-set.delete-all",
		  	"esnext.weak-set.from",
		  	"esnext.weak-set.of"
		  ],
		  	"core-js/stage/2": [
		  	"es.string.at-alternative",
		  	"esnext.aggregate-error",
		  	"esnext.suppressed-error.constructor",
		  	"esnext.array.from-async",
		  	"esnext.array.at",
		  	"esnext.array.find-last",
		  	"esnext.array.find-last-index",
		  	"esnext.array.group",
		  	"esnext.array.group-by",
		  	"esnext.array.group-by-to-map",
		  	"esnext.array.group-to-map",
		  	"esnext.array.is-template-object",
		  	"esnext.array.to-reversed",
		  	"esnext.array.to-sorted",
		  	"esnext.array.to-spliced",
		  	"esnext.array.with",
		  	"esnext.array-buffer.detached",
		  	"esnext.array-buffer.transfer",
		  	"esnext.array-buffer.transfer-to-fixed-length",
		  	"esnext.async-disposable-stack.constructor",
		  	"esnext.async-iterator.constructor",
		  	"esnext.async-iterator.as-indexed-pairs",
		  	"esnext.async-iterator.async-dispose",
		  	"esnext.async-iterator.drop",
		  	"esnext.async-iterator.every",
		  	"esnext.async-iterator.filter",
		  	"esnext.async-iterator.find",
		  	"esnext.async-iterator.flat-map",
		  	"esnext.async-iterator.for-each",
		  	"esnext.async-iterator.from",
		  	"esnext.async-iterator.indexed",
		  	"esnext.async-iterator.map",
		  	"esnext.async-iterator.reduce",
		  	"esnext.async-iterator.some",
		  	"esnext.async-iterator.take",
		  	"esnext.async-iterator.to-array",
		  	"esnext.data-view.get-float16",
		  	"esnext.data-view.set-float16",
		  	"esnext.disposable-stack.constructor",
		  	"esnext.function.metadata",
		  	"esnext.global-this",
		  	"esnext.iterator.constructor",
		  	"esnext.iterator.as-indexed-pairs",
		  	"esnext.iterator.dispose",
		  	"esnext.iterator.drop",
		  	"esnext.iterator.every",
		  	"esnext.iterator.filter",
		  	"esnext.iterator.find",
		  	"esnext.iterator.flat-map",
		  	"esnext.iterator.for-each",
		  	"esnext.iterator.from",
		  	"esnext.iterator.indexed",
		  	"esnext.iterator.map",
		  	"esnext.iterator.range",
		  	"esnext.iterator.reduce",
		  	"esnext.iterator.some",
		  	"esnext.iterator.take",
		  	"esnext.iterator.to-array",
		  	"esnext.iterator.to-async",
		  	"esnext.json.is-raw-json",
		  	"esnext.json.parse",
		  	"esnext.json.raw-json",
		  	"esnext.map.emplace",
		  	"esnext.map.group-by",
		  	"esnext.math.f16round",
		  	"esnext.object.has-own",
		  	"esnext.object.group-by",
		  	"esnext.promise.all-settled",
		  	"esnext.promise.any",
		  	"esnext.promise.try",
		  	"esnext.promise.with-resolvers",
		  	"esnext.regexp.escape",
		  	"esnext.set.difference.v2",
		  	"esnext.set.difference",
		  	"esnext.set.intersection.v2",
		  	"esnext.set.intersection",
		  	"esnext.set.is-disjoint-from.v2",
		  	"esnext.set.is-disjoint-from",
		  	"esnext.set.is-subset-of.v2",
		  	"esnext.set.is-subset-of",
		  	"esnext.set.is-superset-of.v2",
		  	"esnext.set.is-superset-of",
		  	"esnext.set.symmetric-difference.v2",
		  	"esnext.set.symmetric-difference",
		  	"esnext.set.union.v2",
		  	"esnext.set.union",
		  	"esnext.string.dedent",
		  	"esnext.string.is-well-formed",
		  	"esnext.string.match-all",
		  	"esnext.string.replace-all",
		  	"esnext.string.to-well-formed",
		  	"esnext.symbol.async-dispose",
		  	"esnext.symbol.dispose",
		  	"esnext.symbol.is-registered-symbol",
		  	"esnext.symbol.is-registered",
		  	"esnext.symbol.is-well-known-symbol",
		  	"esnext.symbol.is-well-known",
		  	"esnext.symbol.metadata",
		  	"esnext.symbol.metadata-key",
		  	"esnext.typed-array.at",
		  	"esnext.typed-array.find-last",
		  	"esnext.typed-array.find-last-index",
		  	"esnext.typed-array.group-by",
		  	"esnext.typed-array.to-reversed",
		  	"esnext.typed-array.to-sorted",
		  	"esnext.typed-array.to-spliced",
		  	"esnext.typed-array.with",
		  	"esnext.uint8-array.from-base64",
		  	"esnext.uint8-array.from-hex",
		  	"esnext.uint8-array.to-base64",
		  	"esnext.uint8-array.to-hex",
		  	"esnext.weak-map.emplace"
		  ],
		  	"core-js/stage/2.7": [
		  	"es.string.at-alternative",
		  	"esnext.aggregate-error",
		  	"esnext.suppressed-error.constructor",
		  	"esnext.array.from-async",
		  	"esnext.array.at",
		  	"esnext.array.find-last",
		  	"esnext.array.find-last-index",
		  	"esnext.array.group",
		  	"esnext.array.group-by",
		  	"esnext.array.group-by-to-map",
		  	"esnext.array.group-to-map",
		  	"esnext.array.to-reversed",
		  	"esnext.array.to-sorted",
		  	"esnext.array.to-spliced",
		  	"esnext.array.with",
		  	"esnext.array-buffer.detached",
		  	"esnext.array-buffer.transfer",
		  	"esnext.array-buffer.transfer-to-fixed-length",
		  	"esnext.async-disposable-stack.constructor",
		  	"esnext.async-iterator.constructor",
		  	"esnext.async-iterator.async-dispose",
		  	"esnext.async-iterator.drop",
		  	"esnext.async-iterator.every",
		  	"esnext.async-iterator.filter",
		  	"esnext.async-iterator.find",
		  	"esnext.async-iterator.flat-map",
		  	"esnext.async-iterator.for-each",
		  	"esnext.async-iterator.from",
		  	"esnext.async-iterator.map",
		  	"esnext.async-iterator.reduce",
		  	"esnext.async-iterator.some",
		  	"esnext.async-iterator.take",
		  	"esnext.async-iterator.to-array",
		  	"esnext.data-view.get-float16",
		  	"esnext.data-view.set-float16",
		  	"esnext.disposable-stack.constructor",
		  	"esnext.function.metadata",
		  	"esnext.global-this",
		  	"esnext.iterator.constructor",
		  	"esnext.iterator.dispose",
		  	"esnext.iterator.drop",
		  	"esnext.iterator.every",
		  	"esnext.iterator.filter",
		  	"esnext.iterator.find",
		  	"esnext.iterator.flat-map",
		  	"esnext.iterator.for-each",
		  	"esnext.iterator.from",
		  	"esnext.iterator.map",
		  	"esnext.iterator.reduce",
		  	"esnext.iterator.some",
		  	"esnext.iterator.take",
		  	"esnext.iterator.to-array",
		  	"esnext.iterator.to-async",
		  	"esnext.json.is-raw-json",
		  	"esnext.json.parse",
		  	"esnext.json.raw-json",
		  	"esnext.map.group-by",
		  	"esnext.math.f16round",
		  	"esnext.object.has-own",
		  	"esnext.object.group-by",
		  	"esnext.promise.all-settled",
		  	"esnext.promise.any",
		  	"esnext.promise.with-resolvers",
		  	"esnext.set.difference.v2",
		  	"esnext.set.intersection.v2",
		  	"esnext.set.is-disjoint-from.v2",
		  	"esnext.set.is-subset-of.v2",
		  	"esnext.set.is-superset-of.v2",
		  	"esnext.set.symmetric-difference.v2",
		  	"esnext.set.union.v2",
		  	"esnext.string.is-well-formed",
		  	"esnext.string.match-all",
		  	"esnext.string.replace-all",
		  	"esnext.string.to-well-formed",
		  	"esnext.symbol.async-dispose",
		  	"esnext.symbol.dispose",
		  	"esnext.symbol.metadata",
		  	"esnext.typed-array.at",
		  	"esnext.typed-array.find-last",
		  	"esnext.typed-array.find-last-index",
		  	"esnext.typed-array.to-reversed",
		  	"esnext.typed-array.to-sorted",
		  	"esnext.typed-array.to-spliced",
		  	"esnext.typed-array.with",
		  	"esnext.uint8-array.from-base64",
		  	"esnext.uint8-array.from-hex",
		  	"esnext.uint8-array.to-base64",
		  	"esnext.uint8-array.to-hex"
		  ],
		  	"core-js/stage/3": [
		  	"es.string.at-alternative",
		  	"esnext.aggregate-error",
		  	"esnext.suppressed-error.constructor",
		  	"esnext.array.from-async",
		  	"esnext.array.at",
		  	"esnext.array.find-last",
		  	"esnext.array.find-last-index",
		  	"esnext.array.group",
		  	"esnext.array.group-by",
		  	"esnext.array.group-by-to-map",
		  	"esnext.array.group-to-map",
		  	"esnext.array.to-reversed",
		  	"esnext.array.to-sorted",
		  	"esnext.array.to-spliced",
		  	"esnext.array.with",
		  	"esnext.array-buffer.detached",
		  	"esnext.array-buffer.transfer",
		  	"esnext.array-buffer.transfer-to-fixed-length",
		  	"esnext.async-disposable-stack.constructor",
		  	"esnext.async-iterator.constructor",
		  	"esnext.async-iterator.async-dispose",
		  	"esnext.async-iterator.drop",
		  	"esnext.async-iterator.every",
		  	"esnext.async-iterator.filter",
		  	"esnext.async-iterator.find",
		  	"esnext.async-iterator.flat-map",
		  	"esnext.async-iterator.for-each",
		  	"esnext.async-iterator.from",
		  	"esnext.async-iterator.map",
		  	"esnext.async-iterator.reduce",
		  	"esnext.async-iterator.some",
		  	"esnext.async-iterator.take",
		  	"esnext.async-iterator.to-array",
		  	"esnext.data-view.get-float16",
		  	"esnext.data-view.set-float16",
		  	"esnext.disposable-stack.constructor",
		  	"esnext.function.metadata",
		  	"esnext.global-this",
		  	"esnext.iterator.constructor",
		  	"esnext.iterator.dispose",
		  	"esnext.iterator.drop",
		  	"esnext.iterator.every",
		  	"esnext.iterator.filter",
		  	"esnext.iterator.find",
		  	"esnext.iterator.flat-map",
		  	"esnext.iterator.for-each",
		  	"esnext.iterator.from",
		  	"esnext.iterator.map",
		  	"esnext.iterator.reduce",
		  	"esnext.iterator.some",
		  	"esnext.iterator.take",
		  	"esnext.iterator.to-array",
		  	"esnext.iterator.to-async",
		  	"esnext.json.is-raw-json",
		  	"esnext.json.parse",
		  	"esnext.json.raw-json",
		  	"esnext.map.group-by",
		  	"esnext.math.f16round",
		  	"esnext.object.has-own",
		  	"esnext.object.group-by",
		  	"esnext.promise.all-settled",
		  	"esnext.promise.any",
		  	"esnext.promise.with-resolvers",
		  	"esnext.set.difference.v2",
		  	"esnext.set.intersection.v2",
		  	"esnext.set.is-disjoint-from.v2",
		  	"esnext.set.is-subset-of.v2",
		  	"esnext.set.is-superset-of.v2",
		  	"esnext.set.symmetric-difference.v2",
		  	"esnext.set.union.v2",
		  	"esnext.string.is-well-formed",
		  	"esnext.string.match-all",
		  	"esnext.string.replace-all",
		  	"esnext.string.to-well-formed",
		  	"esnext.symbol.async-dispose",
		  	"esnext.symbol.dispose",
		  	"esnext.symbol.metadata",
		  	"esnext.typed-array.at",
		  	"esnext.typed-array.find-last",
		  	"esnext.typed-array.find-last-index",
		  	"esnext.typed-array.to-reversed",
		  	"esnext.typed-array.to-sorted",
		  	"esnext.typed-array.to-spliced",
		  	"esnext.typed-array.with",
		  	"esnext.uint8-array.from-base64",
		  	"esnext.uint8-array.from-hex",
		  	"esnext.uint8-array.to-base64",
		  	"esnext.uint8-array.to-hex"
		  ],
		  	"core-js/stage/4": [
		  	"es.string.at-alternative",
		  	"esnext.aggregate-error",
		  	"esnext.array.at",
		  	"esnext.array.find-last",
		  	"esnext.array.find-last-index",
		  	"esnext.array.to-reversed",
		  	"esnext.array.to-sorted",
		  	"esnext.array.to-spliced",
		  	"esnext.array.with",
		  	"esnext.array-buffer.detached",
		  	"esnext.array-buffer.transfer",
		  	"esnext.array-buffer.transfer-to-fixed-length",
		  	"esnext.global-this",
		  	"esnext.map.group-by",
		  	"esnext.object.has-own",
		  	"esnext.object.group-by",
		  	"esnext.promise.all-settled",
		  	"esnext.promise.any",
		  	"esnext.promise.with-resolvers",
		  	"esnext.string.is-well-formed",
		  	"esnext.string.match-all",
		  	"esnext.string.replace-all",
		  	"esnext.string.to-well-formed",
		  	"esnext.typed-array.at",
		  	"esnext.typed-array.find-last",
		  	"esnext.typed-array.find-last-index",
		  	"esnext.typed-array.to-reversed",
		  	"esnext.typed-array.to-sorted",
		  	"esnext.typed-array.with"
		  ],
		  	"core-js/stage/pre": [
		  	"es.map",
		  	"es.string.at-alternative",
		  	"esnext.aggregate-error",
		  	"esnext.suppressed-error.constructor",
		  	"esnext.array.from-async",
		  	"esnext.array.at",
		  	"esnext.array.filter-out",
		  	"esnext.array.filter-reject",
		  	"esnext.array.find-last",
		  	"esnext.array.find-last-index",
		  	"esnext.array.group",
		  	"esnext.array.group-by",
		  	"esnext.array.group-by-to-map",
		  	"esnext.array.group-to-map",
		  	"esnext.array.is-template-object",
		  	"esnext.array.last-index",
		  	"esnext.array.last-item",
		  	"esnext.array.to-reversed",
		  	"esnext.array.to-sorted",
		  	"esnext.array.to-spliced",
		  	"esnext.array.unique-by",
		  	"esnext.array.with",
		  	"esnext.array-buffer.detached",
		  	"esnext.array-buffer.transfer",
		  	"esnext.array-buffer.transfer-to-fixed-length",
		  	"esnext.async-disposable-stack.constructor",
		  	"esnext.async-iterator.constructor",
		  	"esnext.async-iterator.as-indexed-pairs",
		  	"esnext.async-iterator.async-dispose",
		  	"esnext.async-iterator.drop",
		  	"esnext.async-iterator.every",
		  	"esnext.async-iterator.filter",
		  	"esnext.async-iterator.find",
		  	"esnext.async-iterator.flat-map",
		  	"esnext.async-iterator.for-each",
		  	"esnext.async-iterator.from",
		  	"esnext.async-iterator.indexed",
		  	"esnext.async-iterator.map",
		  	"esnext.async-iterator.reduce",
		  	"esnext.async-iterator.some",
		  	"esnext.async-iterator.take",
		  	"esnext.async-iterator.to-array",
		  	"esnext.bigint.range",
		  	"esnext.composite-key",
		  	"esnext.composite-symbol",
		  	"esnext.data-view.get-float16",
		  	"esnext.data-view.get-uint8-clamped",
		  	"esnext.data-view.set-float16",
		  	"esnext.data-view.set-uint8-clamped",
		  	"esnext.disposable-stack.constructor",
		  	"esnext.function.demethodize",
		  	"esnext.function.is-callable",
		  	"esnext.function.is-constructor",
		  	"esnext.function.metadata",
		  	"esnext.function.un-this",
		  	"esnext.global-this",
		  	"esnext.iterator.constructor",
		  	"esnext.iterator.as-indexed-pairs",
		  	"esnext.iterator.dispose",
		  	"esnext.iterator.drop",
		  	"esnext.iterator.every",
		  	"esnext.iterator.filter",
		  	"esnext.iterator.find",
		  	"esnext.iterator.flat-map",
		  	"esnext.iterator.for-each",
		  	"esnext.iterator.from",
		  	"esnext.iterator.indexed",
		  	"esnext.iterator.map",
		  	"esnext.iterator.range",
		  	"esnext.iterator.reduce",
		  	"esnext.iterator.some",
		  	"esnext.iterator.take",
		  	"esnext.iterator.to-array",
		  	"esnext.iterator.to-async",
		  	"esnext.json.is-raw-json",
		  	"esnext.json.parse",
		  	"esnext.json.raw-json",
		  	"esnext.map.delete-all",
		  	"esnext.map.emplace",
		  	"esnext.map.every",
		  	"esnext.map.filter",
		  	"esnext.map.find",
		  	"esnext.map.find-key",
		  	"esnext.map.from",
		  	"esnext.map.group-by",
		  	"esnext.map.includes",
		  	"esnext.map.key-by",
		  	"esnext.map.key-of",
		  	"esnext.map.map-keys",
		  	"esnext.map.map-values",
		  	"esnext.map.merge",
		  	"esnext.map.of",
		  	"esnext.map.reduce",
		  	"esnext.map.some",
		  	"esnext.map.update",
		  	"esnext.map.update-or-insert",
		  	"esnext.map.upsert",
		  	"esnext.math.clamp",
		  	"esnext.math.deg-per-rad",
		  	"esnext.math.degrees",
		  	"esnext.math.fscale",
		  	"esnext.math.f16round",
		  	"esnext.math.iaddh",
		  	"esnext.math.imulh",
		  	"esnext.math.isubh",
		  	"esnext.math.rad-per-deg",
		  	"esnext.math.radians",
		  	"esnext.math.scale",
		  	"esnext.math.seeded-prng",
		  	"esnext.math.signbit",
		  	"esnext.math.umulh",
		  	"esnext.number.from-string",
		  	"esnext.number.range",
		  	"esnext.object.has-own",
		  	"esnext.object.iterate-entries",
		  	"esnext.object.iterate-keys",
		  	"esnext.object.iterate-values",
		  	"esnext.object.group-by",
		  	"esnext.observable",
		  	"esnext.promise.all-settled",
		  	"esnext.promise.any",
		  	"esnext.promise.try",
		  	"esnext.promise.with-resolvers",
		  	"esnext.reflect.define-metadata",
		  	"esnext.reflect.delete-metadata",
		  	"esnext.reflect.get-metadata",
		  	"esnext.reflect.get-metadata-keys",
		  	"esnext.reflect.get-own-metadata",
		  	"esnext.reflect.get-own-metadata-keys",
		  	"esnext.reflect.has-metadata",
		  	"esnext.reflect.has-own-metadata",
		  	"esnext.reflect.metadata",
		  	"esnext.regexp.escape",
		  	"esnext.set.add-all",
		  	"esnext.set.delete-all",
		  	"esnext.set.difference.v2",
		  	"esnext.set.difference",
		  	"esnext.set.every",
		  	"esnext.set.filter",
		  	"esnext.set.find",
		  	"esnext.set.from",
		  	"esnext.set.intersection.v2",
		  	"esnext.set.intersection",
		  	"esnext.set.is-disjoint-from.v2",
		  	"esnext.set.is-disjoint-from",
		  	"esnext.set.is-subset-of.v2",
		  	"esnext.set.is-subset-of",
		  	"esnext.set.is-superset-of.v2",
		  	"esnext.set.is-superset-of",
		  	"esnext.set.join",
		  	"esnext.set.map",
		  	"esnext.set.of",
		  	"esnext.set.reduce",
		  	"esnext.set.some",
		  	"esnext.set.symmetric-difference.v2",
		  	"esnext.set.symmetric-difference",
		  	"esnext.set.union.v2",
		  	"esnext.set.union",
		  	"esnext.string.at",
		  	"esnext.string.cooked",
		  	"esnext.string.code-points",
		  	"esnext.string.dedent",
		  	"esnext.string.is-well-formed",
		  	"esnext.string.match-all",
		  	"esnext.string.replace-all",
		  	"esnext.string.to-well-formed",
		  	"esnext.symbol.async-dispose",
		  	"esnext.symbol.dispose",
		  	"esnext.symbol.is-registered-symbol",
		  	"esnext.symbol.is-registered",
		  	"esnext.symbol.is-well-known-symbol",
		  	"esnext.symbol.is-well-known",
		  	"esnext.symbol.matcher",
		  	"esnext.symbol.metadata",
		  	"esnext.symbol.metadata-key",
		  	"esnext.symbol.observable",
		  	"esnext.symbol.pattern-match",
		  	"esnext.symbol.replace-all",
		  	"esnext.typed-array.from-async",
		  	"esnext.typed-array.at",
		  	"esnext.typed-array.filter-out",
		  	"esnext.typed-array.filter-reject",
		  	"esnext.typed-array.find-last",
		  	"esnext.typed-array.find-last-index",
		  	"esnext.typed-array.group-by",
		  	"esnext.typed-array.to-reversed",
		  	"esnext.typed-array.to-sorted",
		  	"esnext.typed-array.to-spliced",
		  	"esnext.typed-array.unique-by",
		  	"esnext.typed-array.with",
		  	"esnext.uint8-array.from-base64",
		  	"esnext.uint8-array.from-hex",
		  	"esnext.uint8-array.to-base64",
		  	"esnext.uint8-array.to-hex",
		  	"esnext.weak-map.delete-all",
		  	"esnext.weak-map.from",
		  	"esnext.weak-map.of",
		  	"esnext.weak-map.emplace",
		  	"esnext.weak-map.upsert",
		  	"esnext.weak-set.add-all",
		  	"esnext.weak-set.delete-all",
		  	"esnext.weak-set.from",
		  	"esnext.weak-set.of",
		  	"web.url",
		  	"web.url.can-parse",
		  	"web.url.to-json",
		  	"web.url-search-params",
		  	"web.url-search-params.delete",
		  	"web.url-search-params.has",
		  	"web.url-search-params.size"
		  ],
		  	"core-js/web": [
		  	"web.atob",
		  	"web.btoa",
		  	"web.dom-collections.for-each",
		  	"web.dom-collections.iterator",
		  	"web.dom-exception.constructor",
		  	"web.dom-exception.stack",
		  	"web.dom-exception.to-string-tag",
		  	"web.immediate",
		  	"web.queue-microtask",
		  	"web.self",
		  	"web.structured-clone",
		  	"web.timers",
		  	"web.url",
		  	"web.url.can-parse",
		  	"web.url.to-json",
		  	"web.url-search-params",
		  	"web.url-search-params.delete",
		  	"web.url-search-params.has",
		  	"web.url-search-params.size"
		  ],
		  	"core-js/web/dom-collections": [
		  	"web.dom-collections.for-each",
		  	"web.dom-collections.iterator"
		  ],
		  	"core-js/web/dom-exception": [
		  	"es.error.to-string",
		  	"web.dom-exception.constructor",
		  	"web.dom-exception.stack",
		  	"web.dom-exception.to-string-tag"
		  ],
		  	"core-js/web/immediate": [
		  	"web.immediate"
		  ],
		  	"core-js/web/queue-microtask": [
		  	"web.queue-microtask"
		  ],
		  	"core-js/web/structured-clone": [
		  	"es.array.iterator",
		  	"es.map",
		  	"es.object.to-string",
		  	"es.set",
		  	"web.structured-clone"
		  ],
		  	"core-js/web/timers": [
		  	"web.timers"
		  ],
		  	"core-js/web/url": [
		  	"web.url",
		  	"web.url.can-parse",
		  	"web.url.to-json",
		  	"web.url-search-params",
		  	"web.url-search-params.delete",
		  	"web.url-search-params.has",
		  	"web.url-search-params.size"
		  ],
		  	"core-js/web/url-search-params": [
		  	"web.url-search-params",
		  	"web.url-search-params.delete",
		  	"web.url-search-params.has",
		  	"web.url-search-params.size"
		  ]
		  };

		  var entries$1;
		  var hasRequiredEntries;
		  function requireEntries() {
		    if (hasRequiredEntries) return entries$1;
		    hasRequiredEntries = 1;
		    entries$1 = require$$0$2;
		    return entries$1;
		  }

		  var hasRequiredUtils$2;
		  function requireUtils$2() {
		    if (hasRequiredUtils$2) return utils$2;
		    hasRequiredUtils$2 = 1;
		    utils$2.__esModule = true;
		    utils$2.BABEL_RUNTIME = void 0;
		    utils$2.callMethod = callMethod;
		    utils$2.coreJSModule = coreJSModule;
		    utils$2.coreJSPureHelper = coreJSPureHelper;
		    utils$2.isCoreJSSource = isCoreJSSource;
		    var _babel = _interopRequireWildcard(require$$5);
		    var _entries = _interopRequireDefault(requireEntries());
		    function _interopRequireDefault(obj) {
		      return obj && obj.__esModule ? obj : {
		        "default": obj
		      };
		    }
		    function _getRequireWildcardCache(nodeInterop) {
		      if (typeof WeakMap !== "function") return null;
		      var cacheBabelInterop = new WeakMap();
		      var cacheNodeInterop = new WeakMap();
		      return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) {
		        return nodeInterop ? cacheNodeInterop : cacheBabelInterop;
		      })(nodeInterop);
		    }
		    function _interopRequireWildcard(obj, nodeInterop) {
		      if (!nodeInterop && obj && obj.__esModule) {
		        return obj;
		      }
		      if (obj === null || typeof obj !== "object" && typeof obj !== "function") {
		        return {
		          "default": obj
		        };
		      }
		      var cache = _getRequireWildcardCache(nodeInterop);
		      if (cache && cache.has(obj)) {
		        return cache.get(obj);
		      }
		      var newObj = {};
		      var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
		      for (var key in obj) {
		        if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) {
		          var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
		          if (desc && (desc.get || desc.set)) {
		            Object.defineProperty(newObj, key, desc);
		          } else {
		            newObj[key] = obj[key];
		          }
		        }
		      }
		      newObj["default"] = obj;
		      if (cache) {
		        cache.set(obj, newObj);
		      }
		      return newObj;
		    }
		    var _ref = _babel["default"] || _babel,
		      t = _ref.types;
		    var BABEL_RUNTIME = "@babel/runtime-corejs3";
		    utils$2.BABEL_RUNTIME = BABEL_RUNTIME;
		    function callMethod(path, id) {
		      var object = path.node.object;
		      var context1, context2;
		      if (t.isIdentifier(object)) {
		        context1 = object;
		        context2 = t.cloneNode(object);
		      } else {
		        context1 = path.scope.generateDeclaredUidIdentifier("context");
		        context2 = t.assignmentExpression("=", t.cloneNode(context1), object);
		      }
		      path.replaceWith(t.memberExpression(t.callExpression(id, [context2]), t.identifier("call")));
		      path.parentPath.unshiftContainer("arguments", context1);
		    }
		    function isCoreJSSource(source) {
		      if (typeof source === "string") {
		        source = source.replace(/\\/g, "/").replace(/(\/(index)?)?(\.js)?$/i, "").toLowerCase();
		      }
		      return Object.prototype.hasOwnProperty.call(_entries["default"], source) && _entries["default"][source];
		    }
		    function coreJSModule(name) {
		      return "core-js/modules/" + name + ".js";
		    }
		    function coreJSPureHelper(name, useBabelRuntime, ext) {
		      return useBabelRuntime ? BABEL_RUNTIME + "/core-js/" + name + ext : "core-js-pure/features/" + name + ".js";
		    }
		    return utils$2;
		  }

		  var hasRequiredLib$4;
		  function requireLib$4() {
		    if (hasRequiredLib$4) return lib$4;
		    hasRequiredLib$4 = 1;
		    lib$4.__esModule = true;
		    lib$4["default"] = void 0;
		    var _data = _interopRequireDefault(requireData());
		    var _shippedProposals = _interopRequireDefault(requireShippedProposals());
		    var _getModulesListForTargetVersion = _interopRequireDefault(requireGetModulesListForTargetVersion());
		    var _builtInDefinitions = requireBuiltInDefinitions$1();
		    var BabelRuntimePaths = _interopRequireWildcard(requireBabelRuntimeCorejs3Paths());
		    var _usageFilters = _interopRequireDefault(requireUsageFilters());
		    var _babel = _interopRequireWildcard(require$$5);
		    var _utils = requireUtils$2();
		    var _helperDefinePolyfillProvider = _interopRequireDefault(requireLib$6());
		    function _getRequireWildcardCache(nodeInterop) {
		      if (typeof WeakMap !== "function") return null;
		      var cacheBabelInterop = new WeakMap();
		      var cacheNodeInterop = new WeakMap();
		      return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) {
		        return nodeInterop ? cacheNodeInterop : cacheBabelInterop;
		      })(nodeInterop);
		    }
		    function _interopRequireWildcard(obj, nodeInterop) {
		      if (!nodeInterop && obj && obj.__esModule) {
		        return obj;
		      }
		      if (obj === null || typeof obj !== "object" && typeof obj !== "function") {
		        return {
		          "default": obj
		        };
		      }
		      var cache = _getRequireWildcardCache(nodeInterop);
		      if (cache && cache.has(obj)) {
		        return cache.get(obj);
		      }
		      var newObj = {};
		      var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
		      for (var key in obj) {
		        if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) {
		          var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
		          if (desc && (desc.get || desc.set)) {
		            Object.defineProperty(newObj, key, desc);
		          } else {
		            newObj[key] = obj[key];
		          }
		        }
		      }
		      newObj["default"] = obj;
		      if (cache) {
		        cache.set(obj, newObj);
		      }
		      return newObj;
		    }
		    function _interopRequireDefault(obj) {
		      return obj && obj.__esModule ? obj : {
		        "default": obj
		      };
		    }
		    function _extends() {
		      _extends = Object.assign ? Object.assign.bind() : function (target) {
		        for (var i = 1; i < arguments.length; i++) {
		          var source = arguments[i];
		          for (var key in source) {
		            if (Object.prototype.hasOwnProperty.call(source, key)) {
		              target[key] = source[key];
		            }
		          }
		        }
		        return target;
		      };
		      return _extends.apply(this, arguments);
		    }
		    var _ref = _babel["default"] || _babel,
		      t = _ref.types;
		    var presetEnvCompat = "#__secret_key__@babel/preset-env__compatibility";
		    var runtimeCompat = "#__secret_key__@babel/runtime__compatibility";
		    var uniqueObjects = ["array", "string", "iterator", "async-iterator", "dom-collections"].map(function (v) {
		      return new RegExp("[a-z]*\\." + v + "\\..*");
		    });
		    var esnextFallback = function esnextFallback(name, cb) {
		      if (cb(name)) return true;
		      if (!name.startsWith("es.")) return false;
		      var fallback = "esnext." + name.slice(3);
		      if (!_data["default"][fallback]) return false;
		      return cb(fallback);
		    };
		    var _default = (0, _helperDefinePolyfillProvider["default"])(function (_ref2, _ref3) {
		      var getUtils = _ref2.getUtils,
		        method = _ref2.method,
		        shouldInjectPolyfill = _ref2.shouldInjectPolyfill,
		        createMetaResolver = _ref2.createMetaResolver,
		        debug = _ref2.debug,
		        babel = _ref2.babel;
		      var _ref3$version = _ref3.version,
		        version = _ref3$version === void 0 ? 3 : _ref3$version,
		        proposals = _ref3.proposals,
		        shippedProposals = _ref3.shippedProposals,
		        _ref3$presetEnvCompat = _ref3[presetEnvCompat],
		        _ref3$presetEnvCompat2 = _ref3$presetEnvCompat === void 0 ? {} : _ref3$presetEnvCompat,
		        _ref3$presetEnvCompat3 = _ref3$presetEnvCompat2.noRuntimeName,
		        noRuntimeName = _ref3$presetEnvCompat3 === void 0 ? false : _ref3$presetEnvCompat3,
		        _ref3$runtimeCompat = _ref3[runtimeCompat],
		        _ref3$runtimeCompat2 = _ref3$runtimeCompat === void 0 ? {} : _ref3$runtimeCompat,
		        _ref3$runtimeCompat2$ = _ref3$runtimeCompat2.useBabelRuntime,
		        useBabelRuntime = _ref3$runtimeCompat2$ === void 0 ? false : _ref3$runtimeCompat2$,
		        _ref3$runtimeCompat2$2 = _ref3$runtimeCompat2.ext,
		        ext = _ref3$runtimeCompat2$2 === void 0 ? ".js" : _ref3$runtimeCompat2$2;
		      var isWebpack = babel.caller(function (caller) {
		        return (caller == null ? void 0 : caller.name) === "babel-loader";
		      });
		      var resolve = createMetaResolver({
		        global: _builtInDefinitions.BuiltIns,
		        "static": _builtInDefinitions.StaticProperties,
		        instance: _builtInDefinitions.InstanceProperties
		      });
		      var available = new Set((0, _getModulesListForTargetVersion["default"])(version));
		      function getCoreJSPureBase(useProposalBase) {
		        return useBabelRuntime ? useProposalBase ? _utils.BABEL_RUNTIME + "/core-js" : _utils.BABEL_RUNTIME + "/core-js-stable" : useProposalBase ? "core-js-pure/features" : "core-js-pure/stable";
		      }
		      function maybeInjectGlobalImpl(name, utils) {
		        if (shouldInjectPolyfill(name)) {
		          debug(name);
		          utils.injectGlobalImport((0, _utils.coreJSModule)(name), name);
		          return true;
		        }
		        return false;
		      }
		      function maybeInjectGlobal(names, utils, fallback) {
		        if (fallback === void 0) {
		          fallback = true;
		        }
		        for (var _iterator = _createForOfIteratorHelperLoose(names), _step; !(_step = _iterator()).done;) {
		          var name = _step.value;
		          if (fallback) {
		            esnextFallback(name, function (name) {
		              return maybeInjectGlobalImpl(name, utils);
		            });
		          } else {
		            maybeInjectGlobalImpl(name, utils);
		          }
		        }
		      }
		      function maybeInjectPure(desc, hint, utils, object) {
		        if (desc.pure && !(object && desc.exclude && desc.exclude.includes(object)) && esnextFallback(desc.name, shouldInjectPolyfill)) {
		          var name = desc.name;
		          var useProposalBase = false;
		          if (proposals || shippedProposals && name.startsWith("esnext.")) {
		            useProposalBase = true;
		          } else if (name.startsWith("es.") && !available.has(name)) {
		            useProposalBase = true;
		          }
		          if (useBabelRuntime && !(useProposalBase ? BabelRuntimePaths.proposals : BabelRuntimePaths.stable).has(desc.pure)) {
		            return;
		          }
		          var coreJSPureBase = getCoreJSPureBase(useProposalBase);
		          return utils.injectDefaultImport(coreJSPureBase + "/" + desc.pure + ext, hint);
		        }
		      }
		      function isFeatureStable(name) {
		        if (name.startsWith("esnext.")) {
		          var esName = "es." + name.slice(7);
		          return esName in _data["default"];
		        }
		        return true;
		      }
		      return {
		        name: "corejs3",
		        runtimeName: noRuntimeName ? null : _utils.BABEL_RUNTIME,
		        polyfills: _data["default"],
		        filterPolyfills: function filterPolyfills(name) {
		          if (!available.has(name)) return false;
		          if (proposals || method === "entry-global") return true;
		          if (shippedProposals && _shippedProposals["default"].has(name)) {
		            return true;
		          }
		          return isFeatureStable(name);
		        },
		        entryGlobal: function entryGlobal(meta, utils, path) {
		          if (meta.kind !== "import") return;
		          var modules = (0, _utils.isCoreJSSource)(meta.source);
		          if (!modules) return;
		          if (modules.length === 1 && meta.source === (0, _utils.coreJSModule)(modules[0]) && shouldInjectPolyfill(modules[0])) {
		            debug(null);
		            return;
		          }
		          var modulesSet = new Set(modules);
		          var filteredModules = modules.filter(function (module) {
		            if (!module.startsWith("esnext.")) return true;
		            var stable = module.replace("esnext.", "es.");
		            if (modulesSet.has(stable) && shouldInjectPolyfill(stable)) {
		              return false;
		            }
		            return true;
		          });
		          maybeInjectGlobal(filteredModules, utils, false);
		          path.remove();
		        },
		        usageGlobal: function usageGlobal(meta, utils, path) {
		          var resolved = resolve(meta);
		          if (!resolved) return;
		          if ((0, _usageFilters["default"])(resolved.desc, path)) return;
		          var deps = resolved.desc.global;
		          if (resolved.kind !== "global" && "object" in meta && meta.object && meta.placement === "prototype") {
		            var low = meta.object.toLowerCase();
		            deps = deps.filter(function (m) {
		              return uniqueObjects.some(function (v) {
		                return v.test(m);
		              }) ? m.includes(low) : true;
		            });
		          }
		          maybeInjectGlobal(deps, utils);
		          return true;
		        },
		        usagePure: function usagePure(meta, utils, path) {
		          if (meta.kind === "in") {
		            if (meta.key === "Symbol.iterator") {
		              path.replaceWith(t.callExpression(utils.injectDefaultImport((0, _utils.coreJSPureHelper)("is-iterable", useBabelRuntime, ext), "isIterable"), [path.node.right]));
		            }
		            return;
		          }
		          if (path.parentPath.isUnaryExpression({
		            operator: "delete"
		          })) return;
		          if (meta.kind === "property") {
		            if (!path.isMemberExpression()) return;
		            if (!path.isReferenced()) return;
		            if (path.parentPath.isUpdateExpression()) return;
		            if (t.isSuper(path.node.object)) {
		              return;
		            }
		            if (meta.key === "Symbol.iterator") {
		              if (!shouldInjectPolyfill("es.symbol.iterator")) return;
		              var parent = path.parent,
		                node = path.node;
		              if (t.isCallExpression(parent, {
		                callee: node
		              })) {
		                if (parent.arguments.length === 0) {
		                  path.parentPath.replaceWith(t.callExpression(utils.injectDefaultImport((0, _utils.coreJSPureHelper)("get-iterator", useBabelRuntime, ext), "getIterator"), [node.object]));
		                  path.skip();
		                } else {
		                  (0, _utils.callMethod)(path, utils.injectDefaultImport((0, _utils.coreJSPureHelper)("get-iterator-method", useBabelRuntime, ext), "getIteratorMethod"));
		                }
		              } else {
		                path.replaceWith(t.callExpression(utils.injectDefaultImport((0, _utils.coreJSPureHelper)("get-iterator-method", useBabelRuntime, ext), "getIteratorMethod"), [path.node.object]));
		              }
		              return;
		            }
		          }
		          var resolved = resolve(meta);
		          if (!resolved) return;
		          if ((0, _usageFilters["default"])(resolved.desc, path)) return;
		          if (useBabelRuntime && resolved.desc.pure && resolved.desc.pure.slice(-6) === "/index") {
		            resolved = _extends({}, resolved, {
		              desc: _extends({}, resolved.desc, {
		                pure: resolved.desc.pure.slice(0, -6)
		              })
		            });
		          }
		          if (resolved.kind === "global") {
		            var id = maybeInjectPure(resolved.desc, resolved.name, utils);
		            if (id) path.replaceWith(id);
		          } else if (resolved.kind === "static") {
		            var _id = maybeInjectPure(resolved.desc, resolved.name, utils, meta.object);
		            if (_id) path.replaceWith(_id);
		          } else if (resolved.kind === "instance") {
		            var _id2 = maybeInjectPure(resolved.desc, resolved.name + "InstanceProperty", utils, meta.object);
		            if (!_id2) return;
		            var _node = path.node;
		            if (t.isCallExpression(path.parent, {
		              callee: _node
		            })) {
		              (0, _utils.callMethod)(path, _id2);
		            } else {
		              path.replaceWith(t.callExpression(_id2, [_node.object]));
		            }
		          }
		        },
		        visitor: method === "usage-global" && {
		          CallExpression: function CallExpression(path) {
		            if (path.get("callee").isImport()) {
		              var utils = getUtils(path);
		              if (isWebpack) {
		                maybeInjectGlobal(_builtInDefinitions.PromiseDependenciesWithIterators, utils);
		              } else {
		                maybeInjectGlobal(_builtInDefinitions.PromiseDependencies, utils);
		              }
		            }
		          },
		          Function: function Function(path) {
		            if (path.node.async) {
		              maybeInjectGlobal(_builtInDefinitions.PromiseDependencies, getUtils(path));
		            }
		          },
		          "ForOfStatement|ArrayPattern": function ForOfStatementArrayPattern(path) {
		            maybeInjectGlobal(_builtInDefinitions.CommonIterators, getUtils(path));
		          },
		          SpreadElement: function SpreadElement(path) {
		            if (!path.parentPath.isObjectExpression()) {
		              maybeInjectGlobal(_builtInDefinitions.CommonIterators, getUtils(path));
		            }
		          },
		          YieldExpression: function YieldExpression(path) {
		            if (path.node.delegate) {
		              maybeInjectGlobal(_builtInDefinitions.CommonIterators, getUtils(path));
		            }
		          },
		          Class: function Class(path) {
		            var _path$node$decorators;
		            var hasDecorators = ((_path$node$decorators = path.node.decorators) == null ? void 0 : _path$node$decorators.length) || path.node.body.body.some(function (el) {
		              var _decorators;
		              return (_decorators = el.decorators) == null ? void 0 : _decorators.length;
		            });
		            if (hasDecorators) {
		              maybeInjectGlobal(_builtInDefinitions.DecoratorMetadataDependencies, getUtils(path));
		            }
		          }
		        }
		      };
		    });
		    lib$4["default"] = _default;
		    return lib$4;
		  }

		  var lib$3 = {};

		  var hasRequiredLib$3;
		  function requireLib$3() {
		    if (hasRequiredLib$3) return lib$3;
		    hasRequiredLib$3 = 1;
		    lib$3.__esModule = true;
		    lib$3["default"] = void 0;
		    var _helperDefinePolyfillProvider = _interopRequireDefault(requireLib$6());
		    function _interopRequireDefault(obj) {
		      return obj && obj.__esModule ? obj : {
		        "default": obj
		      };
		    }
		    var runtimeCompat = "#__secret_key__@babel/runtime__compatibility";
		    var _default = (0, _helperDefinePolyfillProvider["default"])(function (_ref2, options) {
		      var debug = _ref2.debug,
		        targets = _ref2.targets,
		        babel = _ref2.babel;
		      if (!shallowEqual(targets, babel.targets())) {
		        throw new Error("This plugin does not use the targets option. Only preset-env's targets" + " or top-level targets need to be configured for this plugin to work." + " See https://github.com/babel/babel-polyfills/issues/36 for more" + " details.");
		      }
		      var _options$runtimeCompa = options[runtimeCompat],
		        _options$runtimeCompa2 = _options$runtimeCompa === void 0 ? {} : _options$runtimeCompa,
		        _options$runtimeCompa3 = _options$runtimeCompa2.moduleName,
		        moduleName = _options$runtimeCompa3 === void 0 ? null : _options$runtimeCompa3,
		        _options$runtimeCompa4 = _options$runtimeCompa2.useBabelRuntime,
		        useBabelRuntime = _options$runtimeCompa4 === void 0 ? false : _options$runtimeCompa4;
		      return {
		        name: "regenerator",
		        polyfills: ["regenerator-runtime"],
		        usageGlobal: function usageGlobal(meta, utils) {
		          if (isRegenerator(meta)) {
		            debug("regenerator-runtime");
		            utils.injectGlobalImport("regenerator-runtime/runtime.js");
		          }
		        },
		        usagePure: function usagePure(meta, utils, path) {
		          if (isRegenerator(meta)) {
		            var pureName = "regenerator-runtime";
		            if (useBabelRuntime) {
		              var _ref;
		              var runtimeName = (_ref = moduleName != null ? moduleName : path.hub.file.get("runtimeHelpersModuleName")) != null ? _ref : "@babel/runtime";
		              pureName = runtimeName + "/regenerator";
		            }
		            path.replaceWith(utils.injectDefaultImport(pureName, "regenerator-runtime"));
		          }
		        }
		      };
		    });
		    lib$3["default"] = _default;
		    var isRegenerator = function isRegenerator(meta) {
		      return meta.kind === "global" && meta.name === "regeneratorRuntime";
		    };
		    function shallowEqual(obj1, obj2) {
		      return JSON.stringify(obj1) === JSON.stringify(obj2);
		    }
		    return lib$3;
		  }

		  var babelPluginPolyfillRegenerator$1;
		  var hasRequiredBabelPluginPolyfillRegenerator$1;
		  function requireBabelPluginPolyfillRegenerator$1() {
		    if (hasRequiredBabelPluginPolyfillRegenerator$1) return babelPluginPolyfillRegenerator$1;
		    hasRequiredBabelPluginPolyfillRegenerator$1 = 1;
		    function bool(value) {
		      if (value == null) return false;
		      return value && value !== "false" && value !== "0";
		    }
		    babelPluginPolyfillRegenerator$1 = bool(browser$1$1.env["BABEL_8_BREAKING"]) ? null : requireLib$3();
		    return babelPluginPolyfillRegenerator$1;
		  }

		  var polyfills;
		  var hasRequiredPolyfills;
		  function requirePolyfills() {
		    if (hasRequiredPolyfills) return polyfills;
		    hasRequiredPolyfills = 1;
		    var pluginCorejs2 = requireBabelPluginPolyfillCorejs2$1()["default"];
		    var pluginCorejs3 = requireLib$4()["default"];
		    var pluginRegenerator = requireBabelPluginPolyfillRegenerator$1()["default"];
		    var pluginsCompat = "#__secret_key__@babel/runtime__compatibility";
		    function createCorejs2Plugin(options) {
		      return function (api, _, filename) {
		        return pluginCorejs2(api, options, filename);
		      };
		    }
		    function createCorejs3Plugin(options) {
		      return function (api, _, filename) {
		        return pluginCorejs3(api, options, filename);
		      };
		    }
		    function createRegeneratorPlugin(options, useRuntimeRegenerator, corejsPlugin) {
		      if (!useRuntimeRegenerator) return corejsPlugin != null ? corejsPlugin : undefined;
		      return function (api, _, filename) {
		        return Object.assign({}, pluginRegenerator(api, options, filename), {
		          inherits: corejsPlugin != null ? corejsPlugin : undefined
		        });
		      };
		    }
		    polyfills = function createBasePolyfillsPlugin(_ref, runtimeVersion, absoluteImports) {
		      var _polyfillOpts;
		      var corejs = _ref.corejs,
		        _ref$regenerator = _ref.regenerator,
		        regenerator = _ref$regenerator === void 0 ? true : _ref$regenerator,
		        moduleName = _ref.moduleName;
		      var proposals = false;
		      var rawVersion;
		      if (typeof corejs === "object" && corejs !== null) {
		        rawVersion = corejs.version;
		        proposals = Boolean(corejs.proposals);
		      } else {
		        rawVersion = corejs;
		      }
		      var corejsVersion = rawVersion ? Number(rawVersion) : false;
		      if (![false, 2, 3].includes(corejsVersion)) {
		        throw new Error("The `core-js` version must be false, 2 or 3, but got " + JSON.stringify(rawVersion) + ".");
		      }
		      if (proposals && (!corejsVersion || corejsVersion < 3)) {
		        throw new Error("The 'proposals' option is only supported when using 'corejs: 3'");
		      }
		      if (typeof regenerator !== "boolean") {
		        throw new Error("The 'regenerator' option must be undefined, or a boolean.");
		      }
		      var polyfillOpts = (_polyfillOpts = {
		        method: "usage-pure",
		        absoluteImports: absoluteImports,
		        proposals: proposals
		      }, _polyfillOpts[pluginsCompat] = {
		        useBabelRuntime: true,
		        runtimeVersion: runtimeVersion,
		        ext: "",
		        moduleName: moduleName
		      }, _polyfillOpts);
		      return createRegeneratorPlugin(polyfillOpts, regenerator, corejsVersion === 2 ? createCorejs2Plugin(polyfillOpts) : corejsVersion === 3 ? createCorejs3Plugin(polyfillOpts) : null);
		    };
		    return polyfills;
		  }

		  (function (exports) {
		    Object.defineProperty(exports, "createPolyfillPlugins", {
		      get: function get() {
		        return requirePolyfills();
		      }
		    });
		  })(babel7);

		  var transformRuntime = declare(function (api, options, dirname) {
		    api.assertVersion("*");
		    var _options$version = options.version,
		      runtimeVersion = _options$version === void 0 ? "7.0.0-beta.0" : _options$version,
		      _options$absoluteRunt = options.absoluteRuntime,
		      absoluteRuntime = _options$absoluteRunt === void 0 ? false : _options$absoluteRunt,
		      _options$moduleName = options.moduleName,
		      moduleName = _options$moduleName === void 0 ? null : _options$moduleName;
		    if (typeof absoluteRuntime !== "boolean" && typeof absoluteRuntime !== "string") {
		      throw new Error("The 'absoluteRuntime' option must be undefined, a boolean, or a string.");
		    }
		    if (typeof runtimeVersion !== "string") {
		      throw new Error("The 'version' option must be a version string.");
		    }
		    if (moduleName !== null && typeof moduleName !== "string") {
		      throw new Error("The 'moduleName' option must be null or a string.");
		    }
		    {
		      var DUAL_MODE_RUNTIME = "7.13.0";
		      var supportsCJSDefault = hasMinVersion(DUAL_MODE_RUNTIME, runtimeVersion);
		    }
		    if (hasOwnProperty.call(options, "useBuiltIns")) {
		      if (options["useBuiltIns"]) {
		        throw new Error("The 'useBuiltIns' option has been removed. The @babel/runtime " + "module now uses builtins by default.");
		      } else {
		        throw new Error("The 'useBuiltIns' option has been removed. Use the 'corejs'" + "option to polyfill with `core-js` via @babel/runtime.");
		      }
		    }
		    if (hasOwnProperty.call(options, "polyfill")) {
		      if (options["polyfill"] === false) {
		        throw new Error("The 'polyfill' option has been removed. The @babel/runtime " + "module now skips polyfilling by default.");
		      } else {
		        throw new Error("The 'polyfill' option has been removed. Use the 'corejs'" + "option to polyfill with `core-js` via @babel/runtime.");
		      }
		    }
		    {
		      var _options$useESModules = options.useESModules,
		        useESModules = _options$useESModules === void 0 ? false : _options$useESModules;
		      if (typeof useESModules !== "boolean" && useESModules !== "auto") {
		        throw new Error("The 'useESModules' option must be undefined, or a boolean, or 'auto'.");
		      }
		      var esModules = useESModules === "auto" ? api.caller(function (caller) {
		        return !!(caller != null && caller.supportsStaticESM);
		      }) : useESModules;
		    }
		    {
		      var _options$helpers = options.helpers,
		        useRuntimeHelpers = _options$helpers === void 0 ? true : _options$helpers;
		      if (typeof useRuntimeHelpers !== "boolean") {
		        throw new Error("The 'helpers' option must be undefined, or a boolean.");
		      }
		    }
		    var HEADER_HELPERS = new Set(["interopRequireWildcard", "interopRequireDefault"]);
		    return {
		      name: "transform-runtime",
		      inherits: babel7.createPolyfillPlugins(options, runtimeVersion, absoluteRuntime),
		      pre: function pre(file) {
		        if (!useRuntimeHelpers) return;
		        var modulePath;
		        file.set("helperGenerator", function (name) {
		          var _modulePath, _ref;
		          (_modulePath = modulePath) != null ? _modulePath : modulePath = getRuntimePath((_ref = moduleName != null ? moduleName : file.get("runtimeHelpersModuleName")) != null ? _ref : "@babel/runtime", dirname, absoluteRuntime);
		          {
		            if (!(file.availableHelper != null && file.availableHelper(name, runtimeVersion))) {
		              if (name === "regeneratorRuntime") {
		                return arrowFunctionExpression$4([], identifier$j("regeneratorRuntime"));
		              }
		              return;
		            }
		          }
		          var blockHoist = HEADER_HELPERS.has(name) && !isModule(file.path) ? 4 : undefined;
		          var helperPath = modulePath + "/helpers/" + (esModules && file.path.node.sourceType === "module" ? "esm/" + name : name);
		          if (absoluteRuntime) helperPath = resolveFSPath();
		          return addDefaultImport(helperPath, name, blockHoist, true);
		        });
		        var cache = new Map();
		        function addDefaultImport(source, nameHint, blockHoist, isHelper) {
		          if (isHelper === void 0) {
		            isHelper = false;
		          }
		          var cacheKey = isModule(file.path);
		          var key = source + ":" + nameHint + ":" + (cacheKey || "");
		          var cached = cache.get(key);
		          if (cached) {
		            cached = cloneNode$j(cached);
		          } else {
		            cached = addDefault(file.path, source, {
		              importedInterop: isHelper && supportsCJSDefault ? "compiled" : "uncompiled",
		              nameHint: nameHint,
		              blockHoist: blockHoist
		            });
		            cache.set(key, cached);
		          }
		          return cached;
		        }
		      }
		    };
		  });

		  var _transformShorthandProperties = declare(function (api) {
		    api.assertVersion("*");
		    return {
		      name: "transform-shorthand-properties",
		      visitor: {
		        ObjectMethod: function ObjectMethod(path) {
		          var node = path.node;
		          if (node.kind === "method") {
		            var func = functionExpression$2(null, node.params, node.body, node.generator, node.async);
		            func.returnType = node.returnType;
		            var computedKey = toComputedKey$2(node);
		            if (isStringLiteral$5(computedKey, {
		              value: "__proto__"
		            })) {
		              path.replaceWith(objectProperty$1(computedKey, func, true));
		            } else {
		              path.replaceWith(objectProperty$1(node.key, func, node.computed));
		            }
		          }
		        },
		        ObjectProperty: function ObjectProperty(path) {
		          var node = path.node;
		          if (node.shorthand) {
		            var computedKey = toComputedKey$2(node);
		            if (isStringLiteral$5(computedKey, {
		              value: "__proto__"
		            })) {
		              path.replaceWith(objectProperty$1(computedKey, node.value, true));
		            } else {
		              node.shorthand = false;
		            }
		          }
		        }
		      }
		    };
		  });

		  var _transformSpread = declare(function (api, options) {
		    var _api$assumption, _options$allowArrayLi;
		    api.assertVersion("*");
		    var iterableIsArray = (_api$assumption = api.assumption("iterableIsArray")) != null ? _api$assumption : options.loose;
		    var arrayLikeIsIterable = (_options$allowArrayLi = options.allowArrayLike) != null ? _options$allowArrayLi : api.assumption("arrayLikeIsIterable");
		    function getSpreadLiteral(spread, scope) {
		      if (iterableIsArray && !isIdentifier$i(spread.argument, {
		        name: "arguments"
		      })) {
		        return spread.argument;
		      } else {
		        return scope.toArray(spread.argument, true, arrayLikeIsIterable);
		      }
		    }
		    function hasHole(spread) {
		      return spread.elements.some(function (el) {
		        return el === null;
		      });
		    }
		    function hasSpread(nodes) {
		      for (var i = 0; i < nodes.length; i++) {
		        if (isSpreadElement$1(nodes[i])) {
		          return true;
		        }
		      }
		      return false;
		    }
		    function push(_props, nodes) {
		      if (!_props.length) return _props;
		      nodes.push(arrayExpression$1(_props));
		      return [];
		    }
		    function build(props, scope, file) {
		      var nodes = [];
		      var _props = [];
		      for (var _iterator = _createForOfIteratorHelperLoose(props), _step; !(_step = _iterator()).done;) {
		        var prop = _step.value;
		        if (isSpreadElement$1(prop)) {
		          _props = push(_props, nodes);
		          var spreadLiteral = getSpreadLiteral(prop, scope);
		          if (isArrayExpression$2(spreadLiteral) && hasHole(spreadLiteral)) {
		            spreadLiteral = callExpression$d(file.addHelper("arrayWithoutHoles"), [spreadLiteral]);
		          }
		          nodes.push(spreadLiteral);
		        } else {
		          _props.push(prop);
		        }
		      }
		      push(_props, nodes);
		      return nodes;
		    }
		    return {
		      name: "transform-spread",
		      visitor: {
		        ArrayExpression: function ArrayExpression(path) {
		          var node = path.node,
		            scope = path.scope;
		          var elements = node.elements;
		          if (!hasSpread(elements)) return;
		          var nodes = build(elements, scope, this.file);
		          var first = nodes[0];
		          if (nodes.length === 1 && first !== elements[0].argument) {
		            path.replaceWith(first);
		            return;
		          }
		          if (!isArrayExpression$2(first)) {
		            first = arrayExpression$1([]);
		          } else {
		            nodes.shift();
		          }
		          path.replaceWith(callExpression$d(memberExpression$c(first, identifier$j("concat")), nodes));
		        },
		        CallExpression: function CallExpression(path) {
		          var node = path.node,
		            scope = path.scope;
		          var args = node.arguments;
		          if (!hasSpread(args)) return;
		          var calleePath = skipTransparentExprWrappers(path.get("callee"));
		          if (calleePath.isSuper()) {
		            throw path.buildCodeFrameError("It's not possible to compile spread arguments in `super()` without compiling classes.\n" + "Please add '@babel/plugin-transform-classes' to your Babel configuration.");
		          }
		          var contextLiteral = scope.buildUndefinedNode();
		          node.arguments = [];
		          var nodes;
		          if (args.length === 1 && isIdentifier$i(args[0].argument, {
		            name: "arguments"
		          })) {
		            nodes = [args[0].argument];
		          } else {
		            nodes = build(args, scope, this.file);
		          }
		          var first = nodes.shift();
		          if (nodes.length) {
		            node.arguments.push(callExpression$d(memberExpression$c(first, identifier$j("concat")), nodes));
		          } else {
		            node.arguments.push(first);
		          }
		          var callee = calleePath.node;
		          if (isMemberExpression$9(callee)) {
		            var temp = scope.maybeGenerateMemoised(callee.object);
		            if (temp) {
		              callee.object = assignmentExpression$d("=", temp, callee.object);
		              contextLiteral = temp;
		            } else {
		              contextLiteral = cloneNode$j(callee.object);
		            }
		          }
		          node.callee = memberExpression$c(node.callee, identifier$j("apply"));
		          if (isSuper$3(contextLiteral)) {
		            contextLiteral = thisExpression$4();
		          }
		          node.arguments.unshift(cloneNode$j(contextLiteral));
		        },
		        NewExpression: function NewExpression(path) {
		          var node = path.node,
		            scope = path.scope;
		          if (!hasSpread(node.arguments)) return;
		          var nodes = build(node.arguments, scope, this.file);
		          var first = nodes.shift();
		          var args;
		          if (nodes.length) {
		            args = callExpression$d(memberExpression$c(first, identifier$j("concat")), nodes);
		          } else {
		            args = first;
		          }
		          path.replaceWith(callExpression$d(path.hub.addHelper("construct"), [node.callee, args]));
		        }
		      }
		    };
		  });

		  var _transformStickyRegex = declare(function (api) {
		    api.assertVersion("*");
		    return {
		      name: "transform-sticky-regex",
		      visitor: {
		        RegExpLiteral: function RegExpLiteral(path) {
		          var node = path.node;
		          if (!node.flags.includes("y")) return;
		          path.replaceWith(newExpression(identifier$j("RegExp"), [stringLiteral$8(node.pattern), stringLiteral$8(node.flags)]));
		        }
		      }
		    };
		  });

		  var transformStrictMode = declare(function (api) {
		    api.assertVersion("*");
		    return {
		      name: "transform-strict-mode",
		      visitor: {
		        Program: function Program(path) {
		          var node = path.node;
		          for (var _iterator = _createForOfIteratorHelperLoose(node.directives), _step; !(_step = _iterator()).done;) {
		            var directive = _step.value;
		            if (directive.value.value === "use strict") return;
		          }
		          path.unshiftContainer("directives", directive$1(directiveLiteral$1("use strict")));
		        }
		      }
		    };
		  });

		  var _templateObject$9;
		  var _transformTemplateLiterals = declare(function (api, options) {
		    var _api$assumption, _api$assumption2;
		    api.assertVersion("*");
		    var ignoreToPrimitiveHint = (_api$assumption = api.assumption("ignoreToPrimitiveHint")) != null ? _api$assumption : options.loose;
		    var mutableTemplateObject = (_api$assumption2 = api.assumption("mutableTemplateObject")) != null ? _api$assumption2 : options.loose;
		    var helperName = "taggedTemplateLiteral";
		    if (mutableTemplateObject) helperName += "Loose";
		    function buildConcatCallExpressions(items) {
		      var avail = true;
		      return items.reduce(function (left, right) {
		        var canBeInserted = isLiteral$6(right);
		        if (!canBeInserted && avail) {
		          canBeInserted = true;
		          avail = false;
		        }
		        if (canBeInserted && isCallExpression$8(left)) {
		          left.arguments.push(right);
		          return left;
		        }
		        return callExpression$d(memberExpression$c(left, identifier$j("concat")), [right]);
		      });
		    }
		    return {
		      name: "transform-template-literals",
		      visitor: {
		        TaggedTemplateExpression: function TaggedTemplateExpression(path) {
		          var node = path.node;
		          var quasi = node.quasi;
		          var strings = [];
		          var raws = [];
		          var isStringsRawEqual = true;
		          for (var _iterator = _createForOfIteratorHelperLoose(quasi.quasis), _step; !(_step = _iterator()).done;) {
		            var elem = _step.value;
		            var _elem$value = elem.value,
		              raw = _elem$value.raw,
		              cooked = _elem$value.cooked;
		            var value = cooked == null ? path.scope.buildUndefinedNode() : stringLiteral$8(cooked);
		            strings.push(value);
		            raws.push(stringLiteral$8(raw));
		            if (raw !== cooked) {
		              isStringsRawEqual = false;
		            }
		          }
		          var helperArgs = [arrayExpression$1(strings)];
		          if (!isStringsRawEqual) {
		            helperArgs.push(arrayExpression$1(raws));
		          }
		          var tmp = path.scope.generateUidIdentifier("templateObject");
		          path.scope.getProgramParent().push({
		            id: cloneNode$j(tmp)
		          });
		          path.replaceWith(callExpression$d(node.tag, [template$1.expression.ast(_templateObject$9 || (_templateObject$9 = _taggedTemplateLiteralLoose(["\n              ", " || (\n                ", " = ", "(", ")\n              )\n            "])), cloneNode$j(tmp), tmp, this.addHelper(helperName), helperArgs)].concat(_toConsumableArray(quasi.expressions))));
		        },
		        TemplateLiteral: function TemplateLiteral(path) {
		          if (path.parent.type === "TSLiteralType") {
		            return;
		          }
		          var nodes = [];
		          var expressions = path.get("expressions");
		          var index = 0;
		          for (var _iterator2 = _createForOfIteratorHelperLoose(path.node.quasis), _step2; !(_step2 = _iterator2()).done;) {
		            var elem = _step2.value;
		            if (elem.value.cooked) {
		              nodes.push(stringLiteral$8(elem.value.cooked));
		            }
		            if (index < expressions.length) {
		              var expr = expressions[index++];
		              var node = expr.node;
		              if (!isStringLiteral$5(node, {
		                value: ""
		              })) {
		                nodes.push(node);
		              }
		            }
		          }
		          if (!isStringLiteral$5(nodes[0]) && !(ignoreToPrimitiveHint && isStringLiteral$5(nodes[1]))) {
		            nodes.unshift(stringLiteral$8(""));
		          }
		          var root = nodes[0];
		          if (ignoreToPrimitiveHint) {
		            for (var i = 1; i < nodes.length; i++) {
		              root = binaryExpression$5("+", root, nodes[i]);
		            }
		          } else if (nodes.length > 1) {
		            root = buildConcatCallExpressions(nodes);
		          }
		          path.replaceWith(root);
		        }
		      }
		    };
		  });

		  var _transformTypeofSymbol = declare(function (api) {
		    api.assertVersion("*");
		    return {
		      name: "transform-typeof-symbol",
		      visitor: {
		        Scope: function Scope(_ref) {
		          var scope = _ref.scope;
		          if (!scope.getBinding("Symbol")) {
		            return;
		          }
		          scope.rename("Symbol");
		        },
		        UnaryExpression: function UnaryExpression(path) {
		          var node = path.node,
		            parent = path.parent;
		          if (node.operator !== "typeof") return;
		          if (path.parentPath.isBinaryExpression() && EQUALITY_BINARY_OPERATORS.indexOf(parent.operator) >= 0) {
		            var opposite = path.getOpposite();
		            if (opposite.isStringLiteral() && opposite.node.value !== "symbol" && opposite.node.value !== "object") {
		              return;
		            }
		          }
		          var isUnderHelper = path.findParent(function (path) {
		            if (path.isFunction()) {
		              var _path$get;
		              return ((_path$get = path.get("body.directives.0")) == null ? void 0 : _path$get.node.value.value) === "@babel/helpers - typeof";
		            }
		          });
		          if (isUnderHelper) return;
		          var helper = this.addHelper("typeof");
		          isUnderHelper = path.findParent(function (path) {
		            return path.isVariableDeclarator() && path.node.id === helper || path.isFunctionDeclaration() && path.node.id && path.node.id.name === helper.name;
		          });
		          if (isUnderHelper) {
		            return;
		          }
		          var call = callExpression$d(helper, [node.argument]);
		          var arg = path.get("argument");
		          if (arg.isIdentifier() && !path.scope.hasBinding(arg.node.name, true)) {
		            var unary = unaryExpression$6("typeof", cloneNode$j(node.argument));
		            path.replaceWith(conditionalExpression$5(binaryExpression$5("===", unary, stringLiteral$8("undefined")), stringLiteral$8("undefined"), call));
		          } else {
		            path.replaceWith(call);
		          }
		        }
		      }
		    };
		  });

		  var ENUMS = new WeakMap();
		  var buildEnumWrapper = template$1.expression("\n    (function (ID) {\n      ASSIGNMENTS;\n      return ID;\n    })(INIT)\n  ");
		  function transpileEnum(path, t) {
		    var node = path.node,
		      parentPath = path.parentPath;
		    if (node.declare) {
		      path.remove();
		      return;
		    }
		    var name = node.id.name;
		    var _enumFill = enumFill(path, t, node.id),
		      fill = _enumFill.fill,
		      data = _enumFill.data,
		      isPure = _enumFill.isPure;
		    switch (parentPath.type) {
		      case "BlockStatement":
		      case "ExportNamedDeclaration":
		      case "Program":
		        {
		          var isGlobal = t.isProgram(path.parent);
		          var isSeen = seen(parentPath);
		          var init = t.objectExpression([]);
		          if (isSeen || isGlobal) {
		            init = t.logicalExpression("||", t.cloneNode(fill.ID), init);
		          }
		          var enumIIFE = buildEnumWrapper(Object.assign({}, fill, {
		            INIT: init
		          }));
		          if (isPure) annotateAsPure(enumIIFE);
		          if (isSeen) {
		            var toReplace = parentPath.isExportDeclaration() ? parentPath : path;
		            toReplace.replaceWith(t.expressionStatement(t.assignmentExpression("=", t.cloneNode(node.id), enumIIFE)));
		          } else {
		            path.scope.registerDeclaration(path.replaceWith(t.variableDeclaration(isGlobal ? "var" : "let", [t.variableDeclarator(node.id, enumIIFE)]))[0]);
		          }
		          ENUMS.set(path.scope.getBindingIdentifier(name), data);
		          break;
		        }
		      default:
		        throw new Error("Unexpected enum parent '" + path.parent.type);
		    }
		    function seen(parentPath) {
		      if (parentPath.isExportDeclaration()) {
		        return seen(parentPath.parentPath);
		      }
		      if (parentPath.getData(name)) {
		        return true;
		      } else {
		        parentPath.setData(name, true);
		        return false;
		      }
		    }
		  }
		  var buildStringAssignment = template$1("\n  ENUM[\"NAME\"] = VALUE;\n");
		  var buildNumericAssignment = template$1("\n  ENUM[ENUM[\"NAME\"] = VALUE] = \"NAME\";\n");
		  var buildEnumMember = function buildEnumMember(isString, options) {
		    return (isString ? buildStringAssignment : buildNumericAssignment)(options);
		  };
		  function enumFill(path, t, id) {
		    var _translateEnumValues = translateEnumValues(path, t),
		      x = _translateEnumValues.enumValues,
		      data = _translateEnumValues.data,
		      isPure = _translateEnumValues.isPure;
		    var assignments = x.map(function (_ref) {
		      var _ref2 = _slicedToArray(_ref, 2),
		        memberName = _ref2[0],
		        memberValue = _ref2[1];
		      return buildEnumMember(t.isStringLiteral(memberValue), {
		        ENUM: t.cloneNode(id),
		        NAME: memberName,
		        VALUE: memberValue
		      });
		    });
		    return {
		      fill: {
		        ID: t.cloneNode(id),
		        ASSIGNMENTS: assignments
		      },
		      data: data,
		      isPure: isPure
		    };
		  }
		  function ReferencedIdentifier(expr, state) {
		    var seen = state.seen,
		      path = state.path,
		      t = state.t;
		    var name = expr.node.name;
		    if (seen.has(name) && !expr.scope.hasOwnBinding(name)) {
		      expr.replaceWith(t.memberExpression(t.cloneNode(path.node.id), t.cloneNode(expr.node)));
		      expr.skip();
		    }
		  }
		  var enumSelfReferenceVisitor = {
		    ReferencedIdentifier: ReferencedIdentifier
		  };
		  function translateEnumValues(path, t) {
		    var _ENUMS$get;
		    var bindingIdentifier = path.scope.getBindingIdentifier(path.node.id.name);
		    var seen = (_ENUMS$get = ENUMS.get(bindingIdentifier)) != null ? _ENUMS$get : new Map();
		    var constValue = -1;
		    var lastName;
		    var isPure = true;
		    var enumValues = path.get("members").map(function (memberPath) {
		      var member = memberPath.node;
		      var name = t.isIdentifier(member.id) ? member.id.name : member.id.value;
		      var initializerPath = memberPath.get("initializer");
		      var initializer = member.initializer;
		      var value;
		      if (initializer) {
		        constValue = computeConstantValue(initializerPath, seen);
		        if (constValue !== undefined) {
		          seen.set(name, constValue);
		          assert(typeof constValue === "number" || typeof constValue === "string");
		          if (constValue === Infinity || Number.isNaN(constValue)) {
		            value = t.identifier(String(constValue));
		          } else if (constValue === -Infinity) {
		            value = t.unaryExpression("-", t.identifier("Infinity"));
		          } else {
		            value = t.valueToNode(constValue);
		          }
		        } else {
		          isPure && (isPure = initializerPath.isPure());
		          if (initializerPath.isReferencedIdentifier()) {
		            ReferencedIdentifier(initializerPath, {
		              t: t,
		              seen: seen,
		              path: path
		            });
		          } else {
		            initializerPath.traverse(enumSelfReferenceVisitor, {
		              t: t,
		              seen: seen,
		              path: path
		            });
		          }
		          value = initializerPath.node;
		          seen.set(name, undefined);
		        }
		      } else if (typeof constValue === "number") {
		        constValue += 1;
		        value = t.numericLiteral(constValue);
		        seen.set(name, constValue);
		      } else if (typeof constValue === "string") {
		        throw path.buildCodeFrameError("Enum member must have initializer.");
		      } else {
		        var lastRef = t.memberExpression(t.cloneNode(path.node.id), t.stringLiteral(lastName), true);
		        value = t.binaryExpression("+", t.numericLiteral(1), lastRef);
		        seen.set(name, undefined);
		      }
		      lastName = name;
		      return [name, value];
		    });
		    return {
		      isPure: isPure,
		      data: seen,
		      enumValues: enumValues
		    };
		  }
		  function computeConstantValue(path, prevMembers, seen) {
		    if (seen === void 0) {
		      seen = new Set();
		    }
		    return evaluate(path);
		    function evaluate(path) {
		      var expr = path.node;
		      switch (expr.type) {
		        case "MemberExpression":
		          return evaluateRef(path, prevMembers, seen);
		        case "StringLiteral":
		          return expr.value;
		        case "UnaryExpression":
		          return evalUnaryExpression(path);
		        case "BinaryExpression":
		          return evalBinaryExpression(path);
		        case "NumericLiteral":
		          return expr.value;
		        case "ParenthesizedExpression":
		          return evaluate(path.get("expression"));
		        case "Identifier":
		          return evaluateRef(path, prevMembers, seen);
		        case "TemplateLiteral":
		          {
		            if (expr.quasis.length === 1) {
		              return expr.quasis[0].value.cooked;
		            }
		            var paths = path.get("expressions");
		            var quasis = expr.quasis;
		            var str = "";
		            for (var i = 0; i < quasis.length; i++) {
		              str += quasis[i].value.cooked;
		              if (i + 1 < quasis.length) {
		                var _value = evaluateRef(paths[i], prevMembers, seen);
		                if (_value === undefined) return undefined;
		                str += _value;
		              }
		            }
		            return str;
		          }
		        default:
		          return undefined;
		      }
		    }
		    function evaluateRef(path, prevMembers, seen) {
		      if (path.isMemberExpression()) {
		        var expr = path.node;
		        var obj = expr.object;
		        var prop = expr.property;
		        if (!isIdentifier$i(obj) || (expr.computed ? !isStringLiteral$5(prop) : !isIdentifier$i(prop))) {
		          return;
		        }
		        var bindingIdentifier = path.scope.getBindingIdentifier(obj.name);
		        var data = ENUMS.get(bindingIdentifier);
		        if (!data) return;
		        return data.get(prop.computed ? prop.value : prop.name);
		      } else if (path.isIdentifier()) {
		        var _name = path.node.name;
		        if (["Infinity", "NaN"].includes(_name)) {
		          return Number(_name);
		        }
		        var _value2 = prevMembers == null ? void 0 : prevMembers.get(_name);
		        if (_value2 !== undefined) {
		          return _value2;
		        }
		        if (seen.has(path.node)) return;
		        seen.add(path.node);
		        _value2 = computeConstantValue(path.resolve(), prevMembers, seen);
		        prevMembers == null || prevMembers.set(_name, _value2);
		        return _value2;
		      }
		    }
		    function evalUnaryExpression(path) {
		      var value = evaluate(path.get("argument"));
		      if (value === undefined) {
		        return undefined;
		      }
		      switch (path.node.operator) {
		        case "+":
		          return value;
		        case "-":
		          return -value;
		        case "~":
		          return ~value;
		        default:
		          return undefined;
		      }
		    }
		    function evalBinaryExpression(path) {
		      var left = evaluate(path.get("left"));
		      if (left === undefined) {
		        return undefined;
		      }
		      var right = evaluate(path.get("right"));
		      if (right === undefined) {
		        return undefined;
		      }
		      switch (path.node.operator) {
		        case "|":
		          return left | right;
		        case "&":
		          return left & right;
		        case ">>":
		          return left >> right;
		        case ">>>":
		          return left >>> right;
		        case "<<":
		          return left << right;
		        case "^":
		          return left ^ right;
		        case "*":
		          return left * right;
		        case "/":
		          return left / right;
		        case "+":
		          return left + right;
		        case "-":
		          return left - right;
		        case "%":
		          return left % right;
		        case "**":
		          return Math.pow(left, right);
		        default:
		          return undefined;
		      }
		    }
		  }

		  function transpileConstEnum(path, t) {
		    var name = path.node.id.name;
		    var parentIsExport = path.parentPath.isExportNamedDeclaration();
		    var isExported = parentIsExport;
		    if (!isExported && t.isProgram(path.parent)) {
		      isExported = path.parent.body.some(function (stmt) {
		        return t.isExportNamedDeclaration(stmt) && stmt.exportKind !== "type" && !stmt.source && stmt.specifiers.some(function (spec) {
		          return t.isExportSpecifier(spec) && spec.exportKind !== "type" && spec.local.name === name;
		        });
		      });
		    }
		    var _translateEnumValues = translateEnumValues(path, t),
		      entries = _translateEnumValues.enumValues;
		    if (isExported) {
		      var obj = t.objectExpression(entries.map(function (_ref) {
		        var _ref2 = _slicedToArray(_ref, 2),
		          name = _ref2[0],
		          value = _ref2[1];
		        return t.objectProperty(t.isValidIdentifier(name) ? t.identifier(name) : t.stringLiteral(name), value);
		      }));
		      if (path.scope.hasOwnBinding(name)) {
		        (parentIsExport ? path.parentPath : path).replaceWith(t.expressionStatement(t.callExpression(t.memberExpression(t.identifier("Object"), t.identifier("assign")), [path.node.id, obj])));
		      } else {
		        path.replaceWith(t.variableDeclaration("var", [t.variableDeclarator(path.node.id, obj)]));
		        path.scope.registerDeclaration(path);
		      }
		      return;
		    }
		    var entriesMap = new Map(entries);
		    path.scope.path.traverse({
		      Scope: function Scope(path) {
		        if (path.scope.hasOwnBinding(name)) path.skip();
		      },
		      MemberExpression: function MemberExpression(path) {
		        if (!t.isIdentifier(path.node.object, {
		          name: name
		        })) return;
		        var key;
		        if (path.node.computed) {
		          if (t.isStringLiteral(path.node.property)) {
		            key = path.node.property.value;
		          } else {
		            return;
		          }
		        } else if (t.isIdentifier(path.node.property)) {
		          key = path.node.property.name;
		        } else {
		          return;
		        }
		        if (!entriesMap.has(key)) return;
		        path.replaceWith(t.cloneNode(entriesMap.get(key)));
		      }
		    });
		    path.remove();
		  }

		  var GLOBAL_TYPES = new WeakMap();
		  function isGlobalType(_ref, name) {
		    var scope = _ref.scope;
		    if (scope.hasBinding(name)) return false;
		    if (GLOBAL_TYPES.get(scope).has(name)) return true;
		    console.warn("The exported identifier \"" + name + "\" is not declared in Babel's scope tracker\n" + "as a JavaScript value binding, and \"@babel/plugin-transform-typescript\"\n" + "never encountered it as a TypeScript type declaration.\n" + "It will be treated as a JavaScript value.\n\n" + "This problem is likely caused by another plugin injecting\n" + ("\"" + name + "\" without registering it in the scope tracker. If you are the author\n") + " of that plugin, please use \"scope.registerDeclaration(declarationPath)\".");
		    return false;
		  }
		  function registerGlobalType(programScope, name) {
		    GLOBAL_TYPES.get(programScope).add(name);
		  }

		  var _templateObject$8, _templateObject2$8;
		  function transpileNamespace(path, allowNamespaces) {
		    if (path.node.declare || path.node.id.type === "StringLiteral") {
		      path.remove();
		      return;
		    }
		    if (!allowNamespaces) {
		      throw path.get("id").buildCodeFrameError("Namespace not marked type-only declare." + " Non-declarative namespaces are only supported experimentally in Babel." + " To enable and review caveats see:" + " https://babeljs.io/docs/en/babel-plugin-transform-typescript");
		    }
		    var name = path.node.id.name;
		    var value = handleNested(path, cloneNode$j(path.node, true));
		    if (value === null) {
		      var program = path.findParent(function (p) {
		        return p.isProgram();
		      });
		      registerGlobalType(program.scope, name);
		      path.remove();
		    } else if (path.scope.hasOwnBinding(name)) {
		      path.replaceWith(value);
		    } else {
		      path.scope.registerDeclaration(path.replaceWithMultiple([getDeclaration(name), value])[0]);
		    }
		  }
		  function getDeclaration(name) {
		    return variableDeclaration$8("let", [variableDeclarator$8(identifier$j(name))]);
		  }
		  function getMemberExpression(name, itemName) {
		    return memberExpression$c(identifier$j(name), identifier$j(itemName));
		  }
		  function handleVariableDeclaration(node, name, hub) {
		    if (node.kind !== "const") {
		      throw hub.file.buildCodeFrameError(node, "Namespaces exporting non-const are not supported by Babel." + " Change to const or see:" + " https://babeljs.io/docs/en/babel-plugin-transform-typescript");
		    }
		    var declarations = node.declarations;
		    if (declarations.every(function (declarator) {
		      return isIdentifier$i(declarator.id);
		    })) {
		      for (var _iterator = _createForOfIteratorHelperLoose(declarations), _step; !(_step = _iterator()).done;) {
		        var declarator = _step.value;
		        declarator.init = assignmentExpression$d("=", getMemberExpression(name, declarator.id.name), declarator.init);
		      }
		      return [node];
		    }
		    var bindingIdentifiers = getBindingIdentifiers$4(node);
		    var assignments = [];
		    for (var idName in bindingIdentifiers) {
		      assignments.push(assignmentExpression$d("=", getMemberExpression(name, idName), cloneNode$j(bindingIdentifiers[idName])));
		    }
		    return [node, expressionStatement$a(sequenceExpression$8(assignments))];
		  }
		  function buildNestedAmbientModuleError(path, node) {
		    return path.hub.buildError(node, "Ambient modules cannot be nested in other modules or namespaces.", Error);
		  }
		  function handleNested(path, node, parentExport) {
		    var names = new Set();
		    var realName = node.id;
		    assertIdentifier(realName);
		    var name = path.scope.generateUid(realName.name);
		    var namespaceTopLevel = isTSModuleBlock(node.body) ? node.body.body : [exportNamedDeclaration$2(node.body)];
		    var isEmpty = true;
		    for (var i = 0; i < namespaceTopLevel.length; i++) {
		      var subNode = namespaceTopLevel[i];
		      switch (subNode.type) {
		        case "TSModuleDeclaration":
		          {
		            if (!isIdentifier$i(subNode.id)) {
		              throw buildNestedAmbientModuleError(path, subNode);
		            }
		            var transformed = handleNested(path, subNode);
		            if (transformed !== null) {
		              isEmpty = false;
		              var moduleName = subNode.id.name;
		              if (names.has(moduleName)) {
		                namespaceTopLevel[i] = transformed;
		              } else {
		                names.add(moduleName);
		                namespaceTopLevel.splice(i++, 1, getDeclaration(moduleName), transformed);
		              }
		            }
		            continue;
		          }
		        case "TSEnumDeclaration":
		        case "FunctionDeclaration":
		        case "ClassDeclaration":
		          isEmpty = false;
		          names.add(subNode.id.name);
		          continue;
		        case "VariableDeclaration":
		          {
		            isEmpty = false;
		            for (var _name in getBindingIdentifiers$4(subNode)) {
		              names.add(_name);
		            }
		            continue;
		          }
		        default:
		          isEmpty && (isEmpty = isTypeScript(subNode));
		          continue;
		        case "ExportNamedDeclaration":
		      }
		      if ("declare" in subNode.declaration && subNode.declaration.declare) {
		        continue;
		      }
		      switch (subNode.declaration.type) {
		        case "TSEnumDeclaration":
		        case "FunctionDeclaration":
		        case "ClassDeclaration":
		          {
		            isEmpty = false;
		            var itemName = subNode.declaration.id.name;
		            names.add(itemName);
		            namespaceTopLevel.splice(i++, 1, subNode.declaration, expressionStatement$a(assignmentExpression$d("=", getMemberExpression(name, itemName), identifier$j(itemName))));
		            break;
		          }
		        case "VariableDeclaration":
		          {
		            isEmpty = false;
		            var nodes = handleVariableDeclaration(subNode.declaration, name, path.hub);
		            namespaceTopLevel.splice.apply(namespaceTopLevel, [i, nodes.length].concat(_toConsumableArray(nodes)));
		            i += nodes.length - 1;
		            break;
		          }
		        case "TSModuleDeclaration":
		          {
		            if (!isIdentifier$i(subNode.declaration.id)) {
		              throw buildNestedAmbientModuleError(path, subNode.declaration);
		            }
		            var _transformed = handleNested(path, subNode.declaration, identifier$j(name));
		            if (_transformed !== null) {
		              isEmpty = false;
		              var _moduleName = subNode.declaration.id.name;
		              if (names.has(_moduleName)) {
		                namespaceTopLevel[i] = _transformed;
		              } else {
		                names.add(_moduleName);
		                namespaceTopLevel.splice(i++, 1, getDeclaration(_moduleName), _transformed);
		              }
		            } else {
		              namespaceTopLevel.splice(i, 1);
		              i--;
		            }
		          }
		      }
		    }
		    if (isEmpty) return null;
		    var fallthroughValue = objectExpression$3([]);
		    if (parentExport) {
		      var memberExpr = memberExpression$c(parentExport, realName);
		      fallthroughValue = template$1.expression.ast(_templateObject$8 || (_templateObject$8 = _taggedTemplateLiteralLoose(["\n      ", " ||\n        (", " = ", ")\n    "])), cloneNode$j(memberExpr), cloneNode$j(memberExpr), fallthroughValue);
		    }
		    return template$1.statement.ast(_templateObject2$8 || (_templateObject2$8 = _taggedTemplateLiteralLoose(["\n    (function (", ") {\n      ", "\n    })(", " || (", " = ", "));\n  "])), identifier$j(name), namespaceTopLevel, realName, cloneNode$j(realName), fallthroughValue);
		  }

		  var _templateObject$7, _templateObject2$7;
		  function isInType(path) {
		    switch (path.parent.type) {
		      case "TSTypeReference":
		      case "TSExpressionWithTypeArguments":
		      case "TSTypeQuery":
		        return true;
		      case "TSQualifiedName":
		        return path.parentPath.findParent(function (path) {
		          return path.type !== "TSQualifiedName";
		        }).type !== "TSImportEqualsDeclaration";
		      case "ExportSpecifier":
		        return path.parent.exportKind === "type" || path.parentPath.parent.exportKind === "type";
		      default:
		        return false;
		    }
		  }
		  var NEEDS_EXPLICIT_ESM = new WeakMap();
		  var PARSED_PARAMS = new WeakSet();
		  function safeRemove(path) {
		    var ids = path.getBindingIdentifiers();
		    for (var _i = 0, _Object$keys = Object.keys(ids); _i < _Object$keys.length; _i++) {
		      var name = _Object$keys[_i];
		      var binding = path.scope.getBinding(name);
		      if (binding && binding.identifier === ids[name]) {
		        binding.scope.removeBinding(name);
		      }
		    }
		    path.opts.noScope = true;
		    path.remove();
		    path.opts.noScope = false;
		  }
		  function assertCjsTransformEnabled(path, pass, wrong, suggestion, extra) {
		    if (extra === void 0) {
		      extra = "";
		    }
		    if (pass.file.get("@babel/plugin-transform-modules-*") !== "commonjs") {
		      throw path.buildCodeFrameError("`" + wrong + "` is only supported when compiling modules to CommonJS.\n" + ("Please consider using `" + suggestion + "`" + extra + ", or add ") + "@babel/plugin-transform-modules-commonjs to your Babel config.");
		    }
		  }
		  var transformTypeScript = declare(function (api, opts) {
		    var _visitor;
		    var t = api.types,
		      template = api.template;
		    api.assertVersion("*");
		    var JSX_PRAGMA_REGEX = /\*?\s*@jsx((?:Frag)?)\s+([^\s]+)/;
		    var _opts$allowNamespaces = opts.allowNamespaces,
		      allowNamespaces = _opts$allowNamespaces === void 0 ? true : _opts$allowNamespaces,
		      _opts$jsxPragma = opts.jsxPragma,
		      jsxPragma = _opts$jsxPragma === void 0 ? "React.createElement" : _opts$jsxPragma,
		      _opts$jsxPragmaFrag = opts.jsxPragmaFrag,
		      jsxPragmaFrag = _opts$jsxPragmaFrag === void 0 ? "React.Fragment" : _opts$jsxPragmaFrag,
		      _opts$onlyRemoveTypeI = opts.onlyRemoveTypeImports,
		      onlyRemoveTypeImports = _opts$onlyRemoveTypeI === void 0 ? false : _opts$onlyRemoveTypeI,
		      _opts$optimizeConstEn = opts.optimizeConstEnums,
		      optimizeConstEnums = _opts$optimizeConstEn === void 0 ? false : _opts$optimizeConstEn;
		    {
		      var _opts$allowDeclareFie = opts.allowDeclareFields,
		        allowDeclareFields = _opts$allowDeclareFie === void 0 ? false : _opts$allowDeclareFie;
		    }
		    var classMemberVisitors = {
		      field: function field(path) {
		        var node = path.node;
		        {
		          if (!allowDeclareFields && node.declare) {
		            throw path.buildCodeFrameError("The 'declare' modifier is only allowed when the 'allowDeclareFields' option of " + "@babel/plugin-transform-typescript or @babel/preset-typescript is enabled.");
		          }
		        }
		        if (node.declare) {
		          if (node.value) {
		            throw path.buildCodeFrameError("Fields with the 'declare' modifier cannot be initialized here, but only in the constructor");
		          }
		          if (!node.decorators) {
		            path.remove();
		          }
		        } else if (node.definite) {
		          if (node.value) {
		            throw path.buildCodeFrameError("Definitely assigned fields cannot be initialized here, but only in the constructor");
		          }
		          {
		            if (!allowDeclareFields && !node.decorators && !t.isClassPrivateProperty(node)) {
		              path.remove();
		            }
		          }
		        } else if (node["abstract"]) {
		          path.remove();
		        } else {
		          if (!allowDeclareFields && !node.value && !node.decorators && !t.isClassPrivateProperty(node)) {
		            path.remove();
		          }
		        }
		        if (node.accessibility) node.accessibility = null;
		        if (node["abstract"]) node["abstract"] = null;
		        if (node.readonly) node.readonly = null;
		        if (node.optional) node.optional = null;
		        if (node.typeAnnotation) node.typeAnnotation = null;
		        if (node.definite) node.definite = null;
		        if (node.declare) node.declare = null;
		        if (node.override) node.override = null;
		      },
		      method: function method(_ref) {
		        var node = _ref.node;
		        if (node.accessibility) node.accessibility = null;
		        if (node["abstract"]) node["abstract"] = null;
		        if (node.optional) node.optional = null;
		        if (node.override) node.override = null;
		      },
		      constructor: function constructor(path, classPath) {
		        if (path.node.accessibility) path.node.accessibility = null;
		        var assigns = [];
		        var scope = path.scope;
		        for (var _iterator = _createForOfIteratorHelperLoose(path.get("params")), _step; !(_step = _iterator()).done;) {
		          var paramPath = _step.value;
		          var param = paramPath.node;
		          if (param.type === "TSParameterProperty") {
		            var parameter = param.parameter;
		            if (PARSED_PARAMS.has(parameter)) continue;
		            PARSED_PARAMS.add(parameter);
		            var id = void 0;
		            if (t.isIdentifier(parameter)) {
		              id = parameter;
		            } else if (t.isAssignmentPattern(parameter) && t.isIdentifier(parameter.left)) {
		              id = parameter.left;
		            } else {
		              throw paramPath.buildCodeFrameError("Parameter properties can not be destructuring patterns.");
		            }
		            assigns.push(template.statement.ast(_templateObject$7 || (_templateObject$7 = _taggedTemplateLiteralLoose(["\n              this.", " = ", "\n            "])), t.cloneNode(id), t.cloneNode(id)));
		            paramPath.replaceWith(paramPath.get("parameter"));
		            scope.registerBinding("param", paramPath);
		          }
		        }
		        injectInitialization(classPath, path, assigns);
		      }
		    };
		    return {
		      name: "transform-typescript",
		      inherits: syntaxTypescript,
		      visitor: (_visitor = {
		        Pattern: visitPattern,
		        Identifier: visitPattern,
		        RestElement: visitPattern,
		        Program: {
		          enter: function enter(path, state) {
		            var file = state.file;
		            var fileJsxPragma = null;
		            var fileJsxPragmaFrag = null;
		            var programScope = path.scope;
		            if (!GLOBAL_TYPES.has(programScope)) {
		              GLOBAL_TYPES.set(programScope, new Set());
		            }
		            if (file.ast.comments) {
		              for (var _iterator2 = _createForOfIteratorHelperLoose(file.ast.comments), _step2; !(_step2 = _iterator2()).done;) {
		                var comment = _step2.value;
		                var jsxMatches = JSX_PRAGMA_REGEX.exec(comment.value);
		                if (jsxMatches) {
		                  if (jsxMatches[1]) {
		                    fileJsxPragmaFrag = jsxMatches[2];
		                  } else {
		                    fileJsxPragma = jsxMatches[2];
		                  }
		                }
		              }
		            }
		            var pragmaImportName = fileJsxPragma || jsxPragma;
		            if (pragmaImportName) {
		              var _pragmaImportName$spl = pragmaImportName.split(".");
		              var _pragmaImportName$spl2 = _slicedToArray(_pragmaImportName$spl, 1);
		              pragmaImportName = _pragmaImportName$spl2[0];
		            }
		            var pragmaFragImportName = fileJsxPragmaFrag || jsxPragmaFrag;
		            if (pragmaFragImportName) {
		              var _pragmaFragImportName = pragmaFragImportName.split(".");
		              var _pragmaFragImportName2 = _slicedToArray(_pragmaFragImportName, 1);
		              pragmaFragImportName = _pragmaFragImportName2[0];
		            }
		            var _loop = function _loop() {
		                var stmt = _step3.value;
		                if (stmt.isImportDeclaration()) {
		                  if (!NEEDS_EXPLICIT_ESM.has(state.file.ast.program)) {
		                    NEEDS_EXPLICIT_ESM.set(state.file.ast.program, true);
		                  }
		                  if (stmt.node.importKind === "type") {
		                    for (var _iterator4 = _createForOfIteratorHelperLoose(stmt.node.specifiers), _step4; !(_step4 = _iterator4()).done;) {
		                      var specifier = _step4.value;
		                      registerGlobalType(programScope, specifier.local.name);
		                    }
		                    stmt.remove();
		                    return 0;
		                  }
		                  var importsToRemove = new Set();
		                  var specifiersLength = stmt.node.specifiers.length;
		                  var isAllSpecifiersElided = function isAllSpecifiersElided() {
		                    return specifiersLength > 0 && specifiersLength === importsToRemove.size;
		                  };
		                  for (var _iterator5 = _createForOfIteratorHelperLoose(stmt.node.specifiers), _step5; !(_step5 = _iterator5()).done;) {
		                    var _specifier2 = _step5.value;
		                    if (_specifier2.type === "ImportSpecifier" && _specifier2.importKind === "type") {
		                      registerGlobalType(programScope, _specifier2.local.name);
		                      var _binding = stmt.scope.getBinding(_specifier2.local.name);
		                      if (_binding) {
		                        importsToRemove.add(_binding.path);
		                      }
		                    }
		                  }
		                  if (onlyRemoveTypeImports) {
		                    NEEDS_EXPLICIT_ESM.set(path.node, false);
		                  } else {
		                    if (stmt.node.specifiers.length === 0) {
		                      NEEDS_EXPLICIT_ESM.set(path.node, false);
		                      return 0;
		                    }
		                    for (var _iterator6 = _createForOfIteratorHelperLoose(stmt.node.specifiers), _step6; !(_step6 = _iterator6()).done;) {
		                      var _specifier = _step6.value;
		                      var binding = stmt.scope.getBinding(_specifier.local.name);
		                      if (binding && !importsToRemove.has(binding.path)) {
		                        if (isImportTypeOnly({
		                          binding: binding,
		                          programPath: path,
		                          pragmaImportName: pragmaImportName,
		                          pragmaFragImportName: pragmaFragImportName
		                        })) {
		                          importsToRemove.add(binding.path);
		                        } else {
		                          NEEDS_EXPLICIT_ESM.set(path.node, false);
		                        }
		                      }
		                    }
		                  }
		                  if (isAllSpecifiersElided() && !onlyRemoveTypeImports) {
		                    stmt.remove();
		                  } else {
		                    for (var _iterator7 = _createForOfIteratorHelperLoose(importsToRemove), _step7; !(_step7 = _iterator7()).done;) {
		                      var importPath = _step7.value;
		                      importPath.remove();
		                    }
		                  }
		                  return 0;
		                }
		                if (stmt.isExportDeclaration()) {
		                  stmt = stmt.get("declaration");
		                }
		                if (stmt.isVariableDeclaration({
		                  declare: true
		                })) {
		                  for (var _i2 = 0, _Object$keys2 = Object.keys(stmt.getBindingIdentifiers()); _i2 < _Object$keys2.length; _i2++) {
		                    var name = _Object$keys2[_i2];
		                    registerGlobalType(programScope, name);
		                  }
		                } else if (stmt.isTSTypeAliasDeclaration() || stmt.isTSDeclareFunction() && stmt.get("id").isIdentifier() || stmt.isTSInterfaceDeclaration() || stmt.isClassDeclaration({
		                  declare: true
		                }) || stmt.isTSEnumDeclaration({
		                  declare: true
		                }) || stmt.isTSModuleDeclaration({
		                  declare: true
		                }) && stmt.get("id").isIdentifier()) {
		                  registerGlobalType(programScope, stmt.node.id.name);
		                }
		              },
		              _ret;
		            for (var _iterator3 = _createForOfIteratorHelperLoose(path.get("body")), _step3; !(_step3 = _iterator3()).done;) {
		              _ret = _loop();
		              if (_ret === 0) continue;
		            }
		          },
		          exit: function exit(path) {
		            if (path.node.sourceType === "module" && NEEDS_EXPLICIT_ESM.get(path.node)) {
		              path.pushContainer("body", t.exportNamedDeclaration());
		            }
		          }
		        },
		        ExportNamedDeclaration: function ExportNamedDeclaration(path, state) {
		          if (!NEEDS_EXPLICIT_ESM.has(state.file.ast.program)) {
		            NEEDS_EXPLICIT_ESM.set(state.file.ast.program, true);
		          }
		          if (path.node.exportKind === "type") {
		            path.remove();
		            return;
		          }
		          if (path.node.source && path.node.specifiers.length > 0 && path.node.specifiers.every(function (specifier) {
		            return specifier.type === "ExportSpecifier" && specifier.exportKind === "type";
		          })) {
		            path.remove();
		            return;
		          }
		          if (!path.node.source && path.node.specifiers.length > 0 && path.node.specifiers.every(function (specifier) {
		            return t.isExportSpecifier(specifier) && isGlobalType(path, specifier.local.name);
		          })) {
		            path.remove();
		            return;
		          }
		          if (t.isTSModuleDeclaration(path.node.declaration)) {
		            var namespace = path.node.declaration;
		            var id = namespace.id;
		            if (t.isIdentifier(id)) {
		              if (path.scope.hasOwnBinding(id.name)) {
		                path.replaceWith(namespace);
		              } else {
		                var _path$replaceWithMult = path.replaceWithMultiple([t.exportNamedDeclaration(t.variableDeclaration("let", [t.variableDeclarator(t.cloneNode(id))])), namespace]),
		                  _path$replaceWithMult2 = _slicedToArray(_path$replaceWithMult, 1),
		                  newExport = _path$replaceWithMult2[0];
		                path.scope.registerDeclaration(newExport);
		              }
		            }
		          }
		          NEEDS_EXPLICIT_ESM.set(state.file.ast.program, false);
		        },
		        ExportAllDeclaration: function ExportAllDeclaration(path) {
		          if (path.node.exportKind === "type") path.remove();
		        },
		        ExportSpecifier: function ExportSpecifier(path) {
		          var parent = path.parent;
		          if (!parent.source && isGlobalType(path, path.node.local.name) || path.node.exportKind === "type") {
		            path.remove();
		          }
		        },
		        ExportDefaultDeclaration: function ExportDefaultDeclaration(path, state) {
		          if (!NEEDS_EXPLICIT_ESM.has(state.file.ast.program)) {
		            NEEDS_EXPLICIT_ESM.set(state.file.ast.program, true);
		          }
		          if (t.isIdentifier(path.node.declaration) && isGlobalType(path, path.node.declaration.name)) {
		            path.remove();
		            return;
		          }
		          NEEDS_EXPLICIT_ESM.set(state.file.ast.program, false);
		        },
		        TSDeclareFunction: function TSDeclareFunction(path) {
		          safeRemove(path);
		        },
		        TSDeclareMethod: function TSDeclareMethod(path) {
		          safeRemove(path);
		        },
		        VariableDeclaration: function VariableDeclaration(path) {
		          if (path.node.declare) {
		            safeRemove(path);
		          }
		        },
		        VariableDeclarator: function VariableDeclarator(_ref2) {
		          var node = _ref2.node;
		          if (node.definite) node.definite = null;
		        },
		        TSIndexSignature: function TSIndexSignature(path) {
		          path.remove();
		        },
		        ClassDeclaration: function ClassDeclaration(path) {
		          var node = path.node;
		          if (node.declare) {
		            safeRemove(path);
		          }
		        },
		        Class: function Class(path) {
		          var node = path.node;
		          if (node.typeParameters) node.typeParameters = null;
		          if (node.superTypeParameters) node.superTypeParameters = null;
		          if (node["implements"]) node["implements"] = null;
		          if (node["abstract"]) node["abstract"] = null;
		          path.get("body.body").forEach(function (child) {
		            if (child.isClassMethod() || child.isClassPrivateMethod()) {
		              if (child.node.kind === "constructor") {
		                classMemberVisitors.constructor(child, path);
		              } else {
		                classMemberVisitors.method(child);
		              }
		            } else if (child.isClassProperty() || child.isClassPrivateProperty() || child.isClassAccessorProperty()) {
		              classMemberVisitors.field(child);
		            }
		          });
		        },
		        Function: function Function(path) {
		          var node = path.node;
		          if (node.typeParameters) node.typeParameters = null;
		          if (node.returnType) node.returnType = null;
		          var params = node.params;
		          if (params.length > 0 && t.isIdentifier(params[0], {
		            name: "this"
		          })) {
		            params.shift();
		          }
		        },
		        TSModuleDeclaration: function TSModuleDeclaration(path) {
		          transpileNamespace(path, allowNamespaces);
		        },
		        TSInterfaceDeclaration: function TSInterfaceDeclaration(path) {
		          path.remove();
		        },
		        TSTypeAliasDeclaration: function TSTypeAliasDeclaration(path) {
		          path.remove();
		        },
		        TSEnumDeclaration: function TSEnumDeclaration(path) {
		          if (optimizeConstEnums && path.node["const"]) {
		            transpileConstEnum(path, t);
		          } else {
		            transpileEnum(path, t);
		          }
		        },
		        TSImportEqualsDeclaration: function (_TSImportEqualsDeclaration) {
		          function TSImportEqualsDeclaration(_x, _x2) {
		            return _TSImportEqualsDeclaration.apply(this, arguments);
		          }
		          TSImportEqualsDeclaration.toString = function () {
		            return _TSImportEqualsDeclaration.toString();
		          };
		          return TSImportEqualsDeclaration;
		        }(function (path, pass) {
		          var _path$node = path.node,
		            id = _path$node.id,
		            moduleReference = _path$node.moduleReference;
		          var init;
		          var varKind;
		          if (t.isTSExternalModuleReference(moduleReference)) {
		            assertCjsTransformEnabled(path, pass, "import " + id.name + " = require(...);", "import " + id.name + " from '...';", " alongside Typescript's --allowSyntheticDefaultImports option");
		            init = t.callExpression(t.identifier("require"), [moduleReference.expression]);
		            varKind = "const";
		          } else {
		            init = entityNameToExpr(moduleReference);
		            varKind = "var";
		          }
		          path.replaceWith(t.variableDeclaration(varKind, [t.variableDeclarator(id, init)]));
		          path.scope.registerDeclaration(path);
		        }),
		        TSExportAssignment: function TSExportAssignment(path, pass) {
		          assertCjsTransformEnabled(path, pass, "export = <value>;", "export default <value>;");
		          path.replaceWith(template.statement.ast(_templateObject2$7 || (_templateObject2$7 = _taggedTemplateLiteralLoose(["module.exports = ", ""])), path.node.expression));
		        },
		        TSTypeAssertion: function TSTypeAssertion(path) {
		          path.replaceWith(path.node.expression);
		        }
		      }, _visitor["TSAsExpression" + (t.tsSatisfiesExpression ? "|TSSatisfiesExpression" : "")] = function (_TSAsExpression) {
		        function TSAsExpression(_x3) {
		          return _TSAsExpression.apply(this, arguments);
		        }
		        TSAsExpression.toString = function () {
		          return _TSAsExpression.toString();
		        };
		        return TSAsExpression;
		      }(function (path) {
		        var node = path.node;
		        do {
		          node = node.expression;
		        } while (t.isTSAsExpression(node) || t.isTSSatisfiesExpression != null && t.isTSSatisfiesExpression(node));
		        path.replaceWith(node);
		      }), _visitor[api.types.tsInstantiationExpression ? "TSNonNullExpression|TSInstantiationExpression" : "TSNonNullExpression"] = function (path) {
		        path.replaceWith(path.node.expression);
		      }, _visitor.CallExpression = function CallExpression(path) {
		        path.node.typeParameters = null;
		      }, _visitor.OptionalCallExpression = function OptionalCallExpression(path) {
		        path.node.typeParameters = null;
		      }, _visitor.NewExpression = function NewExpression(path) {
		        path.node.typeParameters = null;
		      }, _visitor.JSXOpeningElement = function JSXOpeningElement(path) {
		        path.node.typeParameters = null;
		      }, _visitor.TaggedTemplateExpression = function TaggedTemplateExpression(path) {
		        path.node.typeParameters = null;
		      }, _visitor)
		    };
		    function entityNameToExpr(node) {
		      if (t.isTSQualifiedName(node)) {
		        return t.memberExpression(entityNameToExpr(node.left), node.right);
		      }
		      return node;
		    }
		    function visitPattern(_ref3) {
		      var node = _ref3.node;
		      if (node.typeAnnotation) node.typeAnnotation = null;
		      if (t.isIdentifier(node) && node.optional) node.optional = null;
		    }
		    function isImportTypeOnly(_ref4) {
		      var binding = _ref4.binding,
		        programPath = _ref4.programPath,
		        pragmaImportName = _ref4.pragmaImportName,
		        pragmaFragImportName = _ref4.pragmaFragImportName;
		      for (var _iterator8 = _createForOfIteratorHelperLoose(binding.referencePaths), _step8; !(_step8 = _iterator8()).done;) {
		        var path = _step8.value;
		        if (!isInType(path)) {
		          return false;
		        }
		      }
		      if (binding.identifier.name !== pragmaImportName && binding.identifier.name !== pragmaFragImportName) {
		        return true;
		      }
		      var sourceFileHasJsx = false;
		      programPath.traverse({
		        "JSXElement|JSXFragment": function JSXElementJSXFragment(path) {
		          sourceFileHasJsx = true;
		          path.stop();
		        }
		      });
		      return !sourceFileHasJsx;
		    }
		  });

		  var _transformUnicodeEscapes = declare(function (api) {
		    api.assertVersion("*");
		    var surrogate = /[\ud800-\udfff]/g;
		    var unicodeEscape = /(\\+)u\{([0-9a-fA-F]+)\}/g;
		    function escape(code) {
		      {
		        var str = code.toString(16);
		        while (str.length < 4) str = "0" + str;
		        return "\\u" + str;
		      }
		    }
		    function replacer(match, backslashes, code) {
		      if (backslashes.length % 2 === 0) {
		        return match;
		      }
		      var _char = String.fromCodePoint(parseInt(code, 16));
		      var escaped = backslashes.slice(0, -1) + escape(_char.charCodeAt(0));
		      return _char.length === 1 ? escaped : escaped + escape(_char.charCodeAt(1));
		    }
		    function replaceUnicodeEscapes(str) {
		      return str.replace(unicodeEscape, replacer);
		    }
		    function getUnicodeEscape(str) {
		      var match;
		      while (match = unicodeEscape.exec(str)) {
		        if (match[1].length % 2 === 0) continue;
		        unicodeEscape.lastIndex = 0;
		        return match[0];
		      }
		      return null;
		    }
		    return {
		      name: "transform-unicode-escapes",
		      manipulateOptions: function manipulateOptions(_ref) {
		        var _generatorOpts$jsescO, _generatorOpts$jsescO2;
		        var generatorOpts = _ref.generatorOpts;
		        if (!generatorOpts.jsescOption) {
		          generatorOpts.jsescOption = {};
		        }
		        (_generatorOpts$jsescO2 = (_generatorOpts$jsescO = generatorOpts.jsescOption).minimal) != null ? _generatorOpts$jsescO2 : _generatorOpts$jsescO.minimal = false;
		      },
		      visitor: {
		        Identifier: function Identifier(path) {
		          var node = path.node,
		            key = path.key;
		          var name = node.name;
		          var replaced = name.replace(surrogate, function (c) {
		            return "_u" + c.charCodeAt(0).toString(16);
		          });
		          if (name === replaced) return;
		          var str = inherits$3(stringLiteral$8(name), node);
		          if (key === "key") {
		            path.replaceWith(str);
		            return;
		          }
		          var parentPath = path.parentPath,
		            scope = path.scope;
		          if (parentPath.isMemberExpression({
		            property: node
		          }) || parentPath.isOptionalMemberExpression({
		            property: node
		          })) {
		            parentPath.node.computed = true;
		            path.replaceWith(str);
		            return;
		          }
		          var binding = scope.getBinding(name);
		          if (binding) {
		            scope.rename(name, scope.generateUid(replaced));
		            return;
		          }
		          throw path.buildCodeFrameError("Can't reference '" + name + "' as a bare identifier");
		        },
		        "StringLiteral|DirectiveLiteral": function StringLiteralDirectiveLiteral(path) {
		          var node = path.node;
		          var extra = node.extra;
		          if (extra != null && extra.raw) extra.raw = replaceUnicodeEscapes(extra.raw);
		        },
		        TemplateElement: function TemplateElement(path) {
		          var node = path.node,
		            parentPath = path.parentPath;
		          var value = node.value;
		          var firstEscape = getUnicodeEscape(value.raw);
		          if (!firstEscape) return;
		          var grandParent = parentPath.parentPath;
		          if (grandParent.isTaggedTemplateExpression()) {
		            throw path.buildCodeFrameError("Can't replace Unicode escape '" + firstEscape + "' inside tagged template literals. You can enable '@babel/plugin-transform-template-literals' to compile them to classic strings.");
		          }
		          value.raw = replaceUnicodeEscapes(value.raw);
		        }
		      }
		    };
		  });

		  var _transformUnicodeRegex = declare(function (api) {
		    api.assertVersion("*");
		    return createRegExpFeaturePlugin({
		      name: "transform-unicode-regex",
		      feature: "unicodeFlag"
		    });
		  });

		  var _templateObject$6, _templateObject2$6;
		  var proposalExplicitResourceManagement = declare(function (api) {
		    api.assertVersion("*");
		    var TOP_LEVEL_USING = new Map();
		    function isUsingDeclaration(node) {
		      if (!isVariableDeclaration$4(node)) return false;
		      return node.kind === "using" || node.kind === "await using" || TOP_LEVEL_USING.has(node);
		    }
		    var transformUsingDeclarationsVisitor = {
		      ForOfStatement: function (_ForOfStatement) {
		        function ForOfStatement(_x) {
		          return _ForOfStatement.apply(this, arguments);
		        }
		        ForOfStatement.toString = function () {
		          return _ForOfStatement.toString();
		        };
		        return ForOfStatement;
		      }(function (path) {
		        var left = path.node.left;
		        if (!isUsingDeclaration(left)) return;
		        var id = left.declarations[0].id;
		        var tmpId = path.scope.generateUidIdentifierBasedOnNode(id);
		        left.declarations[0].id = tmpId;
		        left.kind = "const";
		        path.ensureBlock();
		        path.node.body.body.unshift(variableDeclaration$8("using", [variableDeclarator$8(id, cloneNode$j(tmpId))]));
		      }),
		      "BlockStatement|StaticBlock": function BlockStatementStaticBlock(path, state) {
		        if (state.availableHelper("usingCtx")) {
		          var ctx = null;
		          var needsAwait = false;
		          for (var _iterator = _createForOfIteratorHelperLoose(path.node.body), _step; !(_step = _iterator()).done;) {
		            var _ctx;
		            var node = _step.value;
		            if (!isUsingDeclaration(node)) continue;
		            (_ctx = ctx) != null ? _ctx : ctx = path.scope.generateUidIdentifier("usingCtx");
		            var isAwaitUsing = node.kind === "await using" || TOP_LEVEL_USING.get(node) === 1;
		            needsAwait || (needsAwait = isAwaitUsing);
		            if (!TOP_LEVEL_USING["delete"](node)) {
		              node.kind = "const";
		            }
		            for (var _iterator2 = _createForOfIteratorHelperLoose(node.declarations), _step2; !(_step2 = _iterator2()).done;) {
		              var decl = _step2.value;
		              decl.init = callExpression$d(memberExpression$c(cloneNode$j(ctx), isAwaitUsing ? identifier$j("a") : identifier$j("u")), [decl.init]);
		            }
		          }
		          if (!ctx) return;
		          var disposeCall = callExpression$d(memberExpression$c(cloneNode$j(ctx), identifier$j("d")), []);
		          var replacement = template$1.statement.ast(_templateObject$6 || (_templateObject$6 = _taggedTemplateLiteralLoose(["\n        try {\n          var ", " = ", "();\n          ", "\n        } catch (_) {\n          ", ".e = _;\n        } finally {\n          ", "\n        }\n      "])), cloneNode$j(ctx), state.addHelper("usingCtx"), path.node.body, cloneNode$j(ctx), needsAwait ? awaitExpression$1(disposeCall) : disposeCall);
		          inherits$3(replacement, path.node);
		          var parentPath = path.parentPath;
		          if (parentPath.isFunction() || parentPath.isTryStatement() || parentPath.isCatchClause()) {
		            path.replaceWith(blockStatement$6([replacement]));
		          } else if (path.isStaticBlock()) {
		            path.node.body = [replacement];
		          } else {
		            path.replaceWith(replacement);
		          }
		        } else {
		          var stackId = null;
		          var _needsAwait = false;
		          var _loop = function _loop() {
		            var _stackId;
		            var node = _step3.value;
		            if (!isUsingDeclaration(node)) return 1;
		            (_stackId = stackId) != null ? _stackId : stackId = path.scope.generateUidIdentifier("stack");
		            var isAwaitUsing = node.kind === "await using" || TOP_LEVEL_USING.get(node) === 1;
		            _needsAwait || (_needsAwait = isAwaitUsing);
		            if (!TOP_LEVEL_USING["delete"](node)) {
		              node.kind = "const";
		            }
		            node.declarations.forEach(function (decl) {
		              var args = [cloneNode$j(stackId), decl.init];
		              if (isAwaitUsing) args.push(booleanLiteral$4(true));
		              decl.init = callExpression$d(state.addHelper("using"), args);
		            });
		          };
		          for (var _iterator3 = _createForOfIteratorHelperLoose(path.node.body), _step3; !(_step3 = _iterator3()).done;) {
		            if (_loop()) continue;
		          }
		          if (!stackId) return;
		          var errorId = path.scope.generateUidIdentifier("error");
		          var hasErrorId = path.scope.generateUidIdentifier("hasError");
		          var _disposeCall = callExpression$d(state.addHelper("dispose"), [cloneNode$j(stackId), cloneNode$j(errorId), cloneNode$j(hasErrorId)]);
		          if (_needsAwait) _disposeCall = awaitExpression$1(_disposeCall);
		          var _replacement = template$1.statement.ast(_templateObject2$6 || (_templateObject2$6 = _taggedTemplateLiteralLoose(["\n        try {\n          var ", " = [];\n          ", "\n        } catch (_) {\n          var ", " = _;\n          var ", " = true;\n        } finally {\n          ", "\n        }\n      "])), stackId, path.node.body, errorId, hasErrorId, _disposeCall);
		          inherits$3(_replacement.block, path.node);
		          var _parentPath = path.parentPath;
		          if (_parentPath.isFunction() || _parentPath.isTryStatement() || _parentPath.isCatchClause()) {
		            path.replaceWith(blockStatement$6([_replacement]));
		          } else if (path.isStaticBlock()) {
		            path.node.body = [_replacement];
		          } else {
		            path.replaceWith(_replacement);
		          }
		        }
		      }
		    };
		    var transformUsingDeclarationsVisitorSkipFn = traverse.visitors.merge([transformUsingDeclarationsVisitor, {
		      Function: function Function(path) {
		        path.skip();
		      }
		    }]);
		    return {
		      name: "proposal-explicit-resource-management",
		      inherits: syntaxExplicitResourceManagement,
		      visitor: traverse.visitors.merge([transformUsingDeclarationsVisitor, {
		        Program: function Program(path) {
		          TOP_LEVEL_USING.clear();
		          if (path.node.sourceType !== "module") return;
		          if (!path.node.body.some(isUsingDeclaration)) return;
		          var innerBlockBody = [];
		          for (var _iterator4 = _createForOfIteratorHelperLoose(path.get("body")), _step4; !(_step4 = _iterator4()).done;) {
		            var stmt = _step4.value;
		            if (stmt.isFunctionDeclaration() || stmt.isImportDeclaration()) {
		              continue;
		            }
		            var node = stmt.node;
		            var shouldRemove = true;
		            if (stmt.isExportDefaultDeclaration()) {
		              var _varId;
		              var declaration = stmt.node.declaration;
		              var varId = void 0;
		              if (isClassDeclaration$2(declaration)) {
		                varId = declaration.id;
		                declaration.id = null;
		                declaration = toExpression$1(declaration);
		              } else if (!isExpression$4(declaration)) {
		                continue;
		              }
		              (_varId = varId) != null ? _varId : varId = path.scope.generateUidIdentifier("_default");
		              innerBlockBody.push(variableDeclaration$8("var", [variableDeclarator$8(varId, declaration)]));
		              stmt.replaceWith(exportNamedDeclaration$2(null, [exportSpecifier$2(cloneNode$j(varId), identifier$j("default"))]));
		              continue;
		            }
		            if (stmt.isExportNamedDeclaration()) {
		              node = stmt.node.declaration;
		              if (!node || isFunction$5(node)) continue;
		              stmt.replaceWith(exportNamedDeclaration$2(null, Object.keys(getOuterBindingIdentifiers$2(node, false)).map(function (id) {
		                return exportSpecifier$2(identifier$j(id), identifier$j(id));
		              })));
		              shouldRemove = false;
		            } else if (stmt.isExportDeclaration()) {
		              continue;
		            }
		            if (isClassDeclaration$2(node)) {
		              var _node = node,
		                id = _node.id;
		              node.id = null;
		              innerBlockBody.push(variableDeclaration$8("var", [variableDeclarator$8(id, toExpression$1(node))]));
		            } else if (isVariableDeclaration$4(node)) {
		              if (node.kind === "using") {
		                TOP_LEVEL_USING.set(stmt.node, 0);
		              } else if (node.kind === "await using") {
		                TOP_LEVEL_USING.set(stmt.node, 1);
		              }
		              node.kind = "var";
		              innerBlockBody.push(node);
		            } else {
		              innerBlockBody.push(stmt.node);
		            }
		            if (shouldRemove) stmt.remove();
		          }
		          path.pushContainer("body", blockStatement$6(innerBlockBody));
		        },
		        Function: function Function(path, state) {
		          if (path.node.async) {
		            path.traverse(transformUsingDeclarationsVisitorSkipFn, state);
		          }
		        }
		      }])
		    };
		  });

		  var syntaxImportDefer = declare(function (api) {
		    api.assertVersion("*");
		    return {
		      name: "syntax-import-defer",
		      manipulateOptions: function manipulateOptions(_, parserOpts) {
		        parserOpts.plugins.push("deferredImportEvaluation");
		      }
		    };
		  });

		  var _templateObject$5, _templateObject2$5;
		  var proposalImportDefer = declare(function (api) {
		    api.assertVersion("*");
		    var t = api.types;
		    var template = api.template;
		    function allReferencesAreProps(scope, node) {
		      var specifier = node.specifiers[0];
		      t.assertImportNamespaceSpecifier(specifier);
		      var binding = scope.getOwnBinding(specifier.local.name);
		      return !!(binding != null && binding.referencePaths.every(function (path) {
		        return path.parentPath.isMemberExpression({
		          object: path.node
		        });
		      }));
		    }
		    return {
		      name: "proposal-import-defer",
		      inherits: syntaxImportDefer,
		      pre: function pre() {
		        var file = this.file;
		        defineCommonJSHook(file, {
		          name: "@babel/plugin-proposal-import-defer",
		          version: "7.24.1",
		          getWrapperPayload: function getWrapperPayload(source, metadata, importNodes) {
		            var needsProxy = false;
		            for (var _iterator = _createForOfIteratorHelperLoose(importNodes), _step; !(_step = _iterator()).done;) {
		              var node = _step.value;
		              if (!t.isImportDeclaration(node)) return null;
		              if (node.phase !== "defer") return null;
		              if (!allReferencesAreProps(file.scope, node)) needsProxy = true;
		            }
		            return needsProxy ? "defer/proxy" : "defer/function";
		          },
		          buildRequireWrapper: function buildRequireWrapper(name, init, payload, referenced) {
		            if (payload === "defer/proxy") {
		              if (!referenced) return false;
		              return template.statement.ast(_templateObject$5 || (_templateObject$5 = _taggedTemplateLiteralLoose(["\n              var ", " = ", "(\n                () => ", "\n              )\n            "])), name, file.addHelper("importDeferProxy"), init);
		            }
		            if (payload === "defer/function") {
		              if (!referenced) return false;
		              return template.statement.ast(_templateObject2$5 || (_templateObject2$5 = _taggedTemplateLiteralLoose(["\n              function ", "(data) {\n                ", " = () => data;\n                return data = ", ";\n              }\n            "])), name, name, init);
		            }
		          },
		          wrapReference: function wrapReference(ref, payload) {
		            if (payload === "defer/function") return t.callExpression(ref, []);
		          }
		        });
		      },
		      visitor: {
		        Program: function Program(path) {
		          if (this.file.get("@babel/plugin-transform-modules-*") !== "commonjs") {
		            throw new Error("@babel/plugin-proposal-import-defer can only be used when" + " transpiling modules to CommonJS.");
		          }
		          var eagerImports = new Set();
		          for (var _iterator2 = _createForOfIteratorHelperLoose(path.get("body")), _step2; !(_step2 = _iterator2()).done;) {
		            var child = _step2.value;
		            if (child.isImportDeclaration() && child.node.phase == null || child.isExportNamedDeclaration() && child.node.source !== null || child.isExportAllDeclaration()) {
		              var specifier = child.node.source.value;
		              if (!eagerImports.has(specifier)) {
		                eagerImports.add(specifier);
		              }
		            }
		          }
		          var importsToPush = [];
		          for (var _iterator3 = _createForOfIteratorHelperLoose(path.get("body")), _step3; !(_step3 = _iterator3()).done;) {
		            var _child = _step3.value;
		            if (_child.isImportDeclaration({
		              phase: "defer"
		            })) {
		              var _specifier = _child.node.source.value;
		              if (!eagerImports.has(_specifier)) continue;
		              _child.node.phase = null;
		              importsToPush.push(_child.node);
		              _child.remove();
		            }
		          }
		          if (importsToPush.length) {
		            path.pushContainer("body", importsToPush);
		            path.scope.crawl();
		          }
		        }
		      }
		    };
		  });

		  var _excluded$1 = ["node"];
		  function isEmpty$1(obj) {
		    return Object.keys(obj).length === 0;
		  }
		  var isRequiredOptions = {
		    compatData: {
		      webIMR: {
		        chrome: "105.0.0",
		        edge: "105.0.0",
		        firefox: "106.0.0",
		        opera: "91.0.0",
		        safari: "16.4.0",
		        opera_mobile: "72.0.0",
		        ios: "16.4.0",
		        samsung: "20.0",
		        deno: "1.24.0"
		      },
		      nodeIMR: {
		        node: "20.6.0"
		      },
		      nodeFSP: {
		        node: "10.0.0"
		      }
		    }
		  };
		  var SUPPORT_CACHE = new WeakMap();
		  function getSupport(targets) {
		    if (SUPPORT_CACHE.has(targets)) return SUPPORT_CACHE.get(targets);
		    var nodeTarget = targets.node,
		      webTargets = _objectWithoutPropertiesLoose(targets, _excluded$1);
		    var emptyNodeTarget = nodeTarget == null;
		    var emptyWebTargets = isEmpty$1(webTargets);
		    var needsNodeSupport = !emptyNodeTarget || emptyWebTargets;
		    var needsWebSupport = !emptyWebTargets || emptyNodeTarget;
		    var webSupportsIMR = !emptyWebTargets && !isRequired("webIMR", webTargets, isRequiredOptions);
		    var nodeSupportsIMR = !emptyNodeTarget && !isRequired("nodeIMR", {
		      node: nodeTarget
		    }, isRequiredOptions);
		    var nodeSupportsFsPromises = !emptyNodeTarget && !isRequired("nodeFSP", {
		      node: nodeTarget
		    }, isRequiredOptions);
		    var result = {
		      needsNodeSupport: needsNodeSupport,
		      needsWebSupport: needsWebSupport,
		      nodeSupportsIMR: nodeSupportsIMR,
		      webSupportsIMR: webSupportsIMR,
		      nodeSupportsFsPromises: nodeSupportsFsPromises
		    };
		    SUPPORT_CACHE.set(targets, result);
		    return result;
		  }

		  var _templateObject$4, _templateObject2$4, _templateObject3$4, _templateObject4$2, _templateObject5$1, _templateObject6, _templateObject7, _templateObject8, _templateObject9, _templateObject10, _templateObject11, _templateObject12, _templateObject13, _templateObject14, _templateObject15, _templateObject16, _templateObject17, _templateObject18;
		  function imp(path, name, module) {
		    return addNamed(path, name, module, {
		      importedType: "es6"
		    });
		  }
		  var imr = function imr(s) {
		    return template$1.expression.ast(_templateObject$4 || (_templateObject$4 = _taggedTemplateLiteralLoose(["\n  import.meta.resolve(", ")\n"])), s);
		  };
		  var imrWithFallback = function imrWithFallback(s) {
		    return template$1.expression.ast(_templateObject2$4 || (_templateObject2$4 = _taggedTemplateLiteralLoose(["\n  import.meta.resolve?.(", ") ?? new URL(", ", import.meta.url)\n"])), s, cloneNode$j(s));
		  };
		  function importToPlatformApi(targets, transformers, toCommonJS) {
		    var _buildFetchAsync;
		    var _getSupport = getSupport(targets),
		      needsNodeSupport = _getSupport.needsNodeSupport,
		      needsWebSupport = _getSupport.needsWebSupport,
		      nodeSupportsIMR = _getSupport.nodeSupportsIMR,
		      webSupportsIMR = _getSupport.webSupportsIMR,
		      nodeSupportsFsPromises = _getSupport.nodeSupportsFsPromises;
		    var buildFetchAsync;
		    var buildFetchSync;
		    var p = function p(_ref) {
		      var w = _ref.web,
		        n = _ref.node,
		        _ref$nodeFSP = _ref.nodeFSP,
		        nF = _ref$nodeFSP === void 0 ? nodeSupportsFsPromises : _ref$nodeFSP,
		        _ref$webIMR = _ref.webIMR,
		        wI = _ref$webIMR === void 0 ? webSupportsIMR : _ref$webIMR,
		        _ref$nodeIMR = _ref.nodeIMR,
		        nI = _ref$nodeIMR === void 0 ? nodeSupportsIMR : _ref$nodeIMR,
		        _ref$toCJS = _ref.toCJS,
		        c = _ref$toCJS === void 0 ? toCommonJS : _ref$toCJS;
		      return +w + (+n << 1) + (+wI << 2) + (+nI << 3) + (+c << 4) + (+nF << 5);
		    };
		    var readFileP = function readFileP(fs, arg) {
		      if (nodeSupportsFsPromises) {
		        return template$1.expression.ast(_templateObject3$4 || (_templateObject3$4 = _taggedTemplateLiteralLoose(["", ".promises.readFile(", ")"])), fs, arg);
		      }
		      return template$1.expression.ast(_templateObject4$2 || (_templateObject4$2 = _taggedTemplateLiteralLoose(["\n      new Promise(\n        (a =>\n          (r, j) => ", ".readFile(a, (e, d) => e ? j(e) : r(d))\n        )(", ")\n      )"])), fs, arg);
		    };
		    switch (p({
		      web: needsWebSupport,
		      node: needsNodeSupport,
		      webIMR: webSupportsIMR,
		      nodeIMR: nodeSupportsIMR,
		      toCJS: toCommonJS
		    })) {
		      case p({
		        web: true,
		        node: true
		      }):
		        buildFetchAsync = function buildFetchAsync(specifier) {
		          var web = transformers.webFetch(callExpression$d(identifier$j("fetch"), [(webSupportsIMR ? imr : imrWithFallback)(cloneNode$j(specifier))]));
		          var node = nodeSupportsIMR ? template$1.expression.ast(_templateObject5$1 || (_templateObject5$1 = _taggedTemplateLiteralLoose(["\n                import(\"fs\").then(\n                  fs => ", "\n                ).then(", ")\n              "])), readFileP(identifier$j("fs"), template$1.expression.ast(_templateObject6 || (_templateObject6 = _taggedTemplateLiteralLoose(["new URL(", ")"])), imr(specifier))), transformers.nodeFsAsync()) : template$1.expression.ast(_templateObject7 || (_templateObject7 = _taggedTemplateLiteralLoose(["\n                Promise.all([import(\"fs\"), import(\"module\")])\n                  .then(([fs, module]) =>\n                    ", "\n                  )\n                  .then(", ")\n              "])), readFileP(identifier$j("fs"), template$1.expression.ast(_templateObject8 || (_templateObject8 = _taggedTemplateLiteralLoose(["\n                        module.createRequire(import.meta.url).resolve(", ")\n                      "])), specifier)), transformers.nodeFsAsync());
		          return template$1.expression.ast(_templateObject9 || (_templateObject9 = _taggedTemplateLiteralLoose(["\n            typeof process === \"object\" && process.versions?.node\n              ? ", "\n              : ", "\n          "])), node, web);
		        };
		        break;
		      case p({
		        web: true,
		        node: false,
		        webIMR: true
		      }):
		        buildFetchAsync = function buildFetchAsync(specifier) {
		          return transformers.webFetch(callExpression$d(identifier$j("fetch"), [imr(specifier)]));
		        };
		        break;
		      case p({
		        web: true,
		        node: false,
		        webIMR: false
		      }):
		        buildFetchAsync = function buildFetchAsync(specifier) {
		          return transformers.webFetch(callExpression$d(identifier$j("fetch"), [imrWithFallback(specifier)]));
		        };
		        break;
		      case p({
		        web: false,
		        node: true,
		        toCJS: true
		      }):
		        buildFetchSync = function buildFetchSync(specifier) {
		          return transformers.nodeFsSync(template$1.expression.ast(_templateObject10 || (_templateObject10 = _taggedTemplateLiteralLoose(["\n            require(\"fs\").readFileSync(require.resolve(", "))\n          "])), specifier));
		        };
		        buildFetchAsync = function buildFetchAsync(specifier) {
		          return template$1.expression.ast(_templateObject11 || (_templateObject11 = _taggedTemplateLiteralLoose(["\n            require(\"fs\").promises.readFile(require.resolve(", "))\n              .then(", ")\n          "])), specifier, transformers.nodeFsAsync());
		        };
		        break;
		      case p({
		        web: false,
		        node: true,
		        toCJS: false,
		        nodeIMR: true
		      }):
		        buildFetchSync = function buildFetchSync(specifier, path) {
		          return transformers.nodeFsSync(template$1.expression.ast(_templateObject12 || (_templateObject12 = _taggedTemplateLiteralLoose(["\n            ", "(\n              new URL(", ")\n            )\n          "])), imp(path, "readFileSync", "fs"), imr(specifier)));
		        };
		        buildFetchAsync = function buildFetchAsync(specifier, path) {
		          return template$1.expression.ast(_templateObject13 || (_templateObject13 = _taggedTemplateLiteralLoose(["\n          ", "\n            .readFile(new URL(", "))\n            .then(", ")\n        "])), imp(path, "promises", "fs"), imr(specifier), transformers.nodeFsAsync());
		        };
		        break;
		      case p({
		        web: false,
		        node: true,
		        toCJS: false,
		        nodeIMR: false
		      }):
		        buildFetchSync = function buildFetchSync(specifier, path) {
		          return transformers.nodeFsSync(template$1.expression.ast(_templateObject14 || (_templateObject14 = _taggedTemplateLiteralLoose(["\n            ", "(\n              ", "(import.meta.url)\n                .resolve(", ")\n            )\n          "])), imp(path, "readFileSync", "fs"), imp(path, "createRequire", "module"), specifier));
		        };
		        buildFetchAsync = function buildFetchAsync(specifier, path) {
		          return transformers.webFetch(template$1.expression.ast(_templateObject15 || (_templateObject15 = _taggedTemplateLiteralLoose(["\n            ", "\n              .readFile(\n                ", "(import.meta.url)\n                  .resolve(", ")\n              )\n          "])), imp(path, "promises", "fs"), imp(path, "createRequire", "module"), specifier));
		        };
		        break;
		      default:
		        throw new Error("Internal Babel error: unreachable code.");
		    }
		    (_buildFetchAsync = buildFetchAsync) != null ? _buildFetchAsync : buildFetchAsync = buildFetchSync;
		    var buildFetchAsyncWrapped = function buildFetchAsyncWrapped(expression, path) {
		      if (isStringLiteral$5(expression)) {
		        return template$1.expression.ast(_templateObject16 || (_templateObject16 = _taggedTemplateLiteralLoose(["\n        Promise.resolve().then(() => ", ")\n      "])), buildFetchAsync(expression, path));
		      } else {
		        return template$1.expression.ast(_templateObject17 || (_templateObject17 = _taggedTemplateLiteralLoose(["\n        Promise.resolve(`${", "}`).then((s) => ", ")\n      "], ["\n        Promise.resolve(\\`\\${", "}\\`).then((s) => ", ")\n      "])), expression, buildFetchAsync(identifier$j("s"), path));
		      }
		    };
		    return {
		      buildFetch: buildFetchSync || buildFetchAsync,
		      buildFetchAsync: buildFetchAsyncWrapped,
		      needsAwait: !buildFetchSync
		    };
		  }
		  function buildParallelStaticImports(data, needsAwait) {
		    if (data.length === 0) return null;
		    var declarators = [];
		    if (data.length === 1) {
		      var rhs = data[0].fetch;
		      if (needsAwait) rhs = awaitExpression$1(rhs);
		      declarators.push(variableDeclarator$8(data[0].id, rhs));
		    } else if (needsAwait) {
		      var ids = data.map(function (_ref2) {
		        var id = _ref2.id;
		        return id;
		      });
		      var fetches = data.map(function (_ref3) {
		        var fetch = _ref3.fetch;
		        return fetch;
		      });
		      declarators.push(variableDeclarator$8(arrayPattern(ids), awaitExpression$1(template$1.expression.ast(_templateObject18 || (_templateObject18 = _taggedTemplateLiteralLoose(["\n            Promise.all(", ")\n          "])), arrayExpression$1(fetches)))));
		    } else {
		      for (var _iterator = _createForOfIteratorHelperLoose(data), _step; !(_step = _iterator()).done;) {
		        var _step$value = _step.value,
		          id = _step$value.id,
		          _fetch = _step$value.fetch;
		        declarators.push(variableDeclarator$8(id, _fetch));
		      }
		    }
		    return variableDeclaration$8("const", declarators);
		  }

		  var _templateObject$3, _templateObject2$3, _templateObject3$3, _templateObject4$1, _templateObject5;
		  var proposalJsonModules = declare(function (api) {
		    var t = api.types,
		      template = api.template;
		    api.assertVersion("*");
		    var targets = api.targets();
		    var helperESM;
		    var helperCJS;
		    var transformers = {
		      webFetch: function webFetch(fetch) {
		        return template.expression.ast(_templateObject$3 || (_templateObject$3 = _taggedTemplateLiteralLoose(["", ".then(r => r.json())"])), fetch);
		      },
		      nodeFsSync: function nodeFsSync(read) {
		        return template.expression.ast(_templateObject2$3 || (_templateObject2$3 = _taggedTemplateLiteralLoose(["JSON.parse(", ")"])), read);
		      },
		      nodeFsAsync: function nodeFsAsync() {
		        return template.expression.ast(_templateObject3$3 || (_templateObject3$3 = _taggedTemplateLiteralLoose(["JSON.parse"])));
		      }
		    };
		    var getHelper = function getHelper(file) {
		      var modules = file.get("@babel/plugin-transform-modules-*");
		      if (modules === "commonjs") {
		        var _helperCJS;
		        return (_helperCJS = helperCJS) != null ? _helperCJS : helperCJS = importToPlatformApi(targets, transformers, true);
		      }
		      if (modules == null) {
		        var _helperESM;
		        return (_helperESM = helperESM) != null ? _helperESM : helperESM = importToPlatformApi(targets, transformers, false);
		      }
		      throw new Error("@babel/plugin-proposal-json-modules can only be used when not " + "compiling modules, or when compiling them to CommonJS.");
		    };
		    function getAttributeKey(_ref) {
		      var key = _ref.key;
		      return t.isIdentifier(key) ? key.name : key.value;
		    }
		    function hasTypeJson(attributes) {
		      return !!(attributes != null && attributes.some(function (attr) {
		        return getAttributeKey(attr) === "type" && attr.value.value === "json";
		      }));
		    }
		    return {
		      name: "proposal-json-modules",
		      inherits: _syntaxImportAttributes,
		      visitor: {
		        Program: function Program(path) {
		          if (path.node.sourceType !== "module") return;
		          var helper = getHelper(this.file);
		          var data = [];
		          for (var _iterator = _createForOfIteratorHelperLoose(path.get("body")), _step; !(_step = _iterator()).done;) {
		            var _id;
		            var _decl = _step.value;
		            if (!_decl.isImportDeclaration()) continue;
		            var attributes = _decl.node.attributes || _decl.node.assertions;
		            if (!hasTypeJson(attributes)) continue;
		            if (_decl.node.phase != null) {
		              throw _decl.buildCodeFrameError("JSON modules do not support phase modifiers.");
		            }
		            if (attributes.length > 1) {
		              var paths = _decl.node.attributes ? _decl.get("attributes") : _decl.get("assertions");
		              var index = getAttributeKey(attributes[0]) === "type" ? 1 : 0;
		              throw paths[index].buildCodeFrameError("Unknown attribute for JSON modules.");
		            }
		            var id = void 0;
		            var needsNS = false;
		            for (var _iterator2 = _createForOfIteratorHelperLoose(_decl.get("specifiers")), _step2; !(_step2 = _iterator2()).done;) {
		              var specifier = _step2.value;
		              if (specifier.isImportSpecifier()) {
		                throw specifier.buildCodeFrameError("JSON modules do not support named imports.");
		              }
		              id = specifier.node.local;
		              needsNS = specifier.isImportNamespaceSpecifier();
		            }
		            (_id = id) != null ? _id : id = path.scope.generateUidIdentifier("_");
		            var fetch = helper.buildFetch(_decl.node.source, path);
		            if (needsNS) {
		              if (helper.needsAwait) {
		                fetch = template.expression.ast(_templateObject4$1 || (_templateObject4$1 = _taggedTemplateLiteralLoose(["\n                ", ".then(j => ({ default: j }))\n              "])), fetch);
		              } else {
		                fetch = template.expression.ast(_templateObject5 || (_templateObject5 = _taggedTemplateLiteralLoose(["{ default: ", " }"])), fetch);
		              }
		            }
		            data.push({
		              id: id,
		              fetch: fetch
		            });
		            _decl.remove();
		          }
		          var decl = buildParallelStaticImports(data, helper.needsAwait);
		          if (decl) path.unshiftContainer("body", decl);
		        }
		      }
		    };
		  });

		  var syntaxAsyncGenerators = makeNoopPlugin(),
		    syntaxClassProperties = makeNoopPlugin(),
		    syntaxClassStaticBlock = makeNoopPlugin(),
		    syntaxImportMeta = makeNoopPlugin(),
		    syntaxObjectRestSpread = makeNoopPlugin(),
		    syntaxOptionalCatchBinding = makeNoopPlugin(),
		    syntaxTopLevelAwait = makeNoopPlugin();
		  var all = {
		    "syntax-async-generators": syntaxAsyncGenerators,
		    "syntax-class-properties": syntaxClassProperties,
		    "syntax-class-static-block": syntaxClassStaticBlock,
		    "syntax-import-meta": syntaxImportMeta,
		    "syntax-object-rest-spread": syntaxObjectRestSpread,
		    "syntax-optional-catch-binding": syntaxOptionalCatchBinding,
		    "syntax-top-level-await": syntaxTopLevelAwait,
		    "external-helpers": externalHelpers,
		    "syntax-decimal": syntaxDecimal,
		    "syntax-decorators": syntaxDecorators,
		    "syntax-destructuring-private": syntaxDestructuringPrivate,
		    "syntax-do-expressions": syntaxDoExpressions,
		    "syntax-explicit-resource-management": syntaxExplicitResourceManagement,
		    "syntax-export-default-from": syntaxExportDefaultFrom,
		    "syntax-flow": syntaxFlow,
		    "syntax-function-bind": syntaxFunctionBind,
		    "syntax-function-sent": syntaxFunctionSent,
		    "syntax-import-assertions": _syntaxImportAssertions,
		    "syntax-import-attributes": _syntaxImportAttributes,
		    "syntax-import-reflection": syntaxImportReflection,
		    "syntax-jsx": syntaxJsx,
		    "syntax-module-blocks": syntaxModuleBlocks,
		    "syntax-optional-chaining-assign": syntaxOptionalChainingAssign,
		    "syntax-pipeline-operator": syntaxPipelineOperator,
		    "syntax-record-and-tuple": syntaxRecordAndTuple,
		    "syntax-typescript": syntaxTypescript,
		    "transform-async-generator-functions": proposalAsyncGeneratorFunctions,
		    "transform-class-properties": proposalClassProperties,
		    "transform-class-static-block": proposalClassStaticBlock,
		    "proposal-decorators": proposalDecorators,
		    "proposal-destructuring-private": proposalDestructuringPrivate,
		    "proposal-do-expressions": proposalDoExpressions,
		    "proposal-duplicate-named-capturing-groups-regex": proposalDuplicateNamedCapturingGroupsRegex,
		    "transform-dynamic-import": proposalDynamicImport,
		    "proposal-export-default-from": proposalExportDefaultFrom,
		    "transform-export-namespace-from": proposalExportNamespaceFrom,
		    "proposal-function-bind": proposalFunctionBind,
		    "proposal-function-sent": proposalFunctionSent,
		    "transform-json-strings": proposalJsonStrings,
		    "transform-logical-assignment-operators": proposalLogicalAssignmentOperators,
		    "transform-nullish-coalescing-operator": proposalNullishCoalescingOperator,
		    "transform-numeric-separator": proposalNumericSeparator,
		    "transform-object-rest-spread": proposalObjectRestSpread,
		    "transform-optional-catch-binding": proposalOptionalCatchBinding,
		    "transform-optional-chaining": proposalOptionalChaining,
		    "proposal-optional-chaining-assign": proposalOptionalChainingAssign,
		    "proposal-pipeline-operator": proposalPipelineOperator,
		    "transform-private-methods": proposalPrivateMethods,
		    "transform-private-property-in-object": proposalPrivatePropertyInObject,
		    "proposal-record-and-tuple": proposalRecordAndTuple,
		    "proposal-regexp-modifiers": proposalRegexpModifiers,
		    "proposal-throw-expressions": proposalThrowExpressions,
		    "transform-unicode-property-regex": proposalUnicodePropertyRegex,
		    "transform-unicode-sets-regex": _transformUnicodeSetsRegex,
		    "transform-async-to-generator": _transformAsyncToGenerator,
		    "transform-arrow-functions": _transformArrowFunctions,
		    "transform-block-scoped-functions": _transformBlockScopedFunctions,
		    "transform-block-scoping": _transformBlockScoping,
		    "transform-classes": _transformClasses,
		    "transform-computed-properties": _transformComputedProperties,
		    "transform-destructuring": _transformDestructuring,
		    "transform-dotall-regex": _transformDotallRegex,
		    "transform-duplicate-keys": _transformDuplicateKeys,
		    "transform-exponentiation-operator": transformExponentialOperator,
		    "transform-flow-comments": transformFlowComments,
		    "transform-flow-strip-types": transformFlowStripTypes,
		    "transform-for-of": _transformForOf,
		    "transform-function-name": _transformFunctionName,
		    "transform-instanceof": transformInstanceof,
		    "transform-jscript": transformJscript,
		    "transform-literals": _transformLiterals,
		    "transform-member-expression-literals": _transformMemberExpressionLiterals,
		    "transform-modules-amd": _transformModulesAmd,
		    "transform-modules-commonjs": transformModulesCommonJS,
		    "transform-modules-systemjs": _transformModulesSystemjs,
		    "transform-modules-umd": _transformModulesUmd,
		    "transform-named-capturing-groups-regex": _transformNamedCapturingGroupsRegex,
		    "transform-new-target": _transformNewTarget,
		    "transform-object-assign": transformObjectAssign,
		    "transform-object-super": _transformObjectSuper,
		    "transform-object-set-prototype-of-to-assign": transformObjectSetPrototypeOfToAssign,
		    "transform-parameters": _transformParameters,
		    "transform-property-literals": _transformPropertyLiterals,
		    "transform-property-mutators": transformPropertyMutators,
		    "transform-proto-to-assign": transformProtoToAssign,
		    "transform-react-constant-elements": transformReactConstantElements,
		    "transform-react-display-name": transformReactDisplayName,
		    "transform-react-inline-elements": transformReactInlineElements,
		    "transform-react-jsx": transformReactJSX,
		    "transform-react-jsx-compat": transformReactJsxCompat,
		    "transform-react-jsx-development": transformReactJSXDevelopment,
		    "transform-react-jsx-self": transformReactJsxSelf,
		    "transform-react-jsx-source": transformReactJsxSource,
		    "transform-regenerator": _transformRegenerator,
		    "transform-reserved-words": _transformReservedWords,
		    "transform-runtime": transformRuntime,
		    "transform-shorthand-properties": _transformShorthandProperties,
		    "transform-spread": _transformSpread,
		    "transform-sticky-regex": _transformStickyRegex,
		    "transform-strict-mode": transformStrictMode,
		    "transform-template-literals": _transformTemplateLiterals,
		    "transform-typeof-symbol": _transformTypeofSymbol,
		    "transform-typescript": transformTypeScript,
		    "transform-unicode-escapes": _transformUnicodeEscapes,
		    "transform-unicode-regex": _transformUnicodeRegex,
		    "proposal-explicit-resource-management": proposalExplicitResourceManagement,
		    "proposal-import-defer": proposalImportDefer,
		    "proposal-json-modules": proposalJsonModules
		  };

		  var preset2015 = (function (_, opts) {
		    var loose = false;
		    var modules = "commonjs";
		    var spec = false;
		    if (opts !== undefined) {
		      if (opts.loose !== undefined) loose = opts.loose;
		      if (opts.modules !== undefined) modules = opts.modules;
		      if (opts.spec !== undefined) spec = opts.spec;
		    }
		    var optsLoose = {
		      loose: loose
		    };
		    return {
		      plugins: [[_transformTemplateLiterals, {
		        loose: loose,
		        spec: spec
		      }], _transformLiterals, _transformFunctionName, [_transformArrowFunctions, {
		        spec: spec
		      }], _transformBlockScopedFunctions, [_transformClasses, optsLoose], _transformObjectSuper, _transformShorthandProperties, _transformDuplicateKeys, [_transformComputedProperties, optsLoose], [_transformForOf, optsLoose], _transformStickyRegex, _transformUnicodeEscapes, _transformUnicodeRegex, [_transformSpread, optsLoose], [_transformParameters, optsLoose], [_transformDestructuring, optsLoose], _transformBlockScoping, _transformTypeofSymbol, transformInstanceof, (modules === "commonjs" || modules === "cjs") && [transformModulesCommonJS, optsLoose], modules === "systemjs" && [_transformModulesSystemjs, optsLoose], modules === "amd" && [_transformModulesAmd, optsLoose], modules === "umd" && [_transformModulesUmd, optsLoose], [_transformRegenerator, {
		        async: false,
		        asyncGenerators: false
		      }]].filter(Boolean)
		    };
		  });

		  var presetStage3 = (function (_, opts) {
		    if (opts === void 0) {
		      opts = {};
		    }
		    var _opts = opts,
		      _opts$loose = _opts.loose,
		      loose = _opts$loose === void 0 ? false : _opts$loose,
		      _opts$decoratorsLegac = _opts.decoratorsLegacy,
		      decoratorsLegacy = _opts$decoratorsLegac === void 0 ? false : _opts$decoratorsLegac,
		      _opts$decoratorsVersi = _opts.decoratorsVersion,
		      decoratorsVersion = _opts$decoratorsVersi === void 0 ? "2018-09" : _opts$decoratorsVersi,
		      decoratorsBeforeExport = _opts.decoratorsBeforeExport;
		    var plugins = [[_syntaxImportAttributes, {
		      deprecatedAssertSyntax: true
		    }], _transformUnicodeSetsRegex, proposalDuplicateNamedCapturingGroupsRegex, [proposalDecorators, {
		      version: decoratorsLegacy ? "legacy" : decoratorsVersion,
		      decoratorsBeforeExport: decoratorsBeforeExport
		    }], proposalRegexpModifiers, proposalExplicitResourceManagement, proposalJsonModules].concat(_toConsumableArray([proposalExportNamespaceFrom, proposalLogicalAssignmentOperators, [proposalOptionalChaining, {
		      loose: loose
		    }], [proposalNullishCoalescingOperator, {
		      loose: loose
		    }], [proposalClassProperties, {
		      loose: loose
		    }], proposalJsonStrings, proposalNumericSeparator, [proposalPrivateMethods, {
		      loose: loose
		    }], proposalPrivatePropertyInObject, proposalClassStaticBlock]));
		    return {
		      plugins: plugins
		    };
		  });

		  var presetStage2 = (function (_, opts) {
		    if (opts === void 0) {
		      opts = {};
		    }
		    var _opts = opts,
		      _opts$pipelineProposa = _opts.pipelineProposal,
		      pipelineProposal = _opts$pipelineProposa === void 0 ? "minimal" : _opts$pipelineProposa,
		      _opts$pipelineTopicTo = _opts.pipelineTopicToken,
		      pipelineTopicToken = _opts$pipelineTopicTo === void 0 ? "%" : _opts$pipelineTopicTo,
		      _opts$recordAndTupleS = _opts.recordAndTupleSyntax,
		      recordAndTupleSyntax = _opts$recordAndTupleS === void 0 ? "hash" : _opts$recordAndTupleS;
		    return {
		      presets: [[presetStage3, opts]],
		      plugins: [proposalDestructuringPrivate, [proposalPipelineOperator, {
		        proposal: pipelineProposal,
		        topicToken: pipelineTopicToken
		      }], proposalFunctionSent, proposalThrowExpressions, [proposalRecordAndTuple, {
		        syntaxType: recordAndTupleSyntax
		      }], syntaxModuleBlocks, syntaxImportReflection]
		    };
		  });

		  var presetStage1 = (function (_, opts) {
		    if (opts === void 0) {
		      opts = {};
		    }
		    var _opts = opts,
		      _opts$loose = _opts.loose,
		      loose = _opts$loose === void 0 ? false : _opts$loose,
		      _opts$useBuiltIns = _opts.useBuiltIns,
		      useBuiltIns = _opts$useBuiltIns === void 0 ? false : _opts$useBuiltIns,
		      decoratorsLegacy = _opts.decoratorsLegacy,
		      decoratorsVersion = _opts.decoratorsVersion,
		      decoratorsBeforeExport = _opts.decoratorsBeforeExport,
		      pipelineProposal = _opts.pipelineProposal,
		      pipelineTopicToken = _opts.pipelineTopicToken,
		      recordAndTupleSyntax = _opts.recordAndTupleSyntax,
		      _opts$optionalChainin = _opts.optionalChainingAssignVersion,
		      optionalChainingAssignVersion = _opts$optionalChainin === void 0 ? "2023-07" : _opts$optionalChainin;
		    return {
		      presets: [[presetStage2, {
		        loose: loose,
		        useBuiltIns: useBuiltIns,
		        decoratorsLegacy: decoratorsLegacy,
		        decoratorsVersion: decoratorsVersion,
		        decoratorsBeforeExport: decoratorsBeforeExport,
		        pipelineProposal: pipelineProposal,
		        pipelineTopicToken: pipelineTopicToken,
		        recordAndTupleSyntax: recordAndTupleSyntax
		      }]],
		      plugins: [syntaxDecimal, proposalExportDefaultFrom, proposalDoExpressions, [proposalOptionalChainingAssign, {
		        version: optionalChainingAssignVersion
		      }]]
		    };
		  });

		  var presetStage0 = (function (_, opts) {
		    if (opts === void 0) {
		      opts = {};
		    }
		    var _opts = opts,
		      _opts$loose = _opts.loose,
		      loose = _opts$loose === void 0 ? false : _opts$loose,
		      _opts$useBuiltIns = _opts.useBuiltIns,
		      useBuiltIns = _opts$useBuiltIns === void 0 ? false : _opts$useBuiltIns,
		      decoratorsLegacy = _opts.decoratorsLegacy,
		      decoratorsVersion = _opts.decoratorsVersion,
		      decoratorsBeforeExport = _opts.decoratorsBeforeExport,
		      pipelineProposal = _opts.pipelineProposal,
		      pipelineTopicToken = _opts.pipelineTopicToken;
		    return {
		      presets: [[presetStage1, {
		        loose: loose,
		        useBuiltIns: useBuiltIns,
		        decoratorsLegacy: decoratorsLegacy,
		        decoratorsVersion: decoratorsVersion,
		        decoratorsBeforeExport: decoratorsBeforeExport,
		        pipelineProposal: pipelineProposal,
		        pipelineTopicToken: pipelineTopicToken
		      }]],
		      plugins: [proposalFunctionBind]
		    };
		  });

		  function bool(value) {
		    if (value == null) return false;
		    return value && value !== "false" && value !== "0";
		  }
		  var semver$1 = bool(browser$1$1.env["BABEL_8_BREAKING"]) ? requireSemver$2() : requireSemver$2();

		  var logPlugin = function logPlugin(item, targetVersions, list) {
		    var filteredList = getInclusionReasons(item, targetVersions, list);
		    var support = list[item];
		    {
		      if (item.startsWith("transform-")) {
		        var proposalName = "proposal-" + item.slice(10);
		        if (proposalName === "proposal-dynamic-import" || hasOwnProperty.call(plugins$1, proposalName)) {
		          item = proposalName;
		        }
		      }
		    }
		    if (!support) {
		      console.log("  " + item);
		      return;
		    }
		    var formattedTargets = "{";
		    var first = true;
		    for (var _i = 0, _arr = Object.keys(filteredList); _i < _arr.length; _i++) {
		      var target = _arr[_i];
		      if (!first) formattedTargets += ",";
		      first = false;
		      formattedTargets += " " + target;
		      if (support[target]) formattedTargets += " < " + support[target];
		    }
		    formattedTargets += " }";
		    console.log("  " + item + " " + formattedTargets);
		  };

		  var transformAsyncArrowsInClass = {exports: {}};

		  (function (module, exports) {

		    exports.__esModule = true;
		    exports["default"] = void 0;
		    var OPTS = {
		      allowInsertArrow: false,
		      specCompliant: false
		    };
		    var _default = function _default(_ref) {
		      var t = _ref.types;
		      return {
		        name: "transform-async-arrows-in-class",
		        visitor: {
		          ArrowFunctionExpression: function ArrowFunctionExpression(path) {
		            if (path.node.async && path.findParent(t.isClassMethod)) {
		              path.arrowFunctionToExpression(OPTS);
		            }
		          }
		        }
		      };
		    };
		    exports["default"] = _default;
		    module.exports = exports["default"];
		  })(transformAsyncArrowsInClass, transformAsyncArrowsInClass.exports);
		  var transformAsyncArrowsInClassExports = transformAsyncArrowsInClass.exports;

		  var transformEdgeDefaultParameters = {exports: {}};

		  (function (module, exports) {

		    exports.__esModule = true;
		    exports["default"] = void 0;
		    var _default = function _default(_ref) {
		      var t = _ref.types;
		      var isArrowParent = function isArrowParent(p) {
		        return p.parentKey === "params" && p.parentPath && t.isArrowFunctionExpression(p.parentPath);
		      };
		      return {
		        name: "transform-edge-default-parameters",
		        visitor: {
		          AssignmentPattern: function AssignmentPattern(path) {
		            var arrowArgParent = path.find(isArrowParent);
		            if (arrowArgParent && path.parent.shorthand) {
		              path.parent.shorthand = false;
		              (path.parent.extra || {}).shorthand = false;
		              path.scope.rename(path.parent.key.name);
		            }
		          }
		        }
		      };
		    };
		    exports["default"] = _default;
		    module.exports = exports["default"];
		  })(transformEdgeDefaultParameters, transformEdgeDefaultParameters.exports);
		  var transformEdgeDefaultParametersExports = transformEdgeDefaultParameters.exports;

		  var transformEdgeFunctionName = {exports: {}};

		  (function (module, exports) {

		    exports.__esModule = true;
		    exports["default"] = void 0;
		    var _default = function _default(_ref) {
		      var t = _ref.types;
		      return {
		        name: "transform-edge-function-name",
		        visitor: {
		          FunctionExpression: {
		            exit: function exit(path) {
		              if (!path.node.id && t.isIdentifier(path.parent.id)) {
		                var id = t.cloneNode(path.parent.id);
		                var binding = path.scope.getBinding(id.name);
		                if (binding == null ? void 0 : binding.constantViolations.length) {
		                  path.scope.rename(id.name);
		                }
		                path.node.id = id;
		              }
		            }
		          }
		        }
		      };
		    };
		    exports["default"] = _default;
		    module.exports = exports["default"];
		  })(transformEdgeFunctionName, transformEdgeFunctionName.exports);
		  var transformEdgeFunctionNameExports = transformEdgeFunctionName.exports;

		  var bugfixFirefoxClassInComputedKey = declare(function (_ref) {
		    var t = _ref.types,
		      traverse = _ref.traverse,
		      assertVersion = _ref.assertVersion;
		    assertVersion("*");
		    var containsClassExpressionVisitor = {
		      ClassExpression: function ClassExpression(path, state) {
		        state.found = true;
		        path.stop();
		      },
		      Function: function Function(path) {
		        path.skip();
		      }
		    };
		    var containsYieldOrAwaitVisitor = traverse.visitors.merge([{
		      YieldExpression: function YieldExpression(path, state) {
		        state["yield"] = true;
		        if (state["await"]) path.stop();
		      },
		      AwaitExpression: function AwaitExpression(path, state) {
		        state["await"] = true;
		        if (state["yield"]) path.stop();
		      }
		    }, visitor$5]);
		    function containsClassExpression(path) {
		      if (t.isClassExpression(path.node)) return true;
		      if (t.isFunction(path.node)) return false;
		      var state = {
		        found: false
		      };
		      path.traverse(containsClassExpressionVisitor, state);
		      return state.found;
		    }
		    function wrap(path) {
		      var context = {
		        "yield": t.isYieldExpression(path.node),
		        "await": t.isAwaitExpression(path.node)
		      };
		      path.traverse(containsYieldOrAwaitVisitor, context);
		      var replacement;
		      if (context["yield"]) {
		        var fn = t.functionExpression(null, [], t.blockStatement([t.returnStatement(path.node)]), true, context["await"]);
		        replacement = t.yieldExpression(t.callExpression(t.memberExpression(fn, t.identifier("call")), [t.thisExpression(), t.identifier("arguments")]), true);
		      } else {
		        var _fn = t.arrowFunctionExpression([], path.node, context["await"]);
		        replacement = t.callExpression(_fn, []);
		        if (context["await"]) replacement = t.awaitExpression(replacement);
		      }
		      path.replaceWith(replacement);
		    }
		    return {
		      name: "bugfix-firefox-class-in-computed-class-key",
		      visitor: {
		        Class: function Class(path) {
		          var hasPrivateElement = path.node.body.body.some(function (node) {
		            return t.isPrivate(node);
		          });
		          if (!hasPrivateElement) return;
		          for (var _iterator = _createForOfIteratorHelperLoose(path.get("body.body")), _step; !(_step = _iterator()).done;) {
		            var elem = _step.value;
		            if ("computed" in elem.node && elem.node.computed && containsClassExpression(elem.get("key"))) {
		              wrap(elem.get("key"));
		            }
		          }
		        }
		      }
		    };
		  });

		  var transformTaggedTemplateCaching = {exports: {}};

		  (function (module, exports) {

		    exports.__esModule = true;
		    exports["default"] = void 0;
		    var _default = function _default(_ref) {
		      var t = _ref.types;
		      return {
		        name: "transform-tagged-template-caching",
		        visitor: {
		          TaggedTemplateExpression: function TaggedTemplateExpression(path, state) {
		            var processed = state.get("processed");
		            if (!processed) {
		              processed = new WeakSet();
		              state.set("processed", processed);
		            }
		            if (processed.has(path.node)) return path.skip();
		            var expressions = path.node.quasi.expressions;
		            var identity = state.get("identity");
		            if (!identity) {
		              identity = path.scope.getProgramParent().generateDeclaredUidIdentifier("_");
		              state.set("identity", identity);
		              var binding = path.scope.getBinding(identity.name);
		              binding.path.get("init").replaceWith(t.arrowFunctionExpression([t.identifier("t")], t.identifier("t")));
		            }
		            var template = t.taggedTemplateExpression(t.cloneNode(identity), t.templateLiteral(path.node.quasi.quasis, expressions.map(function () {
		              return t.numericLiteral(0);
		            })));
		            processed.add(template);
		            var ident = path.scope.getProgramParent().generateDeclaredUidIdentifier("t");
		            path.scope.getBinding(ident.name).path.parent.kind = "let";
		            var inlineCache = t.logicalExpression("||", ident, t.assignmentExpression("=", t.cloneNode(ident), template));
		            var node = t.callExpression(path.node.tag, [inlineCache].concat(_toConsumableArray(expressions)));
		            path.replaceWith(node);
		          }
		        }
		      };
		    };
		    exports["default"] = _default;
		    module.exports = exports["default"];
		  })(transformTaggedTemplateCaching, transformTaggedTemplateCaching.exports);
		  var transformTaggedTemplateCachingExports = transformTaggedTemplateCaching.exports;

		  var transformSafariBlockShadowing = {exports: {}};

		  (function (module, exports) {

		    exports.__esModule = true;
		    exports["default"] = _default;
		    function _default(_ref) {
		      var t = _ref.types;
		      return {
		        name: "transform-safari-block-shadowing",
		        visitor: {
		          VariableDeclarator: function VariableDeclarator(path) {
		            var kind = path.parent.kind;
		            if (kind !== "let" && kind !== "const") return;
		            var block = path.scope.block;
		            if (t.isFunction(block) || t.isProgram(block)) return;
		            var bindings = t.getOuterBindingIdentifiers(path.node.id);
		            for (var _i = 0, _Object$keys = Object.keys(bindings); _i < _Object$keys.length; _i++) {
		              var name = _Object$keys[_i];
		              var scope = path.scope;
		              if (!scope.hasOwnBinding(name)) continue;
		              while (scope = scope.parent) {
		                if (scope.hasOwnBinding(name)) {
		                  path.scope.rename(name);
		                  break;
		                }
		                if (t.isFunction(scope.block) || t.isProgram(scope.block)) {
		                  break;
		                }
		              }
		            }
		          }
		        }
		      };
		    }
		    module.exports = exports["default"];
		  })(transformSafariBlockShadowing, transformSafariBlockShadowing.exports);
		  var transformSafariBlockShadowingExports = transformSafariBlockShadowing.exports;

		  var transformSafariForShadowing = {exports: {}};

		  (function (module, exports) {

		    exports.__esModule = true;
		    exports["default"] = void 0;
		    function handle(declaration) {
		      if (!declaration.isVariableDeclaration()) return;
		      var fn = declaration.getFunctionParent();
		      var name = declaration.node.declarations[0].id.name;
		      if (fn && fn.scope.hasOwnBinding(name) && fn.scope.getOwnBinding(name).kind === "param") {
		        declaration.scope.rename(name);
		      }
		    }
		    var _default = function _default() {
		      return {
		        name: "transform-safari-for-shadowing",
		        visitor: {
		          ForXStatement: function ForXStatement(path) {
		            handle(path.get("left"));
		          },
		          ForStatement: function ForStatement(path) {
		            handle(path.get("init"));
		          }
		        }
		      };
		    };
		    exports["default"] = _default;
		    module.exports = exports["default"];
		  })(transformSafariForShadowing, transformSafariForShadowing.exports);
		  var transformSafariForShadowingExports = transformSafariForShadowing.exports;

		  function shouldTransform$1(path) {
		    var node = path.node;
		    var functionId = node.id;
		    if (!functionId) return false;
		    var name = functionId.name;
		    var paramNameBinding = path.scope.getOwnBinding(name);
		    if (paramNameBinding === undefined) {
		      return false;
		    }
		    if (paramNameBinding.kind !== "param") {
		      return false;
		    }
		    if (paramNameBinding.identifier === paramNameBinding.path.node) {
		      return false;
		    }
		    return name;
		  }

		  var bugfixSafariIdDestructuringCollisionInFunctionExpression = declare(function (api) {
		    api.assertVersion("*");
		    return {
		      name: "plugin-bugfix-safari-id-destructuring-collision-in-function-expression",
		      visitor: {
		        FunctionExpression: function FunctionExpression(path) {
		          var name = shouldTransform$1(path);
		          if (name) {
		            var scope = path.scope;
		            var newParamName = scope.generateUid(name);
		            scope.rename(name, newParamName);
		          }
		        }
		      }
		    };
		  });

		  function matchAffectedArguments(argumentNodes) {
		    var spreadIndex = argumentNodes.findIndex(function (node) {
		      return isSpreadElement$1(node);
		    });
		    return spreadIndex >= 0 && spreadIndex !== argumentNodes.length - 1;
		  }
		  function shouldTransform(path) {
		    var optionalPath = path;
		    var chains = [];
		    for (;;) {
		      if (optionalPath.isOptionalMemberExpression()) {
		        chains.push(optionalPath.node);
		        optionalPath = skipTransparentExprWrappers(optionalPath.get("object"));
		      } else if (optionalPath.isOptionalCallExpression()) {
		        chains.push(optionalPath.node);
		        optionalPath = skipTransparentExprWrappers(optionalPath.get("callee"));
		      } else {
		        break;
		      }
		    }
		    for (var i = 0; i < chains.length; i++) {
		      var node = chains[i];
		      if (isOptionalCallExpression$2(node) && matchAffectedArguments(node.arguments)) {
		        if (node.optional) {
		          return true;
		        }
		        var callee = chains[i + 1];
		        if (isOptionalMemberExpression$3(callee, {
		          optional: true
		        })) {
		          return true;
		        }
		      }
		    }
		    return false;
		  }

		  var bugfixV8SpreadParametersInOptionalChaining = declare(function (api) {
		    var _api$assumption, _api$assumption2;
		    api.assertVersion("*");
		    var noDocumentAll = (_api$assumption = api.assumption("noDocumentAll")) != null ? _api$assumption : false;
		    var pureGetters = (_api$assumption2 = api.assumption("pureGetters")) != null ? _api$assumption2 : false;
		    return {
		      name: "bugfix-v8-spread-parameters-in-optional-chaining",
		      visitor: {
		        "OptionalCallExpression|OptionalMemberExpression": function OptionalCallExpressionOptionalMemberExpression(path) {
		          if (shouldTransform(path)) {
		            transform$1(path, {
		              noDocumentAll: noDocumentAll,
		              pureGetters: pureGetters
		            });
		          }
		        }
		      }
		    };
		  });

		  function isNameOrLength(key) {
		    if (isIdentifier$i(key)) {
		      return key.name === "name" || key.name === "length";
		    }
		    if (isStringLiteral$5(key)) {
		      return key.value === "name" || key.value === "length";
		    }
		    return false;
		  }
		  function isStaticFieldWithValue(node) {
		    return (isClassProperty(node) || isClassPrivateProperty(node)) && node["static"] && !!node.value;
		  }
		  var hasReferenceVisitor = {
		    ReferencedIdentifier: function ReferencedIdentifier(path, state) {
		      if (path.node.name === state.name) {
		        state.ref();
		        path.stop();
		      }
		    },
		    Scope: function Scope(path, _ref) {
		      var name = _ref.name;
		      if (path.scope.hasOwnBinding(name)) {
		        path.skip();
		      }
		    }
		  };
		  function isReferenceOrThis(node, name) {
		    return isThisExpression$2(node) || name && isIdentifier$i(node, {
		      name: name
		    });
		  }
		  var hasReferenceOrThisVisitor = {
		    "ThisExpression|ReferencedIdentifier": function ThisExpressionReferencedIdentifier(path, state) {
		      if (isReferenceOrThis(path.node, state.name)) {
		        state.ref();
		        path.stop();
		      }
		    },
		    FunctionParent: function FunctionParent(path, state) {
		      if (path.isArrowFunctionExpression()) return;
		      if (state.name && !path.scope.hasOwnBinding(state.name)) {
		        path.traverse(hasReferenceVisitor, state);
		      }
		      path.skip();
		      if (path.isMethod()) {
		        requeueComputedKeyAndDecorators(path);
		      }
		    }
		  };
		  function getPotentiallyBuggyFieldsIndexes(path) {
		    var _path$node$id;
		    var buggyPublicStaticFieldsIndexes = [];
		    var classReferenced = false;
		    var className = (_path$node$id = path.node.id) == null ? void 0 : _path$node$id.name;
		    var hasReferenceState = {
		      name: className,
		      ref: function ref() {
		        return classReferenced = true;
		      }
		    };
		    if (className) {
		      for (var _iterator = _createForOfIteratorHelperLoose(path.get("body.body")), _step; !(_step = _iterator()).done;) {
		        var el = _step.value;
		        if (el.node.computed) {
		          el.get("key").traverse(hasReferenceVisitor, hasReferenceState);
		          if (classReferenced) break;
		        }
		      }
		    }
		    var nextPotentiallyBuggy = false;
		    var body = path.node.body.body;
		    for (var i = 0; i < body.length; i++) {
		      var node = body[i];
		      if (!nextPotentiallyBuggy) {
		        if (isStaticBlock(node)) {
		          classReferenced = true;
		          nextPotentiallyBuggy = true;
		        } else if (isStaticFieldWithValue(node)) {
		          if (!classReferenced) {
		            if (isReferenceOrThis(node.value, className)) {
		              classReferenced = true;
		            } else {
		              path.get("body.body." + i + ".value").traverse(hasReferenceOrThisVisitor, hasReferenceState);
		            }
		          }
		          if (classReferenced) {
		            nextPotentiallyBuggy = !path.scope.isPure(node.value);
		          }
		        }
		      }
		      if (isClassProperty(node, {
		        "static": true
		      }) && (nextPotentiallyBuggy || node.computed || isNameOrLength(node.key))) {
		        buggyPublicStaticFieldsIndexes.push(i);
		      }
		    }
		    return buggyPublicStaticFieldsIndexes;
		  }
		  function getNameOrLengthStaticFieldsIndexes(path) {
		    var indexes = [];
		    var body = path.node.body.body;
		    for (var i = 0; i < body.length; i++) {
		      var node = body[i];
		      if (isClassProperty(node, {
		        "static": true,
		        computed: false
		      }) && isNameOrLength(node.key)) {
		        indexes.push(i);
		      }
		    }
		    return indexes;
		  }
		  function toRanges(nums) {
		    var ranges = [];
		    if (nums.length === 0) return ranges;
		    var start = nums[0];
		    var end = start + 1;
		    for (var i = 1; i < nums.length; i++) {
		      if (nums[i] <= nums[i - 1]) {
		        throw new Error("Internal Babel error: nums must be in ascending order");
		      }
		      if (nums[i] === end) {
		        end++;
		      } else {
		        ranges.push([start, end]);
		        start = nums[i];
		        end = start + 1;
		      }
		    }
		    ranges.push([start, end]);
		    return ranges;
		  }

		  function buildFieldsReplacement(fields, scope, file) {
		    return staticBlock(fields.map(function (field) {
		      var key = field.computed || !isIdentifier$i(field.key) ? field.key : stringLiteral$8(field.key.name);
		      return expressionStatement$a(callExpression$d(file.addHelper("defineProperty"), [thisExpression$4(), key, field.value || scope.buildUndefinedNode()]));
		    }));
		  }
		  var bugfixV8StaticClassFieldsRedefineReadonly = declare(function (api) {
		    api.assertVersion("*");
		    var setPublicClassFields = api.assumption("setPublicClassFields");
		    return {
		      name: "bugfix-v8-static-class-fields-redefine-readonly",
		      visitor: {
		        Class: function (_Class) {
		          function Class(_x) {
		            return _Class.apply(this, arguments);
		          }
		          Class.toString = function () {
		            return _Class.toString();
		          };
		          return Class;
		        }(function (path) {
		          var ranges = toRanges(setPublicClassFields ? getNameOrLengthStaticFieldsIndexes(path) : getPotentiallyBuggyFieldsIndexes(path));
		          for (var i = ranges.length - 1; i >= 0; i--) {
		            var _ranges$i = _slicedToArray(ranges[i], 2),
		              start = _ranges$i[0],
		              end = _ranges$i[1];
		            var startPath = path.get("body.body")[start];
		            startPath.replaceWith(buildFieldsReplacement(path.node.body.body.slice(start, end), path.scope, this.file));
		            for (var j = end - 1; j > start; j--) {
		              path.get("body.body")[j].remove();
		            }
		          }
		        })
		      }
		    };
		  });

		  var availablePlugins$1 = {
		    "bugfix/transform-async-arrows-in-class": function bugfixTransformAsyncArrowsInClass() {
		      return transformAsyncArrowsInClassExports;
		    },
		    "bugfix/transform-edge-default-parameters": function bugfixTransformEdgeDefaultParameters() {
		      return transformEdgeDefaultParametersExports;
		    },
		    "bugfix/transform-edge-function-name": function bugfixTransformEdgeFunctionName() {
		      return transformEdgeFunctionNameExports;
		    },
		    "bugfix/transform-firefox-class-in-computed-class-key": function bugfixTransformFirefoxClassInComputedClassKey() {
		      return bugfixFirefoxClassInComputedKey;
		    },
		    "bugfix/transform-safari-block-shadowing": function bugfixTransformSafariBlockShadowing() {
		      return transformSafariBlockShadowingExports;
		    },
		    "bugfix/transform-safari-for-shadowing": function bugfixTransformSafariForShadowing() {
		      return transformSafariForShadowingExports;
		    },
		    "bugfix/transform-safari-id-destructuring-collision-in-function-expression": function bugfixTransformSafariIdDestructuringCollisionInFunctionExpression() {
		      return bugfixSafariIdDestructuringCollisionInFunctionExpression;
		    },
		    "bugfix/transform-tagged-template-caching": function bugfixTransformTaggedTemplateCaching() {
		      return transformTaggedTemplateCachingExports;
		    },
		    "bugfix/transform-v8-spread-parameters-in-optional-chaining": function bugfixTransformV8SpreadParametersInOptionalChaining() {
		      return bugfixV8SpreadParametersInOptionalChaining;
		    },
		    "bugfix/transform-v8-static-class-fields-redefine-readonly": function bugfixTransformV8StaticClassFieldsRedefineReadonly() {
		      return bugfixV8StaticClassFieldsRedefineReadonly;
		    },
		    "syntax-import-assertions": function syntaxImportAssertions() {
		      return _syntaxImportAssertions;
		    },
		    "syntax-import-attributes": function syntaxImportAttributes() {
		      return _syntaxImportAttributes;
		    },
		    "transform-arrow-functions": function transformArrowFunctions() {
		      return _transformArrowFunctions;
		    },
		    "transform-async-generator-functions": function transformAsyncGeneratorFunctions() {
		      return proposalAsyncGeneratorFunctions;
		    },
		    "transform-async-to-generator": function transformAsyncToGenerator() {
		      return _transformAsyncToGenerator;
		    },
		    "transform-block-scoped-functions": function transformBlockScopedFunctions() {
		      return _transformBlockScopedFunctions;
		    },
		    "transform-block-scoping": function transformBlockScoping() {
		      return _transformBlockScoping;
		    },
		    "transform-class-properties": function transformClassProperties() {
		      return proposalClassProperties;
		    },
		    "transform-class-static-block": function transformClassStaticBlock() {
		      return proposalClassStaticBlock;
		    },
		    "transform-classes": function transformClasses() {
		      return _transformClasses;
		    },
		    "transform-computed-properties": function transformComputedProperties() {
		      return _transformComputedProperties;
		    },
		    "transform-destructuring": function transformDestructuring() {
		      return _transformDestructuring;
		    },
		    "transform-dotall-regex": function transformDotallRegex() {
		      return _transformDotallRegex;
		    },
		    "transform-duplicate-keys": function transformDuplicateKeys() {
		      return _transformDuplicateKeys;
		    },
		    "transform-dynamic-import": function transformDynamicImport() {
		      return proposalDynamicImport;
		    },
		    "transform-exponentiation-operator": function transformExponentiationOperator() {
		      return transformExponentialOperator;
		    },
		    "transform-export-namespace-from": function transformExportNamespaceFrom() {
		      return proposalExportNamespaceFrom;
		    },
		    "transform-for-of": function transformForOf() {
		      return _transformForOf;
		    },
		    "transform-function-name": function transformFunctionName() {
		      return _transformFunctionName;
		    },
		    "transform-json-strings": function transformJsonStrings() {
		      return proposalJsonStrings;
		    },
		    "transform-literals": function transformLiterals() {
		      return _transformLiterals;
		    },
		    "transform-logical-assignment-operators": function transformLogicalAssignmentOperators() {
		      return proposalLogicalAssignmentOperators;
		    },
		    "transform-member-expression-literals": function transformMemberExpressionLiterals() {
		      return _transformMemberExpressionLiterals;
		    },
		    "transform-modules-amd": function transformModulesAmd() {
		      return _transformModulesAmd;
		    },
		    "transform-modules-commonjs": function transformModulesCommonjs() {
		      return transformModulesCommonJS;
		    },
		    "transform-modules-systemjs": function transformModulesSystemjs() {
		      return _transformModulesSystemjs;
		    },
		    "transform-modules-umd": function transformModulesUmd() {
		      return _transformModulesUmd;
		    },
		    "transform-named-capturing-groups-regex": function transformNamedCapturingGroupsRegex() {
		      return _transformNamedCapturingGroupsRegex;
		    },
		    "transform-new-target": function transformNewTarget() {
		      return _transformNewTarget;
		    },
		    "transform-nullish-coalescing-operator": function transformNullishCoalescingOperator() {
		      return proposalNullishCoalescingOperator;
		    },
		    "transform-numeric-separator": function transformNumericSeparator() {
		      return proposalNumericSeparator;
		    },
		    "transform-object-rest-spread": function transformObjectRestSpread() {
		      return proposalObjectRestSpread;
		    },
		    "transform-object-super": function transformObjectSuper() {
		      return _transformObjectSuper;
		    },
		    "transform-optional-catch-binding": function transformOptionalCatchBinding() {
		      return proposalOptionalCatchBinding;
		    },
		    "transform-optional-chaining": function transformOptionalChaining() {
		      return proposalOptionalChaining;
		    },
		    "transform-parameters": function transformParameters() {
		      return _transformParameters;
		    },
		    "transform-private-methods": function transformPrivateMethods() {
		      return proposalPrivateMethods;
		    },
		    "transform-private-property-in-object": function transformPrivatePropertyInObject() {
		      return proposalPrivatePropertyInObject;
		    },
		    "transform-property-literals": function transformPropertyLiterals() {
		      return _transformPropertyLiterals;
		    },
		    "transform-regenerator": function transformRegenerator() {
		      return _transformRegenerator;
		    },
		    "transform-reserved-words": function transformReservedWords() {
		      return _transformReservedWords;
		    },
		    "transform-shorthand-properties": function transformShorthandProperties() {
		      return _transformShorthandProperties;
		    },
		    "transform-spread": function transformSpread() {
		      return _transformSpread;
		    },
		    "transform-sticky-regex": function transformStickyRegex() {
		      return _transformStickyRegex;
		    },
		    "transform-template-literals": function transformTemplateLiterals() {
		      return _transformTemplateLiterals;
		    },
		    "transform-typeof-symbol": function transformTypeofSymbol() {
		      return _transformTypeofSymbol;
		    },
		    "transform-unicode-escapes": function transformUnicodeEscapes() {
		      return _transformUnicodeEscapes;
		    },
		    "transform-unicode-property-regex": function transformUnicodePropertyRegex() {
		      return proposalUnicodePropertyRegex;
		    },
		    "transform-unicode-regex": function transformUnicodeRegex() {
		      return _transformUnicodeRegex;
		    },
		    "transform-unicode-sets-regex": function transformUnicodeSetsRegex() {
		      return _transformUnicodeSetsRegex;
		    }
		  };
		  var minVersions = {};
		  var legacyBabel7SyntaxPlugins;
		  {
		    Object.assign(minVersions, {
		      "bugfix/transform-safari-id-destructuring-collision-in-function-expression": "7.16.0",
		      "bugfix/transform-v8-static-class-fields-redefine-readonly": "7.12.0",
		      "syntax-import-attributes": "7.22.0",
		      "transform-class-static-block": "7.12.0",
		      "transform-private-property-in-object": "7.10.0"
		    });
		    var e = function e() {
		      return function () {
		        return function () {
		          return {};
		        };
		      };
		    };
		    var legacyBabel7SyntaxPluginsLoaders = {
		      "syntax-async-generators": e(),
		      "syntax-class-properties": e(),
		      "syntax-class-static-block": e(),
		      "syntax-dynamic-import": e(),
		      "syntax-export-namespace-from": e(),
		      "syntax-import-meta": e(),
		      "syntax-json-strings": e(),
		      "syntax-logical-assignment-operators": e(),
		      "syntax-nullish-coalescing-operator": e(),
		      "syntax-numeric-separator": e(),
		      "syntax-object-rest-spread": e(),
		      "syntax-optional-catch-binding": e(),
		      "syntax-optional-chaining": e(),
		      "syntax-private-property-in-object": e(),
		      "syntax-top-level-await": e()
		    };
		    {
		      legacyBabel7SyntaxPluginsLoaders["unicode-sets-regex"] = e();
		    }
		    Object.assign(availablePlugins$1, legacyBabel7SyntaxPluginsLoaders);
		    legacyBabel7SyntaxPlugins = new Set(Object.keys(legacyBabel7SyntaxPluginsLoaders));
		  }

		  function addProposalSyntaxPlugins(items, proposalSyntaxPlugins) {
		    proposalSyntaxPlugins.forEach(function (plugin) {
		      items.add(plugin);
		    });
		  }
		  function removeUnnecessaryItems(items, overlapping) {
		    items.forEach(function (item) {
		      var _overlapping$item;
		      (_overlapping$item = overlapping[item]) == null || _overlapping$item.forEach(function (name) {
		        return items["delete"](name);
		      });
		    });
		  }
		  function removeUnsupportedItems(items, babelVersion) {
		    items.forEach(function (item) {
		      if (hasOwnProperty.call(minVersions, item) && semver$1.lt(babelVersion, minVersions[item])) {
		        items["delete"](item);
		      } else if (babelVersion[0] === "8" && legacyBabel7SyntaxPlugins.has(item)) {
		        items["delete"](item);
		      }
		    });
		  }

		  var moduleTransformations = {
		    amd: "transform-modules-amd",
		    commonjs: "transform-modules-commonjs",
		    cjs: "transform-modules-commonjs",
		    systemjs: "transform-modules-systemjs",
		    umd: "transform-modules-umd"
		  };

		  var require$$0$1 = {
		  	"bugfix/transform-async-arrows-in-class": {
		  	chrome: "55",
		  	opera: "42",
		  	edge: "15",
		  	firefox: "52",
		  	safari: "11",
		  	node: "7.6",
		  	deno: "1",
		  	ios: "11",
		  	samsung: "6",
		  	opera_mobile: "42",
		  	electron: "1.6"
		  },
		  	"bugfix/transform-edge-default-parameters": {
		  	chrome: "49",
		  	opera: "36",
		  	edge: "18",
		  	firefox: "52",
		  	safari: "10",
		  	node: "6",
		  	deno: "1",
		  	ios: "10",
		  	samsung: "5",
		  	opera_mobile: "36",
		  	electron: "0.37"
		  },
		  	"bugfix/transform-edge-function-name": {
		  	chrome: "51",
		  	opera: "38",
		  	edge: "79",
		  	firefox: "53",
		  	safari: "10",
		  	node: "6.5",
		  	deno: "1",
		  	ios: "10",
		  	samsung: "5",
		  	opera_mobile: "41",
		  	electron: "1.2"
		  },
		  	"bugfix/transform-safari-block-shadowing": {
		  	chrome: "49",
		  	opera: "36",
		  	edge: "12",
		  	firefox: "44",
		  	safari: "11",
		  	node: "6",
		  	deno: "1",
		  	ie: "11",
		  	ios: "11",
		  	samsung: "5",
		  	opera_mobile: "36",
		  	electron: "0.37"
		  },
		  	"bugfix/transform-safari-for-shadowing": {
		  	chrome: "49",
		  	opera: "36",
		  	edge: "12",
		  	firefox: "4",
		  	safari: "11",
		  	node: "6",
		  	deno: "1",
		  	ie: "11",
		  	ios: "11",
		  	samsung: "5",
		  	rhino: "1.7.13",
		  	opera_mobile: "36",
		  	electron: "0.37"
		  },
		  	"bugfix/transform-safari-id-destructuring-collision-in-function-expression": {
		  	chrome: "49",
		  	opera: "36",
		  	edge: "14",
		  	firefox: "2",
		  	safari: "16.3",
		  	node: "6",
		  	deno: "1",
		  	ios: "16.3",
		  	samsung: "5",
		  	opera_mobile: "36",
		  	electron: "0.37"
		  },
		  	"bugfix/transform-tagged-template-caching": {
		  	chrome: "41",
		  	opera: "28",
		  	edge: "12",
		  	firefox: "34",
		  	safari: "13",
		  	node: "4",
		  	deno: "1",
		  	ios: "13",
		  	samsung: "3.4",
		  	rhino: "1.7.14",
		  	opera_mobile: "28",
		  	electron: "0.21"
		  },
		  	"bugfix/transform-v8-spread-parameters-in-optional-chaining": {
		  	chrome: "91",
		  	opera: "77",
		  	edge: "91",
		  	firefox: "74",
		  	safari: "13.1",
		  	node: "16.9",
		  	deno: "1.9",
		  	ios: "13.4",
		  	samsung: "16",
		  	opera_mobile: "64",
		  	electron: "13.0"
		  },
		  	"bugfix/transform-firefox-class-in-computed-class-key": {
		  	chrome: "74",
		  	opera: "62",
		  	edge: "79",
		  	safari: "14.1",
		  	node: "12",
		  	deno: "1",
		  	ios: "14.5",
		  	samsung: "11",
		  	opera_mobile: "53",
		  	electron: "6.0"
		  },
		  	"transform-optional-chaining": {
		  	chrome: "80",
		  	opera: "67",
		  	edge: "80",
		  	firefox: "74",
		  	safari: "13.1",
		  	node: "14",
		  	deno: "1",
		  	ios: "13.4",
		  	samsung: "13",
		  	opera_mobile: "57",
		  	electron: "8.0"
		  },
		  	"proposal-optional-chaining": {
		  	chrome: "80",
		  	opera: "67",
		  	edge: "80",
		  	firefox: "74",
		  	safari: "13.1",
		  	node: "14",
		  	deno: "1",
		  	ios: "13.4",
		  	samsung: "13",
		  	opera_mobile: "57",
		  	electron: "8.0"
		  },
		  	"transform-parameters": {
		  	chrome: "49",
		  	opera: "36",
		  	edge: "15",
		  	firefox: "53",
		  	safari: "10",
		  	node: "6",
		  	deno: "1",
		  	ios: "10",
		  	samsung: "5",
		  	opera_mobile: "36",
		  	electron: "0.37"
		  },
		  	"transform-async-to-generator": {
		  	chrome: "55",
		  	opera: "42",
		  	edge: "15",
		  	firefox: "52",
		  	safari: "10.1",
		  	node: "7.6",
		  	deno: "1",
		  	ios: "10.3",
		  	samsung: "6",
		  	opera_mobile: "42",
		  	electron: "1.6"
		  },
		  	"transform-template-literals": {
		  	chrome: "41",
		  	opera: "28",
		  	edge: "13",
		  	firefox: "34",
		  	safari: "9",
		  	node: "4",
		  	deno: "1",
		  	ios: "9",
		  	samsung: "3.4",
		  	opera_mobile: "28",
		  	electron: "0.21"
		  },
		  	"transform-function-name": {
		  	chrome: "51",
		  	opera: "38",
		  	edge: "14",
		  	firefox: "53",
		  	safari: "10",
		  	node: "6.5",
		  	deno: "1",
		  	ios: "10",
		  	samsung: "5",
		  	opera_mobile: "41",
		  	electron: "1.2"
		  },
		  	"transform-block-scoping": {
		  	chrome: "50",
		  	opera: "37",
		  	edge: "14",
		  	firefox: "53",
		  	safari: "10",
		  	node: "6",
		  	deno: "1",
		  	ios: "10",
		  	samsung: "5",
		  	opera_mobile: "37",
		  	electron: "1.1"
		  }
		  };

		  var pluginBugfixes = require$$0$1;

		  var require$$0 = {
		  	"transform-async-to-generator": [
		  	"bugfix/transform-async-arrows-in-class"
		  ],
		  	"transform-parameters": [
		  	"bugfix/transform-edge-default-parameters",
		  	"bugfix/transform-safari-id-destructuring-collision-in-function-expression"
		  ],
		  	"transform-function-name": [
		  	"bugfix/transform-edge-function-name"
		  ],
		  	"transform-block-scoping": [
		  	"bugfix/transform-safari-block-shadowing",
		  	"bugfix/transform-safari-for-shadowing"
		  ],
		  	"transform-template-literals": [
		  	"bugfix/transform-tagged-template-caching"
		  ],
		  	"transform-optional-chaining": [
		  	"bugfix/transform-v8-spread-parameters-in-optional-chaining"
		  ],
		  	"proposal-optional-chaining": [
		  	"bugfix/transform-v8-spread-parameters-in-optional-chaining"
		  ],
		  	"transform-class-properties": [
		  	"bugfix/transform-v8-static-class-fields-redefine-readonly",
		  	"bugfix/transform-firefox-class-in-computed-class-key"
		  ],
		  	"proposal-class-properties": [
		  	"bugfix/transform-v8-static-class-fields-redefine-readonly",
		  	"bugfix/transform-firefox-class-in-computed-class-key"
		  ]
		  };

		  var overlappingPlugins$1 = require$$0;

		  var keys = Object.keys;
		  var plugins = filterAvailable(plugins$1);
		  var pluginsBugfixes = filterAvailable(pluginBugfixes);
		  var overlappingPlugins = filterAvailable(overlappingPlugins$1);
		  overlappingPlugins["syntax-import-attributes"] = ["syntax-import-assertions"];
		  function filterAvailable(data) {
		    var result = {};
		    for (var _iterator = _createForOfIteratorHelperLoose(keys(data)), _step; !(_step = _iterator()).done;) {
		      var plugin = _step.value;
		      if (hasOwnProperty.call(availablePlugins$1, plugin)) {
		        result[plugin] = data[plugin];
		      }
		    }
		    return result;
		  }

		  var TopLevelOptions = {
		    bugfixes: "bugfixes",
		    configPath: "configPath",
		    corejs: "corejs",
		    debug: "debug",
		    exclude: "exclude",
		    forceAllTransforms: "forceAllTransforms",
		    ignoreBrowserslistConfig: "ignoreBrowserslistConfig",
		    include: "include",
		    modules: "modules",
		    shippedProposals: "shippedProposals",
		    targets: "targets",
		    useBuiltIns: "useBuiltIns",
		    browserslistEnv: "browserslistEnv"
		  };
		  {
		    Object.assign(TopLevelOptions, {
		      loose: "loose",
		      spec: "spec"
		    });
		  }
		  var ModulesOption = {
		    "false": false,
		    auto: "auto",
		    amd: "amd",
		    commonjs: "commonjs",
		    cjs: "cjs",
		    systemjs: "systemjs",
		    umd: "umd"
		  };
		  var UseBuiltInsOption = {
		    "false": false,
		    entry: "entry",
		    usage: "usage"
		  };

		  var babel7Plugins = {};

		  var lib$2 = {};

		  var builtInDefinitions = {};

		  var hasRequiredBuiltInDefinitions;
		  function requireBuiltInDefinitions() {
		    if (hasRequiredBuiltInDefinitions) return builtInDefinitions;
		    hasRequiredBuiltInDefinitions = 1;
		    builtInDefinitions.__esModule = true;
		    builtInDefinitions.StaticProperties = builtInDefinitions.InstanceProperties = builtInDefinitions.CommonIterators = builtInDefinitions.BuiltIns = void 0;
		    var _corejs2BuiltIns = _interopRequireDefault(requireCorejs2BuiltIns());
		    function _interopRequireDefault(obj) {
		      return obj && obj.__esModule ? obj : {
		        "default": obj
		      };
		    }
		    var define = function define(name, pure, global, meta) {
		      if (global === void 0) {
		        global = [];
		      }
		      return {
		        name: name,
		        pure: pure,
		        global: global,
		        meta: meta
		      };
		    };
		    var pureAndGlobal = function pureAndGlobal(pure, global, minRuntimeVersion) {
		      if (minRuntimeVersion === void 0) {
		        minRuntimeVersion = null;
		      }
		      return define(global[0], pure, global, {
		        minRuntimeVersion: minRuntimeVersion
		      });
		    };
		    var globalOnly = function globalOnly(global) {
		      return define(global[0], null, global);
		    };
		    var pureOnly = function pureOnly(pure, name) {
		      return define(name, pure, []);
		    };
		    var ArrayNatureIterators = ["es6.object.to-string", "es6.array.iterator", "web.dom.iterable"];
		    var CommonIterators = ["es6.string.iterator"].concat(ArrayNatureIterators);
		    builtInDefinitions.CommonIterators = CommonIterators;
		    var PromiseDependencies = ["es6.object.to-string", "es6.promise"];
		    var BuiltIns = {
		      DataView: globalOnly(["es6.typed.data-view"]),
		      Float32Array: globalOnly(["es6.typed.float32-array"]),
		      Float64Array: globalOnly(["es6.typed.float64-array"]),
		      Int8Array: globalOnly(["es6.typed.int8-array"]),
		      Int16Array: globalOnly(["es6.typed.int16-array"]),
		      Int32Array: globalOnly(["es6.typed.int32-array"]),
		      Map: pureAndGlobal("map", ["es6.map"].concat(_toConsumableArray(CommonIterators))),
		      Number: globalOnly(["es6.number.constructor"]),
		      Promise: pureAndGlobal("promise", PromiseDependencies),
		      RegExp: globalOnly(["es6.regexp.constructor"]),
		      Set: pureAndGlobal("set", ["es6.set"].concat(_toConsumableArray(CommonIterators))),
		      Symbol: pureAndGlobal("symbol/index", ["es6.symbol"]),
		      Uint8Array: globalOnly(["es6.typed.uint8-array"]),
		      Uint8ClampedArray: globalOnly(["es6.typed.uint8-clamped-array"]),
		      Uint16Array: globalOnly(["es6.typed.uint16-array"]),
		      Uint32Array: globalOnly(["es6.typed.uint32-array"]),
		      WeakMap: pureAndGlobal("weak-map", ["es6.weak-map"].concat(_toConsumableArray(CommonIterators))),
		      WeakSet: pureAndGlobal("weak-set", ["es6.weak-set"].concat(_toConsumableArray(CommonIterators))),
		      setImmediate: pureOnly("set-immediate", "web.immediate"),
		      clearImmediate: pureOnly("clear-immediate", "web.immediate"),
		      parseFloat: pureOnly("parse-float", "es6.parse-float"),
		      parseInt: pureOnly("parse-int", "es6.parse-int")
		    };
		    builtInDefinitions.BuiltIns = BuiltIns;
		    var InstanceProperties = {
		      __defineGetter__: globalOnly(["es7.object.define-getter"]),
		      __defineSetter__: globalOnly(["es7.object.define-setter"]),
		      __lookupGetter__: globalOnly(["es7.object.lookup-getter"]),
		      __lookupSetter__: globalOnly(["es7.object.lookup-setter"]),
		      anchor: globalOnly(["es6.string.anchor"]),
		      big: globalOnly(["es6.string.big"]),
		      bind: globalOnly(["es6.function.bind"]),
		      blink: globalOnly(["es6.string.blink"]),
		      bold: globalOnly(["es6.string.bold"]),
		      codePointAt: globalOnly(["es6.string.code-point-at"]),
		      copyWithin: globalOnly(["es6.array.copy-within"]),
		      endsWith: globalOnly(["es6.string.ends-with"]),
		      entries: globalOnly(ArrayNatureIterators),
		      every: globalOnly(["es6.array.every"]),
		      fill: globalOnly(["es6.array.fill"]),
		      filter: globalOnly(["es6.array.filter"]),
		      "finally": globalOnly(["es7.promise.finally"].concat(PromiseDependencies)),
		      find: globalOnly(["es6.array.find"]),
		      findIndex: globalOnly(["es6.array.find-index"]),
		      fixed: globalOnly(["es6.string.fixed"]),
		      flags: globalOnly(["es6.regexp.flags"]),
		      flatMap: globalOnly(["es7.array.flat-map"]),
		      fontcolor: globalOnly(["es6.string.fontcolor"]),
		      fontsize: globalOnly(["es6.string.fontsize"]),
		      forEach: globalOnly(["es6.array.for-each"]),
		      includes: globalOnly(["es6.string.includes", "es7.array.includes"]),
		      indexOf: globalOnly(["es6.array.index-of"]),
		      italics: globalOnly(["es6.string.italics"]),
		      keys: globalOnly(ArrayNatureIterators),
		      lastIndexOf: globalOnly(["es6.array.last-index-of"]),
		      link: globalOnly(["es6.string.link"]),
		      map: globalOnly(["es6.array.map"]),
		      match: globalOnly(["es6.regexp.match"]),
		      name: globalOnly(["es6.function.name"]),
		      padStart: globalOnly(["es7.string.pad-start"]),
		      padEnd: globalOnly(["es7.string.pad-end"]),
		      reduce: globalOnly(["es6.array.reduce"]),
		      reduceRight: globalOnly(["es6.array.reduce-right"]),
		      repeat: globalOnly(["es6.string.repeat"]),
		      replace: globalOnly(["es6.regexp.replace"]),
		      search: globalOnly(["es6.regexp.search"]),
		      small: globalOnly(["es6.string.small"]),
		      some: globalOnly(["es6.array.some"]),
		      sort: globalOnly(["es6.array.sort"]),
		      split: globalOnly(["es6.regexp.split"]),
		      startsWith: globalOnly(["es6.string.starts-with"]),
		      strike: globalOnly(["es6.string.strike"]),
		      sub: globalOnly(["es6.string.sub"]),
		      sup: globalOnly(["es6.string.sup"]),
		      toISOString: globalOnly(["es6.date.to-iso-string"]),
		      toJSON: globalOnly(["es6.date.to-json"]),
		      toString: globalOnly(["es6.object.to-string", "es6.date.to-string", "es6.regexp.to-string"]),
		      trim: globalOnly(["es6.string.trim"]),
		      trimEnd: globalOnly(["es7.string.trim-right"]),
		      trimLeft: globalOnly(["es7.string.trim-left"]),
		      trimRight: globalOnly(["es7.string.trim-right"]),
		      trimStart: globalOnly(["es7.string.trim-left"]),
		      values: globalOnly(ArrayNatureIterators)
		    };
		    builtInDefinitions.InstanceProperties = InstanceProperties;
		    if ("es6.array.slice" in _corejs2BuiltIns["default"]) {
		      InstanceProperties.slice = globalOnly(["es6.array.slice"]);
		    }
		    var StaticProperties = {
		      Array: {
		        from: pureAndGlobal("array/from", ["es6.symbol", "es6.array.from"].concat(_toConsumableArray(CommonIterators))),
		        isArray: pureAndGlobal("array/is-array", ["es6.array.is-array"]),
		        of: pureAndGlobal("array/of", ["es6.array.of"])
		      },
		      Date: {
		        now: pureAndGlobal("date/now", ["es6.date.now"])
		      },
		      JSON: {
		        stringify: pureOnly("json/stringify", "es6.symbol")
		      },
		      Math: {
		        acosh: pureAndGlobal("math/acosh", ["es6.math.acosh"], "7.0.1"),
		        asinh: pureAndGlobal("math/asinh", ["es6.math.asinh"], "7.0.1"),
		        atanh: pureAndGlobal("math/atanh", ["es6.math.atanh"], "7.0.1"),
		        cbrt: pureAndGlobal("math/cbrt", ["es6.math.cbrt"], "7.0.1"),
		        clz32: pureAndGlobal("math/clz32", ["es6.math.clz32"], "7.0.1"),
		        cosh: pureAndGlobal("math/cosh", ["es6.math.cosh"], "7.0.1"),
		        expm1: pureAndGlobal("math/expm1", ["es6.math.expm1"], "7.0.1"),
		        fround: pureAndGlobal("math/fround", ["es6.math.fround"], "7.0.1"),
		        hypot: pureAndGlobal("math/hypot", ["es6.math.hypot"], "7.0.1"),
		        imul: pureAndGlobal("math/imul", ["es6.math.imul"], "7.0.1"),
		        log1p: pureAndGlobal("math/log1p", ["es6.math.log1p"], "7.0.1"),
		        log10: pureAndGlobal("math/log10", ["es6.math.log10"], "7.0.1"),
		        log2: pureAndGlobal("math/log2", ["es6.math.log2"], "7.0.1"),
		        sign: pureAndGlobal("math/sign", ["es6.math.sign"], "7.0.1"),
		        sinh: pureAndGlobal("math/sinh", ["es6.math.sinh"], "7.0.1"),
		        tanh: pureAndGlobal("math/tanh", ["es6.math.tanh"], "7.0.1"),
		        trunc: pureAndGlobal("math/trunc", ["es6.math.trunc"], "7.0.1")
		      },
		      Number: {
		        EPSILON: pureAndGlobal("number/epsilon", ["es6.number.epsilon"]),
		        MIN_SAFE_INTEGER: pureAndGlobal("number/min-safe-integer", ["es6.number.min-safe-integer"]),
		        MAX_SAFE_INTEGER: pureAndGlobal("number/max-safe-integer", ["es6.number.max-safe-integer"]),
		        isFinite: pureAndGlobal("number/is-finite", ["es6.number.is-finite"]),
		        isInteger: pureAndGlobal("number/is-integer", ["es6.number.is-integer"]),
		        isSafeInteger: pureAndGlobal("number/is-safe-integer", ["es6.number.is-safe-integer"]),
		        isNaN: pureAndGlobal("number/is-nan", ["es6.number.is-nan"]),
		        parseFloat: pureAndGlobal("number/parse-float", ["es6.number.parse-float"]),
		        parseInt: pureAndGlobal("number/parse-int", ["es6.number.parse-int"])
		      },
		      Object: {
		        assign: pureAndGlobal("object/assign", ["es6.object.assign"]),
		        create: pureAndGlobal("object/create", ["es6.object.create"]),
		        defineProperties: pureAndGlobal("object/define-properties", ["es6.object.define-properties"]),
		        defineProperty: pureAndGlobal("object/define-property", ["es6.object.define-property"]),
		        entries: pureAndGlobal("object/entries", ["es7.object.entries"]),
		        freeze: pureAndGlobal("object/freeze", ["es6.object.freeze"]),
		        getOwnPropertyDescriptor: pureAndGlobal("object/get-own-property-descriptor", ["es6.object.get-own-property-descriptor"]),
		        getOwnPropertyDescriptors: pureAndGlobal("object/get-own-property-descriptors", ["es7.object.get-own-property-descriptors"]),
		        getOwnPropertyNames: pureAndGlobal("object/get-own-property-names", ["es6.object.get-own-property-names"]),
		        getOwnPropertySymbols: pureAndGlobal("object/get-own-property-symbols", ["es6.symbol"]),
		        getPrototypeOf: pureAndGlobal("object/get-prototype-of", ["es6.object.get-prototype-of"]),
		        is: pureAndGlobal("object/is", ["es6.object.is"]),
		        isExtensible: pureAndGlobal("object/is-extensible", ["es6.object.is-extensible"]),
		        isFrozen: pureAndGlobal("object/is-frozen", ["es6.object.is-frozen"]),
		        isSealed: pureAndGlobal("object/is-sealed", ["es6.object.is-sealed"]),
		        keys: pureAndGlobal("object/keys", ["es6.object.keys"]),
		        preventExtensions: pureAndGlobal("object/prevent-extensions", ["es6.object.prevent-extensions"]),
		        seal: pureAndGlobal("object/seal", ["es6.object.seal"]),
		        setPrototypeOf: pureAndGlobal("object/set-prototype-of", ["es6.object.set-prototype-of"]),
		        values: pureAndGlobal("object/values", ["es7.object.values"])
		      },
		      Promise: {
		        all: globalOnly(CommonIterators),
		        race: globalOnly(CommonIterators)
		      },
		      Reflect: {
		        apply: pureAndGlobal("reflect/apply", ["es6.reflect.apply"]),
		        construct: pureAndGlobal("reflect/construct", ["es6.reflect.construct"]),
		        defineProperty: pureAndGlobal("reflect/define-property", ["es6.reflect.define-property"]),
		        deleteProperty: pureAndGlobal("reflect/delete-property", ["es6.reflect.delete-property"]),
		        get: pureAndGlobal("reflect/get", ["es6.reflect.get"]),
		        getOwnPropertyDescriptor: pureAndGlobal("reflect/get-own-property-descriptor", ["es6.reflect.get-own-property-descriptor"]),
		        getPrototypeOf: pureAndGlobal("reflect/get-prototype-of", ["es6.reflect.get-prototype-of"]),
		        has: pureAndGlobal("reflect/has", ["es6.reflect.has"]),
		        isExtensible: pureAndGlobal("reflect/is-extensible", ["es6.reflect.is-extensible"]),
		        ownKeys: pureAndGlobal("reflect/own-keys", ["es6.reflect.own-keys"]),
		        preventExtensions: pureAndGlobal("reflect/prevent-extensions", ["es6.reflect.prevent-extensions"]),
		        set: pureAndGlobal("reflect/set", ["es6.reflect.set"]),
		        setPrototypeOf: pureAndGlobal("reflect/set-prototype-of", ["es6.reflect.set-prototype-of"])
		      },
		      String: {
		        at: pureOnly("string/at", "es7.string.at"),
		        fromCodePoint: pureAndGlobal("string/from-code-point", ["es6.string.from-code-point"]),
		        raw: pureAndGlobal("string/raw", ["es6.string.raw"])
		      },
		      Symbol: {
		        asyncIterator: globalOnly(["es6.symbol", "es7.symbol.async-iterator"]),
		        "for": pureOnly("symbol/for", "es6.symbol"),
		        hasInstance: pureOnly("symbol/has-instance", "es6.symbol"),
		        isConcatSpreadable: pureOnly("symbol/is-concat-spreadable", "es6.symbol"),
		        iterator: define("es6.symbol", "symbol/iterator", CommonIterators),
		        keyFor: pureOnly("symbol/key-for", "es6.symbol"),
		        match: pureAndGlobal("symbol/match", ["es6.regexp.match"]),
		        replace: pureOnly("symbol/replace", "es6.symbol"),
		        search: pureOnly("symbol/search", "es6.symbol"),
		        species: pureOnly("symbol/species", "es6.symbol"),
		        split: pureOnly("symbol/split", "es6.symbol"),
		        toPrimitive: pureOnly("symbol/to-primitive", "es6.symbol"),
		        toStringTag: pureOnly("symbol/to-string-tag", "es6.symbol"),
		        unscopables: pureOnly("symbol/unscopables", "es6.symbol")
		      }
		    };
		    builtInDefinitions.StaticProperties = StaticProperties;
		    return builtInDefinitions;
		  }

		  var addPlatformSpecificPolyfills = {};

		  var hasRequiredAddPlatformSpecificPolyfills;
		  function requireAddPlatformSpecificPolyfills() {
		    if (hasRequiredAddPlatformSpecificPolyfills) return addPlatformSpecificPolyfills;
		    hasRequiredAddPlatformSpecificPolyfills = 1;
		    addPlatformSpecificPolyfills.__esModule = true;
		    addPlatformSpecificPolyfills["default"] = _default;
		    function _extends() {
		      _extends = Object.assign ? Object.assign.bind() : function (target) {
		        for (var i = 1; i < arguments.length; i++) {
		          var source = arguments[i];
		          for (var key in source) {
		            if (Object.prototype.hasOwnProperty.call(source, key)) {
		              target[key] = source[key];
		            }
		          }
		        }
		        return target;
		      };
		      return _extends.apply(this, arguments);
		    }
		    var webPolyfills = {
		      "web.timers": {},
		      "web.immediate": {},
		      "web.dom.iterable": {}
		    };
		    var purePolyfills = {
		      "es6.parse-float": {},
		      "es6.parse-int": {},
		      "es7.string.at": {}
		    };
		    function _default(targets, method, polyfills) {
		      var targetNames = Object.keys(targets);
		      var isAnyTarget = !targetNames.length;
		      var isWebTarget = targetNames.some(function (name) {
		        return name !== "node";
		      });
		      return _extends({}, polyfills, method === "usage-pure" ? purePolyfills : null, isAnyTarget || isWebTarget ? webPolyfills : null);
		    }
		    return addPlatformSpecificPolyfills;
		  }

		  var helpers = {};

		  var semver = {exports: {}};

		  var hasRequiredSemver;
		  function requireSemver() {
		    if (hasRequiredSemver) return semver.exports;
		    hasRequiredSemver = 1;
		    (function (module, exports) {
		      exports = module.exports = SemVer;
		      var debug;
		      if (typeof browser$1$1 === 'object' && browser$1$1.env && browser$1$1.env.NODE_DEBUG && /\bsemver\b/i.test(browser$1$1.env.NODE_DEBUG)) {
		        debug = function debug() {
		          var args = Array.prototype.slice.call(arguments, 0);
		          args.unshift('SEMVER');
		          console.log.apply(console, args);
		        };
		      } else {
		        debug = function debug() {};
		      }
		      exports.SEMVER_SPEC_VERSION = '2.0.0';
		      var MAX_LENGTH = 256;
		      var MAX_SAFE_INTEGER = Number.MAX_SAFE_INTEGER || 9007199254740991;
		      var MAX_SAFE_COMPONENT_LENGTH = 16;
		      var MAX_SAFE_BUILD_LENGTH = MAX_LENGTH - 6;
		      var re = exports.re = [];
		      var safeRe = exports.safeRe = [];
		      var src = exports.src = [];
		      var t = exports.tokens = {};
		      var R = 0;
		      function tok(n) {
		        t[n] = R++;
		      }
		      var LETTERDASHNUMBER = '[a-zA-Z0-9-]';
		      var safeRegexReplacements = [['\\s', 1], ['\\d', MAX_LENGTH], [LETTERDASHNUMBER, MAX_SAFE_BUILD_LENGTH]];
		      function makeSafeRe(value) {
		        for (var i = 0; i < safeRegexReplacements.length; i++) {
		          var token = safeRegexReplacements[i][0];
		          var max = safeRegexReplacements[i][1];
		          value = value.split(token + '*').join(token + '{0,' + max + '}').split(token + '+').join(token + '{1,' + max + '}');
		        }
		        return value;
		      }
		      tok('NUMERICIDENTIFIER');
		      src[t.NUMERICIDENTIFIER] = '0|[1-9]\\d*';
		      tok('NUMERICIDENTIFIERLOOSE');
		      src[t.NUMERICIDENTIFIERLOOSE] = '\\d+';
		      tok('NONNUMERICIDENTIFIER');
		      src[t.NONNUMERICIDENTIFIER] = '\\d*[a-zA-Z-]' + LETTERDASHNUMBER + '*';
		      tok('MAINVERSION');
		      src[t.MAINVERSION] = '(' + src[t.NUMERICIDENTIFIER] + ')\\.' + '(' + src[t.NUMERICIDENTIFIER] + ')\\.' + '(' + src[t.NUMERICIDENTIFIER] + ')';
		      tok('MAINVERSIONLOOSE');
		      src[t.MAINVERSIONLOOSE] = '(' + src[t.NUMERICIDENTIFIERLOOSE] + ')\\.' + '(' + src[t.NUMERICIDENTIFIERLOOSE] + ')\\.' + '(' + src[t.NUMERICIDENTIFIERLOOSE] + ')';
		      tok('PRERELEASEIDENTIFIER');
		      src[t.PRERELEASEIDENTIFIER] = '(?:' + src[t.NUMERICIDENTIFIER] + '|' + src[t.NONNUMERICIDENTIFIER] + ')';
		      tok('PRERELEASEIDENTIFIERLOOSE');
		      src[t.PRERELEASEIDENTIFIERLOOSE] = '(?:' + src[t.NUMERICIDENTIFIERLOOSE] + '|' + src[t.NONNUMERICIDENTIFIER] + ')';
		      tok('PRERELEASE');
		      src[t.PRERELEASE] = '(?:-(' + src[t.PRERELEASEIDENTIFIER] + '(?:\\.' + src[t.PRERELEASEIDENTIFIER] + ')*))';
		      tok('PRERELEASELOOSE');
		      src[t.PRERELEASELOOSE] = '(?:-?(' + src[t.PRERELEASEIDENTIFIERLOOSE] + '(?:\\.' + src[t.PRERELEASEIDENTIFIERLOOSE] + ')*))';
		      tok('BUILDIDENTIFIER');
		      src[t.BUILDIDENTIFIER] = LETTERDASHNUMBER + '+';
		      tok('BUILD');
		      src[t.BUILD] = '(?:\\+(' + src[t.BUILDIDENTIFIER] + '(?:\\.' + src[t.BUILDIDENTIFIER] + ')*))';
		      tok('FULL');
		      tok('FULLPLAIN');
		      src[t.FULLPLAIN] = 'v?' + src[t.MAINVERSION] + src[t.PRERELEASE] + '?' + src[t.BUILD] + '?';
		      src[t.FULL] = '^' + src[t.FULLPLAIN] + '$';
		      tok('LOOSEPLAIN');
		      src[t.LOOSEPLAIN] = '[v=\\s]*' + src[t.MAINVERSIONLOOSE] + src[t.PRERELEASELOOSE] + '?' + src[t.BUILD] + '?';
		      tok('LOOSE');
		      src[t.LOOSE] = '^' + src[t.LOOSEPLAIN] + '$';
		      tok('GTLT');
		      src[t.GTLT] = '((?:<|>)?=?)';
		      tok('XRANGEIDENTIFIERLOOSE');
		      src[t.XRANGEIDENTIFIERLOOSE] = src[t.NUMERICIDENTIFIERLOOSE] + '|x|X|\\*';
		      tok('XRANGEIDENTIFIER');
		      src[t.XRANGEIDENTIFIER] = src[t.NUMERICIDENTIFIER] + '|x|X|\\*';
		      tok('XRANGEPLAIN');
		      src[t.XRANGEPLAIN] = '[v=\\s]*(' + src[t.XRANGEIDENTIFIER] + ')' + '(?:\\.(' + src[t.XRANGEIDENTIFIER] + ')' + '(?:\\.(' + src[t.XRANGEIDENTIFIER] + ')' + '(?:' + src[t.PRERELEASE] + ')?' + src[t.BUILD] + '?' + ')?)?';
		      tok('XRANGEPLAINLOOSE');
		      src[t.XRANGEPLAINLOOSE] = '[v=\\s]*(' + src[t.XRANGEIDENTIFIERLOOSE] + ')' + '(?:\\.(' + src[t.XRANGEIDENTIFIERLOOSE] + ')' + '(?:\\.(' + src[t.XRANGEIDENTIFIERLOOSE] + ')' + '(?:' + src[t.PRERELEASELOOSE] + ')?' + src[t.BUILD] + '?' + ')?)?';
		      tok('XRANGE');
		      src[t.XRANGE] = '^' + src[t.GTLT] + '\\s*' + src[t.XRANGEPLAIN] + '$';
		      tok('XRANGELOOSE');
		      src[t.XRANGELOOSE] = '^' + src[t.GTLT] + '\\s*' + src[t.XRANGEPLAINLOOSE] + '$';
		      tok('COERCE');
		      src[t.COERCE] = '(^|[^\\d])' + '(\\d{1,' + MAX_SAFE_COMPONENT_LENGTH + '})' + '(?:\\.(\\d{1,' + MAX_SAFE_COMPONENT_LENGTH + '}))?' + '(?:\\.(\\d{1,' + MAX_SAFE_COMPONENT_LENGTH + '}))?' + '(?:$|[^\\d])';
		      tok('COERCERTL');
		      re[t.COERCERTL] = new RegExp(src[t.COERCE], 'g');
		      safeRe[t.COERCERTL] = new RegExp(makeSafeRe(src[t.COERCE]), 'g');
		      tok('LONETILDE');
		      src[t.LONETILDE] = '(?:~>?)';
		      tok('TILDETRIM');
		      src[t.TILDETRIM] = '(\\s*)' + src[t.LONETILDE] + '\\s+';
		      re[t.TILDETRIM] = new RegExp(src[t.TILDETRIM], 'g');
		      safeRe[t.TILDETRIM] = new RegExp(makeSafeRe(src[t.TILDETRIM]), 'g');
		      var tildeTrimReplace = '$1~';
		      tok('TILDE');
		      src[t.TILDE] = '^' + src[t.LONETILDE] + src[t.XRANGEPLAIN] + '$';
		      tok('TILDELOOSE');
		      src[t.TILDELOOSE] = '^' + src[t.LONETILDE] + src[t.XRANGEPLAINLOOSE] + '$';
		      tok('LONECARET');
		      src[t.LONECARET] = '(?:\\^)';
		      tok('CARETTRIM');
		      src[t.CARETTRIM] = '(\\s*)' + src[t.LONECARET] + '\\s+';
		      re[t.CARETTRIM] = new RegExp(src[t.CARETTRIM], 'g');
		      safeRe[t.CARETTRIM] = new RegExp(makeSafeRe(src[t.CARETTRIM]), 'g');
		      var caretTrimReplace = '$1^';
		      tok('CARET');
		      src[t.CARET] = '^' + src[t.LONECARET] + src[t.XRANGEPLAIN] + '$';
		      tok('CARETLOOSE');
		      src[t.CARETLOOSE] = '^' + src[t.LONECARET] + src[t.XRANGEPLAINLOOSE] + '$';
		      tok('COMPARATORLOOSE');
		      src[t.COMPARATORLOOSE] = '^' + src[t.GTLT] + '\\s*(' + src[t.LOOSEPLAIN] + ')$|^$';
		      tok('COMPARATOR');
		      src[t.COMPARATOR] = '^' + src[t.GTLT] + '\\s*(' + src[t.FULLPLAIN] + ')$|^$';
		      tok('COMPARATORTRIM');
		      src[t.COMPARATORTRIM] = '(\\s*)' + src[t.GTLT] + '\\s*(' + src[t.LOOSEPLAIN] + '|' + src[t.XRANGEPLAIN] + ')';
		      re[t.COMPARATORTRIM] = new RegExp(src[t.COMPARATORTRIM], 'g');
		      safeRe[t.COMPARATORTRIM] = new RegExp(makeSafeRe(src[t.COMPARATORTRIM]), 'g');
		      var comparatorTrimReplace = '$1$2$3';
		      tok('HYPHENRANGE');
		      src[t.HYPHENRANGE] = '^\\s*(' + src[t.XRANGEPLAIN] + ')' + '\\s+-\\s+' + '(' + src[t.XRANGEPLAIN] + ')' + '\\s*$';
		      tok('HYPHENRANGELOOSE');
		      src[t.HYPHENRANGELOOSE] = '^\\s*(' + src[t.XRANGEPLAINLOOSE] + ')' + '\\s+-\\s+' + '(' + src[t.XRANGEPLAINLOOSE] + ')' + '\\s*$';
		      tok('STAR');
		      src[t.STAR] = '(<|>)?=?\\s*\\*';
		      for (var i = 0; i < R; i++) {
		        debug(i, src[i]);
		        if (!re[i]) {
		          re[i] = new RegExp(src[i]);
		          safeRe[i] = new RegExp(makeSafeRe(src[i]));
		        }
		      }
		      exports.parse = parse;
		      function parse(version, options) {
		        if (!options || typeof options !== 'object') {
		          options = {
		            loose: !!options,
		            includePrerelease: false
		          };
		        }
		        if (version instanceof SemVer) {
		          return version;
		        }
		        if (typeof version !== 'string') {
		          return null;
		        }
		        if (version.length > MAX_LENGTH) {
		          return null;
		        }
		        var r = options.loose ? safeRe[t.LOOSE] : safeRe[t.FULL];
		        if (!r.test(version)) {
		          return null;
		        }
		        try {
		          return new SemVer(version, options);
		        } catch (er) {
		          return null;
		        }
		      }
		      exports.valid = valid;
		      function valid(version, options) {
		        var v = parse(version, options);
		        return v ? v.version : null;
		      }
		      exports.clean = clean;
		      function clean(version, options) {
		        var s = parse(version.trim().replace(/^[=v]+/, ''), options);
		        return s ? s.version : null;
		      }
		      exports.SemVer = SemVer;
		      function SemVer(version, options) {
		        if (!options || typeof options !== 'object') {
		          options = {
		            loose: !!options,
		            includePrerelease: false
		          };
		        }
		        if (version instanceof SemVer) {
		          if (version.loose === options.loose) {
		            return version;
		          } else {
		            version = version.version;
		          }
		        } else if (typeof version !== 'string') {
		          throw new TypeError('Invalid Version: ' + version);
		        }
		        if (version.length > MAX_LENGTH) {
		          throw new TypeError('version is longer than ' + MAX_LENGTH + ' characters');
		        }
		        if (!(this instanceof SemVer)) {
		          return new SemVer(version, options);
		        }
		        debug('SemVer', version, options);
		        this.options = options;
		        this.loose = !!options.loose;
		        var m = version.trim().match(options.loose ? safeRe[t.LOOSE] : safeRe[t.FULL]);
		        if (!m) {
		          throw new TypeError('Invalid Version: ' + version);
		        }
		        this.raw = version;
		        this.major = +m[1];
		        this.minor = +m[2];
		        this.patch = +m[3];
		        if (this.major > MAX_SAFE_INTEGER || this.major < 0) {
		          throw new TypeError('Invalid major version');
		        }
		        if (this.minor > MAX_SAFE_INTEGER || this.minor < 0) {
		          throw new TypeError('Invalid minor version');
		        }
		        if (this.patch > MAX_SAFE_INTEGER || this.patch < 0) {
		          throw new TypeError('Invalid patch version');
		        }
		        if (!m[4]) {
		          this.prerelease = [];
		        } else {
		          this.prerelease = m[4].split('.').map(function (id) {
		            if (/^[0-9]+$/.test(id)) {
		              var num = +id;
		              if (num >= 0 && num < MAX_SAFE_INTEGER) {
		                return num;
		              }
		            }
		            return id;
		          });
		        }
		        this.build = m[5] ? m[5].split('.') : [];
		        this.format();
		      }
		      SemVer.prototype.format = function () {
		        this.version = this.major + '.' + this.minor + '.' + this.patch;
		        if (this.prerelease.length) {
		          this.version += '-' + this.prerelease.join('.');
		        }
		        return this.version;
		      };
		      SemVer.prototype.toString = function () {
		        return this.version;
		      };
		      SemVer.prototype.compare = function (other) {
		        debug('SemVer.compare', this.version, this.options, other);
		        if (!(other instanceof SemVer)) {
		          other = new SemVer(other, this.options);
		        }
		        return this.compareMain(other) || this.comparePre(other);
		      };
		      SemVer.prototype.compareMain = function (other) {
		        if (!(other instanceof SemVer)) {
		          other = new SemVer(other, this.options);
		        }
		        return compareIdentifiers(this.major, other.major) || compareIdentifiers(this.minor, other.minor) || compareIdentifiers(this.patch, other.patch);
		      };
		      SemVer.prototype.comparePre = function (other) {
		        if (!(other instanceof SemVer)) {
		          other = new SemVer(other, this.options);
		        }
		        if (this.prerelease.length && !other.prerelease.length) {
		          return -1;
		        } else if (!this.prerelease.length && other.prerelease.length) {
		          return 1;
		        } else if (!this.prerelease.length && !other.prerelease.length) {
		          return 0;
		        }
		        var i = 0;
		        do {
		          var a = this.prerelease[i];
		          var b = other.prerelease[i];
		          debug('prerelease compare', i, a, b);
		          if (a === undefined && b === undefined) {
		            return 0;
		          } else if (b === undefined) {
		            return 1;
		          } else if (a === undefined) {
		            return -1;
		          } else if (a === b) {
		            continue;
		          } else {
		            return compareIdentifiers(a, b);
		          }
		        } while (++i);
		      };
		      SemVer.prototype.compareBuild = function (other) {
		        if (!(other instanceof SemVer)) {
		          other = new SemVer(other, this.options);
		        }
		        var i = 0;
		        do {
		          var a = this.build[i];
		          var b = other.build[i];
		          debug('prerelease compare', i, a, b);
		          if (a === undefined && b === undefined) {
		            return 0;
		          } else if (b === undefined) {
		            return 1;
		          } else if (a === undefined) {
		            return -1;
		          } else if (a === b) {
		            continue;
		          } else {
		            return compareIdentifiers(a, b);
		          }
		        } while (++i);
		      };
		      SemVer.prototype.inc = function (release, identifier) {
		        switch (release) {
		          case 'premajor':
		            this.prerelease.length = 0;
		            this.patch = 0;
		            this.minor = 0;
		            this.major++;
		            this.inc('pre', identifier);
		            break;
		          case 'preminor':
		            this.prerelease.length = 0;
		            this.patch = 0;
		            this.minor++;
		            this.inc('pre', identifier);
		            break;
		          case 'prepatch':
		            this.prerelease.length = 0;
		            this.inc('patch', identifier);
		            this.inc('pre', identifier);
		            break;
		          case 'prerelease':
		            if (this.prerelease.length === 0) {
		              this.inc('patch', identifier);
		            }
		            this.inc('pre', identifier);
		            break;
		          case 'major':
		            if (this.minor !== 0 || this.patch !== 0 || this.prerelease.length === 0) {
		              this.major++;
		            }
		            this.minor = 0;
		            this.patch = 0;
		            this.prerelease = [];
		            break;
		          case 'minor':
		            if (this.patch !== 0 || this.prerelease.length === 0) {
		              this.minor++;
		            }
		            this.patch = 0;
		            this.prerelease = [];
		            break;
		          case 'patch':
		            if (this.prerelease.length === 0) {
		              this.patch++;
		            }
		            this.prerelease = [];
		            break;
		          case 'pre':
		            if (this.prerelease.length === 0) {
		              this.prerelease = [0];
		            } else {
		              var i = this.prerelease.length;
		              while (--i >= 0) {
		                if (typeof this.prerelease[i] === 'number') {
		                  this.prerelease[i]++;
		                  i = -2;
		                }
		              }
		              if (i === -1) {
		                this.prerelease.push(0);
		              }
		            }
		            if (identifier) {
		              if (this.prerelease[0] === identifier) {
		                if (isNaN(this.prerelease[1])) {
		                  this.prerelease = [identifier, 0];
		                }
		              } else {
		                this.prerelease = [identifier, 0];
		              }
		            }
		            break;
		          default:
		            throw new Error('invalid increment argument: ' + release);
		        }
		        this.format();
		        this.raw = this.version;
		        return this;
		      };
		      exports.inc = inc;
		      function inc(version, release, loose, identifier) {
		        if (typeof loose === 'string') {
		          identifier = loose;
		          loose = undefined;
		        }
		        try {
		          return new SemVer(version, loose).inc(release, identifier).version;
		        } catch (er) {
		          return null;
		        }
		      }
		      exports.diff = diff;
		      function diff(version1, version2) {
		        if (eq(version1, version2)) {
		          return null;
		        } else {
		          var v1 = parse(version1);
		          var v2 = parse(version2);
		          var prefix = '';
		          if (v1.prerelease.length || v2.prerelease.length) {
		            prefix = 'pre';
		            var defaultResult = 'prerelease';
		          }
		          for (var key in v1) {
		            if (key === 'major' || key === 'minor' || key === 'patch') {
		              if (v1[key] !== v2[key]) {
		                return prefix + key;
		              }
		            }
		          }
		          return defaultResult;
		        }
		      }
		      exports.compareIdentifiers = compareIdentifiers;
		      var numeric = /^[0-9]+$/;
		      function compareIdentifiers(a, b) {
		        var anum = numeric.test(a);
		        var bnum = numeric.test(b);
		        if (anum && bnum) {
		          a = +a;
		          b = +b;
		        }
		        return a === b ? 0 : anum && !bnum ? -1 : bnum && !anum ? 1 : a < b ? -1 : 1;
		      }
		      exports.rcompareIdentifiers = rcompareIdentifiers;
		      function rcompareIdentifiers(a, b) {
		        return compareIdentifiers(b, a);
		      }
		      exports.major = major;
		      function major(a, loose) {
		        return new SemVer(a, loose).major;
		      }
		      exports.minor = minor;
		      function minor(a, loose) {
		        return new SemVer(a, loose).minor;
		      }
		      exports.patch = patch;
		      function patch(a, loose) {
		        return new SemVer(a, loose).patch;
		      }
		      exports.compare = compare;
		      function compare(a, b, loose) {
		        return new SemVer(a, loose).compare(new SemVer(b, loose));
		      }
		      exports.compareLoose = compareLoose;
		      function compareLoose(a, b) {
		        return compare(a, b, true);
		      }
		      exports.compareBuild = compareBuild;
		      function compareBuild(a, b, loose) {
		        var versionA = new SemVer(a, loose);
		        var versionB = new SemVer(b, loose);
		        return versionA.compare(versionB) || versionA.compareBuild(versionB);
		      }
		      exports.rcompare = rcompare;
		      function rcompare(a, b, loose) {
		        return compare(b, a, loose);
		      }
		      exports.sort = sort;
		      function sort(list, loose) {
		        return list.sort(function (a, b) {
		          return exports.compareBuild(a, b, loose);
		        });
		      }
		      exports.rsort = rsort;
		      function rsort(list, loose) {
		        return list.sort(function (a, b) {
		          return exports.compareBuild(b, a, loose);
		        });
		      }
		      exports.gt = gt;
		      function gt(a, b, loose) {
		        return compare(a, b, loose) > 0;
		      }
		      exports.lt = lt;
		      function lt(a, b, loose) {
		        return compare(a, b, loose) < 0;
		      }
		      exports.eq = eq;
		      function eq(a, b, loose) {
		        return compare(a, b, loose) === 0;
		      }
		      exports.neq = neq;
		      function neq(a, b, loose) {
		        return compare(a, b, loose) !== 0;
		      }
		      exports.gte = gte;
		      function gte(a, b, loose) {
		        return compare(a, b, loose) >= 0;
		      }
		      exports.lte = lte;
		      function lte(a, b, loose) {
		        return compare(a, b, loose) <= 0;
		      }
		      exports.cmp = cmp;
		      function cmp(a, op, b, loose) {
		        switch (op) {
		          case '===':
		            if (typeof a === 'object') a = a.version;
		            if (typeof b === 'object') b = b.version;
		            return a === b;
		          case '!==':
		            if (typeof a === 'object') a = a.version;
		            if (typeof b === 'object') b = b.version;
		            return a !== b;
		          case '':
		          case '=':
		          case '==':
		            return eq(a, b, loose);
		          case '!=':
		            return neq(a, b, loose);
		          case '>':
		            return gt(a, b, loose);
		          case '>=':
		            return gte(a, b, loose);
		          case '<':
		            return lt(a, b, loose);
		          case '<=':
		            return lte(a, b, loose);
		          default:
		            throw new TypeError('Invalid operator: ' + op);
		        }
		      }
		      exports.Comparator = Comparator;
		      function Comparator(comp, options) {
		        if (!options || typeof options !== 'object') {
		          options = {
		            loose: !!options,
		            includePrerelease: false
		          };
		        }
		        if (comp instanceof Comparator) {
		          if (comp.loose === !!options.loose) {
		            return comp;
		          } else {
		            comp = comp.value;
		          }
		        }
		        if (!(this instanceof Comparator)) {
		          return new Comparator(comp, options);
		        }
		        comp = comp.trim().split(/\s+/).join(' ');
		        debug('comparator', comp, options);
		        this.options = options;
		        this.loose = !!options.loose;
		        this.parse(comp);
		        if (this.semver === ANY) {
		          this.value = '';
		        } else {
		          this.value = this.operator + this.semver.version;
		        }
		        debug('comp', this);
		      }
		      var ANY = {};
		      Comparator.prototype.parse = function (comp) {
		        var r = this.options.loose ? safeRe[t.COMPARATORLOOSE] : safeRe[t.COMPARATOR];
		        var m = comp.match(r);
		        if (!m) {
		          throw new TypeError('Invalid comparator: ' + comp);
		        }
		        this.operator = m[1] !== undefined ? m[1] : '';
		        if (this.operator === '=') {
		          this.operator = '';
		        }
		        if (!m[2]) {
		          this.semver = ANY;
		        } else {
		          this.semver = new SemVer(m[2], this.options.loose);
		        }
		      };
		      Comparator.prototype.toString = function () {
		        return this.value;
		      };
		      Comparator.prototype.test = function (version) {
		        debug('Comparator.test', version, this.options.loose);
		        if (this.semver === ANY || version === ANY) {
		          return true;
		        }
		        if (typeof version === 'string') {
		          try {
		            version = new SemVer(version, this.options);
		          } catch (er) {
		            return false;
		          }
		        }
		        return cmp(version, this.operator, this.semver, this.options);
		      };
		      Comparator.prototype.intersects = function (comp, options) {
		        if (!(comp instanceof Comparator)) {
		          throw new TypeError('a Comparator is required');
		        }
		        if (!options || typeof options !== 'object') {
		          options = {
		            loose: !!options,
		            includePrerelease: false
		          };
		        }
		        var rangeTmp;
		        if (this.operator === '') {
		          if (this.value === '') {
		            return true;
		          }
		          rangeTmp = new Range(comp.value, options);
		          return satisfies(this.value, rangeTmp, options);
		        } else if (comp.operator === '') {
		          if (comp.value === '') {
		            return true;
		          }
		          rangeTmp = new Range(this.value, options);
		          return satisfies(comp.semver, rangeTmp, options);
		        }
		        var sameDirectionIncreasing = (this.operator === '>=' || this.operator === '>') && (comp.operator === '>=' || comp.operator === '>');
		        var sameDirectionDecreasing = (this.operator === '<=' || this.operator === '<') && (comp.operator === '<=' || comp.operator === '<');
		        var sameSemVer = this.semver.version === comp.semver.version;
		        var differentDirectionsInclusive = (this.operator === '>=' || this.operator === '<=') && (comp.operator === '>=' || comp.operator === '<=');
		        var oppositeDirectionsLessThan = cmp(this.semver, '<', comp.semver, options) && (this.operator === '>=' || this.operator === '>') && (comp.operator === '<=' || comp.operator === '<');
		        var oppositeDirectionsGreaterThan = cmp(this.semver, '>', comp.semver, options) && (this.operator === '<=' || this.operator === '<') && (comp.operator === '>=' || comp.operator === '>');
		        return sameDirectionIncreasing || sameDirectionDecreasing || sameSemVer && differentDirectionsInclusive || oppositeDirectionsLessThan || oppositeDirectionsGreaterThan;
		      };
		      exports.Range = Range;
		      function Range(range, options) {
		        if (!options || typeof options !== 'object') {
		          options = {
		            loose: !!options,
		            includePrerelease: false
		          };
		        }
		        if (range instanceof Range) {
		          if (range.loose === !!options.loose && range.includePrerelease === !!options.includePrerelease) {
		            return range;
		          } else {
		            return new Range(range.raw, options);
		          }
		        }
		        if (range instanceof Comparator) {
		          return new Range(range.value, options);
		        }
		        if (!(this instanceof Range)) {
		          return new Range(range, options);
		        }
		        this.options = options;
		        this.loose = !!options.loose;
		        this.includePrerelease = !!options.includePrerelease;
		        this.raw = range.trim().split(/\s+/).join(' ');
		        this.set = this.raw.split('||').map(function (range) {
		          return this.parseRange(range.trim());
		        }, this).filter(function (c) {
		          return c.length;
		        });
		        if (!this.set.length) {
		          throw new TypeError('Invalid SemVer Range: ' + this.raw);
		        }
		        this.format();
		      }
		      Range.prototype.format = function () {
		        this.range = this.set.map(function (comps) {
		          return comps.join(' ').trim();
		        }).join('||').trim();
		        return this.range;
		      };
		      Range.prototype.toString = function () {
		        return this.range;
		      };
		      Range.prototype.parseRange = function (range) {
		        var loose = this.options.loose;
		        var hr = loose ? safeRe[t.HYPHENRANGELOOSE] : safeRe[t.HYPHENRANGE];
		        range = range.replace(hr, hyphenReplace);
		        debug('hyphen replace', range);
		        range = range.replace(safeRe[t.COMPARATORTRIM], comparatorTrimReplace);
		        debug('comparator trim', range, safeRe[t.COMPARATORTRIM]);
		        range = range.replace(safeRe[t.TILDETRIM], tildeTrimReplace);
		        range = range.replace(safeRe[t.CARETTRIM], caretTrimReplace);
		        range = range.split(/\s+/).join(' ');
		        var compRe = loose ? safeRe[t.COMPARATORLOOSE] : safeRe[t.COMPARATOR];
		        var set = range.split(' ').map(function (comp) {
		          return parseComparator(comp, this.options);
		        }, this).join(' ').split(/\s+/);
		        if (this.options.loose) {
		          set = set.filter(function (comp) {
		            return !!comp.match(compRe);
		          });
		        }
		        set = set.map(function (comp) {
		          return new Comparator(comp, this.options);
		        }, this);
		        return set;
		      };
		      Range.prototype.intersects = function (range, options) {
		        if (!(range instanceof Range)) {
		          throw new TypeError('a Range is required');
		        }
		        return this.set.some(function (thisComparators) {
		          return isSatisfiable(thisComparators, options) && range.set.some(function (rangeComparators) {
		            return isSatisfiable(rangeComparators, options) && thisComparators.every(function (thisComparator) {
		              return rangeComparators.every(function (rangeComparator) {
		                return thisComparator.intersects(rangeComparator, options);
		              });
		            });
		          });
		        });
		      };
		      function isSatisfiable(comparators, options) {
		        var result = true;
		        var remainingComparators = comparators.slice();
		        var testComparator = remainingComparators.pop();
		        while (result && remainingComparators.length) {
		          result = remainingComparators.every(function (otherComparator) {
		            return testComparator.intersects(otherComparator, options);
		          });
		          testComparator = remainingComparators.pop();
		        }
		        return result;
		      }
		      exports.toComparators = toComparators;
		      function toComparators(range, options) {
		        return new Range(range, options).set.map(function (comp) {
		          return comp.map(function (c) {
		            return c.value;
		          }).join(' ').trim().split(' ');
		        });
		      }
		      function parseComparator(comp, options) {
		        debug('comp', comp, options);
		        comp = replaceCarets(comp, options);
		        debug('caret', comp);
		        comp = replaceTildes(comp, options);
		        debug('tildes', comp);
		        comp = replaceXRanges(comp, options);
		        debug('xrange', comp);
		        comp = replaceStars(comp, options);
		        debug('stars', comp);
		        return comp;
		      }
		      function isX(id) {
		        return !id || id.toLowerCase() === 'x' || id === '*';
		      }
		      function replaceTildes(comp, options) {
		        return comp.trim().split(/\s+/).map(function (comp) {
		          return replaceTilde(comp, options);
		        }).join(' ');
		      }
		      function replaceTilde(comp, options) {
		        var r = options.loose ? safeRe[t.TILDELOOSE] : safeRe[t.TILDE];
		        return comp.replace(r, function (_, M, m, p, pr) {
		          debug('tilde', comp, _, M, m, p, pr);
		          var ret;
		          if (isX(M)) {
		            ret = '';
		          } else if (isX(m)) {
		            ret = '>=' + M + '.0.0 <' + (+M + 1) + '.0.0';
		          } else if (isX(p)) {
		            ret = '>=' + M + '.' + m + '.0 <' + M + '.' + (+m + 1) + '.0';
		          } else if (pr) {
		            debug('replaceTilde pr', pr);
		            ret = '>=' + M + '.' + m + '.' + p + '-' + pr + ' <' + M + '.' + (+m + 1) + '.0';
		          } else {
		            ret = '>=' + M + '.' + m + '.' + p + ' <' + M + '.' + (+m + 1) + '.0';
		          }
		          debug('tilde return', ret);
		          return ret;
		        });
		      }
		      function replaceCarets(comp, options) {
		        return comp.trim().split(/\s+/).map(function (comp) {
		          return replaceCaret(comp, options);
		        }).join(' ');
		      }
		      function replaceCaret(comp, options) {
		        debug('caret', comp, options);
		        var r = options.loose ? safeRe[t.CARETLOOSE] : safeRe[t.CARET];
		        return comp.replace(r, function (_, M, m, p, pr) {
		          debug('caret', comp, _, M, m, p, pr);
		          var ret;
		          if (isX(M)) {
		            ret = '';
		          } else if (isX(m)) {
		            ret = '>=' + M + '.0.0 <' + (+M + 1) + '.0.0';
		          } else if (isX(p)) {
		            if (M === '0') {
		              ret = '>=' + M + '.' + m + '.0 <' + M + '.' + (+m + 1) + '.0';
		            } else {
		              ret = '>=' + M + '.' + m + '.0 <' + (+M + 1) + '.0.0';
		            }
		          } else if (pr) {
		            debug('replaceCaret pr', pr);
		            if (M === '0') {
		              if (m === '0') {
		                ret = '>=' + M + '.' + m + '.' + p + '-' + pr + ' <' + M + '.' + m + '.' + (+p + 1);
		              } else {
		                ret = '>=' + M + '.' + m + '.' + p + '-' + pr + ' <' + M + '.' + (+m + 1) + '.0';
		              }
		            } else {
		              ret = '>=' + M + '.' + m + '.' + p + '-' + pr + ' <' + (+M + 1) + '.0.0';
		            }
		          } else {
		            debug('no pr');
		            if (M === '0') {
		              if (m === '0') {
		                ret = '>=' + M + '.' + m + '.' + p + ' <' + M + '.' + m + '.' + (+p + 1);
		              } else {
		                ret = '>=' + M + '.' + m + '.' + p + ' <' + M + '.' + (+m + 1) + '.0';
		              }
		            } else {
		              ret = '>=' + M + '.' + m + '.' + p + ' <' + (+M + 1) + '.0.0';
		            }
		          }
		          debug('caret return', ret);
		          return ret;
		        });
		      }
		      function replaceXRanges(comp, options) {
		        debug('replaceXRanges', comp, options);
		        return comp.split(/\s+/).map(function (comp) {
		          return replaceXRange(comp, options);
		        }).join(' ');
		      }
		      function replaceXRange(comp, options) {
		        comp = comp.trim();
		        var r = options.loose ? safeRe[t.XRANGELOOSE] : safeRe[t.XRANGE];
		        return comp.replace(r, function (ret, gtlt, M, m, p, pr) {
		          debug('xRange', comp, ret, gtlt, M, m, p, pr);
		          var xM = isX(M);
		          var xm = xM || isX(m);
		          var xp = xm || isX(p);
		          var anyX = xp;
		          if (gtlt === '=' && anyX) {
		            gtlt = '';
		          }
		          pr = options.includePrerelease ? '-0' : '';
		          if (xM) {
		            if (gtlt === '>' || gtlt === '<') {
		              ret = '<0.0.0-0';
		            } else {
		              ret = '*';
		            }
		          } else if (gtlt && anyX) {
		            if (xm) {
		              m = 0;
		            }
		            p = 0;
		            if (gtlt === '>') {
		              gtlt = '>=';
		              if (xm) {
		                M = +M + 1;
		                m = 0;
		                p = 0;
		              } else {
		                m = +m + 1;
		                p = 0;
		              }
		            } else if (gtlt === '<=') {
		              gtlt = '<';
		              if (xm) {
		                M = +M + 1;
		              } else {
		                m = +m + 1;
		              }
		            }
		            ret = gtlt + M + '.' + m + '.' + p + pr;
		          } else if (xm) {
		            ret = '>=' + M + '.0.0' + pr + ' <' + (+M + 1) + '.0.0' + pr;
		          } else if (xp) {
		            ret = '>=' + M + '.' + m + '.0' + pr + ' <' + M + '.' + (+m + 1) + '.0' + pr;
		          }
		          debug('xRange return', ret);
		          return ret;
		        });
		      }
		      function replaceStars(comp, options) {
		        debug('replaceStars', comp, options);
		        return comp.trim().replace(safeRe[t.STAR], '');
		      }
		      function hyphenReplace($0, from, fM, fm, fp, fpr, fb, to, tM, tm, tp, tpr, tb) {
		        if (isX(fM)) {
		          from = '';
		        } else if (isX(fm)) {
		          from = '>=' + fM + '.0.0';
		        } else if (isX(fp)) {
		          from = '>=' + fM + '.' + fm + '.0';
		        } else {
		          from = '>=' + from;
		        }
		        if (isX(tM)) {
		          to = '';
		        } else if (isX(tm)) {
		          to = '<' + (+tM + 1) + '.0.0';
		        } else if (isX(tp)) {
		          to = '<' + tM + '.' + (+tm + 1) + '.0';
		        } else if (tpr) {
		          to = '<=' + tM + '.' + tm + '.' + tp + '-' + tpr;
		        } else {
		          to = '<=' + to;
		        }
		        return (from + ' ' + to).trim();
		      }
		      Range.prototype.test = function (version) {
		        if (!version) {
		          return false;
		        }
		        if (typeof version === 'string') {
		          try {
		            version = new SemVer(version, this.options);
		          } catch (er) {
		            return false;
		          }
		        }
		        for (var i = 0; i < this.set.length; i++) {
		          if (testSet(this.set[i], version, this.options)) {
		            return true;
		          }
		        }
		        return false;
		      };
		      function testSet(set, version, options) {
		        for (var i = 0; i < set.length; i++) {
		          if (!set[i].test(version)) {
		            return false;
		          }
		        }
		        if (version.prerelease.length && !options.includePrerelease) {
		          for (i = 0; i < set.length; i++) {
		            debug(set[i].semver);
		            if (set[i].semver === ANY) {
		              continue;
		            }
		            if (set[i].semver.prerelease.length > 0) {
		              var allowed = set[i].semver;
		              if (allowed.major === version.major && allowed.minor === version.minor && allowed.patch === version.patch) {
		                return true;
		              }
		            }
		          }
		          return false;
		        }
		        return true;
		      }
		      exports.satisfies = satisfies;
		      function satisfies(version, range, options) {
		        try {
		          range = new Range(range, options);
		        } catch (er) {
		          return false;
		        }
		        return range.test(version);
		      }
		      exports.maxSatisfying = maxSatisfying;
		      function maxSatisfying(versions, range, options) {
		        var max = null;
		        var maxSV = null;
		        try {
		          var rangeObj = new Range(range, options);
		        } catch (er) {
		          return null;
		        }
		        versions.forEach(function (v) {
		          if (rangeObj.test(v)) {
		            if (!max || maxSV.compare(v) === -1) {
		              max = v;
		              maxSV = new SemVer(max, options);
		            }
		          }
		        });
		        return max;
		      }
		      exports.minSatisfying = minSatisfying;
		      function minSatisfying(versions, range, options) {
		        var min = null;
		        var minSV = null;
		        try {
		          var rangeObj = new Range(range, options);
		        } catch (er) {
		          return null;
		        }
		        versions.forEach(function (v) {
		          if (rangeObj.test(v)) {
		            if (!min || minSV.compare(v) === 1) {
		              min = v;
		              minSV = new SemVer(min, options);
		            }
		          }
		        });
		        return min;
		      }
		      exports.minVersion = minVersion;
		      function minVersion(range, loose) {
		        range = new Range(range, loose);
		        var minver = new SemVer('0.0.0');
		        if (range.test(minver)) {
		          return minver;
		        }
		        minver = new SemVer('0.0.0-0');
		        if (range.test(minver)) {
		          return minver;
		        }
		        minver = null;
		        for (var i = 0; i < range.set.length; ++i) {
		          var comparators = range.set[i];
		          comparators.forEach(function (comparator) {
		            var compver = new SemVer(comparator.semver.version);
		            switch (comparator.operator) {
		              case '>':
		                if (compver.prerelease.length === 0) {
		                  compver.patch++;
		                } else {
		                  compver.prerelease.push(0);
		                }
		                compver.raw = compver.format();
		              case '':
		              case '>=':
		                if (!minver || gt(minver, compver)) {
		                  minver = compver;
		                }
		                break;
		              case '<':
		              case '<=':
		                break;
		              default:
		                throw new Error('Unexpected operation: ' + comparator.operator);
		            }
		          });
		        }
		        if (minver && range.test(minver)) {
		          return minver;
		        }
		        return null;
		      }
		      exports.validRange = validRange;
		      function validRange(range, options) {
		        try {
		          return new Range(range, options).range || '*';
		        } catch (er) {
		          return null;
		        }
		      }
		      exports.ltr = ltr;
		      function ltr(version, range, options) {
		        return outside(version, range, '<', options);
		      }
		      exports.gtr = gtr;
		      function gtr(version, range, options) {
		        return outside(version, range, '>', options);
		      }
		      exports.outside = outside;
		      function outside(version, range, hilo, options) {
		        version = new SemVer(version, options);
		        range = new Range(range, options);
		        var gtfn, ltefn, ltfn, comp, ecomp;
		        switch (hilo) {
		          case '>':
		            gtfn = gt;
		            ltefn = lte;
		            ltfn = lt;
		            comp = '>';
		            ecomp = '>=';
		            break;
		          case '<':
		            gtfn = lt;
		            ltefn = gte;
		            ltfn = gt;
		            comp = '<';
		            ecomp = '<=';
		            break;
		          default:
		            throw new TypeError('Must provide a hilo val of "<" or ">"');
		        }
		        if (satisfies(version, range, options)) {
		          return false;
		        }
		        for (var i = 0; i < range.set.length; ++i) {
		          var comparators = range.set[i];
		          var high = null;
		          var low = null;
		          comparators.forEach(function (comparator) {
		            if (comparator.semver === ANY) {
		              comparator = new Comparator('>=0.0.0');
		            }
		            high = high || comparator;
		            low = low || comparator;
		            if (gtfn(comparator.semver, high.semver, options)) {
		              high = comparator;
		            } else if (ltfn(comparator.semver, low.semver, options)) {
		              low = comparator;
		            }
		          });
		          if (high.operator === comp || high.operator === ecomp) {
		            return false;
		          }
		          if ((!low.operator || low.operator === comp) && ltefn(version, low.semver)) {
		            return false;
		          } else if (low.operator === ecomp && ltfn(version, low.semver)) {
		            return false;
		          }
		        }
		        return true;
		      }
		      exports.prerelease = prerelease;
		      function prerelease(version, options) {
		        var parsed = parse(version, options);
		        return parsed && parsed.prerelease.length ? parsed.prerelease : null;
		      }
		      exports.intersects = intersects;
		      function intersects(r1, r2, options) {
		        r1 = new Range(r1, options);
		        r2 = new Range(r2, options);
		        return r1.intersects(r2);
		      }
		      exports.coerce = coerce;
		      function coerce(version, options) {
		        if (version instanceof SemVer) {
		          return version;
		        }
		        if (typeof version === 'number') {
		          version = String(version);
		        }
		        if (typeof version !== 'string') {
		          return null;
		        }
		        options = options || {};
		        var match = null;
		        if (!options.rtl) {
		          match = version.match(safeRe[t.COERCE]);
		        } else {
		          var next;
		          while ((next = safeRe[t.COERCERTL].exec(version)) && (!match || match.index + match[0].length !== version.length)) {
		            if (!match || next.index + next[0].length !== match.index + match[0].length) {
		              match = next;
		            }
		            safeRe[t.COERCERTL].lastIndex = next.index + next[1].length + next[2].length;
		          }
		          safeRe[t.COERCERTL].lastIndex = -1;
		        }
		        if (match === null) {
		          return null;
		        }
		        return parse(match[2] + '.' + (match[3] || '0') + '.' + (match[4] || '0'), options);
		      }
		    })(semver, semver.exports);
		    return semver.exports;
		  }

		  var hasRequiredHelpers;
		  function requireHelpers() {
		    if (hasRequiredHelpers) return helpers;
		    hasRequiredHelpers = 1;
		    helpers.__esModule = true;
		    helpers.hasMinVersion = hasMinVersion;
		    var _semver = _interopRequireDefault(requireSemver());
		    function _interopRequireDefault(obj) {
		      return obj && obj.__esModule ? obj : {
		        "default": obj
		      };
		    }
		    function hasMinVersion(minVersion, runtimeVersion) {
		      if (!runtimeVersion || !minVersion) return true;
		      runtimeVersion = String(runtimeVersion);
		      if (_semver["default"].valid(runtimeVersion)) runtimeVersion = "^" + runtimeVersion;
		      return !_semver["default"].intersects("<" + minVersion, runtimeVersion) && !_semver["default"].intersects(">=8.0.0", runtimeVersion);
		    }
		    return helpers;
		  }

		  var lib$1 = {};

		  var utils$1 = {};

		  var _templateObject$2, _templateObject2$2, _templateObject3$2;
		  var hasRequiredUtils$1;
		  function requireUtils$1() {
		    if (hasRequiredUtils$1) return utils$1;
		    hasRequiredUtils$1 = 1;
		    utils$1.__esModule = true;
		    utils$1.createUtilsGetter = createUtilsGetter;
		    utils$1.getImportSource = getImportSource;
		    utils$1.getRequireSource = getRequireSource;
		    utils$1.has = has;
		    utils$1.intersection = intersection;
		    utils$1.resolveKey = resolveKey;
		    utils$1.resolveSource = resolveSource;
		    var _babel = _interopRequireWildcard(require$$5);
		    function _getRequireWildcardCache(nodeInterop) {
		      if (typeof WeakMap !== "function") return null;
		      var cacheBabelInterop = new WeakMap();
		      var cacheNodeInterop = new WeakMap();
		      return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) {
		        return nodeInterop ? cacheNodeInterop : cacheBabelInterop;
		      })(nodeInterop);
		    }
		    function _interopRequireWildcard(obj, nodeInterop) {
		      if (!nodeInterop && obj && obj.__esModule) {
		        return obj;
		      }
		      if (obj === null || typeof obj !== "object" && typeof obj !== "function") {
		        return {
		          "default": obj
		        };
		      }
		      var cache = _getRequireWildcardCache(nodeInterop);
		      if (cache && cache.has(obj)) {
		        return cache.get(obj);
		      }
		      var newObj = {};
		      var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
		      for (var key in obj) {
		        if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) {
		          var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
		          if (desc && (desc.get || desc.set)) {
		            Object.defineProperty(newObj, key, desc);
		          } else {
		            newObj[key] = obj[key];
		          }
		        }
		      }
		      newObj["default"] = obj;
		      if (cache) {
		        cache.set(obj, newObj);
		      }
		      return newObj;
		    }
		    var _ref = _babel["default"] || _babel,
		      t = _ref.types,
		      template = _ref.template;
		    function intersection(a, b) {
		      var result = new Set();
		      a.forEach(function (v) {
		        return b.has(v) && result.add(v);
		      });
		      return result;
		    }
		    function has(object, key) {
		      return Object.prototype.hasOwnProperty.call(object, key);
		    }
		    function getType(target) {
		      return Object.prototype.toString.call(target).slice(8, -1);
		    }
		    function resolveId(path) {
		      if (path.isIdentifier() && !path.scope.hasBinding(path.node.name, true)) {
		        return path.node.name;
		      }
		      if (path.isPure()) {
		        var _path$evaluate = path.evaluate(),
		          deopt = _path$evaluate.deopt;
		        if (deopt && deopt.isIdentifier()) {
		          return deopt.node.name;
		        }
		      }
		    }
		    function resolveKey(path, computed) {
		      if (computed === void 0) {
		        computed = false;
		      }
		      var scope = path.scope;
		      if (path.isStringLiteral()) return path.node.value;
		      var isIdentifier = path.isIdentifier();
		      if (isIdentifier && !(computed || path.parent.computed)) {
		        return path.node.name;
		      }
		      if (computed && path.isMemberExpression() && path.get("object").isIdentifier({
		        name: "Symbol"
		      }) && !scope.hasBinding("Symbol", true)) {
		        var sym = resolveKey(path.get("property"), path.node.computed);
		        if (sym) return "Symbol." + sym;
		      }
		      if (isIdentifier ? scope.hasBinding(path.node.name, true) : path.isPure()) {
		        var _path$evaluate2 = path.evaluate(),
		          value = _path$evaluate2.value;
		        if (typeof value === "string") return value;
		      }
		    }
		    function resolveSource(obj) {
		      if (obj.isMemberExpression() && obj.get("property").isIdentifier({
		        name: "prototype"
		      })) {
		        var _id = resolveId(obj.get("object"));
		        if (_id) {
		          return {
		            id: _id,
		            placement: "prototype"
		          };
		        }
		        return {
		          id: null,
		          placement: null
		        };
		      }
		      var id = resolveId(obj);
		      if (id) {
		        return {
		          id: id,
		          placement: "static"
		        };
		      }
		      if (obj.isRegExpLiteral()) {
		        return {
		          id: "RegExp",
		          placement: "prototype"
		        };
		      } else if (obj.isFunction()) {
		        return {
		          id: "Function",
		          placement: "prototype"
		        };
		      } else if (obj.isPure()) {
		        var _obj$evaluate = obj.evaluate(),
		          value = _obj$evaluate.value;
		        if (value !== undefined) {
		          return {
		            id: getType(value),
		            placement: "prototype"
		          };
		        }
		      }
		      return {
		        id: null,
		        placement: null
		      };
		    }
		    function getImportSource(_ref2) {
		      var node = _ref2.node;
		      if (node.specifiers.length === 0) return node.source.value;
		    }
		    function getRequireSource(_ref3) {
		      var node = _ref3.node;
		      if (!t.isExpressionStatement(node)) return;
		      var expression = node.expression;
		      if (t.isCallExpression(expression) && t.isIdentifier(expression.callee) && expression.callee.name === "require" && expression.arguments.length === 1 && t.isStringLiteral(expression.arguments[0])) {
		        return expression.arguments[0].value;
		      }
		    }
		    function hoist(node) {
		      node._blockHoist = 3;
		      return node;
		    }
		    function createUtilsGetter(cache) {
		      return function (path) {
		        var prog = path.findParent(function (p) {
		          return p.isProgram();
		        });
		        return {
		          injectGlobalImport: function injectGlobalImport(url, moduleName) {
		            cache.storeAnonymous(prog, url, moduleName, function (isScript, source) {
		              return isScript ? template.statement.ast(_templateObject$2 || (_templateObject$2 = _taggedTemplateLiteralLoose(["require(", ")"])), source) : t.importDeclaration([], source);
		            });
		          },
		          injectNamedImport: function injectNamedImport(url, name, hint, moduleName) {
		            if (hint === void 0) {
		              hint = name;
		            }
		            return cache.storeNamed(prog, url, name, moduleName, function (isScript, source, name) {
		              var id = prog.scope.generateUidIdentifier(hint);
		              return {
		                node: isScript ? hoist(template.statement.ast(_templateObject2$2 || (_templateObject2$2 = _taggedTemplateLiteralLoose(["\n                  var ", " = require(", ").", "\n                "])), id, source, name)) : t.importDeclaration([t.importSpecifier(id, name)], source),
		                name: id.name
		              };
		            });
		          },
		          injectDefaultImport: function injectDefaultImport(url, hint, moduleName) {
		            if (hint === void 0) {
		              hint = url;
		            }
		            return cache.storeNamed(prog, url, "default", moduleName, function (isScript, source) {
		              var id = prog.scope.generateUidIdentifier(hint);
		              return {
		                node: isScript ? hoist(template.statement.ast(_templateObject3$2 || (_templateObject3$2 = _taggedTemplateLiteralLoose(["var ", " = require(", ")"])), id, source)) : t.importDeclaration([t.importDefaultSpecifier(id)], source),
		                name: id.name
		              };
		            });
		          }
		        };
		      };
		    }
		    return utils$1;
		  }

		  var importsInjector = {};

		  var hasRequiredImportsInjector;
		  function requireImportsInjector() {
		    if (hasRequiredImportsInjector) return importsInjector;
		    hasRequiredImportsInjector = 1;
		    importsInjector.__esModule = true;
		    importsInjector["default"] = void 0;
		    var _babel = _interopRequireWildcard(require$$5);
		    function _getRequireWildcardCache(nodeInterop) {
		      if (typeof WeakMap !== "function") return null;
		      var cacheBabelInterop = new WeakMap();
		      var cacheNodeInterop = new WeakMap();
		      return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) {
		        return nodeInterop ? cacheNodeInterop : cacheBabelInterop;
		      })(nodeInterop);
		    }
		    function _interopRequireWildcard(obj, nodeInterop) {
		      if (!nodeInterop && obj && obj.__esModule) {
		        return obj;
		      }
		      if (obj === null || typeof obj !== "object" && typeof obj !== "function") {
		        return {
		          "default": obj
		        };
		      }
		      var cache = _getRequireWildcardCache(nodeInterop);
		      if (cache && cache.has(obj)) {
		        return cache.get(obj);
		      }
		      var newObj = {};
		      var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
		      for (var key in obj) {
		        if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) {
		          var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
		          if (desc && (desc.get || desc.set)) {
		            Object.defineProperty(newObj, key, desc);
		          } else {
		            newObj[key] = obj[key];
		          }
		        }
		      }
		      newObj["default"] = obj;
		      if (cache) {
		        cache.set(obj, newObj);
		      }
		      return newObj;
		    }
		    var _ref = _babel["default"] || _babel,
		      t = _ref.types;
		    var ImportsCachedInjector = function () {
		      function ImportsCachedInjector(resolver, getPreferredIndex) {
		        this._imports = new WeakMap();
		        this._anonymousImports = new WeakMap();
		        this._lastImports = new WeakMap();
		        this._resolver = resolver;
		        this._getPreferredIndex = getPreferredIndex;
		      }
		      var _proto = ImportsCachedInjector.prototype;
		      _proto.storeAnonymous = function storeAnonymous(programPath, url, moduleName, getVal) {
		        var key = this._normalizeKey(programPath, url);
		        var imports = this._ensure(this._anonymousImports, programPath, Set);
		        if (imports.has(key)) return;
		        var node = getVal(programPath.node.sourceType === "script", t.stringLiteral(this._resolver(url)));
		        imports.add(key);
		        this._injectImport(programPath, node, moduleName);
		      };
		      _proto.storeNamed = function storeNamed(programPath, url, name, moduleName, getVal) {
		        var key = this._normalizeKey(programPath, url, name);
		        var imports = this._ensure(this._imports, programPath, Map);
		        if (!imports.has(key)) {
		          var _getVal = getVal(programPath.node.sourceType === "script", t.stringLiteral(this._resolver(url)), t.identifier(name)),
		            node = _getVal.node,
		            id = _getVal.name;
		          imports.set(key, id);
		          this._injectImport(programPath, node, moduleName);
		        }
		        return t.identifier(imports.get(key));
		      };
		      _proto._injectImport = function _injectImport(programPath, node, moduleName) {
		        var _this$_lastImports$ge;
		        var newIndex = this._getPreferredIndex(moduleName);
		        var lastImports = (_this$_lastImports$ge = this._lastImports.get(programPath)) != null ? _this$_lastImports$ge : [];
		        var isPathStillValid = function isPathStillValid(path) {
		          return path.node && path.parent === programPath.node && path.container === programPath.node.body;
		        };
		        var last;
		        if (newIndex === Infinity) {
		          if (lastImports.length > 0) {
		            last = lastImports[lastImports.length - 1].path;
		            if (!isPathStillValid(last)) last = undefined;
		          }
		        } else {
		          for (var _iterator = _createForOfIteratorHelperLoose(lastImports.entries()), _step; !(_step = _iterator()).done;) {
		            var _step$value = _slicedToArray(_step.value, 2),
		              i = _step$value[0],
		              data = _step$value[1];
		            var path = data.path,
		              index = data.index;
		            if (isPathStillValid(path)) {
		              if (newIndex < index) {
		                var _path$insertBefore = path.insertBefore(node),
		                  _path$insertBefore2 = _slicedToArray(_path$insertBefore, 1),
		                  newPath = _path$insertBefore2[0];
		                lastImports.splice(i, 0, {
		                  path: newPath,
		                  index: newIndex
		                });
		                return;
		              }
		              last = path;
		            }
		          }
		        }
		        if (last) {
		          var _last$insertAfter = last.insertAfter(node),
		            _last$insertAfter2 = _slicedToArray(_last$insertAfter, 1),
		            _newPath = _last$insertAfter2[0];
		          lastImports.push({
		            path: _newPath,
		            index: newIndex
		          });
		        } else {
		          var _programPath$unshiftC = programPath.unshiftContainer("body", node),
		            _programPath$unshiftC2 = _slicedToArray(_programPath$unshiftC, 1),
		            _newPath2 = _programPath$unshiftC2[0];
		          this._lastImports.set(programPath, [{
		            path: _newPath2,
		            index: newIndex
		          }]);
		        }
		      };
		      _proto._ensure = function _ensure(map, programPath, Collection) {
		        var collection = map.get(programPath);
		        if (!collection) {
		          collection = new Collection();
		          map.set(programPath, collection);
		        }
		        return collection;
		      };
		      _proto._normalizeKey = function _normalizeKey(programPath, url, name) {
		        if (name === void 0) {
		          name = "";
		        }
		        var sourceType = programPath.node.sourceType;
		        return (name && sourceType) + "::" + url + "::" + name;
		      };
		      return _createClass(ImportsCachedInjector);
		    }();
		    importsInjector["default"] = ImportsCachedInjector;
		    return importsInjector;
		  }

		  var debugUtils = {};

		  var hasRequiredDebugUtils;
		  function requireDebugUtils() {
		    if (hasRequiredDebugUtils) return debugUtils;
		    hasRequiredDebugUtils = 1;
		    debugUtils.__esModule = true;
		    debugUtils.presetEnvSilentDebugHeader = void 0;
		    debugUtils.stringifyTargets = stringifyTargets;
		    debugUtils.stringifyTargetsMultiline = stringifyTargetsMultiline;
		    var _helperCompilationTargets = require$$1$1;
		    var presetEnvSilentDebugHeader = "#__secret_key__@babel/preset-env__don't_log_debug_header_and_resolved_targets";
		    debugUtils.presetEnvSilentDebugHeader = presetEnvSilentDebugHeader;
		    function stringifyTargetsMultiline(targets) {
		      return JSON.stringify((0, _helperCompilationTargets.prettifyTargets)(targets), null, 2);
		    }
		    function stringifyTargets(targets) {
		      return JSON.stringify(targets).replace(/,/g, ", ").replace(/^\{"/, '{ "').replace(/"\}$/, '" }');
		    }
		    return debugUtils;
		  }

		  var normalizeOptions$4 = {};

		  var hasRequiredNormalizeOptions;
		  function requireNormalizeOptions() {
		    if (hasRequiredNormalizeOptions) return normalizeOptions$4;
		    hasRequiredNormalizeOptions = 1;
		    normalizeOptions$4.__esModule = true;
		    normalizeOptions$4.applyMissingDependenciesDefaults = applyMissingDependenciesDefaults;
		    normalizeOptions$4.validateIncludeExclude = validateIncludeExclude;
		    var _utils = requireUtils$1();
		    function patternToRegExp(pattern) {
		      if (pattern instanceof RegExp) return pattern;
		      try {
		        return new RegExp("^" + pattern + "$");
		      } catch (_unused) {
		        return null;
		      }
		    }
		    function buildUnusedError(label, unused) {
		      if (!unused.length) return "";
		      return "  - The following \"" + label + "\" patterns didn't match any polyfill:\n" + unused.map(function (original) {
		        return "    " + String(original) + "\n";
		      }).join("");
		    }
		    function buldDuplicatesError(duplicates) {
		      if (!duplicates.size) return "";
		      return "  - The following polyfills were matched both by \"include\" and \"exclude\" patterns:\n" + Array.from(duplicates, function (name) {
		        return "    " + name + "\n";
		      }).join("");
		    }
		    function validateIncludeExclude(provider, polyfills, includePatterns, excludePatterns) {
		      var current;
		      var filter = function filter(pattern) {
		        var regexp = patternToRegExp(pattern);
		        if (!regexp) return false;
		        var matched = false;
		        for (var _iterator = _createForOfIteratorHelperLoose(polyfills.keys()), _step; !(_step = _iterator()).done;) {
		          var polyfill = _step.value;
		          if (regexp.test(polyfill)) {
		            matched = true;
		            current.add(polyfill);
		          }
		        }
		        return !matched;
		      };
		      var include = current = new Set();
		      var unusedInclude = Array.from(includePatterns).filter(filter);
		      var exclude = current = new Set();
		      var unusedExclude = Array.from(excludePatterns).filter(filter);
		      var duplicates = (0, _utils.intersection)(include, exclude);
		      if (duplicates.size > 0 || unusedInclude.length > 0 || unusedExclude.length > 0) {
		        throw new Error("Error while validating the \"" + provider + "\" provider options:\n" + buildUnusedError("include", unusedInclude) + buildUnusedError("exclude", unusedExclude) + buldDuplicatesError(duplicates));
		      }
		      return {
		        include: include,
		        exclude: exclude
		      };
		    }
		    function applyMissingDependenciesDefaults(options, babelApi) {
		      var _options$missingDepen = options.missingDependencies,
		        missingDependencies = _options$missingDepen === void 0 ? {} : _options$missingDepen;
		      if (missingDependencies === false) return false;
		      var caller = babelApi.caller(function (caller) {
		        return caller == null ? void 0 : caller.name;
		      });
		      var _missingDependencies$ = missingDependencies.log,
		        log = _missingDependencies$ === void 0 ? "deferred" : _missingDependencies$,
		        _missingDependencies$2 = missingDependencies.inject,
		        inject = _missingDependencies$2 === void 0 ? caller === "rollup-plugin-babel" ? "throw" : "import" : _missingDependencies$2,
		        _missingDependencies$3 = missingDependencies.all,
		        all = _missingDependencies$3 === void 0 ? false : _missingDependencies$3;
		      return {
		        log: log,
		        inject: inject,
		        all: all
		      };
		    }
		    return normalizeOptions$4;
		  }

		  var visitors = {};

		  var usage$1 = {};

		  var hasRequiredUsage;
		  function requireUsage() {
		    if (hasRequiredUsage) return usage$1;
		    hasRequiredUsage = 1;
		    usage$1.__esModule = true;
		    usage$1["default"] = void 0;
		    var _utils = requireUtils$1();
		    function isRemoved(path) {
		      if (path.removed) return true;
		      if (!path.parentPath) return false;
		      if (path.listKey) {
		        if (!path.parentPath.node[path.listKey].includes(path.node)) return true;
		      } else {
		        if (path.parentPath.node[path.key] !== path.node) return true;
		      }
		      return isRemoved(path.parentPath);
		    }
		    var _default = function _default(callProvider) {
		      function property(object, key, placement, path) {
		        return callProvider({
		          kind: "property",
		          object: object,
		          key: key,
		          placement: placement
		        }, path);
		      }
		      function handleReferencedIdentifier(path) {
		        var name = path.node.name,
		          scope = path.scope;
		        if (scope.getBindingIdentifier(name)) return;
		        callProvider({
		          kind: "global",
		          name: name
		        }, path);
		      }
		      function analyzeMemberExpression(path) {
		        var key = (0, _utils.resolveKey)(path.get("property"), path.node.computed);
		        return {
		          key: key,
		          handleAsMemberExpression: !!key && key !== "prototype"
		        };
		      }
		      return {
		        ReferencedIdentifier: function ReferencedIdentifier(path) {
		          var parentPath = path.parentPath;
		          if (parentPath.isMemberExpression({
		            object: path.node
		          }) && analyzeMemberExpression(parentPath).handleAsMemberExpression) {
		            return;
		          }
		          handleReferencedIdentifier(path);
		        },
		        MemberExpression: function MemberExpression(path) {
		          var _analyzeMemberExpress = analyzeMemberExpression(path),
		            key = _analyzeMemberExpress.key,
		            handleAsMemberExpression = _analyzeMemberExpress.handleAsMemberExpression;
		          if (!handleAsMemberExpression) return;
		          var object = path.get("object");
		          var objectIsGlobalIdentifier = object.isIdentifier();
		          if (objectIsGlobalIdentifier) {
		            var binding = object.scope.getBinding(object.node.name);
		            if (binding) {
		              if (binding.path.isImportNamespaceSpecifier()) return;
		              objectIsGlobalIdentifier = false;
		            }
		          }
		          var source = (0, _utils.resolveSource)(object);
		          var skipObject = property(source.id, key, source.placement, path);
		          skipObject || (skipObject = !objectIsGlobalIdentifier || path.shouldSkip || object.shouldSkip || isRemoved(object));
		          if (!skipObject) handleReferencedIdentifier(object);
		        },
		        ObjectPattern: function ObjectPattern(path) {
		          var parentPath = path.parentPath,
		            parent = path.parent;
		          var obj;
		          if (parentPath.isVariableDeclarator()) {
		            obj = parentPath.get("init");
		          } else if (parentPath.isAssignmentExpression()) {
		            obj = parentPath.get("right");
		          } else if (parentPath.isFunction()) {
		            var grand = parentPath.parentPath;
		            if (grand.isCallExpression() || grand.isNewExpression()) {
		              if (grand.node.callee === parent) {
		                obj = grand.get("arguments")[path.key];
		              }
		            }
		          }
		          var id = null;
		          var placement = null;
		          if (obj) {
		            var _ref = (0, _utils.resolveSource)(obj);
		            id = _ref.id;
		            placement = _ref.placement;
		          }
		          for (var _iterator = _createForOfIteratorHelperLoose(path.get("properties")), _step; !(_step = _iterator()).done;) {
		            var prop = _step.value;
		            if (prop.isObjectProperty()) {
		              var key = (0, _utils.resolveKey)(prop.get("key"));
		              if (key) property(id, key, placement, prop);
		            }
		          }
		        },
		        BinaryExpression: function BinaryExpression(path) {
		          if (path.node.operator !== "in") return;
		          var source = (0, _utils.resolveSource)(path.get("right"));
		          var key = (0, _utils.resolveKey)(path.get("left"), true);
		          if (!key) return;
		          callProvider({
		            kind: "in",
		            object: source.id,
		            key: key,
		            placement: source.placement
		          }, path);
		        }
		      };
		    };
		    usage$1["default"] = _default;
		    return usage$1;
		  }

		  var entry$1 = {};

		  var hasRequiredEntry;
		  function requireEntry() {
		    if (hasRequiredEntry) return entry$1;
		    hasRequiredEntry = 1;
		    entry$1.__esModule = true;
		    entry$1["default"] = void 0;
		    var _utils = requireUtils$1();
		    var _default = function _default(callProvider) {
		      return {
		        ImportDeclaration: function ImportDeclaration(path) {
		          var source = (0, _utils.getImportSource)(path);
		          if (!source) return;
		          callProvider({
		            kind: "import",
		            source: source
		          }, path);
		        },
		        Program: function Program(path) {
		          path.get("body").forEach(function (bodyPath) {
		            var source = (0, _utils.getRequireSource)(bodyPath);
		            if (!source) return;
		            callProvider({
		              kind: "import",
		              source: source
		            }, bodyPath);
		          });
		        }
		      };
		    };
		    entry$1["default"] = _default;
		    return entry$1;
		  }

		  var hasRequiredVisitors;
		  function requireVisitors() {
		    if (hasRequiredVisitors) return visitors;
		    hasRequiredVisitors = 1;
		    visitors.__esModule = true;
		    visitors.usage = visitors.entry = void 0;
		    var _usage = _interopRequireDefault(requireUsage());
		    visitors.usage = _usage["default"];
		    var _entry = _interopRequireDefault(requireEntry());
		    visitors.entry = _entry["default"];
		    function _interopRequireDefault(obj) {
		      return obj && obj.__esModule ? obj : {
		        "default": obj
		      };
		    }
		    return visitors;
		  }

		  var dependencies = {};

		  var hasRequiredDependencies;
		  function requireDependencies() {
		    if (hasRequiredDependencies) return dependencies;
		    hasRequiredDependencies = 1;
		    dependencies.__esModule = true;
		    dependencies.has = has;
		    dependencies.laterLogMissing = laterLogMissing;
		    dependencies.logMissing = logMissing;
		    dependencies.resolve = resolve;
		    function resolve(dirname, moduleName, absoluteImports) {
		      if (absoluteImports === false) return moduleName;
		      throw new Error("\"absoluteImports\" is not supported in bundles prepared for the browser.");
		    }
		    function has(basedir, name) {
		      return true;
		    }
		    function logMissing(missingDeps) {}
		    function laterLogMissing(missingDeps) {}
		    return dependencies;
		  }

		  var metaResolver = {};

		  var hasRequiredMetaResolver;
		  function requireMetaResolver() {
		    if (hasRequiredMetaResolver) return metaResolver;
		    hasRequiredMetaResolver = 1;
		    metaResolver.__esModule = true;
		    metaResolver["default"] = createMetaResolver;
		    var _utils = requireUtils$1();
		    var PossibleGlobalObjects = new Set(["global", "globalThis", "self", "window"]);
		    function createMetaResolver(polyfills) {
		      var staticP = polyfills["static"],
		        instanceP = polyfills.instance,
		        globalP = polyfills.global;
		      return function (meta) {
		        if (meta.kind === "global" && globalP && (0, _utils.has)(globalP, meta.name)) {
		          return {
		            kind: "global",
		            desc: globalP[meta.name],
		            name: meta.name
		          };
		        }
		        if (meta.kind === "property" || meta.kind === "in") {
		          var placement = meta.placement,
		            object = meta.object,
		            key = meta.key;
		          if (object && placement === "static") {
		            if (globalP && PossibleGlobalObjects.has(object) && (0, _utils.has)(globalP, key)) {
		              return {
		                kind: "global",
		                desc: globalP[key],
		                name: key
		              };
		            }
		            if (staticP && (0, _utils.has)(staticP, object) && (0, _utils.has)(staticP[object], key)) {
		              return {
		                kind: "static",
		                desc: staticP[object][key],
		                name: object + "$" + key
		              };
		            }
		          }
		          if (instanceP && (0, _utils.has)(instanceP, key)) {
		            return {
		              kind: "instance",
		              desc: instanceP[key],
		              name: "" + key
		            };
		          }
		        }
		      };
		    }
		    return metaResolver;
		  }

		  var hasRequiredLib$2;
		  function requireLib$2() {
		    if (hasRequiredLib$2) return lib$1;
		    hasRequiredLib$2 = 1;
		    lib$1.__esModule = true;
		    lib$1["default"] = definePolyfillProvider;
		    var _helperPluginUtils = require$$0$4;
		    var _helperCompilationTargets = _interopRequireWildcard(require$$1$1);
		    var _utils = requireUtils$1();
		    var _importsInjector = _interopRequireDefault(requireImportsInjector());
		    var _debugUtils = requireDebugUtils();
		    var _normalizeOptions = requireNormalizeOptions();
		    var v = _interopRequireWildcard(requireVisitors());
		    var deps = _interopRequireWildcard(requireDependencies());
		    var _metaResolver = _interopRequireDefault(requireMetaResolver());
		    var _excluded = ["method", "targets", "ignoreBrowserslistConfig", "configPath", "debug", "shouldInjectPolyfill", "absoluteImports"];
		    function _interopRequireDefault(obj) {
		      return obj && obj.__esModule ? obj : {
		        "default": obj
		      };
		    }
		    function _getRequireWildcardCache(nodeInterop) {
		      if (typeof WeakMap !== "function") return null;
		      var cacheBabelInterop = new WeakMap();
		      var cacheNodeInterop = new WeakMap();
		      return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) {
		        return nodeInterop ? cacheNodeInterop : cacheBabelInterop;
		      })(nodeInterop);
		    }
		    function _interopRequireWildcard(obj, nodeInterop) {
		      if (!nodeInterop && obj && obj.__esModule) {
		        return obj;
		      }
		      if (obj === null || typeof obj !== "object" && typeof obj !== "function") {
		        return {
		          "default": obj
		        };
		      }
		      var cache = _getRequireWildcardCache(nodeInterop);
		      if (cache && cache.has(obj)) {
		        return cache.get(obj);
		      }
		      var newObj = {};
		      var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
		      for (var key in obj) {
		        if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) {
		          var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
		          if (desc && (desc.get || desc.set)) {
		            Object.defineProperty(newObj, key, desc);
		          } else {
		            newObj[key] = obj[key];
		          }
		        }
		      }
		      newObj["default"] = obj;
		      if (cache) {
		        cache.set(obj, newObj);
		      }
		      return newObj;
		    }
		    function _objectWithoutPropertiesLoose(source, excluded) {
		      if (source == null) return {};
		      var target = {};
		      var sourceKeys = Object.keys(source);
		      var key, i;
		      for (i = 0; i < sourceKeys.length; i++) {
		        key = sourceKeys[i];
		        if (excluded.indexOf(key) >= 0) continue;
		        target[key] = source[key];
		      }
		      return target;
		    }
		    var getTargets = _helperCompilationTargets["default"]["default"] || _helperCompilationTargets["default"];
		    function resolveOptions(options, babelApi) {
		      var method = options.method,
		        targetsOption = options.targets,
		        ignoreBrowserslistConfig = options.ignoreBrowserslistConfig,
		        configPath = options.configPath,
		        debug = options.debug,
		        shouldInjectPolyfill = options.shouldInjectPolyfill,
		        absoluteImports = options.absoluteImports,
		        providerOptions = _objectWithoutPropertiesLoose(options, _excluded);
		      if (isEmpty(options)) {
		        throw new Error("This plugin requires options, for example:\n    {\n      \"plugins\": [\n        [\"<plugin name>\", { method: \"usage-pure\" }]\n      ]\n    }\n\nSee more options at https://github.com/babel/babel-polyfills/blob/main/docs/usage.md");
		      }
		      var methodName;
		      if (method === "usage-global") methodName = "usageGlobal";else if (method === "entry-global") methodName = "entryGlobal";else if (method === "usage-pure") methodName = "usagePure";else if (typeof method !== "string") {
		        throw new Error(".method must be a string");
		      } else {
		        throw new Error(".method must be one of \"entry-global\", \"usage-global\"" + (" or \"usage-pure\" (received " + JSON.stringify(method) + ")"));
		      }
		      if (typeof shouldInjectPolyfill === "function") {
		        if (options.include || options.exclude) {
		          throw new Error(".include and .exclude are not supported when using the" + " .shouldInjectPolyfill function.");
		        }
		      } else if (shouldInjectPolyfill != null) {
		        throw new Error(".shouldInjectPolyfill must be a function, or undefined" + (" (received " + JSON.stringify(shouldInjectPolyfill) + ")"));
		      }
		      if (absoluteImports != null && typeof absoluteImports !== "boolean" && typeof absoluteImports !== "string") {
		        throw new Error(".absoluteImports must be a boolean, a string, or undefined" + (" (received " + JSON.stringify(absoluteImports) + ")"));
		      }
		      var targets;
		      if (targetsOption || configPath || ignoreBrowserslistConfig) {
		        var targetsObj = typeof targetsOption === "string" || Array.isArray(targetsOption) ? {
		          browsers: targetsOption
		        } : targetsOption;
		        targets = getTargets(targetsObj, {
		          ignoreBrowserslistConfig: ignoreBrowserslistConfig,
		          configPath: configPath
		        });
		      } else {
		        targets = babelApi.targets();
		      }
		      return {
		        method: method,
		        methodName: methodName,
		        targets: targets,
		        absoluteImports: absoluteImports != null ? absoluteImports : false,
		        shouldInjectPolyfill: shouldInjectPolyfill,
		        debug: !!debug,
		        providerOptions: providerOptions
		      };
		    }
		    function instantiateProvider(factory, options, missingDependencies, dirname, debugLog, babelApi) {
		      var _resolveOptions = resolveOptions(options, babelApi),
		        method = _resolveOptions.method,
		        methodName = _resolveOptions.methodName,
		        targets = _resolveOptions.targets,
		        _debug = _resolveOptions.debug,
		        _shouldInjectPolyfill = _resolveOptions.shouldInjectPolyfill,
		        providerOptions = _resolveOptions.providerOptions,
		        absoluteImports = _resolveOptions.absoluteImports;
		      var include, exclude;
		      var polyfillsSupport;
		      var polyfillsNames;
		      var filterPolyfills;
		      var getUtils = (0, _utils.createUtilsGetter)(new _importsInjector["default"](function (moduleName) {
		        return deps.resolve(dirname, moduleName, absoluteImports);
		      }, function (name) {
		        var _polyfillsNames$get, _polyfillsNames;
		        return (_polyfillsNames$get = (_polyfillsNames = polyfillsNames) == null ? void 0 : _polyfillsNames.get(name)) != null ? _polyfillsNames$get : Infinity;
		      }));
		      var depsCache = new Map();
		      var api = {
		        babel: babelApi,
		        getUtils: getUtils,
		        method: options.method,
		        targets: targets,
		        createMetaResolver: _metaResolver["default"],
		        shouldInjectPolyfill: function shouldInjectPolyfill(name) {
		          if (polyfillsNames === undefined) {
		            throw new Error("Internal error in the " + factory.name + " provider: " + "shouldInjectPolyfill() can't be called during initialization.");
		          }
		          if (!polyfillsNames.has(name)) {
		            console.warn("Internal error in the " + providerName + " provider: " + ("unknown polyfill \"" + name + "\"."));
		          }
		          if (filterPolyfills && !filterPolyfills(name)) return false;
		          var shouldInject = (0, _helperCompilationTargets.isRequired)(name, targets, {
		            compatData: polyfillsSupport,
		            includes: include,
		            excludes: exclude
		          });
		          if (_shouldInjectPolyfill) {
		            shouldInject = _shouldInjectPolyfill(name, shouldInject);
		            if (typeof shouldInject !== "boolean") {
		              throw new Error(".shouldInjectPolyfill must return a boolean.");
		            }
		          }
		          return shouldInject;
		        },
		        debug: function debug(name) {
		          var _debugLog, _debugLog$polyfillsSu;
		          debugLog().found = true;
		          if (!_debug || !name) return;
		          if (debugLog().polyfills.has(providerName)) return;
		          debugLog().polyfills.add(name);
		          (_debugLog$polyfillsSu = (_debugLog = debugLog()).polyfillsSupport) != null ? _debugLog$polyfillsSu : _debugLog.polyfillsSupport = polyfillsSupport;
		        },
		        assertDependency: function assertDependency(name, version) {
		          if (version === void 0) {
		            version = "*";
		          }
		          if (missingDependencies === false) return;
		          if (absoluteImports) {
		            return;
		          }
		          var dep = version === "*" ? name : name + "@^" + version;
		          var found = missingDependencies.all ? false : mapGetOr(depsCache, name + " :: " + dirname, function () {
		            return deps.has(dirname, name);
		          });
		          if (!found) {
		            debugLog().missingDeps.add(dep);
		          }
		        }
		      };
		      var provider = factory(api, providerOptions, dirname);
		      var providerName = provider.name || factory.name;
		      if (typeof provider[methodName] !== "function") {
		        throw new Error("The \"" + providerName + "\" provider doesn't support the \"" + method + "\" polyfilling method.");
		      }
		      if (Array.isArray(provider.polyfills)) {
		        polyfillsNames = new Map(provider.polyfills.map(function (name, index) {
		          return [name, index];
		        }));
		        filterPolyfills = provider.filterPolyfills;
		      } else if (provider.polyfills) {
		        polyfillsNames = new Map(Object.keys(provider.polyfills).map(function (name, index) {
		          return [name, index];
		        }));
		        polyfillsSupport = provider.polyfills;
		        filterPolyfills = provider.filterPolyfills;
		      } else {
		        polyfillsNames = new Map();
		      }
		      var _ref2 = (0, _normalizeOptions.validateIncludeExclude)(providerName, polyfillsNames, providerOptions.include || [], providerOptions.exclude || []);
		      include = _ref2.include;
		      exclude = _ref2.exclude;
		      var callProvider;
		      if (methodName === "usageGlobal") {
		        callProvider = function callProvider(payload, path) {
		          var _ref;
		          var utils = getUtils(path);
		          return (_ref = provider[methodName](payload, utils, path)) != null ? _ref : false;
		        };
		      } else {
		        callProvider = function callProvider(payload, path) {
		          var utils = getUtils(path);
		          provider[methodName](payload, utils, path);
		          return false;
		        };
		      }
		      return {
		        debug: _debug,
		        method: method,
		        targets: targets,
		        provider: provider,
		        providerName: providerName,
		        callProvider: callProvider
		      };
		    }
		    function definePolyfillProvider(factory) {
		      return (0, _helperPluginUtils.declare)(function (babelApi, options, dirname) {
		        babelApi.assertVersion("^7.0.0 || ^8.0.0-alpha.0");
		        var traverse = babelApi.traverse;
		        var debugLog;
		        var missingDependencies = (0, _normalizeOptions.applyMissingDependenciesDefaults)(options, babelApi);
		        var _instantiateProvider = instantiateProvider(factory, options, missingDependencies, dirname, function () {
		            return debugLog;
		          }, babelApi),
		          debug = _instantiateProvider.debug,
		          method = _instantiateProvider.method,
		          targets = _instantiateProvider.targets,
		          provider = _instantiateProvider.provider,
		          providerName = _instantiateProvider.providerName,
		          callProvider = _instantiateProvider.callProvider;
		        var createVisitor = method === "entry-global" ? v.entry : v.usage;
		        var visitor = provider.visitor ? traverse.visitors.merge([createVisitor(callProvider), provider.visitor]) : createVisitor(callProvider);
		        if (debug && debug !== _debugUtils.presetEnvSilentDebugHeader) {
		          console.log(providerName + ": `DEBUG` option");
		          console.log("\nUsing targets: " + (0, _debugUtils.stringifyTargetsMultiline)(targets));
		          console.log("\nUsing polyfills with `" + method + "` method:");
		        }
		        var runtimeName = provider.runtimeName;
		        return {
		          name: "inject-polyfills",
		          visitor: visitor,
		          pre: function pre(file) {
		            var _provider$pre;
		            if (runtimeName) {
		              if (file.get("runtimeHelpersModuleName") && file.get("runtimeHelpersModuleName") !== runtimeName) {
		                console.warn("Two different polyfill providers" + (" (" + file.get("runtimeHelpersModuleProvider")) + (" and " + providerName + ") are trying to define two") + " conflicting @babel/runtime alternatives:" + (" " + file.get("runtimeHelpersModuleName") + " and " + runtimeName + ".") + " The second one will be ignored.");
		              } else {
		                file.set("runtimeHelpersModuleName", runtimeName);
		                file.set("runtimeHelpersModuleProvider", providerName);
		              }
		            }
		            debugLog = {
		              polyfills: new Set(),
		              polyfillsSupport: undefined,
		              found: false,
		              providers: new Set(),
		              missingDeps: new Set()
		            };
		            (_provider$pre = provider.pre) == null ? void 0 : _provider$pre.apply(this, arguments);
		          },
		          post: function post() {
		            var _provider$post;
		            (_provider$post = provider.post) == null ? void 0 : _provider$post.apply(this, arguments);
		            if (missingDependencies !== false) {
		              if (missingDependencies.log === "per-file") {
		                deps.logMissing(debugLog.missingDeps);
		              } else {
		                deps.laterLogMissing(debugLog.missingDeps);
		              }
		            }
		            if (!debug) return;
		            if (this.filename) console.log("\n[" + this.filename + "]");
		            if (debugLog.polyfills.size === 0) {
		              console.log(method === "entry-global" ? debugLog.found ? "Based on your targets, the " + providerName + " polyfill did not add any polyfill." : "The entry point for the " + providerName + " polyfill has not been found." : "Based on your code and targets, the " + providerName + " polyfill did not add any polyfill.");
		              return;
		            }
		            if (method === "entry-global") {
		              console.log("The " + providerName + " polyfill entry has been replaced with " + "the following polyfills:");
		            } else {
		              console.log("The " + providerName + " polyfill added the following polyfills:");
		            }
		            for (var _iterator = _createForOfIteratorHelperLoose(debugLog.polyfills), _step; !(_step = _iterator()).done;) {
		              var name = _step.value;
		              var _debugLog$polyfillsSu2;
		              if ((_debugLog$polyfillsSu2 = debugLog.polyfillsSupport) != null && _debugLog$polyfillsSu2[name]) {
		                var filteredTargets = (0, _helperCompilationTargets.getInclusionReasons)(name, targets, debugLog.polyfillsSupport);
		                var formattedTargets = JSON.stringify(filteredTargets).replace(/,/g, ", ").replace(/^\{"/, '{ "').replace(/"\}$/, '" }');
		                console.log("  " + name + " " + formattedTargets);
		              } else {
		                console.log("  " + name);
		              }
		            }
		          }
		        };
		      });
		    }
		    function mapGetOr(map, key, getDefault) {
		      var val = map.get(key);
		      if (val === undefined) {
		        val = getDefault();
		        map.set(key, val);
		      }
		      return val;
		    }
		    function isEmpty(obj) {
		      return Object.keys(obj).length === 0;
		    }
		    return lib$1;
		  }

		  var hasRequiredLib$1;
		  function requireLib$1() {
		    if (hasRequiredLib$1) return lib$2;
		    hasRequiredLib$1 = 1;
		    lib$2.__esModule = true;
		    lib$2["default"] = void 0;
		    var _corejs2BuiltIns = _interopRequireDefault(requireCorejs2BuiltIns());
		    var _builtInDefinitions = requireBuiltInDefinitions();
		    var _addPlatformSpecificPolyfills = _interopRequireDefault(requireAddPlatformSpecificPolyfills());
		    var _helpers = requireHelpers();
		    var _helperDefinePolyfillProvider = _interopRequireDefault(requireLib$2());
		    var _babel = _interopRequireWildcard(require$$5);
		    function _getRequireWildcardCache(nodeInterop) {
		      if (typeof WeakMap !== "function") return null;
		      var cacheBabelInterop = new WeakMap();
		      var cacheNodeInterop = new WeakMap();
		      return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) {
		        return nodeInterop ? cacheNodeInterop : cacheBabelInterop;
		      })(nodeInterop);
		    }
		    function _interopRequireWildcard(obj, nodeInterop) {
		      if (!nodeInterop && obj && obj.__esModule) {
		        return obj;
		      }
		      if (obj === null || typeof obj !== "object" && typeof obj !== "function") {
		        return {
		          "default": obj
		        };
		      }
		      var cache = _getRequireWildcardCache(nodeInterop);
		      if (cache && cache.has(obj)) {
		        return cache.get(obj);
		      }
		      var newObj = {};
		      var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
		      for (var key in obj) {
		        if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) {
		          var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
		          if (desc && (desc.get || desc.set)) {
		            Object.defineProperty(newObj, key, desc);
		          } else {
		            newObj[key] = obj[key];
		          }
		        }
		      }
		      newObj["default"] = obj;
		      if (cache) {
		        cache.set(obj, newObj);
		      }
		      return newObj;
		    }
		    function _interopRequireDefault(obj) {
		      return obj && obj.__esModule ? obj : {
		        "default": obj
		      };
		    }
		    var _ref = _babel["default"] || _babel,
		      t = _ref.types;
		    var BABEL_RUNTIME = "@babel/runtime-corejs2";
		    var presetEnvCompat = "#__secret_key__@babel/preset-env__compatibility";
		    var runtimeCompat = "#__secret_key__@babel/runtime__compatibility";
		    var has = Function.call.bind(Object.hasOwnProperty);
		    var _default = (0, _helperDefinePolyfillProvider["default"])(function (api, _ref2) {
		      var _ref2$presetEnvCompat = _ref2[presetEnvCompat],
		        _ref2$presetEnvCompat2 = _ref2$presetEnvCompat === void 0 ? {} : _ref2$presetEnvCompat,
		        _ref2$presetEnvCompat3 = _ref2$presetEnvCompat2.entryInjectRegenerator,
		        entryInjectRegenerator = _ref2$presetEnvCompat3 === void 0 ? false : _ref2$presetEnvCompat3,
		        _ref2$presetEnvCompat4 = _ref2$presetEnvCompat2.noRuntimeName,
		        noRuntimeName = _ref2$presetEnvCompat4 === void 0 ? false : _ref2$presetEnvCompat4,
		        _ref2$runtimeCompat = _ref2[runtimeCompat],
		        _ref2$runtimeCompat2 = _ref2$runtimeCompat === void 0 ? {} : _ref2$runtimeCompat,
		        _ref2$runtimeCompat2$ = _ref2$runtimeCompat2.useBabelRuntime,
		        useBabelRuntime = _ref2$runtimeCompat2$ === void 0 ? false : _ref2$runtimeCompat2$,
		        _ref2$runtimeCompat2$2 = _ref2$runtimeCompat2.runtimeVersion,
		        runtimeVersion = _ref2$runtimeCompat2$2 === void 0 ? "" : _ref2$runtimeCompat2$2,
		        _ref2$runtimeCompat2$3 = _ref2$runtimeCompat2.ext,
		        ext = _ref2$runtimeCompat2$3 === void 0 ? ".js" : _ref2$runtimeCompat2$3;
		      var resolve = api.createMetaResolver({
		        global: _builtInDefinitions.BuiltIns,
		        "static": _builtInDefinitions.StaticProperties,
		        instance: _builtInDefinitions.InstanceProperties
		      });
		      var debug = api.debug,
		        shouldInjectPolyfill = api.shouldInjectPolyfill,
		        method = api.method;
		      var polyfills = (0, _addPlatformSpecificPolyfills["default"])(api.targets, method, _corejs2BuiltIns["default"]);
		      var coreJSBase = useBabelRuntime ? BABEL_RUNTIME + "/core-js" : method === "usage-pure" ? "core-js/library/fn" : "core-js/modules";
		      function inject(name, utils) {
		        if (typeof name === "string") {
		          if (has(polyfills, name) && shouldInjectPolyfill(name)) {
		            debug(name);
		            utils.injectGlobalImport(coreJSBase + "/" + name + ".js");
		          }
		          return;
		        }
		        name.forEach(function (name) {
		          return inject(name, utils);
		        });
		      }
		      function maybeInjectPure(desc, hint, utils) {
		        var pure = desc.pure,
		          meta = desc.meta,
		          name = desc.name;
		        if (!pure || !shouldInjectPolyfill(name)) return;
		        if (runtimeVersion && meta && meta.minRuntimeVersion && !(0, _helpers.hasMinVersion)(meta && meta.minRuntimeVersion, runtimeVersion)) {
		          return;
		        }
		        if (useBabelRuntime && pure === "symbol/index") pure = "symbol";
		        return utils.injectDefaultImport(coreJSBase + "/" + pure + ext, hint);
		      }
		      return {
		        name: "corejs2",
		        runtimeName: noRuntimeName ? null : BABEL_RUNTIME,
		        polyfills: polyfills,
		        entryGlobal: function entryGlobal(meta, utils, path) {
		          if (meta.kind === "import" && meta.source === "core-js") {
		            debug(null);
		            inject(Object.keys(polyfills), utils);
		            if (entryInjectRegenerator) {
		              utils.injectGlobalImport("regenerator-runtime/runtime.js");
		            }
		            path.remove();
		          }
		        },
		        usageGlobal: function usageGlobal(meta, utils) {
		          var resolved = resolve(meta);
		          if (!resolved) return;
		          var deps = resolved.desc.global;
		          if (resolved.kind !== "global" && "object" in meta && meta.object && meta.placement === "prototype") {
		            var low = meta.object.toLowerCase();
		            deps = deps.filter(function (m) {
		              return m.includes(low);
		            });
		          }
		          inject(deps, utils);
		        },
		        usagePure: function usagePure(meta, utils, path) {
		          if (meta.kind === "in") {
		            if (meta.key === "Symbol.iterator") {
		              path.replaceWith(t.callExpression(utils.injectDefaultImport(coreJSBase + "/is-iterable" + ext, "isIterable"), [path.node.right]));
		            }
		            return;
		          }
		          if (path.parentPath.isUnaryExpression({
		            operator: "delete"
		          })) return;
		          if (meta.kind === "property") {
		            if (!path.isMemberExpression()) return;
		            if (!path.isReferenced()) return;
		            if (meta.key === "Symbol.iterator" && shouldInjectPolyfill("es6.symbol") && path.parentPath.isCallExpression({
		              callee: path.node
		            }) && path.parentPath.node.arguments.length === 0) {
		              path.parentPath.replaceWith(t.callExpression(utils.injectDefaultImport(coreJSBase + "/get-iterator" + ext, "getIterator"), [path.node.object]));
		              path.skip();
		              return;
		            }
		          }
		          var resolved = resolve(meta);
		          if (!resolved) return;
		          var id = maybeInjectPure(resolved.desc, resolved.name, utils);
		          if (id) path.replaceWith(id);
		        },
		        visitor: method === "usage-global" && {
		          YieldExpression: function YieldExpression(path) {
		            if (path.node.delegate) {
		              inject("web.dom.iterable", api.getUtils(path));
		            }
		          },
		          "ForOfStatement|ArrayPattern": function ForOfStatementArrayPattern(path) {
		            _builtInDefinitions.CommonIterators.forEach(function (name) {
		              return inject(name, api.getUtils(path));
		            });
		          }
		        }
		      };
		    });
		    lib$2["default"] = _default;
		    return lib$2;
		  }

		  var babelPluginPolyfillCorejs2;
		  var hasRequiredBabelPluginPolyfillCorejs2;
		  function requireBabelPluginPolyfillCorejs2() {
		    if (hasRequiredBabelPluginPolyfillCorejs2) return babelPluginPolyfillCorejs2;
		    hasRequiredBabelPluginPolyfillCorejs2 = 1;
		    function bool(value) {
		      if (value == null) return false;
		      return value && value !== "false" && value !== "0";
		    }
		    babelPluginPolyfillCorejs2 = bool(browser$1$1.env["BABEL_8_BREAKING"]) ? null : requireLib$1();
		    return babelPluginPolyfillCorejs2;
		  }

		  var lib = {};

		  var hasRequiredLib;
		  function requireLib() {
		    if (hasRequiredLib) return lib;
		    hasRequiredLib = 1;
		    lib.__esModule = true;
		    lib["default"] = void 0;
		    var _helperDefinePolyfillProvider = _interopRequireDefault(requireLib$2());
		    function _interopRequireDefault(obj) {
		      return obj && obj.__esModule ? obj : {
		        "default": obj
		      };
		    }
		    var runtimeCompat = "#__secret_key__@babel/runtime__compatibility";
		    var _default = (0, _helperDefinePolyfillProvider["default"])(function (_ref2, options) {
		      var debug = _ref2.debug,
		        targets = _ref2.targets,
		        babel = _ref2.babel;
		      if (!shallowEqual(targets, babel.targets())) {
		        throw new Error("This plugin does not use the targets option. Only preset-env's targets" + " or top-level targets need to be configured for this plugin to work." + " See https://github.com/babel/babel-polyfills/issues/36 for more" + " details.");
		      }
		      var _options$runtimeCompa = options[runtimeCompat],
		        _options$runtimeCompa2 = _options$runtimeCompa === void 0 ? {} : _options$runtimeCompa,
		        _options$runtimeCompa3 = _options$runtimeCompa2.moduleName,
		        moduleName = _options$runtimeCompa3 === void 0 ? null : _options$runtimeCompa3,
		        _options$runtimeCompa4 = _options$runtimeCompa2.useBabelRuntime,
		        useBabelRuntime = _options$runtimeCompa4 === void 0 ? false : _options$runtimeCompa4;
		      return {
		        name: "regenerator",
		        polyfills: ["regenerator-runtime"],
		        usageGlobal: function usageGlobal(meta, utils) {
		          if (isRegenerator(meta)) {
		            debug("regenerator-runtime");
		            utils.injectGlobalImport("regenerator-runtime/runtime.js");
		          }
		        },
		        usagePure: function usagePure(meta, utils, path) {
		          if (isRegenerator(meta)) {
		            var pureName = "regenerator-runtime";
		            if (useBabelRuntime) {
		              var _ref;
		              var runtimeName = (_ref = moduleName != null ? moduleName : path.hub.file.get("runtimeHelpersModuleName")) != null ? _ref : "@babel/runtime";
		              pureName = runtimeName + "/regenerator";
		            }
		            path.replaceWith(utils.injectDefaultImport(pureName, "regenerator-runtime"));
		          }
		        }
		      };
		    });
		    lib["default"] = _default;
		    var isRegenerator = function isRegenerator(meta) {
		      return meta.kind === "global" && meta.name === "regeneratorRuntime";
		    };
		    function shallowEqual(obj1, obj2) {
		      return JSON.stringify(obj1) === JSON.stringify(obj2);
		    }
		    return lib;
		  }

		  var babelPluginPolyfillRegenerator;
		  var hasRequiredBabelPluginPolyfillRegenerator;
		  function requireBabelPluginPolyfillRegenerator() {
		    if (hasRequiredBabelPluginPolyfillRegenerator) return babelPluginPolyfillRegenerator;
		    hasRequiredBabelPluginPolyfillRegenerator = 1;
		    function bool(value) {
		      if (value == null) return false;
		      return value && value !== "false" && value !== "0";
		    }
		    babelPluginPolyfillRegenerator = bool(browser$1$1.env["BABEL_8_BREAKING"]) ? null : requireLib();
		    return babelPluginPolyfillRegenerator;
		  }

		  var utils = {};

		  var hasRequiredUtils;
		  function requireUtils() {
		    if (hasRequiredUtils) return utils;
		    hasRequiredUtils = 1;
		    utils.getImportSource = function (_ref) {
		      var node = _ref.node;
		      if (node.specifiers.length === 0) return node.source.value;
		    };
		    utils.getRequireSource = function (_ref2) {
		      var node = _ref2.node;
		      if (node.type !== "ExpressionStatement") return;
		      var expression = node.expression;
		      if (expression.type === "CallExpression" && expression.callee.type === "Identifier" && expression.callee.name === "require" && expression.arguments.length === 1 && expression.arguments[0].type === "StringLiteral") {
		        return expression.arguments[0].value;
		      }
		    };
		    utils.isPolyfillSource = function (source) {
		      return source === "@babel/polyfill" || source === "core-js";
		    };
		    return utils;
		  }

		  var _templateObject$1, _templateObject2$1, _templateObject3$1, _templateObject4;
		  var babelPolyfill;
		  var hasRequiredBabelPolyfill;
		  function requireBabelPolyfill() {
		    if (hasRequiredBabelPolyfill) return babelPolyfill;
		    hasRequiredBabelPolyfill = 1;
		    var _require$$ = requireUtils(),
		      getImportSource = _require$$.getImportSource,
		      getRequireSource = _require$$.getRequireSource,
		      isPolyfillSource = _require$$.isPolyfillSource;
		    var BABEL_POLYFILL_DEPRECATION = "\n  `@babel/polyfill` is deprecated. Please, use required parts of `core-js`\n  and `regenerator-runtime/runtime` separately";
		    var NO_DIRECT_POLYFILL_IMPORT = "\n  When setting `useBuiltIns: 'usage'`, polyfills are automatically imported when needed.\n  Please remove the direct import of `SPECIFIER` or use `useBuiltIns: 'entry'` instead.";
		    babelPolyfill = function babelPolyfill(_ref, _ref2) {
		      var template = _ref.template;
		      var regenerator = _ref2.regenerator,
		        deprecated = _ref2.deprecated,
		        usage = _ref2.usage;
		      return {
		        name: "preset-env/replace-babel-polyfill",
		        visitor: {
		          ImportDeclaration: function ImportDeclaration(path) {
		            var src = getImportSource(path);
		            if (usage && isPolyfillSource(src)) {
		              console.warn(NO_DIRECT_POLYFILL_IMPORT.replace("SPECIFIER", src));
		              if (!deprecated) path.remove();
		            } else if (src === "@babel/polyfill") {
		              if (deprecated) {
		                console.warn(BABEL_POLYFILL_DEPRECATION);
		              } else if (regenerator) {
		                path.replaceWithMultiple(template.ast(_templateObject$1 || (_templateObject$1 = _taggedTemplateLiteralLoose(["\n              import \"core-js\";\n              import \"regenerator-runtime/runtime.js\";\n            "]))));
		              } else {
		                path.replaceWith(template.ast(_templateObject2$1 || (_templateObject2$1 = _taggedTemplateLiteralLoose(["\n              import \"core-js\";\n            "]))));
		              }
		            }
		          },
		          Program: function Program(path) {
		            path.get("body").forEach(function (bodyPath) {
		              var src = getRequireSource(bodyPath);
		              if (usage && isPolyfillSource(src)) {
		                console.warn(NO_DIRECT_POLYFILL_IMPORT.replace("SPECIFIER", src));
		                if (!deprecated) bodyPath.remove();
		              } else if (src === "@babel/polyfill") {
		                if (deprecated) {
		                  console.warn(BABEL_POLYFILL_DEPRECATION);
		                } else if (regenerator) {
		                  bodyPath.replaceWithMultiple(template.ast(_templateObject3$1 || (_templateObject3$1 = _taggedTemplateLiteralLoose(["\n                require(\"core-js\");\n                require(\"regenerator-runtime/runtime.js\");\n              "]))));
		                } else {
		                  bodyPath.replaceWith(template.ast(_templateObject4 || (_templateObject4 = _taggedTemplateLiteralLoose(["\n                require(\"core-js\");\n              "]))));
		                }
		              }
		            });
		          }
		        }
		      };
		    };
		    return babelPolyfill;
		  }

		  var regenerator;
		  var hasRequiredRegenerator;
		  function requireRegenerator() {
		    if (hasRequiredRegenerator) return regenerator;
		    hasRequiredRegenerator = 1;
		    var _require$$ = requireUtils(),
		      getImportSource = _require$$.getImportSource,
		      getRequireSource = _require$$.getRequireSource;
		    function isRegeneratorSource(source) {
		      return source === "regenerator-runtime/runtime" || source === "regenerator-runtime/runtime.js";
		    }
		    regenerator = function regenerator() {
		      var visitor = {
		        ImportDeclaration: function ImportDeclaration(path) {
		          if (isRegeneratorSource(getImportSource(path))) {
		            this.regeneratorImportExcluded = true;
		            path.remove();
		          }
		        },
		        Program: function Program(path) {
		          var _this = this;
		          path.get("body").forEach(function (bodyPath) {
		            if (isRegeneratorSource(getRequireSource(bodyPath))) {
		              _this.regeneratorImportExcluded = true;
		              bodyPath.remove();
		            }
		          });
		        }
		      };
		      return {
		        name: "preset-env/remove-regenerator",
		        visitor: visitor,
		        pre: function pre() {
		          this.regeneratorImportExcluded = false;
		        },
		        post: function post() {
		          if (this.opts.debug && this.regeneratorImportExcluded) {
		            var filename = this.file.opts.filename;
		            if (browser$1$1.env.BABEL_ENV === "test") {
		              filename = filename.replace(/\\/g, "/");
		            }
		            console.log("\n[" + filename + "] Based on your targets, regenerator-runtime import excluded.");
		          }
		        }
		      };
		    };
		    return regenerator;
		  }

		  (function (exports) {
		    {
		      Object.defineProperties(exports, {
		        pluginCoreJS2: {
		          get: function get() {
		            return requireBabelPluginPolyfillCorejs2()["default"];
		          }
		        },
		        pluginRegenerator: {
		          get: function get() {
		            return requireBabelPluginPolyfillRegenerator()["default"];
		          }
		        },
		        legacyBabelPolyfillPlugin: {
		          get: function get() {
		            return requireBabelPolyfill();
		          }
		        },
		        removeRegeneratorEntryPlugin: {
		          get: function get() {
		            return requireRegenerator();
		          }
		        },
		        corejs2Polyfills: {
		          get: function get() {
		            return requireCorejs2BuiltIns();
		          }
		        }
		      });
		    }
		  })(babel7Plugins);

		  var v$1 = new OptionValidator("@babel/preset-env");
		  var allPluginsList = Object.keys(plugins);
		  var modulePlugins = ["transform-dynamic-import"].concat(_toConsumableArray(Object.keys(moduleTransformations).map(function (m) {
		    return moduleTransformations[m];
		  })));
		  var getValidIncludesAndExcludes = function getValidIncludesAndExcludes(type, corejs) {
		    var set = new Set(allPluginsList);
		    if (type === "exclude") modulePlugins.map(set.add, set);
		    if (corejs) {
		      if (corejs === 2) {
		        Object.keys(babel7Plugins.corejs2Polyfills).map(set.add, set);
		        set.add("web.timers").add("web.immediate").add("web.dom.iterable");
		      } else {
		        Object.keys(require$$0$3).map(set.add, set);
		      }
		    }
		    return Array.from(set);
		  };
		  function flatMap(array, fn) {
		    return Array.prototype.concat.apply([], array.map(fn));
		  }
		  var normalizePluginName = function normalizePluginName(plugin) {
		    return plugin.replace(/^(@babel\/|babel-)(plugin-)?/, "");
		  };
		  var expandIncludesAndExcludes = function expandIncludesAndExcludes(filterList, type, corejs) {
		    if (filterList === void 0) {
		      filterList = [];
		    }
		    if (filterList.length === 0) return [];
		    var filterableItems = getValidIncludesAndExcludes(type, corejs);
		    var invalidFilters = [];
		    var selectedPlugins = flatMap(filterList, function (filter) {
		      var re;
		      if (typeof filter === "string") {
		        try {
		          re = new RegExp("^" + normalizePluginName(filter) + "$");
		        } catch (e) {
		          invalidFilters.push(filter);
		          return [];
		        }
		      } else {
		        re = filter;
		      }
		      var items = filterableItems.filter(function (item) {
		        return re.test(item) || re.test(item.replace(/^transform-/, "proposal-"));
		      });
		      if (items.length === 0) invalidFilters.push(filter);
		      return items;
		    });
		    v$1.invariant(invalidFilters.length === 0, "The plugins/built-ins '" + invalidFilters.join(", ") + "' passed to the '" + type + "' option are not\n    valid. Please check data/[plugin-features|built-in-features].js in babel-preset-env");
		    return selectedPlugins;
		  };
		  var checkDuplicateIncludeExcludes = function checkDuplicateIncludeExcludes(include, exclude) {
		    if (include === void 0) {
		      include = [];
		    }
		    if (exclude === void 0) {
		      exclude = [];
		    }
		    var duplicates = include.filter(function (opt) {
		      return exclude.indexOf(opt) >= 0;
		    });
		    v$1.invariant(duplicates.length === 0, "The plugins/built-ins '" + duplicates.join(", ") + "' were found in both the \"include\" and\n    \"exclude\" options.");
		  };
		  var normalizeTargets = function normalizeTargets(targets) {
		    if (typeof targets === "string" || Array.isArray(targets)) {
		      return {
		        browsers: targets
		      };
		    }
		    return Object.assign({}, targets);
		  };
		  var validateModulesOption = function validateModulesOption(modulesOpt) {
		    if (modulesOpt === void 0) {
		      modulesOpt = ModulesOption.auto;
		    }
		    v$1.invariant(ModulesOption[modulesOpt.toString()] || modulesOpt === ModulesOption["false"], "The 'modules' option must be one of \n" + " - 'false' to indicate no module processing\n" + " - a specific module type: 'commonjs', 'amd', 'umd', 'systemjs'" + " - 'auto' (default) which will automatically select 'false' if the current\n" + "   process is known to support ES module syntax, or \"commonjs\" otherwise\n");
		    return modulesOpt;
		  };
		  var validateUseBuiltInsOption = function validateUseBuiltInsOption(builtInsOpt) {
		    if (builtInsOpt === void 0) {
		      builtInsOpt = false;
		    }
		    v$1.invariant(UseBuiltInsOption[builtInsOpt.toString()] || builtInsOpt === UseBuiltInsOption["false"], "The 'useBuiltIns' option must be either\n    'false' (default) to indicate no polyfill,\n    '\"entry\"' to indicate replacing the entry polyfill, or\n    '\"usage\"' to import only used polyfills per file");
		    return builtInsOpt;
		  };
		  function normalizeCoreJSOption(corejs, useBuiltIns) {
		    var proposals = false;
		    var rawVersion;
		    if (useBuiltIns && corejs === undefined) {
		      {
		        rawVersion = 2;
		        console.warn("\nWARNING (@babel/preset-env): We noticed you're using the `useBuiltIns` option without declaring a " + "core-js version. Currently, we assume version 2.x when no version " + "is passed. Since this default version will likely change in future " + "versions of Babel, we recommend explicitly setting the core-js version " + "you are using via the `corejs` option.\n" + "\nYou should also be sure that the version you pass to the `corejs` " + "option matches the version specified in your `package.json`'s " + "`dependencies` section. If it doesn't, you need to run one of the " + "following commands:\n\n" + "  npm install --save core-js@2    npm install --save core-js@3\n" + "  yarn add core-js@2              yarn add core-js@3\n\n" + "More info about useBuiltIns: https://babeljs.io/docs/en/babel-preset-env#usebuiltins\n" + "More info about core-js: https://babeljs.io/docs/en/babel-preset-env#corejs");
		      }
		    } else if (typeof corejs === "object" && corejs !== null) {
		      rawVersion = corejs.version;
		      proposals = Boolean(corejs.proposals);
		    } else {
		      rawVersion = corejs;
		    }
		    var version = rawVersion ? semver$1.coerce(String(rawVersion)) : false;
		    if (version) {
		      if (useBuiltIns) {
		        {
		          if (version.major < 2 || version.major > 3) {
		            throw new RangeError("Invalid Option: The version passed to `corejs` is invalid. Currently, " + "only core-js@2 and core-js@3 are supported.");
		          }
		        }
		      } else {
		        console.warn("\nWARNING (@babel/preset-env): The `corejs` option only has an effect when the `useBuiltIns` option is not `false`\n");
		      }
		    }
		    return {
		      version: version,
		      proposals: proposals
		    };
		  }
		  function normalizeOptions$3(opts) {
		    v$1.validateTopLevelOptions(opts, TopLevelOptions);
		    var useBuiltIns = validateUseBuiltInsOption(opts.useBuiltIns);
		    var corejs = normalizeCoreJSOption(opts.corejs, useBuiltIns);
		    var include = expandIncludesAndExcludes(opts.include, TopLevelOptions.include, !!corejs.version && corejs.version.major);
		    var exclude = expandIncludesAndExcludes(opts.exclude, TopLevelOptions.exclude, !!corejs.version && corejs.version.major);
		    checkDuplicateIncludeExcludes(include, exclude);
		    {
		      v$1.validateBooleanOption("loose", opts.loose);
		      v$1.validateBooleanOption("spec", opts.spec);
		    }
		    return {
		      bugfixes: v$1.validateBooleanOption(TopLevelOptions.bugfixes, opts.bugfixes, false),
		      configPath: v$1.validateStringOption(TopLevelOptions.configPath, opts.configPath, browser$1$1.cwd()),
		      corejs: corejs,
		      debug: v$1.validateBooleanOption(TopLevelOptions.debug, opts.debug, false),
		      include: include,
		      exclude: exclude,
		      forceAllTransforms: v$1.validateBooleanOption(TopLevelOptions.forceAllTransforms, opts.forceAllTransforms, false),
		      ignoreBrowserslistConfig: v$1.validateBooleanOption(TopLevelOptions.ignoreBrowserslistConfig, opts.ignoreBrowserslistConfig, false),
		      modules: validateModulesOption(opts.modules),
		      shippedProposals: v$1.validateBooleanOption(TopLevelOptions.shippedProposals, opts.shippedProposals, false),
		      targets: normalizeTargets(opts.targets),
		      useBuiltIns: useBuiltIns,
		      browserslistEnv: v$1.validateStringOption(TopLevelOptions.browserslistEnv, opts.browserslistEnv)
		    };
		  }

		  var proposalPlugins = new Set();
		  var proposalSyntaxPlugins = ["syntax-import-assertions", "syntax-import-attributes"];
		  var pluginSyntaxObject = {
		    "transform-async-generator-functions": "syntax-async-generators",
		    "transform-class-properties": "syntax-class-properties",
		    "transform-class-static-block": "syntax-class-static-block",
		    "transform-export-namespace-from": "syntax-export-namespace-from",
		    "transform-json-strings": "syntax-json-strings",
		    "transform-nullish-coalescing-operator": "syntax-nullish-coalescing-operator",
		    "transform-numeric-separator": "syntax-numeric-separator",
		    "transform-object-rest-spread": "syntax-object-rest-spread",
		    "transform-optional-catch-binding": "syntax-optional-catch-binding",
		    "transform-optional-chaining": "syntax-optional-chaining",
		    "transform-private-methods": "syntax-class-properties",
		    "transform-private-property-in-object": "syntax-private-property-in-object",
		    "transform-unicode-property-regex": null
		  };
		  var pluginSyntaxEntries = Object.keys(pluginSyntaxObject).map(function (key) {
		    return [key, pluginSyntaxObject[key]];
		  });
		  var pluginSyntaxMap = new Map(pluginSyntaxEntries);

		  var data = require$$0$3;

		  var getModulesListForTargetVersion = getModulesListForTargetVersion$2;

		  var entries = require$$0$2;

		  var _excluded = ["method", "targets", "ignoreBrowserslistConfig", "configPath", "debug", "shouldInjectPolyfill", "absoluteImports"];
		  var _templateObject, _templateObject2, _templateObject3;
		  var _ref2$1 = _babel,
		    t$1$1 = _ref2$1.types,
		    template = _ref2$1.template;
		  function intersection(a, b) {
		    var result = new Set();
		    a.forEach(function (v) {
		      return b.has(v) && result.add(v);
		    });
		    return result;
		  }
		  function has$1(object, key) {
		    return Object.prototype.hasOwnProperty.call(object, key);
		  }
		  function getType(target) {
		    return Object.prototype.toString.call(target).slice(8, -1);
		  }
		  function resolveId(path) {
		    if (path.isIdentifier() && !path.scope.hasBinding(path.node.name, true)) {
		      return path.node.name;
		    }
		    if (path.isPure()) {
		      var _path$evaluate = path.evaluate(),
		        deopt = _path$evaluate.deopt;
		      if (deopt && deopt.isIdentifier()) {
		        return deopt.node.name;
		      }
		    }
		  }
		  function resolveKey(path, computed) {
		    if (computed === void 0) {
		      computed = false;
		    }
		    var scope = path.scope;
		    if (path.isStringLiteral()) return path.node.value;
		    var isIdentifier = path.isIdentifier();
		    if (isIdentifier && !(computed || path.parent.computed)) {
		      return path.node.name;
		    }
		    if (computed && path.isMemberExpression() && path.get("object").isIdentifier({
		      name: "Symbol"
		    }) && !scope.hasBinding("Symbol", true)) {
		      var sym = resolveKey(path.get("property"), path.node.computed);
		      if (sym) return "Symbol." + sym;
		    }
		    if (isIdentifier ? scope.hasBinding(path.node.name, true) : path.isPure()) {
		      var _path$evaluate2 = path.evaluate(),
		        value = _path$evaluate2.value;
		      if (typeof value === "string") return value;
		    }
		  }
		  function resolveSource(obj) {
		    if (obj.isMemberExpression() && obj.get("property").isIdentifier({
		      name: "prototype"
		    })) {
		      var _id = resolveId(obj.get("object"));
		      if (_id) {
		        return {
		          id: _id,
		          placement: "prototype"
		        };
		      }
		      return {
		        id: null,
		        placement: null
		      };
		    }
		    var id = resolveId(obj);
		    if (id) {
		      return {
		        id: id,
		        placement: "static"
		      };
		    }
		    if (obj.isRegExpLiteral()) {
		      return {
		        id: "RegExp",
		        placement: "prototype"
		      };
		    } else if (obj.isFunction()) {
		      return {
		        id: "Function",
		        placement: "prototype"
		      };
		    } else if (obj.isPure()) {
		      var _obj$evaluate = obj.evaluate(),
		        value = _obj$evaluate.value;
		      if (value !== undefined) {
		        return {
		          id: getType(value),
		          placement: "prototype"
		        };
		      }
		    }
		    return {
		      id: null,
		      placement: null
		    };
		  }
		  function getImportSource(_ref3) {
		    var node = _ref3.node;
		    if (node.specifiers.length === 0) return node.source.value;
		  }
		  function getRequireSource(_ref4) {
		    var node = _ref4.node;
		    if (!t$1$1.isExpressionStatement(node)) return;
		    var expression = node.expression;
		    if (t$1$1.isCallExpression(expression) && t$1$1.isIdentifier(expression.callee) && expression.callee.name === "require" && expression.arguments.length === 1 && t$1$1.isStringLiteral(expression.arguments[0])) {
		      return expression.arguments[0].value;
		    }
		  }
		  function hoist(node) {
		    node._blockHoist = 3;
		    return node;
		  }
		  function createUtilsGetter(cache) {
		    return function (path) {
		      var prog = path.findParent(function (p) {
		        return p.isProgram();
		      });
		      return {
		        injectGlobalImport: function injectGlobalImport(url, moduleName) {
		          cache.storeAnonymous(prog, url, moduleName, function (isScript, source) {
		            return isScript ? template.statement.ast(_templateObject || (_templateObject = _taggedTemplateLiteralLoose(["require(", ")"])), source) : t$1$1.importDeclaration([], source);
		          });
		        },
		        injectNamedImport: function injectNamedImport(url, name, hint, moduleName) {
		          if (hint === void 0) {
		            hint = name;
		          }
		          return cache.storeNamed(prog, url, name, moduleName, function (isScript, source, name) {
		            var id = prog.scope.generateUidIdentifier(hint);
		            return {
		              node: isScript ? hoist(template.statement.ast(_templateObject2 || (_templateObject2 = _taggedTemplateLiteralLoose(["\n                  var ", " = require(", ").", "\n                "])), id, source, name)) : t$1$1.importDeclaration([t$1$1.importSpecifier(id, name)], source),
		              name: id.name
		            };
		          });
		        },
		        injectDefaultImport: function injectDefaultImport(url, hint, moduleName) {
		          if (hint === void 0) {
		            hint = url;
		          }
		          return cache.storeNamed(prog, url, "default", moduleName, function (isScript, source) {
		            var id = prog.scope.generateUidIdentifier(hint);
		            return {
		              node: isScript ? hoist(template.statement.ast(_templateObject3 || (_templateObject3 = _taggedTemplateLiteralLoose(["var ", " = require(", ")"])), id, source)) : t$1$1.importDeclaration([t$1$1.importDefaultSpecifier(id)], source),
		              name: id.name
		            };
		          });
		        }
		      };
		    };
		  }
		  var _ref5 = _babel,
		    t$3 = _ref5.types;
		  var ImportsCachedInjector = function () {
		    function ImportsCachedInjector(resolver, getPreferredIndex) {
		      this._imports = new WeakMap();
		      this._anonymousImports = new WeakMap();
		      this._lastImports = new WeakMap();
		      this._resolver = resolver;
		      this._getPreferredIndex = getPreferredIndex;
		    }
		    var _proto = ImportsCachedInjector.prototype;
		    _proto.storeAnonymous = function storeAnonymous(programPath, url, moduleName, getVal) {
		      var key = this._normalizeKey(programPath, url);
		      var imports = this._ensure(this._anonymousImports, programPath, Set);
		      if (imports.has(key)) return;
		      var node = getVal(programPath.node.sourceType === "script", t$3.stringLiteral(this._resolver(url)));
		      imports.add(key);
		      this._injectImport(programPath, node, moduleName);
		    };
		    _proto.storeNamed = function storeNamed(programPath, url, name, moduleName, getVal) {
		      var key = this._normalizeKey(programPath, url, name);
		      var imports = this._ensure(this._imports, programPath, Map);
		      if (!imports.has(key)) {
		        var _getVal = getVal(programPath.node.sourceType === "script", t$3.stringLiteral(this._resolver(url)), t$3.identifier(name)),
		          node = _getVal.node,
		          id = _getVal.name;
		        imports.set(key, id);
		        this._injectImport(programPath, node, moduleName);
		      }
		      return t$3.identifier(imports.get(key));
		    };
		    _proto._injectImport = function _injectImport(programPath, node, moduleName) {
		      var _this$_lastImports$ge;
		      var newIndex = this._getPreferredIndex(moduleName);
		      var lastImports = (_this$_lastImports$ge = this._lastImports.get(programPath)) != null ? _this$_lastImports$ge : [];
		      var isPathStillValid = function isPathStillValid(path) {
		        return path.node && path.parent === programPath.node && path.container === programPath.node.body;
		      };
		      var last;
		      if (newIndex === Infinity) {
		        if (lastImports.length > 0) {
		          last = lastImports[lastImports.length - 1].path;
		          if (!isPathStillValid(last)) last = undefined;
		        }
		      } else {
		        for (var _iterator = _createForOfIteratorHelperLoose(lastImports.entries()), _step; !(_step = _iterator()).done;) {
		          var _step$value = _slicedToArray(_step.value, 2),
		            i = _step$value[0],
		            data = _step$value[1];
		          var path = data.path,
		            index = data.index;
		          if (isPathStillValid(path)) {
		            if (newIndex < index) {
		              var _path$insertBefore = path.insertBefore(node),
		                _path$insertBefore2 = _slicedToArray(_path$insertBefore, 1),
		                newPath = _path$insertBefore2[0];
		              lastImports.splice(i, 0, {
		                path: newPath,
		                index: newIndex
		              });
		              return;
		            }
		            last = path;
		          }
		        }
		      }
		      if (last) {
		        var _last$insertAfter = last.insertAfter(node),
		          _last$insertAfter2 = _slicedToArray(_last$insertAfter, 1),
		          _newPath = _last$insertAfter2[0];
		        lastImports.push({
		          path: _newPath,
		          index: newIndex
		        });
		      } else {
		        var _programPath$unshiftC = programPath.unshiftContainer("body", node),
		          _programPath$unshiftC2 = _slicedToArray(_programPath$unshiftC, 1),
		          _newPath2 = _programPath$unshiftC2[0];
		        this._lastImports.set(programPath, [{
		          path: _newPath2,
		          index: newIndex
		        }]);
		      }
		    };
		    _proto._ensure = function _ensure(map, programPath, Collection) {
		      var collection = map.get(programPath);
		      if (!collection) {
		        collection = new Collection();
		        map.set(programPath, collection);
		      }
		      return collection;
		    };
		    _proto._normalizeKey = function _normalizeKey(programPath, url, name) {
		      if (name === void 0) {
		        name = "";
		      }
		      var sourceType = programPath.node.sourceType;
		      return (name && sourceType) + "::" + url + "::" + name;
		    };
		    return _createClass(ImportsCachedInjector);
		  }();
		  var presetEnvSilentDebugHeader = "#__secret_key__@babel/preset-env__don't_log_debug_header_and_resolved_targets";
		  function stringifyTargetsMultiline(targets) {
		    return JSON.stringify(prettifyTargets(targets), null, 2);
		  }
		  function patternToRegExp(pattern) {
		    if (pattern instanceof RegExp) return pattern;
		    try {
		      return new RegExp("^" + pattern + "$");
		    } catch (_unused) {
		      return null;
		    }
		  }
		  function buildUnusedError(label, unused) {
		    if (!unused.length) return "";
		    return "  - The following \"" + label + "\" patterns didn't match any polyfill:\n" + unused.map(function (original) {
		      return "    " + String(original) + "\n";
		    }).join("");
		  }
		  function buldDuplicatesError(duplicates) {
		    if (!duplicates.size) return "";
		    return "  - The following polyfills were matched both by \"include\" and \"exclude\" patterns:\n" + Array.from(duplicates, function (name) {
		      return "    " + name + "\n";
		    }).join("");
		  }
		  function validateIncludeExclude(provider, polyfills, includePatterns, excludePatterns) {
		    var current;
		    var filter = function filter(pattern) {
		      var regexp = patternToRegExp(pattern);
		      if (!regexp) return false;
		      var matched = false;
		      for (var _iterator2 = _createForOfIteratorHelperLoose(polyfills.keys()), _step2; !(_step2 = _iterator2()).done;) {
		        var polyfill = _step2.value;
		        if (regexp.test(polyfill)) {
		          matched = true;
		          current.add(polyfill);
		        }
		      }
		      return !matched;
		    };
		    var include = current = new Set();
		    var unusedInclude = Array.from(includePatterns).filter(filter);
		    var exclude = current = new Set();
		    var unusedExclude = Array.from(excludePatterns).filter(filter);
		    var duplicates = intersection(include, exclude);
		    if (duplicates.size > 0 || unusedInclude.length > 0 || unusedExclude.length > 0) {
		      throw new Error("Error while validating the \"" + provider + "\" provider options:\n" + buildUnusedError("include", unusedInclude) + buildUnusedError("exclude", unusedExclude) + buldDuplicatesError(duplicates));
		    }
		    return {
		      include: include,
		      exclude: exclude
		    };
		  }
		  function applyMissingDependenciesDefaults(options, babelApi) {
		    var _options$missingDepen = options.missingDependencies,
		      missingDependencies = _options$missingDepen === void 0 ? {} : _options$missingDepen;
		    if (missingDependencies === false) return false;
		    var caller = babelApi.caller(function (caller) {
		      return caller == null ? void 0 : caller.name;
		    });
		    var _missingDependencies$ = missingDependencies.log,
		      log = _missingDependencies$ === void 0 ? "deferred" : _missingDependencies$,
		      _missingDependencies$2 = missingDependencies.inject,
		      inject = _missingDependencies$2 === void 0 ? caller === "rollup-plugin-babel" ? "throw" : "import" : _missingDependencies$2,
		      _missingDependencies$3 = missingDependencies.all,
		      all = _missingDependencies$3 === void 0 ? false : _missingDependencies$3;
		    return {
		      log: log,
		      inject: inject,
		      all: all
		    };
		  }
		  function isRemoved(path) {
		    if (path.removed) return true;
		    if (!path.parentPath) return false;
		    if (path.listKey) {
		      if (!path.parentPath.node[path.listKey].includes(path.node)) return true;
		    } else {
		      if (path.parentPath.node[path.key] !== path.node) return true;
		    }
		    return isRemoved(path.parentPath);
		  }
		  var usage = function usage(callProvider) {
		    function property(object, key, placement, path) {
		      return callProvider({
		        kind: "property",
		        object: object,
		        key: key,
		        placement: placement
		      }, path);
		    }
		    function handleReferencedIdentifier(path) {
		      var name = path.node.name,
		        scope = path.scope;
		      if (scope.getBindingIdentifier(name)) return;
		      callProvider({
		        kind: "global",
		        name: name
		      }, path);
		    }
		    function analyzeMemberExpression(path) {
		      var key = resolveKey(path.get("property"), path.node.computed);
		      return {
		        key: key,
		        handleAsMemberExpression: !!key && key !== "prototype"
		      };
		    }
		    return {
		      ReferencedIdentifier: function ReferencedIdentifier(path) {
		        var parentPath = path.parentPath;
		        if (parentPath.isMemberExpression({
		          object: path.node
		        }) && analyzeMemberExpression(parentPath).handleAsMemberExpression) {
		          return;
		        }
		        handleReferencedIdentifier(path);
		      },
		      MemberExpression: function MemberExpression(path) {
		        var _analyzeMemberExpress = analyzeMemberExpression(path),
		          key = _analyzeMemberExpress.key,
		          handleAsMemberExpression = _analyzeMemberExpress.handleAsMemberExpression;
		        if (!handleAsMemberExpression) return;
		        var object = path.get("object");
		        var objectIsGlobalIdentifier = object.isIdentifier();
		        if (objectIsGlobalIdentifier) {
		          var binding = object.scope.getBinding(object.node.name);
		          if (binding) {
		            if (binding.path.isImportNamespaceSpecifier()) return;
		            objectIsGlobalIdentifier = false;
		          }
		        }
		        var source = resolveSource(object);
		        var skipObject = property(source.id, key, source.placement, path);
		        skipObject || (skipObject = !objectIsGlobalIdentifier || path.shouldSkip || object.shouldSkip || isRemoved(object));
		        if (!skipObject) handleReferencedIdentifier(object);
		      },
		      ObjectPattern: function ObjectPattern(path) {
		        var parentPath = path.parentPath,
		          parent = path.parent;
		        var obj;
		        if (parentPath.isVariableDeclarator()) {
		          obj = parentPath.get("init");
		        } else if (parentPath.isAssignmentExpression()) {
		          obj = parentPath.get("right");
		        } else if (parentPath.isFunction()) {
		          var grand = parentPath.parentPath;
		          if (grand.isCallExpression() || grand.isNewExpression()) {
		            if (grand.node.callee === parent) {
		              obj = grand.get("arguments")[path.key];
		            }
		          }
		        }
		        var id = null;
		        var placement = null;
		        if (obj) {
		          var _resolveSource = resolveSource(obj);
		          id = _resolveSource.id;
		          placement = _resolveSource.placement;
		        }
		        for (var _iterator3 = _createForOfIteratorHelperLoose(path.get("properties")), _step3; !(_step3 = _iterator3()).done;) {
		          var prop = _step3.value;
		          if (prop.isObjectProperty()) {
		            var key = resolveKey(prop.get("key"));
		            if (key) property(id, key, placement, prop);
		          }
		        }
		      },
		      BinaryExpression: function BinaryExpression(path) {
		        if (path.node.operator !== "in") return;
		        var source = resolveSource(path.get("right"));
		        var key = resolveKey(path.get("left"), true);
		        if (!key) return;
		        callProvider({
		          kind: "in",
		          object: source.id,
		          key: key,
		          placement: source.placement
		        }, path);
		      }
		    };
		  };
		  var entry = function entry(callProvider) {
		    return {
		      ImportDeclaration: function ImportDeclaration(path) {
		        var source = getImportSource(path);
		        if (!source) return;
		        callProvider({
		          kind: "import",
		          source: source
		        }, path);
		      },
		      Program: function Program(path) {
		        path.get("body").forEach(function (bodyPath) {
		          var source = getRequireSource(bodyPath);
		          if (!source) return;
		          callProvider({
		            kind: "import",
		            source: source
		          }, bodyPath);
		        });
		      }
		    };
		  };
		  function resolve(dirname, moduleName, absoluteImports) {
		    if (absoluteImports === false) return moduleName;
		    throw new Error("\"absoluteImports\" is not supported in bundles prepared for the browser.");
		  }
		  function has(basedir, name) {
		    return true;
		  }
		  function logMissing(missingDeps) {}
		  function laterLogMissing(missingDeps) {}
		  var PossibleGlobalObjects = new Set(["global", "globalThis", "self", "window"]);
		  function createMetaResolver(polyfills) {
		    var staticP = polyfills["static"],
		      instanceP = polyfills.instance,
		      globalP = polyfills.global;
		    return function (meta) {
		      if (meta.kind === "global" && globalP && has$1(globalP, meta.name)) {
		        return {
		          kind: "global",
		          desc: globalP[meta.name],
		          name: meta.name
		        };
		      }
		      if (meta.kind === "property" || meta.kind === "in") {
		        var placement = meta.placement,
		          object = meta.object,
		          key = meta.key;
		        if (object && placement === "static") {
		          if (globalP && PossibleGlobalObjects.has(object) && has$1(globalP, key)) {
		            return {
		              kind: "global",
		              desc: globalP[key],
		              name: key
		            };
		          }
		          if (staticP && has$1(staticP, object) && has$1(staticP[object], key)) {
		            return {
		              kind: "static",
		              desc: staticP[object][key],
		              name: object + "$" + key
		            };
		          }
		        }
		        if (instanceP && has$1(instanceP, key)) {
		          return {
		            kind: "instance",
		            desc: instanceP[key],
		            name: "" + key
		          };
		        }
		      }
		    };
		  }
		  var getTargets = getTargets$1["default"] || getTargets$1;
		  function resolveOptions(options, babelApi) {
		    var method = options.method,
		      targetsOption = options.targets,
		      ignoreBrowserslistConfig = options.ignoreBrowserslistConfig,
		      configPath = options.configPath,
		      debug = options.debug,
		      shouldInjectPolyfill = options.shouldInjectPolyfill,
		      absoluteImports = options.absoluteImports,
		      providerOptions = _objectWithoutProperties(options, _excluded);
		    if (isEmpty(options)) {
		      throw new Error("This plugin requires options, for example:\n    {\n      \"plugins\": [\n        [\"<plugin name>\", { method: \"usage-pure\" }]\n      ]\n    }\n\nSee more options at https://github.com/babel/babel-polyfills/blob/main/docs/usage.md");
		    }
		    var methodName;
		    if (method === "usage-global") methodName = "usageGlobal";else if (method === "entry-global") methodName = "entryGlobal";else if (method === "usage-pure") methodName = "usagePure";else if (typeof method !== "string") {
		      throw new Error(".method must be a string");
		    } else {
		      throw new Error(".method must be one of \"entry-global\", \"usage-global\"" + (" or \"usage-pure\" (received " + JSON.stringify(method) + ")"));
		    }
		    if (typeof shouldInjectPolyfill === "function") {
		      if (options.include || options.exclude) {
		        throw new Error(".include and .exclude are not supported when using the" + " .shouldInjectPolyfill function.");
		      }
		    } else if (shouldInjectPolyfill != null) {
		      throw new Error(".shouldInjectPolyfill must be a function, or undefined" + (" (received " + JSON.stringify(shouldInjectPolyfill) + ")"));
		    }
		    if (absoluteImports != null && typeof absoluteImports !== "boolean" && typeof absoluteImports !== "string") {
		      throw new Error(".absoluteImports must be a boolean, a string, or undefined" + (" (received " + JSON.stringify(absoluteImports) + ")"));
		    }
		    var targets;
		    if (targetsOption || configPath || ignoreBrowserslistConfig) {
		      var targetsObj = typeof targetsOption === "string" || Array.isArray(targetsOption) ? {
		        browsers: targetsOption
		      } : targetsOption;
		      targets = getTargets(targetsObj, {
		        ignoreBrowserslistConfig: ignoreBrowserslistConfig,
		        configPath: configPath
		      });
		    } else {
		      targets = babelApi.targets();
		    }
		    return {
		      method: method,
		      methodName: methodName,
		      targets: targets,
		      absoluteImports: absoluteImports != null ? absoluteImports : false,
		      shouldInjectPolyfill: shouldInjectPolyfill,
		      debug: !!debug,
		      providerOptions: providerOptions
		    };
		  }
		  function instantiateProvider(factory, options, missingDependencies, dirname, debugLog, babelApi) {
		    var _resolveOptions = resolveOptions(options, babelApi),
		      method = _resolveOptions.method,
		      methodName = _resolveOptions.methodName,
		      targets = _resolveOptions.targets,
		      _debug = _resolveOptions.debug,
		      _shouldInjectPolyfill = _resolveOptions.shouldInjectPolyfill,
		      providerOptions = _resolveOptions.providerOptions,
		      absoluteImports = _resolveOptions.absoluteImports;
		    var include, exclude;
		    var polyfillsSupport;
		    var polyfillsNames;
		    var filterPolyfills;
		    var getUtils = createUtilsGetter(new ImportsCachedInjector(function (moduleName) {
		      return resolve(dirname, moduleName, absoluteImports);
		    }, function (name) {
		      var _polyfillsNames$get, _polyfillsNames;
		      return (_polyfillsNames$get = (_polyfillsNames = polyfillsNames) == null ? void 0 : _polyfillsNames.get(name)) != null ? _polyfillsNames$get : Infinity;
		    }));
		    var depsCache = new Map();
		    var api = {
		      babel: babelApi,
		      getUtils: getUtils,
		      method: options.method,
		      targets: targets,
		      createMetaResolver: createMetaResolver,
		      shouldInjectPolyfill: function shouldInjectPolyfill(name) {
		        if (polyfillsNames === undefined) {
		          throw new Error("Internal error in the " + factory.name + " provider: " + "shouldInjectPolyfill() can't be called during initialization.");
		        }
		        if (!polyfillsNames.has(name)) {
		          console.warn("Internal error in the " + providerName + " provider: " + ("unknown polyfill \"" + name + "\"."));
		        }
		        if (filterPolyfills && !filterPolyfills(name)) return false;
		        var shouldInject = isRequired(name, targets, {
		          compatData: polyfillsSupport,
		          includes: include,
		          excludes: exclude
		        });
		        if (_shouldInjectPolyfill) {
		          shouldInject = _shouldInjectPolyfill(name, shouldInject);
		          if (typeof shouldInject !== "boolean") {
		            throw new Error(".shouldInjectPolyfill must return a boolean.");
		          }
		        }
		        return shouldInject;
		      },
		      debug: function debug(name) {
		        var _debugLog, _debugLog$polyfillsSu;
		        debugLog().found = true;
		        if (!_debug || !name) return;
		        if (debugLog().polyfills.has(providerName)) return;
		        debugLog().polyfills.add(name);
		        (_debugLog$polyfillsSu = (_debugLog = debugLog()).polyfillsSupport) != null ? _debugLog$polyfillsSu : _debugLog.polyfillsSupport = polyfillsSupport;
		      },
		      assertDependency: function assertDependency(name, version) {
		        if (version === void 0) {
		          version = "*";
		        }
		        if (missingDependencies === false) return;
		        if (absoluteImports) {
		          return;
		        }
		        var dep = version === "*" ? name : name + "@^" + version;
		        var found = missingDependencies.all ? false : mapGetOr(depsCache, name + " :: " + dirname, function () {
		          return has();
		        });
		        if (!found) {
		          debugLog().missingDeps.add(dep);
		        }
		      }
		    };
		    var provider = factory(api, providerOptions, dirname);
		    var providerName = provider.name || factory.name;
		    if (typeof provider[methodName] !== "function") {
		      throw new Error("The \"" + providerName + "\" provider doesn't support the \"" + method + "\" polyfilling method.");
		    }
		    if (Array.isArray(provider.polyfills)) {
		      polyfillsNames = new Map(provider.polyfills.map(function (name, index) {
		        return [name, index];
		      }));
		      filterPolyfills = provider.filterPolyfills;
		    } else if (provider.polyfills) {
		      polyfillsNames = new Map(Object.keys(provider.polyfills).map(function (name, index) {
		        return [name, index];
		      }));
		      polyfillsSupport = provider.polyfills;
		      filterPolyfills = provider.filterPolyfills;
		    } else {
		      polyfillsNames = new Map();
		    }
		    var _validateIncludeExclu = validateIncludeExclude(providerName, polyfillsNames, providerOptions.include || [], providerOptions.exclude || []);
		    include = _validateIncludeExclu.include;
		    exclude = _validateIncludeExclu.exclude;
		    var callProvider;
		    if (methodName === "usageGlobal") {
		      callProvider = function callProvider(payload, path) {
		        var _ref;
		        var utils = getUtils(path);
		        return (_ref = provider[methodName](payload, utils, path)) != null ? _ref : false;
		      };
		    } else {
		      callProvider = function callProvider(payload, path) {
		        var utils = getUtils(path);
		        provider[methodName](payload, utils, path);
		        return false;
		      };
		    }
		    return {
		      debug: _debug,
		      method: method,
		      targets: targets,
		      provider: provider,
		      providerName: providerName,
		      callProvider: callProvider
		    };
		  }
		  function definePolyfillProvider(factory) {
		    return declare(function (babelApi, options, dirname) {
		      babelApi.assertVersion("^7.0.0 || ^8.0.0-alpha.0");
		      var traverse = babelApi.traverse;
		      var debugLog;
		      var missingDependencies = applyMissingDependenciesDefaults(options, babelApi);
		      var _instantiateProvider = instantiateProvider(factory, options, missingDependencies, dirname, function () {
		          return debugLog;
		        }, babelApi),
		        debug = _instantiateProvider.debug,
		        method = _instantiateProvider.method,
		        targets = _instantiateProvider.targets,
		        provider = _instantiateProvider.provider,
		        providerName = _instantiateProvider.providerName,
		        callProvider = _instantiateProvider.callProvider;
		      var createVisitor = method === "entry-global" ? entry : usage;
		      var visitor = provider.visitor ? traverse.visitors.merge([createVisitor(callProvider), provider.visitor]) : createVisitor(callProvider);
		      if (debug && debug !== presetEnvSilentDebugHeader) {
		        console.log(providerName + ": `DEBUG` option");
		        console.log("\nUsing targets: " + stringifyTargetsMultiline(targets));
		        console.log("\nUsing polyfills with `" + method + "` method:");
		      }
		      var runtimeName = provider.runtimeName;
		      return {
		        name: "inject-polyfills",
		        visitor: visitor,
		        pre: function pre(file) {
		          var _provider$pre;
		          if (runtimeName) {
		            if (file.get("runtimeHelpersModuleName") && file.get("runtimeHelpersModuleName") !== runtimeName) {
		              console.warn("Two different polyfill providers" + (" (" + file.get("runtimeHelpersModuleProvider")) + (" and " + providerName + ") are trying to define two") + " conflicting @babel/runtime alternatives:" + (" " + file.get("runtimeHelpersModuleName") + " and " + runtimeName + ".") + " The second one will be ignored.");
		            } else {
		              file.set("runtimeHelpersModuleName", runtimeName);
		              file.set("runtimeHelpersModuleProvider", providerName);
		            }
		          }
		          debugLog = {
		            polyfills: new Set(),
		            polyfillsSupport: undefined,
		            found: false,
		            providers: new Set(),
		            missingDeps: new Set()
		          };
		          (_provider$pre = provider.pre) == null ? void 0 : _provider$pre.apply(this, arguments);
		        },
		        post: function post() {
		          var _provider$post;
		          (_provider$post = provider.post) == null ? void 0 : _provider$post.apply(this, arguments);
		          if (missingDependencies !== false) {
		            if (missingDependencies.log === "per-file") {
		              logMissing(debugLog.missingDeps);
		            } else {
		              laterLogMissing(debugLog.missingDeps);
		            }
		          }
		          if (!debug) return;
		          if (this.filename) console.log("\n[" + this.filename + "]");
		          if (debugLog.polyfills.size === 0) {
		            console.log(method === "entry-global" ? debugLog.found ? "Based on your targets, the " + providerName + " polyfill did not add any polyfill." : "The entry point for the " + providerName + " polyfill has not been found." : "Based on your code and targets, the " + providerName + " polyfill did not add any polyfill.");
		            return;
		          }
		          if (method === "entry-global") {
		            console.log("The " + providerName + " polyfill entry has been replaced with " + "the following polyfills:");
		          } else {
		            console.log("The " + providerName + " polyfill added the following polyfills:");
		          }
		          for (var _iterator4 = _createForOfIteratorHelperLoose(debugLog.polyfills), _step4; !(_step4 = _iterator4()).done;) {
		            var name = _step4.value;
		            var _debugLog$polyfillsSu2;
		            if ((_debugLog$polyfillsSu2 = debugLog.polyfillsSupport) != null && _debugLog$polyfillsSu2[name]) {
		              var filteredTargets = getInclusionReasons(name, targets, debugLog.polyfillsSupport);
		              var formattedTargets = JSON.stringify(filteredTargets).replace(/,/g, ", ").replace(/^\{"/, '{ "').replace(/"\}$/, '" }');
		              console.log("  " + name + " " + formattedTargets);
		            } else {
		              console.log("  " + name);
		            }
		          }
		        }
		      };
		    });
		  }
		  function mapGetOr(map, key, getDefault) {
		    var val = map.get(key);
		    if (val === undefined) {
		      val = getDefault();
		      map.set(key, val);
		    }
		    return val;
		  }
		  function isEmpty(obj) {
		    return Object.keys(obj).length === 0;
		  }

		  var _InstanceProperties;
		  var corejs3ShippedProposalsList = new Set(["esnext.suppressed-error.constructor", "esnext.array.from-async", "esnext.array.group", "esnext.array.group-to-map", "esnext.iterator.constructor", "esnext.iterator.drop", "esnext.iterator.every", "esnext.iterator.filter", "esnext.iterator.find", "esnext.iterator.flat-map", "esnext.iterator.for-each", "esnext.iterator.from", "esnext.iterator.map", "esnext.iterator.reduce", "esnext.iterator.some", "esnext.iterator.take", "esnext.iterator.to-array", "esnext.json.is-raw-json", "esnext.json.parse", "esnext.json.raw-json", "esnext.set.difference.v2", "esnext.set.intersection.v2", "esnext.set.is-disjoint-from.v2", "esnext.set.is-subset-of.v2", "esnext.set.is-superset-of.v2", "esnext.set.symmetric-difference.v2", "esnext.set.union.v2", "esnext.symbol.async-dispose", "esnext.symbol.dispose", "esnext.symbol.metadata"]);
		  var polyfillsOrder = {};
		  Object.keys(data).forEach(function (name, index) {
		    polyfillsOrder[name] = index;
		  });
		  var define = function define(pure, global, name, exclude) {
		    if (name === void 0) {
		      name = global[0];
		    }
		    return {
		      name: name,
		      pure: pure,
		      global: global.sort(function (a, b) {
		        return polyfillsOrder[a] - polyfillsOrder[b];
		      }),
		      exclude: exclude
		    };
		  };
		  var typed = function typed() {
		    for (var _len = arguments.length, modules = new Array(_len), _key = 0; _key < _len; _key++) {
		      modules[_key] = arguments[_key];
		    }
		    return define(null, [].concat(modules, TypedArrayDependencies));
		  };
		  var ArrayNatureIterators = ["es.array.iterator", "web.dom-collections.iterator"];
		  var CommonIterators = ["es.string.iterator"].concat(ArrayNatureIterators);
		  var ArrayNatureIteratorsWithTag = ["es.object.to-string"].concat(ArrayNatureIterators);
		  var CommonIteratorsWithTag = ["es.object.to-string"].concat(_toConsumableArray(CommonIterators));
		  var ErrorDependencies = ["es.error.cause", "es.error.to-string"];
		  var SuppressedErrorDependencies = ["esnext.suppressed-error.constructor"].concat(ErrorDependencies);
		  var TypedArrayDependencies = ["es.typed-array.at", "es.typed-array.copy-within", "es.typed-array.every", "es.typed-array.fill", "es.typed-array.filter", "es.typed-array.find", "es.typed-array.find-index", "es.typed-array.find-last", "es.typed-array.find-last-index", "es.typed-array.for-each", "es.typed-array.includes", "es.typed-array.index-of", "es.typed-array.iterator", "es.typed-array.join", "es.typed-array.last-index-of", "es.typed-array.map", "es.typed-array.reduce", "es.typed-array.reduce-right", "es.typed-array.reverse", "es.typed-array.set", "es.typed-array.slice", "es.typed-array.some", "es.typed-array.sort", "es.typed-array.subarray", "es.typed-array.to-locale-string", "es.typed-array.to-reversed", "es.typed-array.to-sorted", "es.typed-array.to-string", "es.typed-array.with", "es.object.to-string", "es.array.iterator", "es.array-buffer.slice", "es.data-view", "es.array-buffer.detached", "es.array-buffer.transfer", "es.array-buffer.transfer-to-fixed-length", "esnext.typed-array.filter-reject", "esnext.typed-array.group-by", "esnext.typed-array.to-spliced", "esnext.typed-array.unique-by"];
		  var PromiseDependencies = ["es.promise", "es.object.to-string"];
		  var PromiseDependenciesWithIterators = [].concat(PromiseDependencies, _toConsumableArray(CommonIterators));
		  var SymbolDependencies = ["es.symbol", "es.symbol.description", "es.object.to-string"];
		  var MapDependencies = ["es.map", "esnext.map.delete-all", "esnext.map.emplace", "esnext.map.every", "esnext.map.filter", "esnext.map.find", "esnext.map.find-key", "esnext.map.includes", "esnext.map.key-of", "esnext.map.map-keys", "esnext.map.map-values", "esnext.map.merge", "esnext.map.reduce", "esnext.map.some", "esnext.map.update"].concat(_toConsumableArray(CommonIteratorsWithTag));
		  var SetDependencies = ["es.set", "esnext.set.add-all", "esnext.set.delete-all", "esnext.set.difference", "esnext.set.difference.v2", "esnext.set.every", "esnext.set.filter", "esnext.set.find", "esnext.set.intersection", "esnext.set.intersection.v2", "esnext.set.is-disjoint-from", "esnext.set.is-disjoint-from.v2", "esnext.set.is-subset-of", "esnext.set.is-subset-of.v2", "esnext.set.is-superset-of", "esnext.set.is-superset-of.v2", "esnext.set.join", "esnext.set.map", "esnext.set.reduce", "esnext.set.some", "esnext.set.symmetric-difference", "esnext.set.symmetric-difference.v2", "esnext.set.union", "esnext.set.union.v2"].concat(_toConsumableArray(CommonIteratorsWithTag));
		  var WeakMapDependencies = ["es.weak-map", "esnext.weak-map.delete-all", "esnext.weak-map.emplace"].concat(_toConsumableArray(CommonIteratorsWithTag));
		  var WeakSetDependencies = ["es.weak-set", "esnext.weak-set.add-all", "esnext.weak-set.delete-all"].concat(_toConsumableArray(CommonIteratorsWithTag));
		  var DOMExceptionDependencies = ["web.dom-exception.constructor", "web.dom-exception.stack", "web.dom-exception.to-string-tag", "es.error.to-string"];
		  var URLSearchParamsDependencies = ["web.url-search-params", "web.url-search-params.delete", "web.url-search-params.has", "web.url-search-params.size"].concat(_toConsumableArray(CommonIteratorsWithTag));
		  var AsyncIteratorDependencies = ["esnext.async-iterator.constructor"].concat(PromiseDependencies);
		  var AsyncIteratorProblemMethods = ["esnext.async-iterator.every", "esnext.async-iterator.filter", "esnext.async-iterator.find", "esnext.async-iterator.flat-map", "esnext.async-iterator.for-each", "esnext.async-iterator.map", "esnext.async-iterator.reduce", "esnext.async-iterator.some"];
		  var IteratorDependencies = ["esnext.iterator.constructor", "es.object.to-string"];
		  var DecoratorMetadataDependencies = ["esnext.symbol.metadata", "esnext.function.metadata"];
		  var TypedArrayStaticMethods = function TypedArrayStaticMethods(base) {
		    return {
		      from: define(null, ["es.typed-array.from", base].concat(TypedArrayDependencies)),
		      fromAsync: define(null, ["esnext.typed-array.from-async", base].concat(_toConsumableArray(PromiseDependenciesWithIterators), TypedArrayDependencies)),
		      of: define(null, ["es.typed-array.of", base].concat(TypedArrayDependencies))
		    };
		  };
		  var DataViewDependencies = ["es.data-view", "es.array-buffer.constructor", "es.array-buffer.slice", "es.array-buffer.detached", "es.array-buffer.transfer", "es.array-buffer.transfer-to-fixed-length", "es.object.to-string"];
		  var BuiltIns = {
		    AsyncDisposableStack: define("async-disposable-stack/index", ["esnext.async-disposable-stack.constructor", "es.object.to-string", "esnext.async-iterator.async-dispose", "esnext.iterator.dispose"].concat(PromiseDependencies, _toConsumableArray(SuppressedErrorDependencies))),
		    AsyncIterator: define("async-iterator/index", AsyncIteratorDependencies),
		    AggregateError: define("aggregate-error", ["es.aggregate-error"].concat(ErrorDependencies, _toConsumableArray(CommonIteratorsWithTag), ["es.aggregate-error.cause"])),
		    ArrayBuffer: define(null, ["es.array-buffer.constructor", "es.array-buffer.slice", "es.data-view", "es.array-buffer.detached", "es.array-buffer.transfer", "es.array-buffer.transfer-to-fixed-length", "es.object.to-string"]),
		    DataView: define(null, DataViewDependencies),
		    Date: define(null, ["es.date.to-string"]),
		    DOMException: define("dom-exception/index", DOMExceptionDependencies),
		    DisposableStack: define("disposable-stack/index", ["esnext.disposable-stack.constructor", "es.object.to-string", "esnext.iterator.dispose"].concat(_toConsumableArray(SuppressedErrorDependencies))),
		    Error: define(null, ErrorDependencies),
		    EvalError: define(null, ErrorDependencies),
		    Float32Array: typed("es.typed-array.float32-array"),
		    Float64Array: typed("es.typed-array.float64-array"),
		    Int8Array: typed("es.typed-array.int8-array"),
		    Int16Array: typed("es.typed-array.int16-array"),
		    Int32Array: typed("es.typed-array.int32-array"),
		    Iterator: define("iterator/index", IteratorDependencies),
		    Uint8Array: typed("es.typed-array.uint8-array", "esnext.uint8-array.to-base64", "esnext.uint8-array.to-hex"),
		    Uint8ClampedArray: typed("es.typed-array.uint8-clamped-array"),
		    Uint16Array: typed("es.typed-array.uint16-array"),
		    Uint32Array: typed("es.typed-array.uint32-array"),
		    Map: define("map/index", MapDependencies),
		    Number: define(null, ["es.number.constructor"]),
		    Observable: define("observable/index", ["esnext.observable", "esnext.symbol.observable", "es.object.to-string"].concat(_toConsumableArray(CommonIteratorsWithTag))),
		    Promise: define("promise/index", PromiseDependencies),
		    RangeError: define(null, ErrorDependencies),
		    ReferenceError: define(null, ErrorDependencies),
		    Reflect: define(null, ["es.reflect.to-string-tag", "es.object.to-string"]),
		    RegExp: define(null, ["es.regexp.constructor", "es.regexp.dot-all", "es.regexp.exec", "es.regexp.sticky", "es.regexp.to-string"]),
		    Set: define("set/index", SetDependencies),
		    SuppressedError: define("suppressed-error", SuppressedErrorDependencies),
		    Symbol: define("symbol/index", SymbolDependencies),
		    SyntaxError: define(null, ErrorDependencies),
		    TypeError: define(null, ErrorDependencies),
		    URIError: define(null, ErrorDependencies),
		    URL: define("url/index", ["web.url", "web.url.to-json"].concat(_toConsumableArray(URLSearchParamsDependencies))),
		    URLSearchParams: define("url-search-params/index", URLSearchParamsDependencies),
		    WeakMap: define("weak-map/index", WeakMapDependencies),
		    WeakSet: define("weak-set/index", WeakSetDependencies),
		    atob: define("atob", ["web.atob"].concat(DOMExceptionDependencies)),
		    btoa: define("btoa", ["web.btoa"].concat(DOMExceptionDependencies)),
		    clearImmediate: define("clear-immediate", ["web.immediate"]),
		    compositeKey: define("composite-key", ["esnext.composite-key"]),
		    compositeSymbol: define("composite-symbol", ["esnext.composite-symbol"]),
		    escape: define("escape", ["es.escape"]),
		    fetch: define(null, PromiseDependencies),
		    globalThis: define("global-this", ["es.global-this"]),
		    parseFloat: define("parse-float", ["es.parse-float"]),
		    parseInt: define("parse-int", ["es.parse-int"]),
		    queueMicrotask: define("queue-microtask", ["web.queue-microtask"]),
		    self: define("self", ["web.self"]),
		    setImmediate: define("set-immediate", ["web.immediate"]),
		    setInterval: define("set-interval", ["web.timers"]),
		    setTimeout: define("set-timeout", ["web.timers"]),
		    structuredClone: define("structured-clone", ["web.structured-clone"].concat(DOMExceptionDependencies, ["es.array.iterator", "es.object.keys", "es.object.to-string", "es.map", "es.set"])),
		    unescape: define("unescape", ["es.unescape"])
		  };
		  var StaticProperties = {
		    AsyncIterator: {
		      from: define("async-iterator/from", ["esnext.async-iterator.from"].concat(_toConsumableArray(AsyncIteratorDependencies), AsyncIteratorProblemMethods, _toConsumableArray(CommonIterators)))
		    },
		    Array: {
		      from: define("array/from", ["es.array.from", "es.string.iterator"]),
		      fromAsync: define("array/from-async", ["esnext.array.from-async"].concat(_toConsumableArray(PromiseDependenciesWithIterators))),
		      isArray: define("array/is-array", ["es.array.is-array"]),
		      isTemplateObject: define("array/is-template-object", ["esnext.array.is-template-object"]),
		      of: define("array/of", ["es.array.of"])
		    },
		    ArrayBuffer: {
		      isView: define(null, ["es.array-buffer.is-view"])
		    },
		    BigInt: {
		      range: define("bigint/range", ["esnext.bigint.range", "es.object.to-string"])
		    },
		    Date: {
		      now: define("date/now", ["es.date.now"])
		    },
		    Function: {
		      isCallable: define("function/is-callable", ["esnext.function.is-callable"]),
		      isConstructor: define("function/is-constructor", ["esnext.function.is-constructor"])
		    },
		    Iterator: {
		      from: define("iterator/from", ["esnext.iterator.from"].concat(IteratorDependencies, _toConsumableArray(CommonIterators))),
		      range: define("iterator/range", ["esnext.iterator.range", "es.object.to-string"])
		    },
		    JSON: {
		      isRawJSON: define("json/is-raw-json", ["esnext.json.is-raw-json"]),
		      parse: define("json/parse", ["esnext.json.parse", "es.object.keys"]),
		      rawJSON: define("json/raw-json", ["esnext.json.raw-json", "es.object.create", "es.object.freeze"]),
		      stringify: define("json/stringify", ["es.json.stringify", "es.date.to-json"], "es.symbol")
		    },
		    Math: {
		      DEG_PER_RAD: define("math/deg-per-rad", ["esnext.math.deg-per-rad"]),
		      RAD_PER_DEG: define("math/rad-per-deg", ["esnext.math.rad-per-deg"]),
		      acosh: define("math/acosh", ["es.math.acosh"]),
		      asinh: define("math/asinh", ["es.math.asinh"]),
		      atanh: define("math/atanh", ["es.math.atanh"]),
		      cbrt: define("math/cbrt", ["es.math.cbrt"]),
		      clamp: define("math/clamp", ["esnext.math.clamp"]),
		      clz32: define("math/clz32", ["es.math.clz32"]),
		      cosh: define("math/cosh", ["es.math.cosh"]),
		      degrees: define("math/degrees", ["esnext.math.degrees"]),
		      expm1: define("math/expm1", ["es.math.expm1"]),
		      fround: define("math/fround", ["es.math.fround"]),
		      f16round: define("math/f16round", ["esnext.math.f16round"]),
		      fscale: define("math/fscale", ["esnext.math.fscale"]),
		      hypot: define("math/hypot", ["es.math.hypot"]),
		      iaddh: define("math/iaddh", ["esnext.math.iaddh"]),
		      imul: define("math/imul", ["es.math.imul"]),
		      imulh: define("math/imulh", ["esnext.math.imulh"]),
		      isubh: define("math/isubh", ["esnext.math.isubh"]),
		      log10: define("math/log10", ["es.math.log10"]),
		      log1p: define("math/log1p", ["es.math.log1p"]),
		      log2: define("math/log2", ["es.math.log2"]),
		      radians: define("math/radians", ["esnext.math.radians"]),
		      scale: define("math/scale", ["esnext.math.scale"]),
		      seededPRNG: define("math/seeded-prng", ["esnext.math.seeded-prng"]),
		      sign: define("math/sign", ["es.math.sign"]),
		      signbit: define("math/signbit", ["esnext.math.signbit"]),
		      sinh: define("math/sinh", ["es.math.sinh"]),
		      tanh: define("math/tanh", ["es.math.tanh"]),
		      trunc: define("math/trunc", ["es.math.trunc"]),
		      umulh: define("math/umulh", ["esnext.math.umulh"])
		    },
		    Map: {
		      from: define(null, ["esnext.map.from"].concat(_toConsumableArray(MapDependencies))),
		      groupBy: define("map/group-by", ["es.map.group-by"].concat(_toConsumableArray(MapDependencies))),
		      keyBy: define("map/key-by", ["esnext.map.key-by"].concat(_toConsumableArray(MapDependencies))),
		      of: define(null, ["esnext.map.of"].concat(_toConsumableArray(MapDependencies)))
		    },
		    Number: {
		      EPSILON: define("number/epsilon", ["es.number.epsilon"]),
		      MAX_SAFE_INTEGER: define("number/max-safe-integer", ["es.number.max-safe-integer"]),
		      MIN_SAFE_INTEGER: define("number/min-safe-integer", ["es.number.min-safe-integer"]),
		      fromString: define("number/from-string", ["esnext.number.from-string"]),
		      isFinite: define("number/is-finite", ["es.number.is-finite"]),
		      isInteger: define("number/is-integer", ["es.number.is-integer"]),
		      isNaN: define("number/is-nan", ["es.number.is-nan"]),
		      isSafeInteger: define("number/is-safe-integer", ["es.number.is-safe-integer"]),
		      parseFloat: define("number/parse-float", ["es.number.parse-float"]),
		      parseInt: define("number/parse-int", ["es.number.parse-int"]),
		      range: define("number/range", ["esnext.number.range", "es.object.to-string"])
		    },
		    Object: {
		      assign: define("object/assign", ["es.object.assign"]),
		      create: define("object/create", ["es.object.create"]),
		      defineProperties: define("object/define-properties", ["es.object.define-properties"]),
		      defineProperty: define("object/define-property", ["es.object.define-property"]),
		      entries: define("object/entries", ["es.object.entries"]),
		      freeze: define("object/freeze", ["es.object.freeze"]),
		      fromEntries: define("object/from-entries", ["es.object.from-entries", "es.array.iterator"]),
		      getOwnPropertyDescriptor: define("object/get-own-property-descriptor", ["es.object.get-own-property-descriptor"]),
		      getOwnPropertyDescriptors: define("object/get-own-property-descriptors", ["es.object.get-own-property-descriptors"]),
		      getOwnPropertyNames: define("object/get-own-property-names", ["es.object.get-own-property-names"]),
		      getOwnPropertySymbols: define("object/get-own-property-symbols", ["es.symbol"]),
		      getPrototypeOf: define("object/get-prototype-of", ["es.object.get-prototype-of"]),
		      groupBy: define("object/group-by", ["es.object.group-by", "es.object.create"]),
		      hasOwn: define("object/has-own", ["es.object.has-own"]),
		      is: define("object/is", ["es.object.is"]),
		      isExtensible: define("object/is-extensible", ["es.object.is-extensible"]),
		      isFrozen: define("object/is-frozen", ["es.object.is-frozen"]),
		      isSealed: define("object/is-sealed", ["es.object.is-sealed"]),
		      keys: define("object/keys", ["es.object.keys"]),
		      preventExtensions: define("object/prevent-extensions", ["es.object.prevent-extensions"]),
		      seal: define("object/seal", ["es.object.seal"]),
		      setPrototypeOf: define("object/set-prototype-of", ["es.object.set-prototype-of"]),
		      values: define("object/values", ["es.object.values"])
		    },
		    Promise: {
		      all: define(null, PromiseDependenciesWithIterators),
		      allSettled: define("promise/all-settled", ["es.promise.all-settled"].concat(_toConsumableArray(PromiseDependenciesWithIterators))),
		      any: define("promise/any", ["es.promise.any", "es.aggregate-error"].concat(_toConsumableArray(PromiseDependenciesWithIterators))),
		      race: define(null, PromiseDependenciesWithIterators),
		      "try": define("promise/try", ["esnext.promise.try"].concat(PromiseDependencies)),
		      withResolvers: define("promise/with-resolvers", ["es.promise.with-resolvers"].concat(PromiseDependencies))
		    },
		    Reflect: {
		      apply: define("reflect/apply", ["es.reflect.apply"]),
		      construct: define("reflect/construct", ["es.reflect.construct"]),
		      defineMetadata: define("reflect/define-metadata", ["esnext.reflect.define-metadata"]),
		      defineProperty: define("reflect/define-property", ["es.reflect.define-property"]),
		      deleteMetadata: define("reflect/delete-metadata", ["esnext.reflect.delete-metadata"]),
		      deleteProperty: define("reflect/delete-property", ["es.reflect.delete-property"]),
		      get: define("reflect/get", ["es.reflect.get"]),
		      getMetadata: define("reflect/get-metadata", ["esnext.reflect.get-metadata"]),
		      getMetadataKeys: define("reflect/get-metadata-keys", ["esnext.reflect.get-metadata-keys"]),
		      getOwnMetadata: define("reflect/get-own-metadata", ["esnext.reflect.get-own-metadata"]),
		      getOwnMetadataKeys: define("reflect/get-own-metadata-keys", ["esnext.reflect.get-own-metadata-keys"]),
		      getOwnPropertyDescriptor: define("reflect/get-own-property-descriptor", ["es.reflect.get-own-property-descriptor"]),
		      getPrototypeOf: define("reflect/get-prototype-of", ["es.reflect.get-prototype-of"]),
		      has: define("reflect/has", ["es.reflect.has"]),
		      hasMetadata: define("reflect/has-metadata", ["esnext.reflect.has-metadata"]),
		      hasOwnMetadata: define("reflect/has-own-metadata", ["esnext.reflect.has-own-metadata"]),
		      isExtensible: define("reflect/is-extensible", ["es.reflect.is-extensible"]),
		      metadata: define("reflect/metadata", ["esnext.reflect.metadata"]),
		      ownKeys: define("reflect/own-keys", ["es.reflect.own-keys"]),
		      preventExtensions: define("reflect/prevent-extensions", ["es.reflect.prevent-extensions"]),
		      set: define("reflect/set", ["es.reflect.set"]),
		      setPrototypeOf: define("reflect/set-prototype-of", ["es.reflect.set-prototype-of"])
		    },
		    RegExp: {
		      escape: define("regexp/escape", ["esnext.regexp.escape"])
		    },
		    Set: {
		      from: define(null, ["esnext.set.from"].concat(_toConsumableArray(SetDependencies))),
		      of: define(null, ["esnext.set.of"].concat(_toConsumableArray(SetDependencies)))
		    },
		    String: {
		      cooked: define("string/cooked", ["esnext.string.cooked"]),
		      dedent: define("string/dedent", ["esnext.string.dedent", "es.string.from-code-point", "es.weak-map"]),
		      fromCodePoint: define("string/from-code-point", ["es.string.from-code-point"]),
		      raw: define("string/raw", ["es.string.raw"])
		    },
		    Symbol: {
		      asyncDispose: define("symbol/async-dispose", ["esnext.symbol.async-dispose", "esnext.async-iterator.async-dispose"]),
		      asyncIterator: define("symbol/async-iterator", ["es.symbol.async-iterator"]),
		      dispose: define("symbol/dispose", ["esnext.symbol.dispose", "esnext.iterator.dispose"]),
		      "for": define("symbol/for", [], "es.symbol"),
		      hasInstance: define("symbol/has-instance", ["es.symbol.has-instance", "es.function.has-instance"]),
		      isConcatSpreadable: define("symbol/is-concat-spreadable", ["es.symbol.is-concat-spreadable", "es.array.concat"]),
		      isRegistered: define("symbol/is-registered", ["esnext.symbol.is-registered", "es.symbol"]),
		      isRegisteredSymbol: define("symbol/is-registered-symbol", ["esnext.symbol.is-registered-symbol", "es.symbol"]),
		      isWellKnown: define("symbol/is-well-known", ["esnext.symbol.is-well-known", "es.symbol"]),
		      isWellKnownSymbol: define("symbol/is-well-known-symbol", ["esnext.symbol.is-well-known-symbol", "es.symbol"]),
		      iterator: define("symbol/iterator", ["es.symbol.iterator"].concat(_toConsumableArray(CommonIteratorsWithTag))),
		      keyFor: define("symbol/key-for", [], "es.symbol"),
		      match: define("symbol/match", ["es.symbol.match", "es.string.match"]),
		      matcher: define("symbol/matcher", ["esnext.symbol.matcher"]),
		      matchAll: define("symbol/match-all", ["es.symbol.match-all", "es.string.match-all"]),
		      metadata: define("symbol/metadata", DecoratorMetadataDependencies),
		      metadataKey: define("symbol/metadata-key", ["esnext.symbol.metadata-key"]),
		      observable: define("symbol/observable", ["esnext.symbol.observable"]),
		      patternMatch: define("symbol/pattern-match", ["esnext.symbol.pattern-match"]),
		      replace: define("symbol/replace", ["es.symbol.replace", "es.string.replace"]),
		      search: define("symbol/search", ["es.symbol.search", "es.string.search"]),
		      species: define("symbol/species", ["es.symbol.species", "es.array.species"]),
		      split: define("symbol/split", ["es.symbol.split", "es.string.split"]),
		      toPrimitive: define("symbol/to-primitive", ["es.symbol.to-primitive", "es.date.to-primitive"]),
		      toStringTag: define("symbol/to-string-tag", ["es.symbol.to-string-tag", "es.object.to-string", "es.math.to-string-tag", "es.json.to-string-tag"]),
		      unscopables: define("symbol/unscopables", ["es.symbol.unscopables"])
		    },
		    URL: {
		      canParse: define("url/can-parse", ["web.url.can-parse", "web.url"])
		    },
		    WeakMap: {
		      from: define(null, ["esnext.weak-map.from"].concat(_toConsumableArray(WeakMapDependencies))),
		      of: define(null, ["esnext.weak-map.of"].concat(_toConsumableArray(WeakMapDependencies)))
		    },
		    WeakSet: {
		      from: define(null, ["esnext.weak-set.from"].concat(_toConsumableArray(WeakSetDependencies))),
		      of: define(null, ["esnext.weak-set.of"].concat(_toConsumableArray(WeakSetDependencies)))
		    },
		    Int8Array: TypedArrayStaticMethods("es.typed-array.int8-array"),
		    Uint8Array: Object.assign({
		      fromBase64: define(null, ["esnext.uint8-array.from-base64"].concat(TypedArrayDependencies)),
		      fromHex: define(null, ["esnext.uint8-array.from-hex"].concat(TypedArrayDependencies))
		    }, TypedArrayStaticMethods("es.typed-array.uint8-array")),
		    Uint8ClampedArray: TypedArrayStaticMethods("es.typed-array.uint8-clamped-array"),
		    Int16Array: TypedArrayStaticMethods("es.typed-array.int16-array"),
		    Uint16Array: TypedArrayStaticMethods("es.typed-array.uint16-array"),
		    Int32Array: TypedArrayStaticMethods("es.typed-array.int32-array"),
		    Uint32Array: TypedArrayStaticMethods("es.typed-array.uint32-array"),
		    Float32Array: TypedArrayStaticMethods("es.typed-array.float32-array"),
		    Float64Array: TypedArrayStaticMethods("es.typed-array.float64-array"),
		    WebAssembly: {
		      CompileError: define(null, ErrorDependencies),
		      LinkError: define(null, ErrorDependencies),
		      RuntimeError: define(null, ErrorDependencies)
		    }
		  };
		  var InstanceProperties = (_InstanceProperties = {
		    asIndexedPairs: define("instance/asIndexedPairs", ["esnext.async-iterator.as-indexed-pairs"].concat(_toConsumableArray(AsyncIteratorDependencies), ["esnext.iterator.as-indexed-pairs"], IteratorDependencies)),
		    at: define("instance/at", ["esnext.string.at", "es.string.at-alternative", "es.array.at"]),
		    anchor: define(null, ["es.string.anchor"]),
		    big: define(null, ["es.string.big"]),
		    bind: define("instance/bind", ["es.function.bind"]),
		    blink: define(null, ["es.string.blink"]),
		    bold: define(null, ["es.string.bold"]),
		    codePointAt: define("instance/code-point-at", ["es.string.code-point-at"]),
		    codePoints: define("instance/code-points", ["esnext.string.code-points"]),
		    concat: define("instance/concat", ["es.array.concat"], undefined, ["String"]),
		    copyWithin: define("instance/copy-within", ["es.array.copy-within"]),
		    demethodize: define("instance/demethodize", ["esnext.function.demethodize"]),
		    description: define(null, ["es.symbol", "es.symbol.description"]),
		    dotAll: define(null, ["es.regexp.dot-all"]),
		    drop: define(null, ["esnext.async-iterator.drop"].concat(_toConsumableArray(AsyncIteratorDependencies), ["esnext.iterator.drop"], IteratorDependencies)),
		    emplace: define("instance/emplace", ["esnext.map.emplace", "esnext.weak-map.emplace"]),
		    endsWith: define("instance/ends-with", ["es.string.ends-with"]),
		    entries: define("instance/entries", ArrayNatureIteratorsWithTag),
		    every: define("instance/every", ["es.array.every", "esnext.async-iterator.every", "esnext.iterator.every"].concat(IteratorDependencies)),
		    exec: define(null, ["es.regexp.exec"]),
		    fill: define("instance/fill", ["es.array.fill"]),
		    filter: define("instance/filter", ["es.array.filter", "esnext.async-iterator.filter", "esnext.iterator.filter"].concat(IteratorDependencies)),
		    filterReject: define("instance/filterReject", ["esnext.array.filter-reject"]),
		    "finally": define(null, ["es.promise.finally"].concat(PromiseDependencies)),
		    find: define("instance/find", ["es.array.find", "esnext.async-iterator.find", "esnext.iterator.find"].concat(IteratorDependencies)),
		    findIndex: define("instance/find-index", ["es.array.find-index"]),
		    findLast: define("instance/find-last", ["es.array.find-last"]),
		    findLastIndex: define("instance/find-last-index", ["es.array.find-last-index"]),
		    fixed: define(null, ["es.string.fixed"]),
		    flags: define("instance/flags", ["es.regexp.flags"]),
		    flatMap: define("instance/flat-map", ["es.array.flat-map", "es.array.unscopables.flat-map", "esnext.async-iterator.flat-map", "esnext.iterator.flat-map"].concat(IteratorDependencies)),
		    flat: define("instance/flat", ["es.array.flat", "es.array.unscopables.flat"]),
		    getFloat16: define(null, ["esnext.data-view.get-float16"].concat(DataViewDependencies)),
		    getUint8Clamped: define(null, ["esnext.data-view.get-uint8-clamped"].concat(DataViewDependencies)),
		    getYear: define(null, ["es.date.get-year"]),
		    group: define("instance/group", ["esnext.array.group"]),
		    groupBy: define("instance/group-by", ["esnext.array.group-by"]),
		    groupByToMap: define("instance/group-by-to-map", ["esnext.array.group-by-to-map", "es.map", "es.object.to-string"]),
		    groupToMap: define("instance/group-to-map", ["esnext.array.group-to-map", "es.map", "es.object.to-string"]),
		    fontcolor: define(null, ["es.string.fontcolor"]),
		    fontsize: define(null, ["es.string.fontsize"]),
		    forEach: define("instance/for-each", ["es.array.for-each", "esnext.async-iterator.for-each", "esnext.iterator.for-each"].concat(IteratorDependencies, ["web.dom-collections.for-each"])),
		    includes: define("instance/includes", ["es.array.includes", "es.string.includes"]),
		    indexed: define(null, ["esnext.async-iterator.indexed"].concat(_toConsumableArray(AsyncIteratorDependencies), ["esnext.iterator.indexed"], IteratorDependencies)),
		    indexOf: define("instance/index-of", ["es.array.index-of"]),
		    isWellFormed: define("instance/is-well-formed", ["es.string.is-well-formed"]),
		    italic: define(null, ["es.string.italics"]),
		    join: define(null, ["es.array.join"]),
		    keys: define("instance/keys", ArrayNatureIteratorsWithTag),
		    lastIndex: define(null, ["esnext.array.last-index"]),
		    lastIndexOf: define("instance/last-index-of", ["es.array.last-index-of"]),
		    lastItem: define(null, ["esnext.array.last-item"]),
		    link: define(null, ["es.string.link"]),
		    map: define("instance/map", ["es.array.map", "esnext.async-iterator.map", "esnext.iterator.map"]),
		    match: define(null, ["es.string.match", "es.regexp.exec"]),
		    matchAll: define("instance/match-all", ["es.string.match-all", "es.regexp.exec"]),
		    name: define(null, ["es.function.name"]),
		    padEnd: define("instance/pad-end", ["es.string.pad-end"]),
		    padStart: define("instance/pad-start", ["es.string.pad-start"]),
		    push: define("instance/push", ["es.array.push"]),
		    reduce: define("instance/reduce", ["es.array.reduce", "esnext.async-iterator.reduce", "esnext.iterator.reduce"].concat(IteratorDependencies)),
		    reduceRight: define("instance/reduce-right", ["es.array.reduce-right"]),
		    repeat: define("instance/repeat", ["es.string.repeat"]),
		    replace: define(null, ["es.string.replace", "es.regexp.exec"]),
		    replaceAll: define("instance/replace-all", ["es.string.replace-all", "es.string.replace", "es.regexp.exec"]),
		    reverse: define("instance/reverse", ["es.array.reverse"]),
		    search: define(null, ["es.string.search", "es.regexp.exec"]),
		    setFloat16: define(null, ["esnext.data-view.set-float16"].concat(DataViewDependencies)),
		    setUint8Clamped: define(null, ["esnext.data-view.set-uint8-clamped"].concat(DataViewDependencies)),
		    setYear: define(null, ["es.date.set-year"]),
		    slice: define("instance/slice", ["es.array.slice"]),
		    small: define(null, ["es.string.small"]),
		    some: define("instance/some", ["es.array.some", "esnext.async-iterator.some", "esnext.iterator.some"].concat(IteratorDependencies)),
		    sort: define("instance/sort", ["es.array.sort"]),
		    splice: define("instance/splice", ["es.array.splice"]),
		    split: define(null, ["es.string.split", "es.regexp.exec"]),
		    startsWith: define("instance/starts-with", ["es.string.starts-with"]),
		    sticky: define(null, ["es.regexp.sticky"]),
		    strike: define(null, ["es.string.strike"]),
		    sub: define(null, ["es.string.sub"]),
		    substr: define(null, ["es.string.substr"]),
		    sup: define(null, ["es.string.sup"]),
		    take: define(null, ["esnext.async-iterator.take"].concat(_toConsumableArray(AsyncIteratorDependencies), ["esnext.iterator.take"], IteratorDependencies)),
		    test: define(null, ["es.regexp.test", "es.regexp.exec"]),
		    toArray: define(null, ["esnext.async-iterator.to-array"].concat(_toConsumableArray(AsyncIteratorDependencies), ["esnext.iterator.to-array"], IteratorDependencies)),
		    toAsync: define(null, ["esnext.iterator.to-async"].concat(IteratorDependencies, _toConsumableArray(AsyncIteratorDependencies), AsyncIteratorProblemMethods)),
		    toExponential: define(null, ["es.number.to-exponential"]),
		    toFixed: define(null, ["es.number.to-fixed"]),
		    toGMTString: define(null, ["es.date.to-gmt-string"]),
		    toISOString: define(null, ["es.date.to-iso-string"]),
		    toJSON: define(null, ["es.date.to-json"]),
		    toPrecision: define(null, ["es.number.to-precision"]),
		    toReversed: define("instance/to-reversed", ["es.array.to-reversed"]),
		    toSorted: define("instance/to-sorted", ["es.array.to-sorted", "es.array.sort"]),
		    toSpliced: define("instance/to-spliced", ["es.array.to-spliced"]),
		    toString: define(null, ["es.object.to-string", "es.error.to-string", "es.date.to-string", "es.regexp.to-string"]),
		    toWellFormed: define("instance/to-well-formed", ["es.string.to-well-formed"]),
		    trim: define("instance/trim", ["es.string.trim"]),
		    trimEnd: define("instance/trim-end", ["es.string.trim-end"]),
		    trimLeft: define("instance/trim-left", ["es.string.trim-start"]),
		    trimRight: define("instance/trim-right", ["es.string.trim-end"]),
		    trimStart: define("instance/trim-start", ["es.string.trim-start"]),
		    uniqueBy: define("instance/unique-by", ["esnext.array.unique-by", "es.map"]),
		    unshift: define("instance/unshift", ["es.array.unshift"]),
		    unThis: define("instance/un-this", ["esnext.function.un-this"]),
		    values: define("instance/values", ArrayNatureIteratorsWithTag),
		    "with": define("instance/with", ["es.array.with"]),
		    __defineGetter__: define(null, ["es.object.define-getter"]),
		    __defineSetter__: define(null, ["es.object.define-setter"]),
		    __lookupGetter__: define(null, ["es.object.lookup-getter"]),
		    __lookupSetter__: define(null, ["es.object.lookup-setter"])
		  }, _InstanceProperties["__proto__"] = define(null, ["es.object.proto"]), _InstanceProperties);
		  var stable = new Set(["array", "array/from", "array/is-array", "array/of", "clear-immediate", "date/now", "instance/bind", "instance/code-point-at", "instance/concat", "instance/copy-within", "instance/ends-with", "instance/entries", "instance/every", "instance/fill", "instance/filter", "instance/find", "instance/find-index", "instance/flags", "instance/flat", "instance/flat-map", "instance/for-each", "instance/includes", "instance/index-of", "instance/keys", "instance/last-index-of", "instance/map", "instance/pad-end", "instance/pad-start", "instance/reduce", "instance/reduce-right", "instance/repeat", "instance/reverse", "instance/slice", "instance/some", "instance/sort", "instance/splice", "instance/starts-with", "instance/trim", "instance/trim-end", "instance/trim-left", "instance/trim-right", "instance/trim-start", "instance/values", "json/stringify", "map", "math/acosh", "math/asinh", "math/atanh", "math/cbrt", "math/clz32", "math/cosh", "math/expm1", "math/fround", "math/hypot", "math/imul", "math/log10", "math/log1p", "math/log2", "math/sign", "math/sinh", "math/tanh", "math/trunc", "number/epsilon", "number/is-finite", "number/is-integer", "number/is-nan", "number/is-safe-integer", "number/max-safe-integer", "number/min-safe-integer", "number/parse-float", "number/parse-int", "object/assign", "object/create", "object/define-properties", "object/define-property", "object/entries", "object/freeze", "object/from-entries", "object/get-own-property-descriptor", "object/get-own-property-descriptors", "object/get-own-property-names", "object/get-own-property-symbols", "object/get-prototype-of", "object/is", "object/is-extensible", "object/is-frozen", "object/is-sealed", "object/keys", "object/prevent-extensions", "object/seal", "object/set-prototype-of", "object/values", "parse-float", "parse-int", "promise", "queue-microtask", "reflect/apply", "reflect/construct", "reflect/define-property", "reflect/delete-property", "reflect/get", "reflect/get-own-property-descriptor", "reflect/get-prototype-of", "reflect/has", "reflect/is-extensible", "reflect/own-keys", "reflect/prevent-extensions", "reflect/set", "reflect/set-prototype-of", "set", "set-immediate", "set-interval", "set-timeout", "string/from-code-point", "string/raw", "symbol", "symbol/async-iterator", "symbol/for", "symbol/has-instance", "symbol/is-concat-spreadable", "symbol/iterator", "symbol/key-for", "symbol/match", "symbol/replace", "symbol/search", "symbol/species", "symbol/split", "symbol/to-primitive", "symbol/to-string-tag", "symbol/unscopables", "url", "url-search-params", "weak-map", "weak-set"]);
		  var proposals = new Set([].concat(_toConsumableArray(stable), ["aggregate-error", "composite-key", "composite-symbol", "global-this", "instance/at", "instance/code-points", "instance/match-all", "instance/replace-all", "math/clamp", "math/degrees", "math/deg-per-rad", "math/fscale", "math/iaddh", "math/imulh", "math/isubh", "math/rad-per-deg", "math/radians", "math/scale", "math/seeded-prng", "math/signbit", "math/umulh", "number/from-string", "observable", "reflect/define-metadata", "reflect/delete-metadata", "reflect/get-metadata", "reflect/get-metadata-keys", "reflect/get-own-metadata", "reflect/get-own-metadata-keys", "reflect/has-metadata", "reflect/has-own-metadata", "reflect/metadata", "symbol/dispose", "symbol/observable", "symbol/pattern-match"]));
		  var _ref = _babel,
		    t$2 = _ref.types;
		  function canSkipPolyfill(desc, path) {
		    var node = path.node,
		      parent = path.parent;
		    switch (desc.name) {
		      case "es.string.split":
		        {
		          if (!t$2.isCallExpression(parent, {
		            callee: node
		          })) return false;
		          if (parent.arguments.length < 1) return true;
		          var splitter = parent.arguments[0];
		          return t$2.isStringLiteral(splitter) || t$2.isTemplateLiteral(splitter);
		        }
		    }
		  }
		  var _ref2 = _babel,
		    t$1 = _ref2.types;
		  var BABEL_RUNTIME = "@babel/runtime-corejs3";
		  function callMethod(path, id) {
		    var object = path.node.object;
		    var context1, context2;
		    if (t$1.isIdentifier(object)) {
		      context1 = object;
		      context2 = t$1.cloneNode(object);
		    } else {
		      context1 = path.scope.generateDeclaredUidIdentifier("context");
		      context2 = t$1.assignmentExpression("=", t$1.cloneNode(context1), object);
		    }
		    path.replaceWith(t$1.memberExpression(t$1.callExpression(id, [context2]), t$1.identifier("call")));
		    path.parentPath.unshiftContainer("arguments", context1);
		  }
		  function isCoreJSSource(source) {
		    if (typeof source === "string") {
		      source = source.replace(/\\/g, "/").replace(/(\/(index)?)?(\.js)?$/i, "").toLowerCase();
		    }
		    return Object.prototype.hasOwnProperty.call(entries, source) && entries[source];
		  }
		  function coreJSModule(name) {
		    return "core-js/modules/" + name + ".js";
		  }
		  function coreJSPureHelper(name, useBabelRuntime, ext) {
		    return useBabelRuntime ? BABEL_RUNTIME + "/core-js/" + name + ext : "core-js-pure/features/" + name + ".js";
		  }
		  var _ref3 = _babel,
		    t = _ref3.types;
		  var presetEnvCompat = "#__secret_key__@babel/preset-env__compatibility";
		  var runtimeCompat = "#__secret_key__@babel/runtime__compatibility";
		  var uniqueObjects = ["array", "string", "iterator", "async-iterator", "dom-collections"].map(function (v) {
		    return new RegExp("[a-z]*\\." + v + "\\..*");
		  });
		  var esnextFallback = function esnextFallback(name, cb) {
		    if (cb(name)) return true;
		    if (!name.startsWith("es.")) return false;
		    var fallback = "esnext." + name.slice(3);
		    if (!data[fallback]) return false;
		    return cb(fallback);
		  };
		  var index = definePolyfillProvider(function (_ref4, _ref5) {
		    var getUtils = _ref4.getUtils,
		      method = _ref4.method,
		      shouldInjectPolyfill = _ref4.shouldInjectPolyfill,
		      createMetaResolver = _ref4.createMetaResolver,
		      debug = _ref4.debug,
		      babel = _ref4.babel;
		    var _ref5$version = _ref5.version,
		      version = _ref5$version === void 0 ? 3 : _ref5$version,
		      proposals$1 = _ref5.proposals,
		      shippedProposals = _ref5.shippedProposals,
		      _ref5$presetEnvCompat = _ref5[presetEnvCompat],
		      _ref5$presetEnvCompat2 = _ref5$presetEnvCompat === void 0 ? {} : _ref5$presetEnvCompat,
		      _ref5$presetEnvCompat3 = _ref5$presetEnvCompat2.noRuntimeName,
		      noRuntimeName = _ref5$presetEnvCompat3 === void 0 ? false : _ref5$presetEnvCompat3,
		      _ref5$runtimeCompat = _ref5[runtimeCompat],
		      _ref5$runtimeCompat2 = _ref5$runtimeCompat === void 0 ? {} : _ref5$runtimeCompat,
		      _ref5$runtimeCompat2$ = _ref5$runtimeCompat2.useBabelRuntime,
		      useBabelRuntime = _ref5$runtimeCompat2$ === void 0 ? false : _ref5$runtimeCompat2$,
		      _ref5$runtimeCompat2$2 = _ref5$runtimeCompat2.ext,
		      ext = _ref5$runtimeCompat2$2 === void 0 ? ".js" : _ref5$runtimeCompat2$2;
		    var isWebpack = babel.caller(function (caller) {
		      return (caller == null ? void 0 : caller.name) === "babel-loader";
		    });
		    var resolve = createMetaResolver({
		      global: BuiltIns,
		      "static": StaticProperties,
		      instance: InstanceProperties
		    });
		    var available = new Set(getModulesListForTargetVersion(version));
		    function getCoreJSPureBase(useProposalBase) {
		      return useBabelRuntime ? useProposalBase ? BABEL_RUNTIME + "/core-js" : BABEL_RUNTIME + "/core-js-stable" : useProposalBase ? "core-js-pure/features" : "core-js-pure/stable";
		    }
		    function maybeInjectGlobalImpl(name, utils) {
		      if (shouldInjectPolyfill(name)) {
		        debug(name);
		        utils.injectGlobalImport(coreJSModule(name), name);
		        return true;
		      }
		      return false;
		    }
		    function maybeInjectGlobal(names, utils, fallback) {
		      if (fallback === void 0) {
		        fallback = true;
		      }
		      for (var _iterator = _createForOfIteratorHelperLoose(names), _step; !(_step = _iterator()).done;) {
		        var name = _step.value;
		        if (fallback) {
		          esnextFallback(name, function (name) {
		            return maybeInjectGlobalImpl(name, utils);
		          });
		        } else {
		          maybeInjectGlobalImpl(name, utils);
		        }
		      }
		    }
		    function maybeInjectPure(desc, hint, utils, object) {
		      if (desc.pure && !(object && desc.exclude && desc.exclude.includes(object)) && esnextFallback(desc.name, shouldInjectPolyfill)) {
		        var name = desc.name;
		        var useProposalBase = false;
		        if (proposals$1 || shippedProposals && name.startsWith("esnext.")) {
		          useProposalBase = true;
		        } else if (name.startsWith("es.") && !available.has(name)) {
		          useProposalBase = true;
		        }
		        if (useBabelRuntime && !(useProposalBase ? proposals : stable).has(desc.pure)) {
		          return;
		        }
		        var coreJSPureBase = getCoreJSPureBase(useProposalBase);
		        return utils.injectDefaultImport(coreJSPureBase + "/" + desc.pure + ext, hint);
		      }
		    }
		    function isFeatureStable(name) {
		      if (name.startsWith("esnext.")) {
		        var esName = "es." + name.slice(7);
		        return esName in data;
		      }
		      return true;
		    }
		    return {
		      name: "corejs3",
		      runtimeName: noRuntimeName ? null : BABEL_RUNTIME,
		      polyfills: data,
		      filterPolyfills: function filterPolyfills(name) {
		        if (!available.has(name)) return false;
		        if (proposals$1 || method === "entry-global") return true;
		        if (shippedProposals && corejs3ShippedProposalsList.has(name)) {
		          return true;
		        }
		        return isFeatureStable(name);
		      },
		      entryGlobal: function entryGlobal(meta, utils, path) {
		        if (meta.kind !== "import") return;
		        var modules = isCoreJSSource(meta.source);
		        if (!modules) return;
		        if (modules.length === 1 && meta.source === coreJSModule(modules[0]) && shouldInjectPolyfill(modules[0])) {
		          debug(null);
		          return;
		        }
		        var modulesSet = new Set(modules);
		        var filteredModules = modules.filter(function (module) {
		          if (!module.startsWith("esnext.")) return true;
		          var stable = module.replace("esnext.", "es.");
		          if (modulesSet.has(stable) && shouldInjectPolyfill(stable)) {
		            return false;
		          }
		          return true;
		        });
		        maybeInjectGlobal(filteredModules, utils, false);
		        path.remove();
		      },
		      usageGlobal: function usageGlobal(meta, utils, path) {
		        var resolved = resolve(meta);
		        if (!resolved) return;
		        if (canSkipPolyfill(resolved.desc, path)) return;
		        var deps = resolved.desc.global;
		        if (resolved.kind !== "global" && "object" in meta && meta.object && meta.placement === "prototype") {
		          var low = meta.object.toLowerCase();
		          deps = deps.filter(function (m) {
		            return uniqueObjects.some(function (v) {
		              return v.test(m);
		            }) ? m.includes(low) : true;
		          });
		        }
		        maybeInjectGlobal(deps, utils);
		        return true;
		      },
		      usagePure: function usagePure(meta, utils, path) {
		        if (meta.kind === "in") {
		          if (meta.key === "Symbol.iterator") {
		            path.replaceWith(t.callExpression(utils.injectDefaultImport(coreJSPureHelper("is-iterable", useBabelRuntime, ext), "isIterable"), [path.node.right]));
		          }
		          return;
		        }
		        if (path.parentPath.isUnaryExpression({
		          operator: "delete"
		        })) return;
		        if (meta.kind === "property") {
		          if (!path.isMemberExpression()) return;
		          if (!path.isReferenced()) return;
		          if (path.parentPath.isUpdateExpression()) return;
		          if (t.isSuper(path.node.object)) {
		            return;
		          }
		          if (meta.key === "Symbol.iterator") {
		            if (!shouldInjectPolyfill("es.symbol.iterator")) return;
		            var parent = path.parent,
		              node = path.node;
		            if (t.isCallExpression(parent, {
		              callee: node
		            })) {
		              if (parent.arguments.length === 0) {
		                path.parentPath.replaceWith(t.callExpression(utils.injectDefaultImport(coreJSPureHelper("get-iterator", useBabelRuntime, ext), "getIterator"), [node.object]));
		                path.skip();
		              } else {
		                callMethod(path, utils.injectDefaultImport(coreJSPureHelper("get-iterator-method", useBabelRuntime, ext), "getIteratorMethod"));
		              }
		            } else {
		              path.replaceWith(t.callExpression(utils.injectDefaultImport(coreJSPureHelper("get-iterator-method", useBabelRuntime, ext), "getIteratorMethod"), [path.node.object]));
		            }
		            return;
		          }
		        }
		        var resolved = resolve(meta);
		        if (!resolved) return;
		        if (canSkipPolyfill(resolved.desc, path)) return;
		        if (useBabelRuntime && resolved.desc.pure && resolved.desc.pure.slice(-6) === "/index") {
		          resolved = Object.assign(Object.assign({}, resolved), {}, {
		            desc: Object.assign(Object.assign({}, resolved.desc), {}, {
		              pure: resolved.desc.pure.slice(0, -6)
		            })
		          });
		        }
		        if (resolved.kind === "global") {
		          var id = maybeInjectPure(resolved.desc, resolved.name, utils);
		          if (id) path.replaceWith(id);
		        } else if (resolved.kind === "static") {
		          var _id = maybeInjectPure(resolved.desc, resolved.name, utils, meta.object);
		          if (_id) path.replaceWith(_id);
		        } else if (resolved.kind === "instance") {
		          var _id2 = maybeInjectPure(resolved.desc, resolved.name + "InstanceProperty", utils, meta.object);
		          if (!_id2) return;
		          var _node = path.node;
		          if (t.isCallExpression(path.parent, {
		            callee: _node
		          })) {
		            callMethod(path, _id2);
		          } else {
		            path.replaceWith(t.callExpression(_id2, [_node.object]));
		          }
		        }
		      },
		      visitor: method === "usage-global" && {
		        CallExpression: function CallExpression(path) {
		          if (path.get("callee").isImport()) {
		            var utils = getUtils(path);
		            if (isWebpack) {
		              maybeInjectGlobal(PromiseDependenciesWithIterators, utils);
		            } else {
		              maybeInjectGlobal(PromiseDependencies, utils);
		            }
		          }
		        },
		        Function: function Function(path) {
		          if (path.node.async) {
		            maybeInjectGlobal(PromiseDependencies, getUtils(path));
		          }
		        },
		        "ForOfStatement|ArrayPattern": function ForOfStatementArrayPattern(path) {
		          maybeInjectGlobal(CommonIterators, getUtils(path));
		        },
		        SpreadElement: function SpreadElement(path) {
		          if (!path.parentPath.isObjectExpression()) {
		            maybeInjectGlobal(CommonIterators, getUtils(path));
		          }
		        },
		        YieldExpression: function YieldExpression(path) {
		          if (path.node.delegate) {
		            maybeInjectGlobal(CommonIterators, getUtils(path));
		          }
		        },
		        Class: function Class(path) {
		          var _path$node$decorators;
		          var hasDecorators = ((_path$node$decorators = path.node.decorators) == null ? void 0 : _path$node$decorators.length) || path.node.body.body.some(function (el) {
		            var _decorators;
		            return (_decorators = el.decorators) == null ? void 0 : _decorators.length;
		          });
		          if (hasDecorators) {
		            maybeInjectGlobal(DecoratorMetadataDependencies, getUtils(path));
		          }
		        }
		      }
		    };
		  });

		  var pluginCoreJS3 = index["default"] || index;
		  function filterStageFromList(list, stageList) {
		    return Object.keys(list).reduce(function (result, item) {
		      if (!stageList.has(item)) {
		        result[item] = list[item];
		      }
		      return result;
		    }, {});
		  }
		  var pluginLists = {
		    withProposals: {
		      withoutBugfixes: plugins,
		      withBugfixes: Object.assign({}, plugins, pluginsBugfixes)
		    },
		    withoutProposals: {
		      withoutBugfixes: filterStageFromList(plugins, proposalPlugins),
		      withBugfixes: filterStageFromList(Object.assign({}, plugins, pluginsBugfixes), proposalPlugins)
		    }
		  };
		  function getPluginList(proposals, bugfixes) {
		    if (proposals) {
		      if (bugfixes) return pluginLists.withProposals.withBugfixes;else return pluginLists.withProposals.withoutBugfixes;
		    } else {
		      if (bugfixes) return pluginLists.withoutProposals.withBugfixes;else return pluginLists.withoutProposals.withoutBugfixes;
		    }
		  }
		  var getPlugin = function getPlugin(pluginName) {
		    var plugin = availablePlugins$1[pluginName]();
		    if (!plugin) {
		      throw new Error("Could not find plugin \"" + pluginName + "\". Ensure there is an entry in ./available-plugins.js for it.");
		    }
		    return plugin;
		  };
		  var transformIncludesAndExcludes = function transformIncludesAndExcludes(opts) {
		    return opts.reduce(function (result, opt) {
		      var target = opt.match(/^(es|es6|es7|esnext|web)\./) ? "builtIns" : "plugins";
		      result[target].add(opt);
		      return result;
		    }, {
		      all: opts,
		      plugins: new Set(),
		      builtIns: new Set()
		    });
		  };
		  function getSpecialModulesPluginNames(modules, shouldTransformDynamicImport, babelVersion) {
		    var modulesPluginNames = [];
		    if (modules) {
		      modulesPluginNames.push(moduleTransformations[modules]);
		    }
		    if (shouldTransformDynamicImport) {
		      if (modules && modules !== "umd") {
		        modulesPluginNames.push("transform-dynamic-import");
		      } else {
		        console.warn("Dynamic import can only be transformed when transforming ES" + " modules to AMD, CommonJS or SystemJS.");
		      }
		    }
		    if (babelVersion[0] !== "8") {
		      if (!shouldTransformDynamicImport) {
		        modulesPluginNames.push("syntax-dynamic-import");
		      }
		      modulesPluginNames.push("syntax-top-level-await");
		      modulesPluginNames.push("syntax-import-meta");
		    }
		    return modulesPluginNames;
		  }
		  var getCoreJSOptions = function getCoreJSOptions(_ref) {
		    var useBuiltIns = _ref.useBuiltIns,
		      corejs = _ref.corejs,
		      polyfillTargets = _ref.polyfillTargets,
		      include = _ref.include,
		      exclude = _ref.exclude,
		      proposals = _ref.proposals,
		      shippedProposals = _ref.shippedProposals,
		      debug = _ref.debug;
		    return {
		      method: useBuiltIns + "-global",
		      version: corejs ? corejs.toString() : undefined,
		      targets: polyfillTargets,
		      include: include,
		      exclude: exclude,
		      proposals: proposals,
		      shippedProposals: shippedProposals,
		      debug: debug,
		      "#__secret_key__@babel/preset-env__compatibility": {
		        noRuntimeName: true
		      }
		    };
		  };
		  {
		    var getPolyfillPlugins = function getPolyfillPlugins(_ref2) {
		      var useBuiltIns = _ref2.useBuiltIns,
		        corejs = _ref2.corejs,
		        polyfillTargets = _ref2.polyfillTargets,
		        include = _ref2.include,
		        exclude = _ref2.exclude,
		        proposals = _ref2.proposals,
		        shippedProposals = _ref2.shippedProposals,
		        regenerator = _ref2.regenerator,
		        debug = _ref2.debug;
		      var polyfillPlugins = [];
		      if (useBuiltIns === "usage" || useBuiltIns === "entry") {
		        var pluginOptions = getCoreJSOptions({
		          useBuiltIns: useBuiltIns,
		          corejs: corejs,
		          polyfillTargets: polyfillTargets,
		          include: include,
		          exclude: exclude,
		          proposals: proposals,
		          shippedProposals: shippedProposals,
		          debug: debug
		        });
		        if (corejs) {
		          {
		            if (useBuiltIns === "usage") {
		              if (corejs.major === 2) {
		                polyfillPlugins.push([babel7Plugins.pluginCoreJS2, pluginOptions], [babel7Plugins.legacyBabelPolyfillPlugin, {
		                  usage: true
		                }]);
		              } else {
		                polyfillPlugins.push([pluginCoreJS3, pluginOptions], [babel7Plugins.legacyBabelPolyfillPlugin, {
		                  usage: true,
		                  deprecated: true
		                }]);
		              }
		              if (regenerator) {
		                polyfillPlugins.push([babel7Plugins.pluginRegenerator, {
		                  method: "usage-global",
		                  debug: debug
		                }]);
		              }
		            } else {
		              if (corejs.major === 2) {
		                polyfillPlugins.push([babel7Plugins.legacyBabelPolyfillPlugin, {
		                  regenerator: regenerator
		                }], [babel7Plugins.pluginCoreJS2, pluginOptions]);
		              } else {
		                polyfillPlugins.push([pluginCoreJS3, pluginOptions], [babel7Plugins.legacyBabelPolyfillPlugin, {
		                  deprecated: true
		                }]);
		                if (!regenerator) {
		                  polyfillPlugins.push([babel7Plugins.removeRegeneratorEntryPlugin, pluginOptions]);
		                }
		              }
		            }
		          }
		        }
		      }
		      return polyfillPlugins;
		    };
		    {
		      exports.getPolyfillPlugins = getPolyfillPlugins;
		    }
		  }
		  function getLocalTargets(optionsTargets, ignoreBrowserslistConfig, configPath, browserslistEnv) {
		    if (optionsTargets != null && optionsTargets.esmodules && optionsTargets.browsers) {
		      console.warn("\n@babel/preset-env: esmodules and browsers targets have been specified together.\n`browsers` target, `" + optionsTargets.browsers.toString() + "` will be ignored.\n");
		    }
		    return getTargets$1(optionsTargets, {
		      ignoreBrowserslistConfig: ignoreBrowserslistConfig,
		      configPath: configPath,
		      browserslistEnv: browserslistEnv
		    });
		  }
		  function supportsStaticESM(caller) {
		    return !!(caller != null && caller.supportsStaticESM);
		  }
		  function supportsDynamicImport(caller) {
		    return !!(caller != null && caller.supportsDynamicImport);
		  }
		  function supportsExportNamespaceFrom(caller) {
		    return !!(caller != null && caller.supportsExportNamespaceFrom);
		  }
		  var presetEnv = declare(function (api, opts) {
		    api.assertVersion("*");
		    var babelTargets = api.targets();
		    var _normalizeOptions = normalizeOptions$3(opts),
		      bugfixes = _normalizeOptions.bugfixes,
		      configPath = _normalizeOptions.configPath,
		      debug = _normalizeOptions.debug,
		      optionsExclude = _normalizeOptions.exclude,
		      forceAllTransforms = _normalizeOptions.forceAllTransforms,
		      ignoreBrowserslistConfig = _normalizeOptions.ignoreBrowserslistConfig,
		      optionsInclude = _normalizeOptions.include,
		      optionsModules = _normalizeOptions.modules,
		      shippedProposals = _normalizeOptions.shippedProposals,
		      optionsTargets = _normalizeOptions.targets,
		      useBuiltIns = _normalizeOptions.useBuiltIns,
		      _normalizeOptions$cor = _normalizeOptions.corejs,
		      corejs = _normalizeOptions$cor.version,
		      proposals = _normalizeOptions$cor.proposals,
		      browserslistEnv = _normalizeOptions.browserslistEnv;
		    {
		      var loose = opts.loose,
		        _opts$spec = opts.spec,
		        spec = _opts$spec === void 0 ? false : _opts$spec;
		    }
		    var targets = babelTargets;
		    if (semver$1.lt(api.version, "7.13.0") || opts.targets || opts.configPath || opts.browserslistEnv || opts.ignoreBrowserslistConfig) {
		      {
		        var hasUglifyTarget = false;
		        if (optionsTargets != null && optionsTargets.uglify) {
		          hasUglifyTarget = true;
		          delete optionsTargets.uglify;
		          console.warn("\nThe uglify target has been deprecated. Set the top level\noption `forceAllTransforms: true` instead.\n");
		        }
		      }
		      targets = getLocalTargets(optionsTargets, ignoreBrowserslistConfig, configPath, browserslistEnv);
		    }
		    var transformTargets = forceAllTransforms || hasUglifyTarget ? {} : targets;
		    var include = transformIncludesAndExcludes(optionsInclude);
		    var exclude = transformIncludesAndExcludes(optionsExclude);
		    var compatData = getPluginList(shippedProposals, bugfixes);
		    var modules = optionsModules === "auto" ? api.caller(supportsStaticESM) ? false : "commonjs" : optionsModules;
		    var shouldTransformDynamicImport = optionsModules === "auto" ? !api.caller(supportsDynamicImport) : !!modules;
		    if (!exclude.plugins.has("transform-export-namespace-from") && (optionsModules === "auto" ? !api.caller(supportsExportNamespaceFrom) : !!modules)) {
		      include.plugins.add("transform-export-namespace-from");
		    }
		    var pluginNames = filterItems(compatData, include.plugins, exclude.plugins, transformTargets, getSpecialModulesPluginNames(modules, shouldTransformDynamicImport, api.version), !loose ? undefined : ["transform-typeof-symbol"], pluginSyntaxMap);
		    if (shippedProposals) {
		      addProposalSyntaxPlugins(pluginNames, proposalSyntaxPlugins);
		    }
		    removeUnsupportedItems(pluginNames, api.version);
		    removeUnnecessaryItems(pluginNames, overlappingPlugins);
		    var polyfillPlugins = getPolyfillPlugins({
		      useBuiltIns: useBuiltIns,
		      corejs: corejs,
		      polyfillTargets: targets,
		      include: include.builtIns,
		      exclude: exclude.builtIns,
		      proposals: proposals,
		      shippedProposals: shippedProposals,
		      regenerator: pluginNames.has("transform-regenerator"),
		      debug: debug
		    });
		    var pluginUseBuiltIns = useBuiltIns !== false;
		    var plugins = Array.from(pluginNames).map(function (pluginName) {
		      if (pluginName === "transform-class-properties" || pluginName === "transform-private-methods" || pluginName === "transform-private-property-in-object") {
		        return [getPlugin(pluginName), {
		          loose: loose ? "#__internal__@babel/preset-env__prefer-true-but-false-is-ok-if-it-prevents-an-error" : "#__internal__@babel/preset-env__prefer-false-but-true-is-ok-if-it-prevents-an-error"
		        }];
		      }
		      if (pluginName === "syntax-import-attributes") {
		        return [getPlugin(pluginName), {
		          deprecatedAssertSyntax: true
		        }];
		      }
		      return [getPlugin(pluginName), {
		        spec: spec,
		        loose: loose,
		        useBuiltIns: pluginUseBuiltIns
		      }];
		    }).concat(polyfillPlugins);
		    if (debug) {
		      console.log("@babel/preset-env: `DEBUG` option");
		      console.log("\nUsing targets:");
		      console.log(JSON.stringify(prettifyTargets(targets), null, 2));
		      console.log("\nUsing modules transform: " + optionsModules.toString());
		      console.log("\nUsing plugins:");
		      pluginNames.forEach(function (pluginName) {
		        logPlugin(pluginName, targets, compatData);
		      });
		      if (!useBuiltIns) {
		        console.log("\nUsing polyfills: No polyfills were added, since the `useBuiltIns` option was not set.");
		      }
		    }
		    return {
		      plugins: plugins
		    };
		  });
		  {
		    exports.getModulesPluginNames = function (_ref3) {
		      var modules = _ref3.modules,
		        transformations = _ref3.transformations,
		        shouldTransformESM = _ref3.shouldTransformESM,
		        shouldTransformDynamicImport = _ref3.shouldTransformDynamicImport,
		        shouldTransformExportNamespaceFrom = _ref3.shouldTransformExportNamespaceFrom;
		      var modulesPluginNames = [];
		      if (modules !== false && transformations[modules]) {
		        if (shouldTransformESM) {
		          modulesPluginNames.push(transformations[modules]);
		        }
		        if (shouldTransformDynamicImport) {
		          if (shouldTransformESM && modules !== "umd") {
		            modulesPluginNames.push("transform-dynamic-import");
		          } else {
		            console.warn("Dynamic import can only be transformed when transforming ES" + " modules to AMD, CommonJS or SystemJS.");
		          }
		        }
		      }
		      if (shouldTransformExportNamespaceFrom) {
		        modulesPluginNames.push("transform-export-namespace-from");
		      }
		      if (!shouldTransformDynamicImport) {
		        modulesPluginNames.push("syntax-dynamic-import");
		      }
		      if (!shouldTransformExportNamespaceFrom) {
		        modulesPluginNames.push("syntax-export-namespace-from");
		      }
		      modulesPluginNames.push("syntax-top-level-await");
		      modulesPluginNames.push("syntax-import-meta");
		      return modulesPluginNames;
		    };
		  }

		  new OptionValidator("@babel/preset-flow");
		  function normalizeOptions$2(options) {
		    if (options === void 0) {
		      options = {};
		    }
		    var _options = options,
		      all = _options.all,
		      ignoreExtensions = _options.ignoreExtensions,
		      experimental_useHermesParser = _options.experimental_useHermesParser;
		    var _options2 = options,
		      allowDeclareFields = _options2.allowDeclareFields;
		    {
		      return {
		        all: all,
		        allowDeclareFields: allowDeclareFields,
		        ignoreExtensions: ignoreExtensions,
		        experimental_useHermesParser: experimental_useHermesParser
		      };
		    }
		  }

		  var presetFlow = declare(function (api, opts) {
		    api.assertVersion("*");
		    var _normalizeOptions = normalizeOptions$2(opts),
		      all = _normalizeOptions.all,
		      allowDeclareFields = _normalizeOptions.allowDeclareFields,
		      _normalizeOptions$ign = _normalizeOptions.ignoreExtensions,
		      ignoreExtensions = _normalizeOptions$ign === void 0 ? true : _normalizeOptions$ign,
		      _normalizeOptions$exp = _normalizeOptions.experimental_useHermesParser,
		      useHermesParser = _normalizeOptions$exp === void 0 ? false : _normalizeOptions$exp;
		    var plugins = [[transformFlowStripTypes, {
		      all: all,
		      allowDeclareFields: allowDeclareFields
		    }]];
		    if (useHermesParser) {
		      if (Number.parseInt(browser$1$1.versions.node, 10) < 12) {
		        throw new Error("The Hermes parser is only supported in Node 12 and later.");
		      }
		      {
		        throw new Error("The Hermes parser is not supported in the @babel/standalone.");
		      }
		    }
		    if (ignoreExtensions) {
		      return {
		        plugins: plugins
		      };
		    }
		    return {
		      overrides: [{
		        test: function test(filename) {
		          return filename == null || !/\.tsx?$/.test(filename);
		        },
		        plugins: plugins
		      }]
		    };
		  });

		  var PURE_CALLS = [["react", new Set(["cloneElement", "createContext", "createElement", "createFactory", "createRef", "forwardRef", "isValidElement", "memo", "lazy"])], ["react-dom", new Set(["createPortal"])]];
		  var transformReactPure = declare(function (api) {
		    api.assertVersion("*");
		    return {
		      name: "transform-react-pure-annotations",
		      visitor: {
		        CallExpression: function CallExpression(path) {
		          if (isReactCall(path)) {
		            annotateAsPure(path);
		          }
		        }
		      }
		    };
		  });
		  function isReactCall(path) {
		    var calleePath = path.get("callee");
		    if (!calleePath.isMemberExpression()) {
		      for (var _i = 0, _PURE_CALLS = PURE_CALLS; _i < _PURE_CALLS.length; _i++) {
		        var _PURE_CALLS$_i = _slicedToArray(_PURE_CALLS[_i], 2),
		          module = _PURE_CALLS$_i[0],
		          methods = _PURE_CALLS$_i[1];
		        for (var _iterator = _createForOfIteratorHelperLoose(methods), _step; !(_step = _iterator()).done;) {
		          var method = _step.value;
		          if (calleePath.referencesImport(module, method)) {
		            return true;
		          }
		        }
		      }
		      return false;
		    }
		    var object = calleePath.get("object");
		    var callee = calleePath.node;
		    if (!callee.computed && isIdentifier$i(callee.property)) {
		      var propertyName = callee.property.name;
		      for (var _i2 = 0, _PURE_CALLS2 = PURE_CALLS; _i2 < _PURE_CALLS2.length; _i2++) {
		        var _PURE_CALLS2$_i = _slicedToArray(_PURE_CALLS2[_i2], 2),
		          _module = _PURE_CALLS2$_i[0],
		          _methods = _PURE_CALLS2$_i[1];
		        if (object.referencesImport(_module, "default") || object.referencesImport(_module, "*")) {
		          return _methods.has(propertyName);
		        }
		      }
		    }
		    return false;
		  }

		  new OptionValidator("@babel/preset-react");
		  function normalizeOptions$1(options) {
		    if (options === void 0) {
		      options = {};
		    }
		    {
		      var _options = options,
		        pragma = _options.pragma,
		        pragmaFrag = _options.pragmaFrag;
		      var _options2 = options,
		        pure = _options2.pure,
		        _options2$throwIfName = _options2.throwIfNamespace,
		        throwIfNamespace = _options2$throwIfName === void 0 ? true : _options2$throwIfName,
		        _options2$runtime = _options2.runtime,
		        runtime = _options2$runtime === void 0 ? "classic" : _options2$runtime,
		        importSource = _options2.importSource,
		        useBuiltIns = _options2.useBuiltIns,
		        useSpread = _options2.useSpread;
		      if (runtime === "classic") {
		        pragma = pragma || "React.createElement";
		        pragmaFrag = pragmaFrag || "React.Fragment";
		      }
		      var development = !!options.development;
		      return {
		        development: development,
		        importSource: importSource,
		        pragma: pragma,
		        pragmaFrag: pragmaFrag,
		        pure: pure,
		        runtime: runtime,
		        throwIfNamespace: throwIfNamespace,
		        useBuiltIns: useBuiltIns,
		        useSpread: useSpread
		      };
		    }
		  }

		  var presetReact = declare(function (api, opts) {
		    api.assertVersion("*");
		    var _normalizeOptions = normalizeOptions$1(opts),
		      development = _normalizeOptions.development,
		      importSource = _normalizeOptions.importSource,
		      pragma = _normalizeOptions.pragma,
		      pragmaFrag = _normalizeOptions.pragmaFrag,
		      pure = _normalizeOptions.pure,
		      runtime = _normalizeOptions.runtime,
		      throwIfNamespace = _normalizeOptions.throwIfNamespace;
		    return {
		      plugins: [[development ? transformReactJSXDevelopment : transformReactJSX, {
		        importSource: importSource,
		        pragma: pragma,
		        pragmaFrag: pragmaFrag,
		        runtime: runtime,
		        throwIfNamespace: throwIfNamespace,
		        pure: pure,
		        useBuiltIns: !!opts.useBuiltIns,
		        useSpread: opts.useSpread
		      }], transformReactDisplayName, pure !== false && transformReactPure].filter(Boolean)
		    };
		  });

		  var v = new OptionValidator("@babel/preset-typescript");
		  function normalizeOptions(options) {
		    if (options === void 0) {
		      options = {};
		    }
		    var _options = options,
		      _options$allowNamespa = _options.allowNamespaces,
		      allowNamespaces = _options$allowNamespa === void 0 ? true : _options$allowNamespa,
		      jsxPragma = _options.jsxPragma,
		      onlyRemoveTypeImports = _options.onlyRemoveTypeImports;
		    var TopLevelOptions = {
		      ignoreExtensions: "ignoreExtensions",
		      allowNamespaces: "allowNamespaces",
		      disallowAmbiguousJSXLike: "disallowAmbiguousJSXLike",
		      jsxPragma: "jsxPragma",
		      jsxPragmaFrag: "jsxPragmaFrag",
		      onlyRemoveTypeImports: "onlyRemoveTypeImports",
		      optimizeConstEnums: "optimizeConstEnums",
		      rewriteImportExtensions: "rewriteImportExtensions",
		      allExtensions: "allExtensions",
		      isTSX: "isTSX"
		    };
		    var jsxPragmaFrag = v.validateStringOption(TopLevelOptions.jsxPragmaFrag, options.jsxPragmaFrag, "React.Fragment");
		    {
		      var allExtensions = v.validateBooleanOption(TopLevelOptions.allExtensions, options.allExtensions, false);
		      var isTSX = v.validateBooleanOption(TopLevelOptions.isTSX, options.isTSX, false);
		      if (isTSX) {
		        v.invariant(allExtensions, "isTSX:true requires allExtensions:true");
		      }
		    }
		    var ignoreExtensions = v.validateBooleanOption(TopLevelOptions.ignoreExtensions, options.ignoreExtensions, false);
		    var disallowAmbiguousJSXLike = v.validateBooleanOption(TopLevelOptions.disallowAmbiguousJSXLike, options.disallowAmbiguousJSXLike, false);
		    if (disallowAmbiguousJSXLike) {
		      {
		        v.invariant(allExtensions, "disallowAmbiguousJSXLike:true requires allExtensions:true");
		      }
		    }
		    var optimizeConstEnums = v.validateBooleanOption(TopLevelOptions.optimizeConstEnums, options.optimizeConstEnums, false);
		    var rewriteImportExtensions = v.validateBooleanOption(TopLevelOptions.rewriteImportExtensions, options.rewriteImportExtensions, false);
		    var normalized = {
		      ignoreExtensions: ignoreExtensions,
		      allowNamespaces: allowNamespaces,
		      disallowAmbiguousJSXLike: disallowAmbiguousJSXLike,
		      jsxPragma: jsxPragma,
		      jsxPragmaFrag: jsxPragmaFrag,
		      onlyRemoveTypeImports: onlyRemoveTypeImports,
		      optimizeConstEnums: optimizeConstEnums,
		      rewriteImportExtensions: rewriteImportExtensions
		    };
		    {
		      normalized.allExtensions = allExtensions;
		      normalized.isTSX = isTSX;
		    }
		    return normalized;
		  }

		  var pluginRewriteTSImports = declare(function (_ref) {
		    var t = _ref.types;
		    return {
		      name: "preset-typescript/plugin-rewrite-ts-imports",
		      visitor: {
		        "ImportDeclaration|ExportAllDeclaration|ExportNamedDeclaration": function ImportDeclarationExportAllDeclarationExportNamedDeclaration(_ref2) {
		          var node = _ref2.node;
		          var source = node.source;
		          var kind = t.isImportDeclaration(node) ? node.importKind : node.exportKind;
		          if (kind === "value" && source && /[\\/]/.test(source.value)) {
		            source.value = source.value.replace(/(\.[mc]?)ts$/, "$1js").replace(/\.tsx$/, ".js");
		          }
		        }
		      }
		    };
		  });

		  var presetTypescript = declare(function (api, opts) {
		    api.assertVersion("*");
		    var _normalizeOptions = normalizeOptions(opts),
		      allExtensions = _normalizeOptions.allExtensions,
		      ignoreExtensions = _normalizeOptions.ignoreExtensions,
		      allowNamespaces = _normalizeOptions.allowNamespaces,
		      disallowAmbiguousJSXLike = _normalizeOptions.disallowAmbiguousJSXLike,
		      isTSX = _normalizeOptions.isTSX,
		      jsxPragma = _normalizeOptions.jsxPragma,
		      jsxPragmaFrag = _normalizeOptions.jsxPragmaFrag,
		      onlyRemoveTypeImports = _normalizeOptions.onlyRemoveTypeImports,
		      optimizeConstEnums = _normalizeOptions.optimizeConstEnums,
		      rewriteImportExtensions = _normalizeOptions.rewriteImportExtensions;
		    var pluginOptions = function pluginOptions(disallowAmbiguousJSXLike) {
		      return {
		        allowDeclareFields: opts.allowDeclareFields,
		        allowNamespaces: allowNamespaces,
		        disallowAmbiguousJSXLike: disallowAmbiguousJSXLike,
		        jsxPragma: jsxPragma,
		        jsxPragmaFrag: jsxPragmaFrag,
		        onlyRemoveTypeImports: onlyRemoveTypeImports,
		        optimizeConstEnums: optimizeConstEnums
		      };
		    };
		    var getPlugins = function getPlugins(isTSX, disallowAmbiguousJSXLike) {
		      {
		        return [[transformTypeScript, Object.assign({
		          isTSX: isTSX
		        }, pluginOptions(disallowAmbiguousJSXLike))]];
		      }
		    };
		    var disableExtensionDetect = allExtensions || ignoreExtensions;
		    return {
		      plugins: rewriteImportExtensions ? [pluginRewriteTSImports] : [],
		      overrides: disableExtensionDetect ? [{
		        plugins: getPlugins(isTSX, disallowAmbiguousJSXLike)
		      }] : [{
		        test: /\.ts$/,
		        plugins: getPlugins(false, false)
		      }, {
		        test: /\.mts$/,
		        sourceType: "module",
		        plugins: getPlugins(false, true)
		      }, {
		        test: /\.cts$/,
		        sourceType: "unambiguous",
		        plugins: [[transformModulesCommonJS, {
		          allowTopLevelThis: true
		        }], [transformTypeScript, pluginOptions(true)]]
		      }, {
		        test: /\.tsx$/,
		        plugins: getPlugins(true, false)
		      }]
		    };
		  });

		  var scriptTypes = ["text/jsx", "text/babel"];
		  var headEl;
		  var inlineScriptCount = 0;
		  function transformCode(transformFn, script) {
		    var source;
		    if (script.url != null) {
		      source = script.url;
		    } else {
		      source = "Inline Babel script";
		      inlineScriptCount++;
		      if (inlineScriptCount > 1) {
		        source += " (" + inlineScriptCount + ")";
		      }
		    }
		    return transformFn(script.content, buildBabelOptions(script, source)).code;
		  }
		  function buildBabelOptions(script, filename) {
		    var presets = script.presets;
		    if (!presets) {
		      if (script.type === "module") {
		        presets = ["react", ["env", {
		          targets: {
		            esmodules: true
		          },
		          modules: false
		        }]];
		      } else {
		        presets = ["react", "env"];
		      }
		    }
		    return {
		      filename: filename,
		      presets: presets,
		      plugins: script.plugins || ["transform-class-properties", "transform-object-rest-spread", "transform-flow-strip-types"],
		      sourceMaps: "inline",
		      sourceFileName: filename
		    };
		  }
		  function run(transformFn, script) {
		    var scriptEl = document.createElement("script");
		    if (script.type) {
		      scriptEl.setAttribute("type", script.type);
		    }
		    if (script.nonce) {
		      scriptEl.nonce = script.nonce;
		    }
		    scriptEl.text = transformCode(transformFn, script);
		    headEl.appendChild(scriptEl);
		  }
		  function load(url, successCallback, errorCallback) {
		    var xhr = new XMLHttpRequest();
		    xhr.open("GET", url, true);
		    if ("overrideMimeType" in xhr) {
		      xhr.overrideMimeType("text/plain");
		    }
		    xhr.onreadystatechange = function () {
		      if (xhr.readyState === 4) {
		        if (xhr.status === 0 || xhr.status === 200) {
		          successCallback(xhr.responseText);
		        } else {
		          errorCallback();
		          throw new Error("Could not load " + url);
		        }
		      }
		    };
		    xhr.send(null);
		  }
		  function getPluginsOrPresetsFromScript(script, attributeName) {
		    var rawValue = script.getAttribute(attributeName);
		    if (rawValue === "") {
		      return [];
		    }
		    if (!rawValue) {
		      return null;
		    }
		    return rawValue.split(",").map(function (item) {
		      return item.trim();
		    });
		  }
		  function loadScripts(transformFn, scripts) {
		    var results = [];
		    var count = scripts.length;
		    function check() {
		      for (var i = 0; i < count; i++) {
		        var result = results[i];
		        if (result.loaded && !result.executed) {
		          result.executed = true;
		          run(transformFn, result);
		        } else if (!result.loaded && !result.error && !result.async) {
		          break;
		        }
		      }
		    }
		    var _loop = function _loop() {
		      var script = scripts[i];
		      var result = {
		        async: script.hasAttribute("async"),
		        type: script.getAttribute("data-type"),
		        nonce: script.nonce,
		        error: false,
		        executed: false,
		        plugins: getPluginsOrPresetsFromScript(script, "data-plugins"),
		        presets: getPluginsOrPresetsFromScript(script, "data-presets"),
		        loaded: false,
		        url: null,
		        content: null
		      };
		      results.push(result);
		      if (script.src) {
		        result.url = script.src;
		        load(script.src, function (content) {
		          result.loaded = true;
		          result.content = content;
		          check();
		        }, function () {
		          result.error = true;
		          check();
		        });
		      } else {
		        result.url = script.getAttribute("data-module") || null;
		        result.loaded = true;
		        result.content = script.innerHTML;
		      }
		    };
		    for (var i = 0; i < count; i++) {
		      _loop();
		    }
		    check();
		  }
		  function runScripts(transformFn, scripts) {
		    headEl = document.getElementsByTagName("head")[0];
		    if (!scripts) {
		      scripts = document.getElementsByTagName("script");
		    }
		    var jsxScripts = [];
		    for (var i = 0; i < scripts.length; i++) {
		      var script = scripts.item(i);
		      var type = script.type.split(";")[0];
		      if (scriptTypes.indexOf(type) !== -1) {
		        jsxScripts.push(script);
		      }
		    }
		    if (jsxScripts.length === 0) {
		      return;
		    }
		    console.warn("You are using the in-browser Babel transformer. Be sure to precompile " + "your scripts for production - https://babeljs.io/docs/setup/");
		    loadScripts(transformFn, jsxScripts);
		  }

		  var packages = /*#__PURE__*/Object.freeze({
		    __proto__: null,
		    generator: index$4,
		    parser: index$3,
		    template: index$2,
		    traverse: index$1,
		    types: t$4
		  });

		  var legacyPluginAliases = {
		    __proto__: null,
		    "transform-class-static-block": "proposal-class-static-block",
		    "transform-private-property-in-object": "proposal-private-property-in-object",
		    "transform-class-properties": "proposal-class-properties",
		    "transform-private-methods": "proposal-private-methods",
		    "transform-numeric-separator": "proposal-numeric-separator",
		    "transform-logical-assignment-operators": "proposal-logical-assignment-operators",
		    "transform-nullish-coalescing-operator": "proposal-nullish-coalescing-operator",
		    "transform-optional-chaining": "proposal-optional-chaining",
		    "transform-json-strings": "proposal-json-strings",
		    "transform-optional-catch-binding": "proposal-optional-catch-binding",
		    "transform-async-generator-functions": "proposal-async-generator-functions",
		    "transform-object-rest-spread": "proposal-object-rest-spread",
		    "transform-unicode-property-regex": "proposal-unicode-property-regex",
		    "transform-export-namespace-from": "proposal-export-namespace-from"
		  };

		  var _window;
		  for (var name in legacyPluginAliases) {
		    all[legacyPluginAliases[name]] = all[name];
		  }
		  all["proposal-unicode-sets-regex"] = all["transform-unicode-sets-regex"];
		  var availablePlugins = {};
		  registerPlugins(all);
		  var availablePresets = {
		    env: presetEnv,
		    es2015: preset2015,
		    es2016: function es2016() {
		      return {
		        plugins: [availablePlugins["transform-exponentiation-operator"]]
		      };
		    },
		    es2017: function es2017() {
		      return {
		        plugins: [availablePlugins["transform-async-to-generator"]]
		      };
		    },
		    react: presetReact,
		    "stage-0": presetStage0,
		    "stage-1": presetStage1,
		    "stage-2": presetStage2,
		    "stage-3": presetStage3,
		    "es2015-loose": {
		      presets: [[preset2015, {
		        loose: true
		      }]]
		    },
		    "es2015-no-commonjs": {
		      presets: [[preset2015, {
		        modules: false
		      }]]
		    },
		    typescript: presetTypescript,
		    flow: presetFlow
		  };
		  var isArray = Array.isArray || function (arg) {
		    return Object.prototype.toString.call(arg) === "[object Array]";
		  };
		  function loadBuiltin(builtinTable, name) {
		    if (isArray(name) && typeof name[0] === "string") {
		      if (hasOwnProperty.call(builtinTable, name[0])) {
		        return [builtinTable[name[0]]].concat(name.slice(1));
		      }
		      return;
		    } else if (typeof name === "string") {
		      return builtinTable[name];
		    }
		    return name;
		  }
		  function processOptions(options) {
		    var presets = (options.presets || []).map(function (presetName) {
		      var preset = loadBuiltin(availablePresets, presetName);
		      if (preset) {
		        if (isArray(preset) && typeof preset[0] === "object" && hasOwnProperty.call(preset[0], "buildPreset")) {
		          preset[0] = Object.assign({}, preset[0], {
		            buildPreset: preset[0].buildPreset
		          });
		        }
		      } else {
		        throw new Error("Invalid preset specified in Babel options: \"" + presetName + "\"");
		      }
		      return preset;
		    });
		    var plugins = (options.plugins || []).map(function (pluginName) {
		      var plugin = loadBuiltin(availablePlugins, pluginName);
		      if (!plugin) {
		        throw new Error("Invalid plugin specified in Babel options: \"" + pluginName + "\"");
		      }
		      return plugin;
		    });
		    return Object.assign({
		      babelrc: false
		    }, options, {
		      presets: presets,
		      plugins: plugins
		    });
		  }
		  function transform(code, options) {
		    return transformSync(code, processOptions(options));
		  }
		  function transformFromAst(ast, code, options) {
		    return transformFromAstSync(ast, code, processOptions(options));
		  }
		  var buildExternalHelpers = babelBuildExternalHelpers;
		  function registerPlugin(name, plugin) {
		    if (hasOwnProperty.call(availablePlugins, name)) {
		      console.warn("A plugin named \"" + name + "\" is already registered, it will be overridden");
		    }
		    availablePlugins[name] = plugin;
		  }
		  function registerPlugins(newPlugins) {
		    Object.keys(newPlugins).forEach(function (name) {
		      return registerPlugin(name, newPlugins[name]);
		    });
		  }
		  function registerPreset(name, preset) {
		    if (hasOwnProperty.call(availablePresets, name)) {
		      if (name === "env") {
		        console.warn("@babel/preset-env is now included in @babel/standalone, please remove @babel/preset-env-standalone");
		      } else {
		        console.warn("A preset named \"" + name + "\" is already registered, it will be overridden");
		      }
		    }
		    availablePresets[name] = preset;
		  }
		  function registerPresets(newPresets) {
		    Object.keys(newPresets).forEach(function (name) {
		      return registerPreset(name, newPresets[name]);
		    });
		  }
		  var version = "7.24.5";
		  function onDOMContentLoaded() {
		    transformScriptTags();
		  }
		  if (typeof window !== "undefined" && (_window = window) != null && _window.addEventListener) {
		    window.addEventListener("DOMContentLoaded", onDOMContentLoaded, false);
		  }
		  function transformScriptTags(scriptTags) {
		    runScripts(transform, scriptTags);
		  }
		  function disableScriptTags() {
		    window.removeEventListener("DOMContentLoaded", onDOMContentLoaded);
		  }

		  exports.availablePlugins = availablePlugins;
		  exports.availablePresets = availablePresets;
		  exports.buildExternalHelpers = buildExternalHelpers;
		  exports.disableScriptTags = disableScriptTags;
		  exports.packages = packages;
		  exports.registerPlugin = registerPlugin;
		  exports.registerPlugins = registerPlugins;
		  exports.registerPreset = registerPreset;
		  exports.registerPresets = registerPresets;
		  exports.transform = transform;
		  exports.transformFromAst = transformFromAst;
		  exports.transformScriptTags = transformScriptTags;
		  exports.version = version;

		  Object.defineProperty(exports, '__esModule', { value: true });

		}));
		
	} (babel$1, babel$1.exports));
	return babel$1.exports;
}

var name = "core-js";
var version = "3.37.0";
var type = "commonjs";
var description = "Standard library";
var keywords = [
	"ES3",
	"ES5",
	"ES6",
	"ES7",
	"ES2015",
	"ES2016",
	"ES2017",
	"ES2018",
	"ES2019",
	"ES2020",
	"ES2021",
	"ES2022",
	"ES2023",
	"ECMAScript 3",
	"ECMAScript 5",
	"ECMAScript 6",
	"ECMAScript 7",
	"ECMAScript 2015",
	"ECMAScript 2016",
	"ECMAScript 2017",
	"ECMAScript 2018",
	"ECMAScript 2019",
	"ECMAScript 2020",
	"ECMAScript 2021",
	"ECMAScript 2022",
	"ECMAScript 2023",
	"Map",
	"Set",
	"WeakMap",
	"WeakSet",
	"TypedArray",
	"Promise",
	"Observable",
	"Symbol",
	"Iterator",
	"AsyncIterator",
	"URL",
	"URLSearchParams",
	"queueMicrotask",
	"setImmediate",
	"structuredClone",
	"polyfill",
	"ponyfill",
	"shim"
];
var repository = {
	type: "git",
	url: "https://github.com/zloirock/core-js.git",
	directory: "packages/core-js"
};
var funding = {
	type: "opencollective",
	url: "https://opencollective.com/core-js"
};
var license = "MIT";
var author = {
	name: "Denis Pushkarev",
	email: "zloirock@zloirock.ru",
	url: "http://zloirock.ru"
};
var main$2 = "index.js";
var scripts = {
	postinstall: "node -e \"try{require('./postinstall')}catch(e){}\""
};
var require$$5 = {
	name: name,
	version: version,
	type: type,
	description: description,
	keywords: keywords,
	repository: repository,
	funding: funding,
	license: license,
	author: author,
	main: main$2,
	scripts: scripts
};

// @ts-check
const path = path__default["default"];
const { createHash } = require$$3__default$1["default"];
const { build } = require$$2__default$1["default"];
const MagicString = magicString_cjs.default;

// lazy load babel since it's not used during dev
let babel;
/**
 * @return {import('@babel/standalone')}
 */
const loadBabel = () => babel || (babel = requireBabel());

// https://gist.github.com/samthor/64b114e4a4f539915a95b91ffd340acc
// DO NOT ALTER THIS CONTENT
const safari10NoModuleFix = `!function(){var e=document,t=e.createElement("script");if(!("noModule"in t)&&"onbeforeload"in t){var n=!1;e.addEventListener("beforeload",(function(e){if(e.target===t)n=!0;else if(!e.target.hasAttribute("nomodule")||!n)return;e.preventDefault()}),!0),t.type="module",t.src=".",e.head.appendChild(t),t.remove()}}();`;

const legacyPolyfillId = 'vite-legacy-polyfill';
const legacyEntryId = 'vite-legacy-entry';
const systemJSInlineCode = `System.import(document.getElementById('${legacyEntryId}').getAttribute('data-src'))`;

const detectDynamicImportVarName = '__vite_is_dynamic_import_support';
const detectDynamicImportCode = `try{import("_").catch(()=>1);}catch(e){}window.${detectDynamicImportVarName}=true;`;
const dynamicFallbackInlineCode = `!function(){if(window.${detectDynamicImportVarName})return;console.warn("vite: loading legacy build because dynamic import is unsupported, syntax error above should be ignored");var e=document.getElementById("${legacyPolyfillId}"),n=document.createElement("script");n.src=e.src,n.onload=function(){${systemJSInlineCode}},document.body.appendChild(n)}();`;

const forceDynamicImportUsage = `export function __vite_legacy_guard(){import('data:text/javascript,')};`;

const legacyEnvVarMarker = `__VITE_IS_LEGACY__`;

/**
 * @param {import('.').Options} options
 * @returns {import('vite').Plugin[]}
 */
function viteLegacyPlugin(options = {}) {
  /**
   * @type {import('vite').ResolvedConfig}
   */
  let config;
  const targets = options.targets || 'defaults';
  const genLegacy = options.renderLegacyChunks !== false;
  const genDynamicFallback = genLegacy;

  const debugFlags = (process.env.DEBUG || '').split(',');
  const isDebug =
    debugFlags.includes('vite:*') || debugFlags.includes('vite:legacy');

  const facadeToLegacyChunkMap = new Map();
  const facadeToLegacyPolyfillMap = new Map();
  const facadeToModernPolyfillMap = new Map();
  const modernPolyfills = new Set();
  // System JS relies on the Promise interface. It needs to be polyfilled for IE 11. (array.iterator is mandatory for supporting Promise.all)
  const DEFAULT_LEGACY_POLYFILL = [
    'core-js/modules/es.promise',
    'core-js/modules/es.array.iterator'
  ];
  const legacyPolyfills = new Set(DEFAULT_LEGACY_POLYFILL);

  if (Array.isArray(options.modernPolyfills)) {
    options.modernPolyfills.forEach((i) => {
      modernPolyfills.add(
        i.includes('/') ? `core-js/${i}` : `core-js/modules/${i}.js`
      );
    });
  }
  if (Array.isArray(options.polyfills)) {
    options.polyfills.forEach((i) => {
      if (i.startsWith(`regenerator`)) {
        legacyPolyfills.add(`regenerator-runtime/runtime.js`);
      } else {
        legacyPolyfills.add(
          i.includes('/') ? `core-js/${i}` : `core-js/modules/${i}.js`
        );
      }
    });
  }
  if (Array.isArray(options.additionalLegacyPolyfills)) {
    options.additionalLegacyPolyfills.forEach((i) => {
      legacyPolyfills.add(i);
    });
  }

  /**
   * @type {import('vite').Plugin}
   */
  const legacyConfigPlugin = {
    name: 'vite:legacy-config',

    apply: 'build',
    config(config) {
      if (!config.build) {
        config.build = {};
      }

      if (!config.build.cssTarget) {
        // Hint for esbuild that we are targeting legacy browsers when minifying CSS.
        // Full CSS compat table available at https://github.com/evanw/esbuild/blob/78e04680228cf989bdd7d471e02bbc2c8d345dc9/internal/compat/css_table.go
        // But note that only the `HexRGBA` feature affects the minify outcome.
        // HSL & rebeccapurple values will be minified away regardless the target.
        // So targeting `chrome61` suffices to fix the compatiblity issue.
        config.build.cssTarget = 'chrome61';
      }
    }
  };

  /**
   * @type {import('vite').Plugin}
   */
  const legacyGenerateBundlePlugin = {
    name: 'vite:legacy-generate-polyfill-chunk',
    apply: 'build',

    async generateBundle(opts, bundle) {
      if (config.build.ssr) {
        return
      }

      if (!isLegacyBundle(bundle, opts)) {
        if (!modernPolyfills.size) {
          return
        }
        isDebug &&
          console.log(
            `[@vitejs/plugin-legacy] modern polyfills:`,
            modernPolyfills
          );
        await buildPolyfillChunk(
          'polyfills-modern',
          modernPolyfills,
          bundle,
          facadeToModernPolyfillMap,
          config.build,
          options.externalSystemJS
        );
        return
      }

      if (!genLegacy) {
        return
      }

      // legacy bundle
      if (legacyPolyfills.size || genDynamicFallback) {
        if (!legacyPolyfills.has('es.promise')) {
          // check if the target needs Promise polyfill because SystemJS relies
          // on it
          detectPolyfills(`Promise.resolve()`, targets, legacyPolyfills);
        }

        isDebug &&
          console.log(
            `[@vitejs/plugin-legacy] legacy polyfills:`,
            legacyPolyfills
          );

        await buildPolyfillChunk(
          'polyfills-legacy',
          legacyPolyfills,
          bundle,
          facadeToLegacyPolyfillMap,
          // force using terser for legacy polyfill minification, since esbuild
          // isn't legacy-safe
          config.build,
          options.externalSystemJS
        );
      }
    }
  };

  /**
   * @type {import('vite').Plugin}
   */
  const legacyPostPlugin = {
    name: 'vite:legacy-post-process',
    enforce: 'post',
    apply: 'build',

    configResolved(_config) {
      if (_config.build.lib) {
        throw new Error('@vitejs/plugin-legacy does not support library mode.')
      }
      config = _config;

      if (!genLegacy || config.build.ssr) {
        return
      }

      /**
       * @param {string | ((chunkInfo: import('rollup').PreRenderedChunk) => string)} fileNames
       * @param {string?} defaultFileName
       * @returns {string | ((chunkInfo: import('rollup').PreRenderedChunk) => string)}
       */
      const getLegacyOutputFileName = (
        fileNames,
        defaultFileName = '[name]-legacy.[hash].js'
      ) => {
        if (!fileNames) {
          return path.posix.join(config.build.assetsDir, defaultFileName)
        }

        return (chunkInfo) => {
          let fileName =
            typeof fileNames === 'function' ? fileNames(chunkInfo) : fileNames;

          if (fileName.includes('[name]')) {
            // [name]-[hash].[format] -> [name]-legacy-[hash].[format]
            fileName = fileName.replace('[name]', '[name]-legacy');
          } else {
            // entry.js -> entry-legacy.js
            fileName = fileName.replace(/(.+)\.(.+)/, '$1-legacy.$2');
          }

          return fileName
        }
      };

      /**
       * @param {import('rollup').OutputOptions} options
       * @returns {import('rollup').OutputOptions}
       */
      const createLegacyOutput = (options = {}) => {
        return {
          ...options,
          format: 'system',
          entryFileNames: getLegacyOutputFileName(options.entryFileNames),
          chunkFileNames: getLegacyOutputFileName(options.chunkFileNames)
        }
      };

      const { rollupOptions } = config.build;
      const { output } = rollupOptions;
      if (Array.isArray(output)) {
        rollupOptions.output = [...output.map(createLegacyOutput), ...output];
      } else {
        rollupOptions.output = [createLegacyOutput(output), output || {}];
      }
    },

    renderChunk(raw, chunk, opts) {
      if (config.build.ssr) {
        return
      }

      if (!isLegacyChunk(chunk, opts)) {
        if (
          options.modernPolyfills &&
          !Array.isArray(options.modernPolyfills)
        ) {
          // analyze and record modern polyfills
          detectPolyfills(raw, { esmodules: true }, modernPolyfills);
        }

        const ms = new MagicString(raw);

        if (genDynamicFallback && chunk.isEntry) {
          ms.prepend(forceDynamicImportUsage);
        }

        if (raw.includes(legacyEnvVarMarker)) {
          const re = new RegExp(legacyEnvVarMarker, 'g');
          let match;
          while ((match = re.exec(raw))) {
            ms.overwrite(
              match.index,
              match.index + legacyEnvVarMarker.length,
              `false`
            );
          }
        }

        if (config.build.sourcemap) {
          return {
            code: ms.toString(),
            map: ms.generateMap({ hires: true })
          }
        }
        return ms.toString()
      }

      if (!genLegacy) {
        return
      }

      // @ts-ignore avoid esbuild transform on legacy chunks since it produces
      // legacy-unsafe code - e.g. rewriting object properties into shorthands
      opts.__vite_skip_esbuild__ = true;

      // @ts-ignore force terser for legacy chunks. This only takes effect if
      // minification isn't disabled, because that leaves out the terser plugin
      // entirely.
      opts.__vite_force_terser__ = true;

      // @ts-ignore
      // In the `generateBundle` hook,
      // we'll delete the assets from the legacy bundle to avoid emitting duplicate assets.
      // But that's still a waste of computing resource.
      // So we add this flag to avoid emitting the asset in the first place whenever possible.
      opts.__vite_skip_asset_emit__ = true;

      // @ts-ignore avoid emitting assets for legacy bundle
      const needPolyfills =
        options.polyfills !== false && !Array.isArray(options.polyfills);

      // transform the legacy chunk with @babel/preset-env
      const sourceMaps = !!config.build.sourcemap;
      const { code, map } = loadBabel().transform(raw, {
        babelrc: false,
        configFile: false,
        compact: true,
        sourceMaps,
        inputSourceMap: sourceMaps && chunk.map,
        presets: [
          // forcing our plugin to run before preset-env by wrapping it in a
          // preset so we can catch the injected import statements...
          [
            () => ({
              plugins: [
                recordAndRemovePolyfillBabelPlugin(legacyPolyfills),
                replaceLegacyEnvBabelPlugin(),
                wrapIIFEBabelPlugin()
              ]
            })
          ],
          [
            'env',
            {
              targets,
              modules: false,
              bugfixes: true,
              loose: false,
              useBuiltIns: needPolyfills ? 'usage' : false,
              corejs: needPolyfills
                ? {
                    version: require$$5.version,
                    proposals: false
                  }
                : undefined,
              shippedProposals: true,
              ignoreBrowserslistConfig: options.ignoreBrowserslistConfig
            }
          ]
        ]
      });

      return { code, map }
    },

    transformIndexHtml(html, { chunk }) {
      if (config.build.ssr) return
      if (!chunk) return
      if (chunk.fileName.includes('-legacy')) {
        // The legacy bundle is built first, and its index.html isn't actually
        // emitted. Here we simply record its corresponding legacy chunk.
        facadeToLegacyChunkMap.set(chunk.facadeModuleId, chunk.fileName);
        return
      }

      /**
       * @type {import('vite').HtmlTagDescriptor[]}
       */
      const tags = [];
      const htmlFilename = chunk.facadeModuleId.replace(/\?.*$/, '');

      // 1. inject modern polyfills
      const modernPolyfillFilename = facadeToModernPolyfillMap.get(
        chunk.facadeModuleId
      );
      if (modernPolyfillFilename) {
        tags.push({
          tag: 'script',
          attrs: {
            type: 'module',
            src: `${config.base}${modernPolyfillFilename}`
          }
        });
      } else if (modernPolyfills.size) {
        throw new Error(
          `No corresponding modern polyfill chunk found for ${htmlFilename}`
        )
      }

      if (!genLegacy) {
        return { html, tags }
      }

      // 2. inject Safari 10 nomodule fix
      tags.push({
        tag: 'script',
        attrs: { nomodule: true },
        children: safari10NoModuleFix,
        injectTo: 'body'
      });

      // 3. inject legacy polyfills
      const legacyPolyfillFilename = facadeToLegacyPolyfillMap.get(
        chunk.facadeModuleId
      );
      if (legacyPolyfillFilename) {
        tags.push({
          tag: 'script',
          attrs: {
            nomodule: true,
            id: legacyPolyfillId,
            src: `${config.base}${legacyPolyfillFilename}`
          },
          injectTo: 'body'
        });
      } else if (legacyPolyfills.size) {
        throw new Error(
          `No corresponding legacy polyfill chunk found for ${htmlFilename}`
        )
      }

      // 4. inject legacy entry
      const legacyEntryFilename = facadeToLegacyChunkMap.get(
        chunk.facadeModuleId
      );
      if (legacyEntryFilename) {
        tags.push({
          tag: 'script',
          attrs: {
            nomodule: true,
            // we set the entry path on the element as an attribute so that the
            // script content will stay consistent - which allows using a constant
            // hash value for CSP.
            id: legacyEntryId,
            'data-src': config.base + legacyEntryFilename
          },
          children: systemJSInlineCode,
          injectTo: 'body'
        });
      } else {
        throw new Error(
          `No corresponding legacy entry chunk found for ${htmlFilename}`
        )
      }

      // 5. inject dynamic import fallback entry
      if (genDynamicFallback && legacyPolyfillFilename && legacyEntryFilename) {
        tags.push({
          tag: 'script',
          attrs: { type: 'module' },
          children: detectDynamicImportCode,
          injectTo: 'head'
        });
        tags.push({
          tag: 'script',
          attrs: { type: 'module' },
          children: dynamicFallbackInlineCode,
          injectTo: 'head'
        });
      }

      return {
        html,
        tags
      }
    },

    generateBundle(opts, bundle) {
      if (config.build.ssr) {
        return
      }

      if (isLegacyBundle(bundle, opts)) {
        // avoid emitting duplicate assets
        for (const name in bundle) {
          if (bundle[name].type === 'asset') {
            delete bundle[name];
          }
        }
      }
    }
  };

  let envInjectionFailed = false;
  /**
   * @type {import('vite').Plugin}
   */
  const legacyEnvPlugin = {
    name: 'vite:legacy-env',

    config(config, env) {
      if (env) {
        return {
          define: {
            'import.meta.env.LEGACY':
              env.command === 'serve' || config.build.ssr
                ? false
                : legacyEnvVarMarker
          }
        }
      } else {
        envInjectionFailed = true;
      }
    },

    configResolved(config) {
      if (envInjectionFailed) {
        config.logger.warn(
          `[@vitejs/plugin-legacy] import.meta.env.LEGACY was not injected due ` +
            `to incompatible vite version (requires vite@^2.0.0-beta.69).`
        );
      }
    }
  };

  return [
    legacyConfigPlugin,
    legacyGenerateBundlePlugin,
    legacyPostPlugin,
    legacyEnvPlugin
  ]
}

/**
 * @param {string} code
 * @param {any} targets
 * @param {Set<string>} list
 */
function detectPolyfills(code, targets, list) {
  const { ast } = loadBabel().transform(code, {
    ast: true,
    babelrc: false,
    configFile: false,
    presets: [
      [
        'env',
        {
          targets,
          modules: false,
          useBuiltIns: 'usage',
          corejs: { version: 3, proposals: false },
          shippedProposals: true,
          ignoreBrowserslistConfig: true
        }
      ]
    ]
  });
  for (const node of ast.program.body) {
    if (node.type === 'ImportDeclaration') {
      const source = node.source.value;
      if (
        source.startsWith('core-js/') ||
        source.startsWith('regenerator-runtime/')
      ) {
        list.add(source);
      }
    }
  }
}

/**
 * @param {string} name
 * @param {Set<string>} imports
 * @param {import('rollup').OutputBundle} bundle
 * @param {Map<string, string>} facadeToChunkMap
 * @param {import('vite').BuildOptions} buildOptions
 */
async function buildPolyfillChunk(
  name,
  imports,
  bundle,
  facadeToChunkMap,
  buildOptions,
  externalSystemJS
) {
  let { minify, assetsDir } = buildOptions;
  minify = minify ? 'terser' : false;
  const res = await build({
    // so that everything is resolved from here
    root: __dirname,
    configFile: false,
    logLevel: 'error',
    plugins: [polyfillsPlugin(imports, externalSystemJS)],
    build: {
      write: false,
      target: false,
      minify,
      assetsDir,
      rollupOptions: {
        input: {
          [name]: polyfillId
        },
        output: {
          format: name.includes('legacy') ? 'iife' : 'es',
          manualChunks: undefined
        }
      }
    }
  });
  const _polyfillChunk = Array.isArray(res) ? res[0] : res;
  if (!('output' in _polyfillChunk)) return
  const polyfillChunk = _polyfillChunk.output[0];

  // associate the polyfill chunk to every entry chunk so that we can retrieve
  // the polyfill filename in index html transform
  for (const key in bundle) {
    const chunk = bundle[key];
    if (chunk.type === 'chunk' && chunk.facadeModuleId) {
      facadeToChunkMap.set(chunk.facadeModuleId, polyfillChunk.fileName);
    }
  }

  // add the chunk to the bundle
  bundle[polyfillChunk.name] = polyfillChunk;
}

const polyfillId = '\0vite/legacy-polyfills';

/**
 * @param {Set<string>} imports
 * @return {import('rollup').Plugin}
 */
function polyfillsPlugin(imports, externalSystemJS) {
  return {
    name: 'vite:legacy-polyfills',
    resolveId(id) {
      if (id === polyfillId) {
        return id
      }
    },
    load(id) {
      if (id === polyfillId) {
        return (
          [...imports].map((i) => `import "${i}";`).join('') +
          (externalSystemJS ? '' : `import "systemjs/dist/s.min.js";`)
        )
      }
    }
  }
}

/**
 * @param {import('rollup').RenderedChunk} chunk
 * @param {import('rollup').NormalizedOutputOptions} options
 */
function isLegacyChunk(chunk, options) {
  return options.format === 'system' && chunk.fileName.includes('-legacy')
}

/**
 * @param {import('rollup').OutputBundle} bundle
 * @param {import('rollup').NormalizedOutputOptions} options
 */
function isLegacyBundle(bundle, options) {
  if (options.format === 'system') {
    const entryChunk = Object.values(bundle).find(
      (output) => output.type === 'chunk' && output.isEntry
    );

    return !!entryChunk && entryChunk.fileName.includes('-legacy')
  }

  return false
}

/**
 * @param {Set<string>} polyfills
 */
function recordAndRemovePolyfillBabelPlugin(polyfills) {
  return ({ types: t }) => ({
    name: 'vite-remove-polyfill-import',
    post({ path }) {
      path.get('body').forEach((p) => {
        if (t.isImportDeclaration(p)) {
          polyfills.add(p.node.source.value);
          p.remove();
        }
      });
    }
  })
}

function replaceLegacyEnvBabelPlugin() {
  return ({ types: t }) => ({
    name: 'vite-replace-env-legacy',
    visitor: {
      Identifier(path) {
        if (path.node.name === legacyEnvVarMarker) {
          path.replaceWith(t.booleanLiteral(true));
        }
      }
    }
  })
}

function wrapIIFEBabelPlugin() {
  return ({ types: t, template }) => {
    const buildIIFE = template(';(function(){%%body%%})();');

    return {
      name: 'vite-wrap-iife',
      post({ path }) {
        if (!this.isWrapped) {
          this.isWrapped = true;
          path.replaceWith(t.program(buildIIFE({ body: path.node.body })));
        }
      }
    }
  }
}

var pluginLegacy = viteLegacyPlugin;

viteLegacyPlugin.default = viteLegacyPlugin;

viteLegacyPlugin.cspHashes = [
  createHash('sha256').update(safari10NoModuleFix).digest('base64'),
  createHash('sha256').update(systemJSInlineCode).digest('base64'),
  createHash('sha256').update(detectDynamicImportCode).digest('base64'),
  createHash('sha256').update(dynamicFallbackInlineCode).digest('base64')
];

var legacy = /*@__PURE__*/getDefaultExportFromCjs(pluginLegacy);

const fs$1 = require("fs");
function modifyDistPath(obj) {
    const { root, outDir, html, assets } = obj;
    return {
        name: "modifyDistPath",
        closeBundle() {
            const fileName = "/index.html";
            /** 转移html文件 */
            fs$1.mkdir(path__default["default"].join(root + html), function (err) {
                if (err) {
                    return console.error(err);
                }
                fs$1.renameSync(path__default["default"].join(outDir + fileName), path__default["default"].join(root + html + fileName));
            });
            /** 转移manifest文件 */
            fs$1.mkdir(path__default["default"].join(root + assets), function (err) {
                if (err) {
                    return console.error(err);
                }
                fs$1.renameSync(path__default["default"].join(`${outDir}/rev-manifest.json`), path__default["default"].join(`${root}${assets}/rev-manifest.json`));
            });
        },
    };
}

const cwd = process.cwd();

const os = require("os");
const fs = require("fs");
const NEWLINE = "\n";
const RE_INI_KEY_VAL = /^\s*([\w.-]+)\s*=\s*("[^"]*"|'[^']*'|.*?)(\s+#.*)?$/;
const RE_NEWLINES = /\\n/g;
const NEWLINES_MATCH = /\r\n|\n|\r/;
var main$1 = { exports: {} };
// Parses src into an Object
function parse(src, options) {
    const debug = Boolean(options && options.debug);
    const multiline = Boolean(options && options.multiline);
    const obj = {};
    // convert Buffers before splitting into lines and processing
    const lines = src.toString().split(NEWLINES_MATCH);
    for (let idx = 0; idx < lines.length; idx++) {
        let line = lines[idx];
        // matching "KEY' and 'VAL' in 'KEY=VAL'
        const keyValueArr = line.match(RE_INI_KEY_VAL);
        // matched?
        if (keyValueArr != null) {
            const key = keyValueArr[1];
            // default undefined or missing values to empty any
            let val = keyValueArr[2] || "";
            let end = val.length - 1;
            const isDoubleQuoted = val[0] === '"' && val[end] === '"';
            const isSingleQuoted = val[0] === "'" && val[end] === "'";
            const isMultilineDoubleQuoted = val[0] === '"' && val[end] !== '"';
            const isMultilineSingleQuoted = val[0] === "'" && val[end] !== "'";
            // if parsing line breaks and the value starts with a quote
            if (multiline && (isMultilineDoubleQuoted || isMultilineSingleQuoted)) {
                const quoteChar = isMultilineDoubleQuoted ? '"' : "'";
                val = val.substring(1);
                while (idx++ < lines.length - 1) {
                    line = lines[idx];
                    end = line.length - 1;
                    if (line[end] === quoteChar) {
                        val += NEWLINE + line.substring(0, end);
                        break;
                    }
                    val += NEWLINE + line;
                }
                // if single or double quoted, remove quotes
            }
            else if (isSingleQuoted || isDoubleQuoted) {
                val = val.substring(1, end);
                // if double quoted, expand newlines
                if (isDoubleQuoted) {
                    val = val.replace(RE_NEWLINES, NEWLINE);
                }
            }
            else {
                // remove surrounding whitespace
                val = val.trim();
            }
            obj[key] = val;
        }
        else if (debug) {
            const trimmedLine = line.trim();
            // ignore empty and commented lines
            if (trimmedLine.length && trimmedLine[0] !== "#") {
                console.log(`Failed to match key and value when parsing line ${idx + 1}: ${line}`);
            }
        }
    }
    return obj;
}
function lookupFile(dir, formats, options) {
    for (const format of formats) {
        const fullPath = path__default["default"].join(dir, format);
        if (fs.existsSync(fullPath) && fs.statSync(fullPath).isFile()) {
            const result = (options === null || options === void 0 ? void 0 : options.pathOnly)
                ? fullPath
                : fs.readFileSync(fullPath, "utf-8");
            if (!(options === null || options === void 0 ? void 0 : options.predicate) || options.predicate(result)) {
                return result;
            }
        }
    }
    const parentDir = path__default["default"].dirname(dir);
    if (parentDir !== dir &&
        (!(options === null || options === void 0 ? void 0 : options.rootDir) || parentDir.startsWith(options === null || options === void 0 ? void 0 : options.rootDir))) {
        return lookupFile(parentDir, formats, options);
    }
}
function resolveHome(envPath) {
    return envPath[0] === "~"
        ? path__default["default"].join(os.homedir(), envPath.slice(1))
        : envPath;
}
var dotenvExpand = function (config) {
    // if ignoring process.env, use a blank object
    var environment = config.ignoreProcessEnv ? {} : process.env;
    var interpolate = function (envValue) {
        var matches = envValue.match(/(.?\${?(?:[a-zA-Z0-9_]+)?}?)/g) || [];
        return matches.reduce(function (newEnv, match) {
            var parts = /(.?)\${?([a-zA-Z0-9_]+)?}?/g.exec(match);
            var prefix = parts[1];
            var value, replacePart;
            if (prefix === "\\") {
                replacePart = parts[0];
                value = replacePart.replace("\\$", "$");
            }
            else {
                var key = parts[2];
                replacePart = parts[0].substring(prefix.length);
                // process.env value 'wins' over .env file's value
                value = environment.hasOwnProperty(key)
                    ? environment[key]
                    : config.parsed[key] || "";
                // Resolve recursive interpolations
                value = interpolate(value);
            }
            return newEnv.replace(replacePart, value);
        }, envValue);
    };
    for (var configKey in config.parsed) {
        var value = environment.hasOwnProperty(configKey)
            ? environment[configKey]
            : config.parsed[configKey];
        config.parsed[configKey] = interpolate(value);
    }
    for (var processKey in config.parsed) {
        environment[processKey] = config.parsed[processKey];
    }
    return config;
};
var main = dotenvExpand;
// Populates process.env from .env file
function config(options) {
    let dotenvPath = path__default["default"].resolve(process.cwd(), ".env");
    let encoding = "utf8";
    const debug = Boolean(options && options.debug);
    const override = Boolean(options && options.override);
    const multiline = Boolean(options && options.multiline);
    if (options) {
        if (options.path != null) {
            dotenvPath = resolveHome(options.path);
        }
        if (options.encoding != null) {
            encoding = options.encoding;
        }
    }
    try {
        // specifying an encoding returns a any instead of a buffer
        const parsed = DotenvModule.parse(fs.readFileSync(dotenvPath, { encoding }), { debug, multiline });
        Object.keys(parsed).forEach(function (key) {
            if (!Object.prototype.hasOwnProperty.call(process.env, key)) {
                process.env[key] = parsed[key];
            }
            else {
                if (override === true) {
                    process.env[key] = parsed[key];
                }
                if (debug) {
                    if (override === true) {
                        console.log(`"${key}" is already defined in \`process.env\` and WAS overwritten`);
                    }
                    else {
                        console.log(`"${key}" is already defined in \`process.env\` and was NOT overwritten`);
                    }
                }
            }
        });
        return { parsed };
    }
    catch (e) {
        if (debug) {
            console.log(`Failed to load ${dotenvPath} ${e.message}`);
        }
        return { error: e };
    }
}
const DotenvModule = {
    config,
    parse,
};
main$1.exports.config = DotenvModule.config;
main$1.exports.parse = DotenvModule.parse;
main$1.exports = DotenvModule;
function arraify(target) {
    return Array.isArray(target) ? target : [target];
}
const loadEnv = (mode, envDir, prefixes = "VITE_") => {
    var _a;
    if (mode === "local") {
        throw new Error(`"local" cannot be used as a mode name because it conflicts with ` +
            `the .local postfix for .env files.`);
    }
    const _prefixes = arraify(prefixes);
    const env = {};
    const envFiles = [
        /** mode local file */ `.env.${mode}.local`,
        /** mode file */ `.env.${mode}`,
        /** local file */ `.env.local`,
        /** default file */ `.env`,
    ];
    // check if there are actual env variables starting with VITE_*
    // these are typically provided inline and should be prioritized
    for (const key in process.env) {
        if (_prefixes.some((prefix) => key.startsWith(prefix)) &&
            env[key] === undefined) {
            env[key] = process.env[key];
        }
    }
    for (const file of envFiles) {
        const path = lookupFile(envDir, [file], {
            pathOnly: true,
            rootDir: envDir,
        });
        if (path) {
            const parsed = main$1.exports.parse(fs.readFileSync(path), {
                debug: ((_a = process.env.DEBUG) === null || _a === void 0 ? void 0 : _a.includes("vite:dotenv")) || undefined,
            });
            // let environment variables use each other
            main({
                parsed,
                // prevent process.env mutation
                ignoreProcessEnv: true,
            });
            // only keys that start with prefix are exposed to client
            for (const [key, value] of Object.entries(parsed)) {
                if (_prefixes.some((prefix) => key.startsWith(prefix)) &&
                    env[key] === undefined) {
                    env[key] = value;
                }
                else if (key === "NODE_ENV" &&
                    process.env.VITE_USER_NODE_ENV === undefined) {
                    // NODE_ENV override in .env file
                    process.env.VITE_USER_NODE_ENV = value;
                }
            }
        }
    }
    return env;
};

const IMAGES_REGEXP = ["png", "jpg", "jpge", "gif", "svga"];
const initProject = (localConfig, viteConfig) => {
    var _a, _b, _c, _d, _e, _f, _g, _h;
    /** 基础路径 */
    const BASE_PROJECT_PATH = ((_a = localConfig === null || localConfig === void 0 ? void 0 : localConfig.dest) === null || _a === void 0 ? void 0 : _a.basePath) || "./";
    /** css文件路径 */
    const CSS_PATH = ((_b = localConfig === null || localConfig === void 0 ? void 0 : localConfig.dest) === null || _b === void 0 ? void 0 : _b.cssPath) || "css";
    /** js文件路径 */
    const JS_PATH = ((_c = localConfig === null || localConfig === void 0 ? void 0 : localConfig.dest) === null || _c === void 0 ? void 0 : _c.jsPath) || "js";
    /** html文件路径 */
    const HTML_PATH = ((_d = localConfig === null || localConfig === void 0 ? void 0 : localConfig.dest) === null || _d === void 0 ? void 0 : _d.htmlPath) || "html";
    /** 图片文件路径 */
    const IMG_PATH = ((_e = localConfig === null || localConfig === void 0 ? void 0 : localConfig.dest) === null || _e === void 0 ? void 0 : _e.imagesPath) || "images";
    /** alias 基础路径 */
    const ALIAS_ROOT_PATH = (localConfig === null || localConfig === void 0 ? void 0 : localConfig.alias).srcRoot || "./src/";
    /** 输出目录 */
    const OUTDIR_PATH = (localConfig === null || localConfig === void 0 ? void 0 : localConfig.outDir) || "./dist/";
    const config = {
        base: "/",
        /** 根目录 */
        root: localConfig.root || "./",
        // /** 存储缓存文件的目录。 */
        cacheDir: localConfig.cacheDir || "node_modules/.vite",
        clearScreen: localConfig.clearScreen || false,
        /** 出口文件 */
        build: {
            outDir: path__default["default"].join(cwd, OUTDIR_PATH),
            emptyOutDir: true,
            manifest: "rev-manifest.json",
            assetsInlineLimit: 4096,
            rollupOptions: {
                external: [
                    "react",
                    "react-dom",
                    ...(((_g = (_f = localConfig === null || localConfig === void 0 ? void 0 : localConfig.build) === null || _f === void 0 ? void 0 : _f.rollupOptions) === null || _g === void 0 ? void 0 : _g.external) || []),
                ],
                output: {
                    entryFileNames: BASE_PROJECT_PATH + "js/[name]-[hash].js",
                    assetFileNames: (val) => {
                        var _a;
                        const works = (_a = val.name) === null || _a === void 0 ? void 0 : _a.split(".");
                        if (works) {
                            const type = works[works.length - 1];
                            if (type === "css") {
                                return BASE_PROJECT_PATH + CSS_PATH + "/[name]-[hash].[ext]";
                            }
                            if (type === "js") {
                                return BASE_PROJECT_PATH + JS_PATH + "/[name]-[hash].[ext]";
                            }
                            if (IMAGES_REGEXP.includes(type)) {
                                return BASE_PROJECT_PATH + IMG_PATH + "/[name]-[hash].[ext]";
                            }
                        }
                        const ext = "assets";
                        return BASE_PROJECT_PATH + ext + "/[name]-[hash].[ext]";
                    },
                    globals: {
                        react: "react",
                        "react-dom": "react-dom",
                    },
                },
            },
        },
        /** 开发配置 */
        server: {
            host: "0.0.0.0",
            port: ((_h = localConfig.server) === null || _h === void 0 ? void 0 : _h.port) || 5000,
        },
        /** 路径设置 */
        resolve: {
            alias: Array.isArray(localConfig === null || localConfig === void 0 ? void 0 : localConfig.alias)
                ? localConfig.alias
                : [
                    {
                        find: "~@",
                        replacement: path__default["default"].join(ALIAS_ROOT_PATH + "components/"),
                    },
                    {
                        find: "~",
                        replacement: path__default["default"].join(ALIAS_ROOT_PATH),
                    },
                ],
        },
        /** 导入 .css 文件将会把内容插入到 <style> 标签中，同时也带有 HMR 支持。也能够以字符串的形式检索处理后的、作为其模块默认导出的 CSS。 */
        css: {
            modules: localConfig.cssModules
                ? {
                    // css模块化 文件以.module.[css|less|scss]结尾
                    generateScopedName: "[name]__[local]___[hash:base64:5]",
                    hashPrefix: "winkey",
                }
                : false,
            /** 指定传递给 CSS 预处理器的选项。文件扩展名用作选项的键 */
            preprocessorOptions: {
                less: {
                    /** 支持内敛JavaScript */
                    javascriptEnabled: true,
                },
                scss: {
                    /** 支持内敛JavaScript */
                    javascriptEnabled: true,
                },
            },
        },
        /** 插件 */
        plugins: [
            legacy({
                targets: [
                    "Android >= 39",
                    "Chrome >= 39",
                    "Safari >= 10.1",
                    "iOS >= 10",
                    "> 0.5%",
                ],
                polyfills: ["es.promise", "regenerator-runtime"],
            }),
            S$1({
                include: ["src/**/*.ts", "src/**/*.tsx", "src/*.ts", "src/*.tsx"],
            }),
            modifyDistPath({
                root: OUTDIR_PATH + BASE_PROJECT_PATH,
                outDir: OUTDIR_PATH,
                html: HTML_PATH,
                assets: "/assets",
            }),
            react({
                babel: {
                    plugins: [
                        ["@babel/plugin-proposal-decorators", { version: "legacy" }],
                        ["@babel/plugin-transform-class-properties", { loose: true }],
                    ],
                },
            }),
            src_default(),
            Y$1({
                fix: true,
                quiet: true,
            }),
            htmlPlugin("react18", {
                useDevMode: true,
            }),
        ],
    };
    /** 合并plugin */
    config.plugins = Object.assign(config.plugins, localConfig.plugins || []);
    /** 合并css */
    config.css = Object.assign(config.css, localConfig.css || {});
    const { mode, command } = viteConfig;
    const env = loadEnv(mode, process.cwd());
    const isBuild = command === "build";
    config.plugins = [
        ...config.plugins,
        createHtmlPlugin({
            inject: {
                data: Object.assign(Object.assign({}, env), { devServerToolScript: localConfig.winkeyTool && !isBuild
                        ? `<script type="module" src="/winkey_tool/js/index.js"></script>`
                        : "", devServerToolDom: localConfig.winkeyTool && !isBuild
                        ? `<div id="winkey_tool"></div>`
                        : "", devServerToolCss: localConfig.winkeyTool && !isBuild
                        ? `<link href="/winkey_tool/css/index.css" rel="stylesheet" >`
                        : "" }),
            },
        }),
    ];
    return config;
};

// Helper since Typescript can't detect readonly arrays with Array.isArray
function isArray(arg) {
    return Array.isArray(arg);
}
function ensureArray(thing) {
    if (isArray(thing))
        return thing;
    if (thing == null)
        return [];
    return [thing];
}

const normalizePath$1 = function normalizePath(filename) {
    return filename.split(path$M.win32.sep).join(path$M.posix.sep);
};

function getMatcherString(id, resolutionBase) {
    if (resolutionBase === false || path$M.isAbsolute(id) || id.startsWith('**')) {
        return normalizePath$1(id);
    }
    // resolve('') is valid and will default to process.cwd()
    const basePath = normalizePath$1(path$M.resolve(resolutionBase || ''))
        // escape all possible (posix + win) path characters that might interfere with regex
        .replace(/[-^$*+?.()|[\]{}]/g, '\\$&');
    // Note that we use posix.join because:
    // 1. the basePath has been normalized to use /
    // 2. the incoming glob (id) matcher, also uses /
    // otherwise Node will force backslash (\) on windows
    return path$M.posix.join(basePath, normalizePath$1(id));
}
const createFilter = function createFilter(include, exclude, options) {
    const resolutionBase = options && options.resolve;
    const getMatcher = (id) => id instanceof RegExp
        ? id
        : {
            test: (what) => {
                // this refactor is a tad overly verbose but makes for easy debugging
                const pattern = getMatcherString(id, resolutionBase);
                const fn = pm$1(pattern, { dot: true });
                const result = fn(what);
                return result;
            }
        };
    const includeMatchers = ensureArray(include).map(getMatcher);
    const excludeMatchers = ensureArray(exclude).map(getMatcher);
    return function result(id) {
        if (typeof id !== 'string')
            return false;
        if (/\0/.test(id))
            return false;
        const pathId = normalizePath$1(id);
        for (let i = 0; i < excludeMatchers.length; ++i) {
            const matcher = excludeMatchers[i];
            if (matcher.test(pathId))
                return false;
        }
        for (let i = 0; i < includeMatchers.length; ++i) {
            const matcher = includeMatchers[i];
            if (matcher.test(pathId))
                return true;
        }
        return !includeMatchers.length;
    };
};

const reservedWords = 'break case class catch const continue debugger default delete do else export extends finally for function if import in instanceof let new return super switch this throw try typeof var void while with yield enum await implements package protected static interface private public';
const builtins = 'arguments Infinity NaN undefined null true false eval uneval isFinite isNaN parseFloat parseInt decodeURI decodeURIComponent encodeURI encodeURIComponent escape unescape Object Function Boolean Symbol Error EvalError InternalError RangeError ReferenceError SyntaxError TypeError URIError Number Math Date String RegExp Array Int8Array Uint8Array Uint8ClampedArray Int16Array Uint16Array Int32Array Uint32Array Float32Array Float64Array Map Set WeakMap WeakSet SIMD ArrayBuffer DataView JSON Promise Generator GeneratorFunction Reflect Proxy Intl';
const forbiddenIdentifiers = new Set(`${reservedWords} ${builtins}`.split(' '));
forbiddenIdentifiers.add('');

var typescript$2 = {exports: {}};

var sourceMapSupport = {exports: {}};

/* eslint-disable node/no-deprecated-api */

var bufferFrom_1;
var hasRequiredBufferFrom;

function requireBufferFrom () {
	if (hasRequiredBufferFrom) return bufferFrom_1;
	hasRequiredBufferFrom = 1;
	var toString = Object.prototype.toString;

	var isModern = (
	  typeof Buffer !== 'undefined' &&
	  typeof Buffer.alloc === 'function' &&
	  typeof Buffer.allocUnsafe === 'function' &&
	  typeof Buffer.from === 'function'
	);

	function isArrayBuffer (input) {
	  return toString.call(input).slice(8, -1) === 'ArrayBuffer'
	}

	function fromArrayBuffer (obj, byteOffset, length) {
	  byteOffset >>>= 0;

	  var maxLength = obj.byteLength - byteOffset;

	  if (maxLength < 0) {
	    throw new RangeError("'offset' is out of bounds")
	  }

	  if (length === undefined) {
	    length = maxLength;
	  } else {
	    length >>>= 0;

	    if (length > maxLength) {
	      throw new RangeError("'length' is out of bounds")
	    }
	  }

	  return isModern
	    ? Buffer.from(obj.slice(byteOffset, byteOffset + length))
	    : new Buffer(new Uint8Array(obj.slice(byteOffset, byteOffset + length)))
	}

	function fromString (string, encoding) {
	  if (typeof encoding !== 'string' || encoding === '') {
	    encoding = 'utf8';
	  }

	  if (!Buffer.isEncoding(encoding)) {
	    throw new TypeError('"encoding" must be a valid string encoding')
	  }

	  return isModern
	    ? Buffer.from(string, encoding)
	    : new Buffer(string, encoding)
	}

	function bufferFrom (value, encodingOrOffset, length) {
	  if (typeof value === 'number') {
	    throw new TypeError('"value" argument must not be a number')
	  }

	  if (isArrayBuffer(value)) {
	    return fromArrayBuffer(value, encodingOrOffset, length)
	  }

	  if (typeof value === 'string') {
	    return fromString(value, encodingOrOffset)
	  }

	  return isModern
	    ? Buffer.from(value)
	    : new Buffer(value)
	}

	bufferFrom_1 = bufferFrom;
	return bufferFrom_1;
}

sourceMapSupport.exports;

var hasRequiredSourceMapSupport;

function requireSourceMapSupport () {
	if (hasRequiredSourceMapSupport) return sourceMapSupport.exports;
	hasRequiredSourceMapSupport = 1;
	(function (module, exports) {
		var SourceMapConsumer = requireSourceMap$2().SourceMapConsumer;
		var path = path__default["default"];

		var fs;
		try {
		  fs = require('fs');
		  if (!fs.existsSync || !fs.readFileSync) {
		    // fs doesn't have all methods we need
		    fs = null;
		  }
		} catch (err) {
		  /* nop */
		}

		var bufferFrom = requireBufferFrom();

		/**
		 * Requires a module which is protected against bundler minification.
		 *
		 * @param {NodeModule} mod
		 * @param {string} request
		 */
		function dynamicRequire(mod, request) {
		  return mod.require(request);
		}

		// Only install once if called multiple times
		var errorFormatterInstalled = false;
		var uncaughtShimInstalled = false;

		// If true, the caches are reset before a stack trace formatting operation
		var emptyCacheBetweenOperations = false;

		// Supports {browser, node, auto}
		var environment = "auto";

		// Maps a file path to a string containing the file contents
		var fileContentsCache = {};

		// Maps a file path to a source map for that file
		var sourceMapCache = {};

		// Regex for detecting source maps
		var reSourceMap = /^data:application\/json[^,]+base64,/;

		// Priority list of retrieve handlers
		var retrieveFileHandlers = [];
		var retrieveMapHandlers = [];

		function isInBrowser() {
		  if (environment === "browser")
		    return true;
		  if (environment === "node")
		    return false;
		  return ((typeof window !== 'undefined') && (typeof XMLHttpRequest === 'function') && !(window.require && window.module && window.process && window.process.type === "renderer"));
		}

		function hasGlobalProcessEventEmitter() {
		  return ((typeof process === 'object') && (process !== null) && (typeof process.on === 'function'));
		}

		function globalProcessVersion() {
		  if ((typeof process === 'object') && (process !== null)) {
		    return process.version;
		  } else {
		    return '';
		  }
		}

		function globalProcessStderr() {
		  if ((typeof process === 'object') && (process !== null)) {
		    return process.stderr;
		  }
		}

		function globalProcessExit(code) {
		  if ((typeof process === 'object') && (process !== null) && (typeof process.exit === 'function')) {
		    return process.exit(code);
		  }
		}

		function handlerExec(list) {
		  return function(arg) {
		    for (var i = 0; i < list.length; i++) {
		      var ret = list[i](arg);
		      if (ret) {
		        return ret;
		      }
		    }
		    return null;
		  };
		}

		var retrieveFile = handlerExec(retrieveFileHandlers);

		retrieveFileHandlers.push(function(path) {
		  // Trim the path to make sure there is no extra whitespace.
		  path = path.trim();
		  if (/^file:/.test(path)) {
		    // existsSync/readFileSync can't handle file protocol, but once stripped, it works
		    path = path.replace(/file:\/\/\/(\w:)?/, function(protocol, drive) {
		      return drive ?
		        '' : // file:///C:/dir/file -> C:/dir/file
		        '/'; // file:///root-dir/file -> /root-dir/file
		    });
		  }
		  if (path in fileContentsCache) {
		    return fileContentsCache[path];
		  }

		  var contents = '';
		  try {
		    if (!fs) {
		      // Use SJAX if we are in the browser
		      var xhr = new XMLHttpRequest();
		      xhr.open('GET', path, /** async */ false);
		      xhr.send(null);
		      if (xhr.readyState === 4 && xhr.status === 200) {
		        contents = xhr.responseText;
		      }
		    } else if (fs.existsSync(path)) {
		      // Otherwise, use the filesystem
		      contents = fs.readFileSync(path, 'utf8');
		    }
		  } catch (er) {
		    /* ignore any errors */
		  }

		  return fileContentsCache[path] = contents;
		});

		// Support URLs relative to a directory, but be careful about a protocol prefix
		// in case we are in the browser (i.e. directories may start with "http://" or "file:///")
		function supportRelativeURL(file, url) {
		  if (!file) return url;
		  var dir = path.dirname(file);
		  var match = /^\w+:\/\/[^\/]*/.exec(dir);
		  var protocol = match ? match[0] : '';
		  var startPath = dir.slice(protocol.length);
		  if (protocol && /^\/\w\:/.test(startPath)) {
		    // handle file:///C:/ paths
		    protocol += '/';
		    return protocol + path.resolve(dir.slice(protocol.length), url).replace(/\\/g, '/');
		  }
		  return protocol + path.resolve(dir.slice(protocol.length), url);
		}

		function retrieveSourceMapURL(source) {
		  var fileData;

		  if (isInBrowser()) {
		     try {
		       var xhr = new XMLHttpRequest();
		       xhr.open('GET', source, false);
		       xhr.send(null);
		       fileData = xhr.readyState === 4 ? xhr.responseText : null;

		       // Support providing a sourceMappingURL via the SourceMap header
		       var sourceMapHeader = xhr.getResponseHeader("SourceMap") ||
		                             xhr.getResponseHeader("X-SourceMap");
		       if (sourceMapHeader) {
		         return sourceMapHeader;
		       }
		     } catch (e) {
		     }
		  }

		  // Get the URL of the source map
		  fileData = retrieveFile(source);
		  var re = /(?:\/\/[@#][\s]*sourceMappingURL=([^\s'"]+)[\s]*$)|(?:\/\*[@#][\s]*sourceMappingURL=([^\s*'"]+)[\s]*(?:\*\/)[\s]*$)/mg;
		  // Keep executing the search to find the *last* sourceMappingURL to avoid
		  // picking up sourceMappingURLs from comments, strings, etc.
		  var lastMatch, match;
		  while (match = re.exec(fileData)) lastMatch = match;
		  if (!lastMatch) return null;
		  return lastMatch[1];
		}
		// Can be overridden by the retrieveSourceMap option to install. Takes a
		// generated source filename; returns a {map, optional url} object, or null if
		// there is no source map.  The map field may be either a string or the parsed
		// JSON object (ie, it must be a valid argument to the SourceMapConsumer
		// constructor).
		var retrieveSourceMap = handlerExec(retrieveMapHandlers);
		retrieveMapHandlers.push(function(source) {
		  var sourceMappingURL = retrieveSourceMapURL(source);
		  if (!sourceMappingURL) return null;

		  // Read the contents of the source map
		  var sourceMapData;
		  if (reSourceMap.test(sourceMappingURL)) {
		    // Support source map URL as a data url
		    var rawData = sourceMappingURL.slice(sourceMappingURL.indexOf(',') + 1);
		    sourceMapData = bufferFrom(rawData, "base64").toString();
		    sourceMappingURL = source;
		  } else {
		    // Support source map URLs relative to the source URL
		    sourceMappingURL = supportRelativeURL(source, sourceMappingURL);
		    sourceMapData = retrieveFile(sourceMappingURL);
		  }

		  if (!sourceMapData) {
		    return null;
		  }

		  return {
		    url: sourceMappingURL,
		    map: sourceMapData
		  };
		});

		function mapSourcePosition(position) {
		  var sourceMap = sourceMapCache[position.source];
		  if (!sourceMap) {
		    // Call the (overrideable) retrieveSourceMap function to get the source map.
		    var urlAndMap = retrieveSourceMap(position.source);
		    if (urlAndMap) {
		      sourceMap = sourceMapCache[position.source] = {
		        url: urlAndMap.url,
		        map: new SourceMapConsumer(urlAndMap.map)
		      };

		      // Load all sources stored inline with the source map into the file cache
		      // to pretend like they are already loaded. They may not exist on disk.
		      if (sourceMap.map.sourcesContent) {
		        sourceMap.map.sources.forEach(function(source, i) {
		          var contents = sourceMap.map.sourcesContent[i];
		          if (contents) {
		            var url = supportRelativeURL(sourceMap.url, source);
		            fileContentsCache[url] = contents;
		          }
		        });
		      }
		    } else {
		      sourceMap = sourceMapCache[position.source] = {
		        url: null,
		        map: null
		      };
		    }
		  }

		  // Resolve the source URL relative to the URL of the source map
		  if (sourceMap && sourceMap.map && typeof sourceMap.map.originalPositionFor === 'function') {
		    var originalPosition = sourceMap.map.originalPositionFor(position);

		    // Only return the original position if a matching line was found. If no
		    // matching line is found then we return position instead, which will cause
		    // the stack trace to print the path and line for the compiled file. It is
		    // better to give a precise location in the compiled file than a vague
		    // location in the original file.
		    if (originalPosition.source !== null) {
		      originalPosition.source = supportRelativeURL(
		        sourceMap.url, originalPosition.source);
		      return originalPosition;
		    }
		  }

		  return position;
		}

		// Parses code generated by FormatEvalOrigin(), a function inside V8:
		// https://code.google.com/p/v8/source/browse/trunk/src/messages.js
		function mapEvalOrigin(origin) {
		  // Most eval() calls are in this format
		  var match = /^eval at ([^(]+) \((.+):(\d+):(\d+)\)$/.exec(origin);
		  if (match) {
		    var position = mapSourcePosition({
		      source: match[2],
		      line: +match[3],
		      column: match[4] - 1
		    });
		    return 'eval at ' + match[1] + ' (' + position.source + ':' +
		      position.line + ':' + (position.column + 1) + ')';
		  }

		  // Parse nested eval() calls using recursion
		  match = /^eval at ([^(]+) \((.+)\)$/.exec(origin);
		  if (match) {
		    return 'eval at ' + match[1] + ' (' + mapEvalOrigin(match[2]) + ')';
		  }

		  // Make sure we still return useful information if we didn't find anything
		  return origin;
		}

		// This is copied almost verbatim from the V8 source code at
		// https://code.google.com/p/v8/source/browse/trunk/src/messages.js. The
		// implementation of wrapCallSite() used to just forward to the actual source
		// code of CallSite.prototype.toString but unfortunately a new release of V8
		// did something to the prototype chain and broke the shim. The only fix I
		// could find was copy/paste.
		function CallSiteToString() {
		  var fileName;
		  var fileLocation = "";
		  if (this.isNative()) {
		    fileLocation = "native";
		  } else {
		    fileName = this.getScriptNameOrSourceURL();
		    if (!fileName && this.isEval()) {
		      fileLocation = this.getEvalOrigin();
		      fileLocation += ", ";  // Expecting source position to follow.
		    }

		    if (fileName) {
		      fileLocation += fileName;
		    } else {
		      // Source code does not originate from a file and is not native, but we
		      // can still get the source position inside the source string, e.g. in
		      // an eval string.
		      fileLocation += "<anonymous>";
		    }
		    var lineNumber = this.getLineNumber();
		    if (lineNumber != null) {
		      fileLocation += ":" + lineNumber;
		      var columnNumber = this.getColumnNumber();
		      if (columnNumber) {
		        fileLocation += ":" + columnNumber;
		      }
		    }
		  }

		  var line = "";
		  var functionName = this.getFunctionName();
		  var addSuffix = true;
		  var isConstructor = this.isConstructor();
		  var isMethodCall = !(this.isToplevel() || isConstructor);
		  if (isMethodCall) {
		    var typeName = this.getTypeName();
		    // Fixes shim to be backward compatable with Node v0 to v4
		    if (typeName === "[object Object]") {
		      typeName = "null";
		    }
		    var methodName = this.getMethodName();
		    if (functionName) {
		      if (typeName && functionName.indexOf(typeName) != 0) {
		        line += typeName + ".";
		      }
		      line += functionName;
		      if (methodName && functionName.indexOf("." + methodName) != functionName.length - methodName.length - 1) {
		        line += " [as " + methodName + "]";
		      }
		    } else {
		      line += typeName + "." + (methodName || "<anonymous>");
		    }
		  } else if (isConstructor) {
		    line += "new " + (functionName || "<anonymous>");
		  } else if (functionName) {
		    line += functionName;
		  } else {
		    line += fileLocation;
		    addSuffix = false;
		  }
		  if (addSuffix) {
		    line += " (" + fileLocation + ")";
		  }
		  return line;
		}

		function cloneCallSite(frame) {
		  var object = {};
		  Object.getOwnPropertyNames(Object.getPrototypeOf(frame)).forEach(function(name) {
		    object[name] = /^(?:is|get)/.test(name) ? function() { return frame[name].call(frame); } : frame[name];
		  });
		  object.toString = CallSiteToString;
		  return object;
		}

		function wrapCallSite(frame, state) {
		  // provides interface backward compatibility
		  if (state === undefined) {
		    state = { nextPosition: null, curPosition: null };
		  }
		  if(frame.isNative()) {
		    state.curPosition = null;
		    return frame;
		  }

		  // Most call sites will return the source file from getFileName(), but code
		  // passed to eval() ending in "//# sourceURL=..." will return the source file
		  // from getScriptNameOrSourceURL() instead
		  var source = frame.getFileName() || frame.getScriptNameOrSourceURL();
		  if (source) {
		    var line = frame.getLineNumber();
		    var column = frame.getColumnNumber() - 1;

		    // Fix position in Node where some (internal) code is prepended.
		    // See https://github.com/evanw/node-source-map-support/issues/36
		    // Header removed in node at ^10.16 || >=11.11.0
		    // v11 is not an LTS candidate, we can just test the one version with it.
		    // Test node versions for: 10.16-19, 10.20+, 12-19, 20-99, 100+, or 11.11
		    var noHeader = /^v(10\.1[6-9]|10\.[2-9][0-9]|10\.[0-9]{3,}|1[2-9]\d*|[2-9]\d|\d{3,}|11\.11)/;
		    var headerLength = noHeader.test(globalProcessVersion()) ? 0 : 62;
		    if (line === 1 && column > headerLength && !isInBrowser() && !frame.isEval()) {
		      column -= headerLength;
		    }

		    var position = mapSourcePosition({
		      source: source,
		      line: line,
		      column: column
		    });
		    state.curPosition = position;
		    frame = cloneCallSite(frame);
		    var originalFunctionName = frame.getFunctionName;
		    frame.getFunctionName = function() {
		      if (state.nextPosition == null) {
		        return originalFunctionName();
		      }
		      return state.nextPosition.name || originalFunctionName();
		    };
		    frame.getFileName = function() { return position.source; };
		    frame.getLineNumber = function() { return position.line; };
		    frame.getColumnNumber = function() { return position.column + 1; };
		    frame.getScriptNameOrSourceURL = function() { return position.source; };
		    return frame;
		  }

		  // Code called using eval() needs special handling
		  var origin = frame.isEval() && frame.getEvalOrigin();
		  if (origin) {
		    origin = mapEvalOrigin(origin);
		    frame = cloneCallSite(frame);
		    frame.getEvalOrigin = function() { return origin; };
		    return frame;
		  }

		  // If we get here then we were unable to change the source position
		  return frame;
		}

		// This function is part of the V8 stack trace API, for more info see:
		// https://v8.dev/docs/stack-trace-api
		function prepareStackTrace(error, stack) {
		  if (emptyCacheBetweenOperations) {
		    fileContentsCache = {};
		    sourceMapCache = {};
		  }

		  var name = error.name || 'Error';
		  var message = error.message || '';
		  var errorString = name + ": " + message;

		  var state = { nextPosition: null, curPosition: null };
		  var processedStack = [];
		  for (var i = stack.length - 1; i >= 0; i--) {
		    processedStack.push('\n    at ' + wrapCallSite(stack[i], state));
		    state.nextPosition = state.curPosition;
		  }
		  state.curPosition = state.nextPosition = null;
		  return errorString + processedStack.reverse().join('');
		}

		// Generate position and snippet of original source with pointer
		function getErrorSource(error) {
		  var match = /\n    at [^(]+ \((.*):(\d+):(\d+)\)/.exec(error.stack);
		  if (match) {
		    var source = match[1];
		    var line = +match[2];
		    var column = +match[3];

		    // Support the inline sourceContents inside the source map
		    var contents = fileContentsCache[source];

		    // Support files on disk
		    if (!contents && fs && fs.existsSync(source)) {
		      try {
		        contents = fs.readFileSync(source, 'utf8');
		      } catch (er) {
		        contents = '';
		      }
		    }

		    // Format the line from the original source code like node does
		    if (contents) {
		      var code = contents.split(/(?:\r\n|\r|\n)/)[line - 1];
		      if (code) {
		        return source + ':' + line + '\n' + code + '\n' +
		          new Array(column).join(' ') + '^';
		      }
		    }
		  }
		  return null;
		}

		function printErrorAndExit (error) {
		  var source = getErrorSource(error);

		  // Ensure error is printed synchronously and not truncated
		  var stderr = globalProcessStderr();
		  if (stderr && stderr._handle && stderr._handle.setBlocking) {
		    stderr._handle.setBlocking(true);
		  }

		  if (source) {
		    console.error();
		    console.error(source);
		  }

		  console.error(error.stack);
		  globalProcessExit(1);
		}

		function shimEmitUncaughtException () {
		  var origEmit = process.emit;

		  process.emit = function (type) {
		    if (type === 'uncaughtException') {
		      var hasStack = (arguments[1] && arguments[1].stack);
		      var hasListeners = (this.listeners(type).length > 0);

		      if (hasStack && !hasListeners) {
		        return printErrorAndExit(arguments[1]);
		      }
		    }

		    return origEmit.apply(this, arguments);
		  };
		}

		var originalRetrieveFileHandlers = retrieveFileHandlers.slice(0);
		var originalRetrieveMapHandlers = retrieveMapHandlers.slice(0);

		exports.wrapCallSite = wrapCallSite;
		exports.getErrorSource = getErrorSource;
		exports.mapSourcePosition = mapSourcePosition;
		exports.retrieveSourceMap = retrieveSourceMap;

		exports.install = function(options) {
		  options = options || {};

		  if (options.environment) {
		    environment = options.environment;
		    if (["node", "browser", "auto"].indexOf(environment) === -1) {
		      throw new Error("environment " + environment + " was unknown. Available options are {auto, browser, node}")
		    }
		  }

		  // Allow sources to be found by methods other than reading the files
		  // directly from disk.
		  if (options.retrieveFile) {
		    if (options.overrideRetrieveFile) {
		      retrieveFileHandlers.length = 0;
		    }

		    retrieveFileHandlers.unshift(options.retrieveFile);
		  }

		  // Allow source maps to be found by methods other than reading the files
		  // directly from disk.
		  if (options.retrieveSourceMap) {
		    if (options.overrideRetrieveSourceMap) {
		      retrieveMapHandlers.length = 0;
		    }

		    retrieveMapHandlers.unshift(options.retrieveSourceMap);
		  }

		  // Support runtime transpilers that include inline source maps
		  if (options.hookRequire && !isInBrowser()) {
		    // Use dynamicRequire to avoid including in browser bundles
		    var Module = dynamicRequire(module, 'module');
		    var $compile = Module.prototype._compile;

		    if (!$compile.__sourceMapSupport) {
		      Module.prototype._compile = function(content, filename) {
		        fileContentsCache[filename] = content;
		        sourceMapCache[filename] = undefined;
		        return $compile.call(this, content, filename);
		      };

		      Module.prototype._compile.__sourceMapSupport = true;
		    }
		  }

		  // Configure options
		  if (!emptyCacheBetweenOperations) {
		    emptyCacheBetweenOperations = 'emptyCacheBetweenOperations' in options ?
		      options.emptyCacheBetweenOperations : false;
		  }

		  // Install the error reformatter
		  if (!errorFormatterInstalled) {
		    errorFormatterInstalled = true;
		    Error.prepareStackTrace = prepareStackTrace;
		  }

		  if (!uncaughtShimInstalled) {
		    var installHandler = 'handleUncaughtExceptions' in options ?
		      options.handleUncaughtExceptions : true;

		    // Do not override 'uncaughtException' with our own handler in Node.js
		    // Worker threads. Workers pass the error to the main thread as an event,
		    // rather than printing something to stderr and exiting.
		    try {
		      // We need to use `dynamicRequire` because `require` on it's own will be optimized by WebPack/Browserify.
		      var worker_threads = dynamicRequire(module, 'worker_threads');
		      if (worker_threads.isMainThread === false) {
		        installHandler = false;
		      }
		    } catch(e) {}

		    // Provide the option to not install the uncaught exception handler. This is
		    // to support other uncaught exception handlers (in test frameworks, for
		    // example). If this handler is not installed and there are no other uncaught
		    // exception handlers, uncaught exceptions will be caught by node's built-in
		    // exception handler and the process will still be terminated. However, the
		    // generated JavaScript code will be shown above the stack trace instead of
		    // the original source code.
		    if (installHandler && hasGlobalProcessEventEmitter()) {
		      uncaughtShimInstalled = true;
		      shimEmitUncaughtException();
		    }
		  }
		};

		exports.resetRetrieveHandlers = function() {
		  retrieveFileHandlers.length = 0;
		  retrieveMapHandlers.length = 0;

		  retrieveFileHandlers = originalRetrieveFileHandlers.slice(0);
		  retrieveMapHandlers = originalRetrieveMapHandlers.slice(0);

		  retrieveSourceMap = handlerExec(retrieveMapHandlers);
		  retrieveFile = handlerExec(retrieveFileHandlers);
		}; 
	} (sourceMapSupport, sourceMapSupport.exports));
	return sourceMapSupport.exports;
}

/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
typescript$2.exports;

(function (module) {
	var ts = (() => {
	  var __defProp = Object.defineProperty;
	  var __getOwnPropNames = Object.getOwnPropertyNames;
	  var __esm = (fn, res) => function __init() {
	    return fn && (res = (0, fn[__getOwnPropNames(fn)[0]])(fn = 0)), res;
	  };
	  var __commonJS = (cb, mod) => function __require() {
	    return mod || (0, cb[__getOwnPropNames(cb)[0]])((mod = { exports: {} }).exports, mod), mod.exports;
	  };
	  var __export = (target, all) => {
	    for (var name in all)
	      __defProp(target, name, { get: all[name], enumerable: true });
	  };

	  // src/compiler/corePublic.ts
	  var versionMajorMinor, version, Comparison;
	  var init_corePublic = __esm({
	    "src/compiler/corePublic.ts"() {
	      versionMajorMinor = "5.4";
	      version = "5.4.5";
	      Comparison = /* @__PURE__ */ ((Comparison3) => {
	        Comparison3[Comparison3["LessThan"] = -1] = "LessThan";
	        Comparison3[Comparison3["EqualTo"] = 0] = "EqualTo";
	        Comparison3[Comparison3["GreaterThan"] = 1] = "GreaterThan";
	        return Comparison3;
	      })(Comparison || {});
	    }
	  });

	  // src/compiler/core.ts
	  function length(array) {
	    return array ? array.length : 0;
	  }
	  function forEach(array, callback) {
	    if (array) {
	      for (let i = 0; i < array.length; i++) {
	        const result = callback(array[i], i);
	        if (result) {
	          return result;
	        }
	      }
	    }
	    return void 0;
	  }
	  function forEachRight(array, callback) {
	    if (array) {
	      for (let i = array.length - 1; i >= 0; i--) {
	        const result = callback(array[i], i);
	        if (result) {
	          return result;
	        }
	      }
	    }
	    return void 0;
	  }
	  function firstDefined(array, callback) {
	    if (array === void 0) {
	      return void 0;
	    }
	    for (let i = 0; i < array.length; i++) {
	      const result = callback(array[i], i);
	      if (result !== void 0) {
	        return result;
	      }
	    }
	    return void 0;
	  }
	  function firstDefinedIterator(iter, callback) {
	    for (const value of iter) {
	      const result = callback(value);
	      if (result !== void 0) {
	        return result;
	      }
	    }
	    return void 0;
	  }
	  function reduceLeftIterator(iterator, f, initial) {
	    let result = initial;
	    if (iterator) {
	      let pos = 0;
	      for (const value of iterator) {
	        result = f(result, value, pos);
	        pos++;
	      }
	    }
	    return result;
	  }
	  function zipWith(arrayA, arrayB, callback) {
	    const result = [];
	    Debug.assertEqual(arrayA.length, arrayB.length);
	    for (let i = 0; i < arrayA.length; i++) {
	      result.push(callback(arrayA[i], arrayB[i], i));
	    }
	    return result;
	  }
	  function intersperse(input, element) {
	    if (input.length <= 1) {
	      return input;
	    }
	    const result = [];
	    for (let i = 0, n = input.length; i < n; i++) {
	      if (i)
	        result.push(element);
	      result.push(input[i]);
	    }
	    return result;
	  }
	  function every(array, callback) {
	    if (array) {
	      for (let i = 0; i < array.length; i++) {
	        if (!callback(array[i], i)) {
	          return false;
	        }
	      }
	    }
	    return true;
	  }
	  function find(array, predicate, startIndex) {
	    if (array === void 0)
	      return void 0;
	    for (let i = startIndex ?? 0; i < array.length; i++) {
	      const value = array[i];
	      if (predicate(value, i)) {
	        return value;
	      }
	    }
	    return void 0;
	  }
	  function findLast(array, predicate, startIndex) {
	    if (array === void 0)
	      return void 0;
	    for (let i = startIndex ?? array.length - 1; i >= 0; i--) {
	      const value = array[i];
	      if (predicate(value, i)) {
	        return value;
	      }
	    }
	    return void 0;
	  }
	  function findIndex(array, predicate, startIndex) {
	    if (array === void 0)
	      return -1;
	    for (let i = startIndex ?? 0; i < array.length; i++) {
	      if (predicate(array[i], i)) {
	        return i;
	      }
	    }
	    return -1;
	  }
	  function findLastIndex(array, predicate, startIndex) {
	    if (array === void 0)
	      return -1;
	    for (let i = startIndex ?? array.length - 1; i >= 0; i--) {
	      if (predicate(array[i], i)) {
	        return i;
	      }
	    }
	    return -1;
	  }
	  function findMap(array, callback) {
	    for (let i = 0; i < array.length; i++) {
	      const result = callback(array[i], i);
	      if (result) {
	        return result;
	      }
	    }
	    return Debug.fail();
	  }
	  function contains(array, value, equalityComparer = equateValues) {
	    if (array) {
	      for (const v of array) {
	        if (equalityComparer(v, value)) {
	          return true;
	        }
	      }
	    }
	    return false;
	  }
	  function arraysEqual(a, b, equalityComparer = equateValues) {
	    return a.length === b.length && a.every((x, i) => equalityComparer(x, b[i]));
	  }
	  function indexOfAnyCharCode(text, charCodes, start) {
	    for (let i = start || 0; i < text.length; i++) {
	      if (contains(charCodes, text.charCodeAt(i))) {
	        return i;
	      }
	    }
	    return -1;
	  }
	  function countWhere(array, predicate) {
	    let count = 0;
	    if (array) {
	      for (let i = 0; i < array.length; i++) {
	        const v = array[i];
	        if (predicate(v, i)) {
	          count++;
	        }
	      }
	    }
	    return count;
	  }
	  function filter(array, f) {
	    if (array) {
	      const len = array.length;
	      let i = 0;
	      while (i < len && f(array[i]))
	        i++;
	      if (i < len) {
	        const result = array.slice(0, i);
	        i++;
	        while (i < len) {
	          const item = array[i];
	          if (f(item)) {
	            result.push(item);
	          }
	          i++;
	        }
	        return result;
	      }
	    }
	    return array;
	  }
	  function filterMutate(array, f) {
	    let outIndex = 0;
	    for (let i = 0; i < array.length; i++) {
	      if (f(array[i], i, array)) {
	        array[outIndex] = array[i];
	        outIndex++;
	      }
	    }
	    array.length = outIndex;
	  }
	  function clear(array) {
	    array.length = 0;
	  }
	  function map(array, f) {
	    let result;
	    if (array) {
	      result = [];
	      for (let i = 0; i < array.length; i++) {
	        result.push(f(array[i], i));
	      }
	    }
	    return result;
	  }
	  function* mapIterator(iter, mapFn) {
	    for (const x of iter) {
	      yield mapFn(x);
	    }
	  }
	  function sameMap(array, f) {
	    if (array) {
	      for (let i = 0; i < array.length; i++) {
	        const item = array[i];
	        const mapped = f(item, i);
	        if (item !== mapped) {
	          const result = array.slice(0, i);
	          result.push(mapped);
	          for (i++; i < array.length; i++) {
	            result.push(f(array[i], i));
	          }
	          return result;
	        }
	      }
	    }
	    return array;
	  }
	  function flatten(array) {
	    const result = [];
	    for (const v of array) {
	      if (v) {
	        if (isArray(v)) {
	          addRange(result, v);
	        } else {
	          result.push(v);
	        }
	      }
	    }
	    return result;
	  }
	  function flatMap(array, mapfn) {
	    let result;
	    if (array) {
	      for (let i = 0; i < array.length; i++) {
	        const v = mapfn(array[i], i);
	        if (v) {
	          if (isArray(v)) {
	            result = addRange(result, v);
	          } else {
	            result = append(result, v);
	          }
	        }
	      }
	    }
	    return result || emptyArray;
	  }
	  function flatMapToMutable(array, mapfn) {
	    const result = [];
	    if (array) {
	      for (let i = 0; i < array.length; i++) {
	        const v = mapfn(array[i], i);
	        if (v) {
	          if (isArray(v)) {
	            addRange(result, v);
	          } else {
	            result.push(v);
	          }
	        }
	      }
	    }
	    return result;
	  }
	  function* flatMapIterator(iter, mapfn) {
	    for (const x of iter) {
	      const iter2 = mapfn(x);
	      if (!iter2)
	        continue;
	      yield* iter2;
	    }
	  }
	  function sameFlatMap(array, mapfn) {
	    let result;
	    if (array) {
	      for (let i = 0; i < array.length; i++) {
	        const item = array[i];
	        const mapped = mapfn(item, i);
	        if (result || item !== mapped || isArray(mapped)) {
	          if (!result) {
	            result = array.slice(0, i);
	          }
	          if (isArray(mapped)) {
	            addRange(result, mapped);
	          } else {
	            result.push(mapped);
	          }
	        }
	      }
	    }
	    return result || array;
	  }
	  function mapAllOrFail(array, mapFn) {
	    const result = [];
	    for (let i = 0; i < array.length; i++) {
	      const mapped = mapFn(array[i], i);
	      if (mapped === void 0) {
	        return void 0;
	      }
	      result.push(mapped);
	    }
	    return result;
	  }
	  function mapDefined(array, mapFn) {
	    const result = [];
	    if (array) {
	      for (let i = 0; i < array.length; i++) {
	        const mapped = mapFn(array[i], i);
	        if (mapped !== void 0) {
	          result.push(mapped);
	        }
	      }
	    }
	    return result;
	  }
	  function* mapDefinedIterator(iter, mapFn) {
	    for (const x of iter) {
	      const value = mapFn(x);
	      if (value !== void 0) {
	        yield value;
	      }
	    }
	  }
	  function mapDefinedEntries(map2, f) {
	    if (!map2) {
	      return void 0;
	    }
	    const result = /* @__PURE__ */ new Map();
	    map2.forEach((value, key) => {
	      const entry = f(key, value);
	      if (entry !== void 0) {
	        const [newKey, newValue] = entry;
	        if (newKey !== void 0 && newValue !== void 0) {
	          result.set(newKey, newValue);
	        }
	      }
	    });
	    return result;
	  }
	  function getOrUpdate(map2, key, callback) {
	    if (map2.has(key)) {
	      return map2.get(key);
	    }
	    const value = callback();
	    map2.set(key, value);
	    return value;
	  }
	  function tryAddToSet(set, value) {
	    if (!set.has(value)) {
	      set.add(value);
	      return true;
	    }
	    return false;
	  }
	  function* singleIterator(value) {
	    yield value;
	  }
	  function spanMap(array, keyfn, mapfn) {
	    let result;
	    if (array) {
	      result = [];
	      const len = array.length;
	      let previousKey;
	      let key;
	      let start = 0;
	      let pos = 0;
	      while (start < len) {
	        while (pos < len) {
	          const value = array[pos];
	          key = keyfn(value, pos);
	          if (pos === 0) {
	            previousKey = key;
	          } else if (key !== previousKey) {
	            break;
	          }
	          pos++;
	        }
	        if (start < pos) {
	          const v = mapfn(array.slice(start, pos), previousKey, start, pos);
	          if (v) {
	            result.push(v);
	          }
	          start = pos;
	        }
	        previousKey = key;
	        pos++;
	      }
	    }
	    return result;
	  }
	  function mapEntries(map2, f) {
	    if (!map2) {
	      return void 0;
	    }
	    const result = /* @__PURE__ */ new Map();
	    map2.forEach((value, key) => {
	      const [newKey, newValue] = f(key, value);
	      result.set(newKey, newValue);
	    });
	    return result;
	  }
	  function some(array, predicate) {
	    if (array) {
	      if (predicate) {
	        for (const v of array) {
	          if (predicate(v)) {
	            return true;
	          }
	        }
	      } else {
	        return array.length > 0;
	      }
	    }
	    return false;
	  }
	  function getRangesWhere(arr, pred, cb) {
	    let start;
	    for (let i = 0; i < arr.length; i++) {
	      if (pred(arr[i])) {
	        start = start === void 0 ? i : start;
	      } else {
	        if (start !== void 0) {
	          cb(start, i);
	          start = void 0;
	        }
	      }
	    }
	    if (start !== void 0)
	      cb(start, arr.length);
	  }
	  function concatenate(array1, array2) {
	    if (!some(array2))
	      return array1;
	    if (!some(array1))
	      return array2;
	    return [...array1, ...array2];
	  }
	  function selectIndex(_, i) {
	    return i;
	  }
	  function indicesOf(array) {
	    return array.map(selectIndex);
	  }
	  function deduplicateRelational(array, equalityComparer, comparer) {
	    const indices = indicesOf(array);
	    stableSortIndices(array, indices, comparer);
	    let last2 = array[indices[0]];
	    const deduplicated = [indices[0]];
	    for (let i = 1; i < indices.length; i++) {
	      const index = indices[i];
	      const item = array[index];
	      if (!equalityComparer(last2, item)) {
	        deduplicated.push(index);
	        last2 = item;
	      }
	    }
	    deduplicated.sort();
	    return deduplicated.map((i) => array[i]);
	  }
	  function deduplicateEquality(array, equalityComparer) {
	    const result = [];
	    for (const item of array) {
	      pushIfUnique(result, item, equalityComparer);
	    }
	    return result;
	  }
	  function deduplicate(array, equalityComparer, comparer) {
	    return array.length === 0 ? [] : array.length === 1 ? array.slice() : comparer ? deduplicateRelational(array, equalityComparer, comparer) : deduplicateEquality(array, equalityComparer);
	  }
	  function deduplicateSorted(array, comparer) {
	    if (array.length === 0)
	      return emptyArray;
	    let last2 = array[0];
	    const deduplicated = [last2];
	    for (let i = 1; i < array.length; i++) {
	      const next = array[i];
	      switch (comparer(next, last2)) {
	        case true:
	        case 0 /* EqualTo */:
	          continue;
	        case -1 /* LessThan */:
	          return Debug.fail("Array is unsorted.");
	      }
	      deduplicated.push(last2 = next);
	    }
	    return deduplicated;
	  }
	  function createSortedArray() {
	    return [];
	  }
	  function insertSorted(array, insert, compare, allowDuplicates) {
	    if (array.length === 0) {
	      array.push(insert);
	      return true;
	    }
	    const insertIndex = binarySearch(array, insert, identity, compare);
	    if (insertIndex < 0) {
	      array.splice(~insertIndex, 0, insert);
	      return true;
	    }
	    if (allowDuplicates) {
	      array.splice(insertIndex, 0, insert);
	      return true;
	    }
	    return false;
	  }
	  function sortAndDeduplicate(array, comparer, equalityComparer) {
	    return deduplicateSorted(sort(array, comparer), equalityComparer || comparer || compareStringsCaseSensitive);
	  }
	  function arrayIsSorted(array, comparer) {
	    if (array.length < 2)
	      return true;
	    for (let i = 1, len = array.length; i < len; i++) {
	      if (comparer(array[i - 1], array[i]) === 1 /* GreaterThan */) {
	        return false;
	      }
	    }
	    return true;
	  }
	  function detectSortCaseSensitivity(array, getString, compareStringsCaseSensitive2, compareStringsCaseInsensitive2) {
	    let kind = 3 /* Both */;
	    if (array.length < 2)
	      return kind;
	    let prevElement = getString(array[0]);
	    for (let i = 1, len = array.length; i < len && kind !== 0 /* None */; i++) {
	      const element = getString(array[i]);
	      if (kind & 1 /* CaseSensitive */ && compareStringsCaseSensitive2(prevElement, element) > 0) {
	        kind &= ~1 /* CaseSensitive */;
	      }
	      if (kind & 2 /* CaseInsensitive */ && compareStringsCaseInsensitive2(prevElement, element) > 0) {
	        kind &= ~2 /* CaseInsensitive */;
	      }
	      prevElement = element;
	    }
	    return kind;
	  }
	  function arrayIsEqualTo(array1, array2, equalityComparer = equateValues) {
	    if (!array1 || !array2) {
	      return array1 === array2;
	    }
	    if (array1.length !== array2.length) {
	      return false;
	    }
	    for (let i = 0; i < array1.length; i++) {
	      if (!equalityComparer(array1[i], array2[i], i)) {
	        return false;
	      }
	    }
	    return true;
	  }
	  function compact(array) {
	    let result;
	    if (array) {
	      for (let i = 0; i < array.length; i++) {
	        const v = array[i];
	        if (result || !v) {
	          if (!result) {
	            result = array.slice(0, i);
	          }
	          if (v) {
	            result.push(v);
	          }
	        }
	      }
	    }
	    return result || array;
	  }
	  function relativeComplement(arrayA, arrayB, comparer) {
	    if (!arrayB || !arrayA || arrayB.length === 0 || arrayA.length === 0)
	      return arrayB;
	    const result = [];
	    loopB:
	      for (let offsetA = 0, offsetB = 0; offsetB < arrayB.length; offsetB++) {
	        if (offsetB > 0) {
	          Debug.assertGreaterThanOrEqual(comparer(arrayB[offsetB], arrayB[offsetB - 1]), 0 /* EqualTo */);
	        }
	        loopA:
	          for (const startA = offsetA; offsetA < arrayA.length; offsetA++) {
	            if (offsetA > startA) {
	              Debug.assertGreaterThanOrEqual(comparer(arrayA[offsetA], arrayA[offsetA - 1]), 0 /* EqualTo */);
	            }
	            switch (comparer(arrayB[offsetB], arrayA[offsetA])) {
	              case -1 /* LessThan */:
	                result.push(arrayB[offsetB]);
	                continue loopB;
	              case 0 /* EqualTo */:
	                continue loopB;
	              case 1 /* GreaterThan */:
	                continue loopA;
	            }
	          }
	      }
	    return result;
	  }
	  function append(to, value) {
	    if (value === void 0)
	      return to;
	    if (to === void 0)
	      return [value];
	    to.push(value);
	    return to;
	  }
	  function combine(xs, ys) {
	    if (xs === void 0)
	      return ys;
	    if (ys === void 0)
	      return xs;
	    if (isArray(xs))
	      return isArray(ys) ? concatenate(xs, ys) : append(xs, ys);
	    if (isArray(ys))
	      return append(ys, xs);
	    return [xs, ys];
	  }
	  function toOffset(array, offset) {
	    return offset < 0 ? array.length + offset : offset;
	  }
	  function addRange(to, from, start, end) {
	    if (from === void 0 || from.length === 0)
	      return to;
	    if (to === void 0)
	      return from.slice(start, end);
	    start = start === void 0 ? 0 : toOffset(from, start);
	    end = end === void 0 ? from.length : toOffset(from, end);
	    for (let i = start; i < end && i < from.length; i++) {
	      if (from[i] !== void 0) {
	        to.push(from[i]);
	      }
	    }
	    return to;
	  }
	  function pushIfUnique(array, toAdd, equalityComparer) {
	    if (contains(array, toAdd, equalityComparer)) {
	      return false;
	    } else {
	      array.push(toAdd);
	      return true;
	    }
	  }
	  function appendIfUnique(array, toAdd, equalityComparer) {
	    if (array) {
	      pushIfUnique(array, toAdd, equalityComparer);
	      return array;
	    } else {
	      return [toAdd];
	    }
	  }
	  function stableSortIndices(array, indices, comparer) {
	    indices.sort((x, y) => comparer(array[x], array[y]) || compareValues(x, y));
	  }
	  function sort(array, comparer) {
	    return array.length === 0 ? array : array.slice().sort(comparer);
	  }
	  function* arrayReverseIterator(array) {
	    for (let i = array.length - 1; i >= 0; i--) {
	      yield array[i];
	    }
	  }
	  function stableSort(array, comparer) {
	    const indices = indicesOf(array);
	    stableSortIndices(array, indices, comparer);
	    return indices.map((i) => array[i]);
	  }
	  function rangeEquals(array1, array2, pos, end) {
	    while (pos < end) {
	      if (array1[pos] !== array2[pos]) {
	        return false;
	      }
	      pos++;
	    }
	    return true;
	  }
	  function firstOrUndefined(array) {
	    return array === void 0 || array.length === 0 ? void 0 : array[0];
	  }
	  function firstOrUndefinedIterator(iter) {
	    if (iter) {
	      for (const value of iter) {
	        return value;
	      }
	    }
	    return void 0;
	  }
	  function first(array) {
	    Debug.assert(array.length !== 0);
	    return array[0];
	  }
	  function firstIterator(iter) {
	    for (const value of iter) {
	      return value;
	    }
	    Debug.fail("iterator is empty");
	  }
	  function lastOrUndefined(array) {
	    return array === void 0 || array.length === 0 ? void 0 : array[array.length - 1];
	  }
	  function last(array) {
	    Debug.assert(array.length !== 0);
	    return array[array.length - 1];
	  }
	  function singleOrUndefined(array) {
	    return array && array.length === 1 ? array[0] : void 0;
	  }
	  function single(array) {
	    return Debug.checkDefined(singleOrUndefined(array));
	  }
	  function singleOrMany(array) {
	    return array && array.length === 1 ? array[0] : array;
	  }
	  function replaceElement(array, index, value) {
	    const result = array.slice(0);
	    result[index] = value;
	    return result;
	  }
	  function binarySearch(array, value, keySelector, keyComparer, offset) {
	    return binarySearchKey(array, keySelector(value), keySelector, keyComparer, offset);
	  }
	  function binarySearchKey(array, key, keySelector, keyComparer, offset) {
	    if (!some(array)) {
	      return -1;
	    }
	    let low = offset || 0;
	    let high = array.length - 1;
	    while (low <= high) {
	      const middle = low + (high - low >> 1);
	      const midKey = keySelector(array[middle], middle);
	      switch (keyComparer(midKey, key)) {
	        case -1 /* LessThan */:
	          low = middle + 1;
	          break;
	        case 0 /* EqualTo */:
	          return middle;
	        case 1 /* GreaterThan */:
	          high = middle - 1;
	          break;
	      }
	    }
	    return ~low;
	  }
	  function reduceLeft(array, f, initial, start, count) {
	    if (array && array.length > 0) {
	      const size = array.length;
	      if (size > 0) {
	        let pos = start === void 0 || start < 0 ? 0 : start;
	        const end = count === void 0 || pos + count > size - 1 ? size - 1 : pos + count;
	        let result;
	        if (arguments.length <= 2) {
	          result = array[pos];
	          pos++;
	        } else {
	          result = initial;
	        }
	        while (pos <= end) {
	          result = f(result, array[pos], pos);
	          pos++;
	        }
	        return result;
	      }
	    }
	    return initial;
	  }
	  function hasProperty(map2, key) {
	    return hasOwnProperty.call(map2, key);
	  }
	  function getProperty(map2, key) {
	    return hasOwnProperty.call(map2, key) ? map2[key] : void 0;
	  }
	  function getOwnKeys(map2) {
	    const keys = [];
	    for (const key in map2) {
	      if (hasOwnProperty.call(map2, key)) {
	        keys.push(key);
	      }
	    }
	    return keys;
	  }
	  function getAllKeys(obj) {
	    const result = [];
	    do {
	      const names = Object.getOwnPropertyNames(obj);
	      for (const name of names) {
	        pushIfUnique(result, name);
	      }
	    } while (obj = Object.getPrototypeOf(obj));
	    return result;
	  }
	  function getOwnValues(collection) {
	    const values = [];
	    for (const key in collection) {
	      if (hasOwnProperty.call(collection, key)) {
	        values.push(collection[key]);
	      }
	    }
	    return values;
	  }
	  function arrayOf(count, f) {
	    const result = new Array(count);
	    for (let i = 0; i < count; i++) {
	      result[i] = f(i);
	    }
	    return result;
	  }
	  function arrayFrom(iterator, map2) {
	    const result = [];
	    for (const value of iterator) {
	      result.push(map2 ? map2(value) : value);
	    }
	    return result;
	  }
	  function assign(t, ...args) {
	    for (const arg of args) {
	      if (arg === void 0)
	        continue;
	      for (const p in arg) {
	        if (hasProperty(arg, p)) {
	          t[p] = arg[p];
	        }
	      }
	    }
	    return t;
	  }
	  function equalOwnProperties(left, right, equalityComparer = equateValues) {
	    if (left === right)
	      return true;
	    if (!left || !right)
	      return false;
	    for (const key in left) {
	      if (hasOwnProperty.call(left, key)) {
	        if (!hasOwnProperty.call(right, key))
	          return false;
	        if (!equalityComparer(left[key], right[key]))
	          return false;
	      }
	    }
	    for (const key in right) {
	      if (hasOwnProperty.call(right, key)) {
	        if (!hasOwnProperty.call(left, key))
	          return false;
	      }
	    }
	    return true;
	  }
	  function arrayToMap(array, makeKey, makeValue = identity) {
	    const result = /* @__PURE__ */ new Map();
	    for (const value of array) {
	      const key = makeKey(value);
	      if (key !== void 0)
	        result.set(key, makeValue(value));
	    }
	    return result;
	  }
	  function arrayToNumericMap(array, makeKey, makeValue = identity) {
	    const result = [];
	    for (const value of array) {
	      result[makeKey(value)] = makeValue(value);
	    }
	    return result;
	  }
	  function arrayToMultiMap(values, makeKey, makeValue = identity) {
	    const result = createMultiMap();
	    for (const value of values) {
	      result.add(makeKey(value), makeValue(value));
	    }
	    return result;
	  }
	  function group(values, getGroupId, resultSelector = identity) {
	    return arrayFrom(arrayToMultiMap(values, getGroupId).values(), resultSelector);
	  }
	  function groupBy(values, keySelector) {
	    const result = {};
	    if (values) {
	      for (const value of values) {
	        const key = `${keySelector(value)}`;
	        const array = result[key] ?? (result[key] = []);
	        array.push(value);
	      }
	    }
	    return result;
	  }
	  function clone(object) {
	    const result = {};
	    for (const id in object) {
	      if (hasOwnProperty.call(object, id)) {
	        result[id] = object[id];
	      }
	    }
	    return result;
	  }
	  function extend(first2, second) {
	    const result = {};
	    for (const id in second) {
	      if (hasOwnProperty.call(second, id)) {
	        result[id] = second[id];
	      }
	    }
	    for (const id in first2) {
	      if (hasOwnProperty.call(first2, id)) {
	        result[id] = first2[id];
	      }
	    }
	    return result;
	  }
	  function copyProperties(first2, second) {
	    for (const id in second) {
	      if (hasOwnProperty.call(second, id)) {
	        first2[id] = second[id];
	      }
	    }
	  }
	  function maybeBind(obj, fn) {
	    return fn ? fn.bind(obj) : void 0;
	  }
	  function createMultiMap() {
	    const map2 = /* @__PURE__ */ new Map();
	    map2.add = multiMapAdd;
	    map2.remove = multiMapRemove;
	    return map2;
	  }
	  function multiMapAdd(key, value) {
	    let values = this.get(key);
	    if (values) {
	      values.push(value);
	    } else {
	      this.set(key, values = [value]);
	    }
	    return values;
	  }
	  function multiMapRemove(key, value) {
	    const values = this.get(key);
	    if (values) {
	      unorderedRemoveItem(values, value);
	      if (!values.length) {
	        this.delete(key);
	      }
	    }
	  }
	  function createQueue(items) {
	    const elements = (items == null ? void 0 : items.slice()) || [];
	    let headIndex = 0;
	    function isEmpty() {
	      return headIndex === elements.length;
	    }
	    function enqueue(...items2) {
	      elements.push(...items2);
	    }
	    function dequeue() {
	      if (isEmpty()) {
	        throw new Error("Queue is empty");
	      }
	      const result = elements[headIndex];
	      elements[headIndex] = void 0;
	      headIndex++;
	      if (headIndex > 100 && headIndex > elements.length >> 1) {
	        const newLength = elements.length - headIndex;
	        elements.copyWithin(
	          /*target*/
	          0,
	          /*start*/
	          headIndex
	        );
	        elements.length = newLength;
	        headIndex = 0;
	      }
	      return result;
	    }
	    return {
	      enqueue,
	      dequeue,
	      isEmpty
	    };
	  }
	  function createSet(getHashCode, equals) {
	    const multiMap = /* @__PURE__ */ new Map();
	    let size = 0;
	    function* getElementIterator() {
	      for (const value of multiMap.values()) {
	        if (isArray(value)) {
	          yield* value;
	        } else {
	          yield value;
	        }
	      }
	    }
	    const set = {
	      has(element) {
	        const hash = getHashCode(element);
	        if (!multiMap.has(hash))
	          return false;
	        const candidates = multiMap.get(hash);
	        if (!isArray(candidates))
	          return equals(candidates, element);
	        for (const candidate of candidates) {
	          if (equals(candidate, element)) {
	            return true;
	          }
	        }
	        return false;
	      },
	      add(element) {
	        const hash = getHashCode(element);
	        if (multiMap.has(hash)) {
	          const values = multiMap.get(hash);
	          if (isArray(values)) {
	            if (!contains(values, element, equals)) {
	              values.push(element);
	              size++;
	            }
	          } else {
	            const value = values;
	            if (!equals(value, element)) {
	              multiMap.set(hash, [value, element]);
	              size++;
	            }
	          }
	        } else {
	          multiMap.set(hash, element);
	          size++;
	        }
	        return this;
	      },
	      delete(element) {
	        const hash = getHashCode(element);
	        if (!multiMap.has(hash))
	          return false;
	        const candidates = multiMap.get(hash);
	        if (isArray(candidates)) {
	          for (let i = 0; i < candidates.length; i++) {
	            if (equals(candidates[i], element)) {
	              if (candidates.length === 1) {
	                multiMap.delete(hash);
	              } else if (candidates.length === 2) {
	                multiMap.set(hash, candidates[1 - i]);
	              } else {
	                unorderedRemoveItemAt(candidates, i);
	              }
	              size--;
	              return true;
	            }
	          }
	        } else {
	          const candidate = candidates;
	          if (equals(candidate, element)) {
	            multiMap.delete(hash);
	            size--;
	            return true;
	          }
	        }
	        return false;
	      },
	      clear() {
	        multiMap.clear();
	        size = 0;
	      },
	      get size() {
	        return size;
	      },
	      forEach(action) {
	        for (const elements of arrayFrom(multiMap.values())) {
	          if (isArray(elements)) {
	            for (const element of elements) {
	              action(element, element, set);
	            }
	          } else {
	            const element = elements;
	            action(element, element, set);
	          }
	        }
	      },
	      keys() {
	        return getElementIterator();
	      },
	      values() {
	        return getElementIterator();
	      },
	      *entries() {
	        for (const value of getElementIterator()) {
	          yield [value, value];
	        }
	      },
	      [Symbol.iterator]: () => {
	        return getElementIterator();
	      },
	      [Symbol.toStringTag]: multiMap[Symbol.toStringTag]
	    };
	    return set;
	  }
	  function isArray(value) {
	    return Array.isArray(value);
	  }
	  function toArray(value) {
	    return isArray(value) ? value : [value];
	  }
	  function isString(text) {
	    return typeof text === "string";
	  }
	  function isNumber(x) {
	    return typeof x === "number";
	  }
	  function tryCast(value, test) {
	    return value !== void 0 && test(value) ? value : void 0;
	  }
	  function cast(value, test) {
	    if (value !== void 0 && test(value))
	      return value;
	    return Debug.fail(`Invalid cast. The supplied value ${value} did not pass the test '${Debug.getFunctionName(test)}'.`);
	  }
	  function noop(_) {
	  }
	  function returnFalse() {
	    return false;
	  }
	  function returnTrue() {
	    return true;
	  }
	  function returnUndefined() {
	    return void 0;
	  }
	  function identity(x) {
	    return x;
	  }
	  function toLowerCase(x) {
	    return x.toLowerCase();
	  }
	  function toFileNameLowerCase(x) {
	    return fileNameLowerCaseRegExp.test(x) ? x.replace(fileNameLowerCaseRegExp, toLowerCase) : x;
	  }
	  function notImplemented() {
	    throw new Error("Not implemented");
	  }
	  function memoize(callback) {
	    let value;
	    return () => {
	      if (callback) {
	        value = callback();
	        callback = void 0;
	      }
	      return value;
	    };
	  }
	  function memoizeOne(callback) {
	    const map2 = /* @__PURE__ */ new Map();
	    return (arg) => {
	      const key = `${typeof arg}:${arg}`;
	      let value = map2.get(key);
	      if (value === void 0 && !map2.has(key)) {
	        value = callback(arg);
	        map2.set(key, value);
	      }
	      return value;
	    };
	  }
	  function memoizeWeak(callback) {
	    const map2 = /* @__PURE__ */ new WeakMap();
	    return (arg) => {
	      let value = map2.get(arg);
	      if (value === void 0 && !map2.has(arg)) {
	        value = callback(arg);
	        map2.set(arg, value);
	      }
	      return value;
	    };
	  }
	  function memoizeCached(callback, cache) {
	    return (...args) => {
	      let value = cache.get(args);
	      if (value === void 0 && !cache.has(args)) {
	        value = callback(...args);
	        cache.set(args, value);
	      }
	      return value;
	    };
	  }
	  function compose(a, b, c, d, e) {
	    if (!!e) {
	      const args = [];
	      for (let i = 0; i < arguments.length; i++) {
	        args[i] = arguments[i];
	      }
	      return (t) => reduceLeft(args, (u, f) => f(u), t);
	    } else if (d) {
	      return (t) => d(c(b(a(t))));
	    } else if (c) {
	      return (t) => c(b(a(t)));
	    } else if (b) {
	      return (t) => b(a(t));
	    } else if (a) {
	      return (t) => a(t);
	    } else {
	      return (t) => t;
	    }
	  }
	  function equateValues(a, b) {
	    return a === b;
	  }
	  function equateStringsCaseInsensitive(a, b) {
	    return a === b || a !== void 0 && b !== void 0 && a.toUpperCase() === b.toUpperCase();
	  }
	  function equateStringsCaseSensitive(a, b) {
	    return equateValues(a, b);
	  }
	  function compareComparableValues(a, b) {
	    return a === b ? 0 /* EqualTo */ : a === void 0 ? -1 /* LessThan */ : b === void 0 ? 1 /* GreaterThan */ : a < b ? -1 /* LessThan */ : 1 /* GreaterThan */;
	  }
	  function compareValues(a, b) {
	    return compareComparableValues(a, b);
	  }
	  function compareTextSpans(a, b) {
	    return compareValues(a == null ? void 0 : a.start, b == null ? void 0 : b.start) || compareValues(a == null ? void 0 : a.length, b == null ? void 0 : b.length);
	  }
	  function min(items, compare) {
	    return reduceLeft(items, (x, y) => compare(x, y) === -1 /* LessThan */ ? x : y);
	  }
	  function compareStringsCaseInsensitive(a, b) {
	    if (a === b)
	      return 0 /* EqualTo */;
	    if (a === void 0)
	      return -1 /* LessThan */;
	    if (b === void 0)
	      return 1 /* GreaterThan */;
	    a = a.toUpperCase();
	    b = b.toUpperCase();
	    return a < b ? -1 /* LessThan */ : a > b ? 1 /* GreaterThan */ : 0 /* EqualTo */;
	  }
	  function compareStringsCaseInsensitiveEslintCompatible(a, b) {
	    if (a === b)
	      return 0 /* EqualTo */;
	    if (a === void 0)
	      return -1 /* LessThan */;
	    if (b === void 0)
	      return 1 /* GreaterThan */;
	    a = a.toLowerCase();
	    b = b.toLowerCase();
	    return a < b ? -1 /* LessThan */ : a > b ? 1 /* GreaterThan */ : 0 /* EqualTo */;
	  }
	  function compareStringsCaseSensitive(a, b) {
	    return compareComparableValues(a, b);
	  }
	  function getStringComparer(ignoreCase) {
	    return ignoreCase ? compareStringsCaseInsensitive : compareStringsCaseSensitive;
	  }
	  function getUILocale() {
	    return uiLocale;
	  }
	  function setUILocale(value) {
	    if (uiLocale !== value) {
	      uiLocale = value;
	      uiComparerCaseSensitive = void 0;
	    }
	  }
	  function compareStringsCaseSensitiveUI(a, b) {
	    const comparer = uiComparerCaseSensitive || (uiComparerCaseSensitive = createUIStringComparer(uiLocale));
	    return comparer(a, b);
	  }
	  function compareProperties(a, b, key, comparer) {
	    return a === b ? 0 /* EqualTo */ : a === void 0 ? -1 /* LessThan */ : b === void 0 ? 1 /* GreaterThan */ : comparer(a[key], b[key]);
	  }
	  function compareBooleans(a, b) {
	    return compareValues(a ? 1 : 0, b ? 1 : 0);
	  }
	  function getSpellingSuggestion(name, candidates, getName) {
	    const maximumLengthDifference = Math.max(2, Math.floor(name.length * 0.34));
	    let bestDistance = Math.floor(name.length * 0.4) + 1;
	    let bestCandidate;
	    for (const candidate of candidates) {
	      const candidateName = getName(candidate);
	      if (candidateName !== void 0 && Math.abs(candidateName.length - name.length) <= maximumLengthDifference) {
	        if (candidateName === name) {
	          continue;
	        }
	        if (candidateName.length < 3 && candidateName.toLowerCase() !== name.toLowerCase()) {
	          continue;
	        }
	        const distance = levenshteinWithMax(name, candidateName, bestDistance - 0.1);
	        if (distance === void 0) {
	          continue;
	        }
	        Debug.assert(distance < bestDistance);
	        bestDistance = distance;
	        bestCandidate = candidate;
	      }
	    }
	    return bestCandidate;
	  }
	  function levenshteinWithMax(s1, s2, max) {
	    let previous = new Array(s2.length + 1);
	    let current = new Array(s2.length + 1);
	    const big = max + 0.01;
	    for (let i = 0; i <= s2.length; i++) {
	      previous[i] = i;
	    }
	    for (let i = 1; i <= s1.length; i++) {
	      const c1 = s1.charCodeAt(i - 1);
	      const minJ = Math.ceil(i > max ? i - max : 1);
	      const maxJ = Math.floor(s2.length > max + i ? max + i : s2.length);
	      current[0] = i;
	      let colMin = i;
	      for (let j = 1; j < minJ; j++) {
	        current[j] = big;
	      }
	      for (let j = minJ; j <= maxJ; j++) {
	        const substitutionDistance = s1[i - 1].toLowerCase() === s2[j - 1].toLowerCase() ? previous[j - 1] + 0.1 : previous[j - 1] + 2;
	        const dist = c1 === s2.charCodeAt(j - 1) ? previous[j - 1] : Math.min(
	          /*delete*/
	          previous[j] + 1,
	          /*insert*/
	          current[j - 1] + 1,
	          /*substitute*/
	          substitutionDistance
	        );
	        current[j] = dist;
	        colMin = Math.min(colMin, dist);
	      }
	      for (let j = maxJ + 1; j <= s2.length; j++) {
	        current[j] = big;
	      }
	      if (colMin > max) {
	        return void 0;
	      }
	      const temp = previous;
	      previous = current;
	      current = temp;
	    }
	    const res = previous[s2.length];
	    return res > max ? void 0 : res;
	  }
	  function endsWith(str, suffix, ignoreCase) {
	    const expectedPos = str.length - suffix.length;
	    return expectedPos >= 0 && (ignoreCase ? equateStringsCaseInsensitive(str.slice(expectedPos), suffix) : str.indexOf(suffix, expectedPos) === expectedPos);
	  }
	  function removeSuffix(str, suffix) {
	    return endsWith(str, suffix) ? str.slice(0, str.length - suffix.length) : str;
	  }
	  function tryRemoveSuffix(str, suffix) {
	    return endsWith(str, suffix) ? str.slice(0, str.length - suffix.length) : void 0;
	  }
	  function removeMinAndVersionNumbers(fileName) {
	    let end = fileName.length;
	    for (let pos = end - 1; pos > 0; pos--) {
	      let ch = fileName.charCodeAt(pos);
	      if (ch >= 48 /* _0 */ && ch <= 57 /* _9 */) {
	        do {
	          --pos;
	          ch = fileName.charCodeAt(pos);
	        } while (pos > 0 && ch >= 48 /* _0 */ && ch <= 57 /* _9 */);
	      } else if (pos > 4 && (ch === 110 /* n */ || ch === 78 /* N */)) {
	        --pos;
	        ch = fileName.charCodeAt(pos);
	        if (ch !== 105 /* i */ && ch !== 73 /* I */) {
	          break;
	        }
	        --pos;
	        ch = fileName.charCodeAt(pos);
	        if (ch !== 109 /* m */ && ch !== 77 /* M */) {
	          break;
	        }
	        --pos;
	        ch = fileName.charCodeAt(pos);
	      } else {
	        break;
	      }
	      if (ch !== 45 /* minus */ && ch !== 46 /* dot */) {
	        break;
	      }
	      end = pos;
	    }
	    return end === fileName.length ? fileName : fileName.slice(0, end);
	  }
	  function orderedRemoveItem(array, item) {
	    for (let i = 0; i < array.length; i++) {
	      if (array[i] === item) {
	        orderedRemoveItemAt(array, i);
	        return true;
	      }
	    }
	    return false;
	  }
	  function orderedRemoveItemAt(array, index) {
	    for (let i = index; i < array.length - 1; i++) {
	      array[i] = array[i + 1];
	    }
	    array.pop();
	  }
	  function unorderedRemoveItemAt(array, index) {
	    array[index] = array[array.length - 1];
	    array.pop();
	  }
	  function unorderedRemoveItem(array, item) {
	    return unorderedRemoveFirstItemWhere(array, (element) => element === item);
	  }
	  function unorderedRemoveFirstItemWhere(array, predicate) {
	    for (let i = 0; i < array.length; i++) {
	      if (predicate(array[i])) {
	        unorderedRemoveItemAt(array, i);
	        return true;
	      }
	    }
	    return false;
	  }
	  function createGetCanonicalFileName(useCaseSensitiveFileNames2) {
	    return useCaseSensitiveFileNames2 ? identity : toFileNameLowerCase;
	  }
	  function patternText({ prefix, suffix }) {
	    return `${prefix}*${suffix}`;
	  }
	  function matchedText(pattern, candidate) {
	    Debug.assert(isPatternMatch(pattern, candidate));
	    return candidate.substring(pattern.prefix.length, candidate.length - pattern.suffix.length);
	  }
	  function findBestPatternMatch(values, getPattern, candidate) {
	    let matchedValue;
	    let longestMatchPrefixLength = -1;
	    for (const v of values) {
	      const pattern = getPattern(v);
	      if (isPatternMatch(pattern, candidate) && pattern.prefix.length > longestMatchPrefixLength) {
	        longestMatchPrefixLength = pattern.prefix.length;
	        matchedValue = v;
	      }
	    }
	    return matchedValue;
	  }
	  function startsWith(str, prefix, ignoreCase) {
	    return ignoreCase ? equateStringsCaseInsensitive(str.slice(0, prefix.length), prefix) : str.lastIndexOf(prefix, 0) === 0;
	  }
	  function removePrefix(str, prefix) {
	    return startsWith(str, prefix) ? str.substr(prefix.length) : str;
	  }
	  function tryRemovePrefix(str, prefix, getCanonicalFileName = identity) {
	    return startsWith(getCanonicalFileName(str), getCanonicalFileName(prefix)) ? str.substring(prefix.length) : void 0;
	  }
	  function isPatternMatch({ prefix, suffix }, candidate) {
	    return candidate.length >= prefix.length + suffix.length && startsWith(candidate, prefix) && endsWith(candidate, suffix);
	  }
	  function and(f, g) {
	    return (arg) => f(arg) && g(arg);
	  }
	  function or(...fs) {
	    return (...args) => {
	      let lastResult;
	      for (const f of fs) {
	        lastResult = f(...args);
	        if (lastResult) {
	          return lastResult;
	        }
	      }
	      return lastResult;
	    };
	  }
	  function not(fn) {
	    return (...args) => !fn(...args);
	  }
	  function assertType(_) {
	  }
	  function singleElementArray(t) {
	    return t === void 0 ? void 0 : [t];
	  }
	  function enumerateInsertsAndDeletes(newItems, oldItems, comparer, inserted, deleted, unchanged) {
	    unchanged = unchanged || noop;
	    let newIndex = 0;
	    let oldIndex = 0;
	    const newLen = newItems.length;
	    const oldLen = oldItems.length;
	    let hasChanges = false;
	    while (newIndex < newLen && oldIndex < oldLen) {
	      const newItem = newItems[newIndex];
	      const oldItem = oldItems[oldIndex];
	      const compareResult = comparer(newItem, oldItem);
	      if (compareResult === -1 /* LessThan */) {
	        inserted(newItem);
	        newIndex++;
	        hasChanges = true;
	      } else if (compareResult === 1 /* GreaterThan */) {
	        deleted(oldItem);
	        oldIndex++;
	        hasChanges = true;
	      } else {
	        unchanged(oldItem, newItem);
	        newIndex++;
	        oldIndex++;
	      }
	    }
	    while (newIndex < newLen) {
	      inserted(newItems[newIndex++]);
	      hasChanges = true;
	    }
	    while (oldIndex < oldLen) {
	      deleted(oldItems[oldIndex++]);
	      hasChanges = true;
	    }
	    return hasChanges;
	  }
	  function cartesianProduct(arrays) {
	    const result = [];
	    cartesianProductWorker(
	      arrays,
	      result,
	      /*outer*/
	      void 0,
	      0
	    );
	    return result;
	  }
	  function cartesianProductWorker(arrays, result, outer, index) {
	    for (const element of arrays[index]) {
	      let inner;
	      if (outer) {
	        inner = outer.slice();
	        inner.push(element);
	      } else {
	        inner = [element];
	      }
	      if (index === arrays.length - 1) {
	        result.push(inner);
	      } else {
	        cartesianProductWorker(arrays, result, inner, index + 1);
	      }
	    }
	  }
	  function takeWhile(array, predicate) {
	    if (array) {
	      const len = array.length;
	      let index = 0;
	      while (index < len && predicate(array[index])) {
	        index++;
	      }
	      return array.slice(0, index);
	    }
	  }
	  function skipWhile(array, predicate) {
	    if (array) {
	      const len = array.length;
	      let index = 0;
	      while (index < len && predicate(array[index])) {
	        index++;
	      }
	      return array.slice(index);
	    }
	  }
	  function isNodeLikeSystem() {
	    return typeof process !== "undefined" && !!process.nextTick && !process.browser && 'object' === "object";
	  }
	  var emptyArray, emptyMap, emptySet, SortKind, elementAt, hasOwnProperty, fileNameLowerCaseRegExp, AssertionLevel, createUIStringComparer, uiComparerCaseSensitive, uiLocale;
	  var init_core = __esm({
	    "src/compiler/core.ts"() {
	      init_ts2();
	      emptyArray = [];
	      emptyMap = /* @__PURE__ */ new Map();
	      emptySet = /* @__PURE__ */ new Set();
	      SortKind = /* @__PURE__ */ ((SortKind2) => {
	        SortKind2[SortKind2["None"] = 0] = "None";
	        SortKind2[SortKind2["CaseSensitive"] = 1] = "CaseSensitive";
	        SortKind2[SortKind2["CaseInsensitive"] = 2] = "CaseInsensitive";
	        SortKind2[SortKind2["Both"] = 3] = "Both";
	        return SortKind2;
	      })(SortKind || {});
	      elementAt = !!Array.prototype.at ? (array, offset) => array == null ? void 0 : array.at(offset) : (array, offset) => {
	        if (array) {
	          offset = toOffset(array, offset);
	          if (offset < array.length) {
	            return array[offset];
	          }
	        }
	        return void 0;
	      };
	      hasOwnProperty = Object.prototype.hasOwnProperty;
	      fileNameLowerCaseRegExp = /[^\u0130\u0131\u00DFa-z0-9\\/:\-_. ]+/g;
	      AssertionLevel = /* @__PURE__ */ ((AssertionLevel2) => {
	        AssertionLevel2[AssertionLevel2["None"] = 0] = "None";
	        AssertionLevel2[AssertionLevel2["Normal"] = 1] = "Normal";
	        AssertionLevel2[AssertionLevel2["Aggressive"] = 2] = "Aggressive";
	        AssertionLevel2[AssertionLevel2["VeryAggressive"] = 3] = "VeryAggressive";
	        return AssertionLevel2;
	      })(AssertionLevel || {});
	      createUIStringComparer = /* @__PURE__ */ (() => {
	        return createIntlCollatorStringComparer;
	        function compareWithCallback(a, b, comparer) {
	          if (a === b)
	            return 0 /* EqualTo */;
	          if (a === void 0)
	            return -1 /* LessThan */;
	          if (b === void 0)
	            return 1 /* GreaterThan */;
	          const value = comparer(a, b);
	          return value < 0 ? -1 /* LessThan */ : value > 0 ? 1 /* GreaterThan */ : 0 /* EqualTo */;
	        }
	        function createIntlCollatorStringComparer(locale) {
	          const comparer = new Intl.Collator(locale, { usage: "sort", sensitivity: "variant" }).compare;
	          return (a, b) => compareWithCallback(a, b, comparer);
	        }
	      })();
	    }
	  });

	  // src/compiler/debug.ts
	  var LogLevel, Debug;
	  var init_debug = __esm({
	    "src/compiler/debug.ts"() {
	      init_ts2();
	      init_ts2();
	      LogLevel = /* @__PURE__ */ ((LogLevel3) => {
	        LogLevel3[LogLevel3["Off"] = 0] = "Off";
	        LogLevel3[LogLevel3["Error"] = 1] = "Error";
	        LogLevel3[LogLevel3["Warning"] = 2] = "Warning";
	        LogLevel3[LogLevel3["Info"] = 3] = "Info";
	        LogLevel3[LogLevel3["Verbose"] = 4] = "Verbose";
	        return LogLevel3;
	      })(LogLevel || {});
	      ((Debug2) => {
	        let currentAssertionLevel = 0 /* None */;
	        Debug2.currentLogLevel = 2 /* Warning */;
	        Debug2.isDebugging = false;
	        function shouldLog(level) {
	          return Debug2.currentLogLevel <= level;
	        }
	        Debug2.shouldLog = shouldLog;
	        function logMessage(level, s) {
	          if (Debug2.loggingHost && shouldLog(level)) {
	            Debug2.loggingHost.log(level, s);
	          }
	        }
	        function log(s) {
	          logMessage(3 /* Info */, s);
	        }
	        Debug2.log = log;
	        ((_log) => {
	          function error2(s) {
	            logMessage(1 /* Error */, s);
	          }
	          _log.error = error2;
	          function warn(s) {
	            logMessage(2 /* Warning */, s);
	          }
	          _log.warn = warn;
	          function log2(s) {
	            logMessage(3 /* Info */, s);
	          }
	          _log.log = log2;
	          function trace2(s) {
	            logMessage(4 /* Verbose */, s);
	          }
	          _log.trace = trace2;
	        })(log = Debug2.log || (Debug2.log = {}));
	        const assertionCache = {};
	        function getAssertionLevel() {
	          return currentAssertionLevel;
	        }
	        Debug2.getAssertionLevel = getAssertionLevel;
	        function setAssertionLevel(level) {
	          const prevAssertionLevel = currentAssertionLevel;
	          currentAssertionLevel = level;
	          if (level > prevAssertionLevel) {
	            for (const key of getOwnKeys(assertionCache)) {
	              const cachedFunc = assertionCache[key];
	              if (cachedFunc !== void 0 && Debug2[key] !== cachedFunc.assertion && level >= cachedFunc.level) {
	                Debug2[key] = cachedFunc;
	                assertionCache[key] = void 0;
	              }
	            }
	          }
	        }
	        Debug2.setAssertionLevel = setAssertionLevel;
	        function shouldAssert(level) {
	          return currentAssertionLevel >= level;
	        }
	        Debug2.shouldAssert = shouldAssert;
	        function shouldAssertFunction(level, name) {
	          if (!shouldAssert(level)) {
	            assertionCache[name] = { level, assertion: Debug2[name] };
	            Debug2[name] = noop;
	            return false;
	          }
	          return true;
	        }
	        function fail(message, stackCrawlMark) {
	          debugger;
	          const e = new Error(message ? `Debug Failure. ${message}` : "Debug Failure.");
	          if (Error.captureStackTrace) {
	            Error.captureStackTrace(e, stackCrawlMark || fail);
	          }
	          throw e;
	        }
	        Debug2.fail = fail;
	        function failBadSyntaxKind(node, message, stackCrawlMark) {
	          return fail(
	            `${message || "Unexpected node."}\r
Node ${formatSyntaxKind(node.kind)} was unexpected.`,
	            stackCrawlMark || failBadSyntaxKind
	          );
	        }
	        Debug2.failBadSyntaxKind = failBadSyntaxKind;
	        function assert(expression, message, verboseDebugInfo, stackCrawlMark) {
	          if (!expression) {
	            message = message ? `False expression: ${message}` : "False expression.";
	            if (verboseDebugInfo) {
	              message += "\r\nVerbose Debug Information: " + (typeof verboseDebugInfo === "string" ? verboseDebugInfo : verboseDebugInfo());
	            }
	            fail(message, stackCrawlMark || assert);
	          }
	        }
	        Debug2.assert = assert;
	        function assertEqual(a, b, msg, msg2, stackCrawlMark) {
	          if (a !== b) {
	            const message = msg ? msg2 ? `${msg} ${msg2}` : msg : "";
	            fail(`Expected ${a} === ${b}. ${message}`, stackCrawlMark || assertEqual);
	          }
	        }
	        Debug2.assertEqual = assertEqual;
	        function assertLessThan(a, b, msg, stackCrawlMark) {
	          if (a >= b) {
	            fail(`Expected ${a} < ${b}. ${msg || ""}`, stackCrawlMark || assertLessThan);
	          }
	        }
	        Debug2.assertLessThan = assertLessThan;
	        function assertLessThanOrEqual(a, b, stackCrawlMark) {
	          if (a > b) {
	            fail(`Expected ${a} <= ${b}`, stackCrawlMark || assertLessThanOrEqual);
	          }
	        }
	        Debug2.assertLessThanOrEqual = assertLessThanOrEqual;
	        function assertGreaterThanOrEqual(a, b, stackCrawlMark) {
	          if (a < b) {
	            fail(`Expected ${a} >= ${b}`, stackCrawlMark || assertGreaterThanOrEqual);
	          }
	        }
	        Debug2.assertGreaterThanOrEqual = assertGreaterThanOrEqual;
	        function assertIsDefined(value, message, stackCrawlMark) {
	          if (value === void 0 || value === null) {
	            fail(message, stackCrawlMark || assertIsDefined);
	          }
	        }
	        Debug2.assertIsDefined = assertIsDefined;
	        function checkDefined(value, message, stackCrawlMark) {
	          assertIsDefined(value, message, stackCrawlMark || checkDefined);
	          return value;
	        }
	        Debug2.checkDefined = checkDefined;
	        function assertEachIsDefined(value, message, stackCrawlMark) {
	          for (const v of value) {
	            assertIsDefined(v, message, stackCrawlMark || assertEachIsDefined);
	          }
	        }
	        Debug2.assertEachIsDefined = assertEachIsDefined;
	        function checkEachDefined(value, message, stackCrawlMark) {
	          assertEachIsDefined(value, message, stackCrawlMark || checkEachDefined);
	          return value;
	        }
	        Debug2.checkEachDefined = checkEachDefined;
	        function assertNever(member, message = "Illegal value:", stackCrawlMark) {
	          const detail = typeof member === "object" && hasProperty(member, "kind") && hasProperty(member, "pos") ? "SyntaxKind: " + formatSyntaxKind(member.kind) : JSON.stringify(member);
	          return fail(`${message} ${detail}`, stackCrawlMark || assertNever);
	        }
	        Debug2.assertNever = assertNever;
	        function assertEachNode(nodes, test, message, stackCrawlMark) {
	          if (shouldAssertFunction(1 /* Normal */, "assertEachNode")) {
	            assert(
	              test === void 0 || every(nodes, test),
	              message || "Unexpected node.",
	              () => `Node array did not pass test '${getFunctionName(test)}'.`,
	              stackCrawlMark || assertEachNode
	            );
	          }
	        }
	        Debug2.assertEachNode = assertEachNode;
	        function assertNode(node, test, message, stackCrawlMark) {
	          if (shouldAssertFunction(1 /* Normal */, "assertNode")) {
	            assert(
	              node !== void 0 && (test === void 0 || test(node)),
	              message || "Unexpected node.",
	              () => `Node ${formatSyntaxKind(node == null ? void 0 : node.kind)} did not pass test '${getFunctionName(test)}'.`,
	              stackCrawlMark || assertNode
	            );
	          }
	        }
	        Debug2.assertNode = assertNode;
	        function assertNotNode(node, test, message, stackCrawlMark) {
	          if (shouldAssertFunction(1 /* Normal */, "assertNotNode")) {
	            assert(
	              node === void 0 || test === void 0 || !test(node),
	              message || "Unexpected node.",
	              () => `Node ${formatSyntaxKind(node.kind)} should not have passed test '${getFunctionName(test)}'.`,
	              stackCrawlMark || assertNotNode
	            );
	          }
	        }
	        Debug2.assertNotNode = assertNotNode;
	        function assertOptionalNode(node, test, message, stackCrawlMark) {
	          if (shouldAssertFunction(1 /* Normal */, "assertOptionalNode")) {
	            assert(
	              test === void 0 || node === void 0 || test(node),
	              message || "Unexpected node.",
	              () => `Node ${formatSyntaxKind(node == null ? void 0 : node.kind)} did not pass test '${getFunctionName(test)}'.`,
	              stackCrawlMark || assertOptionalNode
	            );
	          }
	        }
	        Debug2.assertOptionalNode = assertOptionalNode;
	        function assertOptionalToken(node, kind, message, stackCrawlMark) {
	          if (shouldAssertFunction(1 /* Normal */, "assertOptionalToken")) {
	            assert(
	              kind === void 0 || node === void 0 || node.kind === kind,
	              message || "Unexpected node.",
	              () => `Node ${formatSyntaxKind(node == null ? void 0 : node.kind)} was not a '${formatSyntaxKind(kind)}' token.`,
	              stackCrawlMark || assertOptionalToken
	            );
	          }
	        }
	        Debug2.assertOptionalToken = assertOptionalToken;
	        function assertMissingNode(node, message, stackCrawlMark) {
	          if (shouldAssertFunction(1 /* Normal */, "assertMissingNode")) {
	            assert(
	              node === void 0,
	              message || "Unexpected node.",
	              () => `Node ${formatSyntaxKind(node.kind)} was unexpected'.`,
	              stackCrawlMark || assertMissingNode
	            );
	          }
	        }
	        Debug2.assertMissingNode = assertMissingNode;
	        function type(_value) {
	        }
	        Debug2.type = type;
	        function getFunctionName(func) {
	          if (typeof func !== "function") {
	            return "";
	          } else if (hasProperty(func, "name")) {
	            return func.name;
	          } else {
	            const text = Function.prototype.toString.call(func);
	            const match = /^function\s+([\w$]+)\s*\(/.exec(text);
	            return match ? match[1] : "";
	          }
	        }
	        Debug2.getFunctionName = getFunctionName;
	        function formatSymbol(symbol) {
	          return `{ name: ${unescapeLeadingUnderscores(symbol.escapedName)}; flags: ${formatSymbolFlags(symbol.flags)}; declarations: ${map(symbol.declarations, (node) => formatSyntaxKind(node.kind))} }`;
	        }
	        Debug2.formatSymbol = formatSymbol;
	        function formatEnum(value = 0, enumObject, isFlags) {
	          const members = getEnumMembers(enumObject);
	          if (value === 0) {
	            return members.length > 0 && members[0][0] === 0 ? members[0][1] : "0";
	          }
	          if (isFlags) {
	            const result = [];
	            let remainingFlags = value;
	            for (const [enumValue, enumName] of members) {
	              if (enumValue > value) {
	                break;
	              }
	              if (enumValue !== 0 && enumValue & value) {
	                result.push(enumName);
	                remainingFlags &= ~enumValue;
	              }
	            }
	            if (remainingFlags === 0) {
	              return result.join("|");
	            }
	          } else {
	            for (const [enumValue, enumName] of members) {
	              if (enumValue === value) {
	                return enumName;
	              }
	            }
	          }
	          return value.toString();
	        }
	        Debug2.formatEnum = formatEnum;
	        const enumMemberCache = /* @__PURE__ */ new Map();
	        function getEnumMembers(enumObject) {
	          const existing = enumMemberCache.get(enumObject);
	          if (existing) {
	            return existing;
	          }
	          const result = [];
	          for (const name in enumObject) {
	            const value = enumObject[name];
	            if (typeof value === "number") {
	              result.push([value, name]);
	            }
	          }
	          const sorted = stableSort(result, (x, y) => compareValues(x[0], y[0]));
	          enumMemberCache.set(enumObject, sorted);
	          return sorted;
	        }
	        function formatSyntaxKind(kind) {
	          return formatEnum(
	            kind,
	            SyntaxKind,
	            /*isFlags*/
	            false
	          );
	        }
	        Debug2.formatSyntaxKind = formatSyntaxKind;
	        function formatSnippetKind(kind) {
	          return formatEnum(
	            kind,
	            SnippetKind,
	            /*isFlags*/
	            false
	          );
	        }
	        Debug2.formatSnippetKind = formatSnippetKind;
	        function formatScriptKind(kind) {
	          return formatEnum(
	            kind,
	            ScriptKind,
	            /*isFlags*/
	            false
	          );
	        }
	        Debug2.formatScriptKind = formatScriptKind;
	        function formatNodeFlags(flags) {
	          return formatEnum(
	            flags,
	            NodeFlags,
	            /*isFlags*/
	            true
	          );
	        }
	        Debug2.formatNodeFlags = formatNodeFlags;
	        function formatModifierFlags(flags) {
	          return formatEnum(
	            flags,
	            ModifierFlags,
	            /*isFlags*/
	            true
	          );
	        }
	        Debug2.formatModifierFlags = formatModifierFlags;
	        function formatTransformFlags(flags) {
	          return formatEnum(
	            flags,
	            TransformFlags,
	            /*isFlags*/
	            true
	          );
	        }
	        Debug2.formatTransformFlags = formatTransformFlags;
	        function formatEmitFlags(flags) {
	          return formatEnum(
	            flags,
	            EmitFlags,
	            /*isFlags*/
	            true
	          );
	        }
	        Debug2.formatEmitFlags = formatEmitFlags;
	        function formatSymbolFlags(flags) {
	          return formatEnum(
	            flags,
	            SymbolFlags,
	            /*isFlags*/
	            true
	          );
	        }
	        Debug2.formatSymbolFlags = formatSymbolFlags;
	        function formatTypeFlags(flags) {
	          return formatEnum(
	            flags,
	            TypeFlags,
	            /*isFlags*/
	            true
	          );
	        }
	        Debug2.formatTypeFlags = formatTypeFlags;
	        function formatSignatureFlags(flags) {
	          return formatEnum(
	            flags,
	            SignatureFlags,
	            /*isFlags*/
	            true
	          );
	        }
	        Debug2.formatSignatureFlags = formatSignatureFlags;
	        function formatObjectFlags(flags) {
	          return formatEnum(
	            flags,
	            ObjectFlags,
	            /*isFlags*/
	            true
	          );
	        }
	        Debug2.formatObjectFlags = formatObjectFlags;
	        function formatFlowFlags(flags) {
	          return formatEnum(
	            flags,
	            FlowFlags,
	            /*isFlags*/
	            true
	          );
	        }
	        Debug2.formatFlowFlags = formatFlowFlags;
	        function formatRelationComparisonResult(result) {
	          return formatEnum(
	            result,
	            RelationComparisonResult,
	            /*isFlags*/
	            true
	          );
	        }
	        Debug2.formatRelationComparisonResult = formatRelationComparisonResult;
	        function formatCheckMode(mode) {
	          return formatEnum(
	            mode,
	            CheckMode,
	            /*isFlags*/
	            true
	          );
	        }
	        Debug2.formatCheckMode = formatCheckMode;
	        function formatSignatureCheckMode(mode) {
	          return formatEnum(
	            mode,
	            SignatureCheckMode,
	            /*isFlags*/
	            true
	          );
	        }
	        Debug2.formatSignatureCheckMode = formatSignatureCheckMode;
	        function formatTypeFacts(facts) {
	          return formatEnum(
	            facts,
	            TypeFacts,
	            /*isFlags*/
	            true
	          );
	        }
	        Debug2.formatTypeFacts = formatTypeFacts;
	        let isDebugInfoEnabled = false;
	        let flowNodeProto;
	        function attachFlowNodeDebugInfoWorker(flowNode) {
	          if (!("__debugFlowFlags" in flowNode)) {
	            Object.defineProperties(flowNode, {
	              // for use with vscode-js-debug's new customDescriptionGenerator in launch.json
	              __tsDebuggerDisplay: {
	                value() {
	                  const flowHeader = this.flags & 2 /* Start */ ? "FlowStart" : this.flags & 4 /* BranchLabel */ ? "FlowBranchLabel" : this.flags & 8 /* LoopLabel */ ? "FlowLoopLabel" : this.flags & 16 /* Assignment */ ? "FlowAssignment" : this.flags & 32 /* TrueCondition */ ? "FlowTrueCondition" : this.flags & 64 /* FalseCondition */ ? "FlowFalseCondition" : this.flags & 128 /* SwitchClause */ ? "FlowSwitchClause" : this.flags & 256 /* ArrayMutation */ ? "FlowArrayMutation" : this.flags & 512 /* Call */ ? "FlowCall" : this.flags & 1024 /* ReduceLabel */ ? "FlowReduceLabel" : this.flags & 1 /* Unreachable */ ? "FlowUnreachable" : "UnknownFlow";
	                  const remainingFlags = this.flags & ~(2048 /* Referenced */ - 1);
	                  return `${flowHeader}${remainingFlags ? ` (${formatFlowFlags(remainingFlags)})` : ""}`;
	                }
	              },
	              __debugFlowFlags: {
	                get() {
	                  return formatEnum(
	                    this.flags,
	                    FlowFlags,
	                    /*isFlags*/
	                    true
	                  );
	                }
	              },
	              __debugToString: {
	                value() {
	                  return formatControlFlowGraph(this);
	                }
	              }
	            });
	          }
	        }
	        function attachFlowNodeDebugInfo(flowNode) {
	          if (isDebugInfoEnabled) {
	            if (typeof Object.setPrototypeOf === "function") {
	              if (!flowNodeProto) {
	                flowNodeProto = Object.create(Object.prototype);
	                attachFlowNodeDebugInfoWorker(flowNodeProto);
	              }
	              Object.setPrototypeOf(flowNode, flowNodeProto);
	            } else {
	              attachFlowNodeDebugInfoWorker(flowNode);
	            }
	          }
	        }
	        Debug2.attachFlowNodeDebugInfo = attachFlowNodeDebugInfo;
	        let nodeArrayProto;
	        function attachNodeArrayDebugInfoWorker(array) {
	          if (!("__tsDebuggerDisplay" in array)) {
	            Object.defineProperties(array, {
	              __tsDebuggerDisplay: {
	                value(defaultValue) {
	                  defaultValue = String(defaultValue).replace(/(?:,[\s\w\d_]+:[^,]+)+\]$/, "]");
	                  return `NodeArray ${defaultValue}`;
	                }
	              }
	            });
	          }
	        }
	        function attachNodeArrayDebugInfo(array) {
	          if (isDebugInfoEnabled) {
	            if (typeof Object.setPrototypeOf === "function") {
	              if (!nodeArrayProto) {
	                nodeArrayProto = Object.create(Array.prototype);
	                attachNodeArrayDebugInfoWorker(nodeArrayProto);
	              }
	              Object.setPrototypeOf(array, nodeArrayProto);
	            } else {
	              attachNodeArrayDebugInfoWorker(array);
	            }
	          }
	        }
	        Debug2.attachNodeArrayDebugInfo = attachNodeArrayDebugInfo;
	        function enableDebugInfo() {
	          if (isDebugInfoEnabled)
	            return;
	          const weakTypeTextMap = /* @__PURE__ */ new WeakMap();
	          const weakNodeTextMap = /* @__PURE__ */ new WeakMap();
	          Object.defineProperties(objectAllocator.getSymbolConstructor().prototype, {
	            // for use with vscode-js-debug's new customDescriptionGenerator in launch.json
	            __tsDebuggerDisplay: {
	              value() {
	                const symbolHeader = this.flags & 33554432 /* Transient */ ? "TransientSymbol" : "Symbol";
	                const remainingSymbolFlags = this.flags & ~33554432 /* Transient */;
	                return `${symbolHeader} '${symbolName(this)}'${remainingSymbolFlags ? ` (${formatSymbolFlags(remainingSymbolFlags)})` : ""}`;
	              }
	            },
	            __debugFlags: {
	              get() {
	                return formatSymbolFlags(this.flags);
	              }
	            }
	          });
	          Object.defineProperties(objectAllocator.getTypeConstructor().prototype, {
	            // for use with vscode-js-debug's new customDescriptionGenerator in launch.json
	            __tsDebuggerDisplay: {
	              value() {
	                const typeHeader = this.flags & 67359327 /* Intrinsic */ ? `IntrinsicType ${this.intrinsicName}${this.debugIntrinsicName ? ` (${this.debugIntrinsicName})` : ""}` : this.flags & 98304 /* Nullable */ ? "NullableType" : this.flags & 384 /* StringOrNumberLiteral */ ? `LiteralType ${JSON.stringify(this.value)}` : this.flags & 2048 /* BigIntLiteral */ ? `LiteralType ${this.value.negative ? "-" : ""}${this.value.base10Value}n` : this.flags & 8192 /* UniqueESSymbol */ ? "UniqueESSymbolType" : this.flags & 32 /* Enum */ ? "EnumType" : this.flags & 1048576 /* Union */ ? "UnionType" : this.flags & 2097152 /* Intersection */ ? "IntersectionType" : this.flags & 4194304 /* Index */ ? "IndexType" : this.flags & 8388608 /* IndexedAccess */ ? "IndexedAccessType" : this.flags & 16777216 /* Conditional */ ? "ConditionalType" : this.flags & 33554432 /* Substitution */ ? "SubstitutionType" : this.flags & 262144 /* TypeParameter */ ? "TypeParameter" : this.flags & 524288 /* Object */ ? this.objectFlags & 3 /* ClassOrInterface */ ? "InterfaceType" : this.objectFlags & 4 /* Reference */ ? "TypeReference" : this.objectFlags & 8 /* Tuple */ ? "TupleType" : this.objectFlags & 16 /* Anonymous */ ? "AnonymousType" : this.objectFlags & 32 /* Mapped */ ? "MappedType" : this.objectFlags & 1024 /* ReverseMapped */ ? "ReverseMappedType" : this.objectFlags & 256 /* EvolvingArray */ ? "EvolvingArrayType" : "ObjectType" : "Type";
	                const remainingObjectFlags = this.flags & 524288 /* Object */ ? this.objectFlags & ~1343 /* ObjectTypeKindMask */ : 0;
	                return `${typeHeader}${this.symbol ? ` '${symbolName(this.symbol)}'` : ""}${remainingObjectFlags ? ` (${formatObjectFlags(remainingObjectFlags)})` : ""}`;
	              }
	            },
	            __debugFlags: {
	              get() {
	                return formatTypeFlags(this.flags);
	              }
	            },
	            __debugObjectFlags: {
	              get() {
	                return this.flags & 524288 /* Object */ ? formatObjectFlags(this.objectFlags) : "";
	              }
	            },
	            __debugTypeToString: {
	              value() {
	                let text = weakTypeTextMap.get(this);
	                if (text === void 0) {
	                  text = this.checker.typeToString(this);
	                  weakTypeTextMap.set(this, text);
	                }
	                return text;
	              }
	            }
	          });
	          Object.defineProperties(objectAllocator.getSignatureConstructor().prototype, {
	            __debugFlags: {
	              get() {
	                return formatSignatureFlags(this.flags);
	              }
	            },
	            __debugSignatureToString: {
	              value() {
	                var _a;
	                return (_a = this.checker) == null ? void 0 : _a.signatureToString(this);
	              }
	            }
	          });
	          const nodeConstructors = [
	            objectAllocator.getNodeConstructor(),
	            objectAllocator.getIdentifierConstructor(),
	            objectAllocator.getTokenConstructor(),
	            objectAllocator.getSourceFileConstructor()
	          ];
	          for (const ctor of nodeConstructors) {
	            if (!hasProperty(ctor.prototype, "__debugKind")) {
	              Object.defineProperties(ctor.prototype, {
	                // for use with vscode-js-debug's new customDescriptionGenerator in launch.json
	                __tsDebuggerDisplay: {
	                  value() {
	                    const nodeHeader = isGeneratedIdentifier(this) ? "GeneratedIdentifier" : isIdentifier(this) ? `Identifier '${idText(this)}'` : isPrivateIdentifier(this) ? `PrivateIdentifier '${idText(this)}'` : isStringLiteral(this) ? `StringLiteral ${JSON.stringify(this.text.length < 10 ? this.text : this.text.slice(10) + "...")}` : isNumericLiteral(this) ? `NumericLiteral ${this.text}` : isBigIntLiteral(this) ? `BigIntLiteral ${this.text}n` : isTypeParameterDeclaration(this) ? "TypeParameterDeclaration" : isParameter(this) ? "ParameterDeclaration" : isConstructorDeclaration(this) ? "ConstructorDeclaration" : isGetAccessorDeclaration(this) ? "GetAccessorDeclaration" : isSetAccessorDeclaration(this) ? "SetAccessorDeclaration" : isCallSignatureDeclaration(this) ? "CallSignatureDeclaration" : isConstructSignatureDeclaration(this) ? "ConstructSignatureDeclaration" : isIndexSignatureDeclaration(this) ? "IndexSignatureDeclaration" : isTypePredicateNode(this) ? "TypePredicateNode" : isTypeReferenceNode(this) ? "TypeReferenceNode" : isFunctionTypeNode(this) ? "FunctionTypeNode" : isConstructorTypeNode(this) ? "ConstructorTypeNode" : isTypeQueryNode(this) ? "TypeQueryNode" : isTypeLiteralNode(this) ? "TypeLiteralNode" : isArrayTypeNode(this) ? "ArrayTypeNode" : isTupleTypeNode(this) ? "TupleTypeNode" : isOptionalTypeNode(this) ? "OptionalTypeNode" : isRestTypeNode(this) ? "RestTypeNode" : isUnionTypeNode(this) ? "UnionTypeNode" : isIntersectionTypeNode(this) ? "IntersectionTypeNode" : isConditionalTypeNode(this) ? "ConditionalTypeNode" : isInferTypeNode(this) ? "InferTypeNode" : isParenthesizedTypeNode(this) ? "ParenthesizedTypeNode" : isThisTypeNode(this) ? "ThisTypeNode" : isTypeOperatorNode(this) ? "TypeOperatorNode" : isIndexedAccessTypeNode(this) ? "IndexedAccessTypeNode" : isMappedTypeNode(this) ? "MappedTypeNode" : isLiteralTypeNode(this) ? "LiteralTypeNode" : isNamedTupleMember(this) ? "NamedTupleMember" : isImportTypeNode(this) ? "ImportTypeNode" : formatSyntaxKind(this.kind);
	                    return `${nodeHeader}${this.flags ? ` (${formatNodeFlags(this.flags)})` : ""}`;
	                  }
	                },
	                __debugKind: {
	                  get() {
	                    return formatSyntaxKind(this.kind);
	                  }
	                },
	                __debugNodeFlags: {
	                  get() {
	                    return formatNodeFlags(this.flags);
	                  }
	                },
	                __debugModifierFlags: {
	                  get() {
	                    return formatModifierFlags(getEffectiveModifierFlagsNoCache(this));
	                  }
	                },
	                __debugTransformFlags: {
	                  get() {
	                    return formatTransformFlags(this.transformFlags);
	                  }
	                },
	                __debugIsParseTreeNode: {
	                  get() {
	                    return isParseTreeNode(this);
	                  }
	                },
	                __debugEmitFlags: {
	                  get() {
	                    return formatEmitFlags(getEmitFlags(this));
	                  }
	                },
	                __debugGetText: {
	                  value(includeTrivia) {
	                    if (nodeIsSynthesized(this))
	                      return "";
	                    let text = weakNodeTextMap.get(this);
	                    if (text === void 0) {
	                      const parseNode = getParseTreeNode(this);
	                      const sourceFile = parseNode && getSourceFileOfNode(parseNode);
	                      text = sourceFile ? getSourceTextOfNodeFromSourceFile(sourceFile, parseNode, includeTrivia) : "";
	                      weakNodeTextMap.set(this, text);
	                    }
	                    return text;
	                  }
	                }
	              });
	            }
	          }
	          isDebugInfoEnabled = true;
	        }
	        Debug2.enableDebugInfo = enableDebugInfo;
	        function formatVariance(varianceFlags) {
	          const variance = varianceFlags & 7 /* VarianceMask */;
	          let result = variance === 0 /* Invariant */ ? "in out" : variance === 3 /* Bivariant */ ? "[bivariant]" : variance === 2 /* Contravariant */ ? "in" : variance === 1 /* Covariant */ ? "out" : variance === 4 /* Independent */ ? "[independent]" : "";
	          if (varianceFlags & 8 /* Unmeasurable */) {
	            result += " (unmeasurable)";
	          } else if (varianceFlags & 16 /* Unreliable */) {
	            result += " (unreliable)";
	          }
	          return result;
	        }
	        Debug2.formatVariance = formatVariance;
	        class DebugTypeMapper {
	          __debugToString() {
	            var _a;
	            switch (this.kind) {
	              case 3 /* Function */:
	                return ((_a = this.debugInfo) == null ? void 0 : _a.call(this)) || "(function mapper)";
	              case 0 /* Simple */:
	                return `${this.source.__debugTypeToString()} -> ${this.target.__debugTypeToString()}`;
	              case 1 /* Array */:
	                return zipWith(
	                  this.sources,
	                  this.targets || map(this.sources, () => "any"),
	                  (s, t) => `${s.__debugTypeToString()} -> ${typeof t === "string" ? t : t.__debugTypeToString()}`
	                ).join(", ");
	              case 2 /* Deferred */:
	                return zipWith(
	                  this.sources,
	                  this.targets,
	                  (s, t) => `${s.__debugTypeToString()} -> ${t().__debugTypeToString()}`
	                ).join(", ");
	              case 5 /* Merged */:
	              case 4 /* Composite */:
	                return `m1: ${this.mapper1.__debugToString().split("\n").join("\n    ")}
m2: ${this.mapper2.__debugToString().split("\n").join("\n    ")}`;
	              default:
	                return assertNever(this);
	            }
	          }
	        }
	        Debug2.DebugTypeMapper = DebugTypeMapper;
	        function attachDebugPrototypeIfDebug(mapper) {
	          if (Debug2.isDebugging) {
	            return Object.setPrototypeOf(mapper, DebugTypeMapper.prototype);
	          }
	          return mapper;
	        }
	        Debug2.attachDebugPrototypeIfDebug = attachDebugPrototypeIfDebug;
	        function printControlFlowGraph(flowNode) {
	          return console.log(formatControlFlowGraph(flowNode));
	        }
	        Debug2.printControlFlowGraph = printControlFlowGraph;
	        function formatControlFlowGraph(flowNode) {
	          let nextDebugFlowId = -1;
	          function getDebugFlowNodeId(f) {
	            if (!f.id) {
	              f.id = nextDebugFlowId;
	              nextDebugFlowId--;
	            }
	            return f.id;
	          }
	          let BoxCharacter;
	          ((BoxCharacter2) => {
	            BoxCharacter2["lr"] = "\u2500";
	            BoxCharacter2["ud"] = "\u2502";
	            BoxCharacter2["dr"] = "\u256D";
	            BoxCharacter2["dl"] = "\u256E";
	            BoxCharacter2["ul"] = "\u256F";
	            BoxCharacter2["ur"] = "\u2570";
	            BoxCharacter2["udr"] = "\u251C";
	            BoxCharacter2["udl"] = "\u2524";
	            BoxCharacter2["dlr"] = "\u252C";
	            BoxCharacter2["ulr"] = "\u2534";
	            BoxCharacter2["udlr"] = "\u256B";
	          })(BoxCharacter || (BoxCharacter = {}));
	          let Connection;
	          ((Connection2) => {
	            Connection2[Connection2["None"] = 0] = "None";
	            Connection2[Connection2["Up"] = 1] = "Up";
	            Connection2[Connection2["Down"] = 2] = "Down";
	            Connection2[Connection2["Left"] = 4] = "Left";
	            Connection2[Connection2["Right"] = 8] = "Right";
	            Connection2[Connection2["UpDown"] = 3] = "UpDown";
	            Connection2[Connection2["LeftRight"] = 12] = "LeftRight";
	            Connection2[Connection2["UpLeft"] = 5] = "UpLeft";
	            Connection2[Connection2["UpRight"] = 9] = "UpRight";
	            Connection2[Connection2["DownLeft"] = 6] = "DownLeft";
	            Connection2[Connection2["DownRight"] = 10] = "DownRight";
	            Connection2[Connection2["UpDownLeft"] = 7] = "UpDownLeft";
	            Connection2[Connection2["UpDownRight"] = 11] = "UpDownRight";
	            Connection2[Connection2["UpLeftRight"] = 13] = "UpLeftRight";
	            Connection2[Connection2["DownLeftRight"] = 14] = "DownLeftRight";
	            Connection2[Connection2["UpDownLeftRight"] = 15] = "UpDownLeftRight";
	            Connection2[Connection2["NoChildren"] = 16] = "NoChildren";
	          })(Connection || (Connection = {}));
	          const hasAntecedentFlags = 16 /* Assignment */ | 96 /* Condition */ | 128 /* SwitchClause */ | 256 /* ArrayMutation */ | 512 /* Call */ | 1024 /* ReduceLabel */;
	          const hasNodeFlags = 2 /* Start */ | 16 /* Assignment */ | 512 /* Call */ | 96 /* Condition */ | 256 /* ArrayMutation */;
	          const links = /* @__PURE__ */ Object.create(
	            /*o*/
	            null
	          );
	          const nodes = [];
	          const root = buildGraphNode(flowNode, /* @__PURE__ */ new Set());
	          for (const node of nodes) {
	            node.text = renderFlowNode(node.flowNode, node.circular);
	            computeLevel(node);
	          }
	          const height = computeHeight(root);
	          const columnWidths = computeColumnWidths(height);
	          computeLanes(root, 0);
	          return renderGraph();
	          function isFlowSwitchClause(f) {
	            return !!(f.flags & 128 /* SwitchClause */);
	          }
	          function hasAntecedents(f) {
	            return !!(f.flags & 12 /* Label */) && !!f.antecedents;
	          }
	          function hasAntecedent(f) {
	            return !!(f.flags & hasAntecedentFlags);
	          }
	          function hasNode(f) {
	            return !!(f.flags & hasNodeFlags);
	          }
	          function getChildren(node) {
	            const children = [];
	            for (const edge of node.edges) {
	              if (edge.source === node) {
	                children.push(edge.target);
	              }
	            }
	            return children;
	          }
	          function getParents(node) {
	            const parents = [];
	            for (const edge of node.edges) {
	              if (edge.target === node) {
	                parents.push(edge.source);
	              }
	            }
	            return parents;
	          }
	          function buildGraphNode(flowNode2, seen) {
	            const id = getDebugFlowNodeId(flowNode2);
	            let graphNode = links[id];
	            if (graphNode && seen.has(flowNode2)) {
	              graphNode.circular = true;
	              graphNode = {
	                id: -1,
	                flowNode: flowNode2,
	                edges: [],
	                text: "",
	                lane: -1,
	                endLane: -1,
	                level: -1,
	                circular: "circularity"
	              };
	              nodes.push(graphNode);
	              return graphNode;
	            }
	            seen.add(flowNode2);
	            if (!graphNode) {
	              links[id] = graphNode = { id, flowNode: flowNode2, edges: [], text: "", lane: -1, endLane: -1, level: -1, circular: false };
	              nodes.push(graphNode);
	              if (hasAntecedents(flowNode2)) {
	                for (const antecedent of flowNode2.antecedents) {
	                  buildGraphEdge(graphNode, antecedent, seen);
	                }
	              } else if (hasAntecedent(flowNode2)) {
	                buildGraphEdge(graphNode, flowNode2.antecedent, seen);
	              }
	            }
	            seen.delete(flowNode2);
	            return graphNode;
	          }
	          function buildGraphEdge(source, antecedent, seen) {
	            const target = buildGraphNode(antecedent, seen);
	            const edge = { source, target };
	            source.edges.push(edge);
	            target.edges.push(edge);
	          }
	          function computeLevel(node) {
	            if (node.level !== -1) {
	              return node.level;
	            }
	            let level = 0;
	            for (const parent2 of getParents(node)) {
	              level = Math.max(level, computeLevel(parent2) + 1);
	            }
	            return node.level = level;
	          }
	          function computeHeight(node) {
	            let height2 = 0;
	            for (const child of getChildren(node)) {
	              height2 = Math.max(height2, computeHeight(child));
	            }
	            return height2 + 1;
	          }
	          function computeColumnWidths(height2) {
	            const columns = fill(Array(height2), 0);
	            for (const node of nodes) {
	              columns[node.level] = Math.max(columns[node.level], node.text.length);
	            }
	            return columns;
	          }
	          function computeLanes(node, lane) {
	            if (node.lane === -1) {
	              node.lane = lane;
	              node.endLane = lane;
	              const children = getChildren(node);
	              for (let i = 0; i < children.length; i++) {
	                if (i > 0)
	                  lane++;
	                const child = children[i];
	                computeLanes(child, lane);
	                if (child.endLane > node.endLane) {
	                  lane = child.endLane;
	                }
	              }
	              node.endLane = lane;
	            }
	          }
	          function getHeader(flags) {
	            if (flags & 2 /* Start */)
	              return "Start";
	            if (flags & 4 /* BranchLabel */)
	              return "Branch";
	            if (flags & 8 /* LoopLabel */)
	              return "Loop";
	            if (flags & 16 /* Assignment */)
	              return "Assignment";
	            if (flags & 32 /* TrueCondition */)
	              return "True";
	            if (flags & 64 /* FalseCondition */)
	              return "False";
	            if (flags & 128 /* SwitchClause */)
	              return "SwitchClause";
	            if (flags & 256 /* ArrayMutation */)
	              return "ArrayMutation";
	            if (flags & 512 /* Call */)
	              return "Call";
	            if (flags & 1024 /* ReduceLabel */)
	              return "ReduceLabel";
	            if (flags & 1 /* Unreachable */)
	              return "Unreachable";
	            throw new Error();
	          }
	          function getNodeText(node) {
	            const sourceFile = getSourceFileOfNode(node);
	            return getSourceTextOfNodeFromSourceFile(
	              sourceFile,
	              node,
	              /*includeTrivia*/
	              false
	            );
	          }
	          function renderFlowNode(flowNode2, circular) {
	            let text = getHeader(flowNode2.flags);
	            if (circular) {
	              text = `${text}#${getDebugFlowNodeId(flowNode2)}`;
	            }
	            if (hasNode(flowNode2)) {
	              if (flowNode2.node) {
	                text += ` (${getNodeText(flowNode2.node)})`;
	              }
	            } else if (isFlowSwitchClause(flowNode2)) {
	              const clauses = [];
	              for (let i = flowNode2.clauseStart; i < flowNode2.clauseEnd; i++) {
	                const clause = flowNode2.switchStatement.caseBlock.clauses[i];
	                if (isDefaultClause(clause)) {
	                  clauses.push("default");
	                } else {
	                  clauses.push(getNodeText(clause.expression));
	                }
	              }
	              text += ` (${clauses.join(", ")})`;
	            }
	            return circular === "circularity" ? `Circular(${text})` : text;
	          }
	          function renderGraph() {
	            const columnCount = columnWidths.length;
	            const laneCount = nodes.reduce((x, n) => Math.max(x, n.lane), 0) + 1;
	            const lanes = fill(Array(laneCount), "");
	            const grid = columnWidths.map(() => Array(laneCount));
	            const connectors = columnWidths.map(() => fill(Array(laneCount), 0));
	            for (const node of nodes) {
	              grid[node.level][node.lane] = node;
	              const children = getChildren(node);
	              for (let i = 0; i < children.length; i++) {
	                const child = children[i];
	                let connector = 8 /* Right */;
	                if (child.lane === node.lane)
	                  connector |= 4 /* Left */;
	                if (i > 0)
	                  connector |= 1 /* Up */;
	                if (i < children.length - 1)
	                  connector |= 2 /* Down */;
	                connectors[node.level][child.lane] |= connector;
	              }
	              if (children.length === 0) {
	                connectors[node.level][node.lane] |= 16 /* NoChildren */;
	              }
	              const parents = getParents(node);
	              for (let i = 0; i < parents.length; i++) {
	                const parent2 = parents[i];
	                let connector = 4 /* Left */;
	                if (i > 0)
	                  connector |= 1 /* Up */;
	                if (i < parents.length - 1)
	                  connector |= 2 /* Down */;
	                connectors[node.level - 1][parent2.lane] |= connector;
	              }
	            }
	            for (let column = 0; column < columnCount; column++) {
	              for (let lane = 0; lane < laneCount; lane++) {
	                const left = column > 0 ? connectors[column - 1][lane] : 0;
	                const above = lane > 0 ? connectors[column][lane - 1] : 0;
	                let connector = connectors[column][lane];
	                if (!connector) {
	                  if (left & 8 /* Right */)
	                    connector |= 12 /* LeftRight */;
	                  if (above & 2 /* Down */)
	                    connector |= 3 /* UpDown */;
	                  connectors[column][lane] = connector;
	                }
	              }
	            }
	            for (let column = 0; column < columnCount; column++) {
	              for (let lane = 0; lane < lanes.length; lane++) {
	                const connector = connectors[column][lane];
	                const fill2 = connector & 4 /* Left */ ? "\u2500" /* lr */ : " ";
	                const node = grid[column][lane];
	                if (!node) {
	                  if (column < columnCount - 1) {
	                    writeLane(lane, repeat(fill2, columnWidths[column] + 1));
	                  }
	                } else {
	                  writeLane(lane, node.text);
	                  if (column < columnCount - 1) {
	                    writeLane(lane, " ");
	                    writeLane(lane, repeat(fill2, columnWidths[column] - node.text.length));
	                  }
	                }
	                writeLane(lane, getBoxCharacter(connector));
	                writeLane(lane, connector & 8 /* Right */ && column < columnCount - 1 && !grid[column + 1][lane] ? "\u2500" /* lr */ : " ");
	              }
	            }
	            return `
${lanes.join("\n")}
`;
	            function writeLane(lane, text) {
	              lanes[lane] += text;
	            }
	          }
	          function getBoxCharacter(connector) {
	            switch (connector) {
	              case 3 /* UpDown */:
	                return "\u2502" /* ud */;
	              case 12 /* LeftRight */:
	                return "\u2500" /* lr */;
	              case 5 /* UpLeft */:
	                return "\u256F" /* ul */;
	              case 9 /* UpRight */:
	                return "\u2570" /* ur */;
	              case 6 /* DownLeft */:
	                return "\u256E" /* dl */;
	              case 10 /* DownRight */:
	                return "\u256D" /* dr */;
	              case 7 /* UpDownLeft */:
	                return "\u2524" /* udl */;
	              case 11 /* UpDownRight */:
	                return "\u251C" /* udr */;
	              case 13 /* UpLeftRight */:
	                return "\u2534" /* ulr */;
	              case 14 /* DownLeftRight */:
	                return "\u252C" /* dlr */;
	              case 15 /* UpDownLeftRight */:
	                return "\u256B" /* udlr */;
	            }
	            return " ";
	          }
	          function fill(array, value) {
	            if (array.fill) {
	              array.fill(value);
	            } else {
	              for (let i = 0; i < array.length; i++) {
	                array[i] = value;
	              }
	            }
	            return array;
	          }
	          function repeat(ch, length2) {
	            if (ch.repeat) {
	              return length2 > 0 ? ch.repeat(length2) : "";
	            }
	            let s = "";
	            while (s.length < length2) {
	              s += ch;
	            }
	            return s;
	          }
	        }
	        Debug2.formatControlFlowGraph = formatControlFlowGraph;
	      })(Debug || (Debug = {}));
	    }
	  });

	  // src/compiler/semver.ts
	  function tryParseComponents(text) {
	    const match = versionRegExp.exec(text);
	    if (!match)
	      return void 0;
	    const [, major, minor = "0", patch = "0", prerelease = "", build2 = ""] = match;
	    if (prerelease && !prereleaseRegExp.test(prerelease))
	      return void 0;
	    if (build2 && !buildRegExp.test(build2))
	      return void 0;
	    return {
	      major: parseInt(major, 10),
	      minor: parseInt(minor, 10),
	      patch: parseInt(patch, 10),
	      prerelease,
	      build: build2
	    };
	  }
	  function comparePrereleaseIdentifiers(left, right) {
	    if (left === right)
	      return 0 /* EqualTo */;
	    if (left.length === 0)
	      return right.length === 0 ? 0 /* EqualTo */ : 1 /* GreaterThan */;
	    if (right.length === 0)
	      return -1 /* LessThan */;
	    const length2 = Math.min(left.length, right.length);
	    for (let i = 0; i < length2; i++) {
	      const leftIdentifier = left[i];
	      const rightIdentifier = right[i];
	      if (leftIdentifier === rightIdentifier)
	        continue;
	      const leftIsNumeric = numericIdentifierRegExp.test(leftIdentifier);
	      const rightIsNumeric = numericIdentifierRegExp.test(rightIdentifier);
	      if (leftIsNumeric || rightIsNumeric) {
	        if (leftIsNumeric !== rightIsNumeric)
	          return leftIsNumeric ? -1 /* LessThan */ : 1 /* GreaterThan */;
	        const result = compareValues(+leftIdentifier, +rightIdentifier);
	        if (result)
	          return result;
	      } else {
	        const result = compareStringsCaseSensitive(leftIdentifier, rightIdentifier);
	        if (result)
	          return result;
	      }
	    }
	    return compareValues(left.length, right.length);
	  }
	  function parseRange(text) {
	    const alternatives = [];
	    for (let range of text.trim().split(logicalOrRegExp)) {
	      if (!range)
	        continue;
	      const comparators = [];
	      range = range.trim();
	      const match = hyphenRegExp.exec(range);
	      if (match) {
	        if (!parseHyphen(match[1], match[2], comparators))
	          return void 0;
	      } else {
	        for (const simple of range.split(whitespaceRegExp)) {
	          const match2 = rangeRegExp.exec(simple.trim());
	          if (!match2 || !parseComparator(match2[1], match2[2], comparators))
	            return void 0;
	        }
	      }
	      alternatives.push(comparators);
	    }
	    return alternatives;
	  }
	  function parsePartial(text) {
	    const match = partialRegExp.exec(text);
	    if (!match)
	      return void 0;
	    const [, major, minor = "*", patch = "*", prerelease, build2] = match;
	    const version2 = new Version(
	      isWildcard(major) ? 0 : parseInt(major, 10),
	      isWildcard(major) || isWildcard(minor) ? 0 : parseInt(minor, 10),
	      isWildcard(major) || isWildcard(minor) || isWildcard(patch) ? 0 : parseInt(patch, 10),
	      prerelease,
	      build2
	    );
	    return { version: version2, major, minor, patch };
	  }
	  function parseHyphen(left, right, comparators) {
	    const leftResult = parsePartial(left);
	    if (!leftResult)
	      return false;
	    const rightResult = parsePartial(right);
	    if (!rightResult)
	      return false;
	    if (!isWildcard(leftResult.major)) {
	      comparators.push(createComparator(">=", leftResult.version));
	    }
	    if (!isWildcard(rightResult.major)) {
	      comparators.push(
	        isWildcard(rightResult.minor) ? createComparator("<", rightResult.version.increment("major")) : isWildcard(rightResult.patch) ? createComparator("<", rightResult.version.increment("minor")) : createComparator("<=", rightResult.version)
	      );
	    }
	    return true;
	  }
	  function parseComparator(operator, text, comparators) {
	    const result = parsePartial(text);
	    if (!result)
	      return false;
	    const { version: version2, major, minor, patch } = result;
	    if (!isWildcard(major)) {
	      switch (operator) {
	        case "~":
	          comparators.push(createComparator(">=", version2));
	          comparators.push(createComparator(
	            "<",
	            version2.increment(
	              isWildcard(minor) ? "major" : "minor"
	            )
	          ));
	          break;
	        case "^":
	          comparators.push(createComparator(">=", version2));
	          comparators.push(createComparator(
	            "<",
	            version2.increment(
	              version2.major > 0 || isWildcard(minor) ? "major" : version2.minor > 0 || isWildcard(patch) ? "minor" : "patch"
	            )
	          ));
	          break;
	        case "<":
	        case ">=":
	          comparators.push(
	            isWildcard(minor) || isWildcard(patch) ? createComparator(operator, version2.with({ prerelease: "0" })) : createComparator(operator, version2)
	          );
	          break;
	        case "<=":
	        case ">":
	          comparators.push(
	            isWildcard(minor) ? createComparator(operator === "<=" ? "<" : ">=", version2.increment("major").with({ prerelease: "0" })) : isWildcard(patch) ? createComparator(operator === "<=" ? "<" : ">=", version2.increment("minor").with({ prerelease: "0" })) : createComparator(operator, version2)
	          );
	          break;
	        case "=":
	        case void 0:
	          if (isWildcard(minor) || isWildcard(patch)) {
	            comparators.push(createComparator(">=", version2.with({ prerelease: "0" })));
	            comparators.push(createComparator("<", version2.increment(isWildcard(minor) ? "major" : "minor").with({ prerelease: "0" })));
	          } else {
	            comparators.push(createComparator("=", version2));
	          }
	          break;
	        default:
	          return false;
	      }
	    } else if (operator === "<" || operator === ">") {
	      comparators.push(createComparator("<", Version.zero));
	    }
	    return true;
	  }
	  function isWildcard(part) {
	    return part === "*" || part === "x" || part === "X";
	  }
	  function createComparator(operator, operand) {
	    return { operator, operand };
	  }
	  function testDisjunction(version2, alternatives) {
	    if (alternatives.length === 0)
	      return true;
	    for (const alternative of alternatives) {
	      if (testAlternative(version2, alternative))
	        return true;
	    }
	    return false;
	  }
	  function testAlternative(version2, comparators) {
	    for (const comparator of comparators) {
	      if (!testComparator(version2, comparator.operator, comparator.operand))
	        return false;
	    }
	    return true;
	  }
	  function testComparator(version2, operator, operand) {
	    const cmp = version2.compareTo(operand);
	    switch (operator) {
	      case "<":
	        return cmp < 0;
	      case "<=":
	        return cmp <= 0;
	      case ">":
	        return cmp > 0;
	      case ">=":
	        return cmp >= 0;
	      case "=":
	        return cmp === 0;
	      default:
	        return Debug.assertNever(operator);
	    }
	  }
	  function formatDisjunction(alternatives) {
	    return map(alternatives, formatAlternative).join(" || ") || "*";
	  }
	  function formatAlternative(comparators) {
	    return map(comparators, formatComparator).join(" ");
	  }
	  function formatComparator(comparator) {
	    return `${comparator.operator}${comparator.operand}`;
	  }
	  var versionRegExp, prereleaseRegExp, prereleasePartRegExp, buildRegExp, buildPartRegExp, numericIdentifierRegExp, _Version, Version, VersionRange, logicalOrRegExp, whitespaceRegExp, partialRegExp, hyphenRegExp, rangeRegExp;
	  var init_semver = __esm({
	    "src/compiler/semver.ts"() {
	      init_ts2();
	      versionRegExp = /^(0|[1-9]\d*)(?:\.(0|[1-9]\d*)(?:\.(0|[1-9]\d*)(?:-([a-z0-9-.]+))?(?:\+([a-z0-9-.]+))?)?)?$/i;
	      prereleaseRegExp = /^(?:0|[1-9]\d*|[a-z-][a-z0-9-]*)(?:\.(?:0|[1-9]\d*|[a-z-][a-z0-9-]*))*$/i;
	      prereleasePartRegExp = /^(?:0|[1-9]\d*|[a-z-][a-z0-9-]*)$/i;
	      buildRegExp = /^[a-z0-9-]+(?:\.[a-z0-9-]+)*$/i;
	      buildPartRegExp = /^[a-z0-9-]+$/i;
	      numericIdentifierRegExp = /^(0|[1-9]\d*)$/;
	      _Version = class _Version {
	        constructor(major, minor = 0, patch = 0, prerelease = "", build2 = "") {
	          if (typeof major === "string") {
	            const result = Debug.checkDefined(tryParseComponents(major), "Invalid version");
	            ({ major, minor, patch, prerelease, build: build2 } = result);
	          }
	          Debug.assert(major >= 0, "Invalid argument: major");
	          Debug.assert(minor >= 0, "Invalid argument: minor");
	          Debug.assert(patch >= 0, "Invalid argument: patch");
	          const prereleaseArray = prerelease ? isArray(prerelease) ? prerelease : prerelease.split(".") : emptyArray;
	          const buildArray = build2 ? isArray(build2) ? build2 : build2.split(".") : emptyArray;
	          Debug.assert(every(prereleaseArray, (s) => prereleasePartRegExp.test(s)), "Invalid argument: prerelease");
	          Debug.assert(every(buildArray, (s) => buildPartRegExp.test(s)), "Invalid argument: build");
	          this.major = major;
	          this.minor = minor;
	          this.patch = patch;
	          this.prerelease = prereleaseArray;
	          this.build = buildArray;
	        }
	        static tryParse(text) {
	          const result = tryParseComponents(text);
	          if (!result)
	            return void 0;
	          const { major, minor, patch, prerelease, build: build2 } = result;
	          return new _Version(major, minor, patch, prerelease, build2);
	        }
	        compareTo(other) {
	          if (this === other)
	            return 0 /* EqualTo */;
	          if (other === void 0)
	            return 1 /* GreaterThan */;
	          return compareValues(this.major, other.major) || compareValues(this.minor, other.minor) || compareValues(this.patch, other.patch) || comparePrereleaseIdentifiers(this.prerelease, other.prerelease);
	        }
	        increment(field) {
	          switch (field) {
	            case "major":
	              return new _Version(this.major + 1, 0, 0);
	            case "minor":
	              return new _Version(this.major, this.minor + 1, 0);
	            case "patch":
	              return new _Version(this.major, this.minor, this.patch + 1);
	            default:
	              return Debug.assertNever(field);
	          }
	        }
	        with(fields) {
	          const {
	            major = this.major,
	            minor = this.minor,
	            patch = this.patch,
	            prerelease = this.prerelease,
	            build: build2 = this.build
	          } = fields;
	          return new _Version(major, minor, patch, prerelease, build2);
	        }
	        toString() {
	          let result = `${this.major}.${this.minor}.${this.patch}`;
	          if (some(this.prerelease))
	            result += `-${this.prerelease.join(".")}`;
	          if (some(this.build))
	            result += `+${this.build.join(".")}`;
	          return result;
	        }
	      };
	      _Version.zero = new _Version(0, 0, 0, ["0"]);
	      Version = _Version;
	      VersionRange = class _VersionRange {
	        constructor(spec) {
	          this._alternatives = spec ? Debug.checkDefined(parseRange(spec), "Invalid range spec.") : emptyArray;
	        }
	        static tryParse(text) {
	          const sets = parseRange(text);
	          if (sets) {
	            const range = new _VersionRange("");
	            range._alternatives = sets;
	            return range;
	          }
	          return void 0;
	        }
	        /**
	         * Tests whether a version matches the range. This is equivalent to `satisfies(version, range, { includePrerelease: true })`.
	         * in `node-semver`.
	         */
	        test(version2) {
	          if (typeof version2 === "string")
	            version2 = new Version(version2);
	          return testDisjunction(version2, this._alternatives);
	        }
	        toString() {
	          return formatDisjunction(this._alternatives);
	        }
	      };
	      logicalOrRegExp = /\|\|/g;
	      whitespaceRegExp = /\s+/g;
	      partialRegExp = /^([xX*0]|[1-9]\d*)(?:\.([xX*0]|[1-9]\d*)(?:\.([xX*0]|[1-9]\d*)(?:-([a-z0-9-.]+))?(?:\+([a-z0-9-.]+))?)?)?$/i;
	      hyphenRegExp = /^\s*([a-z0-9-+.*]+)\s+-\s+([a-z0-9-+.*]+)\s*$/i;
	      rangeRegExp = /^(~|\^|<|<=|>|>=|=)?\s*([a-z0-9-+.*]+)$/i;
	    }
	  });

	  // src/compiler/performanceCore.ts
	  function hasRequiredAPI(performance2, PerformanceObserver2) {
	    return typeof performance2 === "object" && typeof performance2.timeOrigin === "number" && typeof performance2.mark === "function" && typeof performance2.measure === "function" && typeof performance2.now === "function" && typeof performance2.clearMarks === "function" && typeof performance2.clearMeasures === "function" && typeof PerformanceObserver2 === "function";
	  }
	  function tryGetWebPerformanceHooks() {
	    if (typeof performance === "object" && typeof PerformanceObserver === "function" && hasRequiredAPI(performance, PerformanceObserver)) {
	      return {
	        // For now we always write native performance events when running in the browser. We may
	        // make this conditional in the future if we find that native web performance hooks
	        // in the browser also slow down compilation.
	        shouldWriteNativeEvents: true,
	        performance,
	        PerformanceObserver
	      };
	    }
	  }
	  function tryGetNodePerformanceHooks() {
	    if (isNodeLikeSystem()) {
	      try {
	        const { performance: performance2, PerformanceObserver: PerformanceObserver2 } = require("perf_hooks");
	        if (hasRequiredAPI(performance2, PerformanceObserver2)) {
	          return {
	            // By default, only write native events when generating a cpu profile or using the v8 profiler.
	            shouldWriteNativeEvents: false,
	            performance: performance2,
	            PerformanceObserver: PerformanceObserver2
	          };
	        }
	      } catch {
	      }
	    }
	  }
	  function tryGetNativePerformanceHooks() {
	    return nativePerformanceHooks;
	  }
	  var nativePerformanceHooks, nativePerformance, timestamp;
	  var init_performanceCore = __esm({
	    "src/compiler/performanceCore.ts"() {
	      init_ts2();
	      nativePerformanceHooks = tryGetWebPerformanceHooks() || tryGetNodePerformanceHooks();
	      nativePerformance = nativePerformanceHooks == null ? void 0 : nativePerformanceHooks.performance;
	      timestamp = nativePerformance ? () => nativePerformance.now() : Date.now ? Date.now : () => +/* @__PURE__ */ new Date();
	    }
	  });

	  // src/compiler/perfLogger.ts
	  var etwModule, perfLogger;
	  var init_perfLogger = __esm({
	    "src/compiler/perfLogger.ts"() {
	      try {
	        const etwModulePath = process.env.TS_ETW_MODULE_PATH ?? "./node_modules/@microsoft/typescript-etw";
	        etwModule = commonjsRequire(etwModulePath);
	      } catch (e) {
	        etwModule = void 0;
	      }
	      perfLogger = (etwModule == null ? void 0 : etwModule.logEvent) ? etwModule : void 0;
	    }
	  });

	  // src/compiler/performance.ts
	  function createTimerIf(condition, measureName, startMarkName, endMarkName) {
	    return condition ? createTimer(measureName, startMarkName, endMarkName) : nullTimer;
	  }
	  function createTimer(measureName, startMarkName, endMarkName) {
	    let enterCount = 0;
	    return {
	      enter,
	      exit
	    };
	    function enter() {
	      if (++enterCount === 1) {
	        mark(startMarkName);
	      }
	    }
	    function exit() {
	      if (--enterCount === 0) {
	        mark(endMarkName);
	        measure(measureName, startMarkName, endMarkName);
	      } else if (enterCount < 0) {
	        Debug.fail("enter/exit count does not match.");
	      }
	    }
	  }
	  function mark(markName) {
	    if (enabled) {
	      const count = counts.get(markName) ?? 0;
	      counts.set(markName, count + 1);
	      marks.set(markName, timestamp());
	      performanceImpl == null ? void 0 : performanceImpl.mark(markName);
	      if (typeof onProfilerEvent === "function") {
	        onProfilerEvent(markName);
	      }
	    }
	  }
	  function measure(measureName, startMarkName, endMarkName) {
	    if (enabled) {
	      const end = (endMarkName !== void 0 ? marks.get(endMarkName) : void 0) ?? timestamp();
	      const start = (startMarkName !== void 0 ? marks.get(startMarkName) : void 0) ?? timeorigin;
	      const previousDuration = durations.get(measureName) || 0;
	      durations.set(measureName, previousDuration + (end - start));
	      performanceImpl == null ? void 0 : performanceImpl.measure(measureName, startMarkName, endMarkName);
	    }
	  }
	  function getCount(markName) {
	    return counts.get(markName) || 0;
	  }
	  function getDuration(measureName) {
	    return durations.get(measureName) || 0;
	  }
	  function forEachMeasure(cb) {
	    durations.forEach((duration, measureName) => cb(measureName, duration));
	  }
	  function forEachMark(cb) {
	    marks.forEach((_time, markName) => cb(markName));
	  }
	  function clearMeasures(name) {
	    if (name !== void 0)
	      durations.delete(name);
	    else
	      durations.clear();
	    performanceImpl == null ? void 0 : performanceImpl.clearMeasures(name);
	  }
	  function clearMarks(name) {
	    if (name !== void 0) {
	      counts.delete(name);
	      marks.delete(name);
	    } else {
	      counts.clear();
	      marks.clear();
	    }
	    performanceImpl == null ? void 0 : performanceImpl.clearMarks(name);
	  }
	  function isEnabled() {
	    return enabled;
	  }
	  function enable(system = sys) {
	    var _a;
	    if (!enabled) {
	      enabled = true;
	      perfHooks || (perfHooks = tryGetNativePerformanceHooks());
	      if (perfHooks) {
	        timeorigin = perfHooks.performance.timeOrigin;
	        if (perfHooks.shouldWriteNativeEvents || ((_a = system == null ? void 0 : system.cpuProfilingEnabled) == null ? void 0 : _a.call(system)) || (system == null ? void 0 : system.debugMode)) {
	          performanceImpl = perfHooks.performance;
	        }
	      }
	    }
	    return true;
	  }
	  function disable() {
	    if (enabled) {
	      marks.clear();
	      counts.clear();
	      durations.clear();
	      performanceImpl = void 0;
	      enabled = false;
	    }
	  }
	  var perfHooks, performanceImpl, nullTimer, enabled, timeorigin, marks, counts, durations;
	  var init_performance = __esm({
	    "src/compiler/performance.ts"() {
	      init_ts2();
	      nullTimer = { enter: noop, exit: noop };
	      enabled = false;
	      timeorigin = timestamp();
	      marks = /* @__PURE__ */ new Map();
	      counts = /* @__PURE__ */ new Map();
	      durations = /* @__PURE__ */ new Map();
	    }
	  });

	  // src/compiler/_namespaces/ts.performance.ts
	  var ts_performance_exports = {};
	  __export(ts_performance_exports, {
	    clearMarks: () => clearMarks,
	    clearMeasures: () => clearMeasures,
	    createTimer: () => createTimer,
	    createTimerIf: () => createTimerIf,
	    disable: () => disable,
	    enable: () => enable,
	    forEachMark: () => forEachMark,
	    forEachMeasure: () => forEachMeasure,
	    getCount: () => getCount,
	    getDuration: () => getDuration,
	    isEnabled: () => isEnabled,
	    mark: () => mark,
	    measure: () => measure,
	    nullTimer: () => nullTimer
	  });
	  var init_ts_performance = __esm({
	    "src/compiler/_namespaces/ts.performance.ts"() {
	      init_performance();
	    }
	  });

	  // src/compiler/tracing.ts
	  var tracing, tracingEnabled, startTracing, dumpTracingLegend;
	  var init_tracing = __esm({
	    "src/compiler/tracing.ts"() {
	      init_ts2();
	      init_ts_performance();
	      ((tracingEnabled2) => {
	        let fs;
	        let traceCount = 0;
	        let traceFd = 0;
	        let mode;
	        const typeCatalog = [];
	        let legendPath;
	        const legend = [];
	        function startTracing2(tracingMode, traceDir, configFilePath) {
	          Debug.assert(!tracing, "Tracing already started");
	          if (fs === void 0) {
	            try {
	              fs = require("fs");
	            } catch (e) {
	              throw new Error(`tracing requires having fs
(original error: ${e.message || e})`);
	            }
	          }
	          mode = tracingMode;
	          typeCatalog.length = 0;
	          if (legendPath === void 0) {
	            legendPath = combinePaths(traceDir, "legend.json");
	          }
	          if (!fs.existsSync(traceDir)) {
	            fs.mkdirSync(traceDir, { recursive: true });
	          }
	          const countPart = mode === "build" ? `.${process.pid}-${++traceCount}` : mode === "server" ? `.${process.pid}` : ``;
	          const tracePath = combinePaths(traceDir, `trace${countPart}.json`);
	          const typesPath = combinePaths(traceDir, `types${countPart}.json`);
	          legend.push({
	            configFilePath,
	            tracePath,
	            typesPath
	          });
	          traceFd = fs.openSync(tracePath, "w");
	          tracing = tracingEnabled2;
	          const meta = { cat: "__metadata", ph: "M", ts: 1e3 * timestamp(), pid: 1, tid: 1 };
	          fs.writeSync(
	            traceFd,
	            "[\n" + [{ name: "process_name", args: { name: "tsc" }, ...meta }, { name: "thread_name", args: { name: "Main" }, ...meta }, { name: "TracingStartedInBrowser", ...meta, cat: "disabled-by-default-devtools.timeline" }].map((v) => JSON.stringify(v)).join(",\n")
	          );
	        }
	        tracingEnabled2.startTracing = startTracing2;
	        function stopTracing() {
	          Debug.assert(tracing, "Tracing is not in progress");
	          Debug.assert(!!typeCatalog.length === (mode !== "server"));
	          fs.writeSync(traceFd, `
]
`);
	          fs.closeSync(traceFd);
	          tracing = void 0;
	          if (typeCatalog.length) {
	            dumpTypes(typeCatalog);
	          } else {
	            legend[legend.length - 1].typesPath = void 0;
	          }
	        }
	        tracingEnabled2.stopTracing = stopTracing;
	        function recordType(type) {
	          if (mode !== "server") {
	            typeCatalog.push(type);
	          }
	        }
	        tracingEnabled2.recordType = recordType;
	        ((Phase2) => {
	          Phase2["Parse"] = "parse";
	          Phase2["Program"] = "program";
	          Phase2["Bind"] = "bind";
	          Phase2["Check"] = "check";
	          Phase2["CheckTypes"] = "checkTypes";
	          Phase2["Emit"] = "emit";
	          Phase2["Session"] = "session";
	        })(tracingEnabled2.Phase || (tracingEnabled2.Phase = {}));
	        function instant(phase, name, args) {
	          writeEvent("I", phase, name, args, `"s":"g"`);
	        }
	        tracingEnabled2.instant = instant;
	        const eventStack = [];
	        function push(phase, name, args, separateBeginAndEnd = false) {
	          if (separateBeginAndEnd) {
	            writeEvent("B", phase, name, args);
	          }
	          eventStack.push({ phase, name, args, time: 1e3 * timestamp(), separateBeginAndEnd });
	        }
	        tracingEnabled2.push = push;
	        function pop(results) {
	          Debug.assert(eventStack.length > 0);
	          writeStackEvent(eventStack.length - 1, 1e3 * timestamp(), results);
	          eventStack.length--;
	        }
	        tracingEnabled2.pop = pop;
	        function popAll() {
	          const endTime = 1e3 * timestamp();
	          for (let i = eventStack.length - 1; i >= 0; i--) {
	            writeStackEvent(i, endTime);
	          }
	          eventStack.length = 0;
	        }
	        tracingEnabled2.popAll = popAll;
	        const sampleInterval = 1e3 * 10;
	        function writeStackEvent(index, endTime, results) {
	          const { phase, name, args, time, separateBeginAndEnd } = eventStack[index];
	          if (separateBeginAndEnd) {
	            Debug.assert(!results, "`results` are not supported for events with `separateBeginAndEnd`");
	            writeEvent(
	              "E",
	              phase,
	              name,
	              args,
	              /*extras*/
	              void 0,
	              endTime
	            );
	          } else if (sampleInterval - time % sampleInterval <= endTime - time) {
	            writeEvent("X", phase, name, { ...args, results }, `"dur":${endTime - time}`, time);
	          }
	        }
	        function writeEvent(eventType, phase, name, args, extras, time = 1e3 * timestamp()) {
	          if (mode === "server" && phase === "checkTypes" /* CheckTypes */)
	            return;
	          mark("beginTracing");
	          fs.writeSync(traceFd, `,
{"pid":1,"tid":1,"ph":"${eventType}","cat":"${phase}","ts":${time},"name":"${name}"`);
	          if (extras)
	            fs.writeSync(traceFd, `,${extras}`);
	          if (args)
	            fs.writeSync(traceFd, `,"args":${JSON.stringify(args)}`);
	          fs.writeSync(traceFd, `}`);
	          mark("endTracing");
	          measure("Tracing", "beginTracing", "endTracing");
	        }
	        function getLocation(node) {
	          const file = getSourceFileOfNode(node);
	          return !file ? void 0 : {
	            path: file.path,
	            start: indexFromOne(getLineAndCharacterOfPosition(file, node.pos)),
	            end: indexFromOne(getLineAndCharacterOfPosition(file, node.end))
	          };
	          function indexFromOne(lc) {
	            return {
	              line: lc.line + 1,
	              character: lc.character + 1
	            };
	          }
	        }
	        function dumpTypes(types) {
	          var _a, _b, _c, _d, _e, _f, _g, _h, _i, _j, _k, _l, _m, _n, _o, _p, _q, _r, _s;
	          mark("beginDumpTypes");
	          const typesPath = legend[legend.length - 1].typesPath;
	          const typesFd = fs.openSync(typesPath, "w");
	          const recursionIdentityMap = /* @__PURE__ */ new Map();
	          fs.writeSync(typesFd, "[");
	          const numTypes = types.length;
	          for (let i = 0; i < numTypes; i++) {
	            const type = types[i];
	            const objectFlags = type.objectFlags;
	            const symbol = type.aliasSymbol ?? type.symbol;
	            let display;
	            if (objectFlags & 16 /* Anonymous */ | type.flags & 2944 /* Literal */) {
	              try {
	                display = (_a = type.checker) == null ? void 0 : _a.typeToString(type);
	              } catch {
	                display = void 0;
	              }
	            }
	            let indexedAccessProperties = {};
	            if (type.flags & 8388608 /* IndexedAccess */) {
	              const indexedAccessType = type;
	              indexedAccessProperties = {
	                indexedAccessObjectType: (_b = indexedAccessType.objectType) == null ? void 0 : _b.id,
	                indexedAccessIndexType: (_c = indexedAccessType.indexType) == null ? void 0 : _c.id
	              };
	            }
	            let referenceProperties = {};
	            if (objectFlags & 4 /* Reference */) {
	              const referenceType = type;
	              referenceProperties = {
	                instantiatedType: (_d = referenceType.target) == null ? void 0 : _d.id,
	                typeArguments: (_e = referenceType.resolvedTypeArguments) == null ? void 0 : _e.map((t) => t.id),
	                referenceLocation: getLocation(referenceType.node)
	              };
	            }
	            let conditionalProperties = {};
	            if (type.flags & 16777216 /* Conditional */) {
	              const conditionalType = type;
	              conditionalProperties = {
	                conditionalCheckType: (_f = conditionalType.checkType) == null ? void 0 : _f.id,
	                conditionalExtendsType: (_g = conditionalType.extendsType) == null ? void 0 : _g.id,
	                conditionalTrueType: ((_h = conditionalType.resolvedTrueType) == null ? void 0 : _h.id) ?? -1,
	                conditionalFalseType: ((_i = conditionalType.resolvedFalseType) == null ? void 0 : _i.id) ?? -1
	              };
	            }
	            let substitutionProperties = {};
	            if (type.flags & 33554432 /* Substitution */) {
	              const substitutionType = type;
	              substitutionProperties = {
	                substitutionBaseType: (_j = substitutionType.baseType) == null ? void 0 : _j.id,
	                constraintType: (_k = substitutionType.constraint) == null ? void 0 : _k.id
	              };
	            }
	            let reverseMappedProperties = {};
	            if (objectFlags & 1024 /* ReverseMapped */) {
	              const reverseMappedType = type;
	              reverseMappedProperties = {
	                reverseMappedSourceType: (_l = reverseMappedType.source) == null ? void 0 : _l.id,
	                reverseMappedMappedType: (_m = reverseMappedType.mappedType) == null ? void 0 : _m.id,
	                reverseMappedConstraintType: (_n = reverseMappedType.constraintType) == null ? void 0 : _n.id
	              };
	            }
	            let evolvingArrayProperties = {};
	            if (objectFlags & 256 /* EvolvingArray */) {
	              const evolvingArrayType = type;
	              evolvingArrayProperties = {
	                evolvingArrayElementType: evolvingArrayType.elementType.id,
	                evolvingArrayFinalType: (_o = evolvingArrayType.finalArrayType) == null ? void 0 : _o.id
	              };
	            }
	            let recursionToken;
	            const recursionIdentity = type.checker.getRecursionIdentity(type);
	            if (recursionIdentity) {
	              recursionToken = recursionIdentityMap.get(recursionIdentity);
	              if (!recursionToken) {
	                recursionToken = recursionIdentityMap.size;
	                recursionIdentityMap.set(recursionIdentity, recursionToken);
	              }
	            }
	            const descriptor = {
	              id: type.id,
	              intrinsicName: type.intrinsicName,
	              symbolName: (symbol == null ? void 0 : symbol.escapedName) && unescapeLeadingUnderscores(symbol.escapedName),
	              recursionId: recursionToken,
	              isTuple: objectFlags & 8 /* Tuple */ ? true : void 0,
	              unionTypes: type.flags & 1048576 /* Union */ ? (_p = type.types) == null ? void 0 : _p.map((t) => t.id) : void 0,
	              intersectionTypes: type.flags & 2097152 /* Intersection */ ? type.types.map((t) => t.id) : void 0,
	              aliasTypeArguments: (_q = type.aliasTypeArguments) == null ? void 0 : _q.map((t) => t.id),
	              keyofType: type.flags & 4194304 /* Index */ ? (_r = type.type) == null ? void 0 : _r.id : void 0,
	              ...indexedAccessProperties,
	              ...referenceProperties,
	              ...conditionalProperties,
	              ...substitutionProperties,
	              ...reverseMappedProperties,
	              ...evolvingArrayProperties,
	              destructuringPattern: getLocation(type.pattern),
	              firstDeclaration: getLocation((_s = symbol == null ? void 0 : symbol.declarations) == null ? void 0 : _s[0]),
	              flags: Debug.formatTypeFlags(type.flags).split("|"),
	              display
	            };
	            fs.writeSync(typesFd, JSON.stringify(descriptor));
	            if (i < numTypes - 1) {
	              fs.writeSync(typesFd, ",\n");
	            }
	          }
	          fs.writeSync(typesFd, "]\n");
	          fs.closeSync(typesFd);
	          mark("endDumpTypes");
	          measure("Dump types", "beginDumpTypes", "endDumpTypes");
	        }
	        function dumpLegend() {
	          if (!legendPath) {
	            return;
	          }
	          fs.writeFileSync(legendPath, JSON.stringify(legend));
	        }
	        tracingEnabled2.dumpLegend = dumpLegend;
	      })(tracingEnabled || (tracingEnabled = {}));
	      startTracing = tracingEnabled.startTracing;
	      dumpTracingLegend = tracingEnabled.dumpLegend;
	    }
	  });

	  // src/compiler/types.ts
	  function diagnosticCategoryName(d, lowerCase = true) {
	    const name = DiagnosticCategory[d.category];
	    return lowerCase ? name.toLowerCase() : name;
	  }
	  var SyntaxKind, NodeFlags, ModifierFlags, JsxFlags, RelationComparisonResult, GeneratedIdentifierFlags, TokenFlags, FlowFlags, CommentDirectiveType, OperationCanceledException, FileIncludeKind, FilePreprocessingDiagnosticsKind, EmitOnly, StructureIsReused, ExitStatus, MemberOverrideStatus, UnionReduction, ContextFlags, NodeBuilderFlags, TypeFormatFlags, SymbolFormatFlags, SymbolAccessibility, SyntheticSymbolKind, TypePredicateKind, TypeReferenceSerializationKind, SymbolFlags, EnumKind, CheckFlags, InternalSymbolName, NodeCheckFlags, TypeFlags, ObjectFlags, VarianceFlags, ElementFlags, AccessFlags, IndexFlags, JsxReferenceKind, SignatureKind, SignatureFlags, IndexKind, TypeMapKind, InferencePriority, InferenceFlags, Ternary, AssignmentDeclarationKind, DiagnosticCategory, ModuleResolutionKind, ModuleDetectionKind, WatchFileKind, WatchDirectoryKind, PollingWatchKind, ModuleKind, JsxEmit, ImportsNotUsedAsValues, NewLineKind, ScriptKind, ScriptTarget, LanguageVariant, WatchDirectoryFlags, CharacterCodes, Extension, TransformFlags, SnippetKind, EmitFlags, InternalEmitFlags, ExternalEmitHelpers, EmitHint, OuterExpressionKinds, LexicalEnvironmentFlags, BundleFileSectionKind, ListFormat, PragmaKindFlags, commentPragmas, JSDocParsingMode;
	  var init_types = __esm({
	    "src/compiler/types.ts"() {
	      SyntaxKind = /* @__PURE__ */ ((SyntaxKind5) => {
	        SyntaxKind5[SyntaxKind5["Unknown"] = 0] = "Unknown";
	        SyntaxKind5[SyntaxKind5["EndOfFileToken"] = 1] = "EndOfFileToken";
	        SyntaxKind5[SyntaxKind5["SingleLineCommentTrivia"] = 2] = "SingleLineCommentTrivia";
	        SyntaxKind5[SyntaxKind5["MultiLineCommentTrivia"] = 3] = "MultiLineCommentTrivia";
	        SyntaxKind5[SyntaxKind5["NewLineTrivia"] = 4] = "NewLineTrivia";
	        SyntaxKind5[SyntaxKind5["WhitespaceTrivia"] = 5] = "WhitespaceTrivia";
	        SyntaxKind5[SyntaxKind5["ShebangTrivia"] = 6] = "ShebangTrivia";
	        SyntaxKind5[SyntaxKind5["ConflictMarkerTrivia"] = 7] = "ConflictMarkerTrivia";
	        SyntaxKind5[SyntaxKind5["NonTextFileMarkerTrivia"] = 8] = "NonTextFileMarkerTrivia";
	        SyntaxKind5[SyntaxKind5["NumericLiteral"] = 9] = "NumericLiteral";
	        SyntaxKind5[SyntaxKind5["BigIntLiteral"] = 10] = "BigIntLiteral";
	        SyntaxKind5[SyntaxKind5["StringLiteral"] = 11] = "StringLiteral";
	        SyntaxKind5[SyntaxKind5["JsxText"] = 12] = "JsxText";
	        SyntaxKind5[SyntaxKind5["JsxTextAllWhiteSpaces"] = 13] = "JsxTextAllWhiteSpaces";
	        SyntaxKind5[SyntaxKind5["RegularExpressionLiteral"] = 14] = "RegularExpressionLiteral";
	        SyntaxKind5[SyntaxKind5["NoSubstitutionTemplateLiteral"] = 15] = "NoSubstitutionTemplateLiteral";
	        SyntaxKind5[SyntaxKind5["TemplateHead"] = 16] = "TemplateHead";
	        SyntaxKind5[SyntaxKind5["TemplateMiddle"] = 17] = "TemplateMiddle";
	        SyntaxKind5[SyntaxKind5["TemplateTail"] = 18] = "TemplateTail";
	        SyntaxKind5[SyntaxKind5["OpenBraceToken"] = 19] = "OpenBraceToken";
	        SyntaxKind5[SyntaxKind5["CloseBraceToken"] = 20] = "CloseBraceToken";
	        SyntaxKind5[SyntaxKind5["OpenParenToken"] = 21] = "OpenParenToken";
	        SyntaxKind5[SyntaxKind5["CloseParenToken"] = 22] = "CloseParenToken";
	        SyntaxKind5[SyntaxKind5["OpenBracketToken"] = 23] = "OpenBracketToken";
	        SyntaxKind5[SyntaxKind5["CloseBracketToken"] = 24] = "CloseBracketToken";
	        SyntaxKind5[SyntaxKind5["DotToken"] = 25] = "DotToken";
	        SyntaxKind5[SyntaxKind5["DotDotDotToken"] = 26] = "DotDotDotToken";
	        SyntaxKind5[SyntaxKind5["SemicolonToken"] = 27] = "SemicolonToken";
	        SyntaxKind5[SyntaxKind5["CommaToken"] = 28] = "CommaToken";
	        SyntaxKind5[SyntaxKind5["QuestionDotToken"] = 29] = "QuestionDotToken";
	        SyntaxKind5[SyntaxKind5["LessThanToken"] = 30] = "LessThanToken";
	        SyntaxKind5[SyntaxKind5["LessThanSlashToken"] = 31] = "LessThanSlashToken";
	        SyntaxKind5[SyntaxKind5["GreaterThanToken"] = 32] = "GreaterThanToken";
	        SyntaxKind5[SyntaxKind5["LessThanEqualsToken"] = 33] = "LessThanEqualsToken";
	        SyntaxKind5[SyntaxKind5["GreaterThanEqualsToken"] = 34] = "GreaterThanEqualsToken";
	        SyntaxKind5[SyntaxKind5["EqualsEqualsToken"] = 35] = "EqualsEqualsToken";
	        SyntaxKind5[SyntaxKind5["ExclamationEqualsToken"] = 36] = "ExclamationEqualsToken";
	        SyntaxKind5[SyntaxKind5["EqualsEqualsEqualsToken"] = 37] = "EqualsEqualsEqualsToken";
	        SyntaxKind5[SyntaxKind5["ExclamationEqualsEqualsToken"] = 38] = "ExclamationEqualsEqualsToken";
	        SyntaxKind5[SyntaxKind5["EqualsGreaterThanToken"] = 39] = "EqualsGreaterThanToken";
	        SyntaxKind5[SyntaxKind5["PlusToken"] = 40] = "PlusToken";
	        SyntaxKind5[SyntaxKind5["MinusToken"] = 41] = "MinusToken";
	        SyntaxKind5[SyntaxKind5["AsteriskToken"] = 42] = "AsteriskToken";
	        SyntaxKind5[SyntaxKind5["AsteriskAsteriskToken"] = 43] = "AsteriskAsteriskToken";
	        SyntaxKind5[SyntaxKind5["SlashToken"] = 44] = "SlashToken";
	        SyntaxKind5[SyntaxKind5["PercentToken"] = 45] = "PercentToken";
	        SyntaxKind5[SyntaxKind5["PlusPlusToken"] = 46] = "PlusPlusToken";
	        SyntaxKind5[SyntaxKind5["MinusMinusToken"] = 47] = "MinusMinusToken";
	        SyntaxKind5[SyntaxKind5["LessThanLessThanToken"] = 48] = "LessThanLessThanToken";
	        SyntaxKind5[SyntaxKind5["GreaterThanGreaterThanToken"] = 49] = "GreaterThanGreaterThanToken";
	        SyntaxKind5[SyntaxKind5["GreaterThanGreaterThanGreaterThanToken"] = 50] = "GreaterThanGreaterThanGreaterThanToken";
	        SyntaxKind5[SyntaxKind5["AmpersandToken"] = 51] = "AmpersandToken";
	        SyntaxKind5[SyntaxKind5["BarToken"] = 52] = "BarToken";
	        SyntaxKind5[SyntaxKind5["CaretToken"] = 53] = "CaretToken";
	        SyntaxKind5[SyntaxKind5["ExclamationToken"] = 54] = "ExclamationToken";
	        SyntaxKind5[SyntaxKind5["TildeToken"] = 55] = "TildeToken";
	        SyntaxKind5[SyntaxKind5["AmpersandAmpersandToken"] = 56] = "AmpersandAmpersandToken";
	        SyntaxKind5[SyntaxKind5["BarBarToken"] = 57] = "BarBarToken";
	        SyntaxKind5[SyntaxKind5["QuestionToken"] = 58] = "QuestionToken";
	        SyntaxKind5[SyntaxKind5["ColonToken"] = 59] = "ColonToken";
	        SyntaxKind5[SyntaxKind5["AtToken"] = 60] = "AtToken";
	        SyntaxKind5[SyntaxKind5["QuestionQuestionToken"] = 61] = "QuestionQuestionToken";
	        SyntaxKind5[SyntaxKind5["BacktickToken"] = 62] = "BacktickToken";
	        SyntaxKind5[SyntaxKind5["HashToken"] = 63] = "HashToken";
	        SyntaxKind5[SyntaxKind5["EqualsToken"] = 64] = "EqualsToken";
	        SyntaxKind5[SyntaxKind5["PlusEqualsToken"] = 65] = "PlusEqualsToken";
	        SyntaxKind5[SyntaxKind5["MinusEqualsToken"] = 66] = "MinusEqualsToken";
	        SyntaxKind5[SyntaxKind5["AsteriskEqualsToken"] = 67] = "AsteriskEqualsToken";
	        SyntaxKind5[SyntaxKind5["AsteriskAsteriskEqualsToken"] = 68] = "AsteriskAsteriskEqualsToken";
	        SyntaxKind5[SyntaxKind5["SlashEqualsToken"] = 69] = "SlashEqualsToken";
	        SyntaxKind5[SyntaxKind5["PercentEqualsToken"] = 70] = "PercentEqualsToken";
	        SyntaxKind5[SyntaxKind5["LessThanLessThanEqualsToken"] = 71] = "LessThanLessThanEqualsToken";
	        SyntaxKind5[SyntaxKind5["GreaterThanGreaterThanEqualsToken"] = 72] = "GreaterThanGreaterThanEqualsToken";
	        SyntaxKind5[SyntaxKind5["GreaterThanGreaterThanGreaterThanEqualsToken"] = 73] = "GreaterThanGreaterThanGreaterThanEqualsToken";
	        SyntaxKind5[SyntaxKind5["AmpersandEqualsToken"] = 74] = "AmpersandEqualsToken";
	        SyntaxKind5[SyntaxKind5["BarEqualsToken"] = 75] = "BarEqualsToken";
	        SyntaxKind5[SyntaxKind5["BarBarEqualsToken"] = 76] = "BarBarEqualsToken";
	        SyntaxKind5[SyntaxKind5["AmpersandAmpersandEqualsToken"] = 77] = "AmpersandAmpersandEqualsToken";
	        SyntaxKind5[SyntaxKind5["QuestionQuestionEqualsToken"] = 78] = "QuestionQuestionEqualsToken";
	        SyntaxKind5[SyntaxKind5["CaretEqualsToken"] = 79] = "CaretEqualsToken";
	        SyntaxKind5[SyntaxKind5["Identifier"] = 80] = "Identifier";
	        SyntaxKind5[SyntaxKind5["PrivateIdentifier"] = 81] = "PrivateIdentifier";
	        SyntaxKind5[SyntaxKind5["JSDocCommentTextToken"] = 82] = "JSDocCommentTextToken";
	        SyntaxKind5[SyntaxKind5["BreakKeyword"] = 83] = "BreakKeyword";
	        SyntaxKind5[SyntaxKind5["CaseKeyword"] = 84] = "CaseKeyword";
	        SyntaxKind5[SyntaxKind5["CatchKeyword"] = 85] = "CatchKeyword";
	        SyntaxKind5[SyntaxKind5["ClassKeyword"] = 86] = "ClassKeyword";
	        SyntaxKind5[SyntaxKind5["ConstKeyword"] = 87] = "ConstKeyword";
	        SyntaxKind5[SyntaxKind5["ContinueKeyword"] = 88] = "ContinueKeyword";
	        SyntaxKind5[SyntaxKind5["DebuggerKeyword"] = 89] = "DebuggerKeyword";
	        SyntaxKind5[SyntaxKind5["DefaultKeyword"] = 90] = "DefaultKeyword";
	        SyntaxKind5[SyntaxKind5["DeleteKeyword"] = 91] = "DeleteKeyword";
	        SyntaxKind5[SyntaxKind5["DoKeyword"] = 92] = "DoKeyword";
	        SyntaxKind5[SyntaxKind5["ElseKeyword"] = 93] = "ElseKeyword";
	        SyntaxKind5[SyntaxKind5["EnumKeyword"] = 94] = "EnumKeyword";
	        SyntaxKind5[SyntaxKind5["ExportKeyword"] = 95] = "ExportKeyword";
	        SyntaxKind5[SyntaxKind5["ExtendsKeyword"] = 96] = "ExtendsKeyword";
	        SyntaxKind5[SyntaxKind5["FalseKeyword"] = 97] = "FalseKeyword";
	        SyntaxKind5[SyntaxKind5["FinallyKeyword"] = 98] = "FinallyKeyword";
	        SyntaxKind5[SyntaxKind5["ForKeyword"] = 99] = "ForKeyword";
	        SyntaxKind5[SyntaxKind5["FunctionKeyword"] = 100] = "FunctionKeyword";
	        SyntaxKind5[SyntaxKind5["IfKeyword"] = 101] = "IfKeyword";
	        SyntaxKind5[SyntaxKind5["ImportKeyword"] = 102] = "ImportKeyword";
	        SyntaxKind5[SyntaxKind5["InKeyword"] = 103] = "InKeyword";
	        SyntaxKind5[SyntaxKind5["InstanceOfKeyword"] = 104] = "InstanceOfKeyword";
	        SyntaxKind5[SyntaxKind5["NewKeyword"] = 105] = "NewKeyword";
	        SyntaxKind5[SyntaxKind5["NullKeyword"] = 106] = "NullKeyword";
	        SyntaxKind5[SyntaxKind5["ReturnKeyword"] = 107] = "ReturnKeyword";
	        SyntaxKind5[SyntaxKind5["SuperKeyword"] = 108] = "SuperKeyword";
	        SyntaxKind5[SyntaxKind5["SwitchKeyword"] = 109] = "SwitchKeyword";
	        SyntaxKind5[SyntaxKind5["ThisKeyword"] = 110] = "ThisKeyword";
	        SyntaxKind5[SyntaxKind5["ThrowKeyword"] = 111] = "ThrowKeyword";
	        SyntaxKind5[SyntaxKind5["TrueKeyword"] = 112] = "TrueKeyword";
	        SyntaxKind5[SyntaxKind5["TryKeyword"] = 113] = "TryKeyword";
	        SyntaxKind5[SyntaxKind5["TypeOfKeyword"] = 114] = "TypeOfKeyword";
	        SyntaxKind5[SyntaxKind5["VarKeyword"] = 115] = "VarKeyword";
	        SyntaxKind5[SyntaxKind5["VoidKeyword"] = 116] = "VoidKeyword";
	        SyntaxKind5[SyntaxKind5["WhileKeyword"] = 117] = "WhileKeyword";
	        SyntaxKind5[SyntaxKind5["WithKeyword"] = 118] = "WithKeyword";
	        SyntaxKind5[SyntaxKind5["ImplementsKeyword"] = 119] = "ImplementsKeyword";
	        SyntaxKind5[SyntaxKind5["InterfaceKeyword"] = 120] = "InterfaceKeyword";
	        SyntaxKind5[SyntaxKind5["LetKeyword"] = 121] = "LetKeyword";
	        SyntaxKind5[SyntaxKind5["PackageKeyword"] = 122] = "PackageKeyword";
	        SyntaxKind5[SyntaxKind5["PrivateKeyword"] = 123] = "PrivateKeyword";
	        SyntaxKind5[SyntaxKind5["ProtectedKeyword"] = 124] = "ProtectedKeyword";
	        SyntaxKind5[SyntaxKind5["PublicKeyword"] = 125] = "PublicKeyword";
	        SyntaxKind5[SyntaxKind5["StaticKeyword"] = 126] = "StaticKeyword";
	        SyntaxKind5[SyntaxKind5["YieldKeyword"] = 127] = "YieldKeyword";
	        SyntaxKind5[SyntaxKind5["AbstractKeyword"] = 128] = "AbstractKeyword";
	        SyntaxKind5[SyntaxKind5["AccessorKeyword"] = 129] = "AccessorKeyword";
	        SyntaxKind5[SyntaxKind5["AsKeyword"] = 130] = "AsKeyword";
	        SyntaxKind5[SyntaxKind5["AssertsKeyword"] = 131] = "AssertsKeyword";
	        SyntaxKind5[SyntaxKind5["AssertKeyword"] = 132] = "AssertKeyword";
	        SyntaxKind5[SyntaxKind5["AnyKeyword"] = 133] = "AnyKeyword";
	        SyntaxKind5[SyntaxKind5["AsyncKeyword"] = 134] = "AsyncKeyword";
	        SyntaxKind5[SyntaxKind5["AwaitKeyword"] = 135] = "AwaitKeyword";
	        SyntaxKind5[SyntaxKind5["BooleanKeyword"] = 136] = "BooleanKeyword";
	        SyntaxKind5[SyntaxKind5["ConstructorKeyword"] = 137] = "ConstructorKeyword";
	        SyntaxKind5[SyntaxKind5["DeclareKeyword"] = 138] = "DeclareKeyword";
	        SyntaxKind5[SyntaxKind5["GetKeyword"] = 139] = "GetKeyword";
	        SyntaxKind5[SyntaxKind5["InferKeyword"] = 140] = "InferKeyword";
	        SyntaxKind5[SyntaxKind5["IntrinsicKeyword"] = 141] = "IntrinsicKeyword";
	        SyntaxKind5[SyntaxKind5["IsKeyword"] = 142] = "IsKeyword";
	        SyntaxKind5[SyntaxKind5["KeyOfKeyword"] = 143] = "KeyOfKeyword";
	        SyntaxKind5[SyntaxKind5["ModuleKeyword"] = 144] = "ModuleKeyword";
	        SyntaxKind5[SyntaxKind5["NamespaceKeyword"] = 145] = "NamespaceKeyword";
	        SyntaxKind5[SyntaxKind5["NeverKeyword"] = 146] = "NeverKeyword";
	        SyntaxKind5[SyntaxKind5["OutKeyword"] = 147] = "OutKeyword";
	        SyntaxKind5[SyntaxKind5["ReadonlyKeyword"] = 148] = "ReadonlyKeyword";
	        SyntaxKind5[SyntaxKind5["RequireKeyword"] = 149] = "RequireKeyword";
	        SyntaxKind5[SyntaxKind5["NumberKeyword"] = 150] = "NumberKeyword";
	        SyntaxKind5[SyntaxKind5["ObjectKeyword"] = 151] = "ObjectKeyword";
	        SyntaxKind5[SyntaxKind5["SatisfiesKeyword"] = 152] = "SatisfiesKeyword";
	        SyntaxKind5[SyntaxKind5["SetKeyword"] = 153] = "SetKeyword";
	        SyntaxKind5[SyntaxKind5["StringKeyword"] = 154] = "StringKeyword";
	        SyntaxKind5[SyntaxKind5["SymbolKeyword"] = 155] = "SymbolKeyword";
	        SyntaxKind5[SyntaxKind5["TypeKeyword"] = 156] = "TypeKeyword";
	        SyntaxKind5[SyntaxKind5["UndefinedKeyword"] = 157] = "UndefinedKeyword";
	        SyntaxKind5[SyntaxKind5["UniqueKeyword"] = 158] = "UniqueKeyword";
	        SyntaxKind5[SyntaxKind5["UnknownKeyword"] = 159] = "UnknownKeyword";
	        SyntaxKind5[SyntaxKind5["UsingKeyword"] = 160] = "UsingKeyword";
	        SyntaxKind5[SyntaxKind5["FromKeyword"] = 161] = "FromKeyword";
	        SyntaxKind5[SyntaxKind5["GlobalKeyword"] = 162] = "GlobalKeyword";
	        SyntaxKind5[SyntaxKind5["BigIntKeyword"] = 163] = "BigIntKeyword";
	        SyntaxKind5[SyntaxKind5["OverrideKeyword"] = 164] = "OverrideKeyword";
	        SyntaxKind5[SyntaxKind5["OfKeyword"] = 165] = "OfKeyword";
	        SyntaxKind5[SyntaxKind5["QualifiedName"] = 166] = "QualifiedName";
	        SyntaxKind5[SyntaxKind5["ComputedPropertyName"] = 167] = "ComputedPropertyName";
	        SyntaxKind5[SyntaxKind5["TypeParameter"] = 168] = "TypeParameter";
	        SyntaxKind5[SyntaxKind5["Parameter"] = 169] = "Parameter";
	        SyntaxKind5[SyntaxKind5["Decorator"] = 170] = "Decorator";
	        SyntaxKind5[SyntaxKind5["PropertySignature"] = 171] = "PropertySignature";
	        SyntaxKind5[SyntaxKind5["PropertyDeclaration"] = 172] = "PropertyDeclaration";
	        SyntaxKind5[SyntaxKind5["MethodSignature"] = 173] = "MethodSignature";
	        SyntaxKind5[SyntaxKind5["MethodDeclaration"] = 174] = "MethodDeclaration";
	        SyntaxKind5[SyntaxKind5["ClassStaticBlockDeclaration"] = 175] = "ClassStaticBlockDeclaration";
	        SyntaxKind5[SyntaxKind5["Constructor"] = 176] = "Constructor";
	        SyntaxKind5[SyntaxKind5["GetAccessor"] = 177] = "GetAccessor";
	        SyntaxKind5[SyntaxKind5["SetAccessor"] = 178] = "SetAccessor";
	        SyntaxKind5[SyntaxKind5["CallSignature"] = 179] = "CallSignature";
	        SyntaxKind5[SyntaxKind5["ConstructSignature"] = 180] = "ConstructSignature";
	        SyntaxKind5[SyntaxKind5["IndexSignature"] = 181] = "IndexSignature";
	        SyntaxKind5[SyntaxKind5["TypePredicate"] = 182] = "TypePredicate";
	        SyntaxKind5[SyntaxKind5["TypeReference"] = 183] = "TypeReference";
	        SyntaxKind5[SyntaxKind5["FunctionType"] = 184] = "FunctionType";
	        SyntaxKind5[SyntaxKind5["ConstructorType"] = 185] = "ConstructorType";
	        SyntaxKind5[SyntaxKind5["TypeQuery"] = 186] = "TypeQuery";
	        SyntaxKind5[SyntaxKind5["TypeLiteral"] = 187] = "TypeLiteral";
	        SyntaxKind5[SyntaxKind5["ArrayType"] = 188] = "ArrayType";
	        SyntaxKind5[SyntaxKind5["TupleType"] = 189] = "TupleType";
	        SyntaxKind5[SyntaxKind5["OptionalType"] = 190] = "OptionalType";
	        SyntaxKind5[SyntaxKind5["RestType"] = 191] = "RestType";
	        SyntaxKind5[SyntaxKind5["UnionType"] = 192] = "UnionType";
	        SyntaxKind5[SyntaxKind5["IntersectionType"] = 193] = "IntersectionType";
	        SyntaxKind5[SyntaxKind5["ConditionalType"] = 194] = "ConditionalType";
	        SyntaxKind5[SyntaxKind5["InferType"] = 195] = "InferType";
	        SyntaxKind5[SyntaxKind5["ParenthesizedType"] = 196] = "ParenthesizedType";
	        SyntaxKind5[SyntaxKind5["ThisType"] = 197] = "ThisType";
	        SyntaxKind5[SyntaxKind5["TypeOperator"] = 198] = "TypeOperator";
	        SyntaxKind5[SyntaxKind5["IndexedAccessType"] = 199] = "IndexedAccessType";
	        SyntaxKind5[SyntaxKind5["MappedType"] = 200] = "MappedType";
	        SyntaxKind5[SyntaxKind5["LiteralType"] = 201] = "LiteralType";
	        SyntaxKind5[SyntaxKind5["NamedTupleMember"] = 202] = "NamedTupleMember";
	        SyntaxKind5[SyntaxKind5["TemplateLiteralType"] = 203] = "TemplateLiteralType";
	        SyntaxKind5[SyntaxKind5["TemplateLiteralTypeSpan"] = 204] = "TemplateLiteralTypeSpan";
	        SyntaxKind5[SyntaxKind5["ImportType"] = 205] = "ImportType";
	        SyntaxKind5[SyntaxKind5["ObjectBindingPattern"] = 206] = "ObjectBindingPattern";
	        SyntaxKind5[SyntaxKind5["ArrayBindingPattern"] = 207] = "ArrayBindingPattern";
	        SyntaxKind5[SyntaxKind5["BindingElement"] = 208] = "BindingElement";
	        SyntaxKind5[SyntaxKind5["ArrayLiteralExpression"] = 209] = "ArrayLiteralExpression";
	        SyntaxKind5[SyntaxKind5["ObjectLiteralExpression"] = 210] = "ObjectLiteralExpression";
	        SyntaxKind5[SyntaxKind5["PropertyAccessExpression"] = 211] = "PropertyAccessExpression";
	        SyntaxKind5[SyntaxKind5["ElementAccessExpression"] = 212] = "ElementAccessExpression";
	        SyntaxKind5[SyntaxKind5["CallExpression"] = 213] = "CallExpression";
	        SyntaxKind5[SyntaxKind5["NewExpression"] = 214] = "NewExpression";
	        SyntaxKind5[SyntaxKind5["TaggedTemplateExpression"] = 215] = "TaggedTemplateExpression";
	        SyntaxKind5[SyntaxKind5["TypeAssertionExpression"] = 216] = "TypeAssertionExpression";
	        SyntaxKind5[SyntaxKind5["ParenthesizedExpression"] = 217] = "ParenthesizedExpression";
	        SyntaxKind5[SyntaxKind5["FunctionExpression"] = 218] = "FunctionExpression";
	        SyntaxKind5[SyntaxKind5["ArrowFunction"] = 219] = "ArrowFunction";
	        SyntaxKind5[SyntaxKind5["DeleteExpression"] = 220] = "DeleteExpression";
	        SyntaxKind5[SyntaxKind5["TypeOfExpression"] = 221] = "TypeOfExpression";
	        SyntaxKind5[SyntaxKind5["VoidExpression"] = 222] = "VoidExpression";
	        SyntaxKind5[SyntaxKind5["AwaitExpression"] = 223] = "AwaitExpression";
	        SyntaxKind5[SyntaxKind5["PrefixUnaryExpression"] = 224] = "PrefixUnaryExpression";
	        SyntaxKind5[SyntaxKind5["PostfixUnaryExpression"] = 225] = "PostfixUnaryExpression";
	        SyntaxKind5[SyntaxKind5["BinaryExpression"] = 226] = "BinaryExpression";
	        SyntaxKind5[SyntaxKind5["ConditionalExpression"] = 227] = "ConditionalExpression";
	        SyntaxKind5[SyntaxKind5["TemplateExpression"] = 228] = "TemplateExpression";
	        SyntaxKind5[SyntaxKind5["YieldExpression"] = 229] = "YieldExpression";
	        SyntaxKind5[SyntaxKind5["SpreadElement"] = 230] = "SpreadElement";
	        SyntaxKind5[SyntaxKind5["ClassExpression"] = 231] = "ClassExpression";
	        SyntaxKind5[SyntaxKind5["OmittedExpression"] = 232] = "OmittedExpression";
	        SyntaxKind5[SyntaxKind5["ExpressionWithTypeArguments"] = 233] = "ExpressionWithTypeArguments";
	        SyntaxKind5[SyntaxKind5["AsExpression"] = 234] = "AsExpression";
	        SyntaxKind5[SyntaxKind5["NonNullExpression"] = 235] = "NonNullExpression";
	        SyntaxKind5[SyntaxKind5["MetaProperty"] = 236] = "MetaProperty";
	        SyntaxKind5[SyntaxKind5["SyntheticExpression"] = 237] = "SyntheticExpression";
	        SyntaxKind5[SyntaxKind5["SatisfiesExpression"] = 238] = "SatisfiesExpression";
	        SyntaxKind5[SyntaxKind5["TemplateSpan"] = 239] = "TemplateSpan";
	        SyntaxKind5[SyntaxKind5["SemicolonClassElement"] = 240] = "SemicolonClassElement";
	        SyntaxKind5[SyntaxKind5["Block"] = 241] = "Block";
	        SyntaxKind5[SyntaxKind5["EmptyStatement"] = 242] = "EmptyStatement";
	        SyntaxKind5[SyntaxKind5["VariableStatement"] = 243] = "VariableStatement";
	        SyntaxKind5[SyntaxKind5["ExpressionStatement"] = 244] = "ExpressionStatement";
	        SyntaxKind5[SyntaxKind5["IfStatement"] = 245] = "IfStatement";
	        SyntaxKind5[SyntaxKind5["DoStatement"] = 246] = "DoStatement";
	        SyntaxKind5[SyntaxKind5["WhileStatement"] = 247] = "WhileStatement";
	        SyntaxKind5[SyntaxKind5["ForStatement"] = 248] = "ForStatement";
	        SyntaxKind5[SyntaxKind5["ForInStatement"] = 249] = "ForInStatement";
	        SyntaxKind5[SyntaxKind5["ForOfStatement"] = 250] = "ForOfStatement";
	        SyntaxKind5[SyntaxKind5["ContinueStatement"] = 251] = "ContinueStatement";
	        SyntaxKind5[SyntaxKind5["BreakStatement"] = 252] = "BreakStatement";
	        SyntaxKind5[SyntaxKind5["ReturnStatement"] = 253] = "ReturnStatement";
	        SyntaxKind5[SyntaxKind5["WithStatement"] = 254] = "WithStatement";
	        SyntaxKind5[SyntaxKind5["SwitchStatement"] = 255] = "SwitchStatement";
	        SyntaxKind5[SyntaxKind5["LabeledStatement"] = 256] = "LabeledStatement";
	        SyntaxKind5[SyntaxKind5["ThrowStatement"] = 257] = "ThrowStatement";
	        SyntaxKind5[SyntaxKind5["TryStatement"] = 258] = "TryStatement";
	        SyntaxKind5[SyntaxKind5["DebuggerStatement"] = 259] = "DebuggerStatement";
	        SyntaxKind5[SyntaxKind5["VariableDeclaration"] = 260] = "VariableDeclaration";
	        SyntaxKind5[SyntaxKind5["VariableDeclarationList"] = 261] = "VariableDeclarationList";
	        SyntaxKind5[SyntaxKind5["FunctionDeclaration"] = 262] = "FunctionDeclaration";
	        SyntaxKind5[SyntaxKind5["ClassDeclaration"] = 263] = "ClassDeclaration";
	        SyntaxKind5[SyntaxKind5["InterfaceDeclaration"] = 264] = "InterfaceDeclaration";
	        SyntaxKind5[SyntaxKind5["TypeAliasDeclaration"] = 265] = "TypeAliasDeclaration";
	        SyntaxKind5[SyntaxKind5["EnumDeclaration"] = 266] = "EnumDeclaration";
	        SyntaxKind5[SyntaxKind5["ModuleDeclaration"] = 267] = "ModuleDeclaration";
	        SyntaxKind5[SyntaxKind5["ModuleBlock"] = 268] = "ModuleBlock";
	        SyntaxKind5[SyntaxKind5["CaseBlock"] = 269] = "CaseBlock";
	        SyntaxKind5[SyntaxKind5["NamespaceExportDeclaration"] = 270] = "NamespaceExportDeclaration";
	        SyntaxKind5[SyntaxKind5["ImportEqualsDeclaration"] = 271] = "ImportEqualsDeclaration";
	        SyntaxKind5[SyntaxKind5["ImportDeclaration"] = 272] = "ImportDeclaration";
	        SyntaxKind5[SyntaxKind5["ImportClause"] = 273] = "ImportClause";
	        SyntaxKind5[SyntaxKind5["NamespaceImport"] = 274] = "NamespaceImport";
	        SyntaxKind5[SyntaxKind5["NamedImports"] = 275] = "NamedImports";
	        SyntaxKind5[SyntaxKind5["ImportSpecifier"] = 276] = "ImportSpecifier";
	        SyntaxKind5[SyntaxKind5["ExportAssignment"] = 277] = "ExportAssignment";
	        SyntaxKind5[SyntaxKind5["ExportDeclaration"] = 278] = "ExportDeclaration";
	        SyntaxKind5[SyntaxKind5["NamedExports"] = 279] = "NamedExports";
	        SyntaxKind5[SyntaxKind5["NamespaceExport"] = 280] = "NamespaceExport";
	        SyntaxKind5[SyntaxKind5["ExportSpecifier"] = 281] = "ExportSpecifier";
	        SyntaxKind5[SyntaxKind5["MissingDeclaration"] = 282] = "MissingDeclaration";
	        SyntaxKind5[SyntaxKind5["ExternalModuleReference"] = 283] = "ExternalModuleReference";
	        SyntaxKind5[SyntaxKind5["JsxElement"] = 284] = "JsxElement";
	        SyntaxKind5[SyntaxKind5["JsxSelfClosingElement"] = 285] = "JsxSelfClosingElement";
	        SyntaxKind5[SyntaxKind5["JsxOpeningElement"] = 286] = "JsxOpeningElement";
	        SyntaxKind5[SyntaxKind5["JsxClosingElement"] = 287] = "JsxClosingElement";
	        SyntaxKind5[SyntaxKind5["JsxFragment"] = 288] = "JsxFragment";
	        SyntaxKind5[SyntaxKind5["JsxOpeningFragment"] = 289] = "JsxOpeningFragment";
	        SyntaxKind5[SyntaxKind5["JsxClosingFragment"] = 290] = "JsxClosingFragment";
	        SyntaxKind5[SyntaxKind5["JsxAttribute"] = 291] = "JsxAttribute";
	        SyntaxKind5[SyntaxKind5["JsxAttributes"] = 292] = "JsxAttributes";
	        SyntaxKind5[SyntaxKind5["JsxSpreadAttribute"] = 293] = "JsxSpreadAttribute";
	        SyntaxKind5[SyntaxKind5["JsxExpression"] = 294] = "JsxExpression";
	        SyntaxKind5[SyntaxKind5["JsxNamespacedName"] = 295] = "JsxNamespacedName";
	        SyntaxKind5[SyntaxKind5["CaseClause"] = 296] = "CaseClause";
	        SyntaxKind5[SyntaxKind5["DefaultClause"] = 297] = "DefaultClause";
	        SyntaxKind5[SyntaxKind5["HeritageClause"] = 298] = "HeritageClause";
	        SyntaxKind5[SyntaxKind5["CatchClause"] = 299] = "CatchClause";
	        SyntaxKind5[SyntaxKind5["ImportAttributes"] = 300] = "ImportAttributes";
	        SyntaxKind5[SyntaxKind5["ImportAttribute"] = 301] = "ImportAttribute";
	        SyntaxKind5[SyntaxKind5["AssertClause"] = 300 /* ImportAttributes */] = "AssertClause";
	        SyntaxKind5[SyntaxKind5["AssertEntry"] = 301 /* ImportAttribute */] = "AssertEntry";
	        SyntaxKind5[SyntaxKind5["ImportTypeAssertionContainer"] = 302] = "ImportTypeAssertionContainer";
	        SyntaxKind5[SyntaxKind5["PropertyAssignment"] = 303] = "PropertyAssignment";
	        SyntaxKind5[SyntaxKind5["ShorthandPropertyAssignment"] = 304] = "ShorthandPropertyAssignment";
	        SyntaxKind5[SyntaxKind5["SpreadAssignment"] = 305] = "SpreadAssignment";
	        SyntaxKind5[SyntaxKind5["EnumMember"] = 306] = "EnumMember";
	        SyntaxKind5[SyntaxKind5["UnparsedPrologue"] = 307] = "UnparsedPrologue";
	        SyntaxKind5[SyntaxKind5["UnparsedPrepend"] = 308] = "UnparsedPrepend";
	        SyntaxKind5[SyntaxKind5["UnparsedText"] = 309] = "UnparsedText";
	        SyntaxKind5[SyntaxKind5["UnparsedInternalText"] = 310] = "UnparsedInternalText";
	        SyntaxKind5[SyntaxKind5["UnparsedSyntheticReference"] = 311] = "UnparsedSyntheticReference";
	        SyntaxKind5[SyntaxKind5["SourceFile"] = 312] = "SourceFile";
	        SyntaxKind5[SyntaxKind5["Bundle"] = 313] = "Bundle";
	        SyntaxKind5[SyntaxKind5["UnparsedSource"] = 314] = "UnparsedSource";
	        SyntaxKind5[SyntaxKind5["InputFiles"] = 315] = "InputFiles";
	        SyntaxKind5[SyntaxKind5["JSDocTypeExpression"] = 316] = "JSDocTypeExpression";
	        SyntaxKind5[SyntaxKind5["JSDocNameReference"] = 317] = "JSDocNameReference";
	        SyntaxKind5[SyntaxKind5["JSDocMemberName"] = 318] = "JSDocMemberName";
	        SyntaxKind5[SyntaxKind5["JSDocAllType"] = 319] = "JSDocAllType";
	        SyntaxKind5[SyntaxKind5["JSDocUnknownType"] = 320] = "JSDocUnknownType";
	        SyntaxKind5[SyntaxKind5["JSDocNullableType"] = 321] = "JSDocNullableType";
	        SyntaxKind5[SyntaxKind5["JSDocNonNullableType"] = 322] = "JSDocNonNullableType";
	        SyntaxKind5[SyntaxKind5["JSDocOptionalType"] = 323] = "JSDocOptionalType";
	        SyntaxKind5[SyntaxKind5["JSDocFunctionType"] = 324] = "JSDocFunctionType";
	        SyntaxKind5[SyntaxKind5["JSDocVariadicType"] = 325] = "JSDocVariadicType";
	        SyntaxKind5[SyntaxKind5["JSDocNamepathType"] = 326] = "JSDocNamepathType";
	        SyntaxKind5[SyntaxKind5["JSDoc"] = 327] = "JSDoc";
	        SyntaxKind5[SyntaxKind5["JSDocComment"] = 327 /* JSDoc */] = "JSDocComment";
	        SyntaxKind5[SyntaxKind5["JSDocText"] = 328] = "JSDocText";
	        SyntaxKind5[SyntaxKind5["JSDocTypeLiteral"] = 329] = "JSDocTypeLiteral";
	        SyntaxKind5[SyntaxKind5["JSDocSignature"] = 330] = "JSDocSignature";
	        SyntaxKind5[SyntaxKind5["JSDocLink"] = 331] = "JSDocLink";
	        SyntaxKind5[SyntaxKind5["JSDocLinkCode"] = 332] = "JSDocLinkCode";
	        SyntaxKind5[SyntaxKind5["JSDocLinkPlain"] = 333] = "JSDocLinkPlain";
	        SyntaxKind5[SyntaxKind5["JSDocTag"] = 334] = "JSDocTag";
	        SyntaxKind5[SyntaxKind5["JSDocAugmentsTag"] = 335] = "JSDocAugmentsTag";
	        SyntaxKind5[SyntaxKind5["JSDocImplementsTag"] = 336] = "JSDocImplementsTag";
	        SyntaxKind5[SyntaxKind5["JSDocAuthorTag"] = 337] = "JSDocAuthorTag";
	        SyntaxKind5[SyntaxKind5["JSDocDeprecatedTag"] = 338] = "JSDocDeprecatedTag";
	        SyntaxKind5[SyntaxKind5["JSDocClassTag"] = 339] = "JSDocClassTag";
	        SyntaxKind5[SyntaxKind5["JSDocPublicTag"] = 340] = "JSDocPublicTag";
	        SyntaxKind5[SyntaxKind5["JSDocPrivateTag"] = 341] = "JSDocPrivateTag";
	        SyntaxKind5[SyntaxKind5["JSDocProtectedTag"] = 342] = "JSDocProtectedTag";
	        SyntaxKind5[SyntaxKind5["JSDocReadonlyTag"] = 343] = "JSDocReadonlyTag";
	        SyntaxKind5[SyntaxKind5["JSDocOverrideTag"] = 344] = "JSDocOverrideTag";
	        SyntaxKind5[SyntaxKind5["JSDocCallbackTag"] = 345] = "JSDocCallbackTag";
	        SyntaxKind5[SyntaxKind5["JSDocOverloadTag"] = 346] = "JSDocOverloadTag";
	        SyntaxKind5[SyntaxKind5["JSDocEnumTag"] = 347] = "JSDocEnumTag";
	        SyntaxKind5[SyntaxKind5["JSDocParameterTag"] = 348] = "JSDocParameterTag";
	        SyntaxKind5[SyntaxKind5["JSDocReturnTag"] = 349] = "JSDocReturnTag";
	        SyntaxKind5[SyntaxKind5["JSDocThisTag"] = 350] = "JSDocThisTag";
	        SyntaxKind5[SyntaxKind5["JSDocTypeTag"] = 351] = "JSDocTypeTag";
	        SyntaxKind5[SyntaxKind5["JSDocTemplateTag"] = 352] = "JSDocTemplateTag";
	        SyntaxKind5[SyntaxKind5["JSDocTypedefTag"] = 353] = "JSDocTypedefTag";
	        SyntaxKind5[SyntaxKind5["JSDocSeeTag"] = 354] = "JSDocSeeTag";
	        SyntaxKind5[SyntaxKind5["JSDocPropertyTag"] = 355] = "JSDocPropertyTag";
	        SyntaxKind5[SyntaxKind5["JSDocThrowsTag"] = 356] = "JSDocThrowsTag";
	        SyntaxKind5[SyntaxKind5["JSDocSatisfiesTag"] = 357] = "JSDocSatisfiesTag";
	        SyntaxKind5[SyntaxKind5["SyntaxList"] = 358] = "SyntaxList";
	        SyntaxKind5[SyntaxKind5["NotEmittedStatement"] = 359] = "NotEmittedStatement";
	        SyntaxKind5[SyntaxKind5["PartiallyEmittedExpression"] = 360] = "PartiallyEmittedExpression";
	        SyntaxKind5[SyntaxKind5["CommaListExpression"] = 361] = "CommaListExpression";
	        SyntaxKind5[SyntaxKind5["SyntheticReferenceExpression"] = 362] = "SyntheticReferenceExpression";
	        SyntaxKind5[SyntaxKind5["Count"] = 363] = "Count";
	        SyntaxKind5[SyntaxKind5["FirstAssignment"] = 64 /* EqualsToken */] = "FirstAssignment";
	        SyntaxKind5[SyntaxKind5["LastAssignment"] = 79 /* CaretEqualsToken */] = "LastAssignment";
	        SyntaxKind5[SyntaxKind5["FirstCompoundAssignment"] = 65 /* PlusEqualsToken */] = "FirstCompoundAssignment";
	        SyntaxKind5[SyntaxKind5["LastCompoundAssignment"] = 79 /* CaretEqualsToken */] = "LastCompoundAssignment";
	        SyntaxKind5[SyntaxKind5["FirstReservedWord"] = 83 /* BreakKeyword */] = "FirstReservedWord";
	        SyntaxKind5[SyntaxKind5["LastReservedWord"] = 118 /* WithKeyword */] = "LastReservedWord";
	        SyntaxKind5[SyntaxKind5["FirstKeyword"] = 83 /* BreakKeyword */] = "FirstKeyword";
	        SyntaxKind5[SyntaxKind5["LastKeyword"] = 165 /* OfKeyword */] = "LastKeyword";
	        SyntaxKind5[SyntaxKind5["FirstFutureReservedWord"] = 119 /* ImplementsKeyword */] = "FirstFutureReservedWord";
	        SyntaxKind5[SyntaxKind5["LastFutureReservedWord"] = 127 /* YieldKeyword */] = "LastFutureReservedWord";
	        SyntaxKind5[SyntaxKind5["FirstTypeNode"] = 182 /* TypePredicate */] = "FirstTypeNode";
	        SyntaxKind5[SyntaxKind5["LastTypeNode"] = 205 /* ImportType */] = "LastTypeNode";
	        SyntaxKind5[SyntaxKind5["FirstPunctuation"] = 19 /* OpenBraceToken */] = "FirstPunctuation";
	        SyntaxKind5[SyntaxKind5["LastPunctuation"] = 79 /* CaretEqualsToken */] = "LastPunctuation";
	        SyntaxKind5[SyntaxKind5["FirstToken"] = 0 /* Unknown */] = "FirstToken";
	        SyntaxKind5[SyntaxKind5["LastToken"] = 165 /* LastKeyword */] = "LastToken";
	        SyntaxKind5[SyntaxKind5["FirstTriviaToken"] = 2 /* SingleLineCommentTrivia */] = "FirstTriviaToken";
	        SyntaxKind5[SyntaxKind5["LastTriviaToken"] = 7 /* ConflictMarkerTrivia */] = "LastTriviaToken";
	        SyntaxKind5[SyntaxKind5["FirstLiteralToken"] = 9 /* NumericLiteral */] = "FirstLiteralToken";
	        SyntaxKind5[SyntaxKind5["LastLiteralToken"] = 15 /* NoSubstitutionTemplateLiteral */] = "LastLiteralToken";
	        SyntaxKind5[SyntaxKind5["FirstTemplateToken"] = 15 /* NoSubstitutionTemplateLiteral */] = "FirstTemplateToken";
	        SyntaxKind5[SyntaxKind5["LastTemplateToken"] = 18 /* TemplateTail */] = "LastTemplateToken";
	        SyntaxKind5[SyntaxKind5["FirstBinaryOperator"] = 30 /* LessThanToken */] = "FirstBinaryOperator";
	        SyntaxKind5[SyntaxKind5["LastBinaryOperator"] = 79 /* CaretEqualsToken */] = "LastBinaryOperator";
	        SyntaxKind5[SyntaxKind5["FirstStatement"] = 243 /* VariableStatement */] = "FirstStatement";
	        SyntaxKind5[SyntaxKind5["LastStatement"] = 259 /* DebuggerStatement */] = "LastStatement";
	        SyntaxKind5[SyntaxKind5["FirstNode"] = 166 /* QualifiedName */] = "FirstNode";
	        SyntaxKind5[SyntaxKind5["FirstJSDocNode"] = 316 /* JSDocTypeExpression */] = "FirstJSDocNode";
	        SyntaxKind5[SyntaxKind5["LastJSDocNode"] = 357 /* JSDocSatisfiesTag */] = "LastJSDocNode";
	        SyntaxKind5[SyntaxKind5["FirstJSDocTagNode"] = 334 /* JSDocTag */] = "FirstJSDocTagNode";
	        SyntaxKind5[SyntaxKind5["LastJSDocTagNode"] = 357 /* JSDocSatisfiesTag */] = "LastJSDocTagNode";
	        SyntaxKind5[SyntaxKind5["FirstContextualKeyword"] = 128 /* AbstractKeyword */] = "FirstContextualKeyword";
	        SyntaxKind5[SyntaxKind5["LastContextualKeyword"] = 165 /* OfKeyword */] = "LastContextualKeyword";
	        return SyntaxKind5;
	      })(SyntaxKind || {});
	      NodeFlags = /* @__PURE__ */ ((NodeFlags3) => {
	        NodeFlags3[NodeFlags3["None"] = 0] = "None";
	        NodeFlags3[NodeFlags3["Let"] = 1] = "Let";
	        NodeFlags3[NodeFlags3["Const"] = 2] = "Const";
	        NodeFlags3[NodeFlags3["Using"] = 4] = "Using";
	        NodeFlags3[NodeFlags3["AwaitUsing"] = 6] = "AwaitUsing";
	        NodeFlags3[NodeFlags3["NestedNamespace"] = 8] = "NestedNamespace";
	        NodeFlags3[NodeFlags3["Synthesized"] = 16] = "Synthesized";
	        NodeFlags3[NodeFlags3["Namespace"] = 32] = "Namespace";
	        NodeFlags3[NodeFlags3["OptionalChain"] = 64] = "OptionalChain";
	        NodeFlags3[NodeFlags3["ExportContext"] = 128] = "ExportContext";
	        NodeFlags3[NodeFlags3["ContainsThis"] = 256] = "ContainsThis";
	        NodeFlags3[NodeFlags3["HasImplicitReturn"] = 512] = "HasImplicitReturn";
	        NodeFlags3[NodeFlags3["HasExplicitReturn"] = 1024] = "HasExplicitReturn";
	        NodeFlags3[NodeFlags3["GlobalAugmentation"] = 2048] = "GlobalAugmentation";
	        NodeFlags3[NodeFlags3["HasAsyncFunctions"] = 4096] = "HasAsyncFunctions";
	        NodeFlags3[NodeFlags3["DisallowInContext"] = 8192] = "DisallowInContext";
	        NodeFlags3[NodeFlags3["YieldContext"] = 16384] = "YieldContext";
	        NodeFlags3[NodeFlags3["DecoratorContext"] = 32768] = "DecoratorContext";
	        NodeFlags3[NodeFlags3["AwaitContext"] = 65536] = "AwaitContext";
	        NodeFlags3[NodeFlags3["DisallowConditionalTypesContext"] = 131072] = "DisallowConditionalTypesContext";
	        NodeFlags3[NodeFlags3["ThisNodeHasError"] = 262144] = "ThisNodeHasError";
	        NodeFlags3[NodeFlags3["JavaScriptFile"] = 524288] = "JavaScriptFile";
	        NodeFlags3[NodeFlags3["ThisNodeOrAnySubNodesHasError"] = 1048576] = "ThisNodeOrAnySubNodesHasError";
	        NodeFlags3[NodeFlags3["HasAggregatedChildData"] = 2097152] = "HasAggregatedChildData";
	        NodeFlags3[NodeFlags3["PossiblyContainsDynamicImport"] = 4194304] = "PossiblyContainsDynamicImport";
	        NodeFlags3[NodeFlags3["PossiblyContainsImportMeta"] = 8388608] = "PossiblyContainsImportMeta";
	        NodeFlags3[NodeFlags3["JSDoc"] = 16777216] = "JSDoc";
	        NodeFlags3[NodeFlags3["Ambient"] = 33554432] = "Ambient";
	        NodeFlags3[NodeFlags3["InWithStatement"] = 67108864] = "InWithStatement";
	        NodeFlags3[NodeFlags3["JsonFile"] = 134217728] = "JsonFile";
	        NodeFlags3[NodeFlags3["TypeCached"] = 268435456] = "TypeCached";
	        NodeFlags3[NodeFlags3["Deprecated"] = 536870912] = "Deprecated";
	        NodeFlags3[NodeFlags3["BlockScoped"] = 7] = "BlockScoped";
	        NodeFlags3[NodeFlags3["Constant"] = 6] = "Constant";
	        NodeFlags3[NodeFlags3["ReachabilityCheckFlags"] = 1536] = "ReachabilityCheckFlags";
	        NodeFlags3[NodeFlags3["ReachabilityAndEmitFlags"] = 5632] = "ReachabilityAndEmitFlags";
	        NodeFlags3[NodeFlags3["ContextFlags"] = 101441536] = "ContextFlags";
	        NodeFlags3[NodeFlags3["TypeExcludesFlags"] = 81920] = "TypeExcludesFlags";
	        NodeFlags3[NodeFlags3["PermanentlySetIncrementalFlags"] = 12582912] = "PermanentlySetIncrementalFlags";
	        NodeFlags3[NodeFlags3["IdentifierHasExtendedUnicodeEscape"] = 256 /* ContainsThis */] = "IdentifierHasExtendedUnicodeEscape";
	        NodeFlags3[NodeFlags3["IdentifierIsInJSDocNamespace"] = 4096 /* HasAsyncFunctions */] = "IdentifierIsInJSDocNamespace";
	        return NodeFlags3;
	      })(NodeFlags || {});
	      ModifierFlags = /* @__PURE__ */ ((ModifierFlags3) => {
	        ModifierFlags3[ModifierFlags3["None"] = 0] = "None";
	        ModifierFlags3[ModifierFlags3["Public"] = 1] = "Public";
	        ModifierFlags3[ModifierFlags3["Private"] = 2] = "Private";
	        ModifierFlags3[ModifierFlags3["Protected"] = 4] = "Protected";
	        ModifierFlags3[ModifierFlags3["Readonly"] = 8] = "Readonly";
	        ModifierFlags3[ModifierFlags3["Override"] = 16] = "Override";
	        ModifierFlags3[ModifierFlags3["Export"] = 32] = "Export";
	        ModifierFlags3[ModifierFlags3["Abstract"] = 64] = "Abstract";
	        ModifierFlags3[ModifierFlags3["Ambient"] = 128] = "Ambient";
	        ModifierFlags3[ModifierFlags3["Static"] = 256] = "Static";
	        ModifierFlags3[ModifierFlags3["Accessor"] = 512] = "Accessor";
	        ModifierFlags3[ModifierFlags3["Async"] = 1024] = "Async";
	        ModifierFlags3[ModifierFlags3["Default"] = 2048] = "Default";
	        ModifierFlags3[ModifierFlags3["Const"] = 4096] = "Const";
	        ModifierFlags3[ModifierFlags3["In"] = 8192] = "In";
	        ModifierFlags3[ModifierFlags3["Out"] = 16384] = "Out";
	        ModifierFlags3[ModifierFlags3["Decorator"] = 32768] = "Decorator";
	        ModifierFlags3[ModifierFlags3["Deprecated"] = 65536] = "Deprecated";
	        ModifierFlags3[ModifierFlags3["JSDocPublic"] = 8388608] = "JSDocPublic";
	        ModifierFlags3[ModifierFlags3["JSDocPrivate"] = 16777216] = "JSDocPrivate";
	        ModifierFlags3[ModifierFlags3["JSDocProtected"] = 33554432] = "JSDocProtected";
	        ModifierFlags3[ModifierFlags3["JSDocReadonly"] = 67108864] = "JSDocReadonly";
	        ModifierFlags3[ModifierFlags3["JSDocOverride"] = 134217728] = "JSDocOverride";
	        ModifierFlags3[ModifierFlags3["SyntacticOrJSDocModifiers"] = 31] = "SyntacticOrJSDocModifiers";
	        ModifierFlags3[ModifierFlags3["SyntacticOnlyModifiers"] = 65504] = "SyntacticOnlyModifiers";
	        ModifierFlags3[ModifierFlags3["SyntacticModifiers"] = 65535] = "SyntacticModifiers";
	        ModifierFlags3[ModifierFlags3["JSDocCacheOnlyModifiers"] = 260046848] = "JSDocCacheOnlyModifiers";
	        ModifierFlags3[ModifierFlags3["JSDocOnlyModifiers"] = 65536 /* Deprecated */] = "JSDocOnlyModifiers";
	        ModifierFlags3[ModifierFlags3["NonCacheOnlyModifiers"] = 131071] = "NonCacheOnlyModifiers";
	        ModifierFlags3[ModifierFlags3["HasComputedJSDocModifiers"] = 268435456] = "HasComputedJSDocModifiers";
	        ModifierFlags3[ModifierFlags3["HasComputedFlags"] = 536870912] = "HasComputedFlags";
	        ModifierFlags3[ModifierFlags3["AccessibilityModifier"] = 7] = "AccessibilityModifier";
	        ModifierFlags3[ModifierFlags3["ParameterPropertyModifier"] = 31] = "ParameterPropertyModifier";
	        ModifierFlags3[ModifierFlags3["NonPublicAccessibilityModifier"] = 6] = "NonPublicAccessibilityModifier";
	        ModifierFlags3[ModifierFlags3["TypeScriptModifier"] = 28895] = "TypeScriptModifier";
	        ModifierFlags3[ModifierFlags3["ExportDefault"] = 2080] = "ExportDefault";
	        ModifierFlags3[ModifierFlags3["All"] = 131071] = "All";
	        ModifierFlags3[ModifierFlags3["Modifier"] = 98303] = "Modifier";
	        return ModifierFlags3;
	      })(ModifierFlags || {});
	      JsxFlags = /* @__PURE__ */ ((JsxFlags2) => {
	        JsxFlags2[JsxFlags2["None"] = 0] = "None";
	        JsxFlags2[JsxFlags2["IntrinsicNamedElement"] = 1] = "IntrinsicNamedElement";
	        JsxFlags2[JsxFlags2["IntrinsicIndexedElement"] = 2] = "IntrinsicIndexedElement";
	        JsxFlags2[JsxFlags2["IntrinsicElement"] = 3] = "IntrinsicElement";
	        return JsxFlags2;
	      })(JsxFlags || {});
	      RelationComparisonResult = /* @__PURE__ */ ((RelationComparisonResult3) => {
	        RelationComparisonResult3[RelationComparisonResult3["None"] = 0] = "None";
	        RelationComparisonResult3[RelationComparisonResult3["Succeeded"] = 1] = "Succeeded";
	        RelationComparisonResult3[RelationComparisonResult3["Failed"] = 2] = "Failed";
	        RelationComparisonResult3[RelationComparisonResult3["Reported"] = 4] = "Reported";
	        RelationComparisonResult3[RelationComparisonResult3["ReportsUnmeasurable"] = 8] = "ReportsUnmeasurable";
	        RelationComparisonResult3[RelationComparisonResult3["ReportsUnreliable"] = 16] = "ReportsUnreliable";
	        RelationComparisonResult3[RelationComparisonResult3["ReportsMask"] = 24] = "ReportsMask";
	        return RelationComparisonResult3;
	      })(RelationComparisonResult || {});
	      GeneratedIdentifierFlags = /* @__PURE__ */ ((GeneratedIdentifierFlags2) => {
	        GeneratedIdentifierFlags2[GeneratedIdentifierFlags2["None"] = 0] = "None";
	        GeneratedIdentifierFlags2[GeneratedIdentifierFlags2["Auto"] = 1] = "Auto";
	        GeneratedIdentifierFlags2[GeneratedIdentifierFlags2["Loop"] = 2] = "Loop";
	        GeneratedIdentifierFlags2[GeneratedIdentifierFlags2["Unique"] = 3] = "Unique";
	        GeneratedIdentifierFlags2[GeneratedIdentifierFlags2["Node"] = 4] = "Node";
	        GeneratedIdentifierFlags2[GeneratedIdentifierFlags2["KindMask"] = 7] = "KindMask";
	        GeneratedIdentifierFlags2[GeneratedIdentifierFlags2["ReservedInNestedScopes"] = 8] = "ReservedInNestedScopes";
	        GeneratedIdentifierFlags2[GeneratedIdentifierFlags2["Optimistic"] = 16] = "Optimistic";
	        GeneratedIdentifierFlags2[GeneratedIdentifierFlags2["FileLevel"] = 32] = "FileLevel";
	        GeneratedIdentifierFlags2[GeneratedIdentifierFlags2["AllowNameSubstitution"] = 64] = "AllowNameSubstitution";
	        return GeneratedIdentifierFlags2;
	      })(GeneratedIdentifierFlags || {});
	      TokenFlags = /* @__PURE__ */ ((TokenFlags2) => {
	        TokenFlags2[TokenFlags2["None"] = 0] = "None";
	        TokenFlags2[TokenFlags2["PrecedingLineBreak"] = 1] = "PrecedingLineBreak";
	        TokenFlags2[TokenFlags2["PrecedingJSDocComment"] = 2] = "PrecedingJSDocComment";
	        TokenFlags2[TokenFlags2["Unterminated"] = 4] = "Unterminated";
	        TokenFlags2[TokenFlags2["ExtendedUnicodeEscape"] = 8] = "ExtendedUnicodeEscape";
	        TokenFlags2[TokenFlags2["Scientific"] = 16] = "Scientific";
	        TokenFlags2[TokenFlags2["Octal"] = 32] = "Octal";
	        TokenFlags2[TokenFlags2["HexSpecifier"] = 64] = "HexSpecifier";
	        TokenFlags2[TokenFlags2["BinarySpecifier"] = 128] = "BinarySpecifier";
	        TokenFlags2[TokenFlags2["OctalSpecifier"] = 256] = "OctalSpecifier";
	        TokenFlags2[TokenFlags2["ContainsSeparator"] = 512] = "ContainsSeparator";
	        TokenFlags2[TokenFlags2["UnicodeEscape"] = 1024] = "UnicodeEscape";
	        TokenFlags2[TokenFlags2["ContainsInvalidEscape"] = 2048] = "ContainsInvalidEscape";
	        TokenFlags2[TokenFlags2["HexEscape"] = 4096] = "HexEscape";
	        TokenFlags2[TokenFlags2["ContainsLeadingZero"] = 8192] = "ContainsLeadingZero";
	        TokenFlags2[TokenFlags2["ContainsInvalidSeparator"] = 16384] = "ContainsInvalidSeparator";
	        TokenFlags2[TokenFlags2["BinaryOrOctalSpecifier"] = 384] = "BinaryOrOctalSpecifier";
	        TokenFlags2[TokenFlags2["WithSpecifier"] = 448] = "WithSpecifier";
	        TokenFlags2[TokenFlags2["StringLiteralFlags"] = 7176] = "StringLiteralFlags";
	        TokenFlags2[TokenFlags2["NumericLiteralFlags"] = 25584] = "NumericLiteralFlags";
	        TokenFlags2[TokenFlags2["TemplateLiteralLikeFlags"] = 7176] = "TemplateLiteralLikeFlags";
	        TokenFlags2[TokenFlags2["IsInvalid"] = 26656] = "IsInvalid";
	        return TokenFlags2;
	      })(TokenFlags || {});
	      FlowFlags = /* @__PURE__ */ ((FlowFlags2) => {
	        FlowFlags2[FlowFlags2["Unreachable"] = 1] = "Unreachable";
	        FlowFlags2[FlowFlags2["Start"] = 2] = "Start";
	        FlowFlags2[FlowFlags2["BranchLabel"] = 4] = "BranchLabel";
	        FlowFlags2[FlowFlags2["LoopLabel"] = 8] = "LoopLabel";
	        FlowFlags2[FlowFlags2["Assignment"] = 16] = "Assignment";
	        FlowFlags2[FlowFlags2["TrueCondition"] = 32] = "TrueCondition";
	        FlowFlags2[FlowFlags2["FalseCondition"] = 64] = "FalseCondition";
	        FlowFlags2[FlowFlags2["SwitchClause"] = 128] = "SwitchClause";
	        FlowFlags2[FlowFlags2["ArrayMutation"] = 256] = "ArrayMutation";
	        FlowFlags2[FlowFlags2["Call"] = 512] = "Call";
	        FlowFlags2[FlowFlags2["ReduceLabel"] = 1024] = "ReduceLabel";
	        FlowFlags2[FlowFlags2["Referenced"] = 2048] = "Referenced";
	        FlowFlags2[FlowFlags2["Shared"] = 4096] = "Shared";
	        FlowFlags2[FlowFlags2["Label"] = 12] = "Label";
	        FlowFlags2[FlowFlags2["Condition"] = 96] = "Condition";
	        return FlowFlags2;
	      })(FlowFlags || {});
	      CommentDirectiveType = /* @__PURE__ */ ((CommentDirectiveType2) => {
	        CommentDirectiveType2[CommentDirectiveType2["ExpectError"] = 0] = "ExpectError";
	        CommentDirectiveType2[CommentDirectiveType2["Ignore"] = 1] = "Ignore";
	        return CommentDirectiveType2;
	      })(CommentDirectiveType || {});
	      OperationCanceledException = class {
	      };
	      FileIncludeKind = /* @__PURE__ */ ((FileIncludeKind2) => {
	        FileIncludeKind2[FileIncludeKind2["RootFile"] = 0] = "RootFile";
	        FileIncludeKind2[FileIncludeKind2["SourceFromProjectReference"] = 1] = "SourceFromProjectReference";
	        FileIncludeKind2[FileIncludeKind2["OutputFromProjectReference"] = 2] = "OutputFromProjectReference";
	        FileIncludeKind2[FileIncludeKind2["Import"] = 3] = "Import";
	        FileIncludeKind2[FileIncludeKind2["ReferenceFile"] = 4] = "ReferenceFile";
	        FileIncludeKind2[FileIncludeKind2["TypeReferenceDirective"] = 5] = "TypeReferenceDirective";
	        FileIncludeKind2[FileIncludeKind2["LibFile"] = 6] = "LibFile";
	        FileIncludeKind2[FileIncludeKind2["LibReferenceDirective"] = 7] = "LibReferenceDirective";
	        FileIncludeKind2[FileIncludeKind2["AutomaticTypeDirectiveFile"] = 8] = "AutomaticTypeDirectiveFile";
	        return FileIncludeKind2;
	      })(FileIncludeKind || {});
	      FilePreprocessingDiagnosticsKind = /* @__PURE__ */ ((FilePreprocessingDiagnosticsKind2) => {
	        FilePreprocessingDiagnosticsKind2[FilePreprocessingDiagnosticsKind2["FilePreprocessingReferencedDiagnostic"] = 0] = "FilePreprocessingReferencedDiagnostic";
	        FilePreprocessingDiagnosticsKind2[FilePreprocessingDiagnosticsKind2["FilePreprocessingFileExplainingDiagnostic"] = 1] = "FilePreprocessingFileExplainingDiagnostic";
	        FilePreprocessingDiagnosticsKind2[FilePreprocessingDiagnosticsKind2["ResolutionDiagnostics"] = 2] = "ResolutionDiagnostics";
	        return FilePreprocessingDiagnosticsKind2;
	      })(FilePreprocessingDiagnosticsKind || {});
	      EmitOnly = /* @__PURE__ */ ((EmitOnly4) => {
	        EmitOnly4[EmitOnly4["Js"] = 0] = "Js";
	        EmitOnly4[EmitOnly4["Dts"] = 1] = "Dts";
	        return EmitOnly4;
	      })(EmitOnly || {});
	      StructureIsReused = /* @__PURE__ */ ((StructureIsReused2) => {
	        StructureIsReused2[StructureIsReused2["Not"] = 0] = "Not";
	        StructureIsReused2[StructureIsReused2["SafeModules"] = 1] = "SafeModules";
	        StructureIsReused2[StructureIsReused2["Completely"] = 2] = "Completely";
	        return StructureIsReused2;
	      })(StructureIsReused || {});
	      ExitStatus = /* @__PURE__ */ ((ExitStatus2) => {
	        ExitStatus2[ExitStatus2["Success"] = 0] = "Success";
	        ExitStatus2[ExitStatus2["DiagnosticsPresent_OutputsSkipped"] = 1] = "DiagnosticsPresent_OutputsSkipped";
	        ExitStatus2[ExitStatus2["DiagnosticsPresent_OutputsGenerated"] = 2] = "DiagnosticsPresent_OutputsGenerated";
	        ExitStatus2[ExitStatus2["InvalidProject_OutputsSkipped"] = 3] = "InvalidProject_OutputsSkipped";
	        ExitStatus2[ExitStatus2["ProjectReferenceCycle_OutputsSkipped"] = 4] = "ProjectReferenceCycle_OutputsSkipped";
	        return ExitStatus2;
	      })(ExitStatus || {});
	      MemberOverrideStatus = /* @__PURE__ */ ((MemberOverrideStatus2) => {
	        MemberOverrideStatus2[MemberOverrideStatus2["Ok"] = 0] = "Ok";
	        MemberOverrideStatus2[MemberOverrideStatus2["NeedsOverride"] = 1] = "NeedsOverride";
	        MemberOverrideStatus2[MemberOverrideStatus2["HasInvalidOverride"] = 2] = "HasInvalidOverride";
	        return MemberOverrideStatus2;
	      })(MemberOverrideStatus || {});
	      UnionReduction = /* @__PURE__ */ ((UnionReduction2) => {
	        UnionReduction2[UnionReduction2["None"] = 0] = "None";
	        UnionReduction2[UnionReduction2["Literal"] = 1] = "Literal";
	        UnionReduction2[UnionReduction2["Subtype"] = 2] = "Subtype";
	        return UnionReduction2;
	      })(UnionReduction || {});
	      ContextFlags = /* @__PURE__ */ ((ContextFlags3) => {
	        ContextFlags3[ContextFlags3["None"] = 0] = "None";
	        ContextFlags3[ContextFlags3["Signature"] = 1] = "Signature";
	        ContextFlags3[ContextFlags3["NoConstraints"] = 2] = "NoConstraints";
	        ContextFlags3[ContextFlags3["Completions"] = 4] = "Completions";
	        ContextFlags3[ContextFlags3["SkipBindingPatterns"] = 8] = "SkipBindingPatterns";
	        return ContextFlags3;
	      })(ContextFlags || {});
	      NodeBuilderFlags = /* @__PURE__ */ ((NodeBuilderFlags2) => {
	        NodeBuilderFlags2[NodeBuilderFlags2["None"] = 0] = "None";
	        NodeBuilderFlags2[NodeBuilderFlags2["NoTruncation"] = 1] = "NoTruncation";
	        NodeBuilderFlags2[NodeBuilderFlags2["WriteArrayAsGenericType"] = 2] = "WriteArrayAsGenericType";
	        NodeBuilderFlags2[NodeBuilderFlags2["GenerateNamesForShadowedTypeParams"] = 4] = "GenerateNamesForShadowedTypeParams";
	        NodeBuilderFlags2[NodeBuilderFlags2["UseStructuralFallback"] = 8] = "UseStructuralFallback";
	        NodeBuilderFlags2[NodeBuilderFlags2["ForbidIndexedAccessSymbolReferences"] = 16] = "ForbidIndexedAccessSymbolReferences";
	        NodeBuilderFlags2[NodeBuilderFlags2["WriteTypeArgumentsOfSignature"] = 32] = "WriteTypeArgumentsOfSignature";
	        NodeBuilderFlags2[NodeBuilderFlags2["UseFullyQualifiedType"] = 64] = "UseFullyQualifiedType";
	        NodeBuilderFlags2[NodeBuilderFlags2["UseOnlyExternalAliasing"] = 128] = "UseOnlyExternalAliasing";
	        NodeBuilderFlags2[NodeBuilderFlags2["SuppressAnyReturnType"] = 256] = "SuppressAnyReturnType";
	        NodeBuilderFlags2[NodeBuilderFlags2["WriteTypeParametersInQualifiedName"] = 512] = "WriteTypeParametersInQualifiedName";
	        NodeBuilderFlags2[NodeBuilderFlags2["MultilineObjectLiterals"] = 1024] = "MultilineObjectLiterals";
	        NodeBuilderFlags2[NodeBuilderFlags2["WriteClassExpressionAsTypeLiteral"] = 2048] = "WriteClassExpressionAsTypeLiteral";
	        NodeBuilderFlags2[NodeBuilderFlags2["UseTypeOfFunction"] = 4096] = "UseTypeOfFunction";
	        NodeBuilderFlags2[NodeBuilderFlags2["OmitParameterModifiers"] = 8192] = "OmitParameterModifiers";
	        NodeBuilderFlags2[NodeBuilderFlags2["UseAliasDefinedOutsideCurrentScope"] = 16384] = "UseAliasDefinedOutsideCurrentScope";
	        NodeBuilderFlags2[NodeBuilderFlags2["UseSingleQuotesForStringLiteralType"] = 268435456] = "UseSingleQuotesForStringLiteralType";
	        NodeBuilderFlags2[NodeBuilderFlags2["NoTypeReduction"] = 536870912] = "NoTypeReduction";
	        NodeBuilderFlags2[NodeBuilderFlags2["OmitThisParameter"] = 33554432] = "OmitThisParameter";
	        NodeBuilderFlags2[NodeBuilderFlags2["AllowThisInObjectLiteral"] = 32768] = "AllowThisInObjectLiteral";
	        NodeBuilderFlags2[NodeBuilderFlags2["AllowQualifiedNameInPlaceOfIdentifier"] = 65536] = "AllowQualifiedNameInPlaceOfIdentifier";
	        NodeBuilderFlags2[NodeBuilderFlags2["AllowAnonymousIdentifier"] = 131072] = "AllowAnonymousIdentifier";
	        NodeBuilderFlags2[NodeBuilderFlags2["AllowEmptyUnionOrIntersection"] = 262144] = "AllowEmptyUnionOrIntersection";
	        NodeBuilderFlags2[NodeBuilderFlags2["AllowEmptyTuple"] = 524288] = "AllowEmptyTuple";
	        NodeBuilderFlags2[NodeBuilderFlags2["AllowUniqueESSymbolType"] = 1048576] = "AllowUniqueESSymbolType";
	        NodeBuilderFlags2[NodeBuilderFlags2["AllowEmptyIndexInfoType"] = 2097152] = "AllowEmptyIndexInfoType";
	        NodeBuilderFlags2[NodeBuilderFlags2["WriteComputedProps"] = 1073741824] = "WriteComputedProps";
	        NodeBuilderFlags2[NodeBuilderFlags2["AllowNodeModulesRelativePaths"] = 67108864] = "AllowNodeModulesRelativePaths";
	        NodeBuilderFlags2[NodeBuilderFlags2["DoNotIncludeSymbolChain"] = 134217728] = "DoNotIncludeSymbolChain";
	        NodeBuilderFlags2[NodeBuilderFlags2["IgnoreErrors"] = 70221824] = "IgnoreErrors";
	        NodeBuilderFlags2[NodeBuilderFlags2["InObjectTypeLiteral"] = 4194304] = "InObjectTypeLiteral";
	        NodeBuilderFlags2[NodeBuilderFlags2["InTypeAlias"] = 8388608] = "InTypeAlias";
	        NodeBuilderFlags2[NodeBuilderFlags2["InInitialEntityName"] = 16777216] = "InInitialEntityName";
	        return NodeBuilderFlags2;
	      })(NodeBuilderFlags || {});
	      TypeFormatFlags = /* @__PURE__ */ ((TypeFormatFlags2) => {
	        TypeFormatFlags2[TypeFormatFlags2["None"] = 0] = "None";
	        TypeFormatFlags2[TypeFormatFlags2["NoTruncation"] = 1] = "NoTruncation";
	        TypeFormatFlags2[TypeFormatFlags2["WriteArrayAsGenericType"] = 2] = "WriteArrayAsGenericType";
	        TypeFormatFlags2[TypeFormatFlags2["GenerateNamesForShadowedTypeParams"] = 4] = "GenerateNamesForShadowedTypeParams";
	        TypeFormatFlags2[TypeFormatFlags2["UseStructuralFallback"] = 8] = "UseStructuralFallback";
	        TypeFormatFlags2[TypeFormatFlags2["WriteTypeArgumentsOfSignature"] = 32] = "WriteTypeArgumentsOfSignature";
	        TypeFormatFlags2[TypeFormatFlags2["UseFullyQualifiedType"] = 64] = "UseFullyQualifiedType";
	        TypeFormatFlags2[TypeFormatFlags2["SuppressAnyReturnType"] = 256] = "SuppressAnyReturnType";
	        TypeFormatFlags2[TypeFormatFlags2["MultilineObjectLiterals"] = 1024] = "MultilineObjectLiterals";
	        TypeFormatFlags2[TypeFormatFlags2["WriteClassExpressionAsTypeLiteral"] = 2048] = "WriteClassExpressionAsTypeLiteral";
	        TypeFormatFlags2[TypeFormatFlags2["UseTypeOfFunction"] = 4096] = "UseTypeOfFunction";
	        TypeFormatFlags2[TypeFormatFlags2["OmitParameterModifiers"] = 8192] = "OmitParameterModifiers";
	        TypeFormatFlags2[TypeFormatFlags2["UseAliasDefinedOutsideCurrentScope"] = 16384] = "UseAliasDefinedOutsideCurrentScope";
	        TypeFormatFlags2[TypeFormatFlags2["UseSingleQuotesForStringLiteralType"] = 268435456] = "UseSingleQuotesForStringLiteralType";
	        TypeFormatFlags2[TypeFormatFlags2["NoTypeReduction"] = 536870912] = "NoTypeReduction";
	        TypeFormatFlags2[TypeFormatFlags2["OmitThisParameter"] = 33554432] = "OmitThisParameter";
	        TypeFormatFlags2[TypeFormatFlags2["AllowUniqueESSymbolType"] = 1048576] = "AllowUniqueESSymbolType";
	        TypeFormatFlags2[TypeFormatFlags2["AddUndefined"] = 131072] = "AddUndefined";
	        TypeFormatFlags2[TypeFormatFlags2["WriteArrowStyleSignature"] = 262144] = "WriteArrowStyleSignature";
	        TypeFormatFlags2[TypeFormatFlags2["InArrayType"] = 524288] = "InArrayType";
	        TypeFormatFlags2[TypeFormatFlags2["InElementType"] = 2097152] = "InElementType";
	        TypeFormatFlags2[TypeFormatFlags2["InFirstTypeArgument"] = 4194304] = "InFirstTypeArgument";
	        TypeFormatFlags2[TypeFormatFlags2["InTypeAlias"] = 8388608] = "InTypeAlias";
	        TypeFormatFlags2[TypeFormatFlags2["NodeBuilderFlagsMask"] = 848330095] = "NodeBuilderFlagsMask";
	        return TypeFormatFlags2;
	      })(TypeFormatFlags || {});
	      SymbolFormatFlags = /* @__PURE__ */ ((SymbolFormatFlags2) => {
	        SymbolFormatFlags2[SymbolFormatFlags2["None"] = 0] = "None";
	        SymbolFormatFlags2[SymbolFormatFlags2["WriteTypeParametersOrArguments"] = 1] = "WriteTypeParametersOrArguments";
	        SymbolFormatFlags2[SymbolFormatFlags2["UseOnlyExternalAliasing"] = 2] = "UseOnlyExternalAliasing";
	        SymbolFormatFlags2[SymbolFormatFlags2["AllowAnyNodeKind"] = 4] = "AllowAnyNodeKind";
	        SymbolFormatFlags2[SymbolFormatFlags2["UseAliasDefinedOutsideCurrentScope"] = 8] = "UseAliasDefinedOutsideCurrentScope";
	        SymbolFormatFlags2[SymbolFormatFlags2["WriteComputedProps"] = 16] = "WriteComputedProps";
	        SymbolFormatFlags2[SymbolFormatFlags2["DoNotIncludeSymbolChain"] = 32] = "DoNotIncludeSymbolChain";
	        return SymbolFormatFlags2;
	      })(SymbolFormatFlags || {});
	      SymbolAccessibility = /* @__PURE__ */ ((SymbolAccessibility2) => {
	        SymbolAccessibility2[SymbolAccessibility2["Accessible"] = 0] = "Accessible";
	        SymbolAccessibility2[SymbolAccessibility2["NotAccessible"] = 1] = "NotAccessible";
	        SymbolAccessibility2[SymbolAccessibility2["CannotBeNamed"] = 2] = "CannotBeNamed";
	        return SymbolAccessibility2;
	      })(SymbolAccessibility || {});
	      SyntheticSymbolKind = /* @__PURE__ */ ((SyntheticSymbolKind2) => {
	        SyntheticSymbolKind2[SyntheticSymbolKind2["UnionOrIntersection"] = 0] = "UnionOrIntersection";
	        SyntheticSymbolKind2[SyntheticSymbolKind2["Spread"] = 1] = "Spread";
	        return SyntheticSymbolKind2;
	      })(SyntheticSymbolKind || {});
	      TypePredicateKind = /* @__PURE__ */ ((TypePredicateKind2) => {
	        TypePredicateKind2[TypePredicateKind2["This"] = 0] = "This";
	        TypePredicateKind2[TypePredicateKind2["Identifier"] = 1] = "Identifier";
	        TypePredicateKind2[TypePredicateKind2["AssertsThis"] = 2] = "AssertsThis";
	        TypePredicateKind2[TypePredicateKind2["AssertsIdentifier"] = 3] = "AssertsIdentifier";
	        return TypePredicateKind2;
	      })(TypePredicateKind || {});
	      TypeReferenceSerializationKind = /* @__PURE__ */ ((TypeReferenceSerializationKind2) => {
	        TypeReferenceSerializationKind2[TypeReferenceSerializationKind2["Unknown"] = 0] = "Unknown";
	        TypeReferenceSerializationKind2[TypeReferenceSerializationKind2["TypeWithConstructSignatureAndValue"] = 1] = "TypeWithConstructSignatureAndValue";
	        TypeReferenceSerializationKind2[TypeReferenceSerializationKind2["VoidNullableOrNeverType"] = 2] = "VoidNullableOrNeverType";
	        TypeReferenceSerializationKind2[TypeReferenceSerializationKind2["NumberLikeType"] = 3] = "NumberLikeType";
	        TypeReferenceSerializationKind2[TypeReferenceSerializationKind2["BigIntLikeType"] = 4] = "BigIntLikeType";
	        TypeReferenceSerializationKind2[TypeReferenceSerializationKind2["StringLikeType"] = 5] = "StringLikeType";
	        TypeReferenceSerializationKind2[TypeReferenceSerializationKind2["BooleanType"] = 6] = "BooleanType";
	        TypeReferenceSerializationKind2[TypeReferenceSerializationKind2["ArrayLikeType"] = 7] = "ArrayLikeType";
	        TypeReferenceSerializationKind2[TypeReferenceSerializationKind2["ESSymbolType"] = 8] = "ESSymbolType";
	        TypeReferenceSerializationKind2[TypeReferenceSerializationKind2["Promise"] = 9] = "Promise";
	        TypeReferenceSerializationKind2[TypeReferenceSerializationKind2["TypeWithCallSignature"] = 10] = "TypeWithCallSignature";
	        TypeReferenceSerializationKind2[TypeReferenceSerializationKind2["ObjectType"] = 11] = "ObjectType";
	        return TypeReferenceSerializationKind2;
	      })(TypeReferenceSerializationKind || {});
	      SymbolFlags = /* @__PURE__ */ ((SymbolFlags3) => {
	        SymbolFlags3[SymbolFlags3["None"] = 0] = "None";
	        SymbolFlags3[SymbolFlags3["FunctionScopedVariable"] = 1] = "FunctionScopedVariable";
	        SymbolFlags3[SymbolFlags3["BlockScopedVariable"] = 2] = "BlockScopedVariable";
	        SymbolFlags3[SymbolFlags3["Property"] = 4] = "Property";
	        SymbolFlags3[SymbolFlags3["EnumMember"] = 8] = "EnumMember";
	        SymbolFlags3[SymbolFlags3["Function"] = 16] = "Function";
	        SymbolFlags3[SymbolFlags3["Class"] = 32] = "Class";
	        SymbolFlags3[SymbolFlags3["Interface"] = 64] = "Interface";
	        SymbolFlags3[SymbolFlags3["ConstEnum"] = 128] = "ConstEnum";
	        SymbolFlags3[SymbolFlags3["RegularEnum"] = 256] = "RegularEnum";
	        SymbolFlags3[SymbolFlags3["ValueModule"] = 512] = "ValueModule";
	        SymbolFlags3[SymbolFlags3["NamespaceModule"] = 1024] = "NamespaceModule";
	        SymbolFlags3[SymbolFlags3["TypeLiteral"] = 2048] = "TypeLiteral";
	        SymbolFlags3[SymbolFlags3["ObjectLiteral"] = 4096] = "ObjectLiteral";
	        SymbolFlags3[SymbolFlags3["Method"] = 8192] = "Method";
	        SymbolFlags3[SymbolFlags3["Constructor"] = 16384] = "Constructor";
	        SymbolFlags3[SymbolFlags3["GetAccessor"] = 32768] = "GetAccessor";
	        SymbolFlags3[SymbolFlags3["SetAccessor"] = 65536] = "SetAccessor";
	        SymbolFlags3[SymbolFlags3["Signature"] = 131072] = "Signature";
	        SymbolFlags3[SymbolFlags3["TypeParameter"] = 262144] = "TypeParameter";
	        SymbolFlags3[SymbolFlags3["TypeAlias"] = 524288] = "TypeAlias";
	        SymbolFlags3[SymbolFlags3["ExportValue"] = 1048576] = "ExportValue";
	        SymbolFlags3[SymbolFlags3["Alias"] = 2097152] = "Alias";
	        SymbolFlags3[SymbolFlags3["Prototype"] = 4194304] = "Prototype";
	        SymbolFlags3[SymbolFlags3["ExportStar"] = 8388608] = "ExportStar";
	        SymbolFlags3[SymbolFlags3["Optional"] = 16777216] = "Optional";
	        SymbolFlags3[SymbolFlags3["Transient"] = 33554432] = "Transient";
	        SymbolFlags3[SymbolFlags3["Assignment"] = 67108864] = "Assignment";
	        SymbolFlags3[SymbolFlags3["ModuleExports"] = 134217728] = "ModuleExports";
	        SymbolFlags3[SymbolFlags3["All"] = -1] = "All";
	        SymbolFlags3[SymbolFlags3["Enum"] = 384] = "Enum";
	        SymbolFlags3[SymbolFlags3["Variable"] = 3] = "Variable";
	        SymbolFlags3[SymbolFlags3["Value"] = 111551] = "Value";
	        SymbolFlags3[SymbolFlags3["Type"] = 788968] = "Type";
	        SymbolFlags3[SymbolFlags3["Namespace"] = 1920] = "Namespace";
	        SymbolFlags3[SymbolFlags3["Module"] = 1536] = "Module";
	        SymbolFlags3[SymbolFlags3["Accessor"] = 98304] = "Accessor";
	        SymbolFlags3[SymbolFlags3["FunctionScopedVariableExcludes"] = 111550] = "FunctionScopedVariableExcludes";
	        SymbolFlags3[SymbolFlags3["BlockScopedVariableExcludes"] = 111551 /* Value */] = "BlockScopedVariableExcludes";
	        SymbolFlags3[SymbolFlags3["ParameterExcludes"] = 111551 /* Value */] = "ParameterExcludes";
	        SymbolFlags3[SymbolFlags3["PropertyExcludes"] = 0 /* None */] = "PropertyExcludes";
	        SymbolFlags3[SymbolFlags3["EnumMemberExcludes"] = 900095] = "EnumMemberExcludes";
	        SymbolFlags3[SymbolFlags3["FunctionExcludes"] = 110991] = "FunctionExcludes";
	        SymbolFlags3[SymbolFlags3["ClassExcludes"] = 899503] = "ClassExcludes";
	        SymbolFlags3[SymbolFlags3["InterfaceExcludes"] = 788872] = "InterfaceExcludes";
	        SymbolFlags3[SymbolFlags3["RegularEnumExcludes"] = 899327] = "RegularEnumExcludes";
	        SymbolFlags3[SymbolFlags3["ConstEnumExcludes"] = 899967] = "ConstEnumExcludes";
	        SymbolFlags3[SymbolFlags3["ValueModuleExcludes"] = 110735] = "ValueModuleExcludes";
	        SymbolFlags3[SymbolFlags3["NamespaceModuleExcludes"] = 0] = "NamespaceModuleExcludes";
	        SymbolFlags3[SymbolFlags3["MethodExcludes"] = 103359] = "MethodExcludes";
	        SymbolFlags3[SymbolFlags3["GetAccessorExcludes"] = 46015] = "GetAccessorExcludes";
	        SymbolFlags3[SymbolFlags3["SetAccessorExcludes"] = 78783] = "SetAccessorExcludes";
	        SymbolFlags3[SymbolFlags3["AccessorExcludes"] = 13247] = "AccessorExcludes";
	        SymbolFlags3[SymbolFlags3["TypeParameterExcludes"] = 526824] = "TypeParameterExcludes";
	        SymbolFlags3[SymbolFlags3["TypeAliasExcludes"] = 788968 /* Type */] = "TypeAliasExcludes";
	        SymbolFlags3[SymbolFlags3["AliasExcludes"] = 2097152 /* Alias */] = "AliasExcludes";
	        SymbolFlags3[SymbolFlags3["ModuleMember"] = 2623475] = "ModuleMember";
	        SymbolFlags3[SymbolFlags3["ExportHasLocal"] = 944] = "ExportHasLocal";
	        SymbolFlags3[SymbolFlags3["BlockScoped"] = 418] = "BlockScoped";
	        SymbolFlags3[SymbolFlags3["PropertyOrAccessor"] = 98308] = "PropertyOrAccessor";
	        SymbolFlags3[SymbolFlags3["ClassMember"] = 106500] = "ClassMember";
	        SymbolFlags3[SymbolFlags3["ExportSupportsDefaultModifier"] = 112] = "ExportSupportsDefaultModifier";
	        SymbolFlags3[SymbolFlags3["ExportDoesNotSupportDefaultModifier"] = -113] = "ExportDoesNotSupportDefaultModifier";
	        SymbolFlags3[SymbolFlags3["Classifiable"] = 2885600] = "Classifiable";
	        SymbolFlags3[SymbolFlags3["LateBindingContainer"] = 6256] = "LateBindingContainer";
	        return SymbolFlags3;
	      })(SymbolFlags || {});
	      EnumKind = /* @__PURE__ */ ((EnumKind2) => {
	        EnumKind2[EnumKind2["Numeric"] = 0] = "Numeric";
	        EnumKind2[EnumKind2["Literal"] = 1] = "Literal";
	        return EnumKind2;
	      })(EnumKind || {});
	      CheckFlags = /* @__PURE__ */ ((CheckFlags2) => {
	        CheckFlags2[CheckFlags2["None"] = 0] = "None";
	        CheckFlags2[CheckFlags2["Instantiated"] = 1] = "Instantiated";
	        CheckFlags2[CheckFlags2["SyntheticProperty"] = 2] = "SyntheticProperty";
	        CheckFlags2[CheckFlags2["SyntheticMethod"] = 4] = "SyntheticMethod";
	        CheckFlags2[CheckFlags2["Readonly"] = 8] = "Readonly";
	        CheckFlags2[CheckFlags2["ReadPartial"] = 16] = "ReadPartial";
	        CheckFlags2[CheckFlags2["WritePartial"] = 32] = "WritePartial";
	        CheckFlags2[CheckFlags2["HasNonUniformType"] = 64] = "HasNonUniformType";
	        CheckFlags2[CheckFlags2["HasLiteralType"] = 128] = "HasLiteralType";
	        CheckFlags2[CheckFlags2["ContainsPublic"] = 256] = "ContainsPublic";
	        CheckFlags2[CheckFlags2["ContainsProtected"] = 512] = "ContainsProtected";
	        CheckFlags2[CheckFlags2["ContainsPrivate"] = 1024] = "ContainsPrivate";
	        CheckFlags2[CheckFlags2["ContainsStatic"] = 2048] = "ContainsStatic";
	        CheckFlags2[CheckFlags2["Late"] = 4096] = "Late";
	        CheckFlags2[CheckFlags2["ReverseMapped"] = 8192] = "ReverseMapped";
	        CheckFlags2[CheckFlags2["OptionalParameter"] = 16384] = "OptionalParameter";
	        CheckFlags2[CheckFlags2["RestParameter"] = 32768] = "RestParameter";
	        CheckFlags2[CheckFlags2["DeferredType"] = 65536] = "DeferredType";
	        CheckFlags2[CheckFlags2["HasNeverType"] = 131072] = "HasNeverType";
	        CheckFlags2[CheckFlags2["Mapped"] = 262144] = "Mapped";
	        CheckFlags2[CheckFlags2["StripOptional"] = 524288] = "StripOptional";
	        CheckFlags2[CheckFlags2["Unresolved"] = 1048576] = "Unresolved";
	        CheckFlags2[CheckFlags2["Synthetic"] = 6] = "Synthetic";
	        CheckFlags2[CheckFlags2["Discriminant"] = 192] = "Discriminant";
	        CheckFlags2[CheckFlags2["Partial"] = 48] = "Partial";
	        return CheckFlags2;
	      })(CheckFlags || {});
	      InternalSymbolName = /* @__PURE__ */ ((InternalSymbolName2) => {
	        InternalSymbolName2["Call"] = "__call";
	        InternalSymbolName2["Constructor"] = "__constructor";
	        InternalSymbolName2["New"] = "__new";
	        InternalSymbolName2["Index"] = "__index";
	        InternalSymbolName2["ExportStar"] = "__export";
	        InternalSymbolName2["Global"] = "__global";
	        InternalSymbolName2["Missing"] = "__missing";
	        InternalSymbolName2["Type"] = "__type";
	        InternalSymbolName2["Object"] = "__object";
	        InternalSymbolName2["JSXAttributes"] = "__jsxAttributes";
	        InternalSymbolName2["Class"] = "__class";
	        InternalSymbolName2["Function"] = "__function";
	        InternalSymbolName2["Computed"] = "__computed";
	        InternalSymbolName2["Resolving"] = "__resolving__";
	        InternalSymbolName2["ExportEquals"] = "export=";
	        InternalSymbolName2["Default"] = "default";
	        InternalSymbolName2["This"] = "this";
	        InternalSymbolName2["InstantiationExpression"] = "__instantiationExpression";
	        InternalSymbolName2["ImportAttributes"] = "__importAttributes";
	        return InternalSymbolName2;
	      })(InternalSymbolName || {});
	      NodeCheckFlags = /* @__PURE__ */ ((NodeCheckFlags2) => {
	        NodeCheckFlags2[NodeCheckFlags2["None"] = 0] = "None";
	        NodeCheckFlags2[NodeCheckFlags2["TypeChecked"] = 1] = "TypeChecked";
	        NodeCheckFlags2[NodeCheckFlags2["LexicalThis"] = 2] = "LexicalThis";
	        NodeCheckFlags2[NodeCheckFlags2["CaptureThis"] = 4] = "CaptureThis";
	        NodeCheckFlags2[NodeCheckFlags2["CaptureNewTarget"] = 8] = "CaptureNewTarget";
	        NodeCheckFlags2[NodeCheckFlags2["SuperInstance"] = 16] = "SuperInstance";
	        NodeCheckFlags2[NodeCheckFlags2["SuperStatic"] = 32] = "SuperStatic";
	        NodeCheckFlags2[NodeCheckFlags2["ContextChecked"] = 64] = "ContextChecked";
	        NodeCheckFlags2[NodeCheckFlags2["MethodWithSuperPropertyAccessInAsync"] = 128] = "MethodWithSuperPropertyAccessInAsync";
	        NodeCheckFlags2[NodeCheckFlags2["MethodWithSuperPropertyAssignmentInAsync"] = 256] = "MethodWithSuperPropertyAssignmentInAsync";
	        NodeCheckFlags2[NodeCheckFlags2["CaptureArguments"] = 512] = "CaptureArguments";
	        NodeCheckFlags2[NodeCheckFlags2["EnumValuesComputed"] = 1024] = "EnumValuesComputed";
	        NodeCheckFlags2[NodeCheckFlags2["LexicalModuleMergesWithClass"] = 2048] = "LexicalModuleMergesWithClass";
	        NodeCheckFlags2[NodeCheckFlags2["LoopWithCapturedBlockScopedBinding"] = 4096] = "LoopWithCapturedBlockScopedBinding";
	        NodeCheckFlags2[NodeCheckFlags2["ContainsCapturedBlockScopeBinding"] = 8192] = "ContainsCapturedBlockScopeBinding";
	        NodeCheckFlags2[NodeCheckFlags2["CapturedBlockScopedBinding"] = 16384] = "CapturedBlockScopedBinding";
	        NodeCheckFlags2[NodeCheckFlags2["BlockScopedBindingInLoop"] = 32768] = "BlockScopedBindingInLoop";
	        NodeCheckFlags2[NodeCheckFlags2["NeedsLoopOutParameter"] = 65536] = "NeedsLoopOutParameter";
	        NodeCheckFlags2[NodeCheckFlags2["AssignmentsMarked"] = 131072] = "AssignmentsMarked";
	        NodeCheckFlags2[NodeCheckFlags2["ContainsConstructorReference"] = 262144] = "ContainsConstructorReference";
	        NodeCheckFlags2[NodeCheckFlags2["ConstructorReference"] = 536870912] = "ConstructorReference";
	        NodeCheckFlags2[NodeCheckFlags2["ContainsClassWithPrivateIdentifiers"] = 1048576] = "ContainsClassWithPrivateIdentifiers";
	        NodeCheckFlags2[NodeCheckFlags2["ContainsSuperPropertyInStaticInitializer"] = 2097152] = "ContainsSuperPropertyInStaticInitializer";
	        NodeCheckFlags2[NodeCheckFlags2["InCheckIdentifier"] = 4194304] = "InCheckIdentifier";
	        return NodeCheckFlags2;
	      })(NodeCheckFlags || {});
	      TypeFlags = /* @__PURE__ */ ((TypeFlags2) => {
	        TypeFlags2[TypeFlags2["Any"] = 1] = "Any";
	        TypeFlags2[TypeFlags2["Unknown"] = 2] = "Unknown";
	        TypeFlags2[TypeFlags2["String"] = 4] = "String";
	        TypeFlags2[TypeFlags2["Number"] = 8] = "Number";
	        TypeFlags2[TypeFlags2["Boolean"] = 16] = "Boolean";
	        TypeFlags2[TypeFlags2["Enum"] = 32] = "Enum";
	        TypeFlags2[TypeFlags2["BigInt"] = 64] = "BigInt";
	        TypeFlags2[TypeFlags2["StringLiteral"] = 128] = "StringLiteral";
	        TypeFlags2[TypeFlags2["NumberLiteral"] = 256] = "NumberLiteral";
	        TypeFlags2[TypeFlags2["BooleanLiteral"] = 512] = "BooleanLiteral";
	        TypeFlags2[TypeFlags2["EnumLiteral"] = 1024] = "EnumLiteral";
	        TypeFlags2[TypeFlags2["BigIntLiteral"] = 2048] = "BigIntLiteral";
	        TypeFlags2[TypeFlags2["ESSymbol"] = 4096] = "ESSymbol";
	        TypeFlags2[TypeFlags2["UniqueESSymbol"] = 8192] = "UniqueESSymbol";
	        TypeFlags2[TypeFlags2["Void"] = 16384] = "Void";
	        TypeFlags2[TypeFlags2["Undefined"] = 32768] = "Undefined";
	        TypeFlags2[TypeFlags2["Null"] = 65536] = "Null";
	        TypeFlags2[TypeFlags2["Never"] = 131072] = "Never";
	        TypeFlags2[TypeFlags2["TypeParameter"] = 262144] = "TypeParameter";
	        TypeFlags2[TypeFlags2["Object"] = 524288] = "Object";
	        TypeFlags2[TypeFlags2["Union"] = 1048576] = "Union";
	        TypeFlags2[TypeFlags2["Intersection"] = 2097152] = "Intersection";
	        TypeFlags2[TypeFlags2["Index"] = 4194304] = "Index";
	        TypeFlags2[TypeFlags2["IndexedAccess"] = 8388608] = "IndexedAccess";
	        TypeFlags2[TypeFlags2["Conditional"] = 16777216] = "Conditional";
	        TypeFlags2[TypeFlags2["Substitution"] = 33554432] = "Substitution";
	        TypeFlags2[TypeFlags2["NonPrimitive"] = 67108864] = "NonPrimitive";
	        TypeFlags2[TypeFlags2["TemplateLiteral"] = 134217728] = "TemplateLiteral";
	        TypeFlags2[TypeFlags2["StringMapping"] = 268435456] = "StringMapping";
	        TypeFlags2[TypeFlags2["Reserved1"] = 536870912] = "Reserved1";
	        TypeFlags2[TypeFlags2["AnyOrUnknown"] = 3] = "AnyOrUnknown";
	        TypeFlags2[TypeFlags2["Nullable"] = 98304] = "Nullable";
	        TypeFlags2[TypeFlags2["Literal"] = 2944] = "Literal";
	        TypeFlags2[TypeFlags2["Unit"] = 109472] = "Unit";
	        TypeFlags2[TypeFlags2["Freshable"] = 2976] = "Freshable";
	        TypeFlags2[TypeFlags2["StringOrNumberLiteral"] = 384] = "StringOrNumberLiteral";
	        TypeFlags2[TypeFlags2["StringOrNumberLiteralOrUnique"] = 8576] = "StringOrNumberLiteralOrUnique";
	        TypeFlags2[TypeFlags2["DefinitelyFalsy"] = 117632] = "DefinitelyFalsy";
	        TypeFlags2[TypeFlags2["PossiblyFalsy"] = 117724] = "PossiblyFalsy";
	        TypeFlags2[TypeFlags2["Intrinsic"] = 67359327] = "Intrinsic";
	        TypeFlags2[TypeFlags2["StringLike"] = 402653316] = "StringLike";
	        TypeFlags2[TypeFlags2["NumberLike"] = 296] = "NumberLike";
	        TypeFlags2[TypeFlags2["BigIntLike"] = 2112] = "BigIntLike";
	        TypeFlags2[TypeFlags2["BooleanLike"] = 528] = "BooleanLike";
	        TypeFlags2[TypeFlags2["EnumLike"] = 1056] = "EnumLike";
	        TypeFlags2[TypeFlags2["ESSymbolLike"] = 12288] = "ESSymbolLike";
	        TypeFlags2[TypeFlags2["VoidLike"] = 49152] = "VoidLike";
	        TypeFlags2[TypeFlags2["Primitive"] = 402784252] = "Primitive";
	        TypeFlags2[TypeFlags2["DefinitelyNonNullable"] = 470302716] = "DefinitelyNonNullable";
	        TypeFlags2[TypeFlags2["DisjointDomains"] = 469892092] = "DisjointDomains";
	        TypeFlags2[TypeFlags2["UnionOrIntersection"] = 3145728] = "UnionOrIntersection";
	        TypeFlags2[TypeFlags2["StructuredType"] = 3670016] = "StructuredType";
	        TypeFlags2[TypeFlags2["TypeVariable"] = 8650752] = "TypeVariable";
	        TypeFlags2[TypeFlags2["InstantiableNonPrimitive"] = 58982400] = "InstantiableNonPrimitive";
	        TypeFlags2[TypeFlags2["InstantiablePrimitive"] = 406847488] = "InstantiablePrimitive";
	        TypeFlags2[TypeFlags2["Instantiable"] = 465829888] = "Instantiable";
	        TypeFlags2[TypeFlags2["StructuredOrInstantiable"] = 469499904] = "StructuredOrInstantiable";
	        TypeFlags2[TypeFlags2["ObjectFlagsType"] = 3899393] = "ObjectFlagsType";
	        TypeFlags2[TypeFlags2["Simplifiable"] = 25165824] = "Simplifiable";
	        TypeFlags2[TypeFlags2["Singleton"] = 67358815] = "Singleton";
	        TypeFlags2[TypeFlags2["Narrowable"] = 536624127] = "Narrowable";
	        TypeFlags2[TypeFlags2["IncludesMask"] = 473694207] = "IncludesMask";
	        TypeFlags2[TypeFlags2["IncludesMissingType"] = 262144 /* TypeParameter */] = "IncludesMissingType";
	        TypeFlags2[TypeFlags2["IncludesNonWideningType"] = 4194304 /* Index */] = "IncludesNonWideningType";
	        TypeFlags2[TypeFlags2["IncludesWildcard"] = 8388608 /* IndexedAccess */] = "IncludesWildcard";
	        TypeFlags2[TypeFlags2["IncludesEmptyObject"] = 16777216 /* Conditional */] = "IncludesEmptyObject";
	        TypeFlags2[TypeFlags2["IncludesInstantiable"] = 33554432 /* Substitution */] = "IncludesInstantiable";
	        TypeFlags2[TypeFlags2["IncludesConstrainedTypeVariable"] = 536870912 /* Reserved1 */] = "IncludesConstrainedTypeVariable";
	        TypeFlags2[TypeFlags2["NotPrimitiveUnion"] = 36323331] = "NotPrimitiveUnion";
	        return TypeFlags2;
	      })(TypeFlags || {});
	      ObjectFlags = /* @__PURE__ */ ((ObjectFlags3) => {
	        ObjectFlags3[ObjectFlags3["None"] = 0] = "None";
	        ObjectFlags3[ObjectFlags3["Class"] = 1] = "Class";
	        ObjectFlags3[ObjectFlags3["Interface"] = 2] = "Interface";
	        ObjectFlags3[ObjectFlags3["Reference"] = 4] = "Reference";
	        ObjectFlags3[ObjectFlags3["Tuple"] = 8] = "Tuple";
	        ObjectFlags3[ObjectFlags3["Anonymous"] = 16] = "Anonymous";
	        ObjectFlags3[ObjectFlags3["Mapped"] = 32] = "Mapped";
	        ObjectFlags3[ObjectFlags3["Instantiated"] = 64] = "Instantiated";
	        ObjectFlags3[ObjectFlags3["ObjectLiteral"] = 128] = "ObjectLiteral";
	        ObjectFlags3[ObjectFlags3["EvolvingArray"] = 256] = "EvolvingArray";
	        ObjectFlags3[ObjectFlags3["ObjectLiteralPatternWithComputedProperties"] = 512] = "ObjectLiteralPatternWithComputedProperties";
	        ObjectFlags3[ObjectFlags3["ReverseMapped"] = 1024] = "ReverseMapped";
	        ObjectFlags3[ObjectFlags3["JsxAttributes"] = 2048] = "JsxAttributes";
	        ObjectFlags3[ObjectFlags3["JSLiteral"] = 4096] = "JSLiteral";
	        ObjectFlags3[ObjectFlags3["FreshLiteral"] = 8192] = "FreshLiteral";
	        ObjectFlags3[ObjectFlags3["ArrayLiteral"] = 16384] = "ArrayLiteral";
	        ObjectFlags3[ObjectFlags3["PrimitiveUnion"] = 32768] = "PrimitiveUnion";
	        ObjectFlags3[ObjectFlags3["ContainsWideningType"] = 65536] = "ContainsWideningType";
	        ObjectFlags3[ObjectFlags3["ContainsObjectOrArrayLiteral"] = 131072] = "ContainsObjectOrArrayLiteral";
	        ObjectFlags3[ObjectFlags3["NonInferrableType"] = 262144] = "NonInferrableType";
	        ObjectFlags3[ObjectFlags3["CouldContainTypeVariablesComputed"] = 524288] = "CouldContainTypeVariablesComputed";
	        ObjectFlags3[ObjectFlags3["CouldContainTypeVariables"] = 1048576] = "CouldContainTypeVariables";
	        ObjectFlags3[ObjectFlags3["ClassOrInterface"] = 3] = "ClassOrInterface";
	        ObjectFlags3[ObjectFlags3["RequiresWidening"] = 196608] = "RequiresWidening";
	        ObjectFlags3[ObjectFlags3["PropagatingFlags"] = 458752] = "PropagatingFlags";
	        ObjectFlags3[ObjectFlags3["InstantiatedMapped"] = 96] = "InstantiatedMapped";
	        ObjectFlags3[ObjectFlags3["ObjectTypeKindMask"] = 1343] = "ObjectTypeKindMask";
	        ObjectFlags3[ObjectFlags3["ContainsSpread"] = 2097152] = "ContainsSpread";
	        ObjectFlags3[ObjectFlags3["ObjectRestType"] = 4194304] = "ObjectRestType";
	        ObjectFlags3[ObjectFlags3["InstantiationExpressionType"] = 8388608] = "InstantiationExpressionType";
	        ObjectFlags3[ObjectFlags3["IsClassInstanceClone"] = 16777216] = "IsClassInstanceClone";
	        ObjectFlags3[ObjectFlags3["IdenticalBaseTypeCalculated"] = 33554432] = "IdenticalBaseTypeCalculated";
	        ObjectFlags3[ObjectFlags3["IdenticalBaseTypeExists"] = 67108864] = "IdenticalBaseTypeExists";
	        ObjectFlags3[ObjectFlags3["IsGenericTypeComputed"] = 2097152] = "IsGenericTypeComputed";
	        ObjectFlags3[ObjectFlags3["IsGenericObjectType"] = 4194304] = "IsGenericObjectType";
	        ObjectFlags3[ObjectFlags3["IsGenericIndexType"] = 8388608] = "IsGenericIndexType";
	        ObjectFlags3[ObjectFlags3["IsGenericType"] = 12582912] = "IsGenericType";
	        ObjectFlags3[ObjectFlags3["ContainsIntersections"] = 16777216] = "ContainsIntersections";
	        ObjectFlags3[ObjectFlags3["IsUnknownLikeUnionComputed"] = 33554432] = "IsUnknownLikeUnionComputed";
	        ObjectFlags3[ObjectFlags3["IsUnknownLikeUnion"] = 67108864] = "IsUnknownLikeUnion";
	        ObjectFlags3[ObjectFlags3["IsNeverIntersectionComputed"] = 16777216] = "IsNeverIntersectionComputed";
	        ObjectFlags3[ObjectFlags3["IsNeverIntersection"] = 33554432] = "IsNeverIntersection";
	        ObjectFlags3[ObjectFlags3["IsConstrainedTypeVariable"] = 67108864] = "IsConstrainedTypeVariable";
	        return ObjectFlags3;
	      })(ObjectFlags || {});
	      VarianceFlags = /* @__PURE__ */ ((VarianceFlags2) => {
	        VarianceFlags2[VarianceFlags2["Invariant"] = 0] = "Invariant";
	        VarianceFlags2[VarianceFlags2["Covariant"] = 1] = "Covariant";
	        VarianceFlags2[VarianceFlags2["Contravariant"] = 2] = "Contravariant";
	        VarianceFlags2[VarianceFlags2["Bivariant"] = 3] = "Bivariant";
	        VarianceFlags2[VarianceFlags2["Independent"] = 4] = "Independent";
	        VarianceFlags2[VarianceFlags2["VarianceMask"] = 7] = "VarianceMask";
	        VarianceFlags2[VarianceFlags2["Unmeasurable"] = 8] = "Unmeasurable";
	        VarianceFlags2[VarianceFlags2["Unreliable"] = 16] = "Unreliable";
	        VarianceFlags2[VarianceFlags2["AllowsStructuralFallback"] = 24] = "AllowsStructuralFallback";
	        return VarianceFlags2;
	      })(VarianceFlags || {});
	      ElementFlags = /* @__PURE__ */ ((ElementFlags2) => {
	        ElementFlags2[ElementFlags2["Required"] = 1] = "Required";
	        ElementFlags2[ElementFlags2["Optional"] = 2] = "Optional";
	        ElementFlags2[ElementFlags2["Rest"] = 4] = "Rest";
	        ElementFlags2[ElementFlags2["Variadic"] = 8] = "Variadic";
	        ElementFlags2[ElementFlags2["Fixed"] = 3] = "Fixed";
	        ElementFlags2[ElementFlags2["Variable"] = 12] = "Variable";
	        ElementFlags2[ElementFlags2["NonRequired"] = 14] = "NonRequired";
	        ElementFlags2[ElementFlags2["NonRest"] = 11] = "NonRest";
	        return ElementFlags2;
	      })(ElementFlags || {});
	      AccessFlags = /* @__PURE__ */ ((AccessFlags2) => {
	        AccessFlags2[AccessFlags2["None"] = 0] = "None";
	        AccessFlags2[AccessFlags2["IncludeUndefined"] = 1] = "IncludeUndefined";
	        AccessFlags2[AccessFlags2["NoIndexSignatures"] = 2] = "NoIndexSignatures";
	        AccessFlags2[AccessFlags2["Writing"] = 4] = "Writing";
	        AccessFlags2[AccessFlags2["CacheSymbol"] = 8] = "CacheSymbol";
	        AccessFlags2[AccessFlags2["NoTupleBoundsCheck"] = 16] = "NoTupleBoundsCheck";
	        AccessFlags2[AccessFlags2["ExpressionPosition"] = 32] = "ExpressionPosition";
	        AccessFlags2[AccessFlags2["ReportDeprecated"] = 64] = "ReportDeprecated";
	        AccessFlags2[AccessFlags2["SuppressNoImplicitAnyError"] = 128] = "SuppressNoImplicitAnyError";
	        AccessFlags2[AccessFlags2["Contextual"] = 256] = "Contextual";
	        AccessFlags2[AccessFlags2["Persistent"] = 1 /* IncludeUndefined */] = "Persistent";
	        return AccessFlags2;
	      })(AccessFlags || {});
	      IndexFlags = /* @__PURE__ */ ((IndexFlags2) => {
	        IndexFlags2[IndexFlags2["None"] = 0] = "None";
	        IndexFlags2[IndexFlags2["StringsOnly"] = 1] = "StringsOnly";
	        IndexFlags2[IndexFlags2["NoIndexSignatures"] = 2] = "NoIndexSignatures";
	        IndexFlags2[IndexFlags2["NoReducibleCheck"] = 4] = "NoReducibleCheck";
	        return IndexFlags2;
	      })(IndexFlags || {});
	      JsxReferenceKind = /* @__PURE__ */ ((JsxReferenceKind2) => {
	        JsxReferenceKind2[JsxReferenceKind2["Component"] = 0] = "Component";
	        JsxReferenceKind2[JsxReferenceKind2["Function"] = 1] = "Function";
	        JsxReferenceKind2[JsxReferenceKind2["Mixed"] = 2] = "Mixed";
	        return JsxReferenceKind2;
	      })(JsxReferenceKind || {});
	      SignatureKind = /* @__PURE__ */ ((SignatureKind2) => {
	        SignatureKind2[SignatureKind2["Call"] = 0] = "Call";
	        SignatureKind2[SignatureKind2["Construct"] = 1] = "Construct";
	        return SignatureKind2;
	      })(SignatureKind || {});
	      SignatureFlags = /* @__PURE__ */ ((SignatureFlags5) => {
	        SignatureFlags5[SignatureFlags5["None"] = 0] = "None";
	        SignatureFlags5[SignatureFlags5["HasRestParameter"] = 1] = "HasRestParameter";
	        SignatureFlags5[SignatureFlags5["HasLiteralTypes"] = 2] = "HasLiteralTypes";
	        SignatureFlags5[SignatureFlags5["Abstract"] = 4] = "Abstract";
	        SignatureFlags5[SignatureFlags5["IsInnerCallChain"] = 8] = "IsInnerCallChain";
	        SignatureFlags5[SignatureFlags5["IsOuterCallChain"] = 16] = "IsOuterCallChain";
	        SignatureFlags5[SignatureFlags5["IsUntypedSignatureInJSFile"] = 32] = "IsUntypedSignatureInJSFile";
	        SignatureFlags5[SignatureFlags5["IsNonInferrable"] = 64] = "IsNonInferrable";
	        SignatureFlags5[SignatureFlags5["IsSignatureCandidateForOverloadFailure"] = 128] = "IsSignatureCandidateForOverloadFailure";
	        SignatureFlags5[SignatureFlags5["PropagatingFlags"] = 167] = "PropagatingFlags";
	        SignatureFlags5[SignatureFlags5["CallChainFlags"] = 24] = "CallChainFlags";
	        return SignatureFlags5;
	      })(SignatureFlags || {});
	      IndexKind = /* @__PURE__ */ ((IndexKind2) => {
	        IndexKind2[IndexKind2["String"] = 0] = "String";
	        IndexKind2[IndexKind2["Number"] = 1] = "Number";
	        return IndexKind2;
	      })(IndexKind || {});
	      TypeMapKind = /* @__PURE__ */ ((TypeMapKind2) => {
	        TypeMapKind2[TypeMapKind2["Simple"] = 0] = "Simple";
	        TypeMapKind2[TypeMapKind2["Array"] = 1] = "Array";
	        TypeMapKind2[TypeMapKind2["Deferred"] = 2] = "Deferred";
	        TypeMapKind2[TypeMapKind2["Function"] = 3] = "Function";
	        TypeMapKind2[TypeMapKind2["Composite"] = 4] = "Composite";
	        TypeMapKind2[TypeMapKind2["Merged"] = 5] = "Merged";
	        return TypeMapKind2;
	      })(TypeMapKind || {});
	      InferencePriority = /* @__PURE__ */ ((InferencePriority2) => {
	        InferencePriority2[InferencePriority2["None"] = 0] = "None";
	        InferencePriority2[InferencePriority2["NakedTypeVariable"] = 1] = "NakedTypeVariable";
	        InferencePriority2[InferencePriority2["SpeculativeTuple"] = 2] = "SpeculativeTuple";
	        InferencePriority2[InferencePriority2["SubstituteSource"] = 4] = "SubstituteSource";
	        InferencePriority2[InferencePriority2["HomomorphicMappedType"] = 8] = "HomomorphicMappedType";
	        InferencePriority2[InferencePriority2["PartialHomomorphicMappedType"] = 16] = "PartialHomomorphicMappedType";
	        InferencePriority2[InferencePriority2["MappedTypeConstraint"] = 32] = "MappedTypeConstraint";
	        InferencePriority2[InferencePriority2["ContravariantConditional"] = 64] = "ContravariantConditional";
	        InferencePriority2[InferencePriority2["ReturnType"] = 128] = "ReturnType";
	        InferencePriority2[InferencePriority2["LiteralKeyof"] = 256] = "LiteralKeyof";
	        InferencePriority2[InferencePriority2["NoConstraints"] = 512] = "NoConstraints";
	        InferencePriority2[InferencePriority2["AlwaysStrict"] = 1024] = "AlwaysStrict";
	        InferencePriority2[InferencePriority2["MaxValue"] = 2048] = "MaxValue";
	        InferencePriority2[InferencePriority2["PriorityImpliesCombination"] = 416] = "PriorityImpliesCombination";
	        InferencePriority2[InferencePriority2["Circularity"] = -1] = "Circularity";
	        return InferencePriority2;
	      })(InferencePriority || {});
	      InferenceFlags = /* @__PURE__ */ ((InferenceFlags2) => {
	        InferenceFlags2[InferenceFlags2["None"] = 0] = "None";
	        InferenceFlags2[InferenceFlags2["NoDefault"] = 1] = "NoDefault";
	        InferenceFlags2[InferenceFlags2["AnyDefault"] = 2] = "AnyDefault";
	        InferenceFlags2[InferenceFlags2["SkippedGenericFunction"] = 4] = "SkippedGenericFunction";
	        return InferenceFlags2;
	      })(InferenceFlags || {});
	      Ternary = /* @__PURE__ */ ((Ternary2) => {
	        Ternary2[Ternary2["False"] = 0] = "False";
	        Ternary2[Ternary2["Unknown"] = 1] = "Unknown";
	        Ternary2[Ternary2["Maybe"] = 3] = "Maybe";
	        Ternary2[Ternary2["True"] = -1] = "True";
	        return Ternary2;
	      })(Ternary || {});
	      AssignmentDeclarationKind = /* @__PURE__ */ ((AssignmentDeclarationKind2) => {
	        AssignmentDeclarationKind2[AssignmentDeclarationKind2["None"] = 0] = "None";
	        AssignmentDeclarationKind2[AssignmentDeclarationKind2["ExportsProperty"] = 1] = "ExportsProperty";
	        AssignmentDeclarationKind2[AssignmentDeclarationKind2["ModuleExports"] = 2] = "ModuleExports";
	        AssignmentDeclarationKind2[AssignmentDeclarationKind2["PrototypeProperty"] = 3] = "PrototypeProperty";
	        AssignmentDeclarationKind2[AssignmentDeclarationKind2["ThisProperty"] = 4] = "ThisProperty";
	        AssignmentDeclarationKind2[AssignmentDeclarationKind2["Property"] = 5] = "Property";
	        AssignmentDeclarationKind2[AssignmentDeclarationKind2["Prototype"] = 6] = "Prototype";
	        AssignmentDeclarationKind2[AssignmentDeclarationKind2["ObjectDefinePropertyValue"] = 7] = "ObjectDefinePropertyValue";
	        AssignmentDeclarationKind2[AssignmentDeclarationKind2["ObjectDefinePropertyExports"] = 8] = "ObjectDefinePropertyExports";
	        AssignmentDeclarationKind2[AssignmentDeclarationKind2["ObjectDefinePrototypeProperty"] = 9] = "ObjectDefinePrototypeProperty";
	        return AssignmentDeclarationKind2;
	      })(AssignmentDeclarationKind || {});
	      DiagnosticCategory = /* @__PURE__ */ ((DiagnosticCategory2) => {
	        DiagnosticCategory2[DiagnosticCategory2["Warning"] = 0] = "Warning";
	        DiagnosticCategory2[DiagnosticCategory2["Error"] = 1] = "Error";
	        DiagnosticCategory2[DiagnosticCategory2["Suggestion"] = 2] = "Suggestion";
	        DiagnosticCategory2[DiagnosticCategory2["Message"] = 3] = "Message";
	        return DiagnosticCategory2;
	      })(DiagnosticCategory || {});
	      ModuleResolutionKind = /* @__PURE__ */ ((ModuleResolutionKind3) => {
	        ModuleResolutionKind3[ModuleResolutionKind3["Classic"] = 1] = "Classic";
	        ModuleResolutionKind3[ModuleResolutionKind3["NodeJs"] = 2] = "NodeJs";
	        ModuleResolutionKind3[ModuleResolutionKind3["Node10"] = 2] = "Node10";
	        ModuleResolutionKind3[ModuleResolutionKind3["Node16"] = 3] = "Node16";
	        ModuleResolutionKind3[ModuleResolutionKind3["NodeNext"] = 99] = "NodeNext";
	        ModuleResolutionKind3[ModuleResolutionKind3["Bundler"] = 100] = "Bundler";
	        return ModuleResolutionKind3;
	      })(ModuleResolutionKind || {});
	      ModuleDetectionKind = /* @__PURE__ */ ((ModuleDetectionKind2) => {
	        ModuleDetectionKind2[ModuleDetectionKind2["Legacy"] = 1] = "Legacy";
	        ModuleDetectionKind2[ModuleDetectionKind2["Auto"] = 2] = "Auto";
	        ModuleDetectionKind2[ModuleDetectionKind2["Force"] = 3] = "Force";
	        return ModuleDetectionKind2;
	      })(ModuleDetectionKind || {});
	      WatchFileKind = /* @__PURE__ */ ((WatchFileKind3) => {
	        WatchFileKind3[WatchFileKind3["FixedPollingInterval"] = 0] = "FixedPollingInterval";
	        WatchFileKind3[WatchFileKind3["PriorityPollingInterval"] = 1] = "PriorityPollingInterval";
	        WatchFileKind3[WatchFileKind3["DynamicPriorityPolling"] = 2] = "DynamicPriorityPolling";
	        WatchFileKind3[WatchFileKind3["FixedChunkSizePolling"] = 3] = "FixedChunkSizePolling";
	        WatchFileKind3[WatchFileKind3["UseFsEvents"] = 4] = "UseFsEvents";
	        WatchFileKind3[WatchFileKind3["UseFsEventsOnParentDirectory"] = 5] = "UseFsEventsOnParentDirectory";
	        return WatchFileKind3;
	      })(WatchFileKind || {});
	      WatchDirectoryKind = /* @__PURE__ */ ((WatchDirectoryKind3) => {
	        WatchDirectoryKind3[WatchDirectoryKind3["UseFsEvents"] = 0] = "UseFsEvents";
	        WatchDirectoryKind3[WatchDirectoryKind3["FixedPollingInterval"] = 1] = "FixedPollingInterval";
	        WatchDirectoryKind3[WatchDirectoryKind3["DynamicPriorityPolling"] = 2] = "DynamicPriorityPolling";
	        WatchDirectoryKind3[WatchDirectoryKind3["FixedChunkSizePolling"] = 3] = "FixedChunkSizePolling";
	        return WatchDirectoryKind3;
	      })(WatchDirectoryKind || {});
	      PollingWatchKind = /* @__PURE__ */ ((PollingWatchKind3) => {
	        PollingWatchKind3[PollingWatchKind3["FixedInterval"] = 0] = "FixedInterval";
	        PollingWatchKind3[PollingWatchKind3["PriorityInterval"] = 1] = "PriorityInterval";
	        PollingWatchKind3[PollingWatchKind3["DynamicPriority"] = 2] = "DynamicPriority";
	        PollingWatchKind3[PollingWatchKind3["FixedChunkSize"] = 3] = "FixedChunkSize";
	        return PollingWatchKind3;
	      })(PollingWatchKind || {});
	      ModuleKind = /* @__PURE__ */ ((ModuleKind3) => {
	        ModuleKind3[ModuleKind3["None"] = 0] = "None";
	        ModuleKind3[ModuleKind3["CommonJS"] = 1] = "CommonJS";
	        ModuleKind3[ModuleKind3["AMD"] = 2] = "AMD";
	        ModuleKind3[ModuleKind3["UMD"] = 3] = "UMD";
	        ModuleKind3[ModuleKind3["System"] = 4] = "System";
	        ModuleKind3[ModuleKind3["ES2015"] = 5] = "ES2015";
	        ModuleKind3[ModuleKind3["ES2020"] = 6] = "ES2020";
	        ModuleKind3[ModuleKind3["ES2022"] = 7] = "ES2022";
	        ModuleKind3[ModuleKind3["ESNext"] = 99] = "ESNext";
	        ModuleKind3[ModuleKind3["Node16"] = 100] = "Node16";
	        ModuleKind3[ModuleKind3["NodeNext"] = 199] = "NodeNext";
	        ModuleKind3[ModuleKind3["Preserve"] = 200] = "Preserve";
	        return ModuleKind3;
	      })(ModuleKind || {});
	      JsxEmit = /* @__PURE__ */ ((JsxEmit3) => {
	        JsxEmit3[JsxEmit3["None"] = 0] = "None";
	        JsxEmit3[JsxEmit3["Preserve"] = 1] = "Preserve";
	        JsxEmit3[JsxEmit3["React"] = 2] = "React";
	        JsxEmit3[JsxEmit3["ReactNative"] = 3] = "ReactNative";
	        JsxEmit3[JsxEmit3["ReactJSX"] = 4] = "ReactJSX";
	        JsxEmit3[JsxEmit3["ReactJSXDev"] = 5] = "ReactJSXDev";
	        return JsxEmit3;
	      })(JsxEmit || {});
	      ImportsNotUsedAsValues = /* @__PURE__ */ ((ImportsNotUsedAsValues2) => {
	        ImportsNotUsedAsValues2[ImportsNotUsedAsValues2["Remove"] = 0] = "Remove";
	        ImportsNotUsedAsValues2[ImportsNotUsedAsValues2["Preserve"] = 1] = "Preserve";
	        ImportsNotUsedAsValues2[ImportsNotUsedAsValues2["Error"] = 2] = "Error";
	        return ImportsNotUsedAsValues2;
	      })(ImportsNotUsedAsValues || {});
	      NewLineKind = /* @__PURE__ */ ((NewLineKind3) => {
	        NewLineKind3[NewLineKind3["CarriageReturnLineFeed"] = 0] = "CarriageReturnLineFeed";
	        NewLineKind3[NewLineKind3["LineFeed"] = 1] = "LineFeed";
	        return NewLineKind3;
	      })(NewLineKind || {});
	      ScriptKind = /* @__PURE__ */ ((ScriptKind7) => {
	        ScriptKind7[ScriptKind7["Unknown"] = 0] = "Unknown";
	        ScriptKind7[ScriptKind7["JS"] = 1] = "JS";
	        ScriptKind7[ScriptKind7["JSX"] = 2] = "JSX";
	        ScriptKind7[ScriptKind7["TS"] = 3] = "TS";
	        ScriptKind7[ScriptKind7["TSX"] = 4] = "TSX";
	        ScriptKind7[ScriptKind7["External"] = 5] = "External";
	        ScriptKind7[ScriptKind7["JSON"] = 6] = "JSON";
	        ScriptKind7[ScriptKind7["Deferred"] = 7] = "Deferred";
	        return ScriptKind7;
	      })(ScriptKind || {});
	      ScriptTarget = /* @__PURE__ */ ((ScriptTarget11) => {
	        ScriptTarget11[ScriptTarget11["ES3"] = 0] = "ES3";
	        ScriptTarget11[ScriptTarget11["ES5"] = 1] = "ES5";
	        ScriptTarget11[ScriptTarget11["ES2015"] = 2] = "ES2015";
	        ScriptTarget11[ScriptTarget11["ES2016"] = 3] = "ES2016";
	        ScriptTarget11[ScriptTarget11["ES2017"] = 4] = "ES2017";
	        ScriptTarget11[ScriptTarget11["ES2018"] = 5] = "ES2018";
	        ScriptTarget11[ScriptTarget11["ES2019"] = 6] = "ES2019";
	        ScriptTarget11[ScriptTarget11["ES2020"] = 7] = "ES2020";
	        ScriptTarget11[ScriptTarget11["ES2021"] = 8] = "ES2021";
	        ScriptTarget11[ScriptTarget11["ES2022"] = 9] = "ES2022";
	        ScriptTarget11[ScriptTarget11["ESNext"] = 99] = "ESNext";
	        ScriptTarget11[ScriptTarget11["JSON"] = 100] = "JSON";
	        ScriptTarget11[ScriptTarget11["Latest"] = 99 /* ESNext */] = "Latest";
	        return ScriptTarget11;
	      })(ScriptTarget || {});
	      LanguageVariant = /* @__PURE__ */ ((LanguageVariant4) => {
	        LanguageVariant4[LanguageVariant4["Standard"] = 0] = "Standard";
	        LanguageVariant4[LanguageVariant4["JSX"] = 1] = "JSX";
	        return LanguageVariant4;
	      })(LanguageVariant || {});
	      WatchDirectoryFlags = /* @__PURE__ */ ((WatchDirectoryFlags3) => {
	        WatchDirectoryFlags3[WatchDirectoryFlags3["None"] = 0] = "None";
	        WatchDirectoryFlags3[WatchDirectoryFlags3["Recursive"] = 1] = "Recursive";
	        return WatchDirectoryFlags3;
	      })(WatchDirectoryFlags || {});
	      CharacterCodes = /* @__PURE__ */ ((CharacterCodes2) => {
	        CharacterCodes2[CharacterCodes2["nullCharacter"] = 0] = "nullCharacter";
	        CharacterCodes2[CharacterCodes2["maxAsciiCharacter"] = 127] = "maxAsciiCharacter";
	        CharacterCodes2[CharacterCodes2["lineFeed"] = 10] = "lineFeed";
	        CharacterCodes2[CharacterCodes2["carriageReturn"] = 13] = "carriageReturn";
	        CharacterCodes2[CharacterCodes2["lineSeparator"] = 8232] = "lineSeparator";
	        CharacterCodes2[CharacterCodes2["paragraphSeparator"] = 8233] = "paragraphSeparator";
	        CharacterCodes2[CharacterCodes2["nextLine"] = 133] = "nextLine";
	        CharacterCodes2[CharacterCodes2["space"] = 32] = "space";
	        CharacterCodes2[CharacterCodes2["nonBreakingSpace"] = 160] = "nonBreakingSpace";
	        CharacterCodes2[CharacterCodes2["enQuad"] = 8192] = "enQuad";
	        CharacterCodes2[CharacterCodes2["emQuad"] = 8193] = "emQuad";
	        CharacterCodes2[CharacterCodes2["enSpace"] = 8194] = "enSpace";
	        CharacterCodes2[CharacterCodes2["emSpace"] = 8195] = "emSpace";
	        CharacterCodes2[CharacterCodes2["threePerEmSpace"] = 8196] = "threePerEmSpace";
	        CharacterCodes2[CharacterCodes2["fourPerEmSpace"] = 8197] = "fourPerEmSpace";
	        CharacterCodes2[CharacterCodes2["sixPerEmSpace"] = 8198] = "sixPerEmSpace";
	        CharacterCodes2[CharacterCodes2["figureSpace"] = 8199] = "figureSpace";
	        CharacterCodes2[CharacterCodes2["punctuationSpace"] = 8200] = "punctuationSpace";
	        CharacterCodes2[CharacterCodes2["thinSpace"] = 8201] = "thinSpace";
	        CharacterCodes2[CharacterCodes2["hairSpace"] = 8202] = "hairSpace";
	        CharacterCodes2[CharacterCodes2["zeroWidthSpace"] = 8203] = "zeroWidthSpace";
	        CharacterCodes2[CharacterCodes2["narrowNoBreakSpace"] = 8239] = "narrowNoBreakSpace";
	        CharacterCodes2[CharacterCodes2["ideographicSpace"] = 12288] = "ideographicSpace";
	        CharacterCodes2[CharacterCodes2["mathematicalSpace"] = 8287] = "mathematicalSpace";
	        CharacterCodes2[CharacterCodes2["ogham"] = 5760] = "ogham";
	        CharacterCodes2[CharacterCodes2["_"] = 95] = "_";
	        CharacterCodes2[CharacterCodes2["$"] = 36] = "$";
	        CharacterCodes2[CharacterCodes2["_0"] = 48] = "_0";
	        CharacterCodes2[CharacterCodes2["_1"] = 49] = "_1";
	        CharacterCodes2[CharacterCodes2["_2"] = 50] = "_2";
	        CharacterCodes2[CharacterCodes2["_3"] = 51] = "_3";
	        CharacterCodes2[CharacterCodes2["_4"] = 52] = "_4";
	        CharacterCodes2[CharacterCodes2["_5"] = 53] = "_5";
	        CharacterCodes2[CharacterCodes2["_6"] = 54] = "_6";
	        CharacterCodes2[CharacterCodes2["_7"] = 55] = "_7";
	        CharacterCodes2[CharacterCodes2["_8"] = 56] = "_8";
	        CharacterCodes2[CharacterCodes2["_9"] = 57] = "_9";
	        CharacterCodes2[CharacterCodes2["a"] = 97] = "a";
	        CharacterCodes2[CharacterCodes2["b"] = 98] = "b";
	        CharacterCodes2[CharacterCodes2["c"] = 99] = "c";
	        CharacterCodes2[CharacterCodes2["d"] = 100] = "d";
	        CharacterCodes2[CharacterCodes2["e"] = 101] = "e";
	        CharacterCodes2[CharacterCodes2["f"] = 102] = "f";
	        CharacterCodes2[CharacterCodes2["g"] = 103] = "g";
	        CharacterCodes2[CharacterCodes2["h"] = 104] = "h";
	        CharacterCodes2[CharacterCodes2["i"] = 105] = "i";
	        CharacterCodes2[CharacterCodes2["j"] = 106] = "j";
	        CharacterCodes2[CharacterCodes2["k"] = 107] = "k";
	        CharacterCodes2[CharacterCodes2["l"] = 108] = "l";
	        CharacterCodes2[CharacterCodes2["m"] = 109] = "m";
	        CharacterCodes2[CharacterCodes2["n"] = 110] = "n";
	        CharacterCodes2[CharacterCodes2["o"] = 111] = "o";
	        CharacterCodes2[CharacterCodes2["p"] = 112] = "p";
	        CharacterCodes2[CharacterCodes2["q"] = 113] = "q";
	        CharacterCodes2[CharacterCodes2["r"] = 114] = "r";
	        CharacterCodes2[CharacterCodes2["s"] = 115] = "s";
	        CharacterCodes2[CharacterCodes2["t"] = 116] = "t";
	        CharacterCodes2[CharacterCodes2["u"] = 117] = "u";
	        CharacterCodes2[CharacterCodes2["v"] = 118] = "v";
	        CharacterCodes2[CharacterCodes2["w"] = 119] = "w";
	        CharacterCodes2[CharacterCodes2["x"] = 120] = "x";
	        CharacterCodes2[CharacterCodes2["y"] = 121] = "y";
	        CharacterCodes2[CharacterCodes2["z"] = 122] = "z";
	        CharacterCodes2[CharacterCodes2["A"] = 65] = "A";
	        CharacterCodes2[CharacterCodes2["B"] = 66] = "B";
	        CharacterCodes2[CharacterCodes2["C"] = 67] = "C";
	        CharacterCodes2[CharacterCodes2["D"] = 68] = "D";
	        CharacterCodes2[CharacterCodes2["E"] = 69] = "E";
	        CharacterCodes2[CharacterCodes2["F"] = 70] = "F";
	        CharacterCodes2[CharacterCodes2["G"] = 71] = "G";
	        CharacterCodes2[CharacterCodes2["H"] = 72] = "H";
	        CharacterCodes2[CharacterCodes2["I"] = 73] = "I";
	        CharacterCodes2[CharacterCodes2["J"] = 74] = "J";
	        CharacterCodes2[CharacterCodes2["K"] = 75] = "K";
	        CharacterCodes2[CharacterCodes2["L"] = 76] = "L";
	        CharacterCodes2[CharacterCodes2["M"] = 77] = "M";
	        CharacterCodes2[CharacterCodes2["N"] = 78] = "N";
	        CharacterCodes2[CharacterCodes2["O"] = 79] = "O";
	        CharacterCodes2[CharacterCodes2["P"] = 80] = "P";
	        CharacterCodes2[CharacterCodes2["Q"] = 81] = "Q";
	        CharacterCodes2[CharacterCodes2["R"] = 82] = "R";
	        CharacterCodes2[CharacterCodes2["S"] = 83] = "S";
	        CharacterCodes2[CharacterCodes2["T"] = 84] = "T";
	        CharacterCodes2[CharacterCodes2["U"] = 85] = "U";
	        CharacterCodes2[CharacterCodes2["V"] = 86] = "V";
	        CharacterCodes2[CharacterCodes2["W"] = 87] = "W";
	        CharacterCodes2[CharacterCodes2["X"] = 88] = "X";
	        CharacterCodes2[CharacterCodes2["Y"] = 89] = "Y";
	        CharacterCodes2[CharacterCodes2["Z"] = 90] = "Z";
	        CharacterCodes2[CharacterCodes2["ampersand"] = 38] = "ampersand";
	        CharacterCodes2[CharacterCodes2["asterisk"] = 42] = "asterisk";
	        CharacterCodes2[CharacterCodes2["at"] = 64] = "at";
	        CharacterCodes2[CharacterCodes2["backslash"] = 92] = "backslash";
	        CharacterCodes2[CharacterCodes2["backtick"] = 96] = "backtick";
	        CharacterCodes2[CharacterCodes2["bar"] = 124] = "bar";
	        CharacterCodes2[CharacterCodes2["caret"] = 94] = "caret";
	        CharacterCodes2[CharacterCodes2["closeBrace"] = 125] = "closeBrace";
	        CharacterCodes2[CharacterCodes2["closeBracket"] = 93] = "closeBracket";
	        CharacterCodes2[CharacterCodes2["closeParen"] = 41] = "closeParen";
	        CharacterCodes2[CharacterCodes2["colon"] = 58] = "colon";
	        CharacterCodes2[CharacterCodes2["comma"] = 44] = "comma";
	        CharacterCodes2[CharacterCodes2["dot"] = 46] = "dot";
	        CharacterCodes2[CharacterCodes2["doubleQuote"] = 34] = "doubleQuote";
	        CharacterCodes2[CharacterCodes2["equals"] = 61] = "equals";
	        CharacterCodes2[CharacterCodes2["exclamation"] = 33] = "exclamation";
	        CharacterCodes2[CharacterCodes2["greaterThan"] = 62] = "greaterThan";
	        CharacterCodes2[CharacterCodes2["hash"] = 35] = "hash";
	        CharacterCodes2[CharacterCodes2["lessThan"] = 60] = "lessThan";
	        CharacterCodes2[CharacterCodes2["minus"] = 45] = "minus";
	        CharacterCodes2[CharacterCodes2["openBrace"] = 123] = "openBrace";
	        CharacterCodes2[CharacterCodes2["openBracket"] = 91] = "openBracket";
	        CharacterCodes2[CharacterCodes2["openParen"] = 40] = "openParen";
	        CharacterCodes2[CharacterCodes2["percent"] = 37] = "percent";
	        CharacterCodes2[CharacterCodes2["plus"] = 43] = "plus";
	        CharacterCodes2[CharacterCodes2["question"] = 63] = "question";
	        CharacterCodes2[CharacterCodes2["semicolon"] = 59] = "semicolon";
	        CharacterCodes2[CharacterCodes2["singleQuote"] = 39] = "singleQuote";
	        CharacterCodes2[CharacterCodes2["slash"] = 47] = "slash";
	        CharacterCodes2[CharacterCodes2["tilde"] = 126] = "tilde";
	        CharacterCodes2[CharacterCodes2["backspace"] = 8] = "backspace";
	        CharacterCodes2[CharacterCodes2["formFeed"] = 12] = "formFeed";
	        CharacterCodes2[CharacterCodes2["byteOrderMark"] = 65279] = "byteOrderMark";
	        CharacterCodes2[CharacterCodes2["tab"] = 9] = "tab";
	        CharacterCodes2[CharacterCodes2["verticalTab"] = 11] = "verticalTab";
	        return CharacterCodes2;
	      })(CharacterCodes || {});
	      Extension = /* @__PURE__ */ ((Extension2) => {
	        Extension2["Ts"] = ".ts";
	        Extension2["Tsx"] = ".tsx";
	        Extension2["Dts"] = ".d.ts";
	        Extension2["Js"] = ".js";
	        Extension2["Jsx"] = ".jsx";
	        Extension2["Json"] = ".json";
	        Extension2["TsBuildInfo"] = ".tsbuildinfo";
	        Extension2["Mjs"] = ".mjs";
	        Extension2["Mts"] = ".mts";
	        Extension2["Dmts"] = ".d.mts";
	        Extension2["Cjs"] = ".cjs";
	        Extension2["Cts"] = ".cts";
	        Extension2["Dcts"] = ".d.cts";
	        return Extension2;
	      })(Extension || {});
	      TransformFlags = /* @__PURE__ */ ((TransformFlags3) => {
	        TransformFlags3[TransformFlags3["None"] = 0] = "None";
	        TransformFlags3[TransformFlags3["ContainsTypeScript"] = 1] = "ContainsTypeScript";
	        TransformFlags3[TransformFlags3["ContainsJsx"] = 2] = "ContainsJsx";
	        TransformFlags3[TransformFlags3["ContainsESNext"] = 4] = "ContainsESNext";
	        TransformFlags3[TransformFlags3["ContainsES2022"] = 8] = "ContainsES2022";
	        TransformFlags3[TransformFlags3["ContainsES2021"] = 16] = "ContainsES2021";
	        TransformFlags3[TransformFlags3["ContainsES2020"] = 32] = "ContainsES2020";
	        TransformFlags3[TransformFlags3["ContainsES2019"] = 64] = "ContainsES2019";
	        TransformFlags3[TransformFlags3["ContainsES2018"] = 128] = "ContainsES2018";
	        TransformFlags3[TransformFlags3["ContainsES2017"] = 256] = "ContainsES2017";
	        TransformFlags3[TransformFlags3["ContainsES2016"] = 512] = "ContainsES2016";
	        TransformFlags3[TransformFlags3["ContainsES2015"] = 1024] = "ContainsES2015";
	        TransformFlags3[TransformFlags3["ContainsGenerator"] = 2048] = "ContainsGenerator";
	        TransformFlags3[TransformFlags3["ContainsDestructuringAssignment"] = 4096] = "ContainsDestructuringAssignment";
	        TransformFlags3[TransformFlags3["ContainsTypeScriptClassSyntax"] = 8192] = "ContainsTypeScriptClassSyntax";
	        TransformFlags3[TransformFlags3["ContainsLexicalThis"] = 16384] = "ContainsLexicalThis";
	        TransformFlags3[TransformFlags3["ContainsRestOrSpread"] = 32768] = "ContainsRestOrSpread";
	        TransformFlags3[TransformFlags3["ContainsObjectRestOrSpread"] = 65536] = "ContainsObjectRestOrSpread";
	        TransformFlags3[TransformFlags3["ContainsComputedPropertyName"] = 131072] = "ContainsComputedPropertyName";
	        TransformFlags3[TransformFlags3["ContainsBlockScopedBinding"] = 262144] = "ContainsBlockScopedBinding";
	        TransformFlags3[TransformFlags3["ContainsBindingPattern"] = 524288] = "ContainsBindingPattern";
	        TransformFlags3[TransformFlags3["ContainsYield"] = 1048576] = "ContainsYield";
	        TransformFlags3[TransformFlags3["ContainsAwait"] = 2097152] = "ContainsAwait";
	        TransformFlags3[TransformFlags3["ContainsHoistedDeclarationOrCompletion"] = 4194304] = "ContainsHoistedDeclarationOrCompletion";
	        TransformFlags3[TransformFlags3["ContainsDynamicImport"] = 8388608] = "ContainsDynamicImport";
	        TransformFlags3[TransformFlags3["ContainsClassFields"] = 16777216] = "ContainsClassFields";
	        TransformFlags3[TransformFlags3["ContainsDecorators"] = 33554432] = "ContainsDecorators";
	        TransformFlags3[TransformFlags3["ContainsPossibleTopLevelAwait"] = 67108864] = "ContainsPossibleTopLevelAwait";
	        TransformFlags3[TransformFlags3["ContainsLexicalSuper"] = 134217728] = "ContainsLexicalSuper";
	        TransformFlags3[TransformFlags3["ContainsUpdateExpressionForIdentifier"] = 268435456] = "ContainsUpdateExpressionForIdentifier";
	        TransformFlags3[TransformFlags3["ContainsPrivateIdentifierInExpression"] = 536870912] = "ContainsPrivateIdentifierInExpression";
	        TransformFlags3[TransformFlags3["HasComputedFlags"] = -2147483648] = "HasComputedFlags";
	        TransformFlags3[TransformFlags3["AssertTypeScript"] = 1 /* ContainsTypeScript */] = "AssertTypeScript";
	        TransformFlags3[TransformFlags3["AssertJsx"] = 2 /* ContainsJsx */] = "AssertJsx";
	        TransformFlags3[TransformFlags3["AssertESNext"] = 4 /* ContainsESNext */] = "AssertESNext";
	        TransformFlags3[TransformFlags3["AssertES2022"] = 8 /* ContainsES2022 */] = "AssertES2022";
	        TransformFlags3[TransformFlags3["AssertES2021"] = 16 /* ContainsES2021 */] = "AssertES2021";
	        TransformFlags3[TransformFlags3["AssertES2020"] = 32 /* ContainsES2020 */] = "AssertES2020";
	        TransformFlags3[TransformFlags3["AssertES2019"] = 64 /* ContainsES2019 */] = "AssertES2019";
	        TransformFlags3[TransformFlags3["AssertES2018"] = 128 /* ContainsES2018 */] = "AssertES2018";
	        TransformFlags3[TransformFlags3["AssertES2017"] = 256 /* ContainsES2017 */] = "AssertES2017";
	        TransformFlags3[TransformFlags3["AssertES2016"] = 512 /* ContainsES2016 */] = "AssertES2016";
	        TransformFlags3[TransformFlags3["AssertES2015"] = 1024 /* ContainsES2015 */] = "AssertES2015";
	        TransformFlags3[TransformFlags3["AssertGenerator"] = 2048 /* ContainsGenerator */] = "AssertGenerator";
	        TransformFlags3[TransformFlags3["AssertDestructuringAssignment"] = 4096 /* ContainsDestructuringAssignment */] = "AssertDestructuringAssignment";
	        TransformFlags3[TransformFlags3["OuterExpressionExcludes"] = -2147483648 /* HasComputedFlags */] = "OuterExpressionExcludes";
	        TransformFlags3[TransformFlags3["PropertyAccessExcludes"] = -2147483648 /* OuterExpressionExcludes */] = "PropertyAccessExcludes";
	        TransformFlags3[TransformFlags3["NodeExcludes"] = -2147483648 /* PropertyAccessExcludes */] = "NodeExcludes";
	        TransformFlags3[TransformFlags3["ArrowFunctionExcludes"] = -2072174592] = "ArrowFunctionExcludes";
	        TransformFlags3[TransformFlags3["FunctionExcludes"] = -1937940480] = "FunctionExcludes";
	        TransformFlags3[TransformFlags3["ConstructorExcludes"] = -1937948672] = "ConstructorExcludes";
	        TransformFlags3[TransformFlags3["MethodOrAccessorExcludes"] = -2005057536] = "MethodOrAccessorExcludes";
	        TransformFlags3[TransformFlags3["PropertyExcludes"] = -2013249536] = "PropertyExcludes";
	        TransformFlags3[TransformFlags3["ClassExcludes"] = -2147344384] = "ClassExcludes";
	        TransformFlags3[TransformFlags3["ModuleExcludes"] = -1941676032] = "ModuleExcludes";
	        TransformFlags3[TransformFlags3["TypeExcludes"] = -2] = "TypeExcludes";
	        TransformFlags3[TransformFlags3["ObjectLiteralExcludes"] = -2147278848] = "ObjectLiteralExcludes";
	        TransformFlags3[TransformFlags3["ArrayLiteralOrCallOrNewExcludes"] = -2147450880] = "ArrayLiteralOrCallOrNewExcludes";
	        TransformFlags3[TransformFlags3["VariableDeclarationListExcludes"] = -2146893824] = "VariableDeclarationListExcludes";
	        TransformFlags3[TransformFlags3["ParameterExcludes"] = -2147483648 /* NodeExcludes */] = "ParameterExcludes";
	        TransformFlags3[TransformFlags3["CatchClauseExcludes"] = -2147418112] = "CatchClauseExcludes";
	        TransformFlags3[TransformFlags3["BindingPatternExcludes"] = -2147450880] = "BindingPatternExcludes";
	        TransformFlags3[TransformFlags3["ContainsLexicalThisOrSuper"] = 134234112] = "ContainsLexicalThisOrSuper";
	        TransformFlags3[TransformFlags3["PropertyNamePropagatingFlags"] = 134234112] = "PropertyNamePropagatingFlags";
	        return TransformFlags3;
	      })(TransformFlags || {});
	      SnippetKind = /* @__PURE__ */ ((SnippetKind3) => {
	        SnippetKind3[SnippetKind3["TabStop"] = 0] = "TabStop";
	        SnippetKind3[SnippetKind3["Placeholder"] = 1] = "Placeholder";
	        SnippetKind3[SnippetKind3["Choice"] = 2] = "Choice";
	        SnippetKind3[SnippetKind3["Variable"] = 3] = "Variable";
	        return SnippetKind3;
	      })(SnippetKind || {});
	      EmitFlags = /* @__PURE__ */ ((EmitFlags3) => {
	        EmitFlags3[EmitFlags3["None"] = 0] = "None";
	        EmitFlags3[EmitFlags3["SingleLine"] = 1] = "SingleLine";
	        EmitFlags3[EmitFlags3["MultiLine"] = 2] = "MultiLine";
	        EmitFlags3[EmitFlags3["AdviseOnEmitNode"] = 4] = "AdviseOnEmitNode";
	        EmitFlags3[EmitFlags3["NoSubstitution"] = 8] = "NoSubstitution";
	        EmitFlags3[EmitFlags3["CapturesThis"] = 16] = "CapturesThis";
	        EmitFlags3[EmitFlags3["NoLeadingSourceMap"] = 32] = "NoLeadingSourceMap";
	        EmitFlags3[EmitFlags3["NoTrailingSourceMap"] = 64] = "NoTrailingSourceMap";
	        EmitFlags3[EmitFlags3["NoSourceMap"] = 96] = "NoSourceMap";
	        EmitFlags3[EmitFlags3["NoNestedSourceMaps"] = 128] = "NoNestedSourceMaps";
	        EmitFlags3[EmitFlags3["NoTokenLeadingSourceMaps"] = 256] = "NoTokenLeadingSourceMaps";
	        EmitFlags3[EmitFlags3["NoTokenTrailingSourceMaps"] = 512] = "NoTokenTrailingSourceMaps";
	        EmitFlags3[EmitFlags3["NoTokenSourceMaps"] = 768] = "NoTokenSourceMaps";
	        EmitFlags3[EmitFlags3["NoLeadingComments"] = 1024] = "NoLeadingComments";
	        EmitFlags3[EmitFlags3["NoTrailingComments"] = 2048] = "NoTrailingComments";
	        EmitFlags3[EmitFlags3["NoComments"] = 3072] = "NoComments";
	        EmitFlags3[EmitFlags3["NoNestedComments"] = 4096] = "NoNestedComments";
	        EmitFlags3[EmitFlags3["HelperName"] = 8192] = "HelperName";
	        EmitFlags3[EmitFlags3["ExportName"] = 16384] = "ExportName";
	        EmitFlags3[EmitFlags3["LocalName"] = 32768] = "LocalName";
	        EmitFlags3[EmitFlags3["InternalName"] = 65536] = "InternalName";
	        EmitFlags3[EmitFlags3["Indented"] = 131072] = "Indented";
	        EmitFlags3[EmitFlags3["NoIndentation"] = 262144] = "NoIndentation";
	        EmitFlags3[EmitFlags3["AsyncFunctionBody"] = 524288] = "AsyncFunctionBody";
	        EmitFlags3[EmitFlags3["ReuseTempVariableScope"] = 1048576] = "ReuseTempVariableScope";
	        EmitFlags3[EmitFlags3["CustomPrologue"] = 2097152] = "CustomPrologue";
	        EmitFlags3[EmitFlags3["NoHoisting"] = 4194304] = "NoHoisting";
	        EmitFlags3[EmitFlags3["Iterator"] = 8388608] = "Iterator";
	        EmitFlags3[EmitFlags3["NoAsciiEscaping"] = 16777216] = "NoAsciiEscaping";
	        return EmitFlags3;
	      })(EmitFlags || {});
	      InternalEmitFlags = /* @__PURE__ */ ((InternalEmitFlags3) => {
	        InternalEmitFlags3[InternalEmitFlags3["None"] = 0] = "None";
	        InternalEmitFlags3[InternalEmitFlags3["TypeScriptClassWrapper"] = 1] = "TypeScriptClassWrapper";
	        InternalEmitFlags3[InternalEmitFlags3["NeverApplyImportHelper"] = 2] = "NeverApplyImportHelper";
	        InternalEmitFlags3[InternalEmitFlags3["IgnoreSourceNewlines"] = 4] = "IgnoreSourceNewlines";
	        InternalEmitFlags3[InternalEmitFlags3["Immutable"] = 8] = "Immutable";
	        InternalEmitFlags3[InternalEmitFlags3["IndirectCall"] = 16] = "IndirectCall";
	        InternalEmitFlags3[InternalEmitFlags3["TransformPrivateStaticElements"] = 32] = "TransformPrivateStaticElements";
	        return InternalEmitFlags3;
	      })(InternalEmitFlags || {});
	      ExternalEmitHelpers = /* @__PURE__ */ ((ExternalEmitHelpers2) => {
	        ExternalEmitHelpers2[ExternalEmitHelpers2["Extends"] = 1] = "Extends";
	        ExternalEmitHelpers2[ExternalEmitHelpers2["Assign"] = 2] = "Assign";
	        ExternalEmitHelpers2[ExternalEmitHelpers2["Rest"] = 4] = "Rest";
	        ExternalEmitHelpers2[ExternalEmitHelpers2["Decorate"] = 8] = "Decorate";
	        ExternalEmitHelpers2[ExternalEmitHelpers2["ESDecorateAndRunInitializers"] = 8 /* Decorate */] = "ESDecorateAndRunInitializers";
	        ExternalEmitHelpers2[ExternalEmitHelpers2["Metadata"] = 16] = "Metadata";
	        ExternalEmitHelpers2[ExternalEmitHelpers2["Param"] = 32] = "Param";
	        ExternalEmitHelpers2[ExternalEmitHelpers2["Awaiter"] = 64] = "Awaiter";
	        ExternalEmitHelpers2[ExternalEmitHelpers2["Generator"] = 128] = "Generator";
	        ExternalEmitHelpers2[ExternalEmitHelpers2["Values"] = 256] = "Values";
	        ExternalEmitHelpers2[ExternalEmitHelpers2["Read"] = 512] = "Read";
	        ExternalEmitHelpers2[ExternalEmitHelpers2["SpreadArray"] = 1024] = "SpreadArray";
	        ExternalEmitHelpers2[ExternalEmitHelpers2["Await"] = 2048] = "Await";
	        ExternalEmitHelpers2[ExternalEmitHelpers2["AsyncGenerator"] = 4096] = "AsyncGenerator";
	        ExternalEmitHelpers2[ExternalEmitHelpers2["AsyncDelegator"] = 8192] = "AsyncDelegator";
	        ExternalEmitHelpers2[ExternalEmitHelpers2["AsyncValues"] = 16384] = "AsyncValues";
	        ExternalEmitHelpers2[ExternalEmitHelpers2["ExportStar"] = 32768] = "ExportStar";
	        ExternalEmitHelpers2[ExternalEmitHelpers2["ImportStar"] = 65536] = "ImportStar";
	        ExternalEmitHelpers2[ExternalEmitHelpers2["ImportDefault"] = 131072] = "ImportDefault";
	        ExternalEmitHelpers2[ExternalEmitHelpers2["MakeTemplateObject"] = 262144] = "MakeTemplateObject";
	        ExternalEmitHelpers2[ExternalEmitHelpers2["ClassPrivateFieldGet"] = 524288] = "ClassPrivateFieldGet";
	        ExternalEmitHelpers2[ExternalEmitHelpers2["ClassPrivateFieldSet"] = 1048576] = "ClassPrivateFieldSet";
	        ExternalEmitHelpers2[ExternalEmitHelpers2["ClassPrivateFieldIn"] = 2097152] = "ClassPrivateFieldIn";
	        ExternalEmitHelpers2[ExternalEmitHelpers2["CreateBinding"] = 4194304] = "CreateBinding";
	        ExternalEmitHelpers2[ExternalEmitHelpers2["SetFunctionName"] = 8388608] = "SetFunctionName";
	        ExternalEmitHelpers2[ExternalEmitHelpers2["PropKey"] = 16777216] = "PropKey";
	        ExternalEmitHelpers2[ExternalEmitHelpers2["AddDisposableResourceAndDisposeResources"] = 33554432] = "AddDisposableResourceAndDisposeResources";
	        ExternalEmitHelpers2[ExternalEmitHelpers2["FirstEmitHelper"] = 1 /* Extends */] = "FirstEmitHelper";
	        ExternalEmitHelpers2[ExternalEmitHelpers2["LastEmitHelper"] = 33554432 /* AddDisposableResourceAndDisposeResources */] = "LastEmitHelper";
	        ExternalEmitHelpers2[ExternalEmitHelpers2["ForOfIncludes"] = 256 /* Values */] = "ForOfIncludes";
	        ExternalEmitHelpers2[ExternalEmitHelpers2["ForAwaitOfIncludes"] = 16384 /* AsyncValues */] = "ForAwaitOfIncludes";
	        ExternalEmitHelpers2[ExternalEmitHelpers2["AsyncGeneratorIncludes"] = 6144] = "AsyncGeneratorIncludes";
	        ExternalEmitHelpers2[ExternalEmitHelpers2["AsyncDelegatorIncludes"] = 26624] = "AsyncDelegatorIncludes";
	        ExternalEmitHelpers2[ExternalEmitHelpers2["SpreadIncludes"] = 1536] = "SpreadIncludes";
	        return ExternalEmitHelpers2;
	      })(ExternalEmitHelpers || {});
	      EmitHint = /* @__PURE__ */ ((EmitHint6) => {
	        EmitHint6[EmitHint6["SourceFile"] = 0] = "SourceFile";
	        EmitHint6[EmitHint6["Expression"] = 1] = "Expression";
	        EmitHint6[EmitHint6["IdentifierName"] = 2] = "IdentifierName";
	        EmitHint6[EmitHint6["MappedTypeParameter"] = 3] = "MappedTypeParameter";
	        EmitHint6[EmitHint6["Unspecified"] = 4] = "Unspecified";
	        EmitHint6[EmitHint6["EmbeddedStatement"] = 5] = "EmbeddedStatement";
	        EmitHint6[EmitHint6["JsxAttributeValue"] = 6] = "JsxAttributeValue";
	        EmitHint6[EmitHint6["ImportTypeNodeAttributes"] = 7] = "ImportTypeNodeAttributes";
	        return EmitHint6;
	      })(EmitHint || {});
	      OuterExpressionKinds = /* @__PURE__ */ ((OuterExpressionKinds2) => {
	        OuterExpressionKinds2[OuterExpressionKinds2["Parentheses"] = 1] = "Parentheses";
	        OuterExpressionKinds2[OuterExpressionKinds2["TypeAssertions"] = 2] = "TypeAssertions";
	        OuterExpressionKinds2[OuterExpressionKinds2["NonNullAssertions"] = 4] = "NonNullAssertions";
	        OuterExpressionKinds2[OuterExpressionKinds2["PartiallyEmittedExpressions"] = 8] = "PartiallyEmittedExpressions";
	        OuterExpressionKinds2[OuterExpressionKinds2["Assertions"] = 6] = "Assertions";
	        OuterExpressionKinds2[OuterExpressionKinds2["All"] = 15] = "All";
	        OuterExpressionKinds2[OuterExpressionKinds2["ExcludeJSDocTypeAssertion"] = 16] = "ExcludeJSDocTypeAssertion";
	        return OuterExpressionKinds2;
	      })(OuterExpressionKinds || {});
	      LexicalEnvironmentFlags = /* @__PURE__ */ ((LexicalEnvironmentFlags2) => {
	        LexicalEnvironmentFlags2[LexicalEnvironmentFlags2["None"] = 0] = "None";
	        LexicalEnvironmentFlags2[LexicalEnvironmentFlags2["InParameters"] = 1] = "InParameters";
	        LexicalEnvironmentFlags2[LexicalEnvironmentFlags2["VariablesHoistedInParameters"] = 2] = "VariablesHoistedInParameters";
	        return LexicalEnvironmentFlags2;
	      })(LexicalEnvironmentFlags || {});
	      BundleFileSectionKind = /* @__PURE__ */ ((BundleFileSectionKind2) => {
	        BundleFileSectionKind2["Prologue"] = "prologue";
	        BundleFileSectionKind2["EmitHelpers"] = "emitHelpers";
	        BundleFileSectionKind2["NoDefaultLib"] = "no-default-lib";
	        BundleFileSectionKind2["Reference"] = "reference";
	        BundleFileSectionKind2["Type"] = "type";
	        BundleFileSectionKind2["TypeResolutionModeRequire"] = "type-require";
	        BundleFileSectionKind2["TypeResolutionModeImport"] = "type-import";
	        BundleFileSectionKind2["Lib"] = "lib";
	        BundleFileSectionKind2["Prepend"] = "prepend";
	        BundleFileSectionKind2["Text"] = "text";
	        BundleFileSectionKind2["Internal"] = "internal";
	        return BundleFileSectionKind2;
	      })(BundleFileSectionKind || {});
	      ListFormat = /* @__PURE__ */ ((ListFormat2) => {
	        ListFormat2[ListFormat2["None"] = 0] = "None";
	        ListFormat2[ListFormat2["SingleLine"] = 0] = "SingleLine";
	        ListFormat2[ListFormat2["MultiLine"] = 1] = "MultiLine";
	        ListFormat2[ListFormat2["PreserveLines"] = 2] = "PreserveLines";
	        ListFormat2[ListFormat2["LinesMask"] = 3] = "LinesMask";
	        ListFormat2[ListFormat2["NotDelimited"] = 0] = "NotDelimited";
	        ListFormat2[ListFormat2["BarDelimited"] = 4] = "BarDelimited";
	        ListFormat2[ListFormat2["AmpersandDelimited"] = 8] = "AmpersandDelimited";
	        ListFormat2[ListFormat2["CommaDelimited"] = 16] = "CommaDelimited";
	        ListFormat2[ListFormat2["AsteriskDelimited"] = 32] = "AsteriskDelimited";
	        ListFormat2[ListFormat2["DelimitersMask"] = 60] = "DelimitersMask";
	        ListFormat2[ListFormat2["AllowTrailingComma"] = 64] = "AllowTrailingComma";
	        ListFormat2[ListFormat2["Indented"] = 128] = "Indented";
	        ListFormat2[ListFormat2["SpaceBetweenBraces"] = 256] = "SpaceBetweenBraces";
	        ListFormat2[ListFormat2["SpaceBetweenSiblings"] = 512] = "SpaceBetweenSiblings";
	        ListFormat2[ListFormat2["Braces"] = 1024] = "Braces";
	        ListFormat2[ListFormat2["Parenthesis"] = 2048] = "Parenthesis";
	        ListFormat2[ListFormat2["AngleBrackets"] = 4096] = "AngleBrackets";
	        ListFormat2[ListFormat2["SquareBrackets"] = 8192] = "SquareBrackets";
	        ListFormat2[ListFormat2["BracketsMask"] = 15360] = "BracketsMask";
	        ListFormat2[ListFormat2["OptionalIfUndefined"] = 16384] = "OptionalIfUndefined";
	        ListFormat2[ListFormat2["OptionalIfEmpty"] = 32768] = "OptionalIfEmpty";
	        ListFormat2[ListFormat2["Optional"] = 49152] = "Optional";
	        ListFormat2[ListFormat2["PreferNewLine"] = 65536] = "PreferNewLine";
	        ListFormat2[ListFormat2["NoTrailingNewLine"] = 131072] = "NoTrailingNewLine";
	        ListFormat2[ListFormat2["NoInterveningComments"] = 262144] = "NoInterveningComments";
	        ListFormat2[ListFormat2["NoSpaceIfEmpty"] = 524288] = "NoSpaceIfEmpty";
	        ListFormat2[ListFormat2["SingleElement"] = 1048576] = "SingleElement";
	        ListFormat2[ListFormat2["SpaceAfterList"] = 2097152] = "SpaceAfterList";
	        ListFormat2[ListFormat2["Modifiers"] = 2359808] = "Modifiers";
	        ListFormat2[ListFormat2["HeritageClauses"] = 512] = "HeritageClauses";
	        ListFormat2[ListFormat2["SingleLineTypeLiteralMembers"] = 768] = "SingleLineTypeLiteralMembers";
	        ListFormat2[ListFormat2["MultiLineTypeLiteralMembers"] = 32897] = "MultiLineTypeLiteralMembers";
	        ListFormat2[ListFormat2["SingleLineTupleTypeElements"] = 528] = "SingleLineTupleTypeElements";
	        ListFormat2[ListFormat2["MultiLineTupleTypeElements"] = 657] = "MultiLineTupleTypeElements";
	        ListFormat2[ListFormat2["UnionTypeConstituents"] = 516] = "UnionTypeConstituents";
	        ListFormat2[ListFormat2["IntersectionTypeConstituents"] = 520] = "IntersectionTypeConstituents";
	        ListFormat2[ListFormat2["ObjectBindingPatternElements"] = 525136] = "ObjectBindingPatternElements";
	        ListFormat2[ListFormat2["ArrayBindingPatternElements"] = 524880] = "ArrayBindingPatternElements";
	        ListFormat2[ListFormat2["ObjectLiteralExpressionProperties"] = 526226] = "ObjectLiteralExpressionProperties";
	        ListFormat2[ListFormat2["ImportAttributes"] = 526226] = "ImportAttributes";
	        ListFormat2[ListFormat2["ImportClauseEntries"] = 526226 /* ImportAttributes */] = "ImportClauseEntries";
	        ListFormat2[ListFormat2["ArrayLiteralExpressionElements"] = 8914] = "ArrayLiteralExpressionElements";
	        ListFormat2[ListFormat2["CommaListElements"] = 528] = "CommaListElements";
	        ListFormat2[ListFormat2["CallExpressionArguments"] = 2576] = "CallExpressionArguments";
	        ListFormat2[ListFormat2["NewExpressionArguments"] = 18960] = "NewExpressionArguments";
	        ListFormat2[ListFormat2["TemplateExpressionSpans"] = 262144] = "TemplateExpressionSpans";
	        ListFormat2[ListFormat2["SingleLineBlockStatements"] = 768] = "SingleLineBlockStatements";
	        ListFormat2[ListFormat2["MultiLineBlockStatements"] = 129] = "MultiLineBlockStatements";
	        ListFormat2[ListFormat2["VariableDeclarationList"] = 528] = "VariableDeclarationList";
	        ListFormat2[ListFormat2["SingleLineFunctionBodyStatements"] = 768] = "SingleLineFunctionBodyStatements";
	        ListFormat2[ListFormat2["MultiLineFunctionBodyStatements"] = 1 /* MultiLine */] = "MultiLineFunctionBodyStatements";
	        ListFormat2[ListFormat2["ClassHeritageClauses"] = 0 /* SingleLine */] = "ClassHeritageClauses";
	        ListFormat2[ListFormat2["ClassMembers"] = 129] = "ClassMembers";
	        ListFormat2[ListFormat2["InterfaceMembers"] = 129] = "InterfaceMembers";
	        ListFormat2[ListFormat2["EnumMembers"] = 145] = "EnumMembers";
	        ListFormat2[ListFormat2["CaseBlockClauses"] = 129] = "CaseBlockClauses";
	        ListFormat2[ListFormat2["NamedImportsOrExportsElements"] = 525136] = "NamedImportsOrExportsElements";
	        ListFormat2[ListFormat2["JsxElementOrFragmentChildren"] = 262144] = "JsxElementOrFragmentChildren";
	        ListFormat2[ListFormat2["JsxElementAttributes"] = 262656] = "JsxElementAttributes";
	        ListFormat2[ListFormat2["CaseOrDefaultClauseStatements"] = 163969] = "CaseOrDefaultClauseStatements";
	        ListFormat2[ListFormat2["HeritageClauseTypes"] = 528] = "HeritageClauseTypes";
	        ListFormat2[ListFormat2["SourceFileStatements"] = 131073] = "SourceFileStatements";
	        ListFormat2[ListFormat2["Decorators"] = 2146305] = "Decorators";
	        ListFormat2[ListFormat2["TypeArguments"] = 53776] = "TypeArguments";
	        ListFormat2[ListFormat2["TypeParameters"] = 53776] = "TypeParameters";
	        ListFormat2[ListFormat2["Parameters"] = 2576] = "Parameters";
	        ListFormat2[ListFormat2["IndexSignatureParameters"] = 8848] = "IndexSignatureParameters";
	        ListFormat2[ListFormat2["JSDocComment"] = 33] = "JSDocComment";
	        return ListFormat2;
	      })(ListFormat || {});
	      PragmaKindFlags = /* @__PURE__ */ ((PragmaKindFlags2) => {
	        PragmaKindFlags2[PragmaKindFlags2["None"] = 0] = "None";
	        PragmaKindFlags2[PragmaKindFlags2["TripleSlashXML"] = 1] = "TripleSlashXML";
	        PragmaKindFlags2[PragmaKindFlags2["SingleLine"] = 2] = "SingleLine";
	        PragmaKindFlags2[PragmaKindFlags2["MultiLine"] = 4] = "MultiLine";
	        PragmaKindFlags2[PragmaKindFlags2["All"] = 7] = "All";
	        PragmaKindFlags2[PragmaKindFlags2["Default"] = 7 /* All */] = "Default";
	        return PragmaKindFlags2;
	      })(PragmaKindFlags || {});
	      commentPragmas = {
	        "reference": {
	          args: [
	            { name: "types", optional: true, captureSpan: true },
	            { name: "lib", optional: true, captureSpan: true },
	            { name: "path", optional: true, captureSpan: true },
	            { name: "no-default-lib", optional: true },
	            { name: "resolution-mode", optional: true }
	          ],
	          kind: 1 /* TripleSlashXML */
	        },
	        "amd-dependency": {
	          args: [{ name: "path" }, { name: "name", optional: true }],
	          kind: 1 /* TripleSlashXML */
	        },
	        "amd-module": {
	          args: [{ name: "name" }],
	          kind: 1 /* TripleSlashXML */
	        },
	        "ts-check": {
	          kind: 2 /* SingleLine */
	        },
	        "ts-nocheck": {
	          kind: 2 /* SingleLine */
	        },
	        "jsx": {
	          args: [{ name: "factory" }],
	          kind: 4 /* MultiLine */
	        },
	        "jsxfrag": {
	          args: [{ name: "factory" }],
	          kind: 4 /* MultiLine */
	        },
	        "jsximportsource": {
	          args: [{ name: "factory" }],
	          kind: 4 /* MultiLine */
	        },
	        "jsxruntime": {
	          args: [{ name: "factory" }],
	          kind: 4 /* MultiLine */
	        }
	      };
	      JSDocParsingMode = /* @__PURE__ */ ((JSDocParsingMode6) => {
	        JSDocParsingMode6[JSDocParsingMode6["ParseAll"] = 0] = "ParseAll";
	        JSDocParsingMode6[JSDocParsingMode6["ParseNone"] = 1] = "ParseNone";
	        JSDocParsingMode6[JSDocParsingMode6["ParseForTypeErrors"] = 2] = "ParseForTypeErrors";
	        JSDocParsingMode6[JSDocParsingMode6["ParseForTypeInfo"] = 3] = "ParseForTypeInfo";
	        return JSDocParsingMode6;
	      })(JSDocParsingMode || {});
	    }
	  });

	  // src/compiler/sys.ts
	  function generateDjb2Hash(data) {
	    let acc = 5381;
	    for (let i = 0; i < data.length; i++) {
	      acc = (acc << 5) + acc + data.charCodeAt(i);
	    }
	    return acc.toString();
	  }
	  function setStackTraceLimit() {
	    if (Error.stackTraceLimit < 100) {
	      Error.stackTraceLimit = 100;
	    }
	  }
	  function getModifiedTime(host, fileName) {
	    return host.getModifiedTime(fileName) || missingFileModifiedTime;
	  }
	  function createPollingIntervalBasedLevels(levels) {
	    return {
	      [250 /* Low */]: levels.Low,
	      [500 /* Medium */]: levels.Medium,
	      [2e3 /* High */]: levels.High
	    };
	  }
	  function setCustomPollingValues(system) {
	    if (!system.getEnvironmentVariable) {
	      return;
	    }
	    const pollingIntervalChanged = setCustomLevels("TSC_WATCH_POLLINGINTERVAL", PollingInterval);
	    pollingChunkSize = getCustomPollingBasedLevels("TSC_WATCH_POLLINGCHUNKSIZE", defaultChunkLevels) || pollingChunkSize;
	    unchangedPollThresholds = getCustomPollingBasedLevels("TSC_WATCH_UNCHANGEDPOLLTHRESHOLDS", defaultChunkLevels) || unchangedPollThresholds;
	    function getLevel(envVar, level) {
	      return system.getEnvironmentVariable(`${envVar}_${level.toUpperCase()}`);
	    }
	    function getCustomLevels(baseVariable) {
	      let customLevels;
	      setCustomLevel("Low");
	      setCustomLevel("Medium");
	      setCustomLevel("High");
	      return customLevels;
	      function setCustomLevel(level) {
	        const customLevel = getLevel(baseVariable, level);
	        if (customLevel) {
	          (customLevels || (customLevels = {}))[level] = Number(customLevel);
	        }
	      }
	    }
	    function setCustomLevels(baseVariable, levels) {
	      const customLevels = getCustomLevels(baseVariable);
	      if (customLevels) {
	        setLevel("Low");
	        setLevel("Medium");
	        setLevel("High");
	        return true;
	      }
	      return false;
	      function setLevel(level) {
	        levels[level] = customLevels[level] || levels[level];
	      }
	    }
	    function getCustomPollingBasedLevels(baseVariable, defaultLevels) {
	      const customLevels = getCustomLevels(baseVariable);
	      return (pollingIntervalChanged || customLevels) && createPollingIntervalBasedLevels(customLevels ? { ...defaultLevels, ...customLevels } : defaultLevels);
	    }
	  }
	  function pollWatchedFileQueue(host, queue, pollIndex, chunkSize, callbackOnWatchFileStat) {
	    let definedValueCopyToIndex = pollIndex;
	    for (let canVisit = queue.length; chunkSize && canVisit; nextPollIndex(), canVisit--) {
	      const watchedFile = queue[pollIndex];
	      if (!watchedFile) {
	        continue;
	      } else if (watchedFile.isClosed) {
	        queue[pollIndex] = void 0;
	        continue;
	      }
	      chunkSize--;
	      const fileChanged = onWatchedFileStat(watchedFile, getModifiedTime(host, watchedFile.fileName));
	      if (watchedFile.isClosed) {
	        queue[pollIndex] = void 0;
	        continue;
	      }
	      callbackOnWatchFileStat == null ? void 0 : callbackOnWatchFileStat(watchedFile, pollIndex, fileChanged);
	      if (queue[pollIndex]) {
	        if (definedValueCopyToIndex < pollIndex) {
	          queue[definedValueCopyToIndex] = watchedFile;
	          queue[pollIndex] = void 0;
	        }
	        definedValueCopyToIndex++;
	      }
	    }
	    return pollIndex;
	    function nextPollIndex() {
	      pollIndex++;
	      if (pollIndex === queue.length) {
	        if (definedValueCopyToIndex < pollIndex) {
	          queue.length = definedValueCopyToIndex;
	        }
	        pollIndex = 0;
	        definedValueCopyToIndex = 0;
	      }
	    }
	  }
	  function createDynamicPriorityPollingWatchFile(host) {
	    const watchedFiles = [];
	    const changedFilesInLastPoll = [];
	    const lowPollingIntervalQueue = createPollingIntervalQueue(250 /* Low */);
	    const mediumPollingIntervalQueue = createPollingIntervalQueue(500 /* Medium */);
	    const highPollingIntervalQueue = createPollingIntervalQueue(2e3 /* High */);
	    return watchFile2;
	    function watchFile2(fileName, callback, defaultPollingInterval) {
	      const file = {
	        fileName,
	        callback,
	        unchangedPolls: 0,
	        mtime: getModifiedTime(host, fileName)
	      };
	      watchedFiles.push(file);
	      addToPollingIntervalQueue(file, defaultPollingInterval);
	      return {
	        close: () => {
	          file.isClosed = true;
	          unorderedRemoveItem(watchedFiles, file);
	        }
	      };
	    }
	    function createPollingIntervalQueue(pollingInterval) {
	      const queue = [];
	      queue.pollingInterval = pollingInterval;
	      queue.pollIndex = 0;
	      queue.pollScheduled = false;
	      return queue;
	    }
	    function pollPollingIntervalQueue(_timeoutType, queue) {
	      queue.pollIndex = pollQueue(queue, queue.pollingInterval, queue.pollIndex, pollingChunkSize[queue.pollingInterval]);
	      if (queue.length) {
	        scheduleNextPoll(queue.pollingInterval);
	      } else {
	        Debug.assert(queue.pollIndex === 0);
	        queue.pollScheduled = false;
	      }
	    }
	    function pollLowPollingIntervalQueue(_timeoutType, queue) {
	      pollQueue(
	        changedFilesInLastPoll,
	        250 /* Low */,
	        /*pollIndex*/
	        0,
	        changedFilesInLastPoll.length
	      );
	      pollPollingIntervalQueue(_timeoutType, queue);
	      if (!queue.pollScheduled && changedFilesInLastPoll.length) {
	        scheduleNextPoll(250 /* Low */);
	      }
	    }
	    function pollQueue(queue, pollingInterval, pollIndex, chunkSize) {
	      return pollWatchedFileQueue(
	        host,
	        queue,
	        pollIndex,
	        chunkSize,
	        onWatchFileStat
	      );
	      function onWatchFileStat(watchedFile, pollIndex2, fileChanged) {
	        if (fileChanged) {
	          watchedFile.unchangedPolls = 0;
	          if (queue !== changedFilesInLastPoll) {
	            queue[pollIndex2] = void 0;
	            addChangedFileToLowPollingIntervalQueue(watchedFile);
	          }
	        } else if (watchedFile.unchangedPolls !== unchangedPollThresholds[pollingInterval]) {
	          watchedFile.unchangedPolls++;
	        } else if (queue === changedFilesInLastPoll) {
	          watchedFile.unchangedPolls = 1;
	          queue[pollIndex2] = void 0;
	          addToPollingIntervalQueue(watchedFile, 250 /* Low */);
	        } else if (pollingInterval !== 2e3 /* High */) {
	          watchedFile.unchangedPolls++;
	          queue[pollIndex2] = void 0;
	          addToPollingIntervalQueue(watchedFile, pollingInterval === 250 /* Low */ ? 500 /* Medium */ : 2e3 /* High */);
	        }
	      }
	    }
	    function pollingIntervalQueue(pollingInterval) {
	      switch (pollingInterval) {
	        case 250 /* Low */:
	          return lowPollingIntervalQueue;
	        case 500 /* Medium */:
	          return mediumPollingIntervalQueue;
	        case 2e3 /* High */:
	          return highPollingIntervalQueue;
	      }
	    }
	    function addToPollingIntervalQueue(file, pollingInterval) {
	      pollingIntervalQueue(pollingInterval).push(file);
	      scheduleNextPollIfNotAlreadyScheduled(pollingInterval);
	    }
	    function addChangedFileToLowPollingIntervalQueue(file) {
	      changedFilesInLastPoll.push(file);
	      scheduleNextPollIfNotAlreadyScheduled(250 /* Low */);
	    }
	    function scheduleNextPollIfNotAlreadyScheduled(pollingInterval) {
	      if (!pollingIntervalQueue(pollingInterval).pollScheduled) {
	        scheduleNextPoll(pollingInterval);
	      }
	    }
	    function scheduleNextPoll(pollingInterval) {
	      pollingIntervalQueue(pollingInterval).pollScheduled = host.setTimeout(pollingInterval === 250 /* Low */ ? pollLowPollingIntervalQueue : pollPollingIntervalQueue, pollingInterval, pollingInterval === 250 /* Low */ ? "pollLowPollingIntervalQueue" : "pollPollingIntervalQueue", pollingIntervalQueue(pollingInterval));
	    }
	  }
	  function createUseFsEventsOnParentDirectoryWatchFile(fsWatch, useCaseSensitiveFileNames2, getModifiedTime3, fsWatchWithTimestamp) {
	    const fileWatcherCallbacks = createMultiMap();
	    const fileTimestamps = fsWatchWithTimestamp ? /* @__PURE__ */ new Map() : void 0;
	    const dirWatchers = /* @__PURE__ */ new Map();
	    const toCanonicalName = createGetCanonicalFileName(useCaseSensitiveFileNames2);
	    return nonPollingWatchFile;
	    function nonPollingWatchFile(fileName, callback, _pollingInterval, fallbackOptions) {
	      const filePath = toCanonicalName(fileName);
	      if (fileWatcherCallbacks.add(filePath, callback).length === 1 && fileTimestamps) {
	        fileTimestamps.set(filePath, getModifiedTime3(fileName) || missingFileModifiedTime);
	      }
	      const dirPath = getDirectoryPath(filePath) || ".";
	      const watcher = dirWatchers.get(dirPath) || createDirectoryWatcher(getDirectoryPath(fileName) || ".", dirPath, fallbackOptions);
	      watcher.referenceCount++;
	      return {
	        close: () => {
	          if (watcher.referenceCount === 1) {
	            watcher.close();
	            dirWatchers.delete(dirPath);
	          } else {
	            watcher.referenceCount--;
	          }
	          fileWatcherCallbacks.remove(filePath, callback);
	        }
	      };
	    }
	    function createDirectoryWatcher(dirName, dirPath, fallbackOptions) {
	      const watcher = fsWatch(
	        dirName,
	        1 /* Directory */,
	        (eventName, relativeFileName) => {
	          if (!isString(relativeFileName))
	            return;
	          const fileName = getNormalizedAbsolutePath(relativeFileName, dirName);
	          const filePath = toCanonicalName(fileName);
	          const callbacks = fileName && fileWatcherCallbacks.get(filePath);
	          if (callbacks) {
	            let currentModifiedTime;
	            let eventKind = 1 /* Changed */;
	            if (fileTimestamps) {
	              const existingTime = fileTimestamps.get(filePath);
	              if (eventName === "change") {
	                currentModifiedTime = getModifiedTime3(fileName) || missingFileModifiedTime;
	                if (currentModifiedTime.getTime() === existingTime.getTime())
	                  return;
	              }
	              currentModifiedTime || (currentModifiedTime = getModifiedTime3(fileName) || missingFileModifiedTime);
	              fileTimestamps.set(filePath, currentModifiedTime);
	              if (existingTime === missingFileModifiedTime)
	                eventKind = 0 /* Created */;
	              else if (currentModifiedTime === missingFileModifiedTime)
	                eventKind = 2 /* Deleted */;
	            }
	            for (const fileCallback of callbacks) {
	              fileCallback(fileName, eventKind, currentModifiedTime);
	            }
	          }
	        },
	        /*recursive*/
	        false,
	        500 /* Medium */,
	        fallbackOptions
	      );
	      watcher.referenceCount = 0;
	      dirWatchers.set(dirPath, watcher);
	      return watcher;
	    }
	  }
	  function createFixedChunkSizePollingWatchFile(host) {
	    const watchedFiles = [];
	    let pollIndex = 0;
	    let pollScheduled;
	    return watchFile2;
	    function watchFile2(fileName, callback) {
	      const file = {
	        fileName,
	        callback,
	        mtime: getModifiedTime(host, fileName)
	      };
	      watchedFiles.push(file);
	      scheduleNextPoll();
	      return {
	        close: () => {
	          file.isClosed = true;
	          unorderedRemoveItem(watchedFiles, file);
	        }
	      };
	    }
	    function pollQueue() {
	      pollScheduled = void 0;
	      pollIndex = pollWatchedFileQueue(host, watchedFiles, pollIndex, pollingChunkSize[250 /* Low */]);
	      scheduleNextPoll();
	    }
	    function scheduleNextPoll() {
	      if (!watchedFiles.length || pollScheduled)
	        return;
	      pollScheduled = host.setTimeout(pollQueue, 2e3 /* High */, "pollQueue");
	    }
	  }
	  function createSingleWatcherPerName(cache, useCaseSensitiveFileNames2, name, callback, createWatcher) {
	    const toCanonicalFileName = createGetCanonicalFileName(useCaseSensitiveFileNames2);
	    const path = toCanonicalFileName(name);
	    const existing = cache.get(path);
	    if (existing) {
	      existing.callbacks.push(callback);
	    } else {
	      cache.set(path, {
	        watcher: createWatcher(
	          // Cant infer types correctly so lets satisfy checker
	          (param1, param2, param3) => {
	            var _a;
	            return (_a = cache.get(path)) == null ? void 0 : _a.callbacks.slice().forEach((cb) => cb(param1, param2, param3));
	          }
	        ),
	        callbacks: [callback]
	      });
	    }
	    return {
	      close: () => {
	        const watcher = cache.get(path);
	        if (!watcher)
	          return;
	        if (!orderedRemoveItem(watcher.callbacks, callback) || watcher.callbacks.length)
	          return;
	        cache.delete(path);
	        closeFileWatcherOf(watcher);
	      }
	    };
	  }
	  function onWatchedFileStat(watchedFile, modifiedTime) {
	    const oldTime = watchedFile.mtime.getTime();
	    const newTime = modifiedTime.getTime();
	    if (oldTime !== newTime) {
	      watchedFile.mtime = modifiedTime;
	      watchedFile.callback(watchedFile.fileName, getFileWatcherEventKind(oldTime, newTime), modifiedTime);
	      return true;
	    }
	    return false;
	  }
	  function getFileWatcherEventKind(oldTime, newTime) {
	    return oldTime === 0 ? 0 /* Created */ : newTime === 0 ? 2 /* Deleted */ : 1 /* Changed */;
	  }
	  function sysLog(s) {
	    return curSysLog(s);
	  }
	  function setSysLog(logger) {
	    curSysLog = logger;
	  }
	  function createDirectoryWatcherSupportingRecursive({
	    watchDirectory,
	    useCaseSensitiveFileNames: useCaseSensitiveFileNames2,
	    getCurrentDirectory,
	    getAccessibleSortedChildDirectories,
	    fileSystemEntryExists,
	    realpath,
	    setTimeout: setTimeout2,
	    clearTimeout: clearTimeout2
	  }) {
	    const cache = /* @__PURE__ */ new Map();
	    const callbackCache = createMultiMap();
	    const cacheToUpdateChildWatches = /* @__PURE__ */ new Map();
	    let timerToUpdateChildWatches;
	    const filePathComparer = getStringComparer(!useCaseSensitiveFileNames2);
	    const toCanonicalFilePath = createGetCanonicalFileName(useCaseSensitiveFileNames2);
	    return (dirName, callback, recursive, options) => recursive ? createDirectoryWatcher(dirName, options, callback) : watchDirectory(dirName, callback, recursive, options);
	    function createDirectoryWatcher(dirName, options, callback) {
	      const dirPath = toCanonicalFilePath(dirName);
	      let directoryWatcher = cache.get(dirPath);
	      if (directoryWatcher) {
	        directoryWatcher.refCount++;
	      } else {
	        directoryWatcher = {
	          watcher: watchDirectory(
	            dirName,
	            (fileName) => {
	              if (isIgnoredPath(fileName, options))
	                return;
	              if (options == null ? void 0 : options.synchronousWatchDirectory) {
	                invokeCallbacks(dirPath, fileName);
	                updateChildWatches(dirName, dirPath, options);
	              } else {
	                nonSyncUpdateChildWatches(dirName, dirPath, fileName, options);
	              }
	            },
	            /*recursive*/
	            false,
	            options
	          ),
	          refCount: 1,
	          childWatches: emptyArray
	        };
	        cache.set(dirPath, directoryWatcher);
	        updateChildWatches(dirName, dirPath, options);
	      }
	      const callbackToAdd = callback && { dirName, callback };
	      if (callbackToAdd) {
	        callbackCache.add(dirPath, callbackToAdd);
	      }
	      return {
	        dirName,
	        close: () => {
	          const directoryWatcher2 = Debug.checkDefined(cache.get(dirPath));
	          if (callbackToAdd)
	            callbackCache.remove(dirPath, callbackToAdd);
	          directoryWatcher2.refCount--;
	          if (directoryWatcher2.refCount)
	            return;
	          cache.delete(dirPath);
	          closeFileWatcherOf(directoryWatcher2);
	          directoryWatcher2.childWatches.forEach(closeFileWatcher);
	        }
	      };
	    }
	    function invokeCallbacks(dirPath, fileNameOrInvokeMap, fileNames) {
	      let fileName;
	      let invokeMap;
	      if (isString(fileNameOrInvokeMap)) {
	        fileName = fileNameOrInvokeMap;
	      } else {
	        invokeMap = fileNameOrInvokeMap;
	      }
	      callbackCache.forEach((callbacks, rootDirName) => {
	        if (invokeMap && invokeMap.get(rootDirName) === true)
	          return;
	        if (rootDirName === dirPath || startsWith(dirPath, rootDirName) && dirPath[rootDirName.length] === directorySeparator) {
	          if (invokeMap) {
	            if (fileNames) {
	              const existing = invokeMap.get(rootDirName);
	              if (existing) {
	                existing.push(...fileNames);
	              } else {
	                invokeMap.set(rootDirName, fileNames.slice());
	              }
	            } else {
	              invokeMap.set(rootDirName, true);
	            }
	          } else {
	            callbacks.forEach(({ callback }) => callback(fileName));
	          }
	        }
	      });
	    }
	    function nonSyncUpdateChildWatches(dirName, dirPath, fileName, options) {
	      const parentWatcher = cache.get(dirPath);
	      if (parentWatcher && fileSystemEntryExists(dirName, 1 /* Directory */)) {
	        scheduleUpdateChildWatches(dirName, dirPath, fileName, options);
	        return;
	      }
	      invokeCallbacks(dirPath, fileName);
	      removeChildWatches(parentWatcher);
	    }
	    function scheduleUpdateChildWatches(dirName, dirPath, fileName, options) {
	      const existing = cacheToUpdateChildWatches.get(dirPath);
	      if (existing) {
	        existing.fileNames.push(fileName);
	      } else {
	        cacheToUpdateChildWatches.set(dirPath, { dirName, options, fileNames: [fileName] });
	      }
	      if (timerToUpdateChildWatches) {
	        clearTimeout2(timerToUpdateChildWatches);
	        timerToUpdateChildWatches = void 0;
	      }
	      timerToUpdateChildWatches = setTimeout2(onTimerToUpdateChildWatches, 1e3, "timerToUpdateChildWatches");
	    }
	    function onTimerToUpdateChildWatches() {
	      timerToUpdateChildWatches = void 0;
	      sysLog(`sysLog:: onTimerToUpdateChildWatches:: ${cacheToUpdateChildWatches.size}`);
	      const start = timestamp();
	      const invokeMap = /* @__PURE__ */ new Map();
	      while (!timerToUpdateChildWatches && cacheToUpdateChildWatches.size) {
	        const result = cacheToUpdateChildWatches.entries().next();
	        Debug.assert(!result.done);
	        const { value: [dirPath, { dirName, options, fileNames }] } = result;
	        cacheToUpdateChildWatches.delete(dirPath);
	        const hasChanges = updateChildWatches(dirName, dirPath, options);
	        invokeCallbacks(dirPath, invokeMap, hasChanges ? void 0 : fileNames);
	      }
	      sysLog(`sysLog:: invokingWatchers:: Elapsed:: ${timestamp() - start}ms:: ${cacheToUpdateChildWatches.size}`);
	      callbackCache.forEach((callbacks, rootDirName) => {
	        const existing = invokeMap.get(rootDirName);
	        if (existing) {
	          callbacks.forEach(({ callback, dirName }) => {
	            if (isArray(existing)) {
	              existing.forEach(callback);
	            } else {
	              callback(dirName);
	            }
	          });
	        }
	      });
	      const elapsed = timestamp() - start;
	      sysLog(`sysLog:: Elapsed:: ${elapsed}ms:: onTimerToUpdateChildWatches:: ${cacheToUpdateChildWatches.size} ${timerToUpdateChildWatches}`);
	    }
	    function removeChildWatches(parentWatcher) {
	      if (!parentWatcher)
	        return;
	      const existingChildWatches = parentWatcher.childWatches;
	      parentWatcher.childWatches = emptyArray;
	      for (const childWatcher of existingChildWatches) {
	        childWatcher.close();
	        removeChildWatches(cache.get(toCanonicalFilePath(childWatcher.dirName)));
	      }
	    }
	    function updateChildWatches(parentDir, parentDirPath, options) {
	      const parentWatcher = cache.get(parentDirPath);
	      if (!parentWatcher)
	        return false;
	      let newChildWatches;
	      const hasChanges = enumerateInsertsAndDeletes(
	        fileSystemEntryExists(parentDir, 1 /* Directory */) ? mapDefined(getAccessibleSortedChildDirectories(parentDir), (child) => {
	          const childFullName = getNormalizedAbsolutePath(child, parentDir);
	          return !isIgnoredPath(childFullName, options) && filePathComparer(childFullName, normalizePath(realpath(childFullName))) === 0 /* EqualTo */ ? childFullName : void 0;
	        }) : emptyArray,
	        parentWatcher.childWatches,
	        (child, childWatcher) => filePathComparer(child, childWatcher.dirName),
	        createAndAddChildDirectoryWatcher,
	        closeFileWatcher,
	        addChildDirectoryWatcher
	      );
	      parentWatcher.childWatches = newChildWatches || emptyArray;
	      return hasChanges;
	      function createAndAddChildDirectoryWatcher(childName) {
	        const result = createDirectoryWatcher(childName, options);
	        addChildDirectoryWatcher(result);
	      }
	      function addChildDirectoryWatcher(childWatcher) {
	        (newChildWatches || (newChildWatches = [])).push(childWatcher);
	      }
	    }
	    function isIgnoredPath(path, options) {
	      return some(ignoredPaths, (searchPath) => isInPath(path, searchPath)) || isIgnoredByWatchOptions(path, options, useCaseSensitiveFileNames2, getCurrentDirectory);
	    }
	    function isInPath(path, searchPath) {
	      if (path.includes(searchPath))
	        return true;
	      if (useCaseSensitiveFileNames2)
	        return false;
	      return toCanonicalFilePath(path).includes(searchPath);
	    }
	  }
	  function createFileWatcherCallback(callback) {
	    return (_fileName, eventKind, modifiedTime) => callback(eventKind === 1 /* Changed */ ? "change" : "rename", "", modifiedTime);
	  }
	  function createFsWatchCallbackForFileWatcherCallback(fileName, callback, getModifiedTime3) {
	    return (eventName, _relativeFileName, modifiedTime) => {
	      if (eventName === "rename") {
	        modifiedTime || (modifiedTime = getModifiedTime3(fileName) || missingFileModifiedTime);
	        callback(fileName, modifiedTime !== missingFileModifiedTime ? 0 /* Created */ : 2 /* Deleted */, modifiedTime);
	      } else {
	        callback(fileName, 1 /* Changed */, modifiedTime);
	      }
	    };
	  }
	  function isIgnoredByWatchOptions(pathToCheck, options, useCaseSensitiveFileNames2, getCurrentDirectory) {
	    return ((options == null ? void 0 : options.excludeDirectories) || (options == null ? void 0 : options.excludeFiles)) && (matchesExclude(pathToCheck, options == null ? void 0 : options.excludeFiles, useCaseSensitiveFileNames2, getCurrentDirectory()) || matchesExclude(pathToCheck, options == null ? void 0 : options.excludeDirectories, useCaseSensitiveFileNames2, getCurrentDirectory()));
	  }
	  function createFsWatchCallbackForDirectoryWatcherCallback(directoryName, callback, options, useCaseSensitiveFileNames2, getCurrentDirectory) {
	    return (eventName, relativeFileName) => {
	      if (eventName === "rename") {
	        const fileName = !relativeFileName ? directoryName : normalizePath(combinePaths(directoryName, relativeFileName));
	        if (!relativeFileName || !isIgnoredByWatchOptions(fileName, options, useCaseSensitiveFileNames2, getCurrentDirectory)) {
	          callback(fileName);
	        }
	      }
	    };
	  }
	  function createSystemWatchFunctions({
	    pollingWatchFileWorker,
	    getModifiedTime: getModifiedTime3,
	    setTimeout: setTimeout2,
	    clearTimeout: clearTimeout2,
	    fsWatchWorker,
	    fileSystemEntryExists,
	    useCaseSensitiveFileNames: useCaseSensitiveFileNames2,
	    getCurrentDirectory,
	    fsSupportsRecursiveFsWatch,
	    getAccessibleSortedChildDirectories,
	    realpath,
	    tscWatchFile,
	    useNonPollingWatchers,
	    tscWatchDirectory,
	    inodeWatching,
	    fsWatchWithTimestamp,
	    sysLog: sysLog2
	  }) {
	    const pollingWatches = /* @__PURE__ */ new Map();
	    const fsWatches = /* @__PURE__ */ new Map();
	    const fsWatchesRecursive = /* @__PURE__ */ new Map();
	    let dynamicPollingWatchFile;
	    let fixedChunkSizePollingWatchFile;
	    let nonPollingWatchFile;
	    let hostRecursiveDirectoryWatcher;
	    let hitSystemWatcherLimit = false;
	    return {
	      watchFile: watchFile2,
	      watchDirectory
	    };
	    function watchFile2(fileName, callback, pollingInterval, options) {
	      options = updateOptionsForWatchFile(options, useNonPollingWatchers);
	      const watchFileKind = Debug.checkDefined(options.watchFile);
	      switch (watchFileKind) {
	        case 0 /* FixedPollingInterval */:
	          return pollingWatchFile(
	            fileName,
	            callback,
	            250 /* Low */,
	            /*options*/
	            void 0
	          );
	        case 1 /* PriorityPollingInterval */:
	          return pollingWatchFile(
	            fileName,
	            callback,
	            pollingInterval,
	            /*options*/
	            void 0
	          );
	        case 2 /* DynamicPriorityPolling */:
	          return ensureDynamicPollingWatchFile()(
	            fileName,
	            callback,
	            pollingInterval,
	            /*options*/
	            void 0
	          );
	        case 3 /* FixedChunkSizePolling */:
	          return ensureFixedChunkSizePollingWatchFile()(
	            fileName,
	            callback,
	            /* pollingInterval */
	            void 0,
	            /*options*/
	            void 0
	          );
	        case 4 /* UseFsEvents */:
	          return fsWatch(
	            fileName,
	            0 /* File */,
	            createFsWatchCallbackForFileWatcherCallback(fileName, callback, getModifiedTime3),
	            /*recursive*/
	            false,
	            pollingInterval,
	            getFallbackOptions(options)
	          );
	        case 5 /* UseFsEventsOnParentDirectory */:
	          if (!nonPollingWatchFile) {
	            nonPollingWatchFile = createUseFsEventsOnParentDirectoryWatchFile(fsWatch, useCaseSensitiveFileNames2, getModifiedTime3, fsWatchWithTimestamp);
	          }
	          return nonPollingWatchFile(fileName, callback, pollingInterval, getFallbackOptions(options));
	        default:
	          Debug.assertNever(watchFileKind);
	      }
	    }
	    function ensureDynamicPollingWatchFile() {
	      return dynamicPollingWatchFile || (dynamicPollingWatchFile = createDynamicPriorityPollingWatchFile({ getModifiedTime: getModifiedTime3, setTimeout: setTimeout2 }));
	    }
	    function ensureFixedChunkSizePollingWatchFile() {
	      return fixedChunkSizePollingWatchFile || (fixedChunkSizePollingWatchFile = createFixedChunkSizePollingWatchFile({ getModifiedTime: getModifiedTime3, setTimeout: setTimeout2 }));
	    }
	    function updateOptionsForWatchFile(options, useNonPollingWatchers2) {
	      if (options && options.watchFile !== void 0)
	        return options;
	      switch (tscWatchFile) {
	        case "PriorityPollingInterval":
	          return { watchFile: 1 /* PriorityPollingInterval */ };
	        case "DynamicPriorityPolling":
	          return { watchFile: 2 /* DynamicPriorityPolling */ };
	        case "UseFsEvents":
	          return generateWatchFileOptions(4 /* UseFsEvents */, 1 /* PriorityInterval */, options);
	        case "UseFsEventsWithFallbackDynamicPolling":
	          return generateWatchFileOptions(4 /* UseFsEvents */, 2 /* DynamicPriority */, options);
	        case "UseFsEventsOnParentDirectory":
	          useNonPollingWatchers2 = true;
	        default:
	          return useNonPollingWatchers2 ? (
	            // Use notifications from FS to watch with falling back to fs.watchFile
	            generateWatchFileOptions(5 /* UseFsEventsOnParentDirectory */, 1 /* PriorityInterval */, options)
	          ) : (
	            // Default to using fs events
	            { watchFile: 4 /* UseFsEvents */ }
	          );
	      }
	    }
	    function generateWatchFileOptions(watchFile3, fallbackPolling, options) {
	      const defaultFallbackPolling = options == null ? void 0 : options.fallbackPolling;
	      return {
	        watchFile: watchFile3,
	        fallbackPolling: defaultFallbackPolling === void 0 ? fallbackPolling : defaultFallbackPolling
	      };
	    }
	    function watchDirectory(directoryName, callback, recursive, options) {
	      if (fsSupportsRecursiveFsWatch) {
	        return fsWatch(
	          directoryName,
	          1 /* Directory */,
	          createFsWatchCallbackForDirectoryWatcherCallback(directoryName, callback, options, useCaseSensitiveFileNames2, getCurrentDirectory),
	          recursive,
	          500 /* Medium */,
	          getFallbackOptions(options)
	        );
	      }
	      if (!hostRecursiveDirectoryWatcher) {
	        hostRecursiveDirectoryWatcher = createDirectoryWatcherSupportingRecursive({
	          useCaseSensitiveFileNames: useCaseSensitiveFileNames2,
	          getCurrentDirectory,
	          fileSystemEntryExists,
	          getAccessibleSortedChildDirectories,
	          watchDirectory: nonRecursiveWatchDirectory,
	          realpath,
	          setTimeout: setTimeout2,
	          clearTimeout: clearTimeout2
	        });
	      }
	      return hostRecursiveDirectoryWatcher(directoryName, callback, recursive, options);
	    }
	    function nonRecursiveWatchDirectory(directoryName, callback, recursive, options) {
	      Debug.assert(!recursive);
	      const watchDirectoryOptions = updateOptionsForWatchDirectory(options);
	      const watchDirectoryKind = Debug.checkDefined(watchDirectoryOptions.watchDirectory);
	      switch (watchDirectoryKind) {
	        case 1 /* FixedPollingInterval */:
	          return pollingWatchFile(
	            directoryName,
	            () => callback(directoryName),
	            500 /* Medium */,
	            /*options*/
	            void 0
	          );
	        case 2 /* DynamicPriorityPolling */:
	          return ensureDynamicPollingWatchFile()(
	            directoryName,
	            () => callback(directoryName),
	            500 /* Medium */,
	            /*options*/
	            void 0
	          );
	        case 3 /* FixedChunkSizePolling */:
	          return ensureFixedChunkSizePollingWatchFile()(
	            directoryName,
	            () => callback(directoryName),
	            /* pollingInterval */
	            void 0,
	            /*options*/
	            void 0
	          );
	        case 0 /* UseFsEvents */:
	          return fsWatch(
	            directoryName,
	            1 /* Directory */,
	            createFsWatchCallbackForDirectoryWatcherCallback(directoryName, callback, options, useCaseSensitiveFileNames2, getCurrentDirectory),
	            recursive,
	            500 /* Medium */,
	            getFallbackOptions(watchDirectoryOptions)
	          );
	        default:
	          Debug.assertNever(watchDirectoryKind);
	      }
	    }
	    function updateOptionsForWatchDirectory(options) {
	      if (options && options.watchDirectory !== void 0)
	        return options;
	      switch (tscWatchDirectory) {
	        case "RecursiveDirectoryUsingFsWatchFile":
	          return { watchDirectory: 1 /* FixedPollingInterval */ };
	        case "RecursiveDirectoryUsingDynamicPriorityPolling":
	          return { watchDirectory: 2 /* DynamicPriorityPolling */ };
	        default:
	          const defaultFallbackPolling = options == null ? void 0 : options.fallbackPolling;
	          return {
	            watchDirectory: 0 /* UseFsEvents */,
	            fallbackPolling: defaultFallbackPolling !== void 0 ? defaultFallbackPolling : void 0
	          };
	      }
	    }
	    function pollingWatchFile(fileName, callback, pollingInterval, options) {
	      return createSingleWatcherPerName(
	        pollingWatches,
	        useCaseSensitiveFileNames2,
	        fileName,
	        callback,
	        (cb) => pollingWatchFileWorker(fileName, cb, pollingInterval, options)
	      );
	    }
	    function fsWatch(fileOrDirectory, entryKind, callback, recursive, fallbackPollingInterval, fallbackOptions) {
	      return createSingleWatcherPerName(
	        recursive ? fsWatchesRecursive : fsWatches,
	        useCaseSensitiveFileNames2,
	        fileOrDirectory,
	        callback,
	        (cb) => fsWatchHandlingExistenceOnHost(fileOrDirectory, entryKind, cb, recursive, fallbackPollingInterval, fallbackOptions)
	      );
	    }
	    function fsWatchHandlingExistenceOnHost(fileOrDirectory, entryKind, callback, recursive, fallbackPollingInterval, fallbackOptions) {
	      let lastDirectoryPartWithDirectorySeparator;
	      let lastDirectoryPart;
	      if (inodeWatching) {
	        lastDirectoryPartWithDirectorySeparator = fileOrDirectory.substring(fileOrDirectory.lastIndexOf(directorySeparator));
	        lastDirectoryPart = lastDirectoryPartWithDirectorySeparator.slice(directorySeparator.length);
	      }
	      let watcher = !fileSystemEntryExists(fileOrDirectory, entryKind) ? watchMissingFileSystemEntry() : watchPresentFileSystemEntry();
	      return {
	        close: () => {
	          if (watcher) {
	            watcher.close();
	            watcher = void 0;
	          }
	        }
	      };
	      function updateWatcher(createWatcher) {
	        if (watcher) {
	          sysLog2(`sysLog:: ${fileOrDirectory}:: Changing watcher to ${createWatcher === watchPresentFileSystemEntry ? "Present" : "Missing"}FileSystemEntryWatcher`);
	          watcher.close();
	          watcher = createWatcher();
	        }
	      }
	      function watchPresentFileSystemEntry() {
	        if (hitSystemWatcherLimit) {
	          sysLog2(`sysLog:: ${fileOrDirectory}:: Defaulting to watchFile`);
	          return watchPresentFileSystemEntryWithFsWatchFile();
	        }
	        try {
	          const presentWatcher = (entryKind === 1 /* Directory */ || !fsWatchWithTimestamp ? fsWatchWorker : fsWatchWorkerHandlingTimestamp)(
	            fileOrDirectory,
	            recursive,
	            inodeWatching ? callbackChangingToMissingFileSystemEntry : callback
	          );
	          presentWatcher.on("error", () => {
	            callback("rename", "");
	            updateWatcher(watchMissingFileSystemEntry);
	          });
	          return presentWatcher;
	        } catch (e) {
	          hitSystemWatcherLimit || (hitSystemWatcherLimit = e.code === "ENOSPC");
	          sysLog2(`sysLog:: ${fileOrDirectory}:: Changing to watchFile`);
	          return watchPresentFileSystemEntryWithFsWatchFile();
	        }
	      }
	      function callbackChangingToMissingFileSystemEntry(event, relativeName) {
	        let originalRelativeName;
	        if (relativeName && endsWith(relativeName, "~")) {
	          originalRelativeName = relativeName;
	          relativeName = relativeName.slice(0, relativeName.length - 1);
	        }
	        if (event === "rename" && (!relativeName || relativeName === lastDirectoryPart || endsWith(relativeName, lastDirectoryPartWithDirectorySeparator))) {
	          const modifiedTime = getModifiedTime3(fileOrDirectory) || missingFileModifiedTime;
	          if (originalRelativeName)
	            callback(event, originalRelativeName, modifiedTime);
	          callback(event, relativeName, modifiedTime);
	          if (inodeWatching) {
	            updateWatcher(modifiedTime === missingFileModifiedTime ? watchMissingFileSystemEntry : watchPresentFileSystemEntry);
	          } else if (modifiedTime === missingFileModifiedTime) {
	            updateWatcher(watchMissingFileSystemEntry);
	          }
	        } else {
	          if (originalRelativeName)
	            callback(event, originalRelativeName);
	          callback(event, relativeName);
	        }
	      }
	      function watchPresentFileSystemEntryWithFsWatchFile() {
	        return watchFile2(
	          fileOrDirectory,
	          createFileWatcherCallback(callback),
	          fallbackPollingInterval,
	          fallbackOptions
	        );
	      }
	      function watchMissingFileSystemEntry() {
	        return watchFile2(
	          fileOrDirectory,
	          (_fileName, eventKind, modifiedTime) => {
	            if (eventKind === 0 /* Created */) {
	              modifiedTime || (modifiedTime = getModifiedTime3(fileOrDirectory) || missingFileModifiedTime);
	              if (modifiedTime !== missingFileModifiedTime) {
	                callback("rename", "", modifiedTime);
	                updateWatcher(watchPresentFileSystemEntry);
	              }
	            }
	          },
	          fallbackPollingInterval,
	          fallbackOptions
	        );
	      }
	    }
	    function fsWatchWorkerHandlingTimestamp(fileOrDirectory, recursive, callback) {
	      let modifiedTime = getModifiedTime3(fileOrDirectory) || missingFileModifiedTime;
	      return fsWatchWorker(fileOrDirectory, recursive, (eventName, relativeFileName, currentModifiedTime) => {
	        if (eventName === "change") {
	          currentModifiedTime || (currentModifiedTime = getModifiedTime3(fileOrDirectory) || missingFileModifiedTime);
	          if (currentModifiedTime.getTime() === modifiedTime.getTime())
	            return;
	        }
	        modifiedTime = currentModifiedTime || getModifiedTime3(fileOrDirectory) || missingFileModifiedTime;
	        callback(eventName, relativeFileName, modifiedTime);
	      });
	    }
	  }
	  function patchWriteFileEnsuringDirectory(sys2) {
	    const originalWriteFile = sys2.writeFile;
	    sys2.writeFile = (path, data, writeBom) => writeFileEnsuringDirectories(
	      path,
	      data,
	      !!writeBom,
	      (path2, data2, writeByteOrderMark) => originalWriteFile.call(sys2, path2, data2, writeByteOrderMark),
	      (path2) => sys2.createDirectory(path2),
	      (path2) => sys2.directoryExists(path2)
	    );
	  }
	  function setSys(s) {
	    sys = s;
	  }
	  var FileWatcherEventKind, PollingInterval, missingFileModifiedTime, defaultChunkLevels, pollingChunkSize, unchangedPollThresholds, ignoredPaths, curSysLog, FileSystemEntryKind, sys;
	  var init_sys = __esm({
	    "src/compiler/sys.ts"() {
	      init_ts2();
	      FileWatcherEventKind = /* @__PURE__ */ ((FileWatcherEventKind2) => {
	        FileWatcherEventKind2[FileWatcherEventKind2["Created"] = 0] = "Created";
	        FileWatcherEventKind2[FileWatcherEventKind2["Changed"] = 1] = "Changed";
	        FileWatcherEventKind2[FileWatcherEventKind2["Deleted"] = 2] = "Deleted";
	        return FileWatcherEventKind2;
	      })(FileWatcherEventKind || {});
	      PollingInterval = /* @__PURE__ */ ((PollingInterval3) => {
	        PollingInterval3[PollingInterval3["High"] = 2e3] = "High";
	        PollingInterval3[PollingInterval3["Medium"] = 500] = "Medium";
	        PollingInterval3[PollingInterval3["Low"] = 250] = "Low";
	        return PollingInterval3;
	      })(PollingInterval || {});
	      missingFileModifiedTime = /* @__PURE__ */ new Date(0);
	      defaultChunkLevels = { Low: 32, Medium: 64, High: 256 };
	      pollingChunkSize = createPollingIntervalBasedLevels(defaultChunkLevels);
	      unchangedPollThresholds = createPollingIntervalBasedLevels(defaultChunkLevels);
	      ignoredPaths = ["/node_modules/.", "/.git", "/.#"];
	      curSysLog = noop;
	      FileSystemEntryKind = /* @__PURE__ */ ((FileSystemEntryKind2) => {
	        FileSystemEntryKind2[FileSystemEntryKind2["File"] = 0] = "File";
	        FileSystemEntryKind2[FileSystemEntryKind2["Directory"] = 1] = "Directory";
	        return FileSystemEntryKind2;
	      })(FileSystemEntryKind || {});
	      sys = (() => {
	        const byteOrderMarkIndicator = "\uFEFF";
	        function getNodeSystem() {
	          const nativePattern = /^native |^\([^)]+\)$|^(internal[\\/]|[a-zA-Z0-9_\s]+(\.js)?$)/;
	          const _fs = require$$0__default["default"];
	          const _path = path__default["default"];
	          const _os = require$$0__default$1["default"];
	          let _crypto;
	          try {
	            _crypto = require("crypto");
	          } catch {
	            _crypto = void 0;
	          }
	          let activeSession;
	          let profilePath = "./profile.cpuprofile";
	          const Buffer2 = require$$5__default["default"].Buffer;
	          const isMacOs = process.platform === "darwin";
	          const isLinuxOrMacOs = process.platform === "linux" || isMacOs;
	          const platform = _os.platform();
	          const useCaseSensitiveFileNames2 = isFileSystemCaseSensitive();
	          const fsRealpath = !!_fs.realpathSync.native ? process.platform === "win32" ? fsRealPathHandlingLongPath : _fs.realpathSync.native : _fs.realpathSync;
	          const executingFilePath = __filename.endsWith("sys.js") ? _path.join(_path.dirname(__dirname), "__fake__.js") : __filename;
	          const fsSupportsRecursiveFsWatch = process.platform === "win32" || isMacOs;
	          const getCurrentDirectory = memoize(() => process.cwd());
	          const { watchFile: watchFile2, watchDirectory } = createSystemWatchFunctions({
	            pollingWatchFileWorker: fsWatchFileWorker,
	            getModifiedTime: getModifiedTime3,
	            setTimeout,
	            clearTimeout,
	            fsWatchWorker,
	            useCaseSensitiveFileNames: useCaseSensitiveFileNames2,
	            getCurrentDirectory,
	            fileSystemEntryExists,
	            // Node 4.0 `fs.watch` function supports the "recursive" option on both OSX and Windows
	            // (ref: https://github.com/nodejs/node/pull/2649 and https://github.com/Microsoft/TypeScript/issues/4643)
	            fsSupportsRecursiveFsWatch,
	            getAccessibleSortedChildDirectories: (path) => getAccessibleFileSystemEntries(path).directories,
	            realpath,
	            tscWatchFile: process.env.TSC_WATCHFILE,
	            useNonPollingWatchers: !!process.env.TSC_NONPOLLING_WATCHER,
	            tscWatchDirectory: process.env.TSC_WATCHDIRECTORY,
	            inodeWatching: isLinuxOrMacOs,
	            fsWatchWithTimestamp: isMacOs,
	            sysLog
	          });
	          const nodeSystem = {
	            args: process.argv.slice(2),
	            newLine: _os.EOL,
	            useCaseSensitiveFileNames: useCaseSensitiveFileNames2,
	            write(s) {
	              process.stdout.write(s);
	            },
	            getWidthOfTerminal() {
	              return process.stdout.columns;
	            },
	            writeOutputIsTTY() {
	              return process.stdout.isTTY;
	            },
	            readFile,
	            writeFile: writeFile2,
	            watchFile: watchFile2,
	            watchDirectory,
	            resolvePath: (path) => _path.resolve(path),
	            fileExists,
	            directoryExists,
	            getAccessibleFileSystemEntries,
	            createDirectory(directoryName) {
	              if (!nodeSystem.directoryExists(directoryName)) {
	                try {
	                  _fs.mkdirSync(directoryName);
	                } catch (e) {
	                  if (e.code !== "EEXIST") {
	                    throw e;
	                  }
	                }
	              }
	            },
	            getExecutingFilePath() {
	              return executingFilePath;
	            },
	            getCurrentDirectory,
	            getDirectories,
	            getEnvironmentVariable(name) {
	              return process.env[name] || "";
	            },
	            readDirectory,
	            getModifiedTime: getModifiedTime3,
	            setModifiedTime,
	            deleteFile,
	            createHash: _crypto ? createSHA256Hash : generateDjb2Hash,
	            createSHA256Hash: _crypto ? createSHA256Hash : void 0,
	            getMemoryUsage() {
	              if (commonjsGlobal.gc) {
	                commonjsGlobal.gc();
	              }
	              return process.memoryUsage().heapUsed;
	            },
	            getFileSize(path) {
	              try {
	                const stat = statSync(path);
	                if (stat == null ? void 0 : stat.isFile()) {
	                  return stat.size;
	                }
	              } catch {
	              }
	              return 0;
	            },
	            exit(exitCode) {
	              disableCPUProfiler(() => process.exit(exitCode));
	            },
	            enableCPUProfiler,
	            disableCPUProfiler,
	            cpuProfilingEnabled: () => !!activeSession || contains(process.execArgv, "--cpu-prof") || contains(process.execArgv, "--prof"),
	            realpath,
	            debugMode: !!process.env.NODE_INSPECTOR_IPC || !!process.env.VSCODE_INSPECTOR_OPTIONS || some(process.execArgv, (arg) => /^--(inspect|debug)(-brk)?(=\d+)?$/i.test(arg)) || !!process.recordreplay,
	            tryEnableSourceMapsForHost() {
	              try {
	                requireSourceMapSupport().install();
	              } catch {
	              }
	            },
	            setTimeout,
	            clearTimeout,
	            clearScreen: () => {
	              process.stdout.write("\x1Bc");
	            },
	            setBlocking: () => {
	              var _a;
	              const handle = (_a = process.stdout) == null ? void 0 : _a._handle;
	              if (handle && handle.setBlocking) {
	                handle.setBlocking(true);
	              }
	            },
	            bufferFrom,
	            base64decode: (input) => bufferFrom(input, "base64").toString("utf8"),
	            base64encode: (input) => bufferFrom(input).toString("base64"),
	            require: (baseDir, moduleName) => {
	              try {
	                const modulePath = resolveJSModule(moduleName, baseDir, nodeSystem);
	                return { module: commonjsRequire(modulePath), modulePath, error: void 0 };
	              } catch (error2) {
	                return { module: void 0, modulePath: void 0, error: error2 };
	              }
	            }
	          };
	          return nodeSystem;
	          function statSync(path) {
	            return _fs.statSync(path, { throwIfNoEntry: false });
	          }
	          function enableCPUProfiler(path, cb) {
	            if (activeSession) {
	              cb();
	              return false;
	            }
	            const inspector = require$$7__default["default"];
	            if (!inspector || !inspector.Session) {
	              cb();
	              return false;
	            }
	            const session = new inspector.Session();
	            session.connect();
	            session.post("Profiler.enable", () => {
	              session.post("Profiler.start", () => {
	                activeSession = session;
	                profilePath = path;
	                cb();
	              });
	            });
	            return true;
	          }
	          function cleanupPaths(profile) {
	            let externalFileCounter = 0;
	            const remappedPaths = /* @__PURE__ */ new Map();
	            const normalizedDir = normalizeSlashes(_path.dirname(executingFilePath));
	            const fileUrlRoot = `file://${getRootLength(normalizedDir) === 1 ? "" : "/"}${normalizedDir}`;
	            for (const node of profile.nodes) {
	              if (node.callFrame.url) {
	                const url = normalizeSlashes(node.callFrame.url);
	                if (containsPath(fileUrlRoot, url, useCaseSensitiveFileNames2)) {
	                  node.callFrame.url = getRelativePathToDirectoryOrUrl(
	                    fileUrlRoot,
	                    url,
	                    fileUrlRoot,
	                    createGetCanonicalFileName(useCaseSensitiveFileNames2),
	                    /*isAbsolutePathAnUrl*/
	                    true
	                  );
	                } else if (!nativePattern.test(url)) {
	                  node.callFrame.url = (remappedPaths.has(url) ? remappedPaths : remappedPaths.set(url, `external${externalFileCounter}.js`)).get(url);
	                  externalFileCounter++;
	                }
	              }
	            }
	            return profile;
	          }
	          function disableCPUProfiler(cb) {
	            if (activeSession && activeSession !== "stopping") {
	              const s = activeSession;
	              activeSession.post("Profiler.stop", (err, { profile }) => {
	                var _a;
	                if (!err) {
	                  try {
	                    if ((_a = statSync(profilePath)) == null ? void 0 : _a.isDirectory()) {
	                      profilePath = _path.join(profilePath, `${( new Date()).toISOString().replace(/:/g, "-")}+P${process.pid}.cpuprofile`);
	                    }
	                  } catch {
	                  }
	                  try {
	                    _fs.mkdirSync(_path.dirname(profilePath), { recursive: true });
	                  } catch {
	                  }
	                  _fs.writeFileSync(profilePath, JSON.stringify(cleanupPaths(profile)));
	                }
	                activeSession = void 0;
	                s.disconnect();
	                cb();
	              });
	              activeSession = "stopping";
	              return true;
	            } else {
	              cb();
	              return false;
	            }
	          }
	          function bufferFrom(input, encoding) {
	            return Buffer2.from && Buffer2.from !== Int8Array.from ? Buffer2.from(input, encoding) : new Buffer2(input, encoding);
	          }
	          function isFileSystemCaseSensitive() {
	            if (platform === "win32" || platform === "win64") {
	              return false;
	            }
	            return !fileExists(swapCase(__filename));
	          }
	          function swapCase(s) {
	            return s.replace(/\w/g, (ch) => {
	              const up = ch.toUpperCase();
	              return ch === up ? ch.toLowerCase() : up;
	            });
	          }
	          function fsWatchFileWorker(fileName, callback, pollingInterval) {
	            _fs.watchFile(fileName, { persistent: true, interval: pollingInterval }, fileChanged);
	            let eventKind;
	            return {
	              close: () => _fs.unwatchFile(fileName, fileChanged)
	            };
	            function fileChanged(curr, prev) {
	              const isPreviouslyDeleted = +prev.mtime === 0 || eventKind === 2 /* Deleted */;
	              if (+curr.mtime === 0) {
	                if (isPreviouslyDeleted) {
	                  return;
	                }
	                eventKind = 2 /* Deleted */;
	              } else if (isPreviouslyDeleted) {
	                eventKind = 0 /* Created */;
	              } else if (+curr.mtime === +prev.mtime) {
	                return;
	              } else {
	                eventKind = 1 /* Changed */;
	              }
	              callback(fileName, eventKind, curr.mtime);
	            }
	          }
	          function fsWatchWorker(fileOrDirectory, recursive, callback) {
	            return _fs.watch(
	              fileOrDirectory,
	              fsSupportsRecursiveFsWatch ? { persistent: true, recursive: !!recursive } : { persistent: true },
	              callback
	            );
	          }
	          function readFileWorker(fileName, _encoding) {
	            let buffer;
	            try {
	              buffer = _fs.readFileSync(fileName);
	            } catch (e) {
	              return void 0;
	            }
	            let len = buffer.length;
	            if (len >= 2 && buffer[0] === 254 && buffer[1] === 255) {
	              len &= ~1;
	              for (let i = 0; i < len; i += 2) {
	                const temp = buffer[i];
	                buffer[i] = buffer[i + 1];
	                buffer[i + 1] = temp;
	              }
	              return buffer.toString("utf16le", 2);
	            }
	            if (len >= 2 && buffer[0] === 255 && buffer[1] === 254) {
	              return buffer.toString("utf16le", 2);
	            }
	            if (len >= 3 && buffer[0] === 239 && buffer[1] === 187 && buffer[2] === 191) {
	              return buffer.toString("utf8", 3);
	            }
	            return buffer.toString("utf8");
	          }
	          function readFile(fileName, _encoding) {
	            var _a, _b;
	            (_a = perfLogger) == null ? void 0 : _a.logStartReadFile(fileName);
	            const file = readFileWorker(fileName);
	            (_b = perfLogger) == null ? void 0 : _b.logStopReadFile();
	            return file;
	          }
	          function writeFile2(fileName, data, writeByteOrderMark) {
	            var _a;
	            (_a = perfLogger) == null ? void 0 : _a.logEvent("WriteFile: " + fileName);
	            if (writeByteOrderMark) {
	              data = byteOrderMarkIndicator + data;
	            }
	            let fd;
	            try {
	              fd = _fs.openSync(fileName, "w");
	              _fs.writeSync(
	                fd,
	                data,
	                /*position*/
	                void 0,
	                "utf8"
	              );
	            } finally {
	              if (fd !== void 0) {
	                _fs.closeSync(fd);
	              }
	            }
	          }
	          function getAccessibleFileSystemEntries(path) {
	            var _a;
	            (_a = perfLogger) == null ? void 0 : _a.logEvent("ReadDir: " + (path || "."));
	            try {
	              const entries = _fs.readdirSync(path || ".", { withFileTypes: true });
	              const files = [];
	              const directories = [];
	              for (const dirent of entries) {
	                const entry = typeof dirent === "string" ? dirent : dirent.name;
	                if (entry === "." || entry === "..") {
	                  continue;
	                }
	                let stat;
	                if (typeof dirent === "string" || dirent.isSymbolicLink()) {
	                  const name = combinePaths(path, entry);
	                  try {
	                    stat = statSync(name);
	                    if (!stat) {
	                      continue;
	                    }
	                  } catch (e) {
	                    continue;
	                  }
	                } else {
	                  stat = dirent;
	                }
	                if (stat.isFile()) {
	                  files.push(entry);
	                } else if (stat.isDirectory()) {
	                  directories.push(entry);
	                }
	              }
	              files.sort();
	              directories.sort();
	              return { files, directories };
	            } catch (e) {
	              return emptyFileSystemEntries;
	            }
	          }
	          function readDirectory(path, extensions, excludes, includes, depth) {
	            return matchFiles(path, extensions, excludes, includes, useCaseSensitiveFileNames2, process.cwd(), depth, getAccessibleFileSystemEntries, realpath);
	          }
	          function fileSystemEntryExists(path, entryKind) {
	            const originalStackTraceLimit = Error.stackTraceLimit;
	            Error.stackTraceLimit = 0;
	            try {
	              const stat = statSync(path);
	              if (!stat) {
	                return false;
	              }
	              switch (entryKind) {
	                case 0 /* File */:
	                  return stat.isFile();
	                case 1 /* Directory */:
	                  return stat.isDirectory();
	                default:
	                  return false;
	              }
	            } catch (e) {
	              return false;
	            } finally {
	              Error.stackTraceLimit = originalStackTraceLimit;
	            }
	          }
	          function fileExists(path) {
	            return fileSystemEntryExists(path, 0 /* File */);
	          }
	          function directoryExists(path) {
	            return fileSystemEntryExists(path, 1 /* Directory */);
	          }
	          function getDirectories(path) {
	            return getAccessibleFileSystemEntries(path).directories.slice();
	          }
	          function fsRealPathHandlingLongPath(path) {
	            return path.length < 260 ? _fs.realpathSync.native(path) : _fs.realpathSync(path);
	          }
	          function realpath(path) {
	            try {
	              return fsRealpath(path);
	            } catch {
	              return path;
	            }
	          }
	          function getModifiedTime3(path) {
	            var _a;
	            const originalStackTraceLimit = Error.stackTraceLimit;
	            Error.stackTraceLimit = 0;
	            try {
	              return (_a = statSync(path)) == null ? void 0 : _a.mtime;
	            } catch (e) {
	              return void 0;
	            } finally {
	              Error.stackTraceLimit = originalStackTraceLimit;
	            }
	          }
	          function setModifiedTime(path, time) {
	            try {
	              _fs.utimesSync(path, time, time);
	            } catch (e) {
	              return;
	            }
	          }
	          function deleteFile(path) {
	            try {
	              return _fs.unlinkSync(path);
	            } catch (e) {
	              return;
	            }
	          }
	          function createSHA256Hash(data) {
	            const hash = _crypto.createHash("sha256");
	            hash.update(data);
	            return hash.digest("hex");
	          }
	        }
	        let sys2;
	        if (isNodeLikeSystem()) {
	          sys2 = getNodeSystem();
	        }
	        if (sys2) {
	          patchWriteFileEnsuringDirectory(sys2);
	        }
	        return sys2;
	      })();
	      if (sys && sys.getEnvironmentVariable) {
	        setCustomPollingValues(sys);
	        Debug.setAssertionLevel(
	          /^development$/i.test(sys.getEnvironmentVariable("NODE_ENV")) ? 1 /* Normal */ : 0 /* None */
	        );
	      }
	      if (sys && sys.debugMode) {
	        Debug.isDebugging = true;
	      }
	    }
	  });

	  // src/compiler/path.ts
	  function isAnyDirectorySeparator(charCode) {
	    return charCode === 47 /* slash */ || charCode === 92 /* backslash */;
	  }
	  function isUrl(path) {
	    return getEncodedRootLength(path) < 0;
	  }
	  function isRootedDiskPath(path) {
	    return getEncodedRootLength(path) > 0;
	  }
	  function isDiskPathRoot(path) {
	    const rootLength = getEncodedRootLength(path);
	    return rootLength > 0 && rootLength === path.length;
	  }
	  function pathIsAbsolute(path) {
	    return getEncodedRootLength(path) !== 0;
	  }
	  function pathIsRelative(path) {
	    return /^\.\.?($|[\\/])/.test(path);
	  }
	  function pathIsBareSpecifier(path) {
	    return !pathIsAbsolute(path) && !pathIsRelative(path);
	  }
	  function hasExtension(fileName) {
	    return getBaseFileName(fileName).includes(".");
	  }
	  function fileExtensionIs(path, extension) {
	    return path.length > extension.length && endsWith(path, extension);
	  }
	  function fileExtensionIsOneOf(path, extensions) {
	    for (const extension of extensions) {
	      if (fileExtensionIs(path, extension)) {
	        return true;
	      }
	    }
	    return false;
	  }
	  function hasTrailingDirectorySeparator(path) {
	    return path.length > 0 && isAnyDirectorySeparator(path.charCodeAt(path.length - 1));
	  }
	  function isVolumeCharacter(charCode) {
	    return charCode >= 97 /* a */ && charCode <= 122 /* z */ || charCode >= 65 /* A */ && charCode <= 90 /* Z */;
	  }
	  function getFileUrlVolumeSeparatorEnd(url, start) {
	    const ch0 = url.charCodeAt(start);
	    if (ch0 === 58 /* colon */)
	      return start + 1;
	    if (ch0 === 37 /* percent */ && url.charCodeAt(start + 1) === 51 /* _3 */) {
	      const ch2 = url.charCodeAt(start + 2);
	      if (ch2 === 97 /* a */ || ch2 === 65 /* A */)
	        return start + 3;
	    }
	    return -1;
	  }
	  function getEncodedRootLength(path) {
	    if (!path)
	      return 0;
	    const ch0 = path.charCodeAt(0);
	    if (ch0 === 47 /* slash */ || ch0 === 92 /* backslash */) {
	      if (path.charCodeAt(1) !== ch0)
	        return 1;
	      const p1 = path.indexOf(ch0 === 47 /* slash */ ? directorySeparator : altDirectorySeparator, 2);
	      if (p1 < 0)
	        return path.length;
	      return p1 + 1;
	    }
	    if (isVolumeCharacter(ch0) && path.charCodeAt(1) === 58 /* colon */) {
	      const ch2 = path.charCodeAt(2);
	      if (ch2 === 47 /* slash */ || ch2 === 92 /* backslash */)
	        return 3;
	      if (path.length === 2)
	        return 2;
	    }
	    const schemeEnd = path.indexOf(urlSchemeSeparator);
	    if (schemeEnd !== -1) {
	      const authorityStart = schemeEnd + urlSchemeSeparator.length;
	      const authorityEnd = path.indexOf(directorySeparator, authorityStart);
	      if (authorityEnd !== -1) {
	        const scheme = path.slice(0, schemeEnd);
	        const authority = path.slice(authorityStart, authorityEnd);
	        if (scheme === "file" && (authority === "" || authority === "localhost") && isVolumeCharacter(path.charCodeAt(authorityEnd + 1))) {
	          const volumeSeparatorEnd = getFileUrlVolumeSeparatorEnd(path, authorityEnd + 2);
	          if (volumeSeparatorEnd !== -1) {
	            if (path.charCodeAt(volumeSeparatorEnd) === 47 /* slash */) {
	              return ~(volumeSeparatorEnd + 1);
	            }
	            if (volumeSeparatorEnd === path.length) {
	              return ~volumeSeparatorEnd;
	            }
	          }
	        }
	        return ~(authorityEnd + 1);
	      }
	      return ~path.length;
	    }
	    return 0;
	  }
	  function getRootLength(path) {
	    const rootLength = getEncodedRootLength(path);
	    return rootLength < 0 ? ~rootLength : rootLength;
	  }
	  function getDirectoryPath(path) {
	    path = normalizeSlashes(path);
	    const rootLength = getRootLength(path);
	    if (rootLength === path.length)
	      return path;
	    path = removeTrailingDirectorySeparator(path);
	    return path.slice(0, Math.max(rootLength, path.lastIndexOf(directorySeparator)));
	  }
	  function getBaseFileName(path, extensions, ignoreCase) {
	    path = normalizeSlashes(path);
	    const rootLength = getRootLength(path);
	    if (rootLength === path.length)
	      return "";
	    path = removeTrailingDirectorySeparator(path);
	    const name = path.slice(Math.max(getRootLength(path), path.lastIndexOf(directorySeparator) + 1));
	    const extension = extensions !== void 0 && ignoreCase !== void 0 ? getAnyExtensionFromPath(name, extensions, ignoreCase) : void 0;
	    return extension ? name.slice(0, name.length - extension.length) : name;
	  }
	  function tryGetExtensionFromPath(path, extension, stringEqualityComparer) {
	    if (!startsWith(extension, "."))
	      extension = "." + extension;
	    if (path.length >= extension.length && path.charCodeAt(path.length - extension.length) === 46 /* dot */) {
	      const pathExtension = path.slice(path.length - extension.length);
	      if (stringEqualityComparer(pathExtension, extension)) {
	        return pathExtension;
	      }
	    }
	  }
	  function getAnyExtensionFromPathWorker(path, extensions, stringEqualityComparer) {
	    if (typeof extensions === "string") {
	      return tryGetExtensionFromPath(path, extensions, stringEqualityComparer) || "";
	    }
	    for (const extension of extensions) {
	      const result = tryGetExtensionFromPath(path, extension, stringEqualityComparer);
	      if (result)
	        return result;
	    }
	    return "";
	  }
	  function getAnyExtensionFromPath(path, extensions, ignoreCase) {
	    if (extensions) {
	      return getAnyExtensionFromPathWorker(removeTrailingDirectorySeparator(path), extensions, ignoreCase ? equateStringsCaseInsensitive : equateStringsCaseSensitive);
	    }
	    const baseFileName = getBaseFileName(path);
	    const extensionIndex = baseFileName.lastIndexOf(".");
	    if (extensionIndex >= 0) {
	      return baseFileName.substring(extensionIndex);
	    }
	    return "";
	  }
	  function pathComponents(path, rootLength) {
	    const root = path.substring(0, rootLength);
	    const rest = path.substring(rootLength).split(directorySeparator);
	    if (rest.length && !lastOrUndefined(rest))
	      rest.pop();
	    return [root, ...rest];
	  }
	  function getPathComponents(path, currentDirectory = "") {
	    path = combinePaths(currentDirectory, path);
	    return pathComponents(path, getRootLength(path));
	  }
	  function getPathFromPathComponents(pathComponents2, length2) {
	    if (pathComponents2.length === 0)
	      return "";
	    const root = pathComponents2[0] && ensureTrailingDirectorySeparator(pathComponents2[0]);
	    return root + pathComponents2.slice(1, length2).join(directorySeparator);
	  }
	  function normalizeSlashes(path) {
	    return path.includes("\\") ? path.replace(backslashRegExp, directorySeparator) : path;
	  }
	  function reducePathComponents(components) {
	    if (!some(components))
	      return [];
	    const reduced = [components[0]];
	    for (let i = 1; i < components.length; i++) {
	      const component = components[i];
	      if (!component)
	        continue;
	      if (component === ".")
	        continue;
	      if (component === "..") {
	        if (reduced.length > 1) {
	          if (reduced[reduced.length - 1] !== "..") {
	            reduced.pop();
	            continue;
	          }
	        } else if (reduced[0])
	          continue;
	      }
	      reduced.push(component);
	    }
	    return reduced;
	  }
	  function combinePaths(path, ...paths) {
	    if (path)
	      path = normalizeSlashes(path);
	    for (let relativePath of paths) {
	      if (!relativePath)
	        continue;
	      relativePath = normalizeSlashes(relativePath);
	      if (!path || getRootLength(relativePath) !== 0) {
	        path = relativePath;
	      } else {
	        path = ensureTrailingDirectorySeparator(path) + relativePath;
	      }
	    }
	    return path;
	  }
	  function resolvePath(path, ...paths) {
	    return normalizePath(some(paths) ? combinePaths(path, ...paths) : normalizeSlashes(path));
	  }
	  function getNormalizedPathComponents(path, currentDirectory) {
	    return reducePathComponents(getPathComponents(path, currentDirectory));
	  }
	  function getNormalizedAbsolutePath(fileName, currentDirectory) {
	    return getPathFromPathComponents(getNormalizedPathComponents(fileName, currentDirectory));
	  }
	  function normalizePath(path) {
	    path = normalizeSlashes(path);
	    if (!relativePathSegmentRegExp.test(path)) {
	      return path;
	    }
	    const simplified = path.replace(/\/\.\//g, "/").replace(/^\.\//, "");
	    if (simplified !== path) {
	      path = simplified;
	      if (!relativePathSegmentRegExp.test(path)) {
	        return path;
	      }
	    }
	    const normalized = getPathFromPathComponents(reducePathComponents(getPathComponents(path)));
	    return normalized && hasTrailingDirectorySeparator(path) ? ensureTrailingDirectorySeparator(normalized) : normalized;
	  }
	  function getPathWithoutRoot(pathComponents2) {
	    if (pathComponents2.length === 0)
	      return "";
	    return pathComponents2.slice(1).join(directorySeparator);
	  }
	  function getNormalizedAbsolutePathWithoutRoot(fileName, currentDirectory) {
	    return getPathWithoutRoot(getNormalizedPathComponents(fileName, currentDirectory));
	  }
	  function toPath(fileName, basePath, getCanonicalFileName) {
	    const nonCanonicalizedPath = isRootedDiskPath(fileName) ? normalizePath(fileName) : getNormalizedAbsolutePath(fileName, basePath);
	    return getCanonicalFileName(nonCanonicalizedPath);
	  }
	  function removeTrailingDirectorySeparator(path) {
	    if (hasTrailingDirectorySeparator(path)) {
	      return path.substr(0, path.length - 1);
	    }
	    return path;
	  }
	  function ensureTrailingDirectorySeparator(path) {
	    if (!hasTrailingDirectorySeparator(path)) {
	      return path + directorySeparator;
	    }
	    return path;
	  }
	  function ensurePathIsNonModuleName(path) {
	    return !pathIsAbsolute(path) && !pathIsRelative(path) ? "./" + path : path;
	  }
	  function changeAnyExtension(path, ext, extensions, ignoreCase) {
	    const pathext = extensions !== void 0 && ignoreCase !== void 0 ? getAnyExtensionFromPath(path, extensions, ignoreCase) : getAnyExtensionFromPath(path);
	    return pathext ? path.slice(0, path.length - pathext.length) + (startsWith(ext, ".") ? ext : "." + ext) : path;
	  }
	  function changeFullExtension(path, newExtension) {
	    const declarationExtension = getDeclarationFileExtension(path);
	    if (declarationExtension) {
	      return path.slice(0, path.length - declarationExtension.length) + (startsWith(newExtension, ".") ? newExtension : "." + newExtension);
	    }
	    return changeAnyExtension(path, newExtension);
	  }
	  function comparePathsWorker(a, b, componentComparer) {
	    if (a === b)
	      return 0 /* EqualTo */;
	    if (a === void 0)
	      return -1 /* LessThan */;
	    if (b === void 0)
	      return 1 /* GreaterThan */;
	    const aRoot = a.substring(0, getRootLength(a));
	    const bRoot = b.substring(0, getRootLength(b));
	    const result = compareStringsCaseInsensitive(aRoot, bRoot);
	    if (result !== 0 /* EqualTo */) {
	      return result;
	    }
	    const aRest = a.substring(aRoot.length);
	    const bRest = b.substring(bRoot.length);
	    if (!relativePathSegmentRegExp.test(aRest) && !relativePathSegmentRegExp.test(bRest)) {
	      return componentComparer(aRest, bRest);
	    }
	    const aComponents = reducePathComponents(getPathComponents(a));
	    const bComponents = reducePathComponents(getPathComponents(b));
	    const sharedLength = Math.min(aComponents.length, bComponents.length);
	    for (let i = 1; i < sharedLength; i++) {
	      const result2 = componentComparer(aComponents[i], bComponents[i]);
	      if (result2 !== 0 /* EqualTo */) {
	        return result2;
	      }
	    }
	    return compareValues(aComponents.length, bComponents.length);
	  }
	  function comparePathsCaseSensitive(a, b) {
	    return comparePathsWorker(a, b, compareStringsCaseSensitive);
	  }
	  function comparePathsCaseInsensitive(a, b) {
	    return comparePathsWorker(a, b, compareStringsCaseInsensitive);
	  }
	  function comparePaths(a, b, currentDirectory, ignoreCase) {
	    if (typeof currentDirectory === "string") {
	      a = combinePaths(currentDirectory, a);
	      b = combinePaths(currentDirectory, b);
	    } else if (typeof currentDirectory === "boolean") {
	      ignoreCase = currentDirectory;
	    }
	    return comparePathsWorker(a, b, getStringComparer(ignoreCase));
	  }
	  function containsPath(parent2, child, currentDirectory, ignoreCase) {
	    if (typeof currentDirectory === "string") {
	      parent2 = combinePaths(currentDirectory, parent2);
	      child = combinePaths(currentDirectory, child);
	    } else if (typeof currentDirectory === "boolean") {
	      ignoreCase = currentDirectory;
	    }
	    if (parent2 === void 0 || child === void 0)
	      return false;
	    if (parent2 === child)
	      return true;
	    const parentComponents = reducePathComponents(getPathComponents(parent2));
	    const childComponents = reducePathComponents(getPathComponents(child));
	    if (childComponents.length < parentComponents.length) {
	      return false;
	    }
	    const componentEqualityComparer = ignoreCase ? equateStringsCaseInsensitive : equateStringsCaseSensitive;
	    for (let i = 0; i < parentComponents.length; i++) {
	      const equalityComparer = i === 0 ? equateStringsCaseInsensitive : componentEqualityComparer;
	      if (!equalityComparer(parentComponents[i], childComponents[i])) {
	        return false;
	      }
	    }
	    return true;
	  }
	  function startsWithDirectory(fileName, directoryName, getCanonicalFileName) {
	    const canonicalFileName = getCanonicalFileName(fileName);
	    const canonicalDirectoryName = getCanonicalFileName(directoryName);
	    return startsWith(canonicalFileName, canonicalDirectoryName + "/") || startsWith(canonicalFileName, canonicalDirectoryName + "\\");
	  }
	  function getPathComponentsRelativeTo(from, to, stringEqualityComparer, getCanonicalFileName) {
	    const fromComponents = reducePathComponents(getPathComponents(from));
	    const toComponents = reducePathComponents(getPathComponents(to));
	    let start;
	    for (start = 0; start < fromComponents.length && start < toComponents.length; start++) {
	      const fromComponent = getCanonicalFileName(fromComponents[start]);
	      const toComponent = getCanonicalFileName(toComponents[start]);
	      const comparer = start === 0 ? equateStringsCaseInsensitive : stringEqualityComparer;
	      if (!comparer(fromComponent, toComponent))
	        break;
	    }
	    if (start === 0) {
	      return toComponents;
	    }
	    const components = toComponents.slice(start);
	    const relative = [];
	    for (; start < fromComponents.length; start++) {
	      relative.push("..");
	    }
	    return ["", ...relative, ...components];
	  }
	  function getRelativePathFromDirectory(fromDirectory, to, getCanonicalFileNameOrIgnoreCase) {
	    Debug.assert(getRootLength(fromDirectory) > 0 === getRootLength(to) > 0, "Paths must either both be absolute or both be relative");
	    const getCanonicalFileName = typeof getCanonicalFileNameOrIgnoreCase === "function" ? getCanonicalFileNameOrIgnoreCase : identity;
	    const ignoreCase = typeof getCanonicalFileNameOrIgnoreCase === "boolean" ? getCanonicalFileNameOrIgnoreCase : false;
	    const pathComponents2 = getPathComponentsRelativeTo(fromDirectory, to, ignoreCase ? equateStringsCaseInsensitive : equateStringsCaseSensitive, getCanonicalFileName);
	    return getPathFromPathComponents(pathComponents2);
	  }
	  function convertToRelativePath(absoluteOrRelativePath, basePath, getCanonicalFileName) {
	    return !isRootedDiskPath(absoluteOrRelativePath) ? absoluteOrRelativePath : getRelativePathToDirectoryOrUrl(
	      basePath,
	      absoluteOrRelativePath,
	      basePath,
	      getCanonicalFileName,
	      /*isAbsolutePathAnUrl*/
	      false
	    );
	  }
	  function getRelativePathFromFile(from, to, getCanonicalFileName) {
	    return ensurePathIsNonModuleName(getRelativePathFromDirectory(getDirectoryPath(from), to, getCanonicalFileName));
	  }
	  function getRelativePathToDirectoryOrUrl(directoryPathOrUrl, relativeOrAbsolutePath, currentDirectory, getCanonicalFileName, isAbsolutePathAnUrl) {
	    const pathComponents2 = getPathComponentsRelativeTo(
	      resolvePath(currentDirectory, directoryPathOrUrl),
	      resolvePath(currentDirectory, relativeOrAbsolutePath),
	      equateStringsCaseSensitive,
	      getCanonicalFileName
	    );
	    const firstComponent = pathComponents2[0];
	    if (isAbsolutePathAnUrl && isRootedDiskPath(firstComponent)) {
	      const prefix = firstComponent.charAt(0) === directorySeparator ? "file://" : "file:///";
	      pathComponents2[0] = prefix + firstComponent;
	    }
	    return getPathFromPathComponents(pathComponents2);
	  }
	  function forEachAncestorDirectory(directory, callback) {
	    while (true) {
	      const result = callback(directory);
	      if (result !== void 0) {
	        return result;
	      }
	      const parentPath = getDirectoryPath(directory);
	      if (parentPath === directory) {
	        return void 0;
	      }
	      directory = parentPath;
	    }
	  }
	  function isNodeModulesDirectory(dirPath) {
	    return endsWith(dirPath, "/node_modules");
	  }
	  var directorySeparator, altDirectorySeparator, urlSchemeSeparator, backslashRegExp, relativePathSegmentRegExp;
	  var init_path = __esm({
	    "src/compiler/path.ts"() {
	      init_ts2();
	      directorySeparator = "/";
	      altDirectorySeparator = "\\";
	      urlSchemeSeparator = "://";
	      backslashRegExp = /\\/g;
	      relativePathSegmentRegExp = /(?:\/\/)|(?:^|\/)\.\.?(?:$|\/)/;
	    }
	  });

	  // src/compiler/diagnosticInformationMap.generated.ts
	  function diag(code, category, key, message, reportsUnnecessary, elidedInCompatabilityPyramid, reportsDeprecated) {
	    return { code, category, key, message, reportsUnnecessary, elidedInCompatabilityPyramid, reportsDeprecated };
	  }
	  var Diagnostics;
	  var init_diagnosticInformationMap_generated = __esm({
	    "src/compiler/diagnosticInformationMap.generated.ts"() {
	      init_types();
	      Diagnostics = {
	        Unterminated_string_literal: diag(1002, 1 /* Error */, "Unterminated_string_literal_1002", "Unterminated string literal."),
	        Identifier_expected: diag(1003, 1 /* Error */, "Identifier_expected_1003", "Identifier expected."),
	        _0_expected: diag(1005, 1 /* Error */, "_0_expected_1005", "'{0}' expected."),
	        A_file_cannot_have_a_reference_to_itself: diag(1006, 1 /* Error */, "A_file_cannot_have_a_reference_to_itself_1006", "A file cannot have a reference to itself."),
	        The_parser_expected_to_find_a_1_to_match_the_0_token_here: diag(1007, 1 /* Error */, "The_parser_expected_to_find_a_1_to_match_the_0_token_here_1007", "The parser expected to find a '{1}' to match the '{0}' token here."),
	        Trailing_comma_not_allowed: diag(1009, 1 /* Error */, "Trailing_comma_not_allowed_1009", "Trailing comma not allowed."),
	        Asterisk_Slash_expected: diag(1010, 1 /* Error */, "Asterisk_Slash_expected_1010", "'*/' expected."),
	        An_element_access_expression_should_take_an_argument: diag(1011, 1 /* Error */, "An_element_access_expression_should_take_an_argument_1011", "An element access expression should take an argument."),
	        Unexpected_token: diag(1012, 1 /* Error */, "Unexpected_token_1012", "Unexpected token."),
	        A_rest_parameter_or_binding_pattern_may_not_have_a_trailing_comma: diag(1013, 1 /* Error */, "A_rest_parameter_or_binding_pattern_may_not_have_a_trailing_comma_1013", "A rest parameter or binding pattern may not have a trailing comma."),
	        A_rest_parameter_must_be_last_in_a_parameter_list: diag(1014, 1 /* Error */, "A_rest_parameter_must_be_last_in_a_parameter_list_1014", "A rest parameter must be last in a parameter list."),
	        Parameter_cannot_have_question_mark_and_initializer: diag(1015, 1 /* Error */, "Parameter_cannot_have_question_mark_and_initializer_1015", "Parameter cannot have question mark and initializer."),
	        A_required_parameter_cannot_follow_an_optional_parameter: diag(1016, 1 /* Error */, "A_required_parameter_cannot_follow_an_optional_parameter_1016", "A required parameter cannot follow an optional parameter."),
	        An_index_signature_cannot_have_a_rest_parameter: diag(1017, 1 /* Error */, "An_index_signature_cannot_have_a_rest_parameter_1017", "An index signature cannot have a rest parameter."),
	        An_index_signature_parameter_cannot_have_an_accessibility_modifier: diag(1018, 1 /* Error */, "An_index_signature_parameter_cannot_have_an_accessibility_modifier_1018", "An index signature parameter cannot have an accessibility modifier."),
	        An_index_signature_parameter_cannot_have_a_question_mark: diag(1019, 1 /* Error */, "An_index_signature_parameter_cannot_have_a_question_mark_1019", "An index signature parameter cannot have a question mark."),
	        An_index_signature_parameter_cannot_have_an_initializer: diag(1020, 1 /* Error */, "An_index_signature_parameter_cannot_have_an_initializer_1020", "An index signature parameter cannot have an initializer."),
	        An_index_signature_must_have_a_type_annotation: diag(1021, 1 /* Error */, "An_index_signature_must_have_a_type_annotation_1021", "An index signature must have a type annotation."),
	        An_index_signature_parameter_must_have_a_type_annotation: diag(1022, 1 /* Error */, "An_index_signature_parameter_must_have_a_type_annotation_1022", "An index signature parameter must have a type annotation."),
	        readonly_modifier_can_only_appear_on_a_property_declaration_or_index_signature: diag(1024, 1 /* Error */, "readonly_modifier_can_only_appear_on_a_property_declaration_or_index_signature_1024", "'readonly' modifier can only appear on a property declaration or index signature."),
	        An_index_signature_cannot_have_a_trailing_comma: diag(1025, 1 /* Error */, "An_index_signature_cannot_have_a_trailing_comma_1025", "An index signature cannot have a trailing comma."),
	        Accessibility_modifier_already_seen: diag(1028, 1 /* Error */, "Accessibility_modifier_already_seen_1028", "Accessibility modifier already seen."),
	        _0_modifier_must_precede_1_modifier: diag(1029, 1 /* Error */, "_0_modifier_must_precede_1_modifier_1029", "'{0}' modifier must precede '{1}' modifier."),
	        _0_modifier_already_seen: diag(1030, 1 /* Error */, "_0_modifier_already_seen_1030", "'{0}' modifier already seen."),
	        _0_modifier_cannot_appear_on_class_elements_of_this_kind: diag(1031, 1 /* Error */, "_0_modifier_cannot_appear_on_class_elements_of_this_kind_1031", "'{0}' modifier cannot appear on class elements of this kind."),
	        super_must_be_followed_by_an_argument_list_or_member_access: diag(1034, 1 /* Error */, "super_must_be_followed_by_an_argument_list_or_member_access_1034", "'super' must be followed by an argument list or member access."),
	        Only_ambient_modules_can_use_quoted_names: diag(1035, 1 /* Error */, "Only_ambient_modules_can_use_quoted_names_1035", "Only ambient modules can use quoted names."),
	        Statements_are_not_allowed_in_ambient_contexts: diag(1036, 1 /* Error */, "Statements_are_not_allowed_in_ambient_contexts_1036", "Statements are not allowed in ambient contexts."),
	        A_declare_modifier_cannot_be_used_in_an_already_ambient_context: diag(1038, 1 /* Error */, "A_declare_modifier_cannot_be_used_in_an_already_ambient_context_1038", "A 'declare' modifier cannot be used in an already ambient context."),
	        Initializers_are_not_allowed_in_ambient_contexts: diag(1039, 1 /* Error */, "Initializers_are_not_allowed_in_ambient_contexts_1039", "Initializers are not allowed in ambient contexts."),
	        _0_modifier_cannot_be_used_in_an_ambient_context: diag(1040, 1 /* Error */, "_0_modifier_cannot_be_used_in_an_ambient_context_1040", "'{0}' modifier cannot be used in an ambient context."),
	        _0_modifier_cannot_be_used_here: diag(1042, 1 /* Error */, "_0_modifier_cannot_be_used_here_1042", "'{0}' modifier cannot be used here."),
	        _0_modifier_cannot_appear_on_a_module_or_namespace_element: diag(1044, 1 /* Error */, "_0_modifier_cannot_appear_on_a_module_or_namespace_element_1044", "'{0}' modifier cannot appear on a module or namespace element."),
	        Top_level_declarations_in_d_ts_files_must_start_with_either_a_declare_or_export_modifier: diag(1046, 1 /* Error */, "Top_level_declarations_in_d_ts_files_must_start_with_either_a_declare_or_export_modifier_1046", "Top-level declarations in .d.ts files must start with either a 'declare' or 'export' modifier."),
	        A_rest_parameter_cannot_be_optional: diag(1047, 1 /* Error */, "A_rest_parameter_cannot_be_optional_1047", "A rest parameter cannot be optional."),
	        A_rest_parameter_cannot_have_an_initializer: diag(1048, 1 /* Error */, "A_rest_parameter_cannot_have_an_initializer_1048", "A rest parameter cannot have an initializer."),
	        A_set_accessor_must_have_exactly_one_parameter: diag(1049, 1 /* Error */, "A_set_accessor_must_have_exactly_one_parameter_1049", "A 'set' accessor must have exactly one parameter."),
	        A_set_accessor_cannot_have_an_optional_parameter: diag(1051, 1 /* Error */, "A_set_accessor_cannot_have_an_optional_parameter_1051", "A 'set' accessor cannot have an optional parameter."),
	        A_set_accessor_parameter_cannot_have_an_initializer: diag(1052, 1 /* Error */, "A_set_accessor_parameter_cannot_have_an_initializer_1052", "A 'set' accessor parameter cannot have an initializer."),
	        A_set_accessor_cannot_have_rest_parameter: diag(1053, 1 /* Error */, "A_set_accessor_cannot_have_rest_parameter_1053", "A 'set' accessor cannot have rest parameter."),
	        A_get_accessor_cannot_have_parameters: diag(1054, 1 /* Error */, "A_get_accessor_cannot_have_parameters_1054", "A 'get' accessor cannot have parameters."),
	        Type_0_is_not_a_valid_async_function_return_type_in_ES5_SlashES3_because_it_does_not_refer_to_a_Promise_compatible_constructor_value: diag(1055, 1 /* Error */, "Type_0_is_not_a_valid_async_function_return_type_in_ES5_SlashES3_because_it_does_not_refer_to_a_Prom_1055", "Type '{0}' is not a valid async function return type in ES5/ES3 because it does not refer to a Promise-compatible constructor value."),
	        Accessors_are_only_available_when_targeting_ECMAScript_5_and_higher: diag(1056, 1 /* Error */, "Accessors_are_only_available_when_targeting_ECMAScript_5_and_higher_1056", "Accessors are only available when targeting ECMAScript 5 and higher."),
	        The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member: diag(1058, 1 /* Error */, "The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_t_1058", "The return type of an async function must either be a valid promise or must not contain a callable 'then' member."),
	        A_promise_must_have_a_then_method: diag(1059, 1 /* Error */, "A_promise_must_have_a_then_method_1059", "A promise must have a 'then' method."),
	        The_first_parameter_of_the_then_method_of_a_promise_must_be_a_callback: diag(1060, 1 /* Error */, "The_first_parameter_of_the_then_method_of_a_promise_must_be_a_callback_1060", "The first parameter of the 'then' method of a promise must be a callback."),
	        Enum_member_must_have_initializer: diag(1061, 1 /* Error */, "Enum_member_must_have_initializer_1061", "Enum member must have initializer."),
	        Type_is_referenced_directly_or_indirectly_in_the_fulfillment_callback_of_its_own_then_method: diag(1062, 1 /* Error */, "Type_is_referenced_directly_or_indirectly_in_the_fulfillment_callback_of_its_own_then_method_1062", "Type is referenced directly or indirectly in the fulfillment callback of its own 'then' method."),
	        An_export_assignment_cannot_be_used_in_a_namespace: diag(1063, 1 /* Error */, "An_export_assignment_cannot_be_used_in_a_namespace_1063", "An export assignment cannot be used in a namespace."),
	        The_return_type_of_an_async_function_or_method_must_be_the_global_Promise_T_type_Did_you_mean_to_write_Promise_0: diag(1064, 1 /* Error */, "The_return_type_of_an_async_function_or_method_must_be_the_global_Promise_T_type_Did_you_mean_to_wri_1064", "The return type of an async function or method must be the global Promise<T> type. Did you mean to write 'Promise<{0}>'?"),
	        The_return_type_of_an_async_function_or_method_must_be_the_global_Promise_T_type: diag(1065, 1 /* Error */, "The_return_type_of_an_async_function_or_method_must_be_the_global_Promise_T_type_1065", "The return type of an async function or method must be the global Promise<T> type."),
	        In_ambient_enum_declarations_member_initializer_must_be_constant_expression: diag(1066, 1 /* Error */, "In_ambient_enum_declarations_member_initializer_must_be_constant_expression_1066", "In ambient enum declarations member initializer must be constant expression."),
	        Unexpected_token_A_constructor_method_accessor_or_property_was_expected: diag(1068, 1 /* Error */, "Unexpected_token_A_constructor_method_accessor_or_property_was_expected_1068", "Unexpected token. A constructor, method, accessor, or property was expected."),
	        Unexpected_token_A_type_parameter_name_was_expected_without_curly_braces: diag(1069, 1 /* Error */, "Unexpected_token_A_type_parameter_name_was_expected_without_curly_braces_1069", "Unexpected token. A type parameter name was expected without curly braces."),
	        _0_modifier_cannot_appear_on_a_type_member: diag(1070, 1 /* Error */, "_0_modifier_cannot_appear_on_a_type_member_1070", "'{0}' modifier cannot appear on a type member."),
	        _0_modifier_cannot_appear_on_an_index_signature: diag(1071, 1 /* Error */, "_0_modifier_cannot_appear_on_an_index_signature_1071", "'{0}' modifier cannot appear on an index signature."),
	        A_0_modifier_cannot_be_used_with_an_import_declaration: diag(1079, 1 /* Error */, "A_0_modifier_cannot_be_used_with_an_import_declaration_1079", "A '{0}' modifier cannot be used with an import declaration."),
	        Invalid_reference_directive_syntax: diag(1084, 1 /* Error */, "Invalid_reference_directive_syntax_1084", "Invalid 'reference' directive syntax."),
	        _0_modifier_cannot_appear_on_a_constructor_declaration: diag(1089, 1 /* Error */, "_0_modifier_cannot_appear_on_a_constructor_declaration_1089", "'{0}' modifier cannot appear on a constructor declaration."),
	        _0_modifier_cannot_appear_on_a_parameter: diag(1090, 1 /* Error */, "_0_modifier_cannot_appear_on_a_parameter_1090", "'{0}' modifier cannot appear on a parameter."),
	        Only_a_single_variable_declaration_is_allowed_in_a_for_in_statement: diag(1091, 1 /* Error */, "Only_a_single_variable_declaration_is_allowed_in_a_for_in_statement_1091", "Only a single variable declaration is allowed in a 'for...in' statement."),
	        Type_parameters_cannot_appear_on_a_constructor_declaration: diag(1092, 1 /* Error */, "Type_parameters_cannot_appear_on_a_constructor_declaration_1092", "Type parameters cannot appear on a constructor declaration."),
	        Type_annotation_cannot_appear_on_a_constructor_declaration: diag(1093, 1 /* Error */, "Type_annotation_cannot_appear_on_a_constructor_declaration_1093", "Type annotation cannot appear on a constructor declaration."),
	        An_accessor_cannot_have_type_parameters: diag(1094, 1 /* Error */, "An_accessor_cannot_have_type_parameters_1094", "An accessor cannot have type parameters."),
	        A_set_accessor_cannot_have_a_return_type_annotation: diag(1095, 1 /* Error */, "A_set_accessor_cannot_have_a_return_type_annotation_1095", "A 'set' accessor cannot have a return type annotation."),
	        An_index_signature_must_have_exactly_one_parameter: diag(1096, 1 /* Error */, "An_index_signature_must_have_exactly_one_parameter_1096", "An index signature must have exactly one parameter."),
	        _0_list_cannot_be_empty: diag(1097, 1 /* Error */, "_0_list_cannot_be_empty_1097", "'{0}' list cannot be empty."),
	        Type_parameter_list_cannot_be_empty: diag(1098, 1 /* Error */, "Type_parameter_list_cannot_be_empty_1098", "Type parameter list cannot be empty."),
	        Type_argument_list_cannot_be_empty: diag(1099, 1 /* Error */, "Type_argument_list_cannot_be_empty_1099", "Type argument list cannot be empty."),
	        Invalid_use_of_0_in_strict_mode: diag(1100, 1 /* Error */, "Invalid_use_of_0_in_strict_mode_1100", "Invalid use of '{0}' in strict mode."),
	        with_statements_are_not_allowed_in_strict_mode: diag(1101, 1 /* Error */, "with_statements_are_not_allowed_in_strict_mode_1101", "'with' statements are not allowed in strict mode."),
	        delete_cannot_be_called_on_an_identifier_in_strict_mode: diag(1102, 1 /* Error */, "delete_cannot_be_called_on_an_identifier_in_strict_mode_1102", "'delete' cannot be called on an identifier in strict mode."),
	        for_await_loops_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules: diag(1103, 1 /* Error */, "for_await_loops_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules_1103", "'for await' loops are only allowed within async functions and at the top levels of modules."),
	        A_continue_statement_can_only_be_used_within_an_enclosing_iteration_statement: diag(1104, 1 /* Error */, "A_continue_statement_can_only_be_used_within_an_enclosing_iteration_statement_1104", "A 'continue' statement can only be used within an enclosing iteration statement."),
	        A_break_statement_can_only_be_used_within_an_enclosing_iteration_or_switch_statement: diag(1105, 1 /* Error */, "A_break_statement_can_only_be_used_within_an_enclosing_iteration_or_switch_statement_1105", "A 'break' statement can only be used within an enclosing iteration or switch statement."),
	        The_left_hand_side_of_a_for_of_statement_may_not_be_async: diag(1106, 1 /* Error */, "The_left_hand_side_of_a_for_of_statement_may_not_be_async_1106", "The left-hand side of a 'for...of' statement may not be 'async'."),
	        Jump_target_cannot_cross_function_boundary: diag(1107, 1 /* Error */, "Jump_target_cannot_cross_function_boundary_1107", "Jump target cannot cross function boundary."),
	        A_return_statement_can_only_be_used_within_a_function_body: diag(1108, 1 /* Error */, "A_return_statement_can_only_be_used_within_a_function_body_1108", "A 'return' statement can only be used within a function body."),
	        Expression_expected: diag(1109, 1 /* Error */, "Expression_expected_1109", "Expression expected."),
	        Type_expected: diag(1110, 1 /* Error */, "Type_expected_1110", "Type expected."),
	        Private_field_0_must_be_declared_in_an_enclosing_class: diag(1111, 1 /* Error */, "Private_field_0_must_be_declared_in_an_enclosing_class_1111", "Private field '{0}' must be declared in an enclosing class."),
	        A_default_clause_cannot_appear_more_than_once_in_a_switch_statement: diag(1113, 1 /* Error */, "A_default_clause_cannot_appear_more_than_once_in_a_switch_statement_1113", "A 'default' clause cannot appear more than once in a 'switch' statement."),
	        Duplicate_label_0: diag(1114, 1 /* Error */, "Duplicate_label_0_1114", "Duplicate label '{0}'."),
	        A_continue_statement_can_only_jump_to_a_label_of_an_enclosing_iteration_statement: diag(1115, 1 /* Error */, "A_continue_statement_can_only_jump_to_a_label_of_an_enclosing_iteration_statement_1115", "A 'continue' statement can only jump to a label of an enclosing iteration statement."),
	        A_break_statement_can_only_jump_to_a_label_of_an_enclosing_statement: diag(1116, 1 /* Error */, "A_break_statement_can_only_jump_to_a_label_of_an_enclosing_statement_1116", "A 'break' statement can only jump to a label of an enclosing statement."),
	        An_object_literal_cannot_have_multiple_properties_with_the_same_name: diag(1117, 1 /* Error */, "An_object_literal_cannot_have_multiple_properties_with_the_same_name_1117", "An object literal cannot have multiple properties with the same name."),
	        An_object_literal_cannot_have_multiple_get_Slashset_accessors_with_the_same_name: diag(1118, 1 /* Error */, "An_object_literal_cannot_have_multiple_get_Slashset_accessors_with_the_same_name_1118", "An object literal cannot have multiple get/set accessors with the same name."),
	        An_object_literal_cannot_have_property_and_accessor_with_the_same_name: diag(1119, 1 /* Error */, "An_object_literal_cannot_have_property_and_accessor_with_the_same_name_1119", "An object literal cannot have property and accessor with the same name."),
	        An_export_assignment_cannot_have_modifiers: diag(1120, 1 /* Error */, "An_export_assignment_cannot_have_modifiers_1120", "An export assignment cannot have modifiers."),
	        Octal_literals_are_not_allowed_Use_the_syntax_0: diag(1121, 1 /* Error */, "Octal_literals_are_not_allowed_Use_the_syntax_0_1121", "Octal literals are not allowed. Use the syntax '{0}'."),
	        Variable_declaration_list_cannot_be_empty: diag(1123, 1 /* Error */, "Variable_declaration_list_cannot_be_empty_1123", "Variable declaration list cannot be empty."),
	        Digit_expected: diag(1124, 1 /* Error */, "Digit_expected_1124", "Digit expected."),
	        Hexadecimal_digit_expected: diag(1125, 1 /* Error */, "Hexadecimal_digit_expected_1125", "Hexadecimal digit expected."),
	        Unexpected_end_of_text: diag(1126, 1 /* Error */, "Unexpected_end_of_text_1126", "Unexpected end of text."),
	        Invalid_character: diag(1127, 1 /* Error */, "Invalid_character_1127", "Invalid character."),
	        Declaration_or_statement_expected: diag(1128, 1 /* Error */, "Declaration_or_statement_expected_1128", "Declaration or statement expected."),
	        Statement_expected: diag(1129, 1 /* Error */, "Statement_expected_1129", "Statement expected."),
	        case_or_default_expected: diag(1130, 1 /* Error */, "case_or_default_expected_1130", "'case' or 'default' expected."),
	        Property_or_signature_expected: diag(1131, 1 /* Error */, "Property_or_signature_expected_1131", "Property or signature expected."),
	        Enum_member_expected: diag(1132, 1 /* Error */, "Enum_member_expected_1132", "Enum member expected."),
	        Variable_declaration_expected: diag(1134, 1 /* Error */, "Variable_declaration_expected_1134", "Variable declaration expected."),
	        Argument_expression_expected: diag(1135, 1 /* Error */, "Argument_expression_expected_1135", "Argument expression expected."),
	        Property_assignment_expected: diag(1136, 1 /* Error */, "Property_assignment_expected_1136", "Property assignment expected."),
	        Expression_or_comma_expected: diag(1137, 1 /* Error */, "Expression_or_comma_expected_1137", "Expression or comma expected."),
	        Parameter_declaration_expected: diag(1138, 1 /* Error */, "Parameter_declaration_expected_1138", "Parameter declaration expected."),
	        Type_parameter_declaration_expected: diag(1139, 1 /* Error */, "Type_parameter_declaration_expected_1139", "Type parameter declaration expected."),
	        Type_argument_expected: diag(1140, 1 /* Error */, "Type_argument_expected_1140", "Type argument expected."),
	        String_literal_expected: diag(1141, 1 /* Error */, "String_literal_expected_1141", "String literal expected."),
	        Line_break_not_permitted_here: diag(1142, 1 /* Error */, "Line_break_not_permitted_here_1142", "Line break not permitted here."),
	        or_expected: diag(1144, 1 /* Error */, "or_expected_1144", "'{' or ';' expected."),
	        or_JSX_element_expected: diag(1145, 1 /* Error */, "or_JSX_element_expected_1145", "'{' or JSX element expected."),
	        Declaration_expected: diag(1146, 1 /* Error */, "Declaration_expected_1146", "Declaration expected."),
	        Import_declarations_in_a_namespace_cannot_reference_a_module: diag(1147, 1 /* Error */, "Import_declarations_in_a_namespace_cannot_reference_a_module_1147", "Import declarations in a namespace cannot reference a module."),
	        Cannot_use_imports_exports_or_module_augmentations_when_module_is_none: diag(1148, 1 /* Error */, "Cannot_use_imports_exports_or_module_augmentations_when_module_is_none_1148", "Cannot use imports, exports, or module augmentations when '--module' is 'none'."),
	        File_name_0_differs_from_already_included_file_name_1_only_in_casing: diag(1149, 1 /* Error */, "File_name_0_differs_from_already_included_file_name_1_only_in_casing_1149", "File name '{0}' differs from already included file name '{1}' only in casing."),
	        _0_declarations_must_be_initialized: diag(1155, 1 /* Error */, "_0_declarations_must_be_initialized_1155", "'{0}' declarations must be initialized."),
	        _0_declarations_can_only_be_declared_inside_a_block: diag(1156, 1 /* Error */, "_0_declarations_can_only_be_declared_inside_a_block_1156", "'{0}' declarations can only be declared inside a block."),
	        Unterminated_template_literal: diag(1160, 1 /* Error */, "Unterminated_template_literal_1160", "Unterminated template literal."),
	        Unterminated_regular_expression_literal: diag(1161, 1 /* Error */, "Unterminated_regular_expression_literal_1161", "Unterminated regular expression literal."),
	        An_object_member_cannot_be_declared_optional: diag(1162, 1 /* Error */, "An_object_member_cannot_be_declared_optional_1162", "An object member cannot be declared optional."),
	        A_yield_expression_is_only_allowed_in_a_generator_body: diag(1163, 1 /* Error */, "A_yield_expression_is_only_allowed_in_a_generator_body_1163", "A 'yield' expression is only allowed in a generator body."),
	        Computed_property_names_are_not_allowed_in_enums: diag(1164, 1 /* Error */, "Computed_property_names_are_not_allowed_in_enums_1164", "Computed property names are not allowed in enums."),
	        A_computed_property_name_in_an_ambient_context_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type: diag(1165, 1 /* Error */, "A_computed_property_name_in_an_ambient_context_must_refer_to_an_expression_whose_type_is_a_literal_t_1165", "A computed property name in an ambient context must refer to an expression whose type is a literal type or a 'unique symbol' type."),
	        A_computed_property_name_in_a_class_property_declaration_must_have_a_simple_literal_type_or_a_unique_symbol_type: diag(1166, 1 /* Error */, "A_computed_property_name_in_a_class_property_declaration_must_have_a_simple_literal_type_or_a_unique_1166", "A computed property name in a class property declaration must have a simple literal type or a 'unique symbol' type."),
	        A_computed_property_name_in_a_method_overload_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type: diag(1168, 1 /* Error */, "A_computed_property_name_in_a_method_overload_must_refer_to_an_expression_whose_type_is_a_literal_ty_1168", "A computed property name in a method overload must refer to an expression whose type is a literal type or a 'unique symbol' type."),
	        A_computed_property_name_in_an_interface_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type: diag(1169, 1 /* Error */, "A_computed_property_name_in_an_interface_must_refer_to_an_expression_whose_type_is_a_literal_type_or_1169", "A computed property name in an interface must refer to an expression whose type is a literal type or a 'unique symbol' type."),
	        A_computed_property_name_in_a_type_literal_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type: diag(1170, 1 /* Error */, "A_computed_property_name_in_a_type_literal_must_refer_to_an_expression_whose_type_is_a_literal_type__1170", "A computed property name in a type literal must refer to an expression whose type is a literal type or a 'unique symbol' type."),
	        A_comma_expression_is_not_allowed_in_a_computed_property_name: diag(1171, 1 /* Error */, "A_comma_expression_is_not_allowed_in_a_computed_property_name_1171", "A comma expression is not allowed in a computed property name."),
	        extends_clause_already_seen: diag(1172, 1 /* Error */, "extends_clause_already_seen_1172", "'extends' clause already seen."),
	        extends_clause_must_precede_implements_clause: diag(1173, 1 /* Error */, "extends_clause_must_precede_implements_clause_1173", "'extends' clause must precede 'implements' clause."),
	        Classes_can_only_extend_a_single_class: diag(1174, 1 /* Error */, "Classes_can_only_extend_a_single_class_1174", "Classes can only extend a single class."),
	        implements_clause_already_seen: diag(1175, 1 /* Error */, "implements_clause_already_seen_1175", "'implements' clause already seen."),
	        Interface_declaration_cannot_have_implements_clause: diag(1176, 1 /* Error */, "Interface_declaration_cannot_have_implements_clause_1176", "Interface declaration cannot have 'implements' clause."),
	        Binary_digit_expected: diag(1177, 1 /* Error */, "Binary_digit_expected_1177", "Binary digit expected."),
	        Octal_digit_expected: diag(1178, 1 /* Error */, "Octal_digit_expected_1178", "Octal digit expected."),
	        Unexpected_token_expected: diag(1179, 1 /* Error */, "Unexpected_token_expected_1179", "Unexpected token. '{' expected."),
	        Property_destructuring_pattern_expected: diag(1180, 1 /* Error */, "Property_destructuring_pattern_expected_1180", "Property destructuring pattern expected."),
	        Array_element_destructuring_pattern_expected: diag(1181, 1 /* Error */, "Array_element_destructuring_pattern_expected_1181", "Array element destructuring pattern expected."),
	        A_destructuring_declaration_must_have_an_initializer: diag(1182, 1 /* Error */, "A_destructuring_declaration_must_have_an_initializer_1182", "A destructuring declaration must have an initializer."),
	        An_implementation_cannot_be_declared_in_ambient_contexts: diag(1183, 1 /* Error */, "An_implementation_cannot_be_declared_in_ambient_contexts_1183", "An implementation cannot be declared in ambient contexts."),
	        Modifiers_cannot_appear_here: diag(1184, 1 /* Error */, "Modifiers_cannot_appear_here_1184", "Modifiers cannot appear here."),
	        Merge_conflict_marker_encountered: diag(1185, 1 /* Error */, "Merge_conflict_marker_encountered_1185", "Merge conflict marker encountered."),
	        A_rest_element_cannot_have_an_initializer: diag(1186, 1 /* Error */, "A_rest_element_cannot_have_an_initializer_1186", "A rest element cannot have an initializer."),
	        A_parameter_property_may_not_be_declared_using_a_binding_pattern: diag(1187, 1 /* Error */, "A_parameter_property_may_not_be_declared_using_a_binding_pattern_1187", "A parameter property may not be declared using a binding pattern."),
	        Only_a_single_variable_declaration_is_allowed_in_a_for_of_statement: diag(1188, 1 /* Error */, "Only_a_single_variable_declaration_is_allowed_in_a_for_of_statement_1188", "Only a single variable declaration is allowed in a 'for...of' statement."),
	        The_variable_declaration_of_a_for_in_statement_cannot_have_an_initializer: diag(1189, 1 /* Error */, "The_variable_declaration_of_a_for_in_statement_cannot_have_an_initializer_1189", "The variable declaration of a 'for...in' statement cannot have an initializer."),
	        The_variable_declaration_of_a_for_of_statement_cannot_have_an_initializer: diag(1190, 1 /* Error */, "The_variable_declaration_of_a_for_of_statement_cannot_have_an_initializer_1190", "The variable declaration of a 'for...of' statement cannot have an initializer."),
	        An_import_declaration_cannot_have_modifiers: diag(1191, 1 /* Error */, "An_import_declaration_cannot_have_modifiers_1191", "An import declaration cannot have modifiers."),
	        Module_0_has_no_default_export: diag(1192, 1 /* Error */, "Module_0_has_no_default_export_1192", "Module '{0}' has no default export."),
	        An_export_declaration_cannot_have_modifiers: diag(1193, 1 /* Error */, "An_export_declaration_cannot_have_modifiers_1193", "An export declaration cannot have modifiers."),
	        Export_declarations_are_not_permitted_in_a_namespace: diag(1194, 1 /* Error */, "Export_declarations_are_not_permitted_in_a_namespace_1194", "Export declarations are not permitted in a namespace."),
	        export_Asterisk_does_not_re_export_a_default: diag(1195, 1 /* Error */, "export_Asterisk_does_not_re_export_a_default_1195", "'export *' does not re-export a default."),
	        Catch_clause_variable_type_annotation_must_be_any_or_unknown_if_specified: diag(1196, 1 /* Error */, "Catch_clause_variable_type_annotation_must_be_any_or_unknown_if_specified_1196", "Catch clause variable type annotation must be 'any' or 'unknown' if specified."),
	        Catch_clause_variable_cannot_have_an_initializer: diag(1197, 1 /* Error */, "Catch_clause_variable_cannot_have_an_initializer_1197", "Catch clause variable cannot have an initializer."),
	        An_extended_Unicode_escape_value_must_be_between_0x0_and_0x10FFFF_inclusive: diag(1198, 1 /* Error */, "An_extended_Unicode_escape_value_must_be_between_0x0_and_0x10FFFF_inclusive_1198", "An extended Unicode escape value must be between 0x0 and 0x10FFFF inclusive."),
	        Unterminated_Unicode_escape_sequence: diag(1199, 1 /* Error */, "Unterminated_Unicode_escape_sequence_1199", "Unterminated Unicode escape sequence."),
	        Line_terminator_not_permitted_before_arrow: diag(1200, 1 /* Error */, "Line_terminator_not_permitted_before_arrow_1200", "Line terminator not permitted before arrow."),
	        Import_assignment_cannot_be_used_when_targeting_ECMAScript_modules_Consider_using_import_Asterisk_as_ns_from_mod_import_a_from_mod_import_d_from_mod_or_another_module_format_instead: diag(1202, 1 /* Error */, "Import_assignment_cannot_be_used_when_targeting_ECMAScript_modules_Consider_using_import_Asterisk_as_1202", `Import assignment cannot be used when targeting ECMAScript modules. Consider using 'import * as ns from "mod"', 'import {a} from "mod"', 'import d from "mod"', or another module format instead.`),
	        Export_assignment_cannot_be_used_when_targeting_ECMAScript_modules_Consider_using_export_default_or_another_module_format_instead: diag(1203, 1 /* Error */, "Export_assignment_cannot_be_used_when_targeting_ECMAScript_modules_Consider_using_export_default_or__1203", "Export assignment cannot be used when targeting ECMAScript modules. Consider using 'export default' or another module format instead."),
	        Re_exporting_a_type_when_0_is_enabled_requires_using_export_type: diag(1205, 1 /* Error */, "Re_exporting_a_type_when_0_is_enabled_requires_using_export_type_1205", "Re-exporting a type when '{0}' is enabled requires using 'export type'."),
	        Decorators_are_not_valid_here: diag(1206, 1 /* Error */, "Decorators_are_not_valid_here_1206", "Decorators are not valid here."),
	        Decorators_cannot_be_applied_to_multiple_get_Slashset_accessors_of_the_same_name: diag(1207, 1 /* Error */, "Decorators_cannot_be_applied_to_multiple_get_Slashset_accessors_of_the_same_name_1207", "Decorators cannot be applied to multiple get/set accessors of the same name."),
	        Invalid_optional_chain_from_new_expression_Did_you_mean_to_call_0: diag(1209, 1 /* Error */, "Invalid_optional_chain_from_new_expression_Did_you_mean_to_call_0_1209", "Invalid optional chain from new expression. Did you mean to call '{0}()'?"),
	        Code_contained_in_a_class_is_evaluated_in_JavaScript_s_strict_mode_which_does_not_allow_this_use_of_0_For_more_information_see_https_Colon_Slash_Slashdeveloper_mozilla_org_Slashen_US_Slashdocs_SlashWeb_SlashJavaScript_SlashReference_SlashStrict_mode: diag(1210, 1 /* Error */, "Code_contained_in_a_class_is_evaluated_in_JavaScript_s_strict_mode_which_does_not_allow_this_use_of__1210", "Code contained in a class is evaluated in JavaScript's strict mode which does not allow this use of '{0}'. For more information, see https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Strict_mode."),
	        A_class_declaration_without_the_default_modifier_must_have_a_name: diag(1211, 1 /* Error */, "A_class_declaration_without_the_default_modifier_must_have_a_name_1211", "A class declaration without the 'default' modifier must have a name."),
	        Identifier_expected_0_is_a_reserved_word_in_strict_mode: diag(1212, 1 /* Error */, "Identifier_expected_0_is_a_reserved_word_in_strict_mode_1212", "Identifier expected. '{0}' is a reserved word in strict mode."),
	        Identifier_expected_0_is_a_reserved_word_in_strict_mode_Class_definitions_are_automatically_in_strict_mode: diag(1213, 1 /* Error */, "Identifier_expected_0_is_a_reserved_word_in_strict_mode_Class_definitions_are_automatically_in_stric_1213", "Identifier expected. '{0}' is a reserved word in strict mode. Class definitions are automatically in strict mode."),
	        Identifier_expected_0_is_a_reserved_word_in_strict_mode_Modules_are_automatically_in_strict_mode: diag(1214, 1 /* Error */, "Identifier_expected_0_is_a_reserved_word_in_strict_mode_Modules_are_automatically_in_strict_mode_1214", "Identifier expected. '{0}' is a reserved word in strict mode. Modules are automatically in strict mode."),
	        Invalid_use_of_0_Modules_are_automatically_in_strict_mode: diag(1215, 1 /* Error */, "Invalid_use_of_0_Modules_are_automatically_in_strict_mode_1215", "Invalid use of '{0}'. Modules are automatically in strict mode."),
	        Identifier_expected_esModule_is_reserved_as_an_exported_marker_when_transforming_ECMAScript_modules: diag(1216, 1 /* Error */, "Identifier_expected_esModule_is_reserved_as_an_exported_marker_when_transforming_ECMAScript_modules_1216", "Identifier expected. '__esModule' is reserved as an exported marker when transforming ECMAScript modules."),
	        Export_assignment_is_not_supported_when_module_flag_is_system: diag(1218, 1 /* Error */, "Export_assignment_is_not_supported_when_module_flag_is_system_1218", "Export assignment is not supported when '--module' flag is 'system'."),
	        Generators_are_not_allowed_in_an_ambient_context: diag(1221, 1 /* Error */, "Generators_are_not_allowed_in_an_ambient_context_1221", "Generators are not allowed in an ambient context."),
	        An_overload_signature_cannot_be_declared_as_a_generator: diag(1222, 1 /* Error */, "An_overload_signature_cannot_be_declared_as_a_generator_1222", "An overload signature cannot be declared as a generator."),
	        _0_tag_already_specified: diag(1223, 1 /* Error */, "_0_tag_already_specified_1223", "'{0}' tag already specified."),
	        Signature_0_must_be_a_type_predicate: diag(1224, 1 /* Error */, "Signature_0_must_be_a_type_predicate_1224", "Signature '{0}' must be a type predicate."),
	        Cannot_find_parameter_0: diag(1225, 1 /* Error */, "Cannot_find_parameter_0_1225", "Cannot find parameter '{0}'."),
	        Type_predicate_0_is_not_assignable_to_1: diag(1226, 1 /* Error */, "Type_predicate_0_is_not_assignable_to_1_1226", "Type predicate '{0}' is not assignable to '{1}'."),
	        Parameter_0_is_not_in_the_same_position_as_parameter_1: diag(1227, 1 /* Error */, "Parameter_0_is_not_in_the_same_position_as_parameter_1_1227", "Parameter '{0}' is not in the same position as parameter '{1}'."),
	        A_type_predicate_is_only_allowed_in_return_type_position_for_functions_and_methods: diag(1228, 1 /* Error */, "A_type_predicate_is_only_allowed_in_return_type_position_for_functions_and_methods_1228", "A type predicate is only allowed in return type position for functions and methods."),
	        A_type_predicate_cannot_reference_a_rest_parameter: diag(1229, 1 /* Error */, "A_type_predicate_cannot_reference_a_rest_parameter_1229", "A type predicate cannot reference a rest parameter."),
	        A_type_predicate_cannot_reference_element_0_in_a_binding_pattern: diag(1230, 1 /* Error */, "A_type_predicate_cannot_reference_element_0_in_a_binding_pattern_1230", "A type predicate cannot reference element '{0}' in a binding pattern."),
	        An_export_assignment_must_be_at_the_top_level_of_a_file_or_module_declaration: diag(1231, 1 /* Error */, "An_export_assignment_must_be_at_the_top_level_of_a_file_or_module_declaration_1231", "An export assignment must be at the top level of a file or module declaration."),
	        An_import_declaration_can_only_be_used_at_the_top_level_of_a_namespace_or_module: diag(1232, 1 /* Error */, "An_import_declaration_can_only_be_used_at_the_top_level_of_a_namespace_or_module_1232", "An import declaration can only be used at the top level of a namespace or module."),
	        An_export_declaration_can_only_be_used_at_the_top_level_of_a_namespace_or_module: diag(1233, 1 /* Error */, "An_export_declaration_can_only_be_used_at_the_top_level_of_a_namespace_or_module_1233", "An export declaration can only be used at the top level of a namespace or module."),
	        An_ambient_module_declaration_is_only_allowed_at_the_top_level_in_a_file: diag(1234, 1 /* Error */, "An_ambient_module_declaration_is_only_allowed_at_the_top_level_in_a_file_1234", "An ambient module declaration is only allowed at the top level in a file."),
	        A_namespace_declaration_is_only_allowed_at_the_top_level_of_a_namespace_or_module: diag(1235, 1 /* Error */, "A_namespace_declaration_is_only_allowed_at_the_top_level_of_a_namespace_or_module_1235", "A namespace declaration is only allowed at the top level of a namespace or module."),
	        The_return_type_of_a_property_decorator_function_must_be_either_void_or_any: diag(1236, 1 /* Error */, "The_return_type_of_a_property_decorator_function_must_be_either_void_or_any_1236", "The return type of a property decorator function must be either 'void' or 'any'."),
	        The_return_type_of_a_parameter_decorator_function_must_be_either_void_or_any: diag(1237, 1 /* Error */, "The_return_type_of_a_parameter_decorator_function_must_be_either_void_or_any_1237", "The return type of a parameter decorator function must be either 'void' or 'any'."),
	        Unable_to_resolve_signature_of_class_decorator_when_called_as_an_expression: diag(1238, 1 /* Error */, "Unable_to_resolve_signature_of_class_decorator_when_called_as_an_expression_1238", "Unable to resolve signature of class decorator when called as an expression."),
	        Unable_to_resolve_signature_of_parameter_decorator_when_called_as_an_expression: diag(1239, 1 /* Error */, "Unable_to_resolve_signature_of_parameter_decorator_when_called_as_an_expression_1239", "Unable to resolve signature of parameter decorator when called as an expression."),
	        Unable_to_resolve_signature_of_property_decorator_when_called_as_an_expression: diag(1240, 1 /* Error */, "Unable_to_resolve_signature_of_property_decorator_when_called_as_an_expression_1240", "Unable to resolve signature of property decorator when called as an expression."),
	        Unable_to_resolve_signature_of_method_decorator_when_called_as_an_expression: diag(1241, 1 /* Error */, "Unable_to_resolve_signature_of_method_decorator_when_called_as_an_expression_1241", "Unable to resolve signature of method decorator when called as an expression."),
	        abstract_modifier_can_only_appear_on_a_class_method_or_property_declaration: diag(1242, 1 /* Error */, "abstract_modifier_can_only_appear_on_a_class_method_or_property_declaration_1242", "'abstract' modifier can only appear on a class, method, or property declaration."),
	        _0_modifier_cannot_be_used_with_1_modifier: diag(1243, 1 /* Error */, "_0_modifier_cannot_be_used_with_1_modifier_1243", "'{0}' modifier cannot be used with '{1}' modifier."),
	        Abstract_methods_can_only_appear_within_an_abstract_class: diag(1244, 1 /* Error */, "Abstract_methods_can_only_appear_within_an_abstract_class_1244", "Abstract methods can only appear within an abstract class."),
	        Method_0_cannot_have_an_implementation_because_it_is_marked_abstract: diag(1245, 1 /* Error */, "Method_0_cannot_have_an_implementation_because_it_is_marked_abstract_1245", "Method '{0}' cannot have an implementation because it is marked abstract."),
	        An_interface_property_cannot_have_an_initializer: diag(1246, 1 /* Error */, "An_interface_property_cannot_have_an_initializer_1246", "An interface property cannot have an initializer."),
	        A_type_literal_property_cannot_have_an_initializer: diag(1247, 1 /* Error */, "A_type_literal_property_cannot_have_an_initializer_1247", "A type literal property cannot have an initializer."),
	        A_class_member_cannot_have_the_0_keyword: diag(1248, 1 /* Error */, "A_class_member_cannot_have_the_0_keyword_1248", "A class member cannot have the '{0}' keyword."),
	        A_decorator_can_only_decorate_a_method_implementation_not_an_overload: diag(1249, 1 /* Error */, "A_decorator_can_only_decorate_a_method_implementation_not_an_overload_1249", "A decorator can only decorate a method implementation, not an overload."),
	        Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5: diag(1250, 1 /* Error */, "Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5_1250", "Function declarations are not allowed inside blocks in strict mode when targeting 'ES3' or 'ES5'."),
	        Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5_Class_definitions_are_automatically_in_strict_mode: diag(1251, 1 /* Error */, "Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5_Class_d_1251", "Function declarations are not allowed inside blocks in strict mode when targeting 'ES3' or 'ES5'. Class definitions are automatically in strict mode."),
	        Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5_Modules_are_automatically_in_strict_mode: diag(1252, 1 /* Error */, "Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5_Modules_1252", "Function declarations are not allowed inside blocks in strict mode when targeting 'ES3' or 'ES5'. Modules are automatically in strict mode."),
	        Abstract_properties_can_only_appear_within_an_abstract_class: diag(1253, 1 /* Error */, "Abstract_properties_can_only_appear_within_an_abstract_class_1253", "Abstract properties can only appear within an abstract class."),
	        A_const_initializer_in_an_ambient_context_must_be_a_string_or_numeric_literal_or_literal_enum_reference: diag(1254, 1 /* Error */, "A_const_initializer_in_an_ambient_context_must_be_a_string_or_numeric_literal_or_literal_enum_refere_1254", "A 'const' initializer in an ambient context must be a string or numeric literal or literal enum reference."),
	        A_definite_assignment_assertion_is_not_permitted_in_this_context: diag(1255, 1 /* Error */, "A_definite_assignment_assertion_is_not_permitted_in_this_context_1255", "A definite assignment assertion '!' is not permitted in this context."),
	        A_required_element_cannot_follow_an_optional_element: diag(1257, 1 /* Error */, "A_required_element_cannot_follow_an_optional_element_1257", "A required element cannot follow an optional element."),
	        A_default_export_must_be_at_the_top_level_of_a_file_or_module_declaration: diag(1258, 1 /* Error */, "A_default_export_must_be_at_the_top_level_of_a_file_or_module_declaration_1258", "A default export must be at the top level of a file or module declaration."),
	        Module_0_can_only_be_default_imported_using_the_1_flag: diag(1259, 1 /* Error */, "Module_0_can_only_be_default_imported_using_the_1_flag_1259", "Module '{0}' can only be default-imported using the '{1}' flag"),
	        Keywords_cannot_contain_escape_characters: diag(1260, 1 /* Error */, "Keywords_cannot_contain_escape_characters_1260", "Keywords cannot contain escape characters."),
	        Already_included_file_name_0_differs_from_file_name_1_only_in_casing: diag(1261, 1 /* Error */, "Already_included_file_name_0_differs_from_file_name_1_only_in_casing_1261", "Already included file name '{0}' differs from file name '{1}' only in casing."),
	        Identifier_expected_0_is_a_reserved_word_at_the_top_level_of_a_module: diag(1262, 1 /* Error */, "Identifier_expected_0_is_a_reserved_word_at_the_top_level_of_a_module_1262", "Identifier expected. '{0}' is a reserved word at the top-level of a module."),
	        Declarations_with_initializers_cannot_also_have_definite_assignment_assertions: diag(1263, 1 /* Error */, "Declarations_with_initializers_cannot_also_have_definite_assignment_assertions_1263", "Declarations with initializers cannot also have definite assignment assertions."),
	        Declarations_with_definite_assignment_assertions_must_also_have_type_annotations: diag(1264, 1 /* Error */, "Declarations_with_definite_assignment_assertions_must_also_have_type_annotations_1264", "Declarations with definite assignment assertions must also have type annotations."),
	        A_rest_element_cannot_follow_another_rest_element: diag(1265, 1 /* Error */, "A_rest_element_cannot_follow_another_rest_element_1265", "A rest element cannot follow another rest element."),
	        An_optional_element_cannot_follow_a_rest_element: diag(1266, 1 /* Error */, "An_optional_element_cannot_follow_a_rest_element_1266", "An optional element cannot follow a rest element."),
	        Property_0_cannot_have_an_initializer_because_it_is_marked_abstract: diag(1267, 1 /* Error */, "Property_0_cannot_have_an_initializer_because_it_is_marked_abstract_1267", "Property '{0}' cannot have an initializer because it is marked abstract."),
	        An_index_signature_parameter_type_must_be_string_number_symbol_or_a_template_literal_type: diag(1268, 1 /* Error */, "An_index_signature_parameter_type_must_be_string_number_symbol_or_a_template_literal_type_1268", "An index signature parameter type must be 'string', 'number', 'symbol', or a template literal type."),
	        Cannot_use_export_import_on_a_type_or_type_only_namespace_when_0_is_enabled: diag(1269, 1 /* Error */, "Cannot_use_export_import_on_a_type_or_type_only_namespace_when_0_is_enabled_1269", "Cannot use 'export import' on a type or type-only namespace when '{0}' is enabled."),
	        Decorator_function_return_type_0_is_not_assignable_to_type_1: diag(1270, 1 /* Error */, "Decorator_function_return_type_0_is_not_assignable_to_type_1_1270", "Decorator function return type '{0}' is not assignable to type '{1}'."),
	        Decorator_function_return_type_is_0_but_is_expected_to_be_void_or_any: diag(1271, 1 /* Error */, "Decorator_function_return_type_is_0_but_is_expected_to_be_void_or_any_1271", "Decorator function return type is '{0}' but is expected to be 'void' or 'any'."),
	        A_type_referenced_in_a_decorated_signature_must_be_imported_with_import_type_or_a_namespace_import_when_isolatedModules_and_emitDecoratorMetadata_are_enabled: diag(1272, 1 /* Error */, "A_type_referenced_in_a_decorated_signature_must_be_imported_with_import_type_or_a_namespace_import_w_1272", "A type referenced in a decorated signature must be imported with 'import type' or a namespace import when 'isolatedModules' and 'emitDecoratorMetadata' are enabled."),
	        _0_modifier_cannot_appear_on_a_type_parameter: diag(1273, 1 /* Error */, "_0_modifier_cannot_appear_on_a_type_parameter_1273", "'{0}' modifier cannot appear on a type parameter"),
	        _0_modifier_can_only_appear_on_a_type_parameter_of_a_class_interface_or_type_alias: diag(1274, 1 /* Error */, "_0_modifier_can_only_appear_on_a_type_parameter_of_a_class_interface_or_type_alias_1274", "'{0}' modifier can only appear on a type parameter of a class, interface or type alias"),
	        accessor_modifier_can_only_appear_on_a_property_declaration: diag(1275, 1 /* Error */, "accessor_modifier_can_only_appear_on_a_property_declaration_1275", "'accessor' modifier can only appear on a property declaration."),
	        An_accessor_property_cannot_be_declared_optional: diag(1276, 1 /* Error */, "An_accessor_property_cannot_be_declared_optional_1276", "An 'accessor' property cannot be declared optional."),
	        _0_modifier_can_only_appear_on_a_type_parameter_of_a_function_method_or_class: diag(1277, 1 /* Error */, "_0_modifier_can_only_appear_on_a_type_parameter_of_a_function_method_or_class_1277", "'{0}' modifier can only appear on a type parameter of a function, method or class"),
	        The_runtime_will_invoke_the_decorator_with_1_arguments_but_the_decorator_expects_0: diag(1278, 1 /* Error */, "The_runtime_will_invoke_the_decorator_with_1_arguments_but_the_decorator_expects_0_1278", "The runtime will invoke the decorator with {1} arguments, but the decorator expects {0}."),
	        The_runtime_will_invoke_the_decorator_with_1_arguments_but_the_decorator_expects_at_least_0: diag(1279, 1 /* Error */, "The_runtime_will_invoke_the_decorator_with_1_arguments_but_the_decorator_expects_at_least_0_1279", "The runtime will invoke the decorator with {1} arguments, but the decorator expects at least {0}."),
	        Namespaces_are_not_allowed_in_global_script_files_when_0_is_enabled_If_this_file_is_not_intended_to_be_a_global_script_set_moduleDetection_to_force_or_add_an_empty_export_statement: diag(1280, 1 /* Error */, "Namespaces_are_not_allowed_in_global_script_files_when_0_is_enabled_If_this_file_is_not_intended_to__1280", "Namespaces are not allowed in global script files when '{0}' is enabled. If this file is not intended to be a global script, set 'moduleDetection' to 'force' or add an empty 'export {}' statement."),
	        Cannot_access_0_from_another_file_without_qualification_when_1_is_enabled_Use_2_instead: diag(1281, 1 /* Error */, "Cannot_access_0_from_another_file_without_qualification_when_1_is_enabled_Use_2_instead_1281", "Cannot access '{0}' from another file without qualification when '{1}' is enabled. Use '{2}' instead."),
	        An_export_declaration_must_reference_a_value_when_verbatimModuleSyntax_is_enabled_but_0_only_refers_to_a_type: diag(1282, 1 /* Error */, "An_export_declaration_must_reference_a_value_when_verbatimModuleSyntax_is_enabled_but_0_only_refers__1282", "An 'export =' declaration must reference a value when 'verbatimModuleSyntax' is enabled, but '{0}' only refers to a type."),
	        An_export_declaration_must_reference_a_real_value_when_verbatimModuleSyntax_is_enabled_but_0_resolves_to_a_type_only_declaration: diag(1283, 1 /* Error */, "An_export_declaration_must_reference_a_real_value_when_verbatimModuleSyntax_is_enabled_but_0_resolve_1283", "An 'export =' declaration must reference a real value when 'verbatimModuleSyntax' is enabled, but '{0}' resolves to a type-only declaration."),
	        An_export_default_must_reference_a_value_when_verbatimModuleSyntax_is_enabled_but_0_only_refers_to_a_type: diag(1284, 1 /* Error */, "An_export_default_must_reference_a_value_when_verbatimModuleSyntax_is_enabled_but_0_only_refers_to_a_1284", "An 'export default' must reference a value when 'verbatimModuleSyntax' is enabled, but '{0}' only refers to a type."),
	        An_export_default_must_reference_a_real_value_when_verbatimModuleSyntax_is_enabled_but_0_resolves_to_a_type_only_declaration: diag(1285, 1 /* Error */, "An_export_default_must_reference_a_real_value_when_verbatimModuleSyntax_is_enabled_but_0_resolves_to_1285", "An 'export default' must reference a real value when 'verbatimModuleSyntax' is enabled, but '{0}' resolves to a type-only declaration."),
	        ESM_syntax_is_not_allowed_in_a_CommonJS_module_when_verbatimModuleSyntax_is_enabled: diag(1286, 1 /* Error */, "ESM_syntax_is_not_allowed_in_a_CommonJS_module_when_verbatimModuleSyntax_is_enabled_1286", "ESM syntax is not allowed in a CommonJS module when 'verbatimModuleSyntax' is enabled."),
	        A_top_level_export_modifier_cannot_be_used_on_value_declarations_in_a_CommonJS_module_when_verbatimModuleSyntax_is_enabled: diag(1287, 1 /* Error */, "A_top_level_export_modifier_cannot_be_used_on_value_declarations_in_a_CommonJS_module_when_verbatimM_1287", "A top-level 'export' modifier cannot be used on value declarations in a CommonJS module when 'verbatimModuleSyntax' is enabled."),
	        An_import_alias_cannot_resolve_to_a_type_or_type_only_declaration_when_verbatimModuleSyntax_is_enabled: diag(1288, 1 /* Error */, "An_import_alias_cannot_resolve_to_a_type_or_type_only_declaration_when_verbatimModuleSyntax_is_enabl_1288", "An import alias cannot resolve to a type or type-only declaration when 'verbatimModuleSyntax' is enabled."),
	        _0_resolves_to_a_type_only_declaration_and_must_be_marked_type_only_in_this_file_before_re_exporting_when_1_is_enabled_Consider_using_import_type_where_0_is_imported: diag(1289, 1 /* Error */, "_0_resolves_to_a_type_only_declaration_and_must_be_marked_type_only_in_this_file_before_re_exporting_1289", "'{0}' resolves to a type-only declaration and must be marked type-only in this file before re-exporting when '{1}' is enabled. Consider using 'import type' where '{0}' is imported."),
	        _0_resolves_to_a_type_only_declaration_and_must_be_marked_type_only_in_this_file_before_re_exporting_when_1_is_enabled_Consider_using_export_type_0_as_default: diag(1290, 1 /* Error */, "_0_resolves_to_a_type_only_declaration_and_must_be_marked_type_only_in_this_file_before_re_exporting_1290", "'{0}' resolves to a type-only declaration and must be marked type-only in this file before re-exporting when '{1}' is enabled. Consider using 'export type { {0} as default }'."),
	        _0_resolves_to_a_type_and_must_be_marked_type_only_in_this_file_before_re_exporting_when_1_is_enabled_Consider_using_import_type_where_0_is_imported: diag(1291, 1 /* Error */, "_0_resolves_to_a_type_and_must_be_marked_type_only_in_this_file_before_re_exporting_when_1_is_enable_1291", "'{0}' resolves to a type and must be marked type-only in this file before re-exporting when '{1}' is enabled. Consider using 'import type' where '{0}' is imported."),
	        _0_resolves_to_a_type_and_must_be_marked_type_only_in_this_file_before_re_exporting_when_1_is_enabled_Consider_using_export_type_0_as_default: diag(1292, 1 /* Error */, "_0_resolves_to_a_type_and_must_be_marked_type_only_in_this_file_before_re_exporting_when_1_is_enable_1292", "'{0}' resolves to a type and must be marked type-only in this file before re-exporting when '{1}' is enabled. Consider using 'export type { {0} as default }'."),
	        with_statements_are_not_allowed_in_an_async_function_block: diag(1300, 1 /* Error */, "with_statements_are_not_allowed_in_an_async_function_block_1300", "'with' statements are not allowed in an async function block."),
	        await_expressions_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules: diag(1308, 1 /* Error */, "await_expressions_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules_1308", "'await' expressions are only allowed within async functions and at the top levels of modules."),
	        The_current_file_is_a_CommonJS_module_and_cannot_use_await_at_the_top_level: diag(1309, 1 /* Error */, "The_current_file_is_a_CommonJS_module_and_cannot_use_await_at_the_top_level_1309", "The current file is a CommonJS module and cannot use 'await' at the top level."),
	        Did_you_mean_to_use_a_Colon_An_can_only_follow_a_property_name_when_the_containing_object_literal_is_part_of_a_destructuring_pattern: diag(1312, 1 /* Error */, "Did_you_mean_to_use_a_Colon_An_can_only_follow_a_property_name_when_the_containing_object_literal_is_1312", "Did you mean to use a ':'? An '=' can only follow a property name when the containing object literal is part of a destructuring pattern."),
	        The_body_of_an_if_statement_cannot_be_the_empty_statement: diag(1313, 1 /* Error */, "The_body_of_an_if_statement_cannot_be_the_empty_statement_1313", "The body of an 'if' statement cannot be the empty statement."),
	        Global_module_exports_may_only_appear_in_module_files: diag(1314, 1 /* Error */, "Global_module_exports_may_only_appear_in_module_files_1314", "Global module exports may only appear in module files."),
	        Global_module_exports_may_only_appear_in_declaration_files: diag(1315, 1 /* Error */, "Global_module_exports_may_only_appear_in_declaration_files_1315", "Global module exports may only appear in declaration files."),
	        Global_module_exports_may_only_appear_at_top_level: diag(1316, 1 /* Error */, "Global_module_exports_may_only_appear_at_top_level_1316", "Global module exports may only appear at top level."),
	        A_parameter_property_cannot_be_declared_using_a_rest_parameter: diag(1317, 1 /* Error */, "A_parameter_property_cannot_be_declared_using_a_rest_parameter_1317", "A parameter property cannot be declared using a rest parameter."),
	        An_abstract_accessor_cannot_have_an_implementation: diag(1318, 1 /* Error */, "An_abstract_accessor_cannot_have_an_implementation_1318", "An abstract accessor cannot have an implementation."),
	        A_default_export_can_only_be_used_in_an_ECMAScript_style_module: diag(1319, 1 /* Error */, "A_default_export_can_only_be_used_in_an_ECMAScript_style_module_1319", "A default export can only be used in an ECMAScript-style module."),
	        Type_of_await_operand_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member: diag(1320, 1 /* Error */, "Type_of_await_operand_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member_1320", "Type of 'await' operand must either be a valid promise or must not contain a callable 'then' member."),
	        Type_of_yield_operand_in_an_async_generator_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member: diag(1321, 1 /* Error */, "Type_of_yield_operand_in_an_async_generator_must_either_be_a_valid_promise_or_must_not_contain_a_cal_1321", "Type of 'yield' operand in an async generator must either be a valid promise or must not contain a callable 'then' member."),
	        Type_of_iterated_elements_of_a_yield_Asterisk_operand_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member: diag(1322, 1 /* Error */, "Type_of_iterated_elements_of_a_yield_Asterisk_operand_must_either_be_a_valid_promise_or_must_not_con_1322", "Type of iterated elements of a 'yield*' operand must either be a valid promise or must not contain a callable 'then' member."),
	        Dynamic_imports_are_only_supported_when_the_module_flag_is_set_to_es2020_es2022_esnext_commonjs_amd_system_umd_node16_or_nodenext: diag(1323, 1 /* Error */, "Dynamic_imports_are_only_supported_when_the_module_flag_is_set_to_es2020_es2022_esnext_commonjs_amd__1323", "Dynamic imports are only supported when the '--module' flag is set to 'es2020', 'es2022', 'esnext', 'commonjs', 'amd', 'system', 'umd', 'node16', or 'nodenext'."),
	        Dynamic_imports_only_support_a_second_argument_when_the_module_option_is_set_to_esnext_node16_or_nodenext: diag(1324, 1 /* Error */, "Dynamic_imports_only_support_a_second_argument_when_the_module_option_is_set_to_esnext_node16_or_nod_1324", "Dynamic imports only support a second argument when the '--module' option is set to 'esnext', 'node16', or 'nodenext'."),
	        Argument_of_dynamic_import_cannot_be_spread_element: diag(1325, 1 /* Error */, "Argument_of_dynamic_import_cannot_be_spread_element_1325", "Argument of dynamic import cannot be spread element."),
	        This_use_of_import_is_invalid_import_calls_can_be_written_but_they_must_have_parentheses_and_cannot_have_type_arguments: diag(1326, 1 /* Error */, "This_use_of_import_is_invalid_import_calls_can_be_written_but_they_must_have_parentheses_and_cannot__1326", "This use of 'import' is invalid. 'import()' calls can be written, but they must have parentheses and cannot have type arguments."),
	        String_literal_with_double_quotes_expected: diag(1327, 1 /* Error */, "String_literal_with_double_quotes_expected_1327", "String literal with double quotes expected."),
	        Property_value_can_only_be_string_literal_numeric_literal_true_false_null_object_literal_or_array_literal: diag(1328, 1 /* Error */, "Property_value_can_only_be_string_literal_numeric_literal_true_false_null_object_literal_or_array_li_1328", "Property value can only be string literal, numeric literal, 'true', 'false', 'null', object literal or array literal."),
	        _0_accepts_too_few_arguments_to_be_used_as_a_decorator_here_Did_you_mean_to_call_it_first_and_write_0: diag(1329, 1 /* Error */, "_0_accepts_too_few_arguments_to_be_used_as_a_decorator_here_Did_you_mean_to_call_it_first_and_write__1329", "'{0}' accepts too few arguments to be used as a decorator here. Did you mean to call it first and write '@{0}()'?"),
	        A_property_of_an_interface_or_type_literal_whose_type_is_a_unique_symbol_type_must_be_readonly: diag(1330, 1 /* Error */, "A_property_of_an_interface_or_type_literal_whose_type_is_a_unique_symbol_type_must_be_readonly_1330", "A property of an interface or type literal whose type is a 'unique symbol' type must be 'readonly'."),
	        A_property_of_a_class_whose_type_is_a_unique_symbol_type_must_be_both_static_and_readonly: diag(1331, 1 /* Error */, "A_property_of_a_class_whose_type_is_a_unique_symbol_type_must_be_both_static_and_readonly_1331", "A property of a class whose type is a 'unique symbol' type must be both 'static' and 'readonly'."),
	        A_variable_whose_type_is_a_unique_symbol_type_must_be_const: diag(1332, 1 /* Error */, "A_variable_whose_type_is_a_unique_symbol_type_must_be_const_1332", "A variable whose type is a 'unique symbol' type must be 'const'."),
	        unique_symbol_types_may_not_be_used_on_a_variable_declaration_with_a_binding_name: diag(1333, 1 /* Error */, "unique_symbol_types_may_not_be_used_on_a_variable_declaration_with_a_binding_name_1333", "'unique symbol' types may not be used on a variable declaration with a binding name."),
	        unique_symbol_types_are_only_allowed_on_variables_in_a_variable_statement: diag(1334, 1 /* Error */, "unique_symbol_types_are_only_allowed_on_variables_in_a_variable_statement_1334", "'unique symbol' types are only allowed on variables in a variable statement."),
	        unique_symbol_types_are_not_allowed_here: diag(1335, 1 /* Error */, "unique_symbol_types_are_not_allowed_here_1335", "'unique symbol' types are not allowed here."),
	        An_index_signature_parameter_type_cannot_be_a_literal_type_or_generic_type_Consider_using_a_mapped_object_type_instead: diag(1337, 1 /* Error */, "An_index_signature_parameter_type_cannot_be_a_literal_type_or_generic_type_Consider_using_a_mapped_o_1337", "An index signature parameter type cannot be a literal type or generic type. Consider using a mapped object type instead."),
	        infer_declarations_are_only_permitted_in_the_extends_clause_of_a_conditional_type: diag(1338, 1 /* Error */, "infer_declarations_are_only_permitted_in_the_extends_clause_of_a_conditional_type_1338", "'infer' declarations are only permitted in the 'extends' clause of a conditional type."),
	        Module_0_does_not_refer_to_a_value_but_is_used_as_a_value_here: diag(1339, 1 /* Error */, "Module_0_does_not_refer_to_a_value_but_is_used_as_a_value_here_1339", "Module '{0}' does not refer to a value, but is used as a value here."),
	        Module_0_does_not_refer_to_a_type_but_is_used_as_a_type_here_Did_you_mean_typeof_import_0: diag(1340, 1 /* Error */, "Module_0_does_not_refer_to_a_type_but_is_used_as_a_type_here_Did_you_mean_typeof_import_0_1340", "Module '{0}' does not refer to a type, but is used as a type here. Did you mean 'typeof import('{0}')'?"),
	        Class_constructor_may_not_be_an_accessor: diag(1341, 1 /* Error */, "Class_constructor_may_not_be_an_accessor_1341", "Class constructor may not be an accessor."),
	        The_import_meta_meta_property_is_only_allowed_when_the_module_option_is_es2020_es2022_esnext_system_node16_or_nodenext: diag(1343, 1 /* Error */, "The_import_meta_meta_property_is_only_allowed_when_the_module_option_is_es2020_es2022_esnext_system__1343", "The 'import.meta' meta-property is only allowed when the '--module' option is 'es2020', 'es2022', 'esnext', 'system', 'node16', or 'nodenext'."),
	        A_label_is_not_allowed_here: diag(1344, 1 /* Error */, "A_label_is_not_allowed_here_1344", "'A label is not allowed here."),
	        An_expression_of_type_void_cannot_be_tested_for_truthiness: diag(1345, 1 /* Error */, "An_expression_of_type_void_cannot_be_tested_for_truthiness_1345", "An expression of type 'void' cannot be tested for truthiness."),
	        This_parameter_is_not_allowed_with_use_strict_directive: diag(1346, 1 /* Error */, "This_parameter_is_not_allowed_with_use_strict_directive_1346", "This parameter is not allowed with 'use strict' directive."),
	        use_strict_directive_cannot_be_used_with_non_simple_parameter_list: diag(1347, 1 /* Error */, "use_strict_directive_cannot_be_used_with_non_simple_parameter_list_1347", "'use strict' directive cannot be used with non-simple parameter list."),
	        Non_simple_parameter_declared_here: diag(1348, 1 /* Error */, "Non_simple_parameter_declared_here_1348", "Non-simple parameter declared here."),
	        use_strict_directive_used_here: diag(1349, 1 /* Error */, "use_strict_directive_used_here_1349", "'use strict' directive used here."),
	        Print_the_final_configuration_instead_of_building: diag(1350, 3 /* Message */, "Print_the_final_configuration_instead_of_building_1350", "Print the final configuration instead of building."),
	        An_identifier_or_keyword_cannot_immediately_follow_a_numeric_literal: diag(1351, 1 /* Error */, "An_identifier_or_keyword_cannot_immediately_follow_a_numeric_literal_1351", "An identifier or keyword cannot immediately follow a numeric literal."),
	        A_bigint_literal_cannot_use_exponential_notation: diag(1352, 1 /* Error */, "A_bigint_literal_cannot_use_exponential_notation_1352", "A bigint literal cannot use exponential notation."),
	        A_bigint_literal_must_be_an_integer: diag(1353, 1 /* Error */, "A_bigint_literal_must_be_an_integer_1353", "A bigint literal must be an integer."),
	        readonly_type_modifier_is_only_permitted_on_array_and_tuple_literal_types: diag(1354, 1 /* Error */, "readonly_type_modifier_is_only_permitted_on_array_and_tuple_literal_types_1354", "'readonly' type modifier is only permitted on array and tuple literal types."),
	        A_const_assertions_can_only_be_applied_to_references_to_enum_members_or_string_number_boolean_array_or_object_literals: diag(1355, 1 /* Error */, "A_const_assertions_can_only_be_applied_to_references_to_enum_members_or_string_number_boolean_array__1355", "A 'const' assertions can only be applied to references to enum members, or string, number, boolean, array, or object literals."),
	        Did_you_mean_to_mark_this_function_as_async: diag(1356, 1 /* Error */, "Did_you_mean_to_mark_this_function_as_async_1356", "Did you mean to mark this function as 'async'?"),
	        An_enum_member_name_must_be_followed_by_a_or: diag(1357, 1 /* Error */, "An_enum_member_name_must_be_followed_by_a_or_1357", "An enum member name must be followed by a ',', '=', or '}'."),
	        Tagged_template_expressions_are_not_permitted_in_an_optional_chain: diag(1358, 1 /* Error */, "Tagged_template_expressions_are_not_permitted_in_an_optional_chain_1358", "Tagged template expressions are not permitted in an optional chain."),
	        Identifier_expected_0_is_a_reserved_word_that_cannot_be_used_here: diag(1359, 1 /* Error */, "Identifier_expected_0_is_a_reserved_word_that_cannot_be_used_here_1359", "Identifier expected. '{0}' is a reserved word that cannot be used here."),
	        Type_0_does_not_satisfy_the_expected_type_1: diag(1360, 1 /* Error */, "Type_0_does_not_satisfy_the_expected_type_1_1360", "Type '{0}' does not satisfy the expected type '{1}'."),
	        _0_cannot_be_used_as_a_value_because_it_was_imported_using_import_type: diag(1361, 1 /* Error */, "_0_cannot_be_used_as_a_value_because_it_was_imported_using_import_type_1361", "'{0}' cannot be used as a value because it was imported using 'import type'."),
	        _0_cannot_be_used_as_a_value_because_it_was_exported_using_export_type: diag(1362, 1 /* Error */, "_0_cannot_be_used_as_a_value_because_it_was_exported_using_export_type_1362", "'{0}' cannot be used as a value because it was exported using 'export type'."),
	        A_type_only_import_can_specify_a_default_import_or_named_bindings_but_not_both: diag(1363, 1 /* Error */, "A_type_only_import_can_specify_a_default_import_or_named_bindings_but_not_both_1363", "A type-only import can specify a default import or named bindings, but not both."),
	        Convert_to_type_only_export: diag(1364, 3 /* Message */, "Convert_to_type_only_export_1364", "Convert to type-only export"),
	        Convert_all_re_exported_types_to_type_only_exports: diag(1365, 3 /* Message */, "Convert_all_re_exported_types_to_type_only_exports_1365", "Convert all re-exported types to type-only exports"),
	        Split_into_two_separate_import_declarations: diag(1366, 3 /* Message */, "Split_into_two_separate_import_declarations_1366", "Split into two separate import declarations"),
	        Split_all_invalid_type_only_imports: diag(1367, 3 /* Message */, "Split_all_invalid_type_only_imports_1367", "Split all invalid type-only imports"),
	        Class_constructor_may_not_be_a_generator: diag(1368, 1 /* Error */, "Class_constructor_may_not_be_a_generator_1368", "Class constructor may not be a generator."),
	        Did_you_mean_0: diag(1369, 3 /* Message */, "Did_you_mean_0_1369", "Did you mean '{0}'?"),
	        This_import_is_never_used_as_a_value_and_must_use_import_type_because_importsNotUsedAsValues_is_set_to_error: diag(1371, 1 /* Error */, "This_import_is_never_used_as_a_value_and_must_use_import_type_because_importsNotUsedAsValues_is_set__1371", "This import is never used as a value and must use 'import type' because 'importsNotUsedAsValues' is set to 'error'."),
	        await_expressions_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_file_has_no_imports_or_exports_Consider_adding_an_empty_export_to_make_this_file_a_module: diag(1375, 1 /* Error */, "await_expressions_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_fi_1375", "'await' expressions are only allowed at the top level of a file when that file is a module, but this file has no imports or exports. Consider adding an empty 'export {}' to make this file a module."),
	        _0_was_imported_here: diag(1376, 3 /* Message */, "_0_was_imported_here_1376", "'{0}' was imported here."),
	        _0_was_exported_here: diag(1377, 3 /* Message */, "_0_was_exported_here_1377", "'{0}' was exported here."),
	        Top_level_await_expressions_are_only_allowed_when_the_module_option_is_set_to_es2022_esnext_system_node16_nodenext_or_preserve_and_the_target_option_is_set_to_es2017_or_higher: diag(1378, 1 /* Error */, "Top_level_await_expressions_are_only_allowed_when_the_module_option_is_set_to_es2022_esnext_system_n_1378", "Top-level 'await' expressions are only allowed when the 'module' option is set to 'es2022', 'esnext', 'system', 'node16', 'nodenext', or 'preserve', and the 'target' option is set to 'es2017' or higher."),
	        An_import_alias_cannot_reference_a_declaration_that_was_exported_using_export_type: diag(1379, 1 /* Error */, "An_import_alias_cannot_reference_a_declaration_that_was_exported_using_export_type_1379", "An import alias cannot reference a declaration that was exported using 'export type'."),
	        An_import_alias_cannot_reference_a_declaration_that_was_imported_using_import_type: diag(1380, 1 /* Error */, "An_import_alias_cannot_reference_a_declaration_that_was_imported_using_import_type_1380", "An import alias cannot reference a declaration that was imported using 'import type'."),
	        Unexpected_token_Did_you_mean_or_rbrace: diag(1381, 1 /* Error */, "Unexpected_token_Did_you_mean_or_rbrace_1381", "Unexpected token. Did you mean `{'}'}` or `&rbrace;`?"),
	        Unexpected_token_Did_you_mean_or_gt: diag(1382, 1 /* Error */, "Unexpected_token_Did_you_mean_or_gt_1382", "Unexpected token. Did you mean `{'>'}` or `&gt;`?"),
	        Function_type_notation_must_be_parenthesized_when_used_in_a_union_type: diag(1385, 1 /* Error */, "Function_type_notation_must_be_parenthesized_when_used_in_a_union_type_1385", "Function type notation must be parenthesized when used in a union type."),
	        Constructor_type_notation_must_be_parenthesized_when_used_in_a_union_type: diag(1386, 1 /* Error */, "Constructor_type_notation_must_be_parenthesized_when_used_in_a_union_type_1386", "Constructor type notation must be parenthesized when used in a union type."),
	        Function_type_notation_must_be_parenthesized_when_used_in_an_intersection_type: diag(1387, 1 /* Error */, "Function_type_notation_must_be_parenthesized_when_used_in_an_intersection_type_1387", "Function type notation must be parenthesized when used in an intersection type."),
	        Constructor_type_notation_must_be_parenthesized_when_used_in_an_intersection_type: diag(1388, 1 /* Error */, "Constructor_type_notation_must_be_parenthesized_when_used_in_an_intersection_type_1388", "Constructor type notation must be parenthesized when used in an intersection type."),
	        _0_is_not_allowed_as_a_variable_declaration_name: diag(1389, 1 /* Error */, "_0_is_not_allowed_as_a_variable_declaration_name_1389", "'{0}' is not allowed as a variable declaration name."),
	        _0_is_not_allowed_as_a_parameter_name: diag(1390, 1 /* Error */, "_0_is_not_allowed_as_a_parameter_name_1390", "'{0}' is not allowed as a parameter name."),
	        An_import_alias_cannot_use_import_type: diag(1392, 1 /* Error */, "An_import_alias_cannot_use_import_type_1392", "An import alias cannot use 'import type'"),
	        Imported_via_0_from_file_1: diag(1393, 3 /* Message */, "Imported_via_0_from_file_1_1393", "Imported via {0} from file '{1}'"),
	        Imported_via_0_from_file_1_with_packageId_2: diag(1394, 3 /* Message */, "Imported_via_0_from_file_1_with_packageId_2_1394", "Imported via {0} from file '{1}' with packageId '{2}'"),
	        Imported_via_0_from_file_1_to_import_importHelpers_as_specified_in_compilerOptions: diag(1395, 3 /* Message */, "Imported_via_0_from_file_1_to_import_importHelpers_as_specified_in_compilerOptions_1395", "Imported via {0} from file '{1}' to import 'importHelpers' as specified in compilerOptions"),
	        Imported_via_0_from_file_1_with_packageId_2_to_import_importHelpers_as_specified_in_compilerOptions: diag(1396, 3 /* Message */, "Imported_via_0_from_file_1_with_packageId_2_to_import_importHelpers_as_specified_in_compilerOptions_1396", "Imported via {0} from file '{1}' with packageId '{2}' to import 'importHelpers' as specified in compilerOptions"),
	        Imported_via_0_from_file_1_to_import_jsx_and_jsxs_factory_functions: diag(1397, 3 /* Message */, "Imported_via_0_from_file_1_to_import_jsx_and_jsxs_factory_functions_1397", "Imported via {0} from file '{1}' to import 'jsx' and 'jsxs' factory functions"),
	        Imported_via_0_from_file_1_with_packageId_2_to_import_jsx_and_jsxs_factory_functions: diag(1398, 3 /* Message */, "Imported_via_0_from_file_1_with_packageId_2_to_import_jsx_and_jsxs_factory_functions_1398", "Imported via {0} from file '{1}' with packageId '{2}' to import 'jsx' and 'jsxs' factory functions"),
	        File_is_included_via_import_here: diag(1399, 3 /* Message */, "File_is_included_via_import_here_1399", "File is included via import here."),
	        Referenced_via_0_from_file_1: diag(1400, 3 /* Message */, "Referenced_via_0_from_file_1_1400", "Referenced via '{0}' from file '{1}'"),
	        File_is_included_via_reference_here: diag(1401, 3 /* Message */, "File_is_included_via_reference_here_1401", "File is included via reference here."),
	        Type_library_referenced_via_0_from_file_1: diag(1402, 3 /* Message */, "Type_library_referenced_via_0_from_file_1_1402", "Type library referenced via '{0}' from file '{1}'"),
	        Type_library_referenced_via_0_from_file_1_with_packageId_2: diag(1403, 3 /* Message */, "Type_library_referenced_via_0_from_file_1_with_packageId_2_1403", "Type library referenced via '{0}' from file '{1}' with packageId '{2}'"),
	        File_is_included_via_type_library_reference_here: diag(1404, 3 /* Message */, "File_is_included_via_type_library_reference_here_1404", "File is included via type library reference here."),
	        Library_referenced_via_0_from_file_1: diag(1405, 3 /* Message */, "Library_referenced_via_0_from_file_1_1405", "Library referenced via '{0}' from file '{1}'"),
	        File_is_included_via_library_reference_here: diag(1406, 3 /* Message */, "File_is_included_via_library_reference_here_1406", "File is included via library reference here."),
	        Matched_by_include_pattern_0_in_1: diag(1407, 3 /* Message */, "Matched_by_include_pattern_0_in_1_1407", "Matched by include pattern '{0}' in '{1}'"),
	        File_is_matched_by_include_pattern_specified_here: diag(1408, 3 /* Message */, "File_is_matched_by_include_pattern_specified_here_1408", "File is matched by include pattern specified here."),
	        Part_of_files_list_in_tsconfig_json: diag(1409, 3 /* Message */, "Part_of_files_list_in_tsconfig_json_1409", "Part of 'files' list in tsconfig.json"),
	        File_is_matched_by_files_list_specified_here: diag(1410, 3 /* Message */, "File_is_matched_by_files_list_specified_here_1410", "File is matched by 'files' list specified here."),
	        Output_from_referenced_project_0_included_because_1_specified: diag(1411, 3 /* Message */, "Output_from_referenced_project_0_included_because_1_specified_1411", "Output from referenced project '{0}' included because '{1}' specified"),
	        Output_from_referenced_project_0_included_because_module_is_specified_as_none: diag(1412, 3 /* Message */, "Output_from_referenced_project_0_included_because_module_is_specified_as_none_1412", "Output from referenced project '{0}' included because '--module' is specified as 'none'"),
	        File_is_output_from_referenced_project_specified_here: diag(1413, 3 /* Message */, "File_is_output_from_referenced_project_specified_here_1413", "File is output from referenced project specified here."),
	        Source_from_referenced_project_0_included_because_1_specified: diag(1414, 3 /* Message */, "Source_from_referenced_project_0_included_because_1_specified_1414", "Source from referenced project '{0}' included because '{1}' specified"),
	        Source_from_referenced_project_0_included_because_module_is_specified_as_none: diag(1415, 3 /* Message */, "Source_from_referenced_project_0_included_because_module_is_specified_as_none_1415", "Source from referenced project '{0}' included because '--module' is specified as 'none'"),
	        File_is_source_from_referenced_project_specified_here: diag(1416, 3 /* Message */, "File_is_source_from_referenced_project_specified_here_1416", "File is source from referenced project specified here."),
	        Entry_point_of_type_library_0_specified_in_compilerOptions: diag(1417, 3 /* Message */, "Entry_point_of_type_library_0_specified_in_compilerOptions_1417", "Entry point of type library '{0}' specified in compilerOptions"),
	        Entry_point_of_type_library_0_specified_in_compilerOptions_with_packageId_1: diag(1418, 3 /* Message */, "Entry_point_of_type_library_0_specified_in_compilerOptions_with_packageId_1_1418", "Entry point of type library '{0}' specified in compilerOptions with packageId '{1}'"),
	        File_is_entry_point_of_type_library_specified_here: diag(1419, 3 /* Message */, "File_is_entry_point_of_type_library_specified_here_1419", "File is entry point of type library specified here."),
	        Entry_point_for_implicit_type_library_0: diag(1420, 3 /* Message */, "Entry_point_for_implicit_type_library_0_1420", "Entry point for implicit type library '{0}'"),
	        Entry_point_for_implicit_type_library_0_with_packageId_1: diag(1421, 3 /* Message */, "Entry_point_for_implicit_type_library_0_with_packageId_1_1421", "Entry point for implicit type library '{0}' with packageId '{1}'"),
	        Library_0_specified_in_compilerOptions: diag(1422, 3 /* Message */, "Library_0_specified_in_compilerOptions_1422", "Library '{0}' specified in compilerOptions"),
	        File_is_library_specified_here: diag(1423, 3 /* Message */, "File_is_library_specified_here_1423", "File is library specified here."),
	        Default_library: diag(1424, 3 /* Message */, "Default_library_1424", "Default library"),
	        Default_library_for_target_0: diag(1425, 3 /* Message */, "Default_library_for_target_0_1425", "Default library for target '{0}'"),
	        File_is_default_library_for_target_specified_here: diag(1426, 3 /* Message */, "File_is_default_library_for_target_specified_here_1426", "File is default library for target specified here."),
	        Root_file_specified_for_compilation: diag(1427, 3 /* Message */, "Root_file_specified_for_compilation_1427", "Root file specified for compilation"),
	        File_is_output_of_project_reference_source_0: diag(1428, 3 /* Message */, "File_is_output_of_project_reference_source_0_1428", "File is output of project reference source '{0}'"),
	        File_redirects_to_file_0: diag(1429, 3 /* Message */, "File_redirects_to_file_0_1429", "File redirects to file '{0}'"),
	        The_file_is_in_the_program_because_Colon: diag(1430, 3 /* Message */, "The_file_is_in_the_program_because_Colon_1430", "The file is in the program because:"),
	        for_await_loops_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_file_has_no_imports_or_exports_Consider_adding_an_empty_export_to_make_this_file_a_module: diag(1431, 1 /* Error */, "for_await_loops_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_file_1431", "'for await' loops are only allowed at the top level of a file when that file is a module, but this file has no imports or exports. Consider adding an empty 'export {}' to make this file a module."),
	        Top_level_for_await_loops_are_only_allowed_when_the_module_option_is_set_to_es2022_esnext_system_node16_nodenext_or_preserve_and_the_target_option_is_set_to_es2017_or_higher: diag(1432, 1 /* Error */, "Top_level_for_await_loops_are_only_allowed_when_the_module_option_is_set_to_es2022_esnext_system_nod_1432", "Top-level 'for await' loops are only allowed when the 'module' option is set to 'es2022', 'esnext', 'system', 'node16', 'nodenext', or 'preserve', and the 'target' option is set to 'es2017' or higher."),
	        Neither_decorators_nor_modifiers_may_be_applied_to_this_parameters: diag(1433, 1 /* Error */, "Neither_decorators_nor_modifiers_may_be_applied_to_this_parameters_1433", "Neither decorators nor modifiers may be applied to 'this' parameters."),
	        Unexpected_keyword_or_identifier: diag(1434, 1 /* Error */, "Unexpected_keyword_or_identifier_1434", "Unexpected keyword or identifier."),
	        Unknown_keyword_or_identifier_Did_you_mean_0: diag(1435, 1 /* Error */, "Unknown_keyword_or_identifier_Did_you_mean_0_1435", "Unknown keyword or identifier. Did you mean '{0}'?"),
	        Decorators_must_precede_the_name_and_all_keywords_of_property_declarations: diag(1436, 1 /* Error */, "Decorators_must_precede_the_name_and_all_keywords_of_property_declarations_1436", "Decorators must precede the name and all keywords of property declarations."),
	        Namespace_must_be_given_a_name: diag(1437, 1 /* Error */, "Namespace_must_be_given_a_name_1437", "Namespace must be given a name."),
	        Interface_must_be_given_a_name: diag(1438, 1 /* Error */, "Interface_must_be_given_a_name_1438", "Interface must be given a name."),
	        Type_alias_must_be_given_a_name: diag(1439, 1 /* Error */, "Type_alias_must_be_given_a_name_1439", "Type alias must be given a name."),
	        Variable_declaration_not_allowed_at_this_location: diag(1440, 1 /* Error */, "Variable_declaration_not_allowed_at_this_location_1440", "Variable declaration not allowed at this location."),
	        Cannot_start_a_function_call_in_a_type_annotation: diag(1441, 1 /* Error */, "Cannot_start_a_function_call_in_a_type_annotation_1441", "Cannot start a function call in a type annotation."),
	        Expected_for_property_initializer: diag(1442, 1 /* Error */, "Expected_for_property_initializer_1442", "Expected '=' for property initializer."),
	        Module_declaration_names_may_only_use_or_quoted_strings: diag(1443, 1 /* Error */, "Module_declaration_names_may_only_use_or_quoted_strings_1443", `Module declaration names may only use ' or " quoted strings.`),
	        _0_is_a_type_and_must_be_imported_using_a_type_only_import_when_preserveValueImports_and_isolatedModules_are_both_enabled: diag(1444, 1 /* Error */, "_0_is_a_type_and_must_be_imported_using_a_type_only_import_when_preserveValueImports_and_isolatedMod_1444", "'{0}' is a type and must be imported using a type-only import when 'preserveValueImports' and 'isolatedModules' are both enabled."),
	        _0_resolves_to_a_type_only_declaration_and_must_be_imported_using_a_type_only_import_when_preserveValueImports_and_isolatedModules_are_both_enabled: diag(1446, 1 /* Error */, "_0_resolves_to_a_type_only_declaration_and_must_be_imported_using_a_type_only_import_when_preserveVa_1446", "'{0}' resolves to a type-only declaration and must be imported using a type-only import when 'preserveValueImports' and 'isolatedModules' are both enabled."),
	        _0_resolves_to_a_type_only_declaration_and_must_be_re_exported_using_a_type_only_re_export_when_1_is_enabled: diag(1448, 1 /* Error */, "_0_resolves_to_a_type_only_declaration_and_must_be_re_exported_using_a_type_only_re_export_when_1_is_1448", "'{0}' resolves to a type-only declaration and must be re-exported using a type-only re-export when '{1}' is enabled."),
	        Preserve_unused_imported_values_in_the_JavaScript_output_that_would_otherwise_be_removed: diag(1449, 3 /* Message */, "Preserve_unused_imported_values_in_the_JavaScript_output_that_would_otherwise_be_removed_1449", "Preserve unused imported values in the JavaScript output that would otherwise be removed."),
	        Dynamic_imports_can_only_accept_a_module_specifier_and_an_optional_set_of_attributes_as_arguments: diag(1450, 3 /* Message */, "Dynamic_imports_can_only_accept_a_module_specifier_and_an_optional_set_of_attributes_as_arguments_1450", "Dynamic imports can only accept a module specifier and an optional set of attributes as arguments"),
	        Private_identifiers_are_only_allowed_in_class_bodies_and_may_only_be_used_as_part_of_a_class_member_declaration_property_access_or_on_the_left_hand_side_of_an_in_expression: diag(1451, 1 /* Error */, "Private_identifiers_are_only_allowed_in_class_bodies_and_may_only_be_used_as_part_of_a_class_member__1451", "Private identifiers are only allowed in class bodies and may only be used as part of a class member declaration, property access, or on the left-hand-side of an 'in' expression"),
	        resolution_mode_should_be_either_require_or_import: diag(1453, 1 /* Error */, "resolution_mode_should_be_either_require_or_import_1453", "`resolution-mode` should be either `require` or `import`."),
	        resolution_mode_can_only_be_set_for_type_only_imports: diag(1454, 1 /* Error */, "resolution_mode_can_only_be_set_for_type_only_imports_1454", "`resolution-mode` can only be set for type-only imports."),
	        resolution_mode_is_the_only_valid_key_for_type_import_assertions: diag(1455, 1 /* Error */, "resolution_mode_is_the_only_valid_key_for_type_import_assertions_1455", "`resolution-mode` is the only valid key for type import assertions."),
	        Type_import_assertions_should_have_exactly_one_key_resolution_mode_with_value_import_or_require: diag(1456, 1 /* Error */, "Type_import_assertions_should_have_exactly_one_key_resolution_mode_with_value_import_or_require_1456", "Type import assertions should have exactly one key - `resolution-mode` - with value `import` or `require`."),
	        Matched_by_default_include_pattern_Asterisk_Asterisk_Slash_Asterisk: diag(1457, 3 /* Message */, "Matched_by_default_include_pattern_Asterisk_Asterisk_Slash_Asterisk_1457", "Matched by default include pattern '**/*'"),
	        File_is_ECMAScript_module_because_0_has_field_type_with_value_module: diag(1458, 3 /* Message */, "File_is_ECMAScript_module_because_0_has_field_type_with_value_module_1458", `File is ECMAScript module because '{0}' has field "type" with value "module"`),
	        File_is_CommonJS_module_because_0_has_field_type_whose_value_is_not_module: diag(1459, 3 /* Message */, "File_is_CommonJS_module_because_0_has_field_type_whose_value_is_not_module_1459", `File is CommonJS module because '{0}' has field "type" whose value is not "module"`),
	        File_is_CommonJS_module_because_0_does_not_have_field_type: diag(1460, 3 /* Message */, "File_is_CommonJS_module_because_0_does_not_have_field_type_1460", `File is CommonJS module because '{0}' does not have field "type"`),
	        File_is_CommonJS_module_because_package_json_was_not_found: diag(1461, 3 /* Message */, "File_is_CommonJS_module_because_package_json_was_not_found_1461", "File is CommonJS module because 'package.json' was not found"),
	        resolution_mode_is_the_only_valid_key_for_type_import_attributes: diag(1463, 1 /* Error */, "resolution_mode_is_the_only_valid_key_for_type_import_attributes_1463", "'resolution-mode' is the only valid key for type import attributes."),
	        Type_import_attributes_should_have_exactly_one_key_resolution_mode_with_value_import_or_require: diag(1464, 1 /* Error */, "Type_import_attributes_should_have_exactly_one_key_resolution_mode_with_value_import_or_require_1464", "Type import attributes should have exactly one key - 'resolution-mode' - with value 'import' or 'require'."),
	        The_import_meta_meta_property_is_not_allowed_in_files_which_will_build_into_CommonJS_output: diag(1470, 1 /* Error */, "The_import_meta_meta_property_is_not_allowed_in_files_which_will_build_into_CommonJS_output_1470", "The 'import.meta' meta-property is not allowed in files which will build into CommonJS output."),
	        Module_0_cannot_be_imported_using_this_construct_The_specifier_only_resolves_to_an_ES_module_which_cannot_be_imported_with_require_Use_an_ECMAScript_import_instead: diag(1471, 1 /* Error */, "Module_0_cannot_be_imported_using_this_construct_The_specifier_only_resolves_to_an_ES_module_which_c_1471", "Module '{0}' cannot be imported using this construct. The specifier only resolves to an ES module, which cannot be imported with 'require'. Use an ECMAScript import instead."),
	        catch_or_finally_expected: diag(1472, 1 /* Error */, "catch_or_finally_expected_1472", "'catch' or 'finally' expected."),
	        An_import_declaration_can_only_be_used_at_the_top_level_of_a_module: diag(1473, 1 /* Error */, "An_import_declaration_can_only_be_used_at_the_top_level_of_a_module_1473", "An import declaration can only be used at the top level of a module."),
	        An_export_declaration_can_only_be_used_at_the_top_level_of_a_module: diag(1474, 1 /* Error */, "An_export_declaration_can_only_be_used_at_the_top_level_of_a_module_1474", "An export declaration can only be used at the top level of a module."),
	        Control_what_method_is_used_to_detect_module_format_JS_files: diag(1475, 3 /* Message */, "Control_what_method_is_used_to_detect_module_format_JS_files_1475", "Control what method is used to detect module-format JS files."),
	        auto_Colon_Treat_files_with_imports_exports_import_meta_jsx_with_jsx_Colon_react_jsx_or_esm_format_with_module_Colon_node16_as_modules: diag(1476, 3 /* Message */, "auto_Colon_Treat_files_with_imports_exports_import_meta_jsx_with_jsx_Colon_react_jsx_or_esm_format_w_1476", '"auto": Treat files with imports, exports, import.meta, jsx (with jsx: react-jsx), or esm format (with module: node16+) as modules.'),
	        An_instantiation_expression_cannot_be_followed_by_a_property_access: diag(1477, 1 /* Error */, "An_instantiation_expression_cannot_be_followed_by_a_property_access_1477", "An instantiation expression cannot be followed by a property access."),
	        Identifier_or_string_literal_expected: diag(1478, 1 /* Error */, "Identifier_or_string_literal_expected_1478", "Identifier or string literal expected."),
	        The_current_file_is_a_CommonJS_module_whose_imports_will_produce_require_calls_however_the_referenced_file_is_an_ECMAScript_module_and_cannot_be_imported_with_require_Consider_writing_a_dynamic_import_0_call_instead: diag(1479, 1 /* Error */, "The_current_file_is_a_CommonJS_module_whose_imports_will_produce_require_calls_however_the_reference_1479", `The current file is a CommonJS module whose imports will produce 'require' calls; however, the referenced file is an ECMAScript module and cannot be imported with 'require'. Consider writing a dynamic 'import("{0}")' call instead.`),
	        To_convert_this_file_to_an_ECMAScript_module_change_its_file_extension_to_0_or_create_a_local_package_json_file_with_type_Colon_module: diag(1480, 3 /* Message */, "To_convert_this_file_to_an_ECMAScript_module_change_its_file_extension_to_0_or_create_a_local_packag_1480", 'To convert this file to an ECMAScript module, change its file extension to \'{0}\' or create a local package.json file with `{ "type": "module" }`.'),
	        To_convert_this_file_to_an_ECMAScript_module_change_its_file_extension_to_0_or_add_the_field_type_Colon_module_to_1: diag(1481, 3 /* Message */, "To_convert_this_file_to_an_ECMAScript_module_change_its_file_extension_to_0_or_add_the_field_type_Co_1481", `To convert this file to an ECMAScript module, change its file extension to '{0}', or add the field \`"type": "module"\` to '{1}'.`),
	        To_convert_this_file_to_an_ECMAScript_module_add_the_field_type_Colon_module_to_0: diag(1482, 3 /* Message */, "To_convert_this_file_to_an_ECMAScript_module_add_the_field_type_Colon_module_to_0_1482", 'To convert this file to an ECMAScript module, add the field `"type": "module"` to \'{0}\'.'),
	        To_convert_this_file_to_an_ECMAScript_module_create_a_local_package_json_file_with_type_Colon_module: diag(1483, 3 /* Message */, "To_convert_this_file_to_an_ECMAScript_module_create_a_local_package_json_file_with_type_Colon_module_1483", 'To convert this file to an ECMAScript module, create a local package.json file with `{ "type": "module" }`.'),
	        _0_is_a_type_and_must_be_imported_using_a_type_only_import_when_verbatimModuleSyntax_is_enabled: diag(1484, 1 /* Error */, "_0_is_a_type_and_must_be_imported_using_a_type_only_import_when_verbatimModuleSyntax_is_enabled_1484", "'{0}' is a type and must be imported using a type-only import when 'verbatimModuleSyntax' is enabled."),
	        _0_resolves_to_a_type_only_declaration_and_must_be_imported_using_a_type_only_import_when_verbatimModuleSyntax_is_enabled: diag(1485, 1 /* Error */, "_0_resolves_to_a_type_only_declaration_and_must_be_imported_using_a_type_only_import_when_verbatimMo_1485", "'{0}' resolves to a type-only declaration and must be imported using a type-only import when 'verbatimModuleSyntax' is enabled."),
	        Decorator_used_before_export_here: diag(1486, 1 /* Error */, "Decorator_used_before_export_here_1486", "Decorator used before 'export' here."),
	        Octal_escape_sequences_are_not_allowed_Use_the_syntax_0: diag(1487, 1 /* Error */, "Octal_escape_sequences_are_not_allowed_Use_the_syntax_0_1487", "Octal escape sequences are not allowed. Use the syntax '{0}'."),
	        Escape_sequence_0_is_not_allowed: diag(1488, 1 /* Error */, "Escape_sequence_0_is_not_allowed_1488", "Escape sequence '{0}' is not allowed."),
	        Decimals_with_leading_zeros_are_not_allowed: diag(1489, 1 /* Error */, "Decimals_with_leading_zeros_are_not_allowed_1489", "Decimals with leading zeros are not allowed."),
	        File_appears_to_be_binary: diag(1490, 1 /* Error */, "File_appears_to_be_binary_1490", "File appears to be binary."),
	        _0_modifier_cannot_appear_on_a_using_declaration: diag(1491, 1 /* Error */, "_0_modifier_cannot_appear_on_a_using_declaration_1491", "'{0}' modifier cannot appear on a 'using' declaration."),
	        _0_declarations_may_not_have_binding_patterns: diag(1492, 1 /* Error */, "_0_declarations_may_not_have_binding_patterns_1492", "'{0}' declarations may not have binding patterns."),
	        The_left_hand_side_of_a_for_in_statement_cannot_be_a_using_declaration: diag(1493, 1 /* Error */, "The_left_hand_side_of_a_for_in_statement_cannot_be_a_using_declaration_1493", "The left-hand side of a 'for...in' statement cannot be a 'using' declaration."),
	        The_left_hand_side_of_a_for_in_statement_cannot_be_an_await_using_declaration: diag(1494, 1 /* Error */, "The_left_hand_side_of_a_for_in_statement_cannot_be_an_await_using_declaration_1494", "The left-hand side of a 'for...in' statement cannot be an 'await using' declaration."),
	        _0_modifier_cannot_appear_on_an_await_using_declaration: diag(1495, 1 /* Error */, "_0_modifier_cannot_appear_on_an_await_using_declaration_1495", "'{0}' modifier cannot appear on an 'await using' declaration."),
	        Identifier_string_literal_or_number_literal_expected: diag(1496, 1 /* Error */, "Identifier_string_literal_or_number_literal_expected_1496", "Identifier, string literal, or number literal expected."),
	        The_types_of_0_are_incompatible_between_these_types: diag(2200, 1 /* Error */, "The_types_of_0_are_incompatible_between_these_types_2200", "The types of '{0}' are incompatible between these types."),
	        The_types_returned_by_0_are_incompatible_between_these_types: diag(2201, 1 /* Error */, "The_types_returned_by_0_are_incompatible_between_these_types_2201", "The types returned by '{0}' are incompatible between these types."),
	        Call_signature_return_types_0_and_1_are_incompatible: diag(
	          2202,
	          1 /* Error */,
	          "Call_signature_return_types_0_and_1_are_incompatible_2202",
	          "Call signature return types '{0}' and '{1}' are incompatible.",
	          /*reportsUnnecessary*/
	          void 0,
	          /*elidedInCompatabilityPyramid*/
	          true
	        ),
	        Construct_signature_return_types_0_and_1_are_incompatible: diag(
	          2203,
	          1 /* Error */,
	          "Construct_signature_return_types_0_and_1_are_incompatible_2203",
	          "Construct signature return types '{0}' and '{1}' are incompatible.",
	          /*reportsUnnecessary*/
	          void 0,
	          /*elidedInCompatabilityPyramid*/
	          true
	        ),
	        Call_signatures_with_no_arguments_have_incompatible_return_types_0_and_1: diag(
	          2204,
	          1 /* Error */,
	          "Call_signatures_with_no_arguments_have_incompatible_return_types_0_and_1_2204",
	          "Call signatures with no arguments have incompatible return types '{0}' and '{1}'.",
	          /*reportsUnnecessary*/
	          void 0,
	          /*elidedInCompatabilityPyramid*/
	          true
	        ),
	        Construct_signatures_with_no_arguments_have_incompatible_return_types_0_and_1: diag(
	          2205,
	          1 /* Error */,
	          "Construct_signatures_with_no_arguments_have_incompatible_return_types_0_and_1_2205",
	          "Construct signatures with no arguments have incompatible return types '{0}' and '{1}'.",
	          /*reportsUnnecessary*/
	          void 0,
	          /*elidedInCompatabilityPyramid*/
	          true
	        ),
	        The_type_modifier_cannot_be_used_on_a_named_import_when_import_type_is_used_on_its_import_statement: diag(2206, 1 /* Error */, "The_type_modifier_cannot_be_used_on_a_named_import_when_import_type_is_used_on_its_import_statement_2206", "The 'type' modifier cannot be used on a named import when 'import type' is used on its import statement."),
	        The_type_modifier_cannot_be_used_on_a_named_export_when_export_type_is_used_on_its_export_statement: diag(2207, 1 /* Error */, "The_type_modifier_cannot_be_used_on_a_named_export_when_export_type_is_used_on_its_export_statement_2207", "The 'type' modifier cannot be used on a named export when 'export type' is used on its export statement."),
	        This_type_parameter_might_need_an_extends_0_constraint: diag(2208, 1 /* Error */, "This_type_parameter_might_need_an_extends_0_constraint_2208", "This type parameter might need an `extends {0}` constraint."),
	        The_project_root_is_ambiguous_but_is_required_to_resolve_export_map_entry_0_in_file_1_Supply_the_rootDir_compiler_option_to_disambiguate: diag(2209, 1 /* Error */, "The_project_root_is_ambiguous_but_is_required_to_resolve_export_map_entry_0_in_file_1_Supply_the_roo_2209", "The project root is ambiguous, but is required to resolve export map entry '{0}' in file '{1}'. Supply the `rootDir` compiler option to disambiguate."),
	        The_project_root_is_ambiguous_but_is_required_to_resolve_import_map_entry_0_in_file_1_Supply_the_rootDir_compiler_option_to_disambiguate: diag(2210, 1 /* Error */, "The_project_root_is_ambiguous_but_is_required_to_resolve_import_map_entry_0_in_file_1_Supply_the_roo_2210", "The project root is ambiguous, but is required to resolve import map entry '{0}' in file '{1}'. Supply the `rootDir` compiler option to disambiguate."),
	        Add_extends_constraint: diag(2211, 3 /* Message */, "Add_extends_constraint_2211", "Add `extends` constraint."),
	        Add_extends_constraint_to_all_type_parameters: diag(2212, 3 /* Message */, "Add_extends_constraint_to_all_type_parameters_2212", "Add `extends` constraint to all type parameters"),
	        Duplicate_identifier_0: diag(2300, 1 /* Error */, "Duplicate_identifier_0_2300", "Duplicate identifier '{0}'."),
	        Initializer_of_instance_member_variable_0_cannot_reference_identifier_1_declared_in_the_constructor: diag(2301, 1 /* Error */, "Initializer_of_instance_member_variable_0_cannot_reference_identifier_1_declared_in_the_constructor_2301", "Initializer of instance member variable '{0}' cannot reference identifier '{1}' declared in the constructor."),
	        Static_members_cannot_reference_class_type_parameters: diag(2302, 1 /* Error */, "Static_members_cannot_reference_class_type_parameters_2302", "Static members cannot reference class type parameters."),
	        Circular_definition_of_import_alias_0: diag(2303, 1 /* Error */, "Circular_definition_of_import_alias_0_2303", "Circular definition of import alias '{0}'."),
	        Cannot_find_name_0: diag(2304, 1 /* Error */, "Cannot_find_name_0_2304", "Cannot find name '{0}'."),
	        Module_0_has_no_exported_member_1: diag(2305, 1 /* Error */, "Module_0_has_no_exported_member_1_2305", "Module '{0}' has no exported member '{1}'."),
	        File_0_is_not_a_module: diag(2306, 1 /* Error */, "File_0_is_not_a_module_2306", "File '{0}' is not a module."),
	        Cannot_find_module_0_or_its_corresponding_type_declarations: diag(2307, 1 /* Error */, "Cannot_find_module_0_or_its_corresponding_type_declarations_2307", "Cannot find module '{0}' or its corresponding type declarations."),
	        Module_0_has_already_exported_a_member_named_1_Consider_explicitly_re_exporting_to_resolve_the_ambiguity: diag(2308, 1 /* Error */, "Module_0_has_already_exported_a_member_named_1_Consider_explicitly_re_exporting_to_resolve_the_ambig_2308", "Module {0} has already exported a member named '{1}'. Consider explicitly re-exporting to resolve the ambiguity."),
	        An_export_assignment_cannot_be_used_in_a_module_with_other_exported_elements: diag(2309, 1 /* Error */, "An_export_assignment_cannot_be_used_in_a_module_with_other_exported_elements_2309", "An export assignment cannot be used in a module with other exported elements."),
	        Type_0_recursively_references_itself_as_a_base_type: diag(2310, 1 /* Error */, "Type_0_recursively_references_itself_as_a_base_type_2310", "Type '{0}' recursively references itself as a base type."),
	        Cannot_find_name_0_Did_you_mean_to_write_this_in_an_async_function: diag(2311, 1 /* Error */, "Cannot_find_name_0_Did_you_mean_to_write_this_in_an_async_function_2311", "Cannot find name '{0}'. Did you mean to write this in an async function?"),
	        An_interface_can_only_extend_an_object_type_or_intersection_of_object_types_with_statically_known_members: diag(2312, 1 /* Error */, "An_interface_can_only_extend_an_object_type_or_intersection_of_object_types_with_statically_known_me_2312", "An interface can only extend an object type or intersection of object types with statically known members."),
	        Type_parameter_0_has_a_circular_constraint: diag(2313, 1 /* Error */, "Type_parameter_0_has_a_circular_constraint_2313", "Type parameter '{0}' has a circular constraint."),
	        Generic_type_0_requires_1_type_argument_s: diag(2314, 1 /* Error */, "Generic_type_0_requires_1_type_argument_s_2314", "Generic type '{0}' requires {1} type argument(s)."),
	        Type_0_is_not_generic: diag(2315, 1 /* Error */, "Type_0_is_not_generic_2315", "Type '{0}' is not generic."),
	        Global_type_0_must_be_a_class_or_interface_type: diag(2316, 1 /* Error */, "Global_type_0_must_be_a_class_or_interface_type_2316", "Global type '{0}' must be a class or interface type."),
	        Global_type_0_must_have_1_type_parameter_s: diag(2317, 1 /* Error */, "Global_type_0_must_have_1_type_parameter_s_2317", "Global type '{0}' must have {1} type parameter(s)."),
	        Cannot_find_global_type_0: diag(2318, 1 /* Error */, "Cannot_find_global_type_0_2318", "Cannot find global type '{0}'."),
	        Named_property_0_of_types_1_and_2_are_not_identical: diag(2319, 1 /* Error */, "Named_property_0_of_types_1_and_2_are_not_identical_2319", "Named property '{0}' of types '{1}' and '{2}' are not identical."),
	        Interface_0_cannot_simultaneously_extend_types_1_and_2: diag(2320, 1 /* Error */, "Interface_0_cannot_simultaneously_extend_types_1_and_2_2320", "Interface '{0}' cannot simultaneously extend types '{1}' and '{2}'."),
	        Excessive_stack_depth_comparing_types_0_and_1: diag(2321, 1 /* Error */, "Excessive_stack_depth_comparing_types_0_and_1_2321", "Excessive stack depth comparing types '{0}' and '{1}'."),
	        Type_0_is_not_assignable_to_type_1: diag(2322, 1 /* Error */, "Type_0_is_not_assignable_to_type_1_2322", "Type '{0}' is not assignable to type '{1}'."),
	        Cannot_redeclare_exported_variable_0: diag(2323, 1 /* Error */, "Cannot_redeclare_exported_variable_0_2323", "Cannot redeclare exported variable '{0}'."),
	        Property_0_is_missing_in_type_1: diag(2324, 1 /* Error */, "Property_0_is_missing_in_type_1_2324", "Property '{0}' is missing in type '{1}'."),
	        Property_0_is_private_in_type_1_but_not_in_type_2: diag(2325, 1 /* Error */, "Property_0_is_private_in_type_1_but_not_in_type_2_2325", "Property '{0}' is private in type '{1}' but not in type '{2}'."),
	        Types_of_property_0_are_incompatible: diag(2326, 1 /* Error */, "Types_of_property_0_are_incompatible_2326", "Types of property '{0}' are incompatible."),
	        Property_0_is_optional_in_type_1_but_required_in_type_2: diag(2327, 1 /* Error */, "Property_0_is_optional_in_type_1_but_required_in_type_2_2327", "Property '{0}' is optional in type '{1}' but required in type '{2}'."),
	        Types_of_parameters_0_and_1_are_incompatible: diag(2328, 1 /* Error */, "Types_of_parameters_0_and_1_are_incompatible_2328", "Types of parameters '{0}' and '{1}' are incompatible."),
	        Index_signature_for_type_0_is_missing_in_type_1: diag(2329, 1 /* Error */, "Index_signature_for_type_0_is_missing_in_type_1_2329", "Index signature for type '{0}' is missing in type '{1}'."),
	        _0_and_1_index_signatures_are_incompatible: diag(2330, 1 /* Error */, "_0_and_1_index_signatures_are_incompatible_2330", "'{0}' and '{1}' index signatures are incompatible."),
	        this_cannot_be_referenced_in_a_module_or_namespace_body: diag(2331, 1 /* Error */, "this_cannot_be_referenced_in_a_module_or_namespace_body_2331", "'this' cannot be referenced in a module or namespace body."),
	        this_cannot_be_referenced_in_current_location: diag(2332, 1 /* Error */, "this_cannot_be_referenced_in_current_location_2332", "'this' cannot be referenced in current location."),
	        this_cannot_be_referenced_in_constructor_arguments: diag(2333, 1 /* Error */, "this_cannot_be_referenced_in_constructor_arguments_2333", "'this' cannot be referenced in constructor arguments."),
	        this_cannot_be_referenced_in_a_static_property_initializer: diag(2334, 1 /* Error */, "this_cannot_be_referenced_in_a_static_property_initializer_2334", "'this' cannot be referenced in a static property initializer."),
	        super_can_only_be_referenced_in_a_derived_class: diag(2335, 1 /* Error */, "super_can_only_be_referenced_in_a_derived_class_2335", "'super' can only be referenced in a derived class."),
	        super_cannot_be_referenced_in_constructor_arguments: diag(2336, 1 /* Error */, "super_cannot_be_referenced_in_constructor_arguments_2336", "'super' cannot be referenced in constructor arguments."),
	        Super_calls_are_not_permitted_outside_constructors_or_in_nested_functions_inside_constructors: diag(2337, 1 /* Error */, "Super_calls_are_not_permitted_outside_constructors_or_in_nested_functions_inside_constructors_2337", "Super calls are not permitted outside constructors or in nested functions inside constructors."),
	        super_property_access_is_permitted_only_in_a_constructor_member_function_or_member_accessor_of_a_derived_class: diag(2338, 1 /* Error */, "super_property_access_is_permitted_only_in_a_constructor_member_function_or_member_accessor_of_a_der_2338", "'super' property access is permitted only in a constructor, member function, or member accessor of a derived class."),
	        Property_0_does_not_exist_on_type_1: diag(2339, 1 /* Error */, "Property_0_does_not_exist_on_type_1_2339", "Property '{0}' does not exist on type '{1}'."),
	        Only_public_and_protected_methods_of_the_base_class_are_accessible_via_the_super_keyword: diag(2340, 1 /* Error */, "Only_public_and_protected_methods_of_the_base_class_are_accessible_via_the_super_keyword_2340", "Only public and protected methods of the base class are accessible via the 'super' keyword."),
	        Property_0_is_private_and_only_accessible_within_class_1: diag(2341, 1 /* Error */, "Property_0_is_private_and_only_accessible_within_class_1_2341", "Property '{0}' is private and only accessible within class '{1}'."),
	        This_syntax_requires_an_imported_helper_named_1_which_does_not_exist_in_0_Consider_upgrading_your_version_of_0: diag(2343, 1 /* Error */, "This_syntax_requires_an_imported_helper_named_1_which_does_not_exist_in_0_Consider_upgrading_your_ve_2343", "This syntax requires an imported helper named '{1}' which does not exist in '{0}'. Consider upgrading your version of '{0}'."),
	        Type_0_does_not_satisfy_the_constraint_1: diag(2344, 1 /* Error */, "Type_0_does_not_satisfy_the_constraint_1_2344", "Type '{0}' does not satisfy the constraint '{1}'."),
	        Argument_of_type_0_is_not_assignable_to_parameter_of_type_1: diag(2345, 1 /* Error */, "Argument_of_type_0_is_not_assignable_to_parameter_of_type_1_2345", "Argument of type '{0}' is not assignable to parameter of type '{1}'."),
	        Untyped_function_calls_may_not_accept_type_arguments: diag(2347, 1 /* Error */, "Untyped_function_calls_may_not_accept_type_arguments_2347", "Untyped function calls may not accept type arguments."),
	        Value_of_type_0_is_not_callable_Did_you_mean_to_include_new: diag(2348, 1 /* Error */, "Value_of_type_0_is_not_callable_Did_you_mean_to_include_new_2348", "Value of type '{0}' is not callable. Did you mean to include 'new'?"),
	        This_expression_is_not_callable: diag(2349, 1 /* Error */, "This_expression_is_not_callable_2349", "This expression is not callable."),
	        Only_a_void_function_can_be_called_with_the_new_keyword: diag(2350, 1 /* Error */, "Only_a_void_function_can_be_called_with_the_new_keyword_2350", "Only a void function can be called with the 'new' keyword."),
	        This_expression_is_not_constructable: diag(2351, 1 /* Error */, "This_expression_is_not_constructable_2351", "This expression is not constructable."),
	        Conversion_of_type_0_to_type_1_may_be_a_mistake_because_neither_type_sufficiently_overlaps_with_the_other_If_this_was_intentional_convert_the_expression_to_unknown_first: diag(2352, 1 /* Error */, "Conversion_of_type_0_to_type_1_may_be_a_mistake_because_neither_type_sufficiently_overlaps_with_the__2352", "Conversion of type '{0}' to type '{1}' may be a mistake because neither type sufficiently overlaps with the other. If this was intentional, convert the expression to 'unknown' first."),
	        Object_literal_may_only_specify_known_properties_and_0_does_not_exist_in_type_1: diag(2353, 1 /* Error */, "Object_literal_may_only_specify_known_properties_and_0_does_not_exist_in_type_1_2353", "Object literal may only specify known properties, and '{0}' does not exist in type '{1}'."),
	        This_syntax_requires_an_imported_helper_but_module_0_cannot_be_found: diag(2354, 1 /* Error */, "This_syntax_requires_an_imported_helper_but_module_0_cannot_be_found_2354", "This syntax requires an imported helper but module '{0}' cannot be found."),
	        A_function_whose_declared_type_is_neither_undefined_void_nor_any_must_return_a_value: diag(2355, 1 /* Error */, "A_function_whose_declared_type_is_neither_undefined_void_nor_any_must_return_a_value_2355", "A function whose declared type is neither 'undefined', 'void', nor 'any' must return a value."),
	        An_arithmetic_operand_must_be_of_type_any_number_bigint_or_an_enum_type: diag(2356, 1 /* Error */, "An_arithmetic_operand_must_be_of_type_any_number_bigint_or_an_enum_type_2356", "An arithmetic operand must be of type 'any', 'number', 'bigint' or an enum type."),
	        The_operand_of_an_increment_or_decrement_operator_must_be_a_variable_or_a_property_access: diag(2357, 1 /* Error */, "The_operand_of_an_increment_or_decrement_operator_must_be_a_variable_or_a_property_access_2357", "The operand of an increment or decrement operator must be a variable or a property access."),
	        The_left_hand_side_of_an_instanceof_expression_must_be_of_type_any_an_object_type_or_a_type_parameter: diag(2358, 1 /* Error */, "The_left_hand_side_of_an_instanceof_expression_must_be_of_type_any_an_object_type_or_a_type_paramete_2358", "The left-hand side of an 'instanceof' expression must be of type 'any', an object type or a type parameter."),
	        The_right_hand_side_of_an_instanceof_expression_must_be_either_of_type_any_a_class_function_or_other_type_assignable_to_the_Function_interface_type_or_an_object_type_with_a_Symbol_hasInstance_method: diag(2359, 1 /* Error */, "The_right_hand_side_of_an_instanceof_expression_must_be_either_of_type_any_a_class_function_or_other_2359", "The right-hand side of an 'instanceof' expression must be either of type 'any', a class, function, or other type assignable to the 'Function' interface type, or an object type with a 'Symbol.hasInstance' method."),
	        The_left_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type: diag(2362, 1 /* Error */, "The_left_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type_2362", "The left-hand side of an arithmetic operation must be of type 'any', 'number', 'bigint' or an enum type."),
	        The_right_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type: diag(2363, 1 /* Error */, "The_right_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type_2363", "The right-hand side of an arithmetic operation must be of type 'any', 'number', 'bigint' or an enum type."),
	        The_left_hand_side_of_an_assignment_expression_must_be_a_variable_or_a_property_access: diag(2364, 1 /* Error */, "The_left_hand_side_of_an_assignment_expression_must_be_a_variable_or_a_property_access_2364", "The left-hand side of an assignment expression must be a variable or a property access."),
	        Operator_0_cannot_be_applied_to_types_1_and_2: diag(2365, 1 /* Error */, "Operator_0_cannot_be_applied_to_types_1_and_2_2365", "Operator '{0}' cannot be applied to types '{1}' and '{2}'."),
	        Function_lacks_ending_return_statement_and_return_type_does_not_include_undefined: diag(2366, 1 /* Error */, "Function_lacks_ending_return_statement_and_return_type_does_not_include_undefined_2366", "Function lacks ending return statement and return type does not include 'undefined'."),
	        This_comparison_appears_to_be_unintentional_because_the_types_0_and_1_have_no_overlap: diag(2367, 1 /* Error */, "This_comparison_appears_to_be_unintentional_because_the_types_0_and_1_have_no_overlap_2367", "This comparison appears to be unintentional because the types '{0}' and '{1}' have no overlap."),
	        Type_parameter_name_cannot_be_0: diag(2368, 1 /* Error */, "Type_parameter_name_cannot_be_0_2368", "Type parameter name cannot be '{0}'."),
	        A_parameter_property_is_only_allowed_in_a_constructor_implementation: diag(2369, 1 /* Error */, "A_parameter_property_is_only_allowed_in_a_constructor_implementation_2369", "A parameter property is only allowed in a constructor implementation."),
	        A_rest_parameter_must_be_of_an_array_type: diag(2370, 1 /* Error */, "A_rest_parameter_must_be_of_an_array_type_2370", "A rest parameter must be of an array type."),
	        A_parameter_initializer_is_only_allowed_in_a_function_or_constructor_implementation: diag(2371, 1 /* Error */, "A_parameter_initializer_is_only_allowed_in_a_function_or_constructor_implementation_2371", "A parameter initializer is only allowed in a function or constructor implementation."),
	        Parameter_0_cannot_reference_itself: diag(2372, 1 /* Error */, "Parameter_0_cannot_reference_itself_2372", "Parameter '{0}' cannot reference itself."),
	        Parameter_0_cannot_reference_identifier_1_declared_after_it: diag(2373, 1 /* Error */, "Parameter_0_cannot_reference_identifier_1_declared_after_it_2373", "Parameter '{0}' cannot reference identifier '{1}' declared after it."),
	        Duplicate_index_signature_for_type_0: diag(2374, 1 /* Error */, "Duplicate_index_signature_for_type_0_2374", "Duplicate index signature for type '{0}'."),
	        Type_0_is_not_assignable_to_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_types_of_the_target_s_properties: diag(2375, 1 /* Error */, "Type_0_is_not_assignable_to_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefi_2375", "Type '{0}' is not assignable to type '{1}' with 'exactOptionalPropertyTypes: true'. Consider adding 'undefined' to the types of the target's properties."),
	        A_super_call_must_be_the_first_statement_in_the_constructor_to_refer_to_super_or_this_when_a_derived_class_contains_initialized_properties_parameter_properties_or_private_identifiers: diag(2376, 1 /* Error */, "A_super_call_must_be_the_first_statement_in_the_constructor_to_refer_to_super_or_this_when_a_derived_2376", "A 'super' call must be the first statement in the constructor to refer to 'super' or 'this' when a derived class contains initialized properties, parameter properties, or private identifiers."),
	        Constructors_for_derived_classes_must_contain_a_super_call: diag(2377, 1 /* Error */, "Constructors_for_derived_classes_must_contain_a_super_call_2377", "Constructors for derived classes must contain a 'super' call."),
	        A_get_accessor_must_return_a_value: diag(2378, 1 /* Error */, "A_get_accessor_must_return_a_value_2378", "A 'get' accessor must return a value."),
	        Argument_of_type_0_is_not_assignable_to_parameter_of_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_types_of_the_target_s_properties: diag(2379, 1 /* Error */, "Argument_of_type_0_is_not_assignable_to_parameter_of_type_1_with_exactOptionalPropertyTypes_Colon_tr_2379", "Argument of type '{0}' is not assignable to parameter of type '{1}' with 'exactOptionalPropertyTypes: true'. Consider adding 'undefined' to the types of the target's properties."),
	        Overload_signatures_must_all_be_exported_or_non_exported: diag(2383, 1 /* Error */, "Overload_signatures_must_all_be_exported_or_non_exported_2383", "Overload signatures must all be exported or non-exported."),
	        Overload_signatures_must_all_be_ambient_or_non_ambient: diag(2384, 1 /* Error */, "Overload_signatures_must_all_be_ambient_or_non_ambient_2384", "Overload signatures must all be ambient or non-ambient."),
	        Overload_signatures_must_all_be_public_private_or_protected: diag(2385, 1 /* Error */, "Overload_signatures_must_all_be_public_private_or_protected_2385", "Overload signatures must all be public, private or protected."),
	        Overload_signatures_must_all_be_optional_or_required: diag(2386, 1 /* Error */, "Overload_signatures_must_all_be_optional_or_required_2386", "Overload signatures must all be optional or required."),
	        Function_overload_must_be_static: diag(2387, 1 /* Error */, "Function_overload_must_be_static_2387", "Function overload must be static."),
	        Function_overload_must_not_be_static: diag(2388, 1 /* Error */, "Function_overload_must_not_be_static_2388", "Function overload must not be static."),
	        Function_implementation_name_must_be_0: diag(2389, 1 /* Error */, "Function_implementation_name_must_be_0_2389", "Function implementation name must be '{0}'."),
	        Constructor_implementation_is_missing: diag(2390, 1 /* Error */, "Constructor_implementation_is_missing_2390", "Constructor implementation is missing."),
	        Function_implementation_is_missing_or_not_immediately_following_the_declaration: diag(2391, 1 /* Error */, "Function_implementation_is_missing_or_not_immediately_following_the_declaration_2391", "Function implementation is missing or not immediately following the declaration."),
	        Multiple_constructor_implementations_are_not_allowed: diag(2392, 1 /* Error */, "Multiple_constructor_implementations_are_not_allowed_2392", "Multiple constructor implementations are not allowed."),
	        Duplicate_function_implementation: diag(2393, 1 /* Error */, "Duplicate_function_implementation_2393", "Duplicate function implementation."),
	        This_overload_signature_is_not_compatible_with_its_implementation_signature: diag(2394, 1 /* Error */, "This_overload_signature_is_not_compatible_with_its_implementation_signature_2394", "This overload signature is not compatible with its implementation signature."),
	        Individual_declarations_in_merged_declaration_0_must_be_all_exported_or_all_local: diag(2395, 1 /* Error */, "Individual_declarations_in_merged_declaration_0_must_be_all_exported_or_all_local_2395", "Individual declarations in merged declaration '{0}' must be all exported or all local."),
	        Duplicate_identifier_arguments_Compiler_uses_arguments_to_initialize_rest_parameters: diag(2396, 1 /* Error */, "Duplicate_identifier_arguments_Compiler_uses_arguments_to_initialize_rest_parameters_2396", "Duplicate identifier 'arguments'. Compiler uses 'arguments' to initialize rest parameters."),
	        Declaration_name_conflicts_with_built_in_global_identifier_0: diag(2397, 1 /* Error */, "Declaration_name_conflicts_with_built_in_global_identifier_0_2397", "Declaration name conflicts with built-in global identifier '{0}'."),
	        constructor_cannot_be_used_as_a_parameter_property_name: diag(2398, 1 /* Error */, "constructor_cannot_be_used_as_a_parameter_property_name_2398", "'constructor' cannot be used as a parameter property name."),
	        Duplicate_identifier_this_Compiler_uses_variable_declaration_this_to_capture_this_reference: diag(2399, 1 /* Error */, "Duplicate_identifier_this_Compiler_uses_variable_declaration_this_to_capture_this_reference_2399", "Duplicate identifier '_this'. Compiler uses variable declaration '_this' to capture 'this' reference."),
	        Expression_resolves_to_variable_declaration_this_that_compiler_uses_to_capture_this_reference: diag(2400, 1 /* Error */, "Expression_resolves_to_variable_declaration_this_that_compiler_uses_to_capture_this_reference_2400", "Expression resolves to variable declaration '_this' that compiler uses to capture 'this' reference."),
	        A_super_call_must_be_a_root_level_statement_within_a_constructor_of_a_derived_class_that_contains_initialized_properties_parameter_properties_or_private_identifiers: diag(2401, 1 /* Error */, "A_super_call_must_be_a_root_level_statement_within_a_constructor_of_a_derived_class_that_contains_in_2401", "A 'super' call must be a root-level statement within a constructor of a derived class that contains initialized properties, parameter properties, or private identifiers."),
	        Expression_resolves_to_super_that_compiler_uses_to_capture_base_class_reference: diag(2402, 1 /* Error */, "Expression_resolves_to_super_that_compiler_uses_to_capture_base_class_reference_2402", "Expression resolves to '_super' that compiler uses to capture base class reference."),
	        Subsequent_variable_declarations_must_have_the_same_type_Variable_0_must_be_of_type_1_but_here_has_type_2: diag(2403, 1 /* Error */, "Subsequent_variable_declarations_must_have_the_same_type_Variable_0_must_be_of_type_1_but_here_has_t_2403", "Subsequent variable declarations must have the same type.  Variable '{0}' must be of type '{1}', but here has type '{2}'."),
	        The_left_hand_side_of_a_for_in_statement_cannot_use_a_type_annotation: diag(2404, 1 /* Error */, "The_left_hand_side_of_a_for_in_statement_cannot_use_a_type_annotation_2404", "The left-hand side of a 'for...in' statement cannot use a type annotation."),
	        The_left_hand_side_of_a_for_in_statement_must_be_of_type_string_or_any: diag(2405, 1 /* Error */, "The_left_hand_side_of_a_for_in_statement_must_be_of_type_string_or_any_2405", "The left-hand side of a 'for...in' statement must be of type 'string' or 'any'."),
	        The_left_hand_side_of_a_for_in_statement_must_be_a_variable_or_a_property_access: diag(2406, 1 /* Error */, "The_left_hand_side_of_a_for_in_statement_must_be_a_variable_or_a_property_access_2406", "The left-hand side of a 'for...in' statement must be a variable or a property access."),
	        The_right_hand_side_of_a_for_in_statement_must_be_of_type_any_an_object_type_or_a_type_parameter_but_here_has_type_0: diag(2407, 1 /* Error */, "The_right_hand_side_of_a_for_in_statement_must_be_of_type_any_an_object_type_or_a_type_parameter_but_2407", "The right-hand side of a 'for...in' statement must be of type 'any', an object type or a type parameter, but here has type '{0}'."),
	        Setters_cannot_return_a_value: diag(2408, 1 /* Error */, "Setters_cannot_return_a_value_2408", "Setters cannot return a value."),
	        Return_type_of_constructor_signature_must_be_assignable_to_the_instance_type_of_the_class: diag(2409, 1 /* Error */, "Return_type_of_constructor_signature_must_be_assignable_to_the_instance_type_of_the_class_2409", "Return type of constructor signature must be assignable to the instance type of the class."),
	        The_with_statement_is_not_supported_All_symbols_in_a_with_block_will_have_type_any: diag(2410, 1 /* Error */, "The_with_statement_is_not_supported_All_symbols_in_a_with_block_will_have_type_any_2410", "The 'with' statement is not supported. All symbols in a 'with' block will have type 'any'."),
	        Type_0_is_not_assignable_to_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_type_of_the_target: diag(2412, 1 /* Error */, "Type_0_is_not_assignable_to_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefi_2412", "Type '{0}' is not assignable to type '{1}' with 'exactOptionalPropertyTypes: true'. Consider adding 'undefined' to the type of the target."),
	        Property_0_of_type_1_is_not_assignable_to_2_index_type_3: diag(2411, 1 /* Error */, "Property_0_of_type_1_is_not_assignable_to_2_index_type_3_2411", "Property '{0}' of type '{1}' is not assignable to '{2}' index type '{3}'."),
	        _0_index_type_1_is_not_assignable_to_2_index_type_3: diag(2413, 1 /* Error */, "_0_index_type_1_is_not_assignable_to_2_index_type_3_2413", "'{0}' index type '{1}' is not assignable to '{2}' index type '{3}'."),
	        Class_name_cannot_be_0: diag(2414, 1 /* Error */, "Class_name_cannot_be_0_2414", "Class name cannot be '{0}'."),
	        Class_0_incorrectly_extends_base_class_1: diag(2415, 1 /* Error */, "Class_0_incorrectly_extends_base_class_1_2415", "Class '{0}' incorrectly extends base class '{1}'."),
	        Property_0_in_type_1_is_not_assignable_to_the_same_property_in_base_type_2: diag(2416, 1 /* Error */, "Property_0_in_type_1_is_not_assignable_to_the_same_property_in_base_type_2_2416", "Property '{0}' in type '{1}' is not assignable to the same property in base type '{2}'."),
	        Class_static_side_0_incorrectly_extends_base_class_static_side_1: diag(2417, 1 /* Error */, "Class_static_side_0_incorrectly_extends_base_class_static_side_1_2417", "Class static side '{0}' incorrectly extends base class static side '{1}'."),
	        Type_of_computed_property_s_value_is_0_which_is_not_assignable_to_type_1: diag(2418, 1 /* Error */, "Type_of_computed_property_s_value_is_0_which_is_not_assignable_to_type_1_2418", "Type of computed property's value is '{0}', which is not assignable to type '{1}'."),
	        Types_of_construct_signatures_are_incompatible: diag(2419, 1 /* Error */, "Types_of_construct_signatures_are_incompatible_2419", "Types of construct signatures are incompatible."),
	        Class_0_incorrectly_implements_interface_1: diag(2420, 1 /* Error */, "Class_0_incorrectly_implements_interface_1_2420", "Class '{0}' incorrectly implements interface '{1}'."),
	        A_class_can_only_implement_an_object_type_or_intersection_of_object_types_with_statically_known_members: diag(2422, 1 /* Error */, "A_class_can_only_implement_an_object_type_or_intersection_of_object_types_with_statically_known_memb_2422", "A class can only implement an object type or intersection of object types with statically known members."),
	        Class_0_defines_instance_member_function_1_but_extended_class_2_defines_it_as_instance_member_accessor: diag(2423, 1 /* Error */, "Class_0_defines_instance_member_function_1_but_extended_class_2_defines_it_as_instance_member_access_2423", "Class '{0}' defines instance member function '{1}', but extended class '{2}' defines it as instance member accessor."),
	        Class_0_defines_instance_member_property_1_but_extended_class_2_defines_it_as_instance_member_function: diag(2425, 1 /* Error */, "Class_0_defines_instance_member_property_1_but_extended_class_2_defines_it_as_instance_member_functi_2425", "Class '{0}' defines instance member property '{1}', but extended class '{2}' defines it as instance member function."),
	        Class_0_defines_instance_member_accessor_1_but_extended_class_2_defines_it_as_instance_member_function: diag(2426, 1 /* Error */, "Class_0_defines_instance_member_accessor_1_but_extended_class_2_defines_it_as_instance_member_functi_2426", "Class '{0}' defines instance member accessor '{1}', but extended class '{2}' defines it as instance member function."),
	        Interface_name_cannot_be_0: diag(2427, 1 /* Error */, "Interface_name_cannot_be_0_2427", "Interface name cannot be '{0}'."),
	        All_declarations_of_0_must_have_identical_type_parameters: diag(2428, 1 /* Error */, "All_declarations_of_0_must_have_identical_type_parameters_2428", "All declarations of '{0}' must have identical type parameters."),
	        Interface_0_incorrectly_extends_interface_1: diag(2430, 1 /* Error */, "Interface_0_incorrectly_extends_interface_1_2430", "Interface '{0}' incorrectly extends interface '{1}'."),
	        Enum_name_cannot_be_0: diag(2431, 1 /* Error */, "Enum_name_cannot_be_0_2431", "Enum name cannot be '{0}'."),
	        In_an_enum_with_multiple_declarations_only_one_declaration_can_omit_an_initializer_for_its_first_enum_element: diag(2432, 1 /* Error */, "In_an_enum_with_multiple_declarations_only_one_declaration_can_omit_an_initializer_for_its_first_enu_2432", "In an enum with multiple declarations, only one declaration can omit an initializer for its first enum element."),
	        A_namespace_declaration_cannot_be_in_a_different_file_from_a_class_or_function_with_which_it_is_merged: diag(2433, 1 /* Error */, "A_namespace_declaration_cannot_be_in_a_different_file_from_a_class_or_function_with_which_it_is_merg_2433", "A namespace declaration cannot be in a different file from a class or function with which it is merged."),
	        A_namespace_declaration_cannot_be_located_prior_to_a_class_or_function_with_which_it_is_merged: diag(2434, 1 /* Error */, "A_namespace_declaration_cannot_be_located_prior_to_a_class_or_function_with_which_it_is_merged_2434", "A namespace declaration cannot be located prior to a class or function with which it is merged."),
	        Ambient_modules_cannot_be_nested_in_other_modules_or_namespaces: diag(2435, 1 /* Error */, "Ambient_modules_cannot_be_nested_in_other_modules_or_namespaces_2435", "Ambient modules cannot be nested in other modules or namespaces."),
	        Ambient_module_declaration_cannot_specify_relative_module_name: diag(2436, 1 /* Error */, "Ambient_module_declaration_cannot_specify_relative_module_name_2436", "Ambient module declaration cannot specify relative module name."),
	        Module_0_is_hidden_by_a_local_declaration_with_the_same_name: diag(2437, 1 /* Error */, "Module_0_is_hidden_by_a_local_declaration_with_the_same_name_2437", "Module '{0}' is hidden by a local declaration with the same name."),
	        Import_name_cannot_be_0: diag(2438, 1 /* Error */, "Import_name_cannot_be_0_2438", "Import name cannot be '{0}'."),
	        Import_or_export_declaration_in_an_ambient_module_declaration_cannot_reference_module_through_relative_module_name: diag(2439, 1 /* Error */, "Import_or_export_declaration_in_an_ambient_module_declaration_cannot_reference_module_through_relati_2439", "Import or export declaration in an ambient module declaration cannot reference module through relative module name."),
	        Import_declaration_conflicts_with_local_declaration_of_0: diag(2440, 1 /* Error */, "Import_declaration_conflicts_with_local_declaration_of_0_2440", "Import declaration conflicts with local declaration of '{0}'."),
	        Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module: diag(2441, 1 /* Error */, "Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module_2441", "Duplicate identifier '{0}'. Compiler reserves name '{1}' in top level scope of a module."),
	        Types_have_separate_declarations_of_a_private_property_0: diag(2442, 1 /* Error */, "Types_have_separate_declarations_of_a_private_property_0_2442", "Types have separate declarations of a private property '{0}'."),
	        Property_0_is_protected_but_type_1_is_not_a_class_derived_from_2: diag(2443, 1 /* Error */, "Property_0_is_protected_but_type_1_is_not_a_class_derived_from_2_2443", "Property '{0}' is protected but type '{1}' is not a class derived from '{2}'."),
	        Property_0_is_protected_in_type_1_but_public_in_type_2: diag(2444, 1 /* Error */, "Property_0_is_protected_in_type_1_but_public_in_type_2_2444", "Property '{0}' is protected in type '{1}' but public in type '{2}'."),
	        Property_0_is_protected_and_only_accessible_within_class_1_and_its_subclasses: diag(2445, 1 /* Error */, "Property_0_is_protected_and_only_accessible_within_class_1_and_its_subclasses_2445", "Property '{0}' is protected and only accessible within class '{1}' and its subclasses."),
	        Property_0_is_protected_and_only_accessible_through_an_instance_of_class_1_This_is_an_instance_of_class_2: diag(2446, 1 /* Error */, "Property_0_is_protected_and_only_accessible_through_an_instance_of_class_1_This_is_an_instance_of_cl_2446", "Property '{0}' is protected and only accessible through an instance of class '{1}'. This is an instance of class '{2}'."),
	        The_0_operator_is_not_allowed_for_boolean_types_Consider_using_1_instead: diag(2447, 1 /* Error */, "The_0_operator_is_not_allowed_for_boolean_types_Consider_using_1_instead_2447", "The '{0}' operator is not allowed for boolean types. Consider using '{1}' instead."),
	        Block_scoped_variable_0_used_before_its_declaration: diag(2448, 1 /* Error */, "Block_scoped_variable_0_used_before_its_declaration_2448", "Block-scoped variable '{0}' used before its declaration."),
	        Class_0_used_before_its_declaration: diag(2449, 1 /* Error */, "Class_0_used_before_its_declaration_2449", "Class '{0}' used before its declaration."),
	        Enum_0_used_before_its_declaration: diag(2450, 1 /* Error */, "Enum_0_used_before_its_declaration_2450", "Enum '{0}' used before its declaration."),
	        Cannot_redeclare_block_scoped_variable_0: diag(2451, 1 /* Error */, "Cannot_redeclare_block_scoped_variable_0_2451", "Cannot redeclare block-scoped variable '{0}'."),
	        An_enum_member_cannot_have_a_numeric_name: diag(2452, 1 /* Error */, "An_enum_member_cannot_have_a_numeric_name_2452", "An enum member cannot have a numeric name."),
	        Variable_0_is_used_before_being_assigned: diag(2454, 1 /* Error */, "Variable_0_is_used_before_being_assigned_2454", "Variable '{0}' is used before being assigned."),
	        Type_alias_0_circularly_references_itself: diag(2456, 1 /* Error */, "Type_alias_0_circularly_references_itself_2456", "Type alias '{0}' circularly references itself."),
	        Type_alias_name_cannot_be_0: diag(2457, 1 /* Error */, "Type_alias_name_cannot_be_0_2457", "Type alias name cannot be '{0}'."),
	        An_AMD_module_cannot_have_multiple_name_assignments: diag(2458, 1 /* Error */, "An_AMD_module_cannot_have_multiple_name_assignments_2458", "An AMD module cannot have multiple name assignments."),
	        Module_0_declares_1_locally_but_it_is_not_exported: diag(2459, 1 /* Error */, "Module_0_declares_1_locally_but_it_is_not_exported_2459", "Module '{0}' declares '{1}' locally, but it is not exported."),
	        Module_0_declares_1_locally_but_it_is_exported_as_2: diag(2460, 1 /* Error */, "Module_0_declares_1_locally_but_it_is_exported_as_2_2460", "Module '{0}' declares '{1}' locally, but it is exported as '{2}'."),
	        Type_0_is_not_an_array_type: diag(2461, 1 /* Error */, "Type_0_is_not_an_array_type_2461", "Type '{0}' is not an array type."),
	        A_rest_element_must_be_last_in_a_destructuring_pattern: diag(2462, 1 /* Error */, "A_rest_element_must_be_last_in_a_destructuring_pattern_2462", "A rest element must be last in a destructuring pattern."),
	        A_binding_pattern_parameter_cannot_be_optional_in_an_implementation_signature: diag(2463, 1 /* Error */, "A_binding_pattern_parameter_cannot_be_optional_in_an_implementation_signature_2463", "A binding pattern parameter cannot be optional in an implementation signature."),
	        A_computed_property_name_must_be_of_type_string_number_symbol_or_any: diag(2464, 1 /* Error */, "A_computed_property_name_must_be_of_type_string_number_symbol_or_any_2464", "A computed property name must be of type 'string', 'number', 'symbol', or 'any'."),
	        this_cannot_be_referenced_in_a_computed_property_name: diag(2465, 1 /* Error */, "this_cannot_be_referenced_in_a_computed_property_name_2465", "'this' cannot be referenced in a computed property name."),
	        super_cannot_be_referenced_in_a_computed_property_name: diag(2466, 1 /* Error */, "super_cannot_be_referenced_in_a_computed_property_name_2466", "'super' cannot be referenced in a computed property name."),
	        A_computed_property_name_cannot_reference_a_type_parameter_from_its_containing_type: diag(2467, 1 /* Error */, "A_computed_property_name_cannot_reference_a_type_parameter_from_its_containing_type_2467", "A computed property name cannot reference a type parameter from its containing type."),
	        Cannot_find_global_value_0: diag(2468, 1 /* Error */, "Cannot_find_global_value_0_2468", "Cannot find global value '{0}'."),
	        The_0_operator_cannot_be_applied_to_type_symbol: diag(2469, 1 /* Error */, "The_0_operator_cannot_be_applied_to_type_symbol_2469", "The '{0}' operator cannot be applied to type 'symbol'."),
	        Spread_operator_in_new_expressions_is_only_available_when_targeting_ECMAScript_5_and_higher: diag(2472, 1 /* Error */, "Spread_operator_in_new_expressions_is_only_available_when_targeting_ECMAScript_5_and_higher_2472", "Spread operator in 'new' expressions is only available when targeting ECMAScript 5 and higher."),
	        Enum_declarations_must_all_be_const_or_non_const: diag(2473, 1 /* Error */, "Enum_declarations_must_all_be_const_or_non_const_2473", "Enum declarations must all be const or non-const."),
	        const_enum_member_initializers_must_be_constant_expressions: diag(2474, 1 /* Error */, "const_enum_member_initializers_must_be_constant_expressions_2474", "const enum member initializers must be constant expressions."),
	        const_enums_can_only_be_used_in_property_or_index_access_expressions_or_the_right_hand_side_of_an_import_declaration_or_export_assignment_or_type_query: diag(2475, 1 /* Error */, "const_enums_can_only_be_used_in_property_or_index_access_expressions_or_the_right_hand_side_of_an_im_2475", "'const' enums can only be used in property or index access expressions or the right hand side of an import declaration or export assignment or type query."),
	        A_const_enum_member_can_only_be_accessed_using_a_string_literal: diag(2476, 1 /* Error */, "A_const_enum_member_can_only_be_accessed_using_a_string_literal_2476", "A const enum member can only be accessed using a string literal."),
	        const_enum_member_initializer_was_evaluated_to_a_non_finite_value: diag(2477, 1 /* Error */, "const_enum_member_initializer_was_evaluated_to_a_non_finite_value_2477", "'const' enum member initializer was evaluated to a non-finite value."),
	        const_enum_member_initializer_was_evaluated_to_disallowed_value_NaN: diag(2478, 1 /* Error */, "const_enum_member_initializer_was_evaluated_to_disallowed_value_NaN_2478", "'const' enum member initializer was evaluated to disallowed value 'NaN'."),
	        let_is_not_allowed_to_be_used_as_a_name_in_let_or_const_declarations: diag(2480, 1 /* Error */, "let_is_not_allowed_to_be_used_as_a_name_in_let_or_const_declarations_2480", "'let' is not allowed to be used as a name in 'let' or 'const' declarations."),
	        Cannot_initialize_outer_scoped_variable_0_in_the_same_scope_as_block_scoped_declaration_1: diag(2481, 1 /* Error */, "Cannot_initialize_outer_scoped_variable_0_in_the_same_scope_as_block_scoped_declaration_1_2481", "Cannot initialize outer scoped variable '{0}' in the same scope as block scoped declaration '{1}'."),
	        The_left_hand_side_of_a_for_of_statement_cannot_use_a_type_annotation: diag(2483, 1 /* Error */, "The_left_hand_side_of_a_for_of_statement_cannot_use_a_type_annotation_2483", "The left-hand side of a 'for...of' statement cannot use a type annotation."),
	        Export_declaration_conflicts_with_exported_declaration_of_0: diag(2484, 1 /* Error */, "Export_declaration_conflicts_with_exported_declaration_of_0_2484", "Export declaration conflicts with exported declaration of '{0}'."),
	        The_left_hand_side_of_a_for_of_statement_must_be_a_variable_or_a_property_access: diag(2487, 1 /* Error */, "The_left_hand_side_of_a_for_of_statement_must_be_a_variable_or_a_property_access_2487", "The left-hand side of a 'for...of' statement must be a variable or a property access."),
	        Type_0_must_have_a_Symbol_iterator_method_that_returns_an_iterator: diag(2488, 1 /* Error */, "Type_0_must_have_a_Symbol_iterator_method_that_returns_an_iterator_2488", "Type '{0}' must have a '[Symbol.iterator]()' method that returns an iterator."),
	        An_iterator_must_have_a_next_method: diag(2489, 1 /* Error */, "An_iterator_must_have_a_next_method_2489", "An iterator must have a 'next()' method."),
	        The_type_returned_by_the_0_method_of_an_iterator_must_have_a_value_property: diag(2490, 1 /* Error */, "The_type_returned_by_the_0_method_of_an_iterator_must_have_a_value_property_2490", "The type returned by the '{0}()' method of an iterator must have a 'value' property."),
	        The_left_hand_side_of_a_for_in_statement_cannot_be_a_destructuring_pattern: diag(2491, 1 /* Error */, "The_left_hand_side_of_a_for_in_statement_cannot_be_a_destructuring_pattern_2491", "The left-hand side of a 'for...in' statement cannot be a destructuring pattern."),
	        Cannot_redeclare_identifier_0_in_catch_clause: diag(2492, 1 /* Error */, "Cannot_redeclare_identifier_0_in_catch_clause_2492", "Cannot redeclare identifier '{0}' in catch clause."),
	        Tuple_type_0_of_length_1_has_no_element_at_index_2: diag(2493, 1 /* Error */, "Tuple_type_0_of_length_1_has_no_element_at_index_2_2493", "Tuple type '{0}' of length '{1}' has no element at index '{2}'."),
	        Using_a_string_in_a_for_of_statement_is_only_supported_in_ECMAScript_5_and_higher: diag(2494, 1 /* Error */, "Using_a_string_in_a_for_of_statement_is_only_supported_in_ECMAScript_5_and_higher_2494", "Using a string in a 'for...of' statement is only supported in ECMAScript 5 and higher."),
	        Type_0_is_not_an_array_type_or_a_string_type: diag(2495, 1 /* Error */, "Type_0_is_not_an_array_type_or_a_string_type_2495", "Type '{0}' is not an array type or a string type."),
	        The_arguments_object_cannot_be_referenced_in_an_arrow_function_in_ES3_and_ES5_Consider_using_a_standard_function_expression: diag(2496, 1 /* Error */, "The_arguments_object_cannot_be_referenced_in_an_arrow_function_in_ES3_and_ES5_Consider_using_a_stand_2496", "The 'arguments' object cannot be referenced in an arrow function in ES3 and ES5. Consider using a standard function expression."),
	        This_module_can_only_be_referenced_with_ECMAScript_imports_Slashexports_by_turning_on_the_0_flag_and_referencing_its_default_export: diag(2497, 1 /* Error */, "This_module_can_only_be_referenced_with_ECMAScript_imports_Slashexports_by_turning_on_the_0_flag_and_2497", "This module can only be referenced with ECMAScript imports/exports by turning on the '{0}' flag and referencing its default export."),
	        Module_0_uses_export_and_cannot_be_used_with_export_Asterisk: diag(2498, 1 /* Error */, "Module_0_uses_export_and_cannot_be_used_with_export_Asterisk_2498", "Module '{0}' uses 'export =' and cannot be used with 'export *'."),
	        An_interface_can_only_extend_an_identifier_Slashqualified_name_with_optional_type_arguments: diag(2499, 1 /* Error */, "An_interface_can_only_extend_an_identifier_Slashqualified_name_with_optional_type_arguments_2499", "An interface can only extend an identifier/qualified-name with optional type arguments."),
	        A_class_can_only_implement_an_identifier_Slashqualified_name_with_optional_type_arguments: diag(2500, 1 /* Error */, "A_class_can_only_implement_an_identifier_Slashqualified_name_with_optional_type_arguments_2500", "A class can only implement an identifier/qualified-name with optional type arguments."),
	        A_rest_element_cannot_contain_a_binding_pattern: diag(2501, 1 /* Error */, "A_rest_element_cannot_contain_a_binding_pattern_2501", "A rest element cannot contain a binding pattern."),
	        _0_is_referenced_directly_or_indirectly_in_its_own_type_annotation: diag(2502, 1 /* Error */, "_0_is_referenced_directly_or_indirectly_in_its_own_type_annotation_2502", "'{0}' is referenced directly or indirectly in its own type annotation."),
	        Cannot_find_namespace_0: diag(2503, 1 /* Error */, "Cannot_find_namespace_0_2503", "Cannot find namespace '{0}'."),
	        Type_0_must_have_a_Symbol_asyncIterator_method_that_returns_an_async_iterator: diag(2504, 1 /* Error */, "Type_0_must_have_a_Symbol_asyncIterator_method_that_returns_an_async_iterator_2504", "Type '{0}' must have a '[Symbol.asyncIterator]()' method that returns an async iterator."),
	        A_generator_cannot_have_a_void_type_annotation: diag(2505, 1 /* Error */, "A_generator_cannot_have_a_void_type_annotation_2505", "A generator cannot have a 'void' type annotation."),
	        _0_is_referenced_directly_or_indirectly_in_its_own_base_expression: diag(2506, 1 /* Error */, "_0_is_referenced_directly_or_indirectly_in_its_own_base_expression_2506", "'{0}' is referenced directly or indirectly in its own base expression."),
	        Type_0_is_not_a_constructor_function_type: diag(2507, 1 /* Error */, "Type_0_is_not_a_constructor_function_type_2507", "Type '{0}' is not a constructor function type."),
	        No_base_constructor_has_the_specified_number_of_type_arguments: diag(2508, 1 /* Error */, "No_base_constructor_has_the_specified_number_of_type_arguments_2508", "No base constructor has the specified number of type arguments."),
	        Base_constructor_return_type_0_is_not_an_object_type_or_intersection_of_object_types_with_statically_known_members: diag(2509, 1 /* Error */, "Base_constructor_return_type_0_is_not_an_object_type_or_intersection_of_object_types_with_statically_2509", "Base constructor return type '{0}' is not an object type or intersection of object types with statically known members."),
	        Base_constructors_must_all_have_the_same_return_type: diag(2510, 1 /* Error */, "Base_constructors_must_all_have_the_same_return_type_2510", "Base constructors must all have the same return type."),
	        Cannot_create_an_instance_of_an_abstract_class: diag(2511, 1 /* Error */, "Cannot_create_an_instance_of_an_abstract_class_2511", "Cannot create an instance of an abstract class."),
	        Overload_signatures_must_all_be_abstract_or_non_abstract: diag(2512, 1 /* Error */, "Overload_signatures_must_all_be_abstract_or_non_abstract_2512", "Overload signatures must all be abstract or non-abstract."),
	        Abstract_method_0_in_class_1_cannot_be_accessed_via_super_expression: diag(2513, 1 /* Error */, "Abstract_method_0_in_class_1_cannot_be_accessed_via_super_expression_2513", "Abstract method '{0}' in class '{1}' cannot be accessed via super expression."),
	        A_tuple_type_cannot_be_indexed_with_a_negative_value: diag(2514, 1 /* Error */, "A_tuple_type_cannot_be_indexed_with_a_negative_value_2514", "A tuple type cannot be indexed with a negative value."),
	        Non_abstract_class_0_does_not_implement_inherited_abstract_member_1_from_class_2: diag(2515, 1 /* Error */, "Non_abstract_class_0_does_not_implement_inherited_abstract_member_1_from_class_2_2515", "Non-abstract class '{0}' does not implement inherited abstract member '{1}' from class '{2}'."),
	        All_declarations_of_an_abstract_method_must_be_consecutive: diag(2516, 1 /* Error */, "All_declarations_of_an_abstract_method_must_be_consecutive_2516", "All declarations of an abstract method must be consecutive."),
	        Cannot_assign_an_abstract_constructor_type_to_a_non_abstract_constructor_type: diag(2517, 1 /* Error */, "Cannot_assign_an_abstract_constructor_type_to_a_non_abstract_constructor_type_2517", "Cannot assign an abstract constructor type to a non-abstract constructor type."),
	        A_this_based_type_guard_is_not_compatible_with_a_parameter_based_type_guard: diag(2518, 1 /* Error */, "A_this_based_type_guard_is_not_compatible_with_a_parameter_based_type_guard_2518", "A 'this'-based type guard is not compatible with a parameter-based type guard."),
	        An_async_iterator_must_have_a_next_method: diag(2519, 1 /* Error */, "An_async_iterator_must_have_a_next_method_2519", "An async iterator must have a 'next()' method."),
	        Duplicate_identifier_0_Compiler_uses_declaration_1_to_support_async_functions: diag(2520, 1 /* Error */, "Duplicate_identifier_0_Compiler_uses_declaration_1_to_support_async_functions_2520", "Duplicate identifier '{0}'. Compiler uses declaration '{1}' to support async functions."),
	        The_arguments_object_cannot_be_referenced_in_an_async_function_or_method_in_ES3_and_ES5_Consider_using_a_standard_function_or_method: diag(2522, 1 /* Error */, "The_arguments_object_cannot_be_referenced_in_an_async_function_or_method_in_ES3_and_ES5_Consider_usi_2522", "The 'arguments' object cannot be referenced in an async function or method in ES3 and ES5. Consider using a standard function or method."),
	        yield_expressions_cannot_be_used_in_a_parameter_initializer: diag(2523, 1 /* Error */, "yield_expressions_cannot_be_used_in_a_parameter_initializer_2523", "'yield' expressions cannot be used in a parameter initializer."),
	        await_expressions_cannot_be_used_in_a_parameter_initializer: diag(2524, 1 /* Error */, "await_expressions_cannot_be_used_in_a_parameter_initializer_2524", "'await' expressions cannot be used in a parameter initializer."),
	        Initializer_provides_no_value_for_this_binding_element_and_the_binding_element_has_no_default_value: diag(2525, 1 /* Error */, "Initializer_provides_no_value_for_this_binding_element_and_the_binding_element_has_no_default_value_2525", "Initializer provides no value for this binding element and the binding element has no default value."),
	        A_this_type_is_available_only_in_a_non_static_member_of_a_class_or_interface: diag(2526, 1 /* Error */, "A_this_type_is_available_only_in_a_non_static_member_of_a_class_or_interface_2526", "A 'this' type is available only in a non-static member of a class or interface."),
	        The_inferred_type_of_0_references_an_inaccessible_1_type_A_type_annotation_is_necessary: diag(2527, 1 /* Error */, "The_inferred_type_of_0_references_an_inaccessible_1_type_A_type_annotation_is_necessary_2527", "The inferred type of '{0}' references an inaccessible '{1}' type. A type annotation is necessary."),
	        A_module_cannot_have_multiple_default_exports: diag(2528, 1 /* Error */, "A_module_cannot_have_multiple_default_exports_2528", "A module cannot have multiple default exports."),
	        Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module_containing_async_functions: diag(2529, 1 /* Error */, "Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module_containing_async_func_2529", "Duplicate identifier '{0}'. Compiler reserves name '{1}' in top level scope of a module containing async functions."),
	        Property_0_is_incompatible_with_index_signature: diag(2530, 1 /* Error */, "Property_0_is_incompatible_with_index_signature_2530", "Property '{0}' is incompatible with index signature."),
	        Object_is_possibly_null: diag(2531, 1 /* Error */, "Object_is_possibly_null_2531", "Object is possibly 'null'."),
	        Object_is_possibly_undefined: diag(2532, 1 /* Error */, "Object_is_possibly_undefined_2532", "Object is possibly 'undefined'."),
	        Object_is_possibly_null_or_undefined: diag(2533, 1 /* Error */, "Object_is_possibly_null_or_undefined_2533", "Object is possibly 'null' or 'undefined'."),
	        A_function_returning_never_cannot_have_a_reachable_end_point: diag(2534, 1 /* Error */, "A_function_returning_never_cannot_have_a_reachable_end_point_2534", "A function returning 'never' cannot have a reachable end point."),
	        Type_0_cannot_be_used_to_index_type_1: diag(2536, 1 /* Error */, "Type_0_cannot_be_used_to_index_type_1_2536", "Type '{0}' cannot be used to index type '{1}'."),
	        Type_0_has_no_matching_index_signature_for_type_1: diag(2537, 1 /* Error */, "Type_0_has_no_matching_index_signature_for_type_1_2537", "Type '{0}' has no matching index signature for type '{1}'."),
	        Type_0_cannot_be_used_as_an_index_type: diag(2538, 1 /* Error */, "Type_0_cannot_be_used_as_an_index_type_2538", "Type '{0}' cannot be used as an index type."),
	        Cannot_assign_to_0_because_it_is_not_a_variable: diag(2539, 1 /* Error */, "Cannot_assign_to_0_because_it_is_not_a_variable_2539", "Cannot assign to '{0}' because it is not a variable."),
	        Cannot_assign_to_0_because_it_is_a_read_only_property: diag(2540, 1 /* Error */, "Cannot_assign_to_0_because_it_is_a_read_only_property_2540", "Cannot assign to '{0}' because it is a read-only property."),
	        Index_signature_in_type_0_only_permits_reading: diag(2542, 1 /* Error */, "Index_signature_in_type_0_only_permits_reading_2542", "Index signature in type '{0}' only permits reading."),
	        Duplicate_identifier_newTarget_Compiler_uses_variable_declaration_newTarget_to_capture_new_target_meta_property_reference: diag(2543, 1 /* Error */, "Duplicate_identifier_newTarget_Compiler_uses_variable_declaration_newTarget_to_capture_new_target_me_2543", "Duplicate identifier '_newTarget'. Compiler uses variable declaration '_newTarget' to capture 'new.target' meta-property reference."),
	        Expression_resolves_to_variable_declaration_newTarget_that_compiler_uses_to_capture_new_target_meta_property_reference: diag(2544, 1 /* Error */, "Expression_resolves_to_variable_declaration_newTarget_that_compiler_uses_to_capture_new_target_meta__2544", "Expression resolves to variable declaration '_newTarget' that compiler uses to capture 'new.target' meta-property reference."),
	        A_mixin_class_must_have_a_constructor_with_a_single_rest_parameter_of_type_any: diag(2545, 1 /* Error */, "A_mixin_class_must_have_a_constructor_with_a_single_rest_parameter_of_type_any_2545", "A mixin class must have a constructor with a single rest parameter of type 'any[]'."),
	        The_type_returned_by_the_0_method_of_an_async_iterator_must_be_a_promise_for_a_type_with_a_value_property: diag(2547, 1 /* Error */, "The_type_returned_by_the_0_method_of_an_async_iterator_must_be_a_promise_for_a_type_with_a_value_pro_2547", "The type returned by the '{0}()' method of an async iterator must be a promise for a type with a 'value' property."),
	        Type_0_is_not_an_array_type_or_does_not_have_a_Symbol_iterator_method_that_returns_an_iterator: diag(2548, 1 /* Error */, "Type_0_is_not_an_array_type_or_does_not_have_a_Symbol_iterator_method_that_returns_an_iterator_2548", "Type '{0}' is not an array type or does not have a '[Symbol.iterator]()' method that returns an iterator."),
	        Type_0_is_not_an_array_type_or_a_string_type_or_does_not_have_a_Symbol_iterator_method_that_returns_an_iterator: diag(2549, 1 /* Error */, "Type_0_is_not_an_array_type_or_a_string_type_or_does_not_have_a_Symbol_iterator_method_that_returns__2549", "Type '{0}' is not an array type or a string type or does not have a '[Symbol.iterator]()' method that returns an iterator."),
	        Property_0_does_not_exist_on_type_1_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_2_or_later: diag(2550, 1 /* Error */, "Property_0_does_not_exist_on_type_1_Do_you_need_to_change_your_target_library_Try_changing_the_lib_c_2550", "Property '{0}' does not exist on type '{1}'. Do you need to change your target library? Try changing the 'lib' compiler option to '{2}' or later."),
	        Property_0_does_not_exist_on_type_1_Did_you_mean_2: diag(2551, 1 /* Error */, "Property_0_does_not_exist_on_type_1_Did_you_mean_2_2551", "Property '{0}' does not exist on type '{1}'. Did you mean '{2}'?"),
	        Cannot_find_name_0_Did_you_mean_1: diag(2552, 1 /* Error */, "Cannot_find_name_0_Did_you_mean_1_2552", "Cannot find name '{0}'. Did you mean '{1}'?"),
	        Computed_values_are_not_permitted_in_an_enum_with_string_valued_members: diag(2553, 1 /* Error */, "Computed_values_are_not_permitted_in_an_enum_with_string_valued_members_2553", "Computed values are not permitted in an enum with string valued members."),
	        Expected_0_arguments_but_got_1: diag(2554, 1 /* Error */, "Expected_0_arguments_but_got_1_2554", "Expected {0} arguments, but got {1}."),
	        Expected_at_least_0_arguments_but_got_1: diag(2555, 1 /* Error */, "Expected_at_least_0_arguments_but_got_1_2555", "Expected at least {0} arguments, but got {1}."),
	        A_spread_argument_must_either_have_a_tuple_type_or_be_passed_to_a_rest_parameter: diag(2556, 1 /* Error */, "A_spread_argument_must_either_have_a_tuple_type_or_be_passed_to_a_rest_parameter_2556", "A spread argument must either have a tuple type or be passed to a rest parameter."),
	        Expected_0_type_arguments_but_got_1: diag(2558, 1 /* Error */, "Expected_0_type_arguments_but_got_1_2558", "Expected {0} type arguments, but got {1}."),
	        Type_0_has_no_properties_in_common_with_type_1: diag(2559, 1 /* Error */, "Type_0_has_no_properties_in_common_with_type_1_2559", "Type '{0}' has no properties in common with type '{1}'."),
	        Value_of_type_0_has_no_properties_in_common_with_type_1_Did_you_mean_to_call_it: diag(2560, 1 /* Error */, "Value_of_type_0_has_no_properties_in_common_with_type_1_Did_you_mean_to_call_it_2560", "Value of type '{0}' has no properties in common with type '{1}'. Did you mean to call it?"),
	        Object_literal_may_only_specify_known_properties_but_0_does_not_exist_in_type_1_Did_you_mean_to_write_2: diag(2561, 1 /* Error */, "Object_literal_may_only_specify_known_properties_but_0_does_not_exist_in_type_1_Did_you_mean_to_writ_2561", "Object literal may only specify known properties, but '{0}' does not exist in type '{1}'. Did you mean to write '{2}'?"),
	        Base_class_expressions_cannot_reference_class_type_parameters: diag(2562, 1 /* Error */, "Base_class_expressions_cannot_reference_class_type_parameters_2562", "Base class expressions cannot reference class type parameters."),
	        The_containing_function_or_module_body_is_too_large_for_control_flow_analysis: diag(2563, 1 /* Error */, "The_containing_function_or_module_body_is_too_large_for_control_flow_analysis_2563", "The containing function or module body is too large for control flow analysis."),
	        Property_0_has_no_initializer_and_is_not_definitely_assigned_in_the_constructor: diag(2564, 1 /* Error */, "Property_0_has_no_initializer_and_is_not_definitely_assigned_in_the_constructor_2564", "Property '{0}' has no initializer and is not definitely assigned in the constructor."),
	        Property_0_is_used_before_being_assigned: diag(2565, 1 /* Error */, "Property_0_is_used_before_being_assigned_2565", "Property '{0}' is used before being assigned."),
	        A_rest_element_cannot_have_a_property_name: diag(2566, 1 /* Error */, "A_rest_element_cannot_have_a_property_name_2566", "A rest element cannot have a property name."),
	        Enum_declarations_can_only_merge_with_namespace_or_other_enum_declarations: diag(2567, 1 /* Error */, "Enum_declarations_can_only_merge_with_namespace_or_other_enum_declarations_2567", "Enum declarations can only merge with namespace or other enum declarations."),
	        Property_0_may_not_exist_on_type_1_Did_you_mean_2: diag(2568, 1 /* Error */, "Property_0_may_not_exist_on_type_1_Did_you_mean_2_2568", "Property '{0}' may not exist on type '{1}'. Did you mean '{2}'?"),
	        Could_not_find_name_0_Did_you_mean_1: diag(2570, 1 /* Error */, "Could_not_find_name_0_Did_you_mean_1_2570", "Could not find name '{0}'. Did you mean '{1}'?"),
	        Object_is_of_type_unknown: diag(2571, 1 /* Error */, "Object_is_of_type_unknown_2571", "Object is of type 'unknown'."),
	        A_rest_element_type_must_be_an_array_type: diag(2574, 1 /* Error */, "A_rest_element_type_must_be_an_array_type_2574", "A rest element type must be an array type."),
	        No_overload_expects_0_arguments_but_overloads_do_exist_that_expect_either_1_or_2_arguments: diag(2575, 1 /* Error */, "No_overload_expects_0_arguments_but_overloads_do_exist_that_expect_either_1_or_2_arguments_2575", "No overload expects {0} arguments, but overloads do exist that expect either {1} or {2} arguments."),
	        Property_0_does_not_exist_on_type_1_Did_you_mean_to_access_the_static_member_2_instead: diag(2576, 1 /* Error */, "Property_0_does_not_exist_on_type_1_Did_you_mean_to_access_the_static_member_2_instead_2576", "Property '{0}' does not exist on type '{1}'. Did you mean to access the static member '{2}' instead?"),
	        Return_type_annotation_circularly_references_itself: diag(2577, 1 /* Error */, "Return_type_annotation_circularly_references_itself_2577", "Return type annotation circularly references itself."),
	        Unused_ts_expect_error_directive: diag(2578, 1 /* Error */, "Unused_ts_expect_error_directive_2578", "Unused '@ts-expect-error' directive."),
	        Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_node_Try_npm_i_save_dev_types_Slashnode: diag(2580, 1 /* Error */, "Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_node_Try_npm_i_save_dev_types_Slashno_2580", "Cannot find name '{0}'. Do you need to install type definitions for node? Try `npm i --save-dev @types/node`."),
	        Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_jQuery_Try_npm_i_save_dev_types_Slashjquery: diag(2581, 1 /* Error */, "Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_jQuery_Try_npm_i_save_dev_types_Slash_2581", "Cannot find name '{0}'. Do you need to install type definitions for jQuery? Try `npm i --save-dev @types/jquery`."),
	        Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_a_test_runner_Try_npm_i_save_dev_types_Slashjest_or_npm_i_save_dev_types_Slashmocha: diag(2582, 1 /* Error */, "Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_a_test_runner_Try_npm_i_save_dev_type_2582", "Cannot find name '{0}'. Do you need to install type definitions for a test runner? Try `npm i --save-dev @types/jest` or `npm i --save-dev @types/mocha`."),
	        Cannot_find_name_0_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_1_or_later: diag(2583, 1 /* Error */, "Cannot_find_name_0_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_2583", "Cannot find name '{0}'. Do you need to change your target library? Try changing the 'lib' compiler option to '{1}' or later."),
	        Cannot_find_name_0_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_include_dom: diag(2584, 1 /* Error */, "Cannot_find_name_0_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_2584", "Cannot find name '{0}'. Do you need to change your target library? Try changing the 'lib' compiler option to include 'dom'."),
	        _0_only_refers_to_a_type_but_is_being_used_as_a_value_here_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_es2015_or_later: diag(2585, 1 /* Error */, "_0_only_refers_to_a_type_but_is_being_used_as_a_value_here_Do_you_need_to_change_your_target_library_2585", "'{0}' only refers to a type, but is being used as a value here. Do you need to change your target library? Try changing the 'lib' compiler option to es2015 or later."),
	        Cannot_assign_to_0_because_it_is_a_constant: diag(2588, 1 /* Error */, "Cannot_assign_to_0_because_it_is_a_constant_2588", "Cannot assign to '{0}' because it is a constant."),
	        Type_instantiation_is_excessively_deep_and_possibly_infinite: diag(2589, 1 /* Error */, "Type_instantiation_is_excessively_deep_and_possibly_infinite_2589", "Type instantiation is excessively deep and possibly infinite."),
	        Expression_produces_a_union_type_that_is_too_complex_to_represent: diag(2590, 1 /* Error */, "Expression_produces_a_union_type_that_is_too_complex_to_represent_2590", "Expression produces a union type that is too complex to represent."),
	        Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_node_Try_npm_i_save_dev_types_Slashnode_and_then_add_node_to_the_types_field_in_your_tsconfig: diag(2591, 1 /* Error */, "Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_node_Try_npm_i_save_dev_types_Slashno_2591", "Cannot find name '{0}'. Do you need to install type definitions for node? Try `npm i --save-dev @types/node` and then add 'node' to the types field in your tsconfig."),
	        Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_jQuery_Try_npm_i_save_dev_types_Slashjquery_and_then_add_jquery_to_the_types_field_in_your_tsconfig: diag(2592, 1 /* Error */, "Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_jQuery_Try_npm_i_save_dev_types_Slash_2592", "Cannot find name '{0}'. Do you need to install type definitions for jQuery? Try `npm i --save-dev @types/jquery` and then add 'jquery' to the types field in your tsconfig."),
	        Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_a_test_runner_Try_npm_i_save_dev_types_Slashjest_or_npm_i_save_dev_types_Slashmocha_and_then_add_jest_or_mocha_to_the_types_field_in_your_tsconfig: diag(2593, 1 /* Error */, "Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_a_test_runner_Try_npm_i_save_dev_type_2593", "Cannot find name '{0}'. Do you need to install type definitions for a test runner? Try `npm i --save-dev @types/jest` or `npm i --save-dev @types/mocha` and then add 'jest' or 'mocha' to the types field in your tsconfig."),
	        This_module_is_declared_with_export_and_can_only_be_used_with_a_default_import_when_using_the_0_flag: diag(2594, 1 /* Error */, "This_module_is_declared_with_export_and_can_only_be_used_with_a_default_import_when_using_the_0_flag_2594", "This module is declared with 'export =', and can only be used with a default import when using the '{0}' flag."),
	        _0_can_only_be_imported_by_using_a_default_import: diag(2595, 1 /* Error */, "_0_can_only_be_imported_by_using_a_default_import_2595", "'{0}' can only be imported by using a default import."),
	        _0_can_only_be_imported_by_turning_on_the_esModuleInterop_flag_and_using_a_default_import: diag(2596, 1 /* Error */, "_0_can_only_be_imported_by_turning_on_the_esModuleInterop_flag_and_using_a_default_import_2596", "'{0}' can only be imported by turning on the 'esModuleInterop' flag and using a default import."),
	        _0_can_only_be_imported_by_using_a_require_call_or_by_using_a_default_import: diag(2597, 1 /* Error */, "_0_can_only_be_imported_by_using_a_require_call_or_by_using_a_default_import_2597", "'{0}' can only be imported by using a 'require' call or by using a default import."),
	        _0_can_only_be_imported_by_using_a_require_call_or_by_turning_on_the_esModuleInterop_flag_and_using_a_default_import: diag(2598, 1 /* Error */, "_0_can_only_be_imported_by_using_a_require_call_or_by_turning_on_the_esModuleInterop_flag_and_using__2598", "'{0}' can only be imported by using a 'require' call or by turning on the 'esModuleInterop' flag and using a default import."),
	        JSX_element_implicitly_has_type_any_because_the_global_type_JSX_Element_does_not_exist: diag(2602, 1 /* Error */, "JSX_element_implicitly_has_type_any_because_the_global_type_JSX_Element_does_not_exist_2602", "JSX element implicitly has type 'any' because the global type 'JSX.Element' does not exist."),
	        Property_0_in_type_1_is_not_assignable_to_type_2: diag(2603, 1 /* Error */, "Property_0_in_type_1_is_not_assignable_to_type_2_2603", "Property '{0}' in type '{1}' is not assignable to type '{2}'."),
	        JSX_element_type_0_does_not_have_any_construct_or_call_signatures: diag(2604, 1 /* Error */, "JSX_element_type_0_does_not_have_any_construct_or_call_signatures_2604", "JSX element type '{0}' does not have any construct or call signatures."),
	        Property_0_of_JSX_spread_attribute_is_not_assignable_to_target_property: diag(2606, 1 /* Error */, "Property_0_of_JSX_spread_attribute_is_not_assignable_to_target_property_2606", "Property '{0}' of JSX spread attribute is not assignable to target property."),
	        JSX_element_class_does_not_support_attributes_because_it_does_not_have_a_0_property: diag(2607, 1 /* Error */, "JSX_element_class_does_not_support_attributes_because_it_does_not_have_a_0_property_2607", "JSX element class does not support attributes because it does not have a '{0}' property."),
	        The_global_type_JSX_0_may_not_have_more_than_one_property: diag(2608, 1 /* Error */, "The_global_type_JSX_0_may_not_have_more_than_one_property_2608", "The global type 'JSX.{0}' may not have more than one property."),
	        JSX_spread_child_must_be_an_array_type: diag(2609, 1 /* Error */, "JSX_spread_child_must_be_an_array_type_2609", "JSX spread child must be an array type."),
	        _0_is_defined_as_an_accessor_in_class_1_but_is_overridden_here_in_2_as_an_instance_property: diag(2610, 1 /* Error */, "_0_is_defined_as_an_accessor_in_class_1_but_is_overridden_here_in_2_as_an_instance_property_2610", "'{0}' is defined as an accessor in class '{1}', but is overridden here in '{2}' as an instance property."),
	        _0_is_defined_as_a_property_in_class_1_but_is_overridden_here_in_2_as_an_accessor: diag(2611, 1 /* Error */, "_0_is_defined_as_a_property_in_class_1_but_is_overridden_here_in_2_as_an_accessor_2611", "'{0}' is defined as a property in class '{1}', but is overridden here in '{2}' as an accessor."),
	        Property_0_will_overwrite_the_base_property_in_1_If_this_is_intentional_add_an_initializer_Otherwise_add_a_declare_modifier_or_remove_the_redundant_declaration: diag(2612, 1 /* Error */, "Property_0_will_overwrite_the_base_property_in_1_If_this_is_intentional_add_an_initializer_Otherwise_2612", "Property '{0}' will overwrite the base property in '{1}'. If this is intentional, add an initializer. Otherwise, add a 'declare' modifier or remove the redundant declaration."),
	        Module_0_has_no_default_export_Did_you_mean_to_use_import_1_from_0_instead: diag(2613, 1 /* Error */, "Module_0_has_no_default_export_Did_you_mean_to_use_import_1_from_0_instead_2613", "Module '{0}' has no default export. Did you mean to use 'import { {1} } from {0}' instead?"),
	        Module_0_has_no_exported_member_1_Did_you_mean_to_use_import_1_from_0_instead: diag(2614, 1 /* Error */, "Module_0_has_no_exported_member_1_Did_you_mean_to_use_import_1_from_0_instead_2614", "Module '{0}' has no exported member '{1}'. Did you mean to use 'import {1} from {0}' instead?"),
	        Type_of_property_0_circularly_references_itself_in_mapped_type_1: diag(2615, 1 /* Error */, "Type_of_property_0_circularly_references_itself_in_mapped_type_1_2615", "Type of property '{0}' circularly references itself in mapped type '{1}'."),
	        _0_can_only_be_imported_by_using_import_1_require_2_or_a_default_import: diag(2616, 1 /* Error */, "_0_can_only_be_imported_by_using_import_1_require_2_or_a_default_import_2616", "'{0}' can only be imported by using 'import {1} = require({2})' or a default import."),
	        _0_can_only_be_imported_by_using_import_1_require_2_or_by_turning_on_the_esModuleInterop_flag_and_using_a_default_import: diag(2617, 1 /* Error */, "_0_can_only_be_imported_by_using_import_1_require_2_or_by_turning_on_the_esModuleInterop_flag_and_us_2617", "'{0}' can only be imported by using 'import {1} = require({2})' or by turning on the 'esModuleInterop' flag and using a default import."),
	        Source_has_0_element_s_but_target_requires_1: diag(2618, 1 /* Error */, "Source_has_0_element_s_but_target_requires_1_2618", "Source has {0} element(s) but target requires {1}."),
	        Source_has_0_element_s_but_target_allows_only_1: diag(2619, 1 /* Error */, "Source_has_0_element_s_but_target_allows_only_1_2619", "Source has {0} element(s) but target allows only {1}."),
	        Target_requires_0_element_s_but_source_may_have_fewer: diag(2620, 1 /* Error */, "Target_requires_0_element_s_but_source_may_have_fewer_2620", "Target requires {0} element(s) but source may have fewer."),
	        Target_allows_only_0_element_s_but_source_may_have_more: diag(2621, 1 /* Error */, "Target_allows_only_0_element_s_but_source_may_have_more_2621", "Target allows only {0} element(s) but source may have more."),
	        Source_provides_no_match_for_required_element_at_position_0_in_target: diag(2623, 1 /* Error */, "Source_provides_no_match_for_required_element_at_position_0_in_target_2623", "Source provides no match for required element at position {0} in target."),
	        Source_provides_no_match_for_variadic_element_at_position_0_in_target: diag(2624, 1 /* Error */, "Source_provides_no_match_for_variadic_element_at_position_0_in_target_2624", "Source provides no match for variadic element at position {0} in target."),
	        Variadic_element_at_position_0_in_source_does_not_match_element_at_position_1_in_target: diag(2625, 1 /* Error */, "Variadic_element_at_position_0_in_source_does_not_match_element_at_position_1_in_target_2625", "Variadic element at position {0} in source does not match element at position {1} in target."),
	        Type_at_position_0_in_source_is_not_compatible_with_type_at_position_1_in_target: diag(2626, 1 /* Error */, "Type_at_position_0_in_source_is_not_compatible_with_type_at_position_1_in_target_2626", "Type at position {0} in source is not compatible with type at position {1} in target."),
	        Type_at_positions_0_through_1_in_source_is_not_compatible_with_type_at_position_2_in_target: diag(2627, 1 /* Error */, "Type_at_positions_0_through_1_in_source_is_not_compatible_with_type_at_position_2_in_target_2627", "Type at positions {0} through {1} in source is not compatible with type at position {2} in target."),
	        Cannot_assign_to_0_because_it_is_an_enum: diag(2628, 1 /* Error */, "Cannot_assign_to_0_because_it_is_an_enum_2628", "Cannot assign to '{0}' because it is an enum."),
	        Cannot_assign_to_0_because_it_is_a_class: diag(2629, 1 /* Error */, "Cannot_assign_to_0_because_it_is_a_class_2629", "Cannot assign to '{0}' because it is a class."),
	        Cannot_assign_to_0_because_it_is_a_function: diag(2630, 1 /* Error */, "Cannot_assign_to_0_because_it_is_a_function_2630", "Cannot assign to '{0}' because it is a function."),
	        Cannot_assign_to_0_because_it_is_a_namespace: diag(2631, 1 /* Error */, "Cannot_assign_to_0_because_it_is_a_namespace_2631", "Cannot assign to '{0}' because it is a namespace."),
	        Cannot_assign_to_0_because_it_is_an_import: diag(2632, 1 /* Error */, "Cannot_assign_to_0_because_it_is_an_import_2632", "Cannot assign to '{0}' because it is an import."),
	        JSX_property_access_expressions_cannot_include_JSX_namespace_names: diag(2633, 1 /* Error */, "JSX_property_access_expressions_cannot_include_JSX_namespace_names_2633", "JSX property access expressions cannot include JSX namespace names"),
	        _0_index_signatures_are_incompatible: diag(2634, 1 /* Error */, "_0_index_signatures_are_incompatible_2634", "'{0}' index signatures are incompatible."),
	        Type_0_has_no_signatures_for_which_the_type_argument_list_is_applicable: diag(2635, 1 /* Error */, "Type_0_has_no_signatures_for_which_the_type_argument_list_is_applicable_2635", "Type '{0}' has no signatures for which the type argument list is applicable."),
	        Type_0_is_not_assignable_to_type_1_as_implied_by_variance_annotation: diag(2636, 1 /* Error */, "Type_0_is_not_assignable_to_type_1_as_implied_by_variance_annotation_2636", "Type '{0}' is not assignable to type '{1}' as implied by variance annotation."),
	        Variance_annotations_are_only_supported_in_type_aliases_for_object_function_constructor_and_mapped_types: diag(2637, 1 /* Error */, "Variance_annotations_are_only_supported_in_type_aliases_for_object_function_constructor_and_mapped_t_2637", "Variance annotations are only supported in type aliases for object, function, constructor, and mapped types."),
	        Type_0_may_represent_a_primitive_value_which_is_not_permitted_as_the_right_operand_of_the_in_operator: diag(2638, 1 /* Error */, "Type_0_may_represent_a_primitive_value_which_is_not_permitted_as_the_right_operand_of_the_in_operato_2638", "Type '{0}' may represent a primitive value, which is not permitted as the right operand of the 'in' operator."),
	        React_components_cannot_include_JSX_namespace_names: diag(2639, 1 /* Error */, "React_components_cannot_include_JSX_namespace_names_2639", "React components cannot include JSX namespace names"),
	        Cannot_augment_module_0_with_value_exports_because_it_resolves_to_a_non_module_entity: diag(2649, 1 /* Error */, "Cannot_augment_module_0_with_value_exports_because_it_resolves_to_a_non_module_entity_2649", "Cannot augment module '{0}' with value exports because it resolves to a non-module entity."),
	        A_member_initializer_in_a_enum_declaration_cannot_reference_members_declared_after_it_including_members_defined_in_other_enums: diag(2651, 1 /* Error */, "A_member_initializer_in_a_enum_declaration_cannot_reference_members_declared_after_it_including_memb_2651", "A member initializer in a enum declaration cannot reference members declared after it, including members defined in other enums."),
	        Merged_declaration_0_cannot_include_a_default_export_declaration_Consider_adding_a_separate_export_default_0_declaration_instead: diag(2652, 1 /* Error */, "Merged_declaration_0_cannot_include_a_default_export_declaration_Consider_adding_a_separate_export_d_2652", "Merged declaration '{0}' cannot include a default export declaration. Consider adding a separate 'export default {0}' declaration instead."),
	        Non_abstract_class_expression_does_not_implement_inherited_abstract_member_0_from_class_1: diag(2653, 1 /* Error */, "Non_abstract_class_expression_does_not_implement_inherited_abstract_member_0_from_class_1_2653", "Non-abstract class expression does not implement inherited abstract member '{0}' from class '{1}'."),
	        JSX_expressions_must_have_one_parent_element: diag(2657, 1 /* Error */, "JSX_expressions_must_have_one_parent_element_2657", "JSX expressions must have one parent element."),
	        Type_0_provides_no_match_for_the_signature_1: diag(2658, 1 /* Error */, "Type_0_provides_no_match_for_the_signature_1_2658", "Type '{0}' provides no match for the signature '{1}'."),
	        super_is_only_allowed_in_members_of_object_literal_expressions_when_option_target_is_ES2015_or_higher: diag(2659, 1 /* Error */, "super_is_only_allowed_in_members_of_object_literal_expressions_when_option_target_is_ES2015_or_highe_2659", "'super' is only allowed in members of object literal expressions when option 'target' is 'ES2015' or higher."),
	        super_can_only_be_referenced_in_members_of_derived_classes_or_object_literal_expressions: diag(2660, 1 /* Error */, "super_can_only_be_referenced_in_members_of_derived_classes_or_object_literal_expressions_2660", "'super' can only be referenced in members of derived classes or object literal expressions."),
	        Cannot_export_0_Only_local_declarations_can_be_exported_from_a_module: diag(2661, 1 /* Error */, "Cannot_export_0_Only_local_declarations_can_be_exported_from_a_module_2661", "Cannot export '{0}'. Only local declarations can be exported from a module."),
	        Cannot_find_name_0_Did_you_mean_the_static_member_1_0: diag(2662, 1 /* Error */, "Cannot_find_name_0_Did_you_mean_the_static_member_1_0_2662", "Cannot find name '{0}'. Did you mean the static member '{1}.{0}'?"),
	        Cannot_find_name_0_Did_you_mean_the_instance_member_this_0: diag(2663, 1 /* Error */, "Cannot_find_name_0_Did_you_mean_the_instance_member_this_0_2663", "Cannot find name '{0}'. Did you mean the instance member 'this.{0}'?"),
	        Invalid_module_name_in_augmentation_module_0_cannot_be_found: diag(2664, 1 /* Error */, "Invalid_module_name_in_augmentation_module_0_cannot_be_found_2664", "Invalid module name in augmentation, module '{0}' cannot be found."),
	        Invalid_module_name_in_augmentation_Module_0_resolves_to_an_untyped_module_at_1_which_cannot_be_augmented: diag(2665, 1 /* Error */, "Invalid_module_name_in_augmentation_Module_0_resolves_to_an_untyped_module_at_1_which_cannot_be_augm_2665", "Invalid module name in augmentation. Module '{0}' resolves to an untyped module at '{1}', which cannot be augmented."),
	        Exports_and_export_assignments_are_not_permitted_in_module_augmentations: diag(2666, 1 /* Error */, "Exports_and_export_assignments_are_not_permitted_in_module_augmentations_2666", "Exports and export assignments are not permitted in module augmentations."),
	        Imports_are_not_permitted_in_module_augmentations_Consider_moving_them_to_the_enclosing_external_module: diag(2667, 1 /* Error */, "Imports_are_not_permitted_in_module_augmentations_Consider_moving_them_to_the_enclosing_external_mod_2667", "Imports are not permitted in module augmentations. Consider moving them to the enclosing external module."),
	        export_modifier_cannot_be_applied_to_ambient_modules_and_module_augmentations_since_they_are_always_visible: diag(2668, 1 /* Error */, "export_modifier_cannot_be_applied_to_ambient_modules_and_module_augmentations_since_they_are_always__2668", "'export' modifier cannot be applied to ambient modules and module augmentations since they are always visible."),
	        Augmentations_for_the_global_scope_can_only_be_directly_nested_in_external_modules_or_ambient_module_declarations: diag(2669, 1 /* Error */, "Augmentations_for_the_global_scope_can_only_be_directly_nested_in_external_modules_or_ambient_module_2669", "Augmentations for the global scope can only be directly nested in external modules or ambient module declarations."),
	        Augmentations_for_the_global_scope_should_have_declare_modifier_unless_they_appear_in_already_ambient_context: diag(2670, 1 /* Error */, "Augmentations_for_the_global_scope_should_have_declare_modifier_unless_they_appear_in_already_ambien_2670", "Augmentations for the global scope should have 'declare' modifier unless they appear in already ambient context."),
	        Cannot_augment_module_0_because_it_resolves_to_a_non_module_entity: diag(2671, 1 /* Error */, "Cannot_augment_module_0_because_it_resolves_to_a_non_module_entity_2671", "Cannot augment module '{0}' because it resolves to a non-module entity."),
	        Cannot_assign_a_0_constructor_type_to_a_1_constructor_type: diag(2672, 1 /* Error */, "Cannot_assign_a_0_constructor_type_to_a_1_constructor_type_2672", "Cannot assign a '{0}' constructor type to a '{1}' constructor type."),
	        Constructor_of_class_0_is_private_and_only_accessible_within_the_class_declaration: diag(2673, 1 /* Error */, "Constructor_of_class_0_is_private_and_only_accessible_within_the_class_declaration_2673", "Constructor of class '{0}' is private and only accessible within the class declaration."),
	        Constructor_of_class_0_is_protected_and_only_accessible_within_the_class_declaration: diag(2674, 1 /* Error */, "Constructor_of_class_0_is_protected_and_only_accessible_within_the_class_declaration_2674", "Constructor of class '{0}' is protected and only accessible within the class declaration."),
	        Cannot_extend_a_class_0_Class_constructor_is_marked_as_private: diag(2675, 1 /* Error */, "Cannot_extend_a_class_0_Class_constructor_is_marked_as_private_2675", "Cannot extend a class '{0}'. Class constructor is marked as private."),
	        Accessors_must_both_be_abstract_or_non_abstract: diag(2676, 1 /* Error */, "Accessors_must_both_be_abstract_or_non_abstract_2676", "Accessors must both be abstract or non-abstract."),
	        A_type_predicate_s_type_must_be_assignable_to_its_parameter_s_type: diag(2677, 1 /* Error */, "A_type_predicate_s_type_must_be_assignable_to_its_parameter_s_type_2677", "A type predicate's type must be assignable to its parameter's type."),
	        Type_0_is_not_comparable_to_type_1: diag(2678, 1 /* Error */, "Type_0_is_not_comparable_to_type_1_2678", "Type '{0}' is not comparable to type '{1}'."),
	        A_function_that_is_called_with_the_new_keyword_cannot_have_a_this_type_that_is_void: diag(2679, 1 /* Error */, "A_function_that_is_called_with_the_new_keyword_cannot_have_a_this_type_that_is_void_2679", "A function that is called with the 'new' keyword cannot have a 'this' type that is 'void'."),
	        A_0_parameter_must_be_the_first_parameter: diag(2680, 1 /* Error */, "A_0_parameter_must_be_the_first_parameter_2680", "A '{0}' parameter must be the first parameter."),
	        A_constructor_cannot_have_a_this_parameter: diag(2681, 1 /* Error */, "A_constructor_cannot_have_a_this_parameter_2681", "A constructor cannot have a 'this' parameter."),
	        this_implicitly_has_type_any_because_it_does_not_have_a_type_annotation: diag(2683, 1 /* Error */, "this_implicitly_has_type_any_because_it_does_not_have_a_type_annotation_2683", "'this' implicitly has type 'any' because it does not have a type annotation."),
	        The_this_context_of_type_0_is_not_assignable_to_method_s_this_of_type_1: diag(2684, 1 /* Error */, "The_this_context_of_type_0_is_not_assignable_to_method_s_this_of_type_1_2684", "The 'this' context of type '{0}' is not assignable to method's 'this' of type '{1}'."),
	        The_this_types_of_each_signature_are_incompatible: diag(2685, 1 /* Error */, "The_this_types_of_each_signature_are_incompatible_2685", "The 'this' types of each signature are incompatible."),
	        _0_refers_to_a_UMD_global_but_the_current_file_is_a_module_Consider_adding_an_import_instead: diag(2686, 1 /* Error */, "_0_refers_to_a_UMD_global_but_the_current_file_is_a_module_Consider_adding_an_import_instead_2686", "'{0}' refers to a UMD global, but the current file is a module. Consider adding an import instead."),
	        All_declarations_of_0_must_have_identical_modifiers: diag(2687, 1 /* Error */, "All_declarations_of_0_must_have_identical_modifiers_2687", "All declarations of '{0}' must have identical modifiers."),
	        Cannot_find_type_definition_file_for_0: diag(2688, 1 /* Error */, "Cannot_find_type_definition_file_for_0_2688", "Cannot find type definition file for '{0}'."),
	        Cannot_extend_an_interface_0_Did_you_mean_implements: diag(2689, 1 /* Error */, "Cannot_extend_an_interface_0_Did_you_mean_implements_2689", "Cannot extend an interface '{0}'. Did you mean 'implements'?"),
	        _0_only_refers_to_a_type_but_is_being_used_as_a_value_here_Did_you_mean_to_use_1_in_0: diag(2690, 1 /* Error */, "_0_only_refers_to_a_type_but_is_being_used_as_a_value_here_Did_you_mean_to_use_1_in_0_2690", "'{0}' only refers to a type, but is being used as a value here. Did you mean to use '{1} in {0}'?"),
	        _0_is_a_primitive_but_1_is_a_wrapper_object_Prefer_using_0_when_possible: diag(2692, 1 /* Error */, "_0_is_a_primitive_but_1_is_a_wrapper_object_Prefer_using_0_when_possible_2692", "'{0}' is a primitive, but '{1}' is a wrapper object. Prefer using '{0}' when possible."),
	        _0_only_refers_to_a_type_but_is_being_used_as_a_value_here: diag(2693, 1 /* Error */, "_0_only_refers_to_a_type_but_is_being_used_as_a_value_here_2693", "'{0}' only refers to a type, but is being used as a value here."),
	        Namespace_0_has_no_exported_member_1: diag(2694, 1 /* Error */, "Namespace_0_has_no_exported_member_1_2694", "Namespace '{0}' has no exported member '{1}'."),
	        Left_side_of_comma_operator_is_unused_and_has_no_side_effects: diag(
	          2695,
	          1 /* Error */,
	          "Left_side_of_comma_operator_is_unused_and_has_no_side_effects_2695",
	          "Left side of comma operator is unused and has no side effects.",
	          /*reportsUnnecessary*/
	          true
	        ),
	        The_Object_type_is_assignable_to_very_few_other_types_Did_you_mean_to_use_the_any_type_instead: diag(2696, 1 /* Error */, "The_Object_type_is_assignable_to_very_few_other_types_Did_you_mean_to_use_the_any_type_instead_2696", "The 'Object' type is assignable to very few other types. Did you mean to use the 'any' type instead?"),
	        An_async_function_or_method_must_return_a_Promise_Make_sure_you_have_a_declaration_for_Promise_or_include_ES2015_in_your_lib_option: diag(2697, 1 /* Error */, "An_async_function_or_method_must_return_a_Promise_Make_sure_you_have_a_declaration_for_Promise_or_in_2697", "An async function or method must return a 'Promise'. Make sure you have a declaration for 'Promise' or include 'ES2015' in your '--lib' option."),
	        Spread_types_may_only_be_created_from_object_types: diag(2698, 1 /* Error */, "Spread_types_may_only_be_created_from_object_types_2698", "Spread types may only be created from object types."),
	        Static_property_0_conflicts_with_built_in_property_Function_0_of_constructor_function_1: diag(2699, 1 /* Error */, "Static_property_0_conflicts_with_built_in_property_Function_0_of_constructor_function_1_2699", "Static property '{0}' conflicts with built-in property 'Function.{0}' of constructor function '{1}'."),
	        Rest_types_may_only_be_created_from_object_types: diag(2700, 1 /* Error */, "Rest_types_may_only_be_created_from_object_types_2700", "Rest types may only be created from object types."),
	        The_target_of_an_object_rest_assignment_must_be_a_variable_or_a_property_access: diag(2701, 1 /* Error */, "The_target_of_an_object_rest_assignment_must_be_a_variable_or_a_property_access_2701", "The target of an object rest assignment must be a variable or a property access."),
	        _0_only_refers_to_a_type_but_is_being_used_as_a_namespace_here: diag(2702, 1 /* Error */, "_0_only_refers_to_a_type_but_is_being_used_as_a_namespace_here_2702", "'{0}' only refers to a type, but is being used as a namespace here."),
	        The_operand_of_a_delete_operator_must_be_a_property_reference: diag(2703, 1 /* Error */, "The_operand_of_a_delete_operator_must_be_a_property_reference_2703", "The operand of a 'delete' operator must be a property reference."),
	        The_operand_of_a_delete_operator_cannot_be_a_read_only_property: diag(2704, 1 /* Error */, "The_operand_of_a_delete_operator_cannot_be_a_read_only_property_2704", "The operand of a 'delete' operator cannot be a read-only property."),
	        An_async_function_or_method_in_ES5_SlashES3_requires_the_Promise_constructor_Make_sure_you_have_a_declaration_for_the_Promise_constructor_or_include_ES2015_in_your_lib_option: diag(2705, 1 /* Error */, "An_async_function_or_method_in_ES5_SlashES3_requires_the_Promise_constructor_Make_sure_you_have_a_de_2705", "An async function or method in ES5/ES3 requires the 'Promise' constructor.  Make sure you have a declaration for the 'Promise' constructor or include 'ES2015' in your '--lib' option."),
	        Required_type_parameters_may_not_follow_optional_type_parameters: diag(2706, 1 /* Error */, "Required_type_parameters_may_not_follow_optional_type_parameters_2706", "Required type parameters may not follow optional type parameters."),
	        Generic_type_0_requires_between_1_and_2_type_arguments: diag(2707, 1 /* Error */, "Generic_type_0_requires_between_1_and_2_type_arguments_2707", "Generic type '{0}' requires between {1} and {2} type arguments."),
	        Cannot_use_namespace_0_as_a_value: diag(2708, 1 /* Error */, "Cannot_use_namespace_0_as_a_value_2708", "Cannot use namespace '{0}' as a value."),
	        Cannot_use_namespace_0_as_a_type: diag(2709, 1 /* Error */, "Cannot_use_namespace_0_as_a_type_2709", "Cannot use namespace '{0}' as a type."),
	        _0_are_specified_twice_The_attribute_named_0_will_be_overwritten: diag(2710, 1 /* Error */, "_0_are_specified_twice_The_attribute_named_0_will_be_overwritten_2710", "'{0}' are specified twice. The attribute named '{0}' will be overwritten."),
	        A_dynamic_import_call_returns_a_Promise_Make_sure_you_have_a_declaration_for_Promise_or_include_ES2015_in_your_lib_option: diag(2711, 1 /* Error */, "A_dynamic_import_call_returns_a_Promise_Make_sure_you_have_a_declaration_for_Promise_or_include_ES20_2711", "A dynamic import call returns a 'Promise'. Make sure you have a declaration for 'Promise' or include 'ES2015' in your '--lib' option."),
	        A_dynamic_import_call_in_ES5_SlashES3_requires_the_Promise_constructor_Make_sure_you_have_a_declaration_for_the_Promise_constructor_or_include_ES2015_in_your_lib_option: diag(2712, 1 /* Error */, "A_dynamic_import_call_in_ES5_SlashES3_requires_the_Promise_constructor_Make_sure_you_have_a_declarat_2712", "A dynamic import call in ES5/ES3 requires the 'Promise' constructor.  Make sure you have a declaration for the 'Promise' constructor or include 'ES2015' in your '--lib' option."),
	        Cannot_access_0_1_because_0_is_a_type_but_not_a_namespace_Did_you_mean_to_retrieve_the_type_of_the_property_1_in_0_with_0_1: diag(2713, 1 /* Error */, "Cannot_access_0_1_because_0_is_a_type_but_not_a_namespace_Did_you_mean_to_retrieve_the_type_of_the_p_2713", `Cannot access '{0}.{1}' because '{0}' is a type, but not a namespace. Did you mean to retrieve the type of the property '{1}' in '{0}' with '{0}["{1}"]'?`),
	        The_expression_of_an_export_assignment_must_be_an_identifier_or_qualified_name_in_an_ambient_context: diag(2714, 1 /* Error */, "The_expression_of_an_export_assignment_must_be_an_identifier_or_qualified_name_in_an_ambient_context_2714", "The expression of an export assignment must be an identifier or qualified name in an ambient context."),
	        Abstract_property_0_in_class_1_cannot_be_accessed_in_the_constructor: diag(2715, 1 /* Error */, "Abstract_property_0_in_class_1_cannot_be_accessed_in_the_constructor_2715", "Abstract property '{0}' in class '{1}' cannot be accessed in the constructor."),
	        Type_parameter_0_has_a_circular_default: diag(2716, 1 /* Error */, "Type_parameter_0_has_a_circular_default_2716", "Type parameter '{0}' has a circular default."),
	        Subsequent_property_declarations_must_have_the_same_type_Property_0_must_be_of_type_1_but_here_has_type_2: diag(2717, 1 /* Error */, "Subsequent_property_declarations_must_have_the_same_type_Property_0_must_be_of_type_1_but_here_has_t_2717", "Subsequent property declarations must have the same type.  Property '{0}' must be of type '{1}', but here has type '{2}'."),
	        Duplicate_property_0: diag(2718, 1 /* Error */, "Duplicate_property_0_2718", "Duplicate property '{0}'."),
	        Type_0_is_not_assignable_to_type_1_Two_different_types_with_this_name_exist_but_they_are_unrelated: diag(2719, 1 /* Error */, "Type_0_is_not_assignable_to_type_1_Two_different_types_with_this_name_exist_but_they_are_unrelated_2719", "Type '{0}' is not assignable to type '{1}'. Two different types with this name exist, but they are unrelated."),
	        Class_0_incorrectly_implements_class_1_Did_you_mean_to_extend_1_and_inherit_its_members_as_a_subclass: diag(2720, 1 /* Error */, "Class_0_incorrectly_implements_class_1_Did_you_mean_to_extend_1_and_inherit_its_members_as_a_subclas_2720", "Class '{0}' incorrectly implements class '{1}'. Did you mean to extend '{1}' and inherit its members as a subclass?"),
	        Cannot_invoke_an_object_which_is_possibly_null: diag(2721, 1 /* Error */, "Cannot_invoke_an_object_which_is_possibly_null_2721", "Cannot invoke an object which is possibly 'null'."),
	        Cannot_invoke_an_object_which_is_possibly_undefined: diag(2722, 1 /* Error */, "Cannot_invoke_an_object_which_is_possibly_undefined_2722", "Cannot invoke an object which is possibly 'undefined'."),
	        Cannot_invoke_an_object_which_is_possibly_null_or_undefined: diag(2723, 1 /* Error */, "Cannot_invoke_an_object_which_is_possibly_null_or_undefined_2723", "Cannot invoke an object which is possibly 'null' or 'undefined'."),
	        _0_has_no_exported_member_named_1_Did_you_mean_2: diag(2724, 1 /* Error */, "_0_has_no_exported_member_named_1_Did_you_mean_2_2724", "'{0}' has no exported member named '{1}'. Did you mean '{2}'?"),
	        Class_name_cannot_be_Object_when_targeting_ES5_with_module_0: diag(2725, 1 /* Error */, "Class_name_cannot_be_Object_when_targeting_ES5_with_module_0_2725", "Class name cannot be 'Object' when targeting ES5 with module {0}."),
	        Cannot_find_lib_definition_for_0: diag(2726, 1 /* Error */, "Cannot_find_lib_definition_for_0_2726", "Cannot find lib definition for '{0}'."),
	        Cannot_find_lib_definition_for_0_Did_you_mean_1: diag(2727, 1 /* Error */, "Cannot_find_lib_definition_for_0_Did_you_mean_1_2727", "Cannot find lib definition for '{0}'. Did you mean '{1}'?"),
	        _0_is_declared_here: diag(2728, 3 /* Message */, "_0_is_declared_here_2728", "'{0}' is declared here."),
	        Property_0_is_used_before_its_initialization: diag(2729, 1 /* Error */, "Property_0_is_used_before_its_initialization_2729", "Property '{0}' is used before its initialization."),
	        An_arrow_function_cannot_have_a_this_parameter: diag(2730, 1 /* Error */, "An_arrow_function_cannot_have_a_this_parameter_2730", "An arrow function cannot have a 'this' parameter."),
	        Implicit_conversion_of_a_symbol_to_a_string_will_fail_at_runtime_Consider_wrapping_this_expression_in_String: diag(2731, 1 /* Error */, "Implicit_conversion_of_a_symbol_to_a_string_will_fail_at_runtime_Consider_wrapping_this_expression_i_2731", "Implicit conversion of a 'symbol' to a 'string' will fail at runtime. Consider wrapping this expression in 'String(...)'."),
	        Cannot_find_module_0_Consider_using_resolveJsonModule_to_import_module_with_json_extension: diag(2732, 1 /* Error */, "Cannot_find_module_0_Consider_using_resolveJsonModule_to_import_module_with_json_extension_2732", "Cannot find module '{0}'. Consider using '--resolveJsonModule' to import module with '.json' extension."),
	        Property_0_was_also_declared_here: diag(2733, 1 /* Error */, "Property_0_was_also_declared_here_2733", "Property '{0}' was also declared here."),
	        Are_you_missing_a_semicolon: diag(2734, 1 /* Error */, "Are_you_missing_a_semicolon_2734", "Are you missing a semicolon?"),
	        Did_you_mean_for_0_to_be_constrained_to_type_new_args_Colon_any_1: diag(2735, 1 /* Error */, "Did_you_mean_for_0_to_be_constrained_to_type_new_args_Colon_any_1_2735", "Did you mean for '{0}' to be constrained to type 'new (...args: any[]) => {1}'?"),
	        Operator_0_cannot_be_applied_to_type_1: diag(2736, 1 /* Error */, "Operator_0_cannot_be_applied_to_type_1_2736", "Operator '{0}' cannot be applied to type '{1}'."),
	        BigInt_literals_are_not_available_when_targeting_lower_than_ES2020: diag(2737, 1 /* Error */, "BigInt_literals_are_not_available_when_targeting_lower_than_ES2020_2737", "BigInt literals are not available when targeting lower than ES2020."),
	        An_outer_value_of_this_is_shadowed_by_this_container: diag(2738, 3 /* Message */, "An_outer_value_of_this_is_shadowed_by_this_container_2738", "An outer value of 'this' is shadowed by this container."),
	        Type_0_is_missing_the_following_properties_from_type_1_Colon_2: diag(2739, 1 /* Error */, "Type_0_is_missing_the_following_properties_from_type_1_Colon_2_2739", "Type '{0}' is missing the following properties from type '{1}': {2}"),
	        Type_0_is_missing_the_following_properties_from_type_1_Colon_2_and_3_more: diag(2740, 1 /* Error */, "Type_0_is_missing_the_following_properties_from_type_1_Colon_2_and_3_more_2740", "Type '{0}' is missing the following properties from type '{1}': {2}, and {3} more."),
	        Property_0_is_missing_in_type_1_but_required_in_type_2: diag(2741, 1 /* Error */, "Property_0_is_missing_in_type_1_but_required_in_type_2_2741", "Property '{0}' is missing in type '{1}' but required in type '{2}'."),
	        The_inferred_type_of_0_cannot_be_named_without_a_reference_to_1_This_is_likely_not_portable_A_type_annotation_is_necessary: diag(2742, 1 /* Error */, "The_inferred_type_of_0_cannot_be_named_without_a_reference_to_1_This_is_likely_not_portable_A_type_a_2742", "The inferred type of '{0}' cannot be named without a reference to '{1}'. This is likely not portable. A type annotation is necessary."),
	        No_overload_expects_0_type_arguments_but_overloads_do_exist_that_expect_either_1_or_2_type_arguments: diag(2743, 1 /* Error */, "No_overload_expects_0_type_arguments_but_overloads_do_exist_that_expect_either_1_or_2_type_arguments_2743", "No overload expects {0} type arguments, but overloads do exist that expect either {1} or {2} type arguments."),
	        Type_parameter_defaults_can_only_reference_previously_declared_type_parameters: diag(2744, 1 /* Error */, "Type_parameter_defaults_can_only_reference_previously_declared_type_parameters_2744", "Type parameter defaults can only reference previously declared type parameters."),
	        This_JSX_tag_s_0_prop_expects_type_1_which_requires_multiple_children_but_only_a_single_child_was_provided: diag(2745, 1 /* Error */, "This_JSX_tag_s_0_prop_expects_type_1_which_requires_multiple_children_but_only_a_single_child_was_pr_2745", "This JSX tag's '{0}' prop expects type '{1}' which requires multiple children, but only a single child was provided."),
	        This_JSX_tag_s_0_prop_expects_a_single_child_of_type_1_but_multiple_children_were_provided: diag(2746, 1 /* Error */, "This_JSX_tag_s_0_prop_expects_a_single_child_of_type_1_but_multiple_children_were_provided_2746", "This JSX tag's '{0}' prop expects a single child of type '{1}', but multiple children were provided."),
	        _0_components_don_t_accept_text_as_child_elements_Text_in_JSX_has_the_type_string_but_the_expected_type_of_1_is_2: diag(2747, 1 /* Error */, "_0_components_don_t_accept_text_as_child_elements_Text_in_JSX_has_the_type_string_but_the_expected_t_2747", "'{0}' components don't accept text as child elements. Text in JSX has the type 'string', but the expected type of '{1}' is '{2}'."),
	        Cannot_access_ambient_const_enums_when_0_is_enabled: diag(2748, 1 /* Error */, "Cannot_access_ambient_const_enums_when_0_is_enabled_2748", "Cannot access ambient const enums when '{0}' is enabled."),
	        _0_refers_to_a_value_but_is_being_used_as_a_type_here_Did_you_mean_typeof_0: diag(2749, 1 /* Error */, "_0_refers_to_a_value_but_is_being_used_as_a_type_here_Did_you_mean_typeof_0_2749", "'{0}' refers to a value, but is being used as a type here. Did you mean 'typeof {0}'?"),
	        The_implementation_signature_is_declared_here: diag(2750, 1 /* Error */, "The_implementation_signature_is_declared_here_2750", "The implementation signature is declared here."),
	        Circularity_originates_in_type_at_this_location: diag(2751, 1 /* Error */, "Circularity_originates_in_type_at_this_location_2751", "Circularity originates in type at this location."),
	        The_first_export_default_is_here: diag(2752, 1 /* Error */, "The_first_export_default_is_here_2752", "The first export default is here."),
	        Another_export_default_is_here: diag(2753, 1 /* Error */, "Another_export_default_is_here_2753", "Another export default is here."),
	        super_may_not_use_type_arguments: diag(2754, 1 /* Error */, "super_may_not_use_type_arguments_2754", "'super' may not use type arguments."),
	        No_constituent_of_type_0_is_callable: diag(2755, 1 /* Error */, "No_constituent_of_type_0_is_callable_2755", "No constituent of type '{0}' is callable."),
	        Not_all_constituents_of_type_0_are_callable: diag(2756, 1 /* Error */, "Not_all_constituents_of_type_0_are_callable_2756", "Not all constituents of type '{0}' are callable."),
	        Type_0_has_no_call_signatures: diag(2757, 1 /* Error */, "Type_0_has_no_call_signatures_2757", "Type '{0}' has no call signatures."),
	        Each_member_of_the_union_type_0_has_signatures_but_none_of_those_signatures_are_compatible_with_each_other: diag(2758, 1 /* Error */, "Each_member_of_the_union_type_0_has_signatures_but_none_of_those_signatures_are_compatible_with_each_2758", "Each member of the union type '{0}' has signatures, but none of those signatures are compatible with each other."),
	        No_constituent_of_type_0_is_constructable: diag(2759, 1 /* Error */, "No_constituent_of_type_0_is_constructable_2759", "No constituent of type '{0}' is constructable."),
	        Not_all_constituents_of_type_0_are_constructable: diag(2760, 1 /* Error */, "Not_all_constituents_of_type_0_are_constructable_2760", "Not all constituents of type '{0}' are constructable."),
	        Type_0_has_no_construct_signatures: diag(2761, 1 /* Error */, "Type_0_has_no_construct_signatures_2761", "Type '{0}' has no construct signatures."),
	        Each_member_of_the_union_type_0_has_construct_signatures_but_none_of_those_signatures_are_compatible_with_each_other: diag(2762, 1 /* Error */, "Each_member_of_the_union_type_0_has_construct_signatures_but_none_of_those_signatures_are_compatible_2762", "Each member of the union type '{0}' has construct signatures, but none of those signatures are compatible with each other."),
	        Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_for_of_will_always_send_0: diag(2763, 1 /* Error */, "Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_for_of_will_always_s_2763", "Cannot iterate value because the 'next' method of its iterator expects type '{1}', but for-of will always send '{0}'."),
	        Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_array_spread_will_always_send_0: diag(2764, 1 /* Error */, "Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_array_spread_will_al_2764", "Cannot iterate value because the 'next' method of its iterator expects type '{1}', but array spread will always send '{0}'."),
	        Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_array_destructuring_will_always_send_0: diag(2765, 1 /* Error */, "Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_array_destructuring__2765", "Cannot iterate value because the 'next' method of its iterator expects type '{1}', but array destructuring will always send '{0}'."),
	        Cannot_delegate_iteration_to_value_because_the_next_method_of_its_iterator_expects_type_1_but_the_containing_generator_will_always_send_0: diag(2766, 1 /* Error */, "Cannot_delegate_iteration_to_value_because_the_next_method_of_its_iterator_expects_type_1_but_the_co_2766", "Cannot delegate iteration to value because the 'next' method of its iterator expects type '{1}', but the containing generator will always send '{0}'."),
	        The_0_property_of_an_iterator_must_be_a_method: diag(2767, 1 /* Error */, "The_0_property_of_an_iterator_must_be_a_method_2767", "The '{0}' property of an iterator must be a method."),
	        The_0_property_of_an_async_iterator_must_be_a_method: diag(2768, 1 /* Error */, "The_0_property_of_an_async_iterator_must_be_a_method_2768", "The '{0}' property of an async iterator must be a method."),
	        No_overload_matches_this_call: diag(2769, 1 /* Error */, "No_overload_matches_this_call_2769", "No overload matches this call."),
	        The_last_overload_gave_the_following_error: diag(2770, 1 /* Error */, "The_last_overload_gave_the_following_error_2770", "The last overload gave the following error."),
	        The_last_overload_is_declared_here: diag(2771, 1 /* Error */, "The_last_overload_is_declared_here_2771", "The last overload is declared here."),
	        Overload_0_of_1_2_gave_the_following_error: diag(2772, 1 /* Error */, "Overload_0_of_1_2_gave_the_following_error_2772", "Overload {0} of {1}, '{2}', gave the following error."),
	        Did_you_forget_to_use_await: diag(2773, 1 /* Error */, "Did_you_forget_to_use_await_2773", "Did you forget to use 'await'?"),
	        This_condition_will_always_return_true_since_this_function_is_always_defined_Did_you_mean_to_call_it_instead: diag(2774, 1 /* Error */, "This_condition_will_always_return_true_since_this_function_is_always_defined_Did_you_mean_to_call_it_2774", "This condition will always return true since this function is always defined. Did you mean to call it instead?"),
	        Assertions_require_every_name_in_the_call_target_to_be_declared_with_an_explicit_type_annotation: diag(2775, 1 /* Error */, "Assertions_require_every_name_in_the_call_target_to_be_declared_with_an_explicit_type_annotation_2775", "Assertions require every name in the call target to be declared with an explicit type annotation."),
	        Assertions_require_the_call_target_to_be_an_identifier_or_qualified_name: diag(2776, 1 /* Error */, "Assertions_require_the_call_target_to_be_an_identifier_or_qualified_name_2776", "Assertions require the call target to be an identifier or qualified name."),
	        The_operand_of_an_increment_or_decrement_operator_may_not_be_an_optional_property_access: diag(2777, 1 /* Error */, "The_operand_of_an_increment_or_decrement_operator_may_not_be_an_optional_property_access_2777", "The operand of an increment or decrement operator may not be an optional property access."),
	        The_target_of_an_object_rest_assignment_may_not_be_an_optional_property_access: diag(2778, 1 /* Error */, "The_target_of_an_object_rest_assignment_may_not_be_an_optional_property_access_2778", "The target of an object rest assignment may not be an optional property access."),
	        The_left_hand_side_of_an_assignment_expression_may_not_be_an_optional_property_access: diag(2779, 1 /* Error */, "The_left_hand_side_of_an_assignment_expression_may_not_be_an_optional_property_access_2779", "The left-hand side of an assignment expression may not be an optional property access."),
	        The_left_hand_side_of_a_for_in_statement_may_not_be_an_optional_property_access: diag(2780, 1 /* Error */, "The_left_hand_side_of_a_for_in_statement_may_not_be_an_optional_property_access_2780", "The left-hand side of a 'for...in' statement may not be an optional property access."),
	        The_left_hand_side_of_a_for_of_statement_may_not_be_an_optional_property_access: diag(2781, 1 /* Error */, "The_left_hand_side_of_a_for_of_statement_may_not_be_an_optional_property_access_2781", "The left-hand side of a 'for...of' statement may not be an optional property access."),
	        _0_needs_an_explicit_type_annotation: diag(2782, 3 /* Message */, "_0_needs_an_explicit_type_annotation_2782", "'{0}' needs an explicit type annotation."),
	        _0_is_specified_more_than_once_so_this_usage_will_be_overwritten: diag(2783, 1 /* Error */, "_0_is_specified_more_than_once_so_this_usage_will_be_overwritten_2783", "'{0}' is specified more than once, so this usage will be overwritten."),
	        get_and_set_accessors_cannot_declare_this_parameters: diag(2784, 1 /* Error */, "get_and_set_accessors_cannot_declare_this_parameters_2784", "'get' and 'set' accessors cannot declare 'this' parameters."),
	        This_spread_always_overwrites_this_property: diag(2785, 1 /* Error */, "This_spread_always_overwrites_this_property_2785", "This spread always overwrites this property."),
	        _0_cannot_be_used_as_a_JSX_component: diag(2786, 1 /* Error */, "_0_cannot_be_used_as_a_JSX_component_2786", "'{0}' cannot be used as a JSX component."),
	        Its_return_type_0_is_not_a_valid_JSX_element: diag(2787, 1 /* Error */, "Its_return_type_0_is_not_a_valid_JSX_element_2787", "Its return type '{0}' is not a valid JSX element."),
	        Its_instance_type_0_is_not_a_valid_JSX_element: diag(2788, 1 /* Error */, "Its_instance_type_0_is_not_a_valid_JSX_element_2788", "Its instance type '{0}' is not a valid JSX element."),
	        Its_element_type_0_is_not_a_valid_JSX_element: diag(2789, 1 /* Error */, "Its_element_type_0_is_not_a_valid_JSX_element_2789", "Its element type '{0}' is not a valid JSX element."),
	        The_operand_of_a_delete_operator_must_be_optional: diag(2790, 1 /* Error */, "The_operand_of_a_delete_operator_must_be_optional_2790", "The operand of a 'delete' operator must be optional."),
	        Exponentiation_cannot_be_performed_on_bigint_values_unless_the_target_option_is_set_to_es2016_or_later: diag(2791, 1 /* Error */, "Exponentiation_cannot_be_performed_on_bigint_values_unless_the_target_option_is_set_to_es2016_or_lat_2791", "Exponentiation cannot be performed on 'bigint' values unless the 'target' option is set to 'es2016' or later."),
	        Cannot_find_module_0_Did_you_mean_to_set_the_moduleResolution_option_to_nodenext_or_to_add_aliases_to_the_paths_option: diag(2792, 1 /* Error */, "Cannot_find_module_0_Did_you_mean_to_set_the_moduleResolution_option_to_nodenext_or_to_add_aliases_t_2792", "Cannot find module '{0}'. Did you mean to set the 'moduleResolution' option to 'nodenext', or to add aliases to the 'paths' option?"),
	        The_call_would_have_succeeded_against_this_implementation_but_implementation_signatures_of_overloads_are_not_externally_visible: diag(2793, 1 /* Error */, "The_call_would_have_succeeded_against_this_implementation_but_implementation_signatures_of_overloads_2793", "The call would have succeeded against this implementation, but implementation signatures of overloads are not externally visible."),
	        Expected_0_arguments_but_got_1_Did_you_forget_to_include_void_in_your_type_argument_to_Promise: diag(2794, 1 /* Error */, "Expected_0_arguments_but_got_1_Did_you_forget_to_include_void_in_your_type_argument_to_Promise_2794", "Expected {0} arguments, but got {1}. Did you forget to include 'void' in your type argument to 'Promise'?"),
	        The_intrinsic_keyword_can_only_be_used_to_declare_compiler_provided_intrinsic_types: diag(2795, 1 /* Error */, "The_intrinsic_keyword_can_only_be_used_to_declare_compiler_provided_intrinsic_types_2795", "The 'intrinsic' keyword can only be used to declare compiler provided intrinsic types."),
	        It_is_likely_that_you_are_missing_a_comma_to_separate_these_two_template_expressions_They_form_a_tagged_template_expression_which_cannot_be_invoked: diag(2796, 1 /* Error */, "It_is_likely_that_you_are_missing_a_comma_to_separate_these_two_template_expressions_They_form_a_tag_2796", "It is likely that you are missing a comma to separate these two template expressions. They form a tagged template expression which cannot be invoked."),
	        A_mixin_class_that_extends_from_a_type_variable_containing_an_abstract_construct_signature_must_also_be_declared_abstract: diag(2797, 1 /* Error */, "A_mixin_class_that_extends_from_a_type_variable_containing_an_abstract_construct_signature_must_also_2797", "A mixin class that extends from a type variable containing an abstract construct signature must also be declared 'abstract'."),
	        The_declaration_was_marked_as_deprecated_here: diag(2798, 1 /* Error */, "The_declaration_was_marked_as_deprecated_here_2798", "The declaration was marked as deprecated here."),
	        Type_produces_a_tuple_type_that_is_too_large_to_represent: diag(2799, 1 /* Error */, "Type_produces_a_tuple_type_that_is_too_large_to_represent_2799", "Type produces a tuple type that is too large to represent."),
	        Expression_produces_a_tuple_type_that_is_too_large_to_represent: diag(2800, 1 /* Error */, "Expression_produces_a_tuple_type_that_is_too_large_to_represent_2800", "Expression produces a tuple type that is too large to represent."),
	        This_condition_will_always_return_true_since_this_0_is_always_defined: diag(2801, 1 /* Error */, "This_condition_will_always_return_true_since_this_0_is_always_defined_2801", "This condition will always return true since this '{0}' is always defined."),
	        Type_0_can_only_be_iterated_through_when_using_the_downlevelIteration_flag_or_with_a_target_of_es2015_or_higher: diag(2802, 1 /* Error */, "Type_0_can_only_be_iterated_through_when_using_the_downlevelIteration_flag_or_with_a_target_of_es201_2802", "Type '{0}' can only be iterated through when using the '--downlevelIteration' flag or with a '--target' of 'es2015' or higher."),
	        Cannot_assign_to_private_method_0_Private_methods_are_not_writable: diag(2803, 1 /* Error */, "Cannot_assign_to_private_method_0_Private_methods_are_not_writable_2803", "Cannot assign to private method '{0}'. Private methods are not writable."),
	        Duplicate_identifier_0_Static_and_instance_elements_cannot_share_the_same_private_name: diag(2804, 1 /* Error */, "Duplicate_identifier_0_Static_and_instance_elements_cannot_share_the_same_private_name_2804", "Duplicate identifier '{0}'. Static and instance elements cannot share the same private name."),
	        Private_accessor_was_defined_without_a_getter: diag(2806, 1 /* Error */, "Private_accessor_was_defined_without_a_getter_2806", "Private accessor was defined without a getter."),
	        This_syntax_requires_an_imported_helper_named_1_with_2_parameters_which_is_not_compatible_with_the_one_in_0_Consider_upgrading_your_version_of_0: diag(2807, 1 /* Error */, "This_syntax_requires_an_imported_helper_named_1_with_2_parameters_which_is_not_compatible_with_the_o_2807", "This syntax requires an imported helper named '{1}' with {2} parameters, which is not compatible with the one in '{0}'. Consider upgrading your version of '{0}'."),
	        A_get_accessor_must_be_at_least_as_accessible_as_the_setter: diag(2808, 1 /* Error */, "A_get_accessor_must_be_at_least_as_accessible_as_the_setter_2808", "A get accessor must be at least as accessible as the setter"),
	        Declaration_or_statement_expected_This_follows_a_block_of_statements_so_if_you_intended_to_write_a_destructuring_assignment_you_might_need_to_wrap_the_whole_assignment_in_parentheses: diag(2809, 1 /* Error */, "Declaration_or_statement_expected_This_follows_a_block_of_statements_so_if_you_intended_to_write_a_d_2809", "Declaration or statement expected. This '=' follows a block of statements, so if you intended to write a destructuring assignment, you might need to wrap the whole assignment in parentheses."),
	        Expected_1_argument_but_got_0_new_Promise_needs_a_JSDoc_hint_to_produce_a_resolve_that_can_be_called_without_arguments: diag(2810, 1 /* Error */, "Expected_1_argument_but_got_0_new_Promise_needs_a_JSDoc_hint_to_produce_a_resolve_that_can_be_called_2810", "Expected 1 argument, but got 0. 'new Promise()' needs a JSDoc hint to produce a 'resolve' that can be called without arguments."),
	        Initializer_for_property_0: diag(2811, 1 /* Error */, "Initializer_for_property_0_2811", "Initializer for property '{0}'"),
	        Property_0_does_not_exist_on_type_1_Try_changing_the_lib_compiler_option_to_include_dom: diag(2812, 1 /* Error */, "Property_0_does_not_exist_on_type_1_Try_changing_the_lib_compiler_option_to_include_dom_2812", "Property '{0}' does not exist on type '{1}'. Try changing the 'lib' compiler option to include 'dom'."),
	        Class_declaration_cannot_implement_overload_list_for_0: diag(2813, 1 /* Error */, "Class_declaration_cannot_implement_overload_list_for_0_2813", "Class declaration cannot implement overload list for '{0}'."),
	        Function_with_bodies_can_only_merge_with_classes_that_are_ambient: diag(2814, 1 /* Error */, "Function_with_bodies_can_only_merge_with_classes_that_are_ambient_2814", "Function with bodies can only merge with classes that are ambient."),
	        arguments_cannot_be_referenced_in_property_initializers: diag(2815, 1 /* Error */, "arguments_cannot_be_referenced_in_property_initializers_2815", "'arguments' cannot be referenced in property initializers."),
	        Cannot_use_this_in_a_static_property_initializer_of_a_decorated_class: diag(2816, 1 /* Error */, "Cannot_use_this_in_a_static_property_initializer_of_a_decorated_class_2816", "Cannot use 'this' in a static property initializer of a decorated class."),
	        Property_0_has_no_initializer_and_is_not_definitely_assigned_in_a_class_static_block: diag(2817, 1 /* Error */, "Property_0_has_no_initializer_and_is_not_definitely_assigned_in_a_class_static_block_2817", "Property '{0}' has no initializer and is not definitely assigned in a class static block."),
	        Duplicate_identifier_0_Compiler_reserves_name_1_when_emitting_super_references_in_static_initializers: diag(2818, 1 /* Error */, "Duplicate_identifier_0_Compiler_reserves_name_1_when_emitting_super_references_in_static_initializer_2818", "Duplicate identifier '{0}'. Compiler reserves name '{1}' when emitting 'super' references in static initializers."),
	        Namespace_name_cannot_be_0: diag(2819, 1 /* Error */, "Namespace_name_cannot_be_0_2819", "Namespace name cannot be '{0}'."),
	        Type_0_is_not_assignable_to_type_1_Did_you_mean_2: diag(2820, 1 /* Error */, "Type_0_is_not_assignable_to_type_1_Did_you_mean_2_2820", "Type '{0}' is not assignable to type '{1}'. Did you mean '{2}'?"),
	        Import_assertions_are_only_supported_when_the_module_option_is_set_to_esnext_nodenext_or_preserve: diag(2821, 1 /* Error */, "Import_assertions_are_only_supported_when_the_module_option_is_set_to_esnext_nodenext_or_preserve_2821", "Import assertions are only supported when the '--module' option is set to 'esnext', 'nodenext', or 'preserve'."),
	        Import_assertions_cannot_be_used_with_type_only_imports_or_exports: diag(2822, 1 /* Error */, "Import_assertions_cannot_be_used_with_type_only_imports_or_exports_2822", "Import assertions cannot be used with type-only imports or exports."),
	        Import_attributes_are_only_supported_when_the_module_option_is_set_to_esnext_nodenext_or_preserve: diag(2823, 1 /* Error */, "Import_attributes_are_only_supported_when_the_module_option_is_set_to_esnext_nodenext_or_preserve_2823", "Import attributes are only supported when the '--module' option is set to 'esnext', 'nodenext', or 'preserve'."),
	        Cannot_find_namespace_0_Did_you_mean_1: diag(2833, 1 /* Error */, "Cannot_find_namespace_0_Did_you_mean_1_2833", "Cannot find namespace '{0}'. Did you mean '{1}'?"),
	        Relative_import_paths_need_explicit_file_extensions_in_ECMAScript_imports_when_moduleResolution_is_node16_or_nodenext_Consider_adding_an_extension_to_the_import_path: diag(2834, 1 /* Error */, "Relative_import_paths_need_explicit_file_extensions_in_ECMAScript_imports_when_moduleResolution_is_n_2834", "Relative import paths need explicit file extensions in ECMAScript imports when '--moduleResolution' is 'node16' or 'nodenext'. Consider adding an extension to the import path."),
	        Relative_import_paths_need_explicit_file_extensions_in_ECMAScript_imports_when_moduleResolution_is_node16_or_nodenext_Did_you_mean_0: diag(2835, 1 /* Error */, "Relative_import_paths_need_explicit_file_extensions_in_ECMAScript_imports_when_moduleResolution_is_n_2835", "Relative import paths need explicit file extensions in ECMAScript imports when '--moduleResolution' is 'node16' or 'nodenext'. Did you mean '{0}'?"),
	        Import_assertions_are_not_allowed_on_statements_that_compile_to_CommonJS_require_calls: diag(2836, 1 /* Error */, "Import_assertions_are_not_allowed_on_statements_that_compile_to_CommonJS_require_calls_2836", "Import assertions are not allowed on statements that compile to CommonJS 'require' calls."),
	        Import_assertion_values_must_be_string_literal_expressions: diag(2837, 1 /* Error */, "Import_assertion_values_must_be_string_literal_expressions_2837", "Import assertion values must be string literal expressions."),
	        All_declarations_of_0_must_have_identical_constraints: diag(2838, 1 /* Error */, "All_declarations_of_0_must_have_identical_constraints_2838", "All declarations of '{0}' must have identical constraints."),
	        This_condition_will_always_return_0_since_JavaScript_compares_objects_by_reference_not_value: diag(2839, 1 /* Error */, "This_condition_will_always_return_0_since_JavaScript_compares_objects_by_reference_not_value_2839", "This condition will always return '{0}' since JavaScript compares objects by reference, not value."),
	        An_interface_cannot_extend_a_primitive_type_like_0_It_can_only_extend_other_named_object_types: diag(2840, 1 /* Error */, "An_interface_cannot_extend_a_primitive_type_like_0_It_can_only_extend_other_named_object_types_2840", "An interface cannot extend a primitive type like '{0}'. It can only extend other named object types."),
	        _0_is_an_unused_renaming_of_1_Did_you_intend_to_use_it_as_a_type_annotation: diag(2842, 1 /* Error */, "_0_is_an_unused_renaming_of_1_Did_you_intend_to_use_it_as_a_type_annotation_2842", "'{0}' is an unused renaming of '{1}'. Did you intend to use it as a type annotation?"),
	        We_can_only_write_a_type_for_0_by_adding_a_type_for_the_entire_parameter_here: diag(2843, 1 /* Error */, "We_can_only_write_a_type_for_0_by_adding_a_type_for_the_entire_parameter_here_2843", "We can only write a type for '{0}' by adding a type for the entire parameter here."),
	        Type_of_instance_member_variable_0_cannot_reference_identifier_1_declared_in_the_constructor: diag(2844, 1 /* Error */, "Type_of_instance_member_variable_0_cannot_reference_identifier_1_declared_in_the_constructor_2844", "Type of instance member variable '{0}' cannot reference identifier '{1}' declared in the constructor."),
	        This_condition_will_always_return_0: diag(2845, 1 /* Error */, "This_condition_will_always_return_0_2845", "This condition will always return '{0}'."),
	        A_declaration_file_cannot_be_imported_without_import_type_Did_you_mean_to_import_an_implementation_file_0_instead: diag(2846, 1 /* Error */, "A_declaration_file_cannot_be_imported_without_import_type_Did_you_mean_to_import_an_implementation_f_2846", "A declaration file cannot be imported without 'import type'. Did you mean to import an implementation file '{0}' instead?"),
	        The_right_hand_side_of_an_instanceof_expression_must_not_be_an_instantiation_expression: diag(2848, 1 /* Error */, "The_right_hand_side_of_an_instanceof_expression_must_not_be_an_instantiation_expression_2848", "The right-hand side of an 'instanceof' expression must not be an instantiation expression."),
	        Target_signature_provides_too_few_arguments_Expected_0_or_more_but_got_1: diag(2849, 1 /* Error */, "Target_signature_provides_too_few_arguments_Expected_0_or_more_but_got_1_2849", "Target signature provides too few arguments. Expected {0} or more, but got {1}."),
	        The_initializer_of_a_using_declaration_must_be_either_an_object_with_a_Symbol_dispose_method_or_be_null_or_undefined: diag(2850, 1 /* Error */, "The_initializer_of_a_using_declaration_must_be_either_an_object_with_a_Symbol_dispose_method_or_be_n_2850", "The initializer of a 'using' declaration must be either an object with a '[Symbol.dispose]()' method, or be 'null' or 'undefined'."),
	        The_initializer_of_an_await_using_declaration_must_be_either_an_object_with_a_Symbol_asyncDispose_or_Symbol_dispose_method_or_be_null_or_undefined: diag(2851, 1 /* Error */, "The_initializer_of_an_await_using_declaration_must_be_either_an_object_with_a_Symbol_asyncDispose_or_2851", "The initializer of an 'await using' declaration must be either an object with a '[Symbol.asyncDispose]()' or '[Symbol.dispose]()' method, or be 'null' or 'undefined'."),
	        await_using_statements_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules: diag(2852, 1 /* Error */, "await_using_statements_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules_2852", "'await using' statements are only allowed within async functions and at the top levels of modules."),
	        await_using_statements_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_file_has_no_imports_or_exports_Consider_adding_an_empty_export_to_make_this_file_a_module: diag(2853, 1 /* Error */, "await_using_statements_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_th_2853", "'await using' statements are only allowed at the top level of a file when that file is a module, but this file has no imports or exports. Consider adding an empty 'export {}' to make this file a module."),
	        Top_level_await_using_statements_are_only_allowed_when_the_module_option_is_set_to_es2022_esnext_system_node16_nodenext_or_preserve_and_the_target_option_is_set_to_es2017_or_higher: diag(2854, 1 /* Error */, "Top_level_await_using_statements_are_only_allowed_when_the_module_option_is_set_to_es2022_esnext_sys_2854", "Top-level 'await using' statements are only allowed when the 'module' option is set to 'es2022', 'esnext', 'system', 'node16', 'nodenext', or 'preserve', and the 'target' option is set to 'es2017' or higher."),
	        Class_field_0_defined_by_the_parent_class_is_not_accessible_in_the_child_class_via_super: diag(2855, 1 /* Error */, "Class_field_0_defined_by_the_parent_class_is_not_accessible_in_the_child_class_via_super_2855", "Class field '{0}' defined by the parent class is not accessible in the child class via super."),
	        Import_attributes_are_not_allowed_on_statements_that_compile_to_CommonJS_require_calls: diag(2856, 1 /* Error */, "Import_attributes_are_not_allowed_on_statements_that_compile_to_CommonJS_require_calls_2856", "Import attributes are not allowed on statements that compile to CommonJS 'require' calls."),
	        Import_attributes_cannot_be_used_with_type_only_imports_or_exports: diag(2857, 1 /* Error */, "Import_attributes_cannot_be_used_with_type_only_imports_or_exports_2857", "Import attributes cannot be used with type-only imports or exports."),
	        Import_attribute_values_must_be_string_literal_expressions: diag(2858, 1 /* Error */, "Import_attribute_values_must_be_string_literal_expressions_2858", "Import attribute values must be string literal expressions."),
	        Excessive_complexity_comparing_types_0_and_1: diag(2859, 1 /* Error */, "Excessive_complexity_comparing_types_0_and_1_2859", "Excessive complexity comparing types '{0}' and '{1}'."),
	        The_left_hand_side_of_an_instanceof_expression_must_be_assignable_to_the_first_argument_of_the_right_hand_side_s_Symbol_hasInstance_method: diag(2860, 1 /* Error */, "The_left_hand_side_of_an_instanceof_expression_must_be_assignable_to_the_first_argument_of_the_right_2860", "The left-hand side of an 'instanceof' expression must be assignable to the first argument of the right-hand side's '[Symbol.hasInstance]' method."),
	        An_object_s_Symbol_hasInstance_method_must_return_a_boolean_value_for_it_to_be_used_on_the_right_hand_side_of_an_instanceof_expression: diag(2861, 1 /* Error */, "An_object_s_Symbol_hasInstance_method_must_return_a_boolean_value_for_it_to_be_used_on_the_right_han_2861", "An object's '[Symbol.hasInstance]' method must return a boolean value for it to be used on the right-hand side of an 'instanceof' expression."),
	        Type_0_is_generic_and_can_only_be_indexed_for_reading: diag(2862, 1 /* Error */, "Type_0_is_generic_and_can_only_be_indexed_for_reading_2862", "Type '{0}' is generic and can only be indexed for reading."),
	        A_class_cannot_extend_a_primitive_type_like_0_Classes_can_only_extend_constructable_values: diag(2863, 1 /* Error */, "A_class_cannot_extend_a_primitive_type_like_0_Classes_can_only_extend_constructable_values_2863", "A class cannot extend a primitive type like '{0}'. Classes can only extend constructable values."),
	        A_class_cannot_implement_a_primitive_type_like_0_It_can_only_implement_other_named_object_types: diag(2864, 1 /* Error */, "A_class_cannot_implement_a_primitive_type_like_0_It_can_only_implement_other_named_object_types_2864", "A class cannot implement a primitive type like '{0}'. It can only implement other named object types."),
	        Import_0_conflicts_with_local_value_so_must_be_declared_with_a_type_only_import_when_isolatedModules_is_enabled: diag(2865, 1 /* Error */, "Import_0_conflicts_with_local_value_so_must_be_declared_with_a_type_only_import_when_isolatedModules_2865", "Import '{0}' conflicts with local value, so must be declared with a type-only import when 'isolatedModules' is enabled."),
	        Import_0_conflicts_with_global_value_used_in_this_file_so_must_be_declared_with_a_type_only_import_when_isolatedModules_is_enabled: diag(2866, 1 /* Error */, "Import_0_conflicts_with_global_value_used_in_this_file_so_must_be_declared_with_a_type_only_import_w_2866", "Import '{0}' conflicts with global value used in this file, so must be declared with a type-only import when 'isolatedModules' is enabled."),
	        Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_Bun_Try_npm_i_save_dev_types_Slashbun: diag(2867, 1 /* Error */, "Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_Bun_Try_npm_i_save_dev_types_Slashbun_2867", "Cannot find name '{0}'. Do you need to install type definitions for Bun? Try `npm i --save-dev @types/bun`."),
	        Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_Bun_Try_npm_i_save_dev_types_Slashbun_and_then_add_bun_to_the_types_field_in_your_tsconfig: diag(2868, 1 /* Error */, "Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_Bun_Try_npm_i_save_dev_types_Slashbun_2868", "Cannot find name '{0}'. Do you need to install type definitions for Bun? Try `npm i --save-dev @types/bun` and then add 'bun' to the types field in your tsconfig."),
	        Import_declaration_0_is_using_private_name_1: diag(4e3, 1 /* Error */, "Import_declaration_0_is_using_private_name_1_4000", "Import declaration '{0}' is using private name '{1}'."),
	        Type_parameter_0_of_exported_class_has_or_is_using_private_name_1: diag(4002, 1 /* Error */, "Type_parameter_0_of_exported_class_has_or_is_using_private_name_1_4002", "Type parameter '{0}' of exported class has or is using private name '{1}'."),
	        Type_parameter_0_of_exported_interface_has_or_is_using_private_name_1: diag(4004, 1 /* Error */, "Type_parameter_0_of_exported_interface_has_or_is_using_private_name_1_4004", "Type parameter '{0}' of exported interface has or is using private name '{1}'."),
	        Type_parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_1: diag(4006, 1 /* Error */, "Type_parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_1_4006", "Type parameter '{0}' of constructor signature from exported interface has or is using private name '{1}'."),
	        Type_parameter_0_of_call_signature_from_exported_interface_has_or_is_using_private_name_1: diag(4008, 1 /* Error */, "Type_parameter_0_of_call_signature_from_exported_interface_has_or_is_using_private_name_1_4008", "Type parameter '{0}' of call signature from exported interface has or is using private name '{1}'."),
	        Type_parameter_0_of_public_static_method_from_exported_class_has_or_is_using_private_name_1: diag(4010, 1 /* Error */, "Type_parameter_0_of_public_static_method_from_exported_class_has_or_is_using_private_name_1_4010", "Type parameter '{0}' of public static method from exported class has or is using private name '{1}'."),
	        Type_parameter_0_of_public_method_from_exported_class_has_or_is_using_private_name_1: diag(4012, 1 /* Error */, "Type_parameter_0_of_public_method_from_exported_class_has_or_is_using_private_name_1_4012", "Type parameter '{0}' of public method from exported class has or is using private name '{1}'."),
	        Type_parameter_0_of_method_from_exported_interface_has_or_is_using_private_name_1: diag(4014, 1 /* Error */, "Type_parameter_0_of_method_from_exported_interface_has_or_is_using_private_name_1_4014", "Type parameter '{0}' of method from exported interface has or is using private name '{1}'."),
	        Type_parameter_0_of_exported_function_has_or_is_using_private_name_1: diag(4016, 1 /* Error */, "Type_parameter_0_of_exported_function_has_or_is_using_private_name_1_4016", "Type parameter '{0}' of exported function has or is using private name '{1}'."),
	        Implements_clause_of_exported_class_0_has_or_is_using_private_name_1: diag(4019, 1 /* Error */, "Implements_clause_of_exported_class_0_has_or_is_using_private_name_1_4019", "Implements clause of exported class '{0}' has or is using private name '{1}'."),
	        extends_clause_of_exported_class_0_has_or_is_using_private_name_1: diag(4020, 1 /* Error */, "extends_clause_of_exported_class_0_has_or_is_using_private_name_1_4020", "'extends' clause of exported class '{0}' has or is using private name '{1}'."),
	        extends_clause_of_exported_class_has_or_is_using_private_name_0: diag(4021, 1 /* Error */, "extends_clause_of_exported_class_has_or_is_using_private_name_0_4021", "'extends' clause of exported class has or is using private name '{0}'."),
	        extends_clause_of_exported_interface_0_has_or_is_using_private_name_1: diag(4022, 1 /* Error */, "extends_clause_of_exported_interface_0_has_or_is_using_private_name_1_4022", "'extends' clause of exported interface '{0}' has or is using private name '{1}'."),
	        Exported_variable_0_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: diag(4023, 1 /* Error */, "Exported_variable_0_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named_4023", "Exported variable '{0}' has or is using name '{1}' from external module {2} but cannot be named."),
	        Exported_variable_0_has_or_is_using_name_1_from_private_module_2: diag(4024, 1 /* Error */, "Exported_variable_0_has_or_is_using_name_1_from_private_module_2_4024", "Exported variable '{0}' has or is using name '{1}' from private module '{2}'."),
	        Exported_variable_0_has_or_is_using_private_name_1: diag(4025, 1 /* Error */, "Exported_variable_0_has_or_is_using_private_name_1_4025", "Exported variable '{0}' has or is using private name '{1}'."),
	        Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: diag(4026, 1 /* Error */, "Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot__4026", "Public static property '{0}' of exported class has or is using name '{1}' from external module {2} but cannot be named."),
	        Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2: diag(4027, 1 /* Error */, "Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2_4027", "Public static property '{0}' of exported class has or is using name '{1}' from private module '{2}'."),
	        Public_static_property_0_of_exported_class_has_or_is_using_private_name_1: diag(4028, 1 /* Error */, "Public_static_property_0_of_exported_class_has_or_is_using_private_name_1_4028", "Public static property '{0}' of exported class has or is using private name '{1}'."),
	        Public_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: diag(4029, 1 /* Error */, "Public_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_name_4029", "Public property '{0}' of exported class has or is using name '{1}' from external module {2} but cannot be named."),
	        Public_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2: diag(4030, 1 /* Error */, "Public_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2_4030", "Public property '{0}' of exported class has or is using name '{1}' from private module '{2}'."),
	        Public_property_0_of_exported_class_has_or_is_using_private_name_1: diag(4031, 1 /* Error */, "Public_property_0_of_exported_class_has_or_is_using_private_name_1_4031", "Public property '{0}' of exported class has or is using private name '{1}'."),
	        Property_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2: diag(4032, 1 /* Error */, "Property_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2_4032", "Property '{0}' of exported interface has or is using name '{1}' from private module '{2}'."),
	        Property_0_of_exported_interface_has_or_is_using_private_name_1: diag(4033, 1 /* Error */, "Property_0_of_exported_interface_has_or_is_using_private_name_1_4033", "Property '{0}' of exported interface has or is using private name '{1}'."),
	        Parameter_type_of_public_static_setter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2: diag(4034, 1 /* Error */, "Parameter_type_of_public_static_setter_0_from_exported_class_has_or_is_using_name_1_from_private_mod_4034", "Parameter type of public static setter '{0}' from exported class has or is using name '{1}' from private module '{2}'."),
	        Parameter_type_of_public_static_setter_0_from_exported_class_has_or_is_using_private_name_1: diag(4035, 1 /* Error */, "Parameter_type_of_public_static_setter_0_from_exported_class_has_or_is_using_private_name_1_4035", "Parameter type of public static setter '{0}' from exported class has or is using private name '{1}'."),
	        Parameter_type_of_public_setter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2: diag(4036, 1 /* Error */, "Parameter_type_of_public_setter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2_4036", "Parameter type of public setter '{0}' from exported class has or is using name '{1}' from private module '{2}'."),
	        Parameter_type_of_public_setter_0_from_exported_class_has_or_is_using_private_name_1: diag(4037, 1 /* Error */, "Parameter_type_of_public_setter_0_from_exported_class_has_or_is_using_private_name_1_4037", "Parameter type of public setter '{0}' from exported class has or is using private name '{1}'."),
	        Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: diag(4038, 1 /* Error */, "Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_name_1_from_external_modul_4038", "Return type of public static getter '{0}' from exported class has or is using name '{1}' from external module {2} but cannot be named."),
	        Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2: diag(4039, 1 /* Error */, "Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_name_1_from_private_module_4039", "Return type of public static getter '{0}' from exported class has or is using name '{1}' from private module '{2}'."),
	        Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_private_name_1: diag(4040, 1 /* Error */, "Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_private_name_1_4040", "Return type of public static getter '{0}' from exported class has or is using private name '{1}'."),
	        Return_type_of_public_getter_0_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: diag(4041, 1 /* Error */, "Return_type_of_public_getter_0_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_4041", "Return type of public getter '{0}' from exported class has or is using name '{1}' from external module {2} but cannot be named."),
	        Return_type_of_public_getter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2: diag(4042, 1 /* Error */, "Return_type_of_public_getter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2_4042", "Return type of public getter '{0}' from exported class has or is using name '{1}' from private module '{2}'."),
	        Return_type_of_public_getter_0_from_exported_class_has_or_is_using_private_name_1: diag(4043, 1 /* Error */, "Return_type_of_public_getter_0_from_exported_class_has_or_is_using_private_name_1_4043", "Return type of public getter '{0}' from exported class has or is using private name '{1}'."),
	        Return_type_of_constructor_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1: diag(4044, 1 /* Error */, "Return_type_of_constructor_signature_from_exported_interface_has_or_is_using_name_0_from_private_mod_4044", "Return type of constructor signature from exported interface has or is using name '{0}' from private module '{1}'."),
	        Return_type_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_0: diag(4045, 1 /* Error */, "Return_type_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_0_4045", "Return type of constructor signature from exported interface has or is using private name '{0}'."),
	        Return_type_of_call_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1: diag(4046, 1 /* Error */, "Return_type_of_call_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1_4046", "Return type of call signature from exported interface has or is using name '{0}' from private module '{1}'."),
	        Return_type_of_call_signature_from_exported_interface_has_or_is_using_private_name_0: diag(4047, 1 /* Error */, "Return_type_of_call_signature_from_exported_interface_has_or_is_using_private_name_0_4047", "Return type of call signature from exported interface has or is using private name '{0}'."),
	        Return_type_of_index_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1: diag(4048, 1 /* Error */, "Return_type_of_index_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1_4048", "Return type of index signature from exported interface has or is using name '{0}' from private module '{1}'."),
	        Return_type_of_index_signature_from_exported_interface_has_or_is_using_private_name_0: diag(4049, 1 /* Error */, "Return_type_of_index_signature_from_exported_interface_has_or_is_using_private_name_0_4049", "Return type of index signature from exported interface has or is using private name '{0}'."),
	        Return_type_of_public_static_method_from_exported_class_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named: diag(4050, 1 /* Error */, "Return_type_of_public_static_method_from_exported_class_has_or_is_using_name_0_from_external_module__4050", "Return type of public static method from exported class has or is using name '{0}' from external module {1} but cannot be named."),
	        Return_type_of_public_static_method_from_exported_class_has_or_is_using_name_0_from_private_module_1: diag(4051, 1 /* Error */, "Return_type_of_public_static_method_from_exported_class_has_or_is_using_name_0_from_private_module_1_4051", "Return type of public static method from exported class has or is using name '{0}' from private module '{1}'."),
	        Return_type_of_public_static_method_from_exported_class_has_or_is_using_private_name_0: diag(4052, 1 /* Error */, "Return_type_of_public_static_method_from_exported_class_has_or_is_using_private_name_0_4052", "Return type of public static method from exported class has or is using private name '{0}'."),
	        Return_type_of_public_method_from_exported_class_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named: diag(4053, 1 /* Error */, "Return_type_of_public_method_from_exported_class_has_or_is_using_name_0_from_external_module_1_but_c_4053", "Return type of public method from exported class has or is using name '{0}' from external module {1} but cannot be named."),
	        Return_type_of_public_method_from_exported_class_has_or_is_using_name_0_from_private_module_1: diag(4054, 1 /* Error */, "Return_type_of_public_method_from_exported_class_has_or_is_using_name_0_from_private_module_1_4054", "Return type of public method from exported class has or is using name '{0}' from private module '{1}'."),
	        Return_type_of_public_method_from_exported_class_has_or_is_using_private_name_0: diag(4055, 1 /* Error */, "Return_type_of_public_method_from_exported_class_has_or_is_using_private_name_0_4055", "Return type of public method from exported class has or is using private name '{0}'."),
	        Return_type_of_method_from_exported_interface_has_or_is_using_name_0_from_private_module_1: diag(4056, 1 /* Error */, "Return_type_of_method_from_exported_interface_has_or_is_using_name_0_from_private_module_1_4056", "Return type of method from exported interface has or is using name '{0}' from private module '{1}'."),
	        Return_type_of_method_from_exported_interface_has_or_is_using_private_name_0: diag(4057, 1 /* Error */, "Return_type_of_method_from_exported_interface_has_or_is_using_private_name_0_4057", "Return type of method from exported interface has or is using private name '{0}'."),
	        Return_type_of_exported_function_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named: diag(4058, 1 /* Error */, "Return_type_of_exported_function_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named_4058", "Return type of exported function has or is using name '{0}' from external module {1} but cannot be named."),
	        Return_type_of_exported_function_has_or_is_using_name_0_from_private_module_1: diag(4059, 1 /* Error */, "Return_type_of_exported_function_has_or_is_using_name_0_from_private_module_1_4059", "Return type of exported function has or is using name '{0}' from private module '{1}'."),
	        Return_type_of_exported_function_has_or_is_using_private_name_0: diag(4060, 1 /* Error */, "Return_type_of_exported_function_has_or_is_using_private_name_0_4060", "Return type of exported function has or is using private name '{0}'."),
	        Parameter_0_of_constructor_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: diag(4061, 1 /* Error */, "Parameter_0_of_constructor_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_can_4061", "Parameter '{0}' of constructor from exported class has or is using name '{1}' from external module {2} but cannot be named."),
	        Parameter_0_of_constructor_from_exported_class_has_or_is_using_name_1_from_private_module_2: diag(4062, 1 /* Error */, "Parameter_0_of_constructor_from_exported_class_has_or_is_using_name_1_from_private_module_2_4062", "Parameter '{0}' of constructor from exported class has or is using name '{1}' from private module '{2}'."),
	        Parameter_0_of_constructor_from_exported_class_has_or_is_using_private_name_1: diag(4063, 1 /* Error */, "Parameter_0_of_constructor_from_exported_class_has_or_is_using_private_name_1_4063", "Parameter '{0}' of constructor from exported class has or is using private name '{1}'."),
	        Parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2: diag(4064, 1 /* Error */, "Parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_name_1_from_private_mod_4064", "Parameter '{0}' of constructor signature from exported interface has or is using name '{1}' from private module '{2}'."),
	        Parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_1: diag(4065, 1 /* Error */, "Parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_1_4065", "Parameter '{0}' of constructor signature from exported interface has or is using private name '{1}'."),
	        Parameter_0_of_call_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2: diag(4066, 1 /* Error */, "Parameter_0_of_call_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2_4066", "Parameter '{0}' of call signature from exported interface has or is using name '{1}' from private module '{2}'."),
	        Parameter_0_of_call_signature_from_exported_interface_has_or_is_using_private_name_1: diag(4067, 1 /* Error */, "Parameter_0_of_call_signature_from_exported_interface_has_or_is_using_private_name_1_4067", "Parameter '{0}' of call signature from exported interface has or is using private name '{1}'."),
	        Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: diag(4068, 1 /* Error */, "Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_name_1_from_external_module__4068", "Parameter '{0}' of public static method from exported class has or is using name '{1}' from external module {2} but cannot be named."),
	        Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_name_1_from_private_module_2: diag(4069, 1 /* Error */, "Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_name_1_from_private_module_2_4069", "Parameter '{0}' of public static method from exported class has or is using name '{1}' from private module '{2}'."),
	        Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_private_name_1: diag(4070, 1 /* Error */, "Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_private_name_1_4070", "Parameter '{0}' of public static method from exported class has or is using private name '{1}'."),
	        Parameter_0_of_public_method_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: diag(4071, 1 /* Error */, "Parameter_0_of_public_method_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_c_4071", "Parameter '{0}' of public method from exported class has or is using name '{1}' from external module {2} but cannot be named."),
	        Parameter_0_of_public_method_from_exported_class_has_or_is_using_name_1_from_private_module_2: diag(4072, 1 /* Error */, "Parameter_0_of_public_method_from_exported_class_has_or_is_using_name_1_from_private_module_2_4072", "Parameter '{0}' of public method from exported class has or is using name '{1}' from private module '{2}'."),
	        Parameter_0_of_public_method_from_exported_class_has_or_is_using_private_name_1: diag(4073, 1 /* Error */, "Parameter_0_of_public_method_from_exported_class_has_or_is_using_private_name_1_4073", "Parameter '{0}' of public method from exported class has or is using private name '{1}'."),
	        Parameter_0_of_method_from_exported_interface_has_or_is_using_name_1_from_private_module_2: diag(4074, 1 /* Error */, "Parameter_0_of_method_from_exported_interface_has_or_is_using_name_1_from_private_module_2_4074", "Parameter '{0}' of method from exported interface has or is using name '{1}' from private module '{2}'."),
	        Parameter_0_of_method_from_exported_interface_has_or_is_using_private_name_1: diag(4075, 1 /* Error */, "Parameter_0_of_method_from_exported_interface_has_or_is_using_private_name_1_4075", "Parameter '{0}' of method from exported interface has or is using private name '{1}'."),
	        Parameter_0_of_exported_function_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: diag(4076, 1 /* Error */, "Parameter_0_of_exported_function_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named_4076", "Parameter '{0}' of exported function has or is using name '{1}' from external module {2} but cannot be named."),
	        Parameter_0_of_exported_function_has_or_is_using_name_1_from_private_module_2: diag(4077, 1 /* Error */, "Parameter_0_of_exported_function_has_or_is_using_name_1_from_private_module_2_4077", "Parameter '{0}' of exported function has or is using name '{1}' from private module '{2}'."),
	        Parameter_0_of_exported_function_has_or_is_using_private_name_1: diag(4078, 1 /* Error */, "Parameter_0_of_exported_function_has_or_is_using_private_name_1_4078", "Parameter '{0}' of exported function has or is using private name '{1}'."),
	        Exported_type_alias_0_has_or_is_using_private_name_1: diag(4081, 1 /* Error */, "Exported_type_alias_0_has_or_is_using_private_name_1_4081", "Exported type alias '{0}' has or is using private name '{1}'."),
	        Default_export_of_the_module_has_or_is_using_private_name_0: diag(4082, 1 /* Error */, "Default_export_of_the_module_has_or_is_using_private_name_0_4082", "Default export of the module has or is using private name '{0}'."),
	        Type_parameter_0_of_exported_type_alias_has_or_is_using_private_name_1: diag(4083, 1 /* Error */, "Type_parameter_0_of_exported_type_alias_has_or_is_using_private_name_1_4083", "Type parameter '{0}' of exported type alias has or is using private name '{1}'."),
	        Exported_type_alias_0_has_or_is_using_private_name_1_from_module_2: diag(4084, 1 /* Error */, "Exported_type_alias_0_has_or_is_using_private_name_1_from_module_2_4084", "Exported type alias '{0}' has or is using private name '{1}' from module {2}."),
	        Extends_clause_for_inferred_type_0_has_or_is_using_private_name_1: diag(4085, 1 /* Error */, "Extends_clause_for_inferred_type_0_has_or_is_using_private_name_1_4085", "Extends clause for inferred type '{0}' has or is using private name '{1}'."),
	        Conflicting_definitions_for_0_found_at_1_and_2_Consider_installing_a_specific_version_of_this_library_to_resolve_the_conflict: diag(4090, 1 /* Error */, "Conflicting_definitions_for_0_found_at_1_and_2_Consider_installing_a_specific_version_of_this_librar_4090", "Conflicting definitions for '{0}' found at '{1}' and '{2}'. Consider installing a specific version of this library to resolve the conflict."),
	        Parameter_0_of_index_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2: diag(4091, 1 /* Error */, "Parameter_0_of_index_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2_4091", "Parameter '{0}' of index signature from exported interface has or is using name '{1}' from private module '{2}'."),
	        Parameter_0_of_index_signature_from_exported_interface_has_or_is_using_private_name_1: diag(4092, 1 /* Error */, "Parameter_0_of_index_signature_from_exported_interface_has_or_is_using_private_name_1_4092", "Parameter '{0}' of index signature from exported interface has or is using private name '{1}'."),
	        Property_0_of_exported_class_expression_may_not_be_private_or_protected: diag(4094, 1 /* Error */, "Property_0_of_exported_class_expression_may_not_be_private_or_protected_4094", "Property '{0}' of exported class expression may not be private or protected."),
	        Public_static_method_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: diag(4095, 1 /* Error */, "Public_static_method_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_4095", "Public static method '{0}' of exported class has or is using name '{1}' from external module {2} but cannot be named."),
	        Public_static_method_0_of_exported_class_has_or_is_using_name_1_from_private_module_2: diag(4096, 1 /* Error */, "Public_static_method_0_of_exported_class_has_or_is_using_name_1_from_private_module_2_4096", "Public static method '{0}' of exported class has or is using name '{1}' from private module '{2}'."),
	        Public_static_method_0_of_exported_class_has_or_is_using_private_name_1: diag(4097, 1 /* Error */, "Public_static_method_0_of_exported_class_has_or_is_using_private_name_1_4097", "Public static method '{0}' of exported class has or is using private name '{1}'."),
	        Public_method_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: diag(4098, 1 /* Error */, "Public_method_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named_4098", "Public method '{0}' of exported class has or is using name '{1}' from external module {2} but cannot be named."),
	        Public_method_0_of_exported_class_has_or_is_using_name_1_from_private_module_2: diag(4099, 1 /* Error */, "Public_method_0_of_exported_class_has_or_is_using_name_1_from_private_module_2_4099", "Public method '{0}' of exported class has or is using name '{1}' from private module '{2}'."),
	        Public_method_0_of_exported_class_has_or_is_using_private_name_1: diag(4100, 1 /* Error */, "Public_method_0_of_exported_class_has_or_is_using_private_name_1_4100", "Public method '{0}' of exported class has or is using private name '{1}'."),
	        Method_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2: diag(4101, 1 /* Error */, "Method_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2_4101", "Method '{0}' of exported interface has or is using name '{1}' from private module '{2}'."),
	        Method_0_of_exported_interface_has_or_is_using_private_name_1: diag(4102, 1 /* Error */, "Method_0_of_exported_interface_has_or_is_using_private_name_1_4102", "Method '{0}' of exported interface has or is using private name '{1}'."),
	        Type_parameter_0_of_exported_mapped_object_type_is_using_private_name_1: diag(4103, 1 /* Error */, "Type_parameter_0_of_exported_mapped_object_type_is_using_private_name_1_4103", "Type parameter '{0}' of exported mapped object type is using private name '{1}'."),
	        The_type_0_is_readonly_and_cannot_be_assigned_to_the_mutable_type_1: diag(4104, 1 /* Error */, "The_type_0_is_readonly_and_cannot_be_assigned_to_the_mutable_type_1_4104", "The type '{0}' is 'readonly' and cannot be assigned to the mutable type '{1}'."),
	        Private_or_protected_member_0_cannot_be_accessed_on_a_type_parameter: diag(4105, 1 /* Error */, "Private_or_protected_member_0_cannot_be_accessed_on_a_type_parameter_4105", "Private or protected member '{0}' cannot be accessed on a type parameter."),
	        Parameter_0_of_accessor_has_or_is_using_private_name_1: diag(4106, 1 /* Error */, "Parameter_0_of_accessor_has_or_is_using_private_name_1_4106", "Parameter '{0}' of accessor has or is using private name '{1}'."),
	        Parameter_0_of_accessor_has_or_is_using_name_1_from_private_module_2: diag(4107, 1 /* Error */, "Parameter_0_of_accessor_has_or_is_using_name_1_from_private_module_2_4107", "Parameter '{0}' of accessor has or is using name '{1}' from private module '{2}'."),
	        Parameter_0_of_accessor_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: diag(4108, 1 /* Error */, "Parameter_0_of_accessor_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named_4108", "Parameter '{0}' of accessor has or is using name '{1}' from external module '{2}' but cannot be named."),
	        Type_arguments_for_0_circularly_reference_themselves: diag(4109, 1 /* Error */, "Type_arguments_for_0_circularly_reference_themselves_4109", "Type arguments for '{0}' circularly reference themselves."),
	        Tuple_type_arguments_circularly_reference_themselves: diag(4110, 1 /* Error */, "Tuple_type_arguments_circularly_reference_themselves_4110", "Tuple type arguments circularly reference themselves."),
	        Property_0_comes_from_an_index_signature_so_it_must_be_accessed_with_0: diag(4111, 1 /* Error */, "Property_0_comes_from_an_index_signature_so_it_must_be_accessed_with_0_4111", "Property '{0}' comes from an index signature, so it must be accessed with ['{0}']."),
	        This_member_cannot_have_an_override_modifier_because_its_containing_class_0_does_not_extend_another_class: diag(4112, 1 /* Error */, "This_member_cannot_have_an_override_modifier_because_its_containing_class_0_does_not_extend_another__4112", "This member cannot have an 'override' modifier because its containing class '{0}' does not extend another class."),
	        This_member_cannot_have_an_override_modifier_because_it_is_not_declared_in_the_base_class_0: diag(4113, 1 /* Error */, "This_member_cannot_have_an_override_modifier_because_it_is_not_declared_in_the_base_class_0_4113", "This member cannot have an 'override' modifier because it is not declared in the base class '{0}'."),
	        This_member_must_have_an_override_modifier_because_it_overrides_a_member_in_the_base_class_0: diag(4114, 1 /* Error */, "This_member_must_have_an_override_modifier_because_it_overrides_a_member_in_the_base_class_0_4114", "This member must have an 'override' modifier because it overrides a member in the base class '{0}'."),
	        This_parameter_property_must_have_an_override_modifier_because_it_overrides_a_member_in_base_class_0: diag(4115, 1 /* Error */, "This_parameter_property_must_have_an_override_modifier_because_it_overrides_a_member_in_base_class_0_4115", "This parameter property must have an 'override' modifier because it overrides a member in base class '{0}'."),
	        This_member_must_have_an_override_modifier_because_it_overrides_an_abstract_method_that_is_declared_in_the_base_class_0: diag(4116, 1 /* Error */, "This_member_must_have_an_override_modifier_because_it_overrides_an_abstract_method_that_is_declared__4116", "This member must have an 'override' modifier because it overrides an abstract method that is declared in the base class '{0}'."),
	        This_member_cannot_have_an_override_modifier_because_it_is_not_declared_in_the_base_class_0_Did_you_mean_1: diag(4117, 1 /* Error */, "This_member_cannot_have_an_override_modifier_because_it_is_not_declared_in_the_base_class_0_Did_you__4117", "This member cannot have an 'override' modifier because it is not declared in the base class '{0}'. Did you mean '{1}'?"),
	        The_type_of_this_node_cannot_be_serialized_because_its_property_0_cannot_be_serialized: diag(4118, 1 /* Error */, "The_type_of_this_node_cannot_be_serialized_because_its_property_0_cannot_be_serialized_4118", "The type of this node cannot be serialized because its property '{0}' cannot be serialized."),
	        This_member_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_in_the_base_class_0: diag(4119, 1 /* Error */, "This_member_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_in_the_base_4119", "This member must have a JSDoc comment with an '@override' tag because it overrides a member in the base class '{0}'."),
	        This_parameter_property_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_in_the_base_class_0: diag(4120, 1 /* Error */, "This_parameter_property_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_4120", "This parameter property must have a JSDoc comment with an '@override' tag because it overrides a member in the base class '{0}'."),
	        This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_its_containing_class_0_does_not_extend_another_class: diag(4121, 1 /* Error */, "This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_its_containing_class_0_does_not_4121", "This member cannot have a JSDoc comment with an '@override' tag because its containing class '{0}' does not extend another class."),
	        This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_it_is_not_declared_in_the_base_class_0: diag(4122, 1 /* Error */, "This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_it_is_not_declared_in_the_base__4122", "This member cannot have a JSDoc comment with an '@override' tag because it is not declared in the base class '{0}'."),
	        This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_it_is_not_declared_in_the_base_class_0_Did_you_mean_1: diag(4123, 1 /* Error */, "This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_it_is_not_declared_in_the_base__4123", "This member cannot have a JSDoc comment with an 'override' tag because it is not declared in the base class '{0}'. Did you mean '{1}'?"),
	        Compiler_option_0_of_value_1_is_unstable_Use_nightly_TypeScript_to_silence_this_error_Try_updating_with_npm_install_D_typescript_next: diag(4124, 1 /* Error */, "Compiler_option_0_of_value_1_is_unstable_Use_nightly_TypeScript_to_silence_this_error_Try_updating_w_4124", "Compiler option '{0}' of value '{1}' is unstable. Use nightly TypeScript to silence this error. Try updating with 'npm install -D typescript@next'."),
	        Each_declaration_of_0_1_differs_in_its_value_where_2_was_expected_but_3_was_given: diag(4125, 1 /* Error */, "Each_declaration_of_0_1_differs_in_its_value_where_2_was_expected_but_3_was_given_4125", "Each declaration of '{0}.{1}' differs in its value, where '{2}' was expected but '{3}' was given."),
	        One_value_of_0_1_is_the_string_2_and_the_other_is_assumed_to_be_an_unknown_numeric_value: diag(4126, 1 /* Error */, "One_value_of_0_1_is_the_string_2_and_the_other_is_assumed_to_be_an_unknown_numeric_value_4126", "One value of '{0}.{1}' is the string '{2}', and the other is assumed to be an unknown numeric value."),
	        The_current_host_does_not_support_the_0_option: diag(5001, 1 /* Error */, "The_current_host_does_not_support_the_0_option_5001", "The current host does not support the '{0}' option."),
	        Cannot_find_the_common_subdirectory_path_for_the_input_files: diag(5009, 1 /* Error */, "Cannot_find_the_common_subdirectory_path_for_the_input_files_5009", "Cannot find the common subdirectory path for the input files."),
	        File_specification_cannot_end_in_a_recursive_directory_wildcard_Asterisk_Asterisk_Colon_0: diag(5010, 1 /* Error */, "File_specification_cannot_end_in_a_recursive_directory_wildcard_Asterisk_Asterisk_Colon_0_5010", "File specification cannot end in a recursive directory wildcard ('**'): '{0}'."),
	        Cannot_read_file_0_Colon_1: diag(5012, 1 /* Error */, "Cannot_read_file_0_Colon_1_5012", "Cannot read file '{0}': {1}."),
	        Failed_to_parse_file_0_Colon_1: diag(5014, 1 /* Error */, "Failed_to_parse_file_0_Colon_1_5014", "Failed to parse file '{0}': {1}."),
	        Unknown_compiler_option_0: diag(5023, 1 /* Error */, "Unknown_compiler_option_0_5023", "Unknown compiler option '{0}'."),
	        Compiler_option_0_requires_a_value_of_type_1: diag(5024, 1 /* Error */, "Compiler_option_0_requires_a_value_of_type_1_5024", "Compiler option '{0}' requires a value of type {1}."),
	        Unknown_compiler_option_0_Did_you_mean_1: diag(5025, 1 /* Error */, "Unknown_compiler_option_0_Did_you_mean_1_5025", "Unknown compiler option '{0}'. Did you mean '{1}'?"),
	        Could_not_write_file_0_Colon_1: diag(5033, 1 /* Error */, "Could_not_write_file_0_Colon_1_5033", "Could not write file '{0}': {1}."),
	        Option_project_cannot_be_mixed_with_source_files_on_a_command_line: diag(5042, 1 /* Error */, "Option_project_cannot_be_mixed_with_source_files_on_a_command_line_5042", "Option 'project' cannot be mixed with source files on a command line."),
	        Option_isolatedModules_can_only_be_used_when_either_option_module_is_provided_or_option_target_is_ES2015_or_higher: diag(5047, 1 /* Error */, "Option_isolatedModules_can_only_be_used_when_either_option_module_is_provided_or_option_target_is_ES_5047", "Option 'isolatedModules' can only be used when either option '--module' is provided or option 'target' is 'ES2015' or higher."),
	        Option_0_cannot_be_specified_when_option_target_is_ES3: diag(5048, 1 /* Error */, "Option_0_cannot_be_specified_when_option_target_is_ES3_5048", "Option '{0}' cannot be specified when option 'target' is 'ES3'."),
	        Option_0_can_only_be_used_when_either_option_inlineSourceMap_or_option_sourceMap_is_provided: diag(5051, 1 /* Error */, "Option_0_can_only_be_used_when_either_option_inlineSourceMap_or_option_sourceMap_is_provided_5051", "Option '{0} can only be used when either option '--inlineSourceMap' or option '--sourceMap' is provided."),
	        Option_0_cannot_be_specified_without_specifying_option_1: diag(5052, 1 /* Error */, "Option_0_cannot_be_specified_without_specifying_option_1_5052", "Option '{0}' cannot be specified without specifying option '{1}'."),
	        Option_0_cannot_be_specified_with_option_1: diag(5053, 1 /* Error */, "Option_0_cannot_be_specified_with_option_1_5053", "Option '{0}' cannot be specified with option '{1}'."),
	        A_tsconfig_json_file_is_already_defined_at_Colon_0: diag(5054, 1 /* Error */, "A_tsconfig_json_file_is_already_defined_at_Colon_0_5054", "A 'tsconfig.json' file is already defined at: '{0}'."),
	        Cannot_write_file_0_because_it_would_overwrite_input_file: diag(5055, 1 /* Error */, "Cannot_write_file_0_because_it_would_overwrite_input_file_5055", "Cannot write file '{0}' because it would overwrite input file."),
	        Cannot_write_file_0_because_it_would_be_overwritten_by_multiple_input_files: diag(5056, 1 /* Error */, "Cannot_write_file_0_because_it_would_be_overwritten_by_multiple_input_files_5056", "Cannot write file '{0}' because it would be overwritten by multiple input files."),
	        Cannot_find_a_tsconfig_json_file_at_the_specified_directory_Colon_0: diag(5057, 1 /* Error */, "Cannot_find_a_tsconfig_json_file_at_the_specified_directory_Colon_0_5057", "Cannot find a tsconfig.json file at the specified directory: '{0}'."),
	        The_specified_path_does_not_exist_Colon_0: diag(5058, 1 /* Error */, "The_specified_path_does_not_exist_Colon_0_5058", "The specified path does not exist: '{0}'."),
	        Invalid_value_for_reactNamespace_0_is_not_a_valid_identifier: diag(5059, 1 /* Error */, "Invalid_value_for_reactNamespace_0_is_not_a_valid_identifier_5059", "Invalid value for '--reactNamespace'. '{0}' is not a valid identifier."),
	        Pattern_0_can_have_at_most_one_Asterisk_character: diag(5061, 1 /* Error */, "Pattern_0_can_have_at_most_one_Asterisk_character_5061", "Pattern '{0}' can have at most one '*' character."),
	        Substitution_0_in_pattern_1_can_have_at_most_one_Asterisk_character: diag(5062, 1 /* Error */, "Substitution_0_in_pattern_1_can_have_at_most_one_Asterisk_character_5062", "Substitution '{0}' in pattern '{1}' can have at most one '*' character."),
	        Substitutions_for_pattern_0_should_be_an_array: diag(5063, 1 /* Error */, "Substitutions_for_pattern_0_should_be_an_array_5063", "Substitutions for pattern '{0}' should be an array."),
	        Substitution_0_for_pattern_1_has_incorrect_type_expected_string_got_2: diag(5064, 1 /* Error */, "Substitution_0_for_pattern_1_has_incorrect_type_expected_string_got_2_5064", "Substitution '{0}' for pattern '{1}' has incorrect type, expected 'string', got '{2}'."),
	        File_specification_cannot_contain_a_parent_directory_that_appears_after_a_recursive_directory_wildcard_Asterisk_Asterisk_Colon_0: diag(5065, 1 /* Error */, "File_specification_cannot_contain_a_parent_directory_that_appears_after_a_recursive_directory_wildca_5065", "File specification cannot contain a parent directory ('..') that appears after a recursive directory wildcard ('**'): '{0}'."),
	        Substitutions_for_pattern_0_shouldn_t_be_an_empty_array: diag(5066, 1 /* Error */, "Substitutions_for_pattern_0_shouldn_t_be_an_empty_array_5066", "Substitutions for pattern '{0}' shouldn't be an empty array."),
	        Invalid_value_for_jsxFactory_0_is_not_a_valid_identifier_or_qualified_name: diag(5067, 1 /* Error */, "Invalid_value_for_jsxFactory_0_is_not_a_valid_identifier_or_qualified_name_5067", "Invalid value for 'jsxFactory'. '{0}' is not a valid identifier or qualified-name."),
	        Adding_a_tsconfig_json_file_will_help_organize_projects_that_contain_both_TypeScript_and_JavaScript_files_Learn_more_at_https_Colon_Slash_Slashaka_ms_Slashtsconfig: diag(5068, 1 /* Error */, "Adding_a_tsconfig_json_file_will_help_organize_projects_that_contain_both_TypeScript_and_JavaScript__5068", "Adding a tsconfig.json file will help organize projects that contain both TypeScript and JavaScript files. Learn more at https://aka.ms/tsconfig."),
	        Option_0_cannot_be_specified_without_specifying_option_1_or_option_2: diag(5069, 1 /* Error */, "Option_0_cannot_be_specified_without_specifying_option_1_or_option_2_5069", "Option '{0}' cannot be specified without specifying option '{1}' or option '{2}'."),
	        Option_resolveJsonModule_cannot_be_specified_when_moduleResolution_is_set_to_classic: diag(5070, 1 /* Error */, "Option_resolveJsonModule_cannot_be_specified_when_moduleResolution_is_set_to_classic_5070", "Option '--resolveJsonModule' cannot be specified when 'moduleResolution' is set to 'classic'."),
	        Option_resolveJsonModule_cannot_be_specified_when_module_is_set_to_none_system_or_umd: diag(5071, 1 /* Error */, "Option_resolveJsonModule_cannot_be_specified_when_module_is_set_to_none_system_or_umd_5071", "Option '--resolveJsonModule' cannot be specified when 'module' is set to 'none', 'system', or 'umd'."),
	        Unknown_build_option_0: diag(5072, 1 /* Error */, "Unknown_build_option_0_5072", "Unknown build option '{0}'."),
	        Build_option_0_requires_a_value_of_type_1: diag(5073, 1 /* Error */, "Build_option_0_requires_a_value_of_type_1_5073", "Build option '{0}' requires a value of type {1}."),
	        Option_incremental_can_only_be_specified_using_tsconfig_emitting_to_single_file_or_when_option_tsBuildInfoFile_is_specified: diag(5074, 1 /* Error */, "Option_incremental_can_only_be_specified_using_tsconfig_emitting_to_single_file_or_when_option_tsBui_5074", "Option '--incremental' can only be specified using tsconfig, emitting to single file or when option '--tsBuildInfoFile' is specified."),
	        _0_is_assignable_to_the_constraint_of_type_1_but_1_could_be_instantiated_with_a_different_subtype_of_constraint_2: diag(5075, 1 /* Error */, "_0_is_assignable_to_the_constraint_of_type_1_but_1_could_be_instantiated_with_a_different_subtype_of_5075", "'{0}' is assignable to the constraint of type '{1}', but '{1}' could be instantiated with a different subtype of constraint '{2}'."),
	        _0_and_1_operations_cannot_be_mixed_without_parentheses: diag(5076, 1 /* Error */, "_0_and_1_operations_cannot_be_mixed_without_parentheses_5076", "'{0}' and '{1}' operations cannot be mixed without parentheses."),
	        Unknown_build_option_0_Did_you_mean_1: diag(5077, 1 /* Error */, "Unknown_build_option_0_Did_you_mean_1_5077", "Unknown build option '{0}'. Did you mean '{1}'?"),
	        Unknown_watch_option_0: diag(5078, 1 /* Error */, "Unknown_watch_option_0_5078", "Unknown watch option '{0}'."),
	        Unknown_watch_option_0_Did_you_mean_1: diag(5079, 1 /* Error */, "Unknown_watch_option_0_Did_you_mean_1_5079", "Unknown watch option '{0}'. Did you mean '{1}'?"),
	        Watch_option_0_requires_a_value_of_type_1: diag(5080, 1 /* Error */, "Watch_option_0_requires_a_value_of_type_1_5080", "Watch option '{0}' requires a value of type {1}."),
	        Cannot_find_a_tsconfig_json_file_at_the_current_directory_Colon_0: diag(5081, 1 /* Error */, "Cannot_find_a_tsconfig_json_file_at_the_current_directory_Colon_0_5081", "Cannot find a tsconfig.json file at the current directory: {0}."),
	        _0_could_be_instantiated_with_an_arbitrary_type_which_could_be_unrelated_to_1: diag(5082, 1 /* Error */, "_0_could_be_instantiated_with_an_arbitrary_type_which_could_be_unrelated_to_1_5082", "'{0}' could be instantiated with an arbitrary type which could be unrelated to '{1}'."),
	        Cannot_read_file_0: diag(5083, 1 /* Error */, "Cannot_read_file_0_5083", "Cannot read file '{0}'."),
	        A_tuple_member_cannot_be_both_optional_and_rest: diag(5085, 1 /* Error */, "A_tuple_member_cannot_be_both_optional_and_rest_5085", "A tuple member cannot be both optional and rest."),
	        A_labeled_tuple_element_is_declared_as_optional_with_a_question_mark_after_the_name_and_before_the_colon_rather_than_after_the_type: diag(5086, 1 /* Error */, "A_labeled_tuple_element_is_declared_as_optional_with_a_question_mark_after_the_name_and_before_the_c_5086", "A labeled tuple element is declared as optional with a question mark after the name and before the colon, rather than after the type."),
	        A_labeled_tuple_element_is_declared_as_rest_with_a_before_the_name_rather_than_before_the_type: diag(5087, 1 /* Error */, "A_labeled_tuple_element_is_declared_as_rest_with_a_before_the_name_rather_than_before_the_type_5087", "A labeled tuple element is declared as rest with a '...' before the name, rather than before the type."),
	        The_inferred_type_of_0_references_a_type_with_a_cyclic_structure_which_cannot_be_trivially_serialized_A_type_annotation_is_necessary: diag(5088, 1 /* Error */, "The_inferred_type_of_0_references_a_type_with_a_cyclic_structure_which_cannot_be_trivially_serialize_5088", "The inferred type of '{0}' references a type with a cyclic structure which cannot be trivially serialized. A type annotation is necessary."),
	        Option_0_cannot_be_specified_when_option_jsx_is_1: diag(5089, 1 /* Error */, "Option_0_cannot_be_specified_when_option_jsx_is_1_5089", "Option '{0}' cannot be specified when option 'jsx' is '{1}'."),
	        Non_relative_paths_are_not_allowed_when_baseUrl_is_not_set_Did_you_forget_a_leading_Slash: diag(5090, 1 /* Error */, "Non_relative_paths_are_not_allowed_when_baseUrl_is_not_set_Did_you_forget_a_leading_Slash_5090", "Non-relative paths are not allowed when 'baseUrl' is not set. Did you forget a leading './'?"),
	        Option_preserveConstEnums_cannot_be_disabled_when_0_is_enabled: diag(5091, 1 /* Error */, "Option_preserveConstEnums_cannot_be_disabled_when_0_is_enabled_5091", "Option 'preserveConstEnums' cannot be disabled when '{0}' is enabled."),
	        The_root_value_of_a_0_file_must_be_an_object: diag(5092, 1 /* Error */, "The_root_value_of_a_0_file_must_be_an_object_5092", "The root value of a '{0}' file must be an object."),
	        Compiler_option_0_may_only_be_used_with_build: diag(5093, 1 /* Error */, "Compiler_option_0_may_only_be_used_with_build_5093", "Compiler option '--{0}' may only be used with '--build'."),
	        Compiler_option_0_may_not_be_used_with_build: diag(5094, 1 /* Error */, "Compiler_option_0_may_not_be_used_with_build_5094", "Compiler option '--{0}' may not be used with '--build'."),
	        Option_0_can_only_be_used_when_module_is_set_to_preserve_or_to_es2015_or_later: diag(5095, 1 /* Error */, "Option_0_can_only_be_used_when_module_is_set_to_preserve_or_to_es2015_or_later_5095", "Option '{0}' can only be used when 'module' is set to 'preserve' or to 'es2015' or later."),
	        Option_allowImportingTsExtensions_can_only_be_used_when_either_noEmit_or_emitDeclarationOnly_is_set: diag(5096, 1 /* Error */, "Option_allowImportingTsExtensions_can_only_be_used_when_either_noEmit_or_emitDeclarationOnly_is_set_5096", "Option 'allowImportingTsExtensions' can only be used when either 'noEmit' or 'emitDeclarationOnly' is set."),
	        An_import_path_can_only_end_with_a_0_extension_when_allowImportingTsExtensions_is_enabled: diag(5097, 1 /* Error */, "An_import_path_can_only_end_with_a_0_extension_when_allowImportingTsExtensions_is_enabled_5097", "An import path can only end with a '{0}' extension when 'allowImportingTsExtensions' is enabled."),
	        Option_0_can_only_be_used_when_moduleResolution_is_set_to_node16_nodenext_or_bundler: diag(5098, 1 /* Error */, "Option_0_can_only_be_used_when_moduleResolution_is_set_to_node16_nodenext_or_bundler_5098", "Option '{0}' can only be used when 'moduleResolution' is set to 'node16', 'nodenext', or 'bundler'."),
	        Option_0_is_deprecated_and_will_stop_functioning_in_TypeScript_1_Specify_compilerOption_ignoreDeprecations_Colon_2_to_silence_this_error: diag(5101, 1 /* Error */, "Option_0_is_deprecated_and_will_stop_functioning_in_TypeScript_1_Specify_compilerOption_ignoreDeprec_5101", `Option '{0}' is deprecated and will stop functioning in TypeScript {1}. Specify compilerOption '"ignoreDeprecations": "{2}"' to silence this error.`),
	        Option_0_has_been_removed_Please_remove_it_from_your_configuration: diag(5102, 1 /* Error */, "Option_0_has_been_removed_Please_remove_it_from_your_configuration_5102", "Option '{0}' has been removed. Please remove it from your configuration."),
	        Invalid_value_for_ignoreDeprecations: diag(5103, 1 /* Error */, "Invalid_value_for_ignoreDeprecations_5103", "Invalid value for '--ignoreDeprecations'."),
	        Option_0_is_redundant_and_cannot_be_specified_with_option_1: diag(5104, 1 /* Error */, "Option_0_is_redundant_and_cannot_be_specified_with_option_1_5104", "Option '{0}' is redundant and cannot be specified with option '{1}'."),
	        Option_verbatimModuleSyntax_cannot_be_used_when_module_is_set_to_UMD_AMD_or_System: diag(5105, 1 /* Error */, "Option_verbatimModuleSyntax_cannot_be_used_when_module_is_set_to_UMD_AMD_or_System_5105", "Option 'verbatimModuleSyntax' cannot be used when 'module' is set to 'UMD', 'AMD', or 'System'."),
	        Use_0_instead: diag(5106, 3 /* Message */, "Use_0_instead_5106", "Use '{0}' instead."),
	        Option_0_1_is_deprecated_and_will_stop_functioning_in_TypeScript_2_Specify_compilerOption_ignoreDeprecations_Colon_3_to_silence_this_error: diag(5107, 1 /* Error */, "Option_0_1_is_deprecated_and_will_stop_functioning_in_TypeScript_2_Specify_compilerOption_ignoreDepr_5107", `Option '{0}={1}' is deprecated and will stop functioning in TypeScript {2}. Specify compilerOption '"ignoreDeprecations": "{3}"' to silence this error.`),
	        Option_0_1_has_been_removed_Please_remove_it_from_your_configuration: diag(5108, 1 /* Error */, "Option_0_1_has_been_removed_Please_remove_it_from_your_configuration_5108", "Option '{0}={1}' has been removed. Please remove it from your configuration."),
	        Option_moduleResolution_must_be_set_to_0_or_left_unspecified_when_option_module_is_set_to_1: diag(5109, 1 /* Error */, "Option_moduleResolution_must_be_set_to_0_or_left_unspecified_when_option_module_is_set_to_1_5109", "Option 'moduleResolution' must be set to '{0}' (or left unspecified) when option 'module' is set to '{1}'."),
	        Option_module_must_be_set_to_0_when_option_moduleResolution_is_set_to_1: diag(5110, 1 /* Error */, "Option_module_must_be_set_to_0_when_option_moduleResolution_is_set_to_1_5110", "Option 'module' must be set to '{0}' when option 'moduleResolution' is set to '{1}'."),
	        Generates_a_sourcemap_for_each_corresponding_d_ts_file: diag(6e3, 3 /* Message */, "Generates_a_sourcemap_for_each_corresponding_d_ts_file_6000", "Generates a sourcemap for each corresponding '.d.ts' file."),
	        Concatenate_and_emit_output_to_single_file: diag(6001, 3 /* Message */, "Concatenate_and_emit_output_to_single_file_6001", "Concatenate and emit output to single file."),
	        Generates_corresponding_d_ts_file: diag(6002, 3 /* Message */, "Generates_corresponding_d_ts_file_6002", "Generates corresponding '.d.ts' file."),
	        Specify_the_location_where_debugger_should_locate_TypeScript_files_instead_of_source_locations: diag(6004, 3 /* Message */, "Specify_the_location_where_debugger_should_locate_TypeScript_files_instead_of_source_locations_6004", "Specify the location where debugger should locate TypeScript files instead of source locations."),
	        Watch_input_files: diag(6005, 3 /* Message */, "Watch_input_files_6005", "Watch input files."),
	        Redirect_output_structure_to_the_directory: diag(6006, 3 /* Message */, "Redirect_output_structure_to_the_directory_6006", "Redirect output structure to the directory."),
	        Do_not_erase_const_enum_declarations_in_generated_code: diag(6007, 3 /* Message */, "Do_not_erase_const_enum_declarations_in_generated_code_6007", "Do not erase const enum declarations in generated code."),
	        Do_not_emit_outputs_if_any_errors_were_reported: diag(6008, 3 /* Message */, "Do_not_emit_outputs_if_any_errors_were_reported_6008", "Do not emit outputs if any errors were reported."),
	        Do_not_emit_comments_to_output: diag(6009, 3 /* Message */, "Do_not_emit_comments_to_output_6009", "Do not emit comments to output."),
	        Do_not_emit_outputs: diag(6010, 3 /* Message */, "Do_not_emit_outputs_6010", "Do not emit outputs."),
	        Allow_default_imports_from_modules_with_no_default_export_This_does_not_affect_code_emit_just_typechecking: diag(6011, 3 /* Message */, "Allow_default_imports_from_modules_with_no_default_export_This_does_not_affect_code_emit_just_typech_6011", "Allow default imports from modules with no default export. This does not affect code emit, just typechecking."),
	        Skip_type_checking_of_declaration_files: diag(6012, 3 /* Message */, "Skip_type_checking_of_declaration_files_6012", "Skip type checking of declaration files."),
	        Do_not_resolve_the_real_path_of_symlinks: diag(6013, 3 /* Message */, "Do_not_resolve_the_real_path_of_symlinks_6013", "Do not resolve the real path of symlinks."),
	        Only_emit_d_ts_declaration_files: diag(6014, 3 /* Message */, "Only_emit_d_ts_declaration_files_6014", "Only emit '.d.ts' declaration files."),
	        Specify_ECMAScript_target_version: diag(6015, 3 /* Message */, "Specify_ECMAScript_target_version_6015", "Specify ECMAScript target version."),
	        Specify_module_code_generation: diag(6016, 3 /* Message */, "Specify_module_code_generation_6016", "Specify module code generation."),
	        Print_this_message: diag(6017, 3 /* Message */, "Print_this_message_6017", "Print this message."),
	        Print_the_compiler_s_version: diag(6019, 3 /* Message */, "Print_the_compiler_s_version_6019", "Print the compiler's version."),
	        Compile_the_project_given_the_path_to_its_configuration_file_or_to_a_folder_with_a_tsconfig_json: diag(6020, 3 /* Message */, "Compile_the_project_given_the_path_to_its_configuration_file_or_to_a_folder_with_a_tsconfig_json_6020", "Compile the project given the path to its configuration file, or to a folder with a 'tsconfig.json'."),
	        Syntax_Colon_0: diag(6023, 3 /* Message */, "Syntax_Colon_0_6023", "Syntax: {0}"),
	        options: diag(6024, 3 /* Message */, "options_6024", "options"),
	        file: diag(6025, 3 /* Message */, "file_6025", "file"),
	        Examples_Colon_0: diag(6026, 3 /* Message */, "Examples_Colon_0_6026", "Examples: {0}"),
	        Options_Colon: diag(6027, 3 /* Message */, "Options_Colon_6027", "Options:"),
	        Version_0: diag(6029, 3 /* Message */, "Version_0_6029", "Version {0}"),
	        Insert_command_line_options_and_files_from_a_file: diag(6030, 3 /* Message */, "Insert_command_line_options_and_files_from_a_file_6030", "Insert command line options and files from a file."),
	        Starting_compilation_in_watch_mode: diag(6031, 3 /* Message */, "Starting_compilation_in_watch_mode_6031", "Starting compilation in watch mode..."),
	        File_change_detected_Starting_incremental_compilation: diag(6032, 3 /* Message */, "File_change_detected_Starting_incremental_compilation_6032", "File change detected. Starting incremental compilation..."),
	        KIND: diag(6034, 3 /* Message */, "KIND_6034", "KIND"),
	        FILE: diag(6035, 3 /* Message */, "FILE_6035", "FILE"),
	        VERSION: diag(6036, 3 /* Message */, "VERSION_6036", "VERSION"),
	        LOCATION: diag(6037, 3 /* Message */, "LOCATION_6037", "LOCATION"),
	        DIRECTORY: diag(6038, 3 /* Message */, "DIRECTORY_6038", "DIRECTORY"),
	        STRATEGY: diag(6039, 3 /* Message */, "STRATEGY_6039", "STRATEGY"),
	        FILE_OR_DIRECTORY: diag(6040, 3 /* Message */, "FILE_OR_DIRECTORY_6040", "FILE OR DIRECTORY"),
	        Errors_Files: diag(6041, 3 /* Message */, "Errors_Files_6041", "Errors  Files"),
	        Generates_corresponding_map_file: diag(6043, 3 /* Message */, "Generates_corresponding_map_file_6043", "Generates corresponding '.map' file."),
	        Compiler_option_0_expects_an_argument: diag(6044, 1 /* Error */, "Compiler_option_0_expects_an_argument_6044", "Compiler option '{0}' expects an argument."),
	        Unterminated_quoted_string_in_response_file_0: diag(6045, 1 /* Error */, "Unterminated_quoted_string_in_response_file_0_6045", "Unterminated quoted string in response file '{0}'."),
	        Argument_for_0_option_must_be_Colon_1: diag(6046, 1 /* Error */, "Argument_for_0_option_must_be_Colon_1_6046", "Argument for '{0}' option must be: {1}."),
	        Locale_must_be_of_the_form_language_or_language_territory_For_example_0_or_1: diag(6048, 1 /* Error */, "Locale_must_be_of_the_form_language_or_language_territory_For_example_0_or_1_6048", "Locale must be of the form <language> or <language>-<territory>. For example '{0}' or '{1}'."),
	        Unable_to_open_file_0: diag(6050, 1 /* Error */, "Unable_to_open_file_0_6050", "Unable to open file '{0}'."),
	        Corrupted_locale_file_0: diag(6051, 1 /* Error */, "Corrupted_locale_file_0_6051", "Corrupted locale file {0}."),
	        Raise_error_on_expressions_and_declarations_with_an_implied_any_type: diag(6052, 3 /* Message */, "Raise_error_on_expressions_and_declarations_with_an_implied_any_type_6052", "Raise error on expressions and declarations with an implied 'any' type."),
	        File_0_not_found: diag(6053, 1 /* Error */, "File_0_not_found_6053", "File '{0}' not found."),
	        File_0_has_an_unsupported_extension_The_only_supported_extensions_are_1: diag(6054, 1 /* Error */, "File_0_has_an_unsupported_extension_The_only_supported_extensions_are_1_6054", "File '{0}' has an unsupported extension. The only supported extensions are {1}."),
	        Suppress_noImplicitAny_errors_for_indexing_objects_lacking_index_signatures: diag(6055, 3 /* Message */, "Suppress_noImplicitAny_errors_for_indexing_objects_lacking_index_signatures_6055", "Suppress noImplicitAny errors for indexing objects lacking index signatures."),
	        Do_not_emit_declarations_for_code_that_has_an_internal_annotation: diag(6056, 3 /* Message */, "Do_not_emit_declarations_for_code_that_has_an_internal_annotation_6056", "Do not emit declarations for code that has an '@internal' annotation."),
	        Specify_the_root_directory_of_input_files_Use_to_control_the_output_directory_structure_with_outDir: diag(6058, 3 /* Message */, "Specify_the_root_directory_of_input_files_Use_to_control_the_output_directory_structure_with_outDir_6058", "Specify the root directory of input files. Use to control the output directory structure with --outDir."),
	        File_0_is_not_under_rootDir_1_rootDir_is_expected_to_contain_all_source_files: diag(6059, 1 /* Error */, "File_0_is_not_under_rootDir_1_rootDir_is_expected_to_contain_all_source_files_6059", "File '{0}' is not under 'rootDir' '{1}'. 'rootDir' is expected to contain all source files."),
	        Specify_the_end_of_line_sequence_to_be_used_when_emitting_files_Colon_CRLF_dos_or_LF_unix: diag(6060, 3 /* Message */, "Specify_the_end_of_line_sequence_to_be_used_when_emitting_files_Colon_CRLF_dos_or_LF_unix_6060", "Specify the end of line sequence to be used when emitting files: 'CRLF' (dos) or 'LF' (unix)."),
	        NEWLINE: diag(6061, 3 /* Message */, "NEWLINE_6061", "NEWLINE"),
	        Option_0_can_only_be_specified_in_tsconfig_json_file_or_set_to_null_on_command_line: diag(6064, 1 /* Error */, "Option_0_can_only_be_specified_in_tsconfig_json_file_or_set_to_null_on_command_line_6064", "Option '{0}' can only be specified in 'tsconfig.json' file or set to 'null' on command line."),
	        Enables_experimental_support_for_ES7_decorators: diag(6065, 3 /* Message */, "Enables_experimental_support_for_ES7_decorators_6065", "Enables experimental support for ES7 decorators."),
	        Enables_experimental_support_for_emitting_type_metadata_for_decorators: diag(6066, 3 /* Message */, "Enables_experimental_support_for_emitting_type_metadata_for_decorators_6066", "Enables experimental support for emitting type metadata for decorators."),
	        Initializes_a_TypeScript_project_and_creates_a_tsconfig_json_file: diag(6070, 3 /* Message */, "Initializes_a_TypeScript_project_and_creates_a_tsconfig_json_file_6070", "Initializes a TypeScript project and creates a tsconfig.json file."),
	        Successfully_created_a_tsconfig_json_file: diag(6071, 3 /* Message */, "Successfully_created_a_tsconfig_json_file_6071", "Successfully created a tsconfig.json file."),
	        Suppress_excess_property_checks_for_object_literals: diag(6072, 3 /* Message */, "Suppress_excess_property_checks_for_object_literals_6072", "Suppress excess property checks for object literals."),
	        Stylize_errors_and_messages_using_color_and_context_experimental: diag(6073, 3 /* Message */, "Stylize_errors_and_messages_using_color_and_context_experimental_6073", "Stylize errors and messages using color and context (experimental)."),
	        Do_not_report_errors_on_unused_labels: diag(6074, 3 /* Message */, "Do_not_report_errors_on_unused_labels_6074", "Do not report errors on unused labels."),
	        Report_error_when_not_all_code_paths_in_function_return_a_value: diag(6075, 3 /* Message */, "Report_error_when_not_all_code_paths_in_function_return_a_value_6075", "Report error when not all code paths in function return a value."),
	        Report_errors_for_fallthrough_cases_in_switch_statement: diag(6076, 3 /* Message */, "Report_errors_for_fallthrough_cases_in_switch_statement_6076", "Report errors for fallthrough cases in switch statement."),
	        Do_not_report_errors_on_unreachable_code: diag(6077, 3 /* Message */, "Do_not_report_errors_on_unreachable_code_6077", "Do not report errors on unreachable code."),
	        Disallow_inconsistently_cased_references_to_the_same_file: diag(6078, 3 /* Message */, "Disallow_inconsistently_cased_references_to_the_same_file_6078", "Disallow inconsistently-cased references to the same file."),
	        Specify_library_files_to_be_included_in_the_compilation: diag(6079, 3 /* Message */, "Specify_library_files_to_be_included_in_the_compilation_6079", "Specify library files to be included in the compilation."),
	        Specify_JSX_code_generation: diag(6080, 3 /* Message */, "Specify_JSX_code_generation_6080", "Specify JSX code generation."),
	        Only_amd_and_system_modules_are_supported_alongside_0: diag(6082, 1 /* Error */, "Only_amd_and_system_modules_are_supported_alongside_0_6082", "Only 'amd' and 'system' modules are supported alongside --{0}."),
	        Base_directory_to_resolve_non_absolute_module_names: diag(6083, 3 /* Message */, "Base_directory_to_resolve_non_absolute_module_names_6083", "Base directory to resolve non-absolute module names."),
	        Deprecated_Use_jsxFactory_instead_Specify_the_object_invoked_for_createElement_when_targeting_react_JSX_emit: diag(6084, 3 /* Message */, "Deprecated_Use_jsxFactory_instead_Specify_the_object_invoked_for_createElement_when_targeting_react__6084", "[Deprecated] Use '--jsxFactory' instead. Specify the object invoked for createElement when targeting 'react' JSX emit"),
	        Enable_tracing_of_the_name_resolution_process: diag(6085, 3 /* Message */, "Enable_tracing_of_the_name_resolution_process_6085", "Enable tracing of the name resolution process."),
	        Resolving_module_0_from_1: diag(6086, 3 /* Message */, "Resolving_module_0_from_1_6086", "======== Resolving module '{0}' from '{1}'. ========"),
	        Explicitly_specified_module_resolution_kind_Colon_0: diag(6087, 3 /* Message */, "Explicitly_specified_module_resolution_kind_Colon_0_6087", "Explicitly specified module resolution kind: '{0}'."),
	        Module_resolution_kind_is_not_specified_using_0: diag(6088, 3 /* Message */, "Module_resolution_kind_is_not_specified_using_0_6088", "Module resolution kind is not specified, using '{0}'."),
	        Module_name_0_was_successfully_resolved_to_1: diag(6089, 3 /* Message */, "Module_name_0_was_successfully_resolved_to_1_6089", "======== Module name '{0}' was successfully resolved to '{1}'. ========"),
	        Module_name_0_was_not_resolved: diag(6090, 3 /* Message */, "Module_name_0_was_not_resolved_6090", "======== Module name '{0}' was not resolved. ========"),
	        paths_option_is_specified_looking_for_a_pattern_to_match_module_name_0: diag(6091, 3 /* Message */, "paths_option_is_specified_looking_for_a_pattern_to_match_module_name_0_6091", "'paths' option is specified, looking for a pattern to match module name '{0}'."),
	        Module_name_0_matched_pattern_1: diag(6092, 3 /* Message */, "Module_name_0_matched_pattern_1_6092", "Module name '{0}', matched pattern '{1}'."),
	        Trying_substitution_0_candidate_module_location_Colon_1: diag(6093, 3 /* Message */, "Trying_substitution_0_candidate_module_location_Colon_1_6093", "Trying substitution '{0}', candidate module location: '{1}'."),
	        Resolving_module_name_0_relative_to_base_url_1_2: diag(6094, 3 /* Message */, "Resolving_module_name_0_relative_to_base_url_1_2_6094", "Resolving module name '{0}' relative to base url '{1}' - '{2}'."),
	        Loading_module_as_file_Slash_folder_candidate_module_location_0_target_file_types_Colon_1: diag(6095, 3 /* Message */, "Loading_module_as_file_Slash_folder_candidate_module_location_0_target_file_types_Colon_1_6095", "Loading module as file / folder, candidate module location '{0}', target file types: {1}."),
	        File_0_does_not_exist: diag(6096, 3 /* Message */, "File_0_does_not_exist_6096", "File '{0}' does not exist."),
	        File_0_exists_use_it_as_a_name_resolution_result: diag(6097, 3 /* Message */, "File_0_exists_use_it_as_a_name_resolution_result_6097", "File '{0}' exists - use it as a name resolution result."),
	        Loading_module_0_from_node_modules_folder_target_file_types_Colon_1: diag(6098, 3 /* Message */, "Loading_module_0_from_node_modules_folder_target_file_types_Colon_1_6098", "Loading module '{0}' from 'node_modules' folder, target file types: {1}."),
	        Found_package_json_at_0: diag(6099, 3 /* Message */, "Found_package_json_at_0_6099", "Found 'package.json' at '{0}'."),
	        package_json_does_not_have_a_0_field: diag(6100, 3 /* Message */, "package_json_does_not_have_a_0_field_6100", "'package.json' does not have a '{0}' field."),
	        package_json_has_0_field_1_that_references_2: diag(6101, 3 /* Message */, "package_json_has_0_field_1_that_references_2_6101", "'package.json' has '{0}' field '{1}' that references '{2}'."),
	        Allow_javascript_files_to_be_compiled: diag(6102, 3 /* Message */, "Allow_javascript_files_to_be_compiled_6102", "Allow javascript files to be compiled."),
	        Checking_if_0_is_the_longest_matching_prefix_for_1_2: diag(6104, 3 /* Message */, "Checking_if_0_is_the_longest_matching_prefix_for_1_2_6104", "Checking if '{0}' is the longest matching prefix for '{1}' - '{2}'."),
	        Expected_type_of_0_field_in_package_json_to_be_1_got_2: diag(6105, 3 /* Message */, "Expected_type_of_0_field_in_package_json_to_be_1_got_2_6105", "Expected type of '{0}' field in 'package.json' to be '{1}', got '{2}'."),
	        baseUrl_option_is_set_to_0_using_this_value_to_resolve_non_relative_module_name_1: diag(6106, 3 /* Message */, "baseUrl_option_is_set_to_0_using_this_value_to_resolve_non_relative_module_name_1_6106", "'baseUrl' option is set to '{0}', using this value to resolve non-relative module name '{1}'."),
	        rootDirs_option_is_set_using_it_to_resolve_relative_module_name_0: diag(6107, 3 /* Message */, "rootDirs_option_is_set_using_it_to_resolve_relative_module_name_0_6107", "'rootDirs' option is set, using it to resolve relative module name '{0}'."),
	        Longest_matching_prefix_for_0_is_1: diag(6108, 3 /* Message */, "Longest_matching_prefix_for_0_is_1_6108", "Longest matching prefix for '{0}' is '{1}'."),
	        Loading_0_from_the_root_dir_1_candidate_location_2: diag(6109, 3 /* Message */, "Loading_0_from_the_root_dir_1_candidate_location_2_6109", "Loading '{0}' from the root dir '{1}', candidate location '{2}'."),
	        Trying_other_entries_in_rootDirs: diag(6110, 3 /* Message */, "Trying_other_entries_in_rootDirs_6110", "Trying other entries in 'rootDirs'."),
	        Module_resolution_using_rootDirs_has_failed: diag(6111, 3 /* Message */, "Module_resolution_using_rootDirs_has_failed_6111", "Module resolution using 'rootDirs' has failed."),
	        Do_not_emit_use_strict_directives_in_module_output: diag(6112, 3 /* Message */, "Do_not_emit_use_strict_directives_in_module_output_6112", "Do not emit 'use strict' directives in module output."),
	        Enable_strict_null_checks: diag(6113, 3 /* Message */, "Enable_strict_null_checks_6113", "Enable strict null checks."),
	        Unknown_option_excludes_Did_you_mean_exclude: diag(6114, 1 /* Error */, "Unknown_option_excludes_Did_you_mean_exclude_6114", "Unknown option 'excludes'. Did you mean 'exclude'?"),
	        Raise_error_on_this_expressions_with_an_implied_any_type: diag(6115, 3 /* Message */, "Raise_error_on_this_expressions_with_an_implied_any_type_6115", "Raise error on 'this' expressions with an implied 'any' type."),
	        Resolving_type_reference_directive_0_containing_file_1_root_directory_2: diag(6116, 3 /* Message */, "Resolving_type_reference_directive_0_containing_file_1_root_directory_2_6116", "======== Resolving type reference directive '{0}', containing file '{1}', root directory '{2}'. ========"),
	        Type_reference_directive_0_was_successfully_resolved_to_1_primary_Colon_2: diag(6119, 3 /* Message */, "Type_reference_directive_0_was_successfully_resolved_to_1_primary_Colon_2_6119", "======== Type reference directive '{0}' was successfully resolved to '{1}', primary: {2}. ========"),
	        Type_reference_directive_0_was_not_resolved: diag(6120, 3 /* Message */, "Type_reference_directive_0_was_not_resolved_6120", "======== Type reference directive '{0}' was not resolved. ========"),
	        Resolving_with_primary_search_path_0: diag(6121, 3 /* Message */, "Resolving_with_primary_search_path_0_6121", "Resolving with primary search path '{0}'."),
	        Root_directory_cannot_be_determined_skipping_primary_search_paths: diag(6122, 3 /* Message */, "Root_directory_cannot_be_determined_skipping_primary_search_paths_6122", "Root directory cannot be determined, skipping primary search paths."),
	        Resolving_type_reference_directive_0_containing_file_1_root_directory_not_set: diag(6123, 3 /* Message */, "Resolving_type_reference_directive_0_containing_file_1_root_directory_not_set_6123", "======== Resolving type reference directive '{0}', containing file '{1}', root directory not set. ========"),
	        Type_declaration_files_to_be_included_in_compilation: diag(6124, 3 /* Message */, "Type_declaration_files_to_be_included_in_compilation_6124", "Type declaration files to be included in compilation."),
	        Looking_up_in_node_modules_folder_initial_location_0: diag(6125, 3 /* Message */, "Looking_up_in_node_modules_folder_initial_location_0_6125", "Looking up in 'node_modules' folder, initial location '{0}'."),
	        Containing_file_is_not_specified_and_root_directory_cannot_be_determined_skipping_lookup_in_node_modules_folder: diag(6126, 3 /* Message */, "Containing_file_is_not_specified_and_root_directory_cannot_be_determined_skipping_lookup_in_node_mod_6126", "Containing file is not specified and root directory cannot be determined, skipping lookup in 'node_modules' folder."),
	        Resolving_type_reference_directive_0_containing_file_not_set_root_directory_1: diag(6127, 3 /* Message */, "Resolving_type_reference_directive_0_containing_file_not_set_root_directory_1_6127", "======== Resolving type reference directive '{0}', containing file not set, root directory '{1}'. ========"),
	        Resolving_type_reference_directive_0_containing_file_not_set_root_directory_not_set: diag(6128, 3 /* Message */, "Resolving_type_reference_directive_0_containing_file_not_set_root_directory_not_set_6128", "======== Resolving type reference directive '{0}', containing file not set, root directory not set. ========"),
	        Resolving_real_path_for_0_result_1: diag(6130, 3 /* Message */, "Resolving_real_path_for_0_result_1_6130", "Resolving real path for '{0}', result '{1}'."),
	        Cannot_compile_modules_using_option_0_unless_the_module_flag_is_amd_or_system: diag(6131, 1 /* Error */, "Cannot_compile_modules_using_option_0_unless_the_module_flag_is_amd_or_system_6131", "Cannot compile modules using option '{0}' unless the '--module' flag is 'amd' or 'system'."),
	        File_name_0_has_a_1_extension_stripping_it: diag(6132, 3 /* Message */, "File_name_0_has_a_1_extension_stripping_it_6132", "File name '{0}' has a '{1}' extension - stripping it."),
	        _0_is_declared_but_its_value_is_never_read: diag(
	          6133,
	          1 /* Error */,
	          "_0_is_declared_but_its_value_is_never_read_6133",
	          "'{0}' is declared but its value is never read.",
	          /*reportsUnnecessary*/
	          true
	        ),
	        Report_errors_on_unused_locals: diag(6134, 3 /* Message */, "Report_errors_on_unused_locals_6134", "Report errors on unused locals."),
	        Report_errors_on_unused_parameters: diag(6135, 3 /* Message */, "Report_errors_on_unused_parameters_6135", "Report errors on unused parameters."),
	        The_maximum_dependency_depth_to_search_under_node_modules_and_load_JavaScript_files: diag(6136, 3 /* Message */, "The_maximum_dependency_depth_to_search_under_node_modules_and_load_JavaScript_files_6136", "The maximum dependency depth to search under node_modules and load JavaScript files."),
	        Cannot_import_type_declaration_files_Consider_importing_0_instead_of_1: diag(6137, 1 /* Error */, "Cannot_import_type_declaration_files_Consider_importing_0_instead_of_1_6137", "Cannot import type declaration files. Consider importing '{0}' instead of '{1}'."),
	        Property_0_is_declared_but_its_value_is_never_read: diag(
	          6138,
	          1 /* Error */,
	          "Property_0_is_declared_but_its_value_is_never_read_6138",
	          "Property '{0}' is declared but its value is never read.",
	          /*reportsUnnecessary*/
	          true
	        ),
	        Import_emit_helpers_from_tslib: diag(6139, 3 /* Message */, "Import_emit_helpers_from_tslib_6139", "Import emit helpers from 'tslib'."),
	        Auto_discovery_for_typings_is_enabled_in_project_0_Running_extra_resolution_pass_for_module_1_using_cache_location_2: diag(6140, 1 /* Error */, "Auto_discovery_for_typings_is_enabled_in_project_0_Running_extra_resolution_pass_for_module_1_using__6140", "Auto discovery for typings is enabled in project '{0}'. Running extra resolution pass for module '{1}' using cache location '{2}'."),
	        Parse_in_strict_mode_and_emit_use_strict_for_each_source_file: diag(6141, 3 /* Message */, "Parse_in_strict_mode_and_emit_use_strict_for_each_source_file_6141", 'Parse in strict mode and emit "use strict" for each source file.'),
	        Module_0_was_resolved_to_1_but_jsx_is_not_set: diag(6142, 1 /* Error */, "Module_0_was_resolved_to_1_but_jsx_is_not_set_6142", "Module '{0}' was resolved to '{1}', but '--jsx' is not set."),
	        Module_0_was_resolved_as_locally_declared_ambient_module_in_file_1: diag(6144, 3 /* Message */, "Module_0_was_resolved_as_locally_declared_ambient_module_in_file_1_6144", "Module '{0}' was resolved as locally declared ambient module in file '{1}'."),
	        Module_0_was_resolved_as_ambient_module_declared_in_1_since_this_file_was_not_modified: diag(6145, 3 /* Message */, "Module_0_was_resolved_as_ambient_module_declared_in_1_since_this_file_was_not_modified_6145", "Module '{0}' was resolved as ambient module declared in '{1}' since this file was not modified."),
	        Specify_the_JSX_factory_function_to_use_when_targeting_react_JSX_emit_e_g_React_createElement_or_h: diag(6146, 3 /* Message */, "Specify_the_JSX_factory_function_to_use_when_targeting_react_JSX_emit_e_g_React_createElement_or_h_6146", "Specify the JSX factory function to use when targeting 'react' JSX emit, e.g. 'React.createElement' or 'h'."),
	        Resolution_for_module_0_was_found_in_cache_from_location_1: diag(6147, 3 /* Message */, "Resolution_for_module_0_was_found_in_cache_from_location_1_6147", "Resolution for module '{0}' was found in cache from location '{1}'."),
	        Directory_0_does_not_exist_skipping_all_lookups_in_it: diag(6148, 3 /* Message */, "Directory_0_does_not_exist_skipping_all_lookups_in_it_6148", "Directory '{0}' does not exist, skipping all lookups in it."),
	        Show_diagnostic_information: diag(6149, 3 /* Message */, "Show_diagnostic_information_6149", "Show diagnostic information."),
	        Show_verbose_diagnostic_information: diag(6150, 3 /* Message */, "Show_verbose_diagnostic_information_6150", "Show verbose diagnostic information."),
	        Emit_a_single_file_with_source_maps_instead_of_having_a_separate_file: diag(6151, 3 /* Message */, "Emit_a_single_file_with_source_maps_instead_of_having_a_separate_file_6151", "Emit a single file with source maps instead of having a separate file."),
	        Emit_the_source_alongside_the_sourcemaps_within_a_single_file_requires_inlineSourceMap_or_sourceMap_to_be_set: diag(6152, 3 /* Message */, "Emit_the_source_alongside_the_sourcemaps_within_a_single_file_requires_inlineSourceMap_or_sourceMap__6152", "Emit the source alongside the sourcemaps within a single file; requires '--inlineSourceMap' or '--sourceMap' to be set."),
	        Transpile_each_file_as_a_separate_module_similar_to_ts_transpileModule: diag(6153, 3 /* Message */, "Transpile_each_file_as_a_separate_module_similar_to_ts_transpileModule_6153", "Transpile each file as a separate module (similar to 'ts.transpileModule')."),
	        Print_names_of_generated_files_part_of_the_compilation: diag(6154, 3 /* Message */, "Print_names_of_generated_files_part_of_the_compilation_6154", "Print names of generated files part of the compilation."),
	        Print_names_of_files_part_of_the_compilation: diag(6155, 3 /* Message */, "Print_names_of_files_part_of_the_compilation_6155", "Print names of files part of the compilation."),
	        The_locale_used_when_displaying_messages_to_the_user_e_g_en_us: diag(6156, 3 /* Message */, "The_locale_used_when_displaying_messages_to_the_user_e_g_en_us_6156", "The locale used when displaying messages to the user (e.g. 'en-us')"),
	        Do_not_generate_custom_helper_functions_like_extends_in_compiled_output: diag(6157, 3 /* Message */, "Do_not_generate_custom_helper_functions_like_extends_in_compiled_output_6157", "Do not generate custom helper functions like '__extends' in compiled output."),
	        Do_not_include_the_default_library_file_lib_d_ts: diag(6158, 3 /* Message */, "Do_not_include_the_default_library_file_lib_d_ts_6158", "Do not include the default library file (lib.d.ts)."),
	        Do_not_add_triple_slash_references_or_imported_modules_to_the_list_of_compiled_files: diag(6159, 3 /* Message */, "Do_not_add_triple_slash_references_or_imported_modules_to_the_list_of_compiled_files_6159", "Do not add triple-slash references or imported modules to the list of compiled files."),
	        Deprecated_Use_skipLibCheck_instead_Skip_type_checking_of_default_library_declaration_files: diag(6160, 3 /* Message */, "Deprecated_Use_skipLibCheck_instead_Skip_type_checking_of_default_library_declaration_files_6160", "[Deprecated] Use '--skipLibCheck' instead. Skip type checking of default library declaration files."),
	        List_of_folders_to_include_type_definitions_from: diag(6161, 3 /* Message */, "List_of_folders_to_include_type_definitions_from_6161", "List of folders to include type definitions from."),
	        Disable_size_limitations_on_JavaScript_projects: diag(6162, 3 /* Message */, "Disable_size_limitations_on_JavaScript_projects_6162", "Disable size limitations on JavaScript projects."),
	        The_character_set_of_the_input_files: diag(6163, 3 /* Message */, "The_character_set_of_the_input_files_6163", "The character set of the input files."),
	        Skipping_module_0_that_looks_like_an_absolute_URI_target_file_types_Colon_1: diag(6164, 3 /* Message */, "Skipping_module_0_that_looks_like_an_absolute_URI_target_file_types_Colon_1_6164", "Skipping module '{0}' that looks like an absolute URI, target file types: {1}."),
	        Do_not_truncate_error_messages: diag(6165, 3 /* Message */, "Do_not_truncate_error_messages_6165", "Do not truncate error messages."),
	        Output_directory_for_generated_declaration_files: diag(6166, 3 /* Message */, "Output_directory_for_generated_declaration_files_6166", "Output directory for generated declaration files."),
	        A_series_of_entries_which_re_map_imports_to_lookup_locations_relative_to_the_baseUrl: diag(6167, 3 /* Message */, "A_series_of_entries_which_re_map_imports_to_lookup_locations_relative_to_the_baseUrl_6167", "A series of entries which re-map imports to lookup locations relative to the 'baseUrl'."),
	        List_of_root_folders_whose_combined_content_represents_the_structure_of_the_project_at_runtime: diag(6168, 3 /* Message */, "List_of_root_folders_whose_combined_content_represents_the_structure_of_the_project_at_runtime_6168", "List of root folders whose combined content represents the structure of the project at runtime."),
	        Show_all_compiler_options: diag(6169, 3 /* Message */, "Show_all_compiler_options_6169", "Show all compiler options."),
	        Deprecated_Use_outFile_instead_Concatenate_and_emit_output_to_single_file: diag(6170, 3 /* Message */, "Deprecated_Use_outFile_instead_Concatenate_and_emit_output_to_single_file_6170", "[Deprecated] Use '--outFile' instead. Concatenate and emit output to single file"),
	        Command_line_Options: diag(6171, 3 /* Message */, "Command_line_Options_6171", "Command-line Options"),
	        Provide_full_support_for_iterables_in_for_of_spread_and_destructuring_when_targeting_ES5_or_ES3: diag(6179, 3 /* Message */, "Provide_full_support_for_iterables_in_for_of_spread_and_destructuring_when_targeting_ES5_or_ES3_6179", "Provide full support for iterables in 'for-of', spread, and destructuring when targeting 'ES5' or 'ES3'."),
	        Enable_all_strict_type_checking_options: diag(6180, 3 /* Message */, "Enable_all_strict_type_checking_options_6180", "Enable all strict type-checking options."),
	        Scoped_package_detected_looking_in_0: diag(6182, 3 /* Message */, "Scoped_package_detected_looking_in_0_6182", "Scoped package detected, looking in '{0}'"),
	        Reusing_resolution_of_module_0_from_1_of_old_program_it_was_successfully_resolved_to_2: diag(6183, 3 /* Message */, "Reusing_resolution_of_module_0_from_1_of_old_program_it_was_successfully_resolved_to_2_6183", "Reusing resolution of module '{0}' from '{1}' of old program, it was successfully resolved to '{2}'."),
	        Reusing_resolution_of_module_0_from_1_of_old_program_it_was_successfully_resolved_to_2_with_Package_ID_3: diag(6184, 3 /* Message */, "Reusing_resolution_of_module_0_from_1_of_old_program_it_was_successfully_resolved_to_2_with_Package__6184", "Reusing resolution of module '{0}' from '{1}' of old program, it was successfully resolved to '{2}' with Package ID '{3}'."),
	        Enable_strict_checking_of_function_types: diag(6186, 3 /* Message */, "Enable_strict_checking_of_function_types_6186", "Enable strict checking of function types."),
	        Enable_strict_checking_of_property_initialization_in_classes: diag(6187, 3 /* Message */, "Enable_strict_checking_of_property_initialization_in_classes_6187", "Enable strict checking of property initialization in classes."),
	        Numeric_separators_are_not_allowed_here: diag(6188, 1 /* Error */, "Numeric_separators_are_not_allowed_here_6188", "Numeric separators are not allowed here."),
	        Multiple_consecutive_numeric_separators_are_not_permitted: diag(6189, 1 /* Error */, "Multiple_consecutive_numeric_separators_are_not_permitted_6189", "Multiple consecutive numeric separators are not permitted."),
	        Whether_to_keep_outdated_console_output_in_watch_mode_instead_of_clearing_the_screen: diag(6191, 3 /* Message */, "Whether_to_keep_outdated_console_output_in_watch_mode_instead_of_clearing_the_screen_6191", "Whether to keep outdated console output in watch mode instead of clearing the screen."),
	        All_imports_in_import_declaration_are_unused: diag(
	          6192,
	          1 /* Error */,
	          "All_imports_in_import_declaration_are_unused_6192",
	          "All imports in import declaration are unused.",
	          /*reportsUnnecessary*/
	          true
	        ),
	        Found_1_error_Watching_for_file_changes: diag(6193, 3 /* Message */, "Found_1_error_Watching_for_file_changes_6193", "Found 1 error. Watching for file changes."),
	        Found_0_errors_Watching_for_file_changes: diag(6194, 3 /* Message */, "Found_0_errors_Watching_for_file_changes_6194", "Found {0} errors. Watching for file changes."),
	        Resolve_keyof_to_string_valued_property_names_only_no_numbers_or_symbols: diag(6195, 3 /* Message */, "Resolve_keyof_to_string_valued_property_names_only_no_numbers_or_symbols_6195", "Resolve 'keyof' to string valued property names only (no numbers or symbols)."),
	        _0_is_declared_but_never_used: diag(
	          6196,
	          1 /* Error */,
	          "_0_is_declared_but_never_used_6196",
	          "'{0}' is declared but never used.",
	          /*reportsUnnecessary*/
	          true
	        ),
	        Include_modules_imported_with_json_extension: diag(6197, 3 /* Message */, "Include_modules_imported_with_json_extension_6197", "Include modules imported with '.json' extension"),
	        All_destructured_elements_are_unused: diag(
	          6198,
	          1 /* Error */,
	          "All_destructured_elements_are_unused_6198",
	          "All destructured elements are unused.",
	          /*reportsUnnecessary*/
	          true
	        ),
	        All_variables_are_unused: diag(
	          6199,
	          1 /* Error */,
	          "All_variables_are_unused_6199",
	          "All variables are unused.",
	          /*reportsUnnecessary*/
	          true
	        ),
	        Definitions_of_the_following_identifiers_conflict_with_those_in_another_file_Colon_0: diag(6200, 1 /* Error */, "Definitions_of_the_following_identifiers_conflict_with_those_in_another_file_Colon_0_6200", "Definitions of the following identifiers conflict with those in another file: {0}"),
	        Conflicts_are_in_this_file: diag(6201, 3 /* Message */, "Conflicts_are_in_this_file_6201", "Conflicts are in this file."),
	        Project_references_may_not_form_a_circular_graph_Cycle_detected_Colon_0: diag(6202, 1 /* Error */, "Project_references_may_not_form_a_circular_graph_Cycle_detected_Colon_0_6202", "Project references may not form a circular graph. Cycle detected: {0}"),
	        _0_was_also_declared_here: diag(6203, 3 /* Message */, "_0_was_also_declared_here_6203", "'{0}' was also declared here."),
	        and_here: diag(6204, 3 /* Message */, "and_here_6204", "and here."),
	        All_type_parameters_are_unused: diag(6205, 1 /* Error */, "All_type_parameters_are_unused_6205", "All type parameters are unused."),
	        package_json_has_a_typesVersions_field_with_version_specific_path_mappings: diag(6206, 3 /* Message */, "package_json_has_a_typesVersions_field_with_version_specific_path_mappings_6206", "'package.json' has a 'typesVersions' field with version-specific path mappings."),
	        package_json_does_not_have_a_typesVersions_entry_that_matches_version_0: diag(6207, 3 /* Message */, "package_json_does_not_have_a_typesVersions_entry_that_matches_version_0_6207", "'package.json' does not have a 'typesVersions' entry that matches version '{0}'."),
	        package_json_has_a_typesVersions_entry_0_that_matches_compiler_version_1_looking_for_a_pattern_to_match_module_name_2: diag(6208, 3 /* Message */, "package_json_has_a_typesVersions_entry_0_that_matches_compiler_version_1_looking_for_a_pattern_to_ma_6208", "'package.json' has a 'typesVersions' entry '{0}' that matches compiler version '{1}', looking for a pattern to match module name '{2}'."),
	        package_json_has_a_typesVersions_entry_0_that_is_not_a_valid_semver_range: diag(6209, 3 /* Message */, "package_json_has_a_typesVersions_entry_0_that_is_not_a_valid_semver_range_6209", "'package.json' has a 'typesVersions' entry '{0}' that is not a valid semver range."),
	        An_argument_for_0_was_not_provided: diag(6210, 3 /* Message */, "An_argument_for_0_was_not_provided_6210", "An argument for '{0}' was not provided."),
	        An_argument_matching_this_binding_pattern_was_not_provided: diag(6211, 3 /* Message */, "An_argument_matching_this_binding_pattern_was_not_provided_6211", "An argument matching this binding pattern was not provided."),
	        Did_you_mean_to_call_this_expression: diag(6212, 3 /* Message */, "Did_you_mean_to_call_this_expression_6212", "Did you mean to call this expression?"),
	        Did_you_mean_to_use_new_with_this_expression: diag(6213, 3 /* Message */, "Did_you_mean_to_use_new_with_this_expression_6213", "Did you mean to use 'new' with this expression?"),
	        Enable_strict_bind_call_and_apply_methods_on_functions: diag(6214, 3 /* Message */, "Enable_strict_bind_call_and_apply_methods_on_functions_6214", "Enable strict 'bind', 'call', and 'apply' methods on functions."),
	        Using_compiler_options_of_project_reference_redirect_0: diag(6215, 3 /* Message */, "Using_compiler_options_of_project_reference_redirect_0_6215", "Using compiler options of project reference redirect '{0}'."),
	        Found_1_error: diag(6216, 3 /* Message */, "Found_1_error_6216", "Found 1 error."),
	        Found_0_errors: diag(6217, 3 /* Message */, "Found_0_errors_6217", "Found {0} errors."),
	        Module_name_0_was_successfully_resolved_to_1_with_Package_ID_2: diag(6218, 3 /* Message */, "Module_name_0_was_successfully_resolved_to_1_with_Package_ID_2_6218", "======== Module name '{0}' was successfully resolved to '{1}' with Package ID '{2}'. ========"),
	        Type_reference_directive_0_was_successfully_resolved_to_1_with_Package_ID_2_primary_Colon_3: diag(6219, 3 /* Message */, "Type_reference_directive_0_was_successfully_resolved_to_1_with_Package_ID_2_primary_Colon_3_6219", "======== Type reference directive '{0}' was successfully resolved to '{1}' with Package ID '{2}', primary: {3}. ========"),
	        package_json_had_a_falsy_0_field: diag(6220, 3 /* Message */, "package_json_had_a_falsy_0_field_6220", "'package.json' had a falsy '{0}' field."),
	        Disable_use_of_source_files_instead_of_declaration_files_from_referenced_projects: diag(6221, 3 /* Message */, "Disable_use_of_source_files_instead_of_declaration_files_from_referenced_projects_6221", "Disable use of source files instead of declaration files from referenced projects."),
	        Emit_class_fields_with_Define_instead_of_Set: diag(6222, 3 /* Message */, "Emit_class_fields_with_Define_instead_of_Set_6222", "Emit class fields with Define instead of Set."),
	        Generates_a_CPU_profile: diag(6223, 3 /* Message */, "Generates_a_CPU_profile_6223", "Generates a CPU profile."),
	        Disable_solution_searching_for_this_project: diag(6224, 3 /* Message */, "Disable_solution_searching_for_this_project_6224", "Disable solution searching for this project."),
	        Specify_strategy_for_watching_file_Colon_FixedPollingInterval_default_PriorityPollingInterval_DynamicPriorityPolling_FixedChunkSizePolling_UseFsEvents_UseFsEventsOnParentDirectory: diag(6225, 3 /* Message */, "Specify_strategy_for_watching_file_Colon_FixedPollingInterval_default_PriorityPollingInterval_Dynami_6225", "Specify strategy for watching file: 'FixedPollingInterval' (default), 'PriorityPollingInterval', 'DynamicPriorityPolling', 'FixedChunkSizePolling', 'UseFsEvents', 'UseFsEventsOnParentDirectory'."),
	        Specify_strategy_for_watching_directory_on_platforms_that_don_t_support_recursive_watching_natively_Colon_UseFsEvents_default_FixedPollingInterval_DynamicPriorityPolling_FixedChunkSizePolling: diag(6226, 3 /* Message */, "Specify_strategy_for_watching_directory_on_platforms_that_don_t_support_recursive_watching_natively__6226", "Specify strategy for watching directory on platforms that don't support recursive watching natively: 'UseFsEvents' (default), 'FixedPollingInterval', 'DynamicPriorityPolling', 'FixedChunkSizePolling'."),
	        Specify_strategy_for_creating_a_polling_watch_when_it_fails_to_create_using_file_system_events_Colon_FixedInterval_default_PriorityInterval_DynamicPriority_FixedChunkSize: diag(6227, 3 /* Message */, "Specify_strategy_for_creating_a_polling_watch_when_it_fails_to_create_using_file_system_events_Colon_6227", "Specify strategy for creating a polling watch when it fails to create using file system events: 'FixedInterval' (default), 'PriorityInterval', 'DynamicPriority', 'FixedChunkSize'."),
	        Tag_0_expects_at_least_1_arguments_but_the_JSX_factory_2_provides_at_most_3: diag(6229, 1 /* Error */, "Tag_0_expects_at_least_1_arguments_but_the_JSX_factory_2_provides_at_most_3_6229", "Tag '{0}' expects at least '{1}' arguments, but the JSX factory '{2}' provides at most '{3}'."),
	        Option_0_can_only_be_specified_in_tsconfig_json_file_or_set_to_false_or_null_on_command_line: diag(6230, 1 /* Error */, "Option_0_can_only_be_specified_in_tsconfig_json_file_or_set_to_false_or_null_on_command_line_6230", "Option '{0}' can only be specified in 'tsconfig.json' file or set to 'false' or 'null' on command line."),
	        Could_not_resolve_the_path_0_with_the_extensions_Colon_1: diag(6231, 1 /* Error */, "Could_not_resolve_the_path_0_with_the_extensions_Colon_1_6231", "Could not resolve the path '{0}' with the extensions: {1}."),
	        Declaration_augments_declaration_in_another_file_This_cannot_be_serialized: diag(6232, 1 /* Error */, "Declaration_augments_declaration_in_another_file_This_cannot_be_serialized_6232", "Declaration augments declaration in another file. This cannot be serialized."),
	        This_is_the_declaration_being_augmented_Consider_moving_the_augmenting_declaration_into_the_same_file: diag(6233, 1 /* Error */, "This_is_the_declaration_being_augmented_Consider_moving_the_augmenting_declaration_into_the_same_fil_6233", "This is the declaration being augmented. Consider moving the augmenting declaration into the same file."),
	        This_expression_is_not_callable_because_it_is_a_get_accessor_Did_you_mean_to_use_it_without: diag(6234, 1 /* Error */, "This_expression_is_not_callable_because_it_is_a_get_accessor_Did_you_mean_to_use_it_without_6234", "This expression is not callable because it is a 'get' accessor. Did you mean to use it without '()'?"),
	        Disable_loading_referenced_projects: diag(6235, 3 /* Message */, "Disable_loading_referenced_projects_6235", "Disable loading referenced projects."),
	        Arguments_for_the_rest_parameter_0_were_not_provided: diag(6236, 1 /* Error */, "Arguments_for_the_rest_parameter_0_were_not_provided_6236", "Arguments for the rest parameter '{0}' were not provided."),
	        Generates_an_event_trace_and_a_list_of_types: diag(6237, 3 /* Message */, "Generates_an_event_trace_and_a_list_of_types_6237", "Generates an event trace and a list of types."),
	        Specify_the_module_specifier_to_be_used_to_import_the_jsx_and_jsxs_factory_functions_from_eg_react: diag(6238, 1 /* Error */, "Specify_the_module_specifier_to_be_used_to_import_the_jsx_and_jsxs_factory_functions_from_eg_react_6238", "Specify the module specifier to be used to import the 'jsx' and 'jsxs' factory functions from. eg, react"),
	        File_0_exists_according_to_earlier_cached_lookups: diag(6239, 3 /* Message */, "File_0_exists_according_to_earlier_cached_lookups_6239", "File '{0}' exists according to earlier cached lookups."),
	        File_0_does_not_exist_according_to_earlier_cached_lookups: diag(6240, 3 /* Message */, "File_0_does_not_exist_according_to_earlier_cached_lookups_6240", "File '{0}' does not exist according to earlier cached lookups."),
	        Resolution_for_type_reference_directive_0_was_found_in_cache_from_location_1: diag(6241, 3 /* Message */, "Resolution_for_type_reference_directive_0_was_found_in_cache_from_location_1_6241", "Resolution for type reference directive '{0}' was found in cache from location '{1}'."),
	        Resolving_type_reference_directive_0_containing_file_1: diag(6242, 3 /* Message */, "Resolving_type_reference_directive_0_containing_file_1_6242", "======== Resolving type reference directive '{0}', containing file '{1}'. ========"),
	        Interpret_optional_property_types_as_written_rather_than_adding_undefined: diag(6243, 3 /* Message */, "Interpret_optional_property_types_as_written_rather_than_adding_undefined_6243", "Interpret optional property types as written, rather than adding 'undefined'."),
	        Modules: diag(6244, 3 /* Message */, "Modules_6244", "Modules"),
	        File_Management: diag(6245, 3 /* Message */, "File_Management_6245", "File Management"),
	        Emit: diag(6246, 3 /* Message */, "Emit_6246", "Emit"),
	        JavaScript_Support: diag(6247, 3 /* Message */, "JavaScript_Support_6247", "JavaScript Support"),
	        Type_Checking: diag(6248, 3 /* Message */, "Type_Checking_6248", "Type Checking"),
	        Editor_Support: diag(6249, 3 /* Message */, "Editor_Support_6249", "Editor Support"),
	        Watch_and_Build_Modes: diag(6250, 3 /* Message */, "Watch_and_Build_Modes_6250", "Watch and Build Modes"),
	        Compiler_Diagnostics: diag(6251, 3 /* Message */, "Compiler_Diagnostics_6251", "Compiler Diagnostics"),
	        Interop_Constraints: diag(6252, 3 /* Message */, "Interop_Constraints_6252", "Interop Constraints"),
	        Backwards_Compatibility: diag(6253, 3 /* Message */, "Backwards_Compatibility_6253", "Backwards Compatibility"),
	        Language_and_Environment: diag(6254, 3 /* Message */, "Language_and_Environment_6254", "Language and Environment"),
	        Projects: diag(6255, 3 /* Message */, "Projects_6255", "Projects"),
	        Output_Formatting: diag(6256, 3 /* Message */, "Output_Formatting_6256", "Output Formatting"),
	        Completeness: diag(6257, 3 /* Message */, "Completeness_6257", "Completeness"),
	        _0_should_be_set_inside_the_compilerOptions_object_of_the_config_json_file: diag(6258, 1 /* Error */, "_0_should_be_set_inside_the_compilerOptions_object_of_the_config_json_file_6258", "'{0}' should be set inside the 'compilerOptions' object of the config json file"),
	        Found_1_error_in_0: diag(6259, 3 /* Message */, "Found_1_error_in_0_6259", "Found 1 error in {0}"),
	        Found_0_errors_in_the_same_file_starting_at_Colon_1: diag(6260, 3 /* Message */, "Found_0_errors_in_the_same_file_starting_at_Colon_1_6260", "Found {0} errors in the same file, starting at: {1}"),
	        Found_0_errors_in_1_files: diag(6261, 3 /* Message */, "Found_0_errors_in_1_files_6261", "Found {0} errors in {1} files."),
	        File_name_0_has_a_1_extension_looking_up_2_instead: diag(6262, 3 /* Message */, "File_name_0_has_a_1_extension_looking_up_2_instead_6262", "File name '{0}' has a '{1}' extension - looking up '{2}' instead."),
	        Module_0_was_resolved_to_1_but_allowArbitraryExtensions_is_not_set: diag(6263, 1 /* Error */, "Module_0_was_resolved_to_1_but_allowArbitraryExtensions_is_not_set_6263", "Module '{0}' was resolved to '{1}', but '--allowArbitraryExtensions' is not set."),
	        Enable_importing_files_with_any_extension_provided_a_declaration_file_is_present: diag(6264, 3 /* Message */, "Enable_importing_files_with_any_extension_provided_a_declaration_file_is_present_6264", "Enable importing files with any extension, provided a declaration file is present."),
	        Resolving_type_reference_directive_for_program_that_specifies_custom_typeRoots_skipping_lookup_in_node_modules_folder: diag(6265, 3 /* Message */, "Resolving_type_reference_directive_for_program_that_specifies_custom_typeRoots_skipping_lookup_in_no_6265", "Resolving type reference directive for program that specifies custom typeRoots, skipping lookup in 'node_modules' folder."),
	        Option_0_can_only_be_specified_on_command_line: diag(6266, 1 /* Error */, "Option_0_can_only_be_specified_on_command_line_6266", "Option '{0}' can only be specified on command line."),
	        Directory_0_has_no_containing_package_json_scope_Imports_will_not_resolve: diag(6270, 3 /* Message */, "Directory_0_has_no_containing_package_json_scope_Imports_will_not_resolve_6270", "Directory '{0}' has no containing package.json scope. Imports will not resolve."),
	        Import_specifier_0_does_not_exist_in_package_json_scope_at_path_1: diag(6271, 3 /* Message */, "Import_specifier_0_does_not_exist_in_package_json_scope_at_path_1_6271", "Import specifier '{0}' does not exist in package.json scope at path '{1}'."),
	        Invalid_import_specifier_0_has_no_possible_resolutions: diag(6272, 3 /* Message */, "Invalid_import_specifier_0_has_no_possible_resolutions_6272", "Invalid import specifier '{0}' has no possible resolutions."),
	        package_json_scope_0_has_no_imports_defined: diag(6273, 3 /* Message */, "package_json_scope_0_has_no_imports_defined_6273", "package.json scope '{0}' has no imports defined."),
	        package_json_scope_0_explicitly_maps_specifier_1_to_null: diag(6274, 3 /* Message */, "package_json_scope_0_explicitly_maps_specifier_1_to_null_6274", "package.json scope '{0}' explicitly maps specifier '{1}' to null."),
	        package_json_scope_0_has_invalid_type_for_target_of_specifier_1: diag(6275, 3 /* Message */, "package_json_scope_0_has_invalid_type_for_target_of_specifier_1_6275", "package.json scope '{0}' has invalid type for target of specifier '{1}'"),
	        Export_specifier_0_does_not_exist_in_package_json_scope_at_path_1: diag(6276, 3 /* Message */, "Export_specifier_0_does_not_exist_in_package_json_scope_at_path_1_6276", "Export specifier '{0}' does not exist in package.json scope at path '{1}'."),
	        Resolution_of_non_relative_name_failed_trying_with_modern_Node_resolution_features_disabled_to_see_if_npm_library_needs_configuration_update: diag(6277, 3 /* Message */, "Resolution_of_non_relative_name_failed_trying_with_modern_Node_resolution_features_disabled_to_see_i_6277", "Resolution of non-relative name failed; trying with modern Node resolution features disabled to see if npm library needs configuration update."),
	        There_are_types_at_0_but_this_result_could_not_be_resolved_when_respecting_package_json_exports_The_1_library_may_need_to_update_its_package_json_or_typings: diag(6278, 3 /* Message */, "There_are_types_at_0_but_this_result_could_not_be_resolved_when_respecting_package_json_exports_The__6278", `There are types at '{0}', but this result could not be resolved when respecting package.json "exports". The '{1}' library may need to update its package.json or typings.`),
	        Resolution_of_non_relative_name_failed_trying_with_moduleResolution_bundler_to_see_if_project_may_need_configuration_update: diag(6279, 3 /* Message */, "Resolution_of_non_relative_name_failed_trying_with_moduleResolution_bundler_to_see_if_project_may_ne_6279", "Resolution of non-relative name failed; trying with '--moduleResolution bundler' to see if project may need configuration update."),
	        There_are_types_at_0_but_this_result_could_not_be_resolved_under_your_current_moduleResolution_setting_Consider_updating_to_node16_nodenext_or_bundler: diag(6280, 3 /* Message */, "There_are_types_at_0_but_this_result_could_not_be_resolved_under_your_current_moduleResolution_setti_6280", "There are types at '{0}', but this result could not be resolved under your current 'moduleResolution' setting. Consider updating to 'node16', 'nodenext', or 'bundler'."),
	        Enable_project_compilation: diag(6302, 3 /* Message */, "Enable_project_compilation_6302", "Enable project compilation"),
	        Composite_projects_may_not_disable_declaration_emit: diag(6304, 1 /* Error */, "Composite_projects_may_not_disable_declaration_emit_6304", "Composite projects may not disable declaration emit."),
	        Output_file_0_has_not_been_built_from_source_file_1: diag(6305, 1 /* Error */, "Output_file_0_has_not_been_built_from_source_file_1_6305", "Output file '{0}' has not been built from source file '{1}'."),
	        Referenced_project_0_must_have_setting_composite_Colon_true: diag(6306, 1 /* Error */, "Referenced_project_0_must_have_setting_composite_Colon_true_6306", `Referenced project '{0}' must have setting "composite": true.`),
	        File_0_is_not_listed_within_the_file_list_of_project_1_Projects_must_list_all_files_or_use_an_include_pattern: diag(6307, 1 /* Error */, "File_0_is_not_listed_within_the_file_list_of_project_1_Projects_must_list_all_files_or_use_an_includ_6307", "File '{0}' is not listed within the file list of project '{1}'. Projects must list all files or use an 'include' pattern."),
	        Cannot_prepend_project_0_because_it_does_not_have_outFile_set: diag(6308, 1 /* Error */, "Cannot_prepend_project_0_because_it_does_not_have_outFile_set_6308", "Cannot prepend project '{0}' because it does not have 'outFile' set"),
	        Output_file_0_from_project_1_does_not_exist: diag(6309, 1 /* Error */, "Output_file_0_from_project_1_does_not_exist_6309", "Output file '{0}' from project '{1}' does not exist"),
	        Referenced_project_0_may_not_disable_emit: diag(6310, 1 /* Error */, "Referenced_project_0_may_not_disable_emit_6310", "Referenced project '{0}' may not disable emit."),
	        Project_0_is_out_of_date_because_output_1_is_older_than_input_2: diag(6350, 3 /* Message */, "Project_0_is_out_of_date_because_output_1_is_older_than_input_2_6350", "Project '{0}' is out of date because output '{1}' is older than input '{2}'"),
	        Project_0_is_up_to_date_because_newest_input_1_is_older_than_output_2: diag(6351, 3 /* Message */, "Project_0_is_up_to_date_because_newest_input_1_is_older_than_output_2_6351", "Project '{0}' is up to date because newest input '{1}' is older than output '{2}'"),
	        Project_0_is_out_of_date_because_output_file_1_does_not_exist: diag(6352, 3 /* Message */, "Project_0_is_out_of_date_because_output_file_1_does_not_exist_6352", "Project '{0}' is out of date because output file '{1}' does not exist"),
	        Project_0_is_out_of_date_because_its_dependency_1_is_out_of_date: diag(6353, 3 /* Message */, "Project_0_is_out_of_date_because_its_dependency_1_is_out_of_date_6353", "Project '{0}' is out of date because its dependency '{1}' is out of date"),
	        Project_0_is_up_to_date_with_d_ts_files_from_its_dependencies: diag(6354, 3 /* Message */, "Project_0_is_up_to_date_with_d_ts_files_from_its_dependencies_6354", "Project '{0}' is up to date with .d.ts files from its dependencies"),
	        Projects_in_this_build_Colon_0: diag(6355, 3 /* Message */, "Projects_in_this_build_Colon_0_6355", "Projects in this build: {0}"),
	        A_non_dry_build_would_delete_the_following_files_Colon_0: diag(6356, 3 /* Message */, "A_non_dry_build_would_delete_the_following_files_Colon_0_6356", "A non-dry build would delete the following files: {0}"),
	        A_non_dry_build_would_build_project_0: diag(6357, 3 /* Message */, "A_non_dry_build_would_build_project_0_6357", "A non-dry build would build project '{0}'"),
	        Building_project_0: diag(6358, 3 /* Message */, "Building_project_0_6358", "Building project '{0}'..."),
	        Updating_output_timestamps_of_project_0: diag(6359, 3 /* Message */, "Updating_output_timestamps_of_project_0_6359", "Updating output timestamps of project '{0}'..."),
	        Project_0_is_up_to_date: diag(6361, 3 /* Message */, "Project_0_is_up_to_date_6361", "Project '{0}' is up to date"),
	        Skipping_build_of_project_0_because_its_dependency_1_has_errors: diag(6362, 3 /* Message */, "Skipping_build_of_project_0_because_its_dependency_1_has_errors_6362", "Skipping build of project '{0}' because its dependency '{1}' has errors"),
	        Project_0_can_t_be_built_because_its_dependency_1_has_errors: diag(6363, 3 /* Message */, "Project_0_can_t_be_built_because_its_dependency_1_has_errors_6363", "Project '{0}' can't be built because its dependency '{1}' has errors"),
	        Build_one_or_more_projects_and_their_dependencies_if_out_of_date: diag(6364, 3 /* Message */, "Build_one_or_more_projects_and_their_dependencies_if_out_of_date_6364", "Build one or more projects and their dependencies, if out of date"),
	        Delete_the_outputs_of_all_projects: diag(6365, 3 /* Message */, "Delete_the_outputs_of_all_projects_6365", "Delete the outputs of all projects."),
	        Show_what_would_be_built_or_deleted_if_specified_with_clean: diag(6367, 3 /* Message */, "Show_what_would_be_built_or_deleted_if_specified_with_clean_6367", "Show what would be built (or deleted, if specified with '--clean')"),
	        Option_build_must_be_the_first_command_line_argument: diag(6369, 1 /* Error */, "Option_build_must_be_the_first_command_line_argument_6369", "Option '--build' must be the first command line argument."),
	        Options_0_and_1_cannot_be_combined: diag(6370, 1 /* Error */, "Options_0_and_1_cannot_be_combined_6370", "Options '{0}' and '{1}' cannot be combined."),
	        Updating_unchanged_output_timestamps_of_project_0: diag(6371, 3 /* Message */, "Updating_unchanged_output_timestamps_of_project_0_6371", "Updating unchanged output timestamps of project '{0}'..."),
	        Project_0_is_out_of_date_because_output_of_its_dependency_1_has_changed: diag(6372, 3 /* Message */, "Project_0_is_out_of_date_because_output_of_its_dependency_1_has_changed_6372", "Project '{0}' is out of date because output of its dependency '{1}' has changed"),
	        Updating_output_of_project_0: diag(6373, 3 /* Message */, "Updating_output_of_project_0_6373", "Updating output of project '{0}'..."),
	        A_non_dry_build_would_update_timestamps_for_output_of_project_0: diag(6374, 3 /* Message */, "A_non_dry_build_would_update_timestamps_for_output_of_project_0_6374", "A non-dry build would update timestamps for output of project '{0}'"),
	        A_non_dry_build_would_update_output_of_project_0: diag(6375, 3 /* Message */, "A_non_dry_build_would_update_output_of_project_0_6375", "A non-dry build would update output of project '{0}'"),
	        Cannot_update_output_of_project_0_because_there_was_error_reading_file_1: diag(6376, 3 /* Message */, "Cannot_update_output_of_project_0_because_there_was_error_reading_file_1_6376", "Cannot update output of project '{0}' because there was error reading file '{1}'"),
	        Cannot_write_file_0_because_it_will_overwrite_tsbuildinfo_file_generated_by_referenced_project_1: diag(6377, 1 /* Error */, "Cannot_write_file_0_because_it_will_overwrite_tsbuildinfo_file_generated_by_referenced_project_1_6377", "Cannot write file '{0}' because it will overwrite '.tsbuildinfo' file generated by referenced project '{1}'"),
	        Composite_projects_may_not_disable_incremental_compilation: diag(6379, 1 /* Error */, "Composite_projects_may_not_disable_incremental_compilation_6379", "Composite projects may not disable incremental compilation."),
	        Specify_file_to_store_incremental_compilation_information: diag(6380, 3 /* Message */, "Specify_file_to_store_incremental_compilation_information_6380", "Specify file to store incremental compilation information"),
	        Project_0_is_out_of_date_because_output_for_it_was_generated_with_version_1_that_differs_with_current_version_2: diag(6381, 3 /* Message */, "Project_0_is_out_of_date_because_output_for_it_was_generated_with_version_1_that_differs_with_curren_6381", "Project '{0}' is out of date because output for it was generated with version '{1}' that differs with current version '{2}'"),
	        Skipping_build_of_project_0_because_its_dependency_1_was_not_built: diag(6382, 3 /* Message */, "Skipping_build_of_project_0_because_its_dependency_1_was_not_built_6382", "Skipping build of project '{0}' because its dependency '{1}' was not built"),
	        Project_0_can_t_be_built_because_its_dependency_1_was_not_built: diag(6383, 3 /* Message */, "Project_0_can_t_be_built_because_its_dependency_1_was_not_built_6383", "Project '{0}' can't be built because its dependency '{1}' was not built"),
	        Have_recompiles_in_incremental_and_watch_assume_that_changes_within_a_file_will_only_affect_files_directly_depending_on_it: diag(6384, 3 /* Message */, "Have_recompiles_in_incremental_and_watch_assume_that_changes_within_a_file_will_only_affect_files_di_6384", "Have recompiles in '--incremental' and '--watch' assume that changes within a file will only affect files directly depending on it."),
	        _0_is_deprecated: diag(
	          6385,
	          2 /* Suggestion */,
	          "_0_is_deprecated_6385",
	          "'{0}' is deprecated.",
	          /*reportsUnnecessary*/
	          void 0,
	          /*elidedInCompatabilityPyramid*/
	          void 0,
	          /*reportsDeprecated*/
	          true
	        ),
	        Performance_timings_for_diagnostics_or_extendedDiagnostics_are_not_available_in_this_session_A_native_implementation_of_the_Web_Performance_API_could_not_be_found: diag(6386, 3 /* Message */, "Performance_timings_for_diagnostics_or_extendedDiagnostics_are_not_available_in_this_session_A_nativ_6386", "Performance timings for '--diagnostics' or '--extendedDiagnostics' are not available in this session. A native implementation of the Web Performance API could not be found."),
	        The_signature_0_of_1_is_deprecated: diag(
	          6387,
	          2 /* Suggestion */,
	          "The_signature_0_of_1_is_deprecated_6387",
	          "The signature '{0}' of '{1}' is deprecated.",
	          /*reportsUnnecessary*/
	          void 0,
	          /*elidedInCompatabilityPyramid*/
	          void 0,
	          /*reportsDeprecated*/
	          true
	        ),
	        Project_0_is_being_forcibly_rebuilt: diag(6388, 3 /* Message */, "Project_0_is_being_forcibly_rebuilt_6388", "Project '{0}' is being forcibly rebuilt"),
	        Reusing_resolution_of_module_0_from_1_of_old_program_it_was_not_resolved: diag(6389, 3 /* Message */, "Reusing_resolution_of_module_0_from_1_of_old_program_it_was_not_resolved_6389", "Reusing resolution of module '{0}' from '{1}' of old program, it was not resolved."),
	        Reusing_resolution_of_type_reference_directive_0_from_1_of_old_program_it_was_successfully_resolved_to_2: diag(6390, 3 /* Message */, "Reusing_resolution_of_type_reference_directive_0_from_1_of_old_program_it_was_successfully_resolved__6390", "Reusing resolution of type reference directive '{0}' from '{1}' of old program, it was successfully resolved to '{2}'."),
	        Reusing_resolution_of_type_reference_directive_0_from_1_of_old_program_it_was_successfully_resolved_to_2_with_Package_ID_3: diag(6391, 3 /* Message */, "Reusing_resolution_of_type_reference_directive_0_from_1_of_old_program_it_was_successfully_resolved__6391", "Reusing resolution of type reference directive '{0}' from '{1}' of old program, it was successfully resolved to '{2}' with Package ID '{3}'."),
	        Reusing_resolution_of_type_reference_directive_0_from_1_of_old_program_it_was_not_resolved: diag(6392, 3 /* Message */, "Reusing_resolution_of_type_reference_directive_0_from_1_of_old_program_it_was_not_resolved_6392", "Reusing resolution of type reference directive '{0}' from '{1}' of old program, it was not resolved."),
	        Reusing_resolution_of_module_0_from_1_found_in_cache_from_location_2_it_was_successfully_resolved_to_3: diag(6393, 3 /* Message */, "Reusing_resolution_of_module_0_from_1_found_in_cache_from_location_2_it_was_successfully_resolved_to_6393", "Reusing resolution of module '{0}' from '{1}' found in cache from location '{2}', it was successfully resolved to '{3}'."),
	        Reusing_resolution_of_module_0_from_1_found_in_cache_from_location_2_it_was_successfully_resolved_to_3_with_Package_ID_4: diag(6394, 3 /* Message */, "Reusing_resolution_of_module_0_from_1_found_in_cache_from_location_2_it_was_successfully_resolved_to_6394", "Reusing resolution of module '{0}' from '{1}' found in cache from location '{2}', it was successfully resolved to '{3}' with Package ID '{4}'."),
	        Reusing_resolution_of_module_0_from_1_found_in_cache_from_location_2_it_was_not_resolved: diag(6395, 3 /* Message */, "Reusing_resolution_of_module_0_from_1_found_in_cache_from_location_2_it_was_not_resolved_6395", "Reusing resolution of module '{0}' from '{1}' found in cache from location '{2}', it was not resolved."),
	        Reusing_resolution_of_type_reference_directive_0_from_1_found_in_cache_from_location_2_it_was_successfully_resolved_to_3: diag(6396, 3 /* Message */, "Reusing_resolution_of_type_reference_directive_0_from_1_found_in_cache_from_location_2_it_was_succes_6396", "Reusing resolution of type reference directive '{0}' from '{1}' found in cache from location '{2}', it was successfully resolved to '{3}'."),
	        Reusing_resolution_of_type_reference_directive_0_from_1_found_in_cache_from_location_2_it_was_successfully_resolved_to_3_with_Package_ID_4: diag(6397, 3 /* Message */, "Reusing_resolution_of_type_reference_directive_0_from_1_found_in_cache_from_location_2_it_was_succes_6397", "Reusing resolution of type reference directive '{0}' from '{1}' found in cache from location '{2}', it was successfully resolved to '{3}' with Package ID '{4}'."),
	        Reusing_resolution_of_type_reference_directive_0_from_1_found_in_cache_from_location_2_it_was_not_resolved: diag(6398, 3 /* Message */, "Reusing_resolution_of_type_reference_directive_0_from_1_found_in_cache_from_location_2_it_was_not_re_6398", "Reusing resolution of type reference directive '{0}' from '{1}' found in cache from location '{2}', it was not resolved."),
	        Project_0_is_out_of_date_because_buildinfo_file_1_indicates_that_some_of_the_changes_were_not_emitted: diag(6399, 3 /* Message */, "Project_0_is_out_of_date_because_buildinfo_file_1_indicates_that_some_of_the_changes_were_not_emitte_6399", "Project '{0}' is out of date because buildinfo file '{1}' indicates that some of the changes were not emitted"),
	        Project_0_is_up_to_date_but_needs_to_update_timestamps_of_output_files_that_are_older_than_input_files: diag(6400, 3 /* Message */, "Project_0_is_up_to_date_but_needs_to_update_timestamps_of_output_files_that_are_older_than_input_fil_6400", "Project '{0}' is up to date but needs to update timestamps of output files that are older than input files"),
	        Project_0_is_out_of_date_because_there_was_error_reading_file_1: diag(6401, 3 /* Message */, "Project_0_is_out_of_date_because_there_was_error_reading_file_1_6401", "Project '{0}' is out of date because there was error reading file '{1}'"),
	        Resolving_in_0_mode_with_conditions_1: diag(6402, 3 /* Message */, "Resolving_in_0_mode_with_conditions_1_6402", "Resolving in {0} mode with conditions {1}."),
	        Matched_0_condition_1: diag(6403, 3 /* Message */, "Matched_0_condition_1_6403", "Matched '{0}' condition '{1}'."),
	        Using_0_subpath_1_with_target_2: diag(6404, 3 /* Message */, "Using_0_subpath_1_with_target_2_6404", "Using '{0}' subpath '{1}' with target '{2}'."),
	        Saw_non_matching_condition_0: diag(6405, 3 /* Message */, "Saw_non_matching_condition_0_6405", "Saw non-matching condition '{0}'."),
	        Project_0_is_out_of_date_because_buildinfo_file_1_indicates_there_is_change_in_compilerOptions: diag(6406, 3 /* Message */, "Project_0_is_out_of_date_because_buildinfo_file_1_indicates_there_is_change_in_compilerOptions_6406", "Project '{0}' is out of date because buildinfo file '{1}' indicates there is change in compilerOptions"),
	        Allow_imports_to_include_TypeScript_file_extensions_Requires_moduleResolution_bundler_and_either_noEmit_or_emitDeclarationOnly_to_be_set: diag(6407, 3 /* Message */, "Allow_imports_to_include_TypeScript_file_extensions_Requires_moduleResolution_bundler_and_either_noE_6407", "Allow imports to include TypeScript file extensions. Requires '--moduleResolution bundler' and either '--noEmit' or '--emitDeclarationOnly' to be set."),
	        Use_the_package_json_exports_field_when_resolving_package_imports: diag(6408, 3 /* Message */, "Use_the_package_json_exports_field_when_resolving_package_imports_6408", "Use the package.json 'exports' field when resolving package imports."),
	        Use_the_package_json_imports_field_when_resolving_imports: diag(6409, 3 /* Message */, "Use_the_package_json_imports_field_when_resolving_imports_6409", "Use the package.json 'imports' field when resolving imports."),
	        Conditions_to_set_in_addition_to_the_resolver_specific_defaults_when_resolving_imports: diag(6410, 3 /* Message */, "Conditions_to_set_in_addition_to_the_resolver_specific_defaults_when_resolving_imports_6410", "Conditions to set in addition to the resolver-specific defaults when resolving imports."),
	        true_when_moduleResolution_is_node16_nodenext_or_bundler_otherwise_false: diag(6411, 3 /* Message */, "true_when_moduleResolution_is_node16_nodenext_or_bundler_otherwise_false_6411", "`true` when 'moduleResolution' is 'node16', 'nodenext', or 'bundler'; otherwise `false`."),
	        Project_0_is_out_of_date_because_buildinfo_file_1_indicates_that_file_2_was_root_file_of_compilation_but_not_any_more: diag(6412, 3 /* Message */, "Project_0_is_out_of_date_because_buildinfo_file_1_indicates_that_file_2_was_root_file_of_compilation_6412", "Project '{0}' is out of date because buildinfo file '{1}' indicates that file '{2}' was root file of compilation but not any more."),
	        Entering_conditional_exports: diag(6413, 3 /* Message */, "Entering_conditional_exports_6413", "Entering conditional exports."),
	        Resolved_under_condition_0: diag(6414, 3 /* Message */, "Resolved_under_condition_0_6414", "Resolved under condition '{0}'."),
	        Failed_to_resolve_under_condition_0: diag(6415, 3 /* Message */, "Failed_to_resolve_under_condition_0_6415", "Failed to resolve under condition '{0}'."),
	        Exiting_conditional_exports: diag(6416, 3 /* Message */, "Exiting_conditional_exports_6416", "Exiting conditional exports."),
	        Searching_all_ancestor_node_modules_directories_for_preferred_extensions_Colon_0: diag(6417, 3 /* Message */, "Searching_all_ancestor_node_modules_directories_for_preferred_extensions_Colon_0_6417", "Searching all ancestor node_modules directories for preferred extensions: {0}."),
	        Searching_all_ancestor_node_modules_directories_for_fallback_extensions_Colon_0: diag(6418, 3 /* Message */, "Searching_all_ancestor_node_modules_directories_for_fallback_extensions_Colon_0_6418", "Searching all ancestor node_modules directories for fallback extensions: {0}."),
	        The_expected_type_comes_from_property_0_which_is_declared_here_on_type_1: diag(6500, 3 /* Message */, "The_expected_type_comes_from_property_0_which_is_declared_here_on_type_1_6500", "The expected type comes from property '{0}' which is declared here on type '{1}'"),
	        The_expected_type_comes_from_this_index_signature: diag(6501, 3 /* Message */, "The_expected_type_comes_from_this_index_signature_6501", "The expected type comes from this index signature."),
	        The_expected_type_comes_from_the_return_type_of_this_signature: diag(6502, 3 /* Message */, "The_expected_type_comes_from_the_return_type_of_this_signature_6502", "The expected type comes from the return type of this signature."),
	        Print_names_of_files_that_are_part_of_the_compilation_and_then_stop_processing: diag(6503, 3 /* Message */, "Print_names_of_files_that_are_part_of_the_compilation_and_then_stop_processing_6503", "Print names of files that are part of the compilation and then stop processing."),
	        File_0_is_a_JavaScript_file_Did_you_mean_to_enable_the_allowJs_option: diag(6504, 1 /* Error */, "File_0_is_a_JavaScript_file_Did_you_mean_to_enable_the_allowJs_option_6504", "File '{0}' is a JavaScript file. Did you mean to enable the 'allowJs' option?"),
	        Print_names_of_files_and_the_reason_they_are_part_of_the_compilation: diag(6505, 3 /* Message */, "Print_names_of_files_and_the_reason_they_are_part_of_the_compilation_6505", "Print names of files and the reason they are part of the compilation."),
	        Consider_adding_a_declare_modifier_to_this_class: diag(6506, 3 /* Message */, "Consider_adding_a_declare_modifier_to_this_class_6506", "Consider adding a 'declare' modifier to this class."),
	        Allow_JavaScript_files_to_be_a_part_of_your_program_Use_the_checkJS_option_to_get_errors_from_these_files: diag(6600, 3 /* Message */, "Allow_JavaScript_files_to_be_a_part_of_your_program_Use_the_checkJS_option_to_get_errors_from_these__6600", "Allow JavaScript files to be a part of your program. Use the 'checkJS' option to get errors from these files."),
	        Allow_import_x_from_y_when_a_module_doesn_t_have_a_default_export: diag(6601, 3 /* Message */, "Allow_import_x_from_y_when_a_module_doesn_t_have_a_default_export_6601", "Allow 'import x from y' when a module doesn't have a default export."),
	        Allow_accessing_UMD_globals_from_modules: diag(6602, 3 /* Message */, "Allow_accessing_UMD_globals_from_modules_6602", "Allow accessing UMD globals from modules."),
	        Disable_error_reporting_for_unreachable_code: diag(6603, 3 /* Message */, "Disable_error_reporting_for_unreachable_code_6603", "Disable error reporting for unreachable code."),
	        Disable_error_reporting_for_unused_labels: diag(6604, 3 /* Message */, "Disable_error_reporting_for_unused_labels_6604", "Disable error reporting for unused labels."),
	        Ensure_use_strict_is_always_emitted: diag(6605, 3 /* Message */, "Ensure_use_strict_is_always_emitted_6605", "Ensure 'use strict' is always emitted."),
	        Have_recompiles_in_projects_that_use_incremental_and_watch_mode_assume_that_changes_within_a_file_will_only_affect_files_directly_depending_on_it: diag(6606, 3 /* Message */, "Have_recompiles_in_projects_that_use_incremental_and_watch_mode_assume_that_changes_within_a_file_wi_6606", "Have recompiles in projects that use 'incremental' and 'watch' mode assume that changes within a file will only affect files directly depending on it."),
	        Specify_the_base_directory_to_resolve_non_relative_module_names: diag(6607, 3 /* Message */, "Specify_the_base_directory_to_resolve_non_relative_module_names_6607", "Specify the base directory to resolve non-relative module names."),
	        No_longer_supported_In_early_versions_manually_set_the_text_encoding_for_reading_files: diag(6608, 3 /* Message */, "No_longer_supported_In_early_versions_manually_set_the_text_encoding_for_reading_files_6608", "No longer supported. In early versions, manually set the text encoding for reading files."),
	        Enable_error_reporting_in_type_checked_JavaScript_files: diag(6609, 3 /* Message */, "Enable_error_reporting_in_type_checked_JavaScript_files_6609", "Enable error reporting in type-checked JavaScript files."),
	        Enable_constraints_that_allow_a_TypeScript_project_to_be_used_with_project_references: diag(6611, 3 /* Message */, "Enable_constraints_that_allow_a_TypeScript_project_to_be_used_with_project_references_6611", "Enable constraints that allow a TypeScript project to be used with project references."),
	        Generate_d_ts_files_from_TypeScript_and_JavaScript_files_in_your_project: diag(6612, 3 /* Message */, "Generate_d_ts_files_from_TypeScript_and_JavaScript_files_in_your_project_6612", "Generate .d.ts files from TypeScript and JavaScript files in your project."),
	        Specify_the_output_directory_for_generated_declaration_files: diag(6613, 3 /* Message */, "Specify_the_output_directory_for_generated_declaration_files_6613", "Specify the output directory for generated declaration files."),
	        Create_sourcemaps_for_d_ts_files: diag(6614, 3 /* Message */, "Create_sourcemaps_for_d_ts_files_6614", "Create sourcemaps for d.ts files."),
	        Output_compiler_performance_information_after_building: diag(6615, 3 /* Message */, "Output_compiler_performance_information_after_building_6615", "Output compiler performance information after building."),
	        Disables_inference_for_type_acquisition_by_looking_at_filenames_in_a_project: diag(6616, 3 /* Message */, "Disables_inference_for_type_acquisition_by_looking_at_filenames_in_a_project_6616", "Disables inference for type acquisition by looking at filenames in a project."),
	        Reduce_the_number_of_projects_loaded_automatically_by_TypeScript: diag(6617, 3 /* Message */, "Reduce_the_number_of_projects_loaded_automatically_by_TypeScript_6617", "Reduce the number of projects loaded automatically by TypeScript."),
	        Remove_the_20mb_cap_on_total_source_code_size_for_JavaScript_files_in_the_TypeScript_language_server: diag(6618, 3 /* Message */, "Remove_the_20mb_cap_on_total_source_code_size_for_JavaScript_files_in_the_TypeScript_language_server_6618", "Remove the 20mb cap on total source code size for JavaScript files in the TypeScript language server."),
	        Opt_a_project_out_of_multi_project_reference_checking_when_editing: diag(6619, 3 /* Message */, "Opt_a_project_out_of_multi_project_reference_checking_when_editing_6619", "Opt a project out of multi-project reference checking when editing."),
	        Disable_preferring_source_files_instead_of_declaration_files_when_referencing_composite_projects: diag(6620, 3 /* Message */, "Disable_preferring_source_files_instead_of_declaration_files_when_referencing_composite_projects_6620", "Disable preferring source files instead of declaration files when referencing composite projects."),
	        Emit_more_compliant_but_verbose_and_less_performant_JavaScript_for_iteration: diag(6621, 3 /* Message */, "Emit_more_compliant_but_verbose_and_less_performant_JavaScript_for_iteration_6621", "Emit more compliant, but verbose and less performant JavaScript for iteration."),
	        Emit_a_UTF_8_Byte_Order_Mark_BOM_in_the_beginning_of_output_files: diag(6622, 3 /* Message */, "Emit_a_UTF_8_Byte_Order_Mark_BOM_in_the_beginning_of_output_files_6622", "Emit a UTF-8 Byte Order Mark (BOM) in the beginning of output files."),
	        Only_output_d_ts_files_and_not_JavaScript_files: diag(6623, 3 /* Message */, "Only_output_d_ts_files_and_not_JavaScript_files_6623", "Only output d.ts files and not JavaScript files."),
	        Emit_design_type_metadata_for_decorated_declarations_in_source_files: diag(6624, 3 /* Message */, "Emit_design_type_metadata_for_decorated_declarations_in_source_files_6624", "Emit design-type metadata for decorated declarations in source files."),
	        Disable_the_type_acquisition_for_JavaScript_projects: diag(6625, 3 /* Message */, "Disable_the_type_acquisition_for_JavaScript_projects_6625", "Disable the type acquisition for JavaScript projects"),
	        Emit_additional_JavaScript_to_ease_support_for_importing_CommonJS_modules_This_enables_allowSyntheticDefaultImports_for_type_compatibility: diag(6626, 3 /* Message */, "Emit_additional_JavaScript_to_ease_support_for_importing_CommonJS_modules_This_enables_allowSyntheti_6626", "Emit additional JavaScript to ease support for importing CommonJS modules. This enables 'allowSyntheticDefaultImports' for type compatibility."),
	        Filters_results_from_the_include_option: diag(6627, 3 /* Message */, "Filters_results_from_the_include_option_6627", "Filters results from the `include` option."),
	        Remove_a_list_of_directories_from_the_watch_process: diag(6628, 3 /* Message */, "Remove_a_list_of_directories_from_the_watch_process_6628", "Remove a list of directories from the watch process."),
	        Remove_a_list_of_files_from_the_watch_mode_s_processing: diag(6629, 3 /* Message */, "Remove_a_list_of_files_from_the_watch_mode_s_processing_6629", "Remove a list of files from the watch mode's processing."),
	        Enable_experimental_support_for_legacy_experimental_decorators: diag(6630, 3 /* Message */, "Enable_experimental_support_for_legacy_experimental_decorators_6630", "Enable experimental support for legacy experimental decorators."),
	        Print_files_read_during_the_compilation_including_why_it_was_included: diag(6631, 3 /* Message */, "Print_files_read_during_the_compilation_including_why_it_was_included_6631", "Print files read during the compilation including why it was included."),
	        Output_more_detailed_compiler_performance_information_after_building: diag(6632, 3 /* Message */, "Output_more_detailed_compiler_performance_information_after_building_6632", "Output more detailed compiler performance information after building."),
	        Specify_one_or_more_path_or_node_module_references_to_base_configuration_files_from_which_settings_are_inherited: diag(6633, 3 /* Message */, "Specify_one_or_more_path_or_node_module_references_to_base_configuration_files_from_which_settings_a_6633", "Specify one or more path or node module references to base configuration files from which settings are inherited."),
	        Specify_what_approach_the_watcher_should_use_if_the_system_runs_out_of_native_file_watchers: diag(6634, 3 /* Message */, "Specify_what_approach_the_watcher_should_use_if_the_system_runs_out_of_native_file_watchers_6634", "Specify what approach the watcher should use if the system runs out of native file watchers."),
	        Include_a_list_of_files_This_does_not_support_glob_patterns_as_opposed_to_include: diag(6635, 3 /* Message */, "Include_a_list_of_files_This_does_not_support_glob_patterns_as_opposed_to_include_6635", "Include a list of files. This does not support glob patterns, as opposed to `include`."),
	        Build_all_projects_including_those_that_appear_to_be_up_to_date: diag(6636, 3 /* Message */, "Build_all_projects_including_those_that_appear_to_be_up_to_date_6636", "Build all projects, including those that appear to be up to date."),
	        Ensure_that_casing_is_correct_in_imports: diag(6637, 3 /* Message */, "Ensure_that_casing_is_correct_in_imports_6637", "Ensure that casing is correct in imports."),
	        Emit_a_v8_CPU_profile_of_the_compiler_run_for_debugging: diag(6638, 3 /* Message */, "Emit_a_v8_CPU_profile_of_the_compiler_run_for_debugging_6638", "Emit a v8 CPU profile of the compiler run for debugging."),
	        Allow_importing_helper_functions_from_tslib_once_per_project_instead_of_including_them_per_file: diag(6639, 3 /* Message */, "Allow_importing_helper_functions_from_tslib_once_per_project_instead_of_including_them_per_file_6639", "Allow importing helper functions from tslib once per project, instead of including them per-file."),
	        Specify_a_list_of_glob_patterns_that_match_files_to_be_included_in_compilation: diag(6641, 3 /* Message */, "Specify_a_list_of_glob_patterns_that_match_files_to_be_included_in_compilation_6641", "Specify a list of glob patterns that match files to be included in compilation."),
	        Save_tsbuildinfo_files_to_allow_for_incremental_compilation_of_projects: diag(6642, 3 /* Message */, "Save_tsbuildinfo_files_to_allow_for_incremental_compilation_of_projects_6642", "Save .tsbuildinfo files to allow for incremental compilation of projects."),
	        Include_sourcemap_files_inside_the_emitted_JavaScript: diag(6643, 3 /* Message */, "Include_sourcemap_files_inside_the_emitted_JavaScript_6643", "Include sourcemap files inside the emitted JavaScript."),
	        Include_source_code_in_the_sourcemaps_inside_the_emitted_JavaScript: diag(6644, 3 /* Message */, "Include_source_code_in_the_sourcemaps_inside_the_emitted_JavaScript_6644", "Include source code in the sourcemaps inside the emitted JavaScript."),
	        Ensure_that_each_file_can_be_safely_transpiled_without_relying_on_other_imports: diag(6645, 3 /* Message */, "Ensure_that_each_file_can_be_safely_transpiled_without_relying_on_other_imports_6645", "Ensure that each file can be safely transpiled without relying on other imports."),
	        Specify_what_JSX_code_is_generated: diag(6646, 3 /* Message */, "Specify_what_JSX_code_is_generated_6646", "Specify what JSX code is generated."),
	        Specify_the_JSX_factory_function_used_when_targeting_React_JSX_emit_e_g_React_createElement_or_h: diag(6647, 3 /* Message */, "Specify_the_JSX_factory_function_used_when_targeting_React_JSX_emit_e_g_React_createElement_or_h_6647", "Specify the JSX factory function used when targeting React JSX emit, e.g. 'React.createElement' or 'h'."),
	        Specify_the_JSX_Fragment_reference_used_for_fragments_when_targeting_React_JSX_emit_e_g_React_Fragment_or_Fragment: diag(6648, 3 /* Message */, "Specify_the_JSX_Fragment_reference_used_for_fragments_when_targeting_React_JSX_emit_e_g_React_Fragme_6648", "Specify the JSX Fragment reference used for fragments when targeting React JSX emit e.g. 'React.Fragment' or 'Fragment'."),
	        Specify_module_specifier_used_to_import_the_JSX_factory_functions_when_using_jsx_Colon_react_jsx_Asterisk: diag(6649, 3 /* Message */, "Specify_module_specifier_used_to_import_the_JSX_factory_functions_when_using_jsx_Colon_react_jsx_Ast_6649", "Specify module specifier used to import the JSX factory functions when using 'jsx: react-jsx*'."),
	        Make_keyof_only_return_strings_instead_of_string_numbers_or_symbols_Legacy_option: diag(6650, 3 /* Message */, "Make_keyof_only_return_strings_instead_of_string_numbers_or_symbols_Legacy_option_6650", "Make keyof only return strings instead of string, numbers or symbols. Legacy option."),
	        Specify_a_set_of_bundled_library_declaration_files_that_describe_the_target_runtime_environment: diag(6651, 3 /* Message */, "Specify_a_set_of_bundled_library_declaration_files_that_describe_the_target_runtime_environment_6651", "Specify a set of bundled library declaration files that describe the target runtime environment."),
	        Print_the_names_of_emitted_files_after_a_compilation: diag(6652, 3 /* Message */, "Print_the_names_of_emitted_files_after_a_compilation_6652", "Print the names of emitted files after a compilation."),
	        Print_all_of_the_files_read_during_the_compilation: diag(6653, 3 /* Message */, "Print_all_of_the_files_read_during_the_compilation_6653", "Print all of the files read during the compilation."),
	        Set_the_language_of_the_messaging_from_TypeScript_This_does_not_affect_emit: diag(6654, 3 /* Message */, "Set_the_language_of_the_messaging_from_TypeScript_This_does_not_affect_emit_6654", "Set the language of the messaging from TypeScript. This does not affect emit."),
	        Specify_the_location_where_debugger_should_locate_map_files_instead_of_generated_locations: diag(6655, 3 /* Message */, "Specify_the_location_where_debugger_should_locate_map_files_instead_of_generated_locations_6655", "Specify the location where debugger should locate map files instead of generated locations."),
	        Specify_the_maximum_folder_depth_used_for_checking_JavaScript_files_from_node_modules_Only_applicable_with_allowJs: diag(6656, 3 /* Message */, "Specify_the_maximum_folder_depth_used_for_checking_JavaScript_files_from_node_modules_Only_applicabl_6656", "Specify the maximum folder depth used for checking JavaScript files from 'node_modules'. Only applicable with 'allowJs'."),
	        Specify_what_module_code_is_generated: diag(6657, 3 /* Message */, "Specify_what_module_code_is_generated_6657", "Specify what module code is generated."),
	        Specify_how_TypeScript_looks_up_a_file_from_a_given_module_specifier: diag(6658, 3 /* Message */, "Specify_how_TypeScript_looks_up_a_file_from_a_given_module_specifier_6658", "Specify how TypeScript looks up a file from a given module specifier."),
	        Set_the_newline_character_for_emitting_files: diag(6659, 3 /* Message */, "Set_the_newline_character_for_emitting_files_6659", "Set the newline character for emitting files."),
	        Disable_emitting_files_from_a_compilation: diag(6660, 3 /* Message */, "Disable_emitting_files_from_a_compilation_6660", "Disable emitting files from a compilation."),
	        Disable_generating_custom_helper_functions_like_extends_in_compiled_output: diag(6661, 3 /* Message */, "Disable_generating_custom_helper_functions_like_extends_in_compiled_output_6661", "Disable generating custom helper functions like '__extends' in compiled output."),
	        Disable_emitting_files_if_any_type_checking_errors_are_reported: diag(6662, 3 /* Message */, "Disable_emitting_files_if_any_type_checking_errors_are_reported_6662", "Disable emitting files if any type checking errors are reported."),
	        Disable_truncating_types_in_error_messages: diag(6663, 3 /* Message */, "Disable_truncating_types_in_error_messages_6663", "Disable truncating types in error messages."),
	        Enable_error_reporting_for_fallthrough_cases_in_switch_statements: diag(6664, 3 /* Message */, "Enable_error_reporting_for_fallthrough_cases_in_switch_statements_6664", "Enable error reporting for fallthrough cases in switch statements."),
	        Enable_error_reporting_for_expressions_and_declarations_with_an_implied_any_type: diag(6665, 3 /* Message */, "Enable_error_reporting_for_expressions_and_declarations_with_an_implied_any_type_6665", "Enable error reporting for expressions and declarations with an implied 'any' type."),
	        Ensure_overriding_members_in_derived_classes_are_marked_with_an_override_modifier: diag(6666, 3 /* Message */, "Ensure_overriding_members_in_derived_classes_are_marked_with_an_override_modifier_6666", "Ensure overriding members in derived classes are marked with an override modifier."),
	        Enable_error_reporting_for_codepaths_that_do_not_explicitly_return_in_a_function: diag(6667, 3 /* Message */, "Enable_error_reporting_for_codepaths_that_do_not_explicitly_return_in_a_function_6667", "Enable error reporting for codepaths that do not explicitly return in a function."),
	        Enable_error_reporting_when_this_is_given_the_type_any: diag(6668, 3 /* Message */, "Enable_error_reporting_when_this_is_given_the_type_any_6668", "Enable error reporting when 'this' is given the type 'any'."),
	        Disable_adding_use_strict_directives_in_emitted_JavaScript_files: diag(6669, 3 /* Message */, "Disable_adding_use_strict_directives_in_emitted_JavaScript_files_6669", "Disable adding 'use strict' directives in emitted JavaScript files."),
	        Disable_including_any_library_files_including_the_default_lib_d_ts: diag(6670, 3 /* Message */, "Disable_including_any_library_files_including_the_default_lib_d_ts_6670", "Disable including any library files, including the default lib.d.ts."),
	        Enforces_using_indexed_accessors_for_keys_declared_using_an_indexed_type: diag(6671, 3 /* Message */, "Enforces_using_indexed_accessors_for_keys_declared_using_an_indexed_type_6671", "Enforces using indexed accessors for keys declared using an indexed type."),
	        Disallow_import_s_require_s_or_reference_s_from_expanding_the_number_of_files_TypeScript_should_add_to_a_project: diag(6672, 3 /* Message */, "Disallow_import_s_require_s_or_reference_s_from_expanding_the_number_of_files_TypeScript_should_add__6672", "Disallow 'import's, 'require's or '<reference>'s from expanding the number of files TypeScript should add to a project."),
	        Disable_strict_checking_of_generic_signatures_in_function_types: diag(6673, 3 /* Message */, "Disable_strict_checking_of_generic_signatures_in_function_types_6673", "Disable strict checking of generic signatures in function types."),
	        Add_undefined_to_a_type_when_accessed_using_an_index: diag(6674, 3 /* Message */, "Add_undefined_to_a_type_when_accessed_using_an_index_6674", "Add 'undefined' to a type when accessed using an index."),
	        Enable_error_reporting_when_local_variables_aren_t_read: diag(6675, 3 /* Message */, "Enable_error_reporting_when_local_variables_aren_t_read_6675", "Enable error reporting when local variables aren't read."),
	        Raise_an_error_when_a_function_parameter_isn_t_read: diag(6676, 3 /* Message */, "Raise_an_error_when_a_function_parameter_isn_t_read_6676", "Raise an error when a function parameter isn't read."),
	        Deprecated_setting_Use_outFile_instead: diag(6677, 3 /* Message */, "Deprecated_setting_Use_outFile_instead_6677", "Deprecated setting. Use 'outFile' instead."),
	        Specify_an_output_folder_for_all_emitted_files: diag(6678, 3 /* Message */, "Specify_an_output_folder_for_all_emitted_files_6678", "Specify an output folder for all emitted files."),
	        Specify_a_file_that_bundles_all_outputs_into_one_JavaScript_file_If_declaration_is_true_also_designates_a_file_that_bundles_all_d_ts_output: diag(6679, 3 /* Message */, "Specify_a_file_that_bundles_all_outputs_into_one_JavaScript_file_If_declaration_is_true_also_designa_6679", "Specify a file that bundles all outputs into one JavaScript file. If 'declaration' is true, also designates a file that bundles all .d.ts output."),
	        Specify_a_set_of_entries_that_re_map_imports_to_additional_lookup_locations: diag(6680, 3 /* Message */, "Specify_a_set_of_entries_that_re_map_imports_to_additional_lookup_locations_6680", "Specify a set of entries that re-map imports to additional lookup locations."),
	        Specify_a_list_of_language_service_plugins_to_include: diag(6681, 3 /* Message */, "Specify_a_list_of_language_service_plugins_to_include_6681", "Specify a list of language service plugins to include."),
	        Disable_erasing_const_enum_declarations_in_generated_code: diag(6682, 3 /* Message */, "Disable_erasing_const_enum_declarations_in_generated_code_6682", "Disable erasing 'const enum' declarations in generated code."),
	        Disable_resolving_symlinks_to_their_realpath_This_correlates_to_the_same_flag_in_node: diag(6683, 3 /* Message */, "Disable_resolving_symlinks_to_their_realpath_This_correlates_to_the_same_flag_in_node_6683", "Disable resolving symlinks to their realpath. This correlates to the same flag in node."),
	        Disable_wiping_the_console_in_watch_mode: diag(6684, 3 /* Message */, "Disable_wiping_the_console_in_watch_mode_6684", "Disable wiping the console in watch mode."),
	        Enable_color_and_formatting_in_TypeScript_s_output_to_make_compiler_errors_easier_to_read: diag(6685, 3 /* Message */, "Enable_color_and_formatting_in_TypeScript_s_output_to_make_compiler_errors_easier_to_read_6685", "Enable color and formatting in TypeScript's output to make compiler errors easier to read."),
	        Specify_the_object_invoked_for_createElement_This_only_applies_when_targeting_react_JSX_emit: diag(6686, 3 /* Message */, "Specify_the_object_invoked_for_createElement_This_only_applies_when_targeting_react_JSX_emit_6686", "Specify the object invoked for 'createElement'. This only applies when targeting 'react' JSX emit."),
	        Specify_an_array_of_objects_that_specify_paths_for_projects_Used_in_project_references: diag(6687, 3 /* Message */, "Specify_an_array_of_objects_that_specify_paths_for_projects_Used_in_project_references_6687", "Specify an array of objects that specify paths for projects. Used in project references."),
	        Disable_emitting_comments: diag(6688, 3 /* Message */, "Disable_emitting_comments_6688", "Disable emitting comments."),
	        Enable_importing_json_files: diag(6689, 3 /* Message */, "Enable_importing_json_files_6689", "Enable importing .json files."),
	        Specify_the_root_folder_within_your_source_files: diag(6690, 3 /* Message */, "Specify_the_root_folder_within_your_source_files_6690", "Specify the root folder within your source files."),
	        Allow_multiple_folders_to_be_treated_as_one_when_resolving_modules: diag(6691, 3 /* Message */, "Allow_multiple_folders_to_be_treated_as_one_when_resolving_modules_6691", "Allow multiple folders to be treated as one when resolving modules."),
	        Skip_type_checking_d_ts_files_that_are_included_with_TypeScript: diag(6692, 3 /* Message */, "Skip_type_checking_d_ts_files_that_are_included_with_TypeScript_6692", "Skip type checking .d.ts files that are included with TypeScript."),
	        Skip_type_checking_all_d_ts_files: diag(6693, 3 /* Message */, "Skip_type_checking_all_d_ts_files_6693", "Skip type checking all .d.ts files."),
	        Create_source_map_files_for_emitted_JavaScript_files: diag(6694, 3 /* Message */, "Create_source_map_files_for_emitted_JavaScript_files_6694", "Create source map files for emitted JavaScript files."),
	        Specify_the_root_path_for_debuggers_to_find_the_reference_source_code: diag(6695, 3 /* Message */, "Specify_the_root_path_for_debuggers_to_find_the_reference_source_code_6695", "Specify the root path for debuggers to find the reference source code."),
	        Check_that_the_arguments_for_bind_call_and_apply_methods_match_the_original_function: diag(6697, 3 /* Message */, "Check_that_the_arguments_for_bind_call_and_apply_methods_match_the_original_function_6697", "Check that the arguments for 'bind', 'call', and 'apply' methods match the original function."),
	        When_assigning_functions_check_to_ensure_parameters_and_the_return_values_are_subtype_compatible: diag(6698, 3 /* Message */, "When_assigning_functions_check_to_ensure_parameters_and_the_return_values_are_subtype_compatible_6698", "When assigning functions, check to ensure parameters and the return values are subtype-compatible."),
	        When_type_checking_take_into_account_null_and_undefined: diag(6699, 3 /* Message */, "When_type_checking_take_into_account_null_and_undefined_6699", "When type checking, take into account 'null' and 'undefined'."),
	        Check_for_class_properties_that_are_declared_but_not_set_in_the_constructor: diag(6700, 3 /* Message */, "Check_for_class_properties_that_are_declared_but_not_set_in_the_constructor_6700", "Check for class properties that are declared but not set in the constructor."),
	        Disable_emitting_declarations_that_have_internal_in_their_JSDoc_comments: diag(6701, 3 /* Message */, "Disable_emitting_declarations_that_have_internal_in_their_JSDoc_comments_6701", "Disable emitting declarations that have '@internal' in their JSDoc comments."),
	        Disable_reporting_of_excess_property_errors_during_the_creation_of_object_literals: diag(6702, 3 /* Message */, "Disable_reporting_of_excess_property_errors_during_the_creation_of_object_literals_6702", "Disable reporting of excess property errors during the creation of object literals."),
	        Suppress_noImplicitAny_errors_when_indexing_objects_that_lack_index_signatures: diag(6703, 3 /* Message */, "Suppress_noImplicitAny_errors_when_indexing_objects_that_lack_index_signatures_6703", "Suppress 'noImplicitAny' errors when indexing objects that lack index signatures."),
	        Synchronously_call_callbacks_and_update_the_state_of_directory_watchers_on_platforms_that_don_t_support_recursive_watching_natively: diag(6704, 3 /* Message */, "Synchronously_call_callbacks_and_update_the_state_of_directory_watchers_on_platforms_that_don_t_supp_6704", "Synchronously call callbacks and update the state of directory watchers on platforms that don`t support recursive watching natively."),
	        Set_the_JavaScript_language_version_for_emitted_JavaScript_and_include_compatible_library_declarations: diag(6705, 3 /* Message */, "Set_the_JavaScript_language_version_for_emitted_JavaScript_and_include_compatible_library_declaratio_6705", "Set the JavaScript language version for emitted JavaScript and include compatible library declarations."),
	        Log_paths_used_during_the_moduleResolution_process: diag(6706, 3 /* Message */, "Log_paths_used_during_the_moduleResolution_process_6706", "Log paths used during the 'moduleResolution' process."),
	        Specify_the_path_to_tsbuildinfo_incremental_compilation_file: diag(6707, 3 /* Message */, "Specify_the_path_to_tsbuildinfo_incremental_compilation_file_6707", "Specify the path to .tsbuildinfo incremental compilation file."),
	        Specify_options_for_automatic_acquisition_of_declaration_files: diag(6709, 3 /* Message */, "Specify_options_for_automatic_acquisition_of_declaration_files_6709", "Specify options for automatic acquisition of declaration files."),
	        Specify_multiple_folders_that_act_like_Slashnode_modules_Slash_types: diag(6710, 3 /* Message */, "Specify_multiple_folders_that_act_like_Slashnode_modules_Slash_types_6710", "Specify multiple folders that act like './node_modules/@types'."),
	        Specify_type_package_names_to_be_included_without_being_referenced_in_a_source_file: diag(6711, 3 /* Message */, "Specify_type_package_names_to_be_included_without_being_referenced_in_a_source_file_6711", "Specify type package names to be included without being referenced in a source file."),
	        Emit_ECMAScript_standard_compliant_class_fields: diag(6712, 3 /* Message */, "Emit_ECMAScript_standard_compliant_class_fields_6712", "Emit ECMAScript-standard-compliant class fields."),
	        Enable_verbose_logging: diag(6713, 3 /* Message */, "Enable_verbose_logging_6713", "Enable verbose logging."),
	        Specify_how_directories_are_watched_on_systems_that_lack_recursive_file_watching_functionality: diag(6714, 3 /* Message */, "Specify_how_directories_are_watched_on_systems_that_lack_recursive_file_watching_functionality_6714", "Specify how directories are watched on systems that lack recursive file-watching functionality."),
	        Specify_how_the_TypeScript_watch_mode_works: diag(6715, 3 /* Message */, "Specify_how_the_TypeScript_watch_mode_works_6715", "Specify how the TypeScript watch mode works."),
	        Require_undeclared_properties_from_index_signatures_to_use_element_accesses: diag(6717, 3 /* Message */, "Require_undeclared_properties_from_index_signatures_to_use_element_accesses_6717", "Require undeclared properties from index signatures to use element accesses."),
	        Specify_emit_Slashchecking_behavior_for_imports_that_are_only_used_for_types: diag(6718, 3 /* Message */, "Specify_emit_Slashchecking_behavior_for_imports_that_are_only_used_for_types_6718", "Specify emit/checking behavior for imports that are only used for types."),
	        Default_catch_clause_variables_as_unknown_instead_of_any: diag(6803, 3 /* Message */, "Default_catch_clause_variables_as_unknown_instead_of_any_6803", "Default catch clause variables as 'unknown' instead of 'any'."),
	        Do_not_transform_or_elide_any_imports_or_exports_not_marked_as_type_only_ensuring_they_are_written_in_the_output_file_s_format_based_on_the_module_setting: diag(6804, 3 /* Message */, "Do_not_transform_or_elide_any_imports_or_exports_not_marked_as_type_only_ensuring_they_are_written_i_6804", "Do not transform or elide any imports or exports not marked as type-only, ensuring they are written in the output file's format based on the 'module' setting."),
	        one_of_Colon: diag(6900, 3 /* Message */, "one_of_Colon_6900", "one of:"),
	        one_or_more_Colon: diag(6901, 3 /* Message */, "one_or_more_Colon_6901", "one or more:"),
	        type_Colon: diag(6902, 3 /* Message */, "type_Colon_6902", "type:"),
	        default_Colon: diag(6903, 3 /* Message */, "default_Colon_6903", "default:"),
	        module_system_or_esModuleInterop: diag(6904, 3 /* Message */, "module_system_or_esModuleInterop_6904", 'module === "system" or esModuleInterop'),
	        false_unless_strict_is_set: diag(6905, 3 /* Message */, "false_unless_strict_is_set_6905", "`false`, unless `strict` is set"),
	        false_unless_composite_is_set: diag(6906, 3 /* Message */, "false_unless_composite_is_set_6906", "`false`, unless `composite` is set"),
	        node_modules_bower_components_jspm_packages_plus_the_value_of_outDir_if_one_is_specified: diag(6907, 3 /* Message */, "node_modules_bower_components_jspm_packages_plus_the_value_of_outDir_if_one_is_specified_6907", '`["node_modules", "bower_components", "jspm_packages"]`, plus the value of `outDir` if one is specified.'),
	        if_files_is_specified_otherwise_Asterisk_Asterisk_Slash_Asterisk: diag(6908, 3 /* Message */, "if_files_is_specified_otherwise_Asterisk_Asterisk_Slash_Asterisk_6908", '`[]` if `files` is specified, otherwise `["**/*"]`'),
	        true_if_composite_false_otherwise: diag(6909, 3 /* Message */, "true_if_composite_false_otherwise_6909", "`true` if `composite`, `false` otherwise"),
	        module_AMD_or_UMD_or_System_or_ES6_then_Classic_Otherwise_Node: diag(69010, 3 /* Message */, "module_AMD_or_UMD_or_System_or_ES6_then_Classic_Otherwise_Node_69010", "module === `AMD` or `UMD` or `System` or `ES6`, then `Classic`, Otherwise `Node`"),
	        Computed_from_the_list_of_input_files: diag(6911, 3 /* Message */, "Computed_from_the_list_of_input_files_6911", "Computed from the list of input files"),
	        Platform_specific: diag(6912, 3 /* Message */, "Platform_specific_6912", "Platform specific"),
	        You_can_learn_about_all_of_the_compiler_options_at_0: diag(6913, 3 /* Message */, "You_can_learn_about_all_of_the_compiler_options_at_0_6913", "You can learn about all of the compiler options at {0}"),
	        Including_watch_w_will_start_watching_the_current_project_for_the_file_changes_Once_set_you_can_config_watch_mode_with_Colon: diag(6914, 3 /* Message */, "Including_watch_w_will_start_watching_the_current_project_for_the_file_changes_Once_set_you_can_conf_6914", "Including --watch, -w will start watching the current project for the file changes. Once set, you can config watch mode with:"),
	        Using_build_b_will_make_tsc_behave_more_like_a_build_orchestrator_than_a_compiler_This_is_used_to_trigger_building_composite_projects_which_you_can_learn_more_about_at_0: diag(6915, 3 /* Message */, "Using_build_b_will_make_tsc_behave_more_like_a_build_orchestrator_than_a_compiler_This_is_used_to_tr_6915", "Using --build, -b will make tsc behave more like a build orchestrator than a compiler. This is used to trigger building composite projects which you can learn more about at {0}"),
	        COMMON_COMMANDS: diag(6916, 3 /* Message */, "COMMON_COMMANDS_6916", "COMMON COMMANDS"),
	        ALL_COMPILER_OPTIONS: diag(6917, 3 /* Message */, "ALL_COMPILER_OPTIONS_6917", "ALL COMPILER OPTIONS"),
	        WATCH_OPTIONS: diag(6918, 3 /* Message */, "WATCH_OPTIONS_6918", "WATCH OPTIONS"),
	        BUILD_OPTIONS: diag(6919, 3 /* Message */, "BUILD_OPTIONS_6919", "BUILD OPTIONS"),
	        COMMON_COMPILER_OPTIONS: diag(6920, 3 /* Message */, "COMMON_COMPILER_OPTIONS_6920", "COMMON COMPILER OPTIONS"),
	        COMMAND_LINE_FLAGS: diag(6921, 3 /* Message */, "COMMAND_LINE_FLAGS_6921", "COMMAND LINE FLAGS"),
	        tsc_Colon_The_TypeScript_Compiler: diag(6922, 3 /* Message */, "tsc_Colon_The_TypeScript_Compiler_6922", "tsc: The TypeScript Compiler"),
	        Compiles_the_current_project_tsconfig_json_in_the_working_directory: diag(6923, 3 /* Message */, "Compiles_the_current_project_tsconfig_json_in_the_working_directory_6923", "Compiles the current project (tsconfig.json in the working directory.)"),
	        Ignoring_tsconfig_json_compiles_the_specified_files_with_default_compiler_options: diag(6924, 3 /* Message */, "Ignoring_tsconfig_json_compiles_the_specified_files_with_default_compiler_options_6924", "Ignoring tsconfig.json, compiles the specified files with default compiler options."),
	        Build_a_composite_project_in_the_working_directory: diag(6925, 3 /* Message */, "Build_a_composite_project_in_the_working_directory_6925", "Build a composite project in the working directory."),
	        Creates_a_tsconfig_json_with_the_recommended_settings_in_the_working_directory: diag(6926, 3 /* Message */, "Creates_a_tsconfig_json_with_the_recommended_settings_in_the_working_directory_6926", "Creates a tsconfig.json with the recommended settings in the working directory."),
	        Compiles_the_TypeScript_project_located_at_the_specified_path: diag(6927, 3 /* Message */, "Compiles_the_TypeScript_project_located_at_the_specified_path_6927", "Compiles the TypeScript project located at the specified path."),
	        An_expanded_version_of_this_information_showing_all_possible_compiler_options: diag(6928, 3 /* Message */, "An_expanded_version_of_this_information_showing_all_possible_compiler_options_6928", "An expanded version of this information, showing all possible compiler options"),
	        Compiles_the_current_project_with_additional_settings: diag(6929, 3 /* Message */, "Compiles_the_current_project_with_additional_settings_6929", "Compiles the current project, with additional settings."),
	        true_for_ES2022_and_above_including_ESNext: diag(6930, 3 /* Message */, "true_for_ES2022_and_above_including_ESNext_6930", "`true` for ES2022 and above, including ESNext."),
	        List_of_file_name_suffixes_to_search_when_resolving_a_module: diag(6931, 1 /* Error */, "List_of_file_name_suffixes_to_search_when_resolving_a_module_6931", "List of file name suffixes to search when resolving a module."),
	        Variable_0_implicitly_has_an_1_type: diag(7005, 1 /* Error */, "Variable_0_implicitly_has_an_1_type_7005", "Variable '{0}' implicitly has an '{1}' type."),
	        Parameter_0_implicitly_has_an_1_type: diag(7006, 1 /* Error */, "Parameter_0_implicitly_has_an_1_type_7006", "Parameter '{0}' implicitly has an '{1}' type."),
	        Member_0_implicitly_has_an_1_type: diag(7008, 1 /* Error */, "Member_0_implicitly_has_an_1_type_7008", "Member '{0}' implicitly has an '{1}' type."),
	        new_expression_whose_target_lacks_a_construct_signature_implicitly_has_an_any_type: diag(7009, 1 /* Error */, "new_expression_whose_target_lacks_a_construct_signature_implicitly_has_an_any_type_7009", "'new' expression, whose target lacks a construct signature, implicitly has an 'any' type."),
	        _0_which_lacks_return_type_annotation_implicitly_has_an_1_return_type: diag(7010, 1 /* Error */, "_0_which_lacks_return_type_annotation_implicitly_has_an_1_return_type_7010", "'{0}', which lacks return-type annotation, implicitly has an '{1}' return type."),
	        Function_expression_which_lacks_return_type_annotation_implicitly_has_an_0_return_type: diag(7011, 1 /* Error */, "Function_expression_which_lacks_return_type_annotation_implicitly_has_an_0_return_type_7011", "Function expression, which lacks return-type annotation, implicitly has an '{0}' return type."),
	        This_overload_implicitly_returns_the_type_0_because_it_lacks_a_return_type_annotation: diag(7012, 1 /* Error */, "This_overload_implicitly_returns_the_type_0_because_it_lacks_a_return_type_annotation_7012", "This overload implicitly returns the type '{0}' because it lacks a return type annotation."),
	        Construct_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type: diag(7013, 1 /* Error */, "Construct_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type_7013", "Construct signature, which lacks return-type annotation, implicitly has an 'any' return type."),
	        Function_type_which_lacks_return_type_annotation_implicitly_has_an_0_return_type: diag(7014, 1 /* Error */, "Function_type_which_lacks_return_type_annotation_implicitly_has_an_0_return_type_7014", "Function type, which lacks return-type annotation, implicitly has an '{0}' return type."),
	        Element_implicitly_has_an_any_type_because_index_expression_is_not_of_type_number: diag(7015, 1 /* Error */, "Element_implicitly_has_an_any_type_because_index_expression_is_not_of_type_number_7015", "Element implicitly has an 'any' type because index expression is not of type 'number'."),
	        Could_not_find_a_declaration_file_for_module_0_1_implicitly_has_an_any_type: diag(7016, 1 /* Error */, "Could_not_find_a_declaration_file_for_module_0_1_implicitly_has_an_any_type_7016", "Could not find a declaration file for module '{0}'. '{1}' implicitly has an 'any' type."),
	        Element_implicitly_has_an_any_type_because_type_0_has_no_index_signature: diag(7017, 1 /* Error */, "Element_implicitly_has_an_any_type_because_type_0_has_no_index_signature_7017", "Element implicitly has an 'any' type because type '{0}' has no index signature."),
	        Object_literal_s_property_0_implicitly_has_an_1_type: diag(7018, 1 /* Error */, "Object_literal_s_property_0_implicitly_has_an_1_type_7018", "Object literal's property '{0}' implicitly has an '{1}' type."),
	        Rest_parameter_0_implicitly_has_an_any_type: diag(7019, 1 /* Error */, "Rest_parameter_0_implicitly_has_an_any_type_7019", "Rest parameter '{0}' implicitly has an 'any[]' type."),
	        Call_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type: diag(7020, 1 /* Error */, "Call_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type_7020", "Call signature, which lacks return-type annotation, implicitly has an 'any' return type."),
	        _0_implicitly_has_type_any_because_it_does_not_have_a_type_annotation_and_is_referenced_directly_or_indirectly_in_its_own_initializer: diag(7022, 1 /* Error */, "_0_implicitly_has_type_any_because_it_does_not_have_a_type_annotation_and_is_referenced_directly_or__7022", "'{0}' implicitly has type 'any' because it does not have a type annotation and is referenced directly or indirectly in its own initializer."),
	        _0_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_referenced_directly_or_indirectly_in_one_of_its_return_expressions: diag(7023, 1 /* Error */, "_0_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_reference_7023", "'{0}' implicitly has return type 'any' because it does not have a return type annotation and is referenced directly or indirectly in one of its return expressions."),
	        Function_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_referenced_directly_or_indirectly_in_one_of_its_return_expressions: diag(7024, 1 /* Error */, "Function_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_ref_7024", "Function implicitly has return type 'any' because it does not have a return type annotation and is referenced directly or indirectly in one of its return expressions."),
	        Generator_implicitly_has_yield_type_0_because_it_does_not_yield_any_values_Consider_supplying_a_return_type_annotation: diag(7025, 1 /* Error */, "Generator_implicitly_has_yield_type_0_because_it_does_not_yield_any_values_Consider_supplying_a_retu_7025", "Generator implicitly has yield type '{0}' because it does not yield any values. Consider supplying a return type annotation."),
	        JSX_element_implicitly_has_type_any_because_no_interface_JSX_0_exists: diag(7026, 1 /* Error */, "JSX_element_implicitly_has_type_any_because_no_interface_JSX_0_exists_7026", "JSX element implicitly has type 'any' because no interface 'JSX.{0}' exists."),
	        Unreachable_code_detected: diag(
	          7027,
	          1 /* Error */,
	          "Unreachable_code_detected_7027",
	          "Unreachable code detected.",
	          /*reportsUnnecessary*/
	          true
	        ),
	        Unused_label: diag(
	          7028,
	          1 /* Error */,
	          "Unused_label_7028",
	          "Unused label.",
	          /*reportsUnnecessary*/
	          true
	        ),
	        Fallthrough_case_in_switch: diag(7029, 1 /* Error */, "Fallthrough_case_in_switch_7029", "Fallthrough case in switch."),
	        Not_all_code_paths_return_a_value: diag(7030, 1 /* Error */, "Not_all_code_paths_return_a_value_7030", "Not all code paths return a value."),
	        Binding_element_0_implicitly_has_an_1_type: diag(7031, 1 /* Error */, "Binding_element_0_implicitly_has_an_1_type_7031", "Binding element '{0}' implicitly has an '{1}' type."),
	        Property_0_implicitly_has_type_any_because_its_set_accessor_lacks_a_parameter_type_annotation: diag(7032, 1 /* Error */, "Property_0_implicitly_has_type_any_because_its_set_accessor_lacks_a_parameter_type_annotation_7032", "Property '{0}' implicitly has type 'any', because its set accessor lacks a parameter type annotation."),
	        Property_0_implicitly_has_type_any_because_its_get_accessor_lacks_a_return_type_annotation: diag(7033, 1 /* Error */, "Property_0_implicitly_has_type_any_because_its_get_accessor_lacks_a_return_type_annotation_7033", "Property '{0}' implicitly has type 'any', because its get accessor lacks a return type annotation."),
	        Variable_0_implicitly_has_type_1_in_some_locations_where_its_type_cannot_be_determined: diag(7034, 1 /* Error */, "Variable_0_implicitly_has_type_1_in_some_locations_where_its_type_cannot_be_determined_7034", "Variable '{0}' implicitly has type '{1}' in some locations where its type cannot be determined."),
	        Try_npm_i_save_dev_types_Slash_1_if_it_exists_or_add_a_new_declaration_d_ts_file_containing_declare_module_0: diag(7035, 1 /* Error */, "Try_npm_i_save_dev_types_Slash_1_if_it_exists_or_add_a_new_declaration_d_ts_file_containing_declare__7035", "Try `npm i --save-dev @types/{1}` if it exists or add a new declaration (.d.ts) file containing `declare module '{0}';`"),
	        Dynamic_import_s_specifier_must_be_of_type_string_but_here_has_type_0: diag(7036, 1 /* Error */, "Dynamic_import_s_specifier_must_be_of_type_string_but_here_has_type_0_7036", "Dynamic import's specifier must be of type 'string', but here has type '{0}'."),
	        Enables_emit_interoperability_between_CommonJS_and_ES_Modules_via_creation_of_namespace_objects_for_all_imports_Implies_allowSyntheticDefaultImports: diag(7037, 3 /* Message */, "Enables_emit_interoperability_between_CommonJS_and_ES_Modules_via_creation_of_namespace_objects_for__7037", "Enables emit interoperability between CommonJS and ES Modules via creation of namespace objects for all imports. Implies 'allowSyntheticDefaultImports'."),
	        Type_originates_at_this_import_A_namespace_style_import_cannot_be_called_or_constructed_and_will_cause_a_failure_at_runtime_Consider_using_a_default_import_or_import_require_here_instead: diag(7038, 3 /* Message */, "Type_originates_at_this_import_A_namespace_style_import_cannot_be_called_or_constructed_and_will_cau_7038", "Type originates at this import. A namespace-style import cannot be called or constructed, and will cause a failure at runtime. Consider using a default import or import require here instead."),
	        Mapped_object_type_implicitly_has_an_any_template_type: diag(7039, 1 /* Error */, "Mapped_object_type_implicitly_has_an_any_template_type_7039", "Mapped object type implicitly has an 'any' template type."),
	        If_the_0_package_actually_exposes_this_module_consider_sending_a_pull_request_to_amend_https_Colon_Slash_Slashgithub_com_SlashDefinitelyTyped_SlashDefinitelyTyped_Slashtree_Slashmaster_Slashtypes_Slash_1: diag(7040, 1 /* Error */, "If_the_0_package_actually_exposes_this_module_consider_sending_a_pull_request_to_amend_https_Colon_S_7040", "If the '{0}' package actually exposes this module, consider sending a pull request to amend 'https://github.com/DefinitelyTyped/DefinitelyTyped/tree/master/types/{1}'"),
	        The_containing_arrow_function_captures_the_global_value_of_this: diag(7041, 1 /* Error */, "The_containing_arrow_function_captures_the_global_value_of_this_7041", "The containing arrow function captures the global value of 'this'."),
	        Module_0_was_resolved_to_1_but_resolveJsonModule_is_not_used: diag(7042, 1 /* Error */, "Module_0_was_resolved_to_1_but_resolveJsonModule_is_not_used_7042", "Module '{0}' was resolved to '{1}', but '--resolveJsonModule' is not used."),
	        Variable_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage: diag(7043, 2 /* Suggestion */, "Variable_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage_7043", "Variable '{0}' implicitly has an '{1}' type, but a better type may be inferred from usage."),
	        Parameter_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage: diag(7044, 2 /* Suggestion */, "Parameter_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage_7044", "Parameter '{0}' implicitly has an '{1}' type, but a better type may be inferred from usage."),
	        Member_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage: diag(7045, 2 /* Suggestion */, "Member_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage_7045", "Member '{0}' implicitly has an '{1}' type, but a better type may be inferred from usage."),
	        Variable_0_implicitly_has_type_1_in_some_locations_but_a_better_type_may_be_inferred_from_usage: diag(7046, 2 /* Suggestion */, "Variable_0_implicitly_has_type_1_in_some_locations_but_a_better_type_may_be_inferred_from_usage_7046", "Variable '{0}' implicitly has type '{1}' in some locations, but a better type may be inferred from usage."),
	        Rest_parameter_0_implicitly_has_an_any_type_but_a_better_type_may_be_inferred_from_usage: diag(7047, 2 /* Suggestion */, "Rest_parameter_0_implicitly_has_an_any_type_but_a_better_type_may_be_inferred_from_usage_7047", "Rest parameter '{0}' implicitly has an 'any[]' type, but a better type may be inferred from usage."),
	        Property_0_implicitly_has_type_any_but_a_better_type_for_its_get_accessor_may_be_inferred_from_usage: diag(7048, 2 /* Suggestion */, "Property_0_implicitly_has_type_any_but_a_better_type_for_its_get_accessor_may_be_inferred_from_usage_7048", "Property '{0}' implicitly has type 'any', but a better type for its get accessor may be inferred from usage."),
	        Property_0_implicitly_has_type_any_but_a_better_type_for_its_set_accessor_may_be_inferred_from_usage: diag(7049, 2 /* Suggestion */, "Property_0_implicitly_has_type_any_but_a_better_type_for_its_set_accessor_may_be_inferred_from_usage_7049", "Property '{0}' implicitly has type 'any', but a better type for its set accessor may be inferred from usage."),
	        _0_implicitly_has_an_1_return_type_but_a_better_type_may_be_inferred_from_usage: diag(7050, 2 /* Suggestion */, "_0_implicitly_has_an_1_return_type_but_a_better_type_may_be_inferred_from_usage_7050", "'{0}' implicitly has an '{1}' return type, but a better type may be inferred from usage."),
	        Parameter_has_a_name_but_no_type_Did_you_mean_0_Colon_1: diag(7051, 1 /* Error */, "Parameter_has_a_name_but_no_type_Did_you_mean_0_Colon_1_7051", "Parameter has a name but no type. Did you mean '{0}: {1}'?"),
	        Element_implicitly_has_an_any_type_because_type_0_has_no_index_signature_Did_you_mean_to_call_1: diag(7052, 1 /* Error */, "Element_implicitly_has_an_any_type_because_type_0_has_no_index_signature_Did_you_mean_to_call_1_7052", "Element implicitly has an 'any' type because type '{0}' has no index signature. Did you mean to call '{1}'?"),
	        Element_implicitly_has_an_any_type_because_expression_of_type_0_can_t_be_used_to_index_type_1: diag(7053, 1 /* Error */, "Element_implicitly_has_an_any_type_because_expression_of_type_0_can_t_be_used_to_index_type_1_7053", "Element implicitly has an 'any' type because expression of type '{0}' can't be used to index type '{1}'."),
	        No_index_signature_with_a_parameter_of_type_0_was_found_on_type_1: diag(7054, 1 /* Error */, "No_index_signature_with_a_parameter_of_type_0_was_found_on_type_1_7054", "No index signature with a parameter of type '{0}' was found on type '{1}'."),
	        _0_which_lacks_return_type_annotation_implicitly_has_an_1_yield_type: diag(7055, 1 /* Error */, "_0_which_lacks_return_type_annotation_implicitly_has_an_1_yield_type_7055", "'{0}', which lacks return-type annotation, implicitly has an '{1}' yield type."),
	        The_inferred_type_of_this_node_exceeds_the_maximum_length_the_compiler_will_serialize_An_explicit_type_annotation_is_needed: diag(7056, 1 /* Error */, "The_inferred_type_of_this_node_exceeds_the_maximum_length_the_compiler_will_serialize_An_explicit_ty_7056", "The inferred type of this node exceeds the maximum length the compiler will serialize. An explicit type annotation is needed."),
	        yield_expression_implicitly_results_in_an_any_type_because_its_containing_generator_lacks_a_return_type_annotation: diag(7057, 1 /* Error */, "yield_expression_implicitly_results_in_an_any_type_because_its_containing_generator_lacks_a_return_t_7057", "'yield' expression implicitly results in an 'any' type because its containing generator lacks a return-type annotation."),
	        If_the_0_package_actually_exposes_this_module_try_adding_a_new_declaration_d_ts_file_containing_declare_module_1: diag(7058, 1 /* Error */, "If_the_0_package_actually_exposes_this_module_try_adding_a_new_declaration_d_ts_file_containing_decl_7058", "If the '{0}' package actually exposes this module, try adding a new declaration (.d.ts) file containing `declare module '{1}';`"),
	        This_syntax_is_reserved_in_files_with_the_mts_or_cts_extension_Use_an_as_expression_instead: diag(7059, 1 /* Error */, "This_syntax_is_reserved_in_files_with_the_mts_or_cts_extension_Use_an_as_expression_instead_7059", "This syntax is reserved in files with the .mts or .cts extension. Use an `as` expression instead."),
	        This_syntax_is_reserved_in_files_with_the_mts_or_cts_extension_Add_a_trailing_comma_or_explicit_constraint: diag(7060, 1 /* Error */, "This_syntax_is_reserved_in_files_with_the_mts_or_cts_extension_Add_a_trailing_comma_or_explicit_cons_7060", "This syntax is reserved in files with the .mts or .cts extension. Add a trailing comma or explicit constraint."),
	        A_mapped_type_may_not_declare_properties_or_methods: diag(7061, 1 /* Error */, "A_mapped_type_may_not_declare_properties_or_methods_7061", "A mapped type may not declare properties or methods."),
	        You_cannot_rename_this_element: diag(8e3, 1 /* Error */, "You_cannot_rename_this_element_8000", "You cannot rename this element."),
	        You_cannot_rename_elements_that_are_defined_in_the_standard_TypeScript_library: diag(8001, 1 /* Error */, "You_cannot_rename_elements_that_are_defined_in_the_standard_TypeScript_library_8001", "You cannot rename elements that are defined in the standard TypeScript library."),
	        import_can_only_be_used_in_TypeScript_files: diag(8002, 1 /* Error */, "import_can_only_be_used_in_TypeScript_files_8002", "'import ... =' can only be used in TypeScript files."),
	        export_can_only_be_used_in_TypeScript_files: diag(8003, 1 /* Error */, "export_can_only_be_used_in_TypeScript_files_8003", "'export =' can only be used in TypeScript files."),
	        Type_parameter_declarations_can_only_be_used_in_TypeScript_files: diag(8004, 1 /* Error */, "Type_parameter_declarations_can_only_be_used_in_TypeScript_files_8004", "Type parameter declarations can only be used in TypeScript files."),
	        implements_clauses_can_only_be_used_in_TypeScript_files: diag(8005, 1 /* Error */, "implements_clauses_can_only_be_used_in_TypeScript_files_8005", "'implements' clauses can only be used in TypeScript files."),
	        _0_declarations_can_only_be_used_in_TypeScript_files: diag(8006, 1 /* Error */, "_0_declarations_can_only_be_used_in_TypeScript_files_8006", "'{0}' declarations can only be used in TypeScript files."),
	        Type_aliases_can_only_be_used_in_TypeScript_files: diag(8008, 1 /* Error */, "Type_aliases_can_only_be_used_in_TypeScript_files_8008", "Type aliases can only be used in TypeScript files."),
	        The_0_modifier_can_only_be_used_in_TypeScript_files: diag(8009, 1 /* Error */, "The_0_modifier_can_only_be_used_in_TypeScript_files_8009", "The '{0}' modifier can only be used in TypeScript files."),
	        Type_annotations_can_only_be_used_in_TypeScript_files: diag(8010, 1 /* Error */, "Type_annotations_can_only_be_used_in_TypeScript_files_8010", "Type annotations can only be used in TypeScript files."),
	        Type_arguments_can_only_be_used_in_TypeScript_files: diag(8011, 1 /* Error */, "Type_arguments_can_only_be_used_in_TypeScript_files_8011", "Type arguments can only be used in TypeScript files."),
	        Parameter_modifiers_can_only_be_used_in_TypeScript_files: diag(8012, 1 /* Error */, "Parameter_modifiers_can_only_be_used_in_TypeScript_files_8012", "Parameter modifiers can only be used in TypeScript files."),
	        Non_null_assertions_can_only_be_used_in_TypeScript_files: diag(8013, 1 /* Error */, "Non_null_assertions_can_only_be_used_in_TypeScript_files_8013", "Non-null assertions can only be used in TypeScript files."),
	        Type_assertion_expressions_can_only_be_used_in_TypeScript_files: diag(8016, 1 /* Error */, "Type_assertion_expressions_can_only_be_used_in_TypeScript_files_8016", "Type assertion expressions can only be used in TypeScript files."),
	        Signature_declarations_can_only_be_used_in_TypeScript_files: diag(8017, 1 /* Error */, "Signature_declarations_can_only_be_used_in_TypeScript_files_8017", "Signature declarations can only be used in TypeScript files."),
	        Report_errors_in_js_files: diag(8019, 3 /* Message */, "Report_errors_in_js_files_8019", "Report errors in .js files."),
	        JSDoc_types_can_only_be_used_inside_documentation_comments: diag(8020, 1 /* Error */, "JSDoc_types_can_only_be_used_inside_documentation_comments_8020", "JSDoc types can only be used inside documentation comments."),
	        JSDoc_typedef_tag_should_either_have_a_type_annotation_or_be_followed_by_property_or_member_tags: diag(8021, 1 /* Error */, "JSDoc_typedef_tag_should_either_have_a_type_annotation_or_be_followed_by_property_or_member_tags_8021", "JSDoc '@typedef' tag should either have a type annotation or be followed by '@property' or '@member' tags."),
	        JSDoc_0_is_not_attached_to_a_class: diag(8022, 1 /* Error */, "JSDoc_0_is_not_attached_to_a_class_8022", "JSDoc '@{0}' is not attached to a class."),
	        JSDoc_0_1_does_not_match_the_extends_2_clause: diag(8023, 1 /* Error */, "JSDoc_0_1_does_not_match_the_extends_2_clause_8023", "JSDoc '@{0} {1}' does not match the 'extends {2}' clause."),
	        JSDoc_param_tag_has_name_0_but_there_is_no_parameter_with_that_name: diag(8024, 1 /* Error */, "JSDoc_param_tag_has_name_0_but_there_is_no_parameter_with_that_name_8024", "JSDoc '@param' tag has name '{0}', but there is no parameter with that name."),
	        Class_declarations_cannot_have_more_than_one_augments_or_extends_tag: diag(8025, 1 /* Error */, "Class_declarations_cannot_have_more_than_one_augments_or_extends_tag_8025", "Class declarations cannot have more than one '@augments' or '@extends' tag."),
	        Expected_0_type_arguments_provide_these_with_an_extends_tag: diag(8026, 1 /* Error */, "Expected_0_type_arguments_provide_these_with_an_extends_tag_8026", "Expected {0} type arguments; provide these with an '@extends' tag."),
	        Expected_0_1_type_arguments_provide_these_with_an_extends_tag: diag(8027, 1 /* Error */, "Expected_0_1_type_arguments_provide_these_with_an_extends_tag_8027", "Expected {0}-{1} type arguments; provide these with an '@extends' tag."),
	        JSDoc_may_only_appear_in_the_last_parameter_of_a_signature: diag(8028, 1 /* Error */, "JSDoc_may_only_appear_in_the_last_parameter_of_a_signature_8028", "JSDoc '...' may only appear in the last parameter of a signature."),
	        JSDoc_param_tag_has_name_0_but_there_is_no_parameter_with_that_name_It_would_match_arguments_if_it_had_an_array_type: diag(8029, 1 /* Error */, "JSDoc_param_tag_has_name_0_but_there_is_no_parameter_with_that_name_It_would_match_arguments_if_it_h_8029", "JSDoc '@param' tag has name '{0}', but there is no parameter with that name. It would match 'arguments' if it had an array type."),
	        The_type_of_a_function_declaration_must_match_the_function_s_signature: diag(8030, 1 /* Error */, "The_type_of_a_function_declaration_must_match_the_function_s_signature_8030", "The type of a function declaration must match the function's signature."),
	        You_cannot_rename_a_module_via_a_global_import: diag(8031, 1 /* Error */, "You_cannot_rename_a_module_via_a_global_import_8031", "You cannot rename a module via a global import."),
	        Qualified_name_0_is_not_allowed_without_a_leading_param_object_1: diag(8032, 1 /* Error */, "Qualified_name_0_is_not_allowed_without_a_leading_param_object_1_8032", "Qualified name '{0}' is not allowed without a leading '@param {object} {1}'."),
	        A_JSDoc_typedef_comment_may_not_contain_multiple_type_tags: diag(8033, 1 /* Error */, "A_JSDoc_typedef_comment_may_not_contain_multiple_type_tags_8033", "A JSDoc '@typedef' comment may not contain multiple '@type' tags."),
	        The_tag_was_first_specified_here: diag(8034, 1 /* Error */, "The_tag_was_first_specified_here_8034", "The tag was first specified here."),
	        You_cannot_rename_elements_that_are_defined_in_a_node_modules_folder: diag(8035, 1 /* Error */, "You_cannot_rename_elements_that_are_defined_in_a_node_modules_folder_8035", "You cannot rename elements that are defined in a 'node_modules' folder."),
	        You_cannot_rename_elements_that_are_defined_in_another_node_modules_folder: diag(8036, 1 /* Error */, "You_cannot_rename_elements_that_are_defined_in_another_node_modules_folder_8036", "You cannot rename elements that are defined in another 'node_modules' folder."),
	        Type_satisfaction_expressions_can_only_be_used_in_TypeScript_files: diag(8037, 1 /* Error */, "Type_satisfaction_expressions_can_only_be_used_in_TypeScript_files_8037", "Type satisfaction expressions can only be used in TypeScript files."),
	        Decorators_may_not_appear_after_export_or_export_default_if_they_also_appear_before_export: diag(8038, 1 /* Error */, "Decorators_may_not_appear_after_export_or_export_default_if_they_also_appear_before_export_8038", "Decorators may not appear after 'export' or 'export default' if they also appear before 'export'."),
	        A_JSDoc_template_tag_may_not_follow_a_typedef_callback_or_overload_tag: diag(8039, 1 /* Error */, "A_JSDoc_template_tag_may_not_follow_a_typedef_callback_or_overload_tag_8039", "A JSDoc '@template' tag may not follow a '@typedef', '@callback', or '@overload' tag"),
	        Declaration_emit_for_this_file_requires_using_private_name_0_An_explicit_type_annotation_may_unblock_declaration_emit: diag(9005, 1 /* Error */, "Declaration_emit_for_this_file_requires_using_private_name_0_An_explicit_type_annotation_may_unblock_9005", "Declaration emit for this file requires using private name '{0}'. An explicit type annotation may unblock declaration emit."),
	        Declaration_emit_for_this_file_requires_using_private_name_0_from_module_1_An_explicit_type_annotation_may_unblock_declaration_emit: diag(9006, 1 /* Error */, "Declaration_emit_for_this_file_requires_using_private_name_0_from_module_1_An_explicit_type_annotati_9006", "Declaration emit for this file requires using private name '{0}' from module '{1}'. An explicit type annotation may unblock declaration emit."),
	        JSX_attributes_must_only_be_assigned_a_non_empty_expression: diag(17e3, 1 /* Error */, "JSX_attributes_must_only_be_assigned_a_non_empty_expression_17000", "JSX attributes must only be assigned a non-empty 'expression'."),
	        JSX_elements_cannot_have_multiple_attributes_with_the_same_name: diag(17001, 1 /* Error */, "JSX_elements_cannot_have_multiple_attributes_with_the_same_name_17001", "JSX elements cannot have multiple attributes with the same name."),
	        Expected_corresponding_JSX_closing_tag_for_0: diag(17002, 1 /* Error */, "Expected_corresponding_JSX_closing_tag_for_0_17002", "Expected corresponding JSX closing tag for '{0}'."),
	        Cannot_use_JSX_unless_the_jsx_flag_is_provided: diag(17004, 1 /* Error */, "Cannot_use_JSX_unless_the_jsx_flag_is_provided_17004", "Cannot use JSX unless the '--jsx' flag is provided."),
	        A_constructor_cannot_contain_a_super_call_when_its_class_extends_null: diag(17005, 1 /* Error */, "A_constructor_cannot_contain_a_super_call_when_its_class_extends_null_17005", "A constructor cannot contain a 'super' call when its class extends 'null'."),
	        An_unary_expression_with_the_0_operator_is_not_allowed_in_the_left_hand_side_of_an_exponentiation_expression_Consider_enclosing_the_expression_in_parentheses: diag(17006, 1 /* Error */, "An_unary_expression_with_the_0_operator_is_not_allowed_in_the_left_hand_side_of_an_exponentiation_ex_17006", "An unary expression with the '{0}' operator is not allowed in the left-hand side of an exponentiation expression. Consider enclosing the expression in parentheses."),
	        A_type_assertion_expression_is_not_allowed_in_the_left_hand_side_of_an_exponentiation_expression_Consider_enclosing_the_expression_in_parentheses: diag(17007, 1 /* Error */, "A_type_assertion_expression_is_not_allowed_in_the_left_hand_side_of_an_exponentiation_expression_Con_17007", "A type assertion expression is not allowed in the left-hand side of an exponentiation expression. Consider enclosing the expression in parentheses."),
	        JSX_element_0_has_no_corresponding_closing_tag: diag(17008, 1 /* Error */, "JSX_element_0_has_no_corresponding_closing_tag_17008", "JSX element '{0}' has no corresponding closing tag."),
	        super_must_be_called_before_accessing_this_in_the_constructor_of_a_derived_class: diag(17009, 1 /* Error */, "super_must_be_called_before_accessing_this_in_the_constructor_of_a_derived_class_17009", "'super' must be called before accessing 'this' in the constructor of a derived class."),
	        Unknown_type_acquisition_option_0: diag(17010, 1 /* Error */, "Unknown_type_acquisition_option_0_17010", "Unknown type acquisition option '{0}'."),
	        super_must_be_called_before_accessing_a_property_of_super_in_the_constructor_of_a_derived_class: diag(17011, 1 /* Error */, "super_must_be_called_before_accessing_a_property_of_super_in_the_constructor_of_a_derived_class_17011", "'super' must be called before accessing a property of 'super' in the constructor of a derived class."),
	        _0_is_not_a_valid_meta_property_for_keyword_1_Did_you_mean_2: diag(17012, 1 /* Error */, "_0_is_not_a_valid_meta_property_for_keyword_1_Did_you_mean_2_17012", "'{0}' is not a valid meta-property for keyword '{1}'. Did you mean '{2}'?"),
	        Meta_property_0_is_only_allowed_in_the_body_of_a_function_declaration_function_expression_or_constructor: diag(17013, 1 /* Error */, "Meta_property_0_is_only_allowed_in_the_body_of_a_function_declaration_function_expression_or_constru_17013", "Meta-property '{0}' is only allowed in the body of a function declaration, function expression, or constructor."),
	        JSX_fragment_has_no_corresponding_closing_tag: diag(17014, 1 /* Error */, "JSX_fragment_has_no_corresponding_closing_tag_17014", "JSX fragment has no corresponding closing tag."),
	        Expected_corresponding_closing_tag_for_JSX_fragment: diag(17015, 1 /* Error */, "Expected_corresponding_closing_tag_for_JSX_fragment_17015", "Expected corresponding closing tag for JSX fragment."),
	        The_jsxFragmentFactory_compiler_option_must_be_provided_to_use_JSX_fragments_with_the_jsxFactory_compiler_option: diag(17016, 1 /* Error */, "The_jsxFragmentFactory_compiler_option_must_be_provided_to_use_JSX_fragments_with_the_jsxFactory_com_17016", "The 'jsxFragmentFactory' compiler option must be provided to use JSX fragments with the 'jsxFactory' compiler option."),
	        An_jsxFrag_pragma_is_required_when_using_an_jsx_pragma_with_JSX_fragments: diag(17017, 1 /* Error */, "An_jsxFrag_pragma_is_required_when_using_an_jsx_pragma_with_JSX_fragments_17017", "An @jsxFrag pragma is required when using an @jsx pragma with JSX fragments."),
	        Unknown_type_acquisition_option_0_Did_you_mean_1: diag(17018, 1 /* Error */, "Unknown_type_acquisition_option_0_Did_you_mean_1_17018", "Unknown type acquisition option '{0}'. Did you mean '{1}'?"),
	        _0_at_the_end_of_a_type_is_not_valid_TypeScript_syntax_Did_you_mean_to_write_1: diag(17019, 1 /* Error */, "_0_at_the_end_of_a_type_is_not_valid_TypeScript_syntax_Did_you_mean_to_write_1_17019", "'{0}' at the end of a type is not valid TypeScript syntax. Did you mean to write '{1}'?"),
	        _0_at_the_start_of_a_type_is_not_valid_TypeScript_syntax_Did_you_mean_to_write_1: diag(17020, 1 /* Error */, "_0_at_the_start_of_a_type_is_not_valid_TypeScript_syntax_Did_you_mean_to_write_1_17020", "'{0}' at the start of a type is not valid TypeScript syntax. Did you mean to write '{1}'?"),
	        Unicode_escape_sequence_cannot_appear_here: diag(17021, 1 /* Error */, "Unicode_escape_sequence_cannot_appear_here_17021", "Unicode escape sequence cannot appear here."),
	        Circularity_detected_while_resolving_configuration_Colon_0: diag(18e3, 1 /* Error */, "Circularity_detected_while_resolving_configuration_Colon_0_18000", "Circularity detected while resolving configuration: {0}"),
	        The_files_list_in_config_file_0_is_empty: diag(18002, 1 /* Error */, "The_files_list_in_config_file_0_is_empty_18002", "The 'files' list in config file '{0}' is empty."),
	        No_inputs_were_found_in_config_file_0_Specified_include_paths_were_1_and_exclude_paths_were_2: diag(18003, 1 /* Error */, "No_inputs_were_found_in_config_file_0_Specified_include_paths_were_1_and_exclude_paths_were_2_18003", "No inputs were found in config file '{0}'. Specified 'include' paths were '{1}' and 'exclude' paths were '{2}'."),
	        File_is_a_CommonJS_module_it_may_be_converted_to_an_ES_module: diag(80001, 2 /* Suggestion */, "File_is_a_CommonJS_module_it_may_be_converted_to_an_ES_module_80001", "File is a CommonJS module; it may be converted to an ES module."),
	        This_constructor_function_may_be_converted_to_a_class_declaration: diag(80002, 2 /* Suggestion */, "This_constructor_function_may_be_converted_to_a_class_declaration_80002", "This constructor function may be converted to a class declaration."),
	        Import_may_be_converted_to_a_default_import: diag(80003, 2 /* Suggestion */, "Import_may_be_converted_to_a_default_import_80003", "Import may be converted to a default import."),
	        JSDoc_types_may_be_moved_to_TypeScript_types: diag(80004, 2 /* Suggestion */, "JSDoc_types_may_be_moved_to_TypeScript_types_80004", "JSDoc types may be moved to TypeScript types."),
	        require_call_may_be_converted_to_an_import: diag(80005, 2 /* Suggestion */, "require_call_may_be_converted_to_an_import_80005", "'require' call may be converted to an import."),
	        This_may_be_converted_to_an_async_function: diag(80006, 2 /* Suggestion */, "This_may_be_converted_to_an_async_function_80006", "This may be converted to an async function."),
	        await_has_no_effect_on_the_type_of_this_expression: diag(80007, 2 /* Suggestion */, "await_has_no_effect_on_the_type_of_this_expression_80007", "'await' has no effect on the type of this expression."),
	        Numeric_literals_with_absolute_values_equal_to_2_53_or_greater_are_too_large_to_be_represented_accurately_as_integers: diag(80008, 2 /* Suggestion */, "Numeric_literals_with_absolute_values_equal_to_2_53_or_greater_are_too_large_to_be_represented_accur_80008", "Numeric literals with absolute values equal to 2^53 or greater are too large to be represented accurately as integers."),
	        JSDoc_typedef_may_be_converted_to_TypeScript_type: diag(80009, 2 /* Suggestion */, "JSDoc_typedef_may_be_converted_to_TypeScript_type_80009", "JSDoc typedef may be converted to TypeScript type."),
	        JSDoc_typedefs_may_be_converted_to_TypeScript_types: diag(80010, 2 /* Suggestion */, "JSDoc_typedefs_may_be_converted_to_TypeScript_types_80010", "JSDoc typedefs may be converted to TypeScript types."),
	        Add_missing_super_call: diag(90001, 3 /* Message */, "Add_missing_super_call_90001", "Add missing 'super()' call"),
	        Make_super_call_the_first_statement_in_the_constructor: diag(90002, 3 /* Message */, "Make_super_call_the_first_statement_in_the_constructor_90002", "Make 'super()' call the first statement in the constructor"),
	        Change_extends_to_implements: diag(90003, 3 /* Message */, "Change_extends_to_implements_90003", "Change 'extends' to 'implements'"),
	        Remove_unused_declaration_for_Colon_0: diag(90004, 3 /* Message */, "Remove_unused_declaration_for_Colon_0_90004", "Remove unused declaration for: '{0}'"),
	        Remove_import_from_0: diag(90005, 3 /* Message */, "Remove_import_from_0_90005", "Remove import from '{0}'"),
	        Implement_interface_0: diag(90006, 3 /* Message */, "Implement_interface_0_90006", "Implement interface '{0}'"),
	        Implement_inherited_abstract_class: diag(90007, 3 /* Message */, "Implement_inherited_abstract_class_90007", "Implement inherited abstract class"),
	        Add_0_to_unresolved_variable: diag(90008, 3 /* Message */, "Add_0_to_unresolved_variable_90008", "Add '{0}.' to unresolved variable"),
	        Remove_variable_statement: diag(90010, 3 /* Message */, "Remove_variable_statement_90010", "Remove variable statement"),
	        Remove_template_tag: diag(90011, 3 /* Message */, "Remove_template_tag_90011", "Remove template tag"),
	        Remove_type_parameters: diag(90012, 3 /* Message */, "Remove_type_parameters_90012", "Remove type parameters"),
	        Import_0_from_1: diag(90013, 3 /* Message */, "Import_0_from_1_90013", `Import '{0}' from "{1}"`),
	        Change_0_to_1: diag(90014, 3 /* Message */, "Change_0_to_1_90014", "Change '{0}' to '{1}'"),
	        Declare_property_0: diag(90016, 3 /* Message */, "Declare_property_0_90016", "Declare property '{0}'"),
	        Add_index_signature_for_property_0: diag(90017, 3 /* Message */, "Add_index_signature_for_property_0_90017", "Add index signature for property '{0}'"),
	        Disable_checking_for_this_file: diag(90018, 3 /* Message */, "Disable_checking_for_this_file_90018", "Disable checking for this file"),
	        Ignore_this_error_message: diag(90019, 3 /* Message */, "Ignore_this_error_message_90019", "Ignore this error message"),
	        Initialize_property_0_in_the_constructor: diag(90020, 3 /* Message */, "Initialize_property_0_in_the_constructor_90020", "Initialize property '{0}' in the constructor"),
	        Initialize_static_property_0: diag(90021, 3 /* Message */, "Initialize_static_property_0_90021", "Initialize static property '{0}'"),
	        Change_spelling_to_0: diag(90022, 3 /* Message */, "Change_spelling_to_0_90022", "Change spelling to '{0}'"),
	        Declare_method_0: diag(90023, 3 /* Message */, "Declare_method_0_90023", "Declare method '{0}'"),
	        Declare_static_method_0: diag(90024, 3 /* Message */, "Declare_static_method_0_90024", "Declare static method '{0}'"),
	        Prefix_0_with_an_underscore: diag(90025, 3 /* Message */, "Prefix_0_with_an_underscore_90025", "Prefix '{0}' with an underscore"),
	        Rewrite_as_the_indexed_access_type_0: diag(90026, 3 /* Message */, "Rewrite_as_the_indexed_access_type_0_90026", "Rewrite as the indexed access type '{0}'"),
	        Declare_static_property_0: diag(90027, 3 /* Message */, "Declare_static_property_0_90027", "Declare static property '{0}'"),
	        Call_decorator_expression: diag(90028, 3 /* Message */, "Call_decorator_expression_90028", "Call decorator expression"),
	        Add_async_modifier_to_containing_function: diag(90029, 3 /* Message */, "Add_async_modifier_to_containing_function_90029", "Add async modifier to containing function"),
	        Replace_infer_0_with_unknown: diag(90030, 3 /* Message */, "Replace_infer_0_with_unknown_90030", "Replace 'infer {0}' with 'unknown'"),
	        Replace_all_unused_infer_with_unknown: diag(90031, 3 /* Message */, "Replace_all_unused_infer_with_unknown_90031", "Replace all unused 'infer' with 'unknown'"),
	        Add_parameter_name: diag(90034, 3 /* Message */, "Add_parameter_name_90034", "Add parameter name"),
	        Declare_private_property_0: diag(90035, 3 /* Message */, "Declare_private_property_0_90035", "Declare private property '{0}'"),
	        Replace_0_with_Promise_1: diag(90036, 3 /* Message */, "Replace_0_with_Promise_1_90036", "Replace '{0}' with 'Promise<{1}>'"),
	        Fix_all_incorrect_return_type_of_an_async_functions: diag(90037, 3 /* Message */, "Fix_all_incorrect_return_type_of_an_async_functions_90037", "Fix all incorrect return type of an async functions"),
	        Declare_private_method_0: diag(90038, 3 /* Message */, "Declare_private_method_0_90038", "Declare private method '{0}'"),
	        Remove_unused_destructuring_declaration: diag(90039, 3 /* Message */, "Remove_unused_destructuring_declaration_90039", "Remove unused destructuring declaration"),
	        Remove_unused_declarations_for_Colon_0: diag(90041, 3 /* Message */, "Remove_unused_declarations_for_Colon_0_90041", "Remove unused declarations for: '{0}'"),
	        Declare_a_private_field_named_0: diag(90053, 3 /* Message */, "Declare_a_private_field_named_0_90053", "Declare a private field named '{0}'."),
	        Includes_imports_of_types_referenced_by_0: diag(90054, 3 /* Message */, "Includes_imports_of_types_referenced_by_0_90054", "Includes imports of types referenced by '{0}'"),
	        Remove_type_from_import_declaration_from_0: diag(90055, 3 /* Message */, "Remove_type_from_import_declaration_from_0_90055", `Remove 'type' from import declaration from "{0}"`),
	        Remove_type_from_import_of_0_from_1: diag(90056, 3 /* Message */, "Remove_type_from_import_of_0_from_1_90056", `Remove 'type' from import of '{0}' from "{1}"`),
	        Add_import_from_0: diag(90057, 3 /* Message */, "Add_import_from_0_90057", 'Add import from "{0}"'),
	        Update_import_from_0: diag(90058, 3 /* Message */, "Update_import_from_0_90058", 'Update import from "{0}"'),
	        Export_0_from_module_1: diag(90059, 3 /* Message */, "Export_0_from_module_1_90059", "Export '{0}' from module '{1}'"),
	        Export_all_referenced_locals: diag(90060, 3 /* Message */, "Export_all_referenced_locals_90060", "Export all referenced locals"),
	        Convert_function_to_an_ES2015_class: diag(95001, 3 /* Message */, "Convert_function_to_an_ES2015_class_95001", "Convert function to an ES2015 class"),
	        Convert_0_to_1_in_0: diag(95003, 3 /* Message */, "Convert_0_to_1_in_0_95003", "Convert '{0}' to '{1} in {0}'"),
	        Extract_to_0_in_1: diag(95004, 3 /* Message */, "Extract_to_0_in_1_95004", "Extract to {0} in {1}"),
	        Extract_function: diag(95005, 3 /* Message */, "Extract_function_95005", "Extract function"),
	        Extract_constant: diag(95006, 3 /* Message */, "Extract_constant_95006", "Extract constant"),
	        Extract_to_0_in_enclosing_scope: diag(95007, 3 /* Message */, "Extract_to_0_in_enclosing_scope_95007", "Extract to {0} in enclosing scope"),
	        Extract_to_0_in_1_scope: diag(95008, 3 /* Message */, "Extract_to_0_in_1_scope_95008", "Extract to {0} in {1} scope"),
	        Annotate_with_type_from_JSDoc: diag(95009, 3 /* Message */, "Annotate_with_type_from_JSDoc_95009", "Annotate with type from JSDoc"),
	        Infer_type_of_0_from_usage: diag(95011, 3 /* Message */, "Infer_type_of_0_from_usage_95011", "Infer type of '{0}' from usage"),
	        Infer_parameter_types_from_usage: diag(95012, 3 /* Message */, "Infer_parameter_types_from_usage_95012", "Infer parameter types from usage"),
	        Convert_to_default_import: diag(95013, 3 /* Message */, "Convert_to_default_import_95013", "Convert to default import"),
	        Install_0: diag(95014, 3 /* Message */, "Install_0_95014", "Install '{0}'"),
	        Replace_import_with_0: diag(95015, 3 /* Message */, "Replace_import_with_0_95015", "Replace import with '{0}'."),
	        Use_synthetic_default_member: diag(95016, 3 /* Message */, "Use_synthetic_default_member_95016", "Use synthetic 'default' member."),
	        Convert_to_ES_module: diag(95017, 3 /* Message */, "Convert_to_ES_module_95017", "Convert to ES module"),
	        Add_undefined_type_to_property_0: diag(95018, 3 /* Message */, "Add_undefined_type_to_property_0_95018", "Add 'undefined' type to property '{0}'"),
	        Add_initializer_to_property_0: diag(95019, 3 /* Message */, "Add_initializer_to_property_0_95019", "Add initializer to property '{0}'"),
	        Add_definite_assignment_assertion_to_property_0: diag(95020, 3 /* Message */, "Add_definite_assignment_assertion_to_property_0_95020", "Add definite assignment assertion to property '{0}'"),
	        Convert_all_type_literals_to_mapped_type: diag(95021, 3 /* Message */, "Convert_all_type_literals_to_mapped_type_95021", "Convert all type literals to mapped type"),
	        Add_all_missing_members: diag(95022, 3 /* Message */, "Add_all_missing_members_95022", "Add all missing members"),
	        Infer_all_types_from_usage: diag(95023, 3 /* Message */, "Infer_all_types_from_usage_95023", "Infer all types from usage"),
	        Delete_all_unused_declarations: diag(95024, 3 /* Message */, "Delete_all_unused_declarations_95024", "Delete all unused declarations"),
	        Prefix_all_unused_declarations_with_where_possible: diag(95025, 3 /* Message */, "Prefix_all_unused_declarations_with_where_possible_95025", "Prefix all unused declarations with '_' where possible"),
	        Fix_all_detected_spelling_errors: diag(95026, 3 /* Message */, "Fix_all_detected_spelling_errors_95026", "Fix all detected spelling errors"),
	        Add_initializers_to_all_uninitialized_properties: diag(95027, 3 /* Message */, "Add_initializers_to_all_uninitialized_properties_95027", "Add initializers to all uninitialized properties"),
	        Add_definite_assignment_assertions_to_all_uninitialized_properties: diag(95028, 3 /* Message */, "Add_definite_assignment_assertions_to_all_uninitialized_properties_95028", "Add definite assignment assertions to all uninitialized properties"),
	        Add_undefined_type_to_all_uninitialized_properties: diag(95029, 3 /* Message */, "Add_undefined_type_to_all_uninitialized_properties_95029", "Add undefined type to all uninitialized properties"),
	        Change_all_jsdoc_style_types_to_TypeScript: diag(95030, 3 /* Message */, "Change_all_jsdoc_style_types_to_TypeScript_95030", "Change all jsdoc-style types to TypeScript"),
	        Change_all_jsdoc_style_types_to_TypeScript_and_add_undefined_to_nullable_types: diag(95031, 3 /* Message */, "Change_all_jsdoc_style_types_to_TypeScript_and_add_undefined_to_nullable_types_95031", "Change all jsdoc-style types to TypeScript (and add '| undefined' to nullable types)"),
	        Implement_all_unimplemented_interfaces: diag(95032, 3 /* Message */, "Implement_all_unimplemented_interfaces_95032", "Implement all unimplemented interfaces"),
	        Install_all_missing_types_packages: diag(95033, 3 /* Message */, "Install_all_missing_types_packages_95033", "Install all missing types packages"),
	        Rewrite_all_as_indexed_access_types: diag(95034, 3 /* Message */, "Rewrite_all_as_indexed_access_types_95034", "Rewrite all as indexed access types"),
	        Convert_all_to_default_imports: diag(95035, 3 /* Message */, "Convert_all_to_default_imports_95035", "Convert all to default imports"),
	        Make_all_super_calls_the_first_statement_in_their_constructor: diag(95036, 3 /* Message */, "Make_all_super_calls_the_first_statement_in_their_constructor_95036", "Make all 'super()' calls the first statement in their constructor"),
	        Add_qualifier_to_all_unresolved_variables_matching_a_member_name: diag(95037, 3 /* Message */, "Add_qualifier_to_all_unresolved_variables_matching_a_member_name_95037", "Add qualifier to all unresolved variables matching a member name"),
	        Change_all_extended_interfaces_to_implements: diag(95038, 3 /* Message */, "Change_all_extended_interfaces_to_implements_95038", "Change all extended interfaces to 'implements'"),
	        Add_all_missing_super_calls: diag(95039, 3 /* Message */, "Add_all_missing_super_calls_95039", "Add all missing super calls"),
	        Implement_all_inherited_abstract_classes: diag(95040, 3 /* Message */, "Implement_all_inherited_abstract_classes_95040", "Implement all inherited abstract classes"),
	        Add_all_missing_async_modifiers: diag(95041, 3 /* Message */, "Add_all_missing_async_modifiers_95041", "Add all missing 'async' modifiers"),
	        Add_ts_ignore_to_all_error_messages: diag(95042, 3 /* Message */, "Add_ts_ignore_to_all_error_messages_95042", "Add '@ts-ignore' to all error messages"),
	        Annotate_everything_with_types_from_JSDoc: diag(95043, 3 /* Message */, "Annotate_everything_with_types_from_JSDoc_95043", "Annotate everything with types from JSDoc"),
	        Add_to_all_uncalled_decorators: diag(95044, 3 /* Message */, "Add_to_all_uncalled_decorators_95044", "Add '()' to all uncalled decorators"),
	        Convert_all_constructor_functions_to_classes: diag(95045, 3 /* Message */, "Convert_all_constructor_functions_to_classes_95045", "Convert all constructor functions to classes"),
	        Generate_get_and_set_accessors: diag(95046, 3 /* Message */, "Generate_get_and_set_accessors_95046", "Generate 'get' and 'set' accessors"),
	        Convert_require_to_import: diag(95047, 3 /* Message */, "Convert_require_to_import_95047", "Convert 'require' to 'import'"),
	        Convert_all_require_to_import: diag(95048, 3 /* Message */, "Convert_all_require_to_import_95048", "Convert all 'require' to 'import'"),
	        Move_to_a_new_file: diag(95049, 3 /* Message */, "Move_to_a_new_file_95049", "Move to a new file"),
	        Remove_unreachable_code: diag(95050, 3 /* Message */, "Remove_unreachable_code_95050", "Remove unreachable code"),
	        Remove_all_unreachable_code: diag(95051, 3 /* Message */, "Remove_all_unreachable_code_95051", "Remove all unreachable code"),
	        Add_missing_typeof: diag(95052, 3 /* Message */, "Add_missing_typeof_95052", "Add missing 'typeof'"),
	        Remove_unused_label: diag(95053, 3 /* Message */, "Remove_unused_label_95053", "Remove unused label"),
	        Remove_all_unused_labels: diag(95054, 3 /* Message */, "Remove_all_unused_labels_95054", "Remove all unused labels"),
	        Convert_0_to_mapped_object_type: diag(95055, 3 /* Message */, "Convert_0_to_mapped_object_type_95055", "Convert '{0}' to mapped object type"),
	        Convert_namespace_import_to_named_imports: diag(95056, 3 /* Message */, "Convert_namespace_import_to_named_imports_95056", "Convert namespace import to named imports"),
	        Convert_named_imports_to_namespace_import: diag(95057, 3 /* Message */, "Convert_named_imports_to_namespace_import_95057", "Convert named imports to namespace import"),
	        Add_or_remove_braces_in_an_arrow_function: diag(95058, 3 /* Message */, "Add_or_remove_braces_in_an_arrow_function_95058", "Add or remove braces in an arrow function"),
	        Add_braces_to_arrow_function: diag(95059, 3 /* Message */, "Add_braces_to_arrow_function_95059", "Add braces to arrow function"),
	        Remove_braces_from_arrow_function: diag(95060, 3 /* Message */, "Remove_braces_from_arrow_function_95060", "Remove braces from arrow function"),
	        Convert_default_export_to_named_export: diag(95061, 3 /* Message */, "Convert_default_export_to_named_export_95061", "Convert default export to named export"),
	        Convert_named_export_to_default_export: diag(95062, 3 /* Message */, "Convert_named_export_to_default_export_95062", "Convert named export to default export"),
	        Add_missing_enum_member_0: diag(95063, 3 /* Message */, "Add_missing_enum_member_0_95063", "Add missing enum member '{0}'"),
	        Add_all_missing_imports: diag(95064, 3 /* Message */, "Add_all_missing_imports_95064", "Add all missing imports"),
	        Convert_to_async_function: diag(95065, 3 /* Message */, "Convert_to_async_function_95065", "Convert to async function"),
	        Convert_all_to_async_functions: diag(95066, 3 /* Message */, "Convert_all_to_async_functions_95066", "Convert all to async functions"),
	        Add_missing_call_parentheses: diag(95067, 3 /* Message */, "Add_missing_call_parentheses_95067", "Add missing call parentheses"),
	        Add_all_missing_call_parentheses: diag(95068, 3 /* Message */, "Add_all_missing_call_parentheses_95068", "Add all missing call parentheses"),
	        Add_unknown_conversion_for_non_overlapping_types: diag(95069, 3 /* Message */, "Add_unknown_conversion_for_non_overlapping_types_95069", "Add 'unknown' conversion for non-overlapping types"),
	        Add_unknown_to_all_conversions_of_non_overlapping_types: diag(95070, 3 /* Message */, "Add_unknown_to_all_conversions_of_non_overlapping_types_95070", "Add 'unknown' to all conversions of non-overlapping types"),
	        Add_missing_new_operator_to_call: diag(95071, 3 /* Message */, "Add_missing_new_operator_to_call_95071", "Add missing 'new' operator to call"),
	        Add_missing_new_operator_to_all_calls: diag(95072, 3 /* Message */, "Add_missing_new_operator_to_all_calls_95072", "Add missing 'new' operator to all calls"),
	        Add_names_to_all_parameters_without_names: diag(95073, 3 /* Message */, "Add_names_to_all_parameters_without_names_95073", "Add names to all parameters without names"),
	        Enable_the_experimentalDecorators_option_in_your_configuration_file: diag(95074, 3 /* Message */, "Enable_the_experimentalDecorators_option_in_your_configuration_file_95074", "Enable the 'experimentalDecorators' option in your configuration file"),
	        Convert_parameters_to_destructured_object: diag(95075, 3 /* Message */, "Convert_parameters_to_destructured_object_95075", "Convert parameters to destructured object"),
	        Extract_type: diag(95077, 3 /* Message */, "Extract_type_95077", "Extract type"),
	        Extract_to_type_alias: diag(95078, 3 /* Message */, "Extract_to_type_alias_95078", "Extract to type alias"),
	        Extract_to_typedef: diag(95079, 3 /* Message */, "Extract_to_typedef_95079", "Extract to typedef"),
	        Infer_this_type_of_0_from_usage: diag(95080, 3 /* Message */, "Infer_this_type_of_0_from_usage_95080", "Infer 'this' type of '{0}' from usage"),
	        Add_const_to_unresolved_variable: diag(95081, 3 /* Message */, "Add_const_to_unresolved_variable_95081", "Add 'const' to unresolved variable"),
	        Add_const_to_all_unresolved_variables: diag(95082, 3 /* Message */, "Add_const_to_all_unresolved_variables_95082", "Add 'const' to all unresolved variables"),
	        Add_await: diag(95083, 3 /* Message */, "Add_await_95083", "Add 'await'"),
	        Add_await_to_initializer_for_0: diag(95084, 3 /* Message */, "Add_await_to_initializer_for_0_95084", "Add 'await' to initializer for '{0}'"),
	        Fix_all_expressions_possibly_missing_await: diag(95085, 3 /* Message */, "Fix_all_expressions_possibly_missing_await_95085", "Fix all expressions possibly missing 'await'"),
	        Remove_unnecessary_await: diag(95086, 3 /* Message */, "Remove_unnecessary_await_95086", "Remove unnecessary 'await'"),
	        Remove_all_unnecessary_uses_of_await: diag(95087, 3 /* Message */, "Remove_all_unnecessary_uses_of_await_95087", "Remove all unnecessary uses of 'await'"),
	        Enable_the_jsx_flag_in_your_configuration_file: diag(95088, 3 /* Message */, "Enable_the_jsx_flag_in_your_configuration_file_95088", "Enable the '--jsx' flag in your configuration file"),
	        Add_await_to_initializers: diag(95089, 3 /* Message */, "Add_await_to_initializers_95089", "Add 'await' to initializers"),
	        Extract_to_interface: diag(95090, 3 /* Message */, "Extract_to_interface_95090", "Extract to interface"),
	        Convert_to_a_bigint_numeric_literal: diag(95091, 3 /* Message */, "Convert_to_a_bigint_numeric_literal_95091", "Convert to a bigint numeric literal"),
	        Convert_all_to_bigint_numeric_literals: diag(95092, 3 /* Message */, "Convert_all_to_bigint_numeric_literals_95092", "Convert all to bigint numeric literals"),
	        Convert_const_to_let: diag(95093, 3 /* Message */, "Convert_const_to_let_95093", "Convert 'const' to 'let'"),
	        Prefix_with_declare: diag(95094, 3 /* Message */, "Prefix_with_declare_95094", "Prefix with 'declare'"),
	        Prefix_all_incorrect_property_declarations_with_declare: diag(95095, 3 /* Message */, "Prefix_all_incorrect_property_declarations_with_declare_95095", "Prefix all incorrect property declarations with 'declare'"),
	        Convert_to_template_string: diag(95096, 3 /* Message */, "Convert_to_template_string_95096", "Convert to template string"),
	        Add_export_to_make_this_file_into_a_module: diag(95097, 3 /* Message */, "Add_export_to_make_this_file_into_a_module_95097", "Add 'export {}' to make this file into a module"),
	        Set_the_target_option_in_your_configuration_file_to_0: diag(95098, 3 /* Message */, "Set_the_target_option_in_your_configuration_file_to_0_95098", "Set the 'target' option in your configuration file to '{0}'"),
	        Set_the_module_option_in_your_configuration_file_to_0: diag(95099, 3 /* Message */, "Set_the_module_option_in_your_configuration_file_to_0_95099", "Set the 'module' option in your configuration file to '{0}'"),
	        Convert_invalid_character_to_its_html_entity_code: diag(95100, 3 /* Message */, "Convert_invalid_character_to_its_html_entity_code_95100", "Convert invalid character to its html entity code"),
	        Convert_all_invalid_characters_to_HTML_entity_code: diag(95101, 3 /* Message */, "Convert_all_invalid_characters_to_HTML_entity_code_95101", "Convert all invalid characters to HTML entity code"),
	        Convert_all_const_to_let: diag(95102, 3 /* Message */, "Convert_all_const_to_let_95102", "Convert all 'const' to 'let'"),
	        Convert_function_expression_0_to_arrow_function: diag(95105, 3 /* Message */, "Convert_function_expression_0_to_arrow_function_95105", "Convert function expression '{0}' to arrow function"),
	        Convert_function_declaration_0_to_arrow_function: diag(95106, 3 /* Message */, "Convert_function_declaration_0_to_arrow_function_95106", "Convert function declaration '{0}' to arrow function"),
	        Fix_all_implicit_this_errors: diag(95107, 3 /* Message */, "Fix_all_implicit_this_errors_95107", "Fix all implicit-'this' errors"),
	        Wrap_invalid_character_in_an_expression_container: diag(95108, 3 /* Message */, "Wrap_invalid_character_in_an_expression_container_95108", "Wrap invalid character in an expression container"),
	        Wrap_all_invalid_characters_in_an_expression_container: diag(95109, 3 /* Message */, "Wrap_all_invalid_characters_in_an_expression_container_95109", "Wrap all invalid characters in an expression container"),
	        Visit_https_Colon_Slash_Slashaka_ms_Slashtsconfig_to_read_more_about_this_file: diag(95110, 3 /* Message */, "Visit_https_Colon_Slash_Slashaka_ms_Slashtsconfig_to_read_more_about_this_file_95110", "Visit https://aka.ms/tsconfig to read more about this file"),
	        Add_a_return_statement: diag(95111, 3 /* Message */, "Add_a_return_statement_95111", "Add a return statement"),
	        Remove_braces_from_arrow_function_body: diag(95112, 3 /* Message */, "Remove_braces_from_arrow_function_body_95112", "Remove braces from arrow function body"),
	        Wrap_the_following_body_with_parentheses_which_should_be_an_object_literal: diag(95113, 3 /* Message */, "Wrap_the_following_body_with_parentheses_which_should_be_an_object_literal_95113", "Wrap the following body with parentheses which should be an object literal"),
	        Add_all_missing_return_statement: diag(95114, 3 /* Message */, "Add_all_missing_return_statement_95114", "Add all missing return statement"),
	        Remove_braces_from_all_arrow_function_bodies_with_relevant_issues: diag(95115, 3 /* Message */, "Remove_braces_from_all_arrow_function_bodies_with_relevant_issues_95115", "Remove braces from all arrow function bodies with relevant issues"),
	        Wrap_all_object_literal_with_parentheses: diag(95116, 3 /* Message */, "Wrap_all_object_literal_with_parentheses_95116", "Wrap all object literal with parentheses"),
	        Move_labeled_tuple_element_modifiers_to_labels: diag(95117, 3 /* Message */, "Move_labeled_tuple_element_modifiers_to_labels_95117", "Move labeled tuple element modifiers to labels"),
	        Convert_overload_list_to_single_signature: diag(95118, 3 /* Message */, "Convert_overload_list_to_single_signature_95118", "Convert overload list to single signature"),
	        Generate_get_and_set_accessors_for_all_overriding_properties: diag(95119, 3 /* Message */, "Generate_get_and_set_accessors_for_all_overriding_properties_95119", "Generate 'get' and 'set' accessors for all overriding properties"),
	        Wrap_in_JSX_fragment: diag(95120, 3 /* Message */, "Wrap_in_JSX_fragment_95120", "Wrap in JSX fragment"),
	        Wrap_all_unparented_JSX_in_JSX_fragment: diag(95121, 3 /* Message */, "Wrap_all_unparented_JSX_in_JSX_fragment_95121", "Wrap all unparented JSX in JSX fragment"),
	        Convert_arrow_function_or_function_expression: diag(95122, 3 /* Message */, "Convert_arrow_function_or_function_expression_95122", "Convert arrow function or function expression"),
	        Convert_to_anonymous_function: diag(95123, 3 /* Message */, "Convert_to_anonymous_function_95123", "Convert to anonymous function"),
	        Convert_to_named_function: diag(95124, 3 /* Message */, "Convert_to_named_function_95124", "Convert to named function"),
	        Convert_to_arrow_function: diag(95125, 3 /* Message */, "Convert_to_arrow_function_95125", "Convert to arrow function"),
	        Remove_parentheses: diag(95126, 3 /* Message */, "Remove_parentheses_95126", "Remove parentheses"),
	        Could_not_find_a_containing_arrow_function: diag(95127, 3 /* Message */, "Could_not_find_a_containing_arrow_function_95127", "Could not find a containing arrow function"),
	        Containing_function_is_not_an_arrow_function: diag(95128, 3 /* Message */, "Containing_function_is_not_an_arrow_function_95128", "Containing function is not an arrow function"),
	        Could_not_find_export_statement: diag(95129, 3 /* Message */, "Could_not_find_export_statement_95129", "Could not find export statement"),
	        This_file_already_has_a_default_export: diag(95130, 3 /* Message */, "This_file_already_has_a_default_export_95130", "This file already has a default export"),
	        Could_not_find_import_clause: diag(95131, 3 /* Message */, "Could_not_find_import_clause_95131", "Could not find import clause"),
	        Could_not_find_namespace_import_or_named_imports: diag(95132, 3 /* Message */, "Could_not_find_namespace_import_or_named_imports_95132", "Could not find namespace import or named imports"),
	        Selection_is_not_a_valid_type_node: diag(95133, 3 /* Message */, "Selection_is_not_a_valid_type_node_95133", "Selection is not a valid type node"),
	        No_type_could_be_extracted_from_this_type_node: diag(95134, 3 /* Message */, "No_type_could_be_extracted_from_this_type_node_95134", "No type could be extracted from this type node"),
	        Could_not_find_property_for_which_to_generate_accessor: diag(95135, 3 /* Message */, "Could_not_find_property_for_which_to_generate_accessor_95135", "Could not find property for which to generate accessor"),
	        Name_is_not_valid: diag(95136, 3 /* Message */, "Name_is_not_valid_95136", "Name is not valid"),
	        Can_only_convert_property_with_modifier: diag(95137, 3 /* Message */, "Can_only_convert_property_with_modifier_95137", "Can only convert property with modifier"),
	        Switch_each_misused_0_to_1: diag(95138, 3 /* Message */, "Switch_each_misused_0_to_1_95138", "Switch each misused '{0}' to '{1}'"),
	        Convert_to_optional_chain_expression: diag(95139, 3 /* Message */, "Convert_to_optional_chain_expression_95139", "Convert to optional chain expression"),
	        Could_not_find_convertible_access_expression: diag(95140, 3 /* Message */, "Could_not_find_convertible_access_expression_95140", "Could not find convertible access expression"),
	        Could_not_find_matching_access_expressions: diag(95141, 3 /* Message */, "Could_not_find_matching_access_expressions_95141", "Could not find matching access expressions"),
	        Can_only_convert_logical_AND_access_chains: diag(95142, 3 /* Message */, "Can_only_convert_logical_AND_access_chains_95142", "Can only convert logical AND access chains"),
	        Add_void_to_Promise_resolved_without_a_value: diag(95143, 3 /* Message */, "Add_void_to_Promise_resolved_without_a_value_95143", "Add 'void' to Promise resolved without a value"),
	        Add_void_to_all_Promises_resolved_without_a_value: diag(95144, 3 /* Message */, "Add_void_to_all_Promises_resolved_without_a_value_95144", "Add 'void' to all Promises resolved without a value"),
	        Use_element_access_for_0: diag(95145, 3 /* Message */, "Use_element_access_for_0_95145", "Use element access for '{0}'"),
	        Use_element_access_for_all_undeclared_properties: diag(95146, 3 /* Message */, "Use_element_access_for_all_undeclared_properties_95146", "Use element access for all undeclared properties."),
	        Delete_all_unused_imports: diag(95147, 3 /* Message */, "Delete_all_unused_imports_95147", "Delete all unused imports"),
	        Infer_function_return_type: diag(95148, 3 /* Message */, "Infer_function_return_type_95148", "Infer function return type"),
	        Return_type_must_be_inferred_from_a_function: diag(95149, 3 /* Message */, "Return_type_must_be_inferred_from_a_function_95149", "Return type must be inferred from a function"),
	        Could_not_determine_function_return_type: diag(95150, 3 /* Message */, "Could_not_determine_function_return_type_95150", "Could not determine function return type"),
	        Could_not_convert_to_arrow_function: diag(95151, 3 /* Message */, "Could_not_convert_to_arrow_function_95151", "Could not convert to arrow function"),
	        Could_not_convert_to_named_function: diag(95152, 3 /* Message */, "Could_not_convert_to_named_function_95152", "Could not convert to named function"),
	        Could_not_convert_to_anonymous_function: diag(95153, 3 /* Message */, "Could_not_convert_to_anonymous_function_95153", "Could not convert to anonymous function"),
	        Can_only_convert_string_concatenations_and_string_literals: diag(95154, 3 /* Message */, "Can_only_convert_string_concatenations_and_string_literals_95154", "Can only convert string concatenations and string literals"),
	        Selection_is_not_a_valid_statement_or_statements: diag(95155, 3 /* Message */, "Selection_is_not_a_valid_statement_or_statements_95155", "Selection is not a valid statement or statements"),
	        Add_missing_function_declaration_0: diag(95156, 3 /* Message */, "Add_missing_function_declaration_0_95156", "Add missing function declaration '{0}'"),
	        Add_all_missing_function_declarations: diag(95157, 3 /* Message */, "Add_all_missing_function_declarations_95157", "Add all missing function declarations"),
	        Method_not_implemented: diag(95158, 3 /* Message */, "Method_not_implemented_95158", "Method not implemented."),
	        Function_not_implemented: diag(95159, 3 /* Message */, "Function_not_implemented_95159", "Function not implemented."),
	        Add_override_modifier: diag(95160, 3 /* Message */, "Add_override_modifier_95160", "Add 'override' modifier"),
	        Remove_override_modifier: diag(95161, 3 /* Message */, "Remove_override_modifier_95161", "Remove 'override' modifier"),
	        Add_all_missing_override_modifiers: diag(95162, 3 /* Message */, "Add_all_missing_override_modifiers_95162", "Add all missing 'override' modifiers"),
	        Remove_all_unnecessary_override_modifiers: diag(95163, 3 /* Message */, "Remove_all_unnecessary_override_modifiers_95163", "Remove all unnecessary 'override' modifiers"),
	        Can_only_convert_named_export: diag(95164, 3 /* Message */, "Can_only_convert_named_export_95164", "Can only convert named export"),
	        Add_missing_properties: diag(95165, 3 /* Message */, "Add_missing_properties_95165", "Add missing properties"),
	        Add_all_missing_properties: diag(95166, 3 /* Message */, "Add_all_missing_properties_95166", "Add all missing properties"),
	        Add_missing_attributes: diag(95167, 3 /* Message */, "Add_missing_attributes_95167", "Add missing attributes"),
	        Add_all_missing_attributes: diag(95168, 3 /* Message */, "Add_all_missing_attributes_95168", "Add all missing attributes"),
	        Add_undefined_to_optional_property_type: diag(95169, 3 /* Message */, "Add_undefined_to_optional_property_type_95169", "Add 'undefined' to optional property type"),
	        Convert_named_imports_to_default_import: diag(95170, 3 /* Message */, "Convert_named_imports_to_default_import_95170", "Convert named imports to default import"),
	        Delete_unused_param_tag_0: diag(95171, 3 /* Message */, "Delete_unused_param_tag_0_95171", "Delete unused '@param' tag '{0}'"),
	        Delete_all_unused_param_tags: diag(95172, 3 /* Message */, "Delete_all_unused_param_tags_95172", "Delete all unused '@param' tags"),
	        Rename_param_tag_name_0_to_1: diag(95173, 3 /* Message */, "Rename_param_tag_name_0_to_1_95173", "Rename '@param' tag name '{0}' to '{1}'"),
	        Use_0: diag(95174, 3 /* Message */, "Use_0_95174", "Use `{0}`."),
	        Use_Number_isNaN_in_all_conditions: diag(95175, 3 /* Message */, "Use_Number_isNaN_in_all_conditions_95175", "Use `Number.isNaN` in all conditions."),
	        Convert_typedef_to_TypeScript_type: diag(95176, 3 /* Message */, "Convert_typedef_to_TypeScript_type_95176", "Convert typedef to TypeScript type."),
	        Convert_all_typedef_to_TypeScript_types: diag(95177, 3 /* Message */, "Convert_all_typedef_to_TypeScript_types_95177", "Convert all typedef to TypeScript types."),
	        Move_to_file: diag(95178, 3 /* Message */, "Move_to_file_95178", "Move to file"),
	        Cannot_move_to_file_selected_file_is_invalid: diag(95179, 3 /* Message */, "Cannot_move_to_file_selected_file_is_invalid_95179", "Cannot move to file, selected file is invalid"),
	        Use_import_type: diag(95180, 3 /* Message */, "Use_import_type_95180", "Use 'import type'"),
	        Use_type_0: diag(95181, 3 /* Message */, "Use_type_0_95181", "Use 'type {0}'"),
	        Fix_all_with_type_only_imports: diag(95182, 3 /* Message */, "Fix_all_with_type_only_imports_95182", "Fix all with type-only imports"),
	        Cannot_move_statements_to_the_selected_file: diag(95183, 3 /* Message */, "Cannot_move_statements_to_the_selected_file_95183", "Cannot move statements to the selected file"),
	        Inline_variable: diag(95184, 3 /* Message */, "Inline_variable_95184", "Inline variable"),
	        Could_not_find_variable_to_inline: diag(95185, 3 /* Message */, "Could_not_find_variable_to_inline_95185", "Could not find variable to inline."),
	        Variables_with_multiple_declarations_cannot_be_inlined: diag(95186, 3 /* Message */, "Variables_with_multiple_declarations_cannot_be_inlined_95186", "Variables with multiple declarations cannot be inlined."),
	        Add_missing_comma_for_object_member_completion_0: diag(95187, 3 /* Message */, "Add_missing_comma_for_object_member_completion_0_95187", "Add missing comma for object member completion '{0}'."),
	        Add_missing_parameter_to_0: diag(95188, 3 /* Message */, "Add_missing_parameter_to_0_95188", "Add missing parameter to '{0}'"),
	        Add_missing_parameters_to_0: diag(95189, 3 /* Message */, "Add_missing_parameters_to_0_95189", "Add missing parameters to '{0}'"),
	        Add_all_missing_parameters: diag(95190, 3 /* Message */, "Add_all_missing_parameters_95190", "Add all missing parameters"),
	        Add_optional_parameter_to_0: diag(95191, 3 /* Message */, "Add_optional_parameter_to_0_95191", "Add optional parameter to '{0}'"),
	        Add_optional_parameters_to_0: diag(95192, 3 /* Message */, "Add_optional_parameters_to_0_95192", "Add optional parameters to '{0}'"),
	        Add_all_optional_parameters: diag(95193, 3 /* Message */, "Add_all_optional_parameters_95193", "Add all optional parameters"),
	        No_value_exists_in_scope_for_the_shorthand_property_0_Either_declare_one_or_provide_an_initializer: diag(18004, 1 /* Error */, "No_value_exists_in_scope_for_the_shorthand_property_0_Either_declare_one_or_provide_an_initializer_18004", "No value exists in scope for the shorthand property '{0}'. Either declare one or provide an initializer."),
	        Classes_may_not_have_a_field_named_constructor: diag(18006, 1 /* Error */, "Classes_may_not_have_a_field_named_constructor_18006", "Classes may not have a field named 'constructor'."),
	        JSX_expressions_may_not_use_the_comma_operator_Did_you_mean_to_write_an_array: diag(18007, 1 /* Error */, "JSX_expressions_may_not_use_the_comma_operator_Did_you_mean_to_write_an_array_18007", "JSX expressions may not use the comma operator. Did you mean to write an array?"),
	        Private_identifiers_cannot_be_used_as_parameters: diag(18009, 1 /* Error */, "Private_identifiers_cannot_be_used_as_parameters_18009", "Private identifiers cannot be used as parameters."),
	        An_accessibility_modifier_cannot_be_used_with_a_private_identifier: diag(18010, 1 /* Error */, "An_accessibility_modifier_cannot_be_used_with_a_private_identifier_18010", "An accessibility modifier cannot be used with a private identifier."),
	        The_operand_of_a_delete_operator_cannot_be_a_private_identifier: diag(18011, 1 /* Error */, "The_operand_of_a_delete_operator_cannot_be_a_private_identifier_18011", "The operand of a 'delete' operator cannot be a private identifier."),
	        constructor_is_a_reserved_word: diag(18012, 1 /* Error */, "constructor_is_a_reserved_word_18012", "'#constructor' is a reserved word."),
	        Property_0_is_not_accessible_outside_class_1_because_it_has_a_private_identifier: diag(18013, 1 /* Error */, "Property_0_is_not_accessible_outside_class_1_because_it_has_a_private_identifier_18013", "Property '{0}' is not accessible outside class '{1}' because it has a private identifier."),
	        The_property_0_cannot_be_accessed_on_type_1_within_this_class_because_it_is_shadowed_by_another_private_identifier_with_the_same_spelling: diag(18014, 1 /* Error */, "The_property_0_cannot_be_accessed_on_type_1_within_this_class_because_it_is_shadowed_by_another_priv_18014", "The property '{0}' cannot be accessed on type '{1}' within this class because it is shadowed by another private identifier with the same spelling."),
	        Property_0_in_type_1_refers_to_a_different_member_that_cannot_be_accessed_from_within_type_2: diag(18015, 1 /* Error */, "Property_0_in_type_1_refers_to_a_different_member_that_cannot_be_accessed_from_within_type_2_18015", "Property '{0}' in type '{1}' refers to a different member that cannot be accessed from within type '{2}'."),
	        Private_identifiers_are_not_allowed_outside_class_bodies: diag(18016, 1 /* Error */, "Private_identifiers_are_not_allowed_outside_class_bodies_18016", "Private identifiers are not allowed outside class bodies."),
	        The_shadowing_declaration_of_0_is_defined_here: diag(18017, 1 /* Error */, "The_shadowing_declaration_of_0_is_defined_here_18017", "The shadowing declaration of '{0}' is defined here"),
	        The_declaration_of_0_that_you_probably_intended_to_use_is_defined_here: diag(18018, 1 /* Error */, "The_declaration_of_0_that_you_probably_intended_to_use_is_defined_here_18018", "The declaration of '{0}' that you probably intended to use is defined here"),
	        _0_modifier_cannot_be_used_with_a_private_identifier: diag(18019, 1 /* Error */, "_0_modifier_cannot_be_used_with_a_private_identifier_18019", "'{0}' modifier cannot be used with a private identifier."),
	        An_enum_member_cannot_be_named_with_a_private_identifier: diag(18024, 1 /* Error */, "An_enum_member_cannot_be_named_with_a_private_identifier_18024", "An enum member cannot be named with a private identifier."),
	        can_only_be_used_at_the_start_of_a_file: diag(18026, 1 /* Error */, "can_only_be_used_at_the_start_of_a_file_18026", "'#!' can only be used at the start of a file."),
	        Compiler_reserves_name_0_when_emitting_private_identifier_downlevel: diag(18027, 1 /* Error */, "Compiler_reserves_name_0_when_emitting_private_identifier_downlevel_18027", "Compiler reserves name '{0}' when emitting private identifier downlevel."),
	        Private_identifiers_are_only_available_when_targeting_ECMAScript_2015_and_higher: diag(18028, 1 /* Error */, "Private_identifiers_are_only_available_when_targeting_ECMAScript_2015_and_higher_18028", "Private identifiers are only available when targeting ECMAScript 2015 and higher."),
	        Private_identifiers_are_not_allowed_in_variable_declarations: diag(18029, 1 /* Error */, "Private_identifiers_are_not_allowed_in_variable_declarations_18029", "Private identifiers are not allowed in variable declarations."),
	        An_optional_chain_cannot_contain_private_identifiers: diag(18030, 1 /* Error */, "An_optional_chain_cannot_contain_private_identifiers_18030", "An optional chain cannot contain private identifiers."),
	        The_intersection_0_was_reduced_to_never_because_property_1_has_conflicting_types_in_some_constituents: diag(18031, 1 /* Error */, "The_intersection_0_was_reduced_to_never_because_property_1_has_conflicting_types_in_some_constituent_18031", "The intersection '{0}' was reduced to 'never' because property '{1}' has conflicting types in some constituents."),
	        The_intersection_0_was_reduced_to_never_because_property_1_exists_in_multiple_constituents_and_is_private_in_some: diag(18032, 1 /* Error */, "The_intersection_0_was_reduced_to_never_because_property_1_exists_in_multiple_constituents_and_is_pr_18032", "The intersection '{0}' was reduced to 'never' because property '{1}' exists in multiple constituents and is private in some."),
	        Type_0_is_not_assignable_to_type_1_as_required_for_computed_enum_member_values: diag(18033, 1 /* Error */, "Type_0_is_not_assignable_to_type_1_as_required_for_computed_enum_member_values_18033", "Type '{0}' is not assignable to type '{1}' as required for computed enum member values."),
	        Specify_the_JSX_fragment_factory_function_to_use_when_targeting_react_JSX_emit_with_jsxFactory_compiler_option_is_specified_e_g_Fragment: diag(18034, 3 /* Message */, "Specify_the_JSX_fragment_factory_function_to_use_when_targeting_react_JSX_emit_with_jsxFactory_compi_18034", "Specify the JSX fragment factory function to use when targeting 'react' JSX emit with 'jsxFactory' compiler option is specified, e.g. 'Fragment'."),
	        Invalid_value_for_jsxFragmentFactory_0_is_not_a_valid_identifier_or_qualified_name: diag(18035, 1 /* Error */, "Invalid_value_for_jsxFragmentFactory_0_is_not_a_valid_identifier_or_qualified_name_18035", "Invalid value for 'jsxFragmentFactory'. '{0}' is not a valid identifier or qualified-name."),
	        Class_decorators_can_t_be_used_with_static_private_identifier_Consider_removing_the_experimental_decorator: diag(18036, 1 /* Error */, "Class_decorators_can_t_be_used_with_static_private_identifier_Consider_removing_the_experimental_dec_18036", "Class decorators can't be used with static private identifier. Consider removing the experimental decorator."),
	        await_expression_cannot_be_used_inside_a_class_static_block: diag(18037, 1 /* Error */, "await_expression_cannot_be_used_inside_a_class_static_block_18037", "'await' expression cannot be used inside a class static block."),
	        for_await_loops_cannot_be_used_inside_a_class_static_block: diag(18038, 1 /* Error */, "for_await_loops_cannot_be_used_inside_a_class_static_block_18038", "'for await' loops cannot be used inside a class static block."),
	        Invalid_use_of_0_It_cannot_be_used_inside_a_class_static_block: diag(18039, 1 /* Error */, "Invalid_use_of_0_It_cannot_be_used_inside_a_class_static_block_18039", "Invalid use of '{0}'. It cannot be used inside a class static block."),
	        A_return_statement_cannot_be_used_inside_a_class_static_block: diag(18041, 1 /* Error */, "A_return_statement_cannot_be_used_inside_a_class_static_block_18041", "A 'return' statement cannot be used inside a class static block."),
	        _0_is_a_type_and_cannot_be_imported_in_JavaScript_files_Use_1_in_a_JSDoc_type_annotation: diag(18042, 1 /* Error */, "_0_is_a_type_and_cannot_be_imported_in_JavaScript_files_Use_1_in_a_JSDoc_type_annotation_18042", "'{0}' is a type and cannot be imported in JavaScript files. Use '{1}' in a JSDoc type annotation."),
	        Types_cannot_appear_in_export_declarations_in_JavaScript_files: diag(18043, 1 /* Error */, "Types_cannot_appear_in_export_declarations_in_JavaScript_files_18043", "Types cannot appear in export declarations in JavaScript files."),
	        _0_is_automatically_exported_here: diag(18044, 3 /* Message */, "_0_is_automatically_exported_here_18044", "'{0}' is automatically exported here."),
	        Properties_with_the_accessor_modifier_are_only_available_when_targeting_ECMAScript_2015_and_higher: diag(18045, 1 /* Error */, "Properties_with_the_accessor_modifier_are_only_available_when_targeting_ECMAScript_2015_and_higher_18045", "Properties with the 'accessor' modifier are only available when targeting ECMAScript 2015 and higher."),
	        _0_is_of_type_unknown: diag(18046, 1 /* Error */, "_0_is_of_type_unknown_18046", "'{0}' is of type 'unknown'."),
	        _0_is_possibly_null: diag(18047, 1 /* Error */, "_0_is_possibly_null_18047", "'{0}' is possibly 'null'."),
	        _0_is_possibly_undefined: diag(18048, 1 /* Error */, "_0_is_possibly_undefined_18048", "'{0}' is possibly 'undefined'."),
	        _0_is_possibly_null_or_undefined: diag(18049, 1 /* Error */, "_0_is_possibly_null_or_undefined_18049", "'{0}' is possibly 'null' or 'undefined'."),
	        The_value_0_cannot_be_used_here: diag(18050, 1 /* Error */, "The_value_0_cannot_be_used_here_18050", "The value '{0}' cannot be used here."),
	        Compiler_option_0_cannot_be_given_an_empty_string: diag(18051, 1 /* Error */, "Compiler_option_0_cannot_be_given_an_empty_string_18051", "Compiler option '{0}' cannot be given an empty string."),
	        Non_abstract_class_0_does_not_implement_all_abstract_members_of_1: diag(18052, 1 /* Error */, "Non_abstract_class_0_does_not_implement_all_abstract_members_of_1_18052", "Non-abstract class '{0}' does not implement all abstract members of '{1}'"),
	        Its_type_0_is_not_a_valid_JSX_element_type: diag(18053, 1 /* Error */, "Its_type_0_is_not_a_valid_JSX_element_type_18053", "Its type '{0}' is not a valid JSX element type."),
	        await_using_statements_cannot_be_used_inside_a_class_static_block: diag(18054, 1 /* Error */, "await_using_statements_cannot_be_used_inside_a_class_static_block_18054", "'await using' statements cannot be used inside a class static block.")
	      };
	    }
	  });

	  // src/compiler/scanner.ts
	  function tokenIsIdentifierOrKeyword(token) {
	    return token >= 80 /* Identifier */;
	  }
	  function tokenIsIdentifierOrKeywordOrGreaterThan(token) {
	    return token === 32 /* GreaterThanToken */ || tokenIsIdentifierOrKeyword(token);
	  }
	  function lookupInUnicodeMap(code, map2) {
	    if (code < map2[0]) {
	      return false;
	    }
	    let lo = 0;
	    let hi = map2.length;
	    let mid;
	    while (lo + 1 < hi) {
	      mid = lo + (hi - lo) / 2;
	      mid -= mid % 2;
	      if (map2[mid] <= code && code <= map2[mid + 1]) {
	        return true;
	      }
	      if (code < map2[mid]) {
	        hi = mid;
	      } else {
	        lo = mid + 2;
	      }
	    }
	    return false;
	  }
	  function isUnicodeIdentifierStart(code, languageVersion) {
	    return languageVersion >= 2 /* ES2015 */ ? lookupInUnicodeMap(code, unicodeESNextIdentifierStart) : languageVersion === 1 /* ES5 */ ? lookupInUnicodeMap(code, unicodeES5IdentifierStart) : lookupInUnicodeMap(code, unicodeES3IdentifierStart);
	  }
	  function isUnicodeIdentifierPart(code, languageVersion) {
	    return languageVersion >= 2 /* ES2015 */ ? lookupInUnicodeMap(code, unicodeESNextIdentifierPart) : languageVersion === 1 /* ES5 */ ? lookupInUnicodeMap(code, unicodeES5IdentifierPart) : lookupInUnicodeMap(code, unicodeES3IdentifierPart);
	  }
	  function makeReverseMap(source) {
	    const result = [];
	    source.forEach((value, name) => {
	      result[value] = name;
	    });
	    return result;
	  }
	  function tokenToString(t) {
	    return tokenStrings[t];
	  }
	  function stringToToken(s) {
	    return textToToken.get(s);
	  }
	  function computeLineStarts(text) {
	    const result = [];
	    let pos = 0;
	    let lineStart = 0;
	    while (pos < text.length) {
	      const ch = text.charCodeAt(pos);
	      pos++;
	      switch (ch) {
	        case 13 /* carriageReturn */:
	          if (text.charCodeAt(pos) === 10 /* lineFeed */) {
	            pos++;
	          }
	        case 10 /* lineFeed */:
	          result.push(lineStart);
	          lineStart = pos;
	          break;
	        default:
	          if (ch > 127 /* maxAsciiCharacter */ && isLineBreak(ch)) {
	            result.push(lineStart);
	            lineStart = pos;
	          }
	          break;
	      }
	    }
	    result.push(lineStart);
	    return result;
	  }
	  function getPositionOfLineAndCharacter(sourceFile, line, character, allowEdits) {
	    return sourceFile.getPositionOfLineAndCharacter ? sourceFile.getPositionOfLineAndCharacter(line, character, allowEdits) : computePositionOfLineAndCharacter(getLineStarts(sourceFile), line, character, sourceFile.text, allowEdits);
	  }
	  function computePositionOfLineAndCharacter(lineStarts, line, character, debugText, allowEdits) {
	    if (line < 0 || line >= lineStarts.length) {
	      if (allowEdits) {
	        line = line < 0 ? 0 : line >= lineStarts.length ? lineStarts.length - 1 : line;
	      } else {
	        Debug.fail(`Bad line number. Line: ${line}, lineStarts.length: ${lineStarts.length} , line map is correct? ${debugText !== void 0 ? arraysEqual(lineStarts, computeLineStarts(debugText)) : "unknown"}`);
	      }
	    }
	    const res = lineStarts[line] + character;
	    if (allowEdits) {
	      return res > lineStarts[line + 1] ? lineStarts[line + 1] : typeof debugText === "string" && res > debugText.length ? debugText.length : res;
	    }
	    if (line < lineStarts.length - 1) {
	      Debug.assert(res < lineStarts[line + 1]);
	    } else if (debugText !== void 0) {
	      Debug.assert(res <= debugText.length);
	    }
	    return res;
	  }
	  function getLineStarts(sourceFile) {
	    return sourceFile.lineMap || (sourceFile.lineMap = computeLineStarts(sourceFile.text));
	  }
	  function computeLineAndCharacterOfPosition(lineStarts, position) {
	    const lineNumber = computeLineOfPosition(lineStarts, position);
	    return {
	      line: lineNumber,
	      character: position - lineStarts[lineNumber]
	    };
	  }
	  function computeLineOfPosition(lineStarts, position, lowerBound) {
	    let lineNumber = binarySearch(lineStarts, position, identity, compareValues, lowerBound);
	    if (lineNumber < 0) {
	      lineNumber = ~lineNumber - 1;
	      Debug.assert(lineNumber !== -1, "position cannot precede the beginning of the file");
	    }
	    return lineNumber;
	  }
	  function getLinesBetweenPositions(sourceFile, pos1, pos2) {
	    if (pos1 === pos2)
	      return 0;
	    const lineStarts = getLineStarts(sourceFile);
	    const lower = Math.min(pos1, pos2);
	    const isNegative = lower === pos2;
	    const upper = isNegative ? pos1 : pos2;
	    const lowerLine = computeLineOfPosition(lineStarts, lower);
	    const upperLine = computeLineOfPosition(lineStarts, upper, lowerLine);
	    return isNegative ? lowerLine - upperLine : upperLine - lowerLine;
	  }
	  function getLineAndCharacterOfPosition(sourceFile, position) {
	    return computeLineAndCharacterOfPosition(getLineStarts(sourceFile), position);
	  }
	  function isWhiteSpaceLike(ch) {
	    return isWhiteSpaceSingleLine(ch) || isLineBreak(ch);
	  }
	  function isWhiteSpaceSingleLine(ch) {
	    return ch === 32 /* space */ || ch === 9 /* tab */ || ch === 11 /* verticalTab */ || ch === 12 /* formFeed */ || ch === 160 /* nonBreakingSpace */ || ch === 133 /* nextLine */ || ch === 5760 /* ogham */ || ch >= 8192 /* enQuad */ && ch <= 8203 /* zeroWidthSpace */ || ch === 8239 /* narrowNoBreakSpace */ || ch === 8287 /* mathematicalSpace */ || ch === 12288 /* ideographicSpace */ || ch === 65279 /* byteOrderMark */;
	  }
	  function isLineBreak(ch) {
	    return ch === 10 /* lineFeed */ || ch === 13 /* carriageReturn */ || ch === 8232 /* lineSeparator */ || ch === 8233 /* paragraphSeparator */;
	  }
	  function isDigit(ch) {
	    return ch >= 48 /* _0 */ && ch <= 57 /* _9 */;
	  }
	  function isHexDigit(ch) {
	    return isDigit(ch) || ch >= 65 /* A */ && ch <= 70 /* F */ || ch >= 97 /* a */ && ch <= 102 /* f */;
	  }
	  function isCodePoint(code) {
	    return code <= 1114111;
	  }
	  function isOctalDigit(ch) {
	    return ch >= 48 /* _0 */ && ch <= 55 /* _7 */;
	  }
	  function couldStartTrivia(text, pos) {
	    const ch = text.charCodeAt(pos);
	    switch (ch) {
	      case 13 /* carriageReturn */:
	      case 10 /* lineFeed */:
	      case 9 /* tab */:
	      case 11 /* verticalTab */:
	      case 12 /* formFeed */:
	      case 32 /* space */:
	      case 47 /* slash */:
	      case 60 /* lessThan */:
	      case 124 /* bar */:
	      case 61 /* equals */:
	      case 62 /* greaterThan */:
	        return true;
	      case 35 /* hash */:
	        return pos === 0;
	      default:
	        return ch > 127 /* maxAsciiCharacter */;
	    }
	  }
	  function skipTrivia(text, pos, stopAfterLineBreak, stopAtComments, inJSDoc) {
	    if (positionIsSynthesized(pos)) {
	      return pos;
	    }
	    let canConsumeStar = false;
	    while (true) {
	      const ch = text.charCodeAt(pos);
	      switch (ch) {
	        case 13 /* carriageReturn */:
	          if (text.charCodeAt(pos + 1) === 10 /* lineFeed */) {
	            pos++;
	          }
	        case 10 /* lineFeed */:
	          pos++;
	          if (stopAfterLineBreak) {
	            return pos;
	          }
	          canConsumeStar = !!inJSDoc;
	          continue;
	        case 9 /* tab */:
	        case 11 /* verticalTab */:
	        case 12 /* formFeed */:
	        case 32 /* space */:
	          pos++;
	          continue;
	        case 47 /* slash */:
	          if (stopAtComments) {
	            break;
	          }
	          if (text.charCodeAt(pos + 1) === 47 /* slash */) {
	            pos += 2;
	            while (pos < text.length) {
	              if (isLineBreak(text.charCodeAt(pos))) {
	                break;
	              }
	              pos++;
	            }
	            canConsumeStar = false;
	            continue;
	          }
	          if (text.charCodeAt(pos + 1) === 42 /* asterisk */) {
	            pos += 2;
	            while (pos < text.length) {
	              if (text.charCodeAt(pos) === 42 /* asterisk */ && text.charCodeAt(pos + 1) === 47 /* slash */) {
	                pos += 2;
	                break;
	              }
	              pos++;
	            }
	            canConsumeStar = false;
	            continue;
	          }
	          break;
	        case 60 /* lessThan */:
	        case 124 /* bar */:
	        case 61 /* equals */:
	        case 62 /* greaterThan */:
	          if (isConflictMarkerTrivia(text, pos)) {
	            pos = scanConflictMarkerTrivia(text, pos);
	            canConsumeStar = false;
	            continue;
	          }
	          break;
	        case 35 /* hash */:
	          if (pos === 0 && isShebangTrivia(text, pos)) {
	            pos = scanShebangTrivia(text, pos);
	            canConsumeStar = false;
	            continue;
	          }
	          break;
	        case 42 /* asterisk */:
	          if (canConsumeStar) {
	            pos++;
	            canConsumeStar = false;
	            continue;
	          }
	          break;
	        default:
	          if (ch > 127 /* maxAsciiCharacter */ && isWhiteSpaceLike(ch)) {
	            pos++;
	            continue;
	          }
	          break;
	      }
	      return pos;
	    }
	  }
	  function isConflictMarkerTrivia(text, pos) {
	    Debug.assert(pos >= 0);
	    if (pos === 0 || isLineBreak(text.charCodeAt(pos - 1))) {
	      const ch = text.charCodeAt(pos);
	      if (pos + mergeConflictMarkerLength < text.length) {
	        for (let i = 0; i < mergeConflictMarkerLength; i++) {
	          if (text.charCodeAt(pos + i) !== ch) {
	            return false;
	          }
	        }
	        return ch === 61 /* equals */ || text.charCodeAt(pos + mergeConflictMarkerLength) === 32 /* space */;
	      }
	    }
	    return false;
	  }
	  function scanConflictMarkerTrivia(text, pos, error2) {
	    if (error2) {
	      error2(Diagnostics.Merge_conflict_marker_encountered, pos, mergeConflictMarkerLength);
	    }
	    const ch = text.charCodeAt(pos);
	    const len = text.length;
	    if (ch === 60 /* lessThan */ || ch === 62 /* greaterThan */) {
	      while (pos < len && !isLineBreak(text.charCodeAt(pos))) {
	        pos++;
	      }
	    } else {
	      Debug.assert(ch === 124 /* bar */ || ch === 61 /* equals */);
	      while (pos < len) {
	        const currentChar = text.charCodeAt(pos);
	        if ((currentChar === 61 /* equals */ || currentChar === 62 /* greaterThan */) && currentChar !== ch && isConflictMarkerTrivia(text, pos)) {
	          break;
	        }
	        pos++;
	      }
	    }
	    return pos;
	  }
	  function isShebangTrivia(text, pos) {
	    Debug.assert(pos === 0);
	    return shebangTriviaRegex.test(text);
	  }
	  function scanShebangTrivia(text, pos) {
	    const shebang = shebangTriviaRegex.exec(text)[0];
	    pos = pos + shebang.length;
	    return pos;
	  }
	  function iterateCommentRanges(reduce, text, pos, trailing, cb, state, initial) {
	    let pendingPos;
	    let pendingEnd;
	    let pendingKind;
	    let pendingHasTrailingNewLine;
	    let hasPendingCommentRange = false;
	    let collecting = trailing;
	    let accumulator = initial;
	    if (pos === 0) {
	      collecting = true;
	      const shebang = getShebang(text);
	      if (shebang) {
	        pos = shebang.length;
	      }
	    }
	    scan:
	      while (pos >= 0 && pos < text.length) {
	        const ch = text.charCodeAt(pos);
	        switch (ch) {
	          case 13 /* carriageReturn */:
	            if (text.charCodeAt(pos + 1) === 10 /* lineFeed */) {
	              pos++;
	            }
	          case 10 /* lineFeed */:
	            pos++;
	            if (trailing) {
	              break scan;
	            }
	            collecting = true;
	            if (hasPendingCommentRange) {
	              pendingHasTrailingNewLine = true;
	            }
	            continue;
	          case 9 /* tab */:
	          case 11 /* verticalTab */:
	          case 12 /* formFeed */:
	          case 32 /* space */:
	            pos++;
	            continue;
	          case 47 /* slash */:
	            const nextChar = text.charCodeAt(pos + 1);
	            let hasTrailingNewLine = false;
	            if (nextChar === 47 /* slash */ || nextChar === 42 /* asterisk */) {
	              const kind = nextChar === 47 /* slash */ ? 2 /* SingleLineCommentTrivia */ : 3 /* MultiLineCommentTrivia */;
	              const startPos = pos;
	              pos += 2;
	              if (nextChar === 47 /* slash */) {
	                while (pos < text.length) {
	                  if (isLineBreak(text.charCodeAt(pos))) {
	                    hasTrailingNewLine = true;
	                    break;
	                  }
	                  pos++;
	                }
	              } else {
	                while (pos < text.length) {
	                  if (text.charCodeAt(pos) === 42 /* asterisk */ && text.charCodeAt(pos + 1) === 47 /* slash */) {
	                    pos += 2;
	                    break;
	                  }
	                  pos++;
	                }
	              }
	              if (collecting) {
	                if (hasPendingCommentRange) {
	                  accumulator = cb(pendingPos, pendingEnd, pendingKind, pendingHasTrailingNewLine, state, accumulator);
	                  if (!reduce && accumulator) {
	                    return accumulator;
	                  }
	                }
	                pendingPos = startPos;
	                pendingEnd = pos;
	                pendingKind = kind;
	                pendingHasTrailingNewLine = hasTrailingNewLine;
	                hasPendingCommentRange = true;
	              }
	              continue;
	            }
	            break scan;
	          default:
	            if (ch > 127 /* maxAsciiCharacter */ && isWhiteSpaceLike(ch)) {
	              if (hasPendingCommentRange && isLineBreak(ch)) {
	                pendingHasTrailingNewLine = true;
	              }
	              pos++;
	              continue;
	            }
	            break scan;
	        }
	      }
	    if (hasPendingCommentRange) {
	      accumulator = cb(pendingPos, pendingEnd, pendingKind, pendingHasTrailingNewLine, state, accumulator);
	    }
	    return accumulator;
	  }
	  function forEachLeadingCommentRange(text, pos, cb, state) {
	    return iterateCommentRanges(
	      /*reduce*/
	      false,
	      text,
	      pos,
	      /*trailing*/
	      false,
	      cb,
	      state
	    );
	  }
	  function forEachTrailingCommentRange(text, pos, cb, state) {
	    return iterateCommentRanges(
	      /*reduce*/
	      false,
	      text,
	      pos,
	      /*trailing*/
	      true,
	      cb,
	      state
	    );
	  }
	  function reduceEachLeadingCommentRange(text, pos, cb, state, initial) {
	    return iterateCommentRanges(
	      /*reduce*/
	      true,
	      text,
	      pos,
	      /*trailing*/
	      false,
	      cb,
	      state,
	      initial
	    );
	  }
	  function reduceEachTrailingCommentRange(text, pos, cb, state, initial) {
	    return iterateCommentRanges(
	      /*reduce*/
	      true,
	      text,
	      pos,
	      /*trailing*/
	      true,
	      cb,
	      state,
	      initial
	    );
	  }
	  function appendCommentRange(pos, end, kind, hasTrailingNewLine, _state, comments = []) {
	    comments.push({ kind, pos, end, hasTrailingNewLine });
	    return comments;
	  }
	  function getLeadingCommentRanges(text, pos) {
	    return reduceEachLeadingCommentRange(
	      text,
	      pos,
	      appendCommentRange,
	      /*state*/
	      void 0,
	      /*initial*/
	      void 0
	    );
	  }
	  function getTrailingCommentRanges(text, pos) {
	    return reduceEachTrailingCommentRange(
	      text,
	      pos,
	      appendCommentRange,
	      /*state*/
	      void 0,
	      /*initial*/
	      void 0
	    );
	  }
	  function getShebang(text) {
	    const match = shebangTriviaRegex.exec(text);
	    if (match) {
	      return match[0];
	    }
	  }
	  function isIdentifierStart(ch, languageVersion) {
	    return ch >= 65 /* A */ && ch <= 90 /* Z */ || ch >= 97 /* a */ && ch <= 122 /* z */ || ch === 36 /* $ */ || ch === 95 /* _ */ || ch > 127 /* maxAsciiCharacter */ && isUnicodeIdentifierStart(ch, languageVersion);
	  }
	  function isIdentifierPart(ch, languageVersion, identifierVariant) {
	    return ch >= 65 /* A */ && ch <= 90 /* Z */ || ch >= 97 /* a */ && ch <= 122 /* z */ || ch >= 48 /* _0 */ && ch <= 57 /* _9 */ || ch === 36 /* $ */ || ch === 95 /* _ */ || // "-" and ":" are valid in JSX Identifiers
	    (identifierVariant === 1 /* JSX */ ? ch === 45 /* minus */ || ch === 58 /* colon */ : false) || ch > 127 /* maxAsciiCharacter */ && isUnicodeIdentifierPart(ch, languageVersion);
	  }
	  function isIdentifierText(name, languageVersion, identifierVariant) {
	    let ch = codePointAt(name, 0);
	    if (!isIdentifierStart(ch, languageVersion)) {
	      return false;
	    }
	    for (let i = charSize(ch); i < name.length; i += charSize(ch)) {
	      if (!isIdentifierPart(ch = codePointAt(name, i), languageVersion, identifierVariant)) {
	        return false;
	      }
	    }
	    return true;
	  }
	  function createScanner(languageVersion, skipTrivia2, languageVariant = 0 /* Standard */, textInitial, onError, start, length2) {
	    var text = textInitial;
	    var pos;
	    var end;
	    var fullStartPos;
	    var tokenStart;
	    var token;
	    var tokenValue;
	    var tokenFlags;
	    var commentDirectives;
	    var inJSDocType = 0;
	    var scriptKind = 0 /* Unknown */;
	    var jsDocParsingMode = 0 /* ParseAll */;
	    setText(text, start, length2);
	    var scanner2 = {
	      getTokenFullStart: () => fullStartPos,
	      getStartPos: () => fullStartPos,
	      getTokenEnd: () => pos,
	      getTextPos: () => pos,
	      getToken: () => token,
	      getTokenStart: () => tokenStart,
	      getTokenPos: () => tokenStart,
	      getTokenText: () => text.substring(tokenStart, pos),
	      getTokenValue: () => tokenValue,
	      hasUnicodeEscape: () => (tokenFlags & 1024 /* UnicodeEscape */) !== 0,
	      hasExtendedUnicodeEscape: () => (tokenFlags & 8 /* ExtendedUnicodeEscape */) !== 0,
	      hasPrecedingLineBreak: () => (tokenFlags & 1 /* PrecedingLineBreak */) !== 0,
	      hasPrecedingJSDocComment: () => (tokenFlags & 2 /* PrecedingJSDocComment */) !== 0,
	      isIdentifier: () => token === 80 /* Identifier */ || token > 118 /* LastReservedWord */,
	      isReservedWord: () => token >= 83 /* FirstReservedWord */ && token <= 118 /* LastReservedWord */,
	      isUnterminated: () => (tokenFlags & 4 /* Unterminated */) !== 0,
	      getCommentDirectives: () => commentDirectives,
	      getNumericLiteralFlags: () => tokenFlags & 25584 /* NumericLiteralFlags */,
	      getTokenFlags: () => tokenFlags,
	      reScanGreaterToken,
	      reScanAsteriskEqualsToken,
	      reScanSlashToken,
	      reScanTemplateToken,
	      reScanTemplateHeadOrNoSubstitutionTemplate,
	      scanJsxIdentifier,
	      scanJsxAttributeValue,
	      reScanJsxAttributeValue,
	      reScanJsxToken,
	      reScanLessThanToken,
	      reScanHashToken,
	      reScanQuestionToken,
	      reScanInvalidIdentifier,
	      scanJsxToken,
	      scanJsDocToken,
	      scanJSDocCommentTextToken,
	      scan,
	      getText,
	      clearCommentDirectives,
	      setText,
	      setScriptTarget,
	      setLanguageVariant,
	      setScriptKind,
	      setJSDocParsingMode,
	      setOnError,
	      resetTokenState,
	      setTextPos: resetTokenState,
	      setInJSDocType,
	      tryScan,
	      lookAhead,
	      scanRange
	    };
	    if (Debug.isDebugging) {
	      Object.defineProperty(scanner2, "__debugShowCurrentPositionInText", {
	        get: () => {
	          const text2 = scanner2.getText();
	          return text2.slice(0, scanner2.getTokenFullStart()) + "\u2551" + text2.slice(scanner2.getTokenFullStart());
	        }
	      });
	    }
	    return scanner2;
	    function error2(message, errPos = pos, length3, arg0) {
	      if (onError) {
	        const oldPos = pos;
	        pos = errPos;
	        onError(message, length3 || 0, arg0);
	        pos = oldPos;
	      }
	    }
	    function scanNumberFragment() {
	      let start2 = pos;
	      let allowSeparator = false;
	      let isPreviousTokenSeparator = false;
	      let result = "";
	      while (true) {
	        const ch = text.charCodeAt(pos);
	        if (ch === 95 /* _ */) {
	          tokenFlags |= 512 /* ContainsSeparator */;
	          if (allowSeparator) {
	            allowSeparator = false;
	            isPreviousTokenSeparator = true;
	            result += text.substring(start2, pos);
	          } else {
	            tokenFlags |= 16384 /* ContainsInvalidSeparator */;
	            if (isPreviousTokenSeparator) {
	              error2(Diagnostics.Multiple_consecutive_numeric_separators_are_not_permitted, pos, 1);
	            } else {
	              error2(Diagnostics.Numeric_separators_are_not_allowed_here, pos, 1);
	            }
	          }
	          pos++;
	          start2 = pos;
	          continue;
	        }
	        if (isDigit(ch)) {
	          allowSeparator = true;
	          isPreviousTokenSeparator = false;
	          pos++;
	          continue;
	        }
	        break;
	      }
	      if (text.charCodeAt(pos - 1) === 95 /* _ */) {
	        tokenFlags |= 16384 /* ContainsInvalidSeparator */;
	        error2(Diagnostics.Numeric_separators_are_not_allowed_here, pos - 1, 1);
	      }
	      return result + text.substring(start2, pos);
	    }
	    function scanNumber() {
	      let start2 = pos;
	      let mainFragment;
	      if (text.charCodeAt(pos) === 48 /* _0 */) {
	        pos++;
	        if (text.charCodeAt(pos) === 95 /* _ */) {
	          tokenFlags |= 512 /* ContainsSeparator */ | 16384 /* ContainsInvalidSeparator */;
	          error2(Diagnostics.Numeric_separators_are_not_allowed_here, pos, 1);
	          pos--;
	          mainFragment = scanNumberFragment();
	        } else if (!scanDigits()) {
	          tokenFlags |= 8192 /* ContainsLeadingZero */;
	          mainFragment = "" + +tokenValue;
	        } else if (!tokenValue) {
	          mainFragment = "0";
	        } else {
	          tokenValue = "" + parseInt(tokenValue, 8);
	          tokenFlags |= 32 /* Octal */;
	          const withMinus = token === 41 /* MinusToken */;
	          const literal = (withMinus ? "-" : "") + "0o" + (+tokenValue).toString(8);
	          if (withMinus)
	            start2--;
	          error2(Diagnostics.Octal_literals_are_not_allowed_Use_the_syntax_0, start2, pos - start2, literal);
	          return 9 /* NumericLiteral */;
	        }
	      } else {
	        mainFragment = scanNumberFragment();
	      }
	      let decimalFragment;
	      let scientificFragment;
	      if (text.charCodeAt(pos) === 46 /* dot */) {
	        pos++;
	        decimalFragment = scanNumberFragment();
	      }
	      let end2 = pos;
	      if (text.charCodeAt(pos) === 69 /* E */ || text.charCodeAt(pos) === 101 /* e */) {
	        pos++;
	        tokenFlags |= 16 /* Scientific */;
	        if (text.charCodeAt(pos) === 43 /* plus */ || text.charCodeAt(pos) === 45 /* minus */)
	          pos++;
	        const preNumericPart = pos;
	        const finalFragment = scanNumberFragment();
	        if (!finalFragment) {
	          error2(Diagnostics.Digit_expected);
	        } else {
	          scientificFragment = text.substring(end2, preNumericPart) + finalFragment;
	          end2 = pos;
	        }
	      }
	      let result;
	      if (tokenFlags & 512 /* ContainsSeparator */) {
	        result = mainFragment;
	        if (decimalFragment) {
	          result += "." + decimalFragment;
	        }
	        if (scientificFragment) {
	          result += scientificFragment;
	        }
	      } else {
	        result = text.substring(start2, end2);
	      }
	      if (tokenFlags & 8192 /* ContainsLeadingZero */) {
	        error2(Diagnostics.Decimals_with_leading_zeros_are_not_allowed, start2, end2 - start2);
	        tokenValue = "" + +result;
	        return 9 /* NumericLiteral */;
	      }
	      if (decimalFragment !== void 0 || tokenFlags & 16 /* Scientific */) {
	        checkForIdentifierStartAfterNumericLiteral(start2, decimalFragment === void 0 && !!(tokenFlags & 16 /* Scientific */));
	        tokenValue = "" + +result;
	        return 9 /* NumericLiteral */;
	      } else {
	        tokenValue = result;
	        const type = checkBigIntSuffix();
	        checkForIdentifierStartAfterNumericLiteral(start2);
	        return type;
	      }
	    }
	    function checkForIdentifierStartAfterNumericLiteral(numericStart, isScientific) {
	      if (!isIdentifierStart(codePointAt(text, pos), languageVersion)) {
	        return;
	      }
	      const identifierStart = pos;
	      const { length: length3 } = scanIdentifierParts();
	      if (length3 === 1 && text[identifierStart] === "n") {
	        if (isScientific) {
	          error2(Diagnostics.A_bigint_literal_cannot_use_exponential_notation, numericStart, identifierStart - numericStart + 1);
	        } else {
	          error2(Diagnostics.A_bigint_literal_must_be_an_integer, numericStart, identifierStart - numericStart + 1);
	        }
	      } else {
	        error2(Diagnostics.An_identifier_or_keyword_cannot_immediately_follow_a_numeric_literal, identifierStart, length3);
	        pos = identifierStart;
	      }
	    }
	    function scanDigits() {
	      const start2 = pos;
	      let isOctal = true;
	      while (isDigit(text.charCodeAt(pos))) {
	        if (!isOctalDigit(text.charCodeAt(pos))) {
	          isOctal = false;
	        }
	        pos++;
	      }
	      tokenValue = text.substring(start2, pos);
	      return isOctal;
	    }
	    function scanExactNumberOfHexDigits(count, canHaveSeparators) {
	      const valueString = scanHexDigits(
	        /*minCount*/
	        count,
	        /*scanAsManyAsPossible*/
	        false,
	        canHaveSeparators
	      );
	      return valueString ? parseInt(valueString, 16) : -1;
	    }
	    function scanMinimumNumberOfHexDigits(count, canHaveSeparators) {
	      return scanHexDigits(
	        /*minCount*/
	        count,
	        /*scanAsManyAsPossible*/
	        true,
	        canHaveSeparators
	      );
	    }
	    function scanHexDigits(minCount, scanAsManyAsPossible, canHaveSeparators) {
	      let valueChars = [];
	      let allowSeparator = false;
	      let isPreviousTokenSeparator = false;
	      while (valueChars.length < minCount || scanAsManyAsPossible) {
	        let ch = text.charCodeAt(pos);
	        if (canHaveSeparators && ch === 95 /* _ */) {
	          tokenFlags |= 512 /* ContainsSeparator */;
	          if (allowSeparator) {
	            allowSeparator = false;
	            isPreviousTokenSeparator = true;
	          } else if (isPreviousTokenSeparator) {
	            error2(Diagnostics.Multiple_consecutive_numeric_separators_are_not_permitted, pos, 1);
	          } else {
	            error2(Diagnostics.Numeric_separators_are_not_allowed_here, pos, 1);
	          }
	          pos++;
	          continue;
	        }
	        allowSeparator = canHaveSeparators;
	        if (ch >= 65 /* A */ && ch <= 70 /* F */) {
	          ch += 97 /* a */ - 65 /* A */;
	        } else if (!(ch >= 48 /* _0 */ && ch <= 57 /* _9 */ || ch >= 97 /* a */ && ch <= 102 /* f */)) {
	          break;
	        }
	        valueChars.push(ch);
	        pos++;
	        isPreviousTokenSeparator = false;
	      }
	      if (valueChars.length < minCount) {
	        valueChars = [];
	      }
	      if (text.charCodeAt(pos - 1) === 95 /* _ */) {
	        error2(Diagnostics.Numeric_separators_are_not_allowed_here, pos - 1, 1);
	      }
	      return String.fromCharCode(...valueChars);
	    }
	    function scanString(jsxAttributeString = false) {
	      const quote2 = text.charCodeAt(pos);
	      pos++;
	      let result = "";
	      let start2 = pos;
	      while (true) {
	        if (pos >= end) {
	          result += text.substring(start2, pos);
	          tokenFlags |= 4 /* Unterminated */;
	          error2(Diagnostics.Unterminated_string_literal);
	          break;
	        }
	        const ch = text.charCodeAt(pos);
	        if (ch === quote2) {
	          result += text.substring(start2, pos);
	          pos++;
	          break;
	        }
	        if (ch === 92 /* backslash */ && !jsxAttributeString) {
	          result += text.substring(start2, pos);
	          result += scanEscapeSequence(
	            /*shouldEmitInvalidEscapeError*/
	            true
	          );
	          start2 = pos;
	          continue;
	        }
	        if ((ch === 10 /* lineFeed */ || ch === 13 /* carriageReturn */) && !jsxAttributeString) {
	          result += text.substring(start2, pos);
	          tokenFlags |= 4 /* Unterminated */;
	          error2(Diagnostics.Unterminated_string_literal);
	          break;
	        }
	        pos++;
	      }
	      return result;
	    }
	    function scanTemplateAndSetTokenValue(shouldEmitInvalidEscapeError) {
	      const startedWithBacktick = text.charCodeAt(pos) === 96 /* backtick */;
	      pos++;
	      let start2 = pos;
	      let contents = "";
	      let resultingToken;
	      while (true) {
	        if (pos >= end) {
	          contents += text.substring(start2, pos);
	          tokenFlags |= 4 /* Unterminated */;
	          error2(Diagnostics.Unterminated_template_literal);
	          resultingToken = startedWithBacktick ? 15 /* NoSubstitutionTemplateLiteral */ : 18 /* TemplateTail */;
	          break;
	        }
	        const currChar = text.charCodeAt(pos);
	        if (currChar === 96 /* backtick */) {
	          contents += text.substring(start2, pos);
	          pos++;
	          resultingToken = startedWithBacktick ? 15 /* NoSubstitutionTemplateLiteral */ : 18 /* TemplateTail */;
	          break;
	        }
	        if (currChar === 36 /* $ */ && pos + 1 < end && text.charCodeAt(pos + 1) === 123 /* openBrace */) {
	          contents += text.substring(start2, pos);
	          pos += 2;
	          resultingToken = startedWithBacktick ? 16 /* TemplateHead */ : 17 /* TemplateMiddle */;
	          break;
	        }
	        if (currChar === 92 /* backslash */) {
	          contents += text.substring(start2, pos);
	          contents += scanEscapeSequence(shouldEmitInvalidEscapeError);
	          start2 = pos;
	          continue;
	        }
	        if (currChar === 13 /* carriageReturn */) {
	          contents += text.substring(start2, pos);
	          pos++;
	          if (pos < end && text.charCodeAt(pos) === 10 /* lineFeed */) {
	            pos++;
	          }
	          contents += "\n";
	          start2 = pos;
	          continue;
	        }
	        pos++;
	      }
	      Debug.assert(resultingToken !== void 0);
	      tokenValue = contents;
	      return resultingToken;
	    }
	    function scanEscapeSequence(shouldEmitInvalidEscapeError) {
	      const start2 = pos;
	      pos++;
	      if (pos >= end) {
	        error2(Diagnostics.Unexpected_end_of_text);
	        return "";
	      }
	      const ch = text.charCodeAt(pos);
	      pos++;
	      switch (ch) {
	        case 48 /* _0 */:
	          if (pos >= end || !isDigit(text.charCodeAt(pos))) {
	            return "\0";
	          }
	        case 49 /* _1 */:
	        case 50 /* _2 */:
	        case 51 /* _3 */:
	          if (pos < end && isOctalDigit(text.charCodeAt(pos))) {
	            pos++;
	          }
	        case 52 /* _4 */:
	        case 53 /* _5 */:
	        case 54 /* _6 */:
	        case 55 /* _7 */:
	          if (pos < end && isOctalDigit(text.charCodeAt(pos))) {
	            pos++;
	          }
	          tokenFlags |= 2048 /* ContainsInvalidEscape */;
	          if (shouldEmitInvalidEscapeError) {
	            const code = parseInt(text.substring(start2 + 1, pos), 8);
	            error2(Diagnostics.Octal_escape_sequences_are_not_allowed_Use_the_syntax_0, start2, pos - start2, "\\x" + code.toString(16).padStart(2, "0"));
	            return String.fromCharCode(code);
	          }
	          return text.substring(start2, pos);
	        case 56 /* _8 */:
	        case 57 /* _9 */:
	          tokenFlags |= 2048 /* ContainsInvalidEscape */;
	          if (shouldEmitInvalidEscapeError) {
	            error2(Diagnostics.Escape_sequence_0_is_not_allowed, start2, pos - start2, text.substring(start2, pos));
	            return String.fromCharCode(ch);
	          }
	          return text.substring(start2, pos);
	        case 98 /* b */:
	          return "\b";
	        case 116 /* t */:
	          return "	";
	        case 110 /* n */:
	          return "\n";
	        case 118 /* v */:
	          return "\v";
	        case 102 /* f */:
	          return "\f";
	        case 114 /* r */:
	          return "\r";
	        case 39 /* singleQuote */:
	          return "'";
	        case 34 /* doubleQuote */:
	          return '"';
	        case 117 /* u */:
	          if (pos < end && text.charCodeAt(pos) === 123 /* openBrace */) {
	            pos++;
	            const escapedValueString = scanMinimumNumberOfHexDigits(
	              1,
	              /*canHaveSeparators*/
	              false
	            );
	            const escapedValue = escapedValueString ? parseInt(escapedValueString, 16) : -1;
	            if (escapedValue < 0) {
	              tokenFlags |= 2048 /* ContainsInvalidEscape */;
	              if (shouldEmitInvalidEscapeError) {
	                error2(Diagnostics.Hexadecimal_digit_expected);
	              }
	              return text.substring(start2, pos);
	            }
	            if (!isCodePoint(escapedValue)) {
	              tokenFlags |= 2048 /* ContainsInvalidEscape */;
	              if (shouldEmitInvalidEscapeError) {
	                error2(Diagnostics.An_extended_Unicode_escape_value_must_be_between_0x0_and_0x10FFFF_inclusive);
	              }
	              return text.substring(start2, pos);
	            }
	            if (pos >= end) {
	              tokenFlags |= 2048 /* ContainsInvalidEscape */;
	              if (shouldEmitInvalidEscapeError) {
	                error2(Diagnostics.Unexpected_end_of_text);
	              }
	              return text.substring(start2, pos);
	            }
	            if (text.charCodeAt(pos) !== 125 /* closeBrace */) {
	              tokenFlags |= 2048 /* ContainsInvalidEscape */;
	              if (shouldEmitInvalidEscapeError) {
	                error2(Diagnostics.Unterminated_Unicode_escape_sequence);
	              }
	              return text.substring(start2, pos);
	            }
	            pos++;
	            tokenFlags |= 8 /* ExtendedUnicodeEscape */;
	            return utf16EncodeAsString(escapedValue);
	          }
	          for (; pos < start2 + 6; pos++) {
	            if (!(pos < end && isHexDigit(text.charCodeAt(pos)))) {
	              tokenFlags |= 2048 /* ContainsInvalidEscape */;
	              if (shouldEmitInvalidEscapeError) {
	                error2(Diagnostics.Hexadecimal_digit_expected);
	              }
	              return text.substring(start2, pos);
	            }
	          }
	          tokenFlags |= 1024 /* UnicodeEscape */;
	          return String.fromCharCode(parseInt(text.substring(start2 + 2, pos), 16));
	        case 120 /* x */:
	          for (; pos < start2 + 4; pos++) {
	            if (!(pos < end && isHexDigit(text.charCodeAt(pos)))) {
	              tokenFlags |= 2048 /* ContainsInvalidEscape */;
	              if (shouldEmitInvalidEscapeError) {
	                error2(Diagnostics.Hexadecimal_digit_expected);
	              }
	              return text.substring(start2, pos);
	            }
	          }
	          tokenFlags |= 4096 /* HexEscape */;
	          return String.fromCharCode(parseInt(text.substring(start2 + 2, pos), 16));
	        case 13 /* carriageReturn */:
	          if (pos < end && text.charCodeAt(pos) === 10 /* lineFeed */) {
	            pos++;
	          }
	        case 10 /* lineFeed */:
	        case 8232 /* lineSeparator */:
	        case 8233 /* paragraphSeparator */:
	          return "";
	        default:
	          return String.fromCharCode(ch);
	      }
	    }
	    function scanExtendedUnicodeEscape() {
	      const escapedValueString = scanMinimumNumberOfHexDigits(
	        1,
	        /*canHaveSeparators*/
	        false
	      );
	      const escapedValue = escapedValueString ? parseInt(escapedValueString, 16) : -1;
	      let isInvalidExtendedEscape = false;
	      if (escapedValue < 0) {
	        error2(Diagnostics.Hexadecimal_digit_expected);
	        isInvalidExtendedEscape = true;
	      } else if (escapedValue > 1114111) {
	        error2(Diagnostics.An_extended_Unicode_escape_value_must_be_between_0x0_and_0x10FFFF_inclusive);
	        isInvalidExtendedEscape = true;
	      }
	      if (pos >= end) {
	        error2(Diagnostics.Unexpected_end_of_text);
	        isInvalidExtendedEscape = true;
	      } else if (text.charCodeAt(pos) === 125 /* closeBrace */) {
	        pos++;
	      } else {
	        error2(Diagnostics.Unterminated_Unicode_escape_sequence);
	        isInvalidExtendedEscape = true;
	      }
	      if (isInvalidExtendedEscape) {
	        return "";
	      }
	      return utf16EncodeAsString(escapedValue);
	    }
	    function peekUnicodeEscape() {
	      if (pos + 5 < end && text.charCodeAt(pos + 1) === 117 /* u */) {
	        const start2 = pos;
	        pos += 2;
	        const value = scanExactNumberOfHexDigits(
	          4,
	          /*canHaveSeparators*/
	          false
	        );
	        pos = start2;
	        return value;
	      }
	      return -1;
	    }
	    function peekExtendedUnicodeEscape() {
	      if (codePointAt(text, pos + 1) === 117 /* u */ && codePointAt(text, pos + 2) === 123 /* openBrace */) {
	        const start2 = pos;
	        pos += 3;
	        const escapedValueString = scanMinimumNumberOfHexDigits(
	          1,
	          /*canHaveSeparators*/
	          false
	        );
	        const escapedValue = escapedValueString ? parseInt(escapedValueString, 16) : -1;
	        pos = start2;
	        return escapedValue;
	      }
	      return -1;
	    }
	    function scanIdentifierParts() {
	      let result = "";
	      let start2 = pos;
	      while (pos < end) {
	        let ch = codePointAt(text, pos);
	        if (isIdentifierPart(ch, languageVersion)) {
	          pos += charSize(ch);
	        } else if (ch === 92 /* backslash */) {
	          ch = peekExtendedUnicodeEscape();
	          if (ch >= 0 && isIdentifierPart(ch, languageVersion)) {
	            pos += 3;
	            tokenFlags |= 8 /* ExtendedUnicodeEscape */;
	            result += scanExtendedUnicodeEscape();
	            start2 = pos;
	            continue;
	          }
	          ch = peekUnicodeEscape();
	          if (!(ch >= 0 && isIdentifierPart(ch, languageVersion))) {
	            break;
	          }
	          tokenFlags |= 1024 /* UnicodeEscape */;
	          result += text.substring(start2, pos);
	          result += utf16EncodeAsString(ch);
	          pos += 6;
	          start2 = pos;
	        } else {
	          break;
	        }
	      }
	      result += text.substring(start2, pos);
	      return result;
	    }
	    function getIdentifierToken() {
	      const len = tokenValue.length;
	      if (len >= 2 && len <= 12) {
	        const ch = tokenValue.charCodeAt(0);
	        if (ch >= 97 /* a */ && ch <= 122 /* z */) {
	          const keyword = textToKeyword.get(tokenValue);
	          if (keyword !== void 0) {
	            return token = keyword;
	          }
	        }
	      }
	      return token = 80 /* Identifier */;
	    }
	    function scanBinaryOrOctalDigits(base) {
	      let value = "";
	      let separatorAllowed = false;
	      let isPreviousTokenSeparator = false;
	      while (true) {
	        const ch = text.charCodeAt(pos);
	        if (ch === 95 /* _ */) {
	          tokenFlags |= 512 /* ContainsSeparator */;
	          if (separatorAllowed) {
	            separatorAllowed = false;
	            isPreviousTokenSeparator = true;
	          } else if (isPreviousTokenSeparator) {
	            error2(Diagnostics.Multiple_consecutive_numeric_separators_are_not_permitted, pos, 1);
	          } else {
	            error2(Diagnostics.Numeric_separators_are_not_allowed_here, pos, 1);
	          }
	          pos++;
	          continue;
	        }
	        separatorAllowed = true;
	        if (!isDigit(ch) || ch - 48 /* _0 */ >= base) {
	          break;
	        }
	        value += text[pos];
	        pos++;
	        isPreviousTokenSeparator = false;
	      }
	      if (text.charCodeAt(pos - 1) === 95 /* _ */) {
	        error2(Diagnostics.Numeric_separators_are_not_allowed_here, pos - 1, 1);
	      }
	      return value;
	    }
	    function checkBigIntSuffix() {
	      if (text.charCodeAt(pos) === 110 /* n */) {
	        tokenValue += "n";
	        if (tokenFlags & 384 /* BinaryOrOctalSpecifier */) {
	          tokenValue = parsePseudoBigInt(tokenValue) + "n";
	        }
	        pos++;
	        return 10 /* BigIntLiteral */;
	      } else {
	        const numericValue = tokenFlags & 128 /* BinarySpecifier */ ? parseInt(tokenValue.slice(2), 2) : tokenFlags & 256 /* OctalSpecifier */ ? parseInt(tokenValue.slice(2), 8) : +tokenValue;
	        tokenValue = "" + numericValue;
	        return 9 /* NumericLiteral */;
	      }
	    }
	    function scan() {
	      fullStartPos = pos;
	      tokenFlags = 0 /* None */;
	      let asteriskSeen = false;
	      while (true) {
	        tokenStart = pos;
	        if (pos >= end) {
	          return token = 1 /* EndOfFileToken */;
	        }
	        const ch = codePointAt(text, pos);
	        if (pos === 0) {
	          if (text.slice(0, 256).includes("\uFFFD")) {
	            error2(Diagnostics.File_appears_to_be_binary);
	            pos = end;
	            return token = 8 /* NonTextFileMarkerTrivia */;
	          }
	          if (ch === 35 /* hash */ && isShebangTrivia(text, pos)) {
	            pos = scanShebangTrivia(text, pos);
	            if (skipTrivia2) {
	              continue;
	            } else {
	              return token = 6 /* ShebangTrivia */;
	            }
	          }
	        }
	        switch (ch) {
	          case 10 /* lineFeed */:
	          case 13 /* carriageReturn */:
	            tokenFlags |= 1 /* PrecedingLineBreak */;
	            if (skipTrivia2) {
	              pos++;
	              continue;
	            } else {
	              if (ch === 13 /* carriageReturn */ && pos + 1 < end && text.charCodeAt(pos + 1) === 10 /* lineFeed */) {
	                pos += 2;
	              } else {
	                pos++;
	              }
	              return token = 4 /* NewLineTrivia */;
	            }
	          case 9 /* tab */:
	          case 11 /* verticalTab */:
	          case 12 /* formFeed */:
	          case 32 /* space */:
	          case 160 /* nonBreakingSpace */:
	          case 5760 /* ogham */:
	          case 8192 /* enQuad */:
	          case 8193 /* emQuad */:
	          case 8194 /* enSpace */:
	          case 8195 /* emSpace */:
	          case 8196 /* threePerEmSpace */:
	          case 8197 /* fourPerEmSpace */:
	          case 8198 /* sixPerEmSpace */:
	          case 8199 /* figureSpace */:
	          case 8200 /* punctuationSpace */:
	          case 8201 /* thinSpace */:
	          case 8202 /* hairSpace */:
	          case 8203 /* zeroWidthSpace */:
	          case 8239 /* narrowNoBreakSpace */:
	          case 8287 /* mathematicalSpace */:
	          case 12288 /* ideographicSpace */:
	          case 65279 /* byteOrderMark */:
	            if (skipTrivia2) {
	              pos++;
	              continue;
	            } else {
	              while (pos < end && isWhiteSpaceSingleLine(text.charCodeAt(pos))) {
	                pos++;
	              }
	              return token = 5 /* WhitespaceTrivia */;
	            }
	          case 33 /* exclamation */:
	            if (text.charCodeAt(pos + 1) === 61 /* equals */) {
	              if (text.charCodeAt(pos + 2) === 61 /* equals */) {
	                return pos += 3, token = 38 /* ExclamationEqualsEqualsToken */;
	              }
	              return pos += 2, token = 36 /* ExclamationEqualsToken */;
	            }
	            pos++;
	            return token = 54 /* ExclamationToken */;
	          case 34 /* doubleQuote */:
	          case 39 /* singleQuote */:
	            tokenValue = scanString();
	            return token = 11 /* StringLiteral */;
	          case 96 /* backtick */:
	            return token = scanTemplateAndSetTokenValue(
	              /*shouldEmitInvalidEscapeError*/
	              false
	            );
	          case 37 /* percent */:
	            if (text.charCodeAt(pos + 1) === 61 /* equals */) {
	              return pos += 2, token = 70 /* PercentEqualsToken */;
	            }
	            pos++;
	            return token = 45 /* PercentToken */;
	          case 38 /* ampersand */:
	            if (text.charCodeAt(pos + 1) === 38 /* ampersand */) {
	              if (text.charCodeAt(pos + 2) === 61 /* equals */) {
	                return pos += 3, token = 77 /* AmpersandAmpersandEqualsToken */;
	              }
	              return pos += 2, token = 56 /* AmpersandAmpersandToken */;
	            }
	            if (text.charCodeAt(pos + 1) === 61 /* equals */) {
	              return pos += 2, token = 74 /* AmpersandEqualsToken */;
	            }
	            pos++;
	            return token = 51 /* AmpersandToken */;
	          case 40 /* openParen */:
	            pos++;
	            return token = 21 /* OpenParenToken */;
	          case 41 /* closeParen */:
	            pos++;
	            return token = 22 /* CloseParenToken */;
	          case 42 /* asterisk */:
	            if (text.charCodeAt(pos + 1) === 61 /* equals */) {
	              return pos += 2, token = 67 /* AsteriskEqualsToken */;
	            }
	            if (text.charCodeAt(pos + 1) === 42 /* asterisk */) {
	              if (text.charCodeAt(pos + 2) === 61 /* equals */) {
	                return pos += 3, token = 68 /* AsteriskAsteriskEqualsToken */;
	              }
	              return pos += 2, token = 43 /* AsteriskAsteriskToken */;
	            }
	            pos++;
	            if (inJSDocType && !asteriskSeen && tokenFlags & 1 /* PrecedingLineBreak */) {
	              asteriskSeen = true;
	              continue;
	            }
	            return token = 42 /* AsteriskToken */;
	          case 43 /* plus */:
	            if (text.charCodeAt(pos + 1) === 43 /* plus */) {
	              return pos += 2, token = 46 /* PlusPlusToken */;
	            }
	            if (text.charCodeAt(pos + 1) === 61 /* equals */) {
	              return pos += 2, token = 65 /* PlusEqualsToken */;
	            }
	            pos++;
	            return token = 40 /* PlusToken */;
	          case 44 /* comma */:
	            pos++;
	            return token = 28 /* CommaToken */;
	          case 45 /* minus */:
	            if (text.charCodeAt(pos + 1) === 45 /* minus */) {
	              return pos += 2, token = 47 /* MinusMinusToken */;
	            }
	            if (text.charCodeAt(pos + 1) === 61 /* equals */) {
	              return pos += 2, token = 66 /* MinusEqualsToken */;
	            }
	            pos++;
	            return token = 41 /* MinusToken */;
	          case 46 /* dot */:
	            if (isDigit(text.charCodeAt(pos + 1))) {
	              scanNumber();
	              return token = 9 /* NumericLiteral */;
	            }
	            if (text.charCodeAt(pos + 1) === 46 /* dot */ && text.charCodeAt(pos + 2) === 46 /* dot */) {
	              return pos += 3, token = 26 /* DotDotDotToken */;
	            }
	            pos++;
	            return token = 25 /* DotToken */;
	          case 47 /* slash */:
	            if (text.charCodeAt(pos + 1) === 47 /* slash */) {
	              pos += 2;
	              while (pos < end) {
	                if (isLineBreak(text.charCodeAt(pos))) {
	                  break;
	                }
	                pos++;
	              }
	              commentDirectives = appendIfCommentDirective(
	                commentDirectives,
	                text.slice(tokenStart, pos),
	                commentDirectiveRegExSingleLine,
	                tokenStart
	              );
	              if (skipTrivia2) {
	                continue;
	              } else {
	                return token = 2 /* SingleLineCommentTrivia */;
	              }
	            }
	            if (text.charCodeAt(pos + 1) === 42 /* asterisk */) {
	              pos += 2;
	              const isJSDoc2 = text.charCodeAt(pos) === 42 /* asterisk */ && text.charCodeAt(pos + 1) !== 47 /* slash */;
	              let commentClosed = false;
	              let lastLineStart = tokenStart;
	              while (pos < end) {
	                const ch2 = text.charCodeAt(pos);
	                if (ch2 === 42 /* asterisk */ && text.charCodeAt(pos + 1) === 47 /* slash */) {
	                  pos += 2;
	                  commentClosed = true;
	                  break;
	                }
	                pos++;
	                if (isLineBreak(ch2)) {
	                  lastLineStart = pos;
	                  tokenFlags |= 1 /* PrecedingLineBreak */;
	                }
	              }
	              if (isJSDoc2 && shouldParseJSDoc()) {
	                tokenFlags |= 2 /* PrecedingJSDocComment */;
	              }
	              commentDirectives = appendIfCommentDirective(commentDirectives, text.slice(lastLineStart, pos), commentDirectiveRegExMultiLine, lastLineStart);
	              if (!commentClosed) {
	                error2(Diagnostics.Asterisk_Slash_expected);
	              }
	              if (skipTrivia2) {
	                continue;
	              } else {
	                if (!commentClosed) {
	                  tokenFlags |= 4 /* Unterminated */;
	                }
	                return token = 3 /* MultiLineCommentTrivia */;
	              }
	            }
	            if (text.charCodeAt(pos + 1) === 61 /* equals */) {
	              return pos += 2, token = 69 /* SlashEqualsToken */;
	            }
	            pos++;
	            return token = 44 /* SlashToken */;
	          case 48 /* _0 */:
	            if (pos + 2 < end && (text.charCodeAt(pos + 1) === 88 /* X */ || text.charCodeAt(pos + 1) === 120 /* x */)) {
	              pos += 2;
	              tokenValue = scanMinimumNumberOfHexDigits(
	                1,
	                /*canHaveSeparators*/
	                true
	              );
	              if (!tokenValue) {
	                error2(Diagnostics.Hexadecimal_digit_expected);
	                tokenValue = "0";
	              }
	              tokenValue = "0x" + tokenValue;
	              tokenFlags |= 64 /* HexSpecifier */;
	              return token = checkBigIntSuffix();
	            } else if (pos + 2 < end && (text.charCodeAt(pos + 1) === 66 /* B */ || text.charCodeAt(pos + 1) === 98 /* b */)) {
	              pos += 2;
	              tokenValue = scanBinaryOrOctalDigits(
	                /* base */
	                2
	              );
	              if (!tokenValue) {
	                error2(Diagnostics.Binary_digit_expected);
	                tokenValue = "0";
	              }
	              tokenValue = "0b" + tokenValue;
	              tokenFlags |= 128 /* BinarySpecifier */;
	              return token = checkBigIntSuffix();
	            } else if (pos + 2 < end && (text.charCodeAt(pos + 1) === 79 /* O */ || text.charCodeAt(pos + 1) === 111 /* o */)) {
	              pos += 2;
	              tokenValue = scanBinaryOrOctalDigits(
	                /* base */
	                8
	              );
	              if (!tokenValue) {
	                error2(Diagnostics.Octal_digit_expected);
	                tokenValue = "0";
	              }
	              tokenValue = "0o" + tokenValue;
	              tokenFlags |= 256 /* OctalSpecifier */;
	              return token = checkBigIntSuffix();
	            }
	          case 49 /* _1 */:
	          case 50 /* _2 */:
	          case 51 /* _3 */:
	          case 52 /* _4 */:
	          case 53 /* _5 */:
	          case 54 /* _6 */:
	          case 55 /* _7 */:
	          case 56 /* _8 */:
	          case 57 /* _9 */:
	            return token = scanNumber();
	          case 58 /* colon */:
	            pos++;
	            return token = 59 /* ColonToken */;
	          case 59 /* semicolon */:
	            pos++;
	            return token = 27 /* SemicolonToken */;
	          case 60 /* lessThan */:
	            if (isConflictMarkerTrivia(text, pos)) {
	              pos = scanConflictMarkerTrivia(text, pos, error2);
	              if (skipTrivia2) {
	                continue;
	              } else {
	                return token = 7 /* ConflictMarkerTrivia */;
	              }
	            }
	            if (text.charCodeAt(pos + 1) === 60 /* lessThan */) {
	              if (text.charCodeAt(pos + 2) === 61 /* equals */) {
	                return pos += 3, token = 71 /* LessThanLessThanEqualsToken */;
	              }
	              return pos += 2, token = 48 /* LessThanLessThanToken */;
	            }
	            if (text.charCodeAt(pos + 1) === 61 /* equals */) {
	              return pos += 2, token = 33 /* LessThanEqualsToken */;
	            }
	            if (languageVariant === 1 /* JSX */ && text.charCodeAt(pos + 1) === 47 /* slash */ && text.charCodeAt(pos + 2) !== 42 /* asterisk */) {
	              return pos += 2, token = 31 /* LessThanSlashToken */;
	            }
	            pos++;
	            return token = 30 /* LessThanToken */;
	          case 61 /* equals */:
	            if (isConflictMarkerTrivia(text, pos)) {
	              pos = scanConflictMarkerTrivia(text, pos, error2);
	              if (skipTrivia2) {
	                continue;
	              } else {
	                return token = 7 /* ConflictMarkerTrivia */;
	              }
	            }
	            if (text.charCodeAt(pos + 1) === 61 /* equals */) {
	              if (text.charCodeAt(pos + 2) === 61 /* equals */) {
	                return pos += 3, token = 37 /* EqualsEqualsEqualsToken */;
	              }
	              return pos += 2, token = 35 /* EqualsEqualsToken */;
	            }
	            if (text.charCodeAt(pos + 1) === 62 /* greaterThan */) {
	              return pos += 2, token = 39 /* EqualsGreaterThanToken */;
	            }
	            pos++;
	            return token = 64 /* EqualsToken */;
	          case 62 /* greaterThan */:
	            if (isConflictMarkerTrivia(text, pos)) {
	              pos = scanConflictMarkerTrivia(text, pos, error2);
	              if (skipTrivia2) {
	                continue;
	              } else {
	                return token = 7 /* ConflictMarkerTrivia */;
	              }
	            }
	            pos++;
	            return token = 32 /* GreaterThanToken */;
	          case 63 /* question */:
	            if (text.charCodeAt(pos + 1) === 46 /* dot */ && !isDigit(text.charCodeAt(pos + 2))) {
	              return pos += 2, token = 29 /* QuestionDotToken */;
	            }
	            if (text.charCodeAt(pos + 1) === 63 /* question */) {
	              if (text.charCodeAt(pos + 2) === 61 /* equals */) {
	                return pos += 3, token = 78 /* QuestionQuestionEqualsToken */;
	              }
	              return pos += 2, token = 61 /* QuestionQuestionToken */;
	            }
	            pos++;
	            return token = 58 /* QuestionToken */;
	          case 91 /* openBracket */:
	            pos++;
	            return token = 23 /* OpenBracketToken */;
	          case 93 /* closeBracket */:
	            pos++;
	            return token = 24 /* CloseBracketToken */;
	          case 94 /* caret */:
	            if (text.charCodeAt(pos + 1) === 61 /* equals */) {
	              return pos += 2, token = 79 /* CaretEqualsToken */;
	            }
	            pos++;
	            return token = 53 /* CaretToken */;
	          case 123 /* openBrace */:
	            pos++;
	            return token = 19 /* OpenBraceToken */;
	          case 124 /* bar */:
	            if (isConflictMarkerTrivia(text, pos)) {
	              pos = scanConflictMarkerTrivia(text, pos, error2);
	              if (skipTrivia2) {
	                continue;
	              } else {
	                return token = 7 /* ConflictMarkerTrivia */;
	              }
	            }
	            if (text.charCodeAt(pos + 1) === 124 /* bar */) {
	              if (text.charCodeAt(pos + 2) === 61 /* equals */) {
	                return pos += 3, token = 76 /* BarBarEqualsToken */;
	              }
	              return pos += 2, token = 57 /* BarBarToken */;
	            }
	            if (text.charCodeAt(pos + 1) === 61 /* equals */) {
	              return pos += 2, token = 75 /* BarEqualsToken */;
	            }
	            pos++;
	            return token = 52 /* BarToken */;
	          case 125 /* closeBrace */:
	            pos++;
	            return token = 20 /* CloseBraceToken */;
	          case 126 /* tilde */:
	            pos++;
	            return token = 55 /* TildeToken */;
	          case 64 /* at */:
	            pos++;
	            return token = 60 /* AtToken */;
	          case 92 /* backslash */:
	            const extendedCookedChar = peekExtendedUnicodeEscape();
	            if (extendedCookedChar >= 0 && isIdentifierStart(extendedCookedChar, languageVersion)) {
	              pos += 3;
	              tokenFlags |= 8 /* ExtendedUnicodeEscape */;
	              tokenValue = scanExtendedUnicodeEscape() + scanIdentifierParts();
	              return token = getIdentifierToken();
	            }
	            const cookedChar = peekUnicodeEscape();
	            if (cookedChar >= 0 && isIdentifierStart(cookedChar, languageVersion)) {
	              pos += 6;
	              tokenFlags |= 1024 /* UnicodeEscape */;
	              tokenValue = String.fromCharCode(cookedChar) + scanIdentifierParts();
	              return token = getIdentifierToken();
	            }
	            error2(Diagnostics.Invalid_character);
	            pos++;
	            return token = 0 /* Unknown */;
	          case 35 /* hash */:
	            if (pos !== 0 && text[pos + 1] === "!") {
	              error2(Diagnostics.can_only_be_used_at_the_start_of_a_file);
	              pos++;
	              return token = 0 /* Unknown */;
	            }
	            const charAfterHash = codePointAt(text, pos + 1);
	            if (charAfterHash === 92 /* backslash */) {
	              pos++;
	              const extendedCookedChar2 = peekExtendedUnicodeEscape();
	              if (extendedCookedChar2 >= 0 && isIdentifierStart(extendedCookedChar2, languageVersion)) {
	                pos += 3;
	                tokenFlags |= 8 /* ExtendedUnicodeEscape */;
	                tokenValue = "#" + scanExtendedUnicodeEscape() + scanIdentifierParts();
	                return token = 81 /* PrivateIdentifier */;
	              }
	              const cookedChar2 = peekUnicodeEscape();
	              if (cookedChar2 >= 0 && isIdentifierStart(cookedChar2, languageVersion)) {
	                pos += 6;
	                tokenFlags |= 1024 /* UnicodeEscape */;
	                tokenValue = "#" + String.fromCharCode(cookedChar2) + scanIdentifierParts();
	                return token = 81 /* PrivateIdentifier */;
	              }
	              pos--;
	            }
	            if (isIdentifierStart(charAfterHash, languageVersion)) {
	              pos++;
	              scanIdentifier(charAfterHash, languageVersion);
	            } else {
	              tokenValue = "#";
	              error2(Diagnostics.Invalid_character, pos++, charSize(ch));
	            }
	            return token = 81 /* PrivateIdentifier */;
	          default:
	            const identifierKind = scanIdentifier(ch, languageVersion);
	            if (identifierKind) {
	              return token = identifierKind;
	            } else if (isWhiteSpaceSingleLine(ch)) {
	              pos += charSize(ch);
	              continue;
	            } else if (isLineBreak(ch)) {
	              tokenFlags |= 1 /* PrecedingLineBreak */;
	              pos += charSize(ch);
	              continue;
	            }
	            const size = charSize(ch);
	            error2(Diagnostics.Invalid_character, pos, size);
	            pos += size;
	            return token = 0 /* Unknown */;
	        }
	      }
	    }
	    function shouldParseJSDoc() {
	      switch (jsDocParsingMode) {
	        case 0 /* ParseAll */:
	          return true;
	        case 1 /* ParseNone */:
	          return false;
	      }
	      if (scriptKind !== 3 /* TS */ && scriptKind !== 4 /* TSX */) {
	        return true;
	      }
	      if (jsDocParsingMode === 3 /* ParseForTypeInfo */) {
	        return false;
	      }
	      return jsDocSeeOrLink.test(text.slice(fullStartPos, pos));
	    }
	    function reScanInvalidIdentifier() {
	      Debug.assert(token === 0 /* Unknown */, "'reScanInvalidIdentifier' should only be called when the current token is 'SyntaxKind.Unknown'.");
	      pos = tokenStart = fullStartPos;
	      tokenFlags = 0;
	      const ch = codePointAt(text, pos);
	      const identifierKind = scanIdentifier(ch, 99 /* ESNext */);
	      if (identifierKind) {
	        return token = identifierKind;
	      }
	      pos += charSize(ch);
	      return token;
	    }
	    function scanIdentifier(startCharacter, languageVersion2) {
	      let ch = startCharacter;
	      if (isIdentifierStart(ch, languageVersion2)) {
	        pos += charSize(ch);
	        while (pos < end && isIdentifierPart(ch = codePointAt(text, pos), languageVersion2))
	          pos += charSize(ch);
	        tokenValue = text.substring(tokenStart, pos);
	        if (ch === 92 /* backslash */) {
	          tokenValue += scanIdentifierParts();
	        }
	        return getIdentifierToken();
	      }
	    }
	    function reScanGreaterToken() {
	      if (token === 32 /* GreaterThanToken */) {
	        if (text.charCodeAt(pos) === 62 /* greaterThan */) {
	          if (text.charCodeAt(pos + 1) === 62 /* greaterThan */) {
	            if (text.charCodeAt(pos + 2) === 61 /* equals */) {
	              return pos += 3, token = 73 /* GreaterThanGreaterThanGreaterThanEqualsToken */;
	            }
	            return pos += 2, token = 50 /* GreaterThanGreaterThanGreaterThanToken */;
	          }
	          if (text.charCodeAt(pos + 1) === 61 /* equals */) {
	            return pos += 2, token = 72 /* GreaterThanGreaterThanEqualsToken */;
	          }
	          pos++;
	          return token = 49 /* GreaterThanGreaterThanToken */;
	        }
	        if (text.charCodeAt(pos) === 61 /* equals */) {
	          pos++;
	          return token = 34 /* GreaterThanEqualsToken */;
	        }
	      }
	      return token;
	    }
	    function reScanAsteriskEqualsToken() {
	      Debug.assert(token === 67 /* AsteriskEqualsToken */, "'reScanAsteriskEqualsToken' should only be called on a '*='");
	      pos = tokenStart + 1;
	      return token = 64 /* EqualsToken */;
	    }
	    function reScanSlashToken() {
	      if (token === 44 /* SlashToken */ || token === 69 /* SlashEqualsToken */) {
	        let p = tokenStart + 1;
	        let inEscape = false;
	        let inCharacterClass = false;
	        while (true) {
	          if (p >= end) {
	            tokenFlags |= 4 /* Unterminated */;
	            error2(Diagnostics.Unterminated_regular_expression_literal);
	            break;
	          }
	          const ch = text.charCodeAt(p);
	          if (isLineBreak(ch)) {
	            tokenFlags |= 4 /* Unterminated */;
	            error2(Diagnostics.Unterminated_regular_expression_literal);
	            break;
	          }
	          if (inEscape) {
	            inEscape = false;
	          } else if (ch === 47 /* slash */ && !inCharacterClass) {
	            p++;
	            break;
	          } else if (ch === 91 /* openBracket */) {
	            inCharacterClass = true;
	          } else if (ch === 92 /* backslash */) {
	            inEscape = true;
	          } else if (ch === 93 /* closeBracket */) {
	            inCharacterClass = false;
	          }
	          p++;
	        }
	        while (p < end && isIdentifierPart(text.charCodeAt(p), languageVersion)) {
	          p++;
	        }
	        pos = p;
	        tokenValue = text.substring(tokenStart, pos);
	        token = 14 /* RegularExpressionLiteral */;
	      }
	      return token;
	    }
	    function appendIfCommentDirective(commentDirectives2, text2, commentDirectiveRegEx, lineStart) {
	      const type = getDirectiveFromComment(text2.trimStart(), commentDirectiveRegEx);
	      if (type === void 0) {
	        return commentDirectives2;
	      }
	      return append(
	        commentDirectives2,
	        {
	          range: { pos: lineStart, end: pos },
	          type
	        }
	      );
	    }
	    function getDirectiveFromComment(text2, commentDirectiveRegEx) {
	      const match = commentDirectiveRegEx.exec(text2);
	      if (!match) {
	        return void 0;
	      }
	      switch (match[1]) {
	        case "ts-expect-error":
	          return 0 /* ExpectError */;
	        case "ts-ignore":
	          return 1 /* Ignore */;
	      }
	      return void 0;
	    }
	    function reScanTemplateToken(isTaggedTemplate) {
	      pos = tokenStart;
	      return token = scanTemplateAndSetTokenValue(!isTaggedTemplate);
	    }
	    function reScanTemplateHeadOrNoSubstitutionTemplate() {
	      pos = tokenStart;
	      return token = scanTemplateAndSetTokenValue(
	        /*shouldEmitInvalidEscapeError*/
	        true
	      );
	    }
	    function reScanJsxToken(allowMultilineJsxText = true) {
	      pos = tokenStart = fullStartPos;
	      return token = scanJsxToken(allowMultilineJsxText);
	    }
	    function reScanLessThanToken() {
	      if (token === 48 /* LessThanLessThanToken */) {
	        pos = tokenStart + 1;
	        return token = 30 /* LessThanToken */;
	      }
	      return token;
	    }
	    function reScanHashToken() {
	      if (token === 81 /* PrivateIdentifier */) {
	        pos = tokenStart + 1;
	        return token = 63 /* HashToken */;
	      }
	      return token;
	    }
	    function reScanQuestionToken() {
	      Debug.assert(token === 61 /* QuestionQuestionToken */, "'reScanQuestionToken' should only be called on a '??'");
	      pos = tokenStart + 1;
	      return token = 58 /* QuestionToken */;
	    }
	    function scanJsxToken(allowMultilineJsxText = true) {
	      fullStartPos = tokenStart = pos;
	      if (pos >= end) {
	        return token = 1 /* EndOfFileToken */;
	      }
	      let char = text.charCodeAt(pos);
	      if (char === 60 /* lessThan */) {
	        if (text.charCodeAt(pos + 1) === 47 /* slash */) {
	          pos += 2;
	          return token = 31 /* LessThanSlashToken */;
	        }
	        pos++;
	        return token = 30 /* LessThanToken */;
	      }
	      if (char === 123 /* openBrace */) {
	        pos++;
	        return token = 19 /* OpenBraceToken */;
	      }
	      let firstNonWhitespace = 0;
	      while (pos < end) {
	        char = text.charCodeAt(pos);
	        if (char === 123 /* openBrace */) {
	          break;
	        }
	        if (char === 60 /* lessThan */) {
	          if (isConflictMarkerTrivia(text, pos)) {
	            pos = scanConflictMarkerTrivia(text, pos, error2);
	            return token = 7 /* ConflictMarkerTrivia */;
	          }
	          break;
	        }
	        if (char === 62 /* greaterThan */) {
	          error2(Diagnostics.Unexpected_token_Did_you_mean_or_gt, pos, 1);
	        }
	        if (char === 125 /* closeBrace */) {
	          error2(Diagnostics.Unexpected_token_Did_you_mean_or_rbrace, pos, 1);
	        }
	        if (isLineBreak(char) && firstNonWhitespace === 0) {
	          firstNonWhitespace = -1;
	        } else if (!allowMultilineJsxText && isLineBreak(char) && firstNonWhitespace > 0) {
	          break;
	        } else if (!isWhiteSpaceLike(char)) {
	          firstNonWhitespace = pos;
	        }
	        pos++;
	      }
	      tokenValue = text.substring(fullStartPos, pos);
	      return firstNonWhitespace === -1 ? 13 /* JsxTextAllWhiteSpaces */ : 12 /* JsxText */;
	    }
	    function scanJsxIdentifier() {
	      if (tokenIsIdentifierOrKeyword(token)) {
	        while (pos < end) {
	          const ch = text.charCodeAt(pos);
	          if (ch === 45 /* minus */) {
	            tokenValue += "-";
	            pos++;
	            continue;
	          }
	          const oldPos = pos;
	          tokenValue += scanIdentifierParts();
	          if (pos === oldPos) {
	            break;
	          }
	        }
	        return getIdentifierToken();
	      }
	      return token;
	    }
	    function scanJsxAttributeValue() {
	      fullStartPos = pos;
	      switch (text.charCodeAt(pos)) {
	        case 34 /* doubleQuote */:
	        case 39 /* singleQuote */:
	          tokenValue = scanString(
	            /*jsxAttributeString*/
	            true
	          );
	          return token = 11 /* StringLiteral */;
	        default:
	          return scan();
	      }
	    }
	    function reScanJsxAttributeValue() {
	      pos = tokenStart = fullStartPos;
	      return scanJsxAttributeValue();
	    }
	    function scanJSDocCommentTextToken(inBackticks) {
	      fullStartPos = tokenStart = pos;
	      tokenFlags = 0 /* None */;
	      if (pos >= end) {
	        return token = 1 /* EndOfFileToken */;
	      }
	      for (let ch = text.charCodeAt(pos); pos < end && (!isLineBreak(ch) && ch !== 96 /* backtick */); ch = codePointAt(text, ++pos)) {
	        if (!inBackticks) {
	          if (ch === 123 /* openBrace */) {
	            break;
	          } else if (ch === 64 /* at */ && pos - 1 >= 0 && isWhiteSpaceSingleLine(text.charCodeAt(pos - 1)) && !(pos + 1 < end && isWhiteSpaceLike(text.charCodeAt(pos + 1)))) {
	            break;
	          }
	        }
	      }
	      if (pos === tokenStart) {
	        return scanJsDocToken();
	      }
	      tokenValue = text.substring(tokenStart, pos);
	      return token = 82 /* JSDocCommentTextToken */;
	    }
	    function scanJsDocToken() {
	      fullStartPos = tokenStart = pos;
	      tokenFlags = 0 /* None */;
	      if (pos >= end) {
	        return token = 1 /* EndOfFileToken */;
	      }
	      const ch = codePointAt(text, pos);
	      pos += charSize(ch);
	      switch (ch) {
	        case 9 /* tab */:
	        case 11 /* verticalTab */:
	        case 12 /* formFeed */:
	        case 32 /* space */:
	          while (pos < end && isWhiteSpaceSingleLine(text.charCodeAt(pos))) {
	            pos++;
	          }
	          return token = 5 /* WhitespaceTrivia */;
	        case 64 /* at */:
	          return token = 60 /* AtToken */;
	        case 13 /* carriageReturn */:
	          if (text.charCodeAt(pos) === 10 /* lineFeed */) {
	            pos++;
	          }
	        case 10 /* lineFeed */:
	          tokenFlags |= 1 /* PrecedingLineBreak */;
	          return token = 4 /* NewLineTrivia */;
	        case 42 /* asterisk */:
	          return token = 42 /* AsteriskToken */;
	        case 123 /* openBrace */:
	          return token = 19 /* OpenBraceToken */;
	        case 125 /* closeBrace */:
	          return token = 20 /* CloseBraceToken */;
	        case 91 /* openBracket */:
	          return token = 23 /* OpenBracketToken */;
	        case 93 /* closeBracket */:
	          return token = 24 /* CloseBracketToken */;
	        case 60 /* lessThan */:
	          return token = 30 /* LessThanToken */;
	        case 62 /* greaterThan */:
	          return token = 32 /* GreaterThanToken */;
	        case 61 /* equals */:
	          return token = 64 /* EqualsToken */;
	        case 44 /* comma */:
	          return token = 28 /* CommaToken */;
	        case 46 /* dot */:
	          return token = 25 /* DotToken */;
	        case 96 /* backtick */:
	          return token = 62 /* BacktickToken */;
	        case 35 /* hash */:
	          return token = 63 /* HashToken */;
	        case 92 /* backslash */:
	          pos--;
	          const extendedCookedChar = peekExtendedUnicodeEscape();
	          if (extendedCookedChar >= 0 && isIdentifierStart(extendedCookedChar, languageVersion)) {
	            pos += 3;
	            tokenFlags |= 8 /* ExtendedUnicodeEscape */;
	            tokenValue = scanExtendedUnicodeEscape() + scanIdentifierParts();
	            return token = getIdentifierToken();
	          }
	          const cookedChar = peekUnicodeEscape();
	          if (cookedChar >= 0 && isIdentifierStart(cookedChar, languageVersion)) {
	            pos += 6;
	            tokenFlags |= 1024 /* UnicodeEscape */;
	            tokenValue = String.fromCharCode(cookedChar) + scanIdentifierParts();
	            return token = getIdentifierToken();
	          }
	          pos++;
	          return token = 0 /* Unknown */;
	      }
	      if (isIdentifierStart(ch, languageVersion)) {
	        let char = ch;
	        while (pos < end && isIdentifierPart(char = codePointAt(text, pos), languageVersion) || text.charCodeAt(pos) === 45 /* minus */)
	          pos += charSize(char);
	        tokenValue = text.substring(tokenStart, pos);
	        if (char === 92 /* backslash */) {
	          tokenValue += scanIdentifierParts();
	        }
	        return token = getIdentifierToken();
	      } else {
	        return token = 0 /* Unknown */;
	      }
	    }
	    function speculationHelper(callback, isLookahead) {
	      const savePos = pos;
	      const saveStartPos = fullStartPos;
	      const saveTokenPos = tokenStart;
	      const saveToken = token;
	      const saveTokenValue = tokenValue;
	      const saveTokenFlags = tokenFlags;
	      const result = callback();
	      if (!result || isLookahead) {
	        pos = savePos;
	        fullStartPos = saveStartPos;
	        tokenStart = saveTokenPos;
	        token = saveToken;
	        tokenValue = saveTokenValue;
	        tokenFlags = saveTokenFlags;
	      }
	      return result;
	    }
	    function scanRange(start2, length3, callback) {
	      const saveEnd = end;
	      const savePos = pos;
	      const saveStartPos = fullStartPos;
	      const saveTokenPos = tokenStart;
	      const saveToken = token;
	      const saveTokenValue = tokenValue;
	      const saveTokenFlags = tokenFlags;
	      const saveErrorExpectations = commentDirectives;
	      setText(text, start2, length3);
	      const result = callback();
	      end = saveEnd;
	      pos = savePos;
	      fullStartPos = saveStartPos;
	      tokenStart = saveTokenPos;
	      token = saveToken;
	      tokenValue = saveTokenValue;
	      tokenFlags = saveTokenFlags;
	      commentDirectives = saveErrorExpectations;
	      return result;
	    }
	    function lookAhead(callback) {
	      return speculationHelper(
	        callback,
	        /*isLookahead*/
	        true
	      );
	    }
	    function tryScan(callback) {
	      return speculationHelper(
	        callback,
	        /*isLookahead*/
	        false
	      );
	    }
	    function getText() {
	      return text;
	    }
	    function clearCommentDirectives() {
	      commentDirectives = void 0;
	    }
	    function setText(newText, start2, length3) {
	      text = newText || "";
	      end = length3 === void 0 ? text.length : start2 + length3;
	      resetTokenState(start2 || 0);
	    }
	    function setOnError(errorCallback) {
	      onError = errorCallback;
	    }
	    function setScriptTarget(scriptTarget) {
	      languageVersion = scriptTarget;
	    }
	    function setLanguageVariant(variant) {
	      languageVariant = variant;
	    }
	    function setScriptKind(kind) {
	      scriptKind = kind;
	    }
	    function setJSDocParsingMode(kind) {
	      jsDocParsingMode = kind;
	    }
	    function resetTokenState(position) {
	      Debug.assert(position >= 0);
	      pos = position;
	      fullStartPos = position;
	      tokenStart = position;
	      token = 0 /* Unknown */;
	      tokenValue = void 0;
	      tokenFlags = 0 /* None */;
	    }
	    function setInJSDocType(inType) {
	      inJSDocType += inType ? 1 : -1;
	    }
	  }
	  function codePointAt(s, i) {
	    return s.codePointAt(i);
	  }
	  function charSize(ch) {
	    if (ch >= 65536) {
	      return 2;
	    }
	    return 1;
	  }
	  function utf16EncodeAsStringFallback(codePoint) {
	    Debug.assert(0 <= codePoint && codePoint <= 1114111);
	    if (codePoint <= 65535) {
	      return String.fromCharCode(codePoint);
	    }
	    const codeUnit1 = Math.floor((codePoint - 65536) / 1024) + 55296;
	    const codeUnit2 = (codePoint - 65536) % 1024 + 56320;
	    return String.fromCharCode(codeUnit1, codeUnit2);
	  }
	  function utf16EncodeAsString(codePoint) {
	    return utf16EncodeAsStringWorker(codePoint);
	  }
	  var textToKeywordObj, textToKeyword, textToToken, unicodeES3IdentifierStart, unicodeES3IdentifierPart, unicodeES5IdentifierStart, unicodeES5IdentifierPart, unicodeESNextIdentifierStart, unicodeESNextIdentifierPart, commentDirectiveRegExSingleLine, commentDirectiveRegExMultiLine, jsDocSeeOrLink, tokenStrings, mergeConflictMarkerLength, shebangTriviaRegex, utf16EncodeAsStringWorker;
	  var init_scanner = __esm({
	    "src/compiler/scanner.ts"() {
	      init_ts2();
	      textToKeywordObj = {
	        abstract: 128 /* AbstractKeyword */,
	        accessor: 129 /* AccessorKeyword */,
	        any: 133 /* AnyKeyword */,
	        as: 130 /* AsKeyword */,
	        asserts: 131 /* AssertsKeyword */,
	        assert: 132 /* AssertKeyword */,
	        bigint: 163 /* BigIntKeyword */,
	        boolean: 136 /* BooleanKeyword */,
	        break: 83 /* BreakKeyword */,
	        case: 84 /* CaseKeyword */,
	        catch: 85 /* CatchKeyword */,
	        class: 86 /* ClassKeyword */,
	        continue: 88 /* ContinueKeyword */,
	        const: 87 /* ConstKeyword */,
	        ["constructor"]: 137 /* ConstructorKeyword */,
	        debugger: 89 /* DebuggerKeyword */,
	        declare: 138 /* DeclareKeyword */,
	        default: 90 /* DefaultKeyword */,
	        delete: 91 /* DeleteKeyword */,
	        do: 92 /* DoKeyword */,
	        else: 93 /* ElseKeyword */,
	        enum: 94 /* EnumKeyword */,
	        export: 95 /* ExportKeyword */,
	        extends: 96 /* ExtendsKeyword */,
	        false: 97 /* FalseKeyword */,
	        finally: 98 /* FinallyKeyword */,
	        for: 99 /* ForKeyword */,
	        from: 161 /* FromKeyword */,
	        function: 100 /* FunctionKeyword */,
	        get: 139 /* GetKeyword */,
	        if: 101 /* IfKeyword */,
	        implements: 119 /* ImplementsKeyword */,
	        import: 102 /* ImportKeyword */,
	        in: 103 /* InKeyword */,
	        infer: 140 /* InferKeyword */,
	        instanceof: 104 /* InstanceOfKeyword */,
	        interface: 120 /* InterfaceKeyword */,
	        intrinsic: 141 /* IntrinsicKeyword */,
	        is: 142 /* IsKeyword */,
	        keyof: 143 /* KeyOfKeyword */,
	        let: 121 /* LetKeyword */,
	        module: 144 /* ModuleKeyword */,
	        namespace: 145 /* NamespaceKeyword */,
	        never: 146 /* NeverKeyword */,
	        new: 105 /* NewKeyword */,
	        null: 106 /* NullKeyword */,
	        number: 150 /* NumberKeyword */,
	        object: 151 /* ObjectKeyword */,
	        package: 122 /* PackageKeyword */,
	        private: 123 /* PrivateKeyword */,
	        protected: 124 /* ProtectedKeyword */,
	        public: 125 /* PublicKeyword */,
	        override: 164 /* OverrideKeyword */,
	        out: 147 /* OutKeyword */,
	        readonly: 148 /* ReadonlyKeyword */,
	        require: 149 /* RequireKeyword */,
	        global: 162 /* GlobalKeyword */,
	        return: 107 /* ReturnKeyword */,
	        satisfies: 152 /* SatisfiesKeyword */,
	        set: 153 /* SetKeyword */,
	        static: 126 /* StaticKeyword */,
	        string: 154 /* StringKeyword */,
	        super: 108 /* SuperKeyword */,
	        switch: 109 /* SwitchKeyword */,
	        symbol: 155 /* SymbolKeyword */,
	        this: 110 /* ThisKeyword */,
	        throw: 111 /* ThrowKeyword */,
	        true: 112 /* TrueKeyword */,
	        try: 113 /* TryKeyword */,
	        type: 156 /* TypeKeyword */,
	        typeof: 114 /* TypeOfKeyword */,
	        undefined: 157 /* UndefinedKeyword */,
	        unique: 158 /* UniqueKeyword */,
	        unknown: 159 /* UnknownKeyword */,
	        using: 160 /* UsingKeyword */,
	        var: 115 /* VarKeyword */,
	        void: 116 /* VoidKeyword */,
	        while: 117 /* WhileKeyword */,
	        with: 118 /* WithKeyword */,
	        yield: 127 /* YieldKeyword */,
	        async: 134 /* AsyncKeyword */,
	        await: 135 /* AwaitKeyword */,
	        of: 165 /* OfKeyword */
	      };
	      textToKeyword = new Map(Object.entries(textToKeywordObj));
	      textToToken = new Map(Object.entries({
	        ...textToKeywordObj,
	        "{": 19 /* OpenBraceToken */,
	        "}": 20 /* CloseBraceToken */,
	        "(": 21 /* OpenParenToken */,
	        ")": 22 /* CloseParenToken */,
	        "[": 23 /* OpenBracketToken */,
	        "]": 24 /* CloseBracketToken */,
	        ".": 25 /* DotToken */,
	        "...": 26 /* DotDotDotToken */,
	        ";": 27 /* SemicolonToken */,
	        ",": 28 /* CommaToken */,
	        "<": 30 /* LessThanToken */,
	        ">": 32 /* GreaterThanToken */,
	        "<=": 33 /* LessThanEqualsToken */,
	        ">=": 34 /* GreaterThanEqualsToken */,
	        "==": 35 /* EqualsEqualsToken */,
	        "!=": 36 /* ExclamationEqualsToken */,
	        "===": 37 /* EqualsEqualsEqualsToken */,
	        "!==": 38 /* ExclamationEqualsEqualsToken */,
	        "=>": 39 /* EqualsGreaterThanToken */,
	        "+": 40 /* PlusToken */,
	        "-": 41 /* MinusToken */,
	        "**": 43 /* AsteriskAsteriskToken */,
	        "*": 42 /* AsteriskToken */,
	        "/": 44 /* SlashToken */,
	        "%": 45 /* PercentToken */,
	        "++": 46 /* PlusPlusToken */,
	        "--": 47 /* MinusMinusToken */,
	        "<<": 48 /* LessThanLessThanToken */,
	        "</": 31 /* LessThanSlashToken */,
	        ">>": 49 /* GreaterThanGreaterThanToken */,
	        ">>>": 50 /* GreaterThanGreaterThanGreaterThanToken */,
	        "&": 51 /* AmpersandToken */,
	        "|": 52 /* BarToken */,
	        "^": 53 /* CaretToken */,
	        "!": 54 /* ExclamationToken */,
	        "~": 55 /* TildeToken */,
	        "&&": 56 /* AmpersandAmpersandToken */,
	        "||": 57 /* BarBarToken */,
	        "?": 58 /* QuestionToken */,
	        "??": 61 /* QuestionQuestionToken */,
	        "?.": 29 /* QuestionDotToken */,
	        ":": 59 /* ColonToken */,
	        "=": 64 /* EqualsToken */,
	        "+=": 65 /* PlusEqualsToken */,
	        "-=": 66 /* MinusEqualsToken */,
	        "*=": 67 /* AsteriskEqualsToken */,
	        "**=": 68 /* AsteriskAsteriskEqualsToken */,
	        "/=": 69 /* SlashEqualsToken */,
	        "%=": 70 /* PercentEqualsToken */,
	        "<<=": 71 /* LessThanLessThanEqualsToken */,
	        ">>=": 72 /* GreaterThanGreaterThanEqualsToken */,
	        ">>>=": 73 /* GreaterThanGreaterThanGreaterThanEqualsToken */,
	        "&=": 74 /* AmpersandEqualsToken */,
	        "|=": 75 /* BarEqualsToken */,
	        "^=": 79 /* CaretEqualsToken */,
	        "||=": 76 /* BarBarEqualsToken */,
	        "&&=": 77 /* AmpersandAmpersandEqualsToken */,
	        "??=": 78 /* QuestionQuestionEqualsToken */,
	        "@": 60 /* AtToken */,
	        "#": 63 /* HashToken */,
	        "`": 62 /* BacktickToken */
	      }));
	      unicodeES3IdentifierStart = [170, 170, 181, 181, 186, 186, 192, 214, 216, 246, 248, 543, 546, 563, 592, 685, 688, 696, 699, 705, 720, 721, 736, 740, 750, 750, 890, 890, 902, 902, 904, 906, 908, 908, 910, 929, 931, 974, 976, 983, 986, 1011, 1024, 1153, 1164, 1220, 1223, 1224, 1227, 1228, 1232, 1269, 1272, 1273, 1329, 1366, 1369, 1369, 1377, 1415, 1488, 1514, 1520, 1522, 1569, 1594, 1600, 1610, 1649, 1747, 1749, 1749, 1765, 1766, 1786, 1788, 1808, 1808, 1810, 1836, 1920, 1957, 2309, 2361, 2365, 2365, 2384, 2384, 2392, 2401, 2437, 2444, 2447, 2448, 2451, 2472, 2474, 2480, 2482, 2482, 2486, 2489, 2524, 2525, 2527, 2529, 2544, 2545, 2565, 2570, 2575, 2576, 2579, 2600, 2602, 2608, 2610, 2611, 2613, 2614, 2616, 2617, 2649, 2652, 2654, 2654, 2674, 2676, 2693, 2699, 2701, 2701, 2703, 2705, 2707, 2728, 2730, 2736, 2738, 2739, 2741, 2745, 2749, 2749, 2768, 2768, 2784, 2784, 2821, 2828, 2831, 2832, 2835, 2856, 2858, 2864, 2866, 2867, 2870, 2873, 2877, 2877, 2908, 2909, 2911, 2913, 2949, 2954, 2958, 2960, 2962, 2965, 2969, 2970, 2972, 2972, 2974, 2975, 2979, 2980, 2984, 2986, 2990, 2997, 2999, 3001, 3077, 3084, 3086, 3088, 3090, 3112, 3114, 3123, 3125, 3129, 3168, 3169, 3205, 3212, 3214, 3216, 3218, 3240, 3242, 3251, 3253, 3257, 3294, 3294, 3296, 3297, 3333, 3340, 3342, 3344, 3346, 3368, 3370, 3385, 3424, 3425, 3461, 3478, 3482, 3505, 3507, 3515, 3517, 3517, 3520, 3526, 3585, 3632, 3634, 3635, 3648, 3654, 3713, 3714, 3716, 3716, 3719, 3720, 3722, 3722, 3725, 3725, 3732, 3735, 3737, 3743, 3745, 3747, 3749, 3749, 3751, 3751, 3754, 3755, 3757, 3760, 3762, 3763, 3773, 3773, 3776, 3780, 3782, 3782, 3804, 3805, 3840, 3840, 3904, 3911, 3913, 3946, 3976, 3979, 4096, 4129, 4131, 4135, 4137, 4138, 4176, 4181, 4256, 4293, 4304, 4342, 4352, 4441, 4447, 4514, 4520, 4601, 4608, 4614, 4616, 4678, 4680, 4680, 4682, 4685, 4688, 4694, 4696, 4696, 4698, 4701, 4704, 4742, 4744, 4744, 4746, 4749, 4752, 4782, 4784, 4784, 4786, 4789, 4792, 4798, 4800, 4800, 4802, 4805, 4808, 4814, 4816, 4822, 4824, 4846, 4848, 4878, 4880, 4880, 4882, 4885, 4888, 4894, 4896, 4934, 4936, 4954, 5024, 5108, 5121, 5740, 5743, 5750, 5761, 5786, 5792, 5866, 6016, 6067, 6176, 6263, 6272, 6312, 7680, 7835, 7840, 7929, 7936, 7957, 7960, 7965, 7968, 8005, 8008, 8013, 8016, 8023, 8025, 8025, 8027, 8027, 8029, 8029, 8031, 8061, 8064, 8116, 8118, 8124, 8126, 8126, 8130, 8132, 8134, 8140, 8144, 8147, 8150, 8155, 8160, 8172, 8178, 8180, 8182, 8188, 8319, 8319, 8450, 8450, 8455, 8455, 8458, 8467, 8469, 8469, 8473, 8477, 8484, 8484, 8486, 8486, 8488, 8488, 8490, 8493, 8495, 8497, 8499, 8505, 8544, 8579, 12293, 12295, 12321, 12329, 12337, 12341, 12344, 12346, 12353, 12436, 12445, 12446, 12449, 12538, 12540, 12542, 12549, 12588, 12593, 12686, 12704, 12727, 13312, 19893, 19968, 40869, 40960, 42124, 44032, 55203, 63744, 64045, 64256, 64262, 64275, 64279, 64285, 64285, 64287, 64296, 64298, 64310, 64312, 64316, 64318, 64318, 64320, 64321, 64323, 64324, 64326, 64433, 64467, 64829, 64848, 64911, 64914, 64967, 65008, 65019, 65136, 65138, 65140, 65140, 65142, 65276, 65313, 65338, 65345, 65370, 65382, 65470, 65474, 65479, 65482, 65487, 65490, 65495, 65498, 65500];
	      unicodeES3IdentifierPart = [170, 170, 181, 181, 186, 186, 192, 214, 216, 246, 248, 543, 546, 563, 592, 685, 688, 696, 699, 705, 720, 721, 736, 740, 750, 750, 768, 846, 864, 866, 890, 890, 902, 902, 904, 906, 908, 908, 910, 929, 931, 974, 976, 983, 986, 1011, 1024, 1153, 1155, 1158, 1164, 1220, 1223, 1224, 1227, 1228, 1232, 1269, 1272, 1273, 1329, 1366, 1369, 1369, 1377, 1415, 1425, 1441, 1443, 1465, 1467, 1469, 1471, 1471, 1473, 1474, 1476, 1476, 1488, 1514, 1520, 1522, 1569, 1594, 1600, 1621, 1632, 1641, 1648, 1747, 1749, 1756, 1759, 1768, 1770, 1773, 1776, 1788, 1808, 1836, 1840, 1866, 1920, 1968, 2305, 2307, 2309, 2361, 2364, 2381, 2384, 2388, 2392, 2403, 2406, 2415, 2433, 2435, 2437, 2444, 2447, 2448, 2451, 2472, 2474, 2480, 2482, 2482, 2486, 2489, 2492, 2492, 2494, 2500, 2503, 2504, 2507, 2509, 2519, 2519, 2524, 2525, 2527, 2531, 2534, 2545, 2562, 2562, 2565, 2570, 2575, 2576, 2579, 2600, 2602, 2608, 2610, 2611, 2613, 2614, 2616, 2617, 2620, 2620, 2622, 2626, 2631, 2632, 2635, 2637, 2649, 2652, 2654, 2654, 2662, 2676, 2689, 2691, 2693, 2699, 2701, 2701, 2703, 2705, 2707, 2728, 2730, 2736, 2738, 2739, 2741, 2745, 2748, 2757, 2759, 2761, 2763, 2765, 2768, 2768, 2784, 2784, 2790, 2799, 2817, 2819, 2821, 2828, 2831, 2832, 2835, 2856, 2858, 2864, 2866, 2867, 2870, 2873, 2876, 2883, 2887, 2888, 2891, 2893, 2902, 2903, 2908, 2909, 2911, 2913, 2918, 2927, 2946, 2947, 2949, 2954, 2958, 2960, 2962, 2965, 2969, 2970, 2972, 2972, 2974, 2975, 2979, 2980, 2984, 2986, 2990, 2997, 2999, 3001, 3006, 3010, 3014, 3016, 3018, 3021, 3031, 3031, 3047, 3055, 3073, 3075, 3077, 3084, 3086, 3088, 3090, 3112, 3114, 3123, 3125, 3129, 3134, 3140, 3142, 3144, 3146, 3149, 3157, 3158, 3168, 3169, 3174, 3183, 3202, 3203, 3205, 3212, 3214, 3216, 3218, 3240, 3242, 3251, 3253, 3257, 3262, 3268, 3270, 3272, 3274, 3277, 3285, 3286, 3294, 3294, 3296, 3297, 3302, 3311, 3330, 3331, 3333, 3340, 3342, 3344, 3346, 3368, 3370, 3385, 3390, 3395, 3398, 3400, 3402, 3405, 3415, 3415, 3424, 3425, 3430, 3439, 3458, 3459, 3461, 3478, 3482, 3505, 3507, 3515, 3517, 3517, 3520, 3526, 3530, 3530, 3535, 3540, 3542, 3542, 3544, 3551, 3570, 3571, 3585, 3642, 3648, 3662, 3664, 3673, 3713, 3714, 3716, 3716, 3719, 3720, 3722, 3722, 3725, 3725, 3732, 3735, 3737, 3743, 3745, 3747, 3749, 3749, 3751, 3751, 3754, 3755, 3757, 3769, 3771, 3773, 3776, 3780, 3782, 3782, 3784, 3789, 3792, 3801, 3804, 3805, 3840, 3840, 3864, 3865, 3872, 3881, 3893, 3893, 3895, 3895, 3897, 3897, 3902, 3911, 3913, 3946, 3953, 3972, 3974, 3979, 3984, 3991, 3993, 4028, 4038, 4038, 4096, 4129, 4131, 4135, 4137, 4138, 4140, 4146, 4150, 4153, 4160, 4169, 4176, 4185, 4256, 4293, 4304, 4342, 4352, 4441, 4447, 4514, 4520, 4601, 4608, 4614, 4616, 4678, 4680, 4680, 4682, 4685, 4688, 4694, 4696, 4696, 4698, 4701, 4704, 4742, 4744, 4744, 4746, 4749, 4752, 4782, 4784, 4784, 4786, 4789, 4792, 4798, 4800, 4800, 4802, 4805, 4808, 4814, 4816, 4822, 4824, 4846, 4848, 4878, 4880, 4880, 4882, 4885, 4888, 4894, 4896, 4934, 4936, 4954, 4969, 4977, 5024, 5108, 5121, 5740, 5743, 5750, 5761, 5786, 5792, 5866, 6016, 6099, 6112, 6121, 6160, 6169, 6176, 6263, 6272, 6313, 7680, 7835, 7840, 7929, 7936, 7957, 7960, 7965, 7968, 8005, 8008, 8013, 8016, 8023, 8025, 8025, 8027, 8027, 8029, 8029, 8031, 8061, 8064, 8116, 8118, 8124, 8126, 8126, 8130, 8132, 8134, 8140, 8144, 8147, 8150, 8155, 8160, 8172, 8178, 8180, 8182, 8188, 8255, 8256, 8319, 8319, 8400, 8412, 8417, 8417, 8450, 8450, 8455, 8455, 8458, 8467, 8469, 8469, 8473, 8477, 8484, 8484, 8486, 8486, 8488, 8488, 8490, 8493, 8495, 8497, 8499, 8505, 8544, 8579, 12293, 12295, 12321, 12335, 12337, 12341, 12344, 12346, 12353, 12436, 12441, 12442, 12445, 12446, 12449, 12542, 12549, 12588, 12593, 12686, 12704, 12727, 13312, 19893, 19968, 40869, 40960, 42124, 44032, 55203, 63744, 64045, 64256, 64262, 64275, 64279, 64285, 64296, 64298, 64310, 64312, 64316, 64318, 64318, 64320, 64321, 64323, 64324, 64326, 64433, 64467, 64829, 64848, 64911, 64914, 64967, 65008, 65019, 65056, 65059, 65075, 65076, 65101, 65103, 65136, 65138, 65140, 65140, 65142, 65276, 65296, 65305, 65313, 65338, 65343, 65343, 65345, 65370, 65381, 65470, 65474, 65479, 65482, 65487, 65490, 65495, 65498, 65500];
	      unicodeES5IdentifierStart = [170, 170, 181, 181, 186, 186, 192, 214, 216, 246, 248, 705, 710, 721, 736, 740, 748, 748, 750, 750, 880, 884, 886, 887, 890, 893, 902, 902, 904, 906, 908, 908, 910, 929, 931, 1013, 1015, 1153, 1162, 1319, 1329, 1366, 1369, 1369, 1377, 1415, 1488, 1514, 1520, 1522, 1568, 1610, 1646, 1647, 1649, 1747, 1749, 1749, 1765, 1766, 1774, 1775, 1786, 1788, 1791, 1791, 1808, 1808, 1810, 1839, 1869, 1957, 1969, 1969, 1994, 2026, 2036, 2037, 2042, 2042, 2048, 2069, 2074, 2074, 2084, 2084, 2088, 2088, 2112, 2136, 2208, 2208, 2210, 2220, 2308, 2361, 2365, 2365, 2384, 2384, 2392, 2401, 2417, 2423, 2425, 2431, 2437, 2444, 2447, 2448, 2451, 2472, 2474, 2480, 2482, 2482, 2486, 2489, 2493, 2493, 2510, 2510, 2524, 2525, 2527, 2529, 2544, 2545, 2565, 2570, 2575, 2576, 2579, 2600, 2602, 2608, 2610, 2611, 2613, 2614, 2616, 2617, 2649, 2652, 2654, 2654, 2674, 2676, 2693, 2701, 2703, 2705, 2707, 2728, 2730, 2736, 2738, 2739, 2741, 2745, 2749, 2749, 2768, 2768, 2784, 2785, 2821, 2828, 2831, 2832, 2835, 2856, 2858, 2864, 2866, 2867, 2869, 2873, 2877, 2877, 2908, 2909, 2911, 2913, 2929, 2929, 2947, 2947, 2949, 2954, 2958, 2960, 2962, 2965, 2969, 2970, 2972, 2972, 2974, 2975, 2979, 2980, 2984, 2986, 2990, 3001, 3024, 3024, 3077, 3084, 3086, 3088, 3090, 3112, 3114, 3123, 3125, 3129, 3133, 3133, 3160, 3161, 3168, 3169, 3205, 3212, 3214, 3216, 3218, 3240, 3242, 3251, 3253, 3257, 3261, 3261, 3294, 3294, 3296, 3297, 3313, 3314, 3333, 3340, 3342, 3344, 3346, 3386, 3389, 3389, 3406, 3406, 3424, 3425, 3450, 3455, 3461, 3478, 3482, 3505, 3507, 3515, 3517, 3517, 3520, 3526, 3585, 3632, 3634, 3635, 3648, 3654, 3713, 3714, 3716, 3716, 3719, 3720, 3722, 3722, 3725, 3725, 3732, 3735, 3737, 3743, 3745, 3747, 3749, 3749, 3751, 3751, 3754, 3755, 3757, 3760, 3762, 3763, 3773, 3773, 3776, 3780, 3782, 3782, 3804, 3807, 3840, 3840, 3904, 3911, 3913, 3948, 3976, 3980, 4096, 4138, 4159, 4159, 4176, 4181, 4186, 4189, 4193, 4193, 4197, 4198, 4206, 4208, 4213, 4225, 4238, 4238, 4256, 4293, 4295, 4295, 4301, 4301, 4304, 4346, 4348, 4680, 4682, 4685, 4688, 4694, 4696, 4696, 4698, 4701, 4704, 4744, 4746, 4749, 4752, 4784, 4786, 4789, 4792, 4798, 4800, 4800, 4802, 4805, 4808, 4822, 4824, 4880, 4882, 4885, 4888, 4954, 4992, 5007, 5024, 5108, 5121, 5740, 5743, 5759, 5761, 5786, 5792, 5866, 5870, 5872, 5888, 5900, 5902, 5905, 5920, 5937, 5952, 5969, 5984, 5996, 5998, 6e3, 6016, 6067, 6103, 6103, 6108, 6108, 6176, 6263, 6272, 6312, 6314, 6314, 6320, 6389, 6400, 6428, 6480, 6509, 6512, 6516, 6528, 6571, 6593, 6599, 6656, 6678, 6688, 6740, 6823, 6823, 6917, 6963, 6981, 6987, 7043, 7072, 7086, 7087, 7098, 7141, 7168, 7203, 7245, 7247, 7258, 7293, 7401, 7404, 7406, 7409, 7413, 7414, 7424, 7615, 7680, 7957, 7960, 7965, 7968, 8005, 8008, 8013, 8016, 8023, 8025, 8025, 8027, 8027, 8029, 8029, 8031, 8061, 8064, 8116, 8118, 8124, 8126, 8126, 8130, 8132, 8134, 8140, 8144, 8147, 8150, 8155, 8160, 8172, 8178, 8180, 8182, 8188, 8305, 8305, 8319, 8319, 8336, 8348, 8450, 8450, 8455, 8455, 8458, 8467, 8469, 8469, 8473, 8477, 8484, 8484, 8486, 8486, 8488, 8488, 8490, 8493, 8495, 8505, 8508, 8511, 8517, 8521, 8526, 8526, 8544, 8584, 11264, 11310, 11312, 11358, 11360, 11492, 11499, 11502, 11506, 11507, 11520, 11557, 11559, 11559, 11565, 11565, 11568, 11623, 11631, 11631, 11648, 11670, 11680, 11686, 11688, 11694, 11696, 11702, 11704, 11710, 11712, 11718, 11720, 11726, 11728, 11734, 11736, 11742, 11823, 11823, 12293, 12295, 12321, 12329, 12337, 12341, 12344, 12348, 12353, 12438, 12445, 12447, 12449, 12538, 12540, 12543, 12549, 12589, 12593, 12686, 12704, 12730, 12784, 12799, 13312, 19893, 19968, 40908, 40960, 42124, 42192, 42237, 42240, 42508, 42512, 42527, 42538, 42539, 42560, 42606, 42623, 42647, 42656, 42735, 42775, 42783, 42786, 42888, 42891, 42894, 42896, 42899, 42912, 42922, 43e3, 43009, 43011, 43013, 43015, 43018, 43020, 43042, 43072, 43123, 43138, 43187, 43250, 43255, 43259, 43259, 43274, 43301, 43312, 43334, 43360, 43388, 43396, 43442, 43471, 43471, 43520, 43560, 43584, 43586, 43588, 43595, 43616, 43638, 43642, 43642, 43648, 43695, 43697, 43697, 43701, 43702, 43705, 43709, 43712, 43712, 43714, 43714, 43739, 43741, 43744, 43754, 43762, 43764, 43777, 43782, 43785, 43790, 43793, 43798, 43808, 43814, 43816, 43822, 43968, 44002, 44032, 55203, 55216, 55238, 55243, 55291, 63744, 64109, 64112, 64217, 64256, 64262, 64275, 64279, 64285, 64285, 64287, 64296, 64298, 64310, 64312, 64316, 64318, 64318, 64320, 64321, 64323, 64324, 64326, 64433, 64467, 64829, 64848, 64911, 64914, 64967, 65008, 65019, 65136, 65140, 65142, 65276, 65313, 65338, 65345, 65370, 65382, 65470, 65474, 65479, 65482, 65487, 65490, 65495, 65498, 65500];
	      unicodeES5IdentifierPart = [170, 170, 181, 181, 186, 186, 192, 214, 216, 246, 248, 705, 710, 721, 736, 740, 748, 748, 750, 750, 768, 884, 886, 887, 890, 893, 902, 902, 904, 906, 908, 908, 910, 929, 931, 1013, 1015, 1153, 1155, 1159, 1162, 1319, 1329, 1366, 1369, 1369, 1377, 1415, 1425, 1469, 1471, 1471, 1473, 1474, 1476, 1477, 1479, 1479, 1488, 1514, 1520, 1522, 1552, 1562, 1568, 1641, 1646, 1747, 1749, 1756, 1759, 1768, 1770, 1788, 1791, 1791, 1808, 1866, 1869, 1969, 1984, 2037, 2042, 2042, 2048, 2093, 2112, 2139, 2208, 2208, 2210, 2220, 2276, 2302, 2304, 2403, 2406, 2415, 2417, 2423, 2425, 2431, 2433, 2435, 2437, 2444, 2447, 2448, 2451, 2472, 2474, 2480, 2482, 2482, 2486, 2489, 2492, 2500, 2503, 2504, 2507, 2510, 2519, 2519, 2524, 2525, 2527, 2531, 2534, 2545, 2561, 2563, 2565, 2570, 2575, 2576, 2579, 2600, 2602, 2608, 2610, 2611, 2613, 2614, 2616, 2617, 2620, 2620, 2622, 2626, 2631, 2632, 2635, 2637, 2641, 2641, 2649, 2652, 2654, 2654, 2662, 2677, 2689, 2691, 2693, 2701, 2703, 2705, 2707, 2728, 2730, 2736, 2738, 2739, 2741, 2745, 2748, 2757, 2759, 2761, 2763, 2765, 2768, 2768, 2784, 2787, 2790, 2799, 2817, 2819, 2821, 2828, 2831, 2832, 2835, 2856, 2858, 2864, 2866, 2867, 2869, 2873, 2876, 2884, 2887, 2888, 2891, 2893, 2902, 2903, 2908, 2909, 2911, 2915, 2918, 2927, 2929, 2929, 2946, 2947, 2949, 2954, 2958, 2960, 2962, 2965, 2969, 2970, 2972, 2972, 2974, 2975, 2979, 2980, 2984, 2986, 2990, 3001, 3006, 3010, 3014, 3016, 3018, 3021, 3024, 3024, 3031, 3031, 3046, 3055, 3073, 3075, 3077, 3084, 3086, 3088, 3090, 3112, 3114, 3123, 3125, 3129, 3133, 3140, 3142, 3144, 3146, 3149, 3157, 3158, 3160, 3161, 3168, 3171, 3174, 3183, 3202, 3203, 3205, 3212, 3214, 3216, 3218, 3240, 3242, 3251, 3253, 3257, 3260, 3268, 3270, 3272, 3274, 3277, 3285, 3286, 3294, 3294, 3296, 3299, 3302, 3311, 3313, 3314, 3330, 3331, 3333, 3340, 3342, 3344, 3346, 3386, 3389, 3396, 3398, 3400, 3402, 3406, 3415, 3415, 3424, 3427, 3430, 3439, 3450, 3455, 3458, 3459, 3461, 3478, 3482, 3505, 3507, 3515, 3517, 3517, 3520, 3526, 3530, 3530, 3535, 3540, 3542, 3542, 3544, 3551, 3570, 3571, 3585, 3642, 3648, 3662, 3664, 3673, 3713, 3714, 3716, 3716, 3719, 3720, 3722, 3722, 3725, 3725, 3732, 3735, 3737, 3743, 3745, 3747, 3749, 3749, 3751, 3751, 3754, 3755, 3757, 3769, 3771, 3773, 3776, 3780, 3782, 3782, 3784, 3789, 3792, 3801, 3804, 3807, 3840, 3840, 3864, 3865, 3872, 3881, 3893, 3893, 3895, 3895, 3897, 3897, 3902, 3911, 3913, 3948, 3953, 3972, 3974, 3991, 3993, 4028, 4038, 4038, 4096, 4169, 4176, 4253, 4256, 4293, 4295, 4295, 4301, 4301, 4304, 4346, 4348, 4680, 4682, 4685, 4688, 4694, 4696, 4696, 4698, 4701, 4704, 4744, 4746, 4749, 4752, 4784, 4786, 4789, 4792, 4798, 4800, 4800, 4802, 4805, 4808, 4822, 4824, 4880, 4882, 4885, 4888, 4954, 4957, 4959, 4992, 5007, 5024, 5108, 5121, 5740, 5743, 5759, 5761, 5786, 5792, 5866, 5870, 5872, 5888, 5900, 5902, 5908, 5920, 5940, 5952, 5971, 5984, 5996, 5998, 6e3, 6002, 6003, 6016, 6099, 6103, 6103, 6108, 6109, 6112, 6121, 6155, 6157, 6160, 6169, 6176, 6263, 6272, 6314, 6320, 6389, 6400, 6428, 6432, 6443, 6448, 6459, 6470, 6509, 6512, 6516, 6528, 6571, 6576, 6601, 6608, 6617, 6656, 6683, 6688, 6750, 6752, 6780, 6783, 6793, 6800, 6809, 6823, 6823, 6912, 6987, 6992, 7001, 7019, 7027, 7040, 7155, 7168, 7223, 7232, 7241, 7245, 7293, 7376, 7378, 7380, 7414, 7424, 7654, 7676, 7957, 7960, 7965, 7968, 8005, 8008, 8013, 8016, 8023, 8025, 8025, 8027, 8027, 8029, 8029, 8031, 8061, 8064, 8116, 8118, 8124, 8126, 8126, 8130, 8132, 8134, 8140, 8144, 8147, 8150, 8155, 8160, 8172, 8178, 8180, 8182, 8188, 8204, 8205, 8255, 8256, 8276, 8276, 8305, 8305, 8319, 8319, 8336, 8348, 8400, 8412, 8417, 8417, 8421, 8432, 8450, 8450, 8455, 8455, 8458, 8467, 8469, 8469, 8473, 8477, 8484, 8484, 8486, 8486, 8488, 8488, 8490, 8493, 8495, 8505, 8508, 8511, 8517, 8521, 8526, 8526, 8544, 8584, 11264, 11310, 11312, 11358, 11360, 11492, 11499, 11507, 11520, 11557, 11559, 11559, 11565, 11565, 11568, 11623, 11631, 11631, 11647, 11670, 11680, 11686, 11688, 11694, 11696, 11702, 11704, 11710, 11712, 11718, 11720, 11726, 11728, 11734, 11736, 11742, 11744, 11775, 11823, 11823, 12293, 12295, 12321, 12335, 12337, 12341, 12344, 12348, 12353, 12438, 12441, 12442, 12445, 12447, 12449, 12538, 12540, 12543, 12549, 12589, 12593, 12686, 12704, 12730, 12784, 12799, 13312, 19893, 19968, 40908, 40960, 42124, 42192, 42237, 42240, 42508, 42512, 42539, 42560, 42607, 42612, 42621, 42623, 42647, 42655, 42737, 42775, 42783, 42786, 42888, 42891, 42894, 42896, 42899, 42912, 42922, 43e3, 43047, 43072, 43123, 43136, 43204, 43216, 43225, 43232, 43255, 43259, 43259, 43264, 43309, 43312, 43347, 43360, 43388, 43392, 43456, 43471, 43481, 43520, 43574, 43584, 43597, 43600, 43609, 43616, 43638, 43642, 43643, 43648, 43714, 43739, 43741, 43744, 43759, 43762, 43766, 43777, 43782, 43785, 43790, 43793, 43798, 43808, 43814, 43816, 43822, 43968, 44010, 44012, 44013, 44016, 44025, 44032, 55203, 55216, 55238, 55243, 55291, 63744, 64109, 64112, 64217, 64256, 64262, 64275, 64279, 64285, 64296, 64298, 64310, 64312, 64316, 64318, 64318, 64320, 64321, 64323, 64324, 64326, 64433, 64467, 64829, 64848, 64911, 64914, 64967, 65008, 65019, 65024, 65039, 65056, 65062, 65075, 65076, 65101, 65103, 65136, 65140, 65142, 65276, 65296, 65305, 65313, 65338, 65343, 65343, 65345, 65370, 65382, 65470, 65474, 65479, 65482, 65487, 65490, 65495, 65498, 65500];
	      unicodeESNextIdentifierStart = [65, 90, 97, 122, 170, 170, 181, 181, 186, 186, 192, 214, 216, 246, 248, 705, 710, 721, 736, 740, 748, 748, 750, 750, 880, 884, 886, 887, 890, 893, 895, 895, 902, 902, 904, 906, 908, 908, 910, 929, 931, 1013, 1015, 1153, 1162, 1327, 1329, 1366, 1369, 1369, 1376, 1416, 1488, 1514, 1519, 1522, 1568, 1610, 1646, 1647, 1649, 1747, 1749, 1749, 1765, 1766, 1774, 1775, 1786, 1788, 1791, 1791, 1808, 1808, 1810, 1839, 1869, 1957, 1969, 1969, 1994, 2026, 2036, 2037, 2042, 2042, 2048, 2069, 2074, 2074, 2084, 2084, 2088, 2088, 2112, 2136, 2144, 2154, 2208, 2228, 2230, 2237, 2308, 2361, 2365, 2365, 2384, 2384, 2392, 2401, 2417, 2432, 2437, 2444, 2447, 2448, 2451, 2472, 2474, 2480, 2482, 2482, 2486, 2489, 2493, 2493, 2510, 2510, 2524, 2525, 2527, 2529, 2544, 2545, 2556, 2556, 2565, 2570, 2575, 2576, 2579, 2600, 2602, 2608, 2610, 2611, 2613, 2614, 2616, 2617, 2649, 2652, 2654, 2654, 2674, 2676, 2693, 2701, 2703, 2705, 2707, 2728, 2730, 2736, 2738, 2739, 2741, 2745, 2749, 2749, 2768, 2768, 2784, 2785, 2809, 2809, 2821, 2828, 2831, 2832, 2835, 2856, 2858, 2864, 2866, 2867, 2869, 2873, 2877, 2877, 2908, 2909, 2911, 2913, 2929, 2929, 2947, 2947, 2949, 2954, 2958, 2960, 2962, 2965, 2969, 2970, 2972, 2972, 2974, 2975, 2979, 2980, 2984, 2986, 2990, 3001, 3024, 3024, 3077, 3084, 3086, 3088, 3090, 3112, 3114, 3129, 3133, 3133, 3160, 3162, 3168, 3169, 3200, 3200, 3205, 3212, 3214, 3216, 3218, 3240, 3242, 3251, 3253, 3257, 3261, 3261, 3294, 3294, 3296, 3297, 3313, 3314, 3333, 3340, 3342, 3344, 3346, 3386, 3389, 3389, 3406, 3406, 3412, 3414, 3423, 3425, 3450, 3455, 3461, 3478, 3482, 3505, 3507, 3515, 3517, 3517, 3520, 3526, 3585, 3632, 3634, 3635, 3648, 3654, 3713, 3714, 3716, 3716, 3718, 3722, 3724, 3747, 3749, 3749, 3751, 3760, 3762, 3763, 3773, 3773, 3776, 3780, 3782, 3782, 3804, 3807, 3840, 3840, 3904, 3911, 3913, 3948, 3976, 3980, 4096, 4138, 4159, 4159, 4176, 4181, 4186, 4189, 4193, 4193, 4197, 4198, 4206, 4208, 4213, 4225, 4238, 4238, 4256, 4293, 4295, 4295, 4301, 4301, 4304, 4346, 4348, 4680, 4682, 4685, 4688, 4694, 4696, 4696, 4698, 4701, 4704, 4744, 4746, 4749, 4752, 4784, 4786, 4789, 4792, 4798, 4800, 4800, 4802, 4805, 4808, 4822, 4824, 4880, 4882, 4885, 4888, 4954, 4992, 5007, 5024, 5109, 5112, 5117, 5121, 5740, 5743, 5759, 5761, 5786, 5792, 5866, 5870, 5880, 5888, 5900, 5902, 5905, 5920, 5937, 5952, 5969, 5984, 5996, 5998, 6e3, 6016, 6067, 6103, 6103, 6108, 6108, 6176, 6264, 6272, 6312, 6314, 6314, 6320, 6389, 6400, 6430, 6480, 6509, 6512, 6516, 6528, 6571, 6576, 6601, 6656, 6678, 6688, 6740, 6823, 6823, 6917, 6963, 6981, 6987, 7043, 7072, 7086, 7087, 7098, 7141, 7168, 7203, 7245, 7247, 7258, 7293, 7296, 7304, 7312, 7354, 7357, 7359, 7401, 7404, 7406, 7411, 7413, 7414, 7418, 7418, 7424, 7615, 7680, 7957, 7960, 7965, 7968, 8005, 8008, 8013, 8016, 8023, 8025, 8025, 8027, 8027, 8029, 8029, 8031, 8061, 8064, 8116, 8118, 8124, 8126, 8126, 8130, 8132, 8134, 8140, 8144, 8147, 8150, 8155, 8160, 8172, 8178, 8180, 8182, 8188, 8305, 8305, 8319, 8319, 8336, 8348, 8450, 8450, 8455, 8455, 8458, 8467, 8469, 8469, 8472, 8477, 8484, 8484, 8486, 8486, 8488, 8488, 8490, 8505, 8508, 8511, 8517, 8521, 8526, 8526, 8544, 8584, 11264, 11310, 11312, 11358, 11360, 11492, 11499, 11502, 11506, 11507, 11520, 11557, 11559, 11559, 11565, 11565, 11568, 11623, 11631, 11631, 11648, 11670, 11680, 11686, 11688, 11694, 11696, 11702, 11704, 11710, 11712, 11718, 11720, 11726, 11728, 11734, 11736, 11742, 12293, 12295, 12321, 12329, 12337, 12341, 12344, 12348, 12353, 12438, 12443, 12447, 12449, 12538, 12540, 12543, 12549, 12591, 12593, 12686, 12704, 12730, 12784, 12799, 13312, 19893, 19968, 40943, 40960, 42124, 42192, 42237, 42240, 42508, 42512, 42527, 42538, 42539, 42560, 42606, 42623, 42653, 42656, 42735, 42775, 42783, 42786, 42888, 42891, 42943, 42946, 42950, 42999, 43009, 43011, 43013, 43015, 43018, 43020, 43042, 43072, 43123, 43138, 43187, 43250, 43255, 43259, 43259, 43261, 43262, 43274, 43301, 43312, 43334, 43360, 43388, 43396, 43442, 43471, 43471, 43488, 43492, 43494, 43503, 43514, 43518, 43520, 43560, 43584, 43586, 43588, 43595, 43616, 43638, 43642, 43642, 43646, 43695, 43697, 43697, 43701, 43702, 43705, 43709, 43712, 43712, 43714, 43714, 43739, 43741, 43744, 43754, 43762, 43764, 43777, 43782, 43785, 43790, 43793, 43798, 43808, 43814, 43816, 43822, 43824, 43866, 43868, 43879, 43888, 44002, 44032, 55203, 55216, 55238, 55243, 55291, 63744, 64109, 64112, 64217, 64256, 64262, 64275, 64279, 64285, 64285, 64287, 64296, 64298, 64310, 64312, 64316, 64318, 64318, 64320, 64321, 64323, 64324, 64326, 64433, 64467, 64829, 64848, 64911, 64914, 64967, 65008, 65019, 65136, 65140, 65142, 65276, 65313, 65338, 65345, 65370, 65382, 65470, 65474, 65479, 65482, 65487, 65490, 65495, 65498, 65500, 65536, 65547, 65549, 65574, 65576, 65594, 65596, 65597, 65599, 65613, 65616, 65629, 65664, 65786, 65856, 65908, 66176, 66204, 66208, 66256, 66304, 66335, 66349, 66378, 66384, 66421, 66432, 66461, 66464, 66499, 66504, 66511, 66513, 66517, 66560, 66717, 66736, 66771, 66776, 66811, 66816, 66855, 66864, 66915, 67072, 67382, 67392, 67413, 67424, 67431, 67584, 67589, 67592, 67592, 67594, 67637, 67639, 67640, 67644, 67644, 67647, 67669, 67680, 67702, 67712, 67742, 67808, 67826, 67828, 67829, 67840, 67861, 67872, 67897, 67968, 68023, 68030, 68031, 68096, 68096, 68112, 68115, 68117, 68119, 68121, 68149, 68192, 68220, 68224, 68252, 68288, 68295, 68297, 68324, 68352, 68405, 68416, 68437, 68448, 68466, 68480, 68497, 68608, 68680, 68736, 68786, 68800, 68850, 68864, 68899, 69376, 69404, 69415, 69415, 69424, 69445, 69600, 69622, 69635, 69687, 69763, 69807, 69840, 69864, 69891, 69926, 69956, 69956, 69968, 70002, 70006, 70006, 70019, 70066, 70081, 70084, 70106, 70106, 70108, 70108, 70144, 70161, 70163, 70187, 70272, 70278, 70280, 70280, 70282, 70285, 70287, 70301, 70303, 70312, 70320, 70366, 70405, 70412, 70415, 70416, 70419, 70440, 70442, 70448, 70450, 70451, 70453, 70457, 70461, 70461, 70480, 70480, 70493, 70497, 70656, 70708, 70727, 70730, 70751, 70751, 70784, 70831, 70852, 70853, 70855, 70855, 71040, 71086, 71128, 71131, 71168, 71215, 71236, 71236, 71296, 71338, 71352, 71352, 71424, 71450, 71680, 71723, 71840, 71903, 71935, 71935, 72096, 72103, 72106, 72144, 72161, 72161, 72163, 72163, 72192, 72192, 72203, 72242, 72250, 72250, 72272, 72272, 72284, 72329, 72349, 72349, 72384, 72440, 72704, 72712, 72714, 72750, 72768, 72768, 72818, 72847, 72960, 72966, 72968, 72969, 72971, 73008, 73030, 73030, 73056, 73061, 73063, 73064, 73066, 73097, 73112, 73112, 73440, 73458, 73728, 74649, 74752, 74862, 74880, 75075, 77824, 78894, 82944, 83526, 92160, 92728, 92736, 92766, 92880, 92909, 92928, 92975, 92992, 92995, 93027, 93047, 93053, 93071, 93760, 93823, 93952, 94026, 94032, 94032, 94099, 94111, 94176, 94177, 94179, 94179, 94208, 100343, 100352, 101106, 110592, 110878, 110928, 110930, 110948, 110951, 110960, 111355, 113664, 113770, 113776, 113788, 113792, 113800, 113808, 113817, 119808, 119892, 119894, 119964, 119966, 119967, 119970, 119970, 119973, 119974, 119977, 119980, 119982, 119993, 119995, 119995, 119997, 120003, 120005, 120069, 120071, 120074, 120077, 120084, 120086, 120092, 120094, 120121, 120123, 120126, 120128, 120132, 120134, 120134, 120138, 120144, 120146, 120485, 120488, 120512, 120514, 120538, 120540, 120570, 120572, 120596, 120598, 120628, 120630, 120654, 120656, 120686, 120688, 120712, 120714, 120744, 120746, 120770, 120772, 120779, 123136, 123180, 123191, 123197, 123214, 123214, 123584, 123627, 124928, 125124, 125184, 125251, 125259, 125259, 126464, 126467, 126469, 126495, 126497, 126498, 126500, 126500, 126503, 126503, 126505, 126514, 126516, 126519, 126521, 126521, 126523, 126523, 126530, 126530, 126535, 126535, 126537, 126537, 126539, 126539, 126541, 126543, 126545, 126546, 126548, 126548, 126551, 126551, 126553, 126553, 126555, 126555, 126557, 126557, 126559, 126559, 126561, 126562, 126564, 126564, 126567, 126570, 126572, 126578, 126580, 126583, 126585, 126588, 126590, 126590, 126592, 126601, 126603, 126619, 126625, 126627, 126629, 126633, 126635, 126651, 131072, 173782, 173824, 177972, 177984, 178205, 178208, 183969, 183984, 191456, 194560, 195101];
	      unicodeESNextIdentifierPart = [48, 57, 65, 90, 95, 95, 97, 122, 170, 170, 181, 181, 183, 183, 186, 186, 192, 214, 216, 246, 248, 705, 710, 721, 736, 740, 748, 748, 750, 750, 768, 884, 886, 887, 890, 893, 895, 895, 902, 906, 908, 908, 910, 929, 931, 1013, 1015, 1153, 1155, 1159, 1162, 1327, 1329, 1366, 1369, 1369, 1376, 1416, 1425, 1469, 1471, 1471, 1473, 1474, 1476, 1477, 1479, 1479, 1488, 1514, 1519, 1522, 1552, 1562, 1568, 1641, 1646, 1747, 1749, 1756, 1759, 1768, 1770, 1788, 1791, 1791, 1808, 1866, 1869, 1969, 1984, 2037, 2042, 2042, 2045, 2045, 2048, 2093, 2112, 2139, 2144, 2154, 2208, 2228, 2230, 2237, 2259, 2273, 2275, 2403, 2406, 2415, 2417, 2435, 2437, 2444, 2447, 2448, 2451, 2472, 2474, 2480, 2482, 2482, 2486, 2489, 2492, 2500, 2503, 2504, 2507, 2510, 2519, 2519, 2524, 2525, 2527, 2531, 2534, 2545, 2556, 2556, 2558, 2558, 2561, 2563, 2565, 2570, 2575, 2576, 2579, 2600, 2602, 2608, 2610, 2611, 2613, 2614, 2616, 2617, 2620, 2620, 2622, 2626, 2631, 2632, 2635, 2637, 2641, 2641, 2649, 2652, 2654, 2654, 2662, 2677, 2689, 2691, 2693, 2701, 2703, 2705, 2707, 2728, 2730, 2736, 2738, 2739, 2741, 2745, 2748, 2757, 2759, 2761, 2763, 2765, 2768, 2768, 2784, 2787, 2790, 2799, 2809, 2815, 2817, 2819, 2821, 2828, 2831, 2832, 2835, 2856, 2858, 2864, 2866, 2867, 2869, 2873, 2876, 2884, 2887, 2888, 2891, 2893, 2902, 2903, 2908, 2909, 2911, 2915, 2918, 2927, 2929, 2929, 2946, 2947, 2949, 2954, 2958, 2960, 2962, 2965, 2969, 2970, 2972, 2972, 2974, 2975, 2979, 2980, 2984, 2986, 2990, 3001, 3006, 3010, 3014, 3016, 3018, 3021, 3024, 3024, 3031, 3031, 3046, 3055, 3072, 3084, 3086, 3088, 3090, 3112, 3114, 3129, 3133, 3140, 3142, 3144, 3146, 3149, 3157, 3158, 3160, 3162, 3168, 3171, 3174, 3183, 3200, 3203, 3205, 3212, 3214, 3216, 3218, 3240, 3242, 3251, 3253, 3257, 3260, 3268, 3270, 3272, 3274, 3277, 3285, 3286, 3294, 3294, 3296, 3299, 3302, 3311, 3313, 3314, 3328, 3331, 3333, 3340, 3342, 3344, 3346, 3396, 3398, 3400, 3402, 3406, 3412, 3415, 3423, 3427, 3430, 3439, 3450, 3455, 3458, 3459, 3461, 3478, 3482, 3505, 3507, 3515, 3517, 3517, 3520, 3526, 3530, 3530, 3535, 3540, 3542, 3542, 3544, 3551, 3558, 3567, 3570, 3571, 3585, 3642, 3648, 3662, 3664, 3673, 3713, 3714, 3716, 3716, 3718, 3722, 3724, 3747, 3749, 3749, 3751, 3773, 3776, 3780, 3782, 3782, 3784, 3789, 3792, 3801, 3804, 3807, 3840, 3840, 3864, 3865, 3872, 3881, 3893, 3893, 3895, 3895, 3897, 3897, 3902, 3911, 3913, 3948, 3953, 3972, 3974, 3991, 3993, 4028, 4038, 4038, 4096, 4169, 4176, 4253, 4256, 4293, 4295, 4295, 4301, 4301, 4304, 4346, 4348, 4680, 4682, 4685, 4688, 4694, 4696, 4696, 4698, 4701, 4704, 4744, 4746, 4749, 4752, 4784, 4786, 4789, 4792, 4798, 4800, 4800, 4802, 4805, 4808, 4822, 4824, 4880, 4882, 4885, 4888, 4954, 4957, 4959, 4969, 4977, 4992, 5007, 5024, 5109, 5112, 5117, 5121, 5740, 5743, 5759, 5761, 5786, 5792, 5866, 5870, 5880, 5888, 5900, 5902, 5908, 5920, 5940, 5952, 5971, 5984, 5996, 5998, 6e3, 6002, 6003, 6016, 6099, 6103, 6103, 6108, 6109, 6112, 6121, 6155, 6157, 6160, 6169, 6176, 6264, 6272, 6314, 6320, 6389, 6400, 6430, 6432, 6443, 6448, 6459, 6470, 6509, 6512, 6516, 6528, 6571, 6576, 6601, 6608, 6618, 6656, 6683, 6688, 6750, 6752, 6780, 6783, 6793, 6800, 6809, 6823, 6823, 6832, 6845, 6912, 6987, 6992, 7001, 7019, 7027, 7040, 7155, 7168, 7223, 7232, 7241, 7245, 7293, 7296, 7304, 7312, 7354, 7357, 7359, 7376, 7378, 7380, 7418, 7424, 7673, 7675, 7957, 7960, 7965, 7968, 8005, 8008, 8013, 8016, 8023, 8025, 8025, 8027, 8027, 8029, 8029, 8031, 8061, 8064, 8116, 8118, 8124, 8126, 8126, 8130, 8132, 8134, 8140, 8144, 8147, 8150, 8155, 8160, 8172, 8178, 8180, 8182, 8188, 8255, 8256, 8276, 8276, 8305, 8305, 8319, 8319, 8336, 8348, 8400, 8412, 8417, 8417, 8421, 8432, 8450, 8450, 8455, 8455, 8458, 8467, 8469, 8469, 8472, 8477, 8484, 8484, 8486, 8486, 8488, 8488, 8490, 8505, 8508, 8511, 8517, 8521, 8526, 8526, 8544, 8584, 11264, 11310, 11312, 11358, 11360, 11492, 11499, 11507, 11520, 11557, 11559, 11559, 11565, 11565, 11568, 11623, 11631, 11631, 11647, 11670, 11680, 11686, 11688, 11694, 11696, 11702, 11704, 11710, 11712, 11718, 11720, 11726, 11728, 11734, 11736, 11742, 11744, 11775, 12293, 12295, 12321, 12335, 12337, 12341, 12344, 12348, 12353, 12438, 12441, 12447, 12449, 12538, 12540, 12543, 12549, 12591, 12593, 12686, 12704, 12730, 12784, 12799, 13312, 19893, 19968, 40943, 40960, 42124, 42192, 42237, 42240, 42508, 42512, 42539, 42560, 42607, 42612, 42621, 42623, 42737, 42775, 42783, 42786, 42888, 42891, 42943, 42946, 42950, 42999, 43047, 43072, 43123, 43136, 43205, 43216, 43225, 43232, 43255, 43259, 43259, 43261, 43309, 43312, 43347, 43360, 43388, 43392, 43456, 43471, 43481, 43488, 43518, 43520, 43574, 43584, 43597, 43600, 43609, 43616, 43638, 43642, 43714, 43739, 43741, 43744, 43759, 43762, 43766, 43777, 43782, 43785, 43790, 43793, 43798, 43808, 43814, 43816, 43822, 43824, 43866, 43868, 43879, 43888, 44010, 44012, 44013, 44016, 44025, 44032, 55203, 55216, 55238, 55243, 55291, 63744, 64109, 64112, 64217, 64256, 64262, 64275, 64279, 64285, 64296, 64298, 64310, 64312, 64316, 64318, 64318, 64320, 64321, 64323, 64324, 64326, 64433, 64467, 64829, 64848, 64911, 64914, 64967, 65008, 65019, 65024, 65039, 65056, 65071, 65075, 65076, 65101, 65103, 65136, 65140, 65142, 65276, 65296, 65305, 65313, 65338, 65343, 65343, 65345, 65370, 65382, 65470, 65474, 65479, 65482, 65487, 65490, 65495, 65498, 65500, 65536, 65547, 65549, 65574, 65576, 65594, 65596, 65597, 65599, 65613, 65616, 65629, 65664, 65786, 65856, 65908, 66045, 66045, 66176, 66204, 66208, 66256, 66272, 66272, 66304, 66335, 66349, 66378, 66384, 66426, 66432, 66461, 66464, 66499, 66504, 66511, 66513, 66517, 66560, 66717, 66720, 66729, 66736, 66771, 66776, 66811, 66816, 66855, 66864, 66915, 67072, 67382, 67392, 67413, 67424, 67431, 67584, 67589, 67592, 67592, 67594, 67637, 67639, 67640, 67644, 67644, 67647, 67669, 67680, 67702, 67712, 67742, 67808, 67826, 67828, 67829, 67840, 67861, 67872, 67897, 67968, 68023, 68030, 68031, 68096, 68099, 68101, 68102, 68108, 68115, 68117, 68119, 68121, 68149, 68152, 68154, 68159, 68159, 68192, 68220, 68224, 68252, 68288, 68295, 68297, 68326, 68352, 68405, 68416, 68437, 68448, 68466, 68480, 68497, 68608, 68680, 68736, 68786, 68800, 68850, 68864, 68903, 68912, 68921, 69376, 69404, 69415, 69415, 69424, 69456, 69600, 69622, 69632, 69702, 69734, 69743, 69759, 69818, 69840, 69864, 69872, 69881, 69888, 69940, 69942, 69951, 69956, 69958, 69968, 70003, 70006, 70006, 70016, 70084, 70089, 70092, 70096, 70106, 70108, 70108, 70144, 70161, 70163, 70199, 70206, 70206, 70272, 70278, 70280, 70280, 70282, 70285, 70287, 70301, 70303, 70312, 70320, 70378, 70384, 70393, 70400, 70403, 70405, 70412, 70415, 70416, 70419, 70440, 70442, 70448, 70450, 70451, 70453, 70457, 70459, 70468, 70471, 70472, 70475, 70477, 70480, 70480, 70487, 70487, 70493, 70499, 70502, 70508, 70512, 70516, 70656, 70730, 70736, 70745, 70750, 70751, 70784, 70853, 70855, 70855, 70864, 70873, 71040, 71093, 71096, 71104, 71128, 71133, 71168, 71232, 71236, 71236, 71248, 71257, 71296, 71352, 71360, 71369, 71424, 71450, 71453, 71467, 71472, 71481, 71680, 71738, 71840, 71913, 71935, 71935, 72096, 72103, 72106, 72151, 72154, 72161, 72163, 72164, 72192, 72254, 72263, 72263, 72272, 72345, 72349, 72349, 72384, 72440, 72704, 72712, 72714, 72758, 72760, 72768, 72784, 72793, 72818, 72847, 72850, 72871, 72873, 72886, 72960, 72966, 72968, 72969, 72971, 73014, 73018, 73018, 73020, 73021, 73023, 73031, 73040, 73049, 73056, 73061, 73063, 73064, 73066, 73102, 73104, 73105, 73107, 73112, 73120, 73129, 73440, 73462, 73728, 74649, 74752, 74862, 74880, 75075, 77824, 78894, 82944, 83526, 92160, 92728, 92736, 92766, 92768, 92777, 92880, 92909, 92912, 92916, 92928, 92982, 92992, 92995, 93008, 93017, 93027, 93047, 93053, 93071, 93760, 93823, 93952, 94026, 94031, 94087, 94095, 94111, 94176, 94177, 94179, 94179, 94208, 100343, 100352, 101106, 110592, 110878, 110928, 110930, 110948, 110951, 110960, 111355, 113664, 113770, 113776, 113788, 113792, 113800, 113808, 113817, 113821, 113822, 119141, 119145, 119149, 119154, 119163, 119170, 119173, 119179, 119210, 119213, 119362, 119364, 119808, 119892, 119894, 119964, 119966, 119967, 119970, 119970, 119973, 119974, 119977, 119980, 119982, 119993, 119995, 119995, 119997, 120003, 120005, 120069, 120071, 120074, 120077, 120084, 120086, 120092, 120094, 120121, 120123, 120126, 120128, 120132, 120134, 120134, 120138, 120144, 120146, 120485, 120488, 120512, 120514, 120538, 120540, 120570, 120572, 120596, 120598, 120628, 120630, 120654, 120656, 120686, 120688, 120712, 120714, 120744, 120746, 120770, 120772, 120779, 120782, 120831, 121344, 121398, 121403, 121452, 121461, 121461, 121476, 121476, 121499, 121503, 121505, 121519, 122880, 122886, 122888, 122904, 122907, 122913, 122915, 122916, 122918, 122922, 123136, 123180, 123184, 123197, 123200, 123209, 123214, 123214, 123584, 123641, 124928, 125124, 125136, 125142, 125184, 125259, 125264, 125273, 126464, 126467, 126469, 126495, 126497, 126498, 126500, 126500, 126503, 126503, 126505, 126514, 126516, 126519, 126521, 126521, 126523, 126523, 126530, 126530, 126535, 126535, 126537, 126537, 126539, 126539, 126541, 126543, 126545, 126546, 126548, 126548, 126551, 126551, 126553, 126553, 126555, 126555, 126557, 126557, 126559, 126559, 126561, 126562, 126564, 126564, 126567, 126570, 126572, 126578, 126580, 126583, 126585, 126588, 126590, 126590, 126592, 126601, 126603, 126619, 126625, 126627, 126629, 126633, 126635, 126651, 131072, 173782, 173824, 177972, 177984, 178205, 178208, 183969, 183984, 191456, 194560, 195101, 917760, 917999];
	      commentDirectiveRegExSingleLine = /^\/\/\/?\s*@(ts-expect-error|ts-ignore)/;
	      commentDirectiveRegExMultiLine = /^(?:\/|\*)*\s*@(ts-expect-error|ts-ignore)/;
	      jsDocSeeOrLink = /@(?:see|link)/i;
	      tokenStrings = makeReverseMap(textToToken);
	      mergeConflictMarkerLength = "<<<<<<<".length;
	      shebangTriviaRegex = /^#!.*/;
	      utf16EncodeAsStringWorker = String.fromCodePoint ? (codePoint) => String.fromCodePoint(codePoint) : utf16EncodeAsStringFallback;
	    }
	  });

	  // src/compiler/utilitiesPublic.ts
	  function isExternalModuleNameRelative(moduleName) {
	    return pathIsRelative(moduleName) || isRootedDiskPath(moduleName);
	  }
	  function sortAndDeduplicateDiagnostics(diagnostics) {
	    return sortAndDeduplicate(diagnostics, compareDiagnostics);
	  }
	  function getDefaultLibFileName(options) {
	    switch (getEmitScriptTarget(options)) {
	      case 99 /* ESNext */:
	        return "lib.esnext.full.d.ts";
	      case 9 /* ES2022 */:
	        return "lib.es2022.full.d.ts";
	      case 8 /* ES2021 */:
	        return "lib.es2021.full.d.ts";
	      case 7 /* ES2020 */:
	        return "lib.es2020.full.d.ts";
	      case 6 /* ES2019 */:
	        return "lib.es2019.full.d.ts";
	      case 5 /* ES2018 */:
	        return "lib.es2018.full.d.ts";
	      case 4 /* ES2017 */:
	        return "lib.es2017.full.d.ts";
	      case 3 /* ES2016 */:
	        return "lib.es2016.full.d.ts";
	      case 2 /* ES2015 */:
	        return "lib.es6.d.ts";
	      default:
	        return "lib.d.ts";
	    }
	  }
	  function textSpanEnd(span) {
	    return span.start + span.length;
	  }
	  function textSpanIsEmpty(span) {
	    return span.length === 0;
	  }
	  function textSpanContainsPosition(span, position) {
	    return position >= span.start && position < textSpanEnd(span);
	  }
	  function textRangeContainsPositionInclusive(span, position) {
	    return position >= span.pos && position <= span.end;
	  }
	  function textSpanContainsTextSpan(span, other) {
	    return other.start >= span.start && textSpanEnd(other) <= textSpanEnd(span);
	  }
	  function textSpanOverlapsWith(span, other) {
	    return textSpanOverlap(span, other) !== void 0;
	  }
	  function textSpanOverlap(span1, span2) {
	    const overlap = textSpanIntersection(span1, span2);
	    return overlap && overlap.length === 0 ? void 0 : overlap;
	  }
	  function textSpanIntersectsWithTextSpan(span, other) {
	    return decodedTextSpanIntersectsWith(span.start, span.length, other.start, other.length);
	  }
	  function textSpanIntersectsWith(span, start, length2) {
	    return decodedTextSpanIntersectsWith(span.start, span.length, start, length2);
	  }
	  function decodedTextSpanIntersectsWith(start1, length1, start2, length2) {
	    const end1 = start1 + length1;
	    const end2 = start2 + length2;
	    return start2 <= end1 && end2 >= start1;
	  }
	  function textSpanIntersectsWithPosition(span, position) {
	    return position <= textSpanEnd(span) && position >= span.start;
	  }
	  function textSpanIntersection(span1, span2) {
	    const start = Math.max(span1.start, span2.start);
	    const end = Math.min(textSpanEnd(span1), textSpanEnd(span2));
	    return start <= end ? createTextSpanFromBounds(start, end) : void 0;
	  }
	  function createTextSpan(start, length2) {
	    if (start < 0) {
	      throw new Error("start < 0");
	    }
	    if (length2 < 0) {
	      throw new Error("length < 0");
	    }
	    return { start, length: length2 };
	  }
	  function createTextSpanFromBounds(start, end) {
	    return createTextSpan(start, end - start);
	  }
	  function textChangeRangeNewSpan(range) {
	    return createTextSpan(range.span.start, range.newLength);
	  }
	  function textChangeRangeIsUnchanged(range) {
	    return textSpanIsEmpty(range.span) && range.newLength === 0;
	  }
	  function createTextChangeRange(span, newLength) {
	    if (newLength < 0) {
	      throw new Error("newLength < 0");
	    }
	    return { span, newLength };
	  }
	  function collapseTextChangeRangesAcrossMultipleVersions(changes) {
	    if (changes.length === 0) {
	      return unchangedTextChangeRange;
	    }
	    if (changes.length === 1) {
	      return changes[0];
	    }
	    const change0 = changes[0];
	    let oldStartN = change0.span.start;
	    let oldEndN = textSpanEnd(change0.span);
	    let newEndN = oldStartN + change0.newLength;
	    for (let i = 1; i < changes.length; i++) {
	      const nextChange = changes[i];
	      const oldStart1 = oldStartN;
	      const oldEnd1 = oldEndN;
	      const newEnd1 = newEndN;
	      const oldStart2 = nextChange.span.start;
	      const oldEnd2 = textSpanEnd(nextChange.span);
	      const newEnd2 = oldStart2 + nextChange.newLength;
	      oldStartN = Math.min(oldStart1, oldStart2);
	      oldEndN = Math.max(oldEnd1, oldEnd1 + (oldEnd2 - newEnd1));
	      newEndN = Math.max(newEnd2, newEnd2 + (newEnd1 - oldEnd2));
	    }
	    return createTextChangeRange(
	      createTextSpanFromBounds(oldStartN, oldEndN),
	      /*newLength*/
	      newEndN - oldStartN
	    );
	  }
	  function getTypeParameterOwner(d) {
	    if (d && d.kind === 168 /* TypeParameter */) {
	      for (let current = d; current; current = current.parent) {
	        if (isFunctionLike(current) || isClassLike(current) || current.kind === 264 /* InterfaceDeclaration */) {
	          return current;
	        }
	      }
	    }
	  }
	  function isParameterPropertyDeclaration(node, parent2) {
	    return isParameter(node) && hasSyntacticModifier(node, 31 /* ParameterPropertyModifier */) && parent2.kind === 176 /* Constructor */;
	  }
	  function isEmptyBindingPattern(node) {
	    if (isBindingPattern(node)) {
	      return every(node.elements, isEmptyBindingElement);
	    }
	    return false;
	  }
	  function isEmptyBindingElement(node) {
	    if (isOmittedExpression(node)) {
	      return true;
	    }
	    return isEmptyBindingPattern(node.name);
	  }
	  function walkUpBindingElementsAndPatterns(binding) {
	    let node = binding.parent;
	    while (isBindingElement(node.parent)) {
	      node = node.parent.parent;
	    }
	    return node.parent;
	  }
	  function getCombinedFlags(node, getFlags) {
	    if (isBindingElement(node)) {
	      node = walkUpBindingElementsAndPatterns(node);
	    }
	    let flags = getFlags(node);
	    if (node.kind === 260 /* VariableDeclaration */) {
	      node = node.parent;
	    }
	    if (node && node.kind === 261 /* VariableDeclarationList */) {
	      flags |= getFlags(node);
	      node = node.parent;
	    }
	    if (node && node.kind === 243 /* VariableStatement */) {
	      flags |= getFlags(node);
	    }
	    return flags;
	  }
	  function getCombinedModifierFlags(node) {
	    return getCombinedFlags(node, getEffectiveModifierFlags);
	  }
	  function getCombinedNodeFlagsAlwaysIncludeJSDoc(node) {
	    return getCombinedFlags(node, getEffectiveModifierFlagsAlwaysIncludeJSDoc);
	  }
	  function getCombinedNodeFlags(node) {
	    return getCombinedFlags(node, getNodeFlags);
	  }
	  function getNodeFlags(node) {
	    return node.flags;
	  }
	  function validateLocaleAndSetLanguage(locale, sys2, errors) {
	    const lowerCaseLocale = locale.toLowerCase();
	    const matchResult = /^([a-z]+)([_-]([a-z]+))?$/.exec(lowerCaseLocale);
	    if (!matchResult) {
	      if (errors) {
	        errors.push(createCompilerDiagnostic(Diagnostics.Locale_must_be_of_the_form_language_or_language_territory_For_example_0_or_1, "en", "ja-jp"));
	      }
	      return;
	    }
	    const language = matchResult[1];
	    const territory = matchResult[3];
	    if (contains(supportedLocaleDirectories, lowerCaseLocale) && !trySetLanguageAndTerritory(language, territory, errors)) {
	      trySetLanguageAndTerritory(
	        language,
	        /*territory*/
	        void 0,
	        errors
	      );
	    }
	    setUILocale(locale);
	    function trySetLanguageAndTerritory(language2, territory2, errors2) {
	      const compilerFilePath = normalizePath(sys2.getExecutingFilePath());
	      const containingDirectoryPath = getDirectoryPath(compilerFilePath);
	      let filePath = combinePaths(containingDirectoryPath, language2);
	      if (territory2) {
	        filePath = filePath + "-" + territory2;
	      }
	      filePath = sys2.resolvePath(combinePaths(filePath, "diagnosticMessages.generated.json"));
	      if (!sys2.fileExists(filePath)) {
	        return false;
	      }
	      let fileContents = "";
	      try {
	        fileContents = sys2.readFile(filePath);
	      } catch (e) {
	        if (errors2) {
	          errors2.push(createCompilerDiagnostic(Diagnostics.Unable_to_open_file_0, filePath));
	        }
	        return false;
	      }
	      try {
	        setLocalizedDiagnosticMessages(JSON.parse(fileContents));
	      } catch {
	        if (errors2) {
	          errors2.push(createCompilerDiagnostic(Diagnostics.Corrupted_locale_file_0, filePath));
	        }
	        return false;
	      }
	      return true;
	    }
	  }
	  function getOriginalNode(node, nodeTest) {
	    if (node) {
	      while (node.original !== void 0) {
	        node = node.original;
	      }
	    }
	    if (!node || !nodeTest) {
	      return node;
	    }
	    return nodeTest(node) ? node : void 0;
	  }
	  function findAncestor(node, callback) {
	    while (node) {
	      const result = callback(node);
	      if (result === "quit") {
	        return void 0;
	      } else if (result) {
	        return node;
	      }
	      node = node.parent;
	    }
	    return void 0;
	  }
	  function isParseTreeNode(node) {
	    return (node.flags & 16 /* Synthesized */) === 0;
	  }
	  function getParseTreeNode(node, nodeTest) {
	    if (node === void 0 || isParseTreeNode(node)) {
	      return node;
	    }
	    node = node.original;
	    while (node) {
	      if (isParseTreeNode(node)) {
	        return !nodeTest || nodeTest(node) ? node : void 0;
	      }
	      node = node.original;
	    }
	  }
	  function escapeLeadingUnderscores(identifier) {
	    return identifier.length >= 2 && identifier.charCodeAt(0) === 95 /* _ */ && identifier.charCodeAt(1) === 95 /* _ */ ? "_" + identifier : identifier;
	  }
	  function unescapeLeadingUnderscores(identifier) {
	    const id = identifier;
	    return id.length >= 3 && id.charCodeAt(0) === 95 /* _ */ && id.charCodeAt(1) === 95 /* _ */ && id.charCodeAt(2) === 95 /* _ */ ? id.substr(1) : id;
	  }
	  function idText(identifierOrPrivateName) {
	    return unescapeLeadingUnderscores(identifierOrPrivateName.escapedText);
	  }
	  function identifierToKeywordKind(node) {
	    const token = stringToToken(node.escapedText);
	    return token ? tryCast(token, isKeyword) : void 0;
	  }
	  function symbolName(symbol) {
	    if (symbol.valueDeclaration && isPrivateIdentifierClassElementDeclaration(symbol.valueDeclaration)) {
	      return idText(symbol.valueDeclaration.name);
	    }
	    return unescapeLeadingUnderscores(symbol.escapedName);
	  }
	  function nameForNamelessJSDocTypedef(declaration) {
	    const hostNode = declaration.parent.parent;
	    if (!hostNode) {
	      return void 0;
	    }
	    if (isDeclaration(hostNode)) {
	      return getDeclarationIdentifier(hostNode);
	    }
	    switch (hostNode.kind) {
	      case 243 /* VariableStatement */:
	        if (hostNode.declarationList && hostNode.declarationList.declarations[0]) {
	          return getDeclarationIdentifier(hostNode.declarationList.declarations[0]);
	        }
	        break;
	      case 244 /* ExpressionStatement */:
	        let expr = hostNode.expression;
	        if (expr.kind === 226 /* BinaryExpression */ && expr.operatorToken.kind === 64 /* EqualsToken */) {
	          expr = expr.left;
	        }
	        switch (expr.kind) {
	          case 211 /* PropertyAccessExpression */:
	            return expr.name;
	          case 212 /* ElementAccessExpression */:
	            const arg = expr.argumentExpression;
	            if (isIdentifier(arg)) {
	              return arg;
	            }
	        }
	        break;
	      case 217 /* ParenthesizedExpression */: {
	        return getDeclarationIdentifier(hostNode.expression);
	      }
	      case 256 /* LabeledStatement */: {
	        if (isDeclaration(hostNode.statement) || isExpression(hostNode.statement)) {
	          return getDeclarationIdentifier(hostNode.statement);
	        }
	        break;
	      }
	    }
	  }
	  function getDeclarationIdentifier(node) {
	    const name = getNameOfDeclaration(node);
	    return name && isIdentifier(name) ? name : void 0;
	  }
	  function nodeHasName(statement, name) {
	    if (isNamedDeclaration(statement) && isIdentifier(statement.name) && idText(statement.name) === idText(name)) {
	      return true;
	    }
	    if (isVariableStatement(statement) && some(statement.declarationList.declarations, (d) => nodeHasName(d, name))) {
	      return true;
	    }
	    return false;
	  }
	  function getNameOfJSDocTypedef(declaration) {
	    return declaration.name || nameForNamelessJSDocTypedef(declaration);
	  }
	  function isNamedDeclaration(node) {
	    return !!node.name;
	  }
	  function getNonAssignedNameOfDeclaration(declaration) {
	    switch (declaration.kind) {
	      case 80 /* Identifier */:
	        return declaration;
	      case 355 /* JSDocPropertyTag */:
	      case 348 /* JSDocParameterTag */: {
	        const { name } = declaration;
	        if (name.kind === 166 /* QualifiedName */) {
	          return name.right;
	        }
	        break;
	      }
	      case 213 /* CallExpression */:
	      case 226 /* BinaryExpression */: {
	        const expr2 = declaration;
	        switch (getAssignmentDeclarationKind(expr2)) {
	          case 1 /* ExportsProperty */:
	          case 4 /* ThisProperty */:
	          case 5 /* Property */:
	          case 3 /* PrototypeProperty */:
	            return getElementOrPropertyAccessArgumentExpressionOrName(expr2.left);
	          case 7 /* ObjectDefinePropertyValue */:
	          case 8 /* ObjectDefinePropertyExports */:
	          case 9 /* ObjectDefinePrototypeProperty */:
	            return expr2.arguments[1];
	          default:
	            return void 0;
	        }
	      }
	      case 353 /* JSDocTypedefTag */:
	        return getNameOfJSDocTypedef(declaration);
	      case 347 /* JSDocEnumTag */:
	        return nameForNamelessJSDocTypedef(declaration);
	      case 277 /* ExportAssignment */: {
	        const { expression } = declaration;
	        return isIdentifier(expression) ? expression : void 0;
	      }
	      case 212 /* ElementAccessExpression */:
	        const expr = declaration;
	        if (isBindableStaticElementAccessExpression(expr)) {
	          return expr.argumentExpression;
	        }
	    }
	    return declaration.name;
	  }
	  function getNameOfDeclaration(declaration) {
	    if (declaration === void 0)
	      return void 0;
	    return getNonAssignedNameOfDeclaration(declaration) || (isFunctionExpression(declaration) || isArrowFunction(declaration) || isClassExpression(declaration) ? getAssignedName(declaration) : void 0);
	  }
	  function getAssignedName(node) {
	    if (!node.parent) {
	      return void 0;
	    } else if (isPropertyAssignment(node.parent) || isBindingElement(node.parent)) {
	      return node.parent.name;
	    } else if (isBinaryExpression(node.parent) && node === node.parent.right) {
	      if (isIdentifier(node.parent.left)) {
	        return node.parent.left;
	      } else if (isAccessExpression(node.parent.left)) {
	        return getElementOrPropertyAccessArgumentExpressionOrName(node.parent.left);
	      }
	    } else if (isVariableDeclaration(node.parent) && isIdentifier(node.parent.name)) {
	      return node.parent.name;
	    }
	  }
	  function getDecorators(node) {
	    if (hasDecorators(node)) {
	      return filter(node.modifiers, isDecorator);
	    }
	  }
	  function getModifiers(node) {
	    if (hasSyntacticModifier(node, 98303 /* Modifier */)) {
	      return filter(node.modifiers, isModifier);
	    }
	  }
	  function getJSDocParameterTagsWorker(param, noCache) {
	    if (param.name) {
	      if (isIdentifier(param.name)) {
	        const name = param.name.escapedText;
	        return getJSDocTagsWorker(param.parent, noCache).filter((tag) => isJSDocParameterTag(tag) && isIdentifier(tag.name) && tag.name.escapedText === name);
	      } else {
	        const i = param.parent.parameters.indexOf(param);
	        Debug.assert(i > -1, "Parameters should always be in their parents' parameter list");
	        const paramTags = getJSDocTagsWorker(param.parent, noCache).filter(isJSDocParameterTag);
	        if (i < paramTags.length) {
	          return [paramTags[i]];
	        }
	      }
	    }
	    return emptyArray;
	  }
	  function getJSDocParameterTags(param) {
	    return getJSDocParameterTagsWorker(
	      param,
	      /*noCache*/
	      false
	    );
	  }
	  function getJSDocParameterTagsNoCache(param) {
	    return getJSDocParameterTagsWorker(
	      param,
	      /*noCache*/
	      true
	    );
	  }
	  function getJSDocTypeParameterTagsWorker(param, noCache) {
	    const name = param.name.escapedText;
	    return getJSDocTagsWorker(param.parent, noCache).filter((tag) => isJSDocTemplateTag(tag) && tag.typeParameters.some((tp) => tp.name.escapedText === name));
	  }
	  function getJSDocTypeParameterTags(param) {
	    return getJSDocTypeParameterTagsWorker(
	      param,
	      /*noCache*/
	      false
	    );
	  }
	  function getJSDocTypeParameterTagsNoCache(param) {
	    return getJSDocTypeParameterTagsWorker(
	      param,
	      /*noCache*/
	      true
	    );
	  }
	  function hasJSDocParameterTags(node) {
	    return !!getFirstJSDocTag(node, isJSDocParameterTag);
	  }
	  function getJSDocAugmentsTag(node) {
	    return getFirstJSDocTag(node, isJSDocAugmentsTag);
	  }
	  function getJSDocImplementsTags(node) {
	    return getAllJSDocTags(node, isJSDocImplementsTag);
	  }
	  function getJSDocClassTag(node) {
	    return getFirstJSDocTag(node, isJSDocClassTag);
	  }
	  function getJSDocPublicTag(node) {
	    return getFirstJSDocTag(node, isJSDocPublicTag);
	  }
	  function getJSDocPublicTagNoCache(node) {
	    return getFirstJSDocTag(
	      node,
	      isJSDocPublicTag,
	      /*noCache*/
	      true
	    );
	  }
	  function getJSDocPrivateTag(node) {
	    return getFirstJSDocTag(node, isJSDocPrivateTag);
	  }
	  function getJSDocPrivateTagNoCache(node) {
	    return getFirstJSDocTag(
	      node,
	      isJSDocPrivateTag,
	      /*noCache*/
	      true
	    );
	  }
	  function getJSDocProtectedTag(node) {
	    return getFirstJSDocTag(node, isJSDocProtectedTag);
	  }
	  function getJSDocProtectedTagNoCache(node) {
	    return getFirstJSDocTag(
	      node,
	      isJSDocProtectedTag,
	      /*noCache*/
	      true
	    );
	  }
	  function getJSDocReadonlyTag(node) {
	    return getFirstJSDocTag(node, isJSDocReadonlyTag);
	  }
	  function getJSDocReadonlyTagNoCache(node) {
	    return getFirstJSDocTag(
	      node,
	      isJSDocReadonlyTag,
	      /*noCache*/
	      true
	    );
	  }
	  function getJSDocOverrideTagNoCache(node) {
	    return getFirstJSDocTag(
	      node,
	      isJSDocOverrideTag,
	      /*noCache*/
	      true
	    );
	  }
	  function getJSDocDeprecatedTag(node) {
	    return getFirstJSDocTag(node, isJSDocDeprecatedTag);
	  }
	  function getJSDocDeprecatedTagNoCache(node) {
	    return getFirstJSDocTag(
	      node,
	      isJSDocDeprecatedTag,
	      /*noCache*/
	      true
	    );
	  }
	  function getJSDocEnumTag(node) {
	    return getFirstJSDocTag(node, isJSDocEnumTag);
	  }
	  function getJSDocThisTag(node) {
	    return getFirstJSDocTag(node, isJSDocThisTag);
	  }
	  function getJSDocReturnTag(node) {
	    return getFirstJSDocTag(node, isJSDocReturnTag);
	  }
	  function getJSDocTemplateTag(node) {
	    return getFirstJSDocTag(node, isJSDocTemplateTag);
	  }
	  function getJSDocSatisfiesTag(node) {
	    return getFirstJSDocTag(node, isJSDocSatisfiesTag);
	  }
	  function getJSDocTypeTag(node) {
	    const tag = getFirstJSDocTag(node, isJSDocTypeTag);
	    if (tag && tag.typeExpression && tag.typeExpression.type) {
	      return tag;
	    }
	    return void 0;
	  }
	  function getJSDocType(node) {
	    let tag = getFirstJSDocTag(node, isJSDocTypeTag);
	    if (!tag && isParameter(node)) {
	      tag = find(getJSDocParameterTags(node), (tag2) => !!tag2.typeExpression);
	    }
	    return tag && tag.typeExpression && tag.typeExpression.type;
	  }
	  function getJSDocReturnType(node) {
	    const returnTag = getJSDocReturnTag(node);
	    if (returnTag && returnTag.typeExpression) {
	      return returnTag.typeExpression.type;
	    }
	    const typeTag = getJSDocTypeTag(node);
	    if (typeTag && typeTag.typeExpression) {
	      const type = typeTag.typeExpression.type;
	      if (isTypeLiteralNode(type)) {
	        const sig = find(type.members, isCallSignatureDeclaration);
	        return sig && sig.type;
	      }
	      if (isFunctionTypeNode(type) || isJSDocFunctionType(type)) {
	        return type.type;
	      }
	    }
	  }
	  function getJSDocTagsWorker(node, noCache) {
	    var _a;
	    if (!canHaveJSDoc(node))
	      return emptyArray;
	    let tags = (_a = node.jsDoc) == null ? void 0 : _a.jsDocCache;
	    if (tags === void 0 || noCache) {
	      const comments = getJSDocCommentsAndTags(node, noCache);
	      Debug.assert(comments.length < 2 || comments[0] !== comments[1]);
	      tags = flatMap(comments, (j) => isJSDoc(j) ? j.tags : j);
	      if (!noCache) {
	        node.jsDoc ?? (node.jsDoc = []);
	        node.jsDoc.jsDocCache = tags;
	      }
	    }
	    return tags;
	  }
	  function getJSDocTags(node) {
	    return getJSDocTagsWorker(
	      node,
	      /*noCache*/
	      false
	    );
	  }
	  function getJSDocTagsNoCache(node) {
	    return getJSDocTagsWorker(
	      node,
	      /*noCache*/
	      true
	    );
	  }
	  function getFirstJSDocTag(node, predicate, noCache) {
	    return find(getJSDocTagsWorker(node, noCache), predicate);
	  }
	  function getAllJSDocTags(node, predicate) {
	    return getJSDocTags(node).filter(predicate);
	  }
	  function getAllJSDocTagsOfKind(node, kind) {
	    return getJSDocTags(node).filter((doc) => doc.kind === kind);
	  }
	  function getTextOfJSDocComment(comment) {
	    return typeof comment === "string" ? comment : comment == null ? void 0 : comment.map((c) => c.kind === 328 /* JSDocText */ ? c.text : formatJSDocLink(c)).join("");
	  }
	  function formatJSDocLink(link) {
	    const kind = link.kind === 331 /* JSDocLink */ ? "link" : link.kind === 332 /* JSDocLinkCode */ ? "linkcode" : "linkplain";
	    const name = link.name ? entityNameToString(link.name) : "";
	    const space = link.name && link.text.startsWith("://") ? "" : " ";
	    return `{@${kind} ${name}${space}${link.text}}`;
	  }
	  function getEffectiveTypeParameterDeclarations(node) {
	    if (isJSDocSignature(node)) {
	      if (isJSDocOverloadTag(node.parent)) {
	        const jsDoc = getJSDocRoot(node.parent);
	        if (jsDoc && length(jsDoc.tags)) {
	          return flatMap(jsDoc.tags, (tag) => isJSDocTemplateTag(tag) ? tag.typeParameters : void 0);
	        }
	      }
	      return emptyArray;
	    }
	    if (isJSDocTypeAlias(node)) {
	      Debug.assert(node.parent.kind === 327 /* JSDoc */);
	      return flatMap(node.parent.tags, (tag) => isJSDocTemplateTag(tag) ? tag.typeParameters : void 0);
	    }
	    if (node.typeParameters) {
	      return node.typeParameters;
	    }
	    if (canHaveIllegalTypeParameters(node) && node.typeParameters) {
	      return node.typeParameters;
	    }
	    if (isInJSFile(node)) {
	      const decls = getJSDocTypeParameterDeclarations(node);
	      if (decls.length) {
	        return decls;
	      }
	      const typeTag = getJSDocType(node);
	      if (typeTag && isFunctionTypeNode(typeTag) && typeTag.typeParameters) {
	        return typeTag.typeParameters;
	      }
	    }
	    return emptyArray;
	  }
	  function getEffectiveConstraintOfTypeParameter(node) {
	    return node.constraint ? node.constraint : isJSDocTemplateTag(node.parent) && node === node.parent.typeParameters[0] ? node.parent.constraint : void 0;
	  }
	  function isMemberName(node) {
	    return node.kind === 80 /* Identifier */ || node.kind === 81 /* PrivateIdentifier */;
	  }
	  function isGetOrSetAccessorDeclaration(node) {
	    return node.kind === 178 /* SetAccessor */ || node.kind === 177 /* GetAccessor */;
	  }
	  function isPropertyAccessChain(node) {
	    return isPropertyAccessExpression(node) && !!(node.flags & 64 /* OptionalChain */);
	  }
	  function isElementAccessChain(node) {
	    return isElementAccessExpression(node) && !!(node.flags & 64 /* OptionalChain */);
	  }
	  function isCallChain(node) {
	    return isCallExpression(node) && !!(node.flags & 64 /* OptionalChain */);
	  }
	  function isOptionalChain(node) {
	    const kind = node.kind;
	    return !!(node.flags & 64 /* OptionalChain */) && (kind === 211 /* PropertyAccessExpression */ || kind === 212 /* ElementAccessExpression */ || kind === 213 /* CallExpression */ || kind === 235 /* NonNullExpression */);
	  }
	  function isOptionalChainRoot(node) {
	    return isOptionalChain(node) && !isNonNullExpression(node) && !!node.questionDotToken;
	  }
	  function isExpressionOfOptionalChainRoot(node) {
	    return isOptionalChainRoot(node.parent) && node.parent.expression === node;
	  }
	  function isOutermostOptionalChain(node) {
	    return !isOptionalChain(node.parent) || isOptionalChainRoot(node.parent) || node !== node.parent.expression;
	  }
	  function isNullishCoalesce(node) {
	    return node.kind === 226 /* BinaryExpression */ && node.operatorToken.kind === 61 /* QuestionQuestionToken */;
	  }
	  function isConstTypeReference(node) {
	    return isTypeReferenceNode(node) && isIdentifier(node.typeName) && node.typeName.escapedText === "const" && !node.typeArguments;
	  }
	  function skipPartiallyEmittedExpressions(node) {
	    return skipOuterExpressions(node, 8 /* PartiallyEmittedExpressions */);
	  }
	  function isNonNullChain(node) {
	    return isNonNullExpression(node) && !!(node.flags & 64 /* OptionalChain */);
	  }
	  function isBreakOrContinueStatement(node) {
	    return node.kind === 252 /* BreakStatement */ || node.kind === 251 /* ContinueStatement */;
	  }
	  function isNamedExportBindings(node) {
	    return node.kind === 280 /* NamespaceExport */ || node.kind === 279 /* NamedExports */;
	  }
	  function isUnparsedTextLike(node) {
	    switch (node.kind) {
	      case 309 /* UnparsedText */:
	      case 310 /* UnparsedInternalText */:
	        return true;
	      default:
	        return false;
	    }
	  }
	  function isUnparsedNode(node) {
	    return isUnparsedTextLike(node) || node.kind === 307 /* UnparsedPrologue */ || node.kind === 311 /* UnparsedSyntheticReference */;
	  }
	  function isJSDocPropertyLikeTag(node) {
	    return node.kind === 355 /* JSDocPropertyTag */ || node.kind === 348 /* JSDocParameterTag */;
	  }
	  function isNode(node) {
	    return isNodeKind(node.kind);
	  }
	  function isNodeKind(kind) {
	    return kind >= 166 /* FirstNode */;
	  }
	  function isTokenKind(kind) {
	    return kind >= 0 /* FirstToken */ && kind <= 165 /* LastToken */;
	  }
	  function isToken(n) {
	    return isTokenKind(n.kind);
	  }
	  function isNodeArray(array) {
	    return hasProperty(array, "pos") && hasProperty(array, "end");
	  }
	  function isLiteralKind(kind) {
	    return 9 /* FirstLiteralToken */ <= kind && kind <= 15 /* LastLiteralToken */;
	  }
	  function isLiteralExpression(node) {
	    return isLiteralKind(node.kind);
	  }
	  function isLiteralExpressionOfObject(node) {
	    switch (node.kind) {
	      case 210 /* ObjectLiteralExpression */:
	      case 209 /* ArrayLiteralExpression */:
	      case 14 /* RegularExpressionLiteral */:
	      case 218 /* FunctionExpression */:
	      case 231 /* ClassExpression */:
	        return true;
	    }
	    return false;
	  }
	  function isTemplateLiteralKind(kind) {
	    return 15 /* FirstTemplateToken */ <= kind && kind <= 18 /* LastTemplateToken */;
	  }
	  function isTemplateLiteralToken(node) {
	    return isTemplateLiteralKind(node.kind);
	  }
	  function isTemplateMiddleOrTemplateTail(node) {
	    const kind = node.kind;
	    return kind === 17 /* TemplateMiddle */ || kind === 18 /* TemplateTail */;
	  }
	  function isImportOrExportSpecifier(node) {
	    return isImportSpecifier(node) || isExportSpecifier(node);
	  }
	  function isTypeOnlyImportDeclaration(node) {
	    switch (node.kind) {
	      case 276 /* ImportSpecifier */:
	        return node.isTypeOnly || node.parent.parent.isTypeOnly;
	      case 274 /* NamespaceImport */:
	        return node.parent.isTypeOnly;
	      case 273 /* ImportClause */:
	      case 271 /* ImportEqualsDeclaration */:
	        return node.isTypeOnly;
	    }
	    return false;
	  }
	  function isTypeOnlyExportDeclaration(node) {
	    switch (node.kind) {
	      case 281 /* ExportSpecifier */:
	        return node.isTypeOnly || node.parent.parent.isTypeOnly;
	      case 278 /* ExportDeclaration */:
	        return node.isTypeOnly && !!node.moduleSpecifier && !node.exportClause;
	      case 280 /* NamespaceExport */:
	        return node.parent.isTypeOnly;
	    }
	    return false;
	  }
	  function isTypeOnlyImportOrExportDeclaration(node) {
	    return isTypeOnlyImportDeclaration(node) || isTypeOnlyExportDeclaration(node);
	  }
	  function isStringTextContainingNode(node) {
	    return node.kind === 11 /* StringLiteral */ || isTemplateLiteralKind(node.kind);
	  }
	  function isImportAttributeName(node) {
	    return isStringLiteral(node) || isIdentifier(node);
	  }
	  function isGeneratedIdentifier(node) {
	    var _a;
	    return isIdentifier(node) && ((_a = node.emitNode) == null ? void 0 : _a.autoGenerate) !== void 0;
	  }
	  function isGeneratedPrivateIdentifier(node) {
	    var _a;
	    return isPrivateIdentifier(node) && ((_a = node.emitNode) == null ? void 0 : _a.autoGenerate) !== void 0;
	  }
	  function isFileLevelReservedGeneratedIdentifier(node) {
	    const flags = node.emitNode.autoGenerate.flags;
	    return !!(flags & 32 /* FileLevel */) && !!(flags & 16 /* Optimistic */) && !!(flags & 8 /* ReservedInNestedScopes */);
	  }
	  function isPrivateIdentifierClassElementDeclaration(node) {
	    return (isPropertyDeclaration(node) || isMethodOrAccessor(node)) && isPrivateIdentifier(node.name);
	  }
	  function isPrivateIdentifierPropertyAccessExpression(node) {
	    return isPropertyAccessExpression(node) && isPrivateIdentifier(node.name);
	  }
	  function isModifierKind(token) {
	    switch (token) {
	      case 128 /* AbstractKeyword */:
	      case 129 /* AccessorKeyword */:
	      case 134 /* AsyncKeyword */:
	      case 87 /* ConstKeyword */:
	      case 138 /* DeclareKeyword */:
	      case 90 /* DefaultKeyword */:
	      case 95 /* ExportKeyword */:
	      case 103 /* InKeyword */:
	      case 125 /* PublicKeyword */:
	      case 123 /* PrivateKeyword */:
	      case 124 /* ProtectedKeyword */:
	      case 148 /* ReadonlyKeyword */:
	      case 126 /* StaticKeyword */:
	      case 147 /* OutKeyword */:
	      case 164 /* OverrideKeyword */:
	        return true;
	    }
	    return false;
	  }
	  function isParameterPropertyModifier(kind) {
	    return !!(modifierToFlag(kind) & 31 /* ParameterPropertyModifier */);
	  }
	  function isClassMemberModifier(idToken) {
	    return isParameterPropertyModifier(idToken) || idToken === 126 /* StaticKeyword */ || idToken === 164 /* OverrideKeyword */ || idToken === 129 /* AccessorKeyword */;
	  }
	  function isModifier(node) {
	    return isModifierKind(node.kind);
	  }
	  function isEntityName(node) {
	    const kind = node.kind;
	    return kind === 166 /* QualifiedName */ || kind === 80 /* Identifier */;
	  }
	  function isPropertyName(node) {
	    const kind = node.kind;
	    return kind === 80 /* Identifier */ || kind === 81 /* PrivateIdentifier */ || kind === 11 /* StringLiteral */ || kind === 9 /* NumericLiteral */ || kind === 167 /* ComputedPropertyName */;
	  }
	  function isBindingName(node) {
	    const kind = node.kind;
	    return kind === 80 /* Identifier */ || kind === 206 /* ObjectBindingPattern */ || kind === 207 /* ArrayBindingPattern */;
	  }
	  function isFunctionLike(node) {
	    return !!node && isFunctionLikeKind(node.kind);
	  }
	  function isFunctionLikeOrClassStaticBlockDeclaration(node) {
	    return !!node && (isFunctionLikeKind(node.kind) || isClassStaticBlockDeclaration(node));
	  }
	  function isFunctionLikeDeclaration(node) {
	    return node && isFunctionLikeDeclarationKind(node.kind);
	  }
	  function isBooleanLiteral(node) {
	    return node.kind === 112 /* TrueKeyword */ || node.kind === 97 /* FalseKeyword */;
	  }
	  function isFunctionLikeDeclarationKind(kind) {
	    switch (kind) {
	      case 262 /* FunctionDeclaration */:
	      case 174 /* MethodDeclaration */:
	      case 176 /* Constructor */:
	      case 177 /* GetAccessor */:
	      case 178 /* SetAccessor */:
	      case 218 /* FunctionExpression */:
	      case 219 /* ArrowFunction */:
	        return true;
	      default:
	        return false;
	    }
	  }
	  function isFunctionLikeKind(kind) {
	    switch (kind) {
	      case 173 /* MethodSignature */:
	      case 179 /* CallSignature */:
	      case 330 /* JSDocSignature */:
	      case 180 /* ConstructSignature */:
	      case 181 /* IndexSignature */:
	      case 184 /* FunctionType */:
	      case 324 /* JSDocFunctionType */:
	      case 185 /* ConstructorType */:
	        return true;
	      default:
	        return isFunctionLikeDeclarationKind(kind);
	    }
	  }
	  function isFunctionOrModuleBlock(node) {
	    return isSourceFile(node) || isModuleBlock(node) || isBlock(node) && isFunctionLike(node.parent);
	  }
	  function isClassElement(node) {
	    const kind = node.kind;
	    return kind === 176 /* Constructor */ || kind === 172 /* PropertyDeclaration */ || kind === 174 /* MethodDeclaration */ || kind === 177 /* GetAccessor */ || kind === 178 /* SetAccessor */ || kind === 181 /* IndexSignature */ || kind === 175 /* ClassStaticBlockDeclaration */ || kind === 240 /* SemicolonClassElement */;
	  }
	  function isClassLike(node) {
	    return node && (node.kind === 263 /* ClassDeclaration */ || node.kind === 231 /* ClassExpression */);
	  }
	  function isAccessor(node) {
	    return node && (node.kind === 177 /* GetAccessor */ || node.kind === 178 /* SetAccessor */);
	  }
	  function isAutoAccessorPropertyDeclaration(node) {
	    return isPropertyDeclaration(node) && hasAccessorModifier(node);
	  }
	  function isClassInstanceProperty(node) {
	    if (isInJSFile(node) && isExpandoPropertyDeclaration(node)) {
	      return (!isBindableStaticAccessExpression(node) || !isPrototypeAccess(node.expression)) && !isBindableStaticNameExpression(
	        node,
	        /*excludeThisKeyword*/
	        true
	      );
	    }
	    return node.parent && isClassLike(node.parent) && isPropertyDeclaration(node) && !hasAccessorModifier(node);
	  }
	  function isMethodOrAccessor(node) {
	    switch (node.kind) {
	      case 174 /* MethodDeclaration */:
	      case 177 /* GetAccessor */:
	      case 178 /* SetAccessor */:
	        return true;
	      default:
	        return false;
	    }
	  }
	  function isNamedClassElement(node) {
	    switch (node.kind) {
	      case 174 /* MethodDeclaration */:
	      case 177 /* GetAccessor */:
	      case 178 /* SetAccessor */:
	      case 172 /* PropertyDeclaration */:
	        return true;
	      default:
	        return false;
	    }
	  }
	  function isModifierLike(node) {
	    return isModifier(node) || isDecorator(node);
	  }
	  function isTypeElement(node) {
	    const kind = node.kind;
	    return kind === 180 /* ConstructSignature */ || kind === 179 /* CallSignature */ || kind === 171 /* PropertySignature */ || kind === 173 /* MethodSignature */ || kind === 181 /* IndexSignature */ || kind === 177 /* GetAccessor */ || kind === 178 /* SetAccessor */;
	  }
	  function isClassOrTypeElement(node) {
	    return isTypeElement(node) || isClassElement(node);
	  }
	  function isObjectLiteralElementLike(node) {
	    const kind = node.kind;
	    return kind === 303 /* PropertyAssignment */ || kind === 304 /* ShorthandPropertyAssignment */ || kind === 305 /* SpreadAssignment */ || kind === 174 /* MethodDeclaration */ || kind === 177 /* GetAccessor */ || kind === 178 /* SetAccessor */;
	  }
	  function isTypeNode(node) {
	    return isTypeNodeKind(node.kind);
	  }
	  function isFunctionOrConstructorTypeNode(node) {
	    switch (node.kind) {
	      case 184 /* FunctionType */:
	      case 185 /* ConstructorType */:
	        return true;
	    }
	    return false;
	  }
	  function isBindingPattern(node) {
	    if (node) {
	      const kind = node.kind;
	      return kind === 207 /* ArrayBindingPattern */ || kind === 206 /* ObjectBindingPattern */;
	    }
	    return false;
	  }
	  function isAssignmentPattern(node) {
	    const kind = node.kind;
	    return kind === 209 /* ArrayLiteralExpression */ || kind === 210 /* ObjectLiteralExpression */;
	  }
	  function isArrayBindingElement(node) {
	    const kind = node.kind;
	    return kind === 208 /* BindingElement */ || kind === 232 /* OmittedExpression */;
	  }
	  function isDeclarationBindingElement(bindingElement) {
	    switch (bindingElement.kind) {
	      case 260 /* VariableDeclaration */:
	      case 169 /* Parameter */:
	      case 208 /* BindingElement */:
	        return true;
	    }
	    return false;
	  }
	  function isBindingOrAssignmentElement(node) {
	    return isVariableDeclaration(node) || isParameter(node) || isObjectBindingOrAssignmentElement(node) || isArrayBindingOrAssignmentElement(node);
	  }
	  function isBindingOrAssignmentPattern(node) {
	    return isObjectBindingOrAssignmentPattern(node) || isArrayBindingOrAssignmentPattern(node);
	  }
	  function isObjectBindingOrAssignmentPattern(node) {
	    switch (node.kind) {
	      case 206 /* ObjectBindingPattern */:
	      case 210 /* ObjectLiteralExpression */:
	        return true;
	    }
	    return false;
	  }
	  function isObjectBindingOrAssignmentElement(node) {
	    switch (node.kind) {
	      case 208 /* BindingElement */:
	      case 303 /* PropertyAssignment */:
	      case 304 /* ShorthandPropertyAssignment */:
	      case 305 /* SpreadAssignment */:
	        return true;
	    }
	    return false;
	  }
	  function isArrayBindingOrAssignmentPattern(node) {
	    switch (node.kind) {
	      case 207 /* ArrayBindingPattern */:
	      case 209 /* ArrayLiteralExpression */:
	        return true;
	    }
	    return false;
	  }
	  function isArrayBindingOrAssignmentElement(node) {
	    switch (node.kind) {
	      case 208 /* BindingElement */:
	      case 232 /* OmittedExpression */:
	      case 230 /* SpreadElement */:
	      case 209 /* ArrayLiteralExpression */:
	      case 210 /* ObjectLiteralExpression */:
	      case 80 /* Identifier */:
	      case 211 /* PropertyAccessExpression */:
	      case 212 /* ElementAccessExpression */:
	        return true;
	    }
	    return isAssignmentExpression(
	      node,
	      /*excludeCompoundAssignment*/
	      true
	    );
	  }
	  function isPropertyAccessOrQualifiedNameOrImportTypeNode(node) {
	    const kind = node.kind;
	    return kind === 211 /* PropertyAccessExpression */ || kind === 166 /* QualifiedName */ || kind === 205 /* ImportType */;
	  }
	  function isPropertyAccessOrQualifiedName(node) {
	    const kind = node.kind;
	    return kind === 211 /* PropertyAccessExpression */ || kind === 166 /* QualifiedName */;
	  }
	  function isCallLikeOrFunctionLikeExpression(node) {
	    return isCallLikeExpression(node) || isFunctionExpressionOrArrowFunction(node);
	  }
	  function isCallLikeExpression(node) {
	    switch (node.kind) {
	      case 286 /* JsxOpeningElement */:
	      case 285 /* JsxSelfClosingElement */:
	      case 213 /* CallExpression */:
	      case 214 /* NewExpression */:
	      case 215 /* TaggedTemplateExpression */:
	      case 170 /* Decorator */:
	        return true;
	      default:
	        return false;
	    }
	  }
	  function isCallOrNewExpression(node) {
	    return node.kind === 213 /* CallExpression */ || node.kind === 214 /* NewExpression */;
	  }
	  function isTemplateLiteral(node) {
	    const kind = node.kind;
	    return kind === 228 /* TemplateExpression */ || kind === 15 /* NoSubstitutionTemplateLiteral */;
	  }
	  function isLeftHandSideExpression(node) {
	    return isLeftHandSideExpressionKind(skipPartiallyEmittedExpressions(node).kind);
	  }
	  function isLeftHandSideExpressionKind(kind) {
	    switch (kind) {
	      case 211 /* PropertyAccessExpression */:
	      case 212 /* ElementAccessExpression */:
	      case 214 /* NewExpression */:
	      case 213 /* CallExpression */:
	      case 284 /* JsxElement */:
	      case 285 /* JsxSelfClosingElement */:
	      case 288 /* JsxFragment */:
	      case 215 /* TaggedTemplateExpression */:
	      case 209 /* ArrayLiteralExpression */:
	      case 217 /* ParenthesizedExpression */:
	      case 210 /* ObjectLiteralExpression */:
	      case 231 /* ClassExpression */:
	      case 218 /* FunctionExpression */:
	      case 80 /* Identifier */:
	      case 81 /* PrivateIdentifier */:
	      case 14 /* RegularExpressionLiteral */:
	      case 9 /* NumericLiteral */:
	      case 10 /* BigIntLiteral */:
	      case 11 /* StringLiteral */:
	      case 15 /* NoSubstitutionTemplateLiteral */:
	      case 228 /* TemplateExpression */:
	      case 97 /* FalseKeyword */:
	      case 106 /* NullKeyword */:
	      case 110 /* ThisKeyword */:
	      case 112 /* TrueKeyword */:
	      case 108 /* SuperKeyword */:
	      case 235 /* NonNullExpression */:
	      case 233 /* ExpressionWithTypeArguments */:
	      case 236 /* MetaProperty */:
	      case 102 /* ImportKeyword */:
	      case 282 /* MissingDeclaration */:
	        return true;
	      default:
	        return false;
	    }
	  }
	  function isUnaryExpression(node) {
	    return isUnaryExpressionKind(skipPartiallyEmittedExpressions(node).kind);
	  }
	  function isUnaryExpressionKind(kind) {
	    switch (kind) {
	      case 224 /* PrefixUnaryExpression */:
	      case 225 /* PostfixUnaryExpression */:
	      case 220 /* DeleteExpression */:
	      case 221 /* TypeOfExpression */:
	      case 222 /* VoidExpression */:
	      case 223 /* AwaitExpression */:
	      case 216 /* TypeAssertionExpression */:
	        return true;
	      default:
	        return isLeftHandSideExpressionKind(kind);
	    }
	  }
	  function isUnaryExpressionWithWrite(expr) {
	    switch (expr.kind) {
	      case 225 /* PostfixUnaryExpression */:
	        return true;
	      case 224 /* PrefixUnaryExpression */:
	        return expr.operator === 46 /* PlusPlusToken */ || expr.operator === 47 /* MinusMinusToken */;
	      default:
	        return false;
	    }
	  }
	  function isLiteralTypeLiteral(node) {
	    switch (node.kind) {
	      case 106 /* NullKeyword */:
	      case 112 /* TrueKeyword */:
	      case 97 /* FalseKeyword */:
	      case 224 /* PrefixUnaryExpression */:
	        return true;
	      default:
	        return isLiteralExpression(node);
	    }
	  }
	  function isExpression(node) {
	    return isExpressionKind(skipPartiallyEmittedExpressions(node).kind);
	  }
	  function isExpressionKind(kind) {
	    switch (kind) {
	      case 227 /* ConditionalExpression */:
	      case 229 /* YieldExpression */:
	      case 219 /* ArrowFunction */:
	      case 226 /* BinaryExpression */:
	      case 230 /* SpreadElement */:
	      case 234 /* AsExpression */:
	      case 232 /* OmittedExpression */:
	      case 361 /* CommaListExpression */:
	      case 360 /* PartiallyEmittedExpression */:
	      case 238 /* SatisfiesExpression */:
	        return true;
	      default:
	        return isUnaryExpressionKind(kind);
	    }
	  }
	  function isAssertionExpression(node) {
	    const kind = node.kind;
	    return kind === 216 /* TypeAssertionExpression */ || kind === 234 /* AsExpression */;
	  }
	  function isNotEmittedOrPartiallyEmittedNode(node) {
	    return isNotEmittedStatement(node) || isPartiallyEmittedExpression(node);
	  }
	  function isIterationStatement(node, lookInLabeledStatements) {
	    switch (node.kind) {
	      case 248 /* ForStatement */:
	      case 249 /* ForInStatement */:
	      case 250 /* ForOfStatement */:
	      case 246 /* DoStatement */:
	      case 247 /* WhileStatement */:
	        return true;
	      case 256 /* LabeledStatement */:
	        return lookInLabeledStatements && isIterationStatement(node.statement, lookInLabeledStatements);
	    }
	    return false;
	  }
	  function isScopeMarker(node) {
	    return isExportAssignment(node) || isExportDeclaration(node);
	  }
	  function hasScopeMarker(statements) {
	    return some(statements, isScopeMarker);
	  }
	  function needsScopeMarker(result) {
	    return !isAnyImportOrReExport(result) && !isExportAssignment(result) && !hasSyntacticModifier(result, 32 /* Export */) && !isAmbientModule(result);
	  }
	  function isExternalModuleIndicator(result) {
	    return isAnyImportOrReExport(result) || isExportAssignment(result) || hasSyntacticModifier(result, 32 /* Export */);
	  }
	  function isForInOrOfStatement(node) {
	    return node.kind === 249 /* ForInStatement */ || node.kind === 250 /* ForOfStatement */;
	  }
	  function isConciseBody(node) {
	    return isBlock(node) || isExpression(node);
	  }
	  function isFunctionBody(node) {
	    return isBlock(node);
	  }
	  function isForInitializer(node) {
	    return isVariableDeclarationList(node) || isExpression(node);
	  }
	  function isModuleBody(node) {
	    const kind = node.kind;
	    return kind === 268 /* ModuleBlock */ || kind === 267 /* ModuleDeclaration */ || kind === 80 /* Identifier */;
	  }
	  function isNamespaceBody(node) {
	    const kind = node.kind;
	    return kind === 268 /* ModuleBlock */ || kind === 267 /* ModuleDeclaration */;
	  }
	  function isJSDocNamespaceBody(node) {
	    const kind = node.kind;
	    return kind === 80 /* Identifier */ || kind === 267 /* ModuleDeclaration */;
	  }
	  function isNamedImportBindings(node) {
	    const kind = node.kind;
	    return kind === 275 /* NamedImports */ || kind === 274 /* NamespaceImport */;
	  }
	  function isModuleOrEnumDeclaration(node) {
	    return node.kind === 267 /* ModuleDeclaration */ || node.kind === 266 /* EnumDeclaration */;
	  }
	  function canHaveSymbol(node) {
	    switch (node.kind) {
	      case 219 /* ArrowFunction */:
	      case 226 /* BinaryExpression */:
	      case 208 /* BindingElement */:
	      case 213 /* CallExpression */:
	      case 179 /* CallSignature */:
	      case 263 /* ClassDeclaration */:
	      case 231 /* ClassExpression */:
	      case 175 /* ClassStaticBlockDeclaration */:
	      case 176 /* Constructor */:
	      case 185 /* ConstructorType */:
	      case 180 /* ConstructSignature */:
	      case 212 /* ElementAccessExpression */:
	      case 266 /* EnumDeclaration */:
	      case 306 /* EnumMember */:
	      case 277 /* ExportAssignment */:
	      case 278 /* ExportDeclaration */:
	      case 281 /* ExportSpecifier */:
	      case 262 /* FunctionDeclaration */:
	      case 218 /* FunctionExpression */:
	      case 184 /* FunctionType */:
	      case 177 /* GetAccessor */:
	      case 80 /* Identifier */:
	      case 273 /* ImportClause */:
	      case 271 /* ImportEqualsDeclaration */:
	      case 276 /* ImportSpecifier */:
	      case 181 /* IndexSignature */:
	      case 264 /* InterfaceDeclaration */:
	      case 345 /* JSDocCallbackTag */:
	      case 347 /* JSDocEnumTag */:
	      case 324 /* JSDocFunctionType */:
	      case 348 /* JSDocParameterTag */:
	      case 355 /* JSDocPropertyTag */:
	      case 330 /* JSDocSignature */:
	      case 353 /* JSDocTypedefTag */:
	      case 329 /* JSDocTypeLiteral */:
	      case 291 /* JsxAttribute */:
	      case 292 /* JsxAttributes */:
	      case 293 /* JsxSpreadAttribute */:
	      case 200 /* MappedType */:
	      case 174 /* MethodDeclaration */:
	      case 173 /* MethodSignature */:
	      case 267 /* ModuleDeclaration */:
	      case 202 /* NamedTupleMember */:
	      case 280 /* NamespaceExport */:
	      case 270 /* NamespaceExportDeclaration */:
	      case 274 /* NamespaceImport */:
	      case 214 /* NewExpression */:
	      case 15 /* NoSubstitutionTemplateLiteral */:
	      case 9 /* NumericLiteral */:
	      case 210 /* ObjectLiteralExpression */:
	      case 169 /* Parameter */:
	      case 211 /* PropertyAccessExpression */:
	      case 303 /* PropertyAssignment */:
	      case 172 /* PropertyDeclaration */:
	      case 171 /* PropertySignature */:
	      case 178 /* SetAccessor */:
	      case 304 /* ShorthandPropertyAssignment */:
	      case 312 /* SourceFile */:
	      case 305 /* SpreadAssignment */:
	      case 11 /* StringLiteral */:
	      case 265 /* TypeAliasDeclaration */:
	      case 187 /* TypeLiteral */:
	      case 168 /* TypeParameter */:
	      case 260 /* VariableDeclaration */:
	        return true;
	      default:
	        return false;
	    }
	  }
	  function canHaveLocals(node) {
	    switch (node.kind) {
	      case 219 /* ArrowFunction */:
	      case 241 /* Block */:
	      case 179 /* CallSignature */:
	      case 269 /* CaseBlock */:
	      case 299 /* CatchClause */:
	      case 175 /* ClassStaticBlockDeclaration */:
	      case 194 /* ConditionalType */:
	      case 176 /* Constructor */:
	      case 185 /* ConstructorType */:
	      case 180 /* ConstructSignature */:
	      case 248 /* ForStatement */:
	      case 249 /* ForInStatement */:
	      case 250 /* ForOfStatement */:
	      case 262 /* FunctionDeclaration */:
	      case 218 /* FunctionExpression */:
	      case 184 /* FunctionType */:
	      case 177 /* GetAccessor */:
	      case 181 /* IndexSignature */:
	      case 345 /* JSDocCallbackTag */:
	      case 347 /* JSDocEnumTag */:
	      case 324 /* JSDocFunctionType */:
	      case 330 /* JSDocSignature */:
	      case 353 /* JSDocTypedefTag */:
	      case 200 /* MappedType */:
	      case 174 /* MethodDeclaration */:
	      case 173 /* MethodSignature */:
	      case 267 /* ModuleDeclaration */:
	      case 178 /* SetAccessor */:
	      case 312 /* SourceFile */:
	      case 265 /* TypeAliasDeclaration */:
	        return true;
	      default:
	        return false;
	    }
	  }
	  function isDeclarationKind(kind) {
	    return kind === 219 /* ArrowFunction */ || kind === 208 /* BindingElement */ || kind === 263 /* ClassDeclaration */ || kind === 231 /* ClassExpression */ || kind === 175 /* ClassStaticBlockDeclaration */ || kind === 176 /* Constructor */ || kind === 266 /* EnumDeclaration */ || kind === 306 /* EnumMember */ || kind === 281 /* ExportSpecifier */ || kind === 262 /* FunctionDeclaration */ || kind === 218 /* FunctionExpression */ || kind === 177 /* GetAccessor */ || kind === 273 /* ImportClause */ || kind === 271 /* ImportEqualsDeclaration */ || kind === 276 /* ImportSpecifier */ || kind === 264 /* InterfaceDeclaration */ || kind === 291 /* JsxAttribute */ || kind === 174 /* MethodDeclaration */ || kind === 173 /* MethodSignature */ || kind === 267 /* ModuleDeclaration */ || kind === 270 /* NamespaceExportDeclaration */ || kind === 274 /* NamespaceImport */ || kind === 280 /* NamespaceExport */ || kind === 169 /* Parameter */ || kind === 303 /* PropertyAssignment */ || kind === 172 /* PropertyDeclaration */ || kind === 171 /* PropertySignature */ || kind === 178 /* SetAccessor */ || kind === 304 /* ShorthandPropertyAssignment */ || kind === 265 /* TypeAliasDeclaration */ || kind === 168 /* TypeParameter */ || kind === 260 /* VariableDeclaration */ || kind === 353 /* JSDocTypedefTag */ || kind === 345 /* JSDocCallbackTag */ || kind === 355 /* JSDocPropertyTag */;
	  }
	  function isDeclarationStatementKind(kind) {
	    return kind === 262 /* FunctionDeclaration */ || kind === 282 /* MissingDeclaration */ || kind === 263 /* ClassDeclaration */ || kind === 264 /* InterfaceDeclaration */ || kind === 265 /* TypeAliasDeclaration */ || kind === 266 /* EnumDeclaration */ || kind === 267 /* ModuleDeclaration */ || kind === 272 /* ImportDeclaration */ || kind === 271 /* ImportEqualsDeclaration */ || kind === 278 /* ExportDeclaration */ || kind === 277 /* ExportAssignment */ || kind === 270 /* NamespaceExportDeclaration */;
	  }
	  function isStatementKindButNotDeclarationKind(kind) {
	    return kind === 252 /* BreakStatement */ || kind === 251 /* ContinueStatement */ || kind === 259 /* DebuggerStatement */ || kind === 246 /* DoStatement */ || kind === 244 /* ExpressionStatement */ || kind === 242 /* EmptyStatement */ || kind === 249 /* ForInStatement */ || kind === 250 /* ForOfStatement */ || kind === 248 /* ForStatement */ || kind === 245 /* IfStatement */ || kind === 256 /* LabeledStatement */ || kind === 253 /* ReturnStatement */ || kind === 255 /* SwitchStatement */ || kind === 257 /* ThrowStatement */ || kind === 258 /* TryStatement */ || kind === 243 /* VariableStatement */ || kind === 247 /* WhileStatement */ || kind === 254 /* WithStatement */ || kind === 359 /* NotEmittedStatement */;
	  }
	  function isDeclaration(node) {
	    if (node.kind === 168 /* TypeParameter */) {
	      return node.parent && node.parent.kind !== 352 /* JSDocTemplateTag */ || isInJSFile(node);
	    }
	    return isDeclarationKind(node.kind);
	  }
	  function isDeclarationStatement(node) {
	    return isDeclarationStatementKind(node.kind);
	  }
	  function isStatementButNotDeclaration(node) {
	    return isStatementKindButNotDeclarationKind(node.kind);
	  }
	  function isStatement(node) {
	    const kind = node.kind;
	    return isStatementKindButNotDeclarationKind(kind) || isDeclarationStatementKind(kind) || isBlockStatement(node);
	  }
	  function isBlockStatement(node) {
	    if (node.kind !== 241 /* Block */)
	      return false;
	    if (node.parent !== void 0) {
	      if (node.parent.kind === 258 /* TryStatement */ || node.parent.kind === 299 /* CatchClause */) {
	        return false;
	      }
	    }
	    return !isFunctionBlock(node);
	  }
	  function isStatementOrBlock(node) {
	    const kind = node.kind;
	    return isStatementKindButNotDeclarationKind(kind) || isDeclarationStatementKind(kind) || kind === 241 /* Block */;
	  }
	  function isModuleReference(node) {
	    const kind = node.kind;
	    return kind === 283 /* ExternalModuleReference */ || kind === 166 /* QualifiedName */ || kind === 80 /* Identifier */;
	  }
	  function isJsxTagNameExpression(node) {
	    const kind = node.kind;
	    return kind === 110 /* ThisKeyword */ || kind === 80 /* Identifier */ || kind === 211 /* PropertyAccessExpression */ || kind === 295 /* JsxNamespacedName */;
	  }
	  function isJsxChild(node) {
	    const kind = node.kind;
	    return kind === 284 /* JsxElement */ || kind === 294 /* JsxExpression */ || kind === 285 /* JsxSelfClosingElement */ || kind === 12 /* JsxText */ || kind === 288 /* JsxFragment */;
	  }
	  function isJsxAttributeLike(node) {
	    const kind = node.kind;
	    return kind === 291 /* JsxAttribute */ || kind === 293 /* JsxSpreadAttribute */;
	  }
	  function isStringLiteralOrJsxExpression(node) {
	    const kind = node.kind;
	    return kind === 11 /* StringLiteral */ || kind === 294 /* JsxExpression */;
	  }
	  function isJsxOpeningLikeElement(node) {
	    const kind = node.kind;
	    return kind === 286 /* JsxOpeningElement */ || kind === 285 /* JsxSelfClosingElement */;
	  }
	  function isCaseOrDefaultClause(node) {
	    const kind = node.kind;
	    return kind === 296 /* CaseClause */ || kind === 297 /* DefaultClause */;
	  }
	  function isJSDocNode(node) {
	    return node.kind >= 316 /* FirstJSDocNode */ && node.kind <= 357 /* LastJSDocNode */;
	  }
	  function isJSDocCommentContainingNode(node) {
	    return node.kind === 327 /* JSDoc */ || node.kind === 326 /* JSDocNamepathType */ || node.kind === 328 /* JSDocText */ || isJSDocLinkLike(node) || isJSDocTag(node) || isJSDocTypeLiteral(node) || isJSDocSignature(node);
	  }
	  function isJSDocTag(node) {
	    return node.kind >= 334 /* FirstJSDocTagNode */ && node.kind <= 357 /* LastJSDocTagNode */;
	  }
	  function isSetAccessor(node) {
	    return node.kind === 178 /* SetAccessor */;
	  }
	  function isGetAccessor(node) {
	    return node.kind === 177 /* GetAccessor */;
	  }
	  function hasJSDocNodes(node) {
	    if (!canHaveJSDoc(node))
	      return false;
	    const { jsDoc } = node;
	    return !!jsDoc && jsDoc.length > 0;
	  }
	  function hasType(node) {
	    return !!node.type;
	  }
	  function hasInitializer(node) {
	    return !!node.initializer;
	  }
	  function hasOnlyExpressionInitializer(node) {
	    switch (node.kind) {
	      case 260 /* VariableDeclaration */:
	      case 169 /* Parameter */:
	      case 208 /* BindingElement */:
	      case 172 /* PropertyDeclaration */:
	      case 303 /* PropertyAssignment */:
	      case 306 /* EnumMember */:
	        return true;
	      default:
	        return false;
	    }
	  }
	  function isObjectLiteralElement(node) {
	    return node.kind === 291 /* JsxAttribute */ || node.kind === 293 /* JsxSpreadAttribute */ || isObjectLiteralElementLike(node);
	  }
	  function isTypeReferenceType(node) {
	    return node.kind === 183 /* TypeReference */ || node.kind === 233 /* ExpressionWithTypeArguments */;
	  }
	  function guessIndentation(lines) {
	    let indentation = MAX_SMI_X86;
	    for (const line of lines) {
	      if (!line.length) {
	        continue;
	      }
	      let i = 0;
	      for (; i < line.length && i < indentation; i++) {
	        if (!isWhiteSpaceLike(line.charCodeAt(i))) {
	          break;
	        }
	      }
	      if (i < indentation) {
	        indentation = i;
	      }
	      if (indentation === 0) {
	        return 0;
	      }
	    }
	    return indentation === MAX_SMI_X86 ? void 0 : indentation;
	  }
	  function isStringLiteralLike(node) {
	    return node.kind === 11 /* StringLiteral */ || node.kind === 15 /* NoSubstitutionTemplateLiteral */;
	  }
	  function isJSDocLinkLike(node) {
	    return node.kind === 331 /* JSDocLink */ || node.kind === 332 /* JSDocLinkCode */ || node.kind === 333 /* JSDocLinkPlain */;
	  }
	  function hasRestParameter(s) {
	    const last2 = lastOrUndefined(s.parameters);
	    return !!last2 && isRestParameter(last2);
	  }
	  function isRestParameter(node) {
	    const type = isJSDocParameterTag(node) ? node.typeExpression && node.typeExpression.type : node.type;
	    return node.dotDotDotToken !== void 0 || !!type && type.kind === 325 /* JSDocVariadicType */;
	  }
	  function hasInternalAnnotation(range, sourceFile) {
	    const comment = sourceFile.text.substring(range.pos, range.end);
	    return comment.includes("@internal");
	  }
	  function isInternalDeclaration(node, sourceFile) {
	    sourceFile ?? (sourceFile = getSourceFileOfNode(node));
	    const parseTreeNode = getParseTreeNode(node);
	    if (parseTreeNode && parseTreeNode.kind === 169 /* Parameter */) {
	      const paramIdx = parseTreeNode.parent.parameters.indexOf(parseTreeNode);
	      const previousSibling = paramIdx > 0 ? parseTreeNode.parent.parameters[paramIdx - 1] : void 0;
	      const text = sourceFile.text;
	      const commentRanges = previousSibling ? concatenate(
	        // to handle
	        // ... parameters, /** @internal */
	        // public param: string
	        getTrailingCommentRanges(text, skipTrivia(
	          text,
	          previousSibling.end + 1,
	          /*stopAfterLineBreak*/
	          false,
	          /*stopAtComments*/
	          true
	        )),
	        getLeadingCommentRanges(text, node.pos)
	      ) : getTrailingCommentRanges(text, skipTrivia(
	        text,
	        node.pos,
	        /*stopAfterLineBreak*/
	        false,
	        /*stopAtComments*/
	        true
	      ));
	      return some(commentRanges) && hasInternalAnnotation(last(commentRanges), sourceFile);
	    }
	    const leadingCommentRanges = parseTreeNode && getLeadingCommentRangesOfNode(parseTreeNode, sourceFile);
	    return !!forEach(leadingCommentRanges, (range) => {
	      return hasInternalAnnotation(range, sourceFile);
	    });
	  }
	  var unchangedTextChangeRange, supportedLocaleDirectories, MAX_SMI_X86;
	  var init_utilitiesPublic = __esm({
	    "src/compiler/utilitiesPublic.ts"() {
	      init_ts2();
	      unchangedTextChangeRange = createTextChangeRange(createTextSpan(0, 0), 0);
	      supportedLocaleDirectories = ["cs", "de", "es", "fr", "it", "ja", "ko", "pl", "pt-br", "ru", "tr", "zh-cn", "zh-tw"];
	      MAX_SMI_X86 = 1073741823;
	    }
	  });

	  // src/compiler/utilities.ts
	  function getDeclarationOfKind(symbol, kind) {
	    const declarations = symbol.declarations;
	    if (declarations) {
	      for (const declaration of declarations) {
	        if (declaration.kind === kind) {
	          return declaration;
	        }
	      }
	    }
	    return void 0;
	  }
	  function getDeclarationsOfKind(symbol, kind) {
	    return filter(symbol.declarations || emptyArray, (d) => d.kind === kind);
	  }
	  function createSymbolTable(symbols) {
	    const result = /* @__PURE__ */ new Map();
	    if (symbols) {
	      for (const symbol of symbols) {
	        result.set(symbol.escapedName, symbol);
	      }
	    }
	    return result;
	  }
	  function isTransientSymbol(symbol) {
	    return (symbol.flags & 33554432 /* Transient */) !== 0;
	  }
	  function createSingleLineStringWriter() {
	    var str = "";
	    const writeText = (text) => str += text;
	    return {
	      getText: () => str,
	      write: writeText,
	      rawWrite: writeText,
	      writeKeyword: writeText,
	      writeOperator: writeText,
	      writePunctuation: writeText,
	      writeSpace: writeText,
	      writeStringLiteral: writeText,
	      writeLiteral: writeText,
	      writeParameter: writeText,
	      writeProperty: writeText,
	      writeSymbol: (s, _) => writeText(s),
	      writeTrailingSemicolon: writeText,
	      writeComment: writeText,
	      getTextPos: () => str.length,
	      getLine: () => 0,
	      getColumn: () => 0,
	      getIndent: () => 0,
	      isAtStartOfLine: () => false,
	      hasTrailingComment: () => false,
	      hasTrailingWhitespace: () => !!str.length && isWhiteSpaceLike(str.charCodeAt(str.length - 1)),
	      // Completely ignore indentation for string writers.  And map newlines to
	      // a single space.
	      writeLine: () => str += " ",
	      increaseIndent: noop,
	      decreaseIndent: noop,
	      clear: () => str = ""
	    };
	  }
	  function changesAffectModuleResolution(oldOptions, newOptions) {
	    return oldOptions.configFilePath !== newOptions.configFilePath || optionsHaveModuleResolutionChanges(oldOptions, newOptions);
	  }
	  function optionsHaveModuleResolutionChanges(oldOptions, newOptions) {
	    return optionsHaveChanges(oldOptions, newOptions, moduleResolutionOptionDeclarations);
	  }
	  function changesAffectingProgramStructure(oldOptions, newOptions) {
	    return optionsHaveChanges(oldOptions, newOptions, optionsAffectingProgramStructure);
	  }
	  function optionsHaveChanges(oldOptions, newOptions, optionDeclarations2) {
	    return oldOptions !== newOptions && optionDeclarations2.some((o) => !isJsonEqual(getCompilerOptionValue(oldOptions, o), getCompilerOptionValue(newOptions, o)));
	  }
	  function forEachAncestor(node, callback) {
	    while (true) {
	      const res = callback(node);
	      if (res === "quit")
	        return void 0;
	      if (res !== void 0)
	        return res;
	      if (isSourceFile(node))
	        return void 0;
	      node = node.parent;
	    }
	  }
	  function forEachEntry(map2, callback) {
	    const iterator = map2.entries();
	    for (const [key, value] of iterator) {
	      const result = callback(value, key);
	      if (result) {
	        return result;
	      }
	    }
	    return void 0;
	  }
	  function forEachKey(map2, callback) {
	    const iterator = map2.keys();
	    for (const key of iterator) {
	      const result = callback(key);
	      if (result) {
	        return result;
	      }
	    }
	    return void 0;
	  }
	  function copyEntries(source, target) {
	    source.forEach((value, key) => {
	      target.set(key, value);
	    });
	  }
	  function usingSingleLineStringWriter(action) {
	    const oldString = stringWriter.getText();
	    try {
	      action(stringWriter);
	      return stringWriter.getText();
	    } finally {
	      stringWriter.clear();
	      stringWriter.writeKeyword(oldString);
	    }
	  }
	  function getFullWidth(node) {
	    return node.end - node.pos;
	  }
	  function projectReferenceIsEqualTo(oldRef, newRef) {
	    return oldRef.path === newRef.path && !oldRef.prepend === !newRef.prepend && !oldRef.circular === !newRef.circular;
	  }
	  function moduleResolutionIsEqualTo(oldResolution, newResolution) {
	    return oldResolution === newResolution || oldResolution.resolvedModule === newResolution.resolvedModule || !!oldResolution.resolvedModule && !!newResolution.resolvedModule && oldResolution.resolvedModule.isExternalLibraryImport === newResolution.resolvedModule.isExternalLibraryImport && oldResolution.resolvedModule.extension === newResolution.resolvedModule.extension && oldResolution.resolvedModule.resolvedFileName === newResolution.resolvedModule.resolvedFileName && oldResolution.resolvedModule.originalPath === newResolution.resolvedModule.originalPath && packageIdIsEqual(oldResolution.resolvedModule.packageId, newResolution.resolvedModule.packageId) && oldResolution.alternateResult === newResolution.alternateResult;
	  }
	  function createModuleNotFoundChain(sourceFile, host, moduleReference, mode, packageName) {
	    var _a;
	    const alternateResult = (_a = host.getResolvedModule(sourceFile, moduleReference, mode)) == null ? void 0 : _a.alternateResult;
	    const alternateResultMessage = alternateResult && (getEmitModuleResolutionKind(host.getCompilerOptions()) === 2 /* Node10 */ ? [Diagnostics.There_are_types_at_0_but_this_result_could_not_be_resolved_under_your_current_moduleResolution_setting_Consider_updating_to_node16_nodenext_or_bundler, [alternateResult]] : [
	      Diagnostics.There_are_types_at_0_but_this_result_could_not_be_resolved_when_respecting_package_json_exports_The_1_library_may_need_to_update_its_package_json_or_typings,
	      [alternateResult, alternateResult.includes(nodeModulesPathPart + "@types/") ? `@types/${mangleScopedPackageName(packageName)}` : packageName]
	    ]);
	    const result = alternateResultMessage ? chainDiagnosticMessages(
	      /*details*/
	      void 0,
	      alternateResultMessage[0],
	      ...alternateResultMessage[1]
	    ) : host.typesPackageExists(packageName) ? chainDiagnosticMessages(
	      /*details*/
	      void 0,
	      Diagnostics.If_the_0_package_actually_exposes_this_module_consider_sending_a_pull_request_to_amend_https_Colon_Slash_Slashgithub_com_SlashDefinitelyTyped_SlashDefinitelyTyped_Slashtree_Slashmaster_Slashtypes_Slash_1,
	      packageName,
	      mangleScopedPackageName(packageName)
	    ) : host.packageBundlesTypes(packageName) ? chainDiagnosticMessages(
	      /*details*/
	      void 0,
	      Diagnostics.If_the_0_package_actually_exposes_this_module_try_adding_a_new_declaration_d_ts_file_containing_declare_module_1,
	      packageName,
	      moduleReference
	    ) : chainDiagnosticMessages(
	      /*details*/
	      void 0,
	      Diagnostics.Try_npm_i_save_dev_types_Slash_1_if_it_exists_or_add_a_new_declaration_d_ts_file_containing_declare_module_0,
	      moduleReference,
	      mangleScopedPackageName(packageName)
	    );
	    if (result)
	      result.repopulateInfo = () => ({ moduleReference, mode, packageName: packageName === moduleReference ? void 0 : packageName });
	    return result;
	  }
	  function packageIdIsEqual(a, b) {
	    return a === b || !!a && !!b && a.name === b.name && a.subModuleName === b.subModuleName && a.version === b.version;
	  }
	  function packageIdToPackageName({ name, subModuleName }) {
	    return subModuleName ? `${name}/${subModuleName}` : name;
	  }
	  function packageIdToString(packageId) {
	    return `${packageIdToPackageName(packageId)}@${packageId.version}`;
	  }
	  function typeDirectiveIsEqualTo(oldResolution, newResolution) {
	    return oldResolution === newResolution || oldResolution.resolvedTypeReferenceDirective === newResolution.resolvedTypeReferenceDirective || !!oldResolution.resolvedTypeReferenceDirective && !!newResolution.resolvedTypeReferenceDirective && oldResolution.resolvedTypeReferenceDirective.resolvedFileName === newResolution.resolvedTypeReferenceDirective.resolvedFileName && !!oldResolution.resolvedTypeReferenceDirective.primary === !!newResolution.resolvedTypeReferenceDirective.primary && oldResolution.resolvedTypeReferenceDirective.originalPath === newResolution.resolvedTypeReferenceDirective.originalPath;
	  }
	  function hasChangesInResolutions(names, newResolutions, getOldResolution, comparer) {
	    Debug.assert(names.length === newResolutions.length);
	    for (let i = 0; i < names.length; i++) {
	      const newResolution = newResolutions[i];
	      const entry = names[i];
	      const oldResolution = getOldResolution(entry);
	      const changed = oldResolution ? !newResolution || !comparer(oldResolution, newResolution) : newResolution;
	      if (changed) {
	        return true;
	      }
	    }
	    return false;
	  }
	  function containsParseError(node) {
	    aggregateChildData(node);
	    return (node.flags & 1048576 /* ThisNodeOrAnySubNodesHasError */) !== 0;
	  }
	  function aggregateChildData(node) {
	    if (!(node.flags & 2097152 /* HasAggregatedChildData */)) {
	      const thisNodeOrAnySubNodesHasError = (node.flags & 262144 /* ThisNodeHasError */) !== 0 || forEachChild(node, containsParseError);
	      if (thisNodeOrAnySubNodesHasError) {
	        node.flags |= 1048576 /* ThisNodeOrAnySubNodesHasError */;
	      }
	      node.flags |= 2097152 /* HasAggregatedChildData */;
	    }
	  }
	  function getSourceFileOfNode(node) {
	    while (node && node.kind !== 312 /* SourceFile */) {
	      node = node.parent;
	    }
	    return node;
	  }
	  function getSourceFileOfModule(module2) {
	    return getSourceFileOfNode(module2.valueDeclaration || getNonAugmentationDeclaration(module2));
	  }
	  function isPlainJsFile(file, checkJs) {
	    return !!file && (file.scriptKind === 1 /* JS */ || file.scriptKind === 2 /* JSX */) && !file.checkJsDirective && checkJs === void 0;
	  }
	  function isStatementWithLocals(node) {
	    switch (node.kind) {
	      case 241 /* Block */:
	      case 269 /* CaseBlock */:
	      case 248 /* ForStatement */:
	      case 249 /* ForInStatement */:
	      case 250 /* ForOfStatement */:
	        return true;
	    }
	    return false;
	  }
	  function getStartPositionOfLine(line, sourceFile) {
	    Debug.assert(line >= 0);
	    return getLineStarts(sourceFile)[line];
	  }
	  function nodePosToString(node) {
	    const file = getSourceFileOfNode(node);
	    const loc = getLineAndCharacterOfPosition(file, node.pos);
	    return `${file.fileName}(${loc.line + 1},${loc.character + 1})`;
	  }
	  function getEndLinePosition(line, sourceFile) {
	    Debug.assert(line >= 0);
	    const lineStarts = getLineStarts(sourceFile);
	    const lineIndex = line;
	    const sourceText = sourceFile.text;
	    if (lineIndex + 1 === lineStarts.length) {
	      return sourceText.length - 1;
	    } else {
	      const start = lineStarts[lineIndex];
	      let pos = lineStarts[lineIndex + 1] - 1;
	      Debug.assert(isLineBreak(sourceText.charCodeAt(pos)));
	      while (start <= pos && isLineBreak(sourceText.charCodeAt(pos))) {
	        pos--;
	      }
	      return pos;
	    }
	  }
	  function isFileLevelUniqueName(sourceFile, name, hasGlobalName) {
	    return !(hasGlobalName && hasGlobalName(name)) && !sourceFile.identifiers.has(name);
	  }
	  function nodeIsMissing(node) {
	    if (node === void 0) {
	      return true;
	    }
	    return node.pos === node.end && node.pos >= 0 && node.kind !== 1 /* EndOfFileToken */;
	  }
	  function nodeIsPresent(node) {
	    return !nodeIsMissing(node);
	  }
	  function isGrammarError(parent2, child) {
	    if (isTypeParameterDeclaration(parent2))
	      return child === parent2.expression;
	    if (isClassStaticBlockDeclaration(parent2))
	      return child === parent2.modifiers;
	    if (isPropertySignature(parent2))
	      return child === parent2.initializer;
	    if (isPropertyDeclaration(parent2))
	      return child === parent2.questionToken && isAutoAccessorPropertyDeclaration(parent2);
	    if (isPropertyAssignment(parent2))
	      return child === parent2.modifiers || child === parent2.questionToken || child === parent2.exclamationToken || isGrammarErrorElement(parent2.modifiers, child, isModifierLike);
	    if (isShorthandPropertyAssignment(parent2))
	      return child === parent2.equalsToken || child === parent2.modifiers || child === parent2.questionToken || child === parent2.exclamationToken || isGrammarErrorElement(parent2.modifiers, child, isModifierLike);
	    if (isMethodDeclaration(parent2))
	      return child === parent2.exclamationToken;
	    if (isConstructorDeclaration(parent2))
	      return child === parent2.typeParameters || child === parent2.type || isGrammarErrorElement(parent2.typeParameters, child, isTypeParameterDeclaration);
	    if (isGetAccessorDeclaration(parent2))
	      return child === parent2.typeParameters || isGrammarErrorElement(parent2.typeParameters, child, isTypeParameterDeclaration);
	    if (isSetAccessorDeclaration(parent2))
	      return child === parent2.typeParameters || child === parent2.type || isGrammarErrorElement(parent2.typeParameters, child, isTypeParameterDeclaration);
	    if (isNamespaceExportDeclaration(parent2))
	      return child === parent2.modifiers || isGrammarErrorElement(parent2.modifiers, child, isModifierLike);
	    return false;
	  }
	  function isGrammarErrorElement(nodeArray, child, isElement) {
	    if (!nodeArray || isArray(child) || !isElement(child))
	      return false;
	    return contains(nodeArray, child);
	  }
	  function insertStatementsAfterPrologue(to, from, isPrologueDirective2) {
	    if (from === void 0 || from.length === 0)
	      return to;
	    let statementIndex = 0;
	    for (; statementIndex < to.length; ++statementIndex) {
	      if (!isPrologueDirective2(to[statementIndex])) {
	        break;
	      }
	    }
	    to.splice(statementIndex, 0, ...from);
	    return to;
	  }
	  function insertStatementAfterPrologue(to, statement, isPrologueDirective2) {
	    if (statement === void 0)
	      return to;
	    let statementIndex = 0;
	    for (; statementIndex < to.length; ++statementIndex) {
	      if (!isPrologueDirective2(to[statementIndex])) {
	        break;
	      }
	    }
	    to.splice(statementIndex, 0, statement);
	    return to;
	  }
	  function isAnyPrologueDirective(node) {
	    return isPrologueDirective(node) || !!(getEmitFlags(node) & 2097152 /* CustomPrologue */);
	  }
	  function insertStatementsAfterStandardPrologue(to, from) {
	    return insertStatementsAfterPrologue(to, from, isPrologueDirective);
	  }
	  function insertStatementsAfterCustomPrologue(to, from) {
	    return insertStatementsAfterPrologue(to, from, isAnyPrologueDirective);
	  }
	  function insertStatementAfterStandardPrologue(to, statement) {
	    return insertStatementAfterPrologue(to, statement, isPrologueDirective);
	  }
	  function insertStatementAfterCustomPrologue(to, statement) {
	    return insertStatementAfterPrologue(to, statement, isAnyPrologueDirective);
	  }
	  function isRecognizedTripleSlashComment(text, commentPos, commentEnd) {
	    if (text.charCodeAt(commentPos + 1) === 47 /* slash */ && commentPos + 2 < commentEnd && text.charCodeAt(commentPos + 2) === 47 /* slash */) {
	      const textSubStr = text.substring(commentPos, commentEnd);
	      return fullTripleSlashReferencePathRegEx.test(textSubStr) || fullTripleSlashAMDReferencePathRegEx.test(textSubStr) || fullTripleSlashAMDModuleRegEx.test(textSubStr) || fullTripleSlashReferenceTypeReferenceDirectiveRegEx.test(textSubStr) || fullTripleSlashLibReferenceRegEx.test(textSubStr) || defaultLibReferenceRegEx.test(textSubStr) ? true : false;
	    }
	    return false;
	  }
	  function isPinnedComment(text, start) {
	    return text.charCodeAt(start + 1) === 42 /* asterisk */ && text.charCodeAt(start + 2) === 33 /* exclamation */;
	  }
	  function createCommentDirectivesMap(sourceFile, commentDirectives) {
	    const directivesByLine = new Map(
	      commentDirectives.map((commentDirective) => [
	        `${getLineAndCharacterOfPosition(sourceFile, commentDirective.range.end).line}`,
	        commentDirective
	      ])
	    );
	    const usedLines = /* @__PURE__ */ new Map();
	    return { getUnusedExpectations, markUsed };
	    function getUnusedExpectations() {
	      return arrayFrom(directivesByLine.entries()).filter(([line, directive]) => directive.type === 0 /* ExpectError */ && !usedLines.get(line)).map(([_, directive]) => directive);
	    }
	    function markUsed(line) {
	      if (!directivesByLine.has(`${line}`)) {
	        return false;
	      }
	      usedLines.set(`${line}`, true);
	      return true;
	    }
	  }
	  function getTokenPosOfNode(node, sourceFile, includeJsDoc) {
	    if (nodeIsMissing(node)) {
	      return node.pos;
	    }
	    if (isJSDocNode(node) || node.kind === 12 /* JsxText */) {
	      return skipTrivia(
	        (sourceFile || getSourceFileOfNode(node)).text,
	        node.pos,
	        /*stopAfterLineBreak*/
	        false,
	        /*stopAtComments*/
	        true
	      );
	    }
	    if (includeJsDoc && hasJSDocNodes(node)) {
	      return getTokenPosOfNode(node.jsDoc[0], sourceFile);
	    }
	    if (node.kind === 358 /* SyntaxList */ && node._children.length > 0) {
	      return getTokenPosOfNode(node._children[0], sourceFile, includeJsDoc);
	    }
	    return skipTrivia(
	      (sourceFile || getSourceFileOfNode(node)).text,
	      node.pos,
	      /*stopAfterLineBreak*/
	      false,
	      /*stopAtComments*/
	      false,
	      isInJSDoc(node)
	    );
	  }
	  function getNonDecoratorTokenPosOfNode(node, sourceFile) {
	    const lastDecorator = !nodeIsMissing(node) && canHaveModifiers(node) ? findLast(node.modifiers, isDecorator) : void 0;
	    if (!lastDecorator) {
	      return getTokenPosOfNode(node, sourceFile);
	    }
	    return skipTrivia((sourceFile || getSourceFileOfNode(node)).text, lastDecorator.end);
	  }
	  function getSourceTextOfNodeFromSourceFile(sourceFile, node, includeTrivia = false) {
	    return getTextOfNodeFromSourceText(sourceFile.text, node, includeTrivia);
	  }
	  function isJSDocTypeExpressionOrChild(node) {
	    return !!findAncestor(node, isJSDocTypeExpression);
	  }
	  function isExportNamespaceAsDefaultDeclaration(node) {
	    return !!(isExportDeclaration(node) && node.exportClause && isNamespaceExport(node.exportClause) && node.exportClause.name.escapedText === "default");
	  }
	  function getTextOfNodeFromSourceText(sourceText, node, includeTrivia = false) {
	    if (nodeIsMissing(node)) {
	      return "";
	    }
	    let text = sourceText.substring(includeTrivia ? node.pos : skipTrivia(sourceText, node.pos), node.end);
	    if (isJSDocTypeExpressionOrChild(node)) {
	      text = text.split(/\r\n|\n|\r/).map((line) => line.replace(/^\s*\*/, "").trimStart()).join("\n");
	    }
	    return text;
	  }
	  function getTextOfNode(node, includeTrivia = false) {
	    return getSourceTextOfNodeFromSourceFile(getSourceFileOfNode(node), node, includeTrivia);
	  }
	  function getPos(range) {
	    return range.pos;
	  }
	  function indexOfNode(nodeArray, node) {
	    return binarySearch(nodeArray, node, getPos, compareValues);
	  }
	  function getEmitFlags(node) {
	    const emitNode = node.emitNode;
	    return emitNode && emitNode.flags || 0;
	  }
	  function getInternalEmitFlags(node) {
	    const emitNode = node.emitNode;
	    return emitNode && emitNode.internalFlags || 0;
	  }
	  function getLiteralText(node, sourceFile, flags) {
	    if (sourceFile && canUseOriginalText(node, flags)) {
	      return getSourceTextOfNodeFromSourceFile(sourceFile, node);
	    }
	    switch (node.kind) {
	      case 11 /* StringLiteral */: {
	        const escapeText = flags & 2 /* JsxAttributeEscape */ ? escapeJsxAttributeString : flags & 1 /* NeverAsciiEscape */ || getEmitFlags(node) & 16777216 /* NoAsciiEscaping */ ? escapeString : escapeNonAsciiString;
	        if (node.singleQuote) {
	          return "'" + escapeText(node.text, 39 /* singleQuote */) + "'";
	        } else {
	          return '"' + escapeText(node.text, 34 /* doubleQuote */) + '"';
	        }
	      }
	      case 15 /* NoSubstitutionTemplateLiteral */:
	      case 16 /* TemplateHead */:
	      case 17 /* TemplateMiddle */:
	      case 18 /* TemplateTail */: {
	        const escapeText = flags & 1 /* NeverAsciiEscape */ || getEmitFlags(node) & 16777216 /* NoAsciiEscaping */ ? escapeString : escapeNonAsciiString;
	        const rawText = node.rawText ?? escapeTemplateSubstitution(escapeText(node.text, 96 /* backtick */));
	        switch (node.kind) {
	          case 15 /* NoSubstitutionTemplateLiteral */:
	            return "`" + rawText + "`";
	          case 16 /* TemplateHead */:
	            return "`" + rawText + "${";
	          case 17 /* TemplateMiddle */:
	            return "}" + rawText + "${";
	          case 18 /* TemplateTail */:
	            return "}" + rawText + "`";
	        }
	        break;
	      }
	      case 9 /* NumericLiteral */:
	      case 10 /* BigIntLiteral */:
	        return node.text;
	      case 14 /* RegularExpressionLiteral */:
	        if (flags & 4 /* TerminateUnterminatedLiterals */ && node.isUnterminated) {
	          return node.text + (node.text.charCodeAt(node.text.length - 1) === 92 /* backslash */ ? " /" : "/");
	        }
	        return node.text;
	    }
	    return Debug.fail(`Literal kind '${node.kind}' not accounted for.`);
	  }
	  function canUseOriginalText(node, flags) {
	    if (nodeIsSynthesized(node) || !node.parent || flags & 4 /* TerminateUnterminatedLiterals */ && node.isUnterminated) {
	      return false;
	    }
	    if (isNumericLiteral(node)) {
	      if (node.numericLiteralFlags & 26656 /* IsInvalid */) {
	        return false;
	      }
	      if (node.numericLiteralFlags & 512 /* ContainsSeparator */) {
	        return !!(flags & 8 /* AllowNumericSeparator */);
	      }
	    }
	    return !isBigIntLiteral(node);
	  }
	  function getTextOfConstantValue(value) {
	    return isString(value) ? '"' + escapeNonAsciiString(value) + '"' : "" + value;
	  }
	  function makeIdentifierFromModuleName(moduleName) {
	    return getBaseFileName(moduleName).replace(/^(\d)/, "_$1").replace(/\W/g, "_");
	  }
	  function isBlockOrCatchScoped(declaration) {
	    return (getCombinedNodeFlags(declaration) & 7 /* BlockScoped */) !== 0 || isCatchClauseVariableDeclarationOrBindingElement(declaration);
	  }
	  function isCatchClauseVariableDeclarationOrBindingElement(declaration) {
	    const node = getRootDeclaration(declaration);
	    return node.kind === 260 /* VariableDeclaration */ && node.parent.kind === 299 /* CatchClause */;
	  }
	  function isAmbientModule(node) {
	    return isModuleDeclaration(node) && (node.name.kind === 11 /* StringLiteral */ || isGlobalScopeAugmentation(node));
	  }
	  function isModuleWithStringLiteralName(node) {
	    return isModuleDeclaration(node) && node.name.kind === 11 /* StringLiteral */;
	  }
	  function isNonGlobalAmbientModule(node) {
	    return isModuleDeclaration(node) && isStringLiteral(node.name);
	  }
	  function isEffectiveModuleDeclaration(node) {
	    return isModuleDeclaration(node) || isIdentifier(node);
	  }
	  function isShorthandAmbientModuleSymbol(moduleSymbol) {
	    return isShorthandAmbientModule(moduleSymbol.valueDeclaration);
	  }
	  function isShorthandAmbientModule(node) {
	    return !!node && node.kind === 267 /* ModuleDeclaration */ && !node.body;
	  }
	  function isBlockScopedContainerTopLevel(node) {
	    return node.kind === 312 /* SourceFile */ || node.kind === 267 /* ModuleDeclaration */ || isFunctionLikeOrClassStaticBlockDeclaration(node);
	  }
	  function isGlobalScopeAugmentation(module2) {
	    return !!(module2.flags & 2048 /* GlobalAugmentation */);
	  }
	  function isExternalModuleAugmentation(node) {
	    return isAmbientModule(node) && isModuleAugmentationExternal(node);
	  }
	  function isModuleAugmentationExternal(node) {
	    switch (node.parent.kind) {
	      case 312 /* SourceFile */:
	        return isExternalModule(node.parent);
	      case 268 /* ModuleBlock */:
	        return isAmbientModule(node.parent.parent) && isSourceFile(node.parent.parent.parent) && !isExternalModule(node.parent.parent.parent);
	    }
	    return false;
	  }
	  function getNonAugmentationDeclaration(symbol) {
	    var _a;
	    return (_a = symbol.declarations) == null ? void 0 : _a.find((d) => !isExternalModuleAugmentation(d) && !(isModuleDeclaration(d) && isGlobalScopeAugmentation(d)));
	  }
	  function isCommonJSContainingModuleKind(kind) {
	    return kind === 1 /* CommonJS */ || kind === 100 /* Node16 */ || kind === 199 /* NodeNext */;
	  }
	  function isEffectiveExternalModule(node, compilerOptions) {
	    return isExternalModule(node) || isCommonJSContainingModuleKind(getEmitModuleKind(compilerOptions)) && !!node.commonJsModuleIndicator;
	  }
	  function isEffectiveStrictModeSourceFile(node, compilerOptions) {
	    switch (node.scriptKind) {
	      case 1 /* JS */:
	      case 3 /* TS */:
	      case 2 /* JSX */:
	      case 4 /* TSX */:
	        break;
	      default:
	        return false;
	    }
	    if (node.isDeclarationFile) {
	      return false;
	    }
	    if (getStrictOptionValue(compilerOptions, "alwaysStrict")) {
	      return true;
	    }
	    if (startsWithUseStrict(node.statements)) {
	      return true;
	    }
	    if (isExternalModule(node) || getIsolatedModules(compilerOptions)) {
	      if (getEmitModuleKind(compilerOptions) >= 5 /* ES2015 */) {
	        return true;
	      }
	      return !compilerOptions.noImplicitUseStrict;
	    }
	    return false;
	  }
	  function isAmbientPropertyDeclaration(node) {
	    return !!(node.flags & 33554432 /* Ambient */) || hasSyntacticModifier(node, 128 /* Ambient */);
	  }
	  function isBlockScope(node, parentNode) {
	    switch (node.kind) {
	      case 312 /* SourceFile */:
	      case 269 /* CaseBlock */:
	      case 299 /* CatchClause */:
	      case 267 /* ModuleDeclaration */:
	      case 248 /* ForStatement */:
	      case 249 /* ForInStatement */:
	      case 250 /* ForOfStatement */:
	      case 176 /* Constructor */:
	      case 174 /* MethodDeclaration */:
	      case 177 /* GetAccessor */:
	      case 178 /* SetAccessor */:
	      case 262 /* FunctionDeclaration */:
	      case 218 /* FunctionExpression */:
	      case 219 /* ArrowFunction */:
	      case 172 /* PropertyDeclaration */:
	      case 175 /* ClassStaticBlockDeclaration */:
	        return true;
	      case 241 /* Block */:
	        return !isFunctionLikeOrClassStaticBlockDeclaration(parentNode);
	    }
	    return false;
	  }
	  function isDeclarationWithTypeParameters(node) {
	    Debug.type(node);
	    switch (node.kind) {
	      case 345 /* JSDocCallbackTag */:
	      case 353 /* JSDocTypedefTag */:
	      case 330 /* JSDocSignature */:
	        return true;
	      default:
	        return isDeclarationWithTypeParameterChildren(node);
	    }
	  }
	  function isDeclarationWithTypeParameterChildren(node) {
	    Debug.type(node);
	    switch (node.kind) {
	      case 179 /* CallSignature */:
	      case 180 /* ConstructSignature */:
	      case 173 /* MethodSignature */:
	      case 181 /* IndexSignature */:
	      case 184 /* FunctionType */:
	      case 185 /* ConstructorType */:
	      case 324 /* JSDocFunctionType */:
	      case 263 /* ClassDeclaration */:
	      case 231 /* ClassExpression */:
	      case 264 /* InterfaceDeclaration */:
	      case 265 /* TypeAliasDeclaration */:
	      case 352 /* JSDocTemplateTag */:
	      case 262 /* FunctionDeclaration */:
	      case 174 /* MethodDeclaration */:
	      case 176 /* Constructor */:
	      case 177 /* GetAccessor */:
	      case 178 /* SetAccessor */:
	      case 218 /* FunctionExpression */:
	      case 219 /* ArrowFunction */:
	        return true;
	      default:
	        return false;
	    }
	  }
	  function isAnyImportSyntax(node) {
	    switch (node.kind) {
	      case 272 /* ImportDeclaration */:
	      case 271 /* ImportEqualsDeclaration */:
	        return true;
	      default:
	        return false;
	    }
	  }
	  function isAnyImportOrBareOrAccessedRequire(node) {
	    return isAnyImportSyntax(node) || isVariableDeclarationInitializedToBareOrAccessedRequire(node);
	  }
	  function isLateVisibilityPaintedStatement(node) {
	    switch (node.kind) {
	      case 272 /* ImportDeclaration */:
	      case 271 /* ImportEqualsDeclaration */:
	      case 243 /* VariableStatement */:
	      case 263 /* ClassDeclaration */:
	      case 262 /* FunctionDeclaration */:
	      case 267 /* ModuleDeclaration */:
	      case 265 /* TypeAliasDeclaration */:
	      case 264 /* InterfaceDeclaration */:
	      case 266 /* EnumDeclaration */:
	        return true;
	      default:
	        return false;
	    }
	  }
	  function hasPossibleExternalModuleReference(node) {
	    return isAnyImportOrReExport(node) || isModuleDeclaration(node) || isImportTypeNode(node) || isImportCall(node);
	  }
	  function isAnyImportOrReExport(node) {
	    return isAnyImportSyntax(node) || isExportDeclaration(node);
	  }
	  function getEnclosingContainer(node) {
	    return findAncestor(node.parent, (n) => !!(getContainerFlags(n) & 1 /* IsContainer */));
	  }
	  function getEnclosingBlockScopeContainer(node) {
	    return findAncestor(node.parent, (current) => isBlockScope(current, current.parent));
	  }
	  function forEachEnclosingBlockScopeContainer(node, cb) {
	    let container = getEnclosingBlockScopeContainer(node);
	    while (container) {
	      cb(container);
	      container = getEnclosingBlockScopeContainer(container);
	    }
	  }
	  function declarationNameToString(name) {
	    return !name || getFullWidth(name) === 0 ? "(Missing)" : getTextOfNode(name);
	  }
	  function getNameFromIndexInfo(info) {
	    return info.declaration ? declarationNameToString(info.declaration.parameters[0].name) : void 0;
	  }
	  function isComputedNonLiteralName(name) {
	    return name.kind === 167 /* ComputedPropertyName */ && !isStringOrNumericLiteralLike(name.expression);
	  }
	  function tryGetTextOfPropertyName(name) {
	    var _a;
	    switch (name.kind) {
	      case 80 /* Identifier */:
	      case 81 /* PrivateIdentifier */:
	        return ((_a = name.emitNode) == null ? void 0 : _a.autoGenerate) ? void 0 : name.escapedText;
	      case 11 /* StringLiteral */:
	      case 9 /* NumericLiteral */:
	      case 15 /* NoSubstitutionTemplateLiteral */:
	        return escapeLeadingUnderscores(name.text);
	      case 167 /* ComputedPropertyName */:
	        if (isStringOrNumericLiteralLike(name.expression))
	          return escapeLeadingUnderscores(name.expression.text);
	        return void 0;
	      case 295 /* JsxNamespacedName */:
	        return getEscapedTextOfJsxNamespacedName(name);
	      default:
	        return Debug.assertNever(name);
	    }
	  }
	  function getTextOfPropertyName(name) {
	    return Debug.checkDefined(tryGetTextOfPropertyName(name));
	  }
	  function entityNameToString(name) {
	    switch (name.kind) {
	      case 110 /* ThisKeyword */:
	        return "this";
	      case 81 /* PrivateIdentifier */:
	      case 80 /* Identifier */:
	        return getFullWidth(name) === 0 ? idText(name) : getTextOfNode(name);
	      case 166 /* QualifiedName */:
	        return entityNameToString(name.left) + "." + entityNameToString(name.right);
	      case 211 /* PropertyAccessExpression */:
	        if (isIdentifier(name.name) || isPrivateIdentifier(name.name)) {
	          return entityNameToString(name.expression) + "." + entityNameToString(name.name);
	        } else {
	          return Debug.assertNever(name.name);
	        }
	      case 318 /* JSDocMemberName */:
	        return entityNameToString(name.left) + entityNameToString(name.right);
	      case 295 /* JsxNamespacedName */:
	        return entityNameToString(name.namespace) + ":" + entityNameToString(name.name);
	      default:
	        return Debug.assertNever(name);
	    }
	  }
	  function createDiagnosticForNode(node, message, ...args) {
	    const sourceFile = getSourceFileOfNode(node);
	    return createDiagnosticForNodeInSourceFile(sourceFile, node, message, ...args);
	  }
	  function createDiagnosticForNodeArray(sourceFile, nodes, message, ...args) {
	    const start = skipTrivia(sourceFile.text, nodes.pos);
	    return createFileDiagnostic(sourceFile, start, nodes.end - start, message, ...args);
	  }
	  function createDiagnosticForNodeInSourceFile(sourceFile, node, message, ...args) {
	    const span = getErrorSpanForNode(sourceFile, node);
	    return createFileDiagnostic(sourceFile, span.start, span.length, message, ...args);
	  }
	  function createDiagnosticForNodeFromMessageChain(sourceFile, node, messageChain, relatedInformation) {
	    const span = getErrorSpanForNode(sourceFile, node);
	    return createFileDiagnosticFromMessageChain(sourceFile, span.start, span.length, messageChain, relatedInformation);
	  }
	  function createDiagnosticForNodeArrayFromMessageChain(sourceFile, nodes, messageChain, relatedInformation) {
	    const start = skipTrivia(sourceFile.text, nodes.pos);
	    return createFileDiagnosticFromMessageChain(sourceFile, start, nodes.end - start, messageChain, relatedInformation);
	  }
	  function assertDiagnosticLocation(sourceText, start, length2) {
	    Debug.assertGreaterThanOrEqual(start, 0);
	    Debug.assertGreaterThanOrEqual(length2, 0);
	    Debug.assertLessThanOrEqual(start, sourceText.length);
	    Debug.assertLessThanOrEqual(start + length2, sourceText.length);
	  }
	  function createFileDiagnosticFromMessageChain(file, start, length2, messageChain, relatedInformation) {
	    assertDiagnosticLocation(file.text, start, length2);
	    return {
	      file,
	      start,
	      length: length2,
	      code: messageChain.code,
	      category: messageChain.category,
	      messageText: messageChain.next ? messageChain : messageChain.messageText,
	      relatedInformation
	    };
	  }
	  function createDiagnosticForFileFromMessageChain(sourceFile, messageChain, relatedInformation) {
	    return {
	      file: sourceFile,
	      start: 0,
	      length: 0,
	      code: messageChain.code,
	      category: messageChain.category,
	      messageText: messageChain.next ? messageChain : messageChain.messageText,
	      relatedInformation
	    };
	  }
	  function createDiagnosticMessageChainFromDiagnostic(diagnostic) {
	    return typeof diagnostic.messageText === "string" ? {
	      code: diagnostic.code,
	      category: diagnostic.category,
	      messageText: diagnostic.messageText,
	      next: diagnostic.next
	    } : diagnostic.messageText;
	  }
	  function createDiagnosticForRange(sourceFile, range, message) {
	    return {
	      file: sourceFile,
	      start: range.pos,
	      length: range.end - range.pos,
	      code: message.code,
	      category: message.category,
	      messageText: message.message
	    };
	  }
	  function getSpanOfTokenAtPosition(sourceFile, pos) {
	    const scanner2 = createScanner(
	      sourceFile.languageVersion,
	      /*skipTrivia*/
	      true,
	      sourceFile.languageVariant,
	      sourceFile.text,
	      /*onError*/
	      void 0,
	      pos
	    );
	    scanner2.scan();
	    const start = scanner2.getTokenStart();
	    return createTextSpanFromBounds(start, scanner2.getTokenEnd());
	  }
	  function scanTokenAtPosition(sourceFile, pos) {
	    const scanner2 = createScanner(
	      sourceFile.languageVersion,
	      /*skipTrivia*/
	      true,
	      sourceFile.languageVariant,
	      sourceFile.text,
	      /*onError*/
	      void 0,
	      pos
	    );
	    scanner2.scan();
	    return scanner2.getToken();
	  }
	  function getErrorSpanForArrowFunction(sourceFile, node) {
	    const pos = skipTrivia(sourceFile.text, node.pos);
	    if (node.body && node.body.kind === 241 /* Block */) {
	      const { line: startLine } = getLineAndCharacterOfPosition(sourceFile, node.body.pos);
	      const { line: endLine } = getLineAndCharacterOfPosition(sourceFile, node.body.end);
	      if (startLine < endLine) {
	        return createTextSpan(pos, getEndLinePosition(startLine, sourceFile) - pos + 1);
	      }
	    }
	    return createTextSpanFromBounds(pos, node.end);
	  }
	  function getErrorSpanForNode(sourceFile, node) {
	    let errorNode = node;
	    switch (node.kind) {
	      case 312 /* SourceFile */: {
	        const pos2 = skipTrivia(
	          sourceFile.text,
	          0,
	          /*stopAfterLineBreak*/
	          false
	        );
	        if (pos2 === sourceFile.text.length) {
	          return createTextSpan(0, 0);
	        }
	        return getSpanOfTokenAtPosition(sourceFile, pos2);
	      }
	      case 260 /* VariableDeclaration */:
	      case 208 /* BindingElement */:
	      case 263 /* ClassDeclaration */:
	      case 231 /* ClassExpression */:
	      case 264 /* InterfaceDeclaration */:
	      case 267 /* ModuleDeclaration */:
	      case 266 /* EnumDeclaration */:
	      case 306 /* EnumMember */:
	      case 262 /* FunctionDeclaration */:
	      case 218 /* FunctionExpression */:
	      case 174 /* MethodDeclaration */:
	      case 177 /* GetAccessor */:
	      case 178 /* SetAccessor */:
	      case 265 /* TypeAliasDeclaration */:
	      case 172 /* PropertyDeclaration */:
	      case 171 /* PropertySignature */:
	      case 274 /* NamespaceImport */:
	        errorNode = node.name;
	        break;
	      case 219 /* ArrowFunction */:
	        return getErrorSpanForArrowFunction(sourceFile, node);
	      case 296 /* CaseClause */:
	      case 297 /* DefaultClause */: {
	        const start = skipTrivia(sourceFile.text, node.pos);
	        const end = node.statements.length > 0 ? node.statements[0].pos : node.end;
	        return createTextSpanFromBounds(start, end);
	      }
	      case 253 /* ReturnStatement */:
	      case 229 /* YieldExpression */: {
	        const pos2 = skipTrivia(sourceFile.text, node.pos);
	        return getSpanOfTokenAtPosition(sourceFile, pos2);
	      }
	      case 238 /* SatisfiesExpression */: {
	        const pos2 = skipTrivia(sourceFile.text, node.expression.end);
	        return getSpanOfTokenAtPosition(sourceFile, pos2);
	      }
	      case 357 /* JSDocSatisfiesTag */: {
	        const pos2 = skipTrivia(sourceFile.text, node.tagName.pos);
	        return getSpanOfTokenAtPosition(sourceFile, pos2);
	      }
	    }
	    if (errorNode === void 0) {
	      return getSpanOfTokenAtPosition(sourceFile, node.pos);
	    }
	    Debug.assert(!isJSDoc(errorNode));
	    const isMissing = nodeIsMissing(errorNode);
	    const pos = isMissing || isJsxText(node) ? errorNode.pos : skipTrivia(sourceFile.text, errorNode.pos);
	    if (isMissing) {
	      Debug.assert(pos === errorNode.pos, "This failure could trigger https://github.com/Microsoft/TypeScript/issues/20809");
	      Debug.assert(pos === errorNode.end, "This failure could trigger https://github.com/Microsoft/TypeScript/issues/20809");
	    } else {
	      Debug.assert(pos >= errorNode.pos, "This failure could trigger https://github.com/Microsoft/TypeScript/issues/20809");
	      Debug.assert(pos <= errorNode.end, "This failure could trigger https://github.com/Microsoft/TypeScript/issues/20809");
	    }
	    return createTextSpanFromBounds(pos, errorNode.end);
	  }
	  function isExternalOrCommonJsModule(file) {
	    return (file.externalModuleIndicator || file.commonJsModuleIndicator) !== void 0;
	  }
	  function isJsonSourceFile(file) {
	    return file.scriptKind === 6 /* JSON */;
	  }
	  function isEnumConst(node) {
	    return !!(getCombinedModifierFlags(node) & 4096 /* Const */);
	  }
	  function isDeclarationReadonly(declaration) {
	    return !!(getCombinedModifierFlags(declaration) & 8 /* Readonly */ && !isParameterPropertyDeclaration(declaration, declaration.parent));
	  }
	  function isVarAwaitUsing(node) {
	    return (getCombinedNodeFlags(node) & 7 /* BlockScoped */) === 6 /* AwaitUsing */;
	  }
	  function isVarUsing(node) {
	    return (getCombinedNodeFlags(node) & 7 /* BlockScoped */) === 4 /* Using */;
	  }
	  function isVarConst(node) {
	    return (getCombinedNodeFlags(node) & 7 /* BlockScoped */) === 2 /* Const */;
	  }
	  function isLet(node) {
	    return (getCombinedNodeFlags(node) & 7 /* BlockScoped */) === 1 /* Let */;
	  }
	  function isSuperCall(n) {
	    return n.kind === 213 /* CallExpression */ && n.expression.kind === 108 /* SuperKeyword */;
	  }
	  function isImportCall(n) {
	    return n.kind === 213 /* CallExpression */ && n.expression.kind === 102 /* ImportKeyword */;
	  }
	  function isImportMeta(n) {
	    return isMetaProperty(n) && n.keywordToken === 102 /* ImportKeyword */ && n.name.escapedText === "meta";
	  }
	  function isLiteralImportTypeNode(n) {
	    return isImportTypeNode(n) && isLiteralTypeNode(n.argument) && isStringLiteral(n.argument.literal);
	  }
	  function isPrologueDirective(node) {
	    return node.kind === 244 /* ExpressionStatement */ && node.expression.kind === 11 /* StringLiteral */;
	  }
	  function isCustomPrologue(node) {
	    return !!(getEmitFlags(node) & 2097152 /* CustomPrologue */);
	  }
	  function isHoistedFunction(node) {
	    return isCustomPrologue(node) && isFunctionDeclaration(node);
	  }
	  function isHoistedVariable(node) {
	    return isIdentifier(node.name) && !node.initializer;
	  }
	  function isHoistedVariableStatement(node) {
	    return isCustomPrologue(node) && isVariableStatement(node) && every(node.declarationList.declarations, isHoistedVariable);
	  }
	  function getLeadingCommentRangesOfNode(node, sourceFileOfNode) {
	    return node.kind !== 12 /* JsxText */ ? getLeadingCommentRanges(sourceFileOfNode.text, node.pos) : void 0;
	  }
	  function getJSDocCommentRanges(node, text) {
	    const commentRanges = node.kind === 169 /* Parameter */ || node.kind === 168 /* TypeParameter */ || node.kind === 218 /* FunctionExpression */ || node.kind === 219 /* ArrowFunction */ || node.kind === 217 /* ParenthesizedExpression */ || node.kind === 260 /* VariableDeclaration */ || node.kind === 281 /* ExportSpecifier */ ? concatenate(getTrailingCommentRanges(text, node.pos), getLeadingCommentRanges(text, node.pos)) : getLeadingCommentRanges(text, node.pos);
	    return filter(commentRanges, (comment) => text.charCodeAt(comment.pos + 1) === 42 /* asterisk */ && text.charCodeAt(comment.pos + 2) === 42 /* asterisk */ && text.charCodeAt(comment.pos + 3) !== 47 /* slash */);
	  }
	  function isPartOfTypeNode(node) {
	    if (182 /* FirstTypeNode */ <= node.kind && node.kind <= 205 /* LastTypeNode */) {
	      return true;
	    }
	    switch (node.kind) {
	      case 133 /* AnyKeyword */:
	      case 159 /* UnknownKeyword */:
	      case 150 /* NumberKeyword */:
	      case 163 /* BigIntKeyword */:
	      case 154 /* StringKeyword */:
	      case 136 /* BooleanKeyword */:
	      case 155 /* SymbolKeyword */:
	      case 151 /* ObjectKeyword */:
	      case 157 /* UndefinedKeyword */:
	      case 106 /* NullKeyword */:
	      case 146 /* NeverKeyword */:
	        return true;
	      case 116 /* VoidKeyword */:
	        return node.parent.kind !== 222 /* VoidExpression */;
	      case 233 /* ExpressionWithTypeArguments */:
	        return isPartOfTypeExpressionWithTypeArguments(node);
	      case 168 /* TypeParameter */:
	        return node.parent.kind === 200 /* MappedType */ || node.parent.kind === 195 /* InferType */;
	      case 80 /* Identifier */:
	        if (node.parent.kind === 166 /* QualifiedName */ && node.parent.right === node) {
	          node = node.parent;
	        } else if (node.parent.kind === 211 /* PropertyAccessExpression */ && node.parent.name === node) {
	          node = node.parent;
	        }
	        Debug.assert(node.kind === 80 /* Identifier */ || node.kind === 166 /* QualifiedName */ || node.kind === 211 /* PropertyAccessExpression */, "'node' was expected to be a qualified name, identifier or property access in 'isPartOfTypeNode'.");
	      case 166 /* QualifiedName */:
	      case 211 /* PropertyAccessExpression */:
	      case 110 /* ThisKeyword */: {
	        const { parent: parent2 } = node;
	        if (parent2.kind === 186 /* TypeQuery */) {
	          return false;
	        }
	        if (parent2.kind === 205 /* ImportType */) {
	          return !parent2.isTypeOf;
	        }
	        if (182 /* FirstTypeNode */ <= parent2.kind && parent2.kind <= 205 /* LastTypeNode */) {
	          return true;
	        }
	        switch (parent2.kind) {
	          case 233 /* ExpressionWithTypeArguments */:
	            return isPartOfTypeExpressionWithTypeArguments(parent2);
	          case 168 /* TypeParameter */:
	            return node === parent2.constraint;
	          case 352 /* JSDocTemplateTag */:
	            return node === parent2.constraint;
	          case 172 /* PropertyDeclaration */:
	          case 171 /* PropertySignature */:
	          case 169 /* Parameter */:
	          case 260 /* VariableDeclaration */:
	            return node === parent2.type;
	          case 262 /* FunctionDeclaration */:
	          case 218 /* FunctionExpression */:
	          case 219 /* ArrowFunction */:
	          case 176 /* Constructor */:
	          case 174 /* MethodDeclaration */:
	          case 173 /* MethodSignature */:
	          case 177 /* GetAccessor */:
	          case 178 /* SetAccessor */:
	            return node === parent2.type;
	          case 179 /* CallSignature */:
	          case 180 /* ConstructSignature */:
	          case 181 /* IndexSignature */:
	            return node === parent2.type;
	          case 216 /* TypeAssertionExpression */:
	            return node === parent2.type;
	          case 213 /* CallExpression */:
	          case 214 /* NewExpression */:
	          case 215 /* TaggedTemplateExpression */:
	            return contains(parent2.typeArguments, node);
	        }
	      }
	    }
	    return false;
	  }
	  function isPartOfTypeExpressionWithTypeArguments(node) {
	    return isJSDocImplementsTag(node.parent) || isJSDocAugmentsTag(node.parent) || isHeritageClause(node.parent) && !isExpressionWithTypeArgumentsInClassExtendsClause(node);
	  }
	  function isChildOfNodeWithKind(node, kind) {
	    while (node) {
	      if (node.kind === kind) {
	        return true;
	      }
	      node = node.parent;
	    }
	    return false;
	  }
	  function forEachReturnStatement(body, visitor) {
	    return traverse(body);
	    function traverse(node) {
	      switch (node.kind) {
	        case 253 /* ReturnStatement */:
	          return visitor(node);
	        case 269 /* CaseBlock */:
	        case 241 /* Block */:
	        case 245 /* IfStatement */:
	        case 246 /* DoStatement */:
	        case 247 /* WhileStatement */:
	        case 248 /* ForStatement */:
	        case 249 /* ForInStatement */:
	        case 250 /* ForOfStatement */:
	        case 254 /* WithStatement */:
	        case 255 /* SwitchStatement */:
	        case 296 /* CaseClause */:
	        case 297 /* DefaultClause */:
	        case 256 /* LabeledStatement */:
	        case 258 /* TryStatement */:
	        case 299 /* CatchClause */:
	          return forEachChild(node, traverse);
	      }
	    }
	  }
	  function forEachYieldExpression(body, visitor) {
	    return traverse(body);
	    function traverse(node) {
	      switch (node.kind) {
	        case 229 /* YieldExpression */:
	          visitor(node);
	          const operand = node.expression;
	          if (operand) {
	            traverse(operand);
	          }
	          return;
	        case 266 /* EnumDeclaration */:
	        case 264 /* InterfaceDeclaration */:
	        case 267 /* ModuleDeclaration */:
	        case 265 /* TypeAliasDeclaration */:
	          return;
	        default:
	          if (isFunctionLike(node)) {
	            if (node.name && node.name.kind === 167 /* ComputedPropertyName */) {
	              traverse(node.name.expression);
	              return;
	            }
	          } else if (!isPartOfTypeNode(node)) {
	            forEachChild(node, traverse);
	          }
	      }
	    }
	  }
	  function getRestParameterElementType(node) {
	    if (node && node.kind === 188 /* ArrayType */) {
	      return node.elementType;
	    } else if (node && node.kind === 183 /* TypeReference */) {
	      return singleOrUndefined(node.typeArguments);
	    } else {
	      return void 0;
	    }
	  }
	  function getMembersOfDeclaration(node) {
	    switch (node.kind) {
	      case 264 /* InterfaceDeclaration */:
	      case 263 /* ClassDeclaration */:
	      case 231 /* ClassExpression */:
	      case 187 /* TypeLiteral */:
	        return node.members;
	      case 210 /* ObjectLiteralExpression */:
	        return node.properties;
	    }
	  }
	  function isVariableLike(node) {
	    if (node) {
	      switch (node.kind) {
	        case 208 /* BindingElement */:
	        case 306 /* EnumMember */:
	        case 169 /* Parameter */:
	        case 303 /* PropertyAssignment */:
	        case 172 /* PropertyDeclaration */:
	        case 171 /* PropertySignature */:
	        case 304 /* ShorthandPropertyAssignment */:
	        case 260 /* VariableDeclaration */:
	          return true;
	      }
	    }
	    return false;
	  }
	  function isVariableLikeOrAccessor(node) {
	    return isVariableLike(node) || isAccessor(node);
	  }
	  function isVariableDeclarationInVariableStatement(node) {
	    return node.parent.kind === 261 /* VariableDeclarationList */ && node.parent.parent.kind === 243 /* VariableStatement */;
	  }
	  function isCommonJsExportedExpression(node) {
	    if (!isInJSFile(node))
	      return false;
	    return isObjectLiteralExpression(node.parent) && isBinaryExpression(node.parent.parent) && getAssignmentDeclarationKind(node.parent.parent) === 2 /* ModuleExports */ || isCommonJsExportPropertyAssignment(node.parent);
	  }
	  function isCommonJsExportPropertyAssignment(node) {
	    if (!isInJSFile(node))
	      return false;
	    return isBinaryExpression(node) && getAssignmentDeclarationKind(node) === 1 /* ExportsProperty */;
	  }
	  function isValidESSymbolDeclaration(node) {
	    return (isVariableDeclaration(node) ? isVarConst(node) && isIdentifier(node.name) && isVariableDeclarationInVariableStatement(node) : isPropertyDeclaration(node) ? hasEffectiveReadonlyModifier(node) && hasStaticModifier(node) : isPropertySignature(node) && hasEffectiveReadonlyModifier(node)) || isCommonJsExportPropertyAssignment(node);
	  }
	  function introducesArgumentsExoticObject(node) {
	    switch (node.kind) {
	      case 174 /* MethodDeclaration */:
	      case 173 /* MethodSignature */:
	      case 176 /* Constructor */:
	      case 177 /* GetAccessor */:
	      case 178 /* SetAccessor */:
	      case 262 /* FunctionDeclaration */:
	      case 218 /* FunctionExpression */:
	        return true;
	    }
	    return false;
	  }
	  function unwrapInnermostStatementOfLabel(node, beforeUnwrapLabelCallback) {
	    while (true) {
	      if (beforeUnwrapLabelCallback) {
	        beforeUnwrapLabelCallback(node);
	      }
	      if (node.statement.kind !== 256 /* LabeledStatement */) {
	        return node.statement;
	      }
	      node = node.statement;
	    }
	  }
	  function isFunctionBlock(node) {
	    return node && node.kind === 241 /* Block */ && isFunctionLike(node.parent);
	  }
	  function isObjectLiteralMethod(node) {
	    return node && node.kind === 174 /* MethodDeclaration */ && node.parent.kind === 210 /* ObjectLiteralExpression */;
	  }
	  function isObjectLiteralOrClassExpressionMethodOrAccessor(node) {
	    return (node.kind === 174 /* MethodDeclaration */ || node.kind === 177 /* GetAccessor */ || node.kind === 178 /* SetAccessor */) && (node.parent.kind === 210 /* ObjectLiteralExpression */ || node.parent.kind === 231 /* ClassExpression */);
	  }
	  function isIdentifierTypePredicate(predicate) {
	    return predicate && predicate.kind === 1 /* Identifier */;
	  }
	  function isThisTypePredicate(predicate) {
	    return predicate && predicate.kind === 0 /* This */;
	  }
	  function forEachPropertyAssignment(objectLiteral, key, callback, key2) {
	    return forEach(objectLiteral == null ? void 0 : objectLiteral.properties, (property) => {
	      if (!isPropertyAssignment(property))
	        return void 0;
	      const propName = tryGetTextOfPropertyName(property.name);
	      return key === propName || key2 && key2 === propName ? callback(property) : void 0;
	    });
	  }
	  function getPropertyArrayElementValue(objectLiteral, propKey, elementValue) {
	    return forEachPropertyAssignment(objectLiteral, propKey, (property) => isArrayLiteralExpression(property.initializer) ? find(property.initializer.elements, (element) => isStringLiteral(element) && element.text === elementValue) : void 0);
	  }
	  function getTsConfigObjectLiteralExpression(tsConfigSourceFile) {
	    if (tsConfigSourceFile && tsConfigSourceFile.statements.length) {
	      const expression = tsConfigSourceFile.statements[0].expression;
	      return tryCast(expression, isObjectLiteralExpression);
	    }
	  }
	  function getTsConfigPropArrayElementValue(tsConfigSourceFile, propKey, elementValue) {
	    return forEachTsConfigPropArray(tsConfigSourceFile, propKey, (property) => isArrayLiteralExpression(property.initializer) ? find(property.initializer.elements, (element) => isStringLiteral(element) && element.text === elementValue) : void 0);
	  }
	  function forEachTsConfigPropArray(tsConfigSourceFile, propKey, callback) {
	    return forEachPropertyAssignment(getTsConfigObjectLiteralExpression(tsConfigSourceFile), propKey, callback);
	  }
	  function getContainingFunction(node) {
	    return findAncestor(node.parent, isFunctionLike);
	  }
	  function getContainingFunctionDeclaration(node) {
	    return findAncestor(node.parent, isFunctionLikeDeclaration);
	  }
	  function getContainingClass(node) {
	    return findAncestor(node.parent, isClassLike);
	  }
	  function getContainingClassStaticBlock(node) {
	    return findAncestor(node.parent, (n) => {
	      if (isClassLike(n) || isFunctionLike(n)) {
	        return "quit";
	      }
	      return isClassStaticBlockDeclaration(n);
	    });
	  }
	  function getContainingFunctionOrClassStaticBlock(node) {
	    return findAncestor(node.parent, isFunctionLikeOrClassStaticBlockDeclaration);
	  }
	  function getContainingClassExcludingClassDecorators(node) {
	    const decorator = findAncestor(node.parent, (n) => isClassLike(n) ? "quit" : isDecorator(n));
	    return decorator && isClassLike(decorator.parent) ? getContainingClass(decorator.parent) : getContainingClass(decorator ?? node);
	  }
	  function getThisContainer(node, includeArrowFunctions, includeClassComputedPropertyName) {
	    Debug.assert(node.kind !== 312 /* SourceFile */);
	    while (true) {
	      node = node.parent;
	      if (!node) {
	        return Debug.fail();
	      }
	      switch (node.kind) {
	        case 167 /* ComputedPropertyName */:
	          if (includeClassComputedPropertyName && isClassLike(node.parent.parent)) {
	            return node;
	          }
	          node = node.parent.parent;
	          break;
	        case 170 /* Decorator */:
	          if (node.parent.kind === 169 /* Parameter */ && isClassElement(node.parent.parent)) {
	            node = node.parent.parent;
	          } else if (isClassElement(node.parent)) {
	            node = node.parent;
	          }
	          break;
	        case 219 /* ArrowFunction */:
	          if (!includeArrowFunctions) {
	            continue;
	          }
	        case 262 /* FunctionDeclaration */:
	        case 218 /* FunctionExpression */:
	        case 267 /* ModuleDeclaration */:
	        case 175 /* ClassStaticBlockDeclaration */:
	        case 172 /* PropertyDeclaration */:
	        case 171 /* PropertySignature */:
	        case 174 /* MethodDeclaration */:
	        case 173 /* MethodSignature */:
	        case 176 /* Constructor */:
	        case 177 /* GetAccessor */:
	        case 178 /* SetAccessor */:
	        case 179 /* CallSignature */:
	        case 180 /* ConstructSignature */:
	        case 181 /* IndexSignature */:
	        case 266 /* EnumDeclaration */:
	        case 312 /* SourceFile */:
	          return node;
	      }
	    }
	  }
	  function isThisContainerOrFunctionBlock(node) {
	    switch (node.kind) {
	      case 219 /* ArrowFunction */:
	      case 262 /* FunctionDeclaration */:
	      case 218 /* FunctionExpression */:
	      case 172 /* PropertyDeclaration */:
	        return true;
	      case 241 /* Block */:
	        switch (node.parent.kind) {
	          case 176 /* Constructor */:
	          case 174 /* MethodDeclaration */:
	          case 177 /* GetAccessor */:
	          case 178 /* SetAccessor */:
	            return true;
	          default:
	            return false;
	        }
	      default:
	        return false;
	    }
	  }
	  function isInTopLevelContext(node) {
	    if (isIdentifier(node) && (isClassDeclaration(node.parent) || isFunctionDeclaration(node.parent)) && node.parent.name === node) {
	      node = node.parent;
	    }
	    const container = getThisContainer(
	      node,
	      /*includeArrowFunctions*/
	      true,
	      /*includeClassComputedPropertyName*/
	      false
	    );
	    return isSourceFile(container);
	  }
	  function getNewTargetContainer(node) {
	    const container = getThisContainer(
	      node,
	      /*includeArrowFunctions*/
	      false,
	      /*includeClassComputedPropertyName*/
	      false
	    );
	    if (container) {
	      switch (container.kind) {
	        case 176 /* Constructor */:
	        case 262 /* FunctionDeclaration */:
	        case 218 /* FunctionExpression */:
	          return container;
	      }
	    }
	    return void 0;
	  }
	  function getSuperContainer(node, stopOnFunctions) {
	    while (true) {
	      node = node.parent;
	      if (!node) {
	        return void 0;
	      }
	      switch (node.kind) {
	        case 167 /* ComputedPropertyName */:
	          node = node.parent;
	          break;
	        case 262 /* FunctionDeclaration */:
	        case 218 /* FunctionExpression */:
	        case 219 /* ArrowFunction */:
	          if (!stopOnFunctions) {
	            continue;
	          }
	        case 172 /* PropertyDeclaration */:
	        case 171 /* PropertySignature */:
	        case 174 /* MethodDeclaration */:
	        case 173 /* MethodSignature */:
	        case 176 /* Constructor */:
	        case 177 /* GetAccessor */:
	        case 178 /* SetAccessor */:
	        case 175 /* ClassStaticBlockDeclaration */:
	          return node;
	        case 170 /* Decorator */:
	          if (node.parent.kind === 169 /* Parameter */ && isClassElement(node.parent.parent)) {
	            node = node.parent.parent;
	          } else if (isClassElement(node.parent)) {
	            node = node.parent;
	          }
	          break;
	      }
	    }
	  }
	  function getImmediatelyInvokedFunctionExpression(func) {
	    if (func.kind === 218 /* FunctionExpression */ || func.kind === 219 /* ArrowFunction */) {
	      let prev = func;
	      let parent2 = func.parent;
	      while (parent2.kind === 217 /* ParenthesizedExpression */) {
	        prev = parent2;
	        parent2 = parent2.parent;
	      }
	      if (parent2.kind === 213 /* CallExpression */ && parent2.expression === prev) {
	        return parent2;
	      }
	    }
	  }
	  function isSuperOrSuperProperty(node) {
	    return node.kind === 108 /* SuperKeyword */ || isSuperProperty(node);
	  }
	  function isSuperProperty(node) {
	    const kind = node.kind;
	    return (kind === 211 /* PropertyAccessExpression */ || kind === 212 /* ElementAccessExpression */) && node.expression.kind === 108 /* SuperKeyword */;
	  }
	  function isThisProperty(node) {
	    const kind = node.kind;
	    return (kind === 211 /* PropertyAccessExpression */ || kind === 212 /* ElementAccessExpression */) && node.expression.kind === 110 /* ThisKeyword */;
	  }
	  function isThisInitializedDeclaration(node) {
	    var _a;
	    return !!node && isVariableDeclaration(node) && ((_a = node.initializer) == null ? void 0 : _a.kind) === 110 /* ThisKeyword */;
	  }
	  function isThisInitializedObjectBindingExpression(node) {
	    return !!node && (isShorthandPropertyAssignment(node) || isPropertyAssignment(node)) && isBinaryExpression(node.parent.parent) && node.parent.parent.operatorToken.kind === 64 /* EqualsToken */ && node.parent.parent.right.kind === 110 /* ThisKeyword */;
	  }
	  function getEntityNameFromTypeNode(node) {
	    switch (node.kind) {
	      case 183 /* TypeReference */:
	        return node.typeName;
	      case 233 /* ExpressionWithTypeArguments */:
	        return isEntityNameExpression(node.expression) ? node.expression : void 0;
	      case 80 /* Identifier */:
	      case 166 /* QualifiedName */:
	        return node;
	    }
	    return void 0;
	  }
	  function getInvokedExpression(node) {
	    switch (node.kind) {
	      case 215 /* TaggedTemplateExpression */:
	        return node.tag;
	      case 286 /* JsxOpeningElement */:
	      case 285 /* JsxSelfClosingElement */:
	        return node.tagName;
	      case 226 /* BinaryExpression */:
	        return node.right;
	      default:
	        return node.expression;
	    }
	  }
	  function nodeCanBeDecorated(useLegacyDecorators, node, parent2, grandparent) {
	    if (useLegacyDecorators && isNamedDeclaration(node) && isPrivateIdentifier(node.name)) {
	      return false;
	    }
	    switch (node.kind) {
	      case 263 /* ClassDeclaration */:
	        return true;
	      case 231 /* ClassExpression */:
	        return !useLegacyDecorators;
	      case 172 /* PropertyDeclaration */:
	        return parent2 !== void 0 && (useLegacyDecorators ? isClassDeclaration(parent2) : isClassLike(parent2) && !hasAbstractModifier(node) && !hasAmbientModifier(node));
	      case 177 /* GetAccessor */:
	      case 178 /* SetAccessor */:
	      case 174 /* MethodDeclaration */:
	        return node.body !== void 0 && parent2 !== void 0 && (useLegacyDecorators ? isClassDeclaration(parent2) : isClassLike(parent2));
	      case 169 /* Parameter */:
	        if (!useLegacyDecorators)
	          return false;
	        return parent2 !== void 0 && parent2.body !== void 0 && (parent2.kind === 176 /* Constructor */ || parent2.kind === 174 /* MethodDeclaration */ || parent2.kind === 178 /* SetAccessor */) && getThisParameter(parent2) !== node && grandparent !== void 0 && grandparent.kind === 263 /* ClassDeclaration */;
	    }
	    return false;
	  }
	  function nodeIsDecorated(useLegacyDecorators, node, parent2, grandparent) {
	    return hasDecorators(node) && nodeCanBeDecorated(useLegacyDecorators, node, parent2, grandparent);
	  }
	  function nodeOrChildIsDecorated(useLegacyDecorators, node, parent2, grandparent) {
	    return nodeIsDecorated(useLegacyDecorators, node, parent2, grandparent) || childIsDecorated(useLegacyDecorators, node, parent2);
	  }
	  function childIsDecorated(useLegacyDecorators, node, parent2) {
	    switch (node.kind) {
	      case 263 /* ClassDeclaration */:
	        return some(node.members, (m) => nodeOrChildIsDecorated(useLegacyDecorators, m, node, parent2));
	      case 231 /* ClassExpression */:
	        return !useLegacyDecorators && some(node.members, (m) => nodeOrChildIsDecorated(useLegacyDecorators, m, node, parent2));
	      case 174 /* MethodDeclaration */:
	      case 178 /* SetAccessor */:
	      case 176 /* Constructor */:
	        return some(node.parameters, (p) => nodeIsDecorated(useLegacyDecorators, p, node, parent2));
	      default:
	        return false;
	    }
	  }
	  function classOrConstructorParameterIsDecorated(useLegacyDecorators, node) {
	    if (nodeIsDecorated(useLegacyDecorators, node))
	      return true;
	    const constructor = getFirstConstructorWithBody(node);
	    return !!constructor && childIsDecorated(useLegacyDecorators, constructor, node);
	  }
	  function classElementOrClassElementParameterIsDecorated(useLegacyDecorators, node, parent2) {
	    let parameters;
	    if (isAccessor(node)) {
	      const { firstAccessor, secondAccessor, setAccessor } = getAllAccessorDeclarations(parent2.members, node);
	      const firstAccessorWithDecorators = hasDecorators(firstAccessor) ? firstAccessor : secondAccessor && hasDecorators(secondAccessor) ? secondAccessor : void 0;
	      if (!firstAccessorWithDecorators || node !== firstAccessorWithDecorators) {
	        return false;
	      }
	      parameters = setAccessor == null ? void 0 : setAccessor.parameters;
	    } else if (isMethodDeclaration(node)) {
	      parameters = node.parameters;
	    }
	    if (nodeIsDecorated(useLegacyDecorators, node, parent2)) {
	      return true;
	    }
	    if (parameters) {
	      for (const parameter of parameters) {
	        if (parameterIsThisKeyword(parameter))
	          continue;
	        if (nodeIsDecorated(useLegacyDecorators, parameter, node, parent2))
	          return true;
	      }
	    }
	    return false;
	  }
	  function isEmptyStringLiteral(node) {
	    if (node.textSourceNode) {
	      switch (node.textSourceNode.kind) {
	        case 11 /* StringLiteral */:
	          return isEmptyStringLiteral(node.textSourceNode);
	        case 15 /* NoSubstitutionTemplateLiteral */:
	          return node.text === "";
	      }
	      return false;
	    }
	    return node.text === "";
	  }
	  function isJSXTagName(node) {
	    const { parent: parent2 } = node;
	    if (parent2.kind === 286 /* JsxOpeningElement */ || parent2.kind === 285 /* JsxSelfClosingElement */ || parent2.kind === 287 /* JsxClosingElement */) {
	      return parent2.tagName === node;
	    }
	    return false;
	  }
	  function isExpressionNode(node) {
	    switch (node.kind) {
	      case 108 /* SuperKeyword */:
	      case 106 /* NullKeyword */:
	      case 112 /* TrueKeyword */:
	      case 97 /* FalseKeyword */:
	      case 14 /* RegularExpressionLiteral */:
	      case 209 /* ArrayLiteralExpression */:
	      case 210 /* ObjectLiteralExpression */:
	      case 211 /* PropertyAccessExpression */:
	      case 212 /* ElementAccessExpression */:
	      case 213 /* CallExpression */:
	      case 214 /* NewExpression */:
	      case 215 /* TaggedTemplateExpression */:
	      case 234 /* AsExpression */:
	      case 216 /* TypeAssertionExpression */:
	      case 238 /* SatisfiesExpression */:
	      case 235 /* NonNullExpression */:
	      case 217 /* ParenthesizedExpression */:
	      case 218 /* FunctionExpression */:
	      case 231 /* ClassExpression */:
	      case 219 /* ArrowFunction */:
	      case 222 /* VoidExpression */:
	      case 220 /* DeleteExpression */:
	      case 221 /* TypeOfExpression */:
	      case 224 /* PrefixUnaryExpression */:
	      case 225 /* PostfixUnaryExpression */:
	      case 226 /* BinaryExpression */:
	      case 227 /* ConditionalExpression */:
	      case 230 /* SpreadElement */:
	      case 228 /* TemplateExpression */:
	      case 232 /* OmittedExpression */:
	      case 284 /* JsxElement */:
	      case 285 /* JsxSelfClosingElement */:
	      case 288 /* JsxFragment */:
	      case 229 /* YieldExpression */:
	      case 223 /* AwaitExpression */:
	      case 236 /* MetaProperty */:
	        return true;
	      case 233 /* ExpressionWithTypeArguments */:
	        return !isHeritageClause(node.parent) && !isJSDocAugmentsTag(node.parent);
	      case 166 /* QualifiedName */:
	        while (node.parent.kind === 166 /* QualifiedName */) {
	          node = node.parent;
	        }
	        return node.parent.kind === 186 /* TypeQuery */ || isJSDocLinkLike(node.parent) || isJSDocNameReference(node.parent) || isJSDocMemberName(node.parent) || isJSXTagName(node);
	      case 318 /* JSDocMemberName */:
	        while (isJSDocMemberName(node.parent)) {
	          node = node.parent;
	        }
	        return node.parent.kind === 186 /* TypeQuery */ || isJSDocLinkLike(node.parent) || isJSDocNameReference(node.parent) || isJSDocMemberName(node.parent) || isJSXTagName(node);
	      case 81 /* PrivateIdentifier */:
	        return isBinaryExpression(node.parent) && node.parent.left === node && node.parent.operatorToken.kind === 103 /* InKeyword */;
	      case 80 /* Identifier */:
	        if (node.parent.kind === 186 /* TypeQuery */ || isJSDocLinkLike(node.parent) || isJSDocNameReference(node.parent) || isJSDocMemberName(node.parent) || isJSXTagName(node)) {
	          return true;
	        }
	      case 9 /* NumericLiteral */:
	      case 10 /* BigIntLiteral */:
	      case 11 /* StringLiteral */:
	      case 15 /* NoSubstitutionTemplateLiteral */:
	      case 110 /* ThisKeyword */:
	        return isInExpressionContext(node);
	      default:
	        return false;
	    }
	  }
	  function isInExpressionContext(node) {
	    const { parent: parent2 } = node;
	    switch (parent2.kind) {
	      case 260 /* VariableDeclaration */:
	      case 169 /* Parameter */:
	      case 172 /* PropertyDeclaration */:
	      case 171 /* PropertySignature */:
	      case 306 /* EnumMember */:
	      case 303 /* PropertyAssignment */:
	      case 208 /* BindingElement */:
	        return parent2.initializer === node;
	      case 244 /* ExpressionStatement */:
	      case 245 /* IfStatement */:
	      case 246 /* DoStatement */:
	      case 247 /* WhileStatement */:
	      case 253 /* ReturnStatement */:
	      case 254 /* WithStatement */:
	      case 255 /* SwitchStatement */:
	      case 296 /* CaseClause */:
	      case 257 /* ThrowStatement */:
	        return parent2.expression === node;
	      case 248 /* ForStatement */:
	        const forStatement = parent2;
	        return forStatement.initializer === node && forStatement.initializer.kind !== 261 /* VariableDeclarationList */ || forStatement.condition === node || forStatement.incrementor === node;
	      case 249 /* ForInStatement */:
	      case 250 /* ForOfStatement */:
	        const forInOrOfStatement = parent2;
	        return forInOrOfStatement.initializer === node && forInOrOfStatement.initializer.kind !== 261 /* VariableDeclarationList */ || forInOrOfStatement.expression === node;
	      case 216 /* TypeAssertionExpression */:
	      case 234 /* AsExpression */:
	        return node === parent2.expression;
	      case 239 /* TemplateSpan */:
	        return node === parent2.expression;
	      case 167 /* ComputedPropertyName */:
	        return node === parent2.expression;
	      case 170 /* Decorator */:
	      case 294 /* JsxExpression */:
	      case 293 /* JsxSpreadAttribute */:
	      case 305 /* SpreadAssignment */:
	        return true;
	      case 233 /* ExpressionWithTypeArguments */:
	        return parent2.expression === node && !isPartOfTypeNode(parent2);
	      case 304 /* ShorthandPropertyAssignment */:
	        return parent2.objectAssignmentInitializer === node;
	      case 238 /* SatisfiesExpression */:
	        return node === parent2.expression;
	      default:
	        return isExpressionNode(parent2);
	    }
	  }
	  function isPartOfTypeQuery(node) {
	    while (node.kind === 166 /* QualifiedName */ || node.kind === 80 /* Identifier */) {
	      node = node.parent;
	    }
	    return node.kind === 186 /* TypeQuery */;
	  }
	  function isNamespaceReexportDeclaration(node) {
	    return isNamespaceExport(node) && !!node.parent.moduleSpecifier;
	  }
	  function isExternalModuleImportEqualsDeclaration(node) {
	    return node.kind === 271 /* ImportEqualsDeclaration */ && node.moduleReference.kind === 283 /* ExternalModuleReference */;
	  }
	  function getExternalModuleImportEqualsDeclarationExpression(node) {
	    Debug.assert(isExternalModuleImportEqualsDeclaration(node));
	    return node.moduleReference.expression;
	  }
	  function getExternalModuleRequireArgument(node) {
	    return isVariableDeclarationInitializedToBareOrAccessedRequire(node) && getLeftmostAccessExpression(node.initializer).arguments[0];
	  }
	  function isInternalModuleImportEqualsDeclaration(node) {
	    return node.kind === 271 /* ImportEqualsDeclaration */ && node.moduleReference.kind !== 283 /* ExternalModuleReference */;
	  }
	  function isSourceFileJS(file) {
	    return isInJSFile(file);
	  }
	  function isSourceFileNotJS(file) {
	    return !isInJSFile(file);
	  }
	  function isInJSFile(node) {
	    return !!node && !!(node.flags & 524288 /* JavaScriptFile */);
	  }
	  function isInJsonFile(node) {
	    return !!node && !!(node.flags & 134217728 /* JsonFile */);
	  }
	  function isSourceFileNotJson(file) {
	    return !isJsonSourceFile(file);
	  }
	  function isInJSDoc(node) {
	    return !!node && !!(node.flags & 16777216 /* JSDoc */);
	  }
	  function isJSDocIndexSignature(node) {
	    return isTypeReferenceNode(node) && isIdentifier(node.typeName) && node.typeName.escapedText === "Object" && node.typeArguments && node.typeArguments.length === 2 && (node.typeArguments[0].kind === 154 /* StringKeyword */ || node.typeArguments[0].kind === 150 /* NumberKeyword */);
	  }
	  function isRequireCall(callExpression, requireStringLiteralLikeArgument) {
	    if (callExpression.kind !== 213 /* CallExpression */) {
	      return false;
	    }
	    const { expression, arguments: args } = callExpression;
	    if (expression.kind !== 80 /* Identifier */ || expression.escapedText !== "require") {
	      return false;
	    }
	    if (args.length !== 1) {
	      return false;
	    }
	    const arg = args[0];
	    return !requireStringLiteralLikeArgument || isStringLiteralLike(arg);
	  }
	  function isVariableDeclarationInitializedToRequire(node) {
	    return isVariableDeclarationInitializedWithRequireHelper(
	      node,
	      /*allowAccessedRequire*/
	      false
	    );
	  }
	  function isVariableDeclarationInitializedToBareOrAccessedRequire(node) {
	    return isVariableDeclarationInitializedWithRequireHelper(
	      node,
	      /*allowAccessedRequire*/
	      true
	    );
	  }
	  function isBindingElementOfBareOrAccessedRequire(node) {
	    return isBindingElement(node) && isVariableDeclarationInitializedToBareOrAccessedRequire(node.parent.parent);
	  }
	  function isVariableDeclarationInitializedWithRequireHelper(node, allowAccessedRequire) {
	    return isVariableDeclaration(node) && !!node.initializer && isRequireCall(
	      allowAccessedRequire ? getLeftmostAccessExpression(node.initializer) : node.initializer,
	      /*requireStringLiteralLikeArgument*/
	      true
	    );
	  }
	  function isRequireVariableStatement(node) {
	    return isVariableStatement(node) && node.declarationList.declarations.length > 0 && every(node.declarationList.declarations, (decl) => isVariableDeclarationInitializedToRequire(decl));
	  }
	  function isSingleOrDoubleQuote(charCode) {
	    return charCode === 39 /* singleQuote */ || charCode === 34 /* doubleQuote */;
	  }
	  function isStringDoubleQuoted(str, sourceFile) {
	    return getSourceTextOfNodeFromSourceFile(sourceFile, str).charCodeAt(0) === 34 /* doubleQuote */;
	  }
	  function isAssignmentDeclaration(decl) {
	    return isBinaryExpression(decl) || isAccessExpression(decl) || isIdentifier(decl) || isCallExpression(decl);
	  }
	  function getEffectiveInitializer(node) {
	    if (isInJSFile(node) && node.initializer && isBinaryExpression(node.initializer) && (node.initializer.operatorToken.kind === 57 /* BarBarToken */ || node.initializer.operatorToken.kind === 61 /* QuestionQuestionToken */) && node.name && isEntityNameExpression(node.name) && isSameEntityName(node.name, node.initializer.left)) {
	      return node.initializer.right;
	    }
	    return node.initializer;
	  }
	  function getDeclaredExpandoInitializer(node) {
	    const init = getEffectiveInitializer(node);
	    return init && getExpandoInitializer(init, isPrototypeAccess(node.name));
	  }
	  function hasExpandoValueProperty(node, isPrototypeAssignment) {
	    return forEach(node.properties, (p) => isPropertyAssignment(p) && isIdentifier(p.name) && p.name.escapedText === "value" && p.initializer && getExpandoInitializer(p.initializer, isPrototypeAssignment));
	  }
	  function getAssignedExpandoInitializer(node) {
	    if (node && node.parent && isBinaryExpression(node.parent) && node.parent.operatorToken.kind === 64 /* EqualsToken */) {
	      const isPrototypeAssignment = isPrototypeAccess(node.parent.left);
	      return getExpandoInitializer(node.parent.right, isPrototypeAssignment) || getDefaultedExpandoInitializer(node.parent.left, node.parent.right, isPrototypeAssignment);
	    }
	    if (node && isCallExpression(node) && isBindableObjectDefinePropertyCall(node)) {
	      const result = hasExpandoValueProperty(node.arguments[2], node.arguments[1].text === "prototype");
	      if (result) {
	        return result;
	      }
	    }
	  }
	  function getExpandoInitializer(initializer, isPrototypeAssignment) {
	    if (isCallExpression(initializer)) {
	      const e = skipParentheses(initializer.expression);
	      return e.kind === 218 /* FunctionExpression */ || e.kind === 219 /* ArrowFunction */ ? initializer : void 0;
	    }
	    if (initializer.kind === 218 /* FunctionExpression */ || initializer.kind === 231 /* ClassExpression */ || initializer.kind === 219 /* ArrowFunction */) {
	      return initializer;
	    }
	    if (isObjectLiteralExpression(initializer) && (initializer.properties.length === 0 || isPrototypeAssignment)) {
	      return initializer;
	    }
	  }
	  function getDefaultedExpandoInitializer(name, initializer, isPrototypeAssignment) {
	    const e = isBinaryExpression(initializer) && (initializer.operatorToken.kind === 57 /* BarBarToken */ || initializer.operatorToken.kind === 61 /* QuestionQuestionToken */) && getExpandoInitializer(initializer.right, isPrototypeAssignment);
	    if (e && isSameEntityName(name, initializer.left)) {
	      return e;
	    }
	  }
	  function isDefaultedExpandoInitializer(node) {
	    const name = isVariableDeclaration(node.parent) ? node.parent.name : isBinaryExpression(node.parent) && node.parent.operatorToken.kind === 64 /* EqualsToken */ ? node.parent.left : void 0;
	    return name && getExpandoInitializer(node.right, isPrototypeAccess(name)) && isEntityNameExpression(name) && isSameEntityName(name, node.left);
	  }
	  function getNameOfExpando(node) {
	    if (isBinaryExpression(node.parent)) {
	      const parent2 = (node.parent.operatorToken.kind === 57 /* BarBarToken */ || node.parent.operatorToken.kind === 61 /* QuestionQuestionToken */) && isBinaryExpression(node.parent.parent) ? node.parent.parent : node.parent;
	      if (parent2.operatorToken.kind === 64 /* EqualsToken */ && isIdentifier(parent2.left)) {
	        return parent2.left;
	      }
	    } else if (isVariableDeclaration(node.parent)) {
	      return node.parent.name;
	    }
	  }
	  function isSameEntityName(name, initializer) {
	    if (isPropertyNameLiteral(name) && isPropertyNameLiteral(initializer)) {
	      return getTextOfIdentifierOrLiteral(name) === getTextOfIdentifierOrLiteral(initializer);
	    }
	    if (isMemberName(name) && isLiteralLikeAccess(initializer) && (initializer.expression.kind === 110 /* ThisKeyword */ || isIdentifier(initializer.expression) && (initializer.expression.escapedText === "window" || initializer.expression.escapedText === "self" || initializer.expression.escapedText === "global"))) {
	      return isSameEntityName(name, getNameOrArgument(initializer));
	    }
	    if (isLiteralLikeAccess(name) && isLiteralLikeAccess(initializer)) {
	      return getElementOrPropertyAccessName(name) === getElementOrPropertyAccessName(initializer) && isSameEntityName(name.expression, initializer.expression);
	    }
	    return false;
	  }
	  function getRightMostAssignedExpression(node) {
	    while (isAssignmentExpression(
	      node,
	      /*excludeCompoundAssignment*/
	      true
	    )) {
	      node = node.right;
	    }
	    return node;
	  }
	  function isExportsIdentifier(node) {
	    return isIdentifier(node) && node.escapedText === "exports";
	  }
	  function isModuleIdentifier(node) {
	    return isIdentifier(node) && node.escapedText === "module";
	  }
	  function isModuleExportsAccessExpression(node) {
	    return (isPropertyAccessExpression(node) || isLiteralLikeElementAccess(node)) && isModuleIdentifier(node.expression) && getElementOrPropertyAccessName(node) === "exports";
	  }
	  function getAssignmentDeclarationKind(expr) {
	    const special = getAssignmentDeclarationKindWorker(expr);
	    return special === 5 /* Property */ || isInJSFile(expr) ? special : 0 /* None */;
	  }
	  function isBindableObjectDefinePropertyCall(expr) {
	    return length(expr.arguments) === 3 && isPropertyAccessExpression(expr.expression) && isIdentifier(expr.expression.expression) && idText(expr.expression.expression) === "Object" && idText(expr.expression.name) === "defineProperty" && isStringOrNumericLiteralLike(expr.arguments[1]) && isBindableStaticNameExpression(
	      expr.arguments[0],
	      /*excludeThisKeyword*/
	      true
	    );
	  }
	  function isLiteralLikeAccess(node) {
	    return isPropertyAccessExpression(node) || isLiteralLikeElementAccess(node);
	  }
	  function isLiteralLikeElementAccess(node) {
	    return isElementAccessExpression(node) && isStringOrNumericLiteralLike(node.argumentExpression);
	  }
	  function isBindableStaticAccessExpression(node, excludeThisKeyword) {
	    return isPropertyAccessExpression(node) && (!excludeThisKeyword && node.expression.kind === 110 /* ThisKeyword */ || isIdentifier(node.name) && isBindableStaticNameExpression(
	      node.expression,
	      /*excludeThisKeyword*/
	      true
	    )) || isBindableStaticElementAccessExpression(node, excludeThisKeyword);
	  }
	  function isBindableStaticElementAccessExpression(node, excludeThisKeyword) {
	    return isLiteralLikeElementAccess(node) && (!excludeThisKeyword && node.expression.kind === 110 /* ThisKeyword */ || isEntityNameExpression(node.expression) || isBindableStaticAccessExpression(
	      node.expression,
	      /*excludeThisKeyword*/
	      true
	    ));
	  }
	  function isBindableStaticNameExpression(node, excludeThisKeyword) {
	    return isEntityNameExpression(node) || isBindableStaticAccessExpression(node, excludeThisKeyword);
	  }
	  function getNameOrArgument(expr) {
	    if (isPropertyAccessExpression(expr)) {
	      return expr.name;
	    }
	    return expr.argumentExpression;
	  }
	  function getAssignmentDeclarationKindWorker(expr) {
	    if (isCallExpression(expr)) {
	      if (!isBindableObjectDefinePropertyCall(expr)) {
	        return 0 /* None */;
	      }
	      const entityName = expr.arguments[0];
	      if (isExportsIdentifier(entityName) || isModuleExportsAccessExpression(entityName)) {
	        return 8 /* ObjectDefinePropertyExports */;
	      }
	      if (isBindableStaticAccessExpression(entityName) && getElementOrPropertyAccessName(entityName) === "prototype") {
	        return 9 /* ObjectDefinePrototypeProperty */;
	      }
	      return 7 /* ObjectDefinePropertyValue */;
	    }
	    if (expr.operatorToken.kind !== 64 /* EqualsToken */ || !isAccessExpression(expr.left) || isVoidZero(getRightMostAssignedExpression(expr))) {
	      return 0 /* None */;
	    }
	    if (isBindableStaticNameExpression(
	      expr.left.expression,
	      /*excludeThisKeyword*/
	      true
	    ) && getElementOrPropertyAccessName(expr.left) === "prototype" && isObjectLiteralExpression(getInitializerOfBinaryExpression(expr))) {
	      return 6 /* Prototype */;
	    }
	    return getAssignmentDeclarationPropertyAccessKind(expr.left);
	  }
	  function isVoidZero(node) {
	    return isVoidExpression(node) && isNumericLiteral(node.expression) && node.expression.text === "0";
	  }
	  function getElementOrPropertyAccessArgumentExpressionOrName(node) {
	    if (isPropertyAccessExpression(node)) {
	      return node.name;
	    }
	    const arg = skipParentheses(node.argumentExpression);
	    if (isNumericLiteral(arg) || isStringLiteralLike(arg)) {
	      return arg;
	    }
	    return node;
	  }
	  function getElementOrPropertyAccessName(node) {
	    const name = getElementOrPropertyAccessArgumentExpressionOrName(node);
	    if (name) {
	      if (isIdentifier(name)) {
	        return name.escapedText;
	      }
	      if (isStringLiteralLike(name) || isNumericLiteral(name)) {
	        return escapeLeadingUnderscores(name.text);
	      }
	    }
	    return void 0;
	  }
	  function getAssignmentDeclarationPropertyAccessKind(lhs) {
	    if (lhs.expression.kind === 110 /* ThisKeyword */) {
	      return 4 /* ThisProperty */;
	    } else if (isModuleExportsAccessExpression(lhs)) {
	      return 2 /* ModuleExports */;
	    } else if (isBindableStaticNameExpression(
	      lhs.expression,
	      /*excludeThisKeyword*/
	      true
	    )) {
	      if (isPrototypeAccess(lhs.expression)) {
	        return 3 /* PrototypeProperty */;
	      }
	      let nextToLast = lhs;
	      while (!isIdentifier(nextToLast.expression)) {
	        nextToLast = nextToLast.expression;
	      }
	      const id = nextToLast.expression;
	      if ((id.escapedText === "exports" || id.escapedText === "module" && getElementOrPropertyAccessName(nextToLast) === "exports") && // ExportsProperty does not support binding with computed names
	      isBindableStaticAccessExpression(lhs)) {
	        return 1 /* ExportsProperty */;
	      }
	      if (isBindableStaticNameExpression(
	        lhs,
	        /*excludeThisKeyword*/
	        true
	      ) || isElementAccessExpression(lhs) && isDynamicName(lhs)) {
	        return 5 /* Property */;
	      }
	    }
	    return 0 /* None */;
	  }
	  function getInitializerOfBinaryExpression(expr) {
	    while (isBinaryExpression(expr.right)) {
	      expr = expr.right;
	    }
	    return expr.right;
	  }
	  function isPrototypePropertyAssignment(node) {
	    return isBinaryExpression(node) && getAssignmentDeclarationKind(node) === 3 /* PrototypeProperty */;
	  }
	  function isSpecialPropertyDeclaration(expr) {
	    return isInJSFile(expr) && expr.parent && expr.parent.kind === 244 /* ExpressionStatement */ && (!isElementAccessExpression(expr) || isLiteralLikeElementAccess(expr)) && !!getJSDocTypeTag(expr.parent);
	  }
	  function setValueDeclaration(symbol, node) {
	    const { valueDeclaration } = symbol;
	    if (!valueDeclaration || !(node.flags & 33554432 /* Ambient */ && !isInJSFile(node) && !(valueDeclaration.flags & 33554432 /* Ambient */)) && (isAssignmentDeclaration(valueDeclaration) && !isAssignmentDeclaration(node)) || valueDeclaration.kind !== node.kind && isEffectiveModuleDeclaration(valueDeclaration)) {
	      symbol.valueDeclaration = node;
	    }
	  }
	  function isFunctionSymbol(symbol) {
	    if (!symbol || !symbol.valueDeclaration) {
	      return false;
	    }
	    const decl = symbol.valueDeclaration;
	    return decl.kind === 262 /* FunctionDeclaration */ || isVariableDeclaration(decl) && decl.initializer && isFunctionLike(decl.initializer);
	  }
	  function tryGetModuleSpecifierFromDeclaration(node) {
	    var _a, _b;
	    switch (node.kind) {
	      case 260 /* VariableDeclaration */:
	      case 208 /* BindingElement */:
	        return (_a = findAncestor(node.initializer, (node2) => isRequireCall(
	          node2,
	          /*requireStringLiteralLikeArgument*/
	          true
	        ))) == null ? void 0 : _a.arguments[0];
	      case 272 /* ImportDeclaration */:
	      case 278 /* ExportDeclaration */:
	        return tryCast(node.moduleSpecifier, isStringLiteralLike);
	      case 271 /* ImportEqualsDeclaration */:
	        return tryCast((_b = tryCast(node.moduleReference, isExternalModuleReference)) == null ? void 0 : _b.expression, isStringLiteralLike);
	      case 273 /* ImportClause */:
	      case 280 /* NamespaceExport */:
	        return tryCast(node.parent.moduleSpecifier, isStringLiteralLike);
	      case 274 /* NamespaceImport */:
	      case 281 /* ExportSpecifier */:
	        return tryCast(node.parent.parent.moduleSpecifier, isStringLiteralLike);
	      case 276 /* ImportSpecifier */:
	        return tryCast(node.parent.parent.parent.moduleSpecifier, isStringLiteralLike);
	      case 205 /* ImportType */:
	        return isLiteralImportTypeNode(node) ? node.argument.literal : void 0;
	      default:
	        Debug.assertNever(node);
	    }
	  }
	  function importFromModuleSpecifier(node) {
	    return tryGetImportFromModuleSpecifier(node) || Debug.failBadSyntaxKind(node.parent);
	  }
	  function tryGetImportFromModuleSpecifier(node) {
	    switch (node.parent.kind) {
	      case 272 /* ImportDeclaration */:
	      case 278 /* ExportDeclaration */:
	        return node.parent;
	      case 283 /* ExternalModuleReference */:
	        return node.parent.parent;
	      case 213 /* CallExpression */:
	        return isImportCall(node.parent) || isRequireCall(
	          node.parent,
	          /*requireStringLiteralLikeArgument*/
	          false
	        ) ? node.parent : void 0;
	      case 201 /* LiteralType */:
	        Debug.assert(isStringLiteral(node));
	        return tryCast(node.parent.parent, isImportTypeNode);
	      default:
	        return void 0;
	    }
	  }
	  function getExternalModuleName(node) {
	    switch (node.kind) {
	      case 272 /* ImportDeclaration */:
	      case 278 /* ExportDeclaration */:
	        return node.moduleSpecifier;
	      case 271 /* ImportEqualsDeclaration */:
	        return node.moduleReference.kind === 283 /* ExternalModuleReference */ ? node.moduleReference.expression : void 0;
	      case 205 /* ImportType */:
	        return isLiteralImportTypeNode(node) ? node.argument.literal : void 0;
	      case 213 /* CallExpression */:
	        return node.arguments[0];
	      case 267 /* ModuleDeclaration */:
	        return node.name.kind === 11 /* StringLiteral */ ? node.name : void 0;
	      default:
	        return Debug.assertNever(node);
	    }
	  }
	  function getNamespaceDeclarationNode(node) {
	    switch (node.kind) {
	      case 272 /* ImportDeclaration */:
	        return node.importClause && tryCast(node.importClause.namedBindings, isNamespaceImport);
	      case 271 /* ImportEqualsDeclaration */:
	        return node;
	      case 278 /* ExportDeclaration */:
	        return node.exportClause && tryCast(node.exportClause, isNamespaceExport);
	      default:
	        return Debug.assertNever(node);
	    }
	  }
	  function isDefaultImport(node) {
	    return node.kind === 272 /* ImportDeclaration */ && !!node.importClause && !!node.importClause.name;
	  }
	  function forEachImportClauseDeclaration(node, action) {
	    if (node.name) {
	      const result = action(node);
	      if (result)
	        return result;
	    }
	    if (node.namedBindings) {
	      const result = isNamespaceImport(node.namedBindings) ? action(node.namedBindings) : forEach(node.namedBindings.elements, action);
	      if (result)
	        return result;
	    }
	  }
	  function hasQuestionToken(node) {
	    if (node) {
	      switch (node.kind) {
	        case 169 /* Parameter */:
	        case 174 /* MethodDeclaration */:
	        case 173 /* MethodSignature */:
	        case 304 /* ShorthandPropertyAssignment */:
	        case 303 /* PropertyAssignment */:
	        case 172 /* PropertyDeclaration */:
	        case 171 /* PropertySignature */:
	          return node.questionToken !== void 0;
	      }
	    }
	    return false;
	  }
	  function isJSDocConstructSignature(node) {
	    const param = isJSDocFunctionType(node) ? firstOrUndefined(node.parameters) : void 0;
	    const name = tryCast(param && param.name, isIdentifier);
	    return !!name && name.escapedText === "new";
	  }
	  function isJSDocTypeAlias(node) {
	    return node.kind === 353 /* JSDocTypedefTag */ || node.kind === 345 /* JSDocCallbackTag */ || node.kind === 347 /* JSDocEnumTag */;
	  }
	  function isTypeAlias(node) {
	    return isJSDocTypeAlias(node) || isTypeAliasDeclaration(node);
	  }
	  function getSourceOfAssignment(node) {
	    return isExpressionStatement(node) && isBinaryExpression(node.expression) && node.expression.operatorToken.kind === 64 /* EqualsToken */ ? getRightMostAssignedExpression(node.expression) : void 0;
	  }
	  function getSourceOfDefaultedAssignment(node) {
	    return isExpressionStatement(node) && isBinaryExpression(node.expression) && getAssignmentDeclarationKind(node.expression) !== 0 /* None */ && isBinaryExpression(node.expression.right) && (node.expression.right.operatorToken.kind === 57 /* BarBarToken */ || node.expression.right.operatorToken.kind === 61 /* QuestionQuestionToken */) ? node.expression.right.right : void 0;
	  }
	  function getSingleInitializerOfVariableStatementOrPropertyDeclaration(node) {
	    switch (node.kind) {
	      case 243 /* VariableStatement */:
	        const v = getSingleVariableOfVariableStatement(node);
	        return v && v.initializer;
	      case 172 /* PropertyDeclaration */:
	        return node.initializer;
	      case 303 /* PropertyAssignment */:
	        return node.initializer;
	    }
	  }
	  function getSingleVariableOfVariableStatement(node) {
	    return isVariableStatement(node) ? firstOrUndefined(node.declarationList.declarations) : void 0;
	  }
	  function getNestedModuleDeclaration(node) {
	    return isModuleDeclaration(node) && node.body && node.body.kind === 267 /* ModuleDeclaration */ ? node.body : void 0;
	  }
	  function canHaveFlowNode(node) {
	    if (node.kind >= 243 /* FirstStatement */ && node.kind <= 259 /* LastStatement */) {
	      return true;
	    }
	    switch (node.kind) {
	      case 80 /* Identifier */:
	      case 110 /* ThisKeyword */:
	      case 108 /* SuperKeyword */:
	      case 166 /* QualifiedName */:
	      case 236 /* MetaProperty */:
	      case 212 /* ElementAccessExpression */:
	      case 211 /* PropertyAccessExpression */:
	      case 208 /* BindingElement */:
	      case 218 /* FunctionExpression */:
	      case 219 /* ArrowFunction */:
	      case 174 /* MethodDeclaration */:
	      case 177 /* GetAccessor */:
	      case 178 /* SetAccessor */:
	        return true;
	      default:
	        return false;
	    }
	  }
	  function canHaveJSDoc(node) {
	    switch (node.kind) {
	      case 219 /* ArrowFunction */:
	      case 226 /* BinaryExpression */:
	      case 241 /* Block */:
	      case 252 /* BreakStatement */:
	      case 179 /* CallSignature */:
	      case 296 /* CaseClause */:
	      case 263 /* ClassDeclaration */:
	      case 231 /* ClassExpression */:
	      case 175 /* ClassStaticBlockDeclaration */:
	      case 176 /* Constructor */:
	      case 185 /* ConstructorType */:
	      case 180 /* ConstructSignature */:
	      case 251 /* ContinueStatement */:
	      case 259 /* DebuggerStatement */:
	      case 246 /* DoStatement */:
	      case 212 /* ElementAccessExpression */:
	      case 242 /* EmptyStatement */:
	      case 1 /* EndOfFileToken */:
	      case 266 /* EnumDeclaration */:
	      case 306 /* EnumMember */:
	      case 277 /* ExportAssignment */:
	      case 278 /* ExportDeclaration */:
	      case 281 /* ExportSpecifier */:
	      case 244 /* ExpressionStatement */:
	      case 249 /* ForInStatement */:
	      case 250 /* ForOfStatement */:
	      case 248 /* ForStatement */:
	      case 262 /* FunctionDeclaration */:
	      case 218 /* FunctionExpression */:
	      case 184 /* FunctionType */:
	      case 177 /* GetAccessor */:
	      case 80 /* Identifier */:
	      case 245 /* IfStatement */:
	      case 272 /* ImportDeclaration */:
	      case 271 /* ImportEqualsDeclaration */:
	      case 181 /* IndexSignature */:
	      case 264 /* InterfaceDeclaration */:
	      case 324 /* JSDocFunctionType */:
	      case 330 /* JSDocSignature */:
	      case 256 /* LabeledStatement */:
	      case 174 /* MethodDeclaration */:
	      case 173 /* MethodSignature */:
	      case 267 /* ModuleDeclaration */:
	      case 202 /* NamedTupleMember */:
	      case 270 /* NamespaceExportDeclaration */:
	      case 210 /* ObjectLiteralExpression */:
	      case 169 /* Parameter */:
	      case 217 /* ParenthesizedExpression */:
	      case 211 /* PropertyAccessExpression */:
	      case 303 /* PropertyAssignment */:
	      case 172 /* PropertyDeclaration */:
	      case 171 /* PropertySignature */:
	      case 253 /* ReturnStatement */:
	      case 240 /* SemicolonClassElement */:
	      case 178 /* SetAccessor */:
	      case 304 /* ShorthandPropertyAssignment */:
	      case 305 /* SpreadAssignment */:
	      case 255 /* SwitchStatement */:
	      case 257 /* ThrowStatement */:
	      case 258 /* TryStatement */:
	      case 265 /* TypeAliasDeclaration */:
	      case 168 /* TypeParameter */:
	      case 260 /* VariableDeclaration */:
	      case 243 /* VariableStatement */:
	      case 247 /* WhileStatement */:
	      case 254 /* WithStatement */:
	        return true;
	      default:
	        return false;
	    }
	  }
	  function getJSDocCommentsAndTags(hostNode, noCache) {
	    let result;
	    if (isVariableLike(hostNode) && hasInitializer(hostNode) && hasJSDocNodes(hostNode.initializer)) {
	      result = addRange(result, filterOwnedJSDocTags(hostNode, hostNode.initializer.jsDoc));
	    }
	    let node = hostNode;
	    while (node && node.parent) {
	      if (hasJSDocNodes(node)) {
	        result = addRange(result, filterOwnedJSDocTags(hostNode, node.jsDoc));
	      }
	      if (node.kind === 169 /* Parameter */) {
	        result = addRange(result, (noCache ? getJSDocParameterTagsNoCache : getJSDocParameterTags)(node));
	        break;
	      }
	      if (node.kind === 168 /* TypeParameter */) {
	        result = addRange(result, (noCache ? getJSDocTypeParameterTagsNoCache : getJSDocTypeParameterTags)(node));
	        break;
	      }
	      node = getNextJSDocCommentLocation(node);
	    }
	    return result || emptyArray;
	  }
	  function filterOwnedJSDocTags(hostNode, comments) {
	    const lastJsDoc = last(comments);
	    return flatMap(comments, (jsDoc) => {
	      if (jsDoc === lastJsDoc) {
	        const ownedTags = filter(jsDoc.tags, (tag) => ownsJSDocTag(hostNode, tag));
	        return jsDoc.tags === ownedTags ? [jsDoc] : ownedTags;
	      } else {
	        return filter(jsDoc.tags, isJSDocOverloadTag);
	      }
	    });
	  }
	  function ownsJSDocTag(hostNode, tag) {
	    return !(isJSDocTypeTag(tag) || isJSDocSatisfiesTag(tag)) || !tag.parent || !isJSDoc(tag.parent) || !isParenthesizedExpression(tag.parent.parent) || tag.parent.parent === hostNode;
	  }
	  function getNextJSDocCommentLocation(node) {
	    const parent2 = node.parent;
	    if (parent2.kind === 303 /* PropertyAssignment */ || parent2.kind === 277 /* ExportAssignment */ || parent2.kind === 172 /* PropertyDeclaration */ || parent2.kind === 244 /* ExpressionStatement */ && node.kind === 211 /* PropertyAccessExpression */ || parent2.kind === 253 /* ReturnStatement */ || getNestedModuleDeclaration(parent2) || isAssignmentExpression(node)) {
	      return parent2;
	    } else if (parent2.parent && (getSingleVariableOfVariableStatement(parent2.parent) === node || isAssignmentExpression(parent2))) {
	      return parent2.parent;
	    } else if (parent2.parent && parent2.parent.parent && (getSingleVariableOfVariableStatement(parent2.parent.parent) || getSingleInitializerOfVariableStatementOrPropertyDeclaration(parent2.parent.parent) === node || getSourceOfDefaultedAssignment(parent2.parent.parent))) {
	      return parent2.parent.parent;
	    }
	  }
	  function getParameterSymbolFromJSDoc(node) {
	    if (node.symbol) {
	      return node.symbol;
	    }
	    if (!isIdentifier(node.name)) {
	      return void 0;
	    }
	    const name = node.name.escapedText;
	    const decl = getHostSignatureFromJSDoc(node);
	    if (!decl) {
	      return void 0;
	    }
	    const parameter = find(decl.parameters, (p) => p.name.kind === 80 /* Identifier */ && p.name.escapedText === name);
	    return parameter && parameter.symbol;
	  }
	  function getEffectiveContainerForJSDocTemplateTag(node) {
	    if (isJSDoc(node.parent) && node.parent.tags) {
	      const typeAlias = find(node.parent.tags, isJSDocTypeAlias);
	      if (typeAlias) {
	        return typeAlias;
	      }
	    }
	    return getHostSignatureFromJSDoc(node);
	  }
	  function getJSDocOverloadTags(node) {
	    return getAllJSDocTags(node, isJSDocOverloadTag);
	  }
	  function getHostSignatureFromJSDoc(node) {
	    const host = getEffectiveJSDocHost(node);
	    if (host) {
	      return isPropertySignature(host) && host.type && isFunctionLike(host.type) ? host.type : isFunctionLike(host) ? host : void 0;
	    }
	    return void 0;
	  }
	  function getEffectiveJSDocHost(node) {
	    const host = getJSDocHost(node);
	    if (host) {
	      return getSourceOfDefaultedAssignment(host) || getSourceOfAssignment(host) || getSingleInitializerOfVariableStatementOrPropertyDeclaration(host) || getSingleVariableOfVariableStatement(host) || getNestedModuleDeclaration(host) || host;
	    }
	  }
	  function getJSDocHost(node) {
	    const jsDoc = getJSDocRoot(node);
	    if (!jsDoc) {
	      return void 0;
	    }
	    const host = jsDoc.parent;
	    if (host && host.jsDoc && jsDoc === lastOrUndefined(host.jsDoc)) {
	      return host;
	    }
	  }
	  function getJSDocRoot(node) {
	    return findAncestor(node.parent, isJSDoc);
	  }
	  function getTypeParameterFromJsDoc(node) {
	    const name = node.name.escapedText;
	    const { typeParameters } = node.parent.parent.parent;
	    return typeParameters && find(typeParameters, (p) => p.name.escapedText === name);
	  }
	  function hasTypeArguments(node) {
	    return !!node.typeArguments;
	  }
	  function getAssignmentTarget(node) {
	    let parent2 = node.parent;
	    while (true) {
	      switch (parent2.kind) {
	        case 226 /* BinaryExpression */:
	          const binaryExpression = parent2;
	          const binaryOperator = binaryExpression.operatorToken.kind;
	          return isAssignmentOperator(binaryOperator) && binaryExpression.left === node ? binaryExpression : void 0;
	        case 224 /* PrefixUnaryExpression */:
	        case 225 /* PostfixUnaryExpression */:
	          const unaryExpression = parent2;
	          const unaryOperator = unaryExpression.operator;
	          return unaryOperator === 46 /* PlusPlusToken */ || unaryOperator === 47 /* MinusMinusToken */ ? unaryExpression : void 0;
	        case 249 /* ForInStatement */:
	        case 250 /* ForOfStatement */:
	          const forInOrOfStatement = parent2;
	          return forInOrOfStatement.initializer === node ? forInOrOfStatement : void 0;
	        case 217 /* ParenthesizedExpression */:
	        case 209 /* ArrayLiteralExpression */:
	        case 230 /* SpreadElement */:
	        case 235 /* NonNullExpression */:
	          node = parent2;
	          break;
	        case 305 /* SpreadAssignment */:
	          node = parent2.parent;
	          break;
	        case 304 /* ShorthandPropertyAssignment */:
	          if (parent2.name !== node) {
	            return void 0;
	          }
	          node = parent2.parent;
	          break;
	        case 303 /* PropertyAssignment */:
	          if (parent2.name === node) {
	            return void 0;
	          }
	          node = parent2.parent;
	          break;
	        default:
	          return void 0;
	      }
	      parent2 = node.parent;
	    }
	  }
	  function getAssignmentTargetKind(node) {
	    const target = getAssignmentTarget(node);
	    if (!target) {
	      return 0 /* None */;
	    }
	    switch (target.kind) {
	      case 226 /* BinaryExpression */:
	        const binaryOperator = target.operatorToken.kind;
	        return binaryOperator === 64 /* EqualsToken */ || isLogicalOrCoalescingAssignmentOperator(binaryOperator) ? 1 /* Definite */ : 2 /* Compound */;
	      case 224 /* PrefixUnaryExpression */:
	      case 225 /* PostfixUnaryExpression */:
	        return 2 /* Compound */;
	      case 249 /* ForInStatement */:
	      case 250 /* ForOfStatement */:
	        return 1 /* Definite */;
	    }
	  }
	  function isAssignmentTarget(node) {
	    return !!getAssignmentTarget(node);
	  }
	  function isCompoundLikeAssignment(assignment) {
	    const right = skipParentheses(assignment.right);
	    return right.kind === 226 /* BinaryExpression */ && isShiftOperatorOrHigher(right.operatorToken.kind);
	  }
	  function isInCompoundLikeAssignment(node) {
	    const target = getAssignmentTarget(node);
	    return !!target && isAssignmentExpression(
	      target,
	      /*excludeCompoundAssignment*/
	      true
	    ) && isCompoundLikeAssignment(target);
	  }
	  function isNodeWithPossibleHoistedDeclaration(node) {
	    switch (node.kind) {
	      case 241 /* Block */:
	      case 243 /* VariableStatement */:
	      case 254 /* WithStatement */:
	      case 245 /* IfStatement */:
	      case 255 /* SwitchStatement */:
	      case 269 /* CaseBlock */:
	      case 296 /* CaseClause */:
	      case 297 /* DefaultClause */:
	      case 256 /* LabeledStatement */:
	      case 248 /* ForStatement */:
	      case 249 /* ForInStatement */:
	      case 250 /* ForOfStatement */:
	      case 246 /* DoStatement */:
	      case 247 /* WhileStatement */:
	      case 258 /* TryStatement */:
	      case 299 /* CatchClause */:
	        return true;
	    }
	    return false;
	  }
	  function isValueSignatureDeclaration(node) {
	    return isFunctionExpression(node) || isArrowFunction(node) || isMethodOrAccessor(node) || isFunctionDeclaration(node) || isConstructorDeclaration(node);
	  }
	  function walkUp(node, kind) {
	    while (node && node.kind === kind) {
	      node = node.parent;
	    }
	    return node;
	  }
	  function walkUpParenthesizedTypes(node) {
	    return walkUp(node, 196 /* ParenthesizedType */);
	  }
	  function walkUpParenthesizedExpressions(node) {
	    return walkUp(node, 217 /* ParenthesizedExpression */);
	  }
	  function walkUpParenthesizedTypesAndGetParentAndChild(node) {
	    let child;
	    while (node && node.kind === 196 /* ParenthesizedType */) {
	      child = node;
	      node = node.parent;
	    }
	    return [child, node];
	  }
	  function skipTypeParentheses(node) {
	    while (isParenthesizedTypeNode(node))
	      node = node.type;
	    return node;
	  }
	  function skipParentheses(node, excludeJSDocTypeAssertions) {
	    const flags = excludeJSDocTypeAssertions ? 1 /* Parentheses */ | 16 /* ExcludeJSDocTypeAssertion */ : 1 /* Parentheses */;
	    return skipOuterExpressions(node, flags);
	  }
	  function isDeleteTarget(node) {
	    if (node.kind !== 211 /* PropertyAccessExpression */ && node.kind !== 212 /* ElementAccessExpression */) {
	      return false;
	    }
	    node = walkUpParenthesizedExpressions(node.parent);
	    return node && node.kind === 220 /* DeleteExpression */;
	  }
	  function isNodeDescendantOf(node, ancestor) {
	    while (node) {
	      if (node === ancestor)
	        return true;
	      node = node.parent;
	    }
	    return false;
	  }
	  function isDeclarationName(name) {
	    return !isSourceFile(name) && !isBindingPattern(name) && isDeclaration(name.parent) && name.parent.name === name;
	  }
	  function getDeclarationFromName(name) {
	    const parent2 = name.parent;
	    switch (name.kind) {
	      case 11 /* StringLiteral */:
	      case 15 /* NoSubstitutionTemplateLiteral */:
	      case 9 /* NumericLiteral */:
	        if (isComputedPropertyName(parent2))
	          return parent2.parent;
	      case 80 /* Identifier */:
	        if (isDeclaration(parent2)) {
	          return parent2.name === name ? parent2 : void 0;
	        } else if (isQualifiedName(parent2)) {
	          const tag = parent2.parent;
	          return isJSDocParameterTag(tag) && tag.name === parent2 ? tag : void 0;
	        } else {
	          const binExp = parent2.parent;
	          return isBinaryExpression(binExp) && getAssignmentDeclarationKind(binExp) !== 0 /* None */ && (binExp.left.symbol || binExp.symbol) && getNameOfDeclaration(binExp) === name ? binExp : void 0;
	        }
	      case 81 /* PrivateIdentifier */:
	        return isDeclaration(parent2) && parent2.name === name ? parent2 : void 0;
	      default:
	        return void 0;
	    }
	  }
	  function isLiteralComputedPropertyDeclarationName(node) {
	    return isStringOrNumericLiteralLike(node) && node.parent.kind === 167 /* ComputedPropertyName */ && isDeclaration(node.parent.parent);
	  }
	  function isIdentifierName(node) {
	    const parent2 = node.parent;
	    switch (parent2.kind) {
	      case 172 /* PropertyDeclaration */:
	      case 171 /* PropertySignature */:
	      case 174 /* MethodDeclaration */:
	      case 173 /* MethodSignature */:
	      case 177 /* GetAccessor */:
	      case 178 /* SetAccessor */:
	      case 306 /* EnumMember */:
	      case 303 /* PropertyAssignment */:
	      case 211 /* PropertyAccessExpression */:
	        return parent2.name === node;
	      case 166 /* QualifiedName */:
	        return parent2.right === node;
	      case 208 /* BindingElement */:
	      case 276 /* ImportSpecifier */:
	        return parent2.propertyName === node;
	      case 281 /* ExportSpecifier */:
	      case 291 /* JsxAttribute */:
	      case 285 /* JsxSelfClosingElement */:
	      case 286 /* JsxOpeningElement */:
	      case 287 /* JsxClosingElement */:
	        return true;
	    }
	    return false;
	  }
	  function isAliasSymbolDeclaration(node) {
	    if (node.kind === 271 /* ImportEqualsDeclaration */ || node.kind === 270 /* NamespaceExportDeclaration */ || node.kind === 273 /* ImportClause */ && !!node.name || node.kind === 274 /* NamespaceImport */ || node.kind === 280 /* NamespaceExport */ || node.kind === 276 /* ImportSpecifier */ || node.kind === 281 /* ExportSpecifier */ || node.kind === 277 /* ExportAssignment */ && exportAssignmentIsAlias(node)) {
	      return true;
	    }
	    return isInJSFile(node) && (isBinaryExpression(node) && getAssignmentDeclarationKind(node) === 2 /* ModuleExports */ && exportAssignmentIsAlias(node) || isPropertyAccessExpression(node) && isBinaryExpression(node.parent) && node.parent.left === node && node.parent.operatorToken.kind === 64 /* EqualsToken */ && isAliasableExpression(node.parent.right));
	  }
	  function getAliasDeclarationFromName(node) {
	    switch (node.parent.kind) {
	      case 273 /* ImportClause */:
	      case 276 /* ImportSpecifier */:
	      case 274 /* NamespaceImport */:
	      case 281 /* ExportSpecifier */:
	      case 277 /* ExportAssignment */:
	      case 271 /* ImportEqualsDeclaration */:
	      case 280 /* NamespaceExport */:
	        return node.parent;
	      case 166 /* QualifiedName */:
	        do {
	          node = node.parent;
	        } while (node.parent.kind === 166 /* QualifiedName */);
	        return getAliasDeclarationFromName(node);
	    }
	  }
	  function isAliasableExpression(e) {
	    return isEntityNameExpression(e) || isClassExpression(e);
	  }
	  function exportAssignmentIsAlias(node) {
	    const e = getExportAssignmentExpression(node);
	    return isAliasableExpression(e);
	  }
	  function getExportAssignmentExpression(node) {
	    return isExportAssignment(node) ? node.expression : node.right;
	  }
	  function getPropertyAssignmentAliasLikeExpression(node) {
	    return node.kind === 304 /* ShorthandPropertyAssignment */ ? node.name : node.kind === 303 /* PropertyAssignment */ ? node.initializer : node.parent.right;
	  }
	  function getEffectiveBaseTypeNode(node) {
	    const baseType = getClassExtendsHeritageElement(node);
	    if (baseType && isInJSFile(node)) {
	      const tag = getJSDocAugmentsTag(node);
	      if (tag) {
	        return tag.class;
	      }
	    }
	    return baseType;
	  }
	  function getClassExtendsHeritageElement(node) {
	    const heritageClause = getHeritageClause(node.heritageClauses, 96 /* ExtendsKeyword */);
	    return heritageClause && heritageClause.types.length > 0 ? heritageClause.types[0] : void 0;
	  }
	  function getEffectiveImplementsTypeNodes(node) {
	    if (isInJSFile(node)) {
	      return getJSDocImplementsTags(node).map((n) => n.class);
	    } else {
	      const heritageClause = getHeritageClause(node.heritageClauses, 119 /* ImplementsKeyword */);
	      return heritageClause == null ? void 0 : heritageClause.types;
	    }
	  }
	  function getAllSuperTypeNodes(node) {
	    return isInterfaceDeclaration(node) ? getInterfaceBaseTypeNodes(node) || emptyArray : isClassLike(node) ? concatenate(singleElementArray(getEffectiveBaseTypeNode(node)), getEffectiveImplementsTypeNodes(node)) || emptyArray : emptyArray;
	  }
	  function getInterfaceBaseTypeNodes(node) {
	    const heritageClause = getHeritageClause(node.heritageClauses, 96 /* ExtendsKeyword */);
	    return heritageClause ? heritageClause.types : void 0;
	  }
	  function getHeritageClause(clauses, kind) {
	    if (clauses) {
	      for (const clause of clauses) {
	        if (clause.token === kind) {
	          return clause;
	        }
	      }
	    }
	    return void 0;
	  }
	  function getAncestor(node, kind) {
	    while (node) {
	      if (node.kind === kind) {
	        return node;
	      }
	      node = node.parent;
	    }
	    return void 0;
	  }
	  function isKeyword(token) {
	    return 83 /* FirstKeyword */ <= token && token <= 165 /* LastKeyword */;
	  }
	  function isPunctuation(token) {
	    return 19 /* FirstPunctuation */ <= token && token <= 79 /* LastPunctuation */;
	  }
	  function isKeywordOrPunctuation(token) {
	    return isKeyword(token) || isPunctuation(token);
	  }
	  function isContextualKeyword(token) {
	    return 128 /* FirstContextualKeyword */ <= token && token <= 165 /* LastContextualKeyword */;
	  }
	  function isNonContextualKeyword(token) {
	    return isKeyword(token) && !isContextualKeyword(token);
	  }
	  function isFutureReservedKeyword(token) {
	    return 119 /* FirstFutureReservedWord */ <= token && token <= 127 /* LastFutureReservedWord */;
	  }
	  function isStringANonContextualKeyword(name) {
	    const token = stringToToken(name);
	    return token !== void 0 && isNonContextualKeyword(token);
	  }
	  function isStringAKeyword(name) {
	    const token = stringToToken(name);
	    return token !== void 0 && isKeyword(token);
	  }
	  function isIdentifierANonContextualKeyword(node) {
	    const originalKeywordKind = identifierToKeywordKind(node);
	    return !!originalKeywordKind && !isContextualKeyword(originalKeywordKind);
	  }
	  function isTrivia(token) {
	    return 2 /* FirstTriviaToken */ <= token && token <= 7 /* LastTriviaToken */;
	  }
	  function getFunctionFlags(node) {
	    if (!node) {
	      return 4 /* Invalid */;
	    }
	    let flags = 0 /* Normal */;
	    switch (node.kind) {
	      case 262 /* FunctionDeclaration */:
	      case 218 /* FunctionExpression */:
	      case 174 /* MethodDeclaration */:
	        if (node.asteriskToken) {
	          flags |= 1 /* Generator */;
	        }
	      case 219 /* ArrowFunction */:
	        if (hasSyntacticModifier(node, 1024 /* Async */)) {
	          flags |= 2 /* Async */;
	        }
	        break;
	    }
	    if (!node.body) {
	      flags |= 4 /* Invalid */;
	    }
	    return flags;
	  }
	  function isAsyncFunction(node) {
	    switch (node.kind) {
	      case 262 /* FunctionDeclaration */:
	      case 218 /* FunctionExpression */:
	      case 219 /* ArrowFunction */:
	      case 174 /* MethodDeclaration */:
	        return node.body !== void 0 && node.asteriskToken === void 0 && hasSyntacticModifier(node, 1024 /* Async */);
	    }
	    return false;
	  }
	  function isStringOrNumericLiteralLike(node) {
	    return isStringLiteralLike(node) || isNumericLiteral(node);
	  }
	  function isSignedNumericLiteral(node) {
	    return isPrefixUnaryExpression(node) && (node.operator === 40 /* PlusToken */ || node.operator === 41 /* MinusToken */) && isNumericLiteral(node.operand);
	  }
	  function hasDynamicName(declaration) {
	    const name = getNameOfDeclaration(declaration);
	    return !!name && isDynamicName(name);
	  }
	  function isDynamicName(name) {
	    if (!(name.kind === 167 /* ComputedPropertyName */ || name.kind === 212 /* ElementAccessExpression */)) {
	      return false;
	    }
	    const expr = isElementAccessExpression(name) ? skipParentheses(name.argumentExpression) : name.expression;
	    return !isStringOrNumericLiteralLike(expr) && !isSignedNumericLiteral(expr);
	  }
	  function getPropertyNameForPropertyNameNode(name) {
	    switch (name.kind) {
	      case 80 /* Identifier */:
	      case 81 /* PrivateIdentifier */:
	        return name.escapedText;
	      case 11 /* StringLiteral */:
	      case 15 /* NoSubstitutionTemplateLiteral */:
	      case 9 /* NumericLiteral */:
	        return escapeLeadingUnderscores(name.text);
	      case 167 /* ComputedPropertyName */:
	        const nameExpression = name.expression;
	        if (isStringOrNumericLiteralLike(nameExpression)) {
	          return escapeLeadingUnderscores(nameExpression.text);
	        } else if (isSignedNumericLiteral(nameExpression)) {
	          if (nameExpression.operator === 41 /* MinusToken */) {
	            return tokenToString(nameExpression.operator) + nameExpression.operand.text;
	          }
	          return nameExpression.operand.text;
	        }
	        return void 0;
	      case 295 /* JsxNamespacedName */:
	        return getEscapedTextOfJsxNamespacedName(name);
	      default:
	        return Debug.assertNever(name);
	    }
	  }
	  function isPropertyNameLiteral(node) {
	    switch (node.kind) {
	      case 80 /* Identifier */:
	      case 11 /* StringLiteral */:
	      case 15 /* NoSubstitutionTemplateLiteral */:
	      case 9 /* NumericLiteral */:
	        return true;
	      default:
	        return false;
	    }
	  }
	  function getTextOfIdentifierOrLiteral(node) {
	    return isMemberName(node) ? idText(node) : isJsxNamespacedName(node) ? getTextOfJsxNamespacedName(node) : node.text;
	  }
	  function getEscapedTextOfIdentifierOrLiteral(node) {
	    return isMemberName(node) ? node.escapedText : isJsxNamespacedName(node) ? getEscapedTextOfJsxNamespacedName(node) : escapeLeadingUnderscores(node.text);
	  }
	  function getPropertyNameForUniqueESSymbol(symbol) {
	    return `__@${getSymbolId(symbol)}@${symbol.escapedName}`;
	  }
	  function getSymbolNameForPrivateIdentifier(containingClassSymbol, description3) {
	    return `__#${getSymbolId(containingClassSymbol)}@${description3}`;
	  }
	  function isKnownSymbol(symbol) {
	    return startsWith(symbol.escapedName, "__@");
	  }
	  function isPrivateIdentifierSymbol(symbol) {
	    return startsWith(symbol.escapedName, "__#");
	  }
	  function isESSymbolIdentifier(node) {
	    return node.kind === 80 /* Identifier */ && node.escapedText === "Symbol";
	  }
	  function isProtoSetter(node) {
	    return isIdentifier(node) ? idText(node) === "__proto__" : isStringLiteral(node) && node.text === "__proto__";
	  }
	  function isAnonymousFunctionDefinition(node, cb) {
	    node = skipOuterExpressions(node);
	    switch (node.kind) {
	      case 231 /* ClassExpression */:
	        if (classHasDeclaredOrExplicitlyAssignedName(node)) {
	          return false;
	        }
	        break;
	      case 218 /* FunctionExpression */:
	        if (node.name) {
	          return false;
	        }
	        break;
	      case 219 /* ArrowFunction */:
	        break;
	      default:
	        return false;
	    }
	    return typeof cb === "function" ? cb(node) : true;
	  }
	  function isNamedEvaluationSource(node) {
	    switch (node.kind) {
	      case 303 /* PropertyAssignment */:
	        return !isProtoSetter(node.name);
	      case 304 /* ShorthandPropertyAssignment */:
	        return !!node.objectAssignmentInitializer;
	      case 260 /* VariableDeclaration */:
	        return isIdentifier(node.name) && !!node.initializer;
	      case 169 /* Parameter */:
	        return isIdentifier(node.name) && !!node.initializer && !node.dotDotDotToken;
	      case 208 /* BindingElement */:
	        return isIdentifier(node.name) && !!node.initializer && !node.dotDotDotToken;
	      case 172 /* PropertyDeclaration */:
	        return !!node.initializer;
	      case 226 /* BinaryExpression */:
	        switch (node.operatorToken.kind) {
	          case 64 /* EqualsToken */:
	          case 77 /* AmpersandAmpersandEqualsToken */:
	          case 76 /* BarBarEqualsToken */:
	          case 78 /* QuestionQuestionEqualsToken */:
	            return isIdentifier(node.left);
	        }
	        break;
	      case 277 /* ExportAssignment */:
	        return true;
	    }
	    return false;
	  }
	  function isNamedEvaluation(node, cb) {
	    if (!isNamedEvaluationSource(node))
	      return false;
	    switch (node.kind) {
	      case 303 /* PropertyAssignment */:
	        return isAnonymousFunctionDefinition(node.initializer, cb);
	      case 304 /* ShorthandPropertyAssignment */:
	        return isAnonymousFunctionDefinition(node.objectAssignmentInitializer, cb);
	      case 260 /* VariableDeclaration */:
	      case 169 /* Parameter */:
	      case 208 /* BindingElement */:
	      case 172 /* PropertyDeclaration */:
	        return isAnonymousFunctionDefinition(node.initializer, cb);
	      case 226 /* BinaryExpression */:
	        return isAnonymousFunctionDefinition(node.right, cb);
	      case 277 /* ExportAssignment */:
	        return isAnonymousFunctionDefinition(node.expression, cb);
	    }
	  }
	  function isPushOrUnshiftIdentifier(node) {
	    return node.escapedText === "push" || node.escapedText === "unshift";
	  }
	  function isParameterDeclaration(node) {
	    const root = getRootDeclaration(node);
	    return root.kind === 169 /* Parameter */;
	  }
	  function getRootDeclaration(node) {
	    while (node.kind === 208 /* BindingElement */) {
	      node = node.parent.parent;
	    }
	    return node;
	  }
	  function nodeStartsNewLexicalEnvironment(node) {
	    const kind = node.kind;
	    return kind === 176 /* Constructor */ || kind === 218 /* FunctionExpression */ || kind === 262 /* FunctionDeclaration */ || kind === 219 /* ArrowFunction */ || kind === 174 /* MethodDeclaration */ || kind === 177 /* GetAccessor */ || kind === 178 /* SetAccessor */ || kind === 267 /* ModuleDeclaration */ || kind === 312 /* SourceFile */;
	  }
	  function nodeIsSynthesized(range) {
	    return positionIsSynthesized(range.pos) || positionIsSynthesized(range.end);
	  }
	  function getOriginalSourceFile(sourceFile) {
	    return getParseTreeNode(sourceFile, isSourceFile) || sourceFile;
	  }
	  function getExpressionAssociativity(expression) {
	    const operator = getOperator(expression);
	    const hasArguments = expression.kind === 214 /* NewExpression */ && expression.arguments !== void 0;
	    return getOperatorAssociativity(expression.kind, operator, hasArguments);
	  }
	  function getOperatorAssociativity(kind, operator, hasArguments) {
	    switch (kind) {
	      case 214 /* NewExpression */:
	        return hasArguments ? 0 /* Left */ : 1 /* Right */;
	      case 224 /* PrefixUnaryExpression */:
	      case 221 /* TypeOfExpression */:
	      case 222 /* VoidExpression */:
	      case 220 /* DeleteExpression */:
	      case 223 /* AwaitExpression */:
	      case 227 /* ConditionalExpression */:
	      case 229 /* YieldExpression */:
	        return 1 /* Right */;
	      case 226 /* BinaryExpression */:
	        switch (operator) {
	          case 43 /* AsteriskAsteriskToken */:
	          case 64 /* EqualsToken */:
	          case 65 /* PlusEqualsToken */:
	          case 66 /* MinusEqualsToken */:
	          case 68 /* AsteriskAsteriskEqualsToken */:
	          case 67 /* AsteriskEqualsToken */:
	          case 69 /* SlashEqualsToken */:
	          case 70 /* PercentEqualsToken */:
	          case 71 /* LessThanLessThanEqualsToken */:
	          case 72 /* GreaterThanGreaterThanEqualsToken */:
	          case 73 /* GreaterThanGreaterThanGreaterThanEqualsToken */:
	          case 74 /* AmpersandEqualsToken */:
	          case 79 /* CaretEqualsToken */:
	          case 75 /* BarEqualsToken */:
	          case 76 /* BarBarEqualsToken */:
	          case 77 /* AmpersandAmpersandEqualsToken */:
	          case 78 /* QuestionQuestionEqualsToken */:
	            return 1 /* Right */;
	        }
	    }
	    return 0 /* Left */;
	  }
	  function getExpressionPrecedence(expression) {
	    const operator = getOperator(expression);
	    const hasArguments = expression.kind === 214 /* NewExpression */ && expression.arguments !== void 0;
	    return getOperatorPrecedence(expression.kind, operator, hasArguments);
	  }
	  function getOperator(expression) {
	    if (expression.kind === 226 /* BinaryExpression */) {
	      return expression.operatorToken.kind;
	    } else if (expression.kind === 224 /* PrefixUnaryExpression */ || expression.kind === 225 /* PostfixUnaryExpression */) {
	      return expression.operator;
	    } else {
	      return expression.kind;
	    }
	  }
	  function getOperatorPrecedence(nodeKind, operatorKind, hasArguments) {
	    switch (nodeKind) {
	      case 361 /* CommaListExpression */:
	        return 0 /* Comma */;
	      case 230 /* SpreadElement */:
	        return 1 /* Spread */;
	      case 229 /* YieldExpression */:
	        return 2 /* Yield */;
	      case 227 /* ConditionalExpression */:
	        return 4 /* Conditional */;
	      case 226 /* BinaryExpression */:
	        switch (operatorKind) {
	          case 28 /* CommaToken */:
	            return 0 /* Comma */;
	          case 64 /* EqualsToken */:
	          case 65 /* PlusEqualsToken */:
	          case 66 /* MinusEqualsToken */:
	          case 68 /* AsteriskAsteriskEqualsToken */:
	          case 67 /* AsteriskEqualsToken */:
	          case 69 /* SlashEqualsToken */:
	          case 70 /* PercentEqualsToken */:
	          case 71 /* LessThanLessThanEqualsToken */:
	          case 72 /* GreaterThanGreaterThanEqualsToken */:
	          case 73 /* GreaterThanGreaterThanGreaterThanEqualsToken */:
	          case 74 /* AmpersandEqualsToken */:
	          case 79 /* CaretEqualsToken */:
	          case 75 /* BarEqualsToken */:
	          case 76 /* BarBarEqualsToken */:
	          case 77 /* AmpersandAmpersandEqualsToken */:
	          case 78 /* QuestionQuestionEqualsToken */:
	            return 3 /* Assignment */;
	          default:
	            return getBinaryOperatorPrecedence(operatorKind);
	        }
	      case 216 /* TypeAssertionExpression */:
	      case 235 /* NonNullExpression */:
	      case 224 /* PrefixUnaryExpression */:
	      case 221 /* TypeOfExpression */:
	      case 222 /* VoidExpression */:
	      case 220 /* DeleteExpression */:
	      case 223 /* AwaitExpression */:
	        return 16 /* Unary */;
	      case 225 /* PostfixUnaryExpression */:
	        return 17 /* Update */;
	      case 213 /* CallExpression */:
	        return 18 /* LeftHandSide */;
	      case 214 /* NewExpression */:
	        return hasArguments ? 19 /* Member */ : 18 /* LeftHandSide */;
	      case 215 /* TaggedTemplateExpression */:
	      case 211 /* PropertyAccessExpression */:
	      case 212 /* ElementAccessExpression */:
	      case 236 /* MetaProperty */:
	        return 19 /* Member */;
	      case 234 /* AsExpression */:
	      case 238 /* SatisfiesExpression */:
	        return 11 /* Relational */;
	      case 110 /* ThisKeyword */:
	      case 108 /* SuperKeyword */:
	      case 80 /* Identifier */:
	      case 81 /* PrivateIdentifier */:
	      case 106 /* NullKeyword */:
	      case 112 /* TrueKeyword */:
	      case 97 /* FalseKeyword */:
	      case 9 /* NumericLiteral */:
	      case 10 /* BigIntLiteral */:
	      case 11 /* StringLiteral */:
	      case 209 /* ArrayLiteralExpression */:
	      case 210 /* ObjectLiteralExpression */:
	      case 218 /* FunctionExpression */:
	      case 219 /* ArrowFunction */:
	      case 231 /* ClassExpression */:
	      case 14 /* RegularExpressionLiteral */:
	      case 15 /* NoSubstitutionTemplateLiteral */:
	      case 228 /* TemplateExpression */:
	      case 217 /* ParenthesizedExpression */:
	      case 232 /* OmittedExpression */:
	      case 284 /* JsxElement */:
	      case 285 /* JsxSelfClosingElement */:
	      case 288 /* JsxFragment */:
	        return 20 /* Primary */;
	      default:
	        return -1 /* Invalid */;
	    }
	  }
	  function getBinaryOperatorPrecedence(kind) {
	    switch (kind) {
	      case 61 /* QuestionQuestionToken */:
	        return 4 /* Coalesce */;
	      case 57 /* BarBarToken */:
	        return 5 /* LogicalOR */;
	      case 56 /* AmpersandAmpersandToken */:
	        return 6 /* LogicalAND */;
	      case 52 /* BarToken */:
	        return 7 /* BitwiseOR */;
	      case 53 /* CaretToken */:
	        return 8 /* BitwiseXOR */;
	      case 51 /* AmpersandToken */:
	        return 9 /* BitwiseAND */;
	      case 35 /* EqualsEqualsToken */:
	      case 36 /* ExclamationEqualsToken */:
	      case 37 /* EqualsEqualsEqualsToken */:
	      case 38 /* ExclamationEqualsEqualsToken */:
	        return 10 /* Equality */;
	      case 30 /* LessThanToken */:
	      case 32 /* GreaterThanToken */:
	      case 33 /* LessThanEqualsToken */:
	      case 34 /* GreaterThanEqualsToken */:
	      case 104 /* InstanceOfKeyword */:
	      case 103 /* InKeyword */:
	      case 130 /* AsKeyword */:
	      case 152 /* SatisfiesKeyword */:
	        return 11 /* Relational */;
	      case 48 /* LessThanLessThanToken */:
	      case 49 /* GreaterThanGreaterThanToken */:
	      case 50 /* GreaterThanGreaterThanGreaterThanToken */:
	        return 12 /* Shift */;
	      case 40 /* PlusToken */:
	      case 41 /* MinusToken */:
	        return 13 /* Additive */;
	      case 42 /* AsteriskToken */:
	      case 44 /* SlashToken */:
	      case 45 /* PercentToken */:
	        return 14 /* Multiplicative */;
	      case 43 /* AsteriskAsteriskToken */:
	        return 15 /* Exponentiation */;
	    }
	    return -1;
	  }
	  function getSemanticJsxChildren(children) {
	    return filter(children, (i) => {
	      switch (i.kind) {
	        case 294 /* JsxExpression */:
	          return !!i.expression;
	        case 12 /* JsxText */:
	          return !i.containsOnlyTriviaWhiteSpaces;
	        default:
	          return true;
	      }
	    });
	  }
	  function createDiagnosticCollection() {
	    let nonFileDiagnostics = [];
	    const filesWithDiagnostics = [];
	    const fileDiagnostics = /* @__PURE__ */ new Map();
	    let hasReadNonFileDiagnostics = false;
	    return {
	      add,
	      lookup,
	      getGlobalDiagnostics,
	      getDiagnostics: getDiagnostics2
	    };
	    function lookup(diagnostic) {
	      let diagnostics;
	      if (diagnostic.file) {
	        diagnostics = fileDiagnostics.get(diagnostic.file.fileName);
	      } else {
	        diagnostics = nonFileDiagnostics;
	      }
	      if (!diagnostics) {
	        return void 0;
	      }
	      const result = binarySearch(diagnostics, diagnostic, identity, compareDiagnosticsSkipRelatedInformation);
	      if (result >= 0) {
	        return diagnostics[result];
	      }
	      return void 0;
	    }
	    function add(diagnostic) {
	      let diagnostics;
	      if (diagnostic.file) {
	        diagnostics = fileDiagnostics.get(diagnostic.file.fileName);
	        if (!diagnostics) {
	          diagnostics = [];
	          fileDiagnostics.set(diagnostic.file.fileName, diagnostics);
	          insertSorted(filesWithDiagnostics, diagnostic.file.fileName, compareStringsCaseSensitive);
	        }
	      } else {
	        if (hasReadNonFileDiagnostics) {
	          hasReadNonFileDiagnostics = false;
	          nonFileDiagnostics = nonFileDiagnostics.slice();
	        }
	        diagnostics = nonFileDiagnostics;
	      }
	      insertSorted(diagnostics, diagnostic, compareDiagnosticsSkipRelatedInformation);
	    }
	    function getGlobalDiagnostics() {
	      hasReadNonFileDiagnostics = true;
	      return nonFileDiagnostics;
	    }
	    function getDiagnostics2(fileName) {
	      if (fileName) {
	        return fileDiagnostics.get(fileName) || [];
	      }
	      const fileDiags = flatMapToMutable(filesWithDiagnostics, (f) => fileDiagnostics.get(f));
	      if (!nonFileDiagnostics.length) {
	        return fileDiags;
	      }
	      fileDiags.unshift(...nonFileDiagnostics);
	      return fileDiags;
	    }
	  }
	  function escapeTemplateSubstitution(str) {
	    return str.replace(templateSubstitutionRegExp, "\\${");
	  }
	  function containsInvalidEscapeFlag(node) {
	    return !!((node.templateFlags || 0) & 2048 /* ContainsInvalidEscape */);
	  }
	  function hasInvalidEscape(template) {
	    return template && !!(isNoSubstitutionTemplateLiteral(template) ? containsInvalidEscapeFlag(template) : containsInvalidEscapeFlag(template.head) || some(template.templateSpans, (span) => containsInvalidEscapeFlag(span.literal)));
	  }
	  function encodeUtf16EscapeSequence(charCode) {
	    const hexCharCode = charCode.toString(16).toUpperCase();
	    const paddedHexCode = ("0000" + hexCharCode).slice(-4);
	    return "\\u" + paddedHexCode;
	  }
	  function getReplacement(c, offset, input) {
	    if (c.charCodeAt(0) === 0 /* nullCharacter */) {
	      const lookAhead = input.charCodeAt(offset + c.length);
	      if (lookAhead >= 48 /* _0 */ && lookAhead <= 57 /* _9 */) {
	        return "\\x00";
	      }
	      return "\\0";
	    }
	    return escapedCharsMap.get(c) || encodeUtf16EscapeSequence(c.charCodeAt(0));
	  }
	  function escapeString(s, quoteChar) {
	    const escapedCharsRegExp = quoteChar === 96 /* backtick */ ? backtickQuoteEscapedCharsRegExp : quoteChar === 39 /* singleQuote */ ? singleQuoteEscapedCharsRegExp : doubleQuoteEscapedCharsRegExp;
	    return s.replace(escapedCharsRegExp, getReplacement);
	  }
	  function escapeNonAsciiString(s, quoteChar) {
	    s = escapeString(s, quoteChar);
	    return nonAsciiCharacters.test(s) ? s.replace(nonAsciiCharacters, (c) => encodeUtf16EscapeSequence(c.charCodeAt(0))) : s;
	  }
	  function encodeJsxCharacterEntity(charCode) {
	    const hexCharCode = charCode.toString(16).toUpperCase();
	    return "&#x" + hexCharCode + ";";
	  }
	  function getJsxAttributeStringReplacement(c) {
	    if (c.charCodeAt(0) === 0 /* nullCharacter */) {
	      return "&#0;";
	    }
	    return jsxEscapedCharsMap.get(c) || encodeJsxCharacterEntity(c.charCodeAt(0));
	  }
	  function escapeJsxAttributeString(s, quoteChar) {
	    const escapedCharsRegExp = quoteChar === 39 /* singleQuote */ ? jsxSingleQuoteEscapedCharsRegExp : jsxDoubleQuoteEscapedCharsRegExp;
	    return s.replace(escapedCharsRegExp, getJsxAttributeStringReplacement);
	  }
	  function stripQuotes(name) {
	    const length2 = name.length;
	    if (length2 >= 2 && name.charCodeAt(0) === name.charCodeAt(length2 - 1) && isQuoteOrBacktick(name.charCodeAt(0))) {
	      return name.substring(1, length2 - 1);
	    }
	    return name;
	  }
	  function isQuoteOrBacktick(charCode) {
	    return charCode === 39 /* singleQuote */ || charCode === 34 /* doubleQuote */ || charCode === 96 /* backtick */;
	  }
	  function isIntrinsicJsxName(name) {
	    const ch = name.charCodeAt(0);
	    return ch >= 97 /* a */ && ch <= 122 /* z */ || name.includes("-");
	  }
	  function getIndentString(level) {
	    const singleLevel = indentStrings[1];
	    for (let current = indentStrings.length; current <= level; current++) {
	      indentStrings.push(indentStrings[current - 1] + singleLevel);
	    }
	    return indentStrings[level];
	  }
	  function getIndentSize() {
	    return indentStrings[1].length;
	  }
	  function createTextWriter(newLine) {
	    var output;
	    var indent3;
	    var lineStart;
	    var lineCount;
	    var linePos;
	    var hasTrailingComment = false;
	    function updateLineCountAndPosFor(s) {
	      const lineStartsOfS = computeLineStarts(s);
	      if (lineStartsOfS.length > 1) {
	        lineCount = lineCount + lineStartsOfS.length - 1;
	        linePos = output.length - s.length + last(lineStartsOfS);
	        lineStart = linePos - output.length === 0;
	      } else {
	        lineStart = false;
	      }
	    }
	    function writeText(s) {
	      if (s && s.length) {
	        if (lineStart) {
	          s = getIndentString(indent3) + s;
	          lineStart = false;
	        }
	        output += s;
	        updateLineCountAndPosFor(s);
	      }
	    }
	    function write(s) {
	      if (s)
	        hasTrailingComment = false;
	      writeText(s);
	    }
	    function writeComment(s) {
	      if (s)
	        hasTrailingComment = true;
	      writeText(s);
	    }
	    function reset2() {
	      output = "";
	      indent3 = 0;
	      lineStart = true;
	      lineCount = 0;
	      linePos = 0;
	      hasTrailingComment = false;
	    }
	    function rawWrite(s) {
	      if (s !== void 0) {
	        output += s;
	        updateLineCountAndPosFor(s);
	        hasTrailingComment = false;
	      }
	    }
	    function writeLiteral(s) {
	      if (s && s.length) {
	        write(s);
	      }
	    }
	    function writeLine(force) {
	      if (!lineStart || force) {
	        output += newLine;
	        lineCount++;
	        linePos = output.length;
	        lineStart = true;
	        hasTrailingComment = false;
	      }
	    }
	    function getTextPosWithWriteLine() {
	      return lineStart ? output.length : output.length + newLine.length;
	    }
	    reset2();
	    return {
	      write,
	      rawWrite,
	      writeLiteral,
	      writeLine,
	      increaseIndent: () => {
	        indent3++;
	      },
	      decreaseIndent: () => {
	        indent3--;
	      },
	      getIndent: () => indent3,
	      getTextPos: () => output.length,
	      getLine: () => lineCount,
	      getColumn: () => lineStart ? indent3 * getIndentSize() : output.length - linePos,
	      getText: () => output,
	      isAtStartOfLine: () => lineStart,
	      hasTrailingComment: () => hasTrailingComment,
	      hasTrailingWhitespace: () => !!output.length && isWhiteSpaceLike(output.charCodeAt(output.length - 1)),
	      clear: reset2,
	      writeKeyword: write,
	      writeOperator: write,
	      writeParameter: write,
	      writeProperty: write,
	      writePunctuation: write,
	      writeSpace: write,
	      writeStringLiteral: write,
	      writeSymbol: (s, _) => write(s),
	      writeTrailingSemicolon: write,
	      writeComment,
	      getTextPosWithWriteLine
	    };
	  }
	  function getTrailingSemicolonDeferringWriter(writer) {
	    let pendingTrailingSemicolon = false;
	    function commitPendingTrailingSemicolon() {
	      if (pendingTrailingSemicolon) {
	        writer.writeTrailingSemicolon(";");
	        pendingTrailingSemicolon = false;
	      }
	    }
	    return {
	      ...writer,
	      writeTrailingSemicolon() {
	        pendingTrailingSemicolon = true;
	      },
	      writeLiteral(s) {
	        commitPendingTrailingSemicolon();
	        writer.writeLiteral(s);
	      },
	      writeStringLiteral(s) {
	        commitPendingTrailingSemicolon();
	        writer.writeStringLiteral(s);
	      },
	      writeSymbol(s, sym) {
	        commitPendingTrailingSemicolon();
	        writer.writeSymbol(s, sym);
	      },
	      writePunctuation(s) {
	        commitPendingTrailingSemicolon();
	        writer.writePunctuation(s);
	      },
	      writeKeyword(s) {
	        commitPendingTrailingSemicolon();
	        writer.writeKeyword(s);
	      },
	      writeOperator(s) {
	        commitPendingTrailingSemicolon();
	        writer.writeOperator(s);
	      },
	      writeParameter(s) {
	        commitPendingTrailingSemicolon();
	        writer.writeParameter(s);
	      },
	      writeSpace(s) {
	        commitPendingTrailingSemicolon();
	        writer.writeSpace(s);
	      },
	      writeProperty(s) {
	        commitPendingTrailingSemicolon();
	        writer.writeProperty(s);
	      },
	      writeComment(s) {
	        commitPendingTrailingSemicolon();
	        writer.writeComment(s);
	      },
	      writeLine() {
	        commitPendingTrailingSemicolon();
	        writer.writeLine();
	      },
	      increaseIndent() {
	        commitPendingTrailingSemicolon();
	        writer.increaseIndent();
	      },
	      decreaseIndent() {
	        commitPendingTrailingSemicolon();
	        writer.decreaseIndent();
	      }
	    };
	  }
	  function hostUsesCaseSensitiveFileNames(host) {
	    return host.useCaseSensitiveFileNames ? host.useCaseSensitiveFileNames() : false;
	  }
	  function hostGetCanonicalFileName(host) {
	    return createGetCanonicalFileName(hostUsesCaseSensitiveFileNames(host));
	  }
	  function getResolvedExternalModuleName(host, file, referenceFile) {
	    return file.moduleName || getExternalModuleNameFromPath(host, file.fileName, referenceFile && referenceFile.fileName);
	  }
	  function getCanonicalAbsolutePath(host, path) {
	    return host.getCanonicalFileName(getNormalizedAbsolutePath(path, host.getCurrentDirectory()));
	  }
	  function getExternalModuleNameFromDeclaration(host, resolver, declaration) {
	    const file = resolver.getExternalModuleFileFromDeclaration(declaration);
	    if (!file || file.isDeclarationFile) {
	      return void 0;
	    }
	    const specifier = getExternalModuleName(declaration);
	    if (specifier && isStringLiteralLike(specifier) && !pathIsRelative(specifier.text) && !getCanonicalAbsolutePath(host, file.path).includes(getCanonicalAbsolutePath(host, ensureTrailingDirectorySeparator(host.getCommonSourceDirectory())))) {
	      return void 0;
	    }
	    return getResolvedExternalModuleName(host, file);
	  }
	  function getExternalModuleNameFromPath(host, fileName, referencePath) {
	    const getCanonicalFileName = (f) => host.getCanonicalFileName(f);
	    const dir = toPath(referencePath ? getDirectoryPath(referencePath) : host.getCommonSourceDirectory(), host.getCurrentDirectory(), getCanonicalFileName);
	    const filePath = getNormalizedAbsolutePath(fileName, host.getCurrentDirectory());
	    const relativePath = getRelativePathToDirectoryOrUrl(
	      dir,
	      filePath,
	      dir,
	      getCanonicalFileName,
	      /*isAbsolutePathAnUrl*/
	      false
	    );
	    const extensionless = removeFileExtension(relativePath);
	    return referencePath ? ensurePathIsNonModuleName(extensionless) : extensionless;
	  }
	  function getOwnEmitOutputFilePath(fileName, host, extension) {
	    const compilerOptions = host.getCompilerOptions();
	    let emitOutputFilePathWithoutExtension;
	    if (compilerOptions.outDir) {
	      emitOutputFilePathWithoutExtension = removeFileExtension(getSourceFilePathInNewDir(fileName, host, compilerOptions.outDir));
	    } else {
	      emitOutputFilePathWithoutExtension = removeFileExtension(fileName);
	    }
	    return emitOutputFilePathWithoutExtension + extension;
	  }
	  function getDeclarationEmitOutputFilePath(fileName, host) {
	    return getDeclarationEmitOutputFilePathWorker(fileName, host.getCompilerOptions(), host.getCurrentDirectory(), host.getCommonSourceDirectory(), (f) => host.getCanonicalFileName(f));
	  }
	  function getDeclarationEmitOutputFilePathWorker(fileName, options, currentDirectory, commonSourceDirectory, getCanonicalFileName) {
	    const outputDir = options.declarationDir || options.outDir;
	    const path = outputDir ? getSourceFilePathInNewDirWorker(fileName, outputDir, currentDirectory, commonSourceDirectory, getCanonicalFileName) : fileName;
	    const declarationExtension = getDeclarationEmitExtensionForPath(path);
	    return removeFileExtension(path) + declarationExtension;
	  }
	  function getDeclarationEmitExtensionForPath(path) {
	    return fileExtensionIsOneOf(path, [".mjs" /* Mjs */, ".mts" /* Mts */]) ? ".d.mts" /* Dmts */ : fileExtensionIsOneOf(path, [".cjs" /* Cjs */, ".cts" /* Cts */]) ? ".d.cts" /* Dcts */ : fileExtensionIsOneOf(path, [".json" /* Json */]) ? `.d.json.ts` : (
	      // Drive-by redefinition of json declaration file output name so if it's ever enabled, it behaves well
	      ".d.ts" /* Dts */
	    );
	  }
	  function getPossibleOriginalInputExtensionForExtension(path) {
	    return fileExtensionIsOneOf(path, [".d.mts" /* Dmts */, ".mjs" /* Mjs */, ".mts" /* Mts */]) ? [".mts" /* Mts */, ".mjs" /* Mjs */] : fileExtensionIsOneOf(path, [".d.cts" /* Dcts */, ".cjs" /* Cjs */, ".cts" /* Cts */]) ? [".cts" /* Cts */, ".cjs" /* Cjs */] : fileExtensionIsOneOf(path, [`.d.json.ts`]) ? [".json" /* Json */] : [".tsx" /* Tsx */, ".ts" /* Ts */, ".jsx" /* Jsx */, ".js" /* Js */];
	  }
	  function outFile(options) {
	    return options.outFile || options.out;
	  }
	  function getPathsBasePath(options, host) {
	    var _a;
	    if (!options.paths)
	      return void 0;
	    return options.baseUrl ?? Debug.checkDefined(options.pathsBasePath || ((_a = host.getCurrentDirectory) == null ? void 0 : _a.call(host)), "Encountered 'paths' without a 'baseUrl', config file, or host 'getCurrentDirectory'.");
	  }
	  function getSourceFilesToEmit(host, targetSourceFile, forceDtsEmit) {
	    const options = host.getCompilerOptions();
	    if (outFile(options)) {
	      const moduleKind = getEmitModuleKind(options);
	      const moduleEmitEnabled = options.emitDeclarationOnly || moduleKind === 2 /* AMD */ || moduleKind === 4 /* System */;
	      return filter(
	        host.getSourceFiles(),
	        (sourceFile) => (moduleEmitEnabled || !isExternalModule(sourceFile)) && sourceFileMayBeEmitted(sourceFile, host, forceDtsEmit)
	      );
	    } else {
	      const sourceFiles = targetSourceFile === void 0 ? host.getSourceFiles() : [targetSourceFile];
	      return filter(
	        sourceFiles,
	        (sourceFile) => sourceFileMayBeEmitted(sourceFile, host, forceDtsEmit)
	      );
	    }
	  }
	  function sourceFileMayBeEmitted(sourceFile, host, forceDtsEmit) {
	    const options = host.getCompilerOptions();
	    if (options.noEmitForJsFiles && isSourceFileJS(sourceFile))
	      return false;
	    if (sourceFile.isDeclarationFile)
	      return false;
	    if (host.isSourceFileFromExternalLibrary(sourceFile))
	      return false;
	    if (forceDtsEmit)
	      return true;
	    if (host.isSourceOfProjectReferenceRedirect(sourceFile.fileName))
	      return false;
	    if (!isJsonSourceFile(sourceFile))
	      return true;
	    if (host.getResolvedProjectReferenceToRedirect(sourceFile.fileName))
	      return false;
	    if (outFile(options))
	      return true;
	    if (!options.outDir)
	      return false;
	    if (options.rootDir || options.composite && options.configFilePath) {
	      const commonDir = getNormalizedAbsolutePath(getCommonSourceDirectory(options, () => [], host.getCurrentDirectory(), host.getCanonicalFileName), host.getCurrentDirectory());
	      const outputPath = getSourceFilePathInNewDirWorker(sourceFile.fileName, options.outDir, host.getCurrentDirectory(), commonDir, host.getCanonicalFileName);
	      if (comparePaths(sourceFile.fileName, outputPath, host.getCurrentDirectory(), !host.useCaseSensitiveFileNames()) === 0 /* EqualTo */)
	        return false;
	    }
	    return true;
	  }
	  function getSourceFilePathInNewDir(fileName, host, newDirPath) {
	    return getSourceFilePathInNewDirWorker(fileName, newDirPath, host.getCurrentDirectory(), host.getCommonSourceDirectory(), (f) => host.getCanonicalFileName(f));
	  }
	  function getSourceFilePathInNewDirWorker(fileName, newDirPath, currentDirectory, commonSourceDirectory, getCanonicalFileName) {
	    let sourceFilePath = getNormalizedAbsolutePath(fileName, currentDirectory);
	    const isSourceFileInCommonSourceDirectory = getCanonicalFileName(sourceFilePath).indexOf(getCanonicalFileName(commonSourceDirectory)) === 0;
	    sourceFilePath = isSourceFileInCommonSourceDirectory ? sourceFilePath.substring(commonSourceDirectory.length) : sourceFilePath;
	    return combinePaths(newDirPath, sourceFilePath);
	  }
	  function writeFile(host, diagnostics, fileName, text, writeByteOrderMark, sourceFiles, data) {
	    host.writeFile(
	      fileName,
	      text,
	      writeByteOrderMark,
	      (hostErrorMessage) => {
	        diagnostics.add(createCompilerDiagnostic(Diagnostics.Could_not_write_file_0_Colon_1, fileName, hostErrorMessage));
	      },
	      sourceFiles,
	      data
	    );
	  }
	  function ensureDirectoriesExist(directoryPath, createDirectory, directoryExists) {
	    if (directoryPath.length > getRootLength(directoryPath) && !directoryExists(directoryPath)) {
	      const parentDirectory = getDirectoryPath(directoryPath);
	      ensureDirectoriesExist(parentDirectory, createDirectory, directoryExists);
	      createDirectory(directoryPath);
	    }
	  }
	  function writeFileEnsuringDirectories(path, data, writeByteOrderMark, writeFile2, createDirectory, directoryExists) {
	    try {
	      writeFile2(path, data, writeByteOrderMark);
	    } catch {
	      ensureDirectoriesExist(getDirectoryPath(normalizePath(path)), createDirectory, directoryExists);
	      writeFile2(path, data, writeByteOrderMark);
	    }
	  }
	  function getLineOfLocalPosition(sourceFile, pos) {
	    const lineStarts = getLineStarts(sourceFile);
	    return computeLineOfPosition(lineStarts, pos);
	  }
	  function getLineOfLocalPositionFromLineMap(lineMap, pos) {
	    return computeLineOfPosition(lineMap, pos);
	  }
	  function getFirstConstructorWithBody(node) {
	    return find(node.members, (member) => isConstructorDeclaration(member) && nodeIsPresent(member.body));
	  }
	  function getSetAccessorValueParameter(accessor) {
	    if (accessor && accessor.parameters.length > 0) {
	      const hasThis = accessor.parameters.length === 2 && parameterIsThisKeyword(accessor.parameters[0]);
	      return accessor.parameters[hasThis ? 1 : 0];
	    }
	  }
	  function getSetAccessorTypeAnnotationNode(accessor) {
	    const parameter = getSetAccessorValueParameter(accessor);
	    return parameter && parameter.type;
	  }
	  function getThisParameter(signature) {
	    if (signature.parameters.length && !isJSDocSignature(signature)) {
	      const thisParameter = signature.parameters[0];
	      if (parameterIsThisKeyword(thisParameter)) {
	        return thisParameter;
	      }
	    }
	  }
	  function parameterIsThisKeyword(parameter) {
	    return isThisIdentifier(parameter.name);
	  }
	  function isThisIdentifier(node) {
	    return !!node && node.kind === 80 /* Identifier */ && identifierIsThisKeyword(node);
	  }
	  function isInTypeQuery(node) {
	    return !!findAncestor(
	      node,
	      (n) => n.kind === 186 /* TypeQuery */ ? true : n.kind === 80 /* Identifier */ || n.kind === 166 /* QualifiedName */ ? false : "quit"
	    );
	  }
	  function isThisInTypeQuery(node) {
	    if (!isThisIdentifier(node)) {
	      return false;
	    }
	    while (isQualifiedName(node.parent) && node.parent.left === node) {
	      node = node.parent;
	    }
	    return node.parent.kind === 186 /* TypeQuery */;
	  }
	  function identifierIsThisKeyword(id) {
	    return id.escapedText === "this";
	  }
	  function getAllAccessorDeclarations(declarations, accessor) {
	    let firstAccessor;
	    let secondAccessor;
	    let getAccessor;
	    let setAccessor;
	    if (hasDynamicName(accessor)) {
	      firstAccessor = accessor;
	      if (accessor.kind === 177 /* GetAccessor */) {
	        getAccessor = accessor;
	      } else if (accessor.kind === 178 /* SetAccessor */) {
	        setAccessor = accessor;
	      } else {
	        Debug.fail("Accessor has wrong kind");
	      }
	    } else {
	      forEach(declarations, (member) => {
	        if (isAccessor(member) && isStatic(member) === isStatic(accessor)) {
	          const memberName = getPropertyNameForPropertyNameNode(member.name);
	          const accessorName = getPropertyNameForPropertyNameNode(accessor.name);
	          if (memberName === accessorName) {
	            if (!firstAccessor) {
	              firstAccessor = member;
	            } else if (!secondAccessor) {
	              secondAccessor = member;
	            }
	            if (member.kind === 177 /* GetAccessor */ && !getAccessor) {
	              getAccessor = member;
	            }
	            if (member.kind === 178 /* SetAccessor */ && !setAccessor) {
	              setAccessor = member;
	            }
	          }
	        }
	      });
	    }
	    return {
	      firstAccessor,
	      secondAccessor,
	      getAccessor,
	      setAccessor
	    };
	  }
	  function getEffectiveTypeAnnotationNode(node) {
	    if (!isInJSFile(node) && isFunctionDeclaration(node))
	      return void 0;
	    const type = node.type;
	    if (type || !isInJSFile(node))
	      return type;
	    return isJSDocPropertyLikeTag(node) ? node.typeExpression && node.typeExpression.type : getJSDocType(node);
	  }
	  function getTypeAnnotationNode(node) {
	    return node.type;
	  }
	  function getEffectiveReturnTypeNode(node) {
	    return isJSDocSignature(node) ? node.type && node.type.typeExpression && node.type.typeExpression.type : node.type || (isInJSFile(node) ? getJSDocReturnType(node) : void 0);
	  }
	  function getJSDocTypeParameterDeclarations(node) {
	    return flatMap(getJSDocTags(node), (tag) => isNonTypeAliasTemplate(tag) ? tag.typeParameters : void 0);
	  }
	  function isNonTypeAliasTemplate(tag) {
	    return isJSDocTemplateTag(tag) && !(tag.parent.kind === 327 /* JSDoc */ && (tag.parent.tags.some(isJSDocTypeAlias) || tag.parent.tags.some(isJSDocOverloadTag)));
	  }
	  function getEffectiveSetAccessorTypeAnnotationNode(node) {
	    const parameter = getSetAccessorValueParameter(node);
	    return parameter && getEffectiveTypeAnnotationNode(parameter);
	  }
	  function emitNewLineBeforeLeadingComments(lineMap, writer, node, leadingComments) {
	    emitNewLineBeforeLeadingCommentsOfPosition(lineMap, writer, node.pos, leadingComments);
	  }
	  function emitNewLineBeforeLeadingCommentsOfPosition(lineMap, writer, pos, leadingComments) {
	    if (leadingComments && leadingComments.length && pos !== leadingComments[0].pos && getLineOfLocalPositionFromLineMap(lineMap, pos) !== getLineOfLocalPositionFromLineMap(lineMap, leadingComments[0].pos)) {
	      writer.writeLine();
	    }
	  }
	  function emitNewLineBeforeLeadingCommentOfPosition(lineMap, writer, pos, commentPos) {
	    if (pos !== commentPos && getLineOfLocalPositionFromLineMap(lineMap, pos) !== getLineOfLocalPositionFromLineMap(lineMap, commentPos)) {
	      writer.writeLine();
	    }
	  }
	  function emitComments(text, lineMap, writer, comments, leadingSeparator, trailingSeparator, newLine, writeComment) {
	    if (comments && comments.length > 0) {
	      if (leadingSeparator) {
	        writer.writeSpace(" ");
	      }
	      let emitInterveningSeparator = false;
	      for (const comment of comments) {
	        if (emitInterveningSeparator) {
	          writer.writeSpace(" ");
	          emitInterveningSeparator = false;
	        }
	        writeComment(text, lineMap, writer, comment.pos, comment.end, newLine);
	        if (comment.hasTrailingNewLine) {
	          writer.writeLine();
	        } else {
	          emitInterveningSeparator = true;
	        }
	      }
	      if (emitInterveningSeparator && trailingSeparator) {
	        writer.writeSpace(" ");
	      }
	    }
	  }
	  function emitDetachedComments(text, lineMap, writer, writeComment, node, newLine, removeComments) {
	    let leadingComments;
	    let currentDetachedCommentInfo;
	    if (removeComments) {
	      if (node.pos === 0) {
	        leadingComments = filter(getLeadingCommentRanges(text, node.pos), isPinnedCommentLocal);
	      }
	    } else {
	      leadingComments = getLeadingCommentRanges(text, node.pos);
	    }
	    if (leadingComments) {
	      const detachedComments = [];
	      let lastComment;
	      for (const comment of leadingComments) {
	        if (lastComment) {
	          const lastCommentLine = getLineOfLocalPositionFromLineMap(lineMap, lastComment.end);
	          const commentLine = getLineOfLocalPositionFromLineMap(lineMap, comment.pos);
	          if (commentLine >= lastCommentLine + 2) {
	            break;
	          }
	        }
	        detachedComments.push(comment);
	        lastComment = comment;
	      }
	      if (detachedComments.length) {
	        const lastCommentLine = getLineOfLocalPositionFromLineMap(lineMap, last(detachedComments).end);
	        const nodeLine = getLineOfLocalPositionFromLineMap(lineMap, skipTrivia(text, node.pos));
	        if (nodeLine >= lastCommentLine + 2) {
	          emitNewLineBeforeLeadingComments(lineMap, writer, node, leadingComments);
	          emitComments(
	            text,
	            lineMap,
	            writer,
	            detachedComments,
	            /*leadingSeparator*/
	            false,
	            /*trailingSeparator*/
	            true,
	            newLine,
	            writeComment
	          );
	          currentDetachedCommentInfo = { nodePos: node.pos, detachedCommentEndPos: last(detachedComments).end };
	        }
	      }
	    }
	    return currentDetachedCommentInfo;
	    function isPinnedCommentLocal(comment) {
	      return isPinnedComment(text, comment.pos);
	    }
	  }
	  function writeCommentRange(text, lineMap, writer, commentPos, commentEnd, newLine) {
	    if (text.charCodeAt(commentPos + 1) === 42 /* asterisk */) {
	      const firstCommentLineAndCharacter = computeLineAndCharacterOfPosition(lineMap, commentPos);
	      const lineCount = lineMap.length;
	      let firstCommentLineIndent;
	      for (let pos = commentPos, currentLine = firstCommentLineAndCharacter.line; pos < commentEnd; currentLine++) {
	        const nextLineStart = currentLine + 1 === lineCount ? text.length + 1 : lineMap[currentLine + 1];
	        if (pos !== commentPos) {
	          if (firstCommentLineIndent === void 0) {
	            firstCommentLineIndent = calculateIndent(text, lineMap[firstCommentLineAndCharacter.line], commentPos);
	          }
	          const currentWriterIndentSpacing = writer.getIndent() * getIndentSize();
	          const spacesToEmit = currentWriterIndentSpacing - firstCommentLineIndent + calculateIndent(text, pos, nextLineStart);
	          if (spacesToEmit > 0) {
	            let numberOfSingleSpacesToEmit = spacesToEmit % getIndentSize();
	            const indentSizeSpaceString = getIndentString((spacesToEmit - numberOfSingleSpacesToEmit) / getIndentSize());
	            writer.rawWrite(indentSizeSpaceString);
	            while (numberOfSingleSpacesToEmit) {
	              writer.rawWrite(" ");
	              numberOfSingleSpacesToEmit--;
	            }
	          } else {
	            writer.rawWrite("");
	          }
	        }
	        writeTrimmedCurrentLine(text, commentEnd, writer, newLine, pos, nextLineStart);
	        pos = nextLineStart;
	      }
	    } else {
	      writer.writeComment(text.substring(commentPos, commentEnd));
	    }
	  }
	  function writeTrimmedCurrentLine(text, commentEnd, writer, newLine, pos, nextLineStart) {
	    const end = Math.min(commentEnd, nextLineStart - 1);
	    const currentLineText = text.substring(pos, end).trim();
	    if (currentLineText) {
	      writer.writeComment(currentLineText);
	      if (end !== commentEnd) {
	        writer.writeLine();
	      }
	    } else {
	      writer.rawWrite(newLine);
	    }
	  }
	  function calculateIndent(text, pos, end) {
	    let currentLineIndent = 0;
	    for (; pos < end && isWhiteSpaceSingleLine(text.charCodeAt(pos)); pos++) {
	      if (text.charCodeAt(pos) === 9 /* tab */) {
	        currentLineIndent += getIndentSize() - currentLineIndent % getIndentSize();
	      } else {
	        currentLineIndent++;
	      }
	    }
	    return currentLineIndent;
	  }
	  function hasEffectiveModifiers(node) {
	    return getEffectiveModifierFlags(node) !== 0 /* None */;
	  }
	  function hasSyntacticModifiers(node) {
	    return getSyntacticModifierFlags(node) !== 0 /* None */;
	  }
	  function hasEffectiveModifier(node, flags) {
	    return !!getSelectedEffectiveModifierFlags(node, flags);
	  }
	  function hasSyntacticModifier(node, flags) {
	    return !!getSelectedSyntacticModifierFlags(node, flags);
	  }
	  function isStatic(node) {
	    return isClassElement(node) && hasStaticModifier(node) || isClassStaticBlockDeclaration(node);
	  }
	  function hasStaticModifier(node) {
	    return hasSyntacticModifier(node, 256 /* Static */);
	  }
	  function hasOverrideModifier(node) {
	    return hasEffectiveModifier(node, 16 /* Override */);
	  }
	  function hasAbstractModifier(node) {
	    return hasSyntacticModifier(node, 64 /* Abstract */);
	  }
	  function hasAmbientModifier(node) {
	    return hasSyntacticModifier(node, 128 /* Ambient */);
	  }
	  function hasAccessorModifier(node) {
	    return hasSyntacticModifier(node, 512 /* Accessor */);
	  }
	  function hasEffectiveReadonlyModifier(node) {
	    return hasEffectiveModifier(node, 8 /* Readonly */);
	  }
	  function hasDecorators(node) {
	    return hasSyntacticModifier(node, 32768 /* Decorator */);
	  }
	  function getSelectedEffectiveModifierFlags(node, flags) {
	    return getEffectiveModifierFlags(node) & flags;
	  }
	  function getSelectedSyntacticModifierFlags(node, flags) {
	    return getSyntacticModifierFlags(node) & flags;
	  }
	  function getModifierFlagsWorker(node, includeJSDoc, alwaysIncludeJSDoc) {
	    if (node.kind >= 0 /* FirstToken */ && node.kind <= 165 /* LastToken */) {
	      return 0 /* None */;
	    }
	    if (!(node.modifierFlagsCache & 536870912 /* HasComputedFlags */)) {
	      node.modifierFlagsCache = getSyntacticModifierFlagsNoCache(node) | 536870912 /* HasComputedFlags */;
	    }
	    if (alwaysIncludeJSDoc || includeJSDoc && isInJSFile(node)) {
	      if (!(node.modifierFlagsCache & 268435456 /* HasComputedJSDocModifiers */) && node.parent) {
	        node.modifierFlagsCache |= getRawJSDocModifierFlagsNoCache(node) | 268435456 /* HasComputedJSDocModifiers */;
	      }
	      return selectEffectiveModifierFlags(node.modifierFlagsCache);
	    }
	    return selectSyntacticModifierFlags(node.modifierFlagsCache);
	  }
	  function getEffectiveModifierFlags(node) {
	    return getModifierFlagsWorker(
	      node,
	      /*includeJSDoc*/
	      true
	    );
	  }
	  function getEffectiveModifierFlagsAlwaysIncludeJSDoc(node) {
	    return getModifierFlagsWorker(
	      node,
	      /*includeJSDoc*/
	      true,
	      /*alwaysIncludeJSDoc*/
	      true
	    );
	  }
	  function getSyntacticModifierFlags(node) {
	    return getModifierFlagsWorker(
	      node,
	      /*includeJSDoc*/
	      false
	    );
	  }
	  function getRawJSDocModifierFlagsNoCache(node) {
	    let flags = 0 /* None */;
	    if (!!node.parent && !isParameter(node)) {
	      if (isInJSFile(node)) {
	        if (getJSDocPublicTagNoCache(node))
	          flags |= 8388608 /* JSDocPublic */;
	        if (getJSDocPrivateTagNoCache(node))
	          flags |= 16777216 /* JSDocPrivate */;
	        if (getJSDocProtectedTagNoCache(node))
	          flags |= 33554432 /* JSDocProtected */;
	        if (getJSDocReadonlyTagNoCache(node))
	          flags |= 67108864 /* JSDocReadonly */;
	        if (getJSDocOverrideTagNoCache(node))
	          flags |= 134217728 /* JSDocOverride */;
	      }
	      if (getJSDocDeprecatedTagNoCache(node))
	        flags |= 65536 /* Deprecated */;
	    }
	    return flags;
	  }
	  function selectSyntacticModifierFlags(flags) {
	    return flags & 65535 /* SyntacticModifiers */;
	  }
	  function selectEffectiveModifierFlags(flags) {
	    return flags & 131071 /* NonCacheOnlyModifiers */ | (flags & 260046848 /* JSDocCacheOnlyModifiers */) >>> 23;
	  }
	  function getJSDocModifierFlagsNoCache(node) {
	    return selectEffectiveModifierFlags(getRawJSDocModifierFlagsNoCache(node));
	  }
	  function getEffectiveModifierFlagsNoCache(node) {
	    return getSyntacticModifierFlagsNoCache(node) | getJSDocModifierFlagsNoCache(node);
	  }
	  function getSyntacticModifierFlagsNoCache(node) {
	    let flags = canHaveModifiers(node) ? modifiersToFlags(node.modifiers) : 0 /* None */;
	    if (node.flags & 8 /* NestedNamespace */ || node.kind === 80 /* Identifier */ && node.flags & 4096 /* IdentifierIsInJSDocNamespace */) {
	      flags |= 32 /* Export */;
	    }
	    return flags;
	  }
	  function modifiersToFlags(modifiers) {
	    let flags = 0 /* None */;
	    if (modifiers) {
	      for (const modifier of modifiers) {
	        flags |= modifierToFlag(modifier.kind);
	      }
	    }
	    return flags;
	  }
	  function modifierToFlag(token) {
	    switch (token) {
	      case 126 /* StaticKeyword */:
	        return 256 /* Static */;
	      case 125 /* PublicKeyword */:
	        return 1 /* Public */;
	      case 124 /* ProtectedKeyword */:
	        return 4 /* Protected */;
	      case 123 /* PrivateKeyword */:
	        return 2 /* Private */;
	      case 128 /* AbstractKeyword */:
	        return 64 /* Abstract */;
	      case 129 /* AccessorKeyword */:
	        return 512 /* Accessor */;
	      case 95 /* ExportKeyword */:
	        return 32 /* Export */;
	      case 138 /* DeclareKeyword */:
	        return 128 /* Ambient */;
	      case 87 /* ConstKeyword */:
	        return 4096 /* Const */;
	      case 90 /* DefaultKeyword */:
	        return 2048 /* Default */;
	      case 134 /* AsyncKeyword */:
	        return 1024 /* Async */;
	      case 148 /* ReadonlyKeyword */:
	        return 8 /* Readonly */;
	      case 164 /* OverrideKeyword */:
	        return 16 /* Override */;
	      case 103 /* InKeyword */:
	        return 8192 /* In */;
	      case 147 /* OutKeyword */:
	        return 16384 /* Out */;
	      case 170 /* Decorator */:
	        return 32768 /* Decorator */;
	    }
	    return 0 /* None */;
	  }
	  function isBinaryLogicalOperator(token) {
	    return token === 57 /* BarBarToken */ || token === 56 /* AmpersandAmpersandToken */;
	  }
	  function isLogicalOperator(token) {
	    return isBinaryLogicalOperator(token) || token === 54 /* ExclamationToken */;
	  }
	  function isLogicalOrCoalescingAssignmentOperator(token) {
	    return token === 76 /* BarBarEqualsToken */ || token === 77 /* AmpersandAmpersandEqualsToken */ || token === 78 /* QuestionQuestionEqualsToken */;
	  }
	  function isLogicalOrCoalescingAssignmentExpression(expr) {
	    return isBinaryExpression(expr) && isLogicalOrCoalescingAssignmentOperator(expr.operatorToken.kind);
	  }
	  function isLogicalOrCoalescingBinaryOperator(token) {
	    return isBinaryLogicalOperator(token) || token === 61 /* QuestionQuestionToken */;
	  }
	  function isLogicalOrCoalescingBinaryExpression(expr) {
	    return isBinaryExpression(expr) && isLogicalOrCoalescingBinaryOperator(expr.operatorToken.kind);
	  }
	  function isAssignmentOperator(token) {
	    return token >= 64 /* FirstAssignment */ && token <= 79 /* LastAssignment */;
	  }
	  function tryGetClassExtendingExpressionWithTypeArguments(node) {
	    const cls = tryGetClassImplementingOrExtendingExpressionWithTypeArguments(node);
	    return cls && !cls.isImplements ? cls.class : void 0;
	  }
	  function tryGetClassImplementingOrExtendingExpressionWithTypeArguments(node) {
	    if (isExpressionWithTypeArguments(node)) {
	      if (isHeritageClause(node.parent) && isClassLike(node.parent.parent)) {
	        return { class: node.parent.parent, isImplements: node.parent.token === 119 /* ImplementsKeyword */ };
	      }
	      if (isJSDocAugmentsTag(node.parent)) {
	        const host = getEffectiveJSDocHost(node.parent);
	        if (host && isClassLike(host)) {
	          return { class: host, isImplements: false };
	        }
	      }
	    }
	    return void 0;
	  }
	  function isAssignmentExpression(node, excludeCompoundAssignment) {
	    return isBinaryExpression(node) && (excludeCompoundAssignment ? node.operatorToken.kind === 64 /* EqualsToken */ : isAssignmentOperator(node.operatorToken.kind)) && isLeftHandSideExpression(node.left);
	  }
	  function isLeftHandSideOfAssignment(node) {
	    return isAssignmentExpression(node.parent) && node.parent.left === node;
	  }
	  function isDestructuringAssignment(node) {
	    if (isAssignmentExpression(
	      node,
	      /*excludeCompoundAssignment*/
	      true
	    )) {
	      const kind = node.left.kind;
	      return kind === 210 /* ObjectLiteralExpression */ || kind === 209 /* ArrayLiteralExpression */;
	    }
	    return false;
	  }
	  function isExpressionWithTypeArgumentsInClassExtendsClause(node) {
	    return tryGetClassExtendingExpressionWithTypeArguments(node) !== void 0;
	  }
	  function isEntityNameExpression(node) {
	    return node.kind === 80 /* Identifier */ || isPropertyAccessEntityNameExpression(node);
	  }
	  function getFirstIdentifier(node) {
	    switch (node.kind) {
	      case 80 /* Identifier */:
	        return node;
	      case 166 /* QualifiedName */:
	        do {
	          node = node.left;
	        } while (node.kind !== 80 /* Identifier */);
	        return node;
	      case 211 /* PropertyAccessExpression */:
	        do {
	          node = node.expression;
	        } while (node.kind !== 80 /* Identifier */);
	        return node;
	    }
	  }
	  function isDottedName(node) {
	    return node.kind === 80 /* Identifier */ || node.kind === 110 /* ThisKeyword */ || node.kind === 108 /* SuperKeyword */ || node.kind === 236 /* MetaProperty */ || node.kind === 211 /* PropertyAccessExpression */ && isDottedName(node.expression) || node.kind === 217 /* ParenthesizedExpression */ && isDottedName(node.expression);
	  }
	  function isPropertyAccessEntityNameExpression(node) {
	    return isPropertyAccessExpression(node) && isIdentifier(node.name) && isEntityNameExpression(node.expression);
	  }
	  function tryGetPropertyAccessOrIdentifierToString(expr) {
	    if (isPropertyAccessExpression(expr)) {
	      const baseStr = tryGetPropertyAccessOrIdentifierToString(expr.expression);
	      if (baseStr !== void 0) {
	        return baseStr + "." + entityNameToString(expr.name);
	      }
	    } else if (isElementAccessExpression(expr)) {
	      const baseStr = tryGetPropertyAccessOrIdentifierToString(expr.expression);
	      if (baseStr !== void 0 && isPropertyName(expr.argumentExpression)) {
	        return baseStr + "." + getPropertyNameForPropertyNameNode(expr.argumentExpression);
	      }
	    } else if (isIdentifier(expr)) {
	      return unescapeLeadingUnderscores(expr.escapedText);
	    } else if (isJsxNamespacedName(expr)) {
	      return getTextOfJsxNamespacedName(expr);
	    }
	    return void 0;
	  }
	  function isPrototypeAccess(node) {
	    return isBindableStaticAccessExpression(node) && getElementOrPropertyAccessName(node) === "prototype";
	  }
	  function isRightSideOfQualifiedNameOrPropertyAccess(node) {
	    return node.parent.kind === 166 /* QualifiedName */ && node.parent.right === node || node.parent.kind === 211 /* PropertyAccessExpression */ && node.parent.name === node || node.parent.kind === 236 /* MetaProperty */ && node.parent.name === node;
	  }
	  function isRightSideOfAccessExpression(node) {
	    return !!node.parent && (isPropertyAccessExpression(node.parent) && node.parent.name === node || isElementAccessExpression(node.parent) && node.parent.argumentExpression === node);
	  }
	  function isRightSideOfQualifiedNameOrPropertyAccessOrJSDocMemberName(node) {
	    return isQualifiedName(node.parent) && node.parent.right === node || isPropertyAccessExpression(node.parent) && node.parent.name === node || isJSDocMemberName(node.parent) && node.parent.right === node;
	  }
	  function isInstanceOfExpression(node) {
	    return isBinaryExpression(node) && node.operatorToken.kind === 104 /* InstanceOfKeyword */;
	  }
	  function isRightSideOfInstanceofExpression(node) {
	    return isInstanceOfExpression(node.parent) && node === node.parent.right;
	  }
	  function isEmptyObjectLiteral(expression) {
	    return expression.kind === 210 /* ObjectLiteralExpression */ && expression.properties.length === 0;
	  }
	  function isEmptyArrayLiteral(expression) {
	    return expression.kind === 209 /* ArrayLiteralExpression */ && expression.elements.length === 0;
	  }
	  function getLocalSymbolForExportDefault(symbol) {
	    if (!isExportDefaultSymbol(symbol) || !symbol.declarations)
	      return void 0;
	    for (const decl of symbol.declarations) {
	      if (decl.localSymbol)
	        return decl.localSymbol;
	    }
	    return void 0;
	  }
	  function isExportDefaultSymbol(symbol) {
	    return symbol && length(symbol.declarations) > 0 && hasSyntacticModifier(symbol.declarations[0], 2048 /* Default */);
	  }
	  function tryExtractTSExtension(fileName) {
	    return find(supportedTSExtensionsForExtractExtension, (extension) => fileExtensionIs(fileName, extension));
	  }
	  function getExpandedCharCodes(input) {
	    const output = [];
	    const length2 = input.length;
	    for (let i = 0; i < length2; i++) {
	      const charCode = input.charCodeAt(i);
	      if (charCode < 128) {
	        output.push(charCode);
	      } else if (charCode < 2048) {
	        output.push(charCode >> 6 | 192);
	        output.push(charCode & 63 | 128);
	      } else if (charCode < 65536) {
	        output.push(charCode >> 12 | 224);
	        output.push(charCode >> 6 & 63 | 128);
	        output.push(charCode & 63 | 128);
	      } else if (charCode < 131072) {
	        output.push(charCode >> 18 | 240);
	        output.push(charCode >> 12 & 63 | 128);
	        output.push(charCode >> 6 & 63 | 128);
	        output.push(charCode & 63 | 128);
	      } else {
	        Debug.assert(false, "Unexpected code point");
	      }
	    }
	    return output;
	  }
	  function convertToBase64(input) {
	    let result = "";
	    const charCodes = getExpandedCharCodes(input);
	    let i = 0;
	    const length2 = charCodes.length;
	    let byte1, byte2, byte3, byte4;
	    while (i < length2) {
	      byte1 = charCodes[i] >> 2;
	      byte2 = (charCodes[i] & 3) << 4 | charCodes[i + 1] >> 4;
	      byte3 = (charCodes[i + 1] & 15) << 2 | charCodes[i + 2] >> 6;
	      byte4 = charCodes[i + 2] & 63;
	      if (i + 1 >= length2) {
	        byte3 = byte4 = 64;
	      } else if (i + 2 >= length2) {
	        byte4 = 64;
	      }
	      result += base64Digits.charAt(byte1) + base64Digits.charAt(byte2) + base64Digits.charAt(byte3) + base64Digits.charAt(byte4);
	      i += 3;
	    }
	    return result;
	  }
	  function getStringFromExpandedCharCodes(codes) {
	    let output = "";
	    let i = 0;
	    const length2 = codes.length;
	    while (i < length2) {
	      const charCode = codes[i];
	      if (charCode < 128) {
	        output += String.fromCharCode(charCode);
	        i++;
	      } else if ((charCode & 192) === 192) {
	        let value = charCode & 63;
	        i++;
	        let nextCode = codes[i];
	        while ((nextCode & 192) === 128) {
	          value = value << 6 | nextCode & 63;
	          i++;
	          nextCode = codes[i];
	        }
	        output += String.fromCharCode(value);
	      } else {
	        output += String.fromCharCode(charCode);
	        i++;
	      }
	    }
	    return output;
	  }
	  function base64encode(host, input) {
	    if (host && host.base64encode) {
	      return host.base64encode(input);
	    }
	    return convertToBase64(input);
	  }
	  function base64decode(host, input) {
	    if (host && host.base64decode) {
	      return host.base64decode(input);
	    }
	    const length2 = input.length;
	    const expandedCharCodes = [];
	    let i = 0;
	    while (i < length2) {
	      if (input.charCodeAt(i) === base64Digits.charCodeAt(64)) {
	        break;
	      }
	      const ch1 = base64Digits.indexOf(input[i]);
	      const ch2 = base64Digits.indexOf(input[i + 1]);
	      const ch3 = base64Digits.indexOf(input[i + 2]);
	      const ch4 = base64Digits.indexOf(input[i + 3]);
	      const code1 = (ch1 & 63) << 2 | ch2 >> 4 & 3;
	      const code2 = (ch2 & 15) << 4 | ch3 >> 2 & 15;
	      const code3 = (ch3 & 3) << 6 | ch4 & 63;
	      if (code2 === 0 && ch3 !== 0) {
	        expandedCharCodes.push(code1);
	      } else if (code3 === 0 && ch4 !== 0) {
	        expandedCharCodes.push(code1, code2);
	      } else {
	        expandedCharCodes.push(code1, code2, code3);
	      }
	      i += 4;
	    }
	    return getStringFromExpandedCharCodes(expandedCharCodes);
	  }
	  function readJsonOrUndefined(path, hostOrText) {
	    const jsonText = isString(hostOrText) ? hostOrText : hostOrText.readFile(path);
	    if (!jsonText)
	      return void 0;
	    const result = parseConfigFileTextToJson(path, jsonText);
	    return !result.error ? result.config : void 0;
	  }
	  function readJson(path, host) {
	    return readJsonOrUndefined(path, host) || {};
	  }
	  function tryParseJson(text) {
	    try {
	      return JSON.parse(text);
	    } catch {
	      return void 0;
	    }
	  }
	  function directoryProbablyExists(directoryName, host) {
	    return !host.directoryExists || host.directoryExists(directoryName);
	  }
	  function getNewLineCharacter(options) {
	    switch (options.newLine) {
	      case 0 /* CarriageReturnLineFeed */:
	        return carriageReturnLineFeed;
	      case 1 /* LineFeed */:
	      case void 0:
	        return lineFeed;
	    }
	  }
	  function createRange(pos, end = pos) {
	    Debug.assert(end >= pos || end === -1);
	    return { pos, end };
	  }
	  function moveRangeEnd(range, end) {
	    return createRange(range.pos, end);
	  }
	  function moveRangePos(range, pos) {
	    return createRange(pos, range.end);
	  }
	  function moveRangePastDecorators(node) {
	    const lastDecorator = canHaveModifiers(node) ? findLast(node.modifiers, isDecorator) : void 0;
	    return lastDecorator && !positionIsSynthesized(lastDecorator.end) ? moveRangePos(node, lastDecorator.end) : node;
	  }
	  function moveRangePastModifiers(node) {
	    if (isPropertyDeclaration(node) || isMethodDeclaration(node)) {
	      return moveRangePos(node, node.name.pos);
	    }
	    const lastModifier = canHaveModifiers(node) ? lastOrUndefined(node.modifiers) : void 0;
	    return lastModifier && !positionIsSynthesized(lastModifier.end) ? moveRangePos(node, lastModifier.end) : moveRangePastDecorators(node);
	  }
	  function isCollapsedRange(range) {
	    return range.pos === range.end;
	  }
	  function createTokenRange(pos, token) {
	    return createRange(pos, pos + tokenToString(token).length);
	  }
	  function rangeIsOnSingleLine(range, sourceFile) {
	    return rangeStartIsOnSameLineAsRangeEnd(range, range, sourceFile);
	  }
	  function rangeStartPositionsAreOnSameLine(range1, range2, sourceFile) {
	    return positionsAreOnSameLine(
	      getStartPositionOfRange(
	        range1,
	        sourceFile,
	        /*includeComments*/
	        false
	      ),
	      getStartPositionOfRange(
	        range2,
	        sourceFile,
	        /*includeComments*/
	        false
	      ),
	      sourceFile
	    );
	  }
	  function rangeEndPositionsAreOnSameLine(range1, range2, sourceFile) {
	    return positionsAreOnSameLine(range1.end, range2.end, sourceFile);
	  }
	  function rangeStartIsOnSameLineAsRangeEnd(range1, range2, sourceFile) {
	    return positionsAreOnSameLine(getStartPositionOfRange(
	      range1,
	      sourceFile,
	      /*includeComments*/
	      false
	    ), range2.end, sourceFile);
	  }
	  function rangeEndIsOnSameLineAsRangeStart(range1, range2, sourceFile) {
	    return positionsAreOnSameLine(range1.end, getStartPositionOfRange(
	      range2,
	      sourceFile,
	      /*includeComments*/
	      false
	    ), sourceFile);
	  }
	  function getLinesBetweenRangeEndAndRangeStart(range1, range2, sourceFile, includeSecondRangeComments) {
	    const range2Start = getStartPositionOfRange(range2, sourceFile, includeSecondRangeComments);
	    return getLinesBetweenPositions(sourceFile, range1.end, range2Start);
	  }
	  function getLinesBetweenRangeEndPositions(range1, range2, sourceFile) {
	    return getLinesBetweenPositions(sourceFile, range1.end, range2.end);
	  }
	  function isNodeArrayMultiLine(list, sourceFile) {
	    return !positionsAreOnSameLine(list.pos, list.end, sourceFile);
	  }
	  function positionsAreOnSameLine(pos1, pos2, sourceFile) {
	    return getLinesBetweenPositions(sourceFile, pos1, pos2) === 0;
	  }
	  function getStartPositionOfRange(range, sourceFile, includeComments) {
	    return positionIsSynthesized(range.pos) ? -1 : skipTrivia(
	      sourceFile.text,
	      range.pos,
	      /*stopAfterLineBreak*/
	      false,
	      includeComments
	    );
	  }
	  function getLinesBetweenPositionAndPrecedingNonWhitespaceCharacter(pos, stopPos, sourceFile, includeComments) {
	    const startPos = skipTrivia(
	      sourceFile.text,
	      pos,
	      /*stopAfterLineBreak*/
	      false,
	      includeComments
	    );
	    const prevPos = getPreviousNonWhitespacePosition(startPos, stopPos, sourceFile);
	    return getLinesBetweenPositions(sourceFile, prevPos ?? stopPos, startPos);
	  }
	  function getLinesBetweenPositionAndNextNonWhitespaceCharacter(pos, stopPos, sourceFile, includeComments) {
	    const nextPos = skipTrivia(
	      sourceFile.text,
	      pos,
	      /*stopAfterLineBreak*/
	      false,
	      includeComments
	    );
	    return getLinesBetweenPositions(sourceFile, pos, Math.min(stopPos, nextPos));
	  }
	  function getPreviousNonWhitespacePosition(pos, stopPos = 0, sourceFile) {
	    while (pos-- > stopPos) {
	      if (!isWhiteSpaceLike(sourceFile.text.charCodeAt(pos))) {
	        return pos;
	      }
	    }
	  }
	  function isDeclarationNameOfEnumOrNamespace(node) {
	    const parseNode = getParseTreeNode(node);
	    if (parseNode) {
	      switch (parseNode.parent.kind) {
	        case 266 /* EnumDeclaration */:
	        case 267 /* ModuleDeclaration */:
	          return parseNode === parseNode.parent.name;
	      }
	    }
	    return false;
	  }
	  function getInitializedVariables(node) {
	    return filter(node.declarations, isInitializedVariable);
	  }
	  function isInitializedVariable(node) {
	    return isVariableDeclaration(node) && node.initializer !== void 0;
	  }
	  function isWatchSet(options) {
	    return options.watch && hasProperty(options, "watch");
	  }
	  function closeFileWatcher(watcher) {
	    watcher.close();
	  }
	  function getCheckFlags(symbol) {
	    return symbol.flags & 33554432 /* Transient */ ? symbol.links.checkFlags : 0;
	  }
	  function getDeclarationModifierFlagsFromSymbol(s, isWrite = false) {
	    if (s.valueDeclaration) {
	      const declaration = isWrite && s.declarations && find(s.declarations, isSetAccessorDeclaration) || s.flags & 32768 /* GetAccessor */ && find(s.declarations, isGetAccessorDeclaration) || s.valueDeclaration;
	      const flags = getCombinedModifierFlags(declaration);
	      return s.parent && s.parent.flags & 32 /* Class */ ? flags : flags & ~7 /* AccessibilityModifier */;
	    }
	    if (getCheckFlags(s) & 6 /* Synthetic */) {
	      const checkFlags = s.links.checkFlags;
	      const accessModifier = checkFlags & 1024 /* ContainsPrivate */ ? 2 /* Private */ : checkFlags & 256 /* ContainsPublic */ ? 1 /* Public */ : 4 /* Protected */;
	      const staticModifier = checkFlags & 2048 /* ContainsStatic */ ? 256 /* Static */ : 0;
	      return accessModifier | staticModifier;
	    }
	    if (s.flags & 4194304 /* Prototype */) {
	      return 1 /* Public */ | 256 /* Static */;
	    }
	    return 0;
	  }
	  function skipAlias(symbol, checker) {
	    return symbol.flags & 2097152 /* Alias */ ? checker.getAliasedSymbol(symbol) : symbol;
	  }
	  function getCombinedLocalAndExportSymbolFlags(symbol) {
	    return symbol.exportSymbol ? symbol.exportSymbol.flags | symbol.flags : symbol.flags;
	  }
	  function isWriteOnlyAccess(node) {
	    return accessKind(node) === 1 /* Write */;
	  }
	  function isWriteAccess(node) {
	    return accessKind(node) !== 0 /* Read */;
	  }
	  function accessKind(node) {
	    const { parent: parent2 } = node;
	    switch (parent2 == null ? void 0 : parent2.kind) {
	      case 217 /* ParenthesizedExpression */:
	        return accessKind(parent2);
	      case 225 /* PostfixUnaryExpression */:
	      case 224 /* PrefixUnaryExpression */:
	        const { operator } = parent2;
	        return operator === 46 /* PlusPlusToken */ || operator === 47 /* MinusMinusToken */ ? 2 /* ReadWrite */ : 0 /* Read */;
	      case 226 /* BinaryExpression */:
	        const { left, operatorToken } = parent2;
	        return left === node && isAssignmentOperator(operatorToken.kind) ? operatorToken.kind === 64 /* EqualsToken */ ? 1 /* Write */ : 2 /* ReadWrite */ : 0 /* Read */;
	      case 211 /* PropertyAccessExpression */:
	        return parent2.name !== node ? 0 /* Read */ : accessKind(parent2);
	      case 303 /* PropertyAssignment */: {
	        const parentAccess = accessKind(parent2.parent);
	        return node === parent2.name ? reverseAccessKind(parentAccess) : parentAccess;
	      }
	      case 304 /* ShorthandPropertyAssignment */:
	        return node === parent2.objectAssignmentInitializer ? 0 /* Read */ : accessKind(parent2.parent);
	      case 209 /* ArrayLiteralExpression */:
	        return accessKind(parent2);
	      default:
	        return 0 /* Read */;
	    }
	  }
	  function reverseAccessKind(a) {
	    switch (a) {
	      case 0 /* Read */:
	        return 1 /* Write */;
	      case 1 /* Write */:
	        return 0 /* Read */;
	      case 2 /* ReadWrite */:
	        return 2 /* ReadWrite */;
	      default:
	        return Debug.assertNever(a);
	    }
	  }
	  function compareDataObjects(dst, src) {
	    if (!dst || !src || Object.keys(dst).length !== Object.keys(src).length) {
	      return false;
	    }
	    for (const e in dst) {
	      if (typeof dst[e] === "object") {
	        if (!compareDataObjects(dst[e], src[e])) {
	          return false;
	        }
	      } else if (typeof dst[e] !== "function") {
	        if (dst[e] !== src[e]) {
	          return false;
	        }
	      }
	    }
	    return true;
	  }
	  function clearMap(map2, onDeleteValue) {
	    map2.forEach(onDeleteValue);
	    map2.clear();
	  }
	  function mutateMapSkippingNewValues(map2, newMap, options) {
	    const { onDeleteValue, onExistingValue } = options;
	    map2.forEach((existingValue, key) => {
	      var _a;
	      if (!(newMap == null ? void 0 : newMap.has(key))) {
	        map2.delete(key);
	        onDeleteValue(existingValue, key);
	      } else if (onExistingValue) {
	        onExistingValue(existingValue, (_a = newMap.get) == null ? void 0 : _a.call(newMap, key), key);
	      }
	    });
	  }
	  function mutateMap(map2, newMap, options) {
	    mutateMapSkippingNewValues(map2, newMap, options);
	    const { createNewValue } = options;
	    newMap == null ? void 0 : newMap.forEach((valueInNewMap, key) => {
	      if (!map2.has(key)) {
	        map2.set(key, createNewValue(key, valueInNewMap));
	      }
	    });
	  }
	  function isAbstractConstructorSymbol(symbol) {
	    if (symbol.flags & 32 /* Class */) {
	      const declaration = getClassLikeDeclarationOfSymbol(symbol);
	      return !!declaration && hasSyntacticModifier(declaration, 64 /* Abstract */);
	    }
	    return false;
	  }
	  function getClassLikeDeclarationOfSymbol(symbol) {
	    var _a;
	    return (_a = symbol.declarations) == null ? void 0 : _a.find(isClassLike);
	  }
	  function getObjectFlags(type) {
	    return type.flags & 3899393 /* ObjectFlagsType */ ? type.objectFlags : 0;
	  }
	  function forSomeAncestorDirectory(directory, callback) {
	    return !!forEachAncestorDirectory(directory, (d) => callback(d) ? true : void 0);
	  }
	  function isUMDExportSymbol(symbol) {
	    return !!symbol && !!symbol.declarations && !!symbol.declarations[0] && isNamespaceExportDeclaration(symbol.declarations[0]);
	  }
	  function showModuleSpecifier({ moduleSpecifier }) {
	    return isStringLiteral(moduleSpecifier) ? moduleSpecifier.text : getTextOfNode(moduleSpecifier);
	  }
	  function getLastChild(node) {
	    let lastChild;
	    forEachChild(node, (child) => {
	      if (nodeIsPresent(child))
	        lastChild = child;
	    }, (children) => {
	      for (let i = children.length - 1; i >= 0; i--) {
	        if (nodeIsPresent(children[i])) {
	          lastChild = children[i];
	          break;
	        }
	      }
	    });
	    return lastChild;
	  }
	  function addToSeen(seen, key, value = true) {
	    if (seen.has(key)) {
	      return false;
	    }
	    seen.set(key, value);
	    return true;
	  }
	  function isObjectTypeDeclaration(node) {
	    return isClassLike(node) || isInterfaceDeclaration(node) || isTypeLiteralNode(node);
	  }
	  function isTypeNodeKind(kind) {
	    return kind >= 182 /* FirstTypeNode */ && kind <= 205 /* LastTypeNode */ || kind === 133 /* AnyKeyword */ || kind === 159 /* UnknownKeyword */ || kind === 150 /* NumberKeyword */ || kind === 163 /* BigIntKeyword */ || kind === 151 /* ObjectKeyword */ || kind === 136 /* BooleanKeyword */ || kind === 154 /* StringKeyword */ || kind === 155 /* SymbolKeyword */ || kind === 116 /* VoidKeyword */ || kind === 157 /* UndefinedKeyword */ || kind === 146 /* NeverKeyword */ || kind === 141 /* IntrinsicKeyword */ || kind === 233 /* ExpressionWithTypeArguments */ || kind === 319 /* JSDocAllType */ || kind === 320 /* JSDocUnknownType */ || kind === 321 /* JSDocNullableType */ || kind === 322 /* JSDocNonNullableType */ || kind === 323 /* JSDocOptionalType */ || kind === 324 /* JSDocFunctionType */ || kind === 325 /* JSDocVariadicType */;
	  }
	  function isAccessExpression(node) {
	    return node.kind === 211 /* PropertyAccessExpression */ || node.kind === 212 /* ElementAccessExpression */;
	  }
	  function getNameOfAccessExpression(node) {
	    if (node.kind === 211 /* PropertyAccessExpression */) {
	      return node.name;
	    }
	    Debug.assert(node.kind === 212 /* ElementAccessExpression */);
	    return node.argumentExpression;
	  }
	  function isBundleFileTextLike(section) {
	    switch (section.kind) {
	      case "text" /* Text */:
	      case "internal" /* Internal */:
	        return true;
	      default:
	        return false;
	    }
	  }
	  function isNamedImportsOrExports(node) {
	    return node.kind === 275 /* NamedImports */ || node.kind === 279 /* NamedExports */;
	  }
	  function getLeftmostAccessExpression(expr) {
	    while (isAccessExpression(expr)) {
	      expr = expr.expression;
	    }
	    return expr;
	  }
	  function forEachNameInAccessChainWalkingLeft(name, action) {
	    if (isAccessExpression(name.parent) && isRightSideOfAccessExpression(name)) {
	      return walkAccessExpression(name.parent);
	    }
	    function walkAccessExpression(access) {
	      if (access.kind === 211 /* PropertyAccessExpression */) {
	        const res = action(access.name);
	        if (res !== void 0) {
	          return res;
	        }
	      } else if (access.kind === 212 /* ElementAccessExpression */) {
	        if (isIdentifier(access.argumentExpression) || isStringLiteralLike(access.argumentExpression)) {
	          const res = action(access.argumentExpression);
	          if (res !== void 0) {
	            return res;
	          }
	        } else {
	          return void 0;
	        }
	      }
	      if (isAccessExpression(access.expression)) {
	        return walkAccessExpression(access.expression);
	      }
	      if (isIdentifier(access.expression)) {
	        return action(access.expression);
	      }
	      return void 0;
	    }
	  }
	  function getLeftmostExpression(node, stopAtCallExpressions) {
	    while (true) {
	      switch (node.kind) {
	        case 225 /* PostfixUnaryExpression */:
	          node = node.operand;
	          continue;
	        case 226 /* BinaryExpression */:
	          node = node.left;
	          continue;
	        case 227 /* ConditionalExpression */:
	          node = node.condition;
	          continue;
	        case 215 /* TaggedTemplateExpression */:
	          node = node.tag;
	          continue;
	        case 213 /* CallExpression */:
	          if (stopAtCallExpressions) {
	            return node;
	          }
	        case 234 /* AsExpression */:
	        case 212 /* ElementAccessExpression */:
	        case 211 /* PropertyAccessExpression */:
	        case 235 /* NonNullExpression */:
	        case 360 /* PartiallyEmittedExpression */:
	        case 238 /* SatisfiesExpression */:
	          node = node.expression;
	          continue;
	      }
	      return node;
	    }
	  }
	  function Symbol4(flags, name) {
	    this.flags = flags;
	    this.escapedName = name;
	    this.declarations = void 0;
	    this.valueDeclaration = void 0;
	    this.id = 0;
	    this.mergeId = 0;
	    this.parent = void 0;
	    this.members = void 0;
	    this.exports = void 0;
	    this.exportSymbol = void 0;
	    this.constEnumOnlyModule = void 0;
	    this.isReferenced = void 0;
	    this.lastAssignmentPos = void 0;
	    this.links = void 0;
	  }
	  function Type3(checker, flags) {
	    this.flags = flags;
	    if (Debug.isDebugging || tracing) {
	      this.checker = checker;
	    }
	  }
	  function Signature2(checker, flags) {
	    this.flags = flags;
	    if (Debug.isDebugging) {
	      this.checker = checker;
	    }
	  }
	  function Node4(kind, pos, end) {
	    this.pos = pos;
	    this.end = end;
	    this.kind = kind;
	    this.id = 0;
	    this.flags = 0 /* None */;
	    this.modifierFlagsCache = 0 /* None */;
	    this.transformFlags = 0 /* None */;
	    this.parent = void 0;
	    this.original = void 0;
	    this.emitNode = void 0;
	  }
	  function Token(kind, pos, end) {
	    this.pos = pos;
	    this.end = end;
	    this.kind = kind;
	    this.id = 0;
	    this.flags = 0 /* None */;
	    this.transformFlags = 0 /* None */;
	    this.parent = void 0;
	    this.emitNode = void 0;
	  }
	  function Identifier2(kind, pos, end) {
	    this.pos = pos;
	    this.end = end;
	    this.kind = kind;
	    this.id = 0;
	    this.flags = 0 /* None */;
	    this.transformFlags = 0 /* None */;
	    this.parent = void 0;
	    this.original = void 0;
	    this.emitNode = void 0;
	  }
	  function SourceMapSource(fileName, text, skipTrivia2) {
	    this.fileName = fileName;
	    this.text = text;
	    this.skipTrivia = skipTrivia2 || ((pos) => pos);
	  }
	  function addObjectAllocatorPatcher(fn) {
	    objectAllocatorPatchers.push(fn);
	    fn(objectAllocator);
	  }
	  function setObjectAllocator(alloc) {
	    Object.assign(objectAllocator, alloc);
	    forEach(objectAllocatorPatchers, (fn) => fn(objectAllocator));
	  }
	  function formatStringFromArgs(text, args) {
	    return text.replace(/{(\d+)}/g, (_match, index) => "" + Debug.checkDefined(args[+index]));
	  }
	  function setLocalizedDiagnosticMessages(messages) {
	    localizedDiagnosticMessages = messages;
	  }
	  function maybeSetLocalizedDiagnosticMessages(getMessages) {
	    if (!localizedDiagnosticMessages && getMessages) {
	      localizedDiagnosticMessages = getMessages();
	    }
	  }
	  function getLocaleSpecificMessage(message) {
	    return localizedDiagnosticMessages && localizedDiagnosticMessages[message.key] || message.message;
	  }
	  function createDetachedDiagnostic(fileName, sourceText, start, length2, message, ...args) {
	    if (start + length2 > sourceText.length) {
	      length2 = sourceText.length - start;
	    }
	    assertDiagnosticLocation(sourceText, start, length2);
	    let text = getLocaleSpecificMessage(message);
	    if (some(args)) {
	      text = formatStringFromArgs(text, args);
	    }
	    return {
	      file: void 0,
	      start,
	      length: length2,
	      messageText: text,
	      category: message.category,
	      code: message.code,
	      reportsUnnecessary: message.reportsUnnecessary,
	      fileName
	    };
	  }
	  function isDiagnosticWithDetachedLocation(diagnostic) {
	    return diagnostic.file === void 0 && diagnostic.start !== void 0 && diagnostic.length !== void 0 && typeof diagnostic.fileName === "string";
	  }
	  function attachFileToDiagnostic(diagnostic, file) {
	    const fileName = file.fileName || "";
	    const length2 = file.text.length;
	    Debug.assertEqual(diagnostic.fileName, fileName);
	    Debug.assertLessThanOrEqual(diagnostic.start, length2);
	    Debug.assertLessThanOrEqual(diagnostic.start + diagnostic.length, length2);
	    const diagnosticWithLocation = {
	      file,
	      start: diagnostic.start,
	      length: diagnostic.length,
	      messageText: diagnostic.messageText,
	      category: diagnostic.category,
	      code: diagnostic.code,
	      reportsUnnecessary: diagnostic.reportsUnnecessary
	    };
	    if (diagnostic.relatedInformation) {
	      diagnosticWithLocation.relatedInformation = [];
	      for (const related of diagnostic.relatedInformation) {
	        if (isDiagnosticWithDetachedLocation(related) && related.fileName === fileName) {
	          Debug.assertLessThanOrEqual(related.start, length2);
	          Debug.assertLessThanOrEqual(related.start + related.length, length2);
	          diagnosticWithLocation.relatedInformation.push(attachFileToDiagnostic(related, file));
	        } else {
	          diagnosticWithLocation.relatedInformation.push(related);
	        }
	      }
	    }
	    return diagnosticWithLocation;
	  }
	  function attachFileToDiagnostics(diagnostics, file) {
	    const diagnosticsWithLocation = [];
	    for (const diagnostic of diagnostics) {
	      diagnosticsWithLocation.push(attachFileToDiagnostic(diagnostic, file));
	    }
	    return diagnosticsWithLocation;
	  }
	  function createFileDiagnostic(file, start, length2, message, ...args) {
	    assertDiagnosticLocation(file.text, start, length2);
	    let text = getLocaleSpecificMessage(message);
	    if (some(args)) {
	      text = formatStringFromArgs(text, args);
	    }
	    return {
	      file,
	      start,
	      length: length2,
	      messageText: text,
	      category: message.category,
	      code: message.code,
	      reportsUnnecessary: message.reportsUnnecessary,
	      reportsDeprecated: message.reportsDeprecated
	    };
	  }
	  function formatMessage(message, ...args) {
	    let text = getLocaleSpecificMessage(message);
	    if (some(args)) {
	      text = formatStringFromArgs(text, args);
	    }
	    return text;
	  }
	  function createCompilerDiagnostic(message, ...args) {
	    let text = getLocaleSpecificMessage(message);
	    if (some(args)) {
	      text = formatStringFromArgs(text, args);
	    }
	    return {
	      file: void 0,
	      start: void 0,
	      length: void 0,
	      messageText: text,
	      category: message.category,
	      code: message.code,
	      reportsUnnecessary: message.reportsUnnecessary,
	      reportsDeprecated: message.reportsDeprecated
	    };
	  }
	  function createCompilerDiagnosticFromMessageChain(chain, relatedInformation) {
	    return {
	      file: void 0,
	      start: void 0,
	      length: void 0,
	      code: chain.code,
	      category: chain.category,
	      messageText: chain.next ? chain : chain.messageText,
	      relatedInformation
	    };
	  }
	  function chainDiagnosticMessages(details, message, ...args) {
	    let text = getLocaleSpecificMessage(message);
	    if (some(args)) {
	      text = formatStringFromArgs(text, args);
	    }
	    return {
	      messageText: text,
	      category: message.category,
	      code: message.code,
	      next: details === void 0 || Array.isArray(details) ? details : [details]
	    };
	  }
	  function concatenateDiagnosticMessageChains(headChain, tailChain) {
	    let lastChain = headChain;
	    while (lastChain.next) {
	      lastChain = lastChain.next[0];
	    }
	    lastChain.next = [tailChain];
	  }
	  function getDiagnosticFilePath(diagnostic) {
	    return diagnostic.file ? diagnostic.file.path : void 0;
	  }
	  function compareDiagnostics(d1, d2) {
	    return compareDiagnosticsSkipRelatedInformation(d1, d2) || compareRelatedInformation(d1, d2) || 0 /* EqualTo */;
	  }
	  function compareDiagnosticsSkipRelatedInformation(d1, d2) {
	    return compareStringsCaseSensitive(getDiagnosticFilePath(d1), getDiagnosticFilePath(d2)) || compareValues(d1.start, d2.start) || compareValues(d1.length, d2.length) || compareValues(d1.code, d2.code) || compareMessageText(d1.messageText, d2.messageText) || 0 /* EqualTo */;
	  }
	  function compareRelatedInformation(d1, d2) {
	    if (!d1.relatedInformation && !d2.relatedInformation) {
	      return 0 /* EqualTo */;
	    }
	    if (d1.relatedInformation && d2.relatedInformation) {
	      return compareValues(d1.relatedInformation.length, d2.relatedInformation.length) || forEach(d1.relatedInformation, (d1i, index) => {
	        const d2i = d2.relatedInformation[index];
	        return compareDiagnostics(d1i, d2i);
	      }) || 0 /* EqualTo */;
	    }
	    return d1.relatedInformation ? -1 /* LessThan */ : 1 /* GreaterThan */;
	  }
	  function compareMessageText(t1, t2) {
	    if (typeof t1 === "string" && typeof t2 === "string") {
	      return compareStringsCaseSensitive(t1, t2);
	    } else if (typeof t1 === "string") {
	      return -1 /* LessThan */;
	    } else if (typeof t2 === "string") {
	      return 1 /* GreaterThan */;
	    }
	    let res = compareStringsCaseSensitive(t1.messageText, t2.messageText);
	    if (res) {
	      return res;
	    }
	    if (!t1.next && !t2.next) {
	      return 0 /* EqualTo */;
	    }
	    if (!t1.next) {
	      return -1 /* LessThan */;
	    }
	    if (!t2.next) {
	      return 1 /* GreaterThan */;
	    }
	    const len = Math.min(t1.next.length, t2.next.length);
	    for (let i = 0; i < len; i++) {
	      res = compareMessageText(t1.next[i], t2.next[i]);
	      if (res) {
	        return res;
	      }
	    }
	    if (t1.next.length < t2.next.length) {
	      return -1 /* LessThan */;
	    } else if (t1.next.length > t2.next.length) {
	      return 1 /* GreaterThan */;
	    }
	    return 0 /* EqualTo */;
	  }
	  function getLanguageVariant(scriptKind) {
	    return scriptKind === 4 /* TSX */ || scriptKind === 2 /* JSX */ || scriptKind === 1 /* JS */ || scriptKind === 6 /* JSON */ ? 1 /* JSX */ : 0 /* Standard */;
	  }
	  function walkTreeForJSXTags(node) {
	    if (!(node.transformFlags & 2 /* ContainsJsx */))
	      return void 0;
	    return isJsxOpeningLikeElement(node) || isJsxFragment(node) ? node : forEachChild(node, walkTreeForJSXTags);
	  }
	  function isFileModuleFromUsingJSXTag(file) {
	    return !file.isDeclarationFile ? walkTreeForJSXTags(file) : void 0;
	  }
	  function isFileForcedToBeModuleByFormat(file) {
	    return (file.impliedNodeFormat === 99 /* ESNext */ || fileExtensionIsOneOf(file.fileName, [".cjs" /* Cjs */, ".cts" /* Cts */, ".mjs" /* Mjs */, ".mts" /* Mts */])) && !file.isDeclarationFile ? true : void 0;
	  }
	  function getSetExternalModuleIndicator(options) {
	    switch (getEmitModuleDetectionKind(options)) {
	      case 3 /* Force */:
	        return (file) => {
	          file.externalModuleIndicator = isFileProbablyExternalModule(file) || !file.isDeclarationFile || void 0;
	        };
	      case 1 /* Legacy */:
	        return (file) => {
	          file.externalModuleIndicator = isFileProbablyExternalModule(file);
	        };
	      case 2 /* Auto */:
	        const checks = [isFileProbablyExternalModule];
	        if (options.jsx === 4 /* ReactJSX */ || options.jsx === 5 /* ReactJSXDev */) {
	          checks.push(isFileModuleFromUsingJSXTag);
	        }
	        checks.push(isFileForcedToBeModuleByFormat);
	        const combined = or(...checks);
	        const callback = (file) => void (file.externalModuleIndicator = combined(file));
	        return callback;
	    }
	  }
	  function createComputedCompilerOptions(options) {
	    return options;
	  }
	  function emitModuleKindIsNonNodeESM(moduleKind) {
	    return moduleKind >= 5 /* ES2015 */ && moduleKind <= 99 /* ESNext */;
	  }
	  function hasJsonModuleEmitEnabled(options) {
	    switch (getEmitModuleKind(options)) {
	      case 0 /* None */:
	      case 4 /* System */:
	      case 3 /* UMD */:
	        return false;
	    }
	    return true;
	  }
	  function importNameElisionDisabled(options) {
	    return options.verbatimModuleSyntax || options.isolatedModules && options.preserveValueImports;
	  }
	  function unreachableCodeIsError(options) {
	    return options.allowUnreachableCode === false;
	  }
	  function unusedLabelIsError(options) {
	    return options.allowUnusedLabels === false;
	  }
	  function moduleResolutionSupportsPackageJsonExportsAndImports(moduleResolution) {
	    return moduleResolution >= 3 /* Node16 */ && moduleResolution <= 99 /* NodeNext */ || moduleResolution === 100 /* Bundler */;
	  }
	  function getStrictOptionValue(compilerOptions, flag) {
	    return compilerOptions[flag] === void 0 ? !!compilerOptions.strict : !!compilerOptions[flag];
	  }
	  function getEmitStandardClassFields(compilerOptions) {
	    return compilerOptions.useDefineForClassFields !== false && getEmitScriptTarget(compilerOptions) >= 9 /* ES2022 */;
	  }
	  function compilerOptionsAffectSemanticDiagnostics(newOptions, oldOptions) {
	    return optionsHaveChanges(oldOptions, newOptions, semanticDiagnosticsOptionDeclarations);
	  }
	  function compilerOptionsAffectEmit(newOptions, oldOptions) {
	    return optionsHaveChanges(oldOptions, newOptions, affectsEmitOptionDeclarations);
	  }
	  function compilerOptionsAffectDeclarationPath(newOptions, oldOptions) {
	    return optionsHaveChanges(oldOptions, newOptions, affectsDeclarationPathOptionDeclarations);
	  }
	  function getCompilerOptionValue(options, option) {
	    return option.strictFlag ? getStrictOptionValue(options, option.name) : option.allowJsFlag ? getAllowJSCompilerOption(options) : options[option.name];
	  }
	  function getJSXTransformEnabled(options) {
	    const jsx = options.jsx;
	    return jsx === 2 /* React */ || jsx === 4 /* ReactJSX */ || jsx === 5 /* ReactJSXDev */;
	  }
	  function getJSXImplicitImportBase(compilerOptions, file) {
	    const jsxImportSourcePragmas = file == null ? void 0 : file.pragmas.get("jsximportsource");
	    const jsxImportSourcePragma = isArray(jsxImportSourcePragmas) ? jsxImportSourcePragmas[jsxImportSourcePragmas.length - 1] : jsxImportSourcePragmas;
	    return compilerOptions.jsx === 4 /* ReactJSX */ || compilerOptions.jsx === 5 /* ReactJSXDev */ || compilerOptions.jsxImportSource || jsxImportSourcePragma ? (jsxImportSourcePragma == null ? void 0 : jsxImportSourcePragma.arguments.factory) || compilerOptions.jsxImportSource || "react" : void 0;
	  }
	  function getJSXRuntimeImport(base, options) {
	    return base ? `${base}/${options.jsx === 5 /* ReactJSXDev */ ? "jsx-dev-runtime" : "jsx-runtime"}` : void 0;
	  }
	  function hasZeroOrOneAsteriskCharacter(str) {
	    let seenAsterisk = false;
	    for (let i = 0; i < str.length; i++) {
	      if (str.charCodeAt(i) === 42 /* asterisk */) {
	        if (!seenAsterisk) {
	          seenAsterisk = true;
	        } else {
	          return false;
	        }
	      }
	    }
	    return true;
	  }
	  function createSymlinkCache(cwd, getCanonicalFileName) {
	    let symlinkedDirectories;
	    let symlinkedDirectoriesByRealpath;
	    let symlinkedFiles;
	    let hasProcessedResolutions = false;
	    return {
	      getSymlinkedFiles: () => symlinkedFiles,
	      getSymlinkedDirectories: () => symlinkedDirectories,
	      getSymlinkedDirectoriesByRealpath: () => symlinkedDirectoriesByRealpath,
	      setSymlinkedFile: (path, real) => (symlinkedFiles || (symlinkedFiles = /* @__PURE__ */ new Map())).set(path, real),
	      setSymlinkedDirectory: (symlink, real) => {
	        let symlinkPath = toPath(symlink, cwd, getCanonicalFileName);
	        if (!containsIgnoredPath(symlinkPath)) {
	          symlinkPath = ensureTrailingDirectorySeparator(symlinkPath);
	          if (real !== false && !(symlinkedDirectories == null ? void 0 : symlinkedDirectories.has(symlinkPath))) {
	            (symlinkedDirectoriesByRealpath || (symlinkedDirectoriesByRealpath = createMultiMap())).add(real.realPath, symlink);
	          }
	          (symlinkedDirectories || (symlinkedDirectories = /* @__PURE__ */ new Map())).set(symlinkPath, real);
	        }
	      },
	      setSymlinksFromResolutions(forEachResolvedModule, forEachResolvedTypeReferenceDirective, typeReferenceDirectives) {
	        Debug.assert(!hasProcessedResolutions);
	        hasProcessedResolutions = true;
	        forEachResolvedModule((resolution) => processResolution(this, resolution.resolvedModule));
	        forEachResolvedTypeReferenceDirective((resolution) => processResolution(this, resolution.resolvedTypeReferenceDirective));
	        typeReferenceDirectives.forEach((resolution) => processResolution(this, resolution.resolvedTypeReferenceDirective));
	      },
	      hasProcessedResolutions: () => hasProcessedResolutions
	    };
	    function processResolution(cache, resolution) {
	      if (!resolution || !resolution.originalPath || !resolution.resolvedFileName)
	        return;
	      const { resolvedFileName, originalPath } = resolution;
	      cache.setSymlinkedFile(toPath(originalPath, cwd, getCanonicalFileName), resolvedFileName);
	      const [commonResolved, commonOriginal] = guessDirectorySymlink(resolvedFileName, originalPath, cwd, getCanonicalFileName) || emptyArray;
	      if (commonResolved && commonOriginal) {
	        cache.setSymlinkedDirectory(
	          commonOriginal,
	          {
	            real: ensureTrailingDirectorySeparator(commonResolved),
	            realPath: ensureTrailingDirectorySeparator(toPath(commonResolved, cwd, getCanonicalFileName))
	          }
	        );
	      }
	    }
	  }
	  function guessDirectorySymlink(a, b, cwd, getCanonicalFileName) {
	    const aParts = getPathComponents(getNormalizedAbsolutePath(a, cwd));
	    const bParts = getPathComponents(getNormalizedAbsolutePath(b, cwd));
	    let isDirectory = false;
	    while (aParts.length >= 2 && bParts.length >= 2 && !isNodeModulesOrScopedPackageDirectory(aParts[aParts.length - 2], getCanonicalFileName) && !isNodeModulesOrScopedPackageDirectory(bParts[bParts.length - 2], getCanonicalFileName) && getCanonicalFileName(aParts[aParts.length - 1]) === getCanonicalFileName(bParts[bParts.length - 1])) {
	      aParts.pop();
	      bParts.pop();
	      isDirectory = true;
	    }
	    return isDirectory ? [getPathFromPathComponents(aParts), getPathFromPathComponents(bParts)] : void 0;
	  }
	  function isNodeModulesOrScopedPackageDirectory(s, getCanonicalFileName) {
	    return s !== void 0 && (getCanonicalFileName(s) === "node_modules" || startsWith(s, "@"));
	  }
	  function stripLeadingDirectorySeparator(s) {
	    return isAnyDirectorySeparator(s.charCodeAt(0)) ? s.slice(1) : void 0;
	  }
	  function tryRemoveDirectoryPrefix(path, dirPath, getCanonicalFileName) {
	    const withoutPrefix = tryRemovePrefix(path, dirPath, getCanonicalFileName);
	    return withoutPrefix === void 0 ? void 0 : stripLeadingDirectorySeparator(withoutPrefix);
	  }
	  function regExpEscape(text) {
	    return text.replace(reservedCharacterPattern, escapeRegExpCharacter);
	  }
	  function escapeRegExpCharacter(match) {
	    return "\\" + match;
	  }
	  function getRegularExpressionForWildcard(specs, basePath, usage) {
	    const patterns = getRegularExpressionsForWildcards(specs, basePath, usage);
	    if (!patterns || !patterns.length) {
	      return void 0;
	    }
	    const pattern = patterns.map((pattern2) => `(${pattern2})`).join("|");
	    const terminator = usage === "exclude" ? "($|/)" : "$";
	    return `^(${pattern})${terminator}`;
	  }
	  function getRegularExpressionsForWildcards(specs, basePath, usage) {
	    if (specs === void 0 || specs.length === 0) {
	      return void 0;
	    }
	    return flatMap(specs, (spec) => spec && getSubPatternFromSpec(spec, basePath, usage, wildcardMatchers[usage]));
	  }
	  function isImplicitGlob(lastPathComponent) {
	    return !/[.*?]/.test(lastPathComponent);
	  }
	  function getPatternFromSpec(spec, basePath, usage) {
	    const pattern = spec && getSubPatternFromSpec(spec, basePath, usage, wildcardMatchers[usage]);
	    return pattern && `^(${pattern})${usage === "exclude" ? "($|/)" : "$"}`;
	  }
	  function getSubPatternFromSpec(spec, basePath, usage, { singleAsteriskRegexFragment, doubleAsteriskRegexFragment, replaceWildcardCharacter: replaceWildcardCharacter2 } = wildcardMatchers[usage]) {
	    let subpattern = "";
	    let hasWrittenComponent = false;
	    const components = getNormalizedPathComponents(spec, basePath);
	    const lastComponent = last(components);
	    if (usage !== "exclude" && lastComponent === "**") {
	      return void 0;
	    }
	    components[0] = removeTrailingDirectorySeparator(components[0]);
	    if (isImplicitGlob(lastComponent)) {
	      components.push("**", "*");
	    }
	    let optionalCount = 0;
	    for (let component of components) {
	      if (component === "**") {
	        subpattern += doubleAsteriskRegexFragment;
	      } else {
	        if (usage === "directories") {
	          subpattern += "(";
	          optionalCount++;
	        }
	        if (hasWrittenComponent) {
	          subpattern += directorySeparator;
	        }
	        if (usage !== "exclude") {
	          let componentPattern = "";
	          if (component.charCodeAt(0) === 42 /* asterisk */) {
	            componentPattern += "([^./]" + singleAsteriskRegexFragment + ")?";
	            component = component.substr(1);
	          } else if (component.charCodeAt(0) === 63 /* question */) {
	            componentPattern += "[^./]";
	            component = component.substr(1);
	          }
	          componentPattern += component.replace(reservedCharacterPattern, replaceWildcardCharacter2);
	          if (componentPattern !== component) {
	            subpattern += implicitExcludePathRegexPattern;
	          }
	          subpattern += componentPattern;
	        } else {
	          subpattern += component.replace(reservedCharacterPattern, replaceWildcardCharacter2);
	        }
	      }
	      hasWrittenComponent = true;
	    }
	    while (optionalCount > 0) {
	      subpattern += ")?";
	      optionalCount--;
	    }
	    return subpattern;
	  }
	  function replaceWildcardCharacter(match, singleAsteriskRegexFragment) {
	    return match === "*" ? singleAsteriskRegexFragment : match === "?" ? "[^/]" : "\\" + match;
	  }
	  function getFileMatcherPatterns(path, excludes, includes, useCaseSensitiveFileNames2, currentDirectory) {
	    path = normalizePath(path);
	    currentDirectory = normalizePath(currentDirectory);
	    const absolutePath = combinePaths(currentDirectory, path);
	    return {
	      includeFilePatterns: map(getRegularExpressionsForWildcards(includes, absolutePath, "files"), (pattern) => `^${pattern}$`),
	      includeFilePattern: getRegularExpressionForWildcard(includes, absolutePath, "files"),
	      includeDirectoryPattern: getRegularExpressionForWildcard(includes, absolutePath, "directories"),
	      excludePattern: getRegularExpressionForWildcard(excludes, absolutePath, "exclude"),
	      basePaths: getBasePaths(path, includes, useCaseSensitiveFileNames2)
	    };
	  }
	  function getRegexFromPattern(pattern, useCaseSensitiveFileNames2) {
	    return new RegExp(pattern, useCaseSensitiveFileNames2 ? "" : "i");
	  }
	  function matchFiles(path, extensions, excludes, includes, useCaseSensitiveFileNames2, currentDirectory, depth, getFileSystemEntries, realpath) {
	    path = normalizePath(path);
	    currentDirectory = normalizePath(currentDirectory);
	    const patterns = getFileMatcherPatterns(path, excludes, includes, useCaseSensitiveFileNames2, currentDirectory);
	    const includeFileRegexes = patterns.includeFilePatterns && patterns.includeFilePatterns.map((pattern) => getRegexFromPattern(pattern, useCaseSensitiveFileNames2));
	    const includeDirectoryRegex = patterns.includeDirectoryPattern && getRegexFromPattern(patterns.includeDirectoryPattern, useCaseSensitiveFileNames2);
	    const excludeRegex = patterns.excludePattern && getRegexFromPattern(patterns.excludePattern, useCaseSensitiveFileNames2);
	    const results = includeFileRegexes ? includeFileRegexes.map(() => []) : [[]];
	    const visited = /* @__PURE__ */ new Map();
	    const toCanonical = createGetCanonicalFileName(useCaseSensitiveFileNames2);
	    for (const basePath of patterns.basePaths) {
	      visitDirectory(basePath, combinePaths(currentDirectory, basePath), depth);
	    }
	    return flatten(results);
	    function visitDirectory(path2, absolutePath, depth2) {
	      const canonicalPath = toCanonical(realpath(absolutePath));
	      if (visited.has(canonicalPath))
	        return;
	      visited.set(canonicalPath, true);
	      const { files, directories } = getFileSystemEntries(path2);
	      for (const current of sort(files, compareStringsCaseSensitive)) {
	        const name = combinePaths(path2, current);
	        const absoluteName = combinePaths(absolutePath, current);
	        if (extensions && !fileExtensionIsOneOf(name, extensions))
	          continue;
	        if (excludeRegex && excludeRegex.test(absoluteName))
	          continue;
	        if (!includeFileRegexes) {
	          results[0].push(name);
	        } else {
	          const includeIndex = findIndex(includeFileRegexes, (re) => re.test(absoluteName));
	          if (includeIndex !== -1) {
	            results[includeIndex].push(name);
	          }
	        }
	      }
	      if (depth2 !== void 0) {
	        depth2--;
	        if (depth2 === 0) {
	          return;
	        }
	      }
	      for (const current of sort(directories, compareStringsCaseSensitive)) {
	        const name = combinePaths(path2, current);
	        const absoluteName = combinePaths(absolutePath, current);
	        if ((!includeDirectoryRegex || includeDirectoryRegex.test(absoluteName)) && (!excludeRegex || !excludeRegex.test(absoluteName))) {
	          visitDirectory(name, absoluteName, depth2);
	        }
	      }
	    }
	  }
	  function getBasePaths(path, includes, useCaseSensitiveFileNames2) {
	    const basePaths = [path];
	    if (includes) {
	      const includeBasePaths = [];
	      for (const include of includes) {
	        const absolute = isRootedDiskPath(include) ? include : normalizePath(combinePaths(path, include));
	        includeBasePaths.push(getIncludeBasePath(absolute));
	      }
	      includeBasePaths.sort(getStringComparer(!useCaseSensitiveFileNames2));
	      for (const includeBasePath of includeBasePaths) {
	        if (every(basePaths, (basePath) => !containsPath(basePath, includeBasePath, path, !useCaseSensitiveFileNames2))) {
	          basePaths.push(includeBasePath);
	        }
	      }
	    }
	    return basePaths;
	  }
	  function getIncludeBasePath(absolute) {
	    const wildcardOffset = indexOfAnyCharCode(absolute, wildcardCharCodes);
	    if (wildcardOffset < 0) {
	      return !hasExtension(absolute) ? absolute : removeTrailingDirectorySeparator(getDirectoryPath(absolute));
	    }
	    return absolute.substring(0, absolute.lastIndexOf(directorySeparator, wildcardOffset));
	  }
	  function ensureScriptKind(fileName, scriptKind) {
	    return scriptKind || getScriptKindFromFileName(fileName) || 3 /* TS */;
	  }
	  function getScriptKindFromFileName(fileName) {
	    const ext = fileName.substr(fileName.lastIndexOf("."));
	    switch (ext.toLowerCase()) {
	      case ".js" /* Js */:
	      case ".cjs" /* Cjs */:
	      case ".mjs" /* Mjs */:
	        return 1 /* JS */;
	      case ".jsx" /* Jsx */:
	        return 2 /* JSX */;
	      case ".ts" /* Ts */:
	      case ".cts" /* Cts */:
	      case ".mts" /* Mts */:
	        return 3 /* TS */;
	      case ".tsx" /* Tsx */:
	        return 4 /* TSX */;
	      case ".json" /* Json */:
	        return 6 /* JSON */;
	      default:
	        return 0 /* Unknown */;
	    }
	  }
	  function getSupportedExtensions(options, extraFileExtensions) {
	    const needJsExtensions = options && getAllowJSCompilerOption(options);
	    if (!extraFileExtensions || extraFileExtensions.length === 0) {
	      return needJsExtensions ? allSupportedExtensions : supportedTSExtensions;
	    }
	    const builtins = needJsExtensions ? allSupportedExtensions : supportedTSExtensions;
	    const flatBuiltins = flatten(builtins);
	    const extensions = [
	      ...builtins,
	      ...mapDefined(extraFileExtensions, (x) => x.scriptKind === 7 /* Deferred */ || needJsExtensions && isJSLike(x.scriptKind) && !flatBuiltins.includes(x.extension) ? [x.extension] : void 0)
	    ];
	    return extensions;
	  }
	  function getSupportedExtensionsWithJsonIfResolveJsonModule(options, supportedExtensions) {
	    if (!options || !getResolveJsonModule(options))
	      return supportedExtensions;
	    if (supportedExtensions === allSupportedExtensions)
	      return allSupportedExtensionsWithJson;
	    if (supportedExtensions === supportedTSExtensions)
	      return supportedTSExtensionsWithJson;
	    return [...supportedExtensions, [".json" /* Json */]];
	  }
	  function isJSLike(scriptKind) {
	    return scriptKind === 1 /* JS */ || scriptKind === 2 /* JSX */;
	  }
	  function hasJSFileExtension(fileName) {
	    return some(supportedJSExtensionsFlat, (extension) => fileExtensionIs(fileName, extension));
	  }
	  function hasTSFileExtension(fileName) {
	    return some(supportedTSExtensionsFlat, (extension) => fileExtensionIs(fileName, extension));
	  }
	  function usesExtensionsOnImports({ imports }, hasExtension2 = or(hasJSFileExtension, hasTSFileExtension)) {
	    return firstDefined(imports, ({ text }) => pathIsRelative(text) && !fileExtensionIsOneOf(text, extensionsNotSupportingExtensionlessResolution) ? hasExtension2(text) : void 0) || false;
	  }
	  function getModuleSpecifierEndingPreference(preference, resolutionMode, compilerOptions, sourceFile) {
	    const moduleResolution = getEmitModuleResolutionKind(compilerOptions);
	    const moduleResolutionIsNodeNext = 3 /* Node16 */ <= moduleResolution && moduleResolution <= 99 /* NodeNext */;
	    if (preference === "js" || resolutionMode === 99 /* ESNext */ && moduleResolutionIsNodeNext) {
	      if (!shouldAllowImportingTsExtension(compilerOptions)) {
	        return 2 /* JsExtension */;
	      }
	      return inferPreference() !== 2 /* JsExtension */ ? 3 /* TsExtension */ : 2 /* JsExtension */;
	    }
	    if (preference === "minimal") {
	      return 0 /* Minimal */;
	    }
	    if (preference === "index") {
	      return 1 /* Index */;
	    }
	    if (!shouldAllowImportingTsExtension(compilerOptions)) {
	      return usesExtensionsOnImports(sourceFile) ? 2 /* JsExtension */ : 0 /* Minimal */;
	    }
	    return inferPreference();
	    function inferPreference() {
	      let usesJsExtensions = false;
	      const specifiers = sourceFile.imports.length ? sourceFile.imports : isSourceFileJS(sourceFile) ? getRequiresAtTopOfFile(sourceFile).map((r) => r.arguments[0]) : emptyArray;
	      for (const specifier of specifiers) {
	        if (pathIsRelative(specifier.text)) {
	          if (moduleResolutionIsNodeNext && resolutionMode === 1 /* CommonJS */ && getModeForUsageLocation(sourceFile, specifier, compilerOptions) === 99 /* ESNext */) {
	            continue;
	          }
	          if (fileExtensionIsOneOf(specifier.text, extensionsNotSupportingExtensionlessResolution)) {
	            continue;
	          }
	          if (hasTSFileExtension(specifier.text)) {
	            return 3 /* TsExtension */;
	          }
	          if (hasJSFileExtension(specifier.text)) {
	            usesJsExtensions = true;
	          }
	        }
	      }
	      return usesJsExtensions ? 2 /* JsExtension */ : 0 /* Minimal */;
	    }
	  }
	  function getRequiresAtTopOfFile(sourceFile) {
	    let nonRequireStatementCount = 0;
	    let requires;
	    for (const statement of sourceFile.statements) {
	      if (nonRequireStatementCount > 3) {
	        break;
	      }
	      if (isRequireVariableStatement(statement)) {
	        requires = concatenate(requires, statement.declarationList.declarations.map((d) => d.initializer));
	      } else if (isExpressionStatement(statement) && isRequireCall(
	        statement.expression,
	        /*requireStringLiteralLikeArgument*/
	        true
	      )) {
	        requires = append(requires, statement.expression);
	      } else {
	        nonRequireStatementCount++;
	      }
	    }
	    return requires || emptyArray;
	  }
	  function isSupportedSourceFileName(fileName, compilerOptions, extraFileExtensions) {
	    if (!fileName)
	      return false;
	    const supportedExtensions = getSupportedExtensions(compilerOptions, extraFileExtensions);
	    for (const extension of flatten(getSupportedExtensionsWithJsonIfResolveJsonModule(compilerOptions, supportedExtensions))) {
	      if (fileExtensionIs(fileName, extension)) {
	        return true;
	      }
	    }
	    return false;
	  }
	  function numberOfDirectorySeparators(str) {
	    const match = str.match(/\//g);
	    return match ? match.length : 0;
	  }
	  function compareNumberOfDirectorySeparators(path1, path2) {
	    return compareValues(
	      numberOfDirectorySeparators(path1),
	      numberOfDirectorySeparators(path2)
	    );
	  }
	  function removeFileExtension(path) {
	    for (const ext of extensionsToRemove) {
	      const extensionless = tryRemoveExtension(path, ext);
	      if (extensionless !== void 0) {
	        return extensionless;
	      }
	    }
	    return path;
	  }
	  function tryRemoveExtension(path, extension) {
	    return fileExtensionIs(path, extension) ? removeExtension(path, extension) : void 0;
	  }
	  function removeExtension(path, extension) {
	    return path.substring(0, path.length - extension.length);
	  }
	  function changeExtension(path, newExtension) {
	    return changeAnyExtension(
	      path,
	      newExtension,
	      extensionsToRemove,
	      /*ignoreCase*/
	      false
	    );
	  }
	  function tryParsePattern(pattern) {
	    const indexOfStar = pattern.indexOf("*");
	    if (indexOfStar === -1) {
	      return pattern;
	    }
	    return pattern.indexOf("*", indexOfStar + 1) !== -1 ? void 0 : {
	      prefix: pattern.substr(0, indexOfStar),
	      suffix: pattern.substr(indexOfStar + 1)
	    };
	  }
	  function tryParsePatterns(paths) {
	    return mapDefined(getOwnKeys(paths), (path) => tryParsePattern(path));
	  }
	  function positionIsSynthesized(pos) {
	    return !(pos >= 0);
	  }
	  function extensionIsTS(ext) {
	    return ext === ".ts" /* Ts */ || ext === ".tsx" /* Tsx */ || ext === ".d.ts" /* Dts */ || ext === ".cts" /* Cts */ || ext === ".mts" /* Mts */ || ext === ".d.mts" /* Dmts */ || ext === ".d.cts" /* Dcts */ || startsWith(ext, ".d.") && endsWith(ext, ".ts");
	  }
	  function resolutionExtensionIsTSOrJson(ext) {
	    return extensionIsTS(ext) || ext === ".json" /* Json */;
	  }
	  function extensionFromPath(path) {
	    const ext = tryGetExtensionFromPath2(path);
	    return ext !== void 0 ? ext : Debug.fail(`File ${path} has unknown extension.`);
	  }
	  function isAnySupportedFileExtension(path) {
	    return tryGetExtensionFromPath2(path) !== void 0;
	  }
	  function tryGetExtensionFromPath2(path) {
	    return find(extensionsToRemove, (e) => fileExtensionIs(path, e));
	  }
	  function isCheckJsEnabledForFile(sourceFile, compilerOptions) {
	    return sourceFile.checkJsDirective ? sourceFile.checkJsDirective.enabled : compilerOptions.checkJs;
	  }
	  function matchPatternOrExact(patternOrStrings, candidate) {
	    const patterns = [];
	    for (const patternOrString of patternOrStrings) {
	      if (patternOrString === candidate) {
	        return candidate;
	      }
	      if (!isString(patternOrString)) {
	        patterns.push(patternOrString);
	      }
	    }
	    return findBestPatternMatch(patterns, (_) => _, candidate);
	  }
	  function sliceAfter(arr, value) {
	    const index = arr.indexOf(value);
	    Debug.assert(index !== -1);
	    return arr.slice(index);
	  }
	  function addRelatedInfo(diagnostic, ...relatedInformation) {
	    if (!relatedInformation.length) {
	      return diagnostic;
	    }
	    if (!diagnostic.relatedInformation) {
	      diagnostic.relatedInformation = [];
	    }
	    Debug.assert(diagnostic.relatedInformation !== emptyArray, "Diagnostic had empty array singleton for related info, but is still being constructed!");
	    diagnostic.relatedInformation.push(...relatedInformation);
	    return diagnostic;
	  }
	  function minAndMax(arr, getValue) {
	    Debug.assert(arr.length !== 0);
	    let min2 = getValue(arr[0]);
	    let max = min2;
	    for (let i = 1; i < arr.length; i++) {
	      const value = getValue(arr[i]);
	      if (value < min2) {
	        min2 = value;
	      } else if (value > max) {
	        max = value;
	      }
	    }
	    return { min: min2, max };
	  }
	  function rangeOfNode(node) {
	    return { pos: getTokenPosOfNode(node), end: node.end };
	  }
	  function rangeOfTypeParameters(sourceFile, typeParameters) {
	    const pos = typeParameters.pos - 1;
	    const end = Math.min(sourceFile.text.length, skipTrivia(sourceFile.text, typeParameters.end) + 1);
	    return { pos, end };
	  }
	  function skipTypeChecking(sourceFile, options, host) {
	    return options.skipLibCheck && sourceFile.isDeclarationFile || options.skipDefaultLibCheck && sourceFile.hasNoDefaultLib || host.isSourceOfProjectReferenceRedirect(sourceFile.fileName);
	  }
	  function isJsonEqual(a, b) {
	    return a === b || typeof a === "object" && a !== null && typeof b === "object" && b !== null && equalOwnProperties(a, b, isJsonEqual);
	  }
	  function parsePseudoBigInt(stringValue) {
	    let log2Base;
	    switch (stringValue.charCodeAt(1)) {
	      case 98 /* b */:
	      case 66 /* B */:
	        log2Base = 1;
	        break;
	      case 111 /* o */:
	      case 79 /* O */:
	        log2Base = 3;
	        break;
	      case 120 /* x */:
	      case 88 /* X */:
	        log2Base = 4;
	        break;
	      default:
	        const nIndex = stringValue.length - 1;
	        let nonZeroStart = 0;
	        while (stringValue.charCodeAt(nonZeroStart) === 48 /* _0 */) {
	          nonZeroStart++;
	        }
	        return stringValue.slice(nonZeroStart, nIndex) || "0";
	    }
	    const startIndex = 2, endIndex = stringValue.length - 1;
	    const bitsNeeded = (endIndex - startIndex) * log2Base;
	    const segments = new Uint16Array((bitsNeeded >>> 4) + (bitsNeeded & 15 ? 1 : 0));
	    for (let i = endIndex - 1, bitOffset = 0; i >= startIndex; i--, bitOffset += log2Base) {
	      const segment = bitOffset >>> 4;
	      const digitChar = stringValue.charCodeAt(i);
	      const digit = digitChar <= 57 /* _9 */ ? digitChar - 48 /* _0 */ : 10 + digitChar - (digitChar <= 70 /* F */ ? 65 /* A */ : 97 /* a */);
	      const shiftedDigit = digit << (bitOffset & 15);
	      segments[segment] |= shiftedDigit;
	      const residual = shiftedDigit >>> 16;
	      if (residual)
	        segments[segment + 1] |= residual;
	    }
	    let base10Value = "";
	    let firstNonzeroSegment = segments.length - 1;
	    let segmentsRemaining = true;
	    while (segmentsRemaining) {
	      let mod10 = 0;
	      segmentsRemaining = false;
	      for (let segment = firstNonzeroSegment; segment >= 0; segment--) {
	        const newSegment = mod10 << 16 | segments[segment];
	        const segmentValue = newSegment / 10 | 0;
	        segments[segment] = segmentValue;
	        mod10 = newSegment - segmentValue * 10;
	        if (segmentValue && !segmentsRemaining) {
	          firstNonzeroSegment = segment;
	          segmentsRemaining = true;
	        }
	      }
	      base10Value = mod10 + base10Value;
	    }
	    return base10Value;
	  }
	  function pseudoBigIntToString({ negative, base10Value }) {
	    return (negative && base10Value !== "0" ? "-" : "") + base10Value;
	  }
	  function parseBigInt(text) {
	    if (!isValidBigIntString(
	      text,
	      /*roundTripOnly*/
	      false
	    )) {
	      return void 0;
	    }
	    return parseValidBigInt(text);
	  }
	  function parseValidBigInt(text) {
	    const negative = text.startsWith("-");
	    const base10Value = parsePseudoBigInt(`${negative ? text.slice(1) : text}n`);
	    return { negative, base10Value };
	  }
	  function isValidBigIntString(s, roundTripOnly) {
	    if (s === "")
	      return false;
	    const scanner2 = createScanner(
	      99 /* ESNext */,
	      /*skipTrivia*/
	      false
	    );
	    let success = true;
	    scanner2.setOnError(() => success = false);
	    scanner2.setText(s + "n");
	    let result = scanner2.scan();
	    const negative = result === 41 /* MinusToken */;
	    if (negative) {
	      result = scanner2.scan();
	    }
	    const flags = scanner2.getTokenFlags();
	    return success && result === 10 /* BigIntLiteral */ && scanner2.getTokenEnd() === s.length + 1 && !(flags & 512 /* ContainsSeparator */) && (!roundTripOnly || s === pseudoBigIntToString({ negative, base10Value: parsePseudoBigInt(scanner2.getTokenValue()) }));
	  }
	  function isValidTypeOnlyAliasUseSite(useSite) {
	    return !!(useSite.flags & 33554432 /* Ambient */) || isPartOfTypeQuery(useSite) || isIdentifierInNonEmittingHeritageClause(useSite) || isPartOfPossiblyValidTypeOrAbstractComputedPropertyName(useSite) || !(isExpressionNode(useSite) || isShorthandPropertyNameUseSite(useSite));
	  }
	  function isShorthandPropertyNameUseSite(useSite) {
	    return isIdentifier(useSite) && isShorthandPropertyAssignment(useSite.parent) && useSite.parent.name === useSite;
	  }
	  function isPartOfPossiblyValidTypeOrAbstractComputedPropertyName(node) {
	    while (node.kind === 80 /* Identifier */ || node.kind === 211 /* PropertyAccessExpression */) {
	      node = node.parent;
	    }
	    if (node.kind !== 167 /* ComputedPropertyName */) {
	      return false;
	    }
	    if (hasSyntacticModifier(node.parent, 64 /* Abstract */)) {
	      return true;
	    }
	    const containerKind = node.parent.parent.kind;
	    return containerKind === 264 /* InterfaceDeclaration */ || containerKind === 187 /* TypeLiteral */;
	  }
	  function isIdentifierInNonEmittingHeritageClause(node) {
	    if (node.kind !== 80 /* Identifier */)
	      return false;
	    const heritageClause = findAncestor(node.parent, (parent2) => {
	      switch (parent2.kind) {
	        case 298 /* HeritageClause */:
	          return true;
	        case 211 /* PropertyAccessExpression */:
	        case 233 /* ExpressionWithTypeArguments */:
	          return false;
	        default:
	          return "quit";
	      }
	    });
	    return (heritageClause == null ? void 0 : heritageClause.token) === 119 /* ImplementsKeyword */ || (heritageClause == null ? void 0 : heritageClause.parent.kind) === 264 /* InterfaceDeclaration */;
	  }
	  function isIdentifierTypeReference(node) {
	    return isTypeReferenceNode(node) && isIdentifier(node.typeName);
	  }
	  function arrayIsHomogeneous(array, comparer = equateValues) {
	    if (array.length < 2)
	      return true;
	    const first2 = array[0];
	    for (let i = 1, length2 = array.length; i < length2; i++) {
	      const target = array[i];
	      if (!comparer(first2, target))
	        return false;
	    }
	    return true;
	  }
	  function setTextRangePos(range, pos) {
	    range.pos = pos;
	    return range;
	  }
	  function setTextRangeEnd(range, end) {
	    range.end = end;
	    return range;
	  }
	  function setTextRangePosEnd(range, pos, end) {
	    return setTextRangeEnd(setTextRangePos(range, pos), end);
	  }
	  function setTextRangePosWidth(range, pos, width) {
	    return setTextRangePosEnd(range, pos, pos + width);
	  }
	  function setNodeFlags(node, newFlags) {
	    if (node) {
	      node.flags = newFlags;
	    }
	    return node;
	  }
	  function setParent(child, parent2) {
	    if (child && parent2) {
	      child.parent = parent2;
	    }
	    return child;
	  }
	  function setEachParent(children, parent2) {
	    if (children) {
	      for (const child of children) {
	        setParent(child, parent2);
	      }
	    }
	    return children;
	  }
	  function setParentRecursive(rootNode, incremental) {
	    if (!rootNode)
	      return rootNode;
	    forEachChildRecursively(rootNode, isJSDocNode(rootNode) ? bindParentToChildIgnoringJSDoc : bindParentToChild);
	    return rootNode;
	    function bindParentToChildIgnoringJSDoc(child, parent2) {
	      if (incremental && child.parent === parent2) {
	        return "skip";
	      }
	      setParent(child, parent2);
	    }
	    function bindJSDoc(child) {
	      if (hasJSDocNodes(child)) {
	        for (const doc of child.jsDoc) {
	          bindParentToChildIgnoringJSDoc(doc, child);
	          forEachChildRecursively(doc, bindParentToChildIgnoringJSDoc);
	        }
	      }
	    }
	    function bindParentToChild(child, parent2) {
	      return bindParentToChildIgnoringJSDoc(child, parent2) || bindJSDoc(child);
	    }
	  }
	  function isPackedElement(node) {
	    return !isOmittedExpression(node);
	  }
	  function isPackedArrayLiteral(node) {
	    return isArrayLiteralExpression(node) && every(node.elements, isPackedElement);
	  }
	  function expressionResultIsUnused(node) {
	    Debug.assertIsDefined(node.parent);
	    while (true) {
	      const parent2 = node.parent;
	      if (isParenthesizedExpression(parent2)) {
	        node = parent2;
	        continue;
	      }
	      if (isExpressionStatement(parent2) || isVoidExpression(parent2) || isForStatement(parent2) && (parent2.initializer === node || parent2.incrementor === node)) {
	        return true;
	      }
	      if (isCommaListExpression(parent2)) {
	        if (node !== last(parent2.elements))
	          return true;
	        node = parent2;
	        continue;
	      }
	      if (isBinaryExpression(parent2) && parent2.operatorToken.kind === 28 /* CommaToken */) {
	        if (node === parent2.left)
	          return true;
	        node = parent2;
	        continue;
	      }
	      return false;
	    }
	  }
	  function containsIgnoredPath(path) {
	    return some(ignoredPaths, (p) => path.includes(p));
	  }
	  function getContainingNodeArray(node) {
	    if (!node.parent)
	      return void 0;
	    switch (node.kind) {
	      case 168 /* TypeParameter */:
	        const { parent: parent3 } = node;
	        return parent3.kind === 195 /* InferType */ ? void 0 : parent3.typeParameters;
	      case 169 /* Parameter */:
	        return node.parent.parameters;
	      case 204 /* TemplateLiteralTypeSpan */:
	        return node.parent.templateSpans;
	      case 239 /* TemplateSpan */:
	        return node.parent.templateSpans;
	      case 170 /* Decorator */: {
	        const { parent: parent4 } = node;
	        return canHaveDecorators(parent4) ? parent4.modifiers : void 0;
	      }
	      case 298 /* HeritageClause */:
	        return node.parent.heritageClauses;
	    }
	    const { parent: parent2 } = node;
	    if (isJSDocTag(node)) {
	      return isJSDocTypeLiteral(node.parent) ? void 0 : node.parent.tags;
	    }
	    switch (parent2.kind) {
	      case 187 /* TypeLiteral */:
	      case 264 /* InterfaceDeclaration */:
	        return isTypeElement(node) ? parent2.members : void 0;
	      case 192 /* UnionType */:
	      case 193 /* IntersectionType */:
	        return parent2.types;
	      case 189 /* TupleType */:
	      case 209 /* ArrayLiteralExpression */:
	      case 361 /* CommaListExpression */:
	      case 275 /* NamedImports */:
	      case 279 /* NamedExports */:
	        return parent2.elements;
	      case 210 /* ObjectLiteralExpression */:
	      case 292 /* JsxAttributes */:
	        return parent2.properties;
	      case 213 /* CallExpression */:
	      case 214 /* NewExpression */:
	        return isTypeNode(node) ? parent2.typeArguments : parent2.expression === node ? void 0 : parent2.arguments;
	      case 284 /* JsxElement */:
	      case 288 /* JsxFragment */:
	        return isJsxChild(node) ? parent2.children : void 0;
	      case 286 /* JsxOpeningElement */:
	      case 285 /* JsxSelfClosingElement */:
	        return isTypeNode(node) ? parent2.typeArguments : void 0;
	      case 241 /* Block */:
	      case 296 /* CaseClause */:
	      case 297 /* DefaultClause */:
	      case 268 /* ModuleBlock */:
	        return parent2.statements;
	      case 269 /* CaseBlock */:
	        return parent2.clauses;
	      case 263 /* ClassDeclaration */:
	      case 231 /* ClassExpression */:
	        return isClassElement(node) ? parent2.members : void 0;
	      case 266 /* EnumDeclaration */:
	        return isEnumMember(node) ? parent2.members : void 0;
	      case 312 /* SourceFile */:
	        return parent2.statements;
	    }
	  }
	  function hasContextSensitiveParameters(node) {
	    if (!node.typeParameters) {
	      if (some(node.parameters, (p) => !getEffectiveTypeAnnotationNode(p))) {
	        return true;
	      }
	      if (node.kind !== 219 /* ArrowFunction */) {
	        const parameter = firstOrUndefined(node.parameters);
	        if (!(parameter && parameterIsThisKeyword(parameter))) {
	          return true;
	        }
	      }
	    }
	    return false;
	  }
	  function isInfinityOrNaNString(name) {
	    return name === "Infinity" || name === "-Infinity" || name === "NaN";
	  }
	  function isCatchClauseVariableDeclaration(node) {
	    return node.kind === 260 /* VariableDeclaration */ && node.parent.kind === 299 /* CatchClause */;
	  }
	  function isFunctionExpressionOrArrowFunction(node) {
	    return node.kind === 218 /* FunctionExpression */ || node.kind === 219 /* ArrowFunction */;
	  }
	  function escapeSnippetText(text) {
	    return text.replace(/\$/gm, () => "\\$");
	  }
	  function isNumericLiteralName(name) {
	    return (+name).toString() === name;
	  }
	  function createPropertyNameNodeForIdentifierOrLiteral(name, target, singleQuote, stringNamed, isMethod) {
	    const isMethodNamedNew = isMethod && name === "new";
	    return !isMethodNamedNew && isIdentifierText(name, target) ? factory.createIdentifier(name) : !stringNamed && !isMethodNamedNew && isNumericLiteralName(name) && +name >= 0 ? factory.createNumericLiteral(+name) : factory.createStringLiteral(name, !!singleQuote);
	  }
	  function isThisTypeParameter(type) {
	    return !!(type.flags & 262144 /* TypeParameter */ && type.isThisType);
	  }
	  function getNodeModulePathParts(fullPath) {
	    let topLevelNodeModulesIndex = 0;
	    let topLevelPackageNameIndex = 0;
	    let packageRootIndex = 0;
	    let fileNameIndex = 0;
	    let States;
	    ((States2) => {
	      States2[States2["BeforeNodeModules"] = 0] = "BeforeNodeModules";
	      States2[States2["NodeModules"] = 1] = "NodeModules";
	      States2[States2["Scope"] = 2] = "Scope";
	      States2[States2["PackageContent"] = 3] = "PackageContent";
	    })(States || (States = {}));
	    let partStart = 0;
	    let partEnd = 0;
	    let state = 0 /* BeforeNodeModules */;
	    while (partEnd >= 0) {
	      partStart = partEnd;
	      partEnd = fullPath.indexOf("/", partStart + 1);
	      switch (state) {
	        case 0 /* BeforeNodeModules */:
	          if (fullPath.indexOf(nodeModulesPathPart, partStart) === partStart) {
	            topLevelNodeModulesIndex = partStart;
	            topLevelPackageNameIndex = partEnd;
	            state = 1 /* NodeModules */;
	          }
	          break;
	        case 1 /* NodeModules */:
	        case 2 /* Scope */:
	          if (state === 1 /* NodeModules */ && fullPath.charAt(partStart + 1) === "@") {
	            state = 2 /* Scope */;
	          } else {
	            packageRootIndex = partEnd;
	            state = 3 /* PackageContent */;
	          }
	          break;
	        case 3 /* PackageContent */:
	          if (fullPath.indexOf(nodeModulesPathPart, partStart) === partStart) {
	            state = 1 /* NodeModules */;
	          } else {
	            state = 3 /* PackageContent */;
	          }
	          break;
	      }
	    }
	    fileNameIndex = partStart;
	    return state > 1 /* NodeModules */ ? { topLevelNodeModulesIndex, topLevelPackageNameIndex, packageRootIndex, fileNameIndex } : void 0;
	  }
	  function getParameterTypeNode(parameter) {
	    var _a;
	    return parameter.kind === 348 /* JSDocParameterTag */ ? (_a = parameter.typeExpression) == null ? void 0 : _a.type : parameter.type;
	  }
	  function isTypeDeclaration(node) {
	    switch (node.kind) {
	      case 168 /* TypeParameter */:
	      case 263 /* ClassDeclaration */:
	      case 264 /* InterfaceDeclaration */:
	      case 265 /* TypeAliasDeclaration */:
	      case 266 /* EnumDeclaration */:
	      case 353 /* JSDocTypedefTag */:
	      case 345 /* JSDocCallbackTag */:
	      case 347 /* JSDocEnumTag */:
	        return true;
	      case 273 /* ImportClause */:
	        return node.isTypeOnly;
	      case 276 /* ImportSpecifier */:
	      case 281 /* ExportSpecifier */:
	        return node.parent.parent.isTypeOnly;
	      default:
	        return false;
	    }
	  }
	  function canHaveExportModifier(node) {
	    return isEnumDeclaration(node) || isVariableStatement(node) || isFunctionDeclaration(node) || isClassDeclaration(node) || isInterfaceDeclaration(node) || isTypeDeclaration(node) || isModuleDeclaration(node) && !isExternalModuleAugmentation(node) && !isGlobalScopeAugmentation(node);
	  }
	  function isOptionalJSDocPropertyLikeTag(node) {
	    if (!isJSDocPropertyLikeTag(node)) {
	      return false;
	    }
	    const { isBracketed, typeExpression } = node;
	    return isBracketed || !!typeExpression && typeExpression.type.kind === 323 /* JSDocOptionalType */;
	  }
	  function canUsePropertyAccess(name, languageVersion) {
	    if (name.length === 0) {
	      return false;
	    }
	    const firstChar = name.charCodeAt(0);
	    return firstChar === 35 /* hash */ ? name.length > 1 && isIdentifierStart(name.charCodeAt(1), languageVersion) : isIdentifierStart(firstChar, languageVersion);
	  }
	  function hasTabstop(node) {
	    var _a;
	    return ((_a = getSnippetElement(node)) == null ? void 0 : _a.kind) === 0 /* TabStop */;
	  }
	  function isJSDocOptionalParameter(node) {
	    return isInJSFile(node) && // node.type should only be a JSDocOptionalType when node is a parameter of a JSDocFunctionType
	    (node.type && node.type.kind === 323 /* JSDocOptionalType */ || getJSDocParameterTags(node).some(({ isBracketed, typeExpression }) => isBracketed || !!typeExpression && typeExpression.type.kind === 323 /* JSDocOptionalType */));
	  }
	  function isOptionalDeclaration(declaration) {
	    switch (declaration.kind) {
	      case 172 /* PropertyDeclaration */:
	      case 171 /* PropertySignature */:
	        return !!declaration.questionToken;
	      case 169 /* Parameter */:
	        return !!declaration.questionToken || isJSDocOptionalParameter(declaration);
	      case 355 /* JSDocPropertyTag */:
	      case 348 /* JSDocParameterTag */:
	        return isOptionalJSDocPropertyLikeTag(declaration);
	      default:
	        return false;
	    }
	  }
	  function isNonNullAccess(node) {
	    const kind = node.kind;
	    return (kind === 211 /* PropertyAccessExpression */ || kind === 212 /* ElementAccessExpression */) && isNonNullExpression(node.expression);
	  }
	  function isJSDocSatisfiesExpression(node) {
	    return isInJSFile(node) && isParenthesizedExpression(node) && hasJSDocNodes(node) && !!getJSDocSatisfiesTag(node);
	  }
	  function getJSDocSatisfiesExpressionType(node) {
	    return Debug.checkDefined(tryGetJSDocSatisfiesTypeNode(node));
	  }
	  function tryGetJSDocSatisfiesTypeNode(node) {
	    const tag = getJSDocSatisfiesTag(node);
	    return tag && tag.typeExpression && tag.typeExpression.type;
	  }
	  function getEscapedTextOfJsxAttributeName(node) {
	    return isIdentifier(node) ? node.escapedText : getEscapedTextOfJsxNamespacedName(node);
	  }
	  function getTextOfJsxAttributeName(node) {
	    return isIdentifier(node) ? idText(node) : getTextOfJsxNamespacedName(node);
	  }
	  function isJsxAttributeName(node) {
	    const kind = node.kind;
	    return kind === 80 /* Identifier */ || kind === 295 /* JsxNamespacedName */;
	  }
	  function getEscapedTextOfJsxNamespacedName(node) {
	    return `${node.namespace.escapedText}:${idText(node.name)}`;
	  }
	  function getTextOfJsxNamespacedName(node) {
	    return `${idText(node.namespace)}:${idText(node.name)}`;
	  }
	  function intrinsicTagNameToString(node) {
	    return isIdentifier(node) ? idText(node) : getTextOfJsxNamespacedName(node);
	  }
	  function isTypeUsableAsPropertyName(type) {
	    return !!(type.flags & 8576 /* StringOrNumberLiteralOrUnique */);
	  }
	  function getPropertyNameFromType(type) {
	    if (type.flags & 8192 /* UniqueESSymbol */) {
	      return type.escapedName;
	    }
	    if (type.flags & (128 /* StringLiteral */ | 256 /* NumberLiteral */)) {
	      return escapeLeadingUnderscores("" + type.value);
	    }
	    return Debug.fail();
	  }
	  function isExpandoPropertyDeclaration(declaration) {
	    return !!declaration && (isPropertyAccessExpression(declaration) || isElementAccessExpression(declaration) || isBinaryExpression(declaration));
	  }
	  function hasResolutionModeOverride(node) {
	    if (node === void 0) {
	      return false;
	    }
	    return !!getResolutionModeOverride(node.attributes);
	  }
	  function replaceFirstStar(s, replacement) {
	    return stringReplace.call(s, "*", replacement);
	  }
	  function getNameFromImportAttribute(node) {
	    return isIdentifier(node.name) ? node.name.escapedText : escapeLeadingUnderscores(node.name.text);
	  }
	  var resolvingEmptyArray, externalHelpersModuleNameText, defaultMaximumTruncationLength, noTruncationMaximumTruncationLength, stringWriter, getScriptTargetFeatures, GetLiteralTextFlags, fullTripleSlashReferencePathRegEx, fullTripleSlashReferenceTypeReferenceDirectiveRegEx, fullTripleSlashLibReferenceRegEx, fullTripleSlashAMDReferencePathRegEx, fullTripleSlashAMDModuleRegEx, defaultLibReferenceRegEx, AssignmentKind, FunctionFlags, Associativity, OperatorPrecedence, templateSubstitutionRegExp, doubleQuoteEscapedCharsRegExp, singleQuoteEscapedCharsRegExp, backtickQuoteEscapedCharsRegExp, escapedCharsMap, nonAsciiCharacters, jsxDoubleQuoteEscapedCharsRegExp, jsxSingleQuoteEscapedCharsRegExp, jsxEscapedCharsMap, indentStrings, base64Digits, carriageReturnLineFeed, lineFeed, objectAllocator, objectAllocatorPatchers, localizedDiagnosticMessages, computedOptions, getEmitScriptTarget, getEmitModuleKind, getEmitModuleResolutionKind, getEmitModuleDetectionKind, getIsolatedModules, getESModuleInterop, getAllowSyntheticDefaultImports, getResolvePackageJsonExports, getResolvePackageJsonImports, getResolveJsonModule, getEmitDeclarations, shouldPreserveConstEnums, isIncrementalCompilation, getAreDeclarationMapsEnabled, getAllowJSCompilerOption, getUseDefineForClassFields, reservedCharacterPattern, wildcardCharCodes, commonPackageFolders, implicitExcludePathRegexPattern, filesMatcher, directoriesMatcher, excludeMatcher, wildcardMatchers, supportedTSExtensions, supportedTSExtensionsFlat, supportedTSExtensionsWithJson, supportedTSExtensionsForExtractExtension, supportedJSExtensions, supportedJSExtensionsFlat, allSupportedExtensions, allSupportedExtensionsWithJson, supportedDeclarationExtensions, supportedTSImplementationExtensions, extensionsNotSupportingExtensionlessResolution, ModuleSpecifierEnding, extensionsToRemove, emptyFileSystemEntries, stringReplace;
	  var init_utilities = __esm({
	    "src/compiler/utilities.ts"() {
	      init_ts2();
	      resolvingEmptyArray = [];
	      externalHelpersModuleNameText = "tslib";
	      defaultMaximumTruncationLength = 160;
	      noTruncationMaximumTruncationLength = 1e6;
	      stringWriter = createSingleLineStringWriter();
	      getScriptTargetFeatures = /* @__PURE__ */ memoize(
	        () => new Map(Object.entries({
	          Array: new Map(Object.entries({
	            es2015: [
	              "find",
	              "findIndex",
	              "fill",
	              "copyWithin",
	              "entries",
	              "keys",
	              "values"
	            ],
	            es2016: [
	              "includes"
	            ],
	            es2019: [
	              "flat",
	              "flatMap"
	            ],
	            es2022: [
	              "at"
	            ],
	            es2023: [
	              "findLastIndex",
	              "findLast"
	            ]
	          })),
	          Iterator: new Map(Object.entries({
	            es2015: emptyArray
	          })),
	          AsyncIterator: new Map(Object.entries({
	            es2015: emptyArray
	          })),
	          Atomics: new Map(Object.entries({
	            es2017: emptyArray
	          })),
	          SharedArrayBuffer: new Map(Object.entries({
	            es2017: emptyArray
	          })),
	          AsyncIterable: new Map(Object.entries({
	            es2018: emptyArray
	          })),
	          AsyncIterableIterator: new Map(Object.entries({
	            es2018: emptyArray
	          })),
	          AsyncGenerator: new Map(Object.entries({
	            es2018: emptyArray
	          })),
	          AsyncGeneratorFunction: new Map(Object.entries({
	            es2018: emptyArray
	          })),
	          RegExp: new Map(Object.entries({
	            es2015: [
	              "flags",
	              "sticky",
	              "unicode"
	            ],
	            es2018: [
	              "dotAll"
	            ]
	          })),
	          Reflect: new Map(Object.entries({
	            es2015: [
	              "apply",
	              "construct",
	              "defineProperty",
	              "deleteProperty",
	              "get",
	              "getOwnPropertyDescriptor",
	              "getPrototypeOf",
	              "has",
	              "isExtensible",
	              "ownKeys",
	              "preventExtensions",
	              "set",
	              "setPrototypeOf"
	            ]
	          })),
	          ArrayConstructor: new Map(Object.entries({
	            es2015: [
	              "from",
	              "of"
	            ]
	          })),
	          ObjectConstructor: new Map(Object.entries({
	            es2015: [
	              "assign",
	              "getOwnPropertySymbols",
	              "keys",
	              "is",
	              "setPrototypeOf"
	            ],
	            es2017: [
	              "values",
	              "entries",
	              "getOwnPropertyDescriptors"
	            ],
	            es2019: [
	              "fromEntries"
	            ],
	            es2022: [
	              "hasOwn"
	            ]
	          })),
	          NumberConstructor: new Map(Object.entries({
	            es2015: [
	              "isFinite",
	              "isInteger",
	              "isNaN",
	              "isSafeInteger",
	              "parseFloat",
	              "parseInt"
	            ]
	          })),
	          Math: new Map(Object.entries({
	            es2015: [
	              "clz32",
	              "imul",
	              "sign",
	              "log10",
	              "log2",
	              "log1p",
	              "expm1",
	              "cosh",
	              "sinh",
	              "tanh",
	              "acosh",
	              "asinh",
	              "atanh",
	              "hypot",
	              "trunc",
	              "fround",
	              "cbrt"
	            ]
	          })),
	          Map: new Map(Object.entries({
	            es2015: [
	              "entries",
	              "keys",
	              "values"
	            ]
	          })),
	          Set: new Map(Object.entries({
	            es2015: [
	              "entries",
	              "keys",
	              "values"
	            ]
	          })),
	          PromiseConstructor: new Map(Object.entries({
	            es2015: [
	              "all",
	              "race",
	              "reject",
	              "resolve"
	            ],
	            es2020: [
	              "allSettled"
	            ],
	            es2021: [
	              "any"
	            ]
	          })),
	          Symbol: new Map(Object.entries({
	            es2015: [
	              "for",
	              "keyFor"
	            ],
	            es2019: [
	              "description"
	            ]
	          })),
	          WeakMap: new Map(Object.entries({
	            es2015: [
	              "entries",
	              "keys",
	              "values"
	            ]
	          })),
	          WeakSet: new Map(Object.entries({
	            es2015: [
	              "entries",
	              "keys",
	              "values"
	            ]
	          })),
	          String: new Map(Object.entries({
	            es2015: [
	              "codePointAt",
	              "includes",
	              "endsWith",
	              "normalize",
	              "repeat",
	              "startsWith",
	              "anchor",
	              "big",
	              "blink",
	              "bold",
	              "fixed",
	              "fontcolor",
	              "fontsize",
	              "italics",
	              "link",
	              "small",
	              "strike",
	              "sub",
	              "sup"
	            ],
	            es2017: [
	              "padStart",
	              "padEnd"
	            ],
	            es2019: [
	              "trimStart",
	              "trimEnd",
	              "trimLeft",
	              "trimRight"
	            ],
	            es2020: [
	              "matchAll"
	            ],
	            es2021: [
	              "replaceAll"
	            ],
	            es2022: [
	              "at"
	            ]
	          })),
	          StringConstructor: new Map(Object.entries({
	            es2015: [
	              "fromCodePoint",
	              "raw"
	            ]
	          })),
	          DateTimeFormat: new Map(Object.entries({
	            es2017: [
	              "formatToParts"
	            ]
	          })),
	          Promise: new Map(Object.entries({
	            es2015: emptyArray,
	            es2018: [
	              "finally"
	            ]
	          })),
	          RegExpMatchArray: new Map(Object.entries({
	            es2018: [
	              "groups"
	            ]
	          })),
	          RegExpExecArray: new Map(Object.entries({
	            es2018: [
	              "groups"
	            ]
	          })),
	          Intl: new Map(Object.entries({
	            es2018: [
	              "PluralRules"
	            ]
	          })),
	          NumberFormat: new Map(Object.entries({
	            es2018: [
	              "formatToParts"
	            ]
	          })),
	          SymbolConstructor: new Map(Object.entries({
	            es2020: [
	              "matchAll"
	            ]
	          })),
	          DataView: new Map(Object.entries({
	            es2020: [
	              "setBigInt64",
	              "setBigUint64",
	              "getBigInt64",
	              "getBigUint64"
	            ]
	          })),
	          BigInt: new Map(Object.entries({
	            es2020: emptyArray
	          })),
	          RelativeTimeFormat: new Map(Object.entries({
	            es2020: [
	              "format",
	              "formatToParts",
	              "resolvedOptions"
	            ]
	          })),
	          Int8Array: new Map(Object.entries({
	            es2022: [
	              "at"
	            ],
	            es2023: [
	              "findLastIndex",
	              "findLast"
	            ]
	          })),
	          Uint8Array: new Map(Object.entries({
	            es2022: [
	              "at"
	            ],
	            es2023: [
	              "findLastIndex",
	              "findLast"
	            ]
	          })),
	          Uint8ClampedArray: new Map(Object.entries({
	            es2022: [
	              "at"
	            ],
	            es2023: [
	              "findLastIndex",
	              "findLast"
	            ]
	          })),
	          Int16Array: new Map(Object.entries({
	            es2022: [
	              "at"
	            ],
	            es2023: [
	              "findLastIndex",
	              "findLast"
	            ]
	          })),
	          Uint16Array: new Map(Object.entries({
	            es2022: [
	              "at"
	            ],
	            es2023: [
	              "findLastIndex",
	              "findLast"
	            ]
	          })),
	          Int32Array: new Map(Object.entries({
	            es2022: [
	              "at"
	            ],
	            es2023: [
	              "findLastIndex",
	              "findLast"
	            ]
	          })),
	          Uint32Array: new Map(Object.entries({
	            es2022: [
	              "at"
	            ],
	            es2023: [
	              "findLastIndex",
	              "findLast"
	            ]
	          })),
	          Float32Array: new Map(Object.entries({
	            es2022: [
	              "at"
	            ],
	            es2023: [
	              "findLastIndex",
	              "findLast"
	            ]
	          })),
	          Float64Array: new Map(Object.entries({
	            es2022: [
	              "at"
	            ],
	            es2023: [
	              "findLastIndex",
	              "findLast"
	            ]
	          })),
	          BigInt64Array: new Map(Object.entries({
	            es2020: emptyArray,
	            es2022: [
	              "at"
	            ],
	            es2023: [
	              "findLastIndex",
	              "findLast"
	            ]
	          })),
	          BigUint64Array: new Map(Object.entries({
	            es2020: emptyArray,
	            es2022: [
	              "at"
	            ],
	            es2023: [
	              "findLastIndex",
	              "findLast"
	            ]
	          })),
	          Error: new Map(Object.entries({
	            es2022: [
	              "cause"
	            ]
	          }))
	        }))
	      );
	      GetLiteralTextFlags = /* @__PURE__ */ ((GetLiteralTextFlags2) => {
	        GetLiteralTextFlags2[GetLiteralTextFlags2["None"] = 0] = "None";
	        GetLiteralTextFlags2[GetLiteralTextFlags2["NeverAsciiEscape"] = 1] = "NeverAsciiEscape";
	        GetLiteralTextFlags2[GetLiteralTextFlags2["JsxAttributeEscape"] = 2] = "JsxAttributeEscape";
	        GetLiteralTextFlags2[GetLiteralTextFlags2["TerminateUnterminatedLiterals"] = 4] = "TerminateUnterminatedLiterals";
	        GetLiteralTextFlags2[GetLiteralTextFlags2["AllowNumericSeparator"] = 8] = "AllowNumericSeparator";
	        return GetLiteralTextFlags2;
	      })(GetLiteralTextFlags || {});
	      fullTripleSlashReferencePathRegEx = /^(\/\/\/\s*<reference\s+path\s*=\s*)(('[^']*')|("[^"]*")).*?\/>/;
	      fullTripleSlashReferenceTypeReferenceDirectiveRegEx = /^(\/\/\/\s*<reference\s+types\s*=\s*)(('[^']*')|("[^"]*")).*?\/>/;
	      fullTripleSlashLibReferenceRegEx = /^(\/\/\/\s*<reference\s+lib\s*=\s*)(('[^']*')|("[^"]*")).*?\/>/;
	      fullTripleSlashAMDReferencePathRegEx = /^(\/\/\/\s*<amd-dependency\s+path\s*=\s*)(('[^']*')|("[^"]*")).*?\/>/;
	      fullTripleSlashAMDModuleRegEx = /^\/\/\/\s*<amd-module\s+.*?\/>/;
	      defaultLibReferenceRegEx = /^(\/\/\/\s*<reference\s+no-default-lib\s*=\s*)(('[^']*')|("[^"]*"))\s*\/>/;
	      AssignmentKind = /* @__PURE__ */ ((AssignmentKind2) => {
	        AssignmentKind2[AssignmentKind2["None"] = 0] = "None";
	        AssignmentKind2[AssignmentKind2["Definite"] = 1] = "Definite";
	        AssignmentKind2[AssignmentKind2["Compound"] = 2] = "Compound";
	        return AssignmentKind2;
	      })(AssignmentKind || {});
	      FunctionFlags = /* @__PURE__ */ ((FunctionFlags2) => {
	        FunctionFlags2[FunctionFlags2["Normal"] = 0] = "Normal";
	        FunctionFlags2[FunctionFlags2["Generator"] = 1] = "Generator";
	        FunctionFlags2[FunctionFlags2["Async"] = 2] = "Async";
	        FunctionFlags2[FunctionFlags2["Invalid"] = 4] = "Invalid";
	        FunctionFlags2[FunctionFlags2["AsyncGenerator"] = 3] = "AsyncGenerator";
	        return FunctionFlags2;
	      })(FunctionFlags || {});
	      Associativity = /* @__PURE__ */ ((Associativity2) => {
	        Associativity2[Associativity2["Left"] = 0] = "Left";
	        Associativity2[Associativity2["Right"] = 1] = "Right";
	        return Associativity2;
	      })(Associativity || {});
	      OperatorPrecedence = /* @__PURE__ */ ((OperatorPrecedence2) => {
	        OperatorPrecedence2[OperatorPrecedence2["Comma"] = 0] = "Comma";
	        OperatorPrecedence2[OperatorPrecedence2["Spread"] = 1] = "Spread";
	        OperatorPrecedence2[OperatorPrecedence2["Yield"] = 2] = "Yield";
	        OperatorPrecedence2[OperatorPrecedence2["Assignment"] = 3] = "Assignment";
	        OperatorPrecedence2[OperatorPrecedence2["Conditional"] = 4] = "Conditional";
	        OperatorPrecedence2[OperatorPrecedence2["Coalesce"] = 4 /* Conditional */] = "Coalesce";
	        OperatorPrecedence2[OperatorPrecedence2["LogicalOR"] = 5] = "LogicalOR";
	        OperatorPrecedence2[OperatorPrecedence2["LogicalAND"] = 6] = "LogicalAND";
	        OperatorPrecedence2[OperatorPrecedence2["BitwiseOR"] = 7] = "BitwiseOR";
	        OperatorPrecedence2[OperatorPrecedence2["BitwiseXOR"] = 8] = "BitwiseXOR";
	        OperatorPrecedence2[OperatorPrecedence2["BitwiseAND"] = 9] = "BitwiseAND";
	        OperatorPrecedence2[OperatorPrecedence2["Equality"] = 10] = "Equality";
	        OperatorPrecedence2[OperatorPrecedence2["Relational"] = 11] = "Relational";
	        OperatorPrecedence2[OperatorPrecedence2["Shift"] = 12] = "Shift";
	        OperatorPrecedence2[OperatorPrecedence2["Additive"] = 13] = "Additive";
	        OperatorPrecedence2[OperatorPrecedence2["Multiplicative"] = 14] = "Multiplicative";
	        OperatorPrecedence2[OperatorPrecedence2["Exponentiation"] = 15] = "Exponentiation";
	        OperatorPrecedence2[OperatorPrecedence2["Unary"] = 16] = "Unary";
	        OperatorPrecedence2[OperatorPrecedence2["Update"] = 17] = "Update";
	        OperatorPrecedence2[OperatorPrecedence2["LeftHandSide"] = 18] = "LeftHandSide";
	        OperatorPrecedence2[OperatorPrecedence2["Member"] = 19] = "Member";
	        OperatorPrecedence2[OperatorPrecedence2["Primary"] = 20] = "Primary";
	        OperatorPrecedence2[OperatorPrecedence2["Highest"] = 20 /* Primary */] = "Highest";
	        OperatorPrecedence2[OperatorPrecedence2["Lowest"] = 0 /* Comma */] = "Lowest";
	        OperatorPrecedence2[OperatorPrecedence2["Invalid"] = -1] = "Invalid";
	        return OperatorPrecedence2;
	      })(OperatorPrecedence || {});
	      templateSubstitutionRegExp = /\$\{/g;
	      doubleQuoteEscapedCharsRegExp = /[\\"\u0000-\u001f\t\v\f\b\r\n\u2028\u2029\u0085]/g;
	      singleQuoteEscapedCharsRegExp = /[\\'\u0000-\u001f\t\v\f\b\r\n\u2028\u2029\u0085]/g;
	      backtickQuoteEscapedCharsRegExp = /\r\n|[\\`\u0000-\u001f\t\v\f\b\r\u2028\u2029\u0085]/g;
	      escapedCharsMap = new Map(Object.entries({
	        "	": "\\t",
	        "\v": "\\v",
	        "\f": "\\f",
	        "\b": "\\b",
	        "\r": "\\r",
	        "\n": "\\n",
	        "\\": "\\\\",
	        '"': '\\"',
	        "'": "\\'",
	        "`": "\\`",
	        "\u2028": "\\u2028",
	        // lineSeparator
	        "\u2029": "\\u2029",
	        // paragraphSeparator
	        "\x85": "\\u0085",
	        // nextLine
	        "\r\n": "\\r\\n"
	        // special case for CRLFs in backticks
	      }));
	      nonAsciiCharacters = /[^\u0000-\u007F]/g;
	      jsxDoubleQuoteEscapedCharsRegExp = /["\u0000-\u001f\u2028\u2029\u0085]/g;
	      jsxSingleQuoteEscapedCharsRegExp = /['\u0000-\u001f\u2028\u2029\u0085]/g;
	      jsxEscapedCharsMap = new Map(Object.entries({
	        '"': "&quot;",
	        "'": "&apos;"
	      }));
	      indentStrings = ["", "    "];
	      base64Digits = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
	      carriageReturnLineFeed = "\r\n";
	      lineFeed = "\n";
	      objectAllocator = {
	        getNodeConstructor: () => Node4,
	        getTokenConstructor: () => Token,
	        getIdentifierConstructor: () => Identifier2,
	        getPrivateIdentifierConstructor: () => Node4,
	        getSourceFileConstructor: () => Node4,
	        getSymbolConstructor: () => Symbol4,
	        getTypeConstructor: () => Type3,
	        getSignatureConstructor: () => Signature2,
	        getSourceMapSourceConstructor: () => SourceMapSource
	      };
	      objectAllocatorPatchers = [];
	      computedOptions = createComputedCompilerOptions({
	        target: {
	          dependencies: ["module"],
	          computeValue: (compilerOptions) => {
	            return compilerOptions.target ?? (compilerOptions.module === 100 /* Node16 */ && 9 /* ES2022 */ || compilerOptions.module === 199 /* NodeNext */ && 99 /* ESNext */ || 1 /* ES5 */);
	          }
	        },
	        module: {
	          dependencies: ["target"],
	          computeValue: (compilerOptions) => {
	            return typeof compilerOptions.module === "number" ? compilerOptions.module : computedOptions.target.computeValue(compilerOptions) >= 2 /* ES2015 */ ? 5 /* ES2015 */ : 1 /* CommonJS */;
	          }
	        },
	        moduleResolution: {
	          dependencies: ["module", "target"],
	          computeValue: (compilerOptions) => {
	            let moduleResolution = compilerOptions.moduleResolution;
	            if (moduleResolution === void 0) {
	              switch (computedOptions.module.computeValue(compilerOptions)) {
	                case 1 /* CommonJS */:
	                  moduleResolution = 2 /* Node10 */;
	                  break;
	                case 100 /* Node16 */:
	                  moduleResolution = 3 /* Node16 */;
	                  break;
	                case 199 /* NodeNext */:
	                  moduleResolution = 99 /* NodeNext */;
	                  break;
	                case 200 /* Preserve */:
	                  moduleResolution = 100 /* Bundler */;
	                  break;
	                default:
	                  moduleResolution = 1 /* Classic */;
	                  break;
	              }
	            }
	            return moduleResolution;
	          }
	        },
	        moduleDetection: {
	          dependencies: ["module", "target"],
	          computeValue: (compilerOptions) => {
	            return compilerOptions.moduleDetection || (computedOptions.module.computeValue(compilerOptions) === 100 /* Node16 */ || computedOptions.module.computeValue(compilerOptions) === 199 /* NodeNext */ ? 3 /* Force */ : 2 /* Auto */);
	          }
	        },
	        isolatedModules: {
	          dependencies: ["verbatimModuleSyntax"],
	          computeValue: (compilerOptions) => {
	            return !!(compilerOptions.isolatedModules || compilerOptions.verbatimModuleSyntax);
	          }
	        },
	        esModuleInterop: {
	          dependencies: ["module", "target"],
	          computeValue: (compilerOptions) => {
	            if (compilerOptions.esModuleInterop !== void 0) {
	              return compilerOptions.esModuleInterop;
	            }
	            switch (computedOptions.module.computeValue(compilerOptions)) {
	              case 100 /* Node16 */:
	              case 199 /* NodeNext */:
	              case 200 /* Preserve */:
	                return true;
	            }
	            return false;
	          }
	        },
	        allowSyntheticDefaultImports: {
	          dependencies: ["module", "target", "moduleResolution"],
	          computeValue: (compilerOptions) => {
	            if (compilerOptions.allowSyntheticDefaultImports !== void 0) {
	              return compilerOptions.allowSyntheticDefaultImports;
	            }
	            return computedOptions.esModuleInterop.computeValue(compilerOptions) || computedOptions.module.computeValue(compilerOptions) === 4 /* System */ || computedOptions.moduleResolution.computeValue(compilerOptions) === 100 /* Bundler */;
	          }
	        },
	        resolvePackageJsonExports: {
	          dependencies: ["moduleResolution"],
	          computeValue: (compilerOptions) => {
	            const moduleResolution = computedOptions.moduleResolution.computeValue(compilerOptions);
	            if (!moduleResolutionSupportsPackageJsonExportsAndImports(moduleResolution)) {
	              return false;
	            }
	            if (compilerOptions.resolvePackageJsonExports !== void 0) {
	              return compilerOptions.resolvePackageJsonExports;
	            }
	            switch (moduleResolution) {
	              case 3 /* Node16 */:
	              case 99 /* NodeNext */:
	              case 100 /* Bundler */:
	                return true;
	            }
	            return false;
	          }
	        },
	        resolvePackageJsonImports: {
	          dependencies: ["moduleResolution", "resolvePackageJsonExports"],
	          computeValue: (compilerOptions) => {
	            const moduleResolution = computedOptions.moduleResolution.computeValue(compilerOptions);
	            if (!moduleResolutionSupportsPackageJsonExportsAndImports(moduleResolution)) {
	              return false;
	            }
	            if (compilerOptions.resolvePackageJsonExports !== void 0) {
	              return compilerOptions.resolvePackageJsonExports;
	            }
	            switch (moduleResolution) {
	              case 3 /* Node16 */:
	              case 99 /* NodeNext */:
	              case 100 /* Bundler */:
	                return true;
	            }
	            return false;
	          }
	        },
	        resolveJsonModule: {
	          dependencies: ["moduleResolution", "module", "target"],
	          computeValue: (compilerOptions) => {
	            if (compilerOptions.resolveJsonModule !== void 0) {
	              return compilerOptions.resolveJsonModule;
	            }
	            return computedOptions.moduleResolution.computeValue(compilerOptions) === 100 /* Bundler */;
	          }
	        },
	        declaration: {
	          dependencies: ["composite"],
	          computeValue: (compilerOptions) => {
	            return !!(compilerOptions.declaration || compilerOptions.composite);
	          }
	        },
	        preserveConstEnums: {
	          dependencies: ["isolatedModules", "verbatimModuleSyntax"],
	          computeValue: (compilerOptions) => {
	            return !!(compilerOptions.preserveConstEnums || computedOptions.isolatedModules.computeValue(compilerOptions));
	          }
	        },
	        incremental: {
	          dependencies: ["composite"],
	          computeValue: (compilerOptions) => {
	            return !!(compilerOptions.incremental || compilerOptions.composite);
	          }
	        },
	        declarationMap: {
	          dependencies: ["declaration", "composite"],
	          computeValue: (compilerOptions) => {
	            return !!(compilerOptions.declarationMap && computedOptions.declaration.computeValue(compilerOptions));
	          }
	        },
	        allowJs: {
	          dependencies: ["checkJs"],
	          computeValue: (compilerOptions) => {
	            return compilerOptions.allowJs === void 0 ? !!compilerOptions.checkJs : compilerOptions.allowJs;
	          }
	        },
	        useDefineForClassFields: {
	          dependencies: ["target", "module"],
	          computeValue: (compilerOptions) => {
	            return compilerOptions.useDefineForClassFields === void 0 ? computedOptions.target.computeValue(compilerOptions) >= 9 /* ES2022 */ : compilerOptions.useDefineForClassFields;
	          }
	        },
	        noImplicitAny: {
	          dependencies: ["strict"],
	          computeValue: (compilerOptions) => {
	            return getStrictOptionValue(compilerOptions, "noImplicitAny");
	          }
	        },
	        noImplicitThis: {
	          dependencies: ["strict"],
	          computeValue: (compilerOptions) => {
	            return getStrictOptionValue(compilerOptions, "noImplicitThis");
	          }
	        },
	        strictNullChecks: {
	          dependencies: ["strict"],
	          computeValue: (compilerOptions) => {
	            return getStrictOptionValue(compilerOptions, "strictNullChecks");
	          }
	        },
	        strictFunctionTypes: {
	          dependencies: ["strict"],
	          computeValue: (compilerOptions) => {
	            return getStrictOptionValue(compilerOptions, "strictFunctionTypes");
	          }
	        },
	        strictBindCallApply: {
	          dependencies: ["strict"],
	          computeValue: (compilerOptions) => {
	            return getStrictOptionValue(compilerOptions, "strictBindCallApply");
	          }
	        },
	        strictPropertyInitialization: {
	          dependencies: ["strict"],
	          computeValue: (compilerOptions) => {
	            return getStrictOptionValue(compilerOptions, "strictPropertyInitialization");
	          }
	        },
	        alwaysStrict: {
	          dependencies: ["strict"],
	          computeValue: (compilerOptions) => {
	            return getStrictOptionValue(compilerOptions, "alwaysStrict");
	          }
	        },
	        useUnknownInCatchVariables: {
	          dependencies: ["strict"],
	          computeValue: (compilerOptions) => {
	            return getStrictOptionValue(compilerOptions, "useUnknownInCatchVariables");
	          }
	        }
	      });
	      getEmitScriptTarget = computedOptions.target.computeValue;
	      getEmitModuleKind = computedOptions.module.computeValue;
	      getEmitModuleResolutionKind = computedOptions.moduleResolution.computeValue;
	      getEmitModuleDetectionKind = computedOptions.moduleDetection.computeValue;
	      getIsolatedModules = computedOptions.isolatedModules.computeValue;
	      getESModuleInterop = computedOptions.esModuleInterop.computeValue;
	      getAllowSyntheticDefaultImports = computedOptions.allowSyntheticDefaultImports.computeValue;
	      getResolvePackageJsonExports = computedOptions.resolvePackageJsonExports.computeValue;
	      getResolvePackageJsonImports = computedOptions.resolvePackageJsonImports.computeValue;
	      getResolveJsonModule = computedOptions.resolveJsonModule.computeValue;
	      getEmitDeclarations = computedOptions.declaration.computeValue;
	      shouldPreserveConstEnums = computedOptions.preserveConstEnums.computeValue;
	      isIncrementalCompilation = computedOptions.incremental.computeValue;
	      getAreDeclarationMapsEnabled = computedOptions.declarationMap.computeValue;
	      getAllowJSCompilerOption = computedOptions.allowJs.computeValue;
	      getUseDefineForClassFields = computedOptions.useDefineForClassFields.computeValue;
	      reservedCharacterPattern = /[^\w\s/]/g;
	      wildcardCharCodes = [42 /* asterisk */, 63 /* question */];
	      commonPackageFolders = ["node_modules", "bower_components", "jspm_packages"];
	      implicitExcludePathRegexPattern = `(?!(${commonPackageFolders.join("|")})(/|$))`;
	      filesMatcher = {
	        /**
	         * Matches any single directory segment unless it is the last segment and a .min.js file
	         * Breakdown:
	         *  [^./]                   # matches everything up to the first . character (excluding directory separators)
	         *  (\\.(?!min\\.js$))?     # matches . characters but not if they are part of the .min.js file extension
	         */
	        singleAsteriskRegexFragment: "([^./]|(\\.(?!min\\.js$))?)*",
	        /**
	         * Regex for the ** wildcard. Matches any number of subdirectories. When used for including
	         * files or directories, does not match subdirectories that start with a . character
	         */
	        doubleAsteriskRegexFragment: `(/${implicitExcludePathRegexPattern}[^/.][^/]*)*?`,
	        replaceWildcardCharacter: (match) => replaceWildcardCharacter(match, filesMatcher.singleAsteriskRegexFragment)
	      };
	      directoriesMatcher = {
	        singleAsteriskRegexFragment: "[^/]*",
	        /**
	         * Regex for the ** wildcard. Matches any number of subdirectories. When used for including
	         * files or directories, does not match subdirectories that start with a . character
	         */
	        doubleAsteriskRegexFragment: `(/${implicitExcludePathRegexPattern}[^/.][^/]*)*?`,
	        replaceWildcardCharacter: (match) => replaceWildcardCharacter(match, directoriesMatcher.singleAsteriskRegexFragment)
	      };
	      excludeMatcher = {
	        singleAsteriskRegexFragment: "[^/]*",
	        doubleAsteriskRegexFragment: "(/.+?)?",
	        replaceWildcardCharacter: (match) => replaceWildcardCharacter(match, excludeMatcher.singleAsteriskRegexFragment)
	      };
	      wildcardMatchers = {
	        files: filesMatcher,
	        directories: directoriesMatcher,
	        exclude: excludeMatcher
	      };
	      supportedTSExtensions = [[".ts" /* Ts */, ".tsx" /* Tsx */, ".d.ts" /* Dts */], [".cts" /* Cts */, ".d.cts" /* Dcts */], [".mts" /* Mts */, ".d.mts" /* Dmts */]];
	      supportedTSExtensionsFlat = flatten(supportedTSExtensions);
	      supportedTSExtensionsWithJson = [...supportedTSExtensions, [".json" /* Json */]];
	      supportedTSExtensionsForExtractExtension = [".d.ts" /* Dts */, ".d.cts" /* Dcts */, ".d.mts" /* Dmts */, ".cts" /* Cts */, ".mts" /* Mts */, ".ts" /* Ts */, ".tsx" /* Tsx */];
	      supportedJSExtensions = [[".js" /* Js */, ".jsx" /* Jsx */], [".mjs" /* Mjs */], [".cjs" /* Cjs */]];
	      supportedJSExtensionsFlat = flatten(supportedJSExtensions);
	      allSupportedExtensions = [[".ts" /* Ts */, ".tsx" /* Tsx */, ".d.ts" /* Dts */, ".js" /* Js */, ".jsx" /* Jsx */], [".cts" /* Cts */, ".d.cts" /* Dcts */, ".cjs" /* Cjs */], [".mts" /* Mts */, ".d.mts" /* Dmts */, ".mjs" /* Mjs */]];
	      allSupportedExtensionsWithJson = [...allSupportedExtensions, [".json" /* Json */]];
	      supportedDeclarationExtensions = [".d.ts" /* Dts */, ".d.cts" /* Dcts */, ".d.mts" /* Dmts */];
	      supportedTSImplementationExtensions = [".ts" /* Ts */, ".cts" /* Cts */, ".mts" /* Mts */, ".tsx" /* Tsx */];
	      extensionsNotSupportingExtensionlessResolution = [".mts" /* Mts */, ".d.mts" /* Dmts */, ".mjs" /* Mjs */, ".cts" /* Cts */, ".d.cts" /* Dcts */, ".cjs" /* Cjs */];
	      ModuleSpecifierEnding = /* @__PURE__ */ ((ModuleSpecifierEnding2) => {
	        ModuleSpecifierEnding2[ModuleSpecifierEnding2["Minimal"] = 0] = "Minimal";
	        ModuleSpecifierEnding2[ModuleSpecifierEnding2["Index"] = 1] = "Index";
	        ModuleSpecifierEnding2[ModuleSpecifierEnding2["JsExtension"] = 2] = "JsExtension";
	        ModuleSpecifierEnding2[ModuleSpecifierEnding2["TsExtension"] = 3] = "TsExtension";
	        return ModuleSpecifierEnding2;
	      })(ModuleSpecifierEnding || {});
	      extensionsToRemove = [".d.ts" /* Dts */, ".d.mts" /* Dmts */, ".d.cts" /* Dcts */, ".mjs" /* Mjs */, ".mts" /* Mts */, ".cjs" /* Cjs */, ".cts" /* Cts */, ".ts" /* Ts */, ".js" /* Js */, ".tsx" /* Tsx */, ".jsx" /* Jsx */, ".json" /* Json */];
	      emptyFileSystemEntries = {
	        files: emptyArray,
	        directories: emptyArray
	      };
	      stringReplace = String.prototype.replace;
	    }
	  });

	  // src/compiler/factory/baseNodeFactory.ts
	  function createBaseNodeFactory() {
	    let NodeConstructor2;
	    let TokenConstructor2;
	    let IdentifierConstructor2;
	    let PrivateIdentifierConstructor2;
	    let SourceFileConstructor2;
	    return {
	      createBaseSourceFileNode,
	      createBaseIdentifierNode,
	      createBasePrivateIdentifierNode,
	      createBaseTokenNode,
	      createBaseNode
	    };
	    function createBaseSourceFileNode(kind) {
	      return new (SourceFileConstructor2 || (SourceFileConstructor2 = objectAllocator.getSourceFileConstructor()))(
	        kind,
	        /*pos*/
	        -1,
	        /*end*/
	        -1
	      );
	    }
	    function createBaseIdentifierNode(kind) {
	      return new (IdentifierConstructor2 || (IdentifierConstructor2 = objectAllocator.getIdentifierConstructor()))(
	        kind,
	        /*pos*/
	        -1,
	        /*end*/
	        -1
	      );
	    }
	    function createBasePrivateIdentifierNode(kind) {
	      return new (PrivateIdentifierConstructor2 || (PrivateIdentifierConstructor2 = objectAllocator.getPrivateIdentifierConstructor()))(
	        kind,
	        /*pos*/
	        -1,
	        /*end*/
	        -1
	      );
	    }
	    function createBaseTokenNode(kind) {
	      return new (TokenConstructor2 || (TokenConstructor2 = objectAllocator.getTokenConstructor()))(
	        kind,
	        /*pos*/
	        -1,
	        /*end*/
	        -1
	      );
	    }
	    function createBaseNode(kind) {
	      return new (NodeConstructor2 || (NodeConstructor2 = objectAllocator.getNodeConstructor()))(
	        kind,
	        /*pos*/
	        -1,
	        /*end*/
	        -1
	      );
	    }
	  }
	  var init_baseNodeFactory = __esm({
	    "src/compiler/factory/baseNodeFactory.ts"() {
	      init_ts2();
	    }
	  });

	  // src/compiler/factory/parenthesizerRules.ts
	  function createParenthesizerRules(factory2) {
	    let binaryLeftOperandParenthesizerCache;
	    let binaryRightOperandParenthesizerCache;
	    return {
	      getParenthesizeLeftSideOfBinaryForOperator,
	      getParenthesizeRightSideOfBinaryForOperator,
	      parenthesizeLeftSideOfBinary,
	      parenthesizeRightSideOfBinary,
	      parenthesizeExpressionOfComputedPropertyName,
	      parenthesizeConditionOfConditionalExpression,
	      parenthesizeBranchOfConditionalExpression,
	      parenthesizeExpressionOfExportDefault,
	      parenthesizeExpressionOfNew,
	      parenthesizeLeftSideOfAccess,
	      parenthesizeOperandOfPostfixUnary,
	      parenthesizeOperandOfPrefixUnary,
	      parenthesizeExpressionsOfCommaDelimitedList,
	      parenthesizeExpressionForDisallowedComma,
	      parenthesizeExpressionOfExpressionStatement,
	      parenthesizeConciseBodyOfArrowFunction,
	      parenthesizeCheckTypeOfConditionalType,
	      parenthesizeExtendsTypeOfConditionalType,
	      parenthesizeConstituentTypesOfUnionType,
	      parenthesizeConstituentTypeOfUnionType,
	      parenthesizeConstituentTypesOfIntersectionType,
	      parenthesizeConstituentTypeOfIntersectionType,
	      parenthesizeOperandOfTypeOperator,
	      parenthesizeOperandOfReadonlyTypeOperator,
	      parenthesizeNonArrayTypeOfPostfixType,
	      parenthesizeElementTypesOfTupleType,
	      parenthesizeElementTypeOfTupleType,
	      parenthesizeTypeOfOptionalType,
	      parenthesizeTypeArguments,
	      parenthesizeLeadingTypeArgument
	    };
	    function getParenthesizeLeftSideOfBinaryForOperator(operatorKind) {
	      binaryLeftOperandParenthesizerCache || (binaryLeftOperandParenthesizerCache = /* @__PURE__ */ new Map());
	      let parenthesizerRule = binaryLeftOperandParenthesizerCache.get(operatorKind);
	      if (!parenthesizerRule) {
	        parenthesizerRule = (node) => parenthesizeLeftSideOfBinary(operatorKind, node);
	        binaryLeftOperandParenthesizerCache.set(operatorKind, parenthesizerRule);
	      }
	      return parenthesizerRule;
	    }
	    function getParenthesizeRightSideOfBinaryForOperator(operatorKind) {
	      binaryRightOperandParenthesizerCache || (binaryRightOperandParenthesizerCache = /* @__PURE__ */ new Map());
	      let parenthesizerRule = binaryRightOperandParenthesizerCache.get(operatorKind);
	      if (!parenthesizerRule) {
	        parenthesizerRule = (node) => parenthesizeRightSideOfBinary(
	          operatorKind,
	          /*leftSide*/
	          void 0,
	          node
	        );
	        binaryRightOperandParenthesizerCache.set(operatorKind, parenthesizerRule);
	      }
	      return parenthesizerRule;
	    }
	    function binaryOperandNeedsParentheses(binaryOperator, operand, isLeftSideOfBinary, leftOperand) {
	      const binaryOperatorPrecedence = getOperatorPrecedence(226 /* BinaryExpression */, binaryOperator);
	      const binaryOperatorAssociativity = getOperatorAssociativity(226 /* BinaryExpression */, binaryOperator);
	      const emittedOperand = skipPartiallyEmittedExpressions(operand);
	      if (!isLeftSideOfBinary && operand.kind === 219 /* ArrowFunction */ && binaryOperatorPrecedence > 3 /* Assignment */) {
	        return true;
	      }
	      const operandPrecedence = getExpressionPrecedence(emittedOperand);
	      switch (compareValues(operandPrecedence, binaryOperatorPrecedence)) {
	        case -1 /* LessThan */:
	          if (!isLeftSideOfBinary && binaryOperatorAssociativity === 1 /* Right */ && operand.kind === 229 /* YieldExpression */) {
	            return false;
	          }
	          return true;
	        case 1 /* GreaterThan */:
	          return false;
	        case 0 /* EqualTo */:
	          if (isLeftSideOfBinary) {
	            return binaryOperatorAssociativity === 1 /* Right */;
	          } else {
	            if (isBinaryExpression(emittedOperand) && emittedOperand.operatorToken.kind === binaryOperator) {
	              if (operatorHasAssociativeProperty(binaryOperator)) {
	                return false;
	              }
	              if (binaryOperator === 40 /* PlusToken */) {
	                const leftKind = leftOperand ? getLiteralKindOfBinaryPlusOperand(leftOperand) : 0 /* Unknown */;
	                if (isLiteralKind(leftKind) && leftKind === getLiteralKindOfBinaryPlusOperand(emittedOperand)) {
	                  return false;
	                }
	              }
	            }
	            const operandAssociativity = getExpressionAssociativity(emittedOperand);
	            return operandAssociativity === 0 /* Left */;
	          }
	      }
	    }
	    function operatorHasAssociativeProperty(binaryOperator) {
	      return binaryOperator === 42 /* AsteriskToken */ || binaryOperator === 52 /* BarToken */ || binaryOperator === 51 /* AmpersandToken */ || binaryOperator === 53 /* CaretToken */ || binaryOperator === 28 /* CommaToken */;
	    }
	    function getLiteralKindOfBinaryPlusOperand(node) {
	      node = skipPartiallyEmittedExpressions(node);
	      if (isLiteralKind(node.kind)) {
	        return node.kind;
	      }
	      if (node.kind === 226 /* BinaryExpression */ && node.operatorToken.kind === 40 /* PlusToken */) {
	        if (node.cachedLiteralKind !== void 0) {
	          return node.cachedLiteralKind;
	        }
	        const leftKind = getLiteralKindOfBinaryPlusOperand(node.left);
	        const literalKind = isLiteralKind(leftKind) && leftKind === getLiteralKindOfBinaryPlusOperand(node.right) ? leftKind : 0 /* Unknown */;
	        node.cachedLiteralKind = literalKind;
	        return literalKind;
	      }
	      return 0 /* Unknown */;
	    }
	    function parenthesizeBinaryOperand(binaryOperator, operand, isLeftSideOfBinary, leftOperand) {
	      const skipped = skipPartiallyEmittedExpressions(operand);
	      if (skipped.kind === 217 /* ParenthesizedExpression */) {
	        return operand;
	      }
	      return binaryOperandNeedsParentheses(binaryOperator, operand, isLeftSideOfBinary, leftOperand) ? factory2.createParenthesizedExpression(operand) : operand;
	    }
	    function parenthesizeLeftSideOfBinary(binaryOperator, leftSide) {
	      return parenthesizeBinaryOperand(
	        binaryOperator,
	        leftSide,
	        /*isLeftSideOfBinary*/
	        true
	      );
	    }
	    function parenthesizeRightSideOfBinary(binaryOperator, leftSide, rightSide) {
	      return parenthesizeBinaryOperand(
	        binaryOperator,
	        rightSide,
	        /*isLeftSideOfBinary*/
	        false,
	        leftSide
	      );
	    }
	    function parenthesizeExpressionOfComputedPropertyName(expression) {
	      return isCommaSequence(expression) ? factory2.createParenthesizedExpression(expression) : expression;
	    }
	    function parenthesizeConditionOfConditionalExpression(condition) {
	      const conditionalPrecedence = getOperatorPrecedence(227 /* ConditionalExpression */, 58 /* QuestionToken */);
	      const emittedCondition = skipPartiallyEmittedExpressions(condition);
	      const conditionPrecedence = getExpressionPrecedence(emittedCondition);
	      if (compareValues(conditionPrecedence, conditionalPrecedence) !== 1 /* GreaterThan */) {
	        return factory2.createParenthesizedExpression(condition);
	      }
	      return condition;
	    }
	    function parenthesizeBranchOfConditionalExpression(branch) {
	      const emittedExpression = skipPartiallyEmittedExpressions(branch);
	      return isCommaSequence(emittedExpression) ? factory2.createParenthesizedExpression(branch) : branch;
	    }
	    function parenthesizeExpressionOfExportDefault(expression) {
	      const check = skipPartiallyEmittedExpressions(expression);
	      let needsParens = isCommaSequence(check);
	      if (!needsParens) {
	        switch (getLeftmostExpression(
	          check,
	          /*stopAtCallExpressions*/
	          false
	        ).kind) {
	          case 231 /* ClassExpression */:
	          case 218 /* FunctionExpression */:
	            needsParens = true;
	        }
	      }
	      return needsParens ? factory2.createParenthesizedExpression(expression) : expression;
	    }
	    function parenthesizeExpressionOfNew(expression) {
	      const leftmostExpr = getLeftmostExpression(
	        expression,
	        /*stopAtCallExpressions*/
	        true
	      );
	      switch (leftmostExpr.kind) {
	        case 213 /* CallExpression */:
	          return factory2.createParenthesizedExpression(expression);
	        case 214 /* NewExpression */:
	          return !leftmostExpr.arguments ? factory2.createParenthesizedExpression(expression) : expression;
	      }
	      return parenthesizeLeftSideOfAccess(expression);
	    }
	    function parenthesizeLeftSideOfAccess(expression, optionalChain) {
	      const emittedExpression = skipPartiallyEmittedExpressions(expression);
	      if (isLeftHandSideExpression(emittedExpression) && (emittedExpression.kind !== 214 /* NewExpression */ || emittedExpression.arguments) && (optionalChain || !isOptionalChain(emittedExpression))) {
	        return expression;
	      }
	      return setTextRange(factory2.createParenthesizedExpression(expression), expression);
	    }
	    function parenthesizeOperandOfPostfixUnary(operand) {
	      return isLeftHandSideExpression(operand) ? operand : setTextRange(factory2.createParenthesizedExpression(operand), operand);
	    }
	    function parenthesizeOperandOfPrefixUnary(operand) {
	      return isUnaryExpression(operand) ? operand : setTextRange(factory2.createParenthesizedExpression(operand), operand);
	    }
	    function parenthesizeExpressionsOfCommaDelimitedList(elements) {
	      const result = sameMap(elements, parenthesizeExpressionForDisallowedComma);
	      return setTextRange(factory2.createNodeArray(result, elements.hasTrailingComma), elements);
	    }
	    function parenthesizeExpressionForDisallowedComma(expression) {
	      const emittedExpression = skipPartiallyEmittedExpressions(expression);
	      const expressionPrecedence = getExpressionPrecedence(emittedExpression);
	      const commaPrecedence = getOperatorPrecedence(226 /* BinaryExpression */, 28 /* CommaToken */);
	      return expressionPrecedence > commaPrecedence ? expression : setTextRange(factory2.createParenthesizedExpression(expression), expression);
	    }
	    function parenthesizeExpressionOfExpressionStatement(expression) {
	      const emittedExpression = skipPartiallyEmittedExpressions(expression);
	      if (isCallExpression(emittedExpression)) {
	        const callee = emittedExpression.expression;
	        const kind = skipPartiallyEmittedExpressions(callee).kind;
	        if (kind === 218 /* FunctionExpression */ || kind === 219 /* ArrowFunction */) {
	          const updated = factory2.updateCallExpression(
	            emittedExpression,
	            setTextRange(factory2.createParenthesizedExpression(callee), callee),
	            emittedExpression.typeArguments,
	            emittedExpression.arguments
	          );
	          return factory2.restoreOuterExpressions(expression, updated, 8 /* PartiallyEmittedExpressions */);
	        }
	      }
	      const leftmostExpressionKind = getLeftmostExpression(
	        emittedExpression,
	        /*stopAtCallExpressions*/
	        false
	      ).kind;
	      if (leftmostExpressionKind === 210 /* ObjectLiteralExpression */ || leftmostExpressionKind === 218 /* FunctionExpression */) {
	        return setTextRange(factory2.createParenthesizedExpression(expression), expression);
	      }
	      return expression;
	    }
	    function parenthesizeConciseBodyOfArrowFunction(body) {
	      if (!isBlock(body) && (isCommaSequence(body) || getLeftmostExpression(
	        body,
	        /*stopAtCallExpressions*/
	        false
	      ).kind === 210 /* ObjectLiteralExpression */)) {
	        return setTextRange(factory2.createParenthesizedExpression(body), body);
	      }
	      return body;
	    }
	    function parenthesizeCheckTypeOfConditionalType(checkType) {
	      switch (checkType.kind) {
	        case 184 /* FunctionType */:
	        case 185 /* ConstructorType */:
	        case 194 /* ConditionalType */:
	          return factory2.createParenthesizedType(checkType);
	      }
	      return checkType;
	    }
	    function parenthesizeExtendsTypeOfConditionalType(extendsType) {
	      switch (extendsType.kind) {
	        case 194 /* ConditionalType */:
	          return factory2.createParenthesizedType(extendsType);
	      }
	      return extendsType;
	    }
	    function parenthesizeConstituentTypeOfUnionType(type) {
	      switch (type.kind) {
	        case 192 /* UnionType */:
	        case 193 /* IntersectionType */:
	          return factory2.createParenthesizedType(type);
	      }
	      return parenthesizeCheckTypeOfConditionalType(type);
	    }
	    function parenthesizeConstituentTypesOfUnionType(members) {
	      return factory2.createNodeArray(sameMap(members, parenthesizeConstituentTypeOfUnionType));
	    }
	    function parenthesizeConstituentTypeOfIntersectionType(type) {
	      switch (type.kind) {
	        case 192 /* UnionType */:
	        case 193 /* IntersectionType */:
	          return factory2.createParenthesizedType(type);
	      }
	      return parenthesizeConstituentTypeOfUnionType(type);
	    }
	    function parenthesizeConstituentTypesOfIntersectionType(members) {
	      return factory2.createNodeArray(sameMap(members, parenthesizeConstituentTypeOfIntersectionType));
	    }
	    function parenthesizeOperandOfTypeOperator(type) {
	      switch (type.kind) {
	        case 193 /* IntersectionType */:
	          return factory2.createParenthesizedType(type);
	      }
	      return parenthesizeConstituentTypeOfIntersectionType(type);
	    }
	    function parenthesizeOperandOfReadonlyTypeOperator(type) {
	      switch (type.kind) {
	        case 198 /* TypeOperator */:
	          return factory2.createParenthesizedType(type);
	      }
	      return parenthesizeOperandOfTypeOperator(type);
	    }
	    function parenthesizeNonArrayTypeOfPostfixType(type) {
	      switch (type.kind) {
	        case 195 /* InferType */:
	        case 198 /* TypeOperator */:
	        case 186 /* TypeQuery */:
	          return factory2.createParenthesizedType(type);
	      }
	      return parenthesizeOperandOfTypeOperator(type);
	    }
	    function parenthesizeElementTypesOfTupleType(types) {
	      return factory2.createNodeArray(sameMap(types, parenthesizeElementTypeOfTupleType));
	    }
	    function parenthesizeElementTypeOfTupleType(type) {
	      if (hasJSDocPostfixQuestion(type))
	        return factory2.createParenthesizedType(type);
	      return type;
	    }
	    function hasJSDocPostfixQuestion(type) {
	      if (isJSDocNullableType(type))
	        return type.postfix;
	      if (isNamedTupleMember(type))
	        return hasJSDocPostfixQuestion(type.type);
	      if (isFunctionTypeNode(type) || isConstructorTypeNode(type) || isTypeOperatorNode(type))
	        return hasJSDocPostfixQuestion(type.type);
	      if (isConditionalTypeNode(type))
	        return hasJSDocPostfixQuestion(type.falseType);
	      if (isUnionTypeNode(type))
	        return hasJSDocPostfixQuestion(last(type.types));
	      if (isIntersectionTypeNode(type))
	        return hasJSDocPostfixQuestion(last(type.types));
	      if (isInferTypeNode(type))
	        return !!type.typeParameter.constraint && hasJSDocPostfixQuestion(type.typeParameter.constraint);
	      return false;
	    }
	    function parenthesizeTypeOfOptionalType(type) {
	      if (hasJSDocPostfixQuestion(type))
	        return factory2.createParenthesizedType(type);
	      return parenthesizeNonArrayTypeOfPostfixType(type);
	    }
	    function parenthesizeLeadingTypeArgument(node) {
	      return isFunctionOrConstructorTypeNode(node) && node.typeParameters ? factory2.createParenthesizedType(node) : node;
	    }
	    function parenthesizeOrdinalTypeArgument(node, i) {
	      return i === 0 ? parenthesizeLeadingTypeArgument(node) : node;
	    }
	    function parenthesizeTypeArguments(typeArguments) {
	      if (some(typeArguments)) {
	        return factory2.createNodeArray(sameMap(typeArguments, parenthesizeOrdinalTypeArgument));
	      }
	    }
	  }
	  var nullParenthesizerRules;
	  var init_parenthesizerRules = __esm({
	    "src/compiler/factory/parenthesizerRules.ts"() {
	      init_ts2();
	      nullParenthesizerRules = {
	        getParenthesizeLeftSideOfBinaryForOperator: (_) => identity,
	        getParenthesizeRightSideOfBinaryForOperator: (_) => identity,
	        parenthesizeLeftSideOfBinary: (_binaryOperator, leftSide) => leftSide,
	        parenthesizeRightSideOfBinary: (_binaryOperator, _leftSide, rightSide) => rightSide,
	        parenthesizeExpressionOfComputedPropertyName: identity,
	        parenthesizeConditionOfConditionalExpression: identity,
	        parenthesizeBranchOfConditionalExpression: identity,
	        parenthesizeExpressionOfExportDefault: identity,
	        parenthesizeExpressionOfNew: (expression) => cast(expression, isLeftHandSideExpression),
	        parenthesizeLeftSideOfAccess: (expression) => cast(expression, isLeftHandSideExpression),
	        parenthesizeOperandOfPostfixUnary: (operand) => cast(operand, isLeftHandSideExpression),
	        parenthesizeOperandOfPrefixUnary: (operand) => cast(operand, isUnaryExpression),
	        parenthesizeExpressionsOfCommaDelimitedList: (nodes) => cast(nodes, isNodeArray),
	        parenthesizeExpressionForDisallowedComma: identity,
	        parenthesizeExpressionOfExpressionStatement: identity,
	        parenthesizeConciseBodyOfArrowFunction: identity,
	        parenthesizeCheckTypeOfConditionalType: identity,
	        parenthesizeExtendsTypeOfConditionalType: identity,
	        parenthesizeConstituentTypesOfUnionType: (nodes) => cast(nodes, isNodeArray),
	        parenthesizeConstituentTypeOfUnionType: identity,
	        parenthesizeConstituentTypesOfIntersectionType: (nodes) => cast(nodes, isNodeArray),
	        parenthesizeConstituentTypeOfIntersectionType: identity,
	        parenthesizeOperandOfTypeOperator: identity,
	        parenthesizeOperandOfReadonlyTypeOperator: identity,
	        parenthesizeNonArrayTypeOfPostfixType: identity,
	        parenthesizeElementTypesOfTupleType: (nodes) => cast(nodes, isNodeArray),
	        parenthesizeElementTypeOfTupleType: identity,
	        parenthesizeTypeOfOptionalType: identity,
	        parenthesizeTypeArguments: (nodes) => nodes && cast(nodes, isNodeArray),
	        parenthesizeLeadingTypeArgument: identity
	      };
	    }
	  });

	  // src/compiler/factory/nodeConverters.ts
	  function createNodeConverters(factory2) {
	    return {
	      convertToFunctionBlock,
	      convertToFunctionExpression,
	      convertToClassExpression,
	      convertToArrayAssignmentElement,
	      convertToObjectAssignmentElement,
	      convertToAssignmentPattern,
	      convertToObjectAssignmentPattern,
	      convertToArrayAssignmentPattern,
	      convertToAssignmentElementTarget
	    };
	    function convertToFunctionBlock(node, multiLine) {
	      if (isBlock(node))
	        return node;
	      const returnStatement = factory2.createReturnStatement(node);
	      setTextRange(returnStatement, node);
	      const body = factory2.createBlock([returnStatement], multiLine);
	      setTextRange(body, node);
	      return body;
	    }
	    function convertToFunctionExpression(node) {
	      var _a;
	      if (!node.body)
	        return Debug.fail(`Cannot convert a FunctionDeclaration without a body`);
	      const updated = factory2.createFunctionExpression(
	        (_a = getModifiers(node)) == null ? void 0 : _a.filter((modifier) => !isExportModifier(modifier) && !isDefaultModifier(modifier)),
	        node.asteriskToken,
	        node.name,
	        node.typeParameters,
	        node.parameters,
	        node.type,
	        node.body
	      );
	      setOriginalNode(updated, node);
	      setTextRange(updated, node);
	      if (getStartsOnNewLine(node)) {
	        setStartsOnNewLine(
	          updated,
	          /*newLine*/
	          true
	        );
	      }
	      return updated;
	    }
	    function convertToClassExpression(node) {
	      var _a;
	      const updated = factory2.createClassExpression(
	        (_a = node.modifiers) == null ? void 0 : _a.filter((modifier) => !isExportModifier(modifier) && !isDefaultModifier(modifier)),
	        node.name,
	        node.typeParameters,
	        node.heritageClauses,
	        node.members
	      );
	      setOriginalNode(updated, node);
	      setTextRange(updated, node);
	      if (getStartsOnNewLine(node)) {
	        setStartsOnNewLine(
	          updated,
	          /*newLine*/
	          true
	        );
	      }
	      return updated;
	    }
	    function convertToArrayAssignmentElement(element) {
	      if (isBindingElement(element)) {
	        if (element.dotDotDotToken) {
	          Debug.assertNode(element.name, isIdentifier);
	          return setOriginalNode(setTextRange(factory2.createSpreadElement(element.name), element), element);
	        }
	        const expression = convertToAssignmentElementTarget(element.name);
	        return element.initializer ? setOriginalNode(
	          setTextRange(
	            factory2.createAssignment(expression, element.initializer),
	            element
	          ),
	          element
	        ) : expression;
	      }
	      return cast(element, isExpression);
	    }
	    function convertToObjectAssignmentElement(element) {
	      if (isBindingElement(element)) {
	        if (element.dotDotDotToken) {
	          Debug.assertNode(element.name, isIdentifier);
	          return setOriginalNode(setTextRange(factory2.createSpreadAssignment(element.name), element), element);
	        }
	        if (element.propertyName) {
	          const expression = convertToAssignmentElementTarget(element.name);
	          return setOriginalNode(setTextRange(factory2.createPropertyAssignment(element.propertyName, element.initializer ? factory2.createAssignment(expression, element.initializer) : expression), element), element);
	        }
	        Debug.assertNode(element.name, isIdentifier);
	        return setOriginalNode(setTextRange(factory2.createShorthandPropertyAssignment(element.name, element.initializer), element), element);
	      }
	      return cast(element, isObjectLiteralElementLike);
	    }
	    function convertToAssignmentPattern(node) {
	      switch (node.kind) {
	        case 207 /* ArrayBindingPattern */:
	        case 209 /* ArrayLiteralExpression */:
	          return convertToArrayAssignmentPattern(node);
	        case 206 /* ObjectBindingPattern */:
	        case 210 /* ObjectLiteralExpression */:
	          return convertToObjectAssignmentPattern(node);
	      }
	    }
	    function convertToObjectAssignmentPattern(node) {
	      if (isObjectBindingPattern(node)) {
	        return setOriginalNode(
	          setTextRange(
	            factory2.createObjectLiteralExpression(map(node.elements, convertToObjectAssignmentElement)),
	            node
	          ),
	          node
	        );
	      }
	      return cast(node, isObjectLiteralExpression);
	    }
	    function convertToArrayAssignmentPattern(node) {
	      if (isArrayBindingPattern(node)) {
	        return setOriginalNode(
	          setTextRange(
	            factory2.createArrayLiteralExpression(map(node.elements, convertToArrayAssignmentElement)),
	            node
	          ),
	          node
	        );
	      }
	      return cast(node, isArrayLiteralExpression);
	    }
	    function convertToAssignmentElementTarget(node) {
	      if (isBindingPattern(node)) {
	        return convertToAssignmentPattern(node);
	      }
	      return cast(node, isExpression);
	    }
	  }
	  var nullNodeConverters;
	  var init_nodeConverters = __esm({
	    "src/compiler/factory/nodeConverters.ts"() {
	      init_ts2();
	      nullNodeConverters = {
	        convertToFunctionBlock: notImplemented,
	        convertToFunctionExpression: notImplemented,
	        convertToClassExpression: notImplemented,
	        convertToArrayAssignmentElement: notImplemented,
	        convertToObjectAssignmentElement: notImplemented,
	        convertToAssignmentPattern: notImplemented,
	        convertToObjectAssignmentPattern: notImplemented,
	        convertToArrayAssignmentPattern: notImplemented,
	        convertToAssignmentElementTarget: notImplemented
	      };
	    }
	  });

	  // src/compiler/factory/nodeFactory.ts
	  function addNodeFactoryPatcher(fn) {
	    nodeFactoryPatchers.push(fn);
	  }
	  function createNodeFactory(flags, baseFactory2) {
	    const setOriginal = flags & 8 /* NoOriginalNode */ ? identity : setOriginalNode;
	    const parenthesizerRules = memoize(() => flags & 1 /* NoParenthesizerRules */ ? nullParenthesizerRules : createParenthesizerRules(factory2));
	    const converters = memoize(() => flags & 2 /* NoNodeConverters */ ? nullNodeConverters : createNodeConverters(factory2));
	    const getBinaryCreateFunction = memoizeOne((operator) => (left, right) => createBinaryExpression(left, operator, right));
	    const getPrefixUnaryCreateFunction = memoizeOne((operator) => (operand) => createPrefixUnaryExpression(operator, operand));
	    const getPostfixUnaryCreateFunction = memoizeOne((operator) => (operand) => createPostfixUnaryExpression(operand, operator));
	    const getJSDocPrimaryTypeCreateFunction = memoizeOne((kind) => () => createJSDocPrimaryTypeWorker(kind));
	    const getJSDocUnaryTypeCreateFunction = memoizeOne((kind) => (type) => createJSDocUnaryTypeWorker(kind, type));
	    const getJSDocUnaryTypeUpdateFunction = memoizeOne((kind) => (node, type) => updateJSDocUnaryTypeWorker(kind, node, type));
	    const getJSDocPrePostfixUnaryTypeCreateFunction = memoizeOne((kind) => (type, postfix) => createJSDocPrePostfixUnaryTypeWorker(kind, type, postfix));
	    const getJSDocPrePostfixUnaryTypeUpdateFunction = memoizeOne((kind) => (node, type) => updateJSDocPrePostfixUnaryTypeWorker(kind, node, type));
	    const getJSDocSimpleTagCreateFunction = memoizeOne((kind) => (tagName, comment) => createJSDocSimpleTagWorker(kind, tagName, comment));
	    const getJSDocSimpleTagUpdateFunction = memoizeOne((kind) => (node, tagName, comment) => updateJSDocSimpleTagWorker(kind, node, tagName, comment));
	    const getJSDocTypeLikeTagCreateFunction = memoizeOne((kind) => (tagName, typeExpression, comment) => createJSDocTypeLikeTagWorker(kind, tagName, typeExpression, comment));
	    const getJSDocTypeLikeTagUpdateFunction = memoizeOne((kind) => (node, tagName, typeExpression, comment) => updateJSDocTypeLikeTagWorker(kind, node, tagName, typeExpression, comment));
	    const factory2 = {
	      get parenthesizer() {
	        return parenthesizerRules();
	      },
	      get converters() {
	        return converters();
	      },
	      baseFactory: baseFactory2,
	      flags,
	      createNodeArray,
	      createNumericLiteral,
	      createBigIntLiteral,
	      createStringLiteral,
	      createStringLiteralFromNode,
	      createRegularExpressionLiteral,
	      createLiteralLikeNode,
	      createIdentifier,
	      createTempVariable,
	      createLoopVariable,
	      createUniqueName,
	      getGeneratedNameForNode,
	      createPrivateIdentifier,
	      createUniquePrivateName,
	      getGeneratedPrivateNameForNode,
	      createToken,
	      createSuper,
	      createThis,
	      createNull,
	      createTrue,
	      createFalse,
	      createModifier,
	      createModifiersFromModifierFlags,
	      createQualifiedName,
	      updateQualifiedName,
	      createComputedPropertyName,
	      updateComputedPropertyName,
	      createTypeParameterDeclaration,
	      updateTypeParameterDeclaration,
	      createParameterDeclaration,
	      updateParameterDeclaration,
	      createDecorator,
	      updateDecorator,
	      createPropertySignature,
	      updatePropertySignature,
	      createPropertyDeclaration,
	      updatePropertyDeclaration: updatePropertyDeclaration2,
	      createMethodSignature,
	      updateMethodSignature,
	      createMethodDeclaration,
	      updateMethodDeclaration,
	      createConstructorDeclaration,
	      updateConstructorDeclaration,
	      createGetAccessorDeclaration,
	      updateGetAccessorDeclaration,
	      createSetAccessorDeclaration,
	      updateSetAccessorDeclaration,
	      createCallSignature,
	      updateCallSignature,
	      createConstructSignature,
	      updateConstructSignature,
	      createIndexSignature,
	      updateIndexSignature,
	      createClassStaticBlockDeclaration,
	      updateClassStaticBlockDeclaration,
	      createTemplateLiteralTypeSpan,
	      updateTemplateLiteralTypeSpan,
	      createKeywordTypeNode,
	      createTypePredicateNode,
	      updateTypePredicateNode,
	      createTypeReferenceNode,
	      updateTypeReferenceNode,
	      createFunctionTypeNode,
	      updateFunctionTypeNode,
	      createConstructorTypeNode,
	      updateConstructorTypeNode,
	      createTypeQueryNode,
	      updateTypeQueryNode,
	      createTypeLiteralNode,
	      updateTypeLiteralNode,
	      createArrayTypeNode,
	      updateArrayTypeNode,
	      createTupleTypeNode,
	      updateTupleTypeNode,
	      createNamedTupleMember,
	      updateNamedTupleMember,
	      createOptionalTypeNode,
	      updateOptionalTypeNode,
	      createRestTypeNode,
	      updateRestTypeNode,
	      createUnionTypeNode,
	      updateUnionTypeNode,
	      createIntersectionTypeNode,
	      updateIntersectionTypeNode,
	      createConditionalTypeNode,
	      updateConditionalTypeNode,
	      createInferTypeNode,
	      updateInferTypeNode,
	      createImportTypeNode,
	      updateImportTypeNode,
	      createParenthesizedType,
	      updateParenthesizedType,
	      createThisTypeNode,
	      createTypeOperatorNode,
	      updateTypeOperatorNode,
	      createIndexedAccessTypeNode,
	      updateIndexedAccessTypeNode,
	      createMappedTypeNode,
	      updateMappedTypeNode,
	      createLiteralTypeNode,
	      updateLiteralTypeNode,
	      createTemplateLiteralType,
	      updateTemplateLiteralType,
	      createObjectBindingPattern,
	      updateObjectBindingPattern,
	      createArrayBindingPattern,
	      updateArrayBindingPattern,
	      createBindingElement,
	      updateBindingElement,
	      createArrayLiteralExpression,
	      updateArrayLiteralExpression,
	      createObjectLiteralExpression,
	      updateObjectLiteralExpression,
	      createPropertyAccessExpression: flags & 4 /* NoIndentationOnFreshPropertyAccess */ ? (expression, name) => setEmitFlags(createPropertyAccessExpression(expression, name), 262144 /* NoIndentation */) : createPropertyAccessExpression,
	      updatePropertyAccessExpression,
	      createPropertyAccessChain: flags & 4 /* NoIndentationOnFreshPropertyAccess */ ? (expression, questionDotToken, name) => setEmitFlags(createPropertyAccessChain(expression, questionDotToken, name), 262144 /* NoIndentation */) : createPropertyAccessChain,
	      updatePropertyAccessChain,
	      createElementAccessExpression,
	      updateElementAccessExpression,
	      createElementAccessChain,
	      updateElementAccessChain,
	      createCallExpression,
	      updateCallExpression,
	      createCallChain,
	      updateCallChain,
	      createNewExpression,
	      updateNewExpression,
	      createTaggedTemplateExpression,
	      updateTaggedTemplateExpression,
	      createTypeAssertion,
	      updateTypeAssertion,
	      createParenthesizedExpression,
	      updateParenthesizedExpression,
	      createFunctionExpression,
	      updateFunctionExpression,
	      createArrowFunction,
	      updateArrowFunction,
	      createDeleteExpression,
	      updateDeleteExpression,
	      createTypeOfExpression,
	      updateTypeOfExpression,
	      createVoidExpression,
	      updateVoidExpression,
	      createAwaitExpression,
	      updateAwaitExpression,
	      createPrefixUnaryExpression,
	      updatePrefixUnaryExpression,
	      createPostfixUnaryExpression,
	      updatePostfixUnaryExpression,
	      createBinaryExpression,
	      updateBinaryExpression,
	      createConditionalExpression,
	      updateConditionalExpression,
	      createTemplateExpression,
	      updateTemplateExpression,
	      createTemplateHead,
	      createTemplateMiddle,
	      createTemplateTail,
	      createNoSubstitutionTemplateLiteral,
	      createTemplateLiteralLikeNode,
	      createYieldExpression,
	      updateYieldExpression,
	      createSpreadElement,
	      updateSpreadElement,
	      createClassExpression,
	      updateClassExpression,
	      createOmittedExpression,
	      createExpressionWithTypeArguments,
	      updateExpressionWithTypeArguments,
	      createAsExpression,
	      updateAsExpression,
	      createNonNullExpression,
	      updateNonNullExpression,
	      createSatisfiesExpression,
	      updateSatisfiesExpression,
	      createNonNullChain,
	      updateNonNullChain,
	      createMetaProperty,
	      updateMetaProperty,
	      createTemplateSpan,
	      updateTemplateSpan,
	      createSemicolonClassElement,
	      createBlock,
	      updateBlock,
	      createVariableStatement,
	      updateVariableStatement,
	      createEmptyStatement,
	      createExpressionStatement,
	      updateExpressionStatement,
	      createIfStatement,
	      updateIfStatement,
	      createDoStatement,
	      updateDoStatement,
	      createWhileStatement,
	      updateWhileStatement,
	      createForStatement,
	      updateForStatement,
	      createForInStatement,
	      updateForInStatement,
	      createForOfStatement,
	      updateForOfStatement,
	      createContinueStatement,
	      updateContinueStatement,
	      createBreakStatement,
	      updateBreakStatement,
	      createReturnStatement,
	      updateReturnStatement,
	      createWithStatement,
	      updateWithStatement,
	      createSwitchStatement,
	      updateSwitchStatement,
	      createLabeledStatement,
	      updateLabeledStatement,
	      createThrowStatement,
	      updateThrowStatement,
	      createTryStatement,
	      updateTryStatement,
	      createDebuggerStatement,
	      createVariableDeclaration,
	      updateVariableDeclaration,
	      createVariableDeclarationList,
	      updateVariableDeclarationList,
	      createFunctionDeclaration,
	      updateFunctionDeclaration,
	      createClassDeclaration,
	      updateClassDeclaration,
	      createInterfaceDeclaration,
	      updateInterfaceDeclaration,
	      createTypeAliasDeclaration,
	      updateTypeAliasDeclaration,
	      createEnumDeclaration,
	      updateEnumDeclaration,
	      createModuleDeclaration,
	      updateModuleDeclaration,
	      createModuleBlock,
	      updateModuleBlock,
	      createCaseBlock,
	      updateCaseBlock,
	      createNamespaceExportDeclaration,
	      updateNamespaceExportDeclaration,
	      createImportEqualsDeclaration,
	      updateImportEqualsDeclaration,
	      createImportDeclaration,
	      updateImportDeclaration,
	      createImportClause,
	      updateImportClause,
	      createAssertClause,
	      updateAssertClause,
	      createAssertEntry,
	      updateAssertEntry,
	      createImportTypeAssertionContainer,
	      updateImportTypeAssertionContainer,
	      createImportAttributes,
	      updateImportAttributes,
	      createImportAttribute,
	      updateImportAttribute,
	      createNamespaceImport,
	      updateNamespaceImport,
	      createNamespaceExport,
	      updateNamespaceExport,
	      createNamedImports,
	      updateNamedImports,
	      createImportSpecifier,
	      updateImportSpecifier,
	      createExportAssignment: createExportAssignment2,
	      updateExportAssignment,
	      createExportDeclaration,
	      updateExportDeclaration,
	      createNamedExports,
	      updateNamedExports,
	      createExportSpecifier,
	      updateExportSpecifier,
	      createMissingDeclaration,
	      createExternalModuleReference,
	      updateExternalModuleReference,
	      // lazily load factory members for JSDoc types with similar structure
	      get createJSDocAllType() {
	        return getJSDocPrimaryTypeCreateFunction(319 /* JSDocAllType */);
	      },
	      get createJSDocUnknownType() {
	        return getJSDocPrimaryTypeCreateFunction(320 /* JSDocUnknownType */);
	      },
	      get createJSDocNonNullableType() {
	        return getJSDocPrePostfixUnaryTypeCreateFunction(322 /* JSDocNonNullableType */);
	      },
	      get updateJSDocNonNullableType() {
	        return getJSDocPrePostfixUnaryTypeUpdateFunction(322 /* JSDocNonNullableType */);
	      },
	      get createJSDocNullableType() {
	        return getJSDocPrePostfixUnaryTypeCreateFunction(321 /* JSDocNullableType */);
	      },
	      get updateJSDocNullableType() {
	        return getJSDocPrePostfixUnaryTypeUpdateFunction(321 /* JSDocNullableType */);
	      },
	      get createJSDocOptionalType() {
	        return getJSDocUnaryTypeCreateFunction(323 /* JSDocOptionalType */);
	      },
	      get updateJSDocOptionalType() {
	        return getJSDocUnaryTypeUpdateFunction(323 /* JSDocOptionalType */);
	      },
	      get createJSDocVariadicType() {
	        return getJSDocUnaryTypeCreateFunction(325 /* JSDocVariadicType */);
	      },
	      get updateJSDocVariadicType() {
	        return getJSDocUnaryTypeUpdateFunction(325 /* JSDocVariadicType */);
	      },
	      get createJSDocNamepathType() {
	        return getJSDocUnaryTypeCreateFunction(326 /* JSDocNamepathType */);
	      },
	      get updateJSDocNamepathType() {
	        return getJSDocUnaryTypeUpdateFunction(326 /* JSDocNamepathType */);
	      },
	      createJSDocFunctionType,
	      updateJSDocFunctionType,
	      createJSDocTypeLiteral,
	      updateJSDocTypeLiteral,
	      createJSDocTypeExpression,
	      updateJSDocTypeExpression,
	      createJSDocSignature,
	      updateJSDocSignature,
	      createJSDocTemplateTag,
	      updateJSDocTemplateTag,
	      createJSDocTypedefTag,
	      updateJSDocTypedefTag,
	      createJSDocParameterTag,
	      updateJSDocParameterTag,
	      createJSDocPropertyTag,
	      updateJSDocPropertyTag,
	      createJSDocCallbackTag,
	      updateJSDocCallbackTag,
	      createJSDocOverloadTag,
	      updateJSDocOverloadTag,
	      createJSDocAugmentsTag,
	      updateJSDocAugmentsTag,
	      createJSDocImplementsTag,
	      updateJSDocImplementsTag,
	      createJSDocSeeTag,
	      updateJSDocSeeTag,
	      createJSDocNameReference,
	      updateJSDocNameReference,
	      createJSDocMemberName,
	      updateJSDocMemberName,
	      createJSDocLink,
	      updateJSDocLink,
	      createJSDocLinkCode,
	      updateJSDocLinkCode,
	      createJSDocLinkPlain,
	      updateJSDocLinkPlain,
	      // lazily load factory members for JSDoc tags with similar structure
	      get createJSDocTypeTag() {
	        return getJSDocTypeLikeTagCreateFunction(351 /* JSDocTypeTag */);
	      },
	      get updateJSDocTypeTag() {
	        return getJSDocTypeLikeTagUpdateFunction(351 /* JSDocTypeTag */);
	      },
	      get createJSDocReturnTag() {
	        return getJSDocTypeLikeTagCreateFunction(349 /* JSDocReturnTag */);
	      },
	      get updateJSDocReturnTag() {
	        return getJSDocTypeLikeTagUpdateFunction(349 /* JSDocReturnTag */);
	      },
	      get createJSDocThisTag() {
	        return getJSDocTypeLikeTagCreateFunction(350 /* JSDocThisTag */);
	      },
	      get updateJSDocThisTag() {
	        return getJSDocTypeLikeTagUpdateFunction(350 /* JSDocThisTag */);
	      },
	      get createJSDocAuthorTag() {
	        return getJSDocSimpleTagCreateFunction(337 /* JSDocAuthorTag */);
	      },
	      get updateJSDocAuthorTag() {
	        return getJSDocSimpleTagUpdateFunction(337 /* JSDocAuthorTag */);
	      },
	      get createJSDocClassTag() {
	        return getJSDocSimpleTagCreateFunction(339 /* JSDocClassTag */);
	      },
	      get updateJSDocClassTag() {
	        return getJSDocSimpleTagUpdateFunction(339 /* JSDocClassTag */);
	      },
	      get createJSDocPublicTag() {
	        return getJSDocSimpleTagCreateFunction(340 /* JSDocPublicTag */);
	      },
	      get updateJSDocPublicTag() {
	        return getJSDocSimpleTagUpdateFunction(340 /* JSDocPublicTag */);
	      },
	      get createJSDocPrivateTag() {
	        return getJSDocSimpleTagCreateFunction(341 /* JSDocPrivateTag */);
	      },
	      get updateJSDocPrivateTag() {
	        return getJSDocSimpleTagUpdateFunction(341 /* JSDocPrivateTag */);
	      },
	      get createJSDocProtectedTag() {
	        return getJSDocSimpleTagCreateFunction(342 /* JSDocProtectedTag */);
	      },
	      get updateJSDocProtectedTag() {
	        return getJSDocSimpleTagUpdateFunction(342 /* JSDocProtectedTag */);
	      },
	      get createJSDocReadonlyTag() {
	        return getJSDocSimpleTagCreateFunction(343 /* JSDocReadonlyTag */);
	      },
	      get updateJSDocReadonlyTag() {
	        return getJSDocSimpleTagUpdateFunction(343 /* JSDocReadonlyTag */);
	      },
	      get createJSDocOverrideTag() {
	        return getJSDocSimpleTagCreateFunction(344 /* JSDocOverrideTag */);
	      },
	      get updateJSDocOverrideTag() {
	        return getJSDocSimpleTagUpdateFunction(344 /* JSDocOverrideTag */);
	      },
	      get createJSDocDeprecatedTag() {
	        return getJSDocSimpleTagCreateFunction(338 /* JSDocDeprecatedTag */);
	      },
	      get updateJSDocDeprecatedTag() {
	        return getJSDocSimpleTagUpdateFunction(338 /* JSDocDeprecatedTag */);
	      },
	      get createJSDocThrowsTag() {
	        return getJSDocTypeLikeTagCreateFunction(356 /* JSDocThrowsTag */);
	      },
	      get updateJSDocThrowsTag() {
	        return getJSDocTypeLikeTagUpdateFunction(356 /* JSDocThrowsTag */);
	      },
	      get createJSDocSatisfiesTag() {
	        return getJSDocTypeLikeTagCreateFunction(357 /* JSDocSatisfiesTag */);
	      },
	      get updateJSDocSatisfiesTag() {
	        return getJSDocTypeLikeTagUpdateFunction(357 /* JSDocSatisfiesTag */);
	      },
	      createJSDocEnumTag,
	      updateJSDocEnumTag,
	      createJSDocUnknownTag,
	      updateJSDocUnknownTag,
	      createJSDocText,
	      updateJSDocText,
	      createJSDocComment,
	      updateJSDocComment,
	      createJsxElement,
	      updateJsxElement,
	      createJsxSelfClosingElement,
	      updateJsxSelfClosingElement,
	      createJsxOpeningElement,
	      updateJsxOpeningElement,
	      createJsxClosingElement,
	      updateJsxClosingElement,
	      createJsxFragment,
	      createJsxText,
	      updateJsxText,
	      createJsxOpeningFragment,
	      createJsxJsxClosingFragment,
	      updateJsxFragment,
	      createJsxAttribute,
	      updateJsxAttribute,
	      createJsxAttributes,
	      updateJsxAttributes,
	      createJsxSpreadAttribute,
	      updateJsxSpreadAttribute,
	      createJsxExpression,
	      updateJsxExpression,
	      createJsxNamespacedName,
	      updateJsxNamespacedName,
	      createCaseClause,
	      updateCaseClause,
	      createDefaultClause,
	      updateDefaultClause,
	      createHeritageClause,
	      updateHeritageClause,
	      createCatchClause,
	      updateCatchClause,
	      createPropertyAssignment,
	      updatePropertyAssignment,
	      createShorthandPropertyAssignment,
	      updateShorthandPropertyAssignment,
	      createSpreadAssignment,
	      updateSpreadAssignment,
	      createEnumMember,
	      updateEnumMember,
	      createSourceFile: createSourceFile2,
	      updateSourceFile: updateSourceFile2,
	      createRedirectedSourceFile,
	      createBundle,
	      updateBundle,
	      createUnparsedSource,
	      createUnparsedPrologue,
	      createUnparsedPrepend,
	      createUnparsedTextLike,
	      createUnparsedSyntheticReference,
	      createInputFiles: createInputFiles2,
	      createSyntheticExpression,
	      createSyntaxList: createSyntaxList3,
	      createNotEmittedStatement,
	      createPartiallyEmittedExpression,
	      updatePartiallyEmittedExpression,
	      createCommaListExpression,
	      updateCommaListExpression,
	      createSyntheticReferenceExpression,
	      updateSyntheticReferenceExpression,
	      cloneNode,
	      // Lazily load factory methods for common operator factories and utilities
	      get createComma() {
	        return getBinaryCreateFunction(28 /* CommaToken */);
	      },
	      get createAssignment() {
	        return getBinaryCreateFunction(64 /* EqualsToken */);
	      },
	      get createLogicalOr() {
	        return getBinaryCreateFunction(57 /* BarBarToken */);
	      },
	      get createLogicalAnd() {
	        return getBinaryCreateFunction(56 /* AmpersandAmpersandToken */);
	      },
	      get createBitwiseOr() {
	        return getBinaryCreateFunction(52 /* BarToken */);
	      },
	      get createBitwiseXor() {
	        return getBinaryCreateFunction(53 /* CaretToken */);
	      },
	      get createBitwiseAnd() {
	        return getBinaryCreateFunction(51 /* AmpersandToken */);
	      },
	      get createStrictEquality() {
	        return getBinaryCreateFunction(37 /* EqualsEqualsEqualsToken */);
	      },
	      get createStrictInequality() {
	        return getBinaryCreateFunction(38 /* ExclamationEqualsEqualsToken */);
	      },
	      get createEquality() {
	        return getBinaryCreateFunction(35 /* EqualsEqualsToken */);
	      },
	      get createInequality() {
	        return getBinaryCreateFunction(36 /* ExclamationEqualsToken */);
	      },
	      get createLessThan() {
	        return getBinaryCreateFunction(30 /* LessThanToken */);
	      },
	      get createLessThanEquals() {
	        return getBinaryCreateFunction(33 /* LessThanEqualsToken */);
	      },
	      get createGreaterThan() {
	        return getBinaryCreateFunction(32 /* GreaterThanToken */);
	      },
	      get createGreaterThanEquals() {
	        return getBinaryCreateFunction(34 /* GreaterThanEqualsToken */);
	      },
	      get createLeftShift() {
	        return getBinaryCreateFunction(48 /* LessThanLessThanToken */);
	      },
	      get createRightShift() {
	        return getBinaryCreateFunction(49 /* GreaterThanGreaterThanToken */);
	      },
	      get createUnsignedRightShift() {
	        return getBinaryCreateFunction(50 /* GreaterThanGreaterThanGreaterThanToken */);
	      },
	      get createAdd() {
	        return getBinaryCreateFunction(40 /* PlusToken */);
	      },
	      get createSubtract() {
	        return getBinaryCreateFunction(41 /* MinusToken */);
	      },
	      get createMultiply() {
	        return getBinaryCreateFunction(42 /* AsteriskToken */);
	      },
	      get createDivide() {
	        return getBinaryCreateFunction(44 /* SlashToken */);
	      },
	      get createModulo() {
	        return getBinaryCreateFunction(45 /* PercentToken */);
	      },
	      get createExponent() {
	        return getBinaryCreateFunction(43 /* AsteriskAsteriskToken */);
	      },
	      get createPrefixPlus() {
	        return getPrefixUnaryCreateFunction(40 /* PlusToken */);
	      },
	      get createPrefixMinus() {
	        return getPrefixUnaryCreateFunction(41 /* MinusToken */);
	      },
	      get createPrefixIncrement() {
	        return getPrefixUnaryCreateFunction(46 /* PlusPlusToken */);
	      },
	      get createPrefixDecrement() {
	        return getPrefixUnaryCreateFunction(47 /* MinusMinusToken */);
	      },
	      get createBitwiseNot() {
	        return getPrefixUnaryCreateFunction(55 /* TildeToken */);
	      },
	      get createLogicalNot() {
	        return getPrefixUnaryCreateFunction(54 /* ExclamationToken */);
	      },
	      get createPostfixIncrement() {
	        return getPostfixUnaryCreateFunction(46 /* PlusPlusToken */);
	      },
	      get createPostfixDecrement() {
	        return getPostfixUnaryCreateFunction(47 /* MinusMinusToken */);
	      },
	      // Compound nodes
	      createImmediatelyInvokedFunctionExpression,
	      createImmediatelyInvokedArrowFunction,
	      createVoidZero,
	      createExportDefault,
	      createExternalModuleExport,
	      createTypeCheck,
	      createIsNotTypeCheck,
	      createMethodCall,
	      createGlobalMethodCall,
	      createFunctionBindCall,
	      createFunctionCallCall,
	      createFunctionApplyCall,
	      createArraySliceCall,
	      createArrayConcatCall,
	      createObjectDefinePropertyCall,
	      createObjectGetOwnPropertyDescriptorCall,
	      createReflectGetCall,
	      createReflectSetCall,
	      createPropertyDescriptor,
	      createCallBinding,
	      createAssignmentTargetWrapper,
	      // Utilities
	      inlineExpressions,
	      getInternalName,
	      getLocalName,
	      getExportName,
	      getDeclarationName,
	      getNamespaceMemberName,
	      getExternalModuleOrNamespaceExportName,
	      restoreOuterExpressions,
	      restoreEnclosingLabel,
	      createUseStrictPrologue,
	      copyPrologue,
	      copyStandardPrologue,
	      copyCustomPrologue,
	      ensureUseStrict,
	      liftToBlock,
	      mergeLexicalEnvironment,
	      replaceModifiers,
	      replaceDecoratorsAndModifiers,
	      replacePropertyName
	    };
	    forEach(nodeFactoryPatchers, (fn) => fn(factory2));
	    return factory2;
	    function createNodeArray(elements, hasTrailingComma) {
	      if (elements === void 0 || elements === emptyArray) {
	        elements = [];
	      } else if (isNodeArray(elements)) {
	        if (hasTrailingComma === void 0 || elements.hasTrailingComma === hasTrailingComma) {
	          if (elements.transformFlags === void 0) {
	            aggregateChildrenFlags(elements);
	          }
	          Debug.attachNodeArrayDebugInfo(elements);
	          return elements;
	        }
	        const array2 = elements.slice();
	        array2.pos = elements.pos;
	        array2.end = elements.end;
	        array2.hasTrailingComma = hasTrailingComma;
	        array2.transformFlags = elements.transformFlags;
	        Debug.attachNodeArrayDebugInfo(array2);
	        return array2;
	      }
	      const length2 = elements.length;
	      const array = length2 >= 1 && length2 <= 4 ? elements.slice() : elements;
	      array.pos = -1;
	      array.end = -1;
	      array.hasTrailingComma = !!hasTrailingComma;
	      array.transformFlags = 0 /* None */;
	      aggregateChildrenFlags(array);
	      Debug.attachNodeArrayDebugInfo(array);
	      return array;
	    }
	    function createBaseNode(kind) {
	      return baseFactory2.createBaseNode(kind);
	    }
	    function createBaseDeclaration(kind) {
	      const node = createBaseNode(kind);
	      node.symbol = void 0;
	      node.localSymbol = void 0;
	      return node;
	    }
	    function finishUpdateBaseSignatureDeclaration(updated, original) {
	      if (updated !== original) {
	        updated.typeArguments = original.typeArguments;
	      }
	      return update(updated, original);
	    }
	    function createNumericLiteral(value, numericLiteralFlags = 0 /* None */) {
	      const text = typeof value === "number" ? value + "" : value;
	      Debug.assert(text.charCodeAt(0) !== 45 /* minus */, "Negative numbers should be created in combination with createPrefixUnaryExpression");
	      const node = createBaseDeclaration(9 /* NumericLiteral */);
	      node.text = text;
	      node.numericLiteralFlags = numericLiteralFlags;
	      if (numericLiteralFlags & 384 /* BinaryOrOctalSpecifier */)
	        node.transformFlags |= 1024 /* ContainsES2015 */;
	      return node;
	    }
	    function createBigIntLiteral(value) {
	      const node = createBaseToken(10 /* BigIntLiteral */);
	      node.text = typeof value === "string" ? value : pseudoBigIntToString(value) + "n";
	      node.transformFlags |= 32 /* ContainsES2020 */;
	      return node;
	    }
	    function createBaseStringLiteral(text, isSingleQuote) {
	      const node = createBaseDeclaration(11 /* StringLiteral */);
	      node.text = text;
	      node.singleQuote = isSingleQuote;
	      return node;
	    }
	    function createStringLiteral(text, isSingleQuote, hasExtendedUnicodeEscape) {
	      const node = createBaseStringLiteral(text, isSingleQuote);
	      node.hasExtendedUnicodeEscape = hasExtendedUnicodeEscape;
	      if (hasExtendedUnicodeEscape)
	        node.transformFlags |= 1024 /* ContainsES2015 */;
	      return node;
	    }
	    function createStringLiteralFromNode(sourceNode) {
	      const node = createBaseStringLiteral(
	        getTextOfIdentifierOrLiteral(sourceNode),
	        /*isSingleQuote*/
	        void 0
	      );
	      node.textSourceNode = sourceNode;
	      return node;
	    }
	    function createRegularExpressionLiteral(text) {
	      const node = createBaseToken(14 /* RegularExpressionLiteral */);
	      node.text = text;
	      return node;
	    }
	    function createLiteralLikeNode(kind, text) {
	      switch (kind) {
	        case 9 /* NumericLiteral */:
	          return createNumericLiteral(
	            text,
	            /*numericLiteralFlags*/
	            0
	          );
	        case 10 /* BigIntLiteral */:
	          return createBigIntLiteral(text);
	        case 11 /* StringLiteral */:
	          return createStringLiteral(
	            text,
	            /*isSingleQuote*/
	            void 0
	          );
	        case 12 /* JsxText */:
	          return createJsxText(
	            text,
	            /*containsOnlyTriviaWhiteSpaces*/
	            false
	          );
	        case 13 /* JsxTextAllWhiteSpaces */:
	          return createJsxText(
	            text,
	            /*containsOnlyTriviaWhiteSpaces*/
	            true
	          );
	        case 14 /* RegularExpressionLiteral */:
	          return createRegularExpressionLiteral(text);
	        case 15 /* NoSubstitutionTemplateLiteral */:
	          return createTemplateLiteralLikeNode(
	            kind,
	            text,
	            /*rawText*/
	            void 0,
	            /*templateFlags*/
	            0
	          );
	      }
	    }
	    function createBaseIdentifier(escapedText) {
	      const node = baseFactory2.createBaseIdentifierNode(80 /* Identifier */);
	      node.escapedText = escapedText;
	      node.jsDoc = void 0;
	      node.flowNode = void 0;
	      node.symbol = void 0;
	      return node;
	    }
	    function createBaseGeneratedIdentifier(text, autoGenerateFlags, prefix, suffix) {
	      const node = createBaseIdentifier(escapeLeadingUnderscores(text));
	      setIdentifierAutoGenerate(node, {
	        flags: autoGenerateFlags,
	        id: nextAutoGenerateId,
	        prefix,
	        suffix
	      });
	      nextAutoGenerateId++;
	      return node;
	    }
	    function createIdentifier(text, originalKeywordKind, hasExtendedUnicodeEscape) {
	      if (originalKeywordKind === void 0 && text) {
	        originalKeywordKind = stringToToken(text);
	      }
	      if (originalKeywordKind === 80 /* Identifier */) {
	        originalKeywordKind = void 0;
	      }
	      const node = createBaseIdentifier(escapeLeadingUnderscores(text));
	      if (hasExtendedUnicodeEscape)
	        node.flags |= 256 /* IdentifierHasExtendedUnicodeEscape */;
	      if (node.escapedText === "await") {
	        node.transformFlags |= 67108864 /* ContainsPossibleTopLevelAwait */;
	      }
	      if (node.flags & 256 /* IdentifierHasExtendedUnicodeEscape */) {
	        node.transformFlags |= 1024 /* ContainsES2015 */;
	      }
	      return node;
	    }
	    function createTempVariable(recordTempVariable, reservedInNestedScopes, prefix, suffix) {
	      let flags2 = 1 /* Auto */;
	      if (reservedInNestedScopes)
	        flags2 |= 8 /* ReservedInNestedScopes */;
	      const name = createBaseGeneratedIdentifier("", flags2, prefix, suffix);
	      if (recordTempVariable) {
	        recordTempVariable(name);
	      }
	      return name;
	    }
	    function createLoopVariable(reservedInNestedScopes) {
	      let flags2 = 2 /* Loop */;
	      if (reservedInNestedScopes)
	        flags2 |= 8 /* ReservedInNestedScopes */;
	      return createBaseGeneratedIdentifier(
	        "",
	        flags2,
	        /*prefix*/
	        void 0,
	        /*suffix*/
	        void 0
	      );
	    }
	    function createUniqueName(text, flags2 = 0 /* None */, prefix, suffix) {
	      Debug.assert(!(flags2 & 7 /* KindMask */), "Argument out of range: flags");
	      Debug.assert((flags2 & (16 /* Optimistic */ | 32 /* FileLevel */)) !== 32 /* FileLevel */, "GeneratedIdentifierFlags.FileLevel cannot be set without also setting GeneratedIdentifierFlags.Optimistic");
	      return createBaseGeneratedIdentifier(text, 3 /* Unique */ | flags2, prefix, suffix);
	    }
	    function getGeneratedNameForNode(node, flags2 = 0, prefix, suffix) {
	      Debug.assert(!(flags2 & 7 /* KindMask */), "Argument out of range: flags");
	      const text = !node ? "" : isMemberName(node) ? formatGeneratedName(
	        /*privateName*/
	        false,
	        prefix,
	        node,
	        suffix,
	        idText
	      ) : `generated@${getNodeId(node)}`;
	      if (prefix || suffix)
	        flags2 |= 16 /* Optimistic */;
	      const name = createBaseGeneratedIdentifier(text, 4 /* Node */ | flags2, prefix, suffix);
	      name.original = node;
	      return name;
	    }
	    function createBasePrivateIdentifier(escapedText) {
	      const node = baseFactory2.createBasePrivateIdentifierNode(81 /* PrivateIdentifier */);
	      node.escapedText = escapedText;
	      node.transformFlags |= 16777216 /* ContainsClassFields */;
	      return node;
	    }
	    function createPrivateIdentifier(text) {
	      if (!startsWith(text, "#"))
	        Debug.fail("First character of private identifier must be #: " + text);
	      return createBasePrivateIdentifier(escapeLeadingUnderscores(text));
	    }
	    function createBaseGeneratedPrivateIdentifier(text, autoGenerateFlags, prefix, suffix) {
	      const node = createBasePrivateIdentifier(escapeLeadingUnderscores(text));
	      setIdentifierAutoGenerate(node, {
	        flags: autoGenerateFlags,
	        id: nextAutoGenerateId,
	        prefix,
	        suffix
	      });
	      nextAutoGenerateId++;
	      return node;
	    }
	    function createUniquePrivateName(text, prefix, suffix) {
	      if (text && !startsWith(text, "#"))
	        Debug.fail("First character of private identifier must be #: " + text);
	      const autoGenerateFlags = 8 /* ReservedInNestedScopes */ | (text ? 3 /* Unique */ : 1 /* Auto */);
	      return createBaseGeneratedPrivateIdentifier(text ?? "", autoGenerateFlags, prefix, suffix);
	    }
	    function getGeneratedPrivateNameForNode(node, prefix, suffix) {
	      const text = isMemberName(node) ? formatGeneratedName(
	        /*privateName*/
	        true,
	        prefix,
	        node,
	        suffix,
	        idText
	      ) : `#generated@${getNodeId(node)}`;
	      const flags2 = prefix || suffix ? 16 /* Optimistic */ : 0 /* None */;
	      const name = createBaseGeneratedPrivateIdentifier(text, 4 /* Node */ | flags2, prefix, suffix);
	      name.original = node;
	      return name;
	    }
	    function createBaseToken(kind) {
	      return baseFactory2.createBaseTokenNode(kind);
	    }
	    function createToken(token) {
	      Debug.assert(token >= 0 /* FirstToken */ && token <= 165 /* LastToken */, "Invalid token");
	      Debug.assert(token <= 15 /* FirstTemplateToken */ || token >= 18 /* LastTemplateToken */, "Invalid token. Use 'createTemplateLiteralLikeNode' to create template literals.");
	      Debug.assert(token <= 9 /* FirstLiteralToken */ || token >= 15 /* LastLiteralToken */, "Invalid token. Use 'createLiteralLikeNode' to create literals.");
	      Debug.assert(token !== 80 /* Identifier */, "Invalid token. Use 'createIdentifier' to create identifiers");
	      const node = createBaseToken(token);
	      let transformFlags = 0 /* None */;
	      switch (token) {
	        case 134 /* AsyncKeyword */:
	          transformFlags = 256 /* ContainsES2017 */ | 128 /* ContainsES2018 */;
	          break;
	        case 160 /* UsingKeyword */:
	          transformFlags = 4 /* ContainsESNext */;
	          break;
	        case 125 /* PublicKeyword */:
	        case 123 /* PrivateKeyword */:
	        case 124 /* ProtectedKeyword */:
	        case 148 /* ReadonlyKeyword */:
	        case 128 /* AbstractKeyword */:
	        case 138 /* DeclareKeyword */:
	        case 87 /* ConstKeyword */:
	        case 133 /* AnyKeyword */:
	        case 150 /* NumberKeyword */:
	        case 163 /* BigIntKeyword */:
	        case 146 /* NeverKeyword */:
	        case 151 /* ObjectKeyword */:
	        case 103 /* InKeyword */:
	        case 147 /* OutKeyword */:
	        case 164 /* OverrideKeyword */:
	        case 154 /* StringKeyword */:
	        case 136 /* BooleanKeyword */:
	        case 155 /* SymbolKeyword */:
	        case 116 /* VoidKeyword */:
	        case 159 /* UnknownKeyword */:
	        case 157 /* UndefinedKeyword */:
	          transformFlags = 1 /* ContainsTypeScript */;
	          break;
	        case 108 /* SuperKeyword */:
	          transformFlags = 1024 /* ContainsES2015 */ | 134217728 /* ContainsLexicalSuper */;
	          node.flowNode = void 0;
	          break;
	        case 126 /* StaticKeyword */:
	          transformFlags = 1024 /* ContainsES2015 */;
	          break;
	        case 129 /* AccessorKeyword */:
	          transformFlags = 16777216 /* ContainsClassFields */;
	          break;
	        case 110 /* ThisKeyword */:
	          transformFlags = 16384 /* ContainsLexicalThis */;
	          node.flowNode = void 0;
	          break;
	      }
	      if (transformFlags) {
	        node.transformFlags |= transformFlags;
	      }
	      return node;
	    }
	    function createSuper() {
	      return createToken(108 /* SuperKeyword */);
	    }
	    function createThis() {
	      return createToken(110 /* ThisKeyword */);
	    }
	    function createNull() {
	      return createToken(106 /* NullKeyword */);
	    }
	    function createTrue() {
	      return createToken(112 /* TrueKeyword */);
	    }
	    function createFalse() {
	      return createToken(97 /* FalseKeyword */);
	    }
	    function createModifier(kind) {
	      return createToken(kind);
	    }
	    function createModifiersFromModifierFlags(flags2) {
	      const result = [];
	      if (flags2 & 32 /* Export */)
	        result.push(createModifier(95 /* ExportKeyword */));
	      if (flags2 & 128 /* Ambient */)
	        result.push(createModifier(138 /* DeclareKeyword */));
	      if (flags2 & 2048 /* Default */)
	        result.push(createModifier(90 /* DefaultKeyword */));
	      if (flags2 & 4096 /* Const */)
	        result.push(createModifier(87 /* ConstKeyword */));
	      if (flags2 & 1 /* Public */)
	        result.push(createModifier(125 /* PublicKeyword */));
	      if (flags2 & 2 /* Private */)
	        result.push(createModifier(123 /* PrivateKeyword */));
	      if (flags2 & 4 /* Protected */)
	        result.push(createModifier(124 /* ProtectedKeyword */));
	      if (flags2 & 64 /* Abstract */)
	        result.push(createModifier(128 /* AbstractKeyword */));
	      if (flags2 & 256 /* Static */)
	        result.push(createModifier(126 /* StaticKeyword */));
	      if (flags2 & 16 /* Override */)
	        result.push(createModifier(164 /* OverrideKeyword */));
	      if (flags2 & 8 /* Readonly */)
	        result.push(createModifier(148 /* ReadonlyKeyword */));
	      if (flags2 & 512 /* Accessor */)
	        result.push(createModifier(129 /* AccessorKeyword */));
	      if (flags2 & 1024 /* Async */)
	        result.push(createModifier(134 /* AsyncKeyword */));
	      if (flags2 & 8192 /* In */)
	        result.push(createModifier(103 /* InKeyword */));
	      if (flags2 & 16384 /* Out */)
	        result.push(createModifier(147 /* OutKeyword */));
	      return result.length ? result : void 0;
	    }
	    function createQualifiedName(left, right) {
	      const node = createBaseNode(166 /* QualifiedName */);
	      node.left = left;
	      node.right = asName(right);
	      node.transformFlags |= propagateChildFlags(node.left) | propagateIdentifierNameFlags(node.right);
	      node.flowNode = void 0;
	      return node;
	    }
	    function updateQualifiedName(node, left, right) {
	      return node.left !== left || node.right !== right ? update(createQualifiedName(left, right), node) : node;
	    }
	    function createComputedPropertyName(expression) {
	      const node = createBaseNode(167 /* ComputedPropertyName */);
	      node.expression = parenthesizerRules().parenthesizeExpressionOfComputedPropertyName(expression);
	      node.transformFlags |= propagateChildFlags(node.expression) | 1024 /* ContainsES2015 */ | 131072 /* ContainsComputedPropertyName */;
	      return node;
	    }
	    function updateComputedPropertyName(node, expression) {
	      return node.expression !== expression ? update(createComputedPropertyName(expression), node) : node;
	    }
	    function createTypeParameterDeclaration(modifiers, name, constraint, defaultType) {
	      const node = createBaseDeclaration(168 /* TypeParameter */);
	      node.modifiers = asNodeArray(modifiers);
	      node.name = asName(name);
	      node.constraint = constraint;
	      node.default = defaultType;
	      node.transformFlags = 1 /* ContainsTypeScript */;
	      node.expression = void 0;
	      node.jsDoc = void 0;
	      return node;
	    }
	    function updateTypeParameterDeclaration(node, modifiers, name, constraint, defaultType) {
	      return node.modifiers !== modifiers || node.name !== name || node.constraint !== constraint || node.default !== defaultType ? update(createTypeParameterDeclaration(modifiers, name, constraint, defaultType), node) : node;
	    }
	    function createParameterDeclaration(modifiers, dotDotDotToken, name, questionToken, type, initializer) {
	      const node = createBaseDeclaration(169 /* Parameter */);
	      node.modifiers = asNodeArray(modifiers);
	      node.dotDotDotToken = dotDotDotToken;
	      node.name = asName(name);
	      node.questionToken = questionToken;
	      node.type = type;
	      node.initializer = asInitializer(initializer);
	      if (isThisIdentifier(node.name)) {
	        node.transformFlags = 1 /* ContainsTypeScript */;
	      } else {
	        node.transformFlags = propagateChildrenFlags(node.modifiers) | propagateChildFlags(node.dotDotDotToken) | propagateNameFlags(node.name) | propagateChildFlags(node.questionToken) | propagateChildFlags(node.initializer) | (node.questionToken ?? node.type ? 1 /* ContainsTypeScript */ : 0 /* None */) | (node.dotDotDotToken ?? node.initializer ? 1024 /* ContainsES2015 */ : 0 /* None */) | (modifiersToFlags(node.modifiers) & 31 /* ParameterPropertyModifier */ ? 8192 /* ContainsTypeScriptClassSyntax */ : 0 /* None */);
	      }
	      node.jsDoc = void 0;
	      return node;
	    }
	    function updateParameterDeclaration(node, modifiers, dotDotDotToken, name, questionToken, type, initializer) {
	      return node.modifiers !== modifiers || node.dotDotDotToken !== dotDotDotToken || node.name !== name || node.questionToken !== questionToken || node.type !== type || node.initializer !== initializer ? update(createParameterDeclaration(modifiers, dotDotDotToken, name, questionToken, type, initializer), node) : node;
	    }
	    function createDecorator(expression) {
	      const node = createBaseNode(170 /* Decorator */);
	      node.expression = parenthesizerRules().parenthesizeLeftSideOfAccess(
	        expression,
	        /*optionalChain*/
	        false
	      );
	      node.transformFlags |= propagateChildFlags(node.expression) | 1 /* ContainsTypeScript */ | 8192 /* ContainsTypeScriptClassSyntax */ | 33554432 /* ContainsDecorators */;
	      return node;
	    }
	    function updateDecorator(node, expression) {
	      return node.expression !== expression ? update(createDecorator(expression), node) : node;
	    }
	    function createPropertySignature(modifiers, name, questionToken, type) {
	      const node = createBaseDeclaration(171 /* PropertySignature */);
	      node.modifiers = asNodeArray(modifiers);
	      node.name = asName(name);
	      node.type = type;
	      node.questionToken = questionToken;
	      node.transformFlags = 1 /* ContainsTypeScript */;
	      node.initializer = void 0;
	      node.jsDoc = void 0;
	      return node;
	    }
	    function updatePropertySignature(node, modifiers, name, questionToken, type) {
	      return node.modifiers !== modifiers || node.name !== name || node.questionToken !== questionToken || node.type !== type ? finishUpdatePropertySignature(createPropertySignature(modifiers, name, questionToken, type), node) : node;
	    }
	    function finishUpdatePropertySignature(updated, original) {
	      if (updated !== original) {
	        updated.initializer = original.initializer;
	      }
	      return update(updated, original);
	    }
	    function createPropertyDeclaration(modifiers, name, questionOrExclamationToken, type, initializer) {
	      const node = createBaseDeclaration(172 /* PropertyDeclaration */);
	      node.modifiers = asNodeArray(modifiers);
	      node.name = asName(name);
	      node.questionToken = questionOrExclamationToken && isQuestionToken(questionOrExclamationToken) ? questionOrExclamationToken : void 0;
	      node.exclamationToken = questionOrExclamationToken && isExclamationToken(questionOrExclamationToken) ? questionOrExclamationToken : void 0;
	      node.type = type;
	      node.initializer = asInitializer(initializer);
	      const isAmbient = node.flags & 33554432 /* Ambient */ || modifiersToFlags(node.modifiers) & 128 /* Ambient */;
	      node.transformFlags = propagateChildrenFlags(node.modifiers) | propagateNameFlags(node.name) | propagateChildFlags(node.initializer) | (isAmbient || node.questionToken || node.exclamationToken || node.type ? 1 /* ContainsTypeScript */ : 0 /* None */) | (isComputedPropertyName(node.name) || modifiersToFlags(node.modifiers) & 256 /* Static */ && node.initializer ? 8192 /* ContainsTypeScriptClassSyntax */ : 0 /* None */) | 16777216 /* ContainsClassFields */;
	      node.jsDoc = void 0;
	      return node;
	    }
	    function updatePropertyDeclaration2(node, modifiers, name, questionOrExclamationToken, type, initializer) {
	      return node.modifiers !== modifiers || node.name !== name || node.questionToken !== (questionOrExclamationToken !== void 0 && isQuestionToken(questionOrExclamationToken) ? questionOrExclamationToken : void 0) || node.exclamationToken !== (questionOrExclamationToken !== void 0 && isExclamationToken(questionOrExclamationToken) ? questionOrExclamationToken : void 0) || node.type !== type || node.initializer !== initializer ? update(createPropertyDeclaration(modifiers, name, questionOrExclamationToken, type, initializer), node) : node;
	    }
	    function createMethodSignature(modifiers, name, questionToken, typeParameters, parameters, type) {
	      const node = createBaseDeclaration(173 /* MethodSignature */);
	      node.modifiers = asNodeArray(modifiers);
	      node.name = asName(name);
	      node.questionToken = questionToken;
	      node.typeParameters = asNodeArray(typeParameters);
	      node.parameters = asNodeArray(parameters);
	      node.type = type;
	      node.transformFlags = 1 /* ContainsTypeScript */;
	      node.jsDoc = void 0;
	      node.locals = void 0;
	      node.nextContainer = void 0;
	      node.typeArguments = void 0;
	      return node;
	    }
	    function updateMethodSignature(node, modifiers, name, questionToken, typeParameters, parameters, type) {
	      return node.modifiers !== modifiers || node.name !== name || node.questionToken !== questionToken || node.typeParameters !== typeParameters || node.parameters !== parameters || node.type !== type ? finishUpdateBaseSignatureDeclaration(createMethodSignature(modifiers, name, questionToken, typeParameters, parameters, type), node) : node;
	    }
	    function createMethodDeclaration(modifiers, asteriskToken, name, questionToken, typeParameters, parameters, type, body) {
	      const node = createBaseDeclaration(174 /* MethodDeclaration */);
	      node.modifiers = asNodeArray(modifiers);
	      node.asteriskToken = asteriskToken;
	      node.name = asName(name);
	      node.questionToken = questionToken;
	      node.exclamationToken = void 0;
	      node.typeParameters = asNodeArray(typeParameters);
	      node.parameters = createNodeArray(parameters);
	      node.type = type;
	      node.body = body;
	      if (!node.body) {
	        node.transformFlags = 1 /* ContainsTypeScript */;
	      } else {
	        const isAsync = modifiersToFlags(node.modifiers) & 1024 /* Async */;
	        const isGenerator = !!node.asteriskToken;
	        const isAsyncGenerator = isAsync && isGenerator;
	        node.transformFlags = propagateChildrenFlags(node.modifiers) | propagateChildFlags(node.asteriskToken) | propagateNameFlags(node.name) | propagateChildFlags(node.questionToken) | propagateChildrenFlags(node.typeParameters) | propagateChildrenFlags(node.parameters) | propagateChildFlags(node.type) | propagateChildFlags(node.body) & ~67108864 /* ContainsPossibleTopLevelAwait */ | (isAsyncGenerator ? 128 /* ContainsES2018 */ : isAsync ? 256 /* ContainsES2017 */ : isGenerator ? 2048 /* ContainsGenerator */ : 0 /* None */) | (node.questionToken || node.typeParameters || node.type ? 1 /* ContainsTypeScript */ : 0 /* None */) | 1024 /* ContainsES2015 */;
	      }
	      node.typeArguments = void 0;
	      node.jsDoc = void 0;
	      node.locals = void 0;
	      node.nextContainer = void 0;
	      node.flowNode = void 0;
	      node.endFlowNode = void 0;
	      node.returnFlowNode = void 0;
	      return node;
	    }
	    function updateMethodDeclaration(node, modifiers, asteriskToken, name, questionToken, typeParameters, parameters, type, body) {
	      return node.modifiers !== modifiers || node.asteriskToken !== asteriskToken || node.name !== name || node.questionToken !== questionToken || node.typeParameters !== typeParameters || node.parameters !== parameters || node.type !== type || node.body !== body ? finishUpdateMethodDeclaration(createMethodDeclaration(modifiers, asteriskToken, name, questionToken, typeParameters, parameters, type, body), node) : node;
	    }
	    function finishUpdateMethodDeclaration(updated, original) {
	      if (updated !== original) {
	        updated.exclamationToken = original.exclamationToken;
	      }
	      return update(updated, original);
	    }
	    function createClassStaticBlockDeclaration(body) {
	      const node = createBaseDeclaration(175 /* ClassStaticBlockDeclaration */);
	      node.body = body;
	      node.transformFlags = propagateChildFlags(body) | 16777216 /* ContainsClassFields */;
	      node.modifiers = void 0;
	      node.jsDoc = void 0;
	      node.locals = void 0;
	      node.nextContainer = void 0;
	      node.endFlowNode = void 0;
	      node.returnFlowNode = void 0;
	      return node;
	    }
	    function updateClassStaticBlockDeclaration(node, body) {
	      return node.body !== body ? finishUpdateClassStaticBlockDeclaration(createClassStaticBlockDeclaration(body), node) : node;
	    }
	    function finishUpdateClassStaticBlockDeclaration(updated, original) {
	      if (updated !== original) {
	        updated.modifiers = original.modifiers;
	      }
	      return update(updated, original);
	    }
	    function createConstructorDeclaration(modifiers, parameters, body) {
	      const node = createBaseDeclaration(176 /* Constructor */);
	      node.modifiers = asNodeArray(modifiers);
	      node.parameters = createNodeArray(parameters);
	      node.body = body;
	      node.transformFlags = propagateChildrenFlags(node.modifiers) | propagateChildrenFlags(node.parameters) | propagateChildFlags(node.body) & ~67108864 /* ContainsPossibleTopLevelAwait */ | 1024 /* ContainsES2015 */;
	      node.typeParameters = void 0;
	      node.type = void 0;
	      node.typeArguments = void 0;
	      node.jsDoc = void 0;
	      node.locals = void 0;
	      node.nextContainer = void 0;
	      node.endFlowNode = void 0;
	      node.returnFlowNode = void 0;
	      return node;
	    }
	    function updateConstructorDeclaration(node, modifiers, parameters, body) {
	      return node.modifiers !== modifiers || node.parameters !== parameters || node.body !== body ? finishUpdateConstructorDeclaration(createConstructorDeclaration(modifiers, parameters, body), node) : node;
	    }
	    function finishUpdateConstructorDeclaration(updated, original) {
	      if (updated !== original) {
	        updated.typeParameters = original.typeParameters;
	        updated.type = original.type;
	      }
	      return finishUpdateBaseSignatureDeclaration(updated, original);
	    }
	    function createGetAccessorDeclaration(modifiers, name, parameters, type, body) {
	      const node = createBaseDeclaration(177 /* GetAccessor */);
	      node.modifiers = asNodeArray(modifiers);
	      node.name = asName(name);
	      node.parameters = createNodeArray(parameters);
	      node.type = type;
	      node.body = body;
	      if (!node.body) {
	        node.transformFlags = 1 /* ContainsTypeScript */;
	      } else {
	        node.transformFlags = propagateChildrenFlags(node.modifiers) | propagateNameFlags(node.name) | propagateChildrenFlags(node.parameters) | propagateChildFlags(node.type) | propagateChildFlags(node.body) & ~67108864 /* ContainsPossibleTopLevelAwait */ | (node.type ? 1 /* ContainsTypeScript */ : 0 /* None */);
	      }
	      node.typeArguments = void 0;
	      node.typeParameters = void 0;
	      node.jsDoc = void 0;
	      node.locals = void 0;
	      node.nextContainer = void 0;
	      node.flowNode = void 0;
	      node.endFlowNode = void 0;
	      node.returnFlowNode = void 0;
	      return node;
	    }
	    function updateGetAccessorDeclaration(node, modifiers, name, parameters, type, body) {
	      return node.modifiers !== modifiers || node.name !== name || node.parameters !== parameters || node.type !== type || node.body !== body ? finishUpdateGetAccessorDeclaration(createGetAccessorDeclaration(modifiers, name, parameters, type, body), node) : node;
	    }
	    function finishUpdateGetAccessorDeclaration(updated, original) {
	      if (updated !== original) {
	        updated.typeParameters = original.typeParameters;
	      }
	      return finishUpdateBaseSignatureDeclaration(updated, original);
	    }
	    function createSetAccessorDeclaration(modifiers, name, parameters, body) {
	      const node = createBaseDeclaration(178 /* SetAccessor */);
	      node.modifiers = asNodeArray(modifiers);
	      node.name = asName(name);
	      node.parameters = createNodeArray(parameters);
	      node.body = body;
	      if (!node.body) {
	        node.transformFlags = 1 /* ContainsTypeScript */;
	      } else {
	        node.transformFlags = propagateChildrenFlags(node.modifiers) | propagateNameFlags(node.name) | propagateChildrenFlags(node.parameters) | propagateChildFlags(node.body) & ~67108864 /* ContainsPossibleTopLevelAwait */ | (node.type ? 1 /* ContainsTypeScript */ : 0 /* None */);
	      }
	      node.typeArguments = void 0;
	      node.typeParameters = void 0;
	      node.type = void 0;
	      node.jsDoc = void 0;
	      node.locals = void 0;
	      node.nextContainer = void 0;
	      node.flowNode = void 0;
	      node.endFlowNode = void 0;
	      node.returnFlowNode = void 0;
	      return node;
	    }
	    function updateSetAccessorDeclaration(node, modifiers, name, parameters, body) {
	      return node.modifiers !== modifiers || node.name !== name || node.parameters !== parameters || node.body !== body ? finishUpdateSetAccessorDeclaration(createSetAccessorDeclaration(modifiers, name, parameters, body), node) : node;
	    }
	    function finishUpdateSetAccessorDeclaration(updated, original) {
	      if (updated !== original) {
	        updated.typeParameters = original.typeParameters;
	        updated.type = original.type;
	      }
	      return finishUpdateBaseSignatureDeclaration(updated, original);
	    }
	    function createCallSignature(typeParameters, parameters, type) {
	      const node = createBaseDeclaration(179 /* CallSignature */);
	      node.typeParameters = asNodeArray(typeParameters);
	      node.parameters = asNodeArray(parameters);
	      node.type = type;
	      node.transformFlags = 1 /* ContainsTypeScript */;
	      node.jsDoc = void 0;
	      node.locals = void 0;
	      node.nextContainer = void 0;
	      node.typeArguments = void 0;
	      return node;
	    }
	    function updateCallSignature(node, typeParameters, parameters, type) {
	      return node.typeParameters !== typeParameters || node.parameters !== parameters || node.type !== type ? finishUpdateBaseSignatureDeclaration(createCallSignature(typeParameters, parameters, type), node) : node;
	    }
	    function createConstructSignature(typeParameters, parameters, type) {
	      const node = createBaseDeclaration(180 /* ConstructSignature */);
	      node.typeParameters = asNodeArray(typeParameters);
	      node.parameters = asNodeArray(parameters);
	      node.type = type;
	      node.transformFlags = 1 /* ContainsTypeScript */;
	      node.jsDoc = void 0;
	      node.locals = void 0;
	      node.nextContainer = void 0;
	      node.typeArguments = void 0;
	      return node;
	    }
	    function updateConstructSignature(node, typeParameters, parameters, type) {
	      return node.typeParameters !== typeParameters || node.parameters !== parameters || node.type !== type ? finishUpdateBaseSignatureDeclaration(createConstructSignature(typeParameters, parameters, type), node) : node;
	    }
	    function createIndexSignature(modifiers, parameters, type) {
	      const node = createBaseDeclaration(181 /* IndexSignature */);
	      node.modifiers = asNodeArray(modifiers);
	      node.parameters = asNodeArray(parameters);
	      node.type = type;
	      node.transformFlags = 1 /* ContainsTypeScript */;
	      node.jsDoc = void 0;
	      node.locals = void 0;
	      node.nextContainer = void 0;
	      node.typeArguments = void 0;
	      return node;
	    }
	    function updateIndexSignature(node, modifiers, parameters, type) {
	      return node.parameters !== parameters || node.type !== type || node.modifiers !== modifiers ? finishUpdateBaseSignatureDeclaration(createIndexSignature(modifiers, parameters, type), node) : node;
	    }
	    function createTemplateLiteralTypeSpan(type, literal) {
	      const node = createBaseNode(204 /* TemplateLiteralTypeSpan */);
	      node.type = type;
	      node.literal = literal;
	      node.transformFlags = 1 /* ContainsTypeScript */;
	      return node;
	    }
	    function updateTemplateLiteralTypeSpan(node, type, literal) {
	      return node.type !== type || node.literal !== literal ? update(createTemplateLiteralTypeSpan(type, literal), node) : node;
	    }
	    function createKeywordTypeNode(kind) {
	      return createToken(kind);
	    }
	    function createTypePredicateNode(assertsModifier, parameterName, type) {
	      const node = createBaseNode(182 /* TypePredicate */);
	      node.assertsModifier = assertsModifier;
	      node.parameterName = asName(parameterName);
	      node.type = type;
	      node.transformFlags = 1 /* ContainsTypeScript */;
	      return node;
	    }
	    function updateTypePredicateNode(node, assertsModifier, parameterName, type) {
	      return node.assertsModifier !== assertsModifier || node.parameterName !== parameterName || node.type !== type ? update(createTypePredicateNode(assertsModifier, parameterName, type), node) : node;
	    }
	    function createTypeReferenceNode(typeName, typeArguments) {
	      const node = createBaseNode(183 /* TypeReference */);
	      node.typeName = asName(typeName);
	      node.typeArguments = typeArguments && parenthesizerRules().parenthesizeTypeArguments(createNodeArray(typeArguments));
	      node.transformFlags = 1 /* ContainsTypeScript */;
	      return node;
	    }
	    function updateTypeReferenceNode(node, typeName, typeArguments) {
	      return node.typeName !== typeName || node.typeArguments !== typeArguments ? update(createTypeReferenceNode(typeName, typeArguments), node) : node;
	    }
	    function createFunctionTypeNode(typeParameters, parameters, type) {
	      const node = createBaseDeclaration(184 /* FunctionType */);
	      node.typeParameters = asNodeArray(typeParameters);
	      node.parameters = asNodeArray(parameters);
	      node.type = type;
	      node.transformFlags = 1 /* ContainsTypeScript */;
	      node.modifiers = void 0;
	      node.jsDoc = void 0;
	      node.locals = void 0;
	      node.nextContainer = void 0;
	      node.typeArguments = void 0;
	      return node;
	    }
	    function updateFunctionTypeNode(node, typeParameters, parameters, type) {
	      return node.typeParameters !== typeParameters || node.parameters !== parameters || node.type !== type ? finishUpdateFunctionTypeNode(createFunctionTypeNode(typeParameters, parameters, type), node) : node;
	    }
	    function finishUpdateFunctionTypeNode(updated, original) {
	      if (updated !== original) {
	        updated.modifiers = original.modifiers;
	      }
	      return finishUpdateBaseSignatureDeclaration(updated, original);
	    }
	    function createConstructorTypeNode(...args) {
	      return args.length === 4 ? createConstructorTypeNode1(...args) : args.length === 3 ? createConstructorTypeNode2(...args) : Debug.fail("Incorrect number of arguments specified.");
	    }
	    function createConstructorTypeNode1(modifiers, typeParameters, parameters, type) {
	      const node = createBaseDeclaration(185 /* ConstructorType */);
	      node.modifiers = asNodeArray(modifiers);
	      node.typeParameters = asNodeArray(typeParameters);
	      node.parameters = asNodeArray(parameters);
	      node.type = type;
	      node.transformFlags = 1 /* ContainsTypeScript */;
	      node.jsDoc = void 0;
	      node.locals = void 0;
	      node.nextContainer = void 0;
	      node.typeArguments = void 0;
	      return node;
	    }
	    function createConstructorTypeNode2(typeParameters, parameters, type) {
	      return createConstructorTypeNode1(
	        /*modifiers*/
	        void 0,
	        typeParameters,
	        parameters,
	        type
	      );
	    }
	    function updateConstructorTypeNode(...args) {
	      return args.length === 5 ? updateConstructorTypeNode1(...args) : args.length === 4 ? updateConstructorTypeNode2(...args) : Debug.fail("Incorrect number of arguments specified.");
	    }
	    function updateConstructorTypeNode1(node, modifiers, typeParameters, parameters, type) {
	      return node.modifiers !== modifiers || node.typeParameters !== typeParameters || node.parameters !== parameters || node.type !== type ? finishUpdateBaseSignatureDeclaration(createConstructorTypeNode(modifiers, typeParameters, parameters, type), node) : node;
	    }
	    function updateConstructorTypeNode2(node, typeParameters, parameters, type) {
	      return updateConstructorTypeNode1(node, node.modifiers, typeParameters, parameters, type);
	    }
	    function createTypeQueryNode(exprName, typeArguments) {
	      const node = createBaseNode(186 /* TypeQuery */);
	      node.exprName = exprName;
	      node.typeArguments = typeArguments && parenthesizerRules().parenthesizeTypeArguments(typeArguments);
	      node.transformFlags = 1 /* ContainsTypeScript */;
	      return node;
	    }
	    function updateTypeQueryNode(node, exprName, typeArguments) {
	      return node.exprName !== exprName || node.typeArguments !== typeArguments ? update(createTypeQueryNode(exprName, typeArguments), node) : node;
	    }
	    function createTypeLiteralNode(members) {
	      const node = createBaseDeclaration(187 /* TypeLiteral */);
	      node.members = createNodeArray(members);
	      node.transformFlags = 1 /* ContainsTypeScript */;
	      return node;
	    }
	    function updateTypeLiteralNode(node, members) {
	      return node.members !== members ? update(createTypeLiteralNode(members), node) : node;
	    }
	    function createArrayTypeNode(elementType) {
	      const node = createBaseNode(188 /* ArrayType */);
	      node.elementType = parenthesizerRules().parenthesizeNonArrayTypeOfPostfixType(elementType);
	      node.transformFlags = 1 /* ContainsTypeScript */;
	      return node;
	    }
	    function updateArrayTypeNode(node, elementType) {
	      return node.elementType !== elementType ? update(createArrayTypeNode(elementType), node) : node;
	    }
	    function createTupleTypeNode(elements) {
	      const node = createBaseNode(189 /* TupleType */);
	      node.elements = createNodeArray(parenthesizerRules().parenthesizeElementTypesOfTupleType(elements));
	      node.transformFlags = 1 /* ContainsTypeScript */;
	      return node;
	    }
	    function updateTupleTypeNode(node, elements) {
	      return node.elements !== elements ? update(createTupleTypeNode(elements), node) : node;
	    }
	    function createNamedTupleMember(dotDotDotToken, name, questionToken, type) {
	      const node = createBaseDeclaration(202 /* NamedTupleMember */);
	      node.dotDotDotToken = dotDotDotToken;
	      node.name = name;
	      node.questionToken = questionToken;
	      node.type = type;
	      node.transformFlags = 1 /* ContainsTypeScript */;
	      node.jsDoc = void 0;
	      return node;
	    }
	    function updateNamedTupleMember(node, dotDotDotToken, name, questionToken, type) {
	      return node.dotDotDotToken !== dotDotDotToken || node.name !== name || node.questionToken !== questionToken || node.type !== type ? update(createNamedTupleMember(dotDotDotToken, name, questionToken, type), node) : node;
	    }
	    function createOptionalTypeNode(type) {
	      const node = createBaseNode(190 /* OptionalType */);
	      node.type = parenthesizerRules().parenthesizeTypeOfOptionalType(type);
	      node.transformFlags = 1 /* ContainsTypeScript */;
	      return node;
	    }
	    function updateOptionalTypeNode(node, type) {
	      return node.type !== type ? update(createOptionalTypeNode(type), node) : node;
	    }
	    function createRestTypeNode(type) {
	      const node = createBaseNode(191 /* RestType */);
	      node.type = type;
	      node.transformFlags = 1 /* ContainsTypeScript */;
	      return node;
	    }
	    function updateRestTypeNode(node, type) {
	      return node.type !== type ? update(createRestTypeNode(type), node) : node;
	    }
	    function createUnionOrIntersectionTypeNode(kind, types, parenthesize) {
	      const node = createBaseNode(kind);
	      node.types = factory2.createNodeArray(parenthesize(types));
	      node.transformFlags = 1 /* ContainsTypeScript */;
	      return node;
	    }
	    function updateUnionOrIntersectionTypeNode(node, types, parenthesize) {
	      return node.types !== types ? update(createUnionOrIntersectionTypeNode(node.kind, types, parenthesize), node) : node;
	    }
	    function createUnionTypeNode(types) {
	      return createUnionOrIntersectionTypeNode(192 /* UnionType */, types, parenthesizerRules().parenthesizeConstituentTypesOfUnionType);
	    }
	    function updateUnionTypeNode(node, types) {
	      return updateUnionOrIntersectionTypeNode(node, types, parenthesizerRules().parenthesizeConstituentTypesOfUnionType);
	    }
	    function createIntersectionTypeNode(types) {
	      return createUnionOrIntersectionTypeNode(193 /* IntersectionType */, types, parenthesizerRules().parenthesizeConstituentTypesOfIntersectionType);
	    }
	    function updateIntersectionTypeNode(node, types) {
	      return updateUnionOrIntersectionTypeNode(node, types, parenthesizerRules().parenthesizeConstituentTypesOfIntersectionType);
	    }
	    function createConditionalTypeNode(checkType, extendsType, trueType, falseType) {
	      const node = createBaseNode(194 /* ConditionalType */);
	      node.checkType = parenthesizerRules().parenthesizeCheckTypeOfConditionalType(checkType);
	      node.extendsType = parenthesizerRules().parenthesizeExtendsTypeOfConditionalType(extendsType);
	      node.trueType = trueType;
	      node.falseType = falseType;
	      node.transformFlags = 1 /* ContainsTypeScript */;
	      node.locals = void 0;
	      node.nextContainer = void 0;
	      return node;
	    }
	    function updateConditionalTypeNode(node, checkType, extendsType, trueType, falseType) {
	      return node.checkType !== checkType || node.extendsType !== extendsType || node.trueType !== trueType || node.falseType !== falseType ? update(createConditionalTypeNode(checkType, extendsType, trueType, falseType), node) : node;
	    }
	    function createInferTypeNode(typeParameter) {
	      const node = createBaseNode(195 /* InferType */);
	      node.typeParameter = typeParameter;
	      node.transformFlags = 1 /* ContainsTypeScript */;
	      return node;
	    }
	    function updateInferTypeNode(node, typeParameter) {
	      return node.typeParameter !== typeParameter ? update(createInferTypeNode(typeParameter), node) : node;
	    }
	    function createTemplateLiteralType(head, templateSpans) {
	      const node = createBaseNode(203 /* TemplateLiteralType */);
	      node.head = head;
	      node.templateSpans = createNodeArray(templateSpans);
	      node.transformFlags = 1 /* ContainsTypeScript */;
	      return node;
	    }
	    function updateTemplateLiteralType(node, head, templateSpans) {
	      return node.head !== head || node.templateSpans !== templateSpans ? update(createTemplateLiteralType(head, templateSpans), node) : node;
	    }
	    function createImportTypeNode(argument, attributes, qualifier, typeArguments, isTypeOf = false) {
	      const node = createBaseNode(205 /* ImportType */);
	      node.argument = argument;
	      node.attributes = attributes;
	      if (node.assertions && node.assertions.assertClause && node.attributes) {
	        node.assertions.assertClause = node.attributes;
	      }
	      node.qualifier = qualifier;
	      node.typeArguments = typeArguments && parenthesizerRules().parenthesizeTypeArguments(typeArguments);
	      node.isTypeOf = isTypeOf;
	      node.transformFlags = 1 /* ContainsTypeScript */;
	      return node;
	    }
	    function updateImportTypeNode(node, argument, attributes, qualifier, typeArguments, isTypeOf = node.isTypeOf) {
	      return node.argument !== argument || node.attributes !== attributes || node.qualifier !== qualifier || node.typeArguments !== typeArguments || node.isTypeOf !== isTypeOf ? update(createImportTypeNode(argument, attributes, qualifier, typeArguments, isTypeOf), node) : node;
	    }
	    function createParenthesizedType(type) {
	      const node = createBaseNode(196 /* ParenthesizedType */);
	      node.type = type;
	      node.transformFlags = 1 /* ContainsTypeScript */;
	      return node;
	    }
	    function updateParenthesizedType(node, type) {
	      return node.type !== type ? update(createParenthesizedType(type), node) : node;
	    }
	    function createThisTypeNode() {
	      const node = createBaseNode(197 /* ThisType */);
	      node.transformFlags = 1 /* ContainsTypeScript */;
	      return node;
	    }
	    function createTypeOperatorNode(operator, type) {
	      const node = createBaseNode(198 /* TypeOperator */);
	      node.operator = operator;
	      node.type = operator === 148 /* ReadonlyKeyword */ ? parenthesizerRules().parenthesizeOperandOfReadonlyTypeOperator(type) : parenthesizerRules().parenthesizeOperandOfTypeOperator(type);
	      node.transformFlags = 1 /* ContainsTypeScript */;
	      return node;
	    }
	    function updateTypeOperatorNode(node, type) {
	      return node.type !== type ? update(createTypeOperatorNode(node.operator, type), node) : node;
	    }
	    function createIndexedAccessTypeNode(objectType, indexType) {
	      const node = createBaseNode(199 /* IndexedAccessType */);
	      node.objectType = parenthesizerRules().parenthesizeNonArrayTypeOfPostfixType(objectType);
	      node.indexType = indexType;
	      node.transformFlags = 1 /* ContainsTypeScript */;
	      return node;
	    }
	    function updateIndexedAccessTypeNode(node, objectType, indexType) {
	      return node.objectType !== objectType || node.indexType !== indexType ? update(createIndexedAccessTypeNode(objectType, indexType), node) : node;
	    }
	    function createMappedTypeNode(readonlyToken, typeParameter, nameType, questionToken, type, members) {
	      const node = createBaseDeclaration(200 /* MappedType */);
	      node.readonlyToken = readonlyToken;
	      node.typeParameter = typeParameter;
	      node.nameType = nameType;
	      node.questionToken = questionToken;
	      node.type = type;
	      node.members = members && createNodeArray(members);
	      node.transformFlags = 1 /* ContainsTypeScript */;
	      node.locals = void 0;
	      node.nextContainer = void 0;
	      return node;
	    }
	    function updateMappedTypeNode(node, readonlyToken, typeParameter, nameType, questionToken, type, members) {
	      return node.readonlyToken !== readonlyToken || node.typeParameter !== typeParameter || node.nameType !== nameType || node.questionToken !== questionToken || node.type !== type || node.members !== members ? update(createMappedTypeNode(readonlyToken, typeParameter, nameType, questionToken, type, members), node) : node;
	    }
	    function createLiteralTypeNode(literal) {
	      const node = createBaseNode(201 /* LiteralType */);
	      node.literal = literal;
	      node.transformFlags = 1 /* ContainsTypeScript */;
	      return node;
	    }
	    function updateLiteralTypeNode(node, literal) {
	      return node.literal !== literal ? update(createLiteralTypeNode(literal), node) : node;
	    }
	    function createObjectBindingPattern(elements) {
	      const node = createBaseNode(206 /* ObjectBindingPattern */);
	      node.elements = createNodeArray(elements);
	      node.transformFlags |= propagateChildrenFlags(node.elements) | 1024 /* ContainsES2015 */ | 524288 /* ContainsBindingPattern */;
	      if (node.transformFlags & 32768 /* ContainsRestOrSpread */) {
	        node.transformFlags |= 128 /* ContainsES2018 */ | 65536 /* ContainsObjectRestOrSpread */;
	      }
	      return node;
	    }
	    function updateObjectBindingPattern(node, elements) {
	      return node.elements !== elements ? update(createObjectBindingPattern(elements), node) : node;
	    }
	    function createArrayBindingPattern(elements) {
	      const node = createBaseNode(207 /* ArrayBindingPattern */);
	      node.elements = createNodeArray(elements);
	      node.transformFlags |= propagateChildrenFlags(node.elements) | 1024 /* ContainsES2015 */ | 524288 /* ContainsBindingPattern */;
	      return node;
	    }
	    function updateArrayBindingPattern(node, elements) {
	      return node.elements !== elements ? update(createArrayBindingPattern(elements), node) : node;
	    }
	    function createBindingElement(dotDotDotToken, propertyName, name, initializer) {
	      const node = createBaseDeclaration(208 /* BindingElement */);
	      node.dotDotDotToken = dotDotDotToken;
	      node.propertyName = asName(propertyName);
	      node.name = asName(name);
	      node.initializer = asInitializer(initializer);
	      node.transformFlags |= propagateChildFlags(node.dotDotDotToken) | propagateNameFlags(node.propertyName) | propagateNameFlags(node.name) | propagateChildFlags(node.initializer) | (node.dotDotDotToken ? 32768 /* ContainsRestOrSpread */ : 0 /* None */) | 1024 /* ContainsES2015 */;
	      node.flowNode = void 0;
	      return node;
	    }
	    function updateBindingElement(node, dotDotDotToken, propertyName, name, initializer) {
	      return node.propertyName !== propertyName || node.dotDotDotToken !== dotDotDotToken || node.name !== name || node.initializer !== initializer ? update(createBindingElement(dotDotDotToken, propertyName, name, initializer), node) : node;
	    }
	    function createArrayLiteralExpression(elements, multiLine) {
	      const node = createBaseNode(209 /* ArrayLiteralExpression */);
	      const lastElement = elements && lastOrUndefined(elements);
	      const elementsArray = createNodeArray(elements, lastElement && isOmittedExpression(lastElement) ? true : void 0);
	      node.elements = parenthesizerRules().parenthesizeExpressionsOfCommaDelimitedList(elementsArray);
	      node.multiLine = multiLine;
	      node.transformFlags |= propagateChildrenFlags(node.elements);
	      return node;
	    }
	    function updateArrayLiteralExpression(node, elements) {
	      return node.elements !== elements ? update(createArrayLiteralExpression(elements, node.multiLine), node) : node;
	    }
	    function createObjectLiteralExpression(properties, multiLine) {
	      const node = createBaseDeclaration(210 /* ObjectLiteralExpression */);
	      node.properties = createNodeArray(properties);
	      node.multiLine = multiLine;
	      node.transformFlags |= propagateChildrenFlags(node.properties);
	      node.jsDoc = void 0;
	      return node;
	    }
	    function updateObjectLiteralExpression(node, properties) {
	      return node.properties !== properties ? update(createObjectLiteralExpression(properties, node.multiLine), node) : node;
	    }
	    function createBasePropertyAccessExpression(expression, questionDotToken, name) {
	      const node = createBaseDeclaration(211 /* PropertyAccessExpression */);
	      node.expression = expression;
	      node.questionDotToken = questionDotToken;
	      node.name = name;
	      node.transformFlags = propagateChildFlags(node.expression) | propagateChildFlags(node.questionDotToken) | (isIdentifier(node.name) ? propagateIdentifierNameFlags(node.name) : propagateChildFlags(node.name) | 536870912 /* ContainsPrivateIdentifierInExpression */);
	      node.jsDoc = void 0;
	      node.flowNode = void 0;
	      return node;
	    }
	    function createPropertyAccessExpression(expression, name) {
	      const node = createBasePropertyAccessExpression(
	        parenthesizerRules().parenthesizeLeftSideOfAccess(
	          expression,
	          /*optionalChain*/
	          false
	        ),
	        /*questionDotToken*/
	        void 0,
	        asName(name)
	      );
	      if (isSuperKeyword(expression)) {
	        node.transformFlags |= 256 /* ContainsES2017 */ | 128 /* ContainsES2018 */;
	      }
	      return node;
	    }
	    function updatePropertyAccessExpression(node, expression, name) {
	      if (isPropertyAccessChain(node)) {
	        return updatePropertyAccessChain(node, expression, node.questionDotToken, cast(name, isIdentifier));
	      }
	      return node.expression !== expression || node.name !== name ? update(createPropertyAccessExpression(expression, name), node) : node;
	    }
	    function createPropertyAccessChain(expression, questionDotToken, name) {
	      const node = createBasePropertyAccessExpression(
	        parenthesizerRules().parenthesizeLeftSideOfAccess(
	          expression,
	          /*optionalChain*/
	          true
	        ),
	        questionDotToken,
	        asName(name)
	      );
	      node.flags |= 64 /* OptionalChain */;
	      node.transformFlags |= 32 /* ContainsES2020 */;
	      return node;
	    }
	    function updatePropertyAccessChain(node, expression, questionDotToken, name) {
	      Debug.assert(!!(node.flags & 64 /* OptionalChain */), "Cannot update a PropertyAccessExpression using updatePropertyAccessChain. Use updatePropertyAccess instead.");
	      return node.expression !== expression || node.questionDotToken !== questionDotToken || node.name !== name ? update(createPropertyAccessChain(expression, questionDotToken, name), node) : node;
	    }
	    function createBaseElementAccessExpression(expression, questionDotToken, argumentExpression) {
	      const node = createBaseDeclaration(212 /* ElementAccessExpression */);
	      node.expression = expression;
	      node.questionDotToken = questionDotToken;
	      node.argumentExpression = argumentExpression;
	      node.transformFlags |= propagateChildFlags(node.expression) | propagateChildFlags(node.questionDotToken) | propagateChildFlags(node.argumentExpression);
	      node.jsDoc = void 0;
	      node.flowNode = void 0;
	      return node;
	    }
	    function createElementAccessExpression(expression, index) {
	      const node = createBaseElementAccessExpression(
	        parenthesizerRules().parenthesizeLeftSideOfAccess(
	          expression,
	          /*optionalChain*/
	          false
	        ),
	        /*questionDotToken*/
	        void 0,
	        asExpression(index)
	      );
	      if (isSuperKeyword(expression)) {
	        node.transformFlags |= 256 /* ContainsES2017 */ | 128 /* ContainsES2018 */;
	      }
	      return node;
	    }
	    function updateElementAccessExpression(node, expression, argumentExpression) {
	      if (isElementAccessChain(node)) {
	        return updateElementAccessChain(node, expression, node.questionDotToken, argumentExpression);
	      }
	      return node.expression !== expression || node.argumentExpression !== argumentExpression ? update(createElementAccessExpression(expression, argumentExpression), node) : node;
	    }
	    function createElementAccessChain(expression, questionDotToken, index) {
	      const node = createBaseElementAccessExpression(
	        parenthesizerRules().parenthesizeLeftSideOfAccess(
	          expression,
	          /*optionalChain*/
	          true
	        ),
	        questionDotToken,
	        asExpression(index)
	      );
	      node.flags |= 64 /* OptionalChain */;
	      node.transformFlags |= 32 /* ContainsES2020 */;
	      return node;
	    }
	    function updateElementAccessChain(node, expression, questionDotToken, argumentExpression) {
	      Debug.assert(!!(node.flags & 64 /* OptionalChain */), "Cannot update a ElementAccessExpression using updateElementAccessChain. Use updateElementAccess instead.");
	      return node.expression !== expression || node.questionDotToken !== questionDotToken || node.argumentExpression !== argumentExpression ? update(createElementAccessChain(expression, questionDotToken, argumentExpression), node) : node;
	    }
	    function createBaseCallExpression(expression, questionDotToken, typeArguments, argumentsArray) {
	      const node = createBaseDeclaration(213 /* CallExpression */);
	      node.expression = expression;
	      node.questionDotToken = questionDotToken;
	      node.typeArguments = typeArguments;
	      node.arguments = argumentsArray;
	      node.transformFlags |= propagateChildFlags(node.expression) | propagateChildFlags(node.questionDotToken) | propagateChildrenFlags(node.typeArguments) | propagateChildrenFlags(node.arguments);
	      if (node.typeArguments) {
	        node.transformFlags |= 1 /* ContainsTypeScript */;
	      }
	      if (isSuperProperty(node.expression)) {
	        node.transformFlags |= 16384 /* ContainsLexicalThis */;
	      }
	      return node;
	    }
	    function createCallExpression(expression, typeArguments, argumentsArray) {
	      const node = createBaseCallExpression(
	        parenthesizerRules().parenthesizeLeftSideOfAccess(
	          expression,
	          /*optionalChain*/
	          false
	        ),
	        /*questionDotToken*/
	        void 0,
	        asNodeArray(typeArguments),
	        parenthesizerRules().parenthesizeExpressionsOfCommaDelimitedList(createNodeArray(argumentsArray))
	      );
	      if (isImportKeyword(node.expression)) {
	        node.transformFlags |= 8388608 /* ContainsDynamicImport */;
	      }
	      return node;
	    }
	    function updateCallExpression(node, expression, typeArguments, argumentsArray) {
	      if (isCallChain(node)) {
	        return updateCallChain(node, expression, node.questionDotToken, typeArguments, argumentsArray);
	      }
	      return node.expression !== expression || node.typeArguments !== typeArguments || node.arguments !== argumentsArray ? update(createCallExpression(expression, typeArguments, argumentsArray), node) : node;
	    }
	    function createCallChain(expression, questionDotToken, typeArguments, argumentsArray) {
	      const node = createBaseCallExpression(
	        parenthesizerRules().parenthesizeLeftSideOfAccess(
	          expression,
	          /*optionalChain*/
	          true
	        ),
	        questionDotToken,
	        asNodeArray(typeArguments),
	        parenthesizerRules().parenthesizeExpressionsOfCommaDelimitedList(createNodeArray(argumentsArray))
	      );
	      node.flags |= 64 /* OptionalChain */;
	      node.transformFlags |= 32 /* ContainsES2020 */;
	      return node;
	    }
	    function updateCallChain(node, expression, questionDotToken, typeArguments, argumentsArray) {
	      Debug.assert(!!(node.flags & 64 /* OptionalChain */), "Cannot update a CallExpression using updateCallChain. Use updateCall instead.");
	      return node.expression !== expression || node.questionDotToken !== questionDotToken || node.typeArguments !== typeArguments || node.arguments !== argumentsArray ? update(createCallChain(expression, questionDotToken, typeArguments, argumentsArray), node) : node;
	    }
	    function createNewExpression(expression, typeArguments, argumentsArray) {
	      const node = createBaseDeclaration(214 /* NewExpression */);
	      node.expression = parenthesizerRules().parenthesizeExpressionOfNew(expression);
	      node.typeArguments = asNodeArray(typeArguments);
	      node.arguments = argumentsArray ? parenthesizerRules().parenthesizeExpressionsOfCommaDelimitedList(argumentsArray) : void 0;
	      node.transformFlags |= propagateChildFlags(node.expression) | propagateChildrenFlags(node.typeArguments) | propagateChildrenFlags(node.arguments) | 32 /* ContainsES2020 */;
	      if (node.typeArguments) {
	        node.transformFlags |= 1 /* ContainsTypeScript */;
	      }
	      return node;
	    }
	    function updateNewExpression(node, expression, typeArguments, argumentsArray) {
	      return node.expression !== expression || node.typeArguments !== typeArguments || node.arguments !== argumentsArray ? update(createNewExpression(expression, typeArguments, argumentsArray), node) : node;
	    }
	    function createTaggedTemplateExpression(tag, typeArguments, template) {
	      const node = createBaseNode(215 /* TaggedTemplateExpression */);
	      node.tag = parenthesizerRules().parenthesizeLeftSideOfAccess(
	        tag,
	        /*optionalChain*/
	        false
	      );
	      node.typeArguments = asNodeArray(typeArguments);
	      node.template = template;
	      node.transformFlags |= propagateChildFlags(node.tag) | propagateChildrenFlags(node.typeArguments) | propagateChildFlags(node.template) | 1024 /* ContainsES2015 */;
	      if (node.typeArguments) {
	        node.transformFlags |= 1 /* ContainsTypeScript */;
	      }
	      if (hasInvalidEscape(node.template)) {
	        node.transformFlags |= 128 /* ContainsES2018 */;
	      }
	      return node;
	    }
	    function updateTaggedTemplateExpression(node, tag, typeArguments, template) {
	      return node.tag !== tag || node.typeArguments !== typeArguments || node.template !== template ? update(createTaggedTemplateExpression(tag, typeArguments, template), node) : node;
	    }
	    function createTypeAssertion(type, expression) {
	      const node = createBaseNode(216 /* TypeAssertionExpression */);
	      node.expression = parenthesizerRules().parenthesizeOperandOfPrefixUnary(expression);
	      node.type = type;
	      node.transformFlags |= propagateChildFlags(node.expression) | propagateChildFlags(node.type) | 1 /* ContainsTypeScript */;
	      return node;
	    }
	    function updateTypeAssertion(node, type, expression) {
	      return node.type !== type || node.expression !== expression ? update(createTypeAssertion(type, expression), node) : node;
	    }
	    function createParenthesizedExpression(expression) {
	      const node = createBaseNode(217 /* ParenthesizedExpression */);
	      node.expression = expression;
	      node.transformFlags = propagateChildFlags(node.expression);
	      node.jsDoc = void 0;
	      return node;
	    }
	    function updateParenthesizedExpression(node, expression) {
	      return node.expression !== expression ? update(createParenthesizedExpression(expression), node) : node;
	    }
	    function createFunctionExpression(modifiers, asteriskToken, name, typeParameters, parameters, type, body) {
	      const node = createBaseDeclaration(218 /* FunctionExpression */);
	      node.modifiers = asNodeArray(modifiers);
	      node.asteriskToken = asteriskToken;
	      node.name = asName(name);
	      node.typeParameters = asNodeArray(typeParameters);
	      node.parameters = createNodeArray(parameters);
	      node.type = type;
	      node.body = body;
	      const isAsync = modifiersToFlags(node.modifiers) & 1024 /* Async */;
	      const isGenerator = !!node.asteriskToken;
	      const isAsyncGenerator = isAsync && isGenerator;
	      node.transformFlags = propagateChildrenFlags(node.modifiers) | propagateChildFlags(node.asteriskToken) | propagateNameFlags(node.name) | propagateChildrenFlags(node.typeParameters) | propagateChildrenFlags(node.parameters) | propagateChildFlags(node.type) | propagateChildFlags(node.body) & ~67108864 /* ContainsPossibleTopLevelAwait */ | (isAsyncGenerator ? 128 /* ContainsES2018 */ : isAsync ? 256 /* ContainsES2017 */ : isGenerator ? 2048 /* ContainsGenerator */ : 0 /* None */) | (node.typeParameters || node.type ? 1 /* ContainsTypeScript */ : 0 /* None */) | 4194304 /* ContainsHoistedDeclarationOrCompletion */;
	      node.typeArguments = void 0;
	      node.jsDoc = void 0;
	      node.locals = void 0;
	      node.nextContainer = void 0;
	      node.flowNode = void 0;
	      node.endFlowNode = void 0;
	      node.returnFlowNode = void 0;
	      return node;
	    }
	    function updateFunctionExpression(node, modifiers, asteriskToken, name, typeParameters, parameters, type, body) {
	      return node.name !== name || node.modifiers !== modifiers || node.asteriskToken !== asteriskToken || node.typeParameters !== typeParameters || node.parameters !== parameters || node.type !== type || node.body !== body ? finishUpdateBaseSignatureDeclaration(createFunctionExpression(modifiers, asteriskToken, name, typeParameters, parameters, type, body), node) : node;
	    }
	    function createArrowFunction(modifiers, typeParameters, parameters, type, equalsGreaterThanToken, body) {
	      const node = createBaseDeclaration(219 /* ArrowFunction */);
	      node.modifiers = asNodeArray(modifiers);
	      node.typeParameters = asNodeArray(typeParameters);
	      node.parameters = createNodeArray(parameters);
	      node.type = type;
	      node.equalsGreaterThanToken = equalsGreaterThanToken ?? createToken(39 /* EqualsGreaterThanToken */);
	      node.body = parenthesizerRules().parenthesizeConciseBodyOfArrowFunction(body);
	      const isAsync = modifiersToFlags(node.modifiers) & 1024 /* Async */;
	      node.transformFlags = propagateChildrenFlags(node.modifiers) | propagateChildrenFlags(node.typeParameters) | propagateChildrenFlags(node.parameters) | propagateChildFlags(node.type) | propagateChildFlags(node.equalsGreaterThanToken) | propagateChildFlags(node.body) & ~67108864 /* ContainsPossibleTopLevelAwait */ | (node.typeParameters || node.type ? 1 /* ContainsTypeScript */ : 0 /* None */) | (isAsync ? 256 /* ContainsES2017 */ | 16384 /* ContainsLexicalThis */ : 0 /* None */) | 1024 /* ContainsES2015 */;
	      node.typeArguments = void 0;
	      node.jsDoc = void 0;
	      node.locals = void 0;
	      node.nextContainer = void 0;
	      node.flowNode = void 0;
	      node.endFlowNode = void 0;
	      node.returnFlowNode = void 0;
	      return node;
	    }
	    function updateArrowFunction(node, modifiers, typeParameters, parameters, type, equalsGreaterThanToken, body) {
	      return node.modifiers !== modifiers || node.typeParameters !== typeParameters || node.parameters !== parameters || node.type !== type || node.equalsGreaterThanToken !== equalsGreaterThanToken || node.body !== body ? finishUpdateBaseSignatureDeclaration(createArrowFunction(modifiers, typeParameters, parameters, type, equalsGreaterThanToken, body), node) : node;
	    }
	    function createDeleteExpression(expression) {
	      const node = createBaseNode(220 /* DeleteExpression */);
	      node.expression = parenthesizerRules().parenthesizeOperandOfPrefixUnary(expression);
	      node.transformFlags |= propagateChildFlags(node.expression);
	      return node;
	    }
	    function updateDeleteExpression(node, expression) {
	      return node.expression !== expression ? update(createDeleteExpression(expression), node) : node;
	    }
	    function createTypeOfExpression(expression) {
	      const node = createBaseNode(221 /* TypeOfExpression */);
	      node.expression = parenthesizerRules().parenthesizeOperandOfPrefixUnary(expression);
	      node.transformFlags |= propagateChildFlags(node.expression);
	      return node;
	    }
	    function updateTypeOfExpression(node, expression) {
	      return node.expression !== expression ? update(createTypeOfExpression(expression), node) : node;
	    }
	    function createVoidExpression(expression) {
	      const node = createBaseNode(222 /* VoidExpression */);
	      node.expression = parenthesizerRules().parenthesizeOperandOfPrefixUnary(expression);
	      node.transformFlags |= propagateChildFlags(node.expression);
	      return node;
	    }
	    function updateVoidExpression(node, expression) {
	      return node.expression !== expression ? update(createVoidExpression(expression), node) : node;
	    }
	    function createAwaitExpression(expression) {
	      const node = createBaseNode(223 /* AwaitExpression */);
	      node.expression = parenthesizerRules().parenthesizeOperandOfPrefixUnary(expression);
	      node.transformFlags |= propagateChildFlags(node.expression) | 256 /* ContainsES2017 */ | 128 /* ContainsES2018 */ | 2097152 /* ContainsAwait */;
	      return node;
	    }
	    function updateAwaitExpression(node, expression) {
	      return node.expression !== expression ? update(createAwaitExpression(expression), node) : node;
	    }
	    function createPrefixUnaryExpression(operator, operand) {
	      const node = createBaseNode(224 /* PrefixUnaryExpression */);
	      node.operator = operator;
	      node.operand = parenthesizerRules().parenthesizeOperandOfPrefixUnary(operand);
	      node.transformFlags |= propagateChildFlags(node.operand);
	      if ((operator === 46 /* PlusPlusToken */ || operator === 47 /* MinusMinusToken */) && isIdentifier(node.operand) && !isGeneratedIdentifier(node.operand) && !isLocalName(node.operand)) {
	        node.transformFlags |= 268435456 /* ContainsUpdateExpressionForIdentifier */;
	      }
	      return node;
	    }
	    function updatePrefixUnaryExpression(node, operand) {
	      return node.operand !== operand ? update(createPrefixUnaryExpression(node.operator, operand), node) : node;
	    }
	    function createPostfixUnaryExpression(operand, operator) {
	      const node = createBaseNode(225 /* PostfixUnaryExpression */);
	      node.operator = operator;
	      node.operand = parenthesizerRules().parenthesizeOperandOfPostfixUnary(operand);
	      node.transformFlags |= propagateChildFlags(node.operand);
	      if (isIdentifier(node.operand) && !isGeneratedIdentifier(node.operand) && !isLocalName(node.operand)) {
	        node.transformFlags |= 268435456 /* ContainsUpdateExpressionForIdentifier */;
	      }
	      return node;
	    }
	    function updatePostfixUnaryExpression(node, operand) {
	      return node.operand !== operand ? update(createPostfixUnaryExpression(operand, node.operator), node) : node;
	    }
	    function createBinaryExpression(left, operator, right) {
	      const node = createBaseDeclaration(226 /* BinaryExpression */);
	      const operatorToken = asToken(operator);
	      const operatorKind = operatorToken.kind;
	      node.left = parenthesizerRules().parenthesizeLeftSideOfBinary(operatorKind, left);
	      node.operatorToken = operatorToken;
	      node.right = parenthesizerRules().parenthesizeRightSideOfBinary(operatorKind, node.left, right);
	      node.transformFlags |= propagateChildFlags(node.left) | propagateChildFlags(node.operatorToken) | propagateChildFlags(node.right);
	      if (operatorKind === 61 /* QuestionQuestionToken */) {
	        node.transformFlags |= 32 /* ContainsES2020 */;
	      } else if (operatorKind === 64 /* EqualsToken */) {
	        if (isObjectLiteralExpression(node.left)) {
	          node.transformFlags |= 1024 /* ContainsES2015 */ | 128 /* ContainsES2018 */ | 4096 /* ContainsDestructuringAssignment */ | propagateAssignmentPatternFlags(node.left);
	        } else if (isArrayLiteralExpression(node.left)) {
	          node.transformFlags |= 1024 /* ContainsES2015 */ | 4096 /* ContainsDestructuringAssignment */ | propagateAssignmentPatternFlags(node.left);
	        }
	      } else if (operatorKind === 43 /* AsteriskAsteriskToken */ || operatorKind === 68 /* AsteriskAsteriskEqualsToken */) {
	        node.transformFlags |= 512 /* ContainsES2016 */;
	      } else if (isLogicalOrCoalescingAssignmentOperator(operatorKind)) {
	        node.transformFlags |= 16 /* ContainsES2021 */;
	      }
	      if (operatorKind === 103 /* InKeyword */ && isPrivateIdentifier(node.left)) {
	        node.transformFlags |= 536870912 /* ContainsPrivateIdentifierInExpression */;
	      }
	      node.jsDoc = void 0;
	      return node;
	    }
	    function propagateAssignmentPatternFlags(node) {
	      return containsObjectRestOrSpread(node) ? 65536 /* ContainsObjectRestOrSpread */ : 0 /* None */;
	    }
	    function updateBinaryExpression(node, left, operator, right) {
	      return node.left !== left || node.operatorToken !== operator || node.right !== right ? update(createBinaryExpression(left, operator, right), node) : node;
	    }
	    function createConditionalExpression(condition, questionToken, whenTrue, colonToken, whenFalse) {
	      const node = createBaseNode(227 /* ConditionalExpression */);
	      node.condition = parenthesizerRules().parenthesizeConditionOfConditionalExpression(condition);
	      node.questionToken = questionToken ?? createToken(58 /* QuestionToken */);
	      node.whenTrue = parenthesizerRules().parenthesizeBranchOfConditionalExpression(whenTrue);
	      node.colonToken = colonToken ?? createToken(59 /* ColonToken */);
	      node.whenFalse = parenthesizerRules().parenthesizeBranchOfConditionalExpression(whenFalse);
	      node.transformFlags |= propagateChildFlags(node.condition) | propagateChildFlags(node.questionToken) | propagateChildFlags(node.whenTrue) | propagateChildFlags(node.colonToken) | propagateChildFlags(node.whenFalse);
	      return node;
	    }
	    function updateConditionalExpression(node, condition, questionToken, whenTrue, colonToken, whenFalse) {
	      return node.condition !== condition || node.questionToken !== questionToken || node.whenTrue !== whenTrue || node.colonToken !== colonToken || node.whenFalse !== whenFalse ? update(createConditionalExpression(condition, questionToken, whenTrue, colonToken, whenFalse), node) : node;
	    }
	    function createTemplateExpression(head, templateSpans) {
	      const node = createBaseNode(228 /* TemplateExpression */);
	      node.head = head;
	      node.templateSpans = createNodeArray(templateSpans);
	      node.transformFlags |= propagateChildFlags(node.head) | propagateChildrenFlags(node.templateSpans) | 1024 /* ContainsES2015 */;
	      return node;
	    }
	    function updateTemplateExpression(node, head, templateSpans) {
	      return node.head !== head || node.templateSpans !== templateSpans ? update(createTemplateExpression(head, templateSpans), node) : node;
	    }
	    function checkTemplateLiteralLikeNode(kind, text, rawText, templateFlags = 0 /* None */) {
	      Debug.assert(!(templateFlags & ~7176 /* TemplateLiteralLikeFlags */), "Unsupported template flags.");
	      let cooked = void 0;
	      if (rawText !== void 0 && rawText !== text) {
	        cooked = getCookedText(kind, rawText);
	        if (typeof cooked === "object") {
	          return Debug.fail("Invalid raw text");
	        }
	      }
	      if (text === void 0) {
	        if (cooked === void 0) {
	          return Debug.fail("Arguments 'text' and 'rawText' may not both be undefined.");
	        }
	        text = cooked;
	      } else if (cooked !== void 0) {
	        Debug.assert(text === cooked, "Expected argument 'text' to be the normalized (i.e. 'cooked') version of argument 'rawText'.");
	      }
	      return text;
	    }
	    function getTransformFlagsOfTemplateLiteralLike(templateFlags) {
	      let transformFlags = 1024 /* ContainsES2015 */;
	      if (templateFlags) {
	        transformFlags |= 128 /* ContainsES2018 */;
	      }
	      return transformFlags;
	    }
	    function createTemplateLiteralLikeToken(kind, text, rawText, templateFlags) {
	      const node = createBaseToken(kind);
	      node.text = text;
	      node.rawText = rawText;
	      node.templateFlags = templateFlags & 7176 /* TemplateLiteralLikeFlags */;
	      node.transformFlags = getTransformFlagsOfTemplateLiteralLike(node.templateFlags);
	      return node;
	    }
	    function createTemplateLiteralLikeDeclaration(kind, text, rawText, templateFlags) {
	      const node = createBaseDeclaration(kind);
	      node.text = text;
	      node.rawText = rawText;
	      node.templateFlags = templateFlags & 7176 /* TemplateLiteralLikeFlags */;
	      node.transformFlags = getTransformFlagsOfTemplateLiteralLike(node.templateFlags);
	      return node;
	    }
	    function createTemplateLiteralLikeNode(kind, text, rawText, templateFlags) {
	      if (kind === 15 /* NoSubstitutionTemplateLiteral */) {
	        return createTemplateLiteralLikeDeclaration(kind, text, rawText, templateFlags);
	      }
	      return createTemplateLiteralLikeToken(kind, text, rawText, templateFlags);
	    }
	    function createTemplateHead(text, rawText, templateFlags) {
	      text = checkTemplateLiteralLikeNode(16 /* TemplateHead */, text, rawText, templateFlags);
	      return createTemplateLiteralLikeNode(16 /* TemplateHead */, text, rawText, templateFlags);
	    }
	    function createTemplateMiddle(text, rawText, templateFlags) {
	      text = checkTemplateLiteralLikeNode(16 /* TemplateHead */, text, rawText, templateFlags);
	      return createTemplateLiteralLikeNode(17 /* TemplateMiddle */, text, rawText, templateFlags);
	    }
	    function createTemplateTail(text, rawText, templateFlags) {
	      text = checkTemplateLiteralLikeNode(16 /* TemplateHead */, text, rawText, templateFlags);
	      return createTemplateLiteralLikeNode(18 /* TemplateTail */, text, rawText, templateFlags);
	    }
	    function createNoSubstitutionTemplateLiteral(text, rawText, templateFlags) {
	      text = checkTemplateLiteralLikeNode(16 /* TemplateHead */, text, rawText, templateFlags);
	      return createTemplateLiteralLikeDeclaration(15 /* NoSubstitutionTemplateLiteral */, text, rawText, templateFlags);
	    }
	    function createYieldExpression(asteriskToken, expression) {
	      Debug.assert(!asteriskToken || !!expression, "A `YieldExpression` with an asteriskToken must have an expression.");
	      const node = createBaseNode(229 /* YieldExpression */);
	      node.expression = expression && parenthesizerRules().parenthesizeExpressionForDisallowedComma(expression);
	      node.asteriskToken = asteriskToken;
	      node.transformFlags |= propagateChildFlags(node.expression) | propagateChildFlags(node.asteriskToken) | 1024 /* ContainsES2015 */ | 128 /* ContainsES2018 */ | 1048576 /* ContainsYield */;
	      return node;
	    }
	    function updateYieldExpression(node, asteriskToken, expression) {
	      return node.expression !== expression || node.asteriskToken !== asteriskToken ? update(createYieldExpression(asteriskToken, expression), node) : node;
	    }
	    function createSpreadElement(expression) {
	      const node = createBaseNode(230 /* SpreadElement */);
	      node.expression = parenthesizerRules().parenthesizeExpressionForDisallowedComma(expression);
	      node.transformFlags |= propagateChildFlags(node.expression) | 1024 /* ContainsES2015 */ | 32768 /* ContainsRestOrSpread */;
	      return node;
	    }
	    function updateSpreadElement(node, expression) {
	      return node.expression !== expression ? update(createSpreadElement(expression), node) : node;
	    }
	    function createClassExpression(modifiers, name, typeParameters, heritageClauses, members) {
	      const node = createBaseDeclaration(231 /* ClassExpression */);
	      node.modifiers = asNodeArray(modifiers);
	      node.name = asName(name);
	      node.typeParameters = asNodeArray(typeParameters);
	      node.heritageClauses = asNodeArray(heritageClauses);
	      node.members = createNodeArray(members);
	      node.transformFlags |= propagateChildrenFlags(node.modifiers) | propagateNameFlags(node.name) | propagateChildrenFlags(node.typeParameters) | propagateChildrenFlags(node.heritageClauses) | propagateChildrenFlags(node.members) | (node.typeParameters ? 1 /* ContainsTypeScript */ : 0 /* None */) | 1024 /* ContainsES2015 */;
	      node.jsDoc = void 0;
	      return node;
	    }
	    function updateClassExpression(node, modifiers, name, typeParameters, heritageClauses, members) {
	      return node.modifiers !== modifiers || node.name !== name || node.typeParameters !== typeParameters || node.heritageClauses !== heritageClauses || node.members !== members ? update(createClassExpression(modifiers, name, typeParameters, heritageClauses, members), node) : node;
	    }
	    function createOmittedExpression() {
	      return createBaseNode(232 /* OmittedExpression */);
	    }
	    function createExpressionWithTypeArguments(expression, typeArguments) {
	      const node = createBaseNode(233 /* ExpressionWithTypeArguments */);
	      node.expression = parenthesizerRules().parenthesizeLeftSideOfAccess(
	        expression,
	        /*optionalChain*/
	        false
	      );
	      node.typeArguments = typeArguments && parenthesizerRules().parenthesizeTypeArguments(typeArguments);
	      node.transformFlags |= propagateChildFlags(node.expression) | propagateChildrenFlags(node.typeArguments) | 1024 /* ContainsES2015 */;
	      return node;
	    }
	    function updateExpressionWithTypeArguments(node, expression, typeArguments) {
	      return node.expression !== expression || node.typeArguments !== typeArguments ? update(createExpressionWithTypeArguments(expression, typeArguments), node) : node;
	    }
	    function createAsExpression(expression, type) {
	      const node = createBaseNode(234 /* AsExpression */);
	      node.expression = expression;
	      node.type = type;
	      node.transformFlags |= propagateChildFlags(node.expression) | propagateChildFlags(node.type) | 1 /* ContainsTypeScript */;
	      return node;
	    }
	    function updateAsExpression(node, expression, type) {
	      return node.expression !== expression || node.type !== type ? update(createAsExpression(expression, type), node) : node;
	    }
	    function createNonNullExpression(expression) {
	      const node = createBaseNode(235 /* NonNullExpression */);
	      node.expression = parenthesizerRules().parenthesizeLeftSideOfAccess(
	        expression,
	        /*optionalChain*/
	        false
	      );
	      node.transformFlags |= propagateChildFlags(node.expression) | 1 /* ContainsTypeScript */;
	      return node;
	    }
	    function updateNonNullExpression(node, expression) {
	      if (isNonNullChain(node)) {
	        return updateNonNullChain(node, expression);
	      }
	      return node.expression !== expression ? update(createNonNullExpression(expression), node) : node;
	    }
	    function createSatisfiesExpression(expression, type) {
	      const node = createBaseNode(238 /* SatisfiesExpression */);
	      node.expression = expression;
	      node.type = type;
	      node.transformFlags |= propagateChildFlags(node.expression) | propagateChildFlags(node.type) | 1 /* ContainsTypeScript */;
	      return node;
	    }
	    function updateSatisfiesExpression(node, expression, type) {
	      return node.expression !== expression || node.type !== type ? update(createSatisfiesExpression(expression, type), node) : node;
	    }
	    function createNonNullChain(expression) {
	      const node = createBaseNode(235 /* NonNullExpression */);
	      node.flags |= 64 /* OptionalChain */;
	      node.expression = parenthesizerRules().parenthesizeLeftSideOfAccess(
	        expression,
	        /*optionalChain*/
	        true
	      );
	      node.transformFlags |= propagateChildFlags(node.expression) | 1 /* ContainsTypeScript */;
	      return node;
	    }
	    function updateNonNullChain(node, expression) {
	      Debug.assert(!!(node.flags & 64 /* OptionalChain */), "Cannot update a NonNullExpression using updateNonNullChain. Use updateNonNullExpression instead.");
	      return node.expression !== expression ? update(createNonNullChain(expression), node) : node;
	    }
	    function createMetaProperty(keywordToken, name) {
	      const node = createBaseNode(236 /* MetaProperty */);
	      node.keywordToken = keywordToken;
	      node.name = name;
	      node.transformFlags |= propagateChildFlags(node.name);
	      switch (keywordToken) {
	        case 105 /* NewKeyword */:
	          node.transformFlags |= 1024 /* ContainsES2015 */;
	          break;
	        case 102 /* ImportKeyword */:
	          node.transformFlags |= 32 /* ContainsES2020 */;
	          break;
	        default:
	          return Debug.assertNever(keywordToken);
	      }
	      node.flowNode = void 0;
	      return node;
	    }
	    function updateMetaProperty(node, name) {
	      return node.name !== name ? update(createMetaProperty(node.keywordToken, name), node) : node;
	    }
	    function createTemplateSpan(expression, literal) {
	      const node = createBaseNode(239 /* TemplateSpan */);
	      node.expression = expression;
	      node.literal = literal;
	      node.transformFlags |= propagateChildFlags(node.expression) | propagateChildFlags(node.literal) | 1024 /* ContainsES2015 */;
	      return node;
	    }
	    function updateTemplateSpan(node, expression, literal) {
	      return node.expression !== expression || node.literal !== literal ? update(createTemplateSpan(expression, literal), node) : node;
	    }
	    function createSemicolonClassElement() {
	      const node = createBaseNode(240 /* SemicolonClassElement */);
	      node.transformFlags |= 1024 /* ContainsES2015 */;
	      return node;
	    }
	    function createBlock(statements, multiLine) {
	      const node = createBaseNode(241 /* Block */);
	      node.statements = createNodeArray(statements);
	      node.multiLine = multiLine;
	      node.transformFlags |= propagateChildrenFlags(node.statements);
	      node.jsDoc = void 0;
	      node.locals = void 0;
	      node.nextContainer = void 0;
	      return node;
	    }
	    function updateBlock(node, statements) {
	      return node.statements !== statements ? update(createBlock(statements, node.multiLine), node) : node;
	    }
	    function createVariableStatement(modifiers, declarationList) {
	      const node = createBaseNode(243 /* VariableStatement */);
	      node.modifiers = asNodeArray(modifiers);
	      node.declarationList = isArray(declarationList) ? createVariableDeclarationList(declarationList) : declarationList;
	      node.transformFlags |= propagateChildrenFlags(node.modifiers) | propagateChildFlags(node.declarationList);
	      if (modifiersToFlags(node.modifiers) & 128 /* Ambient */) {
	        node.transformFlags = 1 /* ContainsTypeScript */;
	      }
	      node.jsDoc = void 0;
	      node.flowNode = void 0;
	      return node;
	    }
	    function updateVariableStatement(node, modifiers, declarationList) {
	      return node.modifiers !== modifiers || node.declarationList !== declarationList ? update(createVariableStatement(modifiers, declarationList), node) : node;
	    }
	    function createEmptyStatement() {
	      const node = createBaseNode(242 /* EmptyStatement */);
	      node.jsDoc = void 0;
	      return node;
	    }
	    function createExpressionStatement(expression) {
	      const node = createBaseNode(244 /* ExpressionStatement */);
	      node.expression = parenthesizerRules().parenthesizeExpressionOfExpressionStatement(expression);
	      node.transformFlags |= propagateChildFlags(node.expression);
	      node.jsDoc = void 0;
	      node.flowNode = void 0;
	      return node;
	    }
	    function updateExpressionStatement(node, expression) {
	      return node.expression !== expression ? update(createExpressionStatement(expression), node) : node;
	    }
	    function createIfStatement(expression, thenStatement, elseStatement) {
	      const node = createBaseNode(245 /* IfStatement */);
	      node.expression = expression;
	      node.thenStatement = asEmbeddedStatement(thenStatement);
	      node.elseStatement = asEmbeddedStatement(elseStatement);
	      node.transformFlags |= propagateChildFlags(node.expression) | propagateChildFlags(node.thenStatement) | propagateChildFlags(node.elseStatement);
	      node.jsDoc = void 0;
	      node.flowNode = void 0;
	      return node;
	    }
	    function updateIfStatement(node, expression, thenStatement, elseStatement) {
	      return node.expression !== expression || node.thenStatement !== thenStatement || node.elseStatement !== elseStatement ? update(createIfStatement(expression, thenStatement, elseStatement), node) : node;
	    }
	    function createDoStatement(statement, expression) {
	      const node = createBaseNode(246 /* DoStatement */);
	      node.statement = asEmbeddedStatement(statement);
	      node.expression = expression;
	      node.transformFlags |= propagateChildFlags(node.statement) | propagateChildFlags(node.expression);
	      node.jsDoc = void 0;
	      node.flowNode = void 0;
	      return node;
	    }
	    function updateDoStatement(node, statement, expression) {
	      return node.statement !== statement || node.expression !== expression ? update(createDoStatement(statement, expression), node) : node;
	    }
	    function createWhileStatement(expression, statement) {
	      const node = createBaseNode(247 /* WhileStatement */);
	      node.expression = expression;
	      node.statement = asEmbeddedStatement(statement);
	      node.transformFlags |= propagateChildFlags(node.expression) | propagateChildFlags(node.statement);
	      node.jsDoc = void 0;
	      node.flowNode = void 0;
	      return node;
	    }
	    function updateWhileStatement(node, expression, statement) {
	      return node.expression !== expression || node.statement !== statement ? update(createWhileStatement(expression, statement), node) : node;
	    }
	    function createForStatement(initializer, condition, incrementor, statement) {
	      const node = createBaseNode(248 /* ForStatement */);
	      node.initializer = initializer;
	      node.condition = condition;
	      node.incrementor = incrementor;
	      node.statement = asEmbeddedStatement(statement);
	      node.transformFlags |= propagateChildFlags(node.initializer) | propagateChildFlags(node.condition) | propagateChildFlags(node.incrementor) | propagateChildFlags(node.statement);
	      node.jsDoc = void 0;
	      node.locals = void 0;
	      node.nextContainer = void 0;
	      node.flowNode = void 0;
	      return node;
	    }
	    function updateForStatement(node, initializer, condition, incrementor, statement) {
	      return node.initializer !== initializer || node.condition !== condition || node.incrementor !== incrementor || node.statement !== statement ? update(createForStatement(initializer, condition, incrementor, statement), node) : node;
	    }
	    function createForInStatement(initializer, expression, statement) {
	      const node = createBaseNode(249 /* ForInStatement */);
	      node.initializer = initializer;
	      node.expression = expression;
	      node.statement = asEmbeddedStatement(statement);
	      node.transformFlags |= propagateChildFlags(node.initializer) | propagateChildFlags(node.expression) | propagateChildFlags(node.statement);
	      node.jsDoc = void 0;
	      node.locals = void 0;
	      node.nextContainer = void 0;
	      node.flowNode = void 0;
	      return node;
	    }
	    function updateForInStatement(node, initializer, expression, statement) {
	      return node.initializer !== initializer || node.expression !== expression || node.statement !== statement ? update(createForInStatement(initializer, expression, statement), node) : node;
	    }
	    function createForOfStatement(awaitModifier, initializer, expression, statement) {
	      const node = createBaseNode(250 /* ForOfStatement */);
	      node.awaitModifier = awaitModifier;
	      node.initializer = initializer;
	      node.expression = parenthesizerRules().parenthesizeExpressionForDisallowedComma(expression);
	      node.statement = asEmbeddedStatement(statement);
	      node.transformFlags |= propagateChildFlags(node.awaitModifier) | propagateChildFlags(node.initializer) | propagateChildFlags(node.expression) | propagateChildFlags(node.statement) | 1024 /* ContainsES2015 */;
	      if (awaitModifier)
	        node.transformFlags |= 128 /* ContainsES2018 */;
	      node.jsDoc = void 0;
	      node.locals = void 0;
	      node.nextContainer = void 0;
	      node.flowNode = void 0;
	      return node;
	    }
	    function updateForOfStatement(node, awaitModifier, initializer, expression, statement) {
	      return node.awaitModifier !== awaitModifier || node.initializer !== initializer || node.expression !== expression || node.statement !== statement ? update(createForOfStatement(awaitModifier, initializer, expression, statement), node) : node;
	    }
	    function createContinueStatement(label) {
	      const node = createBaseNode(251 /* ContinueStatement */);
	      node.label = asName(label);
	      node.transformFlags |= propagateChildFlags(node.label) | 4194304 /* ContainsHoistedDeclarationOrCompletion */;
	      node.jsDoc = void 0;
	      node.flowNode = void 0;
	      return node;
	    }
	    function updateContinueStatement(node, label) {
	      return node.label !== label ? update(createContinueStatement(label), node) : node;
	    }
	    function createBreakStatement(label) {
	      const node = createBaseNode(252 /* BreakStatement */);
	      node.label = asName(label);
	      node.transformFlags |= propagateChildFlags(node.label) | 4194304 /* ContainsHoistedDeclarationOrCompletion */;
	      node.jsDoc = void 0;
	      node.flowNode = void 0;
	      return node;
	    }
	    function updateBreakStatement(node, label) {
	      return node.label !== label ? update(createBreakStatement(label), node) : node;
	    }
	    function createReturnStatement(expression) {
	      const node = createBaseNode(253 /* ReturnStatement */);
	      node.expression = expression;
	      node.transformFlags |= propagateChildFlags(node.expression) | 128 /* ContainsES2018 */ | 4194304 /* ContainsHoistedDeclarationOrCompletion */;
	      node.jsDoc = void 0;
	      node.flowNode = void 0;
	      return node;
	    }
	    function updateReturnStatement(node, expression) {
	      return node.expression !== expression ? update(createReturnStatement(expression), node) : node;
	    }
	    function createWithStatement(expression, statement) {
	      const node = createBaseNode(254 /* WithStatement */);
	      node.expression = expression;
	      node.statement = asEmbeddedStatement(statement);
	      node.transformFlags |= propagateChildFlags(node.expression) | propagateChildFlags(node.statement);
	      node.jsDoc = void 0;
	      node.flowNode = void 0;
	      return node;
	    }
	    function updateWithStatement(node, expression, statement) {
	      return node.expression !== expression || node.statement !== statement ? update(createWithStatement(expression, statement), node) : node;
	    }
	    function createSwitchStatement(expression, caseBlock) {
	      const node = createBaseNode(255 /* SwitchStatement */);
	      node.expression = parenthesizerRules().parenthesizeExpressionForDisallowedComma(expression);
	      node.caseBlock = caseBlock;
	      node.transformFlags |= propagateChildFlags(node.expression) | propagateChildFlags(node.caseBlock);
	      node.jsDoc = void 0;
	      node.flowNode = void 0;
	      node.possiblyExhaustive = false;
	      return node;
	    }
	    function updateSwitchStatement(node, expression, caseBlock) {
	      return node.expression !== expression || node.caseBlock !== caseBlock ? update(createSwitchStatement(expression, caseBlock), node) : node;
	    }
	    function createLabeledStatement(label, statement) {
	      const node = createBaseNode(256 /* LabeledStatement */);
	      node.label = asName(label);
	      node.statement = asEmbeddedStatement(statement);
	      node.transformFlags |= propagateChildFlags(node.label) | propagateChildFlags(node.statement);
	      node.jsDoc = void 0;
	      node.flowNode = void 0;
	      return node;
	    }
	    function updateLabeledStatement(node, label, statement) {
	      return node.label !== label || node.statement !== statement ? update(createLabeledStatement(label, statement), node) : node;
	    }
	    function createThrowStatement(expression) {
	      const node = createBaseNode(257 /* ThrowStatement */);
	      node.expression = expression;
	      node.transformFlags |= propagateChildFlags(node.expression);
	      node.jsDoc = void 0;
	      node.flowNode = void 0;
	      return node;
	    }
	    function updateThrowStatement(node, expression) {
	      return node.expression !== expression ? update(createThrowStatement(expression), node) : node;
	    }
	    function createTryStatement(tryBlock, catchClause, finallyBlock) {
	      const node = createBaseNode(258 /* TryStatement */);
	      node.tryBlock = tryBlock;
	      node.catchClause = catchClause;
	      node.finallyBlock = finallyBlock;
	      node.transformFlags |= propagateChildFlags(node.tryBlock) | propagateChildFlags(node.catchClause) | propagateChildFlags(node.finallyBlock);
	      node.jsDoc = void 0;
	      node.flowNode = void 0;
	      return node;
	    }
	    function updateTryStatement(node, tryBlock, catchClause, finallyBlock) {
	      return node.tryBlock !== tryBlock || node.catchClause !== catchClause || node.finallyBlock !== finallyBlock ? update(createTryStatement(tryBlock, catchClause, finallyBlock), node) : node;
	    }
	    function createDebuggerStatement() {
	      const node = createBaseNode(259 /* DebuggerStatement */);
	      node.jsDoc = void 0;
	      node.flowNode = void 0;
	      return node;
	    }
	    function createVariableDeclaration(name, exclamationToken, type, initializer) {
	      const node = createBaseDeclaration(260 /* VariableDeclaration */);
	      node.name = asName(name);
	      node.exclamationToken = exclamationToken;
	      node.type = type;
	      node.initializer = asInitializer(initializer);
	      node.transformFlags |= propagateNameFlags(node.name) | propagateChildFlags(node.initializer) | (node.exclamationToken ?? node.type ? 1 /* ContainsTypeScript */ : 0 /* None */);
	      node.jsDoc = void 0;
	      return node;
	    }
	    function updateVariableDeclaration(node, name, exclamationToken, type, initializer) {
	      return node.name !== name || node.type !== type || node.exclamationToken !== exclamationToken || node.initializer !== initializer ? update(createVariableDeclaration(name, exclamationToken, type, initializer), node) : node;
	    }
	    function createVariableDeclarationList(declarations, flags2 = 0 /* None */) {
	      const node = createBaseNode(261 /* VariableDeclarationList */);
	      node.flags |= flags2 & 7 /* BlockScoped */;
	      node.declarations = createNodeArray(declarations);
	      node.transformFlags |= propagateChildrenFlags(node.declarations) | 4194304 /* ContainsHoistedDeclarationOrCompletion */;
	      if (flags2 & 7 /* BlockScoped */) {
	        node.transformFlags |= 1024 /* ContainsES2015 */ | 262144 /* ContainsBlockScopedBinding */;
	      }
	      if (flags2 & 4 /* Using */) {
	        node.transformFlags |= 4 /* ContainsESNext */;
	      }
	      return node;
	    }
	    function updateVariableDeclarationList(node, declarations) {
	      return node.declarations !== declarations ? update(createVariableDeclarationList(declarations, node.flags), node) : node;
	    }
	    function createFunctionDeclaration(modifiers, asteriskToken, name, typeParameters, parameters, type, body) {
	      const node = createBaseDeclaration(262 /* FunctionDeclaration */);
	      node.modifiers = asNodeArray(modifiers);
	      node.asteriskToken = asteriskToken;
	      node.name = asName(name);
	      node.typeParameters = asNodeArray(typeParameters);
	      node.parameters = createNodeArray(parameters);
	      node.type = type;
	      node.body = body;
	      if (!node.body || modifiersToFlags(node.modifiers) & 128 /* Ambient */) {
	        node.transformFlags = 1 /* ContainsTypeScript */;
	      } else {
	        const isAsync = modifiersToFlags(node.modifiers) & 1024 /* Async */;
	        const isGenerator = !!node.asteriskToken;
	        const isAsyncGenerator = isAsync && isGenerator;
	        node.transformFlags = propagateChildrenFlags(node.modifiers) | propagateChildFlags(node.asteriskToken) | propagateNameFlags(node.name) | propagateChildrenFlags(node.typeParameters) | propagateChildrenFlags(node.parameters) | propagateChildFlags(node.type) | propagateChildFlags(node.body) & ~67108864 /* ContainsPossibleTopLevelAwait */ | (isAsyncGenerator ? 128 /* ContainsES2018 */ : isAsync ? 256 /* ContainsES2017 */ : isGenerator ? 2048 /* ContainsGenerator */ : 0 /* None */) | (node.typeParameters || node.type ? 1 /* ContainsTypeScript */ : 0 /* None */) | 4194304 /* ContainsHoistedDeclarationOrCompletion */;
	      }
	      node.typeArguments = void 0;
	      node.jsDoc = void 0;
	      node.locals = void 0;
	      node.nextContainer = void 0;
	      node.endFlowNode = void 0;
	      node.returnFlowNode = void 0;
	      return node;
	    }
	    function updateFunctionDeclaration(node, modifiers, asteriskToken, name, typeParameters, parameters, type, body) {
	      return node.modifiers !== modifiers || node.asteriskToken !== asteriskToken || node.name !== name || node.typeParameters !== typeParameters || node.parameters !== parameters || node.type !== type || node.body !== body ? finishUpdateFunctionDeclaration(createFunctionDeclaration(modifiers, asteriskToken, name, typeParameters, parameters, type, body), node) : node;
	    }
	    function finishUpdateFunctionDeclaration(updated, original) {
	      if (updated !== original) {
	        if (updated.modifiers === original.modifiers) {
	          updated.modifiers = original.modifiers;
	        }
	      }
	      return finishUpdateBaseSignatureDeclaration(updated, original);
	    }
	    function createClassDeclaration(modifiers, name, typeParameters, heritageClauses, members) {
	      const node = createBaseDeclaration(263 /* ClassDeclaration */);
	      node.modifiers = asNodeArray(modifiers);
	      node.name = asName(name);
	      node.typeParameters = asNodeArray(typeParameters);
	      node.heritageClauses = asNodeArray(heritageClauses);
	      node.members = createNodeArray(members);
	      if (modifiersToFlags(node.modifiers) & 128 /* Ambient */) {
	        node.transformFlags = 1 /* ContainsTypeScript */;
	      } else {
	        node.transformFlags |= propagateChildrenFlags(node.modifiers) | propagateNameFlags(node.name) | propagateChildrenFlags(node.typeParameters) | propagateChildrenFlags(node.heritageClauses) | propagateChildrenFlags(node.members) | (node.typeParameters ? 1 /* ContainsTypeScript */ : 0 /* None */) | 1024 /* ContainsES2015 */;
	        if (node.transformFlags & 8192 /* ContainsTypeScriptClassSyntax */) {
	          node.transformFlags |= 1 /* ContainsTypeScript */;
	        }
	      }
	      node.jsDoc = void 0;
	      return node;
	    }
	    function updateClassDeclaration(node, modifiers, name, typeParameters, heritageClauses, members) {
	      return node.modifiers !== modifiers || node.name !== name || node.typeParameters !== typeParameters || node.heritageClauses !== heritageClauses || node.members !== members ? update(createClassDeclaration(modifiers, name, typeParameters, heritageClauses, members), node) : node;
	    }
	    function createInterfaceDeclaration(modifiers, name, typeParameters, heritageClauses, members) {
	      const node = createBaseDeclaration(264 /* InterfaceDeclaration */);
	      node.modifiers = asNodeArray(modifiers);
	      node.name = asName(name);
	      node.typeParameters = asNodeArray(typeParameters);
	      node.heritageClauses = asNodeArray(heritageClauses);
	      node.members = createNodeArray(members);
	      node.transformFlags = 1 /* ContainsTypeScript */;
	      node.jsDoc = void 0;
	      return node;
	    }
	    function updateInterfaceDeclaration(node, modifiers, name, typeParameters, heritageClauses, members) {
	      return node.modifiers !== modifiers || node.name !== name || node.typeParameters !== typeParameters || node.heritageClauses !== heritageClauses || node.members !== members ? update(createInterfaceDeclaration(modifiers, name, typeParameters, heritageClauses, members), node) : node;
	    }
	    function createTypeAliasDeclaration(modifiers, name, typeParameters, type) {
	      const node = createBaseDeclaration(265 /* TypeAliasDeclaration */);
	      node.modifiers = asNodeArray(modifiers);
	      node.name = asName(name);
	      node.typeParameters = asNodeArray(typeParameters);
	      node.type = type;
	      node.transformFlags = 1 /* ContainsTypeScript */;
	      node.jsDoc = void 0;
	      node.locals = void 0;
	      node.nextContainer = void 0;
	      return node;
	    }
	    function updateTypeAliasDeclaration(node, modifiers, name, typeParameters, type) {
	      return node.modifiers !== modifiers || node.name !== name || node.typeParameters !== typeParameters || node.type !== type ? update(createTypeAliasDeclaration(modifiers, name, typeParameters, type), node) : node;
	    }
	    function createEnumDeclaration(modifiers, name, members) {
	      const node = createBaseDeclaration(266 /* EnumDeclaration */);
	      node.modifiers = asNodeArray(modifiers);
	      node.name = asName(name);
	      node.members = createNodeArray(members);
	      node.transformFlags |= propagateChildrenFlags(node.modifiers) | propagateChildFlags(node.name) | propagateChildrenFlags(node.members) | 1 /* ContainsTypeScript */;
	      node.transformFlags &= ~67108864 /* ContainsPossibleTopLevelAwait */;
	      node.jsDoc = void 0;
	      return node;
	    }
	    function updateEnumDeclaration(node, modifiers, name, members) {
	      return node.modifiers !== modifiers || node.name !== name || node.members !== members ? update(createEnumDeclaration(modifiers, name, members), node) : node;
	    }
	    function createModuleDeclaration(modifiers, name, body, flags2 = 0 /* None */) {
	      const node = createBaseDeclaration(267 /* ModuleDeclaration */);
	      node.modifiers = asNodeArray(modifiers);
	      node.flags |= flags2 & (32 /* Namespace */ | 8 /* NestedNamespace */ | 2048 /* GlobalAugmentation */);
	      node.name = name;
	      node.body = body;
	      if (modifiersToFlags(node.modifiers) & 128 /* Ambient */) {
	        node.transformFlags = 1 /* ContainsTypeScript */;
	      } else {
	        node.transformFlags |= propagateChildrenFlags(node.modifiers) | propagateChildFlags(node.name) | propagateChildFlags(node.body) | 1 /* ContainsTypeScript */;
	      }
	      node.transformFlags &= ~67108864 /* ContainsPossibleTopLevelAwait */;
	      node.jsDoc = void 0;
	      node.locals = void 0;
	      node.nextContainer = void 0;
	      return node;
	    }
	    function updateModuleDeclaration(node, modifiers, name, body) {
	      return node.modifiers !== modifiers || node.name !== name || node.body !== body ? update(createModuleDeclaration(modifiers, name, body, node.flags), node) : node;
	    }
	    function createModuleBlock(statements) {
	      const node = createBaseNode(268 /* ModuleBlock */);
	      node.statements = createNodeArray(statements);
	      node.transformFlags |= propagateChildrenFlags(node.statements);
	      node.jsDoc = void 0;
	      return node;
	    }
	    function updateModuleBlock(node, statements) {
	      return node.statements !== statements ? update(createModuleBlock(statements), node) : node;
	    }
	    function createCaseBlock(clauses) {
	      const node = createBaseNode(269 /* CaseBlock */);
	      node.clauses = createNodeArray(clauses);
	      node.transformFlags |= propagateChildrenFlags(node.clauses);
	      node.locals = void 0;
	      node.nextContainer = void 0;
	      return node;
	    }
	    function updateCaseBlock(node, clauses) {
	      return node.clauses !== clauses ? update(createCaseBlock(clauses), node) : node;
	    }
	    function createNamespaceExportDeclaration(name) {
	      const node = createBaseDeclaration(270 /* NamespaceExportDeclaration */);
	      node.name = asName(name);
	      node.transformFlags |= propagateIdentifierNameFlags(node.name) | 1 /* ContainsTypeScript */;
	      node.modifiers = void 0;
	      node.jsDoc = void 0;
	      return node;
	    }
	    function updateNamespaceExportDeclaration(node, name) {
	      return node.name !== name ? finishUpdateNamespaceExportDeclaration(createNamespaceExportDeclaration(name), node) : node;
	    }
	    function finishUpdateNamespaceExportDeclaration(updated, original) {
	      if (updated !== original) {
	        updated.modifiers = original.modifiers;
	      }
	      return update(updated, original);
	    }
	    function createImportEqualsDeclaration(modifiers, isTypeOnly, name, moduleReference) {
	      const node = createBaseDeclaration(271 /* ImportEqualsDeclaration */);
	      node.modifiers = asNodeArray(modifiers);
	      node.name = asName(name);
	      node.isTypeOnly = isTypeOnly;
	      node.moduleReference = moduleReference;
	      node.transformFlags |= propagateChildrenFlags(node.modifiers) | propagateIdentifierNameFlags(node.name) | propagateChildFlags(node.moduleReference);
	      if (!isExternalModuleReference(node.moduleReference)) {
	        node.transformFlags |= 1 /* ContainsTypeScript */;
	      }
	      node.transformFlags &= ~67108864 /* ContainsPossibleTopLevelAwait */;
	      node.jsDoc = void 0;
	      return node;
	    }
	    function updateImportEqualsDeclaration(node, modifiers, isTypeOnly, name, moduleReference) {
	      return node.modifiers !== modifiers || node.isTypeOnly !== isTypeOnly || node.name !== name || node.moduleReference !== moduleReference ? update(createImportEqualsDeclaration(modifiers, isTypeOnly, name, moduleReference), node) : node;
	    }
	    function createImportDeclaration(modifiers, importClause, moduleSpecifier, attributes) {
	      const node = createBaseNode(272 /* ImportDeclaration */);
	      node.modifiers = asNodeArray(modifiers);
	      node.importClause = importClause;
	      node.moduleSpecifier = moduleSpecifier;
	      node.attributes = node.assertClause = attributes;
	      node.transformFlags |= propagateChildFlags(node.importClause) | propagateChildFlags(node.moduleSpecifier);
	      node.transformFlags &= ~67108864 /* ContainsPossibleTopLevelAwait */;
	      node.jsDoc = void 0;
	      return node;
	    }
	    function updateImportDeclaration(node, modifiers, importClause, moduleSpecifier, attributes) {
	      return node.modifiers !== modifiers || node.importClause !== importClause || node.moduleSpecifier !== moduleSpecifier || node.attributes !== attributes ? update(createImportDeclaration(modifiers, importClause, moduleSpecifier, attributes), node) : node;
	    }
	    function createImportClause(isTypeOnly, name, namedBindings) {
	      const node = createBaseDeclaration(273 /* ImportClause */);
	      node.isTypeOnly = isTypeOnly;
	      node.name = name;
	      node.namedBindings = namedBindings;
	      node.transformFlags |= propagateChildFlags(node.name) | propagateChildFlags(node.namedBindings);
	      if (isTypeOnly) {
	        node.transformFlags |= 1 /* ContainsTypeScript */;
	      }
	      node.transformFlags &= ~67108864 /* ContainsPossibleTopLevelAwait */;
	      return node;
	    }
	    function updateImportClause(node, isTypeOnly, name, namedBindings) {
	      return node.isTypeOnly !== isTypeOnly || node.name !== name || node.namedBindings !== namedBindings ? update(createImportClause(isTypeOnly, name, namedBindings), node) : node;
	    }
	    function createAssertClause(elements, multiLine) {
	      const node = createBaseNode(300 /* AssertClause */);
	      node.elements = createNodeArray(elements);
	      node.multiLine = multiLine;
	      node.token = 132 /* AssertKeyword */;
	      node.transformFlags |= 4 /* ContainsESNext */;
	      return node;
	    }
	    function updateAssertClause(node, elements, multiLine) {
	      return node.elements !== elements || node.multiLine !== multiLine ? update(createAssertClause(elements, multiLine), node) : node;
	    }
	    function createAssertEntry(name, value) {
	      const node = createBaseNode(301 /* AssertEntry */);
	      node.name = name;
	      node.value = value;
	      node.transformFlags |= 4 /* ContainsESNext */;
	      return node;
	    }
	    function updateAssertEntry(node, name, value) {
	      return node.name !== name || node.value !== value ? update(createAssertEntry(name, value), node) : node;
	    }
	    function createImportTypeAssertionContainer(clause, multiLine) {
	      const node = createBaseNode(302 /* ImportTypeAssertionContainer */);
	      node.assertClause = clause;
	      node.multiLine = multiLine;
	      return node;
	    }
	    function updateImportTypeAssertionContainer(node, clause, multiLine) {
	      return node.assertClause !== clause || node.multiLine !== multiLine ? update(createImportTypeAssertionContainer(clause, multiLine), node) : node;
	    }
	    function createImportAttributes(elements, multiLine, token) {
	      const node = createBaseNode(300 /* ImportAttributes */);
	      node.token = token ?? 118 /* WithKeyword */;
	      node.elements = createNodeArray(elements);
	      node.multiLine = multiLine;
	      node.transformFlags |= 4 /* ContainsESNext */;
	      return node;
	    }
	    function updateImportAttributes(node, elements, multiLine) {
	      return node.elements !== elements || node.multiLine !== multiLine ? update(createImportAttributes(elements, multiLine, node.token), node) : node;
	    }
	    function createImportAttribute(name, value) {
	      const node = createBaseNode(301 /* ImportAttribute */);
	      node.name = name;
	      node.value = value;
	      node.transformFlags |= 4 /* ContainsESNext */;
	      return node;
	    }
	    function updateImportAttribute(node, name, value) {
	      return node.name !== name || node.value !== value ? update(createImportAttribute(name, value), node) : node;
	    }
	    function createNamespaceImport(name) {
	      const node = createBaseDeclaration(274 /* NamespaceImport */);
	      node.name = name;
	      node.transformFlags |= propagateChildFlags(node.name);
	      node.transformFlags &= ~67108864 /* ContainsPossibleTopLevelAwait */;
	      return node;
	    }
	    function updateNamespaceImport(node, name) {
	      return node.name !== name ? update(createNamespaceImport(name), node) : node;
	    }
	    function createNamespaceExport(name) {
	      const node = createBaseDeclaration(280 /* NamespaceExport */);
	      node.name = name;
	      node.transformFlags |= propagateChildFlags(node.name) | 32 /* ContainsES2020 */;
	      node.transformFlags &= ~67108864 /* ContainsPossibleTopLevelAwait */;
	      return node;
	    }
	    function updateNamespaceExport(node, name) {
	      return node.name !== name ? update(createNamespaceExport(name), node) : node;
	    }
	    function createNamedImports(elements) {
	      const node = createBaseNode(275 /* NamedImports */);
	      node.elements = createNodeArray(elements);
	      node.transformFlags |= propagateChildrenFlags(node.elements);
	      node.transformFlags &= ~67108864 /* ContainsPossibleTopLevelAwait */;
	      return node;
	    }
	    function updateNamedImports(node, elements) {
	      return node.elements !== elements ? update(createNamedImports(elements), node) : node;
	    }
	    function createImportSpecifier(isTypeOnly, propertyName, name) {
	      const node = createBaseDeclaration(276 /* ImportSpecifier */);
	      node.isTypeOnly = isTypeOnly;
	      node.propertyName = propertyName;
	      node.name = name;
	      node.transformFlags |= propagateChildFlags(node.propertyName) | propagateChildFlags(node.name);
	      node.transformFlags &= ~67108864 /* ContainsPossibleTopLevelAwait */;
	      return node;
	    }
	    function updateImportSpecifier(node, isTypeOnly, propertyName, name) {
	      return node.isTypeOnly !== isTypeOnly || node.propertyName !== propertyName || node.name !== name ? update(createImportSpecifier(isTypeOnly, propertyName, name), node) : node;
	    }
	    function createExportAssignment2(modifiers, isExportEquals, expression) {
	      const node = createBaseDeclaration(277 /* ExportAssignment */);
	      node.modifiers = asNodeArray(modifiers);
	      node.isExportEquals = isExportEquals;
	      node.expression = isExportEquals ? parenthesizerRules().parenthesizeRightSideOfBinary(
	        64 /* EqualsToken */,
	        /*leftSide*/
	        void 0,
	        expression
	      ) : parenthesizerRules().parenthesizeExpressionOfExportDefault(expression);
	      node.transformFlags |= propagateChildrenFlags(node.modifiers) | propagateChildFlags(node.expression);
	      node.transformFlags &= ~67108864 /* ContainsPossibleTopLevelAwait */;
	      node.jsDoc = void 0;
	      return node;
	    }
	    function updateExportAssignment(node, modifiers, expression) {
	      return node.modifiers !== modifiers || node.expression !== expression ? update(createExportAssignment2(modifiers, node.isExportEquals, expression), node) : node;
	    }
	    function createExportDeclaration(modifiers, isTypeOnly, exportClause, moduleSpecifier, attributes) {
	      const node = createBaseDeclaration(278 /* ExportDeclaration */);
	      node.modifiers = asNodeArray(modifiers);
	      node.isTypeOnly = isTypeOnly;
	      node.exportClause = exportClause;
	      node.moduleSpecifier = moduleSpecifier;
	      node.attributes = node.assertClause = attributes;
	      node.transformFlags |= propagateChildrenFlags(node.modifiers) | propagateChildFlags(node.exportClause) | propagateChildFlags(node.moduleSpecifier);
	      node.transformFlags &= ~67108864 /* ContainsPossibleTopLevelAwait */;
	      node.jsDoc = void 0;
	      return node;
	    }
	    function updateExportDeclaration(node, modifiers, isTypeOnly, exportClause, moduleSpecifier, attributes) {
	      return node.modifiers !== modifiers || node.isTypeOnly !== isTypeOnly || node.exportClause !== exportClause || node.moduleSpecifier !== moduleSpecifier || node.attributes !== attributes ? finishUpdateExportDeclaration(createExportDeclaration(modifiers, isTypeOnly, exportClause, moduleSpecifier, attributes), node) : node;
	    }
	    function finishUpdateExportDeclaration(updated, original) {
	      if (updated !== original) {
	        if (updated.modifiers === original.modifiers) {
	          updated.modifiers = original.modifiers;
	        }
	      }
	      return update(updated, original);
	    }
	    function createNamedExports(elements) {
	      const node = createBaseNode(279 /* NamedExports */);
	      node.elements = createNodeArray(elements);
	      node.transformFlags |= propagateChildrenFlags(node.elements);
	      node.transformFlags &= ~67108864 /* ContainsPossibleTopLevelAwait */;
	      return node;
	    }
	    function updateNamedExports(node, elements) {
	      return node.elements !== elements ? update(createNamedExports(elements), node) : node;
	    }
	    function createExportSpecifier(isTypeOnly, propertyName, name) {
	      const node = createBaseNode(281 /* ExportSpecifier */);
	      node.isTypeOnly = isTypeOnly;
	      node.propertyName = asName(propertyName);
	      node.name = asName(name);
	      node.transformFlags |= propagateChildFlags(node.propertyName) | propagateChildFlags(node.name);
	      node.transformFlags &= ~67108864 /* ContainsPossibleTopLevelAwait */;
	      node.jsDoc = void 0;
	      return node;
	    }
	    function updateExportSpecifier(node, isTypeOnly, propertyName, name) {
	      return node.isTypeOnly !== isTypeOnly || node.propertyName !== propertyName || node.name !== name ? update(createExportSpecifier(isTypeOnly, propertyName, name), node) : node;
	    }
	    function createMissingDeclaration() {
	      const node = createBaseDeclaration(282 /* MissingDeclaration */);
	      node.jsDoc = void 0;
	      return node;
	    }
	    function createExternalModuleReference(expression) {
	      const node = createBaseNode(283 /* ExternalModuleReference */);
	      node.expression = expression;
	      node.transformFlags |= propagateChildFlags(node.expression);
	      node.transformFlags &= ~67108864 /* ContainsPossibleTopLevelAwait */;
	      return node;
	    }
	    function updateExternalModuleReference(node, expression) {
	      return node.expression !== expression ? update(createExternalModuleReference(expression), node) : node;
	    }
	    function createJSDocPrimaryTypeWorker(kind) {
	      return createBaseNode(kind);
	    }
	    function createJSDocPrePostfixUnaryTypeWorker(kind, type, postfix = false) {
	      const node = createJSDocUnaryTypeWorker(
	        kind,
	        postfix ? type && parenthesizerRules().parenthesizeNonArrayTypeOfPostfixType(type) : type
	      );
	      node.postfix = postfix;
	      return node;
	    }
	    function createJSDocUnaryTypeWorker(kind, type) {
	      const node = createBaseNode(kind);
	      node.type = type;
	      return node;
	    }
	    function updateJSDocPrePostfixUnaryTypeWorker(kind, node, type) {
	      return node.type !== type ? update(createJSDocPrePostfixUnaryTypeWorker(kind, type, node.postfix), node) : node;
	    }
	    function updateJSDocUnaryTypeWorker(kind, node, type) {
	      return node.type !== type ? update(createJSDocUnaryTypeWorker(kind, type), node) : node;
	    }
	    function createJSDocFunctionType(parameters, type) {
	      const node = createBaseDeclaration(324 /* JSDocFunctionType */);
	      node.parameters = asNodeArray(parameters);
	      node.type = type;
	      node.transformFlags = propagateChildrenFlags(node.parameters) | (node.type ? 1 /* ContainsTypeScript */ : 0 /* None */);
	      node.jsDoc = void 0;
	      node.locals = void 0;
	      node.nextContainer = void 0;
	      node.typeArguments = void 0;
	      return node;
	    }
	    function updateJSDocFunctionType(node, parameters, type) {
	      return node.parameters !== parameters || node.type !== type ? update(createJSDocFunctionType(parameters, type), node) : node;
	    }
	    function createJSDocTypeLiteral(propertyTags, isArrayType = false) {
	      const node = createBaseDeclaration(329 /* JSDocTypeLiteral */);
	      node.jsDocPropertyTags = asNodeArray(propertyTags);
	      node.isArrayType = isArrayType;
	      return node;
	    }
	    function updateJSDocTypeLiteral(node, propertyTags, isArrayType) {
	      return node.jsDocPropertyTags !== propertyTags || node.isArrayType !== isArrayType ? update(createJSDocTypeLiteral(propertyTags, isArrayType), node) : node;
	    }
	    function createJSDocTypeExpression(type) {
	      const node = createBaseNode(316 /* JSDocTypeExpression */);
	      node.type = type;
	      return node;
	    }
	    function updateJSDocTypeExpression(node, type) {
	      return node.type !== type ? update(createJSDocTypeExpression(type), node) : node;
	    }
	    function createJSDocSignature(typeParameters, parameters, type) {
	      const node = createBaseDeclaration(330 /* JSDocSignature */);
	      node.typeParameters = asNodeArray(typeParameters);
	      node.parameters = createNodeArray(parameters);
	      node.type = type;
	      node.jsDoc = void 0;
	      node.locals = void 0;
	      node.nextContainer = void 0;
	      return node;
	    }
	    function updateJSDocSignature(node, typeParameters, parameters, type) {
	      return node.typeParameters !== typeParameters || node.parameters !== parameters || node.type !== type ? update(createJSDocSignature(typeParameters, parameters, type), node) : node;
	    }
	    function getDefaultTagName(node) {
	      const defaultTagName = getDefaultTagNameForKind(node.kind);
	      return node.tagName.escapedText === escapeLeadingUnderscores(defaultTagName) ? node.tagName : createIdentifier(defaultTagName);
	    }
	    function createBaseJSDocTag(kind, tagName, comment) {
	      const node = createBaseNode(kind);
	      node.tagName = tagName;
	      node.comment = comment;
	      return node;
	    }
	    function createBaseJSDocTagDeclaration(kind, tagName, comment) {
	      const node = createBaseDeclaration(kind);
	      node.tagName = tagName;
	      node.comment = comment;
	      return node;
	    }
	    function createJSDocTemplateTag(tagName, constraint, typeParameters, comment) {
	      const node = createBaseJSDocTag(352 /* JSDocTemplateTag */, tagName ?? createIdentifier("template"), comment);
	      node.constraint = constraint;
	      node.typeParameters = createNodeArray(typeParameters);
	      return node;
	    }
	    function updateJSDocTemplateTag(node, tagName = getDefaultTagName(node), constraint, typeParameters, comment) {
	      return node.tagName !== tagName || node.constraint !== constraint || node.typeParameters !== typeParameters || node.comment !== comment ? update(createJSDocTemplateTag(tagName, constraint, typeParameters, comment), node) : node;
	    }
	    function createJSDocTypedefTag(tagName, typeExpression, fullName, comment) {
	      const node = createBaseJSDocTagDeclaration(353 /* JSDocTypedefTag */, tagName ?? createIdentifier("typedef"), comment);
	      node.typeExpression = typeExpression;
	      node.fullName = fullName;
	      node.name = getJSDocTypeAliasName(fullName);
	      node.locals = void 0;
	      node.nextContainer = void 0;
	      return node;
	    }
	    function updateJSDocTypedefTag(node, tagName = getDefaultTagName(node), typeExpression, fullName, comment) {
	      return node.tagName !== tagName || node.typeExpression !== typeExpression || node.fullName !== fullName || node.comment !== comment ? update(createJSDocTypedefTag(tagName, typeExpression, fullName, comment), node) : node;
	    }
	    function createJSDocParameterTag(tagName, name, isBracketed, typeExpression, isNameFirst, comment) {
	      const node = createBaseJSDocTagDeclaration(348 /* JSDocParameterTag */, tagName ?? createIdentifier("param"), comment);
	      node.typeExpression = typeExpression;
	      node.name = name;
	      node.isNameFirst = !!isNameFirst;
	      node.isBracketed = isBracketed;
	      return node;
	    }
	    function updateJSDocParameterTag(node, tagName = getDefaultTagName(node), name, isBracketed, typeExpression, isNameFirst, comment) {
	      return node.tagName !== tagName || node.name !== name || node.isBracketed !== isBracketed || node.typeExpression !== typeExpression || node.isNameFirst !== isNameFirst || node.comment !== comment ? update(createJSDocParameterTag(tagName, name, isBracketed, typeExpression, isNameFirst, comment), node) : node;
	    }
	    function createJSDocPropertyTag(tagName, name, isBracketed, typeExpression, isNameFirst, comment) {
	      const node = createBaseJSDocTagDeclaration(355 /* JSDocPropertyTag */, tagName ?? createIdentifier("prop"), comment);
	      node.typeExpression = typeExpression;
	      node.name = name;
	      node.isNameFirst = !!isNameFirst;
	      node.isBracketed = isBracketed;
	      return node;
	    }
	    function updateJSDocPropertyTag(node, tagName = getDefaultTagName(node), name, isBracketed, typeExpression, isNameFirst, comment) {
	      return node.tagName !== tagName || node.name !== name || node.isBracketed !== isBracketed || node.typeExpression !== typeExpression || node.isNameFirst !== isNameFirst || node.comment !== comment ? update(createJSDocPropertyTag(tagName, name, isBracketed, typeExpression, isNameFirst, comment), node) : node;
	    }
	    function createJSDocCallbackTag(tagName, typeExpression, fullName, comment) {
	      const node = createBaseJSDocTagDeclaration(345 /* JSDocCallbackTag */, tagName ?? createIdentifier("callback"), comment);
	      node.typeExpression = typeExpression;
	      node.fullName = fullName;
	      node.name = getJSDocTypeAliasName(fullName);
	      node.locals = void 0;
	      node.nextContainer = void 0;
	      return node;
	    }
	    function updateJSDocCallbackTag(node, tagName = getDefaultTagName(node), typeExpression, fullName, comment) {
	      return node.tagName !== tagName || node.typeExpression !== typeExpression || node.fullName !== fullName || node.comment !== comment ? update(createJSDocCallbackTag(tagName, typeExpression, fullName, comment), node) : node;
	    }
	    function createJSDocOverloadTag(tagName, typeExpression, comment) {
	      const node = createBaseJSDocTag(346 /* JSDocOverloadTag */, tagName ?? createIdentifier("overload"), comment);
	      node.typeExpression = typeExpression;
	      return node;
	    }
	    function updateJSDocOverloadTag(node, tagName = getDefaultTagName(node), typeExpression, comment) {
	      return node.tagName !== tagName || node.typeExpression !== typeExpression || node.comment !== comment ? update(createJSDocOverloadTag(tagName, typeExpression, comment), node) : node;
	    }
	    function createJSDocAugmentsTag(tagName, className, comment) {
	      const node = createBaseJSDocTag(335 /* JSDocAugmentsTag */, tagName ?? createIdentifier("augments"), comment);
	      node.class = className;
	      return node;
	    }
	    function updateJSDocAugmentsTag(node, tagName = getDefaultTagName(node), className, comment) {
	      return node.tagName !== tagName || node.class !== className || node.comment !== comment ? update(createJSDocAugmentsTag(tagName, className, comment), node) : node;
	    }
	    function createJSDocImplementsTag(tagName, className, comment) {
	      const node = createBaseJSDocTag(336 /* JSDocImplementsTag */, tagName ?? createIdentifier("implements"), comment);
	      node.class = className;
	      return node;
	    }
	    function createJSDocSeeTag(tagName, name, comment) {
	      const node = createBaseJSDocTag(354 /* JSDocSeeTag */, tagName ?? createIdentifier("see"), comment);
	      node.name = name;
	      return node;
	    }
	    function updateJSDocSeeTag(node, tagName, name, comment) {
	      return node.tagName !== tagName || node.name !== name || node.comment !== comment ? update(createJSDocSeeTag(tagName, name, comment), node) : node;
	    }
	    function createJSDocNameReference(name) {
	      const node = createBaseNode(317 /* JSDocNameReference */);
	      node.name = name;
	      return node;
	    }
	    function updateJSDocNameReference(node, name) {
	      return node.name !== name ? update(createJSDocNameReference(name), node) : node;
	    }
	    function createJSDocMemberName(left, right) {
	      const node = createBaseNode(318 /* JSDocMemberName */);
	      node.left = left;
	      node.right = right;
	      node.transformFlags |= propagateChildFlags(node.left) | propagateChildFlags(node.right);
	      return node;
	    }
	    function updateJSDocMemberName(node, left, right) {
	      return node.left !== left || node.right !== right ? update(createJSDocMemberName(left, right), node) : node;
	    }
	    function createJSDocLink(name, text) {
	      const node = createBaseNode(331 /* JSDocLink */);
	      node.name = name;
	      node.text = text;
	      return node;
	    }
	    function updateJSDocLink(node, name, text) {
	      return node.name !== name ? update(createJSDocLink(name, text), node) : node;
	    }
	    function createJSDocLinkCode(name, text) {
	      const node = createBaseNode(332 /* JSDocLinkCode */);
	      node.name = name;
	      node.text = text;
	      return node;
	    }
	    function updateJSDocLinkCode(node, name, text) {
	      return node.name !== name ? update(createJSDocLinkCode(name, text), node) : node;
	    }
	    function createJSDocLinkPlain(name, text) {
	      const node = createBaseNode(333 /* JSDocLinkPlain */);
	      node.name = name;
	      node.text = text;
	      return node;
	    }
	    function updateJSDocLinkPlain(node, name, text) {
	      return node.name !== name ? update(createJSDocLinkPlain(name, text), node) : node;
	    }
	    function updateJSDocImplementsTag(node, tagName = getDefaultTagName(node), className, comment) {
	      return node.tagName !== tagName || node.class !== className || node.comment !== comment ? update(createJSDocImplementsTag(tagName, className, comment), node) : node;
	    }
	    function createJSDocSimpleTagWorker(kind, tagName, comment) {
	      const node = createBaseJSDocTag(kind, tagName ?? createIdentifier(getDefaultTagNameForKind(kind)), comment);
	      return node;
	    }
	    function updateJSDocSimpleTagWorker(kind, node, tagName = getDefaultTagName(node), comment) {
	      return node.tagName !== tagName || node.comment !== comment ? update(createJSDocSimpleTagWorker(kind, tagName, comment), node) : node;
	    }
	    function createJSDocTypeLikeTagWorker(kind, tagName, typeExpression, comment) {
	      const node = createBaseJSDocTag(kind, tagName ?? createIdentifier(getDefaultTagNameForKind(kind)), comment);
	      node.typeExpression = typeExpression;
	      return node;
	    }
	    function updateJSDocTypeLikeTagWorker(kind, node, tagName = getDefaultTagName(node), typeExpression, comment) {
	      return node.tagName !== tagName || node.typeExpression !== typeExpression || node.comment !== comment ? update(createJSDocTypeLikeTagWorker(kind, tagName, typeExpression, comment), node) : node;
	    }
	    function createJSDocUnknownTag(tagName, comment) {
	      const node = createBaseJSDocTag(334 /* JSDocTag */, tagName, comment);
	      return node;
	    }
	    function updateJSDocUnknownTag(node, tagName, comment) {
	      return node.tagName !== tagName || node.comment !== comment ? update(createJSDocUnknownTag(tagName, comment), node) : node;
	    }
	    function createJSDocEnumTag(tagName, typeExpression, comment) {
	      const node = createBaseJSDocTagDeclaration(347 /* JSDocEnumTag */, tagName ?? createIdentifier(getDefaultTagNameForKind(347 /* JSDocEnumTag */)), comment);
	      node.typeExpression = typeExpression;
	      node.locals = void 0;
	      node.nextContainer = void 0;
	      return node;
	    }
	    function updateJSDocEnumTag(node, tagName = getDefaultTagName(node), typeExpression, comment) {
	      return node.tagName !== tagName || node.typeExpression !== typeExpression || node.comment !== comment ? update(createJSDocEnumTag(tagName, typeExpression, comment), node) : node;
	    }
	    function createJSDocText(text) {
	      const node = createBaseNode(328 /* JSDocText */);
	      node.text = text;
	      return node;
	    }
	    function updateJSDocText(node, text) {
	      return node.text !== text ? update(createJSDocText(text), node) : node;
	    }
	    function createJSDocComment(comment, tags) {
	      const node = createBaseNode(327 /* JSDoc */);
	      node.comment = comment;
	      node.tags = asNodeArray(tags);
	      return node;
	    }
	    function updateJSDocComment(node, comment, tags) {
	      return node.comment !== comment || node.tags !== tags ? update(createJSDocComment(comment, tags), node) : node;
	    }
	    function createJsxElement(openingElement, children, closingElement) {
	      const node = createBaseNode(284 /* JsxElement */);
	      node.openingElement = openingElement;
	      node.children = createNodeArray(children);
	      node.closingElement = closingElement;
	      node.transformFlags |= propagateChildFlags(node.openingElement) | propagateChildrenFlags(node.children) | propagateChildFlags(node.closingElement) | 2 /* ContainsJsx */;
	      return node;
	    }
	    function updateJsxElement(node, openingElement, children, closingElement) {
	      return node.openingElement !== openingElement || node.children !== children || node.closingElement !== closingElement ? update(createJsxElement(openingElement, children, closingElement), node) : node;
	    }
	    function createJsxSelfClosingElement(tagName, typeArguments, attributes) {
	      const node = createBaseNode(285 /* JsxSelfClosingElement */);
	      node.tagName = tagName;
	      node.typeArguments = asNodeArray(typeArguments);
	      node.attributes = attributes;
	      node.transformFlags |= propagateChildFlags(node.tagName) | propagateChildrenFlags(node.typeArguments) | propagateChildFlags(node.attributes) | 2 /* ContainsJsx */;
	      if (node.typeArguments) {
	        node.transformFlags |= 1 /* ContainsTypeScript */;
	      }
	      return node;
	    }
	    function updateJsxSelfClosingElement(node, tagName, typeArguments, attributes) {
	      return node.tagName !== tagName || node.typeArguments !== typeArguments || node.attributes !== attributes ? update(createJsxSelfClosingElement(tagName, typeArguments, attributes), node) : node;
	    }
	    function createJsxOpeningElement(tagName, typeArguments, attributes) {
	      const node = createBaseNode(286 /* JsxOpeningElement */);
	      node.tagName = tagName;
	      node.typeArguments = asNodeArray(typeArguments);
	      node.attributes = attributes;
	      node.transformFlags |= propagateChildFlags(node.tagName) | propagateChildrenFlags(node.typeArguments) | propagateChildFlags(node.attributes) | 2 /* ContainsJsx */;
	      if (typeArguments) {
	        node.transformFlags |= 1 /* ContainsTypeScript */;
	      }
	      return node;
	    }
	    function updateJsxOpeningElement(node, tagName, typeArguments, attributes) {
	      return node.tagName !== tagName || node.typeArguments !== typeArguments || node.attributes !== attributes ? update(createJsxOpeningElement(tagName, typeArguments, attributes), node) : node;
	    }
	    function createJsxClosingElement(tagName) {
	      const node = createBaseNode(287 /* JsxClosingElement */);
	      node.tagName = tagName;
	      node.transformFlags |= propagateChildFlags(node.tagName) | 2 /* ContainsJsx */;
	      return node;
	    }
	    function updateJsxClosingElement(node, tagName) {
	      return node.tagName !== tagName ? update(createJsxClosingElement(tagName), node) : node;
	    }
	    function createJsxFragment(openingFragment, children, closingFragment) {
	      const node = createBaseNode(288 /* JsxFragment */);
	      node.openingFragment = openingFragment;
	      node.children = createNodeArray(children);
	      node.closingFragment = closingFragment;
	      node.transformFlags |= propagateChildFlags(node.openingFragment) | propagateChildrenFlags(node.children) | propagateChildFlags(node.closingFragment) | 2 /* ContainsJsx */;
	      return node;
	    }
	    function updateJsxFragment(node, openingFragment, children, closingFragment) {
	      return node.openingFragment !== openingFragment || node.children !== children || node.closingFragment !== closingFragment ? update(createJsxFragment(openingFragment, children, closingFragment), node) : node;
	    }
	    function createJsxText(text, containsOnlyTriviaWhiteSpaces) {
	      const node = createBaseNode(12 /* JsxText */);
	      node.text = text;
	      node.containsOnlyTriviaWhiteSpaces = !!containsOnlyTriviaWhiteSpaces;
	      node.transformFlags |= 2 /* ContainsJsx */;
	      return node;
	    }
	    function updateJsxText(node, text, containsOnlyTriviaWhiteSpaces) {
	      return node.text !== text || node.containsOnlyTriviaWhiteSpaces !== containsOnlyTriviaWhiteSpaces ? update(createJsxText(text, containsOnlyTriviaWhiteSpaces), node) : node;
	    }
	    function createJsxOpeningFragment() {
	      const node = createBaseNode(289 /* JsxOpeningFragment */);
	      node.transformFlags |= 2 /* ContainsJsx */;
	      return node;
	    }
	    function createJsxJsxClosingFragment() {
	      const node = createBaseNode(290 /* JsxClosingFragment */);
	      node.transformFlags |= 2 /* ContainsJsx */;
	      return node;
	    }
	    function createJsxAttribute(name, initializer) {
	      const node = createBaseDeclaration(291 /* JsxAttribute */);
	      node.name = name;
	      node.initializer = initializer;
	      node.transformFlags |= propagateChildFlags(node.name) | propagateChildFlags(node.initializer) | 2 /* ContainsJsx */;
	      return node;
	    }
	    function updateJsxAttribute(node, name, initializer) {
	      return node.name !== name || node.initializer !== initializer ? update(createJsxAttribute(name, initializer), node) : node;
	    }
	    function createJsxAttributes(properties) {
	      const node = createBaseDeclaration(292 /* JsxAttributes */);
	      node.properties = createNodeArray(properties);
	      node.transformFlags |= propagateChildrenFlags(node.properties) | 2 /* ContainsJsx */;
	      return node;
	    }
	    function updateJsxAttributes(node, properties) {
	      return node.properties !== properties ? update(createJsxAttributes(properties), node) : node;
	    }
	    function createJsxSpreadAttribute(expression) {
	      const node = createBaseNode(293 /* JsxSpreadAttribute */);
	      node.expression = expression;
	      node.transformFlags |= propagateChildFlags(node.expression) | 2 /* ContainsJsx */;
	      return node;
	    }
	    function updateJsxSpreadAttribute(node, expression) {
	      return node.expression !== expression ? update(createJsxSpreadAttribute(expression), node) : node;
	    }
	    function createJsxExpression(dotDotDotToken, expression) {
	      const node = createBaseNode(294 /* JsxExpression */);
	      node.dotDotDotToken = dotDotDotToken;
	      node.expression = expression;
	      node.transformFlags |= propagateChildFlags(node.dotDotDotToken) | propagateChildFlags(node.expression) | 2 /* ContainsJsx */;
	      return node;
	    }
	    function updateJsxExpression(node, expression) {
	      return node.expression !== expression ? update(createJsxExpression(node.dotDotDotToken, expression), node) : node;
	    }
	    function createJsxNamespacedName(namespace, name) {
	      const node = createBaseNode(295 /* JsxNamespacedName */);
	      node.namespace = namespace;
	      node.name = name;
	      node.transformFlags |= propagateChildFlags(node.namespace) | propagateChildFlags(node.name) | 2 /* ContainsJsx */;
	      return node;
	    }
	    function updateJsxNamespacedName(node, namespace, name) {
	      return node.namespace !== namespace || node.name !== name ? update(createJsxNamespacedName(namespace, name), node) : node;
	    }
	    function createCaseClause(expression, statements) {
	      const node = createBaseNode(296 /* CaseClause */);
	      node.expression = parenthesizerRules().parenthesizeExpressionForDisallowedComma(expression);
	      node.statements = createNodeArray(statements);
	      node.transformFlags |= propagateChildFlags(node.expression) | propagateChildrenFlags(node.statements);
	      node.jsDoc = void 0;
	      return node;
	    }
	    function updateCaseClause(node, expression, statements) {
	      return node.expression !== expression || node.statements !== statements ? update(createCaseClause(expression, statements), node) : node;
	    }
	    function createDefaultClause(statements) {
	      const node = createBaseNode(297 /* DefaultClause */);
	      node.statements = createNodeArray(statements);
	      node.transformFlags = propagateChildrenFlags(node.statements);
	      return node;
	    }
	    function updateDefaultClause(node, statements) {
	      return node.statements !== statements ? update(createDefaultClause(statements), node) : node;
	    }
	    function createHeritageClause(token, types) {
	      const node = createBaseNode(298 /* HeritageClause */);
	      node.token = token;
	      node.types = createNodeArray(types);
	      node.transformFlags |= propagateChildrenFlags(node.types);
	      switch (token) {
	        case 96 /* ExtendsKeyword */:
	          node.transformFlags |= 1024 /* ContainsES2015 */;
	          break;
	        case 119 /* ImplementsKeyword */:
	          node.transformFlags |= 1 /* ContainsTypeScript */;
	          break;
	        default:
	          return Debug.assertNever(token);
	      }
	      return node;
	    }
	    function updateHeritageClause(node, types) {
	      return node.types !== types ? update(createHeritageClause(node.token, types), node) : node;
	    }
	    function createCatchClause(variableDeclaration, block) {
	      const node = createBaseNode(299 /* CatchClause */);
	      node.variableDeclaration = asVariableDeclaration(variableDeclaration);
	      node.block = block;
	      node.transformFlags |= propagateChildFlags(node.variableDeclaration) | propagateChildFlags(node.block) | (!variableDeclaration ? 64 /* ContainsES2019 */ : 0 /* None */);
	      node.locals = void 0;
	      node.nextContainer = void 0;
	      return node;
	    }
	    function updateCatchClause(node, variableDeclaration, block) {
	      return node.variableDeclaration !== variableDeclaration || node.block !== block ? update(createCatchClause(variableDeclaration, block), node) : node;
	    }
	    function createPropertyAssignment(name, initializer) {
	      const node = createBaseDeclaration(303 /* PropertyAssignment */);
	      node.name = asName(name);
	      node.initializer = parenthesizerRules().parenthesizeExpressionForDisallowedComma(initializer);
	      node.transformFlags |= propagateNameFlags(node.name) | propagateChildFlags(node.initializer);
	      node.modifiers = void 0;
	      node.questionToken = void 0;
	      node.exclamationToken = void 0;
	      node.jsDoc = void 0;
	      return node;
	    }
	    function updatePropertyAssignment(node, name, initializer) {
	      return node.name !== name || node.initializer !== initializer ? finishUpdatePropertyAssignment(createPropertyAssignment(name, initializer), node) : node;
	    }
	    function finishUpdatePropertyAssignment(updated, original) {
	      if (updated !== original) {
	        updated.modifiers = original.modifiers;
	        updated.questionToken = original.questionToken;
	        updated.exclamationToken = original.exclamationToken;
	      }
	      return update(updated, original);
	    }
	    function createShorthandPropertyAssignment(name, objectAssignmentInitializer) {
	      const node = createBaseDeclaration(304 /* ShorthandPropertyAssignment */);
	      node.name = asName(name);
	      node.objectAssignmentInitializer = objectAssignmentInitializer && parenthesizerRules().parenthesizeExpressionForDisallowedComma(objectAssignmentInitializer);
	      node.transformFlags |= propagateIdentifierNameFlags(node.name) | propagateChildFlags(node.objectAssignmentInitializer) | 1024 /* ContainsES2015 */;
	      node.equalsToken = void 0;
	      node.modifiers = void 0;
	      node.questionToken = void 0;
	      node.exclamationToken = void 0;
	      node.jsDoc = void 0;
	      return node;
	    }
	    function updateShorthandPropertyAssignment(node, name, objectAssignmentInitializer) {
	      return node.name !== name || node.objectAssignmentInitializer !== objectAssignmentInitializer ? finishUpdateShorthandPropertyAssignment(createShorthandPropertyAssignment(name, objectAssignmentInitializer), node) : node;
	    }
	    function finishUpdateShorthandPropertyAssignment(updated, original) {
	      if (updated !== original) {
	        updated.modifiers = original.modifiers;
	        updated.questionToken = original.questionToken;
	        updated.exclamationToken = original.exclamationToken;
	        updated.equalsToken = original.equalsToken;
	      }
	      return update(updated, original);
	    }
	    function createSpreadAssignment(expression) {
	      const node = createBaseDeclaration(305 /* SpreadAssignment */);
	      node.expression = parenthesizerRules().parenthesizeExpressionForDisallowedComma(expression);
	      node.transformFlags |= propagateChildFlags(node.expression) | 128 /* ContainsES2018 */ | 65536 /* ContainsObjectRestOrSpread */;
	      node.jsDoc = void 0;
	      return node;
	    }
	    function updateSpreadAssignment(node, expression) {
	      return node.expression !== expression ? update(createSpreadAssignment(expression), node) : node;
	    }
	    function createEnumMember(name, initializer) {
	      const node = createBaseDeclaration(306 /* EnumMember */);
	      node.name = asName(name);
	      node.initializer = initializer && parenthesizerRules().parenthesizeExpressionForDisallowedComma(initializer);
	      node.transformFlags |= propagateChildFlags(node.name) | propagateChildFlags(node.initializer) | 1 /* ContainsTypeScript */;
	      node.jsDoc = void 0;
	      return node;
	    }
	    function updateEnumMember(node, name, initializer) {
	      return node.name !== name || node.initializer !== initializer ? update(createEnumMember(name, initializer), node) : node;
	    }
	    function createSourceFile2(statements, endOfFileToken, flags2) {
	      const node = baseFactory2.createBaseSourceFileNode(312 /* SourceFile */);
	      node.statements = createNodeArray(statements);
	      node.endOfFileToken = endOfFileToken;
	      node.flags |= flags2;
	      node.text = "";
	      node.fileName = "";
	      node.path = "";
	      node.resolvedPath = "";
	      node.originalFileName = "";
	      node.languageVersion = 0;
	      node.languageVariant = 0;
	      node.scriptKind = 0;
	      node.isDeclarationFile = false;
	      node.hasNoDefaultLib = false;
	      node.transformFlags |= propagateChildrenFlags(node.statements) | propagateChildFlags(node.endOfFileToken);
	      node.locals = void 0;
	      node.nextContainer = void 0;
	      node.endFlowNode = void 0;
	      node.nodeCount = 0;
	      node.identifierCount = 0;
	      node.symbolCount = 0;
	      node.parseDiagnostics = void 0;
	      node.bindDiagnostics = void 0;
	      node.bindSuggestionDiagnostics = void 0;
	      node.lineMap = void 0;
	      node.externalModuleIndicator = void 0;
	      node.setExternalModuleIndicator = void 0;
	      node.pragmas = void 0;
	      node.checkJsDirective = void 0;
	      node.referencedFiles = void 0;
	      node.typeReferenceDirectives = void 0;
	      node.libReferenceDirectives = void 0;
	      node.amdDependencies = void 0;
	      node.commentDirectives = void 0;
	      node.identifiers = void 0;
	      node.packageJsonLocations = void 0;
	      node.packageJsonScope = void 0;
	      node.imports = void 0;
	      node.moduleAugmentations = void 0;
	      node.ambientModuleNames = void 0;
	      node.classifiableNames = void 0;
	      node.impliedNodeFormat = void 0;
	      return node;
	    }
	    function createRedirectedSourceFile(redirectInfo) {
	      const node = Object.create(redirectInfo.redirectTarget);
	      Object.defineProperties(node, {
	        id: {
	          get() {
	            return this.redirectInfo.redirectTarget.id;
	          },
	          set(value) {
	            this.redirectInfo.redirectTarget.id = value;
	          }
	        },
	        symbol: {
	          get() {
	            return this.redirectInfo.redirectTarget.symbol;
	          },
	          set(value) {
	            this.redirectInfo.redirectTarget.symbol = value;
	          }
	        }
	      });
	      node.redirectInfo = redirectInfo;
	      return node;
	    }
	    function cloneRedirectedSourceFile(source) {
	      const node = createRedirectedSourceFile(source.redirectInfo);
	      node.flags |= source.flags & ~16 /* Synthesized */;
	      node.fileName = source.fileName;
	      node.path = source.path;
	      node.resolvedPath = source.resolvedPath;
	      node.originalFileName = source.originalFileName;
	      node.packageJsonLocations = source.packageJsonLocations;
	      node.packageJsonScope = source.packageJsonScope;
	      node.emitNode = void 0;
	      return node;
	    }
	    function cloneSourceFileWorker(source) {
	      const node = baseFactory2.createBaseSourceFileNode(312 /* SourceFile */);
	      node.flags |= source.flags & ~16 /* Synthesized */;
	      for (const p in source) {
	        if (hasProperty(node, p) || !hasProperty(source, p)) {
	          continue;
	        }
	        if (p === "emitNode") {
	          node.emitNode = void 0;
	          continue;
	        }
	        node[p] = source[p];
	      }
	      return node;
	    }
	    function cloneSourceFile(source) {
	      const node = source.redirectInfo ? cloneRedirectedSourceFile(source) : cloneSourceFileWorker(source);
	      setOriginal(node, source);
	      return node;
	    }
	    function cloneSourceFileWithChanges(source, statements, isDeclarationFile, referencedFiles, typeReferences, hasNoDefaultLib, libReferences) {
	      const node = cloneSourceFile(source);
	      node.statements = createNodeArray(statements);
	      node.isDeclarationFile = isDeclarationFile;
	      node.referencedFiles = referencedFiles;
	      node.typeReferenceDirectives = typeReferences;
	      node.hasNoDefaultLib = hasNoDefaultLib;
	      node.libReferenceDirectives = libReferences;
	      node.transformFlags = propagateChildrenFlags(node.statements) | propagateChildFlags(node.endOfFileToken);
	      return node;
	    }
	    function updateSourceFile2(node, statements, isDeclarationFile = node.isDeclarationFile, referencedFiles = node.referencedFiles, typeReferenceDirectives = node.typeReferenceDirectives, hasNoDefaultLib = node.hasNoDefaultLib, libReferenceDirectives = node.libReferenceDirectives) {
	      return node.statements !== statements || node.isDeclarationFile !== isDeclarationFile || node.referencedFiles !== referencedFiles || node.typeReferenceDirectives !== typeReferenceDirectives || node.hasNoDefaultLib !== hasNoDefaultLib || node.libReferenceDirectives !== libReferenceDirectives ? update(cloneSourceFileWithChanges(node, statements, isDeclarationFile, referencedFiles, typeReferenceDirectives, hasNoDefaultLib, libReferenceDirectives), node) : node;
	    }
	    function createBundle(sourceFiles, prepends = emptyArray) {
	      const node = createBaseNode(313 /* Bundle */);
	      node.prepends = prepends;
	      node.sourceFiles = sourceFiles;
	      node.syntheticFileReferences = void 0;
	      node.syntheticTypeReferences = void 0;
	      node.syntheticLibReferences = void 0;
	      node.hasNoDefaultLib = void 0;
	      return node;
	    }
	    function updateBundle(node, sourceFiles, prepends = emptyArray) {
	      return node.sourceFiles !== sourceFiles || node.prepends !== prepends ? update(createBundle(sourceFiles, prepends), node) : node;
	    }
	    function createUnparsedSource(prologues, syntheticReferences, texts) {
	      const node = createBaseNode(314 /* UnparsedSource */);
	      node.prologues = prologues;
	      node.syntheticReferences = syntheticReferences;
	      node.texts = texts;
	      node.fileName = "";
	      node.text = "";
	      node.referencedFiles = emptyArray;
	      node.libReferenceDirectives = emptyArray;
	      node.getLineAndCharacterOfPosition = (pos) => getLineAndCharacterOfPosition(node, pos);
	      return node;
	    }
	    function createBaseUnparsedNode(kind, data) {
	      const node = createBaseNode(kind);
	      node.data = data;
	      return node;
	    }
	    function createUnparsedPrologue(data) {
	      return createBaseUnparsedNode(307 /* UnparsedPrologue */, data);
	    }
	    function createUnparsedPrepend(data, texts) {
	      const node = createBaseUnparsedNode(308 /* UnparsedPrepend */, data);
	      node.texts = texts;
	      return node;
	    }
	    function createUnparsedTextLike(data, internal) {
	      return createBaseUnparsedNode(internal ? 310 /* UnparsedInternalText */ : 309 /* UnparsedText */, data);
	    }
	    function createUnparsedSyntheticReference(section) {
	      const node = createBaseNode(311 /* UnparsedSyntheticReference */);
	      node.data = section.data;
	      node.section = section;
	      return node;
	    }
	    function createInputFiles2() {
	      const node = createBaseNode(315 /* InputFiles */);
	      node.javascriptText = "";
	      node.declarationText = "";
	      return node;
	    }
	    function createSyntheticExpression(type, isSpread = false, tupleNameSource) {
	      const node = createBaseNode(237 /* SyntheticExpression */);
	      node.type = type;
	      node.isSpread = isSpread;
	      node.tupleNameSource = tupleNameSource;
	      return node;
	    }
	    function createSyntaxList3(children) {
	      const node = createBaseNode(358 /* SyntaxList */);
	      node._children = children;
	      return node;
	    }
	    function createNotEmittedStatement(original) {
	      const node = createBaseNode(359 /* NotEmittedStatement */);
	      node.original = original;
	      setTextRange(node, original);
	      return node;
	    }
	    function createPartiallyEmittedExpression(expression, original) {
	      const node = createBaseNode(360 /* PartiallyEmittedExpression */);
	      node.expression = expression;
	      node.original = original;
	      node.transformFlags |= propagateChildFlags(node.expression) | 1 /* ContainsTypeScript */;
	      setTextRange(node, original);
	      return node;
	    }
	    function updatePartiallyEmittedExpression(node, expression) {
	      return node.expression !== expression ? update(createPartiallyEmittedExpression(expression, node.original), node) : node;
	    }
	    function flattenCommaElements(node) {
	      if (nodeIsSynthesized(node) && !isParseTreeNode(node) && !node.original && !node.emitNode && !node.id) {
	        if (isCommaListExpression(node)) {
	          return node.elements;
	        }
	        if (isBinaryExpression(node) && isCommaToken(node.operatorToken)) {
	          return [node.left, node.right];
	        }
	      }
	      return node;
	    }
	    function createCommaListExpression(elements) {
	      const node = createBaseNode(361 /* CommaListExpression */);
	      node.elements = createNodeArray(sameFlatMap(elements, flattenCommaElements));
	      node.transformFlags |= propagateChildrenFlags(node.elements);
	      return node;
	    }
	    function updateCommaListExpression(node, elements) {
	      return node.elements !== elements ? update(createCommaListExpression(elements), node) : node;
	    }
	    function createSyntheticReferenceExpression(expression, thisArg) {
	      const node = createBaseNode(362 /* SyntheticReferenceExpression */);
	      node.expression = expression;
	      node.thisArg = thisArg;
	      node.transformFlags |= propagateChildFlags(node.expression) | propagateChildFlags(node.thisArg);
	      return node;
	    }
	    function updateSyntheticReferenceExpression(node, expression, thisArg) {
	      return node.expression !== expression || node.thisArg !== thisArg ? update(createSyntheticReferenceExpression(expression, thisArg), node) : node;
	    }
	    function cloneGeneratedIdentifier(node) {
	      const clone2 = createBaseIdentifier(node.escapedText);
	      clone2.flags |= node.flags & ~16 /* Synthesized */;
	      clone2.transformFlags = node.transformFlags;
	      setOriginal(clone2, node);
	      setIdentifierAutoGenerate(clone2, { ...node.emitNode.autoGenerate });
	      return clone2;
	    }
	    function cloneIdentifier(node) {
	      const clone2 = createBaseIdentifier(node.escapedText);
	      clone2.flags |= node.flags & ~16 /* Synthesized */;
	      clone2.jsDoc = node.jsDoc;
	      clone2.flowNode = node.flowNode;
	      clone2.symbol = node.symbol;
	      clone2.transformFlags = node.transformFlags;
	      setOriginal(clone2, node);
	      const typeArguments = getIdentifierTypeArguments(node);
	      if (typeArguments)
	        setIdentifierTypeArguments(clone2, typeArguments);
	      return clone2;
	    }
	    function cloneGeneratedPrivateIdentifier(node) {
	      const clone2 = createBasePrivateIdentifier(node.escapedText);
	      clone2.flags |= node.flags & ~16 /* Synthesized */;
	      clone2.transformFlags = node.transformFlags;
	      setOriginal(clone2, node);
	      setIdentifierAutoGenerate(clone2, { ...node.emitNode.autoGenerate });
	      return clone2;
	    }
	    function clonePrivateIdentifier(node) {
	      const clone2 = createBasePrivateIdentifier(node.escapedText);
	      clone2.flags |= node.flags & ~16 /* Synthesized */;
	      clone2.transformFlags = node.transformFlags;
	      setOriginal(clone2, node);
	      return clone2;
	    }
	    function cloneNode(node) {
	      if (node === void 0) {
	        return node;
	      }
	      if (isSourceFile(node)) {
	        return cloneSourceFile(node);
	      }
	      if (isGeneratedIdentifier(node)) {
	        return cloneGeneratedIdentifier(node);
	      }
	      if (isIdentifier(node)) {
	        return cloneIdentifier(node);
	      }
	      if (isGeneratedPrivateIdentifier(node)) {
	        return cloneGeneratedPrivateIdentifier(node);
	      }
	      if (isPrivateIdentifier(node)) {
	        return clonePrivateIdentifier(node);
	      }
	      const clone2 = !isNodeKind(node.kind) ? baseFactory2.createBaseTokenNode(node.kind) : baseFactory2.createBaseNode(node.kind);
	      clone2.flags |= node.flags & ~16 /* Synthesized */;
	      clone2.transformFlags = node.transformFlags;
	      setOriginal(clone2, node);
	      for (const key in node) {
	        if (hasProperty(clone2, key) || !hasProperty(node, key)) {
	          continue;
	        }
	        clone2[key] = node[key];
	      }
	      return clone2;
	    }
	    function createImmediatelyInvokedFunctionExpression(statements, param, paramValue) {
	      return createCallExpression(
	        createFunctionExpression(
	          /*modifiers*/
	          void 0,
	          /*asteriskToken*/
	          void 0,
	          /*name*/
	          void 0,
	          /*typeParameters*/
	          void 0,
	          /*parameters*/
	          param ? [param] : [],
	          /*type*/
	          void 0,
	          createBlock(
	            statements,
	            /*multiLine*/
	            true
	          )
	        ),
	        /*typeArguments*/
	        void 0,
	        /*argumentsArray*/
	        paramValue ? [paramValue] : []
	      );
	    }
	    function createImmediatelyInvokedArrowFunction(statements, param, paramValue) {
	      return createCallExpression(
	        createArrowFunction(
	          /*modifiers*/
	          void 0,
	          /*typeParameters*/
	          void 0,
	          /*parameters*/
	          param ? [param] : [],
	          /*type*/
	          void 0,
	          /*equalsGreaterThanToken*/
	          void 0,
	          createBlock(
	            statements,
	            /*multiLine*/
	            true
	          )
	        ),
	        /*typeArguments*/
	        void 0,
	        /*argumentsArray*/
	        paramValue ? [paramValue] : []
	      );
	    }
	    function createVoidZero() {
	      return createVoidExpression(createNumericLiteral("0"));
	    }
	    function createExportDefault(expression) {
	      return createExportAssignment2(
	        /*modifiers*/
	        void 0,
	        /*isExportEquals*/
	        false,
	        expression
	      );
	    }
	    function createExternalModuleExport(exportName) {
	      return createExportDeclaration(
	        /*modifiers*/
	        void 0,
	        /*isTypeOnly*/
	        false,
	        createNamedExports([
	          createExportSpecifier(
	            /*isTypeOnly*/
	            false,
	            /*propertyName*/
	            void 0,
	            exportName
	          )
	        ])
	      );
	    }
	    function createTypeCheck(value, tag) {
	      return tag === "null" ? factory2.createStrictEquality(value, createNull()) : tag === "undefined" ? factory2.createStrictEquality(value, createVoidZero()) : factory2.createStrictEquality(createTypeOfExpression(value), createStringLiteral(tag));
	    }
	    function createIsNotTypeCheck(value, tag) {
	      return tag === "null" ? factory2.createStrictInequality(value, createNull()) : tag === "undefined" ? factory2.createStrictInequality(value, createVoidZero()) : factory2.createStrictInequality(createTypeOfExpression(value), createStringLiteral(tag));
	    }
	    function createMethodCall(object, methodName, argumentsList) {
	      if (isCallChain(object)) {
	        return createCallChain(
	          createPropertyAccessChain(
	            object,
	            /*questionDotToken*/
	            void 0,
	            methodName
	          ),
	          /*questionDotToken*/
	          void 0,
	          /*typeArguments*/
	          void 0,
	          argumentsList
	        );
	      }
	      return createCallExpression(
	        createPropertyAccessExpression(object, methodName),
	        /*typeArguments*/
	        void 0,
	        argumentsList
	      );
	    }
	    function createFunctionBindCall(target, thisArg, argumentsList) {
	      return createMethodCall(target, "bind", [thisArg, ...argumentsList]);
	    }
	    function createFunctionCallCall(target, thisArg, argumentsList) {
	      return createMethodCall(target, "call", [thisArg, ...argumentsList]);
	    }
	    function createFunctionApplyCall(target, thisArg, argumentsExpression) {
	      return createMethodCall(target, "apply", [thisArg, argumentsExpression]);
	    }
	    function createGlobalMethodCall(globalObjectName, methodName, argumentsList) {
	      return createMethodCall(createIdentifier(globalObjectName), methodName, argumentsList);
	    }
	    function createArraySliceCall(array, start) {
	      return createMethodCall(array, "slice", start === void 0 ? [] : [asExpression(start)]);
	    }
	    function createArrayConcatCall(array, argumentsList) {
	      return createMethodCall(array, "concat", argumentsList);
	    }
	    function createObjectDefinePropertyCall(target, propertyName, attributes) {
	      return createGlobalMethodCall("Object", "defineProperty", [target, asExpression(propertyName), attributes]);
	    }
	    function createObjectGetOwnPropertyDescriptorCall(target, propertyName) {
	      return createGlobalMethodCall("Object", "getOwnPropertyDescriptor", [target, asExpression(propertyName)]);
	    }
	    function createReflectGetCall(target, propertyKey, receiver) {
	      return createGlobalMethodCall("Reflect", "get", receiver ? [target, propertyKey, receiver] : [target, propertyKey]);
	    }
	    function createReflectSetCall(target, propertyKey, value, receiver) {
	      return createGlobalMethodCall("Reflect", "set", receiver ? [target, propertyKey, value, receiver] : [target, propertyKey, value]);
	    }
	    function tryAddPropertyAssignment(properties, propertyName, expression) {
	      if (expression) {
	        properties.push(createPropertyAssignment(propertyName, expression));
	        return true;
	      }
	      return false;
	    }
	    function createPropertyDescriptor(attributes, singleLine) {
	      const properties = [];
	      tryAddPropertyAssignment(properties, "enumerable", asExpression(attributes.enumerable));
	      tryAddPropertyAssignment(properties, "configurable", asExpression(attributes.configurable));
	      let isData = tryAddPropertyAssignment(properties, "writable", asExpression(attributes.writable));
	      isData = tryAddPropertyAssignment(properties, "value", attributes.value) || isData;
	      let isAccessor2 = tryAddPropertyAssignment(properties, "get", attributes.get);
	      isAccessor2 = tryAddPropertyAssignment(properties, "set", attributes.set) || isAccessor2;
	      Debug.assert(!(isData && isAccessor2), "A PropertyDescriptor may not be both an accessor descriptor and a data descriptor.");
	      return createObjectLiteralExpression(properties, !singleLine);
	    }
	    function updateOuterExpression(outerExpression, expression) {
	      switch (outerExpression.kind) {
	        case 217 /* ParenthesizedExpression */:
	          return updateParenthesizedExpression(outerExpression, expression);
	        case 216 /* TypeAssertionExpression */:
	          return updateTypeAssertion(outerExpression, outerExpression.type, expression);
	        case 234 /* AsExpression */:
	          return updateAsExpression(outerExpression, expression, outerExpression.type);
	        case 238 /* SatisfiesExpression */:
	          return updateSatisfiesExpression(outerExpression, expression, outerExpression.type);
	        case 235 /* NonNullExpression */:
	          return updateNonNullExpression(outerExpression, expression);
	        case 360 /* PartiallyEmittedExpression */:
	          return updatePartiallyEmittedExpression(outerExpression, expression);
	      }
	    }
	    function isIgnorableParen(node) {
	      return isParenthesizedExpression(node) && nodeIsSynthesized(node) && nodeIsSynthesized(getSourceMapRange(node)) && nodeIsSynthesized(getCommentRange(node)) && !some(getSyntheticLeadingComments(node)) && !some(getSyntheticTrailingComments(node));
	    }
	    function restoreOuterExpressions(outerExpression, innerExpression, kinds = 15 /* All */) {
	      if (outerExpression && isOuterExpression(outerExpression, kinds) && !isIgnorableParen(outerExpression)) {
	        return updateOuterExpression(
	          outerExpression,
	          restoreOuterExpressions(outerExpression.expression, innerExpression)
	        );
	      }
	      return innerExpression;
	    }
	    function restoreEnclosingLabel(node, outermostLabeledStatement, afterRestoreLabelCallback) {
	      if (!outermostLabeledStatement) {
	        return node;
	      }
	      const updated = updateLabeledStatement(
	        outermostLabeledStatement,
	        outermostLabeledStatement.label,
	        isLabeledStatement(outermostLabeledStatement.statement) ? restoreEnclosingLabel(node, outermostLabeledStatement.statement) : node
	      );
	      if (afterRestoreLabelCallback) {
	        afterRestoreLabelCallback(outermostLabeledStatement);
	      }
	      return updated;
	    }
	    function shouldBeCapturedInTempVariable(node, cacheIdentifiers) {
	      const target = skipParentheses(node);
	      switch (target.kind) {
	        case 80 /* Identifier */:
	          return cacheIdentifiers;
	        case 110 /* ThisKeyword */:
	        case 9 /* NumericLiteral */:
	        case 10 /* BigIntLiteral */:
	        case 11 /* StringLiteral */:
	          return false;
	        case 209 /* ArrayLiteralExpression */:
	          const elements = target.elements;
	          if (elements.length === 0) {
	            return false;
	          }
	          return true;
	        case 210 /* ObjectLiteralExpression */:
	          return target.properties.length > 0;
	        default:
	          return true;
	      }
	    }
	    function createCallBinding(expression, recordTempVariable, languageVersion, cacheIdentifiers = false) {
	      const callee = skipOuterExpressions(expression, 15 /* All */);
	      let thisArg;
	      let target;
	      if (isSuperProperty(callee)) {
	        thisArg = createThis();
	        target = callee;
	      } else if (isSuperKeyword(callee)) {
	        thisArg = createThis();
	        target = languageVersion !== void 0 && languageVersion < 2 /* ES2015 */ ? setTextRange(createIdentifier("_super"), callee) : callee;
	      } else if (getEmitFlags(callee) & 8192 /* HelperName */) {
	        thisArg = createVoidZero();
	        target = parenthesizerRules().parenthesizeLeftSideOfAccess(
	          callee,
	          /*optionalChain*/
	          false
	        );
	      } else if (isPropertyAccessExpression(callee)) {
	        if (shouldBeCapturedInTempVariable(callee.expression, cacheIdentifiers)) {
	          thisArg = createTempVariable(recordTempVariable);
	          target = createPropertyAccessExpression(
	            setTextRange(
	              factory2.createAssignment(
	                thisArg,
	                callee.expression
	              ),
	              callee.expression
	            ),
	            callee.name
	          );
	          setTextRange(target, callee);
	        } else {
	          thisArg = callee.expression;
	          target = callee;
	        }
	      } else if (isElementAccessExpression(callee)) {
	        if (shouldBeCapturedInTempVariable(callee.expression, cacheIdentifiers)) {
	          thisArg = createTempVariable(recordTempVariable);
	          target = createElementAccessExpression(
	            setTextRange(
	              factory2.createAssignment(
	                thisArg,
	                callee.expression
	              ),
	              callee.expression
	            ),
	            callee.argumentExpression
	          );
	          setTextRange(target, callee);
	        } else {
	          thisArg = callee.expression;
	          target = callee;
	        }
	      } else {
	        thisArg = createVoidZero();
	        target = parenthesizerRules().parenthesizeLeftSideOfAccess(
	          expression,
	          /*optionalChain*/
	          false
	        );
	      }
	      return { target, thisArg };
	    }
	    function createAssignmentTargetWrapper(paramName, expression) {
	      return createPropertyAccessExpression(
	        // Explicit parens required because of v8 regression (https://bugs.chromium.org/p/v8/issues/detail?id=9560)
	        createParenthesizedExpression(
	          createObjectLiteralExpression([
	            createSetAccessorDeclaration(
	              /*modifiers*/
	              void 0,
	              "value",
	              [createParameterDeclaration(
	                /*modifiers*/
	                void 0,
	                /*dotDotDotToken*/
	                void 0,
	                paramName,
	                /*questionToken*/
	                void 0,
	                /*type*/
	                void 0,
	                /*initializer*/
	                void 0
	              )],
	              createBlock([
	                createExpressionStatement(expression)
	              ])
	            )
	          ])
	        ),
	        "value"
	      );
	    }
	    function inlineExpressions(expressions) {
	      return expressions.length > 10 ? createCommaListExpression(expressions) : reduceLeft(expressions, factory2.createComma);
	    }
	    function getName(node, allowComments, allowSourceMaps, emitFlags = 0, ignoreAssignedName) {
	      const nodeName = ignoreAssignedName ? node && getNonAssignedNameOfDeclaration(node) : getNameOfDeclaration(node);
	      if (nodeName && isIdentifier(nodeName) && !isGeneratedIdentifier(nodeName)) {
	        const name = setParent(setTextRange(cloneNode(nodeName), nodeName), nodeName.parent);
	        emitFlags |= getEmitFlags(nodeName);
	        if (!allowSourceMaps)
	          emitFlags |= 96 /* NoSourceMap */;
	        if (!allowComments)
	          emitFlags |= 3072 /* NoComments */;
	        if (emitFlags)
	          setEmitFlags(name, emitFlags);
	        return name;
	      }
	      return getGeneratedNameForNode(node);
	    }
	    function getInternalName(node, allowComments, allowSourceMaps) {
	      return getName(node, allowComments, allowSourceMaps, 32768 /* LocalName */ | 65536 /* InternalName */);
	    }
	    function getLocalName(node, allowComments, allowSourceMaps, ignoreAssignedName) {
	      return getName(node, allowComments, allowSourceMaps, 32768 /* LocalName */, ignoreAssignedName);
	    }
	    function getExportName(node, allowComments, allowSourceMaps) {
	      return getName(node, allowComments, allowSourceMaps, 16384 /* ExportName */);
	    }
	    function getDeclarationName(node, allowComments, allowSourceMaps) {
	      return getName(node, allowComments, allowSourceMaps);
	    }
	    function getNamespaceMemberName(ns, name, allowComments, allowSourceMaps) {
	      const qualifiedName = createPropertyAccessExpression(ns, nodeIsSynthesized(name) ? name : cloneNode(name));
	      setTextRange(qualifiedName, name);
	      let emitFlags = 0;
	      if (!allowSourceMaps)
	        emitFlags |= 96 /* NoSourceMap */;
	      if (!allowComments)
	        emitFlags |= 3072 /* NoComments */;
	      if (emitFlags)
	        setEmitFlags(qualifiedName, emitFlags);
	      return qualifiedName;
	    }
	    function getExternalModuleOrNamespaceExportName(ns, node, allowComments, allowSourceMaps) {
	      if (ns && hasSyntacticModifier(node, 32 /* Export */)) {
	        return getNamespaceMemberName(ns, getName(node), allowComments, allowSourceMaps);
	      }
	      return getExportName(node, allowComments, allowSourceMaps);
	    }
	    function copyPrologue(source, target, ensureUseStrict2, visitor) {
	      const offset = copyStandardPrologue(source, target, 0, ensureUseStrict2);
	      return copyCustomPrologue(source, target, offset, visitor);
	    }
	    function isUseStrictPrologue2(node) {
	      return isStringLiteral(node.expression) && node.expression.text === "use strict";
	    }
	    function createUseStrictPrologue() {
	      return startOnNewLine(createExpressionStatement(createStringLiteral("use strict")));
	    }
	    function copyStandardPrologue(source, target, statementOffset = 0, ensureUseStrict2) {
	      Debug.assert(target.length === 0, "Prologue directives should be at the first statement in the target statements array");
	      let foundUseStrict = false;
	      const numStatements = source.length;
	      while (statementOffset < numStatements) {
	        const statement = source[statementOffset];
	        if (isPrologueDirective(statement)) {
	          if (isUseStrictPrologue2(statement)) {
	            foundUseStrict = true;
	          }
	          target.push(statement);
	        } else {
	          break;
	        }
	        statementOffset++;
	      }
	      if (ensureUseStrict2 && !foundUseStrict) {
	        target.push(createUseStrictPrologue());
	      }
	      return statementOffset;
	    }
	    function copyCustomPrologue(source, target, statementOffset, visitor, filter2 = returnTrue) {
	      const numStatements = source.length;
	      while (statementOffset !== void 0 && statementOffset < numStatements) {
	        const statement = source[statementOffset];
	        if (getEmitFlags(statement) & 2097152 /* CustomPrologue */ && filter2(statement)) {
	          append(target, visitor ? visitNode(statement, visitor, isStatement) : statement);
	        } else {
	          break;
	        }
	        statementOffset++;
	      }
	      return statementOffset;
	    }
	    function ensureUseStrict(statements) {
	      const foundUseStrict = findUseStrictPrologue(statements);
	      if (!foundUseStrict) {
	        return setTextRange(createNodeArray([createUseStrictPrologue(), ...statements]), statements);
	      }
	      return statements;
	    }
	    function liftToBlock(nodes) {
	      Debug.assert(every(nodes, isStatementOrBlock), "Cannot lift nodes to a Block.");
	      return singleOrUndefined(nodes) || createBlock(nodes);
	    }
	    function findSpanEnd(array, test, start) {
	      let i = start;
	      while (i < array.length && test(array[i])) {
	        i++;
	      }
	      return i;
	    }
	    function mergeLexicalEnvironment(statements, declarations) {
	      if (!some(declarations)) {
	        return statements;
	      }
	      const leftStandardPrologueEnd = findSpanEnd(statements, isPrologueDirective, 0);
	      const leftHoistedFunctionsEnd = findSpanEnd(statements, isHoistedFunction, leftStandardPrologueEnd);
	      const leftHoistedVariablesEnd = findSpanEnd(statements, isHoistedVariableStatement, leftHoistedFunctionsEnd);
	      const rightStandardPrologueEnd = findSpanEnd(declarations, isPrologueDirective, 0);
	      const rightHoistedFunctionsEnd = findSpanEnd(declarations, isHoistedFunction, rightStandardPrologueEnd);
	      const rightHoistedVariablesEnd = findSpanEnd(declarations, isHoistedVariableStatement, rightHoistedFunctionsEnd);
	      const rightCustomPrologueEnd = findSpanEnd(declarations, isCustomPrologue, rightHoistedVariablesEnd);
	      Debug.assert(rightCustomPrologueEnd === declarations.length, "Expected declarations to be valid standard or custom prologues");
	      const left = isNodeArray(statements) ? statements.slice() : statements;
	      if (rightCustomPrologueEnd > rightHoistedVariablesEnd) {
	        left.splice(leftHoistedVariablesEnd, 0, ...declarations.slice(rightHoistedVariablesEnd, rightCustomPrologueEnd));
	      }
	      if (rightHoistedVariablesEnd > rightHoistedFunctionsEnd) {
	        left.splice(leftHoistedFunctionsEnd, 0, ...declarations.slice(rightHoistedFunctionsEnd, rightHoistedVariablesEnd));
	      }
	      if (rightHoistedFunctionsEnd > rightStandardPrologueEnd) {
	        left.splice(leftStandardPrologueEnd, 0, ...declarations.slice(rightStandardPrologueEnd, rightHoistedFunctionsEnd));
	      }
	      if (rightStandardPrologueEnd > 0) {
	        if (leftStandardPrologueEnd === 0) {
	          left.splice(0, 0, ...declarations.slice(0, rightStandardPrologueEnd));
	        } else {
	          const leftPrologues = /* @__PURE__ */ new Map();
	          for (let i = 0; i < leftStandardPrologueEnd; i++) {
	            const leftPrologue = statements[i];
	            leftPrologues.set(leftPrologue.expression.text, true);
	          }
	          for (let i = rightStandardPrologueEnd - 1; i >= 0; i--) {
	            const rightPrologue = declarations[i];
	            if (!leftPrologues.has(rightPrologue.expression.text)) {
	              left.unshift(rightPrologue);
	            }
	          }
	        }
	      }
	      if (isNodeArray(statements)) {
	        return setTextRange(createNodeArray(left, statements.hasTrailingComma), statements);
	      }
	      return statements;
	    }
	    function replaceModifiers(node, modifiers) {
	      let modifierArray;
	      if (typeof modifiers === "number") {
	        modifierArray = createModifiersFromModifierFlags(modifiers);
	      } else {
	        modifierArray = modifiers;
	      }
	      return isTypeParameterDeclaration(node) ? updateTypeParameterDeclaration(node, modifierArray, node.name, node.constraint, node.default) : isParameter(node) ? updateParameterDeclaration(node, modifierArray, node.dotDotDotToken, node.name, node.questionToken, node.type, node.initializer) : isConstructorTypeNode(node) ? updateConstructorTypeNode1(node, modifierArray, node.typeParameters, node.parameters, node.type) : isPropertySignature(node) ? updatePropertySignature(node, modifierArray, node.name, node.questionToken, node.type) : isPropertyDeclaration(node) ? updatePropertyDeclaration2(node, modifierArray, node.name, node.questionToken ?? node.exclamationToken, node.type, node.initializer) : isMethodSignature(node) ? updateMethodSignature(node, modifierArray, node.name, node.questionToken, node.typeParameters, node.parameters, node.type) : isMethodDeclaration(node) ? updateMethodDeclaration(node, modifierArray, node.asteriskToken, node.name, node.questionToken, node.typeParameters, node.parameters, node.type, node.body) : isConstructorDeclaration(node) ? updateConstructorDeclaration(node, modifierArray, node.parameters, node.body) : isGetAccessorDeclaration(node) ? updateGetAccessorDeclaration(node, modifierArray, node.name, node.parameters, node.type, node.body) : isSetAccessorDeclaration(node) ? updateSetAccessorDeclaration(node, modifierArray, node.name, node.parameters, node.body) : isIndexSignatureDeclaration(node) ? updateIndexSignature(node, modifierArray, node.parameters, node.type) : isFunctionExpression(node) ? updateFunctionExpression(node, modifierArray, node.asteriskToken, node.name, node.typeParameters, node.parameters, node.type, node.body) : isArrowFunction(node) ? updateArrowFunction(node, modifierArray, node.typeParameters, node.parameters, node.type, node.equalsGreaterThanToken, node.body) : isClassExpression(node) ? updateClassExpression(node, modifierArray, node.name, node.typeParameters, node.heritageClauses, node.members) : isVariableStatement(node) ? updateVariableStatement(node, modifierArray, node.declarationList) : isFunctionDeclaration(node) ? updateFunctionDeclaration(node, modifierArray, node.asteriskToken, node.name, node.typeParameters, node.parameters, node.type, node.body) : isClassDeclaration(node) ? updateClassDeclaration(node, modifierArray, node.name, node.typeParameters, node.heritageClauses, node.members) : isInterfaceDeclaration(node) ? updateInterfaceDeclaration(node, modifierArray, node.name, node.typeParameters, node.heritageClauses, node.members) : isTypeAliasDeclaration(node) ? updateTypeAliasDeclaration(node, modifierArray, node.name, node.typeParameters, node.type) : isEnumDeclaration(node) ? updateEnumDeclaration(node, modifierArray, node.name, node.members) : isModuleDeclaration(node) ? updateModuleDeclaration(node, modifierArray, node.name, node.body) : isImportEqualsDeclaration(node) ? updateImportEqualsDeclaration(node, modifierArray, node.isTypeOnly, node.name, node.moduleReference) : isImportDeclaration(node) ? updateImportDeclaration(node, modifierArray, node.importClause, node.moduleSpecifier, node.attributes) : isExportAssignment(node) ? updateExportAssignment(node, modifierArray, node.expression) : isExportDeclaration(node) ? updateExportDeclaration(node, modifierArray, node.isTypeOnly, node.exportClause, node.moduleSpecifier, node.attributes) : Debug.assertNever(node);
	    }
	    function replaceDecoratorsAndModifiers(node, modifierArray) {
	      return isParameter(node) ? updateParameterDeclaration(node, modifierArray, node.dotDotDotToken, node.name, node.questionToken, node.type, node.initializer) : isPropertyDeclaration(node) ? updatePropertyDeclaration2(node, modifierArray, node.name, node.questionToken ?? node.exclamationToken, node.type, node.initializer) : isMethodDeclaration(node) ? updateMethodDeclaration(node, modifierArray, node.asteriskToken, node.name, node.questionToken, node.typeParameters, node.parameters, node.type, node.body) : isGetAccessorDeclaration(node) ? updateGetAccessorDeclaration(node, modifierArray, node.name, node.parameters, node.type, node.body) : isSetAccessorDeclaration(node) ? updateSetAccessorDeclaration(node, modifierArray, node.name, node.parameters, node.body) : isClassExpression(node) ? updateClassExpression(node, modifierArray, node.name, node.typeParameters, node.heritageClauses, node.members) : isClassDeclaration(node) ? updateClassDeclaration(node, modifierArray, node.name, node.typeParameters, node.heritageClauses, node.members) : Debug.assertNever(node);
	    }
	    function replacePropertyName(node, name) {
	      switch (node.kind) {
	        case 177 /* GetAccessor */:
	          return updateGetAccessorDeclaration(node, node.modifiers, name, node.parameters, node.type, node.body);
	        case 178 /* SetAccessor */:
	          return updateSetAccessorDeclaration(node, node.modifiers, name, node.parameters, node.body);
	        case 174 /* MethodDeclaration */:
	          return updateMethodDeclaration(node, node.modifiers, node.asteriskToken, name, node.questionToken, node.typeParameters, node.parameters, node.type, node.body);
	        case 173 /* MethodSignature */:
	          return updateMethodSignature(node, node.modifiers, name, node.questionToken, node.typeParameters, node.parameters, node.type);
	        case 172 /* PropertyDeclaration */:
	          return updatePropertyDeclaration2(node, node.modifiers, name, node.questionToken ?? node.exclamationToken, node.type, node.initializer);
	        case 171 /* PropertySignature */:
	          return updatePropertySignature(node, node.modifiers, name, node.questionToken, node.type);
	        case 303 /* PropertyAssignment */:
	          return updatePropertyAssignment(node, name, node.initializer);
	      }
	    }
	    function asNodeArray(array) {
	      return array ? createNodeArray(array) : void 0;
	    }
	    function asName(name) {
	      return typeof name === "string" ? createIdentifier(name) : name;
	    }
	    function asExpression(value) {
	      return typeof value === "string" ? createStringLiteral(value) : typeof value === "number" ? createNumericLiteral(value) : typeof value === "boolean" ? value ? createTrue() : createFalse() : value;
	    }
	    function asInitializer(node) {
	      return node && parenthesizerRules().parenthesizeExpressionForDisallowedComma(node);
	    }
	    function asToken(value) {
	      return typeof value === "number" ? createToken(value) : value;
	    }
	    function asEmbeddedStatement(statement) {
	      return statement && isNotEmittedStatement(statement) ? setTextRange(setOriginal(createEmptyStatement(), statement), statement) : statement;
	    }
	    function asVariableDeclaration(variableDeclaration) {
	      if (typeof variableDeclaration === "string" || variableDeclaration && !isVariableDeclaration(variableDeclaration)) {
	        return createVariableDeclaration(
	          variableDeclaration,
	          /*exclamationToken*/
	          void 0,
	          /*type*/
	          void 0,
	          /*initializer*/
	          void 0
	        );
	      }
	      return variableDeclaration;
	    }
	    function update(updated, original) {
	      if (updated !== original) {
	        setOriginal(updated, original);
	        setTextRange(updated, original);
	      }
	      return updated;
	    }
	  }
	  function getDefaultTagNameForKind(kind) {
	    switch (kind) {
	      case 351 /* JSDocTypeTag */:
	        return "type";
	      case 349 /* JSDocReturnTag */:
	        return "returns";
	      case 350 /* JSDocThisTag */:
	        return "this";
	      case 347 /* JSDocEnumTag */:
	        return "enum";
	      case 337 /* JSDocAuthorTag */:
	        return "author";
	      case 339 /* JSDocClassTag */:
	        return "class";
	      case 340 /* JSDocPublicTag */:
	        return "public";
	      case 341 /* JSDocPrivateTag */:
	        return "private";
	      case 342 /* JSDocProtectedTag */:
	        return "protected";
	      case 343 /* JSDocReadonlyTag */:
	        return "readonly";
	      case 344 /* JSDocOverrideTag */:
	        return "override";
	      case 352 /* JSDocTemplateTag */:
	        return "template";
	      case 353 /* JSDocTypedefTag */:
	        return "typedef";
	      case 348 /* JSDocParameterTag */:
	        return "param";
	      case 355 /* JSDocPropertyTag */:
	        return "prop";
	      case 345 /* JSDocCallbackTag */:
	        return "callback";
	      case 346 /* JSDocOverloadTag */:
	        return "overload";
	      case 335 /* JSDocAugmentsTag */:
	        return "augments";
	      case 336 /* JSDocImplementsTag */:
	        return "implements";
	      default:
	        return Debug.fail(`Unsupported kind: ${Debug.formatSyntaxKind(kind)}`);
	    }
	  }
	  function getCookedText(kind, rawText) {
	    if (!rawTextScanner) {
	      rawTextScanner = createScanner(
	        99 /* Latest */,
	        /*skipTrivia*/
	        false,
	        0 /* Standard */
	      );
	    }
	    switch (kind) {
	      case 15 /* NoSubstitutionTemplateLiteral */:
	        rawTextScanner.setText("`" + rawText + "`");
	        break;
	      case 16 /* TemplateHead */:
	        rawTextScanner.setText("`" + rawText + "${");
	        break;
	      case 17 /* TemplateMiddle */:
	        rawTextScanner.setText("}" + rawText + "${");
	        break;
	      case 18 /* TemplateTail */:
	        rawTextScanner.setText("}" + rawText + "`");
	        break;
	    }
	    let token = rawTextScanner.scan();
	    if (token === 20 /* CloseBraceToken */) {
	      token = rawTextScanner.reScanTemplateToken(
	        /*isTaggedTemplate*/
	        false
	      );
	    }
	    if (rawTextScanner.isUnterminated()) {
	      rawTextScanner.setText(void 0);
	      return invalidValueSentinel;
	    }
	    let tokenValue;
	    switch (token) {
	      case 15 /* NoSubstitutionTemplateLiteral */:
	      case 16 /* TemplateHead */:
	      case 17 /* TemplateMiddle */:
	      case 18 /* TemplateTail */:
	        tokenValue = rawTextScanner.getTokenValue();
	        break;
	    }
	    if (tokenValue === void 0 || rawTextScanner.scan() !== 1 /* EndOfFileToken */) {
	      rawTextScanner.setText(void 0);
	      return invalidValueSentinel;
	    }
	    rawTextScanner.setText(void 0);
	    return tokenValue;
	  }
	  function propagateNameFlags(node) {
	    return node && isIdentifier(node) ? propagateIdentifierNameFlags(node) : propagateChildFlags(node);
	  }
	  function propagateIdentifierNameFlags(node) {
	    return propagateChildFlags(node) & ~67108864 /* ContainsPossibleTopLevelAwait */;
	  }
	  function propagatePropertyNameFlagsOfChild(node, transformFlags) {
	    return transformFlags | node.transformFlags & 134234112 /* PropertyNamePropagatingFlags */;
	  }
	  function propagateChildFlags(child) {
	    if (!child)
	      return 0 /* None */;
	    const childFlags = child.transformFlags & ~getTransformFlagsSubtreeExclusions(child.kind);
	    return isNamedDeclaration(child) && isPropertyName(child.name) ? propagatePropertyNameFlagsOfChild(child.name, childFlags) : childFlags;
	  }
	  function propagateChildrenFlags(children) {
	    return children ? children.transformFlags : 0 /* None */;
	  }
	  function aggregateChildrenFlags(children) {
	    let subtreeFlags = 0 /* None */;
	    for (const child of children) {
	      subtreeFlags |= propagateChildFlags(child);
	    }
	    children.transformFlags = subtreeFlags;
	  }
	  function getTransformFlagsSubtreeExclusions(kind) {
	    if (kind >= 182 /* FirstTypeNode */ && kind <= 205 /* LastTypeNode */) {
	      return -2 /* TypeExcludes */;
	    }
	    switch (kind) {
	      case 213 /* CallExpression */:
	      case 214 /* NewExpression */:
	      case 209 /* ArrayLiteralExpression */:
	        return -2147450880 /* ArrayLiteralOrCallOrNewExcludes */;
	      case 267 /* ModuleDeclaration */:
	        return -1941676032 /* ModuleExcludes */;
	      case 169 /* Parameter */:
	        return -2147483648 /* ParameterExcludes */;
	      case 219 /* ArrowFunction */:
	        return -2072174592 /* ArrowFunctionExcludes */;
	      case 218 /* FunctionExpression */:
	      case 262 /* FunctionDeclaration */:
	        return -1937940480 /* FunctionExcludes */;
	      case 261 /* VariableDeclarationList */:
	        return -2146893824 /* VariableDeclarationListExcludes */;
	      case 263 /* ClassDeclaration */:
	      case 231 /* ClassExpression */:
	        return -2147344384 /* ClassExcludes */;
	      case 176 /* Constructor */:
	        return -1937948672 /* ConstructorExcludes */;
	      case 172 /* PropertyDeclaration */:
	        return -2013249536 /* PropertyExcludes */;
	      case 174 /* MethodDeclaration */:
	      case 177 /* GetAccessor */:
	      case 178 /* SetAccessor */:
	        return -2005057536 /* MethodOrAccessorExcludes */;
	      case 133 /* AnyKeyword */:
	      case 150 /* NumberKeyword */:
	      case 163 /* BigIntKeyword */:
	      case 146 /* NeverKeyword */:
	      case 154 /* StringKeyword */:
	      case 151 /* ObjectKeyword */:
	      case 136 /* BooleanKeyword */:
	      case 155 /* SymbolKeyword */:
	      case 116 /* VoidKeyword */:
	      case 168 /* TypeParameter */:
	      case 171 /* PropertySignature */:
	      case 173 /* MethodSignature */:
	      case 179 /* CallSignature */:
	      case 180 /* ConstructSignature */:
	      case 181 /* IndexSignature */:
	      case 264 /* InterfaceDeclaration */:
	      case 265 /* TypeAliasDeclaration */:
	        return -2 /* TypeExcludes */;
	      case 210 /* ObjectLiteralExpression */:
	        return -2147278848 /* ObjectLiteralExcludes */;
	      case 299 /* CatchClause */:
	        return -2147418112 /* CatchClauseExcludes */;
	      case 206 /* ObjectBindingPattern */:
	      case 207 /* ArrayBindingPattern */:
	        return -2147450880 /* BindingPatternExcludes */;
	      case 216 /* TypeAssertionExpression */:
	      case 238 /* SatisfiesExpression */:
	      case 234 /* AsExpression */:
	      case 360 /* PartiallyEmittedExpression */:
	      case 217 /* ParenthesizedExpression */:
	      case 108 /* SuperKeyword */:
	        return -2147483648 /* OuterExpressionExcludes */;
	      case 211 /* PropertyAccessExpression */:
	      case 212 /* ElementAccessExpression */:
	        return -2147483648 /* PropertyAccessExcludes */;
	      default:
	        return -2147483648 /* NodeExcludes */;
	    }
	  }
	  function makeSynthetic(node) {
	    node.flags |= 16 /* Synthesized */;
	    return node;
	  }
	  function createUnparsedSourceFile(textOrInputFiles, mapPathOrType, mapTextOrStripInternal) {
	    let stripInternal;
	    let bundleFileInfo;
	    let fileName;
	    let text;
	    let length2;
	    let sourceMapPath;
	    let sourceMapText;
	    let getText;
	    let getSourceMapText;
	    let oldFileOfCurrentEmit;
	    if (!isString(textOrInputFiles)) {
	      Debug.assert(mapPathOrType === "js" || mapPathOrType === "dts");
	      fileName = (mapPathOrType === "js" ? textOrInputFiles.javascriptPath : textOrInputFiles.declarationPath) || "";
	      sourceMapPath = mapPathOrType === "js" ? textOrInputFiles.javascriptMapPath : textOrInputFiles.declarationMapPath;
	      getText = () => mapPathOrType === "js" ? textOrInputFiles.javascriptText : textOrInputFiles.declarationText;
	      getSourceMapText = () => mapPathOrType === "js" ? textOrInputFiles.javascriptMapText : textOrInputFiles.declarationMapText;
	      length2 = () => getText().length;
	      if (textOrInputFiles.buildInfo && textOrInputFiles.buildInfo.bundle) {
	        Debug.assert(mapTextOrStripInternal === void 0 || typeof mapTextOrStripInternal === "boolean");
	        stripInternal = mapTextOrStripInternal;
	        bundleFileInfo = mapPathOrType === "js" ? textOrInputFiles.buildInfo.bundle.js : textOrInputFiles.buildInfo.bundle.dts;
	        oldFileOfCurrentEmit = textOrInputFiles.oldFileOfCurrentEmit;
	      }
	    } else {
	      fileName = "";
	      text = textOrInputFiles;
	      length2 = textOrInputFiles.length;
	      sourceMapPath = mapPathOrType;
	      sourceMapText = mapTextOrStripInternal;
	    }
	    const node = oldFileOfCurrentEmit ? parseOldFileOfCurrentEmit(Debug.checkDefined(bundleFileInfo)) : parseUnparsedSourceFile(bundleFileInfo, stripInternal, length2);
	    node.fileName = fileName;
	    node.sourceMapPath = sourceMapPath;
	    node.oldFileOfCurrentEmit = oldFileOfCurrentEmit;
	    if (getText && getSourceMapText) {
	      Object.defineProperty(node, "text", { get: getText });
	      Object.defineProperty(node, "sourceMapText", { get: getSourceMapText });
	    } else {
	      Debug.assert(!oldFileOfCurrentEmit);
	      node.text = text ?? "";
	      node.sourceMapText = sourceMapText;
	    }
	    return node;
	  }
	  function parseUnparsedSourceFile(bundleFileInfo, stripInternal, length2) {
	    let prologues;
	    let helpers;
	    let referencedFiles;
	    let typeReferenceDirectives;
	    let libReferenceDirectives;
	    let prependChildren;
	    let texts;
	    let hasNoDefaultLib;
	    for (const section of bundleFileInfo ? bundleFileInfo.sections : emptyArray) {
	      switch (section.kind) {
	        case "prologue" /* Prologue */:
	          prologues = append(prologues, setTextRange(factory.createUnparsedPrologue(section.data), section));
	          break;
	        case "emitHelpers" /* EmitHelpers */:
	          helpers = append(helpers, getAllUnscopedEmitHelpers().get(section.data));
	          break;
	        case "no-default-lib" /* NoDefaultLib */:
	          hasNoDefaultLib = true;
	          break;
	        case "reference" /* Reference */:
	          referencedFiles = append(referencedFiles, { pos: -1, end: -1, fileName: section.data });
	          break;
	        case "type" /* Type */:
	          typeReferenceDirectives = append(typeReferenceDirectives, { pos: -1, end: -1, fileName: section.data });
	          break;
	        case "type-import" /* TypeResolutionModeImport */:
	          typeReferenceDirectives = append(typeReferenceDirectives, { pos: -1, end: -1, fileName: section.data, resolutionMode: 99 /* ESNext */ });
	          break;
	        case "type-require" /* TypeResolutionModeRequire */:
	          typeReferenceDirectives = append(typeReferenceDirectives, { pos: -1, end: -1, fileName: section.data, resolutionMode: 1 /* CommonJS */ });
	          break;
	        case "lib" /* Lib */:
	          libReferenceDirectives = append(libReferenceDirectives, { pos: -1, end: -1, fileName: section.data });
	          break;
	        case "prepend" /* Prepend */:
	          let prependTexts;
	          for (const text of section.texts) {
	            if (!stripInternal || text.kind !== "internal" /* Internal */) {
	              prependTexts = append(prependTexts, setTextRange(factory.createUnparsedTextLike(text.data, text.kind === "internal" /* Internal */), text));
	            }
	          }
	          prependChildren = addRange(prependChildren, prependTexts);
	          texts = append(texts, factory.createUnparsedPrepend(section.data, prependTexts ?? emptyArray));
	          break;
	        case "internal" /* Internal */:
	          if (stripInternal) {
	            if (!texts)
	              texts = [];
	            break;
	          }
	        case "text" /* Text */:
	          texts = append(texts, setTextRange(factory.createUnparsedTextLike(section.data, section.kind === "internal" /* Internal */), section));
	          break;
	        default:
	          Debug.assertNever(section);
	      }
	    }
	    if (!texts) {
	      const textNode = factory.createUnparsedTextLike(
	        /*data*/
	        void 0,
	        /*internal*/
	        false
	      );
	      setTextRangePosWidth(textNode, 0, typeof length2 === "function" ? length2() : length2);
	      texts = [textNode];
	    }
	    const node = parseNodeFactory.createUnparsedSource(
	      prologues ?? emptyArray,
	      /*syntheticReferences*/
	      void 0,
	      texts
	    );
	    setEachParent(prologues, node);
	    setEachParent(texts, node);
	    setEachParent(prependChildren, node);
	    node.hasNoDefaultLib = hasNoDefaultLib;
	    node.helpers = helpers;
	    node.referencedFiles = referencedFiles || emptyArray;
	    node.typeReferenceDirectives = typeReferenceDirectives;
	    node.libReferenceDirectives = libReferenceDirectives || emptyArray;
	    return node;
	  }
	  function parseOldFileOfCurrentEmit(bundleFileInfo) {
	    let texts;
	    let syntheticReferences;
	    for (const section of bundleFileInfo.sections) {
	      switch (section.kind) {
	        case "internal" /* Internal */:
	        case "text" /* Text */:
	          texts = append(texts, setTextRange(factory.createUnparsedTextLike(section.data, section.kind === "internal" /* Internal */), section));
	          break;
	        case "no-default-lib" /* NoDefaultLib */:
	        case "reference" /* Reference */:
	        case "type" /* Type */:
	        case "type-import" /* TypeResolutionModeImport */:
	        case "type-require" /* TypeResolutionModeRequire */:
	        case "lib" /* Lib */:
	          syntheticReferences = append(syntheticReferences, setTextRange(factory.createUnparsedSyntheticReference(section), section));
	          break;
	        case "prologue" /* Prologue */:
	        case "emitHelpers" /* EmitHelpers */:
	        case "prepend" /* Prepend */:
	          break;
	        default:
	          Debug.assertNever(section);
	      }
	    }
	    const node = factory.createUnparsedSource(emptyArray, syntheticReferences, texts ?? emptyArray);
	    setEachParent(syntheticReferences, node);
	    setEachParent(texts, node);
	    node.helpers = map(bundleFileInfo.sources && bundleFileInfo.sources.helpers, (name) => getAllUnscopedEmitHelpers().get(name));
	    return node;
	  }
	  function createInputFiles(javascriptTextOrReadFileText, declarationTextOrJavascriptPath, javascriptMapPath, javascriptMapTextOrDeclarationPath, declarationMapPath, declarationMapTextOrBuildInfoPath) {
	    return !isString(javascriptTextOrReadFileText) ? createInputFilesWithFilePaths(
	      javascriptTextOrReadFileText,
	      declarationTextOrJavascriptPath,
	      javascriptMapPath,
	      javascriptMapTextOrDeclarationPath,
	      declarationMapPath,
	      declarationMapTextOrBuildInfoPath
	    ) : createInputFilesWithFileTexts(
	      /*javascriptPath*/
	      void 0,
	      javascriptTextOrReadFileText,
	      javascriptMapPath,
	      javascriptMapTextOrDeclarationPath,
	      /*declarationPath*/
	      void 0,
	      declarationTextOrJavascriptPath,
	      declarationMapPath,
	      declarationMapTextOrBuildInfoPath
	    );
	  }
	  function createInputFilesWithFilePaths(readFileText, javascriptPath, javascriptMapPath, declarationPath, declarationMapPath, buildInfoPath, host, options) {
	    const node = parseNodeFactory.createInputFiles();
	    node.javascriptPath = javascriptPath;
	    node.javascriptMapPath = javascriptMapPath;
	    node.declarationPath = declarationPath;
	    node.declarationMapPath = declarationMapPath;
	    node.buildInfoPath = buildInfoPath;
	    const cache = /* @__PURE__ */ new Map();
	    const textGetter = (path) => {
	      if (path === void 0)
	        return void 0;
	      let value = cache.get(path);
	      if (value === void 0) {
	        value = readFileText(path);
	        cache.set(path, value !== void 0 ? value : false);
	      }
	      return value !== false ? value : void 0;
	    };
	    const definedTextGetter = (path) => {
	      const result = textGetter(path);
	      return result !== void 0 ? result : `/* Input file ${path} was missing */\r
`;
	    };
	    let buildInfo;
	    const getAndCacheBuildInfo = () => {
	      if (buildInfo === void 0 && buildInfoPath) {
	        if (host == null ? void 0 : host.getBuildInfo) {
	          buildInfo = host.getBuildInfo(buildInfoPath, options.configFilePath) ?? false;
	        } else {
	          const result = textGetter(buildInfoPath);
	          buildInfo = result !== void 0 ? getBuildInfo(buildInfoPath, result) ?? false : false;
	        }
	      }
	      return buildInfo || void 0;
	    };
	    Object.defineProperties(node, {
	      javascriptText: { get: () => definedTextGetter(javascriptPath) },
	      javascriptMapText: { get: () => textGetter(javascriptMapPath) },
	      // TODO:: if there is inline sourceMap in jsFile, use that
	      declarationText: { get: () => definedTextGetter(Debug.checkDefined(declarationPath)) },
	      declarationMapText: { get: () => textGetter(declarationMapPath) },
	      // TODO:: if there is inline sourceMap in dtsFile, use that
	      buildInfo: { get: getAndCacheBuildInfo }
	    });
	    return node;
	  }
	  function createInputFilesWithFileTexts(javascriptPath, javascriptText, javascriptMapPath, javascriptMapText, declarationPath, declarationText, declarationMapPath, declarationMapText, buildInfoPath, buildInfo, oldFileOfCurrentEmit) {
	    const node = parseNodeFactory.createInputFiles();
	    node.javascriptPath = javascriptPath;
	    node.javascriptText = javascriptText;
	    node.javascriptMapPath = javascriptMapPath;
	    node.javascriptMapText = javascriptMapText;
	    node.declarationPath = declarationPath;
	    node.declarationText = declarationText;
	    node.declarationMapPath = declarationMapPath;
	    node.declarationMapText = declarationMapText;
	    node.buildInfoPath = buildInfoPath;
	    node.buildInfo = buildInfo;
	    node.oldFileOfCurrentEmit = oldFileOfCurrentEmit;
	    return node;
	  }
	  function createSourceMapSource(fileName, text, skipTrivia2) {
	    return new (SourceMapSource2 || (SourceMapSource2 = objectAllocator.getSourceMapSourceConstructor()))(fileName, text, skipTrivia2);
	  }
	  function setOriginalNode(node, original) {
	    if (node.original !== original) {
	      node.original = original;
	      if (original) {
	        const emitNode = original.emitNode;
	        if (emitNode)
	          node.emitNode = mergeEmitNode(emitNode, node.emitNode);
	      }
	    }
	    return node;
	  }
	  function mergeEmitNode(sourceEmitNode, destEmitNode) {
	    const {
	      flags,
	      internalFlags,
	      leadingComments,
	      trailingComments,
	      commentRange,
	      sourceMapRange,
	      tokenSourceMapRanges,
	      constantValue,
	      helpers,
	      startsOnNewLine,
	      snippetElement,
	      classThis,
	      assignedName
	    } = sourceEmitNode;
	    if (!destEmitNode)
	      destEmitNode = {};
	    if (flags) {
	      destEmitNode.flags = flags;
	    }
	    if (internalFlags) {
	      destEmitNode.internalFlags = internalFlags & ~8 /* Immutable */;
	    }
	    if (leadingComments) {
	      destEmitNode.leadingComments = addRange(leadingComments.slice(), destEmitNode.leadingComments);
	    }
	    if (trailingComments) {
	      destEmitNode.trailingComments = addRange(trailingComments.slice(), destEmitNode.trailingComments);
	    }
	    if (commentRange) {
	      destEmitNode.commentRange = commentRange;
	    }
	    if (sourceMapRange) {
	      destEmitNode.sourceMapRange = sourceMapRange;
	    }
	    if (tokenSourceMapRanges) {
	      destEmitNode.tokenSourceMapRanges = mergeTokenSourceMapRanges(tokenSourceMapRanges, destEmitNode.tokenSourceMapRanges);
	    }
	    if (constantValue !== void 0) {
	      destEmitNode.constantValue = constantValue;
	    }
	    if (helpers) {
	      for (const helper of helpers) {
	        destEmitNode.helpers = appendIfUnique(destEmitNode.helpers, helper);
	      }
	    }
	    if (startsOnNewLine !== void 0) {
	      destEmitNode.startsOnNewLine = startsOnNewLine;
	    }
	    if (snippetElement !== void 0) {
	      destEmitNode.snippetElement = snippetElement;
	    }
	    if (classThis) {
	      destEmitNode.classThis = classThis;
	    }
	    if (assignedName) {
	      destEmitNode.assignedName = assignedName;
	    }
	    return destEmitNode;
	  }
	  function mergeTokenSourceMapRanges(sourceRanges, destRanges) {
	    if (!destRanges)
	      destRanges = [];
	    for (const key in sourceRanges) {
	      destRanges[key] = sourceRanges[key];
	    }
	    return destRanges;
	  }
	  var nextAutoGenerateId, NodeFactoryFlags, nodeFactoryPatchers, rawTextScanner, invalidValueSentinel, baseFactory, syntheticFactory, factory, SourceMapSource2;
	  var init_nodeFactory = __esm({
	    "src/compiler/factory/nodeFactory.ts"() {
	      init_ts2();
	      nextAutoGenerateId = 0;
	      NodeFactoryFlags = /* @__PURE__ */ ((NodeFactoryFlags2) => {
	        NodeFactoryFlags2[NodeFactoryFlags2["None"] = 0] = "None";
	        NodeFactoryFlags2[NodeFactoryFlags2["NoParenthesizerRules"] = 1] = "NoParenthesizerRules";
	        NodeFactoryFlags2[NodeFactoryFlags2["NoNodeConverters"] = 2] = "NoNodeConverters";
	        NodeFactoryFlags2[NodeFactoryFlags2["NoIndentationOnFreshPropertyAccess"] = 4] = "NoIndentationOnFreshPropertyAccess";
	        NodeFactoryFlags2[NodeFactoryFlags2["NoOriginalNode"] = 8] = "NoOriginalNode";
	        return NodeFactoryFlags2;
	      })(NodeFactoryFlags || {});
	      nodeFactoryPatchers = [];
	      invalidValueSentinel = {};
	      baseFactory = createBaseNodeFactory();
	      syntheticFactory = {
	        createBaseSourceFileNode: (kind) => makeSynthetic(baseFactory.createBaseSourceFileNode(kind)),
	        createBaseIdentifierNode: (kind) => makeSynthetic(baseFactory.createBaseIdentifierNode(kind)),
	        createBasePrivateIdentifierNode: (kind) => makeSynthetic(baseFactory.createBasePrivateIdentifierNode(kind)),
	        createBaseTokenNode: (kind) => makeSynthetic(baseFactory.createBaseTokenNode(kind)),
	        createBaseNode: (kind) => makeSynthetic(baseFactory.createBaseNode(kind))
	      };
	      factory = createNodeFactory(4 /* NoIndentationOnFreshPropertyAccess */, syntheticFactory);
	    }
	  });

	  // src/compiler/factory/emitNode.ts
	  function getOrCreateEmitNode(node) {
	    if (!node.emitNode) {
	      if (isParseTreeNode(node)) {
	        if (node.kind === 312 /* SourceFile */) {
	          return node.emitNode = { annotatedNodes: [node] };
	        }
	        const sourceFile = getSourceFileOfNode(getParseTreeNode(getSourceFileOfNode(node))) ?? Debug.fail("Could not determine parsed source file.");
	        getOrCreateEmitNode(sourceFile).annotatedNodes.push(node);
	      }
	      node.emitNode = {};
	    } else {
	      Debug.assert(!(node.emitNode.internalFlags & 8 /* Immutable */), "Invalid attempt to mutate an immutable node.");
	    }
	    return node.emitNode;
	  }
	  function disposeEmitNodes(sourceFile) {
	    var _a, _b;
	    const annotatedNodes = (_b = (_a = getSourceFileOfNode(getParseTreeNode(sourceFile))) == null ? void 0 : _a.emitNode) == null ? void 0 : _b.annotatedNodes;
	    if (annotatedNodes) {
	      for (const node of annotatedNodes) {
	        node.emitNode = void 0;
	      }
	    }
	  }
	  function removeAllComments(node) {
	    const emitNode = getOrCreateEmitNode(node);
	    emitNode.flags |= 3072 /* NoComments */;
	    emitNode.leadingComments = void 0;
	    emitNode.trailingComments = void 0;
	    return node;
	  }
	  function setEmitFlags(node, emitFlags) {
	    getOrCreateEmitNode(node).flags = emitFlags;
	    return node;
	  }
	  function addEmitFlags(node, emitFlags) {
	    const emitNode = getOrCreateEmitNode(node);
	    emitNode.flags = emitNode.flags | emitFlags;
	    return node;
	  }
	  function setInternalEmitFlags(node, emitFlags) {
	    getOrCreateEmitNode(node).internalFlags = emitFlags;
	    return node;
	  }
	  function addInternalEmitFlags(node, emitFlags) {
	    const emitNode = getOrCreateEmitNode(node);
	    emitNode.internalFlags = emitNode.internalFlags | emitFlags;
	    return node;
	  }
	  function getSourceMapRange(node) {
	    var _a;
	    return ((_a = node.emitNode) == null ? void 0 : _a.sourceMapRange) ?? node;
	  }
	  function setSourceMapRange(node, range) {
	    getOrCreateEmitNode(node).sourceMapRange = range;
	    return node;
	  }
	  function getTokenSourceMapRange(node, token) {
	    var _a, _b;
	    return (_b = (_a = node.emitNode) == null ? void 0 : _a.tokenSourceMapRanges) == null ? void 0 : _b[token];
	  }
	  function setTokenSourceMapRange(node, token, range) {
	    const emitNode = getOrCreateEmitNode(node);
	    const tokenSourceMapRanges = emitNode.tokenSourceMapRanges ?? (emitNode.tokenSourceMapRanges = []);
	    tokenSourceMapRanges[token] = range;
	    return node;
	  }
	  function getStartsOnNewLine(node) {
	    var _a;
	    return (_a = node.emitNode) == null ? void 0 : _a.startsOnNewLine;
	  }
	  function setStartsOnNewLine(node, newLine) {
	    getOrCreateEmitNode(node).startsOnNewLine = newLine;
	    return node;
	  }
	  function getCommentRange(node) {
	    var _a;
	    return ((_a = node.emitNode) == null ? void 0 : _a.commentRange) ?? node;
	  }
	  function setCommentRange(node, range) {
	    getOrCreateEmitNode(node).commentRange = range;
	    return node;
	  }
	  function getSyntheticLeadingComments(node) {
	    var _a;
	    return (_a = node.emitNode) == null ? void 0 : _a.leadingComments;
	  }
	  function setSyntheticLeadingComments(node, comments) {
	    getOrCreateEmitNode(node).leadingComments = comments;
	    return node;
	  }
	  function addSyntheticLeadingComment(node, kind, text, hasTrailingNewLine) {
	    return setSyntheticLeadingComments(node, append(getSyntheticLeadingComments(node), { kind, pos: -1, end: -1, hasTrailingNewLine, text }));
	  }
	  function getSyntheticTrailingComments(node) {
	    var _a;
	    return (_a = node.emitNode) == null ? void 0 : _a.trailingComments;
	  }
	  function setSyntheticTrailingComments(node, comments) {
	    getOrCreateEmitNode(node).trailingComments = comments;
	    return node;
	  }
	  function addSyntheticTrailingComment(node, kind, text, hasTrailingNewLine) {
	    return setSyntheticTrailingComments(node, append(getSyntheticTrailingComments(node), { kind, pos: -1, end: -1, hasTrailingNewLine, text }));
	  }
	  function moveSyntheticComments(node, original) {
	    setSyntheticLeadingComments(node, getSyntheticLeadingComments(original));
	    setSyntheticTrailingComments(node, getSyntheticTrailingComments(original));
	    const emit = getOrCreateEmitNode(original);
	    emit.leadingComments = void 0;
	    emit.trailingComments = void 0;
	    return node;
	  }
	  function getConstantValue(node) {
	    var _a;
	    return (_a = node.emitNode) == null ? void 0 : _a.constantValue;
	  }
	  function setConstantValue(node, value) {
	    const emitNode = getOrCreateEmitNode(node);
	    emitNode.constantValue = value;
	    return node;
	  }
	  function addEmitHelper(node, helper) {
	    const emitNode = getOrCreateEmitNode(node);
	    emitNode.helpers = append(emitNode.helpers, helper);
	    return node;
	  }
	  function addEmitHelpers(node, helpers) {
	    if (some(helpers)) {
	      const emitNode = getOrCreateEmitNode(node);
	      for (const helper of helpers) {
	        emitNode.helpers = appendIfUnique(emitNode.helpers, helper);
	      }
	    }
	    return node;
	  }
	  function removeEmitHelper(node, helper) {
	    var _a;
	    const helpers = (_a = node.emitNode) == null ? void 0 : _a.helpers;
	    if (helpers) {
	      return orderedRemoveItem(helpers, helper);
	    }
	    return false;
	  }
	  function getEmitHelpers(node) {
	    var _a;
	    return (_a = node.emitNode) == null ? void 0 : _a.helpers;
	  }
	  function moveEmitHelpers(source, target, predicate) {
	    const sourceEmitNode = source.emitNode;
	    const sourceEmitHelpers = sourceEmitNode && sourceEmitNode.helpers;
	    if (!some(sourceEmitHelpers))
	      return;
	    const targetEmitNode = getOrCreateEmitNode(target);
	    let helpersRemoved = 0;
	    for (let i = 0; i < sourceEmitHelpers.length; i++) {
	      const helper = sourceEmitHelpers[i];
	      if (predicate(helper)) {
	        helpersRemoved++;
	        targetEmitNode.helpers = appendIfUnique(targetEmitNode.helpers, helper);
	      } else if (helpersRemoved > 0) {
	        sourceEmitHelpers[i - helpersRemoved] = helper;
	      }
	    }
	    if (helpersRemoved > 0) {
	      sourceEmitHelpers.length -= helpersRemoved;
	    }
	  }
	  function getSnippetElement(node) {
	    var _a;
	    return (_a = node.emitNode) == null ? void 0 : _a.snippetElement;
	  }
	  function setSnippetElement(node, snippet) {
	    const emitNode = getOrCreateEmitNode(node);
	    emitNode.snippetElement = snippet;
	    return node;
	  }
	  function ignoreSourceNewlines(node) {
	    getOrCreateEmitNode(node).internalFlags |= 4 /* IgnoreSourceNewlines */;
	    return node;
	  }
	  function setTypeNode(node, type) {
	    const emitNode = getOrCreateEmitNode(node);
	    emitNode.typeNode = type;
	    return node;
	  }
	  function getTypeNode(node) {
	    var _a;
	    return (_a = node.emitNode) == null ? void 0 : _a.typeNode;
	  }
	  function setIdentifierTypeArguments(node, typeArguments) {
	    getOrCreateEmitNode(node).identifierTypeArguments = typeArguments;
	    return node;
	  }
	  function getIdentifierTypeArguments(node) {
	    var _a;
	    return (_a = node.emitNode) == null ? void 0 : _a.identifierTypeArguments;
	  }
	  function setIdentifierAutoGenerate(node, autoGenerate) {
	    getOrCreateEmitNode(node).autoGenerate = autoGenerate;
	    return node;
	  }
	  function getIdentifierAutoGenerate(node) {
	    var _a;
	    return (_a = node.emitNode) == null ? void 0 : _a.autoGenerate;
	  }
	  function setIdentifierGeneratedImportReference(node, value) {
	    getOrCreateEmitNode(node).generatedImportReference = value;
	    return node;
	  }
	  function getIdentifierGeneratedImportReference(node) {
	    var _a;
	    return (_a = node.emitNode) == null ? void 0 : _a.generatedImportReference;
	  }
	  var init_emitNode = __esm({
	    "src/compiler/factory/emitNode.ts"() {
	      init_ts2();
	    }
	  });

	  // src/compiler/factory/emitHelpers.ts
	  function createEmitHelperFactory(context) {
	    const factory2 = context.factory;
	    const immutableTrue = memoize(() => setInternalEmitFlags(factory2.createTrue(), 8 /* Immutable */));
	    const immutableFalse = memoize(() => setInternalEmitFlags(factory2.createFalse(), 8 /* Immutable */));
	    return {
	      getUnscopedHelperName,
	      // TypeScript Helpers
	      createDecorateHelper,
	      createMetadataHelper,
	      createParamHelper,
	      // ES Decorators Helpers
	      createESDecorateHelper,
	      createRunInitializersHelper,
	      // ES2018 Helpers
	      createAssignHelper,
	      createAwaitHelper,
	      createAsyncGeneratorHelper,
	      createAsyncDelegatorHelper,
	      createAsyncValuesHelper,
	      // ES2018 Destructuring Helpers
	      createRestHelper,
	      // ES2017 Helpers
	      createAwaiterHelper,
	      // ES2015 Helpers
	      createExtendsHelper,
	      createTemplateObjectHelper,
	      createSpreadArrayHelper,
	      createPropKeyHelper,
	      createSetFunctionNameHelper,
	      // ES2015 Destructuring Helpers
	      createValuesHelper,
	      createReadHelper,
	      // ES2015 Generator Helpers
	      createGeneratorHelper,
	      // ES Module Helpers
	      createCreateBindingHelper,
	      createImportStarHelper,
	      createImportStarCallbackHelper,
	      createImportDefaultHelper,
	      createExportStarHelper,
	      // Class Fields Helpers
	      createClassPrivateFieldGetHelper,
	      createClassPrivateFieldSetHelper,
	      createClassPrivateFieldInHelper,
	      // 'using' helpers
	      createAddDisposableResourceHelper,
	      createDisposeResourcesHelper
	    };
	    function getUnscopedHelperName(name) {
	      return setEmitFlags(factory2.createIdentifier(name), 8192 /* HelperName */ | 4 /* AdviseOnEmitNode */);
	    }
	    function createDecorateHelper(decoratorExpressions, target, memberName, descriptor) {
	      context.requestEmitHelper(decorateHelper);
	      const argumentsArray = [];
	      argumentsArray.push(factory2.createArrayLiteralExpression(
	        decoratorExpressions,
	        /*multiLine*/
	        true
	      ));
	      argumentsArray.push(target);
	      if (memberName) {
	        argumentsArray.push(memberName);
	        if (descriptor) {
	          argumentsArray.push(descriptor);
	        }
	      }
	      return factory2.createCallExpression(
	        getUnscopedHelperName("__decorate"),
	        /*typeArguments*/
	        void 0,
	        argumentsArray
	      );
	    }
	    function createMetadataHelper(metadataKey, metadataValue) {
	      context.requestEmitHelper(metadataHelper);
	      return factory2.createCallExpression(
	        getUnscopedHelperName("__metadata"),
	        /*typeArguments*/
	        void 0,
	        [
	          factory2.createStringLiteral(metadataKey),
	          metadataValue
	        ]
	      );
	    }
	    function createParamHelper(expression, parameterOffset, location) {
	      context.requestEmitHelper(paramHelper);
	      return setTextRange(
	        factory2.createCallExpression(
	          getUnscopedHelperName("__param"),
	          /*typeArguments*/
	          void 0,
	          [
	            factory2.createNumericLiteral(parameterOffset + ""),
	            expression
	          ]
	        ),
	        location
	      );
	    }
	    function createESDecorateClassContextObject(contextIn) {
	      const properties = [
	        factory2.createPropertyAssignment(factory2.createIdentifier("kind"), factory2.createStringLiteral("class")),
	        factory2.createPropertyAssignment(factory2.createIdentifier("name"), contextIn.name),
	        factory2.createPropertyAssignment(factory2.createIdentifier("metadata"), contextIn.metadata)
	      ];
	      return factory2.createObjectLiteralExpression(properties);
	    }
	    function createESDecorateClassElementAccessGetMethod(elementName) {
	      const accessor = elementName.computed ? factory2.createElementAccessExpression(factory2.createIdentifier("obj"), elementName.name) : factory2.createPropertyAccessExpression(factory2.createIdentifier("obj"), elementName.name);
	      return factory2.createPropertyAssignment(
	        "get",
	        factory2.createArrowFunction(
	          /*modifiers*/
	          void 0,
	          /*typeParameters*/
	          void 0,
	          [factory2.createParameterDeclaration(
	            /*modifiers*/
	            void 0,
	            /*dotDotDotToken*/
	            void 0,
	            factory2.createIdentifier("obj")
	          )],
	          /*type*/
	          void 0,
	          /*equalsGreaterThanToken*/
	          void 0,
	          accessor
	        )
	      );
	    }
	    function createESDecorateClassElementAccessSetMethod(elementName) {
	      const accessor = elementName.computed ? factory2.createElementAccessExpression(factory2.createIdentifier("obj"), elementName.name) : factory2.createPropertyAccessExpression(factory2.createIdentifier("obj"), elementName.name);
	      return factory2.createPropertyAssignment(
	        "set",
	        factory2.createArrowFunction(
	          /*modifiers*/
	          void 0,
	          /*typeParameters*/
	          void 0,
	          [
	            factory2.createParameterDeclaration(
	              /*modifiers*/
	              void 0,
	              /*dotDotDotToken*/
	              void 0,
	              factory2.createIdentifier("obj")
	            ),
	            factory2.createParameterDeclaration(
	              /*modifiers*/
	              void 0,
	              /*dotDotDotToken*/
	              void 0,
	              factory2.createIdentifier("value")
	            )
	          ],
	          /*type*/
	          void 0,
	          /*equalsGreaterThanToken*/
	          void 0,
	          factory2.createBlock([
	            factory2.createExpressionStatement(
	              factory2.createAssignment(
	                accessor,
	                factory2.createIdentifier("value")
	              )
	            )
	          ])
	        )
	      );
	    }
	    function createESDecorateClassElementAccessHasMethod(elementName) {
	      const propertyName = elementName.computed ? elementName.name : isIdentifier(elementName.name) ? factory2.createStringLiteralFromNode(elementName.name) : elementName.name;
	      return factory2.createPropertyAssignment(
	        "has",
	        factory2.createArrowFunction(
	          /*modifiers*/
	          void 0,
	          /*typeParameters*/
	          void 0,
	          [factory2.createParameterDeclaration(
	            /*modifiers*/
	            void 0,
	            /*dotDotDotToken*/
	            void 0,
	            factory2.createIdentifier("obj")
	          )],
	          /*type*/
	          void 0,
	          /*equalsGreaterThanToken*/
	          void 0,
	          factory2.createBinaryExpression(
	            propertyName,
	            103 /* InKeyword */,
	            factory2.createIdentifier("obj")
	          )
	        )
	      );
	    }
	    function createESDecorateClassElementAccessObject(name, access) {
	      const properties = [];
	      properties.push(createESDecorateClassElementAccessHasMethod(name));
	      if (access.get)
	        properties.push(createESDecorateClassElementAccessGetMethod(name));
	      if (access.set)
	        properties.push(createESDecorateClassElementAccessSetMethod(name));
	      return factory2.createObjectLiteralExpression(properties);
	    }
	    function createESDecorateClassElementContextObject(contextIn) {
	      const properties = [
	        factory2.createPropertyAssignment(factory2.createIdentifier("kind"), factory2.createStringLiteral(contextIn.kind)),
	        factory2.createPropertyAssignment(factory2.createIdentifier("name"), contextIn.name.computed ? contextIn.name.name : factory2.createStringLiteralFromNode(contextIn.name.name)),
	        factory2.createPropertyAssignment(factory2.createIdentifier("static"), contextIn.static ? factory2.createTrue() : factory2.createFalse()),
	        factory2.createPropertyAssignment(factory2.createIdentifier("private"), contextIn.private ? factory2.createTrue() : factory2.createFalse()),
	        factory2.createPropertyAssignment(factory2.createIdentifier("access"), createESDecorateClassElementAccessObject(contextIn.name, contextIn.access)),
	        factory2.createPropertyAssignment(factory2.createIdentifier("metadata"), contextIn.metadata)
	      ];
	      return factory2.createObjectLiteralExpression(properties);
	    }
	    function createESDecorateContextObject(contextIn) {
	      return contextIn.kind === "class" ? createESDecorateClassContextObject(contextIn) : createESDecorateClassElementContextObject(contextIn);
	    }
	    function createESDecorateHelper(ctor, descriptorIn, decorators, contextIn, initializers, extraInitializers) {
	      context.requestEmitHelper(esDecorateHelper);
	      return factory2.createCallExpression(
	        getUnscopedHelperName("__esDecorate"),
	        /*typeArguments*/
	        void 0,
	        [
	          ctor ?? factory2.createNull(),
	          descriptorIn ?? factory2.createNull(),
	          decorators,
	          createESDecorateContextObject(contextIn),
	          initializers,
	          extraInitializers
	        ]
	      );
	    }
	    function createRunInitializersHelper(thisArg, initializers, value) {
	      context.requestEmitHelper(runInitializersHelper);
	      return factory2.createCallExpression(
	        getUnscopedHelperName("__runInitializers"),
	        /*typeArguments*/
	        void 0,
	        value ? [thisArg, initializers, value] : [thisArg, initializers]
	      );
	    }
	    function createAssignHelper(attributesSegments) {
	      if (getEmitScriptTarget(context.getCompilerOptions()) >= 2 /* ES2015 */) {
	        return factory2.createCallExpression(
	          factory2.createPropertyAccessExpression(factory2.createIdentifier("Object"), "assign"),
	          /*typeArguments*/
	          void 0,
	          attributesSegments
	        );
	      }
	      context.requestEmitHelper(assignHelper);
	      return factory2.createCallExpression(
	        getUnscopedHelperName("__assign"),
	        /*typeArguments*/
	        void 0,
	        attributesSegments
	      );
	    }
	    function createAwaitHelper(expression) {
	      context.requestEmitHelper(awaitHelper);
	      return factory2.createCallExpression(
	        getUnscopedHelperName("__await"),
	        /*typeArguments*/
	        void 0,
	        [expression]
	      );
	    }
	    function createAsyncGeneratorHelper(generatorFunc, hasLexicalThis) {
	      context.requestEmitHelper(awaitHelper);
	      context.requestEmitHelper(asyncGeneratorHelper);
	      (generatorFunc.emitNode || (generatorFunc.emitNode = {})).flags |= 524288 /* AsyncFunctionBody */ | 1048576 /* ReuseTempVariableScope */;
	      return factory2.createCallExpression(
	        getUnscopedHelperName("__asyncGenerator"),
	        /*typeArguments*/
	        void 0,
	        [
	          hasLexicalThis ? factory2.createThis() : factory2.createVoidZero(),
	          factory2.createIdentifier("arguments"),
	          generatorFunc
	        ]
	      );
	    }
	    function createAsyncDelegatorHelper(expression) {
	      context.requestEmitHelper(awaitHelper);
	      context.requestEmitHelper(asyncDelegator);
	      return factory2.createCallExpression(
	        getUnscopedHelperName("__asyncDelegator"),
	        /*typeArguments*/
	        void 0,
	        [expression]
	      );
	    }
	    function createAsyncValuesHelper(expression) {
	      context.requestEmitHelper(asyncValues);
	      return factory2.createCallExpression(
	        getUnscopedHelperName("__asyncValues"),
	        /*typeArguments*/
	        void 0,
	        [expression]
	      );
	    }
	    function createRestHelper(value, elements, computedTempVariables, location) {
	      context.requestEmitHelper(restHelper);
	      const propertyNames = [];
	      let computedTempVariableOffset = 0;
	      for (let i = 0; i < elements.length - 1; i++) {
	        const propertyName = getPropertyNameOfBindingOrAssignmentElement(elements[i]);
	        if (propertyName) {
	          if (isComputedPropertyName(propertyName)) {
	            Debug.assertIsDefined(computedTempVariables, "Encountered computed property name but 'computedTempVariables' argument was not provided.");
	            const temp = computedTempVariables[computedTempVariableOffset];
	            computedTempVariableOffset++;
	            propertyNames.push(
	              factory2.createConditionalExpression(
	                factory2.createTypeCheck(temp, "symbol"),
	                /*questionToken*/
	                void 0,
	                temp,
	                /*colonToken*/
	                void 0,
	                factory2.createAdd(temp, factory2.createStringLiteral(""))
	              )
	            );
	          } else {
	            propertyNames.push(factory2.createStringLiteralFromNode(propertyName));
	          }
	        }
	      }
	      return factory2.createCallExpression(
	        getUnscopedHelperName("__rest"),
	        /*typeArguments*/
	        void 0,
	        [
	          value,
	          setTextRange(
	            factory2.createArrayLiteralExpression(propertyNames),
	            location
	          )
	        ]
	      );
	    }
	    function createAwaiterHelper(hasLexicalThis, argumentsExpression, promiseConstructor, parameters, body) {
	      context.requestEmitHelper(awaiterHelper);
	      const generatorFunc = factory2.createFunctionExpression(
	        /*modifiers*/
	        void 0,
	        factory2.createToken(42 /* AsteriskToken */),
	        /*name*/
	        void 0,
	        /*typeParameters*/
	        void 0,
	        parameters ?? [],
	        /*type*/
	        void 0,
	        body
	      );
	      (generatorFunc.emitNode || (generatorFunc.emitNode = {})).flags |= 524288 /* AsyncFunctionBody */ | 1048576 /* ReuseTempVariableScope */;
	      return factory2.createCallExpression(
	        getUnscopedHelperName("__awaiter"),
	        /*typeArguments*/
	        void 0,
	        [
	          hasLexicalThis ? factory2.createThis() : factory2.createVoidZero(),
	          argumentsExpression ?? factory2.createVoidZero(),
	          promiseConstructor ? createExpressionFromEntityName(factory2, promiseConstructor) : factory2.createVoidZero(),
	          generatorFunc
	        ]
	      );
	    }
	    function createExtendsHelper(name) {
	      context.requestEmitHelper(extendsHelper);
	      return factory2.createCallExpression(
	        getUnscopedHelperName("__extends"),
	        /*typeArguments*/
	        void 0,
	        [name, factory2.createUniqueName("_super", 16 /* Optimistic */ | 32 /* FileLevel */)]
	      );
	    }
	    function createTemplateObjectHelper(cooked, raw) {
	      context.requestEmitHelper(templateObjectHelper);
	      return factory2.createCallExpression(
	        getUnscopedHelperName("__makeTemplateObject"),
	        /*typeArguments*/
	        void 0,
	        [cooked, raw]
	      );
	    }
	    function createSpreadArrayHelper(to, from, packFrom) {
	      context.requestEmitHelper(spreadArrayHelper);
	      return factory2.createCallExpression(
	        getUnscopedHelperName("__spreadArray"),
	        /*typeArguments*/
	        void 0,
	        [to, from, packFrom ? immutableTrue() : immutableFalse()]
	      );
	    }
	    function createPropKeyHelper(expr) {
	      context.requestEmitHelper(propKeyHelper);
	      return factory2.createCallExpression(
	        getUnscopedHelperName("__propKey"),
	        /*typeArguments*/
	        void 0,
	        [expr]
	      );
	    }
	    function createSetFunctionNameHelper(f, name, prefix) {
	      context.requestEmitHelper(setFunctionNameHelper);
	      return context.factory.createCallExpression(
	        getUnscopedHelperName("__setFunctionName"),
	        /*typeArguments*/
	        void 0,
	        prefix ? [f, name, context.factory.createStringLiteral(prefix)] : [f, name]
	      );
	    }
	    function createValuesHelper(expression) {
	      context.requestEmitHelper(valuesHelper);
	      return factory2.createCallExpression(
	        getUnscopedHelperName("__values"),
	        /*typeArguments*/
	        void 0,
	        [expression]
	      );
	    }
	    function createReadHelper(iteratorRecord, count) {
	      context.requestEmitHelper(readHelper);
	      return factory2.createCallExpression(
	        getUnscopedHelperName("__read"),
	        /*typeArguments*/
	        void 0,
	        count !== void 0 ? [iteratorRecord, factory2.createNumericLiteral(count + "")] : [iteratorRecord]
	      );
	    }
	    function createGeneratorHelper(body) {
	      context.requestEmitHelper(generatorHelper);
	      return factory2.createCallExpression(
	        getUnscopedHelperName("__generator"),
	        /*typeArguments*/
	        void 0,
	        [factory2.createThis(), body]
	      );
	    }
	    function createCreateBindingHelper(module2, inputName, outputName) {
	      context.requestEmitHelper(createBindingHelper);
	      return factory2.createCallExpression(
	        getUnscopedHelperName("__createBinding"),
	        /*typeArguments*/
	        void 0,
	        [factory2.createIdentifier("exports"), module2, inputName, ...outputName ? [outputName] : []]
	      );
	    }
	    function createImportStarHelper(expression) {
	      context.requestEmitHelper(importStarHelper);
	      return factory2.createCallExpression(
	        getUnscopedHelperName("__importStar"),
	        /*typeArguments*/
	        void 0,
	        [expression]
	      );
	    }
	    function createImportStarCallbackHelper() {
	      context.requestEmitHelper(importStarHelper);
	      return getUnscopedHelperName("__importStar");
	    }
	    function createImportDefaultHelper(expression) {
	      context.requestEmitHelper(importDefaultHelper);
	      return factory2.createCallExpression(
	        getUnscopedHelperName("__importDefault"),
	        /*typeArguments*/
	        void 0,
	        [expression]
	      );
	    }
	    function createExportStarHelper(moduleExpression, exportsExpression = factory2.createIdentifier("exports")) {
	      context.requestEmitHelper(exportStarHelper);
	      context.requestEmitHelper(createBindingHelper);
	      return factory2.createCallExpression(
	        getUnscopedHelperName("__exportStar"),
	        /*typeArguments*/
	        void 0,
	        [moduleExpression, exportsExpression]
	      );
	    }
	    function createClassPrivateFieldGetHelper(receiver, state, kind, f) {
	      context.requestEmitHelper(classPrivateFieldGetHelper);
	      let args;
	      if (!f) {
	        args = [receiver, state, factory2.createStringLiteral(kind)];
	      } else {
	        args = [receiver, state, factory2.createStringLiteral(kind), f];
	      }
	      return factory2.createCallExpression(
	        getUnscopedHelperName("__classPrivateFieldGet"),
	        /*typeArguments*/
	        void 0,
	        args
	      );
	    }
	    function createClassPrivateFieldSetHelper(receiver, state, value, kind, f) {
	      context.requestEmitHelper(classPrivateFieldSetHelper);
	      let args;
	      if (!f) {
	        args = [receiver, state, value, factory2.createStringLiteral(kind)];
	      } else {
	        args = [receiver, state, value, factory2.createStringLiteral(kind), f];
	      }
	      return factory2.createCallExpression(
	        getUnscopedHelperName("__classPrivateFieldSet"),
	        /*typeArguments*/
	        void 0,
	        args
	      );
	    }
	    function createClassPrivateFieldInHelper(state, receiver) {
	      context.requestEmitHelper(classPrivateFieldInHelper);
	      return factory2.createCallExpression(
	        getUnscopedHelperName("__classPrivateFieldIn"),
	        /*typeArguments*/
	        void 0,
	        [state, receiver]
	      );
	    }
	    function createAddDisposableResourceHelper(envBinding, value, async) {
	      context.requestEmitHelper(addDisposableResourceHelper);
	      return factory2.createCallExpression(
	        getUnscopedHelperName("__addDisposableResource"),
	        /*typeArguments*/
	        void 0,
	        [envBinding, value, async ? factory2.createTrue() : factory2.createFalse()]
	      );
	    }
	    function createDisposeResourcesHelper(envBinding) {
	      context.requestEmitHelper(disposeResourcesHelper);
	      return factory2.createCallExpression(
	        getUnscopedHelperName("__disposeResources"),
	        /*typeArguments*/
	        void 0,
	        [envBinding]
	      );
	    }
	  }
	  function compareEmitHelpers(x, y) {
	    if (x === y)
	      return 0 /* EqualTo */;
	    if (x.priority === y.priority)
	      return 0 /* EqualTo */;
	    if (x.priority === void 0)
	      return 1 /* GreaterThan */;
	    if (y.priority === void 0)
	      return -1 /* LessThan */;
	    return compareValues(x.priority, y.priority);
	  }
	  function helperString(input, ...args) {
	    return (uniqueName) => {
	      let result = "";
	      for (let i = 0; i < args.length; i++) {
	        result += input[i];
	        result += uniqueName(args[i]);
	      }
	      result += input[input.length - 1];
	      return result;
	    };
	  }
	  function getAllUnscopedEmitHelpers() {
	    return allUnscopedEmitHelpers || (allUnscopedEmitHelpers = arrayToMap([
	      decorateHelper,
	      metadataHelper,
	      paramHelper,
	      esDecorateHelper,
	      runInitializersHelper,
	      assignHelper,
	      awaitHelper,
	      asyncGeneratorHelper,
	      asyncDelegator,
	      asyncValues,
	      restHelper,
	      awaiterHelper,
	      extendsHelper,
	      templateObjectHelper,
	      spreadArrayHelper,
	      valuesHelper,
	      readHelper,
	      propKeyHelper,
	      setFunctionNameHelper,
	      generatorHelper,
	      importStarHelper,
	      importDefaultHelper,
	      exportStarHelper,
	      classPrivateFieldGetHelper,
	      classPrivateFieldSetHelper,
	      classPrivateFieldInHelper,
	      createBindingHelper,
	      setModuleDefaultHelper,
	      addDisposableResourceHelper,
	      disposeResourcesHelper
	    ], (helper) => helper.name));
	  }
	  function isCallToHelper(firstSegment, helperName) {
	    return isCallExpression(firstSegment) && isIdentifier(firstSegment.expression) && (getEmitFlags(firstSegment.expression) & 8192 /* HelperName */) !== 0 && firstSegment.expression.escapedText === helperName;
	  }
	  var PrivateIdentifierKind, decorateHelper, metadataHelper, paramHelper, esDecorateHelper, runInitializersHelper, assignHelper, awaitHelper, asyncGeneratorHelper, asyncDelegator, asyncValues, restHelper, awaiterHelper, extendsHelper, templateObjectHelper, readHelper, spreadArrayHelper, propKeyHelper, setFunctionNameHelper, valuesHelper, generatorHelper, createBindingHelper, setModuleDefaultHelper, importStarHelper, importDefaultHelper, exportStarHelper, classPrivateFieldGetHelper, classPrivateFieldSetHelper, classPrivateFieldInHelper, addDisposableResourceHelper, disposeResourcesHelper, allUnscopedEmitHelpers, asyncSuperHelper, advancedAsyncSuperHelper;
	  var init_emitHelpers = __esm({
	    "src/compiler/factory/emitHelpers.ts"() {
	      init_ts2();
	      PrivateIdentifierKind = /* @__PURE__ */ ((PrivateIdentifierKind2) => {
	        PrivateIdentifierKind2["Field"] = "f";
	        PrivateIdentifierKind2["Method"] = "m";
	        PrivateIdentifierKind2["Accessor"] = "a";
	        return PrivateIdentifierKind2;
	      })(PrivateIdentifierKind || {});
	      decorateHelper = {
	        name: "typescript:decorate",
	        importName: "__decorate",
	        scoped: false,
	        priority: 2,
	        text: `
            var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
                var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
                if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
                else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
                return c > 3 && r && Object.defineProperty(target, key, r), r;
            };`
	      };
	      metadataHelper = {
	        name: "typescript:metadata",
	        importName: "__metadata",
	        scoped: false,
	        priority: 3,
	        text: `
            var __metadata = (this && this.__metadata) || function (k, v) {
                if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
            };`
	      };
	      paramHelper = {
	        name: "typescript:param",
	        importName: "__param",
	        scoped: false,
	        priority: 4,
	        text: `
            var __param = (this && this.__param) || function (paramIndex, decorator) {
                return function (target, key) { decorator(target, key, paramIndex); }
            };`
	      };
	      esDecorateHelper = {
	        name: "typescript:esDecorate",
	        importName: "__esDecorate",
	        scoped: false,
	        priority: 2,
	        text: `
        var __esDecorate = (this && this.__esDecorate) || function (ctor, descriptorIn, decorators, contextIn, initializers, extraInitializers) {
            function accept(f) { if (f !== void 0 && typeof f !== "function") throw new TypeError("Function expected"); return f; }
            var kind = contextIn.kind, key = kind === "getter" ? "get" : kind === "setter" ? "set" : "value";
            var target = !descriptorIn && ctor ? contextIn["static"] ? ctor : ctor.prototype : null;
            var descriptor = descriptorIn || (target ? Object.getOwnPropertyDescriptor(target, contextIn.name) : {});
            var _, done = false;
            for (var i = decorators.length - 1; i >= 0; i--) {
                var context = {};
                for (var p in contextIn) context[p] = p === "access" ? {} : contextIn[p];
                for (var p in contextIn.access) context.access[p] = contextIn.access[p];
                context.addInitializer = function (f) { if (done) throw new TypeError("Cannot add initializers after decoration has completed"); extraInitializers.push(accept(f || null)); };
                var result = (0, decorators[i])(kind === "accessor" ? { get: descriptor.get, set: descriptor.set } : descriptor[key], context);
                if (kind === "accessor") {
                    if (result === void 0) continue;
                    if (result === null || typeof result !== "object") throw new TypeError("Object expected");
                    if (_ = accept(result.get)) descriptor.get = _;
                    if (_ = accept(result.set)) descriptor.set = _;
                    if (_ = accept(result.init)) initializers.unshift(_);
                }
                else if (_ = accept(result)) {
                    if (kind === "field") initializers.unshift(_);
                    else descriptor[key] = _;
                }
            }
            if (target) Object.defineProperty(target, contextIn.name, descriptor);
            done = true;
        };`
	      };
	      runInitializersHelper = {
	        name: "typescript:runInitializers",
	        importName: "__runInitializers",
	        scoped: false,
	        priority: 2,
	        text: `
        var __runInitializers = (this && this.__runInitializers) || function (thisArg, initializers, value) {
            var useValue = arguments.length > 2;
            for (var i = 0; i < initializers.length; i++) {
                value = useValue ? initializers[i].call(thisArg, value) : initializers[i].call(thisArg);
            }
            return useValue ? value : void 0;
        };`
	      };
	      assignHelper = {
	        name: "typescript:assign",
	        importName: "__assign",
	        scoped: false,
	        priority: 1,
	        text: `
            var __assign = (this && this.__assign) || function () {
                __assign = Object.assign || function(t) {
                    for (var s, i = 1, n = arguments.length; i < n; i++) {
                        s = arguments[i];
                        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                            t[p] = s[p];
                    }
                    return t;
                };
                return __assign.apply(this, arguments);
            };`
	      };
	      awaitHelper = {
	        name: "typescript:await",
	        importName: "__await",
	        scoped: false,
	        text: `
            var __await = (this && this.__await) || function (v) { return this instanceof __await ? (this.v = v, this) : new __await(v); }`
	      };
	      asyncGeneratorHelper = {
	        name: "typescript:asyncGenerator",
	        importName: "__asyncGenerator",
	        scoped: false,
	        dependencies: [awaitHelper],
	        text: `
        var __asyncGenerator = (this && this.__asyncGenerator) || function (thisArg, _arguments, generator) {
            if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
            var g = generator.apply(thisArg, _arguments || []), i, q = [];
            return i = {}, verb("next"), verb("throw"), verb("return", awaitReturn), i[Symbol.asyncIterator] = function () { return this; }, i;
            function awaitReturn(f) { return function (v) { return Promise.resolve(v).then(f, reject); }; }
            function verb(n, f) { if (g[n]) { i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; if (f) i[n] = f(i[n]); } }
            function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
            function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
            function fulfill(value) { resume("next", value); }
            function reject(value) { resume("throw", value); }
            function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
        };`
	      };
	      asyncDelegator = {
	        name: "typescript:asyncDelegator",
	        importName: "__asyncDelegator",
	        scoped: false,
	        dependencies: [awaitHelper],
	        text: `
            var __asyncDelegator = (this && this.__asyncDelegator) || function (o) {
                var i, p;
                return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
                function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: false } : f ? f(v) : v; } : f; }
            };`
	      };
	      asyncValues = {
	        name: "typescript:asyncValues",
	        importName: "__asyncValues",
	        scoped: false,
	        text: `
            var __asyncValues = (this && this.__asyncValues) || function (o) {
                if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
                var m = o[Symbol.asyncIterator], i;
                return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
                function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
                function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
            };`
	      };
	      restHelper = {
	        name: "typescript:rest",
	        importName: "__rest",
	        scoped: false,
	        text: `
            var __rest = (this && this.__rest) || function (s, e) {
                var t = {};
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                    t[p] = s[p];
                if (s != null && typeof Object.getOwnPropertySymbols === "function")
                    for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                        if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                            t[p[i]] = s[p[i]];
                    }
                return t;
            };`
	      };
	      awaiterHelper = {
	        name: "typescript:awaiter",
	        importName: "__awaiter",
	        scoped: false,
	        priority: 5,
	        text: `
            var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
                function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
                return new (P || (P = Promise))(function (resolve, reject) {
                    function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
                    function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
                    function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
                    step((generator = generator.apply(thisArg, _arguments || [])).next());
                });
            };`
	      };
	      extendsHelper = {
	        name: "typescript:extends",
	        importName: "__extends",
	        scoped: false,
	        priority: 0,
	        text: `
            var __extends = (this && this.__extends) || (function () {
                var extendStatics = function (d, b) {
                    extendStatics = Object.setPrototypeOf ||
                        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
                        function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
                    return extendStatics(d, b);
                };

                return function (d, b) {
                    if (typeof b !== "function" && b !== null)
                        throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
                    extendStatics(d, b);
                    function __() { this.constructor = d; }
                    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
                };
            })();`
	      };
	      templateObjectHelper = {
	        name: "typescript:makeTemplateObject",
	        importName: "__makeTemplateObject",
	        scoped: false,
	        priority: 0,
	        text: `
            var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
                if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
                return cooked;
            };`
	      };
	      readHelper = {
	        name: "typescript:read",
	        importName: "__read",
	        scoped: false,
	        text: `
            var __read = (this && this.__read) || function (o, n) {
                var m = typeof Symbol === "function" && o[Symbol.iterator];
                if (!m) return o;
                var i = m.call(o), r, ar = [], e;
                try {
                    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
                }
                catch (error) { e = { error: error }; }
                finally {
                    try {
                        if (r && !r.done && (m = i["return"])) m.call(i);
                    }
                    finally { if (e) throw e.error; }
                }
                return ar;
            };`
	      };
	      spreadArrayHelper = {
	        name: "typescript:spreadArray",
	        importName: "__spreadArray",
	        scoped: false,
	        text: `
            var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
                if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
                    if (ar || !(i in from)) {
                        if (!ar) ar = Array.prototype.slice.call(from, 0, i);
                        ar[i] = from[i];
                    }
                }
                return to.concat(ar || Array.prototype.slice.call(from));
            };`
	      };
	      propKeyHelper = {
	        name: "typescript:propKey",
	        importName: "__propKey",
	        scoped: false,
	        text: `
        var __propKey = (this && this.__propKey) || function (x) {
            return typeof x === "symbol" ? x : "".concat(x);
        };`
	      };
	      setFunctionNameHelper = {
	        name: "typescript:setFunctionName",
	        importName: "__setFunctionName",
	        scoped: false,
	        text: `
        var __setFunctionName = (this && this.__setFunctionName) || function (f, name, prefix) {
            if (typeof name === "symbol") name = name.description ? "[".concat(name.description, "]") : "";
            return Object.defineProperty(f, "name", { configurable: true, value: prefix ? "".concat(prefix, " ", name) : name });
        };`
	      };
	      valuesHelper = {
	        name: "typescript:values",
	        importName: "__values",
	        scoped: false,
	        text: `
            var __values = (this && this.__values) || function(o) {
                var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
                if (m) return m.call(o);
                if (o && typeof o.length === "number") return {
                    next: function () {
                        if (o && i >= o.length) o = void 0;
                        return { value: o && o[i++], done: !o };
                    }
                };
                throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
            };`
	      };
	      generatorHelper = {
	        name: "typescript:generator",
	        importName: "__generator",
	        scoped: false,
	        priority: 6,
	        text: `
            var __generator = (this && this.__generator) || function (thisArg, body) {
                var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
                return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
                function verb(n) { return function (v) { return step([n, v]); }; }
                function step(op) {
                    if (f) throw new TypeError("Generator is already executing.");
                    while (g && (g = 0, op[0] && (_ = 0)), _) try {
                        if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                        if (y = 0, t) op = [op[0] & 2, t.value];
                        switch (op[0]) {
                            case 0: case 1: t = op; break;
                            case 4: _.label++; return { value: op[1], done: false };
                            case 5: _.label++; y = op[1]; op = [0]; continue;
                            case 7: op = _.ops.pop(); _.trys.pop(); continue;
                            default:
                                if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                                if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                                if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                                if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                                if (t[2]) _.ops.pop();
                                _.trys.pop(); continue;
                        }
                        op = body.call(thisArg, _);
                    } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
                    if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
                }
            };`
	      };
	      createBindingHelper = {
	        name: "typescript:commonjscreatebinding",
	        importName: "__createBinding",
	        scoped: false,
	        priority: 1,
	        text: `
            var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
                if (k2 === undefined) k2 = k;
                var desc = Object.getOwnPropertyDescriptor(m, k);
                if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
                  desc = { enumerable: true, get: function() { return m[k]; } };
                }
                Object.defineProperty(o, k2, desc);
            }) : (function(o, m, k, k2) {
                if (k2 === undefined) k2 = k;
                o[k2] = m[k];
            }));`
	      };
	      setModuleDefaultHelper = {
	        name: "typescript:commonjscreatevalue",
	        importName: "__setModuleDefault",
	        scoped: false,
	        priority: 1,
	        text: `
            var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
                Object.defineProperty(o, "default", { enumerable: true, value: v });
            }) : function(o, v) {
                o["default"] = v;
            });`
	      };
	      importStarHelper = {
	        name: "typescript:commonjsimportstar",
	        importName: "__importStar",
	        scoped: false,
	        dependencies: [createBindingHelper, setModuleDefaultHelper],
	        priority: 2,
	        text: `
            var __importStar = (this && this.__importStar) || function (mod) {
                if (mod && mod.__esModule) return mod;
                var result = {};
                if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
                __setModuleDefault(result, mod);
                return result;
            };`
	      };
	      importDefaultHelper = {
	        name: "typescript:commonjsimportdefault",
	        importName: "__importDefault",
	        scoped: false,
	        text: `
            var __importDefault = (this && this.__importDefault) || function (mod) {
                return (mod && mod.__esModule) ? mod : { "default": mod };
            };`
	      };
	      exportStarHelper = {
	        name: "typescript:export-star",
	        importName: "__exportStar",
	        scoped: false,
	        dependencies: [createBindingHelper],
	        priority: 2,
	        text: `
            var __exportStar = (this && this.__exportStar) || function(m, exports) {
                for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
            };`
	      };
	      classPrivateFieldGetHelper = {
	        name: "typescript:classPrivateFieldGet",
	        importName: "__classPrivateFieldGet",
	        scoped: false,
	        text: `
            var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
                if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
                if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
                return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
            };`
	      };
	      classPrivateFieldSetHelper = {
	        name: "typescript:classPrivateFieldSet",
	        importName: "__classPrivateFieldSet",
	        scoped: false,
	        text: `
            var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
                if (kind === "m") throw new TypeError("Private method is not writable");
                if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
                if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
                return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
            };`
	      };
	      classPrivateFieldInHelper = {
	        name: "typescript:classPrivateFieldIn",
	        importName: "__classPrivateFieldIn",
	        scoped: false,
	        text: `
            var __classPrivateFieldIn = (this && this.__classPrivateFieldIn) || function(state, receiver) {
                if (receiver === null || (typeof receiver !== "object" && typeof receiver !== "function")) throw new TypeError("Cannot use 'in' operator on non-object");
                return typeof state === "function" ? receiver === state : state.has(receiver);
            };`
	      };
	      addDisposableResourceHelper = {
	        name: "typescript:addDisposableResource",
	        importName: "__addDisposableResource",
	        scoped: false,
	        text: `
        var __addDisposableResource = (this && this.__addDisposableResource) || function (env, value, async) {
            if (value !== null && value !== void 0) {
                if (typeof value !== "object" && typeof value !== "function") throw new TypeError("Object expected.");
                var dispose;
                if (async) {
                    if (!Symbol.asyncDispose) throw new TypeError("Symbol.asyncDispose is not defined.");
                    dispose = value[Symbol.asyncDispose];
                }
                if (dispose === void 0) {
                    if (!Symbol.dispose) throw new TypeError("Symbol.dispose is not defined.");
                    dispose = value[Symbol.dispose];
                }
                if (typeof dispose !== "function") throw new TypeError("Object not disposable.");
                env.stack.push({ value: value, dispose: dispose, async: async });
            }
            else if (async) {
                env.stack.push({ async: true });
            }
            return value;
        };`
	      };
	      disposeResourcesHelper = {
	        name: "typescript:disposeResources",
	        importName: "__disposeResources",
	        scoped: false,
	        text: `
        var __disposeResources = (this && this.__disposeResources) || (function (SuppressedError) {
            return function (env) {
                function fail(e) {
                    env.error = env.hasError ? new SuppressedError(e, env.error, "An error was suppressed during disposal.") : e;
                    env.hasError = true;
                }
                function next() {
                    while (env.stack.length) {
                        var rec = env.stack.pop();
                        try {
                            var result = rec.dispose && rec.dispose.call(rec.value);
                            if (rec.async) return Promise.resolve(result).then(next, function(e) { fail(e); return next(); });
                        }
                        catch (e) {
                            fail(e);
                        }
                    }
                    if (env.hasError) throw env.error;
                }
                return next();
            };
        })(typeof SuppressedError === "function" ? SuppressedError : function (error, suppressed, message) {
            var e = new Error(message);
            return e.name = "SuppressedError", e.error = error, e.suppressed = suppressed, e;
        });`
	      };
	      asyncSuperHelper = {
	        name: "typescript:async-super",
	        scoped: true,
	        text: helperString`
            const ${"_superIndex"} = name => super[name];`
	      };
	      advancedAsyncSuperHelper = {
	        name: "typescript:advanced-async-super",
	        scoped: true,
	        text: helperString`
            const ${"_superIndex"} = (function (geti, seti) {
                const cache = Object.create(null);
                return name => cache[name] || (cache[name] = { get value() { return geti(name); }, set value(v) { seti(name, v); } });
            })(name => super[name], (name, value) => super[name] = value);`
	      };
	    }
	  });

	  // src/compiler/factory/nodeTests.ts
	  function isNumericLiteral(node) {
	    return node.kind === 9 /* NumericLiteral */;
	  }
	  function isBigIntLiteral(node) {
	    return node.kind === 10 /* BigIntLiteral */;
	  }
	  function isStringLiteral(node) {
	    return node.kind === 11 /* StringLiteral */;
	  }
	  function isJsxText(node) {
	    return node.kind === 12 /* JsxText */;
	  }
	  function isRegularExpressionLiteral(node) {
	    return node.kind === 14 /* RegularExpressionLiteral */;
	  }
	  function isNoSubstitutionTemplateLiteral(node) {
	    return node.kind === 15 /* NoSubstitutionTemplateLiteral */;
	  }
	  function isTemplateHead(node) {
	    return node.kind === 16 /* TemplateHead */;
	  }
	  function isTemplateMiddle(node) {
	    return node.kind === 17 /* TemplateMiddle */;
	  }
	  function isTemplateTail(node) {
	    return node.kind === 18 /* TemplateTail */;
	  }
	  function isDotDotDotToken(node) {
	    return node.kind === 26 /* DotDotDotToken */;
	  }
	  function isCommaToken(node) {
	    return node.kind === 28 /* CommaToken */;
	  }
	  function isPlusToken(node) {
	    return node.kind === 40 /* PlusToken */;
	  }
	  function isMinusToken(node) {
	    return node.kind === 41 /* MinusToken */;
	  }
	  function isAsteriskToken(node) {
	    return node.kind === 42 /* AsteriskToken */;
	  }
	  function isExclamationToken(node) {
	    return node.kind === 54 /* ExclamationToken */;
	  }
	  function isQuestionToken(node) {
	    return node.kind === 58 /* QuestionToken */;
	  }
	  function isColonToken(node) {
	    return node.kind === 59 /* ColonToken */;
	  }
	  function isQuestionDotToken(node) {
	    return node.kind === 29 /* QuestionDotToken */;
	  }
	  function isEqualsGreaterThanToken(node) {
	    return node.kind === 39 /* EqualsGreaterThanToken */;
	  }
	  function isIdentifier(node) {
	    return node.kind === 80 /* Identifier */;
	  }
	  function isPrivateIdentifier(node) {
	    return node.kind === 81 /* PrivateIdentifier */;
	  }
	  function isExportModifier(node) {
	    return node.kind === 95 /* ExportKeyword */;
	  }
	  function isDefaultModifier(node) {
	    return node.kind === 90 /* DefaultKeyword */;
	  }
	  function isAsyncModifier(node) {
	    return node.kind === 134 /* AsyncKeyword */;
	  }
	  function isAssertsKeyword(node) {
	    return node.kind === 131 /* AssertsKeyword */;
	  }
	  function isAwaitKeyword(node) {
	    return node.kind === 135 /* AwaitKeyword */;
	  }
	  function isReadonlyKeyword(node) {
	    return node.kind === 148 /* ReadonlyKeyword */;
	  }
	  function isStaticModifier(node) {
	    return node.kind === 126 /* StaticKeyword */;
	  }
	  function isAbstractModifier(node) {
	    return node.kind === 128 /* AbstractKeyword */;
	  }
	  function isOverrideModifier(node) {
	    return node.kind === 164 /* OverrideKeyword */;
	  }
	  function isAccessorModifier(node) {
	    return node.kind === 129 /* AccessorKeyword */;
	  }
	  function isSuperKeyword(node) {
	    return node.kind === 108 /* SuperKeyword */;
	  }
	  function isImportKeyword(node) {
	    return node.kind === 102 /* ImportKeyword */;
	  }
	  function isCaseKeyword(node) {
	    return node.kind === 84 /* CaseKeyword */;
	  }
	  function isQualifiedName(node) {
	    return node.kind === 166 /* QualifiedName */;
	  }
	  function isComputedPropertyName(node) {
	    return node.kind === 167 /* ComputedPropertyName */;
	  }
	  function isTypeParameterDeclaration(node) {
	    return node.kind === 168 /* TypeParameter */;
	  }
	  function isParameter(node) {
	    return node.kind === 169 /* Parameter */;
	  }
	  function isDecorator(node) {
	    return node.kind === 170 /* Decorator */;
	  }
	  function isPropertySignature(node) {
	    return node.kind === 171 /* PropertySignature */;
	  }
	  function isPropertyDeclaration(node) {
	    return node.kind === 172 /* PropertyDeclaration */;
	  }
	  function isMethodSignature(node) {
	    return node.kind === 173 /* MethodSignature */;
	  }
	  function isMethodDeclaration(node) {
	    return node.kind === 174 /* MethodDeclaration */;
	  }
	  function isClassStaticBlockDeclaration(node) {
	    return node.kind === 175 /* ClassStaticBlockDeclaration */;
	  }
	  function isConstructorDeclaration(node) {
	    return node.kind === 176 /* Constructor */;
	  }
	  function isGetAccessorDeclaration(node) {
	    return node.kind === 177 /* GetAccessor */;
	  }
	  function isSetAccessorDeclaration(node) {
	    return node.kind === 178 /* SetAccessor */;
	  }
	  function isCallSignatureDeclaration(node) {
	    return node.kind === 179 /* CallSignature */;
	  }
	  function isConstructSignatureDeclaration(node) {
	    return node.kind === 180 /* ConstructSignature */;
	  }
	  function isIndexSignatureDeclaration(node) {
	    return node.kind === 181 /* IndexSignature */;
	  }
	  function isTypePredicateNode(node) {
	    return node.kind === 182 /* TypePredicate */;
	  }
	  function isTypeReferenceNode(node) {
	    return node.kind === 183 /* TypeReference */;
	  }
	  function isFunctionTypeNode(node) {
	    return node.kind === 184 /* FunctionType */;
	  }
	  function isConstructorTypeNode(node) {
	    return node.kind === 185 /* ConstructorType */;
	  }
	  function isTypeQueryNode(node) {
	    return node.kind === 186 /* TypeQuery */;
	  }
	  function isTypeLiteralNode(node) {
	    return node.kind === 187 /* TypeLiteral */;
	  }
	  function isArrayTypeNode(node) {
	    return node.kind === 188 /* ArrayType */;
	  }
	  function isTupleTypeNode(node) {
	    return node.kind === 189 /* TupleType */;
	  }
	  function isNamedTupleMember(node) {
	    return node.kind === 202 /* NamedTupleMember */;
	  }
	  function isOptionalTypeNode(node) {
	    return node.kind === 190 /* OptionalType */;
	  }
	  function isRestTypeNode(node) {
	    return node.kind === 191 /* RestType */;
	  }
	  function isUnionTypeNode(node) {
	    return node.kind === 192 /* UnionType */;
	  }
	  function isIntersectionTypeNode(node) {
	    return node.kind === 193 /* IntersectionType */;
	  }
	  function isConditionalTypeNode(node) {
	    return node.kind === 194 /* ConditionalType */;
	  }
	  function isInferTypeNode(node) {
	    return node.kind === 195 /* InferType */;
	  }
	  function isParenthesizedTypeNode(node) {
	    return node.kind === 196 /* ParenthesizedType */;
	  }
	  function isThisTypeNode(node) {
	    return node.kind === 197 /* ThisType */;
	  }
	  function isTypeOperatorNode(node) {
	    return node.kind === 198 /* TypeOperator */;
	  }
	  function isIndexedAccessTypeNode(node) {
	    return node.kind === 199 /* IndexedAccessType */;
	  }
	  function isMappedTypeNode(node) {
	    return node.kind === 200 /* MappedType */;
	  }
	  function isLiteralTypeNode(node) {
	    return node.kind === 201 /* LiteralType */;
	  }
	  function isImportTypeNode(node) {
	    return node.kind === 205 /* ImportType */;
	  }
	  function isTemplateLiteralTypeSpan(node) {
	    return node.kind === 204 /* TemplateLiteralTypeSpan */;
	  }
	  function isTemplateLiteralTypeNode(node) {
	    return node.kind === 203 /* TemplateLiteralType */;
	  }
	  function isObjectBindingPattern(node) {
	    return node.kind === 206 /* ObjectBindingPattern */;
	  }
	  function isArrayBindingPattern(node) {
	    return node.kind === 207 /* ArrayBindingPattern */;
	  }
	  function isBindingElement(node) {
	    return node.kind === 208 /* BindingElement */;
	  }
	  function isArrayLiteralExpression(node) {
	    return node.kind === 209 /* ArrayLiteralExpression */;
	  }
	  function isObjectLiteralExpression(node) {
	    return node.kind === 210 /* ObjectLiteralExpression */;
	  }
	  function isPropertyAccessExpression(node) {
	    return node.kind === 211 /* PropertyAccessExpression */;
	  }
	  function isElementAccessExpression(node) {
	    return node.kind === 212 /* ElementAccessExpression */;
	  }
	  function isCallExpression(node) {
	    return node.kind === 213 /* CallExpression */;
	  }
	  function isNewExpression(node) {
	    return node.kind === 214 /* NewExpression */;
	  }
	  function isTaggedTemplateExpression(node) {
	    return node.kind === 215 /* TaggedTemplateExpression */;
	  }
	  function isTypeAssertionExpression(node) {
	    return node.kind === 216 /* TypeAssertionExpression */;
	  }
	  function isParenthesizedExpression(node) {
	    return node.kind === 217 /* ParenthesizedExpression */;
	  }
	  function isFunctionExpression(node) {
	    return node.kind === 218 /* FunctionExpression */;
	  }
	  function isArrowFunction(node) {
	    return node.kind === 219 /* ArrowFunction */;
	  }
	  function isDeleteExpression(node) {
	    return node.kind === 220 /* DeleteExpression */;
	  }
	  function isTypeOfExpression(node) {
	    return node.kind === 221 /* TypeOfExpression */;
	  }
	  function isVoidExpression(node) {
	    return node.kind === 222 /* VoidExpression */;
	  }
	  function isAwaitExpression(node) {
	    return node.kind === 223 /* AwaitExpression */;
	  }
	  function isPrefixUnaryExpression(node) {
	    return node.kind === 224 /* PrefixUnaryExpression */;
	  }
	  function isPostfixUnaryExpression(node) {
	    return node.kind === 225 /* PostfixUnaryExpression */;
	  }
	  function isBinaryExpression(node) {
	    return node.kind === 226 /* BinaryExpression */;
	  }
	  function isConditionalExpression(node) {
	    return node.kind === 227 /* ConditionalExpression */;
	  }
	  function isTemplateExpression(node) {
	    return node.kind === 228 /* TemplateExpression */;
	  }
	  function isYieldExpression(node) {
	    return node.kind === 229 /* YieldExpression */;
	  }
	  function isSpreadElement(node) {
	    return node.kind === 230 /* SpreadElement */;
	  }
	  function isClassExpression(node) {
	    return node.kind === 231 /* ClassExpression */;
	  }
	  function isOmittedExpression(node) {
	    return node.kind === 232 /* OmittedExpression */;
	  }
	  function isExpressionWithTypeArguments(node) {
	    return node.kind === 233 /* ExpressionWithTypeArguments */;
	  }
	  function isAsExpression(node) {
	    return node.kind === 234 /* AsExpression */;
	  }
	  function isSatisfiesExpression(node) {
	    return node.kind === 238 /* SatisfiesExpression */;
	  }
	  function isNonNullExpression(node) {
	    return node.kind === 235 /* NonNullExpression */;
	  }
	  function isMetaProperty(node) {
	    return node.kind === 236 /* MetaProperty */;
	  }
	  function isSyntheticExpression(node) {
	    return node.kind === 237 /* SyntheticExpression */;
	  }
	  function isPartiallyEmittedExpression(node) {
	    return node.kind === 360 /* PartiallyEmittedExpression */;
	  }
	  function isCommaListExpression(node) {
	    return node.kind === 361 /* CommaListExpression */;
	  }
	  function isTemplateSpan(node) {
	    return node.kind === 239 /* TemplateSpan */;
	  }
	  function isSemicolonClassElement(node) {
	    return node.kind === 240 /* SemicolonClassElement */;
	  }
	  function isBlock(node) {
	    return node.kind === 241 /* Block */;
	  }
	  function isVariableStatement(node) {
	    return node.kind === 243 /* VariableStatement */;
	  }
	  function isEmptyStatement(node) {
	    return node.kind === 242 /* EmptyStatement */;
	  }
	  function isExpressionStatement(node) {
	    return node.kind === 244 /* ExpressionStatement */;
	  }
	  function isIfStatement(node) {
	    return node.kind === 245 /* IfStatement */;
	  }
	  function isDoStatement(node) {
	    return node.kind === 246 /* DoStatement */;
	  }
	  function isWhileStatement(node) {
	    return node.kind === 247 /* WhileStatement */;
	  }
	  function isForStatement(node) {
	    return node.kind === 248 /* ForStatement */;
	  }
	  function isForInStatement(node) {
	    return node.kind === 249 /* ForInStatement */;
	  }
	  function isForOfStatement(node) {
	    return node.kind === 250 /* ForOfStatement */;
	  }
	  function isContinueStatement(node) {
	    return node.kind === 251 /* ContinueStatement */;
	  }
	  function isBreakStatement(node) {
	    return node.kind === 252 /* BreakStatement */;
	  }
	  function isReturnStatement(node) {
	    return node.kind === 253 /* ReturnStatement */;
	  }
	  function isWithStatement(node) {
	    return node.kind === 254 /* WithStatement */;
	  }
	  function isSwitchStatement(node) {
	    return node.kind === 255 /* SwitchStatement */;
	  }
	  function isLabeledStatement(node) {
	    return node.kind === 256 /* LabeledStatement */;
	  }
	  function isThrowStatement(node) {
	    return node.kind === 257 /* ThrowStatement */;
	  }
	  function isTryStatement(node) {
	    return node.kind === 258 /* TryStatement */;
	  }
	  function isDebuggerStatement(node) {
	    return node.kind === 259 /* DebuggerStatement */;
	  }
	  function isVariableDeclaration(node) {
	    return node.kind === 260 /* VariableDeclaration */;
	  }
	  function isVariableDeclarationList(node) {
	    return node.kind === 261 /* VariableDeclarationList */;
	  }
	  function isFunctionDeclaration(node) {
	    return node.kind === 262 /* FunctionDeclaration */;
	  }
	  function isClassDeclaration(node) {
	    return node.kind === 263 /* ClassDeclaration */;
	  }
	  function isInterfaceDeclaration(node) {
	    return node.kind === 264 /* InterfaceDeclaration */;
	  }
	  function isTypeAliasDeclaration(node) {
	    return node.kind === 265 /* TypeAliasDeclaration */;
	  }
	  function isEnumDeclaration(node) {
	    return node.kind === 266 /* EnumDeclaration */;
	  }
	  function isModuleDeclaration(node) {
	    return node.kind === 267 /* ModuleDeclaration */;
	  }
	  function isModuleBlock(node) {
	    return node.kind === 268 /* ModuleBlock */;
	  }
	  function isCaseBlock(node) {
	    return node.kind === 269 /* CaseBlock */;
	  }
	  function isNamespaceExportDeclaration(node) {
	    return node.kind === 270 /* NamespaceExportDeclaration */;
	  }
	  function isImportEqualsDeclaration(node) {
	    return node.kind === 271 /* ImportEqualsDeclaration */;
	  }
	  function isImportDeclaration(node) {
	    return node.kind === 272 /* ImportDeclaration */;
	  }
	  function isImportClause(node) {
	    return node.kind === 273 /* ImportClause */;
	  }
	  function isImportTypeAssertionContainer(node) {
	    return node.kind === 302 /* ImportTypeAssertionContainer */;
	  }
	  function isAssertClause(node) {
	    return node.kind === 300 /* AssertClause */;
	  }
	  function isAssertEntry(node) {
	    return node.kind === 301 /* AssertEntry */;
	  }
	  function isImportAttributes(node) {
	    return node.kind === 300 /* ImportAttributes */;
	  }
	  function isImportAttribute(node) {
	    return node.kind === 301 /* ImportAttribute */;
	  }
	  function isNamespaceImport(node) {
	    return node.kind === 274 /* NamespaceImport */;
	  }
	  function isNamespaceExport(node) {
	    return node.kind === 280 /* NamespaceExport */;
	  }
	  function isNamedImports(node) {
	    return node.kind === 275 /* NamedImports */;
	  }
	  function isImportSpecifier(node) {
	    return node.kind === 276 /* ImportSpecifier */;
	  }
	  function isExportAssignment(node) {
	    return node.kind === 277 /* ExportAssignment */;
	  }
	  function isExportDeclaration(node) {
	    return node.kind === 278 /* ExportDeclaration */;
	  }
	  function isNamedExports(node) {
	    return node.kind === 279 /* NamedExports */;
	  }
	  function isExportSpecifier(node) {
	    return node.kind === 281 /* ExportSpecifier */;
	  }
	  function isMissingDeclaration(node) {
	    return node.kind === 282 /* MissingDeclaration */;
	  }
	  function isNotEmittedStatement(node) {
	    return node.kind === 359 /* NotEmittedStatement */;
	  }
	  function isSyntheticReference(node) {
	    return node.kind === 362 /* SyntheticReferenceExpression */;
	  }
	  function isExternalModuleReference(node) {
	    return node.kind === 283 /* ExternalModuleReference */;
	  }
	  function isJsxElement(node) {
	    return node.kind === 284 /* JsxElement */;
	  }
	  function isJsxSelfClosingElement(node) {
	    return node.kind === 285 /* JsxSelfClosingElement */;
	  }
	  function isJsxOpeningElement(node) {
	    return node.kind === 286 /* JsxOpeningElement */;
	  }
	  function isJsxClosingElement(node) {
	    return node.kind === 287 /* JsxClosingElement */;
	  }
	  function isJsxFragment(node) {
	    return node.kind === 288 /* JsxFragment */;
	  }
	  function isJsxOpeningFragment(node) {
	    return node.kind === 289 /* JsxOpeningFragment */;
	  }
	  function isJsxClosingFragment(node) {
	    return node.kind === 290 /* JsxClosingFragment */;
	  }
	  function isJsxAttribute(node) {
	    return node.kind === 291 /* JsxAttribute */;
	  }
	  function isJsxAttributes(node) {
	    return node.kind === 292 /* JsxAttributes */;
	  }
	  function isJsxSpreadAttribute(node) {
	    return node.kind === 293 /* JsxSpreadAttribute */;
	  }
	  function isJsxExpression(node) {
	    return node.kind === 294 /* JsxExpression */;
	  }
	  function isJsxNamespacedName(node) {
	    return node.kind === 295 /* JsxNamespacedName */;
	  }
	  function isCaseClause(node) {
	    return node.kind === 296 /* CaseClause */;
	  }
	  function isDefaultClause(node) {
	    return node.kind === 297 /* DefaultClause */;
	  }
	  function isHeritageClause(node) {
	    return node.kind === 298 /* HeritageClause */;
	  }
	  function isCatchClause(node) {
	    return node.kind === 299 /* CatchClause */;
	  }
	  function isPropertyAssignment(node) {
	    return node.kind === 303 /* PropertyAssignment */;
	  }
	  function isShorthandPropertyAssignment(node) {
	    return node.kind === 304 /* ShorthandPropertyAssignment */;
	  }
	  function isSpreadAssignment(node) {
	    return node.kind === 305 /* SpreadAssignment */;
	  }
	  function isEnumMember(node) {
	    return node.kind === 306 /* EnumMember */;
	  }
	  function isUnparsedPrepend(node) {
	    return node.kind === 308 /* UnparsedPrepend */;
	  }
	  function isSourceFile(node) {
	    return node.kind === 312 /* SourceFile */;
	  }
	  function isBundle(node) {
	    return node.kind === 313 /* Bundle */;
	  }
	  function isUnparsedSource(node) {
	    return node.kind === 314 /* UnparsedSource */;
	  }
	  function isJSDocTypeExpression(node) {
	    return node.kind === 316 /* JSDocTypeExpression */;
	  }
	  function isJSDocNameReference(node) {
	    return node.kind === 317 /* JSDocNameReference */;
	  }
	  function isJSDocMemberName(node) {
	    return node.kind === 318 /* JSDocMemberName */;
	  }
	  function isJSDocLink(node) {
	    return node.kind === 331 /* JSDocLink */;
	  }
	  function isJSDocLinkCode(node) {
	    return node.kind === 332 /* JSDocLinkCode */;
	  }
	  function isJSDocLinkPlain(node) {
	    return node.kind === 333 /* JSDocLinkPlain */;
	  }
	  function isJSDocAllType(node) {
	    return node.kind === 319 /* JSDocAllType */;
	  }
	  function isJSDocUnknownType(node) {
	    return node.kind === 320 /* JSDocUnknownType */;
	  }
	  function isJSDocNullableType(node) {
	    return node.kind === 321 /* JSDocNullableType */;
	  }
	  function isJSDocNonNullableType(node) {
	    return node.kind === 322 /* JSDocNonNullableType */;
	  }
	  function isJSDocOptionalType(node) {
	    return node.kind === 323 /* JSDocOptionalType */;
	  }
	  function isJSDocFunctionType(node) {
	    return node.kind === 324 /* JSDocFunctionType */;
	  }
	  function isJSDocVariadicType(node) {
	    return node.kind === 325 /* JSDocVariadicType */;
	  }
	  function isJSDocNamepathType(node) {
	    return node.kind === 326 /* JSDocNamepathType */;
	  }
	  function isJSDoc(node) {
	    return node.kind === 327 /* JSDoc */;
	  }
	  function isJSDocTypeLiteral(node) {
	    return node.kind === 329 /* JSDocTypeLiteral */;
	  }
	  function isJSDocSignature(node) {
	    return node.kind === 330 /* JSDocSignature */;
	  }
	  function isJSDocAugmentsTag(node) {
	    return node.kind === 335 /* JSDocAugmentsTag */;
	  }
	  function isJSDocAuthorTag(node) {
	    return node.kind === 337 /* JSDocAuthorTag */;
	  }
	  function isJSDocClassTag(node) {
	    return node.kind === 339 /* JSDocClassTag */;
	  }
	  function isJSDocCallbackTag(node) {
	    return node.kind === 345 /* JSDocCallbackTag */;
	  }
	  function isJSDocPublicTag(node) {
	    return node.kind === 340 /* JSDocPublicTag */;
	  }
	  function isJSDocPrivateTag(node) {
	    return node.kind === 341 /* JSDocPrivateTag */;
	  }
	  function isJSDocProtectedTag(node) {
	    return node.kind === 342 /* JSDocProtectedTag */;
	  }
	  function isJSDocReadonlyTag(node) {
	    return node.kind === 343 /* JSDocReadonlyTag */;
	  }
	  function isJSDocOverrideTag(node) {
	    return node.kind === 344 /* JSDocOverrideTag */;
	  }
	  function isJSDocOverloadTag(node) {
	    return node.kind === 346 /* JSDocOverloadTag */;
	  }
	  function isJSDocDeprecatedTag(node) {
	    return node.kind === 338 /* JSDocDeprecatedTag */;
	  }
	  function isJSDocSeeTag(node) {
	    return node.kind === 354 /* JSDocSeeTag */;
	  }
	  function isJSDocEnumTag(node) {
	    return node.kind === 347 /* JSDocEnumTag */;
	  }
	  function isJSDocParameterTag(node) {
	    return node.kind === 348 /* JSDocParameterTag */;
	  }
	  function isJSDocReturnTag(node) {
	    return node.kind === 349 /* JSDocReturnTag */;
	  }
	  function isJSDocThisTag(node) {
	    return node.kind === 350 /* JSDocThisTag */;
	  }
	  function isJSDocTypeTag(node) {
	    return node.kind === 351 /* JSDocTypeTag */;
	  }
	  function isJSDocTemplateTag(node) {
	    return node.kind === 352 /* JSDocTemplateTag */;
	  }
	  function isJSDocTypedefTag(node) {
	    return node.kind === 353 /* JSDocTypedefTag */;
	  }
	  function isJSDocUnknownTag(node) {
	    return node.kind === 334 /* JSDocTag */;
	  }
	  function isJSDocPropertyTag(node) {
	    return node.kind === 355 /* JSDocPropertyTag */;
	  }
	  function isJSDocImplementsTag(node) {
	    return node.kind === 336 /* JSDocImplementsTag */;
	  }
	  function isJSDocSatisfiesTag(node) {
	    return node.kind === 357 /* JSDocSatisfiesTag */;
	  }
	  function isJSDocThrowsTag(node) {
	    return node.kind === 356 /* JSDocThrowsTag */;
	  }
	  function isSyntaxList(n) {
	    return n.kind === 358 /* SyntaxList */;
	  }
	  var init_nodeTests = __esm({
	    "src/compiler/factory/nodeTests.ts"() {
	      init_ts2();
	    }
	  });

	  // src/compiler/factory/utilities.ts
	  function createEmptyExports(factory2) {
	    return factory2.createExportDeclaration(
	      /*modifiers*/
	      void 0,
	      /*isTypeOnly*/
	      false,
	      factory2.createNamedExports([]),
	      /*moduleSpecifier*/
	      void 0
	    );
	  }
	  function createMemberAccessForPropertyName(factory2, target, memberName, location) {
	    if (isComputedPropertyName(memberName)) {
	      return setTextRange(factory2.createElementAccessExpression(target, memberName.expression), location);
	    } else {
	      const expression = setTextRange(
	        isMemberName(memberName) ? factory2.createPropertyAccessExpression(target, memberName) : factory2.createElementAccessExpression(target, memberName),
	        memberName
	      );
	      addEmitFlags(expression, 128 /* NoNestedSourceMaps */);
	      return expression;
	    }
	  }
	  function createReactNamespace(reactNamespace, parent2) {
	    const react = parseNodeFactory.createIdentifier(reactNamespace || "React");
	    setParent(react, getParseTreeNode(parent2));
	    return react;
	  }
	  function createJsxFactoryExpressionFromEntityName(factory2, jsxFactory, parent2) {
	    if (isQualifiedName(jsxFactory)) {
	      const left = createJsxFactoryExpressionFromEntityName(factory2, jsxFactory.left, parent2);
	      const right = factory2.createIdentifier(idText(jsxFactory.right));
	      right.escapedText = jsxFactory.right.escapedText;
	      return factory2.createPropertyAccessExpression(left, right);
	    } else {
	      return createReactNamespace(idText(jsxFactory), parent2);
	    }
	  }
	  function createJsxFactoryExpression(factory2, jsxFactoryEntity, reactNamespace, parent2) {
	    return jsxFactoryEntity ? createJsxFactoryExpressionFromEntityName(factory2, jsxFactoryEntity, parent2) : factory2.createPropertyAccessExpression(
	      createReactNamespace(reactNamespace, parent2),
	      "createElement"
	    );
	  }
	  function createJsxFragmentFactoryExpression(factory2, jsxFragmentFactoryEntity, reactNamespace, parent2) {
	    return jsxFragmentFactoryEntity ? createJsxFactoryExpressionFromEntityName(factory2, jsxFragmentFactoryEntity, parent2) : factory2.createPropertyAccessExpression(
	      createReactNamespace(reactNamespace, parent2),
	      "Fragment"
	    );
	  }
	  function createExpressionForJsxElement(factory2, callee, tagName, props, children, location) {
	    const argumentsList = [tagName];
	    if (props) {
	      argumentsList.push(props);
	    }
	    if (children && children.length > 0) {
	      if (!props) {
	        argumentsList.push(factory2.createNull());
	      }
	      if (children.length > 1) {
	        for (const child of children) {
	          startOnNewLine(child);
	          argumentsList.push(child);
	        }
	      } else {
	        argumentsList.push(children[0]);
	      }
	    }
	    return setTextRange(
	      factory2.createCallExpression(
	        callee,
	        /*typeArguments*/
	        void 0,
	        argumentsList
	      ),
	      location
	    );
	  }
	  function createExpressionForJsxFragment(factory2, jsxFactoryEntity, jsxFragmentFactoryEntity, reactNamespace, children, parentElement, location) {
	    const tagName = createJsxFragmentFactoryExpression(factory2, jsxFragmentFactoryEntity, reactNamespace, parentElement);
	    const argumentsList = [tagName, factory2.createNull()];
	    if (children && children.length > 0) {
	      if (children.length > 1) {
	        for (const child of children) {
	          startOnNewLine(child);
	          argumentsList.push(child);
	        }
	      } else {
	        argumentsList.push(children[0]);
	      }
	    }
	    return setTextRange(
	      factory2.createCallExpression(
	        createJsxFactoryExpression(factory2, jsxFactoryEntity, reactNamespace, parentElement),
	        /*typeArguments*/
	        void 0,
	        argumentsList
	      ),
	      location
	    );
	  }
	  function createForOfBindingStatement(factory2, node, boundValue) {
	    if (isVariableDeclarationList(node)) {
	      const firstDeclaration = first(node.declarations);
	      const updatedDeclaration = factory2.updateVariableDeclaration(
	        firstDeclaration,
	        firstDeclaration.name,
	        /*exclamationToken*/
	        void 0,
	        /*type*/
	        void 0,
	        boundValue
	      );
	      return setTextRange(
	        factory2.createVariableStatement(
	          /*modifiers*/
	          void 0,
	          factory2.updateVariableDeclarationList(node, [updatedDeclaration])
	        ),
	        /*location*/
	        node
	      );
	    } else {
	      const updatedExpression = setTextRange(
	        factory2.createAssignment(node, boundValue),
	        /*location*/
	        node
	      );
	      return setTextRange(
	        factory2.createExpressionStatement(updatedExpression),
	        /*location*/
	        node
	      );
	    }
	  }
	  function insertLeadingStatement(factory2, dest, source) {
	    if (isBlock(dest)) {
	      return factory2.updateBlock(dest, setTextRange(factory2.createNodeArray([source, ...dest.statements]), dest.statements));
	    } else {
	      return factory2.createBlock(
	        factory2.createNodeArray([dest, source]),
	        /*multiLine*/
	        true
	      );
	    }
	  }
	  function createExpressionFromEntityName(factory2, node) {
	    if (isQualifiedName(node)) {
	      const left = createExpressionFromEntityName(factory2, node.left);
	      const right = setParent(setTextRange(factory2.cloneNode(node.right), node.right), node.right.parent);
	      return setTextRange(factory2.createPropertyAccessExpression(left, right), node);
	    } else {
	      return setParent(setTextRange(factory2.cloneNode(node), node), node.parent);
	    }
	  }
	  function createExpressionForPropertyName(factory2, memberName) {
	    if (isIdentifier(memberName)) {
	      return factory2.createStringLiteralFromNode(memberName);
	    } else if (isComputedPropertyName(memberName)) {
	      return setParent(setTextRange(factory2.cloneNode(memberName.expression), memberName.expression), memberName.expression.parent);
	    } else {
	      return setParent(setTextRange(factory2.cloneNode(memberName), memberName), memberName.parent);
	    }
	  }
	  function createExpressionForAccessorDeclaration(factory2, properties, property, receiver, multiLine) {
	    const { firstAccessor, getAccessor, setAccessor } = getAllAccessorDeclarations(properties, property);
	    if (property === firstAccessor) {
	      return setTextRange(
	        factory2.createObjectDefinePropertyCall(
	          receiver,
	          createExpressionForPropertyName(factory2, property.name),
	          factory2.createPropertyDescriptor({
	            enumerable: factory2.createFalse(),
	            configurable: true,
	            get: getAccessor && setTextRange(
	              setOriginalNode(
	                factory2.createFunctionExpression(
	                  getModifiers(getAccessor),
	                  /*asteriskToken*/
	                  void 0,
	                  /*name*/
	                  void 0,
	                  /*typeParameters*/
	                  void 0,
	                  getAccessor.parameters,
	                  /*type*/
	                  void 0,
	                  getAccessor.body
	                  // TODO: GH#18217
	                ),
	                getAccessor
	              ),
	              getAccessor
	            ),
	            set: setAccessor && setTextRange(
	              setOriginalNode(
	                factory2.createFunctionExpression(
	                  getModifiers(setAccessor),
	                  /*asteriskToken*/
	                  void 0,
	                  /*name*/
	                  void 0,
	                  /*typeParameters*/
	                  void 0,
	                  setAccessor.parameters,
	                  /*type*/
	                  void 0,
	                  setAccessor.body
	                  // TODO: GH#18217
	                ),
	                setAccessor
	              ),
	              setAccessor
	            )
	          }, !multiLine)
	        ),
	        firstAccessor
	      );
	    }
	    return void 0;
	  }
	  function createExpressionForPropertyAssignment(factory2, property, receiver) {
	    return setOriginalNode(
	      setTextRange(
	        factory2.createAssignment(
	          createMemberAccessForPropertyName(
	            factory2,
	            receiver,
	            property.name,
	            /*location*/
	            property.name
	          ),
	          property.initializer
	        ),
	        property
	      ),
	      property
	    );
	  }
	  function createExpressionForShorthandPropertyAssignment(factory2, property, receiver) {
	    return setOriginalNode(
	      setTextRange(
	        factory2.createAssignment(
	          createMemberAccessForPropertyName(
	            factory2,
	            receiver,
	            property.name,
	            /*location*/
	            property.name
	          ),
	          factory2.cloneNode(property.name)
	        ),
	        /*location*/
	        property
	      ),
	      /*original*/
	      property
	    );
	  }
	  function createExpressionForMethodDeclaration(factory2, method, receiver) {
	    return setOriginalNode(
	      setTextRange(
	        factory2.createAssignment(
	          createMemberAccessForPropertyName(
	            factory2,
	            receiver,
	            method.name,
	            /*location*/
	            method.name
	          ),
	          setOriginalNode(
	            setTextRange(
	              factory2.createFunctionExpression(
	                getModifiers(method),
	                method.asteriskToken,
	                /*name*/
	                void 0,
	                /*typeParameters*/
	                void 0,
	                method.parameters,
	                /*type*/
	                void 0,
	                method.body
	                // TODO: GH#18217
	              ),
	              /*location*/
	              method
	            ),
	            /*original*/
	            method
	          )
	        ),
	        /*location*/
	        method
	      ),
	      /*original*/
	      method
	    );
	  }
	  function createExpressionForObjectLiteralElementLike(factory2, node, property, receiver) {
	    if (property.name && isPrivateIdentifier(property.name)) {
	      Debug.failBadSyntaxKind(property.name, "Private identifiers are not allowed in object literals.");
	    }
	    switch (property.kind) {
	      case 177 /* GetAccessor */:
	      case 178 /* SetAccessor */:
	        return createExpressionForAccessorDeclaration(factory2, node.properties, property, receiver, !!node.multiLine);
	      case 303 /* PropertyAssignment */:
	        return createExpressionForPropertyAssignment(factory2, property, receiver);
	      case 304 /* ShorthandPropertyAssignment */:
	        return createExpressionForShorthandPropertyAssignment(factory2, property, receiver);
	      case 174 /* MethodDeclaration */:
	        return createExpressionForMethodDeclaration(factory2, property, receiver);
	    }
	  }
	  function expandPreOrPostfixIncrementOrDecrementExpression(factory2, node, expression, recordTempVariable, resultVariable) {
	    const operator = node.operator;
	    Debug.assert(operator === 46 /* PlusPlusToken */ || operator === 47 /* MinusMinusToken */, "Expected 'node' to be a pre- or post-increment or pre- or post-decrement expression");
	    const temp = factory2.createTempVariable(recordTempVariable);
	    expression = factory2.createAssignment(temp, expression);
	    setTextRange(expression, node.operand);
	    let operation = isPrefixUnaryExpression(node) ? factory2.createPrefixUnaryExpression(operator, temp) : factory2.createPostfixUnaryExpression(temp, operator);
	    setTextRange(operation, node);
	    if (resultVariable) {
	      operation = factory2.createAssignment(resultVariable, operation);
	      setTextRange(operation, node);
	    }
	    expression = factory2.createComma(expression, operation);
	    setTextRange(expression, node);
	    if (isPostfixUnaryExpression(node)) {
	      expression = factory2.createComma(expression, temp);
	      setTextRange(expression, node);
	    }
	    return expression;
	  }
	  function isInternalName(node) {
	    return (getEmitFlags(node) & 65536 /* InternalName */) !== 0;
	  }
	  function isLocalName(node) {
	    return (getEmitFlags(node) & 32768 /* LocalName */) !== 0;
	  }
	  function isExportName(node) {
	    return (getEmitFlags(node) & 16384 /* ExportName */) !== 0;
	  }
	  function isUseStrictPrologue(node) {
	    return isStringLiteral(node.expression) && node.expression.text === "use strict";
	  }
	  function findUseStrictPrologue(statements) {
	    for (const statement of statements) {
	      if (isPrologueDirective(statement)) {
	        if (isUseStrictPrologue(statement)) {
	          return statement;
	        }
	      } else {
	        break;
	      }
	    }
	    return void 0;
	  }
	  function startsWithUseStrict(statements) {
	    const firstStatement = firstOrUndefined(statements);
	    return firstStatement !== void 0 && isPrologueDirective(firstStatement) && isUseStrictPrologue(firstStatement);
	  }
	  function isCommaExpression(node) {
	    return node.kind === 226 /* BinaryExpression */ && node.operatorToken.kind === 28 /* CommaToken */;
	  }
	  function isCommaSequence(node) {
	    return isCommaExpression(node) || isCommaListExpression(node);
	  }
	  function isJSDocTypeAssertion(node) {
	    return isParenthesizedExpression(node) && isInJSFile(node) && !!getJSDocTypeTag(node);
	  }
	  function getJSDocTypeAssertionType(node) {
	    const type = getJSDocType(node);
	    Debug.assertIsDefined(type);
	    return type;
	  }
	  function isOuterExpression(node, kinds = 15 /* All */) {
	    switch (node.kind) {
	      case 217 /* ParenthesizedExpression */:
	        if (kinds & 16 /* ExcludeJSDocTypeAssertion */ && isJSDocTypeAssertion(node)) {
	          return false;
	        }
	        return (kinds & 1 /* Parentheses */) !== 0;
	      case 216 /* TypeAssertionExpression */:
	      case 234 /* AsExpression */:
	      case 233 /* ExpressionWithTypeArguments */:
	      case 238 /* SatisfiesExpression */:
	        return (kinds & 2 /* TypeAssertions */) !== 0;
	      case 235 /* NonNullExpression */:
	        return (kinds & 4 /* NonNullAssertions */) !== 0;
	      case 360 /* PartiallyEmittedExpression */:
	        return (kinds & 8 /* PartiallyEmittedExpressions */) !== 0;
	    }
	    return false;
	  }
	  function skipOuterExpressions(node, kinds = 15 /* All */) {
	    while (isOuterExpression(node, kinds)) {
	      node = node.expression;
	    }
	    return node;
	  }
	  function walkUpOuterExpressions(node, kinds = 15 /* All */) {
	    let parent2 = node.parent;
	    while (isOuterExpression(parent2, kinds)) {
	      parent2 = parent2.parent;
	      Debug.assert(parent2);
	    }
	    return parent2;
	  }
	  function skipAssertions(node) {
	    return skipOuterExpressions(node, 6 /* Assertions */);
	  }
	  function startOnNewLine(node) {
	    return setStartsOnNewLine(
	      node,
	      /*newLine*/
	      true
	    );
	  }
	  function getExternalHelpersModuleName(node) {
	    const parseNode = getOriginalNode(node, isSourceFile);
	    const emitNode = parseNode && parseNode.emitNode;
	    return emitNode && emitNode.externalHelpersModuleName;
	  }
	  function hasRecordedExternalHelpers(sourceFile) {
	    const parseNode = getOriginalNode(sourceFile, isSourceFile);
	    const emitNode = parseNode && parseNode.emitNode;
	    return !!emitNode && (!!emitNode.externalHelpersModuleName || !!emitNode.externalHelpers);
	  }
	  function createExternalHelpersImportDeclarationIfNeeded(nodeFactory, helperFactory, sourceFile, compilerOptions, hasExportStarsToExportValues, hasImportStar, hasImportDefault) {
	    if (compilerOptions.importHelpers && isEffectiveExternalModule(sourceFile, compilerOptions)) {
	      let namedBindings;
	      const moduleKind = getEmitModuleKind(compilerOptions);
	      if (moduleKind >= 5 /* ES2015 */ && moduleKind <= 99 /* ESNext */ || sourceFile.impliedNodeFormat === 99 /* ESNext */) {
	        const helpers = getEmitHelpers(sourceFile);
	        if (helpers) {
	          const helperNames = [];
	          for (const helper of helpers) {
	            if (!helper.scoped) {
	              const importName = helper.importName;
	              if (importName) {
	                pushIfUnique(helperNames, importName);
	              }
	            }
	          }
	          if (some(helperNames)) {
	            helperNames.sort(compareStringsCaseSensitive);
	            namedBindings = nodeFactory.createNamedImports(
	              map(helperNames, (name) => isFileLevelUniqueName(sourceFile, name) ? nodeFactory.createImportSpecifier(
	                /*isTypeOnly*/
	                false,
	                /*propertyName*/
	                void 0,
	                nodeFactory.createIdentifier(name)
	              ) : nodeFactory.createImportSpecifier(
	                /*isTypeOnly*/
	                false,
	                nodeFactory.createIdentifier(name),
	                helperFactory.getUnscopedHelperName(name)
	              ))
	            );
	            const parseNode = getOriginalNode(sourceFile, isSourceFile);
	            const emitNode = getOrCreateEmitNode(parseNode);
	            emitNode.externalHelpers = true;
	          }
	        }
	      } else {
	        const externalHelpersModuleName = getOrCreateExternalHelpersModuleNameIfNeeded(nodeFactory, sourceFile, compilerOptions, hasExportStarsToExportValues, hasImportStar || hasImportDefault);
	        if (externalHelpersModuleName) {
	          namedBindings = nodeFactory.createNamespaceImport(externalHelpersModuleName);
	        }
	      }
	      if (namedBindings) {
	        const externalHelpersImportDeclaration = nodeFactory.createImportDeclaration(
	          /*modifiers*/
	          void 0,
	          nodeFactory.createImportClause(
	            /*isTypeOnly*/
	            false,
	            /*name*/
	            void 0,
	            namedBindings
	          ),
	          nodeFactory.createStringLiteral(externalHelpersModuleNameText),
	          /*attributes*/
	          void 0
	        );
	        addInternalEmitFlags(externalHelpersImportDeclaration, 2 /* NeverApplyImportHelper */);
	        return externalHelpersImportDeclaration;
	      }
	    }
	  }
	  function getOrCreateExternalHelpersModuleNameIfNeeded(factory2, node, compilerOptions, hasExportStarsToExportValues, hasImportStarOrImportDefault) {
	    if (compilerOptions.importHelpers && isEffectiveExternalModule(node, compilerOptions)) {
	      const externalHelpersModuleName = getExternalHelpersModuleName(node);
	      if (externalHelpersModuleName) {
	        return externalHelpersModuleName;
	      }
	      const moduleKind = getEmitModuleKind(compilerOptions);
	      let create = (hasExportStarsToExportValues || getESModuleInterop(compilerOptions) && hasImportStarOrImportDefault) && moduleKind !== 4 /* System */ && (moduleKind < 5 /* ES2015 */ || node.impliedNodeFormat === 1 /* CommonJS */);
	      if (!create) {
	        const helpers = getEmitHelpers(node);
	        if (helpers) {
	          for (const helper of helpers) {
	            if (!helper.scoped) {
	              create = true;
	              break;
	            }
	          }
	        }
	      }
	      if (create) {
	        const parseNode = getOriginalNode(node, isSourceFile);
	        const emitNode = getOrCreateEmitNode(parseNode);
	        return emitNode.externalHelpersModuleName || (emitNode.externalHelpersModuleName = factory2.createUniqueName(externalHelpersModuleNameText));
	      }
	    }
	  }
	  function getLocalNameForExternalImport(factory2, node, sourceFile) {
	    const namespaceDeclaration = getNamespaceDeclarationNode(node);
	    if (namespaceDeclaration && !isDefaultImport(node) && !isExportNamespaceAsDefaultDeclaration(node)) {
	      const name = namespaceDeclaration.name;
	      return isGeneratedIdentifier(name) ? name : factory2.createIdentifier(getSourceTextOfNodeFromSourceFile(sourceFile, name) || idText(name));
	    }
	    if (node.kind === 272 /* ImportDeclaration */ && node.importClause) {
	      return factory2.getGeneratedNameForNode(node);
	    }
	    if (node.kind === 278 /* ExportDeclaration */ && node.moduleSpecifier) {
	      return factory2.getGeneratedNameForNode(node);
	    }
	    return void 0;
	  }
	  function getExternalModuleNameLiteral(factory2, importNode, sourceFile, host, resolver, compilerOptions) {
	    const moduleName = getExternalModuleName(importNode);
	    if (moduleName && isStringLiteral(moduleName)) {
	      return tryGetModuleNameFromDeclaration(importNode, host, factory2, resolver, compilerOptions) || tryRenameExternalModule(factory2, moduleName, sourceFile) || factory2.cloneNode(moduleName);
	    }
	    return void 0;
	  }
	  function tryRenameExternalModule(factory2, moduleName, sourceFile) {
	    const rename = sourceFile.renamedDependencies && sourceFile.renamedDependencies.get(moduleName.text);
	    return rename ? factory2.createStringLiteral(rename) : void 0;
	  }
	  function tryGetModuleNameFromFile(factory2, file, host, options) {
	    if (!file) {
	      return void 0;
	    }
	    if (file.moduleName) {
	      return factory2.createStringLiteral(file.moduleName);
	    }
	    if (!file.isDeclarationFile && outFile(options)) {
	      return factory2.createStringLiteral(getExternalModuleNameFromPath(host, file.fileName));
	    }
	    return void 0;
	  }
	  function tryGetModuleNameFromDeclaration(declaration, host, factory2, resolver, compilerOptions) {
	    return tryGetModuleNameFromFile(factory2, resolver.getExternalModuleFileFromDeclaration(declaration), host, compilerOptions);
	  }
	  function getInitializerOfBindingOrAssignmentElement(bindingElement) {
	    if (isDeclarationBindingElement(bindingElement)) {
	      return bindingElement.initializer;
	    }
	    if (isPropertyAssignment(bindingElement)) {
	      const initializer = bindingElement.initializer;
	      return isAssignmentExpression(
	        initializer,
	        /*excludeCompoundAssignment*/
	        true
	      ) ? initializer.right : void 0;
	    }
	    if (isShorthandPropertyAssignment(bindingElement)) {
	      return bindingElement.objectAssignmentInitializer;
	    }
	    if (isAssignmentExpression(
	      bindingElement,
	      /*excludeCompoundAssignment*/
	      true
	    )) {
	      return bindingElement.right;
	    }
	    if (isSpreadElement(bindingElement)) {
	      return getInitializerOfBindingOrAssignmentElement(bindingElement.expression);
	    }
	  }
	  function getTargetOfBindingOrAssignmentElement(bindingElement) {
	    if (isDeclarationBindingElement(bindingElement)) {
	      return bindingElement.name;
	    }
	    if (isObjectLiteralElementLike(bindingElement)) {
	      switch (bindingElement.kind) {
	        case 303 /* PropertyAssignment */:
	          return getTargetOfBindingOrAssignmentElement(bindingElement.initializer);
	        case 304 /* ShorthandPropertyAssignment */:
	          return bindingElement.name;
	        case 305 /* SpreadAssignment */:
	          return getTargetOfBindingOrAssignmentElement(bindingElement.expression);
	      }
	      return void 0;
	    }
	    if (isAssignmentExpression(
	      bindingElement,
	      /*excludeCompoundAssignment*/
	      true
	    )) {
	      return getTargetOfBindingOrAssignmentElement(bindingElement.left);
	    }
	    if (isSpreadElement(bindingElement)) {
	      return getTargetOfBindingOrAssignmentElement(bindingElement.expression);
	    }
	    return bindingElement;
	  }
	  function getRestIndicatorOfBindingOrAssignmentElement(bindingElement) {
	    switch (bindingElement.kind) {
	      case 169 /* Parameter */:
	      case 208 /* BindingElement */:
	        return bindingElement.dotDotDotToken;
	      case 230 /* SpreadElement */:
	      case 305 /* SpreadAssignment */:
	        return bindingElement;
	    }
	    return void 0;
	  }
	  function getPropertyNameOfBindingOrAssignmentElement(bindingElement) {
	    const propertyName = tryGetPropertyNameOfBindingOrAssignmentElement(bindingElement);
	    Debug.assert(!!propertyName || isSpreadAssignment(bindingElement), "Invalid property name for binding element.");
	    return propertyName;
	  }
	  function tryGetPropertyNameOfBindingOrAssignmentElement(bindingElement) {
	    switch (bindingElement.kind) {
	      case 208 /* BindingElement */:
	        if (bindingElement.propertyName) {
	          const propertyName = bindingElement.propertyName;
	          if (isPrivateIdentifier(propertyName)) {
	            return Debug.failBadSyntaxKind(propertyName);
	          }
	          return isComputedPropertyName(propertyName) && isStringOrNumericLiteral(propertyName.expression) ? propertyName.expression : propertyName;
	        }
	        break;
	      case 303 /* PropertyAssignment */:
	        if (bindingElement.name) {
	          const propertyName = bindingElement.name;
	          if (isPrivateIdentifier(propertyName)) {
	            return Debug.failBadSyntaxKind(propertyName);
	          }
	          return isComputedPropertyName(propertyName) && isStringOrNumericLiteral(propertyName.expression) ? propertyName.expression : propertyName;
	        }
	        break;
	      case 305 /* SpreadAssignment */:
	        if (bindingElement.name && isPrivateIdentifier(bindingElement.name)) {
	          return Debug.failBadSyntaxKind(bindingElement.name);
	        }
	        return bindingElement.name;
	    }
	    const target = getTargetOfBindingOrAssignmentElement(bindingElement);
	    if (target && isPropertyName(target)) {
	      return target;
	    }
	  }
	  function isStringOrNumericLiteral(node) {
	    const kind = node.kind;
	    return kind === 11 /* StringLiteral */ || kind === 9 /* NumericLiteral */;
	  }
	  function getElementsOfBindingOrAssignmentPattern(name) {
	    switch (name.kind) {
	      case 206 /* ObjectBindingPattern */:
	      case 207 /* ArrayBindingPattern */:
	      case 209 /* ArrayLiteralExpression */:
	        return name.elements;
	      case 210 /* ObjectLiteralExpression */:
	        return name.properties;
	    }
	  }
	  function getJSDocTypeAliasName(fullName) {
	    if (fullName) {
	      let rightNode = fullName;
	      while (true) {
	        if (isIdentifier(rightNode) || !rightNode.body) {
	          return isIdentifier(rightNode) ? rightNode : rightNode.name;
	        }
	        rightNode = rightNode.body;
	      }
	    }
	  }
	  function canHaveIllegalType(node) {
	    const kind = node.kind;
	    return kind === 176 /* Constructor */ || kind === 178 /* SetAccessor */;
	  }
	  function canHaveIllegalTypeParameters(node) {
	    const kind = node.kind;
	    return kind === 176 /* Constructor */ || kind === 177 /* GetAccessor */ || kind === 178 /* SetAccessor */;
	  }
	  function canHaveIllegalDecorators(node) {
	    const kind = node.kind;
	    return kind === 303 /* PropertyAssignment */ || kind === 304 /* ShorthandPropertyAssignment */ || kind === 262 /* FunctionDeclaration */ || kind === 176 /* Constructor */ || kind === 181 /* IndexSignature */ || kind === 175 /* ClassStaticBlockDeclaration */ || kind === 282 /* MissingDeclaration */ || kind === 243 /* VariableStatement */ || kind === 264 /* InterfaceDeclaration */ || kind === 265 /* TypeAliasDeclaration */ || kind === 266 /* EnumDeclaration */ || kind === 267 /* ModuleDeclaration */ || kind === 271 /* ImportEqualsDeclaration */ || kind === 272 /* ImportDeclaration */ || kind === 270 /* NamespaceExportDeclaration */ || kind === 278 /* ExportDeclaration */ || kind === 277 /* ExportAssignment */;
	  }
	  function canHaveIllegalModifiers(node) {
	    const kind = node.kind;
	    return kind === 175 /* ClassStaticBlockDeclaration */ || kind === 303 /* PropertyAssignment */ || kind === 304 /* ShorthandPropertyAssignment */ || kind === 282 /* MissingDeclaration */ || kind === 270 /* NamespaceExportDeclaration */;
	  }
	  function isQuestionOrExclamationToken(node) {
	    return isQuestionToken(node) || isExclamationToken(node);
	  }
	  function isIdentifierOrThisTypeNode(node) {
	    return isIdentifier(node) || isThisTypeNode(node);
	  }
	  function isReadonlyKeywordOrPlusOrMinusToken(node) {
	    return isReadonlyKeyword(node) || isPlusToken(node) || isMinusToken(node);
	  }
	  function isQuestionOrPlusOrMinusToken(node) {
	    return isQuestionToken(node) || isPlusToken(node) || isMinusToken(node);
	  }
	  function isModuleName(node) {
	    return isIdentifier(node) || isStringLiteral(node);
	  }
	  function isLiteralTypeLikeExpression(node) {
	    const kind = node.kind;
	    return kind === 106 /* NullKeyword */ || kind === 112 /* TrueKeyword */ || kind === 97 /* FalseKeyword */ || isLiteralExpression(node) || isPrefixUnaryExpression(node);
	  }
	  function isExponentiationOperator(kind) {
	    return kind === 43 /* AsteriskAsteriskToken */;
	  }
	  function isMultiplicativeOperator(kind) {
	    return kind === 42 /* AsteriskToken */ || kind === 44 /* SlashToken */ || kind === 45 /* PercentToken */;
	  }
	  function isMultiplicativeOperatorOrHigher(kind) {
	    return isExponentiationOperator(kind) || isMultiplicativeOperator(kind);
	  }
	  function isAdditiveOperator(kind) {
	    return kind === 40 /* PlusToken */ || kind === 41 /* MinusToken */;
	  }
	  function isAdditiveOperatorOrHigher(kind) {
	    return isAdditiveOperator(kind) || isMultiplicativeOperatorOrHigher(kind);
	  }
	  function isShiftOperator(kind) {
	    return kind === 48 /* LessThanLessThanToken */ || kind === 49 /* GreaterThanGreaterThanToken */ || kind === 50 /* GreaterThanGreaterThanGreaterThanToken */;
	  }
	  function isShiftOperatorOrHigher(kind) {
	    return isShiftOperator(kind) || isAdditiveOperatorOrHigher(kind);
	  }
	  function isRelationalOperator(kind) {
	    return kind === 30 /* LessThanToken */ || kind === 33 /* LessThanEqualsToken */ || kind === 32 /* GreaterThanToken */ || kind === 34 /* GreaterThanEqualsToken */ || kind === 104 /* InstanceOfKeyword */ || kind === 103 /* InKeyword */;
	  }
	  function isRelationalOperatorOrHigher(kind) {
	    return isRelationalOperator(kind) || isShiftOperatorOrHigher(kind);
	  }
	  function isEqualityOperator(kind) {
	    return kind === 35 /* EqualsEqualsToken */ || kind === 37 /* EqualsEqualsEqualsToken */ || kind === 36 /* ExclamationEqualsToken */ || kind === 38 /* ExclamationEqualsEqualsToken */;
	  }
	  function isEqualityOperatorOrHigher(kind) {
	    return isEqualityOperator(kind) || isRelationalOperatorOrHigher(kind);
	  }
	  function isBitwiseOperator(kind) {
	    return kind === 51 /* AmpersandToken */ || kind === 52 /* BarToken */ || kind === 53 /* CaretToken */;
	  }
	  function isBitwiseOperatorOrHigher(kind) {
	    return isBitwiseOperator(kind) || isEqualityOperatorOrHigher(kind);
	  }
	  function isLogicalOperator2(kind) {
	    return kind === 56 /* AmpersandAmpersandToken */ || kind === 57 /* BarBarToken */;
	  }
	  function isLogicalOperatorOrHigher(kind) {
	    return isLogicalOperator2(kind) || isBitwiseOperatorOrHigher(kind);
	  }
	  function isAssignmentOperatorOrHigher(kind) {
	    return kind === 61 /* QuestionQuestionToken */ || isLogicalOperatorOrHigher(kind) || isAssignmentOperator(kind);
	  }
	  function isBinaryOperator(kind) {
	    return isAssignmentOperatorOrHigher(kind) || kind === 28 /* CommaToken */;
	  }
	  function isBinaryOperatorToken(node) {
	    return isBinaryOperator(node.kind);
	  }
	  function createBinaryExpressionTrampoline(onEnter, onLeft, onOperator, onRight, onExit, foldState) {
	    const machine = new BinaryExpressionStateMachine(onEnter, onLeft, onOperator, onRight, onExit, foldState);
	    return trampoline;
	    function trampoline(node, outerState) {
	      const resultHolder = { value: void 0 };
	      const stateStack = [BinaryExpressionState.enter];
	      const nodeStack = [node];
	      const userStateStack = [void 0];
	      let stackIndex = 0;
	      while (stateStack[stackIndex] !== BinaryExpressionState.done) {
	        stackIndex = stateStack[stackIndex](machine, stackIndex, stateStack, nodeStack, userStateStack, resultHolder, outerState);
	      }
	      Debug.assertEqual(stackIndex, 0);
	      return resultHolder.value;
	    }
	  }
	  function isExportOrDefaultKeywordKind(kind) {
	    return kind === 95 /* ExportKeyword */ || kind === 90 /* DefaultKeyword */;
	  }
	  function isExportOrDefaultModifier(node) {
	    const kind = node.kind;
	    return isExportOrDefaultKeywordKind(kind);
	  }
	  function isNonExportDefaultModifier(node) {
	    const kind = node.kind;
	    return isModifierKind(kind) && !isExportOrDefaultKeywordKind(kind);
	  }
	  function elideNodes(factory2, nodes) {
	    if (nodes === void 0)
	      return void 0;
	    if (nodes.length === 0)
	      return nodes;
	    return setTextRange(factory2.createNodeArray([], nodes.hasTrailingComma), nodes);
	  }
	  function getNodeForGeneratedName(name) {
	    var _a;
	    const autoGenerate = name.emitNode.autoGenerate;
	    if (autoGenerate.flags & 4 /* Node */) {
	      const autoGenerateId = autoGenerate.id;
	      let node = name;
	      let original = node.original;
	      while (original) {
	        node = original;
	        const autoGenerate2 = (_a = node.emitNode) == null ? void 0 : _a.autoGenerate;
	        if (isMemberName(node) && (autoGenerate2 === void 0 || !!(autoGenerate2.flags & 4 /* Node */) && autoGenerate2.id !== autoGenerateId)) {
	          break;
	        }
	        original = node.original;
	      }
	      return node;
	    }
	    return name;
	  }
	  function formatGeneratedNamePart(part, generateName) {
	    return typeof part === "object" ? formatGeneratedName(
	      /*privateName*/
	      false,
	      part.prefix,
	      part.node,
	      part.suffix,
	      generateName
	    ) : typeof part === "string" ? part.length > 0 && part.charCodeAt(0) === 35 /* hash */ ? part.slice(1) : part : "";
	  }
	  function formatIdentifier(name, generateName) {
	    return typeof name === "string" ? name : formatIdentifierWorker(name, Debug.checkDefined(generateName));
	  }
	  function formatIdentifierWorker(node, generateName) {
	    return isGeneratedPrivateIdentifier(node) ? generateName(node).slice(1) : isGeneratedIdentifier(node) ? generateName(node) : isPrivateIdentifier(node) ? node.escapedText.slice(1) : idText(node);
	  }
	  function formatGeneratedName(privateName, prefix, baseName, suffix, generateName) {
	    prefix = formatGeneratedNamePart(prefix, generateName);
	    suffix = formatGeneratedNamePart(suffix, generateName);
	    baseName = formatIdentifier(baseName, generateName);
	    return `${privateName ? "#" : ""}${prefix}${baseName}${suffix}`;
	  }
	  function createAccessorPropertyBackingField(factory2, node, modifiers, initializer) {
	    return factory2.updatePropertyDeclaration(
	      node,
	      modifiers,
	      factory2.getGeneratedPrivateNameForNode(
	        node.name,
	        /*prefix*/
	        void 0,
	        "_accessor_storage"
	      ),
	      /*questionOrExclamationToken*/
	      void 0,
	      /*type*/
	      void 0,
	      initializer
	    );
	  }
	  function createAccessorPropertyGetRedirector(factory2, node, modifiers, name, receiver = factory2.createThis()) {
	    return factory2.createGetAccessorDeclaration(
	      modifiers,
	      name,
	      [],
	      /*type*/
	      void 0,
	      factory2.createBlock([
	        factory2.createReturnStatement(
	          factory2.createPropertyAccessExpression(
	            receiver,
	            factory2.getGeneratedPrivateNameForNode(
	              node.name,
	              /*prefix*/
	              void 0,
	              "_accessor_storage"
	            )
	          )
	        )
	      ])
	    );
	  }
	  function createAccessorPropertySetRedirector(factory2, node, modifiers, name, receiver = factory2.createThis()) {
	    return factory2.createSetAccessorDeclaration(
	      modifiers,
	      name,
	      [factory2.createParameterDeclaration(
	        /*modifiers*/
	        void 0,
	        /*dotDotDotToken*/
	        void 0,
	        "value"
	      )],
	      factory2.createBlock([
	        factory2.createExpressionStatement(
	          factory2.createAssignment(
	            factory2.createPropertyAccessExpression(
	              receiver,
	              factory2.getGeneratedPrivateNameForNode(
	                node.name,
	                /*prefix*/
	                void 0,
	                "_accessor_storage"
	              )
	            ),
	            factory2.createIdentifier("value")
	          )
	        )
	      ])
	    );
	  }
	  function findComputedPropertyNameCacheAssignment(name) {
	    let node = name.expression;
	    while (true) {
	      node = skipOuterExpressions(node);
	      if (isCommaListExpression(node)) {
	        node = last(node.elements);
	        continue;
	      }
	      if (isCommaExpression(node)) {
	        node = node.right;
	        continue;
	      }
	      if (isAssignmentExpression(
	        node,
	        /*excludeCompoundAssignment*/
	        true
	      ) && isGeneratedIdentifier(node.left)) {
	        return node;
	      }
	      break;
	    }
	  }
	  function isSyntheticParenthesizedExpression(node) {
	    return isParenthesizedExpression(node) && nodeIsSynthesized(node) && !node.emitNode;
	  }
	  function flattenCommaListWorker(node, expressions) {
	    if (isSyntheticParenthesizedExpression(node)) {
	      flattenCommaListWorker(node.expression, expressions);
	    } else if (isCommaExpression(node)) {
	      flattenCommaListWorker(node.left, expressions);
	      flattenCommaListWorker(node.right, expressions);
	    } else if (isCommaListExpression(node)) {
	      for (const child of node.elements) {
	        flattenCommaListWorker(child, expressions);
	      }
	    } else {
	      expressions.push(node);
	    }
	  }
	  function flattenCommaList(node) {
	    const expressions = [];
	    flattenCommaListWorker(node, expressions);
	    return expressions;
	  }
	  function containsObjectRestOrSpread(node) {
	    if (node.transformFlags & 65536 /* ContainsObjectRestOrSpread */)
	      return true;
	    if (node.transformFlags & 128 /* ContainsES2018 */) {
	      for (const element of getElementsOfBindingOrAssignmentPattern(node)) {
	        const target = getTargetOfBindingOrAssignmentElement(element);
	        if (target && isAssignmentPattern(target)) {
	          if (target.transformFlags & 65536 /* ContainsObjectRestOrSpread */) {
	            return true;
	          }
	          if (target.transformFlags & 128 /* ContainsES2018 */) {
	            if (containsObjectRestOrSpread(target))
	              return true;
	          }
	        }
	      }
	    }
	    return false;
	  }
	  var BinaryExpressionState, BinaryExpressionStateMachine;
	  var init_utilities2 = __esm({
	    "src/compiler/factory/utilities.ts"() {
	      init_ts2();
	      ((BinaryExpressionState2) => {
	        function enter(machine, stackIndex, stateStack, nodeStack, userStateStack, _resultHolder, outerState) {
	          const prevUserState = stackIndex > 0 ? userStateStack[stackIndex - 1] : void 0;
	          Debug.assertEqual(stateStack[stackIndex], enter);
	          userStateStack[stackIndex] = machine.onEnter(nodeStack[stackIndex], prevUserState, outerState);
	          stateStack[stackIndex] = nextState(machine, enter);
	          return stackIndex;
	        }
	        BinaryExpressionState2.enter = enter;
	        function left(machine, stackIndex, stateStack, nodeStack, userStateStack, _resultHolder, _outerState) {
	          Debug.assertEqual(stateStack[stackIndex], left);
	          Debug.assertIsDefined(machine.onLeft);
	          stateStack[stackIndex] = nextState(machine, left);
	          const nextNode = machine.onLeft(nodeStack[stackIndex].left, userStateStack[stackIndex], nodeStack[stackIndex]);
	          if (nextNode) {
	            checkCircularity(stackIndex, nodeStack, nextNode);
	            return pushStack(stackIndex, stateStack, nodeStack, userStateStack, nextNode);
	          }
	          return stackIndex;
	        }
	        BinaryExpressionState2.left = left;
	        function operator(machine, stackIndex, stateStack, nodeStack, userStateStack, _resultHolder, _outerState) {
	          Debug.assertEqual(stateStack[stackIndex], operator);
	          Debug.assertIsDefined(machine.onOperator);
	          stateStack[stackIndex] = nextState(machine, operator);
	          machine.onOperator(nodeStack[stackIndex].operatorToken, userStateStack[stackIndex], nodeStack[stackIndex]);
	          return stackIndex;
	        }
	        BinaryExpressionState2.operator = operator;
	        function right(machine, stackIndex, stateStack, nodeStack, userStateStack, _resultHolder, _outerState) {
	          Debug.assertEqual(stateStack[stackIndex], right);
	          Debug.assertIsDefined(machine.onRight);
	          stateStack[stackIndex] = nextState(machine, right);
	          const nextNode = machine.onRight(nodeStack[stackIndex].right, userStateStack[stackIndex], nodeStack[stackIndex]);
	          if (nextNode) {
	            checkCircularity(stackIndex, nodeStack, nextNode);
	            return pushStack(stackIndex, stateStack, nodeStack, userStateStack, nextNode);
	          }
	          return stackIndex;
	        }
	        BinaryExpressionState2.right = right;
	        function exit(machine, stackIndex, stateStack, nodeStack, userStateStack, resultHolder, _outerState) {
	          Debug.assertEqual(stateStack[stackIndex], exit);
	          stateStack[stackIndex] = nextState(machine, exit);
	          const result = machine.onExit(nodeStack[stackIndex], userStateStack[stackIndex]);
	          if (stackIndex > 0) {
	            stackIndex--;
	            if (machine.foldState) {
	              const side = stateStack[stackIndex] === exit ? "right" : "left";
	              userStateStack[stackIndex] = machine.foldState(userStateStack[stackIndex], result, side);
	            }
	          } else {
	            resultHolder.value = result;
	          }
	          return stackIndex;
	        }
	        BinaryExpressionState2.exit = exit;
	        function done(_machine, stackIndex, stateStack, _nodeStack, _userStateStack, _resultHolder, _outerState) {
	          Debug.assertEqual(stateStack[stackIndex], done);
	          return stackIndex;
	        }
	        BinaryExpressionState2.done = done;
	        function nextState(machine, currentState) {
	          switch (currentState) {
	            case enter:
	              if (machine.onLeft)
	                return left;
	            case left:
	              if (machine.onOperator)
	                return operator;
	            case operator:
	              if (machine.onRight)
	                return right;
	            case right:
	              return exit;
	            case exit:
	              return done;
	            case done:
	              return done;
	            default:
	              Debug.fail("Invalid state");
	          }
	        }
	        BinaryExpressionState2.nextState = nextState;
	        function pushStack(stackIndex, stateStack, nodeStack, userStateStack, node) {
	          stackIndex++;
	          stateStack[stackIndex] = enter;
	          nodeStack[stackIndex] = node;
	          userStateStack[stackIndex] = void 0;
	          return stackIndex;
	        }
	        function checkCircularity(stackIndex, nodeStack, node) {
	          if (Debug.shouldAssert(2 /* Aggressive */)) {
	            while (stackIndex >= 0) {
	              Debug.assert(nodeStack[stackIndex] !== node, "Circular traversal detected.");
	              stackIndex--;
	            }
	          }
	        }
	      })(BinaryExpressionState || (BinaryExpressionState = {}));
	      BinaryExpressionStateMachine = class {
	        constructor(onEnter, onLeft, onOperator, onRight, onExit, foldState) {
	          this.onEnter = onEnter;
	          this.onLeft = onLeft;
	          this.onOperator = onOperator;
	          this.onRight = onRight;
	          this.onExit = onExit;
	          this.foldState = foldState;
	        }
	      };
	    }
	  });

	  // src/compiler/factory/utilitiesPublic.ts
	  function setTextRange(range, location) {
	    return location ? setTextRangePosEnd(range, location.pos, location.end) : range;
	  }
	  function canHaveModifiers(node) {
	    const kind = node.kind;
	    return kind === 168 /* TypeParameter */ || kind === 169 /* Parameter */ || kind === 171 /* PropertySignature */ || kind === 172 /* PropertyDeclaration */ || kind === 173 /* MethodSignature */ || kind === 174 /* MethodDeclaration */ || kind === 176 /* Constructor */ || kind === 177 /* GetAccessor */ || kind === 178 /* SetAccessor */ || kind === 181 /* IndexSignature */ || kind === 185 /* ConstructorType */ || kind === 218 /* FunctionExpression */ || kind === 219 /* ArrowFunction */ || kind === 231 /* ClassExpression */ || kind === 243 /* VariableStatement */ || kind === 262 /* FunctionDeclaration */ || kind === 263 /* ClassDeclaration */ || kind === 264 /* InterfaceDeclaration */ || kind === 265 /* TypeAliasDeclaration */ || kind === 266 /* EnumDeclaration */ || kind === 267 /* ModuleDeclaration */ || kind === 271 /* ImportEqualsDeclaration */ || kind === 272 /* ImportDeclaration */ || kind === 277 /* ExportAssignment */ || kind === 278 /* ExportDeclaration */;
	  }
	  function canHaveDecorators(node) {
	    const kind = node.kind;
	    return kind === 169 /* Parameter */ || kind === 172 /* PropertyDeclaration */ || kind === 174 /* MethodDeclaration */ || kind === 177 /* GetAccessor */ || kind === 178 /* SetAccessor */ || kind === 231 /* ClassExpression */ || kind === 263 /* ClassDeclaration */;
	  }
	  var init_utilitiesPublic2 = __esm({
	    "src/compiler/factory/utilitiesPublic.ts"() {
	      init_ts2();
	    }
	  });

	  // src/compiler/parser.ts
	  function visitNode2(cbNode, node) {
	    return node && cbNode(node);
	  }
	  function visitNodes(cbNode, cbNodes, nodes) {
	    if (nodes) {
	      if (cbNodes) {
	        return cbNodes(nodes);
	      }
	      for (const node of nodes) {
	        const result = cbNode(node);
	        if (result) {
	          return result;
	        }
	      }
	    }
	  }
	  function isJSDocLikeText(text, start) {
	    return text.charCodeAt(start + 1) === 42 /* asterisk */ && text.charCodeAt(start + 2) === 42 /* asterisk */ && text.charCodeAt(start + 3) !== 47 /* slash */;
	  }
	  function isFileProbablyExternalModule(sourceFile) {
	    return forEach(sourceFile.statements, isAnExternalModuleIndicatorNode) || getImportMetaIfNecessary(sourceFile);
	  }
	  function isAnExternalModuleIndicatorNode(node) {
	    return canHaveModifiers(node) && hasModifierOfKind(node, 95 /* ExportKeyword */) || isImportEqualsDeclaration(node) && isExternalModuleReference(node.moduleReference) || isImportDeclaration(node) || isExportAssignment(node) || isExportDeclaration(node) ? node : void 0;
	  }
	  function getImportMetaIfNecessary(sourceFile) {
	    return sourceFile.flags & 8388608 /* PossiblyContainsImportMeta */ ? walkTreeForImportMeta(sourceFile) : void 0;
	  }
	  function walkTreeForImportMeta(node) {
	    return isImportMeta2(node) ? node : forEachChild(node, walkTreeForImportMeta);
	  }
	  function hasModifierOfKind(node, kind) {
	    return some(node.modifiers, (m) => m.kind === kind);
	  }
	  function isImportMeta2(node) {
	    return isMetaProperty(node) && node.keywordToken === 102 /* ImportKeyword */ && node.name.escapedText === "meta";
	  }
	  function forEachChildInCallOrConstructSignature(node, cbNode, cbNodes) {
	    return visitNodes(cbNode, cbNodes, node.typeParameters) || visitNodes(cbNode, cbNodes, node.parameters) || visitNode2(cbNode, node.type);
	  }
	  function forEachChildInUnionOrIntersectionType(node, cbNode, cbNodes) {
	    return visitNodes(cbNode, cbNodes, node.types);
	  }
	  function forEachChildInParenthesizedTypeOrTypeOperator(node, cbNode, _cbNodes) {
	    return visitNode2(cbNode, node.type);
	  }
	  function forEachChildInObjectOrArrayBindingPattern(node, cbNode, cbNodes) {
	    return visitNodes(cbNode, cbNodes, node.elements);
	  }
	  function forEachChildInCallOrNewExpression(node, cbNode, cbNodes) {
	    return visitNode2(cbNode, node.expression) || // TODO: should we separate these branches out?
	    visitNode2(cbNode, node.questionDotToken) || visitNodes(cbNode, cbNodes, node.typeArguments) || visitNodes(cbNode, cbNodes, node.arguments);
	  }
	  function forEachChildInBlock(node, cbNode, cbNodes) {
	    return visitNodes(cbNode, cbNodes, node.statements);
	  }
	  function forEachChildInContinueOrBreakStatement(node, cbNode, _cbNodes) {
	    return visitNode2(cbNode, node.label);
	  }
	  function forEachChildInClassDeclarationOrExpression(node, cbNode, cbNodes) {
	    return visitNodes(cbNode, cbNodes, node.modifiers) || visitNode2(cbNode, node.name) || visitNodes(cbNode, cbNodes, node.typeParameters) || visitNodes(cbNode, cbNodes, node.heritageClauses) || visitNodes(cbNode, cbNodes, node.members);
	  }
	  function forEachChildInNamedImportsOrExports(node, cbNode, cbNodes) {
	    return visitNodes(cbNode, cbNodes, node.elements);
	  }
	  function forEachChildInImportOrExportSpecifier(node, cbNode, _cbNodes) {
	    return visitNode2(cbNode, node.propertyName) || visitNode2(cbNode, node.name);
	  }
	  function forEachChildInJsxOpeningOrSelfClosingElement(node, cbNode, cbNodes) {
	    return visitNode2(cbNode, node.tagName) || visitNodes(cbNode, cbNodes, node.typeArguments) || visitNode2(cbNode, node.attributes);
	  }
	  function forEachChildInOptionalRestOrJSDocParameterModifier(node, cbNode, _cbNodes) {
	    return visitNode2(cbNode, node.type);
	  }
	  function forEachChildInJSDocParameterOrPropertyTag(node, cbNode, cbNodes) {
	    return visitNode2(cbNode, node.tagName) || (node.isNameFirst ? visitNode2(cbNode, node.name) || visitNode2(cbNode, node.typeExpression) : visitNode2(cbNode, node.typeExpression) || visitNode2(cbNode, node.name)) || (typeof node.comment === "string" ? void 0 : visitNodes(cbNode, cbNodes, node.comment));
	  }
	  function forEachChildInJSDocTypeLikeTag(node, cbNode, cbNodes) {
	    return visitNode2(cbNode, node.tagName) || visitNode2(cbNode, node.typeExpression) || (typeof node.comment === "string" ? void 0 : visitNodes(cbNode, cbNodes, node.comment));
	  }
	  function forEachChildInJSDocLinkCodeOrPlain(node, cbNode, _cbNodes) {
	    return visitNode2(cbNode, node.name);
	  }
	  function forEachChildInJSDocTag(node, cbNode, cbNodes) {
	    return visitNode2(cbNode, node.tagName) || (typeof node.comment === "string" ? void 0 : visitNodes(cbNode, cbNodes, node.comment));
	  }
	  function forEachChildInPartiallyEmittedExpression(node, cbNode, _cbNodes) {
	    return visitNode2(cbNode, node.expression);
	  }
	  function forEachChild(node, cbNode, cbNodes) {
	    if (node === void 0 || node.kind <= 165 /* LastToken */) {
	      return;
	    }
	    const fn = forEachChildTable[node.kind];
	    return fn === void 0 ? void 0 : fn(node, cbNode, cbNodes);
	  }
	  function forEachChildRecursively(rootNode, cbNode, cbNodes) {
	    const queue = gatherPossibleChildren(rootNode);
	    const parents = [];
	    while (parents.length < queue.length) {
	      parents.push(rootNode);
	    }
	    while (queue.length !== 0) {
	      const current = queue.pop();
	      const parent2 = parents.pop();
	      if (isArray(current)) {
	        if (cbNodes) {
	          const res = cbNodes(current, parent2);
	          if (res) {
	            if (res === "skip")
	              continue;
	            return res;
	          }
	        }
	        for (let i = current.length - 1; i >= 0; --i) {
	          queue.push(current[i]);
	          parents.push(parent2);
	        }
	      } else {
	        const res = cbNode(current, parent2);
	        if (res) {
	          if (res === "skip")
	            continue;
	          return res;
	        }
	        if (current.kind >= 166 /* FirstNode */) {
	          for (const child of gatherPossibleChildren(current)) {
	            queue.push(child);
	            parents.push(current);
	          }
	        }
	      }
	    }
	  }
	  function gatherPossibleChildren(node) {
	    const children = [];
	    forEachChild(node, addWorkItem, addWorkItem);
	    return children;
	    function addWorkItem(n) {
	      children.unshift(n);
	    }
	  }
	  function setExternalModuleIndicator(sourceFile) {
	    sourceFile.externalModuleIndicator = isFileProbablyExternalModule(sourceFile);
	  }
	  function createSourceFile(fileName, sourceText, languageVersionOrOptions, setParentNodes = false, scriptKind) {
	    var _a, _b, _c, _d;
	    (_a = tracing) == null ? void 0 : _a.push(
	      tracing.Phase.Parse,
	      "createSourceFile",
	      { path: fileName },
	      /*separateBeginAndEnd*/
	      true
	    );
	    mark("beforeParse");
	    let result;
	    (_b = perfLogger) == null ? void 0 : _b.logStartParseSourceFile(fileName);
	    const {
	      languageVersion,
	      setExternalModuleIndicator: overrideSetExternalModuleIndicator,
	      impliedNodeFormat: format,
	      jsDocParsingMode
	    } = typeof languageVersionOrOptions === "object" ? languageVersionOrOptions : { languageVersion: languageVersionOrOptions };
	    if (languageVersion === 100 /* JSON */) {
	      result = Parser.parseSourceFile(
	        fileName,
	        sourceText,
	        languageVersion,
	        /*syntaxCursor*/
	        void 0,
	        setParentNodes,
	        6 /* JSON */,
	        noop,
	        jsDocParsingMode
	      );
	    } else {
	      const setIndicator = format === void 0 ? overrideSetExternalModuleIndicator : (file) => {
	        file.impliedNodeFormat = format;
	        return (overrideSetExternalModuleIndicator || setExternalModuleIndicator)(file);
	      };
	      result = Parser.parseSourceFile(
	        fileName,
	        sourceText,
	        languageVersion,
	        /*syntaxCursor*/
	        void 0,
	        setParentNodes,
	        scriptKind,
	        setIndicator,
	        jsDocParsingMode
	      );
	    }
	    (_c = perfLogger) == null ? void 0 : _c.logStopParseSourceFile();
	    mark("afterParse");
	    measure("Parse", "beforeParse", "afterParse");
	    (_d = tracing) == null ? void 0 : _d.pop();
	    return result;
	  }
	  function parseIsolatedEntityName(text, languageVersion) {
	    return Parser.parseIsolatedEntityName(text, languageVersion);
	  }
	  function parseJsonText(fileName, sourceText) {
	    return Parser.parseJsonText(fileName, sourceText);
	  }
	  function isExternalModule(file) {
	    return file.externalModuleIndicator !== void 0;
	  }
	  function updateSourceFile(sourceFile, newText, textChangeRange, aggressiveChecks = false) {
	    const newSourceFile = IncrementalParser.updateSourceFile(sourceFile, newText, textChangeRange, aggressiveChecks);
	    newSourceFile.flags |= sourceFile.flags & 12582912 /* PermanentlySetIncrementalFlags */;
	    return newSourceFile;
	  }
	  function parseIsolatedJSDocComment(content, start, length2) {
	    const result = Parser.JSDocParser.parseIsolatedJSDocComment(content, start, length2);
	    if (result && result.jsDoc) {
	      Parser.fixupParentReferences(result.jsDoc);
	    }
	    return result;
	  }
	  function parseJSDocTypeExpressionForTests(content, start, length2) {
	    return Parser.JSDocParser.parseJSDocTypeExpressionForTests(content, start, length2);
	  }
	  function isDeclarationFileName(fileName) {
	    return getDeclarationFileExtension(fileName) !== void 0;
	  }
	  function getDeclarationFileExtension(fileName) {
	    const standardExtension = getAnyExtensionFromPath(
	      fileName,
	      supportedDeclarationExtensions,
	      /*ignoreCase*/
	      false
	    );
	    if (standardExtension) {
	      return standardExtension;
	    }
	    if (fileExtensionIs(fileName, ".ts" /* Ts */)) {
	      const index = getBaseFileName(fileName).lastIndexOf(".d.");
	      if (index >= 0) {
	        return fileName.substring(index);
	      }
	    }
	    return void 0;
	  }
	  function parseResolutionMode(mode, pos, end, reportDiagnostic) {
	    if (!mode) {
	      return void 0;
	    }
	    if (mode === "import") {
	      return 99 /* ESNext */;
	    }
	    if (mode === "require") {
	      return 1 /* CommonJS */;
	    }
	    reportDiagnostic(pos, end - pos, Diagnostics.resolution_mode_should_be_either_require_or_import);
	    return void 0;
	  }
	  function processCommentPragmas(context, sourceText) {
	    const pragmas = [];
	    for (const range of getLeadingCommentRanges(sourceText, 0) || emptyArray) {
	      const comment = sourceText.substring(range.pos, range.end);
	      extractPragmas(pragmas, range, comment);
	    }
	    context.pragmas = /* @__PURE__ */ new Map();
	    for (const pragma of pragmas) {
	      if (context.pragmas.has(pragma.name)) {
	        const currentValue = context.pragmas.get(pragma.name);
	        if (currentValue instanceof Array) {
	          currentValue.push(pragma.args);
	        } else {
	          context.pragmas.set(pragma.name, [currentValue, pragma.args]);
	        }
	        continue;
	      }
	      context.pragmas.set(pragma.name, pragma.args);
	    }
	  }
	  function processPragmasIntoFields(context, reportDiagnostic) {
	    context.checkJsDirective = void 0;
	    context.referencedFiles = [];
	    context.typeReferenceDirectives = [];
	    context.libReferenceDirectives = [];
	    context.amdDependencies = [];
	    context.hasNoDefaultLib = false;
	    context.pragmas.forEach((entryOrList, key) => {
	      switch (key) {
	        case "reference": {
	          const referencedFiles = context.referencedFiles;
	          const typeReferenceDirectives = context.typeReferenceDirectives;
	          const libReferenceDirectives = context.libReferenceDirectives;
	          forEach(toArray(entryOrList), (arg) => {
	            const { types, lib, path, ["resolution-mode"]: res } = arg.arguments;
	            if (arg.arguments["no-default-lib"]) {
	              context.hasNoDefaultLib = true;
	            } else if (types) {
	              const parsed = parseResolutionMode(res, types.pos, types.end, reportDiagnostic);
	              typeReferenceDirectives.push({ pos: types.pos, end: types.end, fileName: types.value, ...parsed ? { resolutionMode: parsed } : {} });
	            } else if (lib) {
	              libReferenceDirectives.push({ pos: lib.pos, end: lib.end, fileName: lib.value });
	            } else if (path) {
	              referencedFiles.push({ pos: path.pos, end: path.end, fileName: path.value });
	            } else {
	              reportDiagnostic(arg.range.pos, arg.range.end - arg.range.pos, Diagnostics.Invalid_reference_directive_syntax);
	            }
	          });
	          break;
	        }
	        case "amd-dependency": {
	          context.amdDependencies = map(
	            toArray(entryOrList),
	            (x) => ({ name: x.arguments.name, path: x.arguments.path })
	          );
	          break;
	        }
	        case "amd-module": {
	          if (entryOrList instanceof Array) {
	            for (const entry of entryOrList) {
	              if (context.moduleName) {
	                reportDiagnostic(entry.range.pos, entry.range.end - entry.range.pos, Diagnostics.An_AMD_module_cannot_have_multiple_name_assignments);
	              }
	              context.moduleName = entry.arguments.name;
	            }
	          } else {
	            context.moduleName = entryOrList.arguments.name;
	          }
	          break;
	        }
	        case "ts-nocheck":
	        case "ts-check": {
	          forEach(toArray(entryOrList), (entry) => {
	            if (!context.checkJsDirective || entry.range.pos > context.checkJsDirective.pos) {
	              context.checkJsDirective = {
	                enabled: key === "ts-check",
	                end: entry.range.end,
	                pos: entry.range.pos
	              };
	            }
	          });
	          break;
	        }
	        case "jsx":
	        case "jsxfrag":
	        case "jsximportsource":
	        case "jsxruntime":
	          return;
	        default:
	          Debug.fail("Unhandled pragma kind");
	      }
	    });
	  }
	  function getNamedArgRegEx(name) {
	    if (namedArgRegExCache.has(name)) {
	      return namedArgRegExCache.get(name);
	    }
	    const result = new RegExp(`(\\s${name}\\s*=\\s*)(?:(?:'([^']*)')|(?:"([^"]*)"))`, "im");
	    namedArgRegExCache.set(name, result);
	    return result;
	  }
	  function extractPragmas(pragmas, range, text) {
	    const tripleSlash = range.kind === 2 /* SingleLineCommentTrivia */ && tripleSlashXMLCommentStartRegEx.exec(text);
	    if (tripleSlash) {
	      const name = tripleSlash[1].toLowerCase();
	      const pragma = commentPragmas[name];
	      if (!pragma || !(pragma.kind & 1 /* TripleSlashXML */)) {
	        return;
	      }
	      if (pragma.args) {
	        const argument = {};
	        for (const arg of pragma.args) {
	          const matcher = getNamedArgRegEx(arg.name);
	          const matchResult = matcher.exec(text);
	          if (!matchResult && !arg.optional) {
	            return;
	          } else if (matchResult) {
	            const value = matchResult[2] || matchResult[3];
	            if (arg.captureSpan) {
	              const startPos = range.pos + matchResult.index + matchResult[1].length + 1;
	              argument[arg.name] = {
	                value,
	                pos: startPos,
	                end: startPos + value.length
	              };
	            } else {
	              argument[arg.name] = value;
	            }
	          }
	        }
	        pragmas.push({ name, args: { arguments: argument, range } });
	      } else {
	        pragmas.push({ name, args: { arguments: {}, range } });
	      }
	      return;
	    }
	    const singleLine = range.kind === 2 /* SingleLineCommentTrivia */ && singleLinePragmaRegEx.exec(text);
	    if (singleLine) {
	      return addPragmaForMatch(pragmas, range, 2 /* SingleLine */, singleLine);
	    }
	    if (range.kind === 3 /* MultiLineCommentTrivia */) {
	      const multiLinePragmaRegEx = /@(\S+)(\s+.*)?$/gim;
	      let multiLineMatch;
	      while (multiLineMatch = multiLinePragmaRegEx.exec(text)) {
	        addPragmaForMatch(pragmas, range, 4 /* MultiLine */, multiLineMatch);
	      }
	    }
	  }
	  function addPragmaForMatch(pragmas, range, kind, match) {
	    if (!match)
	      return;
	    const name = match[1].toLowerCase();
	    const pragma = commentPragmas[name];
	    if (!pragma || !(pragma.kind & kind)) {
	      return;
	    }
	    const args = match[2];
	    const argument = getNamedPragmaArguments(pragma, args);
	    if (argument === "fail")
	      return;
	    pragmas.push({ name, args: { arguments: argument, range } });
	    return;
	  }
	  function getNamedPragmaArguments(pragma, text) {
	    if (!text)
	      return {};
	    if (!pragma.args)
	      return {};
	    const args = text.trim().split(/\s+/);
	    const argMap = {};
	    for (let i = 0; i < pragma.args.length; i++) {
	      const argument = pragma.args[i];
	      if (!args[i] && !argument.optional) {
	        return "fail";
	      }
	      if (argument.captureSpan) {
	        return Debug.fail("Capture spans not yet implemented for non-xml pragmas");
	      }
	      argMap[argument.name] = args[i];
	    }
	    return argMap;
	  }
	  function tagNamesAreEquivalent(lhs, rhs) {
	    if (lhs.kind !== rhs.kind) {
	      return false;
	    }
	    if (lhs.kind === 80 /* Identifier */) {
	      return lhs.escapedText === rhs.escapedText;
	    }
	    if (lhs.kind === 110 /* ThisKeyword */) {
	      return true;
	    }
	    if (lhs.kind === 295 /* JsxNamespacedName */) {
	      return lhs.namespace.escapedText === rhs.namespace.escapedText && lhs.name.escapedText === rhs.name.escapedText;
	    }
	    return lhs.name.escapedText === rhs.name.escapedText && tagNamesAreEquivalent(lhs.expression, rhs.expression);
	  }
	  var NodeConstructor, TokenConstructor, IdentifierConstructor, PrivateIdentifierConstructor, SourceFileConstructor, parseBaseNodeFactory, parseNodeFactory, forEachChildTable, Parser, IncrementalParser, namedArgRegExCache, tripleSlashXMLCommentStartRegEx, singleLinePragmaRegEx;
	  var init_parser = __esm({
	    "src/compiler/parser.ts"() {
	      init_ts2();
	      init_ts_performance();
	      parseBaseNodeFactory = {
	        createBaseSourceFileNode: (kind) => new (SourceFileConstructor || (SourceFileConstructor = objectAllocator.getSourceFileConstructor()))(kind, -1, -1),
	        createBaseIdentifierNode: (kind) => new (IdentifierConstructor || (IdentifierConstructor = objectAllocator.getIdentifierConstructor()))(kind, -1, -1),
	        createBasePrivateIdentifierNode: (kind) => new (PrivateIdentifierConstructor || (PrivateIdentifierConstructor = objectAllocator.getPrivateIdentifierConstructor()))(kind, -1, -1),
	        createBaseTokenNode: (kind) => new (TokenConstructor || (TokenConstructor = objectAllocator.getTokenConstructor()))(kind, -1, -1),
	        createBaseNode: (kind) => new (NodeConstructor || (NodeConstructor = objectAllocator.getNodeConstructor()))(kind, -1, -1)
	      };
	      parseNodeFactory = createNodeFactory(1 /* NoParenthesizerRules */, parseBaseNodeFactory);
	      forEachChildTable = {
	        [166 /* QualifiedName */]: function forEachChildInQualifiedName(node, cbNode, _cbNodes) {
	          return visitNode2(cbNode, node.left) || visitNode2(cbNode, node.right);
	        },
	        [168 /* TypeParameter */]: function forEachChildInTypeParameter(node, cbNode, cbNodes) {
	          return visitNodes(cbNode, cbNodes, node.modifiers) || visitNode2(cbNode, node.name) || visitNode2(cbNode, node.constraint) || visitNode2(cbNode, node.default) || visitNode2(cbNode, node.expression);
	        },
	        [304 /* ShorthandPropertyAssignment */]: function forEachChildInShorthandPropertyAssignment(node, cbNode, cbNodes) {
	          return visitNodes(cbNode, cbNodes, node.modifiers) || visitNode2(cbNode, node.name) || visitNode2(cbNode, node.questionToken) || visitNode2(cbNode, node.exclamationToken) || visitNode2(cbNode, node.equalsToken) || visitNode2(cbNode, node.objectAssignmentInitializer);
	        },
	        [305 /* SpreadAssignment */]: function forEachChildInSpreadAssignment(node, cbNode, _cbNodes) {
	          return visitNode2(cbNode, node.expression);
	        },
	        [169 /* Parameter */]: function forEachChildInParameter(node, cbNode, cbNodes) {
	          return visitNodes(cbNode, cbNodes, node.modifiers) || visitNode2(cbNode, node.dotDotDotToken) || visitNode2(cbNode, node.name) || visitNode2(cbNode, node.questionToken) || visitNode2(cbNode, node.type) || visitNode2(cbNode, node.initializer);
	        },
	        [172 /* PropertyDeclaration */]: function forEachChildInPropertyDeclaration(node, cbNode, cbNodes) {
	          return visitNodes(cbNode, cbNodes, node.modifiers) || visitNode2(cbNode, node.name) || visitNode2(cbNode, node.questionToken) || visitNode2(cbNode, node.exclamationToken) || visitNode2(cbNode, node.type) || visitNode2(cbNode, node.initializer);
	        },
	        [171 /* PropertySignature */]: function forEachChildInPropertySignature(node, cbNode, cbNodes) {
	          return visitNodes(cbNode, cbNodes, node.modifiers) || visitNode2(cbNode, node.name) || visitNode2(cbNode, node.questionToken) || visitNode2(cbNode, node.type) || visitNode2(cbNode, node.initializer);
	        },
	        [303 /* PropertyAssignment */]: function forEachChildInPropertyAssignment(node, cbNode, cbNodes) {
	          return visitNodes(cbNode, cbNodes, node.modifiers) || visitNode2(cbNode, node.name) || visitNode2(cbNode, node.questionToken) || visitNode2(cbNode, node.exclamationToken) || visitNode2(cbNode, node.initializer);
	        },
	        [260 /* VariableDeclaration */]: function forEachChildInVariableDeclaration(node, cbNode, _cbNodes) {
	          return visitNode2(cbNode, node.name) || visitNode2(cbNode, node.exclamationToken) || visitNode2(cbNode, node.type) || visitNode2(cbNode, node.initializer);
	        },
	        [208 /* BindingElement */]: function forEachChildInBindingElement(node, cbNode, _cbNodes) {
	          return visitNode2(cbNode, node.dotDotDotToken) || visitNode2(cbNode, node.propertyName) || visitNode2(cbNode, node.name) || visitNode2(cbNode, node.initializer);
	        },
	        [181 /* IndexSignature */]: function forEachChildInIndexSignature(node, cbNode, cbNodes) {
	          return visitNodes(cbNode, cbNodes, node.modifiers) || visitNodes(cbNode, cbNodes, node.typeParameters) || visitNodes(cbNode, cbNodes, node.parameters) || visitNode2(cbNode, node.type);
	        },
	        [185 /* ConstructorType */]: function forEachChildInConstructorType(node, cbNode, cbNodes) {
	          return visitNodes(cbNode, cbNodes, node.modifiers) || visitNodes(cbNode, cbNodes, node.typeParameters) || visitNodes(cbNode, cbNodes, node.parameters) || visitNode2(cbNode, node.type);
	        },
	        [184 /* FunctionType */]: function forEachChildInFunctionType(node, cbNode, cbNodes) {
	          return visitNodes(cbNode, cbNodes, node.modifiers) || visitNodes(cbNode, cbNodes, node.typeParameters) || visitNodes(cbNode, cbNodes, node.parameters) || visitNode2(cbNode, node.type);
	        },
	        [179 /* CallSignature */]: forEachChildInCallOrConstructSignature,
	        [180 /* ConstructSignature */]: forEachChildInCallOrConstructSignature,
	        [174 /* MethodDeclaration */]: function forEachChildInMethodDeclaration(node, cbNode, cbNodes) {
	          return visitNodes(cbNode, cbNodes, node.modifiers) || visitNode2(cbNode, node.asteriskToken) || visitNode2(cbNode, node.name) || visitNode2(cbNode, node.questionToken) || visitNode2(cbNode, node.exclamationToken) || visitNodes(cbNode, cbNodes, node.typeParameters) || visitNodes(cbNode, cbNodes, node.parameters) || visitNode2(cbNode, node.type) || visitNode2(cbNode, node.body);
	        },
	        [173 /* MethodSignature */]: function forEachChildInMethodSignature(node, cbNode, cbNodes) {
	          return visitNodes(cbNode, cbNodes, node.modifiers) || visitNode2(cbNode, node.name) || visitNode2(cbNode, node.questionToken) || visitNodes(cbNode, cbNodes, node.typeParameters) || visitNodes(cbNode, cbNodes, node.parameters) || visitNode2(cbNode, node.type);
	        },
	        [176 /* Constructor */]: function forEachChildInConstructor(node, cbNode, cbNodes) {
	          return visitNodes(cbNode, cbNodes, node.modifiers) || visitNode2(cbNode, node.name) || visitNodes(cbNode, cbNodes, node.typeParameters) || visitNodes(cbNode, cbNodes, node.parameters) || visitNode2(cbNode, node.type) || visitNode2(cbNode, node.body);
	        },
	        [177 /* GetAccessor */]: function forEachChildInGetAccessor(node, cbNode, cbNodes) {
	          return visitNodes(cbNode, cbNodes, node.modifiers) || visitNode2(cbNode, node.name) || visitNodes(cbNode, cbNodes, node.typeParameters) || visitNodes(cbNode, cbNodes, node.parameters) || visitNode2(cbNode, node.type) || visitNode2(cbNode, node.body);
	        },
	        [178 /* SetAccessor */]: function forEachChildInSetAccessor(node, cbNode, cbNodes) {
	          return visitNodes(cbNode, cbNodes, node.modifiers) || visitNode2(cbNode, node.name) || visitNodes(cbNode, cbNodes, node.typeParameters) || visitNodes(cbNode, cbNodes, node.parameters) || visitNode2(cbNode, node.type) || visitNode2(cbNode, node.body);
	        },
	        [262 /* FunctionDeclaration */]: function forEachChildInFunctionDeclaration(node, cbNode, cbNodes) {
	          return visitNodes(cbNode, cbNodes, node.modifiers) || visitNode2(cbNode, node.asteriskToken) || visitNode2(cbNode, node.name) || visitNodes(cbNode, cbNodes, node.typeParameters) || visitNodes(cbNode, cbNodes, node.parameters) || visitNode2(cbNode, node.type) || visitNode2(cbNode, node.body);
	        },
	        [218 /* FunctionExpression */]: function forEachChildInFunctionExpression(node, cbNode, cbNodes) {
	          return visitNodes(cbNode, cbNodes, node.modifiers) || visitNode2(cbNode, node.asteriskToken) || visitNode2(cbNode, node.name) || visitNodes(cbNode, cbNodes, node.typeParameters) || visitNodes(cbNode, cbNodes, node.parameters) || visitNode2(cbNode, node.type) || visitNode2(cbNode, node.body);
	        },
	        [219 /* ArrowFunction */]: function forEachChildInArrowFunction(node, cbNode, cbNodes) {
	          return visitNodes(cbNode, cbNodes, node.modifiers) || visitNodes(cbNode, cbNodes, node.typeParameters) || visitNodes(cbNode, cbNodes, node.parameters) || visitNode2(cbNode, node.type) || visitNode2(cbNode, node.equalsGreaterThanToken) || visitNode2(cbNode, node.body);
	        },
	        [175 /* ClassStaticBlockDeclaration */]: function forEachChildInClassStaticBlockDeclaration(node, cbNode, cbNodes) {
	          return visitNodes(cbNode, cbNodes, node.modifiers) || visitNode2(cbNode, node.body);
	        },
	        [183 /* TypeReference */]: function forEachChildInTypeReference(node, cbNode, cbNodes) {
	          return visitNode2(cbNode, node.typeName) || visitNodes(cbNode, cbNodes, node.typeArguments);
	        },
	        [182 /* TypePredicate */]: function forEachChildInTypePredicate(node, cbNode, _cbNodes) {
	          return visitNode2(cbNode, node.assertsModifier) || visitNode2(cbNode, node.parameterName) || visitNode2(cbNode, node.type);
	        },
	        [186 /* TypeQuery */]: function forEachChildInTypeQuery(node, cbNode, cbNodes) {
	          return visitNode2(cbNode, node.exprName) || visitNodes(cbNode, cbNodes, node.typeArguments);
	        },
	        [187 /* TypeLiteral */]: function forEachChildInTypeLiteral(node, cbNode, cbNodes) {
	          return visitNodes(cbNode, cbNodes, node.members);
	        },
	        [188 /* ArrayType */]: function forEachChildInArrayType(node, cbNode, _cbNodes) {
	          return visitNode2(cbNode, node.elementType);
	        },
	        [189 /* TupleType */]: function forEachChildInTupleType(node, cbNode, cbNodes) {
	          return visitNodes(cbNode, cbNodes, node.elements);
	        },
	        [192 /* UnionType */]: forEachChildInUnionOrIntersectionType,
	        [193 /* IntersectionType */]: forEachChildInUnionOrIntersectionType,
	        [194 /* ConditionalType */]: function forEachChildInConditionalType(node, cbNode, _cbNodes) {
	          return visitNode2(cbNode, node.checkType) || visitNode2(cbNode, node.extendsType) || visitNode2(cbNode, node.trueType) || visitNode2(cbNode, node.falseType);
	        },
	        [195 /* InferType */]: function forEachChildInInferType(node, cbNode, _cbNodes) {
	          return visitNode2(cbNode, node.typeParameter);
	        },
	        [205 /* ImportType */]: function forEachChildInImportType(node, cbNode, cbNodes) {
	          return visitNode2(cbNode, node.argument) || visitNode2(cbNode, node.attributes) || visitNode2(cbNode, node.qualifier) || visitNodes(cbNode, cbNodes, node.typeArguments);
	        },
	        [302 /* ImportTypeAssertionContainer */]: function forEachChildInImportTypeAssertionContainer(node, cbNode, _cbNodes) {
	          return visitNode2(cbNode, node.assertClause);
	        },
	        [196 /* ParenthesizedType */]: forEachChildInParenthesizedTypeOrTypeOperator,
	        [198 /* TypeOperator */]: forEachChildInParenthesizedTypeOrTypeOperator,
	        [199 /* IndexedAccessType */]: function forEachChildInIndexedAccessType(node, cbNode, _cbNodes) {
	          return visitNode2(cbNode, node.objectType) || visitNode2(cbNode, node.indexType);
	        },
	        [200 /* MappedType */]: function forEachChildInMappedType(node, cbNode, cbNodes) {
	          return visitNode2(cbNode, node.readonlyToken) || visitNode2(cbNode, node.typeParameter) || visitNode2(cbNode, node.nameType) || visitNode2(cbNode, node.questionToken) || visitNode2(cbNode, node.type) || visitNodes(cbNode, cbNodes, node.members);
	        },
	        [201 /* LiteralType */]: function forEachChildInLiteralType(node, cbNode, _cbNodes) {
	          return visitNode2(cbNode, node.literal);
	        },
	        [202 /* NamedTupleMember */]: function forEachChildInNamedTupleMember(node, cbNode, _cbNodes) {
	          return visitNode2(cbNode, node.dotDotDotToken) || visitNode2(cbNode, node.name) || visitNode2(cbNode, node.questionToken) || visitNode2(cbNode, node.type);
	        },
	        [206 /* ObjectBindingPattern */]: forEachChildInObjectOrArrayBindingPattern,
	        [207 /* ArrayBindingPattern */]: forEachChildInObjectOrArrayBindingPattern,
	        [209 /* ArrayLiteralExpression */]: function forEachChildInArrayLiteralExpression(node, cbNode, cbNodes) {
	          return visitNodes(cbNode, cbNodes, node.elements);
	        },
	        [210 /* ObjectLiteralExpression */]: function forEachChildInObjectLiteralExpression(node, cbNode, cbNodes) {
	          return visitNodes(cbNode, cbNodes, node.properties);
	        },
	        [211 /* PropertyAccessExpression */]: function forEachChildInPropertyAccessExpression(node, cbNode, _cbNodes) {
	          return visitNode2(cbNode, node.expression) || visitNode2(cbNode, node.questionDotToken) || visitNode2(cbNode, node.name);
	        },
	        [212 /* ElementAccessExpression */]: function forEachChildInElementAccessExpression(node, cbNode, _cbNodes) {
	          return visitNode2(cbNode, node.expression) || visitNode2(cbNode, node.questionDotToken) || visitNode2(cbNode, node.argumentExpression);
	        },
	        [213 /* CallExpression */]: forEachChildInCallOrNewExpression,
	        [214 /* NewExpression */]: forEachChildInCallOrNewExpression,
	        [215 /* TaggedTemplateExpression */]: function forEachChildInTaggedTemplateExpression(node, cbNode, cbNodes) {
	          return visitNode2(cbNode, node.tag) || visitNode2(cbNode, node.questionDotToken) || visitNodes(cbNode, cbNodes, node.typeArguments) || visitNode2(cbNode, node.template);
	        },
	        [216 /* TypeAssertionExpression */]: function forEachChildInTypeAssertionExpression(node, cbNode, _cbNodes) {
	          return visitNode2(cbNode, node.type) || visitNode2(cbNode, node.expression);
	        },
	        [217 /* ParenthesizedExpression */]: function forEachChildInParenthesizedExpression(node, cbNode, _cbNodes) {
	          return visitNode2(cbNode, node.expression);
	        },
	        [220 /* DeleteExpression */]: function forEachChildInDeleteExpression(node, cbNode, _cbNodes) {
	          return visitNode2(cbNode, node.expression);
	        },
	        [221 /* TypeOfExpression */]: function forEachChildInTypeOfExpression(node, cbNode, _cbNodes) {
	          return visitNode2(cbNode, node.expression);
	        },
	        [222 /* VoidExpression */]: function forEachChildInVoidExpression(node, cbNode, _cbNodes) {
	          return visitNode2(cbNode, node.expression);
	        },
	        [224 /* PrefixUnaryExpression */]: function forEachChildInPrefixUnaryExpression(node, cbNode, _cbNodes) {
	          return visitNode2(cbNode, node.operand);
	        },
	        [229 /* YieldExpression */]: function forEachChildInYieldExpression(node, cbNode, _cbNodes) {
	          return visitNode2(cbNode, node.asteriskToken) || visitNode2(cbNode, node.expression);
	        },
	        [223 /* AwaitExpression */]: function forEachChildInAwaitExpression(node, cbNode, _cbNodes) {
	          return visitNode2(cbNode, node.expression);
	        },
	        [225 /* PostfixUnaryExpression */]: function forEachChildInPostfixUnaryExpression(node, cbNode, _cbNodes) {
	          return visitNode2(cbNode, node.operand);
	        },
	        [226 /* BinaryExpression */]: function forEachChildInBinaryExpression(node, cbNode, _cbNodes) {
	          return visitNode2(cbNode, node.left) || visitNode2(cbNode, node.operatorToken) || visitNode2(cbNode, node.right);
	        },
	        [234 /* AsExpression */]: function forEachChildInAsExpression(node, cbNode, _cbNodes) {
	          return visitNode2(cbNode, node.expression) || visitNode2(cbNode, node.type);
	        },
	        [235 /* NonNullExpression */]: function forEachChildInNonNullExpression(node, cbNode, _cbNodes) {
	          return visitNode2(cbNode, node.expression);
	        },
	        [238 /* SatisfiesExpression */]: function forEachChildInSatisfiesExpression(node, cbNode, _cbNodes) {
	          return visitNode2(cbNode, node.expression) || visitNode2(cbNode, node.type);
	        },
	        [236 /* MetaProperty */]: function forEachChildInMetaProperty(node, cbNode, _cbNodes) {
	          return visitNode2(cbNode, node.name);
	        },
	        [227 /* ConditionalExpression */]: function forEachChildInConditionalExpression(node, cbNode, _cbNodes) {
	          return visitNode2(cbNode, node.condition) || visitNode2(cbNode, node.questionToken) || visitNode2(cbNode, node.whenTrue) || visitNode2(cbNode, node.colonToken) || visitNode2(cbNode, node.whenFalse);
	        },
	        [230 /* SpreadElement */]: function forEachChildInSpreadElement(node, cbNode, _cbNodes) {
	          return visitNode2(cbNode, node.expression);
	        },
	        [241 /* Block */]: forEachChildInBlock,
	        [268 /* ModuleBlock */]: forEachChildInBlock,
	        [312 /* SourceFile */]: function forEachChildInSourceFile(node, cbNode, cbNodes) {
	          return visitNodes(cbNode, cbNodes, node.statements) || visitNode2(cbNode, node.endOfFileToken);
	        },
	        [243 /* VariableStatement */]: function forEachChildInVariableStatement(node, cbNode, cbNodes) {
	          return visitNodes(cbNode, cbNodes, node.modifiers) || visitNode2(cbNode, node.declarationList);
	        },
	        [261 /* VariableDeclarationList */]: function forEachChildInVariableDeclarationList(node, cbNode, cbNodes) {
	          return visitNodes(cbNode, cbNodes, node.declarations);
	        },
	        [244 /* ExpressionStatement */]: function forEachChildInExpressionStatement(node, cbNode, _cbNodes) {
	          return visitNode2(cbNode, node.expression);
	        },
	        [245 /* IfStatement */]: function forEachChildInIfStatement(node, cbNode, _cbNodes) {
	          return visitNode2(cbNode, node.expression) || visitNode2(cbNode, node.thenStatement) || visitNode2(cbNode, node.elseStatement);
	        },
	        [246 /* DoStatement */]: function forEachChildInDoStatement(node, cbNode, _cbNodes) {
	          return visitNode2(cbNode, node.statement) || visitNode2(cbNode, node.expression);
	        },
	        [247 /* WhileStatement */]: function forEachChildInWhileStatement(node, cbNode, _cbNodes) {
	          return visitNode2(cbNode, node.expression) || visitNode2(cbNode, node.statement);
	        },
	        [248 /* ForStatement */]: function forEachChildInForStatement(node, cbNode, _cbNodes) {
	          return visitNode2(cbNode, node.initializer) || visitNode2(cbNode, node.condition) || visitNode2(cbNode, node.incrementor) || visitNode2(cbNode, node.statement);
	        },
	        [249 /* ForInStatement */]: function forEachChildInForInStatement(node, cbNode, _cbNodes) {
	          return visitNode2(cbNode, node.initializer) || visitNode2(cbNode, node.expression) || visitNode2(cbNode, node.statement);
	        },
	        [250 /* ForOfStatement */]: function forEachChildInForOfStatement(node, cbNode, _cbNodes) {
	          return visitNode2(cbNode, node.awaitModifier) || visitNode2(cbNode, node.initializer) || visitNode2(cbNode, node.expression) || visitNode2(cbNode, node.statement);
	        },
	        [251 /* ContinueStatement */]: forEachChildInContinueOrBreakStatement,
	        [252 /* BreakStatement */]: forEachChildInContinueOrBreakStatement,
	        [253 /* ReturnStatement */]: function forEachChildInReturnStatement(node, cbNode, _cbNodes) {
	          return visitNode2(cbNode, node.expression);
	        },
	        [254 /* WithStatement */]: function forEachChildInWithStatement(node, cbNode, _cbNodes) {
	          return visitNode2(cbNode, node.expression) || visitNode2(cbNode, node.statement);
	        },
	        [255 /* SwitchStatement */]: function forEachChildInSwitchStatement(node, cbNode, _cbNodes) {
	          return visitNode2(cbNode, node.expression) || visitNode2(cbNode, node.caseBlock);
	        },
	        [269 /* CaseBlock */]: function forEachChildInCaseBlock(node, cbNode, cbNodes) {
	          return visitNodes(cbNode, cbNodes, node.clauses);
	        },
	        [296 /* CaseClause */]: function forEachChildInCaseClause(node, cbNode, cbNodes) {
	          return visitNode2(cbNode, node.expression) || visitNodes(cbNode, cbNodes, node.statements);
	        },
	        [297 /* DefaultClause */]: function forEachChildInDefaultClause(node, cbNode, cbNodes) {
	          return visitNodes(cbNode, cbNodes, node.statements);
	        },
	        [256 /* LabeledStatement */]: function forEachChildInLabeledStatement(node, cbNode, _cbNodes) {
	          return visitNode2(cbNode, node.label) || visitNode2(cbNode, node.statement);
	        },
	        [257 /* ThrowStatement */]: function forEachChildInThrowStatement(node, cbNode, _cbNodes) {
	          return visitNode2(cbNode, node.expression);
	        },
	        [258 /* TryStatement */]: function forEachChildInTryStatement(node, cbNode, _cbNodes) {
	          return visitNode2(cbNode, node.tryBlock) || visitNode2(cbNode, node.catchClause) || visitNode2(cbNode, node.finallyBlock);
	        },
	        [299 /* CatchClause */]: function forEachChildInCatchClause(node, cbNode, _cbNodes) {
	          return visitNode2(cbNode, node.variableDeclaration) || visitNode2(cbNode, node.block);
	        },
	        [170 /* Decorator */]: function forEachChildInDecorator(node, cbNode, _cbNodes) {
	          return visitNode2(cbNode, node.expression);
	        },
	        [263 /* ClassDeclaration */]: forEachChildInClassDeclarationOrExpression,
	        [231 /* ClassExpression */]: forEachChildInClassDeclarationOrExpression,
	        [264 /* InterfaceDeclaration */]: function forEachChildInInterfaceDeclaration(node, cbNode, cbNodes) {
	          return visitNodes(cbNode, cbNodes, node.modifiers) || visitNode2(cbNode, node.name) || visitNodes(cbNode, cbNodes, node.typeParameters) || visitNodes(cbNode, cbNodes, node.heritageClauses) || visitNodes(cbNode, cbNodes, node.members);
	        },
	        [265 /* TypeAliasDeclaration */]: function forEachChildInTypeAliasDeclaration(node, cbNode, cbNodes) {
	          return visitNodes(cbNode, cbNodes, node.modifiers) || visitNode2(cbNode, node.name) || visitNodes(cbNode, cbNodes, node.typeParameters) || visitNode2(cbNode, node.type);
	        },
	        [266 /* EnumDeclaration */]: function forEachChildInEnumDeclaration(node, cbNode, cbNodes) {
	          return visitNodes(cbNode, cbNodes, node.modifiers) || visitNode2(cbNode, node.name) || visitNodes(cbNode, cbNodes, node.members);
	        },
	        [306 /* EnumMember */]: function forEachChildInEnumMember(node, cbNode, _cbNodes) {
	          return visitNode2(cbNode, node.name) || visitNode2(cbNode, node.initializer);
	        },
	        [267 /* ModuleDeclaration */]: function forEachChildInModuleDeclaration(node, cbNode, cbNodes) {
	          return visitNodes(cbNode, cbNodes, node.modifiers) || visitNode2(cbNode, node.name) || visitNode2(cbNode, node.body);
	        },
	        [271 /* ImportEqualsDeclaration */]: function forEachChildInImportEqualsDeclaration(node, cbNode, cbNodes) {
	          return visitNodes(cbNode, cbNodes, node.modifiers) || visitNode2(cbNode, node.name) || visitNode2(cbNode, node.moduleReference);
	        },
	        [272 /* ImportDeclaration */]: function forEachChildInImportDeclaration(node, cbNode, cbNodes) {
	          return visitNodes(cbNode, cbNodes, node.modifiers) || visitNode2(cbNode, node.importClause) || visitNode2(cbNode, node.moduleSpecifier) || visitNode2(cbNode, node.attributes);
	        },
	        [273 /* ImportClause */]: function forEachChildInImportClause(node, cbNode, _cbNodes) {
	          return visitNode2(cbNode, node.name) || visitNode2(cbNode, node.namedBindings);
	        },
	        [300 /* ImportAttributes */]: function forEachChildInImportAttributes(node, cbNode, cbNodes) {
	          return visitNodes(cbNode, cbNodes, node.elements);
	        },
	        [301 /* ImportAttribute */]: function forEachChildInImportAttribute(node, cbNode, _cbNodes) {
	          return visitNode2(cbNode, node.name) || visitNode2(cbNode, node.value);
	        },
	        [270 /* NamespaceExportDeclaration */]: function forEachChildInNamespaceExportDeclaration(node, cbNode, cbNodes) {
	          return visitNodes(cbNode, cbNodes, node.modifiers) || visitNode2(cbNode, node.name);
	        },
	        [274 /* NamespaceImport */]: function forEachChildInNamespaceImport(node, cbNode, _cbNodes) {
	          return visitNode2(cbNode, node.name);
	        },
	        [280 /* NamespaceExport */]: function forEachChildInNamespaceExport(node, cbNode, _cbNodes) {
	          return visitNode2(cbNode, node.name);
	        },
	        [275 /* NamedImports */]: forEachChildInNamedImportsOrExports,
	        [279 /* NamedExports */]: forEachChildInNamedImportsOrExports,
	        [278 /* ExportDeclaration */]: function forEachChildInExportDeclaration(node, cbNode, cbNodes) {
	          return visitNodes(cbNode, cbNodes, node.modifiers) || visitNode2(cbNode, node.exportClause) || visitNode2(cbNode, node.moduleSpecifier) || visitNode2(cbNode, node.attributes);
	        },
	        [276 /* ImportSpecifier */]: forEachChildInImportOrExportSpecifier,
	        [281 /* ExportSpecifier */]: forEachChildInImportOrExportSpecifier,
	        [277 /* ExportAssignment */]: function forEachChildInExportAssignment(node, cbNode, cbNodes) {
	          return visitNodes(cbNode, cbNodes, node.modifiers) || visitNode2(cbNode, node.expression);
	        },
	        [228 /* TemplateExpression */]: function forEachChildInTemplateExpression(node, cbNode, cbNodes) {
	          return visitNode2(cbNode, node.head) || visitNodes(cbNode, cbNodes, node.templateSpans);
	        },
	        [239 /* TemplateSpan */]: function forEachChildInTemplateSpan(node, cbNode, _cbNodes) {
	          return visitNode2(cbNode, node.expression) || visitNode2(cbNode, node.literal);
	        },
	        [203 /* TemplateLiteralType */]: function forEachChildInTemplateLiteralType(node, cbNode, cbNodes) {
	          return visitNode2(cbNode, node.head) || visitNodes(cbNode, cbNodes, node.templateSpans);
	        },
	        [204 /* TemplateLiteralTypeSpan */]: function forEachChildInTemplateLiteralTypeSpan(node, cbNode, _cbNodes) {
	          return visitNode2(cbNode, node.type) || visitNode2(cbNode, node.literal);
	        },
	        [167 /* ComputedPropertyName */]: function forEachChildInComputedPropertyName(node, cbNode, _cbNodes) {
	          return visitNode2(cbNode, node.expression);
	        },
	        [298 /* HeritageClause */]: function forEachChildInHeritageClause(node, cbNode, cbNodes) {
	          return visitNodes(cbNode, cbNodes, node.types);
	        },
	        [233 /* ExpressionWithTypeArguments */]: function forEachChildInExpressionWithTypeArguments(node, cbNode, cbNodes) {
	          return visitNode2(cbNode, node.expression) || visitNodes(cbNode, cbNodes, node.typeArguments);
	        },
	        [283 /* ExternalModuleReference */]: function forEachChildInExternalModuleReference(node, cbNode, _cbNodes) {
	          return visitNode2(cbNode, node.expression);
	        },
	        [282 /* MissingDeclaration */]: function forEachChildInMissingDeclaration(node, cbNode, cbNodes) {
	          return visitNodes(cbNode, cbNodes, node.modifiers);
	        },
	        [361 /* CommaListExpression */]: function forEachChildInCommaListExpression(node, cbNode, cbNodes) {
	          return visitNodes(cbNode, cbNodes, node.elements);
	        },
	        [284 /* JsxElement */]: function forEachChildInJsxElement(node, cbNode, cbNodes) {
	          return visitNode2(cbNode, node.openingElement) || visitNodes(cbNode, cbNodes, node.children) || visitNode2(cbNode, node.closingElement);
	        },
	        [288 /* JsxFragment */]: function forEachChildInJsxFragment(node, cbNode, cbNodes) {
	          return visitNode2(cbNode, node.openingFragment) || visitNodes(cbNode, cbNodes, node.children) || visitNode2(cbNode, node.closingFragment);
	        },
	        [285 /* JsxSelfClosingElement */]: forEachChildInJsxOpeningOrSelfClosingElement,
	        [286 /* JsxOpeningElement */]: forEachChildInJsxOpeningOrSelfClosingElement,
	        [292 /* JsxAttributes */]: function forEachChildInJsxAttributes(node, cbNode, cbNodes) {
	          return visitNodes(cbNode, cbNodes, node.properties);
	        },
	        [291 /* JsxAttribute */]: function forEachChildInJsxAttribute(node, cbNode, _cbNodes) {
	          return visitNode2(cbNode, node.name) || visitNode2(cbNode, node.initializer);
	        },
	        [293 /* JsxSpreadAttribute */]: function forEachChildInJsxSpreadAttribute(node, cbNode, _cbNodes) {
	          return visitNode2(cbNode, node.expression);
	        },
	        [294 /* JsxExpression */]: function forEachChildInJsxExpression(node, cbNode, _cbNodes) {
	          return visitNode2(cbNode, node.dotDotDotToken) || visitNode2(cbNode, node.expression);
	        },
	        [287 /* JsxClosingElement */]: function forEachChildInJsxClosingElement(node, cbNode, _cbNodes) {
	          return visitNode2(cbNode, node.tagName);
	        },
	        [295 /* JsxNamespacedName */]: function forEachChildInJsxNamespacedName(node, cbNode, _cbNodes) {
	          return visitNode2(cbNode, node.namespace) || visitNode2(cbNode, node.name);
	        },
	        [190 /* OptionalType */]: forEachChildInOptionalRestOrJSDocParameterModifier,
	        [191 /* RestType */]: forEachChildInOptionalRestOrJSDocParameterModifier,
	        [316 /* JSDocTypeExpression */]: forEachChildInOptionalRestOrJSDocParameterModifier,
	        [322 /* JSDocNonNullableType */]: forEachChildInOptionalRestOrJSDocParameterModifier,
	        [321 /* JSDocNullableType */]: forEachChildInOptionalRestOrJSDocParameterModifier,
	        [323 /* JSDocOptionalType */]: forEachChildInOptionalRestOrJSDocParameterModifier,
	        [325 /* JSDocVariadicType */]: forEachChildInOptionalRestOrJSDocParameterModifier,
	        [324 /* JSDocFunctionType */]: function forEachChildInJSDocFunctionType(node, cbNode, cbNodes) {
	          return visitNodes(cbNode, cbNodes, node.parameters) || visitNode2(cbNode, node.type);
	        },
	        [327 /* JSDoc */]: function forEachChildInJSDoc(node, cbNode, cbNodes) {
	          return (typeof node.comment === "string" ? void 0 : visitNodes(cbNode, cbNodes, node.comment)) || visitNodes(cbNode, cbNodes, node.tags);
	        },
	        [354 /* JSDocSeeTag */]: function forEachChildInJSDocSeeTag(node, cbNode, cbNodes) {
	          return visitNode2(cbNode, node.tagName) || visitNode2(cbNode, node.name) || (typeof node.comment === "string" ? void 0 : visitNodes(cbNode, cbNodes, node.comment));
	        },
	        [317 /* JSDocNameReference */]: function forEachChildInJSDocNameReference(node, cbNode, _cbNodes) {
	          return visitNode2(cbNode, node.name);
	        },
	        [318 /* JSDocMemberName */]: function forEachChildInJSDocMemberName(node, cbNode, _cbNodes) {
	          return visitNode2(cbNode, node.left) || visitNode2(cbNode, node.right);
	        },
	        [348 /* JSDocParameterTag */]: forEachChildInJSDocParameterOrPropertyTag,
	        [355 /* JSDocPropertyTag */]: forEachChildInJSDocParameterOrPropertyTag,
	        [337 /* JSDocAuthorTag */]: function forEachChildInJSDocAuthorTag(node, cbNode, cbNodes) {
	          return visitNode2(cbNode, node.tagName) || (typeof node.comment === "string" ? void 0 : visitNodes(cbNode, cbNodes, node.comment));
	        },
	        [336 /* JSDocImplementsTag */]: function forEachChildInJSDocImplementsTag(node, cbNode, cbNodes) {
	          return visitNode2(cbNode, node.tagName) || visitNode2(cbNode, node.class) || (typeof node.comment === "string" ? void 0 : visitNodes(cbNode, cbNodes, node.comment));
	        },
	        [335 /* JSDocAugmentsTag */]: function forEachChildInJSDocAugmentsTag(node, cbNode, cbNodes) {
	          return visitNode2(cbNode, node.tagName) || visitNode2(cbNode, node.class) || (typeof node.comment === "string" ? void 0 : visitNodes(cbNode, cbNodes, node.comment));
	        },
	        [352 /* JSDocTemplateTag */]: function forEachChildInJSDocTemplateTag(node, cbNode, cbNodes) {
	          return visitNode2(cbNode, node.tagName) || visitNode2(cbNode, node.constraint) || visitNodes(cbNode, cbNodes, node.typeParameters) || (typeof node.comment === "string" ? void 0 : visitNodes(cbNode, cbNodes, node.comment));
	        },
	        [353 /* JSDocTypedefTag */]: function forEachChildInJSDocTypedefTag(node, cbNode, cbNodes) {
	          return visitNode2(cbNode, node.tagName) || (node.typeExpression && node.typeExpression.kind === 316 /* JSDocTypeExpression */ ? visitNode2(cbNode, node.typeExpression) || visitNode2(cbNode, node.fullName) || (typeof node.comment === "string" ? void 0 : visitNodes(cbNode, cbNodes, node.comment)) : visitNode2(cbNode, node.fullName) || visitNode2(cbNode, node.typeExpression) || (typeof node.comment === "string" ? void 0 : visitNodes(cbNode, cbNodes, node.comment)));
	        },
	        [345 /* JSDocCallbackTag */]: function forEachChildInJSDocCallbackTag(node, cbNode, cbNodes) {
	          return visitNode2(cbNode, node.tagName) || visitNode2(cbNode, node.fullName) || visitNode2(cbNode, node.typeExpression) || (typeof node.comment === "string" ? void 0 : visitNodes(cbNode, cbNodes, node.comment));
	        },
	        [349 /* JSDocReturnTag */]: forEachChildInJSDocTypeLikeTag,
	        [351 /* JSDocTypeTag */]: forEachChildInJSDocTypeLikeTag,
	        [350 /* JSDocThisTag */]: forEachChildInJSDocTypeLikeTag,
	        [347 /* JSDocEnumTag */]: forEachChildInJSDocTypeLikeTag,
	        [357 /* JSDocSatisfiesTag */]: forEachChildInJSDocTypeLikeTag,
	        [356 /* JSDocThrowsTag */]: forEachChildInJSDocTypeLikeTag,
	        [346 /* JSDocOverloadTag */]: forEachChildInJSDocTypeLikeTag,
	        [330 /* JSDocSignature */]: function forEachChildInJSDocSignature(node, cbNode, _cbNodes) {
	          return forEach(node.typeParameters, cbNode) || forEach(node.parameters, cbNode) || visitNode2(cbNode, node.type);
	        },
	        [331 /* JSDocLink */]: forEachChildInJSDocLinkCodeOrPlain,
	        [332 /* JSDocLinkCode */]: forEachChildInJSDocLinkCodeOrPlain,
	        [333 /* JSDocLinkPlain */]: forEachChildInJSDocLinkCodeOrPlain,
	        [329 /* JSDocTypeLiteral */]: function forEachChildInJSDocTypeLiteral(node, cbNode, _cbNodes) {
	          return forEach(node.jsDocPropertyTags, cbNode);
	        },
	        [334 /* JSDocTag */]: forEachChildInJSDocTag,
	        [339 /* JSDocClassTag */]: forEachChildInJSDocTag,
	        [340 /* JSDocPublicTag */]: forEachChildInJSDocTag,
	        [341 /* JSDocPrivateTag */]: forEachChildInJSDocTag,
	        [342 /* JSDocProtectedTag */]: forEachChildInJSDocTag,
	        [343 /* JSDocReadonlyTag */]: forEachChildInJSDocTag,
	        [338 /* JSDocDeprecatedTag */]: forEachChildInJSDocTag,
	        [344 /* JSDocOverrideTag */]: forEachChildInJSDocTag,
	        [360 /* PartiallyEmittedExpression */]: forEachChildInPartiallyEmittedExpression
	      };
	      ((Parser2) => {
	        var scanner2 = createScanner(
	          99 /* Latest */,
	          /*skipTrivia*/
	          true
	        );
	        var disallowInAndDecoratorContext = 8192 /* DisallowInContext */ | 32768 /* DecoratorContext */;
	        var NodeConstructor2;
	        var TokenConstructor2;
	        var IdentifierConstructor2;
	        var PrivateIdentifierConstructor2;
	        var SourceFileConstructor2;
	        function countNode(node) {
	          nodeCount++;
	          return node;
	        }
	        var baseNodeFactory = {
	          createBaseSourceFileNode: (kind) => countNode(new SourceFileConstructor2(
	            kind,
	            /*pos*/
	            0,
	            /*end*/
	            0
	          )),
	          createBaseIdentifierNode: (kind) => countNode(new IdentifierConstructor2(
	            kind,
	            /*pos*/
	            0,
	            /*end*/
	            0
	          )),
	          createBasePrivateIdentifierNode: (kind) => countNode(new PrivateIdentifierConstructor2(
	            kind,
	            /*pos*/
	            0,
	            /*end*/
	            0
	          )),
	          createBaseTokenNode: (kind) => countNode(new TokenConstructor2(
	            kind,
	            /*pos*/
	            0,
	            /*end*/
	            0
	          )),
	          createBaseNode: (kind) => countNode(new NodeConstructor2(
	            kind,
	            /*pos*/
	            0,
	            /*end*/
	            0
	          ))
	        };
	        var factory2 = createNodeFactory(1 /* NoParenthesizerRules */ | 2 /* NoNodeConverters */ | 8 /* NoOriginalNode */, baseNodeFactory);
	        var {
	          createNodeArray: factoryCreateNodeArray,
	          createNumericLiteral: factoryCreateNumericLiteral,
	          createStringLiteral: factoryCreateStringLiteral,
	          createLiteralLikeNode: factoryCreateLiteralLikeNode,
	          createIdentifier: factoryCreateIdentifier,
	          createPrivateIdentifier: factoryCreatePrivateIdentifier,
	          createToken: factoryCreateToken,
	          createArrayLiteralExpression: factoryCreateArrayLiteralExpression,
	          createObjectLiteralExpression: factoryCreateObjectLiteralExpression,
	          createPropertyAccessExpression: factoryCreatePropertyAccessExpression,
	          createPropertyAccessChain: factoryCreatePropertyAccessChain,
	          createElementAccessExpression: factoryCreateElementAccessExpression,
	          createElementAccessChain: factoryCreateElementAccessChain,
	          createCallExpression: factoryCreateCallExpression,
	          createCallChain: factoryCreateCallChain,
	          createNewExpression: factoryCreateNewExpression,
	          createParenthesizedExpression: factoryCreateParenthesizedExpression,
	          createBlock: factoryCreateBlock,
	          createVariableStatement: factoryCreateVariableStatement,
	          createExpressionStatement: factoryCreateExpressionStatement,
	          createIfStatement: factoryCreateIfStatement,
	          createWhileStatement: factoryCreateWhileStatement,
	          createForStatement: factoryCreateForStatement,
	          createForOfStatement: factoryCreateForOfStatement,
	          createVariableDeclaration: factoryCreateVariableDeclaration,
	          createVariableDeclarationList: factoryCreateVariableDeclarationList
	        } = factory2;
	        var fileName;
	        var sourceFlags;
	        var sourceText;
	        var languageVersion;
	        var scriptKind;
	        var languageVariant;
	        var parseDiagnostics;
	        var jsDocDiagnostics;
	        var syntaxCursor;
	        var currentToken;
	        var nodeCount;
	        var identifiers;
	        var identifierCount;
	        var parsingContext;
	        var notParenthesizedArrow;
	        var contextFlags;
	        var topLevel = true;
	        var parseErrorBeforeNextFinishedNode = false;
	        function parseSourceFile(fileName2, sourceText2, languageVersion2, syntaxCursor2, setParentNodes = false, scriptKind2, setExternalModuleIndicatorOverride, jsDocParsingMode = 0 /* ParseAll */) {
	          var _a;
	          scriptKind2 = ensureScriptKind(fileName2, scriptKind2);
	          if (scriptKind2 === 6 /* JSON */) {
	            const result2 = parseJsonText2(fileName2, sourceText2, languageVersion2, syntaxCursor2, setParentNodes);
	            convertToJson(
	              result2,
	              (_a = result2.statements[0]) == null ? void 0 : _a.expression,
	              result2.parseDiagnostics,
	              /*returnValue*/
	              false,
	              /*jsonConversionNotifier*/
	              void 0
	            );
	            result2.referencedFiles = emptyArray;
	            result2.typeReferenceDirectives = emptyArray;
	            result2.libReferenceDirectives = emptyArray;
	            result2.amdDependencies = emptyArray;
	            result2.hasNoDefaultLib = false;
	            result2.pragmas = emptyMap;
	            return result2;
	          }
	          initializeState(fileName2, sourceText2, languageVersion2, syntaxCursor2, scriptKind2, jsDocParsingMode);
	          const result = parseSourceFileWorker(languageVersion2, setParentNodes, scriptKind2, setExternalModuleIndicatorOverride || setExternalModuleIndicator, jsDocParsingMode);
	          clearState();
	          return result;
	        }
	        Parser2.parseSourceFile = parseSourceFile;
	        function parseIsolatedEntityName2(content, languageVersion2) {
	          initializeState(
	            "",
	            content,
	            languageVersion2,
	            /*syntaxCursor*/
	            void 0,
	            1 /* JS */,
	            0 /* ParseAll */
	          );
	          nextToken();
	          const entityName = parseEntityName(
	            /*allowReservedWords*/
	            true
	          );
	          const isValid = token() === 1 /* EndOfFileToken */ && !parseDiagnostics.length;
	          clearState();
	          return isValid ? entityName : void 0;
	        }
	        Parser2.parseIsolatedEntityName = parseIsolatedEntityName2;
	        function parseJsonText2(fileName2, sourceText2, languageVersion2 = 2 /* ES2015 */, syntaxCursor2, setParentNodes = false) {
	          initializeState(fileName2, sourceText2, languageVersion2, syntaxCursor2, 6 /* JSON */, 0 /* ParseAll */);
	          sourceFlags = contextFlags;
	          nextToken();
	          const pos = getNodePos();
	          let statements, endOfFileToken;
	          if (token() === 1 /* EndOfFileToken */) {
	            statements = createNodeArray([], pos, pos);
	            endOfFileToken = parseTokenNode();
	          } else {
	            let expressions;
	            while (token() !== 1 /* EndOfFileToken */) {
	              let expression2;
	              switch (token()) {
	                case 23 /* OpenBracketToken */:
	                  expression2 = parseArrayLiteralExpression();
	                  break;
	                case 112 /* TrueKeyword */:
	                case 97 /* FalseKeyword */:
	                case 106 /* NullKeyword */:
	                  expression2 = parseTokenNode();
	                  break;
	                case 41 /* MinusToken */:
	                  if (lookAhead(() => nextToken() === 9 /* NumericLiteral */ && nextToken() !== 59 /* ColonToken */)) {
	                    expression2 = parsePrefixUnaryExpression();
	                  } else {
	                    expression2 = parseObjectLiteralExpression();
	                  }
	                  break;
	                case 9 /* NumericLiteral */:
	                case 11 /* StringLiteral */:
	                  if (lookAhead(() => nextToken() !== 59 /* ColonToken */)) {
	                    expression2 = parseLiteralNode();
	                    break;
	                  }
	                default:
	                  expression2 = parseObjectLiteralExpression();
	                  break;
	              }
	              if (expressions && isArray(expressions)) {
	                expressions.push(expression2);
	              } else if (expressions) {
	                expressions = [expressions, expression2];
	              } else {
	                expressions = expression2;
	                if (token() !== 1 /* EndOfFileToken */) {
	                  parseErrorAtCurrentToken(Diagnostics.Unexpected_token);
	                }
	              }
	            }
	            const expression = isArray(expressions) ? finishNode(factoryCreateArrayLiteralExpression(expressions), pos) : Debug.checkDefined(expressions);
	            const statement = factoryCreateExpressionStatement(expression);
	            finishNode(statement, pos);
	            statements = createNodeArray([statement], pos);
	            endOfFileToken = parseExpectedToken(1 /* EndOfFileToken */, Diagnostics.Unexpected_token);
	          }
	          const sourceFile = createSourceFile2(
	            fileName2,
	            2 /* ES2015 */,
	            6 /* JSON */,
	            /*isDeclarationFile*/
	            false,
	            statements,
	            endOfFileToken,
	            sourceFlags,
	            noop
	          );
	          if (setParentNodes) {
	            fixupParentReferences(sourceFile);
	          }
	          sourceFile.nodeCount = nodeCount;
	          sourceFile.identifierCount = identifierCount;
	          sourceFile.identifiers = identifiers;
	          sourceFile.parseDiagnostics = attachFileToDiagnostics(parseDiagnostics, sourceFile);
	          if (jsDocDiagnostics) {
	            sourceFile.jsDocDiagnostics = attachFileToDiagnostics(jsDocDiagnostics, sourceFile);
	          }
	          const result = sourceFile;
	          clearState();
	          return result;
	        }
	        Parser2.parseJsonText = parseJsonText2;
	        function initializeState(_fileName, _sourceText, _languageVersion, _syntaxCursor, _scriptKind, _jsDocParsingMode) {
	          NodeConstructor2 = objectAllocator.getNodeConstructor();
	          TokenConstructor2 = objectAllocator.getTokenConstructor();
	          IdentifierConstructor2 = objectAllocator.getIdentifierConstructor();
	          PrivateIdentifierConstructor2 = objectAllocator.getPrivateIdentifierConstructor();
	          SourceFileConstructor2 = objectAllocator.getSourceFileConstructor();
	          fileName = normalizePath(_fileName);
	          sourceText = _sourceText;
	          languageVersion = _languageVersion;
	          syntaxCursor = _syntaxCursor;
	          scriptKind = _scriptKind;
	          languageVariant = getLanguageVariant(_scriptKind);
	          parseDiagnostics = [];
	          parsingContext = 0;
	          identifiers = /* @__PURE__ */ new Map();
	          identifierCount = 0;
	          nodeCount = 0;
	          sourceFlags = 0;
	          topLevel = true;
	          switch (scriptKind) {
	            case 1 /* JS */:
	            case 2 /* JSX */:
	              contextFlags = 524288 /* JavaScriptFile */;
	              break;
	            case 6 /* JSON */:
	              contextFlags = 524288 /* JavaScriptFile */ | 134217728 /* JsonFile */;
	              break;
	            default:
	              contextFlags = 0 /* None */;
	              break;
	          }
	          parseErrorBeforeNextFinishedNode = false;
	          scanner2.setText(sourceText);
	          scanner2.setOnError(scanError);
	          scanner2.setScriptTarget(languageVersion);
	          scanner2.setLanguageVariant(languageVariant);
	          scanner2.setScriptKind(scriptKind);
	          scanner2.setJSDocParsingMode(_jsDocParsingMode);
	        }
	        function clearState() {
	          scanner2.clearCommentDirectives();
	          scanner2.setText("");
	          scanner2.setOnError(void 0);
	          scanner2.setScriptKind(0 /* Unknown */);
	          scanner2.setJSDocParsingMode(0 /* ParseAll */);
	          sourceText = void 0;
	          languageVersion = void 0;
	          syntaxCursor = void 0;
	          scriptKind = void 0;
	          languageVariant = void 0;
	          sourceFlags = 0;
	          parseDiagnostics = void 0;
	          jsDocDiagnostics = void 0;
	          parsingContext = 0;
	          identifiers = void 0;
	          notParenthesizedArrow = void 0;
	          topLevel = true;
	        }
	        function parseSourceFileWorker(languageVersion2, setParentNodes, scriptKind2, setExternalModuleIndicator2, jsDocParsingMode) {
	          const isDeclarationFile = isDeclarationFileName(fileName);
	          if (isDeclarationFile) {
	            contextFlags |= 33554432 /* Ambient */;
	          }
	          sourceFlags = contextFlags;
	          nextToken();
	          const statements = parseList(0 /* SourceElements */, parseStatement);
	          Debug.assert(token() === 1 /* EndOfFileToken */);
	          const endHasJSDoc = hasPrecedingJSDocComment();
	          const endOfFileToken = withJSDoc(parseTokenNode(), endHasJSDoc);
	          const sourceFile = createSourceFile2(fileName, languageVersion2, scriptKind2, isDeclarationFile, statements, endOfFileToken, sourceFlags, setExternalModuleIndicator2);
	          processCommentPragmas(sourceFile, sourceText);
	          processPragmasIntoFields(sourceFile, reportPragmaDiagnostic);
	          sourceFile.commentDirectives = scanner2.getCommentDirectives();
	          sourceFile.nodeCount = nodeCount;
	          sourceFile.identifierCount = identifierCount;
	          sourceFile.identifiers = identifiers;
	          sourceFile.parseDiagnostics = attachFileToDiagnostics(parseDiagnostics, sourceFile);
	          sourceFile.jsDocParsingMode = jsDocParsingMode;
	          if (jsDocDiagnostics) {
	            sourceFile.jsDocDiagnostics = attachFileToDiagnostics(jsDocDiagnostics, sourceFile);
	          }
	          if (setParentNodes) {
	            fixupParentReferences(sourceFile);
	          }
	          return sourceFile;
	          function reportPragmaDiagnostic(pos, end, diagnostic) {
	            parseDiagnostics.push(createDetachedDiagnostic(fileName, sourceText, pos, end, diagnostic));
	          }
	        }
	        let hasDeprecatedTag = false;
	        function withJSDoc(node, hasJSDoc) {
	          if (!hasJSDoc) {
	            return node;
	          }
	          Debug.assert(!node.jsDoc);
	          const jsDoc = mapDefined(getJSDocCommentRanges(node, sourceText), (comment) => JSDocParser.parseJSDocComment(node, comment.pos, comment.end - comment.pos));
	          if (jsDoc.length)
	            node.jsDoc = jsDoc;
	          if (hasDeprecatedTag) {
	            hasDeprecatedTag = false;
	            node.flags |= 536870912 /* Deprecated */;
	          }
	          return node;
	        }
	        function reparseTopLevelAwait(sourceFile) {
	          const savedSyntaxCursor = syntaxCursor;
	          const baseSyntaxCursor = IncrementalParser.createSyntaxCursor(sourceFile);
	          syntaxCursor = { currentNode: currentNode2 };
	          const statements = [];
	          const savedParseDiagnostics = parseDiagnostics;
	          parseDiagnostics = [];
	          let pos = 0;
	          let start = findNextStatementWithAwait(sourceFile.statements, 0);
	          while (start !== -1) {
	            const prevStatement = sourceFile.statements[pos];
	            const nextStatement = sourceFile.statements[start];
	            addRange(statements, sourceFile.statements, pos, start);
	            pos = findNextStatementWithoutAwait(sourceFile.statements, start);
	            const diagnosticStart = findIndex(savedParseDiagnostics, (diagnostic) => diagnostic.start >= prevStatement.pos);
	            const diagnosticEnd = diagnosticStart >= 0 ? findIndex(savedParseDiagnostics, (diagnostic) => diagnostic.start >= nextStatement.pos, diagnosticStart) : -1;
	            if (diagnosticStart >= 0) {
	              addRange(parseDiagnostics, savedParseDiagnostics, diagnosticStart, diagnosticEnd >= 0 ? diagnosticEnd : void 0);
	            }
	            speculationHelper(() => {
	              const savedContextFlags = contextFlags;
	              contextFlags |= 65536 /* AwaitContext */;
	              scanner2.resetTokenState(nextStatement.pos);
	              nextToken();
	              while (token() !== 1 /* EndOfFileToken */) {
	                const startPos = scanner2.getTokenFullStart();
	                const statement = parseListElement(0 /* SourceElements */, parseStatement);
	                statements.push(statement);
	                if (startPos === scanner2.getTokenFullStart()) {
	                  nextToken();
	                }
	                if (pos >= 0) {
	                  const nonAwaitStatement = sourceFile.statements[pos];
	                  if (statement.end === nonAwaitStatement.pos) {
	                    break;
	                  }
	                  if (statement.end > nonAwaitStatement.pos) {
	                    pos = findNextStatementWithoutAwait(sourceFile.statements, pos + 1);
	                  }
	                }
	              }
	              contextFlags = savedContextFlags;
	            }, 2 /* Reparse */);
	            start = pos >= 0 ? findNextStatementWithAwait(sourceFile.statements, pos) : -1;
	          }
	          if (pos >= 0) {
	            const prevStatement = sourceFile.statements[pos];
	            addRange(statements, sourceFile.statements, pos);
	            const diagnosticStart = findIndex(savedParseDiagnostics, (diagnostic) => diagnostic.start >= prevStatement.pos);
	            if (diagnosticStart >= 0) {
	              addRange(parseDiagnostics, savedParseDiagnostics, diagnosticStart);
	            }
	          }
	          syntaxCursor = savedSyntaxCursor;
	          return factory2.updateSourceFile(sourceFile, setTextRange(factoryCreateNodeArray(statements), sourceFile.statements));
	          function containsPossibleTopLevelAwait(node) {
	            return !(node.flags & 65536 /* AwaitContext */) && !!(node.transformFlags & 67108864 /* ContainsPossibleTopLevelAwait */);
	          }
	          function findNextStatementWithAwait(statements2, start2) {
	            for (let i = start2; i < statements2.length; i++) {
	              if (containsPossibleTopLevelAwait(statements2[i])) {
	                return i;
	              }
	            }
	            return -1;
	          }
	          function findNextStatementWithoutAwait(statements2, start2) {
	            for (let i = start2; i < statements2.length; i++) {
	              if (!containsPossibleTopLevelAwait(statements2[i])) {
	                return i;
	              }
	            }
	            return -1;
	          }
	          function currentNode2(position) {
	            const node = baseSyntaxCursor.currentNode(position);
	            if (topLevel && node && containsPossibleTopLevelAwait(node)) {
	              node.intersectsChange = true;
	            }
	            return node;
	          }
	        }
	        function fixupParentReferences(rootNode) {
	          setParentRecursive(
	            rootNode,
	            /*incremental*/
	            true
	          );
	        }
	        Parser2.fixupParentReferences = fixupParentReferences;
	        function createSourceFile2(fileName2, languageVersion2, scriptKind2, isDeclarationFile, statements, endOfFileToken, flags, setExternalModuleIndicator2) {
	          let sourceFile = factory2.createSourceFile(statements, endOfFileToken, flags);
	          setTextRangePosWidth(sourceFile, 0, sourceText.length);
	          setFields(sourceFile);
	          if (!isDeclarationFile && isExternalModule(sourceFile) && sourceFile.transformFlags & 67108864 /* ContainsPossibleTopLevelAwait */) {
	            const oldSourceFile = sourceFile;
	            sourceFile = reparseTopLevelAwait(sourceFile);
	            if (oldSourceFile !== sourceFile)
	              setFields(sourceFile);
	          }
	          return sourceFile;
	          function setFields(sourceFile2) {
	            sourceFile2.text = sourceText;
	            sourceFile2.bindDiagnostics = [];
	            sourceFile2.bindSuggestionDiagnostics = void 0;
	            sourceFile2.languageVersion = languageVersion2;
	            sourceFile2.fileName = fileName2;
	            sourceFile2.languageVariant = getLanguageVariant(scriptKind2);
	            sourceFile2.isDeclarationFile = isDeclarationFile;
	            sourceFile2.scriptKind = scriptKind2;
	            setExternalModuleIndicator2(sourceFile2);
	            sourceFile2.setExternalModuleIndicator = setExternalModuleIndicator2;
	          }
	        }
	        function setContextFlag(val, flag) {
	          if (val) {
	            contextFlags |= flag;
	          } else {
	            contextFlags &= ~flag;
	          }
	        }
	        function setDisallowInContext(val) {
	          setContextFlag(val, 8192 /* DisallowInContext */);
	        }
	        function setYieldContext(val) {
	          setContextFlag(val, 16384 /* YieldContext */);
	        }
	        function setDecoratorContext(val) {
	          setContextFlag(val, 32768 /* DecoratorContext */);
	        }
	        function setAwaitContext(val) {
	          setContextFlag(val, 65536 /* AwaitContext */);
	        }
	        function doOutsideOfContext(context, func) {
	          const contextFlagsToClear = context & contextFlags;
	          if (contextFlagsToClear) {
	            setContextFlag(
	              /*val*/
	              false,
	              contextFlagsToClear
	            );
	            const result = func();
	            setContextFlag(
	              /*val*/
	              true,
	              contextFlagsToClear
	            );
	            return result;
	          }
	          return func();
	        }
	        function doInsideOfContext(context, func) {
	          const contextFlagsToSet = context & ~contextFlags;
	          if (contextFlagsToSet) {
	            setContextFlag(
	              /*val*/
	              true,
	              contextFlagsToSet
	            );
	            const result = func();
	            setContextFlag(
	              /*val*/
	              false,
	              contextFlagsToSet
	            );
	            return result;
	          }
	          return func();
	        }
	        function allowInAnd(func) {
	          return doOutsideOfContext(8192 /* DisallowInContext */, func);
	        }
	        function disallowInAnd(func) {
	          return doInsideOfContext(8192 /* DisallowInContext */, func);
	        }
	        function allowConditionalTypesAnd(func) {
	          return doOutsideOfContext(131072 /* DisallowConditionalTypesContext */, func);
	        }
	        function disallowConditionalTypesAnd(func) {
	          return doInsideOfContext(131072 /* DisallowConditionalTypesContext */, func);
	        }
	        function doInYieldContext(func) {
	          return doInsideOfContext(16384 /* YieldContext */, func);
	        }
	        function doInDecoratorContext(func) {
	          return doInsideOfContext(32768 /* DecoratorContext */, func);
	        }
	        function doInAwaitContext(func) {
	          return doInsideOfContext(65536 /* AwaitContext */, func);
	        }
	        function doOutsideOfAwaitContext(func) {
	          return doOutsideOfContext(65536 /* AwaitContext */, func);
	        }
	        function doInYieldAndAwaitContext(func) {
	          return doInsideOfContext(16384 /* YieldContext */ | 65536 /* AwaitContext */, func);
	        }
	        function doOutsideOfYieldAndAwaitContext(func) {
	          return doOutsideOfContext(16384 /* YieldContext */ | 65536 /* AwaitContext */, func);
	        }
	        function inContext(flags) {
	          return (contextFlags & flags) !== 0;
	        }
	        function inYieldContext() {
	          return inContext(16384 /* YieldContext */);
	        }
	        function inDisallowInContext() {
	          return inContext(8192 /* DisallowInContext */);
	        }
	        function inDisallowConditionalTypesContext() {
	          return inContext(131072 /* DisallowConditionalTypesContext */);
	        }
	        function inDecoratorContext() {
	          return inContext(32768 /* DecoratorContext */);
	        }
	        function inAwaitContext() {
	          return inContext(65536 /* AwaitContext */);
	        }
	        function parseErrorAtCurrentToken(message, ...args) {
	          return parseErrorAt(scanner2.getTokenStart(), scanner2.getTokenEnd(), message, ...args);
	        }
	        function parseErrorAtPosition(start, length2, message, ...args) {
	          const lastError = lastOrUndefined(parseDiagnostics);
	          let result;
	          if (!lastError || start !== lastError.start) {
	            result = createDetachedDiagnostic(fileName, sourceText, start, length2, message, ...args);
	            parseDiagnostics.push(result);
	          }
	          parseErrorBeforeNextFinishedNode = true;
	          return result;
	        }
	        function parseErrorAt(start, end, message, ...args) {
	          return parseErrorAtPosition(start, end - start, message, ...args);
	        }
	        function parseErrorAtRange(range, message, ...args) {
	          parseErrorAt(range.pos, range.end, message, ...args);
	        }
	        function scanError(message, length2, arg0) {
	          parseErrorAtPosition(scanner2.getTokenEnd(), length2, message, arg0);
	        }
	        function getNodePos() {
	          return scanner2.getTokenFullStart();
	        }
	        function hasPrecedingJSDocComment() {
	          return scanner2.hasPrecedingJSDocComment();
	        }
	        function token() {
	          return currentToken;
	        }
	        function nextTokenWithoutCheck() {
	          return currentToken = scanner2.scan();
	        }
	        function nextTokenAnd(func) {
	          nextToken();
	          return func();
	        }
	        function nextToken() {
	          if (isKeyword(currentToken) && (scanner2.hasUnicodeEscape() || scanner2.hasExtendedUnicodeEscape())) {
	            parseErrorAt(scanner2.getTokenStart(), scanner2.getTokenEnd(), Diagnostics.Keywords_cannot_contain_escape_characters);
	          }
	          return nextTokenWithoutCheck();
	        }
	        function nextTokenJSDoc() {
	          return currentToken = scanner2.scanJsDocToken();
	        }
	        function nextJSDocCommentTextToken(inBackticks) {
	          return currentToken = scanner2.scanJSDocCommentTextToken(inBackticks);
	        }
	        function reScanGreaterToken() {
	          return currentToken = scanner2.reScanGreaterToken();
	        }
	        function reScanSlashToken() {
	          return currentToken = scanner2.reScanSlashToken();
	        }
	        function reScanTemplateToken(isTaggedTemplate) {
	          return currentToken = scanner2.reScanTemplateToken(isTaggedTemplate);
	        }
	        function reScanLessThanToken() {
	          return currentToken = scanner2.reScanLessThanToken();
	        }
	        function reScanHashToken() {
	          return currentToken = scanner2.reScanHashToken();
	        }
	        function scanJsxIdentifier() {
	          return currentToken = scanner2.scanJsxIdentifier();
	        }
	        function scanJsxText() {
	          return currentToken = scanner2.scanJsxToken();
	        }
	        function scanJsxAttributeValue() {
	          return currentToken = scanner2.scanJsxAttributeValue();
	        }
	        function speculationHelper(callback, speculationKind) {
	          const saveToken = currentToken;
	          const saveParseDiagnosticsLength = parseDiagnostics.length;
	          const saveParseErrorBeforeNextFinishedNode = parseErrorBeforeNextFinishedNode;
	          const saveContextFlags = contextFlags;
	          const result = speculationKind !== 0 /* TryParse */ ? scanner2.lookAhead(callback) : scanner2.tryScan(callback);
	          Debug.assert(saveContextFlags === contextFlags);
	          if (!result || speculationKind !== 0 /* TryParse */) {
	            currentToken = saveToken;
	            if (speculationKind !== 2 /* Reparse */) {
	              parseDiagnostics.length = saveParseDiagnosticsLength;
	            }
	            parseErrorBeforeNextFinishedNode = saveParseErrorBeforeNextFinishedNode;
	          }
	          return result;
	        }
	        function lookAhead(callback) {
	          return speculationHelper(callback, 1 /* Lookahead */);
	        }
	        function tryParse(callback) {
	          return speculationHelper(callback, 0 /* TryParse */);
	        }
	        function isBindingIdentifier() {
	          if (token() === 80 /* Identifier */) {
	            return true;
	          }
	          return token() > 118 /* LastReservedWord */;
	        }
	        function isIdentifier2() {
	          if (token() === 80 /* Identifier */) {
	            return true;
	          }
	          if (token() === 127 /* YieldKeyword */ && inYieldContext()) {
	            return false;
	          }
	          if (token() === 135 /* AwaitKeyword */ && inAwaitContext()) {
	            return false;
	          }
	          return token() > 118 /* LastReservedWord */;
	        }
	        function parseExpected(kind, diagnosticMessage, shouldAdvance = true) {
	          if (token() === kind) {
	            if (shouldAdvance) {
	              nextToken();
	            }
	            return true;
	          }
	          if (diagnosticMessage) {
	            parseErrorAtCurrentToken(diagnosticMessage);
	          } else {
	            parseErrorAtCurrentToken(Diagnostics._0_expected, tokenToString(kind));
	          }
	          return false;
	        }
	        const viableKeywordSuggestions = Object.keys(textToKeywordObj).filter((keyword) => keyword.length > 2);
	        function parseErrorForMissingSemicolonAfter(node) {
	          if (isTaggedTemplateExpression(node)) {
	            parseErrorAt(skipTrivia(sourceText, node.template.pos), node.template.end, Diagnostics.Module_declaration_names_may_only_use_or_quoted_strings);
	            return;
	          }
	          const expressionText = isIdentifier(node) ? idText(node) : void 0;
	          if (!expressionText || !isIdentifierText(expressionText, languageVersion)) {
	            parseErrorAtCurrentToken(Diagnostics._0_expected, tokenToString(27 /* SemicolonToken */));
	            return;
	          }
	          const pos = skipTrivia(sourceText, node.pos);
	          switch (expressionText) {
	            case "const":
	            case "let":
	            case "var":
	              parseErrorAt(pos, node.end, Diagnostics.Variable_declaration_not_allowed_at_this_location);
	              return;
	            case "declare":
	              return;
	            case "interface":
	              parseErrorForInvalidName(Diagnostics.Interface_name_cannot_be_0, Diagnostics.Interface_must_be_given_a_name, 19 /* OpenBraceToken */);
	              return;
	            case "is":
	              parseErrorAt(pos, scanner2.getTokenStart(), Diagnostics.A_type_predicate_is_only_allowed_in_return_type_position_for_functions_and_methods);
	              return;
	            case "module":
	            case "namespace":
	              parseErrorForInvalidName(Diagnostics.Namespace_name_cannot_be_0, Diagnostics.Namespace_must_be_given_a_name, 19 /* OpenBraceToken */);
	              return;
	            case "type":
	              parseErrorForInvalidName(Diagnostics.Type_alias_name_cannot_be_0, Diagnostics.Type_alias_must_be_given_a_name, 64 /* EqualsToken */);
	              return;
	          }
	          const suggestion = getSpellingSuggestion(expressionText, viableKeywordSuggestions, (n) => n) ?? getSpaceSuggestion(expressionText);
	          if (suggestion) {
	            parseErrorAt(pos, node.end, Diagnostics.Unknown_keyword_or_identifier_Did_you_mean_0, suggestion);
	            return;
	          }
	          if (token() === 0 /* Unknown */) {
	            return;
	          }
	          parseErrorAt(pos, node.end, Diagnostics.Unexpected_keyword_or_identifier);
	        }
	        function parseErrorForInvalidName(nameDiagnostic, blankDiagnostic, tokenIfBlankName) {
	          if (token() === tokenIfBlankName) {
	            parseErrorAtCurrentToken(blankDiagnostic);
	          } else {
	            parseErrorAtCurrentToken(nameDiagnostic, scanner2.getTokenValue());
	          }
	        }
	        function getSpaceSuggestion(expressionText) {
	          for (const keyword of viableKeywordSuggestions) {
	            if (expressionText.length > keyword.length + 2 && startsWith(expressionText, keyword)) {
	              return `${keyword} ${expressionText.slice(keyword.length)}`;
	            }
	          }
	          return void 0;
	        }
	        function parseSemicolonAfterPropertyName(name, type, initializer) {
	          if (token() === 60 /* AtToken */ && !scanner2.hasPrecedingLineBreak()) {
	            parseErrorAtCurrentToken(Diagnostics.Decorators_must_precede_the_name_and_all_keywords_of_property_declarations);
	            return;
	          }
	          if (token() === 21 /* OpenParenToken */) {
	            parseErrorAtCurrentToken(Diagnostics.Cannot_start_a_function_call_in_a_type_annotation);
	            nextToken();
	            return;
	          }
	          if (type && !canParseSemicolon()) {
	            if (initializer) {
	              parseErrorAtCurrentToken(Diagnostics._0_expected, tokenToString(27 /* SemicolonToken */));
	            } else {
	              parseErrorAtCurrentToken(Diagnostics.Expected_for_property_initializer);
	            }
	            return;
	          }
	          if (tryParseSemicolon()) {
	            return;
	          }
	          if (initializer) {
	            parseErrorAtCurrentToken(Diagnostics._0_expected, tokenToString(27 /* SemicolonToken */));
	            return;
	          }
	          parseErrorForMissingSemicolonAfter(name);
	        }
	        function parseExpectedJSDoc(kind) {
	          if (token() === kind) {
	            nextTokenJSDoc();
	            return true;
	          }
	          Debug.assert(isKeywordOrPunctuation(kind));
	          parseErrorAtCurrentToken(Diagnostics._0_expected, tokenToString(kind));
	          return false;
	        }
	        function parseExpectedMatchingBrackets(openKind, closeKind, openParsed, openPosition) {
	          if (token() === closeKind) {
	            nextToken();
	            return;
	          }
	          const lastError = parseErrorAtCurrentToken(Diagnostics._0_expected, tokenToString(closeKind));
	          if (!openParsed) {
	            return;
	          }
	          if (lastError) {
	            addRelatedInfo(
	              lastError,
	              createDetachedDiagnostic(fileName, sourceText, openPosition, 1, Diagnostics.The_parser_expected_to_find_a_1_to_match_the_0_token_here, tokenToString(openKind), tokenToString(closeKind))
	            );
	          }
	        }
	        function parseOptional(t) {
	          if (token() === t) {
	            nextToken();
	            return true;
	          }
	          return false;
	        }
	        function parseOptionalToken(t) {
	          if (token() === t) {
	            return parseTokenNode();
	          }
	          return void 0;
	        }
	        function parseOptionalTokenJSDoc(t) {
	          if (token() === t) {
	            return parseTokenNodeJSDoc();
	          }
	          return void 0;
	        }
	        function parseExpectedToken(t, diagnosticMessage, arg0) {
	          return parseOptionalToken(t) || createMissingNode(
	            t,
	            /*reportAtCurrentPosition*/
	            false,
	            diagnosticMessage || Diagnostics._0_expected,
	            arg0 || tokenToString(t)
	          );
	        }
	        function parseExpectedTokenJSDoc(t) {
	          const optional = parseOptionalTokenJSDoc(t);
	          if (optional)
	            return optional;
	          Debug.assert(isKeywordOrPunctuation(t));
	          return createMissingNode(
	            t,
	            /*reportAtCurrentPosition*/
	            false,
	            Diagnostics._0_expected,
	            tokenToString(t)
	          );
	        }
	        function parseTokenNode() {
	          const pos = getNodePos();
	          const kind = token();
	          nextToken();
	          return finishNode(factoryCreateToken(kind), pos);
	        }
	        function parseTokenNodeJSDoc() {
	          const pos = getNodePos();
	          const kind = token();
	          nextTokenJSDoc();
	          return finishNode(factoryCreateToken(kind), pos);
	        }
	        function canParseSemicolon() {
	          if (token() === 27 /* SemicolonToken */) {
	            return true;
	          }
	          return token() === 20 /* CloseBraceToken */ || token() === 1 /* EndOfFileToken */ || scanner2.hasPrecedingLineBreak();
	        }
	        function tryParseSemicolon() {
	          if (!canParseSemicolon()) {
	            return false;
	          }
	          if (token() === 27 /* SemicolonToken */) {
	            nextToken();
	          }
	          return true;
	        }
	        function parseSemicolon() {
	          return tryParseSemicolon() || parseExpected(27 /* SemicolonToken */);
	        }
	        function createNodeArray(elements, pos, end, hasTrailingComma) {
	          const array = factoryCreateNodeArray(elements, hasTrailingComma);
	          setTextRangePosEnd(array, pos, end ?? scanner2.getTokenFullStart());
	          return array;
	        }
	        function finishNode(node, pos, end) {
	          setTextRangePosEnd(node, pos, end ?? scanner2.getTokenFullStart());
	          if (contextFlags) {
	            node.flags |= contextFlags;
	          }
	          if (parseErrorBeforeNextFinishedNode) {
	            parseErrorBeforeNextFinishedNode = false;
	            node.flags |= 262144 /* ThisNodeHasError */;
	          }
	          return node;
	        }
	        function createMissingNode(kind, reportAtCurrentPosition, diagnosticMessage, ...args) {
	          if (reportAtCurrentPosition) {
	            parseErrorAtPosition(scanner2.getTokenFullStart(), 0, diagnosticMessage, ...args);
	          } else if (diagnosticMessage) {
	            parseErrorAtCurrentToken(diagnosticMessage, ...args);
	          }
	          const pos = getNodePos();
	          const result = kind === 80 /* Identifier */ ? factoryCreateIdentifier(
	            "",
	            /*originalKeywordKind*/
	            void 0
	          ) : isTemplateLiteralKind(kind) ? factory2.createTemplateLiteralLikeNode(
	            kind,
	            "",
	            "",
	            /*templateFlags*/
	            void 0
	          ) : kind === 9 /* NumericLiteral */ ? factoryCreateNumericLiteral(
	            "",
	            /*numericLiteralFlags*/
	            void 0
	          ) : kind === 11 /* StringLiteral */ ? factoryCreateStringLiteral(
	            "",
	            /*isSingleQuote*/
	            void 0
	          ) : kind === 282 /* MissingDeclaration */ ? factory2.createMissingDeclaration() : factoryCreateToken(kind);
	          return finishNode(result, pos);
	        }
	        function internIdentifier(text) {
	          let identifier = identifiers.get(text);
	          if (identifier === void 0) {
	            identifiers.set(text, identifier = text);
	          }
	          return identifier;
	        }
	        function createIdentifier(isIdentifier3, diagnosticMessage, privateIdentifierDiagnosticMessage) {
	          if (isIdentifier3) {
	            identifierCount++;
	            const pos = getNodePos();
	            const originalKeywordKind = token();
	            const text = internIdentifier(scanner2.getTokenValue());
	            const hasExtendedUnicodeEscape = scanner2.hasExtendedUnicodeEscape();
	            nextTokenWithoutCheck();
	            return finishNode(factoryCreateIdentifier(text, originalKeywordKind, hasExtendedUnicodeEscape), pos);
	          }
	          if (token() === 81 /* PrivateIdentifier */) {
	            parseErrorAtCurrentToken(privateIdentifierDiagnosticMessage || Diagnostics.Private_identifiers_are_not_allowed_outside_class_bodies);
	            return createIdentifier(
	              /*isIdentifier*/
	              true
	            );
	          }
	          if (token() === 0 /* Unknown */ && scanner2.tryScan(() => scanner2.reScanInvalidIdentifier() === 80 /* Identifier */)) {
	            return createIdentifier(
	              /*isIdentifier*/
	              true
	            );
	          }
	          identifierCount++;
	          const reportAtCurrentPosition = token() === 1 /* EndOfFileToken */;
	          const isReservedWord = scanner2.isReservedWord();
	          const msgArg = scanner2.getTokenText();
	          const defaultMessage = isReservedWord ? Diagnostics.Identifier_expected_0_is_a_reserved_word_that_cannot_be_used_here : Diagnostics.Identifier_expected;
	          return createMissingNode(80 /* Identifier */, reportAtCurrentPosition, diagnosticMessage || defaultMessage, msgArg);
	        }
	        function parseBindingIdentifier(privateIdentifierDiagnosticMessage) {
	          return createIdentifier(
	            isBindingIdentifier(),
	            /*diagnosticMessage*/
	            void 0,
	            privateIdentifierDiagnosticMessage
	          );
	        }
	        function parseIdentifier(diagnosticMessage, privateIdentifierDiagnosticMessage) {
	          return createIdentifier(isIdentifier2(), diagnosticMessage, privateIdentifierDiagnosticMessage);
	        }
	        function parseIdentifierName(diagnosticMessage) {
	          return createIdentifier(tokenIsIdentifierOrKeyword(token()), diagnosticMessage);
	        }
	        function parseIdentifierNameErrorOnUnicodeEscapeSequence() {
	          if (scanner2.hasUnicodeEscape() || scanner2.hasExtendedUnicodeEscape()) {
	            parseErrorAtCurrentToken(Diagnostics.Unicode_escape_sequence_cannot_appear_here);
	          }
	          return createIdentifier(tokenIsIdentifierOrKeyword(token()));
	        }
	        function isLiteralPropertyName() {
	          return tokenIsIdentifierOrKeyword(token()) || token() === 11 /* StringLiteral */ || token() === 9 /* NumericLiteral */;
	        }
	        function isImportAttributeName2() {
	          return tokenIsIdentifierOrKeyword(token()) || token() === 11 /* StringLiteral */;
	        }
	        function parsePropertyNameWorker(allowComputedPropertyNames) {
	          if (token() === 11 /* StringLiteral */ || token() === 9 /* NumericLiteral */) {
	            const node = parseLiteralNode();
	            node.text = internIdentifier(node.text);
	            return node;
	          }
	          if (allowComputedPropertyNames && token() === 23 /* OpenBracketToken */) {
	            return parseComputedPropertyName();
	          }
	          if (token() === 81 /* PrivateIdentifier */) {
	            return parsePrivateIdentifier();
	          }
	          return parseIdentifierName();
	        }
	        function parsePropertyName() {
	          return parsePropertyNameWorker(
	            /*allowComputedPropertyNames*/
	            true
	          );
	        }
	        function parseComputedPropertyName() {
	          const pos = getNodePos();
	          parseExpected(23 /* OpenBracketToken */);
	          const expression = allowInAnd(parseExpression);
	          parseExpected(24 /* CloseBracketToken */);
	          return finishNode(factory2.createComputedPropertyName(expression), pos);
	        }
	        function parsePrivateIdentifier() {
	          const pos = getNodePos();
	          const node = factoryCreatePrivateIdentifier(internIdentifier(scanner2.getTokenValue()));
	          nextToken();
	          return finishNode(node, pos);
	        }
	        function parseContextualModifier(t) {
	          return token() === t && tryParse(nextTokenCanFollowModifier);
	        }
	        function nextTokenIsOnSameLineAndCanFollowModifier() {
	          nextToken();
	          if (scanner2.hasPrecedingLineBreak()) {
	            return false;
	          }
	          return canFollowModifier();
	        }
	        function nextTokenCanFollowModifier() {
	          switch (token()) {
	            case 87 /* ConstKeyword */:
	              return nextToken() === 94 /* EnumKeyword */;
	            case 95 /* ExportKeyword */:
	              nextToken();
	              if (token() === 90 /* DefaultKeyword */) {
	                return lookAhead(nextTokenCanFollowDefaultKeyword);
	              }
	              if (token() === 156 /* TypeKeyword */) {
	                return lookAhead(nextTokenCanFollowExportModifier);
	              }
	              return canFollowExportModifier();
	            case 90 /* DefaultKeyword */:
	              return nextTokenCanFollowDefaultKeyword();
	            case 126 /* StaticKeyword */:
	            case 139 /* GetKeyword */:
	            case 153 /* SetKeyword */:
	              nextToken();
	              return canFollowModifier();
	            default:
	              return nextTokenIsOnSameLineAndCanFollowModifier();
	          }
	        }
	        function canFollowExportModifier() {
	          return token() === 60 /* AtToken */ || token() !== 42 /* AsteriskToken */ && token() !== 130 /* AsKeyword */ && token() !== 19 /* OpenBraceToken */ && canFollowModifier();
	        }
	        function nextTokenCanFollowExportModifier() {
	          nextToken();
	          return canFollowExportModifier();
	        }
	        function parseAnyContextualModifier() {
	          return isModifierKind(token()) && tryParse(nextTokenCanFollowModifier);
	        }
	        function canFollowModifier() {
	          return token() === 23 /* OpenBracketToken */ || token() === 19 /* OpenBraceToken */ || token() === 42 /* AsteriskToken */ || token() === 26 /* DotDotDotToken */ || isLiteralPropertyName();
	        }
	        function nextTokenCanFollowDefaultKeyword() {
	          nextToken();
	          return token() === 86 /* ClassKeyword */ || token() === 100 /* FunctionKeyword */ || token() === 120 /* InterfaceKeyword */ || token() === 60 /* AtToken */ || token() === 128 /* AbstractKeyword */ && lookAhead(nextTokenIsClassKeywordOnSameLine) || token() === 134 /* AsyncKeyword */ && lookAhead(nextTokenIsFunctionKeywordOnSameLine);
	        }
	        function isListElement2(parsingContext2, inErrorRecovery) {
	          const node = currentNode(parsingContext2);
	          if (node) {
	            return true;
	          }
	          switch (parsingContext2) {
	            case 0 /* SourceElements */:
	            case 1 /* BlockStatements */:
	            case 3 /* SwitchClauseStatements */:
	              return !(token() === 27 /* SemicolonToken */ && inErrorRecovery) && isStartOfStatement();
	            case 2 /* SwitchClauses */:
	              return token() === 84 /* CaseKeyword */ || token() === 90 /* DefaultKeyword */;
	            case 4 /* TypeMembers */:
	              return lookAhead(isTypeMemberStart);
	            case 5 /* ClassMembers */:
	              return lookAhead(isClassMemberStart) || token() === 27 /* SemicolonToken */ && !inErrorRecovery;
	            case 6 /* EnumMembers */:
	              return token() === 23 /* OpenBracketToken */ || isLiteralPropertyName();
	            case 12 /* ObjectLiteralMembers */:
	              switch (token()) {
	                case 23 /* OpenBracketToken */:
	                case 42 /* AsteriskToken */:
	                case 26 /* DotDotDotToken */:
	                case 25 /* DotToken */:
	                  return true;
	                default:
	                  return isLiteralPropertyName();
	              }
	            case 18 /* RestProperties */:
	              return isLiteralPropertyName();
	            case 9 /* ObjectBindingElements */:
	              return token() === 23 /* OpenBracketToken */ || token() === 26 /* DotDotDotToken */ || isLiteralPropertyName();
	            case 24 /* ImportAttributes */:
	              return isImportAttributeName2();
	            case 7 /* HeritageClauseElement */:
	              if (token() === 19 /* OpenBraceToken */) {
	                return lookAhead(isValidHeritageClauseObjectLiteral);
	              }
	              if (!inErrorRecovery) {
	                return isStartOfLeftHandSideExpression() && !isHeritageClauseExtendsOrImplementsKeyword();
	              } else {
	                return isIdentifier2() && !isHeritageClauseExtendsOrImplementsKeyword();
	              }
	            case 8 /* VariableDeclarations */:
	              return isBindingIdentifierOrPrivateIdentifierOrPattern();
	            case 10 /* ArrayBindingElements */:
	              return token() === 28 /* CommaToken */ || token() === 26 /* DotDotDotToken */ || isBindingIdentifierOrPrivateIdentifierOrPattern();
	            case 19 /* TypeParameters */:
	              return token() === 103 /* InKeyword */ || token() === 87 /* ConstKeyword */ || isIdentifier2();
	            case 15 /* ArrayLiteralMembers */:
	              switch (token()) {
	                case 28 /* CommaToken */:
	                case 25 /* DotToken */:
	                  return true;
	              }
	            case 11 /* ArgumentExpressions */:
	              return token() === 26 /* DotDotDotToken */ || isStartOfExpression();
	            case 16 /* Parameters */:
	              return isStartOfParameter(
	                /*isJSDocParameter*/
	                false
	              );
	            case 17 /* JSDocParameters */:
	              return isStartOfParameter(
	                /*isJSDocParameter*/
	                true
	              );
	            case 20 /* TypeArguments */:
	            case 21 /* TupleElementTypes */:
	              return token() === 28 /* CommaToken */ || isStartOfType();
	            case 22 /* HeritageClauses */:
	              return isHeritageClause2();
	            case 23 /* ImportOrExportSpecifiers */:
	              if (token() === 161 /* FromKeyword */ && lookAhead(nextTokenIsStringLiteral)) {
	                return false;
	              }
	              return tokenIsIdentifierOrKeyword(token());
	            case 13 /* JsxAttributes */:
	              return tokenIsIdentifierOrKeyword(token()) || token() === 19 /* OpenBraceToken */;
	            case 14 /* JsxChildren */:
	              return true;
	            case 25 /* JSDocComment */:
	              return true;
	            case 26 /* Count */:
	              return Debug.fail("ParsingContext.Count used as a context");
	            default:
	              Debug.assertNever(parsingContext2, "Non-exhaustive case in 'isListElement'.");
	          }
	        }
	        function isValidHeritageClauseObjectLiteral() {
	          Debug.assert(token() === 19 /* OpenBraceToken */);
	          if (nextToken() === 20 /* CloseBraceToken */) {
	            const next = nextToken();
	            return next === 28 /* CommaToken */ || next === 19 /* OpenBraceToken */ || next === 96 /* ExtendsKeyword */ || next === 119 /* ImplementsKeyword */;
	          }
	          return true;
	        }
	        function nextTokenIsIdentifier() {
	          nextToken();
	          return isIdentifier2();
	        }
	        function nextTokenIsIdentifierOrKeyword() {
	          nextToken();
	          return tokenIsIdentifierOrKeyword(token());
	        }
	        function nextTokenIsIdentifierOrKeywordOrGreaterThan() {
	          nextToken();
	          return tokenIsIdentifierOrKeywordOrGreaterThan(token());
	        }
	        function isHeritageClauseExtendsOrImplementsKeyword() {
	          if (token() === 119 /* ImplementsKeyword */ || token() === 96 /* ExtendsKeyword */) {
	            return lookAhead(nextTokenIsStartOfExpression);
	          }
	          return false;
	        }
	        function nextTokenIsStartOfExpression() {
	          nextToken();
	          return isStartOfExpression();
	        }
	        function nextTokenIsStartOfType() {
	          nextToken();
	          return isStartOfType();
	        }
	        function isListTerminator(kind) {
	          if (token() === 1 /* EndOfFileToken */) {
	            return true;
	          }
	          switch (kind) {
	            case 1 /* BlockStatements */:
	            case 2 /* SwitchClauses */:
	            case 4 /* TypeMembers */:
	            case 5 /* ClassMembers */:
	            case 6 /* EnumMembers */:
	            case 12 /* ObjectLiteralMembers */:
	            case 9 /* ObjectBindingElements */:
	            case 23 /* ImportOrExportSpecifiers */:
	            case 24 /* ImportAttributes */:
	              return token() === 20 /* CloseBraceToken */;
	            case 3 /* SwitchClauseStatements */:
	              return token() === 20 /* CloseBraceToken */ || token() === 84 /* CaseKeyword */ || token() === 90 /* DefaultKeyword */;
	            case 7 /* HeritageClauseElement */:
	              return token() === 19 /* OpenBraceToken */ || token() === 96 /* ExtendsKeyword */ || token() === 119 /* ImplementsKeyword */;
	            case 8 /* VariableDeclarations */:
	              return isVariableDeclaratorListTerminator();
	            case 19 /* TypeParameters */:
	              return token() === 32 /* GreaterThanToken */ || token() === 21 /* OpenParenToken */ || token() === 19 /* OpenBraceToken */ || token() === 96 /* ExtendsKeyword */ || token() === 119 /* ImplementsKeyword */;
	            case 11 /* ArgumentExpressions */:
	              return token() === 22 /* CloseParenToken */ || token() === 27 /* SemicolonToken */;
	            case 15 /* ArrayLiteralMembers */:
	            case 21 /* TupleElementTypes */:
	            case 10 /* ArrayBindingElements */:
	              return token() === 24 /* CloseBracketToken */;
	            case 17 /* JSDocParameters */:
	            case 16 /* Parameters */:
	            case 18 /* RestProperties */:
	              return token() === 22 /* CloseParenToken */ || token() === 24 /* CloseBracketToken */;
	            case 20 /* TypeArguments */:
	              return token() !== 28 /* CommaToken */;
	            case 22 /* HeritageClauses */:
	              return token() === 19 /* OpenBraceToken */ || token() === 20 /* CloseBraceToken */;
	            case 13 /* JsxAttributes */:
	              return token() === 32 /* GreaterThanToken */ || token() === 44 /* SlashToken */;
	            case 14 /* JsxChildren */:
	              return token() === 30 /* LessThanToken */ && lookAhead(nextTokenIsSlash);
	            default:
	              return false;
	          }
	        }
	        function isVariableDeclaratorListTerminator() {
	          if (canParseSemicolon()) {
	            return true;
	          }
	          if (isInOrOfKeyword(token())) {
	            return true;
	          }
	          if (token() === 39 /* EqualsGreaterThanToken */) {
	            return true;
	          }
	          return false;
	        }
	        function isInSomeParsingContext() {
	          Debug.assert(parsingContext, "Missing parsing context");
	          for (let kind = 0; kind < 26 /* Count */; kind++) {
	            if (parsingContext & 1 << kind) {
	              if (isListElement2(
	                kind,
	                /*inErrorRecovery*/
	                true
	              ) || isListTerminator(kind)) {
	                return true;
	              }
	            }
	          }
	          return false;
	        }
	        function parseList(kind, parseElement) {
	          const saveParsingContext = parsingContext;
	          parsingContext |= 1 << kind;
	          const list = [];
	          const listPos = getNodePos();
	          while (!isListTerminator(kind)) {
	            if (isListElement2(
	              kind,
	              /*inErrorRecovery*/
	              false
	            )) {
	              list.push(parseListElement(kind, parseElement));
	              continue;
	            }
	            if (abortParsingListOrMoveToNextToken(kind)) {
	              break;
	            }
	          }
	          parsingContext = saveParsingContext;
	          return createNodeArray(list, listPos);
	        }
	        function parseListElement(parsingContext2, parseElement) {
	          const node = currentNode(parsingContext2);
	          if (node) {
	            return consumeNode(node);
	          }
	          return parseElement();
	        }
	        function currentNode(parsingContext2, pos) {
	          var _a;
	          if (!syntaxCursor || !isReusableParsingContext(parsingContext2) || parseErrorBeforeNextFinishedNode) {
	            return void 0;
	          }
	          const node = syntaxCursor.currentNode(pos ?? scanner2.getTokenFullStart());
	          if (nodeIsMissing(node) || node.intersectsChange || containsParseError(node)) {
	            return void 0;
	          }
	          const nodeContextFlags = node.flags & 101441536 /* ContextFlags */;
	          if (nodeContextFlags !== contextFlags) {
	            return void 0;
	          }
	          if (!canReuseNode(node, parsingContext2)) {
	            return void 0;
	          }
	          if (canHaveJSDoc(node) && ((_a = node.jsDoc) == null ? void 0 : _a.jsDocCache)) {
	            node.jsDoc.jsDocCache = void 0;
	          }
	          return node;
	        }
	        function consumeNode(node) {
	          scanner2.resetTokenState(node.end);
	          nextToken();
	          return node;
	        }
	        function isReusableParsingContext(parsingContext2) {
	          switch (parsingContext2) {
	            case 5 /* ClassMembers */:
	            case 2 /* SwitchClauses */:
	            case 0 /* SourceElements */:
	            case 1 /* BlockStatements */:
	            case 3 /* SwitchClauseStatements */:
	            case 6 /* EnumMembers */:
	            case 4 /* TypeMembers */:
	            case 8 /* VariableDeclarations */:
	            case 17 /* JSDocParameters */:
	            case 16 /* Parameters */:
	              return true;
	          }
	          return false;
	        }
	        function canReuseNode(node, parsingContext2) {
	          switch (parsingContext2) {
	            case 5 /* ClassMembers */:
	              return isReusableClassMember(node);
	            case 2 /* SwitchClauses */:
	              return isReusableSwitchClause(node);
	            case 0 /* SourceElements */:
	            case 1 /* BlockStatements */:
	            case 3 /* SwitchClauseStatements */:
	              return isReusableStatement(node);
	            case 6 /* EnumMembers */:
	              return isReusableEnumMember(node);
	            case 4 /* TypeMembers */:
	              return isReusableTypeMember(node);
	            case 8 /* VariableDeclarations */:
	              return isReusableVariableDeclaration(node);
	            case 17 /* JSDocParameters */:
	            case 16 /* Parameters */:
	              return isReusableParameter(node);
	          }
	          return false;
	        }
	        function isReusableClassMember(node) {
	          if (node) {
	            switch (node.kind) {
	              case 176 /* Constructor */:
	              case 181 /* IndexSignature */:
	              case 177 /* GetAccessor */:
	              case 178 /* SetAccessor */:
	              case 172 /* PropertyDeclaration */:
	              case 240 /* SemicolonClassElement */:
	                return true;
	              case 174 /* MethodDeclaration */:
	                const methodDeclaration = node;
	                const nameIsConstructor = methodDeclaration.name.kind === 80 /* Identifier */ && methodDeclaration.name.escapedText === "constructor";
	                return !nameIsConstructor;
	            }
	          }
	          return false;
	        }
	        function isReusableSwitchClause(node) {
	          if (node) {
	            switch (node.kind) {
	              case 296 /* CaseClause */:
	              case 297 /* DefaultClause */:
	                return true;
	            }
	          }
	          return false;
	        }
	        function isReusableStatement(node) {
	          if (node) {
	            switch (node.kind) {
	              case 262 /* FunctionDeclaration */:
	              case 243 /* VariableStatement */:
	              case 241 /* Block */:
	              case 245 /* IfStatement */:
	              case 244 /* ExpressionStatement */:
	              case 257 /* ThrowStatement */:
	              case 253 /* ReturnStatement */:
	              case 255 /* SwitchStatement */:
	              case 252 /* BreakStatement */:
	              case 251 /* ContinueStatement */:
	              case 249 /* ForInStatement */:
	              case 250 /* ForOfStatement */:
	              case 248 /* ForStatement */:
	              case 247 /* WhileStatement */:
	              case 254 /* WithStatement */:
	              case 242 /* EmptyStatement */:
	              case 258 /* TryStatement */:
	              case 256 /* LabeledStatement */:
	              case 246 /* DoStatement */:
	              case 259 /* DebuggerStatement */:
	              case 272 /* ImportDeclaration */:
	              case 271 /* ImportEqualsDeclaration */:
	              case 278 /* ExportDeclaration */:
	              case 277 /* ExportAssignment */:
	              case 267 /* ModuleDeclaration */:
	              case 263 /* ClassDeclaration */:
	              case 264 /* InterfaceDeclaration */:
	              case 266 /* EnumDeclaration */:
	              case 265 /* TypeAliasDeclaration */:
	                return true;
	            }
	          }
	          return false;
	        }
	        function isReusableEnumMember(node) {
	          return node.kind === 306 /* EnumMember */;
	        }
	        function isReusableTypeMember(node) {
	          if (node) {
	            switch (node.kind) {
	              case 180 /* ConstructSignature */:
	              case 173 /* MethodSignature */:
	              case 181 /* IndexSignature */:
	              case 171 /* PropertySignature */:
	              case 179 /* CallSignature */:
	                return true;
	            }
	          }
	          return false;
	        }
	        function isReusableVariableDeclaration(node) {
	          if (node.kind !== 260 /* VariableDeclaration */) {
	            return false;
	          }
	          const variableDeclarator = node;
	          return variableDeclarator.initializer === void 0;
	        }
	        function isReusableParameter(node) {
	          if (node.kind !== 169 /* Parameter */) {
	            return false;
	          }
	          const parameter = node;
	          return parameter.initializer === void 0;
	        }
	        function abortParsingListOrMoveToNextToken(kind) {
	          parsingContextErrors(kind);
	          if (isInSomeParsingContext()) {
	            return true;
	          }
	          nextToken();
	          return false;
	        }
	        function parsingContextErrors(context) {
	          switch (context) {
	            case 0 /* SourceElements */:
	              return token() === 90 /* DefaultKeyword */ ? parseErrorAtCurrentToken(Diagnostics._0_expected, tokenToString(95 /* ExportKeyword */)) : parseErrorAtCurrentToken(Diagnostics.Declaration_or_statement_expected);
	            case 1 /* BlockStatements */:
	              return parseErrorAtCurrentToken(Diagnostics.Declaration_or_statement_expected);
	            case 2 /* SwitchClauses */:
	              return parseErrorAtCurrentToken(Diagnostics.case_or_default_expected);
	            case 3 /* SwitchClauseStatements */:
	              return parseErrorAtCurrentToken(Diagnostics.Statement_expected);
	            case 18 /* RestProperties */:
	            case 4 /* TypeMembers */:
	              return parseErrorAtCurrentToken(Diagnostics.Property_or_signature_expected);
	            case 5 /* ClassMembers */:
	              return parseErrorAtCurrentToken(Diagnostics.Unexpected_token_A_constructor_method_accessor_or_property_was_expected);
	            case 6 /* EnumMembers */:
	              return parseErrorAtCurrentToken(Diagnostics.Enum_member_expected);
	            case 7 /* HeritageClauseElement */:
	              return parseErrorAtCurrentToken(Diagnostics.Expression_expected);
	            case 8 /* VariableDeclarations */:
	              return isKeyword(token()) ? parseErrorAtCurrentToken(Diagnostics._0_is_not_allowed_as_a_variable_declaration_name, tokenToString(token())) : parseErrorAtCurrentToken(Diagnostics.Variable_declaration_expected);
	            case 9 /* ObjectBindingElements */:
	              return parseErrorAtCurrentToken(Diagnostics.Property_destructuring_pattern_expected);
	            case 10 /* ArrayBindingElements */:
	              return parseErrorAtCurrentToken(Diagnostics.Array_element_destructuring_pattern_expected);
	            case 11 /* ArgumentExpressions */:
	              return parseErrorAtCurrentToken(Diagnostics.Argument_expression_expected);
	            case 12 /* ObjectLiteralMembers */:
	              return parseErrorAtCurrentToken(Diagnostics.Property_assignment_expected);
	            case 15 /* ArrayLiteralMembers */:
	              return parseErrorAtCurrentToken(Diagnostics.Expression_or_comma_expected);
	            case 17 /* JSDocParameters */:
	              return parseErrorAtCurrentToken(Diagnostics.Parameter_declaration_expected);
	            case 16 /* Parameters */:
	              return isKeyword(token()) ? parseErrorAtCurrentToken(Diagnostics._0_is_not_allowed_as_a_parameter_name, tokenToString(token())) : parseErrorAtCurrentToken(Diagnostics.Parameter_declaration_expected);
	            case 19 /* TypeParameters */:
	              return parseErrorAtCurrentToken(Diagnostics.Type_parameter_declaration_expected);
	            case 20 /* TypeArguments */:
	              return parseErrorAtCurrentToken(Diagnostics.Type_argument_expected);
	            case 21 /* TupleElementTypes */:
	              return parseErrorAtCurrentToken(Diagnostics.Type_expected);
	            case 22 /* HeritageClauses */:
	              return parseErrorAtCurrentToken(Diagnostics.Unexpected_token_expected);
	            case 23 /* ImportOrExportSpecifiers */:
	              if (token() === 161 /* FromKeyword */) {
	                return parseErrorAtCurrentToken(Diagnostics._0_expected, "}");
	              }
	              return parseErrorAtCurrentToken(Diagnostics.Identifier_expected);
	            case 13 /* JsxAttributes */:
	              return parseErrorAtCurrentToken(Diagnostics.Identifier_expected);
	            case 14 /* JsxChildren */:
	              return parseErrorAtCurrentToken(Diagnostics.Identifier_expected);
	            case 24 /* ImportAttributes */:
	              return parseErrorAtCurrentToken(Diagnostics.Identifier_or_string_literal_expected);
	            case 25 /* JSDocComment */:
	              return parseErrorAtCurrentToken(Diagnostics.Identifier_expected);
	            case 26 /* Count */:
	              return Debug.fail("ParsingContext.Count used as a context");
	            default:
	              Debug.assertNever(context);
	          }
	        }
	        function parseDelimitedList(kind, parseElement, considerSemicolonAsDelimiter) {
	          const saveParsingContext = parsingContext;
	          parsingContext |= 1 << kind;
	          const list = [];
	          const listPos = getNodePos();
	          let commaStart = -1;
	          while (true) {
	            if (isListElement2(
	              kind,
	              /*inErrorRecovery*/
	              false
	            )) {
	              const startPos = scanner2.getTokenFullStart();
	              const result = parseListElement(kind, parseElement);
	              if (!result) {
	                parsingContext = saveParsingContext;
	                return void 0;
	              }
	              list.push(result);
	              commaStart = scanner2.getTokenStart();
	              if (parseOptional(28 /* CommaToken */)) {
	                continue;
	              }
	              commaStart = -1;
	              if (isListTerminator(kind)) {
	                break;
	              }
	              parseExpected(28 /* CommaToken */, getExpectedCommaDiagnostic(kind));
	              if (considerSemicolonAsDelimiter && token() === 27 /* SemicolonToken */ && !scanner2.hasPrecedingLineBreak()) {
	                nextToken();
	              }
	              if (startPos === scanner2.getTokenFullStart()) {
	                nextToken();
	              }
	              continue;
	            }
	            if (isListTerminator(kind)) {
	              break;
	            }
	            if (abortParsingListOrMoveToNextToken(kind)) {
	              break;
	            }
	          }
	          parsingContext = saveParsingContext;
	          return createNodeArray(
	            list,
	            listPos,
	            /*end*/
	            void 0,
	            commaStart >= 0
	          );
	        }
	        function getExpectedCommaDiagnostic(kind) {
	          return kind === 6 /* EnumMembers */ ? Diagnostics.An_enum_member_name_must_be_followed_by_a_or : void 0;
	        }
	        function createMissingList() {
	          const list = createNodeArray([], getNodePos());
	          list.isMissingList = true;
	          return list;
	        }
	        function isMissingList(arr) {
	          return !!arr.isMissingList;
	        }
	        function parseBracketedList(kind, parseElement, open, close) {
	          if (parseExpected(open)) {
	            const result = parseDelimitedList(kind, parseElement);
	            parseExpected(close);
	            return result;
	          }
	          return createMissingList();
	        }
	        function parseEntityName(allowReservedWords, diagnosticMessage) {
	          const pos = getNodePos();
	          let entity = allowReservedWords ? parseIdentifierName(diagnosticMessage) : parseIdentifier(diagnosticMessage);
	          while (parseOptional(25 /* DotToken */)) {
	            if (token() === 30 /* LessThanToken */) {
	              break;
	            }
	            entity = finishNode(
	              factory2.createQualifiedName(
	                entity,
	                parseRightSideOfDot(
	                  allowReservedWords,
	                  /*allowPrivateIdentifiers*/
	                  false,
	                  /*allowUnicodeEscapeSequenceInIdentifierName*/
	                  true
	                )
	              ),
	              pos
	            );
	          }
	          return entity;
	        }
	        function createQualifiedName(entity, name) {
	          return finishNode(factory2.createQualifiedName(entity, name), entity.pos);
	        }
	        function parseRightSideOfDot(allowIdentifierNames, allowPrivateIdentifiers, allowUnicodeEscapeSequenceInIdentifierName) {
	          if (scanner2.hasPrecedingLineBreak() && tokenIsIdentifierOrKeyword(token())) {
	            const matchesPattern = lookAhead(nextTokenIsIdentifierOrKeywordOnSameLine);
	            if (matchesPattern) {
	              return createMissingNode(
	                80 /* Identifier */,
	                /*reportAtCurrentPosition*/
	                true,
	                Diagnostics.Identifier_expected
	              );
	            }
	          }
	          if (token() === 81 /* PrivateIdentifier */) {
	            const node = parsePrivateIdentifier();
	            return allowPrivateIdentifiers ? node : createMissingNode(
	              80 /* Identifier */,
	              /*reportAtCurrentPosition*/
	              true,
	              Diagnostics.Identifier_expected
	            );
	          }
	          if (allowIdentifierNames) {
	            return allowUnicodeEscapeSequenceInIdentifierName ? parseIdentifierName() : parseIdentifierNameErrorOnUnicodeEscapeSequence();
	          }
	          return parseIdentifier();
	        }
	        function parseTemplateSpans(isTaggedTemplate) {
	          const pos = getNodePos();
	          const list = [];
	          let node;
	          do {
	            node = parseTemplateSpan(isTaggedTemplate);
	            list.push(node);
	          } while (node.literal.kind === 17 /* TemplateMiddle */);
	          return createNodeArray(list, pos);
	        }
	        function parseTemplateExpression(isTaggedTemplate) {
	          const pos = getNodePos();
	          return finishNode(
	            factory2.createTemplateExpression(
	              parseTemplateHead(isTaggedTemplate),
	              parseTemplateSpans(isTaggedTemplate)
	            ),
	            pos
	          );
	        }
	        function parseTemplateType() {
	          const pos = getNodePos();
	          return finishNode(
	            factory2.createTemplateLiteralType(
	              parseTemplateHead(
	                /*isTaggedTemplate*/
	                false
	              ),
	              parseTemplateTypeSpans()
	            ),
	            pos
	          );
	        }
	        function parseTemplateTypeSpans() {
	          const pos = getNodePos();
	          const list = [];
	          let node;
	          do {
	            node = parseTemplateTypeSpan();
	            list.push(node);
	          } while (node.literal.kind === 17 /* TemplateMiddle */);
	          return createNodeArray(list, pos);
	        }
	        function parseTemplateTypeSpan() {
	          const pos = getNodePos();
	          return finishNode(
	            factory2.createTemplateLiteralTypeSpan(
	              parseType(),
	              parseLiteralOfTemplateSpan(
	                /*isTaggedTemplate*/
	                false
	              )
	            ),
	            pos
	          );
	        }
	        function parseLiteralOfTemplateSpan(isTaggedTemplate) {
	          if (token() === 20 /* CloseBraceToken */) {
	            reScanTemplateToken(isTaggedTemplate);
	            return parseTemplateMiddleOrTemplateTail();
	          } else {
	            return parseExpectedToken(18 /* TemplateTail */, Diagnostics._0_expected, tokenToString(20 /* CloseBraceToken */));
	          }
	        }
	        function parseTemplateSpan(isTaggedTemplate) {
	          const pos = getNodePos();
	          return finishNode(
	            factory2.createTemplateSpan(
	              allowInAnd(parseExpression),
	              parseLiteralOfTemplateSpan(isTaggedTemplate)
	            ),
	            pos
	          );
	        }
	        function parseLiteralNode() {
	          return parseLiteralLikeNode(token());
	        }
	        function parseTemplateHead(isTaggedTemplate) {
	          if (!isTaggedTemplate && scanner2.getTokenFlags() & 26656 /* IsInvalid */) {
	            reScanTemplateToken(
	              /*isTaggedTemplate*/
	              false
	            );
	          }
	          const fragment = parseLiteralLikeNode(token());
	          Debug.assert(fragment.kind === 16 /* TemplateHead */, "Template head has wrong token kind");
	          return fragment;
	        }
	        function parseTemplateMiddleOrTemplateTail() {
	          const fragment = parseLiteralLikeNode(token());
	          Debug.assert(fragment.kind === 17 /* TemplateMiddle */ || fragment.kind === 18 /* TemplateTail */, "Template fragment has wrong token kind");
	          return fragment;
	        }
	        function getTemplateLiteralRawText(kind) {
	          const isLast = kind === 15 /* NoSubstitutionTemplateLiteral */ || kind === 18 /* TemplateTail */;
	          const tokenText = scanner2.getTokenText();
	          return tokenText.substring(1, tokenText.length - (scanner2.isUnterminated() ? 0 : isLast ? 1 : 2));
	        }
	        function parseLiteralLikeNode(kind) {
	          const pos = getNodePos();
	          const node = isTemplateLiteralKind(kind) ? factory2.createTemplateLiteralLikeNode(kind, scanner2.getTokenValue(), getTemplateLiteralRawText(kind), scanner2.getTokenFlags() & 7176 /* TemplateLiteralLikeFlags */) : (
	            // Note that theoretically the following condition would hold true literals like 009,
	            // which is not octal. But because of how the scanner separates the tokens, we would
	            // never get a token like this. Instead, we would get 00 and 9 as two separate tokens.
	            // We also do not need to check for negatives because any prefix operator would be part of a
	            // parent unary expression.
	            kind === 9 /* NumericLiteral */ ? factoryCreateNumericLiteral(scanner2.getTokenValue(), scanner2.getNumericLiteralFlags()) : kind === 11 /* StringLiteral */ ? factoryCreateStringLiteral(
	              scanner2.getTokenValue(),
	              /*isSingleQuote*/
	              void 0,
	              scanner2.hasExtendedUnicodeEscape()
	            ) : isLiteralKind(kind) ? factoryCreateLiteralLikeNode(kind, scanner2.getTokenValue()) : Debug.fail()
	          );
	          if (scanner2.hasExtendedUnicodeEscape()) {
	            node.hasExtendedUnicodeEscape = true;
	          }
	          if (scanner2.isUnterminated()) {
	            node.isUnterminated = true;
	          }
	          nextToken();
	          return finishNode(node, pos);
	        }
	        function parseEntityNameOfTypeReference() {
	          return parseEntityName(
	            /*allowReservedWords*/
	            true,
	            Diagnostics.Type_expected
	          );
	        }
	        function parseTypeArgumentsOfTypeReference() {
	          if (!scanner2.hasPrecedingLineBreak() && reScanLessThanToken() === 30 /* LessThanToken */) {
	            return parseBracketedList(20 /* TypeArguments */, parseType, 30 /* LessThanToken */, 32 /* GreaterThanToken */);
	          }
	        }
	        function parseTypeReference() {
	          const pos = getNodePos();
	          return finishNode(
	            factory2.createTypeReferenceNode(
	              parseEntityNameOfTypeReference(),
	              parseTypeArgumentsOfTypeReference()
	            ),
	            pos
	          );
	        }
	        function typeHasArrowFunctionBlockingParseError(node) {
	          switch (node.kind) {
	            case 183 /* TypeReference */:
	              return nodeIsMissing(node.typeName);
	            case 184 /* FunctionType */:
	            case 185 /* ConstructorType */: {
	              const { parameters, type } = node;
	              return isMissingList(parameters) || typeHasArrowFunctionBlockingParseError(type);
	            }
	            case 196 /* ParenthesizedType */:
	              return typeHasArrowFunctionBlockingParseError(node.type);
	            default:
	              return false;
	          }
	        }
	        function parseThisTypePredicate(lhs) {
	          nextToken();
	          return finishNode(factory2.createTypePredicateNode(
	            /*assertsModifier*/
	            void 0,
	            lhs,
	            parseType()
	          ), lhs.pos);
	        }
	        function parseThisTypeNode() {
	          const pos = getNodePos();
	          nextToken();
	          return finishNode(factory2.createThisTypeNode(), pos);
	        }
	        function parseJSDocAllType() {
	          const pos = getNodePos();
	          nextToken();
	          return finishNode(factory2.createJSDocAllType(), pos);
	        }
	        function parseJSDocNonNullableType() {
	          const pos = getNodePos();
	          nextToken();
	          return finishNode(factory2.createJSDocNonNullableType(
	            parseNonArrayType(),
	            /*postfix*/
	            false
	          ), pos);
	        }
	        function parseJSDocUnknownOrNullableType() {
	          const pos = getNodePos();
	          nextToken();
	          if (token() === 28 /* CommaToken */ || token() === 20 /* CloseBraceToken */ || token() === 22 /* CloseParenToken */ || token() === 32 /* GreaterThanToken */ || token() === 64 /* EqualsToken */ || token() === 52 /* BarToken */) {
	            return finishNode(factory2.createJSDocUnknownType(), pos);
	          } else {
	            return finishNode(factory2.createJSDocNullableType(
	              parseType(),
	              /*postfix*/
	              false
	            ), pos);
	          }
	        }
	        function parseJSDocFunctionType() {
	          const pos = getNodePos();
	          const hasJSDoc = hasPrecedingJSDocComment();
	          if (tryParse(nextTokenIsOpenParen)) {
	            const parameters = parseParameters(4 /* Type */ | 32 /* JSDoc */);
	            const type = parseReturnType(
	              59 /* ColonToken */,
	              /*isType*/
	              false
	            );
	            return withJSDoc(finishNode(factory2.createJSDocFunctionType(parameters, type), pos), hasJSDoc);
	          }
	          return finishNode(factory2.createTypeReferenceNode(
	            parseIdentifierName(),
	            /*typeArguments*/
	            void 0
	          ), pos);
	        }
	        function parseJSDocParameter() {
	          const pos = getNodePos();
	          let name;
	          if (token() === 110 /* ThisKeyword */ || token() === 105 /* NewKeyword */) {
	            name = parseIdentifierName();
	            parseExpected(59 /* ColonToken */);
	          }
	          return finishNode(
	            factory2.createParameterDeclaration(
	              /*modifiers*/
	              void 0,
	              /*dotDotDotToken*/
	              void 0,
	              // TODO(rbuckton): JSDoc parameters don't have names (except `this`/`new`), should we manufacture an empty identifier?
	              name,
	              /*questionToken*/
	              void 0,
	              parseJSDocType(),
	              /*initializer*/
	              void 0
	            ),
	            pos
	          );
	        }
	        function parseJSDocType() {
	          scanner2.setInJSDocType(true);
	          const pos = getNodePos();
	          if (parseOptional(144 /* ModuleKeyword */)) {
	            const moduleTag = factory2.createJSDocNamepathType(
	              /*type*/
	              void 0
	            );
	            terminate:
	              while (true) {
	                switch (token()) {
	                  case 20 /* CloseBraceToken */:
	                  case 1 /* EndOfFileToken */:
	                  case 28 /* CommaToken */:
	                  case 5 /* WhitespaceTrivia */:
	                    break terminate;
	                  default:
	                    nextTokenJSDoc();
	                }
	              }
	            scanner2.setInJSDocType(false);
	            return finishNode(moduleTag, pos);
	          }
	          const hasDotDotDot = parseOptional(26 /* DotDotDotToken */);
	          let type = parseTypeOrTypePredicate();
	          scanner2.setInJSDocType(false);
	          if (hasDotDotDot) {
	            type = finishNode(factory2.createJSDocVariadicType(type), pos);
	          }
	          if (token() === 64 /* EqualsToken */) {
	            nextToken();
	            return finishNode(factory2.createJSDocOptionalType(type), pos);
	          }
	          return type;
	        }
	        function parseTypeQuery() {
	          const pos = getNodePos();
	          parseExpected(114 /* TypeOfKeyword */);
	          const entityName = parseEntityName(
	            /*allowReservedWords*/
	            true
	          );
	          const typeArguments = !scanner2.hasPrecedingLineBreak() ? tryParseTypeArguments() : void 0;
	          return finishNode(factory2.createTypeQueryNode(entityName, typeArguments), pos);
	        }
	        function parseTypeParameter() {
	          const pos = getNodePos();
	          const modifiers = parseModifiers(
	            /*allowDecorators*/
	            false,
	            /*permitConstAsModifier*/
	            true
	          );
	          const name = parseIdentifier();
	          let constraint;
	          let expression;
	          if (parseOptional(96 /* ExtendsKeyword */)) {
	            if (isStartOfType() || !isStartOfExpression()) {
	              constraint = parseType();
	            } else {
	              expression = parseUnaryExpressionOrHigher();
	            }
	          }
	          const defaultType = parseOptional(64 /* EqualsToken */) ? parseType() : void 0;
	          const node = factory2.createTypeParameterDeclaration(modifiers, name, constraint, defaultType);
	          node.expression = expression;
	          return finishNode(node, pos);
	        }
	        function parseTypeParameters() {
	          if (token() === 30 /* LessThanToken */) {
	            return parseBracketedList(19 /* TypeParameters */, parseTypeParameter, 30 /* LessThanToken */, 32 /* GreaterThanToken */);
	          }
	        }
	        function isStartOfParameter(isJSDocParameter) {
	          return token() === 26 /* DotDotDotToken */ || isBindingIdentifierOrPrivateIdentifierOrPattern() || isModifierKind(token()) || token() === 60 /* AtToken */ || isStartOfType(
	            /*inStartOfParameter*/
	            !isJSDocParameter
	          );
	        }
	        function parseNameOfParameter(modifiers) {
	          const name = parseIdentifierOrPattern(Diagnostics.Private_identifiers_cannot_be_used_as_parameters);
	          if (getFullWidth(name) === 0 && !some(modifiers) && isModifierKind(token())) {
	            nextToken();
	          }
	          return name;
	        }
	        function isParameterNameStart() {
	          return isBindingIdentifier() || token() === 23 /* OpenBracketToken */ || token() === 19 /* OpenBraceToken */;
	        }
	        function parseParameter(inOuterAwaitContext) {
	          return parseParameterWorker(inOuterAwaitContext);
	        }
	        function parseParameterForSpeculation(inOuterAwaitContext) {
	          return parseParameterWorker(
	            inOuterAwaitContext,
	            /*allowAmbiguity*/
	            false
	          );
	        }
	        function parseParameterWorker(inOuterAwaitContext, allowAmbiguity = true) {
	          const pos = getNodePos();
	          const hasJSDoc = hasPrecedingJSDocComment();
	          const modifiers = inOuterAwaitContext ? doInAwaitContext(() => parseModifiers(
	            /*allowDecorators*/
	            true
	          )) : doOutsideOfAwaitContext(() => parseModifiers(
	            /*allowDecorators*/
	            true
	          ));
	          if (token() === 110 /* ThisKeyword */) {
	            const node2 = factory2.createParameterDeclaration(
	              modifiers,
	              /*dotDotDotToken*/
	              void 0,
	              createIdentifier(
	                /*isIdentifier*/
	                true
	              ),
	              /*questionToken*/
	              void 0,
	              parseTypeAnnotation(),
	              /*initializer*/
	              void 0
	            );
	            const modifier = firstOrUndefined(modifiers);
	            if (modifier) {
	              parseErrorAtRange(modifier, Diagnostics.Neither_decorators_nor_modifiers_may_be_applied_to_this_parameters);
	            }
	            return withJSDoc(finishNode(node2, pos), hasJSDoc);
	          }
	          const savedTopLevel = topLevel;
	          topLevel = false;
	          const dotDotDotToken = parseOptionalToken(26 /* DotDotDotToken */);
	          if (!allowAmbiguity && !isParameterNameStart()) {
	            return void 0;
	          }
	          const node = withJSDoc(
	            finishNode(
	              factory2.createParameterDeclaration(
	                modifiers,
	                dotDotDotToken,
	                parseNameOfParameter(modifiers),
	                parseOptionalToken(58 /* QuestionToken */),
	                parseTypeAnnotation(),
	                parseInitializer()
	              ),
	              pos
	            ),
	            hasJSDoc
	          );
	          topLevel = savedTopLevel;
	          return node;
	        }
	        function parseReturnType(returnToken, isType) {
	          if (shouldParseReturnType(returnToken, isType)) {
	            return allowConditionalTypesAnd(parseTypeOrTypePredicate);
	          }
	        }
	        function shouldParseReturnType(returnToken, isType) {
	          if (returnToken === 39 /* EqualsGreaterThanToken */) {
	            parseExpected(returnToken);
	            return true;
	          } else if (parseOptional(59 /* ColonToken */)) {
	            return true;
	          } else if (isType && token() === 39 /* EqualsGreaterThanToken */) {
	            parseErrorAtCurrentToken(Diagnostics._0_expected, tokenToString(59 /* ColonToken */));
	            nextToken();
	            return true;
	          }
	          return false;
	        }
	        function parseParametersWorker(flags, allowAmbiguity) {
	          const savedYieldContext = inYieldContext();
	          const savedAwaitContext = inAwaitContext();
	          setYieldContext(!!(flags & 1 /* Yield */));
	          setAwaitContext(!!(flags & 2 /* Await */));
	          const parameters = flags & 32 /* JSDoc */ ? parseDelimitedList(17 /* JSDocParameters */, parseJSDocParameter) : parseDelimitedList(16 /* Parameters */, () => allowAmbiguity ? parseParameter(savedAwaitContext) : parseParameterForSpeculation(savedAwaitContext));
	          setYieldContext(savedYieldContext);
	          setAwaitContext(savedAwaitContext);
	          return parameters;
	        }
	        function parseParameters(flags) {
	          if (!parseExpected(21 /* OpenParenToken */)) {
	            return createMissingList();
	          }
	          const parameters = parseParametersWorker(
	            flags,
	            /*allowAmbiguity*/
	            true
	          );
	          parseExpected(22 /* CloseParenToken */);
	          return parameters;
	        }
	        function parseTypeMemberSemicolon() {
	          if (parseOptional(28 /* CommaToken */)) {
	            return;
	          }
	          parseSemicolon();
	        }
	        function parseSignatureMember(kind) {
	          const pos = getNodePos();
	          const hasJSDoc = hasPrecedingJSDocComment();
	          if (kind === 180 /* ConstructSignature */) {
	            parseExpected(105 /* NewKeyword */);
	          }
	          const typeParameters = parseTypeParameters();
	          const parameters = parseParameters(4 /* Type */);
	          const type = parseReturnType(
	            59 /* ColonToken */,
	            /*isType*/
	            true
	          );
	          parseTypeMemberSemicolon();
	          const node = kind === 179 /* CallSignature */ ? factory2.createCallSignature(typeParameters, parameters, type) : factory2.createConstructSignature(typeParameters, parameters, type);
	          return withJSDoc(finishNode(node, pos), hasJSDoc);
	        }
	        function isIndexSignature() {
	          return token() === 23 /* OpenBracketToken */ && lookAhead(isUnambiguouslyIndexSignature);
	        }
	        function isUnambiguouslyIndexSignature() {
	          nextToken();
	          if (token() === 26 /* DotDotDotToken */ || token() === 24 /* CloseBracketToken */) {
	            return true;
	          }
	          if (isModifierKind(token())) {
	            nextToken();
	            if (isIdentifier2()) {
	              return true;
	            }
	          } else if (!isIdentifier2()) {
	            return false;
	          } else {
	            nextToken();
	          }
	          if (token() === 59 /* ColonToken */ || token() === 28 /* CommaToken */) {
	            return true;
	          }
	          if (token() !== 58 /* QuestionToken */) {
	            return false;
	          }
	          nextToken();
	          return token() === 59 /* ColonToken */ || token() === 28 /* CommaToken */ || token() === 24 /* CloseBracketToken */;
	        }
	        function parseIndexSignatureDeclaration(pos, hasJSDoc, modifiers) {
	          const parameters = parseBracketedList(16 /* Parameters */, () => parseParameter(
	            /*inOuterAwaitContext*/
	            false
	          ), 23 /* OpenBracketToken */, 24 /* CloseBracketToken */);
	          const type = parseTypeAnnotation();
	          parseTypeMemberSemicolon();
	          const node = factory2.createIndexSignature(modifiers, parameters, type);
	          return withJSDoc(finishNode(node, pos), hasJSDoc);
	        }
	        function parsePropertyOrMethodSignature(pos, hasJSDoc, modifiers) {
	          const name = parsePropertyName();
	          const questionToken = parseOptionalToken(58 /* QuestionToken */);
	          let node;
	          if (token() === 21 /* OpenParenToken */ || token() === 30 /* LessThanToken */) {
	            const typeParameters = parseTypeParameters();
	            const parameters = parseParameters(4 /* Type */);
	            const type = parseReturnType(
	              59 /* ColonToken */,
	              /*isType*/
	              true
	            );
	            node = factory2.createMethodSignature(modifiers, name, questionToken, typeParameters, parameters, type);
	          } else {
	            const type = parseTypeAnnotation();
	            node = factory2.createPropertySignature(modifiers, name, questionToken, type);
	            if (token() === 64 /* EqualsToken */)
	              node.initializer = parseInitializer();
	          }
	          parseTypeMemberSemicolon();
	          return withJSDoc(finishNode(node, pos), hasJSDoc);
	        }
	        function isTypeMemberStart() {
	          if (token() === 21 /* OpenParenToken */ || token() === 30 /* LessThanToken */ || token() === 139 /* GetKeyword */ || token() === 153 /* SetKeyword */) {
	            return true;
	          }
	          let idToken = false;
	          while (isModifierKind(token())) {
	            idToken = true;
	            nextToken();
	          }
	          if (token() === 23 /* OpenBracketToken */) {
	            return true;
	          }
	          if (isLiteralPropertyName()) {
	            idToken = true;
	            nextToken();
	          }
	          if (idToken) {
	            return token() === 21 /* OpenParenToken */ || token() === 30 /* LessThanToken */ || token() === 58 /* QuestionToken */ || token() === 59 /* ColonToken */ || token() === 28 /* CommaToken */ || canParseSemicolon();
	          }
	          return false;
	        }
	        function parseTypeMember() {
	          if (token() === 21 /* OpenParenToken */ || token() === 30 /* LessThanToken */) {
	            return parseSignatureMember(179 /* CallSignature */);
	          }
	          if (token() === 105 /* NewKeyword */ && lookAhead(nextTokenIsOpenParenOrLessThan)) {
	            return parseSignatureMember(180 /* ConstructSignature */);
	          }
	          const pos = getNodePos();
	          const hasJSDoc = hasPrecedingJSDocComment();
	          const modifiers = parseModifiers(
	            /*allowDecorators*/
	            false
	          );
	          if (parseContextualModifier(139 /* GetKeyword */)) {
	            return parseAccessorDeclaration(pos, hasJSDoc, modifiers, 177 /* GetAccessor */, 4 /* Type */);
	          }
	          if (parseContextualModifier(153 /* SetKeyword */)) {
	            return parseAccessorDeclaration(pos, hasJSDoc, modifiers, 178 /* SetAccessor */, 4 /* Type */);
	          }
	          if (isIndexSignature()) {
	            return parseIndexSignatureDeclaration(pos, hasJSDoc, modifiers);
	          }
	          return parsePropertyOrMethodSignature(pos, hasJSDoc, modifiers);
	        }
	        function nextTokenIsOpenParenOrLessThan() {
	          nextToken();
	          return token() === 21 /* OpenParenToken */ || token() === 30 /* LessThanToken */;
	        }
	        function nextTokenIsDot() {
	          return nextToken() === 25 /* DotToken */;
	        }
	        function nextTokenIsOpenParenOrLessThanOrDot() {
	          switch (nextToken()) {
	            case 21 /* OpenParenToken */:
	            case 30 /* LessThanToken */:
	            case 25 /* DotToken */:
	              return true;
	          }
	          return false;
	        }
	        function parseTypeLiteral() {
	          const pos = getNodePos();
	          return finishNode(factory2.createTypeLiteralNode(parseObjectTypeMembers()), pos);
	        }
	        function parseObjectTypeMembers() {
	          let members;
	          if (parseExpected(19 /* OpenBraceToken */)) {
	            members = parseList(4 /* TypeMembers */, parseTypeMember);
	            parseExpected(20 /* CloseBraceToken */);
	          } else {
	            members = createMissingList();
	          }
	          return members;
	        }
	        function isStartOfMappedType() {
	          nextToken();
	          if (token() === 40 /* PlusToken */ || token() === 41 /* MinusToken */) {
	            return nextToken() === 148 /* ReadonlyKeyword */;
	          }
	          if (token() === 148 /* ReadonlyKeyword */) {
	            nextToken();
	          }
	          return token() === 23 /* OpenBracketToken */ && nextTokenIsIdentifier() && nextToken() === 103 /* InKeyword */;
	        }
	        function parseMappedTypeParameter() {
	          const pos = getNodePos();
	          const name = parseIdentifierName();
	          parseExpected(103 /* InKeyword */);
	          const type = parseType();
	          return finishNode(factory2.createTypeParameterDeclaration(
	            /*modifiers*/
	            void 0,
	            name,
	            type,
	            /*defaultType*/
	            void 0
	          ), pos);
	        }
	        function parseMappedType() {
	          const pos = getNodePos();
	          parseExpected(19 /* OpenBraceToken */);
	          let readonlyToken;
	          if (token() === 148 /* ReadonlyKeyword */ || token() === 40 /* PlusToken */ || token() === 41 /* MinusToken */) {
	            readonlyToken = parseTokenNode();
	            if (readonlyToken.kind !== 148 /* ReadonlyKeyword */) {
	              parseExpected(148 /* ReadonlyKeyword */);
	            }
	          }
	          parseExpected(23 /* OpenBracketToken */);
	          const typeParameter = parseMappedTypeParameter();
	          const nameType = parseOptional(130 /* AsKeyword */) ? parseType() : void 0;
	          parseExpected(24 /* CloseBracketToken */);
	          let questionToken;
	          if (token() === 58 /* QuestionToken */ || token() === 40 /* PlusToken */ || token() === 41 /* MinusToken */) {
	            questionToken = parseTokenNode();
	            if (questionToken.kind !== 58 /* QuestionToken */) {
	              parseExpected(58 /* QuestionToken */);
	            }
	          }
	          const type = parseTypeAnnotation();
	          parseSemicolon();
	          const members = parseList(4 /* TypeMembers */, parseTypeMember);
	          parseExpected(20 /* CloseBraceToken */);
	          return finishNode(factory2.createMappedTypeNode(readonlyToken, typeParameter, nameType, questionToken, type, members), pos);
	        }
	        function parseTupleElementType() {
	          const pos = getNodePos();
	          if (parseOptional(26 /* DotDotDotToken */)) {
	            return finishNode(factory2.createRestTypeNode(parseType()), pos);
	          }
	          const type = parseType();
	          if (isJSDocNullableType(type) && type.pos === type.type.pos) {
	            const node = factory2.createOptionalTypeNode(type.type);
	            setTextRange(node, type);
	            node.flags = type.flags;
	            return node;
	          }
	          return type;
	        }
	        function isNextTokenColonOrQuestionColon() {
	          return nextToken() === 59 /* ColonToken */ || token() === 58 /* QuestionToken */ && nextToken() === 59 /* ColonToken */;
	        }
	        function isTupleElementName() {
	          if (token() === 26 /* DotDotDotToken */) {
	            return tokenIsIdentifierOrKeyword(nextToken()) && isNextTokenColonOrQuestionColon();
	          }
	          return tokenIsIdentifierOrKeyword(token()) && isNextTokenColonOrQuestionColon();
	        }
	        function parseTupleElementNameOrTupleElementType() {
	          if (lookAhead(isTupleElementName)) {
	            const pos = getNodePos();
	            const hasJSDoc = hasPrecedingJSDocComment();
	            const dotDotDotToken = parseOptionalToken(26 /* DotDotDotToken */);
	            const name = parseIdentifierName();
	            const questionToken = parseOptionalToken(58 /* QuestionToken */);
	            parseExpected(59 /* ColonToken */);
	            const type = parseTupleElementType();
	            const node = factory2.createNamedTupleMember(dotDotDotToken, name, questionToken, type);
	            return withJSDoc(finishNode(node, pos), hasJSDoc);
	          }
	          return parseTupleElementType();
	        }
	        function parseTupleType() {
	          const pos = getNodePos();
	          return finishNode(
	            factory2.createTupleTypeNode(
	              parseBracketedList(21 /* TupleElementTypes */, parseTupleElementNameOrTupleElementType, 23 /* OpenBracketToken */, 24 /* CloseBracketToken */)
	            ),
	            pos
	          );
	        }
	        function parseParenthesizedType() {
	          const pos = getNodePos();
	          parseExpected(21 /* OpenParenToken */);
	          const type = parseType();
	          parseExpected(22 /* CloseParenToken */);
	          return finishNode(factory2.createParenthesizedType(type), pos);
	        }
	        function parseModifiersForConstructorType() {
	          let modifiers;
	          if (token() === 128 /* AbstractKeyword */) {
	            const pos = getNodePos();
	            nextToken();
	            const modifier = finishNode(factoryCreateToken(128 /* AbstractKeyword */), pos);
	            modifiers = createNodeArray([modifier], pos);
	          }
	          return modifiers;
	        }
	        function parseFunctionOrConstructorType() {
	          const pos = getNodePos();
	          const hasJSDoc = hasPrecedingJSDocComment();
	          const modifiers = parseModifiersForConstructorType();
	          const isConstructorType = parseOptional(105 /* NewKeyword */);
	          Debug.assert(!modifiers || isConstructorType, "Per isStartOfFunctionOrConstructorType, a function type cannot have modifiers.");
	          const typeParameters = parseTypeParameters();
	          const parameters = parseParameters(4 /* Type */);
	          const type = parseReturnType(
	            39 /* EqualsGreaterThanToken */,
	            /*isType*/
	            false
	          );
	          const node = isConstructorType ? factory2.createConstructorTypeNode(modifiers, typeParameters, parameters, type) : factory2.createFunctionTypeNode(typeParameters, parameters, type);
	          return withJSDoc(finishNode(node, pos), hasJSDoc);
	        }
	        function parseKeywordAndNoDot() {
	          const node = parseTokenNode();
	          return token() === 25 /* DotToken */ ? void 0 : node;
	        }
	        function parseLiteralTypeNode(negative) {
	          const pos = getNodePos();
	          if (negative) {
	            nextToken();
	          }
	          let expression = token() === 112 /* TrueKeyword */ || token() === 97 /* FalseKeyword */ || token() === 106 /* NullKeyword */ ? parseTokenNode() : parseLiteralLikeNode(token());
	          if (negative) {
	            expression = finishNode(factory2.createPrefixUnaryExpression(41 /* MinusToken */, expression), pos);
	          }
	          return finishNode(factory2.createLiteralTypeNode(expression), pos);
	        }
	        function isStartOfTypeOfImportType() {
	          nextToken();
	          return token() === 102 /* ImportKeyword */;
	        }
	        function parseImportType() {
	          sourceFlags |= 4194304 /* PossiblyContainsDynamicImport */;
	          const pos = getNodePos();
	          const isTypeOf = parseOptional(114 /* TypeOfKeyword */);
	          parseExpected(102 /* ImportKeyword */);
	          parseExpected(21 /* OpenParenToken */);
	          const type = parseType();
	          let attributes;
	          if (parseOptional(28 /* CommaToken */)) {
	            const openBracePosition = scanner2.getTokenStart();
	            parseExpected(19 /* OpenBraceToken */);
	            const currentToken2 = token();
	            if (currentToken2 === 118 /* WithKeyword */ || currentToken2 === 132 /* AssertKeyword */) {
	              nextToken();
	            } else {
	              parseErrorAtCurrentToken(Diagnostics._0_expected, tokenToString(118 /* WithKeyword */));
	            }
	            parseExpected(59 /* ColonToken */);
	            attributes = parseImportAttributes(
	              currentToken2,
	              /*skipKeyword*/
	              true
	            );
	            if (!parseExpected(20 /* CloseBraceToken */)) {
	              const lastError = lastOrUndefined(parseDiagnostics);
	              if (lastError && lastError.code === Diagnostics._0_expected.code) {
	                addRelatedInfo(
	                  lastError,
	                  createDetachedDiagnostic(fileName, sourceText, openBracePosition, 1, Diagnostics.The_parser_expected_to_find_a_1_to_match_the_0_token_here, "{", "}")
	                );
	              }
	            }
	          }
	          parseExpected(22 /* CloseParenToken */);
	          const qualifier = parseOptional(25 /* DotToken */) ? parseEntityNameOfTypeReference() : void 0;
	          const typeArguments = parseTypeArgumentsOfTypeReference();
	          return finishNode(factory2.createImportTypeNode(type, attributes, qualifier, typeArguments, isTypeOf), pos);
	        }
	        function nextTokenIsNumericOrBigIntLiteral() {
	          nextToken();
	          return token() === 9 /* NumericLiteral */ || token() === 10 /* BigIntLiteral */;
	        }
	        function parseNonArrayType() {
	          switch (token()) {
	            case 133 /* AnyKeyword */:
	            case 159 /* UnknownKeyword */:
	            case 154 /* StringKeyword */:
	            case 150 /* NumberKeyword */:
	            case 163 /* BigIntKeyword */:
	            case 155 /* SymbolKeyword */:
	            case 136 /* BooleanKeyword */:
	            case 157 /* UndefinedKeyword */:
	            case 146 /* NeverKeyword */:
	            case 151 /* ObjectKeyword */:
	              return tryParse(parseKeywordAndNoDot) || parseTypeReference();
	            case 67 /* AsteriskEqualsToken */:
	              scanner2.reScanAsteriskEqualsToken();
	            case 42 /* AsteriskToken */:
	              return parseJSDocAllType();
	            case 61 /* QuestionQuestionToken */:
	              scanner2.reScanQuestionToken();
	            case 58 /* QuestionToken */:
	              return parseJSDocUnknownOrNullableType();
	            case 100 /* FunctionKeyword */:
	              return parseJSDocFunctionType();
	            case 54 /* ExclamationToken */:
	              return parseJSDocNonNullableType();
	            case 15 /* NoSubstitutionTemplateLiteral */:
	            case 11 /* StringLiteral */:
	            case 9 /* NumericLiteral */:
	            case 10 /* BigIntLiteral */:
	            case 112 /* TrueKeyword */:
	            case 97 /* FalseKeyword */:
	            case 106 /* NullKeyword */:
	              return parseLiteralTypeNode();
	            case 41 /* MinusToken */:
	              return lookAhead(nextTokenIsNumericOrBigIntLiteral) ? parseLiteralTypeNode(
	                /*negative*/
	                true
	              ) : parseTypeReference();
	            case 116 /* VoidKeyword */:
	              return parseTokenNode();
	            case 110 /* ThisKeyword */: {
	              const thisKeyword = parseThisTypeNode();
	              if (token() === 142 /* IsKeyword */ && !scanner2.hasPrecedingLineBreak()) {
	                return parseThisTypePredicate(thisKeyword);
	              } else {
	                return thisKeyword;
	              }
	            }
	            case 114 /* TypeOfKeyword */:
	              return lookAhead(isStartOfTypeOfImportType) ? parseImportType() : parseTypeQuery();
	            case 19 /* OpenBraceToken */:
	              return lookAhead(isStartOfMappedType) ? parseMappedType() : parseTypeLiteral();
	            case 23 /* OpenBracketToken */:
	              return parseTupleType();
	            case 21 /* OpenParenToken */:
	              return parseParenthesizedType();
	            case 102 /* ImportKeyword */:
	              return parseImportType();
	            case 131 /* AssertsKeyword */:
	              return lookAhead(nextTokenIsIdentifierOrKeywordOnSameLine) ? parseAssertsTypePredicate() : parseTypeReference();
	            case 16 /* TemplateHead */:
	              return parseTemplateType();
	            default:
	              return parseTypeReference();
	          }
	        }
	        function isStartOfType(inStartOfParameter) {
	          switch (token()) {
	            case 133 /* AnyKeyword */:
	            case 159 /* UnknownKeyword */:
	            case 154 /* StringKeyword */:
	            case 150 /* NumberKeyword */:
	            case 163 /* BigIntKeyword */:
	            case 136 /* BooleanKeyword */:
	            case 148 /* ReadonlyKeyword */:
	            case 155 /* SymbolKeyword */:
	            case 158 /* UniqueKeyword */:
	            case 116 /* VoidKeyword */:
	            case 157 /* UndefinedKeyword */:
	            case 106 /* NullKeyword */:
	            case 110 /* ThisKeyword */:
	            case 114 /* TypeOfKeyword */:
	            case 146 /* NeverKeyword */:
	            case 19 /* OpenBraceToken */:
	            case 23 /* OpenBracketToken */:
	            case 30 /* LessThanToken */:
	            case 52 /* BarToken */:
	            case 51 /* AmpersandToken */:
	            case 105 /* NewKeyword */:
	            case 11 /* StringLiteral */:
	            case 9 /* NumericLiteral */:
	            case 10 /* BigIntLiteral */:
	            case 112 /* TrueKeyword */:
	            case 97 /* FalseKeyword */:
	            case 151 /* ObjectKeyword */:
	            case 42 /* AsteriskToken */:
	            case 58 /* QuestionToken */:
	            case 54 /* ExclamationToken */:
	            case 26 /* DotDotDotToken */:
	            case 140 /* InferKeyword */:
	            case 102 /* ImportKeyword */:
	            case 131 /* AssertsKeyword */:
	            case 15 /* NoSubstitutionTemplateLiteral */:
	            case 16 /* TemplateHead */:
	              return true;
	            case 100 /* FunctionKeyword */:
	              return !inStartOfParameter;
	            case 41 /* MinusToken */:
	              return !inStartOfParameter && lookAhead(nextTokenIsNumericOrBigIntLiteral);
	            case 21 /* OpenParenToken */:
	              return !inStartOfParameter && lookAhead(isStartOfParenthesizedOrFunctionType);
	            default:
	              return isIdentifier2();
	          }
	        }
	        function isStartOfParenthesizedOrFunctionType() {
	          nextToken();
	          return token() === 22 /* CloseParenToken */ || isStartOfParameter(
	            /*isJSDocParameter*/
	            false
	          ) || isStartOfType();
	        }
	        function parsePostfixTypeOrHigher() {
	          const pos = getNodePos();
	          let type = parseNonArrayType();
	          while (!scanner2.hasPrecedingLineBreak()) {
	            switch (token()) {
	              case 54 /* ExclamationToken */:
	                nextToken();
	                type = finishNode(factory2.createJSDocNonNullableType(
	                  type,
	                  /*postfix*/
	                  true
	                ), pos);
	                break;
	              case 58 /* QuestionToken */:
	                if (lookAhead(nextTokenIsStartOfType)) {
	                  return type;
	                }
	                nextToken();
	                type = finishNode(factory2.createJSDocNullableType(
	                  type,
	                  /*postfix*/
	                  true
	                ), pos);
	                break;
	              case 23 /* OpenBracketToken */:
	                parseExpected(23 /* OpenBracketToken */);
	                if (isStartOfType()) {
	                  const indexType = parseType();
	                  parseExpected(24 /* CloseBracketToken */);
	                  type = finishNode(factory2.createIndexedAccessTypeNode(type, indexType), pos);
	                } else {
	                  parseExpected(24 /* CloseBracketToken */);
	                  type = finishNode(factory2.createArrayTypeNode(type), pos);
	                }
	                break;
	              default:
	                return type;
	            }
	          }
	          return type;
	        }
	        function parseTypeOperator(operator) {
	          const pos = getNodePos();
	          parseExpected(operator);
	          return finishNode(factory2.createTypeOperatorNode(operator, parseTypeOperatorOrHigher()), pos);
	        }
	        function tryParseConstraintOfInferType() {
	          if (parseOptional(96 /* ExtendsKeyword */)) {
	            const constraint = disallowConditionalTypesAnd(parseType);
	            if (inDisallowConditionalTypesContext() || token() !== 58 /* QuestionToken */) {
	              return constraint;
	            }
	          }
	        }
	        function parseTypeParameterOfInferType() {
	          const pos = getNodePos();
	          const name = parseIdentifier();
	          const constraint = tryParse(tryParseConstraintOfInferType);
	          const node = factory2.createTypeParameterDeclaration(
	            /*modifiers*/
	            void 0,
	            name,
	            constraint
	          );
	          return finishNode(node, pos);
	        }
	        function parseInferType() {
	          const pos = getNodePos();
	          parseExpected(140 /* InferKeyword */);
	          return finishNode(factory2.createInferTypeNode(parseTypeParameterOfInferType()), pos);
	        }
	        function parseTypeOperatorOrHigher() {
	          const operator = token();
	          switch (operator) {
	            case 143 /* KeyOfKeyword */:
	            case 158 /* UniqueKeyword */:
	            case 148 /* ReadonlyKeyword */:
	              return parseTypeOperator(operator);
	            case 140 /* InferKeyword */:
	              return parseInferType();
	          }
	          return allowConditionalTypesAnd(parsePostfixTypeOrHigher);
	        }
	        function parseFunctionOrConstructorTypeToError(isInUnionType) {
	          if (isStartOfFunctionTypeOrConstructorType()) {
	            const type = parseFunctionOrConstructorType();
	            let diagnostic;
	            if (isFunctionTypeNode(type)) {
	              diagnostic = isInUnionType ? Diagnostics.Function_type_notation_must_be_parenthesized_when_used_in_a_union_type : Diagnostics.Function_type_notation_must_be_parenthesized_when_used_in_an_intersection_type;
	            } else {
	              diagnostic = isInUnionType ? Diagnostics.Constructor_type_notation_must_be_parenthesized_when_used_in_a_union_type : Diagnostics.Constructor_type_notation_must_be_parenthesized_when_used_in_an_intersection_type;
	            }
	            parseErrorAtRange(type, diagnostic);
	            return type;
	          }
	          return void 0;
	        }
	        function parseUnionOrIntersectionType(operator, parseConstituentType, createTypeNode) {
	          const pos = getNodePos();
	          const isUnionType = operator === 52 /* BarToken */;
	          const hasLeadingOperator = parseOptional(operator);
	          let type = hasLeadingOperator && parseFunctionOrConstructorTypeToError(isUnionType) || parseConstituentType();
	          if (token() === operator || hasLeadingOperator) {
	            const types = [type];
	            while (parseOptional(operator)) {
	              types.push(parseFunctionOrConstructorTypeToError(isUnionType) || parseConstituentType());
	            }
	            type = finishNode(createTypeNode(createNodeArray(types, pos)), pos);
	          }
	          return type;
	        }
	        function parseIntersectionTypeOrHigher() {
	          return parseUnionOrIntersectionType(51 /* AmpersandToken */, parseTypeOperatorOrHigher, factory2.createIntersectionTypeNode);
	        }
	        function parseUnionTypeOrHigher() {
	          return parseUnionOrIntersectionType(52 /* BarToken */, parseIntersectionTypeOrHigher, factory2.createUnionTypeNode);
	        }
	        function nextTokenIsNewKeyword() {
	          nextToken();
	          return token() === 105 /* NewKeyword */;
	        }
	        function isStartOfFunctionTypeOrConstructorType() {
	          if (token() === 30 /* LessThanToken */) {
	            return true;
	          }
	          if (token() === 21 /* OpenParenToken */ && lookAhead(isUnambiguouslyStartOfFunctionType)) {
	            return true;
	          }
	          return token() === 105 /* NewKeyword */ || token() === 128 /* AbstractKeyword */ && lookAhead(nextTokenIsNewKeyword);
	        }
	        function skipParameterStart() {
	          if (isModifierKind(token())) {
	            parseModifiers(
	              /*allowDecorators*/
	              false
	            );
	          }
	          if (isIdentifier2() || token() === 110 /* ThisKeyword */) {
	            nextToken();
	            return true;
	          }
	          if (token() === 23 /* OpenBracketToken */ || token() === 19 /* OpenBraceToken */) {
	            const previousErrorCount = parseDiagnostics.length;
	            parseIdentifierOrPattern();
	            return previousErrorCount === parseDiagnostics.length;
	          }
	          return false;
	        }
	        function isUnambiguouslyStartOfFunctionType() {
	          nextToken();
	          if (token() === 22 /* CloseParenToken */ || token() === 26 /* DotDotDotToken */) {
	            return true;
	          }
	          if (skipParameterStart()) {
	            if (token() === 59 /* ColonToken */ || token() === 28 /* CommaToken */ || token() === 58 /* QuestionToken */ || token() === 64 /* EqualsToken */) {
	              return true;
	            }
	            if (token() === 22 /* CloseParenToken */) {
	              nextToken();
	              if (token() === 39 /* EqualsGreaterThanToken */) {
	                return true;
	              }
	            }
	          }
	          return false;
	        }
	        function parseTypeOrTypePredicate() {
	          const pos = getNodePos();
	          const typePredicateVariable = isIdentifier2() && tryParse(parseTypePredicatePrefix);
	          const type = parseType();
	          if (typePredicateVariable) {
	            return finishNode(factory2.createTypePredicateNode(
	              /*assertsModifier*/
	              void 0,
	              typePredicateVariable,
	              type
	            ), pos);
	          } else {
	            return type;
	          }
	        }
	        function parseTypePredicatePrefix() {
	          const id = parseIdentifier();
	          if (token() === 142 /* IsKeyword */ && !scanner2.hasPrecedingLineBreak()) {
	            nextToken();
	            return id;
	          }
	        }
	        function parseAssertsTypePredicate() {
	          const pos = getNodePos();
	          const assertsModifier = parseExpectedToken(131 /* AssertsKeyword */);
	          const parameterName = token() === 110 /* ThisKeyword */ ? parseThisTypeNode() : parseIdentifier();
	          const type = parseOptional(142 /* IsKeyword */) ? parseType() : void 0;
	          return finishNode(factory2.createTypePredicateNode(assertsModifier, parameterName, type), pos);
	        }
	        function parseType() {
	          if (contextFlags & 81920 /* TypeExcludesFlags */) {
	            return doOutsideOfContext(81920 /* TypeExcludesFlags */, parseType);
	          }
	          if (isStartOfFunctionTypeOrConstructorType()) {
	            return parseFunctionOrConstructorType();
	          }
	          const pos = getNodePos();
	          const type = parseUnionTypeOrHigher();
	          if (!inDisallowConditionalTypesContext() && !scanner2.hasPrecedingLineBreak() && parseOptional(96 /* ExtendsKeyword */)) {
	            const extendsType = disallowConditionalTypesAnd(parseType);
	            parseExpected(58 /* QuestionToken */);
	            const trueType = allowConditionalTypesAnd(parseType);
	            parseExpected(59 /* ColonToken */);
	            const falseType = allowConditionalTypesAnd(parseType);
	            return finishNode(factory2.createConditionalTypeNode(type, extendsType, trueType, falseType), pos);
	          }
	          return type;
	        }
	        function parseTypeAnnotation() {
	          return parseOptional(59 /* ColonToken */) ? parseType() : void 0;
	        }
	        function isStartOfLeftHandSideExpression() {
	          switch (token()) {
	            case 110 /* ThisKeyword */:
	            case 108 /* SuperKeyword */:
	            case 106 /* NullKeyword */:
	            case 112 /* TrueKeyword */:
	            case 97 /* FalseKeyword */:
	            case 9 /* NumericLiteral */:
	            case 10 /* BigIntLiteral */:
	            case 11 /* StringLiteral */:
	            case 15 /* NoSubstitutionTemplateLiteral */:
	            case 16 /* TemplateHead */:
	            case 21 /* OpenParenToken */:
	            case 23 /* OpenBracketToken */:
	            case 19 /* OpenBraceToken */:
	            case 100 /* FunctionKeyword */:
	            case 86 /* ClassKeyword */:
	            case 105 /* NewKeyword */:
	            case 44 /* SlashToken */:
	            case 69 /* SlashEqualsToken */:
	            case 80 /* Identifier */:
	              return true;
	            case 102 /* ImportKeyword */:
	              return lookAhead(nextTokenIsOpenParenOrLessThanOrDot);
	            default:
	              return isIdentifier2();
	          }
	        }
	        function isStartOfExpression() {
	          if (isStartOfLeftHandSideExpression()) {
	            return true;
	          }
	          switch (token()) {
	            case 40 /* PlusToken */:
	            case 41 /* MinusToken */:
	            case 55 /* TildeToken */:
	            case 54 /* ExclamationToken */:
	            case 91 /* DeleteKeyword */:
	            case 114 /* TypeOfKeyword */:
	            case 116 /* VoidKeyword */:
	            case 46 /* PlusPlusToken */:
	            case 47 /* MinusMinusToken */:
	            case 30 /* LessThanToken */:
	            case 135 /* AwaitKeyword */:
	            case 127 /* YieldKeyword */:
	            case 81 /* PrivateIdentifier */:
	            case 60 /* AtToken */:
	              return true;
	            default:
	              if (isBinaryOperator2()) {
	                return true;
	              }
	              return isIdentifier2();
	          }
	        }
	        function isStartOfExpressionStatement() {
	          return token() !== 19 /* OpenBraceToken */ && token() !== 100 /* FunctionKeyword */ && token() !== 86 /* ClassKeyword */ && token() !== 60 /* AtToken */ && isStartOfExpression();
	        }
	        function parseExpression() {
	          const saveDecoratorContext = inDecoratorContext();
	          if (saveDecoratorContext) {
	            setDecoratorContext(
	              /*val*/
	              false
	            );
	          }
	          const pos = getNodePos();
	          let expr = parseAssignmentExpressionOrHigher(
	            /*allowReturnTypeInArrowFunction*/
	            true
	          );
	          let operatorToken;
	          while (operatorToken = parseOptionalToken(28 /* CommaToken */)) {
	            expr = makeBinaryExpression(expr, operatorToken, parseAssignmentExpressionOrHigher(
	              /*allowReturnTypeInArrowFunction*/
	              true
	            ), pos);
	          }
	          if (saveDecoratorContext) {
	            setDecoratorContext(
	              /*val*/
	              true
	            );
	          }
	          return expr;
	        }
	        function parseInitializer() {
	          return parseOptional(64 /* EqualsToken */) ? parseAssignmentExpressionOrHigher(
	            /*allowReturnTypeInArrowFunction*/
	            true
	          ) : void 0;
	        }
	        function parseAssignmentExpressionOrHigher(allowReturnTypeInArrowFunction) {
	          if (isYieldExpression2()) {
	            return parseYieldExpression();
	          }
	          const arrowExpression = tryParseParenthesizedArrowFunctionExpression(allowReturnTypeInArrowFunction) || tryParseAsyncSimpleArrowFunctionExpression(allowReturnTypeInArrowFunction);
	          if (arrowExpression) {
	            return arrowExpression;
	          }
	          const pos = getNodePos();
	          const hasJSDoc = hasPrecedingJSDocComment();
	          const expr = parseBinaryExpressionOrHigher(0 /* Lowest */);
	          if (expr.kind === 80 /* Identifier */ && token() === 39 /* EqualsGreaterThanToken */) {
	            return parseSimpleArrowFunctionExpression(
	              pos,
	              expr,
	              allowReturnTypeInArrowFunction,
	              hasJSDoc,
	              /*asyncModifier*/
	              void 0
	            );
	          }
	          if (isLeftHandSideExpression(expr) && isAssignmentOperator(reScanGreaterToken())) {
	            return makeBinaryExpression(expr, parseTokenNode(), parseAssignmentExpressionOrHigher(allowReturnTypeInArrowFunction), pos);
	          }
	          return parseConditionalExpressionRest(expr, pos, allowReturnTypeInArrowFunction);
	        }
	        function isYieldExpression2() {
	          if (token() === 127 /* YieldKeyword */) {
	            if (inYieldContext()) {
	              return true;
	            }
	            return lookAhead(nextTokenIsIdentifierOrKeywordOrLiteralOnSameLine);
	          }
	          return false;
	        }
	        function nextTokenIsIdentifierOnSameLine() {
	          nextToken();
	          return !scanner2.hasPrecedingLineBreak() && isIdentifier2();
	        }
	        function parseYieldExpression() {
	          const pos = getNodePos();
	          nextToken();
	          if (!scanner2.hasPrecedingLineBreak() && (token() === 42 /* AsteriskToken */ || isStartOfExpression())) {
	            return finishNode(
	              factory2.createYieldExpression(
	                parseOptionalToken(42 /* AsteriskToken */),
	                parseAssignmentExpressionOrHigher(
	                  /*allowReturnTypeInArrowFunction*/
	                  true
	                )
	              ),
	              pos
	            );
	          } else {
	            return finishNode(factory2.createYieldExpression(
	              /*asteriskToken*/
	              void 0,
	              /*expression*/
	              void 0
	            ), pos);
	          }
	        }
	        function parseSimpleArrowFunctionExpression(pos, identifier, allowReturnTypeInArrowFunction, hasJSDoc, asyncModifier) {
	          Debug.assert(token() === 39 /* EqualsGreaterThanToken */, "parseSimpleArrowFunctionExpression should only have been called if we had a =>");
	          const parameter = factory2.createParameterDeclaration(
	            /*modifiers*/
	            void 0,
	            /*dotDotDotToken*/
	            void 0,
	            identifier,
	            /*questionToken*/
	            void 0,
	            /*type*/
	            void 0,
	            /*initializer*/
	            void 0
	          );
	          finishNode(parameter, identifier.pos);
	          const parameters = createNodeArray([parameter], parameter.pos, parameter.end);
	          const equalsGreaterThanToken = parseExpectedToken(39 /* EqualsGreaterThanToken */);
	          const body = parseArrowFunctionExpressionBody(
	            /*isAsync*/
	            !!asyncModifier,
	            allowReturnTypeInArrowFunction
	          );
	          const node = factory2.createArrowFunction(
	            asyncModifier,
	            /*typeParameters*/
	            void 0,
	            parameters,
	            /*type*/
	            void 0,
	            equalsGreaterThanToken,
	            body
	          );
	          return withJSDoc(finishNode(node, pos), hasJSDoc);
	        }
	        function tryParseParenthesizedArrowFunctionExpression(allowReturnTypeInArrowFunction) {
	          const triState = isParenthesizedArrowFunctionExpression();
	          if (triState === 0 /* False */) {
	            return void 0;
	          }
	          return triState === 1 /* True */ ? parseParenthesizedArrowFunctionExpression(
	            /*allowAmbiguity*/
	            true,
	            /*allowReturnTypeInArrowFunction*/
	            true
	          ) : tryParse(() => parsePossibleParenthesizedArrowFunctionExpression(allowReturnTypeInArrowFunction));
	        }
	        function isParenthesizedArrowFunctionExpression() {
	          if (token() === 21 /* OpenParenToken */ || token() === 30 /* LessThanToken */ || token() === 134 /* AsyncKeyword */) {
	            return lookAhead(isParenthesizedArrowFunctionExpressionWorker);
	          }
	          if (token() === 39 /* EqualsGreaterThanToken */) {
	            return 1 /* True */;
	          }
	          return 0 /* False */;
	        }
	        function isParenthesizedArrowFunctionExpressionWorker() {
	          if (token() === 134 /* AsyncKeyword */) {
	            nextToken();
	            if (scanner2.hasPrecedingLineBreak()) {
	              return 0 /* False */;
	            }
	            if (token() !== 21 /* OpenParenToken */ && token() !== 30 /* LessThanToken */) {
	              return 0 /* False */;
	            }
	          }
	          const first2 = token();
	          const second = nextToken();
	          if (first2 === 21 /* OpenParenToken */) {
	            if (second === 22 /* CloseParenToken */) {
	              const third = nextToken();
	              switch (third) {
	                case 39 /* EqualsGreaterThanToken */:
	                case 59 /* ColonToken */:
	                case 19 /* OpenBraceToken */:
	                  return 1 /* True */;
	                default:
	                  return 0 /* False */;
	              }
	            }
	            if (second === 23 /* OpenBracketToken */ || second === 19 /* OpenBraceToken */) {
	              return 2 /* Unknown */;
	            }
	            if (second === 26 /* DotDotDotToken */) {
	              return 1 /* True */;
	            }
	            if (isModifierKind(second) && second !== 134 /* AsyncKeyword */ && lookAhead(nextTokenIsIdentifier)) {
	              if (nextToken() === 130 /* AsKeyword */) {
	                return 0 /* False */;
	              }
	              return 1 /* True */;
	            }
	            if (!isIdentifier2() && second !== 110 /* ThisKeyword */) {
	              return 0 /* False */;
	            }
	            switch (nextToken()) {
	              case 59 /* ColonToken */:
	                return 1 /* True */;
	              case 58 /* QuestionToken */:
	                nextToken();
	                if (token() === 59 /* ColonToken */ || token() === 28 /* CommaToken */ || token() === 64 /* EqualsToken */ || token() === 22 /* CloseParenToken */) {
	                  return 1 /* True */;
	                }
	                return 0 /* False */;
	              case 28 /* CommaToken */:
	              case 64 /* EqualsToken */:
	              case 22 /* CloseParenToken */:
	                return 2 /* Unknown */;
	            }
	            return 0 /* False */;
	          } else {
	            Debug.assert(first2 === 30 /* LessThanToken */);
	            if (!isIdentifier2() && token() !== 87 /* ConstKeyword */) {
	              return 0 /* False */;
	            }
	            if (languageVariant === 1 /* JSX */) {
	              const isArrowFunctionInJsx = lookAhead(() => {
	                parseOptional(87 /* ConstKeyword */);
	                const third = nextToken();
	                if (third === 96 /* ExtendsKeyword */) {
	                  const fourth = nextToken();
	                  switch (fourth) {
	                    case 64 /* EqualsToken */:
	                    case 32 /* GreaterThanToken */:
	                    case 44 /* SlashToken */:
	                      return false;
	                    default:
	                      return true;
	                  }
	                } else if (third === 28 /* CommaToken */ || third === 64 /* EqualsToken */) {
	                  return true;
	                }
	                return false;
	              });
	              if (isArrowFunctionInJsx) {
	                return 1 /* True */;
	              }
	              return 0 /* False */;
	            }
	            return 2 /* Unknown */;
	          }
	        }
	        function parsePossibleParenthesizedArrowFunctionExpression(allowReturnTypeInArrowFunction) {
	          const tokenPos = scanner2.getTokenStart();
	          if (notParenthesizedArrow == null ? void 0 : notParenthesizedArrow.has(tokenPos)) {
	            return void 0;
	          }
	          const result = parseParenthesizedArrowFunctionExpression(
	            /*allowAmbiguity*/
	            false,
	            allowReturnTypeInArrowFunction
	          );
	          if (!result) {
	            (notParenthesizedArrow || (notParenthesizedArrow = /* @__PURE__ */ new Set())).add(tokenPos);
	          }
	          return result;
	        }
	        function tryParseAsyncSimpleArrowFunctionExpression(allowReturnTypeInArrowFunction) {
	          if (token() === 134 /* AsyncKeyword */) {
	            if (lookAhead(isUnParenthesizedAsyncArrowFunctionWorker) === 1 /* True */) {
	              const pos = getNodePos();
	              const hasJSDoc = hasPrecedingJSDocComment();
	              const asyncModifier = parseModifiersForArrowFunction();
	              const expr = parseBinaryExpressionOrHigher(0 /* Lowest */);
	              return parseSimpleArrowFunctionExpression(pos, expr, allowReturnTypeInArrowFunction, hasJSDoc, asyncModifier);
	            }
	          }
	          return void 0;
	        }
	        function isUnParenthesizedAsyncArrowFunctionWorker() {
	          if (token() === 134 /* AsyncKeyword */) {
	            nextToken();
	            if (scanner2.hasPrecedingLineBreak() || token() === 39 /* EqualsGreaterThanToken */) {
	              return 0 /* False */;
	            }
	            const expr = parseBinaryExpressionOrHigher(0 /* Lowest */);
	            if (!scanner2.hasPrecedingLineBreak() && expr.kind === 80 /* Identifier */ && token() === 39 /* EqualsGreaterThanToken */) {
	              return 1 /* True */;
	            }
	          }
	          return 0 /* False */;
	        }
	        function parseParenthesizedArrowFunctionExpression(allowAmbiguity, allowReturnTypeInArrowFunction) {
	          const pos = getNodePos();
	          const hasJSDoc = hasPrecedingJSDocComment();
	          const modifiers = parseModifiersForArrowFunction();
	          const isAsync = some(modifiers, isAsyncModifier) ? 2 /* Await */ : 0 /* None */;
	          const typeParameters = parseTypeParameters();
	          let parameters;
	          if (!parseExpected(21 /* OpenParenToken */)) {
	            if (!allowAmbiguity) {
	              return void 0;
	            }
	            parameters = createMissingList();
	          } else {
	            if (!allowAmbiguity) {
	              const maybeParameters = parseParametersWorker(isAsync, allowAmbiguity);
	              if (!maybeParameters) {
	                return void 0;
	              }
	              parameters = maybeParameters;
	            } else {
	              parameters = parseParametersWorker(isAsync, allowAmbiguity);
	            }
	            if (!parseExpected(22 /* CloseParenToken */) && !allowAmbiguity) {
	              return void 0;
	            }
	          }
	          const hasReturnColon = token() === 59 /* ColonToken */;
	          const type = parseReturnType(
	            59 /* ColonToken */,
	            /*isType*/
	            false
	          );
	          if (type && !allowAmbiguity && typeHasArrowFunctionBlockingParseError(type)) {
	            return void 0;
	          }
	          let unwrappedType = type;
	          while ((unwrappedType == null ? void 0 : unwrappedType.kind) === 196 /* ParenthesizedType */) {
	            unwrappedType = unwrappedType.type;
	          }
	          const hasJSDocFunctionType = unwrappedType && isJSDocFunctionType(unwrappedType);
	          if (!allowAmbiguity && token() !== 39 /* EqualsGreaterThanToken */ && (hasJSDocFunctionType || token() !== 19 /* OpenBraceToken */)) {
	            return void 0;
	          }
	          const lastToken = token();
	          const equalsGreaterThanToken = parseExpectedToken(39 /* EqualsGreaterThanToken */);
	          const body = lastToken === 39 /* EqualsGreaterThanToken */ || lastToken === 19 /* OpenBraceToken */ ? parseArrowFunctionExpressionBody(some(modifiers, isAsyncModifier), allowReturnTypeInArrowFunction) : parseIdentifier();
	          if (!allowReturnTypeInArrowFunction && hasReturnColon) {
	            if (token() !== 59 /* ColonToken */) {
	              return void 0;
	            }
	          }
	          const node = factory2.createArrowFunction(modifiers, typeParameters, parameters, type, equalsGreaterThanToken, body);
	          return withJSDoc(finishNode(node, pos), hasJSDoc);
	        }
	        function parseArrowFunctionExpressionBody(isAsync, allowReturnTypeInArrowFunction) {
	          if (token() === 19 /* OpenBraceToken */) {
	            return parseFunctionBlock(isAsync ? 2 /* Await */ : 0 /* None */);
	          }
	          if (token() !== 27 /* SemicolonToken */ && token() !== 100 /* FunctionKeyword */ && token() !== 86 /* ClassKeyword */ && isStartOfStatement() && !isStartOfExpressionStatement()) {
	            return parseFunctionBlock(16 /* IgnoreMissingOpenBrace */ | (isAsync ? 2 /* Await */ : 0 /* None */));
	          }
	          const savedTopLevel = topLevel;
	          topLevel = false;
	          const node = isAsync ? doInAwaitContext(() => parseAssignmentExpressionOrHigher(allowReturnTypeInArrowFunction)) : doOutsideOfAwaitContext(() => parseAssignmentExpressionOrHigher(allowReturnTypeInArrowFunction));
	          topLevel = savedTopLevel;
	          return node;
	        }
	        function parseConditionalExpressionRest(leftOperand, pos, allowReturnTypeInArrowFunction) {
	          const questionToken = parseOptionalToken(58 /* QuestionToken */);
	          if (!questionToken) {
	            return leftOperand;
	          }
	          let colonToken;
	          return finishNode(
	            factory2.createConditionalExpression(
	              leftOperand,
	              questionToken,
	              doOutsideOfContext(disallowInAndDecoratorContext, () => parseAssignmentExpressionOrHigher(
	                /*allowReturnTypeInArrowFunction*/
	                false
	              )),
	              colonToken = parseExpectedToken(59 /* ColonToken */),
	              nodeIsPresent(colonToken) ? parseAssignmentExpressionOrHigher(allowReturnTypeInArrowFunction) : createMissingNode(
	                80 /* Identifier */,
	                /*reportAtCurrentPosition*/
	                false,
	                Diagnostics._0_expected,
	                tokenToString(59 /* ColonToken */)
	              )
	            ),
	            pos
	          );
	        }
	        function parseBinaryExpressionOrHigher(precedence) {
	          const pos = getNodePos();
	          const leftOperand = parseUnaryExpressionOrHigher();
	          return parseBinaryExpressionRest(precedence, leftOperand, pos);
	        }
	        function isInOrOfKeyword(t) {
	          return t === 103 /* InKeyword */ || t === 165 /* OfKeyword */;
	        }
	        function parseBinaryExpressionRest(precedence, leftOperand, pos) {
	          while (true) {
	            reScanGreaterToken();
	            const newPrecedence = getBinaryOperatorPrecedence(token());
	            const consumeCurrentOperator = token() === 43 /* AsteriskAsteriskToken */ ? newPrecedence >= precedence : newPrecedence > precedence;
	            if (!consumeCurrentOperator) {
	              break;
	            }
	            if (token() === 103 /* InKeyword */ && inDisallowInContext()) {
	              break;
	            }
	            if (token() === 130 /* AsKeyword */ || token() === 152 /* SatisfiesKeyword */) {
	              if (scanner2.hasPrecedingLineBreak()) {
	                break;
	              } else {
	                const keywordKind = token();
	                nextToken();
	                leftOperand = keywordKind === 152 /* SatisfiesKeyword */ ? makeSatisfiesExpression(leftOperand, parseType()) : makeAsExpression(leftOperand, parseType());
	              }
	            } else {
	              leftOperand = makeBinaryExpression(leftOperand, parseTokenNode(), parseBinaryExpressionOrHigher(newPrecedence), pos);
	            }
	          }
	          return leftOperand;
	        }
	        function isBinaryOperator2() {
	          if (inDisallowInContext() && token() === 103 /* InKeyword */) {
	            return false;
	          }
	          return getBinaryOperatorPrecedence(token()) > 0;
	        }
	        function makeSatisfiesExpression(left, right) {
	          return finishNode(factory2.createSatisfiesExpression(left, right), left.pos);
	        }
	        function makeBinaryExpression(left, operatorToken, right, pos) {
	          return finishNode(factory2.createBinaryExpression(left, operatorToken, right), pos);
	        }
	        function makeAsExpression(left, right) {
	          return finishNode(factory2.createAsExpression(left, right), left.pos);
	        }
	        function parsePrefixUnaryExpression() {
	          const pos = getNodePos();
	          return finishNode(factory2.createPrefixUnaryExpression(token(), nextTokenAnd(parseSimpleUnaryExpression)), pos);
	        }
	        function parseDeleteExpression() {
	          const pos = getNodePos();
	          return finishNode(factory2.createDeleteExpression(nextTokenAnd(parseSimpleUnaryExpression)), pos);
	        }
	        function parseTypeOfExpression() {
	          const pos = getNodePos();
	          return finishNode(factory2.createTypeOfExpression(nextTokenAnd(parseSimpleUnaryExpression)), pos);
	        }
	        function parseVoidExpression() {
	          const pos = getNodePos();
	          return finishNode(factory2.createVoidExpression(nextTokenAnd(parseSimpleUnaryExpression)), pos);
	        }
	        function isAwaitExpression2() {
	          if (token() === 135 /* AwaitKeyword */) {
	            if (inAwaitContext()) {
	              return true;
	            }
	            return lookAhead(nextTokenIsIdentifierOrKeywordOrLiteralOnSameLine);
	          }
	          return false;
	        }
	        function parseAwaitExpression() {
	          const pos = getNodePos();
	          return finishNode(factory2.createAwaitExpression(nextTokenAnd(parseSimpleUnaryExpression)), pos);
	        }
	        function parseUnaryExpressionOrHigher() {
	          if (isUpdateExpression()) {
	            const pos = getNodePos();
	            const updateExpression = parseUpdateExpression();
	            return token() === 43 /* AsteriskAsteriskToken */ ? parseBinaryExpressionRest(getBinaryOperatorPrecedence(token()), updateExpression, pos) : updateExpression;
	          }
	          const unaryOperator = token();
	          const simpleUnaryExpression = parseSimpleUnaryExpression();
	          if (token() === 43 /* AsteriskAsteriskToken */) {
	            const pos = skipTrivia(sourceText, simpleUnaryExpression.pos);
	            const { end } = simpleUnaryExpression;
	            if (simpleUnaryExpression.kind === 216 /* TypeAssertionExpression */) {
	              parseErrorAt(pos, end, Diagnostics.A_type_assertion_expression_is_not_allowed_in_the_left_hand_side_of_an_exponentiation_expression_Consider_enclosing_the_expression_in_parentheses);
	            } else {
	              Debug.assert(isKeywordOrPunctuation(unaryOperator));
	              parseErrorAt(pos, end, Diagnostics.An_unary_expression_with_the_0_operator_is_not_allowed_in_the_left_hand_side_of_an_exponentiation_expression_Consider_enclosing_the_expression_in_parentheses, tokenToString(unaryOperator));
	            }
	          }
	          return simpleUnaryExpression;
	        }
	        function parseSimpleUnaryExpression() {
	          switch (token()) {
	            case 40 /* PlusToken */:
	            case 41 /* MinusToken */:
	            case 55 /* TildeToken */:
	            case 54 /* ExclamationToken */:
	              return parsePrefixUnaryExpression();
	            case 91 /* DeleteKeyword */:
	              return parseDeleteExpression();
	            case 114 /* TypeOfKeyword */:
	              return parseTypeOfExpression();
	            case 116 /* VoidKeyword */:
	              return parseVoidExpression();
	            case 30 /* LessThanToken */:
	              if (languageVariant === 1 /* JSX */) {
	                return parseJsxElementOrSelfClosingElementOrFragment(
	                  /*inExpressionContext*/
	                  true,
	                  /*topInvalidNodePosition*/
	                  void 0,
	                  /*openingTag*/
	                  void 0,
	                  /*mustBeUnary*/
	                  true
	                );
	              }
	              return parseTypeAssertion();
	            case 135 /* AwaitKeyword */:
	              if (isAwaitExpression2()) {
	                return parseAwaitExpression();
	              }
	            default:
	              return parseUpdateExpression();
	          }
	        }
	        function isUpdateExpression() {
	          switch (token()) {
	            case 40 /* PlusToken */:
	            case 41 /* MinusToken */:
	            case 55 /* TildeToken */:
	            case 54 /* ExclamationToken */:
	            case 91 /* DeleteKeyword */:
	            case 114 /* TypeOfKeyword */:
	            case 116 /* VoidKeyword */:
	            case 135 /* AwaitKeyword */:
	              return false;
	            case 30 /* LessThanToken */:
	              if (languageVariant !== 1 /* JSX */) {
	                return false;
	              }
	            default:
	              return true;
	          }
	        }
	        function parseUpdateExpression() {
	          if (token() === 46 /* PlusPlusToken */ || token() === 47 /* MinusMinusToken */) {
	            const pos = getNodePos();
	            return finishNode(factory2.createPrefixUnaryExpression(token(), nextTokenAnd(parseLeftHandSideExpressionOrHigher)), pos);
	          } else if (languageVariant === 1 /* JSX */ && token() === 30 /* LessThanToken */ && lookAhead(nextTokenIsIdentifierOrKeywordOrGreaterThan)) {
	            return parseJsxElementOrSelfClosingElementOrFragment(
	              /*inExpressionContext*/
	              true
	            );
	          }
	          const expression = parseLeftHandSideExpressionOrHigher();
	          Debug.assert(isLeftHandSideExpression(expression));
	          if ((token() === 46 /* PlusPlusToken */ || token() === 47 /* MinusMinusToken */) && !scanner2.hasPrecedingLineBreak()) {
	            const operator = token();
	            nextToken();
	            return finishNode(factory2.createPostfixUnaryExpression(expression, operator), expression.pos);
	          }
	          return expression;
	        }
	        function parseLeftHandSideExpressionOrHigher() {
	          const pos = getNodePos();
	          let expression;
	          if (token() === 102 /* ImportKeyword */) {
	            if (lookAhead(nextTokenIsOpenParenOrLessThan)) {
	              sourceFlags |= 4194304 /* PossiblyContainsDynamicImport */;
	              expression = parseTokenNode();
	            } else if (lookAhead(nextTokenIsDot)) {
	              nextToken();
	              nextToken();
	              expression = finishNode(factory2.createMetaProperty(102 /* ImportKeyword */, parseIdentifierName()), pos);
	              sourceFlags |= 8388608 /* PossiblyContainsImportMeta */;
	            } else {
	              expression = parseMemberExpressionOrHigher();
	            }
	          } else {
	            expression = token() === 108 /* SuperKeyword */ ? parseSuperExpression() : parseMemberExpressionOrHigher();
	          }
	          return parseCallExpressionRest(pos, expression);
	        }
	        function parseMemberExpressionOrHigher() {
	          const pos = getNodePos();
	          const expression = parsePrimaryExpression();
	          return parseMemberExpressionRest(
	            pos,
	            expression,
	            /*allowOptionalChain*/
	            true
	          );
	        }
	        function parseSuperExpression() {
	          const pos = getNodePos();
	          let expression = parseTokenNode();
	          if (token() === 30 /* LessThanToken */) {
	            const startPos = getNodePos();
	            const typeArguments = tryParse(parseTypeArgumentsInExpression);
	            if (typeArguments !== void 0) {
	              parseErrorAt(startPos, getNodePos(), Diagnostics.super_may_not_use_type_arguments);
	              if (!isTemplateStartOfTaggedTemplate()) {
	                expression = factory2.createExpressionWithTypeArguments(expression, typeArguments);
	              }
	            }
	          }
	          if (token() === 21 /* OpenParenToken */ || token() === 25 /* DotToken */ || token() === 23 /* OpenBracketToken */) {
	            return expression;
	          }
	          parseExpectedToken(25 /* DotToken */, Diagnostics.super_must_be_followed_by_an_argument_list_or_member_access);
	          return finishNode(factoryCreatePropertyAccessExpression(expression, parseRightSideOfDot(
	            /*allowIdentifierNames*/
	            true,
	            /*allowPrivateIdentifiers*/
	            true,
	            /*allowUnicodeEscapeSequenceInIdentifierName*/
	            true
	          )), pos);
	        }
	        function parseJsxElementOrSelfClosingElementOrFragment(inExpressionContext, topInvalidNodePosition, openingTag, mustBeUnary = false) {
	          const pos = getNodePos();
	          const opening = parseJsxOpeningOrSelfClosingElementOrOpeningFragment(inExpressionContext);
	          let result;
	          if (opening.kind === 286 /* JsxOpeningElement */) {
	            let children = parseJsxChildren(opening);
	            let closingElement;
	            const lastChild = children[children.length - 1];
	            if ((lastChild == null ? void 0 : lastChild.kind) === 284 /* JsxElement */ && !tagNamesAreEquivalent(lastChild.openingElement.tagName, lastChild.closingElement.tagName) && tagNamesAreEquivalent(opening.tagName, lastChild.closingElement.tagName)) {
	              const end = lastChild.children.end;
	              const newLast = finishNode(
	                factory2.createJsxElement(
	                  lastChild.openingElement,
	                  lastChild.children,
	                  finishNode(factory2.createJsxClosingElement(finishNode(factoryCreateIdentifier(""), end, end)), end, end)
	                ),
	                lastChild.openingElement.pos,
	                end
	              );
	              children = createNodeArray([...children.slice(0, children.length - 1), newLast], children.pos, end);
	              closingElement = lastChild.closingElement;
	            } else {
	              closingElement = parseJsxClosingElement(opening, inExpressionContext);
	              if (!tagNamesAreEquivalent(opening.tagName, closingElement.tagName)) {
	                if (openingTag && isJsxOpeningElement(openingTag) && tagNamesAreEquivalent(closingElement.tagName, openingTag.tagName)) {
	                  parseErrorAtRange(opening.tagName, Diagnostics.JSX_element_0_has_no_corresponding_closing_tag, getTextOfNodeFromSourceText(sourceText, opening.tagName));
	                } else {
	                  parseErrorAtRange(closingElement.tagName, Diagnostics.Expected_corresponding_JSX_closing_tag_for_0, getTextOfNodeFromSourceText(sourceText, opening.tagName));
	                }
	              }
	            }
	            result = finishNode(factory2.createJsxElement(opening, children, closingElement), pos);
	          } else if (opening.kind === 289 /* JsxOpeningFragment */) {
	            result = finishNode(factory2.createJsxFragment(opening, parseJsxChildren(opening), parseJsxClosingFragment(inExpressionContext)), pos);
	          } else {
	            Debug.assert(opening.kind === 285 /* JsxSelfClosingElement */);
	            result = opening;
	          }
	          if (!mustBeUnary && inExpressionContext && token() === 30 /* LessThanToken */) {
	            const topBadPos = typeof topInvalidNodePosition === "undefined" ? result.pos : topInvalidNodePosition;
	            const invalidElement = tryParse(() => parseJsxElementOrSelfClosingElementOrFragment(
	              /*inExpressionContext*/
	              true,
	              topBadPos
	            ));
	            if (invalidElement) {
	              const operatorToken = createMissingNode(
	                28 /* CommaToken */,
	                /*reportAtCurrentPosition*/
	                false
	              );
	              setTextRangePosWidth(operatorToken, invalidElement.pos, 0);
	              parseErrorAt(skipTrivia(sourceText, topBadPos), invalidElement.end, Diagnostics.JSX_expressions_must_have_one_parent_element);
	              return finishNode(factory2.createBinaryExpression(result, operatorToken, invalidElement), pos);
	            }
	          }
	          return result;
	        }
	        function parseJsxText() {
	          const pos = getNodePos();
	          const node = factory2.createJsxText(scanner2.getTokenValue(), currentToken === 13 /* JsxTextAllWhiteSpaces */);
	          currentToken = scanner2.scanJsxToken();
	          return finishNode(node, pos);
	        }
	        function parseJsxChild(openingTag, token2) {
	          switch (token2) {
	            case 1 /* EndOfFileToken */:
	              if (isJsxOpeningFragment(openingTag)) {
	                parseErrorAtRange(openingTag, Diagnostics.JSX_fragment_has_no_corresponding_closing_tag);
	              } else {
	                const tag = openingTag.tagName;
	                const start = Math.min(skipTrivia(sourceText, tag.pos), tag.end);
	                parseErrorAt(start, tag.end, Diagnostics.JSX_element_0_has_no_corresponding_closing_tag, getTextOfNodeFromSourceText(sourceText, openingTag.tagName));
	              }
	              return void 0;
	            case 31 /* LessThanSlashToken */:
	            case 7 /* ConflictMarkerTrivia */:
	              return void 0;
	            case 12 /* JsxText */:
	            case 13 /* JsxTextAllWhiteSpaces */:
	              return parseJsxText();
	            case 19 /* OpenBraceToken */:
	              return parseJsxExpression(
	                /*inExpressionContext*/
	                false
	              );
	            case 30 /* LessThanToken */:
	              return parseJsxElementOrSelfClosingElementOrFragment(
	                /*inExpressionContext*/
	                false,
	                /*topInvalidNodePosition*/
	                void 0,
	                openingTag
	              );
	            default:
	              return Debug.assertNever(token2);
	          }
	        }
	        function parseJsxChildren(openingTag) {
	          const list = [];
	          const listPos = getNodePos();
	          const saveParsingContext = parsingContext;
	          parsingContext |= 1 << 14 /* JsxChildren */;
	          while (true) {
	            const child = parseJsxChild(openingTag, currentToken = scanner2.reScanJsxToken());
	            if (!child)
	              break;
	            list.push(child);
	            if (isJsxOpeningElement(openingTag) && (child == null ? void 0 : child.kind) === 284 /* JsxElement */ && !tagNamesAreEquivalent(child.openingElement.tagName, child.closingElement.tagName) && tagNamesAreEquivalent(openingTag.tagName, child.closingElement.tagName)) {
	              break;
	            }
	          }
	          parsingContext = saveParsingContext;
	          return createNodeArray(list, listPos);
	        }
	        function parseJsxAttributes() {
	          const pos = getNodePos();
	          return finishNode(factory2.createJsxAttributes(parseList(13 /* JsxAttributes */, parseJsxAttribute)), pos);
	        }
	        function parseJsxOpeningOrSelfClosingElementOrOpeningFragment(inExpressionContext) {
	          const pos = getNodePos();
	          parseExpected(30 /* LessThanToken */);
	          if (token() === 32 /* GreaterThanToken */) {
	            scanJsxText();
	            return finishNode(factory2.createJsxOpeningFragment(), pos);
	          }
	          const tagName = parseJsxElementName();
	          const typeArguments = (contextFlags & 524288 /* JavaScriptFile */) === 0 ? tryParseTypeArguments() : void 0;
	          const attributes = parseJsxAttributes();
	          let node;
	          if (token() === 32 /* GreaterThanToken */) {
	            scanJsxText();
	            node = factory2.createJsxOpeningElement(tagName, typeArguments, attributes);
	          } else {
	            parseExpected(44 /* SlashToken */);
	            if (parseExpected(
	              32 /* GreaterThanToken */,
	              /*diagnosticMessage*/
	              void 0,
	              /*shouldAdvance*/
	              false
	            )) {
	              if (inExpressionContext) {
	                nextToken();
	              } else {
	                scanJsxText();
	              }
	            }
	            node = factory2.createJsxSelfClosingElement(tagName, typeArguments, attributes);
	          }
	          return finishNode(node, pos);
	        }
	        function parseJsxElementName() {
	          const pos = getNodePos();
	          const initialExpression = parseJsxTagName();
	          if (isJsxNamespacedName(initialExpression)) {
	            return initialExpression;
	          }
	          let expression = initialExpression;
	          while (parseOptional(25 /* DotToken */)) {
	            expression = finishNode(factoryCreatePropertyAccessExpression(expression, parseRightSideOfDot(
	              /*allowIdentifierNames*/
	              true,
	              /*allowPrivateIdentifiers*/
	              false,
	              /*allowUnicodeEscapeSequenceInIdentifierName*/
	              false
	            )), pos);
	          }
	          return expression;
	        }
	        function parseJsxTagName() {
	          const pos = getNodePos();
	          scanJsxIdentifier();
	          const isThis2 = token() === 110 /* ThisKeyword */;
	          const tagName = parseIdentifierNameErrorOnUnicodeEscapeSequence();
	          if (parseOptional(59 /* ColonToken */)) {
	            scanJsxIdentifier();
	            return finishNode(factory2.createJsxNamespacedName(tagName, parseIdentifierNameErrorOnUnicodeEscapeSequence()), pos);
	          }
	          return isThis2 ? finishNode(factory2.createToken(110 /* ThisKeyword */), pos) : tagName;
	        }
	        function parseJsxExpression(inExpressionContext) {
	          const pos = getNodePos();
	          if (!parseExpected(19 /* OpenBraceToken */)) {
	            return void 0;
	          }
	          let dotDotDotToken;
	          let expression;
	          if (token() !== 20 /* CloseBraceToken */) {
	            if (!inExpressionContext) {
	              dotDotDotToken = parseOptionalToken(26 /* DotDotDotToken */);
	            }
	            expression = parseExpression();
	          }
	          if (inExpressionContext) {
	            parseExpected(20 /* CloseBraceToken */);
	          } else {
	            if (parseExpected(
	              20 /* CloseBraceToken */,
	              /*diagnosticMessage*/
	              void 0,
	              /*shouldAdvance*/
	              false
	            )) {
	              scanJsxText();
	            }
	          }
	          return finishNode(factory2.createJsxExpression(dotDotDotToken, expression), pos);
	        }
	        function parseJsxAttribute() {
	          if (token() === 19 /* OpenBraceToken */) {
	            return parseJsxSpreadAttribute();
	          }
	          const pos = getNodePos();
	          return finishNode(factory2.createJsxAttribute(parseJsxAttributeName(), parseJsxAttributeValue()), pos);
	        }
	        function parseJsxAttributeValue() {
	          if (token() === 64 /* EqualsToken */) {
	            if (scanJsxAttributeValue() === 11 /* StringLiteral */) {
	              return parseLiteralNode();
	            }
	            if (token() === 19 /* OpenBraceToken */) {
	              return parseJsxExpression(
	                /*inExpressionContext*/
	                true
	              );
	            }
	            if (token() === 30 /* LessThanToken */) {
	              return parseJsxElementOrSelfClosingElementOrFragment(
	                /*inExpressionContext*/
	                true
	              );
	            }
	            parseErrorAtCurrentToken(Diagnostics.or_JSX_element_expected);
	          }
	          return void 0;
	        }
	        function parseJsxAttributeName() {
	          const pos = getNodePos();
	          scanJsxIdentifier();
	          const attrName = parseIdentifierNameErrorOnUnicodeEscapeSequence();
	          if (parseOptional(59 /* ColonToken */)) {
	            scanJsxIdentifier();
	            return finishNode(factory2.createJsxNamespacedName(attrName, parseIdentifierNameErrorOnUnicodeEscapeSequence()), pos);
	          }
	          return attrName;
	        }
	        function parseJsxSpreadAttribute() {
	          const pos = getNodePos();
	          parseExpected(19 /* OpenBraceToken */);
	          parseExpected(26 /* DotDotDotToken */);
	          const expression = parseExpression();
	          parseExpected(20 /* CloseBraceToken */);
	          return finishNode(factory2.createJsxSpreadAttribute(expression), pos);
	        }
	        function parseJsxClosingElement(open, inExpressionContext) {
	          const pos = getNodePos();
	          parseExpected(31 /* LessThanSlashToken */);
	          const tagName = parseJsxElementName();
	          if (parseExpected(
	            32 /* GreaterThanToken */,
	            /*diagnosticMessage*/
	            void 0,
	            /*shouldAdvance*/
	            false
	          )) {
	            if (inExpressionContext || !tagNamesAreEquivalent(open.tagName, tagName)) {
	              nextToken();
	            } else {
	              scanJsxText();
	            }
	          }
	          return finishNode(factory2.createJsxClosingElement(tagName), pos);
	        }
	        function parseJsxClosingFragment(inExpressionContext) {
	          const pos = getNodePos();
	          parseExpected(31 /* LessThanSlashToken */);
	          if (parseExpected(
	            32 /* GreaterThanToken */,
	            Diagnostics.Expected_corresponding_closing_tag_for_JSX_fragment,
	            /*shouldAdvance*/
	            false
	          )) {
	            if (inExpressionContext) {
	              nextToken();
	            } else {
	              scanJsxText();
	            }
	          }
	          return finishNode(factory2.createJsxJsxClosingFragment(), pos);
	        }
	        function parseTypeAssertion() {
	          Debug.assert(languageVariant !== 1 /* JSX */, "Type assertions should never be parsed in JSX; they should be parsed as comparisons or JSX elements/fragments.");
	          const pos = getNodePos();
	          parseExpected(30 /* LessThanToken */);
	          const type = parseType();
	          parseExpected(32 /* GreaterThanToken */);
	          const expression = parseSimpleUnaryExpression();
	          return finishNode(factory2.createTypeAssertion(type, expression), pos);
	        }
	        function nextTokenIsIdentifierOrKeywordOrOpenBracketOrTemplate() {
	          nextToken();
	          return tokenIsIdentifierOrKeyword(token()) || token() === 23 /* OpenBracketToken */ || isTemplateStartOfTaggedTemplate();
	        }
	        function isStartOfOptionalPropertyOrElementAccessChain() {
	          return token() === 29 /* QuestionDotToken */ && lookAhead(nextTokenIsIdentifierOrKeywordOrOpenBracketOrTemplate);
	        }
	        function tryReparseOptionalChain(node) {
	          if (node.flags & 64 /* OptionalChain */) {
	            return true;
	          }
	          if (isNonNullExpression(node)) {
	            let expr = node.expression;
	            while (isNonNullExpression(expr) && !(expr.flags & 64 /* OptionalChain */)) {
	              expr = expr.expression;
	            }
	            if (expr.flags & 64 /* OptionalChain */) {
	              while (isNonNullExpression(node)) {
	                node.flags |= 64 /* OptionalChain */;
	                node = node.expression;
	              }
	              return true;
	            }
	          }
	          return false;
	        }
	        function parsePropertyAccessExpressionRest(pos, expression, questionDotToken) {
	          const name = parseRightSideOfDot(
	            /*allowIdentifierNames*/
	            true,
	            /*allowPrivateIdentifiers*/
	            true,
	            /*allowUnicodeEscapeSequenceInIdentifierName*/
	            true
	          );
	          const isOptionalChain2 = questionDotToken || tryReparseOptionalChain(expression);
	          const propertyAccess = isOptionalChain2 ? factoryCreatePropertyAccessChain(expression, questionDotToken, name) : factoryCreatePropertyAccessExpression(expression, name);
	          if (isOptionalChain2 && isPrivateIdentifier(propertyAccess.name)) {
	            parseErrorAtRange(propertyAccess.name, Diagnostics.An_optional_chain_cannot_contain_private_identifiers);
	          }
	          if (isExpressionWithTypeArguments(expression) && expression.typeArguments) {
	            const pos2 = expression.typeArguments.pos - 1;
	            const end = skipTrivia(sourceText, expression.typeArguments.end) + 1;
	            parseErrorAt(pos2, end, Diagnostics.An_instantiation_expression_cannot_be_followed_by_a_property_access);
	          }
	          return finishNode(propertyAccess, pos);
	        }
	        function parseElementAccessExpressionRest(pos, expression, questionDotToken) {
	          let argumentExpression;
	          if (token() === 24 /* CloseBracketToken */) {
	            argumentExpression = createMissingNode(
	              80 /* Identifier */,
	              /*reportAtCurrentPosition*/
	              true,
	              Diagnostics.An_element_access_expression_should_take_an_argument
	            );
	          } else {
	            const argument = allowInAnd(parseExpression);
	            if (isStringOrNumericLiteralLike(argument)) {
	              argument.text = internIdentifier(argument.text);
	            }
	            argumentExpression = argument;
	          }
	          parseExpected(24 /* CloseBracketToken */);
	          const indexedAccess = questionDotToken || tryReparseOptionalChain(expression) ? factoryCreateElementAccessChain(expression, questionDotToken, argumentExpression) : factoryCreateElementAccessExpression(expression, argumentExpression);
	          return finishNode(indexedAccess, pos);
	        }
	        function parseMemberExpressionRest(pos, expression, allowOptionalChain) {
	          while (true) {
	            let questionDotToken;
	            let isPropertyAccess = false;
	            if (allowOptionalChain && isStartOfOptionalPropertyOrElementAccessChain()) {
	              questionDotToken = parseExpectedToken(29 /* QuestionDotToken */);
	              isPropertyAccess = tokenIsIdentifierOrKeyword(token());
	            } else {
	              isPropertyAccess = parseOptional(25 /* DotToken */);
	            }
	            if (isPropertyAccess) {
	              expression = parsePropertyAccessExpressionRest(pos, expression, questionDotToken);
	              continue;
	            }
	            if ((questionDotToken || !inDecoratorContext()) && parseOptional(23 /* OpenBracketToken */)) {
	              expression = parseElementAccessExpressionRest(pos, expression, questionDotToken);
	              continue;
	            }
	            if (isTemplateStartOfTaggedTemplate()) {
	              expression = !questionDotToken && expression.kind === 233 /* ExpressionWithTypeArguments */ ? parseTaggedTemplateRest(pos, expression.expression, questionDotToken, expression.typeArguments) : parseTaggedTemplateRest(
	                pos,
	                expression,
	                questionDotToken,
	                /*typeArguments*/
	                void 0
	              );
	              continue;
	            }
	            if (!questionDotToken) {
	              if (token() === 54 /* ExclamationToken */ && !scanner2.hasPrecedingLineBreak()) {
	                nextToken();
	                expression = finishNode(factory2.createNonNullExpression(expression), pos);
	                continue;
	              }
	              const typeArguments = tryParse(parseTypeArgumentsInExpression);
	              if (typeArguments) {
	                expression = finishNode(factory2.createExpressionWithTypeArguments(expression, typeArguments), pos);
	                continue;
	              }
	            }
	            return expression;
	          }
	        }
	        function isTemplateStartOfTaggedTemplate() {
	          return token() === 15 /* NoSubstitutionTemplateLiteral */ || token() === 16 /* TemplateHead */;
	        }
	        function parseTaggedTemplateRest(pos, tag, questionDotToken, typeArguments) {
	          const tagExpression = factory2.createTaggedTemplateExpression(
	            tag,
	            typeArguments,
	            token() === 15 /* NoSubstitutionTemplateLiteral */ ? (reScanTemplateToken(
	              /*isTaggedTemplate*/
	              true
	            ), parseLiteralNode()) : parseTemplateExpression(
	              /*isTaggedTemplate*/
	              true
	            )
	          );
	          if (questionDotToken || tag.flags & 64 /* OptionalChain */) {
	            tagExpression.flags |= 64 /* OptionalChain */;
	          }
	          tagExpression.questionDotToken = questionDotToken;
	          return finishNode(tagExpression, pos);
	        }
	        function parseCallExpressionRest(pos, expression) {
	          while (true) {
	            expression = parseMemberExpressionRest(
	              pos,
	              expression,
	              /*allowOptionalChain*/
	              true
	            );
	            let typeArguments;
	            const questionDotToken = parseOptionalToken(29 /* QuestionDotToken */);
	            if (questionDotToken) {
	              typeArguments = tryParse(parseTypeArgumentsInExpression);
	              if (isTemplateStartOfTaggedTemplate()) {
	                expression = parseTaggedTemplateRest(pos, expression, questionDotToken, typeArguments);
	                continue;
	              }
	            }
	            if (typeArguments || token() === 21 /* OpenParenToken */) {
	              if (!questionDotToken && expression.kind === 233 /* ExpressionWithTypeArguments */) {
	                typeArguments = expression.typeArguments;
	                expression = expression.expression;
	              }
	              const argumentList = parseArgumentList();
	              const callExpr = questionDotToken || tryReparseOptionalChain(expression) ? factoryCreateCallChain(expression, questionDotToken, typeArguments, argumentList) : factoryCreateCallExpression(expression, typeArguments, argumentList);
	              expression = finishNode(callExpr, pos);
	              continue;
	            }
	            if (questionDotToken) {
	              const name = createMissingNode(
	                80 /* Identifier */,
	                /*reportAtCurrentPosition*/
	                false,
	                Diagnostics.Identifier_expected
	              );
	              expression = finishNode(factoryCreatePropertyAccessChain(expression, questionDotToken, name), pos);
	            }
	            break;
	          }
	          return expression;
	        }
	        function parseArgumentList() {
	          parseExpected(21 /* OpenParenToken */);
	          const result = parseDelimitedList(11 /* ArgumentExpressions */, parseArgumentExpression);
	          parseExpected(22 /* CloseParenToken */);
	          return result;
	        }
	        function parseTypeArgumentsInExpression() {
	          if ((contextFlags & 524288 /* JavaScriptFile */) !== 0) {
	            return void 0;
	          }
	          if (reScanLessThanToken() !== 30 /* LessThanToken */) {
	            return void 0;
	          }
	          nextToken();
	          const typeArguments = parseDelimitedList(20 /* TypeArguments */, parseType);
	          if (reScanGreaterToken() !== 32 /* GreaterThanToken */) {
	            return void 0;
	          }
	          nextToken();
	          return typeArguments && canFollowTypeArgumentsInExpression() ? typeArguments : void 0;
	        }
	        function canFollowTypeArgumentsInExpression() {
	          switch (token()) {
	            case 21 /* OpenParenToken */:
	            case 15 /* NoSubstitutionTemplateLiteral */:
	            case 16 /* TemplateHead */:
	              return true;
	            case 30 /* LessThanToken */:
	            case 32 /* GreaterThanToken */:
	            case 40 /* PlusToken */:
	            case 41 /* MinusToken */:
	              return false;
	          }
	          return scanner2.hasPrecedingLineBreak() || isBinaryOperator2() || !isStartOfExpression();
	        }
	        function parsePrimaryExpression() {
	          switch (token()) {
	            case 15 /* NoSubstitutionTemplateLiteral */:
	              if (scanner2.getTokenFlags() & 26656 /* IsInvalid */) {
	                reScanTemplateToken(
	                  /*isTaggedTemplate*/
	                  false
	                );
	              }
	            case 9 /* NumericLiteral */:
	            case 10 /* BigIntLiteral */:
	            case 11 /* StringLiteral */:
	              return parseLiteralNode();
	            case 110 /* ThisKeyword */:
	            case 108 /* SuperKeyword */:
	            case 106 /* NullKeyword */:
	            case 112 /* TrueKeyword */:
	            case 97 /* FalseKeyword */:
	              return parseTokenNode();
	            case 21 /* OpenParenToken */:
	              return parseParenthesizedExpression();
	            case 23 /* OpenBracketToken */:
	              return parseArrayLiteralExpression();
	            case 19 /* OpenBraceToken */:
	              return parseObjectLiteralExpression();
	            case 134 /* AsyncKeyword */:
	              if (!lookAhead(nextTokenIsFunctionKeywordOnSameLine)) {
	                break;
	              }
	              return parseFunctionExpression();
	            case 60 /* AtToken */:
	              return parseDecoratedExpression();
	            case 86 /* ClassKeyword */:
	              return parseClassExpression();
	            case 100 /* FunctionKeyword */:
	              return parseFunctionExpression();
	            case 105 /* NewKeyword */:
	              return parseNewExpressionOrNewDotTarget();
	            case 44 /* SlashToken */:
	            case 69 /* SlashEqualsToken */:
	              if (reScanSlashToken() === 14 /* RegularExpressionLiteral */) {
	                return parseLiteralNode();
	              }
	              break;
	            case 16 /* TemplateHead */:
	              return parseTemplateExpression(
	                /*isTaggedTemplate*/
	                false
	              );
	            case 81 /* PrivateIdentifier */:
	              return parsePrivateIdentifier();
	          }
	          return parseIdentifier(Diagnostics.Expression_expected);
	        }
	        function parseParenthesizedExpression() {
	          const pos = getNodePos();
	          const hasJSDoc = hasPrecedingJSDocComment();
	          parseExpected(21 /* OpenParenToken */);
	          const expression = allowInAnd(parseExpression);
	          parseExpected(22 /* CloseParenToken */);
	          return withJSDoc(finishNode(factoryCreateParenthesizedExpression(expression), pos), hasJSDoc);
	        }
	        function parseSpreadElement() {
	          const pos = getNodePos();
	          parseExpected(26 /* DotDotDotToken */);
	          const expression = parseAssignmentExpressionOrHigher(
	            /*allowReturnTypeInArrowFunction*/
	            true
	          );
	          return finishNode(factory2.createSpreadElement(expression), pos);
	        }
	        function parseArgumentOrArrayLiteralElement() {
	          return token() === 26 /* DotDotDotToken */ ? parseSpreadElement() : token() === 28 /* CommaToken */ ? finishNode(factory2.createOmittedExpression(), getNodePos()) : parseAssignmentExpressionOrHigher(
	            /*allowReturnTypeInArrowFunction*/
	            true
	          );
	        }
	        function parseArgumentExpression() {
	          return doOutsideOfContext(disallowInAndDecoratorContext, parseArgumentOrArrayLiteralElement);
	        }
	        function parseArrayLiteralExpression() {
	          const pos = getNodePos();
	          const openBracketPosition = scanner2.getTokenStart();
	          const openBracketParsed = parseExpected(23 /* OpenBracketToken */);
	          const multiLine = scanner2.hasPrecedingLineBreak();
	          const elements = parseDelimitedList(15 /* ArrayLiteralMembers */, parseArgumentOrArrayLiteralElement);
	          parseExpectedMatchingBrackets(23 /* OpenBracketToken */, 24 /* CloseBracketToken */, openBracketParsed, openBracketPosition);
	          return finishNode(factoryCreateArrayLiteralExpression(elements, multiLine), pos);
	        }
	        function parseObjectLiteralElement() {
	          const pos = getNodePos();
	          const hasJSDoc = hasPrecedingJSDocComment();
	          if (parseOptionalToken(26 /* DotDotDotToken */)) {
	            const expression = parseAssignmentExpressionOrHigher(
	              /*allowReturnTypeInArrowFunction*/
	              true
	            );
	            return withJSDoc(finishNode(factory2.createSpreadAssignment(expression), pos), hasJSDoc);
	          }
	          const modifiers = parseModifiers(
	            /*allowDecorators*/
	            true
	          );
	          if (parseContextualModifier(139 /* GetKeyword */)) {
	            return parseAccessorDeclaration(pos, hasJSDoc, modifiers, 177 /* GetAccessor */, 0 /* None */);
	          }
	          if (parseContextualModifier(153 /* SetKeyword */)) {
	            return parseAccessorDeclaration(pos, hasJSDoc, modifiers, 178 /* SetAccessor */, 0 /* None */);
	          }
	          const asteriskToken = parseOptionalToken(42 /* AsteriskToken */);
	          const tokenIsIdentifier = isIdentifier2();
	          const name = parsePropertyName();
	          const questionToken = parseOptionalToken(58 /* QuestionToken */);
	          const exclamationToken = parseOptionalToken(54 /* ExclamationToken */);
	          if (asteriskToken || token() === 21 /* OpenParenToken */ || token() === 30 /* LessThanToken */) {
	            return parseMethodDeclaration(pos, hasJSDoc, modifiers, asteriskToken, name, questionToken, exclamationToken);
	          }
	          let node;
	          const isShorthandPropertyAssignment2 = tokenIsIdentifier && token() !== 59 /* ColonToken */;
	          if (isShorthandPropertyAssignment2) {
	            const equalsToken = parseOptionalToken(64 /* EqualsToken */);
	            const objectAssignmentInitializer = equalsToken ? allowInAnd(() => parseAssignmentExpressionOrHigher(
	              /*allowReturnTypeInArrowFunction*/
	              true
	            )) : void 0;
	            node = factory2.createShorthandPropertyAssignment(name, objectAssignmentInitializer);
	            node.equalsToken = equalsToken;
	          } else {
	            parseExpected(59 /* ColonToken */);
	            const initializer = allowInAnd(() => parseAssignmentExpressionOrHigher(
	              /*allowReturnTypeInArrowFunction*/
	              true
	            ));
	            node = factory2.createPropertyAssignment(name, initializer);
	          }
	          node.modifiers = modifiers;
	          node.questionToken = questionToken;
	          node.exclamationToken = exclamationToken;
	          return withJSDoc(finishNode(node, pos), hasJSDoc);
	        }
	        function parseObjectLiteralExpression() {
	          const pos = getNodePos();
	          const openBracePosition = scanner2.getTokenStart();
	          const openBraceParsed = parseExpected(19 /* OpenBraceToken */);
	          const multiLine = scanner2.hasPrecedingLineBreak();
	          const properties = parseDelimitedList(
	            12 /* ObjectLiteralMembers */,
	            parseObjectLiteralElement,
	            /*considerSemicolonAsDelimiter*/
	            true
	          );
	          parseExpectedMatchingBrackets(19 /* OpenBraceToken */, 20 /* CloseBraceToken */, openBraceParsed, openBracePosition);
	          return finishNode(factoryCreateObjectLiteralExpression(properties, multiLine), pos);
	        }
	        function parseFunctionExpression() {
	          const savedDecoratorContext = inDecoratorContext();
	          setDecoratorContext(
	            /*val*/
	            false
	          );
	          const pos = getNodePos();
	          const hasJSDoc = hasPrecedingJSDocComment();
	          const modifiers = parseModifiers(
	            /*allowDecorators*/
	            false
	          );
	          parseExpected(100 /* FunctionKeyword */);
	          const asteriskToken = parseOptionalToken(42 /* AsteriskToken */);
	          const isGenerator = asteriskToken ? 1 /* Yield */ : 0 /* None */;
	          const isAsync = some(modifiers, isAsyncModifier) ? 2 /* Await */ : 0 /* None */;
	          const name = isGenerator && isAsync ? doInYieldAndAwaitContext(parseOptionalBindingIdentifier) : isGenerator ? doInYieldContext(parseOptionalBindingIdentifier) : isAsync ? doInAwaitContext(parseOptionalBindingIdentifier) : parseOptionalBindingIdentifier();
	          const typeParameters = parseTypeParameters();
	          const parameters = parseParameters(isGenerator | isAsync);
	          const type = parseReturnType(
	            59 /* ColonToken */,
	            /*isType*/
	            false
	          );
	          const body = parseFunctionBlock(isGenerator | isAsync);
	          setDecoratorContext(savedDecoratorContext);
	          const node = factory2.createFunctionExpression(modifiers, asteriskToken, name, typeParameters, parameters, type, body);
	          return withJSDoc(finishNode(node, pos), hasJSDoc);
	        }
	        function parseOptionalBindingIdentifier() {
	          return isBindingIdentifier() ? parseBindingIdentifier() : void 0;
	        }
	        function parseNewExpressionOrNewDotTarget() {
	          const pos = getNodePos();
	          parseExpected(105 /* NewKeyword */);
	          if (parseOptional(25 /* DotToken */)) {
	            const name = parseIdentifierName();
	            return finishNode(factory2.createMetaProperty(105 /* NewKeyword */, name), pos);
	          }
	          const expressionPos = getNodePos();
	          let expression = parseMemberExpressionRest(
	            expressionPos,
	            parsePrimaryExpression(),
	            /*allowOptionalChain*/
	            false
	          );
	          let typeArguments;
	          if (expression.kind === 233 /* ExpressionWithTypeArguments */) {
	            typeArguments = expression.typeArguments;
	            expression = expression.expression;
	          }
	          if (token() === 29 /* QuestionDotToken */) {
	            parseErrorAtCurrentToken(Diagnostics.Invalid_optional_chain_from_new_expression_Did_you_mean_to_call_0, getTextOfNodeFromSourceText(sourceText, expression));
	          }
	          const argumentList = token() === 21 /* OpenParenToken */ ? parseArgumentList() : void 0;
	          return finishNode(factoryCreateNewExpression(expression, typeArguments, argumentList), pos);
	        }
	        function parseBlock(ignoreMissingOpenBrace, diagnosticMessage) {
	          const pos = getNodePos();
	          const hasJSDoc = hasPrecedingJSDocComment();
	          const openBracePosition = scanner2.getTokenStart();
	          const openBraceParsed = parseExpected(19 /* OpenBraceToken */, diagnosticMessage);
	          if (openBraceParsed || ignoreMissingOpenBrace) {
	            const multiLine = scanner2.hasPrecedingLineBreak();
	            const statements = parseList(1 /* BlockStatements */, parseStatement);
	            parseExpectedMatchingBrackets(19 /* OpenBraceToken */, 20 /* CloseBraceToken */, openBraceParsed, openBracePosition);
	            const result = withJSDoc(finishNode(factoryCreateBlock(statements, multiLine), pos), hasJSDoc);
	            if (token() === 64 /* EqualsToken */) {
	              parseErrorAtCurrentToken(Diagnostics.Declaration_or_statement_expected_This_follows_a_block_of_statements_so_if_you_intended_to_write_a_destructuring_assignment_you_might_need_to_wrap_the_whole_assignment_in_parentheses);
	              nextToken();
	            }
	            return result;
	          } else {
	            const statements = createMissingList();
	            return withJSDoc(finishNode(factoryCreateBlock(
	              statements,
	              /*multiLine*/
	              void 0
	            ), pos), hasJSDoc);
	          }
	        }
	        function parseFunctionBlock(flags, diagnosticMessage) {
	          const savedYieldContext = inYieldContext();
	          setYieldContext(!!(flags & 1 /* Yield */));
	          const savedAwaitContext = inAwaitContext();
	          setAwaitContext(!!(flags & 2 /* Await */));
	          const savedTopLevel = topLevel;
	          topLevel = false;
	          const saveDecoratorContext = inDecoratorContext();
	          if (saveDecoratorContext) {
	            setDecoratorContext(
	              /*val*/
	              false
	            );
	          }
	          const block = parseBlock(!!(flags & 16 /* IgnoreMissingOpenBrace */), diagnosticMessage);
	          if (saveDecoratorContext) {
	            setDecoratorContext(
	              /*val*/
	              true
	            );
	          }
	          topLevel = savedTopLevel;
	          setYieldContext(savedYieldContext);
	          setAwaitContext(savedAwaitContext);
	          return block;
	        }
	        function parseEmptyStatement() {
	          const pos = getNodePos();
	          const hasJSDoc = hasPrecedingJSDocComment();
	          parseExpected(27 /* SemicolonToken */);
	          return withJSDoc(finishNode(factory2.createEmptyStatement(), pos), hasJSDoc);
	        }
	        function parseIfStatement() {
	          const pos = getNodePos();
	          const hasJSDoc = hasPrecedingJSDocComment();
	          parseExpected(101 /* IfKeyword */);
	          const openParenPosition = scanner2.getTokenStart();
	          const openParenParsed = parseExpected(21 /* OpenParenToken */);
	          const expression = allowInAnd(parseExpression);
	          parseExpectedMatchingBrackets(21 /* OpenParenToken */, 22 /* CloseParenToken */, openParenParsed, openParenPosition);
	          const thenStatement = parseStatement();
	          const elseStatement = parseOptional(93 /* ElseKeyword */) ? parseStatement() : void 0;
	          return withJSDoc(finishNode(factoryCreateIfStatement(expression, thenStatement, elseStatement), pos), hasJSDoc);
	        }
	        function parseDoStatement() {
	          const pos = getNodePos();
	          const hasJSDoc = hasPrecedingJSDocComment();
	          parseExpected(92 /* DoKeyword */);
	          const statement = parseStatement();
	          parseExpected(117 /* WhileKeyword */);
	          const openParenPosition = scanner2.getTokenStart();
	          const openParenParsed = parseExpected(21 /* OpenParenToken */);
	          const expression = allowInAnd(parseExpression);
	          parseExpectedMatchingBrackets(21 /* OpenParenToken */, 22 /* CloseParenToken */, openParenParsed, openParenPosition);
	          parseOptional(27 /* SemicolonToken */);
	          return withJSDoc(finishNode(factory2.createDoStatement(statement, expression), pos), hasJSDoc);
	        }
	        function parseWhileStatement() {
	          const pos = getNodePos();
	          const hasJSDoc = hasPrecedingJSDocComment();
	          parseExpected(117 /* WhileKeyword */);
	          const openParenPosition = scanner2.getTokenStart();
	          const openParenParsed = parseExpected(21 /* OpenParenToken */);
	          const expression = allowInAnd(parseExpression);
	          parseExpectedMatchingBrackets(21 /* OpenParenToken */, 22 /* CloseParenToken */, openParenParsed, openParenPosition);
	          const statement = parseStatement();
	          return withJSDoc(finishNode(factoryCreateWhileStatement(expression, statement), pos), hasJSDoc);
	        }
	        function parseForOrForInOrForOfStatement() {
	          const pos = getNodePos();
	          const hasJSDoc = hasPrecedingJSDocComment();
	          parseExpected(99 /* ForKeyword */);
	          const awaitToken = parseOptionalToken(135 /* AwaitKeyword */);
	          parseExpected(21 /* OpenParenToken */);
	          let initializer;
	          if (token() !== 27 /* SemicolonToken */) {
	            if (token() === 115 /* VarKeyword */ || token() === 121 /* LetKeyword */ || token() === 87 /* ConstKeyword */ || token() === 160 /* UsingKeyword */ && lookAhead(nextTokenIsBindingIdentifierOrStartOfDestructuringOnSameLineDisallowOf) || // this one is meant to allow of
	            token() === 135 /* AwaitKeyword */ && lookAhead(nextTokenIsUsingKeywordThenBindingIdentifierOrStartOfObjectDestructuringOnSameLine)) {
	              initializer = parseVariableDeclarationList(
	                /*inForStatementInitializer*/
	                true
	              );
	            } else {
	              initializer = disallowInAnd(parseExpression);
	            }
	          }
	          let node;
	          if (awaitToken ? parseExpected(165 /* OfKeyword */) : parseOptional(165 /* OfKeyword */)) {
	            const expression = allowInAnd(() => parseAssignmentExpressionOrHigher(
	              /*allowReturnTypeInArrowFunction*/
	              true
	            ));
	            parseExpected(22 /* CloseParenToken */);
	            node = factoryCreateForOfStatement(awaitToken, initializer, expression, parseStatement());
	          } else if (parseOptional(103 /* InKeyword */)) {
	            const expression = allowInAnd(parseExpression);
	            parseExpected(22 /* CloseParenToken */);
	            node = factory2.createForInStatement(initializer, expression, parseStatement());
	          } else {
	            parseExpected(27 /* SemicolonToken */);
	            const condition = token() !== 27 /* SemicolonToken */ && token() !== 22 /* CloseParenToken */ ? allowInAnd(parseExpression) : void 0;
	            parseExpected(27 /* SemicolonToken */);
	            const incrementor = token() !== 22 /* CloseParenToken */ ? allowInAnd(parseExpression) : void 0;
	            parseExpected(22 /* CloseParenToken */);
	            node = factoryCreateForStatement(initializer, condition, incrementor, parseStatement());
	          }
	          return withJSDoc(finishNode(node, pos), hasJSDoc);
	        }
	        function parseBreakOrContinueStatement(kind) {
	          const pos = getNodePos();
	          const hasJSDoc = hasPrecedingJSDocComment();
	          parseExpected(kind === 252 /* BreakStatement */ ? 83 /* BreakKeyword */ : 88 /* ContinueKeyword */);
	          const label = canParseSemicolon() ? void 0 : parseIdentifier();
	          parseSemicolon();
	          const node = kind === 252 /* BreakStatement */ ? factory2.createBreakStatement(label) : factory2.createContinueStatement(label);
	          return withJSDoc(finishNode(node, pos), hasJSDoc);
	        }
	        function parseReturnStatement() {
	          const pos = getNodePos();
	          const hasJSDoc = hasPrecedingJSDocComment();
	          parseExpected(107 /* ReturnKeyword */);
	          const expression = canParseSemicolon() ? void 0 : allowInAnd(parseExpression);
	          parseSemicolon();
	          return withJSDoc(finishNode(factory2.createReturnStatement(expression), pos), hasJSDoc);
	        }
	        function parseWithStatement() {
	          const pos = getNodePos();
	          const hasJSDoc = hasPrecedingJSDocComment();
	          parseExpected(118 /* WithKeyword */);
	          const openParenPosition = scanner2.getTokenStart();
	          const openParenParsed = parseExpected(21 /* OpenParenToken */);
	          const expression = allowInAnd(parseExpression);
	          parseExpectedMatchingBrackets(21 /* OpenParenToken */, 22 /* CloseParenToken */, openParenParsed, openParenPosition);
	          const statement = doInsideOfContext(67108864 /* InWithStatement */, parseStatement);
	          return withJSDoc(finishNode(factory2.createWithStatement(expression, statement), pos), hasJSDoc);
	        }
	        function parseCaseClause() {
	          const pos = getNodePos();
	          const hasJSDoc = hasPrecedingJSDocComment();
	          parseExpected(84 /* CaseKeyword */);
	          const expression = allowInAnd(parseExpression);
	          parseExpected(59 /* ColonToken */);
	          const statements = parseList(3 /* SwitchClauseStatements */, parseStatement);
	          return withJSDoc(finishNode(factory2.createCaseClause(expression, statements), pos), hasJSDoc);
	        }
	        function parseDefaultClause() {
	          const pos = getNodePos();
	          parseExpected(90 /* DefaultKeyword */);
	          parseExpected(59 /* ColonToken */);
	          const statements = parseList(3 /* SwitchClauseStatements */, parseStatement);
	          return finishNode(factory2.createDefaultClause(statements), pos);
	        }
	        function parseCaseOrDefaultClause() {
	          return token() === 84 /* CaseKeyword */ ? parseCaseClause() : parseDefaultClause();
	        }
	        function parseCaseBlock() {
	          const pos = getNodePos();
	          parseExpected(19 /* OpenBraceToken */);
	          const clauses = parseList(2 /* SwitchClauses */, parseCaseOrDefaultClause);
	          parseExpected(20 /* CloseBraceToken */);
	          return finishNode(factory2.createCaseBlock(clauses), pos);
	        }
	        function parseSwitchStatement() {
	          const pos = getNodePos();
	          const hasJSDoc = hasPrecedingJSDocComment();
	          parseExpected(109 /* SwitchKeyword */);
	          parseExpected(21 /* OpenParenToken */);
	          const expression = allowInAnd(parseExpression);
	          parseExpected(22 /* CloseParenToken */);
	          const caseBlock = parseCaseBlock();
	          return withJSDoc(finishNode(factory2.createSwitchStatement(expression, caseBlock), pos), hasJSDoc);
	        }
	        function parseThrowStatement() {
	          const pos = getNodePos();
	          const hasJSDoc = hasPrecedingJSDocComment();
	          parseExpected(111 /* ThrowKeyword */);
	          let expression = scanner2.hasPrecedingLineBreak() ? void 0 : allowInAnd(parseExpression);
	          if (expression === void 0) {
	            identifierCount++;
	            expression = finishNode(factoryCreateIdentifier(""), getNodePos());
	          }
	          if (!tryParseSemicolon()) {
	            parseErrorForMissingSemicolonAfter(expression);
	          }
	          return withJSDoc(finishNode(factory2.createThrowStatement(expression), pos), hasJSDoc);
	        }
	        function parseTryStatement() {
	          const pos = getNodePos();
	          const hasJSDoc = hasPrecedingJSDocComment();
	          parseExpected(113 /* TryKeyword */);
	          const tryBlock = parseBlock(
	            /*ignoreMissingOpenBrace*/
	            false
	          );
	          const catchClause = token() === 85 /* CatchKeyword */ ? parseCatchClause() : void 0;
	          let finallyBlock;
	          if (!catchClause || token() === 98 /* FinallyKeyword */) {
	            parseExpected(98 /* FinallyKeyword */, Diagnostics.catch_or_finally_expected);
	            finallyBlock = parseBlock(
	              /*ignoreMissingOpenBrace*/
	              false
	            );
	          }
	          return withJSDoc(finishNode(factory2.createTryStatement(tryBlock, catchClause, finallyBlock), pos), hasJSDoc);
	        }
	        function parseCatchClause() {
	          const pos = getNodePos();
	          parseExpected(85 /* CatchKeyword */);
	          let variableDeclaration;
	          if (parseOptional(21 /* OpenParenToken */)) {
	            variableDeclaration = parseVariableDeclaration();
	            parseExpected(22 /* CloseParenToken */);
	          } else {
	            variableDeclaration = void 0;
	          }
	          const block = parseBlock(
	            /*ignoreMissingOpenBrace*/
	            false
	          );
	          return finishNode(factory2.createCatchClause(variableDeclaration, block), pos);
	        }
	        function parseDebuggerStatement() {
	          const pos = getNodePos();
	          const hasJSDoc = hasPrecedingJSDocComment();
	          parseExpected(89 /* DebuggerKeyword */);
	          parseSemicolon();
	          return withJSDoc(finishNode(factory2.createDebuggerStatement(), pos), hasJSDoc);
	        }
	        function parseExpressionOrLabeledStatement() {
	          const pos = getNodePos();
	          let hasJSDoc = hasPrecedingJSDocComment();
	          let node;
	          const hasParen = token() === 21 /* OpenParenToken */;
	          const expression = allowInAnd(parseExpression);
	          if (isIdentifier(expression) && parseOptional(59 /* ColonToken */)) {
	            node = factory2.createLabeledStatement(expression, parseStatement());
	          } else {
	            if (!tryParseSemicolon()) {
	              parseErrorForMissingSemicolonAfter(expression);
	            }
	            node = factoryCreateExpressionStatement(expression);
	            if (hasParen) {
	              hasJSDoc = false;
	            }
	          }
	          return withJSDoc(finishNode(node, pos), hasJSDoc);
	        }
	        function nextTokenIsIdentifierOrKeywordOnSameLine() {
	          nextToken();
	          return tokenIsIdentifierOrKeyword(token()) && !scanner2.hasPrecedingLineBreak();
	        }
	        function nextTokenIsClassKeywordOnSameLine() {
	          nextToken();
	          return token() === 86 /* ClassKeyword */ && !scanner2.hasPrecedingLineBreak();
	        }
	        function nextTokenIsFunctionKeywordOnSameLine() {
	          nextToken();
	          return token() === 100 /* FunctionKeyword */ && !scanner2.hasPrecedingLineBreak();
	        }
	        function nextTokenIsIdentifierOrKeywordOrLiteralOnSameLine() {
	          nextToken();
	          return (tokenIsIdentifierOrKeyword(token()) || token() === 9 /* NumericLiteral */ || token() === 10 /* BigIntLiteral */ || token() === 11 /* StringLiteral */) && !scanner2.hasPrecedingLineBreak();
	        }
	        function isDeclaration2() {
	          while (true) {
	            switch (token()) {
	              case 115 /* VarKeyword */:
	              case 121 /* LetKeyword */:
	              case 87 /* ConstKeyword */:
	              case 100 /* FunctionKeyword */:
	              case 86 /* ClassKeyword */:
	              case 94 /* EnumKeyword */:
	                return true;
	              case 160 /* UsingKeyword */:
	                return isUsingDeclaration();
	              case 135 /* AwaitKeyword */:
	                return isAwaitUsingDeclaration();
	              case 120 /* InterfaceKeyword */:
	              case 156 /* TypeKeyword */:
	                return nextTokenIsIdentifierOnSameLine();
	              case 144 /* ModuleKeyword */:
	              case 145 /* NamespaceKeyword */:
	                return nextTokenIsIdentifierOrStringLiteralOnSameLine();
	              case 128 /* AbstractKeyword */:
	              case 129 /* AccessorKeyword */:
	              case 134 /* AsyncKeyword */:
	              case 138 /* DeclareKeyword */:
	              case 123 /* PrivateKeyword */:
	              case 124 /* ProtectedKeyword */:
	              case 125 /* PublicKeyword */:
	              case 148 /* ReadonlyKeyword */:
	                const previousToken = token();
	                nextToken();
	                if (scanner2.hasPrecedingLineBreak()) {
	                  return false;
	                }
	                if (previousToken === 138 /* DeclareKeyword */ && token() === 156 /* TypeKeyword */) {
	                  return true;
	                }
	                continue;
	              case 162 /* GlobalKeyword */:
	                nextToken();
	                return token() === 19 /* OpenBraceToken */ || token() === 80 /* Identifier */ || token() === 95 /* ExportKeyword */;
	              case 102 /* ImportKeyword */:
	                nextToken();
	                return token() === 11 /* StringLiteral */ || token() === 42 /* AsteriskToken */ || token() === 19 /* OpenBraceToken */ || tokenIsIdentifierOrKeyword(token());
	              case 95 /* ExportKeyword */:
	                let currentToken2 = nextToken();
	                if (currentToken2 === 156 /* TypeKeyword */) {
	                  currentToken2 = lookAhead(nextToken);
	                }
	                if (currentToken2 === 64 /* EqualsToken */ || currentToken2 === 42 /* AsteriskToken */ || currentToken2 === 19 /* OpenBraceToken */ || currentToken2 === 90 /* DefaultKeyword */ || currentToken2 === 130 /* AsKeyword */ || currentToken2 === 60 /* AtToken */) {
	                  return true;
	                }
	                continue;
	              case 126 /* StaticKeyword */:
	                nextToken();
	                continue;
	              default:
	                return false;
	            }
	          }
	        }
	        function isStartOfDeclaration() {
	          return lookAhead(isDeclaration2);
	        }
	        function isStartOfStatement() {
	          switch (token()) {
	            case 60 /* AtToken */:
	            case 27 /* SemicolonToken */:
	            case 19 /* OpenBraceToken */:
	            case 115 /* VarKeyword */:
	            case 121 /* LetKeyword */:
	            case 160 /* UsingKeyword */:
	            case 100 /* FunctionKeyword */:
	            case 86 /* ClassKeyword */:
	            case 94 /* EnumKeyword */:
	            case 101 /* IfKeyword */:
	            case 92 /* DoKeyword */:
	            case 117 /* WhileKeyword */:
	            case 99 /* ForKeyword */:
	            case 88 /* ContinueKeyword */:
	            case 83 /* BreakKeyword */:
	            case 107 /* ReturnKeyword */:
	            case 118 /* WithKeyword */:
	            case 109 /* SwitchKeyword */:
	            case 111 /* ThrowKeyword */:
	            case 113 /* TryKeyword */:
	            case 89 /* DebuggerKeyword */:
	            case 85 /* CatchKeyword */:
	            case 98 /* FinallyKeyword */:
	              return true;
	            case 102 /* ImportKeyword */:
	              return isStartOfDeclaration() || lookAhead(nextTokenIsOpenParenOrLessThanOrDot);
	            case 87 /* ConstKeyword */:
	            case 95 /* ExportKeyword */:
	              return isStartOfDeclaration();
	            case 134 /* AsyncKeyword */:
	            case 138 /* DeclareKeyword */:
	            case 120 /* InterfaceKeyword */:
	            case 144 /* ModuleKeyword */:
	            case 145 /* NamespaceKeyword */:
	            case 156 /* TypeKeyword */:
	            case 162 /* GlobalKeyword */:
	              return true;
	            case 129 /* AccessorKeyword */:
	            case 125 /* PublicKeyword */:
	            case 123 /* PrivateKeyword */:
	            case 124 /* ProtectedKeyword */:
	            case 126 /* StaticKeyword */:
	            case 148 /* ReadonlyKeyword */:
	              return isStartOfDeclaration() || !lookAhead(nextTokenIsIdentifierOrKeywordOnSameLine);
	            default:
	              return isStartOfExpression();
	          }
	        }
	        function nextTokenIsBindingIdentifierOrStartOfDestructuring() {
	          nextToken();
	          return isBindingIdentifier() || token() === 19 /* OpenBraceToken */ || token() === 23 /* OpenBracketToken */;
	        }
	        function isLetDeclaration() {
	          return lookAhead(nextTokenIsBindingIdentifierOrStartOfDestructuring);
	        }
	        function nextTokenIsBindingIdentifierOrStartOfDestructuringOnSameLineDisallowOf() {
	          return nextTokenIsBindingIdentifierOrStartOfDestructuringOnSameLine(
	            /*disallowOf*/
	            true
	          );
	        }
	        function nextTokenIsBindingIdentifierOrStartOfDestructuringOnSameLine(disallowOf) {
	          nextToken();
	          if (disallowOf && token() === 165 /* OfKeyword */)
	            return false;
	          return (isBindingIdentifier() || token() === 19 /* OpenBraceToken */) && !scanner2.hasPrecedingLineBreak();
	        }
	        function isUsingDeclaration() {
	          return lookAhead(nextTokenIsBindingIdentifierOrStartOfDestructuringOnSameLine);
	        }
	        function nextTokenIsUsingKeywordThenBindingIdentifierOrStartOfObjectDestructuringOnSameLine(disallowOf) {
	          if (nextToken() === 160 /* UsingKeyword */) {
	            return nextTokenIsBindingIdentifierOrStartOfDestructuringOnSameLine(disallowOf);
	          }
	          return false;
	        }
	        function isAwaitUsingDeclaration() {
	          return lookAhead(nextTokenIsUsingKeywordThenBindingIdentifierOrStartOfObjectDestructuringOnSameLine);
	        }
	        function parseStatement() {
	          switch (token()) {
	            case 27 /* SemicolonToken */:
	              return parseEmptyStatement();
	            case 19 /* OpenBraceToken */:
	              return parseBlock(
	                /*ignoreMissingOpenBrace*/
	                false
	              );
	            case 115 /* VarKeyword */:
	              return parseVariableStatement(
	                getNodePos(),
	                hasPrecedingJSDocComment(),
	                /*modifiers*/
	                void 0
	              );
	            case 121 /* LetKeyword */:
	              if (isLetDeclaration()) {
	                return parseVariableStatement(
	                  getNodePos(),
	                  hasPrecedingJSDocComment(),
	                  /*modifiers*/
	                  void 0
	                );
	              }
	              break;
	            case 135 /* AwaitKeyword */:
	              if (isAwaitUsingDeclaration()) {
	                return parseVariableStatement(
	                  getNodePos(),
	                  hasPrecedingJSDocComment(),
	                  /*modifiers*/
	                  void 0
	                );
	              }
	              break;
	            case 160 /* UsingKeyword */:
	              if (isUsingDeclaration()) {
	                return parseVariableStatement(
	                  getNodePos(),
	                  hasPrecedingJSDocComment(),
	                  /*modifiers*/
	                  void 0
	                );
	              }
	              break;
	            case 100 /* FunctionKeyword */:
	              return parseFunctionDeclaration(
	                getNodePos(),
	                hasPrecedingJSDocComment(),
	                /*modifiers*/
	                void 0
	              );
	            case 86 /* ClassKeyword */:
	              return parseClassDeclaration(
	                getNodePos(),
	                hasPrecedingJSDocComment(),
	                /*modifiers*/
	                void 0
	              );
	            case 101 /* IfKeyword */:
	              return parseIfStatement();
	            case 92 /* DoKeyword */:
	              return parseDoStatement();
	            case 117 /* WhileKeyword */:
	              return parseWhileStatement();
	            case 99 /* ForKeyword */:
	              return parseForOrForInOrForOfStatement();
	            case 88 /* ContinueKeyword */:
	              return parseBreakOrContinueStatement(251 /* ContinueStatement */);
	            case 83 /* BreakKeyword */:
	              return parseBreakOrContinueStatement(252 /* BreakStatement */);
	            case 107 /* ReturnKeyword */:
	              return parseReturnStatement();
	            case 118 /* WithKeyword */:
	              return parseWithStatement();
	            case 109 /* SwitchKeyword */:
	              return parseSwitchStatement();
	            case 111 /* ThrowKeyword */:
	              return parseThrowStatement();
	            case 113 /* TryKeyword */:
	            case 85 /* CatchKeyword */:
	            case 98 /* FinallyKeyword */:
	              return parseTryStatement();
	            case 89 /* DebuggerKeyword */:
	              return parseDebuggerStatement();
	            case 60 /* AtToken */:
	              return parseDeclaration();
	            case 134 /* AsyncKeyword */:
	            case 120 /* InterfaceKeyword */:
	            case 156 /* TypeKeyword */:
	            case 144 /* ModuleKeyword */:
	            case 145 /* NamespaceKeyword */:
	            case 138 /* DeclareKeyword */:
	            case 87 /* ConstKeyword */:
	            case 94 /* EnumKeyword */:
	            case 95 /* ExportKeyword */:
	            case 102 /* ImportKeyword */:
	            case 123 /* PrivateKeyword */:
	            case 124 /* ProtectedKeyword */:
	            case 125 /* PublicKeyword */:
	            case 128 /* AbstractKeyword */:
	            case 129 /* AccessorKeyword */:
	            case 126 /* StaticKeyword */:
	            case 148 /* ReadonlyKeyword */:
	            case 162 /* GlobalKeyword */:
	              if (isStartOfDeclaration()) {
	                return parseDeclaration();
	              }
	              break;
	          }
	          return parseExpressionOrLabeledStatement();
	        }
	        function isDeclareModifier(modifier) {
	          return modifier.kind === 138 /* DeclareKeyword */;
	        }
	        function parseDeclaration() {
	          const pos = getNodePos();
	          const hasJSDoc = hasPrecedingJSDocComment();
	          const modifiers = parseModifiers(
	            /*allowDecorators*/
	            true
	          );
	          const isAmbient = some(modifiers, isDeclareModifier);
	          if (isAmbient) {
	            const node = tryReuseAmbientDeclaration(pos);
	            if (node) {
	              return node;
	            }
	            for (const m of modifiers) {
	              m.flags |= 33554432 /* Ambient */;
	            }
	            return doInsideOfContext(33554432 /* Ambient */, () => parseDeclarationWorker(pos, hasJSDoc, modifiers));
	          } else {
	            return parseDeclarationWorker(pos, hasJSDoc, modifiers);
	          }
	        }
	        function tryReuseAmbientDeclaration(pos) {
	          return doInsideOfContext(33554432 /* Ambient */, () => {
	            const node = currentNode(parsingContext, pos);
	            if (node) {
	              return consumeNode(node);
	            }
	          });
	        }
	        function parseDeclarationWorker(pos, hasJSDoc, modifiersIn) {
	          switch (token()) {
	            case 115 /* VarKeyword */:
	            case 121 /* LetKeyword */:
	            case 87 /* ConstKeyword */:
	            case 160 /* UsingKeyword */:
	            case 135 /* AwaitKeyword */:
	              return parseVariableStatement(pos, hasJSDoc, modifiersIn);
	            case 100 /* FunctionKeyword */:
	              return parseFunctionDeclaration(pos, hasJSDoc, modifiersIn);
	            case 86 /* ClassKeyword */:
	              return parseClassDeclaration(pos, hasJSDoc, modifiersIn);
	            case 120 /* InterfaceKeyword */:
	              return parseInterfaceDeclaration(pos, hasJSDoc, modifiersIn);
	            case 156 /* TypeKeyword */:
	              return parseTypeAliasDeclaration(pos, hasJSDoc, modifiersIn);
	            case 94 /* EnumKeyword */:
	              return parseEnumDeclaration(pos, hasJSDoc, modifiersIn);
	            case 162 /* GlobalKeyword */:
	            case 144 /* ModuleKeyword */:
	            case 145 /* NamespaceKeyword */:
	              return parseModuleDeclaration(pos, hasJSDoc, modifiersIn);
	            case 102 /* ImportKeyword */:
	              return parseImportDeclarationOrImportEqualsDeclaration(pos, hasJSDoc, modifiersIn);
	            case 95 /* ExportKeyword */:
	              nextToken();
	              switch (token()) {
	                case 90 /* DefaultKeyword */:
	                case 64 /* EqualsToken */:
	                  return parseExportAssignment(pos, hasJSDoc, modifiersIn);
	                case 130 /* AsKeyword */:
	                  return parseNamespaceExportDeclaration(pos, hasJSDoc, modifiersIn);
	                default:
	                  return parseExportDeclaration(pos, hasJSDoc, modifiersIn);
	              }
	            default:
	              if (modifiersIn) {
	                const missing = createMissingNode(
	                  282 /* MissingDeclaration */,
	                  /*reportAtCurrentPosition*/
	                  true,
	                  Diagnostics.Declaration_expected
	                );
	                setTextRangePos(missing, pos);
	                missing.modifiers = modifiersIn;
	                return missing;
	              }
	              return void 0;
	          }
	        }
	        function nextTokenIsStringLiteral() {
	          return nextToken() === 11 /* StringLiteral */;
	        }
	        function nextTokenIsFromKeywordOrEqualsToken() {
	          nextToken();
	          return token() === 161 /* FromKeyword */ || token() === 64 /* EqualsToken */;
	        }
	        function nextTokenIsIdentifierOrStringLiteralOnSameLine() {
	          nextToken();
	          return !scanner2.hasPrecedingLineBreak() && (isIdentifier2() || token() === 11 /* StringLiteral */);
	        }
	        function parseFunctionBlockOrSemicolon(flags, diagnosticMessage) {
	          if (token() !== 19 /* OpenBraceToken */) {
	            if (flags & 4 /* Type */) {
	              parseTypeMemberSemicolon();
	              return;
	            }
	            if (canParseSemicolon()) {
	              parseSemicolon();
	              return;
	            }
	          }
	          return parseFunctionBlock(flags, diagnosticMessage);
	        }
	        function parseArrayBindingElement() {
	          const pos = getNodePos();
	          if (token() === 28 /* CommaToken */) {
	            return finishNode(factory2.createOmittedExpression(), pos);
	          }
	          const dotDotDotToken = parseOptionalToken(26 /* DotDotDotToken */);
	          const name = parseIdentifierOrPattern();
	          const initializer = parseInitializer();
	          return finishNode(factory2.createBindingElement(
	            dotDotDotToken,
	            /*propertyName*/
	            void 0,
	            name,
	            initializer
	          ), pos);
	        }
	        function parseObjectBindingElement() {
	          const pos = getNodePos();
	          const dotDotDotToken = parseOptionalToken(26 /* DotDotDotToken */);
	          const tokenIsIdentifier = isBindingIdentifier();
	          let propertyName = parsePropertyName();
	          let name;
	          if (tokenIsIdentifier && token() !== 59 /* ColonToken */) {
	            name = propertyName;
	            propertyName = void 0;
	          } else {
	            parseExpected(59 /* ColonToken */);
	            name = parseIdentifierOrPattern();
	          }
	          const initializer = parseInitializer();
	          return finishNode(factory2.createBindingElement(dotDotDotToken, propertyName, name, initializer), pos);
	        }
	        function parseObjectBindingPattern() {
	          const pos = getNodePos();
	          parseExpected(19 /* OpenBraceToken */);
	          const elements = allowInAnd(() => parseDelimitedList(9 /* ObjectBindingElements */, parseObjectBindingElement));
	          parseExpected(20 /* CloseBraceToken */);
	          return finishNode(factory2.createObjectBindingPattern(elements), pos);
	        }
	        function parseArrayBindingPattern() {
	          const pos = getNodePos();
	          parseExpected(23 /* OpenBracketToken */);
	          const elements = allowInAnd(() => parseDelimitedList(10 /* ArrayBindingElements */, parseArrayBindingElement));
	          parseExpected(24 /* CloseBracketToken */);
	          return finishNode(factory2.createArrayBindingPattern(elements), pos);
	        }
	        function isBindingIdentifierOrPrivateIdentifierOrPattern() {
	          return token() === 19 /* OpenBraceToken */ || token() === 23 /* OpenBracketToken */ || token() === 81 /* PrivateIdentifier */ || isBindingIdentifier();
	        }
	        function parseIdentifierOrPattern(privateIdentifierDiagnosticMessage) {
	          if (token() === 23 /* OpenBracketToken */) {
	            return parseArrayBindingPattern();
	          }
	          if (token() === 19 /* OpenBraceToken */) {
	            return parseObjectBindingPattern();
	          }
	          return parseBindingIdentifier(privateIdentifierDiagnosticMessage);
	        }
	        function parseVariableDeclarationAllowExclamation() {
	          return parseVariableDeclaration(
	            /*allowExclamation*/
	            true
	          );
	        }
	        function parseVariableDeclaration(allowExclamation) {
	          const pos = getNodePos();
	          const hasJSDoc = hasPrecedingJSDocComment();
	          const name = parseIdentifierOrPattern(Diagnostics.Private_identifiers_are_not_allowed_in_variable_declarations);
	          let exclamationToken;
	          if (allowExclamation && name.kind === 80 /* Identifier */ && token() === 54 /* ExclamationToken */ && !scanner2.hasPrecedingLineBreak()) {
	            exclamationToken = parseTokenNode();
	          }
	          const type = parseTypeAnnotation();
	          const initializer = isInOrOfKeyword(token()) ? void 0 : parseInitializer();
	          const node = factoryCreateVariableDeclaration(name, exclamationToken, type, initializer);
	          return withJSDoc(finishNode(node, pos), hasJSDoc);
	        }
	        function parseVariableDeclarationList(inForStatementInitializer) {
	          const pos = getNodePos();
	          let flags = 0;
	          switch (token()) {
	            case 115 /* VarKeyword */:
	              break;
	            case 121 /* LetKeyword */:
	              flags |= 1 /* Let */;
	              break;
	            case 87 /* ConstKeyword */:
	              flags |= 2 /* Const */;
	              break;
	            case 160 /* UsingKeyword */:
	              flags |= 4 /* Using */;
	              break;
	            case 135 /* AwaitKeyword */:
	              Debug.assert(isAwaitUsingDeclaration());
	              flags |= 6 /* AwaitUsing */;
	              nextToken();
	              break;
	            default:
	              Debug.fail();
	          }
	          nextToken();
	          let declarations;
	          if (token() === 165 /* OfKeyword */ && lookAhead(canFollowContextualOfKeyword)) {
	            declarations = createMissingList();
	          } else {
	            const savedDisallowIn = inDisallowInContext();
	            setDisallowInContext(inForStatementInitializer);
	            declarations = parseDelimitedList(
	              8 /* VariableDeclarations */,
	              inForStatementInitializer ? parseVariableDeclaration : parseVariableDeclarationAllowExclamation
	            );
	            setDisallowInContext(savedDisallowIn);
	          }
	          return finishNode(factoryCreateVariableDeclarationList(declarations, flags), pos);
	        }
	        function canFollowContextualOfKeyword() {
	          return nextTokenIsIdentifier() && nextToken() === 22 /* CloseParenToken */;
	        }
	        function parseVariableStatement(pos, hasJSDoc, modifiers) {
	          const declarationList = parseVariableDeclarationList(
	            /*inForStatementInitializer*/
	            false
	          );
	          parseSemicolon();
	          const node = factoryCreateVariableStatement(modifiers, declarationList);
	          return withJSDoc(finishNode(node, pos), hasJSDoc);
	        }
	        function parseFunctionDeclaration(pos, hasJSDoc, modifiers) {
	          const savedAwaitContext = inAwaitContext();
	          const modifierFlags = modifiersToFlags(modifiers);
	          parseExpected(100 /* FunctionKeyword */);
	          const asteriskToken = parseOptionalToken(42 /* AsteriskToken */);
	          const name = modifierFlags & 2048 /* Default */ ? parseOptionalBindingIdentifier() : parseBindingIdentifier();
	          const isGenerator = asteriskToken ? 1 /* Yield */ : 0 /* None */;
	          const isAsync = modifierFlags & 1024 /* Async */ ? 2 /* Await */ : 0 /* None */;
	          const typeParameters = parseTypeParameters();
	          if (modifierFlags & 32 /* Export */)
	            setAwaitContext(
	              /*value*/
	              true
	            );
	          const parameters = parseParameters(isGenerator | isAsync);
	          const type = parseReturnType(
	            59 /* ColonToken */,
	            /*isType*/
	            false
	          );
	          const body = parseFunctionBlockOrSemicolon(isGenerator | isAsync, Diagnostics.or_expected);
	          setAwaitContext(savedAwaitContext);
	          const node = factory2.createFunctionDeclaration(modifiers, asteriskToken, name, typeParameters, parameters, type, body);
	          return withJSDoc(finishNode(node, pos), hasJSDoc);
	        }
	        function parseConstructorName() {
	          if (token() === 137 /* ConstructorKeyword */) {
	            return parseExpected(137 /* ConstructorKeyword */);
	          }
	          if (token() === 11 /* StringLiteral */ && lookAhead(nextToken) === 21 /* OpenParenToken */) {
	            return tryParse(() => {
	              const literalNode = parseLiteralNode();
	              return literalNode.text === "constructor" ? literalNode : void 0;
	            });
	          }
	        }
	        function tryParseConstructorDeclaration(pos, hasJSDoc, modifiers) {
	          return tryParse(() => {
	            if (parseConstructorName()) {
	              const typeParameters = parseTypeParameters();
	              const parameters = parseParameters(0 /* None */);
	              const type = parseReturnType(
	                59 /* ColonToken */,
	                /*isType*/
	                false
	              );
	              const body = parseFunctionBlockOrSemicolon(0 /* None */, Diagnostics.or_expected);
	              const node = factory2.createConstructorDeclaration(modifiers, parameters, body);
	              node.typeParameters = typeParameters;
	              node.type = type;
	              return withJSDoc(finishNode(node, pos), hasJSDoc);
	            }
	          });
	        }
	        function parseMethodDeclaration(pos, hasJSDoc, modifiers, asteriskToken, name, questionToken, exclamationToken, diagnosticMessage) {
	          const isGenerator = asteriskToken ? 1 /* Yield */ : 0 /* None */;
	          const isAsync = some(modifiers, isAsyncModifier) ? 2 /* Await */ : 0 /* None */;
	          const typeParameters = parseTypeParameters();
	          const parameters = parseParameters(isGenerator | isAsync);
	          const type = parseReturnType(
	            59 /* ColonToken */,
	            /*isType*/
	            false
	          );
	          const body = parseFunctionBlockOrSemicolon(isGenerator | isAsync, diagnosticMessage);
	          const node = factory2.createMethodDeclaration(
	            modifiers,
	            asteriskToken,
	            name,
	            questionToken,
	            typeParameters,
	            parameters,
	            type,
	            body
	          );
	          node.exclamationToken = exclamationToken;
	          return withJSDoc(finishNode(node, pos), hasJSDoc);
	        }
	        function parsePropertyDeclaration(pos, hasJSDoc, modifiers, name, questionToken) {
	          const exclamationToken = !questionToken && !scanner2.hasPrecedingLineBreak() ? parseOptionalToken(54 /* ExclamationToken */) : void 0;
	          const type = parseTypeAnnotation();
	          const initializer = doOutsideOfContext(16384 /* YieldContext */ | 65536 /* AwaitContext */ | 8192 /* DisallowInContext */, parseInitializer);
	          parseSemicolonAfterPropertyName(name, type, initializer);
	          const node = factory2.createPropertyDeclaration(
	            modifiers,
	            name,
	            questionToken || exclamationToken,
	            type,
	            initializer
	          );
	          return withJSDoc(finishNode(node, pos), hasJSDoc);
	        }
	        function parsePropertyOrMethodDeclaration(pos, hasJSDoc, modifiers) {
	          const asteriskToken = parseOptionalToken(42 /* AsteriskToken */);
	          const name = parsePropertyName();
	          const questionToken = parseOptionalToken(58 /* QuestionToken */);
	          if (asteriskToken || token() === 21 /* OpenParenToken */ || token() === 30 /* LessThanToken */) {
	            return parseMethodDeclaration(
	              pos,
	              hasJSDoc,
	              modifiers,
	              asteriskToken,
	              name,
	              questionToken,
	              /*exclamationToken*/
	              void 0,
	              Diagnostics.or_expected
	            );
	          }
	          return parsePropertyDeclaration(pos, hasJSDoc, modifiers, name, questionToken);
	        }
	        function parseAccessorDeclaration(pos, hasJSDoc, modifiers, kind, flags) {
	          const name = parsePropertyName();
	          const typeParameters = parseTypeParameters();
	          const parameters = parseParameters(0 /* None */);
	          const type = parseReturnType(
	            59 /* ColonToken */,
	            /*isType*/
	            false
	          );
	          const body = parseFunctionBlockOrSemicolon(flags);
	          const node = kind === 177 /* GetAccessor */ ? factory2.createGetAccessorDeclaration(modifiers, name, parameters, type, body) : factory2.createSetAccessorDeclaration(modifiers, name, parameters, body);
	          node.typeParameters = typeParameters;
	          if (isSetAccessorDeclaration(node))
	            node.type = type;
	          return withJSDoc(finishNode(node, pos), hasJSDoc);
	        }
	        function isClassMemberStart() {
	          let idToken;
	          if (token() === 60 /* AtToken */) {
	            return true;
	          }
	          while (isModifierKind(token())) {
	            idToken = token();
	            if (isClassMemberModifier(idToken)) {
	              return true;
	            }
	            nextToken();
	          }
	          if (token() === 42 /* AsteriskToken */) {
	            return true;
	          }
	          if (isLiteralPropertyName()) {
	            idToken = token();
	            nextToken();
	          }
	          if (token() === 23 /* OpenBracketToken */) {
	            return true;
	          }
	          if (idToken !== void 0) {
	            if (!isKeyword(idToken) || idToken === 153 /* SetKeyword */ || idToken === 139 /* GetKeyword */) {
	              return true;
	            }
	            switch (token()) {
	              case 21 /* OpenParenToken */:
	              case 30 /* LessThanToken */:
	              case 54 /* ExclamationToken */:
	              case 59 /* ColonToken */:
	              case 64 /* EqualsToken */:
	              case 58 /* QuestionToken */:
	                return true;
	              default:
	                return canParseSemicolon();
	            }
	          }
	          return false;
	        }
	        function parseClassStaticBlockDeclaration(pos, hasJSDoc, modifiers) {
	          parseExpectedToken(126 /* StaticKeyword */);
	          const body = parseClassStaticBlockBody();
	          const node = withJSDoc(finishNode(factory2.createClassStaticBlockDeclaration(body), pos), hasJSDoc);
	          node.modifiers = modifiers;
	          return node;
	        }
	        function parseClassStaticBlockBody() {
	          const savedYieldContext = inYieldContext();
	          const savedAwaitContext = inAwaitContext();
	          setYieldContext(false);
	          setAwaitContext(true);
	          const body = parseBlock(
	            /*ignoreMissingOpenBrace*/
	            false
	          );
	          setYieldContext(savedYieldContext);
	          setAwaitContext(savedAwaitContext);
	          return body;
	        }
	        function parseDecoratorExpression() {
	          if (inAwaitContext() && token() === 135 /* AwaitKeyword */) {
	            const pos = getNodePos();
	            const awaitExpression = parseIdentifier(Diagnostics.Expression_expected);
	            nextToken();
	            const memberExpression = parseMemberExpressionRest(
	              pos,
	              awaitExpression,
	              /*allowOptionalChain*/
	              true
	            );
	            return parseCallExpressionRest(pos, memberExpression);
	          }
	          return parseLeftHandSideExpressionOrHigher();
	        }
	        function tryParseDecorator() {
	          const pos = getNodePos();
	          if (!parseOptional(60 /* AtToken */)) {
	            return void 0;
	          }
	          const expression = doInDecoratorContext(parseDecoratorExpression);
	          return finishNode(factory2.createDecorator(expression), pos);
	        }
	        function tryParseModifier(hasSeenStaticModifier, permitConstAsModifier, stopOnStartOfClassStaticBlock) {
	          const pos = getNodePos();
	          const kind = token();
	          if (token() === 87 /* ConstKeyword */ && permitConstAsModifier) {
	            if (!tryParse(nextTokenIsOnSameLineAndCanFollowModifier)) {
	              return void 0;
	            }
	          } else if (stopOnStartOfClassStaticBlock && token() === 126 /* StaticKeyword */ && lookAhead(nextTokenIsOpenBrace)) {
	            return void 0;
	          } else if (hasSeenStaticModifier && token() === 126 /* StaticKeyword */) {
	            return void 0;
	          } else {
	            if (!parseAnyContextualModifier()) {
	              return void 0;
	            }
	          }
	          return finishNode(factoryCreateToken(kind), pos);
	        }
	        function parseModifiers(allowDecorators, permitConstAsModifier, stopOnStartOfClassStaticBlock) {
	          const pos = getNodePos();
	          let list;
	          let decorator, modifier, hasSeenStaticModifier = false, hasLeadingModifier = false, hasTrailingDecorator = false;
	          if (allowDecorators && token() === 60 /* AtToken */) {
	            while (decorator = tryParseDecorator()) {
	              list = append(list, decorator);
	            }
	          }
	          while (modifier = tryParseModifier(hasSeenStaticModifier, permitConstAsModifier, stopOnStartOfClassStaticBlock)) {
	            if (modifier.kind === 126 /* StaticKeyword */)
	              hasSeenStaticModifier = true;
	            list = append(list, modifier);
	            hasLeadingModifier = true;
	          }
	          if (hasLeadingModifier && allowDecorators && token() === 60 /* AtToken */) {
	            while (decorator = tryParseDecorator()) {
	              list = append(list, decorator);
	              hasTrailingDecorator = true;
	            }
	          }
	          if (hasTrailingDecorator) {
	            while (modifier = tryParseModifier(hasSeenStaticModifier, permitConstAsModifier, stopOnStartOfClassStaticBlock)) {
	              if (modifier.kind === 126 /* StaticKeyword */)
	                hasSeenStaticModifier = true;
	              list = append(list, modifier);
	            }
	          }
	          return list && createNodeArray(list, pos);
	        }
	        function parseModifiersForArrowFunction() {
	          let modifiers;
	          if (token() === 134 /* AsyncKeyword */) {
	            const pos = getNodePos();
	            nextToken();
	            const modifier = finishNode(factoryCreateToken(134 /* AsyncKeyword */), pos);
	            modifiers = createNodeArray([modifier], pos);
	          }
	          return modifiers;
	        }
	        function parseClassElement() {
	          const pos = getNodePos();
	          const hasJSDoc = hasPrecedingJSDocComment();
	          if (token() === 27 /* SemicolonToken */) {
	            nextToken();
	            return withJSDoc(finishNode(factory2.createSemicolonClassElement(), pos), hasJSDoc);
	          }
	          const modifiers = parseModifiers(
	            /*allowDecorators*/
	            true,
	            /*permitConstAsModifier*/
	            true,
	            /*stopOnStartOfClassStaticBlock*/
	            true
	          );
	          if (token() === 126 /* StaticKeyword */ && lookAhead(nextTokenIsOpenBrace)) {
	            return parseClassStaticBlockDeclaration(pos, hasJSDoc, modifiers);
	          }
	          if (parseContextualModifier(139 /* GetKeyword */)) {
	            return parseAccessorDeclaration(pos, hasJSDoc, modifiers, 177 /* GetAccessor */, 0 /* None */);
	          }
	          if (parseContextualModifier(153 /* SetKeyword */)) {
	            return parseAccessorDeclaration(pos, hasJSDoc, modifiers, 178 /* SetAccessor */, 0 /* None */);
	          }
	          if (token() === 137 /* ConstructorKeyword */ || token() === 11 /* StringLiteral */) {
	            const constructorDeclaration = tryParseConstructorDeclaration(pos, hasJSDoc, modifiers);
	            if (constructorDeclaration) {
	              return constructorDeclaration;
	            }
	          }
	          if (isIndexSignature()) {
	            return parseIndexSignatureDeclaration(pos, hasJSDoc, modifiers);
	          }
	          if (tokenIsIdentifierOrKeyword(token()) || token() === 11 /* StringLiteral */ || token() === 9 /* NumericLiteral */ || token() === 42 /* AsteriskToken */ || token() === 23 /* OpenBracketToken */) {
	            const isAmbient = some(modifiers, isDeclareModifier);
	            if (isAmbient) {
	              for (const m of modifiers) {
	                m.flags |= 33554432 /* Ambient */;
	              }
	              return doInsideOfContext(33554432 /* Ambient */, () => parsePropertyOrMethodDeclaration(pos, hasJSDoc, modifiers));
	            } else {
	              return parsePropertyOrMethodDeclaration(pos, hasJSDoc, modifiers);
	            }
	          }
	          if (modifiers) {
	            const name = createMissingNode(
	              80 /* Identifier */,
	              /*reportAtCurrentPosition*/
	              true,
	              Diagnostics.Declaration_expected
	            );
	            return parsePropertyDeclaration(
	              pos,
	              hasJSDoc,
	              modifiers,
	              name,
	              /*questionToken*/
	              void 0
	            );
	          }
	          return Debug.fail("Should not have attempted to parse class member declaration.");
	        }
	        function parseDecoratedExpression() {
	          const pos = getNodePos();
	          const hasJSDoc = hasPrecedingJSDocComment();
	          const modifiers = parseModifiers(
	            /*allowDecorators*/
	            true
	          );
	          if (token() === 86 /* ClassKeyword */) {
	            return parseClassDeclarationOrExpression(pos, hasJSDoc, modifiers, 231 /* ClassExpression */);
	          }
	          const missing = createMissingNode(
	            282 /* MissingDeclaration */,
	            /*reportAtCurrentPosition*/
	            true,
	            Diagnostics.Expression_expected
	          );
	          setTextRangePos(missing, pos);
	          missing.modifiers = modifiers;
	          return missing;
	        }
	        function parseClassExpression() {
	          return parseClassDeclarationOrExpression(
	            getNodePos(),
	            hasPrecedingJSDocComment(),
	            /*modifiers*/
	            void 0,
	            231 /* ClassExpression */
	          );
	        }
	        function parseClassDeclaration(pos, hasJSDoc, modifiers) {
	          return parseClassDeclarationOrExpression(pos, hasJSDoc, modifiers, 263 /* ClassDeclaration */);
	        }
	        function parseClassDeclarationOrExpression(pos, hasJSDoc, modifiers, kind) {
	          const savedAwaitContext = inAwaitContext();
	          parseExpected(86 /* ClassKeyword */);
	          const name = parseNameOfClassDeclarationOrExpression();
	          const typeParameters = parseTypeParameters();
	          if (some(modifiers, isExportModifier))
	            setAwaitContext(
	              /*value*/
	              true
	            );
	          const heritageClauses = parseHeritageClauses();
	          let members;
	          if (parseExpected(19 /* OpenBraceToken */)) {
	            members = parseClassMembers();
	            parseExpected(20 /* CloseBraceToken */);
	          } else {
	            members = createMissingList();
	          }
	          setAwaitContext(savedAwaitContext);
	          const node = kind === 263 /* ClassDeclaration */ ? factory2.createClassDeclaration(modifiers, name, typeParameters, heritageClauses, members) : factory2.createClassExpression(modifiers, name, typeParameters, heritageClauses, members);
	          return withJSDoc(finishNode(node, pos), hasJSDoc);
	        }
	        function parseNameOfClassDeclarationOrExpression() {
	          return isBindingIdentifier() && !isImplementsClause() ? createIdentifier(isBindingIdentifier()) : void 0;
	        }
	        function isImplementsClause() {
	          return token() === 119 /* ImplementsKeyword */ && lookAhead(nextTokenIsIdentifierOrKeyword);
	        }
	        function parseHeritageClauses() {
	          if (isHeritageClause2()) {
	            return parseList(22 /* HeritageClauses */, parseHeritageClause);
	          }
	          return void 0;
	        }
	        function parseHeritageClause() {
	          const pos = getNodePos();
	          const tok = token();
	          Debug.assert(tok === 96 /* ExtendsKeyword */ || tok === 119 /* ImplementsKeyword */);
	          nextToken();
	          const types = parseDelimitedList(7 /* HeritageClauseElement */, parseExpressionWithTypeArguments);
	          return finishNode(factory2.createHeritageClause(tok, types), pos);
	        }
	        function parseExpressionWithTypeArguments() {
	          const pos = getNodePos();
	          const expression = parseLeftHandSideExpressionOrHigher();
	          if (expression.kind === 233 /* ExpressionWithTypeArguments */) {
	            return expression;
	          }
	          const typeArguments = tryParseTypeArguments();
	          return finishNode(factory2.createExpressionWithTypeArguments(expression, typeArguments), pos);
	        }
	        function tryParseTypeArguments() {
	          return token() === 30 /* LessThanToken */ ? parseBracketedList(20 /* TypeArguments */, parseType, 30 /* LessThanToken */, 32 /* GreaterThanToken */) : void 0;
	        }
	        function isHeritageClause2() {
	          return token() === 96 /* ExtendsKeyword */ || token() === 119 /* ImplementsKeyword */;
	        }
	        function parseClassMembers() {
	          return parseList(5 /* ClassMembers */, parseClassElement);
	        }
	        function parseInterfaceDeclaration(pos, hasJSDoc, modifiers) {
	          parseExpected(120 /* InterfaceKeyword */);
	          const name = parseIdentifier();
	          const typeParameters = parseTypeParameters();
	          const heritageClauses = parseHeritageClauses();
	          const members = parseObjectTypeMembers();
	          const node = factory2.createInterfaceDeclaration(modifiers, name, typeParameters, heritageClauses, members);
	          return withJSDoc(finishNode(node, pos), hasJSDoc);
	        }
	        function parseTypeAliasDeclaration(pos, hasJSDoc, modifiers) {
	          parseExpected(156 /* TypeKeyword */);
	          if (scanner2.hasPrecedingLineBreak()) {
	            parseErrorAtCurrentToken(Diagnostics.Line_break_not_permitted_here);
	          }
	          const name = parseIdentifier();
	          const typeParameters = parseTypeParameters();
	          parseExpected(64 /* EqualsToken */);
	          const type = token() === 141 /* IntrinsicKeyword */ && tryParse(parseKeywordAndNoDot) || parseType();
	          parseSemicolon();
	          const node = factory2.createTypeAliasDeclaration(modifiers, name, typeParameters, type);
	          return withJSDoc(finishNode(node, pos), hasJSDoc);
	        }
	        function parseEnumMember() {
	          const pos = getNodePos();
	          const hasJSDoc = hasPrecedingJSDocComment();
	          const name = parsePropertyName();
	          const initializer = allowInAnd(parseInitializer);
	          return withJSDoc(finishNode(factory2.createEnumMember(name, initializer), pos), hasJSDoc);
	        }
	        function parseEnumDeclaration(pos, hasJSDoc, modifiers) {
	          parseExpected(94 /* EnumKeyword */);
	          const name = parseIdentifier();
	          let members;
	          if (parseExpected(19 /* OpenBraceToken */)) {
	            members = doOutsideOfYieldAndAwaitContext(() => parseDelimitedList(6 /* EnumMembers */, parseEnumMember));
	            parseExpected(20 /* CloseBraceToken */);
	          } else {
	            members = createMissingList();
	          }
	          const node = factory2.createEnumDeclaration(modifiers, name, members);
	          return withJSDoc(finishNode(node, pos), hasJSDoc);
	        }
	        function parseModuleBlock() {
	          const pos = getNodePos();
	          let statements;
	          if (parseExpected(19 /* OpenBraceToken */)) {
	            statements = parseList(1 /* BlockStatements */, parseStatement);
	            parseExpected(20 /* CloseBraceToken */);
	          } else {
	            statements = createMissingList();
	          }
	          return finishNode(factory2.createModuleBlock(statements), pos);
	        }
	        function parseModuleOrNamespaceDeclaration(pos, hasJSDoc, modifiers, flags) {
	          const namespaceFlag = flags & 32 /* Namespace */;
	          const name = flags & 8 /* NestedNamespace */ ? parseIdentifierName() : parseIdentifier();
	          const body = parseOptional(25 /* DotToken */) ? parseModuleOrNamespaceDeclaration(
	            getNodePos(),
	            /*hasJSDoc*/
	            false,
	            /*modifiers*/
	            void 0,
	            8 /* NestedNamespace */ | namespaceFlag
	          ) : parseModuleBlock();
	          const node = factory2.createModuleDeclaration(modifiers, name, body, flags);
	          return withJSDoc(finishNode(node, pos), hasJSDoc);
	        }
	        function parseAmbientExternalModuleDeclaration(pos, hasJSDoc, modifiersIn) {
	          let flags = 0;
	          let name;
	          if (token() === 162 /* GlobalKeyword */) {
	            name = parseIdentifier();
	            flags |= 2048 /* GlobalAugmentation */;
	          } else {
	            name = parseLiteralNode();
	            name.text = internIdentifier(name.text);
	          }
	          let body;
	          if (token() === 19 /* OpenBraceToken */) {
	            body = parseModuleBlock();
	          } else {
	            parseSemicolon();
	          }
	          const node = factory2.createModuleDeclaration(modifiersIn, name, body, flags);
	          return withJSDoc(finishNode(node, pos), hasJSDoc);
	        }
	        function parseModuleDeclaration(pos, hasJSDoc, modifiersIn) {
	          let flags = 0;
	          if (token() === 162 /* GlobalKeyword */) {
	            return parseAmbientExternalModuleDeclaration(pos, hasJSDoc, modifiersIn);
	          } else if (parseOptional(145 /* NamespaceKeyword */)) {
	            flags |= 32 /* Namespace */;
	          } else {
	            parseExpected(144 /* ModuleKeyword */);
	            if (token() === 11 /* StringLiteral */) {
	              return parseAmbientExternalModuleDeclaration(pos, hasJSDoc, modifiersIn);
	            }
	          }
	          return parseModuleOrNamespaceDeclaration(pos, hasJSDoc, modifiersIn, flags);
	        }
	        function isExternalModuleReference2() {
	          return token() === 149 /* RequireKeyword */ && lookAhead(nextTokenIsOpenParen);
	        }
	        function nextTokenIsOpenParen() {
	          return nextToken() === 21 /* OpenParenToken */;
	        }
	        function nextTokenIsOpenBrace() {
	          return nextToken() === 19 /* OpenBraceToken */;
	        }
	        function nextTokenIsSlash() {
	          return nextToken() === 44 /* SlashToken */;
	        }
	        function parseNamespaceExportDeclaration(pos, hasJSDoc, modifiers) {
	          parseExpected(130 /* AsKeyword */);
	          parseExpected(145 /* NamespaceKeyword */);
	          const name = parseIdentifier();
	          parseSemicolon();
	          const node = factory2.createNamespaceExportDeclaration(name);
	          node.modifiers = modifiers;
	          return withJSDoc(finishNode(node, pos), hasJSDoc);
	        }
	        function parseImportDeclarationOrImportEqualsDeclaration(pos, hasJSDoc, modifiers) {
	          parseExpected(102 /* ImportKeyword */);
	          const afterImportPos = scanner2.getTokenFullStart();
	          let identifier;
	          if (isIdentifier2()) {
	            identifier = parseIdentifier();
	          }
	          let isTypeOnly = false;
	          if ((identifier == null ? void 0 : identifier.escapedText) === "type" && (token() !== 161 /* FromKeyword */ || isIdentifier2() && lookAhead(nextTokenIsFromKeywordOrEqualsToken)) && (isIdentifier2() || tokenAfterImportDefinitelyProducesImportDeclaration())) {
	            isTypeOnly = true;
	            identifier = isIdentifier2() ? parseIdentifier() : void 0;
	          }
	          if (identifier && !tokenAfterImportedIdentifierDefinitelyProducesImportDeclaration()) {
	            return parseImportEqualsDeclaration(pos, hasJSDoc, modifiers, identifier, isTypeOnly);
	          }
	          let importClause;
	          if (identifier || // import id
	          token() === 42 /* AsteriskToken */ || // import *
	          token() === 19 /* OpenBraceToken */) {
	            importClause = parseImportClause(identifier, afterImportPos, isTypeOnly);
	            parseExpected(161 /* FromKeyword */);
	          }
	          const moduleSpecifier = parseModuleSpecifier();
	          const currentToken2 = token();
	          let attributes;
	          if ((currentToken2 === 118 /* WithKeyword */ || currentToken2 === 132 /* AssertKeyword */) && !scanner2.hasPrecedingLineBreak()) {
	            attributes = parseImportAttributes(currentToken2);
	          }
	          parseSemicolon();
	          const node = factory2.createImportDeclaration(modifiers, importClause, moduleSpecifier, attributes);
	          return withJSDoc(finishNode(node, pos), hasJSDoc);
	        }
	        function parseImportAttribute() {
	          const pos = getNodePos();
	          const name = tokenIsIdentifierOrKeyword(token()) ? parseIdentifierName() : parseLiteralLikeNode(11 /* StringLiteral */);
	          parseExpected(59 /* ColonToken */);
	          const value = parseAssignmentExpressionOrHigher(
	            /*allowReturnTypeInArrowFunction*/
	            true
	          );
	          return finishNode(factory2.createImportAttribute(name, value), pos);
	        }
	        function parseImportAttributes(token2, skipKeyword) {
	          const pos = getNodePos();
	          if (!skipKeyword) {
	            parseExpected(token2);
	          }
	          const openBracePosition = scanner2.getTokenStart();
	          if (parseExpected(19 /* OpenBraceToken */)) {
	            const multiLine = scanner2.hasPrecedingLineBreak();
	            const elements = parseDelimitedList(
	              24 /* ImportAttributes */,
	              parseImportAttribute,
	              /*considerSemicolonAsDelimiter*/
	              true
	            );
	            if (!parseExpected(20 /* CloseBraceToken */)) {
	              const lastError = lastOrUndefined(parseDiagnostics);
	              if (lastError && lastError.code === Diagnostics._0_expected.code) {
	                addRelatedInfo(
	                  lastError,
	                  createDetachedDiagnostic(fileName, sourceText, openBracePosition, 1, Diagnostics.The_parser_expected_to_find_a_1_to_match_the_0_token_here, "{", "}")
	                );
	              }
	            }
	            return finishNode(factory2.createImportAttributes(elements, multiLine, token2), pos);
	          } else {
	            const elements = createNodeArray(
	              [],
	              getNodePos(),
	              /*end*/
	              void 0,
	              /*hasTrailingComma*/
	              false
	            );
	            return finishNode(factory2.createImportAttributes(
	              elements,
	              /*multiLine*/
	              false,
	              token2
	            ), pos);
	          }
	        }
	        function tokenAfterImportDefinitelyProducesImportDeclaration() {
	          return token() === 42 /* AsteriskToken */ || token() === 19 /* OpenBraceToken */;
	        }
	        function tokenAfterImportedIdentifierDefinitelyProducesImportDeclaration() {
	          return token() === 28 /* CommaToken */ || token() === 161 /* FromKeyword */;
	        }
	        function parseImportEqualsDeclaration(pos, hasJSDoc, modifiers, identifier, isTypeOnly) {
	          parseExpected(64 /* EqualsToken */);
	          const moduleReference = parseModuleReference();
	          parseSemicolon();
	          const node = factory2.createImportEqualsDeclaration(modifiers, isTypeOnly, identifier, moduleReference);
	          const finished = withJSDoc(finishNode(node, pos), hasJSDoc);
	          return finished;
	        }
	        function parseImportClause(identifier, pos, isTypeOnly) {
	          let namedBindings;
	          if (!identifier || parseOptional(28 /* CommaToken */)) {
	            namedBindings = token() === 42 /* AsteriskToken */ ? parseNamespaceImport() : parseNamedImportsOrExports(275 /* NamedImports */);
	          }
	          return finishNode(factory2.createImportClause(isTypeOnly, identifier, namedBindings), pos);
	        }
	        function parseModuleReference() {
	          return isExternalModuleReference2() ? parseExternalModuleReference() : parseEntityName(
	            /*allowReservedWords*/
	            false
	          );
	        }
	        function parseExternalModuleReference() {
	          const pos = getNodePos();
	          parseExpected(149 /* RequireKeyword */);
	          parseExpected(21 /* OpenParenToken */);
	          const expression = parseModuleSpecifier();
	          parseExpected(22 /* CloseParenToken */);
	          return finishNode(factory2.createExternalModuleReference(expression), pos);
	        }
	        function parseModuleSpecifier() {
	          if (token() === 11 /* StringLiteral */) {
	            const result = parseLiteralNode();
	            result.text = internIdentifier(result.text);
	            return result;
	          } else {
	            return parseExpression();
	          }
	        }
	        function parseNamespaceImport() {
	          const pos = getNodePos();
	          parseExpected(42 /* AsteriskToken */);
	          parseExpected(130 /* AsKeyword */);
	          const name = parseIdentifier();
	          return finishNode(factory2.createNamespaceImport(name), pos);
	        }
	        function parseNamedImportsOrExports(kind) {
	          const pos = getNodePos();
	          const node = kind === 275 /* NamedImports */ ? factory2.createNamedImports(parseBracketedList(23 /* ImportOrExportSpecifiers */, parseImportSpecifier, 19 /* OpenBraceToken */, 20 /* CloseBraceToken */)) : factory2.createNamedExports(parseBracketedList(23 /* ImportOrExportSpecifiers */, parseExportSpecifier, 19 /* OpenBraceToken */, 20 /* CloseBraceToken */));
	          return finishNode(node, pos);
	        }
	        function parseExportSpecifier() {
	          const hasJSDoc = hasPrecedingJSDocComment();
	          return withJSDoc(parseImportOrExportSpecifier(281 /* ExportSpecifier */), hasJSDoc);
	        }
	        function parseImportSpecifier() {
	          return parseImportOrExportSpecifier(276 /* ImportSpecifier */);
	        }
	        function parseImportOrExportSpecifier(kind) {
	          const pos = getNodePos();
	          let checkIdentifierIsKeyword = isKeyword(token()) && !isIdentifier2();
	          let checkIdentifierStart = scanner2.getTokenStart();
	          let checkIdentifierEnd = scanner2.getTokenEnd();
	          let isTypeOnly = false;
	          let propertyName;
	          let canParseAsKeyword = true;
	          let name = parseIdentifierName();
	          if (name.escapedText === "type") {
	            if (token() === 130 /* AsKeyword */) {
	              const firstAs = parseIdentifierName();
	              if (token() === 130 /* AsKeyword */) {
	                const secondAs = parseIdentifierName();
	                if (tokenIsIdentifierOrKeyword(token())) {
	                  isTypeOnly = true;
	                  propertyName = firstAs;
	                  name = parseNameWithKeywordCheck();
	                  canParseAsKeyword = false;
	                } else {
	                  propertyName = name;
	                  name = secondAs;
	                  canParseAsKeyword = false;
	                }
	              } else if (tokenIsIdentifierOrKeyword(token())) {
	                propertyName = name;
	                canParseAsKeyword = false;
	                name = parseNameWithKeywordCheck();
	              } else {
	                isTypeOnly = true;
	                name = firstAs;
	              }
	            } else if (tokenIsIdentifierOrKeyword(token())) {
	              isTypeOnly = true;
	              name = parseNameWithKeywordCheck();
	            }
	          }
	          if (canParseAsKeyword && token() === 130 /* AsKeyword */) {
	            propertyName = name;
	            parseExpected(130 /* AsKeyword */);
	            name = parseNameWithKeywordCheck();
	          }
	          if (kind === 276 /* ImportSpecifier */ && checkIdentifierIsKeyword) {
	            parseErrorAt(checkIdentifierStart, checkIdentifierEnd, Diagnostics.Identifier_expected);
	          }
	          const node = kind === 276 /* ImportSpecifier */ ? factory2.createImportSpecifier(isTypeOnly, propertyName, name) : factory2.createExportSpecifier(isTypeOnly, propertyName, name);
	          return finishNode(node, pos);
	          function parseNameWithKeywordCheck() {
	            checkIdentifierIsKeyword = isKeyword(token()) && !isIdentifier2();
	            checkIdentifierStart = scanner2.getTokenStart();
	            checkIdentifierEnd = scanner2.getTokenEnd();
	            return parseIdentifierName();
	          }
	        }
	        function parseNamespaceExport(pos) {
	          return finishNode(factory2.createNamespaceExport(parseIdentifierName()), pos);
	        }
	        function parseExportDeclaration(pos, hasJSDoc, modifiers) {
	          const savedAwaitContext = inAwaitContext();
	          setAwaitContext(
	            /*value*/
	            true
	          );
	          let exportClause;
	          let moduleSpecifier;
	          let attributes;
	          const isTypeOnly = parseOptional(156 /* TypeKeyword */);
	          const namespaceExportPos = getNodePos();
	          if (parseOptional(42 /* AsteriskToken */)) {
	            if (parseOptional(130 /* AsKeyword */)) {
	              exportClause = parseNamespaceExport(namespaceExportPos);
	            }
	            parseExpected(161 /* FromKeyword */);
	            moduleSpecifier = parseModuleSpecifier();
	          } else {
	            exportClause = parseNamedImportsOrExports(279 /* NamedExports */);
	            if (token() === 161 /* FromKeyword */ || token() === 11 /* StringLiteral */ && !scanner2.hasPrecedingLineBreak()) {
	              parseExpected(161 /* FromKeyword */);
	              moduleSpecifier = parseModuleSpecifier();
	            }
	          }
	          const currentToken2 = token();
	          if (moduleSpecifier && (currentToken2 === 118 /* WithKeyword */ || currentToken2 === 132 /* AssertKeyword */) && !scanner2.hasPrecedingLineBreak()) {
	            attributes = parseImportAttributes(currentToken2);
	          }
	          parseSemicolon();
	          setAwaitContext(savedAwaitContext);
	          const node = factory2.createExportDeclaration(modifiers, isTypeOnly, exportClause, moduleSpecifier, attributes);
	          return withJSDoc(finishNode(node, pos), hasJSDoc);
	        }
	        function parseExportAssignment(pos, hasJSDoc, modifiers) {
	          const savedAwaitContext = inAwaitContext();
	          setAwaitContext(
	            /*value*/
	            true
	          );
	          let isExportEquals;
	          if (parseOptional(64 /* EqualsToken */)) {
	            isExportEquals = true;
	          } else {
	            parseExpected(90 /* DefaultKeyword */);
	          }
	          const expression = parseAssignmentExpressionOrHigher(
	            /*allowReturnTypeInArrowFunction*/
	            true
	          );
	          parseSemicolon();
	          setAwaitContext(savedAwaitContext);
	          const node = factory2.createExportAssignment(modifiers, isExportEquals, expression);
	          return withJSDoc(finishNode(node, pos), hasJSDoc);
	        }
	        let ParsingContext;
	        ((ParsingContext2) => {
	          ParsingContext2[ParsingContext2["SourceElements"] = 0] = "SourceElements";
	          ParsingContext2[ParsingContext2["BlockStatements"] = 1] = "BlockStatements";
	          ParsingContext2[ParsingContext2["SwitchClauses"] = 2] = "SwitchClauses";
	          ParsingContext2[ParsingContext2["SwitchClauseStatements"] = 3] = "SwitchClauseStatements";
	          ParsingContext2[ParsingContext2["TypeMembers"] = 4] = "TypeMembers";
	          ParsingContext2[ParsingContext2["ClassMembers"] = 5] = "ClassMembers";
	          ParsingContext2[ParsingContext2["EnumMembers"] = 6] = "EnumMembers";
	          ParsingContext2[ParsingContext2["HeritageClauseElement"] = 7] = "HeritageClauseElement";
	          ParsingContext2[ParsingContext2["VariableDeclarations"] = 8] = "VariableDeclarations";
	          ParsingContext2[ParsingContext2["ObjectBindingElements"] = 9] = "ObjectBindingElements";
	          ParsingContext2[ParsingContext2["ArrayBindingElements"] = 10] = "ArrayBindingElements";
	          ParsingContext2[ParsingContext2["ArgumentExpressions"] = 11] = "ArgumentExpressions";
	          ParsingContext2[ParsingContext2["ObjectLiteralMembers"] = 12] = "ObjectLiteralMembers";
	          ParsingContext2[ParsingContext2["JsxAttributes"] = 13] = "JsxAttributes";
	          ParsingContext2[ParsingContext2["JsxChildren"] = 14] = "JsxChildren";
	          ParsingContext2[ParsingContext2["ArrayLiteralMembers"] = 15] = "ArrayLiteralMembers";
	          ParsingContext2[ParsingContext2["Parameters"] = 16] = "Parameters";
	          ParsingContext2[ParsingContext2["JSDocParameters"] = 17] = "JSDocParameters";
	          ParsingContext2[ParsingContext2["RestProperties"] = 18] = "RestProperties";
	          ParsingContext2[ParsingContext2["TypeParameters"] = 19] = "TypeParameters";
	          ParsingContext2[ParsingContext2["TypeArguments"] = 20] = "TypeArguments";
	          ParsingContext2[ParsingContext2["TupleElementTypes"] = 21] = "TupleElementTypes";
	          ParsingContext2[ParsingContext2["HeritageClauses"] = 22] = "HeritageClauses";
	          ParsingContext2[ParsingContext2["ImportOrExportSpecifiers"] = 23] = "ImportOrExportSpecifiers";
	          ParsingContext2[ParsingContext2["ImportAttributes"] = 24] = "ImportAttributes";
	          ParsingContext2[ParsingContext2["JSDocComment"] = 25] = "JSDocComment";
	          ParsingContext2[ParsingContext2["Count"] = 26] = "Count";
	        })(ParsingContext || (ParsingContext = {}));
	        let Tristate;
	        ((Tristate2) => {
	          Tristate2[Tristate2["False"] = 0] = "False";
	          Tristate2[Tristate2["True"] = 1] = "True";
	          Tristate2[Tristate2["Unknown"] = 2] = "Unknown";
	        })(Tristate || (Tristate = {}));
	        let JSDocParser;
	        ((JSDocParser2) => {
	          function parseJSDocTypeExpressionForTests2(content, start, length2) {
	            initializeState(
	              "file.js",
	              content,
	              99 /* Latest */,
	              /*syntaxCursor*/
	              void 0,
	              1 /* JS */,
	              0 /* ParseAll */
	            );
	            scanner2.setText(content, start, length2);
	            currentToken = scanner2.scan();
	            const jsDocTypeExpression = parseJSDocTypeExpression();
	            const sourceFile = createSourceFile2(
	              "file.js",
	              99 /* Latest */,
	              1 /* JS */,
	              /*isDeclarationFile*/
	              false,
	              [],
	              factoryCreateToken(1 /* EndOfFileToken */),
	              0 /* None */,
	              noop
	            );
	            const diagnostics = attachFileToDiagnostics(parseDiagnostics, sourceFile);
	            if (jsDocDiagnostics) {
	              sourceFile.jsDocDiagnostics = attachFileToDiagnostics(jsDocDiagnostics, sourceFile);
	            }
	            clearState();
	            return jsDocTypeExpression ? { jsDocTypeExpression, diagnostics } : void 0;
	          }
	          JSDocParser2.parseJSDocTypeExpressionForTests = parseJSDocTypeExpressionForTests2;
	          function parseJSDocTypeExpression(mayOmitBraces) {
	            const pos = getNodePos();
	            const hasBrace = (mayOmitBraces ? parseOptional : parseExpected)(19 /* OpenBraceToken */);
	            const type = doInsideOfContext(16777216 /* JSDoc */, parseJSDocType);
	            if (!mayOmitBraces || hasBrace) {
	              parseExpectedJSDoc(20 /* CloseBraceToken */);
	            }
	            const result = factory2.createJSDocTypeExpression(type);
	            fixupParentReferences(result);
	            return finishNode(result, pos);
	          }
	          JSDocParser2.parseJSDocTypeExpression = parseJSDocTypeExpression;
	          function parseJSDocNameReference() {
	            const pos = getNodePos();
	            const hasBrace = parseOptional(19 /* OpenBraceToken */);
	            const p2 = getNodePos();
	            let entityName = parseEntityName(
	              /*allowReservedWords*/
	              false
	            );
	            while (token() === 81 /* PrivateIdentifier */) {
	              reScanHashToken();
	              nextTokenJSDoc();
	              entityName = finishNode(factory2.createJSDocMemberName(entityName, parseIdentifier()), p2);
	            }
	            if (hasBrace) {
	              parseExpectedJSDoc(20 /* CloseBraceToken */);
	            }
	            const result = factory2.createJSDocNameReference(entityName);
	            fixupParentReferences(result);
	            return finishNode(result, pos);
	          }
	          JSDocParser2.parseJSDocNameReference = parseJSDocNameReference;
	          function parseIsolatedJSDocComment2(content, start, length2) {
	            initializeState(
	              "",
	              content,
	              99 /* Latest */,
	              /*syntaxCursor*/
	              void 0,
	              1 /* JS */,
	              0 /* ParseAll */
	            );
	            const jsDoc = doInsideOfContext(16777216 /* JSDoc */, () => parseJSDocCommentWorker(start, length2));
	            const sourceFile = { languageVariant: 0 /* Standard */, text: content };
	            const diagnostics = attachFileToDiagnostics(parseDiagnostics, sourceFile);
	            clearState();
	            return jsDoc ? { jsDoc, diagnostics } : void 0;
	          }
	          JSDocParser2.parseIsolatedJSDocComment = parseIsolatedJSDocComment2;
	          function parseJSDocComment(parent2, start, length2) {
	            const saveToken = currentToken;
	            const saveParseDiagnosticsLength = parseDiagnostics.length;
	            const saveParseErrorBeforeNextFinishedNode = parseErrorBeforeNextFinishedNode;
	            const comment = doInsideOfContext(16777216 /* JSDoc */, () => parseJSDocCommentWorker(start, length2));
	            setParent(comment, parent2);
	            if (contextFlags & 524288 /* JavaScriptFile */) {
	              if (!jsDocDiagnostics) {
	                jsDocDiagnostics = [];
	              }
	              addRange(jsDocDiagnostics, parseDiagnostics, saveParseDiagnosticsLength);
	            }
	            currentToken = saveToken;
	            parseDiagnostics.length = saveParseDiagnosticsLength;
	            parseErrorBeforeNextFinishedNode = saveParseErrorBeforeNextFinishedNode;
	            return comment;
	          }
	          JSDocParser2.parseJSDocComment = parseJSDocComment;
	          let JSDocState;
	          ((JSDocState2) => {
	            JSDocState2[JSDocState2["BeginningOfLine"] = 0] = "BeginningOfLine";
	            JSDocState2[JSDocState2["SawAsterisk"] = 1] = "SawAsterisk";
	            JSDocState2[JSDocState2["SavingComments"] = 2] = "SavingComments";
	            JSDocState2[JSDocState2["SavingBackticks"] = 3] = "SavingBackticks";
	          })(JSDocState || (JSDocState = {}));
	          let PropertyLikeParse;
	          ((PropertyLikeParse2) => {
	            PropertyLikeParse2[PropertyLikeParse2["Property"] = 1] = "Property";
	            PropertyLikeParse2[PropertyLikeParse2["Parameter"] = 2] = "Parameter";
	            PropertyLikeParse2[PropertyLikeParse2["CallbackParameter"] = 4] = "CallbackParameter";
	          })(PropertyLikeParse || (PropertyLikeParse = {}));
	          function parseJSDocCommentWorker(start = 0, length2) {
	            const content = sourceText;
	            const end = length2 === void 0 ? content.length : start + length2;
	            length2 = end - start;
	            Debug.assert(start >= 0);
	            Debug.assert(start <= end);
	            Debug.assert(end <= content.length);
	            if (!isJSDocLikeText(content, start)) {
	              return void 0;
	            }
	            let tags;
	            let tagsPos;
	            let tagsEnd;
	            let linkEnd;
	            let commentsPos;
	            let comments = [];
	            const parts = [];
	            const saveParsingContext = parsingContext;
	            parsingContext |= 1 << 25 /* JSDocComment */;
	            const result = scanner2.scanRange(start + 3, length2 - 5, doJSDocScan);
	            parsingContext = saveParsingContext;
	            return result;
	            function doJSDocScan() {
	              let state = 1 /* SawAsterisk */;
	              let margin;
	              let indent3 = start - (content.lastIndexOf("\n", start) + 1) + 4;
	              function pushComment(text) {
	                if (!margin) {
	                  margin = indent3;
	                }
	                comments.push(text);
	                indent3 += text.length;
	              }
	              nextTokenJSDoc();
	              while (parseOptionalJsdoc(5 /* WhitespaceTrivia */))
	                ;
	              if (parseOptionalJsdoc(4 /* NewLineTrivia */)) {
	                state = 0 /* BeginningOfLine */;
	                indent3 = 0;
	              }
	              loop:
	                while (true) {
	                  switch (token()) {
	                    case 60 /* AtToken */:
	                      removeTrailingWhitespace(comments);
	                      if (!commentsPos)
	                        commentsPos = getNodePos();
	                      addTag(parseTag(indent3));
	                      state = 0 /* BeginningOfLine */;
	                      margin = void 0;
	                      break;
	                    case 4 /* NewLineTrivia */:
	                      comments.push(scanner2.getTokenText());
	                      state = 0 /* BeginningOfLine */;
	                      indent3 = 0;
	                      break;
	                    case 42 /* AsteriskToken */:
	                      const asterisk = scanner2.getTokenText();
	                      if (state === 1 /* SawAsterisk */) {
	                        state = 2 /* SavingComments */;
	                        pushComment(asterisk);
	                      } else {
	                        Debug.assert(state === 0 /* BeginningOfLine */);
	                        state = 1 /* SawAsterisk */;
	                        indent3 += asterisk.length;
	                      }
	                      break;
	                    case 5 /* WhitespaceTrivia */:
	                      Debug.assert(state !== 2 /* SavingComments */, "whitespace shouldn't come from the scanner while saving top-level comment text");
	                      const whitespace = scanner2.getTokenText();
	                      if (margin !== void 0 && indent3 + whitespace.length > margin) {
	                        comments.push(whitespace.slice(margin - indent3));
	                      }
	                      indent3 += whitespace.length;
	                      break;
	                    case 1 /* EndOfFileToken */:
	                      break loop;
	                    case 82 /* JSDocCommentTextToken */:
	                      state = 2 /* SavingComments */;
	                      pushComment(scanner2.getTokenValue());
	                      break;
	                    case 19 /* OpenBraceToken */:
	                      state = 2 /* SavingComments */;
	                      const commentEnd = scanner2.getTokenFullStart();
	                      const linkStart = scanner2.getTokenEnd() - 1;
	                      const link = parseJSDocLink(linkStart);
	                      if (link) {
	                        if (!linkEnd) {
	                          removeLeadingNewlines(comments);
	                        }
	                        parts.push(finishNode(factory2.createJSDocText(comments.join("")), linkEnd ?? start, commentEnd));
	                        parts.push(link);
	                        comments = [];
	                        linkEnd = scanner2.getTokenEnd();
	                        break;
	                      }
	                    default:
	                      state = 2 /* SavingComments */;
	                      pushComment(scanner2.getTokenText());
	                      break;
	                  }
	                  if (state === 2 /* SavingComments */) {
	                    nextJSDocCommentTextToken(
	                      /*inBackticks*/
	                      false
	                    );
	                  } else {
	                    nextTokenJSDoc();
	                  }
	                }
	              const trimmedComments = comments.join("").trimEnd();
	              if (parts.length && trimmedComments.length) {
	                parts.push(finishNode(factory2.createJSDocText(trimmedComments), linkEnd ?? start, commentsPos));
	              }
	              if (parts.length && tags)
	                Debug.assertIsDefined(commentsPos, "having parsed tags implies that the end of the comment span should be set");
	              const tagsArray = tags && createNodeArray(tags, tagsPos, tagsEnd);
	              return finishNode(factory2.createJSDocComment(parts.length ? createNodeArray(parts, start, commentsPos) : trimmedComments.length ? trimmedComments : void 0, tagsArray), start, end);
	            }
	            function removeLeadingNewlines(comments2) {
	              while (comments2.length && (comments2[0] === "\n" || comments2[0] === "\r")) {
	                comments2.shift();
	              }
	            }
	            function removeTrailingWhitespace(comments2) {
	              while (comments2.length) {
	                const trimmed = comments2[comments2.length - 1].trimEnd();
	                if (trimmed === "") {
	                  comments2.pop();
	                } else if (trimmed.length < comments2[comments2.length - 1].length) {
	                  comments2[comments2.length - 1] = trimmed;
	                  break;
	                } else {
	                  break;
	                }
	              }
	            }
	            function isNextNonwhitespaceTokenEndOfFile() {
	              while (true) {
	                nextTokenJSDoc();
	                if (token() === 1 /* EndOfFileToken */) {
	                  return true;
	                }
	                if (!(token() === 5 /* WhitespaceTrivia */ || token() === 4 /* NewLineTrivia */)) {
	                  return false;
	                }
	              }
	            }
	            function skipWhitespace() {
	              if (token() === 5 /* WhitespaceTrivia */ || token() === 4 /* NewLineTrivia */) {
	                if (lookAhead(isNextNonwhitespaceTokenEndOfFile)) {
	                  return;
	                }
	              }
	              while (token() === 5 /* WhitespaceTrivia */ || token() === 4 /* NewLineTrivia */) {
	                nextTokenJSDoc();
	              }
	            }
	            function skipWhitespaceOrAsterisk() {
	              if (token() === 5 /* WhitespaceTrivia */ || token() === 4 /* NewLineTrivia */) {
	                if (lookAhead(isNextNonwhitespaceTokenEndOfFile)) {
	                  return "";
	                }
	              }
	              let precedingLineBreak = scanner2.hasPrecedingLineBreak();
	              let seenLineBreak = false;
	              let indentText = "";
	              while (precedingLineBreak && token() === 42 /* AsteriskToken */ || token() === 5 /* WhitespaceTrivia */ || token() === 4 /* NewLineTrivia */) {
	                indentText += scanner2.getTokenText();
	                if (token() === 4 /* NewLineTrivia */) {
	                  precedingLineBreak = true;
	                  seenLineBreak = true;
	                  indentText = "";
	                } else if (token() === 42 /* AsteriskToken */) {
	                  precedingLineBreak = false;
	                }
	                nextTokenJSDoc();
	              }
	              return seenLineBreak ? indentText : "";
	            }
	            function parseTag(margin) {
	              Debug.assert(token() === 60 /* AtToken */);
	              const start2 = scanner2.getTokenStart();
	              nextTokenJSDoc();
	              const tagName = parseJSDocIdentifierName(
	                /*message*/
	                void 0
	              );
	              const indentText = skipWhitespaceOrAsterisk();
	              let tag;
	              switch (tagName.escapedText) {
	                case "author":
	                  tag = parseAuthorTag(start2, tagName, margin, indentText);
	                  break;
	                case "implements":
	                  tag = parseImplementsTag(start2, tagName, margin, indentText);
	                  break;
	                case "augments":
	                case "extends":
	                  tag = parseAugmentsTag(start2, tagName, margin, indentText);
	                  break;
	                case "class":
	                case "constructor":
	                  tag = parseSimpleTag(start2, factory2.createJSDocClassTag, tagName, margin, indentText);
	                  break;
	                case "public":
	                  tag = parseSimpleTag(start2, factory2.createJSDocPublicTag, tagName, margin, indentText);
	                  break;
	                case "private":
	                  tag = parseSimpleTag(start2, factory2.createJSDocPrivateTag, tagName, margin, indentText);
	                  break;
	                case "protected":
	                  tag = parseSimpleTag(start2, factory2.createJSDocProtectedTag, tagName, margin, indentText);
	                  break;
	                case "readonly":
	                  tag = parseSimpleTag(start2, factory2.createJSDocReadonlyTag, tagName, margin, indentText);
	                  break;
	                case "override":
	                  tag = parseSimpleTag(start2, factory2.createJSDocOverrideTag, tagName, margin, indentText);
	                  break;
	                case "deprecated":
	                  hasDeprecatedTag = true;
	                  tag = parseSimpleTag(start2, factory2.createJSDocDeprecatedTag, tagName, margin, indentText);
	                  break;
	                case "this":
	                  tag = parseThisTag(start2, tagName, margin, indentText);
	                  break;
	                case "enum":
	                  tag = parseEnumTag(start2, tagName, margin, indentText);
	                  break;
	                case "arg":
	                case "argument":
	                case "param":
	                  return parseParameterOrPropertyTag(start2, tagName, 2 /* Parameter */, margin);
	                case "return":
	                case "returns":
	                  tag = parseReturnTag(start2, tagName, margin, indentText);
	                  break;
	                case "template":
	                  tag = parseTemplateTag(start2, tagName, margin, indentText);
	                  break;
	                case "type":
	                  tag = parseTypeTag(start2, tagName, margin, indentText);
	                  break;
	                case "typedef":
	                  tag = parseTypedefTag(start2, tagName, margin, indentText);
	                  break;
	                case "callback":
	                  tag = parseCallbackTag(start2, tagName, margin, indentText);
	                  break;
	                case "overload":
	                  tag = parseOverloadTag(start2, tagName, margin, indentText);
	                  break;
	                case "satisfies":
	                  tag = parseSatisfiesTag(start2, tagName, margin, indentText);
	                  break;
	                case "see":
	                  tag = parseSeeTag(start2, tagName, margin, indentText);
	                  break;
	                case "exception":
	                case "throws":
	                  tag = parseThrowsTag(start2, tagName, margin, indentText);
	                  break;
	                default:
	                  tag = parseUnknownTag(start2, tagName, margin, indentText);
	                  break;
	              }
	              return tag;
	            }
	            function parseTrailingTagComments(pos, end2, margin, indentText) {
	              if (!indentText) {
	                margin += end2 - pos;
	              }
	              return parseTagComments(margin, indentText.slice(margin));
	            }
	            function parseTagComments(indent3, initialMargin) {
	              const commentsPos2 = getNodePos();
	              let comments2 = [];
	              const parts2 = [];
	              let linkEnd2;
	              let state = 0 /* BeginningOfLine */;
	              let margin;
	              function pushComment(text) {
	                if (!margin) {
	                  margin = indent3;
	                }
	                comments2.push(text);
	                indent3 += text.length;
	              }
	              if (initialMargin !== void 0) {
	                if (initialMargin !== "") {
	                  pushComment(initialMargin);
	                }
	                state = 1 /* SawAsterisk */;
	              }
	              let tok = token();
	              loop:
	                while (true) {
	                  switch (tok) {
	                    case 4 /* NewLineTrivia */:
	                      state = 0 /* BeginningOfLine */;
	                      comments2.push(scanner2.getTokenText());
	                      indent3 = 0;
	                      break;
	                    case 60 /* AtToken */:
	                      scanner2.resetTokenState(scanner2.getTokenEnd() - 1);
	                      break loop;
	                    case 1 /* EndOfFileToken */:
	                      break loop;
	                    case 5 /* WhitespaceTrivia */:
	                      Debug.assert(state !== 2 /* SavingComments */ && state !== 3 /* SavingBackticks */, "whitespace shouldn't come from the scanner while saving comment text");
	                      const whitespace = scanner2.getTokenText();
	                      if (margin !== void 0 && indent3 + whitespace.length > margin) {
	                        comments2.push(whitespace.slice(margin - indent3));
	                        state = 2 /* SavingComments */;
	                      }
	                      indent3 += whitespace.length;
	                      break;
	                    case 19 /* OpenBraceToken */:
	                      state = 2 /* SavingComments */;
	                      const commentEnd = scanner2.getTokenFullStart();
	                      const linkStart = scanner2.getTokenEnd() - 1;
	                      const link = parseJSDocLink(linkStart);
	                      if (link) {
	                        parts2.push(finishNode(factory2.createJSDocText(comments2.join("")), linkEnd2 ?? commentsPos2, commentEnd));
	                        parts2.push(link);
	                        comments2 = [];
	                        linkEnd2 = scanner2.getTokenEnd();
	                      } else {
	                        pushComment(scanner2.getTokenText());
	                      }
	                      break;
	                    case 62 /* BacktickToken */:
	                      if (state === 3 /* SavingBackticks */) {
	                        state = 2 /* SavingComments */;
	                      } else {
	                        state = 3 /* SavingBackticks */;
	                      }
	                      pushComment(scanner2.getTokenText());
	                      break;
	                    case 82 /* JSDocCommentTextToken */:
	                      if (state !== 3 /* SavingBackticks */) {
	                        state = 2 /* SavingComments */;
	                      }
	                      pushComment(scanner2.getTokenValue());
	                      break;
	                    case 42 /* AsteriskToken */:
	                      if (state === 0 /* BeginningOfLine */) {
	                        state = 1 /* SawAsterisk */;
	                        indent3 += 1;
	                        break;
	                      }
	                    default:
	                      if (state !== 3 /* SavingBackticks */) {
	                        state = 2 /* SavingComments */;
	                      }
	                      pushComment(scanner2.getTokenText());
	                      break;
	                  }
	                  if (state === 2 /* SavingComments */ || state === 3 /* SavingBackticks */) {
	                    tok = nextJSDocCommentTextToken(state === 3 /* SavingBackticks */);
	                  } else {
	                    tok = nextTokenJSDoc();
	                  }
	                }
	              removeLeadingNewlines(comments2);
	              const trimmedComments = comments2.join("").trimEnd();
	              if (parts2.length) {
	                if (trimmedComments.length) {
	                  parts2.push(finishNode(factory2.createJSDocText(trimmedComments), linkEnd2 ?? commentsPos2));
	                }
	                return createNodeArray(parts2, commentsPos2, scanner2.getTokenEnd());
	              } else if (trimmedComments.length) {
	                return trimmedComments;
	              }
	            }
	            function parseJSDocLink(start2) {
	              const linkType = tryParse(parseJSDocLinkPrefix);
	              if (!linkType) {
	                return void 0;
	              }
	              nextTokenJSDoc();
	              skipWhitespace();
	              const name = parseJSDocLinkName();
	              const text = [];
	              while (token() !== 20 /* CloseBraceToken */ && token() !== 4 /* NewLineTrivia */ && token() !== 1 /* EndOfFileToken */) {
	                text.push(scanner2.getTokenText());
	                nextTokenJSDoc();
	              }
	              const create = linkType === "link" ? factory2.createJSDocLink : linkType === "linkcode" ? factory2.createJSDocLinkCode : factory2.createJSDocLinkPlain;
	              return finishNode(create(name, text.join("")), start2, scanner2.getTokenEnd());
	            }
	            function parseJSDocLinkName() {
	              if (tokenIsIdentifierOrKeyword(token())) {
	                const pos = getNodePos();
	                let name = parseIdentifierName();
	                while (parseOptional(25 /* DotToken */)) {
	                  name = finishNode(factory2.createQualifiedName(name, token() === 81 /* PrivateIdentifier */ ? createMissingNode(
	                    80 /* Identifier */,
	                    /*reportAtCurrentPosition*/
	                    false
	                  ) : parseIdentifier()), pos);
	                }
	                while (token() === 81 /* PrivateIdentifier */) {
	                  reScanHashToken();
	                  nextTokenJSDoc();
	                  name = finishNode(factory2.createJSDocMemberName(name, parseIdentifier()), pos);
	                }
	                return name;
	              }
	              return void 0;
	            }
	            function parseJSDocLinkPrefix() {
	              skipWhitespaceOrAsterisk();
	              if (token() === 19 /* OpenBraceToken */ && nextTokenJSDoc() === 60 /* AtToken */ && tokenIsIdentifierOrKeyword(nextTokenJSDoc())) {
	                const kind = scanner2.getTokenValue();
	                if (isJSDocLinkTag(kind))
	                  return kind;
	              }
	            }
	            function isJSDocLinkTag(kind) {
	              return kind === "link" || kind === "linkcode" || kind === "linkplain";
	            }
	            function parseUnknownTag(start2, tagName, indent3, indentText) {
	              return finishNode(factory2.createJSDocUnknownTag(tagName, parseTrailingTagComments(start2, getNodePos(), indent3, indentText)), start2);
	            }
	            function addTag(tag) {
	              if (!tag) {
	                return;
	              }
	              if (!tags) {
	                tags = [tag];
	                tagsPos = tag.pos;
	              } else {
	                tags.push(tag);
	              }
	              tagsEnd = tag.end;
	            }
	            function tryParseTypeExpression() {
	              skipWhitespaceOrAsterisk();
	              return token() === 19 /* OpenBraceToken */ ? parseJSDocTypeExpression() : void 0;
	            }
	            function parseBracketNameInPropertyAndParamTag() {
	              const isBracketed = parseOptionalJsdoc(23 /* OpenBracketToken */);
	              if (isBracketed) {
	                skipWhitespace();
	              }
	              const isBackquoted = parseOptionalJsdoc(62 /* BacktickToken */);
	              const name = parseJSDocEntityName();
	              if (isBackquoted) {
	                parseExpectedTokenJSDoc(62 /* BacktickToken */);
	              }
	              if (isBracketed) {
	                skipWhitespace();
	                if (parseOptionalToken(64 /* EqualsToken */)) {
	                  parseExpression();
	                }
	                parseExpected(24 /* CloseBracketToken */);
	              }
	              return { name, isBracketed };
	            }
	            function isObjectOrObjectArrayTypeReference(node) {
	              switch (node.kind) {
	                case 151 /* ObjectKeyword */:
	                  return true;
	                case 188 /* ArrayType */:
	                  return isObjectOrObjectArrayTypeReference(node.elementType);
	                default:
	                  return isTypeReferenceNode(node) && isIdentifier(node.typeName) && node.typeName.escapedText === "Object" && !node.typeArguments;
	              }
	            }
	            function parseParameterOrPropertyTag(start2, tagName, target, indent3) {
	              let typeExpression = tryParseTypeExpression();
	              let isNameFirst = !typeExpression;
	              skipWhitespaceOrAsterisk();
	              const { name, isBracketed } = parseBracketNameInPropertyAndParamTag();
	              const indentText = skipWhitespaceOrAsterisk();
	              if (isNameFirst && !lookAhead(parseJSDocLinkPrefix)) {
	                typeExpression = tryParseTypeExpression();
	              }
	              const comment = parseTrailingTagComments(start2, getNodePos(), indent3, indentText);
	              const nestedTypeLiteral = parseNestedTypeLiteral(typeExpression, name, target, indent3);
	              if (nestedTypeLiteral) {
	                typeExpression = nestedTypeLiteral;
	                isNameFirst = true;
	              }
	              const result2 = target === 1 /* Property */ ? factory2.createJSDocPropertyTag(tagName, name, isBracketed, typeExpression, isNameFirst, comment) : factory2.createJSDocParameterTag(tagName, name, isBracketed, typeExpression, isNameFirst, comment);
	              return finishNode(result2, start2);
	            }
	            function parseNestedTypeLiteral(typeExpression, name, target, indent3) {
	              if (typeExpression && isObjectOrObjectArrayTypeReference(typeExpression.type)) {
	                const pos = getNodePos();
	                let child;
	                let children;
	                while (child = tryParse(() => parseChildParameterOrPropertyTag(target, indent3, name))) {
	                  if (child.kind === 348 /* JSDocParameterTag */ || child.kind === 355 /* JSDocPropertyTag */) {
	                    children = append(children, child);
	                  } else if (child.kind === 352 /* JSDocTemplateTag */) {
	                    parseErrorAtRange(child.tagName, Diagnostics.A_JSDoc_template_tag_may_not_follow_a_typedef_callback_or_overload_tag);
	                  }
	                }
	                if (children) {
	                  const literal = finishNode(factory2.createJSDocTypeLiteral(children, typeExpression.type.kind === 188 /* ArrayType */), pos);
	                  return finishNode(factory2.createJSDocTypeExpression(literal), pos);
	                }
	              }
	            }
	            function parseReturnTag(start2, tagName, indent3, indentText) {
	              if (some(tags, isJSDocReturnTag)) {
	                parseErrorAt(tagName.pos, scanner2.getTokenStart(), Diagnostics._0_tag_already_specified, unescapeLeadingUnderscores(tagName.escapedText));
	              }
	              const typeExpression = tryParseTypeExpression();
	              return finishNode(factory2.createJSDocReturnTag(tagName, typeExpression, parseTrailingTagComments(start2, getNodePos(), indent3, indentText)), start2);
	            }
	            function parseTypeTag(start2, tagName, indent3, indentText) {
	              if (some(tags, isJSDocTypeTag)) {
	                parseErrorAt(tagName.pos, scanner2.getTokenStart(), Diagnostics._0_tag_already_specified, unescapeLeadingUnderscores(tagName.escapedText));
	              }
	              const typeExpression = parseJSDocTypeExpression(
	                /*mayOmitBraces*/
	                true
	              );
	              const comments2 = indent3 !== void 0 && indentText !== void 0 ? parseTrailingTagComments(start2, getNodePos(), indent3, indentText) : void 0;
	              return finishNode(factory2.createJSDocTypeTag(tagName, typeExpression, comments2), start2);
	            }
	            function parseSeeTag(start2, tagName, indent3, indentText) {
	              const isMarkdownOrJSDocLink = token() === 23 /* OpenBracketToken */ || lookAhead(() => nextTokenJSDoc() === 60 /* AtToken */ && tokenIsIdentifierOrKeyword(nextTokenJSDoc()) && isJSDocLinkTag(scanner2.getTokenValue()));
	              const nameExpression = isMarkdownOrJSDocLink ? void 0 : parseJSDocNameReference();
	              const comments2 = indent3 !== void 0 && indentText !== void 0 ? parseTrailingTagComments(start2, getNodePos(), indent3, indentText) : void 0;
	              return finishNode(factory2.createJSDocSeeTag(tagName, nameExpression, comments2), start2);
	            }
	            function parseThrowsTag(start2, tagName, indent3, indentText) {
	              const typeExpression = tryParseTypeExpression();
	              const comment = parseTrailingTagComments(start2, getNodePos(), indent3, indentText);
	              return finishNode(factory2.createJSDocThrowsTag(tagName, typeExpression, comment), start2);
	            }
	            function parseAuthorTag(start2, tagName, indent3, indentText) {
	              const commentStart = getNodePos();
	              const textOnly = parseAuthorNameAndEmail();
	              let commentEnd = scanner2.getTokenFullStart();
	              const comments2 = parseTrailingTagComments(start2, commentEnd, indent3, indentText);
	              if (!comments2) {
	                commentEnd = scanner2.getTokenFullStart();
	              }
	              const allParts = typeof comments2 !== "string" ? createNodeArray(concatenate([finishNode(textOnly, commentStart, commentEnd)], comments2), commentStart) : textOnly.text + comments2;
	              return finishNode(factory2.createJSDocAuthorTag(tagName, allParts), start2);
	            }
	            function parseAuthorNameAndEmail() {
	              const comments2 = [];
	              let inEmail = false;
	              let token2 = scanner2.getToken();
	              while (token2 !== 1 /* EndOfFileToken */ && token2 !== 4 /* NewLineTrivia */) {
	                if (token2 === 30 /* LessThanToken */) {
	                  inEmail = true;
	                } else if (token2 === 60 /* AtToken */ && !inEmail) {
	                  break;
	                } else if (token2 === 32 /* GreaterThanToken */ && inEmail) {
	                  comments2.push(scanner2.getTokenText());
	                  scanner2.resetTokenState(scanner2.getTokenEnd());
	                  break;
	                }
	                comments2.push(scanner2.getTokenText());
	                token2 = nextTokenJSDoc();
	              }
	              return factory2.createJSDocText(comments2.join(""));
	            }
	            function parseImplementsTag(start2, tagName, margin, indentText) {
	              const className = parseExpressionWithTypeArgumentsForAugments();
	              return finishNode(factory2.createJSDocImplementsTag(tagName, className, parseTrailingTagComments(start2, getNodePos(), margin, indentText)), start2);
	            }
	            function parseAugmentsTag(start2, tagName, margin, indentText) {
	              const className = parseExpressionWithTypeArgumentsForAugments();
	              return finishNode(factory2.createJSDocAugmentsTag(tagName, className, parseTrailingTagComments(start2, getNodePos(), margin, indentText)), start2);
	            }
	            function parseSatisfiesTag(start2, tagName, margin, indentText) {
	              const typeExpression = parseJSDocTypeExpression(
	                /*mayOmitBraces*/
	                false
	              );
	              const comments2 = margin !== void 0 && indentText !== void 0 ? parseTrailingTagComments(start2, getNodePos(), margin, indentText) : void 0;
	              return finishNode(factory2.createJSDocSatisfiesTag(tagName, typeExpression, comments2), start2);
	            }
	            function parseExpressionWithTypeArgumentsForAugments() {
	              const usedBrace = parseOptional(19 /* OpenBraceToken */);
	              const pos = getNodePos();
	              const expression = parsePropertyAccessEntityNameExpression();
	              scanner2.setInJSDocType(true);
	              const typeArguments = tryParseTypeArguments();
	              scanner2.setInJSDocType(false);
	              const node = factory2.createExpressionWithTypeArguments(expression, typeArguments);
	              const res = finishNode(node, pos);
	              if (usedBrace) {
	                parseExpected(20 /* CloseBraceToken */);
	              }
	              return res;
	            }
	            function parsePropertyAccessEntityNameExpression() {
	              const pos = getNodePos();
	              let node = parseJSDocIdentifierName();
	              while (parseOptional(25 /* DotToken */)) {
	                const name = parseJSDocIdentifierName();
	                node = finishNode(factoryCreatePropertyAccessExpression(node, name), pos);
	              }
	              return node;
	            }
	            function parseSimpleTag(start2, createTag, tagName, margin, indentText) {
	              return finishNode(createTag(tagName, parseTrailingTagComments(start2, getNodePos(), margin, indentText)), start2);
	            }
	            function parseThisTag(start2, tagName, margin, indentText) {
	              const typeExpression = parseJSDocTypeExpression(
	                /*mayOmitBraces*/
	                true
	              );
	              skipWhitespace();
	              return finishNode(factory2.createJSDocThisTag(tagName, typeExpression, parseTrailingTagComments(start2, getNodePos(), margin, indentText)), start2);
	            }
	            function parseEnumTag(start2, tagName, margin, indentText) {
	              const typeExpression = parseJSDocTypeExpression(
	                /*mayOmitBraces*/
	                true
	              );
	              skipWhitespace();
	              return finishNode(factory2.createJSDocEnumTag(tagName, typeExpression, parseTrailingTagComments(start2, getNodePos(), margin, indentText)), start2);
	            }
	            function parseTypedefTag(start2, tagName, indent3, indentText) {
	              let typeExpression = tryParseTypeExpression();
	              skipWhitespaceOrAsterisk();
	              const fullName = parseJSDocTypeNameWithNamespace();
	              skipWhitespace();
	              let comment = parseTagComments(indent3);
	              let end2;
	              if (!typeExpression || isObjectOrObjectArrayTypeReference(typeExpression.type)) {
	                let child;
	                let childTypeTag;
	                let jsDocPropertyTags;
	                let hasChildren = false;
	                while (child = tryParse(() => parseChildPropertyTag(indent3))) {
	                  if (child.kind === 352 /* JSDocTemplateTag */) {
	                    break;
	                  }
	                  hasChildren = true;
	                  if (child.kind === 351 /* JSDocTypeTag */) {
	                    if (childTypeTag) {
	                      const lastError = parseErrorAtCurrentToken(Diagnostics.A_JSDoc_typedef_comment_may_not_contain_multiple_type_tags);
	                      if (lastError) {
	                        addRelatedInfo(lastError, createDetachedDiagnostic(fileName, sourceText, 0, 0, Diagnostics.The_tag_was_first_specified_here));
	                      }
	                      break;
	                    } else {
	                      childTypeTag = child;
	                    }
	                  } else {
	                    jsDocPropertyTags = append(jsDocPropertyTags, child);
	                  }
	                }
	                if (hasChildren) {
	                  const isArrayType = typeExpression && typeExpression.type.kind === 188 /* ArrayType */;
	                  const jsdocTypeLiteral = factory2.createJSDocTypeLiteral(jsDocPropertyTags, isArrayType);
	                  typeExpression = childTypeTag && childTypeTag.typeExpression && !isObjectOrObjectArrayTypeReference(childTypeTag.typeExpression.type) ? childTypeTag.typeExpression : finishNode(jsdocTypeLiteral, start2);
	                  end2 = typeExpression.end;
	                }
	              }
	              end2 = end2 || comment !== void 0 ? getNodePos() : (fullName ?? typeExpression ?? tagName).end;
	              if (!comment) {
	                comment = parseTrailingTagComments(start2, end2, indent3, indentText);
	              }
	              const typedefTag = factory2.createJSDocTypedefTag(tagName, typeExpression, fullName, comment);
	              return finishNode(typedefTag, start2, end2);
	            }
	            function parseJSDocTypeNameWithNamespace(nested) {
	              const start2 = scanner2.getTokenStart();
	              if (!tokenIsIdentifierOrKeyword(token())) {
	                return void 0;
	              }
	              const typeNameOrNamespaceName = parseJSDocIdentifierName();
	              if (parseOptional(25 /* DotToken */)) {
	                const body = parseJSDocTypeNameWithNamespace(
	                  /*nested*/
	                  true
	                );
	                const jsDocNamespaceNode = factory2.createModuleDeclaration(
	                  /*modifiers*/
	                  void 0,
	                  typeNameOrNamespaceName,
	                  body,
	                  nested ? 8 /* NestedNamespace */ : void 0
	                );
	                return finishNode(jsDocNamespaceNode, start2);
	              }
	              if (nested) {
	                typeNameOrNamespaceName.flags |= 4096 /* IdentifierIsInJSDocNamespace */;
	              }
	              return typeNameOrNamespaceName;
	            }
	            function parseCallbackTagParameters(indent3) {
	              const pos = getNodePos();
	              let child;
	              let parameters;
	              while (child = tryParse(() => parseChildParameterOrPropertyTag(4 /* CallbackParameter */, indent3))) {
	                if (child.kind === 352 /* JSDocTemplateTag */) {
	                  parseErrorAtRange(child.tagName, Diagnostics.A_JSDoc_template_tag_may_not_follow_a_typedef_callback_or_overload_tag);
	                  break;
	                }
	                parameters = append(parameters, child);
	              }
	              return createNodeArray(parameters || [], pos);
	            }
	            function parseJSDocSignature(start2, indent3) {
	              const parameters = parseCallbackTagParameters(indent3);
	              const returnTag = tryParse(() => {
	                if (parseOptionalJsdoc(60 /* AtToken */)) {
	                  const tag = parseTag(indent3);
	                  if (tag && tag.kind === 349 /* JSDocReturnTag */) {
	                    return tag;
	                  }
	                }
	              });
	              return finishNode(factory2.createJSDocSignature(
	                /*typeParameters*/
	                void 0,
	                parameters,
	                returnTag
	              ), start2);
	            }
	            function parseCallbackTag(start2, tagName, indent3, indentText) {
	              const fullName = parseJSDocTypeNameWithNamespace();
	              skipWhitespace();
	              let comment = parseTagComments(indent3);
	              const typeExpression = parseJSDocSignature(start2, indent3);
	              if (!comment) {
	                comment = parseTrailingTagComments(start2, getNodePos(), indent3, indentText);
	              }
	              const end2 = comment !== void 0 ? getNodePos() : typeExpression.end;
	              return finishNode(factory2.createJSDocCallbackTag(tagName, typeExpression, fullName, comment), start2, end2);
	            }
	            function parseOverloadTag(start2, tagName, indent3, indentText) {
	              skipWhitespace();
	              let comment = parseTagComments(indent3);
	              const typeExpression = parseJSDocSignature(start2, indent3);
	              if (!comment) {
	                comment = parseTrailingTagComments(start2, getNodePos(), indent3, indentText);
	              }
	              const end2 = comment !== void 0 ? getNodePos() : typeExpression.end;
	              return finishNode(factory2.createJSDocOverloadTag(tagName, typeExpression, comment), start2, end2);
	            }
	            function escapedTextsEqual(a, b) {
	              while (!isIdentifier(a) || !isIdentifier(b)) {
	                if (!isIdentifier(a) && !isIdentifier(b) && a.right.escapedText === b.right.escapedText) {
	                  a = a.left;
	                  b = b.left;
	                } else {
	                  return false;
	                }
	              }
	              return a.escapedText === b.escapedText;
	            }
	            function parseChildPropertyTag(indent3) {
	              return parseChildParameterOrPropertyTag(1 /* Property */, indent3);
	            }
	            function parseChildParameterOrPropertyTag(target, indent3, name) {
	              let canParseTag = true;
	              let seenAsterisk = false;
	              while (true) {
	                switch (nextTokenJSDoc()) {
	                  case 60 /* AtToken */:
	                    if (canParseTag) {
	                      const child = tryParseChildTag(target, indent3);
	                      if (child && (child.kind === 348 /* JSDocParameterTag */ || child.kind === 355 /* JSDocPropertyTag */) && name && (isIdentifier(child.name) || !escapedTextsEqual(name, child.name.left))) {
	                        return false;
	                      }
	                      return child;
	                    }
	                    seenAsterisk = false;
	                    break;
	                  case 4 /* NewLineTrivia */:
	                    canParseTag = true;
	                    seenAsterisk = false;
	                    break;
	                  case 42 /* AsteriskToken */:
	                    if (seenAsterisk) {
	                      canParseTag = false;
	                    }
	                    seenAsterisk = true;
	                    break;
	                  case 80 /* Identifier */:
	                    canParseTag = false;
	                    break;
	                  case 1 /* EndOfFileToken */:
	                    return false;
	                }
	              }
	            }
	            function tryParseChildTag(target, indent3) {
	              Debug.assert(token() === 60 /* AtToken */);
	              const start2 = scanner2.getTokenFullStart();
	              nextTokenJSDoc();
	              const tagName = parseJSDocIdentifierName();
	              const indentText = skipWhitespaceOrAsterisk();
	              let t;
	              switch (tagName.escapedText) {
	                case "type":
	                  return target === 1 /* Property */ && parseTypeTag(start2, tagName);
	                case "prop":
	                case "property":
	                  t = 1 /* Property */;
	                  break;
	                case "arg":
	                case "argument":
	                case "param":
	                  t = 2 /* Parameter */ | 4 /* CallbackParameter */;
	                  break;
	                case "template":
	                  return parseTemplateTag(start2, tagName, indent3, indentText);
	                case "this":
	                  return parseThisTag(start2, tagName, indent3, indentText);
	                default:
	                  return false;
	              }
	              if (!(target & t)) {
	                return false;
	              }
	              return parseParameterOrPropertyTag(start2, tagName, target, indent3);
	            }
	            function parseTemplateTagTypeParameter() {
	              const typeParameterPos = getNodePos();
	              const isBracketed = parseOptionalJsdoc(23 /* OpenBracketToken */);
	              if (isBracketed) {
	                skipWhitespace();
	              }
	              const modifiers = parseModifiers(
	                /*allowDecorators*/
	                false,
	                /*permitConstAsModifier*/
	                true
	              );
	              const name = parseJSDocIdentifierName(Diagnostics.Unexpected_token_A_type_parameter_name_was_expected_without_curly_braces);
	              let defaultType;
	              if (isBracketed) {
	                skipWhitespace();
	                parseExpected(64 /* EqualsToken */);
	                defaultType = doInsideOfContext(16777216 /* JSDoc */, parseJSDocType);
	                parseExpected(24 /* CloseBracketToken */);
	              }
	              if (nodeIsMissing(name)) {
	                return void 0;
	              }
	              return finishNode(factory2.createTypeParameterDeclaration(
	                modifiers,
	                name,
	                /*constraint*/
	                void 0,
	                defaultType
	              ), typeParameterPos);
	            }
	            function parseTemplateTagTypeParameters() {
	              const pos = getNodePos();
	              const typeParameters = [];
	              do {
	                skipWhitespace();
	                const node = parseTemplateTagTypeParameter();
	                if (node !== void 0) {
	                  typeParameters.push(node);
	                }
	                skipWhitespaceOrAsterisk();
	              } while (parseOptionalJsdoc(28 /* CommaToken */));
	              return createNodeArray(typeParameters, pos);
	            }
	            function parseTemplateTag(start2, tagName, indent3, indentText) {
	              const constraint = token() === 19 /* OpenBraceToken */ ? parseJSDocTypeExpression() : void 0;
	              const typeParameters = parseTemplateTagTypeParameters();
	              return finishNode(factory2.createJSDocTemplateTag(tagName, constraint, typeParameters, parseTrailingTagComments(start2, getNodePos(), indent3, indentText)), start2);
	            }
	            function parseOptionalJsdoc(t) {
	              if (token() === t) {
	                nextTokenJSDoc();
	                return true;
	              }
	              return false;
	            }
	            function parseJSDocEntityName() {
	              let entity = parseJSDocIdentifierName();
	              if (parseOptional(23 /* OpenBracketToken */)) {
	                parseExpected(24 /* CloseBracketToken */);
	              }
	              while (parseOptional(25 /* DotToken */)) {
	                const name = parseJSDocIdentifierName();
	                if (parseOptional(23 /* OpenBracketToken */)) {
	                  parseExpected(24 /* CloseBracketToken */);
	                }
	                entity = createQualifiedName(entity, name);
	              }
	              return entity;
	            }
	            function parseJSDocIdentifierName(message) {
	              if (!tokenIsIdentifierOrKeyword(token())) {
	                return createMissingNode(
	                  80 /* Identifier */,
	                  /*reportAtCurrentPosition*/
	                  !message,
	                  message || Diagnostics.Identifier_expected
	                );
	              }
	              identifierCount++;
	              const start2 = scanner2.getTokenStart();
	              const end2 = scanner2.getTokenEnd();
	              const originalKeywordKind = token();
	              const text = internIdentifier(scanner2.getTokenValue());
	              const result2 = finishNode(factoryCreateIdentifier(text, originalKeywordKind), start2, end2);
	              nextTokenJSDoc();
	              return result2;
	            }
	          }
	        })(JSDocParser = Parser2.JSDocParser || (Parser2.JSDocParser = {}));
	      })(Parser || (Parser = {}));
	      ((IncrementalParser2) => {
	        function updateSourceFile2(sourceFile, newText, textChangeRange, aggressiveChecks) {
	          aggressiveChecks = aggressiveChecks || Debug.shouldAssert(2 /* Aggressive */);
	          checkChangeRange(sourceFile, newText, textChangeRange, aggressiveChecks);
	          if (textChangeRangeIsUnchanged(textChangeRange)) {
	            return sourceFile;
	          }
	          if (sourceFile.statements.length === 0) {
	            return Parser.parseSourceFile(
	              sourceFile.fileName,
	              newText,
	              sourceFile.languageVersion,
	              /*syntaxCursor*/
	              void 0,
	              /*setParentNodes*/
	              true,
	              sourceFile.scriptKind,
	              sourceFile.setExternalModuleIndicator,
	              sourceFile.jsDocParsingMode
	            );
	          }
	          const incrementalSourceFile = sourceFile;
	          Debug.assert(!incrementalSourceFile.hasBeenIncrementallyParsed);
	          incrementalSourceFile.hasBeenIncrementallyParsed = true;
	          Parser.fixupParentReferences(incrementalSourceFile);
	          const oldText = sourceFile.text;
	          const syntaxCursor = createSyntaxCursor(sourceFile);
	          const changeRange = extendToAffectedRange(sourceFile, textChangeRange);
	          checkChangeRange(sourceFile, newText, changeRange, aggressiveChecks);
	          Debug.assert(changeRange.span.start <= textChangeRange.span.start);
	          Debug.assert(textSpanEnd(changeRange.span) === textSpanEnd(textChangeRange.span));
	          Debug.assert(textSpanEnd(textChangeRangeNewSpan(changeRange)) === textSpanEnd(textChangeRangeNewSpan(textChangeRange)));
	          const delta = textChangeRangeNewSpan(changeRange).length - changeRange.span.length;
	          updateTokenPositionsAndMarkElements(incrementalSourceFile, changeRange.span.start, textSpanEnd(changeRange.span), textSpanEnd(textChangeRangeNewSpan(changeRange)), delta, oldText, newText, aggressiveChecks);
	          const result = Parser.parseSourceFile(
	            sourceFile.fileName,
	            newText,
	            sourceFile.languageVersion,
	            syntaxCursor,
	            /*setParentNodes*/
	            true,
	            sourceFile.scriptKind,
	            sourceFile.setExternalModuleIndicator,
	            sourceFile.jsDocParsingMode
	          );
	          result.commentDirectives = getNewCommentDirectives(
	            sourceFile.commentDirectives,
	            result.commentDirectives,
	            changeRange.span.start,
	            textSpanEnd(changeRange.span),
	            delta,
	            oldText,
	            newText,
	            aggressiveChecks
	          );
	          result.impliedNodeFormat = sourceFile.impliedNodeFormat;
	          return result;
	        }
	        IncrementalParser2.updateSourceFile = updateSourceFile2;
	        function getNewCommentDirectives(oldDirectives, newDirectives, changeStart, changeRangeOldEnd, delta, oldText, newText, aggressiveChecks) {
	          if (!oldDirectives)
	            return newDirectives;
	          let commentDirectives;
	          let addedNewlyScannedDirectives = false;
	          for (const directive of oldDirectives) {
	            const { range, type } = directive;
	            if (range.end < changeStart) {
	              commentDirectives = append(commentDirectives, directive);
	            } else if (range.pos > changeRangeOldEnd) {
	              addNewlyScannedDirectives();
	              const updatedDirective = {
	                range: { pos: range.pos + delta, end: range.end + delta },
	                type
	              };
	              commentDirectives = append(commentDirectives, updatedDirective);
	              if (aggressiveChecks) {
	                Debug.assert(oldText.substring(range.pos, range.end) === newText.substring(updatedDirective.range.pos, updatedDirective.range.end));
	              }
	            }
	          }
	          addNewlyScannedDirectives();
	          return commentDirectives;
	          function addNewlyScannedDirectives() {
	            if (addedNewlyScannedDirectives)
	              return;
	            addedNewlyScannedDirectives = true;
	            if (!commentDirectives) {
	              commentDirectives = newDirectives;
	            } else if (newDirectives) {
	              commentDirectives.push(...newDirectives);
	            }
	          }
	        }
	        function moveElementEntirelyPastChangeRange(element, isArray2, delta, oldText, newText, aggressiveChecks) {
	          if (isArray2) {
	            visitArray2(element);
	          } else {
	            visitNode3(element);
	          }
	          return;
	          function visitNode3(node) {
	            let text = "";
	            if (aggressiveChecks && shouldCheckNode(node)) {
	              text = oldText.substring(node.pos, node.end);
	            }
	            if (node._children) {
	              node._children = void 0;
	            }
	            setTextRangePosEnd(node, node.pos + delta, node.end + delta);
	            if (aggressiveChecks && shouldCheckNode(node)) {
	              Debug.assert(text === newText.substring(node.pos, node.end));
	            }
	            forEachChild(node, visitNode3, visitArray2);
	            if (hasJSDocNodes(node)) {
	              for (const jsDocComment of node.jsDoc) {
	                visitNode3(jsDocComment);
	              }
	            }
	            checkNodePositions(node, aggressiveChecks);
	          }
	          function visitArray2(array) {
	            array._children = void 0;
	            setTextRangePosEnd(array, array.pos + delta, array.end + delta);
	            for (const node of array) {
	              visitNode3(node);
	            }
	          }
	        }
	        function shouldCheckNode(node) {
	          switch (node.kind) {
	            case 11 /* StringLiteral */:
	            case 9 /* NumericLiteral */:
	            case 80 /* Identifier */:
	              return true;
	          }
	          return false;
	        }
	        function adjustIntersectingElement(element, changeStart, changeRangeOldEnd, changeRangeNewEnd, delta) {
	          Debug.assert(element.end >= changeStart, "Adjusting an element that was entirely before the change range");
	          Debug.assert(element.pos <= changeRangeOldEnd, "Adjusting an element that was entirely after the change range");
	          Debug.assert(element.pos <= element.end);
	          const pos = Math.min(element.pos, changeRangeNewEnd);
	          const end = element.end >= changeRangeOldEnd ? (
	            // Element ends after the change range.  Always adjust the end pos.
	            element.end + delta
	          ) : (
	            // Element ends in the change range.  The element will keep its position if
	            // possible. Or Move backward to the new-end if it's in the 'Y' range.
	            Math.min(element.end, changeRangeNewEnd)
	          );
	          Debug.assert(pos <= end);
	          if (element.parent) {
	            Debug.assertGreaterThanOrEqual(pos, element.parent.pos);
	            Debug.assertLessThanOrEqual(end, element.parent.end);
	          }
	          setTextRangePosEnd(element, pos, end);
	        }
	        function checkNodePositions(node, aggressiveChecks) {
	          if (aggressiveChecks) {
	            let pos = node.pos;
	            const visitNode3 = (child) => {
	              Debug.assert(child.pos >= pos);
	              pos = child.end;
	            };
	            if (hasJSDocNodes(node)) {
	              for (const jsDocComment of node.jsDoc) {
	                visitNode3(jsDocComment);
	              }
	            }
	            forEachChild(node, visitNode3);
	            Debug.assert(pos <= node.end);
	          }
	        }
	        function updateTokenPositionsAndMarkElements(sourceFile, changeStart, changeRangeOldEnd, changeRangeNewEnd, delta, oldText, newText, aggressiveChecks) {
	          visitNode3(sourceFile);
	          return;
	          function visitNode3(child) {
	            Debug.assert(child.pos <= child.end);
	            if (child.pos > changeRangeOldEnd) {
	              moveElementEntirelyPastChangeRange(
	                child,
	                /*isArray*/
	                false,
	                delta,
	                oldText,
	                newText,
	                aggressiveChecks
	              );
	              return;
	            }
	            const fullEnd = child.end;
	            if (fullEnd >= changeStart) {
	              child.intersectsChange = true;
	              child._children = void 0;
	              adjustIntersectingElement(child, changeStart, changeRangeOldEnd, changeRangeNewEnd, delta);
	              forEachChild(child, visitNode3, visitArray2);
	              if (hasJSDocNodes(child)) {
	                for (const jsDocComment of child.jsDoc) {
	                  visitNode3(jsDocComment);
	                }
	              }
	              checkNodePositions(child, aggressiveChecks);
	              return;
	            }
	            Debug.assert(fullEnd < changeStart);
	          }
	          function visitArray2(array) {
	            Debug.assert(array.pos <= array.end);
	            if (array.pos > changeRangeOldEnd) {
	              moveElementEntirelyPastChangeRange(
	                array,
	                /*isArray*/
	                true,
	                delta,
	                oldText,
	                newText,
	                aggressiveChecks
	              );
	              return;
	            }
	            const fullEnd = array.end;
	            if (fullEnd >= changeStart) {
	              array.intersectsChange = true;
	              array._children = void 0;
	              adjustIntersectingElement(array, changeStart, changeRangeOldEnd, changeRangeNewEnd, delta);
	              for (const node of array) {
	                visitNode3(node);
	              }
	              return;
	            }
	            Debug.assert(fullEnd < changeStart);
	          }
	        }
	        function extendToAffectedRange(sourceFile, changeRange) {
	          const maxLookahead = 1;
	          let start = changeRange.span.start;
	          for (let i = 0; start > 0 && i <= maxLookahead; i++) {
	            const nearestNode = findNearestNodeStartingBeforeOrAtPosition(sourceFile, start);
	            Debug.assert(nearestNode.pos <= start);
	            const position = nearestNode.pos;
	            start = Math.max(0, position - 1);
	          }
	          const finalSpan = createTextSpanFromBounds(start, textSpanEnd(changeRange.span));
	          const finalLength = changeRange.newLength + (changeRange.span.start - start);
	          return createTextChangeRange(finalSpan, finalLength);
	        }
	        function findNearestNodeStartingBeforeOrAtPosition(sourceFile, position) {
	          let bestResult = sourceFile;
	          let lastNodeEntirelyBeforePosition;
	          forEachChild(sourceFile, visit);
	          if (lastNodeEntirelyBeforePosition) {
	            const lastChildOfLastEntireNodeBeforePosition = getLastDescendant(lastNodeEntirelyBeforePosition);
	            if (lastChildOfLastEntireNodeBeforePosition.pos > bestResult.pos) {
	              bestResult = lastChildOfLastEntireNodeBeforePosition;
	            }
	          }
	          return bestResult;
	          function getLastDescendant(node) {
	            while (true) {
	              const lastChild = getLastChild(node);
	              if (lastChild) {
	                node = lastChild;
	              } else {
	                return node;
	              }
	            }
	          }
	          function visit(child) {
	            if (nodeIsMissing(child)) {
	              return;
	            }
	            if (child.pos <= position) {
	              if (child.pos >= bestResult.pos) {
	                bestResult = child;
	              }
	              if (position < child.end) {
	                forEachChild(child, visit);
	                return true;
	              } else {
	                Debug.assert(child.end <= position);
	                lastNodeEntirelyBeforePosition = child;
	              }
	            } else {
	              Debug.assert(child.pos > position);
	              return true;
	            }
	          }
	        }
	        function checkChangeRange(sourceFile, newText, textChangeRange, aggressiveChecks) {
	          const oldText = sourceFile.text;
	          if (textChangeRange) {
	            Debug.assert(oldText.length - textChangeRange.span.length + textChangeRange.newLength === newText.length);
	            if (aggressiveChecks || Debug.shouldAssert(3 /* VeryAggressive */)) {
	              const oldTextPrefix = oldText.substr(0, textChangeRange.span.start);
	              const newTextPrefix = newText.substr(0, textChangeRange.span.start);
	              Debug.assert(oldTextPrefix === newTextPrefix);
	              const oldTextSuffix = oldText.substring(textSpanEnd(textChangeRange.span), oldText.length);
	              const newTextSuffix = newText.substring(textSpanEnd(textChangeRangeNewSpan(textChangeRange)), newText.length);
	              Debug.assert(oldTextSuffix === newTextSuffix);
	            }
	          }
	        }
	        function createSyntaxCursor(sourceFile) {
	          let currentArray = sourceFile.statements;
	          let currentArrayIndex = 0;
	          Debug.assert(currentArrayIndex < currentArray.length);
	          let current = currentArray[currentArrayIndex];
	          let lastQueriedPosition = -1 /* Value */;
	          return {
	            currentNode(position) {
	              if (position !== lastQueriedPosition) {
	                if (current && current.end === position && currentArrayIndex < currentArray.length - 1) {
	                  currentArrayIndex++;
	                  current = currentArray[currentArrayIndex];
	                }
	                if (!current || current.pos !== position) {
	                  findHighestListElementThatStartsAtPosition(position);
	                }
	              }
	              lastQueriedPosition = position;
	              Debug.assert(!current || current.pos === position);
	              return current;
	            }
	          };
	          function findHighestListElementThatStartsAtPosition(position) {
	            currentArray = void 0;
	            currentArrayIndex = -1 /* Value */;
	            current = void 0;
	            forEachChild(sourceFile, visitNode3, visitArray2);
	            return;
	            function visitNode3(node) {
	              if (position >= node.pos && position < node.end) {
	                forEachChild(node, visitNode3, visitArray2);
	                return true;
	              }
	              return false;
	            }
	            function visitArray2(array) {
	              if (position >= array.pos && position < array.end) {
	                for (let i = 0; i < array.length; i++) {
	                  const child = array[i];
	                  if (child) {
	                    if (child.pos === position) {
	                      currentArray = array;
	                      currentArrayIndex = i;
	                      current = child;
	                      return true;
	                    } else {
	                      if (child.pos < position && position < child.end) {
	                        forEachChild(child, visitNode3, visitArray2);
	                        return true;
	                      }
	                    }
	                  }
	                }
	              }
	              return false;
	            }
	          }
	        }
	        IncrementalParser2.createSyntaxCursor = createSyntaxCursor;
	        let InvalidPosition;
	        ((InvalidPosition2) => {
	          InvalidPosition2[InvalidPosition2["Value"] = -1] = "Value";
	        })(InvalidPosition || (InvalidPosition = {}));
	      })(IncrementalParser || (IncrementalParser = {}));
	      namedArgRegExCache = /* @__PURE__ */ new Map();
	      tripleSlashXMLCommentStartRegEx = /^\/\/\/\s*<(\S+)\s.*?\/>/im;
	      singleLinePragmaRegEx = /^\/\/\/?\s*@([^\s:]+)(.*)\s*$/im;
	    }
	  });

	  // src/compiler/commandLineParser.ts
	  function createOptionNameMap(optionDeclarations2) {
	    const optionsNameMap = /* @__PURE__ */ new Map();
	    const shortOptionNames = /* @__PURE__ */ new Map();
	    forEach(optionDeclarations2, (option) => {
	      optionsNameMap.set(option.name.toLowerCase(), option);
	      if (option.shortName) {
	        shortOptionNames.set(option.shortName, option.name);
	      }
	    });
	    return { optionsNameMap, shortOptionNames };
	  }
	  function getOptionsNameMap() {
	    return optionsNameMapCache || (optionsNameMapCache = createOptionNameMap(optionDeclarations));
	  }
	  function createCompilerDiagnosticForInvalidCustomType(opt) {
	    return createDiagnosticForInvalidCustomType(opt, createCompilerDiagnostic);
	  }
	  function createDiagnosticForInvalidCustomType(opt, createDiagnostic) {
	    const namesOfType = arrayFrom(opt.type.keys());
	    const stringNames = (opt.deprecatedKeys ? namesOfType.filter((k) => !opt.deprecatedKeys.has(k)) : namesOfType).map((key) => `'${key}'`).join(", ");
	    return createDiagnostic(Diagnostics.Argument_for_0_option_must_be_Colon_1, `--${opt.name}`, stringNames);
	  }
	  function parseCustomTypeOption(opt, value, errors) {
	    return convertJsonOptionOfCustomType(opt, (value ?? "").trim(), errors);
	  }
	  function parseListTypeOption(opt, value = "", errors) {
	    value = value.trim();
	    if (startsWith(value, "-")) {
	      return void 0;
	    }
	    if (opt.type === "listOrElement" && !value.includes(",")) {
	      return validateJsonOptionValue(opt, value, errors);
	    }
	    if (value === "") {
	      return [];
	    }
	    const values = value.split(",");
	    switch (opt.element.type) {
	      case "number":
	        return mapDefined(values, (v) => validateJsonOptionValue(opt.element, parseInt(v), errors));
	      case "string":
	        return mapDefined(values, (v) => validateJsonOptionValue(opt.element, v || "", errors));
	      case "boolean":
	      case "object":
	        return Debug.fail(`List of ${opt.element.type} is not yet supported.`);
	      default:
	        return mapDefined(values, (v) => parseCustomTypeOption(opt.element, v, errors));
	    }
	  }
	  function getOptionName(option) {
	    return option.name;
	  }
	  function createUnknownOptionError(unknownOption, diagnostics, unknownOptionErrorText, node, sourceFile) {
	    var _a;
	    if ((_a = diagnostics.alternateMode) == null ? void 0 : _a.getOptionsNameMap().optionsNameMap.has(unknownOption.toLowerCase())) {
	      return createDiagnosticForNodeInSourceFileOrCompilerDiagnostic(sourceFile, node, diagnostics.alternateMode.diagnostic, unknownOption);
	    }
	    const possibleOption = getSpellingSuggestion(unknownOption, diagnostics.optionDeclarations, getOptionName);
	    return possibleOption ? createDiagnosticForNodeInSourceFileOrCompilerDiagnostic(sourceFile, node, diagnostics.unknownDidYouMeanDiagnostic, unknownOptionErrorText || unknownOption, possibleOption.name) : createDiagnosticForNodeInSourceFileOrCompilerDiagnostic(sourceFile, node, diagnostics.unknownOptionDiagnostic, unknownOptionErrorText || unknownOption);
	  }
	  function parseCommandLineWorker(diagnostics, commandLine, readFile) {
	    const options = {};
	    let watchOptions;
	    const fileNames = [];
	    const errors = [];
	    parseStrings(commandLine);
	    return {
	      options,
	      watchOptions,
	      fileNames,
	      errors
	    };
	    function parseStrings(args) {
	      let i = 0;
	      while (i < args.length) {
	        const s = args[i];
	        i++;
	        if (s.charCodeAt(0) === 64 /* at */) {
	          parseResponseFile(s.slice(1));
	        } else if (s.charCodeAt(0) === 45 /* minus */) {
	          const inputOptionName = s.slice(s.charCodeAt(1) === 45 /* minus */ ? 2 : 1);
	          const opt = getOptionDeclarationFromName(
	            diagnostics.getOptionsNameMap,
	            inputOptionName,
	            /*allowShort*/
	            true
	          );
	          if (opt) {
	            i = parseOptionValue(args, i, diagnostics, opt, options, errors);
	          } else {
	            const watchOpt = getOptionDeclarationFromName(
	              watchOptionsDidYouMeanDiagnostics.getOptionsNameMap,
	              inputOptionName,
	              /*allowShort*/
	              true
	            );
	            if (watchOpt) {
	              i = parseOptionValue(args, i, watchOptionsDidYouMeanDiagnostics, watchOpt, watchOptions || (watchOptions = {}), errors);
	            } else {
	              errors.push(createUnknownOptionError(inputOptionName, diagnostics, s));
	            }
	          }
	        } else {
	          fileNames.push(s);
	        }
	      }
	    }
	    function parseResponseFile(fileName) {
	      const text = tryReadFile(fileName, readFile || ((fileName2) => sys.readFile(fileName2)));
	      if (!isString(text)) {
	        errors.push(text);
	        return;
	      }
	      const args = [];
	      let pos = 0;
	      while (true) {
	        while (pos < text.length && text.charCodeAt(pos) <= 32 /* space */)
	          pos++;
	        if (pos >= text.length)
	          break;
	        const start = pos;
	        if (text.charCodeAt(start) === 34 /* doubleQuote */) {
	          pos++;
	          while (pos < text.length && text.charCodeAt(pos) !== 34 /* doubleQuote */)
	            pos++;
	          if (pos < text.length) {
	            args.push(text.substring(start + 1, pos));
	            pos++;
	          } else {
	            errors.push(createCompilerDiagnostic(Diagnostics.Unterminated_quoted_string_in_response_file_0, fileName));
	          }
	        } else {
	          while (text.charCodeAt(pos) > 32 /* space */)
	            pos++;
	          args.push(text.substring(start, pos));
	        }
	      }
	      parseStrings(args);
	    }
	  }
	  function parseOptionValue(args, i, diagnostics, opt, options, errors) {
	    if (opt.isTSConfigOnly) {
	      const optValue = args[i];
	      if (optValue === "null") {
	        options[opt.name] = void 0;
	        i++;
	      } else if (opt.type === "boolean") {
	        if (optValue === "false") {
	          options[opt.name] = validateJsonOptionValue(
	            opt,
	            /*value*/
	            false,
	            errors
	          );
	          i++;
	        } else {
	          if (optValue === "true")
	            i++;
	          errors.push(createCompilerDiagnostic(Diagnostics.Option_0_can_only_be_specified_in_tsconfig_json_file_or_set_to_false_or_null_on_command_line, opt.name));
	        }
	      } else {
	        errors.push(createCompilerDiagnostic(Diagnostics.Option_0_can_only_be_specified_in_tsconfig_json_file_or_set_to_null_on_command_line, opt.name));
	        if (optValue && !startsWith(optValue, "-"))
	          i++;
	      }
	    } else {
	      if (!args[i] && opt.type !== "boolean") {
	        errors.push(createCompilerDiagnostic(diagnostics.optionTypeMismatchDiagnostic, opt.name, getCompilerOptionValueTypeString(opt)));
	      }
	      if (args[i] !== "null") {
	        switch (opt.type) {
	          case "number":
	            options[opt.name] = validateJsonOptionValue(opt, parseInt(args[i]), errors);
	            i++;
	            break;
	          case "boolean":
	            const optValue = args[i];
	            options[opt.name] = validateJsonOptionValue(opt, optValue !== "false", errors);
	            if (optValue === "false" || optValue === "true") {
	              i++;
	            }
	            break;
	          case "string":
	            options[opt.name] = validateJsonOptionValue(opt, args[i] || "", errors);
	            i++;
	            break;
	          case "list":
	            const result = parseListTypeOption(opt, args[i], errors);
	            options[opt.name] = result || [];
	            if (result) {
	              i++;
	            }
	            break;
	          case "listOrElement":
	            Debug.fail("listOrElement not supported here");
	            break;
	          default:
	            options[opt.name] = parseCustomTypeOption(opt, args[i], errors);
	            i++;
	            break;
	        }
	      } else {
	        options[opt.name] = void 0;
	        i++;
	      }
	    }
	    return i;
	  }
	  function parseCommandLine(commandLine, readFile) {
	    return parseCommandLineWorker(compilerOptionsDidYouMeanDiagnostics, commandLine, readFile);
	  }
	  function getOptionFromName(optionName, allowShort) {
	    return getOptionDeclarationFromName(getOptionsNameMap, optionName, allowShort);
	  }
	  function getOptionDeclarationFromName(getOptionNameMap, optionName, allowShort = false) {
	    optionName = optionName.toLowerCase();
	    const { optionsNameMap, shortOptionNames } = getOptionNameMap();
	    if (allowShort) {
	      const short = shortOptionNames.get(optionName);
	      if (short !== void 0) {
	        optionName = short;
	      }
	    }
	    return optionsNameMap.get(optionName);
	  }
	  function getBuildOptionsNameMap() {
	    return buildOptionsNameMapCache || (buildOptionsNameMapCache = createOptionNameMap(buildOpts));
	  }
	  function parseBuildCommand(args) {
	    const { options, watchOptions, fileNames: projects, errors } = parseCommandLineWorker(
	      buildOptionsDidYouMeanDiagnostics,
	      args
	    );
	    const buildOptions = options;
	    if (projects.length === 0) {
	      projects.push(".");
	    }
	    if (buildOptions.clean && buildOptions.force) {
	      errors.push(createCompilerDiagnostic(Diagnostics.Options_0_and_1_cannot_be_combined, "clean", "force"));
	    }
	    if (buildOptions.clean && buildOptions.verbose) {
	      errors.push(createCompilerDiagnostic(Diagnostics.Options_0_and_1_cannot_be_combined, "clean", "verbose"));
	    }
	    if (buildOptions.clean && buildOptions.watch) {
	      errors.push(createCompilerDiagnostic(Diagnostics.Options_0_and_1_cannot_be_combined, "clean", "watch"));
	    }
	    if (buildOptions.watch && buildOptions.dry) {
	      errors.push(createCompilerDiagnostic(Diagnostics.Options_0_and_1_cannot_be_combined, "watch", "dry"));
	    }
	    return { buildOptions, watchOptions, projects, errors };
	  }
	  function getDiagnosticText(message, ...args) {
	    return cast(createCompilerDiagnostic(message, ...args).messageText, isString);
	  }
	  function getParsedCommandLineOfConfigFile(configFileName, optionsToExtend, host, extendedConfigCache, watchOptionsToExtend, extraFileExtensions) {
	    const configFileText = tryReadFile(configFileName, (fileName) => host.readFile(fileName));
	    if (!isString(configFileText)) {
	      host.onUnRecoverableConfigFileDiagnostic(configFileText);
	      return void 0;
	    }
	    const result = parseJsonText(configFileName, configFileText);
	    const cwd = host.getCurrentDirectory();
	    result.path = toPath(configFileName, cwd, createGetCanonicalFileName(host.useCaseSensitiveFileNames));
	    result.resolvedPath = result.path;
	    result.originalFileName = result.fileName;
	    return parseJsonSourceFileConfigFileContent(
	      result,
	      host,
	      getNormalizedAbsolutePath(getDirectoryPath(configFileName), cwd),
	      optionsToExtend,
	      getNormalizedAbsolutePath(configFileName, cwd),
	      /*resolutionStack*/
	      void 0,
	      extraFileExtensions,
	      extendedConfigCache,
	      watchOptionsToExtend
	    );
	  }
	  function readConfigFile(fileName, readFile) {
	    const textOrDiagnostic = tryReadFile(fileName, readFile);
	    return isString(textOrDiagnostic) ? parseConfigFileTextToJson(fileName, textOrDiagnostic) : { config: {}, error: textOrDiagnostic };
	  }
	  function parseConfigFileTextToJson(fileName, jsonText) {
	    const jsonSourceFile = parseJsonText(fileName, jsonText);
	    return {
	      config: convertConfigFileToObject(
	        jsonSourceFile,
	        jsonSourceFile.parseDiagnostics,
	        /*jsonConversionNotifier*/
	        void 0
	      ),
	      error: jsonSourceFile.parseDiagnostics.length ? jsonSourceFile.parseDiagnostics[0] : void 0
	    };
	  }
	  function readJsonConfigFile(fileName, readFile) {
	    const textOrDiagnostic = tryReadFile(fileName, readFile);
	    return isString(textOrDiagnostic) ? parseJsonText(fileName, textOrDiagnostic) : { fileName, parseDiagnostics: [textOrDiagnostic] };
	  }
	  function tryReadFile(fileName, readFile) {
	    let text;
	    try {
	      text = readFile(fileName);
	    } catch (e) {
	      return createCompilerDiagnostic(Diagnostics.Cannot_read_file_0_Colon_1, fileName, e.message);
	    }
	    return text === void 0 ? createCompilerDiagnostic(Diagnostics.Cannot_read_file_0, fileName) : text;
	  }
	  function commandLineOptionsToMap(options) {
	    return arrayToMap(options, getOptionName);
	  }
	  function getWatchOptionsNameMap() {
	    return watchOptionsNameMapCache || (watchOptionsNameMapCache = createOptionNameMap(optionsForWatch));
	  }
	  function getCommandLineCompilerOptionsMap() {
	    return commandLineCompilerOptionsMapCache || (commandLineCompilerOptionsMapCache = commandLineOptionsToMap(optionDeclarations));
	  }
	  function getCommandLineWatchOptionsMap() {
	    return commandLineWatchOptionsMapCache || (commandLineWatchOptionsMapCache = commandLineOptionsToMap(optionsForWatch));
	  }
	  function getCommandLineTypeAcquisitionMap() {
	    return commandLineTypeAcquisitionMapCache || (commandLineTypeAcquisitionMapCache = commandLineOptionsToMap(typeAcquisitionDeclarations));
	  }
	  function getTsconfigRootOptionsMap() {
	    if (_tsconfigRootOptions === void 0) {
	      _tsconfigRootOptions = {
	        name: void 0,
	        // should never be needed since this is root
	        type: "object",
	        elementOptions: commandLineOptionsToMap([
	          compilerOptionsDeclaration,
	          watchOptionsDeclaration,
	          typeAcquisitionDeclaration,
	          extendsOptionDeclaration,
	          {
	            name: "references",
	            type: "list",
	            element: {
	              name: "references",
	              type: "object"
	            },
	            category: Diagnostics.Projects
	          },
	          {
	            name: "files",
	            type: "list",
	            element: {
	              name: "files",
	              type: "string"
	            },
	            category: Diagnostics.File_Management
	          },
	          {
	            name: "include",
	            type: "list",
	            element: {
	              name: "include",
	              type: "string"
	            },
	            category: Diagnostics.File_Management,
	            defaultValueDescription: Diagnostics.if_files_is_specified_otherwise_Asterisk_Asterisk_Slash_Asterisk
	          },
	          {
	            name: "exclude",
	            type: "list",
	            element: {
	              name: "exclude",
	              type: "string"
	            },
	            category: Diagnostics.File_Management,
	            defaultValueDescription: Diagnostics.node_modules_bower_components_jspm_packages_plus_the_value_of_outDir_if_one_is_specified
	          },
	          compileOnSaveCommandLineOption
	        ])
	      };
	    }
	    return _tsconfigRootOptions;
	  }
	  function convertConfigFileToObject(sourceFile, errors, jsonConversionNotifier) {
	    var _a;
	    const rootExpression = (_a = sourceFile.statements[0]) == null ? void 0 : _a.expression;
	    if (rootExpression && rootExpression.kind !== 210 /* ObjectLiteralExpression */) {
	      errors.push(createDiagnosticForNodeInSourceFile(
	        sourceFile,
	        rootExpression,
	        Diagnostics.The_root_value_of_a_0_file_must_be_an_object,
	        getBaseFileName(sourceFile.fileName) === "jsconfig.json" ? "jsconfig.json" : "tsconfig.json"
	      ));
	      if (isArrayLiteralExpression(rootExpression)) {
	        const firstObject = find(rootExpression.elements, isObjectLiteralExpression);
	        if (firstObject) {
	          return convertToJson(
	            sourceFile,
	            firstObject,
	            errors,
	            /*returnValue*/
	            true,
	            jsonConversionNotifier
	          );
	        }
	      }
	      return {};
	    }
	    return convertToJson(
	      sourceFile,
	      rootExpression,
	      errors,
	      /*returnValue*/
	      true,
	      jsonConversionNotifier
	    );
	  }
	  function convertToObject(sourceFile, errors) {
	    var _a;
	    return convertToJson(
	      sourceFile,
	      (_a = sourceFile.statements[0]) == null ? void 0 : _a.expression,
	      errors,
	      /*returnValue*/
	      true,
	      /*jsonConversionNotifier*/
	      void 0
	    );
	  }
	  function convertToJson(sourceFile, rootExpression, errors, returnValue, jsonConversionNotifier) {
	    if (!rootExpression) {
	      return returnValue ? {} : void 0;
	    }
	    return convertPropertyValueToJson(rootExpression, jsonConversionNotifier == null ? void 0 : jsonConversionNotifier.rootOptions);
	    function convertObjectLiteralExpressionToJson(node, objectOption) {
	      var _a;
	      const result = returnValue ? {} : void 0;
	      for (const element of node.properties) {
	        if (element.kind !== 303 /* PropertyAssignment */) {
	          errors.push(createDiagnosticForNodeInSourceFile(sourceFile, element, Diagnostics.Property_assignment_expected));
	          continue;
	        }
	        if (element.questionToken) {
	          errors.push(createDiagnosticForNodeInSourceFile(sourceFile, element.questionToken, Diagnostics.The_0_modifier_can_only_be_used_in_TypeScript_files, "?"));
	        }
	        if (!isDoubleQuotedString(element.name)) {
	          errors.push(createDiagnosticForNodeInSourceFile(sourceFile, element.name, Diagnostics.String_literal_with_double_quotes_expected));
	        }
	        const textOfKey = isComputedNonLiteralName(element.name) ? void 0 : getTextOfPropertyName(element.name);
	        const keyText = textOfKey && unescapeLeadingUnderscores(textOfKey);
	        const option = keyText ? (_a = objectOption == null ? void 0 : objectOption.elementOptions) == null ? void 0 : _a.get(keyText) : void 0;
	        const value = convertPropertyValueToJson(element.initializer, option);
	        if (typeof keyText !== "undefined") {
	          if (returnValue) {
	            result[keyText] = value;
	          }
	          jsonConversionNotifier == null ? void 0 : jsonConversionNotifier.onPropertySet(keyText, value, element, objectOption, option);
	        }
	      }
	      return result;
	    }
	    function convertArrayLiteralExpressionToJson(elements, elementOption) {
	      if (!returnValue) {
	        elements.forEach((element) => convertPropertyValueToJson(element, elementOption));
	        return void 0;
	      }
	      return filter(elements.map((element) => convertPropertyValueToJson(element, elementOption)), (v) => v !== void 0);
	    }
	    function convertPropertyValueToJson(valueExpression, option) {
	      switch (valueExpression.kind) {
	        case 112 /* TrueKeyword */:
	          return true;
	        case 97 /* FalseKeyword */:
	          return false;
	        case 106 /* NullKeyword */:
	          return null;
	        case 11 /* StringLiteral */:
	          if (!isDoubleQuotedString(valueExpression)) {
	            errors.push(createDiagnosticForNodeInSourceFile(sourceFile, valueExpression, Diagnostics.String_literal_with_double_quotes_expected));
	          }
	          return valueExpression.text;
	        case 9 /* NumericLiteral */:
	          return Number(valueExpression.text);
	        case 224 /* PrefixUnaryExpression */:
	          if (valueExpression.operator !== 41 /* MinusToken */ || valueExpression.operand.kind !== 9 /* NumericLiteral */) {
	            break;
	          }
	          return -Number(valueExpression.operand.text);
	        case 210 /* ObjectLiteralExpression */:
	          const objectLiteralExpression = valueExpression;
	          return convertObjectLiteralExpressionToJson(objectLiteralExpression, option);
	        case 209 /* ArrayLiteralExpression */:
	          return convertArrayLiteralExpressionToJson(
	            valueExpression.elements,
	            option && option.element
	          );
	      }
	      if (option) {
	        errors.push(createDiagnosticForNodeInSourceFile(sourceFile, valueExpression, Diagnostics.Compiler_option_0_requires_a_value_of_type_1, option.name, getCompilerOptionValueTypeString(option)));
	      } else {
	        errors.push(createDiagnosticForNodeInSourceFile(sourceFile, valueExpression, Diagnostics.Property_value_can_only_be_string_literal_numeric_literal_true_false_null_object_literal_or_array_literal));
	      }
	      return void 0;
	    }
	    function isDoubleQuotedString(node) {
	      return isStringLiteral(node) && isStringDoubleQuoted(node, sourceFile);
	    }
	  }
	  function getCompilerOptionValueTypeString(option) {
	    return option.type === "listOrElement" ? `${getCompilerOptionValueTypeString(option.element)} or Array` : option.type === "list" ? "Array" : isString(option.type) ? option.type : "string";
	  }
	  function isCompilerOptionsValue(option, value) {
	    if (option) {
	      if (isNullOrUndefined(value))
	        return !option.disallowNullOrUndefined;
	      if (option.type === "list") {
	        return isArray(value);
	      }
	      if (option.type === "listOrElement") {
	        return isArray(value) || isCompilerOptionsValue(option.element, value);
	      }
	      const expectedType = isString(option.type) ? option.type : "string";
	      return typeof value === expectedType;
	    }
	    return false;
	  }
	  function convertToTSConfig(configParseResult, configFileName, host) {
	    var _a, _b, _c;
	    const getCanonicalFileName = createGetCanonicalFileName(host.useCaseSensitiveFileNames);
	    const files = map(
	      filter(
	        configParseResult.fileNames,
	        !((_b = (_a = configParseResult.options.configFile) == null ? void 0 : _a.configFileSpecs) == null ? void 0 : _b.validatedIncludeSpecs) ? returnTrue : matchesSpecs(
	          configFileName,
	          configParseResult.options.configFile.configFileSpecs.validatedIncludeSpecs,
	          configParseResult.options.configFile.configFileSpecs.validatedExcludeSpecs,
	          host
	        )
	      ),
	      (f) => getRelativePathFromFile(getNormalizedAbsolutePath(configFileName, host.getCurrentDirectory()), getNormalizedAbsolutePath(f, host.getCurrentDirectory()), getCanonicalFileName)
	    );
	    const pathOptions = { configFilePath: getNormalizedAbsolutePath(configFileName, host.getCurrentDirectory()), useCaseSensitiveFileNames: host.useCaseSensitiveFileNames };
	    const optionMap = serializeCompilerOptions(configParseResult.options, pathOptions);
	    const watchOptionMap = configParseResult.watchOptions && serializeWatchOptions(configParseResult.watchOptions);
	    const config = {
	      compilerOptions: {
	        ...optionMapToObject(optionMap),
	        showConfig: void 0,
	        configFile: void 0,
	        configFilePath: void 0,
	        help: void 0,
	        init: void 0,
	        listFiles: void 0,
	        listEmittedFiles: void 0,
	        project: void 0,
	        build: void 0,
	        version: void 0
	      },
	      watchOptions: watchOptionMap && optionMapToObject(watchOptionMap),
	      references: map(configParseResult.projectReferences, (r) => ({ ...r, path: r.originalPath ? r.originalPath : "", originalPath: void 0 })),
	      files: length(files) ? files : void 0,
	      ...((_c = configParseResult.options.configFile) == null ? void 0 : _c.configFileSpecs) ? {
	        include: filterSameAsDefaultInclude(configParseResult.options.configFile.configFileSpecs.validatedIncludeSpecs),
	        exclude: configParseResult.options.configFile.configFileSpecs.validatedExcludeSpecs
	      } : {},
	      compileOnSave: !!configParseResult.compileOnSave ? true : void 0
	    };
	    const providedKeys = new Set(optionMap.keys());
	    const impliedCompilerOptions = {};
	    for (const option in computedOptions) {
	      if (!providedKeys.has(option) && some(computedOptions[option].dependencies, (dep) => providedKeys.has(dep))) {
	        const implied = computedOptions[option].computeValue(configParseResult.options);
	        const defaultValue = computedOptions[option].computeValue({});
	        if (implied !== defaultValue) {
	          impliedCompilerOptions[option] = computedOptions[option].computeValue(configParseResult.options);
	        }
	      }
	    }
	    assign(config.compilerOptions, optionMapToObject(serializeCompilerOptions(impliedCompilerOptions, pathOptions)));
	    return config;
	  }
	  function optionMapToObject(optionMap) {
	    return {
	      ...arrayFrom(optionMap.entries()).reduce((prev, cur) => ({ ...prev, [cur[0]]: cur[1] }), {})
	    };
	  }
	  function filterSameAsDefaultInclude(specs) {
	    if (!length(specs))
	      return void 0;
	    if (length(specs) !== 1)
	      return specs;
	    if (specs[0] === defaultIncludeSpec)
	      return void 0;
	    return specs;
	  }
	  function matchesSpecs(path, includeSpecs, excludeSpecs, host) {
	    if (!includeSpecs)
	      return returnTrue;
	    const patterns = getFileMatcherPatterns(path, excludeSpecs, includeSpecs, host.useCaseSensitiveFileNames, host.getCurrentDirectory());
	    const excludeRe = patterns.excludePattern && getRegexFromPattern(patterns.excludePattern, host.useCaseSensitiveFileNames);
	    const includeRe = patterns.includeFilePattern && getRegexFromPattern(patterns.includeFilePattern, host.useCaseSensitiveFileNames);
	    if (includeRe) {
	      if (excludeRe) {
	        return (path2) => !(includeRe.test(path2) && !excludeRe.test(path2));
	      }
	      return (path2) => !includeRe.test(path2);
	    }
	    if (excludeRe) {
	      return (path2) => excludeRe.test(path2);
	    }
	    return returnTrue;
	  }
	  function getCustomTypeMapOfCommandLineOption(optionDefinition) {
	    switch (optionDefinition.type) {
	      case "string":
	      case "number":
	      case "boolean":
	      case "object":
	        return void 0;
	      case "list":
	      case "listOrElement":
	        return getCustomTypeMapOfCommandLineOption(optionDefinition.element);
	      default:
	        return optionDefinition.type;
	    }
	  }
	  function getNameOfCompilerOptionValue(value, customTypeMap) {
	    return forEachEntry(customTypeMap, (mapValue, key) => {
	      if (mapValue === value) {
	        return key;
	      }
	    });
	  }
	  function serializeCompilerOptions(options, pathOptions) {
	    return serializeOptionBaseObject(options, getOptionsNameMap(), pathOptions);
	  }
	  function serializeWatchOptions(options) {
	    return serializeOptionBaseObject(options, getWatchOptionsNameMap());
	  }
	  function serializeOptionBaseObject(options, { optionsNameMap }, pathOptions) {
	    const result = /* @__PURE__ */ new Map();
	    const getCanonicalFileName = pathOptions && createGetCanonicalFileName(pathOptions.useCaseSensitiveFileNames);
	    for (const name in options) {
	      if (hasProperty(options, name)) {
	        if (optionsNameMap.has(name) && (optionsNameMap.get(name).category === Diagnostics.Command_line_Options || optionsNameMap.get(name).category === Diagnostics.Output_Formatting)) {
	          continue;
	        }
	        const value = options[name];
	        const optionDefinition = optionsNameMap.get(name.toLowerCase());
	        if (optionDefinition) {
	          Debug.assert(optionDefinition.type !== "listOrElement");
	          const customTypeMap = getCustomTypeMapOfCommandLineOption(optionDefinition);
	          if (!customTypeMap) {
	            if (pathOptions && optionDefinition.isFilePath) {
	              result.set(name, getRelativePathFromFile(pathOptions.configFilePath, getNormalizedAbsolutePath(value, getDirectoryPath(pathOptions.configFilePath)), getCanonicalFileName));
	            } else {
	              result.set(name, value);
	            }
	          } else {
	            if (optionDefinition.type === "list") {
	              result.set(name, value.map((element) => getNameOfCompilerOptionValue(element, customTypeMap)));
	            } else {
	              result.set(name, getNameOfCompilerOptionValue(value, customTypeMap));
	            }
	          }
	        }
	      }
	    }
	    return result;
	  }
	  function getCompilerOptionsDiffValue(options, newLine) {
	    const compilerOptionsMap = getSerializedCompilerOption(options);
	    return getOverwrittenDefaultOptions();
	    function makePadding(paddingLength) {
	      return Array(paddingLength + 1).join(" ");
	    }
	    function getOverwrittenDefaultOptions() {
	      const result = [];
	      const tab = makePadding(2);
	      commandOptionsWithoutBuild.forEach((cmd) => {
	        if (!compilerOptionsMap.has(cmd.name)) {
	          return;
	        }
	        const newValue = compilerOptionsMap.get(cmd.name);
	        const defaultValue = getDefaultValueForOption(cmd);
	        if (newValue !== defaultValue) {
	          result.push(`${tab}${cmd.name}: ${newValue}`);
	        } else if (hasProperty(defaultInitCompilerOptions, cmd.name)) {
	          result.push(`${tab}${cmd.name}: ${defaultValue}`);
	        }
	      });
	      return result.join(newLine) + newLine;
	    }
	  }
	  function getSerializedCompilerOption(options) {
	    const compilerOptions = extend(options, defaultInitCompilerOptions);
	    return serializeCompilerOptions(compilerOptions);
	  }
	  function generateTSConfig(options, fileNames, newLine) {
	    const compilerOptionsMap = getSerializedCompilerOption(options);
	    return writeConfigurations();
	    function makePadding(paddingLength) {
	      return Array(paddingLength + 1).join(" ");
	    }
	    function isAllowedOptionForOutput({ category, name, isCommandLineOnly }) {
	      const categoriesToSkip = [Diagnostics.Command_line_Options, Diagnostics.Editor_Support, Diagnostics.Compiler_Diagnostics, Diagnostics.Backwards_Compatibility, Diagnostics.Watch_and_Build_Modes, Diagnostics.Output_Formatting];
	      return !isCommandLineOnly && category !== void 0 && (!categoriesToSkip.includes(category) || compilerOptionsMap.has(name));
	    }
	    function writeConfigurations() {
	      const categorizedOptions = /* @__PURE__ */ new Map();
	      categorizedOptions.set(Diagnostics.Projects, []);
	      categorizedOptions.set(Diagnostics.Language_and_Environment, []);
	      categorizedOptions.set(Diagnostics.Modules, []);
	      categorizedOptions.set(Diagnostics.JavaScript_Support, []);
	      categorizedOptions.set(Diagnostics.Emit, []);
	      categorizedOptions.set(Diagnostics.Interop_Constraints, []);
	      categorizedOptions.set(Diagnostics.Type_Checking, []);
	      categorizedOptions.set(Diagnostics.Completeness, []);
	      for (const option of optionDeclarations) {
	        if (isAllowedOptionForOutput(option)) {
	          let listForCategory = categorizedOptions.get(option.category);
	          if (!listForCategory)
	            categorizedOptions.set(option.category, listForCategory = []);
	          listForCategory.push(option);
	        }
	      }
	      let marginLength = 0;
	      let seenKnownKeys = 0;
	      const entries = [];
	      categorizedOptions.forEach((options2, category) => {
	        if (entries.length !== 0) {
	          entries.push({ value: "" });
	        }
	        entries.push({ value: `/* ${getLocaleSpecificMessage(category)} */` });
	        for (const option of options2) {
	          let optionName;
	          if (compilerOptionsMap.has(option.name)) {
	            optionName = `"${option.name}": ${JSON.stringify(compilerOptionsMap.get(option.name))}${(seenKnownKeys += 1) === compilerOptionsMap.size ? "" : ","}`;
	          } else {
	            optionName = `// "${option.name}": ${JSON.stringify(getDefaultValueForOption(option))},`;
	          }
	          entries.push({
	            value: optionName,
	            description: `/* ${option.description && getLocaleSpecificMessage(option.description) || option.name} */`
	          });
	          marginLength = Math.max(optionName.length, marginLength);
	        }
	      });
	      const tab = makePadding(2);
	      const result = [];
	      result.push(`{`);
	      result.push(`${tab}"compilerOptions": {`);
	      result.push(`${tab}${tab}/* ${getLocaleSpecificMessage(Diagnostics.Visit_https_Colon_Slash_Slashaka_ms_Slashtsconfig_to_read_more_about_this_file)} */`);
	      result.push("");
	      for (const entry of entries) {
	        const { value, description: description3 = "" } = entry;
	        result.push(value && `${tab}${tab}${value}${description3 && makePadding(marginLength - value.length + 2) + description3}`);
	      }
	      if (fileNames.length) {
	        result.push(`${tab}},`);
	        result.push(`${tab}"files": [`);
	        for (let i = 0; i < fileNames.length; i++) {
	          result.push(`${tab}${tab}${JSON.stringify(fileNames[i])}${i === fileNames.length - 1 ? "" : ","}`);
	        }
	        result.push(`${tab}]`);
	      } else {
	        result.push(`${tab}}`);
	      }
	      result.push(`}`);
	      return result.join(newLine) + newLine;
	    }
	  }
	  function convertToOptionsWithAbsolutePaths(options, toAbsolutePath) {
	    const result = {};
	    const optionsNameMap = getOptionsNameMap().optionsNameMap;
	    for (const name in options) {
	      if (hasProperty(options, name)) {
	        result[name] = convertToOptionValueWithAbsolutePaths(
	          optionsNameMap.get(name.toLowerCase()),
	          options[name],
	          toAbsolutePath
	        );
	      }
	    }
	    if (result.configFilePath) {
	      result.configFilePath = toAbsolutePath(result.configFilePath);
	    }
	    return result;
	  }
	  function convertToOptionValueWithAbsolutePaths(option, value, toAbsolutePath) {
	    if (option && !isNullOrUndefined(value)) {
	      if (option.type === "list") {
	        const values = value;
	        if (option.element.isFilePath && values.length) {
	          return values.map(toAbsolutePath);
	        }
	      } else if (option.isFilePath) {
	        return toAbsolutePath(value);
	      }
	      Debug.assert(option.type !== "listOrElement");
	    }
	    return value;
	  }
	  function parseJsonConfigFileContent(json, host, basePath, existingOptions, configFileName, resolutionStack, extraFileExtensions, extendedConfigCache, existingWatchOptions) {
	    return parseJsonConfigFileContentWorker(
	      json,
	      /*sourceFile*/
	      void 0,
	      host,
	      basePath,
	      existingOptions,
	      existingWatchOptions,
	      configFileName,
	      resolutionStack,
	      extraFileExtensions,
	      extendedConfigCache
	    );
	  }
	  function parseJsonSourceFileConfigFileContent(sourceFile, host, basePath, existingOptions, configFileName, resolutionStack, extraFileExtensions, extendedConfigCache, existingWatchOptions) {
	    var _a, _b;
	    (_a = tracing) == null ? void 0 : _a.push(tracing.Phase.Parse, "parseJsonSourceFileConfigFileContent", { path: sourceFile.fileName });
	    const result = parseJsonConfigFileContentWorker(
	      /*json*/
	      void 0,
	      sourceFile,
	      host,
	      basePath,
	      existingOptions,
	      existingWatchOptions,
	      configFileName,
	      resolutionStack,
	      extraFileExtensions,
	      extendedConfigCache
	    );
	    (_b = tracing) == null ? void 0 : _b.pop();
	    return result;
	  }
	  function setConfigFileInOptions(options, configFile) {
	    if (configFile) {
	      Object.defineProperty(options, "configFile", { enumerable: false, writable: false, value: configFile });
	    }
	  }
	  function isNullOrUndefined(x) {
	    return x === void 0 || x === null;
	  }
	  function directoryOfCombinedPath(fileName, basePath) {
	    return getDirectoryPath(getNormalizedAbsolutePath(fileName, basePath));
	  }
	  function parseJsonConfigFileContentWorker(json, sourceFile, host, basePath, existingOptions = {}, existingWatchOptions, configFileName, resolutionStack = [], extraFileExtensions = [], extendedConfigCache) {
	    Debug.assert(json === void 0 && sourceFile !== void 0 || json !== void 0 && sourceFile === void 0);
	    const errors = [];
	    const parsedConfig = parseConfig(json, sourceFile, host, basePath, configFileName, resolutionStack, errors, extendedConfigCache);
	    const { raw } = parsedConfig;
	    const options = extend(existingOptions, parsedConfig.options || {});
	    const watchOptions = existingWatchOptions && parsedConfig.watchOptions ? extend(existingWatchOptions, parsedConfig.watchOptions) : parsedConfig.watchOptions || existingWatchOptions;
	    options.configFilePath = configFileName && normalizeSlashes(configFileName);
	    const configFileSpecs = getConfigFileSpecs();
	    if (sourceFile)
	      sourceFile.configFileSpecs = configFileSpecs;
	    setConfigFileInOptions(options, sourceFile);
	    const basePathForFileNames = normalizePath(configFileName ? directoryOfCombinedPath(configFileName, basePath) : basePath);
	    return {
	      options,
	      watchOptions,
	      fileNames: getFileNames(basePathForFileNames),
	      projectReferences: getProjectReferences(basePathForFileNames),
	      typeAcquisition: parsedConfig.typeAcquisition || getDefaultTypeAcquisition(),
	      raw,
	      errors,
	      // Wildcard directories (provided as part of a wildcard path) are stored in a
	      // file map that marks whether it was a regular wildcard match (with a `*` or `?` token),
	      // or a recursive directory. This information is used by filesystem watchers to monitor for
	      // new entries in these paths.
	      wildcardDirectories: getWildcardDirectories(configFileSpecs, basePathForFileNames, host.useCaseSensitiveFileNames),
	      compileOnSave: !!raw.compileOnSave
	    };
	    function getConfigFileSpecs() {
	      const referencesOfRaw = getPropFromRaw("references", (element) => typeof element === "object", "object");
	      const filesSpecs = toPropValue(getSpecsFromRaw("files"));
	      if (filesSpecs) {
	        const hasZeroOrNoReferences = referencesOfRaw === "no-prop" || isArray(referencesOfRaw) && referencesOfRaw.length === 0;
	        const hasExtends = hasProperty(raw, "extends");
	        if (filesSpecs.length === 0 && hasZeroOrNoReferences && !hasExtends) {
	          if (sourceFile) {
	            const fileName = configFileName || "tsconfig.json";
	            const diagnosticMessage = Diagnostics.The_files_list_in_config_file_0_is_empty;
	            const nodeValue = forEachTsConfigPropArray(sourceFile, "files", (property) => property.initializer);
	            const error2 = createDiagnosticForNodeInSourceFileOrCompilerDiagnostic(sourceFile, nodeValue, diagnosticMessage, fileName);
	            errors.push(error2);
	          } else {
	            createCompilerDiagnosticOnlyIfJson(Diagnostics.The_files_list_in_config_file_0_is_empty, configFileName || "tsconfig.json");
	          }
	        }
	      }
	      let includeSpecs = toPropValue(getSpecsFromRaw("include"));
	      const excludeOfRaw = getSpecsFromRaw("exclude");
	      let isDefaultIncludeSpec = false;
	      let excludeSpecs = toPropValue(excludeOfRaw);
	      if (excludeOfRaw === "no-prop" && raw.compilerOptions) {
	        const outDir = raw.compilerOptions.outDir;
	        const declarationDir = raw.compilerOptions.declarationDir;
	        if (outDir || declarationDir) {
	          excludeSpecs = [outDir, declarationDir].filter((d) => !!d);
	        }
	      }
	      if (filesSpecs === void 0 && includeSpecs === void 0) {
	        includeSpecs = [defaultIncludeSpec];
	        isDefaultIncludeSpec = true;
	      }
	      let validatedIncludeSpecs, validatedExcludeSpecs;
	      if (includeSpecs) {
	        validatedIncludeSpecs = validateSpecs(
	          includeSpecs,
	          errors,
	          /*disallowTrailingRecursion*/
	          true,
	          sourceFile,
	          "include"
	        );
	      }
	      if (excludeSpecs) {
	        validatedExcludeSpecs = validateSpecs(
	          excludeSpecs,
	          errors,
	          /*disallowTrailingRecursion*/
	          false,
	          sourceFile,
	          "exclude"
	        );
	      }
	      return {
	        filesSpecs,
	        includeSpecs,
	        excludeSpecs,
	        validatedFilesSpec: filter(filesSpecs, isString),
	        validatedIncludeSpecs,
	        validatedExcludeSpecs,
	        pathPatterns: void 0,
	        // Initialized on first use
	        isDefaultIncludeSpec
	      };
	    }
	    function getFileNames(basePath2) {
	      const fileNames = getFileNamesFromConfigSpecs(configFileSpecs, basePath2, options, host, extraFileExtensions);
	      if (shouldReportNoInputFiles(fileNames, canJsonReportNoInputFiles(raw), resolutionStack)) {
	        errors.push(getErrorForNoInputFiles(configFileSpecs, configFileName));
	      }
	      return fileNames;
	    }
	    function getProjectReferences(basePath2) {
	      let projectReferences;
	      const referencesOfRaw = getPropFromRaw("references", (element) => typeof element === "object", "object");
	      if (isArray(referencesOfRaw)) {
	        for (const ref of referencesOfRaw) {
	          if (typeof ref.path !== "string") {
	            createCompilerDiagnosticOnlyIfJson(Diagnostics.Compiler_option_0_requires_a_value_of_type_1, "reference.path", "string");
	          } else {
	            (projectReferences || (projectReferences = [])).push({
	              path: getNormalizedAbsolutePath(ref.path, basePath2),
	              originalPath: ref.path,
	              prepend: ref.prepend,
	              circular: ref.circular
	            });
	          }
	        }
	      }
	      return projectReferences;
	    }
	    function toPropValue(specResult) {
	      return isArray(specResult) ? specResult : void 0;
	    }
	    function getSpecsFromRaw(prop) {
	      return getPropFromRaw(prop, isString, "string");
	    }
	    function getPropFromRaw(prop, validateElement, elementTypeName) {
	      if (hasProperty(raw, prop) && !isNullOrUndefined(raw[prop])) {
	        if (isArray(raw[prop])) {
	          const result = raw[prop];
	          if (!sourceFile && !every(result, validateElement)) {
	            errors.push(createCompilerDiagnostic(Diagnostics.Compiler_option_0_requires_a_value_of_type_1, prop, elementTypeName));
	          }
	          return result;
	        } else {
	          createCompilerDiagnosticOnlyIfJson(Diagnostics.Compiler_option_0_requires_a_value_of_type_1, prop, "Array");
	          return "not-array";
	        }
	      }
	      return "no-prop";
	    }
	    function createCompilerDiagnosticOnlyIfJson(message, ...args) {
	      if (!sourceFile) {
	        errors.push(createCompilerDiagnostic(message, ...args));
	      }
	    }
	  }
	  function isErrorNoInputFiles(error2) {
	    return error2.code === Diagnostics.No_inputs_were_found_in_config_file_0_Specified_include_paths_were_1_and_exclude_paths_were_2.code;
	  }
	  function getErrorForNoInputFiles({ includeSpecs, excludeSpecs }, configFileName) {
	    return createCompilerDiagnostic(
	      Diagnostics.No_inputs_were_found_in_config_file_0_Specified_include_paths_were_1_and_exclude_paths_were_2,
	      configFileName || "tsconfig.json",
	      JSON.stringify(includeSpecs || []),
	      JSON.stringify(excludeSpecs || [])
	    );
	  }
	  function shouldReportNoInputFiles(fileNames, canJsonReportNoInutFiles, resolutionStack) {
	    return fileNames.length === 0 && canJsonReportNoInutFiles && (!resolutionStack || resolutionStack.length === 0);
	  }
	  function canJsonReportNoInputFiles(raw) {
	    return !hasProperty(raw, "files") && !hasProperty(raw, "references");
	  }
	  function updateErrorForNoInputFiles(fileNames, configFileName, configFileSpecs, configParseDiagnostics, canJsonReportNoInutFiles) {
	    const existingErrors = configParseDiagnostics.length;
	    if (shouldReportNoInputFiles(fileNames, canJsonReportNoInutFiles)) {
	      configParseDiagnostics.push(getErrorForNoInputFiles(configFileSpecs, configFileName));
	    } else {
	      filterMutate(configParseDiagnostics, (error2) => !isErrorNoInputFiles(error2));
	    }
	    return existingErrors !== configParseDiagnostics.length;
	  }
	  function isSuccessfulParsedTsconfig(value) {
	    return !!value.options;
	  }
	  function parseConfig(json, sourceFile, host, basePath, configFileName, resolutionStack, errors, extendedConfigCache) {
	    var _a;
	    basePath = normalizeSlashes(basePath);
	    const resolvedPath = getNormalizedAbsolutePath(configFileName || "", basePath);
	    if (resolutionStack.includes(resolvedPath)) {
	      errors.push(createCompilerDiagnostic(Diagnostics.Circularity_detected_while_resolving_configuration_Colon_0, [...resolutionStack, resolvedPath].join(" -> ")));
	      return { raw: json || convertToObject(sourceFile, errors) };
	    }
	    const ownConfig = json ? parseOwnConfigOfJson(json, host, basePath, configFileName, errors) : parseOwnConfigOfJsonSourceFile(sourceFile, host, basePath, configFileName, errors);
	    if ((_a = ownConfig.options) == null ? void 0 : _a.paths) {
	      ownConfig.options.pathsBasePath = basePath;
	    }
	    if (ownConfig.extendedConfigPath) {
	      resolutionStack = resolutionStack.concat([resolvedPath]);
	      const result = { options: {} };
	      if (isString(ownConfig.extendedConfigPath)) {
	        applyExtendedConfig(result, ownConfig.extendedConfigPath);
	      } else {
	        ownConfig.extendedConfigPath.forEach((extendedConfigPath) => applyExtendedConfig(result, extendedConfigPath));
	      }
	      if (!ownConfig.raw.include && result.include)
	        ownConfig.raw.include = result.include;
	      if (!ownConfig.raw.exclude && result.exclude)
	        ownConfig.raw.exclude = result.exclude;
	      if (!ownConfig.raw.files && result.files)
	        ownConfig.raw.files = result.files;
	      if (ownConfig.raw.compileOnSave === void 0 && result.compileOnSave)
	        ownConfig.raw.compileOnSave = result.compileOnSave;
	      if (sourceFile && result.extendedSourceFiles)
	        sourceFile.extendedSourceFiles = arrayFrom(result.extendedSourceFiles.keys());
	      ownConfig.options = assign(result.options, ownConfig.options);
	      ownConfig.watchOptions = ownConfig.watchOptions && result.watchOptions ? assign(result.watchOptions, ownConfig.watchOptions) : ownConfig.watchOptions || result.watchOptions;
	    }
	    return ownConfig;
	    function applyExtendedConfig(result, extendedConfigPath) {
	      const extendedConfig = getExtendedConfig(sourceFile, extendedConfigPath, host, resolutionStack, errors, extendedConfigCache, result);
	      if (extendedConfig && isSuccessfulParsedTsconfig(extendedConfig)) {
	        const extendsRaw = extendedConfig.raw;
	        let relativeDifference;
	        const setPropertyInResultIfNotUndefined = (propertyName) => {
	          if (extendsRaw[propertyName]) {
	            result[propertyName] = map(extendsRaw[propertyName], (path) => isRootedDiskPath(path) ? path : combinePaths(
	              relativeDifference || (relativeDifference = convertToRelativePath(getDirectoryPath(extendedConfigPath), basePath, createGetCanonicalFileName(host.useCaseSensitiveFileNames))),
	              path
	            ));
	          }
	        };
	        setPropertyInResultIfNotUndefined("include");
	        setPropertyInResultIfNotUndefined("exclude");
	        setPropertyInResultIfNotUndefined("files");
	        if (extendsRaw.compileOnSave !== void 0) {
	          result.compileOnSave = extendsRaw.compileOnSave;
	        }
	        assign(result.options, extendedConfig.options);
	        result.watchOptions = result.watchOptions && extendedConfig.watchOptions ? assign({}, result.watchOptions, extendedConfig.watchOptions) : result.watchOptions || extendedConfig.watchOptions;
	      }
	    }
	  }
	  function parseOwnConfigOfJson(json, host, basePath, configFileName, errors) {
	    if (hasProperty(json, "excludes")) {
	      errors.push(createCompilerDiagnostic(Diagnostics.Unknown_option_excludes_Did_you_mean_exclude));
	    }
	    const options = convertCompilerOptionsFromJsonWorker(json.compilerOptions, basePath, errors, configFileName);
	    const typeAcquisition = convertTypeAcquisitionFromJsonWorker(json.typeAcquisition, basePath, errors, configFileName);
	    const watchOptions = convertWatchOptionsFromJsonWorker(json.watchOptions, basePath, errors);
	    json.compileOnSave = convertCompileOnSaveOptionFromJson(json, basePath, errors);
	    const extendedConfigPath = json.extends || json.extends === "" ? getExtendsConfigPathOrArray(json.extends, host, basePath, configFileName, errors) : void 0;
	    return { raw: json, options, watchOptions, typeAcquisition, extendedConfigPath };
	  }
	  function getExtendsConfigPathOrArray(value, host, basePath, configFileName, errors, propertyAssignment, valueExpression, sourceFile) {
	    let extendedConfigPath;
	    const newBase = configFileName ? directoryOfCombinedPath(configFileName, basePath) : basePath;
	    if (isString(value)) {
	      extendedConfigPath = getExtendsConfigPath(
	        value,
	        host,
	        newBase,
	        errors,
	        valueExpression,
	        sourceFile
	      );
	    } else if (isArray(value)) {
	      extendedConfigPath = [];
	      for (let index = 0; index < value.length; index++) {
	        const fileName = value[index];
	        if (isString(fileName)) {
	          extendedConfigPath = append(
	            extendedConfigPath,
	            getExtendsConfigPath(
	              fileName,
	              host,
	              newBase,
	              errors,
	              valueExpression == null ? void 0 : valueExpression.elements[index],
	              sourceFile
	            )
	          );
	        } else {
	          convertJsonOption(extendsOptionDeclaration.element, value, basePath, errors, propertyAssignment, valueExpression == null ? void 0 : valueExpression.elements[index], sourceFile);
	        }
	      }
	    } else {
	      convertJsonOption(extendsOptionDeclaration, value, basePath, errors, propertyAssignment, valueExpression, sourceFile);
	    }
	    return extendedConfigPath;
	  }
	  function parseOwnConfigOfJsonSourceFile(sourceFile, host, basePath, configFileName, errors) {
	    const options = getDefaultCompilerOptions(configFileName);
	    let typeAcquisition;
	    let watchOptions;
	    let extendedConfigPath;
	    let rootCompilerOptions;
	    const rootOptions = getTsconfigRootOptionsMap();
	    const json = convertConfigFileToObject(
	      sourceFile,
	      errors,
	      { rootOptions, onPropertySet }
	    );
	    if (!typeAcquisition) {
	      typeAcquisition = getDefaultTypeAcquisition(configFileName);
	    }
	    if (rootCompilerOptions && json && json.compilerOptions === void 0) {
	      errors.push(createDiagnosticForNodeInSourceFile(sourceFile, rootCompilerOptions[0], Diagnostics._0_should_be_set_inside_the_compilerOptions_object_of_the_config_json_file, getTextOfPropertyName(rootCompilerOptions[0])));
	    }
	    return { raw: json, options, watchOptions, typeAcquisition, extendedConfigPath };
	    function onPropertySet(keyText, value, propertyAssignment, parentOption, option) {
	      if (option && option !== extendsOptionDeclaration)
	        value = convertJsonOption(option, value, basePath, errors, propertyAssignment, propertyAssignment.initializer, sourceFile);
	      if (parentOption == null ? void 0 : parentOption.name) {
	        if (option) {
	          let currentOption;
	          if (parentOption === compilerOptionsDeclaration)
	            currentOption = options;
	          else if (parentOption === watchOptionsDeclaration)
	            currentOption = watchOptions ?? (watchOptions = {});
	          else if (parentOption === typeAcquisitionDeclaration)
	            currentOption = typeAcquisition ?? (typeAcquisition = getDefaultTypeAcquisition(configFileName));
	          else
	            Debug.fail("Unknown option");
	          currentOption[option.name] = value;
	        } else if (keyText && (parentOption == null ? void 0 : parentOption.extraKeyDiagnostics)) {
	          if (parentOption.elementOptions) {
	            errors.push(createUnknownOptionError(
	              keyText,
	              parentOption.extraKeyDiagnostics,
	              /*unknownOptionErrorText*/
	              void 0,
	              propertyAssignment.name,
	              sourceFile
	            ));
	          } else {
	            errors.push(createDiagnosticForNodeInSourceFile(sourceFile, propertyAssignment.name, parentOption.extraKeyDiagnostics.unknownOptionDiagnostic, keyText));
	          }
	        }
	      } else if (parentOption === rootOptions) {
	        if (option === extendsOptionDeclaration) {
	          extendedConfigPath = getExtendsConfigPathOrArray(value, host, basePath, configFileName, errors, propertyAssignment, propertyAssignment.initializer, sourceFile);
	        } else if (!option) {
	          if (keyText === "excludes") {
	            errors.push(createDiagnosticForNodeInSourceFile(sourceFile, propertyAssignment.name, Diagnostics.Unknown_option_excludes_Did_you_mean_exclude));
	          }
	          if (find(commandOptionsWithoutBuild, (opt) => opt.name === keyText)) {
	            rootCompilerOptions = append(rootCompilerOptions, propertyAssignment.name);
	          }
	        }
	      }
	    }
	  }
	  function getExtendsConfigPath(extendedConfig, host, basePath, errors, valueExpression, sourceFile) {
	    extendedConfig = normalizeSlashes(extendedConfig);
	    if (isRootedDiskPath(extendedConfig) || startsWith(extendedConfig, "./") || startsWith(extendedConfig, "../")) {
	      let extendedConfigPath = getNormalizedAbsolutePath(extendedConfig, basePath);
	      if (!host.fileExists(extendedConfigPath) && !endsWith(extendedConfigPath, ".json" /* Json */)) {
	        extendedConfigPath = `${extendedConfigPath}.json`;
	        if (!host.fileExists(extendedConfigPath)) {
	          errors.push(createDiagnosticForNodeInSourceFileOrCompilerDiagnostic(sourceFile, valueExpression, Diagnostics.File_0_not_found, extendedConfig));
	          return void 0;
	        }
	      }
	      return extendedConfigPath;
	    }
	    const resolved = nodeNextJsonConfigResolver(extendedConfig, combinePaths(basePath, "tsconfig.json"), host);
	    if (resolved.resolvedModule) {
	      return resolved.resolvedModule.resolvedFileName;
	    }
	    if (extendedConfig === "") {
	      errors.push(createDiagnosticForNodeInSourceFileOrCompilerDiagnostic(sourceFile, valueExpression, Diagnostics.Compiler_option_0_cannot_be_given_an_empty_string, "extends"));
	    } else {
	      errors.push(createDiagnosticForNodeInSourceFileOrCompilerDiagnostic(sourceFile, valueExpression, Diagnostics.File_0_not_found, extendedConfig));
	    }
	    return void 0;
	  }
	  function getExtendedConfig(sourceFile, extendedConfigPath, host, resolutionStack, errors, extendedConfigCache, result) {
	    const path = host.useCaseSensitiveFileNames ? extendedConfigPath : toFileNameLowerCase(extendedConfigPath);
	    let value;
	    let extendedResult;
	    let extendedConfig;
	    if (extendedConfigCache && (value = extendedConfigCache.get(path))) {
	      ({ extendedResult, extendedConfig } = value);
	    } else {
	      extendedResult = readJsonConfigFile(extendedConfigPath, (path2) => host.readFile(path2));
	      if (!extendedResult.parseDiagnostics.length) {
	        extendedConfig = parseConfig(
	          /*json*/
	          void 0,
	          extendedResult,
	          host,
	          getDirectoryPath(extendedConfigPath),
	          getBaseFileName(extendedConfigPath),
	          resolutionStack,
	          errors,
	          extendedConfigCache
	        );
	      }
	      if (extendedConfigCache) {
	        extendedConfigCache.set(path, { extendedResult, extendedConfig });
	      }
	    }
	    if (sourceFile) {
	      (result.extendedSourceFiles ?? (result.extendedSourceFiles = /* @__PURE__ */ new Set())).add(extendedResult.fileName);
	      if (extendedResult.extendedSourceFiles) {
	        for (const extenedSourceFile of extendedResult.extendedSourceFiles) {
	          result.extendedSourceFiles.add(extenedSourceFile);
	        }
	      }
	    }
	    if (extendedResult.parseDiagnostics.length) {
	      errors.push(...extendedResult.parseDiagnostics);
	      return void 0;
	    }
	    return extendedConfig;
	  }
	  function convertCompileOnSaveOptionFromJson(jsonOption, basePath, errors) {
	    if (!hasProperty(jsonOption, compileOnSaveCommandLineOption.name)) {
	      return false;
	    }
	    const result = convertJsonOption(compileOnSaveCommandLineOption, jsonOption.compileOnSave, basePath, errors);
	    return typeof result === "boolean" && result;
	  }
	  function convertCompilerOptionsFromJson(jsonOptions, basePath, configFileName) {
	    const errors = [];
	    const options = convertCompilerOptionsFromJsonWorker(jsonOptions, basePath, errors, configFileName);
	    return { options, errors };
	  }
	  function convertTypeAcquisitionFromJson(jsonOptions, basePath, configFileName) {
	    const errors = [];
	    const options = convertTypeAcquisitionFromJsonWorker(jsonOptions, basePath, errors, configFileName);
	    return { options, errors };
	  }
	  function getDefaultCompilerOptions(configFileName) {
	    const options = configFileName && getBaseFileName(configFileName) === "jsconfig.json" ? { allowJs: true, maxNodeModuleJsDepth: 2, allowSyntheticDefaultImports: true, skipLibCheck: true, noEmit: true } : {};
	    return options;
	  }
	  function convertCompilerOptionsFromJsonWorker(jsonOptions, basePath, errors, configFileName) {
	    const options = getDefaultCompilerOptions(configFileName);
	    convertOptionsFromJson(getCommandLineCompilerOptionsMap(), jsonOptions, basePath, options, compilerOptionsDidYouMeanDiagnostics, errors);
	    if (configFileName) {
	      options.configFilePath = normalizeSlashes(configFileName);
	    }
	    return options;
	  }
	  function getDefaultTypeAcquisition(configFileName) {
	    return { enable: !!configFileName && getBaseFileName(configFileName) === "jsconfig.json", include: [], exclude: [] };
	  }
	  function convertTypeAcquisitionFromJsonWorker(jsonOptions, basePath, errors, configFileName) {
	    const options = getDefaultTypeAcquisition(configFileName);
	    convertOptionsFromJson(getCommandLineTypeAcquisitionMap(), jsonOptions, basePath, options, typeAcquisitionDidYouMeanDiagnostics, errors);
	    return options;
	  }
	  function convertWatchOptionsFromJsonWorker(jsonOptions, basePath, errors) {
	    return convertOptionsFromJson(
	      getCommandLineWatchOptionsMap(),
	      jsonOptions,
	      basePath,
	      /*defaultOptions*/
	      void 0,
	      watchOptionsDidYouMeanDiagnostics,
	      errors
	    );
	  }
	  function convertOptionsFromJson(optionsNameMap, jsonOptions, basePath, defaultOptions, diagnostics, errors) {
	    if (!jsonOptions) {
	      return;
	    }
	    for (const id in jsonOptions) {
	      const opt = optionsNameMap.get(id);
	      if (opt) {
	        (defaultOptions || (defaultOptions = {}))[opt.name] = convertJsonOption(opt, jsonOptions[id], basePath, errors);
	      } else {
	        errors.push(createUnknownOptionError(id, diagnostics));
	      }
	    }
	    return defaultOptions;
	  }
	  function createDiagnosticForNodeInSourceFileOrCompilerDiagnostic(sourceFile, node, message, ...args) {
	    return sourceFile && node ? createDiagnosticForNodeInSourceFile(sourceFile, node, message, ...args) : createCompilerDiagnostic(message, ...args);
	  }
	  function convertJsonOption(opt, value, basePath, errors, propertyAssignment, valueExpression, sourceFile) {
	    if (opt.isCommandLineOnly) {
	      errors.push(createDiagnosticForNodeInSourceFileOrCompilerDiagnostic(sourceFile, propertyAssignment == null ? void 0 : propertyAssignment.name, Diagnostics.Option_0_can_only_be_specified_on_command_line, opt.name));
	      return void 0;
	    }
	    if (isCompilerOptionsValue(opt, value)) {
	      const optType = opt.type;
	      if (optType === "list" && isArray(value)) {
	        return convertJsonOptionOfListType(opt, value, basePath, errors, propertyAssignment, valueExpression, sourceFile);
	      } else if (optType === "listOrElement") {
	        return isArray(value) ? convertJsonOptionOfListType(opt, value, basePath, errors, propertyAssignment, valueExpression, sourceFile) : convertJsonOption(opt.element, value, basePath, errors, propertyAssignment, valueExpression, sourceFile);
	      } else if (!isString(opt.type)) {
	        return convertJsonOptionOfCustomType(opt, value, errors, valueExpression, sourceFile);
	      }
	      const validatedValue = validateJsonOptionValue(opt, value, errors, valueExpression, sourceFile);
	      return isNullOrUndefined(validatedValue) ? validatedValue : normalizeNonListOptionValue(opt, basePath, validatedValue);
	    } else {
	      errors.push(createDiagnosticForNodeInSourceFileOrCompilerDiagnostic(sourceFile, valueExpression, Diagnostics.Compiler_option_0_requires_a_value_of_type_1, opt.name, getCompilerOptionValueTypeString(opt)));
	    }
	  }
	  function normalizeNonListOptionValue(option, basePath, value) {
	    if (option.isFilePath) {
	      value = getNormalizedAbsolutePath(value, basePath);
	      if (value === "") {
	        value = ".";
	      }
	    }
	    return value;
	  }
	  function validateJsonOptionValue(opt, value, errors, valueExpression, sourceFile) {
	    var _a;
	    if (isNullOrUndefined(value))
	      return void 0;
	    const d = (_a = opt.extraValidation) == null ? void 0 : _a.call(opt, value);
	    if (!d)
	      return value;
	    errors.push(createDiagnosticForNodeInSourceFileOrCompilerDiagnostic(sourceFile, valueExpression, ...d));
	    return void 0;
	  }
	  function convertJsonOptionOfCustomType(opt, value, errors, valueExpression, sourceFile) {
	    if (isNullOrUndefined(value))
	      return void 0;
	    const key = value.toLowerCase();
	    const val = opt.type.get(key);
	    if (val !== void 0) {
	      return validateJsonOptionValue(opt, val, errors, valueExpression, sourceFile);
	    } else {
	      errors.push(createDiagnosticForInvalidCustomType(opt, (message, ...args) => createDiagnosticForNodeInSourceFileOrCompilerDiagnostic(sourceFile, valueExpression, message, ...args)));
	    }
	  }
	  function convertJsonOptionOfListType(option, values, basePath, errors, propertyAssignment, valueExpression, sourceFile) {
	    return filter(map(values, (v, index) => convertJsonOption(option.element, v, basePath, errors, propertyAssignment, valueExpression == null ? void 0 : valueExpression.elements[index], sourceFile)), (v) => option.listPreserveFalsyValues ? true : !!v);
	  }
	  function getFileNamesFromConfigSpecs(configFileSpecs, basePath, options, host, extraFileExtensions = emptyArray) {
	    basePath = normalizePath(basePath);
	    const keyMapper = createGetCanonicalFileName(host.useCaseSensitiveFileNames);
	    const literalFileMap = /* @__PURE__ */ new Map();
	    const wildcardFileMap = /* @__PURE__ */ new Map();
	    const wildCardJsonFileMap = /* @__PURE__ */ new Map();
	    const { validatedFilesSpec, validatedIncludeSpecs, validatedExcludeSpecs } = configFileSpecs;
	    const supportedExtensions = getSupportedExtensions(options, extraFileExtensions);
	    const supportedExtensionsWithJsonIfResolveJsonModule = getSupportedExtensionsWithJsonIfResolveJsonModule(options, supportedExtensions);
	    if (validatedFilesSpec) {
	      for (const fileName of validatedFilesSpec) {
	        const file = getNormalizedAbsolutePath(fileName, basePath);
	        literalFileMap.set(keyMapper(file), file);
	      }
	    }
	    let jsonOnlyIncludeRegexes;
	    if (validatedIncludeSpecs && validatedIncludeSpecs.length > 0) {
	      for (const file of host.readDirectory(
	        basePath,
	        flatten(supportedExtensionsWithJsonIfResolveJsonModule),
	        validatedExcludeSpecs,
	        validatedIncludeSpecs,
	        /*depth*/
	        void 0
	      )) {
	        if (fileExtensionIs(file, ".json" /* Json */)) {
	          if (!jsonOnlyIncludeRegexes) {
	            const includes = validatedIncludeSpecs.filter((s) => endsWith(s, ".json" /* Json */));
	            const includeFilePatterns = map(getRegularExpressionsForWildcards(includes, basePath, "files"), (pattern) => `^${pattern}$`);
	            jsonOnlyIncludeRegexes = includeFilePatterns ? includeFilePatterns.map((pattern) => getRegexFromPattern(pattern, host.useCaseSensitiveFileNames)) : emptyArray;
	          }
	          const includeIndex = findIndex(jsonOnlyIncludeRegexes, (re) => re.test(file));
	          if (includeIndex !== -1) {
	            const key2 = keyMapper(file);
	            if (!literalFileMap.has(key2) && !wildCardJsonFileMap.has(key2)) {
	              wildCardJsonFileMap.set(key2, file);
	            }
	          }
	          continue;
	        }
	        if (hasFileWithHigherPriorityExtension(file, literalFileMap, wildcardFileMap, supportedExtensions, keyMapper)) {
	          continue;
	        }
	        removeWildcardFilesWithLowerPriorityExtension(file, wildcardFileMap, supportedExtensions, keyMapper);
	        const key = keyMapper(file);
	        if (!literalFileMap.has(key) && !wildcardFileMap.has(key)) {
	          wildcardFileMap.set(key, file);
	        }
	      }
	    }
	    const literalFiles = arrayFrom(literalFileMap.values());
	    const wildcardFiles = arrayFrom(wildcardFileMap.values());
	    return literalFiles.concat(wildcardFiles, arrayFrom(wildCardJsonFileMap.values()));
	  }
	  function isExcludedFile(pathToCheck, spec, basePath, useCaseSensitiveFileNames2, currentDirectory) {
	    const { validatedFilesSpec, validatedIncludeSpecs, validatedExcludeSpecs } = spec;
	    if (!length(validatedIncludeSpecs) || !length(validatedExcludeSpecs))
	      return false;
	    basePath = normalizePath(basePath);
	    const keyMapper = createGetCanonicalFileName(useCaseSensitiveFileNames2);
	    if (validatedFilesSpec) {
	      for (const fileName of validatedFilesSpec) {
	        if (keyMapper(getNormalizedAbsolutePath(fileName, basePath)) === pathToCheck)
	          return false;
	      }
	    }
	    return matchesExcludeWorker(pathToCheck, validatedExcludeSpecs, useCaseSensitiveFileNames2, currentDirectory, basePath);
	  }
	  function invalidDotDotAfterRecursiveWildcard(s) {
	    const wildcardIndex = startsWith(s, "**/") ? 0 : s.indexOf("/**/");
	    if (wildcardIndex === -1) {
	      return false;
	    }
	    const lastDotIndex = endsWith(s, "/..") ? s.length : s.lastIndexOf("/../");
	    return lastDotIndex > wildcardIndex;
	  }
	  function matchesExclude(pathToCheck, excludeSpecs, useCaseSensitiveFileNames2, currentDirectory) {
	    return matchesExcludeWorker(
	      pathToCheck,
	      filter(excludeSpecs, (spec) => !invalidDotDotAfterRecursiveWildcard(spec)),
	      useCaseSensitiveFileNames2,
	      currentDirectory
	    );
	  }
	  function matchesExcludeWorker(pathToCheck, excludeSpecs, useCaseSensitiveFileNames2, currentDirectory, basePath) {
	    const excludePattern = getRegularExpressionForWildcard(excludeSpecs, combinePaths(normalizePath(currentDirectory), basePath), "exclude");
	    const excludeRegex = excludePattern && getRegexFromPattern(excludePattern, useCaseSensitiveFileNames2);
	    if (!excludeRegex)
	      return false;
	    if (excludeRegex.test(pathToCheck))
	      return true;
	    return !hasExtension(pathToCheck) && excludeRegex.test(ensureTrailingDirectorySeparator(pathToCheck));
	  }
	  function validateSpecs(specs, errors, disallowTrailingRecursion, jsonSourceFile, specKey) {
	    return specs.filter((spec) => {
	      if (!isString(spec))
	        return false;
	      const diag2 = specToDiagnostic(spec, disallowTrailingRecursion);
	      if (diag2 !== void 0) {
	        errors.push(createDiagnostic(...diag2));
	      }
	      return diag2 === void 0;
	    });
	    function createDiagnostic(message, spec) {
	      const element = getTsConfigPropArrayElementValue(jsonSourceFile, specKey, spec);
	      return createDiagnosticForNodeInSourceFileOrCompilerDiagnostic(jsonSourceFile, element, message, spec);
	    }
	  }
	  function specToDiagnostic(spec, disallowTrailingRecursion) {
	    Debug.assert(typeof spec === "string");
	    if (disallowTrailingRecursion && invalidTrailingRecursionPattern.test(spec)) {
	      return [Diagnostics.File_specification_cannot_end_in_a_recursive_directory_wildcard_Asterisk_Asterisk_Colon_0, spec];
	    } else if (invalidDotDotAfterRecursiveWildcard(spec)) {
	      return [Diagnostics.File_specification_cannot_contain_a_parent_directory_that_appears_after_a_recursive_directory_wildcard_Asterisk_Asterisk_Colon_0, spec];
	    }
	  }
	  function getWildcardDirectories({ validatedIncludeSpecs: include, validatedExcludeSpecs: exclude }, basePath, useCaseSensitiveFileNames2) {
	    const rawExcludeRegex = getRegularExpressionForWildcard(exclude, basePath, "exclude");
	    const excludeRegex = rawExcludeRegex && new RegExp(rawExcludeRegex, useCaseSensitiveFileNames2 ? "" : "i");
	    const wildcardDirectories = {};
	    const wildCardKeyToPath = /* @__PURE__ */ new Map();
	    if (include !== void 0) {
	      const recursiveKeys = [];
	      for (const file of include) {
	        const spec = normalizePath(combinePaths(basePath, file));
	        if (excludeRegex && excludeRegex.test(spec)) {
	          continue;
	        }
	        const match = getWildcardDirectoryFromSpec(spec, useCaseSensitiveFileNames2);
	        if (match) {
	          const { key, path, flags } = match;
	          const existingPath = wildCardKeyToPath.get(key);
	          const existingFlags = existingPath !== void 0 ? wildcardDirectories[existingPath] : void 0;
	          if (existingFlags === void 0 || existingFlags < flags) {
	            wildcardDirectories[existingPath !== void 0 ? existingPath : path] = flags;
	            if (existingPath === void 0)
	              wildCardKeyToPath.set(key, path);
	            if (flags === 1 /* Recursive */) {
	              recursiveKeys.push(key);
	            }
	          }
	        }
	      }
	      for (const path in wildcardDirectories) {
	        if (hasProperty(wildcardDirectories, path)) {
	          for (const recursiveKey of recursiveKeys) {
	            const key = toCanonicalKey(path, useCaseSensitiveFileNames2);
	            if (key !== recursiveKey && containsPath(recursiveKey, key, basePath, !useCaseSensitiveFileNames2)) {
	              delete wildcardDirectories[path];
	            }
	          }
	        }
	      }
	    }
	    return wildcardDirectories;
	  }
	  function toCanonicalKey(path, useCaseSensitiveFileNames2) {
	    return useCaseSensitiveFileNames2 ? path : toFileNameLowerCase(path);
	  }
	  function getWildcardDirectoryFromSpec(spec, useCaseSensitiveFileNames2) {
	    const match = wildcardDirectoryPattern.exec(spec);
	    if (match) {
	      const questionWildcardIndex = spec.indexOf("?");
	      const starWildcardIndex = spec.indexOf("*");
	      const lastDirectorySeperatorIndex = spec.lastIndexOf(directorySeparator);
	      return {
	        key: toCanonicalKey(match[0], useCaseSensitiveFileNames2),
	        path: match[0],
	        flags: questionWildcardIndex !== -1 && questionWildcardIndex < lastDirectorySeperatorIndex || starWildcardIndex !== -1 && starWildcardIndex < lastDirectorySeperatorIndex ? 1 /* Recursive */ : 0 /* None */
	      };
	    }
	    if (isImplicitGlob(spec.substring(spec.lastIndexOf(directorySeparator) + 1))) {
	      const path = removeTrailingDirectorySeparator(spec);
	      return {
	        key: toCanonicalKey(path, useCaseSensitiveFileNames2),
	        path,
	        flags: 1 /* Recursive */
	      };
	    }
	    return void 0;
	  }
	  function hasFileWithHigherPriorityExtension(file, literalFiles, wildcardFiles, extensions, keyMapper) {
	    const extensionGroup = forEach(extensions, (group2) => fileExtensionIsOneOf(file, group2) ? group2 : void 0);
	    if (!extensionGroup) {
	      return false;
	    }
	    for (const ext of extensionGroup) {
	      if (fileExtensionIs(file, ext) && (ext !== ".ts" /* Ts */ || !fileExtensionIs(file, ".d.ts" /* Dts */))) {
	        return false;
	      }
	      const higherPriorityPath = keyMapper(changeExtension(file, ext));
	      if (literalFiles.has(higherPriorityPath) || wildcardFiles.has(higherPriorityPath)) {
	        if (ext === ".d.ts" /* Dts */ && (fileExtensionIs(file, ".js" /* Js */) || fileExtensionIs(file, ".jsx" /* Jsx */))) {
	          continue;
	        }
	        return true;
	      }
	    }
	    return false;
	  }
	  function removeWildcardFilesWithLowerPriorityExtension(file, wildcardFiles, extensions, keyMapper) {
	    const extensionGroup = forEach(extensions, (group2) => fileExtensionIsOneOf(file, group2) ? group2 : void 0);
	    if (!extensionGroup) {
	      return;
	    }
	    for (let i = extensionGroup.length - 1; i >= 0; i--) {
	      const ext = extensionGroup[i];
	      if (fileExtensionIs(file, ext)) {
	        return;
	      }
	      const lowerPriorityPath = keyMapper(changeExtension(file, ext));
	      wildcardFiles.delete(lowerPriorityPath);
	    }
	  }
	  function convertCompilerOptionsForTelemetry(opts) {
	    const out = {};
	    for (const key in opts) {
	      if (hasProperty(opts, key)) {
	        const type = getOptionFromName(key);
	        if (type !== void 0) {
	          out[key] = getOptionValueWithEmptyStrings(opts[key], type);
	        }
	      }
	    }
	    return out;
	  }
	  function getOptionValueWithEmptyStrings(value, option) {
	    if (value === void 0)
	      return value;
	    switch (option.type) {
	      case "object":
	        return "";
	      case "string":
	        return "";
	      case "number":
	        return typeof value === "number" ? value : "";
	      case "boolean":
	        return typeof value === "boolean" ? value : "";
	      case "listOrElement":
	        if (!isArray(value))
	          return getOptionValueWithEmptyStrings(value, option.element);
	      case "list":
	        const elementType = option.element;
	        return isArray(value) ? mapDefined(value, (v) => getOptionValueWithEmptyStrings(v, elementType)) : "";
	      default:
	        return forEachEntry(option.type, (optionEnumValue, optionStringValue) => {
	          if (optionEnumValue === value) {
	            return optionStringValue;
	          }
	        });
	    }
	  }
	  function getDefaultValueForOption(option) {
	    switch (option.type) {
	      case "number":
	        return 1;
	      case "boolean":
	        return true;
	      case "string":
	        const defaultValue = option.defaultValueDescription;
	        return option.isFilePath ? `./${defaultValue && typeof defaultValue === "string" ? defaultValue : ""}` : "";
	      case "list":
	        return [];
	      case "listOrElement":
	        return getDefaultValueForOption(option.element);
	      case "object":
	        return {};
	      default:
	        const value = firstOrUndefinedIterator(option.type.keys());
	        if (value !== void 0)
	          return value;
	        return Debug.fail("Expected 'option.type' to have entries.");
	    }
	  }
	  var compileOnSaveCommandLineOption, jsxOptionMap, inverseJsxOptionMap, libEntries, libs, libMap, optionsForWatch, commonOptionsWithBuild, targetOptionDeclaration, moduleOptionDeclaration, commandOptionsWithoutBuild, optionDeclarations, semanticDiagnosticsOptionDeclarations, affectsEmitOptionDeclarations, affectsDeclarationPathOptionDeclarations, moduleResolutionOptionDeclarations, sourceFileAffectingCompilerOptions, optionsAffectingProgramStructure, transpileOptionValueCompilerOptions, optionsForBuild, buildOpts, typeAcquisitionDeclarations, optionsNameMapCache, compilerOptionsAlternateMode, defaultInitCompilerOptions, compilerOptionsDidYouMeanDiagnostics, buildOptionsNameMapCache, buildOptionsAlternateMode, buildOptionsDidYouMeanDiagnostics, typeAcquisitionDidYouMeanDiagnostics, watchOptionsNameMapCache, watchOptionsDidYouMeanDiagnostics, commandLineCompilerOptionsMapCache, commandLineWatchOptionsMapCache, commandLineTypeAcquisitionMapCache, extendsOptionDeclaration, compilerOptionsDeclaration, watchOptionsDeclaration, typeAcquisitionDeclaration, _tsconfigRootOptions, defaultIncludeSpec, invalidTrailingRecursionPattern, wildcardDirectoryPattern;
	  var init_commandLineParser = __esm({
	    "src/compiler/commandLineParser.ts"() {
	      init_ts2();
	      compileOnSaveCommandLineOption = {
	        name: "compileOnSave",
	        type: "boolean",
	        defaultValueDescription: false
	      };
	      jsxOptionMap = new Map(Object.entries({
	        "preserve": 1 /* Preserve */,
	        "react-native": 3 /* ReactNative */,
	        "react": 2 /* React */,
	        "react-jsx": 4 /* ReactJSX */,
	        "react-jsxdev": 5 /* ReactJSXDev */
	      }));
	      inverseJsxOptionMap = new Map(mapIterator(jsxOptionMap.entries(), ([key, value]) => ["" + value, key]));
	      libEntries = [
	        // JavaScript only
	        ["es5", "lib.es5.d.ts"],
	        ["es6", "lib.es2015.d.ts"],
	        ["es2015", "lib.es2015.d.ts"],
	        ["es7", "lib.es2016.d.ts"],
	        ["es2016", "lib.es2016.d.ts"],
	        ["es2017", "lib.es2017.d.ts"],
	        ["es2018", "lib.es2018.d.ts"],
	        ["es2019", "lib.es2019.d.ts"],
	        ["es2020", "lib.es2020.d.ts"],
	        ["es2021", "lib.es2021.d.ts"],
	        ["es2022", "lib.es2022.d.ts"],
	        ["es2023", "lib.es2023.d.ts"],
	        ["esnext", "lib.esnext.d.ts"],
	        // Host only
	        ["dom", "lib.dom.d.ts"],
	        ["dom.iterable", "lib.dom.iterable.d.ts"],
	        ["dom.asynciterable", "lib.dom.asynciterable.d.ts"],
	        ["webworker", "lib.webworker.d.ts"],
	        ["webworker.importscripts", "lib.webworker.importscripts.d.ts"],
	        ["webworker.iterable", "lib.webworker.iterable.d.ts"],
	        ["webworker.asynciterable", "lib.webworker.asynciterable.d.ts"],
	        ["scripthost", "lib.scripthost.d.ts"],
	        // ES2015 Or ESNext By-feature options
	        ["es2015.core", "lib.es2015.core.d.ts"],
	        ["es2015.collection", "lib.es2015.collection.d.ts"],
	        ["es2015.generator", "lib.es2015.generator.d.ts"],
	        ["es2015.iterable", "lib.es2015.iterable.d.ts"],
	        ["es2015.promise", "lib.es2015.promise.d.ts"],
	        ["es2015.proxy", "lib.es2015.proxy.d.ts"],
	        ["es2015.reflect", "lib.es2015.reflect.d.ts"],
	        ["es2015.symbol", "lib.es2015.symbol.d.ts"],
	        ["es2015.symbol.wellknown", "lib.es2015.symbol.wellknown.d.ts"],
	        ["es2016.array.include", "lib.es2016.array.include.d.ts"],
	        ["es2016.intl", "lib.es2016.intl.d.ts"],
	        ["es2017.date", "lib.es2017.date.d.ts"],
	        ["es2017.object", "lib.es2017.object.d.ts"],
	        ["es2017.sharedmemory", "lib.es2017.sharedmemory.d.ts"],
	        ["es2017.string", "lib.es2017.string.d.ts"],
	        ["es2017.intl", "lib.es2017.intl.d.ts"],
	        ["es2017.typedarrays", "lib.es2017.typedarrays.d.ts"],
	        ["es2018.asyncgenerator", "lib.es2018.asyncgenerator.d.ts"],
	        ["es2018.asynciterable", "lib.es2018.asynciterable.d.ts"],
	        ["es2018.intl", "lib.es2018.intl.d.ts"],
	        ["es2018.promise", "lib.es2018.promise.d.ts"],
	        ["es2018.regexp", "lib.es2018.regexp.d.ts"],
	        ["es2019.array", "lib.es2019.array.d.ts"],
	        ["es2019.object", "lib.es2019.object.d.ts"],
	        ["es2019.string", "lib.es2019.string.d.ts"],
	        ["es2019.symbol", "lib.es2019.symbol.d.ts"],
	        ["es2019.intl", "lib.es2019.intl.d.ts"],
	        ["es2020.bigint", "lib.es2020.bigint.d.ts"],
	        ["es2020.date", "lib.es2020.date.d.ts"],
	        ["es2020.promise", "lib.es2020.promise.d.ts"],
	        ["es2020.sharedmemory", "lib.es2020.sharedmemory.d.ts"],
	        ["es2020.string", "lib.es2020.string.d.ts"],
	        ["es2020.symbol.wellknown", "lib.es2020.symbol.wellknown.d.ts"],
	        ["es2020.intl", "lib.es2020.intl.d.ts"],
	        ["es2020.number", "lib.es2020.number.d.ts"],
	        ["es2021.promise", "lib.es2021.promise.d.ts"],
	        ["es2021.string", "lib.es2021.string.d.ts"],
	        ["es2021.weakref", "lib.es2021.weakref.d.ts"],
	        ["es2021.intl", "lib.es2021.intl.d.ts"],
	        ["es2022.array", "lib.es2022.array.d.ts"],
	        ["es2022.error", "lib.es2022.error.d.ts"],
	        ["es2022.intl", "lib.es2022.intl.d.ts"],
	        ["es2022.object", "lib.es2022.object.d.ts"],
	        ["es2022.sharedmemory", "lib.es2022.sharedmemory.d.ts"],
	        ["es2022.string", "lib.es2022.string.d.ts"],
	        ["es2022.regexp", "lib.es2022.regexp.d.ts"],
	        ["es2023.array", "lib.es2023.array.d.ts"],
	        ["es2023.collection", "lib.es2023.collection.d.ts"],
	        ["esnext.array", "lib.es2023.array.d.ts"],
	        ["esnext.collection", "lib.esnext.collection.d.ts"],
	        ["esnext.symbol", "lib.es2019.symbol.d.ts"],
	        ["esnext.asynciterable", "lib.es2018.asynciterable.d.ts"],
	        ["esnext.intl", "lib.esnext.intl.d.ts"],
	        ["esnext.disposable", "lib.esnext.disposable.d.ts"],
	        ["esnext.bigint", "lib.es2020.bigint.d.ts"],
	        ["esnext.string", "lib.es2022.string.d.ts"],
	        ["esnext.promise", "lib.esnext.promise.d.ts"],
	        ["esnext.weakref", "lib.es2021.weakref.d.ts"],
	        ["esnext.decorators", "lib.esnext.decorators.d.ts"],
	        ["esnext.object", "lib.esnext.object.d.ts"],
	        ["decorators", "lib.decorators.d.ts"],
	        ["decorators.legacy", "lib.decorators.legacy.d.ts"]
	      ];
	      libs = libEntries.map((entry) => entry[0]);
	      libMap = new Map(libEntries);
	      optionsForWatch = [
	        {
	          name: "watchFile",
	          type: new Map(Object.entries({
	            fixedpollinginterval: 0 /* FixedPollingInterval */,
	            prioritypollinginterval: 1 /* PriorityPollingInterval */,
	            dynamicprioritypolling: 2 /* DynamicPriorityPolling */,
	            fixedchunksizepolling: 3 /* FixedChunkSizePolling */,
	            usefsevents: 4 /* UseFsEvents */,
	            usefseventsonparentdirectory: 5 /* UseFsEventsOnParentDirectory */
	          })),
	          category: Diagnostics.Watch_and_Build_Modes,
	          description: Diagnostics.Specify_how_the_TypeScript_watch_mode_works,
	          defaultValueDescription: 4 /* UseFsEvents */
	        },
	        {
	          name: "watchDirectory",
	          type: new Map(Object.entries({
	            usefsevents: 0 /* UseFsEvents */,
	            fixedpollinginterval: 1 /* FixedPollingInterval */,
	            dynamicprioritypolling: 2 /* DynamicPriorityPolling */,
	            fixedchunksizepolling: 3 /* FixedChunkSizePolling */
	          })),
	          category: Diagnostics.Watch_and_Build_Modes,
	          description: Diagnostics.Specify_how_directories_are_watched_on_systems_that_lack_recursive_file_watching_functionality,
	          defaultValueDescription: 0 /* UseFsEvents */
	        },
	        {
	          name: "fallbackPolling",
	          type: new Map(Object.entries({
	            fixedinterval: 0 /* FixedInterval */,
	            priorityinterval: 1 /* PriorityInterval */,
	            dynamicpriority: 2 /* DynamicPriority */,
	            fixedchunksize: 3 /* FixedChunkSize */
	          })),
	          category: Diagnostics.Watch_and_Build_Modes,
	          description: Diagnostics.Specify_what_approach_the_watcher_should_use_if_the_system_runs_out_of_native_file_watchers,
	          defaultValueDescription: 1 /* PriorityInterval */
	        },
	        {
	          name: "synchronousWatchDirectory",
	          type: "boolean",
	          category: Diagnostics.Watch_and_Build_Modes,
	          description: Diagnostics.Synchronously_call_callbacks_and_update_the_state_of_directory_watchers_on_platforms_that_don_t_support_recursive_watching_natively,
	          defaultValueDescription: false
	        },
	        {
	          name: "excludeDirectories",
	          type: "list",
	          element: {
	            name: "excludeDirectory",
	            type: "string",
	            isFilePath: true,
	            extraValidation: specToDiagnostic
	          },
	          category: Diagnostics.Watch_and_Build_Modes,
	          description: Diagnostics.Remove_a_list_of_directories_from_the_watch_process
	        },
	        {
	          name: "excludeFiles",
	          type: "list",
	          element: {
	            name: "excludeFile",
	            type: "string",
	            isFilePath: true,
	            extraValidation: specToDiagnostic
	          },
	          category: Diagnostics.Watch_and_Build_Modes,
	          description: Diagnostics.Remove_a_list_of_files_from_the_watch_mode_s_processing
	        }
	      ];
	      commonOptionsWithBuild = [
	        {
	          name: "help",
	          shortName: "h",
	          type: "boolean",
	          showInSimplifiedHelpView: true,
	          isCommandLineOnly: true,
	          category: Diagnostics.Command_line_Options,
	          description: Diagnostics.Print_this_message,
	          defaultValueDescription: false
	        },
	        {
	          name: "help",
	          shortName: "?",
	          type: "boolean",
	          isCommandLineOnly: true,
	          category: Diagnostics.Command_line_Options,
	          defaultValueDescription: false
	        },
	        {
	          name: "watch",
	          shortName: "w",
	          type: "boolean",
	          showInSimplifiedHelpView: true,
	          isCommandLineOnly: true,
	          category: Diagnostics.Command_line_Options,
	          description: Diagnostics.Watch_input_files,
	          defaultValueDescription: false
	        },
	        {
	          name: "preserveWatchOutput",
	          type: "boolean",
	          showInSimplifiedHelpView: false,
	          category: Diagnostics.Output_Formatting,
	          description: Diagnostics.Disable_wiping_the_console_in_watch_mode,
	          defaultValueDescription: false
	        },
	        {
	          name: "listFiles",
	          type: "boolean",
	          category: Diagnostics.Compiler_Diagnostics,
	          description: Diagnostics.Print_all_of_the_files_read_during_the_compilation,
	          defaultValueDescription: false
	        },
	        {
	          name: "explainFiles",
	          type: "boolean",
	          category: Diagnostics.Compiler_Diagnostics,
	          description: Diagnostics.Print_files_read_during_the_compilation_including_why_it_was_included,
	          defaultValueDescription: false
	        },
	        {
	          name: "listEmittedFiles",
	          type: "boolean",
	          category: Diagnostics.Compiler_Diagnostics,
	          description: Diagnostics.Print_the_names_of_emitted_files_after_a_compilation,
	          defaultValueDescription: false
	        },
	        {
	          name: "pretty",
	          type: "boolean",
	          showInSimplifiedHelpView: true,
	          category: Diagnostics.Output_Formatting,
	          description: Diagnostics.Enable_color_and_formatting_in_TypeScript_s_output_to_make_compiler_errors_easier_to_read,
	          defaultValueDescription: true
	        },
	        {
	          name: "traceResolution",
	          type: "boolean",
	          category: Diagnostics.Compiler_Diagnostics,
	          description: Diagnostics.Log_paths_used_during_the_moduleResolution_process,
	          defaultValueDescription: false
	        },
	        {
	          name: "diagnostics",
	          type: "boolean",
	          category: Diagnostics.Compiler_Diagnostics,
	          description: Diagnostics.Output_compiler_performance_information_after_building,
	          defaultValueDescription: false
	        },
	        {
	          name: "extendedDiagnostics",
	          type: "boolean",
	          category: Diagnostics.Compiler_Diagnostics,
	          description: Diagnostics.Output_more_detailed_compiler_performance_information_after_building,
	          defaultValueDescription: false
	        },
	        {
	          name: "generateCpuProfile",
	          type: "string",
	          isFilePath: true,
	          paramType: Diagnostics.FILE_OR_DIRECTORY,
	          category: Diagnostics.Compiler_Diagnostics,
	          description: Diagnostics.Emit_a_v8_CPU_profile_of_the_compiler_run_for_debugging,
	          defaultValueDescription: "profile.cpuprofile"
	        },
	        {
	          name: "generateTrace",
	          type: "string",
	          isFilePath: true,
	          isCommandLineOnly: true,
	          paramType: Diagnostics.DIRECTORY,
	          category: Diagnostics.Compiler_Diagnostics,
	          description: Diagnostics.Generates_an_event_trace_and_a_list_of_types
	        },
	        {
	          name: "incremental",
	          shortName: "i",
	          type: "boolean",
	          category: Diagnostics.Projects,
	          description: Diagnostics.Save_tsbuildinfo_files_to_allow_for_incremental_compilation_of_projects,
	          transpileOptionValue: void 0,
	          defaultValueDescription: Diagnostics.false_unless_composite_is_set
	        },
	        {
	          name: "declaration",
	          shortName: "d",
	          type: "boolean",
	          // Not setting affectsEmit because we calculate this flag might not affect full emit
	          affectsBuildInfo: true,
	          showInSimplifiedHelpView: true,
	          category: Diagnostics.Emit,
	          transpileOptionValue: void 0,
	          description: Diagnostics.Generate_d_ts_files_from_TypeScript_and_JavaScript_files_in_your_project,
	          defaultValueDescription: Diagnostics.false_unless_composite_is_set
	        },
	        {
	          name: "declarationMap",
	          type: "boolean",
	          // Not setting affectsEmit because we calculate this flag might not affect full emit
	          affectsBuildInfo: true,
	          showInSimplifiedHelpView: true,
	          category: Diagnostics.Emit,
	          transpileOptionValue: void 0,
	          defaultValueDescription: false,
	          description: Diagnostics.Create_sourcemaps_for_d_ts_files
	        },
	        {
	          name: "emitDeclarationOnly",
	          type: "boolean",
	          // Not setting affectsEmit because we calculate this flag might not affect full emit
	          affectsBuildInfo: true,
	          showInSimplifiedHelpView: true,
	          category: Diagnostics.Emit,
	          description: Diagnostics.Only_output_d_ts_files_and_not_JavaScript_files,
	          transpileOptionValue: void 0,
	          defaultValueDescription: false
	        },
	        {
	          name: "sourceMap",
	          type: "boolean",
	          // Not setting affectsEmit because we calculate this flag might not affect full emit
	          affectsBuildInfo: true,
	          showInSimplifiedHelpView: true,
	          category: Diagnostics.Emit,
	          defaultValueDescription: false,
	          description: Diagnostics.Create_source_map_files_for_emitted_JavaScript_files
	        },
	        {
	          name: "inlineSourceMap",
	          type: "boolean",
	          // Not setting affectsEmit because we calculate this flag might not affect full emit
	          affectsBuildInfo: true,
	          category: Diagnostics.Emit,
	          description: Diagnostics.Include_sourcemap_files_inside_the_emitted_JavaScript,
	          defaultValueDescription: false
	        },
	        {
	          name: "assumeChangesOnlyAffectDirectDependencies",
	          type: "boolean",
	          affectsSemanticDiagnostics: true,
	          affectsEmit: true,
	          affectsBuildInfo: true,
	          category: Diagnostics.Watch_and_Build_Modes,
	          description: Diagnostics.Have_recompiles_in_projects_that_use_incremental_and_watch_mode_assume_that_changes_within_a_file_will_only_affect_files_directly_depending_on_it,
	          defaultValueDescription: false
	        },
	        {
	          name: "locale",
	          type: "string",
	          category: Diagnostics.Command_line_Options,
	          isCommandLineOnly: true,
	          description: Diagnostics.Set_the_language_of_the_messaging_from_TypeScript_This_does_not_affect_emit,
	          defaultValueDescription: Diagnostics.Platform_specific
	        }
	      ];
	      targetOptionDeclaration = {
	        name: "target",
	        shortName: "t",
	        type: new Map(Object.entries({
	          es3: 0 /* ES3 */,
	          es5: 1 /* ES5 */,
	          es6: 2 /* ES2015 */,
	          es2015: 2 /* ES2015 */,
	          es2016: 3 /* ES2016 */,
	          es2017: 4 /* ES2017 */,
	          es2018: 5 /* ES2018 */,
	          es2019: 6 /* ES2019 */,
	          es2020: 7 /* ES2020 */,
	          es2021: 8 /* ES2021 */,
	          es2022: 9 /* ES2022 */,
	          esnext: 99 /* ESNext */
	        })),
	        affectsSourceFile: true,
	        affectsModuleResolution: true,
	        affectsEmit: true,
	        affectsBuildInfo: true,
	        deprecatedKeys: /* @__PURE__ */ new Set(["es3"]),
	        paramType: Diagnostics.VERSION,
	        showInSimplifiedHelpView: true,
	        category: Diagnostics.Language_and_Environment,
	        description: Diagnostics.Set_the_JavaScript_language_version_for_emitted_JavaScript_and_include_compatible_library_declarations,
	        defaultValueDescription: 1 /* ES5 */
	      };
	      moduleOptionDeclaration = {
	        name: "module",
	        shortName: "m",
	        type: new Map(Object.entries({
	          none: 0 /* None */,
	          commonjs: 1 /* CommonJS */,
	          amd: 2 /* AMD */,
	          system: 4 /* System */,
	          umd: 3 /* UMD */,
	          es6: 5 /* ES2015 */,
	          es2015: 5 /* ES2015 */,
	          es2020: 6 /* ES2020 */,
	          es2022: 7 /* ES2022 */,
	          esnext: 99 /* ESNext */,
	          node16: 100 /* Node16 */,
	          nodenext: 199 /* NodeNext */,
	          preserve: 200 /* Preserve */
	        })),
	        affectsSourceFile: true,
	        affectsModuleResolution: true,
	        affectsEmit: true,
	        affectsBuildInfo: true,
	        paramType: Diagnostics.KIND,
	        showInSimplifiedHelpView: true,
	        category: Diagnostics.Modules,
	        description: Diagnostics.Specify_what_module_code_is_generated,
	        defaultValueDescription: void 0
	      };
	      commandOptionsWithoutBuild = [
	        // CommandLine only options
	        {
	          name: "all",
	          type: "boolean",
	          showInSimplifiedHelpView: true,
	          category: Diagnostics.Command_line_Options,
	          description: Diagnostics.Show_all_compiler_options,
	          defaultValueDescription: false
	        },
	        {
	          name: "version",
	          shortName: "v",
	          type: "boolean",
	          showInSimplifiedHelpView: true,
	          category: Diagnostics.Command_line_Options,
	          description: Diagnostics.Print_the_compiler_s_version,
	          defaultValueDescription: false
	        },
	        {
	          name: "init",
	          type: "boolean",
	          showInSimplifiedHelpView: true,
	          category: Diagnostics.Command_line_Options,
	          description: Diagnostics.Initializes_a_TypeScript_project_and_creates_a_tsconfig_json_file,
	          defaultValueDescription: false
	        },
	        {
	          name: "project",
	          shortName: "p",
	          type: "string",
	          isFilePath: true,
	          showInSimplifiedHelpView: true,
	          category: Diagnostics.Command_line_Options,
	          paramType: Diagnostics.FILE_OR_DIRECTORY,
	          description: Diagnostics.Compile_the_project_given_the_path_to_its_configuration_file_or_to_a_folder_with_a_tsconfig_json
	        },
	        {
	          name: "build",
	          type: "boolean",
	          shortName: "b",
	          showInSimplifiedHelpView: true,
	          category: Diagnostics.Command_line_Options,
	          description: Diagnostics.Build_one_or_more_projects_and_their_dependencies_if_out_of_date,
	          defaultValueDescription: false
	        },
	        {
	          name: "showConfig",
	          type: "boolean",
	          showInSimplifiedHelpView: true,
	          category: Diagnostics.Command_line_Options,
	          isCommandLineOnly: true,
	          description: Diagnostics.Print_the_final_configuration_instead_of_building,
	          defaultValueDescription: false
	        },
	        {
	          name: "listFilesOnly",
	          type: "boolean",
	          category: Diagnostics.Command_line_Options,
	          isCommandLineOnly: true,
	          description: Diagnostics.Print_names_of_files_that_are_part_of_the_compilation_and_then_stop_processing,
	          defaultValueDescription: false
	        },
	        // Basic
	        targetOptionDeclaration,
	        moduleOptionDeclaration,
	        {
	          name: "lib",
	          type: "list",
	          element: {
	            name: "lib",
	            type: libMap,
	            defaultValueDescription: void 0
	          },
	          affectsProgramStructure: true,
	          showInSimplifiedHelpView: true,
	          category: Diagnostics.Language_and_Environment,
	          description: Diagnostics.Specify_a_set_of_bundled_library_declaration_files_that_describe_the_target_runtime_environment,
	          transpileOptionValue: void 0
	        },
	        {
	          name: "allowJs",
	          type: "boolean",
	          allowJsFlag: true,
	          affectsBuildInfo: true,
	          showInSimplifiedHelpView: true,
	          category: Diagnostics.JavaScript_Support,
	          description: Diagnostics.Allow_JavaScript_files_to_be_a_part_of_your_program_Use_the_checkJS_option_to_get_errors_from_these_files,
	          defaultValueDescription: false
	        },
	        {
	          name: "checkJs",
	          type: "boolean",
	          affectsModuleResolution: true,
	          affectsSemanticDiagnostics: true,
	          affectsBuildInfo: true,
	          showInSimplifiedHelpView: true,
	          category: Diagnostics.JavaScript_Support,
	          description: Diagnostics.Enable_error_reporting_in_type_checked_JavaScript_files,
	          defaultValueDescription: false
	        },
	        {
	          name: "jsx",
	          type: jsxOptionMap,
	          affectsSourceFile: true,
	          affectsEmit: true,
	          affectsBuildInfo: true,
	          affectsModuleResolution: true,
	          // The checker emits an error when it sees JSX but this option is not set in compilerOptions.
	          // This is effectively a semantic error, so mark this option as affecting semantic diagnostics
	          // so we know to refresh errors when this option is changed.
	          affectsSemanticDiagnostics: true,
	          paramType: Diagnostics.KIND,
	          showInSimplifiedHelpView: true,
	          category: Diagnostics.Language_and_Environment,
	          description: Diagnostics.Specify_what_JSX_code_is_generated,
	          defaultValueDescription: void 0
	        },
	        {
	          name: "outFile",
	          type: "string",
	          affectsEmit: true,
	          affectsBuildInfo: true,
	          affectsDeclarationPath: true,
	          isFilePath: true,
	          paramType: Diagnostics.FILE,
	          showInSimplifiedHelpView: true,
	          category: Diagnostics.Emit,
	          description: Diagnostics.Specify_a_file_that_bundles_all_outputs_into_one_JavaScript_file_If_declaration_is_true_also_designates_a_file_that_bundles_all_d_ts_output,
	          transpileOptionValue: void 0
	        },
	        {
	          name: "outDir",
	          type: "string",
	          affectsEmit: true,
	          affectsBuildInfo: true,
	          affectsDeclarationPath: true,
	          isFilePath: true,
	          paramType: Diagnostics.DIRECTORY,
	          showInSimplifiedHelpView: true,
	          category: Diagnostics.Emit,
	          description: Diagnostics.Specify_an_output_folder_for_all_emitted_files
	        },
	        {
	          name: "rootDir",
	          type: "string",
	          affectsEmit: true,
	          affectsBuildInfo: true,
	          affectsDeclarationPath: true,
	          isFilePath: true,
	          paramType: Diagnostics.LOCATION,
	          category: Diagnostics.Modules,
	          description: Diagnostics.Specify_the_root_folder_within_your_source_files,
	          defaultValueDescription: Diagnostics.Computed_from_the_list_of_input_files
	        },
	        {
	          name: "composite",
	          type: "boolean",
	          // Not setting affectsEmit because we calculate this flag might not affect full emit
	          affectsBuildInfo: true,
	          isTSConfigOnly: true,
	          category: Diagnostics.Projects,
	          transpileOptionValue: void 0,
	          defaultValueDescription: false,
	          description: Diagnostics.Enable_constraints_that_allow_a_TypeScript_project_to_be_used_with_project_references
	        },
	        {
	          name: "tsBuildInfoFile",
	          type: "string",
	          affectsEmit: true,
	          affectsBuildInfo: true,
	          isFilePath: true,
	          paramType: Diagnostics.FILE,
	          category: Diagnostics.Projects,
	          transpileOptionValue: void 0,
	          defaultValueDescription: ".tsbuildinfo",
	          description: Diagnostics.Specify_the_path_to_tsbuildinfo_incremental_compilation_file
	        },
	        {
	          name: "removeComments",
	          type: "boolean",
	          affectsEmit: true,
	          affectsBuildInfo: true,
	          showInSimplifiedHelpView: true,
	          category: Diagnostics.Emit,
	          defaultValueDescription: false,
	          description: Diagnostics.Disable_emitting_comments
	        },
	        {
	          name: "noEmit",
	          type: "boolean",
	          showInSimplifiedHelpView: true,
	          category: Diagnostics.Emit,
	          description: Diagnostics.Disable_emitting_files_from_a_compilation,
	          transpileOptionValue: void 0,
	          defaultValueDescription: false
	        },
	        {
	          name: "importHelpers",
	          type: "boolean",
	          affectsEmit: true,
	          affectsBuildInfo: true,
	          category: Diagnostics.Emit,
	          description: Diagnostics.Allow_importing_helper_functions_from_tslib_once_per_project_instead_of_including_them_per_file,
	          defaultValueDescription: false
	        },
	        {
	          name: "importsNotUsedAsValues",
	          type: new Map(Object.entries({
	            remove: 0 /* Remove */,
	            preserve: 1 /* Preserve */,
	            error: 2 /* Error */
	          })),
	          affectsEmit: true,
	          affectsSemanticDiagnostics: true,
	          affectsBuildInfo: true,
	          category: Diagnostics.Emit,
	          description: Diagnostics.Specify_emit_Slashchecking_behavior_for_imports_that_are_only_used_for_types,
	          defaultValueDescription: 0 /* Remove */
	        },
	        {
	          name: "downlevelIteration",
	          type: "boolean",
	          affectsEmit: true,
	          affectsBuildInfo: true,
	          category: Diagnostics.Emit,
	          description: Diagnostics.Emit_more_compliant_but_verbose_and_less_performant_JavaScript_for_iteration,
	          defaultValueDescription: false
	        },
	        {
	          name: "isolatedModules",
	          type: "boolean",
	          category: Diagnostics.Interop_Constraints,
	          description: Diagnostics.Ensure_that_each_file_can_be_safely_transpiled_without_relying_on_other_imports,
	          transpileOptionValue: true,
	          defaultValueDescription: false
	        },
	        {
	          name: "verbatimModuleSyntax",
	          type: "boolean",
	          category: Diagnostics.Interop_Constraints,
	          description: Diagnostics.Do_not_transform_or_elide_any_imports_or_exports_not_marked_as_type_only_ensuring_they_are_written_in_the_output_file_s_format_based_on_the_module_setting,
	          defaultValueDescription: false
	        },
	        // Strict Type Checks
	        {
	          name: "strict",
	          type: "boolean",
	          // Though this affects semantic diagnostics, affectsSemanticDiagnostics is not set here
	          // The value of each strictFlag depends on own strictFlag value or this and never accessed directly.
	          // But we need to store `strict` in builf info, even though it won't be examined directly, so that the
	          // flags it controls (e.g. `strictNullChecks`) will be retrieved correctly
	          affectsBuildInfo: true,
	          showInSimplifiedHelpView: true,
	          category: Diagnostics.Type_Checking,
	          description: Diagnostics.Enable_all_strict_type_checking_options,
	          defaultValueDescription: false
	        },
	        {
	          name: "noImplicitAny",
	          type: "boolean",
	          affectsSemanticDiagnostics: true,
	          affectsBuildInfo: true,
	          strictFlag: true,
	          category: Diagnostics.Type_Checking,
	          description: Diagnostics.Enable_error_reporting_for_expressions_and_declarations_with_an_implied_any_type,
	          defaultValueDescription: Diagnostics.false_unless_strict_is_set
	        },
	        {
	          name: "strictNullChecks",
	          type: "boolean",
	          affectsSemanticDiagnostics: true,
	          affectsBuildInfo: true,
	          strictFlag: true,
	          category: Diagnostics.Type_Checking,
	          description: Diagnostics.When_type_checking_take_into_account_null_and_undefined,
	          defaultValueDescription: Diagnostics.false_unless_strict_is_set
	        },
	        {
	          name: "strictFunctionTypes",
	          type: "boolean",
	          affectsSemanticDiagnostics: true,
	          affectsBuildInfo: true,
	          strictFlag: true,
	          category: Diagnostics.Type_Checking,
	          description: Diagnostics.When_assigning_functions_check_to_ensure_parameters_and_the_return_values_are_subtype_compatible,
	          defaultValueDescription: Diagnostics.false_unless_strict_is_set
	        },
	        {
	          name: "strictBindCallApply",
	          type: "boolean",
	          affectsSemanticDiagnostics: true,
	          affectsBuildInfo: true,
	          strictFlag: true,
	          category: Diagnostics.Type_Checking,
	          description: Diagnostics.Check_that_the_arguments_for_bind_call_and_apply_methods_match_the_original_function,
	          defaultValueDescription: Diagnostics.false_unless_strict_is_set
	        },
	        {
	          name: "strictPropertyInitialization",
	          type: "boolean",
	          affectsSemanticDiagnostics: true,
	          affectsBuildInfo: true,
	          strictFlag: true,
	          category: Diagnostics.Type_Checking,
	          description: Diagnostics.Check_for_class_properties_that_are_declared_but_not_set_in_the_constructor,
	          defaultValueDescription: Diagnostics.false_unless_strict_is_set
	        },
	        {
	          name: "noImplicitThis",
	          type: "boolean",
	          affectsSemanticDiagnostics: true,
	          affectsBuildInfo: true,
	          strictFlag: true,
	          category: Diagnostics.Type_Checking,
	          description: Diagnostics.Enable_error_reporting_when_this_is_given_the_type_any,
	          defaultValueDescription: Diagnostics.false_unless_strict_is_set
	        },
	        {
	          name: "useUnknownInCatchVariables",
	          type: "boolean",
	          affectsSemanticDiagnostics: true,
	          affectsBuildInfo: true,
	          strictFlag: true,
	          category: Diagnostics.Type_Checking,
	          description: Diagnostics.Default_catch_clause_variables_as_unknown_instead_of_any,
	          defaultValueDescription: Diagnostics.false_unless_strict_is_set
	        },
	        {
	          name: "alwaysStrict",
	          type: "boolean",
	          affectsSourceFile: true,
	          affectsEmit: true,
	          affectsBuildInfo: true,
	          strictFlag: true,
	          category: Diagnostics.Type_Checking,
	          description: Diagnostics.Ensure_use_strict_is_always_emitted,
	          defaultValueDescription: Diagnostics.false_unless_strict_is_set
	        },
	        // Additional Checks
	        {
	          name: "noUnusedLocals",
	          type: "boolean",
	          affectsSemanticDiagnostics: true,
	          affectsBuildInfo: true,
	          category: Diagnostics.Type_Checking,
	          description: Diagnostics.Enable_error_reporting_when_local_variables_aren_t_read,
	          defaultValueDescription: false
	        },
	        {
	          name: "noUnusedParameters",
	          type: "boolean",
	          affectsSemanticDiagnostics: true,
	          affectsBuildInfo: true,
	          category: Diagnostics.Type_Checking,
	          description: Diagnostics.Raise_an_error_when_a_function_parameter_isn_t_read,
	          defaultValueDescription: false
	        },
	        {
	          name: "exactOptionalPropertyTypes",
	          type: "boolean",
	          affectsSemanticDiagnostics: true,
	          affectsBuildInfo: true,
	          category: Diagnostics.Type_Checking,
	          description: Diagnostics.Interpret_optional_property_types_as_written_rather_than_adding_undefined,
	          defaultValueDescription: false
	        },
	        {
	          name: "noImplicitReturns",
	          type: "boolean",
	          affectsSemanticDiagnostics: true,
	          affectsBuildInfo: true,
	          category: Diagnostics.Type_Checking,
	          description: Diagnostics.Enable_error_reporting_for_codepaths_that_do_not_explicitly_return_in_a_function,
	          defaultValueDescription: false
	        },
	        {
	          name: "noFallthroughCasesInSwitch",
	          type: "boolean",
	          affectsBindDiagnostics: true,
	          affectsSemanticDiagnostics: true,
	          affectsBuildInfo: true,
	          category: Diagnostics.Type_Checking,
	          description: Diagnostics.Enable_error_reporting_for_fallthrough_cases_in_switch_statements,
	          defaultValueDescription: false
	        },
	        {
	          name: "noUncheckedIndexedAccess",
	          type: "boolean",
	          affectsSemanticDiagnostics: true,
	          affectsBuildInfo: true,
	          category: Diagnostics.Type_Checking,
	          description: Diagnostics.Add_undefined_to_a_type_when_accessed_using_an_index,
	          defaultValueDescription: false
	        },
	        {
	          name: "noImplicitOverride",
	          type: "boolean",
	          affectsSemanticDiagnostics: true,
	          affectsBuildInfo: true,
	          category: Diagnostics.Type_Checking,
	          description: Diagnostics.Ensure_overriding_members_in_derived_classes_are_marked_with_an_override_modifier,
	          defaultValueDescription: false
	        },
	        {
	          name: "noPropertyAccessFromIndexSignature",
	          type: "boolean",
	          affectsSemanticDiagnostics: true,
	          affectsBuildInfo: true,
	          showInSimplifiedHelpView: false,
	          category: Diagnostics.Type_Checking,
	          description: Diagnostics.Enforces_using_indexed_accessors_for_keys_declared_using_an_indexed_type,
	          defaultValueDescription: false
	        },
	        // Module Resolution
	        {
	          name: "moduleResolution",
	          type: new Map(Object.entries({
	            // N.B. The first entry specifies the value shown in `tsc --init`
	            node10: 2 /* Node10 */,
	            node: 2 /* Node10 */,
	            classic: 1 /* Classic */,
	            node16: 3 /* Node16 */,
	            nodenext: 99 /* NodeNext */,
	            bundler: 100 /* Bundler */
	          })),
	          deprecatedKeys: /* @__PURE__ */ new Set(["node"]),
	          affectsSourceFile: true,
	          affectsModuleResolution: true,
	          paramType: Diagnostics.STRATEGY,
	          category: Diagnostics.Modules,
	          description: Diagnostics.Specify_how_TypeScript_looks_up_a_file_from_a_given_module_specifier,
	          defaultValueDescription: Diagnostics.module_AMD_or_UMD_or_System_or_ES6_then_Classic_Otherwise_Node
	        },
	        {
	          name: "baseUrl",
	          type: "string",
	          affectsModuleResolution: true,
	          isFilePath: true,
	          category: Diagnostics.Modules,
	          description: Diagnostics.Specify_the_base_directory_to_resolve_non_relative_module_names
	        },
	        {
	          // this option can only be specified in tsconfig.json
	          // use type = object to copy the value as-is
	          name: "paths",
	          type: "object",
	          affectsModuleResolution: true,
	          isTSConfigOnly: true,
	          category: Diagnostics.Modules,
	          description: Diagnostics.Specify_a_set_of_entries_that_re_map_imports_to_additional_lookup_locations,
	          transpileOptionValue: void 0
	        },
	        {
	          // this option can only be specified in tsconfig.json
	          // use type = object to copy the value as-is
	          name: "rootDirs",
	          type: "list",
	          isTSConfigOnly: true,
	          element: {
	            name: "rootDirs",
	            type: "string",
	            isFilePath: true
	          },
	          affectsModuleResolution: true,
	          category: Diagnostics.Modules,
	          description: Diagnostics.Allow_multiple_folders_to_be_treated_as_one_when_resolving_modules,
	          transpileOptionValue: void 0,
	          defaultValueDescription: Diagnostics.Computed_from_the_list_of_input_files
	        },
	        {
	          name: "typeRoots",
	          type: "list",
	          element: {
	            name: "typeRoots",
	            type: "string",
	            isFilePath: true
	          },
	          affectsModuleResolution: true,
	          category: Diagnostics.Modules,
	          description: Diagnostics.Specify_multiple_folders_that_act_like_Slashnode_modules_Slash_types
	        },
	        {
	          name: "types",
	          type: "list",
	          element: {
	            name: "types",
	            type: "string"
	          },
	          affectsProgramStructure: true,
	          showInSimplifiedHelpView: true,
	          category: Diagnostics.Modules,
	          description: Diagnostics.Specify_type_package_names_to_be_included_without_being_referenced_in_a_source_file,
	          transpileOptionValue: void 0
	        },
	        {
	          name: "allowSyntheticDefaultImports",
	          type: "boolean",
	          affectsSemanticDiagnostics: true,
	          affectsBuildInfo: true,
	          category: Diagnostics.Interop_Constraints,
	          description: Diagnostics.Allow_import_x_from_y_when_a_module_doesn_t_have_a_default_export,
	          defaultValueDescription: Diagnostics.module_system_or_esModuleInterop
	        },
	        {
	          name: "esModuleInterop",
	          type: "boolean",
	          affectsSemanticDiagnostics: true,
	          affectsEmit: true,
	          affectsBuildInfo: true,
	          showInSimplifiedHelpView: true,
	          category: Diagnostics.Interop_Constraints,
	          description: Diagnostics.Emit_additional_JavaScript_to_ease_support_for_importing_CommonJS_modules_This_enables_allowSyntheticDefaultImports_for_type_compatibility,
	          defaultValueDescription: false
	        },
	        {
	          name: "preserveSymlinks",
	          type: "boolean",
	          category: Diagnostics.Interop_Constraints,
	          description: Diagnostics.Disable_resolving_symlinks_to_their_realpath_This_correlates_to_the_same_flag_in_node,
	          defaultValueDescription: false
	        },
	        {
	          name: "allowUmdGlobalAccess",
	          type: "boolean",
	          affectsSemanticDiagnostics: true,
	          affectsBuildInfo: true,
	          category: Diagnostics.Modules,
	          description: Diagnostics.Allow_accessing_UMD_globals_from_modules,
	          defaultValueDescription: false
	        },
	        {
	          name: "moduleSuffixes",
	          type: "list",
	          element: {
	            name: "suffix",
	            type: "string"
	          },
	          listPreserveFalsyValues: true,
	          affectsModuleResolution: true,
	          category: Diagnostics.Modules,
	          description: Diagnostics.List_of_file_name_suffixes_to_search_when_resolving_a_module
	        },
	        {
	          name: "allowImportingTsExtensions",
	          type: "boolean",
	          affectsSemanticDiagnostics: true,
	          affectsBuildInfo: true,
	          category: Diagnostics.Modules,
	          description: Diagnostics.Allow_imports_to_include_TypeScript_file_extensions_Requires_moduleResolution_bundler_and_either_noEmit_or_emitDeclarationOnly_to_be_set,
	          defaultValueDescription: false,
	          transpileOptionValue: void 0
	        },
	        {
	          name: "resolvePackageJsonExports",
	          type: "boolean",
	          affectsModuleResolution: true,
	          category: Diagnostics.Modules,
	          description: Diagnostics.Use_the_package_json_exports_field_when_resolving_package_imports,
	          defaultValueDescription: Diagnostics.true_when_moduleResolution_is_node16_nodenext_or_bundler_otherwise_false
	        },
	        {
	          name: "resolvePackageJsonImports",
	          type: "boolean",
	          affectsModuleResolution: true,
	          category: Diagnostics.Modules,
	          description: Diagnostics.Use_the_package_json_imports_field_when_resolving_imports,
	          defaultValueDescription: Diagnostics.true_when_moduleResolution_is_node16_nodenext_or_bundler_otherwise_false
	        },
	        {
	          name: "customConditions",
	          type: "list",
	          element: {
	            name: "condition",
	            type: "string"
	          },
	          affectsModuleResolution: true,
	          category: Diagnostics.Modules,
	          description: Diagnostics.Conditions_to_set_in_addition_to_the_resolver_specific_defaults_when_resolving_imports
	        },
	        // Source Maps
	        {
	          name: "sourceRoot",
	          type: "string",
	          affectsEmit: true,
	          affectsBuildInfo: true,
	          paramType: Diagnostics.LOCATION,
	          category: Diagnostics.Emit,
	          description: Diagnostics.Specify_the_root_path_for_debuggers_to_find_the_reference_source_code
	        },
	        {
	          name: "mapRoot",
	          type: "string",
	          affectsEmit: true,
	          affectsBuildInfo: true,
	          paramType: Diagnostics.LOCATION,
	          category: Diagnostics.Emit,
	          description: Diagnostics.Specify_the_location_where_debugger_should_locate_map_files_instead_of_generated_locations
	        },
	        {
	          name: "inlineSources",
	          type: "boolean",
	          affectsEmit: true,
	          affectsBuildInfo: true,
	          category: Diagnostics.Emit,
	          description: Diagnostics.Include_source_code_in_the_sourcemaps_inside_the_emitted_JavaScript,
	          defaultValueDescription: false
	        },
	        // Experimental
	        {
	          name: "experimentalDecorators",
	          type: "boolean",
	          affectsEmit: true,
	          affectsSemanticDiagnostics: true,
	          affectsBuildInfo: true,
	          category: Diagnostics.Language_and_Environment,
	          description: Diagnostics.Enable_experimental_support_for_legacy_experimental_decorators,
	          defaultValueDescription: false
	        },
	        {
	          name: "emitDecoratorMetadata",
	          type: "boolean",
	          affectsSemanticDiagnostics: true,
	          affectsEmit: true,
	          affectsBuildInfo: true,
	          category: Diagnostics.Language_and_Environment,
	          description: Diagnostics.Emit_design_type_metadata_for_decorated_declarations_in_source_files,
	          defaultValueDescription: false
	        },
	        // Advanced
	        {
	          name: "jsxFactory",
	          type: "string",
	          category: Diagnostics.Language_and_Environment,
	          description: Diagnostics.Specify_the_JSX_factory_function_used_when_targeting_React_JSX_emit_e_g_React_createElement_or_h,
	          defaultValueDescription: "`React.createElement`"
	        },
	        {
	          name: "jsxFragmentFactory",
	          type: "string",
	          category: Diagnostics.Language_and_Environment,
	          description: Diagnostics.Specify_the_JSX_Fragment_reference_used_for_fragments_when_targeting_React_JSX_emit_e_g_React_Fragment_or_Fragment,
	          defaultValueDescription: "React.Fragment"
	        },
	        {
	          name: "jsxImportSource",
	          type: "string",
	          affectsSemanticDiagnostics: true,
	          affectsEmit: true,
	          affectsBuildInfo: true,
	          affectsModuleResolution: true,
	          category: Diagnostics.Language_and_Environment,
	          description: Diagnostics.Specify_module_specifier_used_to_import_the_JSX_factory_functions_when_using_jsx_Colon_react_jsx_Asterisk,
	          defaultValueDescription: "react"
	        },
	        {
	          name: "resolveJsonModule",
	          type: "boolean",
	          affectsModuleResolution: true,
	          category: Diagnostics.Modules,
	          description: Diagnostics.Enable_importing_json_files,
	          defaultValueDescription: false
	        },
	        {
	          name: "allowArbitraryExtensions",
	          type: "boolean",
	          affectsProgramStructure: true,
	          category: Diagnostics.Modules,
	          description: Diagnostics.Enable_importing_files_with_any_extension_provided_a_declaration_file_is_present,
	          defaultValueDescription: false
	        },
	        {
	          name: "out",
	          type: "string",
	          affectsEmit: true,
	          affectsBuildInfo: true,
	          affectsDeclarationPath: true,
	          isFilePath: false,
	          // This is intentionally broken to support compatibility with existing tsconfig files
	          // for correct behaviour, please use outFile
	          category: Diagnostics.Backwards_Compatibility,
	          paramType: Diagnostics.FILE,
	          transpileOptionValue: void 0,
	          description: Diagnostics.Deprecated_setting_Use_outFile_instead
	        },
	        {
	          name: "reactNamespace",
	          type: "string",
	          affectsEmit: true,
	          affectsBuildInfo: true,
	          category: Diagnostics.Language_and_Environment,
	          description: Diagnostics.Specify_the_object_invoked_for_createElement_This_only_applies_when_targeting_react_JSX_emit,
	          defaultValueDescription: "`React`"
	        },
	        {
	          name: "skipDefaultLibCheck",
	          type: "boolean",
	          // We need to store these to determine whether `lib` files need to be rechecked
	          affectsBuildInfo: true,
	          category: Diagnostics.Completeness,
	          description: Diagnostics.Skip_type_checking_d_ts_files_that_are_included_with_TypeScript,
	          defaultValueDescription: false
	        },
	        {
	          name: "charset",
	          type: "string",
	          category: Diagnostics.Backwards_Compatibility,
	          description: Diagnostics.No_longer_supported_In_early_versions_manually_set_the_text_encoding_for_reading_files,
	          defaultValueDescription: "utf8"
	        },
	        {
	          name: "emitBOM",
	          type: "boolean",
	          affectsEmit: true,
	          affectsBuildInfo: true,
	          category: Diagnostics.Emit,
	          description: Diagnostics.Emit_a_UTF_8_Byte_Order_Mark_BOM_in_the_beginning_of_output_files,
	          defaultValueDescription: false
	        },
	        {
	          name: "newLine",
	          type: new Map(Object.entries({
	            crlf: 0 /* CarriageReturnLineFeed */,
	            lf: 1 /* LineFeed */
	          })),
	          affectsEmit: true,
	          affectsBuildInfo: true,
	          paramType: Diagnostics.NEWLINE,
	          category: Diagnostics.Emit,
	          description: Diagnostics.Set_the_newline_character_for_emitting_files,
	          defaultValueDescription: "lf"
	        },
	        {
	          name: "noErrorTruncation",
	          type: "boolean",
	          affectsSemanticDiagnostics: true,
	          affectsBuildInfo: true,
	          category: Diagnostics.Output_Formatting,
	          description: Diagnostics.Disable_truncating_types_in_error_messages,
	          defaultValueDescription: false
	        },
	        {
	          name: "noLib",
	          type: "boolean",
	          category: Diagnostics.Language_and_Environment,
	          affectsProgramStructure: true,
	          description: Diagnostics.Disable_including_any_library_files_including_the_default_lib_d_ts,
	          // We are not returning a sourceFile for lib file when asked by the program,
	          // so pass --noLib to avoid reporting a file not found error.
	          transpileOptionValue: true,
	          defaultValueDescription: false
	        },
	        {
	          name: "noResolve",
	          type: "boolean",
	          affectsModuleResolution: true,
	          category: Diagnostics.Modules,
	          description: Diagnostics.Disallow_import_s_require_s_or_reference_s_from_expanding_the_number_of_files_TypeScript_should_add_to_a_project,
	          // We are not doing a full typecheck, we are not resolving the whole context,
	          // so pass --noResolve to avoid reporting missing file errors.
	          transpileOptionValue: true,
	          defaultValueDescription: false
	        },
	        {
	          name: "stripInternal",
	          type: "boolean",
	          affectsEmit: true,
	          affectsBuildInfo: true,
	          category: Diagnostics.Emit,
	          description: Diagnostics.Disable_emitting_declarations_that_have_internal_in_their_JSDoc_comments,
	          defaultValueDescription: false
	        },
	        {
	          name: "disableSizeLimit",
	          type: "boolean",
	          affectsProgramStructure: true,
	          category: Diagnostics.Editor_Support,
	          description: Diagnostics.Remove_the_20mb_cap_on_total_source_code_size_for_JavaScript_files_in_the_TypeScript_language_server,
	          defaultValueDescription: false
	        },
	        {
	          name: "disableSourceOfProjectReferenceRedirect",
	          type: "boolean",
	          isTSConfigOnly: true,
	          category: Diagnostics.Projects,
	          description: Diagnostics.Disable_preferring_source_files_instead_of_declaration_files_when_referencing_composite_projects,
	          defaultValueDescription: false
	        },
	        {
	          name: "disableSolutionSearching",
	          type: "boolean",
	          isTSConfigOnly: true,
	          category: Diagnostics.Projects,
	          description: Diagnostics.Opt_a_project_out_of_multi_project_reference_checking_when_editing,
	          defaultValueDescription: false
	        },
	        {
	          name: "disableReferencedProjectLoad",
	          type: "boolean",
	          isTSConfigOnly: true,
	          category: Diagnostics.Projects,
	          description: Diagnostics.Reduce_the_number_of_projects_loaded_automatically_by_TypeScript,
	          defaultValueDescription: false
	        },
	        {
	          name: "noImplicitUseStrict",
	          type: "boolean",
	          affectsSemanticDiagnostics: true,
	          affectsBuildInfo: true,
	          category: Diagnostics.Backwards_Compatibility,
	          description: Diagnostics.Disable_adding_use_strict_directives_in_emitted_JavaScript_files,
	          defaultValueDescription: false
	        },
	        {
	          name: "noEmitHelpers",
	          type: "boolean",
	          affectsEmit: true,
	          affectsBuildInfo: true,
	          category: Diagnostics.Emit,
	          description: Diagnostics.Disable_generating_custom_helper_functions_like_extends_in_compiled_output,
	          defaultValueDescription: false
	        },
	        {
	          name: "noEmitOnError",
	          type: "boolean",
	          affectsEmit: true,
	          affectsBuildInfo: true,
	          category: Diagnostics.Emit,
	          transpileOptionValue: void 0,
	          description: Diagnostics.Disable_emitting_files_if_any_type_checking_errors_are_reported,
	          defaultValueDescription: false
	        },
	        {
	          name: "preserveConstEnums",
	          type: "boolean",
	          affectsEmit: true,
	          affectsBuildInfo: true,
	          category: Diagnostics.Emit,
	          description: Diagnostics.Disable_erasing_const_enum_declarations_in_generated_code,
	          defaultValueDescription: false
	        },
	        {
	          name: "declarationDir",
	          type: "string",
	          affectsEmit: true,
	          affectsBuildInfo: true,
	          affectsDeclarationPath: true,
	          isFilePath: true,
	          paramType: Diagnostics.DIRECTORY,
	          category: Diagnostics.Emit,
	          transpileOptionValue: void 0,
	          description: Diagnostics.Specify_the_output_directory_for_generated_declaration_files
	        },
	        {
	          name: "skipLibCheck",
	          type: "boolean",
	          // We need to store these to determine whether `lib` files need to be rechecked
	          affectsBuildInfo: true,
	          category: Diagnostics.Completeness,
	          description: Diagnostics.Skip_type_checking_all_d_ts_files,
	          defaultValueDescription: false
	        },
	        {
	          name: "allowUnusedLabels",
	          type: "boolean",
	          affectsBindDiagnostics: true,
	          affectsSemanticDiagnostics: true,
	          affectsBuildInfo: true,
	          category: Diagnostics.Type_Checking,
	          description: Diagnostics.Disable_error_reporting_for_unused_labels,
	          defaultValueDescription: void 0
	        },
	        {
	          name: "allowUnreachableCode",
	          type: "boolean",
	          affectsBindDiagnostics: true,
	          affectsSemanticDiagnostics: true,
	          affectsBuildInfo: true,
	          category: Diagnostics.Type_Checking,
	          description: Diagnostics.Disable_error_reporting_for_unreachable_code,
	          defaultValueDescription: void 0
	        },
	        {
	          name: "suppressExcessPropertyErrors",
	          type: "boolean",
	          affectsSemanticDiagnostics: true,
	          affectsBuildInfo: true,
	          category: Diagnostics.Backwards_Compatibility,
	          description: Diagnostics.Disable_reporting_of_excess_property_errors_during_the_creation_of_object_literals,
	          defaultValueDescription: false
	        },
	        {
	          name: "suppressImplicitAnyIndexErrors",
	          type: "boolean",
	          affectsSemanticDiagnostics: true,
	          affectsBuildInfo: true,
	          category: Diagnostics.Backwards_Compatibility,
	          description: Diagnostics.Suppress_noImplicitAny_errors_when_indexing_objects_that_lack_index_signatures,
	          defaultValueDescription: false
	        },
	        {
	          name: "forceConsistentCasingInFileNames",
	          type: "boolean",
	          affectsModuleResolution: true,
	          category: Diagnostics.Interop_Constraints,
	          description: Diagnostics.Ensure_that_casing_is_correct_in_imports,
	          defaultValueDescription: true
	        },
	        {
	          name: "maxNodeModuleJsDepth",
	          type: "number",
	          affectsModuleResolution: true,
	          category: Diagnostics.JavaScript_Support,
	          description: Diagnostics.Specify_the_maximum_folder_depth_used_for_checking_JavaScript_files_from_node_modules_Only_applicable_with_allowJs,
	          defaultValueDescription: 0
	        },
	        {
	          name: "noStrictGenericChecks",
	          type: "boolean",
	          affectsSemanticDiagnostics: true,
	          affectsBuildInfo: true,
	          category: Diagnostics.Backwards_Compatibility,
	          description: Diagnostics.Disable_strict_checking_of_generic_signatures_in_function_types,
	          defaultValueDescription: false
	        },
	        {
	          name: "useDefineForClassFields",
	          type: "boolean",
	          affectsSemanticDiagnostics: true,
	          affectsEmit: true,
	          affectsBuildInfo: true,
	          category: Diagnostics.Language_and_Environment,
	          description: Diagnostics.Emit_ECMAScript_standard_compliant_class_fields,
	          defaultValueDescription: Diagnostics.true_for_ES2022_and_above_including_ESNext
	        },
	        {
	          name: "preserveValueImports",
	          type: "boolean",
	          affectsEmit: true,
	          affectsBuildInfo: true,
	          category: Diagnostics.Emit,
	          description: Diagnostics.Preserve_unused_imported_values_in_the_JavaScript_output_that_would_otherwise_be_removed,
	          defaultValueDescription: false
	        },
	        {
	          name: "keyofStringsOnly",
	          type: "boolean",
	          category: Diagnostics.Backwards_Compatibility,
	          description: Diagnostics.Make_keyof_only_return_strings_instead_of_string_numbers_or_symbols_Legacy_option,
	          defaultValueDescription: false
	        },
	        {
	          // A list of plugins to load in the language service
	          name: "plugins",
	          type: "list",
	          isTSConfigOnly: true,
	          element: {
	            name: "plugin",
	            type: "object"
	          },
	          description: Diagnostics.Specify_a_list_of_language_service_plugins_to_include,
	          category: Diagnostics.Editor_Support
	        },
	        {
	          name: "moduleDetection",
	          type: new Map(Object.entries({
	            auto: 2 /* Auto */,
	            legacy: 1 /* Legacy */,
	            force: 3 /* Force */
	          })),
	          affectsSourceFile: true,
	          affectsModuleResolution: true,
	          description: Diagnostics.Control_what_method_is_used_to_detect_module_format_JS_files,
	          category: Diagnostics.Language_and_Environment,
	          defaultValueDescription: Diagnostics.auto_Colon_Treat_files_with_imports_exports_import_meta_jsx_with_jsx_Colon_react_jsx_or_esm_format_with_module_Colon_node16_as_modules
	        },
	        {
	          name: "ignoreDeprecations",
	          type: "string",
	          defaultValueDescription: void 0
	        }
	      ];
	      optionDeclarations = [
	        ...commonOptionsWithBuild,
	        ...commandOptionsWithoutBuild
	      ];
	      semanticDiagnosticsOptionDeclarations = optionDeclarations.filter((option) => !!option.affectsSemanticDiagnostics);
	      affectsEmitOptionDeclarations = optionDeclarations.filter((option) => !!option.affectsEmit);
	      affectsDeclarationPathOptionDeclarations = optionDeclarations.filter((option) => !!option.affectsDeclarationPath);
	      moduleResolutionOptionDeclarations = optionDeclarations.filter((option) => !!option.affectsModuleResolution);
	      sourceFileAffectingCompilerOptions = optionDeclarations.filter((option) => !!option.affectsSourceFile || !!option.affectsBindDiagnostics);
	      optionsAffectingProgramStructure = optionDeclarations.filter((option) => !!option.affectsProgramStructure);
	      transpileOptionValueCompilerOptions = optionDeclarations.filter((option) => hasProperty(option, "transpileOptionValue"));
	      optionsForBuild = [
	        {
	          name: "verbose",
	          shortName: "v",
	          category: Diagnostics.Command_line_Options,
	          description: Diagnostics.Enable_verbose_logging,
	          type: "boolean",
	          defaultValueDescription: false
	        },
	        {
	          name: "dry",
	          shortName: "d",
	          category: Diagnostics.Command_line_Options,
	          description: Diagnostics.Show_what_would_be_built_or_deleted_if_specified_with_clean,
	          type: "boolean",
	          defaultValueDescription: false
	        },
	        {
	          name: "force",
	          shortName: "f",
	          category: Diagnostics.Command_line_Options,
	          description: Diagnostics.Build_all_projects_including_those_that_appear_to_be_up_to_date,
	          type: "boolean",
	          defaultValueDescription: false
	        },
	        {
	          name: "clean",
	          category: Diagnostics.Command_line_Options,
	          description: Diagnostics.Delete_the_outputs_of_all_projects,
	          type: "boolean",
	          defaultValueDescription: false
	        }
	      ];
	      buildOpts = [
	        ...commonOptionsWithBuild,
	        ...optionsForBuild
	      ];
	      typeAcquisitionDeclarations = [
	        {
	          name: "enable",
	          type: "boolean",
	          defaultValueDescription: false
	        },
	        {
	          name: "include",
	          type: "list",
	          element: {
	            name: "include",
	            type: "string"
	          }
	        },
	        {
	          name: "exclude",
	          type: "list",
	          element: {
	            name: "exclude",
	            type: "string"
	          }
	        },
	        {
	          name: "disableFilenameBasedTypeAcquisition",
	          type: "boolean",
	          defaultValueDescription: false
	        }
	      ];
	      compilerOptionsAlternateMode = {
	        diagnostic: Diagnostics.Compiler_option_0_may_only_be_used_with_build,
	        getOptionsNameMap: getBuildOptionsNameMap
	      };
	      defaultInitCompilerOptions = {
	        module: 1 /* CommonJS */,
	        target: 3 /* ES2016 */,
	        strict: true,
	        esModuleInterop: true,
	        forceConsistentCasingInFileNames: true,
	        skipLibCheck: true
	      };
	      compilerOptionsDidYouMeanDiagnostics = {
	        alternateMode: compilerOptionsAlternateMode,
	        getOptionsNameMap,
	        optionDeclarations,
	        unknownOptionDiagnostic: Diagnostics.Unknown_compiler_option_0,
	        unknownDidYouMeanDiagnostic: Diagnostics.Unknown_compiler_option_0_Did_you_mean_1,
	        optionTypeMismatchDiagnostic: Diagnostics.Compiler_option_0_expects_an_argument
	      };
	      buildOptionsAlternateMode = {
	        diagnostic: Diagnostics.Compiler_option_0_may_not_be_used_with_build,
	        getOptionsNameMap
	      };
	      buildOptionsDidYouMeanDiagnostics = {
	        alternateMode: buildOptionsAlternateMode,
	        getOptionsNameMap: getBuildOptionsNameMap,
	        optionDeclarations: buildOpts,
	        unknownOptionDiagnostic: Diagnostics.Unknown_build_option_0,
	        unknownDidYouMeanDiagnostic: Diagnostics.Unknown_build_option_0_Did_you_mean_1,
	        optionTypeMismatchDiagnostic: Diagnostics.Build_option_0_requires_a_value_of_type_1
	      };
	      typeAcquisitionDidYouMeanDiagnostics = {
	        optionDeclarations: typeAcquisitionDeclarations,
	        unknownOptionDiagnostic: Diagnostics.Unknown_type_acquisition_option_0,
	        unknownDidYouMeanDiagnostic: Diagnostics.Unknown_type_acquisition_option_0_Did_you_mean_1
	      };
	      watchOptionsDidYouMeanDiagnostics = {
	        getOptionsNameMap: getWatchOptionsNameMap,
	        optionDeclarations: optionsForWatch,
	        unknownOptionDiagnostic: Diagnostics.Unknown_watch_option_0,
	        unknownDidYouMeanDiagnostic: Diagnostics.Unknown_watch_option_0_Did_you_mean_1,
	        optionTypeMismatchDiagnostic: Diagnostics.Watch_option_0_requires_a_value_of_type_1
	      };
	      extendsOptionDeclaration = {
	        name: "extends",
	        type: "listOrElement",
	        element: {
	          name: "extends",
	          type: "string"
	        },
	        category: Diagnostics.File_Management,
	        disallowNullOrUndefined: true
	      };
	      compilerOptionsDeclaration = {
	        name: "compilerOptions",
	        type: "object",
	        elementOptions: getCommandLineCompilerOptionsMap(),
	        extraKeyDiagnostics: compilerOptionsDidYouMeanDiagnostics
	      };
	      watchOptionsDeclaration = {
	        name: "watchOptions",
	        type: "object",
	        elementOptions: getCommandLineWatchOptionsMap(),
	        extraKeyDiagnostics: watchOptionsDidYouMeanDiagnostics
	      };
	      typeAcquisitionDeclaration = {
	        name: "typeAcquisition",
	        type: "object",
	        elementOptions: getCommandLineTypeAcquisitionMap(),
	        extraKeyDiagnostics: typeAcquisitionDidYouMeanDiagnostics
	      };
	      defaultIncludeSpec = "**/*";
	      invalidTrailingRecursionPattern = /(^|\/)\*\*\/?$/;
	      wildcardDirectoryPattern = /^[^*?]*(?=\/[^/]*[*?])/;
	    }
	  });

	  // src/compiler/moduleNameResolver.ts
	  function trace(host, message, ...args) {
	    host.trace(formatMessage(message, ...args));
	  }
	  function isTraceEnabled(compilerOptions, host) {
	    return !!compilerOptions.traceResolution && host.trace !== void 0;
	  }
	  function withPackageId(packageInfo, r) {
	    let packageId;
	    if (r && packageInfo) {
	      const packageJsonContent = packageInfo.contents.packageJsonContent;
	      if (typeof packageJsonContent.name === "string" && typeof packageJsonContent.version === "string") {
	        packageId = {
	          name: packageJsonContent.name,
	          subModuleName: r.path.slice(packageInfo.packageDirectory.length + directorySeparator.length),
	          version: packageJsonContent.version
	        };
	      }
	    }
	    return r && { path: r.path, extension: r.ext, packageId, resolvedUsingTsExtension: r.resolvedUsingTsExtension };
	  }
	  function noPackageId(r) {
	    return withPackageId(
	      /*packageInfo*/
	      void 0,
	      r
	    );
	  }
	  function removeIgnoredPackageId(r) {
	    if (r) {
	      Debug.assert(r.packageId === void 0);
	      return { path: r.path, ext: r.extension, resolvedUsingTsExtension: r.resolvedUsingTsExtension };
	    }
	  }
	  function formatExtensions(extensions) {
	    const result = [];
	    if (extensions & 1 /* TypeScript */)
	      result.push("TypeScript");
	    if (extensions & 2 /* JavaScript */)
	      result.push("JavaScript");
	    if (extensions & 4 /* Declaration */)
	      result.push("Declaration");
	    if (extensions & 8 /* Json */)
	      result.push("JSON");
	    return result.join(", ");
	  }
	  function extensionsToExtensionsArray(extensions) {
	    const result = [];
	    if (extensions & 1 /* TypeScript */)
	      result.push(...supportedTSImplementationExtensions);
	    if (extensions & 2 /* JavaScript */)
	      result.push(...supportedJSExtensionsFlat);
	    if (extensions & 4 /* Declaration */)
	      result.push(...supportedDeclarationExtensions);
	    if (extensions & 8 /* Json */)
	      result.push(".json" /* Json */);
	    return result;
	  }
	  function resolvedTypeScriptOnly(resolved) {
	    if (!resolved) {
	      return void 0;
	    }
	    Debug.assert(extensionIsTS(resolved.extension));
	    return { fileName: resolved.path, packageId: resolved.packageId };
	  }
	  function createResolvedModuleWithFailedLookupLocationsHandlingSymlink(moduleName, resolved, isExternalLibraryImport, failedLookupLocations, affectingLocations, diagnostics, state, cache, alternateResult) {
	    if (!state.resultFromCache && !state.compilerOptions.preserveSymlinks && resolved && isExternalLibraryImport && !resolved.originalPath && !isExternalModuleNameRelative(moduleName)) {
	      const { resolvedFileName, originalPath } = getOriginalAndResolvedFileName(resolved.path, state.host, state.traceEnabled);
	      if (originalPath)
	        resolved = { ...resolved, path: resolvedFileName, originalPath };
	    }
	    return createResolvedModuleWithFailedLookupLocations(
	      resolved,
	      isExternalLibraryImport,
	      failedLookupLocations,
	      affectingLocations,
	      diagnostics,
	      state.resultFromCache,
	      cache,
	      alternateResult
	    );
	  }
	  function createResolvedModuleWithFailedLookupLocations(resolved, isExternalLibraryImport, failedLookupLocations, affectingLocations, diagnostics, resultFromCache, cache, alternateResult) {
	    if (resultFromCache) {
	      if (!(cache == null ? void 0 : cache.isReadonly)) {
	        resultFromCache.failedLookupLocations = updateResolutionField(resultFromCache.failedLookupLocations, failedLookupLocations);
	        resultFromCache.affectingLocations = updateResolutionField(resultFromCache.affectingLocations, affectingLocations);
	        resultFromCache.resolutionDiagnostics = updateResolutionField(resultFromCache.resolutionDiagnostics, diagnostics);
	        return resultFromCache;
	      } else {
	        return {
	          ...resultFromCache,
	          failedLookupLocations: initializeResolutionFieldForReadonlyCache(resultFromCache.failedLookupLocations, failedLookupLocations),
	          affectingLocations: initializeResolutionFieldForReadonlyCache(resultFromCache.affectingLocations, affectingLocations),
	          resolutionDiagnostics: initializeResolutionFieldForReadonlyCache(resultFromCache.resolutionDiagnostics, diagnostics)
	        };
	      }
	    }
	    return {
	      resolvedModule: resolved && {
	        resolvedFileName: resolved.path,
	        originalPath: resolved.originalPath === true ? void 0 : resolved.originalPath,
	        extension: resolved.extension,
	        isExternalLibraryImport,
	        packageId: resolved.packageId,
	        resolvedUsingTsExtension: !!resolved.resolvedUsingTsExtension
	      },
	      failedLookupLocations: initializeResolutionField(failedLookupLocations),
	      affectingLocations: initializeResolutionField(affectingLocations),
	      resolutionDiagnostics: initializeResolutionField(diagnostics),
	      alternateResult
	    };
	  }
	  function initializeResolutionField(value) {
	    return value.length ? value : void 0;
	  }
	  function updateResolutionField(to, value) {
	    if (!(value == null ? void 0 : value.length))
	      return to;
	    if (!(to == null ? void 0 : to.length))
	      return value;
	    to.push(...value);
	    return to;
	  }
	  function initializeResolutionFieldForReadonlyCache(fromCache, value) {
	    if (!(fromCache == null ? void 0 : fromCache.length))
	      return initializeResolutionField(value);
	    if (!value.length)
	      return fromCache.slice();
	    return [...fromCache, ...value];
	  }
	  function readPackageJsonField(jsonContent, fieldName, typeOfTag, state) {
	    if (!hasProperty(jsonContent, fieldName)) {
	      if (state.traceEnabled) {
	        trace(state.host, Diagnostics.package_json_does_not_have_a_0_field, fieldName);
	      }
	      return;
	    }
	    const value = jsonContent[fieldName];
	    if (typeof value !== typeOfTag || value === null) {
	      if (state.traceEnabled) {
	        trace(state.host, Diagnostics.Expected_type_of_0_field_in_package_json_to_be_1_got_2, fieldName, typeOfTag, value === null ? "null" : typeof value);
	      }
	      return;
	    }
	    return value;
	  }
	  function readPackageJsonPathField(jsonContent, fieldName, baseDirectory, state) {
	    const fileName = readPackageJsonField(jsonContent, fieldName, "string", state);
	    if (fileName === void 0) {
	      return;
	    }
	    if (!fileName) {
	      if (state.traceEnabled) {
	        trace(state.host, Diagnostics.package_json_had_a_falsy_0_field, fieldName);
	      }
	      return;
	    }
	    const path = normalizePath(combinePaths(baseDirectory, fileName));
	    if (state.traceEnabled) {
	      trace(state.host, Diagnostics.package_json_has_0_field_1_that_references_2, fieldName, fileName, path);
	    }
	    return path;
	  }
	  function readPackageJsonTypesFields(jsonContent, baseDirectory, state) {
	    return readPackageJsonPathField(jsonContent, "typings", baseDirectory, state) || readPackageJsonPathField(jsonContent, "types", baseDirectory, state);
	  }
	  function readPackageJsonTSConfigField(jsonContent, baseDirectory, state) {
	    return readPackageJsonPathField(jsonContent, "tsconfig", baseDirectory, state);
	  }
	  function readPackageJsonMainField(jsonContent, baseDirectory, state) {
	    return readPackageJsonPathField(jsonContent, "main", baseDirectory, state);
	  }
	  function readPackageJsonTypesVersionsField(jsonContent, state) {
	    const typesVersions = readPackageJsonField(jsonContent, "typesVersions", "object", state);
	    if (typesVersions === void 0)
	      return;
	    if (state.traceEnabled) {
	      trace(state.host, Diagnostics.package_json_has_a_typesVersions_field_with_version_specific_path_mappings);
	    }
	    return typesVersions;
	  }
	  function readPackageJsonTypesVersionPaths(jsonContent, state) {
	    const typesVersions = readPackageJsonTypesVersionsField(jsonContent, state);
	    if (typesVersions === void 0)
	      return;
	    if (state.traceEnabled) {
	      for (const key in typesVersions) {
	        if (hasProperty(typesVersions, key) && !VersionRange.tryParse(key)) {
	          trace(state.host, Diagnostics.package_json_has_a_typesVersions_entry_0_that_is_not_a_valid_semver_range, key);
	        }
	      }
	    }
	    const result = getPackageJsonTypesVersionsPaths(typesVersions);
	    if (!result) {
	      if (state.traceEnabled) {
	        trace(state.host, Diagnostics.package_json_does_not_have_a_typesVersions_entry_that_matches_version_0, versionMajorMinor);
	      }
	      return;
	    }
	    const { version: bestVersionKey, paths: bestVersionPaths } = result;
	    if (typeof bestVersionPaths !== "object") {
	      if (state.traceEnabled) {
	        trace(state.host, Diagnostics.Expected_type_of_0_field_in_package_json_to_be_1_got_2, `typesVersions['${bestVersionKey}']`, "object", typeof bestVersionPaths);
	      }
	      return;
	    }
	    return result;
	  }
	  function getPackageJsonTypesVersionsPaths(typesVersions) {
	    if (!typeScriptVersion)
	      typeScriptVersion = new Version(version);
	    for (const key in typesVersions) {
	      if (!hasProperty(typesVersions, key))
	        continue;
	      const keyRange = VersionRange.tryParse(key);
	      if (keyRange === void 0) {
	        continue;
	      }
	      if (keyRange.test(typeScriptVersion)) {
	        return { version: key, paths: typesVersions[key] };
	      }
	    }
	  }
	  function getEffectiveTypeRoots(options, host) {
	    if (options.typeRoots) {
	      return options.typeRoots;
	    }
	    let currentDirectory;
	    if (options.configFilePath) {
	      currentDirectory = getDirectoryPath(options.configFilePath);
	    } else if (host.getCurrentDirectory) {
	      currentDirectory = host.getCurrentDirectory();
	    }
	    if (currentDirectory !== void 0) {
	      return getDefaultTypeRoots(currentDirectory);
	    }
	  }
	  function getDefaultTypeRoots(currentDirectory) {
	    let typeRoots;
	    forEachAncestorDirectory(normalizePath(currentDirectory), (directory) => {
	      const atTypes = combinePaths(directory, nodeModulesAtTypes);
	      (typeRoots ?? (typeRoots = [])).push(atTypes);
	    });
	    return typeRoots;
	  }
	  function arePathsEqual(path1, path2, host) {
	    const useCaseSensitiveFileNames2 = typeof host.useCaseSensitiveFileNames === "function" ? host.useCaseSensitiveFileNames() : host.useCaseSensitiveFileNames;
	    return comparePaths(path1, path2, !useCaseSensitiveFileNames2) === 0 /* EqualTo */;
	  }
	  function getOriginalAndResolvedFileName(fileName, host, traceEnabled) {
	    const resolvedFileName = realPath(fileName, host, traceEnabled);
	    const pathsAreEqual = arePathsEqual(fileName, resolvedFileName, host);
	    return {
	      // If the fileName and realpath are differing only in casing prefer fileName so that we can issue correct errors for casing under forceConsistentCasingInFileNames
	      resolvedFileName: pathsAreEqual ? fileName : resolvedFileName,
	      originalPath: pathsAreEqual ? void 0 : fileName
	    };
	  }
	  function getCandidateFromTypeRoot(typeRoot, typeReferenceDirectiveName, moduleResolutionState) {
	    const nameForLookup = endsWith(typeRoot, "/node_modules/@types") || endsWith(typeRoot, "/node_modules/@types/") ? mangleScopedPackageNameWithTrace(typeReferenceDirectiveName, moduleResolutionState) : typeReferenceDirectiveName;
	    return combinePaths(typeRoot, nameForLookup);
	  }
	  function resolveTypeReferenceDirective(typeReferenceDirectiveName, containingFile, options, host, redirectedReference, cache, resolutionMode) {
	    Debug.assert(typeof typeReferenceDirectiveName === "string", "Non-string value passed to `ts.resolveTypeReferenceDirective`, likely by a wrapping package working with an outdated `resolveTypeReferenceDirectives` signature. This is probably not a problem in TS itself.");
	    const traceEnabled = isTraceEnabled(options, host);
	    if (redirectedReference) {
	      options = redirectedReference.commandLine.options;
	    }
	    const containingDirectory = containingFile ? getDirectoryPath(containingFile) : void 0;
	    let result = containingDirectory ? cache == null ? void 0 : cache.getFromDirectoryCache(typeReferenceDirectiveName, resolutionMode, containingDirectory, redirectedReference) : void 0;
	    if (!result && containingDirectory && !isExternalModuleNameRelative(typeReferenceDirectiveName)) {
	      result = cache == null ? void 0 : cache.getFromNonRelativeNameCache(typeReferenceDirectiveName, resolutionMode, containingDirectory, redirectedReference);
	    }
	    if (result) {
	      if (traceEnabled) {
	        trace(host, Diagnostics.Resolving_type_reference_directive_0_containing_file_1, typeReferenceDirectiveName, containingFile);
	        if (redirectedReference)
	          trace(host, Diagnostics.Using_compiler_options_of_project_reference_redirect_0, redirectedReference.sourceFile.fileName);
	        trace(host, Diagnostics.Resolution_for_type_reference_directive_0_was_found_in_cache_from_location_1, typeReferenceDirectiveName, containingDirectory);
	        traceResult(result);
	      }
	      return result;
	    }
	    const typeRoots = getEffectiveTypeRoots(options, host);
	    if (traceEnabled) {
	      if (containingFile === void 0) {
	        if (typeRoots === void 0) {
	          trace(host, Diagnostics.Resolving_type_reference_directive_0_containing_file_not_set_root_directory_not_set, typeReferenceDirectiveName);
	        } else {
	          trace(host, Diagnostics.Resolving_type_reference_directive_0_containing_file_not_set_root_directory_1, typeReferenceDirectiveName, typeRoots);
	        }
	      } else {
	        if (typeRoots === void 0) {
	          trace(host, Diagnostics.Resolving_type_reference_directive_0_containing_file_1_root_directory_not_set, typeReferenceDirectiveName, containingFile);
	        } else {
	          trace(host, Diagnostics.Resolving_type_reference_directive_0_containing_file_1_root_directory_2, typeReferenceDirectiveName, containingFile, typeRoots);
	        }
	      }
	      if (redirectedReference) {
	        trace(host, Diagnostics.Using_compiler_options_of_project_reference_redirect_0, redirectedReference.sourceFile.fileName);
	      }
	    }
	    const failedLookupLocations = [];
	    const affectingLocations = [];
	    let features = getNodeResolutionFeatures(options);
	    if (resolutionMode !== void 0) {
	      features |= 30 /* AllFeatures */;
	    }
	    const moduleResolution = getEmitModuleResolutionKind(options);
	    if (resolutionMode === 99 /* ESNext */ && (3 /* Node16 */ <= moduleResolution && moduleResolution <= 99 /* NodeNext */)) {
	      features |= 32 /* EsmMode */;
	    }
	    const conditions = features & 8 /* Exports */ ? getConditions(options, resolutionMode) : [];
	    const diagnostics = [];
	    const moduleResolutionState = {
	      compilerOptions: options,
	      host,
	      traceEnabled,
	      failedLookupLocations,
	      affectingLocations,
	      packageJsonInfoCache: cache,
	      features,
	      conditions,
	      requestContainingDirectory: containingDirectory,
	      reportDiagnostic: (diag2) => void diagnostics.push(diag2),
	      isConfigLookup: false,
	      candidateIsFromPackageJsonField: false,
	      resolvedPackageDirectory: false
	    };
	    let resolved = primaryLookup();
	    let primary = true;
	    if (!resolved) {
	      resolved = secondaryLookup();
	      primary = false;
	    }
	    let resolvedTypeReferenceDirective;
	    if (resolved) {
	      const { fileName, packageId } = resolved;
	      let resolvedFileName = fileName, originalPath;
	      if (!options.preserveSymlinks)
	        ({ resolvedFileName, originalPath } = getOriginalAndResolvedFileName(fileName, host, traceEnabled));
	      resolvedTypeReferenceDirective = {
	        primary,
	        resolvedFileName,
	        originalPath,
	        packageId,
	        isExternalLibraryImport: pathContainsNodeModules(fileName)
	      };
	    }
	    result = {
	      resolvedTypeReferenceDirective,
	      failedLookupLocations: initializeResolutionField(failedLookupLocations),
	      affectingLocations: initializeResolutionField(affectingLocations),
	      resolutionDiagnostics: initializeResolutionField(diagnostics)
	    };
	    if (containingDirectory && cache && !cache.isReadonly) {
	      cache.getOrCreateCacheForDirectory(containingDirectory, redirectedReference).set(
	        typeReferenceDirectiveName,
	        /*mode*/
	        resolutionMode,
	        result
	      );
	      if (!isExternalModuleNameRelative(typeReferenceDirectiveName)) {
	        cache.getOrCreateCacheForNonRelativeName(typeReferenceDirectiveName, resolutionMode, redirectedReference).set(containingDirectory, result);
	      }
	    }
	    if (traceEnabled)
	      traceResult(result);
	    return result;
	    function traceResult(result2) {
	      var _a;
	      if (!((_a = result2.resolvedTypeReferenceDirective) == null ? void 0 : _a.resolvedFileName)) {
	        trace(host, Diagnostics.Type_reference_directive_0_was_not_resolved, typeReferenceDirectiveName);
	      } else if (result2.resolvedTypeReferenceDirective.packageId) {
	        trace(host, Diagnostics.Type_reference_directive_0_was_successfully_resolved_to_1_with_Package_ID_2_primary_Colon_3, typeReferenceDirectiveName, result2.resolvedTypeReferenceDirective.resolvedFileName, packageIdToString(result2.resolvedTypeReferenceDirective.packageId), result2.resolvedTypeReferenceDirective.primary);
	      } else {
	        trace(host, Diagnostics.Type_reference_directive_0_was_successfully_resolved_to_1_primary_Colon_2, typeReferenceDirectiveName, result2.resolvedTypeReferenceDirective.resolvedFileName, result2.resolvedTypeReferenceDirective.primary);
	      }
	    }
	    function primaryLookup() {
	      if (typeRoots && typeRoots.length) {
	        if (traceEnabled) {
	          trace(host, Diagnostics.Resolving_with_primary_search_path_0, typeRoots.join(", "));
	        }
	        return firstDefined(typeRoots, (typeRoot) => {
	          const candidate = getCandidateFromTypeRoot(typeRoot, typeReferenceDirectiveName, moduleResolutionState);
	          const directoryExists = directoryProbablyExists(typeRoot, host);
	          if (!directoryExists && traceEnabled) {
	            trace(host, Diagnostics.Directory_0_does_not_exist_skipping_all_lookups_in_it, typeRoot);
	          }
	          if (options.typeRoots) {
	            const resolvedFromFile = loadModuleFromFile(4 /* Declaration */, candidate, !directoryExists, moduleResolutionState);
	            if (resolvedFromFile) {
	              const packageDirectory = parseNodeModuleFromPath(resolvedFromFile.path);
	              const packageInfo = packageDirectory ? getPackageJsonInfo(
	                packageDirectory,
	                /*onlyRecordFailures*/
	                false,
	                moduleResolutionState
	              ) : void 0;
	              return resolvedTypeScriptOnly(withPackageId(packageInfo, resolvedFromFile));
	            }
	          }
	          return resolvedTypeScriptOnly(
	            loadNodeModuleFromDirectory(4 /* Declaration */, candidate, !directoryExists, moduleResolutionState)
	          );
	        });
	      } else {
	        if (traceEnabled) {
	          trace(host, Diagnostics.Root_directory_cannot_be_determined_skipping_primary_search_paths);
	        }
	      }
	    }
	    function secondaryLookup() {
	      const initialLocationForSecondaryLookup = containingFile && getDirectoryPath(containingFile);
	      if (initialLocationForSecondaryLookup !== void 0) {
	        let result2;
	        if (!options.typeRoots || !endsWith(containingFile, inferredTypesContainingFile)) {
	          if (traceEnabled) {
	            trace(host, Diagnostics.Looking_up_in_node_modules_folder_initial_location_0, initialLocationForSecondaryLookup);
	          }
	          if (!isExternalModuleNameRelative(typeReferenceDirectiveName)) {
	            const searchResult = loadModuleFromNearestNodeModulesDirectory(
	              4 /* Declaration */,
	              typeReferenceDirectiveName,
	              initialLocationForSecondaryLookup,
	              moduleResolutionState,
	              /*cache*/
	              void 0,
	              /*redirectedReference*/
	              void 0
	            );
	            result2 = searchResult && searchResult.value;
	          } else {
	            const { path: candidate } = normalizePathForCJSResolution(initialLocationForSecondaryLookup, typeReferenceDirectiveName);
	            result2 = nodeLoadModuleByRelativeName(
	              4 /* Declaration */,
	              candidate,
	              /*onlyRecordFailures*/
	              false,
	              moduleResolutionState,
	              /*considerPackageJson*/
	              true
	            );
	          }
	        } else if (traceEnabled) {
	          trace(host, Diagnostics.Resolving_type_reference_directive_for_program_that_specifies_custom_typeRoots_skipping_lookup_in_node_modules_folder);
	        }
	        return resolvedTypeScriptOnly(result2);
	      } else {
	        if (traceEnabled) {
	          trace(host, Diagnostics.Containing_file_is_not_specified_and_root_directory_cannot_be_determined_skipping_lookup_in_node_modules_folder);
	        }
	      }
	    }
	  }
	  function getNodeResolutionFeatures(options) {
	    let features = 0 /* None */;
	    switch (getEmitModuleResolutionKind(options)) {
	      case 3 /* Node16 */:
	        features = 30 /* Node16Default */;
	        break;
	      case 99 /* NodeNext */:
	        features = 30 /* NodeNextDefault */;
	        break;
	      case 100 /* Bundler */:
	        features = 30 /* BundlerDefault */;
	        break;
	    }
	    if (options.resolvePackageJsonExports) {
	      features |= 8 /* Exports */;
	    } else if (options.resolvePackageJsonExports === false) {
	      features &= ~8 /* Exports */;
	    }
	    if (options.resolvePackageJsonImports) {
	      features |= 2 /* Imports */;
	    } else if (options.resolvePackageJsonImports === false) {
	      features &= ~2 /* Imports */;
	    }
	    return features;
	  }
	  function getConditions(options, resolutionMode) {
	    const moduleResolution = getEmitModuleResolutionKind(options);
	    if (resolutionMode === void 0) {
	      if (moduleResolution === 100 /* Bundler */) {
	        resolutionMode = 99 /* ESNext */;
	      } else if (moduleResolution === 2 /* Node10 */) {
	        return [];
	      }
	    }
	    const conditions = resolutionMode === 99 /* ESNext */ ? ["import"] : ["require"];
	    if (!options.noDtsResolution) {
	      conditions.push("types");
	    }
	    if (moduleResolution !== 100 /* Bundler */) {
	      conditions.push("node");
	    }
	    return concatenate(conditions, options.customConditions);
	  }
	  function resolvePackageNameToPackageJson(packageName, containingDirectory, options, host, cache) {
	    const moduleResolutionState = getTemporaryModuleResolutionState(cache == null ? void 0 : cache.getPackageJsonInfoCache(), host, options);
	    return forEachAncestorDirectory(containingDirectory, (ancestorDirectory) => {
	      if (getBaseFileName(ancestorDirectory) !== "node_modules") {
	        const nodeModulesFolder = combinePaths(ancestorDirectory, "node_modules");
	        const candidate = combinePaths(nodeModulesFolder, packageName);
	        return getPackageJsonInfo(
	          candidate,
	          /*onlyRecordFailures*/
	          false,
	          moduleResolutionState
	        );
	      }
	    });
	  }
	  function getAutomaticTypeDirectiveNames(options, host) {
	    if (options.types) {
	      return options.types;
	    }
	    const result = [];
	    if (host.directoryExists && host.getDirectories) {
	      const typeRoots = getEffectiveTypeRoots(options, host);
	      if (typeRoots) {
	        for (const root of typeRoots) {
	          if (host.directoryExists(root)) {
	            for (const typeDirectivePath of host.getDirectories(root)) {
	              const normalized = normalizePath(typeDirectivePath);
	              const packageJsonPath = combinePaths(root, normalized, "package.json");
	              const isNotNeededPackage = host.fileExists(packageJsonPath) && readJson(packageJsonPath, host).typings === null;
	              if (!isNotNeededPackage) {
	                const baseFileName = getBaseFileName(normalized);
	                if (baseFileName.charCodeAt(0) !== 46 /* dot */) {
	                  result.push(baseFileName);
	                }
	              }
	            }
	          }
	        }
	      }
	    }
	    return result;
	  }
	  function isPackageJsonInfo(entry) {
	    return !!(entry == null ? void 0 : entry.contents);
	  }
	  function isMissingPackageJsonInfo(entry) {
	    return !!entry && !entry.contents;
	  }
	  function compilerOptionValueToString(value) {
	    var _a;
	    if (value === null || typeof value !== "object") {
	      return "" + value;
	    }
	    if (isArray(value)) {
	      return `[${(_a = value.map((e) => compilerOptionValueToString(e))) == null ? void 0 : _a.join(",")}]`;
	    }
	    let str = "{";
	    for (const key in value) {
	      if (hasProperty(value, key)) {
	        str += `${key}: ${compilerOptionValueToString(value[key])}`;
	      }
	    }
	    return str + "}";
	  }
	  function getKeyForCompilerOptions(options, affectingOptionDeclarations) {
	    return affectingOptionDeclarations.map((option) => compilerOptionValueToString(getCompilerOptionValue(options, option))).join("|") + `|${options.pathsBasePath}`;
	  }
	  function createCacheWithRedirects(ownOptions, optionsToRedirectsKey) {
	    const redirectsMap = /* @__PURE__ */ new Map();
	    const redirectsKeyToMap = /* @__PURE__ */ new Map();
	    let ownMap = /* @__PURE__ */ new Map();
	    if (ownOptions)
	      redirectsMap.set(ownOptions, ownMap);
	    return {
	      getMapOfCacheRedirects,
	      getOrCreateMapOfCacheRedirects,
	      update,
	      clear: clear2,
	      getOwnMap: () => ownMap
	    };
	    function getMapOfCacheRedirects(redirectedReference) {
	      return redirectedReference ? getOrCreateMap(
	        redirectedReference.commandLine.options,
	        /*create*/
	        false
	      ) : ownMap;
	    }
	    function getOrCreateMapOfCacheRedirects(redirectedReference) {
	      return redirectedReference ? getOrCreateMap(
	        redirectedReference.commandLine.options,
	        /*create*/
	        true
	      ) : ownMap;
	    }
	    function update(newOptions) {
	      if (ownOptions !== newOptions) {
	        if (ownOptions)
	          ownMap = getOrCreateMap(
	            newOptions,
	            /*create*/
	            true
	          );
	        else
	          redirectsMap.set(newOptions, ownMap);
	        ownOptions = newOptions;
	      }
	    }
	    function getOrCreateMap(redirectOptions, create) {
	      let result = redirectsMap.get(redirectOptions);
	      if (result)
	        return result;
	      const key = getRedirectsCacheKey(redirectOptions);
	      result = redirectsKeyToMap.get(key);
	      if (!result) {
	        if (ownOptions) {
	          const ownKey = getRedirectsCacheKey(ownOptions);
	          if (ownKey === key)
	            result = ownMap;
	          else if (!redirectsKeyToMap.has(ownKey))
	            redirectsKeyToMap.set(ownKey, ownMap);
	        }
	        if (create)
	          result ?? (result = /* @__PURE__ */ new Map());
	        if (result)
	          redirectsKeyToMap.set(key, result);
	      }
	      if (result)
	        redirectsMap.set(redirectOptions, result);
	      return result;
	    }
	    function clear2() {
	      const ownKey = ownOptions && optionsToRedirectsKey.get(ownOptions);
	      ownMap.clear();
	      redirectsMap.clear();
	      optionsToRedirectsKey.clear();
	      redirectsKeyToMap.clear();
	      if (ownOptions) {
	        if (ownKey)
	          optionsToRedirectsKey.set(ownOptions, ownKey);
	        redirectsMap.set(ownOptions, ownMap);
	      }
	    }
	    function getRedirectsCacheKey(options) {
	      let result = optionsToRedirectsKey.get(options);
	      if (!result) {
	        optionsToRedirectsKey.set(options, result = getKeyForCompilerOptions(options, moduleResolutionOptionDeclarations));
	      }
	      return result;
	    }
	  }
	  function createPackageJsonInfoCache(currentDirectory, getCanonicalFileName) {
	    let cache;
	    return { getPackageJsonInfo: getPackageJsonInfo2, setPackageJsonInfo, clear: clear2, getInternalMap };
	    function getPackageJsonInfo2(packageJsonPath) {
	      return cache == null ? void 0 : cache.get(toPath(packageJsonPath, currentDirectory, getCanonicalFileName));
	    }
	    function setPackageJsonInfo(packageJsonPath, info) {
	      (cache || (cache = /* @__PURE__ */ new Map())).set(toPath(packageJsonPath, currentDirectory, getCanonicalFileName), info);
	    }
	    function clear2() {
	      cache = void 0;
	    }
	    function getInternalMap() {
	      return cache;
	    }
	  }
	  function getOrCreateCache(cacheWithRedirects, redirectedReference, key, create) {
	    const cache = cacheWithRedirects.getOrCreateMapOfCacheRedirects(redirectedReference);
	    let result = cache.get(key);
	    if (!result) {
	      result = create();
	      cache.set(key, result);
	    }
	    return result;
	  }
	  function createPerDirectoryResolutionCache(currentDirectory, getCanonicalFileName, options, optionsToRedirectsKey) {
	    const directoryToModuleNameMap = createCacheWithRedirects(options, optionsToRedirectsKey);
	    return {
	      getFromDirectoryCache,
	      getOrCreateCacheForDirectory,
	      clear: clear2,
	      update,
	      directoryToModuleNameMap
	    };
	    function clear2() {
	      directoryToModuleNameMap.clear();
	    }
	    function update(options2) {
	      directoryToModuleNameMap.update(options2);
	    }
	    function getOrCreateCacheForDirectory(directoryName, redirectedReference) {
	      const path = toPath(directoryName, currentDirectory, getCanonicalFileName);
	      return getOrCreateCache(directoryToModuleNameMap, redirectedReference, path, () => createModeAwareCache());
	    }
	    function getFromDirectoryCache(name, mode, directoryName, redirectedReference) {
	      var _a, _b;
	      const path = toPath(directoryName, currentDirectory, getCanonicalFileName);
	      return (_b = (_a = directoryToModuleNameMap.getMapOfCacheRedirects(redirectedReference)) == null ? void 0 : _a.get(path)) == null ? void 0 : _b.get(name, mode);
	    }
	  }
	  function createModeAwareCacheKey(specifier, mode) {
	    return mode === void 0 ? specifier : `${mode}|${specifier}`;
	  }
	  function createModeAwareCache() {
	    const underlying = /* @__PURE__ */ new Map();
	    const memoizedReverseKeys = /* @__PURE__ */ new Map();
	    const cache = {
	      get(specifier, mode) {
	        return underlying.get(getUnderlyingCacheKey(specifier, mode));
	      },
	      set(specifier, mode, value) {
	        underlying.set(getUnderlyingCacheKey(specifier, mode), value);
	        return cache;
	      },
	      delete(specifier, mode) {
	        underlying.delete(getUnderlyingCacheKey(specifier, mode));
	        return cache;
	      },
	      has(specifier, mode) {
	        return underlying.has(getUnderlyingCacheKey(specifier, mode));
	      },
	      forEach(cb) {
	        return underlying.forEach((elem, key) => {
	          const [specifier, mode] = memoizedReverseKeys.get(key);
	          return cb(elem, specifier, mode);
	        });
	      },
	      size() {
	        return underlying.size;
	      }
	    };
	    return cache;
	    function getUnderlyingCacheKey(specifier, mode) {
	      const result = createModeAwareCacheKey(specifier, mode);
	      memoizedReverseKeys.set(result, [specifier, mode]);
	      return result;
	    }
	  }
	  function getOriginalOrResolvedModuleFileName(result) {
	    return result.resolvedModule && (result.resolvedModule.originalPath || result.resolvedModule.resolvedFileName);
	  }
	  function getOriginalOrResolvedTypeReferenceFileName(result) {
	    return result.resolvedTypeReferenceDirective && (result.resolvedTypeReferenceDirective.originalPath || result.resolvedTypeReferenceDirective.resolvedFileName);
	  }
	  function createNonRelativeNameResolutionCache(currentDirectory, getCanonicalFileName, options, getResolvedFileName, optionsToRedirectsKey) {
	    const moduleNameToDirectoryMap = createCacheWithRedirects(options, optionsToRedirectsKey);
	    return {
	      getFromNonRelativeNameCache,
	      getOrCreateCacheForNonRelativeName,
	      clear: clear2,
	      update
	    };
	    function clear2() {
	      moduleNameToDirectoryMap.clear();
	    }
	    function update(options2) {
	      moduleNameToDirectoryMap.update(options2);
	    }
	    function getFromNonRelativeNameCache(nonRelativeModuleName, mode, directoryName, redirectedReference) {
	      var _a, _b;
	      Debug.assert(!isExternalModuleNameRelative(nonRelativeModuleName));
	      return (_b = (_a = moduleNameToDirectoryMap.getMapOfCacheRedirects(redirectedReference)) == null ? void 0 : _a.get(createModeAwareCacheKey(nonRelativeModuleName, mode))) == null ? void 0 : _b.get(directoryName);
	    }
	    function getOrCreateCacheForNonRelativeName(nonRelativeModuleName, mode, redirectedReference) {
	      Debug.assert(!isExternalModuleNameRelative(nonRelativeModuleName));
	      return getOrCreateCache(moduleNameToDirectoryMap, redirectedReference, createModeAwareCacheKey(nonRelativeModuleName, mode), createPerModuleNameCache);
	    }
	    function createPerModuleNameCache() {
	      const directoryPathMap = /* @__PURE__ */ new Map();
	      return { get, set };
	      function get(directory) {
	        return directoryPathMap.get(toPath(directory, currentDirectory, getCanonicalFileName));
	      }
	      function set(directory, result) {
	        const path = toPath(directory, currentDirectory, getCanonicalFileName);
	        if (directoryPathMap.has(path)) {
	          return;
	        }
	        directoryPathMap.set(path, result);
	        const resolvedFileName = getResolvedFileName(result);
	        const commonPrefix = resolvedFileName && getCommonPrefix(path, resolvedFileName);
	        let current = path;
	        while (current !== commonPrefix) {
	          const parent2 = getDirectoryPath(current);
	          if (parent2 === current || directoryPathMap.has(parent2)) {
	            break;
	          }
	          directoryPathMap.set(parent2, result);
	          current = parent2;
	        }
	      }
	      function getCommonPrefix(directory, resolution) {
	        const resolutionDirectory = toPath(getDirectoryPath(resolution), currentDirectory, getCanonicalFileName);
	        let i = 0;
	        const limit = Math.min(directory.length, resolutionDirectory.length);
	        while (i < limit && directory.charCodeAt(i) === resolutionDirectory.charCodeAt(i)) {
	          i++;
	        }
	        if (i === directory.length && (resolutionDirectory.length === i || resolutionDirectory[i] === directorySeparator)) {
	          return directory;
	        }
	        const rootLength = getRootLength(directory);
	        if (i < rootLength) {
	          return void 0;
	        }
	        const sep = directory.lastIndexOf(directorySeparator, i - 1);
	        if (sep === -1) {
	          return void 0;
	        }
	        return directory.substr(0, Math.max(sep, rootLength));
	      }
	    }
	  }
	  function createModuleOrTypeReferenceResolutionCache(currentDirectory, getCanonicalFileName, options, packageJsonInfoCache, getResolvedFileName, optionsToRedirectsKey) {
	    optionsToRedirectsKey ?? (optionsToRedirectsKey = /* @__PURE__ */ new Map());
	    const perDirectoryResolutionCache = createPerDirectoryResolutionCache(
	      currentDirectory,
	      getCanonicalFileName,
	      options,
	      optionsToRedirectsKey
	    );
	    const nonRelativeNameResolutionCache = createNonRelativeNameResolutionCache(
	      currentDirectory,
	      getCanonicalFileName,
	      options,
	      getResolvedFileName,
	      optionsToRedirectsKey
	    );
	    packageJsonInfoCache ?? (packageJsonInfoCache = createPackageJsonInfoCache(currentDirectory, getCanonicalFileName));
	    return {
	      ...packageJsonInfoCache,
	      ...perDirectoryResolutionCache,
	      ...nonRelativeNameResolutionCache,
	      clear: clear2,
	      update,
	      getPackageJsonInfoCache: () => packageJsonInfoCache,
	      clearAllExceptPackageJsonInfoCache,
	      optionsToRedirectsKey
	    };
	    function clear2() {
	      clearAllExceptPackageJsonInfoCache();
	      packageJsonInfoCache.clear();
	    }
	    function clearAllExceptPackageJsonInfoCache() {
	      perDirectoryResolutionCache.clear();
	      nonRelativeNameResolutionCache.clear();
	    }
	    function update(options2) {
	      perDirectoryResolutionCache.update(options2);
	      nonRelativeNameResolutionCache.update(options2);
	    }
	  }
	  function createModuleResolutionCache(currentDirectory, getCanonicalFileName, options, packageJsonInfoCache, optionsToRedirectsKey) {
	    const result = createModuleOrTypeReferenceResolutionCache(
	      currentDirectory,
	      getCanonicalFileName,
	      options,
	      packageJsonInfoCache,
	      getOriginalOrResolvedModuleFileName,
	      optionsToRedirectsKey
	    );
	    result.getOrCreateCacheForModuleName = (nonRelativeName, mode, redirectedReference) => result.getOrCreateCacheForNonRelativeName(nonRelativeName, mode, redirectedReference);
	    return result;
	  }
	  function createTypeReferenceDirectiveResolutionCache(currentDirectory, getCanonicalFileName, options, packageJsonInfoCache, optionsToRedirectsKey) {
	    return createModuleOrTypeReferenceResolutionCache(
	      currentDirectory,
	      getCanonicalFileName,
	      options,
	      packageJsonInfoCache,
	      getOriginalOrResolvedTypeReferenceFileName,
	      optionsToRedirectsKey
	    );
	  }
	  function getOptionsForLibraryResolution(options) {
	    return { moduleResolution: 2 /* Node10 */, traceResolution: options.traceResolution };
	  }
	  function resolveLibrary(libraryName, resolveFrom, compilerOptions, host, cache) {
	    return resolveModuleName(libraryName, resolveFrom, getOptionsForLibraryResolution(compilerOptions), host, cache);
	  }
	  function resolveModuleNameFromCache(moduleName, containingFile, cache, mode) {
	    const containingDirectory = getDirectoryPath(containingFile);
	    return cache.getFromDirectoryCache(
	      moduleName,
	      mode,
	      containingDirectory,
	      /*redirectedReference*/
	      void 0
	    );
	  }
	  function resolveModuleName(moduleName, containingFile, compilerOptions, host, cache, redirectedReference, resolutionMode) {
	    var _a, _b, _c;
	    const traceEnabled = isTraceEnabled(compilerOptions, host);
	    if (redirectedReference) {
	      compilerOptions = redirectedReference.commandLine.options;
	    }
	    if (traceEnabled) {
	      trace(host, Diagnostics.Resolving_module_0_from_1, moduleName, containingFile);
	      if (redirectedReference) {
	        trace(host, Diagnostics.Using_compiler_options_of_project_reference_redirect_0, redirectedReference.sourceFile.fileName);
	      }
	    }
	    const containingDirectory = getDirectoryPath(containingFile);
	    let result = cache == null ? void 0 : cache.getFromDirectoryCache(moduleName, resolutionMode, containingDirectory, redirectedReference);
	    if (result) {
	      if (traceEnabled) {
	        trace(host, Diagnostics.Resolution_for_module_0_was_found_in_cache_from_location_1, moduleName, containingDirectory);
	      }
	    } else {
	      let moduleResolution = compilerOptions.moduleResolution;
	      if (moduleResolution === void 0) {
	        moduleResolution = getEmitModuleResolutionKind(compilerOptions);
	        if (traceEnabled) {
	          trace(host, Diagnostics.Module_resolution_kind_is_not_specified_using_0, ModuleResolutionKind[moduleResolution]);
	        }
	      } else {
	        if (traceEnabled) {
	          trace(host, Diagnostics.Explicitly_specified_module_resolution_kind_Colon_0, ModuleResolutionKind[moduleResolution]);
	        }
	      }
	      (_a = perfLogger) == null ? void 0 : _a.logStartResolveModule(moduleName);
	      switch (moduleResolution) {
	        case 3 /* Node16 */:
	          result = node16ModuleNameResolver(moduleName, containingFile, compilerOptions, host, cache, redirectedReference, resolutionMode);
	          break;
	        case 99 /* NodeNext */:
	          result = nodeNextModuleNameResolver(moduleName, containingFile, compilerOptions, host, cache, redirectedReference, resolutionMode);
	          break;
	        case 2 /* Node10 */:
	          result = nodeModuleNameResolver(moduleName, containingFile, compilerOptions, host, cache, redirectedReference, resolutionMode ? getConditions(compilerOptions, resolutionMode) : void 0);
	          break;
	        case 1 /* Classic */:
	          result = classicNameResolver(moduleName, containingFile, compilerOptions, host, cache, redirectedReference);
	          break;
	        case 100 /* Bundler */:
	          result = bundlerModuleNameResolver(moduleName, containingFile, compilerOptions, host, cache, redirectedReference, resolutionMode ? getConditions(compilerOptions, resolutionMode) : void 0);
	          break;
	        default:
	          return Debug.fail(`Unexpected moduleResolution: ${moduleResolution}`);
	      }
	      if (result && result.resolvedModule)
	        (_b = perfLogger) == null ? void 0 : _b.logInfoEvent(`Module "${moduleName}" resolved to "${result.resolvedModule.resolvedFileName}"`);
	      (_c = perfLogger) == null ? void 0 : _c.logStopResolveModule(result && result.resolvedModule ? "" + result.resolvedModule.resolvedFileName : "null");
	      if (cache && !cache.isReadonly) {
	        cache.getOrCreateCacheForDirectory(containingDirectory, redirectedReference).set(moduleName, resolutionMode, result);
	        if (!isExternalModuleNameRelative(moduleName)) {
	          cache.getOrCreateCacheForNonRelativeName(moduleName, resolutionMode, redirectedReference).set(containingDirectory, result);
	        }
	      }
	    }
	    if (traceEnabled) {
	      if (result.resolvedModule) {
	        if (result.resolvedModule.packageId) {
	          trace(host, Diagnostics.Module_name_0_was_successfully_resolved_to_1_with_Package_ID_2, moduleName, result.resolvedModule.resolvedFileName, packageIdToString(result.resolvedModule.packageId));
	        } else {
	          trace(host, Diagnostics.Module_name_0_was_successfully_resolved_to_1, moduleName, result.resolvedModule.resolvedFileName);
	        }
	      } else {
	        trace(host, Diagnostics.Module_name_0_was_not_resolved, moduleName);
	      }
	    }
	    return result;
	  }
	  function tryLoadModuleUsingOptionalResolutionSettings(extensions, moduleName, containingDirectory, loader, state) {
	    const resolved = tryLoadModuleUsingPathsIfEligible(extensions, moduleName, loader, state);
	    if (resolved)
	      return resolved.value;
	    if (!isExternalModuleNameRelative(moduleName)) {
	      return tryLoadModuleUsingBaseUrl(extensions, moduleName, loader, state);
	    } else {
	      return tryLoadModuleUsingRootDirs(extensions, moduleName, containingDirectory, loader, state);
	    }
	  }
	  function tryLoadModuleUsingPathsIfEligible(extensions, moduleName, loader, state) {
	    var _a;
	    const { baseUrl, paths, configFile } = state.compilerOptions;
	    if (paths && !pathIsRelative(moduleName)) {
	      if (state.traceEnabled) {
	        if (baseUrl) {
	          trace(state.host, Diagnostics.baseUrl_option_is_set_to_0_using_this_value_to_resolve_non_relative_module_name_1, baseUrl, moduleName);
	        }
	        trace(state.host, Diagnostics.paths_option_is_specified_looking_for_a_pattern_to_match_module_name_0, moduleName);
	      }
	      const baseDirectory = getPathsBasePath(state.compilerOptions, state.host);
	      const pathPatterns = (configFile == null ? void 0 : configFile.configFileSpecs) ? (_a = configFile.configFileSpecs).pathPatterns || (_a.pathPatterns = tryParsePatterns(paths)) : void 0;
	      return tryLoadModuleUsingPaths(
	        extensions,
	        moduleName,
	        baseDirectory,
	        paths,
	        pathPatterns,
	        loader,
	        /*onlyRecordFailures*/
	        false,
	        state
	      );
	    }
	  }
	  function tryLoadModuleUsingRootDirs(extensions, moduleName, containingDirectory, loader, state) {
	    if (!state.compilerOptions.rootDirs) {
	      return void 0;
	    }
	    if (state.traceEnabled) {
	      trace(state.host, Diagnostics.rootDirs_option_is_set_using_it_to_resolve_relative_module_name_0, moduleName);
	    }
	    const candidate = normalizePath(combinePaths(containingDirectory, moduleName));
	    let matchedRootDir;
	    let matchedNormalizedPrefix;
	    for (const rootDir of state.compilerOptions.rootDirs) {
	      let normalizedRoot = normalizePath(rootDir);
	      if (!endsWith(normalizedRoot, directorySeparator)) {
	        normalizedRoot += directorySeparator;
	      }
	      const isLongestMatchingPrefix = startsWith(candidate, normalizedRoot) && (matchedNormalizedPrefix === void 0 || matchedNormalizedPrefix.length < normalizedRoot.length);
	      if (state.traceEnabled) {
	        trace(state.host, Diagnostics.Checking_if_0_is_the_longest_matching_prefix_for_1_2, normalizedRoot, candidate, isLongestMatchingPrefix);
	      }
	      if (isLongestMatchingPrefix) {
	        matchedNormalizedPrefix = normalizedRoot;
	        matchedRootDir = rootDir;
	      }
	    }
	    if (matchedNormalizedPrefix) {
	      if (state.traceEnabled) {
	        trace(state.host, Diagnostics.Longest_matching_prefix_for_0_is_1, candidate, matchedNormalizedPrefix);
	      }
	      const suffix = candidate.substr(matchedNormalizedPrefix.length);
	      if (state.traceEnabled) {
	        trace(state.host, Diagnostics.Loading_0_from_the_root_dir_1_candidate_location_2, suffix, matchedNormalizedPrefix, candidate);
	      }
	      const resolvedFileName = loader(extensions, candidate, !directoryProbablyExists(containingDirectory, state.host), state);
	      if (resolvedFileName) {
	        return resolvedFileName;
	      }
	      if (state.traceEnabled) {
	        trace(state.host, Diagnostics.Trying_other_entries_in_rootDirs);
	      }
	      for (const rootDir of state.compilerOptions.rootDirs) {
	        if (rootDir === matchedRootDir) {
	          continue;
	        }
	        const candidate2 = combinePaths(normalizePath(rootDir), suffix);
	        if (state.traceEnabled) {
	          trace(state.host, Diagnostics.Loading_0_from_the_root_dir_1_candidate_location_2, suffix, rootDir, candidate2);
	        }
	        const baseDirectory = getDirectoryPath(candidate2);
	        const resolvedFileName2 = loader(extensions, candidate2, !directoryProbablyExists(baseDirectory, state.host), state);
	        if (resolvedFileName2) {
	          return resolvedFileName2;
	        }
	      }
	      if (state.traceEnabled) {
	        trace(state.host, Diagnostics.Module_resolution_using_rootDirs_has_failed);
	      }
	    }
	    return void 0;
	  }
	  function tryLoadModuleUsingBaseUrl(extensions, moduleName, loader, state) {
	    const { baseUrl } = state.compilerOptions;
	    if (!baseUrl) {
	      return void 0;
	    }
	    if (state.traceEnabled) {
	      trace(state.host, Diagnostics.baseUrl_option_is_set_to_0_using_this_value_to_resolve_non_relative_module_name_1, baseUrl, moduleName);
	    }
	    const candidate = normalizePath(combinePaths(baseUrl, moduleName));
	    if (state.traceEnabled) {
	      trace(state.host, Diagnostics.Resolving_module_name_0_relative_to_base_url_1_2, moduleName, baseUrl, candidate);
	    }
	    return loader(extensions, candidate, !directoryProbablyExists(getDirectoryPath(candidate), state.host), state);
	  }
	  function resolveJSModule(moduleName, initialDir, host) {
	    const { resolvedModule, failedLookupLocations } = tryResolveJSModuleWorker(moduleName, initialDir, host);
	    if (!resolvedModule) {
	      throw new Error(`Could not resolve JS module '${moduleName}' starting at '${initialDir}'. Looked in: ${failedLookupLocations == null ? void 0 : failedLookupLocations.join(", ")}`);
	    }
	    return resolvedModule.resolvedFileName;
	  }
	  function node16ModuleNameResolver(moduleName, containingFile, compilerOptions, host, cache, redirectedReference, resolutionMode) {
	    return nodeNextModuleNameResolverWorker(
	      30 /* Node16Default */,
	      moduleName,
	      containingFile,
	      compilerOptions,
	      host,
	      cache,
	      redirectedReference,
	      resolutionMode
	    );
	  }
	  function nodeNextModuleNameResolver(moduleName, containingFile, compilerOptions, host, cache, redirectedReference, resolutionMode) {
	    return nodeNextModuleNameResolverWorker(
	      30 /* NodeNextDefault */,
	      moduleName,
	      containingFile,
	      compilerOptions,
	      host,
	      cache,
	      redirectedReference,
	      resolutionMode
	    );
	  }
	  function nodeNextModuleNameResolverWorker(features, moduleName, containingFile, compilerOptions, host, cache, redirectedReference, resolutionMode, conditions) {
	    const containingDirectory = getDirectoryPath(containingFile);
	    const esmMode = resolutionMode === 99 /* ESNext */ ? 32 /* EsmMode */ : 0;
	    let extensions = compilerOptions.noDtsResolution ? 3 /* ImplementationFiles */ : 1 /* TypeScript */ | 2 /* JavaScript */ | 4 /* Declaration */;
	    if (getResolveJsonModule(compilerOptions)) {
	      extensions |= 8 /* Json */;
	    }
	    return nodeModuleNameResolverWorker(
	      features | esmMode,
	      moduleName,
	      containingDirectory,
	      compilerOptions,
	      host,
	      cache,
	      extensions,
	      /*isConfigLookup*/
	      false,
	      redirectedReference,
	      conditions
	    );
	  }
	  function tryResolveJSModuleWorker(moduleName, initialDir, host) {
	    return nodeModuleNameResolverWorker(
	      0 /* None */,
	      moduleName,
	      initialDir,
	      { moduleResolution: 2 /* Node10 */, allowJs: true },
	      host,
	      /*cache*/
	      void 0,
	      2 /* JavaScript */,
	      /*isConfigLookup*/
	      false,
	      /*redirectedReference*/
	      void 0,
	      /*conditions*/
	      void 0
	    );
	  }
	  function bundlerModuleNameResolver(moduleName, containingFile, compilerOptions, host, cache, redirectedReference, conditions) {
	    const containingDirectory = getDirectoryPath(containingFile);
	    let extensions = compilerOptions.noDtsResolution ? 3 /* ImplementationFiles */ : 1 /* TypeScript */ | 2 /* JavaScript */ | 4 /* Declaration */;
	    if (getResolveJsonModule(compilerOptions)) {
	      extensions |= 8 /* Json */;
	    }
	    return nodeModuleNameResolverWorker(
	      getNodeResolutionFeatures(compilerOptions),
	      moduleName,
	      containingDirectory,
	      compilerOptions,
	      host,
	      cache,
	      extensions,
	      /*isConfigLookup*/
	      false,
	      redirectedReference,
	      conditions
	    );
	  }
	  function nodeModuleNameResolver(moduleName, containingFile, compilerOptions, host, cache, redirectedReference, conditions, isConfigLookup) {
	    let extensions;
	    if (isConfigLookup) {
	      extensions = 8 /* Json */;
	    } else if (compilerOptions.noDtsResolution) {
	      extensions = 3 /* ImplementationFiles */;
	      if (getResolveJsonModule(compilerOptions))
	        extensions |= 8 /* Json */;
	    } else {
	      extensions = getResolveJsonModule(compilerOptions) ? 1 /* TypeScript */ | 2 /* JavaScript */ | 4 /* Declaration */ | 8 /* Json */ : 1 /* TypeScript */ | 2 /* JavaScript */ | 4 /* Declaration */;
	    }
	    return nodeModuleNameResolverWorker(conditions ? 30 /* AllFeatures */ : 0 /* None */, moduleName, getDirectoryPath(containingFile), compilerOptions, host, cache, extensions, !!isConfigLookup, redirectedReference, conditions);
	  }
	  function nodeNextJsonConfigResolver(moduleName, containingFile, host) {
	    return nodeModuleNameResolverWorker(
	      30 /* NodeNextDefault */,
	      moduleName,
	      getDirectoryPath(containingFile),
	      { moduleResolution: 99 /* NodeNext */ },
	      host,
	      /*cache*/
	      void 0,
	      8 /* Json */,
	      /*isConfigLookup*/
	      true,
	      /*redirectedReference*/
	      void 0,
	      /*conditions*/
	      void 0
	    );
	  }
	  function nodeModuleNameResolverWorker(features, moduleName, containingDirectory, compilerOptions, host, cache, extensions, isConfigLookup, redirectedReference, conditions) {
	    var _a, _b, _c, _d, _e;
	    const traceEnabled = isTraceEnabled(compilerOptions, host);
	    const failedLookupLocations = [];
	    const affectingLocations = [];
	    const moduleResolution = getEmitModuleResolutionKind(compilerOptions);
	    conditions ?? (conditions = getConditions(
	      compilerOptions,
	      moduleResolution === 100 /* Bundler */ || moduleResolution === 2 /* Node10 */ ? void 0 : features & 32 /* EsmMode */ ? 99 /* ESNext */ : 1 /* CommonJS */
	    ));
	    const diagnostics = [];
	    const state = {
	      compilerOptions,
	      host,
	      traceEnabled,
	      failedLookupLocations,
	      affectingLocations,
	      packageJsonInfoCache: cache,
	      features,
	      conditions: conditions ?? emptyArray,
	      requestContainingDirectory: containingDirectory,
	      reportDiagnostic: (diag2) => void diagnostics.push(diag2),
	      isConfigLookup,
	      candidateIsFromPackageJsonField: false,
	      resolvedPackageDirectory: false
	    };
	    if (traceEnabled && moduleResolutionSupportsPackageJsonExportsAndImports(moduleResolution)) {
	      trace(host, Diagnostics.Resolving_in_0_mode_with_conditions_1, features & 32 /* EsmMode */ ? "ESM" : "CJS", state.conditions.map((c) => `'${c}'`).join(", "));
	    }
	    let result;
	    if (moduleResolution === 2 /* Node10 */) {
	      const priorityExtensions = extensions & (1 /* TypeScript */ | 4 /* Declaration */);
	      const secondaryExtensions = extensions & ~(1 /* TypeScript */ | 4 /* Declaration */);
	      result = priorityExtensions && tryResolve(priorityExtensions, state) || secondaryExtensions && tryResolve(secondaryExtensions, state) || void 0;
	    } else {
	      result = tryResolve(extensions, state);
	    }
	    let alternateResult;
	    if (state.resolvedPackageDirectory && !isConfigLookup && !isExternalModuleNameRelative(moduleName)) {
	      const wantedTypesButGotJs = (result == null ? void 0 : result.value) && extensions & (1 /* TypeScript */ | 4 /* Declaration */) && !extensionIsOk(1 /* TypeScript */ | 4 /* Declaration */, result.value.resolved.extension);
	      if (((_a = result == null ? void 0 : result.value) == null ? void 0 : _a.isExternalLibraryImport) && wantedTypesButGotJs && features & 8 /* Exports */ && (conditions == null ? void 0 : conditions.includes("import"))) {
	        traceIfEnabled(state, Diagnostics.Resolution_of_non_relative_name_failed_trying_with_modern_Node_resolution_features_disabled_to_see_if_npm_library_needs_configuration_update);
	        const diagnosticState = {
	          ...state,
	          features: state.features & ~8 /* Exports */,
	          reportDiagnostic: noop
	        };
	        const diagnosticResult = tryResolve(extensions & (1 /* TypeScript */ | 4 /* Declaration */), diagnosticState);
	        if ((_b = diagnosticResult == null ? void 0 : diagnosticResult.value) == null ? void 0 : _b.isExternalLibraryImport) {
	          alternateResult = diagnosticResult.value.resolved.path;
	        }
	      } else if ((!(result == null ? void 0 : result.value) || wantedTypesButGotJs) && moduleResolution === 2 /* Node10 */) {
	        traceIfEnabled(state, Diagnostics.Resolution_of_non_relative_name_failed_trying_with_moduleResolution_bundler_to_see_if_project_may_need_configuration_update);
	        const diagnosticsCompilerOptions = { ...state.compilerOptions, moduleResolution: 100 /* Bundler */ };
	        const diagnosticState = {
	          ...state,
	          compilerOptions: diagnosticsCompilerOptions,
	          features: 30 /* BundlerDefault */,
	          conditions: getConditions(diagnosticsCompilerOptions),
	          reportDiagnostic: noop
	        };
	        const diagnosticResult = tryResolve(extensions & (1 /* TypeScript */ | 4 /* Declaration */), diagnosticState);
	        if ((_c = diagnosticResult == null ? void 0 : diagnosticResult.value) == null ? void 0 : _c.isExternalLibraryImport) {
	          alternateResult = diagnosticResult.value.resolved.path;
	        }
	      }
	    }
	    return createResolvedModuleWithFailedLookupLocationsHandlingSymlink(
	      moduleName,
	      (_d = result == null ? void 0 : result.value) == null ? void 0 : _d.resolved,
	      (_e = result == null ? void 0 : result.value) == null ? void 0 : _e.isExternalLibraryImport,
	      failedLookupLocations,
	      affectingLocations,
	      diagnostics,
	      state,
	      cache,
	      alternateResult
	    );
	    function tryResolve(extensions2, state2) {
	      const loader = (extensions3, candidate, onlyRecordFailures, state3) => nodeLoadModuleByRelativeName(
	        extensions3,
	        candidate,
	        onlyRecordFailures,
	        state3,
	        /*considerPackageJson*/
	        true
	      );
	      const resolved = tryLoadModuleUsingOptionalResolutionSettings(extensions2, moduleName, containingDirectory, loader, state2);
	      if (resolved) {
	        return toSearchResult({ resolved, isExternalLibraryImport: pathContainsNodeModules(resolved.path) });
	      }
	      if (!isExternalModuleNameRelative(moduleName)) {
	        let resolved2;
	        if (features & 2 /* Imports */ && startsWith(moduleName, "#")) {
	          resolved2 = loadModuleFromImports(extensions2, moduleName, containingDirectory, state2, cache, redirectedReference);
	        }
	        if (!resolved2 && features & 4 /* SelfName */) {
	          resolved2 = loadModuleFromSelfNameReference(extensions2, moduleName, containingDirectory, state2, cache, redirectedReference);
	        }
	        if (!resolved2) {
	          if (moduleName.includes(":")) {
	            if (traceEnabled) {
	              trace(host, Diagnostics.Skipping_module_0_that_looks_like_an_absolute_URI_target_file_types_Colon_1, moduleName, formatExtensions(extensions2));
	            }
	            return void 0;
	          }
	          if (traceEnabled) {
	            trace(host, Diagnostics.Loading_module_0_from_node_modules_folder_target_file_types_Colon_1, moduleName, formatExtensions(extensions2));
	          }
	          resolved2 = loadModuleFromNearestNodeModulesDirectory(extensions2, moduleName, containingDirectory, state2, cache, redirectedReference);
	        }
	        if (extensions2 & 4 /* Declaration */) {
	          resolved2 ?? (resolved2 = resolveFromTypeRoot(moduleName, state2));
	        }
	        return resolved2 && { value: resolved2.value && { resolved: resolved2.value, isExternalLibraryImport: true } };
	      } else {
	        const { path: candidate, parts } = normalizePathForCJSResolution(containingDirectory, moduleName);
	        const resolved2 = nodeLoadModuleByRelativeName(
	          extensions2,
	          candidate,
	          /*onlyRecordFailures*/
	          false,
	          state2,
	          /*considerPackageJson*/
	          true
	        );
	        return resolved2 && toSearchResult({ resolved: resolved2, isExternalLibraryImport: contains(parts, "node_modules") });
	      }
	    }
	  }
	  function normalizePathForCJSResolution(containingDirectory, moduleName) {
	    const combined = combinePaths(containingDirectory, moduleName);
	    const parts = getPathComponents(combined);
	    const lastPart = lastOrUndefined(parts);
	    const path = lastPart === "." || lastPart === ".." ? ensureTrailingDirectorySeparator(normalizePath(combined)) : normalizePath(combined);
	    return { path, parts };
	  }
	  function realPath(path, host, traceEnabled) {
	    if (!host.realpath) {
	      return path;
	    }
	    const real = normalizePath(host.realpath(path));
	    if (traceEnabled) {
	      trace(host, Diagnostics.Resolving_real_path_for_0_result_1, path, real);
	    }
	    return real;
	  }
	  function nodeLoadModuleByRelativeName(extensions, candidate, onlyRecordFailures, state, considerPackageJson) {
	    if (state.traceEnabled) {
	      trace(state.host, Diagnostics.Loading_module_as_file_Slash_folder_candidate_module_location_0_target_file_types_Colon_1, candidate, formatExtensions(extensions));
	    }
	    if (!hasTrailingDirectorySeparator(candidate)) {
	      if (!onlyRecordFailures) {
	        const parentOfCandidate = getDirectoryPath(candidate);
	        if (!directoryProbablyExists(parentOfCandidate, state.host)) {
	          if (state.traceEnabled) {
	            trace(state.host, Diagnostics.Directory_0_does_not_exist_skipping_all_lookups_in_it, parentOfCandidate);
	          }
	          onlyRecordFailures = true;
	        }
	      }
	      const resolvedFromFile = loadModuleFromFile(extensions, candidate, onlyRecordFailures, state);
	      if (resolvedFromFile) {
	        const packageDirectory = considerPackageJson ? parseNodeModuleFromPath(resolvedFromFile.path) : void 0;
	        const packageInfo = packageDirectory ? getPackageJsonInfo(
	          packageDirectory,
	          /*onlyRecordFailures*/
	          false,
	          state
	        ) : void 0;
	        return withPackageId(packageInfo, resolvedFromFile);
	      }
	    }
	    if (!onlyRecordFailures) {
	      const candidateExists = directoryProbablyExists(candidate, state.host);
	      if (!candidateExists) {
	        if (state.traceEnabled) {
	          trace(state.host, Diagnostics.Directory_0_does_not_exist_skipping_all_lookups_in_it, candidate);
	        }
	        onlyRecordFailures = true;
	      }
	    }
	    if (!(state.features & 32 /* EsmMode */)) {
	      return loadNodeModuleFromDirectory(extensions, candidate, onlyRecordFailures, state, considerPackageJson);
	    }
	    return void 0;
	  }
	  function pathContainsNodeModules(path) {
	    return path.includes(nodeModulesPathPart);
	  }
	  function parseNodeModuleFromPath(resolved, isFolder) {
	    const path = normalizePath(resolved);
	    const idx = path.lastIndexOf(nodeModulesPathPart);
	    if (idx === -1) {
	      return void 0;
	    }
	    const indexAfterNodeModules = idx + nodeModulesPathPart.length;
	    let indexAfterPackageName = moveToNextDirectorySeparatorIfAvailable(path, indexAfterNodeModules, isFolder);
	    if (path.charCodeAt(indexAfterNodeModules) === 64 /* at */) {
	      indexAfterPackageName = moveToNextDirectorySeparatorIfAvailable(path, indexAfterPackageName, isFolder);
	    }
	    return path.slice(0, indexAfterPackageName);
	  }
	  function moveToNextDirectorySeparatorIfAvailable(path, prevSeparatorIndex, isFolder) {
	    const nextSeparatorIndex = path.indexOf(directorySeparator, prevSeparatorIndex + 1);
	    return nextSeparatorIndex === -1 ? isFolder ? path.length : prevSeparatorIndex : nextSeparatorIndex;
	  }
	  function loadModuleFromFileNoPackageId(extensions, candidate, onlyRecordFailures, state) {
	    return noPackageId(loadModuleFromFile(extensions, candidate, onlyRecordFailures, state));
	  }
	  function loadModuleFromFile(extensions, candidate, onlyRecordFailures, state) {
	    const resolvedByReplacingExtension = loadModuleFromFileNoImplicitExtensions(extensions, candidate, onlyRecordFailures, state);
	    if (resolvedByReplacingExtension) {
	      return resolvedByReplacingExtension;
	    }
	    if (!(state.features & 32 /* EsmMode */)) {
	      const resolvedByAddingExtension = tryAddingExtensions(candidate, extensions, "", onlyRecordFailures, state);
	      if (resolvedByAddingExtension) {
	        return resolvedByAddingExtension;
	      }
	    }
	  }
	  function loadModuleFromFileNoImplicitExtensions(extensions, candidate, onlyRecordFailures, state) {
	    const filename = getBaseFileName(candidate);
	    if (!filename.includes(".")) {
	      return void 0;
	    }
	    let extensionless = removeFileExtension(candidate);
	    if (extensionless === candidate) {
	      extensionless = candidate.substring(0, candidate.lastIndexOf("."));
	    }
	    const extension = candidate.substring(extensionless.length);
	    if (state.traceEnabled) {
	      trace(state.host, Diagnostics.File_name_0_has_a_1_extension_stripping_it, candidate, extension);
	    }
	    return tryAddingExtensions(extensionless, extensions, extension, onlyRecordFailures, state);
	  }
	  function loadFileNameFromPackageJsonField(extensions, candidate, onlyRecordFailures, state) {
	    if (extensions & 1 /* TypeScript */ && fileExtensionIsOneOf(candidate, supportedTSImplementationExtensions) || extensions & 4 /* Declaration */ && fileExtensionIsOneOf(candidate, supportedDeclarationExtensions)) {
	      const result = tryFile(candidate, onlyRecordFailures, state);
	      return result !== void 0 ? { path: candidate, ext: tryExtractTSExtension(candidate), resolvedUsingTsExtension: void 0 } : void 0;
	    }
	    if (state.isConfigLookup && extensions === 8 /* Json */ && fileExtensionIs(candidate, ".json" /* Json */)) {
	      const result = tryFile(candidate, onlyRecordFailures, state);
	      return result !== void 0 ? { path: candidate, ext: ".json" /* Json */, resolvedUsingTsExtension: void 0 } : void 0;
	    }
	    return loadModuleFromFileNoImplicitExtensions(extensions, candidate, onlyRecordFailures, state);
	  }
	  function tryAddingExtensions(candidate, extensions, originalExtension, onlyRecordFailures, state) {
	    if (!onlyRecordFailures) {
	      const directory = getDirectoryPath(candidate);
	      if (directory) {
	        onlyRecordFailures = !directoryProbablyExists(directory, state.host);
	      }
	    }
	    switch (originalExtension) {
	      case ".mjs" /* Mjs */:
	      case ".mts" /* Mts */:
	      case ".d.mts" /* Dmts */:
	        return extensions & 1 /* TypeScript */ && tryExtension(".mts" /* Mts */, originalExtension === ".mts" /* Mts */ || originalExtension === ".d.mts" /* Dmts */) || extensions & 4 /* Declaration */ && tryExtension(".d.mts" /* Dmts */, originalExtension === ".mts" /* Mts */ || originalExtension === ".d.mts" /* Dmts */) || extensions & 2 /* JavaScript */ && tryExtension(".mjs" /* Mjs */) || void 0;
	      case ".cjs" /* Cjs */:
	      case ".cts" /* Cts */:
	      case ".d.cts" /* Dcts */:
	        return extensions & 1 /* TypeScript */ && tryExtension(".cts" /* Cts */, originalExtension === ".cts" /* Cts */ || originalExtension === ".d.cts" /* Dcts */) || extensions & 4 /* Declaration */ && tryExtension(".d.cts" /* Dcts */, originalExtension === ".cts" /* Cts */ || originalExtension === ".d.cts" /* Dcts */) || extensions & 2 /* JavaScript */ && tryExtension(".cjs" /* Cjs */) || void 0;
	      case ".json" /* Json */:
	        return extensions & 4 /* Declaration */ && tryExtension(".d.json.ts") || extensions & 8 /* Json */ && tryExtension(".json" /* Json */) || void 0;
	      case ".tsx" /* Tsx */:
	      case ".jsx" /* Jsx */:
	        return extensions & 1 /* TypeScript */ && (tryExtension(".tsx" /* Tsx */, originalExtension === ".tsx" /* Tsx */) || tryExtension(".ts" /* Ts */, originalExtension === ".tsx" /* Tsx */)) || extensions & 4 /* Declaration */ && tryExtension(".d.ts" /* Dts */, originalExtension === ".tsx" /* Tsx */) || extensions & 2 /* JavaScript */ && (tryExtension(".jsx" /* Jsx */) || tryExtension(".js" /* Js */)) || void 0;
	      case ".ts" /* Ts */:
	      case ".d.ts" /* Dts */:
	      case ".js" /* Js */:
	      case "":
	        return extensions & 1 /* TypeScript */ && (tryExtension(".ts" /* Ts */, originalExtension === ".ts" /* Ts */ || originalExtension === ".d.ts" /* Dts */) || tryExtension(".tsx" /* Tsx */, originalExtension === ".ts" /* Ts */ || originalExtension === ".d.ts" /* Dts */)) || extensions & 4 /* Declaration */ && tryExtension(".d.ts" /* Dts */, originalExtension === ".ts" /* Ts */ || originalExtension === ".d.ts" /* Dts */) || extensions & 2 /* JavaScript */ && (tryExtension(".js" /* Js */) || tryExtension(".jsx" /* Jsx */)) || state.isConfigLookup && tryExtension(".json" /* Json */) || void 0;
	      default:
	        return extensions & 4 /* Declaration */ && !isDeclarationFileName(candidate + originalExtension) && tryExtension(`.d${originalExtension}.ts`) || void 0;
	    }
	    function tryExtension(ext, resolvedUsingTsExtension) {
	      const path = tryFile(candidate + ext, onlyRecordFailures, state);
	      return path === void 0 ? void 0 : { path, ext, resolvedUsingTsExtension: !state.candidateIsFromPackageJsonField && resolvedUsingTsExtension };
	    }
	  }
	  function tryFile(fileName, onlyRecordFailures, state) {
	    var _a;
	    if (!((_a = state.compilerOptions.moduleSuffixes) == null ? void 0 : _a.length)) {
	      return tryFileLookup(fileName, onlyRecordFailures, state);
	    }
	    const ext = tryGetExtensionFromPath2(fileName) ?? "";
	    const fileNameNoExtension = ext ? removeExtension(fileName, ext) : fileName;
	    return forEach(state.compilerOptions.moduleSuffixes, (suffix) => tryFileLookup(fileNameNoExtension + suffix + ext, onlyRecordFailures, state));
	  }
	  function tryFileLookup(fileName, onlyRecordFailures, state) {
	    var _a;
	    if (!onlyRecordFailures) {
	      if (state.host.fileExists(fileName)) {
	        if (state.traceEnabled) {
	          trace(state.host, Diagnostics.File_0_exists_use_it_as_a_name_resolution_result, fileName);
	        }
	        return fileName;
	      } else {
	        if (state.traceEnabled) {
	          trace(state.host, Diagnostics.File_0_does_not_exist, fileName);
	        }
	      }
	    }
	    (_a = state.failedLookupLocations) == null ? void 0 : _a.push(fileName);
	    return void 0;
	  }
	  function loadNodeModuleFromDirectory(extensions, candidate, onlyRecordFailures, state, considerPackageJson = true) {
	    const packageInfo = considerPackageJson ? getPackageJsonInfo(candidate, onlyRecordFailures, state) : void 0;
	    const packageJsonContent = packageInfo && packageInfo.contents.packageJsonContent;
	    const versionPaths = packageInfo && getVersionPathsOfPackageJsonInfo(packageInfo, state);
	    return withPackageId(packageInfo, loadNodeModuleFromDirectoryWorker(extensions, candidate, onlyRecordFailures, state, packageJsonContent, versionPaths));
	  }
	  function getEntrypointsFromPackageJsonInfo(packageJsonInfo, options, host, cache, resolveJs) {
	    if (!resolveJs && packageJsonInfo.contents.resolvedEntrypoints !== void 0) {
	      return packageJsonInfo.contents.resolvedEntrypoints;
	    }
	    let entrypoints;
	    const extensions = 1 /* TypeScript */ | 4 /* Declaration */ | (resolveJs ? 2 /* JavaScript */ : 0);
	    const features = getNodeResolutionFeatures(options);
	    const loadPackageJsonMainState = getTemporaryModuleResolutionState(cache == null ? void 0 : cache.getPackageJsonInfoCache(), host, options);
	    loadPackageJsonMainState.conditions = getConditions(options);
	    loadPackageJsonMainState.requestContainingDirectory = packageJsonInfo.packageDirectory;
	    const mainResolution = loadNodeModuleFromDirectoryWorker(
	      extensions,
	      packageJsonInfo.packageDirectory,
	      /*onlyRecordFailures*/
	      false,
	      loadPackageJsonMainState,
	      packageJsonInfo.contents.packageJsonContent,
	      getVersionPathsOfPackageJsonInfo(packageJsonInfo, loadPackageJsonMainState)
	    );
	    entrypoints = append(entrypoints, mainResolution == null ? void 0 : mainResolution.path);
	    if (features & 8 /* Exports */ && packageJsonInfo.contents.packageJsonContent.exports) {
	      const conditionSets = deduplicate(
	        [getConditions(options, 99 /* ESNext */), getConditions(options, 1 /* CommonJS */)],
	        arrayIsEqualTo
	      );
	      for (const conditions of conditionSets) {
	        const loadPackageJsonExportsState = { ...loadPackageJsonMainState, failedLookupLocations: [], conditions, host };
	        const exportResolutions = loadEntrypointsFromExportMap(
	          packageJsonInfo,
	          packageJsonInfo.contents.packageJsonContent.exports,
	          loadPackageJsonExportsState,
	          extensions
	        );
	        if (exportResolutions) {
	          for (const resolution of exportResolutions) {
	            entrypoints = appendIfUnique(entrypoints, resolution.path);
	          }
	        }
	      }
	    }
	    return packageJsonInfo.contents.resolvedEntrypoints = entrypoints || false;
	  }
	  function loadEntrypointsFromExportMap(scope, exports, state, extensions) {
	    let entrypoints;
	    if (isArray(exports)) {
	      for (const target of exports) {
	        loadEntrypointsFromTargetExports(target);
	      }
	    } else if (typeof exports === "object" && exports !== null && allKeysStartWithDot(exports)) {
	      for (const key in exports) {
	        loadEntrypointsFromTargetExports(exports[key]);
	      }
	    } else {
	      loadEntrypointsFromTargetExports(exports);
	    }
	    return entrypoints;
	    function loadEntrypointsFromTargetExports(target) {
	      var _a, _b;
	      if (typeof target === "string" && startsWith(target, "./")) {
	        if (target.includes("*") && state.host.readDirectory) {
	          if (target.indexOf("*") !== target.lastIndexOf("*")) {
	            return false;
	          }
	          state.host.readDirectory(
	            scope.packageDirectory,
	            extensionsToExtensionsArray(extensions),
	            /*excludes*/
	            void 0,
	            [
	              changeFullExtension(replaceFirstStar(target, "**/*"), ".*")
	            ]
	          ).forEach((entry) => {
	            entrypoints = appendIfUnique(entrypoints, {
	              path: entry,
	              ext: getAnyExtensionFromPath(entry),
	              resolvedUsingTsExtension: void 0
	            });
	          });
	        } else {
	          const partsAfterFirst = getPathComponents(target).slice(2);
	          if (partsAfterFirst.includes("..") || partsAfterFirst.includes(".") || partsAfterFirst.includes("node_modules")) {
	            return false;
	          }
	          const resolvedTarget = combinePaths(scope.packageDirectory, target);
	          const finalPath = getNormalizedAbsolutePath(resolvedTarget, (_b = (_a = state.host).getCurrentDirectory) == null ? void 0 : _b.call(_a));
	          const result = loadFileNameFromPackageJsonField(
	            extensions,
	            finalPath,
	            /*onlyRecordFailures*/
	            false,
	            state
	          );
	          if (result) {
	            entrypoints = appendIfUnique(entrypoints, result, (a, b) => a.path === b.path);
	            return true;
	          }
	        }
	      } else if (Array.isArray(target)) {
	        for (const t of target) {
	          const success = loadEntrypointsFromTargetExports(t);
	          if (success) {
	            return true;
	          }
	        }
	      } else if (typeof target === "object" && target !== null) {
	        return forEach(getOwnKeys(target), (key) => {
	          if (key === "default" || contains(state.conditions, key) || isApplicableVersionedTypesKey(state.conditions, key)) {
	            loadEntrypointsFromTargetExports(target[key]);
	            return true;
	          }
	        });
	      }
	    }
	  }
	  function getTemporaryModuleResolutionState(packageJsonInfoCache, host, options) {
	    return {
	      host,
	      compilerOptions: options,
	      traceEnabled: isTraceEnabled(options, host),
	      failedLookupLocations: void 0,
	      affectingLocations: void 0,
	      packageJsonInfoCache,
	      features: 0 /* None */,
	      conditions: emptyArray,
	      requestContainingDirectory: void 0,
	      reportDiagnostic: noop,
	      isConfigLookup: false,
	      candidateIsFromPackageJsonField: false,
	      resolvedPackageDirectory: false
	    };
	  }
	  function getPackageScopeForPath(fileName, state) {
	    const parts = getPathComponents(fileName);
	    parts.pop();
	    while (parts.length > 0) {
	      const pkg = getPackageJsonInfo(
	        getPathFromPathComponents(parts),
	        /*onlyRecordFailures*/
	        false,
	        state
	      );
	      if (pkg) {
	        return pkg;
	      }
	      parts.pop();
	    }
	    return void 0;
	  }
	  function getVersionPathsOfPackageJsonInfo(packageJsonInfo, state) {
	    if (packageJsonInfo.contents.versionPaths === void 0) {
	      packageJsonInfo.contents.versionPaths = readPackageJsonTypesVersionPaths(packageJsonInfo.contents.packageJsonContent, state) || false;
	    }
	    return packageJsonInfo.contents.versionPaths || void 0;
	  }
	  function getPackageJsonInfo(packageDirectory, onlyRecordFailures, state) {
	    var _a, _b, _c, _d, _e, _f;
	    const { host, traceEnabled } = state;
	    const packageJsonPath = combinePaths(packageDirectory, "package.json");
	    if (onlyRecordFailures) {
	      (_a = state.failedLookupLocations) == null ? void 0 : _a.push(packageJsonPath);
	      return void 0;
	    }
	    const existing = (_b = state.packageJsonInfoCache) == null ? void 0 : _b.getPackageJsonInfo(packageJsonPath);
	    if (existing !== void 0) {
	      if (isPackageJsonInfo(existing)) {
	        if (traceEnabled)
	          trace(host, Diagnostics.File_0_exists_according_to_earlier_cached_lookups, packageJsonPath);
	        (_c = state.affectingLocations) == null ? void 0 : _c.push(packageJsonPath);
	        return existing.packageDirectory === packageDirectory ? existing : { packageDirectory, contents: existing.contents };
	      } else {
	        if (existing.directoryExists && traceEnabled)
	          trace(host, Diagnostics.File_0_does_not_exist_according_to_earlier_cached_lookups, packageJsonPath);
	        (_d = state.failedLookupLocations) == null ? void 0 : _d.push(packageJsonPath);
	        return void 0;
	      }
	    }
	    const directoryExists = directoryProbablyExists(packageDirectory, host);
	    if (directoryExists && host.fileExists(packageJsonPath)) {
	      const packageJsonContent = readJson(packageJsonPath, host);
	      if (traceEnabled) {
	        trace(host, Diagnostics.Found_package_json_at_0, packageJsonPath);
	      }
	      const result = { packageDirectory, contents: { packageJsonContent, versionPaths: void 0, resolvedEntrypoints: void 0 } };
	      if (state.packageJsonInfoCache && !state.packageJsonInfoCache.isReadonly)
	        state.packageJsonInfoCache.setPackageJsonInfo(packageJsonPath, result);
	      (_e = state.affectingLocations) == null ? void 0 : _e.push(packageJsonPath);
	      return result;
	    } else {
	      if (directoryExists && traceEnabled) {
	        trace(host, Diagnostics.File_0_does_not_exist, packageJsonPath);
	      }
	      if (state.packageJsonInfoCache && !state.packageJsonInfoCache.isReadonly)
	        state.packageJsonInfoCache.setPackageJsonInfo(packageJsonPath, { packageDirectory, directoryExists });
	      (_f = state.failedLookupLocations) == null ? void 0 : _f.push(packageJsonPath);
	    }
	  }
	  function loadNodeModuleFromDirectoryWorker(extensions, candidate, onlyRecordFailures, state, jsonContent, versionPaths) {
	    let packageFile;
	    if (jsonContent) {
	      if (state.isConfigLookup) {
	        packageFile = readPackageJsonTSConfigField(jsonContent, candidate, state);
	      } else {
	        packageFile = extensions & 4 /* Declaration */ && readPackageJsonTypesFields(jsonContent, candidate, state) || extensions & (3 /* ImplementationFiles */ | 4 /* Declaration */) && readPackageJsonMainField(jsonContent, candidate, state) || void 0;
	      }
	    }
	    const loader = (extensions2, candidate2, onlyRecordFailures2, state2) => {
	      const fromFile = loadFileNameFromPackageJsonField(extensions2, candidate2, onlyRecordFailures2, state2);
	      if (fromFile) {
	        return noPackageId(fromFile);
	      }
	      const expandedExtensions = extensions2 === 4 /* Declaration */ ? 1 /* TypeScript */ | 4 /* Declaration */ : extensions2;
	      const features = state2.features;
	      const candidateIsFromPackageJsonField = state2.candidateIsFromPackageJsonField;
	      state2.candidateIsFromPackageJsonField = true;
	      if ((jsonContent == null ? void 0 : jsonContent.type) !== "module") {
	        state2.features &= ~32 /* EsmMode */;
	      }
	      const result = nodeLoadModuleByRelativeName(
	        expandedExtensions,
	        candidate2,
	        onlyRecordFailures2,
	        state2,
	        /*considerPackageJson*/
	        false
	      );
	      state2.features = features;
	      state2.candidateIsFromPackageJsonField = candidateIsFromPackageJsonField;
	      return result;
	    };
	    const onlyRecordFailuresForPackageFile = packageFile ? !directoryProbablyExists(getDirectoryPath(packageFile), state.host) : void 0;
	    const onlyRecordFailuresForIndex = onlyRecordFailures || !directoryProbablyExists(candidate, state.host);
	    const indexPath = combinePaths(candidate, state.isConfigLookup ? "tsconfig" : "index");
	    if (versionPaths && (!packageFile || containsPath(candidate, packageFile))) {
	      const moduleName = getRelativePathFromDirectory(
	        candidate,
	        packageFile || indexPath,
	        /*ignoreCase*/
	        false
	      );
	      if (state.traceEnabled) {
	        trace(state.host, Diagnostics.package_json_has_a_typesVersions_entry_0_that_matches_compiler_version_1_looking_for_a_pattern_to_match_module_name_2, versionPaths.version, version, moduleName);
	      }
	      const result = tryLoadModuleUsingPaths(
	        extensions,
	        moduleName,
	        candidate,
	        versionPaths.paths,
	        /*pathPatterns*/
	        void 0,
	        loader,
	        onlyRecordFailuresForPackageFile || onlyRecordFailuresForIndex,
	        state
	      );
	      if (result) {
	        return removeIgnoredPackageId(result.value);
	      }
	    }
	    const packageFileResult = packageFile && removeIgnoredPackageId(loader(extensions, packageFile, onlyRecordFailuresForPackageFile, state));
	    if (packageFileResult)
	      return packageFileResult;
	    if (!(state.features & 32 /* EsmMode */)) {
	      return loadModuleFromFile(extensions, indexPath, onlyRecordFailuresForIndex, state);
	    }
	  }
	  function extensionIsOk(extensions, extension) {
	    return extensions & 2 /* JavaScript */ && (extension === ".js" /* Js */ || extension === ".jsx" /* Jsx */ || extension === ".mjs" /* Mjs */ || extension === ".cjs" /* Cjs */) || extensions & 1 /* TypeScript */ && (extension === ".ts" /* Ts */ || extension === ".tsx" /* Tsx */ || extension === ".mts" /* Mts */ || extension === ".cts" /* Cts */) || extensions & 4 /* Declaration */ && (extension === ".d.ts" /* Dts */ || extension === ".d.mts" /* Dmts */ || extension === ".d.cts" /* Dcts */) || extensions & 8 /* Json */ && extension === ".json" /* Json */ || false;
	  }
	  function parsePackageName(moduleName) {
	    let idx = moduleName.indexOf(directorySeparator);
	    if (moduleName[0] === "@") {
	      idx = moduleName.indexOf(directorySeparator, idx + 1);
	    }
	    return idx === -1 ? { packageName: moduleName, rest: "" } : { packageName: moduleName.slice(0, idx), rest: moduleName.slice(idx + 1) };
	  }
	  function allKeysStartWithDot(obj) {
	    return every(getOwnKeys(obj), (k) => startsWith(k, "."));
	  }
	  function noKeyStartsWithDot(obj) {
	    return !some(getOwnKeys(obj), (k) => startsWith(k, "."));
	  }
	  function loadModuleFromSelfNameReference(extensions, moduleName, directory, state, cache, redirectedReference) {
	    var _a, _b;
	    const directoryPath = getNormalizedAbsolutePath(combinePaths(directory, "dummy"), (_b = (_a = state.host).getCurrentDirectory) == null ? void 0 : _b.call(_a));
	    const scope = getPackageScopeForPath(directoryPath, state);
	    if (!scope || !scope.contents.packageJsonContent.exports) {
	      return void 0;
	    }
	    if (typeof scope.contents.packageJsonContent.name !== "string") {
	      return void 0;
	    }
	    const parts = getPathComponents(moduleName);
	    const nameParts = getPathComponents(scope.contents.packageJsonContent.name);
	    if (!every(nameParts, (p, i) => parts[i] === p)) {
	      return void 0;
	    }
	    const trailingParts = parts.slice(nameParts.length);
	    const subpath = !length(trailingParts) ? "." : `.${directorySeparator}${trailingParts.join(directorySeparator)}`;
	    if (getAllowJSCompilerOption(state.compilerOptions) && !pathContainsNodeModules(directory)) {
	      return loadModuleFromExports(scope, extensions, subpath, state, cache, redirectedReference);
	    }
	    const priorityExtensions = extensions & (1 /* TypeScript */ | 4 /* Declaration */);
	    const secondaryExtensions = extensions & ~(1 /* TypeScript */ | 4 /* Declaration */);
	    return loadModuleFromExports(scope, priorityExtensions, subpath, state, cache, redirectedReference) || loadModuleFromExports(scope, secondaryExtensions, subpath, state, cache, redirectedReference);
	  }
	  function loadModuleFromExports(scope, extensions, subpath, state, cache, redirectedReference) {
	    if (!scope.contents.packageJsonContent.exports) {
	      return void 0;
	    }
	    if (subpath === ".") {
	      let mainExport;
	      if (typeof scope.contents.packageJsonContent.exports === "string" || Array.isArray(scope.contents.packageJsonContent.exports) || typeof scope.contents.packageJsonContent.exports === "object" && noKeyStartsWithDot(scope.contents.packageJsonContent.exports)) {
	        mainExport = scope.contents.packageJsonContent.exports;
	      } else if (hasProperty(scope.contents.packageJsonContent.exports, ".")) {
	        mainExport = scope.contents.packageJsonContent.exports["."];
	      }
	      if (mainExport) {
	        const loadModuleFromTargetImportOrExport = getLoadModuleFromTargetImportOrExport(
	          extensions,
	          state,
	          cache,
	          redirectedReference,
	          subpath,
	          scope,
	          /*isImports*/
	          false
	        );
	        return loadModuleFromTargetImportOrExport(
	          mainExport,
	          "",
	          /*pattern*/
	          false,
	          "."
	        );
	      }
	    } else if (allKeysStartWithDot(scope.contents.packageJsonContent.exports)) {
	      if (typeof scope.contents.packageJsonContent.exports !== "object") {
	        if (state.traceEnabled) {
	          trace(state.host, Diagnostics.Export_specifier_0_does_not_exist_in_package_json_scope_at_path_1, subpath, scope.packageDirectory);
	        }
	        return toSearchResult(
	          /*value*/
	          void 0
	        );
	      }
	      const result = loadModuleFromImportsOrExports(
	        extensions,
	        state,
	        cache,
	        redirectedReference,
	        subpath,
	        scope.contents.packageJsonContent.exports,
	        scope,
	        /*isImports*/
	        false
	      );
	      if (result) {
	        return result;
	      }
	    }
	    if (state.traceEnabled) {
	      trace(state.host, Diagnostics.Export_specifier_0_does_not_exist_in_package_json_scope_at_path_1, subpath, scope.packageDirectory);
	    }
	    return toSearchResult(
	      /*value*/
	      void 0
	    );
	  }
	  function loadModuleFromImports(extensions, moduleName, directory, state, cache, redirectedReference) {
	    var _a, _b;
	    if (moduleName === "#" || startsWith(moduleName, "#/")) {
	      if (state.traceEnabled) {
	        trace(state.host, Diagnostics.Invalid_import_specifier_0_has_no_possible_resolutions, moduleName);
	      }
	      return toSearchResult(
	        /*value*/
	        void 0
	      );
	    }
	    const directoryPath = getNormalizedAbsolutePath(combinePaths(directory, "dummy"), (_b = (_a = state.host).getCurrentDirectory) == null ? void 0 : _b.call(_a));
	    const scope = getPackageScopeForPath(directoryPath, state);
	    if (!scope) {
	      if (state.traceEnabled) {
	        trace(state.host, Diagnostics.Directory_0_has_no_containing_package_json_scope_Imports_will_not_resolve, directoryPath);
	      }
	      return toSearchResult(
	        /*value*/
	        void 0
	      );
	    }
	    if (!scope.contents.packageJsonContent.imports) {
	      if (state.traceEnabled) {
	        trace(state.host, Diagnostics.package_json_scope_0_has_no_imports_defined, scope.packageDirectory);
	      }
	      return toSearchResult(
	        /*value*/
	        void 0
	      );
	    }
	    const result = loadModuleFromImportsOrExports(
	      extensions,
	      state,
	      cache,
	      redirectedReference,
	      moduleName,
	      scope.contents.packageJsonContent.imports,
	      scope,
	      /*isImports*/
	      true
	    );
	    if (result) {
	      return result;
	    }
	    if (state.traceEnabled) {
	      trace(state.host, Diagnostics.Import_specifier_0_does_not_exist_in_package_json_scope_at_path_1, moduleName, scope.packageDirectory);
	    }
	    return toSearchResult(
	      /*value*/
	      void 0
	    );
	  }
	  function comparePatternKeys(a, b) {
	    const aPatternIndex = a.indexOf("*");
	    const bPatternIndex = b.indexOf("*");
	    const baseLenA = aPatternIndex === -1 ? a.length : aPatternIndex + 1;
	    const baseLenB = bPatternIndex === -1 ? b.length : bPatternIndex + 1;
	    if (baseLenA > baseLenB)
	      return -1;
	    if (baseLenB > baseLenA)
	      return 1;
	    if (aPatternIndex === -1)
	      return 1;
	    if (bPatternIndex === -1)
	      return -1;
	    if (a.length > b.length)
	      return -1;
	    if (b.length > a.length)
	      return 1;
	    return 0;
	  }
	  function loadModuleFromImportsOrExports(extensions, state, cache, redirectedReference, moduleName, lookupTable, scope, isImports) {
	    const loadModuleFromTargetImportOrExport = getLoadModuleFromTargetImportOrExport(extensions, state, cache, redirectedReference, moduleName, scope, isImports);
	    if (!endsWith(moduleName, directorySeparator) && !moduleName.includes("*") && hasProperty(lookupTable, moduleName)) {
	      const target = lookupTable[moduleName];
	      return loadModuleFromTargetImportOrExport(
	        target,
	        /*subpath*/
	        "",
	        /*pattern*/
	        false,
	        moduleName
	      );
	    }
	    const expandingKeys = sort(filter(getOwnKeys(lookupTable), (k) => k.includes("*") || endsWith(k, "/")), comparePatternKeys);
	    for (const potentialTarget of expandingKeys) {
	      if (state.features & 16 /* ExportsPatternTrailers */ && matchesPatternWithTrailer(potentialTarget, moduleName)) {
	        const target = lookupTable[potentialTarget];
	        const starPos = potentialTarget.indexOf("*");
	        const subpath = moduleName.substring(potentialTarget.substring(0, starPos).length, moduleName.length - (potentialTarget.length - 1 - starPos));
	        return loadModuleFromTargetImportOrExport(
	          target,
	          subpath,
	          /*pattern*/
	          true,
	          potentialTarget
	        );
	      } else if (endsWith(potentialTarget, "*") && startsWith(moduleName, potentialTarget.substring(0, potentialTarget.length - 1))) {
	        const target = lookupTable[potentialTarget];
	        const subpath = moduleName.substring(potentialTarget.length - 1);
	        return loadModuleFromTargetImportOrExport(
	          target,
	          subpath,
	          /*pattern*/
	          true,
	          potentialTarget
	        );
	      } else if (startsWith(moduleName, potentialTarget)) {
	        const target = lookupTable[potentialTarget];
	        const subpath = moduleName.substring(potentialTarget.length);
	        return loadModuleFromTargetImportOrExport(
	          target,
	          subpath,
	          /*pattern*/
	          false,
	          potentialTarget
	        );
	      }
	    }
	    function matchesPatternWithTrailer(target, name) {
	      if (endsWith(target, "*"))
	        return false;
	      const starPos = target.indexOf("*");
	      if (starPos === -1)
	        return false;
	      return startsWith(name, target.substring(0, starPos)) && endsWith(name, target.substring(starPos + 1));
	    }
	  }
	  function getLoadModuleFromTargetImportOrExport(extensions, state, cache, redirectedReference, moduleName, scope, isImports) {
	    return loadModuleFromTargetImportOrExport;
	    function loadModuleFromTargetImportOrExport(target, subpath, pattern, key) {
	      if (typeof target === "string") {
	        if (!pattern && subpath.length > 0 && !endsWith(target, "/")) {
	          if (state.traceEnabled) {
	            trace(state.host, Diagnostics.package_json_scope_0_has_invalid_type_for_target_of_specifier_1, scope.packageDirectory, moduleName);
	          }
	          return toSearchResult(
	            /*value*/
	            void 0
	          );
	        }
	        if (!startsWith(target, "./")) {
	          if (isImports && !startsWith(target, "../") && !startsWith(target, "/") && !isRootedDiskPath(target)) {
	            const combinedLookup = pattern ? target.replace(/\*/g, subpath) : target + subpath;
	            traceIfEnabled(state, Diagnostics.Using_0_subpath_1_with_target_2, "imports", key, combinedLookup);
	            traceIfEnabled(state, Diagnostics.Resolving_module_0_from_1, combinedLookup, scope.packageDirectory + "/");
	            const result = nodeModuleNameResolverWorker(
	              state.features,
	              combinedLookup,
	              scope.packageDirectory + "/",
	              state.compilerOptions,
	              state.host,
	              cache,
	              extensions,
	              /*isConfigLookup*/
	              false,
	              redirectedReference,
	              state.conditions
	            );
	            return toSearchResult(
	              result.resolvedModule ? {
	                path: result.resolvedModule.resolvedFileName,
	                extension: result.resolvedModule.extension,
	                packageId: result.resolvedModule.packageId,
	                originalPath: result.resolvedModule.originalPath,
	                resolvedUsingTsExtension: result.resolvedModule.resolvedUsingTsExtension
	              } : void 0
	            );
	          }
	          if (state.traceEnabled) {
	            trace(state.host, Diagnostics.package_json_scope_0_has_invalid_type_for_target_of_specifier_1, scope.packageDirectory, moduleName);
	          }
	          return toSearchResult(
	            /*value*/
	            void 0
	          );
	        }
	        const parts = pathIsRelative(target) ? getPathComponents(target).slice(1) : getPathComponents(target);
	        const partsAfterFirst = parts.slice(1);
	        if (partsAfterFirst.includes("..") || partsAfterFirst.includes(".") || partsAfterFirst.includes("node_modules")) {
	          if (state.traceEnabled) {
	            trace(state.host, Diagnostics.package_json_scope_0_has_invalid_type_for_target_of_specifier_1, scope.packageDirectory, moduleName);
	          }
	          return toSearchResult(
	            /*value*/
	            void 0
	          );
	        }
	        const resolvedTarget = combinePaths(scope.packageDirectory, target);
	        const subpathParts = getPathComponents(subpath);
	        if (subpathParts.includes("..") || subpathParts.includes(".") || subpathParts.includes("node_modules")) {
	          if (state.traceEnabled) {
	            trace(state.host, Diagnostics.package_json_scope_0_has_invalid_type_for_target_of_specifier_1, scope.packageDirectory, moduleName);
	          }
	          return toSearchResult(
	            /*value*/
	            void 0
	          );
	        }
	        if (state.traceEnabled) {
	          trace(state.host, Diagnostics.Using_0_subpath_1_with_target_2, isImports ? "imports" : "exports", key, pattern ? target.replace(/\*/g, subpath) : target + subpath);
	        }
	        const finalPath = toAbsolutePath(pattern ? resolvedTarget.replace(/\*/g, subpath) : resolvedTarget + subpath);
	        const inputLink = tryLoadInputFileForPath(finalPath, subpath, combinePaths(scope.packageDirectory, "package.json"), isImports);
	        if (inputLink)
	          return inputLink;
	        return toSearchResult(withPackageId(scope, loadFileNameFromPackageJsonField(
	          extensions,
	          finalPath,
	          /*onlyRecordFailures*/
	          false,
	          state
	        )));
	      } else if (typeof target === "object" && target !== null) {
	        if (!Array.isArray(target)) {
	          traceIfEnabled(state, Diagnostics.Entering_conditional_exports);
	          for (const condition of getOwnKeys(target)) {
	            if (condition === "default" || state.conditions.includes(condition) || isApplicableVersionedTypesKey(state.conditions, condition)) {
	              traceIfEnabled(state, Diagnostics.Matched_0_condition_1, isImports ? "imports" : "exports", condition);
	              const subTarget = target[condition];
	              const result = loadModuleFromTargetImportOrExport(subTarget, subpath, pattern, key);
	              if (result) {
	                traceIfEnabled(state, Diagnostics.Resolved_under_condition_0, condition);
	                traceIfEnabled(state, Diagnostics.Exiting_conditional_exports);
	                return result;
	              } else {
	                traceIfEnabled(state, Diagnostics.Failed_to_resolve_under_condition_0, condition);
	              }
	            } else {
	              traceIfEnabled(state, Diagnostics.Saw_non_matching_condition_0, condition);
	            }
	          }
	          traceIfEnabled(state, Diagnostics.Exiting_conditional_exports);
	          return void 0;
	        } else {
	          if (!length(target)) {
	            if (state.traceEnabled) {
	              trace(state.host, Diagnostics.package_json_scope_0_has_invalid_type_for_target_of_specifier_1, scope.packageDirectory, moduleName);
	            }
	            return toSearchResult(
	              /*value*/
	              void 0
	            );
	          }
	          for (const elem of target) {
	            const result = loadModuleFromTargetImportOrExport(elem, subpath, pattern, key);
	            if (result) {
	              return result;
	            }
	          }
	        }
	      } else if (target === null) {
	        if (state.traceEnabled) {
	          trace(state.host, Diagnostics.package_json_scope_0_explicitly_maps_specifier_1_to_null, scope.packageDirectory, moduleName);
	        }
	        return toSearchResult(
	          /*value*/
	          void 0
	        );
	      }
	      if (state.traceEnabled) {
	        trace(state.host, Diagnostics.package_json_scope_0_has_invalid_type_for_target_of_specifier_1, scope.packageDirectory, moduleName);
	      }
	      return toSearchResult(
	        /*value*/
	        void 0
	      );
	      function toAbsolutePath(path) {
	        var _a, _b;
	        if (path === void 0)
	          return path;
	        return getNormalizedAbsolutePath(path, (_b = (_a = state.host).getCurrentDirectory) == null ? void 0 : _b.call(_a));
	      }
	      function combineDirectoryPath(root, dir) {
	        return ensureTrailingDirectorySeparator(combinePaths(root, dir));
	      }
	      function tryLoadInputFileForPath(finalPath, entry, packagePath, isImports2) {
	        var _a, _b, _c, _d;
	        if (!state.isConfigLookup && (state.compilerOptions.declarationDir || state.compilerOptions.outDir) && !finalPath.includes("/node_modules/") && (state.compilerOptions.configFile ? containsPath(scope.packageDirectory, toAbsolutePath(state.compilerOptions.configFile.fileName), !useCaseSensitiveFileNames(state)) : true)) {
	          const getCanonicalFileName = hostGetCanonicalFileName({ useCaseSensitiveFileNames: () => useCaseSensitiveFileNames(state) });
	          const commonSourceDirGuesses = [];
	          if (state.compilerOptions.rootDir || state.compilerOptions.composite && state.compilerOptions.configFilePath) {
	            const commonDir = toAbsolutePath(getCommonSourceDirectory(state.compilerOptions, () => [], ((_b = (_a = state.host).getCurrentDirectory) == null ? void 0 : _b.call(_a)) || "", getCanonicalFileName));
	            commonSourceDirGuesses.push(commonDir);
	          } else if (state.requestContainingDirectory) {
	            const requestingFile = toAbsolutePath(combinePaths(state.requestContainingDirectory, "index.ts"));
	            const commonDir = toAbsolutePath(getCommonSourceDirectory(state.compilerOptions, () => [requestingFile, toAbsolutePath(packagePath)], ((_d = (_c = state.host).getCurrentDirectory) == null ? void 0 : _d.call(_c)) || "", getCanonicalFileName));
	            commonSourceDirGuesses.push(commonDir);
	            let fragment = ensureTrailingDirectorySeparator(commonDir);
	            while (fragment && fragment.length > 1) {
	              const parts = getPathComponents(fragment);
	              parts.pop();
	              const commonDir2 = getPathFromPathComponents(parts);
	              commonSourceDirGuesses.unshift(commonDir2);
	              fragment = ensureTrailingDirectorySeparator(commonDir2);
	            }
	          }
	          if (commonSourceDirGuesses.length > 1) {
	            state.reportDiagnostic(createCompilerDiagnostic(
	              isImports2 ? Diagnostics.The_project_root_is_ambiguous_but_is_required_to_resolve_import_map_entry_0_in_file_1_Supply_the_rootDir_compiler_option_to_disambiguate : Diagnostics.The_project_root_is_ambiguous_but_is_required_to_resolve_export_map_entry_0_in_file_1_Supply_the_rootDir_compiler_option_to_disambiguate,
	              entry === "" ? "." : entry,
	              // replace empty string with `.` - the reverse of the operation done when entries are built - so main entrypoint errors don't look weird
	              packagePath
	            ));
	          }
	          for (const commonSourceDirGuess of commonSourceDirGuesses) {
	            const candidateDirectories = getOutputDirectoriesForBaseDirectory(commonSourceDirGuess);
	            for (const candidateDir of candidateDirectories) {
	              if (containsPath(candidateDir, finalPath, !useCaseSensitiveFileNames(state))) {
	                const pathFragment = finalPath.slice(candidateDir.length + 1);
	                const possibleInputBase = combinePaths(commonSourceDirGuess, pathFragment);
	                const jsAndDtsExtensions = [".mjs" /* Mjs */, ".cjs" /* Cjs */, ".js" /* Js */, ".json" /* Json */, ".d.mts" /* Dmts */, ".d.cts" /* Dcts */, ".d.ts" /* Dts */];
	                for (const ext of jsAndDtsExtensions) {
	                  if (fileExtensionIs(possibleInputBase, ext)) {
	                    const inputExts = getPossibleOriginalInputExtensionForExtension(possibleInputBase);
	                    for (const possibleExt of inputExts) {
	                      if (!extensionIsOk(extensions, possibleExt))
	                        continue;
	                      const possibleInputWithInputExtension = changeAnyExtension(possibleInputBase, possibleExt, ext, !useCaseSensitiveFileNames(state));
	                      if (state.host.fileExists(possibleInputWithInputExtension)) {
	                        return toSearchResult(withPackageId(scope, loadFileNameFromPackageJsonField(
	                          extensions,
	                          possibleInputWithInputExtension,
	                          /*onlyRecordFailures*/
	                          false,
	                          state
	                        )));
	                      }
	                    }
	                  }
	                }
	              }
	            }
	          }
	        }
	        return void 0;
	        function getOutputDirectoriesForBaseDirectory(commonSourceDirGuess) {
	          var _a2, _b2;
	          const currentDir = state.compilerOptions.configFile ? ((_b2 = (_a2 = state.host).getCurrentDirectory) == null ? void 0 : _b2.call(_a2)) || "" : commonSourceDirGuess;
	          const candidateDirectories = [];
	          if (state.compilerOptions.declarationDir) {
	            candidateDirectories.push(toAbsolutePath(combineDirectoryPath(currentDir, state.compilerOptions.declarationDir)));
	          }
	          if (state.compilerOptions.outDir && state.compilerOptions.outDir !== state.compilerOptions.declarationDir) {
	            candidateDirectories.push(toAbsolutePath(combineDirectoryPath(currentDir, state.compilerOptions.outDir)));
	          }
	          return candidateDirectories;
	        }
	      }
	    }
	  }
	  function isApplicableVersionedTypesKey(conditions, key) {
	    if (!conditions.includes("types"))
	      return false;
	    if (!startsWith(key, "types@"))
	      return false;
	    const range = VersionRange.tryParse(key.substring("types@".length));
	    if (!range)
	      return false;
	    return range.test(version);
	  }
	  function loadModuleFromNearestNodeModulesDirectory(extensions, moduleName, directory, state, cache, redirectedReference) {
	    return loadModuleFromNearestNodeModulesDirectoryWorker(
	      extensions,
	      moduleName,
	      directory,
	      state,
	      /*typesScopeOnly*/
	      false,
	      cache,
	      redirectedReference
	    );
	  }
	  function loadModuleFromNearestNodeModulesDirectoryTypesScope(moduleName, directory, state) {
	    return loadModuleFromNearestNodeModulesDirectoryWorker(
	      4 /* Declaration */,
	      moduleName,
	      directory,
	      state,
	      /*typesScopeOnly*/
	      true,
	      /*cache*/
	      void 0,
	      /*redirectedReference*/
	      void 0
	    );
	  }
	  function loadModuleFromNearestNodeModulesDirectoryWorker(extensions, moduleName, directory, state, typesScopeOnly, cache, redirectedReference) {
	    const mode = state.features === 0 ? void 0 : state.features & 32 /* EsmMode */ ? 99 /* ESNext */ : 1 /* CommonJS */;
	    const priorityExtensions = extensions & (1 /* TypeScript */ | 4 /* Declaration */);
	    const secondaryExtensions = extensions & ~(1 /* TypeScript */ | 4 /* Declaration */);
	    if (priorityExtensions) {
	      traceIfEnabled(state, Diagnostics.Searching_all_ancestor_node_modules_directories_for_preferred_extensions_Colon_0, formatExtensions(priorityExtensions));
	      const result = lookup(priorityExtensions);
	      if (result)
	        return result;
	    }
	    if (secondaryExtensions && !typesScopeOnly) {
	      traceIfEnabled(state, Diagnostics.Searching_all_ancestor_node_modules_directories_for_fallback_extensions_Colon_0, formatExtensions(secondaryExtensions));
	      return lookup(secondaryExtensions);
	    }
	    function lookup(extensions2) {
	      return forEachAncestorDirectory(normalizeSlashes(directory), (ancestorDirectory) => {
	        if (getBaseFileName(ancestorDirectory) !== "node_modules") {
	          const resolutionFromCache = tryFindNonRelativeModuleNameInCache(cache, moduleName, mode, ancestorDirectory, redirectedReference, state);
	          if (resolutionFromCache) {
	            return resolutionFromCache;
	          }
	          return toSearchResult(loadModuleFromImmediateNodeModulesDirectory(extensions2, moduleName, ancestorDirectory, state, typesScopeOnly, cache, redirectedReference));
	        }
	      });
	    }
	  }
	  function loadModuleFromImmediateNodeModulesDirectory(extensions, moduleName, directory, state, typesScopeOnly, cache, redirectedReference) {
	    const nodeModulesFolder = combinePaths(directory, "node_modules");
	    const nodeModulesFolderExists = directoryProbablyExists(nodeModulesFolder, state.host);
	    if (!nodeModulesFolderExists && state.traceEnabled) {
	      trace(state.host, Diagnostics.Directory_0_does_not_exist_skipping_all_lookups_in_it, nodeModulesFolder);
	    }
	    if (!typesScopeOnly) {
	      const packageResult = loadModuleFromSpecificNodeModulesDirectory(extensions, moduleName, nodeModulesFolder, nodeModulesFolderExists, state, cache, redirectedReference);
	      if (packageResult) {
	        return packageResult;
	      }
	    }
	    if (extensions & 4 /* Declaration */) {
	      const nodeModulesAtTypes2 = combinePaths(nodeModulesFolder, "@types");
	      let nodeModulesAtTypesExists = nodeModulesFolderExists;
	      if (nodeModulesFolderExists && !directoryProbablyExists(nodeModulesAtTypes2, state.host)) {
	        if (state.traceEnabled) {
	          trace(state.host, Diagnostics.Directory_0_does_not_exist_skipping_all_lookups_in_it, nodeModulesAtTypes2);
	        }
	        nodeModulesAtTypesExists = false;
	      }
	      return loadModuleFromSpecificNodeModulesDirectory(4 /* Declaration */, mangleScopedPackageNameWithTrace(moduleName, state), nodeModulesAtTypes2, nodeModulesAtTypesExists, state, cache, redirectedReference);
	    }
	  }
	  function loadModuleFromSpecificNodeModulesDirectory(extensions, moduleName, nodeModulesDirectory, nodeModulesDirectoryExists, state, cache, redirectedReference) {
	    var _a, _b;
	    const candidate = normalizePath(combinePaths(nodeModulesDirectory, moduleName));
	    const { packageName, rest } = parsePackageName(moduleName);
	    const packageDirectory = combinePaths(nodeModulesDirectory, packageName);
	    let rootPackageInfo;
	    let packageInfo = getPackageJsonInfo(candidate, !nodeModulesDirectoryExists, state);
	    if (rest !== "" && packageInfo && (!(state.features & 8 /* Exports */) || !hasProperty(((_a = rootPackageInfo = getPackageJsonInfo(packageDirectory, !nodeModulesDirectoryExists, state)) == null ? void 0 : _a.contents.packageJsonContent) ?? emptyArray, "exports"))) {
	      const fromFile = loadModuleFromFile(extensions, candidate, !nodeModulesDirectoryExists, state);
	      if (fromFile) {
	        return noPackageId(fromFile);
	      }
	      const fromDirectory = loadNodeModuleFromDirectoryWorker(
	        extensions,
	        candidate,
	        !nodeModulesDirectoryExists,
	        state,
	        packageInfo.contents.packageJsonContent,
	        getVersionPathsOfPackageJsonInfo(packageInfo, state)
	      );
	      return withPackageId(packageInfo, fromDirectory);
	    }
	    const loader = (extensions2, candidate2, onlyRecordFailures, state2) => {
	      let pathAndExtension = (rest || !(state2.features & 32 /* EsmMode */)) && loadModuleFromFile(extensions2, candidate2, onlyRecordFailures, state2) || loadNodeModuleFromDirectoryWorker(
	        extensions2,
	        candidate2,
	        onlyRecordFailures,
	        state2,
	        packageInfo && packageInfo.contents.packageJsonContent,
	        packageInfo && getVersionPathsOfPackageJsonInfo(packageInfo, state2)
	      );
	      if (!pathAndExtension && packageInfo && (packageInfo.contents.packageJsonContent.exports === void 0 || packageInfo.contents.packageJsonContent.exports === null) && state2.features & 32 /* EsmMode */) {
	        pathAndExtension = loadModuleFromFile(extensions2, combinePaths(candidate2, "index.js"), onlyRecordFailures, state2);
	      }
	      return withPackageId(packageInfo, pathAndExtension);
	    };
	    if (rest !== "") {
	      packageInfo = rootPackageInfo ?? getPackageJsonInfo(packageDirectory, !nodeModulesDirectoryExists, state);
	    }
	    if (packageInfo) {
	      state.resolvedPackageDirectory = true;
	    }
	    if (packageInfo && packageInfo.contents.packageJsonContent.exports && state.features & 8 /* Exports */) {
	      return (_b = loadModuleFromExports(packageInfo, extensions, combinePaths(".", rest), state, cache, redirectedReference)) == null ? void 0 : _b.value;
	    }
	    const versionPaths = rest !== "" && packageInfo ? getVersionPathsOfPackageJsonInfo(packageInfo, state) : void 0;
	    if (versionPaths) {
	      if (state.traceEnabled) {
	        trace(state.host, Diagnostics.package_json_has_a_typesVersions_entry_0_that_matches_compiler_version_1_looking_for_a_pattern_to_match_module_name_2, versionPaths.version, version, rest);
	      }
	      const packageDirectoryExists = nodeModulesDirectoryExists && directoryProbablyExists(packageDirectory, state.host);
	      const fromPaths = tryLoadModuleUsingPaths(
	        extensions,
	        rest,
	        packageDirectory,
	        versionPaths.paths,
	        /*pathPatterns*/
	        void 0,
	        loader,
	        !packageDirectoryExists,
	        state
	      );
	      if (fromPaths) {
	        return fromPaths.value;
	      }
	    }
	    return loader(extensions, candidate, !nodeModulesDirectoryExists, state);
	  }
	  function tryLoadModuleUsingPaths(extensions, moduleName, baseDirectory, paths, pathPatterns, loader, onlyRecordFailures, state) {
	    pathPatterns || (pathPatterns = tryParsePatterns(paths));
	    const matchedPattern = matchPatternOrExact(pathPatterns, moduleName);
	    if (matchedPattern) {
	      const matchedStar = isString(matchedPattern) ? void 0 : matchedText(matchedPattern, moduleName);
	      const matchedPatternText = isString(matchedPattern) ? matchedPattern : patternText(matchedPattern);
	      if (state.traceEnabled) {
	        trace(state.host, Diagnostics.Module_name_0_matched_pattern_1, moduleName, matchedPatternText);
	      }
	      const resolved = forEach(paths[matchedPatternText], (subst) => {
	        const path = matchedStar ? replaceFirstStar(subst, matchedStar) : subst;
	        const candidate = normalizePath(combinePaths(baseDirectory, path));
	        if (state.traceEnabled) {
	          trace(state.host, Diagnostics.Trying_substitution_0_candidate_module_location_Colon_1, subst, path);
	        }
	        const extension = tryGetExtensionFromPath2(subst);
	        if (extension !== void 0) {
	          const path2 = tryFile(candidate, onlyRecordFailures, state);
	          if (path2 !== void 0) {
	            return noPackageId({ path: path2, ext: extension, resolvedUsingTsExtension: void 0 });
	          }
	        }
	        return loader(extensions, candidate, onlyRecordFailures || !directoryProbablyExists(getDirectoryPath(candidate), state.host), state);
	      });
	      return { value: resolved };
	    }
	  }
	  function mangleScopedPackageNameWithTrace(packageName, state) {
	    const mangled = mangleScopedPackageName(packageName);
	    if (state.traceEnabled && mangled !== packageName) {
	      trace(state.host, Diagnostics.Scoped_package_detected_looking_in_0, mangled);
	    }
	    return mangled;
	  }
	  function getTypesPackageName(packageName) {
	    return `@types/${mangleScopedPackageName(packageName)}`;
	  }
	  function mangleScopedPackageName(packageName) {
	    if (startsWith(packageName, "@")) {
	      const replaceSlash = packageName.replace(directorySeparator, mangledScopedPackageSeparator);
	      if (replaceSlash !== packageName) {
	        return replaceSlash.slice(1);
	      }
	    }
	    return packageName;
	  }
	  function getPackageNameFromTypesPackageName(mangledName) {
	    const withoutAtTypePrefix = removePrefix(mangledName, "@types/");
	    if (withoutAtTypePrefix !== mangledName) {
	      return unmangleScopedPackageName(withoutAtTypePrefix);
	    }
	    return mangledName;
	  }
	  function unmangleScopedPackageName(typesPackageName) {
	    return typesPackageName.includes(mangledScopedPackageSeparator) ? "@" + typesPackageName.replace(mangledScopedPackageSeparator, directorySeparator) : typesPackageName;
	  }
	  function tryFindNonRelativeModuleNameInCache(cache, moduleName, mode, containingDirectory, redirectedReference, state) {
	    const result = cache && cache.getFromNonRelativeNameCache(moduleName, mode, containingDirectory, redirectedReference);
	    if (result) {
	      if (state.traceEnabled) {
	        trace(state.host, Diagnostics.Resolution_for_module_0_was_found_in_cache_from_location_1, moduleName, containingDirectory);
	      }
	      state.resultFromCache = result;
	      return {
	        value: result.resolvedModule && {
	          path: result.resolvedModule.resolvedFileName,
	          originalPath: result.resolvedModule.originalPath || true,
	          extension: result.resolvedModule.extension,
	          packageId: result.resolvedModule.packageId,
	          resolvedUsingTsExtension: result.resolvedModule.resolvedUsingTsExtension
	        }
	      };
	    }
	  }
	  function classicNameResolver(moduleName, containingFile, compilerOptions, host, cache, redirectedReference) {
	    const traceEnabled = isTraceEnabled(compilerOptions, host);
	    const failedLookupLocations = [];
	    const affectingLocations = [];
	    const containingDirectory = getDirectoryPath(containingFile);
	    const diagnostics = [];
	    const state = {
	      compilerOptions,
	      host,
	      traceEnabled,
	      failedLookupLocations,
	      affectingLocations,
	      packageJsonInfoCache: cache,
	      features: 0 /* None */,
	      conditions: [],
	      requestContainingDirectory: containingDirectory,
	      reportDiagnostic: (diag2) => void diagnostics.push(diag2),
	      isConfigLookup: false,
	      candidateIsFromPackageJsonField: false,
	      resolvedPackageDirectory: false
	    };
	    const resolved = tryResolve(1 /* TypeScript */ | 4 /* Declaration */) || tryResolve(2 /* JavaScript */ | (compilerOptions.resolveJsonModule ? 8 /* Json */ : 0));
	    return createResolvedModuleWithFailedLookupLocationsHandlingSymlink(
	      moduleName,
	      resolved && resolved.value,
	      (resolved == null ? void 0 : resolved.value) && pathContainsNodeModules(resolved.value.path),
	      failedLookupLocations,
	      affectingLocations,
	      diagnostics,
	      state,
	      cache
	    );
	    function tryResolve(extensions) {
	      const resolvedUsingSettings = tryLoadModuleUsingOptionalResolutionSettings(extensions, moduleName, containingDirectory, loadModuleFromFileNoPackageId, state);
	      if (resolvedUsingSettings) {
	        return { value: resolvedUsingSettings };
	      }
	      if (!isExternalModuleNameRelative(moduleName)) {
	        const resolved2 = forEachAncestorDirectory(containingDirectory, (directory) => {
	          const resolutionFromCache = tryFindNonRelativeModuleNameInCache(
	            cache,
	            moduleName,
	            /*mode*/
	            void 0,
	            directory,
	            redirectedReference,
	            state
	          );
	          if (resolutionFromCache) {
	            return resolutionFromCache;
	          }
	          const searchName = normalizePath(combinePaths(directory, moduleName));
	          return toSearchResult(loadModuleFromFileNoPackageId(
	            extensions,
	            searchName,
	            /*onlyRecordFailures*/
	            false,
	            state
	          ));
	        });
	        if (resolved2)
	          return resolved2;
	        if (extensions & (1 /* TypeScript */ | 4 /* Declaration */)) {
	          let resolved3 = loadModuleFromNearestNodeModulesDirectoryTypesScope(moduleName, containingDirectory, state);
	          if (extensions & 4 /* Declaration */)
	            resolved3 ?? (resolved3 = resolveFromTypeRoot(moduleName, state));
	          return resolved3;
	        }
	      } else {
	        const candidate = normalizePath(combinePaths(containingDirectory, moduleName));
	        return toSearchResult(loadModuleFromFileNoPackageId(
	          extensions,
	          candidate,
	          /*onlyRecordFailures*/
	          false,
	          state
	        ));
	      }
	    }
	  }
	  function resolveFromTypeRoot(moduleName, state) {
	    if (!state.compilerOptions.typeRoots)
	      return;
	    for (const typeRoot of state.compilerOptions.typeRoots) {
	      const candidate = getCandidateFromTypeRoot(typeRoot, moduleName, state);
	      const directoryExists = directoryProbablyExists(typeRoot, state.host);
	      if (!directoryExists && state.traceEnabled) {
	        trace(state.host, Diagnostics.Directory_0_does_not_exist_skipping_all_lookups_in_it, typeRoot);
	      }
	      const resolvedFromFile = loadModuleFromFile(4 /* Declaration */, candidate, !directoryExists, state);
	      if (resolvedFromFile) {
	        const packageDirectory = parseNodeModuleFromPath(resolvedFromFile.path);
	        const packageInfo = packageDirectory ? getPackageJsonInfo(
	          packageDirectory,
	          /*onlyRecordFailures*/
	          false,
	          state
	        ) : void 0;
	        return toSearchResult(withPackageId(packageInfo, resolvedFromFile));
	      }
	      const resolved = loadNodeModuleFromDirectory(4 /* Declaration */, candidate, !directoryExists, state);
	      if (resolved)
	        return toSearchResult(resolved);
	    }
	  }
	  function shouldAllowImportingTsExtension(compilerOptions, fromFileName) {
	    return !!compilerOptions.allowImportingTsExtensions || fromFileName && isDeclarationFileName(fromFileName);
	  }
	  function loadModuleFromGlobalCache(moduleName, projectName, compilerOptions, host, globalCache, packageJsonInfoCache) {
	    const traceEnabled = isTraceEnabled(compilerOptions, host);
	    if (traceEnabled) {
	      trace(host, Diagnostics.Auto_discovery_for_typings_is_enabled_in_project_0_Running_extra_resolution_pass_for_module_1_using_cache_location_2, projectName, moduleName, globalCache);
	    }
	    const failedLookupLocations = [];
	    const affectingLocations = [];
	    const diagnostics = [];
	    const state = {
	      compilerOptions,
	      host,
	      traceEnabled,
	      failedLookupLocations,
	      affectingLocations,
	      packageJsonInfoCache,
	      features: 0 /* None */,
	      conditions: [],
	      requestContainingDirectory: void 0,
	      reportDiagnostic: (diag2) => void diagnostics.push(diag2),
	      isConfigLookup: false,
	      candidateIsFromPackageJsonField: false,
	      resolvedPackageDirectory: false
	    };
	    const resolved = loadModuleFromImmediateNodeModulesDirectory(
	      4 /* Declaration */,
	      moduleName,
	      globalCache,
	      state,
	      /*typesScopeOnly*/
	      false,
	      /*cache*/
	      void 0,
	      /*redirectedReference*/
	      void 0
	    );
	    return createResolvedModuleWithFailedLookupLocations(
	      resolved,
	      /*isExternalLibraryImport*/
	      true,
	      failedLookupLocations,
	      affectingLocations,
	      diagnostics,
	      state.resultFromCache,
	      /*cache*/
	      void 0
	    );
	  }
	  function toSearchResult(value) {
	    return value !== void 0 ? { value } : void 0;
	  }
	  function traceIfEnabled(state, diagnostic, ...args) {
	    if (state.traceEnabled) {
	      trace(state.host, diagnostic, ...args);
	    }
	  }
	  function useCaseSensitiveFileNames(state) {
	    return !state.host.useCaseSensitiveFileNames ? true : typeof state.host.useCaseSensitiveFileNames === "boolean" ? state.host.useCaseSensitiveFileNames : state.host.useCaseSensitiveFileNames();
	  }
	  var typeScriptVersion, nodeModulesAtTypes, NodeResolutionFeatures, nodeModulesPathPart, mangledScopedPackageSeparator;
	  var init_moduleNameResolver = __esm({
	    "src/compiler/moduleNameResolver.ts"() {
	      init_ts2();
	      nodeModulesAtTypes = combinePaths("node_modules", "@types");
	      NodeResolutionFeatures = /* @__PURE__ */ ((NodeResolutionFeatures2) => {
	        NodeResolutionFeatures2[NodeResolutionFeatures2["None"] = 0] = "None";
	        NodeResolutionFeatures2[NodeResolutionFeatures2["Imports"] = 2] = "Imports";
	        NodeResolutionFeatures2[NodeResolutionFeatures2["SelfName"] = 4] = "SelfName";
	        NodeResolutionFeatures2[NodeResolutionFeatures2["Exports"] = 8] = "Exports";
	        NodeResolutionFeatures2[NodeResolutionFeatures2["ExportsPatternTrailers"] = 16] = "ExportsPatternTrailers";
	        NodeResolutionFeatures2[NodeResolutionFeatures2["AllFeatures"] = 30] = "AllFeatures";
	        NodeResolutionFeatures2[NodeResolutionFeatures2["Node16Default"] = 30] = "Node16Default";
	        NodeResolutionFeatures2[NodeResolutionFeatures2["NodeNextDefault"] = 30 /* AllFeatures */] = "NodeNextDefault";
	        NodeResolutionFeatures2[NodeResolutionFeatures2["BundlerDefault"] = 30] = "BundlerDefault";
	        NodeResolutionFeatures2[NodeResolutionFeatures2["EsmMode"] = 32] = "EsmMode";
	        return NodeResolutionFeatures2;
	      })(NodeResolutionFeatures || {});
	      nodeModulesPathPart = "/node_modules/";
	      mangledScopedPackageSeparator = "__";
	    }
	  });

	  // src/compiler/binder.ts
	  function getModuleInstanceState(node, visited) {
	    if (node.body && !node.body.parent) {
	      setParent(node.body, node);
	      setParentRecursive(
	        node.body,
	        /*incremental*/
	        false
	      );
	    }
	    return node.body ? getModuleInstanceStateCached(node.body, visited) : 1 /* Instantiated */;
	  }
	  function getModuleInstanceStateCached(node, visited = /* @__PURE__ */ new Map()) {
	    const nodeId = getNodeId(node);
	    if (visited.has(nodeId)) {
	      return visited.get(nodeId) || 0 /* NonInstantiated */;
	    }
	    visited.set(nodeId, void 0);
	    const result = getModuleInstanceStateWorker(node, visited);
	    visited.set(nodeId, result);
	    return result;
	  }
	  function getModuleInstanceStateWorker(node, visited) {
	    switch (node.kind) {
	      case 264 /* InterfaceDeclaration */:
	      case 265 /* TypeAliasDeclaration */:
	        return 0 /* NonInstantiated */;
	      case 266 /* EnumDeclaration */:
	        if (isEnumConst(node)) {
	          return 2 /* ConstEnumOnly */;
	        }
	        break;
	      case 272 /* ImportDeclaration */:
	      case 271 /* ImportEqualsDeclaration */:
	        if (!hasSyntacticModifier(node, 32 /* Export */)) {
	          return 0 /* NonInstantiated */;
	        }
	        break;
	      case 278 /* ExportDeclaration */:
	        const exportDeclaration = node;
	        if (!exportDeclaration.moduleSpecifier && exportDeclaration.exportClause && exportDeclaration.exportClause.kind === 279 /* NamedExports */) {
	          let state = 0 /* NonInstantiated */;
	          for (const specifier of exportDeclaration.exportClause.elements) {
	            const specifierState = getModuleInstanceStateForAliasTarget(specifier, visited);
	            if (specifierState > state) {
	              state = specifierState;
	            }
	            if (state === 1 /* Instantiated */) {
	              return state;
	            }
	          }
	          return state;
	        }
	        break;
	      case 268 /* ModuleBlock */: {
	        let state = 0 /* NonInstantiated */;
	        forEachChild(node, (n) => {
	          const childState = getModuleInstanceStateCached(n, visited);
	          switch (childState) {
	            case 0 /* NonInstantiated */:
	              return;
	            case 2 /* ConstEnumOnly */:
	              state = 2 /* ConstEnumOnly */;
	              return;
	            case 1 /* Instantiated */:
	              state = 1 /* Instantiated */;
	              return true;
	            default:
	              Debug.assertNever(childState);
	          }
	        });
	        return state;
	      }
	      case 267 /* ModuleDeclaration */:
	        return getModuleInstanceState(node, visited);
	      case 80 /* Identifier */:
	        if (node.flags & 4096 /* IdentifierIsInJSDocNamespace */) {
	          return 0 /* NonInstantiated */;
	        }
	    }
	    return 1 /* Instantiated */;
	  }
	  function getModuleInstanceStateForAliasTarget(specifier, visited) {
	    const name = specifier.propertyName || specifier.name;
	    let p = specifier.parent;
	    while (p) {
	      if (isBlock(p) || isModuleBlock(p) || isSourceFile(p)) {
	        const statements = p.statements;
	        let found;
	        for (const statement of statements) {
	          if (nodeHasName(statement, name)) {
	            if (!statement.parent) {
	              setParent(statement, p);
	              setParentRecursive(
	                statement,
	                /*incremental*/
	                false
	              );
	            }
	            const state = getModuleInstanceStateCached(statement, visited);
	            if (found === void 0 || state > found) {
	              found = state;
	            }
	            if (found === 1 /* Instantiated */) {
	              return found;
	            }
	            if (statement.kind === 271 /* ImportEqualsDeclaration */) {
	              found = 1 /* Instantiated */;
	            }
	          }
	        }
	        if (found !== void 0) {
	          return found;
	        }
	      }
	      p = p.parent;
	    }
	    return 1 /* Instantiated */;
	  }
	  function initFlowNode(node) {
	    Debug.attachFlowNodeDebugInfo(node);
	    return node;
	  }
	  function bindSourceFile(file, options) {
	    var _a, _b;
	    mark("beforeBind");
	    (_a = perfLogger) == null ? void 0 : _a.logStartBindFile("" + file.fileName);
	    binder(file, options);
	    (_b = perfLogger) == null ? void 0 : _b.logStopBindFile();
	    mark("afterBind");
	    measure("Bind", "beforeBind", "afterBind");
	  }
	  function createBinder() {
	    var file;
	    var options;
	    var languageVersion;
	    var parent2;
	    var container;
	    var thisParentContainer;
	    var blockScopeContainer;
	    var lastContainer;
	    var delayedTypeAliases;
	    var seenThisKeyword;
	    var currentFlow;
	    var currentBreakTarget;
	    var currentContinueTarget;
	    var currentReturnTarget;
	    var currentTrueTarget;
	    var currentFalseTarget;
	    var currentExceptionTarget;
	    var preSwitchCaseFlow;
	    var activeLabelList;
	    var hasExplicitReturn;
	    var emitFlags;
	    var inStrictMode;
	    var inAssignmentPattern = false;
	    var symbolCount = 0;
	    var Symbol47;
	    var classifiableNames;
	    var unreachableFlow = { flags: 1 /* Unreachable */ };
	    var reportedUnreachableFlow = { flags: 1 /* Unreachable */ };
	    var bindBinaryExpressionFlow = createBindBinaryExpressionFlow();
	    return bindSourceFile2;
	    function createDiagnosticForNode2(node, message, ...args) {
	      return createDiagnosticForNodeInSourceFile(getSourceFileOfNode(node) || file, node, message, ...args);
	    }
	    function bindSourceFile2(f, opts) {
	      var _a, _b;
	      file = f;
	      options = opts;
	      languageVersion = getEmitScriptTarget(options);
	      inStrictMode = bindInStrictMode(file, opts);
	      classifiableNames = /* @__PURE__ */ new Set();
	      symbolCount = 0;
	      Symbol47 = objectAllocator.getSymbolConstructor();
	      Debug.attachFlowNodeDebugInfo(unreachableFlow);
	      Debug.attachFlowNodeDebugInfo(reportedUnreachableFlow);
	      if (!file.locals) {
	        (_a = tracing) == null ? void 0 : _a.push(
	          tracing.Phase.Bind,
	          "bindSourceFile",
	          { path: file.path },
	          /*separateBeginAndEnd*/
	          true
	        );
	        bind(file);
	        (_b = tracing) == null ? void 0 : _b.pop();
	        file.symbolCount = symbolCount;
	        file.classifiableNames = classifiableNames;
	        delayedBindJSDocTypedefTag();
	      }
	      file = void 0;
	      options = void 0;
	      languageVersion = void 0;
	      parent2 = void 0;
	      container = void 0;
	      thisParentContainer = void 0;
	      blockScopeContainer = void 0;
	      lastContainer = void 0;
	      delayedTypeAliases = void 0;
	      seenThisKeyword = false;
	      currentFlow = void 0;
	      currentBreakTarget = void 0;
	      currentContinueTarget = void 0;
	      currentReturnTarget = void 0;
	      currentTrueTarget = void 0;
	      currentFalseTarget = void 0;
	      currentExceptionTarget = void 0;
	      activeLabelList = void 0;
	      hasExplicitReturn = false;
	      inAssignmentPattern = false;
	      emitFlags = 0 /* None */;
	    }
	    function bindInStrictMode(file2, opts) {
	      if (getStrictOptionValue(opts, "alwaysStrict") && !file2.isDeclarationFile) {
	        return true;
	      } else {
	        return !!file2.externalModuleIndicator;
	      }
	    }
	    function createSymbol(flags, name) {
	      symbolCount++;
	      return new Symbol47(flags, name);
	    }
	    function addDeclarationToSymbol(symbol, node, symbolFlags) {
	      symbol.flags |= symbolFlags;
	      node.symbol = symbol;
	      symbol.declarations = appendIfUnique(symbol.declarations, node);
	      if (symbolFlags & (32 /* Class */ | 384 /* Enum */ | 1536 /* Module */ | 3 /* Variable */) && !symbol.exports) {
	        symbol.exports = createSymbolTable();
	      }
	      if (symbolFlags & (32 /* Class */ | 64 /* Interface */ | 2048 /* TypeLiteral */ | 4096 /* ObjectLiteral */) && !symbol.members) {
	        symbol.members = createSymbolTable();
	      }
	      if (symbol.constEnumOnlyModule && symbol.flags & (16 /* Function */ | 32 /* Class */ | 256 /* RegularEnum */)) {
	        symbol.constEnumOnlyModule = false;
	      }
	      if (symbolFlags & 111551 /* Value */) {
	        setValueDeclaration(symbol, node);
	      }
	    }
	    function getDeclarationName(node) {
	      if (node.kind === 277 /* ExportAssignment */) {
	        return node.isExportEquals ? "export=" /* ExportEquals */ : "default" /* Default */;
	      }
	      const name = getNameOfDeclaration(node);
	      if (name) {
	        if (isAmbientModule(node)) {
	          const moduleName = getTextOfIdentifierOrLiteral(name);
	          return isGlobalScopeAugmentation(node) ? "__global" : `"${moduleName}"`;
	        }
	        if (name.kind === 167 /* ComputedPropertyName */) {
	          const nameExpression = name.expression;
	          if (isStringOrNumericLiteralLike(nameExpression)) {
	            return escapeLeadingUnderscores(nameExpression.text);
	          }
	          if (isSignedNumericLiteral(nameExpression)) {
	            return tokenToString(nameExpression.operator) + nameExpression.operand.text;
	          } else {
	            Debug.fail("Only computed properties with literal names have declaration names");
	          }
	        }
	        if (isPrivateIdentifier(name)) {
	          const containingClass = getContainingClass(node);
	          if (!containingClass) {
	            return void 0;
	          }
	          const containingClassSymbol = containingClass.symbol;
	          return getSymbolNameForPrivateIdentifier(containingClassSymbol, name.escapedText);
	        }
	        if (isJsxNamespacedName(name)) {
	          return getEscapedTextOfJsxNamespacedName(name);
	        }
	        return isPropertyNameLiteral(name) ? getEscapedTextOfIdentifierOrLiteral(name) : void 0;
	      }
	      switch (node.kind) {
	        case 176 /* Constructor */:
	          return "__constructor" /* Constructor */;
	        case 184 /* FunctionType */:
	        case 179 /* CallSignature */:
	        case 330 /* JSDocSignature */:
	          return "__call" /* Call */;
	        case 185 /* ConstructorType */:
	        case 180 /* ConstructSignature */:
	          return "__new" /* New */;
	        case 181 /* IndexSignature */:
	          return "__index" /* Index */;
	        case 278 /* ExportDeclaration */:
	          return "__export" /* ExportStar */;
	        case 312 /* SourceFile */:
	          return "export=" /* ExportEquals */;
	        case 226 /* BinaryExpression */:
	          if (getAssignmentDeclarationKind(node) === 2 /* ModuleExports */) {
	            return "export=" /* ExportEquals */;
	          }
	          Debug.fail("Unknown binary declaration kind");
	          break;
	        case 324 /* JSDocFunctionType */:
	          return isJSDocConstructSignature(node) ? "__new" /* New */ : "__call" /* Call */;
	        case 169 /* Parameter */:
	          Debug.assert(node.parent.kind === 324 /* JSDocFunctionType */, "Impossible parameter parent kind", () => `parent is: ${Debug.formatSyntaxKind(node.parent.kind)}, expected JSDocFunctionType`);
	          const functionType = node.parent;
	          const index = functionType.parameters.indexOf(node);
	          return "arg" + index;
	      }
	    }
	    function getDisplayName(node) {
	      return isNamedDeclaration(node) ? declarationNameToString(node.name) : unescapeLeadingUnderscores(Debug.checkDefined(getDeclarationName(node)));
	    }
	    function declareSymbol(symbolTable, parent3, node, includes, excludes, isReplaceableByMethod, isComputedName) {
	      Debug.assert(isComputedName || !hasDynamicName(node));
	      const isDefaultExport = hasSyntacticModifier(node, 2048 /* Default */) || isExportSpecifier(node) && node.name.escapedText === "default";
	      const name = isComputedName ? "__computed" /* Computed */ : isDefaultExport && parent3 ? "default" /* Default */ : getDeclarationName(node);
	      let symbol;
	      if (name === void 0) {
	        symbol = createSymbol(0 /* None */, "__missing" /* Missing */);
	      } else {
	        symbol = symbolTable.get(name);
	        if (includes & 2885600 /* Classifiable */) {
	          classifiableNames.add(name);
	        }
	        if (!symbol) {
	          symbolTable.set(name, symbol = createSymbol(0 /* None */, name));
	          if (isReplaceableByMethod)
	            symbol.isReplaceableByMethod = true;
	        } else if (isReplaceableByMethod && !symbol.isReplaceableByMethod) {
	          return symbol;
	        } else if (symbol.flags & excludes) {
	          if (symbol.isReplaceableByMethod) {
	            symbolTable.set(name, symbol = createSymbol(0 /* None */, name));
	          } else if (!(includes & 3 /* Variable */ && symbol.flags & 67108864 /* Assignment */)) {
	            if (isNamedDeclaration(node)) {
	              setParent(node.name, node);
	            }
	            let message = symbol.flags & 2 /* BlockScopedVariable */ ? Diagnostics.Cannot_redeclare_block_scoped_variable_0 : Diagnostics.Duplicate_identifier_0;
	            let messageNeedsName = true;
	            if (symbol.flags & 384 /* Enum */ || includes & 384 /* Enum */) {
	              message = Diagnostics.Enum_declarations_can_only_merge_with_namespace_or_other_enum_declarations;
	              messageNeedsName = false;
	            }
	            let multipleDefaultExports = false;
	            if (length(symbol.declarations)) {
	              if (isDefaultExport) {
	                message = Diagnostics.A_module_cannot_have_multiple_default_exports;
	                messageNeedsName = false;
	                multipleDefaultExports = true;
	              } else {
	                if (symbol.declarations && symbol.declarations.length && (node.kind === 277 /* ExportAssignment */ && !node.isExportEquals)) {
	                  message = Diagnostics.A_module_cannot_have_multiple_default_exports;
	                  messageNeedsName = false;
	                  multipleDefaultExports = true;
	                }
	              }
	            }
	            const relatedInformation = [];
	            if (isTypeAliasDeclaration(node) && nodeIsMissing(node.type) && hasSyntacticModifier(node, 32 /* Export */) && symbol.flags & (2097152 /* Alias */ | 788968 /* Type */ | 1920 /* Namespace */)) {
	              relatedInformation.push(createDiagnosticForNode2(node, Diagnostics.Did_you_mean_0, `export type { ${unescapeLeadingUnderscores(node.name.escapedText)} }`));
	            }
	            const declarationName = getNameOfDeclaration(node) || node;
	            forEach(symbol.declarations, (declaration, index) => {
	              const decl = getNameOfDeclaration(declaration) || declaration;
	              const diag3 = messageNeedsName ? createDiagnosticForNode2(decl, message, getDisplayName(declaration)) : createDiagnosticForNode2(decl, message);
	              file.bindDiagnostics.push(
	                multipleDefaultExports ? addRelatedInfo(diag3, createDiagnosticForNode2(declarationName, index === 0 ? Diagnostics.Another_export_default_is_here : Diagnostics.and_here)) : diag3
	              );
	              if (multipleDefaultExports) {
	                relatedInformation.push(createDiagnosticForNode2(decl, Diagnostics.The_first_export_default_is_here));
	              }
	            });
	            const diag2 = messageNeedsName ? createDiagnosticForNode2(declarationName, message, getDisplayName(node)) : createDiagnosticForNode2(declarationName, message);
	            file.bindDiagnostics.push(addRelatedInfo(diag2, ...relatedInformation));
	            symbol = createSymbol(0 /* None */, name);
	          }
	        }
	      }
	      addDeclarationToSymbol(symbol, node, includes);
	      if (symbol.parent) {
	        Debug.assert(symbol.parent === parent3, "Existing symbol parent should match new one");
	      } else {
	        symbol.parent = parent3;
	      }
	      return symbol;
	    }
	    function declareModuleMember(node, symbolFlags, symbolExcludes) {
	      const hasExportModifier = !!(getCombinedModifierFlags(node) & 32 /* Export */) || jsdocTreatAsExported(node);
	      if (symbolFlags & 2097152 /* Alias */) {
	        if (node.kind === 281 /* ExportSpecifier */ || node.kind === 271 /* ImportEqualsDeclaration */ && hasExportModifier) {
	          return declareSymbol(container.symbol.exports, container.symbol, node, symbolFlags, symbolExcludes);
	        } else {
	          Debug.assertNode(container, canHaveLocals);
	          return declareSymbol(
	            container.locals,
	            /*parent*/
	            void 0,
	            node,
	            symbolFlags,
	            symbolExcludes
	          );
	        }
	      } else {
	        if (isJSDocTypeAlias(node))
	          Debug.assert(isInJSFile(node));
	        if (!isAmbientModule(node) && (hasExportModifier || container.flags & 128 /* ExportContext */)) {
	          if (!canHaveLocals(container) || !container.locals || hasSyntacticModifier(node, 2048 /* Default */) && !getDeclarationName(node)) {
	            return declareSymbol(container.symbol.exports, container.symbol, node, symbolFlags, symbolExcludes);
	          }
	          const exportKind = symbolFlags & 111551 /* Value */ ? 1048576 /* ExportValue */ : 0;
	          const local = declareSymbol(
	            container.locals,
	            /*parent*/
	            void 0,
	            node,
	            exportKind,
	            symbolExcludes
	          );
	          local.exportSymbol = declareSymbol(container.symbol.exports, container.symbol, node, symbolFlags, symbolExcludes);
	          node.localSymbol = local;
	          return local;
	        } else {
	          Debug.assertNode(container, canHaveLocals);
	          return declareSymbol(
	            container.locals,
	            /*parent*/
	            void 0,
	            node,
	            symbolFlags,
	            symbolExcludes
	          );
	        }
	      }
	    }
	    function jsdocTreatAsExported(node) {
	      if (node.parent && isModuleDeclaration(node)) {
	        node = node.parent;
	      }
	      if (!isJSDocTypeAlias(node))
	        return false;
	      if (!isJSDocEnumTag(node) && !!node.fullName)
	        return true;
	      const declName = getNameOfDeclaration(node);
	      if (!declName)
	        return false;
	      if (isPropertyAccessEntityNameExpression(declName.parent) && isTopLevelNamespaceAssignment(declName.parent))
	        return true;
	      if (isDeclaration(declName.parent) && getCombinedModifierFlags(declName.parent) & 32 /* Export */)
	        return true;
	      return false;
	    }
	    function bindContainer(node, containerFlags) {
	      const saveContainer = container;
	      const saveThisParentContainer = thisParentContainer;
	      const savedBlockScopeContainer = blockScopeContainer;
	      if (containerFlags & 1 /* IsContainer */) {
	        if (node.kind !== 219 /* ArrowFunction */) {
	          thisParentContainer = container;
	        }
	        container = blockScopeContainer = node;
	        if (containerFlags & 32 /* HasLocals */) {
	          container.locals = createSymbolTable();
	          addToContainerChain(container);
	        }
	      } else if (containerFlags & 2 /* IsBlockScopedContainer */) {
	        blockScopeContainer = node;
	        if (containerFlags & 32 /* HasLocals */) {
	          blockScopeContainer.locals = void 0;
	        }
	      }
	      if (containerFlags & 4 /* IsControlFlowContainer */) {
	        const saveCurrentFlow = currentFlow;
	        const saveBreakTarget = currentBreakTarget;
	        const saveContinueTarget = currentContinueTarget;
	        const saveReturnTarget = currentReturnTarget;
	        const saveExceptionTarget = currentExceptionTarget;
	        const saveActiveLabelList = activeLabelList;
	        const saveHasExplicitReturn = hasExplicitReturn;
	        const isImmediatelyInvoked = containerFlags & 16 /* IsFunctionExpression */ && !hasSyntacticModifier(node, 1024 /* Async */) && !node.asteriskToken && !!getImmediatelyInvokedFunctionExpression(node) || node.kind === 175 /* ClassStaticBlockDeclaration */;
	        if (!isImmediatelyInvoked) {
	          currentFlow = initFlowNode({ flags: 2 /* Start */ });
	          if (containerFlags & (16 /* IsFunctionExpression */ | 128 /* IsObjectLiteralOrClassExpressionMethodOrAccessor */)) {
	            currentFlow.node = node;
	          }
	        }
	        currentReturnTarget = isImmediatelyInvoked || node.kind === 176 /* Constructor */ || isInJSFile(node) && (node.kind === 262 /* FunctionDeclaration */ || node.kind === 218 /* FunctionExpression */) ? createBranchLabel() : void 0;
	        currentExceptionTarget = void 0;
	        currentBreakTarget = void 0;
	        currentContinueTarget = void 0;
	        activeLabelList = void 0;
	        hasExplicitReturn = false;
	        bindChildren(node);
	        node.flags &= ~5632 /* ReachabilityAndEmitFlags */;
	        if (!(currentFlow.flags & 1 /* Unreachable */) && containerFlags & 8 /* IsFunctionLike */ && nodeIsPresent(node.body)) {
	          node.flags |= 512 /* HasImplicitReturn */;
	          if (hasExplicitReturn)
	            node.flags |= 1024 /* HasExplicitReturn */;
	          node.endFlowNode = currentFlow;
	        }
	        if (node.kind === 312 /* SourceFile */) {
	          node.flags |= emitFlags;
	          node.endFlowNode = currentFlow;
	        }
	        if (currentReturnTarget) {
	          addAntecedent(currentReturnTarget, currentFlow);
	          currentFlow = finishFlowLabel(currentReturnTarget);
	          if (node.kind === 176 /* Constructor */ || node.kind === 175 /* ClassStaticBlockDeclaration */ || isInJSFile(node) && (node.kind === 262 /* FunctionDeclaration */ || node.kind === 218 /* FunctionExpression */)) {
	            node.returnFlowNode = currentFlow;
	          }
	        }
	        if (!isImmediatelyInvoked) {
	          currentFlow = saveCurrentFlow;
	        }
	        currentBreakTarget = saveBreakTarget;
	        currentContinueTarget = saveContinueTarget;
	        currentReturnTarget = saveReturnTarget;
	        currentExceptionTarget = saveExceptionTarget;
	        activeLabelList = saveActiveLabelList;
	        hasExplicitReturn = saveHasExplicitReturn;
	      } else if (containerFlags & 64 /* IsInterface */) {
	        seenThisKeyword = false;
	        bindChildren(node);
	        Debug.assertNotNode(node, isIdentifier);
	        node.flags = seenThisKeyword ? node.flags | 256 /* ContainsThis */ : node.flags & ~256 /* ContainsThis */;
	      } else {
	        bindChildren(node);
	      }
	      container = saveContainer;
	      thisParentContainer = saveThisParentContainer;
	      blockScopeContainer = savedBlockScopeContainer;
	    }
	    function bindEachFunctionsFirst(nodes) {
	      bindEach(nodes, (n) => n.kind === 262 /* FunctionDeclaration */ ? bind(n) : void 0);
	      bindEach(nodes, (n) => n.kind !== 262 /* FunctionDeclaration */ ? bind(n) : void 0);
	    }
	    function bindEach(nodes, bindFunction = bind) {
	      if (nodes === void 0) {
	        return;
	      }
	      forEach(nodes, bindFunction);
	    }
	    function bindEachChild(node) {
	      forEachChild(node, bind, bindEach);
	    }
	    function bindChildren(node) {
	      const saveInAssignmentPattern = inAssignmentPattern;
	      inAssignmentPattern = false;
	      if (checkUnreachable(node)) {
	        bindEachChild(node);
	        bindJSDoc(node);
	        inAssignmentPattern = saveInAssignmentPattern;
	        return;
	      }
	      if (node.kind >= 243 /* FirstStatement */ && node.kind <= 259 /* LastStatement */ && !options.allowUnreachableCode) {
	        node.flowNode = currentFlow;
	      }
	      switch (node.kind) {
	        case 247 /* WhileStatement */:
	          bindWhileStatement(node);
	          break;
	        case 246 /* DoStatement */:
	          bindDoStatement(node);
	          break;
	        case 248 /* ForStatement */:
	          bindForStatement(node);
	          break;
	        case 249 /* ForInStatement */:
	        case 250 /* ForOfStatement */:
	          bindForInOrForOfStatement(node);
	          break;
	        case 245 /* IfStatement */:
	          bindIfStatement(node);
	          break;
	        case 253 /* ReturnStatement */:
	        case 257 /* ThrowStatement */:
	          bindReturnOrThrow(node);
	          break;
	        case 252 /* BreakStatement */:
	        case 251 /* ContinueStatement */:
	          bindBreakOrContinueStatement(node);
	          break;
	        case 258 /* TryStatement */:
	          bindTryStatement(node);
	          break;
	        case 255 /* SwitchStatement */:
	          bindSwitchStatement(node);
	          break;
	        case 269 /* CaseBlock */:
	          bindCaseBlock(node);
	          break;
	        case 296 /* CaseClause */:
	          bindCaseClause(node);
	          break;
	        case 244 /* ExpressionStatement */:
	          bindExpressionStatement(node);
	          break;
	        case 256 /* LabeledStatement */:
	          bindLabeledStatement(node);
	          break;
	        case 224 /* PrefixUnaryExpression */:
	          bindPrefixUnaryExpressionFlow(node);
	          break;
	        case 225 /* PostfixUnaryExpression */:
	          bindPostfixUnaryExpressionFlow(node);
	          break;
	        case 226 /* BinaryExpression */:
	          if (isDestructuringAssignment(node)) {
	            inAssignmentPattern = saveInAssignmentPattern;
	            bindDestructuringAssignmentFlow(node);
	            return;
	          }
	          bindBinaryExpressionFlow(node);
	          break;
	        case 220 /* DeleteExpression */:
	          bindDeleteExpressionFlow(node);
	          break;
	        case 227 /* ConditionalExpression */:
	          bindConditionalExpressionFlow(node);
	          break;
	        case 260 /* VariableDeclaration */:
	          bindVariableDeclarationFlow(node);
	          break;
	        case 211 /* PropertyAccessExpression */:
	        case 212 /* ElementAccessExpression */:
	          bindAccessExpressionFlow(node);
	          break;
	        case 213 /* CallExpression */:
	          bindCallExpressionFlow(node);
	          break;
	        case 235 /* NonNullExpression */:
	          bindNonNullExpressionFlow(node);
	          break;
	        case 353 /* JSDocTypedefTag */:
	        case 345 /* JSDocCallbackTag */:
	        case 347 /* JSDocEnumTag */:
	          bindJSDocTypeAlias(node);
	          break;
	        case 312 /* SourceFile */: {
	          bindEachFunctionsFirst(node.statements);
	          bind(node.endOfFileToken);
	          break;
	        }
	        case 241 /* Block */:
	        case 268 /* ModuleBlock */:
	          bindEachFunctionsFirst(node.statements);
	          break;
	        case 208 /* BindingElement */:
	          bindBindingElementFlow(node);
	          break;
	        case 169 /* Parameter */:
	          bindParameterFlow(node);
	          break;
	        case 210 /* ObjectLiteralExpression */:
	        case 209 /* ArrayLiteralExpression */:
	        case 303 /* PropertyAssignment */:
	        case 230 /* SpreadElement */:
	          inAssignmentPattern = saveInAssignmentPattern;
	        default:
	          bindEachChild(node);
	          break;
	      }
	      bindJSDoc(node);
	      inAssignmentPattern = saveInAssignmentPattern;
	    }
	    function isNarrowingExpression(expr) {
	      switch (expr.kind) {
	        case 80 /* Identifier */:
	        case 81 /* PrivateIdentifier */:
	        case 110 /* ThisKeyword */:
	        case 211 /* PropertyAccessExpression */:
	        case 212 /* ElementAccessExpression */:
	          return containsNarrowableReference(expr);
	        case 213 /* CallExpression */:
	          return hasNarrowableArgument(expr);
	        case 217 /* ParenthesizedExpression */:
	          if (isJSDocTypeAssertion(expr)) {
	            return false;
	          }
	        case 235 /* NonNullExpression */:
	          return isNarrowingExpression(expr.expression);
	        case 226 /* BinaryExpression */:
	          return isNarrowingBinaryExpression(expr);
	        case 224 /* PrefixUnaryExpression */:
	          return expr.operator === 54 /* ExclamationToken */ && isNarrowingExpression(expr.operand);
	        case 221 /* TypeOfExpression */:
	          return isNarrowingExpression(expr.expression);
	      }
	      return false;
	    }
	    function isNarrowableReference(expr) {
	      return isDottedName(expr) || (isPropertyAccessExpression(expr) || isNonNullExpression(expr) || isParenthesizedExpression(expr)) && isNarrowableReference(expr.expression) || isBinaryExpression(expr) && expr.operatorToken.kind === 28 /* CommaToken */ && isNarrowableReference(expr.right) || isElementAccessExpression(expr) && (isStringOrNumericLiteralLike(expr.argumentExpression) || isEntityNameExpression(expr.argumentExpression)) && isNarrowableReference(expr.expression) || isAssignmentExpression(expr) && isNarrowableReference(expr.left);
	    }
	    function containsNarrowableReference(expr) {
	      return isNarrowableReference(expr) || isOptionalChain(expr) && containsNarrowableReference(expr.expression);
	    }
	    function hasNarrowableArgument(expr) {
	      if (expr.arguments) {
	        for (const argument of expr.arguments) {
	          if (containsNarrowableReference(argument)) {
	            return true;
	          }
	        }
	      }
	      if (expr.expression.kind === 211 /* PropertyAccessExpression */ && containsNarrowableReference(expr.expression.expression)) {
	        return true;
	      }
	      return false;
	    }
	    function isNarrowingTypeofOperands(expr1, expr2) {
	      return isTypeOfExpression(expr1) && isNarrowableOperand(expr1.expression) && isStringLiteralLike(expr2);
	    }
	    function isNarrowingBinaryExpression(expr) {
	      switch (expr.operatorToken.kind) {
	        case 64 /* EqualsToken */:
	        case 76 /* BarBarEqualsToken */:
	        case 77 /* AmpersandAmpersandEqualsToken */:
	        case 78 /* QuestionQuestionEqualsToken */:
	          return containsNarrowableReference(expr.left);
	        case 35 /* EqualsEqualsToken */:
	        case 36 /* ExclamationEqualsToken */:
	        case 37 /* EqualsEqualsEqualsToken */:
	        case 38 /* ExclamationEqualsEqualsToken */:
	          return isNarrowableOperand(expr.left) || isNarrowableOperand(expr.right) || isNarrowingTypeofOperands(expr.right, expr.left) || isNarrowingTypeofOperands(expr.left, expr.right) || (isBooleanLiteral(expr.right) && isNarrowingExpression(expr.left) || isBooleanLiteral(expr.left) && isNarrowingExpression(expr.right));
	        case 104 /* InstanceOfKeyword */:
	          return isNarrowableOperand(expr.left);
	        case 103 /* InKeyword */:
	          return isNarrowingExpression(expr.right);
	        case 28 /* CommaToken */:
	          return isNarrowingExpression(expr.right);
	      }
	      return false;
	    }
	    function isNarrowableOperand(expr) {
	      switch (expr.kind) {
	        case 217 /* ParenthesizedExpression */:
	          return isNarrowableOperand(expr.expression);
	        case 226 /* BinaryExpression */:
	          switch (expr.operatorToken.kind) {
	            case 64 /* EqualsToken */:
	              return isNarrowableOperand(expr.left);
	            case 28 /* CommaToken */:
	              return isNarrowableOperand(expr.right);
	          }
	      }
	      return containsNarrowableReference(expr);
	    }
	    function createBranchLabel() {
	      return initFlowNode({ flags: 4 /* BranchLabel */, antecedents: void 0 });
	    }
	    function createLoopLabel() {
	      return initFlowNode({ flags: 8 /* LoopLabel */, antecedents: void 0 });
	    }
	    function createReduceLabel(target, antecedents, antecedent) {
	      return initFlowNode({ flags: 1024 /* ReduceLabel */, target, antecedents, antecedent });
	    }
	    function setFlowNodeReferenced(flow) {
	      flow.flags |= flow.flags & 2048 /* Referenced */ ? 4096 /* Shared */ : 2048 /* Referenced */;
	    }
	    function addAntecedent(label, antecedent) {
	      if (!(antecedent.flags & 1 /* Unreachable */) && !contains(label.antecedents, antecedent)) {
	        (label.antecedents || (label.antecedents = [])).push(antecedent);
	        setFlowNodeReferenced(antecedent);
	      }
	    }
	    function createFlowCondition(flags, antecedent, expression) {
	      if (antecedent.flags & 1 /* Unreachable */) {
	        return antecedent;
	      }
	      if (!expression) {
	        return flags & 32 /* TrueCondition */ ? antecedent : unreachableFlow;
	      }
	      if ((expression.kind === 112 /* TrueKeyword */ && flags & 64 /* FalseCondition */ || expression.kind === 97 /* FalseKeyword */ && flags & 32 /* TrueCondition */) && !isExpressionOfOptionalChainRoot(expression) && !isNullishCoalesce(expression.parent)) {
	        return unreachableFlow;
	      }
	      if (!isNarrowingExpression(expression)) {
	        return antecedent;
	      }
	      setFlowNodeReferenced(antecedent);
	      return initFlowNode({ flags, antecedent, node: expression });
	    }
	    function createFlowSwitchClause(antecedent, switchStatement, clauseStart, clauseEnd) {
	      setFlowNodeReferenced(antecedent);
	      return initFlowNode({ flags: 128 /* SwitchClause */, antecedent, switchStatement, clauseStart, clauseEnd });
	    }
	    function createFlowMutation(flags, antecedent, node) {
	      setFlowNodeReferenced(antecedent);
	      const result = initFlowNode({ flags, antecedent, node });
	      if (currentExceptionTarget) {
	        addAntecedent(currentExceptionTarget, result);
	      }
	      return result;
	    }
	    function createFlowCall(antecedent, node) {
	      setFlowNodeReferenced(antecedent);
	      return initFlowNode({ flags: 512 /* Call */, antecedent, node });
	    }
	    function finishFlowLabel(flow) {
	      const antecedents = flow.antecedents;
	      if (!antecedents) {
	        return unreachableFlow;
	      }
	      if (antecedents.length === 1) {
	        return antecedents[0];
	      }
	      return flow;
	    }
	    function isStatementCondition(node) {
	      const parent3 = node.parent;
	      switch (parent3.kind) {
	        case 245 /* IfStatement */:
	        case 247 /* WhileStatement */:
	        case 246 /* DoStatement */:
	          return parent3.expression === node;
	        case 248 /* ForStatement */:
	        case 227 /* ConditionalExpression */:
	          return parent3.condition === node;
	      }
	      return false;
	    }
	    function isLogicalExpression(node) {
	      while (true) {
	        if (node.kind === 217 /* ParenthesizedExpression */) {
	          node = node.expression;
	        } else if (node.kind === 224 /* PrefixUnaryExpression */ && node.operator === 54 /* ExclamationToken */) {
	          node = node.operand;
	        } else {
	          return isLogicalOrCoalescingBinaryExpression(node);
	        }
	      }
	    }
	    function isLogicalAssignmentExpression(node) {
	      return isLogicalOrCoalescingAssignmentExpression(skipParentheses(node));
	    }
	    function isTopLevelLogicalExpression(node) {
	      while (isParenthesizedExpression(node.parent) || isPrefixUnaryExpression(node.parent) && node.parent.operator === 54 /* ExclamationToken */) {
	        node = node.parent;
	      }
	      return !isStatementCondition(node) && !isLogicalExpression(node.parent) && !(isOptionalChain(node.parent) && node.parent.expression === node);
	    }
	    function doWithConditionalBranches(action, value, trueTarget, falseTarget) {
	      const savedTrueTarget = currentTrueTarget;
	      const savedFalseTarget = currentFalseTarget;
	      currentTrueTarget = trueTarget;
	      currentFalseTarget = falseTarget;
	      action(value);
	      currentTrueTarget = savedTrueTarget;
	      currentFalseTarget = savedFalseTarget;
	    }
	    function bindCondition(node, trueTarget, falseTarget) {
	      doWithConditionalBranches(bind, node, trueTarget, falseTarget);
	      if (!node || !isLogicalAssignmentExpression(node) && !isLogicalExpression(node) && !(isOptionalChain(node) && isOutermostOptionalChain(node))) {
	        addAntecedent(trueTarget, createFlowCondition(32 /* TrueCondition */, currentFlow, node));
	        addAntecedent(falseTarget, createFlowCondition(64 /* FalseCondition */, currentFlow, node));
	      }
	    }
	    function bindIterativeStatement(node, breakTarget, continueTarget) {
	      const saveBreakTarget = currentBreakTarget;
	      const saveContinueTarget = currentContinueTarget;
	      currentBreakTarget = breakTarget;
	      currentContinueTarget = continueTarget;
	      bind(node);
	      currentBreakTarget = saveBreakTarget;
	      currentContinueTarget = saveContinueTarget;
	    }
	    function setContinueTarget(node, target) {
	      let label = activeLabelList;
	      while (label && node.parent.kind === 256 /* LabeledStatement */) {
	        label.continueTarget = target;
	        label = label.next;
	        node = node.parent;
	      }
	      return target;
	    }
	    function bindWhileStatement(node) {
	      const preWhileLabel = setContinueTarget(node, createLoopLabel());
	      const preBodyLabel = createBranchLabel();
	      const postWhileLabel = createBranchLabel();
	      addAntecedent(preWhileLabel, currentFlow);
	      currentFlow = preWhileLabel;
	      bindCondition(node.expression, preBodyLabel, postWhileLabel);
	      currentFlow = finishFlowLabel(preBodyLabel);
	      bindIterativeStatement(node.statement, postWhileLabel, preWhileLabel);
	      addAntecedent(preWhileLabel, currentFlow);
	      currentFlow = finishFlowLabel(postWhileLabel);
	    }
	    function bindDoStatement(node) {
	      const preDoLabel = createLoopLabel();
	      const preConditionLabel = setContinueTarget(node, createBranchLabel());
	      const postDoLabel = createBranchLabel();
	      addAntecedent(preDoLabel, currentFlow);
	      currentFlow = preDoLabel;
	      bindIterativeStatement(node.statement, postDoLabel, preConditionLabel);
	      addAntecedent(preConditionLabel, currentFlow);
	      currentFlow = finishFlowLabel(preConditionLabel);
	      bindCondition(node.expression, preDoLabel, postDoLabel);
	      currentFlow = finishFlowLabel(postDoLabel);
	    }
	    function bindForStatement(node) {
	      const preLoopLabel = setContinueTarget(node, createLoopLabel());
	      const preBodyLabel = createBranchLabel();
	      const postLoopLabel = createBranchLabel();
	      bind(node.initializer);
	      addAntecedent(preLoopLabel, currentFlow);
	      currentFlow = preLoopLabel;
	      bindCondition(node.condition, preBodyLabel, postLoopLabel);
	      currentFlow = finishFlowLabel(preBodyLabel);
	      bindIterativeStatement(node.statement, postLoopLabel, preLoopLabel);
	      bind(node.incrementor);
	      addAntecedent(preLoopLabel, currentFlow);
	      currentFlow = finishFlowLabel(postLoopLabel);
	    }
	    function bindForInOrForOfStatement(node) {
	      const preLoopLabel = setContinueTarget(node, createLoopLabel());
	      const postLoopLabel = createBranchLabel();
	      bind(node.expression);
	      addAntecedent(preLoopLabel, currentFlow);
	      currentFlow = preLoopLabel;
	      if (node.kind === 250 /* ForOfStatement */) {
	        bind(node.awaitModifier);
	      }
	      addAntecedent(postLoopLabel, currentFlow);
	      bind(node.initializer);
	      if (node.initializer.kind !== 261 /* VariableDeclarationList */) {
	        bindAssignmentTargetFlow(node.initializer);
	      }
	      bindIterativeStatement(node.statement, postLoopLabel, preLoopLabel);
	      addAntecedent(preLoopLabel, currentFlow);
	      currentFlow = finishFlowLabel(postLoopLabel);
	    }
	    function bindIfStatement(node) {
	      const thenLabel = createBranchLabel();
	      const elseLabel = createBranchLabel();
	      const postIfLabel = createBranchLabel();
	      bindCondition(node.expression, thenLabel, elseLabel);
	      currentFlow = finishFlowLabel(thenLabel);
	      bind(node.thenStatement);
	      addAntecedent(postIfLabel, currentFlow);
	      currentFlow = finishFlowLabel(elseLabel);
	      bind(node.elseStatement);
	      addAntecedent(postIfLabel, currentFlow);
	      currentFlow = finishFlowLabel(postIfLabel);
	    }
	    function bindReturnOrThrow(node) {
	      bind(node.expression);
	      if (node.kind === 253 /* ReturnStatement */) {
	        hasExplicitReturn = true;
	        if (currentReturnTarget) {
	          addAntecedent(currentReturnTarget, currentFlow);
	        }
	      }
	      currentFlow = unreachableFlow;
	    }
	    function findActiveLabel(name) {
	      for (let label = activeLabelList; label; label = label.next) {
	        if (label.name === name) {
	          return label;
	        }
	      }
	      return void 0;
	    }
	    function bindBreakOrContinueFlow(node, breakTarget, continueTarget) {
	      const flowLabel = node.kind === 252 /* BreakStatement */ ? breakTarget : continueTarget;
	      if (flowLabel) {
	        addAntecedent(flowLabel, currentFlow);
	        currentFlow = unreachableFlow;
	      }
	    }
	    function bindBreakOrContinueStatement(node) {
	      bind(node.label);
	      if (node.label) {
	        const activeLabel = findActiveLabel(node.label.escapedText);
	        if (activeLabel) {
	          activeLabel.referenced = true;
	          bindBreakOrContinueFlow(node, activeLabel.breakTarget, activeLabel.continueTarget);
	        }
	      } else {
	        bindBreakOrContinueFlow(node, currentBreakTarget, currentContinueTarget);
	      }
	    }
	    function bindTryStatement(node) {
	      const saveReturnTarget = currentReturnTarget;
	      const saveExceptionTarget = currentExceptionTarget;
	      const normalExitLabel = createBranchLabel();
	      const returnLabel = createBranchLabel();
	      let exceptionLabel = createBranchLabel();
	      if (node.finallyBlock) {
	        currentReturnTarget = returnLabel;
	      }
	      addAntecedent(exceptionLabel, currentFlow);
	      currentExceptionTarget = exceptionLabel;
	      bind(node.tryBlock);
	      addAntecedent(normalExitLabel, currentFlow);
	      if (node.catchClause) {
	        currentFlow = finishFlowLabel(exceptionLabel);
	        exceptionLabel = createBranchLabel();
	        addAntecedent(exceptionLabel, currentFlow);
	        currentExceptionTarget = exceptionLabel;
	        bind(node.catchClause);
	        addAntecedent(normalExitLabel, currentFlow);
	      }
	      currentReturnTarget = saveReturnTarget;
	      currentExceptionTarget = saveExceptionTarget;
	      if (node.finallyBlock) {
	        const finallyLabel = createBranchLabel();
	        finallyLabel.antecedents = concatenate(concatenate(normalExitLabel.antecedents, exceptionLabel.antecedents), returnLabel.antecedents);
	        currentFlow = finallyLabel;
	        bind(node.finallyBlock);
	        if (currentFlow.flags & 1 /* Unreachable */) {
	          currentFlow = unreachableFlow;
	        } else {
	          if (currentReturnTarget && returnLabel.antecedents) {
	            addAntecedent(currentReturnTarget, createReduceLabel(finallyLabel, returnLabel.antecedents, currentFlow));
	          }
	          if (currentExceptionTarget && exceptionLabel.antecedents) {
	            addAntecedent(currentExceptionTarget, createReduceLabel(finallyLabel, exceptionLabel.antecedents, currentFlow));
	          }
	          currentFlow = normalExitLabel.antecedents ? createReduceLabel(finallyLabel, normalExitLabel.antecedents, currentFlow) : unreachableFlow;
	        }
	      } else {
	        currentFlow = finishFlowLabel(normalExitLabel);
	      }
	    }
	    function bindSwitchStatement(node) {
	      const postSwitchLabel = createBranchLabel();
	      bind(node.expression);
	      const saveBreakTarget = currentBreakTarget;
	      const savePreSwitchCaseFlow = preSwitchCaseFlow;
	      currentBreakTarget = postSwitchLabel;
	      preSwitchCaseFlow = currentFlow;
	      bind(node.caseBlock);
	      addAntecedent(postSwitchLabel, currentFlow);
	      const hasDefault = forEach(node.caseBlock.clauses, (c) => c.kind === 297 /* DefaultClause */);
	      node.possiblyExhaustive = !hasDefault && !postSwitchLabel.antecedents;
	      if (!hasDefault) {
	        addAntecedent(postSwitchLabel, createFlowSwitchClause(preSwitchCaseFlow, node, 0, 0));
	      }
	      currentBreakTarget = saveBreakTarget;
	      preSwitchCaseFlow = savePreSwitchCaseFlow;
	      currentFlow = finishFlowLabel(postSwitchLabel);
	    }
	    function bindCaseBlock(node) {
	      const clauses = node.clauses;
	      const isNarrowingSwitch = node.parent.expression.kind === 112 /* TrueKeyword */ || isNarrowingExpression(node.parent.expression);
	      let fallthroughFlow = unreachableFlow;
	      for (let i = 0; i < clauses.length; i++) {
	        const clauseStart = i;
	        while (!clauses[i].statements.length && i + 1 < clauses.length) {
	          if (fallthroughFlow === unreachableFlow) {
	            currentFlow = preSwitchCaseFlow;
	          }
	          bind(clauses[i]);
	          i++;
	        }
	        const preCaseLabel = createBranchLabel();
	        addAntecedent(preCaseLabel, isNarrowingSwitch ? createFlowSwitchClause(preSwitchCaseFlow, node.parent, clauseStart, i + 1) : preSwitchCaseFlow);
	        addAntecedent(preCaseLabel, fallthroughFlow);
	        currentFlow = finishFlowLabel(preCaseLabel);
	        const clause = clauses[i];
	        bind(clause);
	        fallthroughFlow = currentFlow;
	        if (!(currentFlow.flags & 1 /* Unreachable */) && i !== clauses.length - 1 && options.noFallthroughCasesInSwitch) {
	          clause.fallthroughFlowNode = currentFlow;
	        }
	      }
	    }
	    function bindCaseClause(node) {
	      const saveCurrentFlow = currentFlow;
	      currentFlow = preSwitchCaseFlow;
	      bind(node.expression);
	      currentFlow = saveCurrentFlow;
	      bindEach(node.statements);
	    }
	    function bindExpressionStatement(node) {
	      bind(node.expression);
	      maybeBindExpressionFlowIfCall(node.expression);
	    }
	    function maybeBindExpressionFlowIfCall(node) {
	      if (node.kind === 213 /* CallExpression */) {
	        const call = node;
	        if (call.expression.kind !== 108 /* SuperKeyword */ && isDottedName(call.expression)) {
	          currentFlow = createFlowCall(currentFlow, call);
	        }
	      }
	    }
	    function bindLabeledStatement(node) {
	      const postStatementLabel = createBranchLabel();
	      activeLabelList = {
	        next: activeLabelList,
	        name: node.label.escapedText,
	        breakTarget: postStatementLabel,
	        continueTarget: void 0,
	        referenced: false
	      };
	      bind(node.label);
	      bind(node.statement);
	      if (!activeLabelList.referenced && !options.allowUnusedLabels) {
	        errorOrSuggestionOnNode(unusedLabelIsError(options), node.label, Diagnostics.Unused_label);
	      }
	      activeLabelList = activeLabelList.next;
	      addAntecedent(postStatementLabel, currentFlow);
	      currentFlow = finishFlowLabel(postStatementLabel);
	    }
	    function bindDestructuringTargetFlow(node) {
	      if (node.kind === 226 /* BinaryExpression */ && node.operatorToken.kind === 64 /* EqualsToken */) {
	        bindAssignmentTargetFlow(node.left);
	      } else {
	        bindAssignmentTargetFlow(node);
	      }
	    }
	    function bindAssignmentTargetFlow(node) {
	      if (isNarrowableReference(node)) {
	        currentFlow = createFlowMutation(16 /* Assignment */, currentFlow, node);
	      } else if (node.kind === 209 /* ArrayLiteralExpression */) {
	        for (const e of node.elements) {
	          if (e.kind === 230 /* SpreadElement */) {
	            bindAssignmentTargetFlow(e.expression);
	          } else {
	            bindDestructuringTargetFlow(e);
	          }
	        }
	      } else if (node.kind === 210 /* ObjectLiteralExpression */) {
	        for (const p of node.properties) {
	          if (p.kind === 303 /* PropertyAssignment */) {
	            bindDestructuringTargetFlow(p.initializer);
	          } else if (p.kind === 304 /* ShorthandPropertyAssignment */) {
	            bindAssignmentTargetFlow(p.name);
	          } else if (p.kind === 305 /* SpreadAssignment */) {
	            bindAssignmentTargetFlow(p.expression);
	          }
	        }
	      }
	    }
	    function bindLogicalLikeExpression(node, trueTarget, falseTarget) {
	      const preRightLabel = createBranchLabel();
	      if (node.operatorToken.kind === 56 /* AmpersandAmpersandToken */ || node.operatorToken.kind === 77 /* AmpersandAmpersandEqualsToken */) {
	        bindCondition(node.left, preRightLabel, falseTarget);
	      } else {
	        bindCondition(node.left, trueTarget, preRightLabel);
	      }
	      currentFlow = finishFlowLabel(preRightLabel);
	      bind(node.operatorToken);
	      if (isLogicalOrCoalescingAssignmentOperator(node.operatorToken.kind)) {
	        doWithConditionalBranches(bind, node.right, trueTarget, falseTarget);
	        bindAssignmentTargetFlow(node.left);
	        addAntecedent(trueTarget, createFlowCondition(32 /* TrueCondition */, currentFlow, node));
	        addAntecedent(falseTarget, createFlowCondition(64 /* FalseCondition */, currentFlow, node));
	      } else {
	        bindCondition(node.right, trueTarget, falseTarget);
	      }
	    }
	    function bindPrefixUnaryExpressionFlow(node) {
	      if (node.operator === 54 /* ExclamationToken */) {
	        const saveTrueTarget = currentTrueTarget;
	        currentTrueTarget = currentFalseTarget;
	        currentFalseTarget = saveTrueTarget;
	        bindEachChild(node);
	        currentFalseTarget = currentTrueTarget;
	        currentTrueTarget = saveTrueTarget;
	      } else {
	        bindEachChild(node);
	        if (node.operator === 46 /* PlusPlusToken */ || node.operator === 47 /* MinusMinusToken */) {
	          bindAssignmentTargetFlow(node.operand);
	        }
	      }
	    }
	    function bindPostfixUnaryExpressionFlow(node) {
	      bindEachChild(node);
	      if (node.operator === 46 /* PlusPlusToken */ || node.operator === 47 /* MinusMinusToken */) {
	        bindAssignmentTargetFlow(node.operand);
	      }
	    }
	    function bindDestructuringAssignmentFlow(node) {
	      if (inAssignmentPattern) {
	        inAssignmentPattern = false;
	        bind(node.operatorToken);
	        bind(node.right);
	        inAssignmentPattern = true;
	        bind(node.left);
	      } else {
	        inAssignmentPattern = true;
	        bind(node.left);
	        inAssignmentPattern = false;
	        bind(node.operatorToken);
	        bind(node.right);
	      }
	      bindAssignmentTargetFlow(node.left);
	    }
	    function createBindBinaryExpressionFlow() {
	      return createBinaryExpressionTrampoline(
	        onEnter,
	        onLeft,
	        onOperator,
	        onRight,
	        onExit,
	        /*foldState*/
	        void 0
	      );
	      function onEnter(node, state) {
	        if (state) {
	          state.stackIndex++;
	          setParent(node, parent2);
	          const saveInStrictMode = inStrictMode;
	          bindWorker(node);
	          const saveParent = parent2;
	          parent2 = node;
	          state.skip = false;
	          state.inStrictModeStack[state.stackIndex] = saveInStrictMode;
	          state.parentStack[state.stackIndex] = saveParent;
	        } else {
	          state = {
	            stackIndex: 0,
	            skip: false,
	            inStrictModeStack: [void 0],
	            parentStack: [void 0]
	          };
	        }
	        const operator = node.operatorToken.kind;
	        if (isLogicalOrCoalescingBinaryOperator(operator) || isLogicalOrCoalescingAssignmentOperator(operator)) {
	          if (isTopLevelLogicalExpression(node)) {
	            const postExpressionLabel = createBranchLabel();
	            bindLogicalLikeExpression(node, postExpressionLabel, postExpressionLabel);
	            currentFlow = finishFlowLabel(postExpressionLabel);
	          } else {
	            bindLogicalLikeExpression(node, currentTrueTarget, currentFalseTarget);
	          }
	          state.skip = true;
	        }
	        return state;
	      }
	      function onLeft(left, state, node) {
	        if (!state.skip) {
	          const maybeBound = maybeBind2(left);
	          if (node.operatorToken.kind === 28 /* CommaToken */) {
	            maybeBindExpressionFlowIfCall(left);
	          }
	          return maybeBound;
	        }
	      }
	      function onOperator(operatorToken, state, _node) {
	        if (!state.skip) {
	          bind(operatorToken);
	        }
	      }
	      function onRight(right, state, node) {
	        if (!state.skip) {
	          const maybeBound = maybeBind2(right);
	          if (node.operatorToken.kind === 28 /* CommaToken */) {
	            maybeBindExpressionFlowIfCall(right);
	          }
	          return maybeBound;
	        }
	      }
	      function onExit(node, state) {
	        if (!state.skip) {
	          const operator = node.operatorToken.kind;
	          if (isAssignmentOperator(operator) && !isAssignmentTarget(node)) {
	            bindAssignmentTargetFlow(node.left);
	            if (operator === 64 /* EqualsToken */ && node.left.kind === 212 /* ElementAccessExpression */) {
	              const elementAccess = node.left;
	              if (isNarrowableOperand(elementAccess.expression)) {
	                currentFlow = createFlowMutation(256 /* ArrayMutation */, currentFlow, node);
	              }
	            }
	          }
	        }
	        const savedInStrictMode = state.inStrictModeStack[state.stackIndex];
	        const savedParent = state.parentStack[state.stackIndex];
	        if (savedInStrictMode !== void 0) {
	          inStrictMode = savedInStrictMode;
	        }
	        if (savedParent !== void 0) {
	          parent2 = savedParent;
	        }
	        state.skip = false;
	        state.stackIndex--;
	      }
	      function maybeBind2(node) {
	        if (node && isBinaryExpression(node) && !isDestructuringAssignment(node)) {
	          return node;
	        }
	        bind(node);
	      }
	    }
	    function bindDeleteExpressionFlow(node) {
	      bindEachChild(node);
	      if (node.expression.kind === 211 /* PropertyAccessExpression */) {
	        bindAssignmentTargetFlow(node.expression);
	      }
	    }
	    function bindConditionalExpressionFlow(node) {
	      const trueLabel = createBranchLabel();
	      const falseLabel = createBranchLabel();
	      const postExpressionLabel = createBranchLabel();
	      bindCondition(node.condition, trueLabel, falseLabel);
	      currentFlow = finishFlowLabel(trueLabel);
	      bind(node.questionToken);
	      bind(node.whenTrue);
	      addAntecedent(postExpressionLabel, currentFlow);
	      currentFlow = finishFlowLabel(falseLabel);
	      bind(node.colonToken);
	      bind(node.whenFalse);
	      addAntecedent(postExpressionLabel, currentFlow);
	      currentFlow = finishFlowLabel(postExpressionLabel);
	    }
	    function bindInitializedVariableFlow(node) {
	      const name = !isOmittedExpression(node) ? node.name : void 0;
	      if (isBindingPattern(name)) {
	        for (const child of name.elements) {
	          bindInitializedVariableFlow(child);
	        }
	      } else {
	        currentFlow = createFlowMutation(16 /* Assignment */, currentFlow, node);
	      }
	    }
	    function bindVariableDeclarationFlow(node) {
	      bindEachChild(node);
	      if (node.initializer || isForInOrOfStatement(node.parent.parent)) {
	        bindInitializedVariableFlow(node);
	      }
	    }
	    function bindBindingElementFlow(node) {
	      bind(node.dotDotDotToken);
	      bind(node.propertyName);
	      bindInitializer(node.initializer);
	      bind(node.name);
	    }
	    function bindParameterFlow(node) {
	      bindEach(node.modifiers);
	      bind(node.dotDotDotToken);
	      bind(node.questionToken);
	      bind(node.type);
	      bindInitializer(node.initializer);
	      bind(node.name);
	    }
	    function bindInitializer(node) {
	      if (!node) {
	        return;
	      }
	      const entryFlow = currentFlow;
	      bind(node);
	      if (entryFlow === unreachableFlow || entryFlow === currentFlow) {
	        return;
	      }
	      const exitFlow = createBranchLabel();
	      addAntecedent(exitFlow, entryFlow);
	      addAntecedent(exitFlow, currentFlow);
	      currentFlow = finishFlowLabel(exitFlow);
	    }
	    function bindJSDocTypeAlias(node) {
	      bind(node.tagName);
	      if (node.kind !== 347 /* JSDocEnumTag */ && node.fullName) {
	        setParent(node.fullName, node);
	        setParentRecursive(
	          node.fullName,
	          /*incremental*/
	          false
	        );
	      }
	      if (typeof node.comment !== "string") {
	        bindEach(node.comment);
	      }
	    }
	    function bindJSDocClassTag(node) {
	      bindEachChild(node);
	      const host = getHostSignatureFromJSDoc(node);
	      if (host && host.kind !== 174 /* MethodDeclaration */) {
	        addDeclarationToSymbol(host.symbol, host, 32 /* Class */);
	      }
	    }
	    function bindOptionalExpression(node, trueTarget, falseTarget) {
	      doWithConditionalBranches(bind, node, trueTarget, falseTarget);
	      if (!isOptionalChain(node) || isOutermostOptionalChain(node)) {
	        addAntecedent(trueTarget, createFlowCondition(32 /* TrueCondition */, currentFlow, node));
	        addAntecedent(falseTarget, createFlowCondition(64 /* FalseCondition */, currentFlow, node));
	      }
	    }
	    function bindOptionalChainRest(node) {
	      switch (node.kind) {
	        case 211 /* PropertyAccessExpression */:
	          bind(node.questionDotToken);
	          bind(node.name);
	          break;
	        case 212 /* ElementAccessExpression */:
	          bind(node.questionDotToken);
	          bind(node.argumentExpression);
	          break;
	        case 213 /* CallExpression */:
	          bind(node.questionDotToken);
	          bindEach(node.typeArguments);
	          bindEach(node.arguments);
	          break;
	      }
	    }
	    function bindOptionalChain(node, trueTarget, falseTarget) {
	      const preChainLabel = isOptionalChainRoot(node) ? createBranchLabel() : void 0;
	      bindOptionalExpression(node.expression, preChainLabel || trueTarget, falseTarget);
	      if (preChainLabel) {
	        currentFlow = finishFlowLabel(preChainLabel);
	      }
	      doWithConditionalBranches(bindOptionalChainRest, node, trueTarget, falseTarget);
	      if (isOutermostOptionalChain(node)) {
	        addAntecedent(trueTarget, createFlowCondition(32 /* TrueCondition */, currentFlow, node));
	        addAntecedent(falseTarget, createFlowCondition(64 /* FalseCondition */, currentFlow, node));
	      }
	    }
	    function bindOptionalChainFlow(node) {
	      if (isTopLevelLogicalExpression(node)) {
	        const postExpressionLabel = createBranchLabel();
	        bindOptionalChain(node, postExpressionLabel, postExpressionLabel);
	        currentFlow = finishFlowLabel(postExpressionLabel);
	      } else {
	        bindOptionalChain(node, currentTrueTarget, currentFalseTarget);
	      }
	    }
	    function bindNonNullExpressionFlow(node) {
	      if (isOptionalChain(node)) {
	        bindOptionalChainFlow(node);
	      } else {
	        bindEachChild(node);
	      }
	    }
	    function bindAccessExpressionFlow(node) {
	      if (isOptionalChain(node)) {
	        bindOptionalChainFlow(node);
	      } else {
	        bindEachChild(node);
	      }
	    }
	    function bindCallExpressionFlow(node) {
	      if (isOptionalChain(node)) {
	        bindOptionalChainFlow(node);
	      } else {
	        const expr = skipParentheses(node.expression);
	        if (expr.kind === 218 /* FunctionExpression */ || expr.kind === 219 /* ArrowFunction */) {
	          bindEach(node.typeArguments);
	          bindEach(node.arguments);
	          bind(node.expression);
	        } else {
	          bindEachChild(node);
	          if (node.expression.kind === 108 /* SuperKeyword */) {
	            currentFlow = createFlowCall(currentFlow, node);
	          }
	        }
	      }
	      if (node.expression.kind === 211 /* PropertyAccessExpression */) {
	        const propertyAccess = node.expression;
	        if (isIdentifier(propertyAccess.name) && isNarrowableOperand(propertyAccess.expression) && isPushOrUnshiftIdentifier(propertyAccess.name)) {
	          currentFlow = createFlowMutation(256 /* ArrayMutation */, currentFlow, node);
	        }
	      }
	    }
	    function addToContainerChain(next) {
	      if (lastContainer) {
	        lastContainer.nextContainer = next;
	      }
	      lastContainer = next;
	    }
	    function declareSymbolAndAddToSymbolTable(node, symbolFlags, symbolExcludes) {
	      switch (container.kind) {
	        case 267 /* ModuleDeclaration */:
	          return declareModuleMember(node, symbolFlags, symbolExcludes);
	        case 312 /* SourceFile */:
	          return declareSourceFileMember(node, symbolFlags, symbolExcludes);
	        case 231 /* ClassExpression */:
	        case 263 /* ClassDeclaration */:
	          return declareClassMember(node, symbolFlags, symbolExcludes);
	        case 266 /* EnumDeclaration */:
	          return declareSymbol(container.symbol.exports, container.symbol, node, symbolFlags, symbolExcludes);
	        case 187 /* TypeLiteral */:
	        case 329 /* JSDocTypeLiteral */:
	        case 210 /* ObjectLiteralExpression */:
	        case 264 /* InterfaceDeclaration */:
	        case 292 /* JsxAttributes */:
	          return declareSymbol(container.symbol.members, container.symbol, node, symbolFlags, symbolExcludes);
	        case 184 /* FunctionType */:
	        case 185 /* ConstructorType */:
	        case 179 /* CallSignature */:
	        case 180 /* ConstructSignature */:
	        case 330 /* JSDocSignature */:
	        case 181 /* IndexSignature */:
	        case 174 /* MethodDeclaration */:
	        case 173 /* MethodSignature */:
	        case 176 /* Constructor */:
	        case 177 /* GetAccessor */:
	        case 178 /* SetAccessor */:
	        case 262 /* FunctionDeclaration */:
	        case 218 /* FunctionExpression */:
	        case 219 /* ArrowFunction */:
	        case 324 /* JSDocFunctionType */:
	        case 175 /* ClassStaticBlockDeclaration */:
	        case 265 /* TypeAliasDeclaration */:
	        case 200 /* MappedType */:
	          if (container.locals)
	            Debug.assertNode(container, canHaveLocals);
	          return declareSymbol(
	            container.locals,
	            /*parent*/
	            void 0,
	            node,
	            symbolFlags,
	            symbolExcludes
	          );
	      }
	    }
	    function declareClassMember(node, symbolFlags, symbolExcludes) {
	      return isStatic(node) ? declareSymbol(container.symbol.exports, container.symbol, node, symbolFlags, symbolExcludes) : declareSymbol(container.symbol.members, container.symbol, node, symbolFlags, symbolExcludes);
	    }
	    function declareSourceFileMember(node, symbolFlags, symbolExcludes) {
	      return isExternalModule(file) ? declareModuleMember(node, symbolFlags, symbolExcludes) : declareSymbol(
	        file.locals,
	        /*parent*/
	        void 0,
	        node,
	        symbolFlags,
	        symbolExcludes
	      );
	    }
	    function hasExportDeclarations(node) {
	      const body = isSourceFile(node) ? node : tryCast(node.body, isModuleBlock);
	      return !!body && body.statements.some((s) => isExportDeclaration(s) || isExportAssignment(s));
	    }
	    function setExportContextFlag(node) {
	      if (node.flags & 33554432 /* Ambient */ && !hasExportDeclarations(node)) {
	        node.flags |= 128 /* ExportContext */;
	      } else {
	        node.flags &= ~128 /* ExportContext */;
	      }
	    }
	    function bindModuleDeclaration(node) {
	      setExportContextFlag(node);
	      if (isAmbientModule(node)) {
	        if (hasSyntacticModifier(node, 32 /* Export */)) {
	          errorOnFirstToken(node, Diagnostics.export_modifier_cannot_be_applied_to_ambient_modules_and_module_augmentations_since_they_are_always_visible);
	        }
	        if (isModuleAugmentationExternal(node)) {
	          declareModuleSymbol(node);
	        } else {
	          let pattern;
	          if (node.name.kind === 11 /* StringLiteral */) {
	            const { text } = node.name;
	            pattern = tryParsePattern(text);
	            if (pattern === void 0) {
	              errorOnFirstToken(node.name, Diagnostics.Pattern_0_can_have_at_most_one_Asterisk_character, text);
	            }
	          }
	          const symbol = declareSymbolAndAddToSymbolTable(node, 512 /* ValueModule */, 110735 /* ValueModuleExcludes */);
	          file.patternAmbientModules = append(file.patternAmbientModules, pattern && !isString(pattern) ? { pattern, symbol } : void 0);
	        }
	      } else {
	        const state = declareModuleSymbol(node);
	        if (state !== 0 /* NonInstantiated */) {
	          const { symbol } = node;
	          symbol.constEnumOnlyModule = !(symbol.flags & (16 /* Function */ | 32 /* Class */ | 256 /* RegularEnum */)) && state === 2 /* ConstEnumOnly */ && symbol.constEnumOnlyModule !== false;
	        }
	      }
	    }
	    function declareModuleSymbol(node) {
	      const state = getModuleInstanceState(node);
	      const instantiated = state !== 0 /* NonInstantiated */;
	      declareSymbolAndAddToSymbolTable(
	        node,
	        instantiated ? 512 /* ValueModule */ : 1024 /* NamespaceModule */,
	        instantiated ? 110735 /* ValueModuleExcludes */ : 0 /* NamespaceModuleExcludes */
	      );
	      return state;
	    }
	    function bindFunctionOrConstructorType(node) {
	      const symbol = createSymbol(131072 /* Signature */, getDeclarationName(node));
	      addDeclarationToSymbol(symbol, node, 131072 /* Signature */);
	      const typeLiteralSymbol = createSymbol(2048 /* TypeLiteral */, "__type" /* Type */);
	      addDeclarationToSymbol(typeLiteralSymbol, node, 2048 /* TypeLiteral */);
	      typeLiteralSymbol.members = createSymbolTable();
	      typeLiteralSymbol.members.set(symbol.escapedName, symbol);
	    }
	    function bindObjectLiteralExpression(node) {
	      return bindAnonymousDeclaration(node, 4096 /* ObjectLiteral */, "__object" /* Object */);
	    }
	    function bindJsxAttributes(node) {
	      return bindAnonymousDeclaration(node, 4096 /* ObjectLiteral */, "__jsxAttributes" /* JSXAttributes */);
	    }
	    function bindJsxAttribute(node, symbolFlags, symbolExcludes) {
	      return declareSymbolAndAddToSymbolTable(node, symbolFlags, symbolExcludes);
	    }
	    function bindAnonymousDeclaration(node, symbolFlags, name) {
	      const symbol = createSymbol(symbolFlags, name);
	      if (symbolFlags & (8 /* EnumMember */ | 106500 /* ClassMember */)) {
	        symbol.parent = container.symbol;
	      }
	      addDeclarationToSymbol(symbol, node, symbolFlags);
	      return symbol;
	    }
	    function bindBlockScopedDeclaration(node, symbolFlags, symbolExcludes) {
	      switch (blockScopeContainer.kind) {
	        case 267 /* ModuleDeclaration */:
	          declareModuleMember(node, symbolFlags, symbolExcludes);
	          break;
	        case 312 /* SourceFile */:
	          if (isExternalOrCommonJsModule(container)) {
	            declareModuleMember(node, symbolFlags, symbolExcludes);
	            break;
	          }
	        default:
	          Debug.assertNode(blockScopeContainer, canHaveLocals);
	          if (!blockScopeContainer.locals) {
	            blockScopeContainer.locals = createSymbolTable();
	            addToContainerChain(blockScopeContainer);
	          }
	          declareSymbol(
	            blockScopeContainer.locals,
	            /*parent*/
	            void 0,
	            node,
	            symbolFlags,
	            symbolExcludes
	          );
	      }
	    }
	    function delayedBindJSDocTypedefTag() {
	      if (!delayedTypeAliases) {
	        return;
	      }
	      const saveContainer = container;
	      const saveLastContainer = lastContainer;
	      const saveBlockScopeContainer = blockScopeContainer;
	      const saveParent = parent2;
	      const saveCurrentFlow = currentFlow;
	      for (const typeAlias of delayedTypeAliases) {
	        const host = typeAlias.parent.parent;
	        container = getEnclosingContainer(host) || file;
	        blockScopeContainer = getEnclosingBlockScopeContainer(host) || file;
	        currentFlow = initFlowNode({ flags: 2 /* Start */ });
	        parent2 = typeAlias;
	        bind(typeAlias.typeExpression);
	        const declName = getNameOfDeclaration(typeAlias);
	        if ((isJSDocEnumTag(typeAlias) || !typeAlias.fullName) && declName && isPropertyAccessEntityNameExpression(declName.parent)) {
	          const isTopLevel = isTopLevelNamespaceAssignment(declName.parent);
	          if (isTopLevel) {
	            bindPotentiallyMissingNamespaces(
	              file.symbol,
	              declName.parent,
	              isTopLevel,
	              !!findAncestor(declName, (d) => isPropertyAccessExpression(d) && d.name.escapedText === "prototype"),
	              /*containerIsClass*/
	              false
	            );
	            const oldContainer = container;
	            switch (getAssignmentDeclarationPropertyAccessKind(declName.parent)) {
	              case 1 /* ExportsProperty */:
	              case 2 /* ModuleExports */:
	                if (!isExternalOrCommonJsModule(file)) {
	                  container = void 0;
	                } else {
	                  container = file;
	                }
	                break;
	              case 4 /* ThisProperty */:
	                container = declName.parent.expression;
	                break;
	              case 3 /* PrototypeProperty */:
	                container = declName.parent.expression.name;
	                break;
	              case 5 /* Property */:
	                container = isExportsOrModuleExportsOrAlias(file, declName.parent.expression) ? file : isPropertyAccessExpression(declName.parent.expression) ? declName.parent.expression.name : declName.parent.expression;
	                break;
	              case 0 /* None */:
	                return Debug.fail("Shouldn't have detected typedef or enum on non-assignment declaration");
	            }
	            if (container) {
	              declareModuleMember(typeAlias, 524288 /* TypeAlias */, 788968 /* TypeAliasExcludes */);
	            }
	            container = oldContainer;
	          }
	        } else if (isJSDocEnumTag(typeAlias) || !typeAlias.fullName || typeAlias.fullName.kind === 80 /* Identifier */) {
	          parent2 = typeAlias.parent;
	          bindBlockScopedDeclaration(typeAlias, 524288 /* TypeAlias */, 788968 /* TypeAliasExcludes */);
	        } else {
	          bind(typeAlias.fullName);
	        }
	      }
	      container = saveContainer;
	      lastContainer = saveLastContainer;
	      blockScopeContainer = saveBlockScopeContainer;
	      parent2 = saveParent;
	      currentFlow = saveCurrentFlow;
	    }
	    function checkContextualIdentifier(node) {
	      if (!file.parseDiagnostics.length && !(node.flags & 33554432 /* Ambient */) && !(node.flags & 16777216 /* JSDoc */) && !isIdentifierName(node)) {
	        const originalKeywordKind = identifierToKeywordKind(node);
	        if (originalKeywordKind === void 0) {
	          return;
	        }
	        if (inStrictMode && originalKeywordKind >= 119 /* FirstFutureReservedWord */ && originalKeywordKind <= 127 /* LastFutureReservedWord */) {
	          file.bindDiagnostics.push(createDiagnosticForNode2(node, getStrictModeIdentifierMessage(node), declarationNameToString(node)));
	        } else if (originalKeywordKind === 135 /* AwaitKeyword */) {
	          if (isExternalModule(file) && isInTopLevelContext(node)) {
	            file.bindDiagnostics.push(createDiagnosticForNode2(node, Diagnostics.Identifier_expected_0_is_a_reserved_word_at_the_top_level_of_a_module, declarationNameToString(node)));
	          } else if (node.flags & 65536 /* AwaitContext */) {
	            file.bindDiagnostics.push(createDiagnosticForNode2(node, Diagnostics.Identifier_expected_0_is_a_reserved_word_that_cannot_be_used_here, declarationNameToString(node)));
	          }
	        } else if (originalKeywordKind === 127 /* YieldKeyword */ && node.flags & 16384 /* YieldContext */) {
	          file.bindDiagnostics.push(createDiagnosticForNode2(node, Diagnostics.Identifier_expected_0_is_a_reserved_word_that_cannot_be_used_here, declarationNameToString(node)));
	        }
	      }
	    }
	    function getStrictModeIdentifierMessage(node) {
	      if (getContainingClass(node)) {
	        return Diagnostics.Identifier_expected_0_is_a_reserved_word_in_strict_mode_Class_definitions_are_automatically_in_strict_mode;
	      }
	      if (file.externalModuleIndicator) {
	        return Diagnostics.Identifier_expected_0_is_a_reserved_word_in_strict_mode_Modules_are_automatically_in_strict_mode;
	      }
	      return Diagnostics.Identifier_expected_0_is_a_reserved_word_in_strict_mode;
	    }
	    function checkPrivateIdentifier(node) {
	      if (node.escapedText === "#constructor") {
	        if (!file.parseDiagnostics.length) {
	          file.bindDiagnostics.push(createDiagnosticForNode2(node, Diagnostics.constructor_is_a_reserved_word, declarationNameToString(node)));
	        }
	      }
	    }
	    function checkStrictModeBinaryExpression(node) {
	      if (inStrictMode && isLeftHandSideExpression(node.left) && isAssignmentOperator(node.operatorToken.kind)) {
	        checkStrictModeEvalOrArguments(node, node.left);
	      }
	    }
	    function checkStrictModeCatchClause(node) {
	      if (inStrictMode && node.variableDeclaration) {
	        checkStrictModeEvalOrArguments(node, node.variableDeclaration.name);
	      }
	    }
	    function checkStrictModeDeleteExpression(node) {
	      if (inStrictMode && node.expression.kind === 80 /* Identifier */) {
	        const span = getErrorSpanForNode(file, node.expression);
	        file.bindDiagnostics.push(createFileDiagnostic(file, span.start, span.length, Diagnostics.delete_cannot_be_called_on_an_identifier_in_strict_mode));
	      }
	    }
	    function isEvalOrArgumentsIdentifier(node) {
	      return isIdentifier(node) && (node.escapedText === "eval" || node.escapedText === "arguments");
	    }
	    function checkStrictModeEvalOrArguments(contextNode, name) {
	      if (name && name.kind === 80 /* Identifier */) {
	        const identifier = name;
	        if (isEvalOrArgumentsIdentifier(identifier)) {
	          const span = getErrorSpanForNode(file, name);
	          file.bindDiagnostics.push(createFileDiagnostic(file, span.start, span.length, getStrictModeEvalOrArgumentsMessage(contextNode), idText(identifier)));
	        }
	      }
	    }
	    function getStrictModeEvalOrArgumentsMessage(node) {
	      if (getContainingClass(node)) {
	        return Diagnostics.Code_contained_in_a_class_is_evaluated_in_JavaScript_s_strict_mode_which_does_not_allow_this_use_of_0_For_more_information_see_https_Colon_Slash_Slashdeveloper_mozilla_org_Slashen_US_Slashdocs_SlashWeb_SlashJavaScript_SlashReference_SlashStrict_mode;
	      }
	      if (file.externalModuleIndicator) {
	        return Diagnostics.Invalid_use_of_0_Modules_are_automatically_in_strict_mode;
	      }
	      return Diagnostics.Invalid_use_of_0_in_strict_mode;
	    }
	    function checkStrictModeFunctionName(node) {
	      if (inStrictMode) {
	        checkStrictModeEvalOrArguments(node, node.name);
	      }
	    }
	    function getStrictModeBlockScopeFunctionDeclarationMessage(node) {
	      if (getContainingClass(node)) {
	        return Diagnostics.Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5_Class_definitions_are_automatically_in_strict_mode;
	      }
	      if (file.externalModuleIndicator) {
	        return Diagnostics.Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5_Modules_are_automatically_in_strict_mode;
	      }
	      return Diagnostics.Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5;
	    }
	    function checkStrictModeFunctionDeclaration(node) {
	      if (languageVersion < 2 /* ES2015 */) {
	        if (blockScopeContainer.kind !== 312 /* SourceFile */ && blockScopeContainer.kind !== 267 /* ModuleDeclaration */ && !isFunctionLikeOrClassStaticBlockDeclaration(blockScopeContainer)) {
	          const errorSpan = getErrorSpanForNode(file, node);
	          file.bindDiagnostics.push(createFileDiagnostic(file, errorSpan.start, errorSpan.length, getStrictModeBlockScopeFunctionDeclarationMessage(node)));
	        }
	      }
	    }
	    function checkStrictModePostfixUnaryExpression(node) {
	      if (inStrictMode) {
	        checkStrictModeEvalOrArguments(node, node.operand);
	      }
	    }
	    function checkStrictModePrefixUnaryExpression(node) {
	      if (inStrictMode) {
	        if (node.operator === 46 /* PlusPlusToken */ || node.operator === 47 /* MinusMinusToken */) {
	          checkStrictModeEvalOrArguments(node, node.operand);
	        }
	      }
	    }
	    function checkStrictModeWithStatement(node) {
	      if (inStrictMode) {
	        errorOnFirstToken(node, Diagnostics.with_statements_are_not_allowed_in_strict_mode);
	      }
	    }
	    function checkStrictModeLabeledStatement(node) {
	      if (inStrictMode && getEmitScriptTarget(options) >= 2 /* ES2015 */) {
	        if (isDeclarationStatement(node.statement) || isVariableStatement(node.statement)) {
	          errorOnFirstToken(node.label, Diagnostics.A_label_is_not_allowed_here);
	        }
	      }
	    }
	    function errorOnFirstToken(node, message, ...args) {
	      const span = getSpanOfTokenAtPosition(file, node.pos);
	      file.bindDiagnostics.push(createFileDiagnostic(file, span.start, span.length, message, ...args));
	    }
	    function errorOrSuggestionOnNode(isError, node, message) {
	      errorOrSuggestionOnRange(isError, node, node, message);
	    }
	    function errorOrSuggestionOnRange(isError, startNode2, endNode2, message) {
	      addErrorOrSuggestionDiagnostic(isError, { pos: getTokenPosOfNode(startNode2, file), end: endNode2.end }, message);
	    }
	    function addErrorOrSuggestionDiagnostic(isError, range, message) {
	      const diag2 = createFileDiagnostic(file, range.pos, range.end - range.pos, message);
	      if (isError) {
	        file.bindDiagnostics.push(diag2);
	      } else {
	        file.bindSuggestionDiagnostics = append(file.bindSuggestionDiagnostics, { ...diag2, category: 2 /* Suggestion */ });
	      }
	    }
	    function bind(node) {
	      if (!node) {
	        return;
	      }
	      setParent(node, parent2);
	      if (tracing)
	        node.tracingPath = file.path;
	      const saveInStrictMode = inStrictMode;
	      bindWorker(node);
	      if (node.kind > 165 /* LastToken */) {
	        const saveParent = parent2;
	        parent2 = node;
	        const containerFlags = getContainerFlags(node);
	        if (containerFlags === 0 /* None */) {
	          bindChildren(node);
	        } else {
	          bindContainer(node, containerFlags);
	        }
	        parent2 = saveParent;
	      } else {
	        const saveParent = parent2;
	        if (node.kind === 1 /* EndOfFileToken */)
	          parent2 = node;
	        bindJSDoc(node);
	        parent2 = saveParent;
	      }
	      inStrictMode = saveInStrictMode;
	    }
	    function bindJSDoc(node) {
	      if (hasJSDocNodes(node)) {
	        if (isInJSFile(node)) {
	          for (const j of node.jsDoc) {
	            bind(j);
	          }
	        } else {
	          for (const j of node.jsDoc) {
	            setParent(j, node);
	            setParentRecursive(
	              j,
	              /*incremental*/
	              false
	            );
	          }
	        }
	      }
	    }
	    function updateStrictModeStatementList(statements) {
	      if (!inStrictMode) {
	        for (const statement of statements) {
	          if (!isPrologueDirective(statement)) {
	            return;
	          }
	          if (isUseStrictPrologueDirective(statement)) {
	            inStrictMode = true;
	            return;
	          }
	        }
	      }
	    }
	    function isUseStrictPrologueDirective(node) {
	      const nodeText2 = getSourceTextOfNodeFromSourceFile(file, node.expression);
	      return nodeText2 === '"use strict"' || nodeText2 === "'use strict'";
	    }
	    function bindWorker(node) {
	      switch (node.kind) {
	        case 80 /* Identifier */:
	          if (node.flags & 4096 /* IdentifierIsInJSDocNamespace */) {
	            let parentNode = node.parent;
	            while (parentNode && !isJSDocTypeAlias(parentNode)) {
	              parentNode = parentNode.parent;
	            }
	            bindBlockScopedDeclaration(parentNode, 524288 /* TypeAlias */, 788968 /* TypeAliasExcludes */);
	            break;
	          }
	        case 110 /* ThisKeyword */:
	          if (currentFlow && (isExpression(node) || parent2.kind === 304 /* ShorthandPropertyAssignment */)) {
	            node.flowNode = currentFlow;
	          }
	          return checkContextualIdentifier(node);
	        case 166 /* QualifiedName */:
	          if (currentFlow && isPartOfTypeQuery(node)) {
	            node.flowNode = currentFlow;
	          }
	          break;
	        case 236 /* MetaProperty */:
	        case 108 /* SuperKeyword */:
	          node.flowNode = currentFlow;
	          break;
	        case 81 /* PrivateIdentifier */:
	          return checkPrivateIdentifier(node);
	        case 211 /* PropertyAccessExpression */:
	        case 212 /* ElementAccessExpression */:
	          const expr = node;
	          if (currentFlow && isNarrowableReference(expr)) {
	            expr.flowNode = currentFlow;
	          }
	          if (isSpecialPropertyDeclaration(expr)) {
	            bindSpecialPropertyDeclaration(expr);
	          }
	          if (isInJSFile(expr) && file.commonJsModuleIndicator && isModuleExportsAccessExpression(expr) && !lookupSymbolForName(blockScopeContainer, "module")) {
	            declareSymbol(
	              file.locals,
	              /*parent*/
	              void 0,
	              expr.expression,
	              1 /* FunctionScopedVariable */ | 134217728 /* ModuleExports */,
	              111550 /* FunctionScopedVariableExcludes */
	            );
	          }
	          break;
	        case 226 /* BinaryExpression */:
	          const specialKind = getAssignmentDeclarationKind(node);
	          switch (specialKind) {
	            case 1 /* ExportsProperty */:
	              bindExportsPropertyAssignment(node);
	              break;
	            case 2 /* ModuleExports */:
	              bindModuleExportsAssignment(node);
	              break;
	            case 3 /* PrototypeProperty */:
	              bindPrototypePropertyAssignment(node.left, node);
	              break;
	            case 6 /* Prototype */:
	              bindPrototypeAssignment(node);
	              break;
	            case 4 /* ThisProperty */:
	              bindThisPropertyAssignment(node);
	              break;
	            case 5 /* Property */:
	              const expression = node.left.expression;
	              if (isInJSFile(node) && isIdentifier(expression)) {
	                const symbol = lookupSymbolForName(blockScopeContainer, expression.escapedText);
	                if (isThisInitializedDeclaration(symbol == null ? void 0 : symbol.valueDeclaration)) {
	                  bindThisPropertyAssignment(node);
	                  break;
	                }
	              }
	              bindSpecialPropertyAssignment(node);
	              break;
	            case 0 /* None */:
	              break;
	            default:
	              Debug.fail("Unknown binary expression special property assignment kind");
	          }
	          return checkStrictModeBinaryExpression(node);
	        case 299 /* CatchClause */:
	          return checkStrictModeCatchClause(node);
	        case 220 /* DeleteExpression */:
	          return checkStrictModeDeleteExpression(node);
	        case 225 /* PostfixUnaryExpression */:
	          return checkStrictModePostfixUnaryExpression(node);
	        case 224 /* PrefixUnaryExpression */:
	          return checkStrictModePrefixUnaryExpression(node);
	        case 254 /* WithStatement */:
	          return checkStrictModeWithStatement(node);
	        case 256 /* LabeledStatement */:
	          return checkStrictModeLabeledStatement(node);
	        case 197 /* ThisType */:
	          seenThisKeyword = true;
	          return;
	        case 182 /* TypePredicate */:
	          break;
	        case 168 /* TypeParameter */:
	          return bindTypeParameter(node);
	        case 169 /* Parameter */:
	          return bindParameter(node);
	        case 260 /* VariableDeclaration */:
	          return bindVariableDeclarationOrBindingElement(node);
	        case 208 /* BindingElement */:
	          node.flowNode = currentFlow;
	          return bindVariableDeclarationOrBindingElement(node);
	        case 172 /* PropertyDeclaration */:
	        case 171 /* PropertySignature */:
	          return bindPropertyWorker(node);
	        case 303 /* PropertyAssignment */:
	        case 304 /* ShorthandPropertyAssignment */:
	          return bindPropertyOrMethodOrAccessor(node, 4 /* Property */, 0 /* PropertyExcludes */);
	        case 306 /* EnumMember */:
	          return bindPropertyOrMethodOrAccessor(node, 8 /* EnumMember */, 900095 /* EnumMemberExcludes */);
	        case 179 /* CallSignature */:
	        case 180 /* ConstructSignature */:
	        case 181 /* IndexSignature */:
	          return declareSymbolAndAddToSymbolTable(node, 131072 /* Signature */, 0 /* None */);
	        case 174 /* MethodDeclaration */:
	        case 173 /* MethodSignature */:
	          return bindPropertyOrMethodOrAccessor(node, 8192 /* Method */ | (node.questionToken ? 16777216 /* Optional */ : 0 /* None */), isObjectLiteralMethod(node) ? 0 /* PropertyExcludes */ : 103359 /* MethodExcludes */);
	        case 262 /* FunctionDeclaration */:
	          return bindFunctionDeclaration(node);
	        case 176 /* Constructor */:
	          return declareSymbolAndAddToSymbolTable(
	            node,
	            16384 /* Constructor */,
	            /*symbolExcludes:*/
	            0 /* None */
	          );
	        case 177 /* GetAccessor */:
	          return bindPropertyOrMethodOrAccessor(node, 32768 /* GetAccessor */, 46015 /* GetAccessorExcludes */);
	        case 178 /* SetAccessor */:
	          return bindPropertyOrMethodOrAccessor(node, 65536 /* SetAccessor */, 78783 /* SetAccessorExcludes */);
	        case 184 /* FunctionType */:
	        case 324 /* JSDocFunctionType */:
	        case 330 /* JSDocSignature */:
	        case 185 /* ConstructorType */:
	          return bindFunctionOrConstructorType(node);
	        case 187 /* TypeLiteral */:
	        case 329 /* JSDocTypeLiteral */:
	        case 200 /* MappedType */:
	          return bindAnonymousTypeWorker(node);
	        case 339 /* JSDocClassTag */:
	          return bindJSDocClassTag(node);
	        case 210 /* ObjectLiteralExpression */:
	          return bindObjectLiteralExpression(node);
	        case 218 /* FunctionExpression */:
	        case 219 /* ArrowFunction */:
	          return bindFunctionExpression(node);
	        case 213 /* CallExpression */:
	          const assignmentKind = getAssignmentDeclarationKind(node);
	          switch (assignmentKind) {
	            case 7 /* ObjectDefinePropertyValue */:
	              return bindObjectDefinePropertyAssignment(node);
	            case 8 /* ObjectDefinePropertyExports */:
	              return bindObjectDefinePropertyExport(node);
	            case 9 /* ObjectDefinePrototypeProperty */:
	              return bindObjectDefinePrototypeProperty(node);
	            case 0 /* None */:
	              break;
	            default:
	              return Debug.fail("Unknown call expression assignment declaration kind");
	          }
	          if (isInJSFile(node)) {
	            bindCallExpression(node);
	          }
	          break;
	        case 231 /* ClassExpression */:
	        case 263 /* ClassDeclaration */:
	          inStrictMode = true;
	          return bindClassLikeDeclaration(node);
	        case 264 /* InterfaceDeclaration */:
	          return bindBlockScopedDeclaration(node, 64 /* Interface */, 788872 /* InterfaceExcludes */);
	        case 265 /* TypeAliasDeclaration */:
	          return bindBlockScopedDeclaration(node, 524288 /* TypeAlias */, 788968 /* TypeAliasExcludes */);
	        case 266 /* EnumDeclaration */:
	          return bindEnumDeclaration(node);
	        case 267 /* ModuleDeclaration */:
	          return bindModuleDeclaration(node);
	        case 292 /* JsxAttributes */:
	          return bindJsxAttributes(node);
	        case 291 /* JsxAttribute */:
	          return bindJsxAttribute(node, 4 /* Property */, 0 /* PropertyExcludes */);
	        case 271 /* ImportEqualsDeclaration */:
	        case 274 /* NamespaceImport */:
	        case 276 /* ImportSpecifier */:
	        case 281 /* ExportSpecifier */:
	          return declareSymbolAndAddToSymbolTable(node, 2097152 /* Alias */, 2097152 /* AliasExcludes */);
	        case 270 /* NamespaceExportDeclaration */:
	          return bindNamespaceExportDeclaration(node);
	        case 273 /* ImportClause */:
	          return bindImportClause(node);
	        case 278 /* ExportDeclaration */:
	          return bindExportDeclaration(node);
	        case 277 /* ExportAssignment */:
	          return bindExportAssignment(node);
	        case 312 /* SourceFile */:
	          updateStrictModeStatementList(node.statements);
	          return bindSourceFileIfExternalModule();
	        case 241 /* Block */:
	          if (!isFunctionLikeOrClassStaticBlockDeclaration(node.parent)) {
	            return;
	          }
	        case 268 /* ModuleBlock */:
	          return updateStrictModeStatementList(node.statements);
	        case 348 /* JSDocParameterTag */:
	          if (node.parent.kind === 330 /* JSDocSignature */) {
	            return bindParameter(node);
	          }
	          if (node.parent.kind !== 329 /* JSDocTypeLiteral */) {
	            break;
	          }
	        case 355 /* JSDocPropertyTag */:
	          const propTag = node;
	          const flags = propTag.isBracketed || propTag.typeExpression && propTag.typeExpression.type.kind === 323 /* JSDocOptionalType */ ? 4 /* Property */ | 16777216 /* Optional */ : 4 /* Property */;
	          return declareSymbolAndAddToSymbolTable(propTag, flags, 0 /* PropertyExcludes */);
	        case 353 /* JSDocTypedefTag */:
	        case 345 /* JSDocCallbackTag */:
	        case 347 /* JSDocEnumTag */:
	          return (delayedTypeAliases || (delayedTypeAliases = [])).push(node);
	        case 346 /* JSDocOverloadTag */:
	          return bind(node.typeExpression);
	      }
	    }
	    function bindPropertyWorker(node) {
	      const isAutoAccessor = isAutoAccessorPropertyDeclaration(node);
	      const includes = isAutoAccessor ? 98304 /* Accessor */ : 4 /* Property */;
	      const excludes = isAutoAccessor ? 13247 /* AccessorExcludes */ : 0 /* PropertyExcludes */;
	      return bindPropertyOrMethodOrAccessor(node, includes | (node.questionToken ? 16777216 /* Optional */ : 0 /* None */), excludes);
	    }
	    function bindAnonymousTypeWorker(node) {
	      return bindAnonymousDeclaration(node, 2048 /* TypeLiteral */, "__type" /* Type */);
	    }
	    function bindSourceFileIfExternalModule() {
	      setExportContextFlag(file);
	      if (isExternalModule(file)) {
	        bindSourceFileAsExternalModule();
	      } else if (isJsonSourceFile(file)) {
	        bindSourceFileAsExternalModule();
	        const originalSymbol = file.symbol;
	        declareSymbol(file.symbol.exports, file.symbol, file, 4 /* Property */, -1 /* All */);
	        file.symbol = originalSymbol;
	      }
	    }
	    function bindSourceFileAsExternalModule() {
	      bindAnonymousDeclaration(file, 512 /* ValueModule */, `"${removeFileExtension(file.fileName)}"`);
	    }
	    function bindExportAssignment(node) {
	      if (!container.symbol || !container.symbol.exports) {
	        bindAnonymousDeclaration(node, 111551 /* Value */, getDeclarationName(node));
	      } else {
	        const flags = exportAssignmentIsAlias(node) ? 2097152 /* Alias */ : 4 /* Property */;
	        const symbol = declareSymbol(container.symbol.exports, container.symbol, node, flags, -1 /* All */);
	        if (node.isExportEquals) {
	          setValueDeclaration(symbol, node);
	        }
	      }
	    }
	    function bindNamespaceExportDeclaration(node) {
	      if (some(node.modifiers)) {
	        file.bindDiagnostics.push(createDiagnosticForNode2(node, Diagnostics.Modifiers_cannot_appear_here));
	      }
	      const diag2 = !isSourceFile(node.parent) ? Diagnostics.Global_module_exports_may_only_appear_at_top_level : !isExternalModule(node.parent) ? Diagnostics.Global_module_exports_may_only_appear_in_module_files : !node.parent.isDeclarationFile ? Diagnostics.Global_module_exports_may_only_appear_in_declaration_files : void 0;
	      if (diag2) {
	        file.bindDiagnostics.push(createDiagnosticForNode2(node, diag2));
	      } else {
	        file.symbol.globalExports = file.symbol.globalExports || createSymbolTable();
	        declareSymbol(file.symbol.globalExports, file.symbol, node, 2097152 /* Alias */, 2097152 /* AliasExcludes */);
	      }
	    }
	    function bindExportDeclaration(node) {
	      if (!container.symbol || !container.symbol.exports) {
	        bindAnonymousDeclaration(node, 8388608 /* ExportStar */, getDeclarationName(node));
	      } else if (!node.exportClause) {
	        declareSymbol(container.symbol.exports, container.symbol, node, 8388608 /* ExportStar */, 0 /* None */);
	      } else if (isNamespaceExport(node.exportClause)) {
	        setParent(node.exportClause, node);
	        declareSymbol(container.symbol.exports, container.symbol, node.exportClause, 2097152 /* Alias */, 2097152 /* AliasExcludes */);
	      }
	    }
	    function bindImportClause(node) {
	      if (node.name) {
	        declareSymbolAndAddToSymbolTable(node, 2097152 /* Alias */, 2097152 /* AliasExcludes */);
	      }
	    }
	    function setCommonJsModuleIndicator(node) {
	      if (file.externalModuleIndicator && file.externalModuleIndicator !== true) {
	        return false;
	      }
	      if (!file.commonJsModuleIndicator) {
	        file.commonJsModuleIndicator = node;
	        if (!file.externalModuleIndicator) {
	          bindSourceFileAsExternalModule();
	        }
	      }
	      return true;
	    }
	    function bindObjectDefinePropertyExport(node) {
	      if (!setCommonJsModuleIndicator(node)) {
	        return;
	      }
	      const symbol = forEachIdentifierInEntityName(
	        node.arguments[0],
	        /*parent*/
	        void 0,
	        (id, symbol2) => {
	          if (symbol2) {
	            addDeclarationToSymbol(symbol2, id, 1536 /* Module */ | 67108864 /* Assignment */);
	          }
	          return symbol2;
	        }
	      );
	      if (symbol) {
	        const flags = 4 /* Property */ | 1048576 /* ExportValue */;
	        declareSymbol(symbol.exports, symbol, node, flags, 0 /* None */);
	      }
	    }
	    function bindExportsPropertyAssignment(node) {
	      if (!setCommonJsModuleIndicator(node)) {
	        return;
	      }
	      const symbol = forEachIdentifierInEntityName(
	        node.left.expression,
	        /*parent*/
	        void 0,
	        (id, symbol2) => {
	          if (symbol2) {
	            addDeclarationToSymbol(symbol2, id, 1536 /* Module */ | 67108864 /* Assignment */);
	          }
	          return symbol2;
	        }
	      );
	      if (symbol) {
	        const isAlias = isAliasableExpression(node.right) && (isExportsIdentifier(node.left.expression) || isModuleExportsAccessExpression(node.left.expression));
	        const flags = isAlias ? 2097152 /* Alias */ : 4 /* Property */ | 1048576 /* ExportValue */;
	        setParent(node.left, node);
	        declareSymbol(symbol.exports, symbol, node.left, flags, 0 /* None */);
	      }
	    }
	    function bindModuleExportsAssignment(node) {
	      if (!setCommonJsModuleIndicator(node)) {
	        return;
	      }
	      const assignedExpression = getRightMostAssignedExpression(node.right);
	      if (isEmptyObjectLiteral(assignedExpression) || container === file && isExportsOrModuleExportsOrAlias(file, assignedExpression)) {
	        return;
	      }
	      if (isObjectLiteralExpression(assignedExpression) && every(assignedExpression.properties, isShorthandPropertyAssignment)) {
	        forEach(assignedExpression.properties, bindExportAssignedObjectMemberAlias);
	        return;
	      }
	      const flags = exportAssignmentIsAlias(node) ? 2097152 /* Alias */ : 4 /* Property */ | 1048576 /* ExportValue */ | 512 /* ValueModule */;
	      const symbol = declareSymbol(file.symbol.exports, file.symbol, node, flags | 67108864 /* Assignment */, 0 /* None */);
	      setValueDeclaration(symbol, node);
	    }
	    function bindExportAssignedObjectMemberAlias(node) {
	      declareSymbol(file.symbol.exports, file.symbol, node, 2097152 /* Alias */ | 67108864 /* Assignment */, 0 /* None */);
	    }
	    function bindThisPropertyAssignment(node) {
	      Debug.assert(isInJSFile(node));
	      const hasPrivateIdentifier = isBinaryExpression(node) && isPropertyAccessExpression(node.left) && isPrivateIdentifier(node.left.name) || isPropertyAccessExpression(node) && isPrivateIdentifier(node.name);
	      if (hasPrivateIdentifier) {
	        return;
	      }
	      const thisContainer = getThisContainer(
	        node,
	        /*includeArrowFunctions*/
	        false,
	        /*includeClassComputedPropertyName*/
	        false
	      );
	      switch (thisContainer.kind) {
	        case 262 /* FunctionDeclaration */:
	        case 218 /* FunctionExpression */:
	          let constructorSymbol = thisContainer.symbol;
	          if (isBinaryExpression(thisContainer.parent) && thisContainer.parent.operatorToken.kind === 64 /* EqualsToken */) {
	            const l = thisContainer.parent.left;
	            if (isBindableStaticAccessExpression(l) && isPrototypeAccess(l.expression)) {
	              constructorSymbol = lookupSymbolForPropertyAccess(l.expression.expression, thisParentContainer);
	            }
	          }
	          if (constructorSymbol && constructorSymbol.valueDeclaration) {
	            constructorSymbol.members = constructorSymbol.members || createSymbolTable();
	            if (hasDynamicName(node)) {
	              bindDynamicallyNamedThisPropertyAssignment(node, constructorSymbol, constructorSymbol.members);
	            } else {
	              declareSymbol(constructorSymbol.members, constructorSymbol, node, 4 /* Property */ | 67108864 /* Assignment */, 0 /* PropertyExcludes */ & ~4 /* Property */);
	            }
	            addDeclarationToSymbol(constructorSymbol, constructorSymbol.valueDeclaration, 32 /* Class */);
	          }
	          break;
	        case 176 /* Constructor */:
	        case 172 /* PropertyDeclaration */:
	        case 174 /* MethodDeclaration */:
	        case 177 /* GetAccessor */:
	        case 178 /* SetAccessor */:
	        case 175 /* ClassStaticBlockDeclaration */:
	          const containingClass = thisContainer.parent;
	          const symbolTable = isStatic(thisContainer) ? containingClass.symbol.exports : containingClass.symbol.members;
	          if (hasDynamicName(node)) {
	            bindDynamicallyNamedThisPropertyAssignment(node, containingClass.symbol, symbolTable);
	          } else {
	            declareSymbol(
	              symbolTable,
	              containingClass.symbol,
	              node,
	              4 /* Property */ | 67108864 /* Assignment */,
	              0 /* None */,
	              /*isReplaceableByMethod*/
	              true
	            );
	          }
	          break;
	        case 312 /* SourceFile */:
	          if (hasDynamicName(node)) {
	            break;
	          } else if (thisContainer.commonJsModuleIndicator) {
	            declareSymbol(thisContainer.symbol.exports, thisContainer.symbol, node, 4 /* Property */ | 1048576 /* ExportValue */, 0 /* None */);
	          } else {
	            declareSymbolAndAddToSymbolTable(node, 1 /* FunctionScopedVariable */, 111550 /* FunctionScopedVariableExcludes */);
	          }
	          break;
	        case 267 /* ModuleDeclaration */:
	          break;
	        default:
	          Debug.failBadSyntaxKind(thisContainer);
	      }
	    }
	    function bindDynamicallyNamedThisPropertyAssignment(node, symbol, symbolTable) {
	      declareSymbol(
	        symbolTable,
	        symbol,
	        node,
	        4 /* Property */,
	        0 /* None */,
	        /*isReplaceableByMethod*/
	        true,
	        /*isComputedName*/
	        true
	      );
	      addLateBoundAssignmentDeclarationToSymbol(node, symbol);
	    }
	    function addLateBoundAssignmentDeclarationToSymbol(node, symbol) {
	      if (symbol) {
	        (symbol.assignmentDeclarationMembers || (symbol.assignmentDeclarationMembers = /* @__PURE__ */ new Map())).set(getNodeId(node), node);
	      }
	    }
	    function bindSpecialPropertyDeclaration(node) {
	      if (node.expression.kind === 110 /* ThisKeyword */) {
	        bindThisPropertyAssignment(node);
	      } else if (isBindableStaticAccessExpression(node) && node.parent.parent.kind === 312 /* SourceFile */) {
	        if (isPrototypeAccess(node.expression)) {
	          bindPrototypePropertyAssignment(node, node.parent);
	        } else {
	          bindStaticPropertyAssignment(node);
	        }
	      }
	    }
	    function bindPrototypeAssignment(node) {
	      setParent(node.left, node);
	      setParent(node.right, node);
	      bindPropertyAssignment(
	        node.left.expression,
	        node.left,
	        /*isPrototypeProperty*/
	        false,
	        /*containerIsClass*/
	        true
	      );
	    }
	    function bindObjectDefinePrototypeProperty(node) {
	      const namespaceSymbol = lookupSymbolForPropertyAccess(node.arguments[0].expression);
	      if (namespaceSymbol && namespaceSymbol.valueDeclaration) {
	        addDeclarationToSymbol(namespaceSymbol, namespaceSymbol.valueDeclaration, 32 /* Class */);
	      }
	      bindPotentiallyNewExpandoMemberToNamespace(
	        node,
	        namespaceSymbol,
	        /*isPrototypeProperty*/
	        true
	      );
	    }
	    function bindPrototypePropertyAssignment(lhs, parent3) {
	      const classPrototype = lhs.expression;
	      const constructorFunction = classPrototype.expression;
	      setParent(constructorFunction, classPrototype);
	      setParent(classPrototype, lhs);
	      setParent(lhs, parent3);
	      bindPropertyAssignment(
	        constructorFunction,
	        lhs,
	        /*isPrototypeProperty*/
	        true,
	        /*containerIsClass*/
	        true
	      );
	    }
	    function bindObjectDefinePropertyAssignment(node) {
	      let namespaceSymbol = lookupSymbolForPropertyAccess(node.arguments[0]);
	      const isToplevel = node.parent.parent.kind === 312 /* SourceFile */;
	      namespaceSymbol = bindPotentiallyMissingNamespaces(
	        namespaceSymbol,
	        node.arguments[0],
	        isToplevel,
	        /*isPrototypeProperty*/
	        false,
	        /*containerIsClass*/
	        false
	      );
	      bindPotentiallyNewExpandoMemberToNamespace(
	        node,
	        namespaceSymbol,
	        /*isPrototypeProperty*/
	        false
	      );
	    }
	    function bindSpecialPropertyAssignment(node) {
	      var _a;
	      const parentSymbol = lookupSymbolForPropertyAccess(node.left.expression, blockScopeContainer) || lookupSymbolForPropertyAccess(node.left.expression, container);
	      if (!isInJSFile(node) && !isFunctionSymbol(parentSymbol)) {
	        return;
	      }
	      const rootExpr = getLeftmostAccessExpression(node.left);
	      if (isIdentifier(rootExpr) && ((_a = lookupSymbolForName(container, rootExpr.escapedText)) == null ? void 0 : _a.flags) & 2097152 /* Alias */) {
	        return;
	      }
	      setParent(node.left, node);
	      setParent(node.right, node);
	      if (isIdentifier(node.left.expression) && container === file && isExportsOrModuleExportsOrAlias(file, node.left.expression)) {
	        bindExportsPropertyAssignment(node);
	      } else if (hasDynamicName(node)) {
	        bindAnonymousDeclaration(node, 4 /* Property */ | 67108864 /* Assignment */, "__computed" /* Computed */);
	        const sym = bindPotentiallyMissingNamespaces(
	          parentSymbol,
	          node.left.expression,
	          isTopLevelNamespaceAssignment(node.left),
	          /*isPrototypeProperty*/
	          false,
	          /*containerIsClass*/
	          false
	        );
	        addLateBoundAssignmentDeclarationToSymbol(node, sym);
	      } else {
	        bindStaticPropertyAssignment(cast(node.left, isBindableStaticNameExpression));
	      }
	    }
	    function bindStaticPropertyAssignment(node) {
	      Debug.assert(!isIdentifier(node));
	      setParent(node.expression, node);
	      bindPropertyAssignment(
	        node.expression,
	        node,
	        /*isPrototypeProperty*/
	        false,
	        /*containerIsClass*/
	        false
	      );
	    }
	    function bindPotentiallyMissingNamespaces(namespaceSymbol, entityName, isToplevel, isPrototypeProperty, containerIsClass) {
	      if ((namespaceSymbol == null ? void 0 : namespaceSymbol.flags) & 2097152 /* Alias */) {
	        return namespaceSymbol;
	      }
	      if (isToplevel && !isPrototypeProperty) {
	        const flags = 1536 /* Module */ | 67108864 /* Assignment */;
	        const excludeFlags = 110735 /* ValueModuleExcludes */ & ~67108864 /* Assignment */;
	        namespaceSymbol = forEachIdentifierInEntityName(entityName, namespaceSymbol, (id, symbol, parent3) => {
	          if (symbol) {
	            addDeclarationToSymbol(symbol, id, flags);
	            return symbol;
	          } else {
	            const table = parent3 ? parent3.exports : file.jsGlobalAugmentations || (file.jsGlobalAugmentations = createSymbolTable());
	            return declareSymbol(table, parent3, id, flags, excludeFlags);
	          }
	        });
	      }
	      if (containerIsClass && namespaceSymbol && namespaceSymbol.valueDeclaration) {
	        addDeclarationToSymbol(namespaceSymbol, namespaceSymbol.valueDeclaration, 32 /* Class */);
	      }
	      return namespaceSymbol;
	    }
	    function bindPotentiallyNewExpandoMemberToNamespace(declaration, namespaceSymbol, isPrototypeProperty) {
	      if (!namespaceSymbol || !isExpandoSymbol(namespaceSymbol)) {
	        return;
	      }
	      const symbolTable = isPrototypeProperty ? namespaceSymbol.members || (namespaceSymbol.members = createSymbolTable()) : namespaceSymbol.exports || (namespaceSymbol.exports = createSymbolTable());
	      let includes = 0 /* None */;
	      let excludes = 0 /* None */;
	      if (isFunctionLikeDeclaration(getAssignedExpandoInitializer(declaration))) {
	        includes = 8192 /* Method */;
	        excludes = 103359 /* MethodExcludes */;
	      } else if (isCallExpression(declaration) && isBindableObjectDefinePropertyCall(declaration)) {
	        if (some(declaration.arguments[2].properties, (p) => {
	          const id = getNameOfDeclaration(p);
	          return !!id && isIdentifier(id) && idText(id) === "set";
	        })) {
	          includes |= 65536 /* SetAccessor */ | 4 /* Property */;
	          excludes |= 78783 /* SetAccessorExcludes */;
	        }
	        if (some(declaration.arguments[2].properties, (p) => {
	          const id = getNameOfDeclaration(p);
	          return !!id && isIdentifier(id) && idText(id) === "get";
	        })) {
	          includes |= 32768 /* GetAccessor */ | 4 /* Property */;
	          excludes |= 46015 /* GetAccessorExcludes */;
	        }
	      }
	      if (includes === 0 /* None */) {
	        includes = 4 /* Property */;
	        excludes = 0 /* PropertyExcludes */;
	      }
	      declareSymbol(symbolTable, namespaceSymbol, declaration, includes | 67108864 /* Assignment */, excludes & ~67108864 /* Assignment */);
	    }
	    function isTopLevelNamespaceAssignment(propertyAccess) {
	      return isBinaryExpression(propertyAccess.parent) ? getParentOfBinaryExpression(propertyAccess.parent).parent.kind === 312 /* SourceFile */ : propertyAccess.parent.parent.kind === 312 /* SourceFile */;
	    }
	    function bindPropertyAssignment(name, propertyAccess, isPrototypeProperty, containerIsClass) {
	      let namespaceSymbol = lookupSymbolForPropertyAccess(name, blockScopeContainer) || lookupSymbolForPropertyAccess(name, container);
	      const isToplevel = isTopLevelNamespaceAssignment(propertyAccess);
	      namespaceSymbol = bindPotentiallyMissingNamespaces(namespaceSymbol, propertyAccess.expression, isToplevel, isPrototypeProperty, containerIsClass);
	      bindPotentiallyNewExpandoMemberToNamespace(propertyAccess, namespaceSymbol, isPrototypeProperty);
	    }
	    function isExpandoSymbol(symbol) {
	      if (symbol.flags & (16 /* Function */ | 32 /* Class */ | 1024 /* NamespaceModule */)) {
	        return true;
	      }
	      const node = symbol.valueDeclaration;
	      if (node && isCallExpression(node)) {
	        return !!getAssignedExpandoInitializer(node);
	      }
	      let init = !node ? void 0 : isVariableDeclaration(node) ? node.initializer : isBinaryExpression(node) ? node.right : isPropertyAccessExpression(node) && isBinaryExpression(node.parent) ? node.parent.right : void 0;
	      init = init && getRightMostAssignedExpression(init);
	      if (init) {
	        const isPrototypeAssignment = isPrototypeAccess(isVariableDeclaration(node) ? node.name : isBinaryExpression(node) ? node.left : node);
	        return !!getExpandoInitializer(isBinaryExpression(init) && (init.operatorToken.kind === 57 /* BarBarToken */ || init.operatorToken.kind === 61 /* QuestionQuestionToken */) ? init.right : init, isPrototypeAssignment);
	      }
	      return false;
	    }
	    function getParentOfBinaryExpression(expr) {
	      while (isBinaryExpression(expr.parent)) {
	        expr = expr.parent;
	      }
	      return expr.parent;
	    }
	    function lookupSymbolForPropertyAccess(node, lookupContainer = container) {
	      if (isIdentifier(node)) {
	        return lookupSymbolForName(lookupContainer, node.escapedText);
	      } else {
	        const symbol = lookupSymbolForPropertyAccess(node.expression);
	        return symbol && symbol.exports && symbol.exports.get(getElementOrPropertyAccessName(node));
	      }
	    }
	    function forEachIdentifierInEntityName(e, parent3, action) {
	      if (isExportsOrModuleExportsOrAlias(file, e)) {
	        return file.symbol;
	      } else if (isIdentifier(e)) {
	        return action(e, lookupSymbolForPropertyAccess(e), parent3);
	      } else {
	        const s = forEachIdentifierInEntityName(e.expression, parent3, action);
	        const name = getNameOrArgument(e);
	        if (isPrivateIdentifier(name)) {
	          Debug.fail("unexpected PrivateIdentifier");
	        }
	        return action(name, s && s.exports && s.exports.get(getElementOrPropertyAccessName(e)), s);
	      }
	    }
	    function bindCallExpression(node) {
	      if (!file.commonJsModuleIndicator && isRequireCall(
	        node,
	        /*requireStringLiteralLikeArgument*/
	        false
	      )) {
	        setCommonJsModuleIndicator(node);
	      }
	    }
	    function bindClassLikeDeclaration(node) {
	      if (node.kind === 263 /* ClassDeclaration */) {
	        bindBlockScopedDeclaration(node, 32 /* Class */, 899503 /* ClassExcludes */);
	      } else {
	        const bindingName = node.name ? node.name.escapedText : "__class" /* Class */;
	        bindAnonymousDeclaration(node, 32 /* Class */, bindingName);
	        if (node.name) {
	          classifiableNames.add(node.name.escapedText);
	        }
	      }
	      const { symbol } = node;
	      const prototypeSymbol = createSymbol(4 /* Property */ | 4194304 /* Prototype */, "prototype");
	      const symbolExport = symbol.exports.get(prototypeSymbol.escapedName);
	      if (symbolExport) {
	        if (node.name) {
	          setParent(node.name, node);
	        }
	        file.bindDiagnostics.push(createDiagnosticForNode2(symbolExport.declarations[0], Diagnostics.Duplicate_identifier_0, symbolName(prototypeSymbol)));
	      }
	      symbol.exports.set(prototypeSymbol.escapedName, prototypeSymbol);
	      prototypeSymbol.parent = symbol;
	    }
	    function bindEnumDeclaration(node) {
	      return isEnumConst(node) ? bindBlockScopedDeclaration(node, 128 /* ConstEnum */, 899967 /* ConstEnumExcludes */) : bindBlockScopedDeclaration(node, 256 /* RegularEnum */, 899327 /* RegularEnumExcludes */);
	    }
	    function bindVariableDeclarationOrBindingElement(node) {
	      if (inStrictMode) {
	        checkStrictModeEvalOrArguments(node, node.name);
	      }
	      if (!isBindingPattern(node.name)) {
	        const possibleVariableDecl = node.kind === 260 /* VariableDeclaration */ ? node : node.parent.parent;
	        if (isInJSFile(node) && isVariableDeclarationInitializedToBareOrAccessedRequire(possibleVariableDecl) && !getJSDocTypeTag(node) && !(getCombinedModifierFlags(node) & 32 /* Export */)) {
	          declareSymbolAndAddToSymbolTable(node, 2097152 /* Alias */, 2097152 /* AliasExcludes */);
	        } else if (isBlockOrCatchScoped(node)) {
	          bindBlockScopedDeclaration(node, 2 /* BlockScopedVariable */, 111551 /* BlockScopedVariableExcludes */);
	        } else if (isParameterDeclaration(node)) {
	          declareSymbolAndAddToSymbolTable(node, 1 /* FunctionScopedVariable */, 111551 /* ParameterExcludes */);
	        } else {
	          declareSymbolAndAddToSymbolTable(node, 1 /* FunctionScopedVariable */, 111550 /* FunctionScopedVariableExcludes */);
	        }
	      }
	    }
	    function bindParameter(node) {
	      if (node.kind === 348 /* JSDocParameterTag */ && container.kind !== 330 /* JSDocSignature */) {
	        return;
	      }
	      if (inStrictMode && !(node.flags & 33554432 /* Ambient */)) {
	        checkStrictModeEvalOrArguments(node, node.name);
	      }
	      if (isBindingPattern(node.name)) {
	        bindAnonymousDeclaration(node, 1 /* FunctionScopedVariable */, "__" + node.parent.parameters.indexOf(node));
	      } else {
	        declareSymbolAndAddToSymbolTable(node, 1 /* FunctionScopedVariable */, 111551 /* ParameterExcludes */);
	      }
	      if (isParameterPropertyDeclaration(node, node.parent)) {
	        const classDeclaration = node.parent.parent;
	        declareSymbol(classDeclaration.symbol.members, classDeclaration.symbol, node, 4 /* Property */ | (node.questionToken ? 16777216 /* Optional */ : 0 /* None */), 0 /* PropertyExcludes */);
	      }
	    }
	    function bindFunctionDeclaration(node) {
	      if (!file.isDeclarationFile && !(node.flags & 33554432 /* Ambient */)) {
	        if (isAsyncFunction(node)) {
	          emitFlags |= 4096 /* HasAsyncFunctions */;
	        }
	      }
	      checkStrictModeFunctionName(node);
	      if (inStrictMode) {
	        checkStrictModeFunctionDeclaration(node);
	        bindBlockScopedDeclaration(node, 16 /* Function */, 110991 /* FunctionExcludes */);
	      } else {
	        declareSymbolAndAddToSymbolTable(node, 16 /* Function */, 110991 /* FunctionExcludes */);
	      }
	    }
	    function bindFunctionExpression(node) {
	      if (!file.isDeclarationFile && !(node.flags & 33554432 /* Ambient */)) {
	        if (isAsyncFunction(node)) {
	          emitFlags |= 4096 /* HasAsyncFunctions */;
	        }
	      }
	      if (currentFlow) {
	        node.flowNode = currentFlow;
	      }
	      checkStrictModeFunctionName(node);
	      const bindingName = node.name ? node.name.escapedText : "__function" /* Function */;
	      return bindAnonymousDeclaration(node, 16 /* Function */, bindingName);
	    }
	    function bindPropertyOrMethodOrAccessor(node, symbolFlags, symbolExcludes) {
	      if (!file.isDeclarationFile && !(node.flags & 33554432 /* Ambient */) && isAsyncFunction(node)) {
	        emitFlags |= 4096 /* HasAsyncFunctions */;
	      }
	      if (currentFlow && isObjectLiteralOrClassExpressionMethodOrAccessor(node)) {
	        node.flowNode = currentFlow;
	      }
	      return hasDynamicName(node) ? bindAnonymousDeclaration(node, symbolFlags, "__computed" /* Computed */) : declareSymbolAndAddToSymbolTable(node, symbolFlags, symbolExcludes);
	    }
	    function getInferTypeContainer(node) {
	      const extendsType = findAncestor(node, (n) => n.parent && isConditionalTypeNode(n.parent) && n.parent.extendsType === n);
	      return extendsType && extendsType.parent;
	    }
	    function bindTypeParameter(node) {
	      if (isJSDocTemplateTag(node.parent)) {
	        const container2 = getEffectiveContainerForJSDocTemplateTag(node.parent);
	        if (container2) {
	          Debug.assertNode(container2, canHaveLocals);
	          container2.locals ?? (container2.locals = createSymbolTable());
	          declareSymbol(
	            container2.locals,
	            /*parent*/
	            void 0,
	            node,
	            262144 /* TypeParameter */,
	            526824 /* TypeParameterExcludes */
	          );
	        } else {
	          declareSymbolAndAddToSymbolTable(node, 262144 /* TypeParameter */, 526824 /* TypeParameterExcludes */);
	        }
	      } else if (node.parent.kind === 195 /* InferType */) {
	        const container2 = getInferTypeContainer(node.parent);
	        if (container2) {
	          Debug.assertNode(container2, canHaveLocals);
	          container2.locals ?? (container2.locals = createSymbolTable());
	          declareSymbol(
	            container2.locals,
	            /*parent*/
	            void 0,
	            node,
	            262144 /* TypeParameter */,
	            526824 /* TypeParameterExcludes */
	          );
	        } else {
	          bindAnonymousDeclaration(node, 262144 /* TypeParameter */, getDeclarationName(node));
	        }
	      } else {
	        declareSymbolAndAddToSymbolTable(node, 262144 /* TypeParameter */, 526824 /* TypeParameterExcludes */);
	      }
	    }
	    function shouldReportErrorOnModuleDeclaration(node) {
	      const instanceState = getModuleInstanceState(node);
	      return instanceState === 1 /* Instantiated */ || instanceState === 2 /* ConstEnumOnly */ && shouldPreserveConstEnums(options);
	    }
	    function checkUnreachable(node) {
	      if (!(currentFlow.flags & 1 /* Unreachable */)) {
	        return false;
	      }
	      if (currentFlow === unreachableFlow) {
	        const reportError = (
	          // report error on all statements except empty ones
	          isStatementButNotDeclaration(node) && node.kind !== 242 /* EmptyStatement */ || // report error on class declarations
	          node.kind === 263 /* ClassDeclaration */ || // report error on instantiated modules or const-enums only modules if preserveConstEnums is set
	          node.kind === 267 /* ModuleDeclaration */ && shouldReportErrorOnModuleDeclaration(node)
	        );
	        if (reportError) {
	          currentFlow = reportedUnreachableFlow;
	          if (!options.allowUnreachableCode) {
	            const isError = unreachableCodeIsError(options) && !(node.flags & 33554432 /* Ambient */) && (!isVariableStatement(node) || !!(getCombinedNodeFlags(node.declarationList) & 7 /* BlockScoped */) || node.declarationList.declarations.some((d) => !!d.initializer));
	            eachUnreachableRange(node, (start, end) => errorOrSuggestionOnRange(isError, start, end, Diagnostics.Unreachable_code_detected));
	          }
	        }
	      }
	      return true;
	    }
	  }
	  function eachUnreachableRange(node, cb) {
	    if (isStatement(node) && isExecutableStatement(node) && isBlock(node.parent)) {
	      const { statements } = node.parent;
	      const slice = sliceAfter(statements, node);
	      getRangesWhere(slice, isExecutableStatement, (start, afterEnd) => cb(slice[start], slice[afterEnd - 1]));
	    } else {
	      cb(node, node);
	    }
	  }
	  function isExecutableStatement(s) {
	    return !isFunctionDeclaration(s) && !isPurelyTypeDeclaration(s) && !isEnumDeclaration(s) && // `var x;` may declare a variable used above
	    !(isVariableStatement(s) && !(getCombinedNodeFlags(s) & 7 /* BlockScoped */) && s.declarationList.declarations.some((d) => !d.initializer));
	  }
	  function isPurelyTypeDeclaration(s) {
	    switch (s.kind) {
	      case 264 /* InterfaceDeclaration */:
	      case 265 /* TypeAliasDeclaration */:
	        return true;
	      case 267 /* ModuleDeclaration */:
	        return getModuleInstanceState(s) !== 1 /* Instantiated */;
	      case 266 /* EnumDeclaration */:
	        return hasSyntacticModifier(s, 4096 /* Const */);
	      default:
	        return false;
	    }
	  }
	  function isExportsOrModuleExportsOrAlias(sourceFile, node) {
	    let i = 0;
	    const q = createQueue();
	    q.enqueue(node);
	    while (!q.isEmpty() && i < 100) {
	      i++;
	      node = q.dequeue();
	      if (isExportsIdentifier(node) || isModuleExportsAccessExpression(node)) {
	        return true;
	      } else if (isIdentifier(node)) {
	        const symbol = lookupSymbolForName(sourceFile, node.escapedText);
	        if (!!symbol && !!symbol.valueDeclaration && isVariableDeclaration(symbol.valueDeclaration) && !!symbol.valueDeclaration.initializer) {
	          const init = symbol.valueDeclaration.initializer;
	          q.enqueue(init);
	          if (isAssignmentExpression(
	            init,
	            /*excludeCompoundAssignment*/
	            true
	          )) {
	            q.enqueue(init.left);
	            q.enqueue(init.right);
	          }
	        }
	      }
	    }
	    return false;
	  }
	  function getContainerFlags(node) {
	    switch (node.kind) {
	      case 231 /* ClassExpression */:
	      case 263 /* ClassDeclaration */:
	      case 266 /* EnumDeclaration */:
	      case 210 /* ObjectLiteralExpression */:
	      case 187 /* TypeLiteral */:
	      case 329 /* JSDocTypeLiteral */:
	      case 292 /* JsxAttributes */:
	        return 1 /* IsContainer */;
	      case 264 /* InterfaceDeclaration */:
	        return 1 /* IsContainer */ | 64 /* IsInterface */;
	      case 267 /* ModuleDeclaration */:
	      case 265 /* TypeAliasDeclaration */:
	      case 200 /* MappedType */:
	      case 181 /* IndexSignature */:
	        return 1 /* IsContainer */ | 32 /* HasLocals */;
	      case 312 /* SourceFile */:
	        return 1 /* IsContainer */ | 4 /* IsControlFlowContainer */ | 32 /* HasLocals */;
	      case 177 /* GetAccessor */:
	      case 178 /* SetAccessor */:
	      case 174 /* MethodDeclaration */:
	        if (isObjectLiteralOrClassExpressionMethodOrAccessor(node)) {
	          return 1 /* IsContainer */ | 4 /* IsControlFlowContainer */ | 32 /* HasLocals */ | 8 /* IsFunctionLike */ | 128 /* IsObjectLiteralOrClassExpressionMethodOrAccessor */;
	        }
	      case 176 /* Constructor */:
	      case 262 /* FunctionDeclaration */:
	      case 173 /* MethodSignature */:
	      case 179 /* CallSignature */:
	      case 330 /* JSDocSignature */:
	      case 324 /* JSDocFunctionType */:
	      case 184 /* FunctionType */:
	      case 180 /* ConstructSignature */:
	      case 185 /* ConstructorType */:
	      case 175 /* ClassStaticBlockDeclaration */:
	        return 1 /* IsContainer */ | 4 /* IsControlFlowContainer */ | 32 /* HasLocals */ | 8 /* IsFunctionLike */;
	      case 218 /* FunctionExpression */:
	      case 219 /* ArrowFunction */:
	        return 1 /* IsContainer */ | 4 /* IsControlFlowContainer */ | 32 /* HasLocals */ | 8 /* IsFunctionLike */ | 16 /* IsFunctionExpression */;
	      case 268 /* ModuleBlock */:
	        return 4 /* IsControlFlowContainer */;
	      case 172 /* PropertyDeclaration */:
	        return node.initializer ? 4 /* IsControlFlowContainer */ : 0;
	      case 299 /* CatchClause */:
	      case 248 /* ForStatement */:
	      case 249 /* ForInStatement */:
	      case 250 /* ForOfStatement */:
	      case 269 /* CaseBlock */:
	        return 2 /* IsBlockScopedContainer */ | 32 /* HasLocals */;
	      case 241 /* Block */:
	        return isFunctionLike(node.parent) || isClassStaticBlockDeclaration(node.parent) ? 0 /* None */ : 2 /* IsBlockScopedContainer */ | 32 /* HasLocals */;
	    }
	    return 0 /* None */;
	  }
	  function lookupSymbolForName(container, name) {
	    var _a, _b, _c, _d;
	    const local = (_b = (_a = tryCast(container, canHaveLocals)) == null ? void 0 : _a.locals) == null ? void 0 : _b.get(name);
	    if (local) {
	      return local.exportSymbol ?? local;
	    }
	    if (isSourceFile(container) && container.jsGlobalAugmentations && container.jsGlobalAugmentations.has(name)) {
	      return container.jsGlobalAugmentations.get(name);
	    }
	    if (canHaveSymbol(container)) {
	      return (_d = (_c = container.symbol) == null ? void 0 : _c.exports) == null ? void 0 : _d.get(name);
	    }
	  }
	  var ModuleInstanceState, ContainerFlags, binder;
	  var init_binder = __esm({
	    "src/compiler/binder.ts"() {
	      init_ts2();
	      init_ts_performance();
	      ModuleInstanceState = /* @__PURE__ */ ((ModuleInstanceState2) => {
	        ModuleInstanceState2[ModuleInstanceState2["NonInstantiated"] = 0] = "NonInstantiated";
	        ModuleInstanceState2[ModuleInstanceState2["Instantiated"] = 1] = "Instantiated";
	        ModuleInstanceState2[ModuleInstanceState2["ConstEnumOnly"] = 2] = "ConstEnumOnly";
	        return ModuleInstanceState2;
	      })(ModuleInstanceState || {});
	      ContainerFlags = /* @__PURE__ */ ((ContainerFlags2) => {
	        ContainerFlags2[ContainerFlags2["None"] = 0] = "None";
	        ContainerFlags2[ContainerFlags2["IsContainer"] = 1] = "IsContainer";
	        ContainerFlags2[ContainerFlags2["IsBlockScopedContainer"] = 2] = "IsBlockScopedContainer";
	        ContainerFlags2[ContainerFlags2["IsControlFlowContainer"] = 4] = "IsControlFlowContainer";
	        ContainerFlags2[ContainerFlags2["IsFunctionLike"] = 8] = "IsFunctionLike";
	        ContainerFlags2[ContainerFlags2["IsFunctionExpression"] = 16] = "IsFunctionExpression";
	        ContainerFlags2[ContainerFlags2["HasLocals"] = 32] = "HasLocals";
	        ContainerFlags2[ContainerFlags2["IsInterface"] = 64] = "IsInterface";
	        ContainerFlags2[ContainerFlags2["IsObjectLiteralOrClassExpressionMethodOrAccessor"] = 128] = "IsObjectLiteralOrClassExpressionMethodOrAccessor";
	        return ContainerFlags2;
	      })(ContainerFlags || {});
	      binder = /* @__PURE__ */ createBinder();
	    }
	  });

	  // src/compiler/symbolWalker.ts
	  function createGetSymbolWalker(getRestTypeOfSignature, getTypePredicateOfSignature, getReturnTypeOfSignature, getBaseTypes, resolveStructuredTypeMembers, getTypeOfSymbol, getResolvedSymbol, getConstraintOfTypeParameter, getFirstIdentifier2, getTypeArguments) {
	    return getSymbolWalker;
	    function getSymbolWalker(accept = () => true) {
	      const visitedTypes = [];
	      const visitedSymbols = [];
	      return {
	        walkType: (type) => {
	          try {
	            visitType(type);
	            return { visitedTypes: getOwnValues(visitedTypes), visitedSymbols: getOwnValues(visitedSymbols) };
	          } finally {
	            clear(visitedTypes);
	            clear(visitedSymbols);
	          }
	        },
	        walkSymbol: (symbol) => {
	          try {
	            visitSymbol(symbol);
	            return { visitedTypes: getOwnValues(visitedTypes), visitedSymbols: getOwnValues(visitedSymbols) };
	          } finally {
	            clear(visitedTypes);
	            clear(visitedSymbols);
	          }
	        }
	      };
	      function visitType(type) {
	        if (!type) {
	          return;
	        }
	        if (visitedTypes[type.id]) {
	          return;
	        }
	        visitedTypes[type.id] = type;
	        const shouldBail = visitSymbol(type.symbol);
	        if (shouldBail)
	          return;
	        if (type.flags & 524288 /* Object */) {
	          const objectType = type;
	          const objectFlags = objectType.objectFlags;
	          if (objectFlags & 4 /* Reference */) {
	            visitTypeReference(type);
	          }
	          if (objectFlags & 32 /* Mapped */) {
	            visitMappedType(type);
	          }
	          if (objectFlags & (1 /* Class */ | 2 /* Interface */)) {
	            visitInterfaceType(type);
	          }
	          if (objectFlags & (8 /* Tuple */ | 16 /* Anonymous */)) {
	            visitObjectType(objectType);
	          }
	        }
	        if (type.flags & 262144 /* TypeParameter */) {
	          visitTypeParameter(type);
	        }
	        if (type.flags & 3145728 /* UnionOrIntersection */) {
	          visitUnionOrIntersectionType(type);
	        }
	        if (type.flags & 4194304 /* Index */) {
	          visitIndexType(type);
	        }
	        if (type.flags & 8388608 /* IndexedAccess */) {
	          visitIndexedAccessType(type);
	        }
	      }
	      function visitTypeReference(type) {
	        visitType(type.target);
	        forEach(getTypeArguments(type), visitType);
	      }
	      function visitTypeParameter(type) {
	        visitType(getConstraintOfTypeParameter(type));
	      }
	      function visitUnionOrIntersectionType(type) {
	        forEach(type.types, visitType);
	      }
	      function visitIndexType(type) {
	        visitType(type.type);
	      }
	      function visitIndexedAccessType(type) {
	        visitType(type.objectType);
	        visitType(type.indexType);
	        visitType(type.constraint);
	      }
	      function visitMappedType(type) {
	        visitType(type.typeParameter);
	        visitType(type.constraintType);
	        visitType(type.templateType);
	        visitType(type.modifiersType);
	      }
	      function visitSignature(signature) {
	        const typePredicate = getTypePredicateOfSignature(signature);
	        if (typePredicate) {
	          visitType(typePredicate.type);
	        }
	        forEach(signature.typeParameters, visitType);
	        for (const parameter of signature.parameters) {
	          visitSymbol(parameter);
	        }
	        visitType(getRestTypeOfSignature(signature));
	        visitType(getReturnTypeOfSignature(signature));
	      }
	      function visitInterfaceType(interfaceT) {
	        visitObjectType(interfaceT);
	        forEach(interfaceT.typeParameters, visitType);
	        forEach(getBaseTypes(interfaceT), visitType);
	        visitType(interfaceT.thisType);
	      }
	      function visitObjectType(type) {
	        const resolved = resolveStructuredTypeMembers(type);
	        for (const info of resolved.indexInfos) {
	          visitType(info.keyType);
	          visitType(info.type);
	        }
	        for (const signature of resolved.callSignatures) {
	          visitSignature(signature);
	        }
	        for (const signature of resolved.constructSignatures) {
	          visitSignature(signature);
	        }
	        for (const p of resolved.properties) {
	          visitSymbol(p);
	        }
	      }
	      function visitSymbol(symbol) {
	        if (!symbol) {
	          return false;
	        }
	        const symbolId = getSymbolId(symbol);
	        if (visitedSymbols[symbolId]) {
	          return false;
	        }
	        visitedSymbols[symbolId] = symbol;
	        if (!accept(symbol)) {
	          return true;
	        }
	        const t = getTypeOfSymbol(symbol);
	        visitType(t);
	        if (symbol.exports) {
	          symbol.exports.forEach(visitSymbol);
	        }
	        forEach(symbol.declarations, (d) => {
	          if (d.type && d.type.kind === 186 /* TypeQuery */) {
	            const query = d.type;
	            const entity = getResolvedSymbol(getFirstIdentifier2(query.exprName));
	            visitSymbol(entity);
	          }
	        });
	        return false;
	      }
	    }
	  }
	  var init_symbolWalker = __esm({
	    "src/compiler/symbolWalker.ts"() {
	      init_ts2();
	    }
	  });

	  // src/compiler/moduleSpecifiers.ts
	  function getModuleSpecifierPreferences({ importModuleSpecifierPreference, importModuleSpecifierEnding }, compilerOptions, importingSourceFile, oldImportSpecifier) {
	    const filePreferredEnding = getPreferredEnding();
	    return {
	      relativePreference: oldImportSpecifier !== void 0 ? isExternalModuleNameRelative(oldImportSpecifier) ? 0 /* Relative */ : 1 /* NonRelative */ : importModuleSpecifierPreference === "relative" ? 0 /* Relative */ : importModuleSpecifierPreference === "non-relative" ? 1 /* NonRelative */ : importModuleSpecifierPreference === "project-relative" ? 3 /* ExternalNonRelative */ : 2 /* Shortest */,
	      getAllowedEndingsInPreferredOrder: (syntaxImpliedNodeFormat) => {
	        const preferredEnding = syntaxImpliedNodeFormat !== importingSourceFile.impliedNodeFormat ? getPreferredEnding(syntaxImpliedNodeFormat) : filePreferredEnding;
	        if ((syntaxImpliedNodeFormat ?? importingSourceFile.impliedNodeFormat) === 99 /* ESNext */) {
	          if (shouldAllowImportingTsExtension(compilerOptions, importingSourceFile.fileName)) {
	            return [3 /* TsExtension */, 2 /* JsExtension */];
	          }
	          return [2 /* JsExtension */];
	        }
	        if (getEmitModuleResolutionKind(compilerOptions) === 1 /* Classic */) {
	          return preferredEnding === 2 /* JsExtension */ ? [2 /* JsExtension */, 1 /* Index */] : [1 /* Index */, 2 /* JsExtension */];
	        }
	        const allowImportingTsExtension = shouldAllowImportingTsExtension(compilerOptions, importingSourceFile.fileName);
	        switch (preferredEnding) {
	          case 2 /* JsExtension */:
	            return allowImportingTsExtension ? [2 /* JsExtension */, 3 /* TsExtension */, 0 /* Minimal */, 1 /* Index */] : [2 /* JsExtension */, 0 /* Minimal */, 1 /* Index */];
	          case 3 /* TsExtension */:
	            return [3 /* TsExtension */, 0 /* Minimal */, 2 /* JsExtension */, 1 /* Index */];
	          case 1 /* Index */:
	            return allowImportingTsExtension ? [1 /* Index */, 0 /* Minimal */, 3 /* TsExtension */, 2 /* JsExtension */] : [1 /* Index */, 0 /* Minimal */, 2 /* JsExtension */];
	          case 0 /* Minimal */:
	            return allowImportingTsExtension ? [0 /* Minimal */, 1 /* Index */, 3 /* TsExtension */, 2 /* JsExtension */] : [0 /* Minimal */, 1 /* Index */, 2 /* JsExtension */];
	          default:
	            Debug.assertNever(preferredEnding);
	        }
	      }
	    };
	    function getPreferredEnding(resolutionMode) {
	      if (oldImportSpecifier !== void 0) {
	        if (hasJSFileExtension(oldImportSpecifier))
	          return 2 /* JsExtension */;
	        if (endsWith(oldImportSpecifier, "/index"))
	          return 1 /* Index */;
	      }
	      return getModuleSpecifierEndingPreference(
	        importModuleSpecifierEnding,
	        resolutionMode ?? importingSourceFile.impliedNodeFormat,
	        compilerOptions,
	        importingSourceFile
	      );
	    }
	  }
	  function updateModuleSpecifier(compilerOptions, importingSourceFile, importingSourceFileName, toFileName2, host, oldImportSpecifier, options = {}) {
	    const res = getModuleSpecifierWorker(compilerOptions, importingSourceFile, importingSourceFileName, toFileName2, host, getModuleSpecifierPreferences({}, compilerOptions, importingSourceFile, oldImportSpecifier), {}, options);
	    if (res === oldImportSpecifier)
	      return void 0;
	    return res;
	  }
	  function getModuleSpecifier(compilerOptions, importingSourceFile, importingSourceFileName, toFileName2, host, options = {}) {
	    return getModuleSpecifierWorker(compilerOptions, importingSourceFile, importingSourceFileName, toFileName2, host, getModuleSpecifierPreferences({}, compilerOptions, importingSourceFile), {}, options);
	  }
	  function getNodeModulesPackageName(compilerOptions, importingSourceFile, nodeModulesFileName, host, preferences, options = {}) {
	    const info = getInfo(importingSourceFile.fileName, host);
	    const modulePaths = getAllModulePaths(info, nodeModulesFileName, host, preferences, options);
	    return firstDefined(modulePaths, (modulePath) => tryGetModuleNameAsNodeModule(
	      modulePath,
	      info,
	      importingSourceFile,
	      host,
	      compilerOptions,
	      preferences,
	      /*packageNameOnly*/
	      true,
	      options.overrideImportMode
	    ));
	  }
	  function getModuleSpecifierWorker(compilerOptions, importingSourceFile, importingSourceFileName, toFileName2, host, preferences, userPreferences, options = {}) {
	    const info = getInfo(importingSourceFileName, host);
	    const modulePaths = getAllModulePaths(info, toFileName2, host, userPreferences, options);
	    return firstDefined(modulePaths, (modulePath) => tryGetModuleNameAsNodeModule(
	      modulePath,
	      info,
	      importingSourceFile,
	      host,
	      compilerOptions,
	      userPreferences,
	      /*packageNameOnly*/
	      void 0,
	      options.overrideImportMode
	    )) || getLocalModuleSpecifier(toFileName2, info, compilerOptions, host, options.overrideImportMode || importingSourceFile.impliedNodeFormat, preferences);
	  }
	  function tryGetModuleSpecifiersFromCache(moduleSymbol, importingSourceFile, host, userPreferences, options = {}) {
	    return tryGetModuleSpecifiersFromCacheWorker(
	      moduleSymbol,
	      importingSourceFile,
	      host,
	      userPreferences,
	      options
	    )[0];
	  }
	  function tryGetModuleSpecifiersFromCacheWorker(moduleSymbol, importingSourceFile, host, userPreferences, options = {}) {
	    var _a;
	    const moduleSourceFile = getSourceFileOfModule(moduleSymbol);
	    if (!moduleSourceFile) {
	      return emptyArray;
	    }
	    const cache = (_a = host.getModuleSpecifierCache) == null ? void 0 : _a.call(host);
	    const cached = cache == null ? void 0 : cache.get(importingSourceFile.path, moduleSourceFile.path, userPreferences, options);
	    return [cached == null ? void 0 : cached.moduleSpecifiers, moduleSourceFile, cached == null ? void 0 : cached.modulePaths, cache];
	  }
	  function getModuleSpecifiers(moduleSymbol, checker, compilerOptions, importingSourceFile, host, userPreferences, options = {}) {
	    return getModuleSpecifiersWithCacheInfo(
	      moduleSymbol,
	      checker,
	      compilerOptions,
	      importingSourceFile,
	      host,
	      userPreferences,
	      options,
	      /*forAutoImport*/
	      false
	    ).moduleSpecifiers;
	  }
	  function getModuleSpecifiersWithCacheInfo(moduleSymbol, checker, compilerOptions, importingSourceFile, host, userPreferences, options = {}, forAutoImport) {
	    let computedWithoutCache = false;
	    const ambient = tryGetModuleNameFromAmbientModule(moduleSymbol, checker);
	    if (ambient)
	      return { moduleSpecifiers: [ambient], computedWithoutCache };
	    let [specifiers, moduleSourceFile, modulePaths, cache] = tryGetModuleSpecifiersFromCacheWorker(
	      moduleSymbol,
	      importingSourceFile,
	      host,
	      userPreferences,
	      options
	    );
	    if (specifiers)
	      return { moduleSpecifiers: specifiers, computedWithoutCache };
	    if (!moduleSourceFile)
	      return { moduleSpecifiers: emptyArray, computedWithoutCache };
	    computedWithoutCache = true;
	    modulePaths || (modulePaths = getAllModulePathsWorker(getInfo(importingSourceFile.fileName, host), moduleSourceFile.originalFileName, host));
	    const result = computeModuleSpecifiers(
	      modulePaths,
	      compilerOptions,
	      importingSourceFile,
	      host,
	      userPreferences,
	      options,
	      forAutoImport
	    );
	    cache == null ? void 0 : cache.set(importingSourceFile.path, moduleSourceFile.path, userPreferences, options, modulePaths, result);
	    return { moduleSpecifiers: result, computedWithoutCache };
	  }
	  function computeModuleSpecifiers(modulePaths, compilerOptions, importingSourceFile, host, userPreferences, options = {}, forAutoImport) {
	    const info = getInfo(importingSourceFile.fileName, host);
	    const preferences = getModuleSpecifierPreferences(userPreferences, compilerOptions, importingSourceFile);
	    const existingSpecifier = forEach(modulePaths, (modulePath) => forEach(
	      host.getFileIncludeReasons().get(toPath(modulePath.path, host.getCurrentDirectory(), info.getCanonicalFileName)),
	      (reason) => {
	        if (reason.kind !== 3 /* Import */ || reason.file !== importingSourceFile.path)
	          return void 0;
	        if (importingSourceFile.impliedNodeFormat && importingSourceFile.impliedNodeFormat !== getModeForResolutionAtIndex(importingSourceFile, reason.index, compilerOptions))
	          return void 0;
	        const specifier = getModuleNameStringLiteralAt(importingSourceFile, reason.index).text;
	        return preferences.relativePreference !== 1 /* NonRelative */ || !pathIsRelative(specifier) ? specifier : void 0;
	      }
	    ));
	    if (existingSpecifier) {
	      const moduleSpecifiers = [existingSpecifier];
	      return moduleSpecifiers;
	    }
	    const importedFileIsInNodeModules = some(modulePaths, (p) => p.isInNodeModules);
	    let nodeModulesSpecifiers;
	    let pathsSpecifiers;
	    let redirectPathsSpecifiers;
	    let relativeSpecifiers;
	    for (const modulePath of modulePaths) {
	      const specifier = modulePath.isInNodeModules ? tryGetModuleNameAsNodeModule(
	        modulePath,
	        info,
	        importingSourceFile,
	        host,
	        compilerOptions,
	        userPreferences,
	        /*packageNameOnly*/
	        void 0,
	        options.overrideImportMode
	      ) : void 0;
	      nodeModulesSpecifiers = append(nodeModulesSpecifiers, specifier);
	      if (specifier && modulePath.isRedirect) {
	        return nodeModulesSpecifiers;
	      }
	      if (!specifier) {
	        const local = getLocalModuleSpecifier(
	          modulePath.path,
	          info,
	          compilerOptions,
	          host,
	          options.overrideImportMode || importingSourceFile.impliedNodeFormat,
	          preferences,
	          /*pathsOnly*/
	          modulePath.isRedirect
	        );
	        if (!local) {
	          continue;
	        }
	        if (modulePath.isRedirect) {
	          redirectPathsSpecifiers = append(redirectPathsSpecifiers, local);
	        } else if (pathIsBareSpecifier(local)) {
	          if (pathContainsNodeModules(local)) {
	            relativeSpecifiers = append(relativeSpecifiers, local);
	          } else {
	            pathsSpecifiers = append(pathsSpecifiers, local);
	          }
	        } else if (forAutoImport || !importedFileIsInNodeModules || modulePath.isInNodeModules) {
	          relativeSpecifiers = append(relativeSpecifiers, local);
	        }
	      }
	    }
	    return (pathsSpecifiers == null ? void 0 : pathsSpecifiers.length) ? pathsSpecifiers : (redirectPathsSpecifiers == null ? void 0 : redirectPathsSpecifiers.length) ? redirectPathsSpecifiers : (nodeModulesSpecifiers == null ? void 0 : nodeModulesSpecifiers.length) ? nodeModulesSpecifiers : Debug.checkDefined(relativeSpecifiers);
	  }
	  function getInfo(importingSourceFileName, host) {
	    importingSourceFileName = getNormalizedAbsolutePath(importingSourceFileName, host.getCurrentDirectory());
	    const getCanonicalFileName = createGetCanonicalFileName(host.useCaseSensitiveFileNames ? host.useCaseSensitiveFileNames() : true);
	    const sourceDirectory = getDirectoryPath(importingSourceFileName);
	    return {
	      getCanonicalFileName,
	      importingSourceFileName,
	      sourceDirectory,
	      canonicalSourceDirectory: getCanonicalFileName(sourceDirectory)
	    };
	  }
	  function getLocalModuleSpecifier(moduleFileName, info, compilerOptions, host, importMode, { getAllowedEndingsInPreferredOrder: getAllowedEndingsInPrefererredOrder, relativePreference }, pathsOnly) {
	    const { baseUrl, paths, rootDirs } = compilerOptions;
	    if (pathsOnly && !paths) {
	      return void 0;
	    }
	    const { sourceDirectory, canonicalSourceDirectory, getCanonicalFileName } = info;
	    const allowedEndings = getAllowedEndingsInPrefererredOrder(importMode);
	    const relativePath = rootDirs && tryGetModuleNameFromRootDirs(rootDirs, moduleFileName, sourceDirectory, getCanonicalFileName, allowedEndings, compilerOptions) || processEnding(ensurePathIsNonModuleName(getRelativePathFromDirectory(sourceDirectory, moduleFileName, getCanonicalFileName)), allowedEndings, compilerOptions);
	    if (!baseUrl && !paths && !getResolvePackageJsonImports(compilerOptions) || relativePreference === 0 /* Relative */) {
	      return pathsOnly ? void 0 : relativePath;
	    }
	    const baseDirectory = getNormalizedAbsolutePath(getPathsBasePath(compilerOptions, host) || baseUrl, host.getCurrentDirectory());
	    const relativeToBaseUrl = getRelativePathIfInSameVolume(moduleFileName, baseDirectory, getCanonicalFileName);
	    if (!relativeToBaseUrl) {
	      return pathsOnly ? void 0 : relativePath;
	    }
	    const fromPackageJsonImports = pathsOnly ? void 0 : tryGetModuleNameFromPackageJsonImports(moduleFileName, sourceDirectory, compilerOptions, host, importMode);
	    const fromPaths = pathsOnly || fromPackageJsonImports === void 0 ? paths && tryGetModuleNameFromPaths(relativeToBaseUrl, paths, allowedEndings, host, compilerOptions) : void 0;
	    if (pathsOnly) {
	      return fromPaths;
	    }
	    const maybeNonRelative = fromPackageJsonImports ?? (fromPaths === void 0 && baseUrl !== void 0 ? processEnding(relativeToBaseUrl, allowedEndings, compilerOptions) : fromPaths);
	    if (!maybeNonRelative) {
	      return relativePath;
	    }
	    if (relativePreference === 1 /* NonRelative */ && !pathIsRelative(maybeNonRelative)) {
	      return maybeNonRelative;
	    }
	    if (relativePreference === 3 /* ExternalNonRelative */ && !pathIsRelative(maybeNonRelative)) {
	      const projectDirectory = compilerOptions.configFilePath ? toPath(getDirectoryPath(compilerOptions.configFilePath), host.getCurrentDirectory(), info.getCanonicalFileName) : info.getCanonicalFileName(host.getCurrentDirectory());
	      const modulePath = toPath(moduleFileName, projectDirectory, getCanonicalFileName);
	      const sourceIsInternal = startsWith(canonicalSourceDirectory, projectDirectory);
	      const targetIsInternal = startsWith(modulePath, projectDirectory);
	      if (sourceIsInternal && !targetIsInternal || !sourceIsInternal && targetIsInternal) {
	        return maybeNonRelative;
	      }
	      const nearestTargetPackageJson = getNearestAncestorDirectoryWithPackageJson(host, getDirectoryPath(modulePath));
	      const nearestSourcePackageJson = getNearestAncestorDirectoryWithPackageJson(host, sourceDirectory);
	      const ignoreCase = !hostUsesCaseSensitiveFileNames(host);
	      if (!packageJsonPathsAreEqual(nearestTargetPackageJson, nearestSourcePackageJson, ignoreCase)) {
	        return maybeNonRelative;
	      }
	      return relativePath;
	    }
	    return isPathRelativeToParent(maybeNonRelative) || countPathComponents(relativePath) < countPathComponents(maybeNonRelative) ? relativePath : maybeNonRelative;
	  }
	  function packageJsonPathsAreEqual(a, b, ignoreCase) {
	    if (a === b)
	      return true;
	    if (a === void 0 || b === void 0)
	      return false;
	    return comparePaths(a, b, ignoreCase) === 0 /* EqualTo */;
	  }
	  function countPathComponents(path) {
	    let count = 0;
	    for (let i = startsWith(path, "./") ? 2 : 0; i < path.length; i++) {
	      if (path.charCodeAt(i) === 47 /* slash */)
	        count++;
	    }
	    return count;
	  }
	  function comparePathsByRedirectAndNumberOfDirectorySeparators(a, b) {
	    return compareBooleans(b.isRedirect, a.isRedirect) || compareNumberOfDirectorySeparators(a.path, b.path);
	  }
	  function getNearestAncestorDirectoryWithPackageJson(host, fileName) {
	    if (host.getNearestAncestorDirectoryWithPackageJson) {
	      return host.getNearestAncestorDirectoryWithPackageJson(fileName);
	    }
	    return forEachAncestorDirectory(fileName, (directory) => {
	      return host.fileExists(combinePaths(directory, "package.json")) ? directory : void 0;
	    });
	  }
	  function forEachFileNameOfModule(importingFileName, importedFileName, host, preferSymlinks, cb) {
	    var _a;
	    const getCanonicalFileName = hostGetCanonicalFileName(host);
	    const cwd = host.getCurrentDirectory();
	    const referenceRedirect = host.isSourceOfProjectReferenceRedirect(importedFileName) ? host.getProjectReferenceRedirect(importedFileName) : void 0;
	    const importedPath = toPath(importedFileName, cwd, getCanonicalFileName);
	    const redirects = host.redirectTargetsMap.get(importedPath) || emptyArray;
	    const importedFileNames = [...referenceRedirect ? [referenceRedirect] : emptyArray, importedFileName, ...redirects];
	    const targets = importedFileNames.map((f) => getNormalizedAbsolutePath(f, cwd));
	    let shouldFilterIgnoredPaths = !every(targets, containsIgnoredPath);
	    if (!preferSymlinks) {
	      const result2 = forEach(targets, (p) => !(shouldFilterIgnoredPaths && containsIgnoredPath(p)) && cb(p, referenceRedirect === p));
	      if (result2)
	        return result2;
	    }
	    const symlinkedDirectories = (_a = host.getSymlinkCache) == null ? void 0 : _a.call(host).getSymlinkedDirectoriesByRealpath();
	    const fullImportedFileName = getNormalizedAbsolutePath(importedFileName, cwd);
	    const result = symlinkedDirectories && forEachAncestorDirectory(getDirectoryPath(fullImportedFileName), (realPathDirectory) => {
	      const symlinkDirectories = symlinkedDirectories.get(ensureTrailingDirectorySeparator(toPath(realPathDirectory, cwd, getCanonicalFileName)));
	      if (!symlinkDirectories)
	        return void 0;
	      if (startsWithDirectory(importingFileName, realPathDirectory, getCanonicalFileName)) {
	        return false;
	      }
	      return forEach(targets, (target) => {
	        if (!startsWithDirectory(target, realPathDirectory, getCanonicalFileName)) {
	          return;
	        }
	        const relative = getRelativePathFromDirectory(realPathDirectory, target, getCanonicalFileName);
	        for (const symlinkDirectory of symlinkDirectories) {
	          const option = resolvePath(symlinkDirectory, relative);
	          const result2 = cb(option, target === referenceRedirect);
	          shouldFilterIgnoredPaths = true;
	          if (result2)
	            return result2;
	        }
	      });
	    });
	    return result || (preferSymlinks ? forEach(targets, (p) => shouldFilterIgnoredPaths && containsIgnoredPath(p) ? void 0 : cb(p, p === referenceRedirect)) : void 0);
	  }
	  function getAllModulePaths(info, importedFileName, host, preferences, options = {}) {
	    var _a;
	    const importingFilePath = toPath(info.importingSourceFileName, host.getCurrentDirectory(), hostGetCanonicalFileName(host));
	    const importedFilePath = toPath(importedFileName, host.getCurrentDirectory(), hostGetCanonicalFileName(host));
	    const cache = (_a = host.getModuleSpecifierCache) == null ? void 0 : _a.call(host);
	    if (cache) {
	      const cached = cache.get(importingFilePath, importedFilePath, preferences, options);
	      if (cached == null ? void 0 : cached.modulePaths)
	        return cached.modulePaths;
	    }
	    const modulePaths = getAllModulePathsWorker(info, importedFileName, host);
	    if (cache) {
	      cache.setModulePaths(importingFilePath, importedFilePath, preferences, options, modulePaths);
	    }
	    return modulePaths;
	  }
	  function getAllModulePathsWorker(info, importedFileName, host) {
	    const allFileNames = /* @__PURE__ */ new Map();
	    forEachFileNameOfModule(
	      info.importingSourceFileName,
	      importedFileName,
	      host,
	      /*preferSymlinks*/
	      true,
	      (path, isRedirect) => {
	        const isInNodeModules = pathContainsNodeModules(path);
	        allFileNames.set(path, { path: info.getCanonicalFileName(path), isRedirect, isInNodeModules });
	      }
	    );
	    const sortedPaths = [];
	    for (let directory = info.canonicalSourceDirectory; allFileNames.size !== 0; ) {
	      const directoryStart = ensureTrailingDirectorySeparator(directory);
	      let pathsInDirectory;
	      allFileNames.forEach(({ path, isRedirect, isInNodeModules }, fileName) => {
	        if (startsWith(path, directoryStart)) {
	          (pathsInDirectory || (pathsInDirectory = [])).push({ path: fileName, isRedirect, isInNodeModules });
	          allFileNames.delete(fileName);
	        }
	      });
	      if (pathsInDirectory) {
	        if (pathsInDirectory.length > 1) {
	          pathsInDirectory.sort(comparePathsByRedirectAndNumberOfDirectorySeparators);
	        }
	        sortedPaths.push(...pathsInDirectory);
	      }
	      const newDirectory = getDirectoryPath(directory);
	      if (newDirectory === directory)
	        break;
	      directory = newDirectory;
	    }
	    if (allFileNames.size) {
	      const remainingPaths = arrayFrom(
	        allFileNames.entries(),
	        ([fileName, { isRedirect, isInNodeModules }]) => ({ path: fileName, isRedirect, isInNodeModules })
	      );
	      if (remainingPaths.length > 1)
	        remainingPaths.sort(comparePathsByRedirectAndNumberOfDirectorySeparators);
	      sortedPaths.push(...remainingPaths);
	    }
	    return sortedPaths;
	  }
	  function tryGetModuleNameFromAmbientModule(moduleSymbol, checker) {
	    var _a;
	    const decl = (_a = moduleSymbol.declarations) == null ? void 0 : _a.find(
	      (d) => isNonGlobalAmbientModule(d) && (!isExternalModuleAugmentation(d) || !isExternalModuleNameRelative(getTextOfIdentifierOrLiteral(d.name)))
	    );
	    if (decl) {
	      return decl.name.text;
	    }
	    const ambientModuleDeclareCandidates = mapDefined(moduleSymbol.declarations, (d) => {
	      var _a2, _b, _c, _d;
	      if (!isModuleDeclaration(d))
	        return;
	      const topNamespace = getTopNamespace(d);
	      if (!(((_a2 = topNamespace == null ? void 0 : topNamespace.parent) == null ? void 0 : _a2.parent) && isModuleBlock(topNamespace.parent) && isAmbientModule(topNamespace.parent.parent) && isSourceFile(topNamespace.parent.parent.parent)))
	        return;
	      const exportAssignment = (_d = (_c = (_b = topNamespace.parent.parent.symbol.exports) == null ? void 0 : _b.get("export=")) == null ? void 0 : _c.valueDeclaration) == null ? void 0 : _d.expression;
	      if (!exportAssignment)
	        return;
	      const exportSymbol = checker.getSymbolAtLocation(exportAssignment);
	      if (!exportSymbol)
	        return;
	      const originalExportSymbol = (exportSymbol == null ? void 0 : exportSymbol.flags) & 2097152 /* Alias */ ? checker.getAliasedSymbol(exportSymbol) : exportSymbol;
	      if (originalExportSymbol === d.symbol)
	        return topNamespace.parent.parent;
	      function getTopNamespace(namespaceDeclaration) {
	        while (namespaceDeclaration.flags & 8 /* NestedNamespace */) {
	          namespaceDeclaration = namespaceDeclaration.parent;
	        }
	        return namespaceDeclaration;
	      }
	    });
	    const ambientModuleDeclare = ambientModuleDeclareCandidates[0];
	    if (ambientModuleDeclare) {
	      return ambientModuleDeclare.name.text;
	    }
	  }
	  function tryGetModuleNameFromPaths(relativeToBaseUrl, paths, allowedEndings, host, compilerOptions) {
	    for (const key in paths) {
	      for (const patternText2 of paths[key]) {
	        const pattern = normalizePath(patternText2);
	        const indexOfStar = pattern.indexOf("*");
	        const candidates = allowedEndings.map((ending) => ({
	          ending,
	          value: processEnding(relativeToBaseUrl, [ending], compilerOptions)
	        }));
	        if (tryGetExtensionFromPath2(pattern)) {
	          candidates.push({ ending: void 0, value: relativeToBaseUrl });
	        }
	        if (indexOfStar !== -1) {
	          const prefix = pattern.substring(0, indexOfStar);
	          const suffix = pattern.substring(indexOfStar + 1);
	          for (const { ending, value } of candidates) {
	            if (value.length >= prefix.length + suffix.length && startsWith(value, prefix) && endsWith(value, suffix) && validateEnding({ ending, value })) {
	              const matchedStar = value.substring(prefix.length, value.length - suffix.length);
	              if (!pathIsRelative(matchedStar)) {
	                return replaceFirstStar(key, matchedStar);
	              }
	            }
	          }
	        } else if (some(candidates, (c) => c.ending !== 0 /* Minimal */ && pattern === c.value) || some(candidates, (c) => c.ending === 0 /* Minimal */ && pattern === c.value && validateEnding(c))) {
	          return key;
	        }
	      }
	    }
	    function validateEnding({ ending, value }) {
	      return ending !== 0 /* Minimal */ || value === processEnding(relativeToBaseUrl, [ending], compilerOptions, host);
	    }
	  }
	  function tryGetModuleNameFromExportsOrImports(options, host, targetFilePath, packageDirectory, packageName, exports, conditions, mode, isImports) {
	    if (typeof exports === "string") {
	      const ignoreCase = !hostUsesCaseSensitiveFileNames(host);
	      const getCommonSourceDirectory2 = () => host.getCommonSourceDirectory();
	      const outputFile = isImports && getOutputJSFileNameWorker(targetFilePath, options, ignoreCase, getCommonSourceDirectory2);
	      const declarationFile = isImports && getOutputDeclarationFileNameWorker(targetFilePath, options, ignoreCase, getCommonSourceDirectory2);
	      const pathOrPattern = getNormalizedAbsolutePath(
	        combinePaths(packageDirectory, exports),
	        /*currentDirectory*/
	        void 0
	      );
	      const extensionSwappedTarget = hasTSFileExtension(targetFilePath) ? removeFileExtension(targetFilePath) + tryGetJSExtensionForFile(targetFilePath, options) : void 0;
	      switch (mode) {
	        case 0 /* Exact */:
	          if (extensionSwappedTarget && comparePaths(extensionSwappedTarget, pathOrPattern, ignoreCase) === 0 /* EqualTo */ || comparePaths(targetFilePath, pathOrPattern, ignoreCase) === 0 /* EqualTo */ || outputFile && comparePaths(outputFile, pathOrPattern, ignoreCase) === 0 /* EqualTo */ || declarationFile && comparePaths(declarationFile, pathOrPattern, ignoreCase) === 0 /* EqualTo */) {
	            return { moduleFileToTry: packageName };
	          }
	          break;
	        case 1 /* Directory */:
	          if (extensionSwappedTarget && containsPath(pathOrPattern, extensionSwappedTarget, ignoreCase)) {
	            const fragment = getRelativePathFromDirectory(
	              pathOrPattern,
	              extensionSwappedTarget,
	              /*ignoreCase*/
	              false
	            );
	            return { moduleFileToTry: getNormalizedAbsolutePath(
	              combinePaths(combinePaths(packageName, exports), fragment),
	              /*currentDirectory*/
	              void 0
	            ) };
	          }
	          if (containsPath(pathOrPattern, targetFilePath, ignoreCase)) {
	            const fragment = getRelativePathFromDirectory(
	              pathOrPattern,
	              targetFilePath,
	              /*ignoreCase*/
	              false
	            );
	            return { moduleFileToTry: getNormalizedAbsolutePath(
	              combinePaths(combinePaths(packageName, exports), fragment),
	              /*currentDirectory*/
	              void 0
	            ) };
	          }
	          if (outputFile && containsPath(pathOrPattern, outputFile, ignoreCase)) {
	            const fragment = getRelativePathFromDirectory(
	              pathOrPattern,
	              outputFile,
	              /*ignoreCase*/
	              false
	            );
	            return { moduleFileToTry: combinePaths(packageName, fragment) };
	          }
	          if (declarationFile && containsPath(pathOrPattern, declarationFile, ignoreCase)) {
	            const fragment = getRelativePathFromDirectory(
	              pathOrPattern,
	              declarationFile,
	              /*ignoreCase*/
	              false
	            );
	            return { moduleFileToTry: combinePaths(packageName, fragment) };
	          }
	          break;
	        case 2 /* Pattern */:
	          const starPos = pathOrPattern.indexOf("*");
	          const leadingSlice = pathOrPattern.slice(0, starPos);
	          const trailingSlice = pathOrPattern.slice(starPos + 1);
	          if (extensionSwappedTarget && startsWith(extensionSwappedTarget, leadingSlice, ignoreCase) && endsWith(extensionSwappedTarget, trailingSlice, ignoreCase)) {
	            const starReplacement = extensionSwappedTarget.slice(leadingSlice.length, extensionSwappedTarget.length - trailingSlice.length);
	            return { moduleFileToTry: replaceFirstStar(packageName, starReplacement) };
	          }
	          if (startsWith(targetFilePath, leadingSlice, ignoreCase) && endsWith(targetFilePath, trailingSlice, ignoreCase)) {
	            const starReplacement = targetFilePath.slice(leadingSlice.length, targetFilePath.length - trailingSlice.length);
	            return { moduleFileToTry: replaceFirstStar(packageName, starReplacement) };
	          }
	          if (outputFile && startsWith(outputFile, leadingSlice, ignoreCase) && endsWith(outputFile, trailingSlice, ignoreCase)) {
	            const starReplacement = outputFile.slice(leadingSlice.length, outputFile.length - trailingSlice.length);
	            return { moduleFileToTry: replaceFirstStar(packageName, starReplacement) };
	          }
	          if (declarationFile && startsWith(declarationFile, leadingSlice, ignoreCase) && endsWith(declarationFile, trailingSlice, ignoreCase)) {
	            const starReplacement = declarationFile.slice(leadingSlice.length, declarationFile.length - trailingSlice.length);
	            return { moduleFileToTry: replaceFirstStar(packageName, starReplacement) };
	          }
	          break;
	      }
	    } else if (Array.isArray(exports)) {
	      return forEach(exports, (e) => tryGetModuleNameFromExportsOrImports(options, host, targetFilePath, packageDirectory, packageName, e, conditions, mode, isImports));
	    } else if (typeof exports === "object" && exports !== null) {
	      for (const key of getOwnKeys(exports)) {
	        if (key === "default" || conditions.indexOf(key) >= 0 || isApplicableVersionedTypesKey(conditions, key)) {
	          const subTarget = exports[key];
	          const result = tryGetModuleNameFromExportsOrImports(options, host, targetFilePath, packageDirectory, packageName, subTarget, conditions, mode, isImports);
	          if (result) {
	            return result;
	          }
	        }
	      }
	    }
	    return void 0;
	  }
	  function tryGetModuleNameFromExports(options, host, targetFilePath, packageDirectory, packageName, exports, conditions) {
	    if (typeof exports === "object" && exports !== null && !Array.isArray(exports) && allKeysStartWithDot(exports)) {
	      return forEach(getOwnKeys(exports), (k) => {
	        const subPackageName = getNormalizedAbsolutePath(
	          combinePaths(packageName, k),
	          /*currentDirectory*/
	          void 0
	        );
	        const mode = endsWith(k, "/") ? 1 /* Directory */ : k.includes("*") ? 2 /* Pattern */ : 0 /* Exact */;
	        return tryGetModuleNameFromExportsOrImports(
	          options,
	          host,
	          targetFilePath,
	          packageDirectory,
	          subPackageName,
	          exports[k],
	          conditions,
	          mode,
	          /*isImports*/
	          false
	        );
	      });
	    }
	    return tryGetModuleNameFromExportsOrImports(
	      options,
	      host,
	      targetFilePath,
	      packageDirectory,
	      packageName,
	      exports,
	      conditions,
	      0 /* Exact */,
	      /*isImports*/
	      false
	    );
	  }
	  function tryGetModuleNameFromPackageJsonImports(moduleFileName, sourceDirectory, options, host, importMode) {
	    var _a, _b, _c;
	    if (!host.readFile || !getResolvePackageJsonImports(options)) {
	      return void 0;
	    }
	    const ancestorDirectoryWithPackageJson = getNearestAncestorDirectoryWithPackageJson(host, sourceDirectory);
	    if (!ancestorDirectoryWithPackageJson) {
	      return void 0;
	    }
	    const packageJsonPath = combinePaths(ancestorDirectoryWithPackageJson, "package.json");
	    const cachedPackageJson = (_b = (_a = host.getPackageJsonInfoCache) == null ? void 0 : _a.call(host)) == null ? void 0 : _b.getPackageJsonInfo(packageJsonPath);
	    if (isMissingPackageJsonInfo(cachedPackageJson) || !host.fileExists(packageJsonPath)) {
	      return void 0;
	    }
	    const packageJsonContent = (cachedPackageJson == null ? void 0 : cachedPackageJson.contents.packageJsonContent) || tryParseJson(host.readFile(packageJsonPath));
	    const imports = packageJsonContent == null ? void 0 : packageJsonContent.imports;
	    if (!imports) {
	      return void 0;
	    }
	    const conditions = getConditions(options, importMode);
	    return (_c = forEach(getOwnKeys(imports), (k) => {
	      if (!startsWith(k, "#") || k === "#" || startsWith(k, "#/"))
	        return void 0;
	      const mode = endsWith(k, "/") ? 1 /* Directory */ : k.includes("*") ? 2 /* Pattern */ : 0 /* Exact */;
	      return tryGetModuleNameFromExportsOrImports(
	        options,
	        host,
	        moduleFileName,
	        ancestorDirectoryWithPackageJson,
	        k,
	        imports[k],
	        conditions,
	        mode,
	        /*isImports*/
	        true
	      );
	    })) == null ? void 0 : _c.moduleFileToTry;
	  }
	  function tryGetModuleNameFromRootDirs(rootDirs, moduleFileName, sourceDirectory, getCanonicalFileName, allowedEndings, compilerOptions) {
	    const normalizedTargetPaths = getPathsRelativeToRootDirs(moduleFileName, rootDirs, getCanonicalFileName);
	    if (normalizedTargetPaths === void 0) {
	      return void 0;
	    }
	    const normalizedSourcePaths = getPathsRelativeToRootDirs(sourceDirectory, rootDirs, getCanonicalFileName);
	    const relativePaths = flatMap(normalizedSourcePaths, (sourcePath) => {
	      return map(normalizedTargetPaths, (targetPath) => ensurePathIsNonModuleName(getRelativePathFromDirectory(sourcePath, targetPath, getCanonicalFileName)));
	    });
	    const shortest = min(relativePaths, compareNumberOfDirectorySeparators);
	    if (!shortest) {
	      return void 0;
	    }
	    return processEnding(shortest, allowedEndings, compilerOptions);
	  }
	  function tryGetModuleNameAsNodeModule({ path, isRedirect }, { getCanonicalFileName, canonicalSourceDirectory }, importingSourceFile, host, options, userPreferences, packageNameOnly, overrideMode) {
	    if (!host.fileExists || !host.readFile) {
	      return void 0;
	    }
	    const parts = getNodeModulePathParts(path);
	    if (!parts) {
	      return void 0;
	    }
	    const preferences = getModuleSpecifierPreferences(userPreferences, options, importingSourceFile);
	    const allowedEndings = preferences.getAllowedEndingsInPreferredOrder();
	    let moduleSpecifier = path;
	    let isPackageRootPath = false;
	    if (!packageNameOnly) {
	      let packageRootIndex = parts.packageRootIndex;
	      let moduleFileName;
	      while (true) {
	        const { moduleFileToTry, packageRootPath, blockedByExports, verbatimFromExports } = tryDirectoryWithPackageJson(packageRootIndex);
	        if (getEmitModuleResolutionKind(options) !== 1 /* Classic */) {
	          if (blockedByExports) {
	            return void 0;
	          }
	          if (verbatimFromExports) {
	            return moduleFileToTry;
	          }
	        }
	        if (packageRootPath) {
	          moduleSpecifier = packageRootPath;
	          isPackageRootPath = true;
	          break;
	        }
	        if (!moduleFileName)
	          moduleFileName = moduleFileToTry;
	        packageRootIndex = path.indexOf(directorySeparator, packageRootIndex + 1);
	        if (packageRootIndex === -1) {
	          moduleSpecifier = processEnding(moduleFileName, allowedEndings, options, host);
	          break;
	        }
	      }
	    }
	    if (isRedirect && !isPackageRootPath) {
	      return void 0;
	    }
	    const globalTypingsCacheLocation = host.getGlobalTypingsCacheLocation && host.getGlobalTypingsCacheLocation();
	    const pathToTopLevelNodeModules = getCanonicalFileName(moduleSpecifier.substring(0, parts.topLevelNodeModulesIndex));
	    if (!(startsWith(canonicalSourceDirectory, pathToTopLevelNodeModules) || globalTypingsCacheLocation && startsWith(getCanonicalFileName(globalTypingsCacheLocation), pathToTopLevelNodeModules))) {
	      return void 0;
	    }
	    const nodeModulesDirectoryName = moduleSpecifier.substring(parts.topLevelPackageNameIndex + 1);
	    const packageName = getPackageNameFromTypesPackageName(nodeModulesDirectoryName);
	    return getEmitModuleResolutionKind(options) === 1 /* Classic */ && packageName === nodeModulesDirectoryName ? void 0 : packageName;
	    function tryDirectoryWithPackageJson(packageRootIndex) {
	      var _a, _b;
	      const packageRootPath = path.substring(0, packageRootIndex);
	      const packageJsonPath = combinePaths(packageRootPath, "package.json");
	      let moduleFileToTry = path;
	      let maybeBlockedByTypesVersions = false;
	      const cachedPackageJson = (_b = (_a = host.getPackageJsonInfoCache) == null ? void 0 : _a.call(host)) == null ? void 0 : _b.getPackageJsonInfo(packageJsonPath);
	      if (isPackageJsonInfo(cachedPackageJson) || cachedPackageJson === void 0 && host.fileExists(packageJsonPath)) {
	        const packageJsonContent = (cachedPackageJson == null ? void 0 : cachedPackageJson.contents.packageJsonContent) || tryParseJson(host.readFile(packageJsonPath));
	        const importMode = overrideMode || importingSourceFile.impliedNodeFormat;
	        if (getResolvePackageJsonExports(options)) {
	          const nodeModulesDirectoryName2 = packageRootPath.substring(parts.topLevelPackageNameIndex + 1);
	          const packageName2 = getPackageNameFromTypesPackageName(nodeModulesDirectoryName2);
	          const conditions = getConditions(options, importMode);
	          const fromExports = (packageJsonContent == null ? void 0 : packageJsonContent.exports) ? tryGetModuleNameFromExports(options, host, path, packageRootPath, packageName2, packageJsonContent.exports, conditions) : void 0;
	          if (fromExports) {
	            return { ...fromExports, verbatimFromExports: true };
	          }
	          if (packageJsonContent == null ? void 0 : packageJsonContent.exports) {
	            return { moduleFileToTry: path, blockedByExports: true };
	          }
	        }
	        const versionPaths = (packageJsonContent == null ? void 0 : packageJsonContent.typesVersions) ? getPackageJsonTypesVersionsPaths(packageJsonContent.typesVersions) : void 0;
	        if (versionPaths) {
	          const subModuleName = path.slice(packageRootPath.length + 1);
	          const fromPaths = tryGetModuleNameFromPaths(
	            subModuleName,
	            versionPaths.paths,
	            allowedEndings,
	            host,
	            options
	          );
	          if (fromPaths === void 0) {
	            maybeBlockedByTypesVersions = true;
	          } else {
	            moduleFileToTry = combinePaths(packageRootPath, fromPaths);
	          }
	        }
	        const mainFileRelative = (packageJsonContent == null ? void 0 : packageJsonContent.typings) || (packageJsonContent == null ? void 0 : packageJsonContent.types) || (packageJsonContent == null ? void 0 : packageJsonContent.main) || "index.js";
	        if (isString(mainFileRelative) && !(maybeBlockedByTypesVersions && matchPatternOrExact(tryParsePatterns(versionPaths.paths), mainFileRelative))) {
	          const mainExportFile = toPath(mainFileRelative, packageRootPath, getCanonicalFileName);
	          const canonicalModuleFileToTry = getCanonicalFileName(moduleFileToTry);
	          if (removeFileExtension(mainExportFile) === removeFileExtension(canonicalModuleFileToTry)) {
	            return { packageRootPath, moduleFileToTry };
	          } else if ((packageJsonContent == null ? void 0 : packageJsonContent.type) !== "module" && !fileExtensionIsOneOf(canonicalModuleFileToTry, extensionsNotSupportingExtensionlessResolution) && startsWith(canonicalModuleFileToTry, mainExportFile) && getDirectoryPath(canonicalModuleFileToTry) === removeTrailingDirectorySeparator(mainExportFile) && removeFileExtension(getBaseFileName(canonicalModuleFileToTry)) === "index") {
	            return { packageRootPath, moduleFileToTry };
	          }
	        }
	      } else {
	        const fileName = getCanonicalFileName(moduleFileToTry.substring(parts.packageRootIndex + 1));
	        if (fileName === "index.d.ts" || fileName === "index.js" || fileName === "index.ts" || fileName === "index.tsx") {
	          return { moduleFileToTry, packageRootPath };
	        }
	      }
	      return { moduleFileToTry };
	    }
	  }
	  function tryGetAnyFileFromPath(host, path) {
	    if (!host.fileExists)
	      return;
	    const extensions = flatten(getSupportedExtensions({ allowJs: true }, [{ extension: "node", isMixedContent: false }, { extension: "json", isMixedContent: false, scriptKind: 6 /* JSON */ }]));
	    for (const e of extensions) {
	      const fullPath = path + e;
	      if (host.fileExists(fullPath)) {
	        return fullPath;
	      }
	    }
	  }
	  function getPathsRelativeToRootDirs(path, rootDirs, getCanonicalFileName) {
	    return mapDefined(rootDirs, (rootDir) => {
	      const relativePath = getRelativePathIfInSameVolume(path, rootDir, getCanonicalFileName);
	      return relativePath !== void 0 && isPathRelativeToParent(relativePath) ? void 0 : relativePath;
	    });
	  }
	  function processEnding(fileName, allowedEndings, options, host) {
	    if (fileExtensionIsOneOf(fileName, [".json" /* Json */, ".mjs" /* Mjs */, ".cjs" /* Cjs */])) {
	      return fileName;
	    }
	    const noExtension = removeFileExtension(fileName);
	    if (fileName === noExtension) {
	      return fileName;
	    }
	    const jsPriority = allowedEndings.indexOf(2 /* JsExtension */);
	    const tsPriority = allowedEndings.indexOf(3 /* TsExtension */);
	    if (fileExtensionIsOneOf(fileName, [".mts" /* Mts */, ".cts" /* Cts */]) && tsPriority !== -1 && tsPriority < jsPriority) {
	      return fileName;
	    } else if (fileExtensionIsOneOf(fileName, [".d.mts" /* Dmts */, ".mts" /* Mts */, ".d.cts" /* Dcts */, ".cts" /* Cts */])) {
	      return noExtension + getJSExtensionForFile(fileName, options);
	    } else if (!fileExtensionIsOneOf(fileName, [".d.ts" /* Dts */]) && fileExtensionIsOneOf(fileName, [".ts" /* Ts */]) && fileName.includes(".d.")) {
	      return tryGetRealFileNameForNonJsDeclarationFileName(fileName);
	    }
	    switch (allowedEndings[0]) {
	      case 0 /* Minimal */:
	        const withoutIndex = removeSuffix(noExtension, "/index");
	        if (host && withoutIndex !== noExtension && tryGetAnyFileFromPath(host, withoutIndex)) {
	          return noExtension;
	        }
	        return withoutIndex;
	      case 1 /* Index */:
	        return noExtension;
	      case 2 /* JsExtension */:
	        return noExtension + getJSExtensionForFile(fileName, options);
	      case 3 /* TsExtension */:
	        if (isDeclarationFileName(fileName)) {
	          const extensionlessPriority = allowedEndings.findIndex((e) => e === 0 /* Minimal */ || e === 1 /* Index */);
	          return extensionlessPriority !== -1 && extensionlessPriority < jsPriority ? noExtension : noExtension + getJSExtensionForFile(fileName, options);
	        }
	        return fileName;
	      default:
	        return Debug.assertNever(allowedEndings[0]);
	    }
	  }
	  function tryGetRealFileNameForNonJsDeclarationFileName(fileName) {
	    const baseName = getBaseFileName(fileName);
	    if (!endsWith(fileName, ".ts" /* Ts */) || !baseName.includes(".d.") || fileExtensionIsOneOf(baseName, [".d.ts" /* Dts */]))
	      return void 0;
	    const noExtension = removeExtension(fileName, ".ts" /* Ts */);
	    const ext = noExtension.substring(noExtension.lastIndexOf("."));
	    return noExtension.substring(0, noExtension.indexOf(".d.")) + ext;
	  }
	  function getJSExtensionForFile(fileName, options) {
	    return tryGetJSExtensionForFile(fileName, options) ?? Debug.fail(`Extension ${extensionFromPath(fileName)} is unsupported:: FileName:: ${fileName}`);
	  }
	  function tryGetJSExtensionForFile(fileName, options) {
	    const ext = tryGetExtensionFromPath2(fileName);
	    switch (ext) {
	      case ".ts" /* Ts */:
	      case ".d.ts" /* Dts */:
	        return ".js" /* Js */;
	      case ".tsx" /* Tsx */:
	        return options.jsx === 1 /* Preserve */ ? ".jsx" /* Jsx */ : ".js" /* Js */;
	      case ".js" /* Js */:
	      case ".jsx" /* Jsx */:
	      case ".json" /* Json */:
	        return ext;
	      case ".d.mts" /* Dmts */:
	      case ".mts" /* Mts */:
	      case ".mjs" /* Mjs */:
	        return ".mjs" /* Mjs */;
	      case ".d.cts" /* Dcts */:
	      case ".cts" /* Cts */:
	      case ".cjs" /* Cjs */:
	        return ".cjs" /* Cjs */;
	      default:
	        return void 0;
	    }
	  }
	  function getRelativePathIfInSameVolume(path, directoryPath, getCanonicalFileName) {
	    const relativePath = getRelativePathToDirectoryOrUrl(
	      directoryPath,
	      path,
	      directoryPath,
	      getCanonicalFileName,
	      /*isAbsolutePathAnUrl*/
	      false
	    );
	    return isRootedDiskPath(relativePath) ? void 0 : relativePath;
	  }
	  function isPathRelativeToParent(path) {
	    return startsWith(path, "..");
	  }
	  var RelativePreference;
	  var init_moduleSpecifiers = __esm({
	    "src/compiler/moduleSpecifiers.ts"() {
	      init_ts2();
	      RelativePreference = /* @__PURE__ */ ((RelativePreference2) => {
	        RelativePreference2[RelativePreference2["Relative"] = 0] = "Relative";
	        RelativePreference2[RelativePreference2["NonRelative"] = 1] = "NonRelative";
	        RelativePreference2[RelativePreference2["Shortest"] = 2] = "Shortest";
	        RelativePreference2[RelativePreference2["ExternalNonRelative"] = 3] = "ExternalNonRelative";
	        return RelativePreference2;
	      })(RelativePreference || {});
	    }
	  });

	  // src/compiler/_namespaces/ts.moduleSpecifiers.ts
	  var ts_moduleSpecifiers_exports = {};
	  __export(ts_moduleSpecifiers_exports, {
	    RelativePreference: () => RelativePreference,
	    countPathComponents: () => countPathComponents,
	    forEachFileNameOfModule: () => forEachFileNameOfModule,
	    getModuleSpecifier: () => getModuleSpecifier,
	    getModuleSpecifierPreferences: () => getModuleSpecifierPreferences,
	    getModuleSpecifiers: () => getModuleSpecifiers,
	    getModuleSpecifiersWithCacheInfo: () => getModuleSpecifiersWithCacheInfo,
	    getNodeModulesPackageName: () => getNodeModulesPackageName,
	    tryGetJSExtensionForFile: () => tryGetJSExtensionForFile,
	    tryGetModuleSpecifiersFromCache: () => tryGetModuleSpecifiersFromCache,
	    tryGetRealFileNameForNonJsDeclarationFileName: () => tryGetRealFileNameForNonJsDeclarationFileName,
	    updateModuleSpecifier: () => updateModuleSpecifier
	  });
	  var init_ts_moduleSpecifiers = __esm({
	    "src/compiler/_namespaces/ts.moduleSpecifiers.ts"() {
	      init_moduleSpecifiers();
	    }
	  });

	  // src/compiler/checker.ts
	  function NodeLinks() {
	    this.flags = 0 /* None */;
	  }
	  function getNodeId(node) {
	    if (!node.id) {
	      node.id = nextNodeId;
	      nextNodeId++;
	    }
	    return node.id;
	  }
	  function getSymbolId(symbol) {
	    if (!symbol.id) {
	      symbol.id = nextSymbolId;
	      nextSymbolId++;
	    }
	    return symbol.id;
	  }
	  function isInstantiatedModule(node, preserveConstEnums) {
	    const moduleState = getModuleInstanceState(node);
	    return moduleState === 1 /* Instantiated */ || preserveConstEnums && moduleState === 2 /* ConstEnumOnly */;
	  }
	  function createTypeChecker(host) {
	    var deferredDiagnosticsCallbacks = [];
	    var addLazyDiagnostic = (arg) => {
	      deferredDiagnosticsCallbacks.push(arg);
	    };
	    var cancellationToken;
	    var requestedExternalEmitHelperNames = /* @__PURE__ */ new Set();
	    var requestedExternalEmitHelpers;
	    var externalHelpersModule;
	    var Symbol47 = objectAllocator.getSymbolConstructor();
	    var Type28 = objectAllocator.getTypeConstructor();
	    var Signature14 = objectAllocator.getSignatureConstructor();
	    var typeCount = 0;
	    var symbolCount = 0;
	    var totalInstantiationCount = 0;
	    var instantiationCount = 0;
	    var instantiationDepth = 0;
	    var inlineLevel = 0;
	    var currentNode;
	    var varianceTypeParameter;
	    var isInferencePartiallyBlocked = false;
	    var emptySymbols = createSymbolTable();
	    var arrayVariances = [1 /* Covariant */];
	    var compilerOptions = host.getCompilerOptions();
	    var languageVersion = getEmitScriptTarget(compilerOptions);
	    var moduleKind = getEmitModuleKind(compilerOptions);
	    var legacyDecorators = !!compilerOptions.experimentalDecorators;
	    var useDefineForClassFields = getUseDefineForClassFields(compilerOptions);
	    var emitStandardClassFields = getEmitStandardClassFields(compilerOptions);
	    var allowSyntheticDefaultImports = getAllowSyntheticDefaultImports(compilerOptions);
	    var strictNullChecks = getStrictOptionValue(compilerOptions, "strictNullChecks");
	    var strictFunctionTypes = getStrictOptionValue(compilerOptions, "strictFunctionTypes");
	    var strictBindCallApply = getStrictOptionValue(compilerOptions, "strictBindCallApply");
	    var strictPropertyInitialization = getStrictOptionValue(compilerOptions, "strictPropertyInitialization");
	    var noImplicitAny = getStrictOptionValue(compilerOptions, "noImplicitAny");
	    var noImplicitThis = getStrictOptionValue(compilerOptions, "noImplicitThis");
	    var useUnknownInCatchVariables = getStrictOptionValue(compilerOptions, "useUnknownInCatchVariables");
	    var keyofStringsOnly = !!compilerOptions.keyofStringsOnly;
	    var defaultIndexFlags = keyofStringsOnly ? 1 /* StringsOnly */ : 0 /* None */;
	    var freshObjectLiteralFlag = compilerOptions.suppressExcessPropertyErrors ? 0 : 8192 /* FreshLiteral */;
	    var exactOptionalPropertyTypes = compilerOptions.exactOptionalPropertyTypes;
	    var checkBinaryExpression = createCheckBinaryExpression();
	    var emitResolver = createResolver();
	    var nodeBuilder = createNodeBuilder();
	    var globals = createSymbolTable();
	    var undefinedSymbol = createSymbol(4 /* Property */, "undefined");
	    undefinedSymbol.declarations = [];
	    var globalThisSymbol = createSymbol(1536 /* Module */, "globalThis", 8 /* Readonly */);
	    globalThisSymbol.exports = globals;
	    globalThisSymbol.declarations = [];
	    globals.set(globalThisSymbol.escapedName, globalThisSymbol);
	    var argumentsSymbol = createSymbol(4 /* Property */, "arguments");
	    var requireSymbol = createSymbol(4 /* Property */, "require");
	    var isolatedModulesLikeFlagName = compilerOptions.verbatimModuleSyntax ? "verbatimModuleSyntax" : "isolatedModules";
	    var canCollectSymbolAliasAccessabilityData = !compilerOptions.verbatimModuleSyntax || !!compilerOptions.importsNotUsedAsValues;
	    var apparentArgumentCount;
	    var lastGetCombinedNodeFlagsNode;
	    var lastGetCombinedNodeFlagsResult = 0 /* None */;
	    var lastGetCombinedModifierFlagsNode;
	    var lastGetCombinedModifierFlagsResult = 0 /* None */;
	    const checker = {
	      getNodeCount: () => reduceLeft(host.getSourceFiles(), (n, s) => n + s.nodeCount, 0),
	      getIdentifierCount: () => reduceLeft(host.getSourceFiles(), (n, s) => n + s.identifierCount, 0),
	      getSymbolCount: () => reduceLeft(host.getSourceFiles(), (n, s) => n + s.symbolCount, symbolCount),
	      getTypeCount: () => typeCount,
	      getInstantiationCount: () => totalInstantiationCount,
	      getRelationCacheSizes: () => ({
	        assignable: assignableRelation.size,
	        identity: identityRelation.size,
	        subtype: subtypeRelation.size,
	        strictSubtype: strictSubtypeRelation.size
	      }),
	      isUndefinedSymbol: (symbol) => symbol === undefinedSymbol,
	      isArgumentsSymbol: (symbol) => symbol === argumentsSymbol,
	      isUnknownSymbol: (symbol) => symbol === unknownSymbol,
	      getMergedSymbol,
	      getDiagnostics: getDiagnostics2,
	      getGlobalDiagnostics,
	      getRecursionIdentity,
	      getUnmatchedProperties,
	      getTypeOfSymbolAtLocation: (symbol, locationIn) => {
	        const location = getParseTreeNode(locationIn);
	        return location ? getTypeOfSymbolAtLocation(symbol, location) : errorType;
	      },
	      getTypeOfSymbol,
	      getSymbolsOfParameterPropertyDeclaration: (parameterIn, parameterName) => {
	        const parameter = getParseTreeNode(parameterIn, isParameter);
	        if (parameter === void 0)
	          return Debug.fail("Cannot get symbols of a synthetic parameter that cannot be resolved to a parse-tree node.");
	        Debug.assert(isParameterPropertyDeclaration(parameter, parameter.parent));
	        return getSymbolsOfParameterPropertyDeclaration(parameter, escapeLeadingUnderscores(parameterName));
	      },
	      getDeclaredTypeOfSymbol,
	      getPropertiesOfType,
	      getPropertyOfType: (type, name) => getPropertyOfType(type, escapeLeadingUnderscores(name)),
	      getPrivateIdentifierPropertyOfType: (leftType, name, location) => {
	        const node = getParseTreeNode(location);
	        if (!node) {
	          return void 0;
	        }
	        const propName = escapeLeadingUnderscores(name);
	        const lexicallyScopedIdentifier = lookupSymbolForPrivateIdentifierDeclaration(propName, node);
	        return lexicallyScopedIdentifier ? getPrivateIdentifierPropertyOfType(leftType, lexicallyScopedIdentifier) : void 0;
	      },
	      getTypeOfPropertyOfType: (type, name) => getTypeOfPropertyOfType(type, escapeLeadingUnderscores(name)),
	      getIndexInfoOfType: (type, kind) => getIndexInfoOfType(type, kind === 0 /* String */ ? stringType : numberType),
	      getIndexInfosOfType,
	      getIndexInfosOfIndexSymbol,
	      getSignaturesOfType,
	      getIndexTypeOfType: (type, kind) => getIndexTypeOfType(type, kind === 0 /* String */ ? stringType : numberType),
	      getIndexType: (type) => getIndexType(type),
	      getBaseTypes,
	      getBaseTypeOfLiteralType,
	      getWidenedType,
	      getTypeFromTypeNode: (nodeIn) => {
	        const node = getParseTreeNode(nodeIn, isTypeNode);
	        return node ? getTypeFromTypeNode(node) : errorType;
	      },
	      getParameterType: getTypeAtPosition,
	      getParameterIdentifierInfoAtPosition,
	      getPromisedTypeOfPromise,
	      getAwaitedType: (type) => getAwaitedType(type),
	      getReturnTypeOfSignature,
	      isNullableType,
	      getNullableType,
	      getNonNullableType,
	      getNonOptionalType: removeOptionalTypeMarker,
	      getTypeArguments,
	      typeToTypeNode: nodeBuilder.typeToTypeNode,
	      indexInfoToIndexSignatureDeclaration: nodeBuilder.indexInfoToIndexSignatureDeclaration,
	      signatureToSignatureDeclaration: nodeBuilder.signatureToSignatureDeclaration,
	      symbolToEntityName: nodeBuilder.symbolToEntityName,
	      symbolToExpression: nodeBuilder.symbolToExpression,
	      symbolToNode: nodeBuilder.symbolToNode,
	      symbolToTypeParameterDeclarations: nodeBuilder.symbolToTypeParameterDeclarations,
	      symbolToParameterDeclaration: nodeBuilder.symbolToParameterDeclaration,
	      typeParameterToDeclaration: nodeBuilder.typeParameterToDeclaration,
	      getSymbolsInScope: (locationIn, meaning) => {
	        const location = getParseTreeNode(locationIn);
	        return location ? getSymbolsInScope(location, meaning) : [];
	      },
	      getSymbolAtLocation: (nodeIn) => {
	        const node = getParseTreeNode(nodeIn);
	        return node ? getSymbolAtLocation(
	          node,
	          /*ignoreErrors*/
	          true
	        ) : void 0;
	      },
	      getIndexInfosAtLocation: (nodeIn) => {
	        const node = getParseTreeNode(nodeIn);
	        return node ? getIndexInfosAtLocation(node) : void 0;
	      },
	      getShorthandAssignmentValueSymbol: (nodeIn) => {
	        const node = getParseTreeNode(nodeIn);
	        return node ? getShorthandAssignmentValueSymbol(node) : void 0;
	      },
	      getExportSpecifierLocalTargetSymbol: (nodeIn) => {
	        const node = getParseTreeNode(nodeIn, isExportSpecifier);
	        return node ? getExportSpecifierLocalTargetSymbol(node) : void 0;
	      },
	      getExportSymbolOfSymbol(symbol) {
	        return getMergedSymbol(symbol.exportSymbol || symbol);
	      },
	      getTypeAtLocation: (nodeIn) => {
	        const node = getParseTreeNode(nodeIn);
	        return node ? getTypeOfNode(node) : errorType;
	      },
	      getTypeOfAssignmentPattern: (nodeIn) => {
	        const node = getParseTreeNode(nodeIn, isAssignmentPattern);
	        return node && getTypeOfAssignmentPattern(node) || errorType;
	      },
	      getPropertySymbolOfDestructuringAssignment: (locationIn) => {
	        const location = getParseTreeNode(locationIn, isIdentifier);
	        return location ? getPropertySymbolOfDestructuringAssignment(location) : void 0;
	      },
	      signatureToString: (signature, enclosingDeclaration, flags, kind) => {
	        return signatureToString(signature, getParseTreeNode(enclosingDeclaration), flags, kind);
	      },
	      typeToString: (type, enclosingDeclaration, flags) => {
	        return typeToString(type, getParseTreeNode(enclosingDeclaration), flags);
	      },
	      symbolToString: (symbol, enclosingDeclaration, meaning, flags) => {
	        return symbolToString(symbol, getParseTreeNode(enclosingDeclaration), meaning, flags);
	      },
	      typePredicateToString: (predicate, enclosingDeclaration, flags) => {
	        return typePredicateToString(predicate, getParseTreeNode(enclosingDeclaration), flags);
	      },
	      writeSignature: (signature, enclosingDeclaration, flags, kind, writer) => {
	        return signatureToString(signature, getParseTreeNode(enclosingDeclaration), flags, kind, writer);
	      },
	      writeType: (type, enclosingDeclaration, flags, writer) => {
	        return typeToString(type, getParseTreeNode(enclosingDeclaration), flags, writer);
	      },
	      writeSymbol: (symbol, enclosingDeclaration, meaning, flags, writer) => {
	        return symbolToString(symbol, getParseTreeNode(enclosingDeclaration), meaning, flags, writer);
	      },
	      writeTypePredicate: (predicate, enclosingDeclaration, flags, writer) => {
	        return typePredicateToString(predicate, getParseTreeNode(enclosingDeclaration), flags, writer);
	      },
	      getAugmentedPropertiesOfType,
	      getRootSymbols,
	      getSymbolOfExpando,
	      getContextualType: (nodeIn, contextFlags) => {
	        const node = getParseTreeNode(nodeIn, isExpression);
	        if (!node) {
	          return void 0;
	        }
	        if (contextFlags & 4 /* Completions */) {
	          return runWithInferenceBlockedFromSourceNode(node, () => getContextualType2(node, contextFlags));
	        }
	        return getContextualType2(node, contextFlags);
	      },
	      getContextualTypeForObjectLiteralElement: (nodeIn) => {
	        const node = getParseTreeNode(nodeIn, isObjectLiteralElementLike);
	        return node ? getContextualTypeForObjectLiteralElement(
	          node,
	          /*contextFlags*/
	          void 0
	        ) : void 0;
	      },
	      getContextualTypeForArgumentAtIndex: (nodeIn, argIndex) => {
	        const node = getParseTreeNode(nodeIn, isCallLikeExpression);
	        return node && getContextualTypeForArgumentAtIndex(node, argIndex);
	      },
	      getContextualTypeForJsxAttribute: (nodeIn) => {
	        const node = getParseTreeNode(nodeIn, isJsxAttributeLike);
	        return node && getContextualTypeForJsxAttribute(
	          node,
	          /*contextFlags*/
	          void 0
	        );
	      },
	      isContextSensitive,
	      getTypeOfPropertyOfContextualType,
	      getFullyQualifiedName,
	      getResolvedSignature: (node, candidatesOutArray, argumentCount) => getResolvedSignatureWorker(node, candidatesOutArray, argumentCount, 0 /* Normal */),
	      getCandidateSignaturesForStringLiteralCompletions,
	      getResolvedSignatureForSignatureHelp: (node, candidatesOutArray, argumentCount) => runWithoutResolvedSignatureCaching(node, () => getResolvedSignatureWorker(node, candidatesOutArray, argumentCount, 16 /* IsForSignatureHelp */)),
	      getExpandedParameters,
	      hasEffectiveRestParameter,
	      containsArgumentsReference,
	      getConstantValue: (nodeIn) => {
	        const node = getParseTreeNode(nodeIn, canHaveConstantValue);
	        return node ? getConstantValue2(node) : void 0;
	      },
	      isValidPropertyAccess: (nodeIn, propertyName) => {
	        const node = getParseTreeNode(nodeIn, isPropertyAccessOrQualifiedNameOrImportTypeNode);
	        return !!node && isValidPropertyAccess(node, escapeLeadingUnderscores(propertyName));
	      },
	      isValidPropertyAccessForCompletions: (nodeIn, type, property) => {
	        const node = getParseTreeNode(nodeIn, isPropertyAccessExpression);
	        return !!node && isValidPropertyAccessForCompletions(node, type, property);
	      },
	      getSignatureFromDeclaration: (declarationIn) => {
	        const declaration = getParseTreeNode(declarationIn, isFunctionLike);
	        return declaration ? getSignatureFromDeclaration(declaration) : void 0;
	      },
	      isImplementationOfOverload: (nodeIn) => {
	        const node = getParseTreeNode(nodeIn, isFunctionLike);
	        return node ? isImplementationOfOverload(node) : void 0;
	      },
	      getImmediateAliasedSymbol,
	      getAliasedSymbol: resolveAlias,
	      getEmitResolver,
	      getExportsOfModule: getExportsOfModuleAsArray,
	      getExportsAndPropertiesOfModule,
	      forEachExportAndPropertyOfModule,
	      getSymbolWalker: createGetSymbolWalker(
	        getRestTypeOfSignature,
	        getTypePredicateOfSignature,
	        getReturnTypeOfSignature,
	        getBaseTypes,
	        resolveStructuredTypeMembers,
	        getTypeOfSymbol,
	        getResolvedSymbol,
	        getConstraintOfTypeParameter,
	        getFirstIdentifier,
	        getTypeArguments
	      ),
	      getAmbientModules,
	      getJsxIntrinsicTagNamesAt,
	      isOptionalParameter: (nodeIn) => {
	        const node = getParseTreeNode(nodeIn, isParameter);
	        return node ? isOptionalParameter(node) : false;
	      },
	      tryGetMemberInModuleExports: (name, symbol) => tryGetMemberInModuleExports(escapeLeadingUnderscores(name), symbol),
	      tryGetMemberInModuleExportsAndProperties: (name, symbol) => tryGetMemberInModuleExportsAndProperties(escapeLeadingUnderscores(name), symbol),
	      tryFindAmbientModule: (moduleName) => tryFindAmbientModule(
	        moduleName,
	        /*withAugmentations*/
	        true
	      ),
	      tryFindAmbientModuleWithoutAugmentations: (moduleName) => {
	        return tryFindAmbientModule(
	          moduleName,
	          /*withAugmentations*/
	          false
	        );
	      },
	      getApparentType,
	      getUnionType,
	      isTypeAssignableTo,
	      createAnonymousType,
	      createSignature,
	      createSymbol,
	      createIndexInfo,
	      getAnyType: () => anyType,
	      getStringType: () => stringType,
	      getStringLiteralType,
	      getNumberType: () => numberType,
	      getNumberLiteralType,
	      getBigIntType: () => bigintType,
	      createPromiseType,
	      createArrayType,
	      getElementTypeOfArrayType,
	      getBooleanType: () => booleanType,
	      getFalseType: (fresh) => fresh ? falseType : regularFalseType,
	      getTrueType: (fresh) => fresh ? trueType : regularTrueType,
	      getVoidType: () => voidType,
	      getUndefinedType: () => undefinedType,
	      getNullType: () => nullType,
	      getESSymbolType: () => esSymbolType,
	      getNeverType: () => neverType,
	      getOptionalType: () => optionalType,
	      getPromiseType: () => getGlobalPromiseType(
	        /*reportErrors*/
	        false
	      ),
	      getPromiseLikeType: () => getGlobalPromiseLikeType(
	        /*reportErrors*/
	        false
	      ),
	      getAsyncIterableType: () => {
	        const type = getGlobalAsyncIterableType(
	          /*reportErrors*/
	          false
	        );
	        if (type === emptyGenericType)
	          return void 0;
	        return type;
	      },
	      isSymbolAccessible,
	      isArrayType,
	      isTupleType,
	      isArrayLikeType,
	      isEmptyAnonymousObjectType,
	      isTypeInvalidDueToUnionDiscriminant,
	      getExactOptionalProperties,
	      getAllPossiblePropertiesOfTypes,
	      getSuggestedSymbolForNonexistentProperty,
	      getSuggestionForNonexistentProperty,
	      getSuggestedSymbolForNonexistentJSXAttribute,
	      getSuggestedSymbolForNonexistentSymbol: (location, name, meaning) => getSuggestedSymbolForNonexistentSymbol(location, escapeLeadingUnderscores(name), meaning),
	      getSuggestionForNonexistentSymbol: (location, name, meaning) => getSuggestionForNonexistentSymbol(location, escapeLeadingUnderscores(name), meaning),
	      getSuggestedSymbolForNonexistentModule,
	      getSuggestionForNonexistentExport,
	      getSuggestedSymbolForNonexistentClassMember,
	      getBaseConstraintOfType,
	      getDefaultFromTypeParameter: (type) => type && type.flags & 262144 /* TypeParameter */ ? getDefaultFromTypeParameter(type) : void 0,
	      resolveName(name, location, meaning, excludeGlobals) {
	        return resolveName(
	          location,
	          escapeLeadingUnderscores(name),
	          meaning,
	          /*nameNotFoundMessage*/
	          void 0,
	          /*nameArg*/
	          void 0,
	          /*isUse*/
	          false,
	          excludeGlobals
	        );
	      },
	      getJsxNamespace: (n) => unescapeLeadingUnderscores(getJsxNamespace(n)),
	      getJsxFragmentFactory: (n) => {
	        const jsxFragmentFactory = getJsxFragmentFactoryEntity(n);
	        return jsxFragmentFactory && unescapeLeadingUnderscores(getFirstIdentifier(jsxFragmentFactory).escapedText);
	      },
	      getAccessibleSymbolChain,
	      getTypePredicateOfSignature,
	      resolveExternalModuleName: (moduleSpecifierIn) => {
	        const moduleSpecifier = getParseTreeNode(moduleSpecifierIn, isExpression);
	        return moduleSpecifier && resolveExternalModuleName(
	          moduleSpecifier,
	          moduleSpecifier,
	          /*ignoreErrors*/
	          true
	        );
	      },
	      resolveExternalModuleSymbol,
	      tryGetThisTypeAt: (nodeIn, includeGlobalThis, container) => {
	        const node = getParseTreeNode(nodeIn);
	        return node && tryGetThisTypeAt(node, includeGlobalThis, container);
	      },
	      getTypeArgumentConstraint: (nodeIn) => {
	        const node = getParseTreeNode(nodeIn, isTypeNode);
	        return node && getTypeArgumentConstraint(node);
	      },
	      getSuggestionDiagnostics: (fileIn, ct) => {
	        const file = getParseTreeNode(fileIn, isSourceFile) || Debug.fail("Could not determine parsed source file.");
	        if (skipTypeChecking(file, compilerOptions, host)) {
	          return emptyArray;
	        }
	        let diagnostics2;
	        try {
	          cancellationToken = ct;
	          checkSourceFileWithEagerDiagnostics(file);
	          Debug.assert(!!(getNodeLinks(file).flags & 1 /* TypeChecked */));
	          diagnostics2 = addRange(diagnostics2, suggestionDiagnostics.getDiagnostics(file.fileName));
	          checkUnusedIdentifiers(getPotentiallyUnusedIdentifiers(file), (containingNode, kind, diag2) => {
	            if (!containsParseError(containingNode) && !unusedIsError(kind, !!(containingNode.flags & 33554432 /* Ambient */))) {
	              (diagnostics2 || (diagnostics2 = [])).push({ ...diag2, category: 2 /* Suggestion */ });
	            }
	          });
	          return diagnostics2 || emptyArray;
	        } finally {
	          cancellationToken = void 0;
	        }
	      },
	      runWithCancellationToken: (token, callback) => {
	        try {
	          cancellationToken = token;
	          return callback(checker);
	        } finally {
	          cancellationToken = void 0;
	        }
	      },
	      getLocalTypeParametersOfClassOrInterfaceOrTypeAlias,
	      isDeclarationVisible,
	      isPropertyAccessible,
	      getTypeOnlyAliasDeclaration,
	      getMemberOverrideModifierStatus,
	      isTypeParameterPossiblyReferenced,
	      typeHasCallOrConstructSignatures
	    };
	    function getCandidateSignaturesForStringLiteralCompletions(call, editingArgument) {
	      const candidatesSet = /* @__PURE__ */ new Set();
	      const candidates = [];
	      runWithInferenceBlockedFromSourceNode(editingArgument, () => getResolvedSignatureWorker(
	        call,
	        candidates,
	        /*argumentCount*/
	        void 0,
	        0 /* Normal */
	      ));
	      for (const candidate of candidates) {
	        candidatesSet.add(candidate);
	      }
	      candidates.length = 0;
	      runWithoutResolvedSignatureCaching(editingArgument, () => getResolvedSignatureWorker(
	        call,
	        candidates,
	        /*argumentCount*/
	        void 0,
	        0 /* Normal */
	      ));
	      for (const candidate of candidates) {
	        candidatesSet.add(candidate);
	      }
	      return arrayFrom(candidatesSet);
	    }
	    function runWithoutResolvedSignatureCaching(node, fn) {
	      node = findAncestor(node, isCallLikeOrFunctionLikeExpression);
	      if (node) {
	        const cachedResolvedSignatures = [];
	        const cachedTypes2 = [];
	        while (node) {
	          const nodeLinks2 = getNodeLinks(node);
	          cachedResolvedSignatures.push([nodeLinks2, nodeLinks2.resolvedSignature]);
	          nodeLinks2.resolvedSignature = void 0;
	          if (isFunctionExpressionOrArrowFunction(node)) {
	            const symbolLinks2 = getSymbolLinks(getSymbolOfDeclaration(node));
	            const type = symbolLinks2.type;
	            cachedTypes2.push([symbolLinks2, type]);
	            symbolLinks2.type = void 0;
	          }
	          node = findAncestor(node.parent, isCallLikeOrFunctionLikeExpression);
	        }
	        const result = fn();
	        for (const [nodeLinks2, resolvedSignature] of cachedResolvedSignatures) {
	          nodeLinks2.resolvedSignature = resolvedSignature;
	        }
	        for (const [symbolLinks2, type] of cachedTypes2) {
	          symbolLinks2.type = type;
	        }
	        return result;
	      }
	      return fn();
	    }
	    function runWithInferenceBlockedFromSourceNode(node, fn) {
	      const containingCall = findAncestor(node, isCallLikeExpression);
	      if (containingCall) {
	        let toMarkSkip = node;
	        do {
	          getNodeLinks(toMarkSkip).skipDirectInference = true;
	          toMarkSkip = toMarkSkip.parent;
	        } while (toMarkSkip && toMarkSkip !== containingCall);
	      }
	      isInferencePartiallyBlocked = true;
	      const result = runWithoutResolvedSignatureCaching(node, fn);
	      isInferencePartiallyBlocked = false;
	      if (containingCall) {
	        let toMarkSkip = node;
	        do {
	          getNodeLinks(toMarkSkip).skipDirectInference = void 0;
	          toMarkSkip = toMarkSkip.parent;
	        } while (toMarkSkip && toMarkSkip !== containingCall);
	      }
	      return result;
	    }
	    function getResolvedSignatureWorker(nodeIn, candidatesOutArray, argumentCount, checkMode) {
	      const node = getParseTreeNode(nodeIn, isCallLikeExpression);
	      apparentArgumentCount = argumentCount;
	      const res = !node ? void 0 : getResolvedSignature(node, candidatesOutArray, checkMode);
	      apparentArgumentCount = void 0;
	      return res;
	    }
	    var tupleTypes = /* @__PURE__ */ new Map();
	    var unionTypes = /* @__PURE__ */ new Map();
	    var unionOfUnionTypes = /* @__PURE__ */ new Map();
	    var intersectionTypes = /* @__PURE__ */ new Map();
	    var stringLiteralTypes = /* @__PURE__ */ new Map();
	    var numberLiteralTypes = /* @__PURE__ */ new Map();
	    var bigIntLiteralTypes = /* @__PURE__ */ new Map();
	    var enumLiteralTypes = /* @__PURE__ */ new Map();
	    var indexedAccessTypes = /* @__PURE__ */ new Map();
	    var templateLiteralTypes = /* @__PURE__ */ new Map();
	    var stringMappingTypes = /* @__PURE__ */ new Map();
	    var substitutionTypes = /* @__PURE__ */ new Map();
	    var subtypeReductionCache = /* @__PURE__ */ new Map();
	    var decoratorContextOverrideTypeCache = /* @__PURE__ */ new Map();
	    var cachedTypes = /* @__PURE__ */ new Map();
	    var evolvingArrayTypes = [];
	    var undefinedProperties = /* @__PURE__ */ new Map();
	    var markerTypes = /* @__PURE__ */ new Set();
	    var unknownSymbol = createSymbol(4 /* Property */, "unknown");
	    var resolvingSymbol = createSymbol(0, "__resolving__" /* Resolving */);
	    var unresolvedSymbols = /* @__PURE__ */ new Map();
	    var errorTypes = /* @__PURE__ */ new Map();
	    var seenIntrinsicNames = /* @__PURE__ */ new Set();
	    var anyType = createIntrinsicType(1 /* Any */, "any");
	    var autoType = createIntrinsicType(1 /* Any */, "any", 262144 /* NonInferrableType */, "auto");
	    var wildcardType = createIntrinsicType(
	      1 /* Any */,
	      "any",
	      /*objectFlags*/
	      void 0,
	      "wildcard"
	    );
	    var blockedStringType = createIntrinsicType(
	      1 /* Any */,
	      "any",
	      /*objectFlags*/
	      void 0,
	      "blocked string"
	    );
	    var errorType = createIntrinsicType(1 /* Any */, "error");
	    var unresolvedType = createIntrinsicType(1 /* Any */, "unresolved");
	    var nonInferrableAnyType = createIntrinsicType(1 /* Any */, "any", 65536 /* ContainsWideningType */, "non-inferrable");
	    var intrinsicMarkerType = createIntrinsicType(1 /* Any */, "intrinsic");
	    var unknownType = createIntrinsicType(2 /* Unknown */, "unknown");
	    var nonNullUnknownType = createIntrinsicType(
	      2 /* Unknown */,
	      "unknown",
	      /*objectFlags*/
	      void 0,
	      "non-null"
	    );
	    var undefinedType = createIntrinsicType(32768 /* Undefined */, "undefined");
	    var undefinedWideningType = strictNullChecks ? undefinedType : createIntrinsicType(32768 /* Undefined */, "undefined", 65536 /* ContainsWideningType */, "widening");
	    var missingType = createIntrinsicType(
	      32768 /* Undefined */,
	      "undefined",
	      /*objectFlags*/
	      void 0,
	      "missing"
	    );
	    var undefinedOrMissingType = exactOptionalPropertyTypes ? missingType : undefinedType;
	    var optionalType = createIntrinsicType(
	      32768 /* Undefined */,
	      "undefined",
	      /*objectFlags*/
	      void 0,
	      "optional"
	    );
	    var nullType = createIntrinsicType(65536 /* Null */, "null");
	    var nullWideningType = strictNullChecks ? nullType : createIntrinsicType(65536 /* Null */, "null", 65536 /* ContainsWideningType */, "widening");
	    var stringType = createIntrinsicType(4 /* String */, "string");
	    var numberType = createIntrinsicType(8 /* Number */, "number");
	    var bigintType = createIntrinsicType(64 /* BigInt */, "bigint");
	    var falseType = createIntrinsicType(
	      512 /* BooleanLiteral */,
	      "false",
	      /*objectFlags*/
	      void 0,
	      "fresh"
	    );
	    var regularFalseType = createIntrinsicType(512 /* BooleanLiteral */, "false");
	    var trueType = createIntrinsicType(
	      512 /* BooleanLiteral */,
	      "true",
	      /*objectFlags*/
	      void 0,
	      "fresh"
	    );
	    var regularTrueType = createIntrinsicType(512 /* BooleanLiteral */, "true");
	    trueType.regularType = regularTrueType;
	    trueType.freshType = trueType;
	    regularTrueType.regularType = regularTrueType;
	    regularTrueType.freshType = trueType;
	    falseType.regularType = regularFalseType;
	    falseType.freshType = falseType;
	    regularFalseType.regularType = regularFalseType;
	    regularFalseType.freshType = falseType;
	    var booleanType = getUnionType([regularFalseType, regularTrueType]);
	    var esSymbolType = createIntrinsicType(4096 /* ESSymbol */, "symbol");
	    var voidType = createIntrinsicType(16384 /* Void */, "void");
	    var neverType = createIntrinsicType(131072 /* Never */, "never");
	    var silentNeverType = createIntrinsicType(131072 /* Never */, "never", 262144 /* NonInferrableType */, "silent");
	    var implicitNeverType = createIntrinsicType(
	      131072 /* Never */,
	      "never",
	      /*objectFlags*/
	      void 0,
	      "implicit"
	    );
	    var unreachableNeverType = createIntrinsicType(
	      131072 /* Never */,
	      "never",
	      /*objectFlags*/
	      void 0,
	      "unreachable"
	    );
	    var nonPrimitiveType = createIntrinsicType(67108864 /* NonPrimitive */, "object");
	    var stringOrNumberType = getUnionType([stringType, numberType]);
	    var stringNumberSymbolType = getUnionType([stringType, numberType, esSymbolType]);
	    var keyofConstraintType = keyofStringsOnly ? stringType : stringNumberSymbolType;
	    var numberOrBigIntType = getUnionType([numberType, bigintType]);
	    var templateConstraintType = getUnionType([stringType, numberType, booleanType, bigintType, nullType, undefinedType]);
	    var numericStringType = getTemplateLiteralType(["", ""], [numberType]);
	    var restrictiveMapper = makeFunctionTypeMapper((t) => t.flags & 262144 /* TypeParameter */ ? getRestrictiveTypeParameter(t) : t, () => "(restrictive mapper)");
	    var permissiveMapper = makeFunctionTypeMapper((t) => t.flags & 262144 /* TypeParameter */ ? wildcardType : t, () => "(permissive mapper)");
	    var uniqueLiteralType = createIntrinsicType(
	      131072 /* Never */,
	      "never",
	      /*objectFlags*/
	      void 0,
	      "unique literal"
	    );
	    var uniqueLiteralMapper = makeFunctionTypeMapper((t) => t.flags & 262144 /* TypeParameter */ ? uniqueLiteralType : t, () => "(unique literal mapper)");
	    var outofbandVarianceMarkerHandler;
	    var reportUnreliableMapper = makeFunctionTypeMapper((t) => {
	      if (outofbandVarianceMarkerHandler && (t === markerSuperType || t === markerSubType || t === markerOtherType)) {
	        outofbandVarianceMarkerHandler(
	          /*onlyUnreliable*/
	          true
	        );
	      }
	      return t;
	    }, () => "(unmeasurable reporter)");
	    var reportUnmeasurableMapper = makeFunctionTypeMapper((t) => {
	      if (outofbandVarianceMarkerHandler && (t === markerSuperType || t === markerSubType || t === markerOtherType)) {
	        outofbandVarianceMarkerHandler(
	          /*onlyUnreliable*/
	          false
	        );
	      }
	      return t;
	    }, () => "(unreliable reporter)");
	    var emptyObjectType = createAnonymousType(
	      /*symbol*/
	      void 0,
	      emptySymbols,
	      emptyArray,
	      emptyArray,
	      emptyArray
	    );
	    var emptyJsxObjectType = createAnonymousType(
	      /*symbol*/
	      void 0,
	      emptySymbols,
	      emptyArray,
	      emptyArray,
	      emptyArray
	    );
	    emptyJsxObjectType.objectFlags |= 2048 /* JsxAttributes */;
	    var emptyTypeLiteralSymbol = createSymbol(2048 /* TypeLiteral */, "__type" /* Type */);
	    emptyTypeLiteralSymbol.members = createSymbolTable();
	    var emptyTypeLiteralType = createAnonymousType(emptyTypeLiteralSymbol, emptySymbols, emptyArray, emptyArray, emptyArray);
	    var unknownEmptyObjectType = createAnonymousType(
	      /*symbol*/
	      void 0,
	      emptySymbols,
	      emptyArray,
	      emptyArray,
	      emptyArray
	    );
	    var unknownUnionType = strictNullChecks ? getUnionType([undefinedType, nullType, unknownEmptyObjectType]) : unknownType;
	    var emptyGenericType = createAnonymousType(
	      /*symbol*/
	      void 0,
	      emptySymbols,
	      emptyArray,
	      emptyArray,
	      emptyArray
	    );
	    emptyGenericType.instantiations = /* @__PURE__ */ new Map();
	    var anyFunctionType = createAnonymousType(
	      /*symbol*/
	      void 0,
	      emptySymbols,
	      emptyArray,
	      emptyArray,
	      emptyArray
	    );
	    anyFunctionType.objectFlags |= 262144 /* NonInferrableType */;
	    var noConstraintType = createAnonymousType(
	      /*symbol*/
	      void 0,
	      emptySymbols,
	      emptyArray,
	      emptyArray,
	      emptyArray
	    );
	    var circularConstraintType = createAnonymousType(
	      /*symbol*/
	      void 0,
	      emptySymbols,
	      emptyArray,
	      emptyArray,
	      emptyArray
	    );
	    var resolvingDefaultType = createAnonymousType(
	      /*symbol*/
	      void 0,
	      emptySymbols,
	      emptyArray,
	      emptyArray,
	      emptyArray
	    );
	    var markerSuperType = createTypeParameter();
	    var markerSubType = createTypeParameter();
	    markerSubType.constraint = markerSuperType;
	    var markerOtherType = createTypeParameter();
	    var markerSuperTypeForCheck = createTypeParameter();
	    var markerSubTypeForCheck = createTypeParameter();
	    markerSubTypeForCheck.constraint = markerSuperTypeForCheck;
	    var noTypePredicate = createTypePredicate(1 /* Identifier */, "<<unresolved>>", 0, anyType);
	    var anySignature = createSignature(
	      /*declaration*/
	      void 0,
	      /*typeParameters*/
	      void 0,
	      /*thisParameter*/
	      void 0,
	      emptyArray,
	      anyType,
	      /*resolvedTypePredicate*/
	      void 0,
	      0,
	      0 /* None */
	    );
	    var unknownSignature = createSignature(
	      /*declaration*/
	      void 0,
	      /*typeParameters*/
	      void 0,
	      /*thisParameter*/
	      void 0,
	      emptyArray,
	      errorType,
	      /*resolvedTypePredicate*/
	      void 0,
	      0,
	      0 /* None */
	    );
	    var resolvingSignature = createSignature(
	      /*declaration*/
	      void 0,
	      /*typeParameters*/
	      void 0,
	      /*thisParameter*/
	      void 0,
	      emptyArray,
	      anyType,
	      /*resolvedTypePredicate*/
	      void 0,
	      0,
	      0 /* None */
	    );
	    var silentNeverSignature = createSignature(
	      /*declaration*/
	      void 0,
	      /*typeParameters*/
	      void 0,
	      /*thisParameter*/
	      void 0,
	      emptyArray,
	      silentNeverType,
	      /*resolvedTypePredicate*/
	      void 0,
	      0,
	      0 /* None */
	    );
	    var enumNumberIndexInfo = createIndexInfo(
	      numberType,
	      stringType,
	      /*isReadonly*/
	      true
	    );
	    var iterationTypesCache = /* @__PURE__ */ new Map();
	    var noIterationTypes = {
	      get yieldType() {
	        return Debug.fail("Not supported");
	      },
	      get returnType() {
	        return Debug.fail("Not supported");
	      },
	      get nextType() {
	        return Debug.fail("Not supported");
	      }
	    };
	    var anyIterationTypes = createIterationTypes(anyType, anyType, anyType);
	    var anyIterationTypesExceptNext = createIterationTypes(anyType, anyType, unknownType);
	    var defaultIterationTypes = createIterationTypes(neverType, anyType, undefinedType);
	    var asyncIterationTypesResolver = {
	      iterableCacheKey: "iterationTypesOfAsyncIterable",
	      iteratorCacheKey: "iterationTypesOfAsyncIterator",
	      iteratorSymbolName: "asyncIterator",
	      getGlobalIteratorType: getGlobalAsyncIteratorType,
	      getGlobalIterableType: getGlobalAsyncIterableType,
	      getGlobalIterableIteratorType: getGlobalAsyncIterableIteratorType,
	      getGlobalGeneratorType: getGlobalAsyncGeneratorType,
	      resolveIterationType: (type, errorNode) => getAwaitedType(type, errorNode, Diagnostics.Type_of_await_operand_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member),
	      mustHaveANextMethodDiagnostic: Diagnostics.An_async_iterator_must_have_a_next_method,
	      mustBeAMethodDiagnostic: Diagnostics.The_0_property_of_an_async_iterator_must_be_a_method,
	      mustHaveAValueDiagnostic: Diagnostics.The_type_returned_by_the_0_method_of_an_async_iterator_must_be_a_promise_for_a_type_with_a_value_property
	    };
	    var syncIterationTypesResolver = {
	      iterableCacheKey: "iterationTypesOfIterable",
	      iteratorCacheKey: "iterationTypesOfIterator",
	      iteratorSymbolName: "iterator",
	      getGlobalIteratorType,
	      getGlobalIterableType,
	      getGlobalIterableIteratorType,
	      getGlobalGeneratorType,
	      resolveIterationType: (type, _errorNode) => type,
	      mustHaveANextMethodDiagnostic: Diagnostics.An_iterator_must_have_a_next_method,
	      mustBeAMethodDiagnostic: Diagnostics.The_0_property_of_an_iterator_must_be_a_method,
	      mustHaveAValueDiagnostic: Diagnostics.The_type_returned_by_the_0_method_of_an_iterator_must_have_a_value_property
	    };
	    var amalgamatedDuplicates;
	    var reverseMappedCache = /* @__PURE__ */ new Map();
	    var homomorphicMappedTypeInferenceStack = [];
	    var ambientModulesCache;
	    var patternAmbientModules;
	    var patternAmbientModuleAugmentations;
	    var globalObjectType;
	    var globalFunctionType;
	    var globalCallableFunctionType;
	    var globalNewableFunctionType;
	    var globalArrayType;
	    var globalReadonlyArrayType;
	    var globalStringType;
	    var globalNumberType;
	    var globalBooleanType;
	    var globalRegExpType;
	    var globalThisType;
	    var anyArrayType;
	    var autoArrayType;
	    var anyReadonlyArrayType;
	    var deferredGlobalNonNullableTypeAlias;
	    var deferredGlobalESSymbolConstructorSymbol;
	    var deferredGlobalESSymbolConstructorTypeSymbol;
	    var deferredGlobalESSymbolType;
	    var deferredGlobalTypedPropertyDescriptorType;
	    var deferredGlobalPromiseType;
	    var deferredGlobalPromiseLikeType;
	    var deferredGlobalPromiseConstructorSymbol;
	    var deferredGlobalPromiseConstructorLikeType;
	    var deferredGlobalIterableType;
	    var deferredGlobalIteratorType;
	    var deferredGlobalIterableIteratorType;
	    var deferredGlobalGeneratorType;
	    var deferredGlobalIteratorYieldResultType;
	    var deferredGlobalIteratorReturnResultType;
	    var deferredGlobalAsyncIterableType;
	    var deferredGlobalAsyncIteratorType;
	    var deferredGlobalAsyncIterableIteratorType;
	    var deferredGlobalAsyncGeneratorType;
	    var deferredGlobalTemplateStringsArrayType;
	    var deferredGlobalImportMetaType;
	    var deferredGlobalImportMetaExpressionType;
	    var deferredGlobalImportCallOptionsType;
	    var deferredGlobalImportAttributesType;
	    var deferredGlobalDisposableType;
	    var deferredGlobalAsyncDisposableType;
	    var deferredGlobalExtractSymbol;
	    var deferredGlobalOmitSymbol;
	    var deferredGlobalAwaitedSymbol;
	    var deferredGlobalBigIntType;
	    var deferredGlobalNaNSymbol;
	    var deferredGlobalRecordSymbol;
	    var deferredGlobalClassDecoratorContextType;
	    var deferredGlobalClassMethodDecoratorContextType;
	    var deferredGlobalClassGetterDecoratorContextType;
	    var deferredGlobalClassSetterDecoratorContextType;
	    var deferredGlobalClassAccessorDecoratorContextType;
	    var deferredGlobalClassAccessorDecoratorTargetType;
	    var deferredGlobalClassAccessorDecoratorResultType;
	    var deferredGlobalClassFieldDecoratorContextType;
	    var allPotentiallyUnusedIdentifiers = /* @__PURE__ */ new Map();
	    var flowLoopStart = 0;
	    var flowLoopCount = 0;
	    var sharedFlowCount = 0;
	    var flowAnalysisDisabled = false;
	    var flowInvocationCount = 0;
	    var lastFlowNode;
	    var lastFlowNodeReachable;
	    var flowTypeCache;
	    var contextualTypeNodes = [];
	    var contextualTypes = [];
	    var contextualIsCache = [];
	    var contextualTypeCount = 0;
	    var inferenceContextNodes = [];
	    var inferenceContexts = [];
	    var inferenceContextCount = 0;
	    var emptyStringType = getStringLiteralType("");
	    var zeroType = getNumberLiteralType(0);
	    var zeroBigIntType = getBigIntLiteralType({ negative: false, base10Value: "0" });
	    var resolutionTargets = [];
	    var resolutionResults = [];
	    var resolutionPropertyNames = [];
	    var resolutionStart = 0;
	    var inVarianceComputation = false;
	    var suggestionCount = 0;
	    var maximumSuggestionCount = 10;
	    var mergedSymbols = [];
	    var symbolLinks = [];
	    var nodeLinks = [];
	    var flowLoopCaches = [];
	    var flowLoopNodes = [];
	    var flowLoopKeys = [];
	    var flowLoopTypes = [];
	    var sharedFlowNodes = [];
	    var sharedFlowTypes = [];
	    var flowNodeReachable = [];
	    var flowNodePostSuper = [];
	    var potentialThisCollisions = [];
	    var potentialNewTargetCollisions = [];
	    var potentialWeakMapSetCollisions = [];
	    var potentialReflectCollisions = [];
	    var potentialUnusedRenamedBindingElementsInTypes = [];
	    var awaitedTypeStack = [];
	    var diagnostics = createDiagnosticCollection();
	    var suggestionDiagnostics = createDiagnosticCollection();
	    var typeofType = createTypeofType();
	    var _jsxNamespace;
	    var _jsxFactoryEntity;
	    var subtypeRelation = /* @__PURE__ */ new Map();
	    var strictSubtypeRelation = /* @__PURE__ */ new Map();
	    var assignableRelation = /* @__PURE__ */ new Map();
	    var comparableRelation = /* @__PURE__ */ new Map();
	    var identityRelation = /* @__PURE__ */ new Map();
	    var enumRelation = /* @__PURE__ */ new Map();
	    var builtinGlobals = createSymbolTable();
	    builtinGlobals.set(undefinedSymbol.escapedName, undefinedSymbol);
	    var suggestedExtensions = [
	      [".mts", ".mjs"],
	      [".ts", ".js"],
	      [".cts", ".cjs"],
	      [".mjs", ".mjs"],
	      [".js", ".js"],
	      [".cjs", ".cjs"],
	      [".tsx", compilerOptions.jsx === 1 /* Preserve */ ? ".jsx" : ".js"],
	      [".jsx", ".jsx"],
	      [".json", ".json"]
	    ];
	    initializeTypeChecker();
	    return checker;
	    function getCachedType(key) {
	      return key ? cachedTypes.get(key) : void 0;
	    }
	    function setCachedType(key, type) {
	      if (key)
	        cachedTypes.set(key, type);
	      return type;
	    }
	    function getJsxNamespace(location) {
	      if (location) {
	        const file = getSourceFileOfNode(location);
	        if (file) {
	          if (isJsxOpeningFragment(location)) {
	            if (file.localJsxFragmentNamespace) {
	              return file.localJsxFragmentNamespace;
	            }
	            const jsxFragmentPragma = file.pragmas.get("jsxfrag");
	            if (jsxFragmentPragma) {
	              const chosenPragma = isArray(jsxFragmentPragma) ? jsxFragmentPragma[0] : jsxFragmentPragma;
	              file.localJsxFragmentFactory = parseIsolatedEntityName(chosenPragma.arguments.factory, languageVersion);
	              visitNode(file.localJsxFragmentFactory, markAsSynthetic, isEntityName);
	              if (file.localJsxFragmentFactory) {
	                return file.localJsxFragmentNamespace = getFirstIdentifier(file.localJsxFragmentFactory).escapedText;
	              }
	            }
	            const entity = getJsxFragmentFactoryEntity(location);
	            if (entity) {
	              file.localJsxFragmentFactory = entity;
	              return file.localJsxFragmentNamespace = getFirstIdentifier(entity).escapedText;
	            }
	          } else {
	            const localJsxNamespace = getLocalJsxNamespace(file);
	            if (localJsxNamespace) {
	              return file.localJsxNamespace = localJsxNamespace;
	            }
	          }
	        }
	      }
	      if (!_jsxNamespace) {
	        _jsxNamespace = "React";
	        if (compilerOptions.jsxFactory) {
	          _jsxFactoryEntity = parseIsolatedEntityName(compilerOptions.jsxFactory, languageVersion);
	          visitNode(_jsxFactoryEntity, markAsSynthetic);
	          if (_jsxFactoryEntity) {
	            _jsxNamespace = getFirstIdentifier(_jsxFactoryEntity).escapedText;
	          }
	        } else if (compilerOptions.reactNamespace) {
	          _jsxNamespace = escapeLeadingUnderscores(compilerOptions.reactNamespace);
	        }
	      }
	      if (!_jsxFactoryEntity) {
	        _jsxFactoryEntity = factory.createQualifiedName(factory.createIdentifier(unescapeLeadingUnderscores(_jsxNamespace)), "createElement");
	      }
	      return _jsxNamespace;
	    }
	    function getLocalJsxNamespace(file) {
	      if (file.localJsxNamespace) {
	        return file.localJsxNamespace;
	      }
	      const jsxPragma = file.pragmas.get("jsx");
	      if (jsxPragma) {
	        const chosenPragma = isArray(jsxPragma) ? jsxPragma[0] : jsxPragma;
	        file.localJsxFactory = parseIsolatedEntityName(chosenPragma.arguments.factory, languageVersion);
	        visitNode(file.localJsxFactory, markAsSynthetic, isEntityName);
	        if (file.localJsxFactory) {
	          return file.localJsxNamespace = getFirstIdentifier(file.localJsxFactory).escapedText;
	        }
	      }
	    }
	    function markAsSynthetic(node) {
	      setTextRangePosEnd(node, -1, -1);
	      return visitEachChild(
	        node,
	        markAsSynthetic,
	        /*context*/
	        void 0
	      );
	    }
	    function getEmitResolver(sourceFile, cancellationToken2) {
	      getDiagnostics2(sourceFile, cancellationToken2);
	      return emitResolver;
	    }
	    function lookupOrIssueError(location, message, ...args) {
	      const diagnostic = location ? createDiagnosticForNode(location, message, ...args) : createCompilerDiagnostic(message, ...args);
	      const existing = diagnostics.lookup(diagnostic);
	      if (existing) {
	        return existing;
	      } else {
	        diagnostics.add(diagnostic);
	        return diagnostic;
	      }
	    }
	    function errorSkippedOn(key, location, message, ...args) {
	      const diagnostic = error2(location, message, ...args);
	      diagnostic.skippedOn = key;
	      return diagnostic;
	    }
	    function createError(location, message, ...args) {
	      return location ? createDiagnosticForNode(location, message, ...args) : createCompilerDiagnostic(message, ...args);
	    }
	    function error2(location, message, ...args) {
	      const diagnostic = createError(location, message, ...args);
	      diagnostics.add(diagnostic);
	      return diagnostic;
	    }
	    function addErrorOrSuggestion(isError, diagnostic) {
	      if (isError) {
	        diagnostics.add(diagnostic);
	      } else {
	        suggestionDiagnostics.add({ ...diagnostic, category: 2 /* Suggestion */ });
	      }
	    }
	    function errorOrSuggestion(isError, location, message, ...args) {
	      if (location.pos < 0 || location.end < 0) {
	        if (!isError) {
	          return;
	        }
	        const file = getSourceFileOfNode(location);
	        addErrorOrSuggestion(isError, "message" in message ? createFileDiagnostic(file, 0, 0, message, ...args) : createDiagnosticForFileFromMessageChain(file, message));
	        return;
	      }
	      addErrorOrSuggestion(isError, "message" in message ? createDiagnosticForNode(location, message, ...args) : createDiagnosticForNodeFromMessageChain(getSourceFileOfNode(location), location, message));
	    }
	    function errorAndMaybeSuggestAwait(location, maybeMissingAwait, message, ...args) {
	      const diagnostic = error2(location, message, ...args);
	      if (maybeMissingAwait) {
	        const related = createDiagnosticForNode(location, Diagnostics.Did_you_forget_to_use_await);
	        addRelatedInfo(diagnostic, related);
	      }
	      return diagnostic;
	    }
	    function addDeprecatedSuggestionWorker(declarations, diagnostic) {
	      const deprecatedTag = Array.isArray(declarations) ? forEach(declarations, getJSDocDeprecatedTag) : getJSDocDeprecatedTag(declarations);
	      if (deprecatedTag) {
	        addRelatedInfo(
	          diagnostic,
	          createDiagnosticForNode(deprecatedTag, Diagnostics.The_declaration_was_marked_as_deprecated_here)
	        );
	      }
	      suggestionDiagnostics.add(diagnostic);
	      return diagnostic;
	    }
	    function isDeprecatedSymbol(symbol) {
	      const parentSymbol = getParentOfSymbol(symbol);
	      if (parentSymbol && length(symbol.declarations) > 1) {
	        return parentSymbol.flags & 64 /* Interface */ ? some(symbol.declarations, isDeprecatedDeclaration2) : every(symbol.declarations, isDeprecatedDeclaration2);
	      }
	      return !!symbol.valueDeclaration && isDeprecatedDeclaration2(symbol.valueDeclaration) || length(symbol.declarations) && every(symbol.declarations, isDeprecatedDeclaration2);
	    }
	    function isDeprecatedDeclaration2(declaration) {
	      return !!(getCombinedNodeFlagsCached(declaration) & 536870912 /* Deprecated */);
	    }
	    function addDeprecatedSuggestion(location, declarations, deprecatedEntity) {
	      const diagnostic = createDiagnosticForNode(location, Diagnostics._0_is_deprecated, deprecatedEntity);
	      return addDeprecatedSuggestionWorker(declarations, diagnostic);
	    }
	    function addDeprecatedSuggestionWithSignature(location, declaration, deprecatedEntity, signatureString) {
	      const diagnostic = deprecatedEntity ? createDiagnosticForNode(location, Diagnostics.The_signature_0_of_1_is_deprecated, signatureString, deprecatedEntity) : createDiagnosticForNode(location, Diagnostics._0_is_deprecated, signatureString);
	      return addDeprecatedSuggestionWorker(declaration, diagnostic);
	    }
	    function createSymbol(flags, name, checkFlags) {
	      symbolCount++;
	      const symbol = new Symbol47(flags | 33554432 /* Transient */, name);
	      symbol.links = new SymbolLinks();
	      symbol.links.checkFlags = checkFlags || 0 /* None */;
	      return symbol;
	    }
	    function createParameter2(name, type) {
	      const symbol = createSymbol(1 /* FunctionScopedVariable */, name);
	      symbol.links.type = type;
	      return symbol;
	    }
	    function createProperty(name, type) {
	      const symbol = createSymbol(4 /* Property */, name);
	      symbol.links.type = type;
	      return symbol;
	    }
	    function getExcludedSymbolFlags(flags) {
	      let result = 0;
	      if (flags & 2 /* BlockScopedVariable */)
	        result |= 111551 /* BlockScopedVariableExcludes */;
	      if (flags & 1 /* FunctionScopedVariable */)
	        result |= 111550 /* FunctionScopedVariableExcludes */;
	      if (flags & 4 /* Property */)
	        result |= 0 /* PropertyExcludes */;
	      if (flags & 8 /* EnumMember */)
	        result |= 900095 /* EnumMemberExcludes */;
	      if (flags & 16 /* Function */)
	        result |= 110991 /* FunctionExcludes */;
	      if (flags & 32 /* Class */)
	        result |= 899503 /* ClassExcludes */;
	      if (flags & 64 /* Interface */)
	        result |= 788872 /* InterfaceExcludes */;
	      if (flags & 256 /* RegularEnum */)
	        result |= 899327 /* RegularEnumExcludes */;
	      if (flags & 128 /* ConstEnum */)
	        result |= 899967 /* ConstEnumExcludes */;
	      if (flags & 512 /* ValueModule */)
	        result |= 110735 /* ValueModuleExcludes */;
	      if (flags & 8192 /* Method */)
	        result |= 103359 /* MethodExcludes */;
	      if (flags & 32768 /* GetAccessor */)
	        result |= 46015 /* GetAccessorExcludes */;
	      if (flags & 65536 /* SetAccessor */)
	        result |= 78783 /* SetAccessorExcludes */;
	      if (flags & 262144 /* TypeParameter */)
	        result |= 526824 /* TypeParameterExcludes */;
	      if (flags & 524288 /* TypeAlias */)
	        result |= 788968 /* TypeAliasExcludes */;
	      if (flags & 2097152 /* Alias */)
	        result |= 2097152 /* AliasExcludes */;
	      return result;
	    }
	    function recordMergedSymbol(target, source) {
	      if (!source.mergeId) {
	        source.mergeId = nextMergeId;
	        nextMergeId++;
	      }
	      mergedSymbols[source.mergeId] = target;
	    }
	    function cloneSymbol(symbol) {
	      const result = createSymbol(symbol.flags, symbol.escapedName);
	      result.declarations = symbol.declarations ? symbol.declarations.slice() : [];
	      result.parent = symbol.parent;
	      if (symbol.valueDeclaration)
	        result.valueDeclaration = symbol.valueDeclaration;
	      if (symbol.constEnumOnlyModule)
	        result.constEnumOnlyModule = true;
	      if (symbol.members)
	        result.members = new Map(symbol.members);
	      if (symbol.exports)
	        result.exports = new Map(symbol.exports);
	      recordMergedSymbol(result, symbol);
	      return result;
	    }
	    function mergeSymbol(target, source, unidirectional = false) {
	      if (!(target.flags & getExcludedSymbolFlags(source.flags)) || (source.flags | target.flags) & 67108864 /* Assignment */) {
	        if (source === target) {
	          return target;
	        }
	        if (!(target.flags & 33554432 /* Transient */)) {
	          const resolvedTarget = resolveSymbol(target);
	          if (resolvedTarget === unknownSymbol) {
	            return source;
	          }
	          target = cloneSymbol(resolvedTarget);
	        }
	        if (source.flags & 512 /* ValueModule */ && target.flags & 512 /* ValueModule */ && target.constEnumOnlyModule && !source.constEnumOnlyModule) {
	          target.constEnumOnlyModule = false;
	        }
	        target.flags |= source.flags;
	        if (source.valueDeclaration) {
	          setValueDeclaration(target, source.valueDeclaration);
	        }
	        addRange(target.declarations, source.declarations);
	        if (source.members) {
	          if (!target.members)
	            target.members = createSymbolTable();
	          mergeSymbolTable(target.members, source.members, unidirectional);
	        }
	        if (source.exports) {
	          if (!target.exports)
	            target.exports = createSymbolTable();
	          mergeSymbolTable(target.exports, source.exports, unidirectional);
	        }
	        if (!unidirectional) {
	          recordMergedSymbol(target, source);
	        }
	      } else if (target.flags & 1024 /* NamespaceModule */) {
	        if (target !== globalThisSymbol) {
	          error2(
	            source.declarations && getNameOfDeclaration(source.declarations[0]),
	            Diagnostics.Cannot_augment_module_0_with_value_exports_because_it_resolves_to_a_non_module_entity,
	            symbolToString(target)
	          );
	        }
	      } else {
	        const isEitherEnum = !!(target.flags & 384 /* Enum */ || source.flags & 384 /* Enum */);
	        const isEitherBlockScoped = !!(target.flags & 2 /* BlockScopedVariable */ || source.flags & 2 /* BlockScopedVariable */);
	        const message = isEitherEnum ? Diagnostics.Enum_declarations_can_only_merge_with_namespace_or_other_enum_declarations : isEitherBlockScoped ? Diagnostics.Cannot_redeclare_block_scoped_variable_0 : Diagnostics.Duplicate_identifier_0;
	        const sourceSymbolFile = source.declarations && getSourceFileOfNode(source.declarations[0]);
	        const targetSymbolFile = target.declarations && getSourceFileOfNode(target.declarations[0]);
	        const isSourcePlainJs = isPlainJsFile(sourceSymbolFile, compilerOptions.checkJs);
	        const isTargetPlainJs = isPlainJsFile(targetSymbolFile, compilerOptions.checkJs);
	        const symbolName2 = symbolToString(source);
	        if (sourceSymbolFile && targetSymbolFile && amalgamatedDuplicates && !isEitherEnum && sourceSymbolFile !== targetSymbolFile) {
	          const firstFile = comparePaths(sourceSymbolFile.path, targetSymbolFile.path) === -1 /* LessThan */ ? sourceSymbolFile : targetSymbolFile;
	          const secondFile = firstFile === sourceSymbolFile ? targetSymbolFile : sourceSymbolFile;
	          const filesDuplicates = getOrUpdate(amalgamatedDuplicates, `${firstFile.path}|${secondFile.path}`, () => ({ firstFile, secondFile, conflictingSymbols: /* @__PURE__ */ new Map() }));
	          const conflictingSymbolInfo = getOrUpdate(filesDuplicates.conflictingSymbols, symbolName2, () => ({ isBlockScoped: isEitherBlockScoped, firstFileLocations: [], secondFileLocations: [] }));
	          if (!isSourcePlainJs)
	            addDuplicateLocations(conflictingSymbolInfo.firstFileLocations, source);
	          if (!isTargetPlainJs)
	            addDuplicateLocations(conflictingSymbolInfo.secondFileLocations, target);
	        } else {
	          if (!isSourcePlainJs)
	            addDuplicateDeclarationErrorsForSymbols(source, message, symbolName2, target);
	          if (!isTargetPlainJs)
	            addDuplicateDeclarationErrorsForSymbols(target, message, symbolName2, source);
	        }
	      }
	      return target;
	      function addDuplicateLocations(locs, symbol) {
	        if (symbol.declarations) {
	          for (const decl of symbol.declarations) {
	            pushIfUnique(locs, decl);
	          }
	        }
	      }
	    }
	    function addDuplicateDeclarationErrorsForSymbols(target, message, symbolName2, source) {
	      forEach(target.declarations, (node) => {
	        addDuplicateDeclarationError(node, message, symbolName2, source.declarations);
	      });
	    }
	    function addDuplicateDeclarationError(node, message, symbolName2, relatedNodes) {
	      const errorNode = (getExpandoInitializer(
	        node,
	        /*isPrototypeAssignment*/
	        false
	      ) ? getNameOfExpando(node) : getNameOfDeclaration(node)) || node;
	      const err = lookupOrIssueError(errorNode, message, symbolName2);
	      for (const relatedNode of relatedNodes || emptyArray) {
	        const adjustedNode = (getExpandoInitializer(
	          relatedNode,
	          /*isPrototypeAssignment*/
	          false
	        ) ? getNameOfExpando(relatedNode) : getNameOfDeclaration(relatedNode)) || relatedNode;
	        if (adjustedNode === errorNode)
	          continue;
	        err.relatedInformation = err.relatedInformation || [];
	        const leadingMessage = createDiagnosticForNode(adjustedNode, Diagnostics._0_was_also_declared_here, symbolName2);
	        const followOnMessage = createDiagnosticForNode(adjustedNode, Diagnostics.and_here);
	        if (length(err.relatedInformation) >= 5 || some(err.relatedInformation, (r) => compareDiagnostics(r, followOnMessage) === 0 /* EqualTo */ || compareDiagnostics(r, leadingMessage) === 0 /* EqualTo */))
	          continue;
	        addRelatedInfo(err, !length(err.relatedInformation) ? leadingMessage : followOnMessage);
	      }
	    }
	    function combineSymbolTables(first2, second) {
	      if (!(first2 == null ? void 0 : first2.size))
	        return second;
	      if (!(second == null ? void 0 : second.size))
	        return first2;
	      const combined = createSymbolTable();
	      mergeSymbolTable(combined, first2);
	      mergeSymbolTable(combined, second);
	      return combined;
	    }
	    function mergeSymbolTable(target, source, unidirectional = false) {
	      source.forEach((sourceSymbol, id) => {
	        const targetSymbol = target.get(id);
	        target.set(id, targetSymbol ? mergeSymbol(targetSymbol, sourceSymbol, unidirectional) : getMergedSymbol(sourceSymbol));
	      });
	    }
	    function mergeModuleAugmentation(moduleName) {
	      var _a, _b, _c;
	      const moduleAugmentation = moduleName.parent;
	      if (((_a = moduleAugmentation.symbol.declarations) == null ? void 0 : _a[0]) !== moduleAugmentation) {
	        Debug.assert(moduleAugmentation.symbol.declarations.length > 1);
	        return;
	      }
	      if (isGlobalScopeAugmentation(moduleAugmentation)) {
	        mergeSymbolTable(globals, moduleAugmentation.symbol.exports);
	      } else {
	        const moduleNotFoundError = !(moduleName.parent.parent.flags & 33554432 /* Ambient */) ? Diagnostics.Invalid_module_name_in_augmentation_module_0_cannot_be_found : void 0;
	        let mainModule = resolveExternalModuleNameWorker(
	          moduleName,
	          moduleName,
	          moduleNotFoundError,
	          /*isForAugmentation*/
	          true
	        );
	        if (!mainModule) {
	          return;
	        }
	        mainModule = resolveExternalModuleSymbol(mainModule);
	        if (mainModule.flags & 1920 /* Namespace */) {
	          if (some(patternAmbientModules, (module2) => mainModule === module2.symbol)) {
	            const merged = mergeSymbol(
	              moduleAugmentation.symbol,
	              mainModule,
	              /*unidirectional*/
	              true
	            );
	            if (!patternAmbientModuleAugmentations) {
	              patternAmbientModuleAugmentations = /* @__PURE__ */ new Map();
	            }
	            patternAmbientModuleAugmentations.set(moduleName.text, merged);
	          } else {
	            if (((_b = mainModule.exports) == null ? void 0 : _b.get("__export" /* ExportStar */)) && ((_c = moduleAugmentation.symbol.exports) == null ? void 0 : _c.size)) {
	              const resolvedExports = getResolvedMembersOrExportsOfSymbol(mainModule, "resolvedExports" /* resolvedExports */);
	              for (const [key, value] of arrayFrom(moduleAugmentation.symbol.exports.entries())) {
	                if (resolvedExports.has(key) && !mainModule.exports.has(key)) {
	                  mergeSymbol(resolvedExports.get(key), value);
	                }
	              }
	            }
	            mergeSymbol(mainModule, moduleAugmentation.symbol);
	          }
	        } else {
	          error2(moduleName, Diagnostics.Cannot_augment_module_0_because_it_resolves_to_a_non_module_entity, moduleName.text);
	        }
	      }
	    }
	    function addToSymbolTable(target, source, message) {
	      source.forEach((sourceSymbol, id) => {
	        const targetSymbol = target.get(id);
	        if (targetSymbol) {
	          forEach(targetSymbol.declarations, addDeclarationDiagnostic(unescapeLeadingUnderscores(id), message));
	        } else {
	          target.set(id, sourceSymbol);
	        }
	      });
	      function addDeclarationDiagnostic(id, message2) {
	        return (declaration) => diagnostics.add(createDiagnosticForNode(declaration, message2, id));
	      }
	    }
	    function getSymbolLinks(symbol) {
	      if (symbol.flags & 33554432 /* Transient */)
	        return symbol.links;
	      const id = getSymbolId(symbol);
	      return symbolLinks[id] ?? (symbolLinks[id] = new SymbolLinks());
	    }
	    function getNodeLinks(node) {
	      const nodeId = getNodeId(node);
	      return nodeLinks[nodeId] || (nodeLinks[nodeId] = new NodeLinks());
	    }
	    function isGlobalSourceFile(node) {
	      return node.kind === 312 /* SourceFile */ && !isExternalOrCommonJsModule(node);
	    }
	    function getSymbol2(symbols, name, meaning) {
	      if (meaning) {
	        const symbol = getMergedSymbol(symbols.get(name));
	        if (symbol) {
	          Debug.assert((getCheckFlags(symbol) & 1 /* Instantiated */) === 0, "Should never get an instantiated symbol here.");
	          if (symbol.flags & meaning) {
	            return symbol;
	          }
	          if (symbol.flags & 2097152 /* Alias */) {
	            const targetFlags = getSymbolFlags(symbol);
	            if (targetFlags & meaning) {
	              return symbol;
	            }
	          }
	        }
	      }
	    }
	    function getSymbolsOfParameterPropertyDeclaration(parameter, parameterName) {
	      const constructorDeclaration = parameter.parent;
	      const classDeclaration = parameter.parent.parent;
	      const parameterSymbol = getSymbol2(constructorDeclaration.locals, parameterName, 111551 /* Value */);
	      const propertySymbol = getSymbol2(getMembersOfSymbol(classDeclaration.symbol), parameterName, 111551 /* Value */);
	      if (parameterSymbol && propertySymbol) {
	        return [parameterSymbol, propertySymbol];
	      }
	      return Debug.fail("There should exist two symbols, one as property declaration and one as parameter declaration");
	    }
	    function isBlockScopedNameDeclaredBeforeUse(declaration, usage) {
	      const declarationFile = getSourceFileOfNode(declaration);
	      const useFile = getSourceFileOfNode(usage);
	      const declContainer = getEnclosingBlockScopeContainer(declaration);
	      if (declarationFile !== useFile) {
	        if (moduleKind && (declarationFile.externalModuleIndicator || useFile.externalModuleIndicator) || !outFile(compilerOptions) || isInTypeQuery(usage) || declaration.flags & 33554432 /* Ambient */) {
	          return true;
	        }
	        if (isUsedInFunctionOrInstanceProperty(usage, declaration)) {
	          return true;
	        }
	        const sourceFiles = host.getSourceFiles();
	        return sourceFiles.indexOf(declarationFile) <= sourceFiles.indexOf(useFile);
	      }
	      if (!!(usage.flags & 16777216 /* JSDoc */) || isInTypeQuery(usage) || isInAmbientOrTypeNode(usage)) {
	        return true;
	      }
	      if (declaration.pos <= usage.pos && !(isPropertyDeclaration(declaration) && isThisProperty(usage.parent) && !declaration.initializer && !declaration.exclamationToken)) {
	        if (declaration.kind === 208 /* BindingElement */) {
	          const errorBindingElement = getAncestor(usage, 208 /* BindingElement */);
	          if (errorBindingElement) {
	            return findAncestor(errorBindingElement, isBindingElement) !== findAncestor(declaration, isBindingElement) || declaration.pos < errorBindingElement.pos;
	          }
	          return isBlockScopedNameDeclaredBeforeUse(getAncestor(declaration, 260 /* VariableDeclaration */), usage);
	        } else if (declaration.kind === 260 /* VariableDeclaration */) {
	          return !isImmediatelyUsedInInitializerOfBlockScopedVariable(declaration, usage);
	        } else if (isClassLike(declaration)) {
	          return !findAncestor(usage, (n) => isComputedPropertyName(n) && n.parent.parent === declaration);
	        } else if (isPropertyDeclaration(declaration)) {
	          return !isPropertyImmediatelyReferencedWithinDeclaration(
	            declaration,
	            usage,
	            /*stopAtAnyPropertyDeclaration*/
	            false
	          );
	        } else if (isParameterPropertyDeclaration(declaration, declaration.parent)) {
	          return !(emitStandardClassFields && getContainingClass(declaration) === getContainingClass(usage) && isUsedInFunctionOrInstanceProperty(usage, declaration));
	        }
	        return true;
	      }
	      if (usage.parent.kind === 281 /* ExportSpecifier */ || usage.parent.kind === 277 /* ExportAssignment */ && usage.parent.isExportEquals) {
	        return true;
	      }
	      if (usage.kind === 277 /* ExportAssignment */ && usage.isExportEquals) {
	        return true;
	      }
	      if (isUsedInFunctionOrInstanceProperty(usage, declaration)) {
	        if (emitStandardClassFields && getContainingClass(declaration) && (isPropertyDeclaration(declaration) || isParameterPropertyDeclaration(declaration, declaration.parent))) {
	          return !isPropertyImmediatelyReferencedWithinDeclaration(
	            declaration,
	            usage,
	            /*stopAtAnyPropertyDeclaration*/
	            true
	          );
	        } else {
	          return true;
	        }
	      }
	      return false;
	      function isImmediatelyUsedInInitializerOfBlockScopedVariable(declaration2, usage2) {
	        switch (declaration2.parent.parent.kind) {
	          case 243 /* VariableStatement */:
	          case 248 /* ForStatement */:
	          case 250 /* ForOfStatement */:
	            if (isSameScopeDescendentOf(usage2, declaration2, declContainer)) {
	              return true;
	            }
	            break;
	        }
	        const grandparent = declaration2.parent.parent;
	        return isForInOrOfStatement(grandparent) && isSameScopeDescendentOf(usage2, grandparent.expression, declContainer);
	      }
	      function isUsedInFunctionOrInstanceProperty(usage2, declaration2) {
	        return !!findAncestor(usage2, (current) => {
	          if (current === declContainer) {
	            return "quit";
	          }
	          if (isFunctionLike(current)) {
	            return true;
	          }
	          if (isClassStaticBlockDeclaration(current)) {
	            return declaration2.pos < usage2.pos;
	          }
	          const propertyDeclaration = tryCast(current.parent, isPropertyDeclaration);
	          if (propertyDeclaration) {
	            const initializerOfProperty = propertyDeclaration.initializer === current;
	            if (initializerOfProperty) {
	              if (isStatic(current.parent)) {
	                if (declaration2.kind === 174 /* MethodDeclaration */) {
	                  return true;
	                }
	                if (isPropertyDeclaration(declaration2) && getContainingClass(usage2) === getContainingClass(declaration2)) {
	                  const propName = declaration2.name;
	                  if (isIdentifier(propName) || isPrivateIdentifier(propName)) {
	                    const type = getTypeOfSymbol(getSymbolOfDeclaration(declaration2));
	                    const staticBlocks = filter(declaration2.parent.members, isClassStaticBlockDeclaration);
	                    if (isPropertyInitializedInStaticBlocks(propName, type, staticBlocks, declaration2.parent.pos, current.pos)) {
	                      return true;
	                    }
	                  }
	                }
	              } else {
	                const isDeclarationInstanceProperty = declaration2.kind === 172 /* PropertyDeclaration */ && !isStatic(declaration2);
	                if (!isDeclarationInstanceProperty || getContainingClass(usage2) !== getContainingClass(declaration2)) {
	                  return true;
	                }
	              }
	            }
	          }
	          return false;
	        });
	      }
	      function isPropertyImmediatelyReferencedWithinDeclaration(declaration2, usage2, stopAtAnyPropertyDeclaration) {
	        if (usage2.end > declaration2.end) {
	          return false;
	        }
	        const ancestorChangingReferenceScope = findAncestor(usage2, (node) => {
	          if (node === declaration2) {
	            return "quit";
	          }
	          switch (node.kind) {
	            case 219 /* ArrowFunction */:
	              return true;
	            case 172 /* PropertyDeclaration */:
	              return stopAtAnyPropertyDeclaration && (isPropertyDeclaration(declaration2) && node.parent === declaration2.parent || isParameterPropertyDeclaration(declaration2, declaration2.parent) && node.parent === declaration2.parent.parent) ? "quit" : true;
	            case 241 /* Block */:
	              switch (node.parent.kind) {
	                case 177 /* GetAccessor */:
	                case 174 /* MethodDeclaration */:
	                case 178 /* SetAccessor */:
	                  return true;
	                default:
	                  return false;
	              }
	            default:
	              return false;
	          }
	        });
	        return ancestorChangingReferenceScope === void 0;
	      }
	    }
	    function useOuterVariableScopeInParameter(result, location, lastLocation) {
	      const target = getEmitScriptTarget(compilerOptions);
	      const functionLocation = location;
	      if (isParameter(lastLocation) && functionLocation.body && result.valueDeclaration && result.valueDeclaration.pos >= functionLocation.body.pos && result.valueDeclaration.end <= functionLocation.body.end) {
	        if (target >= 2 /* ES2015 */) {
	          const links = getNodeLinks(functionLocation);
	          if (links.declarationRequiresScopeChange === void 0) {
	            links.declarationRequiresScopeChange = forEach(functionLocation.parameters, requiresScopeChange) || false;
	          }
	          return !links.declarationRequiresScopeChange;
	        }
	      }
	      return false;
	      function requiresScopeChange(node) {
	        return requiresScopeChangeWorker(node.name) || !!node.initializer && requiresScopeChangeWorker(node.initializer);
	      }
	      function requiresScopeChangeWorker(node) {
	        switch (node.kind) {
	          case 219 /* ArrowFunction */:
	          case 218 /* FunctionExpression */:
	          case 262 /* FunctionDeclaration */:
	          case 176 /* Constructor */:
	            return false;
	          case 174 /* MethodDeclaration */:
	          case 177 /* GetAccessor */:
	          case 178 /* SetAccessor */:
	          case 303 /* PropertyAssignment */:
	            return requiresScopeChangeWorker(node.name);
	          case 172 /* PropertyDeclaration */:
	            if (hasStaticModifier(node)) {
	              return !emitStandardClassFields;
	            }
	            return requiresScopeChangeWorker(node.name);
	          default:
	            if (isNullishCoalesce(node) || isOptionalChain(node)) {
	              return target < 7 /* ES2020 */;
	            }
	            if (isBindingElement(node) && node.dotDotDotToken && isObjectBindingPattern(node.parent)) {
	              return target < 4 /* ES2017 */;
	            }
	            if (isTypeNode(node))
	              return false;
	            return forEachChild(node, requiresScopeChangeWorker) || false;
	        }
	      }
	    }
	    function isConstAssertion(location) {
	      return isAssertionExpression(location) && isConstTypeReference(location.type) || isJSDocTypeTag(location) && isConstTypeReference(location.typeExpression);
	    }
	    function resolveName(location, name, meaning, nameNotFoundMessage, nameArg, isUse, excludeGlobals = false, getSpellingSuggestions = true) {
	      return resolveNameHelper(location, name, meaning, nameNotFoundMessage, nameArg, isUse, excludeGlobals, getSpellingSuggestions, getSymbol2);
	    }
	    function resolveNameHelper(location, name, meaning, nameNotFoundMessage, nameArg, isUse, excludeGlobals, getSpellingSuggestions, lookup) {
	      var _a, _b, _c;
	      const originalLocation = location;
	      let result;
	      let lastLocation;
	      let lastSelfReferenceLocation;
	      let propertyWithInvalidInitializer;
	      let associatedDeclarationForContainingInitializerOrBindingName;
	      let withinDeferredContext = false;
	      const errorLocation = location;
	      let grandparent;
	      let isInExternalModule = false;
	      loop:
	        while (location) {
	          if (name === "const" && isConstAssertion(location)) {
	            return void 0;
	          }
	          if (isModuleOrEnumDeclaration(location) && lastLocation && location.name === lastLocation) {
	            lastLocation = location;
	            location = location.parent;
	          }
	          if (canHaveLocals(location) && location.locals && !isGlobalSourceFile(location)) {
	            if (result = lookup(location.locals, name, meaning)) {
	              let useResult = true;
	              if (isFunctionLike(location) && lastLocation && lastLocation !== location.body) {
	                if (meaning & result.flags & 788968 /* Type */ && lastLocation.kind !== 327 /* JSDoc */) {
	                  useResult = result.flags & 262144 /* TypeParameter */ ? lastLocation === location.type || lastLocation.kind === 169 /* Parameter */ || lastLocation.kind === 348 /* JSDocParameterTag */ || lastLocation.kind === 349 /* JSDocReturnTag */ || lastLocation.kind === 168 /* TypeParameter */ : false;
	                }
	                if (meaning & result.flags & 3 /* Variable */) {
	                  if (useOuterVariableScopeInParameter(result, location, lastLocation)) {
	                    useResult = false;
	                  } else if (result.flags & 1 /* FunctionScopedVariable */) {
	                    useResult = lastLocation.kind === 169 /* Parameter */ || lastLocation === location.type && !!findAncestor(result.valueDeclaration, isParameter);
	                  }
	                }
	              } else if (location.kind === 194 /* ConditionalType */) {
	                useResult = lastLocation === location.trueType;
	              }
	              if (useResult) {
	                break loop;
	              } else {
	                result = void 0;
	              }
	            }
	          }
	          withinDeferredContext = withinDeferredContext || getIsDeferredContext(location, lastLocation);
	          switch (location.kind) {
	            case 312 /* SourceFile */:
	              if (!isExternalOrCommonJsModule(location))
	                break;
	              isInExternalModule = true;
	            case 267 /* ModuleDeclaration */:
	              const moduleExports = ((_a = getSymbolOfDeclaration(location)) == null ? void 0 : _a.exports) || emptySymbols;
	              if (location.kind === 312 /* SourceFile */ || isModuleDeclaration(location) && location.flags & 33554432 /* Ambient */ && !isGlobalScopeAugmentation(location)) {
	                if (result = moduleExports.get("default" /* Default */)) {
	                  const localSymbol = getLocalSymbolForExportDefault(result);
	                  if (localSymbol && result.flags & meaning && localSymbol.escapedName === name) {
	                    break loop;
	                  }
	                  result = void 0;
	                }
	                const moduleExport = moduleExports.get(name);
	                if (moduleExport && moduleExport.flags === 2097152 /* Alias */ && (getDeclarationOfKind(moduleExport, 281 /* ExportSpecifier */) || getDeclarationOfKind(moduleExport, 280 /* NamespaceExport */))) {
	                  break;
	                }
	              }
	              if (name !== "default" /* Default */ && (result = lookup(moduleExports, name, meaning & 2623475 /* ModuleMember */))) {
	                if (isSourceFile(location) && location.commonJsModuleIndicator && !((_b = result.declarations) == null ? void 0 : _b.some(isJSDocTypeAlias))) {
	                  result = void 0;
	                } else {
	                  break loop;
	                }
	              }
	              break;
	            case 266 /* EnumDeclaration */:
	              if (result = lookup(((_c = getSymbolOfDeclaration(location)) == null ? void 0 : _c.exports) || emptySymbols, name, meaning & 8 /* EnumMember */)) {
	                if (nameNotFoundMessage && getIsolatedModules(compilerOptions) && !(location.flags & 33554432 /* Ambient */) && getSourceFileOfNode(location) !== getSourceFileOfNode(result.valueDeclaration)) {
	                  error2(
	                    errorLocation,
	                    Diagnostics.Cannot_access_0_from_another_file_without_qualification_when_1_is_enabled_Use_2_instead,
	                    unescapeLeadingUnderscores(name),
	                    isolatedModulesLikeFlagName,
	                    `${unescapeLeadingUnderscores(getSymbolOfNode(location).escapedName)}.${unescapeLeadingUnderscores(name)}`
	                  );
	                }
	                break loop;
	              }
	              break;
	            case 172 /* PropertyDeclaration */:
	              if (!isStatic(location)) {
	                const ctor = findConstructorDeclaration(location.parent);
	                if (ctor && ctor.locals) {
	                  if (lookup(ctor.locals, name, meaning & 111551 /* Value */)) {
	                    Debug.assertNode(location, isPropertyDeclaration);
	                    propertyWithInvalidInitializer = location;
	                  }
	                }
	              }
	              break;
	            case 263 /* ClassDeclaration */:
	            case 231 /* ClassExpression */:
	            case 264 /* InterfaceDeclaration */:
	              if (result = lookup(getSymbolOfDeclaration(location).members || emptySymbols, name, meaning & 788968 /* Type */)) {
	                if (!isTypeParameterSymbolDeclaredInContainer(result, location)) {
	                  result = void 0;
	                  break;
	                }
	                if (lastLocation && isStatic(lastLocation)) {
	                  if (nameNotFoundMessage) {
	                    error2(errorLocation, Diagnostics.Static_members_cannot_reference_class_type_parameters);
	                  }
	                  return void 0;
	                }
	                break loop;
	              }
	              if (isClassExpression(location) && meaning & 32 /* Class */) {
	                const className = location.name;
	                if (className && name === className.escapedText) {
	                  result = location.symbol;
	                  break loop;
	                }
	              }
	              break;
	            case 233 /* ExpressionWithTypeArguments */:
	              if (lastLocation === location.expression && location.parent.token === 96 /* ExtendsKeyword */) {
	                const container = location.parent.parent;
	                if (isClassLike(container) && (result = lookup(getSymbolOfDeclaration(container).members, name, meaning & 788968 /* Type */))) {
	                  if (nameNotFoundMessage) {
	                    error2(errorLocation, Diagnostics.Base_class_expressions_cannot_reference_class_type_parameters);
	                  }
	                  return void 0;
	                }
	              }
	              break;
	            case 167 /* ComputedPropertyName */:
	              grandparent = location.parent.parent;
	              if (isClassLike(grandparent) || grandparent.kind === 264 /* InterfaceDeclaration */) {
	                if (result = lookup(getSymbolOfDeclaration(grandparent).members, name, meaning & 788968 /* Type */)) {
	                  if (nameNotFoundMessage) {
	                    error2(errorLocation, Diagnostics.A_computed_property_name_cannot_reference_a_type_parameter_from_its_containing_type);
	                  }
	                  return void 0;
	                }
	              }
	              break;
	            case 219 /* ArrowFunction */:
	              if (getEmitScriptTarget(compilerOptions) >= 2 /* ES2015 */) {
	                break;
	              }
	            case 174 /* MethodDeclaration */:
	            case 176 /* Constructor */:
	            case 177 /* GetAccessor */:
	            case 178 /* SetAccessor */:
	            case 262 /* FunctionDeclaration */:
	              if (meaning & 3 /* Variable */ && name === "arguments") {
	                result = argumentsSymbol;
	                break loop;
	              }
	              break;
	            case 218 /* FunctionExpression */:
	              if (meaning & 3 /* Variable */ && name === "arguments") {
	                result = argumentsSymbol;
	                break loop;
	              }
	              if (meaning & 16 /* Function */) {
	                const functionName = location.name;
	                if (functionName && name === functionName.escapedText) {
	                  result = location.symbol;
	                  break loop;
	                }
	              }
	              break;
	            case 170 /* Decorator */:
	              if (location.parent && location.parent.kind === 169 /* Parameter */) {
	                location = location.parent;
	              }
	              if (location.parent && (isClassElement(location.parent) || location.parent.kind === 263 /* ClassDeclaration */)) {
	                location = location.parent;
	              }
	              break;
	            case 353 /* JSDocTypedefTag */:
	            case 345 /* JSDocCallbackTag */:
	            case 347 /* JSDocEnumTag */:
	              const root = getJSDocRoot(location);
	              if (root) {
	                location = root.parent;
	              }
	              break;
	            case 169 /* Parameter */:
	              if (lastLocation && (lastLocation === location.initializer || lastLocation === location.name && isBindingPattern(lastLocation))) {
	                if (!associatedDeclarationForContainingInitializerOrBindingName) {
	                  associatedDeclarationForContainingInitializerOrBindingName = location;
	                }
	              }
	              break;
	            case 208 /* BindingElement */:
	              if (lastLocation && (lastLocation === location.initializer || lastLocation === location.name && isBindingPattern(lastLocation))) {
	                if (isParameterDeclaration(location) && !associatedDeclarationForContainingInitializerOrBindingName) {
	                  associatedDeclarationForContainingInitializerOrBindingName = location;
	                }
	              }
	              break;
	            case 195 /* InferType */:
	              if (meaning & 262144 /* TypeParameter */) {
	                const parameterName = location.typeParameter.name;
	                if (parameterName && name === parameterName.escapedText) {
	                  result = location.typeParameter.symbol;
	                  break loop;
	                }
	              }
	              break;
	            case 281 /* ExportSpecifier */:
	              if (lastLocation && lastLocation === location.propertyName && location.parent.parent.moduleSpecifier) {
	                location = location.parent.parent.parent;
	              }
	              break;
	          }
	          if (isSelfReferenceLocation(location)) {
	            lastSelfReferenceLocation = location;
	          }
	          lastLocation = location;
	          location = isJSDocTemplateTag(location) ? getEffectiveContainerForJSDocTemplateTag(location) || location.parent : isJSDocParameterTag(location) || isJSDocReturnTag(location) ? getHostSignatureFromJSDoc(location) || location.parent : location.parent;
	        }
	      if (isUse && result && (!lastSelfReferenceLocation || result !== lastSelfReferenceLocation.symbol)) {
	        result.isReferenced |= meaning;
	      }
	      if (!result) {
	        if (lastLocation) {
	          Debug.assertNode(lastLocation, isSourceFile);
	          if (lastLocation.commonJsModuleIndicator && name === "exports" && meaning & lastLocation.symbol.flags) {
	            return lastLocation.symbol;
	          }
	        }
	        if (!excludeGlobals) {
	          result = lookup(globals, name, meaning);
	        }
	      }
	      if (!result) {
	        if (originalLocation && isInJSFile(originalLocation) && originalLocation.parent) {
	          if (isRequireCall(
	            originalLocation.parent,
	            /*requireStringLiteralLikeArgument*/
	            false
	          )) {
	            return requireSymbol;
	          }
	        }
	      }
	      function checkAndReportErrorForInvalidInitializer() {
	        if (propertyWithInvalidInitializer && !emitStandardClassFields) {
	          error2(
	            errorLocation,
	            errorLocation && propertyWithInvalidInitializer.type && textRangeContainsPositionInclusive(propertyWithInvalidInitializer.type, errorLocation.pos) ? Diagnostics.Type_of_instance_member_variable_0_cannot_reference_identifier_1_declared_in_the_constructor : Diagnostics.Initializer_of_instance_member_variable_0_cannot_reference_identifier_1_declared_in_the_constructor,
	            declarationNameToString(propertyWithInvalidInitializer.name),
	            diagnosticName(nameArg)
	          );
	          return true;
	        }
	        return false;
	      }
	      if (!result) {
	        if (nameNotFoundMessage) {
	          addLazyDiagnostic(() => {
	            if (!errorLocation || errorLocation.parent.kind !== 331 /* JSDocLink */ && !checkAndReportErrorForMissingPrefix(errorLocation, name, nameArg) && // TODO: GH#18217
	            !checkAndReportErrorForInvalidInitializer() && !checkAndReportErrorForExtendingInterface(errorLocation) && !checkAndReportErrorForUsingTypeAsNamespace(errorLocation, name, meaning) && !checkAndReportErrorForExportingPrimitiveType(errorLocation, name) && !checkAndReportErrorForUsingNamespaceAsTypeOrValue(errorLocation, name, meaning) && !checkAndReportErrorForUsingTypeAsValue(errorLocation, name, meaning) && !checkAndReportErrorForUsingValueAsType(errorLocation, name, meaning)) {
	              let suggestion;
	              let suggestedLib;
	              if (nameArg) {
	                suggestedLib = getSuggestedLibForNonExistentName(nameArg);
	                if (suggestedLib) {
	                  error2(errorLocation, nameNotFoundMessage, diagnosticName(nameArg), suggestedLib);
	                }
	              }
	              if (!suggestedLib && getSpellingSuggestions && suggestionCount < maximumSuggestionCount) {
	                suggestion = getSuggestedSymbolForNonexistentSymbol(originalLocation, name, meaning);
	                const isGlobalScopeAugmentationDeclaration = (suggestion == null ? void 0 : suggestion.valueDeclaration) && isAmbientModule(suggestion.valueDeclaration) && isGlobalScopeAugmentation(suggestion.valueDeclaration);
	                if (isGlobalScopeAugmentationDeclaration) {
	                  suggestion = void 0;
	                }
	                if (suggestion) {
	                  const suggestionName = symbolToString(suggestion);
	                  const isUncheckedJS = isUncheckedJSSuggestion(
	                    originalLocation,
	                    suggestion,
	                    /*excludeClasses*/
	                    false
	                  );
	                  const message = meaning === 1920 /* Namespace */ || nameArg && typeof nameArg !== "string" && nodeIsSynthesized(nameArg) ? Diagnostics.Cannot_find_namespace_0_Did_you_mean_1 : isUncheckedJS ? Diagnostics.Could_not_find_name_0_Did_you_mean_1 : Diagnostics.Cannot_find_name_0_Did_you_mean_1;
	                  const diagnostic = createError(errorLocation, message, diagnosticName(nameArg), suggestionName);
	                  addErrorOrSuggestion(!isUncheckedJS, diagnostic);
	                  if (suggestion.valueDeclaration) {
	                    addRelatedInfo(
	                      diagnostic,
	                      createDiagnosticForNode(suggestion.valueDeclaration, Diagnostics._0_is_declared_here, suggestionName)
	                    );
	                  }
	                }
	              }
	              if (!suggestion && !suggestedLib && nameArg) {
	                error2(errorLocation, nameNotFoundMessage, diagnosticName(nameArg));
	              }
	              suggestionCount++;
	            }
	          });
	        }
	        return void 0;
	      } else if (nameNotFoundMessage && checkAndReportErrorForInvalidInitializer()) {
	        return void 0;
	      }
	      if (nameNotFoundMessage) {
	        addLazyDiagnostic(() => {
	          var _a2;
	          if (errorLocation && (meaning & 2 /* BlockScopedVariable */ || (meaning & 32 /* Class */ || meaning & 384 /* Enum */) && (meaning & 111551 /* Value */) === 111551 /* Value */)) {
	            const exportOrLocalSymbol = getExportSymbolOfValueSymbolIfExported(result);
	            if (exportOrLocalSymbol.flags & 2 /* BlockScopedVariable */ || exportOrLocalSymbol.flags & 32 /* Class */ || exportOrLocalSymbol.flags & 384 /* Enum */) {
	              checkResolvedBlockScopedVariable(exportOrLocalSymbol, errorLocation);
	            }
	          }
	          if (result && isInExternalModule && (meaning & 111551 /* Value */) === 111551 /* Value */ && !(originalLocation.flags & 16777216 /* JSDoc */)) {
	            const merged = getMergedSymbol(result);
	            if (length(merged.declarations) && every(merged.declarations, (d) => isNamespaceExportDeclaration(d) || isSourceFile(d) && !!d.symbol.globalExports)) {
	              errorOrSuggestion(!compilerOptions.allowUmdGlobalAccess, errorLocation, Diagnostics._0_refers_to_a_UMD_global_but_the_current_file_is_a_module_Consider_adding_an_import_instead, unescapeLeadingUnderscores(name));
	            }
	          }
	          if (result && associatedDeclarationForContainingInitializerOrBindingName && !withinDeferredContext && (meaning & 111551 /* Value */) === 111551 /* Value */) {
	            const candidate = getMergedSymbol(getLateBoundSymbol(result));
	            const root = getRootDeclaration(associatedDeclarationForContainingInitializerOrBindingName);
	            if (candidate === getSymbolOfDeclaration(associatedDeclarationForContainingInitializerOrBindingName)) {
	              error2(errorLocation, Diagnostics.Parameter_0_cannot_reference_itself, declarationNameToString(associatedDeclarationForContainingInitializerOrBindingName.name));
	            } else if (candidate.valueDeclaration && candidate.valueDeclaration.pos > associatedDeclarationForContainingInitializerOrBindingName.pos && root.parent.locals && lookup(root.parent.locals, candidate.escapedName, meaning) === candidate) {
	              error2(errorLocation, Diagnostics.Parameter_0_cannot_reference_identifier_1_declared_after_it, declarationNameToString(associatedDeclarationForContainingInitializerOrBindingName.name), declarationNameToString(errorLocation));
	            }
	          }
	          if (result && errorLocation && meaning & 111551 /* Value */ && result.flags & 2097152 /* Alias */ && !(result.flags & 111551 /* Value */) && !isValidTypeOnlyAliasUseSite(errorLocation)) {
	            const typeOnlyDeclaration = getTypeOnlyAliasDeclaration(result, 111551 /* Value */);
	            if (typeOnlyDeclaration) {
	              const message = typeOnlyDeclaration.kind === 281 /* ExportSpecifier */ || typeOnlyDeclaration.kind === 278 /* ExportDeclaration */ || typeOnlyDeclaration.kind === 280 /* NamespaceExport */ ? Diagnostics._0_cannot_be_used_as_a_value_because_it_was_exported_using_export_type : Diagnostics._0_cannot_be_used_as_a_value_because_it_was_imported_using_import_type;
	              const unescapedName = unescapeLeadingUnderscores(name);
	              addTypeOnlyDeclarationRelatedInfo(
	                error2(errorLocation, message, unescapedName),
	                typeOnlyDeclaration,
	                unescapedName
	              );
	            }
	          }
	          if (compilerOptions.isolatedModules && result && isInExternalModule && (meaning & 111551 /* Value */) === 111551 /* Value */) {
	            const isGlobal = lookup(globals, name, meaning) === result;
	            const nonValueSymbol = isGlobal && isSourceFile(lastLocation) && lastLocation.locals && lookup(lastLocation.locals, name, ~111551 /* Value */);
	            if (nonValueSymbol) {
	              const importDecl = (_a2 = nonValueSymbol.declarations) == null ? void 0 : _a2.find((d) => d.kind === 276 /* ImportSpecifier */ || d.kind === 273 /* ImportClause */ || d.kind === 274 /* NamespaceImport */ || d.kind === 271 /* ImportEqualsDeclaration */);
	              if (importDecl && !isTypeOnlyImportDeclaration(importDecl)) {
	                error2(importDecl, Diagnostics.Import_0_conflicts_with_global_value_used_in_this_file_so_must_be_declared_with_a_type_only_import_when_isolatedModules_is_enabled, unescapeLeadingUnderscores(name));
	              }
	            }
	          }
	        });
	      }
	      return result;
	    }
	    function addTypeOnlyDeclarationRelatedInfo(diagnostic, typeOnlyDeclaration, unescapedName) {
	      if (!typeOnlyDeclaration)
	        return diagnostic;
	      return addRelatedInfo(
	        diagnostic,
	        createDiagnosticForNode(
	          typeOnlyDeclaration,
	          typeOnlyDeclaration.kind === 281 /* ExportSpecifier */ || typeOnlyDeclaration.kind === 278 /* ExportDeclaration */ || typeOnlyDeclaration.kind === 280 /* NamespaceExport */ ? Diagnostics._0_was_exported_here : Diagnostics._0_was_imported_here,
	          unescapedName
	        )
	      );
	    }
	    function getIsDeferredContext(location, lastLocation) {
	      if (location.kind !== 219 /* ArrowFunction */ && location.kind !== 218 /* FunctionExpression */) {
	        return isTypeQueryNode(location) || (isFunctionLikeDeclaration(location) || location.kind === 172 /* PropertyDeclaration */ && !isStatic(location)) && (!lastLocation || lastLocation !== location.name);
	      }
	      if (lastLocation && lastLocation === location.name) {
	        return false;
	      }
	      if (location.asteriskToken || hasSyntacticModifier(location, 1024 /* Async */)) {
	        return true;
	      }
	      return !getImmediatelyInvokedFunctionExpression(location);
	    }
	    function isSelfReferenceLocation(node) {
	      switch (node.kind) {
	        case 262 /* FunctionDeclaration */:
	        case 263 /* ClassDeclaration */:
	        case 264 /* InterfaceDeclaration */:
	        case 266 /* EnumDeclaration */:
	        case 265 /* TypeAliasDeclaration */:
	        case 267 /* ModuleDeclaration */:
	          return true;
	        default:
	          return false;
	      }
	    }
	    function diagnosticName(nameArg) {
	      return isString(nameArg) ? unescapeLeadingUnderscores(nameArg) : declarationNameToString(nameArg);
	    }
	    function isTypeParameterSymbolDeclaredInContainer(symbol, container) {
	      if (symbol.declarations) {
	        for (const decl of symbol.declarations) {
	          if (decl.kind === 168 /* TypeParameter */) {
	            const parent2 = isJSDocTemplateTag(decl.parent) ? getJSDocHost(decl.parent) : decl.parent;
	            if (parent2 === container) {
	              return !(isJSDocTemplateTag(decl.parent) && find(decl.parent.parent.tags, isJSDocTypeAlias));
	            }
	          }
	        }
	      }
	      return false;
	    }
	    function checkAndReportErrorForMissingPrefix(errorLocation, name, nameArg) {
	      if (!isIdentifier(errorLocation) || errorLocation.escapedText !== name || isTypeReferenceIdentifier(errorLocation) || isInTypeQuery(errorLocation)) {
	        return false;
	      }
	      const container = getThisContainer(
	        errorLocation,
	        /*includeArrowFunctions*/
	        false,
	        /*includeClassComputedPropertyName*/
	        false
	      );
	      let location = container;
	      while (location) {
	        if (isClassLike(location.parent)) {
	          const classSymbol = getSymbolOfDeclaration(location.parent);
	          if (!classSymbol) {
	            break;
	          }
	          const constructorType = getTypeOfSymbol(classSymbol);
	          if (getPropertyOfType(constructorType, name)) {
	            error2(errorLocation, Diagnostics.Cannot_find_name_0_Did_you_mean_the_static_member_1_0, diagnosticName(nameArg), symbolToString(classSymbol));
	            return true;
	          }
	          if (location === container && !isStatic(location)) {
	            const instanceType = getDeclaredTypeOfSymbol(classSymbol).thisType;
	            if (getPropertyOfType(instanceType, name)) {
	              error2(errorLocation, Diagnostics.Cannot_find_name_0_Did_you_mean_the_instance_member_this_0, diagnosticName(nameArg));
	              return true;
	            }
	          }
	        }
	        location = location.parent;
	      }
	      return false;
	    }
	    function checkAndReportErrorForExtendingInterface(errorLocation) {
	      const expression = getEntityNameForExtendingInterface(errorLocation);
	      if (expression && resolveEntityName(
	        expression,
	        64 /* Interface */,
	        /*ignoreErrors*/
	        true
	      )) {
	        error2(errorLocation, Diagnostics.Cannot_extend_an_interface_0_Did_you_mean_implements, getTextOfNode(expression));
	        return true;
	      }
	      return false;
	    }
	    function getEntityNameForExtendingInterface(node) {
	      switch (node.kind) {
	        case 80 /* Identifier */:
	        case 211 /* PropertyAccessExpression */:
	          return node.parent ? getEntityNameForExtendingInterface(node.parent) : void 0;
	        case 233 /* ExpressionWithTypeArguments */:
	          if (isEntityNameExpression(node.expression)) {
	            return node.expression;
	          }
	        default:
	          return void 0;
	      }
	    }
	    function checkAndReportErrorForUsingTypeAsNamespace(errorLocation, name, meaning) {
	      const namespaceMeaning = 1920 /* Namespace */ | (isInJSFile(errorLocation) ? 111551 /* Value */ : 0);
	      if (meaning === namespaceMeaning) {
	        const symbol = resolveSymbol(resolveName(
	          errorLocation,
	          name,
	          788968 /* Type */ & ~namespaceMeaning,
	          /*nameNotFoundMessage*/
	          void 0,
	          /*nameArg*/
	          void 0,
	          /*isUse*/
	          false
	        ));
	        const parent2 = errorLocation.parent;
	        if (symbol) {
	          if (isQualifiedName(parent2)) {
	            Debug.assert(parent2.left === errorLocation, "Should only be resolving left side of qualified name as a namespace");
	            const propName = parent2.right.escapedText;
	            const propType = getPropertyOfType(getDeclaredTypeOfSymbol(symbol), propName);
	            if (propType) {
	              error2(
	                parent2,
	                Diagnostics.Cannot_access_0_1_because_0_is_a_type_but_not_a_namespace_Did_you_mean_to_retrieve_the_type_of_the_property_1_in_0_with_0_1,
	                unescapeLeadingUnderscores(name),
	                unescapeLeadingUnderscores(propName)
	              );
	              return true;
	            }
	          }
	          error2(errorLocation, Diagnostics._0_only_refers_to_a_type_but_is_being_used_as_a_namespace_here, unescapeLeadingUnderscores(name));
	          return true;
	        }
	      }
	      return false;
	    }
	    function checkAndReportErrorForUsingValueAsType(errorLocation, name, meaning) {
	      if (meaning & (788968 /* Type */ & ~1920 /* Namespace */)) {
	        const symbol = resolveSymbol(resolveName(
	          errorLocation,
	          name,
	          ~788968 /* Type */ & 111551 /* Value */,
	          /*nameNotFoundMessage*/
	          void 0,
	          /*nameArg*/
	          void 0,
	          /*isUse*/
	          false
	        ));
	        if (symbol && !(symbol.flags & 1920 /* Namespace */)) {
	          error2(errorLocation, Diagnostics._0_refers_to_a_value_but_is_being_used_as_a_type_here_Did_you_mean_typeof_0, unescapeLeadingUnderscores(name));
	          return true;
	        }
	      }
	      return false;
	    }
	    function isPrimitiveTypeName(name) {
	      return name === "any" || name === "string" || name === "number" || name === "boolean" || name === "never" || name === "unknown";
	    }
	    function checkAndReportErrorForExportingPrimitiveType(errorLocation, name) {
	      if (isPrimitiveTypeName(name) && errorLocation.parent.kind === 281 /* ExportSpecifier */) {
	        error2(errorLocation, Diagnostics.Cannot_export_0_Only_local_declarations_can_be_exported_from_a_module, name);
	        return true;
	      }
	      return false;
	    }
	    function checkAndReportErrorForUsingTypeAsValue(errorLocation, name, meaning) {
	      if (meaning & 111551 /* Value */) {
	        if (isPrimitiveTypeName(name)) {
	          const grandparent = errorLocation.parent.parent;
	          if (grandparent && grandparent.parent && isHeritageClause(grandparent)) {
	            const heritageKind = grandparent.token;
	            const containerKind = grandparent.parent.kind;
	            if (containerKind === 264 /* InterfaceDeclaration */ && heritageKind === 96 /* ExtendsKeyword */) {
	              error2(errorLocation, Diagnostics.An_interface_cannot_extend_a_primitive_type_like_0_It_can_only_extend_other_named_object_types, unescapeLeadingUnderscores(name));
	            } else if (containerKind === 263 /* ClassDeclaration */ && heritageKind === 96 /* ExtendsKeyword */) {
	              error2(errorLocation, Diagnostics.A_class_cannot_extend_a_primitive_type_like_0_Classes_can_only_extend_constructable_values, unescapeLeadingUnderscores(name));
	            } else if (containerKind === 263 /* ClassDeclaration */ && heritageKind === 119 /* ImplementsKeyword */) {
	              error2(errorLocation, Diagnostics.A_class_cannot_implement_a_primitive_type_like_0_It_can_only_implement_other_named_object_types, unescapeLeadingUnderscores(name));
	            }
	          } else {
	            error2(errorLocation, Diagnostics._0_only_refers_to_a_type_but_is_being_used_as_a_value_here, unescapeLeadingUnderscores(name));
	          }
	          return true;
	        }
	        const symbol = resolveSymbol(resolveName(
	          errorLocation,
	          name,
	          788968 /* Type */ & ~111551 /* Value */,
	          /*nameNotFoundMessage*/
	          void 0,
	          /*nameArg*/
	          void 0,
	          /*isUse*/
	          false
	        ));
	        const allFlags = symbol && getSymbolFlags(symbol);
	        if (symbol && allFlags !== void 0 && !(allFlags & 111551 /* Value */)) {
	          const rawName = unescapeLeadingUnderscores(name);
	          if (isES2015OrLaterConstructorName(name)) {
	            error2(errorLocation, Diagnostics._0_only_refers_to_a_type_but_is_being_used_as_a_value_here_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_es2015_or_later, rawName);
	          } else if (maybeMappedType(errorLocation, symbol)) {
	            error2(errorLocation, Diagnostics._0_only_refers_to_a_type_but_is_being_used_as_a_value_here_Did_you_mean_to_use_1_in_0, rawName, rawName === "K" ? "P" : "K");
	          } else {
	            error2(errorLocation, Diagnostics._0_only_refers_to_a_type_but_is_being_used_as_a_value_here, rawName);
	          }
	          return true;
	        }
	      }
	      return false;
	    }
	    function maybeMappedType(node, symbol) {
	      const container = findAncestor(node.parent, (n) => isComputedPropertyName(n) || isPropertySignature(n) ? false : isTypeLiteralNode(n) || "quit");
	      if (container && container.members.length === 1) {
	        const type = getDeclaredTypeOfSymbol(symbol);
	        return !!(type.flags & 1048576 /* Union */) && allTypesAssignableToKind(
	          type,
	          384 /* StringOrNumberLiteral */,
	          /*strict*/
	          true
	        );
	      }
	      return false;
	    }
	    function isES2015OrLaterConstructorName(n) {
	      switch (n) {
	        case "Promise":
	        case "Symbol":
	        case "Map":
	        case "WeakMap":
	        case "Set":
	        case "WeakSet":
	          return true;
	      }
	      return false;
	    }
	    function checkAndReportErrorForUsingNamespaceAsTypeOrValue(errorLocation, name, meaning) {
	      if (meaning & (111551 /* Value */ & ~788968 /* Type */)) {
	        const symbol = resolveSymbol(resolveName(
	          errorLocation,
	          name,
	          1024 /* NamespaceModule */,
	          /*nameNotFoundMessage*/
	          void 0,
	          /*nameArg*/
	          void 0,
	          /*isUse*/
	          false
	        ));
	        if (symbol) {
	          error2(
	            errorLocation,
	            Diagnostics.Cannot_use_namespace_0_as_a_value,
	            unescapeLeadingUnderscores(name)
	          );
	          return true;
	        }
	      } else if (meaning & (788968 /* Type */ & ~111551 /* Value */)) {
	        const symbol = resolveSymbol(resolveName(
	          errorLocation,
	          name,
	          1536 /* Module */,
	          /*nameNotFoundMessage*/
	          void 0,
	          /*nameArg*/
	          void 0,
	          /*isUse*/
	          false
	        ));
	        if (symbol) {
	          error2(errorLocation, Diagnostics.Cannot_use_namespace_0_as_a_type, unescapeLeadingUnderscores(name));
	          return true;
	        }
	      }
	      return false;
	    }
	    function checkResolvedBlockScopedVariable(result, errorLocation) {
	      var _a;
	      Debug.assert(!!(result.flags & 2 /* BlockScopedVariable */ || result.flags & 32 /* Class */ || result.flags & 384 /* Enum */));
	      if (result.flags & (16 /* Function */ | 1 /* FunctionScopedVariable */ | 67108864 /* Assignment */) && result.flags & 32 /* Class */) {
	        return;
	      }
	      const declaration = (_a = result.declarations) == null ? void 0 : _a.find(
	        (d) => isBlockOrCatchScoped(d) || isClassLike(d) || d.kind === 266 /* EnumDeclaration */
	      );
	      if (declaration === void 0)
	        return Debug.fail("checkResolvedBlockScopedVariable could not find block-scoped declaration");
	      if (!(declaration.flags & 33554432 /* Ambient */) && !isBlockScopedNameDeclaredBeforeUse(declaration, errorLocation)) {
	        let diagnosticMessage;
	        const declarationName = declarationNameToString(getNameOfDeclaration(declaration));
	        if (result.flags & 2 /* BlockScopedVariable */) {
	          diagnosticMessage = error2(errorLocation, Diagnostics.Block_scoped_variable_0_used_before_its_declaration, declarationName);
	        } else if (result.flags & 32 /* Class */) {
	          diagnosticMessage = error2(errorLocation, Diagnostics.Class_0_used_before_its_declaration, declarationName);
	        } else if (result.flags & 256 /* RegularEnum */) {
	          diagnosticMessage = error2(errorLocation, Diagnostics.Enum_0_used_before_its_declaration, declarationName);
	        } else {
	          Debug.assert(!!(result.flags & 128 /* ConstEnum */));
	          if (getIsolatedModules(compilerOptions)) {
	            diagnosticMessage = error2(errorLocation, Diagnostics.Enum_0_used_before_its_declaration, declarationName);
	          }
	        }
	        if (diagnosticMessage) {
	          addRelatedInfo(diagnosticMessage, createDiagnosticForNode(declaration, Diagnostics._0_is_declared_here, declarationName));
	        }
	      }
	    }
	    function isSameScopeDescendentOf(initial, parent2, stopAt) {
	      return !!parent2 && !!findAncestor(initial, (n) => n === parent2 || (n === stopAt || isFunctionLike(n) && (!getImmediatelyInvokedFunctionExpression(n) || getFunctionFlags(n) & 3 /* AsyncGenerator */) ? "quit" : false));
	    }
	    function getAnyImportSyntax(node) {
	      switch (node.kind) {
	        case 271 /* ImportEqualsDeclaration */:
	          return node;
	        case 273 /* ImportClause */:
	          return node.parent;
	        case 274 /* NamespaceImport */:
	          return node.parent.parent;
	        case 276 /* ImportSpecifier */:
	          return node.parent.parent.parent;
	        default:
	          return void 0;
	      }
	    }
	    function getDeclarationOfAliasSymbol(symbol) {
	      return symbol.declarations && findLast(symbol.declarations, isAliasSymbolDeclaration2);
	    }
	    function isAliasSymbolDeclaration2(node) {
	      return node.kind === 271 /* ImportEqualsDeclaration */ || node.kind === 270 /* NamespaceExportDeclaration */ || node.kind === 273 /* ImportClause */ && !!node.name || node.kind === 274 /* NamespaceImport */ || node.kind === 280 /* NamespaceExport */ || node.kind === 276 /* ImportSpecifier */ || node.kind === 281 /* ExportSpecifier */ || node.kind === 277 /* ExportAssignment */ && exportAssignmentIsAlias(node) || isBinaryExpression(node) && getAssignmentDeclarationKind(node) === 2 /* ModuleExports */ && exportAssignmentIsAlias(node) || isAccessExpression(node) && isBinaryExpression(node.parent) && node.parent.left === node && node.parent.operatorToken.kind === 64 /* EqualsToken */ && isAliasableOrJsExpression(node.parent.right) || node.kind === 304 /* ShorthandPropertyAssignment */ || node.kind === 303 /* PropertyAssignment */ && isAliasableOrJsExpression(node.initializer) || node.kind === 260 /* VariableDeclaration */ && isVariableDeclarationInitializedToBareOrAccessedRequire(node) || node.kind === 208 /* BindingElement */ && isVariableDeclarationInitializedToBareOrAccessedRequire(node.parent.parent);
	    }
	    function isAliasableOrJsExpression(e) {
	      return isAliasableExpression(e) || isFunctionExpression(e) && isJSConstructor(e);
	    }
	    function getTargetOfImportEqualsDeclaration(node, dontResolveAlias) {
	      const commonJSPropertyAccess = getCommonJSPropertyAccess(node);
	      if (commonJSPropertyAccess) {
	        const name = getLeftmostAccessExpression(commonJSPropertyAccess.expression).arguments[0];
	        return isIdentifier(commonJSPropertyAccess.name) ? resolveSymbol(getPropertyOfType(resolveExternalModuleTypeByLiteral(name), commonJSPropertyAccess.name.escapedText)) : void 0;
	      }
	      if (isVariableDeclaration(node) || node.moduleReference.kind === 283 /* ExternalModuleReference */) {
	        const immediate = resolveExternalModuleName(
	          node,
	          getExternalModuleRequireArgument(node) || getExternalModuleImportEqualsDeclarationExpression(node)
	        );
	        const resolved2 = resolveExternalModuleSymbol(immediate);
	        markSymbolOfAliasDeclarationIfTypeOnly(
	          node,
	          immediate,
	          resolved2,
	          /*overwriteEmpty*/
	          false
	        );
	        return resolved2;
	      }
	      const resolved = getSymbolOfPartOfRightHandSideOfImportEquals(node.moduleReference, dontResolveAlias);
	      checkAndReportErrorForResolvingImportAliasToTypeOnlySymbol(node, resolved);
	      return resolved;
	    }
	    function checkAndReportErrorForResolvingImportAliasToTypeOnlySymbol(node, resolved) {
	      if (markSymbolOfAliasDeclarationIfTypeOnly(
	        node,
	        /*immediateTarget*/
	        void 0,
	        resolved,
	        /*overwriteEmpty*/
	        false
	      ) && !node.isTypeOnly) {
	        const typeOnlyDeclaration = getTypeOnlyAliasDeclaration(getSymbolOfDeclaration(node));
	        const isExport = typeOnlyDeclaration.kind === 281 /* ExportSpecifier */ || typeOnlyDeclaration.kind === 278 /* ExportDeclaration */;
	        const message = isExport ? Diagnostics.An_import_alias_cannot_reference_a_declaration_that_was_exported_using_export_type : Diagnostics.An_import_alias_cannot_reference_a_declaration_that_was_imported_using_import_type;
	        const relatedMessage = isExport ? Diagnostics._0_was_exported_here : Diagnostics._0_was_imported_here;
	        const name = typeOnlyDeclaration.kind === 278 /* ExportDeclaration */ ? "*" : unescapeLeadingUnderscores(typeOnlyDeclaration.name.escapedText);
	        addRelatedInfo(error2(node.moduleReference, message), createDiagnosticForNode(typeOnlyDeclaration, relatedMessage, name));
	      }
	    }
	    function resolveExportByName(moduleSymbol, name, sourceNode, dontResolveAlias) {
	      const exportValue = moduleSymbol.exports.get("export=" /* ExportEquals */);
	      const exportSymbol = exportValue ? getPropertyOfType(
	        getTypeOfSymbol(exportValue),
	        name,
	        /*skipObjectFunctionPropertyAugment*/
	        true
	      ) : moduleSymbol.exports.get(name);
	      const resolved = resolveSymbol(exportSymbol, dontResolveAlias);
	      markSymbolOfAliasDeclarationIfTypeOnly(
	        sourceNode,
	        exportSymbol,
	        resolved,
	        /*overwriteEmpty*/
	        false
	      );
	      return resolved;
	    }
	    function isSyntacticDefault(node) {
	      return isExportAssignment(node) && !node.isExportEquals || hasSyntacticModifier(node, 2048 /* Default */) || isExportSpecifier(node) || isNamespaceExport(node);
	    }
	    function getUsageModeForExpression(usage) {
	      return isStringLiteralLike(usage) ? host.getModeForUsageLocation(getSourceFileOfNode(usage), usage) : void 0;
	    }
	    function isESMFormatImportImportingCommonjsFormatFile(usageMode, targetMode) {
	      return usageMode === 99 /* ESNext */ && targetMode === 1 /* CommonJS */;
	    }
	    function isOnlyImportedAsDefault(usage) {
	      const usageMode = getUsageModeForExpression(usage);
	      return usageMode === 99 /* ESNext */ && endsWith(usage.text, ".json" /* Json */);
	    }
	    function canHaveSyntheticDefault(file, moduleSymbol, dontResolveAlias, usage) {
	      const usageMode = file && getUsageModeForExpression(usage);
	      if (file && usageMode !== void 0 && 100 /* Node16 */ <= moduleKind && moduleKind <= 199 /* NodeNext */) {
	        const result = isESMFormatImportImportingCommonjsFormatFile(usageMode, file.impliedNodeFormat);
	        if (usageMode === 99 /* ESNext */ || result) {
	          return result;
	        }
	      }
	      if (!allowSyntheticDefaultImports) {
	        return false;
	      }
	      if (!file || file.isDeclarationFile) {
	        const defaultExportSymbol = resolveExportByName(
	          moduleSymbol,
	          "default" /* Default */,
	          /*sourceNode*/
	          void 0,
	          /*dontResolveAlias*/
	          true
	        );
	        if (defaultExportSymbol && some(defaultExportSymbol.declarations, isSyntacticDefault)) {
	          return false;
	        }
	        if (resolveExportByName(
	          moduleSymbol,
	          escapeLeadingUnderscores("__esModule"),
	          /*sourceNode*/
	          void 0,
	          dontResolveAlias
	        )) {
	          return false;
	        }
	        return true;
	      }
	      if (!isSourceFileJS(file)) {
	        return hasExportAssignmentSymbol(moduleSymbol);
	      }
	      return typeof file.externalModuleIndicator !== "object" && !resolveExportByName(
	        moduleSymbol,
	        escapeLeadingUnderscores("__esModule"),
	        /*sourceNode*/
	        void 0,
	        dontResolveAlias
	      );
	    }
	    function getTargetOfImportClause(node, dontResolveAlias) {
	      const moduleSymbol = resolveExternalModuleName(node, node.parent.moduleSpecifier);
	      if (moduleSymbol) {
	        return getTargetofModuleDefault(moduleSymbol, node, dontResolveAlias);
	      }
	    }
	    function getTargetofModuleDefault(moduleSymbol, node, dontResolveAlias) {
	      var _a;
	      let exportDefaultSymbol;
	      if (isShorthandAmbientModuleSymbol(moduleSymbol)) {
	        exportDefaultSymbol = moduleSymbol;
	      } else {
	        exportDefaultSymbol = resolveExportByName(moduleSymbol, "default" /* Default */, node, dontResolveAlias);
	      }
	      const file = (_a = moduleSymbol.declarations) == null ? void 0 : _a.find(isSourceFile);
	      const specifier = getModuleSpecifierForImportOrExport(node);
	      if (!specifier) {
	        return exportDefaultSymbol;
	      }
	      const hasDefaultOnly = isOnlyImportedAsDefault(specifier);
	      const hasSyntheticDefault = canHaveSyntheticDefault(file, moduleSymbol, dontResolveAlias, specifier);
	      if (!exportDefaultSymbol && !hasSyntheticDefault && !hasDefaultOnly) {
	        if (hasExportAssignmentSymbol(moduleSymbol) && !allowSyntheticDefaultImports) {
	          const compilerOptionName = moduleKind >= 5 /* ES2015 */ ? "allowSyntheticDefaultImports" : "esModuleInterop";
	          const exportEqualsSymbol = moduleSymbol.exports.get("export=" /* ExportEquals */);
	          const exportAssignment = exportEqualsSymbol.valueDeclaration;
	          const err = error2(node.name, Diagnostics.Module_0_can_only_be_default_imported_using_the_1_flag, symbolToString(moduleSymbol), compilerOptionName);
	          if (exportAssignment) {
	            addRelatedInfo(
	              err,
	              createDiagnosticForNode(
	                exportAssignment,
	                Diagnostics.This_module_is_declared_with_export_and_can_only_be_used_with_a_default_import_when_using_the_0_flag,
	                compilerOptionName
	              )
	            );
	          }
	        } else if (isImportClause(node)) {
	          reportNonDefaultExport(moduleSymbol, node);
	        } else {
	          errorNoModuleMemberSymbol(moduleSymbol, moduleSymbol, node, isImportOrExportSpecifier(node) && node.propertyName || node.name);
	        }
	      } else if (hasSyntheticDefault || hasDefaultOnly) {
	        const resolved = resolveExternalModuleSymbol(moduleSymbol, dontResolveAlias) || resolveSymbol(moduleSymbol, dontResolveAlias);
	        markSymbolOfAliasDeclarationIfTypeOnly(
	          node,
	          moduleSymbol,
	          resolved,
	          /*overwriteEmpty*/
	          false
	        );
	        return resolved;
	      }
	      markSymbolOfAliasDeclarationIfTypeOnly(
	        node,
	        exportDefaultSymbol,
	        /*finalTarget*/
	        void 0,
	        /*overwriteEmpty*/
	        false
	      );
	      return exportDefaultSymbol;
	    }
	    function getModuleSpecifierForImportOrExport(node) {
	      switch (node.kind) {
	        case 273 /* ImportClause */:
	          return node.parent.moduleSpecifier;
	        case 271 /* ImportEqualsDeclaration */:
	          return isExternalModuleReference(node.moduleReference) ? node.moduleReference.expression : void 0;
	        case 274 /* NamespaceImport */:
	          return node.parent.parent.moduleSpecifier;
	        case 276 /* ImportSpecifier */:
	          return node.parent.parent.parent.moduleSpecifier;
	        case 281 /* ExportSpecifier */:
	          return node.parent.parent.moduleSpecifier;
	        default:
	          return Debug.assertNever(node);
	      }
	    }
	    function reportNonDefaultExport(moduleSymbol, node) {
	      var _a, _b, _c;
	      if ((_a = moduleSymbol.exports) == null ? void 0 : _a.has(node.symbol.escapedName)) {
	        error2(
	          node.name,
	          Diagnostics.Module_0_has_no_default_export_Did_you_mean_to_use_import_1_from_0_instead,
	          symbolToString(moduleSymbol),
	          symbolToString(node.symbol)
	        );
	      } else {
	        const diagnostic = error2(node.name, Diagnostics.Module_0_has_no_default_export, symbolToString(moduleSymbol));
	        const exportStar = (_b = moduleSymbol.exports) == null ? void 0 : _b.get("__export" /* ExportStar */);
	        if (exportStar) {
	          const defaultExport = (_c = exportStar.declarations) == null ? void 0 : _c.find(
	            (decl) => {
	              var _a2, _b2;
	              return !!(isExportDeclaration(decl) && decl.moduleSpecifier && ((_b2 = (_a2 = resolveExternalModuleName(decl, decl.moduleSpecifier)) == null ? void 0 : _a2.exports) == null ? void 0 : _b2.has("default" /* Default */)));
	            }
	          );
	          if (defaultExport) {
	            addRelatedInfo(diagnostic, createDiagnosticForNode(defaultExport, Diagnostics.export_Asterisk_does_not_re_export_a_default));
	          }
	        }
	      }
	    }
	    function getTargetOfNamespaceImport(node, dontResolveAlias) {
	      const moduleSpecifier = node.parent.parent.moduleSpecifier;
	      const immediate = resolveExternalModuleName(node, moduleSpecifier);
	      const resolved = resolveESModuleSymbol(
	        immediate,
	        moduleSpecifier,
	        dontResolveAlias,
	        /*suppressInteropError*/
	        false
	      );
	      markSymbolOfAliasDeclarationIfTypeOnly(
	        node,
	        immediate,
	        resolved,
	        /*overwriteEmpty*/
	        false
	      );
	      return resolved;
	    }
	    function getTargetOfNamespaceExport(node, dontResolveAlias) {
	      const moduleSpecifier = node.parent.moduleSpecifier;
	      const immediate = moduleSpecifier && resolveExternalModuleName(node, moduleSpecifier);
	      const resolved = moduleSpecifier && resolveESModuleSymbol(
	        immediate,
	        moduleSpecifier,
	        dontResolveAlias,
	        /*suppressInteropError*/
	        false
	      );
	      markSymbolOfAliasDeclarationIfTypeOnly(
	        node,
	        immediate,
	        resolved,
	        /*overwriteEmpty*/
	        false
	      );
	      return resolved;
	    }
	    function combineValueAndTypeSymbols(valueSymbol, typeSymbol) {
	      if (valueSymbol === unknownSymbol && typeSymbol === unknownSymbol) {
	        return unknownSymbol;
	      }
	      if (valueSymbol.flags & (788968 /* Type */ | 1920 /* Namespace */)) {
	        return valueSymbol;
	      }
	      const result = createSymbol(valueSymbol.flags | typeSymbol.flags, valueSymbol.escapedName);
	      Debug.assert(valueSymbol.declarations || typeSymbol.declarations);
	      result.declarations = deduplicate(concatenate(valueSymbol.declarations, typeSymbol.declarations), equateValues);
	      result.parent = valueSymbol.parent || typeSymbol.parent;
	      if (valueSymbol.valueDeclaration)
	        result.valueDeclaration = valueSymbol.valueDeclaration;
	      if (typeSymbol.members)
	        result.members = new Map(typeSymbol.members);
	      if (valueSymbol.exports)
	        result.exports = new Map(valueSymbol.exports);
	      return result;
	    }
	    function getExportOfModule(symbol, name, specifier, dontResolveAlias) {
	      var _a;
	      if (symbol.flags & 1536 /* Module */) {
	        const exportSymbol = getExportsOfSymbol(symbol).get(name.escapedText);
	        const resolved = resolveSymbol(exportSymbol, dontResolveAlias);
	        const exportStarDeclaration = (_a = getSymbolLinks(symbol).typeOnlyExportStarMap) == null ? void 0 : _a.get(name.escapedText);
	        markSymbolOfAliasDeclarationIfTypeOnly(
	          specifier,
	          exportSymbol,
	          resolved,
	          /*overwriteEmpty*/
	          false,
	          exportStarDeclaration,
	          name.escapedText
	        );
	        return resolved;
	      }
	    }
	    function getPropertyOfVariable(symbol, name) {
	      if (symbol.flags & 3 /* Variable */) {
	        const typeAnnotation = symbol.valueDeclaration.type;
	        if (typeAnnotation) {
	          return resolveSymbol(getPropertyOfType(getTypeFromTypeNode(typeAnnotation), name));
	        }
	      }
	    }
	    function getExternalModuleMember(node, specifier, dontResolveAlias = false) {
	      var _a;
	      const moduleSpecifier = getExternalModuleRequireArgument(node) || node.moduleSpecifier;
	      const moduleSymbol = resolveExternalModuleName(node, moduleSpecifier);
	      const name = !isPropertyAccessExpression(specifier) && specifier.propertyName || specifier.name;
	      if (!isIdentifier(name)) {
	        return void 0;
	      }
	      const suppressInteropError = name.escapedText === "default" /* Default */ && allowSyntheticDefaultImports;
	      const targetSymbol = resolveESModuleSymbol(
	        moduleSymbol,
	        moduleSpecifier,
	        /*dontResolveAlias*/
	        false,
	        suppressInteropError
	      );
	      if (targetSymbol) {
	        if (name.escapedText) {
	          if (isShorthandAmbientModuleSymbol(moduleSymbol)) {
	            return moduleSymbol;
	          }
	          let symbolFromVariable;
	          if (moduleSymbol && moduleSymbol.exports && moduleSymbol.exports.get("export=" /* ExportEquals */)) {
	            symbolFromVariable = getPropertyOfType(
	              getTypeOfSymbol(targetSymbol),
	              name.escapedText,
	              /*skipObjectFunctionPropertyAugment*/
	              true
	            );
	          } else {
	            symbolFromVariable = getPropertyOfVariable(targetSymbol, name.escapedText);
	          }
	          symbolFromVariable = resolveSymbol(symbolFromVariable, dontResolveAlias);
	          let symbolFromModule = getExportOfModule(targetSymbol, name, specifier, dontResolveAlias);
	          if (symbolFromModule === void 0 && name.escapedText === "default" /* Default */) {
	            const file = (_a = moduleSymbol.declarations) == null ? void 0 : _a.find(isSourceFile);
	            if (isOnlyImportedAsDefault(moduleSpecifier) || canHaveSyntheticDefault(file, moduleSymbol, dontResolveAlias, moduleSpecifier)) {
	              symbolFromModule = resolveExternalModuleSymbol(moduleSymbol, dontResolveAlias) || resolveSymbol(moduleSymbol, dontResolveAlias);
	            }
	          }
	          const symbol = symbolFromModule && symbolFromVariable && symbolFromModule !== symbolFromVariable ? combineValueAndTypeSymbols(symbolFromVariable, symbolFromModule) : symbolFromModule || symbolFromVariable;
	          if (!symbol) {
	            errorNoModuleMemberSymbol(moduleSymbol, targetSymbol, node, name);
	          }
	          return symbol;
	        }
	      }
	    }
	    function errorNoModuleMemberSymbol(moduleSymbol, targetSymbol, node, name) {
	      var _a;
	      const moduleName = getFullyQualifiedName(moduleSymbol, node);
	      const declarationName = declarationNameToString(name);
	      const suggestion = getSuggestedSymbolForNonexistentModule(name, targetSymbol);
	      if (suggestion !== void 0) {
	        const suggestionName = symbolToString(suggestion);
	        const diagnostic = error2(name, Diagnostics._0_has_no_exported_member_named_1_Did_you_mean_2, moduleName, declarationName, suggestionName);
	        if (suggestion.valueDeclaration) {
	          addRelatedInfo(diagnostic, createDiagnosticForNode(suggestion.valueDeclaration, Diagnostics._0_is_declared_here, suggestionName));
	        }
	      } else {
	        if ((_a = moduleSymbol.exports) == null ? void 0 : _a.has("default" /* Default */)) {
	          error2(
	            name,
	            Diagnostics.Module_0_has_no_exported_member_1_Did_you_mean_to_use_import_1_from_0_instead,
	            moduleName,
	            declarationName
	          );
	        } else {
	          reportNonExportedMember(node, name, declarationName, moduleSymbol, moduleName);
	        }
	      }
	    }
	    function reportNonExportedMember(node, name, declarationName, moduleSymbol, moduleName) {
	      var _a, _b;
	      const localSymbol = (_b = (_a = tryCast(moduleSymbol.valueDeclaration, canHaveLocals)) == null ? void 0 : _a.locals) == null ? void 0 : _b.get(name.escapedText);
	      const exports = moduleSymbol.exports;
	      if (localSymbol) {
	        const exportedEqualsSymbol = exports == null ? void 0 : exports.get("export=" /* ExportEquals */);
	        if (exportedEqualsSymbol) {
	          getSymbolIfSameReference(exportedEqualsSymbol, localSymbol) ? reportInvalidImportEqualsExportMember(node, name, declarationName, moduleName) : error2(name, Diagnostics.Module_0_has_no_exported_member_1, moduleName, declarationName);
	        } else {
	          const exportedSymbol = exports ? find(symbolsToArray(exports), (symbol) => !!getSymbolIfSameReference(symbol, localSymbol)) : void 0;
	          const diagnostic = exportedSymbol ? error2(name, Diagnostics.Module_0_declares_1_locally_but_it_is_exported_as_2, moduleName, declarationName, symbolToString(exportedSymbol)) : error2(name, Diagnostics.Module_0_declares_1_locally_but_it_is_not_exported, moduleName, declarationName);
	          if (localSymbol.declarations) {
	            addRelatedInfo(diagnostic, ...map(localSymbol.declarations, (decl, index) => createDiagnosticForNode(decl, index === 0 ? Diagnostics._0_is_declared_here : Diagnostics.and_here, declarationName)));
	          }
	        }
	      } else {
	        error2(name, Diagnostics.Module_0_has_no_exported_member_1, moduleName, declarationName);
	      }
	    }
	    function reportInvalidImportEqualsExportMember(node, name, declarationName, moduleName) {
	      if (moduleKind >= 5 /* ES2015 */) {
	        const message = getESModuleInterop(compilerOptions) ? Diagnostics._0_can_only_be_imported_by_using_a_default_import : Diagnostics._0_can_only_be_imported_by_turning_on_the_esModuleInterop_flag_and_using_a_default_import;
	        error2(name, message, declarationName);
	      } else {
	        if (isInJSFile(node)) {
	          const message = getESModuleInterop(compilerOptions) ? Diagnostics._0_can_only_be_imported_by_using_a_require_call_or_by_using_a_default_import : Diagnostics._0_can_only_be_imported_by_using_a_require_call_or_by_turning_on_the_esModuleInterop_flag_and_using_a_default_import;
	          error2(name, message, declarationName);
	        } else {
	          const message = getESModuleInterop(compilerOptions) ? Diagnostics._0_can_only_be_imported_by_using_import_1_require_2_or_a_default_import : Diagnostics._0_can_only_be_imported_by_using_import_1_require_2_or_by_turning_on_the_esModuleInterop_flag_and_using_a_default_import;
	          error2(name, message, declarationName, declarationName, moduleName);
	        }
	      }
	    }
	    function getTargetOfImportSpecifier(node, dontResolveAlias) {
	      if (isImportSpecifier(node) && idText(node.propertyName || node.name) === "default" /* Default */) {
	        const specifier = getModuleSpecifierForImportOrExport(node);
	        const moduleSymbol = specifier && resolveExternalModuleName(node, specifier);
	        if (moduleSymbol) {
	          return getTargetofModuleDefault(moduleSymbol, node, dontResolveAlias);
	        }
	      }
	      const root = isBindingElement(node) ? getRootDeclaration(node) : node.parent.parent.parent;
	      const commonJSPropertyAccess = getCommonJSPropertyAccess(root);
	      const resolved = getExternalModuleMember(root, commonJSPropertyAccess || node, dontResolveAlias);
	      const name = node.propertyName || node.name;
	      if (commonJSPropertyAccess && resolved && isIdentifier(name)) {
	        return resolveSymbol(getPropertyOfType(getTypeOfSymbol(resolved), name.escapedText), dontResolveAlias);
	      }
	      markSymbolOfAliasDeclarationIfTypeOnly(
	        node,
	        /*immediateTarget*/
	        void 0,
	        resolved,
	        /*overwriteEmpty*/
	        false
	      );
	      return resolved;
	    }
	    function getCommonJSPropertyAccess(node) {
	      if (isVariableDeclaration(node) && node.initializer && isPropertyAccessExpression(node.initializer)) {
	        return node.initializer;
	      }
	    }
	    function getTargetOfNamespaceExportDeclaration(node, dontResolveAlias) {
	      if (canHaveSymbol(node.parent)) {
	        const resolved = resolveExternalModuleSymbol(node.parent.symbol, dontResolveAlias);
	        markSymbolOfAliasDeclarationIfTypeOnly(
	          node,
	          /*immediateTarget*/
	          void 0,
	          resolved,
	          /*overwriteEmpty*/
	          false
	        );
	        return resolved;
	      }
	    }
	    function getTargetOfExportSpecifier(node, meaning, dontResolveAlias) {
	      if (idText(node.propertyName || node.name) === "default" /* Default */) {
	        const specifier = getModuleSpecifierForImportOrExport(node);
	        const moduleSymbol = specifier && resolveExternalModuleName(node, specifier);
	        if (moduleSymbol) {
	          return getTargetofModuleDefault(moduleSymbol, node, !!dontResolveAlias);
	        }
	      }
	      const resolved = node.parent.parent.moduleSpecifier ? getExternalModuleMember(node.parent.parent, node, dontResolveAlias) : resolveEntityName(
	        node.propertyName || node.name,
	        meaning,
	        /*ignoreErrors*/
	        false,
	        dontResolveAlias
	      );
	      markSymbolOfAliasDeclarationIfTypeOnly(
	        node,
	        /*immediateTarget*/
	        void 0,
	        resolved,
	        /*overwriteEmpty*/
	        false
	      );
	      return resolved;
	    }
	    function getTargetOfExportAssignment(node, dontResolveAlias) {
	      const expression = isExportAssignment(node) ? node.expression : node.right;
	      const resolved = getTargetOfAliasLikeExpression(expression, dontResolveAlias);
	      markSymbolOfAliasDeclarationIfTypeOnly(
	        node,
	        /*immediateTarget*/
	        void 0,
	        resolved,
	        /*overwriteEmpty*/
	        false
	      );
	      return resolved;
	    }
	    function getTargetOfAliasLikeExpression(expression, dontResolveAlias) {
	      if (isClassExpression(expression)) {
	        return checkExpressionCached(expression).symbol;
	      }
	      if (!isEntityName(expression) && !isEntityNameExpression(expression)) {
	        return void 0;
	      }
	      const aliasLike = resolveEntityName(
	        expression,
	        111551 /* Value */ | 788968 /* Type */ | 1920 /* Namespace */,
	        /*ignoreErrors*/
	        true,
	        dontResolveAlias
	      );
	      if (aliasLike) {
	        return aliasLike;
	      }
	      checkExpressionCached(expression);
	      return getNodeLinks(expression).resolvedSymbol;
	    }
	    function getTargetOfAccessExpression(node, dontRecursivelyResolve) {
	      if (!(isBinaryExpression(node.parent) && node.parent.left === node && node.parent.operatorToken.kind === 64 /* EqualsToken */)) {
	        return void 0;
	      }
	      return getTargetOfAliasLikeExpression(node.parent.right, dontRecursivelyResolve);
	    }
	    function getTargetOfAliasDeclaration(node, dontRecursivelyResolve = false) {
	      switch (node.kind) {
	        case 271 /* ImportEqualsDeclaration */:
	        case 260 /* VariableDeclaration */:
	          return getTargetOfImportEqualsDeclaration(node, dontRecursivelyResolve);
	        case 273 /* ImportClause */:
	          return getTargetOfImportClause(node, dontRecursivelyResolve);
	        case 274 /* NamespaceImport */:
	          return getTargetOfNamespaceImport(node, dontRecursivelyResolve);
	        case 280 /* NamespaceExport */:
	          return getTargetOfNamespaceExport(node, dontRecursivelyResolve);
	        case 276 /* ImportSpecifier */:
	        case 208 /* BindingElement */:
	          return getTargetOfImportSpecifier(node, dontRecursivelyResolve);
	        case 281 /* ExportSpecifier */:
	          return getTargetOfExportSpecifier(node, 111551 /* Value */ | 788968 /* Type */ | 1920 /* Namespace */, dontRecursivelyResolve);
	        case 277 /* ExportAssignment */:
	        case 226 /* BinaryExpression */:
	          return getTargetOfExportAssignment(node, dontRecursivelyResolve);
	        case 270 /* NamespaceExportDeclaration */:
	          return getTargetOfNamespaceExportDeclaration(node, dontRecursivelyResolve);
	        case 304 /* ShorthandPropertyAssignment */:
	          return resolveEntityName(
	            node.name,
	            111551 /* Value */ | 788968 /* Type */ | 1920 /* Namespace */,
	            /*ignoreErrors*/
	            true,
	            dontRecursivelyResolve
	          );
	        case 303 /* PropertyAssignment */:
	          return getTargetOfAliasLikeExpression(node.initializer, dontRecursivelyResolve);
	        case 212 /* ElementAccessExpression */:
	        case 211 /* PropertyAccessExpression */:
	          return getTargetOfAccessExpression(node, dontRecursivelyResolve);
	        default:
	          return Debug.fail();
	      }
	    }
	    function isNonLocalAlias(symbol, excludes = 111551 /* Value */ | 788968 /* Type */ | 1920 /* Namespace */) {
	      if (!symbol)
	        return false;
	      return (symbol.flags & (2097152 /* Alias */ | excludes)) === 2097152 /* Alias */ || !!(symbol.flags & 2097152 /* Alias */ && symbol.flags & 67108864 /* Assignment */);
	    }
	    function resolveSymbol(symbol, dontResolveAlias) {
	      return !dontResolveAlias && isNonLocalAlias(symbol) ? resolveAlias(symbol) : symbol;
	    }
	    function resolveAlias(symbol) {
	      Debug.assert((symbol.flags & 2097152 /* Alias */) !== 0, "Should only get Alias here.");
	      const links = getSymbolLinks(symbol);
	      if (!links.aliasTarget) {
	        links.aliasTarget = resolvingSymbol;
	        const node = getDeclarationOfAliasSymbol(symbol);
	        if (!node)
	          return Debug.fail();
	        const target = getTargetOfAliasDeclaration(node);
	        if (links.aliasTarget === resolvingSymbol) {
	          links.aliasTarget = target || unknownSymbol;
	        } else {
	          error2(node, Diagnostics.Circular_definition_of_import_alias_0, symbolToString(symbol));
	        }
	      } else if (links.aliasTarget === resolvingSymbol) {
	        links.aliasTarget = unknownSymbol;
	      }
	      return links.aliasTarget;
	    }
	    function tryResolveAlias(symbol) {
	      const links = getSymbolLinks(symbol);
	      if (links.aliasTarget !== resolvingSymbol) {
	        return resolveAlias(symbol);
	      }
	      return void 0;
	    }
	    function getSymbolFlags(symbol, excludeTypeOnlyMeanings, excludeLocalMeanings) {
	      const typeOnlyDeclaration = excludeTypeOnlyMeanings && getTypeOnlyAliasDeclaration(symbol);
	      const typeOnlyDeclarationIsExportStar = typeOnlyDeclaration && isExportDeclaration(typeOnlyDeclaration);
	      const typeOnlyResolution = typeOnlyDeclaration && (typeOnlyDeclarationIsExportStar ? resolveExternalModuleName(
	        typeOnlyDeclaration.moduleSpecifier,
	        typeOnlyDeclaration.moduleSpecifier,
	        /*ignoreErrors*/
	        true
	      ) : resolveAlias(typeOnlyDeclaration.symbol));
	      const typeOnlyExportStarTargets = typeOnlyDeclarationIsExportStar && typeOnlyResolution ? getExportsOfModule(typeOnlyResolution) : void 0;
	      let flags = excludeLocalMeanings ? 0 /* None */ : symbol.flags;
	      let seenSymbols;
	      while (symbol.flags & 2097152 /* Alias */) {
	        const target = getExportSymbolOfValueSymbolIfExported(resolveAlias(symbol));
	        if (!typeOnlyDeclarationIsExportStar && target === typeOnlyResolution || (typeOnlyExportStarTargets == null ? void 0 : typeOnlyExportStarTargets.get(target.escapedName)) === target) {
	          break;
	        }
	        if (target === unknownSymbol) {
	          return -1 /* All */;
	        }
	        if (target === symbol || (seenSymbols == null ? void 0 : seenSymbols.has(target))) {
	          break;
	        }
	        if (target.flags & 2097152 /* Alias */) {
	          if (seenSymbols) {
	            seenSymbols.add(target);
	          } else {
	            seenSymbols = /* @__PURE__ */ new Set([symbol, target]);
	          }
	        }
	        flags |= target.flags;
	        symbol = target;
	      }
	      return flags;
	    }
	    function markSymbolOfAliasDeclarationIfTypeOnly(aliasDeclaration, immediateTarget, finalTarget, overwriteEmpty, exportStarDeclaration, exportStarName) {
	      if (!aliasDeclaration || isPropertyAccessExpression(aliasDeclaration))
	        return false;
	      const sourceSymbol = getSymbolOfDeclaration(aliasDeclaration);
	      if (isTypeOnlyImportOrExportDeclaration(aliasDeclaration)) {
	        const links2 = getSymbolLinks(sourceSymbol);
	        links2.typeOnlyDeclaration = aliasDeclaration;
	        return true;
	      }
	      if (exportStarDeclaration) {
	        const links2 = getSymbolLinks(sourceSymbol);
	        links2.typeOnlyDeclaration = exportStarDeclaration;
	        if (sourceSymbol.escapedName !== exportStarName) {
	          links2.typeOnlyExportStarName = exportStarName;
	        }
	        return true;
	      }
	      const links = getSymbolLinks(sourceSymbol);
	      return markSymbolOfAliasDeclarationIfTypeOnlyWorker(links, immediateTarget, overwriteEmpty) || markSymbolOfAliasDeclarationIfTypeOnlyWorker(links, finalTarget, overwriteEmpty);
	    }
	    function markSymbolOfAliasDeclarationIfTypeOnlyWorker(aliasDeclarationLinks, target, overwriteEmpty) {
	      var _a;
	      if (target && (aliasDeclarationLinks.typeOnlyDeclaration === void 0 || overwriteEmpty && aliasDeclarationLinks.typeOnlyDeclaration === false)) {
	        const exportSymbol = ((_a = target.exports) == null ? void 0 : _a.get("export=" /* ExportEquals */)) ?? target;
	        const typeOnly = exportSymbol.declarations && find(exportSymbol.declarations, isTypeOnlyImportOrExportDeclaration);
	        aliasDeclarationLinks.typeOnlyDeclaration = typeOnly ?? getSymbolLinks(exportSymbol).typeOnlyDeclaration ?? false;
	      }
	      return !!aliasDeclarationLinks.typeOnlyDeclaration;
	    }
	    function getTypeOnlyAliasDeclaration(symbol, include) {
	      if (!(symbol.flags & 2097152 /* Alias */)) {
	        return void 0;
	      }
	      const links = getSymbolLinks(symbol);
	      if (include === void 0) {
	        return links.typeOnlyDeclaration || void 0;
	      }
	      if (links.typeOnlyDeclaration) {
	        const resolved = links.typeOnlyDeclaration.kind === 278 /* ExportDeclaration */ ? resolveSymbol(getExportsOfModule(links.typeOnlyDeclaration.symbol.parent).get(links.typeOnlyExportStarName || symbol.escapedName)) : resolveAlias(links.typeOnlyDeclaration.symbol);
	        return getSymbolFlags(resolved) & include ? links.typeOnlyDeclaration : void 0;
	      }
	      return void 0;
	    }
	    function markExportAsReferenced(node) {
	      if (!canCollectSymbolAliasAccessabilityData) {
	        return;
	      }
	      const symbol = getSymbolOfDeclaration(node);
	      const target = resolveAlias(symbol);
	      if (target) {
	        const markAlias = target === unknownSymbol || getSymbolFlags(
	          symbol,
	          /*excludeTypeOnlyMeanings*/
	          true
	        ) & 111551 /* Value */ && !isConstEnumOrConstEnumOnlyModule(target);
	        if (markAlias) {
	          markAliasSymbolAsReferenced(symbol);
	        }
	      }
	    }
	    function markAliasSymbolAsReferenced(symbol) {
	      Debug.assert(canCollectSymbolAliasAccessabilityData);
	      const links = getSymbolLinks(symbol);
	      if (!links.referenced) {
	        links.referenced = true;
	        const node = getDeclarationOfAliasSymbol(symbol);
	        if (!node)
	          return Debug.fail();
	        if (isInternalModuleImportEqualsDeclaration(node)) {
	          if (getSymbolFlags(resolveSymbol(symbol)) & 111551 /* Value */) {
	            checkExpressionCached(node.moduleReference);
	          }
	        }
	      }
	    }
	    function markConstEnumAliasAsReferenced(symbol) {
	      const links = getSymbolLinks(symbol);
	      if (!links.constEnumReferenced) {
	        links.constEnumReferenced = true;
	      }
	    }
	    function getSymbolOfPartOfRightHandSideOfImportEquals(entityName, dontResolveAlias) {
	      if (entityName.kind === 80 /* Identifier */ && isRightSideOfQualifiedNameOrPropertyAccess(entityName)) {
	        entityName = entityName.parent;
	      }
	      if (entityName.kind === 80 /* Identifier */ || entityName.parent.kind === 166 /* QualifiedName */) {
	        return resolveEntityName(
	          entityName,
	          1920 /* Namespace */,
	          /*ignoreErrors*/
	          false,
	          dontResolveAlias
	        );
	      } else {
	        Debug.assert(entityName.parent.kind === 271 /* ImportEqualsDeclaration */);
	        return resolveEntityName(
	          entityName,
	          111551 /* Value */ | 788968 /* Type */ | 1920 /* Namespace */,
	          /*ignoreErrors*/
	          false,
	          dontResolveAlias
	        );
	      }
	    }
	    function getFullyQualifiedName(symbol, containingLocation) {
	      return symbol.parent ? getFullyQualifiedName(symbol.parent, containingLocation) + "." + symbolToString(symbol) : symbolToString(
	        symbol,
	        containingLocation,
	        /*meaning*/
	        void 0,
	        32 /* DoNotIncludeSymbolChain */ | 4 /* AllowAnyNodeKind */
	      );
	    }
	    function getContainingQualifiedNameNode(node) {
	      while (isQualifiedName(node.parent)) {
	        node = node.parent;
	      }
	      return node;
	    }
	    function tryGetQualifiedNameAsValue(node) {
	      let left = getFirstIdentifier(node);
	      let symbol = resolveName(
	        left,
	        left.escapedText,
	        111551 /* Value */,
	        /*nameNotFoundMessage*/
	        void 0,
	        left,
	        /*isUse*/
	        true
	      );
	      if (!symbol) {
	        return void 0;
	      }
	      while (isQualifiedName(left.parent)) {
	        const type = getTypeOfSymbol(symbol);
	        symbol = getPropertyOfType(type, left.parent.right.escapedText);
	        if (!symbol) {
	          return void 0;
	        }
	        left = left.parent;
	      }
	      return symbol;
	    }
	    function resolveEntityName(name, meaning, ignoreErrors, dontResolveAlias, location) {
	      if (nodeIsMissing(name)) {
	        return void 0;
	      }
	      const namespaceMeaning = 1920 /* Namespace */ | (isInJSFile(name) ? meaning & 111551 /* Value */ : 0);
	      let symbol;
	      if (name.kind === 80 /* Identifier */) {
	        const message = meaning === namespaceMeaning || nodeIsSynthesized(name) ? Diagnostics.Cannot_find_namespace_0 : getCannotFindNameDiagnosticForName(getFirstIdentifier(name));
	        const symbolFromJSPrototype = isInJSFile(name) && !nodeIsSynthesized(name) ? resolveEntityNameFromAssignmentDeclaration(name, meaning) : void 0;
	        symbol = getMergedSymbol(resolveName(
	          location || name,
	          name.escapedText,
	          meaning,
	          ignoreErrors || symbolFromJSPrototype ? void 0 : message,
	          name,
	          /*isUse*/
	          true,
	          /*excludeGlobals*/
	          false
	        ));
	        if (!symbol) {
	          return getMergedSymbol(symbolFromJSPrototype);
	        }
	      } else if (name.kind === 166 /* QualifiedName */ || name.kind === 211 /* PropertyAccessExpression */) {
	        const left = name.kind === 166 /* QualifiedName */ ? name.left : name.expression;
	        const right = name.kind === 166 /* QualifiedName */ ? name.right : name.name;
	        let namespace = resolveEntityName(
	          left,
	          namespaceMeaning,
	          ignoreErrors,
	          /*dontResolveAlias*/
	          false,
	          location
	        );
	        if (!namespace || nodeIsMissing(right)) {
	          return void 0;
	        } else if (namespace === unknownSymbol) {
	          return namespace;
	        }
	        if (namespace.valueDeclaration && isInJSFile(namespace.valueDeclaration) && getEmitModuleResolutionKind(compilerOptions) !== 100 /* Bundler */ && isVariableDeclaration(namespace.valueDeclaration) && namespace.valueDeclaration.initializer && isCommonJsRequire(namespace.valueDeclaration.initializer)) {
	          const moduleName = namespace.valueDeclaration.initializer.arguments[0];
	          const moduleSym = resolveExternalModuleName(moduleName, moduleName);
	          if (moduleSym) {
	            const resolvedModuleSymbol = resolveExternalModuleSymbol(moduleSym);
	            if (resolvedModuleSymbol) {
	              namespace = resolvedModuleSymbol;
	            }
	          }
	        }
	        symbol = getMergedSymbol(getSymbol2(getExportsOfSymbol(namespace), right.escapedText, meaning));
	        if (!symbol && namespace.flags & 2097152 /* Alias */) {
	          symbol = getMergedSymbol(getSymbol2(getExportsOfSymbol(resolveAlias(namespace)), right.escapedText, meaning));
	        }
	        if (!symbol) {
	          if (!ignoreErrors) {
	            const namespaceName = getFullyQualifiedName(namespace);
	            const declarationName = declarationNameToString(right);
	            const suggestionForNonexistentModule = getSuggestedSymbolForNonexistentModule(right, namespace);
	            if (suggestionForNonexistentModule) {
	              error2(right, Diagnostics._0_has_no_exported_member_named_1_Did_you_mean_2, namespaceName, declarationName, symbolToString(suggestionForNonexistentModule));
	              return void 0;
	            }
	            const containingQualifiedName = isQualifiedName(name) && getContainingQualifiedNameNode(name);
	            const canSuggestTypeof = globalObjectType && meaning & 788968 /* Type */ && containingQualifiedName && !isTypeOfExpression(containingQualifiedName.parent) && tryGetQualifiedNameAsValue(containingQualifiedName);
	            if (canSuggestTypeof) {
	              error2(
	                containingQualifiedName,
	                Diagnostics._0_refers_to_a_value_but_is_being_used_as_a_type_here_Did_you_mean_typeof_0,
	                entityNameToString(containingQualifiedName)
	              );
	              return void 0;
	            }
	            if (meaning & 1920 /* Namespace */ && isQualifiedName(name.parent)) {
	              const exportedTypeSymbol = getMergedSymbol(getSymbol2(getExportsOfSymbol(namespace), right.escapedText, 788968 /* Type */));
	              if (exportedTypeSymbol) {
	                error2(
	                  name.parent.right,
	                  Diagnostics.Cannot_access_0_1_because_0_is_a_type_but_not_a_namespace_Did_you_mean_to_retrieve_the_type_of_the_property_1_in_0_with_0_1,
	                  symbolToString(exportedTypeSymbol),
	                  unescapeLeadingUnderscores(name.parent.right.escapedText)
	                );
	                return void 0;
	              }
	            }
	            error2(right, Diagnostics.Namespace_0_has_no_exported_member_1, namespaceName, declarationName);
	          }
	          return void 0;
	        }
	      } else {
	        Debug.assertNever(name, "Unknown entity name kind.");
	      }
	      Debug.assert((getCheckFlags(symbol) & 1 /* Instantiated */) === 0, "Should never get an instantiated symbol here.");
	      if (!nodeIsSynthesized(name) && isEntityName(name) && (symbol.flags & 2097152 /* Alias */ || name.parent.kind === 277 /* ExportAssignment */)) {
	        markSymbolOfAliasDeclarationIfTypeOnly(
	          getAliasDeclarationFromName(name),
	          symbol,
	          /*finalTarget*/
	          void 0,
	          /*overwriteEmpty*/
	          true
	        );
	      }
	      return symbol.flags & meaning || dontResolveAlias ? symbol : resolveAlias(symbol);
	    }
	    function resolveEntityNameFromAssignmentDeclaration(name, meaning) {
	      if (isJSDocTypeReference(name.parent)) {
	        const secondaryLocation = getAssignmentDeclarationLocation(name.parent);
	        if (secondaryLocation) {
	          return resolveName(
	            secondaryLocation,
	            name.escapedText,
	            meaning,
	            /*nameNotFoundMessage*/
	            void 0,
	            name,
	            /*isUse*/
	            true
	          );
	        }
	      }
	    }
	    function getAssignmentDeclarationLocation(node) {
	      const typeAlias = findAncestor(node, (node2) => !(isJSDocNode(node2) || node2.flags & 16777216 /* JSDoc */) ? "quit" : isJSDocTypeAlias(node2));
	      if (typeAlias) {
	        return;
	      }
	      const host2 = getJSDocHost(node);
	      if (host2 && isExpressionStatement(host2) && isPrototypePropertyAssignment(host2.expression)) {
	        const symbol = getSymbolOfDeclaration(host2.expression.left);
	        if (symbol) {
	          return getDeclarationOfJSPrototypeContainer(symbol);
	        }
	      }
	      if (host2 && isFunctionExpression(host2) && isPrototypePropertyAssignment(host2.parent) && isExpressionStatement(host2.parent.parent)) {
	        const symbol = getSymbolOfDeclaration(host2.parent.left);
	        if (symbol) {
	          return getDeclarationOfJSPrototypeContainer(symbol);
	        }
	      }
	      if (host2 && (isObjectLiteralMethod(host2) || isPropertyAssignment(host2)) && isBinaryExpression(host2.parent.parent) && getAssignmentDeclarationKind(host2.parent.parent) === 6 /* Prototype */) {
	        const symbol = getSymbolOfDeclaration(host2.parent.parent.left);
	        if (symbol) {
	          return getDeclarationOfJSPrototypeContainer(symbol);
	        }
	      }
	      const sig = getEffectiveJSDocHost(node);
	      if (sig && isFunctionLike(sig)) {
	        const symbol = getSymbolOfDeclaration(sig);
	        return symbol && symbol.valueDeclaration;
	      }
	    }
	    function getDeclarationOfJSPrototypeContainer(symbol) {
	      const decl = symbol.parent.valueDeclaration;
	      if (!decl) {
	        return void 0;
	      }
	      const initializer = isAssignmentDeclaration(decl) ? getAssignedExpandoInitializer(decl) : hasOnlyExpressionInitializer(decl) ? getDeclaredExpandoInitializer(decl) : void 0;
	      return initializer || decl;
	    }
	    function getExpandoSymbol(symbol) {
	      const decl = symbol.valueDeclaration;
	      if (!decl || !isInJSFile(decl) || symbol.flags & 524288 /* TypeAlias */ || getExpandoInitializer(
	        decl,
	        /*isPrototypeAssignment*/
	        false
	      )) {
	        return void 0;
	      }
	      const init = isVariableDeclaration(decl) ? getDeclaredExpandoInitializer(decl) : getAssignedExpandoInitializer(decl);
	      if (init) {
	        const initSymbol = getSymbolOfNode(init);
	        if (initSymbol) {
	          return mergeJSSymbols(initSymbol, symbol);
	        }
	      }
	    }
	    function resolveExternalModuleName(location, moduleReferenceExpression, ignoreErrors) {
	      const isClassic = getEmitModuleResolutionKind(compilerOptions) === 1 /* Classic */;
	      const errorMessage = isClassic ? Diagnostics.Cannot_find_module_0_Did_you_mean_to_set_the_moduleResolution_option_to_nodenext_or_to_add_aliases_to_the_paths_option : Diagnostics.Cannot_find_module_0_or_its_corresponding_type_declarations;
	      return resolveExternalModuleNameWorker(location, moduleReferenceExpression, ignoreErrors ? void 0 : errorMessage);
	    }
	    function resolveExternalModuleNameWorker(location, moduleReferenceExpression, moduleNotFoundError, isForAugmentation = false) {
	      return isStringLiteralLike(moduleReferenceExpression) ? resolveExternalModule(location, moduleReferenceExpression.text, moduleNotFoundError, moduleReferenceExpression, isForAugmentation) : void 0;
	    }
	    function resolveExternalModule(location, moduleReference, moduleNotFoundError, errorNode, isForAugmentation = false) {
	      var _a, _b, _c, _d, _e, _f, _g, _h, _i, _j, _k;
	      if (startsWith(moduleReference, "@types/")) {
	        const diag2 = Diagnostics.Cannot_import_type_declaration_files_Consider_importing_0_instead_of_1;
	        const withoutAtTypePrefix = removePrefix(moduleReference, "@types/");
	        error2(errorNode, diag2, withoutAtTypePrefix, moduleReference);
	      }
	      const ambientModule = tryFindAmbientModule(
	        moduleReference,
	        /*withAugmentations*/
	        true
	      );
	      if (ambientModule) {
	        return ambientModule;
	      }
	      const currentSourceFile = getSourceFileOfNode(location);
	      const contextSpecifier = isStringLiteralLike(location) ? location : ((_a = isModuleDeclaration(location) ? location : location.parent && isModuleDeclaration(location.parent) && location.parent.name === location ? location.parent : void 0) == null ? void 0 : _a.name) || ((_b = isLiteralImportTypeNode(location) ? location : void 0) == null ? void 0 : _b.argument.literal) || (isVariableDeclaration(location) && location.initializer && isRequireCall(
	        location.initializer,
	        /*requireStringLiteralLikeArgument*/
	        true
	      ) ? location.initializer.arguments[0] : void 0) || ((_c = findAncestor(location, isImportCall)) == null ? void 0 : _c.arguments[0]) || ((_d = findAncestor(location, isImportDeclaration)) == null ? void 0 : _d.moduleSpecifier) || ((_e = findAncestor(location, isExternalModuleImportEqualsDeclaration)) == null ? void 0 : _e.moduleReference.expression) || ((_f = findAncestor(location, isExportDeclaration)) == null ? void 0 : _f.moduleSpecifier);
	      const mode = contextSpecifier && isStringLiteralLike(contextSpecifier) ? host.getModeForUsageLocation(currentSourceFile, contextSpecifier) : currentSourceFile.impliedNodeFormat;
	      const moduleResolutionKind = getEmitModuleResolutionKind(compilerOptions);
	      const resolvedModule = (_g = host.getResolvedModule(currentSourceFile, moduleReference, mode)) == null ? void 0 : _g.resolvedModule;
	      const resolutionDiagnostic = resolvedModule && getResolutionDiagnostic(compilerOptions, resolvedModule, currentSourceFile);
	      const sourceFile = resolvedModule && (!resolutionDiagnostic || resolutionDiagnostic === Diagnostics.Module_0_was_resolved_to_1_but_jsx_is_not_set) && host.getSourceFile(resolvedModule.resolvedFileName);
	      if (sourceFile) {
	        if (resolutionDiagnostic) {
	          error2(errorNode, resolutionDiagnostic, moduleReference, resolvedModule.resolvedFileName);
	        }
	        if (resolvedModule.resolvedUsingTsExtension && isDeclarationFileName(moduleReference)) {
	          const importOrExport = ((_h = findAncestor(location, isImportDeclaration)) == null ? void 0 : _h.importClause) || findAncestor(location, or(isImportEqualsDeclaration, isExportDeclaration));
	          if (importOrExport && !importOrExport.isTypeOnly || findAncestor(location, isImportCall)) {
	            error2(
	              errorNode,
	              Diagnostics.A_declaration_file_cannot_be_imported_without_import_type_Did_you_mean_to_import_an_implementation_file_0_instead,
	              getSuggestedImportSource(Debug.checkDefined(tryExtractTSExtension(moduleReference)))
	            );
	          }
	        } else if (resolvedModule.resolvedUsingTsExtension && !shouldAllowImportingTsExtension(compilerOptions, currentSourceFile.fileName)) {
	          const importOrExport = ((_i = findAncestor(location, isImportDeclaration)) == null ? void 0 : _i.importClause) || findAncestor(location, or(isImportEqualsDeclaration, isExportDeclaration));
	          if (!((importOrExport == null ? void 0 : importOrExport.isTypeOnly) || findAncestor(location, isImportTypeNode))) {
	            const tsExtension = Debug.checkDefined(tryExtractTSExtension(moduleReference));
	            error2(errorNode, Diagnostics.An_import_path_can_only_end_with_a_0_extension_when_allowImportingTsExtensions_is_enabled, tsExtension);
	          }
	        }
	        if (sourceFile.symbol) {
	          if (resolvedModule.isExternalLibraryImport && !resolutionExtensionIsTSOrJson(resolvedModule.extension)) {
	            errorOnImplicitAnyModule(
	              /*isError*/
	              false,
	              errorNode,
	              currentSourceFile,
	              mode,
	              resolvedModule,
	              moduleReference
	            );
	          }
	          if (moduleResolutionKind === 3 /* Node16 */ || moduleResolutionKind === 99 /* NodeNext */) {
	            const isSyncImport = currentSourceFile.impliedNodeFormat === 1 /* CommonJS */ && !findAncestor(location, isImportCall) || !!findAncestor(location, isImportEqualsDeclaration);
	            const overrideHost = findAncestor(location, (l) => isImportTypeNode(l) || isExportDeclaration(l) || isImportDeclaration(l));
	            if (isSyncImport && sourceFile.impliedNodeFormat === 99 /* ESNext */ && !hasResolutionModeOverride(overrideHost)) {
	              if (findAncestor(location, isImportEqualsDeclaration)) {
	                error2(errorNode, Diagnostics.Module_0_cannot_be_imported_using_this_construct_The_specifier_only_resolves_to_an_ES_module_which_cannot_be_imported_with_require_Use_an_ECMAScript_import_instead, moduleReference);
	              } else {
	                let diagnosticDetails;
	                const ext = tryGetExtensionFromPath2(currentSourceFile.fileName);
	                if (ext === ".ts" /* Ts */ || ext === ".js" /* Js */ || ext === ".tsx" /* Tsx */ || ext === ".jsx" /* Jsx */) {
	                  const scope = currentSourceFile.packageJsonScope;
	                  const targetExt = ext === ".ts" /* Ts */ ? ".mts" /* Mts */ : ext === ".js" /* Js */ ? ".mjs" /* Mjs */ : void 0;
	                  if (scope && !scope.contents.packageJsonContent.type) {
	                    if (targetExt) {
	                      diagnosticDetails = chainDiagnosticMessages(
	                        /*details*/
	                        void 0,
	                        Diagnostics.To_convert_this_file_to_an_ECMAScript_module_change_its_file_extension_to_0_or_add_the_field_type_Colon_module_to_1,
	                        targetExt,
	                        combinePaths(scope.packageDirectory, "package.json")
	                      );
	                    } else {
	                      diagnosticDetails = chainDiagnosticMessages(
	                        /*details*/
	                        void 0,
	                        Diagnostics.To_convert_this_file_to_an_ECMAScript_module_add_the_field_type_Colon_module_to_0,
	                        combinePaths(scope.packageDirectory, "package.json")
	                      );
	                    }
	                  } else {
	                    if (targetExt) {
	                      diagnosticDetails = chainDiagnosticMessages(
	                        /*details*/
	                        void 0,
	                        Diagnostics.To_convert_this_file_to_an_ECMAScript_module_change_its_file_extension_to_0_or_create_a_local_package_json_file_with_type_Colon_module,
	                        targetExt
	                      );
	                    } else {
	                      diagnosticDetails = chainDiagnosticMessages(
	                        /*details*/
	                        void 0,
	                        Diagnostics.To_convert_this_file_to_an_ECMAScript_module_create_a_local_package_json_file_with_type_Colon_module
	                      );
	                    }
	                  }
	                }
	                diagnostics.add(createDiagnosticForNodeFromMessageChain(
	                  getSourceFileOfNode(errorNode),
	                  errorNode,
	                  chainDiagnosticMessages(
	                    diagnosticDetails,
	                    Diagnostics.The_current_file_is_a_CommonJS_module_whose_imports_will_produce_require_calls_however_the_referenced_file_is_an_ECMAScript_module_and_cannot_be_imported_with_require_Consider_writing_a_dynamic_import_0_call_instead,
	                    moduleReference
	                  )
	                ));
	              }
	            }
	          }
	          return getMergedSymbol(sourceFile.symbol);
	        }
	        if (moduleNotFoundError) {
	          error2(errorNode, Diagnostics.File_0_is_not_a_module, sourceFile.fileName);
	        }
	        return void 0;
	      }
	      if (patternAmbientModules) {
	        const pattern = findBestPatternMatch(patternAmbientModules, (_) => _.pattern, moduleReference);
	        if (pattern) {
	          const augmentation = patternAmbientModuleAugmentations && patternAmbientModuleAugmentations.get(moduleReference);
	          if (augmentation) {
	            return getMergedSymbol(augmentation);
	          }
	          return getMergedSymbol(pattern.symbol);
	        }
	      }
	      if (resolvedModule && !resolutionExtensionIsTSOrJson(resolvedModule.extension) && resolutionDiagnostic === void 0 || resolutionDiagnostic === Diagnostics.Could_not_find_a_declaration_file_for_module_0_1_implicitly_has_an_any_type) {
	        if (isForAugmentation) {
	          const diag2 = Diagnostics.Invalid_module_name_in_augmentation_Module_0_resolves_to_an_untyped_module_at_1_which_cannot_be_augmented;
	          error2(errorNode, diag2, moduleReference, resolvedModule.resolvedFileName);
	        } else {
	          errorOnImplicitAnyModule(
	            /*isError*/
	            noImplicitAny && !!moduleNotFoundError,
	            errorNode,
	            currentSourceFile,
	            mode,
	            resolvedModule,
	            moduleReference
	          );
	        }
	        return void 0;
	      }
	      if (moduleNotFoundError) {
	        if (resolvedModule) {
	          const redirect = host.getProjectReferenceRedirect(resolvedModule.resolvedFileName);
	          if (redirect) {
	            error2(errorNode, Diagnostics.Output_file_0_has_not_been_built_from_source_file_1, redirect, resolvedModule.resolvedFileName);
	            return void 0;
	          }
	        }
	        if (resolutionDiagnostic) {
	          error2(errorNode, resolutionDiagnostic, moduleReference, resolvedModule.resolvedFileName);
	        } else {
	          const isExtensionlessRelativePathImport = pathIsRelative(moduleReference) && !hasExtension(moduleReference);
	          const resolutionIsNode16OrNext = moduleResolutionKind === 3 /* Node16 */ || moduleResolutionKind === 99 /* NodeNext */;
	          if (!getResolveJsonModule(compilerOptions) && fileExtensionIs(moduleReference, ".json" /* Json */) && moduleResolutionKind !== 1 /* Classic */ && hasJsonModuleEmitEnabled(compilerOptions)) {
	            error2(errorNode, Diagnostics.Cannot_find_module_0_Consider_using_resolveJsonModule_to_import_module_with_json_extension, moduleReference);
	          } else if (mode === 99 /* ESNext */ && resolutionIsNode16OrNext && isExtensionlessRelativePathImport) {
	            const absoluteRef = getNormalizedAbsolutePath(moduleReference, getDirectoryPath(currentSourceFile.path));
	            const suggestedExt = (_j = suggestedExtensions.find(([actualExt, _importExt]) => host.fileExists(absoluteRef + actualExt))) == null ? void 0 : _j[1];
	            if (suggestedExt) {
	              error2(errorNode, Diagnostics.Relative_import_paths_need_explicit_file_extensions_in_ECMAScript_imports_when_moduleResolution_is_node16_or_nodenext_Did_you_mean_0, moduleReference + suggestedExt);
	            } else {
	              error2(errorNode, Diagnostics.Relative_import_paths_need_explicit_file_extensions_in_ECMAScript_imports_when_moduleResolution_is_node16_or_nodenext_Consider_adding_an_extension_to_the_import_path);
	            }
	          } else {
	            if ((_k = host.getResolvedModule(currentSourceFile, moduleReference, mode)) == null ? void 0 : _k.alternateResult) {
	              const errorInfo = createModuleNotFoundChain(currentSourceFile, host, moduleReference, mode, moduleReference);
	              errorOrSuggestion(
	                /*isError*/
	                true,
	                errorNode,
	                chainDiagnosticMessages(errorInfo, moduleNotFoundError, moduleReference)
	              );
	            } else {
	              error2(errorNode, moduleNotFoundError, moduleReference);
	            }
	          }
	        }
	      }
	      return void 0;
	      function getSuggestedImportSource(tsExtension) {
	        const importSourceWithoutExtension = removeExtension(moduleReference, tsExtension);
	        if (emitModuleKindIsNonNodeESM(moduleKind) || mode === 99 /* ESNext */) {
	          const preferTs = isDeclarationFileName(moduleReference) && shouldAllowImportingTsExtension(compilerOptions);
	          const ext = tsExtension === ".mts" /* Mts */ || tsExtension === ".d.mts" /* Dmts */ ? preferTs ? ".mts" : ".mjs" : tsExtension === ".cts" /* Cts */ || tsExtension === ".d.mts" /* Dmts */ ? preferTs ? ".cts" : ".cjs" : preferTs ? ".ts" : ".js";
	          return importSourceWithoutExtension + ext;
	        }
	        return importSourceWithoutExtension;
	      }
	    }
	    function errorOnImplicitAnyModule(isError, errorNode, sourceFile, mode, { packageId, resolvedFileName }, moduleReference) {
	      let errorInfo;
	      if (!isExternalModuleNameRelative(moduleReference) && packageId) {
	        errorInfo = createModuleNotFoundChain(sourceFile, host, moduleReference, mode, packageId.name);
	      }
	      errorOrSuggestion(
	        isError,
	        errorNode,
	        chainDiagnosticMessages(
	          errorInfo,
	          Diagnostics.Could_not_find_a_declaration_file_for_module_0_1_implicitly_has_an_any_type,
	          moduleReference,
	          resolvedFileName
	        )
	      );
	    }
	    function resolveExternalModuleSymbol(moduleSymbol, dontResolveAlias) {
	      if (moduleSymbol == null ? void 0 : moduleSymbol.exports) {
	        const exportEquals = resolveSymbol(moduleSymbol.exports.get("export=" /* ExportEquals */), dontResolveAlias);
	        const exported = getCommonJsExportEquals(getMergedSymbol(exportEquals), getMergedSymbol(moduleSymbol));
	        return getMergedSymbol(exported) || moduleSymbol;
	      }
	      return void 0;
	    }
	    function getCommonJsExportEquals(exported, moduleSymbol) {
	      if (!exported || exported === unknownSymbol || exported === moduleSymbol || moduleSymbol.exports.size === 1 || exported.flags & 2097152 /* Alias */) {
	        return exported;
	      }
	      const links = getSymbolLinks(exported);
	      if (links.cjsExportMerged) {
	        return links.cjsExportMerged;
	      }
	      const merged = exported.flags & 33554432 /* Transient */ ? exported : cloneSymbol(exported);
	      merged.flags = merged.flags | 512 /* ValueModule */;
	      if (merged.exports === void 0) {
	        merged.exports = createSymbolTable();
	      }
	      moduleSymbol.exports.forEach((s, name) => {
	        if (name === "export=" /* ExportEquals */)
	          return;
	        merged.exports.set(name, merged.exports.has(name) ? mergeSymbol(merged.exports.get(name), s) : s);
	      });
	      if (merged === exported) {
	        getSymbolLinks(merged).resolvedExports = void 0;
	        getSymbolLinks(merged).resolvedMembers = void 0;
	      }
	      getSymbolLinks(merged).cjsExportMerged = merged;
	      return links.cjsExportMerged = merged;
	    }
	    function resolveESModuleSymbol(moduleSymbol, referencingLocation, dontResolveAlias, suppressInteropError) {
	      var _a;
	      const symbol = resolveExternalModuleSymbol(moduleSymbol, dontResolveAlias);
	      if (!dontResolveAlias && symbol) {
	        if (!suppressInteropError && !(symbol.flags & (1536 /* Module */ | 3 /* Variable */)) && !getDeclarationOfKind(symbol, 312 /* SourceFile */)) {
	          const compilerOptionName = moduleKind >= 5 /* ES2015 */ ? "allowSyntheticDefaultImports" : "esModuleInterop";
	          error2(referencingLocation, Diagnostics.This_module_can_only_be_referenced_with_ECMAScript_imports_Slashexports_by_turning_on_the_0_flag_and_referencing_its_default_export, compilerOptionName);
	          return symbol;
	        }
	        const referenceParent = referencingLocation.parent;
	        if (isImportDeclaration(referenceParent) && getNamespaceDeclarationNode(referenceParent) || isImportCall(referenceParent)) {
	          const reference = isImportCall(referenceParent) ? referenceParent.arguments[0] : referenceParent.moduleSpecifier;
	          const type = getTypeOfSymbol(symbol);
	          const defaultOnlyType = getTypeWithSyntheticDefaultOnly(type, symbol, moduleSymbol, reference);
	          if (defaultOnlyType) {
	            return cloneTypeAsModuleType(symbol, defaultOnlyType, referenceParent);
	          }
	          const targetFile = (_a = moduleSymbol == null ? void 0 : moduleSymbol.declarations) == null ? void 0 : _a.find(isSourceFile);
	          const isEsmCjsRef = targetFile && isESMFormatImportImportingCommonjsFormatFile(getUsageModeForExpression(reference), targetFile.impliedNodeFormat);
	          if (getESModuleInterop(compilerOptions) || isEsmCjsRef) {
	            let sigs = getSignaturesOfStructuredType(type, 0 /* Call */);
	            if (!sigs || !sigs.length) {
	              sigs = getSignaturesOfStructuredType(type, 1 /* Construct */);
	            }
	            if (sigs && sigs.length || getPropertyOfType(
	              type,
	              "default" /* Default */,
	              /*skipObjectFunctionPropertyAugment*/
	              true
	            ) || isEsmCjsRef) {
	              const moduleType = type.flags & 3670016 /* StructuredType */ ? getTypeWithSyntheticDefaultImportType(type, symbol, moduleSymbol, reference) : createDefaultPropertyWrapperForModule(symbol, symbol.parent);
	              return cloneTypeAsModuleType(symbol, moduleType, referenceParent);
	            }
	          }
	        }
	      }
	      return symbol;
	    }
	    function cloneTypeAsModuleType(symbol, moduleType, referenceParent) {
	      const result = createSymbol(symbol.flags, symbol.escapedName);
	      result.declarations = symbol.declarations ? symbol.declarations.slice() : [];
	      result.parent = symbol.parent;
	      result.links.target = symbol;
	      result.links.originatingImport = referenceParent;
	      if (symbol.valueDeclaration)
	        result.valueDeclaration = symbol.valueDeclaration;
	      if (symbol.constEnumOnlyModule)
	        result.constEnumOnlyModule = true;
	      if (symbol.members)
	        result.members = new Map(symbol.members);
	      if (symbol.exports)
	        result.exports = new Map(symbol.exports);
	      const resolvedModuleType = resolveStructuredTypeMembers(moduleType);
	      result.links.type = createAnonymousType(result, resolvedModuleType.members, emptyArray, emptyArray, resolvedModuleType.indexInfos);
	      return result;
	    }
	    function hasExportAssignmentSymbol(moduleSymbol) {
	      return moduleSymbol.exports.get("export=" /* ExportEquals */) !== void 0;
	    }
	    function getExportsOfModuleAsArray(moduleSymbol) {
	      return symbolsToArray(getExportsOfModule(moduleSymbol));
	    }
	    function getExportsAndPropertiesOfModule(moduleSymbol) {
	      const exports = getExportsOfModuleAsArray(moduleSymbol);
	      const exportEquals = resolveExternalModuleSymbol(moduleSymbol);
	      if (exportEquals !== moduleSymbol) {
	        const type = getTypeOfSymbol(exportEquals);
	        if (shouldTreatPropertiesOfExternalModuleAsExports(type)) {
	          addRange(exports, getPropertiesOfType(type));
	        }
	      }
	      return exports;
	    }
	    function forEachExportAndPropertyOfModule(moduleSymbol, cb) {
	      const exports = getExportsOfModule(moduleSymbol);
	      exports.forEach((symbol, key) => {
	        if (!isReservedMemberName(key)) {
	          cb(symbol, key);
	        }
	      });
	      const exportEquals = resolveExternalModuleSymbol(moduleSymbol);
	      if (exportEquals !== moduleSymbol) {
	        const type = getTypeOfSymbol(exportEquals);
	        if (shouldTreatPropertiesOfExternalModuleAsExports(type)) {
	          forEachPropertyOfType(type, (symbol, escapedName) => {
	            cb(symbol, escapedName);
	          });
	        }
	      }
	    }
	    function tryGetMemberInModuleExports(memberName, moduleSymbol) {
	      const symbolTable = getExportsOfModule(moduleSymbol);
	      if (symbolTable) {
	        return symbolTable.get(memberName);
	      }
	    }
	    function tryGetMemberInModuleExportsAndProperties(memberName, moduleSymbol) {
	      const symbol = tryGetMemberInModuleExports(memberName, moduleSymbol);
	      if (symbol) {
	        return symbol;
	      }
	      const exportEquals = resolveExternalModuleSymbol(moduleSymbol);
	      if (exportEquals === moduleSymbol) {
	        return void 0;
	      }
	      const type = getTypeOfSymbol(exportEquals);
	      return shouldTreatPropertiesOfExternalModuleAsExports(type) ? getPropertyOfType(type, memberName) : void 0;
	    }
	    function shouldTreatPropertiesOfExternalModuleAsExports(resolvedExternalModuleType) {
	      return !(resolvedExternalModuleType.flags & 402784252 /* Primitive */ || getObjectFlags(resolvedExternalModuleType) & 1 /* Class */ || // `isArrayOrTupleLikeType` is too expensive to use in this auto-imports hot path
	      isArrayType(resolvedExternalModuleType) || isTupleType(resolvedExternalModuleType));
	    }
	    function getExportsOfSymbol(symbol) {
	      return symbol.flags & 6256 /* LateBindingContainer */ ? getResolvedMembersOrExportsOfSymbol(symbol, "resolvedExports" /* resolvedExports */) : symbol.flags & 1536 /* Module */ ? getExportsOfModule(symbol) : symbol.exports || emptySymbols;
	    }
	    function getExportsOfModule(moduleSymbol) {
	      const links = getSymbolLinks(moduleSymbol);
	      if (!links.resolvedExports) {
	        const { exports, typeOnlyExportStarMap } = getExportsOfModuleWorker(moduleSymbol);
	        links.resolvedExports = exports;
	        links.typeOnlyExportStarMap = typeOnlyExportStarMap;
	      }
	      return links.resolvedExports;
	    }
	    function extendExportSymbols(target, source, lookupTable, exportNode) {
	      if (!source)
	        return;
	      source.forEach((sourceSymbol, id) => {
	        if (id === "default" /* Default */)
	          return;
	        const targetSymbol = target.get(id);
	        if (!targetSymbol) {
	          target.set(id, sourceSymbol);
	          if (lookupTable && exportNode) {
	            lookupTable.set(id, {
	              specifierText: getTextOfNode(exportNode.moduleSpecifier)
	            });
	          }
	        } else if (lookupTable && exportNode && targetSymbol && resolveSymbol(targetSymbol) !== resolveSymbol(sourceSymbol)) {
	          const collisionTracker = lookupTable.get(id);
	          if (!collisionTracker.exportsWithDuplicate) {
	            collisionTracker.exportsWithDuplicate = [exportNode];
	          } else {
	            collisionTracker.exportsWithDuplicate.push(exportNode);
	          }
	        }
	      });
	    }
	    function getExportsOfModuleWorker(moduleSymbol) {
	      const visitedSymbols = [];
	      let typeOnlyExportStarMap;
	      const nonTypeOnlyNames = /* @__PURE__ */ new Set();
	      moduleSymbol = resolveExternalModuleSymbol(moduleSymbol);
	      const exports = visit(moduleSymbol) || emptySymbols;
	      if (typeOnlyExportStarMap) {
	        nonTypeOnlyNames.forEach((name) => typeOnlyExportStarMap.delete(name));
	      }
	      return {
	        exports,
	        typeOnlyExportStarMap
	      };
	      function visit(symbol, exportStar, isTypeOnly) {
	        if (!isTypeOnly && (symbol == null ? void 0 : symbol.exports)) {
	          symbol.exports.forEach((_, name) => nonTypeOnlyNames.add(name));
	        }
	        if (!(symbol && symbol.exports && pushIfUnique(visitedSymbols, symbol))) {
	          return;
	        }
	        const symbols = new Map(symbol.exports);
	        const exportStars = symbol.exports.get("__export" /* ExportStar */);
	        if (exportStars) {
	          const nestedSymbols = createSymbolTable();
	          const lookupTable = /* @__PURE__ */ new Map();
	          if (exportStars.declarations) {
	            for (const node of exportStars.declarations) {
	              const resolvedModule = resolveExternalModuleName(node, node.moduleSpecifier);
	              const exportedSymbols = visit(resolvedModule, node, isTypeOnly || node.isTypeOnly);
	              extendExportSymbols(
	                nestedSymbols,
	                exportedSymbols,
	                lookupTable,
	                node
	              );
	            }
	          }
	          lookupTable.forEach(({ exportsWithDuplicate }, id) => {
	            if (id === "export=" || !(exportsWithDuplicate && exportsWithDuplicate.length) || symbols.has(id)) {
	              return;
	            }
	            for (const node of exportsWithDuplicate) {
	              diagnostics.add(createDiagnosticForNode(
	                node,
	                Diagnostics.Module_0_has_already_exported_a_member_named_1_Consider_explicitly_re_exporting_to_resolve_the_ambiguity,
	                lookupTable.get(id).specifierText,
	                unescapeLeadingUnderscores(id)
	              ));
	            }
	          });
	          extendExportSymbols(symbols, nestedSymbols);
	        }
	        if (exportStar == null ? void 0 : exportStar.isTypeOnly) {
	          typeOnlyExportStarMap ?? (typeOnlyExportStarMap = /* @__PURE__ */ new Map());
	          symbols.forEach(
	            (_, escapedName) => typeOnlyExportStarMap.set(
	              escapedName,
	              exportStar
	            )
	          );
	        }
	        return symbols;
	      }
	    }
	    function getMergedSymbol(symbol) {
	      let merged;
	      return symbol && symbol.mergeId && (merged = mergedSymbols[symbol.mergeId]) ? merged : symbol;
	    }
	    function getSymbolOfDeclaration(node) {
	      return getMergedSymbol(node.symbol && getLateBoundSymbol(node.symbol));
	    }
	    function getSymbolOfNode(node) {
	      return canHaveSymbol(node) ? getSymbolOfDeclaration(node) : void 0;
	    }
	    function getParentOfSymbol(symbol) {
	      return getMergedSymbol(symbol.parent && getLateBoundSymbol(symbol.parent));
	    }
	    function getFunctionExpressionParentSymbolOrSymbol(symbol) {
	      var _a, _b;
	      return ((_a = symbol.valueDeclaration) == null ? void 0 : _a.kind) === 219 /* ArrowFunction */ || ((_b = symbol.valueDeclaration) == null ? void 0 : _b.kind) === 218 /* FunctionExpression */ ? getSymbolOfNode(symbol.valueDeclaration.parent) || symbol : symbol;
	    }
	    function getAlternativeContainingModules(symbol, enclosingDeclaration) {
	      const containingFile = getSourceFileOfNode(enclosingDeclaration);
	      const id = getNodeId(containingFile);
	      const links = getSymbolLinks(symbol);
	      let results;
	      if (links.extendedContainersByFile && (results = links.extendedContainersByFile.get(id))) {
	        return results;
	      }
	      if (containingFile && containingFile.imports) {
	        for (const importRef of containingFile.imports) {
	          if (nodeIsSynthesized(importRef))
	            continue;
	          const resolvedModule = resolveExternalModuleName(
	            enclosingDeclaration,
	            importRef,
	            /*ignoreErrors*/
	            true
	          );
	          if (!resolvedModule)
	            continue;
	          const ref = getAliasForSymbolInContainer(resolvedModule, symbol);
	          if (!ref)
	            continue;
	          results = append(results, resolvedModule);
	        }
	        if (length(results)) {
	          (links.extendedContainersByFile || (links.extendedContainersByFile = /* @__PURE__ */ new Map())).set(id, results);
	          return results;
	        }
	      }
	      if (links.extendedContainers) {
	        return links.extendedContainers;
	      }
	      const otherFiles = host.getSourceFiles();
	      for (const file of otherFiles) {
	        if (!isExternalModule(file))
	          continue;
	        const sym = getSymbolOfDeclaration(file);
	        const ref = getAliasForSymbolInContainer(sym, symbol);
	        if (!ref)
	          continue;
	        results = append(results, sym);
	      }
	      return links.extendedContainers = results || emptyArray;
	    }
	    function getContainersOfSymbol(symbol, enclosingDeclaration, meaning) {
	      const container = getParentOfSymbol(symbol);
	      if (container && !(symbol.flags & 262144 /* TypeParameter */)) {
	        return getWithAlternativeContainers(container);
	      }
	      const candidates = mapDefined(symbol.declarations, (d) => {
	        if (!isAmbientModule(d) && d.parent) {
	          if (hasNonGlobalAugmentationExternalModuleSymbol(d.parent)) {
	            return getSymbolOfDeclaration(d.parent);
	          }
	          if (isModuleBlock(d.parent) && d.parent.parent && resolveExternalModuleSymbol(getSymbolOfDeclaration(d.parent.parent)) === symbol) {
	            return getSymbolOfDeclaration(d.parent.parent);
	          }
	        }
	        if (isClassExpression(d) && isBinaryExpression(d.parent) && d.parent.operatorToken.kind === 64 /* EqualsToken */ && isAccessExpression(d.parent.left) && isEntityNameExpression(d.parent.left.expression)) {
	          if (isModuleExportsAccessExpression(d.parent.left) || isExportsIdentifier(d.parent.left.expression)) {
	            return getSymbolOfDeclaration(getSourceFileOfNode(d));
	          }
	          checkExpressionCached(d.parent.left.expression);
	          return getNodeLinks(d.parent.left.expression).resolvedSymbol;
	        }
	      });
	      if (!length(candidates)) {
	        return void 0;
	      }
	      const containers = mapDefined(candidates, (candidate) => getAliasForSymbolInContainer(candidate, symbol) ? candidate : void 0);
	      let bestContainers = [];
	      let alternativeContainers = [];
	      for (const container2 of containers) {
	        const [bestMatch, ...rest] = getWithAlternativeContainers(container2);
	        bestContainers = append(bestContainers, bestMatch);
	        alternativeContainers = addRange(alternativeContainers, rest);
	      }
	      return concatenate(bestContainers, alternativeContainers);
	      function getWithAlternativeContainers(container2) {
	        const additionalContainers = mapDefined(container2.declarations, fileSymbolIfFileSymbolExportEqualsContainer);
	        const reexportContainers = enclosingDeclaration && getAlternativeContainingModules(symbol, enclosingDeclaration);
	        const objectLiteralContainer = getVariableDeclarationOfObjectLiteral(container2, meaning);
	        if (enclosingDeclaration && container2.flags & getQualifiedLeftMeaning(meaning) && getAccessibleSymbolChain(
	          container2,
	          enclosingDeclaration,
	          1920 /* Namespace */,
	          /*useOnlyExternalAliasing*/
	          false
	        )) {
	          return append(concatenate(concatenate([container2], additionalContainers), reexportContainers), objectLiteralContainer);
	        }
	        const firstVariableMatch = !(container2.flags & getQualifiedLeftMeaning(meaning)) && container2.flags & 788968 /* Type */ && getDeclaredTypeOfSymbol(container2).flags & 524288 /* Object */ && meaning === 111551 /* Value */ ? forEachSymbolTableInScope(enclosingDeclaration, (t) => {
	          return forEachEntry(t, (s) => {
	            if (s.flags & getQualifiedLeftMeaning(meaning) && getTypeOfSymbol(s) === getDeclaredTypeOfSymbol(container2)) {
	              return s;
	            }
	          });
	        }) : void 0;
	        let res = firstVariableMatch ? [firstVariableMatch, ...additionalContainers, container2] : [...additionalContainers, container2];
	        res = append(res, objectLiteralContainer);
	        res = addRange(res, reexportContainers);
	        return res;
	      }
	      function fileSymbolIfFileSymbolExportEqualsContainer(d) {
	        return container && getFileSymbolIfFileSymbolExportEqualsContainer(d, container);
	      }
	    }
	    function getVariableDeclarationOfObjectLiteral(symbol, meaning) {
	      const firstDecl = !!length(symbol.declarations) && first(symbol.declarations);
	      if (meaning & 111551 /* Value */ && firstDecl && firstDecl.parent && isVariableDeclaration(firstDecl.parent)) {
	        if (isObjectLiteralExpression(firstDecl) && firstDecl === firstDecl.parent.initializer || isTypeLiteralNode(firstDecl) && firstDecl === firstDecl.parent.type) {
	          return getSymbolOfDeclaration(firstDecl.parent);
	        }
	      }
	    }
	    function getFileSymbolIfFileSymbolExportEqualsContainer(d, container) {
	      const fileSymbol = getExternalModuleContainer(d);
	      const exported = fileSymbol && fileSymbol.exports && fileSymbol.exports.get("export=" /* ExportEquals */);
	      return exported && getSymbolIfSameReference(exported, container) ? fileSymbol : void 0;
	    }
	    function getAliasForSymbolInContainer(container, symbol) {
	      if (container === getParentOfSymbol(symbol)) {
	        return symbol;
	      }
	      const exportEquals = container.exports && container.exports.get("export=" /* ExportEquals */);
	      if (exportEquals && getSymbolIfSameReference(exportEquals, symbol)) {
	        return container;
	      }
	      const exports = getExportsOfSymbol(container);
	      const quick = exports.get(symbol.escapedName);
	      if (quick && getSymbolIfSameReference(quick, symbol)) {
	        return quick;
	      }
	      return forEachEntry(exports, (exported) => {
	        if (getSymbolIfSameReference(exported, symbol)) {
	          return exported;
	        }
	      });
	    }
	    function getSymbolIfSameReference(s1, s2) {
	      if (getMergedSymbol(resolveSymbol(getMergedSymbol(s1))) === getMergedSymbol(resolveSymbol(getMergedSymbol(s2)))) {
	        return s1;
	      }
	    }
	    function getExportSymbolOfValueSymbolIfExported(symbol) {
	      return getMergedSymbol(symbol && (symbol.flags & 1048576 /* ExportValue */) !== 0 && symbol.exportSymbol || symbol);
	    }
	    function symbolIsValue(symbol, includeTypeOnlyMembers) {
	      return !!(symbol.flags & 111551 /* Value */ || symbol.flags & 2097152 /* Alias */ && getSymbolFlags(symbol, !includeTypeOnlyMembers) & 111551 /* Value */);
	    }
	    function findConstructorDeclaration(node) {
	      const members = node.members;
	      for (const member of members) {
	        if (member.kind === 176 /* Constructor */ && nodeIsPresent(member.body)) {
	          return member;
	        }
	      }
	    }
	    function createType(flags) {
	      var _a;
	      const result = new Type28(checker, flags);
	      typeCount++;
	      result.id = typeCount;
	      (_a = tracing) == null ? void 0 : _a.recordType(result);
	      return result;
	    }
	    function createTypeWithSymbol(flags, symbol) {
	      const result = createType(flags);
	      result.symbol = symbol;
	      return result;
	    }
	    function createOriginType(flags) {
	      return new Type28(checker, flags);
	    }
	    function createIntrinsicType(kind, intrinsicName, objectFlags = 0 /* None */, debugIntrinsicName) {
	      checkIntrinsicName(intrinsicName, debugIntrinsicName);
	      const type = createType(kind);
	      type.intrinsicName = intrinsicName;
	      type.debugIntrinsicName = debugIntrinsicName;
	      type.objectFlags = objectFlags | 524288 /* CouldContainTypeVariablesComputed */ | 2097152 /* IsGenericTypeComputed */ | 33554432 /* IsUnknownLikeUnionComputed */ | 16777216 /* IsNeverIntersectionComputed */;
	      return type;
	    }
	    function checkIntrinsicName(name, debug) {
	      const key = `${name},${debug ?? ""}`;
	      if (seenIntrinsicNames.has(key)) {
	        Debug.fail(`Duplicate intrinsic type name ${name}${debug ? ` (${debug})` : ""}; you may need to pass a name to createIntrinsicType.`);
	      }
	      seenIntrinsicNames.add(key);
	    }
	    function createObjectType(objectFlags, symbol) {
	      const type = createTypeWithSymbol(524288 /* Object */, symbol);
	      type.objectFlags = objectFlags;
	      type.members = void 0;
	      type.properties = void 0;
	      type.callSignatures = void 0;
	      type.constructSignatures = void 0;
	      type.indexInfos = void 0;
	      return type;
	    }
	    function createTypeofType() {
	      return getUnionType(arrayFrom(typeofNEFacts.keys(), getStringLiteralType));
	    }
	    function createTypeParameter(symbol) {
	      return createTypeWithSymbol(262144 /* TypeParameter */, symbol);
	    }
	    function isReservedMemberName(name) {
	      return name.charCodeAt(0) === 95 /* _ */ && name.charCodeAt(1) === 95 /* _ */ && name.charCodeAt(2) !== 95 /* _ */ && name.charCodeAt(2) !== 64 /* at */ && name.charCodeAt(2) !== 35 /* hash */;
	    }
	    function getNamedMembers(members) {
	      let result;
	      members.forEach((symbol, id) => {
	        if (isNamedMember(symbol, id)) {
	          (result || (result = [])).push(symbol);
	        }
	      });
	      return result || emptyArray;
	    }
	    function isNamedMember(member, escapedName) {
	      return !isReservedMemberName(escapedName) && symbolIsValue(member);
	    }
	    function getNamedOrIndexSignatureMembers(members) {
	      const result = getNamedMembers(members);
	      const index = getIndexSymbolFromSymbolTable(members);
	      return index ? concatenate(result, [index]) : result;
	    }
	    function setStructuredTypeMembers(type, members, callSignatures, constructSignatures, indexInfos) {
	      const resolved = type;
	      resolved.members = members;
	      resolved.properties = emptyArray;
	      resolved.callSignatures = callSignatures;
	      resolved.constructSignatures = constructSignatures;
	      resolved.indexInfos = indexInfos;
	      if (members !== emptySymbols)
	        resolved.properties = getNamedMembers(members);
	      return resolved;
	    }
	    function createAnonymousType(symbol, members, callSignatures, constructSignatures, indexInfos) {
	      return setStructuredTypeMembers(createObjectType(16 /* Anonymous */, symbol), members, callSignatures, constructSignatures, indexInfos);
	    }
	    function getResolvedTypeWithoutAbstractConstructSignatures(type) {
	      if (type.constructSignatures.length === 0)
	        return type;
	      if (type.objectTypeWithoutAbstractConstructSignatures)
	        return type.objectTypeWithoutAbstractConstructSignatures;
	      const constructSignatures = filter(type.constructSignatures, (signature) => !(signature.flags & 4 /* Abstract */));
	      if (type.constructSignatures === constructSignatures)
	        return type;
	      const typeCopy = createAnonymousType(
	        type.symbol,
	        type.members,
	        type.callSignatures,
	        some(constructSignatures) ? constructSignatures : emptyArray,
	        type.indexInfos
	      );
	      type.objectTypeWithoutAbstractConstructSignatures = typeCopy;
	      typeCopy.objectTypeWithoutAbstractConstructSignatures = typeCopy;
	      return typeCopy;
	    }
	    function forEachSymbolTableInScope(enclosingDeclaration, callback) {
	      let result;
	      for (let location = enclosingDeclaration; location; location = location.parent) {
	        if (canHaveLocals(location) && location.locals && !isGlobalSourceFile(location)) {
	          if (result = callback(
	            location.locals,
	            /*ignoreQualification*/
	            void 0,
	            /*isLocalNameLookup*/
	            true,
	            location
	          )) {
	            return result;
	          }
	        }
	        switch (location.kind) {
	          case 312 /* SourceFile */:
	            if (!isExternalOrCommonJsModule(location)) {
	              break;
	            }
	          case 267 /* ModuleDeclaration */:
	            const sym = getSymbolOfDeclaration(location);
	            if (result = callback(
	              (sym == null ? void 0 : sym.exports) || emptySymbols,
	              /*ignoreQualification*/
	              void 0,
	              /*isLocalNameLookup*/
	              true,
	              location
	            )) {
	              return result;
	            }
	            break;
	          case 263 /* ClassDeclaration */:
	          case 231 /* ClassExpression */:
	          case 264 /* InterfaceDeclaration */:
	            let table;
	            (getSymbolOfDeclaration(location).members || emptySymbols).forEach((memberSymbol, key) => {
	              if (memberSymbol.flags & (788968 /* Type */ & ~67108864 /* Assignment */)) {
	                (table || (table = createSymbolTable())).set(key, memberSymbol);
	              }
	            });
	            if (table && (result = callback(
	              table,
	              /*ignoreQualification*/
	              void 0,
	              /*isLocalNameLookup*/
	              false,
	              location
	            ))) {
	              return result;
	            }
	            break;
	        }
	      }
	      return callback(
	        globals,
	        /*ignoreQualification*/
	        void 0,
	        /*isLocalNameLookup*/
	        true
	      );
	    }
	    function getQualifiedLeftMeaning(rightMeaning) {
	      return rightMeaning === 111551 /* Value */ ? 111551 /* Value */ : 1920 /* Namespace */;
	    }
	    function getAccessibleSymbolChain(symbol, enclosingDeclaration, meaning, useOnlyExternalAliasing, visitedSymbolTablesMap = /* @__PURE__ */ new Map()) {
	      if (!(symbol && !isPropertyOrMethodDeclarationSymbol(symbol))) {
	        return void 0;
	      }
	      const links = getSymbolLinks(symbol);
	      const cache = links.accessibleChainCache || (links.accessibleChainCache = /* @__PURE__ */ new Map());
	      const firstRelevantLocation = forEachSymbolTableInScope(enclosingDeclaration, (_, __, ___, node) => node);
	      const key = `${useOnlyExternalAliasing ? 0 : 1}|${firstRelevantLocation && getNodeId(firstRelevantLocation)}|${meaning}`;
	      if (cache.has(key)) {
	        return cache.get(key);
	      }
	      const id = getSymbolId(symbol);
	      let visitedSymbolTables = visitedSymbolTablesMap.get(id);
	      if (!visitedSymbolTables) {
	        visitedSymbolTablesMap.set(id, visitedSymbolTables = []);
	      }
	      const result = forEachSymbolTableInScope(enclosingDeclaration, getAccessibleSymbolChainFromSymbolTable);
	      cache.set(key, result);
	      return result;
	      function getAccessibleSymbolChainFromSymbolTable(symbols, ignoreQualification, isLocalNameLookup) {
	        if (!pushIfUnique(visitedSymbolTables, symbols)) {
	          return void 0;
	        }
	        const result2 = trySymbolTable(symbols, ignoreQualification, isLocalNameLookup);
	        visitedSymbolTables.pop();
	        return result2;
	      }
	      function canQualifySymbol(symbolFromSymbolTable, meaning2) {
	        return !needsQualification(symbolFromSymbolTable, enclosingDeclaration, meaning2) || // If symbol needs qualification, make sure that parent is accessible, if it is then this symbol is accessible too
	        !!getAccessibleSymbolChain(symbolFromSymbolTable.parent, enclosingDeclaration, getQualifiedLeftMeaning(meaning2), useOnlyExternalAliasing, visitedSymbolTablesMap);
	      }
	      function isAccessible(symbolFromSymbolTable, resolvedAliasSymbol, ignoreQualification) {
	        return (symbol === (resolvedAliasSymbol || symbolFromSymbolTable) || getMergedSymbol(symbol) === getMergedSymbol(resolvedAliasSymbol || symbolFromSymbolTable)) && // if the symbolFromSymbolTable is not external module (it could be if it was determined as ambient external module and would be in globals table)
	        // and if symbolFromSymbolTable or alias resolution matches the symbol,
	        // check the symbol can be qualified, it is only then this symbol is accessible
	        !some(symbolFromSymbolTable.declarations, hasNonGlobalAugmentationExternalModuleSymbol) && (ignoreQualification || canQualifySymbol(getMergedSymbol(symbolFromSymbolTable), meaning));
	      }
	      function trySymbolTable(symbols, ignoreQualification, isLocalNameLookup) {
	        if (isAccessible(
	          symbols.get(symbol.escapedName),
	          /*resolvedAliasSymbol*/
	          void 0,
	          ignoreQualification
	        )) {
	          return [symbol];
	        }
	        const result2 = forEachEntry(symbols, (symbolFromSymbolTable) => {
	          if (symbolFromSymbolTable.flags & 2097152 /* Alias */ && symbolFromSymbolTable.escapedName !== "export=" /* ExportEquals */ && symbolFromSymbolTable.escapedName !== "default" /* Default */ && !(isUMDExportSymbol(symbolFromSymbolTable) && enclosingDeclaration && isExternalModule(getSourceFileOfNode(enclosingDeclaration))) && (!useOnlyExternalAliasing || some(symbolFromSymbolTable.declarations, isExternalModuleImportEqualsDeclaration)) && (isLocalNameLookup ? !some(symbolFromSymbolTable.declarations, isNamespaceReexportDeclaration) : true) && (ignoreQualification || !getDeclarationOfKind(symbolFromSymbolTable, 281 /* ExportSpecifier */))) {
	            const resolvedImportedSymbol = resolveAlias(symbolFromSymbolTable);
	            const candidate = getCandidateListForSymbol(symbolFromSymbolTable, resolvedImportedSymbol, ignoreQualification);
	            if (candidate) {
	              return candidate;
	            }
	          }
	          if (symbolFromSymbolTable.escapedName === symbol.escapedName && symbolFromSymbolTable.exportSymbol) {
	            if (isAccessible(
	              getMergedSymbol(symbolFromSymbolTable.exportSymbol),
	              /*resolvedAliasSymbol*/
	              void 0,
	              ignoreQualification
	            )) {
	              return [symbol];
	            }
	          }
	        });
	        return result2 || (symbols === globals ? getCandidateListForSymbol(globalThisSymbol, globalThisSymbol, ignoreQualification) : void 0);
	      }
	      function getCandidateListForSymbol(symbolFromSymbolTable, resolvedImportedSymbol, ignoreQualification) {
	        if (isAccessible(symbolFromSymbolTable, resolvedImportedSymbol, ignoreQualification)) {
	          return [symbolFromSymbolTable];
	        }
	        const candidateTable = getExportsOfSymbol(resolvedImportedSymbol);
	        const accessibleSymbolsFromExports = candidateTable && getAccessibleSymbolChainFromSymbolTable(
	          candidateTable,
	          /*ignoreQualification*/
	          true
	        );
	        if (accessibleSymbolsFromExports && canQualifySymbol(symbolFromSymbolTable, getQualifiedLeftMeaning(meaning))) {
	          return [symbolFromSymbolTable].concat(accessibleSymbolsFromExports);
	        }
	      }
	    }
	    function needsQualification(symbol, enclosingDeclaration, meaning) {
	      let qualify = false;
	      forEachSymbolTableInScope(enclosingDeclaration, (symbolTable) => {
	        let symbolFromSymbolTable = getMergedSymbol(symbolTable.get(symbol.escapedName));
	        if (!symbolFromSymbolTable) {
	          return false;
	        }
	        if (symbolFromSymbolTable === symbol) {
	          return true;
	        }
	        const shouldResolveAlias = symbolFromSymbolTable.flags & 2097152 /* Alias */ && !getDeclarationOfKind(symbolFromSymbolTable, 281 /* ExportSpecifier */);
	        symbolFromSymbolTable = shouldResolveAlias ? resolveAlias(symbolFromSymbolTable) : symbolFromSymbolTable;
	        const flags = shouldResolveAlias ? getSymbolFlags(symbolFromSymbolTable) : symbolFromSymbolTable.flags;
	        if (flags & meaning) {
	          qualify = true;
	          return true;
	        }
	        return false;
	      });
	      return qualify;
	    }
	    function isPropertyOrMethodDeclarationSymbol(symbol) {
	      if (symbol.declarations && symbol.declarations.length) {
	        for (const declaration of symbol.declarations) {
	          switch (declaration.kind) {
	            case 172 /* PropertyDeclaration */:
	            case 174 /* MethodDeclaration */:
	            case 177 /* GetAccessor */:
	            case 178 /* SetAccessor */:
	              continue;
	            default:
	              return false;
	          }
	        }
	        return true;
	      }
	      return false;
	    }
	    function isTypeSymbolAccessible(typeSymbol, enclosingDeclaration) {
	      const access = isSymbolAccessibleWorker(
	        typeSymbol,
	        enclosingDeclaration,
	        788968 /* Type */,
	        /*shouldComputeAliasesToMakeVisible*/
	        false,
	        /*allowModules*/
	        true
	      );
	      return access.accessibility === 0 /* Accessible */;
	    }
	    function isValueSymbolAccessible(typeSymbol, enclosingDeclaration) {
	      const access = isSymbolAccessibleWorker(
	        typeSymbol,
	        enclosingDeclaration,
	        111551 /* Value */,
	        /*shouldComputeAliasesToMakeVisible*/
	        false,
	        /*allowModules*/
	        true
	      );
	      return access.accessibility === 0 /* Accessible */;
	    }
	    function isSymbolAccessibleByFlags(typeSymbol, enclosingDeclaration, flags) {
	      const access = isSymbolAccessibleWorker(
	        typeSymbol,
	        enclosingDeclaration,
	        flags,
	        /*shouldComputeAliasesToMakeVisible*/
	        false,
	        /*allowModules*/
	        false
	      );
	      return access.accessibility === 0 /* Accessible */;
	    }
	    function isAnySymbolAccessible(symbols, enclosingDeclaration, initialSymbol, meaning, shouldComputeAliasesToMakeVisible, allowModules) {
	      if (!length(symbols))
	        return;
	      let hadAccessibleChain;
	      let earlyModuleBail = false;
	      for (const symbol of symbols) {
	        const accessibleSymbolChain = getAccessibleSymbolChain(
	          symbol,
	          enclosingDeclaration,
	          meaning,
	          /*useOnlyExternalAliasing*/
	          false
	        );
	        if (accessibleSymbolChain) {
	          hadAccessibleChain = symbol;
	          const hasAccessibleDeclarations = hasVisibleDeclarations(accessibleSymbolChain[0], shouldComputeAliasesToMakeVisible);
	          if (hasAccessibleDeclarations) {
	            return hasAccessibleDeclarations;
	          }
	        }
	        if (allowModules) {
	          if (some(symbol.declarations, hasNonGlobalAugmentationExternalModuleSymbol)) {
	            if (shouldComputeAliasesToMakeVisible) {
	              earlyModuleBail = true;
	              continue;
	            }
	            return {
	              accessibility: 0 /* Accessible */
	            };
	          }
	        }
	        const containers = getContainersOfSymbol(symbol, enclosingDeclaration, meaning);
	        const parentResult = isAnySymbolAccessible(containers, enclosingDeclaration, initialSymbol, initialSymbol === symbol ? getQualifiedLeftMeaning(meaning) : meaning, shouldComputeAliasesToMakeVisible, allowModules);
	        if (parentResult) {
	          return parentResult;
	        }
	      }
	      if (earlyModuleBail) {
	        return {
	          accessibility: 0 /* Accessible */
	        };
	      }
	      if (hadAccessibleChain) {
	        return {
	          accessibility: 1 /* NotAccessible */,
	          errorSymbolName: symbolToString(initialSymbol, enclosingDeclaration, meaning),
	          errorModuleName: hadAccessibleChain !== initialSymbol ? symbolToString(hadAccessibleChain, enclosingDeclaration, 1920 /* Namespace */) : void 0
	        };
	      }
	    }
	    function isSymbolAccessible(symbol, enclosingDeclaration, meaning, shouldComputeAliasesToMakeVisible) {
	      return isSymbolAccessibleWorker(
	        symbol,
	        enclosingDeclaration,
	        meaning,
	        shouldComputeAliasesToMakeVisible,
	        /*allowModules*/
	        true
	      );
	    }
	    function isSymbolAccessibleWorker(symbol, enclosingDeclaration, meaning, shouldComputeAliasesToMakeVisible, allowModules) {
	      if (symbol && enclosingDeclaration) {
	        const result = isAnySymbolAccessible([symbol], enclosingDeclaration, symbol, meaning, shouldComputeAliasesToMakeVisible, allowModules);
	        if (result) {
	          return result;
	        }
	        const symbolExternalModule = forEach(symbol.declarations, getExternalModuleContainer);
	        if (symbolExternalModule) {
	          const enclosingExternalModule = getExternalModuleContainer(enclosingDeclaration);
	          if (symbolExternalModule !== enclosingExternalModule) {
	            return {
	              accessibility: 2 /* CannotBeNamed */,
	              errorSymbolName: symbolToString(symbol, enclosingDeclaration, meaning),
	              errorModuleName: symbolToString(symbolExternalModule),
	              errorNode: isInJSFile(enclosingDeclaration) ? enclosingDeclaration : void 0
	            };
	          }
	        }
	        return {
	          accessibility: 1 /* NotAccessible */,
	          errorSymbolName: symbolToString(symbol, enclosingDeclaration, meaning)
	        };
	      }
	      return { accessibility: 0 /* Accessible */ };
	    }
	    function getExternalModuleContainer(declaration) {
	      const node = findAncestor(declaration, hasExternalModuleSymbol);
	      return node && getSymbolOfDeclaration(node);
	    }
	    function hasExternalModuleSymbol(declaration) {
	      return isAmbientModule(declaration) || declaration.kind === 312 /* SourceFile */ && isExternalOrCommonJsModule(declaration);
	    }
	    function hasNonGlobalAugmentationExternalModuleSymbol(declaration) {
	      return isModuleWithStringLiteralName(declaration) || declaration.kind === 312 /* SourceFile */ && isExternalOrCommonJsModule(declaration);
	    }
	    function hasVisibleDeclarations(symbol, shouldComputeAliasToMakeVisible) {
	      let aliasesToMakeVisible;
	      if (!every(filter(symbol.declarations, (d) => d.kind !== 80 /* Identifier */), getIsDeclarationVisible)) {
	        return void 0;
	      }
	      return { accessibility: 0 /* Accessible */, aliasesToMakeVisible };
	      function getIsDeclarationVisible(declaration) {
	        var _a, _b;
	        if (!isDeclarationVisible(declaration)) {
	          const anyImportSyntax = getAnyImportSyntax(declaration);
	          if (anyImportSyntax && !hasSyntacticModifier(anyImportSyntax, 32 /* Export */) && // import clause without export
	          isDeclarationVisible(anyImportSyntax.parent)) {
	            return addVisibleAlias(declaration, anyImportSyntax);
	          } else if (isVariableDeclaration(declaration) && isVariableStatement(declaration.parent.parent) && !hasSyntacticModifier(declaration.parent.parent, 32 /* Export */) && // unexported variable statement
	          isDeclarationVisible(declaration.parent.parent.parent)) {
	            return addVisibleAlias(declaration, declaration.parent.parent);
	          } else if (isLateVisibilityPaintedStatement(declaration) && !hasSyntacticModifier(declaration, 32 /* Export */) && isDeclarationVisible(declaration.parent)) {
	            return addVisibleAlias(declaration, declaration);
	          } else if (isBindingElement(declaration)) {
	            if (symbol.flags & 2097152 /* Alias */ && isInJSFile(declaration) && ((_a = declaration.parent) == null ? void 0 : _a.parent) && isVariableDeclaration(declaration.parent.parent) && ((_b = declaration.parent.parent.parent) == null ? void 0 : _b.parent) && isVariableStatement(declaration.parent.parent.parent.parent) && !hasSyntacticModifier(declaration.parent.parent.parent.parent, 32 /* Export */) && declaration.parent.parent.parent.parent.parent && isDeclarationVisible(declaration.parent.parent.parent.parent.parent)) {
	              return addVisibleAlias(declaration, declaration.parent.parent.parent.parent);
	            } else if (symbol.flags & 2 /* BlockScopedVariable */) {
	              const variableStatement = findAncestor(declaration, isVariableStatement);
	              if (hasSyntacticModifier(variableStatement, 32 /* Export */)) {
	                return true;
	              }
	              if (!isDeclarationVisible(variableStatement.parent)) {
	                return false;
	              }
	              return addVisibleAlias(declaration, variableStatement);
	            }
	          }
	          return false;
	        }
	        return true;
	      }
	      function addVisibleAlias(declaration, aliasingStatement) {
	        if (shouldComputeAliasToMakeVisible) {
	          getNodeLinks(declaration).isVisible = true;
	          aliasesToMakeVisible = appendIfUnique(aliasesToMakeVisible, aliasingStatement);
	        }
	        return true;
	      }
	    }
	    function getMeaningOfEntityNameReference(entityName) {
	      let meaning;
	      if (entityName.parent.kind === 186 /* TypeQuery */ || entityName.parent.kind === 233 /* ExpressionWithTypeArguments */ && !isPartOfTypeNode(entityName.parent) || entityName.parent.kind === 167 /* ComputedPropertyName */) {
	        meaning = 111551 /* Value */ | 1048576 /* ExportValue */;
	      } else if (entityName.kind === 166 /* QualifiedName */ || entityName.kind === 211 /* PropertyAccessExpression */ || entityName.parent.kind === 271 /* ImportEqualsDeclaration */ || entityName.parent.kind === 166 /* QualifiedName */ && entityName.parent.left === entityName || entityName.parent.kind === 211 /* PropertyAccessExpression */ && entityName.parent.expression === entityName || entityName.parent.kind === 212 /* ElementAccessExpression */ && entityName.parent.expression === entityName) {
	        meaning = 1920 /* Namespace */;
	      } else {
	        meaning = 788968 /* Type */;
	      }
	      return meaning;
	    }
	    function isEntityNameVisible(entityName, enclosingDeclaration) {
	      const meaning = getMeaningOfEntityNameReference(entityName);
	      const firstIdentifier = getFirstIdentifier(entityName);
	      const symbol = resolveName(
	        enclosingDeclaration,
	        firstIdentifier.escapedText,
	        meaning,
	        /*nameNotFoundMessage*/
	        void 0,
	        /*nameArg*/
	        void 0,
	        /*isUse*/
	        false
	      );
	      if (symbol && symbol.flags & 262144 /* TypeParameter */ && meaning & 788968 /* Type */) {
	        return { accessibility: 0 /* Accessible */ };
	      }
	      if (!symbol && isThisIdentifier(firstIdentifier) && isSymbolAccessible(
	        getSymbolOfDeclaration(getThisContainer(
	          firstIdentifier,
	          /*includeArrowFunctions*/
	          false,
	          /*includeClassComputedPropertyName*/
	          false
	        )),
	        firstIdentifier,
	        meaning,
	        /*shouldComputeAliasesToMakeVisible*/
	        false
	      ).accessibility === 0 /* Accessible */) {
	        return { accessibility: 0 /* Accessible */ };
	      }
	      return symbol && hasVisibleDeclarations(
	        symbol,
	        /*shouldComputeAliasToMakeVisible*/
	        true
	      ) || {
	        accessibility: 1 /* NotAccessible */,
	        errorSymbolName: getTextOfNode(firstIdentifier),
	        errorNode: firstIdentifier
	      };
	    }
	    function symbolToString(symbol, enclosingDeclaration, meaning, flags = 4 /* AllowAnyNodeKind */, writer) {
	      let nodeFlags = 70221824 /* IgnoreErrors */;
	      if (flags & 2 /* UseOnlyExternalAliasing */) {
	        nodeFlags |= 128 /* UseOnlyExternalAliasing */;
	      }
	      if (flags & 1 /* WriteTypeParametersOrArguments */) {
	        nodeFlags |= 512 /* WriteTypeParametersInQualifiedName */;
	      }
	      if (flags & 8 /* UseAliasDefinedOutsideCurrentScope */) {
	        nodeFlags |= 16384 /* UseAliasDefinedOutsideCurrentScope */;
	      }
	      if (flags & 32 /* DoNotIncludeSymbolChain */) {
	        nodeFlags |= 134217728 /* DoNotIncludeSymbolChain */;
	      }
	      if (flags & 16 /* WriteComputedProps */) {
	        nodeFlags |= 1073741824 /* WriteComputedProps */;
	      }
	      const builder = flags & 4 /* AllowAnyNodeKind */ ? nodeBuilder.symbolToNode : nodeBuilder.symbolToEntityName;
	      return writer ? symbolToStringWorker(writer).getText() : usingSingleLineStringWriter(symbolToStringWorker);
	      function symbolToStringWorker(writer2) {
	        const entity = builder(symbol, meaning, enclosingDeclaration, nodeFlags);
	        const printer = (enclosingDeclaration == null ? void 0 : enclosingDeclaration.kind) === 312 /* SourceFile */ ? createPrinterWithRemoveCommentsNeverAsciiEscape() : createPrinterWithRemoveComments();
	        const sourceFile = enclosingDeclaration && getSourceFileOfNode(enclosingDeclaration);
	        printer.writeNode(
	          4 /* Unspecified */,
	          entity,
	          /*sourceFile*/
	          sourceFile,
	          writer2
	        );
	        return writer2;
	      }
	    }
	    function signatureToString(signature, enclosingDeclaration, flags = 0 /* None */, kind, writer) {
	      return writer ? signatureToStringWorker(writer).getText() : usingSingleLineStringWriter(signatureToStringWorker);
	      function signatureToStringWorker(writer2) {
	        let sigOutput;
	        if (flags & 262144 /* WriteArrowStyleSignature */) {
	          sigOutput = kind === 1 /* Construct */ ? 185 /* ConstructorType */ : 184 /* FunctionType */;
	        } else {
	          sigOutput = kind === 1 /* Construct */ ? 180 /* ConstructSignature */ : 179 /* CallSignature */;
	        }
	        const sig = nodeBuilder.signatureToSignatureDeclaration(signature, sigOutput, enclosingDeclaration, toNodeBuilderFlags(flags) | 70221824 /* IgnoreErrors */ | 512 /* WriteTypeParametersInQualifiedName */);
	        const printer = createPrinterWithRemoveCommentsOmitTrailingSemicolon();
	        const sourceFile = enclosingDeclaration && getSourceFileOfNode(enclosingDeclaration);
	        printer.writeNode(
	          4 /* Unspecified */,
	          sig,
	          /*sourceFile*/
	          sourceFile,
	          getTrailingSemicolonDeferringWriter(writer2)
	        );
	        return writer2;
	      }
	    }
	    function typeToString(type, enclosingDeclaration, flags = 1048576 /* AllowUniqueESSymbolType */ | 16384 /* UseAliasDefinedOutsideCurrentScope */, writer = createTextWriter("")) {
	      const noTruncation = compilerOptions.noErrorTruncation || flags & 1 /* NoTruncation */;
	      const typeNode = nodeBuilder.typeToTypeNode(type, enclosingDeclaration, toNodeBuilderFlags(flags) | 70221824 /* IgnoreErrors */ | (noTruncation ? 1 /* NoTruncation */ : 0));
	      if (typeNode === void 0)
	        return Debug.fail("should always get typenode");
	      const printer = type !== unresolvedType ? createPrinterWithRemoveComments() : createPrinterWithDefaults();
	      const sourceFile = enclosingDeclaration && getSourceFileOfNode(enclosingDeclaration);
	      printer.writeNode(
	        4 /* Unspecified */,
	        typeNode,
	        /*sourceFile*/
	        sourceFile,
	        writer
	      );
	      const result = writer.getText();
	      const maxLength2 = noTruncation ? noTruncationMaximumTruncationLength * 2 : defaultMaximumTruncationLength * 2;
	      if (maxLength2 && result && result.length >= maxLength2) {
	        return result.substr(0, maxLength2 - "...".length) + "...";
	      }
	      return result;
	    }
	    function getTypeNamesForErrorDisplay(left, right) {
	      let leftStr = symbolValueDeclarationIsContextSensitive(left.symbol) ? typeToString(left, left.symbol.valueDeclaration) : typeToString(left);
	      let rightStr = symbolValueDeclarationIsContextSensitive(right.symbol) ? typeToString(right, right.symbol.valueDeclaration) : typeToString(right);
	      if (leftStr === rightStr) {
	        leftStr = getTypeNameForErrorDisplay(left);
	        rightStr = getTypeNameForErrorDisplay(right);
	      }
	      return [leftStr, rightStr];
	    }
	    function getTypeNameForErrorDisplay(type) {
	      return typeToString(
	        type,
	        /*enclosingDeclaration*/
	        void 0,
	        64 /* UseFullyQualifiedType */
	      );
	    }
	    function symbolValueDeclarationIsContextSensitive(symbol) {
	      return symbol && !!symbol.valueDeclaration && isExpression(symbol.valueDeclaration) && !isContextSensitive(symbol.valueDeclaration);
	    }
	    function toNodeBuilderFlags(flags = 0 /* None */) {
	      return flags & 848330095 /* NodeBuilderFlagsMask */;
	    }
	    function isClassInstanceSide(type) {
	      return !!type.symbol && !!(type.symbol.flags & 32 /* Class */) && (type === getDeclaredTypeOfClassOrInterface(type.symbol) || !!(type.flags & 524288 /* Object */) && !!(getObjectFlags(type) & 16777216 /* IsClassInstanceClone */));
	    }
	    function createNodeBuilder() {
	      return {
	        typeToTypeNode: (type, enclosingDeclaration, flags, tracker) => withContext(enclosingDeclaration, flags, tracker, (context) => typeToTypeNodeHelper(type, context)),
	        indexInfoToIndexSignatureDeclaration: (indexInfo, enclosingDeclaration, flags, tracker) => withContext(enclosingDeclaration, flags, tracker, (context) => indexInfoToIndexSignatureDeclarationHelper(
	          indexInfo,
	          context,
	          /*typeNode*/
	          void 0
	        )),
	        signatureToSignatureDeclaration: (signature, kind, enclosingDeclaration, flags, tracker) => withContext(enclosingDeclaration, flags, tracker, (context) => signatureToSignatureDeclarationHelper(signature, kind, context)),
	        symbolToEntityName: (symbol, meaning, enclosingDeclaration, flags, tracker) => withContext(enclosingDeclaration, flags, tracker, (context) => symbolToName(
	          symbol,
	          context,
	          meaning,
	          /*expectsIdentifier*/
	          false
	        )),
	        symbolToExpression: (symbol, meaning, enclosingDeclaration, flags, tracker) => withContext(enclosingDeclaration, flags, tracker, (context) => symbolToExpression(symbol, context, meaning)),
	        symbolToTypeParameterDeclarations: (symbol, enclosingDeclaration, flags, tracker) => withContext(enclosingDeclaration, flags, tracker, (context) => typeParametersToTypeParameterDeclarations(symbol, context)),
	        symbolToParameterDeclaration: (symbol, enclosingDeclaration, flags, tracker) => withContext(enclosingDeclaration, flags, tracker, (context) => symbolToParameterDeclaration(symbol, context)),
	        typeParameterToDeclaration: (parameter, enclosingDeclaration, flags, tracker) => withContext(enclosingDeclaration, flags, tracker, (context) => typeParameterToDeclaration(parameter, context)),
	        symbolTableToDeclarationStatements: (symbolTable, enclosingDeclaration, flags, tracker, bundled) => withContext(enclosingDeclaration, flags, tracker, (context) => symbolTableToDeclarationStatements(symbolTable, context, bundled)),
	        symbolToNode: (symbol, meaning, enclosingDeclaration, flags, tracker) => withContext(enclosingDeclaration, flags, tracker, (context) => symbolToNode(symbol, context, meaning))
	      };
	      function symbolToNode(symbol, context, meaning) {
	        if (context.flags & 1073741824 /* WriteComputedProps */) {
	          if (symbol.valueDeclaration) {
	            const name = getNameOfDeclaration(symbol.valueDeclaration);
	            if (name && isComputedPropertyName(name))
	              return name;
	          }
	          const nameType = getSymbolLinks(symbol).nameType;
	          if (nameType && nameType.flags & (1024 /* EnumLiteral */ | 8192 /* UniqueESSymbol */)) {
	            context.enclosingDeclaration = nameType.symbol.valueDeclaration;
	            return factory.createComputedPropertyName(symbolToExpression(nameType.symbol, context, meaning));
	          }
	        }
	        return symbolToExpression(symbol, context, meaning);
	      }
	      function withContext(enclosingDeclaration, flags, tracker, cb) {
	        Debug.assert(enclosingDeclaration === void 0 || (enclosingDeclaration.flags & 16 /* Synthesized */) === 0);
	        const moduleResolverHost = (tracker == null ? void 0 : tracker.trackSymbol) ? tracker.moduleResolverHost : flags & 134217728 /* DoNotIncludeSymbolChain */ ? createBasicNodeBuilderModuleSpecifierResolutionHost(host) : void 0;
	        const context = {
	          enclosingDeclaration,
	          flags: flags || 0 /* None */,
	          tracker: void 0,
	          encounteredError: false,
	          reportedDiagnostic: false,
	          visitedTypes: void 0,
	          symbolDepth: void 0,
	          inferTypeParameters: void 0,
	          approximateLength: 0,
	          trackedSymbols: void 0
	        };
	        context.tracker = new SymbolTrackerImpl(context, tracker, moduleResolverHost);
	        const resultingNode = cb(context);
	        if (context.truncating && context.flags & 1 /* NoTruncation */) {
	          context.tracker.reportTruncationError();
	        }
	        return context.encounteredError ? void 0 : resultingNode;
	      }
	      function checkTruncationLength(context) {
	        if (context.truncating)
	          return context.truncating;
	        return context.truncating = context.approximateLength > (context.flags & 1 /* NoTruncation */ ? noTruncationMaximumTruncationLength : defaultMaximumTruncationLength);
	      }
	      function typeToTypeNodeHelper(type, context) {
	        const savedFlags = context.flags;
	        const typeNode = typeToTypeNodeWorker(type, context);
	        context.flags = savedFlags;
	        return typeNode;
	      }
	      function typeToTypeNodeWorker(type, context) {
	        var _a, _b;
	        if (cancellationToken && cancellationToken.throwIfCancellationRequested) {
	          cancellationToken.throwIfCancellationRequested();
	        }
	        const inTypeAlias = context.flags & 8388608 /* InTypeAlias */;
	        context.flags &= ~8388608 /* InTypeAlias */;
	        if (!type) {
	          if (!(context.flags & 262144 /* AllowEmptyUnionOrIntersection */)) {
	            context.encounteredError = true;
	            return void 0;
	          }
	          context.approximateLength += 3;
	          return factory.createKeywordTypeNode(133 /* AnyKeyword */);
	        }
	        if (!(context.flags & 536870912 /* NoTypeReduction */)) {
	          type = getReducedType(type);
	        }
	        if (type.flags & 1 /* Any */) {
	          if (type.aliasSymbol) {
	            return factory.createTypeReferenceNode(symbolToEntityNameNode(type.aliasSymbol), mapToTypeNodes(type.aliasTypeArguments, context));
	          }
	          if (type === unresolvedType) {
	            return addSyntheticLeadingComment(factory.createKeywordTypeNode(133 /* AnyKeyword */), 3 /* MultiLineCommentTrivia */, "unresolved");
	          }
	          context.approximateLength += 3;
	          return factory.createKeywordTypeNode(type === intrinsicMarkerType ? 141 /* IntrinsicKeyword */ : 133 /* AnyKeyword */);
	        }
	        if (type.flags & 2 /* Unknown */) {
	          return factory.createKeywordTypeNode(159 /* UnknownKeyword */);
	        }
	        if (type.flags & 4 /* String */) {
	          context.approximateLength += 6;
	          return factory.createKeywordTypeNode(154 /* StringKeyword */);
	        }
	        if (type.flags & 8 /* Number */) {
	          context.approximateLength += 6;
	          return factory.createKeywordTypeNode(150 /* NumberKeyword */);
	        }
	        if (type.flags & 64 /* BigInt */) {
	          context.approximateLength += 6;
	          return factory.createKeywordTypeNode(163 /* BigIntKeyword */);
	        }
	        if (type.flags & 16 /* Boolean */ && !type.aliasSymbol) {
	          context.approximateLength += 7;
	          return factory.createKeywordTypeNode(136 /* BooleanKeyword */);
	        }
	        if (type.flags & 1056 /* EnumLike */) {
	          if (type.symbol.flags & 8 /* EnumMember */) {
	            const parentSymbol = getParentOfSymbol(type.symbol);
	            const parentName = symbolToTypeNode(parentSymbol, context, 788968 /* Type */);
	            if (getDeclaredTypeOfSymbol(parentSymbol) === type) {
	              return parentName;
	            }
	            const memberName = symbolName(type.symbol);
	            if (isIdentifierText(memberName, 0 /* ES3 */)) {
	              return appendReferenceToType(
	                parentName,
	                factory.createTypeReferenceNode(
	                  memberName,
	                  /*typeArguments*/
	                  void 0
	                )
	              );
	            }
	            if (isImportTypeNode(parentName)) {
	              parentName.isTypeOf = true;
	              return factory.createIndexedAccessTypeNode(parentName, factory.createLiteralTypeNode(factory.createStringLiteral(memberName)));
	            } else if (isTypeReferenceNode(parentName)) {
	              return factory.createIndexedAccessTypeNode(factory.createTypeQueryNode(parentName.typeName), factory.createLiteralTypeNode(factory.createStringLiteral(memberName)));
	            } else {
	              return Debug.fail("Unhandled type node kind returned from `symbolToTypeNode`.");
	            }
	          }
	          return symbolToTypeNode(type.symbol, context, 788968 /* Type */);
	        }
	        if (type.flags & 128 /* StringLiteral */) {
	          context.approximateLength += type.value.length + 2;
	          return factory.createLiteralTypeNode(setEmitFlags(factory.createStringLiteral(type.value, !!(context.flags & 268435456 /* UseSingleQuotesForStringLiteralType */)), 16777216 /* NoAsciiEscaping */));
	        }
	        if (type.flags & 256 /* NumberLiteral */) {
	          const value = type.value;
	          context.approximateLength += ("" + value).length;
	          return factory.createLiteralTypeNode(value < 0 ? factory.createPrefixUnaryExpression(41 /* MinusToken */, factory.createNumericLiteral(-value)) : factory.createNumericLiteral(value));
	        }
	        if (type.flags & 2048 /* BigIntLiteral */) {
	          context.approximateLength += pseudoBigIntToString(type.value).length + 1;
	          return factory.createLiteralTypeNode(factory.createBigIntLiteral(type.value));
	        }
	        if (type.flags & 512 /* BooleanLiteral */) {
	          context.approximateLength += type.intrinsicName.length;
	          return factory.createLiteralTypeNode(type.intrinsicName === "true" ? factory.createTrue() : factory.createFalse());
	        }
	        if (type.flags & 8192 /* UniqueESSymbol */) {
	          if (!(context.flags & 1048576 /* AllowUniqueESSymbolType */)) {
	            if (isValueSymbolAccessible(type.symbol, context.enclosingDeclaration)) {
	              context.approximateLength += 6;
	              return symbolToTypeNode(type.symbol, context, 111551 /* Value */);
	            }
	            if (context.tracker.reportInaccessibleUniqueSymbolError) {
	              context.tracker.reportInaccessibleUniqueSymbolError();
	            }
	          }
	          context.approximateLength += 13;
	          return factory.createTypeOperatorNode(158 /* UniqueKeyword */, factory.createKeywordTypeNode(155 /* SymbolKeyword */));
	        }
	        if (type.flags & 16384 /* Void */) {
	          context.approximateLength += 4;
	          return factory.createKeywordTypeNode(116 /* VoidKeyword */);
	        }
	        if (type.flags & 32768 /* Undefined */) {
	          context.approximateLength += 9;
	          return factory.createKeywordTypeNode(157 /* UndefinedKeyword */);
	        }
	        if (type.flags & 65536 /* Null */) {
	          context.approximateLength += 4;
	          return factory.createLiteralTypeNode(factory.createNull());
	        }
	        if (type.flags & 131072 /* Never */) {
	          context.approximateLength += 5;
	          return factory.createKeywordTypeNode(146 /* NeverKeyword */);
	        }
	        if (type.flags & 4096 /* ESSymbol */) {
	          context.approximateLength += 6;
	          return factory.createKeywordTypeNode(155 /* SymbolKeyword */);
	        }
	        if (type.flags & 67108864 /* NonPrimitive */) {
	          context.approximateLength += 6;
	          return factory.createKeywordTypeNode(151 /* ObjectKeyword */);
	        }
	        if (isThisTypeParameter(type)) {
	          if (context.flags & 4194304 /* InObjectTypeLiteral */) {
	            if (!context.encounteredError && !(context.flags & 32768 /* AllowThisInObjectLiteral */)) {
	              context.encounteredError = true;
	            }
	            (_b = (_a = context.tracker).reportInaccessibleThisError) == null ? void 0 : _b.call(_a);
	          }
	          context.approximateLength += 4;
	          return factory.createThisTypeNode();
	        }
	        if (!inTypeAlias && type.aliasSymbol && (context.flags & 16384 /* UseAliasDefinedOutsideCurrentScope */ || isTypeSymbolAccessible(type.aliasSymbol, context.enclosingDeclaration))) {
	          const typeArgumentNodes = mapToTypeNodes(type.aliasTypeArguments, context);
	          if (isReservedMemberName(type.aliasSymbol.escapedName) && !(type.aliasSymbol.flags & 32 /* Class */))
	            return factory.createTypeReferenceNode(factory.createIdentifier(""), typeArgumentNodes);
	          if (length(typeArgumentNodes) === 1 && type.aliasSymbol === globalArrayType.symbol) {
	            return factory.createArrayTypeNode(typeArgumentNodes[0]);
	          }
	          return symbolToTypeNode(type.aliasSymbol, context, 788968 /* Type */, typeArgumentNodes);
	        }
	        const objectFlags = getObjectFlags(type);
	        if (objectFlags & 4 /* Reference */) {
	          Debug.assert(!!(type.flags & 524288 /* Object */));
	          return type.node ? visitAndTransformType(type, typeReferenceToTypeNode) : typeReferenceToTypeNode(type);
	        }
	        if (type.flags & 262144 /* TypeParameter */ || objectFlags & 3 /* ClassOrInterface */) {
	          if (type.flags & 262144 /* TypeParameter */ && contains(context.inferTypeParameters, type)) {
	            context.approximateLength += symbolName(type.symbol).length + 6;
	            let constraintNode;
	            const constraint = getConstraintOfTypeParameter(type);
	            if (constraint) {
	              const inferredConstraint = getInferredTypeParameterConstraint(
	                type,
	                /*omitTypeReferences*/
	                true
	              );
	              if (!(inferredConstraint && isTypeIdenticalTo(constraint, inferredConstraint))) {
	                context.approximateLength += 9;
	                constraintNode = constraint && typeToTypeNodeHelper(constraint, context);
	              }
	            }
	            return factory.createInferTypeNode(typeParameterToDeclarationWithConstraint(type, context, constraintNode));
	          }
	          if (context.flags & 4 /* GenerateNamesForShadowedTypeParams */ && type.flags & 262144 /* TypeParameter */) {
	            const name2 = typeParameterToName(type, context);
	            context.approximateLength += idText(name2).length;
	            return factory.createTypeReferenceNode(
	              factory.createIdentifier(idText(name2)),
	              /*typeArguments*/
	              void 0
	            );
	          }
	          if (type.symbol) {
	            return symbolToTypeNode(type.symbol, context, 788968 /* Type */);
	          }
	          const name = (type === markerSuperTypeForCheck || type === markerSubTypeForCheck) && varianceTypeParameter && varianceTypeParameter.symbol ? (type === markerSubTypeForCheck ? "sub-" : "super-") + symbolName(varianceTypeParameter.symbol) : "?";
	          return factory.createTypeReferenceNode(
	            factory.createIdentifier(name),
	            /*typeArguments*/
	            void 0
	          );
	        }
	        if (type.flags & 1048576 /* Union */ && type.origin) {
	          type = type.origin;
	        }
	        if (type.flags & (1048576 /* Union */ | 2097152 /* Intersection */)) {
	          const types = type.flags & 1048576 /* Union */ ? formatUnionTypes(type.types) : type.types;
	          if (length(types) === 1) {
	            return typeToTypeNodeHelper(types[0], context);
	          }
	          const typeNodes = mapToTypeNodes(
	            types,
	            context,
	            /*isBareList*/
	            true
	          );
	          if (typeNodes && typeNodes.length > 0) {
	            return type.flags & 1048576 /* Union */ ? factory.createUnionTypeNode(typeNodes) : factory.createIntersectionTypeNode(typeNodes);
	          } else {
	            if (!context.encounteredError && !(context.flags & 262144 /* AllowEmptyUnionOrIntersection */)) {
	              context.encounteredError = true;
	            }
	            return void 0;
	          }
	        }
	        if (objectFlags & (16 /* Anonymous */ | 32 /* Mapped */)) {
	          Debug.assert(!!(type.flags & 524288 /* Object */));
	          return createAnonymousTypeNode(type);
	        }
	        if (type.flags & 4194304 /* Index */) {
	          const indexedType = type.type;
	          context.approximateLength += 6;
	          const indexTypeNode = typeToTypeNodeHelper(indexedType, context);
	          return factory.createTypeOperatorNode(143 /* KeyOfKeyword */, indexTypeNode);
	        }
	        if (type.flags & 134217728 /* TemplateLiteral */) {
	          const texts = type.texts;
	          const types = type.types;
	          const templateHead = factory.createTemplateHead(texts[0]);
	          const templateSpans = factory.createNodeArray(
	            map(types, (t, i) => factory.createTemplateLiteralTypeSpan(
	              typeToTypeNodeHelper(t, context),
	              (i < types.length - 1 ? factory.createTemplateMiddle : factory.createTemplateTail)(texts[i + 1])
	            ))
	          );
	          context.approximateLength += 2;
	          return factory.createTemplateLiteralType(templateHead, templateSpans);
	        }
	        if (type.flags & 268435456 /* StringMapping */) {
	          const typeNode = typeToTypeNodeHelper(type.type, context);
	          return symbolToTypeNode(type.symbol, context, 788968 /* Type */, [typeNode]);
	        }
	        if (type.flags & 8388608 /* IndexedAccess */) {
	          const objectTypeNode = typeToTypeNodeHelper(type.objectType, context);
	          const indexTypeNode = typeToTypeNodeHelper(type.indexType, context);
	          context.approximateLength += 2;
	          return factory.createIndexedAccessTypeNode(objectTypeNode, indexTypeNode);
	        }
	        if (type.flags & 16777216 /* Conditional */) {
	          return visitAndTransformType(type, (type2) => conditionalTypeToTypeNode(type2));
	        }
	        if (type.flags & 33554432 /* Substitution */) {
	          const typeNode = typeToTypeNodeHelper(type.baseType, context);
	          const noInferSymbol = isNoInferType(type) && getGlobalTypeSymbol(
	            "NoInfer",
	            /*reportErrors*/
	            false
	          );
	          return noInferSymbol ? symbolToTypeNode(noInferSymbol, context, 788968 /* Type */, [typeNode]) : typeNode;
	        }
	        return Debug.fail("Should be unreachable.");
	        function conditionalTypeToTypeNode(type2) {
	          const checkTypeNode = typeToTypeNodeHelper(type2.checkType, context);
	          context.approximateLength += 15;
	          if (context.flags & 4 /* GenerateNamesForShadowedTypeParams */ && type2.root.isDistributive && !(type2.checkType.flags & 262144 /* TypeParameter */)) {
	            const newParam = createTypeParameter(createSymbol(262144 /* TypeParameter */, "T"));
	            const name = typeParameterToName(newParam, context);
	            const newTypeVariable = factory.createTypeReferenceNode(name);
	            context.approximateLength += 37;
	            const newMapper = prependTypeMapping(type2.root.checkType, newParam, type2.mapper);
	            const saveInferTypeParameters2 = context.inferTypeParameters;
	            context.inferTypeParameters = type2.root.inferTypeParameters;
	            const extendsTypeNode2 = typeToTypeNodeHelper(instantiateType(type2.root.extendsType, newMapper), context);
	            context.inferTypeParameters = saveInferTypeParameters2;
	            const trueTypeNode2 = typeToTypeNodeOrCircularityElision(instantiateType(getTypeFromTypeNode(type2.root.node.trueType), newMapper));
	            const falseTypeNode2 = typeToTypeNodeOrCircularityElision(instantiateType(getTypeFromTypeNode(type2.root.node.falseType), newMapper));
	            return factory.createConditionalTypeNode(
	              checkTypeNode,
	              factory.createInferTypeNode(factory.createTypeParameterDeclaration(
	                /*modifiers*/
	                void 0,
	                factory.cloneNode(newTypeVariable.typeName)
	              )),
	              factory.createConditionalTypeNode(
	                factory.createTypeReferenceNode(factory.cloneNode(name)),
	                typeToTypeNodeHelper(type2.checkType, context),
	                factory.createConditionalTypeNode(newTypeVariable, extendsTypeNode2, trueTypeNode2, falseTypeNode2),
	                factory.createKeywordTypeNode(146 /* NeverKeyword */)
	              ),
	              factory.createKeywordTypeNode(146 /* NeverKeyword */)
	            );
	          }
	          const saveInferTypeParameters = context.inferTypeParameters;
	          context.inferTypeParameters = type2.root.inferTypeParameters;
	          const extendsTypeNode = typeToTypeNodeHelper(type2.extendsType, context);
	          context.inferTypeParameters = saveInferTypeParameters;
	          const trueTypeNode = typeToTypeNodeOrCircularityElision(getTrueTypeFromConditionalType(type2));
	          const falseTypeNode = typeToTypeNodeOrCircularityElision(getFalseTypeFromConditionalType(type2));
	          return factory.createConditionalTypeNode(checkTypeNode, extendsTypeNode, trueTypeNode, falseTypeNode);
	        }
	        function typeToTypeNodeOrCircularityElision(type2) {
	          var _a2, _b2, _c;
	          if (type2.flags & 1048576 /* Union */) {
	            if ((_a2 = context.visitedTypes) == null ? void 0 : _a2.has(getTypeId(type2))) {
	              if (!(context.flags & 131072 /* AllowAnonymousIdentifier */)) {
	                context.encounteredError = true;
	                (_c = (_b2 = context.tracker) == null ? void 0 : _b2.reportCyclicStructureError) == null ? void 0 : _c.call(_b2);
	              }
	              return createElidedInformationPlaceholder(context);
	            }
	            return visitAndTransformType(type2, (type3) => typeToTypeNodeHelper(type3, context));
	          }
	          return typeToTypeNodeHelper(type2, context);
	        }
	        function isMappedTypeHomomorphic(type2) {
	          return !!getHomomorphicTypeVariable(type2);
	        }
	        function isHomomorphicMappedTypeWithNonHomomorphicInstantiation(type2) {
	          return !!type2.target && isMappedTypeHomomorphic(type2.target) && !isMappedTypeHomomorphic(type2);
	        }
	        function createMappedTypeNodeFromType(type2) {
	          var _a2;
	          Debug.assert(!!(type2.flags & 524288 /* Object */));
	          const readonlyToken = type2.declaration.readonlyToken ? factory.createToken(type2.declaration.readonlyToken.kind) : void 0;
	          const questionToken = type2.declaration.questionToken ? factory.createToken(type2.declaration.questionToken.kind) : void 0;
	          let appropriateConstraintTypeNode;
	          let newTypeVariable;
	          const needsModifierPreservingWrapper = !isMappedTypeWithKeyofConstraintDeclaration(type2) && !(getModifiersTypeFromMappedType(type2).flags & 2 /* Unknown */) && context.flags & 4 /* GenerateNamesForShadowedTypeParams */ && !(getConstraintTypeFromMappedType(type2).flags & 262144 /* TypeParameter */ && ((_a2 = getConstraintOfTypeParameter(getConstraintTypeFromMappedType(type2))) == null ? void 0 : _a2.flags) & 4194304 /* Index */);
	          if (isMappedTypeWithKeyofConstraintDeclaration(type2)) {
	            if (isHomomorphicMappedTypeWithNonHomomorphicInstantiation(type2) && context.flags & 4 /* GenerateNamesForShadowedTypeParams */) {
	              const newParam = createTypeParameter(createSymbol(262144 /* TypeParameter */, "T"));
	              const name = typeParameterToName(newParam, context);
	              newTypeVariable = factory.createTypeReferenceNode(name);
	            }
	            appropriateConstraintTypeNode = factory.createTypeOperatorNode(143 /* KeyOfKeyword */, newTypeVariable || typeToTypeNodeHelper(getModifiersTypeFromMappedType(type2), context));
	          } else if (needsModifierPreservingWrapper) {
	            const newParam = createTypeParameter(createSymbol(262144 /* TypeParameter */, "T"));
	            const name = typeParameterToName(newParam, context);
	            newTypeVariable = factory.createTypeReferenceNode(name);
	            appropriateConstraintTypeNode = newTypeVariable;
	          } else {
	            appropriateConstraintTypeNode = typeToTypeNodeHelper(getConstraintTypeFromMappedType(type2), context);
	          }
	          const typeParameterNode = typeParameterToDeclarationWithConstraint(getTypeParameterFromMappedType(type2), context, appropriateConstraintTypeNode);
	          const nameTypeNode = type2.declaration.nameType ? typeToTypeNodeHelper(getNameTypeFromMappedType(type2), context) : void 0;
	          const templateTypeNode = typeToTypeNodeHelper(removeMissingType(getTemplateTypeFromMappedType(type2), !!(getMappedTypeModifiers(type2) & 4 /* IncludeOptional */)), context);
	          const mappedTypeNode = factory.createMappedTypeNode(
	            readonlyToken,
	            typeParameterNode,
	            nameTypeNode,
	            questionToken,
	            templateTypeNode,
	            /*members*/
	            void 0
	          );
	          context.approximateLength += 10;
	          const result = setEmitFlags(mappedTypeNode, 1 /* SingleLine */);
	          if (isHomomorphicMappedTypeWithNonHomomorphicInstantiation(type2) && context.flags & 4 /* GenerateNamesForShadowedTypeParams */) {
	            const originalConstraint = instantiateType(getConstraintOfTypeParameter(getTypeFromTypeNode(type2.declaration.typeParameter.constraint.type)) || unknownType, type2.mapper);
	            return factory.createConditionalTypeNode(
	              typeToTypeNodeHelper(getModifiersTypeFromMappedType(type2), context),
	              factory.createInferTypeNode(factory.createTypeParameterDeclaration(
	                /*modifiers*/
	                void 0,
	                factory.cloneNode(newTypeVariable.typeName),
	                originalConstraint.flags & 2 /* Unknown */ ? void 0 : typeToTypeNodeHelper(originalConstraint, context)
	              )),
	              result,
	              factory.createKeywordTypeNode(146 /* NeverKeyword */)
	            );
	          } else if (needsModifierPreservingWrapper) {
	            return factory.createConditionalTypeNode(
	              typeToTypeNodeHelper(getConstraintTypeFromMappedType(type2), context),
	              factory.createInferTypeNode(factory.createTypeParameterDeclaration(
	                /*modifiers*/
	                void 0,
	                factory.cloneNode(newTypeVariable.typeName),
	                factory.createTypeOperatorNode(143 /* KeyOfKeyword */, typeToTypeNodeHelper(getModifiersTypeFromMappedType(type2), context))
	              )),
	              result,
	              factory.createKeywordTypeNode(146 /* NeverKeyword */)
	            );
	          }
	          return result;
	        }
	        function createAnonymousTypeNode(type2) {
	          var _a2, _b2;
	          const typeId = type2.id;
	          const symbol = type2.symbol;
	          if (symbol) {
	            const isInstantiationExpressionType = !!(getObjectFlags(type2) & 8388608 /* InstantiationExpressionType */);
	            if (isInstantiationExpressionType) {
	              const instantiationExpressionType = type2;
	              const existing = instantiationExpressionType.node;
	              if (isTypeQueryNode(existing) && getTypeFromTypeNode(existing) === type2) {
	                const typeNode = serializeExistingTypeNode(context, existing);
	                if (typeNode) {
	                  return typeNode;
	                }
	              }
	              if ((_a2 = context.visitedTypes) == null ? void 0 : _a2.has(typeId)) {
	                return createElidedInformationPlaceholder(context);
	              }
	              return visitAndTransformType(type2, createTypeNodeFromObjectType);
	            }
	            const isInstanceType = isClassInstanceSide(type2) ? 788968 /* Type */ : 111551 /* Value */;
	            if (isJSConstructor(symbol.valueDeclaration)) {
	              return symbolToTypeNode(symbol, context, isInstanceType);
	            } else if (symbol.flags & 32 /* Class */ && !getBaseTypeVariableOfClass(symbol) && !(symbol.valueDeclaration && isClassLike(symbol.valueDeclaration) && context.flags & 2048 /* WriteClassExpressionAsTypeLiteral */ && (!isClassDeclaration(symbol.valueDeclaration) || isSymbolAccessible(
	              symbol,
	              context.enclosingDeclaration,
	              isInstanceType,
	              /*shouldComputeAliasesToMakeVisible*/
	              false
	            ).accessibility !== 0 /* Accessible */)) || symbol.flags & (384 /* Enum */ | 512 /* ValueModule */) || shouldWriteTypeOfFunctionSymbol()) {
	              return symbolToTypeNode(symbol, context, isInstanceType);
	            } else if ((_b2 = context.visitedTypes) == null ? void 0 : _b2.has(typeId)) {
	              const typeAlias = getTypeAliasForTypeLiteral(type2);
	              if (typeAlias) {
	                return symbolToTypeNode(typeAlias, context, 788968 /* Type */);
	              } else {
	                return createElidedInformationPlaceholder(context);
	              }
	            } else {
	              return visitAndTransformType(type2, createTypeNodeFromObjectType);
	            }
	          } else {
	            return createTypeNodeFromObjectType(type2);
	          }
	          function shouldWriteTypeOfFunctionSymbol() {
	            var _a3;
	            const isStaticMethodSymbol = !!(symbol.flags & 8192 /* Method */) && // typeof static method
	            some(symbol.declarations, (declaration) => isStatic(declaration));
	            const isNonLocalFunctionSymbol = !!(symbol.flags & 16 /* Function */) && (symbol.parent || // is exported function symbol
	            forEach(symbol.declarations, (declaration) => declaration.parent.kind === 312 /* SourceFile */ || declaration.parent.kind === 268 /* ModuleBlock */));
	            if (isStaticMethodSymbol || isNonLocalFunctionSymbol) {
	              return (!!(context.flags & 4096 /* UseTypeOfFunction */) || ((_a3 = context.visitedTypes) == null ? void 0 : _a3.has(typeId))) && // it is type of the symbol uses itself recursively
	              (!(context.flags & 8 /* UseStructuralFallback */) || isValueSymbolAccessible(symbol, context.enclosingDeclaration));
	            }
	          }
	        }
	        function visitAndTransformType(type2, transform2) {
	          var _a2, _b2, _c;
	          const typeId = type2.id;
	          const isConstructorObject = getObjectFlags(type2) & 16 /* Anonymous */ && type2.symbol && type2.symbol.flags & 32 /* Class */;
	          const id = getObjectFlags(type2) & 4 /* Reference */ && type2.node ? "N" + getNodeId(type2.node) : type2.flags & 16777216 /* Conditional */ ? "N" + getNodeId(type2.root.node) : type2.symbol ? (isConstructorObject ? "+" : "") + getSymbolId(type2.symbol) : void 0;
	          if (!context.visitedTypes) {
	            context.visitedTypes = /* @__PURE__ */ new Set();
	          }
	          if (id && !context.symbolDepth) {
	            context.symbolDepth = /* @__PURE__ */ new Map();
	          }
	          const links = context.enclosingDeclaration && getNodeLinks(context.enclosingDeclaration);
	          const key = `${getTypeId(type2)}|${context.flags}`;
	          if (links) {
	            links.serializedTypes || (links.serializedTypes = /* @__PURE__ */ new Map());
	          }
	          const cachedResult = (_a2 = links == null ? void 0 : links.serializedTypes) == null ? void 0 : _a2.get(key);
	          if (cachedResult) {
	            (_b2 = cachedResult.trackedSymbols) == null ? void 0 : _b2.forEach(
	              ([symbol, enclosingDeclaration, meaning]) => context.tracker.trackSymbol(
	                symbol,
	                enclosingDeclaration,
	                meaning
	              )
	            );
	            if (cachedResult.truncating) {
	              context.truncating = true;
	            }
	            context.approximateLength += cachedResult.addedLength;
	            return deepCloneOrReuseNode(cachedResult.node);
	          }
	          let depth;
	          if (id) {
	            depth = context.symbolDepth.get(id) || 0;
	            if (depth > 10) {
	              return createElidedInformationPlaceholder(context);
	            }
	            context.symbolDepth.set(id, depth + 1);
	          }
	          context.visitedTypes.add(typeId);
	          const prevTrackedSymbols = context.trackedSymbols;
	          context.trackedSymbols = void 0;
	          const startLength = context.approximateLength;
	          const result = transform2(type2);
	          const addedLength = context.approximateLength - startLength;
	          if (!context.reportedDiagnostic && !context.encounteredError) {
	            (_c = links == null ? void 0 : links.serializedTypes) == null ? void 0 : _c.set(key, {
	              node: result,
	              truncating: context.truncating,
	              addedLength,
	              trackedSymbols: context.trackedSymbols
	            });
	          }
	          context.visitedTypes.delete(typeId);
	          if (id) {
	            context.symbolDepth.set(id, depth);
	          }
	          context.trackedSymbols = prevTrackedSymbols;
	          return result;
	          function deepCloneOrReuseNode(node) {
	            if (!nodeIsSynthesized(node) && getParseTreeNode(node) === node) {
	              return node;
	            }
	            return setTextRange(factory.cloneNode(visitEachChild(
	              node,
	              deepCloneOrReuseNode,
	              /*context*/
	              void 0,
	              deepCloneOrReuseNodes
	            )), node);
	          }
	          function deepCloneOrReuseNodes(nodes, visitor, test, start, count) {
	            if (nodes && nodes.length === 0) {
	              return setTextRange(factory.createNodeArray(
	                /*elements*/
	                void 0,
	                nodes.hasTrailingComma
	              ), nodes);
	            }
	            return visitNodes2(nodes, visitor, test, start, count);
	          }
	        }
	        function createTypeNodeFromObjectType(type2) {
	          if (isGenericMappedType(type2) || type2.containsError) {
	            return createMappedTypeNodeFromType(type2);
	          }
	          const resolved = resolveStructuredTypeMembers(type2);
	          if (!resolved.properties.length && !resolved.indexInfos.length) {
	            if (!resolved.callSignatures.length && !resolved.constructSignatures.length) {
	              context.approximateLength += 2;
	              return setEmitFlags(factory.createTypeLiteralNode(
	                /*members*/
	                void 0
	              ), 1 /* SingleLine */);
	            }
	            if (resolved.callSignatures.length === 1 && !resolved.constructSignatures.length) {
	              const signature = resolved.callSignatures[0];
	              const signatureNode = signatureToSignatureDeclarationHelper(signature, 184 /* FunctionType */, context);
	              return signatureNode;
	            }
	            if (resolved.constructSignatures.length === 1 && !resolved.callSignatures.length) {
	              const signature = resolved.constructSignatures[0];
	              const signatureNode = signatureToSignatureDeclarationHelper(signature, 185 /* ConstructorType */, context);
	              return signatureNode;
	            }
	          }
	          const abstractSignatures = filter(resolved.constructSignatures, (signature) => !!(signature.flags & 4 /* Abstract */));
	          if (some(abstractSignatures)) {
	            const types = map(abstractSignatures, getOrCreateTypeFromSignature);
	            const typeElementCount = resolved.callSignatures.length + (resolved.constructSignatures.length - abstractSignatures.length) + resolved.indexInfos.length + // exclude `prototype` when writing a class expression as a type literal, as per
	            // the logic in `createTypeNodesFromResolvedType`.
	            (context.flags & 2048 /* WriteClassExpressionAsTypeLiteral */ ? countWhere(resolved.properties, (p) => !(p.flags & 4194304 /* Prototype */)) : length(resolved.properties));
	            if (typeElementCount) {
	              types.push(getResolvedTypeWithoutAbstractConstructSignatures(resolved));
	            }
	            return typeToTypeNodeHelper(getIntersectionType(types), context);
	          }
	          const savedFlags = context.flags;
	          context.flags |= 4194304 /* InObjectTypeLiteral */;
	          const members = createTypeNodesFromResolvedType(resolved);
	          context.flags = savedFlags;
	          const typeLiteralNode = factory.createTypeLiteralNode(members);
	          context.approximateLength += 2;
	          setEmitFlags(typeLiteralNode, context.flags & 1024 /* MultilineObjectLiterals */ ? 0 : 1 /* SingleLine */);
	          return typeLiteralNode;
	        }
	        function typeReferenceToTypeNode(type2) {
	          let typeArguments = getTypeArguments(type2);
	          if (type2.target === globalArrayType || type2.target === globalReadonlyArrayType) {
	            if (context.flags & 2 /* WriteArrayAsGenericType */) {
	              const typeArgumentNode = typeToTypeNodeHelper(typeArguments[0], context);
	              return factory.createTypeReferenceNode(type2.target === globalArrayType ? "Array" : "ReadonlyArray", [typeArgumentNode]);
	            }
	            const elementType = typeToTypeNodeHelper(typeArguments[0], context);
	            const arrayType = factory.createArrayTypeNode(elementType);
	            return type2.target === globalArrayType ? arrayType : factory.createTypeOperatorNode(148 /* ReadonlyKeyword */, arrayType);
	          } else if (type2.target.objectFlags & 8 /* Tuple */) {
	            typeArguments = sameMap(typeArguments, (t, i) => removeMissingType(t, !!(type2.target.elementFlags[i] & 2 /* Optional */)));
	            if (typeArguments.length > 0) {
	              const arity = getTypeReferenceArity(type2);
	              const tupleConstituentNodes = mapToTypeNodes(typeArguments.slice(0, arity), context);
	              if (tupleConstituentNodes) {
	                const { labeledElementDeclarations } = type2.target;
	                for (let i = 0; i < tupleConstituentNodes.length; i++) {
	                  const flags = type2.target.elementFlags[i];
	                  const labeledElementDeclaration = labeledElementDeclarations == null ? void 0 : labeledElementDeclarations[i];
	                  if (labeledElementDeclaration) {
	                    tupleConstituentNodes[i] = factory.createNamedTupleMember(
	                      flags & 12 /* Variable */ ? factory.createToken(26 /* DotDotDotToken */) : void 0,
	                      factory.createIdentifier(unescapeLeadingUnderscores(getTupleElementLabel(labeledElementDeclaration))),
	                      flags & 2 /* Optional */ ? factory.createToken(58 /* QuestionToken */) : void 0,
	                      flags & 4 /* Rest */ ? factory.createArrayTypeNode(tupleConstituentNodes[i]) : tupleConstituentNodes[i]
	                    );
	                  } else {
	                    tupleConstituentNodes[i] = flags & 12 /* Variable */ ? factory.createRestTypeNode(flags & 4 /* Rest */ ? factory.createArrayTypeNode(tupleConstituentNodes[i]) : tupleConstituentNodes[i]) : flags & 2 /* Optional */ ? factory.createOptionalTypeNode(tupleConstituentNodes[i]) : tupleConstituentNodes[i];
	                  }
	                }
	                const tupleTypeNode = setEmitFlags(factory.createTupleTypeNode(tupleConstituentNodes), 1 /* SingleLine */);
	                return type2.target.readonly ? factory.createTypeOperatorNode(148 /* ReadonlyKeyword */, tupleTypeNode) : tupleTypeNode;
	              }
	            }
	            if (context.encounteredError || context.flags & 524288 /* AllowEmptyTuple */) {
	              const tupleTypeNode = setEmitFlags(factory.createTupleTypeNode([]), 1 /* SingleLine */);
	              return type2.target.readonly ? factory.createTypeOperatorNode(148 /* ReadonlyKeyword */, tupleTypeNode) : tupleTypeNode;
	            }
	            context.encounteredError = true;
	            return void 0;
	          } else if (context.flags & 2048 /* WriteClassExpressionAsTypeLiteral */ && type2.symbol.valueDeclaration && isClassLike(type2.symbol.valueDeclaration) && !isValueSymbolAccessible(type2.symbol, context.enclosingDeclaration)) {
	            return createAnonymousTypeNode(type2);
	          } else {
	            const outerTypeParameters = type2.target.outerTypeParameters;
	            let i = 0;
	            let resultType;
	            if (outerTypeParameters) {
	              const length2 = outerTypeParameters.length;
	              while (i < length2) {
	                const start = i;
	                const parent2 = getParentSymbolOfTypeParameter(outerTypeParameters[i]);
	                do {
	                  i++;
	                } while (i < length2 && getParentSymbolOfTypeParameter(outerTypeParameters[i]) === parent2);
	                if (!rangeEquals(outerTypeParameters, typeArguments, start, i)) {
	                  const typeArgumentSlice = mapToTypeNodes(typeArguments.slice(start, i), context);
	                  const flags2 = context.flags;
	                  context.flags |= 16 /* ForbidIndexedAccessSymbolReferences */;
	                  const ref = symbolToTypeNode(parent2, context, 788968 /* Type */, typeArgumentSlice);
	                  context.flags = flags2;
	                  resultType = !resultType ? ref : appendReferenceToType(resultType, ref);
	                }
	              }
	            }
	            let typeArgumentNodes;
	            if (typeArguments.length > 0) {
	              const typeParameterCount = (type2.target.typeParameters || emptyArray).length;
	              typeArgumentNodes = mapToTypeNodes(typeArguments.slice(i, typeParameterCount), context);
	            }
	            const flags = context.flags;
	            context.flags |= 16 /* ForbidIndexedAccessSymbolReferences */;
	            const finalRef = symbolToTypeNode(type2.symbol, context, 788968 /* Type */, typeArgumentNodes);
	            context.flags = flags;
	            return !resultType ? finalRef : appendReferenceToType(resultType, finalRef);
	          }
	        }
	        function appendReferenceToType(root, ref) {
	          if (isImportTypeNode(root)) {
	            let typeArguments = root.typeArguments;
	            let qualifier = root.qualifier;
	            if (qualifier) {
	              if (isIdentifier(qualifier)) {
	                if (typeArguments !== getIdentifierTypeArguments(qualifier)) {
	                  qualifier = setIdentifierTypeArguments(factory.cloneNode(qualifier), typeArguments);
	                }
	              } else {
	                if (typeArguments !== getIdentifierTypeArguments(qualifier.right)) {
	                  qualifier = factory.updateQualifiedName(qualifier, qualifier.left, setIdentifierTypeArguments(factory.cloneNode(qualifier.right), typeArguments));
	                }
	              }
	            }
	            typeArguments = ref.typeArguments;
	            const ids = getAccessStack(ref);
	            for (const id of ids) {
	              qualifier = qualifier ? factory.createQualifiedName(qualifier, id) : id;
	            }
	            return factory.updateImportTypeNode(
	              root,
	              root.argument,
	              root.attributes,
	              qualifier,
	              typeArguments,
	              root.isTypeOf
	            );
	          } else {
	            let typeArguments = root.typeArguments;
	            let typeName = root.typeName;
	            if (isIdentifier(typeName)) {
	              if (typeArguments !== getIdentifierTypeArguments(typeName)) {
	                typeName = setIdentifierTypeArguments(factory.cloneNode(typeName), typeArguments);
	              }
	            } else {
	              if (typeArguments !== getIdentifierTypeArguments(typeName.right)) {
	                typeName = factory.updateQualifiedName(typeName, typeName.left, setIdentifierTypeArguments(factory.cloneNode(typeName.right), typeArguments));
	              }
	            }
	            typeArguments = ref.typeArguments;
	            const ids = getAccessStack(ref);
	            for (const id of ids) {
	              typeName = factory.createQualifiedName(typeName, id);
	            }
	            return factory.updateTypeReferenceNode(
	              root,
	              typeName,
	              typeArguments
	            );
	          }
	        }
	        function getAccessStack(ref) {
	          let state = ref.typeName;
	          const ids = [];
	          while (!isIdentifier(state)) {
	            ids.unshift(state.right);
	            state = state.left;
	          }
	          ids.unshift(state);
	          return ids;
	        }
	        function createTypeNodesFromResolvedType(resolvedType) {
	          if (checkTruncationLength(context)) {
	            return [factory.createPropertySignature(
	              /*modifiers*/
	              void 0,
	              "...",
	              /*questionToken*/
	              void 0,
	              /*type*/
	              void 0
	            )];
	          }
	          const typeElements = [];
	          for (const signature of resolvedType.callSignatures) {
	            typeElements.push(signatureToSignatureDeclarationHelper(signature, 179 /* CallSignature */, context));
	          }
	          for (const signature of resolvedType.constructSignatures) {
	            if (signature.flags & 4 /* Abstract */)
	              continue;
	            typeElements.push(signatureToSignatureDeclarationHelper(signature, 180 /* ConstructSignature */, context));
	          }
	          for (const info of resolvedType.indexInfos) {
	            typeElements.push(indexInfoToIndexSignatureDeclarationHelper(info, context, resolvedType.objectFlags & 1024 /* ReverseMapped */ ? createElidedInformationPlaceholder(context) : void 0));
	          }
	          const properties = resolvedType.properties;
	          if (!properties) {
	            return typeElements;
	          }
	          let i = 0;
	          for (const propertySymbol of properties) {
	            i++;
	            if (context.flags & 2048 /* WriteClassExpressionAsTypeLiteral */) {
	              if (propertySymbol.flags & 4194304 /* Prototype */) {
	                continue;
	              }
	              if (getDeclarationModifierFlagsFromSymbol(propertySymbol) & (2 /* Private */ | 4 /* Protected */) && context.tracker.reportPrivateInBaseOfClassExpression) {
	                context.tracker.reportPrivateInBaseOfClassExpression(unescapeLeadingUnderscores(propertySymbol.escapedName));
	              }
	            }
	            if (checkTruncationLength(context) && i + 2 < properties.length - 1) {
	              typeElements.push(factory.createPropertySignature(
	                /*modifiers*/
	                void 0,
	                `... ${properties.length - i} more ...`,
	                /*questionToken*/
	                void 0,
	                /*type*/
	                void 0
	              ));
	              addPropertyToElementList(properties[properties.length - 1], context, typeElements);
	              break;
	            }
	            addPropertyToElementList(propertySymbol, context, typeElements);
	          }
	          return typeElements.length ? typeElements : void 0;
	        }
	      }
	      function createElidedInformationPlaceholder(context) {
	        context.approximateLength += 3;
	        if (!(context.flags & 1 /* NoTruncation */)) {
	          return factory.createTypeReferenceNode(
	            factory.createIdentifier("..."),
	            /*typeArguments*/
	            void 0
	          );
	        }
	        return factory.createKeywordTypeNode(133 /* AnyKeyword */);
	      }
	      function shouldUsePlaceholderForProperty(propertySymbol, context) {
	        var _a;
	        return !!(getCheckFlags(propertySymbol) & 8192 /* ReverseMapped */) && (contains(context.reverseMappedStack, propertySymbol) || ((_a = context.reverseMappedStack) == null ? void 0 : _a[0]) && !(getObjectFlags(last(context.reverseMappedStack).links.propertyType) & 16 /* Anonymous */));
	      }
	      function addPropertyToElementList(propertySymbol, context, typeElements) {
	        var _a;
	        const propertyIsReverseMapped = !!(getCheckFlags(propertySymbol) & 8192 /* ReverseMapped */);
	        const propertyType = shouldUsePlaceholderForProperty(propertySymbol, context) ? anyType : getNonMissingTypeOfSymbol(propertySymbol);
	        const saveEnclosingDeclaration = context.enclosingDeclaration;
	        context.enclosingDeclaration = void 0;
	        if (context.tracker.canTrackSymbol && isLateBoundName(propertySymbol.escapedName)) {
	          if (propertySymbol.declarations) {
	            const decl = first(propertySymbol.declarations);
	            if (hasLateBindableName(decl)) {
	              if (isBinaryExpression(decl)) {
	                const name = getNameOfDeclaration(decl);
	                if (name && isElementAccessExpression(name) && isPropertyAccessEntityNameExpression(name.argumentExpression)) {
	                  trackComputedName(name.argumentExpression, saveEnclosingDeclaration, context);
	                }
	              } else {
	                trackComputedName(decl.name.expression, saveEnclosingDeclaration, context);
	              }
	            }
	          } else {
	            context.tracker.reportNonSerializableProperty(symbolToString(propertySymbol));
	          }
	        }
	        context.enclosingDeclaration = propertySymbol.valueDeclaration || ((_a = propertySymbol.declarations) == null ? void 0 : _a[0]) || saveEnclosingDeclaration;
	        const propertyName = getPropertyNameNodeForSymbol(propertySymbol, context);
	        context.enclosingDeclaration = saveEnclosingDeclaration;
	        context.approximateLength += symbolName(propertySymbol).length + 1;
	        if (propertySymbol.flags & 98304 /* Accessor */) {
	          const writeType = getWriteTypeOfSymbol(propertySymbol);
	          if (propertyType !== writeType && !isErrorType(propertyType) && !isErrorType(writeType)) {
	            const getterDeclaration = getDeclarationOfKind(propertySymbol, 177 /* GetAccessor */);
	            const getterSignature = getSignatureFromDeclaration(getterDeclaration);
	            typeElements.push(
	              setCommentRange(
	                signatureToSignatureDeclarationHelper(getterSignature, 177 /* GetAccessor */, context, { name: propertyName }),
	                getterDeclaration
	              )
	            );
	            const setterDeclaration = getDeclarationOfKind(propertySymbol, 178 /* SetAccessor */);
	            const setterSignature = getSignatureFromDeclaration(setterDeclaration);
	            typeElements.push(
	              setCommentRange(
	                signatureToSignatureDeclarationHelper(setterSignature, 178 /* SetAccessor */, context, { name: propertyName }),
	                setterDeclaration
	              )
	            );
	            return;
	          }
	        }
	        const optionalToken = propertySymbol.flags & 16777216 /* Optional */ ? factory.createToken(58 /* QuestionToken */) : void 0;
	        if (propertySymbol.flags & (16 /* Function */ | 8192 /* Method */) && !getPropertiesOfObjectType(propertyType).length && !isReadonlySymbol(propertySymbol)) {
	          const signatures = getSignaturesOfType(filterType(propertyType, (t) => !(t.flags & 32768 /* Undefined */)), 0 /* Call */);
	          for (const signature of signatures) {
	            const methodDeclaration = signatureToSignatureDeclarationHelper(signature, 173 /* MethodSignature */, context, { name: propertyName, questionToken: optionalToken });
	            typeElements.push(preserveCommentsOn(methodDeclaration));
	          }
	          if (signatures.length || !optionalToken) {
	            return;
	          }
	        }
	        let propertyTypeNode;
	        if (shouldUsePlaceholderForProperty(propertySymbol, context)) {
	          propertyTypeNode = createElidedInformationPlaceholder(context);
	        } else {
	          if (propertyIsReverseMapped) {
	            context.reverseMappedStack || (context.reverseMappedStack = []);
	            context.reverseMappedStack.push(propertySymbol);
	          }
	          propertyTypeNode = propertyType ? serializeTypeForDeclaration(context, propertyType, propertySymbol, saveEnclosingDeclaration) : factory.createKeywordTypeNode(133 /* AnyKeyword */);
	          if (propertyIsReverseMapped) {
	            context.reverseMappedStack.pop();
	          }
	        }
	        const modifiers = isReadonlySymbol(propertySymbol) ? [factory.createToken(148 /* ReadonlyKeyword */)] : void 0;
	        if (modifiers) {
	          context.approximateLength += 9;
	        }
	        const propertySignature = factory.createPropertySignature(
	          modifiers,
	          propertyName,
	          optionalToken,
	          propertyTypeNode
	        );
	        typeElements.push(preserveCommentsOn(propertySignature));
	        function preserveCommentsOn(node) {
	          var _a2;
	          const jsdocPropertyTag = (_a2 = propertySymbol.declarations) == null ? void 0 : _a2.find((d) => d.kind === 355 /* JSDocPropertyTag */);
	          if (jsdocPropertyTag) {
	            const commentText = getTextOfJSDocComment(jsdocPropertyTag.comment);
	            if (commentText) {
	              setSyntheticLeadingComments(node, [{ kind: 3 /* MultiLineCommentTrivia */, text: "*\n * " + commentText.replace(/\n/g, "\n * ") + "\n ", pos: -1, end: -1, hasTrailingNewLine: true }]);
	            }
	          } else if (propertySymbol.valueDeclaration) {
	            setCommentRange(node, propertySymbol.valueDeclaration);
	          }
	          return node;
	        }
	      }
	      function mapToTypeNodes(types, context, isBareList) {
	        if (some(types)) {
	          if (checkTruncationLength(context)) {
	            if (!isBareList) {
	              return [factory.createTypeReferenceNode(
	                "...",
	                /*typeArguments*/
	                void 0
	              )];
	            } else if (types.length > 2) {
	              return [
	                typeToTypeNodeHelper(types[0], context),
	                factory.createTypeReferenceNode(
	                  `... ${types.length - 2} more ...`,
	                  /*typeArguments*/
	                  void 0
	                ),
	                typeToTypeNodeHelper(types[types.length - 1], context)
	              ];
	            }
	          }
	          const mayHaveNameCollisions = !(context.flags & 64 /* UseFullyQualifiedType */);
	          const seenNames = mayHaveNameCollisions ? createMultiMap() : void 0;
	          const result = [];
	          let i = 0;
	          for (const type of types) {
	            i++;
	            if (checkTruncationLength(context) && i + 2 < types.length - 1) {
	              result.push(factory.createTypeReferenceNode(
	                `... ${types.length - i} more ...`,
	                /*typeArguments*/
	                void 0
	              ));
	              const typeNode2 = typeToTypeNodeHelper(types[types.length - 1], context);
	              if (typeNode2) {
	                result.push(typeNode2);
	              }
	              break;
	            }
	            context.approximateLength += 2;
	            const typeNode = typeToTypeNodeHelper(type, context);
	            if (typeNode) {
	              result.push(typeNode);
	              if (seenNames && isIdentifierTypeReference(typeNode)) {
	                seenNames.add(typeNode.typeName.escapedText, [type, result.length - 1]);
	              }
	            }
	          }
	          if (seenNames) {
	            const saveContextFlags = context.flags;
	            context.flags |= 64 /* UseFullyQualifiedType */;
	            seenNames.forEach((types2) => {
	              if (!arrayIsHomogeneous(types2, ([a], [b]) => typesAreSameReference(a, b))) {
	                for (const [type, resultIndex] of types2) {
	                  result[resultIndex] = typeToTypeNodeHelper(type, context);
	                }
	              }
	            });
	            context.flags = saveContextFlags;
	          }
	          return result;
	        }
	      }
	      function typesAreSameReference(a, b) {
	        return a === b || !!a.symbol && a.symbol === b.symbol || !!a.aliasSymbol && a.aliasSymbol === b.aliasSymbol;
	      }
	      function indexInfoToIndexSignatureDeclarationHelper(indexInfo, context, typeNode) {
	        const name = getNameFromIndexInfo(indexInfo) || "x";
	        const indexerTypeNode = typeToTypeNodeHelper(indexInfo.keyType, context);
	        const indexingParameter = factory.createParameterDeclaration(
	          /*modifiers*/
	          void 0,
	          /*dotDotDotToken*/
	          void 0,
	          name,
	          /*questionToken*/
	          void 0,
	          indexerTypeNode,
	          /*initializer*/
	          void 0
	        );
	        if (!typeNode) {
	          typeNode = typeToTypeNodeHelper(indexInfo.type || anyType, context);
	        }
	        if (!indexInfo.type && !(context.flags & 2097152 /* AllowEmptyIndexInfoType */)) {
	          context.encounteredError = true;
	        }
	        context.approximateLength += name.length + 4;
	        return factory.createIndexSignature(
	          indexInfo.isReadonly ? [factory.createToken(148 /* ReadonlyKeyword */)] : void 0,
	          [indexingParameter],
	          typeNode
	        );
	      }
	      function signatureToSignatureDeclarationHelper(signature, kind, context, options) {
	        var _a;
	        const suppressAny = context.flags & 256 /* SuppressAnyReturnType */;
	        if (suppressAny)
	          context.flags &= ~256 /* SuppressAnyReturnType */;
	        context.approximateLength += 3;
	        let typeParameters;
	        let typeArguments;
	        if (context.flags & 32 /* WriteTypeArgumentsOfSignature */ && signature.target && signature.mapper && signature.target.typeParameters) {
	          typeArguments = signature.target.typeParameters.map((parameter) => typeToTypeNodeHelper(instantiateType(parameter, signature.mapper), context));
	        } else {
	          typeParameters = signature.typeParameters && signature.typeParameters.map((parameter) => typeParameterToDeclaration(parameter, context));
	        }
	        const expandedParams = getExpandedParameters(
	          signature,
	          /*skipUnionExpanding*/
	          true
	        )[0];
	        let cleanup;
	        if (context.enclosingDeclaration && signature.declaration && signature.declaration !== context.enclosingDeclaration && !isInJSFile(signature.declaration) && (some(expandedParams) || some(signature.typeParameters))) {
	          let pushFakeScope2 = function(kind2, addAll) {
	            Debug.assert(context.enclosingDeclaration);
	            let existingFakeScope;
	            if (getNodeLinks(context.enclosingDeclaration).fakeScopeForSignatureDeclaration === kind2) {
	              existingFakeScope = context.enclosingDeclaration;
	            } else if (context.enclosingDeclaration.parent && getNodeLinks(context.enclosingDeclaration.parent).fakeScopeForSignatureDeclaration === kind2) {
	              existingFakeScope = context.enclosingDeclaration.parent;
	            }
	            Debug.assertOptionalNode(existingFakeScope, isBlock);
	            const locals = (existingFakeScope == null ? void 0 : existingFakeScope.locals) ?? createSymbolTable();
	            let newLocals;
	            addAll((name, symbol) => {
	              if (!locals.has(name)) {
	                newLocals = append(newLocals, name);
	                locals.set(name, symbol);
	              }
	            });
	            if (!newLocals)
	              return;
	            const oldCleanup = cleanup;
	            function undo() {
	              forEach(newLocals, (s) => locals.delete(s));
	              oldCleanup == null ? void 0 : oldCleanup();
	            }
	            if (existingFakeScope) {
	              cleanup = undo;
	            } else {
	              const fakeScope = parseNodeFactory.createBlock(emptyArray);
	              getNodeLinks(fakeScope).fakeScopeForSignatureDeclaration = kind2;
	              fakeScope.locals = locals;
	              const saveEnclosingDeclaration = context.enclosingDeclaration;
	              setParent(fakeScope, saveEnclosingDeclaration);
	              context.enclosingDeclaration = fakeScope;
	              cleanup = () => {
	                context.enclosingDeclaration = saveEnclosingDeclaration;
	                undo();
	              };
	            }
	          };
	          pushFakeScope2(
	            "params",
	            (add) => {
	              for (const param of expandedParams) {
	                add(param.escapedName, param);
	              }
	            }
	          );
	          if (context.flags & 4 /* GenerateNamesForShadowedTypeParams */) {
	            pushFakeScope2(
	              "typeParams",
	              (add) => {
	                for (const typeParam of signature.typeParameters ?? emptyArray) {
	                  const typeParamName = typeParameterToName(typeParam, context).escapedText;
	                  add(typeParamName, typeParam.symbol);
	                }
	              }
	            );
	          }
	        }
	        const parameters = (some(expandedParams, (p) => p !== expandedParams[expandedParams.length - 1] && !!(getCheckFlags(p) & 32768 /* RestParameter */)) ? signature.parameters : expandedParams).map((parameter) => symbolToParameterDeclaration(parameter, context, kind === 176 /* Constructor */, options == null ? void 0 : options.privateSymbolVisitor, options == null ? void 0 : options.bundledImports));
	        const thisParameter = context.flags & 33554432 /* OmitThisParameter */ ? void 0 : tryGetThisParameterDeclaration(signature, context);
	        if (thisParameter) {
	          parameters.unshift(thisParameter);
	        }
	        let returnTypeNode;
	        const typePredicate = getTypePredicateOfSignature(signature);
	        if (typePredicate) {
	          const assertsModifier = typePredicate.kind === 2 /* AssertsThis */ || typePredicate.kind === 3 /* AssertsIdentifier */ ? factory.createToken(131 /* AssertsKeyword */) : void 0;
	          const parameterName = typePredicate.kind === 1 /* Identifier */ || typePredicate.kind === 3 /* AssertsIdentifier */ ? setEmitFlags(factory.createIdentifier(typePredicate.parameterName), 16777216 /* NoAsciiEscaping */) : factory.createThisTypeNode();
	          const typeNode = typePredicate.type && typeToTypeNodeHelper(typePredicate.type, context);
	          returnTypeNode = factory.createTypePredicateNode(assertsModifier, parameterName, typeNode);
	        } else {
	          const returnType = getReturnTypeOfSignature(signature);
	          if (returnType && !(suppressAny && isTypeAny(returnType))) {
	            returnTypeNode = serializeReturnTypeForSignature(context, returnType, signature, options == null ? void 0 : options.privateSymbolVisitor, options == null ? void 0 : options.bundledImports);
	          } else if (!suppressAny) {
	            returnTypeNode = factory.createKeywordTypeNode(133 /* AnyKeyword */);
	          }
	        }
	        let modifiers = options == null ? void 0 : options.modifiers;
	        if (kind === 185 /* ConstructorType */ && signature.flags & 4 /* Abstract */) {
	          const flags = modifiersToFlags(modifiers);
	          modifiers = factory.createModifiersFromModifierFlags(flags | 64 /* Abstract */);
	        }
	        const node = kind === 179 /* CallSignature */ ? factory.createCallSignature(typeParameters, parameters, returnTypeNode) : kind === 180 /* ConstructSignature */ ? factory.createConstructSignature(typeParameters, parameters, returnTypeNode) : kind === 173 /* MethodSignature */ ? factory.createMethodSignature(modifiers, (options == null ? void 0 : options.name) ?? factory.createIdentifier(""), options == null ? void 0 : options.questionToken, typeParameters, parameters, returnTypeNode) : kind === 174 /* MethodDeclaration */ ? factory.createMethodDeclaration(
	          modifiers,
	          /*asteriskToken*/
	          void 0,
	          (options == null ? void 0 : options.name) ?? factory.createIdentifier(""),
	          /*questionToken*/
	          void 0,
	          typeParameters,
	          parameters,
	          returnTypeNode,
	          /*body*/
	          void 0
	        ) : kind === 176 /* Constructor */ ? factory.createConstructorDeclaration(
	          modifiers,
	          parameters,
	          /*body*/
	          void 0
	        ) : kind === 177 /* GetAccessor */ ? factory.createGetAccessorDeclaration(
	          modifiers,
	          (options == null ? void 0 : options.name) ?? factory.createIdentifier(""),
	          parameters,
	          returnTypeNode,
	          /*body*/
	          void 0
	        ) : kind === 178 /* SetAccessor */ ? factory.createSetAccessorDeclaration(
	          modifiers,
	          (options == null ? void 0 : options.name) ?? factory.createIdentifier(""),
	          parameters,
	          /*body*/
	          void 0
	        ) : kind === 181 /* IndexSignature */ ? factory.createIndexSignature(modifiers, parameters, returnTypeNode) : kind === 324 /* JSDocFunctionType */ ? factory.createJSDocFunctionType(parameters, returnTypeNode) : kind === 184 /* FunctionType */ ? factory.createFunctionTypeNode(typeParameters, parameters, returnTypeNode ?? factory.createTypeReferenceNode(factory.createIdentifier(""))) : kind === 185 /* ConstructorType */ ? factory.createConstructorTypeNode(modifiers, typeParameters, parameters, returnTypeNode ?? factory.createTypeReferenceNode(factory.createIdentifier(""))) : kind === 262 /* FunctionDeclaration */ ? factory.createFunctionDeclaration(
	          modifiers,
	          /*asteriskToken*/
	          void 0,
	          (options == null ? void 0 : options.name) ? cast(options.name, isIdentifier) : factory.createIdentifier(""),
	          typeParameters,
	          parameters,
	          returnTypeNode,
	          /*body*/
	          void 0
	        ) : kind === 218 /* FunctionExpression */ ? factory.createFunctionExpression(
	          modifiers,
	          /*asteriskToken*/
	          void 0,
	          (options == null ? void 0 : options.name) ? cast(options.name, isIdentifier) : factory.createIdentifier(""),
	          typeParameters,
	          parameters,
	          returnTypeNode,
	          factory.createBlock([])
	        ) : kind === 219 /* ArrowFunction */ ? factory.createArrowFunction(
	          modifiers,
	          typeParameters,
	          parameters,
	          returnTypeNode,
	          /*equalsGreaterThanToken*/
	          void 0,
	          factory.createBlock([])
	        ) : Debug.assertNever(kind);
	        if (typeArguments) {
	          node.typeArguments = factory.createNodeArray(typeArguments);
	        }
	        if (((_a = signature.declaration) == null ? void 0 : _a.kind) === 330 /* JSDocSignature */ && signature.declaration.parent.kind === 346 /* JSDocOverloadTag */) {
	          const comment = getTextOfNode(
	            signature.declaration.parent.parent,
	            /*includeTrivia*/
	            true
	          ).slice(2, -2).split(/\r\n|\n|\r/).map((line) => line.replace(/^\s+/, " ")).join("\n");
	          addSyntheticLeadingComment(
	            node,
	            3 /* MultiLineCommentTrivia */,
	            comment,
	            /*hasTrailingNewLine*/
	            true
	          );
	        }
	        cleanup == null ? void 0 : cleanup();
	        return node;
	      }
	      function tryGetThisParameterDeclaration(signature, context) {
	        if (signature.thisParameter) {
	          return symbolToParameterDeclaration(signature.thisParameter, context);
	        }
	        if (signature.declaration && isInJSFile(signature.declaration)) {
	          const thisTag = getJSDocThisTag(signature.declaration);
	          if (thisTag && thisTag.typeExpression) {
	            return factory.createParameterDeclaration(
	              /*modifiers*/
	              void 0,
	              /*dotDotDotToken*/
	              void 0,
	              "this",
	              /*questionToken*/
	              void 0,
	              typeToTypeNodeHelper(getTypeFromTypeNode(thisTag.typeExpression), context)
	            );
	          }
	        }
	      }
	      function typeParameterToDeclarationWithConstraint(type, context, constraintNode) {
	        const savedContextFlags = context.flags;
	        context.flags &= ~512 /* WriteTypeParametersInQualifiedName */;
	        const modifiers = factory.createModifiersFromModifierFlags(getTypeParameterModifiers(type));
	        const name = typeParameterToName(type, context);
	        const defaultParameter = getDefaultFromTypeParameter(type);
	        const defaultParameterNode = defaultParameter && typeToTypeNodeHelper(defaultParameter, context);
	        context.flags = savedContextFlags;
	        return factory.createTypeParameterDeclaration(modifiers, name, constraintNode, defaultParameterNode);
	      }
	      function typeParameterToDeclaration(type, context, constraint = getConstraintOfTypeParameter(type)) {
	        const constraintNode = constraint && typeToTypeNodeHelper(constraint, context);
	        return typeParameterToDeclarationWithConstraint(type, context, constraintNode);
	      }
	      function getEffectiveParameterDeclaration(parameterSymbol) {
	        const parameterDeclaration = getDeclarationOfKind(parameterSymbol, 169 /* Parameter */);
	        if (parameterDeclaration) {
	          return parameterDeclaration;
	        }
	        if (!isTransientSymbol(parameterSymbol)) {
	          return getDeclarationOfKind(parameterSymbol, 348 /* JSDocParameterTag */);
	        }
	      }
	      function symbolToParameterDeclaration(parameterSymbol, context, preserveModifierFlags, privateSymbolVisitor, bundledImports) {
	        const parameterDeclaration = getEffectiveParameterDeclaration(parameterSymbol);
	        let parameterType = getTypeOfSymbol(parameterSymbol);
	        if (parameterDeclaration && isRequiredInitializedParameter(parameterDeclaration)) {
	          parameterType = getOptionalType(parameterType);
	        }
	        const parameterTypeNode = serializeTypeForDeclaration(context, parameterType, parameterSymbol, context.enclosingDeclaration, privateSymbolVisitor, bundledImports);
	        const modifiers = !(context.flags & 8192 /* OmitParameterModifiers */) && preserveModifierFlags && parameterDeclaration && canHaveModifiers(parameterDeclaration) ? map(getModifiers(parameterDeclaration), factory.cloneNode) : void 0;
	        const isRest = parameterDeclaration && isRestParameter(parameterDeclaration) || getCheckFlags(parameterSymbol) & 32768 /* RestParameter */;
	        const dotDotDotToken = isRest ? factory.createToken(26 /* DotDotDotToken */) : void 0;
	        const name = parameterToParameterDeclarationName(parameterSymbol, parameterDeclaration, context);
	        const isOptional = parameterDeclaration && isOptionalParameter(parameterDeclaration) || getCheckFlags(parameterSymbol) & 16384 /* OptionalParameter */;
	        const questionToken = isOptional ? factory.createToken(58 /* QuestionToken */) : void 0;
	        const parameterNode = factory.createParameterDeclaration(
	          modifiers,
	          dotDotDotToken,
	          name,
	          questionToken,
	          parameterTypeNode,
	          /*initializer*/
	          void 0
	        );
	        context.approximateLength += symbolName(parameterSymbol).length + 3;
	        return parameterNode;
	      }
	      function parameterToParameterDeclarationName(parameterSymbol, parameterDeclaration, context) {
	        return parameterDeclaration ? parameterDeclaration.name ? parameterDeclaration.name.kind === 80 /* Identifier */ ? setEmitFlags(factory.cloneNode(parameterDeclaration.name), 16777216 /* NoAsciiEscaping */) : parameterDeclaration.name.kind === 166 /* QualifiedName */ ? setEmitFlags(factory.cloneNode(parameterDeclaration.name.right), 16777216 /* NoAsciiEscaping */) : cloneBindingName(parameterDeclaration.name) : symbolName(parameterSymbol) : symbolName(parameterSymbol);
	        function cloneBindingName(node) {
	          return elideInitializerAndSetEmitFlags(node);
	          function elideInitializerAndSetEmitFlags(node2) {
	            if (context.tracker.canTrackSymbol && isComputedPropertyName(node2) && isLateBindableName(node2)) {
	              trackComputedName(node2.expression, context.enclosingDeclaration, context);
	            }
	            let visited = visitEachChild(
	              node2,
	              elideInitializerAndSetEmitFlags,
	              /*context*/
	              void 0,
	              /*nodesVisitor*/
	              void 0,
	              elideInitializerAndSetEmitFlags
	            );
	            if (isBindingElement(visited)) {
	              visited = factory.updateBindingElement(
	                visited,
	                visited.dotDotDotToken,
	                visited.propertyName,
	                visited.name,
	                /*initializer*/
	                void 0
	              );
	            }
	            if (!nodeIsSynthesized(visited)) {
	              visited = factory.cloneNode(visited);
	            }
	            return setEmitFlags(visited, 1 /* SingleLine */ | 16777216 /* NoAsciiEscaping */);
	          }
	        }
	      }
	      function trackComputedName(accessExpression, enclosingDeclaration, context) {
	        if (!context.tracker.canTrackSymbol)
	          return;
	        const firstIdentifier = getFirstIdentifier(accessExpression);
	        const name = resolveName(
	          firstIdentifier,
	          firstIdentifier.escapedText,
	          111551 /* Value */ | 1048576 /* ExportValue */,
	          /*nameNotFoundMessage*/
	          void 0,
	          /*nameArg*/
	          void 0,
	          /*isUse*/
	          true
	        );
	        if (name) {
	          context.tracker.trackSymbol(name, enclosingDeclaration, 111551 /* Value */);
	        }
	      }
	      function lookupSymbolChain(symbol, context, meaning, yieldModuleSymbol) {
	        context.tracker.trackSymbol(symbol, context.enclosingDeclaration, meaning);
	        return lookupSymbolChainWorker(symbol, context, meaning, yieldModuleSymbol);
	      }
	      function lookupSymbolChainWorker(symbol, context, meaning, yieldModuleSymbol) {
	        let chain;
	        const isTypeParameter = symbol.flags & 262144 /* TypeParameter */;
	        if (!isTypeParameter && (context.enclosingDeclaration || context.flags & 64 /* UseFullyQualifiedType */) && !(context.flags & 134217728 /* DoNotIncludeSymbolChain */)) {
	          chain = Debug.checkDefined(getSymbolChain(
	            symbol,
	            meaning,
	            /*endOfChain*/
	            true
	          ));
	          Debug.assert(chain && chain.length > 0);
	        } else {
	          chain = [symbol];
	        }
	        return chain;
	        function getSymbolChain(symbol2, meaning2, endOfChain) {
	          let accessibleSymbolChain = getAccessibleSymbolChain(symbol2, context.enclosingDeclaration, meaning2, !!(context.flags & 128 /* UseOnlyExternalAliasing */));
	          let parentSpecifiers;
	          if (!accessibleSymbolChain || needsQualification(accessibleSymbolChain[0], context.enclosingDeclaration, accessibleSymbolChain.length === 1 ? meaning2 : getQualifiedLeftMeaning(meaning2))) {
	            const parents = getContainersOfSymbol(accessibleSymbolChain ? accessibleSymbolChain[0] : symbol2, context.enclosingDeclaration, meaning2);
	            if (length(parents)) {
	              parentSpecifiers = parents.map(
	                (symbol3) => some(symbol3.declarations, hasNonGlobalAugmentationExternalModuleSymbol) ? getSpecifierForModuleSymbol(symbol3, context) : void 0
	              );
	              const indices = parents.map((_, i) => i);
	              indices.sort(sortByBestName);
	              const sortedParents = indices.map((i) => parents[i]);
	              for (const parent2 of sortedParents) {
	                const parentChain = getSymbolChain(
	                  parent2,
	                  getQualifiedLeftMeaning(meaning2),
	                  /*endOfChain*/
	                  false
	                );
	                if (parentChain) {
	                  if (parent2.exports && parent2.exports.get("export=" /* ExportEquals */) && getSymbolIfSameReference(parent2.exports.get("export=" /* ExportEquals */), symbol2)) {
	                    accessibleSymbolChain = parentChain;
	                    break;
	                  }
	                  accessibleSymbolChain = parentChain.concat(accessibleSymbolChain || [getAliasForSymbolInContainer(parent2, symbol2) || symbol2]);
	                  break;
	                }
	              }
	            }
	          }
	          if (accessibleSymbolChain) {
	            return accessibleSymbolChain;
	          }
	          if (
	            // If this is the last part of outputting the symbol, always output. The cases apply only to parent symbols.
	            endOfChain || // If a parent symbol is an anonymous type, don't write it.
	            !(symbol2.flags & (2048 /* TypeLiteral */ | 4096 /* ObjectLiteral */))
	          ) {
	            if (!endOfChain && !yieldModuleSymbol && !!forEach(symbol2.declarations, hasNonGlobalAugmentationExternalModuleSymbol)) {
	              return;
	            }
	            return [symbol2];
	          }
	          function sortByBestName(a, b) {
	            const specifierA = parentSpecifiers[a];
	            const specifierB = parentSpecifiers[b];
	            if (specifierA && specifierB) {
	              const isBRelative = pathIsRelative(specifierB);
	              if (pathIsRelative(specifierA) === isBRelative) {
	                return countPathComponents(specifierA) - countPathComponents(specifierB);
	              }
	              if (isBRelative) {
	                return -1;
	              }
	              return 1;
	            }
	            return 0;
	          }
	        }
	      }
	      function typeParametersToTypeParameterDeclarations(symbol, context) {
	        let typeParameterNodes;
	        const targetSymbol = getTargetSymbol(symbol);
	        if (targetSymbol.flags & (32 /* Class */ | 64 /* Interface */ | 524288 /* TypeAlias */)) {
	          typeParameterNodes = factory.createNodeArray(map(getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(symbol), (tp) => typeParameterToDeclaration(tp, context)));
	        }
	        return typeParameterNodes;
	      }
	      function lookupTypeParameterNodes(chain, index, context) {
	        var _a;
	        Debug.assert(chain && 0 <= index && index < chain.length);
	        const symbol = chain[index];
	        const symbolId = getSymbolId(symbol);
	        if ((_a = context.typeParameterSymbolList) == null ? void 0 : _a.has(symbolId)) {
	          return void 0;
	        }
	        (context.typeParameterSymbolList || (context.typeParameterSymbolList = /* @__PURE__ */ new Set())).add(symbolId);
	        let typeParameterNodes;
	        if (context.flags & 512 /* WriteTypeParametersInQualifiedName */ && index < chain.length - 1) {
	          const parentSymbol = symbol;
	          const nextSymbol = chain[index + 1];
	          if (getCheckFlags(nextSymbol) & 1 /* Instantiated */) {
	            const params = getTypeParametersOfClassOrInterface(
	              parentSymbol.flags & 2097152 /* Alias */ ? resolveAlias(parentSymbol) : parentSymbol
	            );
	            typeParameterNodes = mapToTypeNodes(map(params, (t) => getMappedType(t, nextSymbol.links.mapper)), context);
	          } else {
	            typeParameterNodes = typeParametersToTypeParameterDeclarations(symbol, context);
	          }
	        }
	        return typeParameterNodes;
	      }
	      function getTopmostIndexedAccessType(top) {
	        if (isIndexedAccessTypeNode(top.objectType)) {
	          return getTopmostIndexedAccessType(top.objectType);
	        }
	        return top;
	      }
	      function getSpecifierForModuleSymbol(symbol, context, overrideImportMode) {
	        let file = getDeclarationOfKind(symbol, 312 /* SourceFile */);
	        if (!file) {
	          const equivalentFileSymbol = firstDefined(symbol.declarations, (d) => getFileSymbolIfFileSymbolExportEqualsContainer(d, symbol));
	          if (equivalentFileSymbol) {
	            file = getDeclarationOfKind(equivalentFileSymbol, 312 /* SourceFile */);
	          }
	        }
	        if (file && file.moduleName !== void 0) {
	          return file.moduleName;
	        }
	        if (!file) {
	          if (context.tracker.trackReferencedAmbientModule) {
	            const ambientDecls = filter(symbol.declarations, isAmbientModule);
	            if (length(ambientDecls)) {
	              for (const decl of ambientDecls) {
	                context.tracker.trackReferencedAmbientModule(decl, symbol);
	              }
	            }
	          }
	          if (ambientModuleSymbolRegex.test(symbol.escapedName)) {
	            return symbol.escapedName.substring(1, symbol.escapedName.length - 1);
	          }
	        }
	        if (!context.enclosingDeclaration || !context.tracker.moduleResolverHost) {
	          if (ambientModuleSymbolRegex.test(symbol.escapedName)) {
	            return symbol.escapedName.substring(1, symbol.escapedName.length - 1);
	          }
	          return getSourceFileOfNode(getNonAugmentationDeclaration(symbol)).fileName;
	        }
	        const contextFile = getSourceFileOfNode(getOriginalNode(context.enclosingDeclaration));
	        const resolutionMode = overrideImportMode || (contextFile == null ? void 0 : contextFile.impliedNodeFormat);
	        const cacheKey = createModeAwareCacheKey(contextFile.path, resolutionMode);
	        const links = getSymbolLinks(symbol);
	        let specifier = links.specifierCache && links.specifierCache.get(cacheKey);
	        if (!specifier) {
	          const isBundle2 = !!outFile(compilerOptions);
	          const { moduleResolverHost } = context.tracker;
	          const specifierCompilerOptions = isBundle2 ? { ...compilerOptions, baseUrl: moduleResolverHost.getCommonSourceDirectory() } : compilerOptions;
	          specifier = first(getModuleSpecifiers(
	            symbol,
	            checker,
	            specifierCompilerOptions,
	            contextFile,
	            moduleResolverHost,
	            {
	              importModuleSpecifierPreference: isBundle2 ? "non-relative" : "project-relative",
	              importModuleSpecifierEnding: isBundle2 ? "minimal" : resolutionMode === 99 /* ESNext */ ? "js" : void 0
	            },
	            { overrideImportMode }
	          ));
	          links.specifierCache ?? (links.specifierCache = /* @__PURE__ */ new Map());
	          links.specifierCache.set(cacheKey, specifier);
	        }
	        return specifier;
	      }
	      function symbolToEntityNameNode(symbol) {
	        const identifier = factory.createIdentifier(unescapeLeadingUnderscores(symbol.escapedName));
	        return symbol.parent ? factory.createQualifiedName(symbolToEntityNameNode(symbol.parent), identifier) : identifier;
	      }
	      function symbolToTypeNode(symbol, context, meaning, overrideTypeArguments) {
	        const chain = lookupSymbolChain(symbol, context, meaning, !(context.flags & 16384 /* UseAliasDefinedOutsideCurrentScope */));
	        const isTypeOf = meaning === 111551 /* Value */;
	        if (some(chain[0].declarations, hasNonGlobalAugmentationExternalModuleSymbol)) {
	          const nonRootParts = chain.length > 1 ? createAccessFromSymbolChain(chain, chain.length - 1, 1) : void 0;
	          const typeParameterNodes = overrideTypeArguments || lookupTypeParameterNodes(chain, 0, context);
	          const contextFile = getSourceFileOfNode(getOriginalNode(context.enclosingDeclaration));
	          const targetFile = getSourceFileOfModule(chain[0]);
	          let specifier;
	          let attributes;
	          if (getEmitModuleResolutionKind(compilerOptions) === 3 /* Node16 */ || getEmitModuleResolutionKind(compilerOptions) === 99 /* NodeNext */) {
	            if ((targetFile == null ? void 0 : targetFile.impliedNodeFormat) === 99 /* ESNext */ && targetFile.impliedNodeFormat !== (contextFile == null ? void 0 : contextFile.impliedNodeFormat)) {
	              specifier = getSpecifierForModuleSymbol(chain[0], context, 99 /* ESNext */);
	              attributes = factory.createImportAttributes(
	                factory.createNodeArray([
	                  factory.createImportAttribute(
	                    factory.createStringLiteral("resolution-mode"),
	                    factory.createStringLiteral("import")
	                  )
	                ])
	              );
	            }
	          }
	          if (!specifier) {
	            specifier = getSpecifierForModuleSymbol(chain[0], context);
	          }
	          if (!(context.flags & 67108864 /* AllowNodeModulesRelativePaths */) && getEmitModuleResolutionKind(compilerOptions) !== 1 /* Classic */ && specifier.includes("/node_modules/")) {
	            const oldSpecifier = specifier;
	            if (getEmitModuleResolutionKind(compilerOptions) === 3 /* Node16 */ || getEmitModuleResolutionKind(compilerOptions) === 99 /* NodeNext */) {
	              const swappedMode = (contextFile == null ? void 0 : contextFile.impliedNodeFormat) === 99 /* ESNext */ ? 1 /* CommonJS */ : 99 /* ESNext */;
	              specifier = getSpecifierForModuleSymbol(chain[0], context, swappedMode);
	              if (specifier.includes("/node_modules/")) {
	                specifier = oldSpecifier;
	              } else {
	                attributes = factory.createImportAttributes(
	                  factory.createNodeArray([
	                    factory.createImportAttribute(
	                      factory.createStringLiteral("resolution-mode"),
	                      factory.createStringLiteral(swappedMode === 99 /* ESNext */ ? "import" : "require")
	                    )
	                  ])
	                );
	              }
	            }
	            if (!attributes) {
	              context.encounteredError = true;
	              if (context.tracker.reportLikelyUnsafeImportRequiredError) {
	                context.tracker.reportLikelyUnsafeImportRequiredError(oldSpecifier);
	              }
	            }
	          }
	          const lit = factory.createLiteralTypeNode(factory.createStringLiteral(specifier));
	          if (context.tracker.trackExternalModuleSymbolOfImportTypeNode)
	            context.tracker.trackExternalModuleSymbolOfImportTypeNode(chain[0]);
	          context.approximateLength += specifier.length + 10;
	          if (!nonRootParts || isEntityName(nonRootParts)) {
	            if (nonRootParts) {
	              const lastId = isIdentifier(nonRootParts) ? nonRootParts : nonRootParts.right;
	              setIdentifierTypeArguments(
	                lastId,
	                /*typeArguments*/
	                void 0
	              );
	            }
	            return factory.createImportTypeNode(lit, attributes, nonRootParts, typeParameterNodes, isTypeOf);
	          } else {
	            const splitNode = getTopmostIndexedAccessType(nonRootParts);
	            const qualifier = splitNode.objectType.typeName;
	            return factory.createIndexedAccessTypeNode(factory.createImportTypeNode(lit, attributes, qualifier, typeParameterNodes, isTypeOf), splitNode.indexType);
	          }
	        }
	        const entityName = createAccessFromSymbolChain(chain, chain.length - 1, 0);
	        if (isIndexedAccessTypeNode(entityName)) {
	          return entityName;
	        }
	        if (isTypeOf) {
	          return factory.createTypeQueryNode(entityName);
	        } else {
	          const lastId = isIdentifier(entityName) ? entityName : entityName.right;
	          const lastTypeArgs = getIdentifierTypeArguments(lastId);
	          setIdentifierTypeArguments(
	            lastId,
	            /*typeArguments*/
	            void 0
	          );
	          return factory.createTypeReferenceNode(entityName, lastTypeArgs);
	        }
	        function createAccessFromSymbolChain(chain2, index, stopper) {
	          const typeParameterNodes = index === chain2.length - 1 ? overrideTypeArguments : lookupTypeParameterNodes(chain2, index, context);
	          const symbol2 = chain2[index];
	          const parent2 = chain2[index - 1];
	          let symbolName2;
	          if (index === 0) {
	            context.flags |= 16777216 /* InInitialEntityName */;
	            symbolName2 = getNameOfSymbolAsWritten(symbol2, context);
	            context.approximateLength += (symbolName2 ? symbolName2.length : 0) + 1;
	            context.flags ^= 16777216 /* InInitialEntityName */;
	          } else {
	            if (parent2 && getExportsOfSymbol(parent2)) {
	              const exports = getExportsOfSymbol(parent2);
	              forEachEntry(exports, (ex, name) => {
	                if (getSymbolIfSameReference(ex, symbol2) && !isLateBoundName(name) && name !== "export=" /* ExportEquals */) {
	                  symbolName2 = unescapeLeadingUnderscores(name);
	                  return true;
	                }
	              });
	            }
	          }
	          if (symbolName2 === void 0) {
	            const name = firstDefined(symbol2.declarations, getNameOfDeclaration);
	            if (name && isComputedPropertyName(name) && isEntityName(name.expression)) {
	              const LHS = createAccessFromSymbolChain(chain2, index - 1, stopper);
	              if (isEntityName(LHS)) {
	                return factory.createIndexedAccessTypeNode(factory.createParenthesizedType(factory.createTypeQueryNode(LHS)), factory.createTypeQueryNode(name.expression));
	              }
	              return LHS;
	            }
	            symbolName2 = getNameOfSymbolAsWritten(symbol2, context);
	          }
	          context.approximateLength += symbolName2.length + 1;
	          if (!(context.flags & 16 /* ForbidIndexedAccessSymbolReferences */) && parent2 && getMembersOfSymbol(parent2) && getMembersOfSymbol(parent2).get(symbol2.escapedName) && getSymbolIfSameReference(getMembersOfSymbol(parent2).get(symbol2.escapedName), symbol2)) {
	            const LHS = createAccessFromSymbolChain(chain2, index - 1, stopper);
	            if (isIndexedAccessTypeNode(LHS)) {
	              return factory.createIndexedAccessTypeNode(LHS, factory.createLiteralTypeNode(factory.createStringLiteral(symbolName2)));
	            } else {
	              return factory.createIndexedAccessTypeNode(factory.createTypeReferenceNode(LHS, typeParameterNodes), factory.createLiteralTypeNode(factory.createStringLiteral(symbolName2)));
	            }
	          }
	          const identifier = setEmitFlags(factory.createIdentifier(symbolName2), 16777216 /* NoAsciiEscaping */);
	          if (typeParameterNodes)
	            setIdentifierTypeArguments(identifier, factory.createNodeArray(typeParameterNodes));
	          identifier.symbol = symbol2;
	          if (index > stopper) {
	            const LHS = createAccessFromSymbolChain(chain2, index - 1, stopper);
	            if (!isEntityName(LHS)) {
	              return Debug.fail("Impossible construct - an export of an indexed access cannot be reachable");
	            }
	            return factory.createQualifiedName(LHS, identifier);
	          }
	          return identifier;
	        }
	      }
	      function typeParameterShadowsOtherTypeParameterInScope(escapedName, context, type) {
	        const result = resolveName(
	          context.enclosingDeclaration,
	          escapedName,
	          788968 /* Type */,
	          /*nameNotFoundMessage*/
	          void 0,
	          escapedName,
	          /*isUse*/
	          false
	        );
	        if (result && result.flags & 262144 /* TypeParameter */) {
	          return result !== type.symbol;
	        }
	        return false;
	      }
	      function typeParameterToName(type, context) {
	        var _a, _b;
	        if (context.flags & 4 /* GenerateNamesForShadowedTypeParams */ && context.typeParameterNames) {
	          const cached = context.typeParameterNames.get(getTypeId(type));
	          if (cached) {
	            return cached;
	          }
	        }
	        let result = symbolToName(
	          type.symbol,
	          context,
	          788968 /* Type */,
	          /*expectsIdentifier*/
	          true
	        );
	        if (!(result.kind & 80 /* Identifier */)) {
	          return factory.createIdentifier("(Missing type parameter)");
	        }
	        if (context.flags & 4 /* GenerateNamesForShadowedTypeParams */) {
	          const rawtext = result.escapedText;
	          let i = ((_a = context.typeParameterNamesByTextNextNameCount) == null ? void 0 : _a.get(rawtext)) || 0;
	          let text = rawtext;
	          while (((_b = context.typeParameterNamesByText) == null ? void 0 : _b.has(text)) || typeParameterShadowsOtherTypeParameterInScope(text, context, type)) {
	            i++;
	            text = `${rawtext}_${i}`;
	          }
	          if (text !== rawtext) {
	            const typeArguments = getIdentifierTypeArguments(result);
	            result = factory.createIdentifier(text);
	            setIdentifierTypeArguments(result, typeArguments);
	          }
	          (context.typeParameterNamesByTextNextNameCount || (context.typeParameterNamesByTextNextNameCount = /* @__PURE__ */ new Map())).set(rawtext, i);
	          (context.typeParameterNames || (context.typeParameterNames = /* @__PURE__ */ new Map())).set(getTypeId(type), result);
	          (context.typeParameterNamesByText || (context.typeParameterNamesByText = /* @__PURE__ */ new Set())).add(text);
	        }
	        return result;
	      }
	      function symbolToName(symbol, context, meaning, expectsIdentifier) {
	        const chain = lookupSymbolChain(symbol, context, meaning);
	        if (expectsIdentifier && chain.length !== 1 && !context.encounteredError && !(context.flags & 65536 /* AllowQualifiedNameInPlaceOfIdentifier */)) {
	          context.encounteredError = true;
	        }
	        return createEntityNameFromSymbolChain(chain, chain.length - 1);
	        function createEntityNameFromSymbolChain(chain2, index) {
	          const typeParameterNodes = lookupTypeParameterNodes(chain2, index, context);
	          const symbol2 = chain2[index];
	          if (index === 0) {
	            context.flags |= 16777216 /* InInitialEntityName */;
	          }
	          const symbolName2 = getNameOfSymbolAsWritten(symbol2, context);
	          if (index === 0) {
	            context.flags ^= 16777216 /* InInitialEntityName */;
	          }
	          const identifier = setEmitFlags(factory.createIdentifier(symbolName2), 16777216 /* NoAsciiEscaping */);
	          if (typeParameterNodes)
	            setIdentifierTypeArguments(identifier, factory.createNodeArray(typeParameterNodes));
	          identifier.symbol = symbol2;
	          return index > 0 ? factory.createQualifiedName(createEntityNameFromSymbolChain(chain2, index - 1), identifier) : identifier;
	        }
	      }
	      function symbolToExpression(symbol, context, meaning) {
	        const chain = lookupSymbolChain(symbol, context, meaning);
	        return createExpressionFromSymbolChain(chain, chain.length - 1);
	        function createExpressionFromSymbolChain(chain2, index) {
	          const typeParameterNodes = lookupTypeParameterNodes(chain2, index, context);
	          const symbol2 = chain2[index];
	          if (index === 0) {
	            context.flags |= 16777216 /* InInitialEntityName */;
	          }
	          let symbolName2 = getNameOfSymbolAsWritten(symbol2, context);
	          if (index === 0) {
	            context.flags ^= 16777216 /* InInitialEntityName */;
	          }
	          let firstChar = symbolName2.charCodeAt(0);
	          if (isSingleOrDoubleQuote(firstChar) && some(symbol2.declarations, hasNonGlobalAugmentationExternalModuleSymbol)) {
	            return factory.createStringLiteral(getSpecifierForModuleSymbol(symbol2, context));
	          }
	          if (index === 0 || canUsePropertyAccess(symbolName2, languageVersion)) {
	            const identifier = setEmitFlags(factory.createIdentifier(symbolName2), 16777216 /* NoAsciiEscaping */);
	            if (typeParameterNodes)
	              setIdentifierTypeArguments(identifier, factory.createNodeArray(typeParameterNodes));
	            identifier.symbol = symbol2;
	            return index > 0 ? factory.createPropertyAccessExpression(createExpressionFromSymbolChain(chain2, index - 1), identifier) : identifier;
	          } else {
	            if (firstChar === 91 /* openBracket */) {
	              symbolName2 = symbolName2.substring(1, symbolName2.length - 1);
	              firstChar = symbolName2.charCodeAt(0);
	            }
	            let expression;
	            if (isSingleOrDoubleQuote(firstChar) && !(symbol2.flags & 8 /* EnumMember */)) {
	              expression = factory.createStringLiteral(stripQuotes(symbolName2).replace(/\\./g, (s) => s.substring(1)), firstChar === 39 /* singleQuote */);
	            } else if ("" + +symbolName2 === symbolName2) {
	              expression = factory.createNumericLiteral(+symbolName2);
	            }
	            if (!expression) {
	              const identifier = setEmitFlags(factory.createIdentifier(symbolName2), 16777216 /* NoAsciiEscaping */);
	              if (typeParameterNodes)
	                setIdentifierTypeArguments(identifier, factory.createNodeArray(typeParameterNodes));
	              identifier.symbol = symbol2;
	              expression = identifier;
	            }
	            return factory.createElementAccessExpression(createExpressionFromSymbolChain(chain2, index - 1), expression);
	          }
	        }
	      }
	      function isStringNamed(d) {
	        const name = getNameOfDeclaration(d);
	        if (!name) {
	          return false;
	        }
	        if (isComputedPropertyName(name)) {
	          const type = checkExpression(name.expression);
	          return !!(type.flags & 402653316 /* StringLike */);
	        }
	        if (isElementAccessExpression(name)) {
	          const type = checkExpression(name.argumentExpression);
	          return !!(type.flags & 402653316 /* StringLike */);
	        }
	        return isStringLiteral(name);
	      }
	      function isSingleQuotedStringNamed(d) {
	        const name = getNameOfDeclaration(d);
	        return !!(name && isStringLiteral(name) && (name.singleQuote || !nodeIsSynthesized(name) && startsWith(getTextOfNode(
	          name,
	          /*includeTrivia*/
	          false
	        ), "'")));
	      }
	      function getPropertyNameNodeForSymbol(symbol, context) {
	        const stringNamed = !!length(symbol.declarations) && every(symbol.declarations, isStringNamed);
	        const singleQuote = !!length(symbol.declarations) && every(symbol.declarations, isSingleQuotedStringNamed);
	        const isMethod = !!(symbol.flags & 8192 /* Method */);
	        const fromNameType = getPropertyNameNodeForSymbolFromNameType(symbol, context, singleQuote, stringNamed, isMethod);
	        if (fromNameType) {
	          return fromNameType;
	        }
	        const rawName = unescapeLeadingUnderscores(symbol.escapedName);
	        return createPropertyNameNodeForIdentifierOrLiteral(rawName, getEmitScriptTarget(compilerOptions), singleQuote, stringNamed, isMethod);
	      }
	      function getPropertyNameNodeForSymbolFromNameType(symbol, context, singleQuote, stringNamed, isMethod) {
	        const nameType = getSymbolLinks(symbol).nameType;
	        if (nameType) {
	          if (nameType.flags & 384 /* StringOrNumberLiteral */) {
	            const name = "" + nameType.value;
	            if (!isIdentifierText(name, getEmitScriptTarget(compilerOptions)) && (stringNamed || !isNumericLiteralName(name))) {
	              return factory.createStringLiteral(name, !!singleQuote);
	            }
	            if (isNumericLiteralName(name) && startsWith(name, "-")) {
	              return factory.createComputedPropertyName(factory.createPrefixUnaryExpression(41 /* MinusToken */, factory.createNumericLiteral(-name)));
	            }
	            return createPropertyNameNodeForIdentifierOrLiteral(name, getEmitScriptTarget(compilerOptions), singleQuote, stringNamed, isMethod);
	          }
	          if (nameType.flags & 8192 /* UniqueESSymbol */) {
	            return factory.createComputedPropertyName(symbolToExpression(nameType.symbol, context, 111551 /* Value */));
	          }
	        }
	      }
	      function cloneNodeBuilderContext(context) {
	        const initial = { ...context };
	        if (initial.typeParameterNames) {
	          initial.typeParameterNames = new Map(initial.typeParameterNames);
	        }
	        if (initial.typeParameterNamesByText) {
	          initial.typeParameterNamesByText = new Set(initial.typeParameterNamesByText);
	        }
	        if (initial.typeParameterSymbolList) {
	          initial.typeParameterSymbolList = new Set(initial.typeParameterSymbolList);
	        }
	        initial.tracker = new SymbolTrackerImpl(initial, initial.tracker.inner, initial.tracker.moduleResolverHost);
	        return initial;
	      }
	      function getDeclarationWithTypeAnnotation(symbol, enclosingDeclaration) {
	        return symbol.declarations && find(symbol.declarations, (s) => !!getEffectiveTypeAnnotationNode(s) && (!enclosingDeclaration || !!findAncestor(s, (n) => n === enclosingDeclaration)));
	      }
	      function existingTypeNodeIsNotReferenceOrIsReferenceWithCompatibleTypeArgumentCount(existing, type) {
	        return !(getObjectFlags(type) & 4 /* Reference */) || !isTypeReferenceNode(existing) || length(existing.typeArguments) >= getMinTypeArgumentCount(type.target.typeParameters);
	      }
	      function getEnclosingDeclarationIgnoringFakeScope(enclosingDeclaration) {
	        while (getNodeLinks(enclosingDeclaration).fakeScopeForSignatureDeclaration) {
	          enclosingDeclaration = enclosingDeclaration.parent;
	        }
	        return enclosingDeclaration;
	      }
	      function serializeTypeForDeclaration(context, type, symbol, enclosingDeclaration, includePrivateSymbol, bundled) {
	        if (!isErrorType(type) && enclosingDeclaration) {
	          const declWithExistingAnnotation = getDeclarationWithTypeAnnotation(symbol, getEnclosingDeclarationIgnoringFakeScope(enclosingDeclaration));
	          if (declWithExistingAnnotation && !isFunctionLikeDeclaration(declWithExistingAnnotation) && !isGetAccessorDeclaration(declWithExistingAnnotation)) {
	            const existing = getEffectiveTypeAnnotationNode(declWithExistingAnnotation);
	            if (typeNodeIsEquivalentToType(existing, declWithExistingAnnotation, type) && existingTypeNodeIsNotReferenceOrIsReferenceWithCompatibleTypeArgumentCount(existing, type)) {
	              const result2 = serializeExistingTypeNode(context, existing, includePrivateSymbol, bundled);
	              if (result2) {
	                return result2;
	              }
	            }
	          }
	        }
	        const oldFlags = context.flags;
	        if (type.flags & 8192 /* UniqueESSymbol */ && type.symbol === symbol && (!context.enclosingDeclaration || some(symbol.declarations, (d) => getSourceFileOfNode(d) === getSourceFileOfNode(context.enclosingDeclaration)))) {
	          context.flags |= 1048576 /* AllowUniqueESSymbolType */;
	        }
	        const result = typeToTypeNodeHelper(type, context);
	        context.flags = oldFlags;
	        return result;
	      }
	      function typeNodeIsEquivalentToType(typeNode, annotatedDeclaration, type) {
	        const typeFromTypeNode = getTypeFromTypeNode(typeNode);
	        if (typeFromTypeNode === type) {
	          return true;
	        }
	        if (isParameter(annotatedDeclaration) && annotatedDeclaration.questionToken) {
	          return getTypeWithFacts(type, 524288 /* NEUndefined */) === typeFromTypeNode;
	        }
	        return false;
	      }
	      function serializeReturnTypeForSignature(context, type, signature, includePrivateSymbol, bundled) {
	        if (!isErrorType(type) && context.enclosingDeclaration) {
	          const annotation = signature.declaration && getEffectiveReturnTypeNode(signature.declaration);
	          const enclosingDeclarationIgnoringFakeScope = getEnclosingDeclarationIgnoringFakeScope(context.enclosingDeclaration);
	          if (!!findAncestor(annotation, (n) => n === enclosingDeclarationIgnoringFakeScope) && annotation) {
	            const annotated = getTypeFromTypeNode(annotation);
	            const thisInstantiated = annotated.flags & 262144 /* TypeParameter */ && annotated.isThisType ? instantiateType(annotated, signature.mapper) : annotated;
	            if (thisInstantiated === type && existingTypeNodeIsNotReferenceOrIsReferenceWithCompatibleTypeArgumentCount(annotation, type)) {
	              const result = serializeExistingTypeNode(context, annotation, includePrivateSymbol, bundled);
	              if (result) {
	                return result;
	              }
	            }
	          }
	        }
	        return typeToTypeNodeHelper(type, context);
	      }
	      function trackExistingEntityName(node, context, includePrivateSymbol) {
	        let introducesError = false;
	        const leftmost = getFirstIdentifier(node);
	        if (isInJSFile(node) && (isExportsIdentifier(leftmost) || isModuleExportsAccessExpression(leftmost.parent) || isQualifiedName(leftmost.parent) && isModuleIdentifier(leftmost.parent.left) && isExportsIdentifier(leftmost.parent.right))) {
	          introducesError = true;
	          return { introducesError, node };
	        }
	        const meaning = getMeaningOfEntityNameReference(node);
	        const sym = resolveEntityName(
	          leftmost,
	          meaning,
	          /*ignoreErrors*/
	          true,
	          /*dontResolveAlias*/
	          true
	        );
	        if (sym) {
	          if (isSymbolAccessible(
	            sym,
	            context.enclosingDeclaration,
	            meaning,
	            /*shouldComputeAliasesToMakeVisible*/
	            false
	          ).accessibility !== 0 /* Accessible */) {
	            introducesError = true;
	          } else {
	            context.tracker.trackSymbol(sym, context.enclosingDeclaration, meaning);
	            includePrivateSymbol == null ? void 0 : includePrivateSymbol(sym);
	          }
	          if (isIdentifier(node)) {
	            const type = getDeclaredTypeOfSymbol(sym);
	            const name = sym.flags & 262144 /* TypeParameter */ ? typeParameterToName(type, context) : factory.cloneNode(node);
	            name.symbol = sym;
	            return { introducesError, node: setEmitFlags(setOriginalNode(name, node), 16777216 /* NoAsciiEscaping */) };
	          }
	        }
	        return { introducesError, node };
	      }
	      function serializeExistingTypeNode(context, existing, includePrivateSymbol, bundled) {
	        if (cancellationToken && cancellationToken.throwIfCancellationRequested) {
	          cancellationToken.throwIfCancellationRequested();
	        }
	        let hadError = false;
	        const file = getSourceFileOfNode(existing);
	        const transformed = visitNode(existing, visitExistingNodeTreeSymbols, isTypeNode);
	        if (hadError) {
	          return void 0;
	        }
	        return transformed === existing ? setTextRange(factory.cloneNode(existing), existing) : transformed;
	        function visitExistingNodeTreeSymbols(node) {
	          if (isJSDocAllType(node) || node.kind === 326 /* JSDocNamepathType */) {
	            return factory.createKeywordTypeNode(133 /* AnyKeyword */);
	          }
	          if (isJSDocUnknownType(node)) {
	            return factory.createKeywordTypeNode(159 /* UnknownKeyword */);
	          }
	          if (isJSDocNullableType(node)) {
	            return factory.createUnionTypeNode([visitNode(node.type, visitExistingNodeTreeSymbols, isTypeNode), factory.createLiteralTypeNode(factory.createNull())]);
	          }
	          if (isJSDocOptionalType(node)) {
	            return factory.createUnionTypeNode([visitNode(node.type, visitExistingNodeTreeSymbols, isTypeNode), factory.createKeywordTypeNode(157 /* UndefinedKeyword */)]);
	          }
	          if (isJSDocNonNullableType(node)) {
	            return visitNode(node.type, visitExistingNodeTreeSymbols);
	          }
	          if (isJSDocVariadicType(node)) {
	            return factory.createArrayTypeNode(visitNode(node.type, visitExistingNodeTreeSymbols, isTypeNode));
	          }
	          if (isJSDocTypeLiteral(node)) {
	            return factory.createTypeLiteralNode(map(node.jsDocPropertyTags, (t) => {
	              const name = isIdentifier(t.name) ? t.name : t.name.right;
	              const typeViaParent = getTypeOfPropertyOfType(getTypeFromTypeNode(node), name.escapedText);
	              const overrideTypeNode = typeViaParent && t.typeExpression && getTypeFromTypeNode(t.typeExpression.type) !== typeViaParent ? typeToTypeNodeHelper(typeViaParent, context) : void 0;
	              return factory.createPropertySignature(
	                /*modifiers*/
	                void 0,
	                name,
	                t.isBracketed || t.typeExpression && isJSDocOptionalType(t.typeExpression.type) ? factory.createToken(58 /* QuestionToken */) : void 0,
	                overrideTypeNode || t.typeExpression && visitNode(t.typeExpression.type, visitExistingNodeTreeSymbols, isTypeNode) || factory.createKeywordTypeNode(133 /* AnyKeyword */)
	              );
	            }));
	          }
	          if (isTypeReferenceNode(node) && isIdentifier(node.typeName) && node.typeName.escapedText === "") {
	            return setOriginalNode(factory.createKeywordTypeNode(133 /* AnyKeyword */), node);
	          }
	          if ((isExpressionWithTypeArguments(node) || isTypeReferenceNode(node)) && isJSDocIndexSignature(node)) {
	            return factory.createTypeLiteralNode([factory.createIndexSignature(
	              /*modifiers*/
	              void 0,
	              [factory.createParameterDeclaration(
	                /*modifiers*/
	                void 0,
	                /*dotDotDotToken*/
	                void 0,
	                "x",
	                /*questionToken*/
	                void 0,
	                visitNode(node.typeArguments[0], visitExistingNodeTreeSymbols, isTypeNode)
	              )],
	              visitNode(node.typeArguments[1], visitExistingNodeTreeSymbols, isTypeNode)
	            )]);
	          }
	          if (isJSDocFunctionType(node)) {
	            if (isJSDocConstructSignature(node)) {
	              let newTypeNode;
	              return factory.createConstructorTypeNode(
	                /*modifiers*/
	                void 0,
	                visitNodes2(node.typeParameters, visitExistingNodeTreeSymbols, isTypeParameterDeclaration),
	                mapDefined(node.parameters, (p, i) => p.name && isIdentifier(p.name) && p.name.escapedText === "new" ? (newTypeNode = p.type, void 0) : factory.createParameterDeclaration(
	                  /*modifiers*/
	                  void 0,
	                  getEffectiveDotDotDotForParameter(p),
	                  getNameForJSDocFunctionParameter(p, i),
	                  p.questionToken,
	                  visitNode(p.type, visitExistingNodeTreeSymbols, isTypeNode),
	                  /*initializer*/
	                  void 0
	                )),
	                visitNode(newTypeNode || node.type, visitExistingNodeTreeSymbols, isTypeNode) || factory.createKeywordTypeNode(133 /* AnyKeyword */)
	              );
	            } else {
	              return factory.createFunctionTypeNode(
	                visitNodes2(node.typeParameters, visitExistingNodeTreeSymbols, isTypeParameterDeclaration),
	                map(node.parameters, (p, i) => factory.createParameterDeclaration(
	                  /*modifiers*/
	                  void 0,
	                  getEffectiveDotDotDotForParameter(p),
	                  getNameForJSDocFunctionParameter(p, i),
	                  p.questionToken,
	                  visitNode(p.type, visitExistingNodeTreeSymbols, isTypeNode),
	                  /*initializer*/
	                  void 0
	                )),
	                visitNode(node.type, visitExistingNodeTreeSymbols, isTypeNode) || factory.createKeywordTypeNode(133 /* AnyKeyword */)
	              );
	            }
	          }
	          if (isTypeReferenceNode(node) && isInJSDoc(node) && (!existingTypeNodeIsNotReferenceOrIsReferenceWithCompatibleTypeArgumentCount(node, getTypeFromTypeNode(node)) || getIntendedTypeFromJSDocTypeReference(node) || unknownSymbol === resolveTypeReferenceName(
	            node,
	            788968 /* Type */,
	            /*ignoreErrors*/
	            true
	          ))) {
	            return setOriginalNode(typeToTypeNodeHelper(getTypeFromTypeNode(node), context), node);
	          }
	          if (isLiteralImportTypeNode(node)) {
	            const nodeSymbol = getNodeLinks(node).resolvedSymbol;
	            if (isInJSDoc(node) && nodeSymbol && // The import type resolved using jsdoc fallback logic
	            (!node.isTypeOf && !(nodeSymbol.flags & 788968 /* Type */) || // The import type had type arguments autofilled by js fallback logic
	            !(length(node.typeArguments) >= getMinTypeArgumentCount(getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(nodeSymbol))))) {
	              return setOriginalNode(typeToTypeNodeHelper(getTypeFromTypeNode(node), context), node);
	            }
	            return factory.updateImportTypeNode(
	              node,
	              factory.updateLiteralTypeNode(node.argument, rewriteModuleSpecifier(node, node.argument.literal)),
	              node.attributes,
	              node.qualifier,
	              visitNodes2(node.typeArguments, visitExistingNodeTreeSymbols, isTypeNode),
	              node.isTypeOf
	            );
	          }
	          if (isEntityName(node) || isEntityNameExpression(node)) {
	            const { introducesError, node: result } = trackExistingEntityName(node, context, includePrivateSymbol);
	            hadError = hadError || introducesError;
	            if (result !== node) {
	              return result;
	            }
	          }
	          if (file && isTupleTypeNode(node) && getLineAndCharacterOfPosition(file, node.pos).line === getLineAndCharacterOfPosition(file, node.end).line) {
	            setEmitFlags(node, 1 /* SingleLine */);
	          }
	          return visitEachChild(
	            node,
	            visitExistingNodeTreeSymbols,
	            /*context*/
	            void 0
	          );
	          function getEffectiveDotDotDotForParameter(p) {
	            return p.dotDotDotToken || (p.type && isJSDocVariadicType(p.type) ? factory.createToken(26 /* DotDotDotToken */) : void 0);
	          }
	          function getNameForJSDocFunctionParameter(p, index) {
	            return p.name && isIdentifier(p.name) && p.name.escapedText === "this" ? "this" : getEffectiveDotDotDotForParameter(p) ? `args` : `arg${index}`;
	          }
	          function rewriteModuleSpecifier(parent2, lit) {
	            if (bundled) {
	              if (context.tracker && context.tracker.moduleResolverHost) {
	                const targetFile = getExternalModuleFileFromDeclaration(parent2);
	                if (targetFile) {
	                  const getCanonicalFileName = createGetCanonicalFileName(!!host.useCaseSensitiveFileNames);
	                  const resolverHost = {
	                    getCanonicalFileName,
	                    getCurrentDirectory: () => context.tracker.moduleResolverHost.getCurrentDirectory(),
	                    getCommonSourceDirectory: () => context.tracker.moduleResolverHost.getCommonSourceDirectory()
	                  };
	                  const newName = getResolvedExternalModuleName(resolverHost, targetFile);
	                  return factory.createStringLiteral(newName);
	                }
	              }
	            } else {
	              if (context.tracker && context.tracker.trackExternalModuleSymbolOfImportTypeNode) {
	                const moduleSym = resolveExternalModuleNameWorker(
	                  lit,
	                  lit,
	                  /*moduleNotFoundError*/
	                  void 0
	                );
	                if (moduleSym) {
	                  context.tracker.trackExternalModuleSymbolOfImportTypeNode(moduleSym);
	                }
	              }
	            }
	            return lit;
	          }
	        }
	      }
	      function symbolTableToDeclarationStatements(symbolTable, context, bundled) {
	        var _a;
	        const serializePropertySymbolForClass = makeSerializePropertySymbol(
	          factory.createPropertyDeclaration,
	          174 /* MethodDeclaration */,
	          /*useAccessors*/
	          true
	        );
	        const serializePropertySymbolForInterfaceWorker = makeSerializePropertySymbol(
	          (mods, name, question, type) => factory.createPropertySignature(mods, name, question, type),
	          173 /* MethodSignature */,
	          /*useAccessors*/
	          false
	        );
	        const enclosingDeclaration = context.enclosingDeclaration;
	        let results = [];
	        const visitedSymbols = /* @__PURE__ */ new Set();
	        const deferredPrivatesStack = [];
	        const oldcontext = context;
	        context = {
	          ...oldcontext,
	          usedSymbolNames: new Set(oldcontext.usedSymbolNames),
	          remappedSymbolNames: /* @__PURE__ */ new Map(),
	          remappedSymbolReferences: new Map((_a = oldcontext.remappedSymbolReferences) == null ? void 0 : _a.entries()),
	          tracker: void 0
	        };
	        const tracker = {
	          ...oldcontext.tracker.inner,
	          trackSymbol: (sym, decl, meaning) => {
	            var _a2, _b;
	            if ((_a2 = context.remappedSymbolNames) == null ? void 0 : _a2.has(getSymbolId(sym)))
	              return false;
	            const accessibleResult = isSymbolAccessible(
	              sym,
	              decl,
	              meaning,
	              /*shouldComputeAliasesToMakeVisible*/
	              false
	            );
	            if (accessibleResult.accessibility === 0 /* Accessible */) {
	              const chain = lookupSymbolChainWorker(sym, context, meaning);
	              if (!(sym.flags & 4 /* Property */)) {
	                const root = chain[0];
	                const contextFile = getSourceFileOfNode(oldcontext.enclosingDeclaration);
	                if (some(root.declarations, (d) => getSourceFileOfNode(d) === contextFile)) {
	                  includePrivateSymbol(root);
	                }
	              }
	            } else if ((_b = oldcontext.tracker.inner) == null ? void 0 : _b.trackSymbol) {
	              return oldcontext.tracker.inner.trackSymbol(sym, decl, meaning);
	            }
	            return false;
	          }
	        };
	        context.tracker = new SymbolTrackerImpl(context, tracker, oldcontext.tracker.moduleResolverHost);
	        forEachEntry(symbolTable, (symbol, name) => {
	          const baseName = unescapeLeadingUnderscores(name);
	          void getInternalSymbolName(symbol, baseName);
	        });
	        let addingDeclare = !bundled;
	        const exportEquals = symbolTable.get("export=" /* ExportEquals */);
	        if (exportEquals && symbolTable.size > 1 && exportEquals.flags & (2097152 /* Alias */ | 1536 /* Module */)) {
	          symbolTable = createSymbolTable();
	          symbolTable.set("export=" /* ExportEquals */, exportEquals);
	        }
	        visitSymbolTable(symbolTable);
	        return mergeRedundantStatements(results);
	        function isIdentifierAndNotUndefined(node) {
	          return !!node && node.kind === 80 /* Identifier */;
	        }
	        function getNamesOfDeclaration(statement) {
	          if (isVariableStatement(statement)) {
	            return filter(map(statement.declarationList.declarations, getNameOfDeclaration), isIdentifierAndNotUndefined);
	          }
	          return filter([getNameOfDeclaration(statement)], isIdentifierAndNotUndefined);
	        }
	        function flattenExportAssignedNamespace(statements) {
	          const exportAssignment = find(statements, isExportAssignment);
	          const nsIndex = findIndex(statements, isModuleDeclaration);
	          let ns = nsIndex !== -1 ? statements[nsIndex] : void 0;
	          if (ns && exportAssignment && exportAssignment.isExportEquals && isIdentifier(exportAssignment.expression) && isIdentifier(ns.name) && idText(ns.name) === idText(exportAssignment.expression) && ns.body && isModuleBlock(ns.body)) {
	            const excessExports = filter(statements, (s) => !!(getEffectiveModifierFlags(s) & 32 /* Export */));
	            const name = ns.name;
	            let body = ns.body;
	            if (length(excessExports)) {
	              ns = factory.updateModuleDeclaration(
	                ns,
	                ns.modifiers,
	                ns.name,
	                body = factory.updateModuleBlock(
	                  body,
	                  factory.createNodeArray([
	                    ...ns.body.statements,
	                    factory.createExportDeclaration(
	                      /*modifiers*/
	                      void 0,
	                      /*isTypeOnly*/
	                      false,
	                      factory.createNamedExports(map(flatMap(excessExports, (e) => getNamesOfDeclaration(e)), (id) => factory.createExportSpecifier(
	                        /*isTypeOnly*/
	                        false,
	                        /*propertyName*/
	                        void 0,
	                        id
	                      ))),
	                      /*moduleSpecifier*/
	                      void 0
	                    )
	                  ])
	                )
	              );
	              statements = [...statements.slice(0, nsIndex), ns, ...statements.slice(nsIndex + 1)];
	            }
	            if (!find(statements, (s) => s !== ns && nodeHasName(s, name))) {
	              results = [];
	              const mixinExportFlag = !some(body.statements, (s) => hasSyntacticModifier(s, 32 /* Export */) || isExportAssignment(s) || isExportDeclaration(s));
	              forEach(body.statements, (s) => {
	                addResult(s, mixinExportFlag ? 32 /* Export */ : 0 /* None */);
	              });
	              statements = [...filter(statements, (s) => s !== ns && s !== exportAssignment), ...results];
	            }
	          }
	          return statements;
	        }
	        function mergeExportDeclarations(statements) {
	          const exports = filter(statements, (d) => isExportDeclaration(d) && !d.moduleSpecifier && !!d.exportClause && isNamedExports(d.exportClause));
	          if (length(exports) > 1) {
	            const nonExports = filter(statements, (d) => !isExportDeclaration(d) || !!d.moduleSpecifier || !d.exportClause);
	            statements = [
	              ...nonExports,
	              factory.createExportDeclaration(
	                /*modifiers*/
	                void 0,
	                /*isTypeOnly*/
	                false,
	                factory.createNamedExports(flatMap(exports, (e) => cast(e.exportClause, isNamedExports).elements)),
	                /*moduleSpecifier*/
	                void 0
	              )
	            ];
	          }
	          const reexports = filter(statements, (d) => isExportDeclaration(d) && !!d.moduleSpecifier && !!d.exportClause && isNamedExports(d.exportClause));
	          if (length(reexports) > 1) {
	            const groups = group(reexports, (decl) => isStringLiteral(decl.moduleSpecifier) ? ">" + decl.moduleSpecifier.text : ">");
	            if (groups.length !== reexports.length) {
	              for (const group2 of groups) {
	                if (group2.length > 1) {
	                  statements = [
	                    ...filter(statements, (s) => !group2.includes(s)),
	                    factory.createExportDeclaration(
	                      /*modifiers*/
	                      void 0,
	                      /*isTypeOnly*/
	                      false,
	                      factory.createNamedExports(flatMap(group2, (e) => cast(e.exportClause, isNamedExports).elements)),
	                      group2[0].moduleSpecifier
	                    )
	                  ];
	                }
	              }
	            }
	          }
	          return statements;
	        }
	        function inlineExportModifiers(statements) {
	          const index = findIndex(statements, (d) => isExportDeclaration(d) && !d.moduleSpecifier && !d.attributes && !!d.exportClause && isNamedExports(d.exportClause));
	          if (index >= 0) {
	            const exportDecl = statements[index];
	            const replacements = mapDefined(exportDecl.exportClause.elements, (e) => {
	              if (!e.propertyName) {
	                const indices = indicesOf(statements);
	                const associatedIndices = filter(indices, (i) => nodeHasName(statements[i], e.name));
	                if (length(associatedIndices) && every(associatedIndices, (i) => canHaveExportModifier(statements[i]))) {
	                  for (const index2 of associatedIndices) {
	                    statements[index2] = addExportModifier(statements[index2]);
	                  }
	                  return void 0;
	                }
	              }
	              return e;
	            });
	            if (!length(replacements)) {
	              orderedRemoveItemAt(statements, index);
	            } else {
	              statements[index] = factory.updateExportDeclaration(
	                exportDecl,
	                exportDecl.modifiers,
	                exportDecl.isTypeOnly,
	                factory.updateNamedExports(
	                  exportDecl.exportClause,
	                  replacements
	                ),
	                exportDecl.moduleSpecifier,
	                exportDecl.attributes
	              );
	            }
	          }
	          return statements;
	        }
	        function mergeRedundantStatements(statements) {
	          statements = flattenExportAssignedNamespace(statements);
	          statements = mergeExportDeclarations(statements);
	          statements = inlineExportModifiers(statements);
	          if (enclosingDeclaration && (isSourceFile(enclosingDeclaration) && isExternalOrCommonJsModule(enclosingDeclaration) || isModuleDeclaration(enclosingDeclaration)) && (!some(statements, isExternalModuleIndicator) || !hasScopeMarker(statements) && some(statements, needsScopeMarker))) {
	            statements.push(createEmptyExports(factory));
	          }
	          return statements;
	        }
	        function addExportModifier(node) {
	          const flags = (getEffectiveModifierFlags(node) | 32 /* Export */) & ~128 /* Ambient */;
	          return factory.replaceModifiers(node, flags);
	        }
	        function removeExportModifier(node) {
	          const flags = getEffectiveModifierFlags(node) & ~32 /* Export */;
	          return factory.replaceModifiers(node, flags);
	        }
	        function visitSymbolTable(symbolTable2, suppressNewPrivateContext, propertyAsAlias) {
	          if (!suppressNewPrivateContext) {
	            deferredPrivatesStack.push(/* @__PURE__ */ new Map());
	          }
	          symbolTable2.forEach((symbol) => {
	            serializeSymbol(
	              symbol,
	              /*isPrivate*/
	              false,
	              !!propertyAsAlias
	            );
	          });
	          if (!suppressNewPrivateContext) {
	            deferredPrivatesStack[deferredPrivatesStack.length - 1].forEach((symbol) => {
	              serializeSymbol(
	                symbol,
	                /*isPrivate*/
	                true,
	                !!propertyAsAlias
	              );
	            });
	            deferredPrivatesStack.pop();
	          }
	        }
	        function serializeSymbol(symbol, isPrivate, propertyAsAlias) {
	          const visitedSym = getMergedSymbol(symbol);
	          if (visitedSymbols.has(getSymbolId(visitedSym))) {
	            return;
	          }
	          visitedSymbols.add(getSymbolId(visitedSym));
	          const skipMembershipCheck = !isPrivate;
	          if (skipMembershipCheck || !!length(symbol.declarations) && some(symbol.declarations, (d) => !!findAncestor(d, (n) => n === enclosingDeclaration))) {
	            const oldContext = context;
	            context = cloneNodeBuilderContext(context);
	            serializeSymbolWorker(symbol, isPrivate, propertyAsAlias);
	            if (context.reportedDiagnostic) {
	              oldcontext.reportedDiagnostic = context.reportedDiagnostic;
	            }
	            if (context.trackedSymbols) {
	              if (!oldContext.trackedSymbols)
	                oldContext.trackedSymbols = context.trackedSymbols;
	              else
	                Debug.assert(context.trackedSymbols === oldContext.trackedSymbols);
	            }
	            context = oldContext;
	          }
	        }
	        function serializeSymbolWorker(symbol, isPrivate, propertyAsAlias, escapedSymbolName = symbol.escapedName) {
	          var _a2, _b, _c, _d, _e, _f;
	          const symbolName2 = unescapeLeadingUnderscores(escapedSymbolName);
	          const isDefault = escapedSymbolName === "default" /* Default */;
	          if (isPrivate && !(context.flags & 131072 /* AllowAnonymousIdentifier */) && isStringANonContextualKeyword(symbolName2) && !isDefault) {
	            context.encounteredError = true;
	            return;
	          }
	          let needsPostExportDefault = isDefault && !!(symbol.flags & -113 /* ExportDoesNotSupportDefaultModifier */ || symbol.flags & 16 /* Function */ && length(getPropertiesOfType(getTypeOfSymbol(symbol)))) && !(symbol.flags & 2097152 /* Alias */);
	          let needsExportDeclaration = !needsPostExportDefault && !isPrivate && isStringANonContextualKeyword(symbolName2) && !isDefault;
	          if (needsPostExportDefault || needsExportDeclaration) {
	            isPrivate = true;
	          }
	          const modifierFlags = (!isPrivate ? 32 /* Export */ : 0) | (isDefault && !needsPostExportDefault ? 2048 /* Default */ : 0);
	          const isConstMergedWithNS = symbol.flags & 1536 /* Module */ && symbol.flags & (2 /* BlockScopedVariable */ | 1 /* FunctionScopedVariable */ | 4 /* Property */) && escapedSymbolName !== "export=" /* ExportEquals */;
	          const isConstMergedWithNSPrintableAsSignatureMerge = isConstMergedWithNS && isTypeRepresentableAsFunctionNamespaceMerge(getTypeOfSymbol(symbol), symbol);
	          if (symbol.flags & (16 /* Function */ | 8192 /* Method */) || isConstMergedWithNSPrintableAsSignatureMerge) {
	            serializeAsFunctionNamespaceMerge(getTypeOfSymbol(symbol), symbol, getInternalSymbolName(symbol, symbolName2), modifierFlags);
	          }
	          if (symbol.flags & 524288 /* TypeAlias */) {
	            serializeTypeAlias(symbol, symbolName2, modifierFlags);
	          }
	          if (symbol.flags & (2 /* BlockScopedVariable */ | 1 /* FunctionScopedVariable */ | 4 /* Property */ | 98304 /* Accessor */) && escapedSymbolName !== "export=" /* ExportEquals */ && !(symbol.flags & 4194304 /* Prototype */) && !(symbol.flags & 32 /* Class */) && !(symbol.flags & 8192 /* Method */) && !isConstMergedWithNSPrintableAsSignatureMerge) {
	            if (propertyAsAlias) {
	              const createdExport = serializeMaybeAliasAssignment(symbol);
	              if (createdExport) {
	                needsExportDeclaration = false;
	                needsPostExportDefault = false;
	              }
	            } else {
	              const type = getTypeOfSymbol(symbol);
	              const localName = getInternalSymbolName(symbol, symbolName2);
	              if (type.symbol && type.symbol !== symbol && type.symbol.flags & 16 /* Function */ && some(type.symbol.declarations, isFunctionExpressionOrArrowFunction) && (((_a2 = type.symbol.members) == null ? void 0 : _a2.size) || ((_b = type.symbol.exports) == null ? void 0 : _b.size))) {
	                if (!context.remappedSymbolReferences) {
	                  context.remappedSymbolReferences = /* @__PURE__ */ new Map();
	                }
	                context.remappedSymbolReferences.set(getSymbolId(type.symbol), symbol);
	                serializeSymbolWorker(type.symbol, isPrivate, propertyAsAlias, escapedSymbolName);
	                context.remappedSymbolReferences.delete(getSymbolId(type.symbol));
	              } else if (!(symbol.flags & 16 /* Function */) && isTypeRepresentableAsFunctionNamespaceMerge(type, symbol)) {
	                serializeAsFunctionNamespaceMerge(type, symbol, localName, modifierFlags);
	              } else {
	                const flags = !(symbol.flags & 2 /* BlockScopedVariable */) ? ((_c = symbol.parent) == null ? void 0 : _c.valueDeclaration) && isSourceFile((_d = symbol.parent) == null ? void 0 : _d.valueDeclaration) ? 2 /* Const */ : void 0 : isConstantVariable(symbol) ? 2 /* Const */ : 1 /* Let */;
	                const name = needsPostExportDefault || !(symbol.flags & 4 /* Property */) ? localName : getUnusedName(localName, symbol);
	                let textRange = symbol.declarations && find(symbol.declarations, (d) => isVariableDeclaration(d));
	                if (textRange && isVariableDeclarationList(textRange.parent) && textRange.parent.declarations.length === 1) {
	                  textRange = textRange.parent.parent;
	                }
	                const propertyAccessRequire = (_e = symbol.declarations) == null ? void 0 : _e.find(isPropertyAccessExpression);
	                if (propertyAccessRequire && isBinaryExpression(propertyAccessRequire.parent) && isIdentifier(propertyAccessRequire.parent.right) && ((_f = type.symbol) == null ? void 0 : _f.valueDeclaration) && isSourceFile(type.symbol.valueDeclaration)) {
	                  const alias = localName === propertyAccessRequire.parent.right.escapedText ? void 0 : propertyAccessRequire.parent.right;
	                  addResult(
	                    factory.createExportDeclaration(
	                      /*modifiers*/
	                      void 0,
	                      /*isTypeOnly*/
	                      false,
	                      factory.createNamedExports([factory.createExportSpecifier(
	                        /*isTypeOnly*/
	                        false,
	                        alias,
	                        localName
	                      )])
	                    ),
	                    0 /* None */
	                  );
	                  context.tracker.trackSymbol(type.symbol, context.enclosingDeclaration, 111551 /* Value */);
	                } else {
	                  const statement = setTextRange(
	                    factory.createVariableStatement(
	                      /*modifiers*/
	                      void 0,
	                      factory.createVariableDeclarationList([
	                        factory.createVariableDeclaration(
	                          name,
	                          /*exclamationToken*/
	                          void 0,
	                          serializeTypeForDeclaration(context, type, symbol, enclosingDeclaration, includePrivateSymbol, bundled)
	                        )
	                      ], flags)
	                    ),
	                    textRange
	                  );
	                  addResult(statement, name !== localName ? modifierFlags & ~32 /* Export */ : modifierFlags);
	                  if (name !== localName && !isPrivate) {
	                    addResult(
	                      factory.createExportDeclaration(
	                        /*modifiers*/
	                        void 0,
	                        /*isTypeOnly*/
	                        false,
	                        factory.createNamedExports([factory.createExportSpecifier(
	                          /*isTypeOnly*/
	                          false,
	                          name,
	                          localName
	                        )])
	                      ),
	                      0 /* None */
	                    );
	                    needsExportDeclaration = false;
	                    needsPostExportDefault = false;
	                  }
	                }
	              }
	            }
	          }
	          if (symbol.flags & 384 /* Enum */) {
	            serializeEnum(symbol, symbolName2, modifierFlags);
	          }
	          if (symbol.flags & 32 /* Class */) {
	            if (symbol.flags & 4 /* Property */ && symbol.valueDeclaration && isBinaryExpression(symbol.valueDeclaration.parent) && isClassExpression(symbol.valueDeclaration.parent.right)) {
	              serializeAsAlias(symbol, getInternalSymbolName(symbol, symbolName2), modifierFlags);
	            } else {
	              serializeAsClass(symbol, getInternalSymbolName(symbol, symbolName2), modifierFlags);
	            }
	          }
	          if (symbol.flags & (512 /* ValueModule */ | 1024 /* NamespaceModule */) && (!isConstMergedWithNS || isTypeOnlyNamespace(symbol)) || isConstMergedWithNSPrintableAsSignatureMerge) {
	            serializeModule(symbol, symbolName2, modifierFlags);
	          }
	          if (symbol.flags & 64 /* Interface */ && !(symbol.flags & 32 /* Class */)) {
	            serializeInterface(symbol, symbolName2, modifierFlags);
	          }
	          if (symbol.flags & 2097152 /* Alias */) {
	            serializeAsAlias(symbol, getInternalSymbolName(symbol, symbolName2), modifierFlags);
	          }
	          if (symbol.flags & 4 /* Property */ && symbol.escapedName === "export=" /* ExportEquals */) {
	            serializeMaybeAliasAssignment(symbol);
	          }
	          if (symbol.flags & 8388608 /* ExportStar */) {
	            if (symbol.declarations) {
	              for (const node of symbol.declarations) {
	                const resolvedModule = resolveExternalModuleName(node, node.moduleSpecifier);
	                if (!resolvedModule)
	                  continue;
	                addResult(factory.createExportDeclaration(
	                  /*modifiers*/
	                  void 0,
	                  /*isTypeOnly*/
	                  node.isTypeOnly,
	                  /*exportClause*/
	                  void 0,
	                  factory.createStringLiteral(getSpecifierForModuleSymbol(resolvedModule, context))
	                ), 0 /* None */);
	              }
	            }
	          }
	          if (needsPostExportDefault) {
	            addResult(factory.createExportAssignment(
	              /*modifiers*/
	              void 0,
	              /*isExportEquals*/
	              false,
	              factory.createIdentifier(getInternalSymbolName(symbol, symbolName2))
	            ), 0 /* None */);
	          } else if (needsExportDeclaration) {
	            addResult(
	              factory.createExportDeclaration(
	                /*modifiers*/
	                void 0,
	                /*isTypeOnly*/
	                false,
	                factory.createNamedExports([factory.createExportSpecifier(
	                  /*isTypeOnly*/
	                  false,
	                  getInternalSymbolName(symbol, symbolName2),
	                  symbolName2
	                )])
	              ),
	              0 /* None */
	            );
	          }
	        }
	        function includePrivateSymbol(symbol) {
	          if (some(symbol.declarations, isParameterDeclaration))
	            return;
	          Debug.assertIsDefined(deferredPrivatesStack[deferredPrivatesStack.length - 1]);
	          getUnusedName(unescapeLeadingUnderscores(symbol.escapedName), symbol);
	          const isExternalImportAlias = !!(symbol.flags & 2097152 /* Alias */) && !some(symbol.declarations, (d) => !!findAncestor(d, isExportDeclaration) || isNamespaceExport(d) || isImportEqualsDeclaration(d) && !isExternalModuleReference(d.moduleReference));
	          deferredPrivatesStack[isExternalImportAlias ? 0 : deferredPrivatesStack.length - 1].set(getSymbolId(symbol), symbol);
	        }
	        function isExportingScope(enclosingDeclaration2) {
	          return isSourceFile(enclosingDeclaration2) && (isExternalOrCommonJsModule(enclosingDeclaration2) || isJsonSourceFile(enclosingDeclaration2)) || isAmbientModule(enclosingDeclaration2) && !isGlobalScopeAugmentation(enclosingDeclaration2);
	        }
	        function addResult(node, additionalModifierFlags) {
	          if (canHaveModifiers(node)) {
	            let newModifierFlags = 0 /* None */;
	            const enclosingDeclaration2 = context.enclosingDeclaration && (isJSDocTypeAlias(context.enclosingDeclaration) ? getSourceFileOfNode(context.enclosingDeclaration) : context.enclosingDeclaration);
	            if (additionalModifierFlags & 32 /* Export */ && enclosingDeclaration2 && (isExportingScope(enclosingDeclaration2) || isModuleDeclaration(enclosingDeclaration2)) && canHaveExportModifier(node)) {
	              newModifierFlags |= 32 /* Export */;
	            }
	            if (addingDeclare && !(newModifierFlags & 32 /* Export */) && (!enclosingDeclaration2 || !(enclosingDeclaration2.flags & 33554432 /* Ambient */)) && (isEnumDeclaration(node) || isVariableStatement(node) || isFunctionDeclaration(node) || isClassDeclaration(node) || isModuleDeclaration(node))) {
	              newModifierFlags |= 128 /* Ambient */;
	            }
	            if (additionalModifierFlags & 2048 /* Default */ && (isClassDeclaration(node) || isInterfaceDeclaration(node) || isFunctionDeclaration(node))) {
	              newModifierFlags |= 2048 /* Default */;
	            }
	            if (newModifierFlags) {
	              node = factory.replaceModifiers(node, newModifierFlags | getEffectiveModifierFlags(node));
	            }
	          }
	          results.push(node);
	        }
	        function serializeTypeAlias(symbol, symbolName2, modifierFlags) {
	          var _a2;
	          const aliasType = getDeclaredTypeOfTypeAlias(symbol);
	          const typeParams = getSymbolLinks(symbol).typeParameters;
	          const typeParamDecls = map(typeParams, (p) => typeParameterToDeclaration(p, context));
	          const jsdocAliasDecl = (_a2 = symbol.declarations) == null ? void 0 : _a2.find(isJSDocTypeAlias);
	          const commentText = getTextOfJSDocComment(jsdocAliasDecl ? jsdocAliasDecl.comment || jsdocAliasDecl.parent.comment : void 0);
	          const oldFlags = context.flags;
	          context.flags |= 8388608 /* InTypeAlias */;
	          const oldEnclosingDecl = context.enclosingDeclaration;
	          context.enclosingDeclaration = jsdocAliasDecl;
	          const typeNode = jsdocAliasDecl && jsdocAliasDecl.typeExpression && isJSDocTypeExpression(jsdocAliasDecl.typeExpression) && serializeExistingTypeNode(context, jsdocAliasDecl.typeExpression.type, includePrivateSymbol, bundled) || typeToTypeNodeHelper(aliasType, context);
	          addResult(
	            setSyntheticLeadingComments(
	              factory.createTypeAliasDeclaration(
	                /*modifiers*/
	                void 0,
	                getInternalSymbolName(symbol, symbolName2),
	                typeParamDecls,
	                typeNode
	              ),
	              !commentText ? [] : [{ kind: 3 /* MultiLineCommentTrivia */, text: "*\n * " + commentText.replace(/\n/g, "\n * ") + "\n ", pos: -1, end: -1, hasTrailingNewLine: true }]
	            ),
	            modifierFlags
	          );
	          context.flags = oldFlags;
	          context.enclosingDeclaration = oldEnclosingDecl;
	        }
	        function serializeInterface(symbol, symbolName2, modifierFlags) {
	          const interfaceType = getDeclaredTypeOfClassOrInterface(symbol);
	          const localParams = getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(symbol);
	          const typeParamDecls = map(localParams, (p) => typeParameterToDeclaration(p, context));
	          const baseTypes = getBaseTypes(interfaceType);
	          const baseType = length(baseTypes) ? getIntersectionType(baseTypes) : void 0;
	          const members = flatMap(getPropertiesOfType(interfaceType), (p) => serializePropertySymbolForInterface(p, baseType));
	          const callSignatures = serializeSignatures(0 /* Call */, interfaceType, baseType, 179 /* CallSignature */);
	          const constructSignatures = serializeSignatures(1 /* Construct */, interfaceType, baseType, 180 /* ConstructSignature */);
	          const indexSignatures = serializeIndexSignatures(interfaceType, baseType);
	          const heritageClauses = !length(baseTypes) ? void 0 : [factory.createHeritageClause(96 /* ExtendsKeyword */, mapDefined(baseTypes, (b) => trySerializeAsTypeReference(b, 111551 /* Value */)))];
	          addResult(
	            factory.createInterfaceDeclaration(
	              /*modifiers*/
	              void 0,
	              getInternalSymbolName(symbol, symbolName2),
	              typeParamDecls,
	              heritageClauses,
	              [...indexSignatures, ...constructSignatures, ...callSignatures, ...members]
	            ),
	            modifierFlags
	          );
	        }
	        function getNamespaceMembersForSerialization(symbol) {
	          let exports = arrayFrom(getExportsOfSymbol(symbol).values());
	          const merged = getMergedSymbol(symbol);
	          if (merged !== symbol) {
	            const membersSet = new Set(exports);
	            for (const exported of getExportsOfSymbol(merged).values()) {
	              if (!(getSymbolFlags(resolveSymbol(exported)) & 111551 /* Value */)) {
	                membersSet.add(exported);
	              }
	            }
	            exports = arrayFrom(membersSet);
	          }
	          return filter(exports, (m) => isNamespaceMember(m) && isIdentifierText(m.escapedName, 99 /* ESNext */));
	        }
	        function isTypeOnlyNamespace(symbol) {
	          return every(getNamespaceMembersForSerialization(symbol), (m) => !(getSymbolFlags(resolveSymbol(m)) & 111551 /* Value */));
	        }
	        function serializeModule(symbol, symbolName2, modifierFlags) {
	          const members = getNamespaceMembersForSerialization(symbol);
	          const locationMap = arrayToMultiMap(members, (m) => m.parent && m.parent === symbol ? "real" : "merged");
	          const realMembers = locationMap.get("real") || emptyArray;
	          const mergedMembers = locationMap.get("merged") || emptyArray;
	          if (length(realMembers)) {
	            const localName = getInternalSymbolName(symbol, symbolName2);
	            serializeAsNamespaceDeclaration(realMembers, localName, modifierFlags, !!(symbol.flags & (16 /* Function */ | 67108864 /* Assignment */)));
	          }
	          if (length(mergedMembers)) {
	            const containingFile = getSourceFileOfNode(context.enclosingDeclaration);
	            const localName = getInternalSymbolName(symbol, symbolName2);
	            const nsBody = factory.createModuleBlock([factory.createExportDeclaration(
	              /*modifiers*/
	              void 0,
	              /*isTypeOnly*/
	              false,
	              factory.createNamedExports(mapDefined(filter(mergedMembers, (n) => n.escapedName !== "export=" /* ExportEquals */), (s) => {
	                var _a2, _b;
	                const name = unescapeLeadingUnderscores(s.escapedName);
	                const localName2 = getInternalSymbolName(s, name);
	                const aliasDecl = s.declarations && getDeclarationOfAliasSymbol(s);
	                if (containingFile && (aliasDecl ? containingFile !== getSourceFileOfNode(aliasDecl) : !some(s.declarations, (d) => getSourceFileOfNode(d) === containingFile))) {
	                  (_b = (_a2 = context.tracker) == null ? void 0 : _a2.reportNonlocalAugmentation) == null ? void 0 : _b.call(_a2, containingFile, symbol, s);
	                  return void 0;
	                }
	                const target = aliasDecl && getTargetOfAliasDeclaration(
	                  aliasDecl,
	                  /*dontRecursivelyResolve*/
	                  true
	                );
	                includePrivateSymbol(target || s);
	                const targetName = target ? getInternalSymbolName(target, unescapeLeadingUnderscores(target.escapedName)) : localName2;
	                return factory.createExportSpecifier(
	                  /*isTypeOnly*/
	                  false,
	                  name === targetName ? void 0 : targetName,
	                  name
	                );
	              }))
	            )]);
	            addResult(
	              factory.createModuleDeclaration(
	                /*modifiers*/
	                void 0,
	                factory.createIdentifier(localName),
	                nsBody,
	                32 /* Namespace */
	              ),
	              0 /* None */
	            );
	          }
	        }
	        function serializeEnum(symbol, symbolName2, modifierFlags) {
	          addResult(
	            factory.createEnumDeclaration(
	              factory.createModifiersFromModifierFlags(isConstEnumSymbol(symbol) ? 4096 /* Const */ : 0),
	              getInternalSymbolName(symbol, symbolName2),
	              map(filter(getPropertiesOfType(getTypeOfSymbol(symbol)), (p) => !!(p.flags & 8 /* EnumMember */)), (p) => {
	                const initializedValue = p.declarations && p.declarations[0] && isEnumMember(p.declarations[0]) ? getConstantValue2(p.declarations[0]) : void 0;
	                return factory.createEnumMember(
	                  unescapeLeadingUnderscores(p.escapedName),
	                  initializedValue === void 0 ? void 0 : typeof initializedValue === "string" ? factory.createStringLiteral(initializedValue) : factory.createNumericLiteral(initializedValue)
	                );
	              })
	            ),
	            modifierFlags
	          );
	        }
	        function serializeAsFunctionNamespaceMerge(type, symbol, localName, modifierFlags) {
	          const signatures = getSignaturesOfType(type, 0 /* Call */);
	          for (const sig of signatures) {
	            const decl = signatureToSignatureDeclarationHelper(sig, 262 /* FunctionDeclaration */, context, { name: factory.createIdentifier(localName), privateSymbolVisitor: includePrivateSymbol, bundledImports: bundled });
	            addResult(setTextRange(decl, getSignatureTextRangeLocation(sig)), modifierFlags);
	          }
	          if (!(symbol.flags & (512 /* ValueModule */ | 1024 /* NamespaceModule */) && !!symbol.exports && !!symbol.exports.size)) {
	            const props = filter(getPropertiesOfType(type), isNamespaceMember);
	            serializeAsNamespaceDeclaration(
	              props,
	              localName,
	              modifierFlags,
	              /*suppressNewPrivateContext*/
	              true
	            );
	          }
	        }
	        function getSignatureTextRangeLocation(signature) {
	          if (signature.declaration && signature.declaration.parent) {
	            if (isBinaryExpression(signature.declaration.parent) && getAssignmentDeclarationKind(signature.declaration.parent) === 5 /* Property */) {
	              return signature.declaration.parent;
	            }
	            if (isVariableDeclaration(signature.declaration.parent) && signature.declaration.parent.parent) {
	              return signature.declaration.parent.parent;
	            }
	          }
	          return signature.declaration;
	        }
	        function serializeAsNamespaceDeclaration(props, localName, modifierFlags, suppressNewPrivateContext) {
	          if (length(props)) {
	            const localVsRemoteMap = arrayToMultiMap(props, (p) => !length(p.declarations) || some(p.declarations, (d) => getSourceFileOfNode(d) === getSourceFileOfNode(context.enclosingDeclaration)) ? "local" : "remote");
	            const localProps = localVsRemoteMap.get("local") || emptyArray;
	            let fakespace = parseNodeFactory.createModuleDeclaration(
	              /*modifiers*/
	              void 0,
	              factory.createIdentifier(localName),
	              factory.createModuleBlock([]),
	              32 /* Namespace */
	            );
	            setParent(fakespace, enclosingDeclaration);
	            fakespace.locals = createSymbolTable(props);
	            fakespace.symbol = props[0].parent;
	            const oldResults = results;
	            results = [];
	            const oldAddingDeclare = addingDeclare;
	            addingDeclare = false;
	            const subcontext = { ...context, enclosingDeclaration: fakespace };
	            const oldContext = context;
	            context = subcontext;
	            visitSymbolTable(
	              createSymbolTable(localProps),
	              suppressNewPrivateContext,
	              /*propertyAsAlias*/
	              true
	            );
	            context = oldContext;
	            addingDeclare = oldAddingDeclare;
	            const declarations = results;
	            results = oldResults;
	            const defaultReplaced = map(declarations, (d) => isExportAssignment(d) && !d.isExportEquals && isIdentifier(d.expression) ? factory.createExportDeclaration(
	              /*modifiers*/
	              void 0,
	              /*isTypeOnly*/
	              false,
	              factory.createNamedExports([factory.createExportSpecifier(
	                /*isTypeOnly*/
	                false,
	                d.expression,
	                factory.createIdentifier("default" /* Default */)
	              )])
	            ) : d);
	            const exportModifierStripped = every(defaultReplaced, (d) => hasSyntacticModifier(d, 32 /* Export */)) ? map(defaultReplaced, removeExportModifier) : defaultReplaced;
	            fakespace = factory.updateModuleDeclaration(
	              fakespace,
	              fakespace.modifiers,
	              fakespace.name,
	              factory.createModuleBlock(exportModifierStripped)
	            );
	            addResult(fakespace, modifierFlags);
	          }
	        }
	        function isNamespaceMember(p) {
	          return !!(p.flags & (788968 /* Type */ | 1920 /* Namespace */ | 2097152 /* Alias */)) || !(p.flags & 4194304 /* Prototype */ || p.escapedName === "prototype" || p.valueDeclaration && isStatic(p.valueDeclaration) && isClassLike(p.valueDeclaration.parent));
	        }
	        function sanitizeJSDocImplements(clauses) {
	          const result = mapDefined(clauses, (e) => {
	            const oldEnclosing = context.enclosingDeclaration;
	            context.enclosingDeclaration = e;
	            let expr = e.expression;
	            if (isEntityNameExpression(expr)) {
	              if (isIdentifier(expr) && idText(expr) === "") {
	                return cleanup(
	                  /*result*/
	                  void 0
	                );
	              }
	              let introducesError;
	              ({ introducesError, node: expr } = trackExistingEntityName(expr, context, includePrivateSymbol));
	              if (introducesError) {
	                return cleanup(
	                  /*result*/
	                  void 0
	                );
	              }
	            }
	            return cleanup(factory.createExpressionWithTypeArguments(
	              expr,
	              map(e.typeArguments, (a) => serializeExistingTypeNode(context, a, includePrivateSymbol, bundled) || typeToTypeNodeHelper(getTypeFromTypeNode(a), context))
	            ));
	            function cleanup(result2) {
	              context.enclosingDeclaration = oldEnclosing;
	              return result2;
	            }
	          });
	          if (result.length === clauses.length) {
	            return result;
	          }
	          return void 0;
	        }
	        function serializeAsClass(symbol, localName, modifierFlags) {
	          var _a2, _b;
	          const originalDecl = (_a2 = symbol.declarations) == null ? void 0 : _a2.find(isClassLike);
	          const oldEnclosing = context.enclosingDeclaration;
	          context.enclosingDeclaration = originalDecl || oldEnclosing;
	          const localParams = getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(symbol);
	          const typeParamDecls = map(localParams, (p) => typeParameterToDeclaration(p, context));
	          const classType = getTypeWithThisArgument(getDeclaredTypeOfClassOrInterface(symbol));
	          const baseTypes = getBaseTypes(classType);
	          const originalImplements = originalDecl && getEffectiveImplementsTypeNodes(originalDecl);
	          const implementsExpressions = originalImplements && sanitizeJSDocImplements(originalImplements) || mapDefined(getImplementsTypes(classType), serializeImplementedType);
	          const staticType = getTypeOfSymbol(symbol);
	          const isClass = !!((_b = staticType.symbol) == null ? void 0 : _b.valueDeclaration) && isClassLike(staticType.symbol.valueDeclaration);
	          const staticBaseType = isClass ? getBaseConstructorTypeOfClass(staticType) : anyType;
	          const heritageClauses = [
	            ...!length(baseTypes) ? [] : [factory.createHeritageClause(96 /* ExtendsKeyword */, map(baseTypes, (b) => serializeBaseType(b, staticBaseType, localName)))],
	            ...!length(implementsExpressions) ? [] : [factory.createHeritageClause(119 /* ImplementsKeyword */, implementsExpressions)]
	          ];
	          const symbolProps = getNonInheritedProperties(classType, baseTypes, getPropertiesOfType(classType));
	          const publicSymbolProps = filter(symbolProps, (s) => {
	            const valueDecl = s.valueDeclaration;
	            return !!valueDecl && !(isNamedDeclaration(valueDecl) && isPrivateIdentifier(valueDecl.name));
	          });
	          const hasPrivateIdentifier = some(symbolProps, (s) => {
	            const valueDecl = s.valueDeclaration;
	            return !!valueDecl && isNamedDeclaration(valueDecl) && isPrivateIdentifier(valueDecl.name);
	          });
	          const privateProperties = hasPrivateIdentifier ? [factory.createPropertyDeclaration(
	            /*modifiers*/
	            void 0,
	            factory.createPrivateIdentifier("#private"),
	            /*questionOrExclamationToken*/
	            void 0,
	            /*type*/
	            void 0,
	            /*initializer*/
	            void 0
	          )] : emptyArray;
	          const publicProperties = flatMap(publicSymbolProps, (p) => serializePropertySymbolForClass(
	            p,
	            /*isStatic*/
	            false,
	            baseTypes[0]
	          ));
	          const staticMembers = flatMap(
	            filter(getPropertiesOfType(staticType), (p) => !(p.flags & 4194304 /* Prototype */) && p.escapedName !== "prototype" && !isNamespaceMember(p)),
	            (p) => serializePropertySymbolForClass(
	              p,
	              /*isStatic*/
	              true,
	              staticBaseType
	            )
	          );
	          const isNonConstructableClassLikeInJsFile = !isClass && !!symbol.valueDeclaration && isInJSFile(symbol.valueDeclaration) && !some(getSignaturesOfType(staticType, 1 /* Construct */));
	          const constructors = isNonConstructableClassLikeInJsFile ? [factory.createConstructorDeclaration(
	            factory.createModifiersFromModifierFlags(2 /* Private */),
	            [],
	            /*body*/
	            void 0
	          )] : serializeSignatures(1 /* Construct */, staticType, staticBaseType, 176 /* Constructor */);
	          const indexSignatures = serializeIndexSignatures(classType, baseTypes[0]);
	          context.enclosingDeclaration = oldEnclosing;
	          addResult(
	            setTextRange(
	              factory.createClassDeclaration(
	                /*modifiers*/
	                void 0,
	                localName,
	                typeParamDecls,
	                heritageClauses,
	                [...indexSignatures, ...staticMembers, ...constructors, ...publicProperties, ...privateProperties]
	              ),
	              symbol.declarations && filter(symbol.declarations, (d) => isClassDeclaration(d) || isClassExpression(d))[0]
	            ),
	            modifierFlags
	          );
	        }
	        function getSomeTargetNameFromDeclarations(declarations) {
	          return firstDefined(declarations, (d) => {
	            if (isImportSpecifier(d) || isExportSpecifier(d)) {
	              return idText(d.propertyName || d.name);
	            }
	            if (isBinaryExpression(d) || isExportAssignment(d)) {
	              const expression = isExportAssignment(d) ? d.expression : d.right;
	              if (isPropertyAccessExpression(expression)) {
	                return idText(expression.name);
	              }
	            }
	            if (isAliasSymbolDeclaration2(d)) {
	              const name = getNameOfDeclaration(d);
	              if (name && isIdentifier(name)) {
	                return idText(name);
	              }
	            }
	            return void 0;
	          });
	        }
	        function serializeAsAlias(symbol, localName, modifierFlags) {
	          var _a2, _b, _c, _d, _e, _f;
	          const node = getDeclarationOfAliasSymbol(symbol);
	          if (!node)
	            return Debug.fail();
	          const target = getMergedSymbol(getTargetOfAliasDeclaration(
	            node,
	            /*dontRecursivelyResolve*/
	            true
	          ));
	          if (!target) {
	            return;
	          }
	          let verbatimTargetName = isShorthandAmbientModuleSymbol(target) && getSomeTargetNameFromDeclarations(symbol.declarations) || unescapeLeadingUnderscores(target.escapedName);
	          if (verbatimTargetName === "export=" /* ExportEquals */ && allowSyntheticDefaultImports) {
	            verbatimTargetName = "default" /* Default */;
	          }
	          const targetName = getInternalSymbolName(target, verbatimTargetName);
	          includePrivateSymbol(target);
	          switch (node.kind) {
	            case 208 /* BindingElement */:
	              if (((_b = (_a2 = node.parent) == null ? void 0 : _a2.parent) == null ? void 0 : _b.kind) === 260 /* VariableDeclaration */) {
	                const specifier2 = getSpecifierForModuleSymbol(target.parent || target, context);
	                const { propertyName } = node;
	                addResult(
	                  factory.createImportDeclaration(
	                    /*modifiers*/
	                    void 0,
	                    factory.createImportClause(
	                      /*isTypeOnly*/
	                      false,
	                      /*name*/
	                      void 0,
	                      factory.createNamedImports([factory.createImportSpecifier(
	                        /*isTypeOnly*/
	                        false,
	                        propertyName && isIdentifier(propertyName) ? factory.createIdentifier(idText(propertyName)) : void 0,
	                        factory.createIdentifier(localName)
	                      )])
	                    ),
	                    factory.createStringLiteral(specifier2),
	                    /*attributes*/
	                    void 0
	                  ),
	                  0 /* None */
	                );
	                break;
	              }
	              Debug.failBadSyntaxKind(((_c = node.parent) == null ? void 0 : _c.parent) || node, "Unhandled binding element grandparent kind in declaration serialization");
	              break;
	            case 304 /* ShorthandPropertyAssignment */:
	              if (((_e = (_d = node.parent) == null ? void 0 : _d.parent) == null ? void 0 : _e.kind) === 226 /* BinaryExpression */) {
	                serializeExportSpecifier(
	                  unescapeLeadingUnderscores(symbol.escapedName),
	                  targetName
	                );
	              }
	              break;
	            case 260 /* VariableDeclaration */:
	              if (isPropertyAccessExpression(node.initializer)) {
	                const initializer = node.initializer;
	                const uniqueName = factory.createUniqueName(localName);
	                const specifier2 = getSpecifierForModuleSymbol(target.parent || target, context);
	                addResult(
	                  factory.createImportEqualsDeclaration(
	                    /*modifiers*/
	                    void 0,
	                    /*isTypeOnly*/
	                    false,
	                    uniqueName,
	                    factory.createExternalModuleReference(factory.createStringLiteral(specifier2))
	                  ),
	                  0 /* None */
	                );
	                addResult(
	                  factory.createImportEqualsDeclaration(
	                    /*modifiers*/
	                    void 0,
	                    /*isTypeOnly*/
	                    false,
	                    factory.createIdentifier(localName),
	                    factory.createQualifiedName(uniqueName, initializer.name)
	                  ),
	                  modifierFlags
	                );
	                break;
	              }
	            case 271 /* ImportEqualsDeclaration */:
	              if (target.escapedName === "export=" /* ExportEquals */ && some(target.declarations, (d) => isSourceFile(d) && isJsonSourceFile(d))) {
	                serializeMaybeAliasAssignment(symbol);
	                break;
	              }
	              const isLocalImport = !(target.flags & 512 /* ValueModule */) && !isVariableDeclaration(node);
	              addResult(
	                factory.createImportEqualsDeclaration(
	                  /*modifiers*/
	                  void 0,
	                  /*isTypeOnly*/
	                  false,
	                  factory.createIdentifier(localName),
	                  isLocalImport ? symbolToName(
	                    target,
	                    context,
	                    -1 /* All */,
	                    /*expectsIdentifier*/
	                    false
	                  ) : factory.createExternalModuleReference(factory.createStringLiteral(getSpecifierForModuleSymbol(target, context)))
	                ),
	                isLocalImport ? modifierFlags : 0 /* None */
	              );
	              break;
	            case 270 /* NamespaceExportDeclaration */:
	              addResult(factory.createNamespaceExportDeclaration(idText(node.name)), 0 /* None */);
	              break;
	            case 273 /* ImportClause */: {
	              const generatedSpecifier = getSpecifierForModuleSymbol(target.parent || target, context);
	              const specifier2 = bundled ? factory.createStringLiteral(generatedSpecifier) : node.parent.moduleSpecifier;
	              addResult(
	                factory.createImportDeclaration(
	                  /*modifiers*/
	                  void 0,
	                  factory.createImportClause(
	                    /*isTypeOnly*/
	                    false,
	                    factory.createIdentifier(localName),
	                    /*namedBindings*/
	                    void 0
	                  ),
	                  specifier2,
	                  node.parent.attributes
	                ),
	                0 /* None */
	              );
	              break;
	            }
	            case 274 /* NamespaceImport */: {
	              const generatedSpecifier = getSpecifierForModuleSymbol(target.parent || target, context);
	              const specifier2 = bundled ? factory.createStringLiteral(generatedSpecifier) : node.parent.parent.moduleSpecifier;
	              addResult(
	                factory.createImportDeclaration(
	                  /*modifiers*/
	                  void 0,
	                  factory.createImportClause(
	                    /*isTypeOnly*/
	                    false,
	                    /*name*/
	                    void 0,
	                    factory.createNamespaceImport(factory.createIdentifier(localName))
	                  ),
	                  specifier2,
	                  node.parent.attributes
	                ),
	                0 /* None */
	              );
	              break;
	            }
	            case 280 /* NamespaceExport */:
	              addResult(
	                factory.createExportDeclaration(
	                  /*modifiers*/
	                  void 0,
	                  /*isTypeOnly*/
	                  false,
	                  factory.createNamespaceExport(factory.createIdentifier(localName)),
	                  factory.createStringLiteral(getSpecifierForModuleSymbol(target, context))
	                ),
	                0 /* None */
	              );
	              break;
	            case 276 /* ImportSpecifier */: {
	              const generatedSpecifier = getSpecifierForModuleSymbol(target.parent || target, context);
	              const specifier2 = bundled ? factory.createStringLiteral(generatedSpecifier) : node.parent.parent.parent.moduleSpecifier;
	              addResult(
	                factory.createImportDeclaration(
	                  /*modifiers*/
	                  void 0,
	                  factory.createImportClause(
	                    /*isTypeOnly*/
	                    false,
	                    /*name*/
	                    void 0,
	                    factory.createNamedImports([
	                      factory.createImportSpecifier(
	                        /*isTypeOnly*/
	                        false,
	                        localName !== verbatimTargetName ? factory.createIdentifier(verbatimTargetName) : void 0,
	                        factory.createIdentifier(localName)
	                      )
	                    ])
	                  ),
	                  specifier2,
	                  node.parent.parent.parent.attributes
	                ),
	                0 /* None */
	              );
	              break;
	            }
	            case 281 /* ExportSpecifier */:
	              const specifier = node.parent.parent.moduleSpecifier;
	              if (specifier && ((_f = node.propertyName) == null ? void 0 : _f.escapedText) === "default" /* Default */) {
	                verbatimTargetName = "default" /* Default */;
	              }
	              serializeExportSpecifier(
	                unescapeLeadingUnderscores(symbol.escapedName),
	                specifier ? verbatimTargetName : targetName,
	                specifier && isStringLiteralLike(specifier) ? factory.createStringLiteral(specifier.text) : void 0
	              );
	              break;
	            case 277 /* ExportAssignment */:
	              serializeMaybeAliasAssignment(symbol);
	              break;
	            case 226 /* BinaryExpression */:
	            case 211 /* PropertyAccessExpression */:
	            case 212 /* ElementAccessExpression */:
	              if (symbol.escapedName === "default" /* Default */ || symbol.escapedName === "export=" /* ExportEquals */) {
	                serializeMaybeAliasAssignment(symbol);
	              } else {
	                serializeExportSpecifier(localName, targetName);
	              }
	              break;
	            default:
	              return Debug.failBadSyntaxKind(node, "Unhandled alias declaration kind in symbol serializer!");
	          }
	        }
	        function serializeExportSpecifier(localName, targetName, specifier) {
	          addResult(
	            factory.createExportDeclaration(
	              /*modifiers*/
	              void 0,
	              /*isTypeOnly*/
	              false,
	              factory.createNamedExports([factory.createExportSpecifier(
	                /*isTypeOnly*/
	                false,
	                localName !== targetName ? targetName : void 0,
	                localName
	              )]),
	              specifier
	            ),
	            0 /* None */
	          );
	        }
	        function serializeMaybeAliasAssignment(symbol) {
	          var _a2;
	          if (symbol.flags & 4194304 /* Prototype */) {
	            return false;
	          }
	          const name = unescapeLeadingUnderscores(symbol.escapedName);
	          const isExportEquals = name === "export=" /* ExportEquals */;
	          const isDefault = name === "default" /* Default */;
	          const isExportAssignmentCompatibleSymbolName = isExportEquals || isDefault;
	          const aliasDecl = symbol.declarations && getDeclarationOfAliasSymbol(symbol);
	          const target = aliasDecl && getTargetOfAliasDeclaration(
	            aliasDecl,
	            /*dontRecursivelyResolve*/
	            true
	          );
	          if (target && length(target.declarations) && some(target.declarations, (d) => getSourceFileOfNode(d) === getSourceFileOfNode(enclosingDeclaration))) {
	            const expr = aliasDecl && (isExportAssignment(aliasDecl) || isBinaryExpression(aliasDecl) ? getExportAssignmentExpression(aliasDecl) : getPropertyAssignmentAliasLikeExpression(aliasDecl));
	            const first2 = expr && isEntityNameExpression(expr) ? getFirstNonModuleExportsIdentifier(expr) : void 0;
	            const referenced = first2 && resolveEntityName(
	              first2,
	              -1 /* All */,
	              /*ignoreErrors*/
	              true,
	              /*dontResolveAlias*/
	              true,
	              enclosingDeclaration
	            );
	            if (referenced || target) {
	              includePrivateSymbol(referenced || target);
	            }
	            const prevDisableTrackSymbol = context.tracker.disableTrackSymbol;
	            context.tracker.disableTrackSymbol = true;
	            if (isExportAssignmentCompatibleSymbolName) {
	              results.push(factory.createExportAssignment(
	                /*modifiers*/
	                void 0,
	                isExportEquals,
	                symbolToExpression(target, context, -1 /* All */)
	              ));
	            } else {
	              if (first2 === expr && first2) {
	                serializeExportSpecifier(name, idText(first2));
	              } else if (expr && isClassExpression(expr)) {
	                serializeExportSpecifier(name, getInternalSymbolName(target, symbolName(target)));
	              } else {
	                const varName = getUnusedName(name, symbol);
	                addResult(
	                  factory.createImportEqualsDeclaration(
	                    /*modifiers*/
	                    void 0,
	                    /*isTypeOnly*/
	                    false,
	                    factory.createIdentifier(varName),
	                    symbolToName(
	                      target,
	                      context,
	                      -1 /* All */,
	                      /*expectsIdentifier*/
	                      false
	                    )
	                  ),
	                  0 /* None */
	                );
	                serializeExportSpecifier(name, varName);
	              }
	            }
	            context.tracker.disableTrackSymbol = prevDisableTrackSymbol;
	            return true;
	          } else {
	            const varName = getUnusedName(name, symbol);
	            const typeToSerialize = getWidenedType(getTypeOfSymbol(getMergedSymbol(symbol)));
	            if (isTypeRepresentableAsFunctionNamespaceMerge(typeToSerialize, symbol)) {
	              serializeAsFunctionNamespaceMerge(typeToSerialize, symbol, varName, isExportAssignmentCompatibleSymbolName ? 0 /* None */ : 32 /* Export */);
	            } else {
	              const flags = ((_a2 = context.enclosingDeclaration) == null ? void 0 : _a2.kind) === 267 /* ModuleDeclaration */ && (!(symbol.flags & 98304 /* Accessor */) || symbol.flags & 65536 /* SetAccessor */) ? 1 /* Let */ : 2 /* Const */;
	              const statement = factory.createVariableStatement(
	                /*modifiers*/
	                void 0,
	                factory.createVariableDeclarationList([
	                  factory.createVariableDeclaration(
	                    varName,
	                    /*exclamationToken*/
	                    void 0,
	                    serializeTypeForDeclaration(context, typeToSerialize, symbol, enclosingDeclaration, includePrivateSymbol, bundled)
	                  )
	                ], flags)
	              );
	              addResult(
	                statement,
	                target && target.flags & 4 /* Property */ && target.escapedName === "export=" /* ExportEquals */ ? 128 /* Ambient */ : name === varName ? 32 /* Export */ : 0 /* None */
	              );
	            }
	            if (isExportAssignmentCompatibleSymbolName) {
	              results.push(factory.createExportAssignment(
	                /*modifiers*/
	                void 0,
	                isExportEquals,
	                factory.createIdentifier(varName)
	              ));
	              return true;
	            } else if (name !== varName) {
	              serializeExportSpecifier(name, varName);
	              return true;
	            }
	            return false;
	          }
	        }
	        function isTypeRepresentableAsFunctionNamespaceMerge(typeToSerialize, hostSymbol) {
	          const ctxSrc = getSourceFileOfNode(context.enclosingDeclaration);
	          return getObjectFlags(typeToSerialize) & (16 /* Anonymous */ | 32 /* Mapped */) && !length(getIndexInfosOfType(typeToSerialize)) && !isClassInstanceSide(typeToSerialize) && // While a class instance is potentially representable as a NS, prefer printing a reference to the instance type and serializing the class
	          !!(length(filter(getPropertiesOfType(typeToSerialize), isNamespaceMember)) || length(getSignaturesOfType(typeToSerialize, 0 /* Call */))) && !length(getSignaturesOfType(typeToSerialize, 1 /* Construct */)) && // TODO: could probably serialize as function + ns + class, now that that's OK
	          !getDeclarationWithTypeAnnotation(hostSymbol, enclosingDeclaration) && !(typeToSerialize.symbol && some(typeToSerialize.symbol.declarations, (d) => getSourceFileOfNode(d) !== ctxSrc)) && !some(getPropertiesOfType(typeToSerialize), (p) => isLateBoundName(p.escapedName)) && !some(getPropertiesOfType(typeToSerialize), (p) => some(p.declarations, (d) => getSourceFileOfNode(d) !== ctxSrc)) && every(getPropertiesOfType(typeToSerialize), (p) => {
	            if (!isIdentifierText(symbolName(p), languageVersion)) {
	              return false;
	            }
	            if (!(p.flags & 98304 /* Accessor */)) {
	              return true;
	            }
	            return getNonMissingTypeOfSymbol(p) === getWriteTypeOfSymbol(p);
	          });
	        }
	        function makeSerializePropertySymbol(createProperty2, methodKind, useAccessors) {
	          return function serializePropertySymbol(p, isStatic2, baseType) {
	            var _a2, _b, _c, _d, _e;
	            const modifierFlags = getDeclarationModifierFlagsFromSymbol(p);
	            const isPrivate = !!(modifierFlags & 2 /* Private */);
	            if (isStatic2 && p.flags & (788968 /* Type */ | 1920 /* Namespace */ | 2097152 /* Alias */)) {
	              return [];
	            }
	            if (p.flags & 4194304 /* Prototype */ || p.escapedName === "constructor" || baseType && getPropertyOfType(baseType, p.escapedName) && isReadonlySymbol(getPropertyOfType(baseType, p.escapedName)) === isReadonlySymbol(p) && (p.flags & 16777216 /* Optional */) === (getPropertyOfType(baseType, p.escapedName).flags & 16777216 /* Optional */) && isTypeIdenticalTo(getTypeOfSymbol(p), getTypeOfPropertyOfType(baseType, p.escapedName))) {
	              return [];
	            }
	            const flag = modifierFlags & ~1024 /* Async */ | (isStatic2 ? 256 /* Static */ : 0);
	            const name = getPropertyNameNodeForSymbol(p, context);
	            const firstPropertyLikeDecl = (_a2 = p.declarations) == null ? void 0 : _a2.find(or(isPropertyDeclaration, isAccessor, isVariableDeclaration, isPropertySignature, isBinaryExpression, isPropertyAccessExpression));
	            if (p.flags & 98304 /* Accessor */ && useAccessors) {
	              const result = [];
	              if (p.flags & 65536 /* SetAccessor */) {
	                const setter = p.declarations && forEach(p.declarations, (d) => {
	                  if (d.kind === 178 /* SetAccessor */) {
	                    return d;
	                  }
	                  if (isCallExpression(d) && isBindableObjectDefinePropertyCall(d)) {
	                    return forEach(d.arguments[2].properties, (propDecl) => {
	                      const id = getNameOfDeclaration(propDecl);
	                      if (!!id && isIdentifier(id) && idText(id) === "set") {
	                        return propDecl;
	                      }
	                    });
	                  }
	                });
	                Debug.assert(!!setter);
	                const paramSymbol = isFunctionLikeDeclaration(setter) ? getSignatureFromDeclaration(setter).parameters[0] : void 0;
	                result.push(setTextRange(
	                  factory.createSetAccessorDeclaration(
	                    factory.createModifiersFromModifierFlags(flag),
	                    name,
	                    [factory.createParameterDeclaration(
	                      /*modifiers*/
	                      void 0,
	                      /*dotDotDotToken*/
	                      void 0,
	                      paramSymbol ? parameterToParameterDeclarationName(paramSymbol, getEffectiveParameterDeclaration(paramSymbol), context) : "value",
	                      /*questionToken*/
	                      void 0,
	                      isPrivate ? void 0 : serializeTypeForDeclaration(context, getTypeOfSymbol(p), p, enclosingDeclaration, includePrivateSymbol, bundled)
	                    )],
	                    /*body*/
	                    void 0
	                  ),
	                  ((_b = p.declarations) == null ? void 0 : _b.find(isSetAccessor)) || firstPropertyLikeDecl
	                ));
	              }
	              if (p.flags & 32768 /* GetAccessor */) {
	                const isPrivate2 = modifierFlags & 2 /* Private */;
	                result.push(setTextRange(
	                  factory.createGetAccessorDeclaration(
	                    factory.createModifiersFromModifierFlags(flag),
	                    name,
	                    [],
	                    isPrivate2 ? void 0 : serializeTypeForDeclaration(context, getTypeOfSymbol(p), p, enclosingDeclaration, includePrivateSymbol, bundled),
	                    /*body*/
	                    void 0
	                  ),
	                  ((_c = p.declarations) == null ? void 0 : _c.find(isGetAccessor)) || firstPropertyLikeDecl
	                ));
	              }
	              return result;
	            } else if (p.flags & (4 /* Property */ | 3 /* Variable */ | 98304 /* Accessor */)) {
	              return setTextRange(
	                createProperty2(
	                  factory.createModifiersFromModifierFlags((isReadonlySymbol(p) ? 8 /* Readonly */ : 0) | flag),
	                  name,
	                  p.flags & 16777216 /* Optional */ ? factory.createToken(58 /* QuestionToken */) : void 0,
	                  isPrivate ? void 0 : serializeTypeForDeclaration(context, getWriteTypeOfSymbol(p), p, enclosingDeclaration, includePrivateSymbol, bundled),
	                  // TODO: https://github.com/microsoft/TypeScript/pull/32372#discussion_r328386357
	                  // interface members can't have initializers, however class members _can_
	                  /*initializer*/
	                  void 0
	                ),
	                ((_d = p.declarations) == null ? void 0 : _d.find(or(isPropertyDeclaration, isVariableDeclaration))) || firstPropertyLikeDecl
	              );
	            }
	            if (p.flags & (8192 /* Method */ | 16 /* Function */)) {
	              const type = getTypeOfSymbol(p);
	              const signatures = getSignaturesOfType(type, 0 /* Call */);
	              if (flag & 2 /* Private */) {
	                return setTextRange(
	                  createProperty2(
	                    factory.createModifiersFromModifierFlags((isReadonlySymbol(p) ? 8 /* Readonly */ : 0) | flag),
	                    name,
	                    p.flags & 16777216 /* Optional */ ? factory.createToken(58 /* QuestionToken */) : void 0,
	                    /*type*/
	                    void 0,
	                    /*initializer*/
	                    void 0
	                  ),
	                  ((_e = p.declarations) == null ? void 0 : _e.find(isFunctionLikeDeclaration)) || signatures[0] && signatures[0].declaration || p.declarations && p.declarations[0]
	                );
	              }
	              const results2 = [];
	              for (const sig of signatures) {
	                const decl = signatureToSignatureDeclarationHelper(
	                  sig,
	                  methodKind,
	                  context,
	                  {
	                    name,
	                    questionToken: p.flags & 16777216 /* Optional */ ? factory.createToken(58 /* QuestionToken */) : void 0,
	                    modifiers: flag ? factory.createModifiersFromModifierFlags(flag) : void 0
	                  }
	                );
	                const location = sig.declaration && isPrototypePropertyAssignment(sig.declaration.parent) ? sig.declaration.parent : sig.declaration;
	                results2.push(setTextRange(decl, location));
	              }
	              return results2;
	            }
	            return Debug.fail(`Unhandled class member kind! ${p.__debugFlags || p.flags}`);
	          };
	        }
	        function serializePropertySymbolForInterface(p, baseType) {
	          return serializePropertySymbolForInterfaceWorker(
	            p,
	            /*isStatic*/
	            false,
	            baseType
	          );
	        }
	        function serializeSignatures(kind, input, baseType, outputKind) {
	          const signatures = getSignaturesOfType(input, kind);
	          if (kind === 1 /* Construct */) {
	            if (!baseType && every(signatures, (s) => length(s.parameters) === 0)) {
	              return [];
	            }
	            if (baseType) {
	              const baseSigs = getSignaturesOfType(baseType, 1 /* Construct */);
	              if (!length(baseSigs) && every(signatures, (s) => length(s.parameters) === 0)) {
	                return [];
	              }
	              if (baseSigs.length === signatures.length) {
	                let failed = false;
	                for (let i = 0; i < baseSigs.length; i++) {
	                  if (!compareSignaturesIdentical(
	                    signatures[i],
	                    baseSigs[i],
	                    /*partialMatch*/
	                    false,
	                    /*ignoreThisTypes*/
	                    false,
	                    /*ignoreReturnTypes*/
	                    true,
	                    compareTypesIdentical
	                  )) {
	                    failed = true;
	                    break;
	                  }
	                }
	                if (!failed) {
	                  return [];
	                }
	              }
	            }
	            let privateProtected = 0;
	            for (const s of signatures) {
	              if (s.declaration) {
	                privateProtected |= getSelectedEffectiveModifierFlags(s.declaration, 2 /* Private */ | 4 /* Protected */);
	              }
	            }
	            if (privateProtected) {
	              return [setTextRange(
	                factory.createConstructorDeclaration(
	                  factory.createModifiersFromModifierFlags(privateProtected),
	                  /*parameters*/
	                  [],
	                  /*body*/
	                  void 0
	                ),
	                signatures[0].declaration
	              )];
	            }
	          }
	          const results2 = [];
	          for (const sig of signatures) {
	            const decl = signatureToSignatureDeclarationHelper(sig, outputKind, context);
	            results2.push(setTextRange(decl, sig.declaration));
	          }
	          return results2;
	        }
	        function serializeIndexSignatures(input, baseType) {
	          const results2 = [];
	          for (const info of getIndexInfosOfType(input)) {
	            if (baseType) {
	              const baseInfo = getIndexInfoOfType(baseType, info.keyType);
	              if (baseInfo) {
	                if (isTypeIdenticalTo(info.type, baseInfo.type)) {
	                  continue;
	                }
	              }
	            }
	            results2.push(indexInfoToIndexSignatureDeclarationHelper(
	              info,
	              context,
	              /*typeNode*/
	              void 0
	            ));
	          }
	          return results2;
	        }
	        function serializeBaseType(t, staticType, rootName) {
	          const ref = trySerializeAsTypeReference(t, 111551 /* Value */);
	          if (ref) {
	            return ref;
	          }
	          const tempName = getUnusedName(`${rootName}_base`);
	          const statement = factory.createVariableStatement(
	            /*modifiers*/
	            void 0,
	            factory.createVariableDeclarationList([
	              factory.createVariableDeclaration(
	                tempName,
	                /*exclamationToken*/
	                void 0,
	                typeToTypeNodeHelper(staticType, context)
	              )
	            ], 2 /* Const */)
	          );
	          addResult(statement, 0 /* None */);
	          return factory.createExpressionWithTypeArguments(
	            factory.createIdentifier(tempName),
	            /*typeArguments*/
	            void 0
	          );
	        }
	        function trySerializeAsTypeReference(t, flags) {
	          let typeArgs;
	          let reference;
	          if (t.target && isSymbolAccessibleByFlags(t.target.symbol, enclosingDeclaration, flags)) {
	            typeArgs = map(getTypeArguments(t), (t2) => typeToTypeNodeHelper(t2, context));
	            reference = symbolToExpression(t.target.symbol, context, 788968 /* Type */);
	          } else if (t.symbol && isSymbolAccessibleByFlags(t.symbol, enclosingDeclaration, flags)) {
	            reference = symbolToExpression(t.symbol, context, 788968 /* Type */);
	          }
	          if (reference) {
	            return factory.createExpressionWithTypeArguments(reference, typeArgs);
	          }
	        }
	        function serializeImplementedType(t) {
	          const ref = trySerializeAsTypeReference(t, 788968 /* Type */);
	          if (ref) {
	            return ref;
	          }
	          if (t.symbol) {
	            return factory.createExpressionWithTypeArguments(
	              symbolToExpression(t.symbol, context, 788968 /* Type */),
	              /*typeArguments*/
	              void 0
	            );
	          }
	        }
	        function getUnusedName(input, symbol) {
	          var _a2, _b;
	          const id = symbol ? getSymbolId(symbol) : void 0;
	          if (id) {
	            if (context.remappedSymbolNames.has(id)) {
	              return context.remappedSymbolNames.get(id);
	            }
	          }
	          if (symbol) {
	            input = getNameCandidateWorker(symbol, input);
	          }
	          let i = 0;
	          const original = input;
	          while ((_a2 = context.usedSymbolNames) == null ? void 0 : _a2.has(input)) {
	            i++;
	            input = `${original}_${i}`;
	          }
	          (_b = context.usedSymbolNames) == null ? void 0 : _b.add(input);
	          if (id) {
	            context.remappedSymbolNames.set(id, input);
	          }
	          return input;
	        }
	        function getNameCandidateWorker(symbol, localName) {
	          if (localName === "default" /* Default */ || localName === "__class" /* Class */ || localName === "__function" /* Function */) {
	            const flags = context.flags;
	            context.flags |= 16777216 /* InInitialEntityName */;
	            const nameCandidate = getNameOfSymbolAsWritten(symbol, context);
	            context.flags = flags;
	            localName = nameCandidate.length > 0 && isSingleOrDoubleQuote(nameCandidate.charCodeAt(0)) ? stripQuotes(nameCandidate) : nameCandidate;
	          }
	          if (localName === "default" /* Default */) {
	            localName = "_default";
	          } else if (localName === "export=" /* ExportEquals */) {
	            localName = "_exports";
	          }
	          localName = isIdentifierText(localName, languageVersion) && !isStringANonContextualKeyword(localName) ? localName : "_" + localName.replace(/[^a-zA-Z0-9]/g, "_");
	          return localName;
	        }
	        function getInternalSymbolName(symbol, localName) {
	          const id = getSymbolId(symbol);
	          if (context.remappedSymbolNames.has(id)) {
	            return context.remappedSymbolNames.get(id);
	          }
	          localName = getNameCandidateWorker(symbol, localName);
	          context.remappedSymbolNames.set(id, localName);
	          return localName;
	        }
	      }
	    }
	    function typePredicateToString(typePredicate, enclosingDeclaration, flags = 16384 /* UseAliasDefinedOutsideCurrentScope */, writer) {
	      return writer ? typePredicateToStringWorker(writer).getText() : usingSingleLineStringWriter(typePredicateToStringWorker);
	      function typePredicateToStringWorker(writer2) {
	        const predicate = factory.createTypePredicateNode(
	          typePredicate.kind === 2 /* AssertsThis */ || typePredicate.kind === 3 /* AssertsIdentifier */ ? factory.createToken(131 /* AssertsKeyword */) : void 0,
	          typePredicate.kind === 1 /* Identifier */ || typePredicate.kind === 3 /* AssertsIdentifier */ ? factory.createIdentifier(typePredicate.parameterName) : factory.createThisTypeNode(),
	          typePredicate.type && nodeBuilder.typeToTypeNode(typePredicate.type, enclosingDeclaration, toNodeBuilderFlags(flags) | 70221824 /* IgnoreErrors */ | 512 /* WriteTypeParametersInQualifiedName */)
	          // TODO: GH#18217
	        );
	        const printer = createPrinterWithRemoveComments();
	        const sourceFile = enclosingDeclaration && getSourceFileOfNode(enclosingDeclaration);
	        printer.writeNode(
	          4 /* Unspecified */,
	          predicate,
	          /*sourceFile*/
	          sourceFile,
	          writer2
	        );
	        return writer2;
	      }
	    }
	    function formatUnionTypes(types) {
	      const result = [];
	      let flags = 0;
	      for (let i = 0; i < types.length; i++) {
	        const t = types[i];
	        flags |= t.flags;
	        if (!(t.flags & 98304 /* Nullable */)) {
	          if (t.flags & (512 /* BooleanLiteral */ | 1056 /* EnumLike */)) {
	            const baseType = t.flags & 512 /* BooleanLiteral */ ? booleanType : getBaseTypeOfEnumLikeType(t);
	            if (baseType.flags & 1048576 /* Union */) {
	              const count = baseType.types.length;
	              if (i + count <= types.length && getRegularTypeOfLiteralType(types[i + count - 1]) === getRegularTypeOfLiteralType(baseType.types[count - 1])) {
	                result.push(baseType);
	                i += count - 1;
	                continue;
	              }
	            }
	          }
	          result.push(t);
	        }
	      }
	      if (flags & 65536 /* Null */)
	        result.push(nullType);
	      if (flags & 32768 /* Undefined */)
	        result.push(undefinedType);
	      return result || types;
	    }
	    function visibilityToString(flags) {
	      if (flags === 2 /* Private */) {
	        return "private";
	      }
	      if (flags === 4 /* Protected */) {
	        return "protected";
	      }
	      return "public";
	    }
	    function getTypeAliasForTypeLiteral(type) {
	      if (type.symbol && type.symbol.flags & 2048 /* TypeLiteral */ && type.symbol.declarations) {
	        const node = walkUpParenthesizedTypes(type.symbol.declarations[0].parent);
	        if (isTypeAliasDeclaration(node)) {
	          return getSymbolOfDeclaration(node);
	        }
	      }
	      return void 0;
	    }
	    function isTopLevelInExternalModuleAugmentation(node) {
	      return node && node.parent && node.parent.kind === 268 /* ModuleBlock */ && isExternalModuleAugmentation(node.parent.parent);
	    }
	    function isDefaultBindingContext(location) {
	      return location.kind === 312 /* SourceFile */ || isAmbientModule(location);
	    }
	    function getNameOfSymbolFromNameType(symbol, context) {
	      const nameType = getSymbolLinks(symbol).nameType;
	      if (nameType) {
	        if (nameType.flags & 384 /* StringOrNumberLiteral */) {
	          const name = "" + nameType.value;
	          if (!isIdentifierText(name, getEmitScriptTarget(compilerOptions)) && !isNumericLiteralName(name)) {
	            return `"${escapeString(name, 34 /* doubleQuote */)}"`;
	          }
	          if (isNumericLiteralName(name) && startsWith(name, "-")) {
	            return `[${name}]`;
	          }
	          return name;
	        }
	        if (nameType.flags & 8192 /* UniqueESSymbol */) {
	          return `[${getNameOfSymbolAsWritten(nameType.symbol, context)}]`;
	        }
	      }
	    }
	    function getNameOfSymbolAsWritten(symbol, context) {
	      var _a;
	      if ((_a = context == null ? void 0 : context.remappedSymbolReferences) == null ? void 0 : _a.has(getSymbolId(symbol))) {
	        symbol = context.remappedSymbolReferences.get(getSymbolId(symbol));
	      }
	      if (context && symbol.escapedName === "default" /* Default */ && !(context.flags & 16384 /* UseAliasDefinedOutsideCurrentScope */) && // If it's not the first part of an entity name, it must print as `default`
	      (!(context.flags & 16777216 /* InInitialEntityName */) || // if the symbol is synthesized, it will only be referenced externally it must print as `default`
	      !symbol.declarations || // if not in the same binding context (source file, module declaration), it must print as `default`
	      context.enclosingDeclaration && findAncestor(symbol.declarations[0], isDefaultBindingContext) !== findAncestor(context.enclosingDeclaration, isDefaultBindingContext))) {
	        return "default";
	      }
	      if (symbol.declarations && symbol.declarations.length) {
	        let declaration = firstDefined(symbol.declarations, (d) => getNameOfDeclaration(d) ? d : void 0);
	        const name2 = declaration && getNameOfDeclaration(declaration);
	        if (declaration && name2) {
	          if (isCallExpression(declaration) && isBindableObjectDefinePropertyCall(declaration)) {
	            return symbolName(symbol);
	          }
	          if (isComputedPropertyName(name2) && !(getCheckFlags(symbol) & 4096 /* Late */)) {
	            const nameType = getSymbolLinks(symbol).nameType;
	            if (nameType && nameType.flags & 384 /* StringOrNumberLiteral */) {
	              const result = getNameOfSymbolFromNameType(symbol, context);
	              if (result !== void 0) {
	                return result;
	              }
	            }
	          }
	          return declarationNameToString(name2);
	        }
	        if (!declaration) {
	          declaration = symbol.declarations[0];
	        }
	        if (declaration.parent && declaration.parent.kind === 260 /* VariableDeclaration */) {
	          return declarationNameToString(declaration.parent.name);
	        }
	        switch (declaration.kind) {
	          case 231 /* ClassExpression */:
	          case 218 /* FunctionExpression */:
	          case 219 /* ArrowFunction */:
	            if (context && !context.encounteredError && !(context.flags & 131072 /* AllowAnonymousIdentifier */)) {
	              context.encounteredError = true;
	            }
	            return declaration.kind === 231 /* ClassExpression */ ? "(Anonymous class)" : "(Anonymous function)";
	        }
	      }
	      const name = getNameOfSymbolFromNameType(symbol, context);
	      return name !== void 0 ? name : symbolName(symbol);
	    }
	    function isDeclarationVisible(node) {
	      if (node) {
	        const links = getNodeLinks(node);
	        if (links.isVisible === void 0) {
	          links.isVisible = !!determineIfDeclarationIsVisible();
	        }
	        return links.isVisible;
	      }
	      return false;
	      function determineIfDeclarationIsVisible() {
	        switch (node.kind) {
	          case 345 /* JSDocCallbackTag */:
	          case 353 /* JSDocTypedefTag */:
	          case 347 /* JSDocEnumTag */:
	            return !!(node.parent && node.parent.parent && node.parent.parent.parent && isSourceFile(node.parent.parent.parent));
	          case 208 /* BindingElement */:
	            return isDeclarationVisible(node.parent.parent);
	          case 260 /* VariableDeclaration */:
	            if (isBindingPattern(node.name) && !node.name.elements.length) {
	              return false;
	            }
	          case 267 /* ModuleDeclaration */:
	          case 263 /* ClassDeclaration */:
	          case 264 /* InterfaceDeclaration */:
	          case 265 /* TypeAliasDeclaration */:
	          case 262 /* FunctionDeclaration */:
	          case 266 /* EnumDeclaration */:
	          case 271 /* ImportEqualsDeclaration */:
	            if (isExternalModuleAugmentation(node)) {
	              return true;
	            }
	            const parent2 = getDeclarationContainer(node);
	            if (!(getCombinedModifierFlagsCached(node) & 32 /* Export */) && !(node.kind !== 271 /* ImportEqualsDeclaration */ && parent2.kind !== 312 /* SourceFile */ && parent2.flags & 33554432 /* Ambient */)) {
	              return isGlobalSourceFile(parent2);
	            }
	            return isDeclarationVisible(parent2);
	          case 172 /* PropertyDeclaration */:
	          case 171 /* PropertySignature */:
	          case 177 /* GetAccessor */:
	          case 178 /* SetAccessor */:
	          case 174 /* MethodDeclaration */:
	          case 173 /* MethodSignature */:
	            if (hasEffectiveModifier(node, 2 /* Private */ | 4 /* Protected */)) {
	              return false;
	            }
	          case 176 /* Constructor */:
	          case 180 /* ConstructSignature */:
	          case 179 /* CallSignature */:
	          case 181 /* IndexSignature */:
	          case 169 /* Parameter */:
	          case 268 /* ModuleBlock */:
	          case 184 /* FunctionType */:
	          case 185 /* ConstructorType */:
	          case 187 /* TypeLiteral */:
	          case 183 /* TypeReference */:
	          case 188 /* ArrayType */:
	          case 189 /* TupleType */:
	          case 192 /* UnionType */:
	          case 193 /* IntersectionType */:
	          case 196 /* ParenthesizedType */:
	          case 202 /* NamedTupleMember */:
	            return isDeclarationVisible(node.parent);
	          case 273 /* ImportClause */:
	          case 274 /* NamespaceImport */:
	          case 276 /* ImportSpecifier */:
	            return false;
	          case 168 /* TypeParameter */:
	          case 312 /* SourceFile */:
	          case 270 /* NamespaceExportDeclaration */:
	            return true;
	          case 277 /* ExportAssignment */:
	            return false;
	          default:
	            return false;
	        }
	      }
	    }
	    function collectLinkedAliases(node, setVisibility) {
	      let exportSymbol;
	      if (node.parent && node.parent.kind === 277 /* ExportAssignment */) {
	        exportSymbol = resolveName(
	          node,
	          node.escapedText,
	          111551 /* Value */ | 788968 /* Type */ | 1920 /* Namespace */ | 2097152 /* Alias */,
	          /*nameNotFoundMessage*/
	          void 0,
	          node,
	          /*isUse*/
	          false
	        );
	      } else if (node.parent.kind === 281 /* ExportSpecifier */) {
	        exportSymbol = getTargetOfExportSpecifier(node.parent, 111551 /* Value */ | 788968 /* Type */ | 1920 /* Namespace */ | 2097152 /* Alias */);
	      }
	      let result;
	      let visited;
	      if (exportSymbol) {
	        visited = /* @__PURE__ */ new Set();
	        visited.add(getSymbolId(exportSymbol));
	        buildVisibleNodeList(exportSymbol.declarations);
	      }
	      return result;
	      function buildVisibleNodeList(declarations) {
	        forEach(declarations, (declaration) => {
	          const resultNode = getAnyImportSyntax(declaration) || declaration;
	          if (setVisibility) {
	            getNodeLinks(declaration).isVisible = true;
	          } else {
	            result = result || [];
	            pushIfUnique(result, resultNode);
	          }
	          if (isInternalModuleImportEqualsDeclaration(declaration)) {
	            const internalModuleReference = declaration.moduleReference;
	            const firstIdentifier = getFirstIdentifier(internalModuleReference);
	            const importSymbol = resolveName(
	              declaration,
	              firstIdentifier.escapedText,
	              111551 /* Value */ | 788968 /* Type */ | 1920 /* Namespace */,
	              /*nameNotFoundMessage*/
	              void 0,
	              /*nameArg*/
	              void 0,
	              /*isUse*/
	              false
	            );
	            if (importSymbol && visited) {
	              if (tryAddToSet(visited, getSymbolId(importSymbol))) {
	                buildVisibleNodeList(importSymbol.declarations);
	              }
	            }
	          }
	        });
	      }
	    }
	    function pushTypeResolution(target, propertyName) {
	      const resolutionCycleStartIndex = findResolutionCycleStartIndex(target, propertyName);
	      if (resolutionCycleStartIndex >= 0) {
	        const { length: length2 } = resolutionTargets;
	        for (let i = resolutionCycleStartIndex; i < length2; i++) {
	          resolutionResults[i] = false;
	        }
	        return false;
	      }
	      resolutionTargets.push(target);
	      resolutionResults.push(
	        /*items*/
	        true
	      );
	      resolutionPropertyNames.push(propertyName);
	      return true;
	    }
	    function findResolutionCycleStartIndex(target, propertyName) {
	      for (let i = resolutionTargets.length - 1; i >= resolutionStart; i--) {
	        if (resolutionTargetHasProperty(resolutionTargets[i], resolutionPropertyNames[i])) {
	          return -1;
	        }
	        if (resolutionTargets[i] === target && resolutionPropertyNames[i] === propertyName) {
	          return i;
	        }
	      }
	      return -1;
	    }
	    function resolutionTargetHasProperty(target, propertyName) {
	      switch (propertyName) {
	        case 0 /* Type */:
	          return !!getSymbolLinks(target).type;
	        case 5 /* EnumTagType */:
	          return !!getNodeLinks(target).resolvedEnumType;
	        case 2 /* DeclaredType */:
	          return !!getSymbolLinks(target).declaredType;
	        case 1 /* ResolvedBaseConstructorType */:
	          return !!target.resolvedBaseConstructorType;
	        case 3 /* ResolvedReturnType */:
	          return !!target.resolvedReturnType;
	        case 4 /* ImmediateBaseConstraint */:
	          return !!target.immediateBaseConstraint;
	        case 6 /* ResolvedTypeArguments */:
	          return !!target.resolvedTypeArguments;
	        case 7 /* ResolvedBaseTypes */:
	          return !!target.baseTypesResolved;
	        case 8 /* WriteType */:
	          return !!getSymbolLinks(target).writeType;
	        case 9 /* ParameterInitializerContainsUndefined */:
	          return getNodeLinks(target).parameterInitializerContainsUndefined !== void 0;
	      }
	      return Debug.assertNever(propertyName);
	    }
	    function popTypeResolution() {
	      resolutionTargets.pop();
	      resolutionPropertyNames.pop();
	      return resolutionResults.pop();
	    }
	    function getDeclarationContainer(node) {
	      return findAncestor(getRootDeclaration(node), (node2) => {
	        switch (node2.kind) {
	          case 260 /* VariableDeclaration */:
	          case 261 /* VariableDeclarationList */:
	          case 276 /* ImportSpecifier */:
	          case 275 /* NamedImports */:
	          case 274 /* NamespaceImport */:
	          case 273 /* ImportClause */:
	            return false;
	          default:
	            return true;
	        }
	      }).parent;
	    }
	    function getTypeOfPrototypeProperty(prototype) {
	      const classType = getDeclaredTypeOfSymbol(getParentOfSymbol(prototype));
	      return classType.typeParameters ? createTypeReference(classType, map(classType.typeParameters, (_) => anyType)) : classType;
	    }
	    function getTypeOfPropertyOfType(type, name) {
	      const prop = getPropertyOfType(type, name);
	      return prop ? getTypeOfSymbol(prop) : void 0;
	    }
	    function getTypeOfPropertyOrIndexSignatureOfType(type, name) {
	      var _a;
	      let propType;
	      return getTypeOfPropertyOfType(type, name) || (propType = (_a = getApplicableIndexInfoForName(type, name)) == null ? void 0 : _a.type) && addOptionality(
	        propType,
	        /*isProperty*/
	        true,
	        /*isOptional*/
	        true
	      );
	    }
	    function isTypeAny(type) {
	      return type && (type.flags & 1 /* Any */) !== 0;
	    }
	    function isErrorType(type) {
	      return type === errorType || !!(type.flags & 1 /* Any */ && type.aliasSymbol);
	    }
	    function getTypeForBindingElementParent(node, checkMode) {
	      if (checkMode !== 0 /* Normal */) {
	        return getTypeForVariableLikeDeclaration(
	          node,
	          /*includeOptionality*/
	          false,
	          checkMode
	        );
	      }
	      const symbol = getSymbolOfDeclaration(node);
	      return symbol && getSymbolLinks(symbol).type || getTypeForVariableLikeDeclaration(
	        node,
	        /*includeOptionality*/
	        false,
	        checkMode
	      );
	    }
	    function getRestType(source, properties, symbol) {
	      source = filterType(source, (t) => !(t.flags & 98304 /* Nullable */));
	      if (source.flags & 131072 /* Never */) {
	        return emptyObjectType;
	      }
	      if (source.flags & 1048576 /* Union */) {
	        return mapType(source, (t) => getRestType(t, properties, symbol));
	      }
	      let omitKeyType = getUnionType(map(properties, getLiteralTypeFromPropertyName));
	      const spreadableProperties = [];
	      const unspreadableToRestKeys = [];
	      for (const prop of getPropertiesOfType(source)) {
	        const literalTypeFromProperty = getLiteralTypeFromProperty(prop, 8576 /* StringOrNumberLiteralOrUnique */);
	        if (!isTypeAssignableTo(literalTypeFromProperty, omitKeyType) && !(getDeclarationModifierFlagsFromSymbol(prop) & (2 /* Private */ | 4 /* Protected */)) && isSpreadableProperty(prop)) {
	          spreadableProperties.push(prop);
	        } else {
	          unspreadableToRestKeys.push(literalTypeFromProperty);
	        }
	      }
	      if (isGenericObjectType(source) || isGenericIndexType(omitKeyType)) {
	        if (unspreadableToRestKeys.length) {
	          omitKeyType = getUnionType([omitKeyType, ...unspreadableToRestKeys]);
	        }
	        if (omitKeyType.flags & 131072 /* Never */) {
	          return source;
	        }
	        const omitTypeAlias = getGlobalOmitSymbol();
	        if (!omitTypeAlias) {
	          return errorType;
	        }
	        return getTypeAliasInstantiation(omitTypeAlias, [source, omitKeyType]);
	      }
	      const members = createSymbolTable();
	      for (const prop of spreadableProperties) {
	        members.set(prop.escapedName, getSpreadSymbol(
	          prop,
	          /*readonly*/
	          false
	        ));
	      }
	      const result = createAnonymousType(symbol, members, emptyArray, emptyArray, getIndexInfosOfType(source));
	      result.objectFlags |= 4194304 /* ObjectRestType */;
	      return result;
	    }
	    function isGenericTypeWithUndefinedConstraint(type) {
	      return !!(type.flags & 465829888 /* Instantiable */) && maybeTypeOfKind(getBaseConstraintOfType(type) || unknownType, 32768 /* Undefined */);
	    }
	    function getNonUndefinedType(type) {
	      const typeOrConstraint = someType(type, isGenericTypeWithUndefinedConstraint) ? mapType(type, (t) => t.flags & 465829888 /* Instantiable */ ? getBaseConstraintOrType(t) : t) : type;
	      return getTypeWithFacts(typeOrConstraint, 524288 /* NEUndefined */);
	    }
	    function getFlowTypeOfDestructuring(node, declaredType) {
	      const reference = getSyntheticElementAccess(node);
	      return reference ? getFlowTypeOfReference(reference, declaredType) : declaredType;
	    }
	    function getSyntheticElementAccess(node) {
	      const parentAccess = getParentElementAccess(node);
	      if (parentAccess && canHaveFlowNode(parentAccess) && parentAccess.flowNode) {
	        const propName = getDestructuringPropertyName(node);
	        if (propName) {
	          const literal = setTextRange(parseNodeFactory.createStringLiteral(propName), node);
	          const lhsExpr = isLeftHandSideExpression(parentAccess) ? parentAccess : parseNodeFactory.createParenthesizedExpression(parentAccess);
	          const result = setTextRange(parseNodeFactory.createElementAccessExpression(lhsExpr, literal), node);
	          setParent(literal, result);
	          setParent(result, node);
	          if (lhsExpr !== parentAccess) {
	            setParent(lhsExpr, result);
	          }
	          result.flowNode = parentAccess.flowNode;
	          return result;
	        }
	      }
	    }
	    function getParentElementAccess(node) {
	      const ancestor = node.parent.parent;
	      switch (ancestor.kind) {
	        case 208 /* BindingElement */:
	        case 303 /* PropertyAssignment */:
	          return getSyntheticElementAccess(ancestor);
	        case 209 /* ArrayLiteralExpression */:
	          return getSyntheticElementAccess(node.parent);
	        case 260 /* VariableDeclaration */:
	          return ancestor.initializer;
	        case 226 /* BinaryExpression */:
	          return ancestor.right;
	      }
	    }
	    function getDestructuringPropertyName(node) {
	      const parent2 = node.parent;
	      if (node.kind === 208 /* BindingElement */ && parent2.kind === 206 /* ObjectBindingPattern */) {
	        return getLiteralPropertyNameText(node.propertyName || node.name);
	      }
	      if (node.kind === 303 /* PropertyAssignment */ || node.kind === 304 /* ShorthandPropertyAssignment */) {
	        return getLiteralPropertyNameText(node.name);
	      }
	      return "" + parent2.elements.indexOf(node);
	    }
	    function getLiteralPropertyNameText(name) {
	      const type = getLiteralTypeFromPropertyName(name);
	      return type.flags & (128 /* StringLiteral */ | 256 /* NumberLiteral */) ? "" + type.value : void 0;
	    }
	    function getTypeForBindingElement(declaration) {
	      const checkMode = declaration.dotDotDotToken ? 32 /* RestBindingElement */ : 0 /* Normal */;
	      const parentType = getTypeForBindingElementParent(declaration.parent.parent, checkMode);
	      return parentType && getBindingElementTypeFromParentType(
	        declaration,
	        parentType,
	        /*noTupleBoundsCheck*/
	        false
	      );
	    }
	    function getBindingElementTypeFromParentType(declaration, parentType, noTupleBoundsCheck) {
	      if (isTypeAny(parentType)) {
	        return parentType;
	      }
	      const pattern = declaration.parent;
	      if (strictNullChecks && declaration.flags & 33554432 /* Ambient */ && isParameterDeclaration(declaration)) {
	        parentType = getNonNullableType(parentType);
	      } else if (strictNullChecks && pattern.parent.initializer && !hasTypeFacts(getTypeOfInitializer(pattern.parent.initializer), 65536 /* EQUndefined */)) {
	        parentType = getTypeWithFacts(parentType, 524288 /* NEUndefined */);
	      }
	      let type;
	      if (pattern.kind === 206 /* ObjectBindingPattern */) {
	        if (declaration.dotDotDotToken) {
	          parentType = getReducedType(parentType);
	          if (parentType.flags & 2 /* Unknown */ || !isValidSpreadType(parentType)) {
	            error2(declaration, Diagnostics.Rest_types_may_only_be_created_from_object_types);
	            return errorType;
	          }
	          const literalMembers = [];
	          for (const element of pattern.elements) {
	            if (!element.dotDotDotToken) {
	              literalMembers.push(element.propertyName || element.name);
	            }
	          }
	          type = getRestType(parentType, literalMembers, declaration.symbol);
	        } else {
	          const name = declaration.propertyName || declaration.name;
	          const indexType = getLiteralTypeFromPropertyName(name);
	          const declaredType = getIndexedAccessType(parentType, indexType, 32 /* ExpressionPosition */, name);
	          type = getFlowTypeOfDestructuring(declaration, declaredType);
	        }
	      } else {
	        const elementType = checkIteratedTypeOrElementType(65 /* Destructuring */ | (declaration.dotDotDotToken ? 0 : 128 /* PossiblyOutOfBounds */), parentType, undefinedType, pattern);
	        const index = pattern.elements.indexOf(declaration);
	        if (declaration.dotDotDotToken) {
	          const baseConstraint = mapType(parentType, (t) => t.flags & 58982400 /* InstantiableNonPrimitive */ ? getBaseConstraintOrType(t) : t);
	          type = everyType(baseConstraint, isTupleType) ? mapType(baseConstraint, (t) => sliceTupleType(t, index)) : createArrayType(elementType);
	        } else if (isArrayLikeType(parentType)) {
	          const indexType = getNumberLiteralType(index);
	          const accessFlags = 32 /* ExpressionPosition */ | (noTupleBoundsCheck || hasDefaultValue(declaration) ? 16 /* NoTupleBoundsCheck */ : 0);
	          const declaredType = getIndexedAccessTypeOrUndefined(parentType, indexType, accessFlags, declaration.name) || errorType;
	          type = getFlowTypeOfDestructuring(declaration, declaredType);
	        } else {
	          type = elementType;
	        }
	      }
	      if (!declaration.initializer) {
	        return type;
	      }
	      if (getEffectiveTypeAnnotationNode(walkUpBindingElementsAndPatterns(declaration))) {
	        return strictNullChecks && !hasTypeFacts(checkDeclarationInitializer(declaration, 0 /* Normal */), 16777216 /* IsUndefined */) ? getNonUndefinedType(type) : type;
	      }
	      return widenTypeInferredFromInitializer(declaration, getUnionType([getNonUndefinedType(type), checkDeclarationInitializer(declaration, 0 /* Normal */)], 2 /* Subtype */));
	    }
	    function getTypeForDeclarationFromJSDocComment(declaration) {
	      const jsdocType = getJSDocType(declaration);
	      if (jsdocType) {
	        return getTypeFromTypeNode(jsdocType);
	      }
	      return void 0;
	    }
	    function isNullOrUndefined3(node) {
	      const expr = skipParentheses(
	        node,
	        /*excludeJSDocTypeAssertions*/
	        true
	      );
	      return expr.kind === 106 /* NullKeyword */ || expr.kind === 80 /* Identifier */ && getResolvedSymbol(expr) === undefinedSymbol;
	    }
	    function isEmptyArrayLiteral2(node) {
	      const expr = skipParentheses(
	        node,
	        /*excludeJSDocTypeAssertions*/
	        true
	      );
	      return expr.kind === 209 /* ArrayLiteralExpression */ && expr.elements.length === 0;
	    }
	    function addOptionality(type, isProperty = false, isOptional = true) {
	      return strictNullChecks && isOptional ? getOptionalType(type, isProperty) : type;
	    }
	    function getTypeForVariableLikeDeclaration(declaration, includeOptionality, checkMode) {
	      if (isVariableDeclaration(declaration) && declaration.parent.parent.kind === 249 /* ForInStatement */) {
	        const indexType = getIndexType(getNonNullableTypeIfNeeded(checkExpression(
	          declaration.parent.parent.expression,
	          /*checkMode*/
	          checkMode
	        )));
	        return indexType.flags & (262144 /* TypeParameter */ | 4194304 /* Index */) ? getExtractStringType(indexType) : stringType;
	      }
	      if (isVariableDeclaration(declaration) && declaration.parent.parent.kind === 250 /* ForOfStatement */) {
	        const forOfStatement = declaration.parent.parent;
	        return checkRightHandSideOfForOf(forOfStatement) || anyType;
	      }
	      if (isBindingPattern(declaration.parent)) {
	        return getTypeForBindingElement(declaration);
	      }
	      const isProperty = isPropertyDeclaration(declaration) && !hasAccessorModifier(declaration) || isPropertySignature(declaration) || isJSDocPropertyTag(declaration);
	      const isOptional = includeOptionality && isOptionalDeclaration(declaration);
	      const declaredType = tryGetTypeFromEffectiveTypeNode(declaration);
	      if (isCatchClauseVariableDeclarationOrBindingElement(declaration)) {
	        if (declaredType) {
	          return isTypeAny(declaredType) || declaredType === unknownType ? declaredType : errorType;
	        }
	        return useUnknownInCatchVariables ? unknownType : anyType;
	      }
	      if (declaredType) {
	        return addOptionality(declaredType, isProperty, isOptional);
	      }
	      if ((noImplicitAny || isInJSFile(declaration)) && isVariableDeclaration(declaration) && !isBindingPattern(declaration.name) && !(getCombinedModifierFlagsCached(declaration) & 32 /* Export */) && !(declaration.flags & 33554432 /* Ambient */)) {
	        if (!(getCombinedNodeFlagsCached(declaration) & 6 /* Constant */) && (!declaration.initializer || isNullOrUndefined3(declaration.initializer))) {
	          return autoType;
	        }
	        if (declaration.initializer && isEmptyArrayLiteral2(declaration.initializer)) {
	          return autoArrayType;
	        }
	      }
	      if (isParameter(declaration)) {
	        const func = declaration.parent;
	        if (func.kind === 178 /* SetAccessor */ && hasBindableName(func)) {
	          const getter = getDeclarationOfKind(getSymbolOfDeclaration(declaration.parent), 177 /* GetAccessor */);
	          if (getter) {
	            const getterSignature = getSignatureFromDeclaration(getter);
	            const thisParameter = getAccessorThisParameter(func);
	            if (thisParameter && declaration === thisParameter) {
	              Debug.assert(!thisParameter.type);
	              return getTypeOfSymbol(getterSignature.thisParameter);
	            }
	            return getReturnTypeOfSignature(getterSignature);
	          }
	        }
	        const parameterTypeOfTypeTag = getParameterTypeOfTypeTag(func, declaration);
	        if (parameterTypeOfTypeTag)
	          return parameterTypeOfTypeTag;
	        const type = declaration.symbol.escapedName === "this" /* This */ ? getContextualThisParameterType(func) : getContextuallyTypedParameterType(declaration);
	        if (type) {
	          return addOptionality(
	            type,
	            /*isProperty*/
	            false,
	            isOptional
	          );
	        }
	      }
	      if (hasOnlyExpressionInitializer(declaration) && !!declaration.initializer) {
	        if (isInJSFile(declaration) && !isParameter(declaration)) {
	          const containerObjectType = getJSContainerObjectType(declaration, getSymbolOfDeclaration(declaration), getDeclaredExpandoInitializer(declaration));
	          if (containerObjectType) {
	            return containerObjectType;
	          }
	        }
	        const type = widenTypeInferredFromInitializer(declaration, checkDeclarationInitializer(declaration, checkMode));
	        return addOptionality(type, isProperty, isOptional);
	      }
	      if (isPropertyDeclaration(declaration) && (noImplicitAny || isInJSFile(declaration))) {
	        if (!hasStaticModifier(declaration)) {
	          const constructor = findConstructorDeclaration(declaration.parent);
	          const type = constructor ? getFlowTypeInConstructor(declaration.symbol, constructor) : getEffectiveModifierFlags(declaration) & 128 /* Ambient */ ? getTypeOfPropertyInBaseClass(declaration.symbol) : void 0;
	          return type && addOptionality(
	            type,
	            /*isProperty*/
	            true,
	            isOptional
	          );
	        } else {
	          const staticBlocks = filter(declaration.parent.members, isClassStaticBlockDeclaration);
	          const type = staticBlocks.length ? getFlowTypeInStaticBlocks(declaration.symbol, staticBlocks) : getEffectiveModifierFlags(declaration) & 128 /* Ambient */ ? getTypeOfPropertyInBaseClass(declaration.symbol) : void 0;
	          return type && addOptionality(
	            type,
	            /*isProperty*/
	            true,
	            isOptional
	          );
	        }
	      }
	      if (isJsxAttribute(declaration)) {
	        return trueType;
	      }
	      if (isBindingPattern(declaration.name)) {
	        return getTypeFromBindingPattern(
	          declaration.name,
	          /*includePatternInType*/
	          false,
	          /*reportErrors*/
	          true
	        );
	      }
	      return void 0;
	    }
	    function isConstructorDeclaredProperty(symbol) {
	      if (symbol.valueDeclaration && isBinaryExpression(symbol.valueDeclaration)) {
	        const links = getSymbolLinks(symbol);
	        if (links.isConstructorDeclaredProperty === void 0) {
	          links.isConstructorDeclaredProperty = false;
	          links.isConstructorDeclaredProperty = !!getDeclaringConstructor(symbol) && every(symbol.declarations, (declaration) => isBinaryExpression(declaration) && isPossiblyAliasedThisProperty(declaration) && (declaration.left.kind !== 212 /* ElementAccessExpression */ || isStringOrNumericLiteralLike(declaration.left.argumentExpression)) && !getAnnotatedTypeForAssignmentDeclaration(
	            /*declaredType*/
	            void 0,
	            declaration,
	            symbol,
	            declaration
	          ));
	        }
	        return links.isConstructorDeclaredProperty;
	      }
	      return false;
	    }
	    function isAutoTypedProperty(symbol) {
	      const declaration = symbol.valueDeclaration;
	      return declaration && isPropertyDeclaration(declaration) && !getEffectiveTypeAnnotationNode(declaration) && !declaration.initializer && (noImplicitAny || isInJSFile(declaration));
	    }
	    function getDeclaringConstructor(symbol) {
	      if (!symbol.declarations) {
	        return;
	      }
	      for (const declaration of symbol.declarations) {
	        const container = getThisContainer(
	          declaration,
	          /*includeArrowFunctions*/
	          false,
	          /*includeClassComputedPropertyName*/
	          false
	        );
	        if (container && (container.kind === 176 /* Constructor */ || isJSConstructor(container))) {
	          return container;
	        }
	      }
	    }
	    function getFlowTypeFromCommonJSExport(symbol) {
	      const file = getSourceFileOfNode(symbol.declarations[0]);
	      const accessName = unescapeLeadingUnderscores(symbol.escapedName);
	      const areAllModuleExports = symbol.declarations.every((d) => isInJSFile(d) && isAccessExpression(d) && isModuleExportsAccessExpression(d.expression));
	      const reference = areAllModuleExports ? factory.createPropertyAccessExpression(factory.createPropertyAccessExpression(factory.createIdentifier("module"), factory.createIdentifier("exports")), accessName) : factory.createPropertyAccessExpression(factory.createIdentifier("exports"), accessName);
	      if (areAllModuleExports) {
	        setParent(reference.expression.expression, reference.expression);
	      }
	      setParent(reference.expression, reference);
	      setParent(reference, file);
	      reference.flowNode = file.endFlowNode;
	      return getFlowTypeOfReference(reference, autoType, undefinedType);
	    }
	    function getFlowTypeInStaticBlocks(symbol, staticBlocks) {
	      const accessName = startsWith(symbol.escapedName, "__#") ? factory.createPrivateIdentifier(symbol.escapedName.split("@")[1]) : unescapeLeadingUnderscores(symbol.escapedName);
	      for (const staticBlock of staticBlocks) {
	        const reference = factory.createPropertyAccessExpression(factory.createThis(), accessName);
	        setParent(reference.expression, reference);
	        setParent(reference, staticBlock);
	        reference.flowNode = staticBlock.returnFlowNode;
	        const flowType = getFlowTypeOfProperty(reference, symbol);
	        if (noImplicitAny && (flowType === autoType || flowType === autoArrayType)) {
	          error2(symbol.valueDeclaration, Diagnostics.Member_0_implicitly_has_an_1_type, symbolToString(symbol), typeToString(flowType));
	        }
	        if (everyType(flowType, isNullableType)) {
	          continue;
	        }
	        return convertAutoToAny(flowType);
	      }
	    }
	    function getFlowTypeInConstructor(symbol, constructor) {
	      const accessName = startsWith(symbol.escapedName, "__#") ? factory.createPrivateIdentifier(symbol.escapedName.split("@")[1]) : unescapeLeadingUnderscores(symbol.escapedName);
	      const reference = factory.createPropertyAccessExpression(factory.createThis(), accessName);
	      setParent(reference.expression, reference);
	      setParent(reference, constructor);
	      reference.flowNode = constructor.returnFlowNode;
	      const flowType = getFlowTypeOfProperty(reference, symbol);
	      if (noImplicitAny && (flowType === autoType || flowType === autoArrayType)) {
	        error2(symbol.valueDeclaration, Diagnostics.Member_0_implicitly_has_an_1_type, symbolToString(symbol), typeToString(flowType));
	      }
	      return everyType(flowType, isNullableType) ? void 0 : convertAutoToAny(flowType);
	    }
	    function getFlowTypeOfProperty(reference, prop) {
	      const initialType = (prop == null ? void 0 : prop.valueDeclaration) && (!isAutoTypedProperty(prop) || getEffectiveModifierFlags(prop.valueDeclaration) & 128 /* Ambient */) && getTypeOfPropertyInBaseClass(prop) || undefinedType;
	      return getFlowTypeOfReference(reference, autoType, initialType);
	    }
	    function getWidenedTypeForAssignmentDeclaration(symbol, resolvedSymbol) {
	      const container = getAssignedExpandoInitializer(symbol.valueDeclaration);
	      if (container) {
	        const tag = isInJSFile(container) ? getJSDocTypeTag(container) : void 0;
	        if (tag && tag.typeExpression) {
	          return getTypeFromTypeNode(tag.typeExpression);
	        }
	        const containerObjectType = symbol.valueDeclaration && getJSContainerObjectType(symbol.valueDeclaration, symbol, container);
	        return containerObjectType || getWidenedLiteralType(checkExpressionCached(container));
	      }
	      let type;
	      let definedInConstructor = false;
	      let definedInMethod = false;
	      if (isConstructorDeclaredProperty(symbol)) {
	        type = getFlowTypeInConstructor(symbol, getDeclaringConstructor(symbol));
	      }
	      if (!type) {
	        let types;
	        if (symbol.declarations) {
	          let jsdocType;
	          for (const declaration of symbol.declarations) {
	            const expression = isBinaryExpression(declaration) || isCallExpression(declaration) ? declaration : isAccessExpression(declaration) ? isBinaryExpression(declaration.parent) ? declaration.parent : declaration : void 0;
	            if (!expression) {
	              continue;
	            }
	            const kind = isAccessExpression(expression) ? getAssignmentDeclarationPropertyAccessKind(expression) : getAssignmentDeclarationKind(expression);
	            if (kind === 4 /* ThisProperty */ || isBinaryExpression(expression) && isPossiblyAliasedThisProperty(expression, kind)) {
	              if (isDeclarationInConstructor(expression)) {
	                definedInConstructor = true;
	              } else {
	                definedInMethod = true;
	              }
	            }
	            if (!isCallExpression(expression)) {
	              jsdocType = getAnnotatedTypeForAssignmentDeclaration(jsdocType, expression, symbol, declaration);
	            }
	            if (!jsdocType) {
	              (types || (types = [])).push(isBinaryExpression(expression) || isCallExpression(expression) ? getInitializerTypeFromAssignmentDeclaration(symbol, resolvedSymbol, expression, kind) : neverType);
	            }
	          }
	          type = jsdocType;
	        }
	        if (!type) {
	          if (!length(types)) {
	            return errorType;
	          }
	          let constructorTypes = definedInConstructor && symbol.declarations ? getConstructorDefinedThisAssignmentTypes(types, symbol.declarations) : void 0;
	          if (definedInMethod) {
	            const propType = getTypeOfPropertyInBaseClass(symbol);
	            if (propType) {
	              (constructorTypes || (constructorTypes = [])).push(propType);
	              definedInConstructor = true;
	            }
	          }
	          const sourceTypes = some(constructorTypes, (t) => !!(t.flags & ~98304 /* Nullable */)) ? constructorTypes : types;
	          type = getUnionType(sourceTypes);
	        }
	      }
	      const widened = getWidenedType(addOptionality(
	        type,
	        /*isProperty*/
	        false,
	        definedInMethod && !definedInConstructor
	      ));
	      if (symbol.valueDeclaration && isInJSFile(symbol.valueDeclaration) && filterType(widened, (t) => !!(t.flags & ~98304 /* Nullable */)) === neverType) {
	        reportImplicitAny(symbol.valueDeclaration, anyType);
	        return anyType;
	      }
	      return widened;
	    }
	    function getJSContainerObjectType(decl, symbol, init) {
	      var _a, _b;
	      if (!isInJSFile(decl) || !init || !isObjectLiteralExpression(init) || init.properties.length) {
	        return void 0;
	      }
	      const exports = createSymbolTable();
	      while (isBinaryExpression(decl) || isPropertyAccessExpression(decl)) {
	        const s2 = getSymbolOfNode(decl);
	        if ((_a = s2 == null ? void 0 : s2.exports) == null ? void 0 : _a.size) {
	          mergeSymbolTable(exports, s2.exports);
	        }
	        decl = isBinaryExpression(decl) ? decl.parent : decl.parent.parent;
	      }
	      const s = getSymbolOfNode(decl);
	      if ((_b = s == null ? void 0 : s.exports) == null ? void 0 : _b.size) {
	        mergeSymbolTable(exports, s.exports);
	      }
	      const type = createAnonymousType(symbol, exports, emptyArray, emptyArray, emptyArray);
	      type.objectFlags |= 4096 /* JSLiteral */;
	      return type;
	    }
	    function getAnnotatedTypeForAssignmentDeclaration(declaredType, expression, symbol, declaration) {
	      var _a;
	      const typeNode = getEffectiveTypeAnnotationNode(expression.parent);
	      if (typeNode) {
	        const type = getWidenedType(getTypeFromTypeNode(typeNode));
	        if (!declaredType) {
	          return type;
	        } else if (!isErrorType(declaredType) && !isErrorType(type) && !isTypeIdenticalTo(declaredType, type)) {
	          errorNextVariableOrPropertyDeclarationMustHaveSameType(
	            /*firstDeclaration*/
	            void 0,
	            declaredType,
	            declaration,
	            type
	          );
	        }
	      }
	      if ((_a = symbol.parent) == null ? void 0 : _a.valueDeclaration) {
	        const possiblyAnnotatedSymbol = getFunctionExpressionParentSymbolOrSymbol(symbol.parent);
	        if (possiblyAnnotatedSymbol.valueDeclaration) {
	          const typeNode2 = getEffectiveTypeAnnotationNode(possiblyAnnotatedSymbol.valueDeclaration);
	          if (typeNode2) {
	            const annotationSymbol = getPropertyOfType(getTypeFromTypeNode(typeNode2), symbol.escapedName);
	            if (annotationSymbol) {
	              return getNonMissingTypeOfSymbol(annotationSymbol);
	            }
	          }
	        }
	      }
	      return declaredType;
	    }
	    function getInitializerTypeFromAssignmentDeclaration(symbol, resolvedSymbol, expression, kind) {
	      if (isCallExpression(expression)) {
	        if (resolvedSymbol) {
	          return getTypeOfSymbol(resolvedSymbol);
	        }
	        const objectLitType = checkExpressionCached(expression.arguments[2]);
	        const valueType = getTypeOfPropertyOfType(objectLitType, "value");
	        if (valueType) {
	          return valueType;
	        }
	        const getFunc = getTypeOfPropertyOfType(objectLitType, "get");
	        if (getFunc) {
	          const getSig = getSingleCallSignature(getFunc);
	          if (getSig) {
	            return getReturnTypeOfSignature(getSig);
	          }
	        }
	        const setFunc = getTypeOfPropertyOfType(objectLitType, "set");
	        if (setFunc) {
	          const setSig = getSingleCallSignature(setFunc);
	          if (setSig) {
	            return getTypeOfFirstParameterOfSignature(setSig);
	          }
	        }
	        return anyType;
	      }
	      if (containsSameNamedThisProperty(expression.left, expression.right)) {
	        return anyType;
	      }
	      const isDirectExport = kind === 1 /* ExportsProperty */ && (isPropertyAccessExpression(expression.left) || isElementAccessExpression(expression.left)) && (isModuleExportsAccessExpression(expression.left.expression) || isIdentifier(expression.left.expression) && isExportsIdentifier(expression.left.expression));
	      const type = resolvedSymbol ? getTypeOfSymbol(resolvedSymbol) : isDirectExport ? getRegularTypeOfLiteralType(checkExpressionCached(expression.right)) : getWidenedLiteralType(checkExpressionCached(expression.right));
	      if (type.flags & 524288 /* Object */ && kind === 2 /* ModuleExports */ && symbol.escapedName === "export=" /* ExportEquals */) {
	        const exportedType = resolveStructuredTypeMembers(type);
	        const members = createSymbolTable();
	        copyEntries(exportedType.members, members);
	        const initialSize = members.size;
	        if (resolvedSymbol && !resolvedSymbol.exports) {
	          resolvedSymbol.exports = createSymbolTable();
	        }
	        (resolvedSymbol || symbol).exports.forEach((s, name) => {
	          var _a;
	          const exportedMember = members.get(name);
	          if (exportedMember && exportedMember !== s && !(s.flags & 2097152 /* Alias */)) {
	            if (s.flags & 111551 /* Value */ && exportedMember.flags & 111551 /* Value */) {
	              if (s.valueDeclaration && exportedMember.valueDeclaration && getSourceFileOfNode(s.valueDeclaration) !== getSourceFileOfNode(exportedMember.valueDeclaration)) {
	                const unescapedName = unescapeLeadingUnderscores(s.escapedName);
	                const exportedMemberName = ((_a = tryCast(exportedMember.valueDeclaration, isNamedDeclaration)) == null ? void 0 : _a.name) || exportedMember.valueDeclaration;
	                addRelatedInfo(
	                  error2(s.valueDeclaration, Diagnostics.Duplicate_identifier_0, unescapedName),
	                  createDiagnosticForNode(exportedMemberName, Diagnostics._0_was_also_declared_here, unescapedName)
	                );
	                addRelatedInfo(
	                  error2(exportedMemberName, Diagnostics.Duplicate_identifier_0, unescapedName),
	                  createDiagnosticForNode(s.valueDeclaration, Diagnostics._0_was_also_declared_here, unescapedName)
	                );
	              }
	              const union = createSymbol(s.flags | exportedMember.flags, name);
	              union.links.type = getUnionType([getTypeOfSymbol(s), getTypeOfSymbol(exportedMember)]);
	              union.valueDeclaration = exportedMember.valueDeclaration;
	              union.declarations = concatenate(exportedMember.declarations, s.declarations);
	              members.set(name, union);
	            } else {
	              members.set(name, mergeSymbol(s, exportedMember));
	            }
	          } else {
	            members.set(name, s);
	          }
	        });
	        const result = createAnonymousType(
	          initialSize !== members.size ? void 0 : exportedType.symbol,
	          // Only set the type's symbol if it looks to be the same as the original type
	          members,
	          exportedType.callSignatures,
	          exportedType.constructSignatures,
	          exportedType.indexInfos
	        );
	        if (initialSize === members.size) {
	          if (type.aliasSymbol) {
	            result.aliasSymbol = type.aliasSymbol;
	            result.aliasTypeArguments = type.aliasTypeArguments;
	          }
	          if (getObjectFlags(type) & 4 /* Reference */) {
	            result.aliasSymbol = type.symbol;
	            const args = getTypeArguments(type);
	            result.aliasTypeArguments = length(args) ? args : void 0;
	          }
	        }
	        result.objectFlags |= getObjectFlags(type) & 4096 /* JSLiteral */;
	        if (result.symbol && result.symbol.flags & 32 /* Class */ && type === getDeclaredTypeOfClassOrInterface(result.symbol)) {
	          result.objectFlags |= 16777216 /* IsClassInstanceClone */;
	        }
	        return result;
	      }
	      if (isEmptyArrayLiteralType(type)) {
	        reportImplicitAny(expression, anyArrayType);
	        return anyArrayType;
	      }
	      return type;
	    }
	    function containsSameNamedThisProperty(thisProperty, expression) {
	      return isPropertyAccessExpression(thisProperty) && thisProperty.expression.kind === 110 /* ThisKeyword */ && forEachChildRecursively(expression, (n) => isMatchingReference(thisProperty, n));
	    }
	    function isDeclarationInConstructor(expression) {
	      const thisContainer = getThisContainer(
	        expression,
	        /*includeArrowFunctions*/
	        false,
	        /*includeClassComputedPropertyName*/
	        false
	      );
	      return thisContainer.kind === 176 /* Constructor */ || thisContainer.kind === 262 /* FunctionDeclaration */ || thisContainer.kind === 218 /* FunctionExpression */ && !isPrototypePropertyAssignment(thisContainer.parent);
	    }
	    function getConstructorDefinedThisAssignmentTypes(types, declarations) {
	      Debug.assert(types.length === declarations.length);
	      return types.filter((_, i) => {
	        const declaration = declarations[i];
	        const expression = isBinaryExpression(declaration) ? declaration : isBinaryExpression(declaration.parent) ? declaration.parent : void 0;
	        return expression && isDeclarationInConstructor(expression);
	      });
	    }
	    function getTypeFromBindingElement(element, includePatternInType, reportErrors2) {
	      if (element.initializer) {
	        const contextualType = isBindingPattern(element.name) ? getTypeFromBindingPattern(
	          element.name,
	          /*includePatternInType*/
	          true,
	          /*reportErrors*/
	          false
	        ) : unknownType;
	        return addOptionality(widenTypeInferredFromInitializer(element, checkDeclarationInitializer(element, reportErrors2 ? 0 /* Normal */ : 1 /* Contextual */, contextualType)));
	      }
	      if (isBindingPattern(element.name)) {
	        return getTypeFromBindingPattern(element.name, includePatternInType, reportErrors2);
	      }
	      if (reportErrors2 && !declarationBelongsToPrivateAmbientMember(element)) {
	        reportImplicitAny(element, anyType);
	      }
	      return includePatternInType ? nonInferrableAnyType : anyType;
	    }
	    function getTypeFromObjectBindingPattern(pattern, includePatternInType, reportErrors2) {
	      const members = createSymbolTable();
	      let stringIndexInfo;
	      let objectFlags = 128 /* ObjectLiteral */ | 131072 /* ContainsObjectOrArrayLiteral */;
	      forEach(pattern.elements, (e) => {
	        const name = e.propertyName || e.name;
	        if (e.dotDotDotToken) {
	          stringIndexInfo = createIndexInfo(
	            stringType,
	            anyType,
	            /*isReadonly*/
	            false
	          );
	          return;
	        }
	        const exprType = getLiteralTypeFromPropertyName(name);
	        if (!isTypeUsableAsPropertyName(exprType)) {
	          objectFlags |= 512 /* ObjectLiteralPatternWithComputedProperties */;
	          return;
	        }
	        const text = getPropertyNameFromType(exprType);
	        const flags = 4 /* Property */ | (e.initializer ? 16777216 /* Optional */ : 0);
	        const symbol = createSymbol(flags, text);
	        symbol.links.type = getTypeFromBindingElement(e, includePatternInType, reportErrors2);
	        symbol.links.bindingElement = e;
	        members.set(symbol.escapedName, symbol);
	      });
	      const result = createAnonymousType(
	        /*symbol*/
	        void 0,
	        members,
	        emptyArray,
	        emptyArray,
	        stringIndexInfo ? [stringIndexInfo] : emptyArray
	      );
	      result.objectFlags |= objectFlags;
	      if (includePatternInType) {
	        result.pattern = pattern;
	        result.objectFlags |= 131072 /* ContainsObjectOrArrayLiteral */;
	      }
	      return result;
	    }
	    function getTypeFromArrayBindingPattern(pattern, includePatternInType, reportErrors2) {
	      const elements = pattern.elements;
	      const lastElement = lastOrUndefined(elements);
	      const restElement = lastElement && lastElement.kind === 208 /* BindingElement */ && lastElement.dotDotDotToken ? lastElement : void 0;
	      if (elements.length === 0 || elements.length === 1 && restElement) {
	        return languageVersion >= 2 /* ES2015 */ ? createIterableType(anyType) : anyArrayType;
	      }
	      const elementTypes = map(elements, (e) => isOmittedExpression(e) ? anyType : getTypeFromBindingElement(e, includePatternInType, reportErrors2));
	      const minLength = findLastIndex(elements, (e) => !(e === restElement || isOmittedExpression(e) || hasDefaultValue(e)), elements.length - 1) + 1;
	      const elementFlags = map(elements, (e, i) => e === restElement ? 4 /* Rest */ : i >= minLength ? 2 /* Optional */ : 1 /* Required */);
	      let result = createTupleType(elementTypes, elementFlags);
	      if (includePatternInType) {
	        result = cloneTypeReference(result);
	        result.pattern = pattern;
	        result.objectFlags |= 131072 /* ContainsObjectOrArrayLiteral */;
	      }
	      return result;
	    }
	    function getTypeFromBindingPattern(pattern, includePatternInType = false, reportErrors2 = false) {
	      return pattern.kind === 206 /* ObjectBindingPattern */ ? getTypeFromObjectBindingPattern(pattern, includePatternInType, reportErrors2) : getTypeFromArrayBindingPattern(pattern, includePatternInType, reportErrors2);
	    }
	    function getWidenedTypeForVariableLikeDeclaration(declaration, reportErrors2) {
	      return widenTypeForVariableLikeDeclaration(getTypeForVariableLikeDeclaration(
	        declaration,
	        /*includeOptionality*/
	        true,
	        0 /* Normal */
	      ), declaration, reportErrors2);
	    }
	    function getTypeFromImportAttributes(node) {
	      const links = getNodeLinks(node);
	      if (!links.resolvedType) {
	        const symbol = createSymbol(4096 /* ObjectLiteral */, "__importAttributes" /* ImportAttributes */);
	        const members = createSymbolTable();
	        forEach(node.elements, (attr) => {
	          const member = createSymbol(4 /* Property */, getNameFromImportAttribute(attr));
	          member.parent = symbol;
	          member.links.type = checkImportAttribute(attr);
	          member.links.target = member;
	          members.set(member.escapedName, member);
	        });
	        const type = createAnonymousType(symbol, members, emptyArray, emptyArray, emptyArray);
	        type.objectFlags |= 128 /* ObjectLiteral */ | 262144 /* NonInferrableType */;
	        links.resolvedType = type;
	      }
	      return links.resolvedType;
	    }
	    function isGlobalSymbolConstructor(node) {
	      const symbol = getSymbolOfNode(node);
	      const globalSymbol = getGlobalESSymbolConstructorTypeSymbol(
	        /*reportErrors*/
	        false
	      );
	      return globalSymbol && symbol && symbol === globalSymbol;
	    }
	    function widenTypeForVariableLikeDeclaration(type, declaration, reportErrors2) {
	      if (type) {
	        if (type.flags & 4096 /* ESSymbol */ && isGlobalSymbolConstructor(declaration.parent)) {
	          type = getESSymbolLikeTypeForNode(declaration);
	        }
	        if (reportErrors2) {
	          reportErrorsFromWidening(declaration, type);
	        }
	        if (type.flags & 8192 /* UniqueESSymbol */ && (isBindingElement(declaration) || !declaration.type) && type.symbol !== getSymbolOfDeclaration(declaration)) {
	          type = esSymbolType;
	        }
	        return getWidenedType(type);
	      }
	      type = isParameter(declaration) && declaration.dotDotDotToken ? anyArrayType : anyType;
	      if (reportErrors2) {
	        if (!declarationBelongsToPrivateAmbientMember(declaration)) {
	          reportImplicitAny(declaration, type);
	        }
	      }
	      return type;
	    }
	    function declarationBelongsToPrivateAmbientMember(declaration) {
	      const root = getRootDeclaration(declaration);
	      const memberDeclaration = root.kind === 169 /* Parameter */ ? root.parent : root;
	      return isPrivateWithinAmbient(memberDeclaration);
	    }
	    function tryGetTypeFromEffectiveTypeNode(node) {
	      const typeNode = getEffectiveTypeAnnotationNode(node);
	      if (typeNode) {
	        return getTypeFromTypeNode(typeNode);
	      }
	    }
	    function isParameterOfContextSensitiveSignature(symbol) {
	      let decl = symbol.valueDeclaration;
	      if (!decl) {
	        return false;
	      }
	      if (isBindingElement(decl)) {
	        decl = walkUpBindingElementsAndPatterns(decl);
	      }
	      if (isParameter(decl)) {
	        return isContextSensitiveFunctionOrObjectLiteralMethod(decl.parent);
	      }
	      return false;
	    }
	    function getTypeOfVariableOrParameterOrProperty(symbol, checkMode) {
	      const links = getSymbolLinks(symbol);
	      if (!links.type) {
	        const type = getTypeOfVariableOrParameterOrPropertyWorker(symbol, checkMode);
	        if (!links.type && !isParameterOfContextSensitiveSignature(symbol) && !checkMode) {
	          links.type = type;
	        }
	        return type;
	      }
	      return links.type;
	    }
	    function getTypeOfVariableOrParameterOrPropertyWorker(symbol, checkMode) {
	      if (symbol.flags & 4194304 /* Prototype */) {
	        return getTypeOfPrototypeProperty(symbol);
	      }
	      if (symbol === requireSymbol) {
	        return anyType;
	      }
	      if (symbol.flags & 134217728 /* ModuleExports */ && symbol.valueDeclaration) {
	        const fileSymbol = getSymbolOfDeclaration(getSourceFileOfNode(symbol.valueDeclaration));
	        const result = createSymbol(fileSymbol.flags, "exports");
	        result.declarations = fileSymbol.declarations ? fileSymbol.declarations.slice() : [];
	        result.parent = symbol;
	        result.links.target = fileSymbol;
	        if (fileSymbol.valueDeclaration)
	          result.valueDeclaration = fileSymbol.valueDeclaration;
	        if (fileSymbol.members)
	          result.members = new Map(fileSymbol.members);
	        if (fileSymbol.exports)
	          result.exports = new Map(fileSymbol.exports);
	        const members = createSymbolTable();
	        members.set("exports", result);
	        return createAnonymousType(symbol, members, emptyArray, emptyArray, emptyArray);
	      }
	      Debug.assertIsDefined(symbol.valueDeclaration);
	      const declaration = symbol.valueDeclaration;
	      if (isSourceFile(declaration) && isJsonSourceFile(declaration)) {
	        if (!declaration.statements.length) {
	          return emptyObjectType;
	        }
	        return getWidenedType(getWidenedLiteralType(checkExpression(declaration.statements[0].expression)));
	      }
	      if (isAccessor(declaration)) {
	        return getTypeOfAccessors(symbol);
	      }
	      if (!pushTypeResolution(symbol, 0 /* Type */)) {
	        if (symbol.flags & 512 /* ValueModule */ && !(symbol.flags & 67108864 /* Assignment */)) {
	          return getTypeOfFuncClassEnumModule(symbol);
	        }
	        if (isBindingElement(declaration) && checkMode === 1 /* Contextual */) {
	          return errorType;
	        }
	        return reportCircularityError(symbol);
	      }
	      let type;
	      if (declaration.kind === 277 /* ExportAssignment */) {
	        type = widenTypeForVariableLikeDeclaration(tryGetTypeFromEffectiveTypeNode(declaration) || checkExpressionCached(declaration.expression), declaration);
	      } else if (isBinaryExpression(declaration) || isInJSFile(declaration) && (isCallExpression(declaration) || (isPropertyAccessExpression(declaration) || isBindableStaticElementAccessExpression(declaration)) && isBinaryExpression(declaration.parent))) {
	        type = getWidenedTypeForAssignmentDeclaration(symbol);
	      } else if (isPropertyAccessExpression(declaration) || isElementAccessExpression(declaration) || isIdentifier(declaration) || isStringLiteralLike(declaration) || isNumericLiteral(declaration) || isClassDeclaration(declaration) || isFunctionDeclaration(declaration) || isMethodDeclaration(declaration) && !isObjectLiteralMethod(declaration) || isMethodSignature(declaration) || isSourceFile(declaration)) {
	        if (symbol.flags & (16 /* Function */ | 8192 /* Method */ | 32 /* Class */ | 384 /* Enum */ | 512 /* ValueModule */)) {
	          return getTypeOfFuncClassEnumModule(symbol);
	        }
	        type = isBinaryExpression(declaration.parent) ? getWidenedTypeForAssignmentDeclaration(symbol) : tryGetTypeFromEffectiveTypeNode(declaration) || anyType;
	      } else if (isPropertyAssignment(declaration)) {
	        type = tryGetTypeFromEffectiveTypeNode(declaration) || checkPropertyAssignment(declaration);
	      } else if (isJsxAttribute(declaration)) {
	        type = tryGetTypeFromEffectiveTypeNode(declaration) || checkJsxAttribute(declaration);
	      } else if (isShorthandPropertyAssignment(declaration)) {
	        type = tryGetTypeFromEffectiveTypeNode(declaration) || checkExpressionForMutableLocation(declaration.name, 0 /* Normal */);
	      } else if (isObjectLiteralMethod(declaration)) {
	        type = tryGetTypeFromEffectiveTypeNode(declaration) || checkObjectLiteralMethod(declaration, 0 /* Normal */);
	      } else if (isParameter(declaration) || isPropertyDeclaration(declaration) || isPropertySignature(declaration) || isVariableDeclaration(declaration) || isBindingElement(declaration) || isJSDocPropertyLikeTag(declaration)) {
	        type = getWidenedTypeForVariableLikeDeclaration(
	          declaration,
	          /*reportErrors*/
	          true
	        );
	      } else if (isEnumDeclaration(declaration)) {
	        type = getTypeOfFuncClassEnumModule(symbol);
	      } else if (isEnumMember(declaration)) {
	        type = getTypeOfEnumMember(symbol);
	      } else {
	        return Debug.fail("Unhandled declaration kind! " + Debug.formatSyntaxKind(declaration.kind) + " for " + Debug.formatSymbol(symbol));
	      }
	      if (!popTypeResolution()) {
	        if (symbol.flags & 512 /* ValueModule */ && !(symbol.flags & 67108864 /* Assignment */)) {
	          return getTypeOfFuncClassEnumModule(symbol);
	        }
	        if (isBindingElement(declaration) && checkMode === 1 /* Contextual */) {
	          return type;
	        }
	        return reportCircularityError(symbol);
	      }
	      return type;
	    }
	    function getAnnotatedAccessorTypeNode(accessor) {
	      if (accessor) {
	        switch (accessor.kind) {
	          case 177 /* GetAccessor */:
	            const getterTypeAnnotation = getEffectiveReturnTypeNode(accessor);
	            return getterTypeAnnotation;
	          case 178 /* SetAccessor */:
	            const setterTypeAnnotation = getEffectiveSetAccessorTypeAnnotationNode(accessor);
	            return setterTypeAnnotation;
	          case 172 /* PropertyDeclaration */:
	            Debug.assert(hasAccessorModifier(accessor));
	            const accessorTypeAnnotation = getEffectiveTypeAnnotationNode(accessor);
	            return accessorTypeAnnotation;
	        }
	      }
	      return void 0;
	    }
	    function getAnnotatedAccessorType(accessor) {
	      const node = getAnnotatedAccessorTypeNode(accessor);
	      return node && getTypeFromTypeNode(node);
	    }
	    function getAnnotatedAccessorThisParameter(accessor) {
	      const parameter = getAccessorThisParameter(accessor);
	      return parameter && parameter.symbol;
	    }
	    function getThisTypeOfDeclaration(declaration) {
	      return getThisTypeOfSignature(getSignatureFromDeclaration(declaration));
	    }
	    function getTypeOfAccessors(symbol) {
	      const links = getSymbolLinks(symbol);
	      if (!links.type) {
	        if (!pushTypeResolution(symbol, 0 /* Type */)) {
	          return errorType;
	        }
	        const getter = getDeclarationOfKind(symbol, 177 /* GetAccessor */);
	        const setter = getDeclarationOfKind(symbol, 178 /* SetAccessor */);
	        const accessor = tryCast(getDeclarationOfKind(symbol, 172 /* PropertyDeclaration */), isAutoAccessorPropertyDeclaration);
	        let type = getter && isInJSFile(getter) && getTypeForDeclarationFromJSDocComment(getter) || getAnnotatedAccessorType(getter) || getAnnotatedAccessorType(setter) || getAnnotatedAccessorType(accessor) || getter && getter.body && getReturnTypeFromBody(getter) || accessor && accessor.initializer && getWidenedTypeForVariableLikeDeclaration(
	          accessor,
	          /*reportErrors*/
	          true
	        );
	        if (!type) {
	          if (setter && !isPrivateWithinAmbient(setter)) {
	            errorOrSuggestion(noImplicitAny, setter, Diagnostics.Property_0_implicitly_has_type_any_because_its_set_accessor_lacks_a_parameter_type_annotation, symbolToString(symbol));
	          } else if (getter && !isPrivateWithinAmbient(getter)) {
	            errorOrSuggestion(noImplicitAny, getter, Diagnostics.Property_0_implicitly_has_type_any_because_its_get_accessor_lacks_a_return_type_annotation, symbolToString(symbol));
	          } else if (accessor && !isPrivateWithinAmbient(accessor)) {
	            errorOrSuggestion(noImplicitAny, accessor, Diagnostics.Member_0_implicitly_has_an_1_type, symbolToString(symbol), "any");
	          }
	          type = anyType;
	        }
	        if (!popTypeResolution()) {
	          if (getAnnotatedAccessorTypeNode(getter)) {
	            error2(getter, Diagnostics._0_is_referenced_directly_or_indirectly_in_its_own_type_annotation, symbolToString(symbol));
	          } else if (getAnnotatedAccessorTypeNode(setter)) {
	            error2(setter, Diagnostics._0_is_referenced_directly_or_indirectly_in_its_own_type_annotation, symbolToString(symbol));
	          } else if (getAnnotatedAccessorTypeNode(accessor)) {
	            error2(setter, Diagnostics._0_is_referenced_directly_or_indirectly_in_its_own_type_annotation, symbolToString(symbol));
	          } else if (getter && noImplicitAny) {
	            error2(getter, Diagnostics._0_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_referenced_directly_or_indirectly_in_one_of_its_return_expressions, symbolToString(symbol));
	          }
	          type = anyType;
	        }
	        links.type = type;
	      }
	      return links.type;
	    }
	    function getWriteTypeOfAccessors(symbol) {
	      const links = getSymbolLinks(symbol);
	      if (!links.writeType) {
	        if (!pushTypeResolution(symbol, 8 /* WriteType */)) {
	          return errorType;
	        }
	        const setter = getDeclarationOfKind(symbol, 178 /* SetAccessor */) ?? tryCast(getDeclarationOfKind(symbol, 172 /* PropertyDeclaration */), isAutoAccessorPropertyDeclaration);
	        let writeType = getAnnotatedAccessorType(setter);
	        if (!popTypeResolution()) {
	          if (getAnnotatedAccessorTypeNode(setter)) {
	            error2(setter, Diagnostics._0_is_referenced_directly_or_indirectly_in_its_own_type_annotation, symbolToString(symbol));
	          }
	          writeType = anyType;
	        }
	        links.writeType = writeType || getTypeOfAccessors(symbol);
	      }
	      return links.writeType;
	    }
	    function getBaseTypeVariableOfClass(symbol) {
	      const baseConstructorType = getBaseConstructorTypeOfClass(getDeclaredTypeOfClassOrInterface(symbol));
	      return baseConstructorType.flags & 8650752 /* TypeVariable */ ? baseConstructorType : baseConstructorType.flags & 2097152 /* Intersection */ ? find(baseConstructorType.types, (t) => !!(t.flags & 8650752 /* TypeVariable */)) : void 0;
	    }
	    function getTypeOfFuncClassEnumModule(symbol) {
	      let links = getSymbolLinks(symbol);
	      const originalLinks = links;
	      if (!links.type) {
	        const expando = symbol.valueDeclaration && getSymbolOfExpando(
	          symbol.valueDeclaration,
	          /*allowDeclaration*/
	          false
	        );
	        if (expando) {
	          const merged = mergeJSSymbols(symbol, expando);
	          if (merged) {
	            symbol = merged;
	            links = merged.links;
	          }
	        }
	        originalLinks.type = links.type = getTypeOfFuncClassEnumModuleWorker(symbol);
	      }
	      return links.type;
	    }
	    function getTypeOfFuncClassEnumModuleWorker(symbol) {
	      const declaration = symbol.valueDeclaration;
	      if (symbol.flags & 1536 /* Module */ && isShorthandAmbientModuleSymbol(symbol)) {
	        return anyType;
	      } else if (declaration && (declaration.kind === 226 /* BinaryExpression */ || isAccessExpression(declaration) && declaration.parent.kind === 226 /* BinaryExpression */)) {
	        return getWidenedTypeForAssignmentDeclaration(symbol);
	      } else if (symbol.flags & 512 /* ValueModule */ && declaration && isSourceFile(declaration) && declaration.commonJsModuleIndicator) {
	        const resolvedModule = resolveExternalModuleSymbol(symbol);
	        if (resolvedModule !== symbol) {
	          if (!pushTypeResolution(symbol, 0 /* Type */)) {
	            return errorType;
	          }
	          const exportEquals = getMergedSymbol(symbol.exports.get("export=" /* ExportEquals */));
	          const type2 = getWidenedTypeForAssignmentDeclaration(exportEquals, exportEquals === resolvedModule ? void 0 : resolvedModule);
	          if (!popTypeResolution()) {
	            return reportCircularityError(symbol);
	          }
	          return type2;
	        }
	      }
	      const type = createObjectType(16 /* Anonymous */, symbol);
	      if (symbol.flags & 32 /* Class */) {
	        const baseTypeVariable = getBaseTypeVariableOfClass(symbol);
	        return baseTypeVariable ? getIntersectionType([type, baseTypeVariable]) : type;
	      } else {
	        return strictNullChecks && symbol.flags & 16777216 /* Optional */ ? getOptionalType(
	          type,
	          /*isProperty*/
	          true
	        ) : type;
	      }
	    }
	    function getTypeOfEnumMember(symbol) {
	      const links = getSymbolLinks(symbol);
	      return links.type || (links.type = getDeclaredTypeOfEnumMember(symbol));
	    }
	    function getTypeOfAlias(symbol) {
	      const links = getSymbolLinks(symbol);
	      if (!links.type) {
	        if (!pushTypeResolution(symbol, 0 /* Type */)) {
	          return errorType;
	        }
	        const targetSymbol = resolveAlias(symbol);
	        const exportSymbol = symbol.declarations && getTargetOfAliasDeclaration(
	          getDeclarationOfAliasSymbol(symbol),
	          /*dontRecursivelyResolve*/
	          true
	        );
	        const declaredType = firstDefined(exportSymbol == null ? void 0 : exportSymbol.declarations, (d) => isExportAssignment(d) ? tryGetTypeFromEffectiveTypeNode(d) : void 0);
	        links.type = (exportSymbol == null ? void 0 : exportSymbol.declarations) && isDuplicatedCommonJSExport(exportSymbol.declarations) && symbol.declarations.length ? getFlowTypeFromCommonJSExport(exportSymbol) : isDuplicatedCommonJSExport(symbol.declarations) ? autoType : declaredType ? declaredType : getSymbolFlags(targetSymbol) & 111551 /* Value */ ? getTypeOfSymbol(targetSymbol) : errorType;
	        if (!popTypeResolution()) {
	          reportCircularityError(exportSymbol ?? symbol);
	          return links.type = errorType;
	        }
	      }
	      return links.type;
	    }
	    function getTypeOfInstantiatedSymbol(symbol) {
	      const links = getSymbolLinks(symbol);
	      return links.type || (links.type = instantiateType(getTypeOfSymbol(links.target), links.mapper));
	    }
	    function getWriteTypeOfInstantiatedSymbol(symbol) {
	      const links = getSymbolLinks(symbol);
	      return links.writeType || (links.writeType = instantiateType(getWriteTypeOfSymbol(links.target), links.mapper));
	    }
	    function reportCircularityError(symbol) {
	      const declaration = symbol.valueDeclaration;
	      if (declaration) {
	        if (getEffectiveTypeAnnotationNode(declaration)) {
	          error2(symbol.valueDeclaration, Diagnostics._0_is_referenced_directly_or_indirectly_in_its_own_type_annotation, symbolToString(symbol));
	          return errorType;
	        }
	        if (noImplicitAny && (declaration.kind !== 169 /* Parameter */ || declaration.initializer)) {
	          error2(symbol.valueDeclaration, Diagnostics._0_implicitly_has_type_any_because_it_does_not_have_a_type_annotation_and_is_referenced_directly_or_indirectly_in_its_own_initializer, symbolToString(symbol));
	        }
	      } else if (symbol.flags & 2097152 /* Alias */) {
	        const node = getDeclarationOfAliasSymbol(symbol);
	        if (node) {
	          error2(node, Diagnostics.Circular_definition_of_import_alias_0, symbolToString(symbol));
	        }
	      }
	      return anyType;
	    }
	    function getTypeOfSymbolWithDeferredType(symbol) {
	      const links = getSymbolLinks(symbol);
	      if (!links.type) {
	        Debug.assertIsDefined(links.deferralParent);
	        Debug.assertIsDefined(links.deferralConstituents);
	        links.type = links.deferralParent.flags & 1048576 /* Union */ ? getUnionType(links.deferralConstituents) : getIntersectionType(links.deferralConstituents);
	      }
	      return links.type;
	    }
	    function getWriteTypeOfSymbolWithDeferredType(symbol) {
	      const links = getSymbolLinks(symbol);
	      if (!links.writeType && links.deferralWriteConstituents) {
	        Debug.assertIsDefined(links.deferralParent);
	        Debug.assertIsDefined(links.deferralConstituents);
	        links.writeType = links.deferralParent.flags & 1048576 /* Union */ ? getUnionType(links.deferralWriteConstituents) : getIntersectionType(links.deferralWriteConstituents);
	      }
	      return links.writeType;
	    }
	    function getWriteTypeOfSymbol(symbol) {
	      const checkFlags = getCheckFlags(symbol);
	      if (symbol.flags & 4 /* Property */) {
	        return checkFlags & 2 /* SyntheticProperty */ ? checkFlags & 65536 /* DeferredType */ ? getWriteTypeOfSymbolWithDeferredType(symbol) || getTypeOfSymbolWithDeferredType(symbol) : (
	          // NOTE: cast to TransientSymbol should be safe because only TransientSymbols can have CheckFlags.SyntheticProperty
	          symbol.links.writeType || symbol.links.type
	        ) : removeMissingType(getTypeOfSymbol(symbol), !!(symbol.flags & 16777216 /* Optional */));
	      }
	      if (symbol.flags & 98304 /* Accessor */) {
	        return checkFlags & 1 /* Instantiated */ ? getWriteTypeOfInstantiatedSymbol(symbol) : getWriteTypeOfAccessors(symbol);
	      }
	      return getTypeOfSymbol(symbol);
	    }
	    function getTypeOfSymbol(symbol, checkMode) {
	      const checkFlags = getCheckFlags(symbol);
	      if (checkFlags & 65536 /* DeferredType */) {
	        return getTypeOfSymbolWithDeferredType(symbol);
	      }
	      if (checkFlags & 1 /* Instantiated */) {
	        return getTypeOfInstantiatedSymbol(symbol);
	      }
	      if (checkFlags & 262144 /* Mapped */) {
	        return getTypeOfMappedSymbol(symbol);
	      }
	      if (checkFlags & 8192 /* ReverseMapped */) {
	        return getTypeOfReverseMappedSymbol(symbol);
	      }
	      if (symbol.flags & (3 /* Variable */ | 4 /* Property */)) {
	        return getTypeOfVariableOrParameterOrProperty(symbol, checkMode);
	      }
	      if (symbol.flags & (16 /* Function */ | 8192 /* Method */ | 32 /* Class */ | 384 /* Enum */ | 512 /* ValueModule */)) {
	        return getTypeOfFuncClassEnumModule(symbol);
	      }
	      if (symbol.flags & 8 /* EnumMember */) {
	        return getTypeOfEnumMember(symbol);
	      }
	      if (symbol.flags & 98304 /* Accessor */) {
	        return getTypeOfAccessors(symbol);
	      }
	      if (symbol.flags & 2097152 /* Alias */) {
	        return getTypeOfAlias(symbol);
	      }
	      return errorType;
	    }
	    function getNonMissingTypeOfSymbol(symbol) {
	      return removeMissingType(getTypeOfSymbol(symbol), !!(symbol.flags & 16777216 /* Optional */));
	    }
	    function isReferenceToType2(type, target) {
	      return type !== void 0 && target !== void 0 && (getObjectFlags(type) & 4 /* Reference */) !== 0 && type.target === target;
	    }
	    function getTargetType(type) {
	      return getObjectFlags(type) & 4 /* Reference */ ? type.target : type;
	    }
	    function hasBaseType(type, checkBase) {
	      return check(type);
	      function check(type2) {
	        if (getObjectFlags(type2) & (3 /* ClassOrInterface */ | 4 /* Reference */)) {
	          const target = getTargetType(type2);
	          return target === checkBase || some(getBaseTypes(target), check);
	        } else if (type2.flags & 2097152 /* Intersection */) {
	          return some(type2.types, check);
	        }
	        return false;
	      }
	    }
	    function appendTypeParameters(typeParameters, declarations) {
	      for (const declaration of declarations) {
	        typeParameters = appendIfUnique(typeParameters, getDeclaredTypeOfTypeParameter(getSymbolOfDeclaration(declaration)));
	      }
	      return typeParameters;
	    }
	    function getOuterTypeParameters(node, includeThisTypes) {
	      while (true) {
	        node = node.parent;
	        if (node && isBinaryExpression(node)) {
	          const assignmentKind = getAssignmentDeclarationKind(node);
	          if (assignmentKind === 6 /* Prototype */ || assignmentKind === 3 /* PrototypeProperty */) {
	            const symbol = getSymbolOfDeclaration(node.left);
	            if (symbol && symbol.parent && !findAncestor(symbol.parent.valueDeclaration, (d) => node === d)) {
	              node = symbol.parent.valueDeclaration;
	            }
	          }
	        }
	        if (!node) {
	          return void 0;
	        }
	        switch (node.kind) {
	          case 263 /* ClassDeclaration */:
	          case 231 /* ClassExpression */:
	          case 264 /* InterfaceDeclaration */:
	          case 179 /* CallSignature */:
	          case 180 /* ConstructSignature */:
	          case 173 /* MethodSignature */:
	          case 184 /* FunctionType */:
	          case 185 /* ConstructorType */:
	          case 324 /* JSDocFunctionType */:
	          case 262 /* FunctionDeclaration */:
	          case 174 /* MethodDeclaration */:
	          case 218 /* FunctionExpression */:
	          case 219 /* ArrowFunction */:
	          case 265 /* TypeAliasDeclaration */:
	          case 352 /* JSDocTemplateTag */:
	          case 353 /* JSDocTypedefTag */:
	          case 347 /* JSDocEnumTag */:
	          case 345 /* JSDocCallbackTag */:
	          case 200 /* MappedType */:
	          case 194 /* ConditionalType */: {
	            const outerTypeParameters = getOuterTypeParameters(node, includeThisTypes);
	            if (node.kind === 200 /* MappedType */) {
	              return append(outerTypeParameters, getDeclaredTypeOfTypeParameter(getSymbolOfDeclaration(node.typeParameter)));
	            } else if (node.kind === 194 /* ConditionalType */) {
	              return concatenate(outerTypeParameters, getInferTypeParameters(node));
	            }
	            const outerAndOwnTypeParameters = appendTypeParameters(outerTypeParameters, getEffectiveTypeParameterDeclarations(node));
	            const thisType = includeThisTypes && (node.kind === 263 /* ClassDeclaration */ || node.kind === 231 /* ClassExpression */ || node.kind === 264 /* InterfaceDeclaration */ || isJSConstructor(node)) && getDeclaredTypeOfClassOrInterface(getSymbolOfDeclaration(node)).thisType;
	            return thisType ? append(outerAndOwnTypeParameters, thisType) : outerAndOwnTypeParameters;
	          }
	          case 348 /* JSDocParameterTag */:
	            const paramSymbol = getParameterSymbolFromJSDoc(node);
	            if (paramSymbol) {
	              node = paramSymbol.valueDeclaration;
	            }
	            break;
	          case 327 /* JSDoc */: {
	            const outerTypeParameters = getOuterTypeParameters(node, includeThisTypes);
	            return node.tags ? appendTypeParameters(outerTypeParameters, flatMap(node.tags, (t) => isJSDocTemplateTag(t) ? t.typeParameters : void 0)) : outerTypeParameters;
	          }
	        }
	      }
	    }
	    function getOuterTypeParametersOfClassOrInterface(symbol) {
	      var _a;
	      const declaration = symbol.flags & 32 /* Class */ || symbol.flags & 16 /* Function */ ? symbol.valueDeclaration : (_a = symbol.declarations) == null ? void 0 : _a.find((decl) => {
	        if (decl.kind === 264 /* InterfaceDeclaration */) {
	          return true;
	        }
	        if (decl.kind !== 260 /* VariableDeclaration */) {
	          return false;
	        }
	        const initializer = decl.initializer;
	        return !!initializer && (initializer.kind === 218 /* FunctionExpression */ || initializer.kind === 219 /* ArrowFunction */);
	      });
	      Debug.assert(!!declaration, "Class was missing valueDeclaration -OR- non-class had no interface declarations");
	      return getOuterTypeParameters(declaration);
	    }
	    function getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(symbol) {
	      if (!symbol.declarations) {
	        return;
	      }
	      let result;
	      for (const node of symbol.declarations) {
	        if (node.kind === 264 /* InterfaceDeclaration */ || node.kind === 263 /* ClassDeclaration */ || node.kind === 231 /* ClassExpression */ || isJSConstructor(node) || isTypeAlias(node)) {
	          const declaration = node;
	          result = appendTypeParameters(result, getEffectiveTypeParameterDeclarations(declaration));
	        }
	      }
	      return result;
	    }
	    function getTypeParametersOfClassOrInterface(symbol) {
	      return concatenate(getOuterTypeParametersOfClassOrInterface(symbol), getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(symbol));
	    }
	    function isMixinConstructorType(type) {
	      const signatures = getSignaturesOfType(type, 1 /* Construct */);
	      if (signatures.length === 1) {
	        const s = signatures[0];
	        if (!s.typeParameters && s.parameters.length === 1 && signatureHasRestParameter(s)) {
	          const paramType = getTypeOfParameter(s.parameters[0]);
	          return isTypeAny(paramType) || getElementTypeOfArrayType(paramType) === anyType;
	        }
	      }
	      return false;
	    }
	    function isConstructorType(type) {
	      if (getSignaturesOfType(type, 1 /* Construct */).length > 0) {
	        return true;
	      }
	      if (type.flags & 8650752 /* TypeVariable */) {
	        const constraint = getBaseConstraintOfType(type);
	        return !!constraint && isMixinConstructorType(constraint);
	      }
	      return false;
	    }
	    function getBaseTypeNodeOfClass(type) {
	      const decl = getClassLikeDeclarationOfSymbol(type.symbol);
	      return decl && getEffectiveBaseTypeNode(decl);
	    }
	    function getConstructorsForTypeArguments(type, typeArgumentNodes, location) {
	      const typeArgCount = length(typeArgumentNodes);
	      const isJavascript = isInJSFile(location);
	      return filter(getSignaturesOfType(type, 1 /* Construct */), (sig) => (isJavascript || typeArgCount >= getMinTypeArgumentCount(sig.typeParameters)) && typeArgCount <= length(sig.typeParameters));
	    }
	    function getInstantiatedConstructorsForTypeArguments(type, typeArgumentNodes, location) {
	      const signatures = getConstructorsForTypeArguments(type, typeArgumentNodes, location);
	      const typeArguments = map(typeArgumentNodes, getTypeFromTypeNode);
	      return sameMap(signatures, (sig) => some(sig.typeParameters) ? getSignatureInstantiation(sig, typeArguments, isInJSFile(location)) : sig);
	    }
	    function getBaseConstructorTypeOfClass(type) {
	      if (!type.resolvedBaseConstructorType) {
	        const decl = getClassLikeDeclarationOfSymbol(type.symbol);
	        const extended = decl && getEffectiveBaseTypeNode(decl);
	        const baseTypeNode = getBaseTypeNodeOfClass(type);
	        if (!baseTypeNode) {
	          return type.resolvedBaseConstructorType = undefinedType;
	        }
	        if (!pushTypeResolution(type, 1 /* ResolvedBaseConstructorType */)) {
	          return errorType;
	        }
	        const baseConstructorType = checkExpression(baseTypeNode.expression);
	        if (extended && baseTypeNode !== extended) {
	          Debug.assert(!extended.typeArguments);
	          checkExpression(extended.expression);
	        }
	        if (baseConstructorType.flags & (524288 /* Object */ | 2097152 /* Intersection */)) {
	          resolveStructuredTypeMembers(baseConstructorType);
	        }
	        if (!popTypeResolution()) {
	          error2(type.symbol.valueDeclaration, Diagnostics._0_is_referenced_directly_or_indirectly_in_its_own_base_expression, symbolToString(type.symbol));
	          return type.resolvedBaseConstructorType = errorType;
	        }
	        if (!(baseConstructorType.flags & 1 /* Any */) && baseConstructorType !== nullWideningType && !isConstructorType(baseConstructorType)) {
	          const err = error2(baseTypeNode.expression, Diagnostics.Type_0_is_not_a_constructor_function_type, typeToString(baseConstructorType));
	          if (baseConstructorType.flags & 262144 /* TypeParameter */) {
	            const constraint = getConstraintFromTypeParameter(baseConstructorType);
	            let ctorReturn = unknownType;
	            if (constraint) {
	              const ctorSig = getSignaturesOfType(constraint, 1 /* Construct */);
	              if (ctorSig[0]) {
	                ctorReturn = getReturnTypeOfSignature(ctorSig[0]);
	              }
	            }
	            if (baseConstructorType.symbol.declarations) {
	              addRelatedInfo(err, createDiagnosticForNode(baseConstructorType.symbol.declarations[0], Diagnostics.Did_you_mean_for_0_to_be_constrained_to_type_new_args_Colon_any_1, symbolToString(baseConstructorType.symbol), typeToString(ctorReturn)));
	            }
	          }
	          return type.resolvedBaseConstructorType = errorType;
	        }
	        type.resolvedBaseConstructorType = baseConstructorType;
	      }
	      return type.resolvedBaseConstructorType;
	    }
	    function getImplementsTypes(type) {
	      let resolvedImplementsTypes = emptyArray;
	      if (type.symbol.declarations) {
	        for (const declaration of type.symbol.declarations) {
	          const implementsTypeNodes = getEffectiveImplementsTypeNodes(declaration);
	          if (!implementsTypeNodes)
	            continue;
	          for (const node of implementsTypeNodes) {
	            const implementsType = getTypeFromTypeNode(node);
	            if (!isErrorType(implementsType)) {
	              if (resolvedImplementsTypes === emptyArray) {
	                resolvedImplementsTypes = [implementsType];
	              } else {
	                resolvedImplementsTypes.push(implementsType);
	              }
	            }
	          }
	        }
	      }
	      return resolvedImplementsTypes;
	    }
	    function reportCircularBaseType(node, type) {
	      error2(node, Diagnostics.Type_0_recursively_references_itself_as_a_base_type, typeToString(
	        type,
	        /*enclosingDeclaration*/
	        void 0,
	        2 /* WriteArrayAsGenericType */
	      ));
	    }
	    function getBaseTypes(type) {
	      if (!type.baseTypesResolved) {
	        if (pushTypeResolution(type, 7 /* ResolvedBaseTypes */)) {
	          if (type.objectFlags & 8 /* Tuple */) {
	            type.resolvedBaseTypes = [getTupleBaseType(type)];
	          } else if (type.symbol.flags & (32 /* Class */ | 64 /* Interface */)) {
	            if (type.symbol.flags & 32 /* Class */) {
	              resolveBaseTypesOfClass(type);
	            }
	            if (type.symbol.flags & 64 /* Interface */) {
	              resolveBaseTypesOfInterface(type);
	            }
	          } else {
	            Debug.fail("type must be class or interface");
	          }
	          if (!popTypeResolution() && type.symbol.declarations) {
	            for (const declaration of type.symbol.declarations) {
	              if (declaration.kind === 263 /* ClassDeclaration */ || declaration.kind === 264 /* InterfaceDeclaration */) {
	                reportCircularBaseType(declaration, type);
	              }
	            }
	          }
	        }
	        type.baseTypesResolved = true;
	      }
	      return type.resolvedBaseTypes;
	    }
	    function getTupleBaseType(type) {
	      const elementTypes = sameMap(type.typeParameters, (t, i) => type.elementFlags[i] & 8 /* Variadic */ ? getIndexedAccessType(t, numberType) : t);
	      return createArrayType(getUnionType(elementTypes || emptyArray), type.readonly);
	    }
	    function resolveBaseTypesOfClass(type) {
	      type.resolvedBaseTypes = resolvingEmptyArray;
	      const baseConstructorType = getApparentType(getBaseConstructorTypeOfClass(type));
	      if (!(baseConstructorType.flags & (524288 /* Object */ | 2097152 /* Intersection */ | 1 /* Any */))) {
	        return type.resolvedBaseTypes = emptyArray;
	      }
	      const baseTypeNode = getBaseTypeNodeOfClass(type);
	      let baseType;
	      const originalBaseType = baseConstructorType.symbol ? getDeclaredTypeOfSymbol(baseConstructorType.symbol) : void 0;
	      if (baseConstructorType.symbol && baseConstructorType.symbol.flags & 32 /* Class */ && areAllOuterTypeParametersApplied(originalBaseType)) {
	        baseType = getTypeFromClassOrInterfaceReference(baseTypeNode, baseConstructorType.symbol);
	      } else if (baseConstructorType.flags & 1 /* Any */) {
	        baseType = baseConstructorType;
	      } else {
	        const constructors = getInstantiatedConstructorsForTypeArguments(baseConstructorType, baseTypeNode.typeArguments, baseTypeNode);
	        if (!constructors.length) {
	          error2(baseTypeNode.expression, Diagnostics.No_base_constructor_has_the_specified_number_of_type_arguments);
	          return type.resolvedBaseTypes = emptyArray;
	        }
	        baseType = getReturnTypeOfSignature(constructors[0]);
	      }
	      if (isErrorType(baseType)) {
	        return type.resolvedBaseTypes = emptyArray;
	      }
	      const reducedBaseType = getReducedType(baseType);
	      if (!isValidBaseType(reducedBaseType)) {
	        const elaboration = elaborateNeverIntersection(
	          /*errorInfo*/
	          void 0,
	          baseType
	        );
	        const diagnostic = chainDiagnosticMessages(elaboration, Diagnostics.Base_constructor_return_type_0_is_not_an_object_type_or_intersection_of_object_types_with_statically_known_members, typeToString(reducedBaseType));
	        diagnostics.add(createDiagnosticForNodeFromMessageChain(getSourceFileOfNode(baseTypeNode.expression), baseTypeNode.expression, diagnostic));
	        return type.resolvedBaseTypes = emptyArray;
	      }
	      if (type === reducedBaseType || hasBaseType(reducedBaseType, type)) {
	        error2(type.symbol.valueDeclaration, Diagnostics.Type_0_recursively_references_itself_as_a_base_type, typeToString(
	          type,
	          /*enclosingDeclaration*/
	          void 0,
	          2 /* WriteArrayAsGenericType */
	        ));
	        return type.resolvedBaseTypes = emptyArray;
	      }
	      if (type.resolvedBaseTypes === resolvingEmptyArray) {
	        type.members = void 0;
	      }
	      return type.resolvedBaseTypes = [reducedBaseType];
	    }
	    function areAllOuterTypeParametersApplied(type) {
	      const outerTypeParameters = type.outerTypeParameters;
	      if (outerTypeParameters) {
	        const last2 = outerTypeParameters.length - 1;
	        const typeArguments = getTypeArguments(type);
	        return outerTypeParameters[last2].symbol !== typeArguments[last2].symbol;
	      }
	      return true;
	    }
	    function isValidBaseType(type) {
	      if (type.flags & 262144 /* TypeParameter */) {
	        const constraint = getBaseConstraintOfType(type);
	        if (constraint) {
	          return isValidBaseType(constraint);
	        }
	      }
	      return !!(type.flags & (524288 /* Object */ | 67108864 /* NonPrimitive */ | 1 /* Any */) && !isGenericMappedType(type) || type.flags & 2097152 /* Intersection */ && every(type.types, isValidBaseType));
	    }
	    function resolveBaseTypesOfInterface(type) {
	      type.resolvedBaseTypes = type.resolvedBaseTypes || emptyArray;
	      if (type.symbol.declarations) {
	        for (const declaration of type.symbol.declarations) {
	          if (declaration.kind === 264 /* InterfaceDeclaration */ && getInterfaceBaseTypeNodes(declaration)) {
	            for (const node of getInterfaceBaseTypeNodes(declaration)) {
	              const baseType = getReducedType(getTypeFromTypeNode(node));
	              if (!isErrorType(baseType)) {
	                if (isValidBaseType(baseType)) {
	                  if (type !== baseType && !hasBaseType(baseType, type)) {
	                    if (type.resolvedBaseTypes === emptyArray) {
	                      type.resolvedBaseTypes = [baseType];
	                    } else {
	                      type.resolvedBaseTypes.push(baseType);
	                    }
	                  } else {
	                    reportCircularBaseType(declaration, type);
	                  }
	                } else {
	                  error2(node, Diagnostics.An_interface_can_only_extend_an_object_type_or_intersection_of_object_types_with_statically_known_members);
	                }
	              }
	            }
	          }
	        }
	      }
	    }
	    function isThislessInterface(symbol) {
	      if (!symbol.declarations) {
	        return true;
	      }
	      for (const declaration of symbol.declarations) {
	        if (declaration.kind === 264 /* InterfaceDeclaration */) {
	          if (declaration.flags & 256 /* ContainsThis */) {
	            return false;
	          }
	          const baseTypeNodes = getInterfaceBaseTypeNodes(declaration);
	          if (baseTypeNodes) {
	            for (const node of baseTypeNodes) {
	              if (isEntityNameExpression(node.expression)) {
	                const baseSymbol = resolveEntityName(
	                  node.expression,
	                  788968 /* Type */,
	                  /*ignoreErrors*/
	                  true
	                );
	                if (!baseSymbol || !(baseSymbol.flags & 64 /* Interface */) || getDeclaredTypeOfClassOrInterface(baseSymbol).thisType) {
	                  return false;
	                }
	              }
	            }
	          }
	        }
	      }
	      return true;
	    }
	    function getDeclaredTypeOfClassOrInterface(symbol) {
	      let links = getSymbolLinks(symbol);
	      const originalLinks = links;
	      if (!links.declaredType) {
	        const kind = symbol.flags & 32 /* Class */ ? 1 /* Class */ : 2 /* Interface */;
	        const merged = mergeJSSymbols(symbol, symbol.valueDeclaration && getAssignedClassSymbol(symbol.valueDeclaration));
	        if (merged) {
	          symbol = merged;
	          links = merged.links;
	        }
	        const type = originalLinks.declaredType = links.declaredType = createObjectType(kind, symbol);
	        const outerTypeParameters = getOuterTypeParametersOfClassOrInterface(symbol);
	        const localTypeParameters = getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(symbol);
	        if (outerTypeParameters || localTypeParameters || kind === 1 /* Class */ || !isThislessInterface(symbol)) {
	          type.objectFlags |= 4 /* Reference */;
	          type.typeParameters = concatenate(outerTypeParameters, localTypeParameters);
	          type.outerTypeParameters = outerTypeParameters;
	          type.localTypeParameters = localTypeParameters;
	          type.instantiations = /* @__PURE__ */ new Map();
	          type.instantiations.set(getTypeListId(type.typeParameters), type);
	          type.target = type;
	          type.resolvedTypeArguments = type.typeParameters;
	          type.thisType = createTypeParameter(symbol);
	          type.thisType.isThisType = true;
	          type.thisType.constraint = type;
	        }
	      }
	      return links.declaredType;
	    }
	    function getDeclaredTypeOfTypeAlias(symbol) {
	      var _a;
	      const links = getSymbolLinks(symbol);
	      if (!links.declaredType) {
	        if (!pushTypeResolution(symbol, 2 /* DeclaredType */)) {
	          return errorType;
	        }
	        const declaration = Debug.checkDefined((_a = symbol.declarations) == null ? void 0 : _a.find(isTypeAlias), "Type alias symbol with no valid declaration found");
	        const typeNode = isJSDocTypeAlias(declaration) ? declaration.typeExpression : declaration.type;
	        let type = typeNode ? getTypeFromTypeNode(typeNode) : errorType;
	        if (popTypeResolution()) {
	          const typeParameters = getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(symbol);
	          if (typeParameters) {
	            links.typeParameters = typeParameters;
	            links.instantiations = /* @__PURE__ */ new Map();
	            links.instantiations.set(getTypeListId(typeParameters), type);
	          }
	        } else {
	          type = errorType;
	          if (declaration.kind === 347 /* JSDocEnumTag */) {
	            error2(declaration.typeExpression.type, Diagnostics.Type_alias_0_circularly_references_itself, symbolToString(symbol));
	          } else {
	            error2(isNamedDeclaration(declaration) ? declaration.name || declaration : declaration, Diagnostics.Type_alias_0_circularly_references_itself, symbolToString(symbol));
	          }
	        }
	        links.declaredType = type;
	      }
	      return links.declaredType;
	    }
	    function getBaseTypeOfEnumLikeType(type) {
	      return type.flags & 1056 /* EnumLike */ && type.symbol.flags & 8 /* EnumMember */ ? getDeclaredTypeOfSymbol(getParentOfSymbol(type.symbol)) : type;
	    }
	    function getDeclaredTypeOfEnum(symbol) {
	      const links = getSymbolLinks(symbol);
	      if (!links.declaredType) {
	        const memberTypeList = [];
	        if (symbol.declarations) {
	          for (const declaration of symbol.declarations) {
	            if (declaration.kind === 266 /* EnumDeclaration */) {
	              for (const member of declaration.members) {
	                if (hasBindableName(member)) {
	                  const memberSymbol = getSymbolOfDeclaration(member);
	                  const value = getEnumMemberValue(member);
	                  const memberType = getFreshTypeOfLiteralType(
	                    value !== void 0 ? getEnumLiteralType(value, getSymbolId(symbol), memberSymbol) : createComputedEnumType(memberSymbol)
	                  );
	                  getSymbolLinks(memberSymbol).declaredType = memberType;
	                  memberTypeList.push(getRegularTypeOfLiteralType(memberType));
	                }
	              }
	            }
	          }
	        }
	        const enumType = memberTypeList.length ? getUnionType(
	          memberTypeList,
	          1 /* Literal */,
	          symbol,
	          /*aliasTypeArguments*/
	          void 0
	        ) : createComputedEnumType(symbol);
	        if (enumType.flags & 1048576 /* Union */) {
	          enumType.flags |= 1024 /* EnumLiteral */;
	          enumType.symbol = symbol;
	        }
	        links.declaredType = enumType;
	      }
	      return links.declaredType;
	    }
	    function createComputedEnumType(symbol) {
	      const regularType = createTypeWithSymbol(32 /* Enum */, symbol);
	      const freshType = createTypeWithSymbol(32 /* Enum */, symbol);
	      regularType.regularType = regularType;
	      regularType.freshType = freshType;
	      freshType.regularType = regularType;
	      freshType.freshType = freshType;
	      return regularType;
	    }
	    function getDeclaredTypeOfEnumMember(symbol) {
	      const links = getSymbolLinks(symbol);
	      if (!links.declaredType) {
	        const enumType = getDeclaredTypeOfEnum(getParentOfSymbol(symbol));
	        if (!links.declaredType) {
	          links.declaredType = enumType;
	        }
	      }
	      return links.declaredType;
	    }
	    function getDeclaredTypeOfTypeParameter(symbol) {
	      const links = getSymbolLinks(symbol);
	      return links.declaredType || (links.declaredType = createTypeParameter(symbol));
	    }
	    function getDeclaredTypeOfAlias(symbol) {
	      const links = getSymbolLinks(symbol);
	      return links.declaredType || (links.declaredType = getDeclaredTypeOfSymbol(resolveAlias(symbol)));
	    }
	    function getDeclaredTypeOfSymbol(symbol) {
	      return tryGetDeclaredTypeOfSymbol(symbol) || errorType;
	    }
	    function tryGetDeclaredTypeOfSymbol(symbol) {
	      if (symbol.flags & (32 /* Class */ | 64 /* Interface */)) {
	        return getDeclaredTypeOfClassOrInterface(symbol);
	      }
	      if (symbol.flags & 524288 /* TypeAlias */) {
	        return getDeclaredTypeOfTypeAlias(symbol);
	      }
	      if (symbol.flags & 262144 /* TypeParameter */) {
	        return getDeclaredTypeOfTypeParameter(symbol);
	      }
	      if (symbol.flags & 384 /* Enum */) {
	        return getDeclaredTypeOfEnum(symbol);
	      }
	      if (symbol.flags & 8 /* EnumMember */) {
	        return getDeclaredTypeOfEnumMember(symbol);
	      }
	      if (symbol.flags & 2097152 /* Alias */) {
	        return getDeclaredTypeOfAlias(symbol);
	      }
	      return void 0;
	    }
	    function isThislessType(node) {
	      switch (node.kind) {
	        case 133 /* AnyKeyword */:
	        case 159 /* UnknownKeyword */:
	        case 154 /* StringKeyword */:
	        case 150 /* NumberKeyword */:
	        case 163 /* BigIntKeyword */:
	        case 136 /* BooleanKeyword */:
	        case 155 /* SymbolKeyword */:
	        case 151 /* ObjectKeyword */:
	        case 116 /* VoidKeyword */:
	        case 157 /* UndefinedKeyword */:
	        case 146 /* NeverKeyword */:
	        case 201 /* LiteralType */:
	          return true;
	        case 188 /* ArrayType */:
	          return isThislessType(node.elementType);
	        case 183 /* TypeReference */:
	          return !node.typeArguments || node.typeArguments.every(isThislessType);
	      }
	      return false;
	    }
	    function isThislessTypeParameter(node) {
	      const constraint = getEffectiveConstraintOfTypeParameter(node);
	      return !constraint || isThislessType(constraint);
	    }
	    function isThislessVariableLikeDeclaration(node) {
	      const typeNode = getEffectiveTypeAnnotationNode(node);
	      return typeNode ? isThislessType(typeNode) : !hasInitializer(node);
	    }
	    function isThislessFunctionLikeDeclaration(node) {
	      const returnType = getEffectiveReturnTypeNode(node);
	      const typeParameters = getEffectiveTypeParameterDeclarations(node);
	      return (node.kind === 176 /* Constructor */ || !!returnType && isThislessType(returnType)) && node.parameters.every(isThislessVariableLikeDeclaration) && typeParameters.every(isThislessTypeParameter);
	    }
	    function isThisless(symbol) {
	      if (symbol.declarations && symbol.declarations.length === 1) {
	        const declaration = symbol.declarations[0];
	        if (declaration) {
	          switch (declaration.kind) {
	            case 172 /* PropertyDeclaration */:
	            case 171 /* PropertySignature */:
	              return isThislessVariableLikeDeclaration(declaration);
	            case 174 /* MethodDeclaration */:
	            case 173 /* MethodSignature */:
	            case 176 /* Constructor */:
	            case 177 /* GetAccessor */:
	            case 178 /* SetAccessor */:
	              return isThislessFunctionLikeDeclaration(declaration);
	          }
	        }
	      }
	      return false;
	    }
	    function createInstantiatedSymbolTable(symbols, mapper, mappingThisOnly) {
	      const result = createSymbolTable();
	      for (const symbol of symbols) {
	        result.set(symbol.escapedName, mappingThisOnly && isThisless(symbol) ? symbol : instantiateSymbol(symbol, mapper));
	      }
	      return result;
	    }
	    function addInheritedMembers(symbols, baseSymbols) {
	      for (const base of baseSymbols) {
	        if (isStaticPrivateIdentifierProperty(base)) {
	          continue;
	        }
	        const derived = symbols.get(base.escapedName);
	        if (!derived || derived.valueDeclaration && isBinaryExpression(derived.valueDeclaration) && !isConstructorDeclaredProperty(derived) && !getContainingClassStaticBlock(derived.valueDeclaration)) {
	          symbols.set(base.escapedName, base);
	          symbols.set(base.escapedName, base);
	        }
	      }
	    }
	    function isStaticPrivateIdentifierProperty(s) {
	      return !!s.valueDeclaration && isPrivateIdentifierClassElementDeclaration(s.valueDeclaration) && isStatic(s.valueDeclaration);
	    }
	    function resolveDeclaredMembers(type) {
	      if (!type.declaredProperties) {
	        const symbol = type.symbol;
	        const members = getMembersOfSymbol(symbol);
	        type.declaredProperties = getNamedMembers(members);
	        type.declaredCallSignatures = emptyArray;
	        type.declaredConstructSignatures = emptyArray;
	        type.declaredIndexInfos = emptyArray;
	        type.declaredCallSignatures = getSignaturesOfSymbol(members.get("__call" /* Call */));
	        type.declaredConstructSignatures = getSignaturesOfSymbol(members.get("__new" /* New */));
	        type.declaredIndexInfos = getIndexInfosOfSymbol(symbol);
	      }
	      return type;
	    }
	    function isLateBindableName(node) {
	      if (!isComputedPropertyName(node) && !isElementAccessExpression(node)) {
	        return false;
	      }
	      const expr = isComputedPropertyName(node) ? node.expression : node.argumentExpression;
	      return isEntityNameExpression(expr) && isTypeUsableAsPropertyName(isComputedPropertyName(node) ? checkComputedPropertyName(node) : checkExpressionCached(expr));
	    }
	    function isLateBoundName(name) {
	      return name.charCodeAt(0) === 95 /* _ */ && name.charCodeAt(1) === 95 /* _ */ && name.charCodeAt(2) === 64 /* at */;
	    }
	    function hasLateBindableName(node) {
	      const name = getNameOfDeclaration(node);
	      return !!name && isLateBindableName(name);
	    }
	    function hasBindableName(node) {
	      return !hasDynamicName(node) || hasLateBindableName(node);
	    }
	    function isNonBindableDynamicName(node) {
	      return isDynamicName(node) && !isLateBindableName(node);
	    }
	    function addDeclarationToLateBoundSymbol(symbol, member, symbolFlags) {
	      Debug.assert(!!(getCheckFlags(symbol) & 4096 /* Late */), "Expected a late-bound symbol.");
	      symbol.flags |= symbolFlags;
	      getSymbolLinks(member.symbol).lateSymbol = symbol;
	      if (!symbol.declarations) {
	        symbol.declarations = [member];
	      } else if (!member.symbol.isReplaceableByMethod) {
	        symbol.declarations.push(member);
	      }
	      if (symbolFlags & 111551 /* Value */) {
	        if (!symbol.valueDeclaration || symbol.valueDeclaration.kind !== member.kind) {
	          symbol.valueDeclaration = member;
	        }
	      }
	    }
	    function lateBindMember(parent2, earlySymbols, lateSymbols, decl) {
	      Debug.assert(!!decl.symbol, "The member is expected to have a symbol.");
	      const links = getNodeLinks(decl);
	      if (!links.resolvedSymbol) {
	        links.resolvedSymbol = decl.symbol;
	        const declName = isBinaryExpression(decl) ? decl.left : decl.name;
	        const type = isElementAccessExpression(declName) ? checkExpressionCached(declName.argumentExpression) : checkComputedPropertyName(declName);
	        if (isTypeUsableAsPropertyName(type)) {
	          const memberName = getPropertyNameFromType(type);
	          const symbolFlags = decl.symbol.flags;
	          let lateSymbol = lateSymbols.get(memberName);
	          if (!lateSymbol)
	            lateSymbols.set(memberName, lateSymbol = createSymbol(0 /* None */, memberName, 4096 /* Late */));
	          const earlySymbol = earlySymbols && earlySymbols.get(memberName);
	          if (!(parent2.flags & 32 /* Class */) && (lateSymbol.flags & getExcludedSymbolFlags(symbolFlags) || earlySymbol)) {
	            const declarations = earlySymbol ? concatenate(earlySymbol.declarations, lateSymbol.declarations) : lateSymbol.declarations;
	            const name = !(type.flags & 8192 /* UniqueESSymbol */) && unescapeLeadingUnderscores(memberName) || declarationNameToString(declName);
	            forEach(declarations, (declaration) => error2(getNameOfDeclaration(declaration) || declaration, Diagnostics.Property_0_was_also_declared_here, name));
	            error2(declName || decl, Diagnostics.Duplicate_property_0, name);
	            lateSymbol = createSymbol(0 /* None */, memberName, 4096 /* Late */);
	          }
	          lateSymbol.links.nameType = type;
	          addDeclarationToLateBoundSymbol(lateSymbol, decl, symbolFlags);
	          if (lateSymbol.parent) {
	            Debug.assert(lateSymbol.parent === parent2, "Existing symbol parent should match new one");
	          } else {
	            lateSymbol.parent = parent2;
	          }
	          return links.resolvedSymbol = lateSymbol;
	        }
	      }
	      return links.resolvedSymbol;
	    }
	    function getResolvedMembersOrExportsOfSymbol(symbol, resolutionKind) {
	      const links = getSymbolLinks(symbol);
	      if (!links[resolutionKind]) {
	        const isStatic2 = resolutionKind === "resolvedExports" /* resolvedExports */;
	        const earlySymbols = !isStatic2 ? symbol.members : symbol.flags & 1536 /* Module */ ? getExportsOfModuleWorker(symbol).exports : symbol.exports;
	        links[resolutionKind] = earlySymbols || emptySymbols;
	        const lateSymbols = createSymbolTable();
	        for (const decl of symbol.declarations || emptyArray) {
	          const members = getMembersOfDeclaration(decl);
	          if (members) {
	            for (const member of members) {
	              if (isStatic2 === hasStaticModifier(member)) {
	                if (hasLateBindableName(member)) {
	                  lateBindMember(symbol, earlySymbols, lateSymbols, member);
	                }
	              }
	            }
	          }
	        }
	        const assignments = getFunctionExpressionParentSymbolOrSymbol(symbol).assignmentDeclarationMembers;
	        if (assignments) {
	          const decls = arrayFrom(assignments.values());
	          for (const member of decls) {
	            const assignmentKind = getAssignmentDeclarationKind(member);
	            const isInstanceMember = assignmentKind === 3 /* PrototypeProperty */ || isBinaryExpression(member) && isPossiblyAliasedThisProperty(member, assignmentKind) || assignmentKind === 9 /* ObjectDefinePrototypeProperty */ || assignmentKind === 6 /* Prototype */;
	            if (isStatic2 === !isInstanceMember) {
	              if (hasLateBindableName(member)) {
	                lateBindMember(symbol, earlySymbols, lateSymbols, member);
	              }
	            }
	          }
	        }
	        let resolved = combineSymbolTables(earlySymbols, lateSymbols);
	        if (symbol.flags & 33554432 /* Transient */ && links.cjsExportMerged && symbol.declarations) {
	          for (const decl of symbol.declarations) {
	            const original = getSymbolLinks(decl.symbol)[resolutionKind];
	            if (!resolved) {
	              resolved = original;
	              continue;
	            }
	            if (!original)
	              continue;
	            original.forEach((s, name) => {
	              const existing = resolved.get(name);
	              if (!existing)
	                resolved.set(name, s);
	              else if (existing === s)
	                return;
	              else
	                resolved.set(name, mergeSymbol(existing, s));
	            });
	          }
	        }
	        links[resolutionKind] = resolved || emptySymbols;
	      }
	      return links[resolutionKind];
	    }
	    function getMembersOfSymbol(symbol) {
	      return symbol.flags & 6256 /* LateBindingContainer */ ? getResolvedMembersOrExportsOfSymbol(symbol, "resolvedMembers" /* resolvedMembers */) : symbol.members || emptySymbols;
	    }
	    function getLateBoundSymbol(symbol) {
	      if (symbol.flags & 106500 /* ClassMember */ && symbol.escapedName === "__computed" /* Computed */) {
	        const links = getSymbolLinks(symbol);
	        if (!links.lateSymbol && some(symbol.declarations, hasLateBindableName)) {
	          const parent2 = getMergedSymbol(symbol.parent);
	          if (some(symbol.declarations, hasStaticModifier)) {
	            getExportsOfSymbol(parent2);
	          } else {
	            getMembersOfSymbol(parent2);
	          }
	        }
	        return links.lateSymbol || (links.lateSymbol = symbol);
	      }
	      return symbol;
	    }
	    function getTypeWithThisArgument(type, thisArgument, needApparentType) {
	      if (getObjectFlags(type) & 4 /* Reference */) {
	        const target = type.target;
	        const typeArguments = getTypeArguments(type);
	        return length(target.typeParameters) === length(typeArguments) ? createTypeReference(target, concatenate(typeArguments, [thisArgument || target.thisType])) : type;
	      } else if (type.flags & 2097152 /* Intersection */) {
	        const types = sameMap(type.types, (t) => getTypeWithThisArgument(t, thisArgument, needApparentType));
	        return types !== type.types ? getIntersectionType(types) : type;
	      }
	      return needApparentType ? getApparentType(type) : type;
	    }
	    function resolveObjectTypeMembers(type, source, typeParameters, typeArguments) {
	      let mapper;
	      let members;
	      let callSignatures;
	      let constructSignatures;
	      let indexInfos;
	      if (rangeEquals(typeParameters, typeArguments, 0, typeParameters.length)) {
	        members = source.symbol ? getMembersOfSymbol(source.symbol) : createSymbolTable(source.declaredProperties);
	        callSignatures = source.declaredCallSignatures;
	        constructSignatures = source.declaredConstructSignatures;
	        indexInfos = source.declaredIndexInfos;
	      } else {
	        mapper = createTypeMapper(typeParameters, typeArguments);
	        members = createInstantiatedSymbolTable(
	          source.declaredProperties,
	          mapper,
	          /*mappingThisOnly*/
	          typeParameters.length === 1
	        );
	        callSignatures = instantiateSignatures(source.declaredCallSignatures, mapper);
	        constructSignatures = instantiateSignatures(source.declaredConstructSignatures, mapper);
	        indexInfos = instantiateIndexInfos(source.declaredIndexInfos, mapper);
	      }
	      const baseTypes = getBaseTypes(source);
	      if (baseTypes.length) {
	        if (source.symbol && members === getMembersOfSymbol(source.symbol)) {
	          const symbolTable = createSymbolTable(source.declaredProperties);
	          const sourceIndex = getIndexSymbol(source.symbol);
	          if (sourceIndex) {
	            symbolTable.set("__index" /* Index */, sourceIndex);
	          }
	          members = symbolTable;
	        }
	        setStructuredTypeMembers(type, members, callSignatures, constructSignatures, indexInfos);
	        const thisArgument = lastOrUndefined(typeArguments);
	        for (const baseType of baseTypes) {
	          const instantiatedBaseType = thisArgument ? getTypeWithThisArgument(instantiateType(baseType, mapper), thisArgument) : baseType;
	          addInheritedMembers(members, getPropertiesOfType(instantiatedBaseType));
	          callSignatures = concatenate(callSignatures, getSignaturesOfType(instantiatedBaseType, 0 /* Call */));
	          constructSignatures = concatenate(constructSignatures, getSignaturesOfType(instantiatedBaseType, 1 /* Construct */));
	          const inheritedIndexInfos = instantiatedBaseType !== anyType ? getIndexInfosOfType(instantiatedBaseType) : [createIndexInfo(
	            stringType,
	            anyType,
	            /*isReadonly*/
	            false
	          )];
	          indexInfos = concatenate(indexInfos, filter(inheritedIndexInfos, (info) => !findIndexInfo(indexInfos, info.keyType)));
	        }
	      }
	      setStructuredTypeMembers(type, members, callSignatures, constructSignatures, indexInfos);
	    }
	    function resolveClassOrInterfaceMembers(type) {
	      resolveObjectTypeMembers(type, resolveDeclaredMembers(type), emptyArray, emptyArray);
	    }
	    function resolveTypeReferenceMembers(type) {
	      const source = resolveDeclaredMembers(type.target);
	      const typeParameters = concatenate(source.typeParameters, [source.thisType]);
	      const typeArguments = getTypeArguments(type);
	      const paddedTypeArguments = typeArguments.length === typeParameters.length ? typeArguments : concatenate(typeArguments, [type]);
	      resolveObjectTypeMembers(type, source, typeParameters, paddedTypeArguments);
	    }
	    function createSignature(declaration, typeParameters, thisParameter, parameters, resolvedReturnType, resolvedTypePredicate, minArgumentCount, flags) {
	      const sig = new Signature14(checker, flags);
	      sig.declaration = declaration;
	      sig.typeParameters = typeParameters;
	      sig.parameters = parameters;
	      sig.thisParameter = thisParameter;
	      sig.resolvedReturnType = resolvedReturnType;
	      sig.resolvedTypePredicate = resolvedTypePredicate;
	      sig.minArgumentCount = minArgumentCount;
	      sig.resolvedMinArgumentCount = void 0;
	      sig.target = void 0;
	      sig.mapper = void 0;
	      sig.compositeSignatures = void 0;
	      sig.compositeKind = void 0;
	      return sig;
	    }
	    function cloneSignature(sig) {
	      const result = createSignature(
	        sig.declaration,
	        sig.typeParameters,
	        sig.thisParameter,
	        sig.parameters,
	        /*resolvedReturnType*/
	        void 0,
	        /*resolvedTypePredicate*/
	        void 0,
	        sig.minArgumentCount,
	        sig.flags & 167 /* PropagatingFlags */
	      );
	      result.target = sig.target;
	      result.mapper = sig.mapper;
	      result.compositeSignatures = sig.compositeSignatures;
	      result.compositeKind = sig.compositeKind;
	      return result;
	    }
	    function createUnionSignature(signature, unionSignatures) {
	      const result = cloneSignature(signature);
	      result.compositeSignatures = unionSignatures;
	      result.compositeKind = 1048576 /* Union */;
	      result.target = void 0;
	      result.mapper = void 0;
	      return result;
	    }
	    function getOptionalCallSignature(signature, callChainFlags) {
	      if ((signature.flags & 24 /* CallChainFlags */) === callChainFlags) {
	        return signature;
	      }
	      if (!signature.optionalCallSignatureCache) {
	        signature.optionalCallSignatureCache = {};
	      }
	      const key = callChainFlags === 8 /* IsInnerCallChain */ ? "inner" : "outer";
	      return signature.optionalCallSignatureCache[key] || (signature.optionalCallSignatureCache[key] = createOptionalCallSignature(signature, callChainFlags));
	    }
	    function createOptionalCallSignature(signature, callChainFlags) {
	      Debug.assert(callChainFlags === 8 /* IsInnerCallChain */ || callChainFlags === 16 /* IsOuterCallChain */, "An optional call signature can either be for an inner call chain or an outer call chain, but not both.");
	      const result = cloneSignature(signature);
	      result.flags |= callChainFlags;
	      return result;
	    }
	    function getExpandedParameters(sig, skipUnionExpanding) {
	      if (signatureHasRestParameter(sig)) {
	        const restIndex = sig.parameters.length - 1;
	        const restName = sig.parameters[restIndex].escapedName;
	        const restType = getTypeOfSymbol(sig.parameters[restIndex]);
	        if (isTupleType(restType)) {
	          return [expandSignatureParametersWithTupleMembers(restType, restIndex, restName)];
	        } else if (!skipUnionExpanding && restType.flags & 1048576 /* Union */ && every(restType.types, isTupleType)) {
	          return map(restType.types, (t) => expandSignatureParametersWithTupleMembers(t, restIndex, restName));
	        }
	      }
	      return [sig.parameters];
	      function expandSignatureParametersWithTupleMembers(restType, restIndex, restName) {
	        const elementTypes = getTypeArguments(restType);
	        const associatedNames = getUniqAssociatedNamesFromTupleType(restType, restName);
	        const restParams = map(elementTypes, (t, i) => {
	          const name = associatedNames && associatedNames[i] ? associatedNames[i] : getParameterNameAtPosition(sig, restIndex + i, restType);
	          const flags = restType.target.elementFlags[i];
	          const checkFlags = flags & 12 /* Variable */ ? 32768 /* RestParameter */ : flags & 2 /* Optional */ ? 16384 /* OptionalParameter */ : 0;
	          const symbol = createSymbol(1 /* FunctionScopedVariable */, name, checkFlags);
	          symbol.links.type = flags & 4 /* Rest */ ? createArrayType(t) : t;
	          return symbol;
	        });
	        return concatenate(sig.parameters.slice(0, restIndex), restParams);
	      }
	      function getUniqAssociatedNamesFromTupleType(type, restName) {
	        const associatedNamesMap = /* @__PURE__ */ new Map();
	        return map(type.target.labeledElementDeclarations, (labeledElement, i) => {
	          const name = getTupleElementLabel(labeledElement, i, restName);
	          const prevCounter = associatedNamesMap.get(name);
	          if (prevCounter === void 0) {
	            associatedNamesMap.set(name, 1);
	            return name;
	          } else {
	            associatedNamesMap.set(name, prevCounter + 1);
	            return `${name}_${prevCounter}`;
	          }
	        });
	      }
	    }
	    function getDefaultConstructSignatures(classType) {
	      const baseConstructorType = getBaseConstructorTypeOfClass(classType);
	      const baseSignatures = getSignaturesOfType(baseConstructorType, 1 /* Construct */);
	      const declaration = getClassLikeDeclarationOfSymbol(classType.symbol);
	      const isAbstract = !!declaration && hasSyntacticModifier(declaration, 64 /* Abstract */);
	      if (baseSignatures.length === 0) {
	        return [createSignature(
	          /*declaration*/
	          void 0,
	          classType.localTypeParameters,
	          /*thisParameter*/
	          void 0,
	          emptyArray,
	          classType,
	          /*resolvedTypePredicate*/
	          void 0,
	          0,
	          isAbstract ? 4 /* Abstract */ : 0 /* None */
	        )];
	      }
	      const baseTypeNode = getBaseTypeNodeOfClass(classType);
	      const isJavaScript = isInJSFile(baseTypeNode);
	      const typeArguments = typeArgumentsFromTypeReferenceNode(baseTypeNode);
	      const typeArgCount = length(typeArguments);
	      const result = [];
	      for (const baseSig of baseSignatures) {
	        const minTypeArgumentCount = getMinTypeArgumentCount(baseSig.typeParameters);
	        const typeParamCount = length(baseSig.typeParameters);
	        if (isJavaScript || typeArgCount >= minTypeArgumentCount && typeArgCount <= typeParamCount) {
	          const sig = typeParamCount ? createSignatureInstantiation(baseSig, fillMissingTypeArguments(typeArguments, baseSig.typeParameters, minTypeArgumentCount, isJavaScript)) : cloneSignature(baseSig);
	          sig.typeParameters = classType.localTypeParameters;
	          sig.resolvedReturnType = classType;
	          sig.flags = isAbstract ? sig.flags | 4 /* Abstract */ : sig.flags & ~4 /* Abstract */;
	          result.push(sig);
	        }
	      }
	      return result;
	    }
	    function findMatchingSignature(signatureList, signature, partialMatch, ignoreThisTypes, ignoreReturnTypes) {
	      for (const s of signatureList) {
	        if (compareSignaturesIdentical(s, signature, partialMatch, ignoreThisTypes, ignoreReturnTypes, partialMatch ? compareTypesSubtypeOf : compareTypesIdentical)) {
	          return s;
	        }
	      }
	    }
	    function findMatchingSignatures(signatureLists, signature, listIndex) {
	      if (signature.typeParameters) {
	        if (listIndex > 0) {
	          return void 0;
	        }
	        for (let i = 1; i < signatureLists.length; i++) {
	          if (!findMatchingSignature(
	            signatureLists[i],
	            signature,
	            /*partialMatch*/
	            false,
	            /*ignoreThisTypes*/
	            false,
	            /*ignoreReturnTypes*/
	            false
	          )) {
	            return void 0;
	          }
	        }
	        return [signature];
	      }
	      let result;
	      for (let i = 0; i < signatureLists.length; i++) {
	        const match = i === listIndex ? signature : findMatchingSignature(
	          signatureLists[i],
	          signature,
	          /*partialMatch*/
	          false,
	          /*ignoreThisTypes*/
	          false,
	          /*ignoreReturnTypes*/
	          true
	        ) || findMatchingSignature(
	          signatureLists[i],
	          signature,
	          /*partialMatch*/
	          true,
	          /*ignoreThisTypes*/
	          false,
	          /*ignoreReturnTypes*/
	          true
	        );
	        if (!match) {
	          return void 0;
	        }
	        result = appendIfUnique(result, match);
	      }
	      return result;
	    }
	    function getUnionSignatures(signatureLists) {
	      let result;
	      let indexWithLengthOverOne;
	      for (let i = 0; i < signatureLists.length; i++) {
	        if (signatureLists[i].length === 0)
	          return emptyArray;
	        if (signatureLists[i].length > 1) {
	          indexWithLengthOverOne = indexWithLengthOverOne === void 0 ? i : -1;
	        }
	        for (const signature of signatureLists[i]) {
	          if (!result || !findMatchingSignature(
	            result,
	            signature,
	            /*partialMatch*/
	            false,
	            /*ignoreThisTypes*/
	            false,
	            /*ignoreReturnTypes*/
	            true
	          )) {
	            const unionSignatures = findMatchingSignatures(signatureLists, signature, i);
	            if (unionSignatures) {
	              let s = signature;
	              if (unionSignatures.length > 1) {
	                let thisParameter = signature.thisParameter;
	                const firstThisParameterOfUnionSignatures = forEach(unionSignatures, (sig) => sig.thisParameter);
	                if (firstThisParameterOfUnionSignatures) {
	                  const thisType = getIntersectionType(mapDefined(unionSignatures, (sig) => sig.thisParameter && getTypeOfSymbol(sig.thisParameter)));
	                  thisParameter = createSymbolWithType(firstThisParameterOfUnionSignatures, thisType);
	                }
	                s = createUnionSignature(signature, unionSignatures);
	                s.thisParameter = thisParameter;
	              }
	              (result || (result = [])).push(s);
	            }
	          }
	        }
	      }
	      if (!length(result) && indexWithLengthOverOne !== -1) {
	        const masterList = signatureLists[indexWithLengthOverOne !== void 0 ? indexWithLengthOverOne : 0];
	        let results = masterList.slice();
	        for (const signatures of signatureLists) {
	          if (signatures !== masterList) {
	            const signature = signatures[0];
	            Debug.assert(!!signature, "getUnionSignatures bails early on empty signature lists and should not have empty lists on second pass");
	            results = !!signature.typeParameters && some(results, (s) => !!s.typeParameters && !compareTypeParametersIdentical(signature.typeParameters, s.typeParameters)) ? void 0 : map(results, (sig) => combineSignaturesOfUnionMembers(sig, signature));
	            if (!results) {
	              break;
	            }
	          }
	        }
	        result = results;
	      }
	      return result || emptyArray;
	    }
	    function compareTypeParametersIdentical(sourceParams, targetParams) {
	      if (length(sourceParams) !== length(targetParams)) {
	        return false;
	      }
	      if (!sourceParams || !targetParams) {
	        return true;
	      }
	      const mapper = createTypeMapper(targetParams, sourceParams);
	      for (let i = 0; i < sourceParams.length; i++) {
	        const source = sourceParams[i];
	        const target = targetParams[i];
	        if (source === target)
	          continue;
	        if (!isTypeIdenticalTo(getConstraintFromTypeParameter(source) || unknownType, instantiateType(getConstraintFromTypeParameter(target) || unknownType, mapper)))
	          return false;
	      }
	      return true;
	    }
	    function combineUnionThisParam(left, right, mapper) {
	      if (!left || !right) {
	        return left || right;
	      }
	      const thisType = getIntersectionType([getTypeOfSymbol(left), instantiateType(getTypeOfSymbol(right), mapper)]);
	      return createSymbolWithType(left, thisType);
	    }
	    function combineUnionParameters(left, right, mapper) {
	      const leftCount = getParameterCount(left);
	      const rightCount = getParameterCount(right);
	      const longest = leftCount >= rightCount ? left : right;
	      const shorter = longest === left ? right : left;
	      const longestCount = longest === left ? leftCount : rightCount;
	      const eitherHasEffectiveRest = hasEffectiveRestParameter(left) || hasEffectiveRestParameter(right);
	      const needsExtraRestElement = eitherHasEffectiveRest && !hasEffectiveRestParameter(longest);
	      const params = new Array(longestCount + (needsExtraRestElement ? 1 : 0));
	      for (let i = 0; i < longestCount; i++) {
	        let longestParamType = tryGetTypeAtPosition(longest, i);
	        if (longest === right) {
	          longestParamType = instantiateType(longestParamType, mapper);
	        }
	        let shorterParamType = tryGetTypeAtPosition(shorter, i) || unknownType;
	        if (shorter === right) {
	          shorterParamType = instantiateType(shorterParamType, mapper);
	        }
	        const unionParamType = getIntersectionType([longestParamType, shorterParamType]);
	        const isRestParam = eitherHasEffectiveRest && !needsExtraRestElement && i === longestCount - 1;
	        const isOptional = i >= getMinArgumentCount(longest) && i >= getMinArgumentCount(shorter);
	        const leftName = i >= leftCount ? void 0 : getParameterNameAtPosition(left, i);
	        const rightName = i >= rightCount ? void 0 : getParameterNameAtPosition(right, i);
	        const paramName = leftName === rightName ? leftName : !leftName ? rightName : !rightName ? leftName : void 0;
	        const paramSymbol = createSymbol(
	          1 /* FunctionScopedVariable */ | (isOptional && !isRestParam ? 16777216 /* Optional */ : 0),
	          paramName || `arg${i}`,
	          isRestParam ? 32768 /* RestParameter */ : isOptional ? 16384 /* OptionalParameter */ : 0
	        );
	        paramSymbol.links.type = isRestParam ? createArrayType(unionParamType) : unionParamType;
	        params[i] = paramSymbol;
	      }
	      if (needsExtraRestElement) {
	        const restParamSymbol = createSymbol(1 /* FunctionScopedVariable */, "args", 32768 /* RestParameter */);
	        restParamSymbol.links.type = createArrayType(getTypeAtPosition(shorter, longestCount));
	        if (shorter === right) {
	          restParamSymbol.links.type = instantiateType(restParamSymbol.links.type, mapper);
	        }
	        params[longestCount] = restParamSymbol;
	      }
	      return params;
	    }
	    function combineSignaturesOfUnionMembers(left, right) {
	      const typeParams = left.typeParameters || right.typeParameters;
	      let paramMapper;
	      if (left.typeParameters && right.typeParameters) {
	        paramMapper = createTypeMapper(right.typeParameters, left.typeParameters);
	      }
	      const declaration = left.declaration;
	      const params = combineUnionParameters(left, right, paramMapper);
	      const thisParam = combineUnionThisParam(left.thisParameter, right.thisParameter, paramMapper);
	      const minArgCount = Math.max(left.minArgumentCount, right.minArgumentCount);
	      const result = createSignature(
	        declaration,
	        typeParams,
	        thisParam,
	        params,
	        /*resolvedReturnType*/
	        void 0,
	        /*resolvedTypePredicate*/
	        void 0,
	        minArgCount,
	        (left.flags | right.flags) & 167 /* PropagatingFlags */
	      );
	      result.compositeKind = 1048576 /* Union */;
	      result.compositeSignatures = concatenate(left.compositeKind !== 2097152 /* Intersection */ && left.compositeSignatures || [left], [right]);
	      if (paramMapper) {
	        result.mapper = left.compositeKind !== 2097152 /* Intersection */ && left.mapper && left.compositeSignatures ? combineTypeMappers(left.mapper, paramMapper) : paramMapper;
	      } else if (left.compositeKind !== 2097152 /* Intersection */ && left.mapper && left.compositeSignatures) {
	        result.mapper = left.mapper;
	      }
	      return result;
	    }
	    function getUnionIndexInfos(types) {
	      const sourceInfos = getIndexInfosOfType(types[0]);
	      if (sourceInfos) {
	        const result = [];
	        for (const info of sourceInfos) {
	          const indexType = info.keyType;
	          if (every(types, (t) => !!getIndexInfoOfType(t, indexType))) {
	            result.push(createIndexInfo(indexType, getUnionType(map(types, (t) => getIndexTypeOfType(t, indexType))), some(types, (t) => getIndexInfoOfType(t, indexType).isReadonly)));
	          }
	        }
	        return result;
	      }
	      return emptyArray;
	    }
	    function resolveUnionTypeMembers(type) {
	      const callSignatures = getUnionSignatures(map(type.types, (t) => t === globalFunctionType ? [unknownSignature] : getSignaturesOfType(t, 0 /* Call */)));
	      const constructSignatures = getUnionSignatures(map(type.types, (t) => getSignaturesOfType(t, 1 /* Construct */)));
	      const indexInfos = getUnionIndexInfos(type.types);
	      setStructuredTypeMembers(type, emptySymbols, callSignatures, constructSignatures, indexInfos);
	    }
	    function intersectTypes(type1, type2) {
	      return !type1 ? type2 : !type2 ? type1 : getIntersectionType([type1, type2]);
	    }
	    function findMixins(types) {
	      const constructorTypeCount = countWhere(types, (t) => getSignaturesOfType(t, 1 /* Construct */).length > 0);
	      const mixinFlags = map(types, isMixinConstructorType);
	      if (constructorTypeCount > 0 && constructorTypeCount === countWhere(mixinFlags, (b) => b)) {
	        const firstMixinIndex = mixinFlags.indexOf(
	          /*searchElement*/
	          true
	        );
	        mixinFlags[firstMixinIndex] = false;
	      }
	      return mixinFlags;
	    }
	    function includeMixinType(type, types, mixinFlags, index) {
	      const mixedTypes = [];
	      for (let i = 0; i < types.length; i++) {
	        if (i === index) {
	          mixedTypes.push(type);
	        } else if (mixinFlags[i]) {
	          mixedTypes.push(getReturnTypeOfSignature(getSignaturesOfType(types[i], 1 /* Construct */)[0]));
	        }
	      }
	      return getIntersectionType(mixedTypes);
	    }
	    function resolveIntersectionTypeMembers(type) {
	      let callSignatures;
	      let constructSignatures;
	      let indexInfos;
	      const types = type.types;
	      const mixinFlags = findMixins(types);
	      const mixinCount = countWhere(mixinFlags, (b) => b);
	      for (let i = 0; i < types.length; i++) {
	        const t = type.types[i];
	        if (!mixinFlags[i]) {
	          let signatures = getSignaturesOfType(t, 1 /* Construct */);
	          if (signatures.length && mixinCount > 0) {
	            signatures = map(signatures, (s) => {
	              const clone2 = cloneSignature(s);
	              clone2.resolvedReturnType = includeMixinType(getReturnTypeOfSignature(s), types, mixinFlags, i);
	              return clone2;
	            });
	          }
	          constructSignatures = appendSignatures(constructSignatures, signatures);
	        }
	        callSignatures = appendSignatures(callSignatures, getSignaturesOfType(t, 0 /* Call */));
	        indexInfos = reduceLeft(getIndexInfosOfType(t), (infos, newInfo) => appendIndexInfo(
	          infos,
	          newInfo,
	          /*union*/
	          false
	        ), indexInfos);
	      }
	      setStructuredTypeMembers(type, emptySymbols, callSignatures || emptyArray, constructSignatures || emptyArray, indexInfos || emptyArray);
	    }
	    function appendSignatures(signatures, newSignatures) {
	      for (const sig of newSignatures) {
	        if (!signatures || every(signatures, (s) => !compareSignaturesIdentical(
	          s,
	          sig,
	          /*partialMatch*/
	          false,
	          /*ignoreThisTypes*/
	          false,
	          /*ignoreReturnTypes*/
	          false,
	          compareTypesIdentical
	        ))) {
	          signatures = append(signatures, sig);
	        }
	      }
	      return signatures;
	    }
	    function appendIndexInfo(indexInfos, newInfo, union) {
	      if (indexInfos) {
	        for (let i = 0; i < indexInfos.length; i++) {
	          const info = indexInfos[i];
	          if (info.keyType === newInfo.keyType) {
	            indexInfos[i] = createIndexInfo(info.keyType, union ? getUnionType([info.type, newInfo.type]) : getIntersectionType([info.type, newInfo.type]), union ? info.isReadonly || newInfo.isReadonly : info.isReadonly && newInfo.isReadonly);
	            return indexInfos;
	          }
	        }
	      }
	      return append(indexInfos, newInfo);
	    }
	    function resolveAnonymousTypeMembers(type) {
	      if (type.target) {
	        setStructuredTypeMembers(type, emptySymbols, emptyArray, emptyArray, emptyArray);
	        const members2 = createInstantiatedSymbolTable(
	          getPropertiesOfObjectType(type.target),
	          type.mapper,
	          /*mappingThisOnly*/
	          false
	        );
	        const callSignatures = instantiateSignatures(getSignaturesOfType(type.target, 0 /* Call */), type.mapper);
	        const constructSignatures = instantiateSignatures(getSignaturesOfType(type.target, 1 /* Construct */), type.mapper);
	        const indexInfos2 = instantiateIndexInfos(getIndexInfosOfType(type.target), type.mapper);
	        setStructuredTypeMembers(type, members2, callSignatures, constructSignatures, indexInfos2);
	        return;
	      }
	      const symbol = getMergedSymbol(type.symbol);
	      if (symbol.flags & 2048 /* TypeLiteral */) {
	        setStructuredTypeMembers(type, emptySymbols, emptyArray, emptyArray, emptyArray);
	        const members2 = getMembersOfSymbol(symbol);
	        const callSignatures = getSignaturesOfSymbol(members2.get("__call" /* Call */));
	        const constructSignatures = getSignaturesOfSymbol(members2.get("__new" /* New */));
	        const indexInfos2 = getIndexInfosOfSymbol(symbol);
	        setStructuredTypeMembers(type, members2, callSignatures, constructSignatures, indexInfos2);
	        return;
	      }
	      let members = getExportsOfSymbol(symbol);
	      let indexInfos;
	      if (symbol === globalThisSymbol) {
	        const varsOnly = /* @__PURE__ */ new Map();
	        members.forEach((p) => {
	          var _a;
	          if (!(p.flags & 418 /* BlockScoped */) && !(p.flags & 512 /* ValueModule */ && ((_a = p.declarations) == null ? void 0 : _a.length) && every(p.declarations, isAmbientModule))) {
	            varsOnly.set(p.escapedName, p);
	          }
	        });
	        members = varsOnly;
	      }
	      let baseConstructorIndexInfo;
	      setStructuredTypeMembers(type, members, emptyArray, emptyArray, emptyArray);
	      if (symbol.flags & 32 /* Class */) {
	        const classType = getDeclaredTypeOfClassOrInterface(symbol);
	        const baseConstructorType = getBaseConstructorTypeOfClass(classType);
	        if (baseConstructorType.flags & (524288 /* Object */ | 2097152 /* Intersection */ | 8650752 /* TypeVariable */)) {
	          members = createSymbolTable(getNamedOrIndexSignatureMembers(members));
	          addInheritedMembers(members, getPropertiesOfType(baseConstructorType));
	        } else if (baseConstructorType === anyType) {
	          baseConstructorIndexInfo = createIndexInfo(
	            stringType,
	            anyType,
	            /*isReadonly*/
	            false
	          );
	        }
	      }
	      const indexSymbol = getIndexSymbolFromSymbolTable(members);
	      if (indexSymbol) {
	        indexInfos = getIndexInfosOfIndexSymbol(indexSymbol);
	      } else {
	        if (baseConstructorIndexInfo) {
	          indexInfos = append(indexInfos, baseConstructorIndexInfo);
	        }
	        if (symbol.flags & 384 /* Enum */ && (getDeclaredTypeOfSymbol(symbol).flags & 32 /* Enum */ || some(type.properties, (prop) => !!(getTypeOfSymbol(prop).flags & 296 /* NumberLike */)))) {
	          indexInfos = append(indexInfos, enumNumberIndexInfo);
	        }
	      }
	      setStructuredTypeMembers(type, members, emptyArray, emptyArray, indexInfos || emptyArray);
	      if (symbol.flags & (16 /* Function */ | 8192 /* Method */)) {
	        type.callSignatures = getSignaturesOfSymbol(symbol);
	      }
	      if (symbol.flags & 32 /* Class */) {
	        const classType = getDeclaredTypeOfClassOrInterface(symbol);
	        let constructSignatures = symbol.members ? getSignaturesOfSymbol(symbol.members.get("__constructor" /* Constructor */)) : emptyArray;
	        if (symbol.flags & 16 /* Function */) {
	          constructSignatures = addRange(
	            constructSignatures.slice(),
	            mapDefined(
	              type.callSignatures,
	              (sig) => isJSConstructor(sig.declaration) ? createSignature(
	                sig.declaration,
	                sig.typeParameters,
	                sig.thisParameter,
	                sig.parameters,
	                classType,
	                /*resolvedTypePredicate*/
	                void 0,
	                sig.minArgumentCount,
	                sig.flags & 167 /* PropagatingFlags */
	              ) : void 0
	            )
	          );
	        }
	        if (!constructSignatures.length) {
	          constructSignatures = getDefaultConstructSignatures(classType);
	        }
	        type.constructSignatures = constructSignatures;
	      }
	    }
	    function replaceIndexedAccess(instantiable, type, replacement) {
	      return instantiateType(instantiable, createTypeMapper([type.indexType, type.objectType], [getNumberLiteralType(0), createTupleType([replacement])]));
	    }
	    function getLimitedConstraint(type) {
	      const constraint = getConstraintTypeFromMappedType(type.mappedType);
	      if (!(constraint.flags & 1048576 /* Union */ || constraint.flags & 2097152 /* Intersection */)) {
	        return;
	      }
	      const origin = constraint.flags & 1048576 /* Union */ ? constraint.origin : constraint;
	      if (!origin || !(origin.flags & 2097152 /* Intersection */)) {
	        return;
	      }
	      const limitedConstraint = getIntersectionType(origin.types.filter((t) => t !== type.constraintType));
	      return limitedConstraint !== neverType ? limitedConstraint : void 0;
	    }
	    function resolveReverseMappedTypeMembers(type) {
	      const indexInfo = getIndexInfoOfType(type.source, stringType);
	      const modifiers = getMappedTypeModifiers(type.mappedType);
	      const readonlyMask = modifiers & 1 /* IncludeReadonly */ ? false : true;
	      const optionalMask = modifiers & 4 /* IncludeOptional */ ? 0 : 16777216 /* Optional */;
	      const indexInfos = indexInfo ? [createIndexInfo(stringType, inferReverseMappedType(indexInfo.type, type.mappedType, type.constraintType), readonlyMask && indexInfo.isReadonly)] : emptyArray;
	      const members = createSymbolTable();
	      const limitedConstraint = getLimitedConstraint(type);
	      for (const prop of getPropertiesOfType(type.source)) {
	        if (limitedConstraint) {
	          const propertyNameType = getLiteralTypeFromProperty(prop, 8576 /* StringOrNumberLiteralOrUnique */);
	          if (!isTypeAssignableTo(propertyNameType, limitedConstraint)) {
	            continue;
	          }
	        }
	        const checkFlags = 8192 /* ReverseMapped */ | (readonlyMask && isReadonlySymbol(prop) ? 8 /* Readonly */ : 0);
	        const inferredProp = createSymbol(4 /* Property */ | prop.flags & optionalMask, prop.escapedName, checkFlags);
	        inferredProp.declarations = prop.declarations;
	        inferredProp.links.nameType = getSymbolLinks(prop).nameType;
	        inferredProp.links.propertyType = getTypeOfSymbol(prop);
	        if (type.constraintType.type.flags & 8388608 /* IndexedAccess */ && type.constraintType.type.objectType.flags & 262144 /* TypeParameter */ && type.constraintType.type.indexType.flags & 262144 /* TypeParameter */) {
	          const newTypeParam = type.constraintType.type.objectType;
	          const newMappedType = replaceIndexedAccess(type.mappedType, type.constraintType.type, newTypeParam);
	          inferredProp.links.mappedType = newMappedType;
	          inferredProp.links.constraintType = getIndexType(newTypeParam);
	        } else {
	          inferredProp.links.mappedType = type.mappedType;
	          inferredProp.links.constraintType = type.constraintType;
	        }
	        members.set(prop.escapedName, inferredProp);
	      }
	      setStructuredTypeMembers(type, members, emptyArray, emptyArray, indexInfos);
	    }
	    function getLowerBoundOfKeyType(type) {
	      if (type.flags & 4194304 /* Index */) {
	        const t = getApparentType(type.type);
	        return isGenericTupleType(t) ? getKnownKeysOfTupleType(t) : getIndexType(t);
	      }
	      if (type.flags & 16777216 /* Conditional */) {
	        if (type.root.isDistributive) {
	          const checkType = type.checkType;
	          const constraint = getLowerBoundOfKeyType(checkType);
	          if (constraint !== checkType) {
	            return getConditionalTypeInstantiation(
	              type,
	              prependTypeMapping(type.root.checkType, constraint, type.mapper),
	              /*forConstraint*/
	              false
	            );
	          }
	        }
	        return type;
	      }
	      if (type.flags & 1048576 /* Union */) {
	        return mapType(
	          type,
	          getLowerBoundOfKeyType,
	          /*noReductions*/
	          true
	        );
	      }
	      if (type.flags & 2097152 /* Intersection */) {
	        const types = type.types;
	        if (types.length === 2 && !!(types[0].flags & (4 /* String */ | 8 /* Number */ | 64 /* BigInt */)) && types[1] === emptyTypeLiteralType) {
	          return type;
	        }
	        return getIntersectionType(sameMap(type.types, getLowerBoundOfKeyType));
	      }
	      return type;
	    }
	    function getIsLateCheckFlag(s) {
	      return getCheckFlags(s) & 4096 /* Late */;
	    }
	    function forEachMappedTypePropertyKeyTypeAndIndexSignatureKeyType(type, include, stringsOnly, cb) {
	      for (const prop of getPropertiesOfType(type)) {
	        cb(getLiteralTypeFromProperty(prop, include));
	      }
	      if (type.flags & 1 /* Any */) {
	        cb(stringType);
	      } else {
	        for (const info of getIndexInfosOfType(type)) {
	          if (!stringsOnly || info.keyType.flags & (4 /* String */ | 134217728 /* TemplateLiteral */)) {
	            cb(info.keyType);
	          }
	        }
	      }
	    }
	    function resolveMappedTypeMembers(type) {
	      const members = createSymbolTable();
	      let indexInfos;
	      setStructuredTypeMembers(type, emptySymbols, emptyArray, emptyArray, emptyArray);
	      const typeParameter = getTypeParameterFromMappedType(type);
	      const constraintType = getConstraintTypeFromMappedType(type);
	      const mappedType = type.target || type;
	      const nameType = getNameTypeFromMappedType(mappedType);
	      const shouldLinkPropDeclarations = getMappedTypeNameTypeKind(mappedType) !== 2 /* Remapping */;
	      const templateType = getTemplateTypeFromMappedType(mappedType);
	      const modifiersType = getApparentType(getModifiersTypeFromMappedType(type));
	      const templateModifiers = getMappedTypeModifiers(type);
	      const include = keyofStringsOnly ? 128 /* StringLiteral */ : 8576 /* StringOrNumberLiteralOrUnique */;
	      if (isMappedTypeWithKeyofConstraintDeclaration(type)) {
	        forEachMappedTypePropertyKeyTypeAndIndexSignatureKeyType(modifiersType, include, keyofStringsOnly, addMemberForKeyType);
	      } else {
	        forEachType(getLowerBoundOfKeyType(constraintType), addMemberForKeyType);
	      }
	      setStructuredTypeMembers(type, members, emptyArray, emptyArray, indexInfos || emptyArray);
	      function addMemberForKeyType(keyType) {
	        const propNameType = nameType ? instantiateType(nameType, appendTypeMapping(type.mapper, typeParameter, keyType)) : keyType;
	        forEachType(propNameType, (t) => addMemberForKeyTypeWorker(keyType, t));
	      }
	      function addMemberForKeyTypeWorker(keyType, propNameType) {
	        if (isTypeUsableAsPropertyName(propNameType)) {
	          const propName = getPropertyNameFromType(propNameType);
	          const existingProp = members.get(propName);
	          if (existingProp) {
	            existingProp.links.nameType = getUnionType([existingProp.links.nameType, propNameType]);
	            existingProp.links.keyType = getUnionType([existingProp.links.keyType, keyType]);
	          } else {
	            const modifiersProp = isTypeUsableAsPropertyName(keyType) ? getPropertyOfType(modifiersType, getPropertyNameFromType(keyType)) : void 0;
	            const isOptional = !!(templateModifiers & 4 /* IncludeOptional */ || !(templateModifiers & 8 /* ExcludeOptional */) && modifiersProp && modifiersProp.flags & 16777216 /* Optional */);
	            const isReadonly = !!(templateModifiers & 1 /* IncludeReadonly */ || !(templateModifiers & 2 /* ExcludeReadonly */) && modifiersProp && isReadonlySymbol(modifiersProp));
	            const stripOptional = strictNullChecks && !isOptional && modifiersProp && modifiersProp.flags & 16777216 /* Optional */;
	            const lateFlag = modifiersProp ? getIsLateCheckFlag(modifiersProp) : 0;
	            const prop = createSymbol(4 /* Property */ | (isOptional ? 16777216 /* Optional */ : 0), propName, lateFlag | 262144 /* Mapped */ | (isReadonly ? 8 /* Readonly */ : 0) | (stripOptional ? 524288 /* StripOptional */ : 0));
	            prop.links.mappedType = type;
	            prop.links.nameType = propNameType;
	            prop.links.keyType = keyType;
	            if (modifiersProp) {
	              prop.links.syntheticOrigin = modifiersProp;
	              prop.declarations = shouldLinkPropDeclarations ? modifiersProp.declarations : void 0;
	            }
	            members.set(propName, prop);
	          }
	        } else if (isValidIndexKeyType(propNameType) || propNameType.flags & (1 /* Any */ | 32 /* Enum */)) {
	          const indexKeyType = propNameType.flags & (1 /* Any */ | 4 /* String */) ? stringType : propNameType.flags & (8 /* Number */ | 32 /* Enum */) ? numberType : propNameType;
	          const propType = instantiateType(templateType, appendTypeMapping(type.mapper, typeParameter, keyType));
	          const modifiersIndexInfo = getApplicableIndexInfo(modifiersType, propNameType);
	          const isReadonly = !!(templateModifiers & 1 /* IncludeReadonly */ || !(templateModifiers & 2 /* ExcludeReadonly */) && (modifiersIndexInfo == null ? void 0 : modifiersIndexInfo.isReadonly));
	          const indexInfo = createIndexInfo(indexKeyType, propType, isReadonly);
	          indexInfos = appendIndexInfo(
	            indexInfos,
	            indexInfo,
	            /*union*/
	            true
	          );
	        }
	      }
	    }
	    function getTypeOfMappedSymbol(symbol) {
	      if (!symbol.links.type) {
	        const mappedType = symbol.links.mappedType;
	        if (!pushTypeResolution(symbol, 0 /* Type */)) {
	          mappedType.containsError = true;
	          return errorType;
	        }
	        const templateType = getTemplateTypeFromMappedType(mappedType.target || mappedType);
	        const mapper = appendTypeMapping(mappedType.mapper, getTypeParameterFromMappedType(mappedType), symbol.links.keyType);
	        const propType = instantiateType(templateType, mapper);
	        let type = strictNullChecks && symbol.flags & 16777216 /* Optional */ && !maybeTypeOfKind(propType, 32768 /* Undefined */ | 16384 /* Void */) ? getOptionalType(
	          propType,
	          /*isProperty*/
	          true
	        ) : symbol.links.checkFlags & 524288 /* StripOptional */ ? removeMissingOrUndefinedType(propType) : propType;
	        if (!popTypeResolution()) {
	          error2(currentNode, Diagnostics.Type_of_property_0_circularly_references_itself_in_mapped_type_1, symbolToString(symbol), typeToString(mappedType));
	          type = errorType;
	        }
	        symbol.links.type = type;
	      }
	      return symbol.links.type;
	    }
	    function getTypeParameterFromMappedType(type) {
	      return type.typeParameter || (type.typeParameter = getDeclaredTypeOfTypeParameter(getSymbolOfDeclaration(type.declaration.typeParameter)));
	    }
	    function getConstraintTypeFromMappedType(type) {
	      return type.constraintType || (type.constraintType = getConstraintOfTypeParameter(getTypeParameterFromMappedType(type)) || errorType);
	    }
	    function getNameTypeFromMappedType(type) {
	      return type.declaration.nameType ? type.nameType || (type.nameType = instantiateType(getTypeFromTypeNode(type.declaration.nameType), type.mapper)) : void 0;
	    }
	    function getTemplateTypeFromMappedType(type) {
	      return type.templateType || (type.templateType = type.declaration.type ? instantiateType(addOptionality(
	        getTypeFromTypeNode(type.declaration.type),
	        /*isProperty*/
	        true,
	        !!(getMappedTypeModifiers(type) & 4 /* IncludeOptional */)
	      ), type.mapper) : errorType);
	    }
	    function getConstraintDeclarationForMappedType(type) {
	      return getEffectiveConstraintOfTypeParameter(type.declaration.typeParameter);
	    }
	    function isMappedTypeWithKeyofConstraintDeclaration(type) {
	      const constraintDeclaration = getConstraintDeclarationForMappedType(type);
	      return constraintDeclaration.kind === 198 /* TypeOperator */ && constraintDeclaration.operator === 143 /* KeyOfKeyword */;
	    }
	    function getModifiersTypeFromMappedType(type) {
	      if (!type.modifiersType) {
	        if (isMappedTypeWithKeyofConstraintDeclaration(type)) {
	          type.modifiersType = instantiateType(getTypeFromTypeNode(getConstraintDeclarationForMappedType(type).type), type.mapper);
	        } else {
	          const declaredType = getTypeFromMappedTypeNode(type.declaration);
	          const constraint = getConstraintTypeFromMappedType(declaredType);
	          const extendedConstraint = constraint && constraint.flags & 262144 /* TypeParameter */ ? getConstraintOfTypeParameter(constraint) : constraint;
	          type.modifiersType = extendedConstraint && extendedConstraint.flags & 4194304 /* Index */ ? instantiateType(extendedConstraint.type, type.mapper) : unknownType;
	        }
	      }
	      return type.modifiersType;
	    }
	    function getMappedTypeModifiers(type) {
	      const declaration = type.declaration;
	      return (declaration.readonlyToken ? declaration.readonlyToken.kind === 41 /* MinusToken */ ? 2 /* ExcludeReadonly */ : 1 /* IncludeReadonly */ : 0) | (declaration.questionToken ? declaration.questionToken.kind === 41 /* MinusToken */ ? 8 /* ExcludeOptional */ : 4 /* IncludeOptional */ : 0);
	    }
	    function getMappedTypeOptionality(type) {
	      const modifiers = getMappedTypeModifiers(type);
	      return modifiers & 8 /* ExcludeOptional */ ? -1 : modifiers & 4 /* IncludeOptional */ ? 1 : 0;
	    }
	    function getCombinedMappedTypeOptionality(type) {
	      const optionality = getMappedTypeOptionality(type);
	      const modifiersType = getModifiersTypeFromMappedType(type);
	      return optionality || (isGenericMappedType(modifiersType) ? getMappedTypeOptionality(modifiersType) : 0);
	    }
	    function isPartialMappedType(type) {
	      return !!(getObjectFlags(type) & 32 /* Mapped */ && getMappedTypeModifiers(type) & 4 /* IncludeOptional */);
	    }
	    function isGenericMappedType(type) {
	      if (getObjectFlags(type) & 32 /* Mapped */) {
	        const constraint = getConstraintTypeFromMappedType(type);
	        if (isGenericIndexType(constraint)) {
	          return true;
	        }
	        const nameType = getNameTypeFromMappedType(type);
	        if (nameType && isGenericIndexType(instantiateType(nameType, makeUnaryTypeMapper(getTypeParameterFromMappedType(type), constraint)))) {
	          return true;
	        }
	      }
	      return false;
	    }
	    function getMappedTypeNameTypeKind(type) {
	      const nameType = getNameTypeFromMappedType(type);
	      if (!nameType) {
	        return 0 /* None */;
	      }
	      return isTypeAssignableTo(nameType, getTypeParameterFromMappedType(type)) ? 1 /* Filtering */ : 2 /* Remapping */;
	    }
	    function resolveStructuredTypeMembers(type) {
	      if (!type.members) {
	        if (type.flags & 524288 /* Object */) {
	          if (type.objectFlags & 4 /* Reference */) {
	            resolveTypeReferenceMembers(type);
	          } else if (type.objectFlags & 3 /* ClassOrInterface */) {
	            resolveClassOrInterfaceMembers(type);
	          } else if (type.objectFlags & 1024 /* ReverseMapped */) {
	            resolveReverseMappedTypeMembers(type);
	          } else if (type.objectFlags & 16 /* Anonymous */) {
	            resolveAnonymousTypeMembers(type);
	          } else if (type.objectFlags & 32 /* Mapped */) {
	            resolveMappedTypeMembers(type);
	          } else {
	            Debug.fail("Unhandled object type " + Debug.formatObjectFlags(type.objectFlags));
	          }
	        } else if (type.flags & 1048576 /* Union */) {
	          resolveUnionTypeMembers(type);
	        } else if (type.flags & 2097152 /* Intersection */) {
	          resolveIntersectionTypeMembers(type);
	        } else {
	          Debug.fail("Unhandled type " + Debug.formatTypeFlags(type.flags));
	        }
	      }
	      return type;
	    }
	    function getPropertiesOfObjectType(type) {
	      if (type.flags & 524288 /* Object */) {
	        return resolveStructuredTypeMembers(type).properties;
	      }
	      return emptyArray;
	    }
	    function getPropertyOfObjectType(type, name) {
	      if (type.flags & 524288 /* Object */) {
	        const resolved = resolveStructuredTypeMembers(type);
	        const symbol = resolved.members.get(name);
	        if (symbol && symbolIsValue(symbol)) {
	          return symbol;
	        }
	      }
	    }
	    function getPropertiesOfUnionOrIntersectionType(type) {
	      if (!type.resolvedProperties) {
	        const members = createSymbolTable();
	        for (const current of type.types) {
	          for (const prop of getPropertiesOfType(current)) {
	            if (!members.has(prop.escapedName)) {
	              const combinedProp = getPropertyOfUnionOrIntersectionType(
	                type,
	                prop.escapedName,
	                /*skipObjectFunctionPropertyAugment*/
	                !!(type.flags & 2097152 /* Intersection */)
	              );
	              if (combinedProp) {
	                members.set(prop.escapedName, combinedProp);
	              }
	            }
	          }
	          if (type.flags & 1048576 /* Union */ && getIndexInfosOfType(current).length === 0) {
	            break;
	          }
	        }
	        type.resolvedProperties = getNamedMembers(members);
	      }
	      return type.resolvedProperties;
	    }
	    function getPropertiesOfType(type) {
	      type = getReducedApparentType(type);
	      return type.flags & 3145728 /* UnionOrIntersection */ ? getPropertiesOfUnionOrIntersectionType(type) : getPropertiesOfObjectType(type);
	    }
	    function forEachPropertyOfType(type, action) {
	      type = getReducedApparentType(type);
	      if (type.flags & 3670016 /* StructuredType */) {
	        resolveStructuredTypeMembers(type).members.forEach((symbol, escapedName) => {
	          if (isNamedMember(symbol, escapedName)) {
	            action(symbol, escapedName);
	          }
	        });
	      }
	    }
	    function isTypeInvalidDueToUnionDiscriminant(contextualType, obj) {
	      const list = obj.properties;
	      return list.some((property) => {
	        const nameType = property.name && (isJsxNamespacedName(property.name) ? getStringLiteralType(getTextOfJsxAttributeName(property.name)) : getLiteralTypeFromPropertyName(property.name));
	        const name = nameType && isTypeUsableAsPropertyName(nameType) ? getPropertyNameFromType(nameType) : void 0;
	        const expected = name === void 0 ? void 0 : getTypeOfPropertyOfType(contextualType, name);
	        return !!expected && isLiteralType(expected) && !isTypeAssignableTo(getTypeOfNode(property), expected);
	      });
	    }
	    function getAllPossiblePropertiesOfTypes(types) {
	      const unionType = getUnionType(types);
	      if (!(unionType.flags & 1048576 /* Union */)) {
	        return getAugmentedPropertiesOfType(unionType);
	      }
	      const props = createSymbolTable();
	      for (const memberType of types) {
	        for (const { escapedName } of getAugmentedPropertiesOfType(memberType)) {
	          if (!props.has(escapedName)) {
	            const prop = createUnionOrIntersectionProperty(unionType, escapedName);
	            if (prop)
	              props.set(escapedName, prop);
	          }
	        }
	      }
	      return arrayFrom(props.values());
	    }
	    function getConstraintOfType(type) {
	      return type.flags & 262144 /* TypeParameter */ ? getConstraintOfTypeParameter(type) : type.flags & 8388608 /* IndexedAccess */ ? getConstraintOfIndexedAccess(type) : type.flags & 16777216 /* Conditional */ ? getConstraintOfConditionalType(type) : getBaseConstraintOfType(type);
	    }
	    function getConstraintOfTypeParameter(typeParameter) {
	      return hasNonCircularBaseConstraint(typeParameter) ? getConstraintFromTypeParameter(typeParameter) : void 0;
	    }
	    function isConstMappedType(type, depth) {
	      const typeVariable = getHomomorphicTypeVariable(type);
	      return !!typeVariable && isConstTypeVariable(typeVariable, depth);
	    }
	    function isConstTypeVariable(type, depth = 0) {
	      var _a;
	      return depth < 5 && !!(type && (type.flags & 262144 /* TypeParameter */ && some((_a = type.symbol) == null ? void 0 : _a.declarations, (d) => hasSyntacticModifier(d, 4096 /* Const */)) || type.flags & 3145728 /* UnionOrIntersection */ && some(type.types, (t) => isConstTypeVariable(t, depth)) || type.flags & 8388608 /* IndexedAccess */ && isConstTypeVariable(type.objectType, depth + 1) || type.flags & 16777216 /* Conditional */ && isConstTypeVariable(getConstraintOfConditionalType(type), depth + 1) || type.flags & 33554432 /* Substitution */ && isConstTypeVariable(type.baseType, depth) || getObjectFlags(type) & 32 /* Mapped */ && isConstMappedType(type, depth) || isGenericTupleType(type) && findIndex(getElementTypes(type), (t, i) => !!(type.target.elementFlags[i] & 8 /* Variadic */) && isConstTypeVariable(t, depth)) >= 0));
	    }
	    function getConstraintOfIndexedAccess(type) {
	      return hasNonCircularBaseConstraint(type) ? getConstraintFromIndexedAccess(type) : void 0;
	    }
	    function getSimplifiedTypeOrConstraint(type) {
	      const simplified = getSimplifiedType(
	        type,
	        /*writing*/
	        false
	      );
	      return simplified !== type ? simplified : getConstraintOfType(type);
	    }
	    function getConstraintFromIndexedAccess(type) {
	      if (isMappedTypeGenericIndexedAccess(type)) {
	        return substituteIndexedMappedType(type.objectType, type.indexType);
	      }
	      const indexConstraint = getSimplifiedTypeOrConstraint(type.indexType);
	      if (indexConstraint && indexConstraint !== type.indexType) {
	        const indexedAccess = getIndexedAccessTypeOrUndefined(type.objectType, indexConstraint, type.accessFlags);
	        if (indexedAccess) {
	          return indexedAccess;
	        }
	      }
	      const objectConstraint = getSimplifiedTypeOrConstraint(type.objectType);
	      if (objectConstraint && objectConstraint !== type.objectType) {
	        return getIndexedAccessTypeOrUndefined(objectConstraint, type.indexType, type.accessFlags);
	      }
	      return void 0;
	    }
	    function getDefaultConstraintOfConditionalType(type) {
	      if (!type.resolvedDefaultConstraint) {
	        const trueConstraint = getInferredTrueTypeFromConditionalType(type);
	        const falseConstraint = getFalseTypeFromConditionalType(type);
	        type.resolvedDefaultConstraint = isTypeAny(trueConstraint) ? falseConstraint : isTypeAny(falseConstraint) ? trueConstraint : getUnionType([trueConstraint, falseConstraint]);
	      }
	      return type.resolvedDefaultConstraint;
	    }
	    function getConstraintOfDistributiveConditionalType(type) {
	      if (type.resolvedConstraintOfDistributive !== void 0) {
	        return type.resolvedConstraintOfDistributive || void 0;
	      }
	      if (type.root.isDistributive && type.restrictiveInstantiation !== type) {
	        const simplified = getSimplifiedType(
	          type.checkType,
	          /*writing*/
	          false
	        );
	        const constraint = simplified === type.checkType ? getConstraintOfType(simplified) : simplified;
	        if (constraint && constraint !== type.checkType) {
	          const instantiated = getConditionalTypeInstantiation(
	            type,
	            prependTypeMapping(type.root.checkType, constraint, type.mapper),
	            /*forConstraint*/
	            true
	          );
	          if (!(instantiated.flags & 131072 /* Never */)) {
	            type.resolvedConstraintOfDistributive = instantiated;
	            return instantiated;
	          }
	        }
	      }
	      type.resolvedConstraintOfDistributive = false;
	      return void 0;
	    }
	    function getConstraintFromConditionalType(type) {
	      return getConstraintOfDistributiveConditionalType(type) || getDefaultConstraintOfConditionalType(type);
	    }
	    function getConstraintOfConditionalType(type) {
	      return hasNonCircularBaseConstraint(type) ? getConstraintFromConditionalType(type) : void 0;
	    }
	    function getEffectiveConstraintOfIntersection(types, targetIsUnion) {
	      let constraints;
	      let hasDisjointDomainType = false;
	      for (const t of types) {
	        if (t.flags & 465829888 /* Instantiable */) {
	          let constraint = getConstraintOfType(t);
	          while (constraint && constraint.flags & (262144 /* TypeParameter */ | 4194304 /* Index */ | 16777216 /* Conditional */)) {
	            constraint = getConstraintOfType(constraint);
	          }
	          if (constraint) {
	            constraints = append(constraints, constraint);
	            if (targetIsUnion) {
	              constraints = append(constraints, t);
	            }
	          }
	        } else if (t.flags & 469892092 /* DisjointDomains */ || isEmptyAnonymousObjectType(t)) {
	          hasDisjointDomainType = true;
	        }
	      }
	      if (constraints && (targetIsUnion || hasDisjointDomainType)) {
	        if (hasDisjointDomainType) {
	          for (const t of types) {
	            if (t.flags & 469892092 /* DisjointDomains */ || isEmptyAnonymousObjectType(t)) {
	              constraints = append(constraints, t);
	            }
	          }
	        }
	        return getNormalizedType(
	          getIntersectionType(constraints),
	          /*writing*/
	          false
	        );
	      }
	      return void 0;
	    }
	    function getBaseConstraintOfType(type) {
	      if (type.flags & (58982400 /* InstantiableNonPrimitive */ | 3145728 /* UnionOrIntersection */ | 134217728 /* TemplateLiteral */ | 268435456 /* StringMapping */) || isGenericTupleType(type)) {
	        const constraint = getResolvedBaseConstraint(type);
	        return constraint !== noConstraintType && constraint !== circularConstraintType ? constraint : void 0;
	      }
	      return type.flags & 4194304 /* Index */ ? keyofConstraintType : void 0;
	    }
	    function getBaseConstraintOrType(type) {
	      return getBaseConstraintOfType(type) || type;
	    }
	    function hasNonCircularBaseConstraint(type) {
	      return getResolvedBaseConstraint(type) !== circularConstraintType;
	    }
	    function getResolvedBaseConstraint(type) {
	      if (type.resolvedBaseConstraint) {
	        return type.resolvedBaseConstraint;
	      }
	      const stack = [];
	      return type.resolvedBaseConstraint = getImmediateBaseConstraint(type);
	      function getImmediateBaseConstraint(t) {
	        if (!t.immediateBaseConstraint) {
	          if (!pushTypeResolution(t, 4 /* ImmediateBaseConstraint */)) {
	            return circularConstraintType;
	          }
	          let result;
	          const identity2 = getRecursionIdentity(t);
	          if (stack.length < 10 || stack.length < 50 && !contains(stack, identity2)) {
	            stack.push(identity2);
	            result = computeBaseConstraint(getSimplifiedType(
	              t,
	              /*writing*/
	              false
	            ));
	            stack.pop();
	          }
	          if (!popTypeResolution()) {
	            if (t.flags & 262144 /* TypeParameter */) {
	              const errorNode = getConstraintDeclaration(t);
	              if (errorNode) {
	                const diagnostic = error2(errorNode, Diagnostics.Type_parameter_0_has_a_circular_constraint, typeToString(t));
	                if (currentNode && !isNodeDescendantOf(errorNode, currentNode) && !isNodeDescendantOf(currentNode, errorNode)) {
	                  addRelatedInfo(diagnostic, createDiagnosticForNode(currentNode, Diagnostics.Circularity_originates_in_type_at_this_location));
	                }
	              }
	            }
	            result = circularConstraintType;
	          }
	          t.immediateBaseConstraint = result || noConstraintType;
	        }
	        return t.immediateBaseConstraint;
	      }
	      function getBaseConstraint(t) {
	        const c = getImmediateBaseConstraint(t);
	        return c !== noConstraintType && c !== circularConstraintType ? c : void 0;
	      }
	      function computeBaseConstraint(t) {
	        if (t.flags & 262144 /* TypeParameter */) {
	          const constraint = getConstraintFromTypeParameter(t);
	          return t.isThisType || !constraint ? constraint : getBaseConstraint(constraint);
	        }
	        if (t.flags & 3145728 /* UnionOrIntersection */) {
	          const types = t.types;
	          const baseTypes = [];
	          let different = false;
	          for (const type2 of types) {
	            const baseType = getBaseConstraint(type2);
	            if (baseType) {
	              if (baseType !== type2) {
	                different = true;
	              }
	              baseTypes.push(baseType);
	            } else {
	              different = true;
	            }
	          }
	          if (!different) {
	            return t;
	          }
	          return t.flags & 1048576 /* Union */ && baseTypes.length === types.length ? getUnionType(baseTypes) : t.flags & 2097152 /* Intersection */ && baseTypes.length ? getIntersectionType(baseTypes) : void 0;
	        }
	        if (t.flags & 4194304 /* Index */) {
	          return keyofConstraintType;
	        }
	        if (t.flags & 134217728 /* TemplateLiteral */) {
	          const types = t.types;
	          const constraints = mapDefined(types, getBaseConstraint);
	          return constraints.length === types.length ? getTemplateLiteralType(t.texts, constraints) : stringType;
	        }
	        if (t.flags & 268435456 /* StringMapping */) {
	          const constraint = getBaseConstraint(t.type);
	          return constraint && constraint !== t.type ? getStringMappingType(t.symbol, constraint) : stringType;
	        }
	        if (t.flags & 8388608 /* IndexedAccess */) {
	          if (isMappedTypeGenericIndexedAccess(t)) {
	            return getBaseConstraint(substituteIndexedMappedType(t.objectType, t.indexType));
	          }
	          const baseObjectType = getBaseConstraint(t.objectType);
	          const baseIndexType = getBaseConstraint(t.indexType);
	          const baseIndexedAccess = baseObjectType && baseIndexType && getIndexedAccessTypeOrUndefined(baseObjectType, baseIndexType, t.accessFlags);
	          return baseIndexedAccess && getBaseConstraint(baseIndexedAccess);
	        }
	        if (t.flags & 16777216 /* Conditional */) {
	          const constraint = getConstraintFromConditionalType(t);
	          return constraint && getBaseConstraint(constraint);
	        }
	        if (t.flags & 33554432 /* Substitution */) {
	          return getBaseConstraint(getSubstitutionIntersection(t));
	        }
	        if (isGenericTupleType(t)) {
	          const newElements = map(getElementTypes(t), (v, i) => {
	            const constraint = v.flags & 262144 /* TypeParameter */ && t.target.elementFlags[i] & 8 /* Variadic */ && getBaseConstraint(v) || v;
	            return constraint !== v && everyType(constraint, (c) => isArrayOrTupleType(c) && !isGenericTupleType(c)) ? constraint : v;
	          });
	          return createTupleType(newElements, t.target.elementFlags, t.target.readonly, t.target.labeledElementDeclarations);
	        }
	        return t;
	      }
	    }
	    function getApparentTypeOfIntersectionType(type, thisArgument) {
	      return type.resolvedApparentType || (type.resolvedApparentType = getTypeWithThisArgument(
	        type,
	        thisArgument,
	        /*needApparentType*/
	        true
	      ));
	    }
	    function getResolvedTypeParameterDefault(typeParameter) {
	      if (!typeParameter.default) {
	        if (typeParameter.target) {
	          const targetDefault = getResolvedTypeParameterDefault(typeParameter.target);
	          typeParameter.default = targetDefault ? instantiateType(targetDefault, typeParameter.mapper) : noConstraintType;
	        } else {
	          typeParameter.default = resolvingDefaultType;
	          const defaultDeclaration = typeParameter.symbol && forEach(typeParameter.symbol.declarations, (decl) => isTypeParameterDeclaration(decl) && decl.default);
	          const defaultType = defaultDeclaration ? getTypeFromTypeNode(defaultDeclaration) : noConstraintType;
	          if (typeParameter.default === resolvingDefaultType) {
	            typeParameter.default = defaultType;
	          }
	        }
	      } else if (typeParameter.default === resolvingDefaultType) {
	        typeParameter.default = circularConstraintType;
	      }
	      return typeParameter.default;
	    }
	    function getDefaultFromTypeParameter(typeParameter) {
	      const defaultType = getResolvedTypeParameterDefault(typeParameter);
	      return defaultType !== noConstraintType && defaultType !== circularConstraintType ? defaultType : void 0;
	    }
	    function hasNonCircularTypeParameterDefault(typeParameter) {
	      return getResolvedTypeParameterDefault(typeParameter) !== circularConstraintType;
	    }
	    function hasTypeParameterDefault(typeParameter) {
	      return !!(typeParameter.symbol && forEach(typeParameter.symbol.declarations, (decl) => isTypeParameterDeclaration(decl) && decl.default));
	    }
	    function getApparentTypeOfMappedType(type) {
	      return type.resolvedApparentType || (type.resolvedApparentType = getResolvedApparentTypeOfMappedType(type));
	    }
	    function getResolvedApparentTypeOfMappedType(type) {
	      const target = type.target ?? type;
	      const typeVariable = getHomomorphicTypeVariable(target);
	      if (typeVariable && !target.declaration.nameType) {
	        const modifiersType = getModifiersTypeFromMappedType(type);
	        const baseConstraint = isGenericMappedType(modifiersType) ? getApparentTypeOfMappedType(modifiersType) : getBaseConstraintOfType(modifiersType);
	        if (baseConstraint && everyType(baseConstraint, (t) => isArrayOrTupleType(t) || isArrayOrTupleOrIntersection(t))) {
	          return instantiateType(target, prependTypeMapping(typeVariable, baseConstraint, type.mapper));
	        }
	      }
	      return type;
	    }
	    function isArrayOrTupleOrIntersection(type) {
	      return !!(type.flags & 2097152 /* Intersection */) && every(type.types, isArrayOrTupleType);
	    }
	    function isMappedTypeGenericIndexedAccess(type) {
	      let objectType;
	      return !!(type.flags & 8388608 /* IndexedAccess */ && getObjectFlags(objectType = type.objectType) & 32 /* Mapped */ && !isGenericMappedType(objectType) && isGenericIndexType(type.indexType) && !(getMappedTypeModifiers(objectType) & 8 /* ExcludeOptional */) && !objectType.declaration.nameType);
	    }
	    function getApparentType(type) {
	      const t = type.flags & 465829888 /* Instantiable */ ? getBaseConstraintOfType(type) || unknownType : type;
	      const objectFlags = getObjectFlags(t);
	      return objectFlags & 32 /* Mapped */ ? getApparentTypeOfMappedType(t) : objectFlags & 4 /* Reference */ && t !== type ? getTypeWithThisArgument(t, type) : t.flags & 2097152 /* Intersection */ ? getApparentTypeOfIntersectionType(t, type) : t.flags & 402653316 /* StringLike */ ? globalStringType : t.flags & 296 /* NumberLike */ ? globalNumberType : t.flags & 2112 /* BigIntLike */ ? getGlobalBigIntType() : t.flags & 528 /* BooleanLike */ ? globalBooleanType : t.flags & 12288 /* ESSymbolLike */ ? getGlobalESSymbolType() : t.flags & 67108864 /* NonPrimitive */ ? emptyObjectType : t.flags & 4194304 /* Index */ ? keyofConstraintType : t.flags & 2 /* Unknown */ && !strictNullChecks ? emptyObjectType : t;
	    }
	    function getReducedApparentType(type) {
	      return getReducedType(getApparentType(getReducedType(type)));
	    }
	    function createUnionOrIntersectionProperty(containingType, name, skipObjectFunctionPropertyAugment) {
	      var _a, _b, _c;
	      let singleProp;
	      let propSet;
	      let indexTypes;
	      const isUnion = containingType.flags & 1048576 /* Union */;
	      let optionalFlag;
	      let syntheticFlag = 4 /* SyntheticMethod */;
	      let checkFlags = isUnion ? 0 : 8 /* Readonly */;
	      let mergedInstantiations = false;
	      for (const current of containingType.types) {
	        const type = getApparentType(current);
	        if (!(isErrorType(type) || type.flags & 131072 /* Never */)) {
	          const prop = getPropertyOfType(type, name, skipObjectFunctionPropertyAugment);
	          const modifiers = prop ? getDeclarationModifierFlagsFromSymbol(prop) : 0;
	          if (prop) {
	            if (prop.flags & 106500 /* ClassMember */) {
	              optionalFlag ?? (optionalFlag = isUnion ? 0 /* None */ : 16777216 /* Optional */);
	              if (isUnion) {
	                optionalFlag |= prop.flags & 16777216 /* Optional */;
	              } else {
	                optionalFlag &= prop.flags;
	              }
	            }
	            if (!singleProp) {
	              singleProp = prop;
	            } else if (prop !== singleProp) {
	              const isInstantiation = (getTargetSymbol(prop) || prop) === (getTargetSymbol(singleProp) || singleProp);
	              if (isInstantiation && compareProperties2(singleProp, prop, (a, b) => a === b ? -1 /* True */ : 0 /* False */) === -1 /* True */) {
	                mergedInstantiations = !!singleProp.parent && !!length(getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(singleProp.parent));
	              } else {
	                if (!propSet) {
	                  propSet = /* @__PURE__ */ new Map();
	                  propSet.set(getSymbolId(singleProp), singleProp);
	                }
	                const id = getSymbolId(prop);
	                if (!propSet.has(id)) {
	                  propSet.set(id, prop);
	                }
	              }
	            }
	            if (isUnion && isReadonlySymbol(prop)) {
	              checkFlags |= 8 /* Readonly */;
	            } else if (!isUnion && !isReadonlySymbol(prop)) {
	              checkFlags &= ~8 /* Readonly */;
	            }
	            checkFlags |= (!(modifiers & 6 /* NonPublicAccessibilityModifier */) ? 256 /* ContainsPublic */ : 0) | (modifiers & 4 /* Protected */ ? 512 /* ContainsProtected */ : 0) | (modifiers & 2 /* Private */ ? 1024 /* ContainsPrivate */ : 0) | (modifiers & 256 /* Static */ ? 2048 /* ContainsStatic */ : 0);
	            if (!isPrototypeProperty(prop)) {
	              syntheticFlag = 2 /* SyntheticProperty */;
	            }
	          } else if (isUnion) {
	            const indexInfo = !isLateBoundName(name) && getApplicableIndexInfoForName(type, name);
	            if (indexInfo) {
	              checkFlags |= 32 /* WritePartial */ | (indexInfo.isReadonly ? 8 /* Readonly */ : 0);
	              indexTypes = append(indexTypes, isTupleType(type) ? getRestTypeOfTupleType(type) || undefinedType : indexInfo.type);
	            } else if (isObjectLiteralType2(type) && !(getObjectFlags(type) & 2097152 /* ContainsSpread */)) {
	              checkFlags |= 32 /* WritePartial */;
	              indexTypes = append(indexTypes, undefinedType);
	            } else {
	              checkFlags |= 16 /* ReadPartial */;
	            }
	          }
	        }
	      }
	      if (!singleProp || isUnion && (propSet || checkFlags & 48 /* Partial */) && checkFlags & (1024 /* ContainsPrivate */ | 512 /* ContainsProtected */) && !(propSet && getCommonDeclarationsOfSymbols(propSet.values()))) {
	        return void 0;
	      }
	      if (!propSet && !(checkFlags & 16 /* ReadPartial */) && !indexTypes) {
	        if (mergedInstantiations) {
	          const links = (_a = tryCast(singleProp, isTransientSymbol)) == null ? void 0 : _a.links;
	          const clone2 = createSymbolWithType(singleProp, links == null ? void 0 : links.type);
	          clone2.parent = (_c = (_b = singleProp.valueDeclaration) == null ? void 0 : _b.symbol) == null ? void 0 : _c.parent;
	          clone2.links.containingType = containingType;
	          clone2.links.mapper = links == null ? void 0 : links.mapper;
	          clone2.links.writeType = getWriteTypeOfSymbol(singleProp);
	          return clone2;
	        } else {
	          return singleProp;
	        }
	      }
	      const props = propSet ? arrayFrom(propSet.values()) : [singleProp];
	      let declarations;
	      let firstType;
	      let nameType;
	      const propTypes = [];
	      let writeTypes;
	      let firstValueDeclaration;
	      let hasNonUniformValueDeclaration = false;
	      for (const prop of props) {
	        if (!firstValueDeclaration) {
	          firstValueDeclaration = prop.valueDeclaration;
	        } else if (prop.valueDeclaration && prop.valueDeclaration !== firstValueDeclaration) {
	          hasNonUniformValueDeclaration = true;
	        }
	        declarations = addRange(declarations, prop.declarations);
	        const type = getTypeOfSymbol(prop);
	        if (!firstType) {
	          firstType = type;
	          nameType = getSymbolLinks(prop).nameType;
	        }
	        const writeType = getWriteTypeOfSymbol(prop);
	        if (writeTypes || writeType !== type) {
	          writeTypes = append(!writeTypes ? propTypes.slice() : writeTypes, writeType);
	        }
	        if (type !== firstType) {
	          checkFlags |= 64 /* HasNonUniformType */;
	        }
	        if (isLiteralType(type) || isPatternLiteralType(type)) {
	          checkFlags |= 128 /* HasLiteralType */;
	        }
	        if (type.flags & 131072 /* Never */ && type !== uniqueLiteralType) {
	          checkFlags |= 131072 /* HasNeverType */;
	        }
	        propTypes.push(type);
	      }
	      addRange(propTypes, indexTypes);
	      const result = createSymbol(4 /* Property */ | (optionalFlag ?? 0), name, syntheticFlag | checkFlags);
	      result.links.containingType = containingType;
	      if (!hasNonUniformValueDeclaration && firstValueDeclaration) {
	        result.valueDeclaration = firstValueDeclaration;
	        if (firstValueDeclaration.symbol.parent) {
	          result.parent = firstValueDeclaration.symbol.parent;
	        }
	      }
	      result.declarations = declarations;
	      result.links.nameType = nameType;
	      if (propTypes.length > 2) {
	        result.links.checkFlags |= 65536 /* DeferredType */;
	        result.links.deferralParent = containingType;
	        result.links.deferralConstituents = propTypes;
	        result.links.deferralWriteConstituents = writeTypes;
	      } else {
	        result.links.type = isUnion ? getUnionType(propTypes) : getIntersectionType(propTypes);
	        if (writeTypes) {
	          result.links.writeType = isUnion ? getUnionType(writeTypes) : getIntersectionType(writeTypes);
	        }
	      }
	      return result;
	    }
	    function getUnionOrIntersectionProperty(type, name, skipObjectFunctionPropertyAugment) {
	      var _a, _b, _c;
	      let property = skipObjectFunctionPropertyAugment ? (_a = type.propertyCacheWithoutObjectFunctionPropertyAugment) == null ? void 0 : _a.get(name) : (_b = type.propertyCache) == null ? void 0 : _b.get(name);
	      if (!property) {
	        property = createUnionOrIntersectionProperty(type, name, skipObjectFunctionPropertyAugment);
	        if (property) {
	          const properties = skipObjectFunctionPropertyAugment ? type.propertyCacheWithoutObjectFunctionPropertyAugment || (type.propertyCacheWithoutObjectFunctionPropertyAugment = createSymbolTable()) : type.propertyCache || (type.propertyCache = createSymbolTable());
	          properties.set(name, property);
	          if (skipObjectFunctionPropertyAugment && !(getCheckFlags(property) & 48 /* Partial */) && !((_c = type.propertyCache) == null ? void 0 : _c.get(name))) {
	            const properties2 = type.propertyCache || (type.propertyCache = createSymbolTable());
	            properties2.set(name, property);
	          }
	        }
	      }
	      return property;
	    }
	    function getCommonDeclarationsOfSymbols(symbols) {
	      let commonDeclarations;
	      for (const symbol of symbols) {
	        if (!symbol.declarations) {
	          return void 0;
	        }
	        if (!commonDeclarations) {
	          commonDeclarations = new Set(symbol.declarations);
	          continue;
	        }
	        commonDeclarations.forEach((declaration) => {
	          if (!contains(symbol.declarations, declaration)) {
	            commonDeclarations.delete(declaration);
	          }
	        });
	        if (commonDeclarations.size === 0) {
	          return void 0;
	        }
	      }
	      return commonDeclarations;
	    }
	    function getPropertyOfUnionOrIntersectionType(type, name, skipObjectFunctionPropertyAugment) {
	      const property = getUnionOrIntersectionProperty(type, name, skipObjectFunctionPropertyAugment);
	      return property && !(getCheckFlags(property) & 16 /* ReadPartial */) ? property : void 0;
	    }
	    function getReducedType(type) {
	      if (type.flags & 1048576 /* Union */ && type.objectFlags & 16777216 /* ContainsIntersections */) {
	        return type.resolvedReducedType || (type.resolvedReducedType = getReducedUnionType(type));
	      } else if (type.flags & 2097152 /* Intersection */) {
	        if (!(type.objectFlags & 16777216 /* IsNeverIntersectionComputed */)) {
	          type.objectFlags |= 16777216 /* IsNeverIntersectionComputed */ | (some(getPropertiesOfUnionOrIntersectionType(type), isNeverReducedProperty) ? 33554432 /* IsNeverIntersection */ : 0);
	        }
	        return type.objectFlags & 33554432 /* IsNeverIntersection */ ? neverType : type;
	      }
	      return type;
	    }
	    function getReducedUnionType(unionType) {
	      const reducedTypes = sameMap(unionType.types, getReducedType);
	      if (reducedTypes === unionType.types) {
	        return unionType;
	      }
	      const reduced = getUnionType(reducedTypes);
	      if (reduced.flags & 1048576 /* Union */) {
	        reduced.resolvedReducedType = reduced;
	      }
	      return reduced;
	    }
	    function isNeverReducedProperty(prop) {
	      return isDiscriminantWithNeverType(prop) || isConflictingPrivateProperty(prop);
	    }
	    function isDiscriminantWithNeverType(prop) {
	      return !(prop.flags & 16777216 /* Optional */) && (getCheckFlags(prop) & (192 /* Discriminant */ | 131072 /* HasNeverType */)) === 192 /* Discriminant */ && !!(getTypeOfSymbol(prop).flags & 131072 /* Never */);
	    }
	    function isConflictingPrivateProperty(prop) {
	      return !prop.valueDeclaration && !!(getCheckFlags(prop) & 1024 /* ContainsPrivate */);
	    }
	    function isGenericReducibleType(type) {
	      return !!(type.flags & 1048576 /* Union */ && type.objectFlags & 16777216 /* ContainsIntersections */ && some(type.types, isGenericReducibleType) || type.flags & 2097152 /* Intersection */ && isReducibleIntersection(type));
	    }
	    function isReducibleIntersection(type) {
	      const uniqueFilled = type.uniqueLiteralFilledInstantiation || (type.uniqueLiteralFilledInstantiation = instantiateType(type, uniqueLiteralMapper));
	      return getReducedType(uniqueFilled) !== uniqueFilled;
	    }
	    function elaborateNeverIntersection(errorInfo, type) {
	      if (type.flags & 2097152 /* Intersection */ && getObjectFlags(type) & 33554432 /* IsNeverIntersection */) {
	        const neverProp = find(getPropertiesOfUnionOrIntersectionType(type), isDiscriminantWithNeverType);
	        if (neverProp) {
	          return chainDiagnosticMessages(errorInfo, Diagnostics.The_intersection_0_was_reduced_to_never_because_property_1_has_conflicting_types_in_some_constituents, typeToString(
	            type,
	            /*enclosingDeclaration*/
	            void 0,
	            536870912 /* NoTypeReduction */
	          ), symbolToString(neverProp));
	        }
	        const privateProp = find(getPropertiesOfUnionOrIntersectionType(type), isConflictingPrivateProperty);
	        if (privateProp) {
	          return chainDiagnosticMessages(errorInfo, Diagnostics.The_intersection_0_was_reduced_to_never_because_property_1_exists_in_multiple_constituents_and_is_private_in_some, typeToString(
	            type,
	            /*enclosingDeclaration*/
	            void 0,
	            536870912 /* NoTypeReduction */
	          ), symbolToString(privateProp));
	        }
	      }
	      return errorInfo;
	    }
	    function getPropertyOfType(type, name, skipObjectFunctionPropertyAugment, includeTypeOnlyMembers) {
	      var _a, _b;
	      type = getReducedApparentType(type);
	      if (type.flags & 524288 /* Object */) {
	        const resolved = resolveStructuredTypeMembers(type);
	        const symbol = resolved.members.get(name);
	        if (symbol && !includeTypeOnlyMembers && ((_a = type.symbol) == null ? void 0 : _a.flags) & 512 /* ValueModule */ && ((_b = getSymbolLinks(type.symbol).typeOnlyExportStarMap) == null ? void 0 : _b.has(name))) {
	          return void 0;
	        }
	        if (symbol && symbolIsValue(symbol, includeTypeOnlyMembers)) {
	          return symbol;
	        }
	        if (skipObjectFunctionPropertyAugment)
	          return void 0;
	        const functionType = resolved === anyFunctionType ? globalFunctionType : resolved.callSignatures.length ? globalCallableFunctionType : resolved.constructSignatures.length ? globalNewableFunctionType : void 0;
	        if (functionType) {
	          const symbol2 = getPropertyOfObjectType(functionType, name);
	          if (symbol2) {
	            return symbol2;
	          }
	        }
	        return getPropertyOfObjectType(globalObjectType, name);
	      }
	      if (type.flags & 2097152 /* Intersection */) {
	        const prop = getPropertyOfUnionOrIntersectionType(
	          type,
	          name,
	          /*skipObjectFunctionPropertyAugment*/
	          true
	        );
	        if (prop) {
	          return prop;
	        }
	        if (!skipObjectFunctionPropertyAugment) {
	          return getPropertyOfUnionOrIntersectionType(type, name, skipObjectFunctionPropertyAugment);
	        }
	        return void 0;
	      }
	      if (type.flags & 1048576 /* Union */) {
	        return getPropertyOfUnionOrIntersectionType(type, name, skipObjectFunctionPropertyAugment);
	      }
	      return void 0;
	    }
	    function getSignaturesOfStructuredType(type, kind) {
	      if (type.flags & 3670016 /* StructuredType */) {
	        const resolved = resolveStructuredTypeMembers(type);
	        return kind === 0 /* Call */ ? resolved.callSignatures : resolved.constructSignatures;
	      }
	      return emptyArray;
	    }
	    function getSignaturesOfType(type, kind) {
	      const result = getSignaturesOfStructuredType(getReducedApparentType(type), kind);
	      if (kind === 0 /* Call */ && !length(result) && type.flags & 1048576 /* Union */) {
	        if (type.arrayFallbackSignatures) {
	          return type.arrayFallbackSignatures;
	        }
	        let memberName;
	        if (everyType(type, (t) => {
	          var _a;
	          return !!((_a = t.symbol) == null ? void 0 : _a.parent) && isArrayOrTupleSymbol(t.symbol.parent) && (!memberName ? (memberName = t.symbol.escapedName, true) : memberName === t.symbol.escapedName);
	        })) {
	          const arrayArg = mapType(type, (t) => getMappedType((isReadonlyArraySymbol(t.symbol.parent) ? globalReadonlyArrayType : globalArrayType).typeParameters[0], t.mapper));
	          const arrayType = createArrayType(arrayArg, someType(type, (t) => isReadonlyArraySymbol(t.symbol.parent)));
	          return type.arrayFallbackSignatures = getSignaturesOfType(getTypeOfPropertyOfType(arrayType, memberName), kind);
	        }
	        type.arrayFallbackSignatures = result;
	      }
	      return result;
	    }
	    function isArrayOrTupleSymbol(symbol) {
	      if (!symbol || !globalArrayType.symbol || !globalReadonlyArrayType.symbol) {
	        return false;
	      }
	      return !!getSymbolIfSameReference(symbol, globalArrayType.symbol) || !!getSymbolIfSameReference(symbol, globalReadonlyArrayType.symbol);
	    }
	    function isReadonlyArraySymbol(symbol) {
	      if (!symbol || !globalReadonlyArrayType.symbol) {
	        return false;
	      }
	      return !!getSymbolIfSameReference(symbol, globalReadonlyArrayType.symbol);
	    }
	    function findIndexInfo(indexInfos, keyType) {
	      return find(indexInfos, (info) => info.keyType === keyType);
	    }
	    function findApplicableIndexInfo(indexInfos, keyType) {
	      let stringIndexInfo;
	      let applicableInfo;
	      let applicableInfos;
	      for (const info of indexInfos) {
	        if (info.keyType === stringType) {
	          stringIndexInfo = info;
	        } else if (isApplicableIndexType(keyType, info.keyType)) {
	          if (!applicableInfo) {
	            applicableInfo = info;
	          } else {
	            (applicableInfos || (applicableInfos = [applicableInfo])).push(info);
	          }
	        }
	      }
	      return applicableInfos ? createIndexInfo(unknownType, getIntersectionType(map(applicableInfos, (info) => info.type)), reduceLeft(
	        applicableInfos,
	        (isReadonly, info) => isReadonly && info.isReadonly,
	        /*initial*/
	        true
	      )) : applicableInfo ? applicableInfo : stringIndexInfo && isApplicableIndexType(keyType, stringType) ? stringIndexInfo : void 0;
	    }
	    function isApplicableIndexType(source, target) {
	      return isTypeAssignableTo(source, target) || target === stringType && isTypeAssignableTo(source, numberType) || target === numberType && (source === numericStringType || !!(source.flags & 128 /* StringLiteral */) && isNumericLiteralName(source.value));
	    }
	    function getIndexInfosOfStructuredType(type) {
	      if (type.flags & 3670016 /* StructuredType */) {
	        const resolved = resolveStructuredTypeMembers(type);
	        return resolved.indexInfos;
	      }
	      return emptyArray;
	    }
	    function getIndexInfosOfType(type) {
	      return getIndexInfosOfStructuredType(getReducedApparentType(type));
	    }
	    function getIndexInfoOfType(type, keyType) {
	      return findIndexInfo(getIndexInfosOfType(type), keyType);
	    }
	    function getIndexTypeOfType(type, keyType) {
	      var _a;
	      return (_a = getIndexInfoOfType(type, keyType)) == null ? void 0 : _a.type;
	    }
	    function getApplicableIndexInfos(type, keyType) {
	      return getIndexInfosOfType(type).filter((info) => isApplicableIndexType(keyType, info.keyType));
	    }
	    function getApplicableIndexInfo(type, keyType) {
	      return findApplicableIndexInfo(getIndexInfosOfType(type), keyType);
	    }
	    function getApplicableIndexInfoForName(type, name) {
	      return getApplicableIndexInfo(type, isLateBoundName(name) ? esSymbolType : getStringLiteralType(unescapeLeadingUnderscores(name)));
	    }
	    function getTypeParametersFromDeclaration(declaration) {
	      var _a;
	      let result;
	      for (const node of getEffectiveTypeParameterDeclarations(declaration)) {
	        result = appendIfUnique(result, getDeclaredTypeOfTypeParameter(node.symbol));
	      }
	      return (result == null ? void 0 : result.length) ? result : isFunctionDeclaration(declaration) ? (_a = getSignatureOfTypeTag(declaration)) == null ? void 0 : _a.typeParameters : void 0;
	    }
	    function symbolsToArray(symbols) {
	      const result = [];
	      symbols.forEach((symbol, id) => {
	        if (!isReservedMemberName(id)) {
	          result.push(symbol);
	        }
	      });
	      return result;
	    }
	    function tryFindAmbientModule(moduleName, withAugmentations) {
	      if (isExternalModuleNameRelative(moduleName)) {
	        return void 0;
	      }
	      const symbol = getSymbol2(globals, '"' + moduleName + '"', 512 /* ValueModule */);
	      return symbol && withAugmentations ? getMergedSymbol(symbol) : symbol;
	    }
	    function isOptionalParameter(node) {
	      if (hasQuestionToken(node) || isOptionalJSDocPropertyLikeTag(node) || isJSDocOptionalParameter(node)) {
	        return true;
	      }
	      if (node.initializer) {
	        const signature = getSignatureFromDeclaration(node.parent);
	        const parameterIndex = node.parent.parameters.indexOf(node);
	        Debug.assert(parameterIndex >= 0);
	        return parameterIndex >= getMinArgumentCount(signature, 1 /* StrongArityForUntypedJS */ | 2 /* VoidIsNonOptional */);
	      }
	      const iife = getImmediatelyInvokedFunctionExpression(node.parent);
	      if (iife) {
	        return !node.type && !node.dotDotDotToken && node.parent.parameters.indexOf(node) >= getEffectiveCallArguments(iife).length;
	      }
	      return false;
	    }
	    function isOptionalPropertyDeclaration(node) {
	      return isPropertyDeclaration(node) && !hasAccessorModifier(node) && node.questionToken;
	    }
	    function createTypePredicate(kind, parameterName, parameterIndex, type) {
	      return { kind, parameterName, parameterIndex, type };
	    }
	    function getMinTypeArgumentCount(typeParameters) {
	      let minTypeArgumentCount = 0;
	      if (typeParameters) {
	        for (let i = 0; i < typeParameters.length; i++) {
	          if (!hasTypeParameterDefault(typeParameters[i])) {
	            minTypeArgumentCount = i + 1;
	          }
	        }
	      }
	      return minTypeArgumentCount;
	    }
	    function fillMissingTypeArguments(typeArguments, typeParameters, minTypeArgumentCount, isJavaScriptImplicitAny) {
	      const numTypeParameters = length(typeParameters);
	      if (!numTypeParameters) {
	        return [];
	      }
	      const numTypeArguments = length(typeArguments);
	      if (isJavaScriptImplicitAny || numTypeArguments >= minTypeArgumentCount && numTypeArguments <= numTypeParameters) {
	        const result = typeArguments ? typeArguments.slice() : [];
	        for (let i = numTypeArguments; i < numTypeParameters; i++) {
	          result[i] = errorType;
	        }
	        const baseDefaultType = getDefaultTypeArgumentType(isJavaScriptImplicitAny);
	        for (let i = numTypeArguments; i < numTypeParameters; i++) {
	          let defaultType = getDefaultFromTypeParameter(typeParameters[i]);
	          if (isJavaScriptImplicitAny && defaultType && (isTypeIdenticalTo(defaultType, unknownType) || isTypeIdenticalTo(defaultType, emptyObjectType))) {
	            defaultType = anyType;
	          }
	          result[i] = defaultType ? instantiateType(defaultType, createTypeMapper(typeParameters, result)) : baseDefaultType;
	        }
	        result.length = typeParameters.length;
	        return result;
	      }
	      return typeArguments && typeArguments.slice();
	    }
	    function getSignatureFromDeclaration(declaration) {
	      const links = getNodeLinks(declaration);
	      if (!links.resolvedSignature) {
	        const parameters = [];
	        let flags = 0 /* None */;
	        let minArgumentCount = 0;
	        let thisParameter;
	        let thisTag = isInJSFile(declaration) ? getJSDocThisTag(declaration) : void 0;
	        let hasThisParameter2 = false;
	        const iife = getImmediatelyInvokedFunctionExpression(declaration);
	        const isJSConstructSignature = isJSDocConstructSignature(declaration);
	        const isUntypedSignatureInJSFile = !iife && isInJSFile(declaration) && isValueSignatureDeclaration(declaration) && !hasJSDocParameterTags(declaration) && !getJSDocType(declaration);
	        if (isUntypedSignatureInJSFile) {
	          flags |= 32 /* IsUntypedSignatureInJSFile */;
	        }
	        for (let i = isJSConstructSignature ? 1 : 0; i < declaration.parameters.length; i++) {
	          const param = declaration.parameters[i];
	          if (isInJSFile(param) && isJSDocThisTag(param)) {
	            thisTag = param;
	            continue;
	          }
	          let paramSymbol = param.symbol;
	          const type = isJSDocParameterTag(param) ? param.typeExpression && param.typeExpression.type : param.type;
	          if (paramSymbol && !!(paramSymbol.flags & 4 /* Property */) && !isBindingPattern(param.name)) {
	            const resolvedSymbol = resolveName(
	              param,
	              paramSymbol.escapedName,
	              111551 /* Value */,
	              /*nameNotFoundMessage*/
	              void 0,
	              /*nameArg*/
	              void 0,
	              /*isUse*/
	              false
	            );
	            paramSymbol = resolvedSymbol;
	          }
	          if (i === 0 && paramSymbol.escapedName === "this" /* This */) {
	            hasThisParameter2 = true;
	            thisParameter = param.symbol;
	          } else {
	            parameters.push(paramSymbol);
	          }
	          if (type && type.kind === 201 /* LiteralType */) {
	            flags |= 2 /* HasLiteralTypes */;
	          }
	          const isOptionalParameter2 = isOptionalJSDocPropertyLikeTag(param) || param.initializer || param.questionToken || isRestParameter(param) || iife && parameters.length > iife.arguments.length && !type || isJSDocOptionalParameter(param);
	          if (!isOptionalParameter2) {
	            minArgumentCount = parameters.length;
	          }
	        }
	        if ((declaration.kind === 177 /* GetAccessor */ || declaration.kind === 178 /* SetAccessor */) && hasBindableName(declaration) && (!hasThisParameter2 || !thisParameter)) {
	          const otherKind = declaration.kind === 177 /* GetAccessor */ ? 178 /* SetAccessor */ : 177 /* GetAccessor */;
	          const other = getDeclarationOfKind(getSymbolOfDeclaration(declaration), otherKind);
	          if (other) {
	            thisParameter = getAnnotatedAccessorThisParameter(other);
	          }
	        }
	        if (thisTag && thisTag.typeExpression) {
	          thisParameter = createSymbolWithType(createSymbol(1 /* FunctionScopedVariable */, "this" /* This */), getTypeFromTypeNode(thisTag.typeExpression));
	        }
	        const hostDeclaration = isJSDocSignature(declaration) ? getEffectiveJSDocHost(declaration) : declaration;
	        const classType = hostDeclaration && isConstructorDeclaration(hostDeclaration) ? getDeclaredTypeOfClassOrInterface(getMergedSymbol(hostDeclaration.parent.symbol)) : void 0;
	        const typeParameters = classType ? classType.localTypeParameters : getTypeParametersFromDeclaration(declaration);
	        if (hasRestParameter(declaration) || isInJSFile(declaration) && maybeAddJsSyntheticRestParameter(declaration, parameters)) {
	          flags |= 1 /* HasRestParameter */;
	        }
	        if (isConstructorTypeNode(declaration) && hasSyntacticModifier(declaration, 64 /* Abstract */) || isConstructorDeclaration(declaration) && hasSyntacticModifier(declaration.parent, 64 /* Abstract */)) {
	          flags |= 4 /* Abstract */;
	        }
	        links.resolvedSignature = createSignature(
	          declaration,
	          typeParameters,
	          thisParameter,
	          parameters,
	          /*resolvedReturnType*/
	          void 0,
	          /*resolvedTypePredicate*/
	          void 0,
	          minArgumentCount,
	          flags
	        );
	      }
	      return links.resolvedSignature;
	    }
	    function maybeAddJsSyntheticRestParameter(declaration, parameters) {
	      if (isJSDocSignature(declaration) || !containsArgumentsReference(declaration)) {
	        return false;
	      }
	      const lastParam = lastOrUndefined(declaration.parameters);
	      const lastParamTags = lastParam ? getJSDocParameterTags(lastParam) : getJSDocTags(declaration).filter(isJSDocParameterTag);
	      const lastParamVariadicType = firstDefined(lastParamTags, (p) => p.typeExpression && isJSDocVariadicType(p.typeExpression.type) ? p.typeExpression.type : void 0);
	      const syntheticArgsSymbol = createSymbol(3 /* Variable */, "args", 32768 /* RestParameter */);
	      if (lastParamVariadicType) {
	        syntheticArgsSymbol.links.type = createArrayType(getTypeFromTypeNode(lastParamVariadicType.type));
	      } else {
	        syntheticArgsSymbol.links.checkFlags |= 65536 /* DeferredType */;
	        syntheticArgsSymbol.links.deferralParent = neverType;
	        syntheticArgsSymbol.links.deferralConstituents = [anyArrayType];
	        syntheticArgsSymbol.links.deferralWriteConstituents = [anyArrayType];
	      }
	      if (lastParamVariadicType) {
	        parameters.pop();
	      }
	      parameters.push(syntheticArgsSymbol);
	      return true;
	    }
	    function getSignatureOfTypeTag(node) {
	      if (!(isInJSFile(node) && isFunctionLikeDeclaration(node)))
	        return void 0;
	      const typeTag = getJSDocTypeTag(node);
	      return (typeTag == null ? void 0 : typeTag.typeExpression) && getSingleCallSignature(getTypeFromTypeNode(typeTag.typeExpression));
	    }
	    function getParameterTypeOfTypeTag(func, parameter) {
	      const signature = getSignatureOfTypeTag(func);
	      if (!signature)
	        return void 0;
	      const pos = func.parameters.indexOf(parameter);
	      return parameter.dotDotDotToken ? getRestTypeAtPosition(signature, pos) : getTypeAtPosition(signature, pos);
	    }
	    function getReturnTypeOfTypeTag(node) {
	      const signature = getSignatureOfTypeTag(node);
	      return signature && getReturnTypeOfSignature(signature);
	    }
	    function containsArgumentsReference(declaration) {
	      const links = getNodeLinks(declaration);
	      if (links.containsArgumentsReference === void 0) {
	        if (links.flags & 512 /* CaptureArguments */) {
	          links.containsArgumentsReference = true;
	        } else {
	          links.containsArgumentsReference = traverse(declaration.body);
	        }
	      }
	      return links.containsArgumentsReference;
	      function traverse(node) {
	        if (!node)
	          return false;
	        switch (node.kind) {
	          case 80 /* Identifier */:
	            return node.escapedText === argumentsSymbol.escapedName && getReferencedValueSymbol(node) === argumentsSymbol;
	          case 172 /* PropertyDeclaration */:
	          case 174 /* MethodDeclaration */:
	          case 177 /* GetAccessor */:
	          case 178 /* SetAccessor */:
	            return node.name.kind === 167 /* ComputedPropertyName */ && traverse(node.name);
	          case 211 /* PropertyAccessExpression */:
	          case 212 /* ElementAccessExpression */:
	            return traverse(node.expression);
	          case 303 /* PropertyAssignment */:
	            return traverse(node.initializer);
	          default:
	            return !nodeStartsNewLexicalEnvironment(node) && !isPartOfTypeNode(node) && !!forEachChild(node, traverse);
	        }
	      }
	    }
	    function getSignaturesOfSymbol(symbol) {
	      if (!symbol || !symbol.declarations)
	        return emptyArray;
	      const result = [];
	      for (let i = 0; i < symbol.declarations.length; i++) {
	        const decl = symbol.declarations[i];
	        if (!isFunctionLike(decl))
	          continue;
	        if (i > 0 && decl.body) {
	          const previous = symbol.declarations[i - 1];
	          if (decl.parent === previous.parent && decl.kind === previous.kind && decl.pos === previous.end) {
	            continue;
	          }
	        }
	        if (isInJSFile(decl) && decl.jsDoc) {
	          const tags = getJSDocOverloadTags(decl);
	          if (length(tags)) {
	            for (const tag of tags) {
	              const jsDocSignature = tag.typeExpression;
	              if (jsDocSignature.type === void 0 && !isConstructorDeclaration(decl)) {
	                reportImplicitAny(jsDocSignature, anyType);
	              }
	              result.push(getSignatureFromDeclaration(jsDocSignature));
	            }
	            continue;
	          }
	        }
	        result.push(
	          !isFunctionExpressionOrArrowFunction(decl) && !isObjectLiteralMethod(decl) && getSignatureOfTypeTag(decl) || getSignatureFromDeclaration(decl)
	        );
	      }
	      return result;
	    }
	    function resolveExternalModuleTypeByLiteral(name) {
	      const moduleSym = resolveExternalModuleName(name, name);
	      if (moduleSym) {
	        const resolvedModuleSymbol = resolveExternalModuleSymbol(moduleSym);
	        if (resolvedModuleSymbol) {
	          return getTypeOfSymbol(resolvedModuleSymbol);
	        }
	      }
	      return anyType;
	    }
	    function getThisTypeOfSignature(signature) {
	      if (signature.thisParameter) {
	        return getTypeOfSymbol(signature.thisParameter);
	      }
	    }
	    function getTypePredicateOfSignature(signature) {
	      if (!signature.resolvedTypePredicate) {
	        if (signature.target) {
	          const targetTypePredicate = getTypePredicateOfSignature(signature.target);
	          signature.resolvedTypePredicate = targetTypePredicate ? instantiateTypePredicate(targetTypePredicate, signature.mapper) : noTypePredicate;
	        } else if (signature.compositeSignatures) {
	          signature.resolvedTypePredicate = getUnionOrIntersectionTypePredicate(signature.compositeSignatures, signature.compositeKind) || noTypePredicate;
	        } else {
	          const type = signature.declaration && getEffectiveReturnTypeNode(signature.declaration);
	          let jsdocPredicate;
	          if (!type) {
	            const jsdocSignature = getSignatureOfTypeTag(signature.declaration);
	            if (jsdocSignature && signature !== jsdocSignature) {
	              jsdocPredicate = getTypePredicateOfSignature(jsdocSignature);
	            }
	          }
	          signature.resolvedTypePredicate = type && isTypePredicateNode(type) ? createTypePredicateFromTypePredicateNode(type, signature) : jsdocPredicate || noTypePredicate;
	        }
	        Debug.assert(!!signature.resolvedTypePredicate);
	      }
	      return signature.resolvedTypePredicate === noTypePredicate ? void 0 : signature.resolvedTypePredicate;
	    }
	    function createTypePredicateFromTypePredicateNode(node, signature) {
	      const parameterName = node.parameterName;
	      const type = node.type && getTypeFromTypeNode(node.type);
	      return parameterName.kind === 197 /* ThisType */ ? createTypePredicate(
	        node.assertsModifier ? 2 /* AssertsThis */ : 0 /* This */,
	        /*parameterName*/
	        void 0,
	        /*parameterIndex*/
	        void 0,
	        type
	      ) : createTypePredicate(node.assertsModifier ? 3 /* AssertsIdentifier */ : 1 /* Identifier */, parameterName.escapedText, findIndex(signature.parameters, (p) => p.escapedName === parameterName.escapedText), type);
	    }
	    function getUnionOrIntersectionType(types, kind, unionReduction) {
	      return kind !== 2097152 /* Intersection */ ? getUnionType(types, unionReduction) : getIntersectionType(types);
	    }
	    function getReturnTypeOfSignature(signature) {
	      if (!signature.resolvedReturnType) {
	        if (!pushTypeResolution(signature, 3 /* ResolvedReturnType */)) {
	          return errorType;
	        }
	        let type = signature.target ? instantiateType(getReturnTypeOfSignature(signature.target), signature.mapper) : signature.compositeSignatures ? instantiateType(getUnionOrIntersectionType(map(signature.compositeSignatures, getReturnTypeOfSignature), signature.compositeKind, 2 /* Subtype */), signature.mapper) : getReturnTypeFromAnnotation(signature.declaration) || (nodeIsMissing(signature.declaration.body) ? anyType : getReturnTypeFromBody(signature.declaration));
	        if (signature.flags & 8 /* IsInnerCallChain */) {
	          type = addOptionalTypeMarker(type);
	        } else if (signature.flags & 16 /* IsOuterCallChain */) {
	          type = getOptionalType(type);
	        }
	        if (!popTypeResolution()) {
	          if (signature.declaration) {
	            const typeNode = getEffectiveReturnTypeNode(signature.declaration);
	            if (typeNode) {
	              error2(typeNode, Diagnostics.Return_type_annotation_circularly_references_itself);
	            } else if (noImplicitAny) {
	              const declaration = signature.declaration;
	              const name = getNameOfDeclaration(declaration);
	              if (name) {
	                error2(name, Diagnostics._0_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_referenced_directly_or_indirectly_in_one_of_its_return_expressions, declarationNameToString(name));
	              } else {
	                error2(declaration, Diagnostics.Function_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_referenced_directly_or_indirectly_in_one_of_its_return_expressions);
	              }
	            }
	          }
	          type = anyType;
	        }
	        signature.resolvedReturnType = type;
	      }
	      return signature.resolvedReturnType;
	    }
	    function getReturnTypeFromAnnotation(declaration) {
	      if (declaration.kind === 176 /* Constructor */) {
	        return getDeclaredTypeOfClassOrInterface(getMergedSymbol(declaration.parent.symbol));
	      }
	      const typeNode = getEffectiveReturnTypeNode(declaration);
	      if (isJSDocSignature(declaration)) {
	        const root = getJSDocRoot(declaration);
	        if (root && isConstructorDeclaration(root.parent) && !typeNode) {
	          return getDeclaredTypeOfClassOrInterface(getMergedSymbol(root.parent.parent.symbol));
	        }
	      }
	      if (isJSDocConstructSignature(declaration)) {
	        return getTypeFromTypeNode(declaration.parameters[0].type);
	      }
	      if (typeNode) {
	        return getTypeFromTypeNode(typeNode);
	      }
	      if (declaration.kind === 177 /* GetAccessor */ && hasBindableName(declaration)) {
	        const jsDocType = isInJSFile(declaration) && getTypeForDeclarationFromJSDocComment(declaration);
	        if (jsDocType) {
	          return jsDocType;
	        }
	        const setter = getDeclarationOfKind(getSymbolOfDeclaration(declaration), 178 /* SetAccessor */);
	        const setterType = getAnnotatedAccessorType(setter);
	        if (setterType) {
	          return setterType;
	        }
	      }
	      return getReturnTypeOfTypeTag(declaration);
	    }
	    function isResolvingReturnTypeOfSignature(signature) {
	      return signature.compositeSignatures && some(signature.compositeSignatures, isResolvingReturnTypeOfSignature) || !signature.resolvedReturnType && findResolutionCycleStartIndex(signature, 3 /* ResolvedReturnType */) >= 0;
	    }
	    function getRestTypeOfSignature(signature) {
	      return tryGetRestTypeOfSignature(signature) || anyType;
	    }
	    function tryGetRestTypeOfSignature(signature) {
	      if (signatureHasRestParameter(signature)) {
	        const sigRestType = getTypeOfSymbol(signature.parameters[signature.parameters.length - 1]);
	        const restType = isTupleType(sigRestType) ? getRestTypeOfTupleType(sigRestType) : sigRestType;
	        return restType && getIndexTypeOfType(restType, numberType);
	      }
	      return void 0;
	    }
	    function getSignatureInstantiation(signature, typeArguments, isJavascript, inferredTypeParameters) {
	      const instantiatedSignature = getSignatureInstantiationWithoutFillingInTypeArguments(signature, fillMissingTypeArguments(typeArguments, signature.typeParameters, getMinTypeArgumentCount(signature.typeParameters), isJavascript));
	      if (inferredTypeParameters) {
	        const returnSignature = getSingleCallOrConstructSignature(getReturnTypeOfSignature(instantiatedSignature));
	        if (returnSignature) {
	          const newReturnSignature = cloneSignature(returnSignature);
	          newReturnSignature.typeParameters = inferredTypeParameters;
	          const newInstantiatedSignature = cloneSignature(instantiatedSignature);
	          newInstantiatedSignature.resolvedReturnType = getOrCreateTypeFromSignature(newReturnSignature);
	          return newInstantiatedSignature;
	        }
	      }
	      return instantiatedSignature;
	    }
	    function getSignatureInstantiationWithoutFillingInTypeArguments(signature, typeArguments) {
	      const instantiations = signature.instantiations || (signature.instantiations = /* @__PURE__ */ new Map());
	      const id = getTypeListId(typeArguments);
	      let instantiation = instantiations.get(id);
	      if (!instantiation) {
	        instantiations.set(id, instantiation = createSignatureInstantiation(signature, typeArguments));
	      }
	      return instantiation;
	    }
	    function createSignatureInstantiation(signature, typeArguments) {
	      return instantiateSignature(
	        signature,
	        createSignatureTypeMapper(signature, typeArguments),
	        /*eraseTypeParameters*/
	        true
	      );
	    }
	    function createSignatureTypeMapper(signature, typeArguments) {
	      return createTypeMapper(signature.typeParameters, typeArguments);
	    }
	    function getErasedSignature(signature) {
	      return signature.typeParameters ? signature.erasedSignatureCache || (signature.erasedSignatureCache = createErasedSignature(signature)) : signature;
	    }
	    function createErasedSignature(signature) {
	      return instantiateSignature(
	        signature,
	        createTypeEraser(signature.typeParameters),
	        /*eraseTypeParameters*/
	        true
	      );
	    }
	    function getCanonicalSignature(signature) {
	      return signature.typeParameters ? signature.canonicalSignatureCache || (signature.canonicalSignatureCache = createCanonicalSignature(signature)) : signature;
	    }
	    function createCanonicalSignature(signature) {
	      return getSignatureInstantiation(
	        signature,
	        map(signature.typeParameters, (tp) => tp.target && !getConstraintOfTypeParameter(tp.target) ? tp.target : tp),
	        isInJSFile(signature.declaration)
	      );
	    }
	    function getBaseSignature(signature) {
	      const typeParameters = signature.typeParameters;
	      if (typeParameters) {
	        if (signature.baseSignatureCache) {
	          return signature.baseSignatureCache;
	        }
	        const typeEraser = createTypeEraser(typeParameters);
	        const baseConstraintMapper = createTypeMapper(typeParameters, map(typeParameters, (tp) => getConstraintOfTypeParameter(tp) || unknownType));
	        let baseConstraints = map(typeParameters, (tp) => instantiateType(tp, baseConstraintMapper) || unknownType);
	        for (let i = 0; i < typeParameters.length - 1; i++) {
	          baseConstraints = instantiateTypes(baseConstraints, baseConstraintMapper);
	        }
	        baseConstraints = instantiateTypes(baseConstraints, typeEraser);
	        return signature.baseSignatureCache = instantiateSignature(
	          signature,
	          createTypeMapper(typeParameters, baseConstraints),
	          /*eraseTypeParameters*/
	          true
	        );
	      }
	      return signature;
	    }
	    function getOrCreateTypeFromSignature(signature) {
	      var _a;
	      if (!signature.isolatedSignatureType) {
	        const kind = (_a = signature.declaration) == null ? void 0 : _a.kind;
	        const isConstructor = kind === void 0 || kind === 176 /* Constructor */ || kind === 180 /* ConstructSignature */ || kind === 185 /* ConstructorType */;
	        const type = createObjectType(16 /* Anonymous */);
	        type.members = emptySymbols;
	        type.properties = emptyArray;
	        type.callSignatures = !isConstructor ? [signature] : emptyArray;
	        type.constructSignatures = isConstructor ? [signature] : emptyArray;
	        type.indexInfos = emptyArray;
	        signature.isolatedSignatureType = type;
	      }
	      return signature.isolatedSignatureType;
	    }
	    function getIndexSymbol(symbol) {
	      return symbol.members ? getIndexSymbolFromSymbolTable(symbol.members) : void 0;
	    }
	    function getIndexSymbolFromSymbolTable(symbolTable) {
	      return symbolTable.get("__index" /* Index */);
	    }
	    function createIndexInfo(keyType, type, isReadonly, declaration) {
	      return { keyType, type, isReadonly, declaration };
	    }
	    function getIndexInfosOfSymbol(symbol) {
	      const indexSymbol = getIndexSymbol(symbol);
	      return indexSymbol ? getIndexInfosOfIndexSymbol(indexSymbol) : emptyArray;
	    }
	    function getIndexInfosOfIndexSymbol(indexSymbol) {
	      if (indexSymbol.declarations) {
	        const indexInfos = [];
	        for (const declaration of indexSymbol.declarations) {
	          if (declaration.parameters.length === 1) {
	            const parameter = declaration.parameters[0];
	            if (parameter.type) {
	              forEachType(getTypeFromTypeNode(parameter.type), (keyType) => {
	                if (isValidIndexKeyType(keyType) && !findIndexInfo(indexInfos, keyType)) {
	                  indexInfos.push(createIndexInfo(keyType, declaration.type ? getTypeFromTypeNode(declaration.type) : anyType, hasEffectiveModifier(declaration, 8 /* Readonly */), declaration));
	                }
	              });
	            }
	          }
	        }
	        return indexInfos;
	      }
	      return emptyArray;
	    }
	    function isValidIndexKeyType(type) {
	      return !!(type.flags & (4 /* String */ | 8 /* Number */ | 4096 /* ESSymbol */)) || isPatternLiteralType(type) || !!(type.flags & 2097152 /* Intersection */) && !isGenericType(type) && some(type.types, isValidIndexKeyType);
	    }
	    function getConstraintDeclaration(type) {
	      return mapDefined(filter(type.symbol && type.symbol.declarations, isTypeParameterDeclaration), getEffectiveConstraintOfTypeParameter)[0];
	    }
	    function getInferredTypeParameterConstraint(typeParameter, omitTypeReferences) {
	      var _a;
	      let inferences;
	      if ((_a = typeParameter.symbol) == null ? void 0 : _a.declarations) {
	        for (const declaration of typeParameter.symbol.declarations) {
	          if (declaration.parent.kind === 195 /* InferType */) {
	            const [childTypeParameter = declaration.parent, grandParent] = walkUpParenthesizedTypesAndGetParentAndChild(declaration.parent.parent);
	            if (grandParent.kind === 183 /* TypeReference */ && !omitTypeReferences) {
	              const typeReference = grandParent;
	              const typeParameters = getTypeParametersForTypeReferenceOrImport(typeReference);
	              if (typeParameters) {
	                const index = typeReference.typeArguments.indexOf(childTypeParameter);
	                if (index < typeParameters.length) {
	                  const declaredConstraint = getConstraintOfTypeParameter(typeParameters[index]);
	                  if (declaredConstraint) {
	                    const mapper = makeDeferredTypeMapper(
	                      typeParameters,
	                      typeParameters.map((_, index2) => () => {
	                        return getEffectiveTypeArgumentAtIndex(typeReference, typeParameters, index2);
	                      })
	                    );
	                    const constraint = instantiateType(declaredConstraint, mapper);
	                    if (constraint !== typeParameter) {
	                      inferences = append(inferences, constraint);
	                    }
	                  }
	                }
	              }
	            } else if (grandParent.kind === 169 /* Parameter */ && grandParent.dotDotDotToken || grandParent.kind === 191 /* RestType */ || grandParent.kind === 202 /* NamedTupleMember */ && grandParent.dotDotDotToken) {
	              inferences = append(inferences, createArrayType(unknownType));
	            } else if (grandParent.kind === 204 /* TemplateLiteralTypeSpan */) {
	              inferences = append(inferences, stringType);
	            } else if (grandParent.kind === 168 /* TypeParameter */ && grandParent.parent.kind === 200 /* MappedType */) {
	              inferences = append(inferences, keyofConstraintType);
	            } else if (grandParent.kind === 200 /* MappedType */ && grandParent.type && skipParentheses(grandParent.type) === declaration.parent && grandParent.parent.kind === 194 /* ConditionalType */ && grandParent.parent.extendsType === grandParent && grandParent.parent.checkType.kind === 200 /* MappedType */ && grandParent.parent.checkType.type) {
	              const checkMappedType2 = grandParent.parent.checkType;
	              const nodeType = getTypeFromTypeNode(checkMappedType2.type);
	              inferences = append(inferences, instantiateType(nodeType, makeUnaryTypeMapper(getDeclaredTypeOfTypeParameter(getSymbolOfDeclaration(checkMappedType2.typeParameter)), checkMappedType2.typeParameter.constraint ? getTypeFromTypeNode(checkMappedType2.typeParameter.constraint) : keyofConstraintType)));
	            }
	          }
	        }
	      }
	      return inferences && getIntersectionType(inferences);
	    }
	    function getConstraintFromTypeParameter(typeParameter) {
	      if (!typeParameter.constraint) {
	        if (typeParameter.target) {
	          const targetConstraint = getConstraintOfTypeParameter(typeParameter.target);
	          typeParameter.constraint = targetConstraint ? instantiateType(targetConstraint, typeParameter.mapper) : noConstraintType;
	        } else {
	          const constraintDeclaration = getConstraintDeclaration(typeParameter);
	          if (!constraintDeclaration) {
	            typeParameter.constraint = getInferredTypeParameterConstraint(typeParameter) || noConstraintType;
	          } else {
	            let type = getTypeFromTypeNode(constraintDeclaration);
	            if (type.flags & 1 /* Any */ && !isErrorType(type)) {
	              type = constraintDeclaration.parent.parent.kind === 200 /* MappedType */ ? keyofConstraintType : unknownType;
	            }
	            typeParameter.constraint = type;
	          }
	        }
	      }
	      return typeParameter.constraint === noConstraintType ? void 0 : typeParameter.constraint;
	    }
	    function getParentSymbolOfTypeParameter(typeParameter) {
	      const tp = getDeclarationOfKind(typeParameter.symbol, 168 /* TypeParameter */);
	      const host2 = isJSDocTemplateTag(tp.parent) ? getEffectiveContainerForJSDocTemplateTag(tp.parent) : tp.parent;
	      return host2 && getSymbolOfNode(host2);
	    }
	    function getTypeListId(types) {
	      let result = "";
	      if (types) {
	        const length2 = types.length;
	        let i = 0;
	        while (i < length2) {
	          const startId = types[i].id;
	          let count = 1;
	          while (i + count < length2 && types[i + count].id === startId + count) {
	            count++;
	          }
	          if (result.length) {
	            result += ",";
	          }
	          result += startId;
	          if (count > 1) {
	            result += ":" + count;
	          }
	          i += count;
	        }
	      }
	      return result;
	    }
	    function getAliasId(aliasSymbol, aliasTypeArguments) {
	      return aliasSymbol ? `@${getSymbolId(aliasSymbol)}` + (aliasTypeArguments ? `:${getTypeListId(aliasTypeArguments)}` : "") : "";
	    }
	    function getPropagatingFlagsOfTypes(types, excludeKinds) {
	      let result = 0;
	      for (const type of types) {
	        if (excludeKinds === void 0 || !(type.flags & excludeKinds)) {
	          result |= getObjectFlags(type);
	        }
	      }
	      return result & 458752 /* PropagatingFlags */;
	    }
	    function tryCreateTypeReference(target, typeArguments) {
	      if (some(typeArguments) && target === emptyGenericType) {
	        return unknownType;
	      }
	      return createTypeReference(target, typeArguments);
	    }
	    function createTypeReference(target, typeArguments) {
	      const id = getTypeListId(typeArguments);
	      let type = target.instantiations.get(id);
	      if (!type) {
	        type = createObjectType(4 /* Reference */, target.symbol);
	        target.instantiations.set(id, type);
	        type.objectFlags |= typeArguments ? getPropagatingFlagsOfTypes(typeArguments) : 0;
	        type.target = target;
	        type.resolvedTypeArguments = typeArguments;
	      }
	      return type;
	    }
	    function cloneTypeReference(source) {
	      const type = createTypeWithSymbol(source.flags, source.symbol);
	      type.objectFlags = source.objectFlags;
	      type.target = source.target;
	      type.resolvedTypeArguments = source.resolvedTypeArguments;
	      return type;
	    }
	    function createDeferredTypeReference(target, node, mapper, aliasSymbol, aliasTypeArguments) {
	      if (!aliasSymbol) {
	        aliasSymbol = getAliasSymbolForTypeNode(node);
	        const localAliasTypeArguments = getTypeArgumentsForAliasSymbol(aliasSymbol);
	        aliasTypeArguments = mapper ? instantiateTypes(localAliasTypeArguments, mapper) : localAliasTypeArguments;
	      }
	      const type = createObjectType(4 /* Reference */, target.symbol);
	      type.target = target;
	      type.node = node;
	      type.mapper = mapper;
	      type.aliasSymbol = aliasSymbol;
	      type.aliasTypeArguments = aliasTypeArguments;
	      return type;
	    }
	    function getTypeArguments(type) {
	      var _a, _b;
	      if (!type.resolvedTypeArguments) {
	        if (!pushTypeResolution(type, 6 /* ResolvedTypeArguments */)) {
	          return ((_a = type.target.localTypeParameters) == null ? void 0 : _a.map(() => errorType)) || emptyArray;
	        }
	        const node = type.node;
	        const typeArguments = !node ? emptyArray : node.kind === 183 /* TypeReference */ ? concatenate(type.target.outerTypeParameters, getEffectiveTypeArguments2(node, type.target.localTypeParameters)) : node.kind === 188 /* ArrayType */ ? [getTypeFromTypeNode(node.elementType)] : map(node.elements, getTypeFromTypeNode);
	        if (popTypeResolution()) {
	          type.resolvedTypeArguments = type.mapper ? instantiateTypes(typeArguments, type.mapper) : typeArguments;
	        } else {
	          type.resolvedTypeArguments = ((_b = type.target.localTypeParameters) == null ? void 0 : _b.map(() => errorType)) || emptyArray;
	          error2(
	            type.node || currentNode,
	            type.target.symbol ? Diagnostics.Type_arguments_for_0_circularly_reference_themselves : Diagnostics.Tuple_type_arguments_circularly_reference_themselves,
	            type.target.symbol && symbolToString(type.target.symbol)
	          );
	        }
	      }
	      return type.resolvedTypeArguments;
	    }
	    function getTypeReferenceArity(type) {
	      return length(type.target.typeParameters);
	    }
	    function getTypeFromClassOrInterfaceReference(node, symbol) {
	      const type = getDeclaredTypeOfSymbol(getMergedSymbol(symbol));
	      const typeParameters = type.localTypeParameters;
	      if (typeParameters) {
	        const numTypeArguments = length(node.typeArguments);
	        const minTypeArgumentCount = getMinTypeArgumentCount(typeParameters);
	        const isJs = isInJSFile(node);
	        const isJsImplicitAny = !noImplicitAny && isJs;
	        if (!isJsImplicitAny && (numTypeArguments < minTypeArgumentCount || numTypeArguments > typeParameters.length)) {
	          const missingAugmentsTag = isJs && isExpressionWithTypeArguments(node) && !isJSDocAugmentsTag(node.parent);
	          const diag2 = minTypeArgumentCount === typeParameters.length ? missingAugmentsTag ? Diagnostics.Expected_0_type_arguments_provide_these_with_an_extends_tag : Diagnostics.Generic_type_0_requires_1_type_argument_s : missingAugmentsTag ? Diagnostics.Expected_0_1_type_arguments_provide_these_with_an_extends_tag : Diagnostics.Generic_type_0_requires_between_1_and_2_type_arguments;
	          const typeStr = typeToString(
	            type,
	            /*enclosingDeclaration*/
	            void 0,
	            2 /* WriteArrayAsGenericType */
	          );
	          error2(node, diag2, typeStr, minTypeArgumentCount, typeParameters.length);
	          if (!isJs) {
	            return errorType;
	          }
	        }
	        if (node.kind === 183 /* TypeReference */ && isDeferredTypeReferenceNode(node, length(node.typeArguments) !== typeParameters.length)) {
	          return createDeferredTypeReference(
	            type,
	            node,
	            /*mapper*/
	            void 0
	          );
	        }
	        const typeArguments = concatenate(type.outerTypeParameters, fillMissingTypeArguments(typeArgumentsFromTypeReferenceNode(node), typeParameters, minTypeArgumentCount, isJs));
	        return createTypeReference(type, typeArguments);
	      }
	      return checkNoTypeArguments(node, symbol) ? type : errorType;
	    }
	    function getTypeAliasInstantiation(symbol, typeArguments, aliasSymbol, aliasTypeArguments) {
	      const type = getDeclaredTypeOfSymbol(symbol);
	      if (type === intrinsicMarkerType) {
	        const typeKind = intrinsicTypeKinds.get(symbol.escapedName);
	        if (typeKind !== void 0 && typeArguments && typeArguments.length === 1) {
	          return typeKind === 4 /* NoInfer */ ? getNoInferType(typeArguments[0]) : getStringMappingType(symbol, typeArguments[0]);
	        }
	      }
	      const links = getSymbolLinks(symbol);
	      const typeParameters = links.typeParameters;
	      const id = getTypeListId(typeArguments) + getAliasId(aliasSymbol, aliasTypeArguments);
	      let instantiation = links.instantiations.get(id);
	      if (!instantiation) {
	        links.instantiations.set(id, instantiation = instantiateTypeWithAlias(type, createTypeMapper(typeParameters, fillMissingTypeArguments(typeArguments, typeParameters, getMinTypeArgumentCount(typeParameters), isInJSFile(symbol.valueDeclaration))), aliasSymbol, aliasTypeArguments));
	      }
	      return instantiation;
	    }
	    function getTypeFromTypeAliasReference(node, symbol) {
	      if (getCheckFlags(symbol) & 1048576 /* Unresolved */) {
	        const typeArguments = typeArgumentsFromTypeReferenceNode(node);
	        const id = getAliasId(symbol, typeArguments);
	        let errorType2 = errorTypes.get(id);
	        if (!errorType2) {
	          errorType2 = createIntrinsicType(
	            1 /* Any */,
	            "error",
	            /*objectFlags*/
	            void 0,
	            `alias ${id}`
	          );
	          errorType2.aliasSymbol = symbol;
	          errorType2.aliasTypeArguments = typeArguments;
	          errorTypes.set(id, errorType2);
	        }
	        return errorType2;
	      }
	      const type = getDeclaredTypeOfSymbol(symbol);
	      const typeParameters = getSymbolLinks(symbol).typeParameters;
	      if (typeParameters) {
	        const numTypeArguments = length(node.typeArguments);
	        const minTypeArgumentCount = getMinTypeArgumentCount(typeParameters);
	        if (numTypeArguments < minTypeArgumentCount || numTypeArguments > typeParameters.length) {
	          error2(
	            node,
	            minTypeArgumentCount === typeParameters.length ? Diagnostics.Generic_type_0_requires_1_type_argument_s : Diagnostics.Generic_type_0_requires_between_1_and_2_type_arguments,
	            symbolToString(symbol),
	            minTypeArgumentCount,
	            typeParameters.length
	          );
	          return errorType;
	        }
	        const aliasSymbol = getAliasSymbolForTypeNode(node);
	        let newAliasSymbol = aliasSymbol && (isLocalTypeAlias(symbol) || !isLocalTypeAlias(aliasSymbol)) ? aliasSymbol : void 0;
	        let aliasTypeArguments;
	        if (newAliasSymbol) {
	          aliasTypeArguments = getTypeArgumentsForAliasSymbol(newAliasSymbol);
	        } else if (isTypeReferenceType(node)) {
	          const aliasSymbol2 = resolveTypeReferenceName(
	            node,
	            2097152 /* Alias */,
	            /*ignoreErrors*/
	            true
	          );
	          if (aliasSymbol2 && aliasSymbol2 !== unknownSymbol) {
	            const resolved = resolveAlias(aliasSymbol2);
	            if (resolved && resolved.flags & 524288 /* TypeAlias */) {
	              newAliasSymbol = resolved;
	              aliasTypeArguments = typeArgumentsFromTypeReferenceNode(node) || (typeParameters ? [] : void 0);
	            }
	          }
	        }
	        return getTypeAliasInstantiation(symbol, typeArgumentsFromTypeReferenceNode(node), newAliasSymbol, aliasTypeArguments);
	      }
	      return checkNoTypeArguments(node, symbol) ? type : errorType;
	    }
	    function isLocalTypeAlias(symbol) {
	      var _a;
	      const declaration = (_a = symbol.declarations) == null ? void 0 : _a.find(isTypeAlias);
	      return !!(declaration && getContainingFunction(declaration));
	    }
	    function getTypeReferenceName(node) {
	      switch (node.kind) {
	        case 183 /* TypeReference */:
	          return node.typeName;
	        case 233 /* ExpressionWithTypeArguments */:
	          const expr = node.expression;
	          if (isEntityNameExpression(expr)) {
	            return expr;
	          }
	      }
	      return void 0;
	    }
	    function getSymbolPath(symbol) {
	      return symbol.parent ? `${getSymbolPath(symbol.parent)}.${symbol.escapedName}` : symbol.escapedName;
	    }
	    function getUnresolvedSymbolForEntityName(name) {
	      const identifier = name.kind === 166 /* QualifiedName */ ? name.right : name.kind === 211 /* PropertyAccessExpression */ ? name.name : name;
	      const text = identifier.escapedText;
	      if (text) {
	        const parentSymbol = name.kind === 166 /* QualifiedName */ ? getUnresolvedSymbolForEntityName(name.left) : name.kind === 211 /* PropertyAccessExpression */ ? getUnresolvedSymbolForEntityName(name.expression) : void 0;
	        const path = parentSymbol ? `${getSymbolPath(parentSymbol)}.${text}` : text;
	        let result = unresolvedSymbols.get(path);
	        if (!result) {
	          unresolvedSymbols.set(path, result = createSymbol(524288 /* TypeAlias */, text, 1048576 /* Unresolved */));
	          result.parent = parentSymbol;
	          result.links.declaredType = unresolvedType;
	        }
	        return result;
	      }
	      return unknownSymbol;
	    }
	    function resolveTypeReferenceName(typeReference, meaning, ignoreErrors) {
	      const name = getTypeReferenceName(typeReference);
	      if (!name) {
	        return unknownSymbol;
	      }
	      const symbol = resolveEntityName(name, meaning, ignoreErrors);
	      return symbol && symbol !== unknownSymbol ? symbol : ignoreErrors ? unknownSymbol : getUnresolvedSymbolForEntityName(name);
	    }
	    function getTypeReferenceType(node, symbol) {
	      if (symbol === unknownSymbol) {
	        return errorType;
	      }
	      symbol = getExpandoSymbol(symbol) || symbol;
	      if (symbol.flags & (32 /* Class */ | 64 /* Interface */)) {
	        return getTypeFromClassOrInterfaceReference(node, symbol);
	      }
	      if (symbol.flags & 524288 /* TypeAlias */) {
	        return getTypeFromTypeAliasReference(node, symbol);
	      }
	      const res = tryGetDeclaredTypeOfSymbol(symbol);
	      if (res) {
	        return checkNoTypeArguments(node, symbol) ? getRegularTypeOfLiteralType(res) : errorType;
	      }
	      if (symbol.flags & 111551 /* Value */ && isJSDocTypeReference(node)) {
	        const jsdocType = getTypeFromJSDocValueReference(node, symbol);
	        if (jsdocType) {
	          return jsdocType;
	        } else {
	          resolveTypeReferenceName(node, 788968 /* Type */);
	          return getTypeOfSymbol(symbol);
	        }
	      }
	      return errorType;
	    }
	    function getTypeFromJSDocValueReference(node, symbol) {
	      const links = getNodeLinks(node);
	      if (!links.resolvedJSDocType) {
	        const valueType = getTypeOfSymbol(symbol);
	        let typeType = valueType;
	        if (symbol.valueDeclaration) {
	          const isImportTypeWithQualifier = node.kind === 205 /* ImportType */ && node.qualifier;
	          if (valueType.symbol && valueType.symbol !== symbol && isImportTypeWithQualifier) {
	            typeType = getTypeReferenceType(node, valueType.symbol);
	          }
	        }
	        links.resolvedJSDocType = typeType;
	      }
	      return links.resolvedJSDocType;
	    }
	    function getNoInferType(type) {
	      return isNoInferTargetType(type) ? getOrCreateSubstitutionType(type, unknownType) : type;
	    }
	    function isNoInferTargetType(type) {
	      return !!(type.flags & 3145728 /* UnionOrIntersection */ && some(type.types, isNoInferTargetType) || type.flags & 33554432 /* Substitution */ && !isNoInferType(type) && isNoInferTargetType(type.baseType) || type.flags & 524288 /* Object */ && !isEmptyAnonymousObjectType(type) || type.flags & (465829888 /* Instantiable */ & ~33554432 /* Substitution */) && !isPatternLiteralType(type));
	    }
	    function isNoInferType(type) {
	      return !!(type.flags & 33554432 /* Substitution */ && type.constraint.flags & 2 /* Unknown */);
	    }
	    function getSubstitutionType(baseType, constraint) {
	      return constraint.flags & 3 /* AnyOrUnknown */ || constraint === baseType || baseType.flags & 1 /* Any */ ? baseType : getOrCreateSubstitutionType(baseType, constraint);
	    }
	    function getOrCreateSubstitutionType(baseType, constraint) {
	      const id = `${getTypeId(baseType)}>${getTypeId(constraint)}`;
	      const cached = substitutionTypes.get(id);
	      if (cached) {
	        return cached;
	      }
	      const result = createType(33554432 /* Substitution */);
	      result.baseType = baseType;
	      result.constraint = constraint;
	      substitutionTypes.set(id, result);
	      return result;
	    }
	    function getSubstitutionIntersection(substitutionType) {
	      return isNoInferType(substitutionType) ? substitutionType.baseType : getIntersectionType([substitutionType.constraint, substitutionType.baseType]);
	    }
	    function isUnaryTupleTypeNode(node) {
	      return node.kind === 189 /* TupleType */ && node.elements.length === 1;
	    }
	    function getImpliedConstraint(type, checkNode, extendsNode) {
	      return isUnaryTupleTypeNode(checkNode) && isUnaryTupleTypeNode(extendsNode) ? getImpliedConstraint(type, checkNode.elements[0], extendsNode.elements[0]) : getActualTypeVariable(getTypeFromTypeNode(checkNode)) === getActualTypeVariable(type) ? getTypeFromTypeNode(extendsNode) : void 0;
	    }
	    function getConditionalFlowTypeOfType(type, node) {
	      let constraints;
	      let covariant = true;
	      while (node && !isStatement(node) && node.kind !== 327 /* JSDoc */) {
	        const parent2 = node.parent;
	        if (parent2.kind === 169 /* Parameter */) {
	          covariant = !covariant;
	        }
	        if ((covariant || type.flags & 8650752 /* TypeVariable */) && parent2.kind === 194 /* ConditionalType */ && node === parent2.trueType) {
	          const constraint = getImpliedConstraint(type, parent2.checkType, parent2.extendsType);
	          if (constraint) {
	            constraints = append(constraints, constraint);
	          }
	        } else if (type.flags & 262144 /* TypeParameter */ && parent2.kind === 200 /* MappedType */ && !parent2.nameType && node === parent2.type) {
	          const mappedType = getTypeFromTypeNode(parent2);
	          if (getTypeParameterFromMappedType(mappedType) === getActualTypeVariable(type)) {
	            const typeParameter = getHomomorphicTypeVariable(mappedType);
	            if (typeParameter) {
	              const constraint = getConstraintOfTypeParameter(typeParameter);
	              if (constraint && everyType(constraint, isArrayOrTupleType)) {
	                constraints = append(constraints, getUnionType([numberType, numericStringType]));
	              }
	            }
	          }
	        }
	        node = parent2;
	      }
	      return constraints ? getSubstitutionType(type, getIntersectionType(constraints)) : type;
	    }
	    function isJSDocTypeReference(node) {
	      return !!(node.flags & 16777216 /* JSDoc */) && (node.kind === 183 /* TypeReference */ || node.kind === 205 /* ImportType */);
	    }
	    function checkNoTypeArguments(node, symbol) {
	      if (node.typeArguments) {
	        error2(node, Diagnostics.Type_0_is_not_generic, symbol ? symbolToString(symbol) : node.typeName ? declarationNameToString(node.typeName) : anon);
	        return false;
	      }
	      return true;
	    }
	    function getIntendedTypeFromJSDocTypeReference(node) {
	      if (isIdentifier(node.typeName)) {
	        const typeArgs = node.typeArguments;
	        switch (node.typeName.escapedText) {
	          case "String":
	            checkNoTypeArguments(node);
	            return stringType;
	          case "Number":
	            checkNoTypeArguments(node);
	            return numberType;
	          case "Boolean":
	            checkNoTypeArguments(node);
	            return booleanType;
	          case "Void":
	            checkNoTypeArguments(node);
	            return voidType;
	          case "Undefined":
	            checkNoTypeArguments(node);
	            return undefinedType;
	          case "Null":
	            checkNoTypeArguments(node);
	            return nullType;
	          case "Function":
	          case "function":
	            checkNoTypeArguments(node);
	            return globalFunctionType;
	          case "array":
	            return (!typeArgs || !typeArgs.length) && !noImplicitAny ? anyArrayType : void 0;
	          case "promise":
	            return (!typeArgs || !typeArgs.length) && !noImplicitAny ? createPromiseType(anyType) : void 0;
	          case "Object":
	            if (typeArgs && typeArgs.length === 2) {
	              if (isJSDocIndexSignature(node)) {
	                const indexed = getTypeFromTypeNode(typeArgs[0]);
	                const target = getTypeFromTypeNode(typeArgs[1]);
	                const indexInfo = indexed === stringType || indexed === numberType ? [createIndexInfo(
	                  indexed,
	                  target,
	                  /*isReadonly*/
	                  false
	                )] : emptyArray;
	                return createAnonymousType(
	                  /*symbol*/
	                  void 0,
	                  emptySymbols,
	                  emptyArray,
	                  emptyArray,
	                  indexInfo
	                );
	              }
	              return anyType;
	            }
	            checkNoTypeArguments(node);
	            return !noImplicitAny ? anyType : void 0;
	        }
	      }
	    }
	    function getTypeFromJSDocNullableTypeNode(node) {
	      const type = getTypeFromTypeNode(node.type);
	      return strictNullChecks ? getNullableType(type, 65536 /* Null */) : type;
	    }
	    function getTypeFromTypeReference(node) {
	      const links = getNodeLinks(node);
	      if (!links.resolvedType) {
	        if (isConstTypeReference(node) && isAssertionExpression(node.parent)) {
	          links.resolvedSymbol = unknownSymbol;
	          return links.resolvedType = checkExpressionCached(node.parent.expression);
	        }
	        let symbol;
	        let type;
	        const meaning = 788968 /* Type */;
	        if (isJSDocTypeReference(node)) {
	          type = getIntendedTypeFromJSDocTypeReference(node);
	          if (!type) {
	            symbol = resolveTypeReferenceName(
	              node,
	              meaning,
	              /*ignoreErrors*/
	              true
	            );
	            if (symbol === unknownSymbol) {
	              symbol = resolveTypeReferenceName(node, meaning | 111551 /* Value */);
	            } else {
	              resolveTypeReferenceName(node, meaning);
	            }
	            type = getTypeReferenceType(node, symbol);
	          }
	        }
	        if (!type) {
	          symbol = resolveTypeReferenceName(node, meaning);
	          type = getTypeReferenceType(node, symbol);
	        }
	        links.resolvedSymbol = symbol;
	        links.resolvedType = type;
	      }
	      return links.resolvedType;
	    }
	    function typeArgumentsFromTypeReferenceNode(node) {
	      return map(node.typeArguments, getTypeFromTypeNode);
	    }
	    function getTypeFromTypeQueryNode(node) {
	      const links = getNodeLinks(node);
	      if (!links.resolvedType) {
	        const type = checkExpressionWithTypeArguments(node);
	        links.resolvedType = getRegularTypeOfLiteralType(getWidenedType(type));
	      }
	      return links.resolvedType;
	    }
	    function getTypeOfGlobalSymbol(symbol, arity) {
	      function getTypeDeclaration(symbol2) {
	        const declarations = symbol2.declarations;
	        if (declarations) {
	          for (const declaration of declarations) {
	            switch (declaration.kind) {
	              case 263 /* ClassDeclaration */:
	              case 264 /* InterfaceDeclaration */:
	              case 266 /* EnumDeclaration */:
	                return declaration;
	            }
	          }
	        }
	      }
	      if (!symbol) {
	        return arity ? emptyGenericType : emptyObjectType;
	      }
	      const type = getDeclaredTypeOfSymbol(symbol);
	      if (!(type.flags & 524288 /* Object */)) {
	        error2(getTypeDeclaration(symbol), Diagnostics.Global_type_0_must_be_a_class_or_interface_type, symbolName(symbol));
	        return arity ? emptyGenericType : emptyObjectType;
	      }
	      if (length(type.typeParameters) !== arity) {
	        error2(getTypeDeclaration(symbol), Diagnostics.Global_type_0_must_have_1_type_parameter_s, symbolName(symbol), arity);
	        return arity ? emptyGenericType : emptyObjectType;
	      }
	      return type;
	    }
	    function getGlobalValueSymbol(name, reportErrors2) {
	      return getGlobalSymbol(name, 111551 /* Value */, reportErrors2 ? Diagnostics.Cannot_find_global_value_0 : void 0);
	    }
	    function getGlobalTypeSymbol(name, reportErrors2) {
	      return getGlobalSymbol(name, 788968 /* Type */, reportErrors2 ? Diagnostics.Cannot_find_global_type_0 : void 0);
	    }
	    function getGlobalTypeAliasSymbol(name, arity, reportErrors2) {
	      const symbol = getGlobalSymbol(name, 788968 /* Type */, reportErrors2 ? Diagnostics.Cannot_find_global_type_0 : void 0);
	      if (symbol) {
	        getDeclaredTypeOfSymbol(symbol);
	        if (length(getSymbolLinks(symbol).typeParameters) !== arity) {
	          const decl = symbol.declarations && find(symbol.declarations, isTypeAliasDeclaration);
	          error2(decl, Diagnostics.Global_type_0_must_have_1_type_parameter_s, symbolName(symbol), arity);
	          return void 0;
	        }
	      }
	      return symbol;
	    }
	    function getGlobalSymbol(name, meaning, diagnostic) {
	      return resolveName(
	        /*location*/
	        void 0,
	        name,
	        meaning,
	        diagnostic,
	        name,
	        /*isUse*/
	        false,
	        /*excludeGlobals*/
	        false,
	        /*getSpellingSuggestions*/
	        false
	      );
	    }
	    function getGlobalType(name, arity, reportErrors2) {
	      const symbol = getGlobalTypeSymbol(name, reportErrors2);
	      return symbol || reportErrors2 ? getTypeOfGlobalSymbol(symbol, arity) : void 0;
	    }
	    function getGlobalTypedPropertyDescriptorType() {
	      return deferredGlobalTypedPropertyDescriptorType || (deferredGlobalTypedPropertyDescriptorType = getGlobalType(
	        "TypedPropertyDescriptor",
	        /*arity*/
	        1,
	        /*reportErrors*/
	        true
	      ) || emptyGenericType);
	    }
	    function getGlobalTemplateStringsArrayType() {
	      return deferredGlobalTemplateStringsArrayType || (deferredGlobalTemplateStringsArrayType = getGlobalType(
	        "TemplateStringsArray",
	        /*arity*/
	        0,
	        /*reportErrors*/
	        true
	      ) || emptyObjectType);
	    }
	    function getGlobalImportMetaType() {
	      return deferredGlobalImportMetaType || (deferredGlobalImportMetaType = getGlobalType(
	        "ImportMeta",
	        /*arity*/
	        0,
	        /*reportErrors*/
	        true
	      ) || emptyObjectType);
	    }
	    function getGlobalImportMetaExpressionType() {
	      if (!deferredGlobalImportMetaExpressionType) {
	        const symbol = createSymbol(0 /* None */, "ImportMetaExpression");
	        const importMetaType = getGlobalImportMetaType();
	        const metaPropertySymbol = createSymbol(4 /* Property */, "meta", 8 /* Readonly */);
	        metaPropertySymbol.parent = symbol;
	        metaPropertySymbol.links.type = importMetaType;
	        const members = createSymbolTable([metaPropertySymbol]);
	        symbol.members = members;
	        deferredGlobalImportMetaExpressionType = createAnonymousType(symbol, members, emptyArray, emptyArray, emptyArray);
	      }
	      return deferredGlobalImportMetaExpressionType;
	    }
	    function getGlobalImportCallOptionsType(reportErrors2) {
	      return deferredGlobalImportCallOptionsType || (deferredGlobalImportCallOptionsType = getGlobalType(
	        "ImportCallOptions",
	        /*arity*/
	        0,
	        reportErrors2
	      )) || emptyObjectType;
	    }
	    function getGlobalImportAttributesType(reportErrors2) {
	      return deferredGlobalImportAttributesType || (deferredGlobalImportAttributesType = getGlobalType(
	        "ImportAttributes",
	        /*arity*/
	        0,
	        reportErrors2
	      )) || emptyObjectType;
	    }
	    function getGlobalESSymbolConstructorSymbol(reportErrors2) {
	      return deferredGlobalESSymbolConstructorSymbol || (deferredGlobalESSymbolConstructorSymbol = getGlobalValueSymbol("Symbol", reportErrors2));
	    }
	    function getGlobalESSymbolConstructorTypeSymbol(reportErrors2) {
	      return deferredGlobalESSymbolConstructorTypeSymbol || (deferredGlobalESSymbolConstructorTypeSymbol = getGlobalTypeSymbol("SymbolConstructor", reportErrors2));
	    }
	    function getGlobalESSymbolType() {
	      return deferredGlobalESSymbolType || (deferredGlobalESSymbolType = getGlobalType(
	        "Symbol",
	        /*arity*/
	        0,
	        /*reportErrors*/
	        false
	      )) || emptyObjectType;
	    }
	    function getGlobalPromiseType(reportErrors2) {
	      return deferredGlobalPromiseType || (deferredGlobalPromiseType = getGlobalType(
	        "Promise",
	        /*arity*/
	        1,
	        reportErrors2
	      )) || emptyGenericType;
	    }
	    function getGlobalPromiseLikeType(reportErrors2) {
	      return deferredGlobalPromiseLikeType || (deferredGlobalPromiseLikeType = getGlobalType(
	        "PromiseLike",
	        /*arity*/
	        1,
	        reportErrors2
	      )) || emptyGenericType;
	    }
	    function getGlobalPromiseConstructorSymbol(reportErrors2) {
	      return deferredGlobalPromiseConstructorSymbol || (deferredGlobalPromiseConstructorSymbol = getGlobalValueSymbol("Promise", reportErrors2));
	    }
	    function getGlobalPromiseConstructorLikeType(reportErrors2) {
	      return deferredGlobalPromiseConstructorLikeType || (deferredGlobalPromiseConstructorLikeType = getGlobalType(
	        "PromiseConstructorLike",
	        /*arity*/
	        0,
	        reportErrors2
	      )) || emptyObjectType;
	    }
	    function getGlobalAsyncIterableType(reportErrors2) {
	      return deferredGlobalAsyncIterableType || (deferredGlobalAsyncIterableType = getGlobalType(
	        "AsyncIterable",
	        /*arity*/
	        1,
	        reportErrors2
	      )) || emptyGenericType;
	    }
	    function getGlobalAsyncIteratorType(reportErrors2) {
	      return deferredGlobalAsyncIteratorType || (deferredGlobalAsyncIteratorType = getGlobalType(
	        "AsyncIterator",
	        /*arity*/
	        3,
	        reportErrors2
	      )) || emptyGenericType;
	    }
	    function getGlobalAsyncIterableIteratorType(reportErrors2) {
	      return deferredGlobalAsyncIterableIteratorType || (deferredGlobalAsyncIterableIteratorType = getGlobalType(
	        "AsyncIterableIterator",
	        /*arity*/
	        1,
	        reportErrors2
	      )) || emptyGenericType;
	    }
	    function getGlobalAsyncGeneratorType(reportErrors2) {
	      return deferredGlobalAsyncGeneratorType || (deferredGlobalAsyncGeneratorType = getGlobalType(
	        "AsyncGenerator",
	        /*arity*/
	        3,
	        reportErrors2
	      )) || emptyGenericType;
	    }
	    function getGlobalIterableType(reportErrors2) {
	      return deferredGlobalIterableType || (deferredGlobalIterableType = getGlobalType(
	        "Iterable",
	        /*arity*/
	        1,
	        reportErrors2
	      )) || emptyGenericType;
	    }
	    function getGlobalIteratorType(reportErrors2) {
	      return deferredGlobalIteratorType || (deferredGlobalIteratorType = getGlobalType(
	        "Iterator",
	        /*arity*/
	        3,
	        reportErrors2
	      )) || emptyGenericType;
	    }
	    function getGlobalIterableIteratorType(reportErrors2) {
	      return deferredGlobalIterableIteratorType || (deferredGlobalIterableIteratorType = getGlobalType(
	        "IterableIterator",
	        /*arity*/
	        1,
	        reportErrors2
	      )) || emptyGenericType;
	    }
	    function getGlobalGeneratorType(reportErrors2) {
	      return deferredGlobalGeneratorType || (deferredGlobalGeneratorType = getGlobalType(
	        "Generator",
	        /*arity*/
	        3,
	        reportErrors2
	      )) || emptyGenericType;
	    }
	    function getGlobalIteratorYieldResultType(reportErrors2) {
	      return deferredGlobalIteratorYieldResultType || (deferredGlobalIteratorYieldResultType = getGlobalType(
	        "IteratorYieldResult",
	        /*arity*/
	        1,
	        reportErrors2
	      )) || emptyGenericType;
	    }
	    function getGlobalIteratorReturnResultType(reportErrors2) {
	      return deferredGlobalIteratorReturnResultType || (deferredGlobalIteratorReturnResultType = getGlobalType(
	        "IteratorReturnResult",
	        /*arity*/
	        1,
	        reportErrors2
	      )) || emptyGenericType;
	    }
	    function getGlobalDisposableType(reportErrors2) {
	      return deferredGlobalDisposableType || (deferredGlobalDisposableType = getGlobalType(
	        "Disposable",
	        /*arity*/
	        0,
	        reportErrors2
	      )) || emptyObjectType;
	    }
	    function getGlobalAsyncDisposableType(reportErrors2) {
	      return deferredGlobalAsyncDisposableType || (deferredGlobalAsyncDisposableType = getGlobalType(
	        "AsyncDisposable",
	        /*arity*/
	        0,
	        reportErrors2
	      )) || emptyObjectType;
	    }
	    function getGlobalTypeOrUndefined(name, arity = 0) {
	      const symbol = getGlobalSymbol(
	        name,
	        788968 /* Type */,
	        /*diagnostic*/
	        void 0
	      );
	      return symbol && getTypeOfGlobalSymbol(symbol, arity);
	    }
	    function getGlobalExtractSymbol() {
	      deferredGlobalExtractSymbol || (deferredGlobalExtractSymbol = getGlobalTypeAliasSymbol(
	        "Extract",
	        /*arity*/
	        2,
	        /*reportErrors*/
	        true
	      ) || unknownSymbol);
	      return deferredGlobalExtractSymbol === unknownSymbol ? void 0 : deferredGlobalExtractSymbol;
	    }
	    function getGlobalOmitSymbol() {
	      deferredGlobalOmitSymbol || (deferredGlobalOmitSymbol = getGlobalTypeAliasSymbol(
	        "Omit",
	        /*arity*/
	        2,
	        /*reportErrors*/
	        true
	      ) || unknownSymbol);
	      return deferredGlobalOmitSymbol === unknownSymbol ? void 0 : deferredGlobalOmitSymbol;
	    }
	    function getGlobalAwaitedSymbol(reportErrors2) {
	      deferredGlobalAwaitedSymbol || (deferredGlobalAwaitedSymbol = getGlobalTypeAliasSymbol(
	        "Awaited",
	        /*arity*/
	        1,
	        reportErrors2
	      ) || (reportErrors2 ? unknownSymbol : void 0));
	      return deferredGlobalAwaitedSymbol === unknownSymbol ? void 0 : deferredGlobalAwaitedSymbol;
	    }
	    function getGlobalBigIntType() {
	      return deferredGlobalBigIntType || (deferredGlobalBigIntType = getGlobalType(
	        "BigInt",
	        /*arity*/
	        0,
	        /*reportErrors*/
	        false
	      )) || emptyObjectType;
	    }
	    function getGlobalClassDecoratorContextType(reportErrors2) {
	      return deferredGlobalClassDecoratorContextType ?? (deferredGlobalClassDecoratorContextType = getGlobalType(
	        "ClassDecoratorContext",
	        /*arity*/
	        1,
	        reportErrors2
	      )) ?? emptyGenericType;
	    }
	    function getGlobalClassMethodDecoratorContextType(reportErrors2) {
	      return deferredGlobalClassMethodDecoratorContextType ?? (deferredGlobalClassMethodDecoratorContextType = getGlobalType(
	        "ClassMethodDecoratorContext",
	        /*arity*/
	        2,
	        reportErrors2
	      )) ?? emptyGenericType;
	    }
	    function getGlobalClassGetterDecoratorContextType(reportErrors2) {
	      return deferredGlobalClassGetterDecoratorContextType ?? (deferredGlobalClassGetterDecoratorContextType = getGlobalType(
	        "ClassGetterDecoratorContext",
	        /*arity*/
	        2,
	        reportErrors2
	      )) ?? emptyGenericType;
	    }
	    function getGlobalClassSetterDecoratorContextType(reportErrors2) {
	      return deferredGlobalClassSetterDecoratorContextType ?? (deferredGlobalClassSetterDecoratorContextType = getGlobalType(
	        "ClassSetterDecoratorContext",
	        /*arity*/
	        2,
	        reportErrors2
	      )) ?? emptyGenericType;
	    }
	    function getGlobalClassAccessorDecoratorContextType(reportErrors2) {
	      return deferredGlobalClassAccessorDecoratorContextType ?? (deferredGlobalClassAccessorDecoratorContextType = getGlobalType(
	        "ClassAccessorDecoratorContext",
	        /*arity*/
	        2,
	        reportErrors2
	      )) ?? emptyGenericType;
	    }
	    function getGlobalClassAccessorDecoratorTargetType(reportErrors2) {
	      return deferredGlobalClassAccessorDecoratorTargetType ?? (deferredGlobalClassAccessorDecoratorTargetType = getGlobalType(
	        "ClassAccessorDecoratorTarget",
	        /*arity*/
	        2,
	        reportErrors2
	      )) ?? emptyGenericType;
	    }
	    function getGlobalClassAccessorDecoratorResultType(reportErrors2) {
	      return deferredGlobalClassAccessorDecoratorResultType ?? (deferredGlobalClassAccessorDecoratorResultType = getGlobalType(
	        "ClassAccessorDecoratorResult",
	        /*arity*/
	        2,
	        reportErrors2
	      )) ?? emptyGenericType;
	    }
	    function getGlobalClassFieldDecoratorContextType(reportErrors2) {
	      return deferredGlobalClassFieldDecoratorContextType ?? (deferredGlobalClassFieldDecoratorContextType = getGlobalType(
	        "ClassFieldDecoratorContext",
	        /*arity*/
	        2,
	        reportErrors2
	      )) ?? emptyGenericType;
	    }
	    function getGlobalNaNSymbol() {
	      return deferredGlobalNaNSymbol || (deferredGlobalNaNSymbol = getGlobalValueSymbol(
	        "NaN",
	        /*reportErrors*/
	        false
	      ));
	    }
	    function getGlobalRecordSymbol() {
	      deferredGlobalRecordSymbol || (deferredGlobalRecordSymbol = getGlobalTypeAliasSymbol(
	        "Record",
	        /*arity*/
	        2,
	        /*reportErrors*/
	        true
	      ) || unknownSymbol);
	      return deferredGlobalRecordSymbol === unknownSymbol ? void 0 : deferredGlobalRecordSymbol;
	    }
	    function createTypeFromGenericGlobalType(genericGlobalType, typeArguments) {
	      return genericGlobalType !== emptyGenericType ? createTypeReference(genericGlobalType, typeArguments) : emptyObjectType;
	    }
	    function createTypedPropertyDescriptorType(propertyType) {
	      return createTypeFromGenericGlobalType(getGlobalTypedPropertyDescriptorType(), [propertyType]);
	    }
	    function createIterableType(iteratedType) {
	      return createTypeFromGenericGlobalType(getGlobalIterableType(
	        /*reportErrors*/
	        true
	      ), [iteratedType]);
	    }
	    function createArrayType(elementType, readonly) {
	      return createTypeFromGenericGlobalType(readonly ? globalReadonlyArrayType : globalArrayType, [elementType]);
	    }
	    function getTupleElementFlags(node) {
	      switch (node.kind) {
	        case 190 /* OptionalType */:
	          return 2 /* Optional */;
	        case 191 /* RestType */:
	          return getRestTypeElementFlags(node);
	        case 202 /* NamedTupleMember */:
	          return node.questionToken ? 2 /* Optional */ : node.dotDotDotToken ? getRestTypeElementFlags(node) : 1 /* Required */;
	        default:
	          return 1 /* Required */;
	      }
	    }
	    function getRestTypeElementFlags(node) {
	      return getArrayElementTypeNode(node.type) ? 4 /* Rest */ : 8 /* Variadic */;
	    }
	    function getArrayOrTupleTargetType(node) {
	      const readonly = isReadonlyTypeOperator(node.parent);
	      const elementType = getArrayElementTypeNode(node);
	      if (elementType) {
	        return readonly ? globalReadonlyArrayType : globalArrayType;
	      }
	      const elementFlags = map(node.elements, getTupleElementFlags);
	      return getTupleTargetType(elementFlags, readonly, map(node.elements, memberIfLabeledElementDeclaration));
	    }
	    function memberIfLabeledElementDeclaration(member) {
	      return isNamedTupleMember(member) || isParameter(member) ? member : void 0;
	    }
	    function isDeferredTypeReferenceNode(node, hasDefaultTypeArguments) {
	      return !!getAliasSymbolForTypeNode(node) || isResolvedByTypeAlias(node) && (node.kind === 188 /* ArrayType */ ? mayResolveTypeAlias(node.elementType) : node.kind === 189 /* TupleType */ ? some(node.elements, mayResolveTypeAlias) : hasDefaultTypeArguments || some(node.typeArguments, mayResolveTypeAlias));
	    }
	    function isResolvedByTypeAlias(node) {
	      const parent2 = node.parent;
	      switch (parent2.kind) {
	        case 196 /* ParenthesizedType */:
	        case 202 /* NamedTupleMember */:
	        case 183 /* TypeReference */:
	        case 192 /* UnionType */:
	        case 193 /* IntersectionType */:
	        case 199 /* IndexedAccessType */:
	        case 194 /* ConditionalType */:
	        case 198 /* TypeOperator */:
	        case 188 /* ArrayType */:
	        case 189 /* TupleType */:
	          return isResolvedByTypeAlias(parent2);
	        case 265 /* TypeAliasDeclaration */:
	          return true;
	      }
	      return false;
	    }
	    function mayResolveTypeAlias(node) {
	      switch (node.kind) {
	        case 183 /* TypeReference */:
	          return isJSDocTypeReference(node) || !!(resolveTypeReferenceName(node, 788968 /* Type */).flags & 524288 /* TypeAlias */);
	        case 186 /* TypeQuery */:
	          return true;
	        case 198 /* TypeOperator */:
	          return node.operator !== 158 /* UniqueKeyword */ && mayResolveTypeAlias(node.type);
	        case 196 /* ParenthesizedType */:
	        case 190 /* OptionalType */:
	        case 202 /* NamedTupleMember */:
	        case 323 /* JSDocOptionalType */:
	        case 321 /* JSDocNullableType */:
	        case 322 /* JSDocNonNullableType */:
	        case 316 /* JSDocTypeExpression */:
	          return mayResolveTypeAlias(node.type);
	        case 191 /* RestType */:
	          return node.type.kind !== 188 /* ArrayType */ || mayResolveTypeAlias(node.type.elementType);
	        case 192 /* UnionType */:
	        case 193 /* IntersectionType */:
	          return some(node.types, mayResolveTypeAlias);
	        case 199 /* IndexedAccessType */:
	          return mayResolveTypeAlias(node.objectType) || mayResolveTypeAlias(node.indexType);
	        case 194 /* ConditionalType */:
	          return mayResolveTypeAlias(node.checkType) || mayResolveTypeAlias(node.extendsType) || mayResolveTypeAlias(node.trueType) || mayResolveTypeAlias(node.falseType);
	      }
	      return false;
	    }
	    function getTypeFromArrayOrTupleTypeNode(node) {
	      const links = getNodeLinks(node);
	      if (!links.resolvedType) {
	        const target = getArrayOrTupleTargetType(node);
	        if (target === emptyGenericType) {
	          links.resolvedType = emptyObjectType;
	        } else if (!(node.kind === 189 /* TupleType */ && some(node.elements, (e) => !!(getTupleElementFlags(e) & 8 /* Variadic */))) && isDeferredTypeReferenceNode(node)) {
	          links.resolvedType = node.kind === 189 /* TupleType */ && node.elements.length === 0 ? target : createDeferredTypeReference(
	            target,
	            node,
	            /*mapper*/
	            void 0
	          );
	        } else {
	          const elementTypes = node.kind === 188 /* ArrayType */ ? [getTypeFromTypeNode(node.elementType)] : map(node.elements, getTypeFromTypeNode);
	          links.resolvedType = createNormalizedTypeReference(target, elementTypes);
	        }
	      }
	      return links.resolvedType;
	    }
	    function isReadonlyTypeOperator(node) {
	      return isTypeOperatorNode(node) && node.operator === 148 /* ReadonlyKeyword */;
	    }
	    function createTupleType(elementTypes, elementFlags, readonly = false, namedMemberDeclarations = []) {
	      const tupleTarget = getTupleTargetType(elementFlags || map(elementTypes, (_) => 1 /* Required */), readonly, namedMemberDeclarations);
	      return tupleTarget === emptyGenericType ? emptyObjectType : elementTypes.length ? createNormalizedTypeReference(tupleTarget, elementTypes) : tupleTarget;
	    }
	    function getTupleTargetType(elementFlags, readonly, namedMemberDeclarations) {
	      if (elementFlags.length === 1 && elementFlags[0] & 4 /* Rest */) {
	        return readonly ? globalReadonlyArrayType : globalArrayType;
	      }
	      const key = map(elementFlags, (f) => f & 1 /* Required */ ? "#" : f & 2 /* Optional */ ? "?" : f & 4 /* Rest */ ? "." : "*").join() + (readonly ? "R" : "") + (some(namedMemberDeclarations, (node) => !!node) ? "," + map(namedMemberDeclarations, (node) => node ? getNodeId(node) : "_").join(",") : "");
	      let type = tupleTypes.get(key);
	      if (!type) {
	        tupleTypes.set(key, type = createTupleTargetType(elementFlags, readonly, namedMemberDeclarations));
	      }
	      return type;
	    }
	    function createTupleTargetType(elementFlags, readonly, namedMemberDeclarations) {
	      const arity = elementFlags.length;
	      const minLength = countWhere(elementFlags, (f) => !!(f & (1 /* Required */ | 8 /* Variadic */)));
	      let typeParameters;
	      const properties = [];
	      let combinedFlags = 0;
	      if (arity) {
	        typeParameters = new Array(arity);
	        for (let i = 0; i < arity; i++) {
	          const typeParameter = typeParameters[i] = createTypeParameter();
	          const flags = elementFlags[i];
	          combinedFlags |= flags;
	          if (!(combinedFlags & 12 /* Variable */)) {
	            const property = createSymbol(4 /* Property */ | (flags & 2 /* Optional */ ? 16777216 /* Optional */ : 0), "" + i, readonly ? 8 /* Readonly */ : 0);
	            property.links.tupleLabelDeclaration = namedMemberDeclarations == null ? void 0 : namedMemberDeclarations[i];
	            property.links.type = typeParameter;
	            properties.push(property);
	          }
	        }
	      }
	      const fixedLength = properties.length;
	      const lengthSymbol = createSymbol(4 /* Property */, "length", readonly ? 8 /* Readonly */ : 0);
	      if (combinedFlags & 12 /* Variable */) {
	        lengthSymbol.links.type = numberType;
	      } else {
	        const literalTypes = [];
	        for (let i = minLength; i <= arity; i++)
	          literalTypes.push(getNumberLiteralType(i));
	        lengthSymbol.links.type = getUnionType(literalTypes);
	      }
	      properties.push(lengthSymbol);
	      const type = createObjectType(8 /* Tuple */ | 4 /* Reference */);
	      type.typeParameters = typeParameters;
	      type.outerTypeParameters = void 0;
	      type.localTypeParameters = typeParameters;
	      type.instantiations = /* @__PURE__ */ new Map();
	      type.instantiations.set(getTypeListId(type.typeParameters), type);
	      type.target = type;
	      type.resolvedTypeArguments = type.typeParameters;
	      type.thisType = createTypeParameter();
	      type.thisType.isThisType = true;
	      type.thisType.constraint = type;
	      type.declaredProperties = properties;
	      type.declaredCallSignatures = emptyArray;
	      type.declaredConstructSignatures = emptyArray;
	      type.declaredIndexInfos = emptyArray;
	      type.elementFlags = elementFlags;
	      type.minLength = minLength;
	      type.fixedLength = fixedLength;
	      type.hasRestElement = !!(combinedFlags & 12 /* Variable */);
	      type.combinedFlags = combinedFlags;
	      type.readonly = readonly;
	      type.labeledElementDeclarations = namedMemberDeclarations;
	      return type;
	    }
	    function createNormalizedTypeReference(target, typeArguments) {
	      return target.objectFlags & 8 /* Tuple */ ? createNormalizedTupleType(target, typeArguments) : createTypeReference(target, typeArguments);
	    }
	    function createNormalizedTupleType(target, elementTypes) {
	      var _a, _b, _c, _d;
	      if (!(target.combinedFlags & 14 /* NonRequired */)) {
	        return createTypeReference(target, elementTypes);
	      }
	      if (target.combinedFlags & 8 /* Variadic */) {
	        const unionIndex = findIndex(elementTypes, (t, i) => !!(target.elementFlags[i] & 8 /* Variadic */ && t.flags & (131072 /* Never */ | 1048576 /* Union */)));
	        if (unionIndex >= 0) {
	          return checkCrossProductUnion(map(elementTypes, (t, i) => target.elementFlags[i] & 8 /* Variadic */ ? t : unknownType)) ? mapType(elementTypes[unionIndex], (t) => createNormalizedTupleType(target, replaceElement(elementTypes, unionIndex, t))) : errorType;
	        }
	      }
	      const expandedTypes = [];
	      const expandedFlags = [];
	      const expandedDeclarations = [];
	      let lastRequiredIndex = -1;
	      let firstRestIndex = -1;
	      let lastOptionalOrRestIndex = -1;
	      for (let i = 0; i < elementTypes.length; i++) {
	        const type = elementTypes[i];
	        const flags = target.elementFlags[i];
	        if (flags & 8 /* Variadic */) {
	          if (type.flags & 1 /* Any */) {
	            addElement(type, 4 /* Rest */, (_a = target.labeledElementDeclarations) == null ? void 0 : _a[i]);
	          } else if (type.flags & 58982400 /* InstantiableNonPrimitive */ || isGenericMappedType(type)) {
	            addElement(type, 8 /* Variadic */, (_b = target.labeledElementDeclarations) == null ? void 0 : _b[i]);
	          } else if (isTupleType(type)) {
	            const elements = getElementTypes(type);
	            if (elements.length + expandedTypes.length >= 1e4) {
	              error2(
	                currentNode,
	                isPartOfTypeNode(currentNode) ? Diagnostics.Type_produces_a_tuple_type_that_is_too_large_to_represent : Diagnostics.Expression_produces_a_tuple_type_that_is_too_large_to_represent
	              );
	              return errorType;
	            }
	            forEach(elements, (t, n) => {
	              var _a2;
	              return addElement(t, type.target.elementFlags[n], (_a2 = type.target.labeledElementDeclarations) == null ? void 0 : _a2[n]);
	            });
	          } else {
	            addElement(isArrayLikeType(type) && getIndexTypeOfType(type, numberType) || errorType, 4 /* Rest */, (_c = target.labeledElementDeclarations) == null ? void 0 : _c[i]);
	          }
	        } else {
	          addElement(type, flags, (_d = target.labeledElementDeclarations) == null ? void 0 : _d[i]);
	        }
	      }
	      for (let i = 0; i < lastRequiredIndex; i++) {
	        if (expandedFlags[i] & 2 /* Optional */)
	          expandedFlags[i] = 1 /* Required */;
	      }
	      if (firstRestIndex >= 0 && firstRestIndex < lastOptionalOrRestIndex) {
	        expandedTypes[firstRestIndex] = getUnionType(sameMap(expandedTypes.slice(firstRestIndex, lastOptionalOrRestIndex + 1), (t, i) => expandedFlags[firstRestIndex + i] & 8 /* Variadic */ ? getIndexedAccessType(t, numberType) : t));
	        expandedTypes.splice(firstRestIndex + 1, lastOptionalOrRestIndex - firstRestIndex);
	        expandedFlags.splice(firstRestIndex + 1, lastOptionalOrRestIndex - firstRestIndex);
	        expandedDeclarations.splice(firstRestIndex + 1, lastOptionalOrRestIndex - firstRestIndex);
	      }
	      const tupleTarget = getTupleTargetType(expandedFlags, target.readonly, expandedDeclarations);
	      return tupleTarget === emptyGenericType ? emptyObjectType : expandedFlags.length ? createTypeReference(tupleTarget, expandedTypes) : tupleTarget;
	      function addElement(type, flags, declaration) {
	        if (flags & 1 /* Required */) {
	          lastRequiredIndex = expandedFlags.length;
	        }
	        if (flags & 4 /* Rest */ && firstRestIndex < 0) {
	          firstRestIndex = expandedFlags.length;
	        }
	        if (flags & (2 /* Optional */ | 4 /* Rest */)) {
	          lastOptionalOrRestIndex = expandedFlags.length;
	        }
	        expandedTypes.push(flags & 2 /* Optional */ ? addOptionality(
	          type,
	          /*isProperty*/
	          true
	        ) : type);
	        expandedFlags.push(flags);
	        expandedDeclarations.push(declaration);
	      }
	    }
	    function sliceTupleType(type, index, endSkipCount = 0) {
	      const target = type.target;
	      const endIndex = getTypeReferenceArity(type) - endSkipCount;
	      return index > target.fixedLength ? getRestArrayTypeOfTupleType(type) || createTupleType(emptyArray) : createTupleType(
	        getTypeArguments(type).slice(index, endIndex),
	        target.elementFlags.slice(index, endIndex),
	        /*readonly*/
	        false,
	        target.labeledElementDeclarations && target.labeledElementDeclarations.slice(index, endIndex)
	      );
	    }
	    function getKnownKeysOfTupleType(type) {
	      return getUnionType(append(arrayOf(type.target.fixedLength, (i) => getStringLiteralType("" + i)), getIndexType(type.target.readonly ? globalReadonlyArrayType : globalArrayType)));
	    }
	    function getStartElementCount(type, flags) {
	      const index = findIndex(type.elementFlags, (f) => !(f & flags));
	      return index >= 0 ? index : type.elementFlags.length;
	    }
	    function getEndElementCount(type, flags) {
	      return type.elementFlags.length - findLastIndex(type.elementFlags, (f) => !(f & flags)) - 1;
	    }
	    function getTotalFixedElementCount(type) {
	      return type.fixedLength + getEndElementCount(type, 3 /* Fixed */);
	    }
	    function getElementTypes(type) {
	      const typeArguments = getTypeArguments(type);
	      const arity = getTypeReferenceArity(type);
	      return typeArguments.length === arity ? typeArguments : typeArguments.slice(0, arity);
	    }
	    function getTypeFromOptionalTypeNode(node) {
	      return addOptionality(
	        getTypeFromTypeNode(node.type),
	        /*isProperty*/
	        true
	      );
	    }
	    function getTypeId(type) {
	      return type.id;
	    }
	    function containsType(types, type) {
	      return binarySearch(types, type, getTypeId, compareValues) >= 0;
	    }
	    function insertType(types, type) {
	      const index = binarySearch(types, type, getTypeId, compareValues);
	      if (index < 0) {
	        types.splice(~index, 0, type);
	        return true;
	      }
	      return false;
	    }
	    function addTypeToUnion(typeSet, includes, type) {
	      const flags = type.flags;
	      if (!(flags & 131072 /* Never */)) {
	        includes |= flags & 473694207 /* IncludesMask */;
	        if (flags & 465829888 /* Instantiable */)
	          includes |= 33554432 /* IncludesInstantiable */;
	        if (flags & 2097152 /* Intersection */ && getObjectFlags(type) & 67108864 /* IsConstrainedTypeVariable */)
	          includes |= 536870912 /* IncludesConstrainedTypeVariable */;
	        if (type === wildcardType)
	          includes |= 8388608 /* IncludesWildcard */;
	        if (!strictNullChecks && flags & 98304 /* Nullable */) {
	          if (!(getObjectFlags(type) & 65536 /* ContainsWideningType */))
	            includes |= 4194304 /* IncludesNonWideningType */;
	        } else {
	          const len = typeSet.length;
	          const index = len && type.id > typeSet[len - 1].id ? ~len : binarySearch(typeSet, type, getTypeId, compareValues);
	          if (index < 0) {
	            typeSet.splice(~index, 0, type);
	          }
	        }
	      }
	      return includes;
	    }
	    function addTypesToUnion(typeSet, includes, types) {
	      let lastType;
	      for (const type of types) {
	        if (type !== lastType) {
	          includes = type.flags & 1048576 /* Union */ ? addTypesToUnion(typeSet, includes | (isNamedUnionType(type) ? 1048576 /* Union */ : 0), type.types) : addTypeToUnion(typeSet, includes, type);
	          lastType = type;
	        }
	      }
	      return includes;
	    }
	    function removeSubtypes(types, hasObjectTypes) {
	      var _a;
	      if (types.length < 2) {
	        return types;
	      }
	      const id = getTypeListId(types);
	      const match = subtypeReductionCache.get(id);
	      if (match) {
	        return match;
	      }
	      const hasEmptyObject = hasObjectTypes && some(types, (t) => !!(t.flags & 524288 /* Object */) && !isGenericMappedType(t) && isEmptyResolvedType(resolveStructuredTypeMembers(t)));
	      const len = types.length;
	      let i = len;
	      let count = 0;
	      while (i > 0) {
	        i--;
	        const source = types[i];
	        if (hasEmptyObject || source.flags & 469499904 /* StructuredOrInstantiable */) {
	          if (source.flags & 262144 /* TypeParameter */ && getBaseConstraintOrType(source).flags & 1048576 /* Union */) {
	            if (isTypeRelatedTo(source, getUnionType(map(types, (t) => t === source ? neverType : t)), strictSubtypeRelation)) {
	              orderedRemoveItemAt(types, i);
	            }
	            continue;
	          }
	          const keyProperty = source.flags & (524288 /* Object */ | 2097152 /* Intersection */ | 58982400 /* InstantiableNonPrimitive */) ? find(getPropertiesOfType(source), (p) => isUnitType(getTypeOfSymbol(p))) : void 0;
	          const keyPropertyType = keyProperty && getRegularTypeOfLiteralType(getTypeOfSymbol(keyProperty));
	          for (const target of types) {
	            if (source !== target) {
	              if (count === 1e5) {
	                const estimatedCount = count / (len - i) * len;
	                if (estimatedCount > 1e6) {
	                  (_a = tracing) == null ? void 0 : _a.instant(tracing.Phase.CheckTypes, "removeSubtypes_DepthLimit", { typeIds: types.map((t) => t.id) });
	                  error2(currentNode, Diagnostics.Expression_produces_a_union_type_that_is_too_complex_to_represent);
	                  return void 0;
	                }
	              }
	              count++;
	              if (keyProperty && target.flags & (524288 /* Object */ | 2097152 /* Intersection */ | 58982400 /* InstantiableNonPrimitive */)) {
	                const t = getTypeOfPropertyOfType(target, keyProperty.escapedName);
	                if (t && isUnitType(t) && getRegularTypeOfLiteralType(t) !== keyPropertyType) {
	                  continue;
	                }
	              }
	              if (isTypeRelatedTo(source, target, strictSubtypeRelation) && (!(getObjectFlags(getTargetType(source)) & 1 /* Class */) || !(getObjectFlags(getTargetType(target)) & 1 /* Class */) || isTypeDerivedFrom(source, target))) {
	                orderedRemoveItemAt(types, i);
	                break;
	              }
	            }
	          }
	        }
	      }
	      subtypeReductionCache.set(id, types);
	      return types;
	    }
	    function removeRedundantLiteralTypes(types, includes, reduceVoidUndefined) {
	      let i = types.length;
	      while (i > 0) {
	        i--;
	        const t = types[i];
	        const flags = t.flags;
	        const remove = flags & (128 /* StringLiteral */ | 134217728 /* TemplateLiteral */ | 268435456 /* StringMapping */) && includes & 4 /* String */ || flags & 256 /* NumberLiteral */ && includes & 8 /* Number */ || flags & 2048 /* BigIntLiteral */ && includes & 64 /* BigInt */ || flags & 8192 /* UniqueESSymbol */ && includes & 4096 /* ESSymbol */ || reduceVoidUndefined && flags & 32768 /* Undefined */ && includes & 16384 /* Void */ || isFreshLiteralType(t) && containsType(types, t.regularType);
	        if (remove) {
	          orderedRemoveItemAt(types, i);
	        }
	      }
	    }
	    function removeStringLiteralsMatchedByTemplateLiterals(types) {
	      const templates = filter(types, isPatternLiteralType);
	      if (templates.length) {
	        let i = types.length;
	        while (i > 0) {
	          i--;
	          const t = types[i];
	          if (t.flags & 128 /* StringLiteral */ && some(templates, (template) => isTypeMatchedByTemplateLiteralOrStringMapping(t, template))) {
	            orderedRemoveItemAt(types, i);
	          }
	        }
	      }
	    }
	    function isTypeMatchedByTemplateLiteralOrStringMapping(type, template) {
	      return template.flags & 134217728 /* TemplateLiteral */ ? isTypeMatchedByTemplateLiteralType(type, template) : isMemberOfStringMapping(type, template);
	    }
	    function removeConstrainedTypeVariables(types) {
	      const typeVariables = [];
	      for (const type of types) {
	        if (type.flags & 2097152 /* Intersection */ && getObjectFlags(type) & 67108864 /* IsConstrainedTypeVariable */) {
	          const index = type.types[0].flags & 8650752 /* TypeVariable */ ? 0 : 1;
	          pushIfUnique(typeVariables, type.types[index]);
	        }
	      }
	      for (const typeVariable of typeVariables) {
	        const primitives = [];
	        for (const type of types) {
	          if (type.flags & 2097152 /* Intersection */ && getObjectFlags(type) & 67108864 /* IsConstrainedTypeVariable */) {
	            const index = type.types[0].flags & 8650752 /* TypeVariable */ ? 0 : 1;
	            if (type.types[index] === typeVariable) {
	              insertType(primitives, type.types[1 - index]);
	            }
	          }
	        }
	        const constraint = getBaseConstraintOfType(typeVariable);
	        if (everyType(constraint, (t) => containsType(primitives, t))) {
	          let i = types.length;
	          while (i > 0) {
	            i--;
	            const type = types[i];
	            if (type.flags & 2097152 /* Intersection */ && getObjectFlags(type) & 67108864 /* IsConstrainedTypeVariable */) {
	              const index = type.types[0].flags & 8650752 /* TypeVariable */ ? 0 : 1;
	              if (type.types[index] === typeVariable && containsType(primitives, type.types[1 - index])) {
	                orderedRemoveItemAt(types, i);
	              }
	            }
	          }
	          insertType(types, typeVariable);
	        }
	      }
	    }
	    function isNamedUnionType(type) {
	      return !!(type.flags & 1048576 /* Union */ && (type.aliasSymbol || type.origin));
	    }
	    function addNamedUnions(namedUnions, types) {
	      for (const t of types) {
	        if (t.flags & 1048576 /* Union */) {
	          const origin = t.origin;
	          if (t.aliasSymbol || origin && !(origin.flags & 1048576 /* Union */)) {
	            pushIfUnique(namedUnions, t);
	          } else if (origin && origin.flags & 1048576 /* Union */) {
	            addNamedUnions(namedUnions, origin.types);
	          }
	        }
	      }
	    }
	    function createOriginUnionOrIntersectionType(flags, types) {
	      const result = createOriginType(flags);
	      result.types = types;
	      return result;
	    }
	    function getUnionType(types, unionReduction = 1 /* Literal */, aliasSymbol, aliasTypeArguments, origin) {
	      if (types.length === 0) {
	        return neverType;
	      }
	      if (types.length === 1) {
	        return types[0];
	      }
	      if (types.length === 2 && !origin && (types[0].flags & 1048576 /* Union */ || types[1].flags & 1048576 /* Union */)) {
	        const infix = unionReduction === 0 /* None */ ? "N" : unionReduction === 2 /* Subtype */ ? "S" : "L";
	        const index = types[0].id < types[1].id ? 0 : 1;
	        const id = types[index].id + infix + types[1 - index].id + getAliasId(aliasSymbol, aliasTypeArguments);
	        let type = unionOfUnionTypes.get(id);
	        if (!type) {
	          type = getUnionTypeWorker(
	            types,
	            unionReduction,
	            aliasSymbol,
	            aliasTypeArguments,
	            /*origin*/
	            void 0
	          );
	          unionOfUnionTypes.set(id, type);
	        }
	        return type;
	      }
	      return getUnionTypeWorker(types, unionReduction, aliasSymbol, aliasTypeArguments, origin);
	    }
	    function getUnionTypeWorker(types, unionReduction, aliasSymbol, aliasTypeArguments, origin) {
	      let typeSet = [];
	      const includes = addTypesToUnion(typeSet, 0, types);
	      if (unionReduction !== 0 /* None */) {
	        if (includes & 3 /* AnyOrUnknown */) {
	          return includes & 1 /* Any */ ? includes & 8388608 /* IncludesWildcard */ ? wildcardType : anyType : includes & 65536 /* Null */ || containsType(typeSet, unknownType) ? unknownType : nonNullUnknownType;
	        }
	        if (includes & 32768 /* Undefined */) {
	          if (typeSet.length >= 2 && typeSet[0] === undefinedType && typeSet[1] === missingType) {
	            orderedRemoveItemAt(typeSet, 1);
	          }
	        }
	        if (includes & (32 /* Enum */ | 2944 /* Literal */ | 8192 /* UniqueESSymbol */ | 134217728 /* TemplateLiteral */ | 268435456 /* StringMapping */) || includes & 16384 /* Void */ && includes & 32768 /* Undefined */) {
	          removeRedundantLiteralTypes(typeSet, includes, !!(unionReduction & 2 /* Subtype */));
	        }
	        if (includes & 128 /* StringLiteral */ && includes & (134217728 /* TemplateLiteral */ | 268435456 /* StringMapping */)) {
	          removeStringLiteralsMatchedByTemplateLiterals(typeSet);
	        }
	        if (includes & 536870912 /* IncludesConstrainedTypeVariable */) {
	          removeConstrainedTypeVariables(typeSet);
	        }
	        if (unionReduction === 2 /* Subtype */) {
	          typeSet = removeSubtypes(typeSet, !!(includes & 524288 /* Object */));
	          if (!typeSet) {
	            return errorType;
	          }
	        }
	        if (typeSet.length === 0) {
	          return includes & 65536 /* Null */ ? includes & 4194304 /* IncludesNonWideningType */ ? nullType : nullWideningType : includes & 32768 /* Undefined */ ? includes & 4194304 /* IncludesNonWideningType */ ? undefinedType : undefinedWideningType : neverType;
	        }
	      }
	      if (!origin && includes & 1048576 /* Union */) {
	        const namedUnions = [];
	        addNamedUnions(namedUnions, types);
	        const reducedTypes = [];
	        for (const t of typeSet) {
	          if (!some(namedUnions, (union) => containsType(union.types, t))) {
	            reducedTypes.push(t);
	          }
	        }
	        if (!aliasSymbol && namedUnions.length === 1 && reducedTypes.length === 0) {
	          return namedUnions[0];
	        }
	        const namedTypesCount = reduceLeft(namedUnions, (sum, union) => sum + union.types.length, 0);
	        if (namedTypesCount + reducedTypes.length === typeSet.length) {
	          for (const t of namedUnions) {
	            insertType(reducedTypes, t);
	          }
	          origin = createOriginUnionOrIntersectionType(1048576 /* Union */, reducedTypes);
	        }
	      }
	      const objectFlags = (includes & 36323331 /* NotPrimitiveUnion */ ? 0 : 32768 /* PrimitiveUnion */) | (includes & 2097152 /* Intersection */ ? 16777216 /* ContainsIntersections */ : 0);
	      return getUnionTypeFromSortedList(typeSet, objectFlags, aliasSymbol, aliasTypeArguments, origin);
	    }
	    function getUnionOrIntersectionTypePredicate(signatures, kind) {
	      let last2;
	      const types = [];
	      for (const sig of signatures) {
	        const pred = getTypePredicateOfSignature(sig);
	        if (pred) {
	          if (pred.kind !== 0 /* This */ && pred.kind !== 1 /* Identifier */ || last2 && !typePredicateKindsMatch(last2, pred)) {
	            return void 0;
	          }
	          last2 = pred;
	          types.push(pred.type);
	        } else {
	          const returnType = kind !== 2097152 /* Intersection */ ? getReturnTypeOfSignature(sig) : void 0;
	          if (returnType !== falseType && returnType !== regularFalseType) {
	            return void 0;
	          }
	        }
	      }
	      if (!last2) {
	        return void 0;
	      }
	      const compositeType = getUnionOrIntersectionType(types, kind);
	      return createTypePredicate(last2.kind, last2.parameterName, last2.parameterIndex, compositeType);
	    }
	    function typePredicateKindsMatch(a, b) {
	      return a.kind === b.kind && a.parameterIndex === b.parameterIndex;
	    }
	    function getUnionTypeFromSortedList(types, precomputedObjectFlags, aliasSymbol, aliasTypeArguments, origin) {
	      if (types.length === 0) {
	        return neverType;
	      }
	      if (types.length === 1) {
	        return types[0];
	      }
	      const typeKey = !origin ? getTypeListId(types) : origin.flags & 1048576 /* Union */ ? `|${getTypeListId(origin.types)}` : origin.flags & 2097152 /* Intersection */ ? `&${getTypeListId(origin.types)}` : `#${origin.type.id}|${getTypeListId(types)}`;
	      const id = typeKey + getAliasId(aliasSymbol, aliasTypeArguments);
	      let type = unionTypes.get(id);
	      if (!type) {
	        type = createType(1048576 /* Union */);
	        type.objectFlags = precomputedObjectFlags | getPropagatingFlagsOfTypes(
	          types,
	          /*excludeKinds*/
	          98304 /* Nullable */
	        );
	        type.types = types;
	        type.origin = origin;
	        type.aliasSymbol = aliasSymbol;
	        type.aliasTypeArguments = aliasTypeArguments;
	        if (types.length === 2 && types[0].flags & 512 /* BooleanLiteral */ && types[1].flags & 512 /* BooleanLiteral */) {
	          type.flags |= 16 /* Boolean */;
	          type.intrinsicName = "boolean";
	        }
	        unionTypes.set(id, type);
	      }
	      return type;
	    }
	    function getTypeFromUnionTypeNode(node) {
	      const links = getNodeLinks(node);
	      if (!links.resolvedType) {
	        const aliasSymbol = getAliasSymbolForTypeNode(node);
	        links.resolvedType = getUnionType(map(node.types, getTypeFromTypeNode), 1 /* Literal */, aliasSymbol, getTypeArgumentsForAliasSymbol(aliasSymbol));
	      }
	      return links.resolvedType;
	    }
	    function addTypeToIntersection(typeSet, includes, type) {
	      const flags = type.flags;
	      if (flags & 2097152 /* Intersection */) {
	        return addTypesToIntersection(typeSet, includes, type.types);
	      }
	      if (isEmptyAnonymousObjectType(type)) {
	        if (!(includes & 16777216 /* IncludesEmptyObject */)) {
	          includes |= 16777216 /* IncludesEmptyObject */;
	          typeSet.set(type.id.toString(), type);
	        }
	      } else {
	        if (flags & 3 /* AnyOrUnknown */) {
	          if (type === wildcardType)
	            includes |= 8388608 /* IncludesWildcard */;
	        } else if (strictNullChecks || !(flags & 98304 /* Nullable */)) {
	          if (type === missingType) {
	            includes |= 262144 /* IncludesMissingType */;
	            type = undefinedType;
	          }
	          if (!typeSet.has(type.id.toString())) {
	            if (type.flags & 109472 /* Unit */ && includes & 109472 /* Unit */) {
	              includes |= 67108864 /* NonPrimitive */;
	            }
	            typeSet.set(type.id.toString(), type);
	          }
	        }
	        includes |= flags & 473694207 /* IncludesMask */;
	      }
	      return includes;
	    }
	    function addTypesToIntersection(typeSet, includes, types) {
	      for (const type of types) {
	        includes = addTypeToIntersection(typeSet, includes, getRegularTypeOfLiteralType(type));
	      }
	      return includes;
	    }
	    function removeRedundantSupertypes(types, includes) {
	      let i = types.length;
	      while (i > 0) {
	        i--;
	        const t = types[i];
	        const remove = t.flags & 4 /* String */ && includes & (128 /* StringLiteral */ | 134217728 /* TemplateLiteral */ | 268435456 /* StringMapping */) || t.flags & 8 /* Number */ && includes & 256 /* NumberLiteral */ || t.flags & 64 /* BigInt */ && includes & 2048 /* BigIntLiteral */ || t.flags & 4096 /* ESSymbol */ && includes & 8192 /* UniqueESSymbol */ || t.flags & 16384 /* Void */ && includes & 32768 /* Undefined */ || isEmptyAnonymousObjectType(t) && includes & 470302716 /* DefinitelyNonNullable */;
	        if (remove) {
	          orderedRemoveItemAt(types, i);
	        }
	      }
	    }
	    function eachUnionContains(unionTypes2, type) {
	      for (const u of unionTypes2) {
	        if (!containsType(u.types, type)) {
	          const primitive = type.flags & 128 /* StringLiteral */ ? stringType : type.flags & (32 /* Enum */ | 256 /* NumberLiteral */) ? numberType : type.flags & 2048 /* BigIntLiteral */ ? bigintType : type.flags & 8192 /* UniqueESSymbol */ ? esSymbolType : void 0;
	          if (!primitive || !containsType(u.types, primitive)) {
	            return false;
	          }
	        }
	      }
	      return true;
	    }
	    function extractRedundantTemplateLiterals(types) {
	      let i = types.length;
	      const literals = filter(types, (t) => !!(t.flags & 128 /* StringLiteral */));
	      while (i > 0) {
	        i--;
	        const t = types[i];
	        if (!(t.flags & (134217728 /* TemplateLiteral */ | 268435456 /* StringMapping */)))
	          continue;
	        for (const t2 of literals) {
	          if (isTypeSubtypeOf(t2, t)) {
	            orderedRemoveItemAt(types, i);
	            break;
	          } else if (isPatternLiteralType(t)) {
	            return true;
	          }
	        }
	      }
	      return false;
	    }
	    function removeFromEach(types, flag) {
	      for (let i = 0; i < types.length; i++) {
	        types[i] = filterType(types[i], (t) => !(t.flags & flag));
	      }
	    }
	    function intersectUnionsOfPrimitiveTypes(types) {
	      let unionTypes2;
	      const index = findIndex(types, (t) => !!(getObjectFlags(t) & 32768 /* PrimitiveUnion */));
	      if (index < 0) {
	        return false;
	      }
	      let i = index + 1;
	      while (i < types.length) {
	        const t = types[i];
	        if (getObjectFlags(t) & 32768 /* PrimitiveUnion */) {
	          (unionTypes2 || (unionTypes2 = [types[index]])).push(t);
	          orderedRemoveItemAt(types, i);
	        } else {
	          i++;
	        }
	      }
	      if (!unionTypes2) {
	        return false;
	      }
	      const checked = [];
	      const result = [];
	      for (const u of unionTypes2) {
	        for (const t of u.types) {
	          if (insertType(checked, t)) {
	            if (eachUnionContains(unionTypes2, t)) {
	              insertType(result, t);
	            }
	          }
	        }
	      }
	      types[index] = getUnionTypeFromSortedList(result, 32768 /* PrimitiveUnion */);
	      return true;
	    }
	    function createIntersectionType(types, objectFlags, aliasSymbol, aliasTypeArguments) {
	      const result = createType(2097152 /* Intersection */);
	      result.objectFlags = objectFlags | getPropagatingFlagsOfTypes(
	        types,
	        /*excludeKinds*/
	        98304 /* Nullable */
	      );
	      result.types = types;
	      result.aliasSymbol = aliasSymbol;
	      result.aliasTypeArguments = aliasTypeArguments;
	      return result;
	    }
	    function getIntersectionType(types, aliasSymbol, aliasTypeArguments, noSupertypeReduction) {
	      const typeMembershipMap = /* @__PURE__ */ new Map();
	      const includes = addTypesToIntersection(typeMembershipMap, 0, types);
	      const typeSet = arrayFrom(typeMembershipMap.values());
	      let objectFlags = 0 /* None */;
	      if (includes & 131072 /* Never */) {
	        return contains(typeSet, silentNeverType) ? silentNeverType : neverType;
	      }
	      if (strictNullChecks && includes & 98304 /* Nullable */ && includes & (524288 /* Object */ | 67108864 /* NonPrimitive */ | 16777216 /* IncludesEmptyObject */) || includes & 67108864 /* NonPrimitive */ && includes & (469892092 /* DisjointDomains */ & ~67108864 /* NonPrimitive */) || includes & 402653316 /* StringLike */ && includes & (469892092 /* DisjointDomains */ & ~402653316 /* StringLike */) || includes & 296 /* NumberLike */ && includes & (469892092 /* DisjointDomains */ & ~296 /* NumberLike */) || includes & 2112 /* BigIntLike */ && includes & (469892092 /* DisjointDomains */ & ~2112 /* BigIntLike */) || includes & 12288 /* ESSymbolLike */ && includes & (469892092 /* DisjointDomains */ & ~12288 /* ESSymbolLike */) || includes & 49152 /* VoidLike */ && includes & (469892092 /* DisjointDomains */ & ~49152 /* VoidLike */)) {
	        return neverType;
	      }
	      if (includes & (134217728 /* TemplateLiteral */ | 268435456 /* StringMapping */) && includes & 128 /* StringLiteral */ && extractRedundantTemplateLiterals(typeSet)) {
	        return neverType;
	      }
	      if (includes & 1 /* Any */) {
	        return includes & 8388608 /* IncludesWildcard */ ? wildcardType : anyType;
	      }
	      if (!strictNullChecks && includes & 98304 /* Nullable */) {
	        return includes & 16777216 /* IncludesEmptyObject */ ? neverType : includes & 32768 /* Undefined */ ? undefinedType : nullType;
	      }
	      if (includes & 4 /* String */ && includes & (128 /* StringLiteral */ | 134217728 /* TemplateLiteral */ | 268435456 /* StringMapping */) || includes & 8 /* Number */ && includes & 256 /* NumberLiteral */ || includes & 64 /* BigInt */ && includes & 2048 /* BigIntLiteral */ || includes & 4096 /* ESSymbol */ && includes & 8192 /* UniqueESSymbol */ || includes & 16384 /* Void */ && includes & 32768 /* Undefined */ || includes & 16777216 /* IncludesEmptyObject */ && includes & 470302716 /* DefinitelyNonNullable */) {
	        if (!noSupertypeReduction)
	          removeRedundantSupertypes(typeSet, includes);
	      }
	      if (includes & 262144 /* IncludesMissingType */) {
	        typeSet[typeSet.indexOf(undefinedType)] = missingType;
	      }
	      if (typeSet.length === 0) {
	        return unknownType;
	      }
	      if (typeSet.length === 1) {
	        return typeSet[0];
	      }
	      if (typeSet.length === 2) {
	        const typeVarIndex = typeSet[0].flags & 8650752 /* TypeVariable */ ? 0 : 1;
	        const typeVariable = typeSet[typeVarIndex];
	        const primitiveType = typeSet[1 - typeVarIndex];
	        if (typeVariable.flags & 8650752 /* TypeVariable */ && (primitiveType.flags & (402784252 /* Primitive */ | 67108864 /* NonPrimitive */) && !isGenericStringLikeType(primitiveType) || includes & 16777216 /* IncludesEmptyObject */)) {
	          const constraint = getBaseConstraintOfType(typeVariable);
	          if (constraint && everyType(constraint, (t) => !!(t.flags & (402784252 /* Primitive */ | 67108864 /* NonPrimitive */)) || isEmptyAnonymousObjectType(t))) {
	            if (isTypeStrictSubtypeOf(constraint, primitiveType)) {
	              return typeVariable;
	            }
	            if (!(constraint.flags & 1048576 /* Union */ && someType(constraint, (c) => isTypeStrictSubtypeOf(c, primitiveType)))) {
	              if (!isTypeStrictSubtypeOf(primitiveType, constraint)) {
	                return neverType;
	              }
	            }
	            objectFlags = 67108864 /* IsConstrainedTypeVariable */;
	          }
	        }
	      }
	      const id = getTypeListId(typeSet) + getAliasId(aliasSymbol, aliasTypeArguments);
	      let result = intersectionTypes.get(id);
	      if (!result) {
	        if (includes & 1048576 /* Union */) {
	          if (intersectUnionsOfPrimitiveTypes(typeSet)) {
	            result = getIntersectionType(typeSet, aliasSymbol, aliasTypeArguments);
	          } else if (every(typeSet, (t) => !!(t.flags & 1048576 /* Union */ && t.types[0].flags & 32768 /* Undefined */))) {
	            const containedUndefinedType = some(typeSet, containsMissingType) ? missingType : undefinedType;
	            removeFromEach(typeSet, 32768 /* Undefined */);
	            result = getUnionType([getIntersectionType(typeSet), containedUndefinedType], 1 /* Literal */, aliasSymbol, aliasTypeArguments);
	          } else if (every(typeSet, (t) => !!(t.flags & 1048576 /* Union */ && (t.types[0].flags & 65536 /* Null */ || t.types[1].flags & 65536 /* Null */)))) {
	            removeFromEach(typeSet, 65536 /* Null */);
	            result = getUnionType([getIntersectionType(typeSet), nullType], 1 /* Literal */, aliasSymbol, aliasTypeArguments);
	          } else if (typeSet.length >= 4) {
	            const middle = Math.floor(typeSet.length / 2);
	            result = getIntersectionType([getIntersectionType(typeSet.slice(0, middle)), getIntersectionType(typeSet.slice(middle))], aliasSymbol, aliasTypeArguments);
	          } else {
	            if (!checkCrossProductUnion(typeSet)) {
	              return errorType;
	            }
	            const constituents = getCrossProductIntersections(typeSet);
	            const origin = some(constituents, (t) => !!(t.flags & 2097152 /* Intersection */)) && getConstituentCountOfTypes(constituents) > getConstituentCountOfTypes(typeSet) ? createOriginUnionOrIntersectionType(2097152 /* Intersection */, typeSet) : void 0;
	            result = getUnionType(constituents, 1 /* Literal */, aliasSymbol, aliasTypeArguments, origin);
	          }
	        } else {
	          result = createIntersectionType(typeSet, objectFlags, aliasSymbol, aliasTypeArguments);
	        }
	        intersectionTypes.set(id, result);
	      }
	      return result;
	    }
	    function getCrossProductUnionSize(types) {
	      return reduceLeft(types, (n, t) => t.flags & 1048576 /* Union */ ? n * t.types.length : t.flags & 131072 /* Never */ ? 0 : n, 1);
	    }
	    function checkCrossProductUnion(types) {
	      var _a;
	      const size = getCrossProductUnionSize(types);
	      if (size >= 1e5) {
	        (_a = tracing) == null ? void 0 : _a.instant(tracing.Phase.CheckTypes, "checkCrossProductUnion_DepthLimit", { typeIds: types.map((t) => t.id), size });
	        error2(currentNode, Diagnostics.Expression_produces_a_union_type_that_is_too_complex_to_represent);
	        return false;
	      }
	      return true;
	    }
	    function getCrossProductIntersections(types) {
	      const count = getCrossProductUnionSize(types);
	      const intersections = [];
	      for (let i = 0; i < count; i++) {
	        const constituents = types.slice();
	        let n = i;
	        for (let j = types.length - 1; j >= 0; j--) {
	          if (types[j].flags & 1048576 /* Union */) {
	            const sourceTypes = types[j].types;
	            const length2 = sourceTypes.length;
	            constituents[j] = sourceTypes[n % length2];
	            n = Math.floor(n / length2);
	          }
	        }
	        const t = getIntersectionType(constituents);
	        if (!(t.flags & 131072 /* Never */))
	          intersections.push(t);
	      }
	      return intersections;
	    }
	    function getConstituentCount(type) {
	      return !(type.flags & 3145728 /* UnionOrIntersection */) || type.aliasSymbol ? 1 : type.flags & 1048576 /* Union */ && type.origin ? getConstituentCount(type.origin) : getConstituentCountOfTypes(type.types);
	    }
	    function getConstituentCountOfTypes(types) {
	      return reduceLeft(types, (n, t) => n + getConstituentCount(t), 0);
	    }
	    function getTypeFromIntersectionTypeNode(node) {
	      const links = getNodeLinks(node);
	      if (!links.resolvedType) {
	        const aliasSymbol = getAliasSymbolForTypeNode(node);
	        const types = map(node.types, getTypeFromTypeNode);
	        const emptyIndex = types.length === 2 ? types.indexOf(emptyTypeLiteralType) : -1;
	        const t = emptyIndex >= 0 ? types[1 - emptyIndex] : unknownType;
	        const noSupertypeReduction = !!(t.flags & (4 /* String */ | 8 /* Number */ | 64 /* BigInt */) || t.flags & 134217728 /* TemplateLiteral */ && isPatternLiteralType(t));
	        links.resolvedType = getIntersectionType(types, aliasSymbol, getTypeArgumentsForAliasSymbol(aliasSymbol), noSupertypeReduction);
	      }
	      return links.resolvedType;
	    }
	    function createIndexType(type, indexFlags) {
	      const result = createType(4194304 /* Index */);
	      result.type = type;
	      result.indexFlags = indexFlags;
	      return result;
	    }
	    function createOriginIndexType(type) {
	      const result = createOriginType(4194304 /* Index */);
	      result.type = type;
	      return result;
	    }
	    function getIndexTypeForGenericType(type, indexFlags) {
	      return indexFlags & 1 /* StringsOnly */ ? type.resolvedStringIndexType || (type.resolvedStringIndexType = createIndexType(type, 1 /* StringsOnly */)) : type.resolvedIndexType || (type.resolvedIndexType = createIndexType(type, 0 /* None */));
	    }
	    function getIndexTypeForMappedType(type, indexFlags) {
	      const typeParameter = getTypeParameterFromMappedType(type);
	      const constraintType = getConstraintTypeFromMappedType(type);
	      const nameType = getNameTypeFromMappedType(type.target || type);
	      if (!nameType && !(indexFlags & 2 /* NoIndexSignatures */)) {
	        return constraintType;
	      }
	      const keyTypes = [];
	      if (isGenericIndexType(constraintType)) {
	        if (isMappedTypeWithKeyofConstraintDeclaration(type)) {
	          return getIndexTypeForGenericType(type, indexFlags);
	        }
	        forEachType(constraintType, addMemberForKeyType);
	      } else if (isMappedTypeWithKeyofConstraintDeclaration(type)) {
	        const modifiersType = getApparentType(getModifiersTypeFromMappedType(type));
	        forEachMappedTypePropertyKeyTypeAndIndexSignatureKeyType(modifiersType, 8576 /* StringOrNumberLiteralOrUnique */, !!(indexFlags & 1 /* StringsOnly */), addMemberForKeyType);
	      } else {
	        forEachType(getLowerBoundOfKeyType(constraintType), addMemberForKeyType);
	      }
	      const result = indexFlags & 2 /* NoIndexSignatures */ ? filterType(getUnionType(keyTypes), (t) => !(t.flags & (1 /* Any */ | 4 /* String */))) : getUnionType(keyTypes);
	      if (result.flags & 1048576 /* Union */ && constraintType.flags & 1048576 /* Union */ && getTypeListId(result.types) === getTypeListId(constraintType.types)) {
	        return constraintType;
	      }
	      return result;
	      function addMemberForKeyType(keyType) {
	        const propNameType = nameType ? instantiateType(nameType, appendTypeMapping(type.mapper, typeParameter, keyType)) : keyType;
	        keyTypes.push(propNameType === stringType ? stringOrNumberType : propNameType);
	      }
	    }
	    function hasDistributiveNameType(mappedType) {
	      const typeVariable = getTypeParameterFromMappedType(mappedType);
	      return isDistributive(getNameTypeFromMappedType(mappedType) || typeVariable);
	      function isDistributive(type) {
	        return type.flags & (3 /* AnyOrUnknown */ | 402784252 /* Primitive */ | 131072 /* Never */ | 262144 /* TypeParameter */ | 524288 /* Object */ | 67108864 /* NonPrimitive */) ? true : type.flags & 16777216 /* Conditional */ ? type.root.isDistributive && type.checkType === typeVariable : type.flags & (3145728 /* UnionOrIntersection */ | 134217728 /* TemplateLiteral */) ? every(type.types, isDistributive) : type.flags & 8388608 /* IndexedAccess */ ? isDistributive(type.objectType) && isDistributive(type.indexType) : type.flags & 33554432 /* Substitution */ ? isDistributive(type.baseType) && isDistributive(type.constraint) : type.flags & 268435456 /* StringMapping */ ? isDistributive(type.type) : false;
	      }
	    }
	    function getLiteralTypeFromPropertyName(name) {
	      if (isPrivateIdentifier(name)) {
	        return neverType;
	      }
	      if (isNumericLiteral(name)) {
	        return getRegularTypeOfLiteralType(checkExpression(name));
	      }
	      if (isComputedPropertyName(name)) {
	        return getRegularTypeOfLiteralType(checkComputedPropertyName(name));
	      }
	      const propertyName = getPropertyNameForPropertyNameNode(name);
	      if (propertyName !== void 0) {
	        return getStringLiteralType(unescapeLeadingUnderscores(propertyName));
	      }
	      if (isExpression(name)) {
	        return getRegularTypeOfLiteralType(checkExpression(name));
	      }
	      return neverType;
	    }
	    function getLiteralTypeFromProperty(prop, include, includeNonPublic) {
	      if (includeNonPublic || !(getDeclarationModifierFlagsFromSymbol(prop) & 6 /* NonPublicAccessibilityModifier */)) {
	        let type = getSymbolLinks(getLateBoundSymbol(prop)).nameType;
	        if (!type) {
	          const name = getNameOfDeclaration(prop.valueDeclaration);
	          type = prop.escapedName === "default" /* Default */ ? getStringLiteralType("default") : name && getLiteralTypeFromPropertyName(name) || (!isKnownSymbol(prop) ? getStringLiteralType(symbolName(prop)) : void 0);
	        }
	        if (type && type.flags & include) {
	          return type;
	        }
	      }
	      return neverType;
	    }
	    function isKeyTypeIncluded(keyType, include) {
	      return !!(keyType.flags & include || keyType.flags & 2097152 /* Intersection */ && some(keyType.types, (t) => isKeyTypeIncluded(t, include)));
	    }
	    function getLiteralTypeFromProperties(type, include, includeOrigin) {
	      const origin = includeOrigin && (getObjectFlags(type) & (3 /* ClassOrInterface */ | 4 /* Reference */) || type.aliasSymbol) ? createOriginIndexType(type) : void 0;
	      const propertyTypes = map(getPropertiesOfType(type), (prop) => getLiteralTypeFromProperty(prop, include));
	      const indexKeyTypes = map(getIndexInfosOfType(type), (info) => info !== enumNumberIndexInfo && isKeyTypeIncluded(info.keyType, include) ? info.keyType === stringType && include & 8 /* Number */ ? stringOrNumberType : info.keyType : neverType);
	      return getUnionType(
	        concatenate(propertyTypes, indexKeyTypes),
	        1 /* Literal */,
	        /*aliasSymbol*/
	        void 0,
	        /*aliasTypeArguments*/
	        void 0,
	        origin
	      );
	    }
	    function shouldDeferIndexType(type, indexFlags = 0 /* None */) {
	      return !!(type.flags & 58982400 /* InstantiableNonPrimitive */ || isGenericTupleType(type) || isGenericMappedType(type) && (!hasDistributiveNameType(type) || getMappedTypeNameTypeKind(type) === 2 /* Remapping */) || type.flags & 1048576 /* Union */ && !(indexFlags & 4 /* NoReducibleCheck */) && isGenericReducibleType(type) || type.flags & 2097152 /* Intersection */ && maybeTypeOfKind(type, 465829888 /* Instantiable */) && some(type.types, isEmptyAnonymousObjectType));
	    }
	    function getIndexType(type, indexFlags = defaultIndexFlags) {
	      type = getReducedType(type);
	      return isNoInferType(type) ? getNoInferType(getIndexType(type.baseType, indexFlags)) : shouldDeferIndexType(type, indexFlags) ? getIndexTypeForGenericType(type, indexFlags) : type.flags & 1048576 /* Union */ ? getIntersectionType(map(type.types, (t) => getIndexType(t, indexFlags))) : type.flags & 2097152 /* Intersection */ ? getUnionType(map(type.types, (t) => getIndexType(t, indexFlags))) : getObjectFlags(type) & 32 /* Mapped */ ? getIndexTypeForMappedType(type, indexFlags) : type === wildcardType ? wildcardType : type.flags & 2 /* Unknown */ ? neverType : type.flags & (1 /* Any */ | 131072 /* Never */) ? keyofConstraintType : getLiteralTypeFromProperties(type, (indexFlags & 2 /* NoIndexSignatures */ ? 128 /* StringLiteral */ : 402653316 /* StringLike */) | (indexFlags & 1 /* StringsOnly */ ? 0 : 296 /* NumberLike */ | 12288 /* ESSymbolLike */), indexFlags === defaultIndexFlags);
	    }
	    function getExtractStringType(type) {
	      if (keyofStringsOnly) {
	        return type;
	      }
	      const extractTypeAlias = getGlobalExtractSymbol();
	      return extractTypeAlias ? getTypeAliasInstantiation(extractTypeAlias, [type, stringType]) : stringType;
	    }
	    function getIndexTypeOrString(type) {
	      const indexType = getExtractStringType(getIndexType(type));
	      return indexType.flags & 131072 /* Never */ ? stringType : indexType;
	    }
	    function getTypeFromTypeOperatorNode(node) {
	      const links = getNodeLinks(node);
	      if (!links.resolvedType) {
	        switch (node.operator) {
	          case 143 /* KeyOfKeyword */:
	            links.resolvedType = getIndexType(getTypeFromTypeNode(node.type));
	            break;
	          case 158 /* UniqueKeyword */:
	            links.resolvedType = node.type.kind === 155 /* SymbolKeyword */ ? getESSymbolLikeTypeForNode(walkUpParenthesizedTypes(node.parent)) : errorType;
	            break;
	          case 148 /* ReadonlyKeyword */:
	            links.resolvedType = getTypeFromTypeNode(node.type);
	            break;
	          default:
	            Debug.assertNever(node.operator);
	        }
	      }
	      return links.resolvedType;
	    }
	    function getTypeFromTemplateTypeNode(node) {
	      const links = getNodeLinks(node);
	      if (!links.resolvedType) {
	        links.resolvedType = getTemplateLiteralType(
	          [node.head.text, ...map(node.templateSpans, (span) => span.literal.text)],
	          map(node.templateSpans, (span) => getTypeFromTypeNode(span.type))
	        );
	      }
	      return links.resolvedType;
	    }
	    function getTemplateLiteralType(texts, types) {
	      const unionIndex = findIndex(types, (t) => !!(t.flags & (131072 /* Never */ | 1048576 /* Union */)));
	      if (unionIndex >= 0) {
	        return checkCrossProductUnion(types) ? mapType(types[unionIndex], (t) => getTemplateLiteralType(texts, replaceElement(types, unionIndex, t))) : errorType;
	      }
	      if (contains(types, wildcardType)) {
	        return wildcardType;
	      }
	      const newTypes = [];
	      const newTexts = [];
	      let text = texts[0];
	      if (!addSpans(texts, types)) {
	        return stringType;
	      }
	      if (newTypes.length === 0) {
	        return getStringLiteralType(text);
	      }
	      newTexts.push(text);
	      if (every(newTexts, (t) => t === "")) {
	        if (every(newTypes, (t) => !!(t.flags & 4 /* String */))) {
	          return stringType;
	        }
	        if (newTypes.length === 1 && isPatternLiteralType(newTypes[0])) {
	          return newTypes[0];
	        }
	      }
	      const id = `${getTypeListId(newTypes)}|${map(newTexts, (t) => t.length).join(",")}|${newTexts.join("")}`;
	      let type = templateLiteralTypes.get(id);
	      if (!type) {
	        templateLiteralTypes.set(id, type = createTemplateLiteralType(newTexts, newTypes));
	      }
	      return type;
	      function addSpans(texts2, types2) {
	        for (let i = 0; i < types2.length; i++) {
	          const t = types2[i];
	          if (t.flags & (2944 /* Literal */ | 65536 /* Null */ | 32768 /* Undefined */)) {
	            text += getTemplateStringForType(t) || "";
	            text += texts2[i + 1];
	          } else if (t.flags & 134217728 /* TemplateLiteral */) {
	            text += t.texts[0];
	            if (!addSpans(t.texts, t.types))
	              return false;
	            text += texts2[i + 1];
	          } else if (isGenericIndexType(t) || isPatternLiteralPlaceholderType(t)) {
	            newTypes.push(t);
	            newTexts.push(text);
	            text = texts2[i + 1];
	          } else {
	            return false;
	          }
	        }
	        return true;
	      }
	    }
	    function getTemplateStringForType(type) {
	      return type.flags & 128 /* StringLiteral */ ? type.value : type.flags & 256 /* NumberLiteral */ ? "" + type.value : type.flags & 2048 /* BigIntLiteral */ ? pseudoBigIntToString(type.value) : type.flags & (512 /* BooleanLiteral */ | 98304 /* Nullable */) ? type.intrinsicName : void 0;
	    }
	    function createTemplateLiteralType(texts, types) {
	      const type = createType(134217728 /* TemplateLiteral */);
	      type.texts = texts;
	      type.types = types;
	      return type;
	    }
	    function getStringMappingType(symbol, type) {
	      return type.flags & (1048576 /* Union */ | 131072 /* Never */) ? mapType(type, (t) => getStringMappingType(symbol, t)) : type.flags & 128 /* StringLiteral */ ? getStringLiteralType(applyStringMapping(symbol, type.value)) : type.flags & 134217728 /* TemplateLiteral */ ? getTemplateLiteralType(...applyTemplateStringMapping(symbol, type.texts, type.types)) : (
	        // Mapping<Mapping<T>> === Mapping<T>
	        type.flags & 268435456 /* StringMapping */ && symbol === type.symbol ? type : type.flags & (1 /* Any */ | 4 /* String */ | 268435456 /* StringMapping */) || isGenericIndexType(type) ? getStringMappingTypeForGenericType(symbol, type) : (
	          // This handles Mapping<`${number}`> and Mapping<`${bigint}`>
	          isPatternLiteralPlaceholderType(type) ? getStringMappingTypeForGenericType(symbol, getTemplateLiteralType(["", ""], [type])) : type
	        )
	      );
	    }
	    function applyStringMapping(symbol, str) {
	      switch (intrinsicTypeKinds.get(symbol.escapedName)) {
	        case 0 /* Uppercase */:
	          return str.toUpperCase();
	        case 1 /* Lowercase */:
	          return str.toLowerCase();
	        case 2 /* Capitalize */:
	          return str.charAt(0).toUpperCase() + str.slice(1);
	        case 3 /* Uncapitalize */:
	          return str.charAt(0).toLowerCase() + str.slice(1);
	      }
	      return str;
	    }
	    function applyTemplateStringMapping(symbol, texts, types) {
	      switch (intrinsicTypeKinds.get(symbol.escapedName)) {
	        case 0 /* Uppercase */:
	          return [texts.map((t) => t.toUpperCase()), types.map((t) => getStringMappingType(symbol, t))];
	        case 1 /* Lowercase */:
	          return [texts.map((t) => t.toLowerCase()), types.map((t) => getStringMappingType(symbol, t))];
	        case 2 /* Capitalize */:
	          return [texts[0] === "" ? texts : [texts[0].charAt(0).toUpperCase() + texts[0].slice(1), ...texts.slice(1)], texts[0] === "" ? [getStringMappingType(symbol, types[0]), ...types.slice(1)] : types];
	        case 3 /* Uncapitalize */:
	          return [texts[0] === "" ? texts : [texts[0].charAt(0).toLowerCase() + texts[0].slice(1), ...texts.slice(1)], texts[0] === "" ? [getStringMappingType(symbol, types[0]), ...types.slice(1)] : types];
	      }
	      return [texts, types];
	    }
	    function getStringMappingTypeForGenericType(symbol, type) {
	      const id = `${getSymbolId(symbol)},${getTypeId(type)}`;
	      let result = stringMappingTypes.get(id);
	      if (!result) {
	        stringMappingTypes.set(id, result = createStringMappingType(symbol, type));
	      }
	      return result;
	    }
	    function createStringMappingType(symbol, type) {
	      const result = createTypeWithSymbol(268435456 /* StringMapping */, symbol);
	      result.type = type;
	      return result;
	    }
	    function createIndexedAccessType(objectType, indexType, accessFlags, aliasSymbol, aliasTypeArguments) {
	      const type = createType(8388608 /* IndexedAccess */);
	      type.objectType = objectType;
	      type.indexType = indexType;
	      type.accessFlags = accessFlags;
	      type.aliasSymbol = aliasSymbol;
	      type.aliasTypeArguments = aliasTypeArguments;
	      return type;
	    }
	    function isJSLiteralType(type) {
	      if (noImplicitAny) {
	        return false;
	      }
	      if (getObjectFlags(type) & 4096 /* JSLiteral */) {
	        return true;
	      }
	      if (type.flags & 1048576 /* Union */) {
	        return every(type.types, isJSLiteralType);
	      }
	      if (type.flags & 2097152 /* Intersection */) {
	        return some(type.types, isJSLiteralType);
	      }
	      if (type.flags & 465829888 /* Instantiable */) {
	        const constraint = getResolvedBaseConstraint(type);
	        return constraint !== type && isJSLiteralType(constraint);
	      }
	      return false;
	    }
	    function getPropertyNameFromIndex(indexType, accessNode) {
	      return isTypeUsableAsPropertyName(indexType) ? getPropertyNameFromType(indexType) : accessNode && isPropertyName(accessNode) ? (
	        // late bound names are handled in the first branch, so here we only need to handle normal names
	        getPropertyNameForPropertyNameNode(accessNode)
	      ) : void 0;
	    }
	    function isUncalledFunctionReference(node, symbol) {
	      if (symbol.flags & (16 /* Function */ | 8192 /* Method */)) {
	        const parent2 = findAncestor(node.parent, (n) => !isAccessExpression(n)) || node.parent;
	        if (isCallLikeExpression(parent2)) {
	          return isCallOrNewExpression(parent2) && isIdentifier(node) && hasMatchingArgument(parent2, node);
	        }
	        return every(symbol.declarations, (d) => !isFunctionLike(d) || isDeprecatedDeclaration2(d));
	      }
	      return true;
	    }
	    function getPropertyTypeForIndexType(originalObjectType, objectType, indexType, fullIndexType, accessNode, accessFlags) {
	      const accessExpression = accessNode && accessNode.kind === 212 /* ElementAccessExpression */ ? accessNode : void 0;
	      const propName = accessNode && isPrivateIdentifier(accessNode) ? void 0 : getPropertyNameFromIndex(indexType, accessNode);
	      if (propName !== void 0) {
	        if (accessFlags & 256 /* Contextual */) {
	          return getTypeOfPropertyOfContextualType(objectType, propName) || anyType;
	        }
	        const prop = getPropertyOfType(objectType, propName);
	        if (prop) {
	          if (accessFlags & 64 /* ReportDeprecated */ && accessNode && prop.declarations && isDeprecatedSymbol(prop) && isUncalledFunctionReference(accessNode, prop)) {
	            const deprecatedNode = (accessExpression == null ? void 0 : accessExpression.argumentExpression) ?? (isIndexedAccessTypeNode(accessNode) ? accessNode.indexType : accessNode);
	            addDeprecatedSuggestion(deprecatedNode, prop.declarations, propName);
	          }
	          if (accessExpression) {
	            markPropertyAsReferenced(prop, accessExpression, isSelfTypeAccess(accessExpression.expression, objectType.symbol));
	            if (isAssignmentToReadonlyEntity(accessExpression, prop, getAssignmentTargetKind(accessExpression))) {
	              error2(accessExpression.argumentExpression, Diagnostics.Cannot_assign_to_0_because_it_is_a_read_only_property, symbolToString(prop));
	              return void 0;
	            }
	            if (accessFlags & 8 /* CacheSymbol */) {
	              getNodeLinks(accessNode).resolvedSymbol = prop;
	            }
	            if (isThisPropertyAccessInConstructor(accessExpression, prop)) {
	              return autoType;
	            }
	          }
	          const propType = accessFlags & 4 /* Writing */ ? getWriteTypeOfSymbol(prop) : getTypeOfSymbol(prop);
	          return accessExpression && getAssignmentTargetKind(accessExpression) !== 1 /* Definite */ ? getFlowTypeOfReference(accessExpression, propType) : accessNode && isIndexedAccessTypeNode(accessNode) && containsMissingType(propType) ? getUnionType([propType, undefinedType]) : propType;
	        }
	        if (everyType(objectType, isTupleType) && isNumericLiteralName(propName)) {
	          const index = +propName;
	          if (accessNode && everyType(objectType, (t) => !t.target.hasRestElement) && !(accessFlags & 16 /* NoTupleBoundsCheck */)) {
	            const indexNode = getIndexNodeForAccessExpression(accessNode);
	            if (isTupleType(objectType)) {
	              if (index < 0) {
	                error2(indexNode, Diagnostics.A_tuple_type_cannot_be_indexed_with_a_negative_value);
	                return undefinedType;
	              }
	              error2(indexNode, Diagnostics.Tuple_type_0_of_length_1_has_no_element_at_index_2, typeToString(objectType), getTypeReferenceArity(objectType), unescapeLeadingUnderscores(propName));
	            } else {
	              error2(indexNode, Diagnostics.Property_0_does_not_exist_on_type_1, unescapeLeadingUnderscores(propName), typeToString(objectType));
	            }
	          }
	          if (index >= 0) {
	            errorIfWritingToReadonlyIndex(getIndexInfoOfType(objectType, numberType));
	            return getTupleElementTypeOutOfStartCount(objectType, index, accessFlags & 1 /* IncludeUndefined */ ? missingType : void 0);
	          }
	        }
	      }
	      if (!(indexType.flags & 98304 /* Nullable */) && isTypeAssignableToKind(indexType, 402653316 /* StringLike */ | 296 /* NumberLike */ | 12288 /* ESSymbolLike */)) {
	        if (objectType.flags & (1 /* Any */ | 131072 /* Never */)) {
	          return objectType;
	        }
	        const indexInfo = getApplicableIndexInfo(objectType, indexType) || getIndexInfoOfType(objectType, stringType);
	        if (indexInfo) {
	          if (accessFlags & 2 /* NoIndexSignatures */ && indexInfo.keyType !== numberType) {
	            if (accessExpression) {
	              if (accessFlags & 4 /* Writing */) {
	                error2(accessExpression, Diagnostics.Type_0_is_generic_and_can_only_be_indexed_for_reading, typeToString(originalObjectType));
	              } else {
	                error2(accessExpression, Diagnostics.Type_0_cannot_be_used_to_index_type_1, typeToString(indexType), typeToString(originalObjectType));
	              }
	            }
	            return void 0;
	          }
	          if (accessNode && indexInfo.keyType === stringType && !isTypeAssignableToKind(indexType, 4 /* String */ | 8 /* Number */)) {
	            const indexNode = getIndexNodeForAccessExpression(accessNode);
	            error2(indexNode, Diagnostics.Type_0_cannot_be_used_as_an_index_type, typeToString(indexType));
	            return accessFlags & 1 /* IncludeUndefined */ ? getUnionType([indexInfo.type, missingType]) : indexInfo.type;
	          }
	          errorIfWritingToReadonlyIndex(indexInfo);
	          if (accessFlags & 1 /* IncludeUndefined */ && !(objectType.symbol && objectType.symbol.flags & (256 /* RegularEnum */ | 128 /* ConstEnum */) && (indexType.symbol && indexType.flags & 1024 /* EnumLiteral */ && getParentOfSymbol(indexType.symbol) === objectType.symbol))) {
	            return getUnionType([indexInfo.type, missingType]);
	          }
	          return indexInfo.type;
	        }
	        if (indexType.flags & 131072 /* Never */) {
	          return neverType;
	        }
	        if (isJSLiteralType(objectType)) {
	          return anyType;
	        }
	        if (accessExpression && !isConstEnumObjectType(objectType)) {
	          if (isObjectLiteralType2(objectType)) {
	            if (noImplicitAny && indexType.flags & (128 /* StringLiteral */ | 256 /* NumberLiteral */)) {
	              diagnostics.add(createDiagnosticForNode(accessExpression, Diagnostics.Property_0_does_not_exist_on_type_1, indexType.value, typeToString(objectType)));
	              return undefinedType;
	            } else if (indexType.flags & (8 /* Number */ | 4 /* String */)) {
	              const types = map(objectType.properties, (property) => {
	                return getTypeOfSymbol(property);
	              });
	              return getUnionType(append(types, undefinedType));
	            }
	          }
	          if (objectType.symbol === globalThisSymbol && propName !== void 0 && globalThisSymbol.exports.has(propName) && globalThisSymbol.exports.get(propName).flags & 418 /* BlockScoped */) {
	            error2(accessExpression, Diagnostics.Property_0_does_not_exist_on_type_1, unescapeLeadingUnderscores(propName), typeToString(objectType));
	          } else if (noImplicitAny && !compilerOptions.suppressImplicitAnyIndexErrors && !(accessFlags & 128 /* SuppressNoImplicitAnyError */)) {
	            if (propName !== void 0 && typeHasStaticProperty(propName, objectType)) {
	              const typeName = typeToString(objectType);
	              error2(accessExpression, Diagnostics.Property_0_does_not_exist_on_type_1_Did_you_mean_to_access_the_static_member_2_instead, propName, typeName, typeName + "[" + getTextOfNode(accessExpression.argumentExpression) + "]");
	            } else if (getIndexTypeOfType(objectType, numberType)) {
	              error2(accessExpression.argumentExpression, Diagnostics.Element_implicitly_has_an_any_type_because_index_expression_is_not_of_type_number);
	            } else {
	              let suggestion;
	              if (propName !== void 0 && (suggestion = getSuggestionForNonexistentProperty(propName, objectType))) {
	                if (suggestion !== void 0) {
	                  error2(accessExpression.argumentExpression, Diagnostics.Property_0_does_not_exist_on_type_1_Did_you_mean_2, propName, typeToString(objectType), suggestion);
	                }
	              } else {
	                const suggestion2 = getSuggestionForNonexistentIndexSignature(objectType, accessExpression, indexType);
	                if (suggestion2 !== void 0) {
	                  error2(accessExpression, Diagnostics.Element_implicitly_has_an_any_type_because_type_0_has_no_index_signature_Did_you_mean_to_call_1, typeToString(objectType), suggestion2);
	                } else {
	                  let errorInfo;
	                  if (indexType.flags & 1024 /* EnumLiteral */) {
	                    errorInfo = chainDiagnosticMessages(
	                      /*details*/
	                      void 0,
	                      Diagnostics.Property_0_does_not_exist_on_type_1,
	                      "[" + typeToString(indexType) + "]",
	                      typeToString(objectType)
	                    );
	                  } else if (indexType.flags & 8192 /* UniqueESSymbol */) {
	                    const symbolName2 = getFullyQualifiedName(indexType.symbol, accessExpression);
	                    errorInfo = chainDiagnosticMessages(
	                      /*details*/
	                      void 0,
	                      Diagnostics.Property_0_does_not_exist_on_type_1,
	                      "[" + symbolName2 + "]",
	                      typeToString(objectType)
	                    );
	                  } else if (indexType.flags & 128 /* StringLiteral */) {
	                    errorInfo = chainDiagnosticMessages(
	                      /*details*/
	                      void 0,
	                      Diagnostics.Property_0_does_not_exist_on_type_1,
	                      indexType.value,
	                      typeToString(objectType)
	                    );
	                  } else if (indexType.flags & 256 /* NumberLiteral */) {
	                    errorInfo = chainDiagnosticMessages(
	                      /*details*/
	                      void 0,
	                      Diagnostics.Property_0_does_not_exist_on_type_1,
	                      indexType.value,
	                      typeToString(objectType)
	                    );
	                  } else if (indexType.flags & (8 /* Number */ | 4 /* String */)) {
	                    errorInfo = chainDiagnosticMessages(
	                      /*details*/
	                      void 0,
	                      Diagnostics.No_index_signature_with_a_parameter_of_type_0_was_found_on_type_1,
	                      typeToString(indexType),
	                      typeToString(objectType)
	                    );
	                  }
	                  errorInfo = chainDiagnosticMessages(
	                    errorInfo,
	                    Diagnostics.Element_implicitly_has_an_any_type_because_expression_of_type_0_can_t_be_used_to_index_type_1,
	                    typeToString(fullIndexType),
	                    typeToString(objectType)
	                  );
	                  diagnostics.add(createDiagnosticForNodeFromMessageChain(getSourceFileOfNode(accessExpression), accessExpression, errorInfo));
	                }
	              }
	            }
	          }
	          return void 0;
	        }
	      }
	      if (isJSLiteralType(objectType)) {
	        return anyType;
	      }
	      if (accessNode) {
	        const indexNode = getIndexNodeForAccessExpression(accessNode);
	        if (indexType.flags & (128 /* StringLiteral */ | 256 /* NumberLiteral */)) {
	          error2(indexNode, Diagnostics.Property_0_does_not_exist_on_type_1, "" + indexType.value, typeToString(objectType));
	        } else if (indexType.flags & (4 /* String */ | 8 /* Number */)) {
	          error2(indexNode, Diagnostics.Type_0_has_no_matching_index_signature_for_type_1, typeToString(objectType), typeToString(indexType));
	        } else {
	          error2(indexNode, Diagnostics.Type_0_cannot_be_used_as_an_index_type, typeToString(indexType));
	        }
	      }
	      if (isTypeAny(indexType)) {
	        return indexType;
	      }
	      return void 0;
	      function errorIfWritingToReadonlyIndex(indexInfo) {
	        if (indexInfo && indexInfo.isReadonly && accessExpression && (isAssignmentTarget(accessExpression) || isDeleteTarget(accessExpression))) {
	          error2(accessExpression, Diagnostics.Index_signature_in_type_0_only_permits_reading, typeToString(objectType));
	        }
	      }
	    }
	    function getIndexNodeForAccessExpression(accessNode) {
	      return accessNode.kind === 212 /* ElementAccessExpression */ ? accessNode.argumentExpression : accessNode.kind === 199 /* IndexedAccessType */ ? accessNode.indexType : accessNode.kind === 167 /* ComputedPropertyName */ ? accessNode.expression : accessNode;
	    }
	    function isPatternLiteralPlaceholderType(type) {
	      if (type.flags & 2097152 /* Intersection */) {
	        let seenPlaceholder = false;
	        for (const t of type.types) {
	          if (t.flags & (2944 /* Literal */ | 98304 /* Nullable */) || isPatternLiteralPlaceholderType(t)) {
	            seenPlaceholder = true;
	          } else if (!(t.flags & 524288 /* Object */)) {
	            return false;
	          }
	        }
	        return seenPlaceholder;
	      }
	      return !!(type.flags & (1 /* Any */ | 4 /* String */ | 8 /* Number */ | 64 /* BigInt */)) || isPatternLiteralType(type);
	    }
	    function isPatternLiteralType(type) {
	      return !!(type.flags & 134217728 /* TemplateLiteral */) && every(type.types, isPatternLiteralPlaceholderType) || !!(type.flags & 268435456 /* StringMapping */) && isPatternLiteralPlaceholderType(type.type);
	    }
	    function isGenericStringLikeType(type) {
	      return !!(type.flags & (134217728 /* TemplateLiteral */ | 268435456 /* StringMapping */)) && !isPatternLiteralType(type);
	    }
	    function isGenericType(type) {
	      return !!getGenericObjectFlags(type);
	    }
	    function isGenericObjectType(type) {
	      return !!(getGenericObjectFlags(type) & 4194304 /* IsGenericObjectType */);
	    }
	    function isGenericIndexType(type) {
	      return !!(getGenericObjectFlags(type) & 8388608 /* IsGenericIndexType */);
	    }
	    function getGenericObjectFlags(type) {
	      if (type.flags & 3145728 /* UnionOrIntersection */) {
	        if (!(type.objectFlags & 2097152 /* IsGenericTypeComputed */)) {
	          type.objectFlags |= 2097152 /* IsGenericTypeComputed */ | reduceLeft(type.types, (flags, t) => flags | getGenericObjectFlags(t), 0);
	        }
	        return type.objectFlags & 12582912 /* IsGenericType */;
	      }
	      if (type.flags & 33554432 /* Substitution */) {
	        if (!(type.objectFlags & 2097152 /* IsGenericTypeComputed */)) {
	          type.objectFlags |= 2097152 /* IsGenericTypeComputed */ | getGenericObjectFlags(type.baseType) | getGenericObjectFlags(type.constraint);
	        }
	        return type.objectFlags & 12582912 /* IsGenericType */;
	      }
	      return (type.flags & 58982400 /* InstantiableNonPrimitive */ || isGenericMappedType(type) || isGenericTupleType(type) ? 4194304 /* IsGenericObjectType */ : 0) | (type.flags & (58982400 /* InstantiableNonPrimitive */ | 4194304 /* Index */) || isGenericStringLikeType(type) ? 8388608 /* IsGenericIndexType */ : 0);
	    }
	    function getSimplifiedType(type, writing) {
	      return type.flags & 8388608 /* IndexedAccess */ ? getSimplifiedIndexedAccessType(type, writing) : type.flags & 16777216 /* Conditional */ ? getSimplifiedConditionalType(type, writing) : type;
	    }
	    function distributeIndexOverObjectType(objectType, indexType, writing) {
	      if (objectType.flags & 1048576 /* Union */ || objectType.flags & 2097152 /* Intersection */ && !shouldDeferIndexType(objectType)) {
	        const types = map(objectType.types, (t) => getSimplifiedType(getIndexedAccessType(t, indexType), writing));
	        return objectType.flags & 2097152 /* Intersection */ || writing ? getIntersectionType(types) : getUnionType(types);
	      }
	    }
	    function distributeObjectOverIndexType(objectType, indexType, writing) {
	      if (indexType.flags & 1048576 /* Union */) {
	        const types = map(indexType.types, (t) => getSimplifiedType(getIndexedAccessType(objectType, t), writing));
	        return writing ? getIntersectionType(types) : getUnionType(types);
	      }
	    }
	    function getSimplifiedIndexedAccessType(type, writing) {
	      const cache = writing ? "simplifiedForWriting" : "simplifiedForReading";
	      if (type[cache]) {
	        return type[cache] === circularConstraintType ? type : type[cache];
	      }
	      type[cache] = circularConstraintType;
	      const objectType = getSimplifiedType(type.objectType, writing);
	      const indexType = getSimplifiedType(type.indexType, writing);
	      const distributedOverIndex = distributeObjectOverIndexType(objectType, indexType, writing);
	      if (distributedOverIndex) {
	        return type[cache] = distributedOverIndex;
	      }
	      if (!(indexType.flags & 465829888 /* Instantiable */)) {
	        const distributedOverObject = distributeIndexOverObjectType(objectType, indexType, writing);
	        if (distributedOverObject) {
	          return type[cache] = distributedOverObject;
	        }
	      }
	      if (isGenericTupleType(objectType) && indexType.flags & 296 /* NumberLike */) {
	        const elementType = getElementTypeOfSliceOfTupleType(
	          objectType,
	          indexType.flags & 8 /* Number */ ? 0 : objectType.target.fixedLength,
	          /*endSkipCount*/
	          0,
	          writing
	        );
	        if (elementType) {
	          return type[cache] = elementType;
	        }
	      }
	      if (isGenericMappedType(objectType)) {
	        if (getMappedTypeNameTypeKind(objectType) !== 2 /* Remapping */) {
	          return type[cache] = mapType(substituteIndexedMappedType(objectType, type.indexType), (t) => getSimplifiedType(t, writing));
	        }
	      }
	      return type[cache] = type;
	    }
	    function getSimplifiedConditionalType(type, writing) {
	      const checkType = type.checkType;
	      const extendsType = type.extendsType;
	      const trueType2 = getTrueTypeFromConditionalType(type);
	      const falseType2 = getFalseTypeFromConditionalType(type);
	      if (falseType2.flags & 131072 /* Never */ && getActualTypeVariable(trueType2) === getActualTypeVariable(checkType)) {
	        if (checkType.flags & 1 /* Any */ || isTypeAssignableTo(getRestrictiveInstantiation(checkType), getRestrictiveInstantiation(extendsType))) {
	          return getSimplifiedType(trueType2, writing);
	        } else if (isIntersectionEmpty(checkType, extendsType)) {
	          return neverType;
	        }
	      } else if (trueType2.flags & 131072 /* Never */ && getActualTypeVariable(falseType2) === getActualTypeVariable(checkType)) {
	        if (!(checkType.flags & 1 /* Any */) && isTypeAssignableTo(getRestrictiveInstantiation(checkType), getRestrictiveInstantiation(extendsType))) {
	          return neverType;
	        } else if (checkType.flags & 1 /* Any */ || isIntersectionEmpty(checkType, extendsType)) {
	          return getSimplifiedType(falseType2, writing);
	        }
	      }
	      return type;
	    }
	    function isIntersectionEmpty(type1, type2) {
	      return !!(getUnionType([intersectTypes(type1, type2), neverType]).flags & 131072 /* Never */);
	    }
	    function substituteIndexedMappedType(objectType, index) {
	      const mapper = createTypeMapper([getTypeParameterFromMappedType(objectType)], [index]);
	      const templateMapper = combineTypeMappers(objectType.mapper, mapper);
	      return instantiateType(getTemplateTypeFromMappedType(objectType.target || objectType), templateMapper);
	    }
	    function getIndexedAccessType(objectType, indexType, accessFlags = 0 /* None */, accessNode, aliasSymbol, aliasTypeArguments) {
	      return getIndexedAccessTypeOrUndefined(objectType, indexType, accessFlags, accessNode, aliasSymbol, aliasTypeArguments) || (accessNode ? errorType : unknownType);
	    }
	    function indexTypeLessThan(indexType, limit) {
	      return everyType(indexType, (t) => {
	        if (t.flags & 384 /* StringOrNumberLiteral */) {
	          const propName = getPropertyNameFromType(t);
	          if (isNumericLiteralName(propName)) {
	            const index = +propName;
	            return index >= 0 && index < limit;
	          }
	        }
	        return false;
	      });
	    }
	    function getIndexedAccessTypeOrUndefined(objectType, indexType, accessFlags = 0 /* None */, accessNode, aliasSymbol, aliasTypeArguments) {
	      if (objectType === wildcardType || indexType === wildcardType) {
	        return wildcardType;
	      }
	      objectType = getReducedType(objectType);
	      if (isStringIndexSignatureOnlyType(objectType) && !(indexType.flags & 98304 /* Nullable */) && isTypeAssignableToKind(indexType, 4 /* String */ | 8 /* Number */)) {
	        indexType = stringType;
	      }
	      if (compilerOptions.noUncheckedIndexedAccess && accessFlags & 32 /* ExpressionPosition */)
	        accessFlags |= 1 /* IncludeUndefined */;
	      if (isGenericIndexType(indexType) || (accessNode && accessNode.kind !== 199 /* IndexedAccessType */ ? isGenericTupleType(objectType) && !indexTypeLessThan(indexType, getTotalFixedElementCount(objectType.target)) : isGenericObjectType(objectType) && !(isTupleType(objectType) && indexTypeLessThan(indexType, getTotalFixedElementCount(objectType.target))) || isGenericReducibleType(objectType))) {
	        if (objectType.flags & 3 /* AnyOrUnknown */) {
	          return objectType;
	        }
	        const persistentAccessFlags = accessFlags & 1 /* Persistent */;
	        const id = objectType.id + "," + indexType.id + "," + persistentAccessFlags + getAliasId(aliasSymbol, aliasTypeArguments);
	        let type = indexedAccessTypes.get(id);
	        if (!type) {
	          indexedAccessTypes.set(id, type = createIndexedAccessType(objectType, indexType, persistentAccessFlags, aliasSymbol, aliasTypeArguments));
	        }
	        return type;
	      }
	      const apparentObjectType = getReducedApparentType(objectType);
	      if (indexType.flags & 1048576 /* Union */ && !(indexType.flags & 16 /* Boolean */)) {
	        const propTypes = [];
	        let wasMissingProp = false;
	        for (const t of indexType.types) {
	          const propType = getPropertyTypeForIndexType(objectType, apparentObjectType, t, indexType, accessNode, accessFlags | (wasMissingProp ? 128 /* SuppressNoImplicitAnyError */ : 0));
	          if (propType) {
	            propTypes.push(propType);
	          } else if (!accessNode) {
	            return void 0;
	          } else {
	            wasMissingProp = true;
	          }
	        }
	        if (wasMissingProp) {
	          return void 0;
	        }
	        return accessFlags & 4 /* Writing */ ? getIntersectionType(propTypes, aliasSymbol, aliasTypeArguments) : getUnionType(propTypes, 1 /* Literal */, aliasSymbol, aliasTypeArguments);
	      }
	      return getPropertyTypeForIndexType(objectType, apparentObjectType, indexType, indexType, accessNode, accessFlags | 8 /* CacheSymbol */ | 64 /* ReportDeprecated */);
	    }
	    function getTypeFromIndexedAccessTypeNode(node) {
	      const links = getNodeLinks(node);
	      if (!links.resolvedType) {
	        const objectType = getTypeFromTypeNode(node.objectType);
	        const indexType = getTypeFromTypeNode(node.indexType);
	        const potentialAlias = getAliasSymbolForTypeNode(node);
	        links.resolvedType = getIndexedAccessType(objectType, indexType, 0 /* None */, node, potentialAlias, getTypeArgumentsForAliasSymbol(potentialAlias));
	      }
	      return links.resolvedType;
	    }
	    function getTypeFromMappedTypeNode(node) {
	      const links = getNodeLinks(node);
	      if (!links.resolvedType) {
	        const type = createObjectType(32 /* Mapped */, node.symbol);
	        type.declaration = node;
	        type.aliasSymbol = getAliasSymbolForTypeNode(node);
	        type.aliasTypeArguments = getTypeArgumentsForAliasSymbol(type.aliasSymbol);
	        links.resolvedType = type;
	        getConstraintTypeFromMappedType(type);
	      }
	      return links.resolvedType;
	    }
	    function getActualTypeVariable(type) {
	      if (type.flags & 33554432 /* Substitution */) {
	        return getActualTypeVariable(type.baseType);
	      }
	      if (type.flags & 8388608 /* IndexedAccess */ && (type.objectType.flags & 33554432 /* Substitution */ || type.indexType.flags & 33554432 /* Substitution */)) {
	        return getIndexedAccessType(getActualTypeVariable(type.objectType), getActualTypeVariable(type.indexType));
	      }
	      return type;
	    }
	    function isSimpleTupleType(node) {
	      return isTupleTypeNode(node) && length(node.elements) > 0 && !some(node.elements, (e) => isOptionalTypeNode(e) || isRestTypeNode(e) || isNamedTupleMember(e) && !!(e.questionToken || e.dotDotDotToken));
	    }
	    function isDeferredType(type, checkTuples) {
	      return isGenericType(type) || checkTuples && isTupleType(type) && some(getElementTypes(type), isGenericType);
	    }
	    function getConditionalType(root, mapper, forConstraint, aliasSymbol, aliasTypeArguments) {
	      let result;
	      let extraTypes;
	      let tailCount = 0;
	      while (true) {
	        if (tailCount === 1e3) {
	          error2(currentNode, Diagnostics.Type_instantiation_is_excessively_deep_and_possibly_infinite);
	          return errorType;
	        }
	        const checkType = instantiateType(getActualTypeVariable(root.checkType), mapper);
	        const extendsType = instantiateType(root.extendsType, mapper);
	        if (checkType === errorType || extendsType === errorType) {
	          return errorType;
	        }
	        if (checkType === wildcardType || extendsType === wildcardType) {
	          return wildcardType;
	        }
	        const checkTypeNode = skipTypeParentheses(root.node.checkType);
	        const extendsTypeNode = skipTypeParentheses(root.node.extendsType);
	        const checkTuples = isSimpleTupleType(checkTypeNode) && isSimpleTupleType(extendsTypeNode) && length(checkTypeNode.elements) === length(extendsTypeNode.elements);
	        const checkTypeDeferred = isDeferredType(checkType, checkTuples);
	        let combinedMapper;
	        if (root.inferTypeParameters) {
	          const context = createInferenceContext(
	            root.inferTypeParameters,
	            /*signature*/
	            void 0,
	            0 /* None */
	          );
	          if (mapper) {
	            context.nonFixingMapper = combineTypeMappers(context.nonFixingMapper, mapper);
	          }
	          if (!checkTypeDeferred) {
	            inferTypes(context.inferences, checkType, extendsType, 512 /* NoConstraints */ | 1024 /* AlwaysStrict */);
	          }
	          combinedMapper = mapper ? combineTypeMappers(context.mapper, mapper) : context.mapper;
	        }
	        const inferredExtendsType = combinedMapper ? instantiateType(root.extendsType, combinedMapper) : extendsType;
	        if (!checkTypeDeferred && !isDeferredType(inferredExtendsType, checkTuples)) {
	          if (!(inferredExtendsType.flags & 3 /* AnyOrUnknown */) && (checkType.flags & 1 /* Any */ || !isTypeAssignableTo(getPermissiveInstantiation(checkType), getPermissiveInstantiation(inferredExtendsType)))) {
	            if (checkType.flags & 1 /* Any */ || forConstraint && !(inferredExtendsType.flags & 131072 /* Never */) && someType(getPermissiveInstantiation(inferredExtendsType), (t) => isTypeAssignableTo(t, getPermissiveInstantiation(checkType)))) {
	              (extraTypes || (extraTypes = [])).push(instantiateType(getTypeFromTypeNode(root.node.trueType), combinedMapper || mapper));
	            }
	            const falseType2 = getTypeFromTypeNode(root.node.falseType);
	            if (falseType2.flags & 16777216 /* Conditional */) {
	              const newRoot = falseType2.root;
	              if (newRoot.node.parent === root.node && (!newRoot.isDistributive || newRoot.checkType === root.checkType)) {
	                root = newRoot;
	                continue;
	              }
	              if (canTailRecurse(falseType2, mapper)) {
	                continue;
	              }
	            }
	            result = instantiateType(falseType2, mapper);
	            break;
	          }
	          if (inferredExtendsType.flags & 3 /* AnyOrUnknown */ || isTypeAssignableTo(getRestrictiveInstantiation(checkType), getRestrictiveInstantiation(inferredExtendsType))) {
	            const trueType2 = getTypeFromTypeNode(root.node.trueType);
	            const trueMapper = combinedMapper || mapper;
	            if (canTailRecurse(trueType2, trueMapper)) {
	              continue;
	            }
	            result = instantiateType(trueType2, trueMapper);
	            break;
	          }
	        }
	        result = createType(16777216 /* Conditional */);
	        result.root = root;
	        result.checkType = instantiateType(root.checkType, mapper);
	        result.extendsType = instantiateType(root.extendsType, mapper);
	        result.mapper = mapper;
	        result.combinedMapper = combinedMapper;
	        result.aliasSymbol = aliasSymbol || root.aliasSymbol;
	        result.aliasTypeArguments = aliasSymbol ? aliasTypeArguments : instantiateTypes(root.aliasTypeArguments, mapper);
	        break;
	      }
	      return extraTypes ? getUnionType(append(extraTypes, result)) : result;
	      function canTailRecurse(newType, newMapper) {
	        if (newType.flags & 16777216 /* Conditional */ && newMapper) {
	          const newRoot = newType.root;
	          if (newRoot.outerTypeParameters) {
	            const typeParamMapper = combineTypeMappers(newType.mapper, newMapper);
	            const typeArguments = map(newRoot.outerTypeParameters, (t) => getMappedType(t, typeParamMapper));
	            const newRootMapper = createTypeMapper(newRoot.outerTypeParameters, typeArguments);
	            const newCheckType = newRoot.isDistributive ? getMappedType(newRoot.checkType, newRootMapper) : void 0;
	            if (!newCheckType || newCheckType === newRoot.checkType || !(newCheckType.flags & (1048576 /* Union */ | 131072 /* Never */))) {
	              root = newRoot;
	              mapper = newRootMapper;
	              aliasSymbol = void 0;
	              aliasTypeArguments = void 0;
	              if (newRoot.aliasSymbol) {
	                tailCount++;
	              }
	              return true;
	            }
	          }
	        }
	        return false;
	      }
	    }
	    function getTrueTypeFromConditionalType(type) {
	      return type.resolvedTrueType || (type.resolvedTrueType = instantiateType(getTypeFromTypeNode(type.root.node.trueType), type.mapper));
	    }
	    function getFalseTypeFromConditionalType(type) {
	      return type.resolvedFalseType || (type.resolvedFalseType = instantiateType(getTypeFromTypeNode(type.root.node.falseType), type.mapper));
	    }
	    function getInferredTrueTypeFromConditionalType(type) {
	      return type.resolvedInferredTrueType || (type.resolvedInferredTrueType = type.combinedMapper ? instantiateType(getTypeFromTypeNode(type.root.node.trueType), type.combinedMapper) : getTrueTypeFromConditionalType(type));
	    }
	    function getInferTypeParameters(node) {
	      let result;
	      if (node.locals) {
	        node.locals.forEach((symbol) => {
	          if (symbol.flags & 262144 /* TypeParameter */) {
	            result = append(result, getDeclaredTypeOfSymbol(symbol));
	          }
	        });
	      }
	      return result;
	    }
	    function isDistributionDependent(root) {
	      return root.isDistributive && (isTypeParameterPossiblyReferenced(root.checkType, root.node.trueType) || isTypeParameterPossiblyReferenced(root.checkType, root.node.falseType));
	    }
	    function getTypeFromConditionalTypeNode(node) {
	      const links = getNodeLinks(node);
	      if (!links.resolvedType) {
	        const checkType = getTypeFromTypeNode(node.checkType);
	        const aliasSymbol = getAliasSymbolForTypeNode(node);
	        const aliasTypeArguments = getTypeArgumentsForAliasSymbol(aliasSymbol);
	        const allOuterTypeParameters = getOuterTypeParameters(
	          node,
	          /*includeThisTypes*/
	          true
	        );
	        const outerTypeParameters = aliasTypeArguments ? allOuterTypeParameters : filter(allOuterTypeParameters, (tp) => isTypeParameterPossiblyReferenced(tp, node));
	        const root = {
	          node,
	          checkType,
	          extendsType: getTypeFromTypeNode(node.extendsType),
	          isDistributive: !!(checkType.flags & 262144 /* TypeParameter */),
	          inferTypeParameters: getInferTypeParameters(node),
	          outerTypeParameters,
	          instantiations: void 0,
	          aliasSymbol,
	          aliasTypeArguments
	        };
	        links.resolvedType = getConditionalType(
	          root,
	          /*mapper*/
	          void 0,
	          /*forConstraint*/
	          false
	        );
	        if (outerTypeParameters) {
	          root.instantiations = /* @__PURE__ */ new Map();
	          root.instantiations.set(getTypeListId(outerTypeParameters), links.resolvedType);
	        }
	      }
	      return links.resolvedType;
	    }
	    function getTypeFromInferTypeNode(node) {
	      const links = getNodeLinks(node);
	      if (!links.resolvedType) {
	        links.resolvedType = getDeclaredTypeOfTypeParameter(getSymbolOfDeclaration(node.typeParameter));
	      }
	      return links.resolvedType;
	    }
	    function getIdentifierChain(node) {
	      if (isIdentifier(node)) {
	        return [node];
	      } else {
	        return append(getIdentifierChain(node.left), node.right);
	      }
	    }
	    function getTypeFromImportTypeNode(node) {
	      var _a;
	      const links = getNodeLinks(node);
	      if (!links.resolvedType) {
	        if (!isLiteralImportTypeNode(node)) {
	          error2(node.argument, Diagnostics.String_literal_expected);
	          links.resolvedSymbol = unknownSymbol;
	          return links.resolvedType = errorType;
	        }
	        const targetMeaning = node.isTypeOf ? 111551 /* Value */ : node.flags & 16777216 /* JSDoc */ ? 111551 /* Value */ | 788968 /* Type */ : 788968 /* Type */;
	        const innerModuleSymbol = resolveExternalModuleName(node, node.argument.literal);
	        if (!innerModuleSymbol) {
	          links.resolvedSymbol = unknownSymbol;
	          return links.resolvedType = errorType;
	        }
	        const isExportEquals = !!((_a = innerModuleSymbol.exports) == null ? void 0 : _a.get("export=" /* ExportEquals */));
	        const moduleSymbol = resolveExternalModuleSymbol(
	          innerModuleSymbol,
	          /*dontResolveAlias*/
	          false
	        );
	        if (!nodeIsMissing(node.qualifier)) {
	          const nameStack = getIdentifierChain(node.qualifier);
	          let currentNamespace = moduleSymbol;
	          let current;
	          while (current = nameStack.shift()) {
	            const meaning = nameStack.length ? 1920 /* Namespace */ : targetMeaning;
	            const mergedResolvedSymbol = getMergedSymbol(resolveSymbol(currentNamespace));
	            const symbolFromVariable = node.isTypeOf || isInJSFile(node) && isExportEquals ? getPropertyOfType(
	              getTypeOfSymbol(mergedResolvedSymbol),
	              current.escapedText,
	              /*skipObjectFunctionPropertyAugment*/
	              false,
	              /*includeTypeOnlyMembers*/
	              true
	            ) : void 0;
	            const symbolFromModule = node.isTypeOf ? void 0 : getSymbol2(getExportsOfSymbol(mergedResolvedSymbol), current.escapedText, meaning);
	            const next = symbolFromModule ?? symbolFromVariable;
	            if (!next) {
	              error2(current, Diagnostics.Namespace_0_has_no_exported_member_1, getFullyQualifiedName(currentNamespace), declarationNameToString(current));
	              return links.resolvedType = errorType;
	            }
	            getNodeLinks(current).resolvedSymbol = next;
	            getNodeLinks(current.parent).resolvedSymbol = next;
	            currentNamespace = next;
	          }
	          links.resolvedType = resolveImportSymbolType(node, links, currentNamespace, targetMeaning);
	        } else {
	          if (moduleSymbol.flags & targetMeaning) {
	            links.resolvedType = resolveImportSymbolType(node, links, moduleSymbol, targetMeaning);
	          } else {
	            const errorMessage = targetMeaning === 111551 /* Value */ ? Diagnostics.Module_0_does_not_refer_to_a_value_but_is_used_as_a_value_here : Diagnostics.Module_0_does_not_refer_to_a_type_but_is_used_as_a_type_here_Did_you_mean_typeof_import_0;
	            error2(node, errorMessage, node.argument.literal.text);
	            links.resolvedSymbol = unknownSymbol;
	            links.resolvedType = errorType;
	          }
	        }
	      }
	      return links.resolvedType;
	    }
	    function resolveImportSymbolType(node, links, symbol, meaning) {
	      const resolvedSymbol = resolveSymbol(symbol);
	      links.resolvedSymbol = resolvedSymbol;
	      if (meaning === 111551 /* Value */) {
	        return getInstantiationExpressionType(getTypeOfSymbol(symbol), node);
	      } else {
	        return getTypeReferenceType(node, resolvedSymbol);
	      }
	    }
	    function getTypeFromTypeLiteralOrFunctionOrConstructorTypeNode(node) {
	      const links = getNodeLinks(node);
	      if (!links.resolvedType) {
	        const aliasSymbol = getAliasSymbolForTypeNode(node);
	        if (getMembersOfSymbol(node.symbol).size === 0 && !aliasSymbol) {
	          links.resolvedType = emptyTypeLiteralType;
	        } else {
	          let type = createObjectType(16 /* Anonymous */, node.symbol);
	          type.aliasSymbol = aliasSymbol;
	          type.aliasTypeArguments = getTypeArgumentsForAliasSymbol(aliasSymbol);
	          if (isJSDocTypeLiteral(node) && node.isArrayType) {
	            type = createArrayType(type);
	          }
	          links.resolvedType = type;
	        }
	      }
	      return links.resolvedType;
	    }
	    function getAliasSymbolForTypeNode(node) {
	      let host2 = node.parent;
	      while (isParenthesizedTypeNode(host2) || isJSDocTypeExpression(host2) || isTypeOperatorNode(host2) && host2.operator === 148 /* ReadonlyKeyword */) {
	        host2 = host2.parent;
	      }
	      return isTypeAlias(host2) ? getSymbolOfDeclaration(host2) : void 0;
	    }
	    function getTypeArgumentsForAliasSymbol(symbol) {
	      return symbol ? getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(symbol) : void 0;
	    }
	    function isNonGenericObjectType(type) {
	      return !!(type.flags & 524288 /* Object */) && !isGenericMappedType(type);
	    }
	    function isEmptyObjectTypeOrSpreadsIntoEmptyObject(type) {
	      return isEmptyObjectType(type) || !!(type.flags & (65536 /* Null */ | 32768 /* Undefined */ | 528 /* BooleanLike */ | 296 /* NumberLike */ | 2112 /* BigIntLike */ | 402653316 /* StringLike */ | 1056 /* EnumLike */ | 67108864 /* NonPrimitive */ | 4194304 /* Index */));
	    }
	    function tryMergeUnionOfObjectTypeAndEmptyObject(type, readonly) {
	      if (!(type.flags & 1048576 /* Union */)) {
	        return type;
	      }
	      if (every(type.types, isEmptyObjectTypeOrSpreadsIntoEmptyObject)) {
	        return find(type.types, isEmptyObjectType) || emptyObjectType;
	      }
	      const firstType = find(type.types, (t) => !isEmptyObjectTypeOrSpreadsIntoEmptyObject(t));
	      if (!firstType) {
	        return type;
	      }
	      const secondType = find(type.types, (t) => t !== firstType && !isEmptyObjectTypeOrSpreadsIntoEmptyObject(t));
	      if (secondType) {
	        return type;
	      }
	      return getAnonymousPartialType(firstType);
	      function getAnonymousPartialType(type2) {
	        const members = createSymbolTable();
	        for (const prop of getPropertiesOfType(type2)) {
	          if (getDeclarationModifierFlagsFromSymbol(prop) & (2 /* Private */ | 4 /* Protected */)) ; else if (isSpreadableProperty(prop)) {
	            const isSetonlyAccessor = prop.flags & 65536 /* SetAccessor */ && !(prop.flags & 32768 /* GetAccessor */);
	            const flags = 4 /* Property */ | 16777216 /* Optional */;
	            const result = createSymbol(flags, prop.escapedName, getIsLateCheckFlag(prop) | (readonly ? 8 /* Readonly */ : 0));
	            result.links.type = isSetonlyAccessor ? undefinedType : addOptionality(
	              getTypeOfSymbol(prop),
	              /*isProperty*/
	              true
	            );
	            result.declarations = prop.declarations;
	            result.links.nameType = getSymbolLinks(prop).nameType;
	            result.links.syntheticOrigin = prop;
	            members.set(prop.escapedName, result);
	          }
	        }
	        const spread = createAnonymousType(type2.symbol, members, emptyArray, emptyArray, getIndexInfosOfType(type2));
	        spread.objectFlags |= 128 /* ObjectLiteral */ | 131072 /* ContainsObjectOrArrayLiteral */;
	        return spread;
	      }
	    }
	    function getSpreadType(left, right, symbol, objectFlags, readonly) {
	      if (left.flags & 1 /* Any */ || right.flags & 1 /* Any */) {
	        return anyType;
	      }
	      if (left.flags & 2 /* Unknown */ || right.flags & 2 /* Unknown */) {
	        return unknownType;
	      }
	      if (left.flags & 131072 /* Never */) {
	        return right;
	      }
	      if (right.flags & 131072 /* Never */) {
	        return left;
	      }
	      left = tryMergeUnionOfObjectTypeAndEmptyObject(left, readonly);
	      if (left.flags & 1048576 /* Union */) {
	        return checkCrossProductUnion([left, right]) ? mapType(left, (t) => getSpreadType(t, right, symbol, objectFlags, readonly)) : errorType;
	      }
	      right = tryMergeUnionOfObjectTypeAndEmptyObject(right, readonly);
	      if (right.flags & 1048576 /* Union */) {
	        return checkCrossProductUnion([left, right]) ? mapType(right, (t) => getSpreadType(left, t, symbol, objectFlags, readonly)) : errorType;
	      }
	      if (right.flags & (528 /* BooleanLike */ | 296 /* NumberLike */ | 2112 /* BigIntLike */ | 402653316 /* StringLike */ | 1056 /* EnumLike */ | 67108864 /* NonPrimitive */ | 4194304 /* Index */)) {
	        return left;
	      }
	      if (isGenericObjectType(left) || isGenericObjectType(right)) {
	        if (isEmptyObjectType(left)) {
	          return right;
	        }
	        if (left.flags & 2097152 /* Intersection */) {
	          const types = left.types;
	          const lastLeft = types[types.length - 1];
	          if (isNonGenericObjectType(lastLeft) && isNonGenericObjectType(right)) {
	            return getIntersectionType(concatenate(types.slice(0, types.length - 1), [getSpreadType(lastLeft, right, symbol, objectFlags, readonly)]));
	          }
	        }
	        return getIntersectionType([left, right]);
	      }
	      const members = createSymbolTable();
	      const skippedPrivateMembers = /* @__PURE__ */ new Set();
	      const indexInfos = left === emptyObjectType ? getIndexInfosOfType(right) : getUnionIndexInfos([left, right]);
	      for (const rightProp of getPropertiesOfType(right)) {
	        if (getDeclarationModifierFlagsFromSymbol(rightProp) & (2 /* Private */ | 4 /* Protected */)) {
	          skippedPrivateMembers.add(rightProp.escapedName);
	        } else if (isSpreadableProperty(rightProp)) {
	          members.set(rightProp.escapedName, getSpreadSymbol(rightProp, readonly));
	        }
	      }
	      for (const leftProp of getPropertiesOfType(left)) {
	        if (skippedPrivateMembers.has(leftProp.escapedName) || !isSpreadableProperty(leftProp)) {
	          continue;
	        }
	        if (members.has(leftProp.escapedName)) {
	          const rightProp = members.get(leftProp.escapedName);
	          const rightType = getTypeOfSymbol(rightProp);
	          if (rightProp.flags & 16777216 /* Optional */) {
	            const declarations = concatenate(leftProp.declarations, rightProp.declarations);
	            const flags = 4 /* Property */ | leftProp.flags & 16777216 /* Optional */;
	            const result = createSymbol(flags, leftProp.escapedName);
	            const leftType = getTypeOfSymbol(leftProp);
	            const leftTypeWithoutUndefined = removeMissingOrUndefinedType(leftType);
	            const rightTypeWithoutUndefined = removeMissingOrUndefinedType(rightType);
	            result.links.type = leftTypeWithoutUndefined === rightTypeWithoutUndefined ? leftType : getUnionType([leftType, rightTypeWithoutUndefined], 2 /* Subtype */);
	            result.links.leftSpread = leftProp;
	            result.links.rightSpread = rightProp;
	            result.declarations = declarations;
	            result.links.nameType = getSymbolLinks(leftProp).nameType;
	            members.set(leftProp.escapedName, result);
	          }
	        } else {
	          members.set(leftProp.escapedName, getSpreadSymbol(leftProp, readonly));
	        }
	      }
	      const spread = createAnonymousType(symbol, members, emptyArray, emptyArray, sameMap(indexInfos, (info) => getIndexInfoWithReadonly(info, readonly)));
	      spread.objectFlags |= 128 /* ObjectLiteral */ | 131072 /* ContainsObjectOrArrayLiteral */ | 2097152 /* ContainsSpread */ | objectFlags;
	      return spread;
	    }
	    function isSpreadableProperty(prop) {
	      var _a;
	      return !some(prop.declarations, isPrivateIdentifierClassElementDeclaration) && (!(prop.flags & (8192 /* Method */ | 32768 /* GetAccessor */ | 65536 /* SetAccessor */)) || !((_a = prop.declarations) == null ? void 0 : _a.some((decl) => isClassLike(decl.parent))));
	    }
	    function getSpreadSymbol(prop, readonly) {
	      const isSetonlyAccessor = prop.flags & 65536 /* SetAccessor */ && !(prop.flags & 32768 /* GetAccessor */);
	      if (!isSetonlyAccessor && readonly === isReadonlySymbol(prop)) {
	        return prop;
	      }
	      const flags = 4 /* Property */ | prop.flags & 16777216 /* Optional */;
	      const result = createSymbol(flags, prop.escapedName, getIsLateCheckFlag(prop) | (readonly ? 8 /* Readonly */ : 0));
	      result.links.type = isSetonlyAccessor ? undefinedType : getTypeOfSymbol(prop);
	      result.declarations = prop.declarations;
	      result.links.nameType = getSymbolLinks(prop).nameType;
	      result.links.syntheticOrigin = prop;
	      return result;
	    }
	    function getIndexInfoWithReadonly(info, readonly) {
	      return info.isReadonly !== readonly ? createIndexInfo(info.keyType, info.type, readonly, info.declaration) : info;
	    }
	    function createLiteralType(flags, value, symbol, regularType) {
	      const type = createTypeWithSymbol(flags, symbol);
	      type.value = value;
	      type.regularType = regularType || type;
	      return type;
	    }
	    function getFreshTypeOfLiteralType(type) {
	      if (type.flags & 2976 /* Freshable */) {
	        if (!type.freshType) {
	          const freshType = createLiteralType(type.flags, type.value, type.symbol, type);
	          freshType.freshType = freshType;
	          type.freshType = freshType;
	        }
	        return type.freshType;
	      }
	      return type;
	    }
	    function getRegularTypeOfLiteralType(type) {
	      return type.flags & 2976 /* Freshable */ ? type.regularType : type.flags & 1048576 /* Union */ ? type.regularType || (type.regularType = mapType(type, getRegularTypeOfLiteralType)) : type;
	    }
	    function isFreshLiteralType(type) {
	      return !!(type.flags & 2976 /* Freshable */) && type.freshType === type;
	    }
	    function getStringLiteralType(value) {
	      let type;
	      return stringLiteralTypes.get(value) || (stringLiteralTypes.set(value, type = createLiteralType(128 /* StringLiteral */, value)), type);
	    }
	    function getNumberLiteralType(value) {
	      let type;
	      return numberLiteralTypes.get(value) || (numberLiteralTypes.set(value, type = createLiteralType(256 /* NumberLiteral */, value)), type);
	    }
	    function getBigIntLiteralType(value) {
	      let type;
	      const key = pseudoBigIntToString(value);
	      return bigIntLiteralTypes.get(key) || (bigIntLiteralTypes.set(key, type = createLiteralType(2048 /* BigIntLiteral */, value)), type);
	    }
	    function getEnumLiteralType(value, enumId, symbol) {
	      let type;
	      const key = `${enumId}${typeof value === "string" ? "@" : "#"}${value}`;
	      const flags = 1024 /* EnumLiteral */ | (typeof value === "string" ? 128 /* StringLiteral */ : 256 /* NumberLiteral */);
	      return enumLiteralTypes.get(key) || (enumLiteralTypes.set(key, type = createLiteralType(flags, value, symbol)), type);
	    }
	    function getTypeFromLiteralTypeNode(node) {
	      if (node.literal.kind === 106 /* NullKeyword */) {
	        return nullType;
	      }
	      const links = getNodeLinks(node);
	      if (!links.resolvedType) {
	        links.resolvedType = getRegularTypeOfLiteralType(checkExpression(node.literal));
	      }
	      return links.resolvedType;
	    }
	    function createUniqueESSymbolType(symbol) {
	      const type = createTypeWithSymbol(8192 /* UniqueESSymbol */, symbol);
	      type.escapedName = `__@${type.symbol.escapedName}@${getSymbolId(type.symbol)}`;
	      return type;
	    }
	    function getESSymbolLikeTypeForNode(node) {
	      if (isInJSFile(node) && isJSDocTypeExpression(node)) {
	        const host2 = getJSDocHost(node);
	        if (host2) {
	          node = getSingleVariableOfVariableStatement(host2) || host2;
	        }
	      }
	      if (isValidESSymbolDeclaration(node)) {
	        const symbol = isCommonJsExportPropertyAssignment(node) ? getSymbolOfNode(node.left) : getSymbolOfNode(node);
	        if (symbol) {
	          const links = getSymbolLinks(symbol);
	          return links.uniqueESSymbolType || (links.uniqueESSymbolType = createUniqueESSymbolType(symbol));
	        }
	      }
	      return esSymbolType;
	    }
	    function getThisType(node) {
	      const container = getThisContainer(
	        node,
	        /*includeArrowFunctions*/
	        false,
	        /*includeClassComputedPropertyName*/
	        false
	      );
	      const parent2 = container && container.parent;
	      if (parent2 && (isClassLike(parent2) || parent2.kind === 264 /* InterfaceDeclaration */)) {
	        if (!isStatic(container) && (!isConstructorDeclaration(container) || isNodeDescendantOf(node, container.body))) {
	          return getDeclaredTypeOfClassOrInterface(getSymbolOfDeclaration(parent2)).thisType;
	        }
	      }
	      if (parent2 && isObjectLiteralExpression(parent2) && isBinaryExpression(parent2.parent) && getAssignmentDeclarationKind(parent2.parent) === 6 /* Prototype */) {
	        return getDeclaredTypeOfClassOrInterface(getSymbolOfNode(parent2.parent.left).parent).thisType;
	      }
	      const host2 = node.flags & 16777216 /* JSDoc */ ? getHostSignatureFromJSDoc(node) : void 0;
	      if (host2 && isFunctionExpression(host2) && isBinaryExpression(host2.parent) && getAssignmentDeclarationKind(host2.parent) === 3 /* PrototypeProperty */) {
	        return getDeclaredTypeOfClassOrInterface(getSymbolOfNode(host2.parent.left).parent).thisType;
	      }
	      if (isJSConstructor(container) && isNodeDescendantOf(node, container.body)) {
	        return getDeclaredTypeOfClassOrInterface(getSymbolOfDeclaration(container)).thisType;
	      }
	      error2(node, Diagnostics.A_this_type_is_available_only_in_a_non_static_member_of_a_class_or_interface);
	      return errorType;
	    }
	    function getTypeFromThisTypeNode(node) {
	      const links = getNodeLinks(node);
	      if (!links.resolvedType) {
	        links.resolvedType = getThisType(node);
	      }
	      return links.resolvedType;
	    }
	    function getTypeFromRestTypeNode(node) {
	      return getTypeFromTypeNode(getArrayElementTypeNode(node.type) || node.type);
	    }
	    function getArrayElementTypeNode(node) {
	      switch (node.kind) {
	        case 196 /* ParenthesizedType */:
	          return getArrayElementTypeNode(node.type);
	        case 189 /* TupleType */:
	          if (node.elements.length === 1) {
	            node = node.elements[0];
	            if (node.kind === 191 /* RestType */ || node.kind === 202 /* NamedTupleMember */ && node.dotDotDotToken) {
	              return getArrayElementTypeNode(node.type);
	            }
	          }
	          break;
	        case 188 /* ArrayType */:
	          return node.elementType;
	      }
	      return void 0;
	    }
	    function getTypeFromNamedTupleTypeNode(node) {
	      const links = getNodeLinks(node);
	      return links.resolvedType || (links.resolvedType = node.dotDotDotToken ? getTypeFromRestTypeNode(node) : addOptionality(
	        getTypeFromTypeNode(node.type),
	        /*isProperty*/
	        true,
	        !!node.questionToken
	      ));
	    }
	    function getTypeFromTypeNode(node) {
	      return getConditionalFlowTypeOfType(getTypeFromTypeNodeWorker(node), node);
	    }
	    function getTypeFromTypeNodeWorker(node) {
	      switch (node.kind) {
	        case 133 /* AnyKeyword */:
	        case 319 /* JSDocAllType */:
	        case 320 /* JSDocUnknownType */:
	          return anyType;
	        case 159 /* UnknownKeyword */:
	          return unknownType;
	        case 154 /* StringKeyword */:
	          return stringType;
	        case 150 /* NumberKeyword */:
	          return numberType;
	        case 163 /* BigIntKeyword */:
	          return bigintType;
	        case 136 /* BooleanKeyword */:
	          return booleanType;
	        case 155 /* SymbolKeyword */:
	          return esSymbolType;
	        case 116 /* VoidKeyword */:
	          return voidType;
	        case 157 /* UndefinedKeyword */:
	          return undefinedType;
	        case 106 /* NullKeyword */:
	          return nullType;
	        case 146 /* NeverKeyword */:
	          return neverType;
	        case 151 /* ObjectKeyword */:
	          return node.flags & 524288 /* JavaScriptFile */ && !noImplicitAny ? anyType : nonPrimitiveType;
	        case 141 /* IntrinsicKeyword */:
	          return intrinsicMarkerType;
	        case 197 /* ThisType */:
	        case 110 /* ThisKeyword */:
	          return getTypeFromThisTypeNode(node);
	        case 201 /* LiteralType */:
	          return getTypeFromLiteralTypeNode(node);
	        case 183 /* TypeReference */:
	          return getTypeFromTypeReference(node);
	        case 182 /* TypePredicate */:
	          return node.assertsModifier ? voidType : booleanType;
	        case 233 /* ExpressionWithTypeArguments */:
	          return getTypeFromTypeReference(node);
	        case 186 /* TypeQuery */:
	          return getTypeFromTypeQueryNode(node);
	        case 188 /* ArrayType */:
	        case 189 /* TupleType */:
	          return getTypeFromArrayOrTupleTypeNode(node);
	        case 190 /* OptionalType */:
	          return getTypeFromOptionalTypeNode(node);
	        case 192 /* UnionType */:
	          return getTypeFromUnionTypeNode(node);
	        case 193 /* IntersectionType */:
	          return getTypeFromIntersectionTypeNode(node);
	        case 321 /* JSDocNullableType */:
	          return getTypeFromJSDocNullableTypeNode(node);
	        case 323 /* JSDocOptionalType */:
	          return addOptionality(getTypeFromTypeNode(node.type));
	        case 202 /* NamedTupleMember */:
	          return getTypeFromNamedTupleTypeNode(node);
	        case 196 /* ParenthesizedType */:
	        case 322 /* JSDocNonNullableType */:
	        case 316 /* JSDocTypeExpression */:
	          return getTypeFromTypeNode(node.type);
	        case 191 /* RestType */:
	          return getTypeFromRestTypeNode(node);
	        case 325 /* JSDocVariadicType */:
	          return getTypeFromJSDocVariadicType(node);
	        case 184 /* FunctionType */:
	        case 185 /* ConstructorType */:
	        case 187 /* TypeLiteral */:
	        case 329 /* JSDocTypeLiteral */:
	        case 324 /* JSDocFunctionType */:
	        case 330 /* JSDocSignature */:
	          return getTypeFromTypeLiteralOrFunctionOrConstructorTypeNode(node);
	        case 198 /* TypeOperator */:
	          return getTypeFromTypeOperatorNode(node);
	        case 199 /* IndexedAccessType */:
	          return getTypeFromIndexedAccessTypeNode(node);
	        case 200 /* MappedType */:
	          return getTypeFromMappedTypeNode(node);
	        case 194 /* ConditionalType */:
	          return getTypeFromConditionalTypeNode(node);
	        case 195 /* InferType */:
	          return getTypeFromInferTypeNode(node);
	        case 203 /* TemplateLiteralType */:
	          return getTypeFromTemplateTypeNode(node);
	        case 205 /* ImportType */:
	          return getTypeFromImportTypeNode(node);
	        case 80 /* Identifier */:
	        case 166 /* QualifiedName */:
	        case 211 /* PropertyAccessExpression */:
	          const symbol = getSymbolAtLocation(node);
	          return symbol ? getDeclaredTypeOfSymbol(symbol) : errorType;
	        default:
	          return errorType;
	      }
	    }
	    function instantiateList(items, mapper, instantiator) {
	      if (items && items.length) {
	        for (let i = 0; i < items.length; i++) {
	          const item = items[i];
	          const mapped = instantiator(item, mapper);
	          if (item !== mapped) {
	            const result = i === 0 ? [] : items.slice(0, i);
	            result.push(mapped);
	            for (i++; i < items.length; i++) {
	              result.push(instantiator(items[i], mapper));
	            }
	            return result;
	          }
	        }
	      }
	      return items;
	    }
	    function instantiateTypes(types, mapper) {
	      return instantiateList(types, mapper, instantiateType);
	    }
	    function instantiateSignatures(signatures, mapper) {
	      return instantiateList(signatures, mapper, instantiateSignature);
	    }
	    function instantiateIndexInfos(indexInfos, mapper) {
	      return instantiateList(indexInfos, mapper, instantiateIndexInfo);
	    }
	    function createTypeMapper(sources, targets) {
	      return sources.length === 1 ? makeUnaryTypeMapper(sources[0], targets ? targets[0] : anyType) : makeArrayTypeMapper(sources, targets);
	    }
	    function getMappedType(type, mapper) {
	      switch (mapper.kind) {
	        case 0 /* Simple */:
	          return type === mapper.source ? mapper.target : type;
	        case 1 /* Array */: {
	          const sources = mapper.sources;
	          const targets = mapper.targets;
	          for (let i = 0; i < sources.length; i++) {
	            if (type === sources[i]) {
	              return targets ? targets[i] : anyType;
	            }
	          }
	          return type;
	        }
	        case 2 /* Deferred */: {
	          const sources = mapper.sources;
	          const targets = mapper.targets;
	          for (let i = 0; i < sources.length; i++) {
	            if (type === sources[i]) {
	              return targets[i]();
	            }
	          }
	          return type;
	        }
	        case 3 /* Function */:
	          return mapper.func(type);
	        case 4 /* Composite */:
	        case 5 /* Merged */:
	          const t1 = getMappedType(type, mapper.mapper1);
	          return t1 !== type && mapper.kind === 4 /* Composite */ ? instantiateType(t1, mapper.mapper2) : getMappedType(t1, mapper.mapper2);
	      }
	    }
	    function makeUnaryTypeMapper(source, target) {
	      return Debug.attachDebugPrototypeIfDebug({ kind: 0 /* Simple */, source, target });
	    }
	    function makeArrayTypeMapper(sources, targets) {
	      return Debug.attachDebugPrototypeIfDebug({ kind: 1 /* Array */, sources, targets });
	    }
	    function makeFunctionTypeMapper(func, debugInfo) {
	      return Debug.attachDebugPrototypeIfDebug({ kind: 3 /* Function */, func, debugInfo: Debug.isDebugging ? debugInfo : void 0 });
	    }
	    function makeDeferredTypeMapper(sources, targets) {
	      return Debug.attachDebugPrototypeIfDebug({ kind: 2 /* Deferred */, sources, targets });
	    }
	    function makeCompositeTypeMapper(kind, mapper1, mapper2) {
	      return Debug.attachDebugPrototypeIfDebug({ kind, mapper1, mapper2 });
	    }
	    function createTypeEraser(sources) {
	      return createTypeMapper(
	        sources,
	        /*targets*/
	        void 0
	      );
	    }
	    function createBackreferenceMapper(context, index) {
	      const forwardInferences = context.inferences.slice(index);
	      return createTypeMapper(map(forwardInferences, (i) => i.typeParameter), map(forwardInferences, () => unknownType));
	    }
	    function combineTypeMappers(mapper1, mapper2) {
	      return mapper1 ? makeCompositeTypeMapper(4 /* Composite */, mapper1, mapper2) : mapper2;
	    }
	    function mergeTypeMappers(mapper1, mapper2) {
	      return mapper1 ? makeCompositeTypeMapper(5 /* Merged */, mapper1, mapper2) : mapper2;
	    }
	    function prependTypeMapping(source, target, mapper) {
	      return !mapper ? makeUnaryTypeMapper(source, target) : makeCompositeTypeMapper(5 /* Merged */, makeUnaryTypeMapper(source, target), mapper);
	    }
	    function appendTypeMapping(mapper, source, target) {
	      return !mapper ? makeUnaryTypeMapper(source, target) : makeCompositeTypeMapper(5 /* Merged */, mapper, makeUnaryTypeMapper(source, target));
	    }
	    function getRestrictiveTypeParameter(tp) {
	      return !tp.constraint && !getConstraintDeclaration(tp) || tp.constraint === noConstraintType ? tp : tp.restrictiveInstantiation || (tp.restrictiveInstantiation = createTypeParameter(tp.symbol), tp.restrictiveInstantiation.constraint = noConstraintType, tp.restrictiveInstantiation);
	    }
	    function cloneTypeParameter(typeParameter) {
	      const result = createTypeParameter(typeParameter.symbol);
	      result.target = typeParameter;
	      return result;
	    }
	    function instantiateTypePredicate(predicate, mapper) {
	      return createTypePredicate(predicate.kind, predicate.parameterName, predicate.parameterIndex, instantiateType(predicate.type, mapper));
	    }
	    function instantiateSignature(signature, mapper, eraseTypeParameters) {
	      let freshTypeParameters;
	      if (signature.typeParameters && !eraseTypeParameters) {
	        freshTypeParameters = map(signature.typeParameters, cloneTypeParameter);
	        mapper = combineTypeMappers(createTypeMapper(signature.typeParameters, freshTypeParameters), mapper);
	        for (const tp of freshTypeParameters) {
	          tp.mapper = mapper;
	        }
	      }
	      const result = createSignature(
	        signature.declaration,
	        freshTypeParameters,
	        signature.thisParameter && instantiateSymbol(signature.thisParameter, mapper),
	        instantiateList(signature.parameters, mapper, instantiateSymbol),
	        /*resolvedReturnType*/
	        void 0,
	        /*resolvedTypePredicate*/
	        void 0,
	        signature.minArgumentCount,
	        signature.flags & 167 /* PropagatingFlags */
	      );
	      result.target = signature;
	      result.mapper = mapper;
	      return result;
	    }
	    function instantiateSymbol(symbol, mapper) {
	      const links = getSymbolLinks(symbol);
	      if (links.type && !couldContainTypeVariables(links.type)) {
	        if (!(symbol.flags & 65536 /* SetAccessor */)) {
	          return symbol;
	        }
	        if (links.writeType && !couldContainTypeVariables(links.writeType)) {
	          return symbol;
	        }
	      }
	      if (getCheckFlags(symbol) & 1 /* Instantiated */) {
	        symbol = links.target;
	        mapper = combineTypeMappers(links.mapper, mapper);
	      }
	      const result = createSymbol(symbol.flags, symbol.escapedName, 1 /* Instantiated */ | getCheckFlags(symbol) & (8 /* Readonly */ | 4096 /* Late */ | 16384 /* OptionalParameter */ | 32768 /* RestParameter */));
	      result.declarations = symbol.declarations;
	      result.parent = symbol.parent;
	      result.links.target = symbol;
	      result.links.mapper = mapper;
	      if (symbol.valueDeclaration) {
	        result.valueDeclaration = symbol.valueDeclaration;
	      }
	      if (links.nameType) {
	        result.links.nameType = links.nameType;
	      }
	      return result;
	    }
	    function getObjectTypeInstantiation(type, mapper, aliasSymbol, aliasTypeArguments) {
	      const declaration = type.objectFlags & 4 /* Reference */ ? type.node : type.objectFlags & 8388608 /* InstantiationExpressionType */ ? type.node : type.symbol.declarations[0];
	      const links = getNodeLinks(declaration);
	      const target = type.objectFlags & 4 /* Reference */ ? links.resolvedType : type.objectFlags & 64 /* Instantiated */ ? type.target : type;
	      let typeParameters = links.outerTypeParameters;
	      if (!typeParameters) {
	        let outerTypeParameters = getOuterTypeParameters(
	          declaration,
	          /*includeThisTypes*/
	          true
	        );
	        if (isJSConstructor(declaration)) {
	          const templateTagParameters = getTypeParametersFromDeclaration(declaration);
	          outerTypeParameters = addRange(outerTypeParameters, templateTagParameters);
	        }
	        typeParameters = outerTypeParameters || emptyArray;
	        const allDeclarations = type.objectFlags & (4 /* Reference */ | 8388608 /* InstantiationExpressionType */) ? [declaration] : type.symbol.declarations;
	        typeParameters = (target.objectFlags & (4 /* Reference */ | 8388608 /* InstantiationExpressionType */) || target.symbol.flags & 8192 /* Method */ || target.symbol.flags & 2048 /* TypeLiteral */) && !target.aliasTypeArguments ? filter(typeParameters, (tp) => some(allDeclarations, (d) => isTypeParameterPossiblyReferenced(tp, d))) : typeParameters;
	        links.outerTypeParameters = typeParameters;
	      }
	      if (typeParameters.length) {
	        const combinedMapper = combineTypeMappers(type.mapper, mapper);
	        const typeArguments = map(typeParameters, (t) => getMappedType(t, combinedMapper));
	        const newAliasSymbol = aliasSymbol || type.aliasSymbol;
	        const newAliasTypeArguments = aliasSymbol ? aliasTypeArguments : instantiateTypes(type.aliasTypeArguments, mapper);
	        const id = getTypeListId(typeArguments) + getAliasId(newAliasSymbol, newAliasTypeArguments);
	        if (!target.instantiations) {
	          target.instantiations = /* @__PURE__ */ new Map();
	          target.instantiations.set(getTypeListId(typeParameters) + getAliasId(target.aliasSymbol, target.aliasTypeArguments), target);
	        }
	        let result = target.instantiations.get(id);
	        if (!result) {
	          const newMapper = createTypeMapper(typeParameters, typeArguments);
	          result = target.objectFlags & 4 /* Reference */ ? createDeferredTypeReference(type.target, type.node, newMapper, newAliasSymbol, newAliasTypeArguments) : target.objectFlags & 32 /* Mapped */ ? instantiateMappedType(target, newMapper, newAliasSymbol, newAliasTypeArguments) : instantiateAnonymousType(target, newMapper, newAliasSymbol, newAliasTypeArguments);
	          target.instantiations.set(id, result);
	          const resultObjectFlags = getObjectFlags(result);
	          if (result.flags & 3899393 /* ObjectFlagsType */ && !(resultObjectFlags & 524288 /* CouldContainTypeVariablesComputed */)) {
	            const resultCouldContainTypeVariables = some(typeArguments, couldContainTypeVariables);
	            if (!(getObjectFlags(result) & 524288 /* CouldContainTypeVariablesComputed */)) {
	              if (resultObjectFlags & (32 /* Mapped */ | 16 /* Anonymous */ | 4 /* Reference */)) {
	                result.objectFlags |= 524288 /* CouldContainTypeVariablesComputed */ | (resultCouldContainTypeVariables ? 1048576 /* CouldContainTypeVariables */ : 0);
	              } else {
	                result.objectFlags |= !resultCouldContainTypeVariables ? 524288 /* CouldContainTypeVariablesComputed */ : 0;
	              }
	            }
	          }
	        }
	        return result;
	      }
	      return type;
	    }
	    function maybeTypeParameterReference(node) {
	      return !(node.parent.kind === 183 /* TypeReference */ && node.parent.typeArguments && node === node.parent.typeName || node.parent.kind === 205 /* ImportType */ && node.parent.typeArguments && node === node.parent.qualifier);
	    }
	    function isTypeParameterPossiblyReferenced(tp, node) {
	      if (tp.symbol && tp.symbol.declarations && tp.symbol.declarations.length === 1) {
	        const container = tp.symbol.declarations[0].parent;
	        for (let n = node; n !== container; n = n.parent) {
	          if (!n || n.kind === 241 /* Block */ || n.kind === 194 /* ConditionalType */ && forEachChild(n.extendsType, containsReference)) {
	            return true;
	          }
	        }
	        return containsReference(node);
	      }
	      return true;
	      function containsReference(node2) {
	        switch (node2.kind) {
	          case 197 /* ThisType */:
	            return !!tp.isThisType;
	          case 80 /* Identifier */:
	            return !tp.isThisType && isPartOfTypeNode(node2) && maybeTypeParameterReference(node2) && getTypeFromTypeNodeWorker(node2) === tp;
	          case 186 /* TypeQuery */:
	            const entityName = node2.exprName;
	            const firstIdentifier = getFirstIdentifier(entityName);
	            if (!isThisIdentifier(firstIdentifier)) {
	              const firstIdentifierSymbol = getResolvedSymbol(firstIdentifier);
	              const tpDeclaration = tp.symbol.declarations[0];
	              const tpScope = tpDeclaration.kind === 168 /* TypeParameter */ ? tpDeclaration.parent : (
	                // Type parameter is a regular type parameter, e.g. foo<T>
	                tp.isThisType ? tpDeclaration : (
	                  // Type parameter is the this type, and its declaration is the class declaration.
	                  void 0
	                )
	              );
	              if (firstIdentifierSymbol.declarations && tpScope) {
	                return some(firstIdentifierSymbol.declarations, (idDecl) => isNodeDescendantOf(idDecl, tpScope)) || some(node2.typeArguments, containsReference);
	              }
	            }
	            return true;
	          case 174 /* MethodDeclaration */:
	          case 173 /* MethodSignature */:
	            return !node2.type && !!node2.body || some(node2.typeParameters, containsReference) || some(node2.parameters, containsReference) || !!node2.type && containsReference(node2.type);
	        }
	        return !!forEachChild(node2, containsReference);
	      }
	    }
	    function getHomomorphicTypeVariable(type) {
	      const constraintType = getConstraintTypeFromMappedType(type);
	      if (constraintType.flags & 4194304 /* Index */) {
	        const typeVariable = getActualTypeVariable(constraintType.type);
	        if (typeVariable.flags & 262144 /* TypeParameter */) {
	          return typeVariable;
	        }
	      }
	      return void 0;
	    }
	    function instantiateMappedType(type, mapper, aliasSymbol, aliasTypeArguments) {
	      const typeVariable = getHomomorphicTypeVariable(type);
	      if (typeVariable) {
	        const mappedTypeVariable = instantiateType(typeVariable, mapper);
	        if (typeVariable !== mappedTypeVariable) {
	          return mapTypeWithAlias(getReducedType(mappedTypeVariable), instantiateConstituent, aliasSymbol, aliasTypeArguments);
	        }
	      }
	      return instantiateType(getConstraintTypeFromMappedType(type), mapper) === wildcardType ? wildcardType : instantiateAnonymousType(type, mapper, aliasSymbol, aliasTypeArguments);
	      function instantiateConstituent(t) {
	        if (t.flags & (3 /* AnyOrUnknown */ | 58982400 /* InstantiableNonPrimitive */ | 524288 /* Object */ | 2097152 /* Intersection */) && t !== wildcardType && !isErrorType(t)) {
	          if (!type.declaration.nameType) {
	            let constraint;
	            if (isArrayType(t) || t.flags & 1 /* Any */ && findResolutionCycleStartIndex(typeVariable, 4 /* ImmediateBaseConstraint */) < 0 && (constraint = getConstraintOfTypeParameter(typeVariable)) && everyType(constraint, isArrayOrTupleType)) {
	              return instantiateMappedArrayType(t, type, prependTypeMapping(typeVariable, t, mapper));
	            }
	            if (isTupleType(t)) {
	              return instantiateMappedTupleType(t, type, typeVariable, mapper);
	            }
	            if (isArrayOrTupleOrIntersection(t)) {
	              return getIntersectionType(map(t.types, instantiateConstituent));
	            }
	          }
	          return instantiateAnonymousType(type, prependTypeMapping(typeVariable, t, mapper));
	        }
	        return t;
	      }
	    }
	    function getModifiedReadonlyState(state, modifiers) {
	      return modifiers & 1 /* IncludeReadonly */ ? true : modifiers & 2 /* ExcludeReadonly */ ? false : state;
	    }
	    function instantiateMappedTupleType(tupleType, mappedType, typeVariable, mapper) {
	      const elementFlags = tupleType.target.elementFlags;
	      const fixedLength = tupleType.target.fixedLength;
	      const fixedMapper = fixedLength ? prependTypeMapping(typeVariable, tupleType, mapper) : mapper;
	      const newElementTypes = map(getElementTypes(tupleType), (type, i) => {
	        const flags = elementFlags[i];
	        return i < fixedLength ? instantiateMappedTypeTemplate(mappedType, getStringLiteralType("" + i), !!(flags & 2 /* Optional */), fixedMapper) : flags & 8 /* Variadic */ ? instantiateType(mappedType, prependTypeMapping(typeVariable, type, mapper)) : getElementTypeOfArrayType(instantiateType(mappedType, prependTypeMapping(typeVariable, createArrayType(type), mapper))) ?? unknownType;
	      });
	      const modifiers = getMappedTypeModifiers(mappedType);
	      const newElementFlags = modifiers & 4 /* IncludeOptional */ ? map(elementFlags, (f) => f & 1 /* Required */ ? 2 /* Optional */ : f) : modifiers & 8 /* ExcludeOptional */ ? map(elementFlags, (f) => f & 2 /* Optional */ ? 1 /* Required */ : f) : elementFlags;
	      const newReadonly = getModifiedReadonlyState(tupleType.target.readonly, getMappedTypeModifiers(mappedType));
	      return contains(newElementTypes, errorType) ? errorType : createTupleType(newElementTypes, newElementFlags, newReadonly, tupleType.target.labeledElementDeclarations);
	    }
	    function instantiateMappedArrayType(arrayType, mappedType, mapper) {
	      const elementType = instantiateMappedTypeTemplate(
	        mappedType,
	        numberType,
	        /*isOptional*/
	        true,
	        mapper
	      );
	      return isErrorType(elementType) ? errorType : createArrayType(elementType, getModifiedReadonlyState(isReadonlyArrayType(arrayType), getMappedTypeModifiers(mappedType)));
	    }
	    function instantiateMappedTypeTemplate(type, key, isOptional, mapper) {
	      const templateMapper = appendTypeMapping(mapper, getTypeParameterFromMappedType(type), key);
	      const propType = instantiateType(getTemplateTypeFromMappedType(type.target || type), templateMapper);
	      const modifiers = getMappedTypeModifiers(type);
	      return strictNullChecks && modifiers & 4 /* IncludeOptional */ && !maybeTypeOfKind(propType, 32768 /* Undefined */ | 16384 /* Void */) ? getOptionalType(
	        propType,
	        /*isProperty*/
	        true
	      ) : strictNullChecks && modifiers & 8 /* ExcludeOptional */ && isOptional ? getTypeWithFacts(propType, 524288 /* NEUndefined */) : propType;
	    }
	    function instantiateAnonymousType(type, mapper, aliasSymbol, aliasTypeArguments) {
	      Debug.assert(type.symbol, "anonymous type must have symbol to be instantiated");
	      const result = createObjectType(type.objectFlags & ~(524288 /* CouldContainTypeVariablesComputed */ | 1048576 /* CouldContainTypeVariables */) | 64 /* Instantiated */, type.symbol);
	      if (type.objectFlags & 32 /* Mapped */) {
	        result.declaration = type.declaration;
	        const origTypeParameter = getTypeParameterFromMappedType(type);
	        const freshTypeParameter = cloneTypeParameter(origTypeParameter);
	        result.typeParameter = freshTypeParameter;
	        mapper = combineTypeMappers(makeUnaryTypeMapper(origTypeParameter, freshTypeParameter), mapper);
	        freshTypeParameter.mapper = mapper;
	      }
	      if (type.objectFlags & 8388608 /* InstantiationExpressionType */) {
	        result.node = type.node;
	      }
	      result.target = type;
	      result.mapper = mapper;
	      result.aliasSymbol = aliasSymbol || type.aliasSymbol;
	      result.aliasTypeArguments = aliasSymbol ? aliasTypeArguments : instantiateTypes(type.aliasTypeArguments, mapper);
	      result.objectFlags |= result.aliasTypeArguments ? getPropagatingFlagsOfTypes(result.aliasTypeArguments) : 0;
	      return result;
	    }
	    function getConditionalTypeInstantiation(type, mapper, forConstraint, aliasSymbol, aliasTypeArguments) {
	      const root = type.root;
	      if (root.outerTypeParameters) {
	        const typeArguments = map(root.outerTypeParameters, (t) => getMappedType(t, mapper));
	        const id = (forConstraint ? "C" : "") + getTypeListId(typeArguments) + getAliasId(aliasSymbol, aliasTypeArguments);
	        let result = root.instantiations.get(id);
	        if (!result) {
	          const newMapper = createTypeMapper(root.outerTypeParameters, typeArguments);
	          const checkType = root.checkType;
	          const distributionType = root.isDistributive ? getReducedType(getMappedType(checkType, newMapper)) : void 0;
	          result = distributionType && checkType !== distributionType && distributionType.flags & (1048576 /* Union */ | 131072 /* Never */) ? mapTypeWithAlias(distributionType, (t) => getConditionalType(root, prependTypeMapping(checkType, t, newMapper), forConstraint), aliasSymbol, aliasTypeArguments) : getConditionalType(root, newMapper, forConstraint, aliasSymbol, aliasTypeArguments);
	          root.instantiations.set(id, result);
	        }
	        return result;
	      }
	      return type;
	    }
	    function instantiateType(type, mapper) {
	      return type && mapper ? instantiateTypeWithAlias(
	        type,
	        mapper,
	        /*aliasSymbol*/
	        void 0,
	        /*aliasTypeArguments*/
	        void 0
	      ) : type;
	    }
	    function instantiateTypeWithAlias(type, mapper, aliasSymbol, aliasTypeArguments) {
	      var _a;
	      if (!couldContainTypeVariables(type)) {
	        return type;
	      }
	      if (instantiationDepth === 100 || instantiationCount >= 5e6) {
	        (_a = tracing) == null ? void 0 : _a.instant(tracing.Phase.CheckTypes, "instantiateType_DepthLimit", { typeId: type.id, instantiationDepth, instantiationCount });
	        error2(currentNode, Diagnostics.Type_instantiation_is_excessively_deep_and_possibly_infinite);
	        return errorType;
	      }
	      totalInstantiationCount++;
	      instantiationCount++;
	      instantiationDepth++;
	      const result = instantiateTypeWorker(type, mapper, aliasSymbol, aliasTypeArguments);
	      instantiationDepth--;
	      return result;
	    }
	    function instantiateTypeWorker(type, mapper, aliasSymbol, aliasTypeArguments) {
	      const flags = type.flags;
	      if (flags & 262144 /* TypeParameter */) {
	        return getMappedType(type, mapper);
	      }
	      if (flags & 524288 /* Object */) {
	        const objectFlags = type.objectFlags;
	        if (objectFlags & (4 /* Reference */ | 16 /* Anonymous */ | 32 /* Mapped */)) {
	          if (objectFlags & 4 /* Reference */ && !type.node) {
	            const resolvedTypeArguments = type.resolvedTypeArguments;
	            const newTypeArguments = instantiateTypes(resolvedTypeArguments, mapper);
	            return newTypeArguments !== resolvedTypeArguments ? createNormalizedTypeReference(type.target, newTypeArguments) : type;
	          }
	          if (objectFlags & 1024 /* ReverseMapped */) {
	            return instantiateReverseMappedType(type, mapper);
	          }
	          return getObjectTypeInstantiation(type, mapper, aliasSymbol, aliasTypeArguments);
	        }
	        return type;
	      }
	      if (flags & 3145728 /* UnionOrIntersection */) {
	        const origin = type.flags & 1048576 /* Union */ ? type.origin : void 0;
	        const types = origin && origin.flags & 3145728 /* UnionOrIntersection */ ? origin.types : type.types;
	        const newTypes = instantiateTypes(types, mapper);
	        if (newTypes === types && aliasSymbol === type.aliasSymbol) {
	          return type;
	        }
	        const newAliasSymbol = aliasSymbol || type.aliasSymbol;
	        const newAliasTypeArguments = aliasSymbol ? aliasTypeArguments : instantiateTypes(type.aliasTypeArguments, mapper);
	        return flags & 2097152 /* Intersection */ || origin && origin.flags & 2097152 /* Intersection */ ? getIntersectionType(newTypes, newAliasSymbol, newAliasTypeArguments) : getUnionType(newTypes, 1 /* Literal */, newAliasSymbol, newAliasTypeArguments);
	      }
	      if (flags & 4194304 /* Index */) {
	        return getIndexType(instantiateType(type.type, mapper));
	      }
	      if (flags & 134217728 /* TemplateLiteral */) {
	        return getTemplateLiteralType(type.texts, instantiateTypes(type.types, mapper));
	      }
	      if (flags & 268435456 /* StringMapping */) {
	        return getStringMappingType(type.symbol, instantiateType(type.type, mapper));
	      }
	      if (flags & 8388608 /* IndexedAccess */) {
	        const newAliasSymbol = aliasSymbol || type.aliasSymbol;
	        const newAliasTypeArguments = aliasSymbol ? aliasTypeArguments : instantiateTypes(type.aliasTypeArguments, mapper);
	        return getIndexedAccessType(
	          instantiateType(type.objectType, mapper),
	          instantiateType(type.indexType, mapper),
	          type.accessFlags,
	          /*accessNode*/
	          void 0,
	          newAliasSymbol,
	          newAliasTypeArguments
	        );
	      }
	      if (flags & 16777216 /* Conditional */) {
	        return getConditionalTypeInstantiation(
	          type,
	          combineTypeMappers(type.mapper, mapper),
	          /*forConstraint*/
	          false,
	          aliasSymbol,
	          aliasTypeArguments
	        );
	      }
	      if (flags & 33554432 /* Substitution */) {
	        const newBaseType = instantiateType(type.baseType, mapper);
	        if (isNoInferType(type)) {
	          return getNoInferType(newBaseType);
	        }
	        const newConstraint = instantiateType(type.constraint, mapper);
	        if (newBaseType.flags & 8650752 /* TypeVariable */ && isGenericType(newConstraint)) {
	          return getSubstitutionType(newBaseType, newConstraint);
	        }
	        if (newConstraint.flags & 3 /* AnyOrUnknown */ || isTypeAssignableTo(getRestrictiveInstantiation(newBaseType), getRestrictiveInstantiation(newConstraint))) {
	          return newBaseType;
	        }
	        return newBaseType.flags & 8650752 /* TypeVariable */ ? getSubstitutionType(newBaseType, newConstraint) : getIntersectionType([newConstraint, newBaseType]);
	      }
	      return type;
	    }
	    function instantiateReverseMappedType(type, mapper) {
	      const innerMappedType = instantiateType(type.mappedType, mapper);
	      if (!(getObjectFlags(innerMappedType) & 32 /* Mapped */)) {
	        return type;
	      }
	      const innerIndexType = instantiateType(type.constraintType, mapper);
	      if (!(innerIndexType.flags & 4194304 /* Index */)) {
	        return type;
	      }
	      const instantiated = inferTypeForHomomorphicMappedType(
	        instantiateType(type.source, mapper),
	        innerMappedType,
	        innerIndexType
	      );
	      if (instantiated) {
	        return instantiated;
	      }
	      return type;
	    }
	    function getPermissiveInstantiation(type) {
	      return type.flags & (402784252 /* Primitive */ | 3 /* AnyOrUnknown */ | 131072 /* Never */) ? type : type.permissiveInstantiation || (type.permissiveInstantiation = instantiateType(type, permissiveMapper));
	    }
	    function getRestrictiveInstantiation(type) {
	      if (type.flags & (402784252 /* Primitive */ | 3 /* AnyOrUnknown */ | 131072 /* Never */)) {
	        return type;
	      }
	      if (type.restrictiveInstantiation) {
	        return type.restrictiveInstantiation;
	      }
	      type.restrictiveInstantiation = instantiateType(type, restrictiveMapper);
	      type.restrictiveInstantiation.restrictiveInstantiation = type.restrictiveInstantiation;
	      return type.restrictiveInstantiation;
	    }
	    function instantiateIndexInfo(info, mapper) {
	      return createIndexInfo(info.keyType, instantiateType(info.type, mapper), info.isReadonly, info.declaration);
	    }
	    function isContextSensitive(node) {
	      Debug.assert(node.kind !== 174 /* MethodDeclaration */ || isObjectLiteralMethod(node));
	      switch (node.kind) {
	        case 218 /* FunctionExpression */:
	        case 219 /* ArrowFunction */:
	        case 174 /* MethodDeclaration */:
	        case 262 /* FunctionDeclaration */:
	          return isContextSensitiveFunctionLikeDeclaration(node);
	        case 210 /* ObjectLiteralExpression */:
	          return some(node.properties, isContextSensitive);
	        case 209 /* ArrayLiteralExpression */:
	          return some(node.elements, isContextSensitive);
	        case 227 /* ConditionalExpression */:
	          return isContextSensitive(node.whenTrue) || isContextSensitive(node.whenFalse);
	        case 226 /* BinaryExpression */:
	          return (node.operatorToken.kind === 57 /* BarBarToken */ || node.operatorToken.kind === 61 /* QuestionQuestionToken */) && (isContextSensitive(node.left) || isContextSensitive(node.right));
	        case 303 /* PropertyAssignment */:
	          return isContextSensitive(node.initializer);
	        case 217 /* ParenthesizedExpression */:
	          return isContextSensitive(node.expression);
	        case 292 /* JsxAttributes */:
	          return some(node.properties, isContextSensitive) || isJsxOpeningElement(node.parent) && some(node.parent.parent.children, isContextSensitive);
	        case 291 /* JsxAttribute */: {
	          const { initializer } = node;
	          return !!initializer && isContextSensitive(initializer);
	        }
	        case 294 /* JsxExpression */: {
	          const { expression } = node;
	          return !!expression && isContextSensitive(expression);
	        }
	      }
	      return false;
	    }
	    function isContextSensitiveFunctionLikeDeclaration(node) {
	      return hasContextSensitiveParameters(node) || hasContextSensitiveReturnExpression(node);
	    }
	    function hasContextSensitiveReturnExpression(node) {
	      if (node.typeParameters || getEffectiveReturnTypeNode(node) || !node.body) {
	        return false;
	      }
	      if (node.body.kind !== 241 /* Block */) {
	        return isContextSensitive(node.body);
	      }
	      return !!forEachReturnStatement(node.body, (statement) => !!statement.expression && isContextSensitive(statement.expression));
	    }
	    function isContextSensitiveFunctionOrObjectLiteralMethod(func) {
	      return (isFunctionExpressionOrArrowFunction(func) || isObjectLiteralMethod(func)) && isContextSensitiveFunctionLikeDeclaration(func);
	    }
	    function getTypeWithoutSignatures(type) {
	      if (type.flags & 524288 /* Object */) {
	        const resolved = resolveStructuredTypeMembers(type);
	        if (resolved.constructSignatures.length || resolved.callSignatures.length) {
	          const result = createObjectType(16 /* Anonymous */, type.symbol);
	          result.members = resolved.members;
	          result.properties = resolved.properties;
	          result.callSignatures = emptyArray;
	          result.constructSignatures = emptyArray;
	          result.indexInfos = emptyArray;
	          return result;
	        }
	      } else if (type.flags & 2097152 /* Intersection */) {
	        return getIntersectionType(map(type.types, getTypeWithoutSignatures));
	      }
	      return type;
	    }
	    function isTypeIdenticalTo(source, target) {
	      return isTypeRelatedTo(source, target, identityRelation);
	    }
	    function compareTypesIdentical(source, target) {
	      return isTypeRelatedTo(source, target, identityRelation) ? -1 /* True */ : 0 /* False */;
	    }
	    function compareTypesAssignable(source, target) {
	      return isTypeRelatedTo(source, target, assignableRelation) ? -1 /* True */ : 0 /* False */;
	    }
	    function compareTypesSubtypeOf(source, target) {
	      return isTypeRelatedTo(source, target, subtypeRelation) ? -1 /* True */ : 0 /* False */;
	    }
	    function isTypeSubtypeOf(source, target) {
	      return isTypeRelatedTo(source, target, subtypeRelation);
	    }
	    function isTypeStrictSubtypeOf(source, target) {
	      return isTypeRelatedTo(source, target, strictSubtypeRelation);
	    }
	    function isTypeAssignableTo(source, target) {
	      return isTypeRelatedTo(source, target, assignableRelation);
	    }
	    function isTypeDerivedFrom(source, target) {
	      return source.flags & 1048576 /* Union */ ? every(source.types, (t) => isTypeDerivedFrom(t, target)) : target.flags & 1048576 /* Union */ ? some(target.types, (t) => isTypeDerivedFrom(source, t)) : source.flags & 2097152 /* Intersection */ ? some(source.types, (t) => isTypeDerivedFrom(t, target)) : source.flags & 58982400 /* InstantiableNonPrimitive */ ? isTypeDerivedFrom(getBaseConstraintOfType(source) || unknownType, target) : isEmptyAnonymousObjectType(target) ? !!(source.flags & (524288 /* Object */ | 67108864 /* NonPrimitive */)) : target === globalObjectType ? !!(source.flags & (524288 /* Object */ | 67108864 /* NonPrimitive */)) && !isEmptyAnonymousObjectType(source) : target === globalFunctionType ? !!(source.flags & 524288 /* Object */) && isFunctionObjectType(source) : hasBaseType(source, getTargetType(target)) || isArrayType(target) && !isReadonlyArrayType(target) && isTypeDerivedFrom(source, globalReadonlyArrayType);
	    }
	    function isTypeComparableTo(source, target) {
	      return isTypeRelatedTo(source, target, comparableRelation);
	    }
	    function areTypesComparable(type1, type2) {
	      return isTypeComparableTo(type1, type2) || isTypeComparableTo(type2, type1);
	    }
	    function checkTypeAssignableTo(source, target, errorNode, headMessage, containingMessageChain, errorOutputObject) {
	      return checkTypeRelatedTo(source, target, assignableRelation, errorNode, headMessage, containingMessageChain, errorOutputObject);
	    }
	    function checkTypeAssignableToAndOptionallyElaborate(source, target, errorNode, expr, headMessage, containingMessageChain) {
	      return checkTypeRelatedToAndOptionallyElaborate(
	        source,
	        target,
	        assignableRelation,
	        errorNode,
	        expr,
	        headMessage,
	        containingMessageChain,
	        /*errorOutputContainer*/
	        void 0
	      );
	    }
	    function checkTypeRelatedToAndOptionallyElaborate(source, target, relation, errorNode, expr, headMessage, containingMessageChain, errorOutputContainer) {
	      if (isTypeRelatedTo(source, target, relation))
	        return true;
	      if (!errorNode || !elaborateError(expr, source, target, relation, headMessage, containingMessageChain, errorOutputContainer)) {
	        return checkTypeRelatedTo(source, target, relation, errorNode, headMessage, containingMessageChain, errorOutputContainer);
	      }
	      return false;
	    }
	    function isOrHasGenericConditional(type) {
	      return !!(type.flags & 16777216 /* Conditional */ || type.flags & 2097152 /* Intersection */ && some(type.types, isOrHasGenericConditional));
	    }
	    function elaborateError(node, source, target, relation, headMessage, containingMessageChain, errorOutputContainer) {
	      if (!node || isOrHasGenericConditional(target))
	        return false;
	      if (!checkTypeRelatedTo(
	        source,
	        target,
	        relation,
	        /*errorNode*/
	        void 0
	      ) && elaborateDidYouMeanToCallOrConstruct(node, source, target, relation, headMessage, containingMessageChain, errorOutputContainer)) {
	        return true;
	      }
	      switch (node.kind) {
	        case 234 /* AsExpression */:
	          if (!isConstAssertion(node)) {
	            break;
	          }
	        case 294 /* JsxExpression */:
	        case 217 /* ParenthesizedExpression */:
	          return elaborateError(node.expression, source, target, relation, headMessage, containingMessageChain, errorOutputContainer);
	        case 226 /* BinaryExpression */:
	          switch (node.operatorToken.kind) {
	            case 64 /* EqualsToken */:
	            case 28 /* CommaToken */:
	              return elaborateError(node.right, source, target, relation, headMessage, containingMessageChain, errorOutputContainer);
	          }
	          break;
	        case 210 /* ObjectLiteralExpression */:
	          return elaborateObjectLiteral(node, source, target, relation, containingMessageChain, errorOutputContainer);
	        case 209 /* ArrayLiteralExpression */:
	          return elaborateArrayLiteral(node, source, target, relation, containingMessageChain, errorOutputContainer);
	        case 292 /* JsxAttributes */:
	          return elaborateJsxComponents(node, source, target, relation, containingMessageChain, errorOutputContainer);
	        case 219 /* ArrowFunction */:
	          return elaborateArrowFunction(node, source, target, relation, containingMessageChain, errorOutputContainer);
	      }
	      return false;
	    }
	    function elaborateDidYouMeanToCallOrConstruct(node, source, target, relation, headMessage, containingMessageChain, errorOutputContainer) {
	      const callSignatures = getSignaturesOfType(source, 0 /* Call */);
	      const constructSignatures = getSignaturesOfType(source, 1 /* Construct */);
	      for (const signatures of [constructSignatures, callSignatures]) {
	        if (some(signatures, (s) => {
	          const returnType = getReturnTypeOfSignature(s);
	          return !(returnType.flags & (1 /* Any */ | 131072 /* Never */)) && checkTypeRelatedTo(
	            returnType,
	            target,
	            relation,
	            /*errorNode*/
	            void 0
	          );
	        })) {
	          const resultObj = errorOutputContainer || {};
	          checkTypeAssignableTo(source, target, node, headMessage, containingMessageChain, resultObj);
	          const diagnostic = resultObj.errors[resultObj.errors.length - 1];
	          addRelatedInfo(
	            diagnostic,
	            createDiagnosticForNode(
	              node,
	              signatures === constructSignatures ? Diagnostics.Did_you_mean_to_use_new_with_this_expression : Diagnostics.Did_you_mean_to_call_this_expression
	            )
	          );
	          return true;
	        }
	      }
	      return false;
	    }
	    function elaborateArrowFunction(node, source, target, relation, containingMessageChain, errorOutputContainer) {
	      if (isBlock(node.body)) {
	        return false;
	      }
	      if (some(node.parameters, hasType)) {
	        return false;
	      }
	      const sourceSig = getSingleCallSignature(source);
	      if (!sourceSig) {
	        return false;
	      }
	      const targetSignatures = getSignaturesOfType(target, 0 /* Call */);
	      if (!length(targetSignatures)) {
	        return false;
	      }
	      const returnExpression = node.body;
	      const sourceReturn = getReturnTypeOfSignature(sourceSig);
	      const targetReturn = getUnionType(map(targetSignatures, getReturnTypeOfSignature));
	      if (!checkTypeRelatedTo(
	        sourceReturn,
	        targetReturn,
	        relation,
	        /*errorNode*/
	        void 0
	      )) {
	        const elaborated = returnExpression && elaborateError(
	          returnExpression,
	          sourceReturn,
	          targetReturn,
	          relation,
	          /*headMessage*/
	          void 0,
	          containingMessageChain,
	          errorOutputContainer
	        );
	        if (elaborated) {
	          return elaborated;
	        }
	        const resultObj = errorOutputContainer || {};
	        checkTypeRelatedTo(
	          sourceReturn,
	          targetReturn,
	          relation,
	          returnExpression,
	          /*headMessage*/
	          void 0,
	          containingMessageChain,
	          resultObj
	        );
	        if (resultObj.errors) {
	          if (target.symbol && length(target.symbol.declarations)) {
	            addRelatedInfo(
	              resultObj.errors[resultObj.errors.length - 1],
	              createDiagnosticForNode(
	                target.symbol.declarations[0],
	                Diagnostics.The_expected_type_comes_from_the_return_type_of_this_signature
	              )
	            );
	          }
	          if ((getFunctionFlags(node) & 2 /* Async */) === 0 && !getTypeOfPropertyOfType(sourceReturn, "then") && checkTypeRelatedTo(
	            createPromiseType(sourceReturn),
	            targetReturn,
	            relation,
	            /*errorNode*/
	            void 0
	          )) {
	            addRelatedInfo(
	              resultObj.errors[resultObj.errors.length - 1],
	              createDiagnosticForNode(
	                node,
	                Diagnostics.Did_you_mean_to_mark_this_function_as_async
	              )
	            );
	          }
	          return true;
	        }
	      }
	      return false;
	    }
	    function getBestMatchIndexedAccessTypeOrUndefined(source, target, nameType) {
	      const idx = getIndexedAccessTypeOrUndefined(target, nameType);
	      if (idx) {
	        return idx;
	      }
	      if (target.flags & 1048576 /* Union */) {
	        const best = getBestMatchingType(source, target);
	        if (best) {
	          return getIndexedAccessTypeOrUndefined(best, nameType);
	        }
	      }
	    }
	    function checkExpressionForMutableLocationWithContextualType(next, sourcePropType) {
	      pushContextualType(
	        next,
	        sourcePropType,
	        /*isCache*/
	        false
	      );
	      const result = checkExpressionForMutableLocation(next, 1 /* Contextual */);
	      popContextualType();
	      return result;
	    }
	    function elaborateElementwise(iterator, source, target, relation, containingMessageChain, errorOutputContainer) {
	      let reportedError = false;
	      for (const value of iterator) {
	        const { errorNode: prop, innerExpression: next, nameType, errorMessage } = value;
	        let targetPropType = getBestMatchIndexedAccessTypeOrUndefined(source, target, nameType);
	        if (!targetPropType || targetPropType.flags & 8388608 /* IndexedAccess */)
	          continue;
	        let sourcePropType = getIndexedAccessTypeOrUndefined(source, nameType);
	        if (!sourcePropType)
	          continue;
	        const propName = getPropertyNameFromIndex(
	          nameType,
	          /*accessNode*/
	          void 0
	        );
	        if (!checkTypeRelatedTo(
	          sourcePropType,
	          targetPropType,
	          relation,
	          /*errorNode*/
	          void 0
	        )) {
	          const elaborated = next && elaborateError(
	            next,
	            sourcePropType,
	            targetPropType,
	            relation,
	            /*headMessage*/
	            void 0,
	            containingMessageChain,
	            errorOutputContainer
	          );
	          reportedError = true;
	          if (!elaborated) {
	            const resultObj = errorOutputContainer || {};
	            const specificSource = next ? checkExpressionForMutableLocationWithContextualType(next, sourcePropType) : sourcePropType;
	            if (exactOptionalPropertyTypes && isExactOptionalPropertyMismatch(specificSource, targetPropType)) {
	              const diag2 = createDiagnosticForNode(prop, Diagnostics.Type_0_is_not_assignable_to_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_type_of_the_target, typeToString(specificSource), typeToString(targetPropType));
	              diagnostics.add(diag2);
	              resultObj.errors = [diag2];
	            } else {
	              const targetIsOptional = !!(propName && (getPropertyOfType(target, propName) || unknownSymbol).flags & 16777216 /* Optional */);
	              const sourceIsOptional = !!(propName && (getPropertyOfType(source, propName) || unknownSymbol).flags & 16777216 /* Optional */);
	              targetPropType = removeMissingType(targetPropType, targetIsOptional);
	              sourcePropType = removeMissingType(sourcePropType, targetIsOptional && sourceIsOptional);
	              const result = checkTypeRelatedTo(specificSource, targetPropType, relation, prop, errorMessage, containingMessageChain, resultObj);
	              if (result && specificSource !== sourcePropType) {
	                checkTypeRelatedTo(sourcePropType, targetPropType, relation, prop, errorMessage, containingMessageChain, resultObj);
	              }
	            }
	            if (resultObj.errors) {
	              const reportedDiag = resultObj.errors[resultObj.errors.length - 1];
	              const propertyName = isTypeUsableAsPropertyName(nameType) ? getPropertyNameFromType(nameType) : void 0;
	              const targetProp = propertyName !== void 0 ? getPropertyOfType(target, propertyName) : void 0;
	              let issuedElaboration = false;
	              if (!targetProp) {
	                const indexInfo = getApplicableIndexInfo(target, nameType);
	                if (indexInfo && indexInfo.declaration && !getSourceFileOfNode(indexInfo.declaration).hasNoDefaultLib) {
	                  issuedElaboration = true;
	                  addRelatedInfo(reportedDiag, createDiagnosticForNode(indexInfo.declaration, Diagnostics.The_expected_type_comes_from_this_index_signature));
	                }
	              }
	              if (!issuedElaboration && (targetProp && length(targetProp.declarations) || target.symbol && length(target.symbol.declarations))) {
	                const targetNode = targetProp && length(targetProp.declarations) ? targetProp.declarations[0] : target.symbol.declarations[0];
	                if (!getSourceFileOfNode(targetNode).hasNoDefaultLib) {
	                  addRelatedInfo(
	                    reportedDiag,
	                    createDiagnosticForNode(
	                      targetNode,
	                      Diagnostics.The_expected_type_comes_from_property_0_which_is_declared_here_on_type_1,
	                      propertyName && !(nameType.flags & 8192 /* UniqueESSymbol */) ? unescapeLeadingUnderscores(propertyName) : typeToString(nameType),
	                      typeToString(target)
	                    )
	                  );
	                }
	              }
	            }
	          }
	        }
	      }
	      return reportedError;
	    }
	    function elaborateIterableOrArrayLikeTargetElementwise(iterator, source, target, relation, containingMessageChain, errorOutputContainer) {
	      const tupleOrArrayLikeTargetParts = filterType(target, isArrayOrTupleLikeType);
	      const nonTupleOrArrayLikeTargetParts = filterType(target, (t) => !isArrayOrTupleLikeType(t));
	      const iterationType = nonTupleOrArrayLikeTargetParts !== neverType ? getIterationTypeOfIterable(
	        13 /* ForOf */,
	        0 /* Yield */,
	        nonTupleOrArrayLikeTargetParts,
	        /*errorNode*/
	        void 0
	      ) : void 0;
	      let reportedError = false;
	      for (let status = iterator.next(); !status.done; status = iterator.next()) {
	        const { errorNode: prop, innerExpression: next, nameType, errorMessage } = status.value;
	        let targetPropType = iterationType;
	        const targetIndexedPropType = tupleOrArrayLikeTargetParts !== neverType ? getBestMatchIndexedAccessTypeOrUndefined(source, tupleOrArrayLikeTargetParts, nameType) : void 0;
	        if (targetIndexedPropType && !(targetIndexedPropType.flags & 8388608 /* IndexedAccess */)) {
	          targetPropType = iterationType ? getUnionType([iterationType, targetIndexedPropType]) : targetIndexedPropType;
	        }
	        if (!targetPropType)
	          continue;
	        let sourcePropType = getIndexedAccessTypeOrUndefined(source, nameType);
	        if (!sourcePropType)
	          continue;
	        const propName = getPropertyNameFromIndex(
	          nameType,
	          /*accessNode*/
	          void 0
	        );
	        if (!checkTypeRelatedTo(
	          sourcePropType,
	          targetPropType,
	          relation,
	          /*errorNode*/
	          void 0
	        )) {
	          const elaborated = next && elaborateError(
	            next,
	            sourcePropType,
	            targetPropType,
	            relation,
	            /*headMessage*/
	            void 0,
	            containingMessageChain,
	            errorOutputContainer
	          );
	          reportedError = true;
	          if (!elaborated) {
	            const resultObj = errorOutputContainer || {};
	            const specificSource = next ? checkExpressionForMutableLocationWithContextualType(next, sourcePropType) : sourcePropType;
	            if (exactOptionalPropertyTypes && isExactOptionalPropertyMismatch(specificSource, targetPropType)) {
	              const diag2 = createDiagnosticForNode(prop, Diagnostics.Type_0_is_not_assignable_to_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_type_of_the_target, typeToString(specificSource), typeToString(targetPropType));
	              diagnostics.add(diag2);
	              resultObj.errors = [diag2];
	            } else {
	              const targetIsOptional = !!(propName && (getPropertyOfType(tupleOrArrayLikeTargetParts, propName) || unknownSymbol).flags & 16777216 /* Optional */);
	              const sourceIsOptional = !!(propName && (getPropertyOfType(source, propName) || unknownSymbol).flags & 16777216 /* Optional */);
	              targetPropType = removeMissingType(targetPropType, targetIsOptional);
	              sourcePropType = removeMissingType(sourcePropType, targetIsOptional && sourceIsOptional);
	              const result = checkTypeRelatedTo(specificSource, targetPropType, relation, prop, errorMessage, containingMessageChain, resultObj);
	              if (result && specificSource !== sourcePropType) {
	                checkTypeRelatedTo(sourcePropType, targetPropType, relation, prop, errorMessage, containingMessageChain, resultObj);
	              }
	            }
	          }
	        }
	      }
	      return reportedError;
	    }
	    function* generateJsxAttributes(node) {
	      if (!length(node.properties))
	        return;
	      for (const prop of node.properties) {
	        if (isJsxSpreadAttribute(prop) || isHyphenatedJsxName(getTextOfJsxAttributeName(prop.name)))
	          continue;
	        yield { errorNode: prop.name, innerExpression: prop.initializer, nameType: getStringLiteralType(getTextOfJsxAttributeName(prop.name)) };
	      }
	    }
	    function* generateJsxChildren(node, getInvalidTextDiagnostic) {
	      if (!length(node.children))
	        return;
	      let memberOffset = 0;
	      for (let i = 0; i < node.children.length; i++) {
	        const child = node.children[i];
	        const nameType = getNumberLiteralType(i - memberOffset);
	        const elem = getElaborationElementForJsxChild(child, nameType, getInvalidTextDiagnostic);
	        if (elem) {
	          yield elem;
	        } else {
	          memberOffset++;
	        }
	      }
	    }
	    function getElaborationElementForJsxChild(child, nameType, getInvalidTextDiagnostic) {
	      switch (child.kind) {
	        case 294 /* JsxExpression */:
	          return { errorNode: child, innerExpression: child.expression, nameType };
	        case 12 /* JsxText */:
	          if (child.containsOnlyTriviaWhiteSpaces) {
	            break;
	          }
	          return { errorNode: child, innerExpression: void 0, nameType, errorMessage: getInvalidTextDiagnostic() };
	        case 284 /* JsxElement */:
	        case 285 /* JsxSelfClosingElement */:
	        case 288 /* JsxFragment */:
	          return { errorNode: child, innerExpression: child, nameType };
	        default:
	          return Debug.assertNever(child, "Found invalid jsx child");
	      }
	    }
	    function elaborateJsxComponents(node, source, target, relation, containingMessageChain, errorOutputContainer) {
	      let result = elaborateElementwise(generateJsxAttributes(node), source, target, relation, containingMessageChain, errorOutputContainer);
	      let invalidTextDiagnostic;
	      if (isJsxOpeningElement(node.parent) && isJsxElement(node.parent.parent)) {
	        const containingElement = node.parent.parent;
	        const childPropName = getJsxElementChildrenPropertyName(getJsxNamespaceAt(node));
	        const childrenPropName = childPropName === void 0 ? "children" : unescapeLeadingUnderscores(childPropName);
	        const childrenNameType = getStringLiteralType(childrenPropName);
	        const childrenTargetType = getIndexedAccessType(target, childrenNameType);
	        const validChildren = getSemanticJsxChildren(containingElement.children);
	        if (!length(validChildren)) {
	          return result;
	        }
	        const moreThanOneRealChildren = length(validChildren) > 1;
	        let arrayLikeTargetParts;
	        let nonArrayLikeTargetParts;
	        const iterableType = getGlobalIterableType(
	          /*reportErrors*/
	          false
	        );
	        if (iterableType !== emptyGenericType) {
	          const anyIterable = createIterableType(anyType);
	          arrayLikeTargetParts = filterType(childrenTargetType, (t) => isTypeAssignableTo(t, anyIterable));
	          nonArrayLikeTargetParts = filterType(childrenTargetType, (t) => !isTypeAssignableTo(t, anyIterable));
	        } else {
	          arrayLikeTargetParts = filterType(childrenTargetType, isArrayOrTupleLikeType);
	          nonArrayLikeTargetParts = filterType(childrenTargetType, (t) => !isArrayOrTupleLikeType(t));
	        }
	        if (moreThanOneRealChildren) {
	          if (arrayLikeTargetParts !== neverType) {
	            const realSource = createTupleType(checkJsxChildren(containingElement, 0 /* Normal */));
	            const children = generateJsxChildren(containingElement, getInvalidTextualChildDiagnostic);
	            result = elaborateIterableOrArrayLikeTargetElementwise(children, realSource, arrayLikeTargetParts, relation, containingMessageChain, errorOutputContainer) || result;
	          } else if (!isTypeRelatedTo(getIndexedAccessType(source, childrenNameType), childrenTargetType, relation)) {
	            result = true;
	            const diag2 = error2(
	              containingElement.openingElement.tagName,
	              Diagnostics.This_JSX_tag_s_0_prop_expects_a_single_child_of_type_1_but_multiple_children_were_provided,
	              childrenPropName,
	              typeToString(childrenTargetType)
	            );
	            if (errorOutputContainer && errorOutputContainer.skipLogging) {
	              (errorOutputContainer.errors || (errorOutputContainer.errors = [])).push(diag2);
	            }
	          }
	        } else {
	          if (nonArrayLikeTargetParts !== neverType) {
	            const child = validChildren[0];
	            const elem = getElaborationElementForJsxChild(child, childrenNameType, getInvalidTextualChildDiagnostic);
	            if (elem) {
	              result = elaborateElementwise(
	                function* () {
	                  yield elem;
	                }(),
	                source,
	                target,
	                relation,
	                containingMessageChain,
	                errorOutputContainer
	              ) || result;
	            }
	          } else if (!isTypeRelatedTo(getIndexedAccessType(source, childrenNameType), childrenTargetType, relation)) {
	            result = true;
	            const diag2 = error2(
	              containingElement.openingElement.tagName,
	              Diagnostics.This_JSX_tag_s_0_prop_expects_type_1_which_requires_multiple_children_but_only_a_single_child_was_provided,
	              childrenPropName,
	              typeToString(childrenTargetType)
	            );
	            if (errorOutputContainer && errorOutputContainer.skipLogging) {
	              (errorOutputContainer.errors || (errorOutputContainer.errors = [])).push(diag2);
	            }
	          }
	        }
	      }
	      return result;
	      function getInvalidTextualChildDiagnostic() {
	        if (!invalidTextDiagnostic) {
	          const tagNameText = getTextOfNode(node.parent.tagName);
	          const childPropName = getJsxElementChildrenPropertyName(getJsxNamespaceAt(node));
	          const childrenPropName = childPropName === void 0 ? "children" : unescapeLeadingUnderscores(childPropName);
	          const childrenTargetType = getIndexedAccessType(target, getStringLiteralType(childrenPropName));
	          const diagnostic = Diagnostics._0_components_don_t_accept_text_as_child_elements_Text_in_JSX_has_the_type_string_but_the_expected_type_of_1_is_2;
	          invalidTextDiagnostic = { ...diagnostic, key: "!!ALREADY FORMATTED!!", message: formatMessage(diagnostic, tagNameText, childrenPropName, typeToString(childrenTargetType)) };
	        }
	        return invalidTextDiagnostic;
	      }
	    }
	    function* generateLimitedTupleElements(node, target) {
	      const len = length(node.elements);
	      if (!len)
	        return;
	      for (let i = 0; i < len; i++) {
	        if (isTupleLikeType(target) && !getPropertyOfType(target, "" + i))
	          continue;
	        const elem = node.elements[i];
	        if (isOmittedExpression(elem))
	          continue;
	        const nameType = getNumberLiteralType(i);
	        const checkNode = getEffectiveCheckNode(elem);
	        yield { errorNode: checkNode, innerExpression: checkNode, nameType };
	      }
	    }
	    function elaborateArrayLiteral(node, source, target, relation, containingMessageChain, errorOutputContainer) {
	      if (target.flags & (402784252 /* Primitive */ | 131072 /* Never */))
	        return false;
	      if (isTupleLikeType(source)) {
	        return elaborateElementwise(generateLimitedTupleElements(node, target), source, target, relation, containingMessageChain, errorOutputContainer);
	      }
	      pushContextualType(
	        node,
	        target,
	        /*isCache*/
	        false
	      );
	      const tupleizedType = checkArrayLiteral(
	        node,
	        1 /* Contextual */,
	        /*forceTuple*/
	        true
	      );
	      popContextualType();
	      if (isTupleLikeType(tupleizedType)) {
	        return elaborateElementwise(generateLimitedTupleElements(node, target), tupleizedType, target, relation, containingMessageChain, errorOutputContainer);
	      }
	      return false;
	    }
	    function* generateObjectLiteralElements(node) {
	      if (!length(node.properties))
	        return;
	      for (const prop of node.properties) {
	        if (isSpreadAssignment(prop))
	          continue;
	        const type = getLiteralTypeFromProperty(getSymbolOfDeclaration(prop), 8576 /* StringOrNumberLiteralOrUnique */);
	        if (!type || type.flags & 131072 /* Never */) {
	          continue;
	        }
	        switch (prop.kind) {
	          case 178 /* SetAccessor */:
	          case 177 /* GetAccessor */:
	          case 174 /* MethodDeclaration */:
	          case 304 /* ShorthandPropertyAssignment */:
	            yield { errorNode: prop.name, innerExpression: void 0, nameType: type };
	            break;
	          case 303 /* PropertyAssignment */:
	            yield { errorNode: prop.name, innerExpression: prop.initializer, nameType: type, errorMessage: isComputedNonLiteralName(prop.name) ? Diagnostics.Type_of_computed_property_s_value_is_0_which_is_not_assignable_to_type_1 : void 0 };
	            break;
	          default:
	            Debug.assertNever(prop);
	        }
	      }
	    }
	    function elaborateObjectLiteral(node, source, target, relation, containingMessageChain, errorOutputContainer) {
	      if (target.flags & (402784252 /* Primitive */ | 131072 /* Never */))
	        return false;
	      return elaborateElementwise(generateObjectLiteralElements(node), source, target, relation, containingMessageChain, errorOutputContainer);
	    }
	    function checkTypeComparableTo(source, target, errorNode, headMessage, containingMessageChain) {
	      return checkTypeRelatedTo(source, target, comparableRelation, errorNode, headMessage, containingMessageChain);
	    }
	    function isSignatureAssignableTo(source, target, ignoreReturnTypes) {
	      return compareSignaturesRelated(
	        source,
	        target,
	        ignoreReturnTypes ? 4 /* IgnoreReturnTypes */ : 0 /* None */,
	        /*reportErrors*/
	        false,
	        /*errorReporter*/
	        void 0,
	        /*incompatibleErrorReporter*/
	        void 0,
	        compareTypesAssignable,
	        /*reportUnreliableMarkers*/
	        void 0
	      ) !== 0 /* False */;
	    }
	    function isTopSignature(s) {
	      if (!s.typeParameters && (!s.thisParameter || isTypeAny(getTypeOfParameter(s.thisParameter))) && s.parameters.length === 1 && signatureHasRestParameter(s)) {
	        const paramType = getTypeOfParameter(s.parameters[0]);
	        const restType = isArrayType(paramType) ? getTypeArguments(paramType)[0] : paramType;
	        return !!(restType.flags & (1 /* Any */ | 131072 /* Never */) && getReturnTypeOfSignature(s).flags & 3 /* AnyOrUnknown */);
	      }
	      return false;
	    }
	    function compareSignaturesRelated(source, target, checkMode, reportErrors2, errorReporter, incompatibleErrorReporter, compareTypes, reportUnreliableMarkers) {
	      if (source === target) {
	        return -1 /* True */;
	      }
	      if (!(checkMode & 16 /* StrictTopSignature */ && isTopSignature(source)) && isTopSignature(target)) {
	        return -1 /* True */;
	      }
	      if (checkMode & 16 /* StrictTopSignature */ && isTopSignature(source) && !isTopSignature(target)) {
	        return 0 /* False */;
	      }
	      const targetCount = getParameterCount(target);
	      const sourceHasMoreParameters = !hasEffectiveRestParameter(target) && (checkMode & 8 /* StrictArity */ ? hasEffectiveRestParameter(source) || getParameterCount(source) > targetCount : getMinArgumentCount(source) > targetCount);
	      if (sourceHasMoreParameters) {
	        if (reportErrors2 && !(checkMode & 8 /* StrictArity */)) {
	          errorReporter(Diagnostics.Target_signature_provides_too_few_arguments_Expected_0_or_more_but_got_1, getMinArgumentCount(source), targetCount);
	        }
	        return 0 /* False */;
	      }
	      if (source.typeParameters && source.typeParameters !== target.typeParameters) {
	        target = getCanonicalSignature(target);
	        source = instantiateSignatureInContextOf(
	          source,
	          target,
	          /*inferenceContext*/
	          void 0,
	          compareTypes
	        );
	      }
	      const sourceCount = getParameterCount(source);
	      const sourceRestType = getNonArrayRestType(source);
	      const targetRestType = getNonArrayRestType(target);
	      if (sourceRestType || targetRestType) {
	        void instantiateType(sourceRestType || targetRestType, reportUnreliableMarkers);
	      }
	      const kind = target.declaration ? target.declaration.kind : 0 /* Unknown */;
	      const strictVariance = !(checkMode & 3 /* Callback */) && strictFunctionTypes && kind !== 174 /* MethodDeclaration */ && kind !== 173 /* MethodSignature */ && kind !== 176 /* Constructor */;
	      let result = -1 /* True */;
	      const sourceThisType = getThisTypeOfSignature(source);
	      if (sourceThisType && sourceThisType !== voidType) {
	        const targetThisType = getThisTypeOfSignature(target);
	        if (targetThisType) {
	          const related = !strictVariance && compareTypes(
	            sourceThisType,
	            targetThisType,
	            /*reportErrors*/
	            false
	          ) || compareTypes(targetThisType, sourceThisType, reportErrors2);
	          if (!related) {
	            if (reportErrors2) {
	              errorReporter(Diagnostics.The_this_types_of_each_signature_are_incompatible);
	            }
	            return 0 /* False */;
	          }
	          result &= related;
	        }
	      }
	      const paramCount = sourceRestType || targetRestType ? Math.min(sourceCount, targetCount) : Math.max(sourceCount, targetCount);
	      const restIndex = sourceRestType || targetRestType ? paramCount - 1 : -1;
	      for (let i = 0; i < paramCount; i++) {
	        const sourceType = i === restIndex ? getRestOrAnyTypeAtPosition(source, i) : tryGetTypeAtPosition(source, i);
	        const targetType = i === restIndex ? getRestOrAnyTypeAtPosition(target, i) : tryGetTypeAtPosition(target, i);
	        if (sourceType && targetType) {
	          const sourceSig = checkMode & 3 /* Callback */ || isInstantiatedGenericParameter(source, i) ? void 0 : getSingleCallSignature(getNonNullableType(sourceType));
	          const targetSig = checkMode & 3 /* Callback */ || isInstantiatedGenericParameter(target, i) ? void 0 : getSingleCallSignature(getNonNullableType(targetType));
	          const callbacks = sourceSig && targetSig && !getTypePredicateOfSignature(sourceSig) && !getTypePredicateOfSignature(targetSig) && getTypeFacts(sourceType, 50331648 /* IsUndefinedOrNull */) === getTypeFacts(targetType, 50331648 /* IsUndefinedOrNull */);
	          let related = callbacks ? compareSignaturesRelated(targetSig, sourceSig, checkMode & 8 /* StrictArity */ | (strictVariance ? 2 /* StrictCallback */ : 1 /* BivariantCallback */), reportErrors2, errorReporter, incompatibleErrorReporter, compareTypes, reportUnreliableMarkers) : !(checkMode & 3 /* Callback */) && !strictVariance && compareTypes(
	            sourceType,
	            targetType,
	            /*reportErrors*/
	            false
	          ) || compareTypes(targetType, sourceType, reportErrors2);
	          if (related && checkMode & 8 /* StrictArity */ && i >= getMinArgumentCount(source) && i < getMinArgumentCount(target) && compareTypes(
	            sourceType,
	            targetType,
	            /*reportErrors*/
	            false
	          )) {
	            related = 0 /* False */;
	          }
	          if (!related) {
	            if (reportErrors2) {
	              errorReporter(Diagnostics.Types_of_parameters_0_and_1_are_incompatible, unescapeLeadingUnderscores(getParameterNameAtPosition(source, i)), unescapeLeadingUnderscores(getParameterNameAtPosition(target, i)));
	            }
	            return 0 /* False */;
	          }
	          result &= related;
	        }
	      }
	      if (!(checkMode & 4 /* IgnoreReturnTypes */)) {
	        const targetReturnType = isResolvingReturnTypeOfSignature(target) ? anyType : target.declaration && isJSConstructor(target.declaration) ? getDeclaredTypeOfClassOrInterface(getMergedSymbol(target.declaration.symbol)) : getReturnTypeOfSignature(target);
	        if (targetReturnType === voidType || targetReturnType === anyType) {
	          return result;
	        }
	        const sourceReturnType = isResolvingReturnTypeOfSignature(source) ? anyType : source.declaration && isJSConstructor(source.declaration) ? getDeclaredTypeOfClassOrInterface(getMergedSymbol(source.declaration.symbol)) : getReturnTypeOfSignature(source);
	        const targetTypePredicate = getTypePredicateOfSignature(target);
	        if (targetTypePredicate) {
	          const sourceTypePredicate = getTypePredicateOfSignature(source);
	          if (sourceTypePredicate) {
	            result &= compareTypePredicateRelatedTo(sourceTypePredicate, targetTypePredicate, reportErrors2, errorReporter, compareTypes);
	          } else if (isIdentifierTypePredicate(targetTypePredicate)) {
	            if (reportErrors2) {
	              errorReporter(Diagnostics.Signature_0_must_be_a_type_predicate, signatureToString(source));
	            }
	            return 0 /* False */;
	          }
	        } else {
	          result &= checkMode & 1 /* BivariantCallback */ && compareTypes(
	            targetReturnType,
	            sourceReturnType,
	            /*reportErrors*/
	            false
	          ) || compareTypes(sourceReturnType, targetReturnType, reportErrors2);
	          if (!result && reportErrors2 && incompatibleErrorReporter) {
	            incompatibleErrorReporter(sourceReturnType, targetReturnType);
	          }
	        }
	      }
	      return result;
	    }
	    function compareTypePredicateRelatedTo(source, target, reportErrors2, errorReporter, compareTypes) {
	      if (source.kind !== target.kind) {
	        if (reportErrors2) {
	          errorReporter(Diagnostics.A_this_based_type_guard_is_not_compatible_with_a_parameter_based_type_guard);
	          errorReporter(Diagnostics.Type_predicate_0_is_not_assignable_to_1, typePredicateToString(source), typePredicateToString(target));
	        }
	        return 0 /* False */;
	      }
	      if (source.kind === 1 /* Identifier */ || source.kind === 3 /* AssertsIdentifier */) {
	        if (source.parameterIndex !== target.parameterIndex) {
	          if (reportErrors2) {
	            errorReporter(Diagnostics.Parameter_0_is_not_in_the_same_position_as_parameter_1, source.parameterName, target.parameterName);
	            errorReporter(Diagnostics.Type_predicate_0_is_not_assignable_to_1, typePredicateToString(source), typePredicateToString(target));
	          }
	          return 0 /* False */;
	        }
	      }
	      const related = source.type === target.type ? -1 /* True */ : source.type && target.type ? compareTypes(source.type, target.type, reportErrors2) : 0 /* False */;
	      if (related === 0 /* False */ && reportErrors2) {
	        errorReporter(Diagnostics.Type_predicate_0_is_not_assignable_to_1, typePredicateToString(source), typePredicateToString(target));
	      }
	      return related;
	    }
	    function isImplementationCompatibleWithOverload(implementation, overload) {
	      const erasedSource = getErasedSignature(implementation);
	      const erasedTarget = getErasedSignature(overload);
	      const sourceReturnType = getReturnTypeOfSignature(erasedSource);
	      const targetReturnType = getReturnTypeOfSignature(erasedTarget);
	      if (targetReturnType === voidType || isTypeRelatedTo(targetReturnType, sourceReturnType, assignableRelation) || isTypeRelatedTo(sourceReturnType, targetReturnType, assignableRelation)) {
	        return isSignatureAssignableTo(
	          erasedSource,
	          erasedTarget,
	          /*ignoreReturnTypes*/
	          true
	        );
	      }
	      return false;
	    }
	    function isEmptyResolvedType(t) {
	      return t !== anyFunctionType && t.properties.length === 0 && t.callSignatures.length === 0 && t.constructSignatures.length === 0 && t.indexInfos.length === 0;
	    }
	    function isEmptyObjectType(type) {
	      return type.flags & 524288 /* Object */ ? !isGenericMappedType(type) && isEmptyResolvedType(resolveStructuredTypeMembers(type)) : type.flags & 67108864 /* NonPrimitive */ ? true : type.flags & 1048576 /* Union */ ? some(type.types, isEmptyObjectType) : type.flags & 2097152 /* Intersection */ ? every(type.types, isEmptyObjectType) : false;
	    }
	    function isEmptyAnonymousObjectType(type) {
	      return !!(getObjectFlags(type) & 16 /* Anonymous */ && (type.members && isEmptyResolvedType(type) || type.symbol && type.symbol.flags & 2048 /* TypeLiteral */ && getMembersOfSymbol(type.symbol).size === 0));
	    }
	    function isUnknownLikeUnionType(type) {
	      if (strictNullChecks && type.flags & 1048576 /* Union */) {
	        if (!(type.objectFlags & 33554432 /* IsUnknownLikeUnionComputed */)) {
	          const types = type.types;
	          type.objectFlags |= 33554432 /* IsUnknownLikeUnionComputed */ | (types.length >= 3 && types[0].flags & 32768 /* Undefined */ && types[1].flags & 65536 /* Null */ && some(types, isEmptyAnonymousObjectType) ? 67108864 /* IsUnknownLikeUnion */ : 0);
	        }
	        return !!(type.objectFlags & 67108864 /* IsUnknownLikeUnion */);
	      }
	      return false;
	    }
	    function containsUndefinedType(type) {
	      return !!((type.flags & 1048576 /* Union */ ? type.types[0] : type).flags & 32768 /* Undefined */);
	    }
	    function isStringIndexSignatureOnlyType(type) {
	      return type.flags & 524288 /* Object */ && !isGenericMappedType(type) && getPropertiesOfType(type).length === 0 && getIndexInfosOfType(type).length === 1 && !!getIndexInfoOfType(type, stringType) || type.flags & 3145728 /* UnionOrIntersection */ && every(type.types, isStringIndexSignatureOnlyType) || false;
	    }
	    function isEnumTypeRelatedTo(source, target, errorReporter) {
	      const sourceSymbol = source.flags & 8 /* EnumMember */ ? getParentOfSymbol(source) : source;
	      const targetSymbol = target.flags & 8 /* EnumMember */ ? getParentOfSymbol(target) : target;
	      if (sourceSymbol === targetSymbol) {
	        return true;
	      }
	      if (sourceSymbol.escapedName !== targetSymbol.escapedName || !(sourceSymbol.flags & 256 /* RegularEnum */) || !(targetSymbol.flags & 256 /* RegularEnum */)) {
	        return false;
	      }
	      const id = getSymbolId(sourceSymbol) + "," + getSymbolId(targetSymbol);
	      const entry = enumRelation.get(id);
	      if (entry !== void 0 && !(!(entry & 4 /* Reported */) && entry & 2 /* Failed */ && errorReporter)) {
	        return !!(entry & 1 /* Succeeded */);
	      }
	      const targetEnumType = getTypeOfSymbol(targetSymbol);
	      for (const sourceProperty of getPropertiesOfType(getTypeOfSymbol(sourceSymbol))) {
	        if (sourceProperty.flags & 8 /* EnumMember */) {
	          const targetProperty = getPropertyOfType(targetEnumType, sourceProperty.escapedName);
	          if (!targetProperty || !(targetProperty.flags & 8 /* EnumMember */)) {
	            if (errorReporter) {
	              errorReporter(Diagnostics.Property_0_is_missing_in_type_1, symbolName(sourceProperty), typeToString(
	                getDeclaredTypeOfSymbol(targetSymbol),
	                /*enclosingDeclaration*/
	                void 0,
	                64 /* UseFullyQualifiedType */
	              ));
	              enumRelation.set(id, 2 /* Failed */ | 4 /* Reported */);
	            } else {
	              enumRelation.set(id, 2 /* Failed */);
	            }
	            return false;
	          }
	          const sourceValue = getEnumMemberValue(getDeclarationOfKind(sourceProperty, 306 /* EnumMember */));
	          const targetValue = getEnumMemberValue(getDeclarationOfKind(targetProperty, 306 /* EnumMember */));
	          if (sourceValue !== targetValue) {
	            const sourceIsString = typeof sourceValue === "string";
	            const targetIsString = typeof targetValue === "string";
	            if (sourceValue !== void 0 && targetValue !== void 0) {
	              if (!errorReporter) {
	                enumRelation.set(id, 2 /* Failed */);
	              } else {
	                const escapedSource = sourceIsString ? `"${escapeString(sourceValue)}"` : sourceValue;
	                const escapedTarget = targetIsString ? `"${escapeString(targetValue)}"` : targetValue;
	                errorReporter(Diagnostics.Each_declaration_of_0_1_differs_in_its_value_where_2_was_expected_but_3_was_given, symbolName(targetSymbol), symbolName(targetProperty), escapedTarget, escapedSource);
	                enumRelation.set(id, 2 /* Failed */ | 4 /* Reported */);
	              }
	              return false;
	            }
	            if (sourceIsString || targetIsString) {
	              if (!errorReporter) {
	                enumRelation.set(id, 2 /* Failed */);
	              } else {
	                const knownStringValue = sourceValue ?? targetValue;
	                Debug.assert(typeof knownStringValue === "string");
	                const escapedValue = `"${escapeString(knownStringValue)}"`;
	                errorReporter(Diagnostics.One_value_of_0_1_is_the_string_2_and_the_other_is_assumed_to_be_an_unknown_numeric_value, symbolName(targetSymbol), symbolName(targetProperty), escapedValue);
	                enumRelation.set(id, 2 /* Failed */ | 4 /* Reported */);
	              }
	              return false;
	            }
	          }
	        }
	      }
	      enumRelation.set(id, 1 /* Succeeded */);
	      return true;
	    }
	    function isSimpleTypeRelatedTo(source, target, relation, errorReporter) {
	      const s = source.flags;
	      const t = target.flags;
	      if (t & 1 /* Any */ || s & 131072 /* Never */ || source === wildcardType)
	        return true;
	      if (t & 2 /* Unknown */ && !(relation === strictSubtypeRelation && s & 1 /* Any */))
	        return true;
	      if (t & 131072 /* Never */)
	        return false;
	      if (s & 402653316 /* StringLike */ && t & 4 /* String */)
	        return true;
	      if (s & 128 /* StringLiteral */ && s & 1024 /* EnumLiteral */ && t & 128 /* StringLiteral */ && !(t & 1024 /* EnumLiteral */) && source.value === target.value)
	        return true;
	      if (s & 296 /* NumberLike */ && t & 8 /* Number */)
	        return true;
	      if (s & 256 /* NumberLiteral */ && s & 1024 /* EnumLiteral */ && t & 256 /* NumberLiteral */ && !(t & 1024 /* EnumLiteral */) && source.value === target.value)
	        return true;
	      if (s & 2112 /* BigIntLike */ && t & 64 /* BigInt */)
	        return true;
	      if (s & 528 /* BooleanLike */ && t & 16 /* Boolean */)
	        return true;
	      if (s & 12288 /* ESSymbolLike */ && t & 4096 /* ESSymbol */)
	        return true;
	      if (s & 32 /* Enum */ && t & 32 /* Enum */ && source.symbol.escapedName === target.symbol.escapedName && isEnumTypeRelatedTo(source.symbol, target.symbol, errorReporter))
	        return true;
	      if (s & 1024 /* EnumLiteral */ && t & 1024 /* EnumLiteral */) {
	        if (s & 1048576 /* Union */ && t & 1048576 /* Union */ && isEnumTypeRelatedTo(source.symbol, target.symbol, errorReporter))
	          return true;
	        if (s & 2944 /* Literal */ && t & 2944 /* Literal */ && source.value === target.value && isEnumTypeRelatedTo(source.symbol, target.symbol, errorReporter))
	          return true;
	      }
	      if (s & 32768 /* Undefined */ && (!strictNullChecks && !(t & 3145728 /* UnionOrIntersection */) || t & (32768 /* Undefined */ | 16384 /* Void */)))
	        return true;
	      if (s & 65536 /* Null */ && (!strictNullChecks && !(t & 3145728 /* UnionOrIntersection */) || t & 65536 /* Null */))
	        return true;
	      if (s & 524288 /* Object */ && t & 67108864 /* NonPrimitive */ && !(relation === strictSubtypeRelation && isEmptyAnonymousObjectType(source) && !(getObjectFlags(source) & 8192 /* FreshLiteral */)))
	        return true;
	      if (relation === assignableRelation || relation === comparableRelation) {
	        if (s & 1 /* Any */)
	          return true;
	        if (s & 8 /* Number */ && (t & 32 /* Enum */ || t & 256 /* NumberLiteral */ && t & 1024 /* EnumLiteral */))
	          return true;
	        if (s & 256 /* NumberLiteral */ && !(s & 1024 /* EnumLiteral */) && (t & 32 /* Enum */ || t & 256 /* NumberLiteral */ && t & 1024 /* EnumLiteral */ && source.value === target.value))
	          return true;
	        if (isUnknownLikeUnionType(target))
	          return true;
	      }
	      return false;
	    }
	    function isTypeRelatedTo(source, target, relation) {
	      if (isFreshLiteralType(source)) {
	        source = source.regularType;
	      }
	      if (isFreshLiteralType(target)) {
	        target = target.regularType;
	      }
	      if (source === target) {
	        return true;
	      }
	      if (relation !== identityRelation) {
	        if (relation === comparableRelation && !(target.flags & 131072 /* Never */) && isSimpleTypeRelatedTo(target, source, relation) || isSimpleTypeRelatedTo(source, target, relation)) {
	          return true;
	        }
	      } else if (!((source.flags | target.flags) & (3145728 /* UnionOrIntersection */ | 8388608 /* IndexedAccess */ | 16777216 /* Conditional */ | 33554432 /* Substitution */))) {
	        if (source.flags !== target.flags)
	          return false;
	        if (source.flags & 67358815 /* Singleton */)
	          return true;
	      }
	      if (source.flags & 524288 /* Object */ && target.flags & 524288 /* Object */) {
	        const related = relation.get(getRelationKey(
	          source,
	          target,
	          0 /* None */,
	          relation,
	          /*ignoreConstraints*/
	          false
	        ));
	        if (related !== void 0) {
	          return !!(related & 1 /* Succeeded */);
	        }
	      }
	      if (source.flags & 469499904 /* StructuredOrInstantiable */ || target.flags & 469499904 /* StructuredOrInstantiable */) {
	        return checkTypeRelatedTo(
	          source,
	          target,
	          relation,
	          /*errorNode*/
	          void 0
	        );
	      }
	      return false;
	    }
	    function isIgnoredJsxProperty(source, sourceProp) {
	      return getObjectFlags(source) & 2048 /* JsxAttributes */ && isHyphenatedJsxName(sourceProp.escapedName);
	    }
	    function getNormalizedType(type, writing) {
	      while (true) {
	        const t = isFreshLiteralType(type) ? type.regularType : isGenericTupleType(type) ? getNormalizedTupleType(type, writing) : getObjectFlags(type) & 4 /* Reference */ ? type.node ? createTypeReference(type.target, getTypeArguments(type)) : getSingleBaseForNonAugmentingSubtype(type) || type : type.flags & 3145728 /* UnionOrIntersection */ ? getNormalizedUnionOrIntersectionType(type, writing) : type.flags & 33554432 /* Substitution */ ? writing ? type.baseType : getSubstitutionIntersection(type) : type.flags & 25165824 /* Simplifiable */ ? getSimplifiedType(type, writing) : type;
	        if (t === type)
	          return t;
	        type = t;
	      }
	    }
	    function getNormalizedUnionOrIntersectionType(type, writing) {
	      const reduced = getReducedType(type);
	      if (reduced !== type) {
	        return reduced;
	      }
	      if (type.flags & 2097152 /* Intersection */ && some(type.types, isEmptyAnonymousObjectType)) {
	        const normalizedTypes = sameMap(type.types, (t) => getNormalizedType(t, writing));
	        if (normalizedTypes !== type.types) {
	          return getIntersectionType(normalizedTypes);
	        }
	      }
	      return type;
	    }
	    function getNormalizedTupleType(type, writing) {
	      const elements = getElementTypes(type);
	      const normalizedElements = sameMap(elements, (t) => t.flags & 25165824 /* Simplifiable */ ? getSimplifiedType(t, writing) : t);
	      return elements !== normalizedElements ? createNormalizedTupleType(type.target, normalizedElements) : type;
	    }
	    function checkTypeRelatedTo(source, target, relation, errorNode, headMessage, containingMessageChain, errorOutputContainer) {
	      var _a;
	      let errorInfo;
	      let relatedInfo;
	      let maybeKeys;
	      let maybeKeysSet;
	      let sourceStack;
	      let targetStack;
	      let maybeCount = 0;
	      let sourceDepth = 0;
	      let targetDepth = 0;
	      let expandingFlags = 0 /* None */;
	      let overflow = false;
	      let overrideNextErrorInfo = 0;
	      let skipParentCounter = 0;
	      let lastSkippedInfo;
	      let incompatibleStack;
	      let relationCount = 16e6 - relation.size >> 3;
	      Debug.assert(relation !== identityRelation || !errorNode, "no error reporting in identity checking");
	      const result = isRelatedTo(
	        source,
	        target,
	        3 /* Both */,
	        /*reportErrors*/
	        !!errorNode,
	        headMessage
	      );
	      if (incompatibleStack) {
	        reportIncompatibleStack();
	      }
	      if (overflow) {
	        const id = getRelationKey(
	          source,
	          target,
	          /*intersectionState*/
	          0 /* None */,
	          relation,
	          /*ignoreConstraints*/
	          false
	        );
	        relation.set(id, 4 /* Reported */ | 2 /* Failed */);
	        (_a = tracing) == null ? void 0 : _a.instant(tracing.Phase.CheckTypes, "checkTypeRelatedTo_DepthLimit", { sourceId: source.id, targetId: target.id, depth: sourceDepth, targetDepth });
	        const message = relationCount <= 0 ? Diagnostics.Excessive_complexity_comparing_types_0_and_1 : Diagnostics.Excessive_stack_depth_comparing_types_0_and_1;
	        const diag2 = error2(errorNode || currentNode, message, typeToString(source), typeToString(target));
	        if (errorOutputContainer) {
	          (errorOutputContainer.errors || (errorOutputContainer.errors = [])).push(diag2);
	        }
	      } else if (errorInfo) {
	        if (containingMessageChain) {
	          const chain = containingMessageChain();
	          if (chain) {
	            concatenateDiagnosticMessageChains(chain, errorInfo);
	            errorInfo = chain;
	          }
	        }
	        let relatedInformation;
	        if (headMessage && errorNode && !result && source.symbol) {
	          const links = getSymbolLinks(source.symbol);
	          if (links.originatingImport && !isImportCall(links.originatingImport)) {
	            const helpfulRetry = checkTypeRelatedTo(
	              getTypeOfSymbol(links.target),
	              target,
	              relation,
	              /*errorNode*/
	              void 0
	            );
	            if (helpfulRetry) {
	              const diag3 = createDiagnosticForNode(links.originatingImport, Diagnostics.Type_originates_at_this_import_A_namespace_style_import_cannot_be_called_or_constructed_and_will_cause_a_failure_at_runtime_Consider_using_a_default_import_or_import_require_here_instead);
	              relatedInformation = append(relatedInformation, diag3);
	            }
	          }
	        }
	        const diag2 = createDiagnosticForNodeFromMessageChain(getSourceFileOfNode(errorNode), errorNode, errorInfo, relatedInformation);
	        if (relatedInfo) {
	          addRelatedInfo(diag2, ...relatedInfo);
	        }
	        if (errorOutputContainer) {
	          (errorOutputContainer.errors || (errorOutputContainer.errors = [])).push(diag2);
	        }
	        if (!errorOutputContainer || !errorOutputContainer.skipLogging) {
	          diagnostics.add(diag2);
	        }
	      }
	      if (errorNode && errorOutputContainer && errorOutputContainer.skipLogging && result === 0 /* False */) {
	        Debug.assert(!!errorOutputContainer.errors, "missed opportunity to interact with error.");
	      }
	      return result !== 0 /* False */;
	      function resetErrorInfo(saved) {
	        errorInfo = saved.errorInfo;
	        lastSkippedInfo = saved.lastSkippedInfo;
	        incompatibleStack = saved.incompatibleStack;
	        overrideNextErrorInfo = saved.overrideNextErrorInfo;
	        skipParentCounter = saved.skipParentCounter;
	        relatedInfo = saved.relatedInfo;
	      }
	      function captureErrorCalculationState() {
	        return {
	          errorInfo,
	          lastSkippedInfo,
	          incompatibleStack: incompatibleStack == null ? void 0 : incompatibleStack.slice(),
	          overrideNextErrorInfo,
	          skipParentCounter,
	          relatedInfo: relatedInfo == null ? void 0 : relatedInfo.slice()
	        };
	      }
	      function reportIncompatibleError(message, ...args) {
	        overrideNextErrorInfo++;
	        lastSkippedInfo = void 0;
	        (incompatibleStack || (incompatibleStack = [])).push([message, ...args]);
	      }
	      function reportIncompatibleStack() {
	        const stack = incompatibleStack || [];
	        incompatibleStack = void 0;
	        const info = lastSkippedInfo;
	        lastSkippedInfo = void 0;
	        if (stack.length === 1) {
	          reportError(...stack[0]);
	          if (info) {
	            reportRelationError(
	              /*message*/
	              void 0,
	              ...info
	            );
	          }
	          return;
	        }
	        let path = "";
	        const secondaryRootErrors = [];
	        while (stack.length) {
	          const [msg, ...args] = stack.pop();
	          switch (msg.code) {
	            case Diagnostics.Types_of_property_0_are_incompatible.code: {
	              if (path.indexOf("new ") === 0) {
	                path = `(${path})`;
	              }
	              const str = "" + args[0];
	              if (path.length === 0) {
	                path = `${str}`;
	              } else if (isIdentifierText(str, getEmitScriptTarget(compilerOptions))) {
	                path = `${path}.${str}`;
	              } else if (str[0] === "[" && str[str.length - 1] === "]") {
	                path = `${path}${str}`;
	              } else {
	                path = `${path}[${str}]`;
	              }
	              break;
	            }
	            case Diagnostics.Call_signature_return_types_0_and_1_are_incompatible.code:
	            case Diagnostics.Construct_signature_return_types_0_and_1_are_incompatible.code:
	            case Diagnostics.Call_signatures_with_no_arguments_have_incompatible_return_types_0_and_1.code:
	            case Diagnostics.Construct_signatures_with_no_arguments_have_incompatible_return_types_0_and_1.code: {
	              if (path.length === 0) {
	                let mappedMsg = msg;
	                if (msg.code === Diagnostics.Call_signatures_with_no_arguments_have_incompatible_return_types_0_and_1.code) {
	                  mappedMsg = Diagnostics.Call_signature_return_types_0_and_1_are_incompatible;
	                } else if (msg.code === Diagnostics.Construct_signatures_with_no_arguments_have_incompatible_return_types_0_and_1.code) {
	                  mappedMsg = Diagnostics.Construct_signature_return_types_0_and_1_are_incompatible;
	                }
	                secondaryRootErrors.unshift([mappedMsg, args[0], args[1]]);
	              } else {
	                const prefix = msg.code === Diagnostics.Construct_signature_return_types_0_and_1_are_incompatible.code || msg.code === Diagnostics.Construct_signatures_with_no_arguments_have_incompatible_return_types_0_and_1.code ? "new " : "";
	                const params = msg.code === Diagnostics.Call_signatures_with_no_arguments_have_incompatible_return_types_0_and_1.code || msg.code === Diagnostics.Construct_signatures_with_no_arguments_have_incompatible_return_types_0_and_1.code ? "" : "...";
	                path = `${prefix}${path}(${params})`;
	              }
	              break;
	            }
	            case Diagnostics.Type_at_position_0_in_source_is_not_compatible_with_type_at_position_1_in_target.code: {
	              secondaryRootErrors.unshift([Diagnostics.Type_at_position_0_in_source_is_not_compatible_with_type_at_position_1_in_target, args[0], args[1]]);
	              break;
	            }
	            case Diagnostics.Type_at_positions_0_through_1_in_source_is_not_compatible_with_type_at_position_2_in_target.code: {
	              secondaryRootErrors.unshift([Diagnostics.Type_at_positions_0_through_1_in_source_is_not_compatible_with_type_at_position_2_in_target, args[0], args[1], args[2]]);
	              break;
	            }
	            default:
	              return Debug.fail(`Unhandled Diagnostic: ${msg.code}`);
	          }
	        }
	        if (path) {
	          reportError(
	            path[path.length - 1] === ")" ? Diagnostics.The_types_returned_by_0_are_incompatible_between_these_types : Diagnostics.The_types_of_0_are_incompatible_between_these_types,
	            path
	          );
	        } else {
	          secondaryRootErrors.shift();
	        }
	        for (const [msg, ...args] of secondaryRootErrors) {
	          const originalValue = msg.elidedInCompatabilityPyramid;
	          msg.elidedInCompatabilityPyramid = false;
	          reportError(msg, ...args);
	          msg.elidedInCompatabilityPyramid = originalValue;
	        }
	        if (info) {
	          reportRelationError(
	            /*message*/
	            void 0,
	            ...info
	          );
	        }
	      }
	      function reportError(message, ...args) {
	        Debug.assert(!!errorNode);
	        if (incompatibleStack)
	          reportIncompatibleStack();
	        if (message.elidedInCompatabilityPyramid)
	          return;
	        if (skipParentCounter === 0) {
	          errorInfo = chainDiagnosticMessages(errorInfo, message, ...args);
	        } else {
	          skipParentCounter--;
	        }
	      }
	      function reportParentSkippedError(message, ...args) {
	        reportError(message, ...args);
	        skipParentCounter++;
	      }
	      function associateRelatedInfo(info) {
	        Debug.assert(!!errorInfo);
	        if (!relatedInfo) {
	          relatedInfo = [info];
	        } else {
	          relatedInfo.push(info);
	        }
	      }
	      function reportRelationError(message, source2, target2) {
	        if (incompatibleStack)
	          reportIncompatibleStack();
	        const [sourceType, targetType] = getTypeNamesForErrorDisplay(source2, target2);
	        let generalizedSource = source2;
	        let generalizedSourceType = sourceType;
	        if (isLiteralType(source2) && !typeCouldHaveTopLevelSingletonTypes(target2)) {
	          generalizedSource = getBaseTypeOfLiteralType(source2);
	          Debug.assert(!isTypeAssignableTo(generalizedSource, target2), "generalized source shouldn't be assignable");
	          generalizedSourceType = getTypeNameForErrorDisplay(generalizedSource);
	        }
	        const targetFlags = target2.flags & 8388608 /* IndexedAccess */ && !(source2.flags & 8388608 /* IndexedAccess */) ? target2.objectType.flags : target2.flags;
	        if (targetFlags & 262144 /* TypeParameter */ && target2 !== markerSuperTypeForCheck && target2 !== markerSubTypeForCheck) {
	          const constraint = getBaseConstraintOfType(target2);
	          let needsOriginalSource;
	          if (constraint && (isTypeAssignableTo(generalizedSource, constraint) || (needsOriginalSource = isTypeAssignableTo(source2, constraint)))) {
	            reportError(
	              Diagnostics._0_is_assignable_to_the_constraint_of_type_1_but_1_could_be_instantiated_with_a_different_subtype_of_constraint_2,
	              needsOriginalSource ? sourceType : generalizedSourceType,
	              targetType,
	              typeToString(constraint)
	            );
	          } else {
	            errorInfo = void 0;
	            reportError(
	              Diagnostics._0_could_be_instantiated_with_an_arbitrary_type_which_could_be_unrelated_to_1,
	              targetType,
	              generalizedSourceType
	            );
	          }
	        }
	        if (!message) {
	          if (relation === comparableRelation) {
	            message = Diagnostics.Type_0_is_not_comparable_to_type_1;
	          } else if (sourceType === targetType) {
	            message = Diagnostics.Type_0_is_not_assignable_to_type_1_Two_different_types_with_this_name_exist_but_they_are_unrelated;
	          } else if (exactOptionalPropertyTypes && getExactOptionalUnassignableProperties(source2, target2).length) {
	            message = Diagnostics.Type_0_is_not_assignable_to_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_types_of_the_target_s_properties;
	          } else {
	            if (source2.flags & 128 /* StringLiteral */ && target2.flags & 1048576 /* Union */) {
	              const suggestedType = getSuggestedTypeForNonexistentStringLiteralType(source2, target2);
	              if (suggestedType) {
	                reportError(Diagnostics.Type_0_is_not_assignable_to_type_1_Did_you_mean_2, generalizedSourceType, targetType, typeToString(suggestedType));
	                return;
	              }
	            }
	            message = Diagnostics.Type_0_is_not_assignable_to_type_1;
	          }
	        } else if (message === Diagnostics.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1 && exactOptionalPropertyTypes && getExactOptionalUnassignableProperties(source2, target2).length) {
	          message = Diagnostics.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_types_of_the_target_s_properties;
	        }
	        reportError(message, generalizedSourceType, targetType);
	      }
	      function tryElaborateErrorsForPrimitivesAndObjects(source2, target2) {
	        const sourceType = symbolValueDeclarationIsContextSensitive(source2.symbol) ? typeToString(source2, source2.symbol.valueDeclaration) : typeToString(source2);
	        const targetType = symbolValueDeclarationIsContextSensitive(target2.symbol) ? typeToString(target2, target2.symbol.valueDeclaration) : typeToString(target2);
	        if (globalStringType === source2 && stringType === target2 || globalNumberType === source2 && numberType === target2 || globalBooleanType === source2 && booleanType === target2 || getGlobalESSymbolType() === source2 && esSymbolType === target2) {
	          reportError(Diagnostics._0_is_a_primitive_but_1_is_a_wrapper_object_Prefer_using_0_when_possible, targetType, sourceType);
	        }
	      }
	      function tryElaborateArrayLikeErrors(source2, target2, reportErrors2) {
	        if (isTupleType(source2)) {
	          if (source2.target.readonly && isMutableArrayOrTuple(target2)) {
	            if (reportErrors2) {
	              reportError(Diagnostics.The_type_0_is_readonly_and_cannot_be_assigned_to_the_mutable_type_1, typeToString(source2), typeToString(target2));
	            }
	            return false;
	          }
	          return isArrayOrTupleType(target2);
	        }
	        if (isReadonlyArrayType(source2) && isMutableArrayOrTuple(target2)) {
	          if (reportErrors2) {
	            reportError(Diagnostics.The_type_0_is_readonly_and_cannot_be_assigned_to_the_mutable_type_1, typeToString(source2), typeToString(target2));
	          }
	          return false;
	        }
	        if (isTupleType(target2)) {
	          return isArrayType(source2);
	        }
	        return true;
	      }
	      function isRelatedToWorker(source2, target2, reportErrors2) {
	        return isRelatedTo(source2, target2, 3 /* Both */, reportErrors2);
	      }
	      function isRelatedTo(originalSource, originalTarget, recursionFlags = 3 /* Both */, reportErrors2 = false, headMessage2, intersectionState = 0 /* None */) {
	        if (originalSource === originalTarget)
	          return -1 /* True */;
	        if (originalSource.flags & 524288 /* Object */ && originalTarget.flags & 402784252 /* Primitive */) {
	          if (relation === comparableRelation && !(originalTarget.flags & 131072 /* Never */) && isSimpleTypeRelatedTo(originalTarget, originalSource, relation) || isSimpleTypeRelatedTo(originalSource, originalTarget, relation, reportErrors2 ? reportError : void 0)) {
	            return -1 /* True */;
	          }
	          if (reportErrors2) {
	            reportErrorResults(originalSource, originalTarget, originalSource, originalTarget, headMessage2);
	          }
	          return 0 /* False */;
	        }
	        const source2 = getNormalizedType(
	          originalSource,
	          /*writing*/
	          false
	        );
	        let target2 = getNormalizedType(
	          originalTarget,
	          /*writing*/
	          true
	        );
	        if (source2 === target2)
	          return -1 /* True */;
	        if (relation === identityRelation) {
	          if (source2.flags !== target2.flags)
	            return 0 /* False */;
	          if (source2.flags & 67358815 /* Singleton */)
	            return -1 /* True */;
	          traceUnionsOrIntersectionsTooLarge(source2, target2);
	          return recursiveTypeRelatedTo(
	            source2,
	            target2,
	            /*reportErrors*/
	            false,
	            0 /* None */,
	            recursionFlags
	          );
	        }
	        if (source2.flags & 262144 /* TypeParameter */ && getConstraintOfType(source2) === target2) {
	          return -1 /* True */;
	        }
	        if (source2.flags & 470302716 /* DefinitelyNonNullable */ && target2.flags & 1048576 /* Union */) {
	          const types = target2.types;
	          const candidate = types.length === 2 && types[0].flags & 98304 /* Nullable */ ? types[1] : types.length === 3 && types[0].flags & 98304 /* Nullable */ && types[1].flags & 98304 /* Nullable */ ? types[2] : void 0;
	          if (candidate && !(candidate.flags & 98304 /* Nullable */)) {
	            target2 = getNormalizedType(
	              candidate,
	              /*writing*/
	              true
	            );
	            if (source2 === target2)
	              return -1 /* True */;
	          }
	        }
	        if (relation === comparableRelation && !(target2.flags & 131072 /* Never */) && isSimpleTypeRelatedTo(target2, source2, relation) || isSimpleTypeRelatedTo(source2, target2, relation, reportErrors2 ? reportError : void 0))
	          return -1 /* True */;
	        if (source2.flags & 469499904 /* StructuredOrInstantiable */ || target2.flags & 469499904 /* StructuredOrInstantiable */) {
	          const isPerformingExcessPropertyChecks = !(intersectionState & 2 /* Target */) && (isObjectLiteralType2(source2) && getObjectFlags(source2) & 8192 /* FreshLiteral */);
	          if (isPerformingExcessPropertyChecks) {
	            if (hasExcessProperties(source2, target2, reportErrors2)) {
	              if (reportErrors2) {
	                reportRelationError(headMessage2, source2, originalTarget.aliasSymbol ? originalTarget : target2);
	              }
	              return 0 /* False */;
	            }
	          }
	          const isPerformingCommonPropertyChecks = (relation !== comparableRelation || isUnitType(source2)) && !(intersectionState & 2 /* Target */) && source2.flags & (402784252 /* Primitive */ | 524288 /* Object */ | 2097152 /* Intersection */) && source2 !== globalObjectType && target2.flags & (524288 /* Object */ | 2097152 /* Intersection */) && isWeakType(target2) && (getPropertiesOfType(source2).length > 0 || typeHasCallOrConstructSignatures(source2));
	          const isComparingJsxAttributes = !!(getObjectFlags(source2) & 2048 /* JsxAttributes */);
	          if (isPerformingCommonPropertyChecks && !hasCommonProperties(source2, target2, isComparingJsxAttributes)) {
	            if (reportErrors2) {
	              const sourceString = typeToString(originalSource.aliasSymbol ? originalSource : source2);
	              const targetString = typeToString(originalTarget.aliasSymbol ? originalTarget : target2);
	              const calls = getSignaturesOfType(source2, 0 /* Call */);
	              const constructs = getSignaturesOfType(source2, 1 /* Construct */);
	              if (calls.length > 0 && isRelatedTo(
	                getReturnTypeOfSignature(calls[0]),
	                target2,
	                1 /* Source */,
	                /*reportErrors*/
	                false
	              ) || constructs.length > 0 && isRelatedTo(
	                getReturnTypeOfSignature(constructs[0]),
	                target2,
	                1 /* Source */,
	                /*reportErrors*/
	                false
	              )) {
	                reportError(Diagnostics.Value_of_type_0_has_no_properties_in_common_with_type_1_Did_you_mean_to_call_it, sourceString, targetString);
	              } else {
	                reportError(Diagnostics.Type_0_has_no_properties_in_common_with_type_1, sourceString, targetString);
	              }
	            }
	            return 0 /* False */;
	          }
	          traceUnionsOrIntersectionsTooLarge(source2, target2);
	          const skipCaching = source2.flags & 1048576 /* Union */ && source2.types.length < 4 && !(target2.flags & 1048576 /* Union */) || target2.flags & 1048576 /* Union */ && target2.types.length < 4 && !(source2.flags & 469499904 /* StructuredOrInstantiable */);
	          const result2 = skipCaching ? unionOrIntersectionRelatedTo(source2, target2, reportErrors2, intersectionState) : recursiveTypeRelatedTo(source2, target2, reportErrors2, intersectionState, recursionFlags);
	          if (result2) {
	            return result2;
	          }
	        }
	        if (reportErrors2) {
	          reportErrorResults(originalSource, originalTarget, source2, target2, headMessage2);
	        }
	        return 0 /* False */;
	      }
	      function reportErrorResults(originalSource, originalTarget, source2, target2, headMessage2) {
	        var _a2, _b;
	        const sourceHasBase = !!getSingleBaseForNonAugmentingSubtype(originalSource);
	        const targetHasBase = !!getSingleBaseForNonAugmentingSubtype(originalTarget);
	        source2 = originalSource.aliasSymbol || sourceHasBase ? originalSource : source2;
	        target2 = originalTarget.aliasSymbol || targetHasBase ? originalTarget : target2;
	        let maybeSuppress = overrideNextErrorInfo > 0;
	        if (maybeSuppress) {
	          overrideNextErrorInfo--;
	        }
	        if (source2.flags & 524288 /* Object */ && target2.flags & 524288 /* Object */) {
	          const currentError = errorInfo;
	          tryElaborateArrayLikeErrors(
	            source2,
	            target2,
	            /*reportErrors*/
	            true
	          );
	          if (errorInfo !== currentError) {
	            maybeSuppress = !!errorInfo;
	          }
	        }
	        if (source2.flags & 524288 /* Object */ && target2.flags & 402784252 /* Primitive */) {
	          tryElaborateErrorsForPrimitivesAndObjects(source2, target2);
	        } else if (source2.symbol && source2.flags & 524288 /* Object */ && globalObjectType === source2) {
	          reportError(Diagnostics.The_Object_type_is_assignable_to_very_few_other_types_Did_you_mean_to_use_the_any_type_instead);
	        } else if (getObjectFlags(source2) & 2048 /* JsxAttributes */ && target2.flags & 2097152 /* Intersection */) {
	          const targetTypes = target2.types;
	          const intrinsicAttributes = getJsxType(JsxNames.IntrinsicAttributes, errorNode);
	          const intrinsicClassAttributes = getJsxType(JsxNames.IntrinsicClassAttributes, errorNode);
	          if (!isErrorType(intrinsicAttributes) && !isErrorType(intrinsicClassAttributes) && (contains(targetTypes, intrinsicAttributes) || contains(targetTypes, intrinsicClassAttributes))) {
	            return;
	          }
	        } else {
	          errorInfo = elaborateNeverIntersection(errorInfo, originalTarget);
	        }
	        if (!headMessage2 && maybeSuppress) {
	          lastSkippedInfo = [source2, target2];
	          return;
	        }
	        reportRelationError(headMessage2, source2, target2);
	        if (source2.flags & 262144 /* TypeParameter */ && ((_b = (_a2 = source2.symbol) == null ? void 0 : _a2.declarations) == null ? void 0 : _b[0]) && !getConstraintOfType(source2)) {
	          const syntheticParam = cloneTypeParameter(source2);
	          syntheticParam.constraint = instantiateType(target2, makeUnaryTypeMapper(source2, syntheticParam));
	          if (hasNonCircularBaseConstraint(syntheticParam)) {
	            const targetConstraintString = typeToString(target2, source2.symbol.declarations[0]);
	            associateRelatedInfo(createDiagnosticForNode(source2.symbol.declarations[0], Diagnostics.This_type_parameter_might_need_an_extends_0_constraint, targetConstraintString));
	          }
	        }
	      }
	      function traceUnionsOrIntersectionsTooLarge(source2, target2) {
	        if (!tracing) {
	          return;
	        }
	        if (source2.flags & 3145728 /* UnionOrIntersection */ && target2.flags & 3145728 /* UnionOrIntersection */) {
	          const sourceUnionOrIntersection = source2;
	          const targetUnionOrIntersection = target2;
	          if (sourceUnionOrIntersection.objectFlags & targetUnionOrIntersection.objectFlags & 32768 /* PrimitiveUnion */) {
	            return;
	          }
	          const sourceSize = sourceUnionOrIntersection.types.length;
	          const targetSize = targetUnionOrIntersection.types.length;
	          if (sourceSize * targetSize > 1e6) {
	            tracing.instant(tracing.Phase.CheckTypes, "traceUnionsOrIntersectionsTooLarge_DepthLimit", {
	              sourceId: source2.id,
	              sourceSize,
	              targetId: target2.id,
	              targetSize,
	              pos: errorNode == null ? void 0 : errorNode.pos,
	              end: errorNode == null ? void 0 : errorNode.end
	            });
	          }
	        }
	      }
	      function getTypeOfPropertyInTypes(types, name) {
	        const appendPropType = (propTypes, type) => {
	          var _a2;
	          type = getApparentType(type);
	          const prop = type.flags & 3145728 /* UnionOrIntersection */ ? getPropertyOfUnionOrIntersectionType(type, name) : getPropertyOfObjectType(type, name);
	          const propType = prop && getTypeOfSymbol(prop) || ((_a2 = getApplicableIndexInfoForName(type, name)) == null ? void 0 : _a2.type) || undefinedType;
	          return append(propTypes, propType);
	        };
	        return getUnionType(reduceLeft(
	          types,
	          appendPropType,
	          /*initial*/
	          void 0
	        ) || emptyArray);
	      }
	      function hasExcessProperties(source2, target2, reportErrors2) {
	        var _a2;
	        if (!isExcessPropertyCheckTarget(target2) || !noImplicitAny && getObjectFlags(target2) & 4096 /* JSLiteral */) {
	          return false;
	        }
	        const isComparingJsxAttributes = !!(getObjectFlags(source2) & 2048 /* JsxAttributes */);
	        if ((relation === assignableRelation || relation === comparableRelation) && (isTypeSubsetOf(globalObjectType, target2) || !isComparingJsxAttributes && isEmptyObjectType(target2))) {
	          return false;
	        }
	        let reducedTarget = target2;
	        let checkTypes;
	        if (target2.flags & 1048576 /* Union */) {
	          reducedTarget = findMatchingDiscriminantType(source2, target2, isRelatedTo) || filterPrimitivesIfContainsNonPrimitive(target2);
	          checkTypes = reducedTarget.flags & 1048576 /* Union */ ? reducedTarget.types : [reducedTarget];
	        }
	        for (const prop of getPropertiesOfType(source2)) {
	          if (shouldCheckAsExcessProperty(prop, source2.symbol) && !isIgnoredJsxProperty(source2, prop)) {
	            if (!isKnownProperty(reducedTarget, prop.escapedName, isComparingJsxAttributes)) {
	              if (reportErrors2) {
	                const errorTarget = filterType(reducedTarget, isExcessPropertyCheckTarget);
	                if (!errorNode)
	                  return Debug.fail();
	                if (isJsxAttributes(errorNode) || isJsxOpeningLikeElement(errorNode) || isJsxOpeningLikeElement(errorNode.parent)) {
	                  if (prop.valueDeclaration && isJsxAttribute(prop.valueDeclaration) && getSourceFileOfNode(errorNode) === getSourceFileOfNode(prop.valueDeclaration.name)) {
	                    errorNode = prop.valueDeclaration.name;
	                  }
	                  const propName = symbolToString(prop);
	                  const suggestionSymbol = getSuggestedSymbolForNonexistentJSXAttribute(propName, errorTarget);
	                  const suggestion = suggestionSymbol ? symbolToString(suggestionSymbol) : void 0;
	                  if (suggestion) {
	                    reportError(Diagnostics.Property_0_does_not_exist_on_type_1_Did_you_mean_2, propName, typeToString(errorTarget), suggestion);
	                  } else {
	                    reportError(Diagnostics.Property_0_does_not_exist_on_type_1, propName, typeToString(errorTarget));
	                  }
	                } else {
	                  const objectLiteralDeclaration = ((_a2 = source2.symbol) == null ? void 0 : _a2.declarations) && firstOrUndefined(source2.symbol.declarations);
	                  let suggestion;
	                  if (prop.valueDeclaration && findAncestor(prop.valueDeclaration, (d) => d === objectLiteralDeclaration) && getSourceFileOfNode(objectLiteralDeclaration) === getSourceFileOfNode(errorNode)) {
	                    const propDeclaration = prop.valueDeclaration;
	                    Debug.assertNode(propDeclaration, isObjectLiteralElementLike);
	                    const name = propDeclaration.name;
	                    errorNode = name;
	                    if (isIdentifier(name)) {
	                      suggestion = getSuggestionForNonexistentProperty(name, errorTarget);
	                    }
	                  }
	                  if (suggestion !== void 0) {
	                    reportParentSkippedError(Diagnostics.Object_literal_may_only_specify_known_properties_but_0_does_not_exist_in_type_1_Did_you_mean_to_write_2, symbolToString(prop), typeToString(errorTarget), suggestion);
	                  } else {
	                    reportParentSkippedError(Diagnostics.Object_literal_may_only_specify_known_properties_and_0_does_not_exist_in_type_1, symbolToString(prop), typeToString(errorTarget));
	                  }
	                }
	              }
	              return true;
	            }
	            if (checkTypes && !isRelatedTo(getTypeOfSymbol(prop), getTypeOfPropertyInTypes(checkTypes, prop.escapedName), 3 /* Both */, reportErrors2)) {
	              if (reportErrors2) {
	                reportIncompatibleError(Diagnostics.Types_of_property_0_are_incompatible, symbolToString(prop));
	              }
	              return true;
	            }
	          }
	        }
	        return false;
	      }
	      function shouldCheckAsExcessProperty(prop, container) {
	        return prop.valueDeclaration && container.valueDeclaration && prop.valueDeclaration.parent === container.valueDeclaration;
	      }
	      function unionOrIntersectionRelatedTo(source2, target2, reportErrors2, intersectionState) {
	        if (source2.flags & 1048576 /* Union */) {
	          if (target2.flags & 1048576 /* Union */) {
	            const sourceOrigin = source2.origin;
	            if (sourceOrigin && sourceOrigin.flags & 2097152 /* Intersection */ && target2.aliasSymbol && contains(sourceOrigin.types, target2)) {
	              return -1 /* True */;
	            }
	            const targetOrigin = target2.origin;
	            if (targetOrigin && targetOrigin.flags & 1048576 /* Union */ && source2.aliasSymbol && contains(targetOrigin.types, source2)) {
	              return -1 /* True */;
	            }
	          }
	          return relation === comparableRelation ? someTypeRelatedToType(source2, target2, reportErrors2 && !(source2.flags & 402784252 /* Primitive */), intersectionState) : eachTypeRelatedToType(source2, target2, reportErrors2 && !(source2.flags & 402784252 /* Primitive */), intersectionState);
	        }
	        if (target2.flags & 1048576 /* Union */) {
	          return typeRelatedToSomeType(getRegularTypeOfObjectLiteral(source2), target2, reportErrors2 && !(source2.flags & 402784252 /* Primitive */) && !(target2.flags & 402784252 /* Primitive */), intersectionState);
	        }
	        if (target2.flags & 2097152 /* Intersection */) {
	          return typeRelatedToEachType(source2, target2, reportErrors2, 2 /* Target */);
	        }
	        if (relation === comparableRelation && target2.flags & 402784252 /* Primitive */) {
	          const constraints = sameMap(source2.types, (t) => t.flags & 465829888 /* Instantiable */ ? getBaseConstraintOfType(t) || unknownType : t);
	          if (constraints !== source2.types) {
	            source2 = getIntersectionType(constraints);
	            if (source2.flags & 131072 /* Never */) {
	              return 0 /* False */;
	            }
	            if (!(source2.flags & 2097152 /* Intersection */)) {
	              return isRelatedTo(
	                source2,
	                target2,
	                1 /* Source */,
	                /*reportErrors*/
	                false
	              ) || isRelatedTo(
	                target2,
	                source2,
	                1 /* Source */,
	                /*reportErrors*/
	                false
	              );
	            }
	          }
	        }
	        return someTypeRelatedToType(
	          source2,
	          target2,
	          /*reportErrors*/
	          false,
	          1 /* Source */
	        );
	      }
	      function eachTypeRelatedToSomeType(source2, target2) {
	        let result2 = -1 /* True */;
	        const sourceTypes = source2.types;
	        for (const sourceType of sourceTypes) {
	          const related = typeRelatedToSomeType(
	            sourceType,
	            target2,
	            /*reportErrors*/
	            false,
	            0 /* None */
	          );
	          if (!related) {
	            return 0 /* False */;
	          }
	          result2 &= related;
	        }
	        return result2;
	      }
	      function typeRelatedToSomeType(source2, target2, reportErrors2, intersectionState) {
	        const targetTypes = target2.types;
	        if (target2.flags & 1048576 /* Union */) {
	          if (containsType(targetTypes, source2)) {
	            return -1 /* True */;
	          }
	          if (relation !== comparableRelation && getObjectFlags(target2) & 32768 /* PrimitiveUnion */ && !(source2.flags & 1024 /* EnumLiteral */) && (source2.flags & (128 /* StringLiteral */ | 512 /* BooleanLiteral */ | 2048 /* BigIntLiteral */) || (relation === subtypeRelation || relation === strictSubtypeRelation) && source2.flags & 256 /* NumberLiteral */)) {
	            const alternateForm = source2 === source2.regularType ? source2.freshType : source2.regularType;
	            const primitive = source2.flags & 128 /* StringLiteral */ ? stringType : source2.flags & 256 /* NumberLiteral */ ? numberType : source2.flags & 2048 /* BigIntLiteral */ ? bigintType : void 0;
	            return primitive && containsType(targetTypes, primitive) || alternateForm && containsType(targetTypes, alternateForm) ? -1 /* True */ : 0 /* False */;
	          }
	          const match = getMatchingUnionConstituentForType(target2, source2);
	          if (match) {
	            const related = isRelatedTo(
	              source2,
	              match,
	              2 /* Target */,
	              /*reportErrors*/
	              false,
	              /*headMessage*/
	              void 0,
	              intersectionState
	            );
	            if (related) {
	              return related;
	            }
	          }
	        }
	        for (const type of targetTypes) {
	          const related = isRelatedTo(
	            source2,
	            type,
	            2 /* Target */,
	            /*reportErrors*/
	            false,
	            /*headMessage*/
	            void 0,
	            intersectionState
	          );
	          if (related) {
	            return related;
	          }
	        }
	        if (reportErrors2) {
	          const bestMatchingType = getBestMatchingType(source2, target2, isRelatedTo);
	          if (bestMatchingType) {
	            isRelatedTo(
	              source2,
	              bestMatchingType,
	              2 /* Target */,
	              /*reportErrors*/
	              true,
	              /*headMessage*/
	              void 0,
	              intersectionState
	            );
	          }
	        }
	        return 0 /* False */;
	      }
	      function typeRelatedToEachType(source2, target2, reportErrors2, intersectionState) {
	        let result2 = -1 /* True */;
	        const targetTypes = target2.types;
	        for (const targetType of targetTypes) {
	          const related = isRelatedTo(
	            source2,
	            targetType,
	            2 /* Target */,
	            reportErrors2,
	            /*headMessage*/
	            void 0,
	            intersectionState
	          );
	          if (!related) {
	            return 0 /* False */;
	          }
	          result2 &= related;
	        }
	        return result2;
	      }
	      function someTypeRelatedToType(source2, target2, reportErrors2, intersectionState) {
	        const sourceTypes = source2.types;
	        if (source2.flags & 1048576 /* Union */ && containsType(sourceTypes, target2)) {
	          return -1 /* True */;
	        }
	        const len = sourceTypes.length;
	        for (let i = 0; i < len; i++) {
	          const related = isRelatedTo(
	            sourceTypes[i],
	            target2,
	            1 /* Source */,
	            reportErrors2 && i === len - 1,
	            /*headMessage*/
	            void 0,
	            intersectionState
	          );
	          if (related) {
	            return related;
	          }
	        }
	        return 0 /* False */;
	      }
	      function getUndefinedStrippedTargetIfNeeded(source2, target2) {
	        if (source2.flags & 1048576 /* Union */ && target2.flags & 1048576 /* Union */ && !(source2.types[0].flags & 32768 /* Undefined */) && target2.types[0].flags & 32768 /* Undefined */) {
	          return extractTypesOfKind(target2, ~32768 /* Undefined */);
	        }
	        return target2;
	      }
	      function eachTypeRelatedToType(source2, target2, reportErrors2, intersectionState) {
	        let result2 = -1 /* True */;
	        const sourceTypes = source2.types;
	        const undefinedStrippedTarget = getUndefinedStrippedTargetIfNeeded(source2, target2);
	        for (let i = 0; i < sourceTypes.length; i++) {
	          const sourceType = sourceTypes[i];
	          if (undefinedStrippedTarget.flags & 1048576 /* Union */ && sourceTypes.length >= undefinedStrippedTarget.types.length && sourceTypes.length % undefinedStrippedTarget.types.length === 0) {
	            const related2 = isRelatedTo(
	              sourceType,
	              undefinedStrippedTarget.types[i % undefinedStrippedTarget.types.length],
	              3 /* Both */,
	              /*reportErrors*/
	              false,
	              /*headMessage*/
	              void 0,
	              intersectionState
	            );
	            if (related2) {
	              result2 &= related2;
	              continue;
	            }
	          }
	          const related = isRelatedTo(
	            sourceType,
	            target2,
	            1 /* Source */,
	            reportErrors2,
	            /*headMessage*/
	            void 0,
	            intersectionState
	          );
	          if (!related) {
	            return 0 /* False */;
	          }
	          result2 &= related;
	        }
	        return result2;
	      }
	      function typeArgumentsRelatedTo(sources = emptyArray, targets = emptyArray, variances = emptyArray, reportErrors2, intersectionState) {
	        if (sources.length !== targets.length && relation === identityRelation) {
	          return 0 /* False */;
	        }
	        const length2 = sources.length <= targets.length ? sources.length : targets.length;
	        let result2 = -1 /* True */;
	        for (let i = 0; i < length2; i++) {
	          const varianceFlags = i < variances.length ? variances[i] : 1 /* Covariant */;
	          const variance = varianceFlags & 7 /* VarianceMask */;
	          if (variance !== 4 /* Independent */) {
	            const s = sources[i];
	            const t = targets[i];
	            let related = -1 /* True */;
	            if (varianceFlags & 8 /* Unmeasurable */) {
	              related = relation === identityRelation ? isRelatedTo(
	                s,
	                t,
	                3 /* Both */,
	                /*reportErrors*/
	                false
	              ) : compareTypesIdentical(s, t);
	            } else if (variance === 1 /* Covariant */) {
	              related = isRelatedTo(
	                s,
	                t,
	                3 /* Both */,
	                reportErrors2,
	                /*headMessage*/
	                void 0,
	                intersectionState
	              );
	            } else if (variance === 2 /* Contravariant */) {
	              related = isRelatedTo(
	                t,
	                s,
	                3 /* Both */,
	                reportErrors2,
	                /*headMessage*/
	                void 0,
	                intersectionState
	              );
	            } else if (variance === 3 /* Bivariant */) {
	              related = isRelatedTo(
	                t,
	                s,
	                3 /* Both */,
	                /*reportErrors*/
	                false
	              );
	              if (!related) {
	                related = isRelatedTo(
	                  s,
	                  t,
	                  3 /* Both */,
	                  reportErrors2,
	                  /*headMessage*/
	                  void 0,
	                  intersectionState
	                );
	              }
	            } else {
	              related = isRelatedTo(
	                s,
	                t,
	                3 /* Both */,
	                reportErrors2,
	                /*headMessage*/
	                void 0,
	                intersectionState
	              );
	              if (related) {
	                related &= isRelatedTo(
	                  t,
	                  s,
	                  3 /* Both */,
	                  reportErrors2,
	                  /*headMessage*/
	                  void 0,
	                  intersectionState
	                );
	              }
	            }
	            if (!related) {
	              return 0 /* False */;
	            }
	            result2 &= related;
	          }
	        }
	        return result2;
	      }
	      function recursiveTypeRelatedTo(source2, target2, reportErrors2, intersectionState, recursionFlags) {
	        var _a2, _b, _c;
	        if (overflow) {
	          return 0 /* False */;
	        }
	        const id = getRelationKey(
	          source2,
	          target2,
	          intersectionState,
	          relation,
	          /*ignoreConstraints*/
	          false
	        );
	        const entry = relation.get(id);
	        if (entry !== void 0) {
	          if (reportErrors2 && entry & 2 /* Failed */ && !(entry & 4 /* Reported */)) ; else {
	            if (outofbandVarianceMarkerHandler) {
	              const saved = entry & 24 /* ReportsMask */;
	              if (saved & 8 /* ReportsUnmeasurable */) {
	                instantiateType(source2, reportUnmeasurableMapper);
	              }
	              if (saved & 16 /* ReportsUnreliable */) {
	                instantiateType(source2, reportUnreliableMapper);
	              }
	            }
	            return entry & 1 /* Succeeded */ ? -1 /* True */ : 0 /* False */;
	          }
	        }
	        if (relationCount <= 0) {
	          overflow = true;
	          return 0 /* False */;
	        }
	        if (!maybeKeys) {
	          maybeKeys = [];
	          maybeKeysSet = /* @__PURE__ */ new Set();
	          sourceStack = [];
	          targetStack = [];
	        } else {
	          if (maybeKeysSet.has(id)) {
	            return 3 /* Maybe */;
	          }
	          const broadestEquivalentId = id.startsWith("*") ? getRelationKey(
	            source2,
	            target2,
	            intersectionState,
	            relation,
	            /*ignoreConstraints*/
	            true
	          ) : void 0;
	          if (broadestEquivalentId && maybeKeysSet.has(broadestEquivalentId)) {
	            return 3 /* Maybe */;
	          }
	          if (sourceDepth === 100 || targetDepth === 100) {
	            overflow = true;
	            return 0 /* False */;
	          }
	        }
	        const maybeStart = maybeCount;
	        maybeKeys[maybeCount] = id;
	        maybeKeysSet.add(id);
	        maybeCount++;
	        const saveExpandingFlags = expandingFlags;
	        if (recursionFlags & 1 /* Source */) {
	          sourceStack[sourceDepth] = source2;
	          sourceDepth++;
	          if (!(expandingFlags & 1 /* Source */) && isDeeplyNestedType(source2, sourceStack, sourceDepth))
	            expandingFlags |= 1 /* Source */;
	        }
	        if (recursionFlags & 2 /* Target */) {
	          targetStack[targetDepth] = target2;
	          targetDepth++;
	          if (!(expandingFlags & 2 /* Target */) && isDeeplyNestedType(target2, targetStack, targetDepth))
	            expandingFlags |= 2 /* Target */;
	        }
	        let originalHandler;
	        let propagatingVarianceFlags = 0;
	        if (outofbandVarianceMarkerHandler) {
	          originalHandler = outofbandVarianceMarkerHandler;
	          outofbandVarianceMarkerHandler = (onlyUnreliable) => {
	            propagatingVarianceFlags |= onlyUnreliable ? 16 /* ReportsUnreliable */ : 8 /* ReportsUnmeasurable */;
	            return originalHandler(onlyUnreliable);
	          };
	        }
	        let result2;
	        if (expandingFlags === 3 /* Both */) {
	          (_a2 = tracing) == null ? void 0 : _a2.instant(tracing.Phase.CheckTypes, "recursiveTypeRelatedTo_DepthLimit", {
	            sourceId: source2.id,
	            sourceIdStack: sourceStack.map((t) => t.id),
	            targetId: target2.id,
	            targetIdStack: targetStack.map((t) => t.id),
	            depth: sourceDepth,
	            targetDepth
	          });
	          result2 = 3 /* Maybe */;
	        } else {
	          (_b = tracing) == null ? void 0 : _b.push(tracing.Phase.CheckTypes, "structuredTypeRelatedTo", { sourceId: source2.id, targetId: target2.id });
	          result2 = structuredTypeRelatedTo(source2, target2, reportErrors2, intersectionState);
	          (_c = tracing) == null ? void 0 : _c.pop();
	        }
	        if (outofbandVarianceMarkerHandler) {
	          outofbandVarianceMarkerHandler = originalHandler;
	        }
	        if (recursionFlags & 1 /* Source */) {
	          sourceDepth--;
	        }
	        if (recursionFlags & 2 /* Target */) {
	          targetDepth--;
	        }
	        expandingFlags = saveExpandingFlags;
	        if (result2) {
	          if (result2 === -1 /* True */ || sourceDepth === 0 && targetDepth === 0) {
	            if (result2 === -1 /* True */ || result2 === 3 /* Maybe */) {
	              resetMaybeStack(
	                /*markAllAsSucceeded*/
	                true
	              );
	            } else {
	              resetMaybeStack(
	                /*markAllAsSucceeded*/
	                false
	              );
	            }
	          }
	        } else {
	          relation.set(id, (reportErrors2 ? 4 /* Reported */ : 0) | 2 /* Failed */ | propagatingVarianceFlags);
	          relationCount--;
	          resetMaybeStack(
	            /*markAllAsSucceeded*/
	            false
	          );
	        }
	        return result2;
	        function resetMaybeStack(markAllAsSucceeded) {
	          for (let i = maybeStart; i < maybeCount; i++) {
	            maybeKeysSet.delete(maybeKeys[i]);
	            if (markAllAsSucceeded) {
	              relation.set(maybeKeys[i], 1 /* Succeeded */ | propagatingVarianceFlags);
	              relationCount--;
	            }
	          }
	          maybeCount = maybeStart;
	        }
	      }
	      function structuredTypeRelatedTo(source2, target2, reportErrors2, intersectionState) {
	        const saveErrorInfo = captureErrorCalculationState();
	        let result2 = structuredTypeRelatedToWorker(source2, target2, reportErrors2, intersectionState, saveErrorInfo);
	        if (relation !== identityRelation) {
	          if (!result2 && (source2.flags & 2097152 /* Intersection */ || source2.flags & 262144 /* TypeParameter */ && target2.flags & 1048576 /* Union */)) {
	            const constraint = getEffectiveConstraintOfIntersection(source2.flags & 2097152 /* Intersection */ ? source2.types : [source2], !!(target2.flags & 1048576 /* Union */));
	            if (constraint && everyType(constraint, (c) => c !== source2)) {
	              result2 = isRelatedTo(
	                constraint,
	                target2,
	                1 /* Source */,
	                /*reportErrors*/
	                false,
	                /*headMessage*/
	                void 0,
	                intersectionState
	              );
	            }
	          }
	          if (result2 && !(intersectionState & 2 /* Target */) && target2.flags & 2097152 /* Intersection */ && !isGenericObjectType(target2) && source2.flags & (524288 /* Object */ | 2097152 /* Intersection */)) {
	            result2 &= propertiesRelatedTo(
	              source2,
	              target2,
	              reportErrors2,
	              /*excludedProperties*/
	              void 0,
	              /*optionalsOnly*/
	              false,
	              0 /* None */
	            );
	            if (result2 && isObjectLiteralType2(source2) && getObjectFlags(source2) & 8192 /* FreshLiteral */) {
	              result2 &= indexSignaturesRelatedTo(
	                source2,
	                target2,
	                /*sourceIsPrimitive*/
	                false,
	                reportErrors2,
	                0 /* None */
	              );
	            }
	          } else if (result2 && isNonGenericObjectType(target2) && !isArrayOrTupleType(target2) && source2.flags & 2097152 /* Intersection */ && getApparentType(source2).flags & 3670016 /* StructuredType */ && !some(source2.types, (t) => t === target2 || !!(getObjectFlags(t) & 262144 /* NonInferrableType */))) {
	            result2 &= propertiesRelatedTo(
	              source2,
	              target2,
	              reportErrors2,
	              /*excludedProperties*/
	              void 0,
	              /*optionalsOnly*/
	              true,
	              intersectionState
	            );
	          }
	        }
	        if (result2) {
	          resetErrorInfo(saveErrorInfo);
	        }
	        return result2;
	      }
	      function getApparentMappedTypeKeys(nameType, targetType) {
	        const modifiersType = getApparentType(getModifiersTypeFromMappedType(targetType));
	        const mappedKeys = [];
	        forEachMappedTypePropertyKeyTypeAndIndexSignatureKeyType(
	          modifiersType,
	          8576 /* StringOrNumberLiteralOrUnique */,
	          /*stringsOnly*/
	          false,
	          (t) => void mappedKeys.push(instantiateType(nameType, appendTypeMapping(targetType.mapper, getTypeParameterFromMappedType(targetType), t)))
	        );
	        return getUnionType(mappedKeys);
	      }
	      function structuredTypeRelatedToWorker(source2, target2, reportErrors2, intersectionState, saveErrorInfo) {
	        let result2;
	        let originalErrorInfo;
	        let varianceCheckFailed = false;
	        let sourceFlags = source2.flags;
	        const targetFlags = target2.flags;
	        if (relation === identityRelation) {
	          if (sourceFlags & 3145728 /* UnionOrIntersection */) {
	            let result3 = eachTypeRelatedToSomeType(source2, target2);
	            if (result3) {
	              result3 &= eachTypeRelatedToSomeType(target2, source2);
	            }
	            return result3;
	          }
	          if (sourceFlags & 4194304 /* Index */) {
	            return isRelatedTo(
	              source2.type,
	              target2.type,
	              3 /* Both */,
	              /*reportErrors*/
	              false
	            );
	          }
	          if (sourceFlags & 8388608 /* IndexedAccess */) {
	            if (result2 = isRelatedTo(
	              source2.objectType,
	              target2.objectType,
	              3 /* Both */,
	              /*reportErrors*/
	              false
	            )) {
	              if (result2 &= isRelatedTo(
	                source2.indexType,
	                target2.indexType,
	                3 /* Both */,
	                /*reportErrors*/
	                false
	              )) {
	                return result2;
	              }
	            }
	          }
	          if (sourceFlags & 16777216 /* Conditional */) {
	            if (source2.root.isDistributive === target2.root.isDistributive) {
	              if (result2 = isRelatedTo(
	                source2.checkType,
	                target2.checkType,
	                3 /* Both */,
	                /*reportErrors*/
	                false
	              )) {
	                if (result2 &= isRelatedTo(
	                  source2.extendsType,
	                  target2.extendsType,
	                  3 /* Both */,
	                  /*reportErrors*/
	                  false
	                )) {
	                  if (result2 &= isRelatedTo(
	                    getTrueTypeFromConditionalType(source2),
	                    getTrueTypeFromConditionalType(target2),
	                    3 /* Both */,
	                    /*reportErrors*/
	                    false
	                  )) {
	                    if (result2 &= isRelatedTo(
	                      getFalseTypeFromConditionalType(source2),
	                      getFalseTypeFromConditionalType(target2),
	                      3 /* Both */,
	                      /*reportErrors*/
	                      false
	                    )) {
	                      return result2;
	                    }
	                  }
	                }
	              }
	            }
	          }
	          if (sourceFlags & 33554432 /* Substitution */) {
	            if (result2 = isRelatedTo(
	              source2.baseType,
	              target2.baseType,
	              3 /* Both */,
	              /*reportErrors*/
	              false
	            )) {
	              if (result2 &= isRelatedTo(
	                source2.constraint,
	                target2.constraint,
	                3 /* Both */,
	                /*reportErrors*/
	                false
	              )) {
	                return result2;
	              }
	            }
	          }
	          if (!(sourceFlags & 524288 /* Object */)) {
	            return 0 /* False */;
	          }
	        } else if (sourceFlags & 3145728 /* UnionOrIntersection */ || targetFlags & 3145728 /* UnionOrIntersection */) {
	          if (result2 = unionOrIntersectionRelatedTo(source2, target2, reportErrors2, intersectionState)) {
	            return result2;
	          }
	          if (!(sourceFlags & 465829888 /* Instantiable */ || sourceFlags & 524288 /* Object */ && targetFlags & 1048576 /* Union */ || sourceFlags & 2097152 /* Intersection */ && targetFlags & (524288 /* Object */ | 1048576 /* Union */ | 465829888 /* Instantiable */))) {
	            return 0 /* False */;
	          }
	        }
	        if (sourceFlags & (524288 /* Object */ | 16777216 /* Conditional */) && source2.aliasSymbol && source2.aliasTypeArguments && source2.aliasSymbol === target2.aliasSymbol && !(isMarkerType(source2) || isMarkerType(target2))) {
	          const variances = getAliasVariances(source2.aliasSymbol);
	          if (variances === emptyArray) {
	            return 1 /* Unknown */;
	          }
	          const params = getSymbolLinks(source2.aliasSymbol).typeParameters;
	          const minParams = getMinTypeArgumentCount(params);
	          const sourceTypes = fillMissingTypeArguments(source2.aliasTypeArguments, params, minParams, isInJSFile(source2.aliasSymbol.valueDeclaration));
	          const targetTypes = fillMissingTypeArguments(target2.aliasTypeArguments, params, minParams, isInJSFile(source2.aliasSymbol.valueDeclaration));
	          const varianceResult = relateVariances(sourceTypes, targetTypes, variances, intersectionState);
	          if (varianceResult !== void 0) {
	            return varianceResult;
	          }
	        }
	        if (isSingleElementGenericTupleType(source2) && !source2.target.readonly && (result2 = isRelatedTo(getTypeArguments(source2)[0], target2, 1 /* Source */)) || isSingleElementGenericTupleType(target2) && (target2.target.readonly || isMutableArrayOrTuple(getBaseConstraintOfType(source2) || source2)) && (result2 = isRelatedTo(source2, getTypeArguments(target2)[0], 2 /* Target */))) {
	          return result2;
	        }
	        if (targetFlags & 262144 /* TypeParameter */) {
	          if (getObjectFlags(source2) & 32 /* Mapped */ && !source2.declaration.nameType && isRelatedTo(getIndexType(target2), getConstraintTypeFromMappedType(source2), 3 /* Both */)) {
	            if (!(getMappedTypeModifiers(source2) & 4 /* IncludeOptional */)) {
	              const templateType = getTemplateTypeFromMappedType(source2);
	              const indexedAccessType = getIndexedAccessType(target2, getTypeParameterFromMappedType(source2));
	              if (result2 = isRelatedTo(templateType, indexedAccessType, 3 /* Both */, reportErrors2)) {
	                return result2;
	              }
	            }
	          }
	          if (relation === comparableRelation && sourceFlags & 262144 /* TypeParameter */) {
	            let constraint = getConstraintOfTypeParameter(source2);
	            if (constraint) {
	              while (constraint && someType(constraint, (c) => !!(c.flags & 262144 /* TypeParameter */))) {
	                if (result2 = isRelatedTo(
	                  constraint,
	                  target2,
	                  1 /* Source */,
	                  /*reportErrors*/
	                  false
	                )) {
	                  return result2;
	                }
	                constraint = getConstraintOfTypeParameter(constraint);
	              }
	            }
	            return 0 /* False */;
	          }
	        } else if (targetFlags & 4194304 /* Index */) {
	          const targetType = target2.type;
	          if (sourceFlags & 4194304 /* Index */) {
	            if (result2 = isRelatedTo(
	              targetType,
	              source2.type,
	              3 /* Both */,
	              /*reportErrors*/
	              false
	            )) {
	              return result2;
	            }
	          }
	          if (isTupleType(targetType)) {
	            if (result2 = isRelatedTo(source2, getKnownKeysOfTupleType(targetType), 2 /* Target */, reportErrors2)) {
	              return result2;
	            }
	          } else {
	            const constraint = getSimplifiedTypeOrConstraint(targetType);
	            if (constraint) {
	              if (isRelatedTo(source2, getIndexType(constraint, target2.indexFlags | 4 /* NoReducibleCheck */), 2 /* Target */, reportErrors2) === -1 /* True */) {
	                return -1 /* True */;
	              }
	            } else if (isGenericMappedType(targetType)) {
	              const nameType = getNameTypeFromMappedType(targetType);
	              const constraintType = getConstraintTypeFromMappedType(targetType);
	              let targetKeys;
	              if (nameType && isMappedTypeWithKeyofConstraintDeclaration(targetType)) {
	                const mappedKeys = getApparentMappedTypeKeys(nameType, targetType);
	                targetKeys = getUnionType([mappedKeys, nameType]);
	              } else {
	                targetKeys = nameType || constraintType;
	              }
	              if (isRelatedTo(source2, targetKeys, 2 /* Target */, reportErrors2) === -1 /* True */) {
	                return -1 /* True */;
	              }
	            }
	          }
	        } else if (targetFlags & 8388608 /* IndexedAccess */) {
	          if (sourceFlags & 8388608 /* IndexedAccess */) {
	            if (result2 = isRelatedTo(source2.objectType, target2.objectType, 3 /* Both */, reportErrors2)) {
	              result2 &= isRelatedTo(source2.indexType, target2.indexType, 3 /* Both */, reportErrors2);
	            }
	            if (result2) {
	              return result2;
	            }
	            if (reportErrors2) {
	              originalErrorInfo = errorInfo;
	            }
	          }
	          if (relation === assignableRelation || relation === comparableRelation) {
	            const objectType = target2.objectType;
	            const indexType = target2.indexType;
	            const baseObjectType = getBaseConstraintOfType(objectType) || objectType;
	            const baseIndexType = getBaseConstraintOfType(indexType) || indexType;
	            if (!isGenericObjectType(baseObjectType) && !isGenericIndexType(baseIndexType)) {
	              const accessFlags = 4 /* Writing */ | (baseObjectType !== objectType ? 2 /* NoIndexSignatures */ : 0);
	              const constraint = getIndexedAccessTypeOrUndefined(baseObjectType, baseIndexType, accessFlags);
	              if (constraint) {
	                if (reportErrors2 && originalErrorInfo) {
	                  resetErrorInfo(saveErrorInfo);
	                }
	                if (result2 = isRelatedTo(
	                  source2,
	                  constraint,
	                  2 /* Target */,
	                  reportErrors2,
	                  /*headMessage*/
	                  void 0,
	                  intersectionState
	                )) {
	                  return result2;
	                }
	                if (reportErrors2 && originalErrorInfo && errorInfo) {
	                  errorInfo = countMessageChainBreadth([originalErrorInfo]) <= countMessageChainBreadth([errorInfo]) ? originalErrorInfo : errorInfo;
	                }
	              }
	            }
	          }
	          if (reportErrors2) {
	            originalErrorInfo = void 0;
	          }
	        } else if (isGenericMappedType(target2) && relation !== identityRelation) {
	          const keysRemapped = !!target2.declaration.nameType;
	          const templateType = getTemplateTypeFromMappedType(target2);
	          const modifiers = getMappedTypeModifiers(target2);
	          if (!(modifiers & 8 /* ExcludeOptional */)) {
	            if (!keysRemapped && templateType.flags & 8388608 /* IndexedAccess */ && templateType.objectType === source2 && templateType.indexType === getTypeParameterFromMappedType(target2)) {
	              return -1 /* True */;
	            }
	            if (!isGenericMappedType(source2)) {
	              const targetKeys = keysRemapped ? getNameTypeFromMappedType(target2) : getConstraintTypeFromMappedType(target2);
	              const sourceKeys = getIndexType(source2, 2 /* NoIndexSignatures */);
	              const includeOptional = modifiers & 4 /* IncludeOptional */;
	              const filteredByApplicability = includeOptional ? intersectTypes(targetKeys, sourceKeys) : void 0;
	              if (includeOptional ? !(filteredByApplicability.flags & 131072 /* Never */) : isRelatedTo(targetKeys, sourceKeys, 3 /* Both */)) {
	                const templateType2 = getTemplateTypeFromMappedType(target2);
	                const typeParameter = getTypeParameterFromMappedType(target2);
	                const nonNullComponent = extractTypesOfKind(templateType2, ~98304 /* Nullable */);
	                if (!keysRemapped && nonNullComponent.flags & 8388608 /* IndexedAccess */ && nonNullComponent.indexType === typeParameter) {
	                  if (result2 = isRelatedTo(source2, nonNullComponent.objectType, 2 /* Target */, reportErrors2)) {
	                    return result2;
	                  }
	                } else {
	                  const indexingType = keysRemapped ? filteredByApplicability || targetKeys : filteredByApplicability ? getIntersectionType([filteredByApplicability, typeParameter]) : typeParameter;
	                  const indexedAccessType = getIndexedAccessType(source2, indexingType);
	                  if (result2 = isRelatedTo(indexedAccessType, templateType2, 3 /* Both */, reportErrors2)) {
	                    return result2;
	                  }
	                }
	              }
	              originalErrorInfo = errorInfo;
	              resetErrorInfo(saveErrorInfo);
	            }
	          }
	        } else if (targetFlags & 16777216 /* Conditional */) {
	          if (isDeeplyNestedType(target2, targetStack, targetDepth, 10)) {
	            return 3 /* Maybe */;
	          }
	          const c = target2;
	          if (!c.root.inferTypeParameters && !isDistributionDependent(c.root) && !(source2.flags & 16777216 /* Conditional */ && source2.root === c.root)) {
	            const skipTrue = !isTypeAssignableTo(getPermissiveInstantiation(c.checkType), getPermissiveInstantiation(c.extendsType));
	            const skipFalse = !skipTrue && isTypeAssignableTo(getRestrictiveInstantiation(c.checkType), getRestrictiveInstantiation(c.extendsType));
	            if (result2 = skipTrue ? -1 /* True */ : isRelatedTo(
	              source2,
	              getTrueTypeFromConditionalType(c),
	              2 /* Target */,
	              /*reportErrors*/
	              false,
	              /*headMessage*/
	              void 0,
	              intersectionState
	            )) {
	              result2 &= skipFalse ? -1 /* True */ : isRelatedTo(
	                source2,
	                getFalseTypeFromConditionalType(c),
	                2 /* Target */,
	                /*reportErrors*/
	                false,
	                /*headMessage*/
	                void 0,
	                intersectionState
	              );
	              if (result2) {
	                return result2;
	              }
	            }
	          }
	        } else if (targetFlags & 134217728 /* TemplateLiteral */) {
	          if (sourceFlags & 134217728 /* TemplateLiteral */) {
	            if (relation === comparableRelation) {
	              return templateLiteralTypesDefinitelyUnrelated(source2, target2) ? 0 /* False */ : -1 /* True */;
	            }
	            instantiateType(source2, reportUnreliableMapper);
	          }
	          if (isTypeMatchedByTemplateLiteralType(source2, target2)) {
	            return -1 /* True */;
	          }
	        } else if (target2.flags & 268435456 /* StringMapping */) {
	          if (!(source2.flags & 268435456 /* StringMapping */)) {
	            if (isMemberOfStringMapping(source2, target2)) {
	              return -1 /* True */;
	            }
	          }
	        }
	        if (sourceFlags & 8650752 /* TypeVariable */) {
	          if (!(sourceFlags & 8388608 /* IndexedAccess */ && targetFlags & 8388608 /* IndexedAccess */)) {
	            const constraint = getConstraintOfType(source2) || unknownType;
	            if (result2 = isRelatedTo(
	              constraint,
	              target2,
	              1 /* Source */,
	              /*reportErrors*/
	              false,
	              /*headMessage*/
	              void 0,
	              intersectionState
	            )) {
	              return result2;
	            } else if (result2 = isRelatedTo(
	              getTypeWithThisArgument(constraint, source2),
	              target2,
	              1 /* Source */,
	              reportErrors2 && constraint !== unknownType && !(targetFlags & sourceFlags & 262144 /* TypeParameter */),
	              /*headMessage*/
	              void 0,
	              intersectionState
	            )) {
	              return result2;
	            }
	            if (isMappedTypeGenericIndexedAccess(source2)) {
	              const indexConstraint = getConstraintOfType(source2.indexType);
	              if (indexConstraint) {
	                if (result2 = isRelatedTo(getIndexedAccessType(source2.objectType, indexConstraint), target2, 1 /* Source */, reportErrors2)) {
	                  return result2;
	                }
	              }
	            }
	          }
	        } else if (sourceFlags & 4194304 /* Index */) {
	          const isDeferredMappedIndex = shouldDeferIndexType(source2.type, source2.indexFlags) && getObjectFlags(source2.type) & 32 /* Mapped */;
	          if (result2 = isRelatedTo(keyofConstraintType, target2, 1 /* Source */, reportErrors2 && !isDeferredMappedIndex)) {
	            return result2;
	          }
	          if (isDeferredMappedIndex) {
	            const mappedType = source2.type;
	            const nameType = getNameTypeFromMappedType(mappedType);
	            const sourceMappedKeys = nameType && isMappedTypeWithKeyofConstraintDeclaration(mappedType) ? getApparentMappedTypeKeys(nameType, mappedType) : nameType || getConstraintTypeFromMappedType(mappedType);
	            if (result2 = isRelatedTo(sourceMappedKeys, target2, 1 /* Source */, reportErrors2)) {
	              return result2;
	            }
	          }
	        } else if (sourceFlags & 134217728 /* TemplateLiteral */ && !(targetFlags & 524288 /* Object */)) {
	          if (!(targetFlags & 134217728 /* TemplateLiteral */)) {
	            const constraint = getBaseConstraintOfType(source2);
	            if (constraint && constraint !== source2 && (result2 = isRelatedTo(constraint, target2, 1 /* Source */, reportErrors2))) {
	              return result2;
	            }
	          }
	        } else if (sourceFlags & 268435456 /* StringMapping */) {
	          if (targetFlags & 268435456 /* StringMapping */) {
	            if (source2.symbol !== target2.symbol) {
	              return 0 /* False */;
	            }
	            if (result2 = isRelatedTo(source2.type, target2.type, 3 /* Both */, reportErrors2)) {
	              return result2;
	            }
	          } else {
	            const constraint = getBaseConstraintOfType(source2);
	            if (constraint && (result2 = isRelatedTo(constraint, target2, 1 /* Source */, reportErrors2))) {
	              return result2;
	            }
	          }
	        } else if (sourceFlags & 16777216 /* Conditional */) {
	          if (isDeeplyNestedType(source2, sourceStack, sourceDepth, 10)) {
	            return 3 /* Maybe */;
	          }
	          if (targetFlags & 16777216 /* Conditional */) {
	            const sourceParams = source2.root.inferTypeParameters;
	            let sourceExtends = source2.extendsType;
	            let mapper;
	            if (sourceParams) {
	              const ctx = createInferenceContext(
	                sourceParams,
	                /*signature*/
	                void 0,
	                0 /* None */,
	                isRelatedToWorker
	              );
	              inferTypes(ctx.inferences, target2.extendsType, sourceExtends, 512 /* NoConstraints */ | 1024 /* AlwaysStrict */);
	              sourceExtends = instantiateType(sourceExtends, ctx.mapper);
	              mapper = ctx.mapper;
	            }
	            if (isTypeIdenticalTo(sourceExtends, target2.extendsType) && (isRelatedTo(source2.checkType, target2.checkType, 3 /* Both */) || isRelatedTo(target2.checkType, source2.checkType, 3 /* Both */))) {
	              if (result2 = isRelatedTo(instantiateType(getTrueTypeFromConditionalType(source2), mapper), getTrueTypeFromConditionalType(target2), 3 /* Both */, reportErrors2)) {
	                result2 &= isRelatedTo(getFalseTypeFromConditionalType(source2), getFalseTypeFromConditionalType(target2), 3 /* Both */, reportErrors2);
	              }
	              if (result2) {
	                return result2;
	              }
	            }
	          }
	          const defaultConstraint = getDefaultConstraintOfConditionalType(source2);
	          if (defaultConstraint) {
	            if (result2 = isRelatedTo(defaultConstraint, target2, 1 /* Source */, reportErrors2)) {
	              return result2;
	            }
	          }
	          const distributiveConstraint = !(targetFlags & 16777216 /* Conditional */) && hasNonCircularBaseConstraint(source2) ? getConstraintOfDistributiveConditionalType(source2) : void 0;
	          if (distributiveConstraint) {
	            resetErrorInfo(saveErrorInfo);
	            if (result2 = isRelatedTo(distributiveConstraint, target2, 1 /* Source */, reportErrors2)) {
	              return result2;
	            }
	          }
	        } else {
	          if (relation !== subtypeRelation && relation !== strictSubtypeRelation && isPartialMappedType(target2) && isEmptyObjectType(source2)) {
	            return -1 /* True */;
	          }
	          if (isGenericMappedType(target2)) {
	            if (isGenericMappedType(source2)) {
	              if (result2 = mappedTypeRelatedTo(source2, target2, reportErrors2)) {
	                return result2;
	              }
	            }
	            return 0 /* False */;
	          }
	          const sourceIsPrimitive = !!(sourceFlags & 402784252 /* Primitive */);
	          if (relation !== identityRelation) {
	            source2 = getApparentType(source2);
	            sourceFlags = source2.flags;
	          } else if (isGenericMappedType(source2)) {
	            return 0 /* False */;
	          }
	          if (getObjectFlags(source2) & 4 /* Reference */ && getObjectFlags(target2) & 4 /* Reference */ && source2.target === target2.target && !isTupleType(source2) && !(isMarkerType(source2) || isMarkerType(target2))) {
	            if (isEmptyArrayLiteralType(source2)) {
	              return -1 /* True */;
	            }
	            const variances = getVariances(source2.target);
	            if (variances === emptyArray) {
	              return 1 /* Unknown */;
	            }
	            const varianceResult = relateVariances(getTypeArguments(source2), getTypeArguments(target2), variances, intersectionState);
	            if (varianceResult !== void 0) {
	              return varianceResult;
	            }
	          } else if (isReadonlyArrayType(target2) ? everyType(source2, isArrayOrTupleType) : isArrayType(target2) && everyType(source2, (t) => isTupleType(t) && !t.target.readonly)) {
	            if (relation !== identityRelation) {
	              return isRelatedTo(getIndexTypeOfType(source2, numberType) || anyType, getIndexTypeOfType(target2, numberType) || anyType, 3 /* Both */, reportErrors2);
	            } else {
	              return 0 /* False */;
	            }
	          } else if (isGenericTupleType(source2) && isTupleType(target2) && !isGenericTupleType(target2)) {
	            const constraint = getBaseConstraintOrType(source2);
	            if (constraint !== source2) {
	              return isRelatedTo(constraint, target2, 1 /* Source */, reportErrors2);
	            }
	          } else if ((relation === subtypeRelation || relation === strictSubtypeRelation) && isEmptyObjectType(target2) && getObjectFlags(target2) & 8192 /* FreshLiteral */ && !isEmptyObjectType(source2)) {
	            return 0 /* False */;
	          }
	          if (sourceFlags & (524288 /* Object */ | 2097152 /* Intersection */) && targetFlags & 524288 /* Object */) {
	            const reportStructuralErrors = reportErrors2 && errorInfo === saveErrorInfo.errorInfo && !sourceIsPrimitive;
	            result2 = propertiesRelatedTo(
	              source2,
	              target2,
	              reportStructuralErrors,
	              /*excludedProperties*/
	              void 0,
	              /*optionalsOnly*/
	              false,
	              intersectionState
	            );
	            if (result2) {
	              result2 &= signaturesRelatedTo(source2, target2, 0 /* Call */, reportStructuralErrors, intersectionState);
	              if (result2) {
	                result2 &= signaturesRelatedTo(source2, target2, 1 /* Construct */, reportStructuralErrors, intersectionState);
	                if (result2) {
	                  result2 &= indexSignaturesRelatedTo(source2, target2, sourceIsPrimitive, reportStructuralErrors, intersectionState);
	                }
	              }
	            }
	            if (varianceCheckFailed && result2) {
	              errorInfo = originalErrorInfo || errorInfo || saveErrorInfo.errorInfo;
	            } else if (result2) {
	              return result2;
	            }
	          }
	          if (sourceFlags & (524288 /* Object */ | 2097152 /* Intersection */) && targetFlags & 1048576 /* Union */) {
	            const objectOnlyTarget = extractTypesOfKind(target2, 524288 /* Object */ | 2097152 /* Intersection */ | 33554432 /* Substitution */);
	            if (objectOnlyTarget.flags & 1048576 /* Union */) {
	              const result3 = typeRelatedToDiscriminatedType(source2, objectOnlyTarget);
	              if (result3) {
	                return result3;
	              }
	            }
	          }
	        }
	        return 0 /* False */;
	        function countMessageChainBreadth(info) {
	          if (!info)
	            return 0;
	          return reduceLeft(info, (value, chain) => value + 1 + countMessageChainBreadth(chain.next), 0);
	        }
	        function relateVariances(sourceTypeArguments, targetTypeArguments, variances, intersectionState2) {
	          if (result2 = typeArgumentsRelatedTo(sourceTypeArguments, targetTypeArguments, variances, reportErrors2, intersectionState2)) {
	            return result2;
	          }
	          if (some(variances, (v) => !!(v & 24 /* AllowsStructuralFallback */))) {
	            originalErrorInfo = void 0;
	            resetErrorInfo(saveErrorInfo);
	            return void 0;
	          }
	          const allowStructuralFallback = targetTypeArguments && hasCovariantVoidArgument(targetTypeArguments, variances);
	          varianceCheckFailed = !allowStructuralFallback;
	          if (variances !== emptyArray && !allowStructuralFallback) {
	            if (varianceCheckFailed && !(reportErrors2 && some(variances, (v) => (v & 7 /* VarianceMask */) === 0 /* Invariant */))) {
	              return 0 /* False */;
	            }
	            originalErrorInfo = errorInfo;
	            resetErrorInfo(saveErrorInfo);
	          }
	        }
	      }
	      function mappedTypeRelatedTo(source2, target2, reportErrors2) {
	        const modifiersRelated = relation === comparableRelation || (relation === identityRelation ? getMappedTypeModifiers(source2) === getMappedTypeModifiers(target2) : getCombinedMappedTypeOptionality(source2) <= getCombinedMappedTypeOptionality(target2));
	        if (modifiersRelated) {
	          let result2;
	          const targetConstraint = getConstraintTypeFromMappedType(target2);
	          const sourceConstraint = instantiateType(getConstraintTypeFromMappedType(source2), getCombinedMappedTypeOptionality(source2) < 0 ? reportUnmeasurableMapper : reportUnreliableMapper);
	          if (result2 = isRelatedTo(targetConstraint, sourceConstraint, 3 /* Both */, reportErrors2)) {
	            const mapper = createTypeMapper([getTypeParameterFromMappedType(source2)], [getTypeParameterFromMappedType(target2)]);
	            if (instantiateType(getNameTypeFromMappedType(source2), mapper) === instantiateType(getNameTypeFromMappedType(target2), mapper)) {
	              return result2 & isRelatedTo(instantiateType(getTemplateTypeFromMappedType(source2), mapper), getTemplateTypeFromMappedType(target2), 3 /* Both */, reportErrors2);
	            }
	          }
	        }
	        return 0 /* False */;
	      }
	      function typeRelatedToDiscriminatedType(source2, target2) {
	        var _a2;
	        const sourceProperties = getPropertiesOfType(source2);
	        const sourcePropertiesFiltered = findDiscriminantProperties(sourceProperties, target2);
	        if (!sourcePropertiesFiltered)
	          return 0 /* False */;
	        let numCombinations = 1;
	        for (const sourceProperty of sourcePropertiesFiltered) {
	          numCombinations *= countTypes(getNonMissingTypeOfSymbol(sourceProperty));
	          if (numCombinations > 25) {
	            (_a2 = tracing) == null ? void 0 : _a2.instant(tracing.Phase.CheckTypes, "typeRelatedToDiscriminatedType_DepthLimit", { sourceId: source2.id, targetId: target2.id, numCombinations });
	            return 0 /* False */;
	          }
	        }
	        const sourceDiscriminantTypes = new Array(sourcePropertiesFiltered.length);
	        const excludedProperties = /* @__PURE__ */ new Set();
	        for (let i = 0; i < sourcePropertiesFiltered.length; i++) {
	          const sourceProperty = sourcePropertiesFiltered[i];
	          const sourcePropertyType = getNonMissingTypeOfSymbol(sourceProperty);
	          sourceDiscriminantTypes[i] = sourcePropertyType.flags & 1048576 /* Union */ ? sourcePropertyType.types : [sourcePropertyType];
	          excludedProperties.add(sourceProperty.escapedName);
	        }
	        const discriminantCombinations = cartesianProduct(sourceDiscriminantTypes);
	        const matchingTypes = [];
	        for (const combination of discriminantCombinations) {
	          let hasMatch = false;
	          outer:
	            for (const type of target2.types) {
	              for (let i = 0; i < sourcePropertiesFiltered.length; i++) {
	                const sourceProperty = sourcePropertiesFiltered[i];
	                const targetProperty = getPropertyOfType(type, sourceProperty.escapedName);
	                if (!targetProperty)
	                  continue outer;
	                if (sourceProperty === targetProperty)
	                  continue;
	                const related = propertyRelatedTo(
	                  source2,
	                  target2,
	                  sourceProperty,
	                  targetProperty,
	                  (_) => combination[i],
	                  /*reportErrors*/
	                  false,
	                  0 /* None */,
	                  /*skipOptional*/
	                  strictNullChecks || relation === comparableRelation
	                );
	                if (!related) {
	                  continue outer;
	                }
	              }
	              pushIfUnique(matchingTypes, type, equateValues);
	              hasMatch = true;
	            }
	          if (!hasMatch) {
	            return 0 /* False */;
	          }
	        }
	        let result2 = -1 /* True */;
	        for (const type of matchingTypes) {
	          result2 &= propertiesRelatedTo(
	            source2,
	            type,
	            /*reportErrors*/
	            false,
	            excludedProperties,
	            /*optionalsOnly*/
	            false,
	            0 /* None */
	          );
	          if (result2) {
	            result2 &= signaturesRelatedTo(
	              source2,
	              type,
	              0 /* Call */,
	              /*reportErrors*/
	              false,
	              0 /* None */
	            );
	            if (result2) {
	              result2 &= signaturesRelatedTo(
	                source2,
	                type,
	                1 /* Construct */,
	                /*reportErrors*/
	                false,
	                0 /* None */
	              );
	              if (result2 && !(isTupleType(source2) && isTupleType(type))) {
	                result2 &= indexSignaturesRelatedTo(
	                  source2,
	                  type,
	                  /*sourceIsPrimitive*/
	                  false,
	                  /*reportErrors*/
	                  false,
	                  0 /* None */
	                );
	              }
	            }
	          }
	          if (!result2) {
	            return result2;
	          }
	        }
	        return result2;
	      }
	      function excludeProperties(properties, excludedProperties) {
	        if (!excludedProperties || properties.length === 0)
	          return properties;
	        let result2;
	        for (let i = 0; i < properties.length; i++) {
	          if (!excludedProperties.has(properties[i].escapedName)) {
	            if (result2) {
	              result2.push(properties[i]);
	            }
	          } else if (!result2) {
	            result2 = properties.slice(0, i);
	          }
	        }
	        return result2 || properties;
	      }
	      function isPropertySymbolTypeRelated(sourceProp, targetProp, getTypeOfSourceProperty, reportErrors2, intersectionState) {
	        const targetIsOptional = strictNullChecks && !!(getCheckFlags(targetProp) & 48 /* Partial */);
	        const effectiveTarget = addOptionality(
	          getNonMissingTypeOfSymbol(targetProp),
	          /*isProperty*/
	          false,
	          targetIsOptional
	        );
	        const effectiveSource = getTypeOfSourceProperty(sourceProp);
	        return isRelatedTo(
	          effectiveSource,
	          effectiveTarget,
	          3 /* Both */,
	          reportErrors2,
	          /*headMessage*/
	          void 0,
	          intersectionState
	        );
	      }
	      function propertyRelatedTo(source2, target2, sourceProp, targetProp, getTypeOfSourceProperty, reportErrors2, intersectionState, skipOptional) {
	        const sourcePropFlags = getDeclarationModifierFlagsFromSymbol(sourceProp);
	        const targetPropFlags = getDeclarationModifierFlagsFromSymbol(targetProp);
	        if (sourcePropFlags & 2 /* Private */ || targetPropFlags & 2 /* Private */) {
	          if (sourceProp.valueDeclaration !== targetProp.valueDeclaration) {
	            if (reportErrors2) {
	              if (sourcePropFlags & 2 /* Private */ && targetPropFlags & 2 /* Private */) {
	                reportError(Diagnostics.Types_have_separate_declarations_of_a_private_property_0, symbolToString(targetProp));
	              } else {
	                reportError(Diagnostics.Property_0_is_private_in_type_1_but_not_in_type_2, symbolToString(targetProp), typeToString(sourcePropFlags & 2 /* Private */ ? source2 : target2), typeToString(sourcePropFlags & 2 /* Private */ ? target2 : source2));
	              }
	            }
	            return 0 /* False */;
	          }
	        } else if (targetPropFlags & 4 /* Protected */) {
	          if (!isValidOverrideOf(sourceProp, targetProp)) {
	            if (reportErrors2) {
	              reportError(Diagnostics.Property_0_is_protected_but_type_1_is_not_a_class_derived_from_2, symbolToString(targetProp), typeToString(getDeclaringClass(sourceProp) || source2), typeToString(getDeclaringClass(targetProp) || target2));
	            }
	            return 0 /* False */;
	          }
	        } else if (sourcePropFlags & 4 /* Protected */) {
	          if (reportErrors2) {
	            reportError(Diagnostics.Property_0_is_protected_in_type_1_but_public_in_type_2, symbolToString(targetProp), typeToString(source2), typeToString(target2));
	          }
	          return 0 /* False */;
	        }
	        if (relation === strictSubtypeRelation && isReadonlySymbol(sourceProp) && !isReadonlySymbol(targetProp)) {
	          return 0 /* False */;
	        }
	        const related = isPropertySymbolTypeRelated(sourceProp, targetProp, getTypeOfSourceProperty, reportErrors2, intersectionState);
	        if (!related) {
	          if (reportErrors2) {
	            reportIncompatibleError(Diagnostics.Types_of_property_0_are_incompatible, symbolToString(targetProp));
	          }
	          return 0 /* False */;
	        }
	        if (!skipOptional && sourceProp.flags & 16777216 /* Optional */ && targetProp.flags & 106500 /* ClassMember */ && !(targetProp.flags & 16777216 /* Optional */)) {
	          if (reportErrors2) {
	            reportError(Diagnostics.Property_0_is_optional_in_type_1_but_required_in_type_2, symbolToString(targetProp), typeToString(source2), typeToString(target2));
	          }
	          return 0 /* False */;
	        }
	        return related;
	      }
	      function reportUnmatchedProperty(source2, target2, unmatchedProperty, requireOptionalProperties) {
	        let shouldSkipElaboration = false;
	        if (unmatchedProperty.valueDeclaration && isNamedDeclaration(unmatchedProperty.valueDeclaration) && isPrivateIdentifier(unmatchedProperty.valueDeclaration.name) && source2.symbol && source2.symbol.flags & 32 /* Class */) {
	          const privateIdentifierDescription = unmatchedProperty.valueDeclaration.name.escapedText;
	          const symbolTableKey = getSymbolNameForPrivateIdentifier(source2.symbol, privateIdentifierDescription);
	          if (symbolTableKey && getPropertyOfType(source2, symbolTableKey)) {
	            const sourceName = factory.getDeclarationName(source2.symbol.valueDeclaration);
	            const targetName = factory.getDeclarationName(target2.symbol.valueDeclaration);
	            reportError(
	              Diagnostics.Property_0_in_type_1_refers_to_a_different_member_that_cannot_be_accessed_from_within_type_2,
	              diagnosticName(privateIdentifierDescription),
	              diagnosticName(sourceName.escapedText === "" ? anon : sourceName),
	              diagnosticName(targetName.escapedText === "" ? anon : targetName)
	            );
	            return;
	          }
	        }
	        const props = arrayFrom(getUnmatchedProperties(
	          source2,
	          target2,
	          requireOptionalProperties,
	          /*matchDiscriminantProperties*/
	          false
	        ));
	        if (!headMessage || headMessage.code !== Diagnostics.Class_0_incorrectly_implements_interface_1.code && headMessage.code !== Diagnostics.Class_0_incorrectly_implements_class_1_Did_you_mean_to_extend_1_and_inherit_its_members_as_a_subclass.code) {
	          shouldSkipElaboration = true;
	        }
	        if (props.length === 1) {
	          const propName = symbolToString(
	            unmatchedProperty,
	            /*enclosingDeclaration*/
	            void 0,
	            0 /* None */,
	            4 /* AllowAnyNodeKind */ | 16 /* WriteComputedProps */
	          );
	          reportError(Diagnostics.Property_0_is_missing_in_type_1_but_required_in_type_2, propName, ...getTypeNamesForErrorDisplay(source2, target2));
	          if (length(unmatchedProperty.declarations)) {
	            associateRelatedInfo(createDiagnosticForNode(unmatchedProperty.declarations[0], Diagnostics._0_is_declared_here, propName));
	          }
	          if (shouldSkipElaboration && errorInfo) {
	            overrideNextErrorInfo++;
	          }
	        } else if (tryElaborateArrayLikeErrors(
	          source2,
	          target2,
	          /*reportErrors*/
	          false
	        )) {
	          if (props.length > 5) {
	            reportError(Diagnostics.Type_0_is_missing_the_following_properties_from_type_1_Colon_2_and_3_more, typeToString(source2), typeToString(target2), map(props.slice(0, 4), (p) => symbolToString(p)).join(", "), props.length - 4);
	          } else {
	            reportError(Diagnostics.Type_0_is_missing_the_following_properties_from_type_1_Colon_2, typeToString(source2), typeToString(target2), map(props, (p) => symbolToString(p)).join(", "));
	          }
	          if (shouldSkipElaboration && errorInfo) {
	            overrideNextErrorInfo++;
	          }
	        }
	      }
	      function propertiesRelatedTo(source2, target2, reportErrors2, excludedProperties, optionalsOnly, intersectionState) {
	        if (relation === identityRelation) {
	          return propertiesIdenticalTo(source2, target2, excludedProperties);
	        }
	        let result2 = -1 /* True */;
	        if (isTupleType(target2)) {
	          if (isArrayOrTupleType(source2)) {
	            if (!target2.target.readonly && (isReadonlyArrayType(source2) || isTupleType(source2) && source2.target.readonly)) {
	              return 0 /* False */;
	            }
	            const sourceArity = getTypeReferenceArity(source2);
	            const targetArity = getTypeReferenceArity(target2);
	            const sourceRestFlag = isTupleType(source2) ? source2.target.combinedFlags & 4 /* Rest */ : 4 /* Rest */;
	            const targetRestFlag = target2.target.combinedFlags & 4 /* Rest */;
	            const sourceMinLength = isTupleType(source2) ? source2.target.minLength : 0;
	            const targetMinLength = target2.target.minLength;
	            if (!sourceRestFlag && sourceArity < targetMinLength) {
	              if (reportErrors2) {
	                reportError(Diagnostics.Source_has_0_element_s_but_target_requires_1, sourceArity, targetMinLength);
	              }
	              return 0 /* False */;
	            }
	            if (!targetRestFlag && targetArity < sourceMinLength) {
	              if (reportErrors2) {
	                reportError(Diagnostics.Source_has_0_element_s_but_target_allows_only_1, sourceMinLength, targetArity);
	              }
	              return 0 /* False */;
	            }
	            if (!targetRestFlag && (sourceRestFlag || targetArity < sourceArity)) {
	              if (reportErrors2) {
	                if (sourceMinLength < targetMinLength) {
	                  reportError(Diagnostics.Target_requires_0_element_s_but_source_may_have_fewer, targetMinLength);
	                } else {
	                  reportError(Diagnostics.Target_allows_only_0_element_s_but_source_may_have_more, targetArity);
	                }
	              }
	              return 0 /* False */;
	            }
	            const sourceTypeArguments = getTypeArguments(source2);
	            const targetTypeArguments = getTypeArguments(target2);
	            const targetStartCount = getStartElementCount(target2.target, 11 /* NonRest */);
	            const targetEndCount = getEndElementCount(target2.target, 11 /* NonRest */);
	            const targetHasRestElement = target2.target.hasRestElement;
	            let canExcludeDiscriminants = !!excludedProperties;
	            for (let sourcePosition = 0; sourcePosition < sourceArity; sourcePosition++) {
	              const sourceFlags = isTupleType(source2) ? source2.target.elementFlags[sourcePosition] : 4 /* Rest */;
	              const sourcePositionFromEnd = sourceArity - 1 - sourcePosition;
	              const targetPosition = targetHasRestElement && sourcePosition >= targetStartCount ? targetArity - 1 - Math.min(sourcePositionFromEnd, targetEndCount) : sourcePosition;
	              const targetFlags = target2.target.elementFlags[targetPosition];
	              if (targetFlags & 8 /* Variadic */ && !(sourceFlags & 8 /* Variadic */)) {
	                if (reportErrors2) {
	                  reportError(Diagnostics.Source_provides_no_match_for_variadic_element_at_position_0_in_target, targetPosition);
	                }
	                return 0 /* False */;
	              }
	              if (sourceFlags & 8 /* Variadic */ && !(targetFlags & 12 /* Variable */)) {
	                if (reportErrors2) {
	                  reportError(Diagnostics.Variadic_element_at_position_0_in_source_does_not_match_element_at_position_1_in_target, sourcePosition, targetPosition);
	                }
	                return 0 /* False */;
	              }
	              if (targetFlags & 1 /* Required */ && !(sourceFlags & 1 /* Required */)) {
	                if (reportErrors2) {
	                  reportError(Diagnostics.Source_provides_no_match_for_required_element_at_position_0_in_target, targetPosition);
	                }
	                return 0 /* False */;
	              }
	              if (canExcludeDiscriminants) {
	                if (sourceFlags & 12 /* Variable */ || targetFlags & 12 /* Variable */) {
	                  canExcludeDiscriminants = false;
	                }
	                if (canExcludeDiscriminants && (excludedProperties == null ? void 0 : excludedProperties.has("" + sourcePosition))) {
	                  continue;
	                }
	              }
	              const sourceType = removeMissingType(sourceTypeArguments[sourcePosition], !!(sourceFlags & targetFlags & 2 /* Optional */));
	              const targetType = targetTypeArguments[targetPosition];
	              const targetCheckType = sourceFlags & 8 /* Variadic */ && targetFlags & 4 /* Rest */ ? createArrayType(targetType) : removeMissingType(targetType, !!(targetFlags & 2 /* Optional */));
	              const related = isRelatedTo(
	                sourceType,
	                targetCheckType,
	                3 /* Both */,
	                reportErrors2,
	                /*headMessage*/
	                void 0,
	                intersectionState
	              );
	              if (!related) {
	                if (reportErrors2 && (targetArity > 1 || sourceArity > 1)) {
	                  if (targetHasRestElement && sourcePosition >= targetStartCount && sourcePositionFromEnd >= targetEndCount && targetStartCount !== sourceArity - targetEndCount - 1) {
	                    reportIncompatibleError(Diagnostics.Type_at_positions_0_through_1_in_source_is_not_compatible_with_type_at_position_2_in_target, targetStartCount, sourceArity - targetEndCount - 1, targetPosition);
	                  } else {
	                    reportIncompatibleError(Diagnostics.Type_at_position_0_in_source_is_not_compatible_with_type_at_position_1_in_target, sourcePosition, targetPosition);
	                  }
	                }
	                return 0 /* False */;
	              }
	              result2 &= related;
	            }
	            return result2;
	          }
	          if (target2.target.combinedFlags & 12 /* Variable */) {
	            return 0 /* False */;
	          }
	        }
	        const requireOptionalProperties = (relation === subtypeRelation || relation === strictSubtypeRelation) && !isObjectLiteralType2(source2) && !isEmptyArrayLiteralType(source2) && !isTupleType(source2);
	        const unmatchedProperty = getUnmatchedProperty(
	          source2,
	          target2,
	          requireOptionalProperties,
	          /*matchDiscriminantProperties*/
	          false
	        );
	        if (unmatchedProperty) {
	          if (reportErrors2 && shouldReportUnmatchedPropertyError(source2, target2)) {
	            reportUnmatchedProperty(source2, target2, unmatchedProperty, requireOptionalProperties);
	          }
	          return 0 /* False */;
	        }
	        if (isObjectLiteralType2(target2)) {
	          for (const sourceProp of excludeProperties(getPropertiesOfType(source2), excludedProperties)) {
	            if (!getPropertyOfObjectType(target2, sourceProp.escapedName)) {
	              const sourceType = getTypeOfSymbol(sourceProp);
	              if (!(sourceType.flags & 32768 /* Undefined */)) {
	                if (reportErrors2) {
	                  reportError(Diagnostics.Property_0_does_not_exist_on_type_1, symbolToString(sourceProp), typeToString(target2));
	                }
	                return 0 /* False */;
	              }
	            }
	          }
	        }
	        const properties = getPropertiesOfType(target2);
	        const numericNamesOnly = isTupleType(source2) && isTupleType(target2);
	        for (const targetProp of excludeProperties(properties, excludedProperties)) {
	          const name = targetProp.escapedName;
	          if (!(targetProp.flags & 4194304 /* Prototype */) && (!numericNamesOnly || isNumericLiteralName(name) || name === "length") && (!optionalsOnly || targetProp.flags & 16777216 /* Optional */)) {
	            const sourceProp = getPropertyOfType(source2, name);
	            if (sourceProp && sourceProp !== targetProp) {
	              const related = propertyRelatedTo(source2, target2, sourceProp, targetProp, getNonMissingTypeOfSymbol, reportErrors2, intersectionState, relation === comparableRelation);
	              if (!related) {
	                return 0 /* False */;
	              }
	              result2 &= related;
	            }
	          }
	        }
	        return result2;
	      }
	      function propertiesIdenticalTo(source2, target2, excludedProperties) {
	        if (!(source2.flags & 524288 /* Object */ && target2.flags & 524288 /* Object */)) {
	          return 0 /* False */;
	        }
	        const sourceProperties = excludeProperties(getPropertiesOfObjectType(source2), excludedProperties);
	        const targetProperties = excludeProperties(getPropertiesOfObjectType(target2), excludedProperties);
	        if (sourceProperties.length !== targetProperties.length) {
	          return 0 /* False */;
	        }
	        let result2 = -1 /* True */;
	        for (const sourceProp of sourceProperties) {
	          const targetProp = getPropertyOfObjectType(target2, sourceProp.escapedName);
	          if (!targetProp) {
	            return 0 /* False */;
	          }
	          const related = compareProperties2(sourceProp, targetProp, isRelatedTo);
	          if (!related) {
	            return 0 /* False */;
	          }
	          result2 &= related;
	        }
	        return result2;
	      }
	      function signaturesRelatedTo(source2, target2, kind, reportErrors2, intersectionState) {
	        var _a2, _b;
	        if (relation === identityRelation) {
	          return signaturesIdenticalTo(source2, target2, kind);
	        }
	        if (target2 === anyFunctionType || source2 === anyFunctionType) {
	          return -1 /* True */;
	        }
	        const sourceIsJSConstructor = source2.symbol && isJSConstructor(source2.symbol.valueDeclaration);
	        const targetIsJSConstructor = target2.symbol && isJSConstructor(target2.symbol.valueDeclaration);
	        const sourceSignatures = getSignaturesOfType(
	          source2,
	          sourceIsJSConstructor && kind === 1 /* Construct */ ? 0 /* Call */ : kind
	        );
	        const targetSignatures = getSignaturesOfType(
	          target2,
	          targetIsJSConstructor && kind === 1 /* Construct */ ? 0 /* Call */ : kind
	        );
	        if (kind === 1 /* Construct */ && sourceSignatures.length && targetSignatures.length) {
	          const sourceIsAbstract = !!(sourceSignatures[0].flags & 4 /* Abstract */);
	          const targetIsAbstract = !!(targetSignatures[0].flags & 4 /* Abstract */);
	          if (sourceIsAbstract && !targetIsAbstract) {
	            if (reportErrors2) {
	              reportError(Diagnostics.Cannot_assign_an_abstract_constructor_type_to_a_non_abstract_constructor_type);
	            }
	            return 0 /* False */;
	          }
	          if (!constructorVisibilitiesAreCompatible(sourceSignatures[0], targetSignatures[0], reportErrors2)) {
	            return 0 /* False */;
	          }
	        }
	        let result2 = -1 /* True */;
	        const incompatibleReporter = kind === 1 /* Construct */ ? reportIncompatibleConstructSignatureReturn : reportIncompatibleCallSignatureReturn;
	        const sourceObjectFlags = getObjectFlags(source2);
	        const targetObjectFlags = getObjectFlags(target2);
	        if (sourceObjectFlags & 64 /* Instantiated */ && targetObjectFlags & 64 /* Instantiated */ && source2.symbol === target2.symbol || sourceObjectFlags & 4 /* Reference */ && targetObjectFlags & 4 /* Reference */ && source2.target === target2.target) {
	          Debug.assertEqual(sourceSignatures.length, targetSignatures.length);
	          for (let i = 0; i < targetSignatures.length; i++) {
	            const related = signatureRelatedTo(
	              sourceSignatures[i],
	              targetSignatures[i],
	              /*erase*/
	              true,
	              reportErrors2,
	              intersectionState,
	              incompatibleReporter(sourceSignatures[i], targetSignatures[i])
	            );
	            if (!related) {
	              return 0 /* False */;
	            }
	            result2 &= related;
	          }
	        } else if (sourceSignatures.length === 1 && targetSignatures.length === 1) {
	          const eraseGenerics = relation === comparableRelation || !!compilerOptions.noStrictGenericChecks;
	          const sourceSignature = first(sourceSignatures);
	          const targetSignature = first(targetSignatures);
	          result2 = signatureRelatedTo(sourceSignature, targetSignature, eraseGenerics, reportErrors2, intersectionState, incompatibleReporter(sourceSignature, targetSignature));
	          if (!result2 && reportErrors2 && kind === 1 /* Construct */ && sourceObjectFlags & targetObjectFlags && (((_a2 = targetSignature.declaration) == null ? void 0 : _a2.kind) === 176 /* Constructor */ || ((_b = sourceSignature.declaration) == null ? void 0 : _b.kind) === 176 /* Constructor */)) {
	            const constructSignatureToString = (signature) => signatureToString(
	              signature,
	              /*enclosingDeclaration*/
	              void 0,
	              262144 /* WriteArrowStyleSignature */,
	              kind
	            );
	            reportError(Diagnostics.Type_0_is_not_assignable_to_type_1, constructSignatureToString(sourceSignature), constructSignatureToString(targetSignature));
	            reportError(Diagnostics.Types_of_construct_signatures_are_incompatible);
	            return result2;
	          }
	        } else {
	          outer:
	            for (const t of targetSignatures) {
	              const saveErrorInfo = captureErrorCalculationState();
	              let shouldElaborateErrors = reportErrors2;
	              for (const s of sourceSignatures) {
	                const related = signatureRelatedTo(
	                  s,
	                  t,
	                  /*erase*/
	                  true,
	                  shouldElaborateErrors,
	                  intersectionState,
	                  incompatibleReporter(s, t)
	                );
	                if (related) {
	                  result2 &= related;
	                  resetErrorInfo(saveErrorInfo);
	                  continue outer;
	                }
	                shouldElaborateErrors = false;
	              }
	              if (shouldElaborateErrors) {
	                reportError(Diagnostics.Type_0_provides_no_match_for_the_signature_1, typeToString(source2), signatureToString(
	                  t,
	                  /*enclosingDeclaration*/
	                  void 0,
	                  /*flags*/
	                  void 0,
	                  kind
	                ));
	              }
	              return 0 /* False */;
	            }
	        }
	        return result2;
	      }
	      function shouldReportUnmatchedPropertyError(source2, target2) {
	        const typeCallSignatures = getSignaturesOfStructuredType(source2, 0 /* Call */);
	        const typeConstructSignatures = getSignaturesOfStructuredType(source2, 1 /* Construct */);
	        const typeProperties = getPropertiesOfObjectType(source2);
	        if ((typeCallSignatures.length || typeConstructSignatures.length) && !typeProperties.length) {
	          if (getSignaturesOfType(target2, 0 /* Call */).length && typeCallSignatures.length || getSignaturesOfType(target2, 1 /* Construct */).length && typeConstructSignatures.length) {
	            return true;
	          }
	          return false;
	        }
	        return true;
	      }
	      function reportIncompatibleCallSignatureReturn(siga, sigb) {
	        if (siga.parameters.length === 0 && sigb.parameters.length === 0) {
	          return (source2, target2) => reportIncompatibleError(Diagnostics.Call_signatures_with_no_arguments_have_incompatible_return_types_0_and_1, typeToString(source2), typeToString(target2));
	        }
	        return (source2, target2) => reportIncompatibleError(Diagnostics.Call_signature_return_types_0_and_1_are_incompatible, typeToString(source2), typeToString(target2));
	      }
	      function reportIncompatibleConstructSignatureReturn(siga, sigb) {
	        if (siga.parameters.length === 0 && sigb.parameters.length === 0) {
	          return (source2, target2) => reportIncompatibleError(Diagnostics.Construct_signatures_with_no_arguments_have_incompatible_return_types_0_and_1, typeToString(source2), typeToString(target2));
	        }
	        return (source2, target2) => reportIncompatibleError(Diagnostics.Construct_signature_return_types_0_and_1_are_incompatible, typeToString(source2), typeToString(target2));
	      }
	      function signatureRelatedTo(source2, target2, erase, reportErrors2, intersectionState, incompatibleReporter) {
	        const checkMode = relation === subtypeRelation ? 16 /* StrictTopSignature */ : relation === strictSubtypeRelation ? 16 /* StrictTopSignature */ | 8 /* StrictArity */ : 0 /* None */;
	        return compareSignaturesRelated(erase ? getErasedSignature(source2) : source2, erase ? getErasedSignature(target2) : target2, checkMode, reportErrors2, reportError, incompatibleReporter, isRelatedToWorker2, reportUnreliableMapper);
	        function isRelatedToWorker2(source3, target3, reportErrors3) {
	          return isRelatedTo(
	            source3,
	            target3,
	            3 /* Both */,
	            reportErrors3,
	            /*headMessage*/
	            void 0,
	            intersectionState
	          );
	        }
	      }
	      function signaturesIdenticalTo(source2, target2, kind) {
	        const sourceSignatures = getSignaturesOfType(source2, kind);
	        const targetSignatures = getSignaturesOfType(target2, kind);
	        if (sourceSignatures.length !== targetSignatures.length) {
	          return 0 /* False */;
	        }
	        let result2 = -1 /* True */;
	        for (let i = 0; i < sourceSignatures.length; i++) {
	          const related = compareSignaturesIdentical(
	            sourceSignatures[i],
	            targetSignatures[i],
	            /*partialMatch*/
	            false,
	            /*ignoreThisTypes*/
	            false,
	            /*ignoreReturnTypes*/
	            false,
	            isRelatedTo
	          );
	          if (!related) {
	            return 0 /* False */;
	          }
	          result2 &= related;
	        }
	        return result2;
	      }
	      function membersRelatedToIndexInfo(source2, targetInfo, reportErrors2, intersectionState) {
	        let result2 = -1 /* True */;
	        const keyType = targetInfo.keyType;
	        const props = source2.flags & 2097152 /* Intersection */ ? getPropertiesOfUnionOrIntersectionType(source2) : getPropertiesOfObjectType(source2);
	        for (const prop of props) {
	          if (isIgnoredJsxProperty(source2, prop)) {
	            continue;
	          }
	          if (isApplicableIndexType(getLiteralTypeFromProperty(prop, 8576 /* StringOrNumberLiteralOrUnique */), keyType)) {
	            const propType = getNonMissingTypeOfSymbol(prop);
	            const type = exactOptionalPropertyTypes || propType.flags & 32768 /* Undefined */ || keyType === numberType || !(prop.flags & 16777216 /* Optional */) ? propType : getTypeWithFacts(propType, 524288 /* NEUndefined */);
	            const related = isRelatedTo(
	              type,
	              targetInfo.type,
	              3 /* Both */,
	              reportErrors2,
	              /*headMessage*/
	              void 0,
	              intersectionState
	            );
	            if (!related) {
	              if (reportErrors2) {
	                reportError(Diagnostics.Property_0_is_incompatible_with_index_signature, symbolToString(prop));
	              }
	              return 0 /* False */;
	            }
	            result2 &= related;
	          }
	        }
	        for (const info of getIndexInfosOfType(source2)) {
	          if (isApplicableIndexType(info.keyType, keyType)) {
	            const related = indexInfoRelatedTo(info, targetInfo, reportErrors2, intersectionState);
	            if (!related) {
	              return 0 /* False */;
	            }
	            result2 &= related;
	          }
	        }
	        return result2;
	      }
	      function indexInfoRelatedTo(sourceInfo, targetInfo, reportErrors2, intersectionState) {
	        const related = isRelatedTo(
	          sourceInfo.type,
	          targetInfo.type,
	          3 /* Both */,
	          reportErrors2,
	          /*headMessage*/
	          void 0,
	          intersectionState
	        );
	        if (!related && reportErrors2) {
	          if (sourceInfo.keyType === targetInfo.keyType) {
	            reportError(Diagnostics._0_index_signatures_are_incompatible, typeToString(sourceInfo.keyType));
	          } else {
	            reportError(Diagnostics._0_and_1_index_signatures_are_incompatible, typeToString(sourceInfo.keyType), typeToString(targetInfo.keyType));
	          }
	        }
	        return related;
	      }
	      function indexSignaturesRelatedTo(source2, target2, sourceIsPrimitive, reportErrors2, intersectionState) {
	        if (relation === identityRelation) {
	          return indexSignaturesIdenticalTo(source2, target2);
	        }
	        const indexInfos = getIndexInfosOfType(target2);
	        const targetHasStringIndex = some(indexInfos, (info) => info.keyType === stringType);
	        let result2 = -1 /* True */;
	        for (const targetInfo of indexInfos) {
	          const related = relation !== strictSubtypeRelation && !sourceIsPrimitive && targetHasStringIndex && targetInfo.type.flags & 1 /* Any */ ? -1 /* True */ : isGenericMappedType(source2) && targetHasStringIndex ? isRelatedTo(getTemplateTypeFromMappedType(source2), targetInfo.type, 3 /* Both */, reportErrors2) : typeRelatedToIndexInfo(source2, targetInfo, reportErrors2, intersectionState);
	          if (!related) {
	            return 0 /* False */;
	          }
	          result2 &= related;
	        }
	        return result2;
	      }
	      function typeRelatedToIndexInfo(source2, targetInfo, reportErrors2, intersectionState) {
	        const sourceInfo = getApplicableIndexInfo(source2, targetInfo.keyType);
	        if (sourceInfo) {
	          return indexInfoRelatedTo(sourceInfo, targetInfo, reportErrors2, intersectionState);
	        }
	        if (!(intersectionState & 1 /* Source */) && (relation !== strictSubtypeRelation || getObjectFlags(source2) & 8192 /* FreshLiteral */) && isObjectTypeWithInferableIndex(source2)) {
	          return membersRelatedToIndexInfo(source2, targetInfo, reportErrors2, intersectionState);
	        }
	        if (reportErrors2) {
	          reportError(Diagnostics.Index_signature_for_type_0_is_missing_in_type_1, typeToString(targetInfo.keyType), typeToString(source2));
	        }
	        return 0 /* False */;
	      }
	      function indexSignaturesIdenticalTo(source2, target2) {
	        const sourceInfos = getIndexInfosOfType(source2);
	        const targetInfos = getIndexInfosOfType(target2);
	        if (sourceInfos.length !== targetInfos.length) {
	          return 0 /* False */;
	        }
	        for (const targetInfo of targetInfos) {
	          const sourceInfo = getIndexInfoOfType(source2, targetInfo.keyType);
	          if (!(sourceInfo && isRelatedTo(sourceInfo.type, targetInfo.type, 3 /* Both */) && sourceInfo.isReadonly === targetInfo.isReadonly)) {
	            return 0 /* False */;
	          }
	        }
	        return -1 /* True */;
	      }
	      function constructorVisibilitiesAreCompatible(sourceSignature, targetSignature, reportErrors2) {
	        if (!sourceSignature.declaration || !targetSignature.declaration) {
	          return true;
	        }
	        const sourceAccessibility = getSelectedEffectiveModifierFlags(sourceSignature.declaration, 6 /* NonPublicAccessibilityModifier */);
	        const targetAccessibility = getSelectedEffectiveModifierFlags(targetSignature.declaration, 6 /* NonPublicAccessibilityModifier */);
	        if (targetAccessibility === 2 /* Private */) {
	          return true;
	        }
	        if (targetAccessibility === 4 /* Protected */ && sourceAccessibility !== 2 /* Private */) {
	          return true;
	        }
	        if (targetAccessibility !== 4 /* Protected */ && !sourceAccessibility) {
	          return true;
	        }
	        if (reportErrors2) {
	          reportError(Diagnostics.Cannot_assign_a_0_constructor_type_to_a_1_constructor_type, visibilityToString(sourceAccessibility), visibilityToString(targetAccessibility));
	        }
	        return false;
	      }
	    }
	    function typeCouldHaveTopLevelSingletonTypes(type) {
	      if (type.flags & 16 /* Boolean */) {
	        return false;
	      }
	      if (type.flags & 3145728 /* UnionOrIntersection */) {
	        return !!forEach(type.types, typeCouldHaveTopLevelSingletonTypes);
	      }
	      if (type.flags & 465829888 /* Instantiable */) {
	        const constraint = getConstraintOfType(type);
	        if (constraint && constraint !== type) {
	          return typeCouldHaveTopLevelSingletonTypes(constraint);
	        }
	      }
	      return isUnitType(type) || !!(type.flags & 134217728 /* TemplateLiteral */) || !!(type.flags & 268435456 /* StringMapping */);
	    }
	    function getExactOptionalUnassignableProperties(source, target) {
	      if (isTupleType(source) && isTupleType(target))
	        return emptyArray;
	      return getPropertiesOfType(target).filter((targetProp) => isExactOptionalPropertyMismatch(getTypeOfPropertyOfType(source, targetProp.escapedName), getTypeOfSymbol(targetProp)));
	    }
	    function isExactOptionalPropertyMismatch(source, target) {
	      return !!source && !!target && maybeTypeOfKind(source, 32768 /* Undefined */) && !!containsMissingType(target);
	    }
	    function getExactOptionalProperties(type) {
	      return getPropertiesOfType(type).filter((targetProp) => containsMissingType(getTypeOfSymbol(targetProp)));
	    }
	    function getBestMatchingType(source, target, isRelatedTo = compareTypesAssignable) {
	      return findMatchingDiscriminantType(source, target, isRelatedTo) || findMatchingTypeReferenceOrTypeAliasReference(source, target) || findBestTypeForObjectLiteral(source, target) || findBestTypeForInvokable(source, target) || findMostOverlappyType(source, target);
	    }
	    function discriminateTypeByDiscriminableItems(target, discriminators, related) {
	      const types = target.types;
	      const include = types.map((t) => t.flags & 402784252 /* Primitive */ ? 0 /* False */ : -1 /* True */);
	      for (const [getDiscriminatingType, propertyName] of discriminators) {
	        let matched = false;
	        for (let i = 0; i < types.length; i++) {
	          if (include[i]) {
	            const targetType = getTypeOfPropertyOrIndexSignatureOfType(types[i], propertyName);
	            if (targetType && related(getDiscriminatingType(), targetType)) {
	              matched = true;
	            } else {
	              include[i] = 3 /* Maybe */;
	            }
	          }
	        }
	        for (let i = 0; i < types.length; i++) {
	          if (include[i] === 3 /* Maybe */) {
	            include[i] = matched ? 0 /* False */ : -1 /* True */;
	          }
	        }
	      }
	      const filtered = contains(include, 0 /* False */) ? getUnionType(types.filter((_, i) => include[i]), 0 /* None */) : target;
	      return filtered.flags & 131072 /* Never */ ? target : filtered;
	    }
	    function isWeakType(type) {
	      if (type.flags & 524288 /* Object */) {
	        const resolved = resolveStructuredTypeMembers(type);
	        return resolved.callSignatures.length === 0 && resolved.constructSignatures.length === 0 && resolved.indexInfos.length === 0 && resolved.properties.length > 0 && every(resolved.properties, (p) => !!(p.flags & 16777216 /* Optional */));
	      }
	      if (type.flags & 2097152 /* Intersection */) {
	        return every(type.types, isWeakType);
	      }
	      return false;
	    }
	    function hasCommonProperties(source, target, isComparingJsxAttributes) {
	      for (const prop of getPropertiesOfType(source)) {
	        if (isKnownProperty(target, prop.escapedName, isComparingJsxAttributes)) {
	          return true;
	        }
	      }
	      return false;
	    }
	    function getVariances(type) {
	      return type === globalArrayType || type === globalReadonlyArrayType || type.objectFlags & 8 /* Tuple */ ? arrayVariances : getVariancesWorker(type.symbol, type.typeParameters);
	    }
	    function getAliasVariances(symbol) {
	      return getVariancesWorker(symbol, getSymbolLinks(symbol).typeParameters);
	    }
	    function getVariancesWorker(symbol, typeParameters = emptyArray) {
	      var _a, _b;
	      const links = getSymbolLinks(symbol);
	      if (!links.variances) {
	        (_a = tracing) == null ? void 0 : _a.push(tracing.Phase.CheckTypes, "getVariancesWorker", { arity: typeParameters.length, id: getTypeId(getDeclaredTypeOfSymbol(symbol)) });
	        const oldVarianceComputation = inVarianceComputation;
	        if (!inVarianceComputation) {
	          inVarianceComputation = true;
	          resolutionStart = resolutionTargets.length;
	        }
	        links.variances = emptyArray;
	        const variances = [];
	        for (const tp of typeParameters) {
	          const modifiers = getTypeParameterModifiers(tp);
	          let variance = modifiers & 16384 /* Out */ ? modifiers & 8192 /* In */ ? 0 /* Invariant */ : 1 /* Covariant */ : modifiers & 8192 /* In */ ? 2 /* Contravariant */ : void 0;
	          if (variance === void 0) {
	            let unmeasurable = false;
	            let unreliable = false;
	            const oldHandler = outofbandVarianceMarkerHandler;
	            outofbandVarianceMarkerHandler = (onlyUnreliable) => onlyUnreliable ? unreliable = true : unmeasurable = true;
	            const typeWithSuper = createMarkerType(symbol, tp, markerSuperType);
	            const typeWithSub = createMarkerType(symbol, tp, markerSubType);
	            variance = (isTypeAssignableTo(typeWithSub, typeWithSuper) ? 1 /* Covariant */ : 0) | (isTypeAssignableTo(typeWithSuper, typeWithSub) ? 2 /* Contravariant */ : 0);
	            if (variance === 3 /* Bivariant */ && isTypeAssignableTo(createMarkerType(symbol, tp, markerOtherType), typeWithSuper)) {
	              variance = 4 /* Independent */;
	            }
	            outofbandVarianceMarkerHandler = oldHandler;
	            if (unmeasurable || unreliable) {
	              if (unmeasurable) {
	                variance |= 8 /* Unmeasurable */;
	              }
	              if (unreliable) {
	                variance |= 16 /* Unreliable */;
	              }
	            }
	          }
	          variances.push(variance);
	        }
	        if (!oldVarianceComputation) {
	          inVarianceComputation = false;
	          resolutionStart = 0;
	        }
	        links.variances = variances;
	        (_b = tracing) == null ? void 0 : _b.pop({ variances: variances.map(Debug.formatVariance) });
	      }
	      return links.variances;
	    }
	    function createMarkerType(symbol, source, target) {
	      const mapper = makeUnaryTypeMapper(source, target);
	      const type = getDeclaredTypeOfSymbol(symbol);
	      if (isErrorType(type)) {
	        return type;
	      }
	      const result = symbol.flags & 524288 /* TypeAlias */ ? getTypeAliasInstantiation(symbol, instantiateTypes(getSymbolLinks(symbol).typeParameters, mapper)) : createTypeReference(type, instantiateTypes(type.typeParameters, mapper));
	      markerTypes.add(getTypeId(result));
	      return result;
	    }
	    function isMarkerType(type) {
	      return markerTypes.has(getTypeId(type));
	    }
	    function getTypeParameterModifiers(tp) {
	      var _a;
	      return reduceLeft((_a = tp.symbol) == null ? void 0 : _a.declarations, (modifiers, d) => modifiers | getEffectiveModifierFlags(d), 0 /* None */) & (8192 /* In */ | 16384 /* Out */ | 4096 /* Const */);
	    }
	    function hasCovariantVoidArgument(typeArguments, variances) {
	      for (let i = 0; i < variances.length; i++) {
	        if ((variances[i] & 7 /* VarianceMask */) === 1 /* Covariant */ && typeArguments[i].flags & 16384 /* Void */) {
	          return true;
	        }
	      }
	      return false;
	    }
	    function isUnconstrainedTypeParameter(type) {
	      return type.flags & 262144 /* TypeParameter */ && !getConstraintOfTypeParameter(type);
	    }
	    function isNonDeferredTypeReference(type) {
	      return !!(getObjectFlags(type) & 4 /* Reference */) && !type.node;
	    }
	    function isTypeReferenceWithGenericArguments(type) {
	      return isNonDeferredTypeReference(type) && some(getTypeArguments(type), (t) => !!(t.flags & 262144 /* TypeParameter */) || isTypeReferenceWithGenericArguments(t));
	    }
	    function getGenericTypeReferenceRelationKey(source, target, postFix, ignoreConstraints) {
	      const typeParameters = [];
	      let constraintMarker = "";
	      const sourceId = getTypeReferenceId(source, 0);
	      const targetId = getTypeReferenceId(target, 0);
	      return `${constraintMarker}${sourceId},${targetId}${postFix}`;
	      function getTypeReferenceId(type, depth = 0) {
	        let result = "" + type.target.id;
	        for (const t of getTypeArguments(type)) {
	          if (t.flags & 262144 /* TypeParameter */) {
	            if (ignoreConstraints || isUnconstrainedTypeParameter(t)) {
	              let index = typeParameters.indexOf(t);
	              if (index < 0) {
	                index = typeParameters.length;
	                typeParameters.push(t);
	              }
	              result += "=" + index;
	              continue;
	            }
	            constraintMarker = "*";
	          } else if (depth < 4 && isTypeReferenceWithGenericArguments(t)) {
	            result += "<" + getTypeReferenceId(t, depth + 1) + ">";
	            continue;
	          }
	          result += "-" + t.id;
	        }
	        return result;
	      }
	    }
	    function getRelationKey(source, target, intersectionState, relation, ignoreConstraints) {
	      if (relation === identityRelation && source.id > target.id) {
	        const temp = source;
	        source = target;
	        target = temp;
	      }
	      const postFix = intersectionState ? ":" + intersectionState : "";
	      return isTypeReferenceWithGenericArguments(source) && isTypeReferenceWithGenericArguments(target) ? getGenericTypeReferenceRelationKey(source, target, postFix, ignoreConstraints) : `${source.id},${target.id}${postFix}`;
	    }
	    function forEachProperty2(prop, callback) {
	      if (getCheckFlags(prop) & 6 /* Synthetic */) {
	        for (const t of prop.links.containingType.types) {
	          const p = getPropertyOfType(t, prop.escapedName);
	          const result = p && forEachProperty2(p, callback);
	          if (result) {
	            return result;
	          }
	        }
	        return void 0;
	      }
	      return callback(prop);
	    }
	    function getDeclaringClass(prop) {
	      return prop.parent && prop.parent.flags & 32 /* Class */ ? getDeclaredTypeOfSymbol(getParentOfSymbol(prop)) : void 0;
	    }
	    function getTypeOfPropertyInBaseClass(property) {
	      const classType = getDeclaringClass(property);
	      const baseClassType = classType && getBaseTypes(classType)[0];
	      return baseClassType && getTypeOfPropertyOfType(baseClassType, property.escapedName);
	    }
	    function isPropertyInClassDerivedFrom(prop, baseClass) {
	      return forEachProperty2(prop, (sp) => {
	        const sourceClass = getDeclaringClass(sp);
	        return sourceClass ? hasBaseType(sourceClass, baseClass) : false;
	      });
	    }
	    function isValidOverrideOf(sourceProp, targetProp) {
	      return !forEachProperty2(targetProp, (tp) => getDeclarationModifierFlagsFromSymbol(tp) & 4 /* Protected */ ? !isPropertyInClassDerivedFrom(sourceProp, getDeclaringClass(tp)) : false);
	    }
	    function isClassDerivedFromDeclaringClasses(checkClass, prop, writing) {
	      return forEachProperty2(prop, (p) => getDeclarationModifierFlagsFromSymbol(p, writing) & 4 /* Protected */ ? !hasBaseType(checkClass, getDeclaringClass(p)) : false) ? void 0 : checkClass;
	    }
	    function isDeeplyNestedType(type, stack, depth, maxDepth = 3) {
	      if (depth >= maxDepth) {
	        if ((getObjectFlags(type) & 96 /* InstantiatedMapped */) === 96 /* InstantiatedMapped */) {
	          type = getMappedTargetWithSymbol(type);
	        }
	        if (type.flags & 2097152 /* Intersection */) {
	          return some(type.types, (t) => isDeeplyNestedType(t, stack, depth, maxDepth));
	        }
	        const identity2 = getRecursionIdentity(type);
	        let count = 0;
	        let lastTypeId = 0;
	        for (let i = 0; i < depth; i++) {
	          const t = stack[i];
	          if (hasMatchingRecursionIdentity(t, identity2)) {
	            if (t.id >= lastTypeId) {
	              count++;
	              if (count >= maxDepth) {
	                return true;
	              }
	            }
	            lastTypeId = t.id;
	          }
	        }
	      }
	      return false;
	    }
	    function getMappedTargetWithSymbol(type) {
	      let target;
	      while ((getObjectFlags(type) & 96 /* InstantiatedMapped */) === 96 /* InstantiatedMapped */ && (target = getModifiersTypeFromMappedType(type)) && (target.symbol || target.flags & 2097152 /* Intersection */ && some(target.types, (t) => !!t.symbol))) {
	        type = target;
	      }
	      return type;
	    }
	    function hasMatchingRecursionIdentity(type, identity2) {
	      if ((getObjectFlags(type) & 96 /* InstantiatedMapped */) === 96 /* InstantiatedMapped */) {
	        type = getMappedTargetWithSymbol(type);
	      }
	      if (type.flags & 2097152 /* Intersection */) {
	        return some(type.types, (t) => hasMatchingRecursionIdentity(t, identity2));
	      }
	      return getRecursionIdentity(type) === identity2;
	    }
	    function getRecursionIdentity(type) {
	      if (type.flags & 524288 /* Object */ && !isObjectOrArrayLiteralType(type)) {
	        if (getObjectFlags(type) & 4 /* Reference */ && type.node) {
	          return type.node;
	        }
	        if (type.symbol && !(getObjectFlags(type) & 16 /* Anonymous */ && type.symbol.flags & 32 /* Class */)) {
	          return type.symbol;
	        }
	        if (isTupleType(type)) {
	          return type.target;
	        }
	      }
	      if (type.flags & 262144 /* TypeParameter */) {
	        return type.symbol;
	      }
	      if (type.flags & 8388608 /* IndexedAccess */) {
	        do {
	          type = type.objectType;
	        } while (type.flags & 8388608 /* IndexedAccess */);
	        return type;
	      }
	      if (type.flags & 16777216 /* Conditional */) {
	        return type.root;
	      }
	      return type;
	    }
	    function isPropertyIdenticalTo(sourceProp, targetProp) {
	      return compareProperties2(sourceProp, targetProp, compareTypesIdentical) !== 0 /* False */;
	    }
	    function compareProperties2(sourceProp, targetProp, compareTypes) {
	      if (sourceProp === targetProp) {
	        return -1 /* True */;
	      }
	      const sourcePropAccessibility = getDeclarationModifierFlagsFromSymbol(sourceProp) & 6 /* NonPublicAccessibilityModifier */;
	      const targetPropAccessibility = getDeclarationModifierFlagsFromSymbol(targetProp) & 6 /* NonPublicAccessibilityModifier */;
	      if (sourcePropAccessibility !== targetPropAccessibility) {
	        return 0 /* False */;
	      }
	      if (sourcePropAccessibility) {
	        if (getTargetSymbol(sourceProp) !== getTargetSymbol(targetProp)) {
	          return 0 /* False */;
	        }
	      } else {
	        if ((sourceProp.flags & 16777216 /* Optional */) !== (targetProp.flags & 16777216 /* Optional */)) {
	          return 0 /* False */;
	        }
	      }
	      if (isReadonlySymbol(sourceProp) !== isReadonlySymbol(targetProp)) {
	        return 0 /* False */;
	      }
	      return compareTypes(getTypeOfSymbol(sourceProp), getTypeOfSymbol(targetProp));
	    }
	    function isMatchingSignature(source, target, partialMatch) {
	      const sourceParameterCount = getParameterCount(source);
	      const targetParameterCount = getParameterCount(target);
	      const sourceMinArgumentCount = getMinArgumentCount(source);
	      const targetMinArgumentCount = getMinArgumentCount(target);
	      const sourceHasRestParameter = hasEffectiveRestParameter(source);
	      const targetHasRestParameter = hasEffectiveRestParameter(target);
	      if (sourceParameterCount === targetParameterCount && sourceMinArgumentCount === targetMinArgumentCount && sourceHasRestParameter === targetHasRestParameter) {
	        return true;
	      }
	      if (partialMatch && sourceMinArgumentCount <= targetMinArgumentCount) {
	        return true;
	      }
	      return false;
	    }
	    function compareSignaturesIdentical(source, target, partialMatch, ignoreThisTypes, ignoreReturnTypes, compareTypes) {
	      if (source === target) {
	        return -1 /* True */;
	      }
	      if (!isMatchingSignature(source, target, partialMatch)) {
	        return 0 /* False */;
	      }
	      if (length(source.typeParameters) !== length(target.typeParameters)) {
	        return 0 /* False */;
	      }
	      if (target.typeParameters) {
	        const mapper = createTypeMapper(source.typeParameters, target.typeParameters);
	        for (let i = 0; i < target.typeParameters.length; i++) {
	          const s = source.typeParameters[i];
	          const t = target.typeParameters[i];
	          if (!(s === t || compareTypes(instantiateType(getConstraintFromTypeParameter(s), mapper) || unknownType, getConstraintFromTypeParameter(t) || unknownType) && compareTypes(instantiateType(getDefaultFromTypeParameter(s), mapper) || unknownType, getDefaultFromTypeParameter(t) || unknownType))) {
	            return 0 /* False */;
	          }
	        }
	        source = instantiateSignature(
	          source,
	          mapper,
	          /*eraseTypeParameters*/
	          true
	        );
	      }
	      let result = -1 /* True */;
	      if (!ignoreThisTypes) {
	        const sourceThisType = getThisTypeOfSignature(source);
	        if (sourceThisType) {
	          const targetThisType = getThisTypeOfSignature(target);
	          if (targetThisType) {
	            const related = compareTypes(sourceThisType, targetThisType);
	            if (!related) {
	              return 0 /* False */;
	            }
	            result &= related;
	          }
	        }
	      }
	      const targetLen = getParameterCount(target);
	      for (let i = 0; i < targetLen; i++) {
	        const s = getTypeAtPosition(source, i);
	        const t = getTypeAtPosition(target, i);
	        const related = compareTypes(t, s);
	        if (!related) {
	          return 0 /* False */;
	        }
	        result &= related;
	      }
	      if (!ignoreReturnTypes) {
	        const sourceTypePredicate = getTypePredicateOfSignature(source);
	        const targetTypePredicate = getTypePredicateOfSignature(target);
	        result &= sourceTypePredicate || targetTypePredicate ? compareTypePredicatesIdentical(sourceTypePredicate, targetTypePredicate, compareTypes) : compareTypes(getReturnTypeOfSignature(source), getReturnTypeOfSignature(target));
	      }
	      return result;
	    }
	    function compareTypePredicatesIdentical(source, target, compareTypes) {
	      return !(source && target && typePredicateKindsMatch(source, target)) ? 0 /* False */ : source.type === target.type ? -1 /* True */ : source.type && target.type ? compareTypes(source.type, target.type) : 0 /* False */;
	    }
	    function literalTypesWithSameBaseType(types) {
	      let commonBaseType;
	      for (const t of types) {
	        if (!(t.flags & 131072 /* Never */)) {
	          const baseType = getBaseTypeOfLiteralType(t);
	          commonBaseType ?? (commonBaseType = baseType);
	          if (baseType === t || baseType !== commonBaseType) {
	            return false;
	          }
	        }
	      }
	      return true;
	    }
	    function getCombinedTypeFlags(types) {
	      return reduceLeft(types, (flags, t) => flags | (t.flags & 1048576 /* Union */ ? getCombinedTypeFlags(t.types) : t.flags), 0);
	    }
	    function getCommonSupertype(types) {
	      if (types.length === 1) {
	        return types[0];
	      }
	      const primaryTypes = strictNullChecks ? sameMap(types, (t) => filterType(t, (u) => !(u.flags & 98304 /* Nullable */))) : types;
	      const superTypeOrUnion = literalTypesWithSameBaseType(primaryTypes) ? getUnionType(primaryTypes) : reduceLeft(primaryTypes, (s, t) => isTypeSubtypeOf(s, t) ? t : s);
	      return primaryTypes === types ? superTypeOrUnion : getNullableType(superTypeOrUnion, getCombinedTypeFlags(types) & 98304 /* Nullable */);
	    }
	    function getCommonSubtype(types) {
	      return reduceLeft(types, (s, t) => isTypeSubtypeOf(t, s) ? t : s);
	    }
	    function isArrayType(type) {
	      return !!(getObjectFlags(type) & 4 /* Reference */) && (type.target === globalArrayType || type.target === globalReadonlyArrayType);
	    }
	    function isReadonlyArrayType(type) {
	      return !!(getObjectFlags(type) & 4 /* Reference */) && type.target === globalReadonlyArrayType;
	    }
	    function isArrayOrTupleType(type) {
	      return isArrayType(type) || isTupleType(type);
	    }
	    function isMutableArrayOrTuple(type) {
	      return isArrayType(type) && !isReadonlyArrayType(type) || isTupleType(type) && !type.target.readonly;
	    }
	    function getElementTypeOfArrayType(type) {
	      return isArrayType(type) ? getTypeArguments(type)[0] : void 0;
	    }
	    function isArrayLikeType(type) {
	      return isArrayType(type) || !(type.flags & 98304 /* Nullable */) && isTypeAssignableTo(type, anyReadonlyArrayType);
	    }
	    function isMutableArrayLikeType(type) {
	      return isMutableArrayOrTuple(type) || !(type.flags & (1 /* Any */ | 98304 /* Nullable */)) && isTypeAssignableTo(type, anyArrayType);
	    }
	    function getSingleBaseForNonAugmentingSubtype(type) {
	      if (!(getObjectFlags(type) & 4 /* Reference */) || !(getObjectFlags(type.target) & 3 /* ClassOrInterface */)) {
	        return void 0;
	      }
	      if (getObjectFlags(type) & 33554432 /* IdenticalBaseTypeCalculated */) {
	        return getObjectFlags(type) & 67108864 /* IdenticalBaseTypeExists */ ? type.cachedEquivalentBaseType : void 0;
	      }
	      type.objectFlags |= 33554432 /* IdenticalBaseTypeCalculated */;
	      const target = type.target;
	      if (getObjectFlags(target) & 1 /* Class */) {
	        const baseTypeNode = getBaseTypeNodeOfClass(target);
	        if (baseTypeNode && baseTypeNode.expression.kind !== 80 /* Identifier */ && baseTypeNode.expression.kind !== 211 /* PropertyAccessExpression */) {
	          return void 0;
	        }
	      }
	      const bases = getBaseTypes(target);
	      if (bases.length !== 1) {
	        return void 0;
	      }
	      if (getMembersOfSymbol(type.symbol).size) {
	        return void 0;
	      }
	      let instantiatedBase = !length(target.typeParameters) ? bases[0] : instantiateType(bases[0], createTypeMapper(target.typeParameters, getTypeArguments(type).slice(0, target.typeParameters.length)));
	      if (length(getTypeArguments(type)) > length(target.typeParameters)) {
	        instantiatedBase = getTypeWithThisArgument(instantiatedBase, last(getTypeArguments(type)));
	      }
	      type.objectFlags |= 67108864 /* IdenticalBaseTypeExists */;
	      return type.cachedEquivalentBaseType = instantiatedBase;
	    }
	    function isEmptyLiteralType(type) {
	      return strictNullChecks ? type === implicitNeverType : type === undefinedWideningType;
	    }
	    function isEmptyArrayLiteralType(type) {
	      const elementType = getElementTypeOfArrayType(type);
	      return !!elementType && isEmptyLiteralType(elementType);
	    }
	    function isTupleLikeType(type) {
	      let lengthType;
	      return isTupleType(type) || !!getPropertyOfType(type, "0") || isArrayLikeType(type) && !!(lengthType = getTypeOfPropertyOfType(type, "length")) && everyType(lengthType, (t) => !!(t.flags & 256 /* NumberLiteral */));
	    }
	    function isArrayOrTupleLikeType(type) {
	      return isArrayLikeType(type) || isTupleLikeType(type);
	    }
	    function getTupleElementType(type, index) {
	      const propType = getTypeOfPropertyOfType(type, "" + index);
	      if (propType) {
	        return propType;
	      }
	      if (everyType(type, isTupleType)) {
	        return getTupleElementTypeOutOfStartCount(type, index, compilerOptions.noUncheckedIndexedAccess ? undefinedType : void 0);
	      }
	      return void 0;
	    }
	    function isNeitherUnitTypeNorNever(type) {
	      return !(type.flags & (109472 /* Unit */ | 131072 /* Never */));
	    }
	    function isUnitType(type) {
	      return !!(type.flags & 109472 /* Unit */);
	    }
	    function isUnitLikeType(type) {
	      const t = getBaseConstraintOrType(type);
	      return t.flags & 2097152 /* Intersection */ ? some(t.types, isUnitType) : isUnitType(t);
	    }
	    function extractUnitType(type) {
	      return type.flags & 2097152 /* Intersection */ ? find(type.types, isUnitType) || type : type;
	    }
	    function isLiteralType(type) {
	      return type.flags & 16 /* Boolean */ ? true : type.flags & 1048576 /* Union */ ? type.flags & 1024 /* EnumLiteral */ ? true : every(type.types, isUnitType) : isUnitType(type);
	    }
	    function getBaseTypeOfLiteralType(type) {
	      return type.flags & 1056 /* EnumLike */ ? getBaseTypeOfEnumLikeType(type) : type.flags & (128 /* StringLiteral */ | 134217728 /* TemplateLiteral */ | 268435456 /* StringMapping */) ? stringType : type.flags & 256 /* NumberLiteral */ ? numberType : type.flags & 2048 /* BigIntLiteral */ ? bigintType : type.flags & 512 /* BooleanLiteral */ ? booleanType : type.flags & 1048576 /* Union */ ? getBaseTypeOfLiteralTypeUnion(type) : type;
	    }
	    function getBaseTypeOfLiteralTypeUnion(type) {
	      const key = `B${getTypeId(type)}`;
	      return getCachedType(key) ?? setCachedType(key, mapType(type, getBaseTypeOfLiteralType));
	    }
	    function getBaseTypeOfLiteralTypeForComparison(type) {
	      return type.flags & (128 /* StringLiteral */ | 134217728 /* TemplateLiteral */ | 268435456 /* StringMapping */) ? stringType : type.flags & (256 /* NumberLiteral */ | 32 /* Enum */) ? numberType : type.flags & 2048 /* BigIntLiteral */ ? bigintType : type.flags & 512 /* BooleanLiteral */ ? booleanType : type.flags & 1048576 /* Union */ ? mapType(type, getBaseTypeOfLiteralTypeForComparison) : type;
	    }
	    function getWidenedLiteralType(type) {
	      return type.flags & 1056 /* EnumLike */ && isFreshLiteralType(type) ? getBaseTypeOfEnumLikeType(type) : type.flags & 128 /* StringLiteral */ && isFreshLiteralType(type) ? stringType : type.flags & 256 /* NumberLiteral */ && isFreshLiteralType(type) ? numberType : type.flags & 2048 /* BigIntLiteral */ && isFreshLiteralType(type) ? bigintType : type.flags & 512 /* BooleanLiteral */ && isFreshLiteralType(type) ? booleanType : type.flags & 1048576 /* Union */ ? mapType(type, getWidenedLiteralType) : type;
	    }
	    function getWidenedUniqueESSymbolType(type) {
	      return type.flags & 8192 /* UniqueESSymbol */ ? esSymbolType : type.flags & 1048576 /* Union */ ? mapType(type, getWidenedUniqueESSymbolType) : type;
	    }
	    function getWidenedLiteralLikeTypeForContextualType(type, contextualType) {
	      if (!isLiteralOfContextualType(type, contextualType)) {
	        type = getWidenedUniqueESSymbolType(getWidenedLiteralType(type));
	      }
	      return getRegularTypeOfLiteralType(type);
	    }
	    function getWidenedLiteralLikeTypeForContextualReturnTypeIfNeeded(type, contextualSignatureReturnType, isAsync) {
	      if (type && isUnitType(type)) {
	        const contextualType = !contextualSignatureReturnType ? void 0 : isAsync ? getPromisedTypeOfPromise(contextualSignatureReturnType) : contextualSignatureReturnType;
	        type = getWidenedLiteralLikeTypeForContextualType(type, contextualType);
	      }
	      return type;
	    }
	    function getWidenedLiteralLikeTypeForContextualIterationTypeIfNeeded(type, contextualSignatureReturnType, kind, isAsyncGenerator) {
	      if (type && isUnitType(type)) {
	        const contextualType = !contextualSignatureReturnType ? void 0 : getIterationTypeOfGeneratorFunctionReturnType(kind, contextualSignatureReturnType, isAsyncGenerator);
	        type = getWidenedLiteralLikeTypeForContextualType(type, contextualType);
	      }
	      return type;
	    }
	    function isTupleType(type) {
	      return !!(getObjectFlags(type) & 4 /* Reference */ && type.target.objectFlags & 8 /* Tuple */);
	    }
	    function isGenericTupleType(type) {
	      return isTupleType(type) && !!(type.target.combinedFlags & 8 /* Variadic */);
	    }
	    function isSingleElementGenericTupleType(type) {
	      return isGenericTupleType(type) && type.target.elementFlags.length === 1;
	    }
	    function getRestTypeOfTupleType(type) {
	      return getElementTypeOfSliceOfTupleType(type, type.target.fixedLength);
	    }
	    function getTupleElementTypeOutOfStartCount(type, index, undefinedOrMissingType2) {
	      return mapType(type, (t) => {
	        const tupleType = t;
	        const restType = getRestTypeOfTupleType(tupleType);
	        if (!restType) {
	          return undefinedType;
	        }
	        if (undefinedOrMissingType2 && index >= getTotalFixedElementCount(tupleType.target)) {
	          return getUnionType([restType, undefinedOrMissingType2]);
	        }
	        return restType;
	      });
	    }
	    function getRestArrayTypeOfTupleType(type) {
	      const restType = getRestTypeOfTupleType(type);
	      return restType && createArrayType(restType);
	    }
	    function getElementTypeOfSliceOfTupleType(type, index, endSkipCount = 0, writing = false, noReductions = false) {
	      const length2 = getTypeReferenceArity(type) - endSkipCount;
	      if (index < length2) {
	        const typeArguments = getTypeArguments(type);
	        const elementTypes = [];
	        for (let i = index; i < length2; i++) {
	          const t = typeArguments[i];
	          elementTypes.push(type.target.elementFlags[i] & 8 /* Variadic */ ? getIndexedAccessType(t, numberType) : t);
	        }
	        return writing ? getIntersectionType(elementTypes) : getUnionType(elementTypes, noReductions ? 0 /* None */ : 1 /* Literal */);
	      }
	      return void 0;
	    }
	    function isTupleTypeStructureMatching(t1, t2) {
	      return getTypeReferenceArity(t1) === getTypeReferenceArity(t2) && every(t1.target.elementFlags, (f, i) => (f & 12 /* Variable */) === (t2.target.elementFlags[i] & 12 /* Variable */));
	    }
	    function isZeroBigInt({ value }) {
	      return value.base10Value === "0";
	    }
	    function removeDefinitelyFalsyTypes(type) {
	      return filterType(type, (t) => hasTypeFacts(t, 4194304 /* Truthy */));
	    }
	    function extractDefinitelyFalsyTypes(type) {
	      return mapType(type, getDefinitelyFalsyPartOfType);
	    }
	    function getDefinitelyFalsyPartOfType(type) {
	      return type.flags & 4 /* String */ ? emptyStringType : type.flags & 8 /* Number */ ? zeroType : type.flags & 64 /* BigInt */ ? zeroBigIntType : type === regularFalseType || type === falseType || type.flags & (16384 /* Void */ | 32768 /* Undefined */ | 65536 /* Null */ | 3 /* AnyOrUnknown */) || type.flags & 128 /* StringLiteral */ && type.value === "" || type.flags & 256 /* NumberLiteral */ && type.value === 0 || type.flags & 2048 /* BigIntLiteral */ && isZeroBigInt(type) ? type : neverType;
	    }
	    function getNullableType(type, flags) {
	      const missing = flags & ~type.flags & (32768 /* Undefined */ | 65536 /* Null */);
	      return missing === 0 ? type : missing === 32768 /* Undefined */ ? getUnionType([type, undefinedType]) : missing === 65536 /* Null */ ? getUnionType([type, nullType]) : getUnionType([type, undefinedType, nullType]);
	    }
	    function getOptionalType(type, isProperty = false) {
	      Debug.assert(strictNullChecks);
	      const missingOrUndefined = isProperty ? undefinedOrMissingType : undefinedType;
	      return type === missingOrUndefined || type.flags & 1048576 /* Union */ && type.types[0] === missingOrUndefined ? type : getUnionType([type, missingOrUndefined]);
	    }
	    function getGlobalNonNullableTypeInstantiation(type) {
	      if (!deferredGlobalNonNullableTypeAlias) {
	        deferredGlobalNonNullableTypeAlias = getGlobalSymbol(
	          "NonNullable",
	          524288 /* TypeAlias */,
	          /*diagnostic*/
	          void 0
	        ) || unknownSymbol;
	      }
	      return deferredGlobalNonNullableTypeAlias !== unknownSymbol ? getTypeAliasInstantiation(deferredGlobalNonNullableTypeAlias, [type]) : getIntersectionType([type, emptyObjectType]);
	    }
	    function getNonNullableType(type) {
	      return strictNullChecks ? getAdjustedTypeWithFacts(type, 2097152 /* NEUndefinedOrNull */) : type;
	    }
	    function addOptionalTypeMarker(type) {
	      return strictNullChecks ? getUnionType([type, optionalType]) : type;
	    }
	    function removeOptionalTypeMarker(type) {
	      return strictNullChecks ? removeType(type, optionalType) : type;
	    }
	    function propagateOptionalTypeMarker(type, node, wasOptional) {
	      return wasOptional ? isOutermostOptionalChain(node) ? getOptionalType(type) : addOptionalTypeMarker(type) : type;
	    }
	    function getOptionalExpressionType(exprType, expression) {
	      return isExpressionOfOptionalChainRoot(expression) ? getNonNullableType(exprType) : isOptionalChain(expression) ? removeOptionalTypeMarker(exprType) : exprType;
	    }
	    function removeMissingType(type, isOptional) {
	      return exactOptionalPropertyTypes && isOptional ? removeType(type, missingType) : type;
	    }
	    function containsMissingType(type) {
	      return type === missingType || !!(type.flags & 1048576 /* Union */) && type.types[0] === missingType;
	    }
	    function removeMissingOrUndefinedType(type) {
	      return exactOptionalPropertyTypes ? removeType(type, missingType) : getTypeWithFacts(type, 524288 /* NEUndefined */);
	    }
	    function isCoercibleUnderDoubleEquals(source, target) {
	      return (source.flags & (8 /* Number */ | 4 /* String */ | 512 /* BooleanLiteral */)) !== 0 && (target.flags & (8 /* Number */ | 4 /* String */ | 16 /* Boolean */)) !== 0;
	    }
	    function isObjectTypeWithInferableIndex(type) {
	      const objectFlags = getObjectFlags(type);
	      return type.flags & 2097152 /* Intersection */ ? every(type.types, isObjectTypeWithInferableIndex) : !!(type.symbol && (type.symbol.flags & (4096 /* ObjectLiteral */ | 2048 /* TypeLiteral */ | 384 /* Enum */ | 512 /* ValueModule */)) !== 0 && !(type.symbol.flags & 32 /* Class */) && !typeHasCallOrConstructSignatures(type)) || !!(objectFlags & 4194304 /* ObjectRestType */) || !!(objectFlags & 1024 /* ReverseMapped */ && isObjectTypeWithInferableIndex(type.source));
	    }
	    function createSymbolWithType(source, type) {
	      const symbol = createSymbol(source.flags, source.escapedName, getCheckFlags(source) & 8 /* Readonly */);
	      symbol.declarations = source.declarations;
	      symbol.parent = source.parent;
	      symbol.links.type = type;
	      symbol.links.target = source;
	      if (source.valueDeclaration) {
	        symbol.valueDeclaration = source.valueDeclaration;
	      }
	      const nameType = getSymbolLinks(source).nameType;
	      if (nameType) {
	        symbol.links.nameType = nameType;
	      }
	      return symbol;
	    }
	    function transformTypeOfMembers(type, f) {
	      const members = createSymbolTable();
	      for (const property of getPropertiesOfObjectType(type)) {
	        const original = getTypeOfSymbol(property);
	        const updated = f(original);
	        members.set(property.escapedName, updated === original ? property : createSymbolWithType(property, updated));
	      }
	      return members;
	    }
	    function getRegularTypeOfObjectLiteral(type) {
	      if (!(isObjectLiteralType2(type) && getObjectFlags(type) & 8192 /* FreshLiteral */)) {
	        return type;
	      }
	      const regularType = type.regularType;
	      if (regularType) {
	        return regularType;
	      }
	      const resolved = type;
	      const members = transformTypeOfMembers(type, getRegularTypeOfObjectLiteral);
	      const regularNew = createAnonymousType(resolved.symbol, members, resolved.callSignatures, resolved.constructSignatures, resolved.indexInfos);
	      regularNew.flags = resolved.flags;
	      regularNew.objectFlags |= resolved.objectFlags & ~8192 /* FreshLiteral */;
	      type.regularType = regularNew;
	      return regularNew;
	    }
	    function createWideningContext(parent2, propertyName, siblings) {
	      return { parent: parent2, propertyName, siblings, resolvedProperties: void 0 };
	    }
	    function getSiblingsOfContext(context) {
	      if (!context.siblings) {
	        const siblings = [];
	        for (const type of getSiblingsOfContext(context.parent)) {
	          if (isObjectLiteralType2(type)) {
	            const prop = getPropertyOfObjectType(type, context.propertyName);
	            if (prop) {
	              forEachType(getTypeOfSymbol(prop), (t) => {
	                siblings.push(t);
	              });
	            }
	          }
	        }
	        context.siblings = siblings;
	      }
	      return context.siblings;
	    }
	    function getPropertiesOfContext(context) {
	      if (!context.resolvedProperties) {
	        const names = /* @__PURE__ */ new Map();
	        for (const t of getSiblingsOfContext(context)) {
	          if (isObjectLiteralType2(t) && !(getObjectFlags(t) & 2097152 /* ContainsSpread */)) {
	            for (const prop of getPropertiesOfType(t)) {
	              names.set(prop.escapedName, prop);
	            }
	          }
	        }
	        context.resolvedProperties = arrayFrom(names.values());
	      }
	      return context.resolvedProperties;
	    }
	    function getWidenedProperty(prop, context) {
	      if (!(prop.flags & 4 /* Property */)) {
	        return prop;
	      }
	      const original = getTypeOfSymbol(prop);
	      const propContext = context && createWideningContext(
	        context,
	        prop.escapedName,
	        /*siblings*/
	        void 0
	      );
	      const widened = getWidenedTypeWithContext(original, propContext);
	      return widened === original ? prop : createSymbolWithType(prop, widened);
	    }
	    function getUndefinedProperty(prop) {
	      const cached = undefinedProperties.get(prop.escapedName);
	      if (cached) {
	        return cached;
	      }
	      const result = createSymbolWithType(prop, undefinedOrMissingType);
	      result.flags |= 16777216 /* Optional */;
	      undefinedProperties.set(prop.escapedName, result);
	      return result;
	    }
	    function getWidenedTypeOfObjectLiteral(type, context) {
	      const members = createSymbolTable();
	      for (const prop of getPropertiesOfObjectType(type)) {
	        members.set(prop.escapedName, getWidenedProperty(prop, context));
	      }
	      if (context) {
	        for (const prop of getPropertiesOfContext(context)) {
	          if (!members.has(prop.escapedName)) {
	            members.set(prop.escapedName, getUndefinedProperty(prop));
	          }
	        }
	      }
	      const result = createAnonymousType(type.symbol, members, emptyArray, emptyArray, sameMap(getIndexInfosOfType(type), (info) => createIndexInfo(info.keyType, getWidenedType(info.type), info.isReadonly)));
	      result.objectFlags |= getObjectFlags(type) & (4096 /* JSLiteral */ | 262144 /* NonInferrableType */);
	      return result;
	    }
	    function getWidenedType(type) {
	      return getWidenedTypeWithContext(
	        type,
	        /*context*/
	        void 0
	      );
	    }
	    function getWidenedTypeWithContext(type, context) {
	      if (getObjectFlags(type) & 196608 /* RequiresWidening */) {
	        if (context === void 0 && type.widened) {
	          return type.widened;
	        }
	        let result;
	        if (type.flags & (1 /* Any */ | 98304 /* Nullable */)) {
	          result = anyType;
	        } else if (isObjectLiteralType2(type)) {
	          result = getWidenedTypeOfObjectLiteral(type, context);
	        } else if (type.flags & 1048576 /* Union */) {
	          const unionContext = context || createWideningContext(
	            /*parent*/
	            void 0,
	            /*propertyName*/
	            void 0,
	            type.types
	          );
	          const widenedTypes = sameMap(type.types, (t) => t.flags & 98304 /* Nullable */ ? t : getWidenedTypeWithContext(t, unionContext));
	          result = getUnionType(widenedTypes, some(widenedTypes, isEmptyObjectType) ? 2 /* Subtype */ : 1 /* Literal */);
	        } else if (type.flags & 2097152 /* Intersection */) {
	          result = getIntersectionType(sameMap(type.types, getWidenedType));
	        } else if (isArrayOrTupleType(type)) {
	          result = createTypeReference(type.target, sameMap(getTypeArguments(type), getWidenedType));
	        }
	        if (result && context === void 0) {
	          type.widened = result;
	        }
	        return result || type;
	      }
	      return type;
	    }
	    function reportWideningErrorsInType(type) {
	      let errorReported = false;
	      if (getObjectFlags(type) & 65536 /* ContainsWideningType */) {
	        if (type.flags & 1048576 /* Union */) {
	          if (some(type.types, isEmptyObjectType)) {
	            errorReported = true;
	          } else {
	            for (const t of type.types) {
	              if (reportWideningErrorsInType(t)) {
	                errorReported = true;
	              }
	            }
	          }
	        }
	        if (isArrayOrTupleType(type)) {
	          for (const t of getTypeArguments(type)) {
	            if (reportWideningErrorsInType(t)) {
	              errorReported = true;
	            }
	          }
	        }
	        if (isObjectLiteralType2(type)) {
	          for (const p of getPropertiesOfObjectType(type)) {
	            const t = getTypeOfSymbol(p);
	            if (getObjectFlags(t) & 65536 /* ContainsWideningType */) {
	              if (!reportWideningErrorsInType(t)) {
	                error2(p.valueDeclaration, Diagnostics.Object_literal_s_property_0_implicitly_has_an_1_type, symbolToString(p), typeToString(getWidenedType(t)));
	              }
	              errorReported = true;
	            }
	          }
	        }
	      }
	      return errorReported;
	    }
	    function reportImplicitAny(declaration, type, wideningKind) {
	      const typeAsString = typeToString(getWidenedType(type));
	      if (isInJSFile(declaration) && !isCheckJsEnabledForFile(getSourceFileOfNode(declaration), compilerOptions)) {
	        return;
	      }
	      let diagnostic;
	      switch (declaration.kind) {
	        case 226 /* BinaryExpression */:
	        case 172 /* PropertyDeclaration */:
	        case 171 /* PropertySignature */:
	          diagnostic = noImplicitAny ? Diagnostics.Member_0_implicitly_has_an_1_type : Diagnostics.Member_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage;
	          break;
	        case 169 /* Parameter */:
	          const param = declaration;
	          if (isIdentifier(param.name)) {
	            const originalKeywordKind = identifierToKeywordKind(param.name);
	            if ((isCallSignatureDeclaration(param.parent) || isMethodSignature(param.parent) || isFunctionTypeNode(param.parent)) && param.parent.parameters.includes(param) && (resolveName(
	              param,
	              param.name.escapedText,
	              788968 /* Type */,
	              /*nameNotFoundMessage*/
	              void 0,
	              param.name.escapedText,
	              /*isUse*/
	              true
	            ) || originalKeywordKind && isTypeNodeKind(originalKeywordKind))) {
	              const newName = "arg" + param.parent.parameters.indexOf(param);
	              const typeName = declarationNameToString(param.name) + (param.dotDotDotToken ? "[]" : "");
	              errorOrSuggestion(noImplicitAny, declaration, Diagnostics.Parameter_has_a_name_but_no_type_Did_you_mean_0_Colon_1, newName, typeName);
	              return;
	            }
	          }
	          diagnostic = declaration.dotDotDotToken ? noImplicitAny ? Diagnostics.Rest_parameter_0_implicitly_has_an_any_type : Diagnostics.Rest_parameter_0_implicitly_has_an_any_type_but_a_better_type_may_be_inferred_from_usage : noImplicitAny ? Diagnostics.Parameter_0_implicitly_has_an_1_type : Diagnostics.Parameter_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage;
	          break;
	        case 208 /* BindingElement */:
	          diagnostic = Diagnostics.Binding_element_0_implicitly_has_an_1_type;
	          if (!noImplicitAny) {
	            return;
	          }
	          break;
	        case 324 /* JSDocFunctionType */:
	          error2(declaration, Diagnostics.Function_type_which_lacks_return_type_annotation_implicitly_has_an_0_return_type, typeAsString);
	          return;
	        case 330 /* JSDocSignature */:
	          if (noImplicitAny && isJSDocOverloadTag(declaration.parent)) {
	            error2(declaration.parent.tagName, Diagnostics.This_overload_implicitly_returns_the_type_0_because_it_lacks_a_return_type_annotation, typeAsString);
	          }
	          return;
	        case 262 /* FunctionDeclaration */:
	        case 174 /* MethodDeclaration */:
	        case 173 /* MethodSignature */:
	        case 177 /* GetAccessor */:
	        case 178 /* SetAccessor */:
	        case 218 /* FunctionExpression */:
	        case 219 /* ArrowFunction */:
	          if (noImplicitAny && !declaration.name) {
	            if (wideningKind === 3 /* GeneratorYield */) {
	              error2(declaration, Diagnostics.Generator_implicitly_has_yield_type_0_because_it_does_not_yield_any_values_Consider_supplying_a_return_type_annotation, typeAsString);
	            } else {
	              error2(declaration, Diagnostics.Function_expression_which_lacks_return_type_annotation_implicitly_has_an_0_return_type, typeAsString);
	            }
	            return;
	          }
	          diagnostic = !noImplicitAny ? Diagnostics._0_implicitly_has_an_1_return_type_but_a_better_type_may_be_inferred_from_usage : wideningKind === 3 /* GeneratorYield */ ? Diagnostics._0_which_lacks_return_type_annotation_implicitly_has_an_1_yield_type : Diagnostics._0_which_lacks_return_type_annotation_implicitly_has_an_1_return_type;
	          break;
	        case 200 /* MappedType */:
	          if (noImplicitAny) {
	            error2(declaration, Diagnostics.Mapped_object_type_implicitly_has_an_any_template_type);
	          }
	          return;
	        default:
	          diagnostic = noImplicitAny ? Diagnostics.Variable_0_implicitly_has_an_1_type : Diagnostics.Variable_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage;
	      }
	      errorOrSuggestion(noImplicitAny, declaration, diagnostic, declarationNameToString(getNameOfDeclaration(declaration)), typeAsString);
	    }
	    function reportErrorsFromWidening(declaration, type, wideningKind) {
	      addLazyDiagnostic(() => {
	        if (noImplicitAny && getObjectFlags(type) & 65536 /* ContainsWideningType */ && (!wideningKind || !getContextualSignatureForFunctionLikeDeclaration(declaration))) {
	          if (!reportWideningErrorsInType(type)) {
	            reportImplicitAny(declaration, type, wideningKind);
	          }
	        }
	      });
	    }
	    function applyToParameterTypes(source, target, callback) {
	      const sourceCount = getParameterCount(source);
	      const targetCount = getParameterCount(target);
	      const sourceRestType = getEffectiveRestType(source);
	      const targetRestType = getEffectiveRestType(target);
	      const targetNonRestCount = targetRestType ? targetCount - 1 : targetCount;
	      const paramCount = sourceRestType ? targetNonRestCount : Math.min(sourceCount, targetNonRestCount);
	      const sourceThisType = getThisTypeOfSignature(source);
	      if (sourceThisType) {
	        const targetThisType = getThisTypeOfSignature(target);
	        if (targetThisType) {
	          callback(sourceThisType, targetThisType);
	        }
	      }
	      for (let i = 0; i < paramCount; i++) {
	        callback(getTypeAtPosition(source, i), getTypeAtPosition(target, i));
	      }
	      if (targetRestType) {
	        callback(getRestTypeAtPosition(
	          source,
	          paramCount,
	          /*readonly*/
	          isConstTypeVariable(targetRestType) && !someType(targetRestType, isMutableArrayLikeType)
	        ), targetRestType);
	      }
	    }
	    function applyToReturnTypes(source, target, callback) {
	      const sourceTypePredicate = getTypePredicateOfSignature(source);
	      const targetTypePredicate = getTypePredicateOfSignature(target);
	      if (sourceTypePredicate && targetTypePredicate && typePredicateKindsMatch(sourceTypePredicate, targetTypePredicate) && sourceTypePredicate.type && targetTypePredicate.type) {
	        callback(sourceTypePredicate.type, targetTypePredicate.type);
	      } else {
	        callback(getReturnTypeOfSignature(source), getReturnTypeOfSignature(target));
	      }
	    }
	    function createInferenceContext(typeParameters, signature, flags, compareTypes) {
	      return createInferenceContextWorker(typeParameters.map(createInferenceInfo), signature, flags, compareTypes || compareTypesAssignable);
	    }
	    function cloneInferenceContext(context, extraFlags = 0) {
	      return context && createInferenceContextWorker(map(context.inferences, cloneInferenceInfo), context.signature, context.flags | extraFlags, context.compareTypes);
	    }
	    function createInferenceContextWorker(inferences, signature, flags, compareTypes) {
	      const context = {
	        inferences,
	        signature,
	        flags,
	        compareTypes,
	        mapper: reportUnmeasurableMapper,
	        // initialize to a noop mapper so the context object is available, but the underlying object shape is right upon construction
	        nonFixingMapper: reportUnmeasurableMapper
	      };
	      context.mapper = makeFixingMapperForContext(context);
	      context.nonFixingMapper = makeNonFixingMapperForContext(context);
	      return context;
	    }
	    function makeFixingMapperForContext(context) {
	      return makeDeferredTypeMapper(
	        map(context.inferences, (i) => i.typeParameter),
	        map(context.inferences, (inference, i) => () => {
	          if (!inference.isFixed) {
	            inferFromIntraExpressionSites(context);
	            clearCachedInferences(context.inferences);
	            inference.isFixed = true;
	          }
	          return getInferredType(context, i);
	        })
	      );
	    }
	    function makeNonFixingMapperForContext(context) {
	      return makeDeferredTypeMapper(
	        map(context.inferences, (i) => i.typeParameter),
	        map(context.inferences, (_, i) => () => {
	          return getInferredType(context, i);
	        })
	      );
	    }
	    function clearCachedInferences(inferences) {
	      for (const inference of inferences) {
	        if (!inference.isFixed) {
	          inference.inferredType = void 0;
	        }
	      }
	    }
	    function addIntraExpressionInferenceSite(context, node, type) {
	      (context.intraExpressionInferenceSites ?? (context.intraExpressionInferenceSites = [])).push({ node, type });
	    }
	    function inferFromIntraExpressionSites(context) {
	      if (context.intraExpressionInferenceSites) {
	        for (const { node, type } of context.intraExpressionInferenceSites) {
	          const contextualType = node.kind === 174 /* MethodDeclaration */ ? getContextualTypeForObjectLiteralMethod(node, 2 /* NoConstraints */) : getContextualType2(node, 2 /* NoConstraints */);
	          if (contextualType) {
	            inferTypes(context.inferences, type, contextualType);
	          }
	        }
	        context.intraExpressionInferenceSites = void 0;
	      }
	    }
	    function createInferenceInfo(typeParameter) {
	      return {
	        typeParameter,
	        candidates: void 0,
	        contraCandidates: void 0,
	        inferredType: void 0,
	        priority: void 0,
	        topLevel: true,
	        isFixed: false,
	        impliedArity: void 0
	      };
	    }
	    function cloneInferenceInfo(inference) {
	      return {
	        typeParameter: inference.typeParameter,
	        candidates: inference.candidates && inference.candidates.slice(),
	        contraCandidates: inference.contraCandidates && inference.contraCandidates.slice(),
	        inferredType: inference.inferredType,
	        priority: inference.priority,
	        topLevel: inference.topLevel,
	        isFixed: inference.isFixed,
	        impliedArity: inference.impliedArity
	      };
	    }
	    function cloneInferredPartOfContext(context) {
	      const inferences = filter(context.inferences, hasInferenceCandidates);
	      return inferences.length ? createInferenceContextWorker(map(inferences, cloneInferenceInfo), context.signature, context.flags, context.compareTypes) : void 0;
	    }
	    function getMapperFromContext(context) {
	      return context && context.mapper;
	    }
	    function couldContainTypeVariables(type) {
	      const objectFlags = getObjectFlags(type);
	      if (objectFlags & 524288 /* CouldContainTypeVariablesComputed */) {
	        return !!(objectFlags & 1048576 /* CouldContainTypeVariables */);
	      }
	      const result = !!(type.flags & 465829888 /* Instantiable */ || type.flags & 524288 /* Object */ && !isNonGenericTopLevelType(type) && (objectFlags & 4 /* Reference */ && (type.node || some(getTypeArguments(type), couldContainTypeVariables)) || objectFlags & 16 /* Anonymous */ && type.symbol && type.symbol.flags & (16 /* Function */ | 8192 /* Method */ | 32 /* Class */ | 2048 /* TypeLiteral */ | 4096 /* ObjectLiteral */) && type.symbol.declarations || objectFlags & (32 /* Mapped */ | 1024 /* ReverseMapped */ | 4194304 /* ObjectRestType */ | 8388608 /* InstantiationExpressionType */)) || type.flags & 3145728 /* UnionOrIntersection */ && !(type.flags & 1024 /* EnumLiteral */) && !isNonGenericTopLevelType(type) && some(type.types, couldContainTypeVariables));
	      if (type.flags & 3899393 /* ObjectFlagsType */) {
	        type.objectFlags |= 524288 /* CouldContainTypeVariablesComputed */ | (result ? 1048576 /* CouldContainTypeVariables */ : 0);
	      }
	      return result;
	    }
	    function isNonGenericTopLevelType(type) {
	      if (type.aliasSymbol && !type.aliasTypeArguments) {
	        const declaration = getDeclarationOfKind(type.aliasSymbol, 265 /* TypeAliasDeclaration */);
	        return !!(declaration && findAncestor(declaration.parent, (n) => n.kind === 312 /* SourceFile */ ? true : n.kind === 267 /* ModuleDeclaration */ ? false : "quit"));
	      }
	      return false;
	    }
	    function isTypeParameterAtTopLevel(type, tp, depth = 0) {
	      return !!(type === tp || type.flags & 3145728 /* UnionOrIntersection */ && some(type.types, (t) => isTypeParameterAtTopLevel(t, tp, depth)) || depth < 3 && type.flags & 16777216 /* Conditional */ && (isTypeParameterAtTopLevel(getTrueTypeFromConditionalType(type), tp, depth + 1) || isTypeParameterAtTopLevel(getFalseTypeFromConditionalType(type), tp, depth + 1)));
	    }
	    function isTypeParameterAtTopLevelInReturnType(signature, typeParameter) {
	      const typePredicate = getTypePredicateOfSignature(signature);
	      return typePredicate ? !!typePredicate.type && isTypeParameterAtTopLevel(typePredicate.type, typeParameter) : isTypeParameterAtTopLevel(getReturnTypeOfSignature(signature), typeParameter);
	    }
	    function createEmptyObjectTypeFromStringLiteral(type) {
	      const members = createSymbolTable();
	      forEachType(type, (t) => {
	        if (!(t.flags & 128 /* StringLiteral */)) {
	          return;
	        }
	        const name = escapeLeadingUnderscores(t.value);
	        const literalProp = createSymbol(4 /* Property */, name);
	        literalProp.links.type = anyType;
	        if (t.symbol) {
	          literalProp.declarations = t.symbol.declarations;
	          literalProp.valueDeclaration = t.symbol.valueDeclaration;
	        }
	        members.set(name, literalProp);
	      });
	      const indexInfos = type.flags & 4 /* String */ ? [createIndexInfo(
	        stringType,
	        emptyObjectType,
	        /*isReadonly*/
	        false
	      )] : emptyArray;
	      return createAnonymousType(
	        /*symbol*/
	        void 0,
	        members,
	        emptyArray,
	        emptyArray,
	        indexInfos
	      );
	    }
	    function inferTypeForHomomorphicMappedType(source, target, constraint) {
	      const cacheKey = source.id + "," + target.id + "," + constraint.id;
	      if (reverseMappedCache.has(cacheKey)) {
	        return reverseMappedCache.get(cacheKey);
	      }
	      const recursionKey = source.id + "," + (target.target || target).id;
	      if (contains(homomorphicMappedTypeInferenceStack, recursionKey)) {
	        return void 0;
	      }
	      homomorphicMappedTypeInferenceStack.push(recursionKey);
	      const type = createReverseMappedType(source, target, constraint);
	      homomorphicMappedTypeInferenceStack.pop();
	      reverseMappedCache.set(cacheKey, type);
	      return type;
	    }
	    function isPartiallyInferableType(type) {
	      return !(getObjectFlags(type) & 262144 /* NonInferrableType */) || isObjectLiteralType2(type) && some(getPropertiesOfType(type), (prop) => isPartiallyInferableType(getTypeOfSymbol(prop))) || isTupleType(type) && some(getElementTypes(type), isPartiallyInferableType);
	    }
	    function createReverseMappedType(source, target, constraint) {
	      if (!(getIndexInfoOfType(source, stringType) || getPropertiesOfType(source).length !== 0 && isPartiallyInferableType(source))) {
	        return void 0;
	      }
	      if (isArrayType(source)) {
	        return createArrayType(inferReverseMappedType(getTypeArguments(source)[0], target, constraint), isReadonlyArrayType(source));
	      }
	      if (isTupleType(source)) {
	        const elementTypes = map(getElementTypes(source), (t) => inferReverseMappedType(t, target, constraint));
	        const elementFlags = getMappedTypeModifiers(target) & 4 /* IncludeOptional */ ? sameMap(source.target.elementFlags, (f) => f & 2 /* Optional */ ? 1 /* Required */ : f) : source.target.elementFlags;
	        return createTupleType(elementTypes, elementFlags, source.target.readonly, source.target.labeledElementDeclarations);
	      }
	      const reversed = createObjectType(
	        1024 /* ReverseMapped */ | 16 /* Anonymous */,
	        /*symbol*/
	        void 0
	      );
	      reversed.source = source;
	      reversed.mappedType = target;
	      reversed.constraintType = constraint;
	      return reversed;
	    }
	    function getTypeOfReverseMappedSymbol(symbol) {
	      const links = getSymbolLinks(symbol);
	      if (!links.type) {
	        links.type = inferReverseMappedType(symbol.links.propertyType, symbol.links.mappedType, symbol.links.constraintType);
	      }
	      return links.type;
	    }
	    function inferReverseMappedType(sourceType, target, constraint) {
	      const typeParameter = getIndexedAccessType(constraint.type, getTypeParameterFromMappedType(target));
	      const templateType = getTemplateTypeFromMappedType(target);
	      const inference = createInferenceInfo(typeParameter);
	      inferTypes([inference], sourceType, templateType);
	      return getTypeFromInference(inference) || unknownType;
	    }
	    function* getUnmatchedProperties(source, target, requireOptionalProperties, matchDiscriminantProperties) {
	      const properties = getPropertiesOfType(target);
	      for (const targetProp of properties) {
	        if (isStaticPrivateIdentifierProperty(targetProp)) {
	          continue;
	        }
	        if (requireOptionalProperties || !(targetProp.flags & 16777216 /* Optional */ || getCheckFlags(targetProp) & 48 /* Partial */)) {
	          const sourceProp = getPropertyOfType(source, targetProp.escapedName);
	          if (!sourceProp) {
	            yield targetProp;
	          } else if (matchDiscriminantProperties) {
	            const targetType = getTypeOfSymbol(targetProp);
	            if (targetType.flags & 109472 /* Unit */) {
	              const sourceType = getTypeOfSymbol(sourceProp);
	              if (!(sourceType.flags & 1 /* Any */ || getRegularTypeOfLiteralType(sourceType) === getRegularTypeOfLiteralType(targetType))) {
	                yield targetProp;
	              }
	            }
	          }
	        }
	      }
	    }
	    function getUnmatchedProperty(source, target, requireOptionalProperties, matchDiscriminantProperties) {
	      return firstOrUndefinedIterator(getUnmatchedProperties(source, target, requireOptionalProperties, matchDiscriminantProperties));
	    }
	    function tupleTypesDefinitelyUnrelated(source, target) {
	      return !(target.target.combinedFlags & 8 /* Variadic */) && target.target.minLength > source.target.minLength || !target.target.hasRestElement && (source.target.hasRestElement || target.target.fixedLength < source.target.fixedLength);
	    }
	    function typesDefinitelyUnrelated(source, target) {
	      return isTupleType(source) && isTupleType(target) ? tupleTypesDefinitelyUnrelated(source, target) : !!getUnmatchedProperty(
	        source,
	        target,
	        /*requireOptionalProperties*/
	        false,
	        /*matchDiscriminantProperties*/
	        true
	      ) && !!getUnmatchedProperty(
	        target,
	        source,
	        /*requireOptionalProperties*/
	        false,
	        /*matchDiscriminantProperties*/
	        false
	      );
	    }
	    function getTypeFromInference(inference) {
	      return inference.candidates ? getUnionType(inference.candidates, 2 /* Subtype */) : inference.contraCandidates ? getIntersectionType(inference.contraCandidates) : void 0;
	    }
	    function hasSkipDirectInferenceFlag(node) {
	      return !!getNodeLinks(node).skipDirectInference;
	    }
	    function isFromInferenceBlockedSource(type) {
	      return !!(type.symbol && some(type.symbol.declarations, hasSkipDirectInferenceFlag));
	    }
	    function templateLiteralTypesDefinitelyUnrelated(source, target) {
	      const sourceStart = source.texts[0];
	      const targetStart = target.texts[0];
	      const sourceEnd = source.texts[source.texts.length - 1];
	      const targetEnd = target.texts[target.texts.length - 1];
	      const startLen = Math.min(sourceStart.length, targetStart.length);
	      const endLen = Math.min(sourceEnd.length, targetEnd.length);
	      return sourceStart.slice(0, startLen) !== targetStart.slice(0, startLen) || sourceEnd.slice(sourceEnd.length - endLen) !== targetEnd.slice(targetEnd.length - endLen);
	    }
	    function isValidNumberString(s, roundTripOnly) {
	      if (s === "")
	        return false;
	      const n = +s;
	      return isFinite(n) && (!roundTripOnly || "" + n === s);
	    }
	    function parseBigIntLiteralType(text) {
	      return getBigIntLiteralType(parseValidBigInt(text));
	    }
	    function isMemberOfStringMapping(source, target) {
	      if (target.flags & 1 /* Any */) {
	        return true;
	      }
	      if (target.flags & (4 /* String */ | 134217728 /* TemplateLiteral */)) {
	        return isTypeAssignableTo(source, target);
	      }
	      if (target.flags & 268435456 /* StringMapping */) {
	        const mappingStack = [];
	        while (target.flags & 268435456 /* StringMapping */) {
	          mappingStack.unshift(target.symbol);
	          target = target.type;
	        }
	        const mappedSource = reduceLeft(mappingStack, (memo, value) => getStringMappingType(value, memo), source);
	        return mappedSource === source && isMemberOfStringMapping(source, target);
	      }
	      return false;
	    }
	    function isValidTypeForTemplateLiteralPlaceholder(source, target) {
	      if (target.flags & 2097152 /* Intersection */) {
	        return every(target.types, (t) => t === emptyTypeLiteralType || isValidTypeForTemplateLiteralPlaceholder(source, t));
	      }
	      if (target.flags & 4 /* String */ || isTypeAssignableTo(source, target)) {
	        return true;
	      }
	      if (source.flags & 128 /* StringLiteral */) {
	        const value = source.value;
	        return !!(target.flags & 8 /* Number */ && isValidNumberString(
	          value,
	          /*roundTripOnly*/
	          false
	        ) || target.flags & 64 /* BigInt */ && isValidBigIntString(
	          value,
	          /*roundTripOnly*/
	          false
	        ) || target.flags & (512 /* BooleanLiteral */ | 98304 /* Nullable */) && value === target.intrinsicName || target.flags & 268435456 /* StringMapping */ && isMemberOfStringMapping(getStringLiteralType(value), target) || target.flags & 134217728 /* TemplateLiteral */ && isTypeMatchedByTemplateLiteralType(source, target));
	      }
	      if (source.flags & 134217728 /* TemplateLiteral */) {
	        const texts = source.texts;
	        return texts.length === 2 && texts[0] === "" && texts[1] === "" && isTypeAssignableTo(source.types[0], target);
	      }
	      return false;
	    }
	    function inferTypesFromTemplateLiteralType(source, target) {
	      return source.flags & 128 /* StringLiteral */ ? inferFromLiteralPartsToTemplateLiteral([source.value], emptyArray, target) : source.flags & 134217728 /* TemplateLiteral */ ? arraysEqual(source.texts, target.texts) ? map(source.types, getStringLikeTypeForType) : inferFromLiteralPartsToTemplateLiteral(source.texts, source.types, target) : void 0;
	    }
	    function isTypeMatchedByTemplateLiteralType(source, target) {
	      const inferences = inferTypesFromTemplateLiteralType(source, target);
	      return !!inferences && every(inferences, (r, i) => isValidTypeForTemplateLiteralPlaceholder(r, target.types[i]));
	    }
	    function getStringLikeTypeForType(type) {
	      return type.flags & (1 /* Any */ | 402653316 /* StringLike */) ? type : getTemplateLiteralType(["", ""], [type]);
	    }
	    function inferFromLiteralPartsToTemplateLiteral(sourceTexts, sourceTypes, target) {
	      const lastSourceIndex = sourceTexts.length - 1;
	      const sourceStartText = sourceTexts[0];
	      const sourceEndText = sourceTexts[lastSourceIndex];
	      const targetTexts = target.texts;
	      const lastTargetIndex = targetTexts.length - 1;
	      const targetStartText = targetTexts[0];
	      const targetEndText = targetTexts[lastTargetIndex];
	      if (lastSourceIndex === 0 && sourceStartText.length < targetStartText.length + targetEndText.length || !sourceStartText.startsWith(targetStartText) || !sourceEndText.endsWith(targetEndText))
	        return void 0;
	      const remainingEndText = sourceEndText.slice(0, sourceEndText.length - targetEndText.length);
	      const matches = [];
	      let seg = 0;
	      let pos = targetStartText.length;
	      for (let i = 1; i < lastTargetIndex; i++) {
	        const delim = targetTexts[i];
	        if (delim.length > 0) {
	          let s = seg;
	          let p = pos;
	          while (true) {
	            p = getSourceText(s).indexOf(delim, p);
	            if (p >= 0)
	              break;
	            s++;
	            if (s === sourceTexts.length)
	              return void 0;
	            p = 0;
	          }
	          addMatch(s, p);
	          pos += delim.length;
	        } else if (pos < getSourceText(seg).length) {
	          addMatch(seg, pos + 1);
	        } else if (seg < lastSourceIndex) {
	          addMatch(seg + 1, 0);
	        } else {
	          return void 0;
	        }
	      }
	      addMatch(lastSourceIndex, getSourceText(lastSourceIndex).length);
	      return matches;
	      function getSourceText(index) {
	        return index < lastSourceIndex ? sourceTexts[index] : remainingEndText;
	      }
	      function addMatch(s, p) {
	        const matchType = s === seg ? getStringLiteralType(getSourceText(s).slice(pos, p)) : getTemplateLiteralType(
	          [sourceTexts[seg].slice(pos), ...sourceTexts.slice(seg + 1, s), getSourceText(s).slice(0, p)],
	          sourceTypes.slice(seg, s)
	        );
	        matches.push(matchType);
	        seg = s;
	        pos = p;
	      }
	    }
	    function inferTypes(inferences, originalSource, originalTarget, priority = 0 /* None */, contravariant = false) {
	      let bivariant = false;
	      let propagationType;
	      let inferencePriority = 2048 /* MaxValue */;
	      let visited;
	      let sourceStack;
	      let targetStack;
	      let expandingFlags = 0 /* None */;
	      inferFromTypes(originalSource, originalTarget);
	      function inferFromTypes(source, target) {
	        if (!couldContainTypeVariables(target) || isNoInferType(target)) {
	          return;
	        }
	        if (source === wildcardType || source === blockedStringType) {
	          const savePropagationType = propagationType;
	          propagationType = source;
	          inferFromTypes(target, target);
	          propagationType = savePropagationType;
	          return;
	        }
	        if (source.aliasSymbol && source.aliasSymbol === target.aliasSymbol) {
	          if (source.aliasTypeArguments) {
	            const params = getSymbolLinks(source.aliasSymbol).typeParameters;
	            const minParams = getMinTypeArgumentCount(params);
	            const sourceTypes = fillMissingTypeArguments(source.aliasTypeArguments, params, minParams, isInJSFile(source.aliasSymbol.valueDeclaration));
	            const targetTypes = fillMissingTypeArguments(target.aliasTypeArguments, params, minParams, isInJSFile(source.aliasSymbol.valueDeclaration));
	            inferFromTypeArguments(sourceTypes, targetTypes, getAliasVariances(source.aliasSymbol));
	          }
	          return;
	        }
	        if (source === target && source.flags & 3145728 /* UnionOrIntersection */) {
	          for (const t of source.types) {
	            inferFromTypes(t, t);
	          }
	          return;
	        }
	        if (target.flags & 1048576 /* Union */) {
	          const [tempSources, tempTargets] = inferFromMatchingTypes(source.flags & 1048576 /* Union */ ? source.types : [source], target.types, isTypeOrBaseIdenticalTo);
	          const [sources, targets] = inferFromMatchingTypes(tempSources, tempTargets, isTypeCloselyMatchedBy);
	          if (targets.length === 0) {
	            return;
	          }
	          target = getUnionType(targets);
	          if (sources.length === 0) {
	            inferWithPriority(source, target, 1 /* NakedTypeVariable */);
	            return;
	          }
	          source = getUnionType(sources);
	        } else if (target.flags & 2097152 /* Intersection */ && !every(target.types, isNonGenericObjectType)) {
	          if (!(source.flags & 1048576 /* Union */)) {
	            const [sources, targets] = inferFromMatchingTypes(source.flags & 2097152 /* Intersection */ ? source.types : [source], target.types, isTypeIdenticalTo);
	            if (sources.length === 0 || targets.length === 0) {
	              return;
	            }
	            source = getIntersectionType(sources);
	            target = getIntersectionType(targets);
	          }
	        }
	        if (target.flags & (8388608 /* IndexedAccess */ | 33554432 /* Substitution */)) {
	          if (isNoInferType(target)) {
	            return;
	          }
	          target = getActualTypeVariable(target);
	        }
	        if (target.flags & 8650752 /* TypeVariable */) {
	          if (isFromInferenceBlockedSource(source)) {
	            return;
	          }
	          const inference = getInferenceInfoForType(target);
	          if (inference) {
	            if (getObjectFlags(source) & 262144 /* NonInferrableType */ || source === nonInferrableAnyType) {
	              return;
	            }
	            if (!inference.isFixed) {
	              const candidate = propagationType || source;
	              if (candidate === blockedStringType) {
	                return;
	              }
	              if (inference.priority === void 0 || priority < inference.priority) {
	                inference.candidates = void 0;
	                inference.contraCandidates = void 0;
	                inference.topLevel = true;
	                inference.priority = priority;
	              }
	              if (priority === inference.priority) {
	                if (contravariant && !bivariant) {
	                  if (!contains(inference.contraCandidates, candidate)) {
	                    inference.contraCandidates = append(inference.contraCandidates, candidate);
	                    clearCachedInferences(inferences);
	                  }
	                } else if (!contains(inference.candidates, candidate)) {
	                  inference.candidates = append(inference.candidates, candidate);
	                  clearCachedInferences(inferences);
	                }
	              }
	              if (!(priority & 128 /* ReturnType */) && target.flags & 262144 /* TypeParameter */ && inference.topLevel && !isTypeParameterAtTopLevel(originalTarget, target)) {
	                inference.topLevel = false;
	                clearCachedInferences(inferences);
	              }
	            }
	            inferencePriority = Math.min(inferencePriority, priority);
	            return;
	          }
	          const simplified = getSimplifiedType(
	            target,
	            /*writing*/
	            false
	          );
	          if (simplified !== target) {
	            inferFromTypes(source, simplified);
	          } else if (target.flags & 8388608 /* IndexedAccess */) {
	            const indexType = getSimplifiedType(
	              target.indexType,
	              /*writing*/
	              false
	            );
	            if (indexType.flags & 465829888 /* Instantiable */) {
	              const simplified2 = distributeIndexOverObjectType(
	                getSimplifiedType(
	                  target.objectType,
	                  /*writing*/
	                  false
	                ),
	                indexType,
	                /*writing*/
	                false
	              );
	              if (simplified2 && simplified2 !== target) {
	                inferFromTypes(source, simplified2);
	              }
	            }
	          }
	        }
	        if (getObjectFlags(source) & 4 /* Reference */ && getObjectFlags(target) & 4 /* Reference */ && (source.target === target.target || isArrayType(source) && isArrayType(target)) && !(source.node && target.node)) {
	          inferFromTypeArguments(getTypeArguments(source), getTypeArguments(target), getVariances(source.target));
	        } else if (source.flags & 4194304 /* Index */ && target.flags & 4194304 /* Index */) {
	          inferFromContravariantTypes(source.type, target.type);
	        } else if ((isLiteralType(source) || source.flags & 4 /* String */) && target.flags & 4194304 /* Index */) {
	          const empty = createEmptyObjectTypeFromStringLiteral(source);
	          inferFromContravariantTypesWithPriority(empty, target.type, 256 /* LiteralKeyof */);
	        } else if (source.flags & 8388608 /* IndexedAccess */ && target.flags & 8388608 /* IndexedAccess */) {
	          inferFromTypes(source.objectType, target.objectType);
	          inferFromTypes(source.indexType, target.indexType);
	        } else if (source.flags & 268435456 /* StringMapping */ && target.flags & 268435456 /* StringMapping */) {
	          if (source.symbol === target.symbol) {
	            inferFromTypes(source.type, target.type);
	          }
	        } else if (source.flags & 33554432 /* Substitution */) {
	          inferFromTypes(source.baseType, target);
	          inferWithPriority(getSubstitutionIntersection(source), target, 4 /* SubstituteSource */);
	        } else if (target.flags & 16777216 /* Conditional */) {
	          invokeOnce(source, target, inferToConditionalType);
	        } else if (target.flags & 3145728 /* UnionOrIntersection */) {
	          inferToMultipleTypes(source, target.types, target.flags);
	        } else if (source.flags & 1048576 /* Union */) {
	          const sourceTypes = source.types;
	          for (const sourceType of sourceTypes) {
	            inferFromTypes(sourceType, target);
	          }
	        } else if (target.flags & 134217728 /* TemplateLiteral */) {
	          inferToTemplateLiteralType(source, target);
	        } else {
	          source = getReducedType(source);
	          if (isGenericMappedType(source) && isGenericMappedType(target)) {
	            invokeOnce(source, target, inferFromGenericMappedTypes);
	          }
	          if (!(priority & 512 /* NoConstraints */ && source.flags & (2097152 /* Intersection */ | 465829888 /* Instantiable */))) {
	            const apparentSource = getApparentType(source);
	            if (apparentSource !== source && !(apparentSource.flags & (524288 /* Object */ | 2097152 /* Intersection */))) {
	              return inferFromTypes(apparentSource, target);
	            }
	            source = apparentSource;
	          }
	          if (source.flags & (524288 /* Object */ | 2097152 /* Intersection */)) {
	            invokeOnce(source, target, inferFromObjectTypes);
	          }
	        }
	      }
	      function inferWithPriority(source, target, newPriority) {
	        const savePriority = priority;
	        priority |= newPriority;
	        inferFromTypes(source, target);
	        priority = savePriority;
	      }
	      function inferFromContravariantTypesWithPriority(source, target, newPriority) {
	        const savePriority = priority;
	        priority |= newPriority;
	        inferFromContravariantTypes(source, target);
	        priority = savePriority;
	      }
	      function inferToMultipleTypesWithPriority(source, targets, targetFlags, newPriority) {
	        const savePriority = priority;
	        priority |= newPriority;
	        inferToMultipleTypes(source, targets, targetFlags);
	        priority = savePriority;
	      }
	      function invokeOnce(source, target, action) {
	        const key = source.id + "," + target.id;
	        const status = visited && visited.get(key);
	        if (status !== void 0) {
	          inferencePriority = Math.min(inferencePriority, status);
	          return;
	        }
	        (visited || (visited = /* @__PURE__ */ new Map())).set(key, -1 /* Circularity */);
	        const saveInferencePriority = inferencePriority;
	        inferencePriority = 2048 /* MaxValue */;
	        const saveExpandingFlags = expandingFlags;
	        (sourceStack ?? (sourceStack = [])).push(source);
	        (targetStack ?? (targetStack = [])).push(target);
	        if (isDeeplyNestedType(source, sourceStack, sourceStack.length, 2))
	          expandingFlags |= 1 /* Source */;
	        if (isDeeplyNestedType(target, targetStack, targetStack.length, 2))
	          expandingFlags |= 2 /* Target */;
	        if (expandingFlags !== 3 /* Both */) {
	          action(source, target);
	        } else {
	          inferencePriority = -1 /* Circularity */;
	        }
	        targetStack.pop();
	        sourceStack.pop();
	        expandingFlags = saveExpandingFlags;
	        visited.set(key, inferencePriority);
	        inferencePriority = Math.min(inferencePriority, saveInferencePriority);
	      }
	      function inferFromMatchingTypes(sources, targets, matches) {
	        let matchedSources;
	        let matchedTargets;
	        for (const t of targets) {
	          for (const s of sources) {
	            if (matches(s, t)) {
	              inferFromTypes(s, t);
	              matchedSources = appendIfUnique(matchedSources, s);
	              matchedTargets = appendIfUnique(matchedTargets, t);
	            }
	          }
	        }
	        return [
	          matchedSources ? filter(sources, (t) => !contains(matchedSources, t)) : sources,
	          matchedTargets ? filter(targets, (t) => !contains(matchedTargets, t)) : targets
	        ];
	      }
	      function inferFromTypeArguments(sourceTypes, targetTypes, variances) {
	        const count = sourceTypes.length < targetTypes.length ? sourceTypes.length : targetTypes.length;
	        for (let i = 0; i < count; i++) {
	          if (i < variances.length && (variances[i] & 7 /* VarianceMask */) === 2 /* Contravariant */) {
	            inferFromContravariantTypes(sourceTypes[i], targetTypes[i]);
	          } else {
	            inferFromTypes(sourceTypes[i], targetTypes[i]);
	          }
	        }
	      }
	      function inferFromContravariantTypes(source, target) {
	        contravariant = !contravariant;
	        inferFromTypes(source, target);
	        contravariant = !contravariant;
	      }
	      function inferFromContravariantTypesIfStrictFunctionTypes(source, target) {
	        if (strictFunctionTypes || priority & 1024 /* AlwaysStrict */) {
	          inferFromContravariantTypes(source, target);
	        } else {
	          inferFromTypes(source, target);
	        }
	      }
	      function getInferenceInfoForType(type) {
	        if (type.flags & 8650752 /* TypeVariable */) {
	          for (const inference of inferences) {
	            if (type === inference.typeParameter) {
	              return inference;
	            }
	          }
	        }
	        return void 0;
	      }
	      function getSingleTypeVariableFromIntersectionTypes(types) {
	        let typeVariable;
	        for (const type of types) {
	          const t = type.flags & 2097152 /* Intersection */ && find(type.types, (t2) => !!getInferenceInfoForType(t2));
	          if (!t || typeVariable && t !== typeVariable) {
	            return void 0;
	          }
	          typeVariable = t;
	        }
	        return typeVariable;
	      }
	      function inferToMultipleTypes(source, targets, targetFlags) {
	        let typeVariableCount = 0;
	        if (targetFlags & 1048576 /* Union */) {
	          let nakedTypeVariable;
	          const sources = source.flags & 1048576 /* Union */ ? source.types : [source];
	          const matched = new Array(sources.length);
	          let inferenceCircularity = false;
	          for (const t of targets) {
	            if (getInferenceInfoForType(t)) {
	              nakedTypeVariable = t;
	              typeVariableCount++;
	            } else {
	              for (let i = 0; i < sources.length; i++) {
	                const saveInferencePriority = inferencePriority;
	                inferencePriority = 2048 /* MaxValue */;
	                inferFromTypes(sources[i], t);
	                if (inferencePriority === priority)
	                  matched[i] = true;
	                inferenceCircularity = inferenceCircularity || inferencePriority === -1 /* Circularity */;
	                inferencePriority = Math.min(inferencePriority, saveInferencePriority);
	              }
	            }
	          }
	          if (typeVariableCount === 0) {
	            const intersectionTypeVariable = getSingleTypeVariableFromIntersectionTypes(targets);
	            if (intersectionTypeVariable) {
	              inferWithPriority(source, intersectionTypeVariable, 1 /* NakedTypeVariable */);
	            }
	            return;
	          }
	          if (typeVariableCount === 1 && !inferenceCircularity) {
	            const unmatched = flatMap(sources, (s, i) => matched[i] ? void 0 : s);
	            if (unmatched.length) {
	              inferFromTypes(getUnionType(unmatched), nakedTypeVariable);
	              return;
	            }
	          }
	        } else {
	          for (const t of targets) {
	            if (getInferenceInfoForType(t)) {
	              typeVariableCount++;
	            } else {
	              inferFromTypes(source, t);
	            }
	          }
	        }
	        if (targetFlags & 2097152 /* Intersection */ ? typeVariableCount === 1 : typeVariableCount > 0) {
	          for (const t of targets) {
	            if (getInferenceInfoForType(t)) {
	              inferWithPriority(source, t, 1 /* NakedTypeVariable */);
	            }
	          }
	        }
	      }
	      function inferToMappedType(source, target, constraintType) {
	        if (constraintType.flags & 1048576 /* Union */ || constraintType.flags & 2097152 /* Intersection */) {
	          let result = false;
	          for (const type of constraintType.types) {
	            result = inferToMappedType(source, target, type) || result;
	          }
	          return result;
	        }
	        if (constraintType.flags & 4194304 /* Index */) {
	          const inference = getInferenceInfoForType(constraintType.type);
	          if (inference && !inference.isFixed && !isFromInferenceBlockedSource(source)) {
	            const inferredType = inferTypeForHomomorphicMappedType(source, target, constraintType);
	            if (inferredType) {
	              inferWithPriority(
	                inferredType,
	                inference.typeParameter,
	                getObjectFlags(source) & 262144 /* NonInferrableType */ ? 16 /* PartialHomomorphicMappedType */ : 8 /* HomomorphicMappedType */
	              );
	            }
	          }
	          return true;
	        }
	        if (constraintType.flags & 262144 /* TypeParameter */) {
	          inferWithPriority(getIndexType(
	            source,
	            /*indexFlags*/
	            !!source.pattern ? 2 /* NoIndexSignatures */ : 0 /* None */
	          ), constraintType, 32 /* MappedTypeConstraint */);
	          const extendedConstraint = getConstraintOfType(constraintType);
	          if (extendedConstraint && inferToMappedType(source, target, extendedConstraint)) {
	            return true;
	          }
	          const propTypes = map(getPropertiesOfType(source), getTypeOfSymbol);
	          const indexTypes = map(getIndexInfosOfType(source), (info) => info !== enumNumberIndexInfo ? info.type : neverType);
	          inferFromTypes(getUnionType(concatenate(propTypes, indexTypes)), getTemplateTypeFromMappedType(target));
	          return true;
	        }
	        return false;
	      }
	      function inferToConditionalType(source, target) {
	        if (source.flags & 16777216 /* Conditional */) {
	          inferFromTypes(source.checkType, target.checkType);
	          inferFromTypes(source.extendsType, target.extendsType);
	          inferFromTypes(getTrueTypeFromConditionalType(source), getTrueTypeFromConditionalType(target));
	          inferFromTypes(getFalseTypeFromConditionalType(source), getFalseTypeFromConditionalType(target));
	        } else {
	          const targetTypes = [getTrueTypeFromConditionalType(target), getFalseTypeFromConditionalType(target)];
	          inferToMultipleTypesWithPriority(source, targetTypes, target.flags, contravariant ? 64 /* ContravariantConditional */ : 0);
	        }
	      }
	      function inferToTemplateLiteralType(source, target) {
	        const matches = inferTypesFromTemplateLiteralType(source, target);
	        const types = target.types;
	        if (matches || every(target.texts, (s) => s.length === 0)) {
	          for (let i = 0; i < types.length; i++) {
	            const source2 = matches ? matches[i] : neverType;
	            const target2 = types[i];
	            if (source2.flags & 128 /* StringLiteral */ && target2.flags & 8650752 /* TypeVariable */) {
	              const inferenceContext = getInferenceInfoForType(target2);
	              const constraint = inferenceContext ? getBaseConstraintOfType(inferenceContext.typeParameter) : void 0;
	              if (constraint && !isTypeAny(constraint)) {
	                const constraintTypes = constraint.flags & 1048576 /* Union */ ? constraint.types : [constraint];
	                let allTypeFlags = reduceLeft(constraintTypes, (flags, t) => flags | t.flags, 0);
	                if (!(allTypeFlags & 4 /* String */)) {
	                  const str = source2.value;
	                  if (allTypeFlags & 296 /* NumberLike */ && !isValidNumberString(
	                    str,
	                    /*roundTripOnly*/
	                    true
	                  )) {
	                    allTypeFlags &= ~296 /* NumberLike */;
	                  }
	                  if (allTypeFlags & 2112 /* BigIntLike */ && !isValidBigIntString(
	                    str,
	                    /*roundTripOnly*/
	                    true
	                  )) {
	                    allTypeFlags &= ~2112 /* BigIntLike */;
	                  }
	                  const matchingType = reduceLeft(constraintTypes, (left, right) => !(right.flags & allTypeFlags) ? left : left.flags & 4 /* String */ ? left : right.flags & 4 /* String */ ? source2 : left.flags & 134217728 /* TemplateLiteral */ ? left : right.flags & 134217728 /* TemplateLiteral */ && isTypeMatchedByTemplateLiteralType(source2, right) ? source2 : left.flags & 268435456 /* StringMapping */ ? left : right.flags & 268435456 /* StringMapping */ && str === applyStringMapping(right.symbol, str) ? source2 : left.flags & 128 /* StringLiteral */ ? left : right.flags & 128 /* StringLiteral */ && right.value === str ? right : left.flags & 8 /* Number */ ? left : right.flags & 8 /* Number */ ? getNumberLiteralType(+str) : left.flags & 32 /* Enum */ ? left : right.flags & 32 /* Enum */ ? getNumberLiteralType(+str) : left.flags & 256 /* NumberLiteral */ ? left : right.flags & 256 /* NumberLiteral */ && right.value === +str ? right : left.flags & 64 /* BigInt */ ? left : right.flags & 64 /* BigInt */ ? parseBigIntLiteralType(str) : left.flags & 2048 /* BigIntLiteral */ ? left : right.flags & 2048 /* BigIntLiteral */ && pseudoBigIntToString(right.value) === str ? right : left.flags & 16 /* Boolean */ ? left : right.flags & 16 /* Boolean */ ? str === "true" ? trueType : str === "false" ? falseType : booleanType : left.flags & 512 /* BooleanLiteral */ ? left : right.flags & 512 /* BooleanLiteral */ && right.intrinsicName === str ? right : left.flags & 32768 /* Undefined */ ? left : right.flags & 32768 /* Undefined */ && right.intrinsicName === str ? right : left.flags & 65536 /* Null */ ? left : right.flags & 65536 /* Null */ && right.intrinsicName === str ? right : left, neverType);
	                  if (!(matchingType.flags & 131072 /* Never */)) {
	                    inferFromTypes(matchingType, target2);
	                    continue;
	                  }
	                }
	              }
	            }
	            inferFromTypes(source2, target2);
	          }
	        }
	      }
	      function inferFromGenericMappedTypes(source, target) {
	        inferFromTypes(getConstraintTypeFromMappedType(source), getConstraintTypeFromMappedType(target));
	        inferFromTypes(getTemplateTypeFromMappedType(source), getTemplateTypeFromMappedType(target));
	        const sourceNameType = getNameTypeFromMappedType(source);
	        const targetNameType = getNameTypeFromMappedType(target);
	        if (sourceNameType && targetNameType)
	          inferFromTypes(sourceNameType, targetNameType);
	      }
	      function inferFromObjectTypes(source, target) {
	        var _a, _b;
	        if (getObjectFlags(source) & 4 /* Reference */ && getObjectFlags(target) & 4 /* Reference */ && (source.target === target.target || isArrayType(source) && isArrayType(target))) {
	          inferFromTypeArguments(getTypeArguments(source), getTypeArguments(target), getVariances(source.target));
	          return;
	        }
	        if (isGenericMappedType(source) && isGenericMappedType(target)) {
	          inferFromGenericMappedTypes(source, target);
	        }
	        if (getObjectFlags(target) & 32 /* Mapped */ && !target.declaration.nameType) {
	          const constraintType = getConstraintTypeFromMappedType(target);
	          if (inferToMappedType(source, target, constraintType)) {
	            return;
	          }
	        }
	        if (!typesDefinitelyUnrelated(source, target)) {
	          if (isArrayOrTupleType(source)) {
	            if (isTupleType(target)) {
	              const sourceArity = getTypeReferenceArity(source);
	              const targetArity = getTypeReferenceArity(target);
	              const elementTypes = getTypeArguments(target);
	              const elementFlags = target.target.elementFlags;
	              if (isTupleType(source) && isTupleTypeStructureMatching(source, target)) {
	                for (let i = 0; i < targetArity; i++) {
	                  inferFromTypes(getTypeArguments(source)[i], elementTypes[i]);
	                }
	                return;
	              }
	              const startLength = isTupleType(source) ? Math.min(source.target.fixedLength, target.target.fixedLength) : 0;
	              const endLength = Math.min(isTupleType(source) ? getEndElementCount(source.target, 3 /* Fixed */) : 0, target.target.hasRestElement ? getEndElementCount(target.target, 3 /* Fixed */) : 0);
	              for (let i = 0; i < startLength; i++) {
	                inferFromTypes(getTypeArguments(source)[i], elementTypes[i]);
	              }
	              if (!isTupleType(source) || sourceArity - startLength - endLength === 1 && source.target.elementFlags[startLength] & 4 /* Rest */) {
	                const restType = getTypeArguments(source)[startLength];
	                for (let i = startLength; i < targetArity - endLength; i++) {
	                  inferFromTypes(elementFlags[i] & 8 /* Variadic */ ? createArrayType(restType) : restType, elementTypes[i]);
	                }
	              } else {
	                const middleLength = targetArity - startLength - endLength;
	                if (middleLength === 2) {
	                  if (elementFlags[startLength] & elementFlags[startLength + 1] & 8 /* Variadic */) {
	                    const targetInfo = getInferenceInfoForType(elementTypes[startLength]);
	                    if (targetInfo && targetInfo.impliedArity !== void 0) {
	                      inferFromTypes(sliceTupleType(source, startLength, endLength + sourceArity - targetInfo.impliedArity), elementTypes[startLength]);
	                      inferFromTypes(sliceTupleType(source, startLength + targetInfo.impliedArity, endLength), elementTypes[startLength + 1]);
	                    }
	                  } else if (elementFlags[startLength] & 8 /* Variadic */ && elementFlags[startLength + 1] & 4 /* Rest */) {
	                    const param = (_a = getInferenceInfoForType(elementTypes[startLength])) == null ? void 0 : _a.typeParameter;
	                    const constraint = param && getBaseConstraintOfType(param);
	                    if (constraint && isTupleType(constraint) && !constraint.target.hasRestElement) {
	                      const impliedArity = constraint.target.fixedLength;
	                      inferFromTypes(sliceTupleType(source, startLength, sourceArity - (startLength + impliedArity)), elementTypes[startLength]);
	                      inferFromTypes(getElementTypeOfSliceOfTupleType(source, startLength + impliedArity, endLength), elementTypes[startLength + 1]);
	                    }
	                  } else if (elementFlags[startLength] & 4 /* Rest */ && elementFlags[startLength + 1] & 8 /* Variadic */) {
	                    const param = (_b = getInferenceInfoForType(elementTypes[startLength + 1])) == null ? void 0 : _b.typeParameter;
	                    const constraint = param && getBaseConstraintOfType(param);
	                    if (constraint && isTupleType(constraint) && !constraint.target.hasRestElement) {
	                      const impliedArity = constraint.target.fixedLength;
	                      const endIndex = sourceArity - getEndElementCount(target.target, 3 /* Fixed */);
	                      const startIndex = endIndex - impliedArity;
	                      const trailingSlice = createTupleType(
	                        getTypeArguments(source).slice(startIndex, endIndex),
	                        source.target.elementFlags.slice(startIndex, endIndex),
	                        /*readonly*/
	                        false,
	                        source.target.labeledElementDeclarations && source.target.labeledElementDeclarations.slice(startIndex, endIndex)
	                      );
	                      inferFromTypes(getElementTypeOfSliceOfTupleType(source, startLength, endLength + impliedArity), elementTypes[startLength]);
	                      inferFromTypes(trailingSlice, elementTypes[startLength + 1]);
	                    }
	                  }
	                } else if (middleLength === 1 && elementFlags[startLength] & 8 /* Variadic */) {
	                  const endsInOptional = target.target.elementFlags[targetArity - 1] & 2 /* Optional */;
	                  const sourceSlice = sliceTupleType(source, startLength, endLength);
	                  inferWithPriority(sourceSlice, elementTypes[startLength], endsInOptional ? 2 /* SpeculativeTuple */ : 0);
	                } else if (middleLength === 1 && elementFlags[startLength] & 4 /* Rest */) {
	                  const restType = getElementTypeOfSliceOfTupleType(source, startLength, endLength);
	                  if (restType) {
	                    inferFromTypes(restType, elementTypes[startLength]);
	                  }
	                }
	              }
	              for (let i = 0; i < endLength; i++) {
	                inferFromTypes(getTypeArguments(source)[sourceArity - i - 1], elementTypes[targetArity - i - 1]);
	              }
	              return;
	            }
	            if (isArrayType(target)) {
	              inferFromIndexTypes(source, target);
	              return;
	            }
	          }
	          inferFromProperties(source, target);
	          inferFromSignatures(source, target, 0 /* Call */);
	          inferFromSignatures(source, target, 1 /* Construct */);
	          inferFromIndexTypes(source, target);
	        }
	      }
	      function inferFromProperties(source, target) {
	        const properties = getPropertiesOfObjectType(target);
	        for (const targetProp of properties) {
	          const sourceProp = getPropertyOfType(source, targetProp.escapedName);
	          if (sourceProp && !some(sourceProp.declarations, hasSkipDirectInferenceFlag)) {
	            inferFromTypes(getTypeOfSymbol(sourceProp), getTypeOfSymbol(targetProp));
	          }
	        }
	      }
	      function inferFromSignatures(source, target, kind) {
	        const sourceSignatures = getSignaturesOfType(source, kind);
	        const sourceLen = sourceSignatures.length;
	        if (sourceLen > 0) {
	          const targetSignatures = getSignaturesOfType(target, kind);
	          const targetLen = targetSignatures.length;
	          for (let i = 0; i < targetLen; i++) {
	            const sourceIndex = Math.max(sourceLen - targetLen + i, 0);
	            inferFromSignature(getBaseSignature(sourceSignatures[sourceIndex]), getErasedSignature(targetSignatures[i]));
	          }
	        }
	      }
	      function inferFromSignature(source, target) {
	        if (!(source.flags & 64 /* IsNonInferrable */)) {
	          const saveBivariant = bivariant;
	          const kind = target.declaration ? target.declaration.kind : 0 /* Unknown */;
	          bivariant = bivariant || kind === 174 /* MethodDeclaration */ || kind === 173 /* MethodSignature */ || kind === 176 /* Constructor */;
	          applyToParameterTypes(source, target, inferFromContravariantTypesIfStrictFunctionTypes);
	          bivariant = saveBivariant;
	        }
	        applyToReturnTypes(source, target, inferFromTypes);
	      }
	      function inferFromIndexTypes(source, target) {
	        const priority2 = getObjectFlags(source) & getObjectFlags(target) & 32 /* Mapped */ ? 8 /* HomomorphicMappedType */ : 0;
	        const indexInfos = getIndexInfosOfType(target);
	        if (isObjectTypeWithInferableIndex(source)) {
	          for (const targetInfo of indexInfos) {
	            const propTypes = [];
	            for (const prop of getPropertiesOfType(source)) {
	              if (isApplicableIndexType(getLiteralTypeFromProperty(prop, 8576 /* StringOrNumberLiteralOrUnique */), targetInfo.keyType)) {
	                const propType = getTypeOfSymbol(prop);
	                propTypes.push(prop.flags & 16777216 /* Optional */ ? removeMissingOrUndefinedType(propType) : propType);
	              }
	            }
	            for (const info of getIndexInfosOfType(source)) {
	              if (isApplicableIndexType(info.keyType, targetInfo.keyType)) {
	                propTypes.push(info.type);
	              }
	            }
	            if (propTypes.length) {
	              inferWithPriority(getUnionType(propTypes), targetInfo.type, priority2);
	            }
	          }
	        }
	        for (const targetInfo of indexInfos) {
	          const sourceInfo = getApplicableIndexInfo(source, targetInfo.keyType);
	          if (sourceInfo) {
	            inferWithPriority(sourceInfo.type, targetInfo.type, priority2);
	          }
	        }
	      }
	    }
	    function isTypeOrBaseIdenticalTo(s, t) {
	      return t === missingType ? s === t : isTypeIdenticalTo(s, t) || !!(t.flags & 4 /* String */ && s.flags & 128 /* StringLiteral */ || t.flags & 8 /* Number */ && s.flags & 256 /* NumberLiteral */);
	    }
	    function isTypeCloselyMatchedBy(s, t) {
	      return !!(s.flags & 524288 /* Object */ && t.flags & 524288 /* Object */ && s.symbol && s.symbol === t.symbol || s.aliasSymbol && s.aliasTypeArguments && s.aliasSymbol === t.aliasSymbol);
	    }
	    function hasPrimitiveConstraint(type) {
	      const constraint = getConstraintOfTypeParameter(type);
	      return !!constraint && maybeTypeOfKind(constraint.flags & 16777216 /* Conditional */ ? getDefaultConstraintOfConditionalType(constraint) : constraint, 402784252 /* Primitive */ | 4194304 /* Index */ | 134217728 /* TemplateLiteral */ | 268435456 /* StringMapping */);
	    }
	    function isObjectLiteralType2(type) {
	      return !!(getObjectFlags(type) & 128 /* ObjectLiteral */);
	    }
	    function isObjectOrArrayLiteralType(type) {
	      return !!(getObjectFlags(type) & (128 /* ObjectLiteral */ | 16384 /* ArrayLiteral */));
	    }
	    function unionObjectAndArrayLiteralCandidates(candidates) {
	      if (candidates.length > 1) {
	        const objectLiterals = filter(candidates, isObjectOrArrayLiteralType);
	        if (objectLiterals.length) {
	          const literalsType = getUnionType(objectLiterals, 2 /* Subtype */);
	          return concatenate(filter(candidates, (t) => !isObjectOrArrayLiteralType(t)), [literalsType]);
	        }
	      }
	      return candidates;
	    }
	    function getContravariantInference(inference) {
	      return inference.priority & 416 /* PriorityImpliesCombination */ ? getIntersectionType(inference.contraCandidates) : getCommonSubtype(inference.contraCandidates);
	    }
	    function getCovariantInference(inference, signature) {
	      const candidates = unionObjectAndArrayLiteralCandidates(inference.candidates);
	      const primitiveConstraint = hasPrimitiveConstraint(inference.typeParameter) || isConstTypeVariable(inference.typeParameter);
	      const widenLiteralTypes = !primitiveConstraint && inference.topLevel && (inference.isFixed || !isTypeParameterAtTopLevelInReturnType(signature, inference.typeParameter));
	      const baseCandidates = primitiveConstraint ? sameMap(candidates, getRegularTypeOfLiteralType) : widenLiteralTypes ? sameMap(candidates, getWidenedLiteralType) : candidates;
	      const unwidenedType = inference.priority & 416 /* PriorityImpliesCombination */ ? getUnionType(baseCandidates, 2 /* Subtype */) : getCommonSupertype(baseCandidates);
	      return getWidenedType(unwidenedType);
	    }
	    function getInferredType(context, index) {
	      const inference = context.inferences[index];
	      if (!inference.inferredType) {
	        let inferredType;
	        let fallbackType;
	        if (context.signature) {
	          const inferredCovariantType = inference.candidates ? getCovariantInference(inference, context.signature) : void 0;
	          const inferredContravariantType = inference.contraCandidates ? getContravariantInference(inference) : void 0;
	          if (inferredCovariantType || inferredContravariantType) {
	            const preferCovariantType = inferredCovariantType && (!inferredContravariantType || !(inferredCovariantType.flags & 131072 /* Never */) && some(inference.contraCandidates, (t) => isTypeSubtypeOf(inferredCovariantType, t)) && every(context.inferences, (other) => other !== inference && getConstraintOfTypeParameter(other.typeParameter) !== inference.typeParameter || every(other.candidates, (t) => isTypeSubtypeOf(t, inferredCovariantType))));
	            inferredType = preferCovariantType ? inferredCovariantType : inferredContravariantType;
	            fallbackType = preferCovariantType ? inferredContravariantType : inferredCovariantType;
	          } else if (context.flags & 1 /* NoDefault */) {
	            inferredType = silentNeverType;
	          } else {
	            const defaultType = getDefaultFromTypeParameter(inference.typeParameter);
	            if (defaultType) {
	              inferredType = instantiateType(defaultType, mergeTypeMappers(createBackreferenceMapper(context, index), context.nonFixingMapper));
	            }
	          }
	        } else {
	          inferredType = getTypeFromInference(inference);
	        }
	        inference.inferredType = inferredType || getDefaultTypeArgumentType(!!(context.flags & 2 /* AnyDefault */));
	        const constraint = getConstraintOfTypeParameter(inference.typeParameter);
	        if (constraint) {
	          const instantiatedConstraint = instantiateType(constraint, context.nonFixingMapper);
	          if (!inferredType || !context.compareTypes(inferredType, getTypeWithThisArgument(instantiatedConstraint, inferredType))) {
	            inference.inferredType = fallbackType && context.compareTypes(fallbackType, getTypeWithThisArgument(instantiatedConstraint, fallbackType)) ? fallbackType : instantiatedConstraint;
	          }
	        }
	      }
	      return inference.inferredType;
	    }
	    function getDefaultTypeArgumentType(isInJavaScriptFile) {
	      return isInJavaScriptFile ? anyType : unknownType;
	    }
	    function getInferredTypes(context) {
	      const result = [];
	      for (let i = 0; i < context.inferences.length; i++) {
	        result.push(getInferredType(context, i));
	      }
	      return result;
	    }
	    function getCannotFindNameDiagnosticForName(node) {
	      switch (node.escapedText) {
	        case "document":
	        case "console":
	          return Diagnostics.Cannot_find_name_0_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_include_dom;
	        case "$":
	          return compilerOptions.types ? Diagnostics.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_jQuery_Try_npm_i_save_dev_types_Slashjquery_and_then_add_jquery_to_the_types_field_in_your_tsconfig : Diagnostics.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_jQuery_Try_npm_i_save_dev_types_Slashjquery;
	        case "describe":
	        case "suite":
	        case "it":
	        case "test":
	          return compilerOptions.types ? Diagnostics.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_a_test_runner_Try_npm_i_save_dev_types_Slashjest_or_npm_i_save_dev_types_Slashmocha_and_then_add_jest_or_mocha_to_the_types_field_in_your_tsconfig : Diagnostics.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_a_test_runner_Try_npm_i_save_dev_types_Slashjest_or_npm_i_save_dev_types_Slashmocha;
	        case "process":
	        case "require":
	        case "Buffer":
	        case "module":
	          return compilerOptions.types ? Diagnostics.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_node_Try_npm_i_save_dev_types_Slashnode_and_then_add_node_to_the_types_field_in_your_tsconfig : Diagnostics.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_node_Try_npm_i_save_dev_types_Slashnode;
	        case "Bun":
	          return compilerOptions.types ? Diagnostics.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_Bun_Try_npm_i_save_dev_types_Slashbun_and_then_add_bun_to_the_types_field_in_your_tsconfig : Diagnostics.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_Bun_Try_npm_i_save_dev_types_Slashbun;
	        case "Map":
	        case "Set":
	        case "Promise":
	        case "Symbol":
	        case "WeakMap":
	        case "WeakSet":
	        case "Iterator":
	        case "AsyncIterator":
	        case "SharedArrayBuffer":
	        case "Atomics":
	        case "AsyncIterable":
	        case "AsyncIterableIterator":
	        case "AsyncGenerator":
	        case "AsyncGeneratorFunction":
	        case "BigInt":
	        case "Reflect":
	        case "BigInt64Array":
	        case "BigUint64Array":
	          return Diagnostics.Cannot_find_name_0_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_1_or_later;
	        case "await":
	          if (isCallExpression(node.parent)) {
	            return Diagnostics.Cannot_find_name_0_Did_you_mean_to_write_this_in_an_async_function;
	          }
	        default:
	          if (node.parent.kind === 304 /* ShorthandPropertyAssignment */) {
	            return Diagnostics.No_value_exists_in_scope_for_the_shorthand_property_0_Either_declare_one_or_provide_an_initializer;
	          } else {
	            return Diagnostics.Cannot_find_name_0;
	          }
	      }
	    }
	    function getResolvedSymbol(node) {
	      const links = getNodeLinks(node);
	      if (!links.resolvedSymbol) {
	        links.resolvedSymbol = !nodeIsMissing(node) && resolveName(
	          node,
	          node.escapedText,
	          111551 /* Value */ | 1048576 /* ExportValue */,
	          getCannotFindNameDiagnosticForName(node),
	          node,
	          !isWriteOnlyAccess(node),
	          /*excludeGlobals*/
	          false
	        ) || unknownSymbol;
	      }
	      return links.resolvedSymbol;
	    }
	    function isInAmbientOrTypeNode(node) {
	      return !!(node.flags & 33554432 /* Ambient */ || findAncestor(node, (n) => isInterfaceDeclaration(n) || isTypeAliasDeclaration(n) || isTypeLiteralNode(n)));
	    }
	    function getFlowCacheKey(node, declaredType, initialType, flowContainer) {
	      switch (node.kind) {
	        case 80 /* Identifier */:
	          if (!isThisInTypeQuery(node)) {
	            const symbol = getResolvedSymbol(node);
	            return symbol !== unknownSymbol ? `${flowContainer ? getNodeId(flowContainer) : "-1"}|${getTypeId(declaredType)}|${getTypeId(initialType)}|${getSymbolId(symbol)}` : void 0;
	          }
	        case 110 /* ThisKeyword */:
	          return `0|${flowContainer ? getNodeId(flowContainer) : "-1"}|${getTypeId(declaredType)}|${getTypeId(initialType)}`;
	        case 235 /* NonNullExpression */:
	        case 217 /* ParenthesizedExpression */:
	          return getFlowCacheKey(node.expression, declaredType, initialType, flowContainer);
	        case 166 /* QualifiedName */:
	          const left = getFlowCacheKey(node.left, declaredType, initialType, flowContainer);
	          return left && left + "." + node.right.escapedText;
	        case 211 /* PropertyAccessExpression */:
	        case 212 /* ElementAccessExpression */:
	          const propName = getAccessedPropertyName(node);
	          if (propName !== void 0) {
	            const key = getFlowCacheKey(node.expression, declaredType, initialType, flowContainer);
	            return key && key + "." + propName;
	          }
	          break;
	        case 206 /* ObjectBindingPattern */:
	        case 207 /* ArrayBindingPattern */:
	        case 262 /* FunctionDeclaration */:
	        case 218 /* FunctionExpression */:
	        case 219 /* ArrowFunction */:
	        case 174 /* MethodDeclaration */:
	          return `${getNodeId(node)}#${getTypeId(declaredType)}`;
	      }
	      return void 0;
	    }
	    function isMatchingReference(source, target) {
	      switch (target.kind) {
	        case 217 /* ParenthesizedExpression */:
	        case 235 /* NonNullExpression */:
	          return isMatchingReference(source, target.expression);
	        case 226 /* BinaryExpression */:
	          return isAssignmentExpression(target) && isMatchingReference(source, target.left) || isBinaryExpression(target) && target.operatorToken.kind === 28 /* CommaToken */ && isMatchingReference(source, target.right);
	      }
	      switch (source.kind) {
	        case 236 /* MetaProperty */:
	          return target.kind === 236 /* MetaProperty */ && source.keywordToken === target.keywordToken && source.name.escapedText === target.name.escapedText;
	        case 80 /* Identifier */:
	        case 81 /* PrivateIdentifier */:
	          return isThisInTypeQuery(source) ? target.kind === 110 /* ThisKeyword */ : target.kind === 80 /* Identifier */ && getResolvedSymbol(source) === getResolvedSymbol(target) || (isVariableDeclaration(target) || isBindingElement(target)) && getExportSymbolOfValueSymbolIfExported(getResolvedSymbol(source)) === getSymbolOfDeclaration(target);
	        case 110 /* ThisKeyword */:
	          return target.kind === 110 /* ThisKeyword */;
	        case 108 /* SuperKeyword */:
	          return target.kind === 108 /* SuperKeyword */;
	        case 235 /* NonNullExpression */:
	        case 217 /* ParenthesizedExpression */:
	          return isMatchingReference(source.expression, target);
	        case 211 /* PropertyAccessExpression */:
	        case 212 /* ElementAccessExpression */:
	          const sourcePropertyName = getAccessedPropertyName(source);
	          const targetPropertyName = isAccessExpression(target) ? getAccessedPropertyName(target) : void 0;
	          return sourcePropertyName !== void 0 && targetPropertyName !== void 0 && targetPropertyName === sourcePropertyName && isMatchingReference(source.expression, target.expression);
	        case 166 /* QualifiedName */:
	          return isAccessExpression(target) && source.right.escapedText === getAccessedPropertyName(target) && isMatchingReference(source.left, target.expression);
	        case 226 /* BinaryExpression */:
	          return isBinaryExpression(source) && source.operatorToken.kind === 28 /* CommaToken */ && isMatchingReference(source.right, target);
	      }
	      return false;
	    }
	    function getAccessedPropertyName(access) {
	      if (isPropertyAccessExpression(access)) {
	        return access.name.escapedText;
	      }
	      if (isElementAccessExpression(access)) {
	        return tryGetElementAccessExpressionName(access);
	      }
	      if (isBindingElement(access)) {
	        const name = getDestructuringPropertyName(access);
	        return name ? escapeLeadingUnderscores(name) : void 0;
	      }
	      if (isParameter(access)) {
	        return "" + access.parent.parameters.indexOf(access);
	      }
	      return void 0;
	    }
	    function tryGetNameFromType(type) {
	      return type.flags & 8192 /* UniqueESSymbol */ ? type.escapedName : type.flags & 384 /* StringOrNumberLiteral */ ? escapeLeadingUnderscores("" + type.value) : void 0;
	    }
	    function tryGetElementAccessExpressionName(node) {
	      return isStringOrNumericLiteralLike(node.argumentExpression) ? escapeLeadingUnderscores(node.argumentExpression.text) : isEntityNameExpression(node.argumentExpression) ? tryGetNameFromEntityNameExpression(node.argumentExpression) : void 0;
	    }
	    function tryGetNameFromEntityNameExpression(node) {
	      const symbol = resolveEntityName(
	        node,
	        111551 /* Value */,
	        /*ignoreErrors*/
	        true
	      );
	      if (!symbol || !(isConstantVariable(symbol) || symbol.flags & 8 /* EnumMember */))
	        return void 0;
	      const declaration = symbol.valueDeclaration;
	      if (declaration === void 0)
	        return void 0;
	      const type = tryGetTypeFromEffectiveTypeNode(declaration);
	      if (type) {
	        const name = tryGetNameFromType(type);
	        if (name !== void 0) {
	          return name;
	        }
	      }
	      if (hasOnlyExpressionInitializer(declaration) && isBlockScopedNameDeclaredBeforeUse(declaration, node)) {
	        const initializer = getEffectiveInitializer(declaration);
	        if (initializer) {
	          const initializerType = isBindingPattern(declaration.parent) ? getTypeForBindingElement(declaration) : getTypeOfExpression(initializer);
	          return initializerType && tryGetNameFromType(initializerType);
	        }
	        if (isEnumMember(declaration)) {
	          return getTextOfPropertyName(declaration.name);
	        }
	      }
	      return void 0;
	    }
	    function containsMatchingReference(source, target) {
	      while (isAccessExpression(source)) {
	        source = source.expression;
	        if (isMatchingReference(source, target)) {
	          return true;
	        }
	      }
	      return false;
	    }
	    function optionalChainContainsReference(source, target) {
	      while (isOptionalChain(source)) {
	        source = source.expression;
	        if (isMatchingReference(source, target)) {
	          return true;
	        }
	      }
	      return false;
	    }
	    function isDiscriminantProperty(type, name) {
	      if (type && type.flags & 1048576 /* Union */) {
	        const prop = getUnionOrIntersectionProperty(type, name);
	        if (prop && getCheckFlags(prop) & 2 /* SyntheticProperty */) {
	          if (prop.links.isDiscriminantProperty === void 0) {
	            prop.links.isDiscriminantProperty = (prop.links.checkFlags & 192 /* Discriminant */) === 192 /* Discriminant */ && !isGenericType(getTypeOfSymbol(prop));
	          }
	          return !!prop.links.isDiscriminantProperty;
	        }
	      }
	      return false;
	    }
	    function findDiscriminantProperties(sourceProperties, target) {
	      let result;
	      for (const sourceProperty of sourceProperties) {
	        if (isDiscriminantProperty(target, sourceProperty.escapedName)) {
	          if (result) {
	            result.push(sourceProperty);
	            continue;
	          }
	          result = [sourceProperty];
	        }
	      }
	      return result;
	    }
	    function mapTypesByKeyProperty(types, name) {
	      const map2 = /* @__PURE__ */ new Map();
	      let count = 0;
	      for (const type of types) {
	        if (type.flags & (524288 /* Object */ | 2097152 /* Intersection */ | 58982400 /* InstantiableNonPrimitive */)) {
	          const discriminant = getTypeOfPropertyOfType(type, name);
	          if (discriminant) {
	            if (!isLiteralType(discriminant)) {
	              return void 0;
	            }
	            let duplicate = false;
	            forEachType(discriminant, (t) => {
	              const id = getTypeId(getRegularTypeOfLiteralType(t));
	              const existing = map2.get(id);
	              if (!existing) {
	                map2.set(id, type);
	              } else if (existing !== unknownType) {
	                map2.set(id, unknownType);
	                duplicate = true;
	              }
	            });
	            if (!duplicate)
	              count++;
	          }
	        }
	      }
	      return count >= 10 && count * 2 >= types.length ? map2 : void 0;
	    }
	    function getKeyPropertyName(unionType) {
	      const types = unionType.types;
	      if (types.length < 10 || getObjectFlags(unionType) & 32768 /* PrimitiveUnion */ || countWhere(types, (t) => !!(t.flags & (524288 /* Object */ | 58982400 /* InstantiableNonPrimitive */))) < 10) {
	        return void 0;
	      }
	      if (unionType.keyPropertyName === void 0) {
	        const keyPropertyName = forEach(types, (t) => t.flags & (524288 /* Object */ | 58982400 /* InstantiableNonPrimitive */) ? forEach(getPropertiesOfType(t), (p) => isUnitType(getTypeOfSymbol(p)) ? p.escapedName : void 0) : void 0);
	        const mapByKeyProperty = keyPropertyName && mapTypesByKeyProperty(types, keyPropertyName);
	        unionType.keyPropertyName = mapByKeyProperty ? keyPropertyName : "";
	        unionType.constituentMap = mapByKeyProperty;
	      }
	      return unionType.keyPropertyName.length ? unionType.keyPropertyName : void 0;
	    }
	    function getConstituentTypeForKeyType(unionType, keyType) {
	      var _a;
	      const result = (_a = unionType.constituentMap) == null ? void 0 : _a.get(getTypeId(getRegularTypeOfLiteralType(keyType)));
	      return result !== unknownType ? result : void 0;
	    }
	    function getMatchingUnionConstituentForType(unionType, type) {
	      const keyPropertyName = getKeyPropertyName(unionType);
	      const propType = keyPropertyName && getTypeOfPropertyOfType(type, keyPropertyName);
	      return propType && getConstituentTypeForKeyType(unionType, propType);
	    }
	    function getMatchingUnionConstituentForObjectLiteral(unionType, node) {
	      const keyPropertyName = getKeyPropertyName(unionType);
	      const propNode = keyPropertyName && find(node.properties, (p) => p.symbol && p.kind === 303 /* PropertyAssignment */ && p.symbol.escapedName === keyPropertyName && isPossiblyDiscriminantValue(p.initializer));
	      const propType = propNode && getContextFreeTypeOfExpression(propNode.initializer);
	      return propType && getConstituentTypeForKeyType(unionType, propType);
	    }
	    function isOrContainsMatchingReference(source, target) {
	      return isMatchingReference(source, target) || containsMatchingReference(source, target);
	    }
	    function hasMatchingArgument(expression, reference) {
	      if (expression.arguments) {
	        for (const argument of expression.arguments) {
	          if (isOrContainsMatchingReference(reference, argument) || optionalChainContainsReference(argument, reference)) {
	            return true;
	          }
	        }
	      }
	      if (expression.expression.kind === 211 /* PropertyAccessExpression */ && isOrContainsMatchingReference(reference, expression.expression.expression)) {
	        return true;
	      }
	      return false;
	    }
	    function getFlowNodeId(flow) {
	      if (!flow.id || flow.id < 0) {
	        flow.id = nextFlowId;
	        nextFlowId++;
	      }
	      return flow.id;
	    }
	    function typeMaybeAssignableTo(source, target) {
	      if (!(source.flags & 1048576 /* Union */)) {
	        return isTypeAssignableTo(source, target);
	      }
	      for (const t of source.types) {
	        if (isTypeAssignableTo(t, target)) {
	          return true;
	        }
	      }
	      return false;
	    }
	    function getAssignmentReducedType(declaredType, assignedType) {
	      if (declaredType === assignedType) {
	        return declaredType;
	      }
	      if (assignedType.flags & 131072 /* Never */) {
	        return assignedType;
	      }
	      const key = `A${getTypeId(declaredType)},${getTypeId(assignedType)}`;
	      return getCachedType(key) ?? setCachedType(key, getAssignmentReducedTypeWorker(declaredType, assignedType));
	    }
	    function getAssignmentReducedTypeWorker(declaredType, assignedType) {
	      const filteredType = filterType(declaredType, (t) => typeMaybeAssignableTo(assignedType, t));
	      const reducedType = assignedType.flags & 512 /* BooleanLiteral */ && isFreshLiteralType(assignedType) ? mapType(filteredType, getFreshTypeOfLiteralType) : filteredType;
	      return isTypeAssignableTo(assignedType, reducedType) ? reducedType : declaredType;
	    }
	    function isFunctionObjectType(type) {
	      const resolved = resolveStructuredTypeMembers(type);
	      return !!(resolved.callSignatures.length || resolved.constructSignatures.length || resolved.members.get("bind") && isTypeSubtypeOf(type, globalFunctionType));
	    }
	    function getTypeFacts(type, mask2) {
	      return getTypeFactsWorker(type, mask2) & mask2;
	    }
	    function hasTypeFacts(type, mask2) {
	      return getTypeFacts(type, mask2) !== 0;
	    }
	    function getTypeFactsWorker(type, callerOnlyNeeds) {
	      if (type.flags & (2097152 /* Intersection */ | 465829888 /* Instantiable */)) {
	        type = getBaseConstraintOfType(type) || unknownType;
	      }
	      const flags = type.flags;
	      if (flags & (4 /* String */ | 268435456 /* StringMapping */)) {
	        return strictNullChecks ? 16317953 /* StringStrictFacts */ : 16776705 /* StringFacts */;
	      }
	      if (flags & (128 /* StringLiteral */ | 134217728 /* TemplateLiteral */)) {
	        const isEmpty = flags & 128 /* StringLiteral */ && type.value === "";
	        return strictNullChecks ? isEmpty ? 12123649 /* EmptyStringStrictFacts */ : 7929345 /* NonEmptyStringStrictFacts */ : isEmpty ? 12582401 /* EmptyStringFacts */ : 16776705 /* NonEmptyStringFacts */;
	      }
	      if (flags & (8 /* Number */ | 32 /* Enum */)) {
	        return strictNullChecks ? 16317698 /* NumberStrictFacts */ : 16776450 /* NumberFacts */;
	      }
	      if (flags & 256 /* NumberLiteral */) {
	        const isZero = type.value === 0;
	        return strictNullChecks ? isZero ? 12123394 /* ZeroNumberStrictFacts */ : 7929090 /* NonZeroNumberStrictFacts */ : isZero ? 12582146 /* ZeroNumberFacts */ : 16776450 /* NonZeroNumberFacts */;
	      }
	      if (flags & 64 /* BigInt */) {
	        return strictNullChecks ? 16317188 /* BigIntStrictFacts */ : 16775940 /* BigIntFacts */;
	      }
	      if (flags & 2048 /* BigIntLiteral */) {
	        const isZero = isZeroBigInt(type);
	        return strictNullChecks ? isZero ? 12122884 /* ZeroBigIntStrictFacts */ : 7928580 /* NonZeroBigIntStrictFacts */ : isZero ? 12581636 /* ZeroBigIntFacts */ : 16775940 /* NonZeroBigIntFacts */;
	      }
	      if (flags & 16 /* Boolean */) {
	        return strictNullChecks ? 16316168 /* BooleanStrictFacts */ : 16774920 /* BooleanFacts */;
	      }
	      if (flags & 528 /* BooleanLike */) {
	        return strictNullChecks ? type === falseType || type === regularFalseType ? 12121864 /* FalseStrictFacts */ : 7927560 /* TrueStrictFacts */ : type === falseType || type === regularFalseType ? 12580616 /* FalseFacts */ : 16774920 /* TrueFacts */;
	      }
	      if (flags & 524288 /* Object */) {
	        const possibleFacts = strictNullChecks ? 83427327 /* EmptyObjectStrictFacts */ | 7880640 /* FunctionStrictFacts */ | 7888800 /* ObjectStrictFacts */ : 83886079 /* EmptyObjectFacts */ | 16728e3 /* FunctionFacts */ | 16736160 /* ObjectFacts */;
	        if ((callerOnlyNeeds & possibleFacts) === 0) {
	          return 0;
	        }
	        return getObjectFlags(type) & 16 /* Anonymous */ && isEmptyObjectType(type) ? strictNullChecks ? 83427327 /* EmptyObjectStrictFacts */ : 83886079 /* EmptyObjectFacts */ : isFunctionObjectType(type) ? strictNullChecks ? 7880640 /* FunctionStrictFacts */ : 16728e3 /* FunctionFacts */ : strictNullChecks ? 7888800 /* ObjectStrictFacts */ : 16736160 /* ObjectFacts */;
	      }
	      if (flags & 16384 /* Void */) {
	        return 9830144 /* VoidFacts */;
	      }
	      if (flags & 32768 /* Undefined */) {
	        return 26607360 /* UndefinedFacts */;
	      }
	      if (flags & 65536 /* Null */) {
	        return 42917664 /* NullFacts */;
	      }
	      if (flags & 12288 /* ESSymbolLike */) {
	        return strictNullChecks ? 7925520 /* SymbolStrictFacts */ : 16772880 /* SymbolFacts */;
	      }
	      if (flags & 67108864 /* NonPrimitive */) {
	        return strictNullChecks ? 7888800 /* ObjectStrictFacts */ : 16736160 /* ObjectFacts */;
	      }
	      if (flags & 131072 /* Never */) {
	        return 0 /* None */;
	      }
	      if (flags & 1048576 /* Union */) {
	        return reduceLeft(type.types, (facts, t) => facts | getTypeFactsWorker(t, callerOnlyNeeds), 0 /* None */);
	      }
	      if (flags & 2097152 /* Intersection */) {
	        return getIntersectionTypeFacts(type, callerOnlyNeeds);
	      }
	      return 83886079 /* UnknownFacts */;
	    }
	    function getIntersectionTypeFacts(type, callerOnlyNeeds) {
	      const ignoreObjects = maybeTypeOfKind(type, 402784252 /* Primitive */);
	      let oredFacts = 0 /* None */;
	      let andedFacts = 134217727 /* All */;
	      for (const t of type.types) {
	        if (!(ignoreObjects && t.flags & 524288 /* Object */)) {
	          const f = getTypeFactsWorker(t, callerOnlyNeeds);
	          oredFacts |= f;
	          andedFacts &= f;
	        }
	      }
	      return oredFacts & 8256 /* OrFactsMask */ | andedFacts & 134209471 /* AndFactsMask */;
	    }
	    function getTypeWithFacts(type, include) {
	      return filterType(type, (t) => hasTypeFacts(t, include));
	    }
	    function getAdjustedTypeWithFacts(type, facts) {
	      const reduced = recombineUnknownType(getTypeWithFacts(strictNullChecks && type.flags & 2 /* Unknown */ ? unknownUnionType : type, facts));
	      if (strictNullChecks) {
	        switch (facts) {
	          case 524288 /* NEUndefined */:
	            return mapType(reduced, (t) => hasTypeFacts(t, 65536 /* EQUndefined */) ? getIntersectionType([t, hasTypeFacts(t, 131072 /* EQNull */) && !maybeTypeOfKind(reduced, 65536 /* Null */) ? getUnionType([emptyObjectType, nullType]) : emptyObjectType]) : t);
	          case 1048576 /* NENull */:
	            return mapType(reduced, (t) => hasTypeFacts(t, 131072 /* EQNull */) ? getIntersectionType([t, hasTypeFacts(t, 65536 /* EQUndefined */) && !maybeTypeOfKind(reduced, 32768 /* Undefined */) ? getUnionType([emptyObjectType, undefinedType]) : emptyObjectType]) : t);
	          case 2097152 /* NEUndefinedOrNull */:
	          case 4194304 /* Truthy */:
	            return mapType(reduced, (t) => hasTypeFacts(t, 262144 /* EQUndefinedOrNull */) ? getGlobalNonNullableTypeInstantiation(t) : t);
	        }
	      }
	      return reduced;
	    }
	    function recombineUnknownType(type) {
	      return type === unknownUnionType ? unknownType : type;
	    }
	    function getTypeWithDefault(type, defaultExpression) {
	      return defaultExpression ? getUnionType([getNonUndefinedType(type), getTypeOfExpression(defaultExpression)]) : type;
	    }
	    function getTypeOfDestructuredProperty(type, name) {
	      var _a;
	      const nameType = getLiteralTypeFromPropertyName(name);
	      if (!isTypeUsableAsPropertyName(nameType))
	        return errorType;
	      const text = getPropertyNameFromType(nameType);
	      return getTypeOfPropertyOfType(type, text) || includeUndefinedInIndexSignature((_a = getApplicableIndexInfoForName(type, text)) == null ? void 0 : _a.type) || errorType;
	    }
	    function getTypeOfDestructuredArrayElement(type, index) {
	      return everyType(type, isTupleLikeType) && getTupleElementType(type, index) || includeUndefinedInIndexSignature(checkIteratedTypeOrElementType(
	        65 /* Destructuring */,
	        type,
	        undefinedType,
	        /*errorNode*/
	        void 0
	      )) || errorType;
	    }
	    function includeUndefinedInIndexSignature(type) {
	      if (!type)
	        return type;
	      return compilerOptions.noUncheckedIndexedAccess ? getUnionType([type, missingType]) : type;
	    }
	    function getTypeOfDestructuredSpreadExpression(type) {
	      return createArrayType(checkIteratedTypeOrElementType(
	        65 /* Destructuring */,
	        type,
	        undefinedType,
	        /*errorNode*/
	        void 0
	      ) || errorType);
	    }
	    function getAssignedTypeOfBinaryExpression(node) {
	      const isDestructuringDefaultAssignment = node.parent.kind === 209 /* ArrayLiteralExpression */ && isDestructuringAssignmentTarget(node.parent) || node.parent.kind === 303 /* PropertyAssignment */ && isDestructuringAssignmentTarget(node.parent.parent);
	      return isDestructuringDefaultAssignment ? getTypeWithDefault(getAssignedType(node), node.right) : getTypeOfExpression(node.right);
	    }
	    function isDestructuringAssignmentTarget(parent2) {
	      return parent2.parent.kind === 226 /* BinaryExpression */ && parent2.parent.left === parent2 || parent2.parent.kind === 250 /* ForOfStatement */ && parent2.parent.initializer === parent2;
	    }
	    function getAssignedTypeOfArrayLiteralElement(node, element) {
	      return getTypeOfDestructuredArrayElement(getAssignedType(node), node.elements.indexOf(element));
	    }
	    function getAssignedTypeOfSpreadExpression(node) {
	      return getTypeOfDestructuredSpreadExpression(getAssignedType(node.parent));
	    }
	    function getAssignedTypeOfPropertyAssignment(node) {
	      return getTypeOfDestructuredProperty(getAssignedType(node.parent), node.name);
	    }
	    function getAssignedTypeOfShorthandPropertyAssignment(node) {
	      return getTypeWithDefault(getAssignedTypeOfPropertyAssignment(node), node.objectAssignmentInitializer);
	    }
	    function getAssignedType(node) {
	      const { parent: parent2 } = node;
	      switch (parent2.kind) {
	        case 249 /* ForInStatement */:
	          return stringType;
	        case 250 /* ForOfStatement */:
	          return checkRightHandSideOfForOf(parent2) || errorType;
	        case 226 /* BinaryExpression */:
	          return getAssignedTypeOfBinaryExpression(parent2);
	        case 220 /* DeleteExpression */:
	          return undefinedType;
	        case 209 /* ArrayLiteralExpression */:
	          return getAssignedTypeOfArrayLiteralElement(parent2, node);
	        case 230 /* SpreadElement */:
	          return getAssignedTypeOfSpreadExpression(parent2);
	        case 303 /* PropertyAssignment */:
	          return getAssignedTypeOfPropertyAssignment(parent2);
	        case 304 /* ShorthandPropertyAssignment */:
	          return getAssignedTypeOfShorthandPropertyAssignment(parent2);
	      }
	      return errorType;
	    }
	    function getInitialTypeOfBindingElement(node) {
	      const pattern = node.parent;
	      const parentType = getInitialType(pattern.parent);
	      const type = pattern.kind === 206 /* ObjectBindingPattern */ ? getTypeOfDestructuredProperty(parentType, node.propertyName || node.name) : !node.dotDotDotToken ? getTypeOfDestructuredArrayElement(parentType, pattern.elements.indexOf(node)) : getTypeOfDestructuredSpreadExpression(parentType);
	      return getTypeWithDefault(type, node.initializer);
	    }
	    function getTypeOfInitializer(node) {
	      const links = getNodeLinks(node);
	      return links.resolvedType || getTypeOfExpression(node);
	    }
	    function getInitialTypeOfVariableDeclaration(node) {
	      if (node.initializer) {
	        return getTypeOfInitializer(node.initializer);
	      }
	      if (node.parent.parent.kind === 249 /* ForInStatement */) {
	        return stringType;
	      }
	      if (node.parent.parent.kind === 250 /* ForOfStatement */) {
	        return checkRightHandSideOfForOf(node.parent.parent) || errorType;
	      }
	      return errorType;
	    }
	    function getInitialType(node) {
	      return node.kind === 260 /* VariableDeclaration */ ? getInitialTypeOfVariableDeclaration(node) : getInitialTypeOfBindingElement(node);
	    }
	    function isEmptyArrayAssignment(node) {
	      return node.kind === 260 /* VariableDeclaration */ && node.initializer && isEmptyArrayLiteral2(node.initializer) || node.kind !== 208 /* BindingElement */ && node.parent.kind === 226 /* BinaryExpression */ && isEmptyArrayLiteral2(node.parent.right);
	    }
	    function getReferenceCandidate(node) {
	      switch (node.kind) {
	        case 217 /* ParenthesizedExpression */:
	          return getReferenceCandidate(node.expression);
	        case 226 /* BinaryExpression */:
	          switch (node.operatorToken.kind) {
	            case 64 /* EqualsToken */:
	            case 76 /* BarBarEqualsToken */:
	            case 77 /* AmpersandAmpersandEqualsToken */:
	            case 78 /* QuestionQuestionEqualsToken */:
	              return getReferenceCandidate(node.left);
	            case 28 /* CommaToken */:
	              return getReferenceCandidate(node.right);
	          }
	      }
	      return node;
	    }
	    function getReferenceRoot(node) {
	      const { parent: parent2 } = node;
	      return parent2.kind === 217 /* ParenthesizedExpression */ || parent2.kind === 226 /* BinaryExpression */ && parent2.operatorToken.kind === 64 /* EqualsToken */ && parent2.left === node || parent2.kind === 226 /* BinaryExpression */ && parent2.operatorToken.kind === 28 /* CommaToken */ && parent2.right === node ? getReferenceRoot(parent2) : node;
	    }
	    function getTypeOfSwitchClause(clause) {
	      if (clause.kind === 296 /* CaseClause */) {
	        return getRegularTypeOfLiteralType(getTypeOfExpression(clause.expression));
	      }
	      return neverType;
	    }
	    function getSwitchClauseTypes(switchStatement) {
	      const links = getNodeLinks(switchStatement);
	      if (!links.switchTypes) {
	        links.switchTypes = [];
	        for (const clause of switchStatement.caseBlock.clauses) {
	          links.switchTypes.push(getTypeOfSwitchClause(clause));
	        }
	      }
	      return links.switchTypes;
	    }
	    function getSwitchClauseTypeOfWitnesses(switchStatement) {
	      if (some(switchStatement.caseBlock.clauses, (clause) => clause.kind === 296 /* CaseClause */ && !isStringLiteralLike(clause.expression))) {
	        return void 0;
	      }
	      const witnesses = [];
	      for (const clause of switchStatement.caseBlock.clauses) {
	        const text = clause.kind === 296 /* CaseClause */ ? clause.expression.text : void 0;
	        witnesses.push(text && !contains(witnesses, text) ? text : void 0);
	      }
	      return witnesses;
	    }
	    function eachTypeContainedIn(source, types) {
	      return source.flags & 1048576 /* Union */ ? !forEach(source.types, (t) => !contains(types, t)) : contains(types, source);
	    }
	    function isTypeSubsetOf(source, target) {
	      return !!(source === target || source.flags & 131072 /* Never */ || target.flags & 1048576 /* Union */ && isTypeSubsetOfUnion(source, target));
	    }
	    function isTypeSubsetOfUnion(source, target) {
	      if (source.flags & 1048576 /* Union */) {
	        for (const t of source.types) {
	          if (!containsType(target.types, t)) {
	            return false;
	          }
	        }
	        return true;
	      }
	      if (source.flags & 1056 /* EnumLike */ && getBaseTypeOfEnumLikeType(source) === target) {
	        return true;
	      }
	      return containsType(target.types, source);
	    }
	    function forEachType(type, f) {
	      return type.flags & 1048576 /* Union */ ? forEach(type.types, f) : f(type);
	    }
	    function someType(type, f) {
	      return type.flags & 1048576 /* Union */ ? some(type.types, f) : f(type);
	    }
	    function everyType(type, f) {
	      return type.flags & 1048576 /* Union */ ? every(type.types, f) : f(type);
	    }
	    function everyContainedType(type, f) {
	      return type.flags & 3145728 /* UnionOrIntersection */ ? every(type.types, f) : f(type);
	    }
	    function filterType(type, f) {
	      if (type.flags & 1048576 /* Union */) {
	        const types = type.types;
	        const filtered = filter(types, f);
	        if (filtered === types) {
	          return type;
	        }
	        const origin = type.origin;
	        let newOrigin;
	        if (origin && origin.flags & 1048576 /* Union */) {
	          const originTypes = origin.types;
	          const originFiltered = filter(originTypes, (t) => !!(t.flags & 1048576 /* Union */) || f(t));
	          if (originTypes.length - originFiltered.length === types.length - filtered.length) {
	            if (originFiltered.length === 1) {
	              return originFiltered[0];
	            }
	            newOrigin = createOriginUnionOrIntersectionType(1048576 /* Union */, originFiltered);
	          }
	        }
	        return getUnionTypeFromSortedList(
	          filtered,
	          type.objectFlags & (32768 /* PrimitiveUnion */ | 16777216 /* ContainsIntersections */),
	          /*aliasSymbol*/
	          void 0,
	          /*aliasTypeArguments*/
	          void 0,
	          newOrigin
	        );
	      }
	      return type.flags & 131072 /* Never */ || f(type) ? type : neverType;
	    }
	    function removeType(type, targetType) {
	      return filterType(type, (t) => t !== targetType);
	    }
	    function countTypes(type) {
	      return type.flags & 1048576 /* Union */ ? type.types.length : 1;
	    }
	    function mapType(type, mapper, noReductions) {
	      if (type.flags & 131072 /* Never */) {
	        return type;
	      }
	      if (!(type.flags & 1048576 /* Union */)) {
	        return mapper(type);
	      }
	      const origin = type.origin;
	      const types = origin && origin.flags & 1048576 /* Union */ ? origin.types : type.types;
	      let mappedTypes;
	      let changed = false;
	      for (const t of types) {
	        const mapped = t.flags & 1048576 /* Union */ ? mapType(t, mapper, noReductions) : mapper(t);
	        changed || (changed = t !== mapped);
	        if (mapped) {
	          if (!mappedTypes) {
	            mappedTypes = [mapped];
	          } else {
	            mappedTypes.push(mapped);
	          }
	        }
	      }
	      return changed ? mappedTypes && getUnionType(mappedTypes, noReductions ? 0 /* None */ : 1 /* Literal */) : type;
	    }
	    function mapTypeWithAlias(type, mapper, aliasSymbol, aliasTypeArguments) {
	      return type.flags & 1048576 /* Union */ && aliasSymbol ? getUnionType(map(type.types, mapper), 1 /* Literal */, aliasSymbol, aliasTypeArguments) : mapType(type, mapper);
	    }
	    function extractTypesOfKind(type, kind) {
	      return filterType(type, (t) => (t.flags & kind) !== 0);
	    }
	    function replacePrimitivesWithLiterals(typeWithPrimitives, typeWithLiterals) {
	      if (maybeTypeOfKind(typeWithPrimitives, 4 /* String */ | 134217728 /* TemplateLiteral */ | 8 /* Number */ | 64 /* BigInt */) && maybeTypeOfKind(typeWithLiterals, 128 /* StringLiteral */ | 134217728 /* TemplateLiteral */ | 268435456 /* StringMapping */ | 256 /* NumberLiteral */ | 2048 /* BigIntLiteral */)) {
	        return mapType(typeWithPrimitives, (t) => t.flags & 4 /* String */ ? extractTypesOfKind(typeWithLiterals, 4 /* String */ | 128 /* StringLiteral */ | 134217728 /* TemplateLiteral */ | 268435456 /* StringMapping */) : isPatternLiteralType(t) && !maybeTypeOfKind(typeWithLiterals, 4 /* String */ | 134217728 /* TemplateLiteral */ | 268435456 /* StringMapping */) ? extractTypesOfKind(typeWithLiterals, 128 /* StringLiteral */) : t.flags & 8 /* Number */ ? extractTypesOfKind(typeWithLiterals, 8 /* Number */ | 256 /* NumberLiteral */) : t.flags & 64 /* BigInt */ ? extractTypesOfKind(typeWithLiterals, 64 /* BigInt */ | 2048 /* BigIntLiteral */) : t);
	      }
	      return typeWithPrimitives;
	    }
	    function isIncomplete(flowType) {
	      return flowType.flags === 0;
	    }
	    function getTypeFromFlowType(flowType) {
	      return flowType.flags === 0 ? flowType.type : flowType;
	    }
	    function createFlowType(type, incomplete) {
	      return incomplete ? { flags: 0, type: type.flags & 131072 /* Never */ ? silentNeverType : type } : type;
	    }
	    function createEvolvingArrayType(elementType) {
	      const result = createObjectType(256 /* EvolvingArray */);
	      result.elementType = elementType;
	      return result;
	    }
	    function getEvolvingArrayType(elementType) {
	      return evolvingArrayTypes[elementType.id] || (evolvingArrayTypes[elementType.id] = createEvolvingArrayType(elementType));
	    }
	    function addEvolvingArrayElementType(evolvingArrayType, node) {
	      const elementType = getRegularTypeOfObjectLiteral(getBaseTypeOfLiteralType(getContextFreeTypeOfExpression(node)));
	      return isTypeSubsetOf(elementType, evolvingArrayType.elementType) ? evolvingArrayType : getEvolvingArrayType(getUnionType([evolvingArrayType.elementType, elementType]));
	    }
	    function createFinalArrayType(elementType) {
	      return elementType.flags & 131072 /* Never */ ? autoArrayType : createArrayType(
	        elementType.flags & 1048576 /* Union */ ? getUnionType(elementType.types, 2 /* Subtype */) : elementType
	      );
	    }
	    function getFinalArrayType(evolvingArrayType) {
	      return evolvingArrayType.finalArrayType || (evolvingArrayType.finalArrayType = createFinalArrayType(evolvingArrayType.elementType));
	    }
	    function finalizeEvolvingArrayType(type) {
	      return getObjectFlags(type) & 256 /* EvolvingArray */ ? getFinalArrayType(type) : type;
	    }
	    function getElementTypeOfEvolvingArrayType(type) {
	      return getObjectFlags(type) & 256 /* EvolvingArray */ ? type.elementType : neverType;
	    }
	    function isEvolvingArrayTypeList(types) {
	      let hasEvolvingArrayType = false;
	      for (const t of types) {
	        if (!(t.flags & 131072 /* Never */)) {
	          if (!(getObjectFlags(t) & 256 /* EvolvingArray */)) {
	            return false;
	          }
	          hasEvolvingArrayType = true;
	        }
	      }
	      return hasEvolvingArrayType;
	    }
	    function isEvolvingArrayOperationTarget(node) {
	      const root = getReferenceRoot(node);
	      const parent2 = root.parent;
	      const isLengthPushOrUnshift = isPropertyAccessExpression(parent2) && (parent2.name.escapedText === "length" || parent2.parent.kind === 213 /* CallExpression */ && isIdentifier(parent2.name) && isPushOrUnshiftIdentifier(parent2.name));
	      const isElementAssignment = parent2.kind === 212 /* ElementAccessExpression */ && parent2.expression === root && parent2.parent.kind === 226 /* BinaryExpression */ && parent2.parent.operatorToken.kind === 64 /* EqualsToken */ && parent2.parent.left === parent2 && !isAssignmentTarget(parent2.parent) && isTypeAssignableToKind(getTypeOfExpression(parent2.argumentExpression), 296 /* NumberLike */);
	      return isLengthPushOrUnshift || isElementAssignment;
	    }
	    function isDeclarationWithExplicitTypeAnnotation(node) {
	      return (isVariableDeclaration(node) || isPropertyDeclaration(node) || isPropertySignature(node) || isParameter(node)) && !!(getEffectiveTypeAnnotationNode(node) || isInJSFile(node) && hasInitializer(node) && node.initializer && isFunctionExpressionOrArrowFunction(node.initializer) && getEffectiveReturnTypeNode(node.initializer));
	    }
	    function getExplicitTypeOfSymbol(symbol, diagnostic) {
	      symbol = resolveSymbol(symbol);
	      if (symbol.flags & (16 /* Function */ | 8192 /* Method */ | 32 /* Class */ | 512 /* ValueModule */)) {
	        return getTypeOfSymbol(symbol);
	      }
	      if (symbol.flags & (3 /* Variable */ | 4 /* Property */)) {
	        if (getCheckFlags(symbol) & 262144 /* Mapped */) {
	          const origin = symbol.links.syntheticOrigin;
	          if (origin && getExplicitTypeOfSymbol(origin)) {
	            return getTypeOfSymbol(symbol);
	          }
	        }
	        const declaration = symbol.valueDeclaration;
	        if (declaration) {
	          if (isDeclarationWithExplicitTypeAnnotation(declaration)) {
	            return getTypeOfSymbol(symbol);
	          }
	          if (isVariableDeclaration(declaration) && declaration.parent.parent.kind === 250 /* ForOfStatement */) {
	            const statement = declaration.parent.parent;
	            const expressionType = getTypeOfDottedName(
	              statement.expression,
	              /*diagnostic*/
	              void 0
	            );
	            if (expressionType) {
	              const use = statement.awaitModifier ? 15 /* ForAwaitOf */ : 13 /* ForOf */;
	              return checkIteratedTypeOrElementType(
	                use,
	                expressionType,
	                undefinedType,
	                /*errorNode*/
	                void 0
	              );
	            }
	          }
	          if (diagnostic) {
	            addRelatedInfo(diagnostic, createDiagnosticForNode(declaration, Diagnostics._0_needs_an_explicit_type_annotation, symbolToString(symbol)));
	          }
	        }
	      }
	    }
	    function getTypeOfDottedName(node, diagnostic) {
	      if (!(node.flags & 67108864 /* InWithStatement */)) {
	        switch (node.kind) {
	          case 80 /* Identifier */:
	            const symbol = getExportSymbolOfValueSymbolIfExported(getResolvedSymbol(node));
	            return getExplicitTypeOfSymbol(symbol, diagnostic);
	          case 110 /* ThisKeyword */:
	            return getExplicitThisType(node);
	          case 108 /* SuperKeyword */:
	            return checkSuperExpression(node);
	          case 211 /* PropertyAccessExpression */: {
	            const type = getTypeOfDottedName(node.expression, diagnostic);
	            if (type) {
	              const name = node.name;
	              let prop;
	              if (isPrivateIdentifier(name)) {
	                if (!type.symbol) {
	                  return void 0;
	                }
	                prop = getPropertyOfType(type, getSymbolNameForPrivateIdentifier(type.symbol, name.escapedText));
	              } else {
	                prop = getPropertyOfType(type, name.escapedText);
	              }
	              return prop && getExplicitTypeOfSymbol(prop, diagnostic);
	            }
	            return void 0;
	          }
	          case 217 /* ParenthesizedExpression */:
	            return getTypeOfDottedName(node.expression, diagnostic);
	        }
	      }
	    }
	    function getEffectsSignature(node) {
	      const links = getNodeLinks(node);
	      let signature = links.effectsSignature;
	      if (signature === void 0) {
	        let funcType;
	        if (isBinaryExpression(node)) {
	          const rightType = checkNonNullExpression(node.right);
	          funcType = getSymbolHasInstanceMethodOfObjectType(rightType);
	        } else if (node.parent.kind === 244 /* ExpressionStatement */) {
	          funcType = getTypeOfDottedName(
	            node.expression,
	            /*diagnostic*/
	            void 0
	          );
	        } else if (node.expression.kind !== 108 /* SuperKeyword */) {
	          if (isOptionalChain(node)) {
	            funcType = checkNonNullType(
	              getOptionalExpressionType(checkExpression(node.expression), node.expression),
	              node.expression
	            );
	          } else {
	            funcType = checkNonNullExpression(node.expression);
	          }
	        }
	        const signatures = getSignaturesOfType(funcType && getApparentType(funcType) || unknownType, 0 /* Call */);
	        const candidate = signatures.length === 1 && !signatures[0].typeParameters ? signatures[0] : some(signatures, hasTypePredicateOrNeverReturnType) ? getResolvedSignature(node) : void 0;
	        signature = links.effectsSignature = candidate && hasTypePredicateOrNeverReturnType(candidate) ? candidate : unknownSignature;
	      }
	      return signature === unknownSignature ? void 0 : signature;
	    }
	    function hasTypePredicateOrNeverReturnType(signature) {
	      return !!(getTypePredicateOfSignature(signature) || signature.declaration && (getReturnTypeFromAnnotation(signature.declaration) || unknownType).flags & 131072 /* Never */);
	    }
	    function getTypePredicateArgument(predicate, callExpression) {
	      if (predicate.kind === 1 /* Identifier */ || predicate.kind === 3 /* AssertsIdentifier */) {
	        return callExpression.arguments[predicate.parameterIndex];
	      }
	      const invokedExpression = skipParentheses(callExpression.expression);
	      return isAccessExpression(invokedExpression) ? skipParentheses(invokedExpression.expression) : void 0;
	    }
	    function reportFlowControlError(node) {
	      const block = findAncestor(node, isFunctionOrModuleBlock);
	      const sourceFile = getSourceFileOfNode(node);
	      const span = getSpanOfTokenAtPosition(sourceFile, block.statements.pos);
	      diagnostics.add(createFileDiagnostic(sourceFile, span.start, span.length, Diagnostics.The_containing_function_or_module_body_is_too_large_for_control_flow_analysis));
	    }
	    function isReachableFlowNode(flow) {
	      const result = isReachableFlowNodeWorker(
	        flow,
	        /*noCacheCheck*/
	        false
	      );
	      lastFlowNode = flow;
	      lastFlowNodeReachable = result;
	      return result;
	    }
	    function isFalseExpression(expr) {
	      const node = skipParentheses(
	        expr,
	        /*excludeJSDocTypeAssertions*/
	        true
	      );
	      return node.kind === 97 /* FalseKeyword */ || node.kind === 226 /* BinaryExpression */ && (node.operatorToken.kind === 56 /* AmpersandAmpersandToken */ && (isFalseExpression(node.left) || isFalseExpression(node.right)) || node.operatorToken.kind === 57 /* BarBarToken */ && isFalseExpression(node.left) && isFalseExpression(node.right));
	    }
	    function isReachableFlowNodeWorker(flow, noCacheCheck) {
	      while (true) {
	        if (flow === lastFlowNode) {
	          return lastFlowNodeReachable;
	        }
	        const flags = flow.flags;
	        if (flags & 4096 /* Shared */) {
	          if (!noCacheCheck) {
	            const id = getFlowNodeId(flow);
	            const reachable = flowNodeReachable[id];
	            return reachable !== void 0 ? reachable : flowNodeReachable[id] = isReachableFlowNodeWorker(
	              flow,
	              /*noCacheCheck*/
	              true
	            );
	          }
	          noCacheCheck = false;
	        }
	        if (flags & (16 /* Assignment */ | 96 /* Condition */ | 256 /* ArrayMutation */)) {
	          flow = flow.antecedent;
	        } else if (flags & 512 /* Call */) {
	          const signature = getEffectsSignature(flow.node);
	          if (signature) {
	            const predicate = getTypePredicateOfSignature(signature);
	            if (predicate && predicate.kind === 3 /* AssertsIdentifier */ && !predicate.type) {
	              const predicateArgument = flow.node.arguments[predicate.parameterIndex];
	              if (predicateArgument && isFalseExpression(predicateArgument)) {
	                return false;
	              }
	            }
	            if (getReturnTypeOfSignature(signature).flags & 131072 /* Never */) {
	              return false;
	            }
	          }
	          flow = flow.antecedent;
	        } else if (flags & 4 /* BranchLabel */) {
	          return some(flow.antecedents, (f) => isReachableFlowNodeWorker(
	            f,
	            /*noCacheCheck*/
	            false
	          ));
	        } else if (flags & 8 /* LoopLabel */) {
	          const antecedents = flow.antecedents;
	          if (antecedents === void 0 || antecedents.length === 0) {
	            return false;
	          }
	          flow = antecedents[0];
	        } else if (flags & 128 /* SwitchClause */) {
	          if (flow.clauseStart === flow.clauseEnd && isExhaustiveSwitchStatement(flow.switchStatement)) {
	            return false;
	          }
	          flow = flow.antecedent;
	        } else if (flags & 1024 /* ReduceLabel */) {
	          lastFlowNode = void 0;
	          const target = flow.target;
	          const saveAntecedents = target.antecedents;
	          target.antecedents = flow.antecedents;
	          const result = isReachableFlowNodeWorker(
	            flow.antecedent,
	            /*noCacheCheck*/
	            false
	          );
	          target.antecedents = saveAntecedents;
	          return result;
	        } else {
	          return !(flags & 1 /* Unreachable */);
	        }
	      }
	    }
	    function isPostSuperFlowNode(flow, noCacheCheck) {
	      while (true) {
	        const flags = flow.flags;
	        if (flags & 4096 /* Shared */) {
	          if (!noCacheCheck) {
	            const id = getFlowNodeId(flow);
	            const postSuper = flowNodePostSuper[id];
	            return postSuper !== void 0 ? postSuper : flowNodePostSuper[id] = isPostSuperFlowNode(
	              flow,
	              /*noCacheCheck*/
	              true
	            );
	          }
	          noCacheCheck = false;
	        }
	        if (flags & (16 /* Assignment */ | 96 /* Condition */ | 256 /* ArrayMutation */ | 128 /* SwitchClause */)) {
	          flow = flow.antecedent;
	        } else if (flags & 512 /* Call */) {
	          if (flow.node.expression.kind === 108 /* SuperKeyword */) {
	            return true;
	          }
	          flow = flow.antecedent;
	        } else if (flags & 4 /* BranchLabel */) {
	          return every(flow.antecedents, (f) => isPostSuperFlowNode(
	            f,
	            /*noCacheCheck*/
	            false
	          ));
	        } else if (flags & 8 /* LoopLabel */) {
	          flow = flow.antecedents[0];
	        } else if (flags & 1024 /* ReduceLabel */) {
	          const target = flow.target;
	          const saveAntecedents = target.antecedents;
	          target.antecedents = flow.antecedents;
	          const result = isPostSuperFlowNode(
	            flow.antecedent,
	            /*noCacheCheck*/
	            false
	          );
	          target.antecedents = saveAntecedents;
	          return result;
	        } else {
	          return !!(flags & 1 /* Unreachable */);
	        }
	      }
	    }
	    function isConstantReference(node) {
	      switch (node.kind) {
	        case 110 /* ThisKeyword */:
	          return true;
	        case 80 /* Identifier */:
	          if (!isThisInTypeQuery(node)) {
	            const symbol = getResolvedSymbol(node);
	            return isConstantVariable(symbol) || isParameterOrMutableLocalVariable(symbol) && !isSymbolAssigned(symbol);
	          }
	          break;
	        case 211 /* PropertyAccessExpression */:
	        case 212 /* ElementAccessExpression */:
	          return isConstantReference(node.expression) && isReadonlySymbol(getNodeLinks(node).resolvedSymbol || unknownSymbol);
	        case 206 /* ObjectBindingPattern */:
	        case 207 /* ArrayBindingPattern */:
	          const rootDeclaration = getRootDeclaration(node.parent);
	          return isParameter(rootDeclaration) || isCatchClauseVariableDeclaration(rootDeclaration) ? !isSomeSymbolAssigned(rootDeclaration) : isVariableDeclaration(rootDeclaration) && isVarConstLike(rootDeclaration);
	      }
	      return false;
	    }
	    function getFlowTypeOfReference(reference, declaredType, initialType = declaredType, flowContainer, flowNode = ((_a) => (_a = tryCast(reference, canHaveFlowNode)) == null ? void 0 : _a.flowNode)()) {
	      let key;
	      let isKeySet = false;
	      let flowDepth = 0;
	      if (flowAnalysisDisabled) {
	        return errorType;
	      }
	      if (!flowNode) {
	        return declaredType;
	      }
	      flowInvocationCount++;
	      const sharedFlowStart = sharedFlowCount;
	      const evolvedType = getTypeFromFlowType(getTypeAtFlowNode(flowNode));
	      sharedFlowCount = sharedFlowStart;
	      const resultType = getObjectFlags(evolvedType) & 256 /* EvolvingArray */ && isEvolvingArrayOperationTarget(reference) ? autoArrayType : finalizeEvolvingArrayType(evolvedType);
	      if (resultType === unreachableNeverType || reference.parent && reference.parent.kind === 235 /* NonNullExpression */ && !(resultType.flags & 131072 /* Never */) && getTypeWithFacts(resultType, 2097152 /* NEUndefinedOrNull */).flags & 131072 /* Never */) {
	        return declaredType;
	      }
	      return resultType === nonNullUnknownType ? unknownType : resultType;
	      function getOrSetCacheKey() {
	        if (isKeySet) {
	          return key;
	        }
	        isKeySet = true;
	        return key = getFlowCacheKey(reference, declaredType, initialType, flowContainer);
	      }
	      function getTypeAtFlowNode(flow) {
	        var _a2;
	        if (flowDepth === 2e3) {
	          (_a2 = tracing) == null ? void 0 : _a2.instant(tracing.Phase.CheckTypes, "getTypeAtFlowNode_DepthLimit", { flowId: flow.id });
	          flowAnalysisDisabled = true;
	          reportFlowControlError(reference);
	          return errorType;
	        }
	        flowDepth++;
	        let sharedFlow;
	        while (true) {
	          const flags = flow.flags;
	          if (flags & 4096 /* Shared */) {
	            for (let i = sharedFlowStart; i < sharedFlowCount; i++) {
	              if (sharedFlowNodes[i] === flow) {
	                flowDepth--;
	                return sharedFlowTypes[i];
	              }
	            }
	            sharedFlow = flow;
	          }
	          let type;
	          if (flags & 16 /* Assignment */) {
	            type = getTypeAtFlowAssignment(flow);
	            if (!type) {
	              flow = flow.antecedent;
	              continue;
	            }
	          } else if (flags & 512 /* Call */) {
	            type = getTypeAtFlowCall(flow);
	            if (!type) {
	              flow = flow.antecedent;
	              continue;
	            }
	          } else if (flags & 96 /* Condition */) {
	            type = getTypeAtFlowCondition(flow);
	          } else if (flags & 128 /* SwitchClause */) {
	            type = getTypeAtSwitchClause(flow);
	          } else if (flags & 12 /* Label */) {
	            if (flow.antecedents.length === 1) {
	              flow = flow.antecedents[0];
	              continue;
	            }
	            type = flags & 4 /* BranchLabel */ ? getTypeAtFlowBranchLabel(flow) : getTypeAtFlowLoopLabel(flow);
	          } else if (flags & 256 /* ArrayMutation */) {
	            type = getTypeAtFlowArrayMutation(flow);
	            if (!type) {
	              flow = flow.antecedent;
	              continue;
	            }
	          } else if (flags & 1024 /* ReduceLabel */) {
	            const target = flow.target;
	            const saveAntecedents = target.antecedents;
	            target.antecedents = flow.antecedents;
	            type = getTypeAtFlowNode(flow.antecedent);
	            target.antecedents = saveAntecedents;
	          } else if (flags & 2 /* Start */) {
	            const container = flow.node;
	            if (container && container !== flowContainer && reference.kind !== 211 /* PropertyAccessExpression */ && reference.kind !== 212 /* ElementAccessExpression */ && !(reference.kind === 110 /* ThisKeyword */ && container.kind !== 219 /* ArrowFunction */)) {
	              flow = container.flowNode;
	              continue;
	            }
	            type = initialType;
	          } else {
	            type = convertAutoToAny(declaredType);
	          }
	          if (sharedFlow) {
	            sharedFlowNodes[sharedFlowCount] = sharedFlow;
	            sharedFlowTypes[sharedFlowCount] = type;
	            sharedFlowCount++;
	          }
	          flowDepth--;
	          return type;
	        }
	      }
	      function getInitialOrAssignedType(flow) {
	        const node = flow.node;
	        return getNarrowableTypeForReference(
	          node.kind === 260 /* VariableDeclaration */ || node.kind === 208 /* BindingElement */ ? getInitialType(node) : getAssignedType(node),
	          reference
	        );
	      }
	      function getTypeAtFlowAssignment(flow) {
	        const node = flow.node;
	        if (isMatchingReference(reference, node)) {
	          if (!isReachableFlowNode(flow)) {
	            return unreachableNeverType;
	          }
	          if (getAssignmentTargetKind(node) === 2 /* Compound */) {
	            const flowType = getTypeAtFlowNode(flow.antecedent);
	            return createFlowType(getBaseTypeOfLiteralType(getTypeFromFlowType(flowType)), isIncomplete(flowType));
	          }
	          if (declaredType === autoType || declaredType === autoArrayType) {
	            if (isEmptyArrayAssignment(node)) {
	              return getEvolvingArrayType(neverType);
	            }
	            const assignedType = getWidenedLiteralType(getInitialOrAssignedType(flow));
	            return isTypeAssignableTo(assignedType, declaredType) ? assignedType : anyArrayType;
	          }
	          const t = isInCompoundLikeAssignment(node) ? getBaseTypeOfLiteralType(declaredType) : declaredType;
	          if (t.flags & 1048576 /* Union */) {
	            return getAssignmentReducedType(t, getInitialOrAssignedType(flow));
	          }
	          return t;
	        }
	        if (containsMatchingReference(reference, node)) {
	          if (!isReachableFlowNode(flow)) {
	            return unreachableNeverType;
	          }
	          if (isVariableDeclaration(node) && (isInJSFile(node) || isVarConstLike(node))) {
	            const init = getDeclaredExpandoInitializer(node);
	            if (init && (init.kind === 218 /* FunctionExpression */ || init.kind === 219 /* ArrowFunction */)) {
	              return getTypeAtFlowNode(flow.antecedent);
	            }
	          }
	          return declaredType;
	        }
	        if (isVariableDeclaration(node) && node.parent.parent.kind === 249 /* ForInStatement */ && (isMatchingReference(reference, node.parent.parent.expression) || optionalChainContainsReference(node.parent.parent.expression, reference))) {
	          return getNonNullableTypeIfNeeded(finalizeEvolvingArrayType(getTypeFromFlowType(getTypeAtFlowNode(flow.antecedent))));
	        }
	        return void 0;
	      }
	      function narrowTypeByAssertion(type, expr) {
	        const node = skipParentheses(
	          expr,
	          /*excludeJSDocTypeAssertions*/
	          true
	        );
	        if (node.kind === 97 /* FalseKeyword */) {
	          return unreachableNeverType;
	        }
	        if (node.kind === 226 /* BinaryExpression */) {
	          if (node.operatorToken.kind === 56 /* AmpersandAmpersandToken */) {
	            return narrowTypeByAssertion(narrowTypeByAssertion(type, node.left), node.right);
	          }
	          if (node.operatorToken.kind === 57 /* BarBarToken */) {
	            return getUnionType([narrowTypeByAssertion(type, node.left), narrowTypeByAssertion(type, node.right)]);
	          }
	        }
	        return narrowType(
	          type,
	          node,
	          /*assumeTrue*/
	          true
	        );
	      }
	      function getTypeAtFlowCall(flow) {
	        const signature = getEffectsSignature(flow.node);
	        if (signature) {
	          const predicate = getTypePredicateOfSignature(signature);
	          if (predicate && (predicate.kind === 2 /* AssertsThis */ || predicate.kind === 3 /* AssertsIdentifier */)) {
	            const flowType = getTypeAtFlowNode(flow.antecedent);
	            const type = finalizeEvolvingArrayType(getTypeFromFlowType(flowType));
	            const narrowedType = predicate.type ? narrowTypeByTypePredicate(
	              type,
	              predicate,
	              flow.node,
	              /*assumeTrue*/
	              true
	            ) : predicate.kind === 3 /* AssertsIdentifier */ && predicate.parameterIndex >= 0 && predicate.parameterIndex < flow.node.arguments.length ? narrowTypeByAssertion(type, flow.node.arguments[predicate.parameterIndex]) : type;
	            return narrowedType === type ? flowType : createFlowType(narrowedType, isIncomplete(flowType));
	          }
	          if (getReturnTypeOfSignature(signature).flags & 131072 /* Never */) {
	            return unreachableNeverType;
	          }
	        }
	        return void 0;
	      }
	      function getTypeAtFlowArrayMutation(flow) {
	        if (declaredType === autoType || declaredType === autoArrayType) {
	          const node = flow.node;
	          const expr = node.kind === 213 /* CallExpression */ ? node.expression.expression : node.left.expression;
	          if (isMatchingReference(reference, getReferenceCandidate(expr))) {
	            const flowType = getTypeAtFlowNode(flow.antecedent);
	            const type = getTypeFromFlowType(flowType);
	            if (getObjectFlags(type) & 256 /* EvolvingArray */) {
	              let evolvedType2 = type;
	              if (node.kind === 213 /* CallExpression */) {
	                for (const arg of node.arguments) {
	                  evolvedType2 = addEvolvingArrayElementType(evolvedType2, arg);
	                }
	              } else {
	                const indexType = getContextFreeTypeOfExpression(node.left.argumentExpression);
	                if (isTypeAssignableToKind(indexType, 296 /* NumberLike */)) {
	                  evolvedType2 = addEvolvingArrayElementType(evolvedType2, node.right);
	                }
	              }
	              return evolvedType2 === type ? flowType : createFlowType(evolvedType2, isIncomplete(flowType));
	            }
	            return flowType;
	          }
	        }
	        return void 0;
	      }
	      function getTypeAtFlowCondition(flow) {
	        const flowType = getTypeAtFlowNode(flow.antecedent);
	        const type = getTypeFromFlowType(flowType);
	        if (type.flags & 131072 /* Never */) {
	          return flowType;
	        }
	        const assumeTrue = (flow.flags & 32 /* TrueCondition */) !== 0;
	        const nonEvolvingType = finalizeEvolvingArrayType(type);
	        const narrowedType = narrowType(nonEvolvingType, flow.node, assumeTrue);
	        if (narrowedType === nonEvolvingType) {
	          return flowType;
	        }
	        return createFlowType(narrowedType, isIncomplete(flowType));
	      }
	      function getTypeAtSwitchClause(flow) {
	        const expr = skipParentheses(flow.switchStatement.expression);
	        const flowType = getTypeAtFlowNode(flow.antecedent);
	        let type = getTypeFromFlowType(flowType);
	        if (isMatchingReference(reference, expr)) {
	          type = narrowTypeBySwitchOnDiscriminant(type, flow.switchStatement, flow.clauseStart, flow.clauseEnd);
	        } else if (expr.kind === 221 /* TypeOfExpression */ && isMatchingReference(reference, expr.expression)) {
	          type = narrowTypeBySwitchOnTypeOf(type, flow.switchStatement, flow.clauseStart, flow.clauseEnd);
	        } else if (expr.kind === 112 /* TrueKeyword */) {
	          type = narrowTypeBySwitchOnTrue(type, flow.switchStatement, flow.clauseStart, flow.clauseEnd);
	        } else {
	          if (strictNullChecks) {
	            if (optionalChainContainsReference(expr, reference)) {
	              type = narrowTypeBySwitchOptionalChainContainment(type, flow.switchStatement, flow.clauseStart, flow.clauseEnd, (t) => !(t.flags & (32768 /* Undefined */ | 131072 /* Never */)));
	            } else if (expr.kind === 221 /* TypeOfExpression */ && optionalChainContainsReference(expr.expression, reference)) {
	              type = narrowTypeBySwitchOptionalChainContainment(type, flow.switchStatement, flow.clauseStart, flow.clauseEnd, (t) => !(t.flags & 131072 /* Never */ || t.flags & 128 /* StringLiteral */ && t.value === "undefined"));
	            }
	          }
	          const access = getDiscriminantPropertyAccess(expr, type);
	          if (access) {
	            type = narrowTypeBySwitchOnDiscriminantProperty(type, access, flow.switchStatement, flow.clauseStart, flow.clauseEnd);
	          }
	        }
	        return createFlowType(type, isIncomplete(flowType));
	      }
	      function getTypeAtFlowBranchLabel(flow) {
	        const antecedentTypes = [];
	        let subtypeReduction = false;
	        let seenIncomplete = false;
	        let bypassFlow;
	        for (const antecedent of flow.antecedents) {
	          if (!bypassFlow && antecedent.flags & 128 /* SwitchClause */ && antecedent.clauseStart === antecedent.clauseEnd) {
	            bypassFlow = antecedent;
	            continue;
	          }
	          const flowType = getTypeAtFlowNode(antecedent);
	          const type = getTypeFromFlowType(flowType);
	          if (type === declaredType && declaredType === initialType) {
	            return type;
	          }
	          pushIfUnique(antecedentTypes, type);
	          if (!isTypeSubsetOf(type, initialType)) {
	            subtypeReduction = true;
	          }
	          if (isIncomplete(flowType)) {
	            seenIncomplete = true;
	          }
	        }
	        if (bypassFlow) {
	          const flowType = getTypeAtFlowNode(bypassFlow);
	          const type = getTypeFromFlowType(flowType);
	          if (!(type.flags & 131072 /* Never */) && !contains(antecedentTypes, type) && !isExhaustiveSwitchStatement(bypassFlow.switchStatement)) {
	            if (type === declaredType && declaredType === initialType) {
	              return type;
	            }
	            antecedentTypes.push(type);
	            if (!isTypeSubsetOf(type, initialType)) {
	              subtypeReduction = true;
	            }
	            if (isIncomplete(flowType)) {
	              seenIncomplete = true;
	            }
	          }
	        }
	        return createFlowType(getUnionOrEvolvingArrayType(antecedentTypes, subtypeReduction ? 2 /* Subtype */ : 1 /* Literal */), seenIncomplete);
	      }
	      function getTypeAtFlowLoopLabel(flow) {
	        const id = getFlowNodeId(flow);
	        const cache = flowLoopCaches[id] || (flowLoopCaches[id] = /* @__PURE__ */ new Map());
	        const key2 = getOrSetCacheKey();
	        if (!key2) {
	          return declaredType;
	        }
	        const cached = cache.get(key2);
	        if (cached) {
	          return cached;
	        }
	        for (let i = flowLoopStart; i < flowLoopCount; i++) {
	          if (flowLoopNodes[i] === flow && flowLoopKeys[i] === key2 && flowLoopTypes[i].length) {
	            return createFlowType(
	              getUnionOrEvolvingArrayType(flowLoopTypes[i], 1 /* Literal */),
	              /*incomplete*/
	              true
	            );
	          }
	        }
	        const antecedentTypes = [];
	        let subtypeReduction = false;
	        let firstAntecedentType;
	        for (const antecedent of flow.antecedents) {
	          let flowType;
	          if (!firstAntecedentType) {
	            flowType = firstAntecedentType = getTypeAtFlowNode(antecedent);
	          } else {
	            flowLoopNodes[flowLoopCount] = flow;
	            flowLoopKeys[flowLoopCount] = key2;
	            flowLoopTypes[flowLoopCount] = antecedentTypes;
	            flowLoopCount++;
	            const saveFlowTypeCache = flowTypeCache;
	            flowTypeCache = void 0;
	            flowType = getTypeAtFlowNode(antecedent);
	            flowTypeCache = saveFlowTypeCache;
	            flowLoopCount--;
	            const cached2 = cache.get(key2);
	            if (cached2) {
	              return cached2;
	            }
	          }
	          const type = getTypeFromFlowType(flowType);
	          pushIfUnique(antecedentTypes, type);
	          if (!isTypeSubsetOf(type, initialType)) {
	            subtypeReduction = true;
	          }
	          if (type === declaredType) {
	            break;
	          }
	        }
	        const result = getUnionOrEvolvingArrayType(antecedentTypes, subtypeReduction ? 2 /* Subtype */ : 1 /* Literal */);
	        if (isIncomplete(firstAntecedentType)) {
	          return createFlowType(
	            result,
	            /*incomplete*/
	            true
	          );
	        }
	        cache.set(key2, result);
	        return result;
	      }
	      function getUnionOrEvolvingArrayType(types, subtypeReduction) {
	        if (isEvolvingArrayTypeList(types)) {
	          return getEvolvingArrayType(getUnionType(map(types, getElementTypeOfEvolvingArrayType)));
	        }
	        const result = recombineUnknownType(getUnionType(sameMap(types, finalizeEvolvingArrayType), subtypeReduction));
	        if (result !== declaredType && result.flags & declaredType.flags & 1048576 /* Union */ && arraysEqual(result.types, declaredType.types)) {
	          return declaredType;
	        }
	        return result;
	      }
	      function getCandidateDiscriminantPropertyAccess(expr) {
	        if (isBindingPattern(reference) || isFunctionExpressionOrArrowFunction(reference) || isObjectLiteralMethod(reference)) {
	          if (isIdentifier(expr)) {
	            const symbol = getResolvedSymbol(expr);
	            const declaration = symbol.valueDeclaration;
	            if (declaration && (isBindingElement(declaration) || isParameter(declaration)) && reference === declaration.parent && !declaration.initializer && !declaration.dotDotDotToken) {
	              return declaration;
	            }
	          }
	        } else if (isAccessExpression(expr)) {
	          if (isMatchingReference(reference, expr.expression)) {
	            return expr;
	          }
	        } else if (isIdentifier(expr)) {
	          const symbol = getResolvedSymbol(expr);
	          if (isConstantVariable(symbol)) {
	            const declaration = symbol.valueDeclaration;
	            if (isVariableDeclaration(declaration) && !declaration.type && declaration.initializer && isAccessExpression(declaration.initializer) && isMatchingReference(reference, declaration.initializer.expression)) {
	              return declaration.initializer;
	            }
	            if (isBindingElement(declaration) && !declaration.initializer) {
	              const parent2 = declaration.parent.parent;
	              if (isVariableDeclaration(parent2) && !parent2.type && parent2.initializer && (isIdentifier(parent2.initializer) || isAccessExpression(parent2.initializer)) && isMatchingReference(reference, parent2.initializer)) {
	                return declaration;
	              }
	            }
	          }
	        }
	        return void 0;
	      }
	      function getDiscriminantPropertyAccess(expr, computedType) {
	        if (declaredType.flags & 1048576 /* Union */ || computedType.flags & 1048576 /* Union */) {
	          const access = getCandidateDiscriminantPropertyAccess(expr);
	          if (access) {
	            const name = getAccessedPropertyName(access);
	            if (name) {
	              const type = declaredType.flags & 1048576 /* Union */ && isTypeSubsetOf(computedType, declaredType) ? declaredType : computedType;
	              if (isDiscriminantProperty(type, name)) {
	                return access;
	              }
	            }
	          }
	        }
	        return void 0;
	      }
	      function narrowTypeByDiscriminant(type, access, narrowType2) {
	        const propName = getAccessedPropertyName(access);
	        if (propName === void 0) {
	          return type;
	        }
	        const optionalChain = isOptionalChain(access);
	        const removeNullable = strictNullChecks && (optionalChain || isNonNullAccess(access)) && maybeTypeOfKind(type, 98304 /* Nullable */);
	        let propType = getTypeOfPropertyOfType(removeNullable ? getTypeWithFacts(type, 2097152 /* NEUndefinedOrNull */) : type, propName);
	        if (!propType) {
	          return type;
	        }
	        propType = removeNullable && optionalChain ? getOptionalType(propType) : propType;
	        const narrowedPropType = narrowType2(propType);
	        return filterType(type, (t) => {
	          const discriminantType = getTypeOfPropertyOrIndexSignatureOfType(t, propName) || unknownType;
	          return !(discriminantType.flags & 131072 /* Never */) && !(narrowedPropType.flags & 131072 /* Never */) && areTypesComparable(narrowedPropType, discriminantType);
	        });
	      }
	      function narrowTypeByDiscriminantProperty(type, access, operator, value, assumeTrue) {
	        if ((operator === 37 /* EqualsEqualsEqualsToken */ || operator === 38 /* ExclamationEqualsEqualsToken */) && type.flags & 1048576 /* Union */) {
	          const keyPropertyName = getKeyPropertyName(type);
	          if (keyPropertyName && keyPropertyName === getAccessedPropertyName(access)) {
	            const candidate = getConstituentTypeForKeyType(type, getTypeOfExpression(value));
	            if (candidate) {
	              return operator === (assumeTrue ? 37 /* EqualsEqualsEqualsToken */ : 38 /* ExclamationEqualsEqualsToken */) ? candidate : isUnitType(getTypeOfPropertyOfType(candidate, keyPropertyName) || unknownType) ? removeType(type, candidate) : type;
	            }
	          }
	        }
	        return narrowTypeByDiscriminant(type, access, (t) => narrowTypeByEquality(t, operator, value, assumeTrue));
	      }
	      function narrowTypeBySwitchOnDiscriminantProperty(type, access, switchStatement, clauseStart, clauseEnd) {
	        if (clauseStart < clauseEnd && type.flags & 1048576 /* Union */ && getKeyPropertyName(type) === getAccessedPropertyName(access)) {
	          const clauseTypes = getSwitchClauseTypes(switchStatement).slice(clauseStart, clauseEnd);
	          const candidate = getUnionType(map(clauseTypes, (t) => getConstituentTypeForKeyType(type, t) || unknownType));
	          if (candidate !== unknownType) {
	            return candidate;
	          }
	        }
	        return narrowTypeByDiscriminant(type, access, (t) => narrowTypeBySwitchOnDiscriminant(t, switchStatement, clauseStart, clauseEnd));
	      }
	      function narrowTypeByTruthiness(type, expr, assumeTrue) {
	        if (isMatchingReference(reference, expr)) {
	          return getAdjustedTypeWithFacts(type, assumeTrue ? 4194304 /* Truthy */ : 8388608 /* Falsy */);
	        }
	        if (strictNullChecks && assumeTrue && optionalChainContainsReference(expr, reference)) {
	          type = getAdjustedTypeWithFacts(type, 2097152 /* NEUndefinedOrNull */);
	        }
	        const access = getDiscriminantPropertyAccess(expr, type);
	        if (access) {
	          return narrowTypeByDiscriminant(type, access, (t) => getTypeWithFacts(t, assumeTrue ? 4194304 /* Truthy */ : 8388608 /* Falsy */));
	        }
	        return type;
	      }
	      function isTypePresencePossible(type, propName, assumeTrue) {
	        const prop = getPropertyOfType(type, propName);
	        return prop ? !!(prop.flags & 16777216 /* Optional */ || getCheckFlags(prop) & 48 /* Partial */) || assumeTrue : !!getApplicableIndexInfoForName(type, propName) || !assumeTrue;
	      }
	      function narrowTypeByInKeyword(type, nameType, assumeTrue) {
	        const name = getPropertyNameFromType(nameType);
	        const isKnownProperty2 = someType(type, (t) => isTypePresencePossible(
	          t,
	          name,
	          /*assumeTrue*/
	          true
	        ));
	        if (isKnownProperty2) {
	          return filterType(type, (t) => isTypePresencePossible(t, name, assumeTrue));
	        }
	        if (assumeTrue) {
	          const recordSymbol = getGlobalRecordSymbol();
	          if (recordSymbol) {
	            return getIntersectionType([type, getTypeAliasInstantiation(recordSymbol, [nameType, unknownType])]);
	          }
	        }
	        return type;
	      }
	      function narrowTypeByBooleanComparison(type, expr, bool, operator, assumeTrue) {
	        assumeTrue = assumeTrue !== (bool.kind === 112 /* TrueKeyword */) !== (operator !== 38 /* ExclamationEqualsEqualsToken */ && operator !== 36 /* ExclamationEqualsToken */);
	        return narrowType(type, expr, assumeTrue);
	      }
	      function narrowTypeByBinaryExpression(type, expr, assumeTrue) {
	        switch (expr.operatorToken.kind) {
	          case 64 /* EqualsToken */:
	          case 76 /* BarBarEqualsToken */:
	          case 77 /* AmpersandAmpersandEqualsToken */:
	          case 78 /* QuestionQuestionEqualsToken */:
	            return narrowTypeByTruthiness(narrowType(type, expr.right, assumeTrue), expr.left, assumeTrue);
	          case 35 /* EqualsEqualsToken */:
	          case 36 /* ExclamationEqualsToken */:
	          case 37 /* EqualsEqualsEqualsToken */:
	          case 38 /* ExclamationEqualsEqualsToken */:
	            const operator = expr.operatorToken.kind;
	            const left = getReferenceCandidate(expr.left);
	            const right = getReferenceCandidate(expr.right);
	            if (left.kind === 221 /* TypeOfExpression */ && isStringLiteralLike(right)) {
	              return narrowTypeByTypeof(type, left, operator, right, assumeTrue);
	            }
	            if (right.kind === 221 /* TypeOfExpression */ && isStringLiteralLike(left)) {
	              return narrowTypeByTypeof(type, right, operator, left, assumeTrue);
	            }
	            if (isMatchingReference(reference, left)) {
	              return narrowTypeByEquality(type, operator, right, assumeTrue);
	            }
	            if (isMatchingReference(reference, right)) {
	              return narrowTypeByEquality(type, operator, left, assumeTrue);
	            }
	            if (strictNullChecks) {
	              if (optionalChainContainsReference(left, reference)) {
	                type = narrowTypeByOptionalChainContainment(type, operator, right, assumeTrue);
	              } else if (optionalChainContainsReference(right, reference)) {
	                type = narrowTypeByOptionalChainContainment(type, operator, left, assumeTrue);
	              }
	            }
	            const leftAccess = getDiscriminantPropertyAccess(left, type);
	            if (leftAccess) {
	              return narrowTypeByDiscriminantProperty(type, leftAccess, operator, right, assumeTrue);
	            }
	            const rightAccess = getDiscriminantPropertyAccess(right, type);
	            if (rightAccess) {
	              return narrowTypeByDiscriminantProperty(type, rightAccess, operator, left, assumeTrue);
	            }
	            if (isMatchingConstructorReference(left)) {
	              return narrowTypeByConstructor(type, operator, right, assumeTrue);
	            }
	            if (isMatchingConstructorReference(right)) {
	              return narrowTypeByConstructor(type, operator, left, assumeTrue);
	            }
	            if (isBooleanLiteral(right) && !isAccessExpression(left)) {
	              return narrowTypeByBooleanComparison(type, left, right, operator, assumeTrue);
	            }
	            if (isBooleanLiteral(left) && !isAccessExpression(right)) {
	              return narrowTypeByBooleanComparison(type, right, left, operator, assumeTrue);
	            }
	            break;
	          case 104 /* InstanceOfKeyword */:
	            return narrowTypeByInstanceof(type, expr, assumeTrue);
	          case 103 /* InKeyword */:
	            if (isPrivateIdentifier(expr.left)) {
	              return narrowTypeByPrivateIdentifierInInExpression(type, expr, assumeTrue);
	            }
	            const target = getReferenceCandidate(expr.right);
	            if (containsMissingType(type) && isAccessExpression(reference) && isMatchingReference(reference.expression, target)) {
	              const leftType = getTypeOfExpression(expr.left);
	              if (isTypeUsableAsPropertyName(leftType) && getAccessedPropertyName(reference) === getPropertyNameFromType(leftType)) {
	                return getTypeWithFacts(type, assumeTrue ? 524288 /* NEUndefined */ : 65536 /* EQUndefined */);
	              }
	            }
	            if (isMatchingReference(reference, target)) {
	              const leftType = getTypeOfExpression(expr.left);
	              if (isTypeUsableAsPropertyName(leftType)) {
	                return narrowTypeByInKeyword(type, leftType, assumeTrue);
	              }
	            }
	            break;
	          case 28 /* CommaToken */:
	            return narrowType(type, expr.right, assumeTrue);
	          case 56 /* AmpersandAmpersandToken */:
	            return assumeTrue ? narrowType(
	              narrowType(
	                type,
	                expr.left,
	                /*assumeTrue*/
	                true
	              ),
	              expr.right,
	              /*assumeTrue*/
	              true
	            ) : getUnionType([narrowType(
	              type,
	              expr.left,
	              /*assumeTrue*/
	              false
	            ), narrowType(
	              type,
	              expr.right,
	              /*assumeTrue*/
	              false
	            )]);
	          case 57 /* BarBarToken */:
	            return assumeTrue ? getUnionType([narrowType(
	              type,
	              expr.left,
	              /*assumeTrue*/
	              true
	            ), narrowType(
	              type,
	              expr.right,
	              /*assumeTrue*/
	              true
	            )]) : narrowType(
	              narrowType(
	                type,
	                expr.left,
	                /*assumeTrue*/
	                false
	              ),
	              expr.right,
	              /*assumeTrue*/
	              false
	            );
	        }
	        return type;
	      }
	      function narrowTypeByPrivateIdentifierInInExpression(type, expr, assumeTrue) {
	        const target = getReferenceCandidate(expr.right);
	        if (!isMatchingReference(reference, target)) {
	          return type;
	        }
	        Debug.assertNode(expr.left, isPrivateIdentifier);
	        const symbol = getSymbolForPrivateIdentifierExpression(expr.left);
	        if (symbol === void 0) {
	          return type;
	        }
	        const classSymbol = symbol.parent;
	        const targetType = hasStaticModifier(Debug.checkDefined(symbol.valueDeclaration, "should always have a declaration")) ? getTypeOfSymbol(classSymbol) : getDeclaredTypeOfSymbol(classSymbol);
	        return getNarrowedType(
	          type,
	          targetType,
	          assumeTrue,
	          /*checkDerived*/
	          true
	        );
	      }
	      function narrowTypeByOptionalChainContainment(type, operator, value, assumeTrue) {
	        const equalsOperator = operator === 35 /* EqualsEqualsToken */ || operator === 37 /* EqualsEqualsEqualsToken */;
	        const nullableFlags = operator === 35 /* EqualsEqualsToken */ || operator === 36 /* ExclamationEqualsToken */ ? 98304 /* Nullable */ : 32768 /* Undefined */;
	        const valueType = getTypeOfExpression(value);
	        const removeNullable = equalsOperator !== assumeTrue && everyType(valueType, (t) => !!(t.flags & nullableFlags)) || equalsOperator === assumeTrue && everyType(valueType, (t) => !(t.flags & (3 /* AnyOrUnknown */ | nullableFlags)));
	        return removeNullable ? getAdjustedTypeWithFacts(type, 2097152 /* NEUndefinedOrNull */) : type;
	      }
	      function narrowTypeByEquality(type, operator, value, assumeTrue) {
	        if (type.flags & 1 /* Any */) {
	          return type;
	        }
	        if (operator === 36 /* ExclamationEqualsToken */ || operator === 38 /* ExclamationEqualsEqualsToken */) {
	          assumeTrue = !assumeTrue;
	        }
	        const valueType = getTypeOfExpression(value);
	        const doubleEquals = operator === 35 /* EqualsEqualsToken */ || operator === 36 /* ExclamationEqualsToken */;
	        if (valueType.flags & 98304 /* Nullable */) {
	          if (!strictNullChecks) {
	            return type;
	          }
	          const facts = doubleEquals ? assumeTrue ? 262144 /* EQUndefinedOrNull */ : 2097152 /* NEUndefinedOrNull */ : valueType.flags & 65536 /* Null */ ? assumeTrue ? 131072 /* EQNull */ : 1048576 /* NENull */ : assumeTrue ? 65536 /* EQUndefined */ : 524288 /* NEUndefined */;
	          return getAdjustedTypeWithFacts(type, facts);
	        }
	        if (assumeTrue) {
	          if (!doubleEquals && (type.flags & 2 /* Unknown */ || someType(type, isEmptyAnonymousObjectType))) {
	            if (valueType.flags & (402784252 /* Primitive */ | 67108864 /* NonPrimitive */) || isEmptyAnonymousObjectType(valueType)) {
	              return valueType;
	            }
	            if (valueType.flags & 524288 /* Object */) {
	              return nonPrimitiveType;
	            }
	          }
	          const filteredType = filterType(type, (t) => areTypesComparable(t, valueType) || doubleEquals && isCoercibleUnderDoubleEquals(t, valueType));
	          return replacePrimitivesWithLiterals(filteredType, valueType);
	        }
	        if (isUnitType(valueType)) {
	          return filterType(type, (t) => !(isUnitLikeType(t) && areTypesComparable(t, valueType)));
	        }
	        return type;
	      }
	      function narrowTypeByTypeof(type, typeOfExpr, operator, literal, assumeTrue) {
	        if (operator === 36 /* ExclamationEqualsToken */ || operator === 38 /* ExclamationEqualsEqualsToken */) {
	          assumeTrue = !assumeTrue;
	        }
	        const target = getReferenceCandidate(typeOfExpr.expression);
	        if (!isMatchingReference(reference, target)) {
	          if (strictNullChecks && optionalChainContainsReference(target, reference) && assumeTrue === (literal.text !== "undefined")) {
	            type = getAdjustedTypeWithFacts(type, 2097152 /* NEUndefinedOrNull */);
	          }
	          const propertyAccess = getDiscriminantPropertyAccess(target, type);
	          if (propertyAccess) {
	            return narrowTypeByDiscriminant(type, propertyAccess, (t) => narrowTypeByLiteralExpression(t, literal, assumeTrue));
	          }
	          return type;
	        }
	        return narrowTypeByLiteralExpression(type, literal, assumeTrue);
	      }
	      function narrowTypeByLiteralExpression(type, literal, assumeTrue) {
	        return assumeTrue ? narrowTypeByTypeName(type, literal.text) : getAdjustedTypeWithFacts(type, typeofNEFacts.get(literal.text) || 32768 /* TypeofNEHostObject */);
	      }
	      function narrowTypeBySwitchOptionalChainContainment(type, switchStatement, clauseStart, clauseEnd, clauseCheck) {
	        const everyClauseChecks = clauseStart !== clauseEnd && every(getSwitchClauseTypes(switchStatement).slice(clauseStart, clauseEnd), clauseCheck);
	        return everyClauseChecks ? getTypeWithFacts(type, 2097152 /* NEUndefinedOrNull */) : type;
	      }
	      function narrowTypeBySwitchOnDiscriminant(type, switchStatement, clauseStart, clauseEnd) {
	        const switchTypes = getSwitchClauseTypes(switchStatement);
	        if (!switchTypes.length) {
	          return type;
	        }
	        const clauseTypes = switchTypes.slice(clauseStart, clauseEnd);
	        const hasDefaultClause = clauseStart === clauseEnd || contains(clauseTypes, neverType);
	        if (type.flags & 2 /* Unknown */ && !hasDefaultClause) {
	          let groundClauseTypes;
	          for (let i = 0; i < clauseTypes.length; i += 1) {
	            const t = clauseTypes[i];
	            if (t.flags & (402784252 /* Primitive */ | 67108864 /* NonPrimitive */)) {
	              if (groundClauseTypes !== void 0) {
	                groundClauseTypes.push(t);
	              }
	            } else if (t.flags & 524288 /* Object */) {
	              if (groundClauseTypes === void 0) {
	                groundClauseTypes = clauseTypes.slice(0, i);
	              }
	              groundClauseTypes.push(nonPrimitiveType);
	            } else {
	              return type;
	            }
	          }
	          return getUnionType(groundClauseTypes === void 0 ? clauseTypes : groundClauseTypes);
	        }
	        const discriminantType = getUnionType(clauseTypes);
	        const caseType = discriminantType.flags & 131072 /* Never */ ? neverType : replacePrimitivesWithLiterals(filterType(type, (t) => areTypesComparable(discriminantType, t)), discriminantType);
	        if (!hasDefaultClause) {
	          return caseType;
	        }
	        const defaultType = filterType(type, (t) => !(isUnitLikeType(t) && contains(switchTypes, getRegularTypeOfLiteralType(extractUnitType(t)))));
	        return caseType.flags & 131072 /* Never */ ? defaultType : getUnionType([caseType, defaultType]);
	      }
	      function narrowTypeByTypeName(type, typeName) {
	        switch (typeName) {
	          case "string":
	            return narrowTypeByTypeFacts(type, stringType, 1 /* TypeofEQString */);
	          case "number":
	            return narrowTypeByTypeFacts(type, numberType, 2 /* TypeofEQNumber */);
	          case "bigint":
	            return narrowTypeByTypeFacts(type, bigintType, 4 /* TypeofEQBigInt */);
	          case "boolean":
	            return narrowTypeByTypeFacts(type, booleanType, 8 /* TypeofEQBoolean */);
	          case "symbol":
	            return narrowTypeByTypeFacts(type, esSymbolType, 16 /* TypeofEQSymbol */);
	          case "object":
	            return type.flags & 1 /* Any */ ? type : getUnionType([narrowTypeByTypeFacts(type, nonPrimitiveType, 32 /* TypeofEQObject */), narrowTypeByTypeFacts(type, nullType, 131072 /* EQNull */)]);
	          case "function":
	            return type.flags & 1 /* Any */ ? type : narrowTypeByTypeFacts(type, globalFunctionType, 64 /* TypeofEQFunction */);
	          case "undefined":
	            return narrowTypeByTypeFacts(type, undefinedType, 65536 /* EQUndefined */);
	        }
	        return narrowTypeByTypeFacts(type, nonPrimitiveType, 128 /* TypeofEQHostObject */);
	      }
	      function narrowTypeByTypeFacts(type, impliedType, facts) {
	        return mapType(type, (t) => (
	          // We first check if a constituent is a subtype of the implied type. If so, we either keep or eliminate
	          // the constituent based on its type facts. We use the strict subtype relation because it treats `object`
	          // as a subtype of `{}`, and we need the type facts check because function types are subtypes of `object`,
	          // but are classified as "function" according to `typeof`.
	          isTypeRelatedTo(t, impliedType, strictSubtypeRelation) ? hasTypeFacts(t, facts) ? t : neverType : (
	            // We next check if the consituent is a supertype of the implied type. If so, we substitute the implied
	            // type. This handles top types like `unknown` and `{}`, and supertypes like `{ toString(): string }`.
	            isTypeSubtypeOf(impliedType, t) ? impliedType : (
	              // Neither the constituent nor the implied type is a subtype of the other, however their domains may still
	              // overlap. For example, an unconstrained type parameter and type `string`. If the type facts indicate
	              // possible overlap, we form an intersection. Otherwise, we eliminate the constituent.
	              hasTypeFacts(t, facts) ? getIntersectionType([t, impliedType]) : neverType
	            )
	          )
	        ));
	      }
	      function narrowTypeBySwitchOnTypeOf(type, switchStatement, clauseStart, clauseEnd) {
	        const witnesses = getSwitchClauseTypeOfWitnesses(switchStatement);
	        if (!witnesses) {
	          return type;
	        }
	        const defaultIndex = findIndex(switchStatement.caseBlock.clauses, (clause) => clause.kind === 297 /* DefaultClause */);
	        const hasDefaultClause = clauseStart === clauseEnd || defaultIndex >= clauseStart && defaultIndex < clauseEnd;
	        if (hasDefaultClause) {
	          const notEqualFacts = getNotEqualFactsFromTypeofSwitch(clauseStart, clauseEnd, witnesses);
	          return filterType(type, (t) => getTypeFacts(t, notEqualFacts) === notEqualFacts);
	        }
	        const clauseWitnesses = witnesses.slice(clauseStart, clauseEnd);
	        return getUnionType(map(clauseWitnesses, (text) => text ? narrowTypeByTypeName(type, text) : neverType));
	      }
	      function narrowTypeBySwitchOnTrue(type, switchStatement, clauseStart, clauseEnd) {
	        const defaultIndex = findIndex(switchStatement.caseBlock.clauses, (clause) => clause.kind === 297 /* DefaultClause */);
	        const hasDefaultClause = clauseStart === clauseEnd || defaultIndex >= clauseStart && defaultIndex < clauseEnd;
	        for (let i = 0; i < clauseStart; i++) {
	          const clause = switchStatement.caseBlock.clauses[i];
	          if (clause.kind === 296 /* CaseClause */) {
	            type = narrowType(
	              type,
	              clause.expression,
	              /*assumeTrue*/
	              false
	            );
	          }
	        }
	        if (hasDefaultClause) {
	          for (let i = clauseEnd; i < switchStatement.caseBlock.clauses.length; i++) {
	            const clause = switchStatement.caseBlock.clauses[i];
	            if (clause.kind === 296 /* CaseClause */) {
	              type = narrowType(
	                type,
	                clause.expression,
	                /*assumeTrue*/
	                false
	              );
	            }
	          }
	          return type;
	        }
	        const clauses = switchStatement.caseBlock.clauses.slice(clauseStart, clauseEnd);
	        return getUnionType(map(clauses, (clause) => clause.kind === 296 /* CaseClause */ ? narrowType(
	          type,
	          clause.expression,
	          /*assumeTrue*/
	          true
	        ) : neverType));
	      }
	      function isMatchingConstructorReference(expr) {
	        return (isPropertyAccessExpression(expr) && idText(expr.name) === "constructor" || isElementAccessExpression(expr) && isStringLiteralLike(expr.argumentExpression) && expr.argumentExpression.text === "constructor") && isMatchingReference(reference, expr.expression);
	      }
	      function narrowTypeByConstructor(type, operator, identifier, assumeTrue) {
	        if (assumeTrue ? operator !== 35 /* EqualsEqualsToken */ && operator !== 37 /* EqualsEqualsEqualsToken */ : operator !== 36 /* ExclamationEqualsToken */ && operator !== 38 /* ExclamationEqualsEqualsToken */) {
	          return type;
	        }
	        const identifierType = getTypeOfExpression(identifier);
	        if (!isFunctionType(identifierType) && !isConstructorType(identifierType)) {
	          return type;
	        }
	        const prototypeProperty = getPropertyOfType(identifierType, "prototype");
	        if (!prototypeProperty) {
	          return type;
	        }
	        const prototypeType = getTypeOfSymbol(prototypeProperty);
	        const candidate = !isTypeAny(prototypeType) ? prototypeType : void 0;
	        if (!candidate || candidate === globalObjectType || candidate === globalFunctionType) {
	          return type;
	        }
	        if (isTypeAny(type)) {
	          return candidate;
	        }
	        return filterType(type, (t) => isConstructedBy(t, candidate));
	        function isConstructedBy(source, target) {
	          if (source.flags & 524288 /* Object */ && getObjectFlags(source) & 1 /* Class */ || target.flags & 524288 /* Object */ && getObjectFlags(target) & 1 /* Class */) {
	            return source.symbol === target.symbol;
	          }
	          return isTypeSubtypeOf(source, target);
	        }
	      }
	      function narrowTypeByInstanceof(type, expr, assumeTrue) {
	        const left = getReferenceCandidate(expr.left);
	        if (!isMatchingReference(reference, left)) {
	          if (assumeTrue && strictNullChecks && optionalChainContainsReference(left, reference)) {
	            return getAdjustedTypeWithFacts(type, 2097152 /* NEUndefinedOrNull */);
	          }
	          return type;
	        }
	        const right = expr.right;
	        const rightType = getTypeOfExpression(right);
	        if (!isTypeDerivedFrom(rightType, globalObjectType)) {
	          return type;
	        }
	        const signature = getEffectsSignature(expr);
	        const predicate = signature && getTypePredicateOfSignature(signature);
	        if (predicate && predicate.kind === 1 /* Identifier */ && predicate.parameterIndex === 0) {
	          return getNarrowedType(
	            type,
	            predicate.type,
	            assumeTrue,
	            /*checkDerived*/
	            true
	          );
	        }
	        if (!isTypeDerivedFrom(rightType, globalFunctionType)) {
	          return type;
	        }
	        const instanceType = mapType(rightType, getInstanceType);
	        if (isTypeAny(type) && (instanceType === globalObjectType || instanceType === globalFunctionType) || !assumeTrue && !(instanceType.flags & 524288 /* Object */ && !isEmptyAnonymousObjectType(instanceType))) {
	          return type;
	        }
	        return getNarrowedType(
	          type,
	          instanceType,
	          assumeTrue,
	          /*checkDerived*/
	          true
	        );
	      }
	      function getInstanceType(constructorType) {
	        const prototypePropertyType = getTypeOfPropertyOfType(constructorType, "prototype");
	        if (prototypePropertyType && !isTypeAny(prototypePropertyType)) {
	          return prototypePropertyType;
	        }
	        const constructSignatures = getSignaturesOfType(constructorType, 1 /* Construct */);
	        if (constructSignatures.length) {
	          return getUnionType(map(constructSignatures, (signature) => getReturnTypeOfSignature(getErasedSignature(signature))));
	        }
	        return emptyObjectType;
	      }
	      function getNarrowedType(type, candidate, assumeTrue, checkDerived) {
	        const key2 = type.flags & 1048576 /* Union */ ? `N${getTypeId(type)},${getTypeId(candidate)},${(assumeTrue ? 1 : 0) | (checkDerived ? 2 : 0)}` : void 0;
	        return getCachedType(key2) ?? setCachedType(key2, getNarrowedTypeWorker(type, candidate, assumeTrue, checkDerived));
	      }
	      function getNarrowedTypeWorker(type, candidate, assumeTrue, checkDerived) {
	        if (!assumeTrue) {
	          if (type === candidate) {
	            return neverType;
	          }
	          if (checkDerived) {
	            return filterType(type, (t) => !isTypeDerivedFrom(t, candidate));
	          }
	          const trueType2 = getNarrowedType(
	            type,
	            candidate,
	            /*assumeTrue*/
	            true,
	            /*checkDerived*/
	            false
	          );
	          return filterType(type, (t) => !isTypeSubsetOf(t, trueType2));
	        }
	        if (type.flags & 3 /* AnyOrUnknown */) {
	          return candidate;
	        }
	        if (type === candidate) {
	          return candidate;
	        }
	        const isRelated = checkDerived ? isTypeDerivedFrom : isTypeSubtypeOf;
	        const keyPropertyName = type.flags & 1048576 /* Union */ ? getKeyPropertyName(type) : void 0;
	        const narrowedType = mapType(candidate, (c) => {
	          const discriminant = keyPropertyName && getTypeOfPropertyOfType(c, keyPropertyName);
	          const matching = discriminant && getConstituentTypeForKeyType(type, discriminant);
	          const directlyRelated = mapType(
	            matching || type,
	            checkDerived ? (t) => isTypeDerivedFrom(t, c) ? t : isTypeDerivedFrom(c, t) ? c : neverType : (t) => isTypeStrictSubtypeOf(t, c) ? t : isTypeStrictSubtypeOf(c, t) ? c : isTypeSubtypeOf(t, c) ? t : isTypeSubtypeOf(c, t) ? c : neverType
	          );
	          return directlyRelated.flags & 131072 /* Never */ ? mapType(type, (t) => maybeTypeOfKind(t, 465829888 /* Instantiable */) && isRelated(c, getBaseConstraintOfType(t) || unknownType) ? getIntersectionType([t, c]) : neverType) : directlyRelated;
	        });
	        return !(narrowedType.flags & 131072 /* Never */) ? narrowedType : isTypeSubtypeOf(candidate, type) ? candidate : isTypeAssignableTo(type, candidate) ? type : isTypeAssignableTo(candidate, type) ? candidate : getIntersectionType([type, candidate]);
	      }
	      function narrowTypeByCallExpression(type, callExpression, assumeTrue) {
	        if (hasMatchingArgument(callExpression, reference)) {
	          const signature = assumeTrue || !isCallChain(callExpression) ? getEffectsSignature(callExpression) : void 0;
	          const predicate = signature && getTypePredicateOfSignature(signature);
	          if (predicate && (predicate.kind === 0 /* This */ || predicate.kind === 1 /* Identifier */)) {
	            return narrowTypeByTypePredicate(type, predicate, callExpression, assumeTrue);
	          }
	        }
	        if (containsMissingType(type) && isAccessExpression(reference) && isPropertyAccessExpression(callExpression.expression)) {
	          const callAccess = callExpression.expression;
	          if (isMatchingReference(reference.expression, getReferenceCandidate(callAccess.expression)) && isIdentifier(callAccess.name) && callAccess.name.escapedText === "hasOwnProperty" && callExpression.arguments.length === 1) {
	            const argument = callExpression.arguments[0];
	            if (isStringLiteralLike(argument) && getAccessedPropertyName(reference) === escapeLeadingUnderscores(argument.text)) {
	              return getTypeWithFacts(type, assumeTrue ? 524288 /* NEUndefined */ : 65536 /* EQUndefined */);
	            }
	          }
	        }
	        return type;
	      }
	      function narrowTypeByTypePredicate(type, predicate, callExpression, assumeTrue) {
	        if (predicate.type && !(isTypeAny(type) && (predicate.type === globalObjectType || predicate.type === globalFunctionType))) {
	          const predicateArgument = getTypePredicateArgument(predicate, callExpression);
	          if (predicateArgument) {
	            if (isMatchingReference(reference, predicateArgument)) {
	              return getNarrowedType(
	                type,
	                predicate.type,
	                assumeTrue,
	                /*checkDerived*/
	                false
	              );
	            }
	            if (strictNullChecks && optionalChainContainsReference(predicateArgument, reference) && (assumeTrue && !hasTypeFacts(predicate.type, 65536 /* EQUndefined */) || !assumeTrue && everyType(predicate.type, isNullableType))) {
	              type = getAdjustedTypeWithFacts(type, 2097152 /* NEUndefinedOrNull */);
	            }
	            const access = getDiscriminantPropertyAccess(predicateArgument, type);
	            if (access) {
	              return narrowTypeByDiscriminant(type, access, (t) => getNarrowedType(
	                t,
	                predicate.type,
	                assumeTrue,
	                /*checkDerived*/
	                false
	              ));
	            }
	          }
	        }
	        return type;
	      }
	      function narrowType(type, expr, assumeTrue) {
	        if (isExpressionOfOptionalChainRoot(expr) || isBinaryExpression(expr.parent) && (expr.parent.operatorToken.kind === 61 /* QuestionQuestionToken */ || expr.parent.operatorToken.kind === 78 /* QuestionQuestionEqualsToken */) && expr.parent.left === expr) {
	          return narrowTypeByOptionality(type, expr, assumeTrue);
	        }
	        switch (expr.kind) {
	          case 80 /* Identifier */:
	            if (!isMatchingReference(reference, expr) && inlineLevel < 5) {
	              const symbol = getResolvedSymbol(expr);
	              if (isConstantVariable(symbol)) {
	                const declaration = symbol.valueDeclaration;
	                if (declaration && isVariableDeclaration(declaration) && !declaration.type && declaration.initializer && isConstantReference(reference)) {
	                  inlineLevel++;
	                  const result = narrowType(type, declaration.initializer, assumeTrue);
	                  inlineLevel--;
	                  return result;
	                }
	              }
	            }
	          case 110 /* ThisKeyword */:
	          case 108 /* SuperKeyword */:
	          case 211 /* PropertyAccessExpression */:
	          case 212 /* ElementAccessExpression */:
	            return narrowTypeByTruthiness(type, expr, assumeTrue);
	          case 213 /* CallExpression */:
	            return narrowTypeByCallExpression(type, expr, assumeTrue);
	          case 217 /* ParenthesizedExpression */:
	          case 235 /* NonNullExpression */:
	            return narrowType(type, expr.expression, assumeTrue);
	          case 226 /* BinaryExpression */:
	            return narrowTypeByBinaryExpression(type, expr, assumeTrue);
	          case 224 /* PrefixUnaryExpression */:
	            if (expr.operator === 54 /* ExclamationToken */) {
	              return narrowType(type, expr.operand, !assumeTrue);
	            }
	            break;
	        }
	        return type;
	      }
	      function narrowTypeByOptionality(type, expr, assumePresent) {
	        if (isMatchingReference(reference, expr)) {
	          return getAdjustedTypeWithFacts(type, assumePresent ? 2097152 /* NEUndefinedOrNull */ : 262144 /* EQUndefinedOrNull */);
	        }
	        const access = getDiscriminantPropertyAccess(expr, type);
	        if (access) {
	          return narrowTypeByDiscriminant(type, access, (t) => getTypeWithFacts(t, assumePresent ? 2097152 /* NEUndefinedOrNull */ : 262144 /* EQUndefinedOrNull */));
	        }
	        return type;
	      }
	    }
	    function getTypeOfSymbolAtLocation(symbol, location) {
	      symbol = getExportSymbolOfValueSymbolIfExported(symbol);
	      if (location.kind === 80 /* Identifier */ || location.kind === 81 /* PrivateIdentifier */) {
	        if (isRightSideOfQualifiedNameOrPropertyAccess(location)) {
	          location = location.parent;
	        }
	        if (isExpressionNode(location) && (!isAssignmentTarget(location) || isWriteAccess(location))) {
	          const type = removeOptionalTypeMarker(
	            isWriteAccess(location) && location.kind === 211 /* PropertyAccessExpression */ ? checkPropertyAccessExpression(
	              location,
	              /*checkMode*/
	              void 0,
	              /*writeOnly*/
	              true
	            ) : getTypeOfExpression(location)
	          );
	          if (getExportSymbolOfValueSymbolIfExported(getNodeLinks(location).resolvedSymbol) === symbol) {
	            return type;
	          }
	        }
	      }
	      if (isDeclarationName(location) && isSetAccessor(location.parent) && getAnnotatedAccessorTypeNode(location.parent)) {
	        return getWriteTypeOfAccessors(location.parent.symbol);
	      }
	      return isRightSideOfAccessExpression(location) && isWriteAccess(location.parent) ? getWriteTypeOfSymbol(symbol) : getNonMissingTypeOfSymbol(symbol);
	    }
	    function getControlFlowContainer(node) {
	      return findAncestor(node.parent, (node2) => isFunctionLike(node2) && !getImmediatelyInvokedFunctionExpression(node2) || node2.kind === 268 /* ModuleBlock */ || node2.kind === 312 /* SourceFile */ || node2.kind === 172 /* PropertyDeclaration */);
	    }
	    function isSymbolAssigned(symbol) {
	      return !isPastLastAssignment(
	        symbol,
	        /*location*/
	        void 0
	      );
	    }
	    function isPastLastAssignment(symbol, location) {
	      const parent2 = findAncestor(symbol.valueDeclaration, isFunctionOrSourceFile);
	      if (!parent2) {
	        return false;
	      }
	      const links = getNodeLinks(parent2);
	      if (!(links.flags & 131072 /* AssignmentsMarked */)) {
	        links.flags |= 131072 /* AssignmentsMarked */;
	        if (!hasParentWithAssignmentsMarked(parent2)) {
	          markNodeAssignments(parent2);
	        }
	      }
	      return !symbol.lastAssignmentPos || location && symbol.lastAssignmentPos < location.pos;
	    }
	    function isSomeSymbolAssigned(rootDeclaration) {
	      Debug.assert(isVariableDeclaration(rootDeclaration) || isParameter(rootDeclaration));
	      return isSomeSymbolAssignedWorker(rootDeclaration.name);
	    }
	    function isSomeSymbolAssignedWorker(node) {
	      if (node.kind === 80 /* Identifier */) {
	        return isSymbolAssigned(getSymbolOfDeclaration(node.parent));
	      }
	      return some(node.elements, (e) => e.kind !== 232 /* OmittedExpression */ && isSomeSymbolAssignedWorker(e.name));
	    }
	    function hasParentWithAssignmentsMarked(node) {
	      return !!findAncestor(node.parent, (node2) => isFunctionOrSourceFile(node2) && !!(getNodeLinks(node2).flags & 131072 /* AssignmentsMarked */));
	    }
	    function isFunctionOrSourceFile(node) {
	      return isFunctionLikeDeclaration(node) || isSourceFile(node);
	    }
	    function markNodeAssignments(node) {
	      switch (node.kind) {
	        case 80 /* Identifier */:
	          if (isAssignmentTarget(node)) {
	            const symbol = getResolvedSymbol(node);
	            if (isParameterOrMutableLocalVariable(symbol) && symbol.lastAssignmentPos !== Number.MAX_VALUE) {
	              const referencingFunction = findAncestor(node, isFunctionOrSourceFile);
	              const declaringFunction = findAncestor(symbol.valueDeclaration, isFunctionOrSourceFile);
	              symbol.lastAssignmentPos = referencingFunction === declaringFunction ? extendAssignmentPosition(node, symbol.valueDeclaration) : Number.MAX_VALUE;
	            }
	          }
	          return;
	        case 281 /* ExportSpecifier */:
	          const exportDeclaration = node.parent.parent;
	          if (!node.isTypeOnly && !exportDeclaration.isTypeOnly && !exportDeclaration.moduleSpecifier) {
	            const symbol = resolveEntityName(
	              node.propertyName || node.name,
	              111551 /* Value */,
	              /*ignoreErrors*/
	              true,
	              /*dontResolveAlias*/
	              true
	            );
	            if (symbol && isParameterOrMutableLocalVariable(symbol)) {
	              symbol.lastAssignmentPos = Number.MAX_VALUE;
	            }
	          }
	          return;
	        case 264 /* InterfaceDeclaration */:
	        case 265 /* TypeAliasDeclaration */:
	        case 266 /* EnumDeclaration */:
	          return;
	      }
	      if (isTypeNode(node)) {
	        return;
	      }
	      forEachChild(node, markNodeAssignments);
	    }
	    function extendAssignmentPosition(node, declaration) {
	      let pos = node.pos;
	      while (node && node.pos > declaration.pos) {
	        switch (node.kind) {
	          case 243 /* VariableStatement */:
	          case 244 /* ExpressionStatement */:
	          case 245 /* IfStatement */:
	          case 246 /* DoStatement */:
	          case 247 /* WhileStatement */:
	          case 248 /* ForStatement */:
	          case 249 /* ForInStatement */:
	          case 250 /* ForOfStatement */:
	          case 254 /* WithStatement */:
	          case 255 /* SwitchStatement */:
	          case 258 /* TryStatement */:
	          case 263 /* ClassDeclaration */:
	            pos = node.end;
	        }
	        node = node.parent;
	      }
	      return pos;
	    }
	    function isConstantVariable(symbol) {
	      return symbol.flags & 3 /* Variable */ && (getDeclarationNodeFlagsFromSymbol(symbol) & 6 /* Constant */) !== 0;
	    }
	    function isParameterOrMutableLocalVariable(symbol) {
	      const declaration = symbol.valueDeclaration && getRootDeclaration(symbol.valueDeclaration);
	      return !!declaration && (isParameter(declaration) || isVariableDeclaration(declaration) && (isCatchClause(declaration.parent) || isMutableLocalVariableDeclaration(declaration)));
	    }
	    function isMutableLocalVariableDeclaration(declaration) {
	      return !!(declaration.parent.flags & 1 /* Let */) && !(getCombinedModifierFlags(declaration) & 32 /* Export */ || declaration.parent.parent.kind === 243 /* VariableStatement */ && isGlobalSourceFile(declaration.parent.parent.parent));
	    }
	    function parameterInitializerContainsUndefined(declaration) {
	      const links = getNodeLinks(declaration);
	      if (links.parameterInitializerContainsUndefined === void 0) {
	        if (!pushTypeResolution(declaration, 9 /* ParameterInitializerContainsUndefined */)) {
	          reportCircularityError(declaration.symbol);
	          return true;
	        }
	        const containsUndefined = !!hasTypeFacts(checkDeclarationInitializer(declaration, 0 /* Normal */), 16777216 /* IsUndefined */);
	        if (!popTypeResolution()) {
	          reportCircularityError(declaration.symbol);
	          return true;
	        }
	        links.parameterInitializerContainsUndefined = containsUndefined;
	      }
	      return links.parameterInitializerContainsUndefined;
	    }
	    function removeOptionalityFromDeclaredType(declaredType, declaration) {
	      const removeUndefined = strictNullChecks && declaration.kind === 169 /* Parameter */ && declaration.initializer && hasTypeFacts(declaredType, 16777216 /* IsUndefined */) && !parameterInitializerContainsUndefined(declaration);
	      return removeUndefined ? getTypeWithFacts(declaredType, 524288 /* NEUndefined */) : declaredType;
	    }
	    function isConstraintPosition(type, node) {
	      const parent2 = node.parent;
	      return parent2.kind === 211 /* PropertyAccessExpression */ || parent2.kind === 166 /* QualifiedName */ || parent2.kind === 213 /* CallExpression */ && parent2.expression === node || parent2.kind === 212 /* ElementAccessExpression */ && parent2.expression === node && !(someType(type, isGenericTypeWithoutNullableConstraint) && isGenericIndexType(getTypeOfExpression(parent2.argumentExpression)));
	    }
	    function isGenericTypeWithUnionConstraint(type) {
	      return type.flags & 2097152 /* Intersection */ ? some(type.types, isGenericTypeWithUnionConstraint) : !!(type.flags & 465829888 /* Instantiable */ && getBaseConstraintOrType(type).flags & (98304 /* Nullable */ | 1048576 /* Union */));
	    }
	    function isGenericTypeWithoutNullableConstraint(type) {
	      return type.flags & 2097152 /* Intersection */ ? some(type.types, isGenericTypeWithoutNullableConstraint) : !!(type.flags & 465829888 /* Instantiable */ && !maybeTypeOfKind(getBaseConstraintOrType(type), 98304 /* Nullable */));
	    }
	    function hasContextualTypeWithNoGenericTypes(node, checkMode) {
	      const contextualType = (isIdentifier(node) || isPropertyAccessExpression(node) || isElementAccessExpression(node)) && !((isJsxOpeningElement(node.parent) || isJsxSelfClosingElement(node.parent)) && node.parent.tagName === node) && (checkMode && checkMode & 32 /* RestBindingElement */ ? getContextualType2(node, 8 /* SkipBindingPatterns */) : getContextualType2(
	        node,
	        /*contextFlags*/
	        void 0
	      ));
	      return contextualType && !isGenericType(contextualType);
	    }
	    function getNarrowableTypeForReference(type, reference, checkMode) {
	      const substituteConstraints = !(checkMode && checkMode & 2 /* Inferential */) && someType(type, isGenericTypeWithUnionConstraint) && (isConstraintPosition(type, reference) || hasContextualTypeWithNoGenericTypes(reference, checkMode));
	      return substituteConstraints ? mapType(type, getBaseConstraintOrType) : type;
	    }
	    function isExportOrExportExpression(location) {
	      return !!findAncestor(location, (n) => {
	        const parent2 = n.parent;
	        if (parent2 === void 0) {
	          return "quit";
	        }
	        if (isExportAssignment(parent2)) {
	          return parent2.expression === n && isEntityNameExpression(n);
	        }
	        if (isExportSpecifier(parent2)) {
	          return parent2.name === n || parent2.propertyName === n;
	        }
	        return false;
	      });
	    }
	    function markAliasReferenced(symbol, location) {
	      if (!canCollectSymbolAliasAccessabilityData) {
	        return;
	      }
	      if (isNonLocalAlias(
	        symbol,
	        /*excludes*/
	        111551 /* Value */
	      ) && !isInTypeQuery(location)) {
	        const target = resolveAlias(symbol);
	        if (getSymbolFlags(
	          symbol,
	          /*excludeTypeOnlyMeanings*/
	          true
	        ) & (111551 /* Value */ | 1048576 /* ExportValue */)) {
	          if (getIsolatedModules(compilerOptions) || shouldPreserveConstEnums(compilerOptions) && isExportOrExportExpression(location) || !isConstEnumOrConstEnumOnlyModule(getExportSymbolOfValueSymbolIfExported(target))) {
	            markAliasSymbolAsReferenced(symbol);
	          } else {
	            markConstEnumAliasAsReferenced(symbol);
	          }
	        }
	      }
	    }
	    function getNarrowedTypeOfSymbol(symbol, location, checkMode) {
	      var _a;
	      const type = getTypeOfSymbol(symbol, checkMode);
	      const declaration = symbol.valueDeclaration;
	      if (declaration) {
	        if (isBindingElement(declaration) && !declaration.initializer && !declaration.dotDotDotToken && declaration.parent.elements.length >= 2) {
	          const parent2 = declaration.parent.parent;
	          const rootDeclaration = getRootDeclaration(parent2);
	          if (rootDeclaration.kind === 260 /* VariableDeclaration */ && getCombinedNodeFlagsCached(rootDeclaration) & 6 /* Constant */ || rootDeclaration.kind === 169 /* Parameter */) {
	            const links = getNodeLinks(parent2);
	            if (!(links.flags & 4194304 /* InCheckIdentifier */)) {
	              links.flags |= 4194304 /* InCheckIdentifier */;
	              const parentType = getTypeForBindingElementParent(parent2, 0 /* Normal */);
	              const parentTypeConstraint = parentType && mapType(parentType, getBaseConstraintOrType);
	              links.flags &= ~4194304 /* InCheckIdentifier */;
	              if (parentTypeConstraint && parentTypeConstraint.flags & 1048576 /* Union */ && !(rootDeclaration.kind === 169 /* Parameter */ && isSomeSymbolAssigned(rootDeclaration))) {
	                const pattern = declaration.parent;
	                const narrowedType = getFlowTypeOfReference(
	                  pattern,
	                  parentTypeConstraint,
	                  parentTypeConstraint,
	                  /*flowContainer*/
	                  void 0,
	                  location.flowNode
	                );
	                if (narrowedType.flags & 131072 /* Never */) {
	                  return neverType;
	                }
	                return getBindingElementTypeFromParentType(
	                  declaration,
	                  narrowedType,
	                  /*noTupleBoundsCheck*/
	                  true
	                );
	              }
	            }
	          }
	        }
	        if (isParameter(declaration) && !declaration.type && !declaration.initializer && !declaration.dotDotDotToken) {
	          const func = declaration.parent;
	          if (func.parameters.length >= 2 && isContextSensitiveFunctionOrObjectLiteralMethod(func)) {
	            const contextualSignature = getContextualSignature(func);
	            if (contextualSignature && contextualSignature.parameters.length === 1 && signatureHasRestParameter(contextualSignature)) {
	              const restType = getReducedApparentType(instantiateType(getTypeOfSymbol(contextualSignature.parameters[0]), (_a = getInferenceContext(func)) == null ? void 0 : _a.nonFixingMapper));
	              if (restType.flags & 1048576 /* Union */ && everyType(restType, isTupleType) && !some(func.parameters, isSomeSymbolAssigned)) {
	                const narrowedType = getFlowTypeOfReference(
	                  func,
	                  restType,
	                  restType,
	                  /*flowContainer*/
	                  void 0,
	                  location.flowNode
	                );
	                const index = func.parameters.indexOf(declaration) - (getThisParameter(func) ? 1 : 0);
	                return getIndexedAccessType(narrowedType, getNumberLiteralType(index));
	              }
	            }
	          }
	        }
	      }
	      return type;
	    }
	    function checkIdentifier(node, checkMode) {
	      if (isThisInTypeQuery(node)) {
	        return checkThisExpression(node);
	      }
	      const symbol = getResolvedSymbol(node);
	      if (symbol === unknownSymbol) {
	        return errorType;
	      }
	      if (symbol === argumentsSymbol) {
	        if (isInPropertyInitializerOrClassStaticBlock(node)) {
	          error2(node, Diagnostics.arguments_cannot_be_referenced_in_property_initializers);
	          return errorType;
	        }
	        let container = getContainingFunction(node);
	        if (container) {
	          if (languageVersion < 2 /* ES2015 */) {
	            if (container.kind === 219 /* ArrowFunction */) {
	              error2(node, Diagnostics.The_arguments_object_cannot_be_referenced_in_an_arrow_function_in_ES3_and_ES5_Consider_using_a_standard_function_expression);
	            } else if (hasSyntacticModifier(container, 1024 /* Async */)) {
	              error2(node, Diagnostics.The_arguments_object_cannot_be_referenced_in_an_async_function_or_method_in_ES3_and_ES5_Consider_using_a_standard_function_or_method);
	            }
	          }
	          getNodeLinks(container).flags |= 512 /* CaptureArguments */;
	          while (container && isArrowFunction(container)) {
	            container = getContainingFunction(container);
	            if (container) {
	              getNodeLinks(container).flags |= 512 /* CaptureArguments */;
	            }
	          }
	        }
	        return getTypeOfSymbol(symbol);
	      }
	      if (shouldMarkIdentifierAliasReferenced(node)) {
	        markAliasReferenced(symbol, node);
	      }
	      const localOrExportSymbol = getExportSymbolOfValueSymbolIfExported(symbol);
	      const targetSymbol = resolveAliasWithDeprecationCheck(localOrExportSymbol, node);
	      if (isDeprecatedSymbol(targetSymbol) && isUncalledFunctionReference(node, targetSymbol) && targetSymbol.declarations) {
	        addDeprecatedSuggestion(node, targetSymbol.declarations, node.escapedText);
	      }
	      let declaration = localOrExportSymbol.valueDeclaration;
	      if (declaration && localOrExportSymbol.flags & 32 /* Class */) {
	        if (isClassLike(declaration) && declaration.name !== node) {
	          let container = getThisContainer(
	            node,
	            /*includeArrowFunctions*/
	            false,
	            /*includeClassComputedPropertyName*/
	            false
	          );
	          while (container.kind !== 312 /* SourceFile */ && container.parent !== declaration) {
	            container = getThisContainer(
	              container,
	              /*includeArrowFunctions*/
	              false,
	              /*includeClassComputedPropertyName*/
	              false
	            );
	          }
	          if (container.kind !== 312 /* SourceFile */) {
	            getNodeLinks(declaration).flags |= 262144 /* ContainsConstructorReference */;
	            getNodeLinks(container).flags |= 262144 /* ContainsConstructorReference */;
	            getNodeLinks(node).flags |= 536870912 /* ConstructorReference */;
	          }
	        }
	      }
	      checkNestedBlockScopedBinding(node, symbol);
	      let type = getNarrowedTypeOfSymbol(localOrExportSymbol, node, checkMode);
	      const assignmentKind = getAssignmentTargetKind(node);
	      if (assignmentKind) {
	        if (!(localOrExportSymbol.flags & 3 /* Variable */) && !(isInJSFile(node) && localOrExportSymbol.flags & 512 /* ValueModule */)) {
	          const assignmentError = localOrExportSymbol.flags & 384 /* Enum */ ? Diagnostics.Cannot_assign_to_0_because_it_is_an_enum : localOrExportSymbol.flags & 32 /* Class */ ? Diagnostics.Cannot_assign_to_0_because_it_is_a_class : localOrExportSymbol.flags & 1536 /* Module */ ? Diagnostics.Cannot_assign_to_0_because_it_is_a_namespace : localOrExportSymbol.flags & 16 /* Function */ ? Diagnostics.Cannot_assign_to_0_because_it_is_a_function : localOrExportSymbol.flags & 2097152 /* Alias */ ? Diagnostics.Cannot_assign_to_0_because_it_is_an_import : Diagnostics.Cannot_assign_to_0_because_it_is_not_a_variable;
	          error2(node, assignmentError, symbolToString(symbol));
	          return errorType;
	        }
	        if (isReadonlySymbol(localOrExportSymbol)) {
	          if (localOrExportSymbol.flags & 3 /* Variable */) {
	            error2(node, Diagnostics.Cannot_assign_to_0_because_it_is_a_constant, symbolToString(symbol));
	          } else {
	            error2(node, Diagnostics.Cannot_assign_to_0_because_it_is_a_read_only_property, symbolToString(symbol));
	          }
	          return errorType;
	        }
	      }
	      const isAlias = localOrExportSymbol.flags & 2097152 /* Alias */;
	      if (localOrExportSymbol.flags & 3 /* Variable */) {
	        if (assignmentKind === 1 /* Definite */) {
	          return isInCompoundLikeAssignment(node) ? getBaseTypeOfLiteralType(type) : type;
	        }
	      } else if (isAlias) {
	        declaration = getDeclarationOfAliasSymbol(symbol);
	      } else {
	        return type;
	      }
	      if (!declaration) {
	        return type;
	      }
	      type = getNarrowableTypeForReference(type, node, checkMode);
	      const isParameter2 = getRootDeclaration(declaration).kind === 169 /* Parameter */;
	      const declarationContainer = getControlFlowContainer(declaration);
	      let flowContainer = getControlFlowContainer(node);
	      const isOuterVariable = flowContainer !== declarationContainer;
	      const isSpreadDestructuringAssignmentTarget = node.parent && node.parent.parent && isSpreadAssignment(node.parent) && isDestructuringAssignmentTarget(node.parent.parent);
	      const isModuleExports = symbol.flags & 134217728 /* ModuleExports */;
	      const typeIsAutomatic = type === autoType || type === autoArrayType;
	      const isAutomaticTypeInNonNull = typeIsAutomatic && node.parent.kind === 235 /* NonNullExpression */;
	      while (flowContainer !== declarationContainer && (flowContainer.kind === 218 /* FunctionExpression */ || flowContainer.kind === 219 /* ArrowFunction */ || isObjectLiteralOrClassExpressionMethodOrAccessor(flowContainer)) && (isConstantVariable(localOrExportSymbol) && type !== autoArrayType || isParameterOrMutableLocalVariable(localOrExportSymbol) && isPastLastAssignment(localOrExportSymbol, node))) {
	        flowContainer = getControlFlowContainer(flowContainer);
	      }
	      const assumeInitialized = isParameter2 || isAlias || isOuterVariable || isSpreadDestructuringAssignmentTarget || isModuleExports || isSameScopedBindingElement(node, declaration) || type !== autoType && type !== autoArrayType && (!strictNullChecks || (type.flags & (3 /* AnyOrUnknown */ | 16384 /* Void */)) !== 0 || isInTypeQuery(node) || isInAmbientOrTypeNode(node) || node.parent.kind === 281 /* ExportSpecifier */) || node.parent.kind === 235 /* NonNullExpression */ || declaration.kind === 260 /* VariableDeclaration */ && declaration.exclamationToken || declaration.flags & 33554432 /* Ambient */;
	      const initialType = isAutomaticTypeInNonNull ? undefinedType : assumeInitialized ? isParameter2 ? removeOptionalityFromDeclaredType(type, declaration) : type : typeIsAutomatic ? undefinedType : getOptionalType(type);
	      const flowType = isAutomaticTypeInNonNull ? getNonNullableType(getFlowTypeOfReference(node, type, initialType, flowContainer)) : getFlowTypeOfReference(node, type, initialType, flowContainer);
	      if (!isEvolvingArrayOperationTarget(node) && (type === autoType || type === autoArrayType)) {
	        if (flowType === autoType || flowType === autoArrayType) {
	          if (noImplicitAny) {
	            error2(getNameOfDeclaration(declaration), Diagnostics.Variable_0_implicitly_has_type_1_in_some_locations_where_its_type_cannot_be_determined, symbolToString(symbol), typeToString(flowType));
	            error2(node, Diagnostics.Variable_0_implicitly_has_an_1_type, symbolToString(symbol), typeToString(flowType));
	          }
	          return convertAutoToAny(flowType);
	        }
	      } else if (!assumeInitialized && !containsUndefinedType(type) && containsUndefinedType(flowType)) {
	        error2(node, Diagnostics.Variable_0_is_used_before_being_assigned, symbolToString(symbol));
	        return type;
	      }
	      return assignmentKind ? getBaseTypeOfLiteralType(flowType) : flowType;
	    }
	    function isSameScopedBindingElement(node, declaration) {
	      if (isBindingElement(declaration)) {
	        const bindingElement = findAncestor(node, isBindingElement);
	        return bindingElement && getRootDeclaration(bindingElement) === getRootDeclaration(declaration);
	      }
	    }
	    function shouldMarkIdentifierAliasReferenced(node) {
	      var _a;
	      const parent2 = node.parent;
	      if (parent2) {
	        if (isPropertyAccessExpression(parent2) && parent2.expression === node) {
	          return false;
	        }
	        if (isExportSpecifier(parent2) && parent2.isTypeOnly) {
	          return false;
	        }
	        const greatGrandparent = (_a = parent2.parent) == null ? void 0 : _a.parent;
	        if (greatGrandparent && isExportDeclaration(greatGrandparent) && greatGrandparent.isTypeOnly) {
	          return false;
	        }
	      }
	      return true;
	    }
	    function isInsideFunctionOrInstancePropertyInitializer(node, threshold) {
	      return !!findAncestor(node, (n) => n === threshold ? "quit" : isFunctionLike(n) || n.parent && isPropertyDeclaration(n.parent) && !hasStaticModifier(n.parent) && n.parent.initializer === n);
	    }
	    function getPartOfForStatementContainingNode(node, container) {
	      return findAncestor(node, (n) => n === container ? "quit" : n === container.initializer || n === container.condition || n === container.incrementor || n === container.statement);
	    }
	    function getEnclosingIterationStatement(node) {
	      return findAncestor(node, (n) => !n || nodeStartsNewLexicalEnvironment(n) ? "quit" : isIterationStatement(
	        n,
	        /*lookInLabeledStatements*/
	        false
	      ));
	    }
	    function checkNestedBlockScopedBinding(node, symbol) {
	      if (languageVersion >= 2 /* ES2015 */ || (symbol.flags & (2 /* BlockScopedVariable */ | 32 /* Class */)) === 0 || !symbol.valueDeclaration || isSourceFile(symbol.valueDeclaration) || symbol.valueDeclaration.parent.kind === 299 /* CatchClause */) {
	        return;
	      }
	      const container = getEnclosingBlockScopeContainer(symbol.valueDeclaration);
	      const isCaptured = isInsideFunctionOrInstancePropertyInitializer(node, container);
	      const enclosingIterationStatement = getEnclosingIterationStatement(container);
	      if (enclosingIterationStatement) {
	        if (isCaptured) {
	          let capturesBlockScopeBindingInLoopBody = true;
	          if (isForStatement(container)) {
	            const varDeclList = getAncestor(symbol.valueDeclaration, 261 /* VariableDeclarationList */);
	            if (varDeclList && varDeclList.parent === container) {
	              const part = getPartOfForStatementContainingNode(node.parent, container);
	              if (part) {
	                const links = getNodeLinks(part);
	                links.flags |= 8192 /* ContainsCapturedBlockScopeBinding */;
	                const capturedBindings = links.capturedBlockScopeBindings || (links.capturedBlockScopeBindings = []);
	                pushIfUnique(capturedBindings, symbol);
	                if (part === container.initializer) {
	                  capturesBlockScopeBindingInLoopBody = false;
	                }
	              }
	            }
	          }
	          if (capturesBlockScopeBindingInLoopBody) {
	            getNodeLinks(enclosingIterationStatement).flags |= 4096 /* LoopWithCapturedBlockScopedBinding */;
	          }
	        }
	        if (isForStatement(container)) {
	          const varDeclList = getAncestor(symbol.valueDeclaration, 261 /* VariableDeclarationList */);
	          if (varDeclList && varDeclList.parent === container && isAssignedInBodyOfForStatement(node, container)) {
	            getNodeLinks(symbol.valueDeclaration).flags |= 65536 /* NeedsLoopOutParameter */;
	          }
	        }
	        getNodeLinks(symbol.valueDeclaration).flags |= 32768 /* BlockScopedBindingInLoop */;
	      }
	      if (isCaptured) {
	        getNodeLinks(symbol.valueDeclaration).flags |= 16384 /* CapturedBlockScopedBinding */;
	      }
	    }
	    function isBindingCapturedByNode(node, decl) {
	      const links = getNodeLinks(node);
	      return !!links && contains(links.capturedBlockScopeBindings, getSymbolOfDeclaration(decl));
	    }
	    function isAssignedInBodyOfForStatement(node, container) {
	      let current = node;
	      while (current.parent.kind === 217 /* ParenthesizedExpression */) {
	        current = current.parent;
	      }
	      let isAssigned = false;
	      if (isAssignmentTarget(current)) {
	        isAssigned = true;
	      } else if (current.parent.kind === 224 /* PrefixUnaryExpression */ || current.parent.kind === 225 /* PostfixUnaryExpression */) {
	        const expr = current.parent;
	        isAssigned = expr.operator === 46 /* PlusPlusToken */ || expr.operator === 47 /* MinusMinusToken */;
	      }
	      if (!isAssigned) {
	        return false;
	      }
	      return !!findAncestor(current, (n) => n === container ? "quit" : n === container.statement);
	    }
	    function captureLexicalThis(node, container) {
	      getNodeLinks(node).flags |= 2 /* LexicalThis */;
	      if (container.kind === 172 /* PropertyDeclaration */ || container.kind === 176 /* Constructor */) {
	        const classNode = container.parent;
	        getNodeLinks(classNode).flags |= 4 /* CaptureThis */;
	      } else {
	        getNodeLinks(container).flags |= 4 /* CaptureThis */;
	      }
	    }
	    function findFirstSuperCall(node) {
	      return isSuperCall(node) ? node : isFunctionLike(node) ? void 0 : forEachChild(node, findFirstSuperCall);
	    }
	    function classDeclarationExtendsNull(classDecl) {
	      const classSymbol = getSymbolOfDeclaration(classDecl);
	      const classInstanceType = getDeclaredTypeOfSymbol(classSymbol);
	      const baseConstructorType = getBaseConstructorTypeOfClass(classInstanceType);
	      return baseConstructorType === nullWideningType;
	    }
	    function checkThisBeforeSuper(node, container, diagnosticMessage) {
	      const containingClassDecl = container.parent;
	      const baseTypeNode = getClassExtendsHeritageElement(containingClassDecl);
	      if (baseTypeNode && !classDeclarationExtendsNull(containingClassDecl)) {
	        if (canHaveFlowNode(node) && node.flowNode && !isPostSuperFlowNode(
	          node.flowNode,
	          /*noCacheCheck*/
	          false
	        )) {
	          error2(node, diagnosticMessage);
	        }
	      }
	    }
	    function checkThisInStaticClassFieldInitializerInDecoratedClass(thisExpression, container) {
	      if (isPropertyDeclaration(container) && hasStaticModifier(container) && legacyDecorators && container.initializer && textRangeContainsPositionInclusive(container.initializer, thisExpression.pos) && hasDecorators(container.parent)) {
	        error2(thisExpression, Diagnostics.Cannot_use_this_in_a_static_property_initializer_of_a_decorated_class);
	      }
	    }
	    function checkThisExpression(node) {
	      const isNodeInTypeQuery = isInTypeQuery(node);
	      let container = getThisContainer(
	        node,
	        /*includeArrowFunctions*/
	        true,
	        /*includeClassComputedPropertyName*/
	        true
	      );
	      let capturedByArrowFunction = false;
	      let thisInComputedPropertyName = false;
	      if (container.kind === 176 /* Constructor */) {
	        checkThisBeforeSuper(node, container, Diagnostics.super_must_be_called_before_accessing_this_in_the_constructor_of_a_derived_class);
	      }
	      while (true) {
	        if (container.kind === 219 /* ArrowFunction */) {
	          container = getThisContainer(
	            container,
	            /*includeArrowFunctions*/
	            false,
	            !thisInComputedPropertyName
	          );
	          capturedByArrowFunction = true;
	        }
	        if (container.kind === 167 /* ComputedPropertyName */) {
	          container = getThisContainer(
	            container,
	            !capturedByArrowFunction,
	            /*includeClassComputedPropertyName*/
	            false
	          );
	          thisInComputedPropertyName = true;
	          continue;
	        }
	        break;
	      }
	      checkThisInStaticClassFieldInitializerInDecoratedClass(node, container);
	      if (thisInComputedPropertyName) {
	        error2(node, Diagnostics.this_cannot_be_referenced_in_a_computed_property_name);
	      } else {
	        switch (container.kind) {
	          case 267 /* ModuleDeclaration */:
	            error2(node, Diagnostics.this_cannot_be_referenced_in_a_module_or_namespace_body);
	            break;
	          case 266 /* EnumDeclaration */:
	            error2(node, Diagnostics.this_cannot_be_referenced_in_current_location);
	            break;
	          case 176 /* Constructor */:
	            if (isInConstructorArgumentInitializer(node, container)) {
	              error2(node, Diagnostics.this_cannot_be_referenced_in_constructor_arguments);
	            }
	            break;
	        }
	      }
	      if (!isNodeInTypeQuery && capturedByArrowFunction && languageVersion < 2 /* ES2015 */) {
	        captureLexicalThis(node, container);
	      }
	      const type = tryGetThisTypeAt(
	        node,
	        /*includeGlobalThis*/
	        true,
	        container
	      );
	      if (noImplicitThis) {
	        const globalThisType2 = getTypeOfSymbol(globalThisSymbol);
	        if (type === globalThisType2 && capturedByArrowFunction) {
	          error2(node, Diagnostics.The_containing_arrow_function_captures_the_global_value_of_this);
	        } else if (!type) {
	          const diag2 = error2(node, Diagnostics.this_implicitly_has_type_any_because_it_does_not_have_a_type_annotation);
	          if (!isSourceFile(container)) {
	            const outsideThis = tryGetThisTypeAt(container);
	            if (outsideThis && outsideThis !== globalThisType2) {
	              addRelatedInfo(diag2, createDiagnosticForNode(container, Diagnostics.An_outer_value_of_this_is_shadowed_by_this_container));
	            }
	          }
	        }
	      }
	      return type || anyType;
	    }
	    function tryGetThisTypeAt(node, includeGlobalThis = true, container = getThisContainer(
	      node,
	      /*includeArrowFunctions*/
	      false,
	      /*includeClassComputedPropertyName*/
	      false
	    )) {
	      const isInJS = isInJSFile(node);
	      if (isFunctionLike(container) && (!isInParameterInitializerBeforeContainingFunction(node) || getThisParameter(container))) {
	        let thisType = getThisTypeOfDeclaration(container) || isInJS && getTypeForThisExpressionFromJSDoc(container);
	        if (!thisType) {
	          const className = getClassNameFromPrototypeMethod(container);
	          if (isInJS && className) {
	            const classSymbol = checkExpression(className).symbol;
	            if (classSymbol && classSymbol.members && classSymbol.flags & 16 /* Function */) {
	              thisType = getDeclaredTypeOfSymbol(classSymbol).thisType;
	            }
	          } else if (isJSConstructor(container)) {
	            thisType = getDeclaredTypeOfSymbol(getMergedSymbol(container.symbol)).thisType;
	          }
	          thisType || (thisType = getContextualThisParameterType(container));
	        }
	        if (thisType) {
	          return getFlowTypeOfReference(node, thisType);
	        }
	      }
	      if (isClassLike(container.parent)) {
	        const symbol = getSymbolOfDeclaration(container.parent);
	        const type = isStatic(container) ? getTypeOfSymbol(symbol) : getDeclaredTypeOfSymbol(symbol).thisType;
	        return getFlowTypeOfReference(node, type);
	      }
	      if (isSourceFile(container)) {
	        if (container.commonJsModuleIndicator) {
	          const fileSymbol = getSymbolOfDeclaration(container);
	          return fileSymbol && getTypeOfSymbol(fileSymbol);
	        } else if (container.externalModuleIndicator) {
	          return undefinedType;
	        } else if (includeGlobalThis) {
	          return getTypeOfSymbol(globalThisSymbol);
	        }
	      }
	    }
	    function getExplicitThisType(node) {
	      const container = getThisContainer(
	        node,
	        /*includeArrowFunctions*/
	        false,
	        /*includeClassComputedPropertyName*/
	        false
	      );
	      if (isFunctionLike(container)) {
	        const signature = getSignatureFromDeclaration(container);
	        if (signature.thisParameter) {
	          return getExplicitTypeOfSymbol(signature.thisParameter);
	        }
	      }
	      if (isClassLike(container.parent)) {
	        const symbol = getSymbolOfDeclaration(container.parent);
	        return isStatic(container) ? getTypeOfSymbol(symbol) : getDeclaredTypeOfSymbol(symbol).thisType;
	      }
	    }
	    function getClassNameFromPrototypeMethod(container) {
	      if (container.kind === 218 /* FunctionExpression */ && isBinaryExpression(container.parent) && getAssignmentDeclarationKind(container.parent) === 3 /* PrototypeProperty */) {
	        return container.parent.left.expression.expression;
	      } else if (container.kind === 174 /* MethodDeclaration */ && container.parent.kind === 210 /* ObjectLiteralExpression */ && isBinaryExpression(container.parent.parent) && getAssignmentDeclarationKind(container.parent.parent) === 6 /* Prototype */) {
	        return container.parent.parent.left.expression;
	      } else if (container.kind === 218 /* FunctionExpression */ && container.parent.kind === 303 /* PropertyAssignment */ && container.parent.parent.kind === 210 /* ObjectLiteralExpression */ && isBinaryExpression(container.parent.parent.parent) && getAssignmentDeclarationKind(container.parent.parent.parent) === 6 /* Prototype */) {
	        return container.parent.parent.parent.left.expression;
	      } else if (container.kind === 218 /* FunctionExpression */ && isPropertyAssignment(container.parent) && isIdentifier(container.parent.name) && (container.parent.name.escapedText === "value" || container.parent.name.escapedText === "get" || container.parent.name.escapedText === "set") && isObjectLiteralExpression(container.parent.parent) && isCallExpression(container.parent.parent.parent) && container.parent.parent.parent.arguments[2] === container.parent.parent && getAssignmentDeclarationKind(container.parent.parent.parent) === 9 /* ObjectDefinePrototypeProperty */) {
	        return container.parent.parent.parent.arguments[0].expression;
	      } else if (isMethodDeclaration(container) && isIdentifier(container.name) && (container.name.escapedText === "value" || container.name.escapedText === "get" || container.name.escapedText === "set") && isObjectLiteralExpression(container.parent) && isCallExpression(container.parent.parent) && container.parent.parent.arguments[2] === container.parent && getAssignmentDeclarationKind(container.parent.parent) === 9 /* ObjectDefinePrototypeProperty */) {
	        return container.parent.parent.arguments[0].expression;
	      }
	    }
	    function getTypeForThisExpressionFromJSDoc(node) {
	      const thisTag = getJSDocThisTag(node);
	      if (thisTag && thisTag.typeExpression) {
	        return getTypeFromTypeNode(thisTag.typeExpression);
	      }
	      const signature = getSignatureOfTypeTag(node);
	      if (signature) {
	        return getThisTypeOfSignature(signature);
	      }
	    }
	    function isInConstructorArgumentInitializer(node, constructorDecl) {
	      return !!findAncestor(node, (n) => isFunctionLikeDeclaration(n) ? "quit" : n.kind === 169 /* Parameter */ && n.parent === constructorDecl);
	    }
	    function checkSuperExpression(node) {
	      const isCallExpression2 = node.parent.kind === 213 /* CallExpression */ && node.parent.expression === node;
	      const immediateContainer = getSuperContainer(
	        node,
	        /*stopOnFunctions*/
	        true
	      );
	      let container = immediateContainer;
	      let needToCaptureLexicalThis = false;
	      let inAsyncFunction = false;
	      if (!isCallExpression2) {
	        while (container && container.kind === 219 /* ArrowFunction */) {
	          if (hasSyntacticModifier(container, 1024 /* Async */))
	            inAsyncFunction = true;
	          container = getSuperContainer(
	            container,
	            /*stopOnFunctions*/
	            true
	          );
	          needToCaptureLexicalThis = languageVersion < 2 /* ES2015 */;
	        }
	        if (container && hasSyntacticModifier(container, 1024 /* Async */))
	          inAsyncFunction = true;
	      }
	      let nodeCheckFlag = 0;
	      if (!container || !isLegalUsageOfSuperExpression(container)) {
	        const current = findAncestor(node, (n) => n === container ? "quit" : n.kind === 167 /* ComputedPropertyName */);
	        if (current && current.kind === 167 /* ComputedPropertyName */) {
	          error2(node, Diagnostics.super_cannot_be_referenced_in_a_computed_property_name);
	        } else if (isCallExpression2) {
	          error2(node, Diagnostics.Super_calls_are_not_permitted_outside_constructors_or_in_nested_functions_inside_constructors);
	        } else if (!container || !container.parent || !(isClassLike(container.parent) || container.parent.kind === 210 /* ObjectLiteralExpression */)) {
	          error2(node, Diagnostics.super_can_only_be_referenced_in_members_of_derived_classes_or_object_literal_expressions);
	        } else {
	          error2(node, Diagnostics.super_property_access_is_permitted_only_in_a_constructor_member_function_or_member_accessor_of_a_derived_class);
	        }
	        return errorType;
	      }
	      if (!isCallExpression2 && immediateContainer.kind === 176 /* Constructor */) {
	        checkThisBeforeSuper(node, container, Diagnostics.super_must_be_called_before_accessing_a_property_of_super_in_the_constructor_of_a_derived_class);
	      }
	      if (isStatic(container) || isCallExpression2) {
	        nodeCheckFlag = 32 /* SuperStatic */;
	        if (!isCallExpression2 && languageVersion >= 2 /* ES2015 */ && languageVersion <= 8 /* ES2021 */ && (isPropertyDeclaration(container) || isClassStaticBlockDeclaration(container))) {
	          forEachEnclosingBlockScopeContainer(node.parent, (current) => {
	            if (!isSourceFile(current) || isExternalOrCommonJsModule(current)) {
	              getNodeLinks(current).flags |= 2097152 /* ContainsSuperPropertyInStaticInitializer */;
	            }
	          });
	        }
	      } else {
	        nodeCheckFlag = 16 /* SuperInstance */;
	      }
	      getNodeLinks(node).flags |= nodeCheckFlag;
	      if (container.kind === 174 /* MethodDeclaration */ && inAsyncFunction) {
	        if (isSuperProperty(node.parent) && isAssignmentTarget(node.parent)) {
	          getNodeLinks(container).flags |= 256 /* MethodWithSuperPropertyAssignmentInAsync */;
	        } else {
	          getNodeLinks(container).flags |= 128 /* MethodWithSuperPropertyAccessInAsync */;
	        }
	      }
	      if (needToCaptureLexicalThis) {
	        captureLexicalThis(node.parent, container);
	      }
	      if (container.parent.kind === 210 /* ObjectLiteralExpression */) {
	        if (languageVersion < 2 /* ES2015 */) {
	          error2(node, Diagnostics.super_is_only_allowed_in_members_of_object_literal_expressions_when_option_target_is_ES2015_or_higher);
	          return errorType;
	        } else {
	          return anyType;
	        }
	      }
	      const classLikeDeclaration = container.parent;
	      if (!getClassExtendsHeritageElement(classLikeDeclaration)) {
	        error2(node, Diagnostics.super_can_only_be_referenced_in_a_derived_class);
	        return errorType;
	      }
	      if (classDeclarationExtendsNull(classLikeDeclaration)) {
	        return isCallExpression2 ? errorType : nullWideningType;
	      }
	      const classType = getDeclaredTypeOfSymbol(getSymbolOfDeclaration(classLikeDeclaration));
	      const baseClassType = classType && getBaseTypes(classType)[0];
	      if (!baseClassType) {
	        return errorType;
	      }
	      if (container.kind === 176 /* Constructor */ && isInConstructorArgumentInitializer(node, container)) {
	        error2(node, Diagnostics.super_cannot_be_referenced_in_constructor_arguments);
	        return errorType;
	      }
	      return nodeCheckFlag === 32 /* SuperStatic */ ? getBaseConstructorTypeOfClass(classType) : getTypeWithThisArgument(baseClassType, classType.thisType);
	      function isLegalUsageOfSuperExpression(container2) {
	        if (isCallExpression2) {
	          return container2.kind === 176 /* Constructor */;
	        } else {
	          if (isClassLike(container2.parent) || container2.parent.kind === 210 /* ObjectLiteralExpression */) {
	            if (isStatic(container2)) {
	              return container2.kind === 174 /* MethodDeclaration */ || container2.kind === 173 /* MethodSignature */ || container2.kind === 177 /* GetAccessor */ || container2.kind === 178 /* SetAccessor */ || container2.kind === 172 /* PropertyDeclaration */ || container2.kind === 175 /* ClassStaticBlockDeclaration */;
	            } else {
	              return container2.kind === 174 /* MethodDeclaration */ || container2.kind === 173 /* MethodSignature */ || container2.kind === 177 /* GetAccessor */ || container2.kind === 178 /* SetAccessor */ || container2.kind === 172 /* PropertyDeclaration */ || container2.kind === 171 /* PropertySignature */ || container2.kind === 176 /* Constructor */;
	            }
	          }
	        }
	        return false;
	      }
	    }
	    function getContainingObjectLiteral(func) {
	      return (func.kind === 174 /* MethodDeclaration */ || func.kind === 177 /* GetAccessor */ || func.kind === 178 /* SetAccessor */) && func.parent.kind === 210 /* ObjectLiteralExpression */ ? func.parent : func.kind === 218 /* FunctionExpression */ && func.parent.kind === 303 /* PropertyAssignment */ ? func.parent.parent : void 0;
	    }
	    function getThisTypeArgument(type) {
	      return getObjectFlags(type) & 4 /* Reference */ && type.target === globalThisType ? getTypeArguments(type)[0] : void 0;
	    }
	    function getThisTypeFromContextualType(type) {
	      return mapType(type, (t) => {
	        return t.flags & 2097152 /* Intersection */ ? forEach(t.types, getThisTypeArgument) : getThisTypeArgument(t);
	      });
	    }
	    function getThisTypeOfObjectLiteralFromContextualType(containingLiteral, contextualType) {
	      let literal = containingLiteral;
	      let type = contextualType;
	      while (type) {
	        const thisType = getThisTypeFromContextualType(type);
	        if (thisType) {
	          return thisType;
	        }
	        if (literal.parent.kind !== 303 /* PropertyAssignment */) {
	          break;
	        }
	        literal = literal.parent.parent;
	        type = getApparentTypeOfContextualType(
	          literal,
	          /*contextFlags*/
	          void 0
	        );
	      }
	    }
	    function getContextualThisParameterType(func) {
	      if (func.kind === 219 /* ArrowFunction */) {
	        return void 0;
	      }
	      if (isContextSensitiveFunctionOrObjectLiteralMethod(func)) {
	        const contextualSignature = getContextualSignature(func);
	        if (contextualSignature) {
	          const thisParameter = contextualSignature.thisParameter;
	          if (thisParameter) {
	            return getTypeOfSymbol(thisParameter);
	          }
	        }
	      }
	      const inJs = isInJSFile(func);
	      if (noImplicitThis || inJs) {
	        const containingLiteral = getContainingObjectLiteral(func);
	        if (containingLiteral) {
	          const contextualType = getApparentTypeOfContextualType(
	            containingLiteral,
	            /*contextFlags*/
	            void 0
	          );
	          const thisType = getThisTypeOfObjectLiteralFromContextualType(containingLiteral, contextualType);
	          if (thisType) {
	            return instantiateType(thisType, getMapperFromContext(getInferenceContext(containingLiteral)));
	          }
	          return getWidenedType(contextualType ? getNonNullableType(contextualType) : checkExpressionCached(containingLiteral));
	        }
	        const parent2 = walkUpParenthesizedExpressions(func.parent);
	        if (isAssignmentExpression(parent2)) {
	          const target = parent2.left;
	          if (isAccessExpression(target)) {
	            const { expression } = target;
	            if (inJs && isIdentifier(expression)) {
	              const sourceFile = getSourceFileOfNode(parent2);
	              if (sourceFile.commonJsModuleIndicator && getResolvedSymbol(expression) === sourceFile.symbol) {
	                return void 0;
	              }
	            }
	            return getWidenedType(checkExpressionCached(expression));
	          }
	        }
	      }
	      return void 0;
	    }
	    function getContextuallyTypedParameterType(parameter) {
	      const func = parameter.parent;
	      if (!isContextSensitiveFunctionOrObjectLiteralMethod(func)) {
	        return void 0;
	      }
	      const iife = getImmediatelyInvokedFunctionExpression(func);
	      if (iife && iife.arguments) {
	        const args = getEffectiveCallArguments(iife);
	        const indexOfParameter = func.parameters.indexOf(parameter);
	        if (parameter.dotDotDotToken) {
	          return getSpreadArgumentType(
	            args,
	            indexOfParameter,
	            args.length,
	            anyType,
	            /*context*/
	            void 0,
	            0 /* Normal */
	          );
	        }
	        const links = getNodeLinks(iife);
	        const cached = links.resolvedSignature;
	        links.resolvedSignature = anySignature;
	        const type = indexOfParameter < args.length ? getWidenedLiteralType(checkExpression(args[indexOfParameter])) : parameter.initializer ? void 0 : undefinedWideningType;
	        links.resolvedSignature = cached;
	        return type;
	      }
	      const contextualSignature = getContextualSignature(func);
	      if (contextualSignature) {
	        const index = func.parameters.indexOf(parameter) - (getThisParameter(func) ? 1 : 0);
	        return parameter.dotDotDotToken && lastOrUndefined(func.parameters) === parameter ? getRestTypeAtPosition(contextualSignature, index) : tryGetTypeAtPosition(contextualSignature, index);
	      }
	    }
	    function getContextualTypeForVariableLikeDeclaration(declaration, contextFlags) {
	      const typeNode = getEffectiveTypeAnnotationNode(declaration) || (isInJSFile(declaration) ? tryGetJSDocSatisfiesTypeNode(declaration) : void 0);
	      if (typeNode) {
	        return getTypeFromTypeNode(typeNode);
	      }
	      switch (declaration.kind) {
	        case 169 /* Parameter */:
	          return getContextuallyTypedParameterType(declaration);
	        case 208 /* BindingElement */:
	          return getContextualTypeForBindingElement(declaration, contextFlags);
	        case 172 /* PropertyDeclaration */:
	          if (isStatic(declaration)) {
	            return getContextualTypeForStaticPropertyDeclaration(declaration, contextFlags);
	          }
	      }
	    }
	    function getContextualTypeForBindingElement(declaration, contextFlags) {
	      const parent2 = declaration.parent.parent;
	      const name = declaration.propertyName || declaration.name;
	      const parentType = getContextualTypeForVariableLikeDeclaration(parent2, contextFlags) || parent2.kind !== 208 /* BindingElement */ && parent2.initializer && checkDeclarationInitializer(parent2, declaration.dotDotDotToken ? 32 /* RestBindingElement */ : 0 /* Normal */);
	      if (!parentType || isBindingPattern(name) || isComputedNonLiteralName(name))
	        return void 0;
	      if (parent2.name.kind === 207 /* ArrayBindingPattern */) {
	        const index = indexOfNode(declaration.parent.elements, declaration);
	        if (index < 0)
	          return void 0;
	        return getContextualTypeForElementExpression(parentType, index);
	      }
	      const nameType = getLiteralTypeFromPropertyName(name);
	      if (isTypeUsableAsPropertyName(nameType)) {
	        const text = getPropertyNameFromType(nameType);
	        return getTypeOfPropertyOfType(parentType, text);
	      }
	    }
	    function getContextualTypeForStaticPropertyDeclaration(declaration, contextFlags) {
	      const parentType = isExpression(declaration.parent) && getContextualType2(declaration.parent, contextFlags);
	      if (!parentType)
	        return void 0;
	      return getTypeOfPropertyOfContextualType(parentType, getSymbolOfDeclaration(declaration).escapedName);
	    }
	    function getContextualTypeForInitializerExpression(node, contextFlags) {
	      const declaration = node.parent;
	      if (hasInitializer(declaration) && node === declaration.initializer) {
	        const result = getContextualTypeForVariableLikeDeclaration(declaration, contextFlags);
	        if (result) {
	          return result;
	        }
	        if (!(contextFlags & 8 /* SkipBindingPatterns */) && isBindingPattern(declaration.name) && declaration.name.elements.length > 0) {
	          return getTypeFromBindingPattern(
	            declaration.name,
	            /*includePatternInType*/
	            true,
	            /*reportErrors*/
	            false
	          );
	        }
	      }
	      return void 0;
	    }
	    function getContextualTypeForReturnExpression(node, contextFlags) {
	      const func = getContainingFunction(node);
	      if (func) {
	        let contextualReturnType = getContextualReturnType(func, contextFlags);
	        if (contextualReturnType) {
	          const functionFlags = getFunctionFlags(func);
	          if (functionFlags & 1 /* Generator */) {
	            const isAsyncGenerator = (functionFlags & 2 /* Async */) !== 0;
	            if (contextualReturnType.flags & 1048576 /* Union */) {
	              contextualReturnType = filterType(contextualReturnType, (type) => !!getIterationTypeOfGeneratorFunctionReturnType(1 /* Return */, type, isAsyncGenerator));
	            }
	            const iterationReturnType = getIterationTypeOfGeneratorFunctionReturnType(1 /* Return */, contextualReturnType, (functionFlags & 2 /* Async */) !== 0);
	            if (!iterationReturnType) {
	              return void 0;
	            }
	            contextualReturnType = iterationReturnType;
	          }
	          if (functionFlags & 2 /* Async */) {
	            const contextualAwaitedType = mapType(contextualReturnType, getAwaitedTypeNoAlias);
	            return contextualAwaitedType && getUnionType([contextualAwaitedType, createPromiseLikeType(contextualAwaitedType)]);
	          }
	          return contextualReturnType;
	        }
	      }
	      return void 0;
	    }
	    function getContextualTypeForAwaitOperand(node, contextFlags) {
	      const contextualType = getContextualType2(node, contextFlags);
	      if (contextualType) {
	        const contextualAwaitedType = getAwaitedTypeNoAlias(contextualType);
	        return contextualAwaitedType && getUnionType([contextualAwaitedType, createPromiseLikeType(contextualAwaitedType)]);
	      }
	      return void 0;
	    }
	    function getContextualTypeForYieldOperand(node, contextFlags) {
	      const func = getContainingFunction(node);
	      if (func) {
	        const functionFlags = getFunctionFlags(func);
	        let contextualReturnType = getContextualReturnType(func, contextFlags);
	        if (contextualReturnType) {
	          const isAsyncGenerator = (functionFlags & 2 /* Async */) !== 0;
	          if (!node.asteriskToken && contextualReturnType.flags & 1048576 /* Union */) {
	            contextualReturnType = filterType(contextualReturnType, (type) => !!getIterationTypeOfGeneratorFunctionReturnType(1 /* Return */, type, isAsyncGenerator));
	          }
	          return node.asteriskToken ? contextualReturnType : getIterationTypeOfGeneratorFunctionReturnType(0 /* Yield */, contextualReturnType, isAsyncGenerator);
	        }
	      }
	      return void 0;
	    }
	    function isInParameterInitializerBeforeContainingFunction(node) {
	      let inBindingInitializer = false;
	      while (node.parent && !isFunctionLike(node.parent)) {
	        if (isParameter(node.parent) && (inBindingInitializer || node.parent.initializer === node)) {
	          return true;
	        }
	        if (isBindingElement(node.parent) && node.parent.initializer === node) {
	          inBindingInitializer = true;
	        }
	        node = node.parent;
	      }
	      return false;
	    }
	    function getContextualIterationType(kind, functionDecl) {
	      const isAsync = !!(getFunctionFlags(functionDecl) & 2 /* Async */);
	      const contextualReturnType = getContextualReturnType(
	        functionDecl,
	        /*contextFlags*/
	        void 0
	      );
	      if (contextualReturnType) {
	        return getIterationTypeOfGeneratorFunctionReturnType(kind, contextualReturnType, isAsync) || void 0;
	      }
	      return void 0;
	    }
	    function getContextualReturnType(functionDecl, contextFlags) {
	      const returnType = getReturnTypeFromAnnotation(functionDecl);
	      if (returnType) {
	        return returnType;
	      }
	      const signature = getContextualSignatureForFunctionLikeDeclaration(functionDecl);
	      if (signature && !isResolvingReturnTypeOfSignature(signature)) {
	        const returnType2 = getReturnTypeOfSignature(signature);
	        const functionFlags = getFunctionFlags(functionDecl);
	        if (functionFlags & 1 /* Generator */) {
	          return filterType(returnType2, (t) => {
	            return !!(t.flags & (3 /* AnyOrUnknown */ | 16384 /* Void */ | 58982400 /* InstantiableNonPrimitive */)) || checkGeneratorInstantiationAssignabilityToReturnType(
	              t,
	              functionFlags,
	              /*errorNode*/
	              void 0
	            );
	          });
	        }
	        if (functionFlags & 2 /* Async */) {
	          return filterType(returnType2, (t) => {
	            return !!(t.flags & (3 /* AnyOrUnknown */ | 16384 /* Void */ | 58982400 /* InstantiableNonPrimitive */)) || !!getAwaitedTypeOfPromise(t);
	          });
	        }
	        return returnType2;
	      }
	      const iife = getImmediatelyInvokedFunctionExpression(functionDecl);
	      if (iife) {
	        return getContextualType2(iife, contextFlags);
	      }
	      return void 0;
	    }
	    function getContextualTypeForArgument(callTarget, arg) {
	      const args = getEffectiveCallArguments(callTarget);
	      const argIndex = args.indexOf(arg);
	      return argIndex === -1 ? void 0 : getContextualTypeForArgumentAtIndex(callTarget, argIndex);
	    }
	    function getContextualTypeForArgumentAtIndex(callTarget, argIndex) {
	      if (isImportCall(callTarget)) {
	        return argIndex === 0 ? stringType : argIndex === 1 ? getGlobalImportCallOptionsType(
	          /*reportErrors*/
	          false
	        ) : anyType;
	      }
	      const signature = getNodeLinks(callTarget).resolvedSignature === resolvingSignature ? resolvingSignature : getResolvedSignature(callTarget);
	      if (isJsxOpeningLikeElement(callTarget) && argIndex === 0) {
	        return getEffectiveFirstArgumentForJsxSignature(signature, callTarget);
	      }
	      const restIndex = signature.parameters.length - 1;
	      return signatureHasRestParameter(signature) && argIndex >= restIndex ? getIndexedAccessType(getTypeOfSymbol(signature.parameters[restIndex]), getNumberLiteralType(argIndex - restIndex), 256 /* Contextual */) : getTypeAtPosition(signature, argIndex);
	    }
	    function getContextualTypeForDecorator(decorator) {
	      const signature = getDecoratorCallSignature(decorator);
	      return signature ? getOrCreateTypeFromSignature(signature) : void 0;
	    }
	    function getContextualTypeForSubstitutionExpression(template, substitutionExpression) {
	      if (template.parent.kind === 215 /* TaggedTemplateExpression */) {
	        return getContextualTypeForArgument(template.parent, substitutionExpression);
	      }
	      return void 0;
	    }
	    function getContextualTypeForBinaryOperand(node, contextFlags) {
	      const binaryExpression = node.parent;
	      const { left, operatorToken, right } = binaryExpression;
	      switch (operatorToken.kind) {
	        case 64 /* EqualsToken */:
	        case 77 /* AmpersandAmpersandEqualsToken */:
	        case 76 /* BarBarEqualsToken */:
	        case 78 /* QuestionQuestionEqualsToken */:
	          return node === right ? getContextualTypeForAssignmentDeclaration(binaryExpression) : void 0;
	        case 57 /* BarBarToken */:
	        case 61 /* QuestionQuestionToken */:
	          const type = getContextualType2(binaryExpression, contextFlags);
	          return node === right && (type && type.pattern || !type && !isDefaultedExpandoInitializer(binaryExpression)) ? getTypeOfExpression(left) : type;
	        case 56 /* AmpersandAmpersandToken */:
	        case 28 /* CommaToken */:
	          return node === right ? getContextualType2(binaryExpression, contextFlags) : void 0;
	        default:
	          return void 0;
	      }
	    }
	    function getSymbolForExpression(e) {
	      if (canHaveSymbol(e) && e.symbol) {
	        return e.symbol;
	      }
	      if (isIdentifier(e)) {
	        return getResolvedSymbol(e);
	      }
	      if (isPropertyAccessExpression(e)) {
	        const lhsType = getTypeOfExpression(e.expression);
	        return isPrivateIdentifier(e.name) ? tryGetPrivateIdentifierPropertyOfType(lhsType, e.name) : getPropertyOfType(lhsType, e.name.escapedText);
	      }
	      if (isElementAccessExpression(e)) {
	        const propType = checkExpressionCached(e.argumentExpression);
	        if (!isTypeUsableAsPropertyName(propType)) {
	          return void 0;
	        }
	        const lhsType = getTypeOfExpression(e.expression);
	        return getPropertyOfType(lhsType, getPropertyNameFromType(propType));
	      }
	      return void 0;
	      function tryGetPrivateIdentifierPropertyOfType(type, id) {
	        const lexicallyScopedSymbol = lookupSymbolForPrivateIdentifierDeclaration(id.escapedText, id);
	        return lexicallyScopedSymbol && getPrivateIdentifierPropertyOfType(type, lexicallyScopedSymbol);
	      }
	    }
	    function getContextualTypeForAssignmentDeclaration(binaryExpression) {
	      var _a, _b;
	      const kind = getAssignmentDeclarationKind(binaryExpression);
	      switch (kind) {
	        case 0 /* None */:
	        case 4 /* ThisProperty */:
	          const lhsSymbol = getSymbolForExpression(binaryExpression.left);
	          const decl = lhsSymbol && lhsSymbol.valueDeclaration;
	          if (decl && (isPropertyDeclaration(decl) || isPropertySignature(decl))) {
	            const overallAnnotation = getEffectiveTypeAnnotationNode(decl);
	            return overallAnnotation && instantiateType(getTypeFromTypeNode(overallAnnotation), getSymbolLinks(lhsSymbol).mapper) || (isPropertyDeclaration(decl) ? decl.initializer && getTypeOfExpression(binaryExpression.left) : void 0);
	          }
	          if (kind === 0 /* None */) {
	            return getTypeOfExpression(binaryExpression.left);
	          }
	          return getContextualTypeForThisPropertyAssignment(binaryExpression);
	        case 5 /* Property */:
	          if (isPossiblyAliasedThisProperty(binaryExpression, kind)) {
	            return getContextualTypeForThisPropertyAssignment(binaryExpression);
	          } else if (!canHaveSymbol(binaryExpression.left) || !binaryExpression.left.symbol) {
	            return getTypeOfExpression(binaryExpression.left);
	          } else {
	            const decl2 = binaryExpression.left.symbol.valueDeclaration;
	            if (!decl2) {
	              return void 0;
	            }
	            const lhs = cast(binaryExpression.left, isAccessExpression);
	            const overallAnnotation = getEffectiveTypeAnnotationNode(decl2);
	            if (overallAnnotation) {
	              return getTypeFromTypeNode(overallAnnotation);
	            } else if (isIdentifier(lhs.expression)) {
	              const id = lhs.expression;
	              const parentSymbol = resolveName(
	                id,
	                id.escapedText,
	                111551 /* Value */,
	                /*nameNotFoundMessage*/
	                void 0,
	                id.escapedText,
	                /*isUse*/
	                true
	              );
	              if (parentSymbol) {
	                const annotated2 = parentSymbol.valueDeclaration && getEffectiveTypeAnnotationNode(parentSymbol.valueDeclaration);
	                if (annotated2) {
	                  const nameStr = getElementOrPropertyAccessName(lhs);
	                  if (nameStr !== void 0) {
	                    return getTypeOfPropertyOfContextualType(getTypeFromTypeNode(annotated2), nameStr);
	                  }
	                }
	                return void 0;
	              }
	            }
	            return isInJSFile(decl2) || decl2 === binaryExpression.left ? void 0 : getTypeOfExpression(binaryExpression.left);
	          }
	        case 1 /* ExportsProperty */:
	        case 6 /* Prototype */:
	        case 3 /* PrototypeProperty */:
	        case 2 /* ModuleExports */:
	          let valueDeclaration;
	          if (kind !== 2 /* ModuleExports */) {
	            valueDeclaration = canHaveSymbol(binaryExpression.left) ? (_a = binaryExpression.left.symbol) == null ? void 0 : _a.valueDeclaration : void 0;
	          }
	          valueDeclaration || (valueDeclaration = (_b = binaryExpression.symbol) == null ? void 0 : _b.valueDeclaration);
	          const annotated = valueDeclaration && getEffectiveTypeAnnotationNode(valueDeclaration);
	          return annotated ? getTypeFromTypeNode(annotated) : void 0;
	        case 7 /* ObjectDefinePropertyValue */:
	        case 8 /* ObjectDefinePropertyExports */:
	        case 9 /* ObjectDefinePrototypeProperty */:
	          return Debug.fail("Does not apply");
	        default:
	          return Debug.assertNever(kind);
	      }
	    }
	    function isPossiblyAliasedThisProperty(declaration, kind = getAssignmentDeclarationKind(declaration)) {
	      if (kind === 4 /* ThisProperty */) {
	        return true;
	      }
	      if (!isInJSFile(declaration) || kind !== 5 /* Property */ || !isIdentifier(declaration.left.expression)) {
	        return false;
	      }
	      const name = declaration.left.expression.escapedText;
	      const symbol = resolveName(
	        declaration.left,
	        name,
	        111551 /* Value */,
	        /*nameNotFoundMessage*/
	        void 0,
	        /*nameArg*/
	        void 0,
	        /*isUse*/
	        true,
	        /*excludeGlobals*/
	        true
	      );
	      return isThisInitializedDeclaration(symbol == null ? void 0 : symbol.valueDeclaration);
	    }
	    function getContextualTypeForThisPropertyAssignment(binaryExpression) {
	      if (!binaryExpression.symbol)
	        return getTypeOfExpression(binaryExpression.left);
	      if (binaryExpression.symbol.valueDeclaration) {
	        const annotated = getEffectiveTypeAnnotationNode(binaryExpression.symbol.valueDeclaration);
	        if (annotated) {
	          const type = getTypeFromTypeNode(annotated);
	          if (type) {
	            return type;
	          }
	        }
	      }
	      const thisAccess = cast(binaryExpression.left, isAccessExpression);
	      if (!isObjectLiteralMethod(getThisContainer(
	        thisAccess.expression,
	        /*includeArrowFunctions*/
	        false,
	        /*includeClassComputedPropertyName*/
	        false
	      ))) {
	        return void 0;
	      }
	      const thisType = checkThisExpression(thisAccess.expression);
	      const nameStr = getElementOrPropertyAccessName(thisAccess);
	      return nameStr !== void 0 && getTypeOfPropertyOfContextualType(thisType, nameStr) || void 0;
	    }
	    function isCircularMappedProperty(symbol) {
	      return !!(getCheckFlags(symbol) & 262144 /* Mapped */ && !symbol.links.type && findResolutionCycleStartIndex(symbol, 0 /* Type */) >= 0);
	    }
	    function getTypeOfPropertyOfContextualType(type, name, nameType) {
	      return mapType(
	        type,
	        (t) => {
	          var _a;
	          if (isGenericMappedType(t) && !t.declaration.nameType) {
	            const constraint = getConstraintTypeFromMappedType(t);
	            const constraintOfConstraint = getBaseConstraintOfType(constraint) || constraint;
	            const propertyNameType = nameType || getStringLiteralType(unescapeLeadingUnderscores(name));
	            if (isTypeAssignableTo(propertyNameType, constraintOfConstraint)) {
	              return substituteIndexedMappedType(t, propertyNameType);
	            }
	          } else if (t.flags & 3670016 /* StructuredType */) {
	            const prop = getPropertyOfType(t, name);
	            if (prop) {
	              return isCircularMappedProperty(prop) ? void 0 : removeMissingType(getTypeOfSymbol(prop), !!(prop && prop.flags & 16777216 /* Optional */));
	            }
	            if (isTupleType(t) && isNumericLiteralName(name) && +name >= 0) {
	              const restType = getElementTypeOfSliceOfTupleType(
	                t,
	                t.target.fixedLength,
	                /*endSkipCount*/
	                0,
	                /*writing*/
	                false,
	                /*noReductions*/
	                true
	              );
	              if (restType) {
	                return restType;
	              }
	            }
	            return (_a = findApplicableIndexInfo(getIndexInfosOfStructuredType(t), nameType || getStringLiteralType(unescapeLeadingUnderscores(name)))) == null ? void 0 : _a.type;
	          }
	          return void 0;
	        },
	        /*noReductions*/
	        true
	      );
	    }
	    function getContextualTypeForObjectLiteralMethod(node, contextFlags) {
	      Debug.assert(isObjectLiteralMethod(node));
	      if (node.flags & 67108864 /* InWithStatement */) {
	        return void 0;
	      }
	      return getContextualTypeForObjectLiteralElement(node, contextFlags);
	    }
	    function getContextualTypeForObjectLiteralElement(element, contextFlags) {
	      const objectLiteral = element.parent;
	      const propertyAssignmentType = isPropertyAssignment(element) && getContextualTypeForVariableLikeDeclaration(element, contextFlags);
	      if (propertyAssignmentType) {
	        return propertyAssignmentType;
	      }
	      const type = getApparentTypeOfContextualType(objectLiteral, contextFlags);
	      if (type) {
	        if (hasBindableName(element)) {
	          const symbol = getSymbolOfDeclaration(element);
	          return getTypeOfPropertyOfContextualType(type, symbol.escapedName, getSymbolLinks(symbol).nameType);
	        }
	        if (hasDynamicName(element)) {
	          const name = getNameOfDeclaration(element);
	          if (name && isComputedPropertyName(name)) {
	            const exprType = checkExpression(name.expression);
	            const propType = isTypeUsableAsPropertyName(exprType) && getTypeOfPropertyOfContextualType(type, getPropertyNameFromType(exprType));
	            if (propType) {
	              return propType;
	            }
	          }
	        }
	        if (element.name) {
	          const nameType = getLiteralTypeFromPropertyName(element.name);
	          return mapType(
	            type,
	            (t) => {
	              var _a;
	              return (_a = findApplicableIndexInfo(getIndexInfosOfStructuredType(t), nameType)) == null ? void 0 : _a.type;
	            },
	            /*noReductions*/
	            true
	          );
	        }
	      }
	      return void 0;
	    }
	    function getSpreadIndices(elements) {
	      let first2, last2;
	      for (let i = 0; i < elements.length; i++) {
	        if (isSpreadElement(elements[i])) {
	          first2 ?? (first2 = i);
	          last2 = i;
	        }
	      }
	      return { first: first2, last: last2 };
	    }
	    function getContextualTypeForElementExpression(type, index, length2, firstSpreadIndex, lastSpreadIndex) {
	      return type && mapType(
	        type,
	        (t) => {
	          if (isTupleType(t)) {
	            if ((firstSpreadIndex === void 0 || index < firstSpreadIndex) && index < t.target.fixedLength) {
	              return removeMissingType(getTypeArguments(t)[index], !!(t.target.elementFlags[index] && 2 /* Optional */));
	            }
	            const offset = length2 !== void 0 && (lastSpreadIndex === void 0 || index > lastSpreadIndex) ? length2 - index : 0;
	            const fixedEndLength = offset > 0 && t.target.hasRestElement ? getEndElementCount(t.target, 3 /* Fixed */) : 0;
	            if (offset > 0 && offset <= fixedEndLength) {
	              return getTypeArguments(t)[getTypeReferenceArity(t) - offset];
	            }
	            return getElementTypeOfSliceOfTupleType(
	              t,
	              firstSpreadIndex === void 0 ? t.target.fixedLength : Math.min(t.target.fixedLength, firstSpreadIndex),
	              length2 === void 0 || lastSpreadIndex === void 0 ? fixedEndLength : Math.min(fixedEndLength, length2 - lastSpreadIndex),
	              /*writing*/
	              false,
	              /*noReductions*/
	              true
	            );
	          }
	          return (!firstSpreadIndex || index < firstSpreadIndex) && getTypeOfPropertyOfContextualType(t, "" + index) || getIteratedTypeOrElementType(
	            1 /* Element */,
	            t,
	            undefinedType,
	            /*errorNode*/
	            void 0,
	            /*checkAssignability*/
	            false
	          );
	        },
	        /*noReductions*/
	        true
	      );
	    }
	    function getContextualTypeForConditionalOperand(node, contextFlags) {
	      const conditional = node.parent;
	      return node === conditional.whenTrue || node === conditional.whenFalse ? getContextualType2(conditional, contextFlags) : void 0;
	    }
	    function getContextualTypeForChildJsxExpression(node, child, contextFlags) {
	      const attributesType = getApparentTypeOfContextualType(node.openingElement.attributes, contextFlags);
	      const jsxChildrenPropertyName = getJsxElementChildrenPropertyName(getJsxNamespaceAt(node));
	      if (!(attributesType && !isTypeAny(attributesType) && jsxChildrenPropertyName && jsxChildrenPropertyName !== "")) {
	        return void 0;
	      }
	      const realChildren = getSemanticJsxChildren(node.children);
	      const childIndex = realChildren.indexOf(child);
	      const childFieldType = getTypeOfPropertyOfContextualType(attributesType, jsxChildrenPropertyName);
	      return childFieldType && (realChildren.length === 1 ? childFieldType : mapType(
	        childFieldType,
	        (t) => {
	          if (isArrayLikeType(t)) {
	            return getIndexedAccessType(t, getNumberLiteralType(childIndex));
	          } else {
	            return t;
	          }
	        },
	        /*noReductions*/
	        true
	      ));
	    }
	    function getContextualTypeForJsxExpression(node, contextFlags) {
	      const exprParent = node.parent;
	      return isJsxAttributeLike(exprParent) ? getContextualType2(node, contextFlags) : isJsxElement(exprParent) ? getContextualTypeForChildJsxExpression(exprParent, node, contextFlags) : void 0;
	    }
	    function getContextualTypeForJsxAttribute(attribute, contextFlags) {
	      if (isJsxAttribute(attribute)) {
	        const attributesType = getApparentTypeOfContextualType(attribute.parent, contextFlags);
	        if (!attributesType || isTypeAny(attributesType)) {
	          return void 0;
	        }
	        return getTypeOfPropertyOfContextualType(attributesType, getEscapedTextOfJsxAttributeName(attribute.name));
	      } else {
	        return getContextualType2(attribute.parent, contextFlags);
	      }
	    }
	    function isPossiblyDiscriminantValue(node) {
	      switch (node.kind) {
	        case 11 /* StringLiteral */:
	        case 9 /* NumericLiteral */:
	        case 10 /* BigIntLiteral */:
	        case 15 /* NoSubstitutionTemplateLiteral */:
	        case 228 /* TemplateExpression */:
	        case 112 /* TrueKeyword */:
	        case 97 /* FalseKeyword */:
	        case 106 /* NullKeyword */:
	        case 80 /* Identifier */:
	        case 157 /* UndefinedKeyword */:
	          return true;
	        case 211 /* PropertyAccessExpression */:
	        case 217 /* ParenthesizedExpression */:
	          return isPossiblyDiscriminantValue(node.expression);
	        case 294 /* JsxExpression */:
	          return !node.expression || isPossiblyDiscriminantValue(node.expression);
	      }
	      return false;
	    }
	    function discriminateContextualTypeByObjectMembers(node, contextualType) {
	      return getMatchingUnionConstituentForObjectLiteral(contextualType, node) || discriminateTypeByDiscriminableItems(
	        contextualType,
	        concatenate(
	          map(
	            filter(node.properties, (p) => {
	              if (!p.symbol) {
	                return false;
	              }
	              if (p.kind === 303 /* PropertyAssignment */) {
	                return isPossiblyDiscriminantValue(p.initializer) && isDiscriminantProperty(contextualType, p.symbol.escapedName);
	              }
	              if (p.kind === 304 /* ShorthandPropertyAssignment */) {
	                return isDiscriminantProperty(contextualType, p.symbol.escapedName);
	              }
	              return false;
	            }),
	            (prop) => [() => getContextFreeTypeOfExpression(prop.kind === 303 /* PropertyAssignment */ ? prop.initializer : prop.name), prop.symbol.escapedName]
	          ),
	          map(
	            filter(getPropertiesOfType(contextualType), (s) => {
	              var _a;
	              return !!(s.flags & 16777216 /* Optional */) && !!((_a = node == null ? void 0 : node.symbol) == null ? void 0 : _a.members) && !node.symbol.members.has(s.escapedName) && isDiscriminantProperty(contextualType, s.escapedName);
	            }),
	            (s) => [() => undefinedType, s.escapedName]
	          )
	        ),
	        isTypeAssignableTo
	      );
	    }
	    function discriminateContextualTypeByJSXAttributes(node, contextualType) {
	      const jsxChildrenPropertyName = getJsxElementChildrenPropertyName(getJsxNamespaceAt(node));
	      return discriminateTypeByDiscriminableItems(
	        contextualType,
	        concatenate(
	          map(
	            filter(node.properties, (p) => !!p.symbol && p.kind === 291 /* JsxAttribute */ && isDiscriminantProperty(contextualType, p.symbol.escapedName) && (!p.initializer || isPossiblyDiscriminantValue(p.initializer))),
	            (prop) => [!prop.initializer ? () => trueType : () => getContextFreeTypeOfExpression(prop.initializer), prop.symbol.escapedName]
	          ),
	          map(
	            filter(getPropertiesOfType(contextualType), (s) => {
	              var _a;
	              if (!(s.flags & 16777216 /* Optional */) || !((_a = node == null ? void 0 : node.symbol) == null ? void 0 : _a.members)) {
	                return false;
	              }
	              const element = node.parent.parent;
	              if (s.escapedName === jsxChildrenPropertyName && isJsxElement(element) && getSemanticJsxChildren(element.children).length) {
	                return false;
	              }
	              return !node.symbol.members.has(s.escapedName) && isDiscriminantProperty(contextualType, s.escapedName);
	            }),
	            (s) => [() => undefinedType, s.escapedName]
	          )
	        ),
	        isTypeAssignableTo
	      );
	    }
	    function getApparentTypeOfContextualType(node, contextFlags) {
	      const contextualType = isObjectLiteralMethod(node) ? getContextualTypeForObjectLiteralMethod(node, contextFlags) : getContextualType2(node, contextFlags);
	      const instantiatedType = instantiateContextualType(contextualType, node, contextFlags);
	      if (instantiatedType && !(contextFlags && contextFlags & 2 /* NoConstraints */ && instantiatedType.flags & 8650752 /* TypeVariable */)) {
	        const apparentType = mapType(
	          instantiatedType,
	          // When obtaining apparent type of *contextual* type we don't want to get apparent type of mapped types.
	          // That would evaluate mapped types with array or tuple type constraints too eagerly
	          // and thus it would prevent `getTypeOfPropertyOfContextualType` from obtaining per-position contextual type for elements of array literal expressions.
	          // Apparent type of other mapped types is already the mapped type itself so we can just avoid calling `getApparentType` here for all mapped types.
	          (t) => getObjectFlags(t) & 32 /* Mapped */ ? t : getApparentType(t),
	          /*noReductions*/
	          true
	        );
	        return apparentType.flags & 1048576 /* Union */ && isObjectLiteralExpression(node) ? discriminateContextualTypeByObjectMembers(node, apparentType) : apparentType.flags & 1048576 /* Union */ && isJsxAttributes(node) ? discriminateContextualTypeByJSXAttributes(node, apparentType) : apparentType;
	      }
	    }
	    function instantiateContextualType(contextualType, node, contextFlags) {
	      if (contextualType && maybeTypeOfKind(contextualType, 465829888 /* Instantiable */)) {
	        const inferenceContext = getInferenceContext(node);
	        if (inferenceContext && contextFlags & 1 /* Signature */ && some(inferenceContext.inferences, hasInferenceCandidatesOrDefault)) {
	          return instantiateInstantiableTypes(contextualType, inferenceContext.nonFixingMapper);
	        }
	        if (inferenceContext == null ? void 0 : inferenceContext.returnMapper) {
	          const type = instantiateInstantiableTypes(contextualType, inferenceContext.returnMapper);
	          return type.flags & 1048576 /* Union */ && containsType(type.types, regularFalseType) && containsType(type.types, regularTrueType) ? filterType(type, (t) => t !== regularFalseType && t !== regularTrueType) : type;
	        }
	      }
	      return contextualType;
	    }
	    function instantiateInstantiableTypes(type, mapper) {
	      if (type.flags & 465829888 /* Instantiable */) {
	        return instantiateType(type, mapper);
	      }
	      if (type.flags & 1048576 /* Union */) {
	        return getUnionType(map(type.types, (t) => instantiateInstantiableTypes(t, mapper)), 0 /* None */);
	      }
	      if (type.flags & 2097152 /* Intersection */) {
	        return getIntersectionType(map(type.types, (t) => instantiateInstantiableTypes(t, mapper)));
	      }
	      return type;
	    }
	    function getContextualType2(node, contextFlags) {
	      var _a;
	      if (node.flags & 67108864 /* InWithStatement */) {
	        return void 0;
	      }
	      const index = findContextualNode(
	        node,
	        /*includeCaches*/
	        !contextFlags
	      );
	      if (index >= 0) {
	        return contextualTypes[index];
	      }
	      const { parent: parent2 } = node;
	      switch (parent2.kind) {
	        case 260 /* VariableDeclaration */:
	        case 169 /* Parameter */:
	        case 172 /* PropertyDeclaration */:
	        case 171 /* PropertySignature */:
	        case 208 /* BindingElement */:
	          return getContextualTypeForInitializerExpression(node, contextFlags);
	        case 219 /* ArrowFunction */:
	        case 253 /* ReturnStatement */:
	          return getContextualTypeForReturnExpression(node, contextFlags);
	        case 229 /* YieldExpression */:
	          return getContextualTypeForYieldOperand(parent2, contextFlags);
	        case 223 /* AwaitExpression */:
	          return getContextualTypeForAwaitOperand(parent2, contextFlags);
	        case 213 /* CallExpression */:
	        case 214 /* NewExpression */:
	          return getContextualTypeForArgument(parent2, node);
	        case 170 /* Decorator */:
	          return getContextualTypeForDecorator(parent2);
	        case 216 /* TypeAssertionExpression */:
	        case 234 /* AsExpression */:
	          return isConstTypeReference(parent2.type) ? getContextualType2(parent2, contextFlags) : getTypeFromTypeNode(parent2.type);
	        case 226 /* BinaryExpression */:
	          return getContextualTypeForBinaryOperand(node, contextFlags);
	        case 303 /* PropertyAssignment */:
	        case 304 /* ShorthandPropertyAssignment */:
	          return getContextualTypeForObjectLiteralElement(parent2, contextFlags);
	        case 305 /* SpreadAssignment */:
	          return getContextualType2(parent2.parent, contextFlags);
	        case 209 /* ArrayLiteralExpression */: {
	          const arrayLiteral = parent2;
	          const type = getApparentTypeOfContextualType(arrayLiteral, contextFlags);
	          const elementIndex = indexOfNode(arrayLiteral.elements, node);
	          const spreadIndices = (_a = getNodeLinks(arrayLiteral)).spreadIndices ?? (_a.spreadIndices = getSpreadIndices(arrayLiteral.elements));
	          return getContextualTypeForElementExpression(type, elementIndex, arrayLiteral.elements.length, spreadIndices.first, spreadIndices.last);
	        }
	        case 227 /* ConditionalExpression */:
	          return getContextualTypeForConditionalOperand(node, contextFlags);
	        case 239 /* TemplateSpan */:
	          Debug.assert(parent2.parent.kind === 228 /* TemplateExpression */);
	          return getContextualTypeForSubstitutionExpression(parent2.parent, node);
	        case 217 /* ParenthesizedExpression */: {
	          if (isInJSFile(parent2)) {
	            if (isJSDocSatisfiesExpression(parent2)) {
	              return getTypeFromTypeNode(getJSDocSatisfiesExpressionType(parent2));
	            }
	            const typeTag = getJSDocTypeTag(parent2);
	            if (typeTag && !isConstTypeReference(typeTag.typeExpression.type)) {
	              return getTypeFromTypeNode(typeTag.typeExpression.type);
	            }
	          }
	          return getContextualType2(parent2, contextFlags);
	        }
	        case 235 /* NonNullExpression */:
	          return getContextualType2(parent2, contextFlags);
	        case 238 /* SatisfiesExpression */:
	          return getTypeFromTypeNode(parent2.type);
	        case 277 /* ExportAssignment */:
	          return tryGetTypeFromEffectiveTypeNode(parent2);
	        case 294 /* JsxExpression */:
	          return getContextualTypeForJsxExpression(parent2, contextFlags);
	        case 291 /* JsxAttribute */:
	        case 293 /* JsxSpreadAttribute */:
	          return getContextualTypeForJsxAttribute(parent2, contextFlags);
	        case 286 /* JsxOpeningElement */:
	        case 285 /* JsxSelfClosingElement */:
	          return getContextualJsxElementAttributesType(parent2, contextFlags);
	        case 301 /* ImportAttribute */:
	          return getContextualImportAttributeType(parent2);
	      }
	      return void 0;
	    }
	    function pushCachedContextualType(node) {
	      pushContextualType(
	        node,
	        getContextualType2(
	          node,
	          /*contextFlags*/
	          void 0
	        ),
	        /*isCache*/
	        true
	      );
	    }
	    function pushContextualType(node, type, isCache) {
	      contextualTypeNodes[contextualTypeCount] = node;
	      contextualTypes[contextualTypeCount] = type;
	      contextualIsCache[contextualTypeCount] = isCache;
	      contextualTypeCount++;
	    }
	    function popContextualType() {
	      contextualTypeCount--;
	    }
	    function findContextualNode(node, includeCaches) {
	      for (let i = contextualTypeCount - 1; i >= 0; i--) {
	        if (node === contextualTypeNodes[i] && (includeCaches || !contextualIsCache[i])) {
	          return i;
	        }
	      }
	      return -1;
	    }
	    function pushInferenceContext(node, inferenceContext) {
	      inferenceContextNodes[inferenceContextCount] = node;
	      inferenceContexts[inferenceContextCount] = inferenceContext;
	      inferenceContextCount++;
	    }
	    function popInferenceContext() {
	      inferenceContextCount--;
	    }
	    function getInferenceContext(node) {
	      for (let i = inferenceContextCount - 1; i >= 0; i--) {
	        if (isNodeDescendantOf(node, inferenceContextNodes[i])) {
	          return inferenceContexts[i];
	        }
	      }
	    }
	    function getContextualImportAttributeType(node) {
	      return getTypeOfPropertyOfContextualType(getGlobalImportAttributesType(
	        /*reportErrors*/
	        false
	      ), getNameFromImportAttribute(node));
	    }
	    function getContextualJsxElementAttributesType(node, contextFlags) {
	      if (isJsxOpeningElement(node) && contextFlags !== 4 /* Completions */) {
	        const index = findContextualNode(
	          node.parent,
	          /*includeCaches*/
	          !contextFlags
	        );
	        if (index >= 0) {
	          return contextualTypes[index];
	        }
	      }
	      return getContextualTypeForArgumentAtIndex(node, 0);
	    }
	    function getEffectiveFirstArgumentForJsxSignature(signature, node) {
	      return getJsxReferenceKind(node) !== 0 /* Component */ ? getJsxPropsTypeFromCallSignature(signature, node) : getJsxPropsTypeFromClassType(signature, node);
	    }
	    function getJsxPropsTypeFromCallSignature(sig, context) {
	      let propsType = getTypeOfFirstParameterOfSignatureWithFallback(sig, unknownType);
	      propsType = getJsxManagedAttributesFromLocatedAttributes(context, getJsxNamespaceAt(context), propsType);
	      const intrinsicAttribs = getJsxType(JsxNames.IntrinsicAttributes, context);
	      if (!isErrorType(intrinsicAttribs)) {
	        propsType = intersectTypes(intrinsicAttribs, propsType);
	      }
	      return propsType;
	    }
	    function getJsxPropsTypeForSignatureFromMember(sig, forcedLookupLocation) {
	      if (sig.compositeSignatures) {
	        const results = [];
	        for (const signature of sig.compositeSignatures) {
	          const instance = getReturnTypeOfSignature(signature);
	          if (isTypeAny(instance)) {
	            return instance;
	          }
	          const propType = getTypeOfPropertyOfType(instance, forcedLookupLocation);
	          if (!propType) {
	            return;
	          }
	          results.push(propType);
	        }
	        return getIntersectionType(results);
	      }
	      const instanceType = getReturnTypeOfSignature(sig);
	      return isTypeAny(instanceType) ? instanceType : getTypeOfPropertyOfType(instanceType, forcedLookupLocation);
	    }
	    function getStaticTypeOfReferencedJsxConstructor(context) {
	      if (isJsxIntrinsicTagName(context.tagName)) {
	        const result = getIntrinsicAttributesTypeFromJsxOpeningLikeElement(context);
	        const fakeSignature = createSignatureForJSXIntrinsic(context, result);
	        return getOrCreateTypeFromSignature(fakeSignature);
	      }
	      const tagType = checkExpressionCached(context.tagName);
	      if (tagType.flags & 128 /* StringLiteral */) {
	        const result = getIntrinsicAttributesTypeFromStringLiteralType(tagType, context);
	        if (!result) {
	          return errorType;
	        }
	        const fakeSignature = createSignatureForJSXIntrinsic(context, result);
	        return getOrCreateTypeFromSignature(fakeSignature);
	      }
	      return tagType;
	    }
	    function getJsxManagedAttributesFromLocatedAttributes(context, ns, attributesType) {
	      const managedSym = getJsxLibraryManagedAttributes(ns);
	      if (managedSym) {
	        const ctorType = getStaticTypeOfReferencedJsxConstructor(context);
	        const result = instantiateAliasOrInterfaceWithDefaults(managedSym, isInJSFile(context), ctorType, attributesType);
	        if (result) {
	          return result;
	        }
	      }
	      return attributesType;
	    }
	    function getJsxPropsTypeFromClassType(sig, context) {
	      const ns = getJsxNamespaceAt(context);
	      const forcedLookupLocation = getJsxElementPropertiesName(ns);
	      let attributesType = forcedLookupLocation === void 0 ? getTypeOfFirstParameterOfSignatureWithFallback(sig, unknownType) : forcedLookupLocation === "" ? getReturnTypeOfSignature(sig) : getJsxPropsTypeForSignatureFromMember(sig, forcedLookupLocation);
	      if (!attributesType) {
	        if (!!forcedLookupLocation && !!length(context.attributes.properties)) {
	          error2(context, Diagnostics.JSX_element_class_does_not_support_attributes_because_it_does_not_have_a_0_property, unescapeLeadingUnderscores(forcedLookupLocation));
	        }
	        return unknownType;
	      }
	      attributesType = getJsxManagedAttributesFromLocatedAttributes(context, ns, attributesType);
	      if (isTypeAny(attributesType)) {
	        return attributesType;
	      } else {
	        let apparentAttributesType = attributesType;
	        const intrinsicClassAttribs = getJsxType(JsxNames.IntrinsicClassAttributes, context);
	        if (!isErrorType(intrinsicClassAttribs)) {
	          const typeParams = getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(intrinsicClassAttribs.symbol);
	          const hostClassType = getReturnTypeOfSignature(sig);
	          let libraryManagedAttributeType;
	          if (typeParams) {
	            const inferredArgs = fillMissingTypeArguments([hostClassType], typeParams, getMinTypeArgumentCount(typeParams), isInJSFile(context));
	            libraryManagedAttributeType = instantiateType(intrinsicClassAttribs, createTypeMapper(typeParams, inferredArgs));
	          } else
	            libraryManagedAttributeType = intrinsicClassAttribs;
	          apparentAttributesType = intersectTypes(libraryManagedAttributeType, apparentAttributesType);
	        }
	        const intrinsicAttribs = getJsxType(JsxNames.IntrinsicAttributes, context);
	        if (!isErrorType(intrinsicAttribs)) {
	          apparentAttributesType = intersectTypes(intrinsicAttribs, apparentAttributesType);
	        }
	        return apparentAttributesType;
	      }
	    }
	    function getIntersectedSignatures(signatures) {
	      return getStrictOptionValue(compilerOptions, "noImplicitAny") ? reduceLeft(
	        signatures,
	        (left, right) => left === right || !left ? left : compareTypeParametersIdentical(left.typeParameters, right.typeParameters) ? combineSignaturesOfIntersectionMembers(left, right) : void 0
	      ) : void 0;
	    }
	    function combineIntersectionThisParam(left, right, mapper) {
	      if (!left || !right) {
	        return left || right;
	      }
	      const thisType = getUnionType([getTypeOfSymbol(left), instantiateType(getTypeOfSymbol(right), mapper)]);
	      return createSymbolWithType(left, thisType);
	    }
	    function combineIntersectionParameters(left, right, mapper) {
	      const leftCount = getParameterCount(left);
	      const rightCount = getParameterCount(right);
	      const longest = leftCount >= rightCount ? left : right;
	      const shorter = longest === left ? right : left;
	      const longestCount = longest === left ? leftCount : rightCount;
	      const eitherHasEffectiveRest = hasEffectiveRestParameter(left) || hasEffectiveRestParameter(right);
	      const needsExtraRestElement = eitherHasEffectiveRest && !hasEffectiveRestParameter(longest);
	      const params = new Array(longestCount + (needsExtraRestElement ? 1 : 0));
	      for (let i = 0; i < longestCount; i++) {
	        let longestParamType = tryGetTypeAtPosition(longest, i);
	        if (longest === right) {
	          longestParamType = instantiateType(longestParamType, mapper);
	        }
	        let shorterParamType = tryGetTypeAtPosition(shorter, i) || unknownType;
	        if (shorter === right) {
	          shorterParamType = instantiateType(shorterParamType, mapper);
	        }
	        const unionParamType = getUnionType([longestParamType, shorterParamType]);
	        const isRestParam = eitherHasEffectiveRest && !needsExtraRestElement && i === longestCount - 1;
	        const isOptional = i >= getMinArgumentCount(longest) && i >= getMinArgumentCount(shorter);
	        const leftName = i >= leftCount ? void 0 : getParameterNameAtPosition(left, i);
	        const rightName = i >= rightCount ? void 0 : getParameterNameAtPosition(right, i);
	        const paramName = leftName === rightName ? leftName : !leftName ? rightName : !rightName ? leftName : void 0;
	        const paramSymbol = createSymbol(
	          1 /* FunctionScopedVariable */ | (isOptional && !isRestParam ? 16777216 /* Optional */ : 0),
	          paramName || `arg${i}`
	        );
	        paramSymbol.links.type = isRestParam ? createArrayType(unionParamType) : unionParamType;
	        params[i] = paramSymbol;
	      }
	      if (needsExtraRestElement) {
	        const restParamSymbol = createSymbol(1 /* FunctionScopedVariable */, "args");
	        restParamSymbol.links.type = createArrayType(getTypeAtPosition(shorter, longestCount));
	        if (shorter === right) {
	          restParamSymbol.links.type = instantiateType(restParamSymbol.links.type, mapper);
	        }
	        params[longestCount] = restParamSymbol;
	      }
	      return params;
	    }
	    function combineSignaturesOfIntersectionMembers(left, right) {
	      const typeParams = left.typeParameters || right.typeParameters;
	      let paramMapper;
	      if (left.typeParameters && right.typeParameters) {
	        paramMapper = createTypeMapper(right.typeParameters, left.typeParameters);
	      }
	      const declaration = left.declaration;
	      const params = combineIntersectionParameters(left, right, paramMapper);
	      const thisParam = combineIntersectionThisParam(left.thisParameter, right.thisParameter, paramMapper);
	      const minArgCount = Math.max(left.minArgumentCount, right.minArgumentCount);
	      const result = createSignature(
	        declaration,
	        typeParams,
	        thisParam,
	        params,
	        /*resolvedReturnType*/
	        void 0,
	        /*resolvedTypePredicate*/
	        void 0,
	        minArgCount,
	        (left.flags | right.flags) & 167 /* PropagatingFlags */
	      );
	      result.compositeKind = 2097152 /* Intersection */;
	      result.compositeSignatures = concatenate(left.compositeKind === 2097152 /* Intersection */ && left.compositeSignatures || [left], [right]);
	      if (paramMapper) {
	        result.mapper = left.compositeKind === 2097152 /* Intersection */ && left.mapper && left.compositeSignatures ? combineTypeMappers(left.mapper, paramMapper) : paramMapper;
	      }
	      return result;
	    }
	    function getContextualCallSignature(type, node) {
	      const signatures = getSignaturesOfType(type, 0 /* Call */);
	      const applicableByArity = filter(signatures, (s) => !isAritySmaller(s, node));
	      return applicableByArity.length === 1 ? applicableByArity[0] : getIntersectedSignatures(applicableByArity);
	    }
	    function isAritySmaller(signature, target) {
	      let targetParameterCount = 0;
	      for (; targetParameterCount < target.parameters.length; targetParameterCount++) {
	        const param = target.parameters[targetParameterCount];
	        if (param.initializer || param.questionToken || param.dotDotDotToken || isJSDocOptionalParameter(param)) {
	          break;
	        }
	      }
	      if (target.parameters.length && parameterIsThisKeyword(target.parameters[0])) {
	        targetParameterCount--;
	      }
	      return !hasEffectiveRestParameter(signature) && getParameterCount(signature) < targetParameterCount;
	    }
	    function getContextualSignatureForFunctionLikeDeclaration(node) {
	      return isFunctionExpressionOrArrowFunction(node) || isObjectLiteralMethod(node) ? getContextualSignature(node) : void 0;
	    }
	    function getContextualSignature(node) {
	      Debug.assert(node.kind !== 174 /* MethodDeclaration */ || isObjectLiteralMethod(node));
	      const typeTagSignature = getSignatureOfTypeTag(node);
	      if (typeTagSignature) {
	        return typeTagSignature;
	      }
	      const type = getApparentTypeOfContextualType(node, 1 /* Signature */);
	      if (!type) {
	        return void 0;
	      }
	      if (!(type.flags & 1048576 /* Union */)) {
	        return getContextualCallSignature(type, node);
	      }
	      let signatureList;
	      const types = type.types;
	      for (const current of types) {
	        const signature = getContextualCallSignature(current, node);
	        if (signature) {
	          if (!signatureList) {
	            signatureList = [signature];
	          } else if (!compareSignaturesIdentical(
	            signatureList[0],
	            signature,
	            /*partialMatch*/
	            false,
	            /*ignoreThisTypes*/
	            true,
	            /*ignoreReturnTypes*/
	            true,
	            compareTypesIdentical
	          )) {
	            return void 0;
	          } else {
	            signatureList.push(signature);
	          }
	        }
	      }
	      if (signatureList) {
	        return signatureList.length === 1 ? signatureList[0] : createUnionSignature(signatureList[0], signatureList);
	      }
	    }
	    function checkSpreadExpression(node, checkMode) {
	      if (languageVersion < 2 /* ES2015 */) {
	        checkExternalEmitHelpers(node, compilerOptions.downlevelIteration ? 1536 /* SpreadIncludes */ : 1024 /* SpreadArray */);
	      }
	      const arrayOrIterableType = checkExpression(node.expression, checkMode);
	      return checkIteratedTypeOrElementType(33 /* Spread */, arrayOrIterableType, undefinedType, node.expression);
	    }
	    function checkSyntheticExpression(node) {
	      return node.isSpread ? getIndexedAccessType(node.type, numberType) : node.type;
	    }
	    function hasDefaultValue(node) {
	      return node.kind === 208 /* BindingElement */ && !!node.initializer || node.kind === 226 /* BinaryExpression */ && node.operatorToken.kind === 64 /* EqualsToken */;
	    }
	    function isSpreadIntoCallOrNew(node) {
	      const parent2 = walkUpParenthesizedExpressions(node.parent);
	      return isSpreadElement(parent2) && isCallOrNewExpression(parent2.parent);
	    }
	    function checkArrayLiteral(node, checkMode, forceTuple) {
	      const elements = node.elements;
	      const elementCount = elements.length;
	      const elementTypes = [];
	      const elementFlags = [];
	      pushCachedContextualType(node);
	      const inDestructuringPattern = isAssignmentTarget(node);
	      const inConstContext = isConstContext(node);
	      const contextualType = getApparentTypeOfContextualType(
	        node,
	        /*contextFlags*/
	        void 0
	      );
	      const inTupleContext = isSpreadIntoCallOrNew(node) || !!contextualType && someType(contextualType, (t) => isTupleLikeType(t) || isGenericMappedType(t) && !t.nameType && !!getHomomorphicTypeVariable(t.target || t));
	      let hasOmittedExpression = false;
	      for (let i = 0; i < elementCount; i++) {
	        const e = elements[i];
	        if (e.kind === 230 /* SpreadElement */) {
	          if (languageVersion < 2 /* ES2015 */) {
	            checkExternalEmitHelpers(e, compilerOptions.downlevelIteration ? 1536 /* SpreadIncludes */ : 1024 /* SpreadArray */);
	          }
	          const spreadType = checkExpression(e.expression, checkMode, forceTuple);
	          if (isArrayLikeType(spreadType)) {
	            elementTypes.push(spreadType);
	            elementFlags.push(8 /* Variadic */);
	          } else if (inDestructuringPattern) {
	            const restElementType = getIndexTypeOfType(spreadType, numberType) || getIteratedTypeOrElementType(
	              65 /* Destructuring */,
	              spreadType,
	              undefinedType,
	              /*errorNode*/
	              void 0,
	              /*checkAssignability*/
	              false
	            ) || unknownType;
	            elementTypes.push(restElementType);
	            elementFlags.push(4 /* Rest */);
	          } else {
	            elementTypes.push(checkIteratedTypeOrElementType(33 /* Spread */, spreadType, undefinedType, e.expression));
	            elementFlags.push(4 /* Rest */);
	          }
	        } else if (exactOptionalPropertyTypes && e.kind === 232 /* OmittedExpression */) {
	          hasOmittedExpression = true;
	          elementTypes.push(undefinedOrMissingType);
	          elementFlags.push(2 /* Optional */);
	        } else {
	          const type = checkExpressionForMutableLocation(e, checkMode, forceTuple);
	          elementTypes.push(addOptionality(
	            type,
	            /*isProperty*/
	            true,
	            hasOmittedExpression
	          ));
	          elementFlags.push(hasOmittedExpression ? 2 /* Optional */ : 1 /* Required */);
	          if (inTupleContext && checkMode && checkMode & 2 /* Inferential */ && !(checkMode & 4 /* SkipContextSensitive */) && isContextSensitive(e)) {
	            const inferenceContext = getInferenceContext(node);
	            Debug.assert(inferenceContext);
	            addIntraExpressionInferenceSite(inferenceContext, e, type);
	          }
	        }
	      }
	      popContextualType();
	      if (inDestructuringPattern) {
	        return createTupleType(elementTypes, elementFlags);
	      }
	      if (forceTuple || inConstContext || inTupleContext) {
	        return createArrayLiteralType(createTupleType(
	          elementTypes,
	          elementFlags,
	          /*readonly*/
	          inConstContext && !(contextualType && someType(contextualType, isMutableArrayLikeType))
	        ));
	      }
	      return createArrayLiteralType(createArrayType(
	        elementTypes.length ? getUnionType(sameMap(elementTypes, (t, i) => elementFlags[i] & 8 /* Variadic */ ? getIndexedAccessTypeOrUndefined(t, numberType) || anyType : t), 2 /* Subtype */) : strictNullChecks ? implicitNeverType : undefinedWideningType,
	        inConstContext
	      ));
	    }
	    function createArrayLiteralType(type) {
	      if (!(getObjectFlags(type) & 4 /* Reference */)) {
	        return type;
	      }
	      let literalType = type.literalType;
	      if (!literalType) {
	        literalType = type.literalType = cloneTypeReference(type);
	        literalType.objectFlags |= 16384 /* ArrayLiteral */ | 131072 /* ContainsObjectOrArrayLiteral */;
	      }
	      return literalType;
	    }
	    function isNumericName(name) {
	      switch (name.kind) {
	        case 167 /* ComputedPropertyName */:
	          return isNumericComputedName(name);
	        case 80 /* Identifier */:
	          return isNumericLiteralName(name.escapedText);
	        case 9 /* NumericLiteral */:
	        case 11 /* StringLiteral */:
	          return isNumericLiteralName(name.text);
	        default:
	          return false;
	      }
	    }
	    function isNumericComputedName(name) {
	      return isTypeAssignableToKind(checkComputedPropertyName(name), 296 /* NumberLike */);
	    }
	    function checkComputedPropertyName(node) {
	      const links = getNodeLinks(node.expression);
	      if (!links.resolvedType) {
	        if ((isTypeLiteralNode(node.parent.parent) || isClassLike(node.parent.parent) || isInterfaceDeclaration(node.parent.parent)) && isBinaryExpression(node.expression) && node.expression.operatorToken.kind === 103 /* InKeyword */ && node.parent.kind !== 177 /* GetAccessor */ && node.parent.kind !== 178 /* SetAccessor */) {
	          return links.resolvedType = errorType;
	        }
	        links.resolvedType = checkExpression(node.expression);
	        if (isPropertyDeclaration(node.parent) && !hasStaticModifier(node.parent) && isClassExpression(node.parent.parent)) {
	          const container = getEnclosingBlockScopeContainer(node.parent.parent);
	          const enclosingIterationStatement = getEnclosingIterationStatement(container);
	          if (enclosingIterationStatement) {
	            getNodeLinks(enclosingIterationStatement).flags |= 4096 /* LoopWithCapturedBlockScopedBinding */;
	            getNodeLinks(node).flags |= 32768 /* BlockScopedBindingInLoop */;
	            getNodeLinks(node.parent.parent).flags |= 32768 /* BlockScopedBindingInLoop */;
	          }
	        }
	        if (links.resolvedType.flags & 98304 /* Nullable */ || !isTypeAssignableToKind(links.resolvedType, 402653316 /* StringLike */ | 296 /* NumberLike */ | 12288 /* ESSymbolLike */) && !isTypeAssignableTo(links.resolvedType, stringNumberSymbolType)) {
	          error2(node, Diagnostics.A_computed_property_name_must_be_of_type_string_number_symbol_or_any);
	        }
	      }
	      return links.resolvedType;
	    }
	    function isSymbolWithNumericName(symbol) {
	      var _a;
	      const firstDecl = (_a = symbol.declarations) == null ? void 0 : _a[0];
	      return isNumericLiteralName(symbol.escapedName) || firstDecl && isNamedDeclaration(firstDecl) && isNumericName(firstDecl.name);
	    }
	    function isSymbolWithSymbolName(symbol) {
	      var _a;
	      const firstDecl = (_a = symbol.declarations) == null ? void 0 : _a[0];
	      return isKnownSymbol(symbol) || firstDecl && isNamedDeclaration(firstDecl) && isComputedPropertyName(firstDecl.name) && isTypeAssignableToKind(checkComputedPropertyName(firstDecl.name), 4096 /* ESSymbol */);
	    }
	    function getObjectLiteralIndexInfo(node, offset, properties, keyType) {
	      const propTypes = [];
	      for (let i = offset; i < properties.length; i++) {
	        const prop = properties[i];
	        if (keyType === stringType && !isSymbolWithSymbolName(prop) || keyType === numberType && isSymbolWithNumericName(prop) || keyType === esSymbolType && isSymbolWithSymbolName(prop)) {
	          propTypes.push(getTypeOfSymbol(properties[i]));
	        }
	      }
	      const unionType = propTypes.length ? getUnionType(propTypes, 2 /* Subtype */) : undefinedType;
	      return createIndexInfo(keyType, unionType, isConstContext(node));
	    }
	    function getImmediateAliasedSymbol(symbol) {
	      Debug.assert((symbol.flags & 2097152 /* Alias */) !== 0, "Should only get Alias here.");
	      const links = getSymbolLinks(symbol);
	      if (!links.immediateTarget) {
	        const node = getDeclarationOfAliasSymbol(symbol);
	        if (!node)
	          return Debug.fail();
	        links.immediateTarget = getTargetOfAliasDeclaration(
	          node,
	          /*dontRecursivelyResolve*/
	          true
	        );
	      }
	      return links.immediateTarget;
	    }
	    function checkObjectLiteral(node, checkMode = 0 /* Normal */) {
	      var _a;
	      const inDestructuringPattern = isAssignmentTarget(node);
	      checkGrammarObjectLiteralExpression(node, inDestructuringPattern);
	      const allPropertiesTable = strictNullChecks ? createSymbolTable() : void 0;
	      let propertiesTable = createSymbolTable();
	      let propertiesArray = [];
	      let spread = emptyObjectType;
	      pushCachedContextualType(node);
	      const contextualType = getApparentTypeOfContextualType(
	        node,
	        /*contextFlags*/
	        void 0
	      );
	      const contextualTypeHasPattern = contextualType && contextualType.pattern && (contextualType.pattern.kind === 206 /* ObjectBindingPattern */ || contextualType.pattern.kind === 210 /* ObjectLiteralExpression */);
	      const inConstContext = isConstContext(node);
	      const checkFlags = inConstContext ? 8 /* Readonly */ : 0;
	      const isInJavascript = isInJSFile(node) && !isInJsonFile(node);
	      const enumTag = isInJavascript ? getJSDocEnumTag(node) : void 0;
	      const isJSObjectLiteral = !contextualType && isInJavascript && !enumTag;
	      let objectFlags = freshObjectLiteralFlag;
	      let patternWithComputedProperties = false;
	      let hasComputedStringProperty = false;
	      let hasComputedNumberProperty = false;
	      let hasComputedSymbolProperty = false;
	      for (const elem of node.properties) {
	        if (elem.name && isComputedPropertyName(elem.name)) {
	          checkComputedPropertyName(elem.name);
	        }
	      }
	      let offset = 0;
	      for (const memberDecl of node.properties) {
	        let member = getSymbolOfDeclaration(memberDecl);
	        const computedNameType = memberDecl.name && memberDecl.name.kind === 167 /* ComputedPropertyName */ ? checkComputedPropertyName(memberDecl.name) : void 0;
	        if (memberDecl.kind === 303 /* PropertyAssignment */ || memberDecl.kind === 304 /* ShorthandPropertyAssignment */ || isObjectLiteralMethod(memberDecl)) {
	          let type = memberDecl.kind === 303 /* PropertyAssignment */ ? checkPropertyAssignment(memberDecl, checkMode) : (
	            // avoid resolving the left side of the ShorthandPropertyAssignment outside of the destructuring
	            // for error recovery purposes. For example, if a user wrote `{ a = 100 }` instead of `{ a: 100 }`.
	            // we don't want to say "could not find 'a'".
	            memberDecl.kind === 304 /* ShorthandPropertyAssignment */ ? checkExpressionForMutableLocation(!inDestructuringPattern && memberDecl.objectAssignmentInitializer ? memberDecl.objectAssignmentInitializer : memberDecl.name, checkMode) : checkObjectLiteralMethod(memberDecl, checkMode)
	          );
	          if (isInJavascript) {
	            const jsDocType = getTypeForDeclarationFromJSDocComment(memberDecl);
	            if (jsDocType) {
	              checkTypeAssignableTo(type, jsDocType, memberDecl);
	              type = jsDocType;
	            } else if (enumTag && enumTag.typeExpression) {
	              checkTypeAssignableTo(type, getTypeFromTypeNode(enumTag.typeExpression), memberDecl);
	            }
	          }
	          objectFlags |= getObjectFlags(type) & 458752 /* PropagatingFlags */;
	          const nameType = computedNameType && isTypeUsableAsPropertyName(computedNameType) ? computedNameType : void 0;
	          const prop = nameType ? createSymbol(4 /* Property */ | member.flags, getPropertyNameFromType(nameType), checkFlags | 4096 /* Late */) : createSymbol(4 /* Property */ | member.flags, member.escapedName, checkFlags);
	          if (nameType) {
	            prop.links.nameType = nameType;
	          }
	          if (inDestructuringPattern) {
	            const isOptional = memberDecl.kind === 303 /* PropertyAssignment */ && hasDefaultValue(memberDecl.initializer) || memberDecl.kind === 304 /* ShorthandPropertyAssignment */ && memberDecl.objectAssignmentInitializer;
	            if (isOptional) {
	              prop.flags |= 16777216 /* Optional */;
	            }
	          } else if (contextualTypeHasPattern && !(getObjectFlags(contextualType) & 512 /* ObjectLiteralPatternWithComputedProperties */)) {
	            const impliedProp = getPropertyOfType(contextualType, member.escapedName);
	            if (impliedProp) {
	              prop.flags |= impliedProp.flags & 16777216 /* Optional */;
	            } else if (!compilerOptions.suppressExcessPropertyErrors && !getIndexInfoOfType(contextualType, stringType)) {
	              error2(memberDecl.name, Diagnostics.Object_literal_may_only_specify_known_properties_and_0_does_not_exist_in_type_1, symbolToString(member), typeToString(contextualType));
	            }
	          }
	          prop.declarations = member.declarations;
	          prop.parent = member.parent;
	          if (member.valueDeclaration) {
	            prop.valueDeclaration = member.valueDeclaration;
	          }
	          prop.links.type = type;
	          prop.links.target = member;
	          member = prop;
	          allPropertiesTable == null ? void 0 : allPropertiesTable.set(prop.escapedName, prop);
	          if (contextualType && checkMode & 2 /* Inferential */ && !(checkMode & 4 /* SkipContextSensitive */) && (memberDecl.kind === 303 /* PropertyAssignment */ || memberDecl.kind === 174 /* MethodDeclaration */) && isContextSensitive(memberDecl)) {
	            const inferenceContext = getInferenceContext(node);
	            Debug.assert(inferenceContext);
	            const inferenceNode = memberDecl.kind === 303 /* PropertyAssignment */ ? memberDecl.initializer : memberDecl;
	            addIntraExpressionInferenceSite(inferenceContext, inferenceNode, type);
	          }
	        } else if (memberDecl.kind === 305 /* SpreadAssignment */) {
	          if (languageVersion < 2 /* ES2015 */) {
	            checkExternalEmitHelpers(memberDecl, 2 /* Assign */);
	          }
	          if (propertiesArray.length > 0) {
	            spread = getSpreadType(spread, createObjectLiteralType(), node.symbol, objectFlags, inConstContext);
	            propertiesArray = [];
	            propertiesTable = createSymbolTable();
	            hasComputedStringProperty = false;
	            hasComputedNumberProperty = false;
	            hasComputedSymbolProperty = false;
	          }
	          const type = getReducedType(checkExpression(memberDecl.expression, checkMode & 2 /* Inferential */));
	          if (isValidSpreadType(type)) {
	            const mergedType = tryMergeUnionOfObjectTypeAndEmptyObject(type, inConstContext);
	            if (allPropertiesTable) {
	              checkSpreadPropOverrides(mergedType, allPropertiesTable, memberDecl);
	            }
	            offset = propertiesArray.length;
	            if (isErrorType(spread)) {
	              continue;
	            }
	            spread = getSpreadType(spread, mergedType, node.symbol, objectFlags, inConstContext);
	          } else {
	            error2(memberDecl, Diagnostics.Spread_types_may_only_be_created_from_object_types);
	            spread = errorType;
	          }
	          continue;
	        } else {
	          Debug.assert(memberDecl.kind === 177 /* GetAccessor */ || memberDecl.kind === 178 /* SetAccessor */);
	          checkNodeDeferred(memberDecl);
	        }
	        if (computedNameType && !(computedNameType.flags & 8576 /* StringOrNumberLiteralOrUnique */)) {
	          if (isTypeAssignableTo(computedNameType, stringNumberSymbolType)) {
	            if (isTypeAssignableTo(computedNameType, numberType)) {
	              hasComputedNumberProperty = true;
	            } else if (isTypeAssignableTo(computedNameType, esSymbolType)) {
	              hasComputedSymbolProperty = true;
	            } else {
	              hasComputedStringProperty = true;
	            }
	            if (inDestructuringPattern) {
	              patternWithComputedProperties = true;
	            }
	          }
	        } else {
	          propertiesTable.set(member.escapedName, member);
	        }
	        propertiesArray.push(member);
	      }
	      popContextualType();
	      if (contextualTypeHasPattern) {
	        const rootPatternParent = findAncestor(contextualType.pattern.parent, (n) => n.kind === 260 /* VariableDeclaration */ || n.kind === 226 /* BinaryExpression */ || n.kind === 169 /* Parameter */);
	        const spreadOrOutsideRootObject = findAncestor(node, (n) => n === rootPatternParent || n.kind === 305 /* SpreadAssignment */);
	        if (spreadOrOutsideRootObject.kind !== 305 /* SpreadAssignment */) {
	          for (const prop of getPropertiesOfType(contextualType)) {
	            if (!propertiesTable.get(prop.escapedName) && !getPropertyOfType(spread, prop.escapedName)) {
	              if (!(prop.flags & 16777216 /* Optional */)) {
	                error2(prop.valueDeclaration || ((_a = tryCast(prop, isTransientSymbol)) == null ? void 0 : _a.links.bindingElement), Diagnostics.Initializer_provides_no_value_for_this_binding_element_and_the_binding_element_has_no_default_value);
	              }
	              propertiesTable.set(prop.escapedName, prop);
	              propertiesArray.push(prop);
	            }
	          }
	        }
	      }
	      if (isErrorType(spread)) {
	        return errorType;
	      }
	      if (spread !== emptyObjectType) {
	        if (propertiesArray.length > 0) {
	          spread = getSpreadType(spread, createObjectLiteralType(), node.symbol, objectFlags, inConstContext);
	          propertiesArray = [];
	          propertiesTable = createSymbolTable();
	          hasComputedStringProperty = false;
	          hasComputedNumberProperty = false;
	        }
	        return mapType(spread, (t) => t === emptyObjectType ? createObjectLiteralType() : t);
	      }
	      return createObjectLiteralType();
	      function createObjectLiteralType() {
	        const indexInfos = [];
	        if (hasComputedStringProperty)
	          indexInfos.push(getObjectLiteralIndexInfo(node, offset, propertiesArray, stringType));
	        if (hasComputedNumberProperty)
	          indexInfos.push(getObjectLiteralIndexInfo(node, offset, propertiesArray, numberType));
	        if (hasComputedSymbolProperty)
	          indexInfos.push(getObjectLiteralIndexInfo(node, offset, propertiesArray, esSymbolType));
	        const result = createAnonymousType(node.symbol, propertiesTable, emptyArray, emptyArray, indexInfos);
	        result.objectFlags |= objectFlags | 128 /* ObjectLiteral */ | 131072 /* ContainsObjectOrArrayLiteral */;
	        if (isJSObjectLiteral) {
	          result.objectFlags |= 4096 /* JSLiteral */;
	        }
	        if (patternWithComputedProperties) {
	          result.objectFlags |= 512 /* ObjectLiteralPatternWithComputedProperties */;
	        }
	        if (inDestructuringPattern) {
	          result.pattern = node;
	        }
	        return result;
	      }
	    }
	    function isValidSpreadType(type) {
	      const t = removeDefinitelyFalsyTypes(mapType(type, getBaseConstraintOrType));
	      return !!(t.flags & (1 /* Any */ | 67108864 /* NonPrimitive */ | 524288 /* Object */ | 58982400 /* InstantiableNonPrimitive */) || t.flags & 3145728 /* UnionOrIntersection */ && every(t.types, isValidSpreadType));
	    }
	    function checkJsxSelfClosingElementDeferred(node) {
	      checkJsxOpeningLikeElementOrOpeningFragment(node);
	    }
	    function checkJsxSelfClosingElement(node, _checkMode) {
	      checkNodeDeferred(node);
	      return getJsxElementTypeAt(node) || anyType;
	    }
	    function checkJsxElementDeferred(node) {
	      checkJsxOpeningLikeElementOrOpeningFragment(node.openingElement);
	      if (isJsxIntrinsicTagName(node.closingElement.tagName)) {
	        getIntrinsicTagSymbol(node.closingElement);
	      } else {
	        checkExpression(node.closingElement.tagName);
	      }
	      checkJsxChildren(node);
	    }
	    function checkJsxElement(node, _checkMode) {
	      checkNodeDeferred(node);
	      return getJsxElementTypeAt(node) || anyType;
	    }
	    function checkJsxFragment(node) {
	      checkJsxOpeningLikeElementOrOpeningFragment(node.openingFragment);
	      const nodeSourceFile = getSourceFileOfNode(node);
	      if (getJSXTransformEnabled(compilerOptions) && (compilerOptions.jsxFactory || nodeSourceFile.pragmas.has("jsx")) && !compilerOptions.jsxFragmentFactory && !nodeSourceFile.pragmas.has("jsxfrag")) {
	        error2(
	          node,
	          compilerOptions.jsxFactory ? Diagnostics.The_jsxFragmentFactory_compiler_option_must_be_provided_to_use_JSX_fragments_with_the_jsxFactory_compiler_option : Diagnostics.An_jsxFrag_pragma_is_required_when_using_an_jsx_pragma_with_JSX_fragments
	        );
	      }
	      checkJsxChildren(node);
	      return getJsxElementTypeAt(node) || anyType;
	    }
	    function isHyphenatedJsxName(name) {
	      return name.includes("-");
	    }
	    function isJsxIntrinsicTagName(tagName) {
	      return isIdentifier(tagName) && isIntrinsicJsxName(tagName.escapedText) || isJsxNamespacedName(tagName);
	    }
	    function checkJsxAttribute(node, checkMode) {
	      return node.initializer ? checkExpressionForMutableLocation(node.initializer, checkMode) : trueType;
	    }
	    function createJsxAttributesTypeFromAttributesProperty(openingLikeElement, checkMode = 0 /* Normal */) {
	      const attributes = openingLikeElement.attributes;
	      const contextualType = getContextualType2(attributes, 0 /* None */);
	      const allAttributesTable = strictNullChecks ? createSymbolTable() : void 0;
	      let attributesTable = createSymbolTable();
	      let spread = emptyJsxObjectType;
	      let hasSpreadAnyType = false;
	      let typeToIntersect;
	      let explicitlySpecifyChildrenAttribute = false;
	      let objectFlags = 2048 /* JsxAttributes */;
	      const jsxChildrenPropertyName = getJsxElementChildrenPropertyName(getJsxNamespaceAt(openingLikeElement));
	      for (const attributeDecl of attributes.properties) {
	        const member = attributeDecl.symbol;
	        if (isJsxAttribute(attributeDecl)) {
	          const exprType = checkJsxAttribute(attributeDecl, checkMode);
	          objectFlags |= getObjectFlags(exprType) & 458752 /* PropagatingFlags */;
	          const attributeSymbol = createSymbol(4 /* Property */ | member.flags, member.escapedName);
	          attributeSymbol.declarations = member.declarations;
	          attributeSymbol.parent = member.parent;
	          if (member.valueDeclaration) {
	            attributeSymbol.valueDeclaration = member.valueDeclaration;
	          }
	          attributeSymbol.links.type = exprType;
	          attributeSymbol.links.target = member;
	          attributesTable.set(attributeSymbol.escapedName, attributeSymbol);
	          allAttributesTable == null ? void 0 : allAttributesTable.set(attributeSymbol.escapedName, attributeSymbol);
	          if (getEscapedTextOfJsxAttributeName(attributeDecl.name) === jsxChildrenPropertyName) {
	            explicitlySpecifyChildrenAttribute = true;
	          }
	          if (contextualType) {
	            const prop = getPropertyOfType(contextualType, member.escapedName);
	            if (prop && prop.declarations && isDeprecatedSymbol(prop) && isIdentifier(attributeDecl.name)) {
	              addDeprecatedSuggestion(attributeDecl.name, prop.declarations, attributeDecl.name.escapedText);
	            }
	          }
	          if (contextualType && checkMode & 2 /* Inferential */ && !(checkMode & 4 /* SkipContextSensitive */) && isContextSensitive(attributeDecl)) {
	            const inferenceContext = getInferenceContext(attributes);
	            Debug.assert(inferenceContext);
	            const inferenceNode = attributeDecl.initializer.expression;
	            addIntraExpressionInferenceSite(inferenceContext, inferenceNode, exprType);
	          }
	        } else {
	          Debug.assert(attributeDecl.kind === 293 /* JsxSpreadAttribute */);
	          if (attributesTable.size > 0) {
	            spread = getSpreadType(
	              spread,
	              createJsxAttributesType(),
	              attributes.symbol,
	              objectFlags,
	              /*readonly*/
	              false
	            );
	            attributesTable = createSymbolTable();
	          }
	          const exprType = getReducedType(checkExpression(attributeDecl.expression, checkMode & 2 /* Inferential */));
	          if (isTypeAny(exprType)) {
	            hasSpreadAnyType = true;
	          }
	          if (isValidSpreadType(exprType)) {
	            spread = getSpreadType(
	              spread,
	              exprType,
	              attributes.symbol,
	              objectFlags,
	              /*readonly*/
	              false
	            );
	            if (allAttributesTable) {
	              checkSpreadPropOverrides(exprType, allAttributesTable, attributeDecl);
	            }
	          } else {
	            error2(attributeDecl.expression, Diagnostics.Spread_types_may_only_be_created_from_object_types);
	            typeToIntersect = typeToIntersect ? getIntersectionType([typeToIntersect, exprType]) : exprType;
	          }
	        }
	      }
	      if (!hasSpreadAnyType) {
	        if (attributesTable.size > 0) {
	          spread = getSpreadType(
	            spread,
	            createJsxAttributesType(),
	            attributes.symbol,
	            objectFlags,
	            /*readonly*/
	            false
	          );
	        }
	      }
	      const parent2 = openingLikeElement.parent.kind === 284 /* JsxElement */ ? openingLikeElement.parent : void 0;
	      if (parent2 && parent2.openingElement === openingLikeElement && getSemanticJsxChildren(parent2.children).length > 0) {
	        const childrenTypes = checkJsxChildren(parent2, checkMode);
	        if (!hasSpreadAnyType && jsxChildrenPropertyName && jsxChildrenPropertyName !== "") {
	          if (explicitlySpecifyChildrenAttribute) {
	            error2(attributes, Diagnostics._0_are_specified_twice_The_attribute_named_0_will_be_overwritten, unescapeLeadingUnderscores(jsxChildrenPropertyName));
	          }
	          const contextualType2 = getApparentTypeOfContextualType(
	            openingLikeElement.attributes,
	            /*contextFlags*/
	            void 0
	          );
	          const childrenContextualType = contextualType2 && getTypeOfPropertyOfContextualType(contextualType2, jsxChildrenPropertyName);
	          const childrenPropSymbol = createSymbol(4 /* Property */, jsxChildrenPropertyName);
	          childrenPropSymbol.links.type = childrenTypes.length === 1 ? childrenTypes[0] : childrenContextualType && someType(childrenContextualType, isTupleLikeType) ? createTupleType(childrenTypes) : createArrayType(getUnionType(childrenTypes));
	          childrenPropSymbol.valueDeclaration = factory.createPropertySignature(
	            /*modifiers*/
	            void 0,
	            unescapeLeadingUnderscores(jsxChildrenPropertyName),
	            /*questionToken*/
	            void 0,
	            /*type*/
	            void 0
	          );
	          setParent(childrenPropSymbol.valueDeclaration, attributes);
	          childrenPropSymbol.valueDeclaration.symbol = childrenPropSymbol;
	          const childPropMap = createSymbolTable();
	          childPropMap.set(jsxChildrenPropertyName, childrenPropSymbol);
	          spread = getSpreadType(
	            spread,
	            createAnonymousType(attributes.symbol, childPropMap, emptyArray, emptyArray, emptyArray),
	            attributes.symbol,
	            objectFlags,
	            /*readonly*/
	            false
	          );
	        }
	      }
	      if (hasSpreadAnyType) {
	        return anyType;
	      }
	      if (typeToIntersect && spread !== emptyJsxObjectType) {
	        return getIntersectionType([typeToIntersect, spread]);
	      }
	      return typeToIntersect || (spread === emptyJsxObjectType ? createJsxAttributesType() : spread);
	      function createJsxAttributesType() {
	        objectFlags |= freshObjectLiteralFlag;
	        const result = createAnonymousType(attributes.symbol, attributesTable, emptyArray, emptyArray, emptyArray);
	        result.objectFlags |= objectFlags | 128 /* ObjectLiteral */ | 131072 /* ContainsObjectOrArrayLiteral */;
	        return result;
	      }
	    }
	    function checkJsxChildren(node, checkMode) {
	      const childrenTypes = [];
	      for (const child of node.children) {
	        if (child.kind === 12 /* JsxText */) {
	          if (!child.containsOnlyTriviaWhiteSpaces) {
	            childrenTypes.push(stringType);
	          }
	        } else if (child.kind === 294 /* JsxExpression */ && !child.expression) {
	          continue;
	        } else {
	          childrenTypes.push(checkExpressionForMutableLocation(child, checkMode));
	        }
	      }
	      return childrenTypes;
	    }
	    function checkSpreadPropOverrides(type, props, spread) {
	      for (const right of getPropertiesOfType(type)) {
	        if (!(right.flags & 16777216 /* Optional */)) {
	          const left = props.get(right.escapedName);
	          if (left) {
	            const diagnostic = error2(left.valueDeclaration, Diagnostics._0_is_specified_more_than_once_so_this_usage_will_be_overwritten, unescapeLeadingUnderscores(left.escapedName));
	            addRelatedInfo(diagnostic, createDiagnosticForNode(spread, Diagnostics.This_spread_always_overwrites_this_property));
	          }
	        }
	      }
	    }
	    function checkJsxAttributes(node, checkMode) {
	      return createJsxAttributesTypeFromAttributesProperty(node.parent, checkMode);
	    }
	    function getJsxType(name, location) {
	      const namespace = getJsxNamespaceAt(location);
	      const exports = namespace && getExportsOfSymbol(namespace);
	      const typeSymbol = exports && getSymbol2(exports, name, 788968 /* Type */);
	      return typeSymbol ? getDeclaredTypeOfSymbol(typeSymbol) : errorType;
	    }
	    function getIntrinsicTagSymbol(node) {
	      const links = getNodeLinks(node);
	      if (!links.resolvedSymbol) {
	        const intrinsicElementsType = getJsxType(JsxNames.IntrinsicElements, node);
	        if (!isErrorType(intrinsicElementsType)) {
	          if (!isIdentifier(node.tagName) && !isJsxNamespacedName(node.tagName))
	            return Debug.fail();
	          const propName = isJsxNamespacedName(node.tagName) ? getEscapedTextOfJsxNamespacedName(node.tagName) : node.tagName.escapedText;
	          const intrinsicProp = getPropertyOfType(intrinsicElementsType, propName);
	          if (intrinsicProp) {
	            links.jsxFlags |= 1 /* IntrinsicNamedElement */;
	            return links.resolvedSymbol = intrinsicProp;
	          }
	          const indexSymbol = getApplicableIndexSymbol(intrinsicElementsType, getStringLiteralType(unescapeLeadingUnderscores(propName)));
	          if (indexSymbol) {
	            links.jsxFlags |= 2 /* IntrinsicIndexedElement */;
	            return links.resolvedSymbol = indexSymbol;
	          }
	          if (getTypeOfPropertyOrIndexSignatureOfType(intrinsicElementsType, propName)) {
	            links.jsxFlags |= 2 /* IntrinsicIndexedElement */;
	            return links.resolvedSymbol = intrinsicElementsType.symbol;
	          }
	          error2(node, Diagnostics.Property_0_does_not_exist_on_type_1, intrinsicTagNameToString(node.tagName), "JSX." + JsxNames.IntrinsicElements);
	          return links.resolvedSymbol = unknownSymbol;
	        } else {
	          if (noImplicitAny) {
	            error2(node, Diagnostics.JSX_element_implicitly_has_type_any_because_no_interface_JSX_0_exists, unescapeLeadingUnderscores(JsxNames.IntrinsicElements));
	          }
	          return links.resolvedSymbol = unknownSymbol;
	        }
	      }
	      return links.resolvedSymbol;
	    }
	    function getJsxNamespaceContainerForImplicitImport(location) {
	      const file = location && getSourceFileOfNode(location);
	      const links = file && getNodeLinks(file);
	      if (links && links.jsxImplicitImportContainer === false) {
	        return void 0;
	      }
	      if (links && links.jsxImplicitImportContainer) {
	        return links.jsxImplicitImportContainer;
	      }
	      const runtimeImportSpecifier = getJSXRuntimeImport(getJSXImplicitImportBase(compilerOptions, file), compilerOptions);
	      if (!runtimeImportSpecifier) {
	        return void 0;
	      }
	      const isClassic = getEmitModuleResolutionKind(compilerOptions) === 1 /* Classic */;
	      const errorMessage = isClassic ? Diagnostics.Cannot_find_module_0_Did_you_mean_to_set_the_moduleResolution_option_to_nodenext_or_to_add_aliases_to_the_paths_option : Diagnostics.Cannot_find_module_0_or_its_corresponding_type_declarations;
	      const jsxImportIndex = compilerOptions.importHelpers ? 1 : 0;
	      const specifier = file == null ? void 0 : file.imports[jsxImportIndex];
	      if (specifier) {
	        Debug.assert(nodeIsSynthesized(specifier) && specifier.text === runtimeImportSpecifier, `Expected sourceFile.imports[${jsxImportIndex}] to be the synthesized JSX runtime import`);
	      }
	      const mod = resolveExternalModule(specifier || location, runtimeImportSpecifier, errorMessage, location);
	      const result = mod && mod !== unknownSymbol ? getMergedSymbol(resolveSymbol(mod)) : void 0;
	      if (links) {
	        links.jsxImplicitImportContainer = result || false;
	      }
	      return result;
	    }
	    function getJsxNamespaceAt(location) {
	      const links = location && getNodeLinks(location);
	      if (links && links.jsxNamespace) {
	        return links.jsxNamespace;
	      }
	      if (!links || links.jsxNamespace !== false) {
	        let resolvedNamespace = getJsxNamespaceContainerForImplicitImport(location);
	        if (!resolvedNamespace || resolvedNamespace === unknownSymbol) {
	          const namespaceName = getJsxNamespace(location);
	          resolvedNamespace = resolveName(
	            location,
	            namespaceName,
	            1920 /* Namespace */,
	            /*nameNotFoundMessage*/
	            void 0,
	            namespaceName,
	            /*isUse*/
	            false
	          );
	        }
	        if (resolvedNamespace) {
	          const candidate = resolveSymbol(getSymbol2(getExportsOfSymbol(resolveSymbol(resolvedNamespace)), JsxNames.JSX, 1920 /* Namespace */));
	          if (candidate && candidate !== unknownSymbol) {
	            if (links) {
	              links.jsxNamespace = candidate;
	            }
	            return candidate;
	          }
	        }
	        if (links) {
	          links.jsxNamespace = false;
	        }
	      }
	      const s = resolveSymbol(getGlobalSymbol(
	        JsxNames.JSX,
	        1920 /* Namespace */,
	        /*diagnostic*/
	        void 0
	      ));
	      if (s === unknownSymbol) {
	        return void 0;
	      }
	      return s;
	    }
	    function getNameFromJsxElementAttributesContainer(nameOfAttribPropContainer, jsxNamespace) {
	      const jsxElementAttribPropInterfaceSym = jsxNamespace && getSymbol2(jsxNamespace.exports, nameOfAttribPropContainer, 788968 /* Type */);
	      const jsxElementAttribPropInterfaceType = jsxElementAttribPropInterfaceSym && getDeclaredTypeOfSymbol(jsxElementAttribPropInterfaceSym);
	      const propertiesOfJsxElementAttribPropInterface = jsxElementAttribPropInterfaceType && getPropertiesOfType(jsxElementAttribPropInterfaceType);
	      if (propertiesOfJsxElementAttribPropInterface) {
	        if (propertiesOfJsxElementAttribPropInterface.length === 0) {
	          return "";
	        } else if (propertiesOfJsxElementAttribPropInterface.length === 1) {
	          return propertiesOfJsxElementAttribPropInterface[0].escapedName;
	        } else if (propertiesOfJsxElementAttribPropInterface.length > 1 && jsxElementAttribPropInterfaceSym.declarations) {
	          error2(jsxElementAttribPropInterfaceSym.declarations[0], Diagnostics.The_global_type_JSX_0_may_not_have_more_than_one_property, unescapeLeadingUnderscores(nameOfAttribPropContainer));
	        }
	      }
	      return void 0;
	    }
	    function getJsxLibraryManagedAttributes(jsxNamespace) {
	      return jsxNamespace && getSymbol2(jsxNamespace.exports, JsxNames.LibraryManagedAttributes, 788968 /* Type */);
	    }
	    function getJsxElementTypeSymbol(jsxNamespace) {
	      return jsxNamespace && getSymbol2(jsxNamespace.exports, JsxNames.ElementType, 788968 /* Type */);
	    }
	    function getJsxElementPropertiesName(jsxNamespace) {
	      return getNameFromJsxElementAttributesContainer(JsxNames.ElementAttributesPropertyNameContainer, jsxNamespace);
	    }
	    function getJsxElementChildrenPropertyName(jsxNamespace) {
	      return getNameFromJsxElementAttributesContainer(JsxNames.ElementChildrenAttributeNameContainer, jsxNamespace);
	    }
	    function getUninstantiatedJsxSignaturesOfType(elementType, caller) {
	      if (elementType.flags & 4 /* String */) {
	        return [anySignature];
	      } else if (elementType.flags & 128 /* StringLiteral */) {
	        const intrinsicType = getIntrinsicAttributesTypeFromStringLiteralType(elementType, caller);
	        if (!intrinsicType) {
	          error2(caller, Diagnostics.Property_0_does_not_exist_on_type_1, elementType.value, "JSX." + JsxNames.IntrinsicElements);
	          return emptyArray;
	        } else {
	          const fakeSignature = createSignatureForJSXIntrinsic(caller, intrinsicType);
	          return [fakeSignature];
	        }
	      }
	      const apparentElemType = getApparentType(elementType);
	      let signatures = getSignaturesOfType(apparentElemType, 1 /* Construct */);
	      if (signatures.length === 0) {
	        signatures = getSignaturesOfType(apparentElemType, 0 /* Call */);
	      }
	      if (signatures.length === 0 && apparentElemType.flags & 1048576 /* Union */) {
	        signatures = getUnionSignatures(map(apparentElemType.types, (t) => getUninstantiatedJsxSignaturesOfType(t, caller)));
	      }
	      return signatures;
	    }
	    function getIntrinsicAttributesTypeFromStringLiteralType(type, location) {
	      const intrinsicElementsType = getJsxType(JsxNames.IntrinsicElements, location);
	      if (!isErrorType(intrinsicElementsType)) {
	        const stringLiteralTypeName = type.value;
	        const intrinsicProp = getPropertyOfType(intrinsicElementsType, escapeLeadingUnderscores(stringLiteralTypeName));
	        if (intrinsicProp) {
	          return getTypeOfSymbol(intrinsicProp);
	        }
	        const indexSignatureType = getIndexTypeOfType(intrinsicElementsType, stringType);
	        if (indexSignatureType) {
	          return indexSignatureType;
	        }
	        return void 0;
	      }
	      return anyType;
	    }
	    function checkJsxReturnAssignableToAppropriateBound(refKind, elemInstanceType, openingLikeElement) {
	      if (refKind === 1 /* Function */) {
	        const sfcReturnConstraint = getJsxStatelessElementTypeAt(openingLikeElement);
	        if (sfcReturnConstraint) {
	          checkTypeRelatedTo(elemInstanceType, sfcReturnConstraint, assignableRelation, openingLikeElement.tagName, Diagnostics.Its_return_type_0_is_not_a_valid_JSX_element, generateInitialErrorChain);
	        }
	      } else if (refKind === 0 /* Component */) {
	        const classConstraint = getJsxElementClassTypeAt(openingLikeElement);
	        if (classConstraint) {
	          checkTypeRelatedTo(elemInstanceType, classConstraint, assignableRelation, openingLikeElement.tagName, Diagnostics.Its_instance_type_0_is_not_a_valid_JSX_element, generateInitialErrorChain);
	        }
	      } else {
	        const sfcReturnConstraint = getJsxStatelessElementTypeAt(openingLikeElement);
	        const classConstraint = getJsxElementClassTypeAt(openingLikeElement);
	        if (!sfcReturnConstraint || !classConstraint) {
	          return;
	        }
	        const combined = getUnionType([sfcReturnConstraint, classConstraint]);
	        checkTypeRelatedTo(elemInstanceType, combined, assignableRelation, openingLikeElement.tagName, Diagnostics.Its_element_type_0_is_not_a_valid_JSX_element, generateInitialErrorChain);
	      }
	      function generateInitialErrorChain() {
	        const componentName = getTextOfNode(openingLikeElement.tagName);
	        return chainDiagnosticMessages(
	          /*details*/
	          void 0,
	          Diagnostics._0_cannot_be_used_as_a_JSX_component,
	          componentName
	        );
	      }
	    }
	    function getIntrinsicAttributesTypeFromJsxOpeningLikeElement(node) {
	      var _a;
	      Debug.assert(isJsxIntrinsicTagName(node.tagName));
	      const links = getNodeLinks(node);
	      if (!links.resolvedJsxElementAttributesType) {
	        const symbol = getIntrinsicTagSymbol(node);
	        if (links.jsxFlags & 1 /* IntrinsicNamedElement */) {
	          return links.resolvedJsxElementAttributesType = getTypeOfSymbol(symbol) || errorType;
	        } else if (links.jsxFlags & 2 /* IntrinsicIndexedElement */) {
	          const propName = isJsxNamespacedName(node.tagName) ? getEscapedTextOfJsxNamespacedName(node.tagName) : node.tagName.escapedText;
	          return links.resolvedJsxElementAttributesType = ((_a = getApplicableIndexInfoForName(getJsxType(JsxNames.IntrinsicElements, node), propName)) == null ? void 0 : _a.type) || errorType;
	        } else {
	          return links.resolvedJsxElementAttributesType = errorType;
	        }
	      }
	      return links.resolvedJsxElementAttributesType;
	    }
	    function getJsxElementClassTypeAt(location) {
	      const type = getJsxType(JsxNames.ElementClass, location);
	      if (isErrorType(type))
	        return void 0;
	      return type;
	    }
	    function getJsxElementTypeAt(location) {
	      return getJsxType(JsxNames.Element, location);
	    }
	    function getJsxStatelessElementTypeAt(location) {
	      const jsxElementType = getJsxElementTypeAt(location);
	      if (jsxElementType) {
	        return getUnionType([jsxElementType, nullType]);
	      }
	    }
	    function getJsxElementTypeTypeAt(location) {
	      const ns = getJsxNamespaceAt(location);
	      if (!ns)
	        return void 0;
	      const sym = getJsxElementTypeSymbol(ns);
	      if (!sym)
	        return void 0;
	      const type = instantiateAliasOrInterfaceWithDefaults(sym, isInJSFile(location));
	      if (!type || isErrorType(type))
	        return void 0;
	      return type;
	    }
	    function instantiateAliasOrInterfaceWithDefaults(managedSym, inJs, ...typeArguments) {
	      const declaredManagedType = getDeclaredTypeOfSymbol(managedSym);
	      if (managedSym.flags & 524288 /* TypeAlias */) {
	        const params = getSymbolLinks(managedSym).typeParameters;
	        if (length(params) >= typeArguments.length) {
	          const args = fillMissingTypeArguments(typeArguments, params, typeArguments.length, inJs);
	          return length(args) === 0 ? declaredManagedType : getTypeAliasInstantiation(managedSym, args);
	        }
	      }
	      if (length(declaredManagedType.typeParameters) >= typeArguments.length) {
	        const args = fillMissingTypeArguments(typeArguments, declaredManagedType.typeParameters, typeArguments.length, inJs);
	        return createTypeReference(declaredManagedType, args);
	      }
	      return void 0;
	    }
	    function getJsxIntrinsicTagNamesAt(location) {
	      const intrinsics = getJsxType(JsxNames.IntrinsicElements, location);
	      return intrinsics ? getPropertiesOfType(intrinsics) : emptyArray;
	    }
	    function checkJsxPreconditions(errorNode) {
	      if ((compilerOptions.jsx || 0 /* None */) === 0 /* None */) {
	        error2(errorNode, Diagnostics.Cannot_use_JSX_unless_the_jsx_flag_is_provided);
	      }
	      if (getJsxElementTypeAt(errorNode) === void 0) {
	        if (noImplicitAny) {
	          error2(errorNode, Diagnostics.JSX_element_implicitly_has_type_any_because_the_global_type_JSX_Element_does_not_exist);
	        }
	      }
	    }
	    function checkJsxOpeningLikeElementOrOpeningFragment(node) {
	      const isNodeOpeningLikeElement = isJsxOpeningLikeElement(node);
	      if (isNodeOpeningLikeElement) {
	        checkGrammarJsxElement(node);
	      }
	      checkJsxPreconditions(node);
	      if (!getJsxNamespaceContainerForImplicitImport(node)) {
	        const jsxFactoryRefErr = diagnostics && compilerOptions.jsx === 2 /* React */ ? Diagnostics.Cannot_find_name_0 : void 0;
	        const jsxFactoryNamespace = getJsxNamespace(node);
	        const jsxFactoryLocation = isNodeOpeningLikeElement ? node.tagName : node;
	        let jsxFactorySym;
	        if (!(isJsxOpeningFragment(node) && jsxFactoryNamespace === "null")) {
	          jsxFactorySym = resolveName(
	            jsxFactoryLocation,
	            jsxFactoryNamespace,
	            111551 /* Value */,
	            jsxFactoryRefErr,
	            jsxFactoryNamespace,
	            /*isUse*/
	            true
	          );
	        }
	        if (jsxFactorySym) {
	          jsxFactorySym.isReferenced = -1 /* All */;
	          if (canCollectSymbolAliasAccessabilityData && jsxFactorySym.flags & 2097152 /* Alias */ && !getTypeOnlyAliasDeclaration(jsxFactorySym)) {
	            markAliasSymbolAsReferenced(jsxFactorySym);
	          }
	        }
	        if (isJsxOpeningFragment(node)) {
	          const file = getSourceFileOfNode(node);
	          const localJsxNamespace = getLocalJsxNamespace(file);
	          if (localJsxNamespace) {
	            resolveName(
	              jsxFactoryLocation,
	              localJsxNamespace,
	              111551 /* Value */,
	              jsxFactoryRefErr,
	              localJsxNamespace,
	              /*isUse*/
	              true
	            );
	          }
	        }
	      }
	      if (isNodeOpeningLikeElement) {
	        const jsxOpeningLikeNode = node;
	        const sig = getResolvedSignature(jsxOpeningLikeNode);
	        checkDeprecatedSignature(sig, node);
	        const elementTypeConstraint = getJsxElementTypeTypeAt(jsxOpeningLikeNode);
	        if (elementTypeConstraint !== void 0) {
	          const tagName = jsxOpeningLikeNode.tagName;
	          const tagType = isJsxIntrinsicTagName(tagName) ? getStringLiteralType(intrinsicTagNameToString(tagName)) : checkExpression(tagName);
	          checkTypeRelatedTo(tagType, elementTypeConstraint, assignableRelation, tagName, Diagnostics.Its_type_0_is_not_a_valid_JSX_element_type, () => {
	            const componentName = getTextOfNode(tagName);
	            return chainDiagnosticMessages(
	              /*details*/
	              void 0,
	              Diagnostics._0_cannot_be_used_as_a_JSX_component,
	              componentName
	            );
	          });
	        } else {
	          checkJsxReturnAssignableToAppropriateBound(getJsxReferenceKind(jsxOpeningLikeNode), getReturnTypeOfSignature(sig), jsxOpeningLikeNode);
	        }
	      }
	    }
	    function isKnownProperty(targetType, name, isComparingJsxAttributes) {
	      if (targetType.flags & 524288 /* Object */) {
	        if (getPropertyOfObjectType(targetType, name) || getApplicableIndexInfoForName(targetType, name) || isLateBoundName(name) && getIndexInfoOfType(targetType, stringType) || isComparingJsxAttributes && isHyphenatedJsxName(name)) {
	          return true;
	        }
	      } else if (targetType.flags & 3145728 /* UnionOrIntersection */ && isExcessPropertyCheckTarget(targetType)) {
	        for (const t of targetType.types) {
	          if (isKnownProperty(t, name, isComparingJsxAttributes)) {
	            return true;
	          }
	        }
	      }
	      return false;
	    }
	    function isExcessPropertyCheckTarget(type) {
	      return !!(type.flags & 524288 /* Object */ && !(getObjectFlags(type) & 512 /* ObjectLiteralPatternWithComputedProperties */) || type.flags & 67108864 /* NonPrimitive */ || type.flags & 1048576 /* Union */ && some(type.types, isExcessPropertyCheckTarget) || type.flags & 2097152 /* Intersection */ && every(type.types, isExcessPropertyCheckTarget));
	    }
	    function checkJsxExpression(node, checkMode) {
	      checkGrammarJsxExpression(node);
	      if (node.expression) {
	        const type = checkExpression(node.expression, checkMode);
	        if (node.dotDotDotToken && type !== anyType && !isArrayType(type)) {
	          error2(node, Diagnostics.JSX_spread_child_must_be_an_array_type);
	        }
	        return type;
	      } else {
	        return errorType;
	      }
	    }
	    function getDeclarationNodeFlagsFromSymbol(s) {
	      return s.valueDeclaration ? getCombinedNodeFlagsCached(s.valueDeclaration) : 0;
	    }
	    function isPrototypeProperty(symbol) {
	      if (symbol.flags & 8192 /* Method */ || getCheckFlags(symbol) & 4 /* SyntheticMethod */) {
	        return true;
	      }
	      if (isInJSFile(symbol.valueDeclaration)) {
	        const parent2 = symbol.valueDeclaration.parent;
	        return parent2 && isBinaryExpression(parent2) && getAssignmentDeclarationKind(parent2) === 3 /* PrototypeProperty */;
	      }
	    }
	    function checkPropertyAccessibility(node, isSuper, writing, type, prop, reportError = true) {
	      const errorNode = !reportError ? void 0 : node.kind === 166 /* QualifiedName */ ? node.right : node.kind === 205 /* ImportType */ ? node : node.kind === 208 /* BindingElement */ && node.propertyName ? node.propertyName : node.name;
	      return checkPropertyAccessibilityAtLocation(node, isSuper, writing, type, prop, errorNode);
	    }
	    function checkPropertyAccessibilityAtLocation(location, isSuper, writing, containingType, prop, errorNode) {
	      var _a;
	      const flags = getDeclarationModifierFlagsFromSymbol(prop, writing);
	      if (isSuper) {
	        if (languageVersion < 2 /* ES2015 */) {
	          if (symbolHasNonMethodDeclaration(prop)) {
	            if (errorNode) {
	              error2(errorNode, Diagnostics.Only_public_and_protected_methods_of_the_base_class_are_accessible_via_the_super_keyword);
	            }
	            return false;
	          }
	        }
	        if (flags & 64 /* Abstract */) {
	          if (errorNode) {
	            error2(errorNode, Diagnostics.Abstract_method_0_in_class_1_cannot_be_accessed_via_super_expression, symbolToString(prop), typeToString(getDeclaringClass(prop)));
	          }
	          return false;
	        }
	        if (!(flags & 256 /* Static */) && ((_a = prop.declarations) == null ? void 0 : _a.some(isClassInstanceProperty))) {
	          if (errorNode) {
	            error2(errorNode, Diagnostics.Class_field_0_defined_by_the_parent_class_is_not_accessible_in_the_child_class_via_super, symbolToString(prop));
	          }
	          return false;
	        }
	      }
	      if (flags & 64 /* Abstract */ && symbolHasNonMethodDeclaration(prop) && (isThisProperty(location) || isThisInitializedObjectBindingExpression(location) || isObjectBindingPattern(location.parent) && isThisInitializedDeclaration(location.parent.parent))) {
	        const declaringClassDeclaration = getClassLikeDeclarationOfSymbol(getParentOfSymbol(prop));
	        if (declaringClassDeclaration && isNodeUsedDuringClassInitialization(location)) {
	          if (errorNode) {
	            error2(errorNode, Diagnostics.Abstract_property_0_in_class_1_cannot_be_accessed_in_the_constructor, symbolToString(prop), getTextOfIdentifierOrLiteral(declaringClassDeclaration.name));
	          }
	          return false;
	        }
	      }
	      if (!(flags & 6 /* NonPublicAccessibilityModifier */)) {
	        return true;
	      }
	      if (flags & 2 /* Private */) {
	        const declaringClassDeclaration = getClassLikeDeclarationOfSymbol(getParentOfSymbol(prop));
	        if (!isNodeWithinClass(location, declaringClassDeclaration)) {
	          if (errorNode) {
	            error2(errorNode, Diagnostics.Property_0_is_private_and_only_accessible_within_class_1, symbolToString(prop), typeToString(getDeclaringClass(prop)));
	          }
	          return false;
	        }
	        return true;
	      }
	      if (isSuper) {
	        return true;
	      }
	      let enclosingClass = forEachEnclosingClass(location, (enclosingDeclaration) => {
	        const enclosingClass2 = getDeclaredTypeOfSymbol(getSymbolOfDeclaration(enclosingDeclaration));
	        return isClassDerivedFromDeclaringClasses(enclosingClass2, prop, writing);
	      });
	      if (!enclosingClass) {
	        enclosingClass = getEnclosingClassFromThisParameter(location);
	        enclosingClass = enclosingClass && isClassDerivedFromDeclaringClasses(enclosingClass, prop, writing);
	        if (flags & 256 /* Static */ || !enclosingClass) {
	          if (errorNode) {
	            error2(errorNode, Diagnostics.Property_0_is_protected_and_only_accessible_within_class_1_and_its_subclasses, symbolToString(prop), typeToString(getDeclaringClass(prop) || containingType));
	          }
	          return false;
	        }
	      }
	      if (flags & 256 /* Static */) {
	        return true;
	      }
	      if (containingType.flags & 262144 /* TypeParameter */) {
	        containingType = containingType.isThisType ? getConstraintOfTypeParameter(containingType) : getBaseConstraintOfType(containingType);
	      }
	      if (!containingType || !hasBaseType(containingType, enclosingClass)) {
	        if (errorNode) {
	          error2(errorNode, Diagnostics.Property_0_is_protected_and_only_accessible_through_an_instance_of_class_1_This_is_an_instance_of_class_2, symbolToString(prop), typeToString(enclosingClass), typeToString(containingType));
	        }
	        return false;
	      }
	      return true;
	    }
	    function getEnclosingClassFromThisParameter(node) {
	      const thisParameter = getThisParameterFromNodeContext(node);
	      let thisType = (thisParameter == null ? void 0 : thisParameter.type) && getTypeFromTypeNode(thisParameter.type);
	      if (thisType && thisType.flags & 262144 /* TypeParameter */) {
	        thisType = getConstraintOfTypeParameter(thisType);
	      }
	      if (thisType && getObjectFlags(thisType) & (3 /* ClassOrInterface */ | 4 /* Reference */)) {
	        return getTargetType(thisType);
	      }
	      return void 0;
	    }
	    function getThisParameterFromNodeContext(node) {
	      const thisContainer = getThisContainer(
	        node,
	        /*includeArrowFunctions*/
	        false,
	        /*includeClassComputedPropertyName*/
	        false
	      );
	      return thisContainer && isFunctionLike(thisContainer) ? getThisParameter(thisContainer) : void 0;
	    }
	    function symbolHasNonMethodDeclaration(symbol) {
	      return !!forEachProperty2(symbol, (prop) => !(prop.flags & 8192 /* Method */));
	    }
	    function checkNonNullExpression(node) {
	      return checkNonNullType(checkExpression(node), node);
	    }
	    function isNullableType(type) {
	      return hasTypeFacts(type, 50331648 /* IsUndefinedOrNull */);
	    }
	    function getNonNullableTypeIfNeeded(type) {
	      return isNullableType(type) ? getNonNullableType(type) : type;
	    }
	    function reportObjectPossiblyNullOrUndefinedError(node, facts) {
	      const nodeText2 = isEntityNameExpression(node) ? entityNameToString(node) : void 0;
	      if (node.kind === 106 /* NullKeyword */) {
	        error2(node, Diagnostics.The_value_0_cannot_be_used_here, "null");
	        return;
	      }
	      if (nodeText2 !== void 0 && nodeText2.length < 100) {
	        if (isIdentifier(node) && nodeText2 === "undefined") {
	          error2(node, Diagnostics.The_value_0_cannot_be_used_here, "undefined");
	          return;
	        }
	        error2(
	          node,
	          facts & 16777216 /* IsUndefined */ ? facts & 33554432 /* IsNull */ ? Diagnostics._0_is_possibly_null_or_undefined : Diagnostics._0_is_possibly_undefined : Diagnostics._0_is_possibly_null,
	          nodeText2
	        );
	      } else {
	        error2(
	          node,
	          facts & 16777216 /* IsUndefined */ ? facts & 33554432 /* IsNull */ ? Diagnostics.Object_is_possibly_null_or_undefined : Diagnostics.Object_is_possibly_undefined : Diagnostics.Object_is_possibly_null
	        );
	      }
	    }
	    function reportCannotInvokePossiblyNullOrUndefinedError(node, facts) {
	      error2(
	        node,
	        facts & 16777216 /* IsUndefined */ ? facts & 33554432 /* IsNull */ ? Diagnostics.Cannot_invoke_an_object_which_is_possibly_null_or_undefined : Diagnostics.Cannot_invoke_an_object_which_is_possibly_undefined : Diagnostics.Cannot_invoke_an_object_which_is_possibly_null
	      );
	    }
	    function checkNonNullTypeWithReporter(type, node, reportError) {
	      if (strictNullChecks && type.flags & 2 /* Unknown */) {
	        if (isEntityNameExpression(node)) {
	          const nodeText2 = entityNameToString(node);
	          if (nodeText2.length < 100) {
	            error2(node, Diagnostics._0_is_of_type_unknown, nodeText2);
	            return errorType;
	          }
	        }
	        error2(node, Diagnostics.Object_is_of_type_unknown);
	        return errorType;
	      }
	      const facts = getTypeFacts(type, 50331648 /* IsUndefinedOrNull */);
	      if (facts & 50331648 /* IsUndefinedOrNull */) {
	        reportError(node, facts);
	        const t = getNonNullableType(type);
	        return t.flags & (98304 /* Nullable */ | 131072 /* Never */) ? errorType : t;
	      }
	      return type;
	    }
	    function checkNonNullType(type, node) {
	      return checkNonNullTypeWithReporter(type, node, reportObjectPossiblyNullOrUndefinedError);
	    }
	    function checkNonNullNonVoidType(type, node) {
	      const nonNullType = checkNonNullType(type, node);
	      if (nonNullType.flags & 16384 /* Void */) {
	        if (isEntityNameExpression(node)) {
	          const nodeText2 = entityNameToString(node);
	          if (isIdentifier(node) && nodeText2 === "undefined") {
	            error2(node, Diagnostics.The_value_0_cannot_be_used_here, nodeText2);
	            return nonNullType;
	          }
	          if (nodeText2.length < 100) {
	            error2(node, Diagnostics._0_is_possibly_undefined, nodeText2);
	            return nonNullType;
	          }
	        }
	        error2(node, Diagnostics.Object_is_possibly_undefined);
	      }
	      return nonNullType;
	    }
	    function checkPropertyAccessExpression(node, checkMode, writeOnly) {
	      return node.flags & 64 /* OptionalChain */ ? checkPropertyAccessChain(node, checkMode) : checkPropertyAccessExpressionOrQualifiedName(node, node.expression, checkNonNullExpression(node.expression), node.name, checkMode, writeOnly);
	    }
	    function checkPropertyAccessChain(node, checkMode) {
	      const leftType = checkExpression(node.expression);
	      const nonOptionalType = getOptionalExpressionType(leftType, node.expression);
	      return propagateOptionalTypeMarker(checkPropertyAccessExpressionOrQualifiedName(node, node.expression, checkNonNullType(nonOptionalType, node.expression), node.name, checkMode), node, nonOptionalType !== leftType);
	    }
	    function checkQualifiedName(node, checkMode) {
	      const leftType = isPartOfTypeQuery(node) && isThisIdentifier(node.left) ? checkNonNullType(checkThisExpression(node.left), node.left) : checkNonNullExpression(node.left);
	      return checkPropertyAccessExpressionOrQualifiedName(node, node.left, leftType, node.right, checkMode);
	    }
	    function isMethodAccessForCall(node) {
	      while (node.parent.kind === 217 /* ParenthesizedExpression */) {
	        node = node.parent;
	      }
	      return isCallOrNewExpression(node.parent) && node.parent.expression === node;
	    }
	    function lookupSymbolForPrivateIdentifierDeclaration(propName, location) {
	      for (let containingClass = getContainingClassExcludingClassDecorators(location); !!containingClass; containingClass = getContainingClass(containingClass)) {
	        const { symbol } = containingClass;
	        const name = getSymbolNameForPrivateIdentifier(symbol, propName);
	        const prop = symbol.members && symbol.members.get(name) || symbol.exports && symbol.exports.get(name);
	        if (prop) {
	          return prop;
	        }
	      }
	    }
	    function checkGrammarPrivateIdentifierExpression(privId) {
	      if (!getContainingClass(privId)) {
	        return grammarErrorOnNode(privId, Diagnostics.Private_identifiers_are_not_allowed_outside_class_bodies);
	      }
	      if (!isForInStatement(privId.parent)) {
	        if (!isExpressionNode(privId)) {
	          return grammarErrorOnNode(privId, Diagnostics.Private_identifiers_are_only_allowed_in_class_bodies_and_may_only_be_used_as_part_of_a_class_member_declaration_property_access_or_on_the_left_hand_side_of_an_in_expression);
	        }
	        const isInOperation = isBinaryExpression(privId.parent) && privId.parent.operatorToken.kind === 103 /* InKeyword */;
	        if (!getSymbolForPrivateIdentifierExpression(privId) && !isInOperation) {
	          return grammarErrorOnNode(privId, Diagnostics.Cannot_find_name_0, idText(privId));
	        }
	      }
	      return false;
	    }
	    function checkPrivateIdentifierExpression(privId) {
	      checkGrammarPrivateIdentifierExpression(privId);
	      const symbol = getSymbolForPrivateIdentifierExpression(privId);
	      if (symbol) {
	        markPropertyAsReferenced(
	          symbol,
	          /*nodeForCheckWriteOnly*/
	          void 0,
	          /*isSelfTypeAccess*/
	          false
	        );
	      }
	      return anyType;
	    }
	    function getSymbolForPrivateIdentifierExpression(privId) {
	      if (!isExpressionNode(privId)) {
	        return void 0;
	      }
	      const links = getNodeLinks(privId);
	      if (links.resolvedSymbol === void 0) {
	        links.resolvedSymbol = lookupSymbolForPrivateIdentifierDeclaration(privId.escapedText, privId);
	      }
	      return links.resolvedSymbol;
	    }
	    function getPrivateIdentifierPropertyOfType(leftType, lexicallyScopedIdentifier) {
	      return getPropertyOfType(leftType, lexicallyScopedIdentifier.escapedName);
	    }
	    function checkPrivateIdentifierPropertyAccess(leftType, right, lexicallyScopedIdentifier) {
	      let propertyOnType;
	      const properties = getPropertiesOfType(leftType);
	      if (properties) {
	        forEach(properties, (symbol) => {
	          const decl = symbol.valueDeclaration;
	          if (decl && isNamedDeclaration(decl) && isPrivateIdentifier(decl.name) && decl.name.escapedText === right.escapedText) {
	            propertyOnType = symbol;
	            return true;
	          }
	        });
	      }
	      const diagName = diagnosticName(right);
	      if (propertyOnType) {
	        const typeValueDecl = Debug.checkDefined(propertyOnType.valueDeclaration);
	        const typeClass = Debug.checkDefined(getContainingClass(typeValueDecl));
	        if (lexicallyScopedIdentifier == null ? void 0 : lexicallyScopedIdentifier.valueDeclaration) {
	          const lexicalValueDecl = lexicallyScopedIdentifier.valueDeclaration;
	          const lexicalClass = getContainingClass(lexicalValueDecl);
	          Debug.assert(!!lexicalClass);
	          if (findAncestor(lexicalClass, (n) => typeClass === n)) {
	            const diagnostic = error2(
	              right,
	              Diagnostics.The_property_0_cannot_be_accessed_on_type_1_within_this_class_because_it_is_shadowed_by_another_private_identifier_with_the_same_spelling,
	              diagName,
	              typeToString(leftType)
	            );
	            addRelatedInfo(
	              diagnostic,
	              createDiagnosticForNode(
	                lexicalValueDecl,
	                Diagnostics.The_shadowing_declaration_of_0_is_defined_here,
	                diagName
	              ),
	              createDiagnosticForNode(
	                typeValueDecl,
	                Diagnostics.The_declaration_of_0_that_you_probably_intended_to_use_is_defined_here,
	                diagName
	              )
	            );
	            return true;
	          }
	        }
	        error2(
	          right,
	          Diagnostics.Property_0_is_not_accessible_outside_class_1_because_it_has_a_private_identifier,
	          diagName,
	          diagnosticName(typeClass.name || anon)
	        );
	        return true;
	      }
	      return false;
	    }
	    function isThisPropertyAccessInConstructor(node, prop) {
	      return (isConstructorDeclaredProperty(prop) || isThisProperty(node) && isAutoTypedProperty(prop)) && getThisContainer(
	        node,
	        /*includeArrowFunctions*/
	        true,
	        /*includeClassComputedPropertyName*/
	        false
	      ) === getDeclaringConstructor(prop);
	    }
	    function checkPropertyAccessExpressionOrQualifiedName(node, left, leftType, right, checkMode, writeOnly) {
	      const parentSymbol = getNodeLinks(left).resolvedSymbol;
	      const assignmentKind = getAssignmentTargetKind(node);
	      const apparentType = getApparentType(assignmentKind !== 0 /* None */ || isMethodAccessForCall(node) ? getWidenedType(leftType) : leftType);
	      const isAnyLike = isTypeAny(apparentType) || apparentType === silentNeverType;
	      let prop;
	      if (isPrivateIdentifier(right)) {
	        if (languageVersion < 99 /* ESNext */) {
	          if (assignmentKind !== 0 /* None */) {
	            checkExternalEmitHelpers(node, 1048576 /* ClassPrivateFieldSet */);
	          }
	          if (assignmentKind !== 1 /* Definite */) {
	            checkExternalEmitHelpers(node, 524288 /* ClassPrivateFieldGet */);
	          }
	        }
	        const lexicallyScopedSymbol = lookupSymbolForPrivateIdentifierDeclaration(right.escapedText, right);
	        if (assignmentKind && lexicallyScopedSymbol && lexicallyScopedSymbol.valueDeclaration && isMethodDeclaration(lexicallyScopedSymbol.valueDeclaration)) {
	          grammarErrorOnNode(right, Diagnostics.Cannot_assign_to_private_method_0_Private_methods_are_not_writable, idText(right));
	        }
	        if (isAnyLike) {
	          if (lexicallyScopedSymbol) {
	            return isErrorType(apparentType) ? errorType : apparentType;
	          }
	          if (getContainingClassExcludingClassDecorators(right) === void 0) {
	            grammarErrorOnNode(right, Diagnostics.Private_identifiers_are_not_allowed_outside_class_bodies);
	            return anyType;
	          }
	        }
	        prop = lexicallyScopedSymbol && getPrivateIdentifierPropertyOfType(leftType, lexicallyScopedSymbol);
	        if (prop === void 0) {
	          if (checkPrivateIdentifierPropertyAccess(leftType, right, lexicallyScopedSymbol)) {
	            return errorType;
	          }
	          const containingClass = getContainingClassExcludingClassDecorators(right);
	          if (containingClass && isPlainJsFile(getSourceFileOfNode(containingClass), compilerOptions.checkJs)) {
	            grammarErrorOnNode(right, Diagnostics.Private_field_0_must_be_declared_in_an_enclosing_class, idText(right));
	          }
	        } else {
	          const isSetonlyAccessor = prop.flags & 65536 /* SetAccessor */ && !(prop.flags & 32768 /* GetAccessor */);
	          if (isSetonlyAccessor && assignmentKind !== 1 /* Definite */) {
	            error2(node, Diagnostics.Private_accessor_was_defined_without_a_getter);
	          }
	        }
	      } else {
	        if (isAnyLike) {
	          if (isIdentifier(left) && parentSymbol) {
	            markAliasReferenced(parentSymbol, node);
	          }
	          return isErrorType(apparentType) ? errorType : apparentType;
	        }
	        prop = getPropertyOfType(
	          apparentType,
	          right.escapedText,
	          /*skipObjectFunctionPropertyAugment*/
	          isConstEnumObjectType(apparentType),
	          /*includeTypeOnlyMembers*/
	          node.kind === 166 /* QualifiedName */
	        );
	      }
	      if (isIdentifier(left) && parentSymbol && (getIsolatedModules(compilerOptions) || !(prop && (isConstEnumOrConstEnumOnlyModule(prop) || prop.flags & 8 /* EnumMember */ && node.parent.kind === 306 /* EnumMember */)) || shouldPreserveConstEnums(compilerOptions) && isExportOrExportExpression(node))) {
	        markAliasReferenced(parentSymbol, node);
	      }
	      let propType;
	      if (!prop) {
	        const indexInfo = !isPrivateIdentifier(right) && (assignmentKind === 0 /* None */ || !isGenericObjectType(leftType) || isThisTypeParameter(leftType)) ? getApplicableIndexInfoForName(apparentType, right.escapedText) : void 0;
	        if (!(indexInfo && indexInfo.type)) {
	          const isUncheckedJS = isUncheckedJSSuggestion(
	            node,
	            leftType.symbol,
	            /*excludeClasses*/
	            true
	          );
	          if (!isUncheckedJS && isJSLiteralType(leftType)) {
	            return anyType;
	          }
	          if (leftType.symbol === globalThisSymbol) {
	            if (globalThisSymbol.exports.has(right.escapedText) && globalThisSymbol.exports.get(right.escapedText).flags & 418 /* BlockScoped */) {
	              error2(right, Diagnostics.Property_0_does_not_exist_on_type_1, unescapeLeadingUnderscores(right.escapedText), typeToString(leftType));
	            } else if (noImplicitAny) {
	              error2(right, Diagnostics.Element_implicitly_has_an_any_type_because_type_0_has_no_index_signature, typeToString(leftType));
	            }
	            return anyType;
	          }
	          if (right.escapedText && !checkAndReportErrorForExtendingInterface(node)) {
	            reportNonexistentProperty(right, isThisTypeParameter(leftType) ? apparentType : leftType, isUncheckedJS);
	          }
	          return errorType;
	        }
	        if (indexInfo.isReadonly && (isAssignmentTarget(node) || isDeleteTarget(node))) {
	          error2(node, Diagnostics.Index_signature_in_type_0_only_permits_reading, typeToString(apparentType));
	        }
	        propType = compilerOptions.noUncheckedIndexedAccess && !isAssignmentTarget(node) ? getUnionType([indexInfo.type, missingType]) : indexInfo.type;
	        if (compilerOptions.noPropertyAccessFromIndexSignature && isPropertyAccessExpression(node)) {
	          error2(right, Diagnostics.Property_0_comes_from_an_index_signature_so_it_must_be_accessed_with_0, unescapeLeadingUnderscores(right.escapedText));
	        }
	        if (indexInfo.declaration && isDeprecatedDeclaration2(indexInfo.declaration)) {
	          addDeprecatedSuggestion(right, [indexInfo.declaration], right.escapedText);
	        }
	      } else {
	        const targetPropSymbol = resolveAliasWithDeprecationCheck(prop, right);
	        if (isDeprecatedSymbol(targetPropSymbol) && isUncalledFunctionReference(node, targetPropSymbol) && targetPropSymbol.declarations) {
	          addDeprecatedSuggestion(right, targetPropSymbol.declarations, right.escapedText);
	        }
	        checkPropertyNotUsedBeforeDeclaration(prop, node, right);
	        markPropertyAsReferenced(prop, node, isSelfTypeAccess(left, parentSymbol));
	        getNodeLinks(node).resolvedSymbol = prop;
	        checkPropertyAccessibility(node, left.kind === 108 /* SuperKeyword */, isWriteAccess(node), apparentType, prop);
	        if (isAssignmentToReadonlyEntity(node, prop, assignmentKind)) {
	          error2(right, Diagnostics.Cannot_assign_to_0_because_it_is_a_read_only_property, idText(right));
	          return errorType;
	        }
	        propType = isThisPropertyAccessInConstructor(node, prop) ? autoType : writeOnly || isWriteOnlyAccess(node) ? getWriteTypeOfSymbol(prop) : getTypeOfSymbol(prop);
	      }
	      return getFlowTypeOfAccessExpression(node, prop, propType, right, checkMode);
	    }
	    function isUncheckedJSSuggestion(node, suggestion, excludeClasses) {
	      var _a;
	      const file = getSourceFileOfNode(node);
	      if (file) {
	        if (compilerOptions.checkJs === void 0 && file.checkJsDirective === void 0 && (file.scriptKind === 1 /* JS */ || file.scriptKind === 2 /* JSX */)) {
	          const declarationFile = forEach(suggestion == null ? void 0 : suggestion.declarations, getSourceFileOfNode);
	          const suggestionHasNoExtendsOrDecorators = !(suggestion == null ? void 0 : suggestion.valueDeclaration) || !isClassLike(suggestion.valueDeclaration) || ((_a = suggestion.valueDeclaration.heritageClauses) == null ? void 0 : _a.length) || classOrConstructorParameterIsDecorated(
	            /*useLegacyDecorators*/
	            false,
	            suggestion.valueDeclaration
	          );
	          return !(file !== declarationFile && !!declarationFile && isGlobalSourceFile(declarationFile)) && !(excludeClasses && suggestion && suggestion.flags & 32 /* Class */ && suggestionHasNoExtendsOrDecorators) && !(!!node && excludeClasses && isPropertyAccessExpression(node) && node.expression.kind === 110 /* ThisKeyword */ && suggestionHasNoExtendsOrDecorators);
	        }
	      }
	      return false;
	    }
	    function getFlowTypeOfAccessExpression(node, prop, propType, errorNode, checkMode) {
	      const assignmentKind = getAssignmentTargetKind(node);
	      if (assignmentKind === 1 /* Definite */) {
	        return removeMissingType(propType, !!(prop && prop.flags & 16777216 /* Optional */));
	      }
	      if (prop && !(prop.flags & (3 /* Variable */ | 4 /* Property */ | 98304 /* Accessor */)) && !(prop.flags & 8192 /* Method */ && propType.flags & 1048576 /* Union */) && !isDuplicatedCommonJSExport(prop.declarations)) {
	        return propType;
	      }
	      if (propType === autoType) {
	        return getFlowTypeOfProperty(node, prop);
	      }
	      propType = getNarrowableTypeForReference(propType, node, checkMode);
	      let assumeUninitialized = false;
	      if (strictNullChecks && strictPropertyInitialization && isAccessExpression(node) && node.expression.kind === 110 /* ThisKeyword */) {
	        const declaration = prop && prop.valueDeclaration;
	        if (declaration && isPropertyWithoutInitializer(declaration)) {
	          if (!isStatic(declaration)) {
	            const flowContainer = getControlFlowContainer(node);
	            if (flowContainer.kind === 176 /* Constructor */ && flowContainer.parent === declaration.parent && !(declaration.flags & 33554432 /* Ambient */)) {
	              assumeUninitialized = true;
	            }
	          }
	        }
	      } else if (strictNullChecks && prop && prop.valueDeclaration && isPropertyAccessExpression(prop.valueDeclaration) && getAssignmentDeclarationPropertyAccessKind(prop.valueDeclaration) && getControlFlowContainer(node) === getControlFlowContainer(prop.valueDeclaration)) {
	        assumeUninitialized = true;
	      }
	      const flowType = getFlowTypeOfReference(node, propType, assumeUninitialized ? getOptionalType(propType) : propType);
	      if (assumeUninitialized && !containsUndefinedType(propType) && containsUndefinedType(flowType)) {
	        error2(errorNode, Diagnostics.Property_0_is_used_before_being_assigned, symbolToString(prop));
	        return propType;
	      }
	      return assignmentKind ? getBaseTypeOfLiteralType(flowType) : flowType;
	    }
	    function checkPropertyNotUsedBeforeDeclaration(prop, node, right) {
	      const { valueDeclaration } = prop;
	      if (!valueDeclaration || getSourceFileOfNode(node).isDeclarationFile) {
	        return;
	      }
	      let diagnosticMessage;
	      const declarationName = idText(right);
	      if (isInPropertyInitializerOrClassStaticBlock(node) && !isOptionalPropertyDeclaration(valueDeclaration) && !(isAccessExpression(node) && isAccessExpression(node.expression)) && !isBlockScopedNameDeclaredBeforeUse(valueDeclaration, right) && !(isMethodDeclaration(valueDeclaration) && getCombinedModifierFlagsCached(valueDeclaration) & 256 /* Static */) && (useDefineForClassFields || !isPropertyDeclaredInAncestorClass(prop))) {
	        diagnosticMessage = error2(right, Diagnostics.Property_0_is_used_before_its_initialization, declarationName);
	      } else if (valueDeclaration.kind === 263 /* ClassDeclaration */ && node.parent.kind !== 183 /* TypeReference */ && !(valueDeclaration.flags & 33554432 /* Ambient */) && !isBlockScopedNameDeclaredBeforeUse(valueDeclaration, right)) {
	        diagnosticMessage = error2(right, Diagnostics.Class_0_used_before_its_declaration, declarationName);
	      }
	      if (diagnosticMessage) {
	        addRelatedInfo(diagnosticMessage, createDiagnosticForNode(valueDeclaration, Diagnostics._0_is_declared_here, declarationName));
	      }
	    }
	    function isInPropertyInitializerOrClassStaticBlock(node) {
	      return !!findAncestor(node, (node2) => {
	        switch (node2.kind) {
	          case 172 /* PropertyDeclaration */:
	            return true;
	          case 303 /* PropertyAssignment */:
	          case 174 /* MethodDeclaration */:
	          case 177 /* GetAccessor */:
	          case 178 /* SetAccessor */:
	          case 305 /* SpreadAssignment */:
	          case 167 /* ComputedPropertyName */:
	          case 239 /* TemplateSpan */:
	          case 294 /* JsxExpression */:
	          case 291 /* JsxAttribute */:
	          case 292 /* JsxAttributes */:
	          case 293 /* JsxSpreadAttribute */:
	          case 286 /* JsxOpeningElement */:
	          case 233 /* ExpressionWithTypeArguments */:
	          case 298 /* HeritageClause */:
	            return false;
	          case 219 /* ArrowFunction */:
	          case 244 /* ExpressionStatement */:
	            return isBlock(node2.parent) && isClassStaticBlockDeclaration(node2.parent.parent) ? true : "quit";
	          default:
	            return isExpressionNode(node2) ? false : "quit";
	        }
	      });
	    }
	    function isPropertyDeclaredInAncestorClass(prop) {
	      if (!(prop.parent.flags & 32 /* Class */)) {
	        return false;
	      }
	      let classType = getTypeOfSymbol(prop.parent);
	      while (true) {
	        classType = classType.symbol && getSuperClass(classType);
	        if (!classType) {
	          return false;
	        }
	        const superProperty = getPropertyOfType(classType, prop.escapedName);
	        if (superProperty && superProperty.valueDeclaration) {
	          return true;
	        }
	      }
	    }
	    function getSuperClass(classType) {
	      const x = getBaseTypes(classType);
	      if (x.length === 0) {
	        return void 0;
	      }
	      return getIntersectionType(x);
	    }
	    function reportNonexistentProperty(propNode, containingType, isUncheckedJS) {
	      let errorInfo;
	      let relatedInfo;
	      if (!isPrivateIdentifier(propNode) && containingType.flags & 1048576 /* Union */ && !(containingType.flags & 402784252 /* Primitive */)) {
	        for (const subtype of containingType.types) {
	          if (!getPropertyOfType(subtype, propNode.escapedText) && !getApplicableIndexInfoForName(subtype, propNode.escapedText)) {
	            errorInfo = chainDiagnosticMessages(errorInfo, Diagnostics.Property_0_does_not_exist_on_type_1, declarationNameToString(propNode), typeToString(subtype));
	            break;
	          }
	        }
	      }
	      if (typeHasStaticProperty(propNode.escapedText, containingType)) {
	        const propName = declarationNameToString(propNode);
	        const typeName = typeToString(containingType);
	        errorInfo = chainDiagnosticMessages(errorInfo, Diagnostics.Property_0_does_not_exist_on_type_1_Did_you_mean_to_access_the_static_member_2_instead, propName, typeName, typeName + "." + propName);
	      } else {
	        const promisedType = getPromisedTypeOfPromise(containingType);
	        if (promisedType && getPropertyOfType(promisedType, propNode.escapedText)) {
	          errorInfo = chainDiagnosticMessages(errorInfo, Diagnostics.Property_0_does_not_exist_on_type_1, declarationNameToString(propNode), typeToString(containingType));
	          relatedInfo = createDiagnosticForNode(propNode, Diagnostics.Did_you_forget_to_use_await);
	        } else {
	          const missingProperty = declarationNameToString(propNode);
	          const container = typeToString(containingType);
	          const libSuggestion = getSuggestedLibForNonExistentProperty(missingProperty, containingType);
	          if (libSuggestion !== void 0) {
	            errorInfo = chainDiagnosticMessages(errorInfo, Diagnostics.Property_0_does_not_exist_on_type_1_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_2_or_later, missingProperty, container, libSuggestion);
	          } else {
	            const suggestion = getSuggestedSymbolForNonexistentProperty(propNode, containingType);
	            if (suggestion !== void 0) {
	              const suggestedName = symbolName(suggestion);
	              const message = isUncheckedJS ? Diagnostics.Property_0_may_not_exist_on_type_1_Did_you_mean_2 : Diagnostics.Property_0_does_not_exist_on_type_1_Did_you_mean_2;
	              errorInfo = chainDiagnosticMessages(errorInfo, message, missingProperty, container, suggestedName);
	              relatedInfo = suggestion.valueDeclaration && createDiagnosticForNode(suggestion.valueDeclaration, Diagnostics._0_is_declared_here, suggestedName);
	            } else {
	              const diagnostic = containerSeemsToBeEmptyDomElement(containingType) ? Diagnostics.Property_0_does_not_exist_on_type_1_Try_changing_the_lib_compiler_option_to_include_dom : Diagnostics.Property_0_does_not_exist_on_type_1;
	              errorInfo = chainDiagnosticMessages(elaborateNeverIntersection(errorInfo, containingType), diagnostic, missingProperty, container);
	            }
	          }
	        }
	      }
	      const resultDiagnostic = createDiagnosticForNodeFromMessageChain(getSourceFileOfNode(propNode), propNode, errorInfo);
	      if (relatedInfo) {
	        addRelatedInfo(resultDiagnostic, relatedInfo);
	      }
	      addErrorOrSuggestion(!isUncheckedJS || errorInfo.code !== Diagnostics.Property_0_may_not_exist_on_type_1_Did_you_mean_2.code, resultDiagnostic);
	    }
	    function containerSeemsToBeEmptyDomElement(containingType) {
	      return compilerOptions.lib && !compilerOptions.lib.includes("dom") && everyContainedType(containingType, (type) => type.symbol && /^(EventTarget|Node|((HTML[a-zA-Z]*)?Element))$/.test(unescapeLeadingUnderscores(type.symbol.escapedName))) && isEmptyObjectType(containingType);
	    }
	    function typeHasStaticProperty(propName, containingType) {
	      const prop = containingType.symbol && getPropertyOfType(getTypeOfSymbol(containingType.symbol), propName);
	      return prop !== void 0 && !!prop.valueDeclaration && isStatic(prop.valueDeclaration);
	    }
	    function getSuggestedLibForNonExistentName(name) {
	      const missingName = diagnosticName(name);
	      const allFeatures = getScriptTargetFeatures();
	      const typeFeatures = allFeatures.get(missingName);
	      return typeFeatures && firstIterator(typeFeatures.keys());
	    }
	    function getSuggestedLibForNonExistentProperty(missingProperty, containingType) {
	      const container = getApparentType(containingType).symbol;
	      if (!container) {
	        return void 0;
	      }
	      const containingTypeName = symbolName(container);
	      const allFeatures = getScriptTargetFeatures();
	      const typeFeatures = allFeatures.get(containingTypeName);
	      if (typeFeatures) {
	        for (const [libTarget, featuresOfType] of typeFeatures) {
	          if (contains(featuresOfType, missingProperty)) {
	            return libTarget;
	          }
	        }
	      }
	    }
	    function getSuggestedSymbolForNonexistentClassMember(name, baseType) {
	      return getSpellingSuggestionForName(name, getPropertiesOfType(baseType), 106500 /* ClassMember */);
	    }
	    function getSuggestedSymbolForNonexistentProperty(name, containingType) {
	      let props = getPropertiesOfType(containingType);
	      if (typeof name !== "string") {
	        const parent2 = name.parent;
	        if (isPropertyAccessExpression(parent2)) {
	          props = filter(props, (prop) => isValidPropertyAccessForCompletions(parent2, containingType, prop));
	        }
	        name = idText(name);
	      }
	      return getSpellingSuggestionForName(name, props, 111551 /* Value */);
	    }
	    function getSuggestedSymbolForNonexistentJSXAttribute(name, containingType) {
	      const strName = isString(name) ? name : idText(name);
	      const properties = getPropertiesOfType(containingType);
	      const jsxSpecific = strName === "for" ? find(properties, (x) => symbolName(x) === "htmlFor") : strName === "class" ? find(properties, (x) => symbolName(x) === "className") : void 0;
	      return jsxSpecific ?? getSpellingSuggestionForName(strName, properties, 111551 /* Value */);
	    }
	    function getSuggestionForNonexistentProperty(name, containingType) {
	      const suggestion = getSuggestedSymbolForNonexistentProperty(name, containingType);
	      return suggestion && symbolName(suggestion);
	    }
	    function getSuggestedSymbolForNonexistentSymbol(location, outerName, meaning) {
	      Debug.assert(outerName !== void 0, "outername should always be defined");
	      const result = resolveNameHelper(
	        location,
	        outerName,
	        meaning,
	        /*nameNotFoundMessage*/
	        void 0,
	        outerName,
	        /*isUse*/
	        false,
	        /*excludeGlobals*/
	        false,
	        /*getSpellingSuggestions*/
	        true,
	        (symbols, name, meaning2) => {
	          Debug.assertEqual(outerName, name, "name should equal outerName");
	          const symbol = getSymbol2(symbols, name, meaning2);
	          if (symbol)
	            return symbol;
	          let candidates;
	          if (symbols === globals) {
	            const primitives = mapDefined(
	              ["string", "number", "boolean", "object", "bigint", "symbol"],
	              (s) => symbols.has(s.charAt(0).toUpperCase() + s.slice(1)) ? createSymbol(524288 /* TypeAlias */, s) : void 0
	            );
	            candidates = primitives.concat(arrayFrom(symbols.values()));
	          } else {
	            candidates = arrayFrom(symbols.values());
	          }
	          return getSpellingSuggestionForName(unescapeLeadingUnderscores(name), candidates, meaning2);
	        }
	      );
	      return result;
	    }
	    function getSuggestionForNonexistentSymbol(location, outerName, meaning) {
	      const symbolResult = getSuggestedSymbolForNonexistentSymbol(location, outerName, meaning);
	      return symbolResult && symbolName(symbolResult);
	    }
	    function getSuggestedSymbolForNonexistentModule(name, targetModule) {
	      return targetModule.exports && getSpellingSuggestionForName(idText(name), getExportsOfModuleAsArray(targetModule), 2623475 /* ModuleMember */);
	    }
	    function getSuggestionForNonexistentExport(name, targetModule) {
	      const suggestion = getSuggestedSymbolForNonexistentModule(name, targetModule);
	      return suggestion && symbolName(suggestion);
	    }
	    function getSuggestionForNonexistentIndexSignature(objectType, expr, keyedType) {
	      function hasProp(name) {
	        const prop = getPropertyOfObjectType(objectType, name);
	        if (prop) {
	          const s = getSingleCallSignature(getTypeOfSymbol(prop));
	          return !!s && getMinArgumentCount(s) >= 1 && isTypeAssignableTo(keyedType, getTypeAtPosition(s, 0));
	        }
	        return false;
	      }
	      const suggestedMethod = isAssignmentTarget(expr) ? "set" : "get";
	      if (!hasProp(suggestedMethod)) {
	        return void 0;
	      }
	      let suggestion = tryGetPropertyAccessOrIdentifierToString(expr.expression);
	      if (suggestion === void 0) {
	        suggestion = suggestedMethod;
	      } else {
	        suggestion += "." + suggestedMethod;
	      }
	      return suggestion;
	    }
	    function getSuggestedTypeForNonexistentStringLiteralType(source, target) {
	      const candidates = target.types.filter((type) => !!(type.flags & 128 /* StringLiteral */));
	      return getSpellingSuggestion(source.value, candidates, (type) => type.value);
	    }
	    function getSpellingSuggestionForName(name, symbols, meaning) {
	      return getSpellingSuggestion(name, symbols, getCandidateName);
	      function getCandidateName(candidate) {
	        const candidateName = symbolName(candidate);
	        if (startsWith(candidateName, '"')) {
	          return void 0;
	        }
	        if (candidate.flags & meaning) {
	          return candidateName;
	        }
	        if (candidate.flags & 2097152 /* Alias */) {
	          const alias = tryResolveAlias(candidate);
	          if (alias && alias.flags & meaning) {
	            return candidateName;
	          }
	        }
	        return void 0;
	      }
	    }
	    function markPropertyAsReferenced(prop, nodeForCheckWriteOnly, isSelfTypeAccess2) {
	      const valueDeclaration = prop && prop.flags & 106500 /* ClassMember */ && prop.valueDeclaration;
	      if (!valueDeclaration) {
	        return;
	      }
	      const hasPrivateModifier = hasEffectiveModifier(valueDeclaration, 2 /* Private */);
	      const hasPrivateIdentifier = prop.valueDeclaration && isNamedDeclaration(prop.valueDeclaration) && isPrivateIdentifier(prop.valueDeclaration.name);
	      if (!hasPrivateModifier && !hasPrivateIdentifier) {
	        return;
	      }
	      if (nodeForCheckWriteOnly && isWriteOnlyAccess(nodeForCheckWriteOnly) && !(prop.flags & 65536 /* SetAccessor */)) {
	        return;
	      }
	      if (isSelfTypeAccess2) {
	        const containingMethod = findAncestor(nodeForCheckWriteOnly, isFunctionLikeDeclaration);
	        if (containingMethod && containingMethod.symbol === prop) {
	          return;
	        }
	      }
	      (getCheckFlags(prop) & 1 /* Instantiated */ ? getSymbolLinks(prop).target : prop).isReferenced = -1 /* All */;
	    }
	    function isSelfTypeAccess(name, parent2) {
	      return name.kind === 110 /* ThisKeyword */ || !!parent2 && isEntityNameExpression(name) && parent2 === getResolvedSymbol(getFirstIdentifier(name));
	    }
	    function isValidPropertyAccess(node, propertyName) {
	      switch (node.kind) {
	        case 211 /* PropertyAccessExpression */:
	          return isValidPropertyAccessWithType(node, node.expression.kind === 108 /* SuperKeyword */, propertyName, getWidenedType(checkExpression(node.expression)));
	        case 166 /* QualifiedName */:
	          return isValidPropertyAccessWithType(
	            node,
	            /*isSuper*/
	            false,
	            propertyName,
	            getWidenedType(checkExpression(node.left))
	          );
	        case 205 /* ImportType */:
	          return isValidPropertyAccessWithType(
	            node,
	            /*isSuper*/
	            false,
	            propertyName,
	            getTypeFromTypeNode(node)
	          );
	      }
	    }
	    function isValidPropertyAccessForCompletions(node, type, property) {
	      return isPropertyAccessible(
	        node,
	        node.kind === 211 /* PropertyAccessExpression */ && node.expression.kind === 108 /* SuperKeyword */,
	        /*isWrite*/
	        false,
	        type,
	        property
	      );
	    }
	    function isValidPropertyAccessWithType(node, isSuper, propertyName, type) {
	      if (isTypeAny(type)) {
	        return true;
	      }
	      const prop = getPropertyOfType(type, propertyName);
	      return !!prop && isPropertyAccessible(
	        node,
	        isSuper,
	        /*isWrite*/
	        false,
	        type,
	        prop
	      );
	    }
	    function isPropertyAccessible(node, isSuper, isWrite, containingType, property) {
	      if (isTypeAny(containingType)) {
	        return true;
	      }
	      if (property.valueDeclaration && isPrivateIdentifierClassElementDeclaration(property.valueDeclaration)) {
	        const declClass = getContainingClass(property.valueDeclaration);
	        return !isOptionalChain(node) && !!findAncestor(node, (parent2) => parent2 === declClass);
	      }
	      return checkPropertyAccessibilityAtLocation(node, isSuper, isWrite, containingType, property);
	    }
	    function getForInVariableSymbol(node) {
	      const initializer = node.initializer;
	      if (initializer.kind === 261 /* VariableDeclarationList */) {
	        const variable = initializer.declarations[0];
	        if (variable && !isBindingPattern(variable.name)) {
	          return getSymbolOfDeclaration(variable);
	        }
	      } else if (initializer.kind === 80 /* Identifier */) {
	        return getResolvedSymbol(initializer);
	      }
	      return void 0;
	    }
	    function hasNumericPropertyNames(type) {
	      return getIndexInfosOfType(type).length === 1 && !!getIndexInfoOfType(type, numberType);
	    }
	    function isForInVariableForNumericPropertyNames(expr) {
	      const e = skipParentheses(expr);
	      if (e.kind === 80 /* Identifier */) {
	        const symbol = getResolvedSymbol(e);
	        if (symbol.flags & 3 /* Variable */) {
	          let child = expr;
	          let node = expr.parent;
	          while (node) {
	            if (node.kind === 249 /* ForInStatement */ && child === node.statement && getForInVariableSymbol(node) === symbol && hasNumericPropertyNames(getTypeOfExpression(node.expression))) {
	              return true;
	            }
	            child = node;
	            node = node.parent;
	          }
	        }
	      }
	      return false;
	    }
	    function checkIndexedAccess(node, checkMode) {
	      return node.flags & 64 /* OptionalChain */ ? checkElementAccessChain(node, checkMode) : checkElementAccessExpression(node, checkNonNullExpression(node.expression), checkMode);
	    }
	    function checkElementAccessChain(node, checkMode) {
	      const exprType = checkExpression(node.expression);
	      const nonOptionalType = getOptionalExpressionType(exprType, node.expression);
	      return propagateOptionalTypeMarker(checkElementAccessExpression(node, checkNonNullType(nonOptionalType, node.expression), checkMode), node, nonOptionalType !== exprType);
	    }
	    function checkElementAccessExpression(node, exprType, checkMode) {
	      const objectType = getAssignmentTargetKind(node) !== 0 /* None */ || isMethodAccessForCall(node) ? getWidenedType(exprType) : exprType;
	      const indexExpression = node.argumentExpression;
	      const indexType = checkExpression(indexExpression);
	      if (isErrorType(objectType) || objectType === silentNeverType) {
	        return objectType;
	      }
	      if (isConstEnumObjectType(objectType) && !isStringLiteralLike(indexExpression)) {
	        error2(indexExpression, Diagnostics.A_const_enum_member_can_only_be_accessed_using_a_string_literal);
	        return errorType;
	      }
	      const effectiveIndexType = isForInVariableForNumericPropertyNames(indexExpression) ? numberType : indexType;
	      const accessFlags = isAssignmentTarget(node) ? 4 /* Writing */ | (isGenericObjectType(objectType) && !isThisTypeParameter(objectType) ? 2 /* NoIndexSignatures */ : 0) : 32 /* ExpressionPosition */;
	      const indexedAccessType = getIndexedAccessTypeOrUndefined(objectType, effectiveIndexType, accessFlags, node) || errorType;
	      return checkIndexedAccessIndexType(getFlowTypeOfAccessExpression(node, getNodeLinks(node).resolvedSymbol, indexedAccessType, indexExpression, checkMode), node);
	    }
	    function callLikeExpressionMayHaveTypeArguments(node) {
	      return isCallOrNewExpression(node) || isTaggedTemplateExpression(node) || isJsxOpeningLikeElement(node);
	    }
	    function resolveUntypedCall(node) {
	      if (callLikeExpressionMayHaveTypeArguments(node)) {
	        forEach(node.typeArguments, checkSourceElement);
	      }
	      if (node.kind === 215 /* TaggedTemplateExpression */) {
	        checkExpression(node.template);
	      } else if (isJsxOpeningLikeElement(node)) {
	        checkExpression(node.attributes);
	      } else if (isBinaryExpression(node)) {
	        checkExpression(node.left);
	      } else if (isCallOrNewExpression(node)) {
	        forEach(node.arguments, (argument) => {
	          checkExpression(argument);
	        });
	      }
	      return anySignature;
	    }
	    function resolveErrorCall(node) {
	      resolveUntypedCall(node);
	      return unknownSignature;
	    }
	    function reorderCandidates(signatures, result, callChainFlags) {
	      let lastParent;
	      let lastSymbol;
	      let cutoffIndex = 0;
	      let index;
	      let specializedIndex = -1;
	      let spliceIndex;
	      Debug.assert(!result.length);
	      for (const signature of signatures) {
	        const symbol = signature.declaration && getSymbolOfDeclaration(signature.declaration);
	        const parent2 = signature.declaration && signature.declaration.parent;
	        if (!lastSymbol || symbol === lastSymbol) {
	          if (lastParent && parent2 === lastParent) {
	            index = index + 1;
	          } else {
	            lastParent = parent2;
	            index = cutoffIndex;
	          }
	        } else {
	          index = cutoffIndex = result.length;
	          lastParent = parent2;
	        }
	        lastSymbol = symbol;
	        if (signatureHasLiteralTypes(signature)) {
	          specializedIndex++;
	          spliceIndex = specializedIndex;
	          cutoffIndex++;
	        } else {
	          spliceIndex = index;
	        }
	        result.splice(spliceIndex, 0, callChainFlags ? getOptionalCallSignature(signature, callChainFlags) : signature);
	      }
	    }
	    function isSpreadArgument(arg) {
	      return !!arg && (arg.kind === 230 /* SpreadElement */ || arg.kind === 237 /* SyntheticExpression */ && arg.isSpread);
	    }
	    function getSpreadArgumentIndex(args) {
	      return findIndex(args, isSpreadArgument);
	    }
	    function acceptsVoid(t) {
	      return !!(t.flags & 16384 /* Void */);
	    }
	    function acceptsVoidUndefinedUnknownOrAny(t) {
	      return !!(t.flags & (16384 /* Void */ | 32768 /* Undefined */ | 2 /* Unknown */ | 1 /* Any */));
	    }
	    function hasCorrectArity(node, args, signature, signatureHelpTrailingComma = false) {
	      let argCount;
	      let callIsIncomplete = false;
	      let effectiveParameterCount = getParameterCount(signature);
	      let effectiveMinimumArguments = getMinArgumentCount(signature);
	      if (node.kind === 215 /* TaggedTemplateExpression */) {
	        argCount = args.length;
	        if (node.template.kind === 228 /* TemplateExpression */) {
	          const lastSpan = last(node.template.templateSpans);
	          callIsIncomplete = nodeIsMissing(lastSpan.literal) || !!lastSpan.literal.isUnterminated;
	        } else {
	          const templateLiteral = node.template;
	          Debug.assert(templateLiteral.kind === 15 /* NoSubstitutionTemplateLiteral */);
	          callIsIncomplete = !!templateLiteral.isUnterminated;
	        }
	      } else if (node.kind === 170 /* Decorator */) {
	        argCount = getDecoratorArgumentCount(node, signature);
	      } else if (node.kind === 226 /* BinaryExpression */) {
	        argCount = 1;
	      } else if (isJsxOpeningLikeElement(node)) {
	        callIsIncomplete = node.attributes.end === node.end;
	        if (callIsIncomplete) {
	          return true;
	        }
	        argCount = effectiveMinimumArguments === 0 ? args.length : 1;
	        effectiveParameterCount = args.length === 0 ? effectiveParameterCount : 1;
	        effectiveMinimumArguments = Math.min(effectiveMinimumArguments, 1);
	      } else if (!node.arguments) {
	        Debug.assert(node.kind === 214 /* NewExpression */);
	        return getMinArgumentCount(signature) === 0;
	      } else {
	        argCount = signatureHelpTrailingComma ? args.length + 1 : args.length;
	        callIsIncomplete = node.arguments.end === node.end;
	        const spreadArgIndex = getSpreadArgumentIndex(args);
	        if (spreadArgIndex >= 0) {
	          return spreadArgIndex >= getMinArgumentCount(signature) && (hasEffectiveRestParameter(signature) || spreadArgIndex < getParameterCount(signature));
	        }
	      }
	      if (!hasEffectiveRestParameter(signature) && argCount > effectiveParameterCount) {
	        return false;
	      }
	      if (callIsIncomplete || argCount >= effectiveMinimumArguments) {
	        return true;
	      }
	      for (let i = argCount; i < effectiveMinimumArguments; i++) {
	        const type = getTypeAtPosition(signature, i);
	        if (filterType(type, isInJSFile(node) && !strictNullChecks ? acceptsVoidUndefinedUnknownOrAny : acceptsVoid).flags & 131072 /* Never */) {
	          return false;
	        }
	      }
	      return true;
	    }
	    function hasCorrectTypeArgumentArity(signature, typeArguments) {
	      const numTypeParameters = length(signature.typeParameters);
	      const minTypeArgumentCount = getMinTypeArgumentCount(signature.typeParameters);
	      return !some(typeArguments) || typeArguments.length >= minTypeArgumentCount && typeArguments.length <= numTypeParameters;
	    }
	    function isInstantiatedGenericParameter(signature, pos) {
	      let type;
	      return !!(signature.target && (type = tryGetTypeAtPosition(signature.target, pos)) && isGenericType(type));
	    }
	    function getSingleCallSignature(type) {
	      return getSingleSignature(
	        type,
	        0 /* Call */,
	        /*allowMembers*/
	        false
	      );
	    }
	    function getSingleCallOrConstructSignature(type) {
	      return getSingleSignature(
	        type,
	        0 /* Call */,
	        /*allowMembers*/
	        false
	      ) || getSingleSignature(
	        type,
	        1 /* Construct */,
	        /*allowMembers*/
	        false
	      );
	    }
	    function getSingleSignature(type, kind, allowMembers) {
	      if (type.flags & 524288 /* Object */) {
	        const resolved = resolveStructuredTypeMembers(type);
	        if (allowMembers || resolved.properties.length === 0 && resolved.indexInfos.length === 0) {
	          if (kind === 0 /* Call */ && resolved.callSignatures.length === 1 && resolved.constructSignatures.length === 0) {
	            return resolved.callSignatures[0];
	          }
	          if (kind === 1 /* Construct */ && resolved.constructSignatures.length === 1 && resolved.callSignatures.length === 0) {
	            return resolved.constructSignatures[0];
	          }
	        }
	      }
	      return void 0;
	    }
	    function instantiateSignatureInContextOf(signature, contextualSignature, inferenceContext, compareTypes) {
	      const context = createInferenceContext(signature.typeParameters, signature, 0 /* None */, compareTypes);
	      const restType = getEffectiveRestType(contextualSignature);
	      const mapper = inferenceContext && (restType && restType.flags & 262144 /* TypeParameter */ ? inferenceContext.nonFixingMapper : inferenceContext.mapper);
	      const sourceSignature = mapper ? instantiateSignature(contextualSignature, mapper) : contextualSignature;
	      applyToParameterTypes(sourceSignature, signature, (source, target) => {
	        inferTypes(context.inferences, source, target);
	      });
	      if (!inferenceContext) {
	        applyToReturnTypes(contextualSignature, signature, (source, target) => {
	          inferTypes(context.inferences, source, target, 128 /* ReturnType */);
	        });
	      }
	      return getSignatureInstantiation(signature, getInferredTypes(context), isInJSFile(contextualSignature.declaration));
	    }
	    function inferJsxTypeArguments(node, signature, checkMode, context) {
	      const paramType = getEffectiveFirstArgumentForJsxSignature(signature, node);
	      const checkAttrType = checkExpressionWithContextualType(node.attributes, paramType, context, checkMode);
	      inferTypes(context.inferences, checkAttrType, paramType);
	      return getInferredTypes(context);
	    }
	    function getThisArgumentType(thisArgumentNode) {
	      if (!thisArgumentNode) {
	        return voidType;
	      }
	      const thisArgumentType = checkExpression(thisArgumentNode);
	      return isRightSideOfInstanceofExpression(thisArgumentNode) ? thisArgumentType : isOptionalChainRoot(thisArgumentNode.parent) ? getNonNullableType(thisArgumentType) : isOptionalChain(thisArgumentNode.parent) ? removeOptionalTypeMarker(thisArgumentType) : thisArgumentType;
	    }
	    function inferTypeArguments(node, signature, args, checkMode, context) {
	      if (isJsxOpeningLikeElement(node)) {
	        return inferJsxTypeArguments(node, signature, checkMode, context);
	      }
	      if (node.kind !== 170 /* Decorator */ && node.kind !== 226 /* BinaryExpression */) {
	        const skipBindingPatterns = every(signature.typeParameters, (p) => !!getDefaultFromTypeParameter(p));
	        const contextualType = getContextualType2(node, skipBindingPatterns ? 8 /* SkipBindingPatterns */ : 0 /* None */);
	        if (contextualType) {
	          const inferenceTargetType = getReturnTypeOfSignature(signature);
	          if (couldContainTypeVariables(inferenceTargetType)) {
	            const outerContext = getInferenceContext(node);
	            const isFromBindingPattern = !skipBindingPatterns && getContextualType2(node, 8 /* SkipBindingPatterns */) !== contextualType;
	            if (!isFromBindingPattern) {
	              const outerMapper = getMapperFromContext(cloneInferenceContext(outerContext, 1 /* NoDefault */));
	              const instantiatedType = instantiateType(contextualType, outerMapper);
	              const contextualSignature = getSingleCallSignature(instantiatedType);
	              const inferenceSourceType = contextualSignature && contextualSignature.typeParameters ? getOrCreateTypeFromSignature(getSignatureInstantiationWithoutFillingInTypeArguments(contextualSignature, contextualSignature.typeParameters)) : instantiatedType;
	              inferTypes(context.inferences, inferenceSourceType, inferenceTargetType, 128 /* ReturnType */);
	            }
	            const returnContext = createInferenceContext(signature.typeParameters, signature, context.flags);
	            const returnSourceType = instantiateType(contextualType, outerContext && outerContext.returnMapper);
	            inferTypes(returnContext.inferences, returnSourceType, inferenceTargetType);
	            context.returnMapper = some(returnContext.inferences, hasInferenceCandidates) ? getMapperFromContext(cloneInferredPartOfContext(returnContext)) : void 0;
	          }
	        }
	      }
	      const restType = getNonArrayRestType(signature);
	      const argCount = restType ? Math.min(getParameterCount(signature) - 1, args.length) : args.length;
	      if (restType && restType.flags & 262144 /* TypeParameter */) {
	        const info = find(context.inferences, (info2) => info2.typeParameter === restType);
	        if (info) {
	          info.impliedArity = findIndex(args, isSpreadArgument, argCount) < 0 ? args.length - argCount : void 0;
	        }
	      }
	      const thisType = getThisTypeOfSignature(signature);
	      if (thisType && couldContainTypeVariables(thisType)) {
	        const thisArgumentNode = getThisArgumentOfCall(node);
	        inferTypes(context.inferences, getThisArgumentType(thisArgumentNode), thisType);
	      }
	      for (let i = 0; i < argCount; i++) {
	        const arg = args[i];
	        if (arg.kind !== 232 /* OmittedExpression */) {
	          const paramType = getTypeAtPosition(signature, i);
	          if (couldContainTypeVariables(paramType)) {
	            const argType = checkExpressionWithContextualType(arg, paramType, context, checkMode);
	            inferTypes(context.inferences, argType, paramType);
	          }
	        }
	      }
	      if (restType && couldContainTypeVariables(restType)) {
	        const spreadType = getSpreadArgumentType(args, argCount, args.length, restType, context, checkMode);
	        inferTypes(context.inferences, spreadType, restType);
	      }
	      return getInferredTypes(context);
	    }
	    function getMutableArrayOrTupleType(type) {
	      return type.flags & 1048576 /* Union */ ? mapType(type, getMutableArrayOrTupleType) : type.flags & 1 /* Any */ || isMutableArrayOrTuple(getBaseConstraintOfType(type) || type) ? type : isTupleType(type) ? createTupleType(
	        getElementTypes(type),
	        type.target.elementFlags,
	        /*readonly*/
	        false,
	        type.target.labeledElementDeclarations
	      ) : createTupleType([type], [8 /* Variadic */]);
	    }
	    function getSpreadArgumentType(args, index, argCount, restType, context, checkMode) {
	      const inConstContext = isConstTypeVariable(restType);
	      if (index >= argCount - 1) {
	        const arg = args[argCount - 1];
	        if (isSpreadArgument(arg)) {
	          const spreadType = arg.kind === 237 /* SyntheticExpression */ ? arg.type : checkExpressionWithContextualType(arg.expression, restType, context, checkMode);
	          if (isArrayLikeType(spreadType)) {
	            return getMutableArrayOrTupleType(spreadType);
	          }
	          return createArrayType(checkIteratedTypeOrElementType(33 /* Spread */, spreadType, undefinedType, arg.kind === 230 /* SpreadElement */ ? arg.expression : arg), inConstContext);
	        }
	      }
	      const types = [];
	      const flags = [];
	      const names = [];
	      for (let i = index; i < argCount; i++) {
	        const arg = args[i];
	        if (isSpreadArgument(arg)) {
	          const spreadType = arg.kind === 237 /* SyntheticExpression */ ? arg.type : checkExpression(arg.expression);
	          if (isArrayLikeType(spreadType)) {
	            types.push(spreadType);
	            flags.push(8 /* Variadic */);
	          } else {
	            types.push(checkIteratedTypeOrElementType(33 /* Spread */, spreadType, undefinedType, arg.kind === 230 /* SpreadElement */ ? arg.expression : arg));
	            flags.push(4 /* Rest */);
	          }
	        } else {
	          const contextualType = isTupleType(restType) ? getContextualTypeForElementExpression(restType, i - index, argCount - index) || unknownType : getIndexedAccessType(restType, getNumberLiteralType(i - index), 256 /* Contextual */);
	          const argType = checkExpressionWithContextualType(arg, contextualType, context, checkMode);
	          const hasPrimitiveContextualType = inConstContext || maybeTypeOfKind(contextualType, 402784252 /* Primitive */ | 4194304 /* Index */ | 134217728 /* TemplateLiteral */ | 268435456 /* StringMapping */);
	          types.push(hasPrimitiveContextualType ? getRegularTypeOfLiteralType(argType) : getWidenedLiteralType(argType));
	          flags.push(1 /* Required */);
	        }
	        if (arg.kind === 237 /* SyntheticExpression */ && arg.tupleNameSource) {
	          names.push(arg.tupleNameSource);
	        } else {
	          names.push(void 0);
	        }
	      }
	      return createTupleType(types, flags, inConstContext && !someType(restType, isMutableArrayLikeType), names);
	    }
	    function checkTypeArguments(signature, typeArgumentNodes, reportErrors2, headMessage) {
	      const isJavascript = isInJSFile(signature.declaration);
	      const typeParameters = signature.typeParameters;
	      const typeArgumentTypes = fillMissingTypeArguments(map(typeArgumentNodes, getTypeFromTypeNode), typeParameters, getMinTypeArgumentCount(typeParameters), isJavascript);
	      let mapper;
	      for (let i = 0; i < typeArgumentNodes.length; i++) {
	        Debug.assert(typeParameters[i] !== void 0, "Should not call checkTypeArguments with too many type arguments");
	        const constraint = getConstraintOfTypeParameter(typeParameters[i]);
	        if (constraint) {
	          const errorInfo = reportErrors2 && headMessage ? () => chainDiagnosticMessages(
	            /*details*/
	            void 0,
	            Diagnostics.Type_0_does_not_satisfy_the_constraint_1
	          ) : void 0;
	          const typeArgumentHeadMessage = headMessage || Diagnostics.Type_0_does_not_satisfy_the_constraint_1;
	          if (!mapper) {
	            mapper = createTypeMapper(typeParameters, typeArgumentTypes);
	          }
	          const typeArgument = typeArgumentTypes[i];
	          if (!checkTypeAssignableTo(
	            typeArgument,
	            getTypeWithThisArgument(instantiateType(constraint, mapper), typeArgument),
	            reportErrors2 ? typeArgumentNodes[i] : void 0,
	            typeArgumentHeadMessage,
	            errorInfo
	          )) {
	            return void 0;
	          }
	        }
	      }
	      return typeArgumentTypes;
	    }
	    function getJsxReferenceKind(node) {
	      if (isJsxIntrinsicTagName(node.tagName)) {
	        return 2 /* Mixed */;
	      }
	      const tagType = getApparentType(checkExpression(node.tagName));
	      if (length(getSignaturesOfType(tagType, 1 /* Construct */))) {
	        return 0 /* Component */;
	      }
	      if (length(getSignaturesOfType(tagType, 0 /* Call */))) {
	        return 1 /* Function */;
	      }
	      return 2 /* Mixed */;
	    }
	    function checkApplicableSignatureForJsxOpeningLikeElement(node, signature, relation, checkMode, reportErrors2, containingMessageChain, errorOutputContainer) {
	      const paramType = getEffectiveFirstArgumentForJsxSignature(signature, node);
	      const attributesType = checkExpressionWithContextualType(
	        node.attributes,
	        paramType,
	        /*inferenceContext*/
	        void 0,
	        checkMode
	      );
	      const checkAttributesType = checkMode & 4 /* SkipContextSensitive */ ? getRegularTypeOfObjectLiteral(attributesType) : attributesType;
	      return checkTagNameDoesNotExpectTooManyArguments() && checkTypeRelatedToAndOptionallyElaborate(
	        checkAttributesType,
	        paramType,
	        relation,
	        reportErrors2 ? node.tagName : void 0,
	        node.attributes,
	        /*headMessage*/
	        void 0,
	        containingMessageChain,
	        errorOutputContainer
	      );
	      function checkTagNameDoesNotExpectTooManyArguments() {
	        var _a;
	        if (getJsxNamespaceContainerForImplicitImport(node)) {
	          return true;
	        }
	        const tagType = (isJsxOpeningElement(node) || isJsxSelfClosingElement(node)) && !(isJsxIntrinsicTagName(node.tagName) || isJsxNamespacedName(node.tagName)) ? checkExpression(node.tagName) : void 0;
	        if (!tagType) {
	          return true;
	        }
	        const tagCallSignatures = getSignaturesOfType(tagType, 0 /* Call */);
	        if (!length(tagCallSignatures)) {
	          return true;
	        }
	        const factory2 = getJsxFactoryEntity(node);
	        if (!factory2) {
	          return true;
	        }
	        const factorySymbol = resolveEntityName(
	          factory2,
	          111551 /* Value */,
	          /*ignoreErrors*/
	          true,
	          /*dontResolveAlias*/
	          false,
	          node
	        );
	        if (!factorySymbol) {
	          return true;
	        }
	        const factoryType = getTypeOfSymbol(factorySymbol);
	        const callSignatures = getSignaturesOfType(factoryType, 0 /* Call */);
	        if (!length(callSignatures)) {
	          return true;
	        }
	        let hasFirstParamSignatures = false;
	        let maxParamCount = 0;
	        for (const sig of callSignatures) {
	          const firstparam = getTypeAtPosition(sig, 0);
	          const signaturesOfParam = getSignaturesOfType(firstparam, 0 /* Call */);
	          if (!length(signaturesOfParam))
	            continue;
	          for (const paramSig of signaturesOfParam) {
	            hasFirstParamSignatures = true;
	            if (hasEffectiveRestParameter(paramSig)) {
	              return true;
	            }
	            const paramCount = getParameterCount(paramSig);
	            if (paramCount > maxParamCount) {
	              maxParamCount = paramCount;
	            }
	          }
	        }
	        if (!hasFirstParamSignatures) {
	          return true;
	        }
	        let absoluteMinArgCount = Infinity;
	        for (const tagSig of tagCallSignatures) {
	          const tagRequiredArgCount = getMinArgumentCount(tagSig);
	          if (tagRequiredArgCount < absoluteMinArgCount) {
	            absoluteMinArgCount = tagRequiredArgCount;
	          }
	        }
	        if (absoluteMinArgCount <= maxParamCount) {
	          return true;
	        }
	        if (reportErrors2) {
	          const diag2 = createDiagnosticForNode(node.tagName, Diagnostics.Tag_0_expects_at_least_1_arguments_but_the_JSX_factory_2_provides_at_most_3, entityNameToString(node.tagName), absoluteMinArgCount, entityNameToString(factory2), maxParamCount);
	          const tagNameDeclaration = (_a = getSymbolAtLocation(node.tagName)) == null ? void 0 : _a.valueDeclaration;
	          if (tagNameDeclaration) {
	            addRelatedInfo(diag2, createDiagnosticForNode(tagNameDeclaration, Diagnostics._0_is_declared_here, entityNameToString(node.tagName)));
	          }
	          if (errorOutputContainer && errorOutputContainer.skipLogging) {
	            (errorOutputContainer.errors || (errorOutputContainer.errors = [])).push(diag2);
	          }
	          if (!errorOutputContainer.skipLogging) {
	            diagnostics.add(diag2);
	          }
	        }
	        return false;
	      }
	    }
	    function getEffectiveCheckNode(argument) {
	      argument = skipParentheses(argument);
	      return isSatisfiesExpression(argument) ? skipParentheses(argument.expression) : argument;
	    }
	    function getSignatureApplicabilityError(node, args, signature, relation, checkMode, reportErrors2, containingMessageChain) {
	      const errorOutputContainer = { errors: void 0, skipLogging: true };
	      if (isJsxOpeningLikeElement(node)) {
	        if (!checkApplicableSignatureForJsxOpeningLikeElement(node, signature, relation, checkMode, reportErrors2, containingMessageChain, errorOutputContainer)) {
	          Debug.assert(!reportErrors2 || !!errorOutputContainer.errors, "jsx should have errors when reporting errors");
	          return errorOutputContainer.errors || emptyArray;
	        }
	        return void 0;
	      }
	      const thisType = getThisTypeOfSignature(signature);
	      if (thisType && thisType !== voidType && !(isNewExpression(node) || isCallExpression(node) && isSuperProperty(node.expression))) {
	        const thisArgumentNode = getThisArgumentOfCall(node);
	        const thisArgumentType = getThisArgumentType(thisArgumentNode);
	        const errorNode = reportErrors2 ? thisArgumentNode || node : void 0;
	        const headMessage2 = Diagnostics.The_this_context_of_type_0_is_not_assignable_to_method_s_this_of_type_1;
	        if (!checkTypeRelatedTo(thisArgumentType, thisType, relation, errorNode, headMessage2, containingMessageChain, errorOutputContainer)) {
	          Debug.assert(!reportErrors2 || !!errorOutputContainer.errors, "this parameter should have errors when reporting errors");
	          return errorOutputContainer.errors || emptyArray;
	        }
	      }
	      const headMessage = Diagnostics.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1;
	      const restType = getNonArrayRestType(signature);
	      const argCount = restType ? Math.min(getParameterCount(signature) - 1, args.length) : args.length;
	      for (let i = 0; i < argCount; i++) {
	        const arg = args[i];
	        if (arg.kind !== 232 /* OmittedExpression */) {
	          const paramType = getTypeAtPosition(signature, i);
	          const argType = checkExpressionWithContextualType(
	            arg,
	            paramType,
	            /*inferenceContext*/
	            void 0,
	            checkMode
	          );
	          const checkArgType = checkMode & 4 /* SkipContextSensitive */ ? getRegularTypeOfObjectLiteral(argType) : argType;
	          const effectiveCheckArgumentNode = getEffectiveCheckNode(arg);
	          if (!checkTypeRelatedToAndOptionallyElaborate(checkArgType, paramType, relation, reportErrors2 ? effectiveCheckArgumentNode : void 0, effectiveCheckArgumentNode, headMessage, containingMessageChain, errorOutputContainer)) {
	            Debug.assert(!reportErrors2 || !!errorOutputContainer.errors, "parameter should have errors when reporting errors");
	            maybeAddMissingAwaitInfo(arg, checkArgType, paramType);
	            return errorOutputContainer.errors || emptyArray;
	          }
	        }
	      }
	      if (restType) {
	        const spreadType = getSpreadArgumentType(
	          args,
	          argCount,
	          args.length,
	          restType,
	          /*context*/
	          void 0,
	          checkMode
	        );
	        const restArgCount = args.length - argCount;
	        const errorNode = !reportErrors2 ? void 0 : restArgCount === 0 ? node : restArgCount === 1 ? getEffectiveCheckNode(args[argCount]) : setTextRangePosEnd(createSyntheticExpression(node, spreadType), args[argCount].pos, args[args.length - 1].end);
	        if (!checkTypeRelatedTo(
	          spreadType,
	          restType,
	          relation,
	          errorNode,
	          headMessage,
	          /*containingMessageChain*/
	          void 0,
	          errorOutputContainer
	        )) {
	          Debug.assert(!reportErrors2 || !!errorOutputContainer.errors, "rest parameter should have errors when reporting errors");
	          maybeAddMissingAwaitInfo(errorNode, spreadType, restType);
	          return errorOutputContainer.errors || emptyArray;
	        }
	      }
	      return void 0;
	      function maybeAddMissingAwaitInfo(errorNode, source, target) {
	        if (errorNode && reportErrors2 && errorOutputContainer.errors && errorOutputContainer.errors.length) {
	          if (getAwaitedTypeOfPromise(target)) {
	            return;
	          }
	          const awaitedTypeOfSource = getAwaitedTypeOfPromise(source);
	          if (awaitedTypeOfSource && isTypeRelatedTo(awaitedTypeOfSource, target, relation)) {
	            addRelatedInfo(errorOutputContainer.errors[0], createDiagnosticForNode(errorNode, Diagnostics.Did_you_forget_to_use_await));
	          }
	        }
	      }
	    }
	    function getThisArgumentOfCall(node) {
	      if (node.kind === 226 /* BinaryExpression */) {
	        return node.right;
	      }
	      const expression = node.kind === 213 /* CallExpression */ ? node.expression : node.kind === 215 /* TaggedTemplateExpression */ ? node.tag : node.kind === 170 /* Decorator */ && !legacyDecorators ? node.expression : void 0;
	      if (expression) {
	        const callee = skipOuterExpressions(expression);
	        if (isAccessExpression(callee)) {
	          return callee.expression;
	        }
	      }
	    }
	    function createSyntheticExpression(parent2, type, isSpread, tupleNameSource) {
	      const result = parseNodeFactory.createSyntheticExpression(type, isSpread, tupleNameSource);
	      setTextRange(result, parent2);
	      setParent(result, parent2);
	      return result;
	    }
	    function getEffectiveCallArguments(node) {
	      if (node.kind === 215 /* TaggedTemplateExpression */) {
	        const template = node.template;
	        const args2 = [createSyntheticExpression(template, getGlobalTemplateStringsArrayType())];
	        if (template.kind === 228 /* TemplateExpression */) {
	          forEach(template.templateSpans, (span) => {
	            args2.push(span.expression);
	          });
	        }
	        return args2;
	      }
	      if (node.kind === 170 /* Decorator */) {
	        return getEffectiveDecoratorArguments(node);
	      }
	      if (node.kind === 226 /* BinaryExpression */) {
	        return [node.left];
	      }
	      if (isJsxOpeningLikeElement(node)) {
	        return node.attributes.properties.length > 0 || isJsxOpeningElement(node) && node.parent.children.length > 0 ? [node.attributes] : emptyArray;
	      }
	      const args = node.arguments || emptyArray;
	      const spreadIndex = getSpreadArgumentIndex(args);
	      if (spreadIndex >= 0) {
	        const effectiveArgs = args.slice(0, spreadIndex);
	        for (let i = spreadIndex; i < args.length; i++) {
	          const arg = args[i];
	          const spreadType = arg.kind === 230 /* SpreadElement */ && (flowLoopCount ? checkExpression(arg.expression) : checkExpressionCached(arg.expression));
	          if (spreadType && isTupleType(spreadType)) {
	            forEach(getElementTypes(spreadType), (t, i2) => {
	              var _a;
	              const flags = spreadType.target.elementFlags[i2];
	              const syntheticArg = createSyntheticExpression(arg, flags & 4 /* Rest */ ? createArrayType(t) : t, !!(flags & 12 /* Variable */), (_a = spreadType.target.labeledElementDeclarations) == null ? void 0 : _a[i2]);
	              effectiveArgs.push(syntheticArg);
	            });
	          } else {
	            effectiveArgs.push(arg);
	          }
	        }
	        return effectiveArgs;
	      }
	      return args;
	    }
	    function getEffectiveDecoratorArguments(node) {
	      const expr = node.expression;
	      const signature = getDecoratorCallSignature(node);
	      if (signature) {
	        const args = [];
	        for (const param of signature.parameters) {
	          const type = getTypeOfSymbol(param);
	          args.push(createSyntheticExpression(expr, type));
	        }
	        return args;
	      }
	      return Debug.fail();
	    }
	    function getDecoratorArgumentCount(node, signature) {
	      return compilerOptions.experimentalDecorators ? getLegacyDecoratorArgumentCount(node, signature) : 2;
	    }
	    function getLegacyDecoratorArgumentCount(node, signature) {
	      switch (node.parent.kind) {
	        case 263 /* ClassDeclaration */:
	        case 231 /* ClassExpression */:
	          return 1;
	        case 172 /* PropertyDeclaration */:
	          return hasAccessorModifier(node.parent) ? 3 : 2;
	        case 174 /* MethodDeclaration */:
	        case 177 /* GetAccessor */:
	        case 178 /* SetAccessor */:
	          return languageVersion === 0 /* ES3 */ || signature.parameters.length <= 2 ? 2 : 3;
	        case 169 /* Parameter */:
	          return 3;
	        default:
	          return Debug.fail();
	      }
	    }
	    function getDiagnosticSpanForCallNode(node) {
	      const sourceFile = getSourceFileOfNode(node);
	      const { start, length: length2 } = getErrorSpanForNode(sourceFile, isPropertyAccessExpression(node.expression) ? node.expression.name : node.expression);
	      return { start, length: length2, sourceFile };
	    }
	    function getDiagnosticForCallNode(node, message, ...args) {
	      if (isCallExpression(node)) {
	        const { sourceFile, start, length: length2 } = getDiagnosticSpanForCallNode(node);
	        if ("message" in message) {
	          return createFileDiagnostic(sourceFile, start, length2, message, ...args);
	        }
	        return createDiagnosticForFileFromMessageChain(sourceFile, message);
	      } else {
	        if ("message" in message) {
	          return createDiagnosticForNode(node, message, ...args);
	        }
	        return createDiagnosticForNodeFromMessageChain(getSourceFileOfNode(node), node, message);
	      }
	    }
	    function getErrorNodeForCallNode(callLike) {
	      if (isCallOrNewExpression(callLike)) {
	        return isPropertyAccessExpression(callLike.expression) ? callLike.expression.name : callLike.expression;
	      }
	      if (isTaggedTemplateExpression(callLike)) {
	        return isPropertyAccessExpression(callLike.tag) ? callLike.tag.name : callLike.tag;
	      }
	      if (isJsxOpeningLikeElement(callLike)) {
	        return callLike.tagName;
	      }
	      return callLike;
	    }
	    function isPromiseResolveArityError(node) {
	      if (!isCallExpression(node) || !isIdentifier(node.expression))
	        return false;
	      const symbol = resolveName(
	        node.expression,
	        node.expression.escapedText,
	        111551 /* Value */,
	        /*nameNotFoundMessage*/
	        void 0,
	        /*nameArg*/
	        void 0,
	        /*isUse*/
	        false
	      );
	      const decl = symbol == null ? void 0 : symbol.valueDeclaration;
	      if (!decl || !isParameter(decl) || !isFunctionExpressionOrArrowFunction(decl.parent) || !isNewExpression(decl.parent.parent) || !isIdentifier(decl.parent.parent.expression)) {
	        return false;
	      }
	      const globalPromiseSymbol = getGlobalPromiseConstructorSymbol(
	        /*reportErrors*/
	        false
	      );
	      if (!globalPromiseSymbol)
	        return false;
	      const constructorSymbol = getSymbolAtLocation(
	        decl.parent.parent.expression,
	        /*ignoreErrors*/
	        true
	      );
	      return constructorSymbol === globalPromiseSymbol;
	    }
	    function getArgumentArityError(node, signatures, args, headMessage) {
	      var _a;
	      const spreadIndex = getSpreadArgumentIndex(args);
	      if (spreadIndex > -1) {
	        return createDiagnosticForNode(args[spreadIndex], Diagnostics.A_spread_argument_must_either_have_a_tuple_type_or_be_passed_to_a_rest_parameter);
	      }
	      let min2 = Number.POSITIVE_INFINITY;
	      let max = Number.NEGATIVE_INFINITY;
	      let maxBelow = Number.NEGATIVE_INFINITY;
	      let minAbove = Number.POSITIVE_INFINITY;
	      let closestSignature;
	      for (const sig of signatures) {
	        const minParameter = getMinArgumentCount(sig);
	        const maxParameter = getParameterCount(sig);
	        if (minParameter < min2) {
	          min2 = minParameter;
	          closestSignature = sig;
	        }
	        max = Math.max(max, maxParameter);
	        if (minParameter < args.length && minParameter > maxBelow)
	          maxBelow = minParameter;
	        if (args.length < maxParameter && maxParameter < minAbove)
	          minAbove = maxParameter;
	      }
	      const hasRestParameter2 = some(signatures, hasEffectiveRestParameter);
	      const parameterRange = hasRestParameter2 ? min2 : min2 < max ? min2 + "-" + max : min2;
	      const isVoidPromiseError = !hasRestParameter2 && parameterRange === 1 && args.length === 0 && isPromiseResolveArityError(node);
	      if (isVoidPromiseError && isInJSFile(node)) {
	        return getDiagnosticForCallNode(node, Diagnostics.Expected_1_argument_but_got_0_new_Promise_needs_a_JSDoc_hint_to_produce_a_resolve_that_can_be_called_without_arguments);
	      }
	      const error3 = isDecorator(node) ? hasRestParameter2 ? Diagnostics.The_runtime_will_invoke_the_decorator_with_1_arguments_but_the_decorator_expects_at_least_0 : Diagnostics.The_runtime_will_invoke_the_decorator_with_1_arguments_but_the_decorator_expects_0 : hasRestParameter2 ? Diagnostics.Expected_at_least_0_arguments_but_got_1 : isVoidPromiseError ? Diagnostics.Expected_0_arguments_but_got_1_Did_you_forget_to_include_void_in_your_type_argument_to_Promise : Diagnostics.Expected_0_arguments_but_got_1;
	      if (min2 < args.length && args.length < max) {
	        if (headMessage) {
	          let chain = chainDiagnosticMessages(
	            /*details*/
	            void 0,
	            Diagnostics.No_overload_expects_0_arguments_but_overloads_do_exist_that_expect_either_1_or_2_arguments,
	            args.length,
	            maxBelow,
	            minAbove
	          );
	          chain = chainDiagnosticMessages(chain, headMessage);
	          return getDiagnosticForCallNode(node, chain);
	        }
	        return getDiagnosticForCallNode(node, Diagnostics.No_overload_expects_0_arguments_but_overloads_do_exist_that_expect_either_1_or_2_arguments, args.length, maxBelow, minAbove);
	      } else if (args.length < min2) {
	        let diagnostic;
	        if (headMessage) {
	          let chain = chainDiagnosticMessages(
	            /*details*/
	            void 0,
	            error3,
	            parameterRange,
	            args.length
	          );
	          chain = chainDiagnosticMessages(chain, headMessage);
	          diagnostic = getDiagnosticForCallNode(node, chain);
	        } else {
	          diagnostic = getDiagnosticForCallNode(node, error3, parameterRange, args.length);
	        }
	        const parameter = (_a = closestSignature == null ? void 0 : closestSignature.declaration) == null ? void 0 : _a.parameters[closestSignature.thisParameter ? args.length + 1 : args.length];
	        if (parameter) {
	          const messageAndArgs = isBindingPattern(parameter.name) ? [Diagnostics.An_argument_matching_this_binding_pattern_was_not_provided] : isRestParameter(parameter) ? [Diagnostics.Arguments_for_the_rest_parameter_0_were_not_provided, idText(getFirstIdentifier(parameter.name))] : [Diagnostics.An_argument_for_0_was_not_provided, !parameter.name ? args.length : idText(getFirstIdentifier(parameter.name))];
	          const parameterError = createDiagnosticForNode(parameter, ...messageAndArgs);
	          return addRelatedInfo(diagnostic, parameterError);
	        }
	        return diagnostic;
	      } else {
	        const errorSpan = factory.createNodeArray(args.slice(max));
	        const pos = first(errorSpan).pos;
	        let end = last(errorSpan).end;
	        if (end === pos) {
	          end++;
	        }
	        setTextRangePosEnd(errorSpan, pos, end);
	        if (headMessage) {
	          let chain = chainDiagnosticMessages(
	            /*details*/
	            void 0,
	            error3,
	            parameterRange,
	            args.length
	          );
	          chain = chainDiagnosticMessages(chain, headMessage);
	          return createDiagnosticForNodeArrayFromMessageChain(getSourceFileOfNode(node), errorSpan, chain);
	        }
	        return createDiagnosticForNodeArray(getSourceFileOfNode(node), errorSpan, error3, parameterRange, args.length);
	      }
	    }
	    function getTypeArgumentArityError(node, signatures, typeArguments, headMessage) {
	      const argCount = typeArguments.length;
	      if (signatures.length === 1) {
	        const sig = signatures[0];
	        const min2 = getMinTypeArgumentCount(sig.typeParameters);
	        const max = length(sig.typeParameters);
	        if (headMessage) {
	          let chain = chainDiagnosticMessages(
	            /*details*/
	            void 0,
	            Diagnostics.Expected_0_type_arguments_but_got_1,
	            min2 < max ? min2 + "-" + max : min2,
	            argCount
	          );
	          chain = chainDiagnosticMessages(chain, headMessage);
	          return createDiagnosticForNodeArrayFromMessageChain(getSourceFileOfNode(node), typeArguments, chain);
	        }
	        return createDiagnosticForNodeArray(getSourceFileOfNode(node), typeArguments, Diagnostics.Expected_0_type_arguments_but_got_1, min2 < max ? min2 + "-" + max : min2, argCount);
	      }
	      let belowArgCount = -Infinity;
	      let aboveArgCount = Infinity;
	      for (const sig of signatures) {
	        const min2 = getMinTypeArgumentCount(sig.typeParameters);
	        const max = length(sig.typeParameters);
	        if (min2 > argCount) {
	          aboveArgCount = Math.min(aboveArgCount, min2);
	        } else if (max < argCount) {
	          belowArgCount = Math.max(belowArgCount, max);
	        }
	      }
	      if (belowArgCount !== -Infinity && aboveArgCount !== Infinity) {
	        if (headMessage) {
	          let chain = chainDiagnosticMessages(
	            /*details*/
	            void 0,
	            Diagnostics.No_overload_expects_0_type_arguments_but_overloads_do_exist_that_expect_either_1_or_2_type_arguments,
	            argCount,
	            belowArgCount,
	            aboveArgCount
	          );
	          chain = chainDiagnosticMessages(chain, headMessage);
	          return createDiagnosticForNodeArrayFromMessageChain(getSourceFileOfNode(node), typeArguments, chain);
	        }
	        return createDiagnosticForNodeArray(getSourceFileOfNode(node), typeArguments, Diagnostics.No_overload_expects_0_type_arguments_but_overloads_do_exist_that_expect_either_1_or_2_type_arguments, argCount, belowArgCount, aboveArgCount);
	      }
	      if (headMessage) {
	        let chain = chainDiagnosticMessages(
	          /*details*/
	          void 0,
	          Diagnostics.Expected_0_type_arguments_but_got_1,
	          belowArgCount === -Infinity ? aboveArgCount : belowArgCount,
	          argCount
	        );
	        chain = chainDiagnosticMessages(chain, headMessage);
	        return createDiagnosticForNodeArrayFromMessageChain(getSourceFileOfNode(node), typeArguments, chain);
	      }
	      return createDiagnosticForNodeArray(getSourceFileOfNode(node), typeArguments, Diagnostics.Expected_0_type_arguments_but_got_1, belowArgCount === -Infinity ? aboveArgCount : belowArgCount, argCount);
	    }
	    function resolveCall(node, signatures, candidatesOutArray, checkMode, callChainFlags, headMessage) {
	      const isTaggedTemplate = node.kind === 215 /* TaggedTemplateExpression */;
	      const isDecorator2 = node.kind === 170 /* Decorator */;
	      const isJsxOpeningOrSelfClosingElement = isJsxOpeningLikeElement(node);
	      const isInstanceof = node.kind === 226 /* BinaryExpression */;
	      const reportErrors2 = !isInferencePartiallyBlocked && !candidatesOutArray;
	      let typeArguments;
	      if (!isDecorator2 && !isInstanceof && !isSuperCall(node)) {
	        typeArguments = node.typeArguments;
	        if (isTaggedTemplate || isJsxOpeningOrSelfClosingElement || node.expression.kind !== 108 /* SuperKeyword */) {
	          forEach(typeArguments, checkSourceElement);
	        }
	      }
	      const candidates = candidatesOutArray || [];
	      reorderCandidates(signatures, candidates, callChainFlags);
	      Debug.assert(candidates.length, "Revert #54442 and add a testcase with whatever triggered this");
	      const args = getEffectiveCallArguments(node);
	      const isSingleNonGenericCandidate = candidates.length === 1 && !candidates[0].typeParameters;
	      let argCheckMode = !isDecorator2 && !isSingleNonGenericCandidate && some(args, isContextSensitive) ? 4 /* SkipContextSensitive */ : 0 /* Normal */;
	      let candidatesForArgumentError;
	      let candidateForArgumentArityError;
	      let candidateForTypeArgumentError;
	      let result;
	      const signatureHelpTrailingComma = !!(checkMode & 16 /* IsForSignatureHelp */) && node.kind === 213 /* CallExpression */ && node.arguments.hasTrailingComma;
	      if (candidates.length > 1) {
	        result = chooseOverload(candidates, subtypeRelation, isSingleNonGenericCandidate, signatureHelpTrailingComma);
	      }
	      if (!result) {
	        result = chooseOverload(candidates, assignableRelation, isSingleNonGenericCandidate, signatureHelpTrailingComma);
	      }
	      if (result) {
	        return result;
	      }
	      result = getCandidateForOverloadFailure(node, candidates, args, !!candidatesOutArray, checkMode);
	      getNodeLinks(node).resolvedSignature = result;
	      if (reportErrors2) {
	        if (!headMessage && isInstanceof) {
	          headMessage = Diagnostics.The_left_hand_side_of_an_instanceof_expression_must_be_assignable_to_the_first_argument_of_the_right_hand_side_s_Symbol_hasInstance_method;
	        }
	        if (candidatesForArgumentError) {
	          if (candidatesForArgumentError.length === 1 || candidatesForArgumentError.length > 3) {
	            const last2 = candidatesForArgumentError[candidatesForArgumentError.length - 1];
	            let chain;
	            if (candidatesForArgumentError.length > 3) {
	              chain = chainDiagnosticMessages(chain, Diagnostics.The_last_overload_gave_the_following_error);
	              chain = chainDiagnosticMessages(chain, Diagnostics.No_overload_matches_this_call);
	            }
	            if (headMessage) {
	              chain = chainDiagnosticMessages(chain, headMessage);
	            }
	            const diags = getSignatureApplicabilityError(
	              node,
	              args,
	              last2,
	              assignableRelation,
	              0 /* Normal */,
	              /*reportErrors*/
	              true,
	              () => chain
	            );
	            if (diags) {
	              for (const d of diags) {
	                if (last2.declaration && candidatesForArgumentError.length > 3) {
	                  addRelatedInfo(d, createDiagnosticForNode(last2.declaration, Diagnostics.The_last_overload_is_declared_here));
	                }
	                addImplementationSuccessElaboration(last2, d);
	                diagnostics.add(d);
	              }
	            } else {
	              Debug.fail("No error for last overload signature");
	            }
	          } else {
	            const allDiagnostics = [];
	            let max = 0;
	            let min2 = Number.MAX_VALUE;
	            let minIndex = 0;
	            let i = 0;
	            for (const c of candidatesForArgumentError) {
	              const chain2 = () => chainDiagnosticMessages(
	                /*details*/
	                void 0,
	                Diagnostics.Overload_0_of_1_2_gave_the_following_error,
	                i + 1,
	                candidates.length,
	                signatureToString(c)
	              );
	              const diags2 = getSignatureApplicabilityError(
	                node,
	                args,
	                c,
	                assignableRelation,
	                0 /* Normal */,
	                /*reportErrors*/
	                true,
	                chain2
	              );
	              if (diags2) {
	                if (diags2.length <= min2) {
	                  min2 = diags2.length;
	                  minIndex = i;
	                }
	                max = Math.max(max, diags2.length);
	                allDiagnostics.push(diags2);
	              } else {
	                Debug.fail("No error for 3 or fewer overload signatures");
	              }
	              i++;
	            }
	            const diags = max > 1 ? allDiagnostics[minIndex] : flatten(allDiagnostics);
	            Debug.assert(diags.length > 0, "No errors reported for 3 or fewer overload signatures");
	            let chain = chainDiagnosticMessages(
	              map(diags, createDiagnosticMessageChainFromDiagnostic),
	              Diagnostics.No_overload_matches_this_call
	            );
	            if (headMessage) {
	              chain = chainDiagnosticMessages(chain, headMessage);
	            }
	            const related = [...flatMap(diags, (d) => d.relatedInformation)];
	            let diag2;
	            if (every(diags, (d) => d.start === diags[0].start && d.length === diags[0].length && d.file === diags[0].file)) {
	              const { file, start, length: length2 } = diags[0];
	              diag2 = { file, start, length: length2, code: chain.code, category: chain.category, messageText: chain, relatedInformation: related };
	            } else {
	              diag2 = createDiagnosticForNodeFromMessageChain(getSourceFileOfNode(node), getErrorNodeForCallNode(node), chain, related);
	            }
	            addImplementationSuccessElaboration(candidatesForArgumentError[0], diag2);
	            diagnostics.add(diag2);
	          }
	        } else if (candidateForArgumentArityError) {
	          diagnostics.add(getArgumentArityError(node, [candidateForArgumentArityError], args, headMessage));
	        } else if (candidateForTypeArgumentError) {
	          checkTypeArguments(
	            candidateForTypeArgumentError,
	            node.typeArguments,
	            /*reportErrors*/
	            true,
	            headMessage
	          );
	        } else {
	          const signaturesWithCorrectTypeArgumentArity = filter(signatures, (s) => hasCorrectTypeArgumentArity(s, typeArguments));
	          if (signaturesWithCorrectTypeArgumentArity.length === 0) {
	            diagnostics.add(getTypeArgumentArityError(node, signatures, typeArguments, headMessage));
	          } else {
	            diagnostics.add(getArgumentArityError(node, signaturesWithCorrectTypeArgumentArity, args, headMessage));
	          }
	        }
	      }
	      return result;
	      function addImplementationSuccessElaboration(failed, diagnostic) {
	        var _a, _b;
	        const oldCandidatesForArgumentError = candidatesForArgumentError;
	        const oldCandidateForArgumentArityError = candidateForArgumentArityError;
	        const oldCandidateForTypeArgumentError = candidateForTypeArgumentError;
	        const failedSignatureDeclarations = ((_b = (_a = failed.declaration) == null ? void 0 : _a.symbol) == null ? void 0 : _b.declarations) || emptyArray;
	        const isOverload2 = failedSignatureDeclarations.length > 1;
	        const implDecl = isOverload2 ? find(failedSignatureDeclarations, (d) => isFunctionLikeDeclaration(d) && nodeIsPresent(d.body)) : void 0;
	        if (implDecl) {
	          const candidate = getSignatureFromDeclaration(implDecl);
	          const isSingleNonGenericCandidate2 = !candidate.typeParameters;
	          if (chooseOverload([candidate], assignableRelation, isSingleNonGenericCandidate2)) {
	            addRelatedInfo(diagnostic, createDiagnosticForNode(implDecl, Diagnostics.The_call_would_have_succeeded_against_this_implementation_but_implementation_signatures_of_overloads_are_not_externally_visible));
	          }
	        }
	        candidatesForArgumentError = oldCandidatesForArgumentError;
	        candidateForArgumentArityError = oldCandidateForArgumentArityError;
	        candidateForTypeArgumentError = oldCandidateForTypeArgumentError;
	      }
	      function chooseOverload(candidates2, relation, isSingleNonGenericCandidate2, signatureHelpTrailingComma2 = false) {
	        candidatesForArgumentError = void 0;
	        candidateForArgumentArityError = void 0;
	        candidateForTypeArgumentError = void 0;
	        if (isSingleNonGenericCandidate2) {
	          const candidate = candidates2[0];
	          if (some(typeArguments) || !hasCorrectArity(node, args, candidate, signatureHelpTrailingComma2)) {
	            return void 0;
	          }
	          if (getSignatureApplicabilityError(
	            node,
	            args,
	            candidate,
	            relation,
	            0 /* Normal */,
	            /*reportErrors*/
	            false,
	            /*containingMessageChain*/
	            void 0
	          )) {
	            candidatesForArgumentError = [candidate];
	            return void 0;
	          }
	          return candidate;
	        }
	        for (let candidateIndex = 0; candidateIndex < candidates2.length; candidateIndex++) {
	          const candidate = candidates2[candidateIndex];
	          if (!hasCorrectTypeArgumentArity(candidate, typeArguments) || !hasCorrectArity(node, args, candidate, signatureHelpTrailingComma2)) {
	            continue;
	          }
	          let checkCandidate;
	          let inferenceContext;
	          if (candidate.typeParameters) {
	            let typeArgumentTypes;
	            if (some(typeArguments)) {
	              typeArgumentTypes = checkTypeArguments(
	                candidate,
	                typeArguments,
	                /*reportErrors*/
	                false
	              );
	              if (!typeArgumentTypes) {
	                candidateForTypeArgumentError = candidate;
	                continue;
	              }
	            } else {
	              inferenceContext = createInferenceContext(
	                candidate.typeParameters,
	                candidate,
	                /*flags*/
	                isInJSFile(node) ? 2 /* AnyDefault */ : 0 /* None */
	              );
	              typeArgumentTypes = inferTypeArguments(node, candidate, args, argCheckMode | 8 /* SkipGenericFunctions */, inferenceContext);
	              argCheckMode |= inferenceContext.flags & 4 /* SkippedGenericFunction */ ? 8 /* SkipGenericFunctions */ : 0 /* Normal */;
	            }
	            checkCandidate = getSignatureInstantiation(candidate, typeArgumentTypes, isInJSFile(candidate.declaration), inferenceContext && inferenceContext.inferredTypeParameters);
	            if (getNonArrayRestType(candidate) && !hasCorrectArity(node, args, checkCandidate, signatureHelpTrailingComma2)) {
	              candidateForArgumentArityError = checkCandidate;
	              continue;
	            }
	          } else {
	            checkCandidate = candidate;
	          }
	          if (getSignatureApplicabilityError(
	            node,
	            args,
	            checkCandidate,
	            relation,
	            argCheckMode,
	            /*reportErrors*/
	            false,
	            /*containingMessageChain*/
	            void 0
	          )) {
	            (candidatesForArgumentError || (candidatesForArgumentError = [])).push(checkCandidate);
	            continue;
	          }
	          if (argCheckMode) {
	            argCheckMode = 0 /* Normal */;
	            if (inferenceContext) {
	              const typeArgumentTypes = inferTypeArguments(node, candidate, args, argCheckMode, inferenceContext);
	              checkCandidate = getSignatureInstantiation(candidate, typeArgumentTypes, isInJSFile(candidate.declaration), inferenceContext.inferredTypeParameters);
	              if (getNonArrayRestType(candidate) && !hasCorrectArity(node, args, checkCandidate, signatureHelpTrailingComma2)) {
	                candidateForArgumentArityError = checkCandidate;
	                continue;
	              }
	            }
	            if (getSignatureApplicabilityError(
	              node,
	              args,
	              checkCandidate,
	              relation,
	              argCheckMode,
	              /*reportErrors*/
	              false,
	              /*containingMessageChain*/
	              void 0
	            )) {
	              (candidatesForArgumentError || (candidatesForArgumentError = [])).push(checkCandidate);
	              continue;
	            }
	          }
	          candidates2[candidateIndex] = checkCandidate;
	          return checkCandidate;
	        }
	        return void 0;
	      }
	    }
	    function getCandidateForOverloadFailure(node, candidates, args, hasCandidatesOutArray, checkMode) {
	      Debug.assert(candidates.length > 0);
	      checkNodeDeferred(node);
	      return hasCandidatesOutArray || candidates.length === 1 || candidates.some((c) => !!c.typeParameters) ? pickLongestCandidateSignature(node, candidates, args, checkMode) : createUnionOfSignaturesForOverloadFailure(candidates);
	    }
	    function createUnionOfSignaturesForOverloadFailure(candidates) {
	      const thisParameters = mapDefined(candidates, (c) => c.thisParameter);
	      let thisParameter;
	      if (thisParameters.length) {
	        thisParameter = createCombinedSymbolFromTypes(thisParameters, thisParameters.map(getTypeOfParameter));
	      }
	      const { min: minArgumentCount, max: maxNonRestParam } = minAndMax(candidates, getNumNonRestParameters);
	      const parameters = [];
	      for (let i = 0; i < maxNonRestParam; i++) {
	        const symbols = mapDefined(candidates, (s) => signatureHasRestParameter(s) ? i < s.parameters.length - 1 ? s.parameters[i] : last(s.parameters) : i < s.parameters.length ? s.parameters[i] : void 0);
	        Debug.assert(symbols.length !== 0);
	        parameters.push(createCombinedSymbolFromTypes(symbols, mapDefined(candidates, (candidate) => tryGetTypeAtPosition(candidate, i))));
	      }
	      const restParameterSymbols = mapDefined(candidates, (c) => signatureHasRestParameter(c) ? last(c.parameters) : void 0);
	      let flags = 128 /* IsSignatureCandidateForOverloadFailure */;
	      if (restParameterSymbols.length !== 0) {
	        const type = createArrayType(getUnionType(mapDefined(candidates, tryGetRestTypeOfSignature), 2 /* Subtype */));
	        parameters.push(createCombinedSymbolForOverloadFailure(restParameterSymbols, type));
	        flags |= 1 /* HasRestParameter */;
	      }
	      if (candidates.some(signatureHasLiteralTypes)) {
	        flags |= 2 /* HasLiteralTypes */;
	      }
	      return createSignature(
	        candidates[0].declaration,
	        /*typeParameters*/
	        void 0,
	        // Before calling this we tested for `!candidates.some(c => !!c.typeParameters)`.
	        thisParameter,
	        parameters,
	        /*resolvedReturnType*/
	        getIntersectionType(candidates.map(getReturnTypeOfSignature)),
	        /*resolvedTypePredicate*/
	        void 0,
	        minArgumentCount,
	        flags
	      );
	    }
	    function getNumNonRestParameters(signature) {
	      const numParams = signature.parameters.length;
	      return signatureHasRestParameter(signature) ? numParams - 1 : numParams;
	    }
	    function createCombinedSymbolFromTypes(sources, types) {
	      return createCombinedSymbolForOverloadFailure(sources, getUnionType(types, 2 /* Subtype */));
	    }
	    function createCombinedSymbolForOverloadFailure(sources, type) {
	      return createSymbolWithType(first(sources), type);
	    }
	    function pickLongestCandidateSignature(node, candidates, args, checkMode) {
	      const bestIndex = getLongestCandidateIndex(candidates, apparentArgumentCount === void 0 ? args.length : apparentArgumentCount);
	      const candidate = candidates[bestIndex];
	      const { typeParameters } = candidate;
	      if (!typeParameters) {
	        return candidate;
	      }
	      const typeArgumentNodes = callLikeExpressionMayHaveTypeArguments(node) ? node.typeArguments : void 0;
	      const instantiated = typeArgumentNodes ? createSignatureInstantiation(candidate, getTypeArgumentsFromNodes(typeArgumentNodes, typeParameters, isInJSFile(node))) : inferSignatureInstantiationForOverloadFailure(node, typeParameters, candidate, args, checkMode);
	      candidates[bestIndex] = instantiated;
	      return instantiated;
	    }
	    function getTypeArgumentsFromNodes(typeArgumentNodes, typeParameters, isJs) {
	      const typeArguments = typeArgumentNodes.map(getTypeOfNode);
	      while (typeArguments.length > typeParameters.length) {
	        typeArguments.pop();
	      }
	      while (typeArguments.length < typeParameters.length) {
	        typeArguments.push(getDefaultFromTypeParameter(typeParameters[typeArguments.length]) || getConstraintOfTypeParameter(typeParameters[typeArguments.length]) || getDefaultTypeArgumentType(isJs));
	      }
	      return typeArguments;
	    }
	    function inferSignatureInstantiationForOverloadFailure(node, typeParameters, candidate, args, checkMode) {
	      const inferenceContext = createInferenceContext(
	        typeParameters,
	        candidate,
	        /*flags*/
	        isInJSFile(node) ? 2 /* AnyDefault */ : 0 /* None */
	      );
	      const typeArgumentTypes = inferTypeArguments(node, candidate, args, checkMode | 4 /* SkipContextSensitive */ | 8 /* SkipGenericFunctions */, inferenceContext);
	      return createSignatureInstantiation(candidate, typeArgumentTypes);
	    }
	    function getLongestCandidateIndex(candidates, argsCount) {
	      let maxParamsIndex = -1;
	      let maxParams = -1;
	      for (let i = 0; i < candidates.length; i++) {
	        const candidate = candidates[i];
	        const paramCount = getParameterCount(candidate);
	        if (hasEffectiveRestParameter(candidate) || paramCount >= argsCount) {
	          return i;
	        }
	        if (paramCount > maxParams) {
	          maxParams = paramCount;
	          maxParamsIndex = i;
	        }
	      }
	      return maxParamsIndex;
	    }
	    function resolveCallExpression(node, candidatesOutArray, checkMode) {
	      if (node.expression.kind === 108 /* SuperKeyword */) {
	        const superType = checkSuperExpression(node.expression);
	        if (isTypeAny(superType)) {
	          for (const arg of node.arguments) {
	            checkExpression(arg);
	          }
	          return anySignature;
	        }
	        if (!isErrorType(superType)) {
	          const baseTypeNode = getEffectiveBaseTypeNode(getContainingClass(node));
	          if (baseTypeNode) {
	            const baseConstructors = getInstantiatedConstructorsForTypeArguments(superType, baseTypeNode.typeArguments, baseTypeNode);
	            return resolveCall(node, baseConstructors, candidatesOutArray, checkMode, 0 /* None */);
	          }
	        }
	        return resolveUntypedCall(node);
	      }
	      let callChainFlags;
	      let funcType = checkExpression(node.expression);
	      if (isCallChain(node)) {
	        const nonOptionalType = getOptionalExpressionType(funcType, node.expression);
	        callChainFlags = nonOptionalType === funcType ? 0 /* None */ : isOutermostOptionalChain(node) ? 16 /* IsOuterCallChain */ : 8 /* IsInnerCallChain */;
	        funcType = nonOptionalType;
	      } else {
	        callChainFlags = 0 /* None */;
	      }
	      funcType = checkNonNullTypeWithReporter(
	        funcType,
	        node.expression,
	        reportCannotInvokePossiblyNullOrUndefinedError
	      );
	      if (funcType === silentNeverType) {
	        return silentNeverSignature;
	      }
	      const apparentType = getApparentType(funcType);
	      if (isErrorType(apparentType)) {
	        return resolveErrorCall(node);
	      }
	      const callSignatures = getSignaturesOfType(apparentType, 0 /* Call */);
	      const numConstructSignatures = getSignaturesOfType(apparentType, 1 /* Construct */).length;
	      if (isUntypedFunctionCall(funcType, apparentType, callSignatures.length, numConstructSignatures)) {
	        if (!isErrorType(funcType) && node.typeArguments) {
	          error2(node, Diagnostics.Untyped_function_calls_may_not_accept_type_arguments);
	        }
	        return resolveUntypedCall(node);
	      }
	      if (!callSignatures.length) {
	        if (numConstructSignatures) {
	          error2(node, Diagnostics.Value_of_type_0_is_not_callable_Did_you_mean_to_include_new, typeToString(funcType));
	        } else {
	          let relatedInformation;
	          if (node.arguments.length === 1) {
	            const text = getSourceFileOfNode(node).text;
	            if (isLineBreak(text.charCodeAt(skipTrivia(
	              text,
	              node.expression.end,
	              /*stopAfterLineBreak*/
	              true
	            ) - 1))) {
	              relatedInformation = createDiagnosticForNode(node.expression, Diagnostics.Are_you_missing_a_semicolon);
	            }
	          }
	          invocationError(node.expression, apparentType, 0 /* Call */, relatedInformation);
	        }
	        return resolveErrorCall(node);
	      }
	      if (checkMode & 8 /* SkipGenericFunctions */ && !node.typeArguments && callSignatures.some(isGenericFunctionReturningFunction)) {
	        skippedGenericFunction(node, checkMode);
	        return resolvingSignature;
	      }
	      if (callSignatures.some((sig) => isInJSFile(sig.declaration) && !!getJSDocClassTag(sig.declaration))) {
	        error2(node, Diagnostics.Value_of_type_0_is_not_callable_Did_you_mean_to_include_new, typeToString(funcType));
	        return resolveErrorCall(node);
	      }
	      return resolveCall(node, callSignatures, candidatesOutArray, checkMode, callChainFlags);
	    }
	    function isGenericFunctionReturningFunction(signature) {
	      return !!(signature.typeParameters && isFunctionType(getReturnTypeOfSignature(signature)));
	    }
	    function isUntypedFunctionCall(funcType, apparentFuncType, numCallSignatures, numConstructSignatures) {
	      return isTypeAny(funcType) || isTypeAny(apparentFuncType) && !!(funcType.flags & 262144 /* TypeParameter */) || !numCallSignatures && !numConstructSignatures && !(apparentFuncType.flags & 1048576 /* Union */) && !(getReducedType(apparentFuncType).flags & 131072 /* Never */) && isTypeAssignableTo(funcType, globalFunctionType);
	    }
	    function resolveNewExpression(node, candidatesOutArray, checkMode) {
	      if (node.arguments && languageVersion < 1 /* ES5 */) {
	        const spreadIndex = getSpreadArgumentIndex(node.arguments);
	        if (spreadIndex >= 0) {
	          error2(node.arguments[spreadIndex], Diagnostics.Spread_operator_in_new_expressions_is_only_available_when_targeting_ECMAScript_5_and_higher);
	        }
	      }
	      let expressionType = checkNonNullExpression(node.expression);
	      if (expressionType === silentNeverType) {
	        return silentNeverSignature;
	      }
	      expressionType = getApparentType(expressionType);
	      if (isErrorType(expressionType)) {
	        return resolveErrorCall(node);
	      }
	      if (isTypeAny(expressionType)) {
	        if (node.typeArguments) {
	          error2(node, Diagnostics.Untyped_function_calls_may_not_accept_type_arguments);
	        }
	        return resolveUntypedCall(node);
	      }
	      const constructSignatures = getSignaturesOfType(expressionType, 1 /* Construct */);
	      if (constructSignatures.length) {
	        if (!isConstructorAccessible(node, constructSignatures[0])) {
	          return resolveErrorCall(node);
	        }
	        if (someSignature(constructSignatures, (signature) => !!(signature.flags & 4 /* Abstract */))) {
	          error2(node, Diagnostics.Cannot_create_an_instance_of_an_abstract_class);
	          return resolveErrorCall(node);
	        }
	        const valueDecl = expressionType.symbol && getClassLikeDeclarationOfSymbol(expressionType.symbol);
	        if (valueDecl && hasSyntacticModifier(valueDecl, 64 /* Abstract */)) {
	          error2(node, Diagnostics.Cannot_create_an_instance_of_an_abstract_class);
	          return resolveErrorCall(node);
	        }
	        return resolveCall(node, constructSignatures, candidatesOutArray, checkMode, 0 /* None */);
	      }
	      const callSignatures = getSignaturesOfType(expressionType, 0 /* Call */);
	      if (callSignatures.length) {
	        const signature = resolveCall(node, callSignatures, candidatesOutArray, checkMode, 0 /* None */);
	        if (!noImplicitAny) {
	          if (signature.declaration && !isJSConstructor(signature.declaration) && getReturnTypeOfSignature(signature) !== voidType) {
	            error2(node, Diagnostics.Only_a_void_function_can_be_called_with_the_new_keyword);
	          }
	          if (getThisTypeOfSignature(signature) === voidType) {
	            error2(node, Diagnostics.A_function_that_is_called_with_the_new_keyword_cannot_have_a_this_type_that_is_void);
	          }
	        }
	        return signature;
	      }
	      invocationError(node.expression, expressionType, 1 /* Construct */);
	      return resolveErrorCall(node);
	    }
	    function someSignature(signatures, f) {
	      if (isArray(signatures)) {
	        return some(signatures, (signature) => someSignature(signature, f));
	      }
	      return signatures.compositeKind === 1048576 /* Union */ ? some(signatures.compositeSignatures, f) : f(signatures);
	    }
	    function typeHasProtectedAccessibleBase(target, type) {
	      const baseTypes = getBaseTypes(type);
	      if (!length(baseTypes)) {
	        return false;
	      }
	      const firstBase = baseTypes[0];
	      if (firstBase.flags & 2097152 /* Intersection */) {
	        const types = firstBase.types;
	        const mixinFlags = findMixins(types);
	        let i = 0;
	        for (const intersectionMember of firstBase.types) {
	          if (!mixinFlags[i]) {
	            if (getObjectFlags(intersectionMember) & (1 /* Class */ | 2 /* Interface */)) {
	              if (intersectionMember.symbol === target) {
	                return true;
	              }
	              if (typeHasProtectedAccessibleBase(target, intersectionMember)) {
	                return true;
	              }
	            }
	          }
	          i++;
	        }
	        return false;
	      }
	      if (firstBase.symbol === target) {
	        return true;
	      }
	      return typeHasProtectedAccessibleBase(target, firstBase);
	    }
	    function isConstructorAccessible(node, signature) {
	      if (!signature || !signature.declaration) {
	        return true;
	      }
	      const declaration = signature.declaration;
	      const modifiers = getSelectedEffectiveModifierFlags(declaration, 6 /* NonPublicAccessibilityModifier */);
	      if (!modifiers || declaration.kind !== 176 /* Constructor */) {
	        return true;
	      }
	      const declaringClassDeclaration = getClassLikeDeclarationOfSymbol(declaration.parent.symbol);
	      const declaringClass = getDeclaredTypeOfSymbol(declaration.parent.symbol);
	      if (!isNodeWithinClass(node, declaringClassDeclaration)) {
	        const containingClass = getContainingClass(node);
	        if (containingClass && modifiers & 4 /* Protected */) {
	          const containingType = getTypeOfNode(containingClass);
	          if (typeHasProtectedAccessibleBase(declaration.parent.symbol, containingType)) {
	            return true;
	          }
	        }
	        if (modifiers & 2 /* Private */) {
	          error2(node, Diagnostics.Constructor_of_class_0_is_private_and_only_accessible_within_the_class_declaration, typeToString(declaringClass));
	        }
	        if (modifiers & 4 /* Protected */) {
	          error2(node, Diagnostics.Constructor_of_class_0_is_protected_and_only_accessible_within_the_class_declaration, typeToString(declaringClass));
	        }
	        return false;
	      }
	      return true;
	    }
	    function invocationErrorDetails(errorTarget, apparentType, kind) {
	      let errorInfo;
	      const isCall = kind === 0 /* Call */;
	      const awaitedType = getAwaitedType(apparentType);
	      const maybeMissingAwait = awaitedType && getSignaturesOfType(awaitedType, kind).length > 0;
	      if (apparentType.flags & 1048576 /* Union */) {
	        const types = apparentType.types;
	        let hasSignatures = false;
	        for (const constituent of types) {
	          const signatures = getSignaturesOfType(constituent, kind);
	          if (signatures.length !== 0) {
	            hasSignatures = true;
	            if (errorInfo) {
	              break;
	            }
	          } else {
	            if (!errorInfo) {
	              errorInfo = chainDiagnosticMessages(
	                errorInfo,
	                isCall ? Diagnostics.Type_0_has_no_call_signatures : Diagnostics.Type_0_has_no_construct_signatures,
	                typeToString(constituent)
	              );
	              errorInfo = chainDiagnosticMessages(
	                errorInfo,
	                isCall ? Diagnostics.Not_all_constituents_of_type_0_are_callable : Diagnostics.Not_all_constituents_of_type_0_are_constructable,
	                typeToString(apparentType)
	              );
	            }
	            if (hasSignatures) {
	              break;
	            }
	          }
	        }
	        if (!hasSignatures) {
	          errorInfo = chainDiagnosticMessages(
	            /*details*/
	            void 0,
	            isCall ? Diagnostics.No_constituent_of_type_0_is_callable : Diagnostics.No_constituent_of_type_0_is_constructable,
	            typeToString(apparentType)
	          );
	        }
	        if (!errorInfo) {
	          errorInfo = chainDiagnosticMessages(
	            errorInfo,
	            isCall ? Diagnostics.Each_member_of_the_union_type_0_has_signatures_but_none_of_those_signatures_are_compatible_with_each_other : Diagnostics.Each_member_of_the_union_type_0_has_construct_signatures_but_none_of_those_signatures_are_compatible_with_each_other,
	            typeToString(apparentType)
	          );
	        }
	      } else {
	        errorInfo = chainDiagnosticMessages(
	          errorInfo,
	          isCall ? Diagnostics.Type_0_has_no_call_signatures : Diagnostics.Type_0_has_no_construct_signatures,
	          typeToString(apparentType)
	        );
	      }
	      let headMessage = isCall ? Diagnostics.This_expression_is_not_callable : Diagnostics.This_expression_is_not_constructable;
	      if (isCallExpression(errorTarget.parent) && errorTarget.parent.arguments.length === 0) {
	        const { resolvedSymbol } = getNodeLinks(errorTarget);
	        if (resolvedSymbol && resolvedSymbol.flags & 32768 /* GetAccessor */) {
	          headMessage = Diagnostics.This_expression_is_not_callable_because_it_is_a_get_accessor_Did_you_mean_to_use_it_without;
	        }
	      }
	      return {
	        messageChain: chainDiagnosticMessages(errorInfo, headMessage),
	        relatedMessage: maybeMissingAwait ? Diagnostics.Did_you_forget_to_use_await : void 0
	      };
	    }
	    function invocationError(errorTarget, apparentType, kind, relatedInformation) {
	      const { messageChain, relatedMessage: relatedInfo } = invocationErrorDetails(errorTarget, apparentType, kind);
	      const diagnostic = createDiagnosticForNodeFromMessageChain(getSourceFileOfNode(errorTarget), errorTarget, messageChain);
	      if (relatedInfo) {
	        addRelatedInfo(diagnostic, createDiagnosticForNode(errorTarget, relatedInfo));
	      }
	      if (isCallExpression(errorTarget.parent)) {
	        const { start, length: length2 } = getDiagnosticSpanForCallNode(errorTarget.parent);
	        diagnostic.start = start;
	        diagnostic.length = length2;
	      }
	      diagnostics.add(diagnostic);
	      invocationErrorRecovery(apparentType, kind, relatedInformation ? addRelatedInfo(diagnostic, relatedInformation) : diagnostic);
	    }
	    function invocationErrorRecovery(apparentType, kind, diagnostic) {
	      if (!apparentType.symbol) {
	        return;
	      }
	      const importNode = getSymbolLinks(apparentType.symbol).originatingImport;
	      if (importNode && !isImportCall(importNode)) {
	        const sigs = getSignaturesOfType(getTypeOfSymbol(getSymbolLinks(apparentType.symbol).target), kind);
	        if (!sigs || !sigs.length)
	          return;
	        addRelatedInfo(diagnostic, createDiagnosticForNode(importNode, Diagnostics.Type_originates_at_this_import_A_namespace_style_import_cannot_be_called_or_constructed_and_will_cause_a_failure_at_runtime_Consider_using_a_default_import_or_import_require_here_instead));
	      }
	    }
	    function resolveTaggedTemplateExpression(node, candidatesOutArray, checkMode) {
	      const tagType = checkExpression(node.tag);
	      const apparentType = getApparentType(tagType);
	      if (isErrorType(apparentType)) {
	        return resolveErrorCall(node);
	      }
	      const callSignatures = getSignaturesOfType(apparentType, 0 /* Call */);
	      const numConstructSignatures = getSignaturesOfType(apparentType, 1 /* Construct */).length;
	      if (isUntypedFunctionCall(tagType, apparentType, callSignatures.length, numConstructSignatures)) {
	        return resolveUntypedCall(node);
	      }
	      if (!callSignatures.length) {
	        if (isArrayLiteralExpression(node.parent)) {
	          const diagnostic = createDiagnosticForNode(node.tag, Diagnostics.It_is_likely_that_you_are_missing_a_comma_to_separate_these_two_template_expressions_They_form_a_tagged_template_expression_which_cannot_be_invoked);
	          diagnostics.add(diagnostic);
	          return resolveErrorCall(node);
	        }
	        invocationError(node.tag, apparentType, 0 /* Call */);
	        return resolveErrorCall(node);
	      }
	      return resolveCall(node, callSignatures, candidatesOutArray, checkMode, 0 /* None */);
	    }
	    function getDiagnosticHeadMessageForDecoratorResolution(node) {
	      switch (node.parent.kind) {
	        case 263 /* ClassDeclaration */:
	        case 231 /* ClassExpression */:
	          return Diagnostics.Unable_to_resolve_signature_of_class_decorator_when_called_as_an_expression;
	        case 169 /* Parameter */:
	          return Diagnostics.Unable_to_resolve_signature_of_parameter_decorator_when_called_as_an_expression;
	        case 172 /* PropertyDeclaration */:
	          return Diagnostics.Unable_to_resolve_signature_of_property_decorator_when_called_as_an_expression;
	        case 174 /* MethodDeclaration */:
	        case 177 /* GetAccessor */:
	        case 178 /* SetAccessor */:
	          return Diagnostics.Unable_to_resolve_signature_of_method_decorator_when_called_as_an_expression;
	        default:
	          return Debug.fail();
	      }
	    }
	    function resolveDecorator(node, candidatesOutArray, checkMode) {
	      const funcType = checkExpression(node.expression);
	      const apparentType = getApparentType(funcType);
	      if (isErrorType(apparentType)) {
	        return resolveErrorCall(node);
	      }
	      const callSignatures = getSignaturesOfType(apparentType, 0 /* Call */);
	      const numConstructSignatures = getSignaturesOfType(apparentType, 1 /* Construct */).length;
	      if (isUntypedFunctionCall(funcType, apparentType, callSignatures.length, numConstructSignatures)) {
	        return resolveUntypedCall(node);
	      }
	      if (isPotentiallyUncalledDecorator(node, callSignatures) && !isParenthesizedExpression(node.expression)) {
	        const nodeStr = getTextOfNode(
	          node.expression,
	          /*includeTrivia*/
	          false
	        );
	        error2(node, Diagnostics._0_accepts_too_few_arguments_to_be_used_as_a_decorator_here_Did_you_mean_to_call_it_first_and_write_0, nodeStr);
	        return resolveErrorCall(node);
	      }
	      const headMessage = getDiagnosticHeadMessageForDecoratorResolution(node);
	      if (!callSignatures.length) {
	        const errorDetails = invocationErrorDetails(node.expression, apparentType, 0 /* Call */);
	        const messageChain = chainDiagnosticMessages(errorDetails.messageChain, headMessage);
	        const diag2 = createDiagnosticForNodeFromMessageChain(getSourceFileOfNode(node.expression), node.expression, messageChain);
	        if (errorDetails.relatedMessage) {
	          addRelatedInfo(diag2, createDiagnosticForNode(node.expression, errorDetails.relatedMessage));
	        }
	        diagnostics.add(diag2);
	        invocationErrorRecovery(apparentType, 0 /* Call */, diag2);
	        return resolveErrorCall(node);
	      }
	      return resolveCall(node, callSignatures, candidatesOutArray, checkMode, 0 /* None */, headMessage);
	    }
	    function createSignatureForJSXIntrinsic(node, result) {
	      const namespace = getJsxNamespaceAt(node);
	      const exports = namespace && getExportsOfSymbol(namespace);
	      const typeSymbol = exports && getSymbol2(exports, JsxNames.Element, 788968 /* Type */);
	      const returnNode = typeSymbol && nodeBuilder.symbolToEntityName(typeSymbol, 788968 /* Type */, node);
	      const declaration = factory.createFunctionTypeNode(
	        /*typeParameters*/
	        void 0,
	        [factory.createParameterDeclaration(
	          /*modifiers*/
	          void 0,
	          /*dotDotDotToken*/
	          void 0,
	          "props",
	          /*questionToken*/
	          void 0,
	          nodeBuilder.typeToTypeNode(result, node)
	        )],
	        returnNode ? factory.createTypeReferenceNode(
	          returnNode,
	          /*typeArguments*/
	          void 0
	        ) : factory.createKeywordTypeNode(133 /* AnyKeyword */)
	      );
	      const parameterSymbol = createSymbol(1 /* FunctionScopedVariable */, "props");
	      parameterSymbol.links.type = result;
	      return createSignature(
	        declaration,
	        /*typeParameters*/
	        void 0,
	        /*thisParameter*/
	        void 0,
	        [parameterSymbol],
	        typeSymbol ? getDeclaredTypeOfSymbol(typeSymbol) : errorType,
	        /*resolvedTypePredicate*/
	        void 0,
	        1,
	        0 /* None */
	      );
	    }
	    function resolveJsxOpeningLikeElement(node, candidatesOutArray, checkMode) {
	      if (isJsxIntrinsicTagName(node.tagName)) {
	        const result = getIntrinsicAttributesTypeFromJsxOpeningLikeElement(node);
	        const fakeSignature = createSignatureForJSXIntrinsic(node, result);
	        checkTypeAssignableToAndOptionallyElaborate(checkExpressionWithContextualType(
	          node.attributes,
	          getEffectiveFirstArgumentForJsxSignature(fakeSignature, node),
	          /*inferenceContext*/
	          void 0,
	          0 /* Normal */
	        ), result, node.tagName, node.attributes);
	        if (length(node.typeArguments)) {
	          forEach(node.typeArguments, checkSourceElement);
	          diagnostics.add(createDiagnosticForNodeArray(getSourceFileOfNode(node), node.typeArguments, Diagnostics.Expected_0_type_arguments_but_got_1, 0, length(node.typeArguments)));
	        }
	        return fakeSignature;
	      }
	      const exprTypes = checkExpression(node.tagName);
	      const apparentType = getApparentType(exprTypes);
	      if (isErrorType(apparentType)) {
	        return resolveErrorCall(node);
	      }
	      const signatures = getUninstantiatedJsxSignaturesOfType(exprTypes, node);
	      if (isUntypedFunctionCall(
	        exprTypes,
	        apparentType,
	        signatures.length,
	        /*constructSignatures*/
	        0
	      )) {
	        return resolveUntypedCall(node);
	      }
	      if (signatures.length === 0) {
	        error2(node.tagName, Diagnostics.JSX_element_type_0_does_not_have_any_construct_or_call_signatures, getTextOfNode(node.tagName));
	        return resolveErrorCall(node);
	      }
	      return resolveCall(node, signatures, candidatesOutArray, checkMode, 0 /* None */);
	    }
	    function resolveInstanceofExpression(node, candidatesOutArray, checkMode) {
	      const rightType = checkExpression(node.right);
	      if (!isTypeAny(rightType)) {
	        const hasInstanceMethodType = getSymbolHasInstanceMethodOfObjectType(rightType);
	        if (hasInstanceMethodType) {
	          const apparentType = getApparentType(hasInstanceMethodType);
	          if (isErrorType(apparentType)) {
	            return resolveErrorCall(node);
	          }
	          const callSignatures = getSignaturesOfType(apparentType, 0 /* Call */);
	          const constructSignatures = getSignaturesOfType(apparentType, 1 /* Construct */);
	          if (isUntypedFunctionCall(hasInstanceMethodType, apparentType, callSignatures.length, constructSignatures.length)) {
	            return resolveUntypedCall(node);
	          }
	          if (callSignatures.length) {
	            return resolveCall(node, callSignatures, candidatesOutArray, checkMode, 0 /* None */);
	          }
	        } else if (!(typeHasCallOrConstructSignatures(rightType) || isTypeSubtypeOf(rightType, globalFunctionType))) {
	          error2(node.right, Diagnostics.The_right_hand_side_of_an_instanceof_expression_must_be_either_of_type_any_a_class_function_or_other_type_assignable_to_the_Function_interface_type_or_an_object_type_with_a_Symbol_hasInstance_method);
	          return resolveErrorCall(node);
	        }
	      }
	      return anySignature;
	    }
	    function isPotentiallyUncalledDecorator(decorator, signatures) {
	      return signatures.length && every(signatures, (signature) => signature.minArgumentCount === 0 && !signatureHasRestParameter(signature) && signature.parameters.length < getDecoratorArgumentCount(decorator, signature));
	    }
	    function resolveSignature(node, candidatesOutArray, checkMode) {
	      switch (node.kind) {
	        case 213 /* CallExpression */:
	          return resolveCallExpression(node, candidatesOutArray, checkMode);
	        case 214 /* NewExpression */:
	          return resolveNewExpression(node, candidatesOutArray, checkMode);
	        case 215 /* TaggedTemplateExpression */:
	          return resolveTaggedTemplateExpression(node, candidatesOutArray, checkMode);
	        case 170 /* Decorator */:
	          return resolveDecorator(node, candidatesOutArray, checkMode);
	        case 286 /* JsxOpeningElement */:
	        case 285 /* JsxSelfClosingElement */:
	          return resolveJsxOpeningLikeElement(node, candidatesOutArray, checkMode);
	        case 226 /* BinaryExpression */:
	          return resolveInstanceofExpression(node, candidatesOutArray, checkMode);
	      }
	      Debug.assertNever(node, "Branch in 'resolveSignature' should be unreachable.");
	    }
	    function getResolvedSignature(node, candidatesOutArray, checkMode) {
	      const links = getNodeLinks(node);
	      const cached = links.resolvedSignature;
	      if (cached && cached !== resolvingSignature && !candidatesOutArray) {
	        return cached;
	      }
	      links.resolvedSignature = resolvingSignature;
	      let result = resolveSignature(node, candidatesOutArray, checkMode || 0 /* Normal */);
	      if (result !== resolvingSignature) {
	        if (links.resolvedSignature !== resolvingSignature) {
	          result = links.resolvedSignature;
	        }
	        links.resolvedSignature = flowLoopStart === flowLoopCount ? result : cached;
	      }
	      return result;
	    }
	    function isJSConstructor(node) {
	      var _a;
	      if (!node || !isInJSFile(node)) {
	        return false;
	      }
	      const func = isFunctionDeclaration(node) || isFunctionExpression(node) ? node : (isVariableDeclaration(node) || isPropertyAssignment(node)) && node.initializer && isFunctionExpression(node.initializer) ? node.initializer : void 0;
	      if (func) {
	        if (getJSDocClassTag(node))
	          return true;
	        if (isPropertyAssignment(walkUpParenthesizedExpressions(func.parent)))
	          return false;
	        const symbol = getSymbolOfDeclaration(func);
	        return !!((_a = symbol == null ? void 0 : symbol.members) == null ? void 0 : _a.size);
	      }
	      return false;
	    }
	    function mergeJSSymbols(target, source) {
	      var _a, _b;
	      if (source) {
	        const links = getSymbolLinks(source);
	        if (!links.inferredClassSymbol || !links.inferredClassSymbol.has(getSymbolId(target))) {
	          const inferred = isTransientSymbol(target) ? target : cloneSymbol(target);
	          inferred.exports = inferred.exports || createSymbolTable();
	          inferred.members = inferred.members || createSymbolTable();
	          inferred.flags |= source.flags & 32 /* Class */;
	          if ((_a = source.exports) == null ? void 0 : _a.size) {
	            mergeSymbolTable(inferred.exports, source.exports);
	          }
	          if ((_b = source.members) == null ? void 0 : _b.size) {
	            mergeSymbolTable(inferred.members, source.members);
	          }
	          (links.inferredClassSymbol || (links.inferredClassSymbol = /* @__PURE__ */ new Map())).set(getSymbolId(inferred), inferred);
	          return inferred;
	        }
	        return links.inferredClassSymbol.get(getSymbolId(target));
	      }
	    }
	    function getAssignedClassSymbol(decl) {
	      var _a;
	      const assignmentSymbol = decl && getSymbolOfExpando(
	        decl,
	        /*allowDeclaration*/
	        true
	      );
	      const prototype = (_a = assignmentSymbol == null ? void 0 : assignmentSymbol.exports) == null ? void 0 : _a.get("prototype");
	      const init = (prototype == null ? void 0 : prototype.valueDeclaration) && getAssignedJSPrototype(prototype.valueDeclaration);
	      return init ? getSymbolOfDeclaration(init) : void 0;
	    }
	    function getSymbolOfExpando(node, allowDeclaration) {
	      if (!node.parent) {
	        return void 0;
	      }
	      let name;
	      let decl;
	      if (isVariableDeclaration(node.parent) && node.parent.initializer === node) {
	        if (!isInJSFile(node) && !(isVarConstLike(node.parent) && isFunctionLikeDeclaration(node))) {
	          return void 0;
	        }
	        name = node.parent.name;
	        decl = node.parent;
	      } else if (isBinaryExpression(node.parent)) {
	        const parentNode = node.parent;
	        const parentNodeOperator = node.parent.operatorToken.kind;
	        if (parentNodeOperator === 64 /* EqualsToken */ && (allowDeclaration || parentNode.right === node)) {
	          name = parentNode.left;
	          decl = name;
	        } else if (parentNodeOperator === 57 /* BarBarToken */ || parentNodeOperator === 61 /* QuestionQuestionToken */) {
	          if (isVariableDeclaration(parentNode.parent) && parentNode.parent.initializer === parentNode) {
	            name = parentNode.parent.name;
	            decl = parentNode.parent;
	          } else if (isBinaryExpression(parentNode.parent) && parentNode.parent.operatorToken.kind === 64 /* EqualsToken */ && (allowDeclaration || parentNode.parent.right === parentNode)) {
	            name = parentNode.parent.left;
	            decl = name;
	          }
	          if (!name || !isBindableStaticNameExpression(name) || !isSameEntityName(name, parentNode.left)) {
	            return void 0;
	          }
	        }
	      } else if (allowDeclaration && isFunctionDeclaration(node)) {
	        name = node.name;
	        decl = node;
	      }
	      if (!decl || !name || !allowDeclaration && !getExpandoInitializer(node, isPrototypeAccess(name))) {
	        return void 0;
	      }
	      return getSymbolOfNode(decl);
	    }
	    function getAssignedJSPrototype(node) {
	      if (!node.parent) {
	        return false;
	      }
	      let parent2 = node.parent;
	      while (parent2 && parent2.kind === 211 /* PropertyAccessExpression */) {
	        parent2 = parent2.parent;
	      }
	      if (parent2 && isBinaryExpression(parent2) && isPrototypeAccess(parent2.left) && parent2.operatorToken.kind === 64 /* EqualsToken */) {
	        const right = getInitializerOfBinaryExpression(parent2);
	        return isObjectLiteralExpression(right) && right;
	      }
	    }
	    function checkCallExpression(node, checkMode) {
	      var _a, _b, _c;
	      checkGrammarTypeArguments(node, node.typeArguments);
	      const signature = getResolvedSignature(
	        node,
	        /*candidatesOutArray*/
	        void 0,
	        checkMode
	      );
	      if (signature === resolvingSignature) {
	        return silentNeverType;
	      }
	      checkDeprecatedSignature(signature, node);
	      if (node.expression.kind === 108 /* SuperKeyword */) {
	        return voidType;
	      }
	      if (node.kind === 214 /* NewExpression */) {
	        const declaration = signature.declaration;
	        if (declaration && declaration.kind !== 176 /* Constructor */ && declaration.kind !== 180 /* ConstructSignature */ && declaration.kind !== 185 /* ConstructorType */ && !(isJSDocSignature(declaration) && ((_b = (_a = getJSDocRoot(declaration)) == null ? void 0 : _a.parent) == null ? void 0 : _b.kind) === 176 /* Constructor */) && !isJSDocConstructSignature(declaration) && !isJSConstructor(declaration)) {
	          if (noImplicitAny) {
	            error2(node, Diagnostics.new_expression_whose_target_lacks_a_construct_signature_implicitly_has_an_any_type);
	          }
	          return anyType;
	        }
	      }
	      if (isInJSFile(node) && isCommonJsRequire(node)) {
	        return resolveExternalModuleTypeByLiteral(node.arguments[0]);
	      }
	      const returnType = getReturnTypeOfSignature(signature);
	      if (returnType.flags & 12288 /* ESSymbolLike */ && isSymbolOrSymbolForCall(node)) {
	        return getESSymbolLikeTypeForNode(walkUpParenthesizedExpressions(node.parent));
	      }
	      if (node.kind === 213 /* CallExpression */ && !node.questionDotToken && node.parent.kind === 244 /* ExpressionStatement */ && returnType.flags & 16384 /* Void */ && getTypePredicateOfSignature(signature)) {
	        if (!isDottedName(node.expression)) {
	          error2(node.expression, Diagnostics.Assertions_require_the_call_target_to_be_an_identifier_or_qualified_name);
	        } else if (!getEffectsSignature(node)) {
	          const diagnostic = error2(node.expression, Diagnostics.Assertions_require_every_name_in_the_call_target_to_be_declared_with_an_explicit_type_annotation);
	          getTypeOfDottedName(node.expression, diagnostic);
	        }
	      }
	      if (isInJSFile(node)) {
	        const jsSymbol = getSymbolOfExpando(
	          node,
	          /*allowDeclaration*/
	          false
	        );
	        if ((_c = jsSymbol == null ? void 0 : jsSymbol.exports) == null ? void 0 : _c.size) {
	          const jsAssignmentType = createAnonymousType(jsSymbol, jsSymbol.exports, emptyArray, emptyArray, emptyArray);
	          jsAssignmentType.objectFlags |= 4096 /* JSLiteral */;
	          return getIntersectionType([returnType, jsAssignmentType]);
	        }
	      }
	      return returnType;
	    }
	    function checkDeprecatedSignature(signature, node) {
	      if (signature.flags & 128 /* IsSignatureCandidateForOverloadFailure */)
	        return;
	      if (signature.declaration && signature.declaration.flags & 536870912 /* Deprecated */) {
	        const suggestionNode = getDeprecatedSuggestionNode(node);
	        const name = tryGetPropertyAccessOrIdentifierToString(getInvokedExpression(node));
	        addDeprecatedSuggestionWithSignature(suggestionNode, signature.declaration, name, signatureToString(signature));
	      }
	    }
	    function getDeprecatedSuggestionNode(node) {
	      node = skipParentheses(node);
	      switch (node.kind) {
	        case 213 /* CallExpression */:
	        case 170 /* Decorator */:
	        case 214 /* NewExpression */:
	          return getDeprecatedSuggestionNode(node.expression);
	        case 215 /* TaggedTemplateExpression */:
	          return getDeprecatedSuggestionNode(node.tag);
	        case 286 /* JsxOpeningElement */:
	        case 285 /* JsxSelfClosingElement */:
	          return getDeprecatedSuggestionNode(node.tagName);
	        case 212 /* ElementAccessExpression */:
	          return node.argumentExpression;
	        case 211 /* PropertyAccessExpression */:
	          return node.name;
	        case 183 /* TypeReference */:
	          const typeReference = node;
	          return isQualifiedName(typeReference.typeName) ? typeReference.typeName.right : typeReference;
	        default:
	          return node;
	      }
	    }
	    function isSymbolOrSymbolForCall(node) {
	      if (!isCallExpression(node))
	        return false;
	      let left = node.expression;
	      if (isPropertyAccessExpression(left) && left.name.escapedText === "for") {
	        left = left.expression;
	      }
	      if (!isIdentifier(left) || left.escapedText !== "Symbol") {
	        return false;
	      }
	      const globalESSymbol = getGlobalESSymbolConstructorSymbol(
	        /*reportErrors*/
	        false
	      );
	      if (!globalESSymbol) {
	        return false;
	      }
	      return globalESSymbol === resolveName(
	        left,
	        "Symbol",
	        111551 /* Value */,
	        /*nameNotFoundMessage*/
	        void 0,
	        /*nameArg*/
	        void 0,
	        /*isUse*/
	        false
	      );
	    }
	    function checkImportCallExpression(node) {
	      checkGrammarImportCallExpression(node);
	      if (node.arguments.length === 0) {
	        return createPromiseReturnType(node, anyType);
	      }
	      const specifier = node.arguments[0];
	      const specifierType = checkExpressionCached(specifier);
	      const optionsType = node.arguments.length > 1 ? checkExpressionCached(node.arguments[1]) : void 0;
	      for (let i = 2; i < node.arguments.length; ++i) {
	        checkExpressionCached(node.arguments[i]);
	      }
	      if (specifierType.flags & 32768 /* Undefined */ || specifierType.flags & 65536 /* Null */ || !isTypeAssignableTo(specifierType, stringType)) {
	        error2(specifier, Diagnostics.Dynamic_import_s_specifier_must_be_of_type_string_but_here_has_type_0, typeToString(specifierType));
	      }
	      if (optionsType) {
	        const importCallOptionsType = getGlobalImportCallOptionsType(
	          /*reportErrors*/
	          true
	        );
	        if (importCallOptionsType !== emptyObjectType) {
	          checkTypeAssignableTo(optionsType, getNullableType(importCallOptionsType, 32768 /* Undefined */), node.arguments[1]);
	        }
	      }
	      const moduleSymbol = resolveExternalModuleName(node, specifier);
	      if (moduleSymbol) {
	        const esModuleSymbol = resolveESModuleSymbol(
	          moduleSymbol,
	          specifier,
	          /*dontResolveAlias*/
	          true,
	          /*suppressInteropError*/
	          false
	        );
	        if (esModuleSymbol) {
	          return createPromiseReturnType(
	            node,
	            getTypeWithSyntheticDefaultOnly(getTypeOfSymbol(esModuleSymbol), esModuleSymbol, moduleSymbol, specifier) || getTypeWithSyntheticDefaultImportType(getTypeOfSymbol(esModuleSymbol), esModuleSymbol, moduleSymbol, specifier)
	          );
	        }
	      }
	      return createPromiseReturnType(node, anyType);
	    }
	    function createDefaultPropertyWrapperForModule(symbol, originalSymbol, anonymousSymbol) {
	      const memberTable = createSymbolTable();
	      const newSymbol = createSymbol(2097152 /* Alias */, "default" /* Default */);
	      newSymbol.parent = originalSymbol;
	      newSymbol.links.nameType = getStringLiteralType("default");
	      newSymbol.links.aliasTarget = resolveSymbol(symbol);
	      memberTable.set("default" /* Default */, newSymbol);
	      return createAnonymousType(anonymousSymbol, memberTable, emptyArray, emptyArray, emptyArray);
	    }
	    function getTypeWithSyntheticDefaultOnly(type, symbol, originalSymbol, moduleSpecifier) {
	      const hasDefaultOnly = isOnlyImportedAsDefault(moduleSpecifier);
	      if (hasDefaultOnly && type && !isErrorType(type)) {
	        const synthType = type;
	        if (!synthType.defaultOnlyType) {
	          const type2 = createDefaultPropertyWrapperForModule(symbol, originalSymbol);
	          synthType.defaultOnlyType = type2;
	        }
	        return synthType.defaultOnlyType;
	      }
	      return void 0;
	    }
	    function getTypeWithSyntheticDefaultImportType(type, symbol, originalSymbol, moduleSpecifier) {
	      var _a;
	      if (allowSyntheticDefaultImports && type && !isErrorType(type)) {
	        const synthType = type;
	        if (!synthType.syntheticType) {
	          const file = (_a = originalSymbol.declarations) == null ? void 0 : _a.find(isSourceFile);
	          const hasSyntheticDefault = canHaveSyntheticDefault(
	            file,
	            originalSymbol,
	            /*dontResolveAlias*/
	            false,
	            moduleSpecifier
	          );
	          if (hasSyntheticDefault) {
	            const anonymousSymbol = createSymbol(2048 /* TypeLiteral */, "__type" /* Type */);
	            const defaultContainingObject = createDefaultPropertyWrapperForModule(symbol, originalSymbol, anonymousSymbol);
	            anonymousSymbol.links.type = defaultContainingObject;
	            synthType.syntheticType = isValidSpreadType(type) ? getSpreadType(
	              type,
	              defaultContainingObject,
	              anonymousSymbol,
	              /*objectFlags*/
	              0,
	              /*readonly*/
	              false
	            ) : defaultContainingObject;
	          } else {
	            synthType.syntheticType = type;
	          }
	        }
	        return synthType.syntheticType;
	      }
	      return type;
	    }
	    function isCommonJsRequire(node) {
	      if (!isRequireCall(
	        node,
	        /*requireStringLiteralLikeArgument*/
	        true
	      )) {
	        return false;
	      }
	      if (!isIdentifier(node.expression))
	        return Debug.fail();
	      const resolvedRequire = resolveName(
	        node.expression,
	        node.expression.escapedText,
	        111551 /* Value */,
	        /*nameNotFoundMessage*/
	        void 0,
	        /*nameArg*/
	        void 0,
	        /*isUse*/
	        true
	      );
	      if (resolvedRequire === requireSymbol) {
	        return true;
	      }
	      if (resolvedRequire.flags & 2097152 /* Alias */) {
	        return false;
	      }
	      const targetDeclarationKind = resolvedRequire.flags & 16 /* Function */ ? 262 /* FunctionDeclaration */ : resolvedRequire.flags & 3 /* Variable */ ? 260 /* VariableDeclaration */ : 0 /* Unknown */;
	      if (targetDeclarationKind !== 0 /* Unknown */) {
	        const decl = getDeclarationOfKind(resolvedRequire, targetDeclarationKind);
	        return !!decl && !!(decl.flags & 33554432 /* Ambient */);
	      }
	      return false;
	    }
	    function checkTaggedTemplateExpression(node) {
	      if (!checkGrammarTaggedTemplateChain(node))
	        checkGrammarTypeArguments(node, node.typeArguments);
	      if (languageVersion < 2 /* ES2015 */) {
	        checkExternalEmitHelpers(node, 262144 /* MakeTemplateObject */);
	      }
	      const signature = getResolvedSignature(node);
	      checkDeprecatedSignature(signature, node);
	      return getReturnTypeOfSignature(signature);
	    }
	    function checkAssertion(node, checkMode) {
	      if (node.kind === 216 /* TypeAssertionExpression */) {
	        const file = getSourceFileOfNode(node);
	        if (file && fileExtensionIsOneOf(file.fileName, [".cts" /* Cts */, ".mts" /* Mts */])) {
	          grammarErrorOnNode(node, Diagnostics.This_syntax_is_reserved_in_files_with_the_mts_or_cts_extension_Use_an_as_expression_instead);
	        }
	      }
	      return checkAssertionWorker(node, checkMode);
	    }
	    function isValidConstAssertionArgument(node) {
	      switch (node.kind) {
	        case 11 /* StringLiteral */:
	        case 15 /* NoSubstitutionTemplateLiteral */:
	        case 9 /* NumericLiteral */:
	        case 10 /* BigIntLiteral */:
	        case 112 /* TrueKeyword */:
	        case 97 /* FalseKeyword */:
	        case 209 /* ArrayLiteralExpression */:
	        case 210 /* ObjectLiteralExpression */:
	        case 228 /* TemplateExpression */:
	          return true;
	        case 217 /* ParenthesizedExpression */:
	          return isValidConstAssertionArgument(node.expression);
	        case 224 /* PrefixUnaryExpression */:
	          const op = node.operator;
	          const arg = node.operand;
	          return op === 41 /* MinusToken */ && (arg.kind === 9 /* NumericLiteral */ || arg.kind === 10 /* BigIntLiteral */) || op === 40 /* PlusToken */ && arg.kind === 9 /* NumericLiteral */;
	        case 211 /* PropertyAccessExpression */:
	        case 212 /* ElementAccessExpression */:
	          const expr = skipParentheses(node.expression);
	          const symbol = isEntityNameExpression(expr) ? resolveEntityName(
	            expr,
	            111551 /* Value */,
	            /*ignoreErrors*/
	            true
	          ) : void 0;
	          return !!(symbol && symbol.flags & 384 /* Enum */);
	      }
	      return false;
	    }
	    function checkAssertionWorker(node, checkMode) {
	      const { type, expression } = getAssertionTypeAndExpression(node);
	      const exprType = checkExpression(expression, checkMode);
	      if (isConstTypeReference(type)) {
	        if (!isValidConstAssertionArgument(expression)) {
	          error2(expression, Diagnostics.A_const_assertions_can_only_be_applied_to_references_to_enum_members_or_string_number_boolean_array_or_object_literals);
	        }
	        return getRegularTypeOfLiteralType(exprType);
	      }
	      const links = getNodeLinks(node);
	      links.assertionExpressionType = exprType;
	      checkSourceElement(type);
	      checkNodeDeferred(node);
	      return getTypeFromTypeNode(type);
	    }
	    function getAssertionTypeAndExpression(node) {
	      let type;
	      let expression;
	      switch (node.kind) {
	        case 234 /* AsExpression */:
	        case 216 /* TypeAssertionExpression */:
	          type = node.type;
	          expression = node.expression;
	          break;
	        case 217 /* ParenthesizedExpression */:
	          type = getJSDocTypeAssertionType(node);
	          expression = node.expression;
	          break;
	      }
	      return { type, expression };
	    }
	    function checkAssertionDeferred(node) {
	      const { type } = getAssertionTypeAndExpression(node);
	      const errNode = isParenthesizedExpression(node) ? type : node;
	      const links = getNodeLinks(node);
	      Debug.assertIsDefined(links.assertionExpressionType);
	      const exprType = getRegularTypeOfObjectLiteral(getBaseTypeOfLiteralType(links.assertionExpressionType));
	      const targetType = getTypeFromTypeNode(type);
	      if (!isErrorType(targetType)) {
	        addLazyDiagnostic(() => {
	          const widenedType = getWidenedType(exprType);
	          if (!isTypeComparableTo(targetType, widenedType)) {
	            checkTypeComparableTo(exprType, targetType, errNode, Diagnostics.Conversion_of_type_0_to_type_1_may_be_a_mistake_because_neither_type_sufficiently_overlaps_with_the_other_If_this_was_intentional_convert_the_expression_to_unknown_first);
	          }
	        });
	      }
	    }
	    function checkNonNullChain(node) {
	      const leftType = checkExpression(node.expression);
	      const nonOptionalType = getOptionalExpressionType(leftType, node.expression);
	      return propagateOptionalTypeMarker(getNonNullableType(nonOptionalType), node, nonOptionalType !== leftType);
	    }
	    function checkNonNullAssertion(node) {
	      return node.flags & 64 /* OptionalChain */ ? checkNonNullChain(node) : getNonNullableType(checkExpression(node.expression));
	    }
	    function checkExpressionWithTypeArguments(node) {
	      checkGrammarExpressionWithTypeArguments(node);
	      forEach(node.typeArguments, checkSourceElement);
	      if (node.kind === 233 /* ExpressionWithTypeArguments */) {
	        const parent2 = walkUpParenthesizedExpressions(node.parent);
	        if (parent2.kind === 226 /* BinaryExpression */ && parent2.operatorToken.kind === 104 /* InstanceOfKeyword */ && isNodeDescendantOf(node, parent2.right)) {
	          error2(node, Diagnostics.The_right_hand_side_of_an_instanceof_expression_must_not_be_an_instantiation_expression);
	        }
	      }
	      const exprType = node.kind === 233 /* ExpressionWithTypeArguments */ ? checkExpression(node.expression) : isThisIdentifier(node.exprName) ? checkThisExpression(node.exprName) : checkExpression(node.exprName);
	      return getInstantiationExpressionType(exprType, node);
	    }
	    function getInstantiationExpressionType(exprType, node) {
	      const typeArguments = node.typeArguments;
	      if (exprType === silentNeverType || isErrorType(exprType) || !some(typeArguments)) {
	        return exprType;
	      }
	      let hasSomeApplicableSignature = false;
	      let nonApplicableType;
	      const result = getInstantiatedType(exprType);
	      const errorType2 = hasSomeApplicableSignature ? nonApplicableType : exprType;
	      if (errorType2) {
	        diagnostics.add(createDiagnosticForNodeArray(getSourceFileOfNode(node), typeArguments, Diagnostics.Type_0_has_no_signatures_for_which_the_type_argument_list_is_applicable, typeToString(errorType2)));
	      }
	      return result;
	      function getInstantiatedType(type) {
	        let hasSignatures = false;
	        let hasApplicableSignature = false;
	        const result2 = getInstantiatedTypePart(type);
	        hasSomeApplicableSignature || (hasSomeApplicableSignature = hasApplicableSignature);
	        if (hasSignatures && !hasApplicableSignature) {
	          nonApplicableType ?? (nonApplicableType = type);
	        }
	        return result2;
	        function getInstantiatedTypePart(type2) {
	          if (type2.flags & 524288 /* Object */) {
	            const resolved = resolveStructuredTypeMembers(type2);
	            const callSignatures = getInstantiatedSignatures(resolved.callSignatures);
	            const constructSignatures = getInstantiatedSignatures(resolved.constructSignatures);
	            hasSignatures || (hasSignatures = resolved.callSignatures.length !== 0 || resolved.constructSignatures.length !== 0);
	            hasApplicableSignature || (hasApplicableSignature = callSignatures.length !== 0 || constructSignatures.length !== 0);
	            if (callSignatures !== resolved.callSignatures || constructSignatures !== resolved.constructSignatures) {
	              const result3 = createAnonymousType(createSymbol(0 /* None */, "__instantiationExpression" /* InstantiationExpression */), resolved.members, callSignatures, constructSignatures, resolved.indexInfos);
	              result3.objectFlags |= 8388608 /* InstantiationExpressionType */;
	              result3.node = node;
	              return result3;
	            }
	          } else if (type2.flags & 58982400 /* InstantiableNonPrimitive */) {
	            const constraint = getBaseConstraintOfType(type2);
	            if (constraint) {
	              const instantiated = getInstantiatedTypePart(constraint);
	              if (instantiated !== constraint) {
	                return instantiated;
	              }
	            }
	          } else if (type2.flags & 1048576 /* Union */) {
	            return mapType(type2, getInstantiatedType);
	          } else if (type2.flags & 2097152 /* Intersection */) {
	            return getIntersectionType(sameMap(type2.types, getInstantiatedTypePart));
	          }
	          return type2;
	        }
	      }
	      function getInstantiatedSignatures(signatures) {
	        const applicableSignatures = filter(signatures, (sig) => !!sig.typeParameters && hasCorrectTypeArgumentArity(sig, typeArguments));
	        return sameMap(applicableSignatures, (sig) => {
	          const typeArgumentTypes = checkTypeArguments(
	            sig,
	            typeArguments,
	            /*reportErrors*/
	            true
	          );
	          return typeArgumentTypes ? getSignatureInstantiation(sig, typeArgumentTypes, isInJSFile(sig.declaration)) : sig;
	        });
	      }
	    }
	    function checkSatisfiesExpression(node) {
	      checkSourceElement(node.type);
	      return checkSatisfiesExpressionWorker(node.expression, node.type);
	    }
	    function checkSatisfiesExpressionWorker(expression, target, checkMode) {
	      const exprType = checkExpression(expression, checkMode);
	      const targetType = getTypeFromTypeNode(target);
	      if (isErrorType(targetType)) {
	        return targetType;
	      }
	      const errorNode = findAncestor(target.parent, (n) => n.kind === 238 /* SatisfiesExpression */ || n.kind === 357 /* JSDocSatisfiesTag */);
	      checkTypeAssignableToAndOptionallyElaborate(exprType, targetType, errorNode, expression, Diagnostics.Type_0_does_not_satisfy_the_expected_type_1);
	      return exprType;
	    }
	    function checkMetaProperty(node) {
	      checkGrammarMetaProperty(node);
	      if (node.keywordToken === 105 /* NewKeyword */) {
	        return checkNewTargetMetaProperty(node);
	      }
	      if (node.keywordToken === 102 /* ImportKeyword */) {
	        return checkImportMetaProperty(node);
	      }
	      return Debug.assertNever(node.keywordToken);
	    }
	    function checkMetaPropertyKeyword(node) {
	      switch (node.keywordToken) {
	        case 102 /* ImportKeyword */:
	          return getGlobalImportMetaExpressionType();
	        case 105 /* NewKeyword */:
	          const type = checkNewTargetMetaProperty(node);
	          return isErrorType(type) ? errorType : createNewTargetExpressionType(type);
	        default:
	          Debug.assertNever(node.keywordToken);
	      }
	    }
	    function checkNewTargetMetaProperty(node) {
	      const container = getNewTargetContainer(node);
	      if (!container) {
	        error2(node, Diagnostics.Meta_property_0_is_only_allowed_in_the_body_of_a_function_declaration_function_expression_or_constructor, "new.target");
	        return errorType;
	      } else if (container.kind === 176 /* Constructor */) {
	        const symbol = getSymbolOfDeclaration(container.parent);
	        return getTypeOfSymbol(symbol);
	      } else {
	        const symbol = getSymbolOfDeclaration(container);
	        return getTypeOfSymbol(symbol);
	      }
	    }
	    function checkImportMetaProperty(node) {
	      if (moduleKind === 100 /* Node16 */ || moduleKind === 199 /* NodeNext */) {
	        if (getSourceFileOfNode(node).impliedNodeFormat !== 99 /* ESNext */) {
	          error2(node, Diagnostics.The_import_meta_meta_property_is_not_allowed_in_files_which_will_build_into_CommonJS_output);
	        }
	      } else if (moduleKind < 6 /* ES2020 */ && moduleKind !== 4 /* System */) {
	        error2(node, Diagnostics.The_import_meta_meta_property_is_only_allowed_when_the_module_option_is_es2020_es2022_esnext_system_node16_or_nodenext);
	      }
	      const file = getSourceFileOfNode(node);
	      Debug.assert(!!(file.flags & 8388608 /* PossiblyContainsImportMeta */), "Containing file is missing import meta node flag.");
	      return node.name.escapedText === "meta" ? getGlobalImportMetaType() : errorType;
	    }
	    function getTypeOfParameter(symbol) {
	      const declaration = symbol.valueDeclaration;
	      return addOptionality(
	        getTypeOfSymbol(symbol),
	        /*isProperty*/
	        false,
	        /*isOptional*/
	        !!declaration && (hasInitializer(declaration) || isOptionalDeclaration(declaration))
	      );
	    }
	    function getTupleElementLabel(d, index, restParameterName = "arg") {
	      if (!d) {
	        return `${restParameterName}_${index}`;
	      }
	      Debug.assert(isIdentifier(d.name));
	      return d.name.escapedText;
	    }
	    function getParameterNameAtPosition(signature, pos, overrideRestType) {
	      const paramCount = signature.parameters.length - (signatureHasRestParameter(signature) ? 1 : 0);
	      if (pos < paramCount) {
	        return signature.parameters[pos].escapedName;
	      }
	      const restParameter = signature.parameters[paramCount] || unknownSymbol;
	      const restType = overrideRestType || getTypeOfSymbol(restParameter);
	      if (isTupleType(restType)) {
	        const associatedNames = restType.target.labeledElementDeclarations;
	        const index = pos - paramCount;
	        return getTupleElementLabel(associatedNames == null ? void 0 : associatedNames[index], index, restParameter.escapedName);
	      }
	      return restParameter.escapedName;
	    }
	    function getParameterIdentifierInfoAtPosition(signature, pos) {
	      var _a;
	      if (((_a = signature.declaration) == null ? void 0 : _a.kind) === 324 /* JSDocFunctionType */) {
	        return void 0;
	      }
	      const paramCount = signature.parameters.length - (signatureHasRestParameter(signature) ? 1 : 0);
	      if (pos < paramCount) {
	        const param = signature.parameters[pos];
	        const paramIdent = getParameterDeclarationIdentifier(param);
	        return paramIdent ? {
	          parameter: paramIdent,
	          parameterName: param.escapedName,
	          isRestParameter: false
	        } : void 0;
	      }
	      const restParameter = signature.parameters[paramCount] || unknownSymbol;
	      const restIdent = getParameterDeclarationIdentifier(restParameter);
	      if (!restIdent) {
	        return void 0;
	      }
	      const restType = getTypeOfSymbol(restParameter);
	      if (isTupleType(restType)) {
	        const associatedNames = restType.target.labeledElementDeclarations;
	        const index = pos - paramCount;
	        const associatedName = associatedNames == null ? void 0 : associatedNames[index];
	        const isRestTupleElement = !!(associatedName == null ? void 0 : associatedName.dotDotDotToken);
	        if (associatedName) {
	          Debug.assert(isIdentifier(associatedName.name));
	          return { parameter: associatedName.name, parameterName: associatedName.name.escapedText, isRestParameter: isRestTupleElement };
	        }
	        return void 0;
	      }
	      if (pos === paramCount) {
	        return { parameter: restIdent, parameterName: restParameter.escapedName, isRestParameter: true };
	      }
	      return void 0;
	    }
	    function getParameterDeclarationIdentifier(symbol) {
	      return symbol.valueDeclaration && isParameter(symbol.valueDeclaration) && isIdentifier(symbol.valueDeclaration.name) && symbol.valueDeclaration.name;
	    }
	    function isValidDeclarationForTupleLabel(d) {
	      return d.kind === 202 /* NamedTupleMember */ || isParameter(d) && d.name && isIdentifier(d.name);
	    }
	    function getNameableDeclarationAtPosition(signature, pos) {
	      const paramCount = signature.parameters.length - (signatureHasRestParameter(signature) ? 1 : 0);
	      if (pos < paramCount) {
	        const decl = signature.parameters[pos].valueDeclaration;
	        return decl && isValidDeclarationForTupleLabel(decl) ? decl : void 0;
	      }
	      const restParameter = signature.parameters[paramCount] || unknownSymbol;
	      const restType = getTypeOfSymbol(restParameter);
	      if (isTupleType(restType)) {
	        const associatedNames = restType.target.labeledElementDeclarations;
	        const index = pos - paramCount;
	        return associatedNames && associatedNames[index];
	      }
	      return restParameter.valueDeclaration && isValidDeclarationForTupleLabel(restParameter.valueDeclaration) ? restParameter.valueDeclaration : void 0;
	    }
	    function getTypeAtPosition(signature, pos) {
	      return tryGetTypeAtPosition(signature, pos) || anyType;
	    }
	    function tryGetTypeAtPosition(signature, pos) {
	      const paramCount = signature.parameters.length - (signatureHasRestParameter(signature) ? 1 : 0);
	      if (pos < paramCount) {
	        return getTypeOfParameter(signature.parameters[pos]);
	      }
	      if (signatureHasRestParameter(signature)) {
	        const restType = getTypeOfSymbol(signature.parameters[paramCount]);
	        const index = pos - paramCount;
	        if (!isTupleType(restType) || restType.target.hasRestElement || index < restType.target.fixedLength) {
	          return getIndexedAccessType(restType, getNumberLiteralType(index));
	        }
	      }
	      return void 0;
	    }
	    function getRestTypeAtPosition(source, pos, readonly) {
	      const parameterCount = getParameterCount(source);
	      const minArgumentCount = getMinArgumentCount(source);
	      const restType = getEffectiveRestType(source);
	      if (restType && pos >= parameterCount - 1) {
	        return pos === parameterCount - 1 ? restType : createArrayType(getIndexedAccessType(restType, numberType));
	      }
	      const types = [];
	      const flags = [];
	      const names = [];
	      for (let i = pos; i < parameterCount; i++) {
	        if (!restType || i < parameterCount - 1) {
	          types.push(getTypeAtPosition(source, i));
	          flags.push(i < minArgumentCount ? 1 /* Required */ : 2 /* Optional */);
	        } else {
	          types.push(restType);
	          flags.push(8 /* Variadic */);
	        }
	        names.push(getNameableDeclarationAtPosition(source, i));
	      }
	      return createTupleType(types, flags, readonly, names);
	    }
	    function getRestOrAnyTypeAtPosition(source, pos) {
	      const restType = getRestTypeAtPosition(source, pos);
	      const elementType = restType && getElementTypeOfArrayType(restType);
	      return elementType && isTypeAny(elementType) ? anyType : restType;
	    }
	    function getParameterCount(signature) {
	      const length2 = signature.parameters.length;
	      if (signatureHasRestParameter(signature)) {
	        const restType = getTypeOfSymbol(signature.parameters[length2 - 1]);
	        if (isTupleType(restType)) {
	          return length2 + restType.target.fixedLength - (restType.target.hasRestElement ? 0 : 1);
	        }
	      }
	      return length2;
	    }
	    function getMinArgumentCount(signature, flags) {
	      const strongArityForUntypedJS = flags & 1 /* StrongArityForUntypedJS */;
	      const voidIsNonOptional = flags & 2 /* VoidIsNonOptional */;
	      if (voidIsNonOptional || signature.resolvedMinArgumentCount === void 0) {
	        let minArgumentCount;
	        if (signatureHasRestParameter(signature)) {
	          const restType = getTypeOfSymbol(signature.parameters[signature.parameters.length - 1]);
	          if (isTupleType(restType)) {
	            const firstOptionalIndex = findIndex(restType.target.elementFlags, (f) => !(f & 1 /* Required */));
	            const requiredCount = firstOptionalIndex < 0 ? restType.target.fixedLength : firstOptionalIndex;
	            if (requiredCount > 0) {
	              minArgumentCount = signature.parameters.length - 1 + requiredCount;
	            }
	          }
	        }
	        if (minArgumentCount === void 0) {
	          if (!strongArityForUntypedJS && signature.flags & 32 /* IsUntypedSignatureInJSFile */) {
	            return 0;
	          }
	          minArgumentCount = signature.minArgumentCount;
	        }
	        if (voidIsNonOptional) {
	          return minArgumentCount;
	        }
	        for (let i = minArgumentCount - 1; i >= 0; i--) {
	          const type = getTypeAtPosition(signature, i);
	          if (filterType(type, acceptsVoid).flags & 131072 /* Never */) {
	            break;
	          }
	          minArgumentCount = i;
	        }
	        signature.resolvedMinArgumentCount = minArgumentCount;
	      }
	      return signature.resolvedMinArgumentCount;
	    }
	    function hasEffectiveRestParameter(signature) {
	      if (signatureHasRestParameter(signature)) {
	        const restType = getTypeOfSymbol(signature.parameters[signature.parameters.length - 1]);
	        return !isTupleType(restType) || restType.target.hasRestElement;
	      }
	      return false;
	    }
	    function getEffectiveRestType(signature) {
	      if (signatureHasRestParameter(signature)) {
	        const restType = getTypeOfSymbol(signature.parameters[signature.parameters.length - 1]);
	        if (!isTupleType(restType)) {
	          return isTypeAny(restType) ? anyArrayType : restType;
	        }
	        if (restType.target.hasRestElement) {
	          return sliceTupleType(restType, restType.target.fixedLength);
	        }
	      }
	      return void 0;
	    }
	    function getNonArrayRestType(signature) {
	      const restType = getEffectiveRestType(signature);
	      return restType && !isArrayType(restType) && !isTypeAny(restType) ? restType : void 0;
	    }
	    function getTypeOfFirstParameterOfSignature(signature) {
	      return getTypeOfFirstParameterOfSignatureWithFallback(signature, neverType);
	    }
	    function getTypeOfFirstParameterOfSignatureWithFallback(signature, fallbackType) {
	      return signature.parameters.length > 0 ? getTypeAtPosition(signature, 0) : fallbackType;
	    }
	    function inferFromAnnotatedParameters(signature, context, inferenceContext) {
	      const len = signature.parameters.length - (signatureHasRestParameter(signature) ? 1 : 0);
	      for (let i = 0; i < len; i++) {
	        const declaration = signature.parameters[i].valueDeclaration;
	        const typeNode = getEffectiveTypeAnnotationNode(declaration);
	        if (typeNode) {
	          const source = addOptionality(
	            getTypeFromTypeNode(typeNode),
	            /*isProperty*/
	            false,
	            isOptionalDeclaration(declaration)
	          );
	          const target = getTypeAtPosition(context, i);
	          inferTypes(inferenceContext.inferences, source, target);
	        }
	      }
	    }
	    function assignContextualParameterTypes(signature, context) {
	      if (context.typeParameters) {
	        if (!signature.typeParameters) {
	          signature.typeParameters = context.typeParameters;
	        } else {
	          return;
	        }
	      }
	      if (context.thisParameter) {
	        const parameter = signature.thisParameter;
	        if (!parameter || parameter.valueDeclaration && !parameter.valueDeclaration.type) {
	          if (!parameter) {
	            signature.thisParameter = createSymbolWithType(
	              context.thisParameter,
	              /*type*/
	              void 0
	            );
	          }
	          assignParameterType(signature.thisParameter, getTypeOfSymbol(context.thisParameter));
	        }
	      }
	      const len = signature.parameters.length - (signatureHasRestParameter(signature) ? 1 : 0);
	      for (let i = 0; i < len; i++) {
	        const parameter = signature.parameters[i];
	        const declaration = parameter.valueDeclaration;
	        if (!getEffectiveTypeAnnotationNode(declaration)) {
	          let type = tryGetTypeAtPosition(context, i);
	          if (type && declaration.initializer) {
	            let initializerType = checkDeclarationInitializer(declaration, 0 /* Normal */);
	            if (!isTypeAssignableTo(initializerType, type) && isTypeAssignableTo(type, initializerType = widenTypeInferredFromInitializer(declaration, initializerType))) {
	              type = initializerType;
	            }
	          }
	          assignParameterType(parameter, type);
	        }
	      }
	      if (signatureHasRestParameter(signature)) {
	        const parameter = last(signature.parameters);
	        if (parameter.valueDeclaration ? !getEffectiveTypeAnnotationNode(parameter.valueDeclaration) : !!(getCheckFlags(parameter) & 65536 /* DeferredType */)) {
	          const contextualParameterType = getRestTypeAtPosition(context, len);
	          assignParameterType(parameter, contextualParameterType);
	        }
	      }
	    }
	    function assignNonContextualParameterTypes(signature) {
	      if (signature.thisParameter) {
	        assignParameterType(signature.thisParameter);
	      }
	      for (const parameter of signature.parameters) {
	        assignParameterType(parameter);
	      }
	    }
	    function assignParameterType(parameter, contextualType) {
	      const links = getSymbolLinks(parameter);
	      if (!links.type) {
	        const declaration = parameter.valueDeclaration;
	        links.type = addOptionality(
	          contextualType || (declaration ? getWidenedTypeForVariableLikeDeclaration(
	            declaration,
	            /*reportErrors*/
	            true
	          ) : getTypeOfSymbol(parameter)),
	          /*isProperty*/
	          false,
	          /*isOptional*/
	          !!declaration && !declaration.initializer && isOptionalDeclaration(declaration)
	        );
	        if (declaration && declaration.name.kind !== 80 /* Identifier */) {
	          if (links.type === unknownType) {
	            links.type = getTypeFromBindingPattern(declaration.name);
	          }
	          assignBindingElementTypes(declaration.name, links.type);
	        }
	      } else if (contextualType) {
	        Debug.assertEqual(links.type, contextualType, "Parameter symbol already has a cached type which differs from newly assigned type");
	      }
	    }
	    function assignBindingElementTypes(pattern, parentType) {
	      for (const element of pattern.elements) {
	        if (!isOmittedExpression(element)) {
	          const type = getBindingElementTypeFromParentType(
	            element,
	            parentType,
	            /*noTupleBoundsCheck*/
	            false
	          );
	          if (element.name.kind === 80 /* Identifier */) {
	            getSymbolLinks(getSymbolOfDeclaration(element)).type = type;
	          } else {
	            assignBindingElementTypes(element.name, type);
	          }
	        }
	      }
	    }
	    function createClassDecoratorContextType(classType) {
	      return tryCreateTypeReference(getGlobalClassDecoratorContextType(
	        /*reportErrors*/
	        true
	      ), [classType]);
	    }
	    function createClassMethodDecoratorContextType(thisType, valueType) {
	      return tryCreateTypeReference(getGlobalClassMethodDecoratorContextType(
	        /*reportErrors*/
	        true
	      ), [thisType, valueType]);
	    }
	    function createClassGetterDecoratorContextType(thisType, valueType) {
	      return tryCreateTypeReference(getGlobalClassGetterDecoratorContextType(
	        /*reportErrors*/
	        true
	      ), [thisType, valueType]);
	    }
	    function createClassSetterDecoratorContextType(thisType, valueType) {
	      return tryCreateTypeReference(getGlobalClassSetterDecoratorContextType(
	        /*reportErrors*/
	        true
	      ), [thisType, valueType]);
	    }
	    function createClassAccessorDecoratorContextType(thisType, valueType) {
	      return tryCreateTypeReference(getGlobalClassAccessorDecoratorContextType(
	        /*reportErrors*/
	        true
	      ), [thisType, valueType]);
	    }
	    function createClassFieldDecoratorContextType(thisType, valueType) {
	      return tryCreateTypeReference(getGlobalClassFieldDecoratorContextType(
	        /*reportErrors*/
	        true
	      ), [thisType, valueType]);
	    }
	    function getClassMemberDecoratorContextOverrideType(nameType, isPrivate, isStatic2) {
	      const key = `${isPrivate ? "p" : "P"}${isStatic2 ? "s" : "S"}${nameType.id}`;
	      let overrideType = decoratorContextOverrideTypeCache.get(key);
	      if (!overrideType) {
	        const members = createSymbolTable();
	        members.set("name", createProperty("name", nameType));
	        members.set("private", createProperty("private", isPrivate ? trueType : falseType));
	        members.set("static", createProperty("static", isStatic2 ? trueType : falseType));
	        overrideType = createAnonymousType(
	          /*symbol*/
	          void 0,
	          members,
	          emptyArray,
	          emptyArray,
	          emptyArray
	        );
	        decoratorContextOverrideTypeCache.set(key, overrideType);
	      }
	      return overrideType;
	    }
	    function createClassMemberDecoratorContextTypeForNode(node, thisType, valueType) {
	      const isStatic2 = hasStaticModifier(node);
	      const isPrivate = isPrivateIdentifier(node.name);
	      const nameType = isPrivate ? getStringLiteralType(idText(node.name)) : getLiteralTypeFromPropertyName(node.name);
	      const contextType = isMethodDeclaration(node) ? createClassMethodDecoratorContextType(thisType, valueType) : isGetAccessorDeclaration(node) ? createClassGetterDecoratorContextType(thisType, valueType) : isSetAccessorDeclaration(node) ? createClassSetterDecoratorContextType(thisType, valueType) : isAutoAccessorPropertyDeclaration(node) ? createClassAccessorDecoratorContextType(thisType, valueType) : isPropertyDeclaration(node) ? createClassFieldDecoratorContextType(thisType, valueType) : Debug.failBadSyntaxKind(node);
	      const overrideType = getClassMemberDecoratorContextOverrideType(nameType, isPrivate, isStatic2);
	      return getIntersectionType([contextType, overrideType]);
	    }
	    function createClassAccessorDecoratorTargetType(thisType, valueType) {
	      return tryCreateTypeReference(getGlobalClassAccessorDecoratorTargetType(
	        /*reportErrors*/
	        true
	      ), [thisType, valueType]);
	    }
	    function createClassAccessorDecoratorResultType(thisType, valueType) {
	      return tryCreateTypeReference(getGlobalClassAccessorDecoratorResultType(
	        /*reportErrors*/
	        true
	      ), [thisType, valueType]);
	    }
	    function createClassFieldDecoratorInitializerMutatorType(thisType, valueType) {
	      const thisParam = createParameter2("this", thisType);
	      const valueParam = createParameter2("value", valueType);
	      return createFunctionType(
	        /*typeParameters*/
	        void 0,
	        thisParam,
	        [valueParam],
	        valueType,
	        /*typePredicate*/
	        void 0,
	        1
	      );
	    }
	    function createESDecoratorCallSignature(targetType, contextType, nonOptionalReturnType) {
	      const targetParam = createParameter2("target", targetType);
	      const contextParam = createParameter2("context", contextType);
	      const returnType = getUnionType([nonOptionalReturnType, voidType]);
	      return createCallSignature(
	        /*typeParameters*/
	        void 0,
	        /*thisParameter*/
	        void 0,
	        [targetParam, contextParam],
	        returnType
	      );
	    }
	    function getESDecoratorCallSignature(decorator) {
	      const { parent: parent2 } = decorator;
	      const links = getNodeLinks(parent2);
	      if (!links.decoratorSignature) {
	        links.decoratorSignature = anySignature;
	        switch (parent2.kind) {
	          case 263 /* ClassDeclaration */:
	          case 231 /* ClassExpression */: {
	            const node = parent2;
	            const targetType = getTypeOfSymbol(getSymbolOfDeclaration(node));
	            const contextType = createClassDecoratorContextType(targetType);
	            links.decoratorSignature = createESDecoratorCallSignature(targetType, contextType, targetType);
	            break;
	          }
	          case 174 /* MethodDeclaration */:
	          case 177 /* GetAccessor */:
	          case 178 /* SetAccessor */: {
	            const node = parent2;
	            if (!isClassLike(node.parent))
	              break;
	            const valueType = isMethodDeclaration(node) ? getOrCreateTypeFromSignature(getSignatureFromDeclaration(node)) : getTypeOfNode(node);
	            const thisType = hasStaticModifier(node) ? getTypeOfSymbol(getSymbolOfDeclaration(node.parent)) : getDeclaredTypeOfClassOrInterface(getSymbolOfDeclaration(node.parent));
	            const targetType = isGetAccessorDeclaration(node) ? createGetterFunctionType(valueType) : isSetAccessorDeclaration(node) ? createSetterFunctionType(valueType) : valueType;
	            const contextType = createClassMemberDecoratorContextTypeForNode(node, thisType, valueType);
	            const returnType = isGetAccessorDeclaration(node) ? createGetterFunctionType(valueType) : isSetAccessorDeclaration(node) ? createSetterFunctionType(valueType) : valueType;
	            links.decoratorSignature = createESDecoratorCallSignature(targetType, contextType, returnType);
	            break;
	          }
	          case 172 /* PropertyDeclaration */: {
	            const node = parent2;
	            if (!isClassLike(node.parent))
	              break;
	            const valueType = getTypeOfNode(node);
	            const thisType = hasStaticModifier(node) ? getTypeOfSymbol(getSymbolOfDeclaration(node.parent)) : getDeclaredTypeOfClassOrInterface(getSymbolOfDeclaration(node.parent));
	            const targetType = hasAccessorModifier(node) ? createClassAccessorDecoratorTargetType(thisType, valueType) : undefinedType;
	            const contextType = createClassMemberDecoratorContextTypeForNode(node, thisType, valueType);
	            const returnType = hasAccessorModifier(node) ? createClassAccessorDecoratorResultType(thisType, valueType) : createClassFieldDecoratorInitializerMutatorType(thisType, valueType);
	            links.decoratorSignature = createESDecoratorCallSignature(targetType, contextType, returnType);
	            break;
	          }
	        }
	      }
	      return links.decoratorSignature === anySignature ? void 0 : links.decoratorSignature;
	    }
	    function getLegacyDecoratorCallSignature(decorator) {
	      const { parent: parent2 } = decorator;
	      const links = getNodeLinks(parent2);
	      if (!links.decoratorSignature) {
	        links.decoratorSignature = anySignature;
	        switch (parent2.kind) {
	          case 263 /* ClassDeclaration */:
	          case 231 /* ClassExpression */: {
	            const node = parent2;
	            const targetType = getTypeOfSymbol(getSymbolOfDeclaration(node));
	            const targetParam = createParameter2("target", targetType);
	            links.decoratorSignature = createCallSignature(
	              /*typeParameters*/
	              void 0,
	              /*thisParameter*/
	              void 0,
	              [targetParam],
	              getUnionType([targetType, voidType])
	            );
	            break;
	          }
	          case 169 /* Parameter */: {
	            const node = parent2;
	            if (!isConstructorDeclaration(node.parent) && !(isMethodDeclaration(node.parent) || isSetAccessorDeclaration(node.parent) && isClassLike(node.parent.parent))) {
	              break;
	            }
	            if (getThisParameter(node.parent) === node) {
	              break;
	            }
	            const index = getThisParameter(node.parent) ? node.parent.parameters.indexOf(node) - 1 : node.parent.parameters.indexOf(node);
	            Debug.assert(index >= 0);
	            const targetType = isConstructorDeclaration(node.parent) ? getTypeOfSymbol(getSymbolOfDeclaration(node.parent.parent)) : getParentTypeOfClassElement(node.parent);
	            const keyType = isConstructorDeclaration(node.parent) ? undefinedType : getClassElementPropertyKeyType(node.parent);
	            const indexType = getNumberLiteralType(index);
	            const targetParam = createParameter2("target", targetType);
	            const keyParam = createParameter2("propertyKey", keyType);
	            const indexParam = createParameter2("parameterIndex", indexType);
	            links.decoratorSignature = createCallSignature(
	              /*typeParameters*/
	              void 0,
	              /*thisParameter*/
	              void 0,
	              [targetParam, keyParam, indexParam],
	              voidType
	            );
	            break;
	          }
	          case 174 /* MethodDeclaration */:
	          case 177 /* GetAccessor */:
	          case 178 /* SetAccessor */:
	          case 172 /* PropertyDeclaration */: {
	            const node = parent2;
	            if (!isClassLike(node.parent))
	              break;
	            const targetType = getParentTypeOfClassElement(node);
	            const targetParam = createParameter2("target", targetType);
	            const keyType = getClassElementPropertyKeyType(node);
	            const keyParam = createParameter2("propertyKey", keyType);
	            const returnType = isPropertyDeclaration(node) ? voidType : createTypedPropertyDescriptorType(getTypeOfNode(node));
	            const hasPropDesc = languageVersion !== 0 /* ES3 */ && (!isPropertyDeclaration(parent2) || hasAccessorModifier(parent2));
	            if (hasPropDesc) {
	              const descriptorType = createTypedPropertyDescriptorType(getTypeOfNode(node));
	              const descriptorParam = createParameter2("descriptor", descriptorType);
	              links.decoratorSignature = createCallSignature(
	                /*typeParameters*/
	                void 0,
	                /*thisParameter*/
	                void 0,
	                [targetParam, keyParam, descriptorParam],
	                getUnionType([returnType, voidType])
	              );
	            } else {
	              links.decoratorSignature = createCallSignature(
	                /*typeParameters*/
	                void 0,
	                /*thisParameter*/
	                void 0,
	                [targetParam, keyParam],
	                getUnionType([returnType, voidType])
	              );
	            }
	            break;
	          }
	        }
	      }
	      return links.decoratorSignature === anySignature ? void 0 : links.decoratorSignature;
	    }
	    function getDecoratorCallSignature(decorator) {
	      return legacyDecorators ? getLegacyDecoratorCallSignature(decorator) : getESDecoratorCallSignature(decorator);
	    }
	    function createPromiseType(promisedType) {
	      const globalPromiseType = getGlobalPromiseType(
	        /*reportErrors*/
	        true
	      );
	      if (globalPromiseType !== emptyGenericType) {
	        promisedType = getAwaitedTypeNoAlias(unwrapAwaitedType(promisedType)) || unknownType;
	        return createTypeReference(globalPromiseType, [promisedType]);
	      }
	      return unknownType;
	    }
	    function createPromiseLikeType(promisedType) {
	      const globalPromiseLikeType = getGlobalPromiseLikeType(
	        /*reportErrors*/
	        true
	      );
	      if (globalPromiseLikeType !== emptyGenericType) {
	        promisedType = getAwaitedTypeNoAlias(unwrapAwaitedType(promisedType)) || unknownType;
	        return createTypeReference(globalPromiseLikeType, [promisedType]);
	      }
	      return unknownType;
	    }
	    function createPromiseReturnType(func, promisedType) {
	      const promiseType = createPromiseType(promisedType);
	      if (promiseType === unknownType) {
	        error2(
	          func,
	          isImportCall(func) ? Diagnostics.A_dynamic_import_call_returns_a_Promise_Make_sure_you_have_a_declaration_for_Promise_or_include_ES2015_in_your_lib_option : Diagnostics.An_async_function_or_method_must_return_a_Promise_Make_sure_you_have_a_declaration_for_Promise_or_include_ES2015_in_your_lib_option
	        );
	        return errorType;
	      } else if (!getGlobalPromiseConstructorSymbol(
	        /*reportErrors*/
	        true
	      )) {
	        error2(
	          func,
	          isImportCall(func) ? Diagnostics.A_dynamic_import_call_in_ES5_SlashES3_requires_the_Promise_constructor_Make_sure_you_have_a_declaration_for_the_Promise_constructor_or_include_ES2015_in_your_lib_option : Diagnostics.An_async_function_or_method_in_ES5_SlashES3_requires_the_Promise_constructor_Make_sure_you_have_a_declaration_for_the_Promise_constructor_or_include_ES2015_in_your_lib_option
	        );
	      }
	      return promiseType;
	    }
	    function createNewTargetExpressionType(targetType) {
	      const symbol = createSymbol(0 /* None */, "NewTargetExpression");
	      const targetPropertySymbol = createSymbol(4 /* Property */, "target", 8 /* Readonly */);
	      targetPropertySymbol.parent = symbol;
	      targetPropertySymbol.links.type = targetType;
	      const members = createSymbolTable([targetPropertySymbol]);
	      symbol.members = members;
	      return createAnonymousType(symbol, members, emptyArray, emptyArray, emptyArray);
	    }
	    function getReturnTypeFromBody(func, checkMode) {
	      if (!func.body) {
	        return errorType;
	      }
	      const functionFlags = getFunctionFlags(func);
	      const isAsync = (functionFlags & 2 /* Async */) !== 0;
	      const isGenerator = (functionFlags & 1 /* Generator */) !== 0;
	      let returnType;
	      let yieldType;
	      let nextType;
	      let fallbackReturnType = voidType;
	      if (func.body.kind !== 241 /* Block */) {
	        returnType = checkExpressionCached(func.body, checkMode && checkMode & ~8 /* SkipGenericFunctions */);
	        if (isAsync) {
	          returnType = unwrapAwaitedType(checkAwaitedType(
	            returnType,
	            /*withAlias*/
	            false,
	            /*errorNode*/
	            func,
	            Diagnostics.The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member
	          ));
	        }
	      } else if (isGenerator) {
	        const returnTypes = checkAndAggregateReturnExpressionTypes(func, checkMode);
	        if (!returnTypes) {
	          fallbackReturnType = neverType;
	        } else if (returnTypes.length > 0) {
	          returnType = getUnionType(returnTypes, 2 /* Subtype */);
	        }
	        const { yieldTypes, nextTypes } = checkAndAggregateYieldOperandTypes(func, checkMode);
	        yieldType = some(yieldTypes) ? getUnionType(yieldTypes, 2 /* Subtype */) : void 0;
	        nextType = some(nextTypes) ? getIntersectionType(nextTypes) : void 0;
	      } else {
	        const types = checkAndAggregateReturnExpressionTypes(func, checkMode);
	        if (!types) {
	          return functionFlags & 2 /* Async */ ? createPromiseReturnType(func, neverType) : neverType;
	        }
	        if (types.length === 0) {
	          const contextualReturnType = getContextualReturnType(
	            func,
	            /*contextFlags*/
	            void 0
	          );
	          const returnType2 = contextualReturnType && (unwrapReturnType(contextualReturnType, functionFlags) || voidType).flags & 32768 /* Undefined */ ? undefinedType : voidType;
	          return functionFlags & 2 /* Async */ ? createPromiseReturnType(func, returnType2) : (
	            // Async function
	            returnType2
	          );
	        }
	        returnType = getUnionType(types, 2 /* Subtype */);
	      }
	      if (returnType || yieldType || nextType) {
	        if (yieldType)
	          reportErrorsFromWidening(func, yieldType, 3 /* GeneratorYield */);
	        if (returnType)
	          reportErrorsFromWidening(func, returnType, 1 /* FunctionReturn */);
	        if (nextType)
	          reportErrorsFromWidening(func, nextType, 2 /* GeneratorNext */);
	        if (returnType && isUnitType(returnType) || yieldType && isUnitType(yieldType) || nextType && isUnitType(nextType)) {
	          const contextualSignature = getContextualSignatureForFunctionLikeDeclaration(func);
	          const contextualType = !contextualSignature ? void 0 : contextualSignature === getSignatureFromDeclaration(func) ? isGenerator ? void 0 : returnType : instantiateContextualType(
	            getReturnTypeOfSignature(contextualSignature),
	            func,
	            /*contextFlags*/
	            void 0
	          );
	          if (isGenerator) {
	            yieldType = getWidenedLiteralLikeTypeForContextualIterationTypeIfNeeded(yieldType, contextualType, 0 /* Yield */, isAsync);
	            returnType = getWidenedLiteralLikeTypeForContextualIterationTypeIfNeeded(returnType, contextualType, 1 /* Return */, isAsync);
	            nextType = getWidenedLiteralLikeTypeForContextualIterationTypeIfNeeded(nextType, contextualType, 2 /* Next */, isAsync);
	          } else {
	            returnType = getWidenedLiteralLikeTypeForContextualReturnTypeIfNeeded(returnType, contextualType, isAsync);
	          }
	        }
	        if (yieldType)
	          yieldType = getWidenedType(yieldType);
	        if (returnType)
	          returnType = getWidenedType(returnType);
	        if (nextType)
	          nextType = getWidenedType(nextType);
	      }
	      if (isGenerator) {
	        return createGeneratorReturnType(
	          yieldType || neverType,
	          returnType || fallbackReturnType,
	          nextType || getContextualIterationType(2 /* Next */, func) || unknownType,
	          isAsync
	        );
	      } else {
	        return isAsync ? createPromiseType(returnType || fallbackReturnType) : returnType || fallbackReturnType;
	      }
	    }
	    function createGeneratorReturnType(yieldType, returnType, nextType, isAsyncGenerator) {
	      const resolver = isAsyncGenerator ? asyncIterationTypesResolver : syncIterationTypesResolver;
	      const globalGeneratorType = resolver.getGlobalGeneratorType(
	        /*reportErrors*/
	        false
	      );
	      yieldType = resolver.resolveIterationType(
	        yieldType,
	        /*errorNode*/
	        void 0
	      ) || unknownType;
	      returnType = resolver.resolveIterationType(
	        returnType,
	        /*errorNode*/
	        void 0
	      ) || unknownType;
	      nextType = resolver.resolveIterationType(
	        nextType,
	        /*errorNode*/
	        void 0
	      ) || unknownType;
	      if (globalGeneratorType === emptyGenericType) {
	        const globalType = resolver.getGlobalIterableIteratorType(
	          /*reportErrors*/
	          false
	        );
	        const iterationTypes = globalType !== emptyGenericType ? getIterationTypesOfGlobalIterableType(globalType, resolver) : void 0;
	        const iterableIteratorReturnType = iterationTypes ? iterationTypes.returnType : anyType;
	        const iterableIteratorNextType = iterationTypes ? iterationTypes.nextType : undefinedType;
	        if (isTypeAssignableTo(returnType, iterableIteratorReturnType) && isTypeAssignableTo(iterableIteratorNextType, nextType)) {
	          if (globalType !== emptyGenericType) {
	            return createTypeFromGenericGlobalType(globalType, [yieldType]);
	          }
	          resolver.getGlobalIterableIteratorType(
	            /*reportErrors*/
	            true
	          );
	          return emptyObjectType;
	        }
	        resolver.getGlobalGeneratorType(
	          /*reportErrors*/
	          true
	        );
	        return emptyObjectType;
	      }
	      return createTypeFromGenericGlobalType(globalGeneratorType, [yieldType, returnType, nextType]);
	    }
	    function checkAndAggregateYieldOperandTypes(func, checkMode) {
	      const yieldTypes = [];
	      const nextTypes = [];
	      const isAsync = (getFunctionFlags(func) & 2 /* Async */) !== 0;
	      forEachYieldExpression(func.body, (yieldExpression) => {
	        const yieldExpressionType = yieldExpression.expression ? checkExpression(yieldExpression.expression, checkMode) : undefinedWideningType;
	        pushIfUnique(yieldTypes, getYieldedTypeOfYieldExpression(yieldExpression, yieldExpressionType, anyType, isAsync));
	        let nextType;
	        if (yieldExpression.asteriskToken) {
	          const iterationTypes = getIterationTypesOfIterable(
	            yieldExpressionType,
	            isAsync ? 19 /* AsyncYieldStar */ : 17 /* YieldStar */,
	            yieldExpression.expression
	          );
	          nextType = iterationTypes && iterationTypes.nextType;
	        } else {
	          nextType = getContextualType2(
	            yieldExpression,
	            /*contextFlags*/
	            void 0
	          );
	        }
	        if (nextType)
	          pushIfUnique(nextTypes, nextType);
	      });
	      return { yieldTypes, nextTypes };
	    }
	    function getYieldedTypeOfYieldExpression(node, expressionType, sentType, isAsync) {
	      const errorNode = node.expression || node;
	      const yieldedType = node.asteriskToken ? checkIteratedTypeOrElementType(isAsync ? 19 /* AsyncYieldStar */ : 17 /* YieldStar */, expressionType, sentType, errorNode) : expressionType;
	      return !isAsync ? yieldedType : getAwaitedType(
	        yieldedType,
	        errorNode,
	        node.asteriskToken ? Diagnostics.Type_of_iterated_elements_of_a_yield_Asterisk_operand_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member : Diagnostics.Type_of_yield_operand_in_an_async_generator_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member
	      );
	    }
	    function getNotEqualFactsFromTypeofSwitch(start, end, witnesses) {
	      let facts = 0 /* None */;
	      for (let i = 0; i < witnesses.length; i++) {
	        const witness = i < start || i >= end ? witnesses[i] : void 0;
	        facts |= witness !== void 0 ? typeofNEFacts.get(witness) || 32768 /* TypeofNEHostObject */ : 0;
	      }
	      return facts;
	    }
	    function isExhaustiveSwitchStatement(node) {
	      const links = getNodeLinks(node);
	      if (links.isExhaustive === void 0) {
	        links.isExhaustive = 0;
	        const exhaustive = computeExhaustiveSwitchStatement(node);
	        if (links.isExhaustive === 0) {
	          links.isExhaustive = exhaustive;
	        }
	      } else if (links.isExhaustive === 0) {
	        links.isExhaustive = false;
	      }
	      return links.isExhaustive;
	    }
	    function computeExhaustiveSwitchStatement(node) {
	      if (node.expression.kind === 221 /* TypeOfExpression */) {
	        const witnesses = getSwitchClauseTypeOfWitnesses(node);
	        if (!witnesses) {
	          return false;
	        }
	        const operandConstraint = getBaseConstraintOrType(checkExpressionCached(node.expression.expression));
	        const notEqualFacts = getNotEqualFactsFromTypeofSwitch(0, 0, witnesses);
	        if (operandConstraint.flags & 3 /* AnyOrUnknown */) {
	          return (556800 /* AllTypeofNE */ & notEqualFacts) === 556800 /* AllTypeofNE */;
	        }
	        return !someType(operandConstraint, (t) => getTypeFacts(t, notEqualFacts) === notEqualFacts);
	      }
	      const type = checkExpressionCached(node.expression);
	      if (!isLiteralType(type)) {
	        return false;
	      }
	      const switchTypes = getSwitchClauseTypes(node);
	      if (!switchTypes.length || some(switchTypes, isNeitherUnitTypeNorNever)) {
	        return false;
	      }
	      return eachTypeContainedIn(mapType(type, getRegularTypeOfLiteralType), switchTypes);
	    }
	    function functionHasImplicitReturn(func) {
	      return func.endFlowNode && isReachableFlowNode(func.endFlowNode);
	    }
	    function checkAndAggregateReturnExpressionTypes(func, checkMode) {
	      const functionFlags = getFunctionFlags(func);
	      const aggregatedTypes = [];
	      let hasReturnWithNoExpression = functionHasImplicitReturn(func);
	      let hasReturnOfTypeNever = false;
	      forEachReturnStatement(func.body, (returnStatement) => {
	        let expr = returnStatement.expression;
	        if (expr) {
	          expr = skipParentheses(
	            expr,
	            /*excludeJSDocTypeAssertions*/
	            true
	          );
	          if (functionFlags & 2 /* Async */ && expr.kind === 223 /* AwaitExpression */) {
	            expr = skipParentheses(
	              expr.expression,
	              /*excludeJSDocTypeAssertions*/
	              true
	            );
	          }
	          if (expr.kind === 213 /* CallExpression */ && expr.expression.kind === 80 /* Identifier */ && checkExpressionCached(expr.expression).symbol === func.symbol) {
	            hasReturnOfTypeNever = true;
	            return;
	          }
	          let type = checkExpressionCached(expr, checkMode && checkMode & ~8 /* SkipGenericFunctions */);
	          if (functionFlags & 2 /* Async */) {
	            type = unwrapAwaitedType(checkAwaitedType(
	              type,
	              /*withAlias*/
	              false,
	              func,
	              Diagnostics.The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member
	            ));
	          }
	          if (type.flags & 131072 /* Never */) {
	            hasReturnOfTypeNever = true;
	          }
	          pushIfUnique(aggregatedTypes, type);
	        } else {
	          hasReturnWithNoExpression = true;
	        }
	      });
	      if (aggregatedTypes.length === 0 && !hasReturnWithNoExpression && (hasReturnOfTypeNever || mayReturnNever(func))) {
	        return void 0;
	      }
	      if (strictNullChecks && aggregatedTypes.length && hasReturnWithNoExpression && !(isJSConstructor(func) && aggregatedTypes.some((t) => t.symbol === func.symbol))) {
	        pushIfUnique(aggregatedTypes, undefinedType);
	      }
	      return aggregatedTypes;
	    }
	    function mayReturnNever(func) {
	      switch (func.kind) {
	        case 218 /* FunctionExpression */:
	        case 219 /* ArrowFunction */:
	          return true;
	        case 174 /* MethodDeclaration */:
	          return func.parent.kind === 210 /* ObjectLiteralExpression */;
	        default:
	          return false;
	      }
	    }
	    function checkAllCodePathsInNonVoidFunctionReturnOrThrow(func, returnType) {
	      addLazyDiagnostic(checkAllCodePathsInNonVoidFunctionReturnOrThrowDiagnostics);
	      return;
	      function checkAllCodePathsInNonVoidFunctionReturnOrThrowDiagnostics() {
	        const functionFlags = getFunctionFlags(func);
	        const type = returnType && unwrapReturnType(returnType, functionFlags);
	        if (type && (maybeTypeOfKind(type, 16384 /* Void */) || type.flags & (1 /* Any */ | 32768 /* Undefined */))) {
	          return;
	        }
	        if (func.kind === 173 /* MethodSignature */ || nodeIsMissing(func.body) || func.body.kind !== 241 /* Block */ || !functionHasImplicitReturn(func)) {
	          return;
	        }
	        const hasExplicitReturn = func.flags & 1024 /* HasExplicitReturn */;
	        const errorNode = getEffectiveReturnTypeNode(func) || func;
	        if (type && type.flags & 131072 /* Never */) {
	          error2(errorNode, Diagnostics.A_function_returning_never_cannot_have_a_reachable_end_point);
	        } else if (type && !hasExplicitReturn) {
	          error2(errorNode, Diagnostics.A_function_whose_declared_type_is_neither_undefined_void_nor_any_must_return_a_value);
	        } else if (type && strictNullChecks && !isTypeAssignableTo(undefinedType, type)) {
	          error2(errorNode, Diagnostics.Function_lacks_ending_return_statement_and_return_type_does_not_include_undefined);
	        } else if (compilerOptions.noImplicitReturns) {
	          if (!type) {
	            if (!hasExplicitReturn) {
	              return;
	            }
	            const inferredReturnType = getReturnTypeOfSignature(getSignatureFromDeclaration(func));
	            if (isUnwrappedReturnTypeUndefinedVoidOrAny(func, inferredReturnType)) {
	              return;
	            }
	          }
	          error2(errorNode, Diagnostics.Not_all_code_paths_return_a_value);
	        }
	      }
	    }
	    function checkFunctionExpressionOrObjectLiteralMethod(node, checkMode) {
	      Debug.assert(node.kind !== 174 /* MethodDeclaration */ || isObjectLiteralMethod(node));
	      checkNodeDeferred(node);
	      if (isFunctionExpression(node)) {
	        checkCollisionsForDeclarationName(node, node.name);
	      }
	      if (checkMode && checkMode & 4 /* SkipContextSensitive */ && isContextSensitive(node)) {
	        if (!getEffectiveReturnTypeNode(node) && !hasContextSensitiveParameters(node)) {
	          const contextualSignature = getContextualSignature(node);
	          if (contextualSignature && couldContainTypeVariables(getReturnTypeOfSignature(contextualSignature))) {
	            const links = getNodeLinks(node);
	            if (links.contextFreeType) {
	              return links.contextFreeType;
	            }
	            const returnType = getReturnTypeFromBody(node, checkMode);
	            const returnOnlySignature = createSignature(
	              /*declaration*/
	              void 0,
	              /*typeParameters*/
	              void 0,
	              /*thisParameter*/
	              void 0,
	              emptyArray,
	              returnType,
	              /*resolvedTypePredicate*/
	              void 0,
	              0,
	              64 /* IsNonInferrable */
	            );
	            const returnOnlyType = createAnonymousType(node.symbol, emptySymbols, [returnOnlySignature], emptyArray, emptyArray);
	            returnOnlyType.objectFlags |= 262144 /* NonInferrableType */;
	            return links.contextFreeType = returnOnlyType;
	          }
	        }
	        return anyFunctionType;
	      }
	      const hasGrammarError = checkGrammarFunctionLikeDeclaration(node);
	      if (!hasGrammarError && node.kind === 218 /* FunctionExpression */) {
	        checkGrammarForGenerator(node);
	      }
	      contextuallyCheckFunctionExpressionOrObjectLiteralMethod(node, checkMode);
	      return getTypeOfSymbol(getSymbolOfDeclaration(node));
	    }
	    function contextuallyCheckFunctionExpressionOrObjectLiteralMethod(node, checkMode) {
	      const links = getNodeLinks(node);
	      if (!(links.flags & 64 /* ContextChecked */)) {
	        const contextualSignature = getContextualSignature(node);
	        if (!(links.flags & 64 /* ContextChecked */)) {
	          links.flags |= 64 /* ContextChecked */;
	          const signature = firstOrUndefined(getSignaturesOfType(getTypeOfSymbol(getSymbolOfDeclaration(node)), 0 /* Call */));
	          if (!signature) {
	            return;
	          }
	          if (isContextSensitive(node)) {
	            if (contextualSignature) {
	              const inferenceContext = getInferenceContext(node);
	              let instantiatedContextualSignature;
	              if (checkMode && checkMode & 2 /* Inferential */) {
	                inferFromAnnotatedParameters(signature, contextualSignature, inferenceContext);
	                const restType = getEffectiveRestType(contextualSignature);
	                if (restType && restType.flags & 262144 /* TypeParameter */) {
	                  instantiatedContextualSignature = instantiateSignature(contextualSignature, inferenceContext.nonFixingMapper);
	                }
	              }
	              instantiatedContextualSignature || (instantiatedContextualSignature = inferenceContext ? instantiateSignature(contextualSignature, inferenceContext.mapper) : contextualSignature);
	              assignContextualParameterTypes(signature, instantiatedContextualSignature);
	            } else {
	              assignNonContextualParameterTypes(signature);
	            }
	          } else if (contextualSignature && !node.typeParameters && contextualSignature.parameters.length > node.parameters.length) {
	            const inferenceContext = getInferenceContext(node);
	            if (checkMode && checkMode & 2 /* Inferential */) {
	              inferFromAnnotatedParameters(signature, contextualSignature, inferenceContext);
	            }
	          }
	          if (contextualSignature && !getReturnTypeFromAnnotation(node) && !signature.resolvedReturnType) {
	            const returnType = getReturnTypeFromBody(node, checkMode);
	            if (!signature.resolvedReturnType) {
	              signature.resolvedReturnType = returnType;
	            }
	          }
	          checkSignatureDeclaration(node);
	        }
	      }
	    }
	    function checkFunctionExpressionOrObjectLiteralMethodDeferred(node) {
	      Debug.assert(node.kind !== 174 /* MethodDeclaration */ || isObjectLiteralMethod(node));
	      const functionFlags = getFunctionFlags(node);
	      const returnType = getReturnTypeFromAnnotation(node);
	      checkAllCodePathsInNonVoidFunctionReturnOrThrow(node, returnType);
	      if (node.body) {
	        if (!getEffectiveReturnTypeNode(node)) {
	          getReturnTypeOfSignature(getSignatureFromDeclaration(node));
	        }
	        if (node.body.kind === 241 /* Block */) {
	          checkSourceElement(node.body);
	        } else {
	          const exprType = checkExpression(node.body);
	          const returnOrPromisedType = returnType && unwrapReturnType(returnType, functionFlags);
	          if (returnOrPromisedType) {
	            const effectiveCheckNode = getEffectiveCheckNode(node.body);
	            if ((functionFlags & 3 /* AsyncGenerator */) === 2 /* Async */) {
	              const awaitedType = checkAwaitedType(
	                exprType,
	                /*withAlias*/
	                false,
	                effectiveCheckNode,
	                Diagnostics.The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member
	              );
	              checkTypeAssignableToAndOptionallyElaborate(awaitedType, returnOrPromisedType, effectiveCheckNode, effectiveCheckNode);
	            } else {
	              checkTypeAssignableToAndOptionallyElaborate(exprType, returnOrPromisedType, effectiveCheckNode, effectiveCheckNode);
	            }
	          }
	        }
	      }
	    }
	    function checkArithmeticOperandType(operand, type, diagnostic, isAwaitValid = false) {
	      if (!isTypeAssignableTo(type, numberOrBigIntType)) {
	        const awaitedType = isAwaitValid && getAwaitedTypeOfPromise(type);
	        errorAndMaybeSuggestAwait(
	          operand,
	          !!awaitedType && isTypeAssignableTo(awaitedType, numberOrBigIntType),
	          diagnostic
	        );
	        return false;
	      }
	      return true;
	    }
	    function isReadonlyAssignmentDeclaration(d) {
	      if (!isCallExpression(d)) {
	        return false;
	      }
	      if (!isBindableObjectDefinePropertyCall(d)) {
	        return false;
	      }
	      const objectLitType = checkExpressionCached(d.arguments[2]);
	      const valueType = getTypeOfPropertyOfType(objectLitType, "value");
	      if (valueType) {
	        const writableProp = getPropertyOfType(objectLitType, "writable");
	        const writableType = writableProp && getTypeOfSymbol(writableProp);
	        if (!writableType || writableType === falseType || writableType === regularFalseType) {
	          return true;
	        }
	        if (writableProp && writableProp.valueDeclaration && isPropertyAssignment(writableProp.valueDeclaration)) {
	          const initializer = writableProp.valueDeclaration.initializer;
	          const rawOriginalType = checkExpression(initializer);
	          if (rawOriginalType === falseType || rawOriginalType === regularFalseType) {
	            return true;
	          }
	        }
	        return false;
	      }
	      const setProp = getPropertyOfType(objectLitType, "set");
	      return !setProp;
	    }
	    function isReadonlySymbol(symbol) {
	      return !!(getCheckFlags(symbol) & 8 /* Readonly */ || symbol.flags & 4 /* Property */ && getDeclarationModifierFlagsFromSymbol(symbol) & 8 /* Readonly */ || symbol.flags & 3 /* Variable */ && getDeclarationNodeFlagsFromSymbol(symbol) & 6 /* Constant */ || symbol.flags & 98304 /* Accessor */ && !(symbol.flags & 65536 /* SetAccessor */) || symbol.flags & 8 /* EnumMember */ || some(symbol.declarations, isReadonlyAssignmentDeclaration));
	    }
	    function isAssignmentToReadonlyEntity(expr, symbol, assignmentKind) {
	      var _a, _b;
	      if (assignmentKind === 0 /* None */) {
	        return false;
	      }
	      if (isReadonlySymbol(symbol)) {
	        if (symbol.flags & 4 /* Property */ && isAccessExpression(expr) && expr.expression.kind === 110 /* ThisKeyword */) {
	          const ctor = getContainingFunction(expr);
	          if (!(ctor && (ctor.kind === 176 /* Constructor */ || isJSConstructor(ctor)))) {
	            return true;
	          }
	          if (symbol.valueDeclaration) {
	            const isAssignmentDeclaration2 = isBinaryExpression(symbol.valueDeclaration);
	            const isLocalPropertyDeclaration = ctor.parent === symbol.valueDeclaration.parent;
	            const isLocalParameterProperty = ctor === symbol.valueDeclaration.parent;
	            const isLocalThisPropertyAssignment = isAssignmentDeclaration2 && ((_a = symbol.parent) == null ? void 0 : _a.valueDeclaration) === ctor.parent;
	            const isLocalThisPropertyAssignmentConstructorFunction = isAssignmentDeclaration2 && ((_b = symbol.parent) == null ? void 0 : _b.valueDeclaration) === ctor;
	            const isWriteableSymbol = isLocalPropertyDeclaration || isLocalParameterProperty || isLocalThisPropertyAssignment || isLocalThisPropertyAssignmentConstructorFunction;
	            return !isWriteableSymbol;
	          }
	        }
	        return true;
	      }
	      if (isAccessExpression(expr)) {
	        const node = skipParentheses(expr.expression);
	        if (node.kind === 80 /* Identifier */) {
	          const symbol2 = getNodeLinks(node).resolvedSymbol;
	          if (symbol2.flags & 2097152 /* Alias */) {
	            const declaration = getDeclarationOfAliasSymbol(symbol2);
	            return !!declaration && declaration.kind === 274 /* NamespaceImport */;
	          }
	        }
	      }
	      return false;
	    }
	    function checkReferenceExpression(expr, invalidReferenceMessage, invalidOptionalChainMessage) {
	      const node = skipOuterExpressions(expr, 6 /* Assertions */ | 1 /* Parentheses */);
	      if (node.kind !== 80 /* Identifier */ && !isAccessExpression(node)) {
	        error2(expr, invalidReferenceMessage);
	        return false;
	      }
	      if (node.flags & 64 /* OptionalChain */) {
	        error2(expr, invalidOptionalChainMessage);
	        return false;
	      }
	      return true;
	    }
	    function checkDeleteExpression(node) {
	      checkExpression(node.expression);
	      const expr = skipParentheses(node.expression);
	      if (!isAccessExpression(expr)) {
	        error2(expr, Diagnostics.The_operand_of_a_delete_operator_must_be_a_property_reference);
	        return booleanType;
	      }
	      if (isPropertyAccessExpression(expr) && isPrivateIdentifier(expr.name)) {
	        error2(expr, Diagnostics.The_operand_of_a_delete_operator_cannot_be_a_private_identifier);
	      }
	      const links = getNodeLinks(expr);
	      const symbol = getExportSymbolOfValueSymbolIfExported(links.resolvedSymbol);
	      if (symbol) {
	        if (isReadonlySymbol(symbol)) {
	          error2(expr, Diagnostics.The_operand_of_a_delete_operator_cannot_be_a_read_only_property);
	        } else {
	          checkDeleteExpressionMustBeOptional(expr, symbol);
	        }
	      }
	      return booleanType;
	    }
	    function checkDeleteExpressionMustBeOptional(expr, symbol) {
	      const type = getTypeOfSymbol(symbol);
	      if (strictNullChecks && !(type.flags & (3 /* AnyOrUnknown */ | 131072 /* Never */)) && !(exactOptionalPropertyTypes ? symbol.flags & 16777216 /* Optional */ : hasTypeFacts(type, 16777216 /* IsUndefined */))) {
	        error2(expr, Diagnostics.The_operand_of_a_delete_operator_must_be_optional);
	      }
	    }
	    function checkTypeOfExpression(node) {
	      checkExpression(node.expression);
	      return typeofType;
	    }
	    function checkVoidExpression(node) {
	      checkNodeDeferred(node);
	      return undefinedWideningType;
	    }
	    function checkAwaitGrammar(node) {
	      let hasError = false;
	      const container = getContainingFunctionOrClassStaticBlock(node);
	      if (container && isClassStaticBlockDeclaration(container)) {
	        const message = isAwaitExpression(node) ? Diagnostics.await_expression_cannot_be_used_inside_a_class_static_block : Diagnostics.await_using_statements_cannot_be_used_inside_a_class_static_block;
	        error2(node, message);
	        hasError = true;
	      } else if (!(node.flags & 65536 /* AwaitContext */)) {
	        if (isInTopLevelContext(node)) {
	          const sourceFile = getSourceFileOfNode(node);
	          if (!hasParseDiagnostics(sourceFile)) {
	            let span;
	            if (!isEffectiveExternalModule(sourceFile, compilerOptions)) {
	              span ?? (span = getSpanOfTokenAtPosition(sourceFile, node.pos));
	              const message = isAwaitExpression(node) ? Diagnostics.await_expressions_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_file_has_no_imports_or_exports_Consider_adding_an_empty_export_to_make_this_file_a_module : Diagnostics.await_using_statements_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_file_has_no_imports_or_exports_Consider_adding_an_empty_export_to_make_this_file_a_module;
	              const diagnostic = createFileDiagnostic(sourceFile, span.start, span.length, message);
	              diagnostics.add(diagnostic);
	              hasError = true;
	            }
	            switch (moduleKind) {
	              case 100 /* Node16 */:
	              case 199 /* NodeNext */:
	                if (sourceFile.impliedNodeFormat === 1 /* CommonJS */) {
	                  span ?? (span = getSpanOfTokenAtPosition(sourceFile, node.pos));
	                  diagnostics.add(
	                    createFileDiagnostic(sourceFile, span.start, span.length, Diagnostics.The_current_file_is_a_CommonJS_module_and_cannot_use_await_at_the_top_level)
	                  );
	                  hasError = true;
	                  break;
	                }
	              case 7 /* ES2022 */:
	              case 99 /* ESNext */:
	              case 200 /* Preserve */:
	              case 4 /* System */:
	                if (languageVersion >= 4 /* ES2017 */) {
	                  break;
	                }
	              default:
	                span ?? (span = getSpanOfTokenAtPosition(sourceFile, node.pos));
	                const message = isAwaitExpression(node) ? Diagnostics.Top_level_await_expressions_are_only_allowed_when_the_module_option_is_set_to_es2022_esnext_system_node16_nodenext_or_preserve_and_the_target_option_is_set_to_es2017_or_higher : Diagnostics.Top_level_await_using_statements_are_only_allowed_when_the_module_option_is_set_to_es2022_esnext_system_node16_nodenext_or_preserve_and_the_target_option_is_set_to_es2017_or_higher;
	                diagnostics.add(createFileDiagnostic(sourceFile, span.start, span.length, message));
	                hasError = true;
	                break;
	            }
	          }
	        } else {
	          const sourceFile = getSourceFileOfNode(node);
	          if (!hasParseDiagnostics(sourceFile)) {
	            const span = getSpanOfTokenAtPosition(sourceFile, node.pos);
	            const message = isAwaitExpression(node) ? Diagnostics.await_expressions_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules : Diagnostics.await_using_statements_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules;
	            const diagnostic = createFileDiagnostic(sourceFile, span.start, span.length, message);
	            if (container && container.kind !== 176 /* Constructor */ && (getFunctionFlags(container) & 2 /* Async */) === 0) {
	              const relatedInfo = createDiagnosticForNode(container, Diagnostics.Did_you_mean_to_mark_this_function_as_async);
	              addRelatedInfo(diagnostic, relatedInfo);
	            }
	            diagnostics.add(diagnostic);
	            hasError = true;
	          }
	        }
	      }
	      if (isAwaitExpression(node) && isInParameterInitializerBeforeContainingFunction(node)) {
	        error2(node, Diagnostics.await_expressions_cannot_be_used_in_a_parameter_initializer);
	        hasError = true;
	      }
	      return hasError;
	    }
	    function checkAwaitExpression(node) {
	      addLazyDiagnostic(() => checkAwaitGrammar(node));
	      const operandType = checkExpression(node.expression);
	      const awaitedType = checkAwaitedType(
	        operandType,
	        /*withAlias*/
	        true,
	        node,
	        Diagnostics.Type_of_await_operand_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member
	      );
	      if (awaitedType === operandType && !isErrorType(awaitedType) && !(operandType.flags & 3 /* AnyOrUnknown */)) {
	        addErrorOrSuggestion(
	          /*isError*/
	          false,
	          createDiagnosticForNode(node, Diagnostics.await_has_no_effect_on_the_type_of_this_expression)
	        );
	      }
	      return awaitedType;
	    }
	    function checkPrefixUnaryExpression(node) {
	      const operandType = checkExpression(node.operand);
	      if (operandType === silentNeverType) {
	        return silentNeverType;
	      }
	      switch (node.operand.kind) {
	        case 9 /* NumericLiteral */:
	          switch (node.operator) {
	            case 41 /* MinusToken */:
	              return getFreshTypeOfLiteralType(getNumberLiteralType(-node.operand.text));
	            case 40 /* PlusToken */:
	              return getFreshTypeOfLiteralType(getNumberLiteralType(+node.operand.text));
	          }
	          break;
	        case 10 /* BigIntLiteral */:
	          if (node.operator === 41 /* MinusToken */) {
	            return getFreshTypeOfLiteralType(getBigIntLiteralType({
	              negative: true,
	              base10Value: parsePseudoBigInt(node.operand.text)
	            }));
	          }
	      }
	      switch (node.operator) {
	        case 40 /* PlusToken */:
	        case 41 /* MinusToken */:
	        case 55 /* TildeToken */:
	          checkNonNullType(operandType, node.operand);
	          if (maybeTypeOfKindConsideringBaseConstraint(operandType, 12288 /* ESSymbolLike */)) {
	            error2(node.operand, Diagnostics.The_0_operator_cannot_be_applied_to_type_symbol, tokenToString(node.operator));
	          }
	          if (node.operator === 40 /* PlusToken */) {
	            if (maybeTypeOfKindConsideringBaseConstraint(operandType, 2112 /* BigIntLike */)) {
	              error2(node.operand, Diagnostics.Operator_0_cannot_be_applied_to_type_1, tokenToString(node.operator), typeToString(getBaseTypeOfLiteralType(operandType)));
	            }
	            return numberType;
	          }
	          return getUnaryResultType(operandType);
	        case 54 /* ExclamationToken */:
	          checkTruthinessOfType(operandType, node.operand);
	          const facts = getTypeFacts(operandType, 4194304 /* Truthy */ | 8388608 /* Falsy */);
	          return facts === 4194304 /* Truthy */ ? falseType : facts === 8388608 /* Falsy */ ? trueType : booleanType;
	        case 46 /* PlusPlusToken */:
	        case 47 /* MinusMinusToken */:
	          const ok = checkArithmeticOperandType(node.operand, checkNonNullType(operandType, node.operand), Diagnostics.An_arithmetic_operand_must_be_of_type_any_number_bigint_or_an_enum_type);
	          if (ok) {
	            checkReferenceExpression(
	              node.operand,
	              Diagnostics.The_operand_of_an_increment_or_decrement_operator_must_be_a_variable_or_a_property_access,
	              Diagnostics.The_operand_of_an_increment_or_decrement_operator_may_not_be_an_optional_property_access
	            );
	          }
	          return getUnaryResultType(operandType);
	      }
	      return errorType;
	    }
	    function checkPostfixUnaryExpression(node) {
	      const operandType = checkExpression(node.operand);
	      if (operandType === silentNeverType) {
	        return silentNeverType;
	      }
	      const ok = checkArithmeticOperandType(
	        node.operand,
	        checkNonNullType(operandType, node.operand),
	        Diagnostics.An_arithmetic_operand_must_be_of_type_any_number_bigint_or_an_enum_type
	      );
	      if (ok) {
	        checkReferenceExpression(
	          node.operand,
	          Diagnostics.The_operand_of_an_increment_or_decrement_operator_must_be_a_variable_or_a_property_access,
	          Diagnostics.The_operand_of_an_increment_or_decrement_operator_may_not_be_an_optional_property_access
	        );
	      }
	      return getUnaryResultType(operandType);
	    }
	    function getUnaryResultType(operandType) {
	      if (maybeTypeOfKind(operandType, 2112 /* BigIntLike */)) {
	        return isTypeAssignableToKind(operandType, 3 /* AnyOrUnknown */) || maybeTypeOfKind(operandType, 296 /* NumberLike */) ? numberOrBigIntType : bigintType;
	      }
	      return numberType;
	    }
	    function maybeTypeOfKindConsideringBaseConstraint(type, kind) {
	      if (maybeTypeOfKind(type, kind)) {
	        return true;
	      }
	      const baseConstraint = getBaseConstraintOrType(type);
	      return !!baseConstraint && maybeTypeOfKind(baseConstraint, kind);
	    }
	    function maybeTypeOfKind(type, kind) {
	      if (type.flags & kind) {
	        return true;
	      }
	      if (type.flags & 3145728 /* UnionOrIntersection */) {
	        const types = type.types;
	        for (const t of types) {
	          if (maybeTypeOfKind(t, kind)) {
	            return true;
	          }
	        }
	      }
	      return false;
	    }
	    function isTypeAssignableToKind(source, kind, strict) {
	      if (source.flags & kind) {
	        return true;
	      }
	      if (strict && source.flags & (3 /* AnyOrUnknown */ | 16384 /* Void */ | 32768 /* Undefined */ | 65536 /* Null */)) {
	        return false;
	      }
	      return !!(kind & 296 /* NumberLike */) && isTypeAssignableTo(source, numberType) || !!(kind & 2112 /* BigIntLike */) && isTypeAssignableTo(source, bigintType) || !!(kind & 402653316 /* StringLike */) && isTypeAssignableTo(source, stringType) || !!(kind & 528 /* BooleanLike */) && isTypeAssignableTo(source, booleanType) || !!(kind & 16384 /* Void */) && isTypeAssignableTo(source, voidType) || !!(kind & 131072 /* Never */) && isTypeAssignableTo(source, neverType) || !!(kind & 65536 /* Null */) && isTypeAssignableTo(source, nullType) || !!(kind & 32768 /* Undefined */) && isTypeAssignableTo(source, undefinedType) || !!(kind & 4096 /* ESSymbol */) && isTypeAssignableTo(source, esSymbolType) || !!(kind & 67108864 /* NonPrimitive */) && isTypeAssignableTo(source, nonPrimitiveType);
	    }
	    function allTypesAssignableToKind(source, kind, strict) {
	      return source.flags & 1048576 /* Union */ ? every(source.types, (subType) => allTypesAssignableToKind(subType, kind, strict)) : isTypeAssignableToKind(source, kind, strict);
	    }
	    function isConstEnumObjectType(type) {
	      return !!(getObjectFlags(type) & 16 /* Anonymous */) && !!type.symbol && isConstEnumSymbol(type.symbol);
	    }
	    function isConstEnumSymbol(symbol) {
	      return (symbol.flags & 128 /* ConstEnum */) !== 0;
	    }
	    function getSymbolHasInstanceMethodOfObjectType(type) {
	      const hasInstancePropertyName = getPropertyNameForKnownSymbolName("hasInstance");
	      const hasInstanceProperty = getPropertyOfObjectType(type, hasInstancePropertyName);
	      if (hasInstanceProperty) {
	        const hasInstancePropertyType = getTypeOfSymbol(hasInstanceProperty);
	        if (hasInstancePropertyType && getSignaturesOfType(hasInstancePropertyType, 0 /* Call */).length !== 0) {
	          return hasInstancePropertyType;
	        }
	      }
	    }
	    function checkInstanceOfExpression(left, right, leftType, rightType, checkMode) {
	      if (leftType === silentNeverType || rightType === silentNeverType) {
	        return silentNeverType;
	      }
	      if (!isTypeAny(leftType) && allTypesAssignableToKind(leftType, 402784252 /* Primitive */)) {
	        error2(left, Diagnostics.The_left_hand_side_of_an_instanceof_expression_must_be_of_type_any_an_object_type_or_a_type_parameter);
	      }
	      Debug.assert(isInstanceOfExpression(left.parent));
	      const signature = getResolvedSignature(
	        left.parent,
	        /*candidatesOutArray*/
	        void 0,
	        checkMode
	      );
	      if (signature === resolvingSignature) {
	        return silentNeverType;
	      }
	      const returnType = getReturnTypeOfSignature(signature);
	      checkTypeAssignableTo(returnType, booleanType, right, Diagnostics.An_object_s_Symbol_hasInstance_method_must_return_a_boolean_value_for_it_to_be_used_on_the_right_hand_side_of_an_instanceof_expression);
	      return booleanType;
	    }
	    function hasEmptyObjectIntersection(type) {
	      return someType(type, (t) => t === unknownEmptyObjectType || !!(t.flags & 2097152 /* Intersection */) && isEmptyAnonymousObjectType(getBaseConstraintOrType(t)));
	    }
	    function checkInExpression(left, right, leftType, rightType) {
	      if (leftType === silentNeverType || rightType === silentNeverType) {
	        return silentNeverType;
	      }
	      if (isPrivateIdentifier(left)) {
	        if (languageVersion < 99 /* ESNext */) {
	          checkExternalEmitHelpers(left, 2097152 /* ClassPrivateFieldIn */);
	        }
	        if (!getNodeLinks(left).resolvedSymbol && getContainingClass(left)) {
	          const isUncheckedJS = isUncheckedJSSuggestion(
	            left,
	            rightType.symbol,
	            /*excludeClasses*/
	            true
	          );
	          reportNonexistentProperty(left, rightType, isUncheckedJS);
	        }
	      } else {
	        checkTypeAssignableTo(checkNonNullType(leftType, left), stringNumberSymbolType, left);
	      }
	      if (checkTypeAssignableTo(checkNonNullType(rightType, right), nonPrimitiveType, right)) {
	        if (hasEmptyObjectIntersection(rightType)) {
	          error2(right, Diagnostics.Type_0_may_represent_a_primitive_value_which_is_not_permitted_as_the_right_operand_of_the_in_operator, typeToString(rightType));
	        }
	      }
	      return booleanType;
	    }
	    function checkObjectLiteralAssignment(node, sourceType, rightIsThis) {
	      const properties = node.properties;
	      if (strictNullChecks && properties.length === 0) {
	        return checkNonNullType(sourceType, node);
	      }
	      for (let i = 0; i < properties.length; i++) {
	        checkObjectLiteralDestructuringPropertyAssignment(node, sourceType, i, properties, rightIsThis);
	      }
	      return sourceType;
	    }
	    function checkObjectLiteralDestructuringPropertyAssignment(node, objectLiteralType, propertyIndex, allProperties, rightIsThis = false) {
	      const properties = node.properties;
	      const property = properties[propertyIndex];
	      if (property.kind === 303 /* PropertyAssignment */ || property.kind === 304 /* ShorthandPropertyAssignment */) {
	        const name = property.name;
	        const exprType = getLiteralTypeFromPropertyName(name);
	        if (isTypeUsableAsPropertyName(exprType)) {
	          const text = getPropertyNameFromType(exprType);
	          const prop = getPropertyOfType(objectLiteralType, text);
	          if (prop) {
	            markPropertyAsReferenced(prop, property, rightIsThis);
	            checkPropertyAccessibility(
	              property,
	              /*isSuper*/
	              false,
	              /*writing*/
	              true,
	              objectLiteralType,
	              prop
	            );
	          }
	        }
	        const elementType = getIndexedAccessType(objectLiteralType, exprType, 32 /* ExpressionPosition */, name);
	        const type = getFlowTypeOfDestructuring(property, elementType);
	        return checkDestructuringAssignment(property.kind === 304 /* ShorthandPropertyAssignment */ ? property : property.initializer, type);
	      } else if (property.kind === 305 /* SpreadAssignment */) {
	        if (propertyIndex < properties.length - 1) {
	          error2(property, Diagnostics.A_rest_element_must_be_last_in_a_destructuring_pattern);
	        } else {
	          if (languageVersion < 99 /* ESNext */) {
	            checkExternalEmitHelpers(property, 4 /* Rest */);
	          }
	          const nonRestNames = [];
	          if (allProperties) {
	            for (const otherProperty of allProperties) {
	              if (!isSpreadAssignment(otherProperty)) {
	                nonRestNames.push(otherProperty.name);
	              }
	            }
	          }
	          const type = getRestType(objectLiteralType, nonRestNames, objectLiteralType.symbol);
	          checkGrammarForDisallowedTrailingComma(allProperties, Diagnostics.A_rest_parameter_or_binding_pattern_may_not_have_a_trailing_comma);
	          return checkDestructuringAssignment(property.expression, type);
	        }
	      } else {
	        error2(property, Diagnostics.Property_assignment_expected);
	      }
	    }
	    function checkArrayLiteralAssignment(node, sourceType, checkMode) {
	      const elements = node.elements;
	      if (languageVersion < 2 /* ES2015 */ && compilerOptions.downlevelIteration) {
	        checkExternalEmitHelpers(node, 512 /* Read */);
	      }
	      const possiblyOutOfBoundsType = checkIteratedTypeOrElementType(65 /* Destructuring */ | 128 /* PossiblyOutOfBounds */, sourceType, undefinedType, node) || errorType;
	      let inBoundsType = compilerOptions.noUncheckedIndexedAccess ? void 0 : possiblyOutOfBoundsType;
	      for (let i = 0; i < elements.length; i++) {
	        let type = possiblyOutOfBoundsType;
	        if (node.elements[i].kind === 230 /* SpreadElement */) {
	          type = inBoundsType = inBoundsType ?? (checkIteratedTypeOrElementType(65 /* Destructuring */, sourceType, undefinedType, node) || errorType);
	        }
	        checkArrayLiteralDestructuringElementAssignment(node, sourceType, i, type, checkMode);
	      }
	      return sourceType;
	    }
	    function checkArrayLiteralDestructuringElementAssignment(node, sourceType, elementIndex, elementType, checkMode) {
	      const elements = node.elements;
	      const element = elements[elementIndex];
	      if (element.kind !== 232 /* OmittedExpression */) {
	        if (element.kind !== 230 /* SpreadElement */) {
	          const indexType = getNumberLiteralType(elementIndex);
	          if (isArrayLikeType(sourceType)) {
	            const accessFlags = 32 /* ExpressionPosition */ | (hasDefaultValue(element) ? 16 /* NoTupleBoundsCheck */ : 0);
	            const elementType2 = getIndexedAccessTypeOrUndefined(sourceType, indexType, accessFlags, createSyntheticExpression(element, indexType)) || errorType;
	            const assignedType = hasDefaultValue(element) ? getTypeWithFacts(elementType2, 524288 /* NEUndefined */) : elementType2;
	            const type = getFlowTypeOfDestructuring(element, assignedType);
	            return checkDestructuringAssignment(element, type, checkMode);
	          }
	          return checkDestructuringAssignment(element, elementType, checkMode);
	        }
	        if (elementIndex < elements.length - 1) {
	          error2(element, Diagnostics.A_rest_element_must_be_last_in_a_destructuring_pattern);
	        } else {
	          const restExpression = element.expression;
	          if (restExpression.kind === 226 /* BinaryExpression */ && restExpression.operatorToken.kind === 64 /* EqualsToken */) {
	            error2(restExpression.operatorToken, Diagnostics.A_rest_element_cannot_have_an_initializer);
	          } else {
	            checkGrammarForDisallowedTrailingComma(node.elements, Diagnostics.A_rest_parameter_or_binding_pattern_may_not_have_a_trailing_comma);
	            const type = everyType(sourceType, isTupleType) ? mapType(sourceType, (t) => sliceTupleType(t, elementIndex)) : createArrayType(elementType);
	            return checkDestructuringAssignment(restExpression, type, checkMode);
	          }
	        }
	      }
	      return void 0;
	    }
	    function checkDestructuringAssignment(exprOrAssignment, sourceType, checkMode, rightIsThis) {
	      let target;
	      if (exprOrAssignment.kind === 304 /* ShorthandPropertyAssignment */) {
	        const prop = exprOrAssignment;
	        if (prop.objectAssignmentInitializer) {
	          if (strictNullChecks && !hasTypeFacts(checkExpression(prop.objectAssignmentInitializer), 16777216 /* IsUndefined */)) {
	            sourceType = getTypeWithFacts(sourceType, 524288 /* NEUndefined */);
	          }
	          checkBinaryLikeExpression(prop.name, prop.equalsToken, prop.objectAssignmentInitializer, checkMode);
	        }
	        target = exprOrAssignment.name;
	      } else {
	        target = exprOrAssignment;
	      }
	      if (target.kind === 226 /* BinaryExpression */ && target.operatorToken.kind === 64 /* EqualsToken */) {
	        checkBinaryExpression(target, checkMode);
	        target = target.left;
	        if (strictNullChecks) {
	          sourceType = getTypeWithFacts(sourceType, 524288 /* NEUndefined */);
	        }
	      }
	      if (target.kind === 210 /* ObjectLiteralExpression */) {
	        return checkObjectLiteralAssignment(target, sourceType, rightIsThis);
	      }
	      if (target.kind === 209 /* ArrayLiteralExpression */) {
	        return checkArrayLiteralAssignment(target, sourceType, checkMode);
	      }
	      return checkReferenceAssignment(target, sourceType, checkMode);
	    }
	    function checkReferenceAssignment(target, sourceType, checkMode) {
	      const targetType = checkExpression(target, checkMode);
	      const error3 = target.parent.kind === 305 /* SpreadAssignment */ ? Diagnostics.The_target_of_an_object_rest_assignment_must_be_a_variable_or_a_property_access : Diagnostics.The_left_hand_side_of_an_assignment_expression_must_be_a_variable_or_a_property_access;
	      const optionalError = target.parent.kind === 305 /* SpreadAssignment */ ? Diagnostics.The_target_of_an_object_rest_assignment_may_not_be_an_optional_property_access : Diagnostics.The_left_hand_side_of_an_assignment_expression_may_not_be_an_optional_property_access;
	      if (checkReferenceExpression(target, error3, optionalError)) {
	        checkTypeAssignableToAndOptionallyElaborate(sourceType, targetType, target, target);
	      }
	      if (isPrivateIdentifierPropertyAccessExpression(target)) {
	        checkExternalEmitHelpers(target.parent, 1048576 /* ClassPrivateFieldSet */);
	      }
	      return sourceType;
	    }
	    function isSideEffectFree(node) {
	      node = skipParentheses(node);
	      switch (node.kind) {
	        case 80 /* Identifier */:
	        case 11 /* StringLiteral */:
	        case 14 /* RegularExpressionLiteral */:
	        case 215 /* TaggedTemplateExpression */:
	        case 228 /* TemplateExpression */:
	        case 15 /* NoSubstitutionTemplateLiteral */:
	        case 9 /* NumericLiteral */:
	        case 10 /* BigIntLiteral */:
	        case 112 /* TrueKeyword */:
	        case 97 /* FalseKeyword */:
	        case 106 /* NullKeyword */:
	        case 157 /* UndefinedKeyword */:
	        case 218 /* FunctionExpression */:
	        case 231 /* ClassExpression */:
	        case 219 /* ArrowFunction */:
	        case 209 /* ArrayLiteralExpression */:
	        case 210 /* ObjectLiteralExpression */:
	        case 221 /* TypeOfExpression */:
	        case 235 /* NonNullExpression */:
	        case 285 /* JsxSelfClosingElement */:
	        case 284 /* JsxElement */:
	          return true;
	        case 227 /* ConditionalExpression */:
	          return isSideEffectFree(node.whenTrue) && isSideEffectFree(node.whenFalse);
	        case 226 /* BinaryExpression */:
	          if (isAssignmentOperator(node.operatorToken.kind)) {
	            return false;
	          }
	          return isSideEffectFree(node.left) && isSideEffectFree(node.right);
	        case 224 /* PrefixUnaryExpression */:
	        case 225 /* PostfixUnaryExpression */:
	          switch (node.operator) {
	            case 54 /* ExclamationToken */:
	            case 40 /* PlusToken */:
	            case 41 /* MinusToken */:
	            case 55 /* TildeToken */:
	              return true;
	          }
	          return false;
	        case 222 /* VoidExpression */:
	        case 216 /* TypeAssertionExpression */:
	        case 234 /* AsExpression */:
	        default:
	          return false;
	      }
	    }
	    function isTypeEqualityComparableTo(source, target) {
	      return (target.flags & 98304 /* Nullable */) !== 0 || isTypeComparableTo(source, target);
	    }
	    function createCheckBinaryExpression() {
	      const trampoline = createBinaryExpressionTrampoline(onEnter, onLeft, onOperator, onRight, onExit, foldState);
	      return (node, checkMode) => {
	        const result = trampoline(node, checkMode);
	        Debug.assertIsDefined(result);
	        return result;
	      };
	      function onEnter(node, state, checkMode) {
	        if (state) {
	          state.stackIndex++;
	          state.skip = false;
	          setLeftType(
	            state,
	            /*type*/
	            void 0
	          );
	          setLastResult(
	            state,
	            /*type*/
	            void 0
	          );
	        } else {
	          state = {
	            checkMode,
	            skip: false,
	            stackIndex: 0,
	            typeStack: [void 0, void 0]
	          };
	        }
	        if (isInJSFile(node) && getAssignedExpandoInitializer(node)) {
	          state.skip = true;
	          setLastResult(state, checkExpression(node.right, checkMode));
	          return state;
	        }
	        checkGrammarNullishCoalesceWithLogicalExpression(node);
	        const operator = node.operatorToken.kind;
	        if (operator === 64 /* EqualsToken */ && (node.left.kind === 210 /* ObjectLiteralExpression */ || node.left.kind === 209 /* ArrayLiteralExpression */)) {
	          state.skip = true;
	          setLastResult(state, checkDestructuringAssignment(node.left, checkExpression(node.right, checkMode), checkMode, node.right.kind === 110 /* ThisKeyword */));
	          return state;
	        }
	        return state;
	      }
	      function onLeft(left, state, _node) {
	        if (!state.skip) {
	          return maybeCheckExpression(state, left);
	        }
	      }
	      function onOperator(operatorToken, state, node) {
	        if (!state.skip) {
	          const leftType = getLastResult(state);
	          Debug.assertIsDefined(leftType);
	          setLeftType(state, leftType);
	          setLastResult(
	            state,
	            /*type*/
	            void 0
	          );
	          const operator = operatorToken.kind;
	          if (isLogicalOrCoalescingBinaryOperator(operator)) {
	            let parent2 = node.parent;
	            while (parent2.kind === 217 /* ParenthesizedExpression */ || isLogicalOrCoalescingBinaryExpression(parent2)) {
	              parent2 = parent2.parent;
	            }
	            if (operator === 56 /* AmpersandAmpersandToken */ || isIfStatement(parent2)) {
	              checkTestingKnownTruthyCallableOrAwaitableType(node.left, leftType, isIfStatement(parent2) ? parent2.thenStatement : void 0);
	            }
	            checkTruthinessOfType(leftType, node.left);
	          }
	        }
	      }
	      function onRight(right, state, _node) {
	        if (!state.skip) {
	          return maybeCheckExpression(state, right);
	        }
	      }
	      function onExit(node, state) {
	        let result;
	        if (state.skip) {
	          result = getLastResult(state);
	        } else {
	          const leftType = getLeftType(state);
	          Debug.assertIsDefined(leftType);
	          const rightType = getLastResult(state);
	          Debug.assertIsDefined(rightType);
	          result = checkBinaryLikeExpressionWorker(node.left, node.operatorToken, node.right, leftType, rightType, state.checkMode, node);
	        }
	        state.skip = false;
	        setLeftType(
	          state,
	          /*type*/
	          void 0
	        );
	        setLastResult(
	          state,
	          /*type*/
	          void 0
	        );
	        state.stackIndex--;
	        return result;
	      }
	      function foldState(state, result, _side) {
	        setLastResult(state, result);
	        return state;
	      }
	      function maybeCheckExpression(state, node) {
	        if (isBinaryExpression(node)) {
	          return node;
	        }
	        setLastResult(state, checkExpression(node, state.checkMode));
	      }
	      function getLeftType(state) {
	        return state.typeStack[state.stackIndex];
	      }
	      function setLeftType(state, type) {
	        state.typeStack[state.stackIndex] = type;
	      }
	      function getLastResult(state) {
	        return state.typeStack[state.stackIndex + 1];
	      }
	      function setLastResult(state, type) {
	        state.typeStack[state.stackIndex + 1] = type;
	      }
	    }
	    function checkGrammarNullishCoalesceWithLogicalExpression(node) {
	      const { left, operatorToken, right } = node;
	      if (operatorToken.kind === 61 /* QuestionQuestionToken */) {
	        if (isBinaryExpression(left) && (left.operatorToken.kind === 57 /* BarBarToken */ || left.operatorToken.kind === 56 /* AmpersandAmpersandToken */)) {
	          grammarErrorOnNode(left, Diagnostics._0_and_1_operations_cannot_be_mixed_without_parentheses, tokenToString(left.operatorToken.kind), tokenToString(operatorToken.kind));
	        }
	        if (isBinaryExpression(right) && (right.operatorToken.kind === 57 /* BarBarToken */ || right.operatorToken.kind === 56 /* AmpersandAmpersandToken */)) {
	          grammarErrorOnNode(right, Diagnostics._0_and_1_operations_cannot_be_mixed_without_parentheses, tokenToString(right.operatorToken.kind), tokenToString(operatorToken.kind));
	        }
	      }
	    }
	    function checkBinaryLikeExpression(left, operatorToken, right, checkMode, errorNode) {
	      const operator = operatorToken.kind;
	      if (operator === 64 /* EqualsToken */ && (left.kind === 210 /* ObjectLiteralExpression */ || left.kind === 209 /* ArrayLiteralExpression */)) {
	        return checkDestructuringAssignment(left, checkExpression(right, checkMode), checkMode, right.kind === 110 /* ThisKeyword */);
	      }
	      let leftType;
	      if (isLogicalOrCoalescingBinaryOperator(operator)) {
	        leftType = checkTruthinessExpression(left, checkMode);
	      } else {
	        leftType = checkExpression(left, checkMode);
	      }
	      const rightType = checkExpression(right, checkMode);
	      return checkBinaryLikeExpressionWorker(left, operatorToken, right, leftType, rightType, checkMode, errorNode);
	    }
	    function checkBinaryLikeExpressionWorker(left, operatorToken, right, leftType, rightType, checkMode, errorNode) {
	      const operator = operatorToken.kind;
	      switch (operator) {
	        case 42 /* AsteriskToken */:
	        case 43 /* AsteriskAsteriskToken */:
	        case 67 /* AsteriskEqualsToken */:
	        case 68 /* AsteriskAsteriskEqualsToken */:
	        case 44 /* SlashToken */:
	        case 69 /* SlashEqualsToken */:
	        case 45 /* PercentToken */:
	        case 70 /* PercentEqualsToken */:
	        case 41 /* MinusToken */:
	        case 66 /* MinusEqualsToken */:
	        case 48 /* LessThanLessThanToken */:
	        case 71 /* LessThanLessThanEqualsToken */:
	        case 49 /* GreaterThanGreaterThanToken */:
	        case 72 /* GreaterThanGreaterThanEqualsToken */:
	        case 50 /* GreaterThanGreaterThanGreaterThanToken */:
	        case 73 /* GreaterThanGreaterThanGreaterThanEqualsToken */:
	        case 52 /* BarToken */:
	        case 75 /* BarEqualsToken */:
	        case 53 /* CaretToken */:
	        case 79 /* CaretEqualsToken */:
	        case 51 /* AmpersandToken */:
	        case 74 /* AmpersandEqualsToken */:
	          if (leftType === silentNeverType || rightType === silentNeverType) {
	            return silentNeverType;
	          }
	          leftType = checkNonNullType(leftType, left);
	          rightType = checkNonNullType(rightType, right);
	          let suggestedOperator;
	          if (leftType.flags & 528 /* BooleanLike */ && rightType.flags & 528 /* BooleanLike */ && (suggestedOperator = getSuggestedBooleanOperator(operatorToken.kind)) !== void 0) {
	            error2(errorNode || operatorToken, Diagnostics.The_0_operator_is_not_allowed_for_boolean_types_Consider_using_1_instead, tokenToString(operatorToken.kind), tokenToString(suggestedOperator));
	            return numberType;
	          } else {
	            const leftOk = checkArithmeticOperandType(
	              left,
	              leftType,
	              Diagnostics.The_left_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type,
	              /*isAwaitValid*/
	              true
	            );
	            const rightOk = checkArithmeticOperandType(
	              right,
	              rightType,
	              Diagnostics.The_right_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type,
	              /*isAwaitValid*/
	              true
	            );
	            let resultType2;
	            if (isTypeAssignableToKind(leftType, 3 /* AnyOrUnknown */) && isTypeAssignableToKind(rightType, 3 /* AnyOrUnknown */) || // Or, if neither could be bigint, implicit coercion results in a number result
	            !(maybeTypeOfKind(leftType, 2112 /* BigIntLike */) || maybeTypeOfKind(rightType, 2112 /* BigIntLike */))) {
	              resultType2 = numberType;
	            } else if (bothAreBigIntLike(leftType, rightType)) {
	              switch (operator) {
	                case 50 /* GreaterThanGreaterThanGreaterThanToken */:
	                case 73 /* GreaterThanGreaterThanGreaterThanEqualsToken */:
	                  reportOperatorError();
	                  break;
	                case 43 /* AsteriskAsteriskToken */:
	                case 68 /* AsteriskAsteriskEqualsToken */:
	                  if (languageVersion < 3 /* ES2016 */) {
	                    error2(errorNode, Diagnostics.Exponentiation_cannot_be_performed_on_bigint_values_unless_the_target_option_is_set_to_es2016_or_later);
	                  }
	              }
	              resultType2 = bigintType;
	            } else {
	              reportOperatorError(bothAreBigIntLike);
	              resultType2 = errorType;
	            }
	            if (leftOk && rightOk) {
	              checkAssignmentOperator(resultType2);
	            }
	            return resultType2;
	          }
	        case 40 /* PlusToken */:
	        case 65 /* PlusEqualsToken */:
	          if (leftType === silentNeverType || rightType === silentNeverType) {
	            return silentNeverType;
	          }
	          if (!isTypeAssignableToKind(leftType, 402653316 /* StringLike */) && !isTypeAssignableToKind(rightType, 402653316 /* StringLike */)) {
	            leftType = checkNonNullType(leftType, left);
	            rightType = checkNonNullType(rightType, right);
	          }
	          let resultType;
	          if (isTypeAssignableToKind(
	            leftType,
	            296 /* NumberLike */,
	            /*strict*/
	            true
	          ) && isTypeAssignableToKind(
	            rightType,
	            296 /* NumberLike */,
	            /*strict*/
	            true
	          )) {
	            resultType = numberType;
	          } else if (isTypeAssignableToKind(
	            leftType,
	            2112 /* BigIntLike */,
	            /*strict*/
	            true
	          ) && isTypeAssignableToKind(
	            rightType,
	            2112 /* BigIntLike */,
	            /*strict*/
	            true
	          )) {
	            resultType = bigintType;
	          } else if (isTypeAssignableToKind(
	            leftType,
	            402653316 /* StringLike */,
	            /*strict*/
	            true
	          ) || isTypeAssignableToKind(
	            rightType,
	            402653316 /* StringLike */,
	            /*strict*/
	            true
	          )) {
	            resultType = stringType;
	          } else if (isTypeAny(leftType) || isTypeAny(rightType)) {
	            resultType = isErrorType(leftType) || isErrorType(rightType) ? errorType : anyType;
	          }
	          if (resultType && !checkForDisallowedESSymbolOperand(operator)) {
	            return resultType;
	          }
	          if (!resultType) {
	            const closeEnoughKind = 296 /* NumberLike */ | 2112 /* BigIntLike */ | 402653316 /* StringLike */ | 3 /* AnyOrUnknown */;
	            reportOperatorError(
	              (left2, right2) => isTypeAssignableToKind(left2, closeEnoughKind) && isTypeAssignableToKind(right2, closeEnoughKind)
	            );
	            return anyType;
	          }
	          if (operator === 65 /* PlusEqualsToken */) {
	            checkAssignmentOperator(resultType);
	          }
	          return resultType;
	        case 30 /* LessThanToken */:
	        case 32 /* GreaterThanToken */:
	        case 33 /* LessThanEqualsToken */:
	        case 34 /* GreaterThanEqualsToken */:
	          if (checkForDisallowedESSymbolOperand(operator)) {
	            leftType = getBaseTypeOfLiteralTypeForComparison(checkNonNullType(leftType, left));
	            rightType = getBaseTypeOfLiteralTypeForComparison(checkNonNullType(rightType, right));
	            reportOperatorErrorUnless((left2, right2) => {
	              if (isTypeAny(left2) || isTypeAny(right2)) {
	                return true;
	              }
	              const leftAssignableToNumber = isTypeAssignableTo(left2, numberOrBigIntType);
	              const rightAssignableToNumber = isTypeAssignableTo(right2, numberOrBigIntType);
	              return leftAssignableToNumber && rightAssignableToNumber || !leftAssignableToNumber && !rightAssignableToNumber && areTypesComparable(left2, right2);
	            });
	          }
	          return booleanType;
	        case 35 /* EqualsEqualsToken */:
	        case 36 /* ExclamationEqualsToken */:
	        case 37 /* EqualsEqualsEqualsToken */:
	        case 38 /* ExclamationEqualsEqualsToken */:
	          if (!(checkMode && checkMode & 64 /* TypeOnly */)) {
	            if ((isLiteralExpressionOfObject(left) || isLiteralExpressionOfObject(right)) && // only report for === and !== in JS, not == or !=
	            (!isInJSFile(left) || (operator === 37 /* EqualsEqualsEqualsToken */ || operator === 38 /* ExclamationEqualsEqualsToken */))) {
	              const eqType = operator === 35 /* EqualsEqualsToken */ || operator === 37 /* EqualsEqualsEqualsToken */;
	              error2(errorNode, Diagnostics.This_condition_will_always_return_0_since_JavaScript_compares_objects_by_reference_not_value, eqType ? "false" : "true");
	            }
	            checkNaNEquality(errorNode, operator, left, right);
	            reportOperatorErrorUnless((left2, right2) => isTypeEqualityComparableTo(left2, right2) || isTypeEqualityComparableTo(right2, left2));
	          }
	          return booleanType;
	        case 104 /* InstanceOfKeyword */:
	          return checkInstanceOfExpression(left, right, leftType, rightType, checkMode);
	        case 103 /* InKeyword */:
	          return checkInExpression(left, right, leftType, rightType);
	        case 56 /* AmpersandAmpersandToken */:
	        case 77 /* AmpersandAmpersandEqualsToken */: {
	          const resultType2 = hasTypeFacts(leftType, 4194304 /* Truthy */) ? getUnionType([extractDefinitelyFalsyTypes(strictNullChecks ? leftType : getBaseTypeOfLiteralType(rightType)), rightType]) : leftType;
	          if (operator === 77 /* AmpersandAmpersandEqualsToken */) {
	            checkAssignmentOperator(rightType);
	          }
	          return resultType2;
	        }
	        case 57 /* BarBarToken */:
	        case 76 /* BarBarEqualsToken */: {
	          const resultType2 = hasTypeFacts(leftType, 8388608 /* Falsy */) ? getUnionType([getNonNullableType(removeDefinitelyFalsyTypes(leftType)), rightType], 2 /* Subtype */) : leftType;
	          if (operator === 76 /* BarBarEqualsToken */) {
	            checkAssignmentOperator(rightType);
	          }
	          return resultType2;
	        }
	        case 61 /* QuestionQuestionToken */:
	        case 78 /* QuestionQuestionEqualsToken */: {
	          const resultType2 = hasTypeFacts(leftType, 262144 /* EQUndefinedOrNull */) ? getUnionType([getNonNullableType(leftType), rightType], 2 /* Subtype */) : leftType;
	          if (operator === 78 /* QuestionQuestionEqualsToken */) {
	            checkAssignmentOperator(rightType);
	          }
	          return resultType2;
	        }
	        case 64 /* EqualsToken */:
	          const declKind = isBinaryExpression(left.parent) ? getAssignmentDeclarationKind(left.parent) : 0 /* None */;
	          checkAssignmentDeclaration(declKind, rightType);
	          if (isAssignmentDeclaration2(declKind)) {
	            if (!(rightType.flags & 524288 /* Object */) || declKind !== 2 /* ModuleExports */ && declKind !== 6 /* Prototype */ && !isEmptyObjectType(rightType) && !isFunctionObjectType(rightType) && !(getObjectFlags(rightType) & 1 /* Class */)) {
	              checkAssignmentOperator(rightType);
	            }
	            return leftType;
	          } else {
	            checkAssignmentOperator(rightType);
	            return rightType;
	          }
	        case 28 /* CommaToken */:
	          if (!compilerOptions.allowUnreachableCode && isSideEffectFree(left) && !isIndirectCall(left.parent)) {
	            const sf = getSourceFileOfNode(left);
	            const sourceText = sf.text;
	            const start = skipTrivia(sourceText, left.pos);
	            const isInDiag2657 = sf.parseDiagnostics.some((diag2) => {
	              if (diag2.code !== Diagnostics.JSX_expressions_must_have_one_parent_element.code)
	                return false;
	              return textSpanContainsPosition(diag2, start);
	            });
	            if (!isInDiag2657)
	              error2(left, Diagnostics.Left_side_of_comma_operator_is_unused_and_has_no_side_effects);
	          }
	          return rightType;
	        default:
	          return Debug.fail();
	      }
	      function bothAreBigIntLike(left2, right2) {
	        return isTypeAssignableToKind(left2, 2112 /* BigIntLike */) && isTypeAssignableToKind(right2, 2112 /* BigIntLike */);
	      }
	      function checkAssignmentDeclaration(kind, rightType2) {
	        if (kind === 2 /* ModuleExports */) {
	          for (const prop of getPropertiesOfObjectType(rightType2)) {
	            const propType = getTypeOfSymbol(prop);
	            if (propType.symbol && propType.symbol.flags & 32 /* Class */) {
	              const name = prop.escapedName;
	              const symbol = resolveName(
	                prop.valueDeclaration,
	                name,
	                788968 /* Type */,
	                /*nameNotFoundMessage*/
	                void 0,
	                name,
	                /*isUse*/
	                false
	              );
	              if ((symbol == null ? void 0 : symbol.declarations) && symbol.declarations.some(isJSDocTypedefTag)) {
	                addDuplicateDeclarationErrorsForSymbols(symbol, Diagnostics.Duplicate_identifier_0, unescapeLeadingUnderscores(name), prop);
	                addDuplicateDeclarationErrorsForSymbols(prop, Diagnostics.Duplicate_identifier_0, unescapeLeadingUnderscores(name), symbol);
	              }
	            }
	          }
	        }
	      }
	      function isIndirectCall(node) {
	        return node.parent.kind === 217 /* ParenthesizedExpression */ && isNumericLiteral(node.left) && node.left.text === "0" && (isCallExpression(node.parent.parent) && node.parent.parent.expression === node.parent || node.parent.parent.kind === 215 /* TaggedTemplateExpression */) && // special-case for "eval" because it's the only non-access case where an indirect call actually affects behavior.
	        (isAccessExpression(node.right) || isIdentifier(node.right) && node.right.escapedText === "eval");
	      }
	      function checkForDisallowedESSymbolOperand(operator2) {
	        const offendingSymbolOperand = maybeTypeOfKindConsideringBaseConstraint(leftType, 12288 /* ESSymbolLike */) ? left : maybeTypeOfKindConsideringBaseConstraint(rightType, 12288 /* ESSymbolLike */) ? right : void 0;
	        if (offendingSymbolOperand) {
	          error2(offendingSymbolOperand, Diagnostics.The_0_operator_cannot_be_applied_to_type_symbol, tokenToString(operator2));
	          return false;
	        }
	        return true;
	      }
	      function getSuggestedBooleanOperator(operator2) {
	        switch (operator2) {
	          case 52 /* BarToken */:
	          case 75 /* BarEqualsToken */:
	            return 57 /* BarBarToken */;
	          case 53 /* CaretToken */:
	          case 79 /* CaretEqualsToken */:
	            return 38 /* ExclamationEqualsEqualsToken */;
	          case 51 /* AmpersandToken */:
	          case 74 /* AmpersandEqualsToken */:
	            return 56 /* AmpersandAmpersandToken */;
	          default:
	            return void 0;
	        }
	      }
	      function checkAssignmentOperator(valueType) {
	        if (isAssignmentOperator(operator)) {
	          addLazyDiagnostic(checkAssignmentOperatorWorker);
	        }
	        function checkAssignmentOperatorWorker() {
	          let assigneeType = leftType;
	          if (isCompoundAssignment(operatorToken.kind) && left.kind === 211 /* PropertyAccessExpression */) {
	            assigneeType = checkPropertyAccessExpression(
	              left,
	              /*checkMode*/
	              void 0,
	              /*writeOnly*/
	              true
	            );
	          }
	          if (checkReferenceExpression(left, Diagnostics.The_left_hand_side_of_an_assignment_expression_must_be_a_variable_or_a_property_access, Diagnostics.The_left_hand_side_of_an_assignment_expression_may_not_be_an_optional_property_access)) {
	            let headMessage;
	            if (exactOptionalPropertyTypes && isPropertyAccessExpression(left) && maybeTypeOfKind(valueType, 32768 /* Undefined */)) {
	              const target = getTypeOfPropertyOfType(getTypeOfExpression(left.expression), left.name.escapedText);
	              if (isExactOptionalPropertyMismatch(valueType, target)) {
	                headMessage = Diagnostics.Type_0_is_not_assignable_to_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_type_of_the_target;
	              }
	            }
	            checkTypeAssignableToAndOptionallyElaborate(valueType, assigneeType, left, right, headMessage);
	          }
	        }
	      }
	      function isAssignmentDeclaration2(kind) {
	        var _a;
	        switch (kind) {
	          case 2 /* ModuleExports */:
	            return true;
	          case 1 /* ExportsProperty */:
	          case 5 /* Property */:
	          case 6 /* Prototype */:
	          case 3 /* PrototypeProperty */:
	          case 4 /* ThisProperty */:
	            const symbol = getSymbolOfNode(left);
	            const init = getAssignedExpandoInitializer(right);
	            return !!init && isObjectLiteralExpression(init) && !!((_a = symbol == null ? void 0 : symbol.exports) == null ? void 0 : _a.size);
	          default:
	            return false;
	        }
	      }
	      function reportOperatorErrorUnless(typesAreCompatible) {
	        if (!typesAreCompatible(leftType, rightType)) {
	          reportOperatorError(typesAreCompatible);
	          return true;
	        }
	        return false;
	      }
	      function reportOperatorError(isRelated) {
	        let wouldWorkWithAwait = false;
	        const errNode = errorNode || operatorToken;
	        if (isRelated) {
	          const awaitedLeftType = getAwaitedTypeNoAlias(leftType);
	          const awaitedRightType = getAwaitedTypeNoAlias(rightType);
	          wouldWorkWithAwait = !(awaitedLeftType === leftType && awaitedRightType === rightType) && !!(awaitedLeftType && awaitedRightType) && isRelated(awaitedLeftType, awaitedRightType);
	        }
	        let effectiveLeft = leftType;
	        let effectiveRight = rightType;
	        if (!wouldWorkWithAwait && isRelated) {
	          [effectiveLeft, effectiveRight] = getBaseTypesIfUnrelated(leftType, rightType, isRelated);
	        }
	        const [leftStr, rightStr] = getTypeNamesForErrorDisplay(effectiveLeft, effectiveRight);
	        if (!tryGiveBetterPrimaryError(errNode, wouldWorkWithAwait, leftStr, rightStr)) {
	          errorAndMaybeSuggestAwait(
	            errNode,
	            wouldWorkWithAwait,
	            Diagnostics.Operator_0_cannot_be_applied_to_types_1_and_2,
	            tokenToString(operatorToken.kind),
	            leftStr,
	            rightStr
	          );
	        }
	      }
	      function tryGiveBetterPrimaryError(errNode, maybeMissingAwait, leftStr, rightStr) {
	        switch (operatorToken.kind) {
	          case 37 /* EqualsEqualsEqualsToken */:
	          case 35 /* EqualsEqualsToken */:
	          case 38 /* ExclamationEqualsEqualsToken */:
	          case 36 /* ExclamationEqualsToken */:
	            return errorAndMaybeSuggestAwait(
	              errNode,
	              maybeMissingAwait,
	              Diagnostics.This_comparison_appears_to_be_unintentional_because_the_types_0_and_1_have_no_overlap,
	              leftStr,
	              rightStr
	            );
	          default:
	            return void 0;
	        }
	      }
	      function checkNaNEquality(errorNode2, operator2, left2, right2) {
	        const isLeftNaN = isGlobalNaN(skipParentheses(left2));
	        const isRightNaN = isGlobalNaN(skipParentheses(right2));
	        if (isLeftNaN || isRightNaN) {
	          const err = error2(errorNode2, Diagnostics.This_condition_will_always_return_0, tokenToString(operator2 === 37 /* EqualsEqualsEqualsToken */ || operator2 === 35 /* EqualsEqualsToken */ ? 97 /* FalseKeyword */ : 112 /* TrueKeyword */));
	          if (isLeftNaN && isRightNaN)
	            return;
	          const operatorString = operator2 === 38 /* ExclamationEqualsEqualsToken */ || operator2 === 36 /* ExclamationEqualsToken */ ? tokenToString(54 /* ExclamationToken */) : "";
	          const location = isLeftNaN ? right2 : left2;
	          const expression = skipParentheses(location);
	          addRelatedInfo(err, createDiagnosticForNode(location, Diagnostics.Did_you_mean_0, `${operatorString}Number.isNaN(${isEntityNameExpression(expression) ? entityNameToString(expression) : "..."})`));
	        }
	      }
	      function isGlobalNaN(expr) {
	        if (isIdentifier(expr) && expr.escapedText === "NaN") {
	          const globalNaNSymbol = getGlobalNaNSymbol();
	          return !!globalNaNSymbol && globalNaNSymbol === getResolvedSymbol(expr);
	        }
	        return false;
	      }
	    }
	    function getBaseTypesIfUnrelated(leftType, rightType, isRelated) {
	      let effectiveLeft = leftType;
	      let effectiveRight = rightType;
	      const leftBase = getBaseTypeOfLiteralType(leftType);
	      const rightBase = getBaseTypeOfLiteralType(rightType);
	      if (!isRelated(leftBase, rightBase)) {
	        effectiveLeft = leftBase;
	        effectiveRight = rightBase;
	      }
	      return [effectiveLeft, effectiveRight];
	    }
	    function checkYieldExpression(node) {
	      addLazyDiagnostic(checkYieldExpressionGrammar);
	      const func = getContainingFunction(node);
	      if (!func)
	        return anyType;
	      const functionFlags = getFunctionFlags(func);
	      if (!(functionFlags & 1 /* Generator */)) {
	        return anyType;
	      }
	      const isAsync = (functionFlags & 2 /* Async */) !== 0;
	      if (node.asteriskToken) {
	        if (isAsync && languageVersion < 99 /* ESNext */) {
	          checkExternalEmitHelpers(node, 26624 /* AsyncDelegatorIncludes */);
	        }
	        if (!isAsync && languageVersion < 2 /* ES2015 */ && compilerOptions.downlevelIteration) {
	          checkExternalEmitHelpers(node, 256 /* Values */);
	        }
	      }
	      let returnType = getReturnTypeFromAnnotation(func);
	      if (returnType && returnType.flags & 1048576 /* Union */) {
	        returnType = filterType(returnType, (t) => checkGeneratorInstantiationAssignabilityToReturnType(
	          t,
	          functionFlags,
	          /*errorNode*/
	          void 0
	        ));
	      }
	      const iterationTypes = returnType && getIterationTypesOfGeneratorFunctionReturnType(returnType, isAsync);
	      const signatureYieldType = iterationTypes && iterationTypes.yieldType || anyType;
	      const signatureNextType = iterationTypes && iterationTypes.nextType || anyType;
	      const resolvedSignatureNextType = isAsync ? getAwaitedType(signatureNextType) || anyType : signatureNextType;
	      const yieldExpressionType = node.expression ? checkExpression(node.expression) : undefinedWideningType;
	      const yieldedType = getYieldedTypeOfYieldExpression(node, yieldExpressionType, resolvedSignatureNextType, isAsync);
	      if (returnType && yieldedType) {
	        checkTypeAssignableToAndOptionallyElaborate(yieldedType, signatureYieldType, node.expression || node, node.expression);
	      }
	      if (node.asteriskToken) {
	        const use = isAsync ? 19 /* AsyncYieldStar */ : 17 /* YieldStar */;
	        return getIterationTypeOfIterable(use, 1 /* Return */, yieldExpressionType, node.expression) || anyType;
	      } else if (returnType) {
	        return getIterationTypeOfGeneratorFunctionReturnType(2 /* Next */, returnType, isAsync) || anyType;
	      }
	      let type = getContextualIterationType(2 /* Next */, func);
	      if (!type) {
	        type = anyType;
	        addLazyDiagnostic(() => {
	          if (noImplicitAny && !expressionResultIsUnused(node)) {
	            const contextualType = getContextualType2(
	              node,
	              /*contextFlags*/
	              void 0
	            );
	            if (!contextualType || isTypeAny(contextualType)) {
	              error2(node, Diagnostics.yield_expression_implicitly_results_in_an_any_type_because_its_containing_generator_lacks_a_return_type_annotation);
	            }
	          }
	        });
	      }
	      return type;
	      function checkYieldExpressionGrammar() {
	        if (!(node.flags & 16384 /* YieldContext */)) {
	          grammarErrorOnFirstToken(node, Diagnostics.A_yield_expression_is_only_allowed_in_a_generator_body);
	        }
	        if (isInParameterInitializerBeforeContainingFunction(node)) {
	          error2(node, Diagnostics.yield_expressions_cannot_be_used_in_a_parameter_initializer);
	        }
	      }
	    }
	    function checkConditionalExpression(node, checkMode) {
	      const type = checkTruthinessExpression(node.condition, checkMode);
	      checkTestingKnownTruthyCallableOrAwaitableType(node.condition, type, node.whenTrue);
	      const type1 = checkExpression(node.whenTrue, checkMode);
	      const type2 = checkExpression(node.whenFalse, checkMode);
	      return getUnionType([type1, type2], 2 /* Subtype */);
	    }
	    function isTemplateLiteralContext(node) {
	      const parent2 = node.parent;
	      return isParenthesizedExpression(parent2) && isTemplateLiteralContext(parent2) || isElementAccessExpression(parent2) && parent2.argumentExpression === node;
	    }
	    function checkTemplateExpression(node) {
	      const texts = [node.head.text];
	      const types = [];
	      for (const span of node.templateSpans) {
	        const type = checkExpression(span.expression);
	        if (maybeTypeOfKindConsideringBaseConstraint(type, 12288 /* ESSymbolLike */)) {
	          error2(span.expression, Diagnostics.Implicit_conversion_of_a_symbol_to_a_string_will_fail_at_runtime_Consider_wrapping_this_expression_in_String);
	        }
	        texts.push(span.literal.text);
	        types.push(isTypeAssignableTo(type, templateConstraintType) ? type : stringType);
	      }
	      if (isConstContext(node) || isTemplateLiteralContext(node) || someType(getContextualType2(
	        node,
	        /*contextFlags*/
	        void 0
	      ) || unknownType, isTemplateLiteralContextualType)) {
	        return getTemplateLiteralType(texts, types);
	      }
	      const evaluated = node.parent.kind !== 215 /* TaggedTemplateExpression */ && evaluateTemplateExpression(node);
	      return evaluated ? getFreshTypeOfLiteralType(getStringLiteralType(evaluated)) : stringType;
	    }
	    function isTemplateLiteralContextualType(type) {
	      return !!(type.flags & (128 /* StringLiteral */ | 134217728 /* TemplateLiteral */) || type.flags & 58982400 /* InstantiableNonPrimitive */ && maybeTypeOfKind(getBaseConstraintOfType(type) || unknownType, 402653316 /* StringLike */));
	    }
	    function getContextNode2(node) {
	      if (isJsxAttributes(node) && !isJsxSelfClosingElement(node.parent)) {
	        return node.parent.parent;
	      }
	      return node;
	    }
	    function checkExpressionWithContextualType(node, contextualType, inferenceContext, checkMode) {
	      const contextNode = getContextNode2(node);
	      pushContextualType(
	        contextNode,
	        contextualType,
	        /*isCache*/
	        false
	      );
	      pushInferenceContext(contextNode, inferenceContext);
	      const type = checkExpression(node, checkMode | 1 /* Contextual */ | (inferenceContext ? 2 /* Inferential */ : 0));
	      if (inferenceContext && inferenceContext.intraExpressionInferenceSites) {
	        inferenceContext.intraExpressionInferenceSites = void 0;
	      }
	      const result = maybeTypeOfKind(type, 2944 /* Literal */) && isLiteralOfContextualType(type, instantiateContextualType(
	        contextualType,
	        node,
	        /*contextFlags*/
	        void 0
	      )) ? getRegularTypeOfLiteralType(type) : type;
	      popInferenceContext();
	      popContextualType();
	      return result;
	    }
	    function checkExpressionCached(node, checkMode) {
	      if (checkMode) {
	        return checkExpression(node, checkMode);
	      }
	      const links = getNodeLinks(node);
	      if (!links.resolvedType) {
	        const saveFlowLoopStart = flowLoopStart;
	        const saveFlowTypeCache = flowTypeCache;
	        flowLoopStart = flowLoopCount;
	        flowTypeCache = void 0;
	        links.resolvedType = checkExpression(node, checkMode);
	        flowTypeCache = saveFlowTypeCache;
	        flowLoopStart = saveFlowLoopStart;
	      }
	      return links.resolvedType;
	    }
	    function isTypeAssertion(node) {
	      node = skipParentheses(
	        node,
	        /*excludeJSDocTypeAssertions*/
	        true
	      );
	      return node.kind === 216 /* TypeAssertionExpression */ || node.kind === 234 /* AsExpression */ || isJSDocTypeAssertion(node);
	    }
	    function checkDeclarationInitializer(declaration, checkMode, contextualType) {
	      const initializer = getEffectiveInitializer(declaration);
	      if (isInJSFile(declaration)) {
	        const typeNode = tryGetJSDocSatisfiesTypeNode(declaration);
	        if (typeNode) {
	          return checkSatisfiesExpressionWorker(initializer, typeNode, checkMode);
	        }
	      }
	      const type = getQuickTypeOfExpression(initializer) || (contextualType ? checkExpressionWithContextualType(
	        initializer,
	        contextualType,
	        /*inferenceContext*/
	        void 0,
	        checkMode || 0 /* Normal */
	      ) : checkExpressionCached(initializer, checkMode));
	      return isParameter(declaration) && declaration.name.kind === 207 /* ArrayBindingPattern */ && isTupleType(type) && !type.target.hasRestElement && getTypeReferenceArity(type) < declaration.name.elements.length ? padTupleType(type, declaration.name) : type;
	    }
	    function padTupleType(type, pattern) {
	      const patternElements = pattern.elements;
	      const elementTypes = getElementTypes(type).slice();
	      const elementFlags = type.target.elementFlags.slice();
	      for (let i = getTypeReferenceArity(type); i < patternElements.length; i++) {
	        const e = patternElements[i];
	        if (i < patternElements.length - 1 || !(e.kind === 208 /* BindingElement */ && e.dotDotDotToken)) {
	          elementTypes.push(!isOmittedExpression(e) && hasDefaultValue(e) ? getTypeFromBindingElement(
	            e,
	            /*includePatternInType*/
	            false,
	            /*reportErrors*/
	            false
	          ) : anyType);
	          elementFlags.push(2 /* Optional */);
	          if (!isOmittedExpression(e) && !hasDefaultValue(e)) {
	            reportImplicitAny(e, anyType);
	          }
	        }
	      }
	      return createTupleType(elementTypes, elementFlags, type.target.readonly);
	    }
	    function widenTypeInferredFromInitializer(declaration, type) {
	      const widened = getCombinedNodeFlagsCached(declaration) & 6 /* Constant */ || isDeclarationReadonly(declaration) ? type : getWidenedLiteralType(type);
	      if (isInJSFile(declaration)) {
	        if (isEmptyLiteralType(widened)) {
	          reportImplicitAny(declaration, anyType);
	          return anyType;
	        } else if (isEmptyArrayLiteralType(widened)) {
	          reportImplicitAny(declaration, anyArrayType);
	          return anyArrayType;
	        }
	      }
	      return widened;
	    }
	    function isLiteralOfContextualType(candidateType, contextualType) {
	      if (contextualType) {
	        if (contextualType.flags & 3145728 /* UnionOrIntersection */) {
	          const types = contextualType.types;
	          return some(types, (t) => isLiteralOfContextualType(candidateType, t));
	        }
	        if (contextualType.flags & 58982400 /* InstantiableNonPrimitive */) {
	          const constraint = getBaseConstraintOfType(contextualType) || unknownType;
	          return maybeTypeOfKind(constraint, 4 /* String */) && maybeTypeOfKind(candidateType, 128 /* StringLiteral */) || maybeTypeOfKind(constraint, 8 /* Number */) && maybeTypeOfKind(candidateType, 256 /* NumberLiteral */) || maybeTypeOfKind(constraint, 64 /* BigInt */) && maybeTypeOfKind(candidateType, 2048 /* BigIntLiteral */) || maybeTypeOfKind(constraint, 4096 /* ESSymbol */) && maybeTypeOfKind(candidateType, 8192 /* UniqueESSymbol */) || isLiteralOfContextualType(candidateType, constraint);
	        }
	        return !!(contextualType.flags & (128 /* StringLiteral */ | 4194304 /* Index */ | 134217728 /* TemplateLiteral */ | 268435456 /* StringMapping */) && maybeTypeOfKind(candidateType, 128 /* StringLiteral */) || contextualType.flags & 256 /* NumberLiteral */ && maybeTypeOfKind(candidateType, 256 /* NumberLiteral */) || contextualType.flags & 2048 /* BigIntLiteral */ && maybeTypeOfKind(candidateType, 2048 /* BigIntLiteral */) || contextualType.flags & 512 /* BooleanLiteral */ && maybeTypeOfKind(candidateType, 512 /* BooleanLiteral */) || contextualType.flags & 8192 /* UniqueESSymbol */ && maybeTypeOfKind(candidateType, 8192 /* UniqueESSymbol */));
	      }
	      return false;
	    }
	    function isConstContext(node) {
	      const parent2 = node.parent;
	      return isAssertionExpression(parent2) && isConstTypeReference(parent2.type) || isJSDocTypeAssertion(parent2) && isConstTypeReference(getJSDocTypeAssertionType(parent2)) || isValidConstAssertionArgument(node) && isConstTypeVariable(getContextualType2(node, 0 /* None */)) || (isParenthesizedExpression(parent2) || isArrayLiteralExpression(parent2) || isSpreadElement(parent2)) && isConstContext(parent2) || (isPropertyAssignment(parent2) || isShorthandPropertyAssignment(parent2) || isTemplateSpan(parent2)) && isConstContext(parent2.parent);
	    }
	    function checkExpressionForMutableLocation(node, checkMode, forceTuple) {
	      const type = checkExpression(node, checkMode, forceTuple);
	      return isConstContext(node) || isCommonJsExportedExpression(node) ? getRegularTypeOfLiteralType(type) : isTypeAssertion(node) ? type : getWidenedLiteralLikeTypeForContextualType(type, instantiateContextualType(
	        getContextualType2(
	          node,
	          /*contextFlags*/
	          void 0
	        ),
	        node,
	        /*contextFlags*/
	        void 0
	      ));
	    }
	    function checkPropertyAssignment(node, checkMode) {
	      if (node.name.kind === 167 /* ComputedPropertyName */) {
	        checkComputedPropertyName(node.name);
	      }
	      return checkExpressionForMutableLocation(node.initializer, checkMode);
	    }
	    function checkObjectLiteralMethod(node, checkMode) {
	      checkGrammarMethod(node);
	      if (node.name.kind === 167 /* ComputedPropertyName */) {
	        checkComputedPropertyName(node.name);
	      }
	      const uninstantiatedType = checkFunctionExpressionOrObjectLiteralMethod(node, checkMode);
	      return instantiateTypeWithSingleGenericCallSignature(node, uninstantiatedType, checkMode);
	    }
	    function instantiateTypeWithSingleGenericCallSignature(node, type, checkMode) {
	      if (checkMode && checkMode & (2 /* Inferential */ | 8 /* SkipGenericFunctions */)) {
	        const callSignature = getSingleSignature(
	          type,
	          0 /* Call */,
	          /*allowMembers*/
	          true
	        );
	        const constructSignature = getSingleSignature(
	          type,
	          1 /* Construct */,
	          /*allowMembers*/
	          true
	        );
	        const signature = callSignature || constructSignature;
	        if (signature && signature.typeParameters) {
	          const contextualType = getApparentTypeOfContextualType(node, 2 /* NoConstraints */);
	          if (contextualType) {
	            const contextualSignature = getSingleSignature(
	              getNonNullableType(contextualType),
	              callSignature ? 0 /* Call */ : 1 /* Construct */,
	              /*allowMembers*/
	              false
	            );
	            if (contextualSignature && !contextualSignature.typeParameters) {
	              if (checkMode & 8 /* SkipGenericFunctions */) {
	                skippedGenericFunction(node, checkMode);
	                return anyFunctionType;
	              }
	              const context = getInferenceContext(node);
	              const returnType = context.signature && getReturnTypeOfSignature(context.signature);
	              const returnSignature = returnType && getSingleCallOrConstructSignature(returnType);
	              if (returnSignature && !returnSignature.typeParameters && !every(context.inferences, hasInferenceCandidates)) {
	                const uniqueTypeParameters = getUniqueTypeParameters(context, signature.typeParameters);
	                const instantiatedSignature = getSignatureInstantiationWithoutFillingInTypeArguments(signature, uniqueTypeParameters);
	                const inferences = map(context.inferences, (info) => createInferenceInfo(info.typeParameter));
	                applyToParameterTypes(instantiatedSignature, contextualSignature, (source, target) => {
	                  inferTypes(
	                    inferences,
	                    source,
	                    target,
	                    /*priority*/
	                    0,
	                    /*contravariant*/
	                    true
	                  );
	                });
	                if (some(inferences, hasInferenceCandidates)) {
	                  applyToReturnTypes(instantiatedSignature, contextualSignature, (source, target) => {
	                    inferTypes(inferences, source, target);
	                  });
	                  if (!hasOverlappingInferences(context.inferences, inferences)) {
	                    mergeInferences(context.inferences, inferences);
	                    context.inferredTypeParameters = concatenate(context.inferredTypeParameters, uniqueTypeParameters);
	                    return getOrCreateTypeFromSignature(instantiatedSignature);
	                  }
	                }
	              }
	              return getOrCreateTypeFromSignature(instantiateSignatureInContextOf(signature, contextualSignature, context));
	            }
	          }
	        }
	      }
	      return type;
	    }
	    function skippedGenericFunction(node, checkMode) {
	      if (checkMode & 2 /* Inferential */) {
	        const context = getInferenceContext(node);
	        context.flags |= 4 /* SkippedGenericFunction */;
	      }
	    }
	    function hasInferenceCandidates(info) {
	      return !!(info.candidates || info.contraCandidates);
	    }
	    function hasInferenceCandidatesOrDefault(info) {
	      return !!(info.candidates || info.contraCandidates || hasTypeParameterDefault(info.typeParameter));
	    }
	    function hasOverlappingInferences(a, b) {
	      for (let i = 0; i < a.length; i++) {
	        if (hasInferenceCandidates(a[i]) && hasInferenceCandidates(b[i])) {
	          return true;
	        }
	      }
	      return false;
	    }
	    function mergeInferences(target, source) {
	      for (let i = 0; i < target.length; i++) {
	        if (!hasInferenceCandidates(target[i]) && hasInferenceCandidates(source[i])) {
	          target[i] = source[i];
	        }
	      }
	    }
	    function getUniqueTypeParameters(context, typeParameters) {
	      const result = [];
	      let oldTypeParameters;
	      let newTypeParameters;
	      for (const tp of typeParameters) {
	        const name = tp.symbol.escapedName;
	        if (hasTypeParameterByName(context.inferredTypeParameters, name) || hasTypeParameterByName(result, name)) {
	          const newName = getUniqueTypeParameterName(concatenate(context.inferredTypeParameters, result), name);
	          const symbol = createSymbol(262144 /* TypeParameter */, newName);
	          const newTypeParameter = createTypeParameter(symbol);
	          newTypeParameter.target = tp;
	          oldTypeParameters = append(oldTypeParameters, tp);
	          newTypeParameters = append(newTypeParameters, newTypeParameter);
	          result.push(newTypeParameter);
	        } else {
	          result.push(tp);
	        }
	      }
	      if (newTypeParameters) {
	        const mapper = createTypeMapper(oldTypeParameters, newTypeParameters);
	        for (const tp of newTypeParameters) {
	          tp.mapper = mapper;
	        }
	      }
	      return result;
	    }
	    function hasTypeParameterByName(typeParameters, name) {
	      return some(typeParameters, (tp) => tp.symbol.escapedName === name);
	    }
	    function getUniqueTypeParameterName(typeParameters, baseName) {
	      let len = baseName.length;
	      while (len > 1 && baseName.charCodeAt(len - 1) >= 48 /* _0 */ && baseName.charCodeAt(len - 1) <= 57 /* _9 */)
	        len--;
	      const s = baseName.slice(0, len);
	      for (let index = 1; true; index++) {
	        const augmentedName = s + index;
	        if (!hasTypeParameterByName(typeParameters, augmentedName)) {
	          return augmentedName;
	        }
	      }
	    }
	    function getReturnTypeOfSingleNonGenericCallSignature(funcType) {
	      const signature = getSingleCallSignature(funcType);
	      if (signature && !signature.typeParameters) {
	        return getReturnTypeOfSignature(signature);
	      }
	    }
	    function getReturnTypeOfSingleNonGenericSignatureOfCallChain(expr) {
	      const funcType = checkExpression(expr.expression);
	      const nonOptionalType = getOptionalExpressionType(funcType, expr.expression);
	      const returnType = getReturnTypeOfSingleNonGenericCallSignature(funcType);
	      return returnType && propagateOptionalTypeMarker(returnType, expr, nonOptionalType !== funcType);
	    }
	    function getTypeOfExpression(node) {
	      const quickType = getQuickTypeOfExpression(node);
	      if (quickType) {
	        return quickType;
	      }
	      if (node.flags & 268435456 /* TypeCached */ && flowTypeCache) {
	        const cachedType = flowTypeCache[getNodeId(node)];
	        if (cachedType) {
	          return cachedType;
	        }
	      }
	      const startInvocationCount = flowInvocationCount;
	      const type = checkExpression(node, 64 /* TypeOnly */);
	      if (flowInvocationCount !== startInvocationCount) {
	        const cache = flowTypeCache || (flowTypeCache = []);
	        cache[getNodeId(node)] = type;
	        setNodeFlags(node, node.flags | 268435456 /* TypeCached */);
	      }
	      return type;
	    }
	    function getQuickTypeOfExpression(node) {
	      let expr = skipParentheses(
	        node,
	        /*excludeJSDocTypeAssertions*/
	        true
	      );
	      if (isJSDocTypeAssertion(expr)) {
	        const type = getJSDocTypeAssertionType(expr);
	        if (!isConstTypeReference(type)) {
	          return getTypeFromTypeNode(type);
	        }
	      }
	      expr = skipParentheses(node);
	      if (isAwaitExpression(expr)) {
	        const type = getQuickTypeOfExpression(expr.expression);
	        return type ? getAwaitedType(type) : void 0;
	      }
	      if (isCallExpression(expr) && expr.expression.kind !== 108 /* SuperKeyword */ && !isRequireCall(
	        expr,
	        /*requireStringLiteralLikeArgument*/
	        true
	      ) && !isSymbolOrSymbolForCall(expr)) {
	        return isCallChain(expr) ? getReturnTypeOfSingleNonGenericSignatureOfCallChain(expr) : getReturnTypeOfSingleNonGenericCallSignature(checkNonNullExpression(expr.expression));
	      } else if (isAssertionExpression(expr) && !isConstTypeReference(expr.type)) {
	        return getTypeFromTypeNode(expr.type);
	      } else if (isLiteralExpression(node) || isBooleanLiteral(node)) {
	        return checkExpression(node);
	      }
	      return void 0;
	    }
	    function getContextFreeTypeOfExpression(node) {
	      const links = getNodeLinks(node);
	      if (links.contextFreeType) {
	        return links.contextFreeType;
	      }
	      pushContextualType(
	        node,
	        anyType,
	        /*isCache*/
	        false
	      );
	      const type = links.contextFreeType = checkExpression(node, 4 /* SkipContextSensitive */);
	      popContextualType();
	      return type;
	    }
	    function checkExpression(node, checkMode, forceTuple) {
	      var _a, _b;
	      (_a = tracing) == null ? void 0 : _a.push(tracing.Phase.Check, "checkExpression", { kind: node.kind, pos: node.pos, end: node.end, path: node.tracingPath });
	      const saveCurrentNode = currentNode;
	      currentNode = node;
	      instantiationCount = 0;
	      const uninstantiatedType = checkExpressionWorker(node, checkMode, forceTuple);
	      const type = instantiateTypeWithSingleGenericCallSignature(node, uninstantiatedType, checkMode);
	      if (isConstEnumObjectType(type)) {
	        checkConstEnumAccess(node, type);
	      }
	      currentNode = saveCurrentNode;
	      (_b = tracing) == null ? void 0 : _b.pop();
	      return type;
	    }
	    function checkConstEnumAccess(node, type) {
	      const ok = node.parent.kind === 211 /* PropertyAccessExpression */ && node.parent.expression === node || node.parent.kind === 212 /* ElementAccessExpression */ && node.parent.expression === node || ((node.kind === 80 /* Identifier */ || node.kind === 166 /* QualifiedName */) && isInRightSideOfImportOrExportAssignment(node) || node.parent.kind === 186 /* TypeQuery */ && node.parent.exprName === node) || node.parent.kind === 281 /* ExportSpecifier */;
	      if (!ok) {
	        error2(node, Diagnostics.const_enums_can_only_be_used_in_property_or_index_access_expressions_or_the_right_hand_side_of_an_import_declaration_or_export_assignment_or_type_query);
	      }
	      if (getIsolatedModules(compilerOptions)) {
	        Debug.assert(!!(type.symbol.flags & 128 /* ConstEnum */));
	        const constEnumDeclaration = type.symbol.valueDeclaration;
	        if (constEnumDeclaration.flags & 33554432 /* Ambient */ && !isValidTypeOnlyAliasUseSite(node)) {
	          error2(node, Diagnostics.Cannot_access_ambient_const_enums_when_0_is_enabled, isolatedModulesLikeFlagName);
	        }
	      }
	    }
	    function checkParenthesizedExpression(node, checkMode) {
	      if (hasJSDocNodes(node)) {
	        if (isJSDocSatisfiesExpression(node)) {
	          return checkSatisfiesExpressionWorker(node.expression, getJSDocSatisfiesExpressionType(node), checkMode);
	        }
	        if (isJSDocTypeAssertion(node)) {
	          return checkAssertionWorker(node, checkMode);
	        }
	      }
	      return checkExpression(node.expression, checkMode);
	    }
	    function checkExpressionWorker(node, checkMode, forceTuple) {
	      const kind = node.kind;
	      if (cancellationToken) {
	        switch (kind) {
	          case 231 /* ClassExpression */:
	          case 218 /* FunctionExpression */:
	          case 219 /* ArrowFunction */:
	            cancellationToken.throwIfCancellationRequested();
	        }
	      }
	      switch (kind) {
	        case 80 /* Identifier */:
	          return checkIdentifier(node, checkMode);
	        case 81 /* PrivateIdentifier */:
	          return checkPrivateIdentifierExpression(node);
	        case 110 /* ThisKeyword */:
	          return checkThisExpression(node);
	        case 108 /* SuperKeyword */:
	          return checkSuperExpression(node);
	        case 106 /* NullKeyword */:
	          return nullWideningType;
	        case 15 /* NoSubstitutionTemplateLiteral */:
	        case 11 /* StringLiteral */:
	          return hasSkipDirectInferenceFlag(node) ? blockedStringType : getFreshTypeOfLiteralType(getStringLiteralType(node.text));
	        case 9 /* NumericLiteral */:
	          checkGrammarNumericLiteral(node);
	          return getFreshTypeOfLiteralType(getNumberLiteralType(+node.text));
	        case 10 /* BigIntLiteral */:
	          checkGrammarBigIntLiteral(node);
	          return getFreshTypeOfLiteralType(getBigIntLiteralType({
	            negative: false,
	            base10Value: parsePseudoBigInt(node.text)
	          }));
	        case 112 /* TrueKeyword */:
	          return trueType;
	        case 97 /* FalseKeyword */:
	          return falseType;
	        case 228 /* TemplateExpression */:
	          return checkTemplateExpression(node);
	        case 14 /* RegularExpressionLiteral */:
	          return globalRegExpType;
	        case 209 /* ArrayLiteralExpression */:
	          return checkArrayLiteral(node, checkMode, forceTuple);
	        case 210 /* ObjectLiteralExpression */:
	          return checkObjectLiteral(node, checkMode);
	        case 211 /* PropertyAccessExpression */:
	          return checkPropertyAccessExpression(node, checkMode);
	        case 166 /* QualifiedName */:
	          return checkQualifiedName(node, checkMode);
	        case 212 /* ElementAccessExpression */:
	          return checkIndexedAccess(node, checkMode);
	        case 213 /* CallExpression */:
	          if (node.expression.kind === 102 /* ImportKeyword */) {
	            return checkImportCallExpression(node);
	          }
	        case 214 /* NewExpression */:
	          return checkCallExpression(node, checkMode);
	        case 215 /* TaggedTemplateExpression */:
	          return checkTaggedTemplateExpression(node);
	        case 217 /* ParenthesizedExpression */:
	          return checkParenthesizedExpression(node, checkMode);
	        case 231 /* ClassExpression */:
	          return checkClassExpression(node);
	        case 218 /* FunctionExpression */:
	        case 219 /* ArrowFunction */:
	          return checkFunctionExpressionOrObjectLiteralMethod(node, checkMode);
	        case 221 /* TypeOfExpression */:
	          return checkTypeOfExpression(node);
	        case 216 /* TypeAssertionExpression */:
	        case 234 /* AsExpression */:
	          return checkAssertion(node, checkMode);
	        case 235 /* NonNullExpression */:
	          return checkNonNullAssertion(node);
	        case 233 /* ExpressionWithTypeArguments */:
	          return checkExpressionWithTypeArguments(node);
	        case 238 /* SatisfiesExpression */:
	          return checkSatisfiesExpression(node);
	        case 236 /* MetaProperty */:
	          return checkMetaProperty(node);
	        case 220 /* DeleteExpression */:
	          return checkDeleteExpression(node);
	        case 222 /* VoidExpression */:
	          return checkVoidExpression(node);
	        case 223 /* AwaitExpression */:
	          return checkAwaitExpression(node);
	        case 224 /* PrefixUnaryExpression */:
	          return checkPrefixUnaryExpression(node);
	        case 225 /* PostfixUnaryExpression */:
	          return checkPostfixUnaryExpression(node);
	        case 226 /* BinaryExpression */:
	          return checkBinaryExpression(node, checkMode);
	        case 227 /* ConditionalExpression */:
	          return checkConditionalExpression(node, checkMode);
	        case 230 /* SpreadElement */:
	          return checkSpreadExpression(node, checkMode);
	        case 232 /* OmittedExpression */:
	          return undefinedWideningType;
	        case 229 /* YieldExpression */:
	          return checkYieldExpression(node);
	        case 237 /* SyntheticExpression */:
	          return checkSyntheticExpression(node);
	        case 294 /* JsxExpression */:
	          return checkJsxExpression(node, checkMode);
	        case 284 /* JsxElement */:
	          return checkJsxElement(node);
	        case 285 /* JsxSelfClosingElement */:
	          return checkJsxSelfClosingElement(node);
	        case 288 /* JsxFragment */:
	          return checkJsxFragment(node);
	        case 292 /* JsxAttributes */:
	          return checkJsxAttributes(node, checkMode);
	        case 286 /* JsxOpeningElement */:
	          Debug.fail("Shouldn't ever directly check a JsxOpeningElement");
	      }
	      return errorType;
	    }
	    function checkTypeParameter(node) {
	      checkGrammarModifiers(node);
	      if (node.expression) {
	        grammarErrorOnFirstToken(node.expression, Diagnostics.Type_expected);
	      }
	      checkSourceElement(node.constraint);
	      checkSourceElement(node.default);
	      const typeParameter = getDeclaredTypeOfTypeParameter(getSymbolOfDeclaration(node));
	      getBaseConstraintOfType(typeParameter);
	      if (!hasNonCircularTypeParameterDefault(typeParameter)) {
	        error2(node.default, Diagnostics.Type_parameter_0_has_a_circular_default, typeToString(typeParameter));
	      }
	      const constraintType = getConstraintOfTypeParameter(typeParameter);
	      const defaultType = getDefaultFromTypeParameter(typeParameter);
	      if (constraintType && defaultType) {
	        checkTypeAssignableTo(defaultType, getTypeWithThisArgument(instantiateType(constraintType, makeUnaryTypeMapper(typeParameter, defaultType)), defaultType), node.default, Diagnostics.Type_0_does_not_satisfy_the_constraint_1);
	      }
	      checkNodeDeferred(node);
	      addLazyDiagnostic(() => checkTypeNameIsReserved(node.name, Diagnostics.Type_parameter_name_cannot_be_0));
	    }
	    function checkTypeParameterDeferred(node) {
	      var _a, _b;
	      if (isInterfaceDeclaration(node.parent) || isClassLike(node.parent) || isTypeAliasDeclaration(node.parent)) {
	        const typeParameter = getDeclaredTypeOfTypeParameter(getSymbolOfDeclaration(node));
	        const modifiers = getTypeParameterModifiers(typeParameter) & (8192 /* In */ | 16384 /* Out */);
	        if (modifiers) {
	          const symbol = getSymbolOfDeclaration(node.parent);
	          if (isTypeAliasDeclaration(node.parent) && !(getObjectFlags(getDeclaredTypeOfSymbol(symbol)) & (4 /* Reference */ | 16 /* Anonymous */ | 32 /* Mapped */))) {
	            error2(node, Diagnostics.Variance_annotations_are_only_supported_in_type_aliases_for_object_function_constructor_and_mapped_types);
	          } else if (modifiers === 8192 /* In */ || modifiers === 16384 /* Out */) {
	            (_a = tracing) == null ? void 0 : _a.push(tracing.Phase.CheckTypes, "checkTypeParameterDeferred", { parent: getTypeId(getDeclaredTypeOfSymbol(symbol)), id: getTypeId(typeParameter) });
	            const source = createMarkerType(symbol, typeParameter, modifiers === 16384 /* Out */ ? markerSubTypeForCheck : markerSuperTypeForCheck);
	            const target = createMarkerType(symbol, typeParameter, modifiers === 16384 /* Out */ ? markerSuperTypeForCheck : markerSubTypeForCheck);
	            const saveVarianceTypeParameter = typeParameter;
	            varianceTypeParameter = typeParameter;
	            checkTypeAssignableTo(source, target, node, Diagnostics.Type_0_is_not_assignable_to_type_1_as_implied_by_variance_annotation);
	            varianceTypeParameter = saveVarianceTypeParameter;
	            (_b = tracing) == null ? void 0 : _b.pop();
	          }
	        }
	      }
	    }
	    function checkParameter(node) {
	      checkGrammarModifiers(node);
	      checkVariableLikeDeclaration(node);
	      const func = getContainingFunction(node);
	      if (hasSyntacticModifier(node, 31 /* ParameterPropertyModifier */)) {
	        if (!(func.kind === 176 /* Constructor */ && nodeIsPresent(func.body))) {
	          error2(node, Diagnostics.A_parameter_property_is_only_allowed_in_a_constructor_implementation);
	        }
	        if (func.kind === 176 /* Constructor */ && isIdentifier(node.name) && node.name.escapedText === "constructor") {
	          error2(node.name, Diagnostics.constructor_cannot_be_used_as_a_parameter_property_name);
	        }
	      }
	      if (!node.initializer && isOptionalDeclaration(node) && isBindingPattern(node.name) && func.body) {
	        error2(node, Diagnostics.A_binding_pattern_parameter_cannot_be_optional_in_an_implementation_signature);
	      }
	      if (node.name && isIdentifier(node.name) && (node.name.escapedText === "this" || node.name.escapedText === "new")) {
	        if (func.parameters.indexOf(node) !== 0) {
	          error2(node, Diagnostics.A_0_parameter_must_be_the_first_parameter, node.name.escapedText);
	        }
	        if (func.kind === 176 /* Constructor */ || func.kind === 180 /* ConstructSignature */ || func.kind === 185 /* ConstructorType */) {
	          error2(node, Diagnostics.A_constructor_cannot_have_a_this_parameter);
	        }
	        if (func.kind === 219 /* ArrowFunction */) {
	          error2(node, Diagnostics.An_arrow_function_cannot_have_a_this_parameter);
	        }
	        if (func.kind === 177 /* GetAccessor */ || func.kind === 178 /* SetAccessor */) {
	          error2(node, Diagnostics.get_and_set_accessors_cannot_declare_this_parameters);
	        }
	      }
	      if (node.dotDotDotToken && !isBindingPattern(node.name) && !isTypeAssignableTo(getReducedType(getTypeOfSymbol(node.symbol)), anyReadonlyArrayType)) {
	        error2(node, Diagnostics.A_rest_parameter_must_be_of_an_array_type);
	      }
	    }
	    function checkTypePredicate(node) {
	      const parent2 = getTypePredicateParent(node);
	      if (!parent2) {
	        error2(node, Diagnostics.A_type_predicate_is_only_allowed_in_return_type_position_for_functions_and_methods);
	        return;
	      }
	      const signature = getSignatureFromDeclaration(parent2);
	      const typePredicate = getTypePredicateOfSignature(signature);
	      if (!typePredicate) {
	        return;
	      }
	      checkSourceElement(node.type);
	      const { parameterName } = node;
	      if (typePredicate.kind === 0 /* This */ || typePredicate.kind === 2 /* AssertsThis */) {
	        getTypeFromThisTypeNode(parameterName);
	      } else {
	        if (typePredicate.parameterIndex >= 0) {
	          if (signatureHasRestParameter(signature) && typePredicate.parameterIndex === signature.parameters.length - 1) {
	            error2(parameterName, Diagnostics.A_type_predicate_cannot_reference_a_rest_parameter);
	          } else {
	            if (typePredicate.type) {
	              const leadingError = () => chainDiagnosticMessages(
	                /*details*/
	                void 0,
	                Diagnostics.A_type_predicate_s_type_must_be_assignable_to_its_parameter_s_type
	              );
	              checkTypeAssignableTo(
	                typePredicate.type,
	                getTypeOfSymbol(signature.parameters[typePredicate.parameterIndex]),
	                node.type,
	                /*headMessage*/
	                void 0,
	                leadingError
	              );
	            }
	          }
	        } else if (parameterName) {
	          let hasReportedError = false;
	          for (const { name } of parent2.parameters) {
	            if (isBindingPattern(name) && checkIfTypePredicateVariableIsDeclaredInBindingPattern(name, parameterName, typePredicate.parameterName)) {
	              hasReportedError = true;
	              break;
	            }
	          }
	          if (!hasReportedError) {
	            error2(node.parameterName, Diagnostics.Cannot_find_parameter_0, typePredicate.parameterName);
	          }
	        }
	      }
	    }
	    function getTypePredicateParent(node) {
	      switch (node.parent.kind) {
	        case 219 /* ArrowFunction */:
	        case 179 /* CallSignature */:
	        case 262 /* FunctionDeclaration */:
	        case 218 /* FunctionExpression */:
	        case 184 /* FunctionType */:
	        case 174 /* MethodDeclaration */:
	        case 173 /* MethodSignature */:
	          const parent2 = node.parent;
	          if (node === parent2.type) {
	            return parent2;
	          }
	      }
	    }
	    function checkIfTypePredicateVariableIsDeclaredInBindingPattern(pattern, predicateVariableNode, predicateVariableName) {
	      for (const element of pattern.elements) {
	        if (isOmittedExpression(element)) {
	          continue;
	        }
	        const name = element.name;
	        if (name.kind === 80 /* Identifier */ && name.escapedText === predicateVariableName) {
	          error2(predicateVariableNode, Diagnostics.A_type_predicate_cannot_reference_element_0_in_a_binding_pattern, predicateVariableName);
	          return true;
	        } else if (name.kind === 207 /* ArrayBindingPattern */ || name.kind === 206 /* ObjectBindingPattern */) {
	          if (checkIfTypePredicateVariableIsDeclaredInBindingPattern(
	            name,
	            predicateVariableNode,
	            predicateVariableName
	          )) {
	            return true;
	          }
	        }
	      }
	    }
	    function checkSignatureDeclaration(node) {
	      if (node.kind === 181 /* IndexSignature */) {
	        checkGrammarIndexSignature(node);
	      } else if (node.kind === 184 /* FunctionType */ || node.kind === 262 /* FunctionDeclaration */ || node.kind === 185 /* ConstructorType */ || node.kind === 179 /* CallSignature */ || node.kind === 176 /* Constructor */ || node.kind === 180 /* ConstructSignature */) {
	        checkGrammarFunctionLikeDeclaration(node);
	      }
	      const functionFlags = getFunctionFlags(node);
	      if (!(functionFlags & 4 /* Invalid */)) {
	        if ((functionFlags & 3 /* AsyncGenerator */) === 3 /* AsyncGenerator */ && languageVersion < 99 /* ESNext */) {
	          checkExternalEmitHelpers(node, 6144 /* AsyncGeneratorIncludes */);
	        }
	        if ((functionFlags & 3 /* AsyncGenerator */) === 2 /* Async */ && languageVersion < 4 /* ES2017 */) {
	          checkExternalEmitHelpers(node, 64 /* Awaiter */);
	        }
	        if ((functionFlags & 3 /* AsyncGenerator */) !== 0 /* Normal */ && languageVersion < 2 /* ES2015 */) {
	          checkExternalEmitHelpers(node, 128 /* Generator */);
	        }
	      }
	      checkTypeParameters(getEffectiveTypeParameterDeclarations(node));
	      checkUnmatchedJSDocParameters(node);
	      forEach(node.parameters, checkParameter);
	      if (node.type) {
	        checkSourceElement(node.type);
	      }
	      addLazyDiagnostic(checkSignatureDeclarationDiagnostics);
	      function checkSignatureDeclarationDiagnostics() {
	        checkCollisionWithArgumentsInGeneratedCode(node);
	        let returnTypeNode = getEffectiveReturnTypeNode(node);
	        let returnTypeErrorLocation = returnTypeNode;
	        if (isInJSFile(node)) {
	          const typeTag = getJSDocTypeTag(node);
	          if (typeTag && typeTag.typeExpression && isTypeReferenceNode(typeTag.typeExpression.type)) {
	            const signature = getSingleCallSignature(getTypeFromTypeNode(typeTag.typeExpression));
	            if (signature && signature.declaration) {
	              returnTypeNode = getEffectiveReturnTypeNode(signature.declaration);
	              returnTypeErrorLocation = typeTag.typeExpression.type;
	            }
	          }
	        }
	        if (noImplicitAny && !returnTypeNode) {
	          switch (node.kind) {
	            case 180 /* ConstructSignature */:
	              error2(node, Diagnostics.Construct_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type);
	              break;
	            case 179 /* CallSignature */:
	              error2(node, Diagnostics.Call_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type);
	              break;
	          }
	        }
	        if (returnTypeNode && returnTypeErrorLocation) {
	          const functionFlags2 = getFunctionFlags(node);
	          if ((functionFlags2 & (4 /* Invalid */ | 1 /* Generator */)) === 1 /* Generator */) {
	            const returnType = getTypeFromTypeNode(returnTypeNode);
	            if (returnType === voidType) {
	              error2(returnTypeErrorLocation, Diagnostics.A_generator_cannot_have_a_void_type_annotation);
	            } else {
	              checkGeneratorInstantiationAssignabilityToReturnType(returnType, functionFlags2, returnTypeErrorLocation);
	            }
	          } else if ((functionFlags2 & 3 /* AsyncGenerator */) === 2 /* Async */) {
	            checkAsyncFunctionReturnType(node, returnTypeNode, returnTypeErrorLocation);
	          }
	        }
	        if (node.kind !== 181 /* IndexSignature */ && node.kind !== 324 /* JSDocFunctionType */) {
	          registerForUnusedIdentifiersCheck(node);
	        }
	      }
	    }
	    function checkGeneratorInstantiationAssignabilityToReturnType(returnType, functionFlags, errorNode) {
	      const generatorYieldType = getIterationTypeOfGeneratorFunctionReturnType(0 /* Yield */, returnType, (functionFlags & 2 /* Async */) !== 0) || anyType;
	      const generatorReturnType = getIterationTypeOfGeneratorFunctionReturnType(1 /* Return */, returnType, (functionFlags & 2 /* Async */) !== 0) || generatorYieldType;
	      const generatorNextType = getIterationTypeOfGeneratorFunctionReturnType(2 /* Next */, returnType, (functionFlags & 2 /* Async */) !== 0) || unknownType;
	      const generatorInstantiation = createGeneratorReturnType(generatorYieldType, generatorReturnType, generatorNextType, !!(functionFlags & 2 /* Async */));
	      return checkTypeAssignableTo(generatorInstantiation, returnType, errorNode);
	    }
	    function checkClassForDuplicateDeclarations(node) {
	      const instanceNames = /* @__PURE__ */ new Map();
	      const staticNames = /* @__PURE__ */ new Map();
	      const privateIdentifiers = /* @__PURE__ */ new Map();
	      for (const member of node.members) {
	        if (member.kind === 176 /* Constructor */) {
	          for (const param of member.parameters) {
	            if (isParameterPropertyDeclaration(param, member) && !isBindingPattern(param.name)) {
	              addName(instanceNames, param.name, param.name.escapedText, 3 /* GetOrSetAccessor */);
	            }
	          }
	        } else {
	          const isStaticMember = isStatic(member);
	          const name = member.name;
	          if (!name) {
	            continue;
	          }
	          const isPrivate = isPrivateIdentifier(name);
	          const privateStaticFlags = isPrivate && isStaticMember ? 16 /* PrivateStatic */ : 0;
	          const names = isPrivate ? privateIdentifiers : isStaticMember ? staticNames : instanceNames;
	          const memberName = name && getEffectivePropertyNameForPropertyNameNode(name);
	          if (memberName) {
	            switch (member.kind) {
	              case 177 /* GetAccessor */:
	                addName(names, name, memberName, 1 /* GetAccessor */ | privateStaticFlags);
	                break;
	              case 178 /* SetAccessor */:
	                addName(names, name, memberName, 2 /* SetAccessor */ | privateStaticFlags);
	                break;
	              case 172 /* PropertyDeclaration */:
	                addName(names, name, memberName, 3 /* GetOrSetAccessor */ | privateStaticFlags);
	                break;
	              case 174 /* MethodDeclaration */:
	                addName(names, name, memberName, 8 /* Method */ | privateStaticFlags);
	                break;
	            }
	          }
	        }
	      }
	      function addName(names, location, name, meaning) {
	        const prev = names.get(name);
	        if (prev) {
	          if ((prev & 16 /* PrivateStatic */) !== (meaning & 16 /* PrivateStatic */)) {
	            error2(location, Diagnostics.Duplicate_identifier_0_Static_and_instance_elements_cannot_share_the_same_private_name, getTextOfNode(location));
	          } else {
	            const prevIsMethod = !!(prev & 8 /* Method */);
	            const isMethod = !!(meaning & 8 /* Method */);
	            if (prevIsMethod || isMethod) {
	              if (prevIsMethod !== isMethod) {
	                error2(location, Diagnostics.Duplicate_identifier_0, getTextOfNode(location));
	              }
	            } else if (prev & meaning & ~16 /* PrivateStatic */) {
	              error2(location, Diagnostics.Duplicate_identifier_0, getTextOfNode(location));
	            } else {
	              names.set(name, prev | meaning);
	            }
	          }
	        } else {
	          names.set(name, meaning);
	        }
	      }
	    }
	    function checkClassForStaticPropertyNameConflicts(node) {
	      for (const member of node.members) {
	        const memberNameNode = member.name;
	        const isStaticMember = isStatic(member);
	        if (isStaticMember && memberNameNode) {
	          const memberName = getEffectivePropertyNameForPropertyNameNode(memberNameNode);
	          switch (memberName) {
	            case "name":
	            case "length":
	            case "caller":
	            case "arguments":
	              if (useDefineForClassFields) {
	                break;
	              }
	            case "prototype":
	              const message = Diagnostics.Static_property_0_conflicts_with_built_in_property_Function_0_of_constructor_function_1;
	              const className = getNameOfSymbolAsWritten(getSymbolOfDeclaration(node));
	              error2(memberNameNode, message, memberName, className);
	              break;
	          }
	        }
	      }
	    }
	    function checkObjectTypeForDuplicateDeclarations(node) {
	      const names = /* @__PURE__ */ new Map();
	      for (const member of node.members) {
	        if (member.kind === 171 /* PropertySignature */) {
	          let memberName;
	          const name = member.name;
	          switch (name.kind) {
	            case 11 /* StringLiteral */:
	            case 9 /* NumericLiteral */:
	              memberName = name.text;
	              break;
	            case 80 /* Identifier */:
	              memberName = idText(name);
	              break;
	            default:
	              continue;
	          }
	          if (names.get(memberName)) {
	            error2(getNameOfDeclaration(member.symbol.valueDeclaration), Diagnostics.Duplicate_identifier_0, memberName);
	            error2(member.name, Diagnostics.Duplicate_identifier_0, memberName);
	          } else {
	            names.set(memberName, true);
	          }
	        }
	      }
	    }
	    function checkTypeForDuplicateIndexSignatures(node) {
	      if (node.kind === 264 /* InterfaceDeclaration */) {
	        const nodeSymbol = getSymbolOfDeclaration(node);
	        if (nodeSymbol.declarations && nodeSymbol.declarations.length > 0 && nodeSymbol.declarations[0] !== node) {
	          return;
	        }
	      }
	      const indexSymbol = getIndexSymbol(getSymbolOfDeclaration(node));
	      if (indexSymbol == null ? void 0 : indexSymbol.declarations) {
	        const indexSignatureMap = /* @__PURE__ */ new Map();
	        for (const declaration of indexSymbol.declarations) {
	          if (declaration.parameters.length === 1 && declaration.parameters[0].type) {
	            forEachType(getTypeFromTypeNode(declaration.parameters[0].type), (type) => {
	              const entry = indexSignatureMap.get(getTypeId(type));
	              if (entry) {
	                entry.declarations.push(declaration);
	              } else {
	                indexSignatureMap.set(getTypeId(type), { type, declarations: [declaration] });
	              }
	            });
	          }
	        }
	        indexSignatureMap.forEach((entry) => {
	          if (entry.declarations.length > 1) {
	            for (const declaration of entry.declarations) {
	              error2(declaration, Diagnostics.Duplicate_index_signature_for_type_0, typeToString(entry.type));
	            }
	          }
	        });
	      }
	    }
	    function checkPropertyDeclaration(node) {
	      if (!checkGrammarModifiers(node) && !checkGrammarProperty(node))
	        checkGrammarComputedPropertyName(node.name);
	      checkVariableLikeDeclaration(node);
	      setNodeLinksForPrivateIdentifierScope(node);
	      if (hasSyntacticModifier(node, 64 /* Abstract */) && node.kind === 172 /* PropertyDeclaration */ && node.initializer) {
	        error2(node, Diagnostics.Property_0_cannot_have_an_initializer_because_it_is_marked_abstract, declarationNameToString(node.name));
	      }
	    }
	    function checkPropertySignature(node) {
	      if (isPrivateIdentifier(node.name)) {
	        error2(node, Diagnostics.Private_identifiers_are_not_allowed_outside_class_bodies);
	      }
	      return checkPropertyDeclaration(node);
	    }
	    function checkMethodDeclaration(node) {
	      if (!checkGrammarMethod(node))
	        checkGrammarComputedPropertyName(node.name);
	      if (isMethodDeclaration(node) && node.asteriskToken && isIdentifier(node.name) && idText(node.name) === "constructor") {
	        error2(node.name, Diagnostics.Class_constructor_may_not_be_a_generator);
	      }
	      checkFunctionOrMethodDeclaration(node);
	      if (hasSyntacticModifier(node, 64 /* Abstract */) && node.kind === 174 /* MethodDeclaration */ && node.body) {
	        error2(node, Diagnostics.Method_0_cannot_have_an_implementation_because_it_is_marked_abstract, declarationNameToString(node.name));
	      }
	      if (isPrivateIdentifier(node.name) && !getContainingClass(node)) {
	        error2(node, Diagnostics.Private_identifiers_are_not_allowed_outside_class_bodies);
	      }
	      setNodeLinksForPrivateIdentifierScope(node);
	    }
	    function setNodeLinksForPrivateIdentifierScope(node) {
	      if (isPrivateIdentifier(node.name) && languageVersion < 99 /* ESNext */) {
	        for (let lexicalScope = getEnclosingBlockScopeContainer(node); !!lexicalScope; lexicalScope = getEnclosingBlockScopeContainer(lexicalScope)) {
	          getNodeLinks(lexicalScope).flags |= 1048576 /* ContainsClassWithPrivateIdentifiers */;
	        }
	        if (isClassExpression(node.parent)) {
	          const enclosingIterationStatement = getEnclosingIterationStatement(node.parent);
	          if (enclosingIterationStatement) {
	            getNodeLinks(node.name).flags |= 32768 /* BlockScopedBindingInLoop */;
	            getNodeLinks(enclosingIterationStatement).flags |= 4096 /* LoopWithCapturedBlockScopedBinding */;
	          }
	        }
	      }
	    }
	    function checkClassStaticBlockDeclaration(node) {
	      checkGrammarModifiers(node);
	      forEachChild(node, checkSourceElement);
	    }
	    function checkConstructorDeclaration(node) {
	      checkSignatureDeclaration(node);
	      if (!checkGrammarConstructorTypeParameters(node))
	        checkGrammarConstructorTypeAnnotation(node);
	      checkSourceElement(node.body);
	      const symbol = getSymbolOfDeclaration(node);
	      const firstDeclaration = getDeclarationOfKind(symbol, node.kind);
	      if (node === firstDeclaration) {
	        checkFunctionOrConstructorSymbol(symbol);
	      }
	      if (nodeIsMissing(node.body)) {
	        return;
	      }
	      addLazyDiagnostic(checkConstructorDeclarationDiagnostics);
	      return;
	      function isInstancePropertyWithInitializerOrPrivateIdentifierProperty(n) {
	        if (isPrivateIdentifierClassElementDeclaration(n)) {
	          return true;
	        }
	        return n.kind === 172 /* PropertyDeclaration */ && !isStatic(n) && !!n.initializer;
	      }
	      function checkConstructorDeclarationDiagnostics() {
	        const containingClassDecl = node.parent;
	        if (getClassExtendsHeritageElement(containingClassDecl)) {
	          captureLexicalThis(node.parent, containingClassDecl);
	          const classExtendsNull = classDeclarationExtendsNull(containingClassDecl);
	          const superCall = findFirstSuperCall(node.body);
	          if (superCall) {
	            if (classExtendsNull) {
	              error2(superCall, Diagnostics.A_constructor_cannot_contain_a_super_call_when_its_class_extends_null);
	            }
	            const superCallShouldBeRootLevel = !emitStandardClassFields && (some(node.parent.members, isInstancePropertyWithInitializerOrPrivateIdentifierProperty) || some(node.parameters, (p) => hasSyntacticModifier(p, 31 /* ParameterPropertyModifier */)));
	            if (superCallShouldBeRootLevel) {
	              if (!superCallIsRootLevelInConstructor(superCall, node.body)) {
	                error2(superCall, Diagnostics.A_super_call_must_be_a_root_level_statement_within_a_constructor_of_a_derived_class_that_contains_initialized_properties_parameter_properties_or_private_identifiers);
	              } else {
	                let superCallStatement;
	                for (const statement of node.body.statements) {
	                  if (isExpressionStatement(statement) && isSuperCall(skipOuterExpressions(statement.expression))) {
	                    superCallStatement = statement;
	                    break;
	                  }
	                  if (nodeImmediatelyReferencesSuperOrThis(statement)) {
	                    break;
	                  }
	                }
	                if (superCallStatement === void 0) {
	                  error2(node, Diagnostics.A_super_call_must_be_the_first_statement_in_the_constructor_to_refer_to_super_or_this_when_a_derived_class_contains_initialized_properties_parameter_properties_or_private_identifiers);
	                }
	              }
	            }
	          } else if (!classExtendsNull) {
	            error2(node, Diagnostics.Constructors_for_derived_classes_must_contain_a_super_call);
	          }
	        }
	      }
	    }
	    function superCallIsRootLevelInConstructor(superCall, body) {
	      const superCallParent = walkUpParenthesizedExpressions(superCall.parent);
	      return isExpressionStatement(superCallParent) && superCallParent.parent === body;
	    }
	    function nodeImmediatelyReferencesSuperOrThis(node) {
	      if (node.kind === 108 /* SuperKeyword */ || node.kind === 110 /* ThisKeyword */) {
	        return true;
	      }
	      if (isThisContainerOrFunctionBlock(node)) {
	        return false;
	      }
	      return !!forEachChild(node, nodeImmediatelyReferencesSuperOrThis);
	    }
	    function checkAccessorDeclaration(node) {
	      if (isIdentifier(node.name) && idText(node.name) === "constructor" && isClassLike(node.parent)) {
	        error2(node.name, Diagnostics.Class_constructor_may_not_be_an_accessor);
	      }
	      addLazyDiagnostic(checkAccessorDeclarationDiagnostics);
	      checkSourceElement(node.body);
	      setNodeLinksForPrivateIdentifierScope(node);
	      function checkAccessorDeclarationDiagnostics() {
	        if (!checkGrammarFunctionLikeDeclaration(node) && !checkGrammarAccessor(node))
	          checkGrammarComputedPropertyName(node.name);
	        checkDecorators(node);
	        checkSignatureDeclaration(node);
	        if (node.kind === 177 /* GetAccessor */) {
	          if (!(node.flags & 33554432 /* Ambient */) && nodeIsPresent(node.body) && node.flags & 512 /* HasImplicitReturn */) {
	            if (!(node.flags & 1024 /* HasExplicitReturn */)) {
	              error2(node.name, Diagnostics.A_get_accessor_must_return_a_value);
	            }
	          }
	        }
	        if (node.name.kind === 167 /* ComputedPropertyName */) {
	          checkComputedPropertyName(node.name);
	        }
	        if (hasBindableName(node)) {
	          const symbol = getSymbolOfDeclaration(node);
	          const getter = getDeclarationOfKind(symbol, 177 /* GetAccessor */);
	          const setter = getDeclarationOfKind(symbol, 178 /* SetAccessor */);
	          if (getter && setter && !(getNodeCheckFlags(getter) & 1 /* TypeChecked */)) {
	            getNodeLinks(getter).flags |= 1 /* TypeChecked */;
	            const getterFlags = getEffectiveModifierFlags(getter);
	            const setterFlags = getEffectiveModifierFlags(setter);
	            if ((getterFlags & 64 /* Abstract */) !== (setterFlags & 64 /* Abstract */)) {
	              error2(getter.name, Diagnostics.Accessors_must_both_be_abstract_or_non_abstract);
	              error2(setter.name, Diagnostics.Accessors_must_both_be_abstract_or_non_abstract);
	            }
	            if (getterFlags & 4 /* Protected */ && !(setterFlags & (4 /* Protected */ | 2 /* Private */)) || getterFlags & 2 /* Private */ && !(setterFlags & 2 /* Private */)) {
	              error2(getter.name, Diagnostics.A_get_accessor_must_be_at_least_as_accessible_as_the_setter);
	              error2(setter.name, Diagnostics.A_get_accessor_must_be_at_least_as_accessible_as_the_setter);
	            }
	          }
	        }
	        const returnType = getTypeOfAccessors(getSymbolOfDeclaration(node));
	        if (node.kind === 177 /* GetAccessor */) {
	          checkAllCodePathsInNonVoidFunctionReturnOrThrow(node, returnType);
	        }
	      }
	    }
	    function checkMissingDeclaration(node) {
	      checkDecorators(node);
	    }
	    function getEffectiveTypeArgumentAtIndex(node, typeParameters, index) {
	      if (node.typeArguments && index < node.typeArguments.length) {
	        return getTypeFromTypeNode(node.typeArguments[index]);
	      }
	      return getEffectiveTypeArguments2(node, typeParameters)[index];
	    }
	    function getEffectiveTypeArguments2(node, typeParameters) {
	      return fillMissingTypeArguments(map(node.typeArguments, getTypeFromTypeNode), typeParameters, getMinTypeArgumentCount(typeParameters), isInJSFile(node));
	    }
	    function checkTypeArgumentConstraints(node, typeParameters) {
	      let typeArguments;
	      let mapper;
	      let result = true;
	      for (let i = 0; i < typeParameters.length; i++) {
	        const constraint = getConstraintOfTypeParameter(typeParameters[i]);
	        if (constraint) {
	          if (!typeArguments) {
	            typeArguments = getEffectiveTypeArguments2(node, typeParameters);
	            mapper = createTypeMapper(typeParameters, typeArguments);
	          }
	          result = result && checkTypeAssignableTo(
	            typeArguments[i],
	            instantiateType(constraint, mapper),
	            node.typeArguments[i],
	            Diagnostics.Type_0_does_not_satisfy_the_constraint_1
	          );
	        }
	      }
	      return result;
	    }
	    function getTypeParametersForTypeAndSymbol(type, symbol) {
	      if (!isErrorType(type)) {
	        return symbol.flags & 524288 /* TypeAlias */ && getSymbolLinks(symbol).typeParameters || (getObjectFlags(type) & 4 /* Reference */ ? type.target.localTypeParameters : void 0);
	      }
	      return void 0;
	    }
	    function getTypeParametersForTypeReferenceOrImport(node) {
	      const type = getTypeFromTypeNode(node);
	      if (!isErrorType(type)) {
	        const symbol = getNodeLinks(node).resolvedSymbol;
	        if (symbol) {
	          return getTypeParametersForTypeAndSymbol(type, symbol);
	        }
	      }
	      return void 0;
	    }
	    function checkTypeReferenceNode(node) {
	      checkGrammarTypeArguments(node, node.typeArguments);
	      if (node.kind === 183 /* TypeReference */ && !isInJSFile(node) && !isInJSDoc(node) && node.typeArguments && node.typeName.end !== node.typeArguments.pos) {
	        const sourceFile = getSourceFileOfNode(node);
	        if (scanTokenAtPosition(sourceFile, node.typeName.end) === 25 /* DotToken */) {
	          grammarErrorAtPos(node, skipTrivia(sourceFile.text, node.typeName.end), 1, Diagnostics.JSDoc_types_can_only_be_used_inside_documentation_comments);
	        }
	      }
	      forEach(node.typeArguments, checkSourceElement);
	      checkTypeReferenceOrImport(node);
	    }
	    function checkTypeReferenceOrImport(node) {
	      const type = getTypeFromTypeNode(node);
	      if (!isErrorType(type)) {
	        if (node.typeArguments) {
	          addLazyDiagnostic(() => {
	            const typeParameters = getTypeParametersForTypeReferenceOrImport(node);
	            if (typeParameters) {
	              checkTypeArgumentConstraints(node, typeParameters);
	            }
	          });
	        }
	        const symbol = getNodeLinks(node).resolvedSymbol;
	        if (symbol) {
	          if (some(symbol.declarations, (d) => isTypeDeclaration(d) && !!(d.flags & 536870912 /* Deprecated */))) {
	            addDeprecatedSuggestion(
	              getDeprecatedSuggestionNode(node),
	              symbol.declarations,
	              symbol.escapedName
	            );
	          }
	        }
	      }
	    }
	    function getTypeArgumentConstraint(node) {
	      const typeReferenceNode = tryCast(node.parent, isTypeReferenceType);
	      if (!typeReferenceNode)
	        return void 0;
	      const typeParameters = getTypeParametersForTypeReferenceOrImport(typeReferenceNode);
	      if (!typeParameters)
	        return void 0;
	      const constraint = getConstraintOfTypeParameter(typeParameters[typeReferenceNode.typeArguments.indexOf(node)]);
	      return constraint && instantiateType(constraint, createTypeMapper(typeParameters, getEffectiveTypeArguments2(typeReferenceNode, typeParameters)));
	    }
	    function checkTypeQuery(node) {
	      getTypeFromTypeQueryNode(node);
	    }
	    function checkTypeLiteral(node) {
	      forEach(node.members, checkSourceElement);
	      addLazyDiagnostic(checkTypeLiteralDiagnostics);
	      function checkTypeLiteralDiagnostics() {
	        const type = getTypeFromTypeLiteralOrFunctionOrConstructorTypeNode(node);
	        checkIndexConstraints(type, type.symbol);
	        checkTypeForDuplicateIndexSignatures(node);
	        checkObjectTypeForDuplicateDeclarations(node);
	      }
	    }
	    function checkArrayType(node) {
	      checkSourceElement(node.elementType);
	    }
	    function checkTupleType(node) {
	      let seenOptionalElement = false;
	      let seenRestElement = false;
	      for (const e of node.elements) {
	        let flags = getTupleElementFlags(e);
	        if (flags & 8 /* Variadic */) {
	          const type = getTypeFromTypeNode(e.type);
	          if (!isArrayLikeType(type)) {
	            error2(e, Diagnostics.A_rest_element_type_must_be_an_array_type);
	            break;
	          }
	          if (isArrayType(type) || isTupleType(type) && type.target.combinedFlags & 4 /* Rest */) {
	            flags |= 4 /* Rest */;
	          }
	        }
	        if (flags & 4 /* Rest */) {
	          if (seenRestElement) {
	            grammarErrorOnNode(e, Diagnostics.A_rest_element_cannot_follow_another_rest_element);
	            break;
	          }
	          seenRestElement = true;
	        } else if (flags & 2 /* Optional */) {
	          if (seenRestElement) {
	            grammarErrorOnNode(e, Diagnostics.An_optional_element_cannot_follow_a_rest_element);
	            break;
	          }
	          seenOptionalElement = true;
	        } else if (flags & 1 /* Required */ && seenOptionalElement) {
	          grammarErrorOnNode(e, Diagnostics.A_required_element_cannot_follow_an_optional_element);
	          break;
	        }
	      }
	      forEach(node.elements, checkSourceElement);
	      getTypeFromTypeNode(node);
	    }
	    function checkUnionOrIntersectionType(node) {
	      forEach(node.types, checkSourceElement);
	      getTypeFromTypeNode(node);
	    }
	    function checkIndexedAccessIndexType(type, accessNode) {
	      if (!(type.flags & 8388608 /* IndexedAccess */)) {
	        return type;
	      }
	      const objectType = type.objectType;
	      const indexType = type.indexType;
	      const objectIndexType = isGenericMappedType(objectType) && getMappedTypeNameTypeKind(objectType) === 2 /* Remapping */ ? getIndexTypeForMappedType(objectType, 0 /* None */) : getIndexType(objectType, 0 /* None */);
	      const hasNumberIndexInfo = !!getIndexInfoOfType(objectType, numberType);
	      if (everyType(indexType, (t) => isTypeAssignableTo(t, objectIndexType) || hasNumberIndexInfo && isApplicableIndexType(t, numberType))) {
	        if (accessNode.kind === 212 /* ElementAccessExpression */ && isAssignmentTarget(accessNode) && getObjectFlags(objectType) & 32 /* Mapped */ && getMappedTypeModifiers(objectType) & 1 /* IncludeReadonly */) {
	          error2(accessNode, Diagnostics.Index_signature_in_type_0_only_permits_reading, typeToString(objectType));
	        }
	        return type;
	      }
	      if (isGenericObjectType(objectType)) {
	        const propertyName = getPropertyNameFromIndex(indexType, accessNode);
	        if (propertyName) {
	          const propertySymbol = forEachType(getApparentType(objectType), (t) => getPropertyOfType(t, propertyName));
	          if (propertySymbol && getDeclarationModifierFlagsFromSymbol(propertySymbol) & 6 /* NonPublicAccessibilityModifier */) {
	            error2(accessNode, Diagnostics.Private_or_protected_member_0_cannot_be_accessed_on_a_type_parameter, unescapeLeadingUnderscores(propertyName));
	            return errorType;
	          }
	        }
	      }
	      error2(accessNode, Diagnostics.Type_0_cannot_be_used_to_index_type_1, typeToString(indexType), typeToString(objectType));
	      return errorType;
	    }
	    function checkIndexedAccessType(node) {
	      checkSourceElement(node.objectType);
	      checkSourceElement(node.indexType);
	      checkIndexedAccessIndexType(getTypeFromIndexedAccessTypeNode(node), node);
	    }
	    function checkMappedType(node) {
	      checkGrammarMappedType(node);
	      checkSourceElement(node.typeParameter);
	      checkSourceElement(node.nameType);
	      checkSourceElement(node.type);
	      if (!node.type) {
	        reportImplicitAny(node, anyType);
	      }
	      const type = getTypeFromMappedTypeNode(node);
	      const nameType = getNameTypeFromMappedType(type);
	      if (nameType) {
	        checkTypeAssignableTo(nameType, keyofConstraintType, node.nameType);
	      } else {
	        const constraintType = getConstraintTypeFromMappedType(type);
	        checkTypeAssignableTo(constraintType, keyofConstraintType, getEffectiveConstraintOfTypeParameter(node.typeParameter));
	      }
	    }
	    function checkGrammarMappedType(node) {
	      var _a;
	      if ((_a = node.members) == null ? void 0 : _a.length) {
	        return grammarErrorOnNode(node.members[0], Diagnostics.A_mapped_type_may_not_declare_properties_or_methods);
	      }
	    }
	    function checkThisType(node) {
	      getTypeFromThisTypeNode(node);
	    }
	    function checkTypeOperator(node) {
	      checkGrammarTypeOperatorNode(node);
	      checkSourceElement(node.type);
	    }
	    function checkConditionalType(node) {
	      forEachChild(node, checkSourceElement);
	    }
	    function checkInferType(node) {
	      if (!findAncestor(node, (n) => n.parent && n.parent.kind === 194 /* ConditionalType */ && n.parent.extendsType === n)) {
	        grammarErrorOnNode(node, Diagnostics.infer_declarations_are_only_permitted_in_the_extends_clause_of_a_conditional_type);
	      }
	      checkSourceElement(node.typeParameter);
	      const symbol = getSymbolOfDeclaration(node.typeParameter);
	      if (symbol.declarations && symbol.declarations.length > 1) {
	        const links = getSymbolLinks(symbol);
	        if (!links.typeParametersChecked) {
	          links.typeParametersChecked = true;
	          const typeParameter = getDeclaredTypeOfTypeParameter(symbol);
	          const declarations = getDeclarationsOfKind(symbol, 168 /* TypeParameter */);
	          if (!areTypeParametersIdentical(declarations, [typeParameter], (decl) => [decl])) {
	            const name = symbolToString(symbol);
	            for (const declaration of declarations) {
	              error2(declaration.name, Diagnostics.All_declarations_of_0_must_have_identical_constraints, name);
	            }
	          }
	        }
	      }
	      registerForUnusedIdentifiersCheck(node);
	    }
	    function checkTemplateLiteralType(node) {
	      for (const span of node.templateSpans) {
	        checkSourceElement(span.type);
	        const type = getTypeFromTypeNode(span.type);
	        checkTypeAssignableTo(type, templateConstraintType, span.type);
	      }
	      getTypeFromTypeNode(node);
	    }
	    function checkImportType(node) {
	      checkSourceElement(node.argument);
	      if (node.attributes) {
	        getResolutionModeOverride(node.attributes, grammarErrorOnNode);
	      }
	      checkTypeReferenceOrImport(node);
	    }
	    function checkNamedTupleMember(node) {
	      if (node.dotDotDotToken && node.questionToken) {
	        grammarErrorOnNode(node, Diagnostics.A_tuple_member_cannot_be_both_optional_and_rest);
	      }
	      if (node.type.kind === 190 /* OptionalType */) {
	        grammarErrorOnNode(node.type, Diagnostics.A_labeled_tuple_element_is_declared_as_optional_with_a_question_mark_after_the_name_and_before_the_colon_rather_than_after_the_type);
	      }
	      if (node.type.kind === 191 /* RestType */) {
	        grammarErrorOnNode(node.type, Diagnostics.A_labeled_tuple_element_is_declared_as_rest_with_a_before_the_name_rather_than_before_the_type);
	      }
	      checkSourceElement(node.type);
	      getTypeFromTypeNode(node);
	    }
	    function isPrivateWithinAmbient(node) {
	      return (hasEffectiveModifier(node, 2 /* Private */) || isPrivateIdentifierClassElementDeclaration(node)) && !!(node.flags & 33554432 /* Ambient */);
	    }
	    function getEffectiveDeclarationFlags(n, flagsToCheck) {
	      let flags = getCombinedModifierFlagsCached(n);
	      if (n.parent.kind !== 264 /* InterfaceDeclaration */ && n.parent.kind !== 263 /* ClassDeclaration */ && n.parent.kind !== 231 /* ClassExpression */ && n.flags & 33554432 /* Ambient */) {
	        const container = getEnclosingContainer(n);
	        if (container && container.flags & 128 /* ExportContext */ && !(flags & 128 /* Ambient */) && !(isModuleBlock(n.parent) && isModuleDeclaration(n.parent.parent) && isGlobalScopeAugmentation(n.parent.parent))) {
	          flags |= 32 /* Export */;
	        }
	        flags |= 128 /* Ambient */;
	      }
	      return flags & flagsToCheck;
	    }
	    function checkFunctionOrConstructorSymbol(symbol) {
	      addLazyDiagnostic(() => checkFunctionOrConstructorSymbolWorker(symbol));
	    }
	    function checkFunctionOrConstructorSymbolWorker(symbol) {
	      function getCanonicalOverload(overloads, implementation) {
	        const implementationSharesContainerWithFirstOverload = implementation !== void 0 && implementation.parent === overloads[0].parent;
	        return implementationSharesContainerWithFirstOverload ? implementation : overloads[0];
	      }
	      function checkFlagAgreementBetweenOverloads(overloads, implementation, flagsToCheck2, someOverloadFlags, allOverloadFlags) {
	        const someButNotAllOverloadFlags = someOverloadFlags ^ allOverloadFlags;
	        if (someButNotAllOverloadFlags !== 0) {
	          const canonicalFlags = getEffectiveDeclarationFlags(getCanonicalOverload(overloads, implementation), flagsToCheck2);
	          forEach(overloads, (o) => {
	            const deviation = getEffectiveDeclarationFlags(o, flagsToCheck2) ^ canonicalFlags;
	            if (deviation & 32 /* Export */) {
	              error2(getNameOfDeclaration(o), Diagnostics.Overload_signatures_must_all_be_exported_or_non_exported);
	            } else if (deviation & 128 /* Ambient */) {
	              error2(getNameOfDeclaration(o), Diagnostics.Overload_signatures_must_all_be_ambient_or_non_ambient);
	            } else if (deviation & (2 /* Private */ | 4 /* Protected */)) {
	              error2(getNameOfDeclaration(o) || o, Diagnostics.Overload_signatures_must_all_be_public_private_or_protected);
	            } else if (deviation & 64 /* Abstract */) {
	              error2(getNameOfDeclaration(o), Diagnostics.Overload_signatures_must_all_be_abstract_or_non_abstract);
	            }
	          });
	        }
	      }
	      function checkQuestionTokenAgreementBetweenOverloads(overloads, implementation, someHaveQuestionToken2, allHaveQuestionToken2) {
	        if (someHaveQuestionToken2 !== allHaveQuestionToken2) {
	          const canonicalHasQuestionToken = hasQuestionToken(getCanonicalOverload(overloads, implementation));
	          forEach(overloads, (o) => {
	            const deviation = hasQuestionToken(o) !== canonicalHasQuestionToken;
	            if (deviation) {
	              error2(getNameOfDeclaration(o), Diagnostics.Overload_signatures_must_all_be_optional_or_required);
	            }
	          });
	        }
	      }
	      const flagsToCheck = 32 /* Export */ | 128 /* Ambient */ | 2 /* Private */ | 4 /* Protected */ | 64 /* Abstract */;
	      let someNodeFlags = 0 /* None */;
	      let allNodeFlags = flagsToCheck;
	      let someHaveQuestionToken = false;
	      let allHaveQuestionToken = true;
	      let hasOverloads = false;
	      let bodyDeclaration;
	      let lastSeenNonAmbientDeclaration;
	      let previousDeclaration;
	      const declarations = symbol.declarations;
	      const isConstructor = (symbol.flags & 16384 /* Constructor */) !== 0;
	      function reportImplementationExpectedError(node) {
	        if (node.name && nodeIsMissing(node.name)) {
	          return;
	        }
	        let seen = false;
	        const subsequentNode = forEachChild(node.parent, (c) => {
	          if (seen) {
	            return c;
	          } else {
	            seen = c === node;
	          }
	        });
	        if (subsequentNode && subsequentNode.pos === node.end) {
	          if (subsequentNode.kind === node.kind) {
	            const errorNode2 = subsequentNode.name || subsequentNode;
	            const subsequentName = subsequentNode.name;
	            if (node.name && subsequentName && // both are private identifiers
	            (isPrivateIdentifier(node.name) && isPrivateIdentifier(subsequentName) && node.name.escapedText === subsequentName.escapedText || // Both are computed property names
	            isComputedPropertyName(node.name) && isComputedPropertyName(subsequentName) && isTypeIdenticalTo(checkComputedPropertyName(node.name), checkComputedPropertyName(subsequentName)) || // Both are literal property names that are the same.
	            isPropertyNameLiteral(node.name) && isPropertyNameLiteral(subsequentName) && getEscapedTextOfIdentifierOrLiteral(node.name) === getEscapedTextOfIdentifierOrLiteral(subsequentName))) {
	              const reportError = (node.kind === 174 /* MethodDeclaration */ || node.kind === 173 /* MethodSignature */) && isStatic(node) !== isStatic(subsequentNode);
	              if (reportError) {
	                const diagnostic = isStatic(node) ? Diagnostics.Function_overload_must_be_static : Diagnostics.Function_overload_must_not_be_static;
	                error2(errorNode2, diagnostic);
	              }
	              return;
	            }
	            if (nodeIsPresent(subsequentNode.body)) {
	              error2(errorNode2, Diagnostics.Function_implementation_name_must_be_0, declarationNameToString(node.name));
	              return;
	            }
	          }
	        }
	        const errorNode = node.name || node;
	        if (isConstructor) {
	          error2(errorNode, Diagnostics.Constructor_implementation_is_missing);
	        } else {
	          if (hasSyntacticModifier(node, 64 /* Abstract */)) {
	            error2(errorNode, Diagnostics.All_declarations_of_an_abstract_method_must_be_consecutive);
	          } else {
	            error2(errorNode, Diagnostics.Function_implementation_is_missing_or_not_immediately_following_the_declaration);
	          }
	        }
	      }
	      let duplicateFunctionDeclaration = false;
	      let multipleConstructorImplementation = false;
	      let hasNonAmbientClass = false;
	      const functionDeclarations = [];
	      if (declarations) {
	        for (const current of declarations) {
	          const node = current;
	          const inAmbientContext = node.flags & 33554432 /* Ambient */;
	          const inAmbientContextOrInterface = node.parent && (node.parent.kind === 264 /* InterfaceDeclaration */ || node.parent.kind === 187 /* TypeLiteral */) || inAmbientContext;
	          if (inAmbientContextOrInterface) {
	            previousDeclaration = void 0;
	          }
	          if ((node.kind === 263 /* ClassDeclaration */ || node.kind === 231 /* ClassExpression */) && !inAmbientContext) {
	            hasNonAmbientClass = true;
	          }
	          if (node.kind === 262 /* FunctionDeclaration */ || node.kind === 174 /* MethodDeclaration */ || node.kind === 173 /* MethodSignature */ || node.kind === 176 /* Constructor */) {
	            functionDeclarations.push(node);
	            const currentNodeFlags = getEffectiveDeclarationFlags(node, flagsToCheck);
	            someNodeFlags |= currentNodeFlags;
	            allNodeFlags &= currentNodeFlags;
	            someHaveQuestionToken = someHaveQuestionToken || hasQuestionToken(node);
	            allHaveQuestionToken = allHaveQuestionToken && hasQuestionToken(node);
	            const bodyIsPresent = nodeIsPresent(node.body);
	            if (bodyIsPresent && bodyDeclaration) {
	              if (isConstructor) {
	                multipleConstructorImplementation = true;
	              } else {
	                duplicateFunctionDeclaration = true;
	              }
	            } else if ((previousDeclaration == null ? void 0 : previousDeclaration.parent) === node.parent && previousDeclaration.end !== node.pos) {
	              reportImplementationExpectedError(previousDeclaration);
	            }
	            if (bodyIsPresent) {
	              if (!bodyDeclaration) {
	                bodyDeclaration = node;
	              }
	            } else {
	              hasOverloads = true;
	            }
	            previousDeclaration = node;
	            if (!inAmbientContextOrInterface) {
	              lastSeenNonAmbientDeclaration = node;
	            }
	          }
	          if (isInJSFile(current) && isFunctionLike(current) && current.jsDoc) {
	            hasOverloads = length(getJSDocOverloadTags(current)) > 0;
	          }
	        }
	      }
	      if (multipleConstructorImplementation) {
	        forEach(functionDeclarations, (declaration) => {
	          error2(declaration, Diagnostics.Multiple_constructor_implementations_are_not_allowed);
	        });
	      }
	      if (duplicateFunctionDeclaration) {
	        forEach(functionDeclarations, (declaration) => {
	          error2(getNameOfDeclaration(declaration) || declaration, Diagnostics.Duplicate_function_implementation);
	        });
	      }
	      if (hasNonAmbientClass && !isConstructor && symbol.flags & 16 /* Function */ && declarations) {
	        const relatedDiagnostics = filter(declarations, (d) => d.kind === 263 /* ClassDeclaration */).map((d) => createDiagnosticForNode(d, Diagnostics.Consider_adding_a_declare_modifier_to_this_class));
	        forEach(declarations, (declaration) => {
	          const diagnostic = declaration.kind === 263 /* ClassDeclaration */ ? Diagnostics.Class_declaration_cannot_implement_overload_list_for_0 : declaration.kind === 262 /* FunctionDeclaration */ ? Diagnostics.Function_with_bodies_can_only_merge_with_classes_that_are_ambient : void 0;
	          if (diagnostic) {
	            addRelatedInfo(
	              error2(getNameOfDeclaration(declaration) || declaration, diagnostic, symbolName(symbol)),
	              ...relatedDiagnostics
	            );
	          }
	        });
	      }
	      if (lastSeenNonAmbientDeclaration && !lastSeenNonAmbientDeclaration.body && !hasSyntacticModifier(lastSeenNonAmbientDeclaration, 64 /* Abstract */) && !lastSeenNonAmbientDeclaration.questionToken) {
	        reportImplementationExpectedError(lastSeenNonAmbientDeclaration);
	      }
	      if (hasOverloads) {
	        if (declarations) {
	          checkFlagAgreementBetweenOverloads(declarations, bodyDeclaration, flagsToCheck, someNodeFlags, allNodeFlags);
	          checkQuestionTokenAgreementBetweenOverloads(declarations, bodyDeclaration, someHaveQuestionToken, allHaveQuestionToken);
	        }
	        if (bodyDeclaration) {
	          const signatures = getSignaturesOfSymbol(symbol);
	          const bodySignature = getSignatureFromDeclaration(bodyDeclaration);
	          for (const signature of signatures) {
	            if (!isImplementationCompatibleWithOverload(bodySignature, signature)) {
	              const errorNode = signature.declaration && isJSDocSignature(signature.declaration) ? signature.declaration.parent.tagName : signature.declaration;
	              addRelatedInfo(
	                error2(errorNode, Diagnostics.This_overload_signature_is_not_compatible_with_its_implementation_signature),
	                createDiagnosticForNode(bodyDeclaration, Diagnostics.The_implementation_signature_is_declared_here)
	              );
	              break;
	            }
	          }
	        }
	      }
	    }
	    function checkExportsOnMergedDeclarations(node) {
	      addLazyDiagnostic(() => checkExportsOnMergedDeclarationsWorker(node));
	    }
	    function checkExportsOnMergedDeclarationsWorker(node) {
	      let symbol = node.localSymbol;
	      if (!symbol) {
	        symbol = getSymbolOfDeclaration(node);
	        if (!symbol.exportSymbol) {
	          return;
	        }
	      }
	      if (getDeclarationOfKind(symbol, node.kind) !== node) {
	        return;
	      }
	      let exportedDeclarationSpaces = 0 /* None */;
	      let nonExportedDeclarationSpaces = 0 /* None */;
	      let defaultExportedDeclarationSpaces = 0 /* None */;
	      for (const d of symbol.declarations) {
	        const declarationSpaces = getDeclarationSpaces(d);
	        const effectiveDeclarationFlags = getEffectiveDeclarationFlags(d, 32 /* Export */ | 2048 /* Default */);
	        if (effectiveDeclarationFlags & 32 /* Export */) {
	          if (effectiveDeclarationFlags & 2048 /* Default */) {
	            defaultExportedDeclarationSpaces |= declarationSpaces;
	          } else {
	            exportedDeclarationSpaces |= declarationSpaces;
	          }
	        } else {
	          nonExportedDeclarationSpaces |= declarationSpaces;
	        }
	      }
	      const nonDefaultExportedDeclarationSpaces = exportedDeclarationSpaces | nonExportedDeclarationSpaces;
	      const commonDeclarationSpacesForExportsAndLocals = exportedDeclarationSpaces & nonExportedDeclarationSpaces;
	      const commonDeclarationSpacesForDefaultAndNonDefault = defaultExportedDeclarationSpaces & nonDefaultExportedDeclarationSpaces;
	      if (commonDeclarationSpacesForExportsAndLocals || commonDeclarationSpacesForDefaultAndNonDefault) {
	        for (const d of symbol.declarations) {
	          const declarationSpaces = getDeclarationSpaces(d);
	          const name = getNameOfDeclaration(d);
	          if (declarationSpaces & commonDeclarationSpacesForDefaultAndNonDefault) {
	            error2(name, Diagnostics.Merged_declaration_0_cannot_include_a_default_export_declaration_Consider_adding_a_separate_export_default_0_declaration_instead, declarationNameToString(name));
	          } else if (declarationSpaces & commonDeclarationSpacesForExportsAndLocals) {
	            error2(name, Diagnostics.Individual_declarations_in_merged_declaration_0_must_be_all_exported_or_all_local, declarationNameToString(name));
	          }
	        }
	      }
	      function getDeclarationSpaces(decl) {
	        let d = decl;
	        switch (d.kind) {
	          case 264 /* InterfaceDeclaration */:
	          case 265 /* TypeAliasDeclaration */:
	          case 353 /* JSDocTypedefTag */:
	          case 345 /* JSDocCallbackTag */:
	          case 347 /* JSDocEnumTag */:
	            return 2 /* ExportType */;
	          case 267 /* ModuleDeclaration */:
	            return isAmbientModule(d) || getModuleInstanceState(d) !== 0 /* NonInstantiated */ ? 4 /* ExportNamespace */ | 1 /* ExportValue */ : 4 /* ExportNamespace */;
	          case 263 /* ClassDeclaration */:
	          case 266 /* EnumDeclaration */:
	          case 306 /* EnumMember */:
	            return 2 /* ExportType */ | 1 /* ExportValue */;
	          case 312 /* SourceFile */:
	            return 2 /* ExportType */ | 1 /* ExportValue */ | 4 /* ExportNamespace */;
	          case 277 /* ExportAssignment */:
	          case 226 /* BinaryExpression */:
	            const node2 = d;
	            const expression = isExportAssignment(node2) ? node2.expression : node2.right;
	            if (!isEntityNameExpression(expression)) {
	              return 1 /* ExportValue */;
	            }
	            d = expression;
	          case 271 /* ImportEqualsDeclaration */:
	          case 274 /* NamespaceImport */:
	          case 273 /* ImportClause */:
	            let result = 0 /* None */;
	            const target = resolveAlias(getSymbolOfDeclaration(d));
	            forEach(target.declarations, (d2) => {
	              result |= getDeclarationSpaces(d2);
	            });
	            return result;
	          case 260 /* VariableDeclaration */:
	          case 208 /* BindingElement */:
	          case 262 /* FunctionDeclaration */:
	          case 276 /* ImportSpecifier */:
	          case 80 /* Identifier */:
	            return 1 /* ExportValue */;
	          case 173 /* MethodSignature */:
	          case 171 /* PropertySignature */:
	            return 2 /* ExportType */;
	          default:
	            return Debug.failBadSyntaxKind(d);
	        }
	      }
	    }
	    function getAwaitedTypeOfPromise(type, errorNode, diagnosticMessage, ...args) {
	      const promisedType = getPromisedTypeOfPromise(type, errorNode);
	      return promisedType && getAwaitedType(promisedType, errorNode, diagnosticMessage, ...args);
	    }
	    function getPromisedTypeOfPromise(type, errorNode, thisTypeForErrorOut) {
	      if (isTypeAny(type)) {
	        return void 0;
	      }
	      const typeAsPromise = type;
	      if (typeAsPromise.promisedTypeOfPromise) {
	        return typeAsPromise.promisedTypeOfPromise;
	      }
	      if (isReferenceToType2(type, getGlobalPromiseType(
	        /*reportErrors*/
	        false
	      ))) {
	        return typeAsPromise.promisedTypeOfPromise = getTypeArguments(type)[0];
	      }
	      if (allTypesAssignableToKind(getBaseConstraintOrType(type), 402784252 /* Primitive */ | 131072 /* Never */)) {
	        return void 0;
	      }
	      const thenFunction = getTypeOfPropertyOfType(type, "then");
	      if (isTypeAny(thenFunction)) {
	        return void 0;
	      }
	      const thenSignatures = thenFunction ? getSignaturesOfType(thenFunction, 0 /* Call */) : emptyArray;
	      if (thenSignatures.length === 0) {
	        if (errorNode) {
	          error2(errorNode, Diagnostics.A_promise_must_have_a_then_method);
	        }
	        return void 0;
	      }
	      let thisTypeForError;
	      let candidates;
	      for (const thenSignature of thenSignatures) {
	        const thisType = getThisTypeOfSignature(thenSignature);
	        if (thisType && thisType !== voidType && !isTypeRelatedTo(type, thisType, subtypeRelation)) {
	          thisTypeForError = thisType;
	        } else {
	          candidates = append(candidates, thenSignature);
	        }
	      }
	      if (!candidates) {
	        Debug.assertIsDefined(thisTypeForError);
	        if (thisTypeForErrorOut) {
	          thisTypeForErrorOut.value = thisTypeForError;
	        }
	        if (errorNode) {
	          error2(errorNode, Diagnostics.The_this_context_of_type_0_is_not_assignable_to_method_s_this_of_type_1, typeToString(type), typeToString(thisTypeForError));
	        }
	        return void 0;
	      }
	      const onfulfilledParameterType = getTypeWithFacts(getUnionType(map(candidates, getTypeOfFirstParameterOfSignature)), 2097152 /* NEUndefinedOrNull */);
	      if (isTypeAny(onfulfilledParameterType)) {
	        return void 0;
	      }
	      const onfulfilledParameterSignatures = getSignaturesOfType(onfulfilledParameterType, 0 /* Call */);
	      if (onfulfilledParameterSignatures.length === 0) {
	        if (errorNode) {
	          error2(errorNode, Diagnostics.The_first_parameter_of_the_then_method_of_a_promise_must_be_a_callback);
	        }
	        return void 0;
	      }
	      return typeAsPromise.promisedTypeOfPromise = getUnionType(map(onfulfilledParameterSignatures, getTypeOfFirstParameterOfSignature), 2 /* Subtype */);
	    }
	    function checkAwaitedType(type, withAlias, errorNode, diagnosticMessage, ...args) {
	      const awaitedType = withAlias ? getAwaitedType(type, errorNode, diagnosticMessage, ...args) : getAwaitedTypeNoAlias(type, errorNode, diagnosticMessage, ...args);
	      return awaitedType || errorType;
	    }
	    function isThenableType(type) {
	      if (allTypesAssignableToKind(getBaseConstraintOrType(type), 402784252 /* Primitive */ | 131072 /* Never */)) {
	        return false;
	      }
	      const thenFunction = getTypeOfPropertyOfType(type, "then");
	      return !!thenFunction && getSignaturesOfType(getTypeWithFacts(thenFunction, 2097152 /* NEUndefinedOrNull */), 0 /* Call */).length > 0;
	    }
	    function isAwaitedTypeInstantiation(type) {
	      var _a;
	      if (type.flags & 16777216 /* Conditional */) {
	        const awaitedSymbol = getGlobalAwaitedSymbol(
	          /*reportErrors*/
	          false
	        );
	        return !!awaitedSymbol && type.aliasSymbol === awaitedSymbol && ((_a = type.aliasTypeArguments) == null ? void 0 : _a.length) === 1;
	      }
	      return false;
	    }
	    function unwrapAwaitedType(type) {
	      return type.flags & 1048576 /* Union */ ? mapType(type, unwrapAwaitedType) : isAwaitedTypeInstantiation(type) ? type.aliasTypeArguments[0] : type;
	    }
	    function isAwaitedTypeNeeded(type) {
	      if (isTypeAny(type) || isAwaitedTypeInstantiation(type)) {
	        return false;
	      }
	      if (isGenericObjectType(type)) {
	        const baseConstraint = getBaseConstraintOfType(type);
	        if (baseConstraint ? baseConstraint.flags & 3 /* AnyOrUnknown */ || isEmptyObjectType(baseConstraint) || someType(baseConstraint, isThenableType) : maybeTypeOfKind(type, 8650752 /* TypeVariable */)) {
	          return true;
	        }
	      }
	      return false;
	    }
	    function tryCreateAwaitedType(type) {
	      const awaitedSymbol = getGlobalAwaitedSymbol(
	        /*reportErrors*/
	        true
	      );
	      if (awaitedSymbol) {
	        return getTypeAliasInstantiation(awaitedSymbol, [unwrapAwaitedType(type)]);
	      }
	      return void 0;
	    }
	    function createAwaitedTypeIfNeeded(type) {
	      if (isAwaitedTypeNeeded(type)) {
	        const awaitedType = tryCreateAwaitedType(type);
	        if (awaitedType) {
	          return awaitedType;
	        }
	      }
	      Debug.assert(isAwaitedTypeInstantiation(type) || getPromisedTypeOfPromise(type) === void 0, "type provided should not be a non-generic 'promise'-like.");
	      return type;
	    }
	    function getAwaitedType(type, errorNode, diagnosticMessage, ...args) {
	      const awaitedType = getAwaitedTypeNoAlias(type, errorNode, diagnosticMessage, ...args);
	      return awaitedType && createAwaitedTypeIfNeeded(awaitedType);
	    }
	    function getAwaitedTypeNoAlias(type, errorNode, diagnosticMessage, ...args) {
	      if (isTypeAny(type)) {
	        return type;
	      }
	      if (isAwaitedTypeInstantiation(type)) {
	        return type;
	      }
	      const typeAsAwaitable = type;
	      if (typeAsAwaitable.awaitedTypeOfType) {
	        return typeAsAwaitable.awaitedTypeOfType;
	      }
	      if (type.flags & 1048576 /* Union */) {
	        if (awaitedTypeStack.lastIndexOf(type.id) >= 0) {
	          if (errorNode) {
	            error2(errorNode, Diagnostics.Type_is_referenced_directly_or_indirectly_in_the_fulfillment_callback_of_its_own_then_method);
	          }
	          return void 0;
	        }
	        const mapper = errorNode ? (constituentType) => getAwaitedTypeNoAlias(constituentType, errorNode, diagnosticMessage, ...args) : getAwaitedTypeNoAlias;
	        awaitedTypeStack.push(type.id);
	        const mapped = mapType(type, mapper);
	        awaitedTypeStack.pop();
	        return typeAsAwaitable.awaitedTypeOfType = mapped;
	      }
	      if (isAwaitedTypeNeeded(type)) {
	        return typeAsAwaitable.awaitedTypeOfType = type;
	      }
	      const thisTypeForErrorOut = { value: void 0 };
	      const promisedType = getPromisedTypeOfPromise(
	        type,
	        /*errorNode*/
	        void 0,
	        thisTypeForErrorOut
	      );
	      if (promisedType) {
	        if (type.id === promisedType.id || awaitedTypeStack.lastIndexOf(promisedType.id) >= 0) {
	          if (errorNode) {
	            error2(errorNode, Diagnostics.Type_is_referenced_directly_or_indirectly_in_the_fulfillment_callback_of_its_own_then_method);
	          }
	          return void 0;
	        }
	        awaitedTypeStack.push(type.id);
	        const awaitedType = getAwaitedTypeNoAlias(promisedType, errorNode, diagnosticMessage, ...args);
	        awaitedTypeStack.pop();
	        if (!awaitedType) {
	          return void 0;
	        }
	        return typeAsAwaitable.awaitedTypeOfType = awaitedType;
	      }
	      if (isThenableType(type)) {
	        if (errorNode) {
	          Debug.assertIsDefined(diagnosticMessage);
	          let chain;
	          if (thisTypeForErrorOut.value) {
	            chain = chainDiagnosticMessages(chain, Diagnostics.The_this_context_of_type_0_is_not_assignable_to_method_s_this_of_type_1, typeToString(type), typeToString(thisTypeForErrorOut.value));
	          }
	          chain = chainDiagnosticMessages(chain, diagnosticMessage, ...args);
	          diagnostics.add(createDiagnosticForNodeFromMessageChain(getSourceFileOfNode(errorNode), errorNode, chain));
	        }
	        return void 0;
	      }
	      return typeAsAwaitable.awaitedTypeOfType = type;
	    }
	    function checkAsyncFunctionReturnType(node, returnTypeNode, returnTypeErrorLocation) {
	      const returnType = getTypeFromTypeNode(returnTypeNode);
	      if (languageVersion >= 2 /* ES2015 */) {
	        if (isErrorType(returnType)) {
	          return;
	        }
	        const globalPromiseType = getGlobalPromiseType(
	          /*reportErrors*/
	          true
	        );
	        if (globalPromiseType !== emptyGenericType && !isReferenceToType2(returnType, globalPromiseType)) {
	          reportErrorForInvalidReturnType(Diagnostics.The_return_type_of_an_async_function_or_method_must_be_the_global_Promise_T_type_Did_you_mean_to_write_Promise_0, returnTypeNode, returnTypeErrorLocation, typeToString(getAwaitedTypeNoAlias(returnType) || voidType));
	          return;
	        }
	      } else {
	        markTypeNodeAsReferenced(returnTypeNode);
	        if (isErrorType(returnType)) {
	          return;
	        }
	        const promiseConstructorName = getEntityNameFromTypeNode(returnTypeNode);
	        if (promiseConstructorName === void 0) {
	          reportErrorForInvalidReturnType(Diagnostics.Type_0_is_not_a_valid_async_function_return_type_in_ES5_SlashES3_because_it_does_not_refer_to_a_Promise_compatible_constructor_value, returnTypeNode, returnTypeErrorLocation, typeToString(returnType));
	          return;
	        }
	        const promiseConstructorSymbol = resolveEntityName(
	          promiseConstructorName,
	          111551 /* Value */,
	          /*ignoreErrors*/
	          true
	        );
	        const promiseConstructorType = promiseConstructorSymbol ? getTypeOfSymbol(promiseConstructorSymbol) : errorType;
	        if (isErrorType(promiseConstructorType)) {
	          if (promiseConstructorName.kind === 80 /* Identifier */ && promiseConstructorName.escapedText === "Promise" && getTargetType(returnType) === getGlobalPromiseType(
	            /*reportErrors*/
	            false
	          )) {
	            error2(returnTypeErrorLocation, Diagnostics.An_async_function_or_method_in_ES5_SlashES3_requires_the_Promise_constructor_Make_sure_you_have_a_declaration_for_the_Promise_constructor_or_include_ES2015_in_your_lib_option);
	          } else {
	            reportErrorForInvalidReturnType(Diagnostics.Type_0_is_not_a_valid_async_function_return_type_in_ES5_SlashES3_because_it_does_not_refer_to_a_Promise_compatible_constructor_value, returnTypeNode, returnTypeErrorLocation, entityNameToString(promiseConstructorName));
	          }
	          return;
	        }
	        const globalPromiseConstructorLikeType = getGlobalPromiseConstructorLikeType(
	          /*reportErrors*/
	          true
	        );
	        if (globalPromiseConstructorLikeType === emptyObjectType) {
	          reportErrorForInvalidReturnType(Diagnostics.Type_0_is_not_a_valid_async_function_return_type_in_ES5_SlashES3_because_it_does_not_refer_to_a_Promise_compatible_constructor_value, returnTypeNode, returnTypeErrorLocation, entityNameToString(promiseConstructorName));
	          return;
	        }
	        const headMessage = Diagnostics.Type_0_is_not_a_valid_async_function_return_type_in_ES5_SlashES3_because_it_does_not_refer_to_a_Promise_compatible_constructor_value;
	        const errorInfo = () => returnTypeNode === returnTypeErrorLocation ? void 0 : chainDiagnosticMessages(
	          /*details*/
	          void 0,
	          Diagnostics.The_return_type_of_an_async_function_or_method_must_be_the_global_Promise_T_type
	        );
	        if (!checkTypeAssignableTo(promiseConstructorType, globalPromiseConstructorLikeType, returnTypeErrorLocation, headMessage, errorInfo)) {
	          return;
	        }
	        const rootName = promiseConstructorName && getFirstIdentifier(promiseConstructorName);
	        const collidingSymbol = getSymbol2(node.locals, rootName.escapedText, 111551 /* Value */);
	        if (collidingSymbol) {
	          error2(collidingSymbol.valueDeclaration, Diagnostics.Duplicate_identifier_0_Compiler_uses_declaration_1_to_support_async_functions, idText(rootName), entityNameToString(promiseConstructorName));
	          return;
	        }
	      }
	      checkAwaitedType(
	        returnType,
	        /*withAlias*/
	        false,
	        node,
	        Diagnostics.The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member
	      );
	      function reportErrorForInvalidReturnType(message, returnTypeNode2, returnTypeErrorLocation2, typeName) {
	        if (returnTypeNode2 === returnTypeErrorLocation2) {
	          error2(returnTypeErrorLocation2, message, typeName);
	        } else {
	          const diag2 = error2(returnTypeErrorLocation2, Diagnostics.The_return_type_of_an_async_function_or_method_must_be_the_global_Promise_T_type);
	          addRelatedInfo(diag2, createDiagnosticForNode(returnTypeNode2, message, typeName));
	        }
	      }
	    }
	    function checkDecorator(node) {
	      const signature = getResolvedSignature(node);
	      checkDeprecatedSignature(signature, node);
	      const returnType = getReturnTypeOfSignature(signature);
	      if (returnType.flags & 1 /* Any */) {
	        return;
	      }
	      const decoratorSignature = getDecoratorCallSignature(node);
	      if (!(decoratorSignature == null ? void 0 : decoratorSignature.resolvedReturnType))
	        return;
	      let headMessage;
	      const expectedReturnType = decoratorSignature.resolvedReturnType;
	      switch (node.parent.kind) {
	        case 263 /* ClassDeclaration */:
	        case 231 /* ClassExpression */:
	          headMessage = Diagnostics.Decorator_function_return_type_0_is_not_assignable_to_type_1;
	          break;
	        case 172 /* PropertyDeclaration */:
	          if (!legacyDecorators) {
	            headMessage = Diagnostics.Decorator_function_return_type_0_is_not_assignable_to_type_1;
	            break;
	          }
	        case 169 /* Parameter */:
	          headMessage = Diagnostics.Decorator_function_return_type_is_0_but_is_expected_to_be_void_or_any;
	          break;
	        case 174 /* MethodDeclaration */:
	        case 177 /* GetAccessor */:
	        case 178 /* SetAccessor */:
	          headMessage = Diagnostics.Decorator_function_return_type_0_is_not_assignable_to_type_1;
	          break;
	        default:
	          return Debug.failBadSyntaxKind(node.parent);
	      }
	      checkTypeAssignableTo(returnType, expectedReturnType, node.expression, headMessage);
	    }
	    function createCallSignature(typeParameters, thisParameter, parameters, returnType, typePredicate, minArgumentCount = parameters.length, flags = 0 /* None */) {
	      const decl = factory.createFunctionTypeNode(
	        /*typeParameters*/
	        void 0,
	        emptyArray,
	        factory.createKeywordTypeNode(133 /* AnyKeyword */)
	      );
	      return createSignature(decl, typeParameters, thisParameter, parameters, returnType, typePredicate, minArgumentCount, flags);
	    }
	    function createFunctionType(typeParameters, thisParameter, parameters, returnType, typePredicate, minArgumentCount, flags) {
	      const signature = createCallSignature(typeParameters, thisParameter, parameters, returnType, typePredicate, minArgumentCount, flags);
	      return getOrCreateTypeFromSignature(signature);
	    }
	    function createGetterFunctionType(type) {
	      return createFunctionType(
	        /*typeParameters*/
	        void 0,
	        /*thisParameter*/
	        void 0,
	        emptyArray,
	        type
	      );
	    }
	    function createSetterFunctionType(type) {
	      const valueParam = createParameter2("value", type);
	      return createFunctionType(
	        /*typeParameters*/
	        void 0,
	        /*thisParameter*/
	        void 0,
	        [valueParam],
	        voidType
	      );
	    }
	    function markTypeNodeAsReferenced(node) {
	      markEntityNameOrEntityExpressionAsReference(
	        node && getEntityNameFromTypeNode(node),
	        /*forDecoratorMetadata*/
	        false
	      );
	    }
	    function markEntityNameOrEntityExpressionAsReference(typeName, forDecoratorMetadata) {
	      if (!typeName)
	        return;
	      const rootName = getFirstIdentifier(typeName);
	      const meaning = (typeName.kind === 80 /* Identifier */ ? 788968 /* Type */ : 1920 /* Namespace */) | 2097152 /* Alias */;
	      const rootSymbol = resolveName(
	        rootName,
	        rootName.escapedText,
	        meaning,
	        /*nameNotFoundMessage*/
	        void 0,
	        /*nameArg*/
	        void 0,
	        /*isUse*/
	        true
	      );
	      if (rootSymbol && rootSymbol.flags & 2097152 /* Alias */) {
	        if (canCollectSymbolAliasAccessabilityData && symbolIsValue(rootSymbol) && !isConstEnumOrConstEnumOnlyModule(resolveAlias(rootSymbol)) && !getTypeOnlyAliasDeclaration(rootSymbol)) {
	          markAliasSymbolAsReferenced(rootSymbol);
	        } else if (forDecoratorMetadata && getIsolatedModules(compilerOptions) && getEmitModuleKind(compilerOptions) >= 5 /* ES2015 */ && !symbolIsValue(rootSymbol) && !some(rootSymbol.declarations, isTypeOnlyImportOrExportDeclaration)) {
	          const diag2 = error2(typeName, Diagnostics.A_type_referenced_in_a_decorated_signature_must_be_imported_with_import_type_or_a_namespace_import_when_isolatedModules_and_emitDecoratorMetadata_are_enabled);
	          const aliasDeclaration = find(rootSymbol.declarations || emptyArray, isAliasSymbolDeclaration2);
	          if (aliasDeclaration) {
	            addRelatedInfo(diag2, createDiagnosticForNode(aliasDeclaration, Diagnostics._0_was_imported_here, idText(rootName)));
	          }
	        }
	      }
	    }
	    function markDecoratorMedataDataTypeNodeAsReferenced(node) {
	      const entityName = getEntityNameForDecoratorMetadata(node);
	      if (entityName && isEntityName(entityName)) {
	        markEntityNameOrEntityExpressionAsReference(
	          entityName,
	          /*forDecoratorMetadata*/
	          true
	        );
	      }
	    }
	    function getEntityNameForDecoratorMetadata(node) {
	      if (node) {
	        switch (node.kind) {
	          case 193 /* IntersectionType */:
	          case 192 /* UnionType */:
	            return getEntityNameForDecoratorMetadataFromTypeList(node.types);
	          case 194 /* ConditionalType */:
	            return getEntityNameForDecoratorMetadataFromTypeList([node.trueType, node.falseType]);
	          case 196 /* ParenthesizedType */:
	          case 202 /* NamedTupleMember */:
	            return getEntityNameForDecoratorMetadata(node.type);
	          case 183 /* TypeReference */:
	            return node.typeName;
	        }
	      }
	    }
	    function getEntityNameForDecoratorMetadataFromTypeList(types) {
	      let commonEntityName;
	      for (let typeNode of types) {
	        while (typeNode.kind === 196 /* ParenthesizedType */ || typeNode.kind === 202 /* NamedTupleMember */) {
	          typeNode = typeNode.type;
	        }
	        if (typeNode.kind === 146 /* NeverKeyword */) {
	          continue;
	        }
	        if (!strictNullChecks && (typeNode.kind === 201 /* LiteralType */ && typeNode.literal.kind === 106 /* NullKeyword */ || typeNode.kind === 157 /* UndefinedKeyword */)) {
	          continue;
	        }
	        const individualEntityName = getEntityNameForDecoratorMetadata(typeNode);
	        if (!individualEntityName) {
	          return void 0;
	        }
	        if (commonEntityName) {
	          if (!isIdentifier(commonEntityName) || !isIdentifier(individualEntityName) || commonEntityName.escapedText !== individualEntityName.escapedText) {
	            return void 0;
	          }
	        } else {
	          commonEntityName = individualEntityName;
	        }
	      }
	      return commonEntityName;
	    }
	    function getParameterTypeNodeForDecoratorCheck(node) {
	      const typeNode = getEffectiveTypeAnnotationNode(node);
	      return isRestParameter(node) ? getRestParameterElementType(typeNode) : typeNode;
	    }
	    function checkDecorators(node) {
	      if (!canHaveDecorators(node) || !hasDecorators(node) || !node.modifiers || !nodeCanBeDecorated(legacyDecorators, node, node.parent, node.parent.parent)) {
	        return;
	      }
	      const firstDecorator = find(node.modifiers, isDecorator);
	      if (!firstDecorator) {
	        return;
	      }
	      if (legacyDecorators) {
	        checkExternalEmitHelpers(firstDecorator, 8 /* Decorate */);
	        if (node.kind === 169 /* Parameter */) {
	          checkExternalEmitHelpers(firstDecorator, 32 /* Param */);
	        }
	      } else if (languageVersion < 99 /* ESNext */) {
	        checkExternalEmitHelpers(firstDecorator, 8 /* ESDecorateAndRunInitializers */);
	        if (isClassDeclaration(node)) {
	          if (!node.name) {
	            checkExternalEmitHelpers(firstDecorator, 8388608 /* SetFunctionName */);
	          } else {
	            const member = getFirstTransformableStaticClassElement(node);
	            if (member) {
	              checkExternalEmitHelpers(firstDecorator, 8388608 /* SetFunctionName */);
	            }
	          }
	        } else if (!isClassExpression(node)) {
	          if (isPrivateIdentifier(node.name) && (isMethodDeclaration(node) || isAccessor(node) || isAutoAccessorPropertyDeclaration(node))) {
	            checkExternalEmitHelpers(firstDecorator, 8388608 /* SetFunctionName */);
	          }
	          if (isComputedPropertyName(node.name)) {
	            checkExternalEmitHelpers(firstDecorator, 16777216 /* PropKey */);
	          }
	        }
	      }
	      if (compilerOptions.emitDecoratorMetadata) {
	        checkExternalEmitHelpers(firstDecorator, 16 /* Metadata */);
	        switch (node.kind) {
	          case 263 /* ClassDeclaration */:
	            const constructor = getFirstConstructorWithBody(node);
	            if (constructor) {
	              for (const parameter of constructor.parameters) {
	                markDecoratorMedataDataTypeNodeAsReferenced(getParameterTypeNodeForDecoratorCheck(parameter));
	              }
	            }
	            break;
	          case 177 /* GetAccessor */:
	          case 178 /* SetAccessor */:
	            const otherKind = node.kind === 177 /* GetAccessor */ ? 178 /* SetAccessor */ : 177 /* GetAccessor */;
	            const otherAccessor = getDeclarationOfKind(getSymbolOfDeclaration(node), otherKind);
	            markDecoratorMedataDataTypeNodeAsReferenced(getAnnotatedAccessorTypeNode(node) || otherAccessor && getAnnotatedAccessorTypeNode(otherAccessor));
	            break;
	          case 174 /* MethodDeclaration */:
	            for (const parameter of node.parameters) {
	              markDecoratorMedataDataTypeNodeAsReferenced(getParameterTypeNodeForDecoratorCheck(parameter));
	            }
	            markDecoratorMedataDataTypeNodeAsReferenced(getEffectiveReturnTypeNode(node));
	            break;
	          case 172 /* PropertyDeclaration */:
	            markDecoratorMedataDataTypeNodeAsReferenced(getEffectiveTypeAnnotationNode(node));
	            break;
	          case 169 /* Parameter */:
	            markDecoratorMedataDataTypeNodeAsReferenced(getParameterTypeNodeForDecoratorCheck(node));
	            const containingSignature = node.parent;
	            for (const parameter of containingSignature.parameters) {
	              markDecoratorMedataDataTypeNodeAsReferenced(getParameterTypeNodeForDecoratorCheck(parameter));
	            }
	            markDecoratorMedataDataTypeNodeAsReferenced(getEffectiveReturnTypeNode(containingSignature));
	            break;
	        }
	      }
	      for (const modifier of node.modifiers) {
	        if (isDecorator(modifier)) {
	          checkDecorator(modifier);
	        }
	      }
	    }
	    function checkFunctionDeclaration(node) {
	      addLazyDiagnostic(checkFunctionDeclarationDiagnostics);
	      function checkFunctionDeclarationDiagnostics() {
	        checkFunctionOrMethodDeclaration(node);
	        checkGrammarForGenerator(node);
	        checkCollisionsForDeclarationName(node, node.name);
	      }
	    }
	    function checkJSDocTypeAliasTag(node) {
	      if (!node.typeExpression) {
	        error2(node.name, Diagnostics.JSDoc_typedef_tag_should_either_have_a_type_annotation_or_be_followed_by_property_or_member_tags);
	      }
	      if (node.name) {
	        checkTypeNameIsReserved(node.name, Diagnostics.Type_alias_name_cannot_be_0);
	      }
	      checkSourceElement(node.typeExpression);
	      checkTypeParameters(getEffectiveTypeParameterDeclarations(node));
	    }
	    function checkJSDocTemplateTag(node) {
	      checkSourceElement(node.constraint);
	      for (const tp of node.typeParameters) {
	        checkSourceElement(tp);
	      }
	    }
	    function checkJSDocTypeTag(node) {
	      checkSourceElement(node.typeExpression);
	    }
	    function checkJSDocSatisfiesTag(node) {
	      checkSourceElement(node.typeExpression);
	      const host2 = getEffectiveJSDocHost(node);
	      if (host2) {
	        const tags = getAllJSDocTags(host2, isJSDocSatisfiesTag);
	        if (length(tags) > 1) {
	          for (let i = 1; i < length(tags); i++) {
	            const tagName = tags[i].tagName;
	            error2(tagName, Diagnostics._0_tag_already_specified, idText(tagName));
	          }
	        }
	      }
	    }
	    function checkJSDocLinkLikeTag(node) {
	      if (node.name) {
	        resolveJSDocMemberName(
	          node.name,
	          /*ignoreErrors*/
	          true
	        );
	      }
	    }
	    function checkJSDocParameterTag(node) {
	      checkSourceElement(node.typeExpression);
	    }
	    function checkJSDocPropertyTag(node) {
	      checkSourceElement(node.typeExpression);
	    }
	    function checkJSDocFunctionType(node) {
	      addLazyDiagnostic(checkJSDocFunctionTypeImplicitAny);
	      checkSignatureDeclaration(node);
	      function checkJSDocFunctionTypeImplicitAny() {
	        if (!node.type && !isJSDocConstructSignature(node)) {
	          reportImplicitAny(node, anyType);
	        }
	      }
	    }
	    function checkJSDocThisTag(node) {
	      const host2 = getEffectiveJSDocHost(node);
	      if (host2 && isArrowFunction(host2)) {
	        error2(node.tagName, Diagnostics.An_arrow_function_cannot_have_a_this_parameter);
	      }
	    }
	    function checkJSDocImplementsTag(node) {
	      const classLike = getEffectiveJSDocHost(node);
	      if (!classLike || !isClassDeclaration(classLike) && !isClassExpression(classLike)) {
	        error2(classLike, Diagnostics.JSDoc_0_is_not_attached_to_a_class, idText(node.tagName));
	      }
	    }
	    function checkJSDocAugmentsTag(node) {
	      const classLike = getEffectiveJSDocHost(node);
	      if (!classLike || !isClassDeclaration(classLike) && !isClassExpression(classLike)) {
	        error2(classLike, Diagnostics.JSDoc_0_is_not_attached_to_a_class, idText(node.tagName));
	        return;
	      }
	      const augmentsTags = getJSDocTags(classLike).filter(isJSDocAugmentsTag);
	      Debug.assert(augmentsTags.length > 0);
	      if (augmentsTags.length > 1) {
	        error2(augmentsTags[1], Diagnostics.Class_declarations_cannot_have_more_than_one_augments_or_extends_tag);
	      }
	      const name = getIdentifierFromEntityNameExpression(node.class.expression);
	      const extend2 = getClassExtendsHeritageElement(classLike);
	      if (extend2) {
	        const className = getIdentifierFromEntityNameExpression(extend2.expression);
	        if (className && name.escapedText !== className.escapedText) {
	          error2(name, Diagnostics.JSDoc_0_1_does_not_match_the_extends_2_clause, idText(node.tagName), idText(name), idText(className));
	        }
	      }
	    }
	    function checkJSDocAccessibilityModifiers(node) {
	      const host2 = getJSDocHost(node);
	      if (host2 && isPrivateIdentifierClassElementDeclaration(host2)) {
	        error2(node, Diagnostics.An_accessibility_modifier_cannot_be_used_with_a_private_identifier);
	      }
	    }
	    function getIdentifierFromEntityNameExpression(node) {
	      switch (node.kind) {
	        case 80 /* Identifier */:
	          return node;
	        case 211 /* PropertyAccessExpression */:
	          return node.name;
	        default:
	          return void 0;
	      }
	    }
	    function checkFunctionOrMethodDeclaration(node) {
	      var _a;
	      checkDecorators(node);
	      checkSignatureDeclaration(node);
	      const functionFlags = getFunctionFlags(node);
	      if (node.name && node.name.kind === 167 /* ComputedPropertyName */) {
	        checkComputedPropertyName(node.name);
	      }
	      if (hasBindableName(node)) {
	        const symbol = getSymbolOfDeclaration(node);
	        const localSymbol = node.localSymbol || symbol;
	        const firstDeclaration = (_a = localSymbol.declarations) == null ? void 0 : _a.find(
	          // Get first non javascript function declaration
	          (declaration) => declaration.kind === node.kind && !(declaration.flags & 524288 /* JavaScriptFile */)
	        );
	        if (node === firstDeclaration) {
	          checkFunctionOrConstructorSymbol(localSymbol);
	        }
	        if (symbol.parent) {
	          checkFunctionOrConstructorSymbol(symbol);
	        }
	      }
	      const body = node.kind === 173 /* MethodSignature */ ? void 0 : node.body;
	      checkSourceElement(body);
	      checkAllCodePathsInNonVoidFunctionReturnOrThrow(node, getReturnTypeFromAnnotation(node));
	      addLazyDiagnostic(checkFunctionOrMethodDeclarationDiagnostics);
	      if (isInJSFile(node)) {
	        const typeTag = getJSDocTypeTag(node);
	        if (typeTag && typeTag.typeExpression && !getContextualCallSignature(getTypeFromTypeNode(typeTag.typeExpression), node)) {
	          error2(typeTag.typeExpression.type, Diagnostics.The_type_of_a_function_declaration_must_match_the_function_s_signature);
	        }
	      }
	      function checkFunctionOrMethodDeclarationDiagnostics() {
	        if (!getEffectiveReturnTypeNode(node)) {
	          if (nodeIsMissing(body) && !isPrivateWithinAmbient(node)) {
	            reportImplicitAny(node, anyType);
	          }
	          if (functionFlags & 1 /* Generator */ && nodeIsPresent(body)) {
	            getReturnTypeOfSignature(getSignatureFromDeclaration(node));
	          }
	        }
	      }
	    }
	    function registerForUnusedIdentifiersCheck(node) {
	      addLazyDiagnostic(registerForUnusedIdentifiersCheckDiagnostics);
	      function registerForUnusedIdentifiersCheckDiagnostics() {
	        const sourceFile = getSourceFileOfNode(node);
	        let potentiallyUnusedIdentifiers = allPotentiallyUnusedIdentifiers.get(sourceFile.path);
	        if (!potentiallyUnusedIdentifiers) {
	          potentiallyUnusedIdentifiers = [];
	          allPotentiallyUnusedIdentifiers.set(sourceFile.path, potentiallyUnusedIdentifiers);
	        }
	        potentiallyUnusedIdentifiers.push(node);
	      }
	    }
	    function checkUnusedIdentifiers(potentiallyUnusedIdentifiers, addDiagnostic) {
	      for (const node of potentiallyUnusedIdentifiers) {
	        switch (node.kind) {
	          case 263 /* ClassDeclaration */:
	          case 231 /* ClassExpression */:
	            checkUnusedClassMembers(node, addDiagnostic);
	            checkUnusedTypeParameters(node, addDiagnostic);
	            break;
	          case 312 /* SourceFile */:
	          case 267 /* ModuleDeclaration */:
	          case 241 /* Block */:
	          case 269 /* CaseBlock */:
	          case 248 /* ForStatement */:
	          case 249 /* ForInStatement */:
	          case 250 /* ForOfStatement */:
	            checkUnusedLocalsAndParameters(node, addDiagnostic);
	            break;
	          case 176 /* Constructor */:
	          case 218 /* FunctionExpression */:
	          case 262 /* FunctionDeclaration */:
	          case 219 /* ArrowFunction */:
	          case 174 /* MethodDeclaration */:
	          case 177 /* GetAccessor */:
	          case 178 /* SetAccessor */:
	            if (node.body) {
	              checkUnusedLocalsAndParameters(node, addDiagnostic);
	            }
	            checkUnusedTypeParameters(node, addDiagnostic);
	            break;
	          case 173 /* MethodSignature */:
	          case 179 /* CallSignature */:
	          case 180 /* ConstructSignature */:
	          case 184 /* FunctionType */:
	          case 185 /* ConstructorType */:
	          case 265 /* TypeAliasDeclaration */:
	          case 264 /* InterfaceDeclaration */:
	            checkUnusedTypeParameters(node, addDiagnostic);
	            break;
	          case 195 /* InferType */:
	            checkUnusedInferTypeParameter(node, addDiagnostic);
	            break;
	          default:
	            Debug.assertNever(node, "Node should not have been registered for unused identifiers check");
	        }
	      }
	    }
	    function errorUnusedLocal(declaration, name, addDiagnostic) {
	      const node = getNameOfDeclaration(declaration) || declaration;
	      const message = isTypeDeclaration(declaration) ? Diagnostics._0_is_declared_but_never_used : Diagnostics._0_is_declared_but_its_value_is_never_read;
	      addDiagnostic(declaration, 0 /* Local */, createDiagnosticForNode(node, message, name));
	    }
	    function isIdentifierThatStartsWithUnderscore(node) {
	      return isIdentifier(node) && idText(node).charCodeAt(0) === 95 /* _ */;
	    }
	    function checkUnusedClassMembers(node, addDiagnostic) {
	      for (const member of node.members) {
	        switch (member.kind) {
	          case 174 /* MethodDeclaration */:
	          case 172 /* PropertyDeclaration */:
	          case 177 /* GetAccessor */:
	          case 178 /* SetAccessor */:
	            if (member.kind === 178 /* SetAccessor */ && member.symbol.flags & 32768 /* GetAccessor */) {
	              break;
	            }
	            const symbol = getSymbolOfDeclaration(member);
	            if (!symbol.isReferenced && (hasEffectiveModifier(member, 2 /* Private */) || isNamedDeclaration(member) && isPrivateIdentifier(member.name)) && !(member.flags & 33554432 /* Ambient */)) {
	              addDiagnostic(member, 0 /* Local */, createDiagnosticForNode(member.name, Diagnostics._0_is_declared_but_its_value_is_never_read, symbolToString(symbol)));
	            }
	            break;
	          case 176 /* Constructor */:
	            for (const parameter of member.parameters) {
	              if (!parameter.symbol.isReferenced && hasSyntacticModifier(parameter, 2 /* Private */)) {
	                addDiagnostic(parameter, 0 /* Local */, createDiagnosticForNode(parameter.name, Diagnostics.Property_0_is_declared_but_its_value_is_never_read, symbolName(parameter.symbol)));
	              }
	            }
	            break;
	          case 181 /* IndexSignature */:
	          case 240 /* SemicolonClassElement */:
	          case 175 /* ClassStaticBlockDeclaration */:
	            break;
	          default:
	            Debug.fail("Unexpected class member");
	        }
	      }
	    }
	    function checkUnusedInferTypeParameter(node, addDiagnostic) {
	      const { typeParameter } = node;
	      if (isTypeParameterUnused(typeParameter)) {
	        addDiagnostic(node, 1 /* Parameter */, createDiagnosticForNode(node, Diagnostics._0_is_declared_but_its_value_is_never_read, idText(typeParameter.name)));
	      }
	    }
	    function checkUnusedTypeParameters(node, addDiagnostic) {
	      const declarations = getSymbolOfDeclaration(node).declarations;
	      if (!declarations || last(declarations) !== node)
	        return;
	      const typeParameters = getEffectiveTypeParameterDeclarations(node);
	      const seenParentsWithEveryUnused = /* @__PURE__ */ new Set();
	      for (const typeParameter of typeParameters) {
	        if (!isTypeParameterUnused(typeParameter))
	          continue;
	        const name = idText(typeParameter.name);
	        const { parent: parent2 } = typeParameter;
	        if (parent2.kind !== 195 /* InferType */ && parent2.typeParameters.every(isTypeParameterUnused)) {
	          if (tryAddToSet(seenParentsWithEveryUnused, parent2)) {
	            const sourceFile = getSourceFileOfNode(parent2);
	            const range = isJSDocTemplateTag(parent2) ? rangeOfNode(parent2) : rangeOfTypeParameters(sourceFile, parent2.typeParameters);
	            const only = parent2.typeParameters.length === 1;
	            const messageAndArg = only ? [Diagnostics._0_is_declared_but_its_value_is_never_read, name] : [Diagnostics.All_type_parameters_are_unused];
	            addDiagnostic(typeParameter, 1 /* Parameter */, createFileDiagnostic(sourceFile, range.pos, range.end - range.pos, ...messageAndArg));
	          }
	        } else {
	          addDiagnostic(typeParameter, 1 /* Parameter */, createDiagnosticForNode(typeParameter, Diagnostics._0_is_declared_but_its_value_is_never_read, name));
	        }
	      }
	    }
	    function isTypeParameterUnused(typeParameter) {
	      return !(getMergedSymbol(typeParameter.symbol).isReferenced & 262144 /* TypeParameter */) && !isIdentifierThatStartsWithUnderscore(typeParameter.name);
	    }
	    function addToGroup(map2, key, value, getKey) {
	      const keyString = String(getKey(key));
	      const group2 = map2.get(keyString);
	      if (group2) {
	        group2[1].push(value);
	      } else {
	        map2.set(keyString, [key, [value]]);
	      }
	    }
	    function tryGetRootParameterDeclaration(node) {
	      return tryCast(getRootDeclaration(node), isParameter);
	    }
	    function isValidUnusedLocalDeclaration(declaration) {
	      if (isBindingElement(declaration)) {
	        if (isObjectBindingPattern(declaration.parent)) {
	          return !!(declaration.propertyName && isIdentifierThatStartsWithUnderscore(declaration.name));
	        }
	        return isIdentifierThatStartsWithUnderscore(declaration.name);
	      }
	      return isAmbientModule(declaration) || (isVariableDeclaration(declaration) && isForInOrOfStatement(declaration.parent.parent) || isImportedDeclaration(declaration)) && isIdentifierThatStartsWithUnderscore(declaration.name);
	    }
	    function checkUnusedLocalsAndParameters(nodeWithLocals, addDiagnostic) {
	      const unusedImports = /* @__PURE__ */ new Map();
	      const unusedDestructures = /* @__PURE__ */ new Map();
	      const unusedVariables = /* @__PURE__ */ new Map();
	      nodeWithLocals.locals.forEach((local) => {
	        if (local.flags & 262144 /* TypeParameter */ ? !(local.flags & 3 /* Variable */ && !(local.isReferenced & 3 /* Variable */)) : local.isReferenced || local.exportSymbol) {
	          return;
	        }
	        if (local.declarations) {
	          for (const declaration of local.declarations) {
	            if (isValidUnusedLocalDeclaration(declaration)) {
	              continue;
	            }
	            if (isImportedDeclaration(declaration)) {
	              addToGroup(unusedImports, importClauseFromImported(declaration), declaration, getNodeId);
	            } else if (isBindingElement(declaration) && isObjectBindingPattern(declaration.parent)) {
	              const lastElement = last(declaration.parent.elements);
	              if (declaration === lastElement || !last(declaration.parent.elements).dotDotDotToken) {
	                addToGroup(unusedDestructures, declaration.parent, declaration, getNodeId);
	              }
	            } else if (isVariableDeclaration(declaration)) {
	              const blockScopeKind = getCombinedNodeFlagsCached(declaration) & 7 /* BlockScoped */;
	              const name = getNameOfDeclaration(declaration);
	              if (blockScopeKind !== 4 /* Using */ && blockScopeKind !== 6 /* AwaitUsing */ || !name || !isIdentifierThatStartsWithUnderscore(name)) {
	                addToGroup(unusedVariables, declaration.parent, declaration, getNodeId);
	              }
	            } else {
	              const parameter = local.valueDeclaration && tryGetRootParameterDeclaration(local.valueDeclaration);
	              const name = local.valueDeclaration && getNameOfDeclaration(local.valueDeclaration);
	              if (parameter && name) {
	                if (!isParameterPropertyDeclaration(parameter, parameter.parent) && !parameterIsThisKeyword(parameter) && !isIdentifierThatStartsWithUnderscore(name)) {
	                  if (isBindingElement(declaration) && isArrayBindingPattern(declaration.parent)) {
	                    addToGroup(unusedDestructures, declaration.parent, declaration, getNodeId);
	                  } else {
	                    addDiagnostic(parameter, 1 /* Parameter */, createDiagnosticForNode(name, Diagnostics._0_is_declared_but_its_value_is_never_read, symbolName(local)));
	                  }
	                }
	              } else {
	                errorUnusedLocal(declaration, symbolName(local), addDiagnostic);
	              }
	            }
	          }
	        }
	      });
	      unusedImports.forEach(([importClause, unuseds]) => {
	        const importDecl = importClause.parent;
	        const nDeclarations = (importClause.name ? 1 : 0) + (importClause.namedBindings ? importClause.namedBindings.kind === 274 /* NamespaceImport */ ? 1 : importClause.namedBindings.elements.length : 0);
	        if (nDeclarations === unuseds.length) {
	          addDiagnostic(
	            importDecl,
	            0 /* Local */,
	            unuseds.length === 1 ? createDiagnosticForNode(importDecl, Diagnostics._0_is_declared_but_its_value_is_never_read, idText(first(unuseds).name)) : createDiagnosticForNode(importDecl, Diagnostics.All_imports_in_import_declaration_are_unused)
	          );
	        } else {
	          for (const unused of unuseds)
	            errorUnusedLocal(unused, idText(unused.name), addDiagnostic);
	        }
	      });
	      unusedDestructures.forEach(([bindingPattern, bindingElements]) => {
	        const kind = tryGetRootParameterDeclaration(bindingPattern.parent) ? 1 /* Parameter */ : 0 /* Local */;
	        if (bindingPattern.elements.length === bindingElements.length) {
	          if (bindingElements.length === 1 && bindingPattern.parent.kind === 260 /* VariableDeclaration */ && bindingPattern.parent.parent.kind === 261 /* VariableDeclarationList */) {
	            addToGroup(unusedVariables, bindingPattern.parent.parent, bindingPattern.parent, getNodeId);
	          } else {
	            addDiagnostic(
	              bindingPattern,
	              kind,
	              bindingElements.length === 1 ? createDiagnosticForNode(bindingPattern, Diagnostics._0_is_declared_but_its_value_is_never_read, bindingNameText(first(bindingElements).name)) : createDiagnosticForNode(bindingPattern, Diagnostics.All_destructured_elements_are_unused)
	            );
	          }
	        } else {
	          for (const e of bindingElements) {
	            addDiagnostic(e, kind, createDiagnosticForNode(e, Diagnostics._0_is_declared_but_its_value_is_never_read, bindingNameText(e.name)));
	          }
	        }
	      });
	      unusedVariables.forEach(([declarationList, declarations]) => {
	        if (declarationList.declarations.length === declarations.length) {
	          addDiagnostic(
	            declarationList,
	            0 /* Local */,
	            declarations.length === 1 ? createDiagnosticForNode(first(declarations).name, Diagnostics._0_is_declared_but_its_value_is_never_read, bindingNameText(first(declarations).name)) : createDiagnosticForNode(declarationList.parent.kind === 243 /* VariableStatement */ ? declarationList.parent : declarationList, Diagnostics.All_variables_are_unused)
	          );
	        } else {
	          for (const decl of declarations) {
	            addDiagnostic(decl, 0 /* Local */, createDiagnosticForNode(decl, Diagnostics._0_is_declared_but_its_value_is_never_read, bindingNameText(decl.name)));
	          }
	        }
	      });
	    }
	    function checkPotentialUncheckedRenamedBindingElementsInTypes() {
	      var _a;
	      for (const node of potentialUnusedRenamedBindingElementsInTypes) {
	        if (!((_a = getSymbolOfDeclaration(node)) == null ? void 0 : _a.isReferenced)) {
	          const wrappingDeclaration = walkUpBindingElementsAndPatterns(node);
	          Debug.assert(isParameterDeclaration(wrappingDeclaration), "Only parameter declaration should be checked here");
	          const diagnostic = createDiagnosticForNode(node.name, Diagnostics._0_is_an_unused_renaming_of_1_Did_you_intend_to_use_it_as_a_type_annotation, declarationNameToString(node.name), declarationNameToString(node.propertyName));
	          if (!wrappingDeclaration.type) {
	            addRelatedInfo(
	              diagnostic,
	              createFileDiagnostic(getSourceFileOfNode(wrappingDeclaration), wrappingDeclaration.end, 1, Diagnostics.We_can_only_write_a_type_for_0_by_adding_a_type_for_the_entire_parameter_here, declarationNameToString(node.propertyName))
	            );
	          }
	          diagnostics.add(diagnostic);
	        }
	      }
	    }
	    function bindingNameText(name) {
	      switch (name.kind) {
	        case 80 /* Identifier */:
	          return idText(name);
	        case 207 /* ArrayBindingPattern */:
	        case 206 /* ObjectBindingPattern */:
	          return bindingNameText(cast(first(name.elements), isBindingElement).name);
	        default:
	          return Debug.assertNever(name);
	      }
	    }
	    function isImportedDeclaration(node) {
	      return node.kind === 273 /* ImportClause */ || node.kind === 276 /* ImportSpecifier */ || node.kind === 274 /* NamespaceImport */;
	    }
	    function importClauseFromImported(decl) {
	      return decl.kind === 273 /* ImportClause */ ? decl : decl.kind === 274 /* NamespaceImport */ ? decl.parent : decl.parent.parent;
	    }
	    function checkBlock(node) {
	      if (node.kind === 241 /* Block */) {
	        checkGrammarStatementInAmbientContext(node);
	      }
	      if (isFunctionOrModuleBlock(node)) {
	        const saveFlowAnalysisDisabled = flowAnalysisDisabled;
	        forEach(node.statements, checkSourceElement);
	        flowAnalysisDisabled = saveFlowAnalysisDisabled;
	      } else {
	        forEach(node.statements, checkSourceElement);
	      }
	      if (node.locals) {
	        registerForUnusedIdentifiersCheck(node);
	      }
	    }
	    function checkCollisionWithArgumentsInGeneratedCode(node) {
	      if (languageVersion >= 2 /* ES2015 */ || !hasRestParameter(node) || node.flags & 33554432 /* Ambient */ || nodeIsMissing(node.body)) {
	        return;
	      }
	      forEach(node.parameters, (p) => {
	        if (p.name && !isBindingPattern(p.name) && p.name.escapedText === argumentsSymbol.escapedName) {
	          errorSkippedOn("noEmit", p, Diagnostics.Duplicate_identifier_arguments_Compiler_uses_arguments_to_initialize_rest_parameters);
	        }
	      });
	    }
	    function needCollisionCheckForIdentifier(node, identifier, name) {
	      if ((identifier == null ? void 0 : identifier.escapedText) !== name) {
	        return false;
	      }
	      if (node.kind === 172 /* PropertyDeclaration */ || node.kind === 171 /* PropertySignature */ || node.kind === 174 /* MethodDeclaration */ || node.kind === 173 /* MethodSignature */ || node.kind === 177 /* GetAccessor */ || node.kind === 178 /* SetAccessor */ || node.kind === 303 /* PropertyAssignment */) {
	        return false;
	      }
	      if (node.flags & 33554432 /* Ambient */) {
	        return false;
	      }
	      if (isImportClause(node) || isImportEqualsDeclaration(node) || isImportSpecifier(node)) {
	        if (isTypeOnlyImportOrExportDeclaration(node)) {
	          return false;
	        }
	      }
	      const root = getRootDeclaration(node);
	      if (isParameter(root) && nodeIsMissing(root.parent.body)) {
	        return false;
	      }
	      return true;
	    }
	    function checkIfThisIsCapturedInEnclosingScope(node) {
	      findAncestor(node, (current) => {
	        if (getNodeCheckFlags(current) & 4 /* CaptureThis */) {
	          const isDeclaration2 = node.kind !== 80 /* Identifier */;
	          if (isDeclaration2) {
	            error2(getNameOfDeclaration(node), Diagnostics.Duplicate_identifier_this_Compiler_uses_variable_declaration_this_to_capture_this_reference);
	          } else {
	            error2(node, Diagnostics.Expression_resolves_to_variable_declaration_this_that_compiler_uses_to_capture_this_reference);
	          }
	          return true;
	        }
	        return false;
	      });
	    }
	    function checkIfNewTargetIsCapturedInEnclosingScope(node) {
	      findAncestor(node, (current) => {
	        if (getNodeCheckFlags(current) & 8 /* CaptureNewTarget */) {
	          const isDeclaration2 = node.kind !== 80 /* Identifier */;
	          if (isDeclaration2) {
	            error2(getNameOfDeclaration(node), Diagnostics.Duplicate_identifier_newTarget_Compiler_uses_variable_declaration_newTarget_to_capture_new_target_meta_property_reference);
	          } else {
	            error2(node, Diagnostics.Expression_resolves_to_variable_declaration_newTarget_that_compiler_uses_to_capture_new_target_meta_property_reference);
	          }
	          return true;
	        }
	        return false;
	      });
	    }
	    function checkCollisionWithRequireExportsInGeneratedCode(node, name) {
	      if (moduleKind >= 5 /* ES2015 */ && !(moduleKind >= 100 /* Node16 */ && getSourceFileOfNode(node).impliedNodeFormat === 1 /* CommonJS */)) {
	        return;
	      }
	      if (!name || !needCollisionCheckForIdentifier(node, name, "require") && !needCollisionCheckForIdentifier(node, name, "exports")) {
	        return;
	      }
	      if (isModuleDeclaration(node) && getModuleInstanceState(node) !== 1 /* Instantiated */) {
	        return;
	      }
	      const parent2 = getDeclarationContainer(node);
	      if (parent2.kind === 312 /* SourceFile */ && isExternalOrCommonJsModule(parent2)) {
	        errorSkippedOn("noEmit", name, Diagnostics.Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module, declarationNameToString(name), declarationNameToString(name));
	      }
	    }
	    function checkCollisionWithGlobalPromiseInGeneratedCode(node, name) {
	      if (!name || languageVersion >= 4 /* ES2017 */ || !needCollisionCheckForIdentifier(node, name, "Promise")) {
	        return;
	      }
	      if (isModuleDeclaration(node) && getModuleInstanceState(node) !== 1 /* Instantiated */) {
	        return;
	      }
	      const parent2 = getDeclarationContainer(node);
	      if (parent2.kind === 312 /* SourceFile */ && isExternalOrCommonJsModule(parent2) && parent2.flags & 4096 /* HasAsyncFunctions */) {
	        errorSkippedOn("noEmit", name, Diagnostics.Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module_containing_async_functions, declarationNameToString(name), declarationNameToString(name));
	      }
	    }
	    function recordPotentialCollisionWithWeakMapSetInGeneratedCode(node, name) {
	      if (languageVersion <= 8 /* ES2021 */ && (needCollisionCheckForIdentifier(node, name, "WeakMap") || needCollisionCheckForIdentifier(node, name, "WeakSet"))) {
	        potentialWeakMapSetCollisions.push(node);
	      }
	    }
	    function checkWeakMapSetCollision(node) {
	      const enclosingBlockScope = getEnclosingBlockScopeContainer(node);
	      if (getNodeCheckFlags(enclosingBlockScope) & 1048576 /* ContainsClassWithPrivateIdentifiers */) {
	        Debug.assert(isNamedDeclaration(node) && isIdentifier(node.name) && typeof node.name.escapedText === "string", "The target of a WeakMap/WeakSet collision check should be an identifier");
	        errorSkippedOn("noEmit", node, Diagnostics.Compiler_reserves_name_0_when_emitting_private_identifier_downlevel, node.name.escapedText);
	      }
	    }
	    function recordPotentialCollisionWithReflectInGeneratedCode(node, name) {
	      if (name && languageVersion >= 2 /* ES2015 */ && languageVersion <= 8 /* ES2021 */ && needCollisionCheckForIdentifier(node, name, "Reflect")) {
	        potentialReflectCollisions.push(node);
	      }
	    }
	    function checkReflectCollision(node) {
	      let hasCollision = false;
	      if (isClassExpression(node)) {
	        for (const member of node.members) {
	          if (getNodeCheckFlags(member) & 2097152 /* ContainsSuperPropertyInStaticInitializer */) {
	            hasCollision = true;
	            break;
	          }
	        }
	      } else if (isFunctionExpression(node)) {
	        if (getNodeCheckFlags(node) & 2097152 /* ContainsSuperPropertyInStaticInitializer */) {
	          hasCollision = true;
	        }
	      } else {
	        const container = getEnclosingBlockScopeContainer(node);
	        if (container && getNodeCheckFlags(container) & 2097152 /* ContainsSuperPropertyInStaticInitializer */) {
	          hasCollision = true;
	        }
	      }
	      if (hasCollision) {
	        Debug.assert(isNamedDeclaration(node) && isIdentifier(node.name), "The target of a Reflect collision check should be an identifier");
	        errorSkippedOn("noEmit", node, Diagnostics.Duplicate_identifier_0_Compiler_reserves_name_1_when_emitting_super_references_in_static_initializers, declarationNameToString(node.name), "Reflect");
	      }
	    }
	    function checkCollisionsForDeclarationName(node, name) {
	      if (!name)
	        return;
	      checkCollisionWithRequireExportsInGeneratedCode(node, name);
	      checkCollisionWithGlobalPromiseInGeneratedCode(node, name);
	      recordPotentialCollisionWithWeakMapSetInGeneratedCode(node, name);
	      recordPotentialCollisionWithReflectInGeneratedCode(node, name);
	      if (isClassLike(node)) {
	        checkTypeNameIsReserved(name, Diagnostics.Class_name_cannot_be_0);
	        if (!(node.flags & 33554432 /* Ambient */)) {
	          checkClassNameCollisionWithObject(name);
	        }
	      } else if (isEnumDeclaration(node)) {
	        checkTypeNameIsReserved(name, Diagnostics.Enum_name_cannot_be_0);
	      }
	    }
	    function checkVarDeclaredNamesNotShadowed(node) {
	      if ((getCombinedNodeFlagsCached(node) & 7 /* BlockScoped */) !== 0 || isParameterDeclaration(node)) {
	        return;
	      }
	      const symbol = getSymbolOfDeclaration(node);
	      if (symbol.flags & 1 /* FunctionScopedVariable */) {
	        if (!isIdentifier(node.name))
	          return Debug.fail();
	        const localDeclarationSymbol = resolveName(
	          node,
	          node.name.escapedText,
	          3 /* Variable */,
	          /*nameNotFoundMessage*/
	          void 0,
	          /*nameArg*/
	          void 0,
	          /*isUse*/
	          false
	        );
	        if (localDeclarationSymbol && localDeclarationSymbol !== symbol && localDeclarationSymbol.flags & 2 /* BlockScopedVariable */) {
	          if (getDeclarationNodeFlagsFromSymbol(localDeclarationSymbol) & 7 /* BlockScoped */) {
	            const varDeclList = getAncestor(localDeclarationSymbol.valueDeclaration, 261 /* VariableDeclarationList */);
	            const container = varDeclList.parent.kind === 243 /* VariableStatement */ && varDeclList.parent.parent ? varDeclList.parent.parent : void 0;
	            const namesShareScope = container && (container.kind === 241 /* Block */ && isFunctionLike(container.parent) || container.kind === 268 /* ModuleBlock */ || container.kind === 267 /* ModuleDeclaration */ || container.kind === 312 /* SourceFile */);
	            if (!namesShareScope) {
	              const name = symbolToString(localDeclarationSymbol);
	              error2(node, Diagnostics.Cannot_initialize_outer_scoped_variable_0_in_the_same_scope_as_block_scoped_declaration_1, name, name);
	            }
	          }
	        }
	      }
	    }
	    function convertAutoToAny(type) {
	      return type === autoType ? anyType : type === autoArrayType ? anyArrayType : type;
	    }
	    function checkVariableLikeDeclaration(node) {
	      var _a;
	      checkDecorators(node);
	      if (!isBindingElement(node)) {
	        checkSourceElement(node.type);
	      }
	      if (!node.name) {
	        return;
	      }
	      if (node.name.kind === 167 /* ComputedPropertyName */) {
	        checkComputedPropertyName(node.name);
	        if (hasOnlyExpressionInitializer(node) && node.initializer) {
	          checkExpressionCached(node.initializer);
	        }
	      }
	      if (isBindingElement(node)) {
	        if (node.propertyName && isIdentifier(node.name) && isParameterDeclaration(node) && nodeIsMissing(getContainingFunction(node).body)) {
	          potentialUnusedRenamedBindingElementsInTypes.push(node);
	          return;
	        }
	        if (isObjectBindingPattern(node.parent) && node.dotDotDotToken && languageVersion < 5 /* ES2018 */) {
	          checkExternalEmitHelpers(node, 4 /* Rest */);
	        }
	        if (node.propertyName && node.propertyName.kind === 167 /* ComputedPropertyName */) {
	          checkComputedPropertyName(node.propertyName);
	        }
	        const parent2 = node.parent.parent;
	        const parentCheckMode = node.dotDotDotToken ? 32 /* RestBindingElement */ : 0 /* Normal */;
	        const parentType = getTypeForBindingElementParent(parent2, parentCheckMode);
	        const name = node.propertyName || node.name;
	        if (parentType && !isBindingPattern(name)) {
	          const exprType = getLiteralTypeFromPropertyName(name);
	          if (isTypeUsableAsPropertyName(exprType)) {
	            const nameText = getPropertyNameFromType(exprType);
	            const property = getPropertyOfType(parentType, nameText);
	            if (property) {
	              markPropertyAsReferenced(
	                property,
	                /*nodeForCheckWriteOnly*/
	                void 0,
	                /*isSelfTypeAccess*/
	                false
	              );
	              checkPropertyAccessibility(
	                node,
	                !!parent2.initializer && parent2.initializer.kind === 108 /* SuperKeyword */,
	                /*writing*/
	                false,
	                parentType,
	                property
	              );
	            }
	          }
	        }
	      }
	      if (isBindingPattern(node.name)) {
	        if (node.name.kind === 207 /* ArrayBindingPattern */ && languageVersion < 2 /* ES2015 */ && compilerOptions.downlevelIteration) {
	          checkExternalEmitHelpers(node, 512 /* Read */);
	        }
	        forEach(node.name.elements, checkSourceElement);
	      }
	      if (node.initializer && isParameterDeclaration(node) && nodeIsMissing(getContainingFunction(node).body)) {
	        error2(node, Diagnostics.A_parameter_initializer_is_only_allowed_in_a_function_or_constructor_implementation);
	        return;
	      }
	      if (isBindingPattern(node.name)) {
	        if (isInAmbientOrTypeNode(node)) {
	          return;
	        }
	        const needCheckInitializer = hasOnlyExpressionInitializer(node) && node.initializer && node.parent.parent.kind !== 249 /* ForInStatement */;
	        const needCheckWidenedType = !some(node.name.elements, not(isOmittedExpression));
	        if (needCheckInitializer || needCheckWidenedType) {
	          const widenedType = getWidenedTypeForVariableLikeDeclaration(node);
	          if (needCheckInitializer) {
	            const initializerType = checkExpressionCached(node.initializer);
	            if (strictNullChecks && needCheckWidenedType) {
	              checkNonNullNonVoidType(initializerType, node);
	            } else {
	              checkTypeAssignableToAndOptionallyElaborate(initializerType, getWidenedTypeForVariableLikeDeclaration(node), node, node.initializer);
	            }
	          }
	          if (needCheckWidenedType) {
	            if (isArrayBindingPattern(node.name)) {
	              checkIteratedTypeOrElementType(65 /* Destructuring */, widenedType, undefinedType, node);
	            } else if (strictNullChecks) {
	              checkNonNullNonVoidType(widenedType, node);
	            }
	          }
	        }
	        return;
	      }
	      const symbol = getSymbolOfDeclaration(node);
	      if (symbol.flags & 2097152 /* Alias */ && (isVariableDeclarationInitializedToBareOrAccessedRequire(node) || isBindingElementOfBareOrAccessedRequire(node))) {
	        checkAliasSymbol(node);
	        return;
	      }
	      const type = convertAutoToAny(getTypeOfSymbol(symbol));
	      if (node === symbol.valueDeclaration) {
	        const initializer = hasOnlyExpressionInitializer(node) && getEffectiveInitializer(node);
	        if (initializer) {
	          const isJSObjectLiteralInitializer = isInJSFile(node) && isObjectLiteralExpression(initializer) && (initializer.properties.length === 0 || isPrototypeAccess(node.name)) && !!((_a = symbol.exports) == null ? void 0 : _a.size);
	          if (!isJSObjectLiteralInitializer && node.parent.parent.kind !== 249 /* ForInStatement */) {
	            const initializerType = checkExpressionCached(initializer);
	            checkTypeAssignableToAndOptionallyElaborate(
	              initializerType,
	              type,
	              node,
	              initializer,
	              /*headMessage*/
	              void 0
	            );
	            const blockScopeKind = getCombinedNodeFlagsCached(node) & 7 /* BlockScoped */;
	            if (blockScopeKind === 6 /* AwaitUsing */) {
	              const globalAsyncDisposableType = getGlobalAsyncDisposableType(
	                /*reportErrors*/
	                true
	              );
	              const globalDisposableType = getGlobalDisposableType(
	                /*reportErrors*/
	                true
	              );
	              if (globalAsyncDisposableType !== emptyObjectType && globalDisposableType !== emptyObjectType) {
	                const optionalDisposableType = getUnionType([globalAsyncDisposableType, globalDisposableType, nullType, undefinedType]);
	                checkTypeAssignableTo(initializerType, optionalDisposableType, initializer, Diagnostics.The_initializer_of_an_await_using_declaration_must_be_either_an_object_with_a_Symbol_asyncDispose_or_Symbol_dispose_method_or_be_null_or_undefined);
	              }
	            } else if (blockScopeKind === 4 /* Using */) {
	              const globalDisposableType = getGlobalDisposableType(
	                /*reportErrors*/
	                true
	              );
	              if (globalDisposableType !== emptyObjectType) {
	                const optionalDisposableType = getUnionType([globalDisposableType, nullType, undefinedType]);
	                checkTypeAssignableTo(initializerType, optionalDisposableType, initializer, Diagnostics.The_initializer_of_a_using_declaration_must_be_either_an_object_with_a_Symbol_dispose_method_or_be_null_or_undefined);
	              }
	            }
	          }
	        }
	        if (symbol.declarations && symbol.declarations.length > 1) {
	          if (some(symbol.declarations, (d) => d !== node && isVariableLike(d) && !areDeclarationFlagsIdentical(d, node))) {
	            error2(node.name, Diagnostics.All_declarations_of_0_must_have_identical_modifiers, declarationNameToString(node.name));
	          }
	        }
	      } else {
	        const declarationType = convertAutoToAny(getWidenedTypeForVariableLikeDeclaration(node));
	        if (!isErrorType(type) && !isErrorType(declarationType) && !isTypeIdenticalTo(type, declarationType) && !(symbol.flags & 67108864 /* Assignment */)) {
	          errorNextVariableOrPropertyDeclarationMustHaveSameType(symbol.valueDeclaration, type, node, declarationType);
	        }
	        if (hasOnlyExpressionInitializer(node) && node.initializer) {
	          checkTypeAssignableToAndOptionallyElaborate(
	            checkExpressionCached(node.initializer),
	            declarationType,
	            node,
	            node.initializer,
	            /*headMessage*/
	            void 0
	          );
	        }
	        if (symbol.valueDeclaration && !areDeclarationFlagsIdentical(node, symbol.valueDeclaration)) {
	          error2(node.name, Diagnostics.All_declarations_of_0_must_have_identical_modifiers, declarationNameToString(node.name));
	        }
	      }
	      if (node.kind !== 172 /* PropertyDeclaration */ && node.kind !== 171 /* PropertySignature */) {
	        checkExportsOnMergedDeclarations(node);
	        if (node.kind === 260 /* VariableDeclaration */ || node.kind === 208 /* BindingElement */) {
	          checkVarDeclaredNamesNotShadowed(node);
	        }
	        checkCollisionsForDeclarationName(node, node.name);
	      }
	    }
	    function errorNextVariableOrPropertyDeclarationMustHaveSameType(firstDeclaration, firstType, nextDeclaration, nextType) {
	      const nextDeclarationName = getNameOfDeclaration(nextDeclaration);
	      const message = nextDeclaration.kind === 172 /* PropertyDeclaration */ || nextDeclaration.kind === 171 /* PropertySignature */ ? Diagnostics.Subsequent_property_declarations_must_have_the_same_type_Property_0_must_be_of_type_1_but_here_has_type_2 : Diagnostics.Subsequent_variable_declarations_must_have_the_same_type_Variable_0_must_be_of_type_1_but_here_has_type_2;
	      const declName = declarationNameToString(nextDeclarationName);
	      const err = error2(
	        nextDeclarationName,
	        message,
	        declName,
	        typeToString(firstType),
	        typeToString(nextType)
	      );
	      if (firstDeclaration) {
	        addRelatedInfo(err, createDiagnosticForNode(firstDeclaration, Diagnostics._0_was_also_declared_here, declName));
	      }
	    }
	    function areDeclarationFlagsIdentical(left, right) {
	      if (left.kind === 169 /* Parameter */ && right.kind === 260 /* VariableDeclaration */ || left.kind === 260 /* VariableDeclaration */ && right.kind === 169 /* Parameter */) {
	        return true;
	      }
	      if (hasQuestionToken(left) !== hasQuestionToken(right)) {
	        return false;
	      }
	      const interestingFlags = 2 /* Private */ | 4 /* Protected */ | 1024 /* Async */ | 64 /* Abstract */ | 8 /* Readonly */ | 256 /* Static */;
	      return getSelectedEffectiveModifierFlags(left, interestingFlags) === getSelectedEffectiveModifierFlags(right, interestingFlags);
	    }
	    function checkVariableDeclaration(node) {
	      var _a, _b;
	      (_a = tracing) == null ? void 0 : _a.push(tracing.Phase.Check, "checkVariableDeclaration", { kind: node.kind, pos: node.pos, end: node.end, path: node.tracingPath });
	      checkGrammarVariableDeclaration(node);
	      checkVariableLikeDeclaration(node);
	      (_b = tracing) == null ? void 0 : _b.pop();
	    }
	    function checkBindingElement(node) {
	      checkGrammarBindingElement(node);
	      return checkVariableLikeDeclaration(node);
	    }
	    function checkVariableDeclarationList(node) {
	      const blockScopeKind = getCombinedNodeFlags(node) & 7 /* BlockScoped */;
	      if (blockScopeKind === 4 /* Using */ || blockScopeKind === 6 /* AwaitUsing */) {
	        checkExternalEmitHelpers(node, 33554432 /* AddDisposableResourceAndDisposeResources */);
	      }
	      forEach(node.declarations, checkSourceElement);
	    }
	    function checkVariableStatement(node) {
	      if (!checkGrammarModifiers(node) && !checkGrammarVariableDeclarationList(node.declarationList))
	        checkGrammarForDisallowedBlockScopedVariableStatement(node);
	      checkVariableDeclarationList(node.declarationList);
	    }
	    function checkExpressionStatement(node) {
	      checkGrammarStatementInAmbientContext(node);
	      checkExpression(node.expression);
	    }
	    function checkIfStatement(node) {
	      checkGrammarStatementInAmbientContext(node);
	      const type = checkTruthinessExpression(node.expression);
	      checkTestingKnownTruthyCallableOrAwaitableType(node.expression, type, node.thenStatement);
	      checkSourceElement(node.thenStatement);
	      if (node.thenStatement.kind === 242 /* EmptyStatement */) {
	        error2(node.thenStatement, Diagnostics.The_body_of_an_if_statement_cannot_be_the_empty_statement);
	      }
	      checkSourceElement(node.elseStatement);
	    }
	    function checkTestingKnownTruthyCallableOrAwaitableType(condExpr, condType, body) {
	      if (!strictNullChecks)
	        return;
	      bothHelper(condExpr, body);
	      function bothHelper(condExpr2, body2) {
	        condExpr2 = skipParentheses(condExpr2);
	        helper(condExpr2, body2);
	        while (isBinaryExpression(condExpr2) && (condExpr2.operatorToken.kind === 57 /* BarBarToken */ || condExpr2.operatorToken.kind === 61 /* QuestionQuestionToken */)) {
	          condExpr2 = skipParentheses(condExpr2.left);
	          helper(condExpr2, body2);
	        }
	      }
	      function helper(condExpr2, body2) {
	        const location = isLogicalOrCoalescingBinaryExpression(condExpr2) ? skipParentheses(condExpr2.right) : condExpr2;
	        if (isModuleExportsAccessExpression(location)) {
	          return;
	        }
	        if (isLogicalOrCoalescingBinaryExpression(location)) {
	          bothHelper(location, body2);
	          return;
	        }
	        const type = location === condExpr2 ? condType : checkTruthinessExpression(location);
	        const isPropertyExpressionCast = isPropertyAccessExpression(location) && isTypeAssertion(location.expression);
	        if (!hasTypeFacts(type, 4194304 /* Truthy */) || isPropertyExpressionCast)
	          return;
	        const callSignatures = getSignaturesOfType(type, 0 /* Call */);
	        const isPromise = !!getAwaitedTypeOfPromise(type);
	        if (callSignatures.length === 0 && !isPromise) {
	          return;
	        }
	        const testedNode = isIdentifier(location) ? location : isPropertyAccessExpression(location) ? location.name : void 0;
	        const testedSymbol = testedNode && getSymbolAtLocation(testedNode);
	        if (!testedSymbol && !isPromise) {
	          return;
	        }
	        const isUsed = testedSymbol && isBinaryExpression(condExpr2.parent) && isSymbolUsedInBinaryExpressionChain(condExpr2.parent, testedSymbol) || testedSymbol && body2 && isSymbolUsedInConditionBody(condExpr2, body2, testedNode, testedSymbol);
	        if (!isUsed) {
	          if (isPromise) {
	            errorAndMaybeSuggestAwait(
	              location,
	              /*maybeMissingAwait*/
	              true,
	              Diagnostics.This_condition_will_always_return_true_since_this_0_is_always_defined,
	              getTypeNameForErrorDisplay(type)
	            );
	          } else {
	            error2(location, Diagnostics.This_condition_will_always_return_true_since_this_function_is_always_defined_Did_you_mean_to_call_it_instead);
	          }
	        }
	      }
	    }
	    function isSymbolUsedInConditionBody(expr, body, testedNode, testedSymbol) {
	      return !!forEachChild(body, function check(childNode) {
	        if (isIdentifier(childNode)) {
	          const childSymbol = getSymbolAtLocation(childNode);
	          if (childSymbol && childSymbol === testedSymbol) {
	            if (isIdentifier(expr) || isIdentifier(testedNode) && isBinaryExpression(testedNode.parent)) {
	              return true;
	            }
	            let testedExpression = testedNode.parent;
	            let childExpression = childNode.parent;
	            while (testedExpression && childExpression) {
	              if (isIdentifier(testedExpression) && isIdentifier(childExpression) || testedExpression.kind === 110 /* ThisKeyword */ && childExpression.kind === 110 /* ThisKeyword */) {
	                return getSymbolAtLocation(testedExpression) === getSymbolAtLocation(childExpression);
	              } else if (isPropertyAccessExpression(testedExpression) && isPropertyAccessExpression(childExpression)) {
	                if (getSymbolAtLocation(testedExpression.name) !== getSymbolAtLocation(childExpression.name)) {
	                  return false;
	                }
	                childExpression = childExpression.expression;
	                testedExpression = testedExpression.expression;
	              } else if (isCallExpression(testedExpression) && isCallExpression(childExpression)) {
	                childExpression = childExpression.expression;
	                testedExpression = testedExpression.expression;
	              } else {
	                return false;
	              }
	            }
	          }
	        }
	        return forEachChild(childNode, check);
	      });
	    }
	    function isSymbolUsedInBinaryExpressionChain(node, testedSymbol) {
	      while (isBinaryExpression(node) && node.operatorToken.kind === 56 /* AmpersandAmpersandToken */) {
	        const isUsed = forEachChild(node.right, function visit(child) {
	          if (isIdentifier(child)) {
	            const symbol = getSymbolAtLocation(child);
	            if (symbol && symbol === testedSymbol) {
	              return true;
	            }
	          }
	          return forEachChild(child, visit);
	        });
	        if (isUsed) {
	          return true;
	        }
	        node = node.parent;
	      }
	      return false;
	    }
	    function checkDoStatement(node) {
	      checkGrammarStatementInAmbientContext(node);
	      checkSourceElement(node.statement);
	      checkTruthinessExpression(node.expression);
	    }
	    function checkWhileStatement(node) {
	      checkGrammarStatementInAmbientContext(node);
	      checkTruthinessExpression(node.expression);
	      checkSourceElement(node.statement);
	    }
	    function checkTruthinessOfType(type, node) {
	      if (type.flags & 16384 /* Void */) {
	        error2(node, Diagnostics.An_expression_of_type_void_cannot_be_tested_for_truthiness);
	      }
	      return type;
	    }
	    function checkTruthinessExpression(node, checkMode) {
	      return checkTruthinessOfType(checkExpression(node, checkMode), node);
	    }
	    function checkForStatement(node) {
	      if (!checkGrammarStatementInAmbientContext(node)) {
	        if (node.initializer && node.initializer.kind === 261 /* VariableDeclarationList */) {
	          checkGrammarVariableDeclarationList(node.initializer);
	        }
	      }
	      if (node.initializer) {
	        if (node.initializer.kind === 261 /* VariableDeclarationList */) {
	          checkVariableDeclarationList(node.initializer);
	        } else {
	          checkExpression(node.initializer);
	        }
	      }
	      if (node.condition)
	        checkTruthinessExpression(node.condition);
	      if (node.incrementor)
	        checkExpression(node.incrementor);
	      checkSourceElement(node.statement);
	      if (node.locals) {
	        registerForUnusedIdentifiersCheck(node);
	      }
	    }
	    function checkForOfStatement(node) {
	      checkGrammarForInOrForOfStatement(node);
	      const container = getContainingFunctionOrClassStaticBlock(node);
	      if (node.awaitModifier) {
	        if (container && isClassStaticBlockDeclaration(container)) {
	          grammarErrorOnNode(node.awaitModifier, Diagnostics.for_await_loops_cannot_be_used_inside_a_class_static_block);
	        } else {
	          const functionFlags = getFunctionFlags(container);
	          if ((functionFlags & (4 /* Invalid */ | 2 /* Async */)) === 2 /* Async */ && languageVersion < 99 /* ESNext */) {
	            checkExternalEmitHelpers(node, 16384 /* ForAwaitOfIncludes */);
	          }
	        }
	      } else if (compilerOptions.downlevelIteration && languageVersion < 2 /* ES2015 */) {
	        checkExternalEmitHelpers(node, 256 /* ForOfIncludes */);
	      }
	      if (node.initializer.kind === 261 /* VariableDeclarationList */) {
	        checkVariableDeclarationList(node.initializer);
	      } else {
	        const varExpr = node.initializer;
	        const iteratedType = checkRightHandSideOfForOf(node);
	        if (varExpr.kind === 209 /* ArrayLiteralExpression */ || varExpr.kind === 210 /* ObjectLiteralExpression */) {
	          checkDestructuringAssignment(varExpr, iteratedType || errorType);
	        } else {
	          const leftType = checkExpression(varExpr);
	          checkReferenceExpression(
	            varExpr,
	            Diagnostics.The_left_hand_side_of_a_for_of_statement_must_be_a_variable_or_a_property_access,
	            Diagnostics.The_left_hand_side_of_a_for_of_statement_may_not_be_an_optional_property_access
	          );
	          if (iteratedType) {
	            checkTypeAssignableToAndOptionallyElaborate(iteratedType, leftType, varExpr, node.expression);
	          }
	        }
	      }
	      checkSourceElement(node.statement);
	      if (node.locals) {
	        registerForUnusedIdentifiersCheck(node);
	      }
	    }
	    function checkForInStatement(node) {
	      checkGrammarForInOrForOfStatement(node);
	      const rightType = getNonNullableTypeIfNeeded(checkExpression(node.expression));
	      if (node.initializer.kind === 261 /* VariableDeclarationList */) {
	        const variable = node.initializer.declarations[0];
	        if (variable && isBindingPattern(variable.name)) {
	          error2(variable.name, Diagnostics.The_left_hand_side_of_a_for_in_statement_cannot_be_a_destructuring_pattern);
	        }
	        checkVariableDeclarationList(node.initializer);
	      } else {
	        const varExpr = node.initializer;
	        const leftType = checkExpression(varExpr);
	        if (varExpr.kind === 209 /* ArrayLiteralExpression */ || varExpr.kind === 210 /* ObjectLiteralExpression */) {
	          error2(varExpr, Diagnostics.The_left_hand_side_of_a_for_in_statement_cannot_be_a_destructuring_pattern);
	        } else if (!isTypeAssignableTo(getIndexTypeOrString(rightType), leftType)) {
	          error2(varExpr, Diagnostics.The_left_hand_side_of_a_for_in_statement_must_be_of_type_string_or_any);
	        } else {
	          checkReferenceExpression(
	            varExpr,
	            Diagnostics.The_left_hand_side_of_a_for_in_statement_must_be_a_variable_or_a_property_access,
	            Diagnostics.The_left_hand_side_of_a_for_in_statement_may_not_be_an_optional_property_access
	          );
	        }
	      }
	      if (rightType === neverType || !isTypeAssignableToKind(rightType, 67108864 /* NonPrimitive */ | 58982400 /* InstantiableNonPrimitive */)) {
	        error2(node.expression, Diagnostics.The_right_hand_side_of_a_for_in_statement_must_be_of_type_any_an_object_type_or_a_type_parameter_but_here_has_type_0, typeToString(rightType));
	      }
	      checkSourceElement(node.statement);
	      if (node.locals) {
	        registerForUnusedIdentifiersCheck(node);
	      }
	    }
	    function checkRightHandSideOfForOf(statement) {
	      const use = statement.awaitModifier ? 15 /* ForAwaitOf */ : 13 /* ForOf */;
	      return checkIteratedTypeOrElementType(use, checkNonNullExpression(statement.expression), undefinedType, statement.expression);
	    }
	    function checkIteratedTypeOrElementType(use, inputType, sentType, errorNode) {
	      if (isTypeAny(inputType)) {
	        return inputType;
	      }
	      return getIteratedTypeOrElementType(
	        use,
	        inputType,
	        sentType,
	        errorNode,
	        /*checkAssignability*/
	        true
	      ) || anyType;
	    }
	    function getIteratedTypeOrElementType(use, inputType, sentType, errorNode, checkAssignability) {
	      const allowAsyncIterables = (use & 2 /* AllowsAsyncIterablesFlag */) !== 0;
	      if (inputType === neverType) {
	        reportTypeNotIterableError(errorNode, inputType, allowAsyncIterables);
	        return void 0;
	      }
	      const uplevelIteration = languageVersion >= 2 /* ES2015 */;
	      const downlevelIteration = !uplevelIteration && compilerOptions.downlevelIteration;
	      const possibleOutOfBounds = compilerOptions.noUncheckedIndexedAccess && !!(use & 128 /* PossiblyOutOfBounds */);
	      if (uplevelIteration || downlevelIteration || allowAsyncIterables) {
	        const iterationTypes = getIterationTypesOfIterable(inputType, use, uplevelIteration ? errorNode : void 0);
	        if (checkAssignability) {
	          if (iterationTypes) {
	            const diagnostic = use & 8 /* ForOfFlag */ ? Diagnostics.Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_for_of_will_always_send_0 : use & 32 /* SpreadFlag */ ? Diagnostics.Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_array_spread_will_always_send_0 : use & 64 /* DestructuringFlag */ ? Diagnostics.Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_array_destructuring_will_always_send_0 : use & 16 /* YieldStarFlag */ ? Diagnostics.Cannot_delegate_iteration_to_value_because_the_next_method_of_its_iterator_expects_type_1_but_the_containing_generator_will_always_send_0 : void 0;
	            if (diagnostic) {
	              checkTypeAssignableTo(sentType, iterationTypes.nextType, errorNode, diagnostic);
	            }
	          }
	        }
	        if (iterationTypes || uplevelIteration) {
	          return possibleOutOfBounds ? includeUndefinedInIndexSignature(iterationTypes && iterationTypes.yieldType) : iterationTypes && iterationTypes.yieldType;
	        }
	      }
	      let arrayType = inputType;
	      let reportedError = false;
	      let hasStringConstituent = false;
	      if (use & 4 /* AllowsStringInputFlag */) {
	        if (arrayType.flags & 1048576 /* Union */) {
	          const arrayTypes = inputType.types;
	          const filteredTypes = filter(arrayTypes, (t) => !(t.flags & 402653316 /* StringLike */));
	          if (filteredTypes !== arrayTypes) {
	            arrayType = getUnionType(filteredTypes, 2 /* Subtype */);
	          }
	        } else if (arrayType.flags & 402653316 /* StringLike */) {
	          arrayType = neverType;
	        }
	        hasStringConstituent = arrayType !== inputType;
	        if (hasStringConstituent) {
	          if (languageVersion < 1 /* ES5 */) {
	            if (errorNode) {
	              error2(errorNode, Diagnostics.Using_a_string_in_a_for_of_statement_is_only_supported_in_ECMAScript_5_and_higher);
	              reportedError = true;
	            }
	          }
	          if (arrayType.flags & 131072 /* Never */) {
	            return possibleOutOfBounds ? includeUndefinedInIndexSignature(stringType) : stringType;
	          }
	        }
	      }
	      if (!isArrayLikeType(arrayType)) {
	        if (errorNode && !reportedError) {
	          const allowsStrings = !!(use & 4 /* AllowsStringInputFlag */) && !hasStringConstituent;
	          const [defaultDiagnostic, maybeMissingAwait] = getIterationDiagnosticDetails(allowsStrings, downlevelIteration);
	          errorAndMaybeSuggestAwait(
	            errorNode,
	            maybeMissingAwait && !!getAwaitedTypeOfPromise(arrayType),
	            defaultDiagnostic,
	            typeToString(arrayType)
	          );
	        }
	        return hasStringConstituent ? possibleOutOfBounds ? includeUndefinedInIndexSignature(stringType) : stringType : void 0;
	      }
	      const arrayElementType = getIndexTypeOfType(arrayType, numberType);
	      if (hasStringConstituent && arrayElementType) {
	        if (arrayElementType.flags & 402653316 /* StringLike */ && !compilerOptions.noUncheckedIndexedAccess) {
	          return stringType;
	        }
	        return getUnionType(possibleOutOfBounds ? [arrayElementType, stringType, undefinedType] : [arrayElementType, stringType], 2 /* Subtype */);
	      }
	      return use & 128 /* PossiblyOutOfBounds */ ? includeUndefinedInIndexSignature(arrayElementType) : arrayElementType;
	      function getIterationDiagnosticDetails(allowsStrings, downlevelIteration2) {
	        var _a;
	        if (downlevelIteration2) {
	          return allowsStrings ? [Diagnostics.Type_0_is_not_an_array_type_or_a_string_type_or_does_not_have_a_Symbol_iterator_method_that_returns_an_iterator, true] : [Diagnostics.Type_0_is_not_an_array_type_or_does_not_have_a_Symbol_iterator_method_that_returns_an_iterator, true];
	        }
	        const yieldType = getIterationTypeOfIterable(
	          use,
	          0 /* Yield */,
	          inputType,
	          /*errorNode*/
	          void 0
	        );
	        if (yieldType) {
	          return [Diagnostics.Type_0_can_only_be_iterated_through_when_using_the_downlevelIteration_flag_or_with_a_target_of_es2015_or_higher, false];
	        }
	        if (isES2015OrLaterIterable((_a = inputType.symbol) == null ? void 0 : _a.escapedName)) {
	          return [Diagnostics.Type_0_can_only_be_iterated_through_when_using_the_downlevelIteration_flag_or_with_a_target_of_es2015_or_higher, true];
	        }
	        return allowsStrings ? [Diagnostics.Type_0_is_not_an_array_type_or_a_string_type, true] : [Diagnostics.Type_0_is_not_an_array_type, true];
	      }
	    }
	    function isES2015OrLaterIterable(n) {
	      switch (n) {
	        case "Float32Array":
	        case "Float64Array":
	        case "Int16Array":
	        case "Int32Array":
	        case "Int8Array":
	        case "NodeList":
	        case "Uint16Array":
	        case "Uint32Array":
	        case "Uint8Array":
	        case "Uint8ClampedArray":
	          return true;
	      }
	      return false;
	    }
	    function getIterationTypeOfIterable(use, typeKind, inputType, errorNode) {
	      if (isTypeAny(inputType)) {
	        return void 0;
	      }
	      const iterationTypes = getIterationTypesOfIterable(inputType, use, errorNode);
	      return iterationTypes && iterationTypes[getIterationTypesKeyFromIterationTypeKind(typeKind)];
	    }
	    function createIterationTypes(yieldType = neverType, returnType = neverType, nextType = unknownType) {
	      if (yieldType.flags & 67359327 /* Intrinsic */ && returnType.flags & (1 /* Any */ | 131072 /* Never */ | 2 /* Unknown */ | 16384 /* Void */ | 32768 /* Undefined */) && nextType.flags & (1 /* Any */ | 131072 /* Never */ | 2 /* Unknown */ | 16384 /* Void */ | 32768 /* Undefined */)) {
	        const id = getTypeListId([yieldType, returnType, nextType]);
	        let iterationTypes = iterationTypesCache.get(id);
	        if (!iterationTypes) {
	          iterationTypes = { yieldType, returnType, nextType };
	          iterationTypesCache.set(id, iterationTypes);
	        }
	        return iterationTypes;
	      }
	      return { yieldType, returnType, nextType };
	    }
	    function combineIterationTypes(array) {
	      let yieldTypes;
	      let returnTypes;
	      let nextTypes;
	      for (const iterationTypes of array) {
	        if (iterationTypes === void 0 || iterationTypes === noIterationTypes) {
	          continue;
	        }
	        if (iterationTypes === anyIterationTypes) {
	          return anyIterationTypes;
	        }
	        yieldTypes = append(yieldTypes, iterationTypes.yieldType);
	        returnTypes = append(returnTypes, iterationTypes.returnType);
	        nextTypes = append(nextTypes, iterationTypes.nextType);
	      }
	      if (yieldTypes || returnTypes || nextTypes) {
	        return createIterationTypes(
	          yieldTypes && getUnionType(yieldTypes),
	          returnTypes && getUnionType(returnTypes),
	          nextTypes && getIntersectionType(nextTypes)
	        );
	      }
	      return noIterationTypes;
	    }
	    function getCachedIterationTypes(type, cacheKey) {
	      return type[cacheKey];
	    }
	    function setCachedIterationTypes(type, cacheKey, cachedTypes2) {
	      return type[cacheKey] = cachedTypes2;
	    }
	    function getIterationTypesOfIterable(type, use, errorNode) {
	      var _a, _b;
	      if (isTypeAny(type)) {
	        return anyIterationTypes;
	      }
	      if (!(type.flags & 1048576 /* Union */)) {
	        const errorOutputContainer = errorNode ? { errors: void 0 } : void 0;
	        const iterationTypes2 = getIterationTypesOfIterableWorker(type, use, errorNode, errorOutputContainer);
	        if (iterationTypes2 === noIterationTypes) {
	          if (errorNode) {
	            const rootDiag = reportTypeNotIterableError(errorNode, type, !!(use & 2 /* AllowsAsyncIterablesFlag */));
	            if (errorOutputContainer == null ? void 0 : errorOutputContainer.errors) {
	              addRelatedInfo(rootDiag, ...errorOutputContainer.errors);
	            }
	          }
	          return void 0;
	        } else if ((_a = errorOutputContainer == null ? void 0 : errorOutputContainer.errors) == null ? void 0 : _a.length) {
	          for (const diag2 of errorOutputContainer.errors) {
	            diagnostics.add(diag2);
	          }
	        }
	        return iterationTypes2;
	      }
	      const cacheKey = use & 2 /* AllowsAsyncIterablesFlag */ ? "iterationTypesOfAsyncIterable" : "iterationTypesOfIterable";
	      const cachedTypes2 = getCachedIterationTypes(type, cacheKey);
	      if (cachedTypes2)
	        return cachedTypes2 === noIterationTypes ? void 0 : cachedTypes2;
	      let allIterationTypes;
	      for (const constituent of type.types) {
	        const errorOutputContainer = errorNode ? { errors: void 0 } : void 0;
	        const iterationTypes2 = getIterationTypesOfIterableWorker(constituent, use, errorNode, errorOutputContainer);
	        if (iterationTypes2 === noIterationTypes) {
	          if (errorNode) {
	            const rootDiag = reportTypeNotIterableError(errorNode, type, !!(use & 2 /* AllowsAsyncIterablesFlag */));
	            if (errorOutputContainer == null ? void 0 : errorOutputContainer.errors) {
	              addRelatedInfo(rootDiag, ...errorOutputContainer.errors);
	            }
	          }
	          setCachedIterationTypes(type, cacheKey, noIterationTypes);
	          return void 0;
	        } else if ((_b = errorOutputContainer == null ? void 0 : errorOutputContainer.errors) == null ? void 0 : _b.length) {
	          for (const diag2 of errorOutputContainer.errors) {
	            diagnostics.add(diag2);
	          }
	        }
	        allIterationTypes = append(allIterationTypes, iterationTypes2);
	      }
	      const iterationTypes = allIterationTypes ? combineIterationTypes(allIterationTypes) : noIterationTypes;
	      setCachedIterationTypes(type, cacheKey, iterationTypes);
	      return iterationTypes === noIterationTypes ? void 0 : iterationTypes;
	    }
	    function getAsyncFromSyncIterationTypes(iterationTypes, errorNode) {
	      if (iterationTypes === noIterationTypes)
	        return noIterationTypes;
	      if (iterationTypes === anyIterationTypes)
	        return anyIterationTypes;
	      const { yieldType, returnType, nextType } = iterationTypes;
	      if (errorNode) {
	        getGlobalAwaitedSymbol(
	          /*reportErrors*/
	          true
	        );
	      }
	      return createIterationTypes(
	        getAwaitedType(yieldType, errorNode) || anyType,
	        getAwaitedType(returnType, errorNode) || anyType,
	        nextType
	      );
	    }
	    function getIterationTypesOfIterableWorker(type, use, errorNode, errorOutputContainer) {
	      if (isTypeAny(type)) {
	        return anyIterationTypes;
	      }
	      let noCache = false;
	      if (use & 2 /* AllowsAsyncIterablesFlag */) {
	        const iterationTypes = getIterationTypesOfIterableCached(type, asyncIterationTypesResolver) || getIterationTypesOfIterableFast(type, asyncIterationTypesResolver);
	        if (iterationTypes) {
	          if (iterationTypes === noIterationTypes && errorNode) {
	            noCache = true;
	          } else {
	            return use & 8 /* ForOfFlag */ ? getAsyncFromSyncIterationTypes(iterationTypes, errorNode) : iterationTypes;
	          }
	        }
	      }
	      if (use & 1 /* AllowsSyncIterablesFlag */) {
	        let iterationTypes = getIterationTypesOfIterableCached(type, syncIterationTypesResolver) || getIterationTypesOfIterableFast(type, syncIterationTypesResolver);
	        if (iterationTypes) {
	          if (iterationTypes === noIterationTypes && errorNode) {
	            noCache = true;
	          } else {
	            if (use & 2 /* AllowsAsyncIterablesFlag */) {
	              if (iterationTypes !== noIterationTypes) {
	                iterationTypes = getAsyncFromSyncIterationTypes(iterationTypes, errorNode);
	                return noCache ? iterationTypes : setCachedIterationTypes(type, "iterationTypesOfAsyncIterable", iterationTypes);
	              }
	            } else {
	              return iterationTypes;
	            }
	          }
	        }
	      }
	      if (use & 2 /* AllowsAsyncIterablesFlag */) {
	        const iterationTypes = getIterationTypesOfIterableSlow(type, asyncIterationTypesResolver, errorNode, errorOutputContainer, noCache);
	        if (iterationTypes !== noIterationTypes) {
	          return iterationTypes;
	        }
	      }
	      if (use & 1 /* AllowsSyncIterablesFlag */) {
	        let iterationTypes = getIterationTypesOfIterableSlow(type, syncIterationTypesResolver, errorNode, errorOutputContainer, noCache);
	        if (iterationTypes !== noIterationTypes) {
	          if (use & 2 /* AllowsAsyncIterablesFlag */) {
	            iterationTypes = getAsyncFromSyncIterationTypes(iterationTypes, errorNode);
	            return noCache ? iterationTypes : setCachedIterationTypes(type, "iterationTypesOfAsyncIterable", iterationTypes);
	          } else {
	            return iterationTypes;
	          }
	        }
	      }
	      return noIterationTypes;
	    }
	    function getIterationTypesOfIterableCached(type, resolver) {
	      return getCachedIterationTypes(type, resolver.iterableCacheKey);
	    }
	    function getIterationTypesOfGlobalIterableType(globalType, resolver) {
	      const globalIterationTypes = getIterationTypesOfIterableCached(globalType, resolver) || getIterationTypesOfIterableSlow(
	        globalType,
	        resolver,
	        /*errorNode*/
	        void 0,
	        /*errorOutputContainer*/
	        void 0,
	        /*noCache*/
	        false
	      );
	      return globalIterationTypes === noIterationTypes ? defaultIterationTypes : globalIterationTypes;
	    }
	    function getIterationTypesOfIterableFast(type, resolver) {
	      let globalType;
	      if (isReferenceToType2(type, globalType = resolver.getGlobalIterableType(
	        /*reportErrors*/
	        false
	      )) || isReferenceToType2(type, globalType = resolver.getGlobalIterableIteratorType(
	        /*reportErrors*/
	        false
	      ))) {
	        const [yieldType] = getTypeArguments(type);
	        const { returnType, nextType } = getIterationTypesOfGlobalIterableType(globalType, resolver);
	        return setCachedIterationTypes(type, resolver.iterableCacheKey, createIterationTypes(resolver.resolveIterationType(
	          yieldType,
	          /*errorNode*/
	          void 0
	        ) || yieldType, resolver.resolveIterationType(
	          returnType,
	          /*errorNode*/
	          void 0
	        ) || returnType, nextType));
	      }
	      if (isReferenceToType2(type, resolver.getGlobalGeneratorType(
	        /*reportErrors*/
	        false
	      ))) {
	        const [yieldType, returnType, nextType] = getTypeArguments(type);
	        return setCachedIterationTypes(type, resolver.iterableCacheKey, createIterationTypes(resolver.resolveIterationType(
	          yieldType,
	          /*errorNode*/
	          void 0
	        ) || yieldType, resolver.resolveIterationType(
	          returnType,
	          /*errorNode*/
	          void 0
	        ) || returnType, nextType));
	      }
	    }
	    function getPropertyNameForKnownSymbolName(symbolName2) {
	      const ctorType = getGlobalESSymbolConstructorSymbol(
	        /*reportErrors*/
	        false
	      );
	      const uniqueType = ctorType && getTypeOfPropertyOfType(getTypeOfSymbol(ctorType), escapeLeadingUnderscores(symbolName2));
	      return uniqueType && isTypeUsableAsPropertyName(uniqueType) ? getPropertyNameFromType(uniqueType) : `__@${symbolName2}`;
	    }
	    function getIterationTypesOfIterableSlow(type, resolver, errorNode, errorOutputContainer, noCache) {
	      const method = getPropertyOfType(type, getPropertyNameForKnownSymbolName(resolver.iteratorSymbolName));
	      const methodType = method && !(method.flags & 16777216 /* Optional */) ? getTypeOfSymbol(method) : void 0;
	      if (isTypeAny(methodType)) {
	        return noCache ? anyIterationTypes : setCachedIterationTypes(type, resolver.iterableCacheKey, anyIterationTypes);
	      }
	      const signatures = methodType ? getSignaturesOfType(methodType, 0 /* Call */) : void 0;
	      if (!some(signatures)) {
	        return noCache ? noIterationTypes : setCachedIterationTypes(type, resolver.iterableCacheKey, noIterationTypes);
	      }
	      const iteratorType = getIntersectionType(map(signatures, getReturnTypeOfSignature));
	      const iterationTypes = getIterationTypesOfIteratorWorker(iteratorType, resolver, errorNode, errorOutputContainer, noCache) ?? noIterationTypes;
	      return noCache ? iterationTypes : setCachedIterationTypes(type, resolver.iterableCacheKey, iterationTypes);
	    }
	    function reportTypeNotIterableError(errorNode, type, allowAsyncIterables) {
	      const message = allowAsyncIterables ? Diagnostics.Type_0_must_have_a_Symbol_asyncIterator_method_that_returns_an_async_iterator : Diagnostics.Type_0_must_have_a_Symbol_iterator_method_that_returns_an_iterator;
	      const suggestAwait = (
	        // for (const x of Promise<...>) or [...Promise<...>]
	        !!getAwaitedTypeOfPromise(type) || !allowAsyncIterables && isForOfStatement(errorNode.parent) && errorNode.parent.expression === errorNode && getGlobalAsyncIterableType(
	          /*reportErrors*/
	          false
	        ) !== emptyGenericType && isTypeAssignableTo(type, getGlobalAsyncIterableType(
	          /*reportErrors*/
	          false
	        ))
	      );
	      return errorAndMaybeSuggestAwait(errorNode, suggestAwait, message, typeToString(type));
	    }
	    function getIterationTypesOfIterator(type, resolver, errorNode, errorOutputContainer) {
	      return getIterationTypesOfIteratorWorker(
	        type,
	        resolver,
	        errorNode,
	        errorOutputContainer,
	        /*noCache*/
	        false
	      );
	    }
	    function getIterationTypesOfIteratorWorker(type, resolver, errorNode, errorOutputContainer, noCache) {
	      if (isTypeAny(type)) {
	        return anyIterationTypes;
	      }
	      let iterationTypes = getIterationTypesOfIteratorCached(type, resolver) || getIterationTypesOfIteratorFast(type, resolver);
	      if (iterationTypes === noIterationTypes && errorNode) {
	        iterationTypes = void 0;
	        noCache = true;
	      }
	      iterationTypes ?? (iterationTypes = getIterationTypesOfIteratorSlow(type, resolver, errorNode, errorOutputContainer, noCache));
	      return iterationTypes === noIterationTypes ? void 0 : iterationTypes;
	    }
	    function getIterationTypesOfIteratorCached(type, resolver) {
	      return getCachedIterationTypes(type, resolver.iteratorCacheKey);
	    }
	    function getIterationTypesOfIteratorFast(type, resolver) {
	      const globalType = resolver.getGlobalIterableIteratorType(
	        /*reportErrors*/
	        false
	      );
	      if (isReferenceToType2(type, globalType)) {
	        const [yieldType] = getTypeArguments(type);
	        const globalIterationTypes = getIterationTypesOfIteratorCached(globalType, resolver) || getIterationTypesOfIteratorSlow(
	          globalType,
	          resolver,
	          /*errorNode*/
	          void 0,
	          /*errorOutputContainer*/
	          void 0,
	          /*noCache*/
	          false
	        );
	        const { returnType, nextType } = globalIterationTypes === noIterationTypes ? defaultIterationTypes : globalIterationTypes;
	        return setCachedIterationTypes(type, resolver.iteratorCacheKey, createIterationTypes(yieldType, returnType, nextType));
	      }
	      if (isReferenceToType2(type, resolver.getGlobalIteratorType(
	        /*reportErrors*/
	        false
	      )) || isReferenceToType2(type, resolver.getGlobalGeneratorType(
	        /*reportErrors*/
	        false
	      ))) {
	        const [yieldType, returnType, nextType] = getTypeArguments(type);
	        return setCachedIterationTypes(type, resolver.iteratorCacheKey, createIterationTypes(yieldType, returnType, nextType));
	      }
	    }
	    function isIteratorResult(type, kind) {
	      const doneType = getTypeOfPropertyOfType(type, "done") || falseType;
	      return isTypeAssignableTo(kind === 0 /* Yield */ ? falseType : trueType, doneType);
	    }
	    function isYieldIteratorResult(type) {
	      return isIteratorResult(type, 0 /* Yield */);
	    }
	    function isReturnIteratorResult(type) {
	      return isIteratorResult(type, 1 /* Return */);
	    }
	    function getIterationTypesOfIteratorResult(type) {
	      if (isTypeAny(type)) {
	        return anyIterationTypes;
	      }
	      const cachedTypes2 = getCachedIterationTypes(type, "iterationTypesOfIteratorResult");
	      if (cachedTypes2) {
	        return cachedTypes2;
	      }
	      if (isReferenceToType2(type, getGlobalIteratorYieldResultType(
	        /*reportErrors*/
	        false
	      ))) {
	        const yieldType2 = getTypeArguments(type)[0];
	        return setCachedIterationTypes(type, "iterationTypesOfIteratorResult", createIterationTypes(
	          yieldType2,
	          /*returnType*/
	          void 0,
	          /*nextType*/
	          void 0
	        ));
	      }
	      if (isReferenceToType2(type, getGlobalIteratorReturnResultType(
	        /*reportErrors*/
	        false
	      ))) {
	        const returnType2 = getTypeArguments(type)[0];
	        return setCachedIterationTypes(type, "iterationTypesOfIteratorResult", createIterationTypes(
	          /*yieldType*/
	          void 0,
	          returnType2,
	          /*nextType*/
	          void 0
	        ));
	      }
	      const yieldIteratorResult = filterType(type, isYieldIteratorResult);
	      const yieldType = yieldIteratorResult !== neverType ? getTypeOfPropertyOfType(yieldIteratorResult, "value") : void 0;
	      const returnIteratorResult = filterType(type, isReturnIteratorResult);
	      const returnType = returnIteratorResult !== neverType ? getTypeOfPropertyOfType(returnIteratorResult, "value") : void 0;
	      if (!yieldType && !returnType) {
	        return setCachedIterationTypes(type, "iterationTypesOfIteratorResult", noIterationTypes);
	      }
	      return setCachedIterationTypes(type, "iterationTypesOfIteratorResult", createIterationTypes(
	        yieldType,
	        returnType || voidType,
	        /*nextType*/
	        void 0
	      ));
	    }
	    function getIterationTypesOfMethod(type, resolver, methodName, errorNode, errorOutputContainer) {
	      var _a, _b, _c, _d;
	      const method = getPropertyOfType(type, methodName);
	      if (!method && methodName !== "next") {
	        return void 0;
	      }
	      const methodType = method && !(methodName === "next" && method.flags & 16777216 /* Optional */) ? methodName === "next" ? getTypeOfSymbol(method) : getTypeWithFacts(getTypeOfSymbol(method), 2097152 /* NEUndefinedOrNull */) : void 0;
	      if (isTypeAny(methodType)) {
	        return methodName === "next" ? anyIterationTypes : anyIterationTypesExceptNext;
	      }
	      const methodSignatures = methodType ? getSignaturesOfType(methodType, 0 /* Call */) : emptyArray;
	      if (methodSignatures.length === 0) {
	        if (errorNode) {
	          const diagnostic = methodName === "next" ? resolver.mustHaveANextMethodDiagnostic : resolver.mustBeAMethodDiagnostic;
	          if (errorOutputContainer) {
	            errorOutputContainer.errors ?? (errorOutputContainer.errors = []);
	            errorOutputContainer.errors.push(createDiagnosticForNode(errorNode, diagnostic, methodName));
	          } else {
	            error2(errorNode, diagnostic, methodName);
	          }
	        }
	        return methodName === "next" ? noIterationTypes : void 0;
	      }
	      if ((methodType == null ? void 0 : methodType.symbol) && methodSignatures.length === 1) {
	        const globalGeneratorType = resolver.getGlobalGeneratorType(
	          /*reportErrors*/
	          false
	        );
	        const globalIteratorType = resolver.getGlobalIteratorType(
	          /*reportErrors*/
	          false
	        );
	        const isGeneratorMethod = ((_b = (_a = globalGeneratorType.symbol) == null ? void 0 : _a.members) == null ? void 0 : _b.get(methodName)) === methodType.symbol;
	        const isIteratorMethod = !isGeneratorMethod && ((_d = (_c = globalIteratorType.symbol) == null ? void 0 : _c.members) == null ? void 0 : _d.get(methodName)) === methodType.symbol;
	        if (isGeneratorMethod || isIteratorMethod) {
	          const globalType = isGeneratorMethod ? globalGeneratorType : globalIteratorType;
	          const { mapper } = methodType;
	          return createIterationTypes(
	            getMappedType(globalType.typeParameters[0], mapper),
	            getMappedType(globalType.typeParameters[1], mapper),
	            methodName === "next" ? getMappedType(globalType.typeParameters[2], mapper) : void 0
	          );
	        }
	      }
	      let methodParameterTypes;
	      let methodReturnTypes;
	      for (const signature of methodSignatures) {
	        if (methodName !== "throw" && some(signature.parameters)) {
	          methodParameterTypes = append(methodParameterTypes, getTypeAtPosition(signature, 0));
	        }
	        methodReturnTypes = append(methodReturnTypes, getReturnTypeOfSignature(signature));
	      }
	      let returnTypes;
	      let nextType;
	      if (methodName !== "throw") {
	        const methodParameterType = methodParameterTypes ? getUnionType(methodParameterTypes) : unknownType;
	        if (methodName === "next") {
	          nextType = methodParameterType;
	        } else if (methodName === "return") {
	          const resolvedMethodParameterType = resolver.resolveIterationType(methodParameterType, errorNode) || anyType;
	          returnTypes = append(returnTypes, resolvedMethodParameterType);
	        }
	      }
	      let yieldType;
	      const methodReturnType = methodReturnTypes ? getIntersectionType(methodReturnTypes) : neverType;
	      const resolvedMethodReturnType = resolver.resolveIterationType(methodReturnType, errorNode) || anyType;
	      const iterationTypes = getIterationTypesOfIteratorResult(resolvedMethodReturnType);
	      if (iterationTypes === noIterationTypes) {
	        if (errorNode) {
	          if (errorOutputContainer) {
	            errorOutputContainer.errors ?? (errorOutputContainer.errors = []);
	            errorOutputContainer.errors.push(createDiagnosticForNode(errorNode, resolver.mustHaveAValueDiagnostic, methodName));
	          } else {
	            error2(errorNode, resolver.mustHaveAValueDiagnostic, methodName);
	          }
	        }
	        yieldType = anyType;
	        returnTypes = append(returnTypes, anyType);
	      } else {
	        yieldType = iterationTypes.yieldType;
	        returnTypes = append(returnTypes, iterationTypes.returnType);
	      }
	      return createIterationTypes(yieldType, getUnionType(returnTypes), nextType);
	    }
	    function getIterationTypesOfIteratorSlow(type, resolver, errorNode, errorOutputContainer, noCache) {
	      const iterationTypes = combineIterationTypes([
	        getIterationTypesOfMethod(type, resolver, "next", errorNode, errorOutputContainer),
	        getIterationTypesOfMethod(type, resolver, "return", errorNode, errorOutputContainer),
	        getIterationTypesOfMethod(type, resolver, "throw", errorNode, errorOutputContainer)
	      ]);
	      return noCache ? iterationTypes : setCachedIterationTypes(type, resolver.iteratorCacheKey, iterationTypes);
	    }
	    function getIterationTypeOfGeneratorFunctionReturnType(kind, returnType, isAsyncGenerator) {
	      if (isTypeAny(returnType)) {
	        return void 0;
	      }
	      const iterationTypes = getIterationTypesOfGeneratorFunctionReturnType(returnType, isAsyncGenerator);
	      return iterationTypes && iterationTypes[getIterationTypesKeyFromIterationTypeKind(kind)];
	    }
	    function getIterationTypesOfGeneratorFunctionReturnType(type, isAsyncGenerator) {
	      if (isTypeAny(type)) {
	        return anyIterationTypes;
	      }
	      const use = isAsyncGenerator ? 2 /* AsyncGeneratorReturnType */ : 1 /* GeneratorReturnType */;
	      const resolver = isAsyncGenerator ? asyncIterationTypesResolver : syncIterationTypesResolver;
	      return getIterationTypesOfIterable(
	        type,
	        use,
	        /*errorNode*/
	        void 0
	      ) || getIterationTypesOfIterator(
	        type,
	        resolver,
	        /*errorNode*/
	        void 0,
	        /*errorOutputContainer*/
	        void 0
	      );
	    }
	    function checkBreakOrContinueStatement(node) {
	      if (!checkGrammarStatementInAmbientContext(node))
	        checkGrammarBreakOrContinueStatement(node);
	    }
	    function unwrapReturnType(returnType, functionFlags) {
	      const isGenerator = !!(functionFlags & 1 /* Generator */);
	      const isAsync = !!(functionFlags & 2 /* Async */);
	      if (isGenerator) {
	        const returnIterationType = getIterationTypeOfGeneratorFunctionReturnType(1 /* Return */, returnType, isAsync);
	        if (!returnIterationType) {
	          return errorType;
	        }
	        return isAsync ? getAwaitedTypeNoAlias(unwrapAwaitedType(returnIterationType)) : returnIterationType;
	      }
	      return isAsync ? getAwaitedTypeNoAlias(returnType) || errorType : returnType;
	    }
	    function isUnwrappedReturnTypeUndefinedVoidOrAny(func, returnType) {
	      const type = unwrapReturnType(returnType, getFunctionFlags(func));
	      return !!(type && (maybeTypeOfKind(type, 16384 /* Void */) || type.flags & (1 /* Any */ | 32768 /* Undefined */)));
	    }
	    function checkReturnStatement(node) {
	      if (checkGrammarStatementInAmbientContext(node)) {
	        return;
	      }
	      const container = getContainingFunctionOrClassStaticBlock(node);
	      if (container && isClassStaticBlockDeclaration(container)) {
	        grammarErrorOnFirstToken(node, Diagnostics.A_return_statement_cannot_be_used_inside_a_class_static_block);
	        return;
	      }
	      if (!container) {
	        grammarErrorOnFirstToken(node, Diagnostics.A_return_statement_can_only_be_used_within_a_function_body);
	        return;
	      }
	      const signature = getSignatureFromDeclaration(container);
	      const returnType = getReturnTypeOfSignature(signature);
	      const functionFlags = getFunctionFlags(container);
	      if (strictNullChecks || node.expression || returnType.flags & 131072 /* Never */) {
	        const exprType = node.expression ? checkExpressionCached(node.expression) : undefinedType;
	        if (container.kind === 178 /* SetAccessor */) {
	          if (node.expression) {
	            error2(node, Diagnostics.Setters_cannot_return_a_value);
	          }
	        } else if (container.kind === 176 /* Constructor */) {
	          if (node.expression && !checkTypeAssignableToAndOptionallyElaborate(exprType, returnType, node, node.expression)) {
	            error2(node, Diagnostics.Return_type_of_constructor_signature_must_be_assignable_to_the_instance_type_of_the_class);
	          }
	        } else if (getReturnTypeFromAnnotation(container)) {
	          const unwrappedReturnType = unwrapReturnType(returnType, functionFlags) ?? returnType;
	          const unwrappedExprType = functionFlags & 2 /* Async */ ? checkAwaitedType(
	            exprType,
	            /*withAlias*/
	            false,
	            node,
	            Diagnostics.The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member
	          ) : exprType;
	          if (unwrappedReturnType) {
	            checkTypeAssignableToAndOptionallyElaborate(unwrappedExprType, unwrappedReturnType, node, node.expression);
	          }
	        }
	      } else if (container.kind !== 176 /* Constructor */ && compilerOptions.noImplicitReturns && !isUnwrappedReturnTypeUndefinedVoidOrAny(container, returnType)) {
	        error2(node, Diagnostics.Not_all_code_paths_return_a_value);
	      }
	    }
	    function checkWithStatement(node) {
	      if (!checkGrammarStatementInAmbientContext(node)) {
	        if (node.flags & 65536 /* AwaitContext */) {
	          grammarErrorOnFirstToken(node, Diagnostics.with_statements_are_not_allowed_in_an_async_function_block);
	        }
	      }
	      checkExpression(node.expression);
	      const sourceFile = getSourceFileOfNode(node);
	      if (!hasParseDiagnostics(sourceFile)) {
	        const start = getSpanOfTokenAtPosition(sourceFile, node.pos).start;
	        const end = node.statement.pos;
	        grammarErrorAtPos(sourceFile, start, end - start, Diagnostics.The_with_statement_is_not_supported_All_symbols_in_a_with_block_will_have_type_any);
	      }
	    }
	    function checkSwitchStatement(node) {
	      checkGrammarStatementInAmbientContext(node);
	      let firstDefaultClause;
	      let hasDuplicateDefaultClause = false;
	      const expressionType = checkExpression(node.expression);
	      forEach(node.caseBlock.clauses, (clause) => {
	        if (clause.kind === 297 /* DefaultClause */ && !hasDuplicateDefaultClause) {
	          if (firstDefaultClause === void 0) {
	            firstDefaultClause = clause;
	          } else {
	            grammarErrorOnNode(clause, Diagnostics.A_default_clause_cannot_appear_more_than_once_in_a_switch_statement);
	            hasDuplicateDefaultClause = true;
	          }
	        }
	        if (clause.kind === 296 /* CaseClause */) {
	          addLazyDiagnostic(createLazyCaseClauseDiagnostics(clause));
	        }
	        forEach(clause.statements, checkSourceElement);
	        if (compilerOptions.noFallthroughCasesInSwitch && clause.fallthroughFlowNode && isReachableFlowNode(clause.fallthroughFlowNode)) {
	          error2(clause, Diagnostics.Fallthrough_case_in_switch);
	        }
	        function createLazyCaseClauseDiagnostics(clause2) {
	          return () => {
	            const caseType = checkExpression(clause2.expression);
	            if (!isTypeEqualityComparableTo(expressionType, caseType)) {
	              checkTypeComparableTo(
	                caseType,
	                expressionType,
	                clause2.expression,
	                /*headMessage*/
	                void 0
	              );
	            }
	          };
	        }
	      });
	      if (node.caseBlock.locals) {
	        registerForUnusedIdentifiersCheck(node.caseBlock);
	      }
	    }
	    function checkLabeledStatement(node) {
	      if (!checkGrammarStatementInAmbientContext(node)) {
	        findAncestor(node.parent, (current) => {
	          if (isFunctionLike(current)) {
	            return "quit";
	          }
	          if (current.kind === 256 /* LabeledStatement */ && current.label.escapedText === node.label.escapedText) {
	            grammarErrorOnNode(node.label, Diagnostics.Duplicate_label_0, getTextOfNode(node.label));
	            return true;
	          }
	          return false;
	        });
	      }
	      checkSourceElement(node.statement);
	    }
	    function checkThrowStatement(node) {
	      if (!checkGrammarStatementInAmbientContext(node)) {
	        if (isIdentifier(node.expression) && !node.expression.escapedText) {
	          grammarErrorAfterFirstToken(node, Diagnostics.Line_break_not_permitted_here);
	        }
	      }
	      if (node.expression) {
	        checkExpression(node.expression);
	      }
	    }
	    function checkTryStatement(node) {
	      checkGrammarStatementInAmbientContext(node);
	      checkBlock(node.tryBlock);
	      const catchClause = node.catchClause;
	      if (catchClause) {
	        if (catchClause.variableDeclaration) {
	          const declaration = catchClause.variableDeclaration;
	          checkVariableLikeDeclaration(declaration);
	          const typeNode = getEffectiveTypeAnnotationNode(declaration);
	          if (typeNode) {
	            const type = getTypeFromTypeNode(typeNode);
	            if (type && !(type.flags & 3 /* AnyOrUnknown */)) {
	              grammarErrorOnFirstToken(typeNode, Diagnostics.Catch_clause_variable_type_annotation_must_be_any_or_unknown_if_specified);
	            }
	          } else if (declaration.initializer) {
	            grammarErrorOnFirstToken(declaration.initializer, Diagnostics.Catch_clause_variable_cannot_have_an_initializer);
	          } else {
	            const blockLocals = catchClause.block.locals;
	            if (blockLocals) {
	              forEachKey(catchClause.locals, (caughtName) => {
	                const blockLocal = blockLocals.get(caughtName);
	                if ((blockLocal == null ? void 0 : blockLocal.valueDeclaration) && (blockLocal.flags & 2 /* BlockScopedVariable */) !== 0) {
	                  grammarErrorOnNode(blockLocal.valueDeclaration, Diagnostics.Cannot_redeclare_identifier_0_in_catch_clause, unescapeLeadingUnderscores(caughtName));
	                }
	              });
	            }
	          }
	        }
	        checkBlock(catchClause.block);
	      }
	      if (node.finallyBlock) {
	        checkBlock(node.finallyBlock);
	      }
	    }
	    function checkIndexConstraints(type, symbol, isStaticIndex) {
	      const indexInfos = getIndexInfosOfType(type);
	      if (indexInfos.length === 0) {
	        return;
	      }
	      for (const prop of getPropertiesOfObjectType(type)) {
	        if (!(isStaticIndex && prop.flags & 4194304 /* Prototype */)) {
	          checkIndexConstraintForProperty(type, prop, getLiteralTypeFromProperty(
	            prop,
	            8576 /* StringOrNumberLiteralOrUnique */,
	            /*includeNonPublic*/
	            true
	          ), getNonMissingTypeOfSymbol(prop));
	        }
	      }
	      const typeDeclaration = symbol.valueDeclaration;
	      if (typeDeclaration && isClassLike(typeDeclaration)) {
	        for (const member of typeDeclaration.members) {
	          if (!isStatic(member) && !hasBindableName(member)) {
	            const symbol2 = getSymbolOfDeclaration(member);
	            checkIndexConstraintForProperty(type, symbol2, getTypeOfExpression(member.name.expression), getNonMissingTypeOfSymbol(symbol2));
	          }
	        }
	      }
	      if (indexInfos.length > 1) {
	        for (const info of indexInfos) {
	          checkIndexConstraintForIndexSignature(type, info);
	        }
	      }
	    }
	    function checkIndexConstraintForProperty(type, prop, propNameType, propType) {
	      const declaration = prop.valueDeclaration;
	      const name = getNameOfDeclaration(declaration);
	      if (name && isPrivateIdentifier(name)) {
	        return;
	      }
	      const indexInfos = getApplicableIndexInfos(type, propNameType);
	      const interfaceDeclaration = getObjectFlags(type) & 2 /* Interface */ ? getDeclarationOfKind(type.symbol, 264 /* InterfaceDeclaration */) : void 0;
	      const propDeclaration = declaration && declaration.kind === 226 /* BinaryExpression */ || name && name.kind === 167 /* ComputedPropertyName */ ? declaration : void 0;
	      const localPropDeclaration = getParentOfSymbol(prop) === type.symbol ? declaration : void 0;
	      for (const info of indexInfos) {
	        const localIndexDeclaration = info.declaration && getParentOfSymbol(getSymbolOfDeclaration(info.declaration)) === type.symbol ? info.declaration : void 0;
	        const errorNode = localPropDeclaration || localIndexDeclaration || (interfaceDeclaration && !some(getBaseTypes(type), (base) => !!getPropertyOfObjectType(base, prop.escapedName) && !!getIndexTypeOfType(base, info.keyType)) ? interfaceDeclaration : void 0);
	        if (errorNode && !isTypeAssignableTo(propType, info.type)) {
	          const diagnostic = createError(errorNode, Diagnostics.Property_0_of_type_1_is_not_assignable_to_2_index_type_3, symbolToString(prop), typeToString(propType), typeToString(info.keyType), typeToString(info.type));
	          if (propDeclaration && errorNode !== propDeclaration) {
	            addRelatedInfo(diagnostic, createDiagnosticForNode(propDeclaration, Diagnostics._0_is_declared_here, symbolToString(prop)));
	          }
	          diagnostics.add(diagnostic);
	        }
	      }
	    }
	    function checkIndexConstraintForIndexSignature(type, checkInfo) {
	      const declaration = checkInfo.declaration;
	      const indexInfos = getApplicableIndexInfos(type, checkInfo.keyType);
	      const interfaceDeclaration = getObjectFlags(type) & 2 /* Interface */ ? getDeclarationOfKind(type.symbol, 264 /* InterfaceDeclaration */) : void 0;
	      const localCheckDeclaration = declaration && getParentOfSymbol(getSymbolOfDeclaration(declaration)) === type.symbol ? declaration : void 0;
	      for (const info of indexInfos) {
	        if (info === checkInfo)
	          continue;
	        const localIndexDeclaration = info.declaration && getParentOfSymbol(getSymbolOfDeclaration(info.declaration)) === type.symbol ? info.declaration : void 0;
	        const errorNode = localCheckDeclaration || localIndexDeclaration || (interfaceDeclaration && !some(getBaseTypes(type), (base) => !!getIndexInfoOfType(base, checkInfo.keyType) && !!getIndexTypeOfType(base, info.keyType)) ? interfaceDeclaration : void 0);
	        if (errorNode && !isTypeAssignableTo(checkInfo.type, info.type)) {
	          error2(errorNode, Diagnostics._0_index_type_1_is_not_assignable_to_2_index_type_3, typeToString(checkInfo.keyType), typeToString(checkInfo.type), typeToString(info.keyType), typeToString(info.type));
	        }
	      }
	    }
	    function checkTypeNameIsReserved(name, message) {
	      switch (name.escapedText) {
	        case "any":
	        case "unknown":
	        case "never":
	        case "number":
	        case "bigint":
	        case "boolean":
	        case "string":
	        case "symbol":
	        case "void":
	        case "object":
	          error2(name, message, name.escapedText);
	      }
	    }
	    function checkClassNameCollisionWithObject(name) {
	      if (languageVersion >= 1 /* ES5 */ && name.escapedText === "Object" && (moduleKind < 5 /* ES2015 */ || getSourceFileOfNode(name).impliedNodeFormat === 1 /* CommonJS */)) {
	        error2(name, Diagnostics.Class_name_cannot_be_Object_when_targeting_ES5_with_module_0, ModuleKind[moduleKind]);
	      }
	    }
	    function checkUnmatchedJSDocParameters(node) {
	      const jsdocParameters = filter(getJSDocTags(node), isJSDocParameterTag);
	      if (!length(jsdocParameters))
	        return;
	      const isJs = isInJSFile(node);
	      const parameters = /* @__PURE__ */ new Set();
	      const excludedParameters = /* @__PURE__ */ new Set();
	      forEach(node.parameters, ({ name }, index) => {
	        if (isIdentifier(name)) {
	          parameters.add(name.escapedText);
	        }
	        if (isBindingPattern(name)) {
	          excludedParameters.add(index);
	        }
	      });
	      const containsArguments = containsArgumentsReference(node);
	      if (containsArguments) {
	        const lastJSDocParamIndex = jsdocParameters.length - 1;
	        const lastJSDocParam = jsdocParameters[lastJSDocParamIndex];
	        if (isJs && lastJSDocParam && isIdentifier(lastJSDocParam.name) && lastJSDocParam.typeExpression && lastJSDocParam.typeExpression.type && !parameters.has(lastJSDocParam.name.escapedText) && !excludedParameters.has(lastJSDocParamIndex) && !isArrayType(getTypeFromTypeNode(lastJSDocParam.typeExpression.type))) {
	          error2(lastJSDocParam.name, Diagnostics.JSDoc_param_tag_has_name_0_but_there_is_no_parameter_with_that_name_It_would_match_arguments_if_it_had_an_array_type, idText(lastJSDocParam.name));
	        }
	      } else {
	        forEach(jsdocParameters, ({ name, isNameFirst }, index) => {
	          if (excludedParameters.has(index) || isIdentifier(name) && parameters.has(name.escapedText)) {
	            return;
	          }
	          if (isQualifiedName(name)) {
	            if (isJs) {
	              error2(name, Diagnostics.Qualified_name_0_is_not_allowed_without_a_leading_param_object_1, entityNameToString(name), entityNameToString(name.left));
	            }
	          } else {
	            if (!isNameFirst) {
	              errorOrSuggestion(isJs, name, Diagnostics.JSDoc_param_tag_has_name_0_but_there_is_no_parameter_with_that_name, idText(name));
	            }
	          }
	        });
	      }
	    }
	    function checkTypeParameters(typeParameterDeclarations) {
	      let seenDefault = false;
	      if (typeParameterDeclarations) {
	        for (let i = 0; i < typeParameterDeclarations.length; i++) {
	          const node = typeParameterDeclarations[i];
	          checkTypeParameter(node);
	          addLazyDiagnostic(createCheckTypeParameterDiagnostic(node, i));
	        }
	      }
	      function createCheckTypeParameterDiagnostic(node, i) {
	        return () => {
	          if (node.default) {
	            seenDefault = true;
	            checkTypeParametersNotReferenced(node.default, typeParameterDeclarations, i);
	          } else if (seenDefault) {
	            error2(node, Diagnostics.Required_type_parameters_may_not_follow_optional_type_parameters);
	          }
	          for (let j = 0; j < i; j++) {
	            if (typeParameterDeclarations[j].symbol === node.symbol) {
	              error2(node.name, Diagnostics.Duplicate_identifier_0, declarationNameToString(node.name));
	            }
	          }
	        };
	      }
	    }
	    function checkTypeParametersNotReferenced(root, typeParameters, index) {
	      visit(root);
	      function visit(node) {
	        if (node.kind === 183 /* TypeReference */) {
	          const type = getTypeFromTypeReference(node);
	          if (type.flags & 262144 /* TypeParameter */) {
	            for (let i = index; i < typeParameters.length; i++) {
	              if (type.symbol === getSymbolOfDeclaration(typeParameters[i])) {
	                error2(node, Diagnostics.Type_parameter_defaults_can_only_reference_previously_declared_type_parameters);
	              }
	            }
	          }
	        }
	        forEachChild(node, visit);
	      }
	    }
	    function checkTypeParameterListsIdentical(symbol) {
	      if (symbol.declarations && symbol.declarations.length === 1) {
	        return;
	      }
	      const links = getSymbolLinks(symbol);
	      if (!links.typeParametersChecked) {
	        links.typeParametersChecked = true;
	        const declarations = getClassOrInterfaceDeclarationsOfSymbol(symbol);
	        if (!declarations || declarations.length <= 1) {
	          return;
	        }
	        const type = getDeclaredTypeOfSymbol(symbol);
	        if (!areTypeParametersIdentical(declarations, type.localTypeParameters, getEffectiveTypeParameterDeclarations)) {
	          const name = symbolToString(symbol);
	          for (const declaration of declarations) {
	            error2(declaration.name, Diagnostics.All_declarations_of_0_must_have_identical_type_parameters, name);
	          }
	        }
	      }
	    }
	    function areTypeParametersIdentical(declarations, targetParameters, getTypeParameterDeclarations) {
	      const maxTypeArgumentCount = length(targetParameters);
	      const minTypeArgumentCount = getMinTypeArgumentCount(targetParameters);
	      for (const declaration of declarations) {
	        const sourceParameters = getTypeParameterDeclarations(declaration);
	        const numTypeParameters = sourceParameters.length;
	        if (numTypeParameters < minTypeArgumentCount || numTypeParameters > maxTypeArgumentCount) {
	          return false;
	        }
	        for (let i = 0; i < numTypeParameters; i++) {
	          const source = sourceParameters[i];
	          const target = targetParameters[i];
	          if (source.name.escapedText !== target.symbol.escapedName) {
	            return false;
	          }
	          const constraint = getEffectiveConstraintOfTypeParameter(source);
	          const sourceConstraint = constraint && getTypeFromTypeNode(constraint);
	          const targetConstraint = getConstraintOfTypeParameter(target);
	          if (sourceConstraint && targetConstraint && !isTypeIdenticalTo(sourceConstraint, targetConstraint)) {
	            return false;
	          }
	          const sourceDefault = source.default && getTypeFromTypeNode(source.default);
	          const targetDefault = getDefaultFromTypeParameter(target);
	          if (sourceDefault && targetDefault && !isTypeIdenticalTo(sourceDefault, targetDefault)) {
	            return false;
	          }
	        }
	      }
	      return true;
	    }
	    function getFirstTransformableStaticClassElement(node) {
	      const willTransformStaticElementsOfDecoratedClass = !legacyDecorators && languageVersion < 99 /* ESNext */ && classOrConstructorParameterIsDecorated(
	        /*useLegacyDecorators*/
	        false,
	        node
	      );
	      const willTransformPrivateElementsOrClassStaticBlocks = languageVersion <= 9 /* ES2022 */;
	      const willTransformInitializers = !emitStandardClassFields;
	      if (willTransformStaticElementsOfDecoratedClass || willTransformPrivateElementsOrClassStaticBlocks) {
	        for (const member of node.members) {
	          if (willTransformStaticElementsOfDecoratedClass && classElementOrClassElementParameterIsDecorated(
	            /*useLegacyDecorators*/
	            false,
	            member,
	            node
	          )) {
	            return firstOrUndefined(getDecorators(node)) ?? node;
	          } else if (willTransformPrivateElementsOrClassStaticBlocks) {
	            if (isClassStaticBlockDeclaration(member)) {
	              return member;
	            } else if (isStatic(member)) {
	              if (isPrivateIdentifierClassElementDeclaration(member) || willTransformInitializers && isInitializedProperty(member)) {
	                return member;
	              }
	            }
	          }
	        }
	      }
	    }
	    function checkClassExpressionExternalHelpers(node) {
	      if (node.name)
	        return;
	      const parent2 = walkUpOuterExpressions(node);
	      if (!isNamedEvaluationSource(parent2))
	        return;
	      const willTransformESDecorators = !legacyDecorators && languageVersion < 99 /* ESNext */;
	      let location;
	      if (willTransformESDecorators && classOrConstructorParameterIsDecorated(
	        /*useLegacyDecorators*/
	        false,
	        node
	      )) {
	        location = firstOrUndefined(getDecorators(node)) ?? node;
	      } else {
	        location = getFirstTransformableStaticClassElement(node);
	      }
	      if (location) {
	        checkExternalEmitHelpers(location, 8388608 /* SetFunctionName */);
	        if ((isPropertyAssignment(parent2) || isPropertyDeclaration(parent2) || isBindingElement(parent2)) && isComputedPropertyName(parent2.name)) {
	          checkExternalEmitHelpers(location, 16777216 /* PropKey */);
	        }
	      }
	    }
	    function checkClassExpression(node) {
	      checkClassLikeDeclaration(node);
	      checkNodeDeferred(node);
	      checkClassExpressionExternalHelpers(node);
	      return getTypeOfSymbol(getSymbolOfDeclaration(node));
	    }
	    function checkClassExpressionDeferred(node) {
	      forEach(node.members, checkSourceElement);
	      registerForUnusedIdentifiersCheck(node);
	    }
	    function checkClassDeclaration(node) {
	      const firstDecorator = find(node.modifiers, isDecorator);
	      if (legacyDecorators && firstDecorator && some(node.members, (p) => hasStaticModifier(p) && isPrivateIdentifierClassElementDeclaration(p))) {
	        grammarErrorOnNode(firstDecorator, Diagnostics.Class_decorators_can_t_be_used_with_static_private_identifier_Consider_removing_the_experimental_decorator);
	      }
	      if (!node.name && !hasSyntacticModifier(node, 2048 /* Default */)) {
	        grammarErrorOnFirstToken(node, Diagnostics.A_class_declaration_without_the_default_modifier_must_have_a_name);
	      }
	      checkClassLikeDeclaration(node);
	      forEach(node.members, checkSourceElement);
	      registerForUnusedIdentifiersCheck(node);
	    }
	    function checkClassLikeDeclaration(node) {
	      checkGrammarClassLikeDeclaration(node);
	      checkDecorators(node);
	      checkCollisionsForDeclarationName(node, node.name);
	      checkTypeParameters(getEffectiveTypeParameterDeclarations(node));
	      checkExportsOnMergedDeclarations(node);
	      const symbol = getSymbolOfDeclaration(node);
	      const type = getDeclaredTypeOfSymbol(symbol);
	      const typeWithThis = getTypeWithThisArgument(type);
	      const staticType = getTypeOfSymbol(symbol);
	      checkTypeParameterListsIdentical(symbol);
	      checkFunctionOrConstructorSymbol(symbol);
	      checkClassForDuplicateDeclarations(node);
	      const nodeInAmbientContext = !!(node.flags & 33554432 /* Ambient */);
	      if (!nodeInAmbientContext) {
	        checkClassForStaticPropertyNameConflicts(node);
	      }
	      const baseTypeNode = getEffectiveBaseTypeNode(node);
	      if (baseTypeNode) {
	        forEach(baseTypeNode.typeArguments, checkSourceElement);
	        if (languageVersion < 2 /* ES2015 */) {
	          checkExternalEmitHelpers(baseTypeNode.parent, 1 /* Extends */);
	        }
	        const extendsNode = getClassExtendsHeritageElement(node);
	        if (extendsNode && extendsNode !== baseTypeNode) {
	          checkExpression(extendsNode.expression);
	        }
	        const baseTypes = getBaseTypes(type);
	        if (baseTypes.length) {
	          addLazyDiagnostic(() => {
	            const baseType = baseTypes[0];
	            const baseConstructorType = getBaseConstructorTypeOfClass(type);
	            const staticBaseType = getApparentType(baseConstructorType);
	            checkBaseTypeAccessibility(staticBaseType, baseTypeNode);
	            checkSourceElement(baseTypeNode.expression);
	            if (some(baseTypeNode.typeArguments)) {
	              forEach(baseTypeNode.typeArguments, checkSourceElement);
	              for (const constructor of getConstructorsForTypeArguments(staticBaseType, baseTypeNode.typeArguments, baseTypeNode)) {
	                if (!checkTypeArgumentConstraints(baseTypeNode, constructor.typeParameters)) {
	                  break;
	                }
	              }
	            }
	            const baseWithThis = getTypeWithThisArgument(baseType, type.thisType);
	            if (!checkTypeAssignableTo(
	              typeWithThis,
	              baseWithThis,
	              /*errorNode*/
	              void 0
	            )) {
	              issueMemberSpecificError(node, typeWithThis, baseWithThis, Diagnostics.Class_0_incorrectly_extends_base_class_1);
	            } else {
	              checkTypeAssignableTo(staticType, getTypeWithoutSignatures(staticBaseType), node.name || node, Diagnostics.Class_static_side_0_incorrectly_extends_base_class_static_side_1);
	            }
	            if (baseConstructorType.flags & 8650752 /* TypeVariable */) {
	              if (!isMixinConstructorType(staticType)) {
	                error2(node.name || node, Diagnostics.A_mixin_class_must_have_a_constructor_with_a_single_rest_parameter_of_type_any);
	              } else {
	                const constructSignatures = getSignaturesOfType(baseConstructorType, 1 /* Construct */);
	                if (constructSignatures.some((signature) => signature.flags & 4 /* Abstract */) && !hasSyntacticModifier(node, 64 /* Abstract */)) {
	                  error2(node.name || node, Diagnostics.A_mixin_class_that_extends_from_a_type_variable_containing_an_abstract_construct_signature_must_also_be_declared_abstract);
	                }
	              }
	            }
	            if (!(staticBaseType.symbol && staticBaseType.symbol.flags & 32 /* Class */) && !(baseConstructorType.flags & 8650752 /* TypeVariable */)) {
	              const constructors = getInstantiatedConstructorsForTypeArguments(staticBaseType, baseTypeNode.typeArguments, baseTypeNode);
	              if (forEach(constructors, (sig) => !isJSConstructor(sig.declaration) && !isTypeIdenticalTo(getReturnTypeOfSignature(sig), baseType))) {
	                error2(baseTypeNode.expression, Diagnostics.Base_constructors_must_all_have_the_same_return_type);
	              }
	            }
	            checkKindsOfPropertyMemberOverrides(type, baseType);
	          });
	        }
	      }
	      checkMembersForOverrideModifier(node, type, typeWithThis, staticType);
	      const implementedTypeNodes = getEffectiveImplementsTypeNodes(node);
	      if (implementedTypeNodes) {
	        for (const typeRefNode of implementedTypeNodes) {
	          if (!isEntityNameExpression(typeRefNode.expression) || isOptionalChain(typeRefNode.expression)) {
	            error2(typeRefNode.expression, Diagnostics.A_class_can_only_implement_an_identifier_Slashqualified_name_with_optional_type_arguments);
	          }
	          checkTypeReferenceNode(typeRefNode);
	          addLazyDiagnostic(createImplementsDiagnostics(typeRefNode));
	        }
	      }
	      addLazyDiagnostic(() => {
	        checkIndexConstraints(type, symbol);
	        checkIndexConstraints(
	          staticType,
	          symbol,
	          /*isStaticIndex*/
	          true
	        );
	        checkTypeForDuplicateIndexSignatures(node);
	        checkPropertyInitialization(node);
	      });
	      function createImplementsDiagnostics(typeRefNode) {
	        return () => {
	          const t = getReducedType(getTypeFromTypeNode(typeRefNode));
	          if (!isErrorType(t)) {
	            if (isValidBaseType(t)) {
	              const genericDiag = t.symbol && t.symbol.flags & 32 /* Class */ ? Diagnostics.Class_0_incorrectly_implements_class_1_Did_you_mean_to_extend_1_and_inherit_its_members_as_a_subclass : Diagnostics.Class_0_incorrectly_implements_interface_1;
	              const baseWithThis = getTypeWithThisArgument(t, type.thisType);
	              if (!checkTypeAssignableTo(
	                typeWithThis,
	                baseWithThis,
	                /*errorNode*/
	                void 0
	              )) {
	                issueMemberSpecificError(node, typeWithThis, baseWithThis, genericDiag);
	              }
	            } else {
	              error2(typeRefNode, Diagnostics.A_class_can_only_implement_an_object_type_or_intersection_of_object_types_with_statically_known_members);
	            }
	          }
	        };
	      }
	    }
	    function checkMembersForOverrideModifier(node, type, typeWithThis, staticType) {
	      const baseTypeNode = getEffectiveBaseTypeNode(node);
	      const baseTypes = baseTypeNode && getBaseTypes(type);
	      const baseWithThis = (baseTypes == null ? void 0 : baseTypes.length) ? getTypeWithThisArgument(first(baseTypes), type.thisType) : void 0;
	      const baseStaticType = getBaseConstructorTypeOfClass(type);
	      for (const member of node.members) {
	        if (hasAmbientModifier(member)) {
	          continue;
	        }
	        if (isConstructorDeclaration(member)) {
	          forEach(member.parameters, (param) => {
	            if (isParameterPropertyDeclaration(param, member)) {
	              checkExistingMemberForOverrideModifier(
	                node,
	                staticType,
	                baseStaticType,
	                baseWithThis,
	                type,
	                typeWithThis,
	                param,
	                /*memberIsParameterProperty*/
	                true
	              );
	            }
	          });
	        }
	        checkExistingMemberForOverrideModifier(
	          node,
	          staticType,
	          baseStaticType,
	          baseWithThis,
	          type,
	          typeWithThis,
	          member,
	          /*memberIsParameterProperty*/
	          false
	        );
	      }
	    }
	    function checkExistingMemberForOverrideModifier(node, staticType, baseStaticType, baseWithThis, type, typeWithThis, member, memberIsParameterProperty, reportErrors2 = true) {
	      const declaredProp = member.name && getSymbolAtLocation(member.name) || getSymbolAtLocation(member);
	      if (!declaredProp) {
	        return 0 /* Ok */;
	      }
	      return checkMemberForOverrideModifier(
	        node,
	        staticType,
	        baseStaticType,
	        baseWithThis,
	        type,
	        typeWithThis,
	        hasOverrideModifier(member),
	        hasAbstractModifier(member),
	        isStatic(member),
	        memberIsParameterProperty,
	        symbolName(declaredProp),
	        reportErrors2 ? member : void 0
	      );
	    }
	    function checkMemberForOverrideModifier(node, staticType, baseStaticType, baseWithThis, type, typeWithThis, memberHasOverrideModifier, memberHasAbstractModifier, memberIsStatic, memberIsParameterProperty, memberName, errorNode) {
	      const isJs = isInJSFile(node);
	      const nodeInAmbientContext = !!(node.flags & 33554432 /* Ambient */);
	      if (baseWithThis && (memberHasOverrideModifier || compilerOptions.noImplicitOverride)) {
	        const memberEscapedName = escapeLeadingUnderscores(memberName);
	        const thisType = memberIsStatic ? staticType : typeWithThis;
	        const baseType = memberIsStatic ? baseStaticType : baseWithThis;
	        const prop = getPropertyOfType(thisType, memberEscapedName);
	        const baseProp = getPropertyOfType(baseType, memberEscapedName);
	        const baseClassName = typeToString(baseWithThis);
	        if (prop && !baseProp && memberHasOverrideModifier) {
	          if (errorNode) {
	            const suggestion = getSuggestedSymbolForNonexistentClassMember(memberName, baseType);
	            suggestion ? error2(
	              errorNode,
	              isJs ? Diagnostics.This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_it_is_not_declared_in_the_base_class_0_Did_you_mean_1 : Diagnostics.This_member_cannot_have_an_override_modifier_because_it_is_not_declared_in_the_base_class_0_Did_you_mean_1,
	              baseClassName,
	              symbolToString(suggestion)
	            ) : error2(
	              errorNode,
	              isJs ? Diagnostics.This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_it_is_not_declared_in_the_base_class_0 : Diagnostics.This_member_cannot_have_an_override_modifier_because_it_is_not_declared_in_the_base_class_0,
	              baseClassName
	            );
	          }
	          return 2 /* HasInvalidOverride */;
	        } else if (prop && (baseProp == null ? void 0 : baseProp.declarations) && compilerOptions.noImplicitOverride && !nodeInAmbientContext) {
	          const baseHasAbstract = some(baseProp.declarations, hasAbstractModifier);
	          if (memberHasOverrideModifier) {
	            return 0 /* Ok */;
	          }
	          if (!baseHasAbstract) {
	            if (errorNode) {
	              const diag2 = memberIsParameterProperty ? isJs ? Diagnostics.This_parameter_property_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_in_the_base_class_0 : Diagnostics.This_parameter_property_must_have_an_override_modifier_because_it_overrides_a_member_in_base_class_0 : isJs ? Diagnostics.This_member_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_in_the_base_class_0 : Diagnostics.This_member_must_have_an_override_modifier_because_it_overrides_a_member_in_the_base_class_0;
	              error2(errorNode, diag2, baseClassName);
	            }
	            return 1 /* NeedsOverride */;
	          } else if (memberHasAbstractModifier && baseHasAbstract) {
	            if (errorNode) {
	              error2(errorNode, Diagnostics.This_member_must_have_an_override_modifier_because_it_overrides_an_abstract_method_that_is_declared_in_the_base_class_0, baseClassName);
	            }
	            return 1 /* NeedsOverride */;
	          }
	        }
	      } else if (memberHasOverrideModifier) {
	        if (errorNode) {
	          const className = typeToString(type);
	          error2(
	            errorNode,
	            isJs ? Diagnostics.This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_its_containing_class_0_does_not_extend_another_class : Diagnostics.This_member_cannot_have_an_override_modifier_because_its_containing_class_0_does_not_extend_another_class,
	            className
	          );
	        }
	        return 2 /* HasInvalidOverride */;
	      }
	      return 0 /* Ok */;
	    }
	    function issueMemberSpecificError(node, typeWithThis, baseWithThis, broadDiag) {
	      let issuedMemberError = false;
	      for (const member of node.members) {
	        if (isStatic(member)) {
	          continue;
	        }
	        const declaredProp = member.name && getSymbolAtLocation(member.name) || getSymbolAtLocation(member);
	        if (declaredProp) {
	          const prop = getPropertyOfType(typeWithThis, declaredProp.escapedName);
	          const baseProp = getPropertyOfType(baseWithThis, declaredProp.escapedName);
	          if (prop && baseProp) {
	            const rootChain = () => chainDiagnosticMessages(
	              /*details*/
	              void 0,
	              Diagnostics.Property_0_in_type_1_is_not_assignable_to_the_same_property_in_base_type_2,
	              symbolToString(declaredProp),
	              typeToString(typeWithThis),
	              typeToString(baseWithThis)
	            );
	            if (!checkTypeAssignableTo(
	              getTypeOfSymbol(prop),
	              getTypeOfSymbol(baseProp),
	              member.name || member,
	              /*headMessage*/
	              void 0,
	              rootChain
	            )) {
	              issuedMemberError = true;
	            }
	          }
	        }
	      }
	      if (!issuedMemberError) {
	        checkTypeAssignableTo(typeWithThis, baseWithThis, node.name || node, broadDiag);
	      }
	    }
	    function checkBaseTypeAccessibility(type, node) {
	      const signatures = getSignaturesOfType(type, 1 /* Construct */);
	      if (signatures.length) {
	        const declaration = signatures[0].declaration;
	        if (declaration && hasEffectiveModifier(declaration, 2 /* Private */)) {
	          const typeClassDeclaration = getClassLikeDeclarationOfSymbol(type.symbol);
	          if (!isNodeWithinClass(node, typeClassDeclaration)) {
	            error2(node, Diagnostics.Cannot_extend_a_class_0_Class_constructor_is_marked_as_private, getFullyQualifiedName(type.symbol));
	          }
	        }
	      }
	    }
	    function getMemberOverrideModifierStatus(node, member, memberSymbol) {
	      if (!member.name) {
	        return 0 /* Ok */;
	      }
	      const classSymbol = getSymbolOfDeclaration(node);
	      const type = getDeclaredTypeOfSymbol(classSymbol);
	      const typeWithThis = getTypeWithThisArgument(type);
	      const staticType = getTypeOfSymbol(classSymbol);
	      const baseTypeNode = getEffectiveBaseTypeNode(node);
	      const baseTypes = baseTypeNode && getBaseTypes(type);
	      const baseWithThis = (baseTypes == null ? void 0 : baseTypes.length) ? getTypeWithThisArgument(first(baseTypes), type.thisType) : void 0;
	      const baseStaticType = getBaseConstructorTypeOfClass(type);
	      const memberHasOverrideModifier = member.parent ? hasOverrideModifier(member) : hasSyntacticModifier(member, 16 /* Override */);
	      return checkMemberForOverrideModifier(
	        node,
	        staticType,
	        baseStaticType,
	        baseWithThis,
	        type,
	        typeWithThis,
	        memberHasOverrideModifier,
	        hasAbstractModifier(member),
	        isStatic(member),
	        /*memberIsParameterProperty*/
	        false,
	        symbolName(memberSymbol)
	      );
	    }
	    function getTargetSymbol(s) {
	      return getCheckFlags(s) & 1 /* Instantiated */ ? s.links.target : s;
	    }
	    function getClassOrInterfaceDeclarationsOfSymbol(symbol) {
	      return filter(symbol.declarations, (d) => d.kind === 263 /* ClassDeclaration */ || d.kind === 264 /* InterfaceDeclaration */);
	    }
	    function checkKindsOfPropertyMemberOverrides(type, baseType) {
	      var _a, _b, _c, _d;
	      const baseProperties = getPropertiesOfType(baseType);
	      let inheritedAbstractMemberNotImplementedError;
	      basePropertyCheck:
	        for (const baseProperty of baseProperties) {
	          const base = getTargetSymbol(baseProperty);
	          if (base.flags & 4194304 /* Prototype */) {
	            continue;
	          }
	          const baseSymbol = getPropertyOfObjectType(type, base.escapedName);
	          if (!baseSymbol) {
	            continue;
	          }
	          const derived = getTargetSymbol(baseSymbol);
	          const baseDeclarationFlags = getDeclarationModifierFlagsFromSymbol(base);
	          Debug.assert(!!derived, "derived should point to something, even if it is the base class' declaration.");
	          if (derived === base) {
	            const derivedClassDecl = getClassLikeDeclarationOfSymbol(type.symbol);
	            if (baseDeclarationFlags & 64 /* Abstract */ && (!derivedClassDecl || !hasSyntacticModifier(derivedClassDecl, 64 /* Abstract */))) {
	              for (const otherBaseType of getBaseTypes(type)) {
	                if (otherBaseType === baseType)
	                  continue;
	                const baseSymbol2 = getPropertyOfObjectType(otherBaseType, base.escapedName);
	                const derivedElsewhere = baseSymbol2 && getTargetSymbol(baseSymbol2);
	                if (derivedElsewhere && derivedElsewhere !== base) {
	                  continue basePropertyCheck;
	                }
	              }
	              if (!inheritedAbstractMemberNotImplementedError) {
	                inheritedAbstractMemberNotImplementedError = error2(
	                  derivedClassDecl,
	                  Diagnostics.Non_abstract_class_0_does_not_implement_all_abstract_members_of_1,
	                  typeToString(type),
	                  typeToString(baseType)
	                );
	              }
	              if (derivedClassDecl.kind === 231 /* ClassExpression */) {
	                addRelatedInfo(
	                  inheritedAbstractMemberNotImplementedError,
	                  createDiagnosticForNode(
	                    baseProperty.valueDeclaration ?? (baseProperty.declarations && first(baseProperty.declarations)) ?? derivedClassDecl,
	                    Diagnostics.Non_abstract_class_expression_does_not_implement_inherited_abstract_member_0_from_class_1,
	                    symbolToString(baseProperty),
	                    typeToString(baseType)
	                  )
	                );
	              } else {
	                addRelatedInfo(
	                  inheritedAbstractMemberNotImplementedError,
	                  createDiagnosticForNode(
	                    baseProperty.valueDeclaration ?? (baseProperty.declarations && first(baseProperty.declarations)) ?? derivedClassDecl,
	                    Diagnostics.Non_abstract_class_0_does_not_implement_inherited_abstract_member_1_from_class_2,
	                    typeToString(type),
	                    symbolToString(baseProperty),
	                    typeToString(baseType)
	                  )
	                );
	              }
	            }
	          } else {
	            const derivedDeclarationFlags = getDeclarationModifierFlagsFromSymbol(derived);
	            if (baseDeclarationFlags & 2 /* Private */ || derivedDeclarationFlags & 2 /* Private */) {
	              continue;
	            }
	            let errorMessage;
	            const basePropertyFlags = base.flags & 98308 /* PropertyOrAccessor */;
	            const derivedPropertyFlags = derived.flags & 98308 /* PropertyOrAccessor */;
	            if (basePropertyFlags && derivedPropertyFlags) {
	              if ((getCheckFlags(base) & 6 /* Synthetic */ ? (_a = base.declarations) == null ? void 0 : _a.some((d) => isPropertyAbstractOrInterface(d, baseDeclarationFlags)) : (_b = base.declarations) == null ? void 0 : _b.every((d) => isPropertyAbstractOrInterface(d, baseDeclarationFlags))) || getCheckFlags(base) & 262144 /* Mapped */ || derived.valueDeclaration && isBinaryExpression(derived.valueDeclaration)) {
	                continue;
	              }
	              const overriddenInstanceProperty = basePropertyFlags !== 4 /* Property */ && derivedPropertyFlags === 4 /* Property */;
	              const overriddenInstanceAccessor = basePropertyFlags === 4 /* Property */ && derivedPropertyFlags !== 4 /* Property */;
	              if (overriddenInstanceProperty || overriddenInstanceAccessor) {
	                const errorMessage2 = overriddenInstanceProperty ? Diagnostics._0_is_defined_as_an_accessor_in_class_1_but_is_overridden_here_in_2_as_an_instance_property : Diagnostics._0_is_defined_as_a_property_in_class_1_but_is_overridden_here_in_2_as_an_accessor;
	                error2(getNameOfDeclaration(derived.valueDeclaration) || derived.valueDeclaration, errorMessage2, symbolToString(base), typeToString(baseType), typeToString(type));
	              } else if (useDefineForClassFields) {
	                const uninitialized = (_c = derived.declarations) == null ? void 0 : _c.find((d) => d.kind === 172 /* PropertyDeclaration */ && !d.initializer);
	                if (uninitialized && !(derived.flags & 33554432 /* Transient */) && !(baseDeclarationFlags & 64 /* Abstract */) && !(derivedDeclarationFlags & 64 /* Abstract */) && !((_d = derived.declarations) == null ? void 0 : _d.some((d) => !!(d.flags & 33554432 /* Ambient */)))) {
	                  const constructor = findConstructorDeclaration(getClassLikeDeclarationOfSymbol(type.symbol));
	                  const propName = uninitialized.name;
	                  if (uninitialized.exclamationToken || !constructor || !isIdentifier(propName) || !strictNullChecks || !isPropertyInitializedInConstructor(propName, type, constructor)) {
	                    const errorMessage2 = Diagnostics.Property_0_will_overwrite_the_base_property_in_1_If_this_is_intentional_add_an_initializer_Otherwise_add_a_declare_modifier_or_remove_the_redundant_declaration;
	                    error2(getNameOfDeclaration(derived.valueDeclaration) || derived.valueDeclaration, errorMessage2, symbolToString(base), typeToString(baseType));
	                  }
	                }
	              }
	              continue;
	            } else if (isPrototypeProperty(base)) {
	              if (isPrototypeProperty(derived) || derived.flags & 4 /* Property */) {
	                continue;
	              } else {
	                Debug.assert(!!(derived.flags & 98304 /* Accessor */));
	                errorMessage = Diagnostics.Class_0_defines_instance_member_function_1_but_extended_class_2_defines_it_as_instance_member_accessor;
	              }
	            } else if (base.flags & 98304 /* Accessor */) {
	              errorMessage = Diagnostics.Class_0_defines_instance_member_accessor_1_but_extended_class_2_defines_it_as_instance_member_function;
	            } else {
	              errorMessage = Diagnostics.Class_0_defines_instance_member_property_1_but_extended_class_2_defines_it_as_instance_member_function;
	            }
	            error2(getNameOfDeclaration(derived.valueDeclaration) || derived.valueDeclaration, errorMessage, typeToString(baseType), symbolToString(base), typeToString(type));
	          }
	        }
	    }
	    function isPropertyAbstractOrInterface(declaration, baseDeclarationFlags) {
	      return baseDeclarationFlags & 64 /* Abstract */ && (!isPropertyDeclaration(declaration) || !declaration.initializer) || isInterfaceDeclaration(declaration.parent);
	    }
	    function getNonInheritedProperties(type, baseTypes, properties) {
	      if (!length(baseTypes)) {
	        return properties;
	      }
	      const seen = /* @__PURE__ */ new Map();
	      forEach(properties, (p) => {
	        seen.set(p.escapedName, p);
	      });
	      for (const base of baseTypes) {
	        const properties2 = getPropertiesOfType(getTypeWithThisArgument(base, type.thisType));
	        for (const prop of properties2) {
	          const existing = seen.get(prop.escapedName);
	          if (existing && prop.parent === existing.parent) {
	            seen.delete(prop.escapedName);
	          }
	        }
	      }
	      return arrayFrom(seen.values());
	    }
	    function checkInheritedPropertiesAreIdentical(type, typeNode) {
	      const baseTypes = getBaseTypes(type);
	      if (baseTypes.length < 2) {
	        return true;
	      }
	      const seen = /* @__PURE__ */ new Map();
	      forEach(resolveDeclaredMembers(type).declaredProperties, (p) => {
	        seen.set(p.escapedName, { prop: p, containingType: type });
	      });
	      let ok = true;
	      for (const base of baseTypes) {
	        const properties = getPropertiesOfType(getTypeWithThisArgument(base, type.thisType));
	        for (const prop of properties) {
	          const existing = seen.get(prop.escapedName);
	          if (!existing) {
	            seen.set(prop.escapedName, { prop, containingType: base });
	          } else {
	            const isInheritedProperty = existing.containingType !== type;
	            if (isInheritedProperty && !isPropertyIdenticalTo(existing.prop, prop)) {
	              ok = false;
	              const typeName1 = typeToString(existing.containingType);
	              const typeName2 = typeToString(base);
	              let errorInfo = chainDiagnosticMessages(
	                /*details*/
	                void 0,
	                Diagnostics.Named_property_0_of_types_1_and_2_are_not_identical,
	                symbolToString(prop),
	                typeName1,
	                typeName2
	              );
	              errorInfo = chainDiagnosticMessages(errorInfo, Diagnostics.Interface_0_cannot_simultaneously_extend_types_1_and_2, typeToString(type), typeName1, typeName2);
	              diagnostics.add(createDiagnosticForNodeFromMessageChain(getSourceFileOfNode(typeNode), typeNode, errorInfo));
	            }
	          }
	        }
	      }
	      return ok;
	    }
	    function checkPropertyInitialization(node) {
	      if (!strictNullChecks || !strictPropertyInitialization || node.flags & 33554432 /* Ambient */) {
	        return;
	      }
	      const constructor = findConstructorDeclaration(node);
	      for (const member of node.members) {
	        if (getEffectiveModifierFlags(member) & 128 /* Ambient */) {
	          continue;
	        }
	        if (!isStatic(member) && isPropertyWithoutInitializer(member)) {
	          const propName = member.name;
	          if (isIdentifier(propName) || isPrivateIdentifier(propName) || isComputedPropertyName(propName)) {
	            const type = getTypeOfSymbol(getSymbolOfDeclaration(member));
	            if (!(type.flags & 3 /* AnyOrUnknown */ || containsUndefinedType(type))) {
	              if (!constructor || !isPropertyInitializedInConstructor(propName, type, constructor)) {
	                error2(member.name, Diagnostics.Property_0_has_no_initializer_and_is_not_definitely_assigned_in_the_constructor, declarationNameToString(propName));
	              }
	            }
	          }
	        }
	      }
	    }
	    function isPropertyWithoutInitializer(node) {
	      return node.kind === 172 /* PropertyDeclaration */ && !hasAbstractModifier(node) && !node.exclamationToken && !node.initializer;
	    }
	    function isPropertyInitializedInStaticBlocks(propName, propType, staticBlocks, startPos, endPos) {
	      for (const staticBlock of staticBlocks) {
	        if (staticBlock.pos >= startPos && staticBlock.pos <= endPos) {
	          const reference = factory.createPropertyAccessExpression(factory.createThis(), propName);
	          setParent(reference.expression, reference);
	          setParent(reference, staticBlock);
	          reference.flowNode = staticBlock.returnFlowNode;
	          const flowType = getFlowTypeOfReference(reference, propType, getOptionalType(propType));
	          if (!containsUndefinedType(flowType)) {
	            return true;
	          }
	        }
	      }
	      return false;
	    }
	    function isPropertyInitializedInConstructor(propName, propType, constructor) {
	      const reference = isComputedPropertyName(propName) ? factory.createElementAccessExpression(factory.createThis(), propName.expression) : factory.createPropertyAccessExpression(factory.createThis(), propName);
	      setParent(reference.expression, reference);
	      setParent(reference, constructor);
	      reference.flowNode = constructor.returnFlowNode;
	      const flowType = getFlowTypeOfReference(reference, propType, getOptionalType(propType));
	      return !containsUndefinedType(flowType);
	    }
	    function checkInterfaceDeclaration(node) {
	      if (!checkGrammarModifiers(node))
	        checkGrammarInterfaceDeclaration(node);
	      checkTypeParameters(node.typeParameters);
	      addLazyDiagnostic(() => {
	        checkTypeNameIsReserved(node.name, Diagnostics.Interface_name_cannot_be_0);
	        checkExportsOnMergedDeclarations(node);
	        const symbol = getSymbolOfDeclaration(node);
	        checkTypeParameterListsIdentical(symbol);
	        const firstInterfaceDecl = getDeclarationOfKind(symbol, 264 /* InterfaceDeclaration */);
	        if (node === firstInterfaceDecl) {
	          const type = getDeclaredTypeOfSymbol(symbol);
	          const typeWithThis = getTypeWithThisArgument(type);
	          if (checkInheritedPropertiesAreIdentical(type, node.name)) {
	            for (const baseType of getBaseTypes(type)) {
	              checkTypeAssignableTo(typeWithThis, getTypeWithThisArgument(baseType, type.thisType), node.name, Diagnostics.Interface_0_incorrectly_extends_interface_1);
	            }
	            checkIndexConstraints(type, symbol);
	          }
	        }
	        checkObjectTypeForDuplicateDeclarations(node);
	      });
	      forEach(getInterfaceBaseTypeNodes(node), (heritageElement) => {
	        if (!isEntityNameExpression(heritageElement.expression) || isOptionalChain(heritageElement.expression)) {
	          error2(heritageElement.expression, Diagnostics.An_interface_can_only_extend_an_identifier_Slashqualified_name_with_optional_type_arguments);
	        }
	        checkTypeReferenceNode(heritageElement);
	      });
	      forEach(node.members, checkSourceElement);
	      addLazyDiagnostic(() => {
	        checkTypeForDuplicateIndexSignatures(node);
	        registerForUnusedIdentifiersCheck(node);
	      });
	    }
	    function checkTypeAliasDeclaration(node) {
	      checkGrammarModifiers(node);
	      checkTypeNameIsReserved(node.name, Diagnostics.Type_alias_name_cannot_be_0);
	      checkExportsOnMergedDeclarations(node);
	      checkTypeParameters(node.typeParameters);
	      if (node.type.kind === 141 /* IntrinsicKeyword */) {
	        if (!intrinsicTypeKinds.has(node.name.escapedText) || length(node.typeParameters) !== 1) {
	          error2(node.type, Diagnostics.The_intrinsic_keyword_can_only_be_used_to_declare_compiler_provided_intrinsic_types);
	        }
	      } else {
	        checkSourceElement(node.type);
	        registerForUnusedIdentifiersCheck(node);
	      }
	    }
	    function computeEnumMemberValues(node) {
	      const nodeLinks2 = getNodeLinks(node);
	      if (!(nodeLinks2.flags & 1024 /* EnumValuesComputed */)) {
	        nodeLinks2.flags |= 1024 /* EnumValuesComputed */;
	        let autoValue = 0;
	        for (const member of node.members) {
	          const value = computeMemberValue(member, autoValue);
	          getNodeLinks(member).enumMemberValue = value;
	          autoValue = typeof value === "number" ? value + 1 : void 0;
	        }
	      }
	    }
	    function computeMemberValue(member, autoValue) {
	      if (isComputedNonLiteralName(member.name)) {
	        error2(member.name, Diagnostics.Computed_property_names_are_not_allowed_in_enums);
	      } else {
	        const text = getTextOfPropertyName(member.name);
	        if (isNumericLiteralName(text) && !isInfinityOrNaNString(text)) {
	          error2(member.name, Diagnostics.An_enum_member_cannot_have_a_numeric_name);
	        }
	      }
	      if (member.initializer) {
	        return computeConstantValue(member);
	      }
	      if (member.parent.flags & 33554432 /* Ambient */ && !isEnumConst(member.parent)) {
	        return void 0;
	      }
	      if (autoValue !== void 0) {
	        return autoValue;
	      }
	      error2(member.name, Diagnostics.Enum_member_must_have_initializer);
	      return void 0;
	    }
	    function computeConstantValue(member) {
	      const isConstEnum = isEnumConst(member.parent);
	      const initializer = member.initializer;
	      const value = evaluate(initializer, member);
	      if (value !== void 0) {
	        if (isConstEnum && typeof value === "number" && !isFinite(value)) {
	          error2(
	            initializer,
	            isNaN(value) ? Diagnostics.const_enum_member_initializer_was_evaluated_to_disallowed_value_NaN : Diagnostics.const_enum_member_initializer_was_evaluated_to_a_non_finite_value
	          );
	        }
	      } else if (isConstEnum) {
	        error2(initializer, Diagnostics.const_enum_member_initializers_must_be_constant_expressions);
	      } else if (member.parent.flags & 33554432 /* Ambient */) {
	        error2(initializer, Diagnostics.In_ambient_enum_declarations_member_initializer_must_be_constant_expression);
	      } else {
	        checkTypeAssignableTo(checkExpression(initializer), numberType, initializer, Diagnostics.Type_0_is_not_assignable_to_type_1_as_required_for_computed_enum_member_values);
	      }
	      return value;
	    }
	    function evaluate(expr, location) {
	      switch (expr.kind) {
	        case 224 /* PrefixUnaryExpression */:
	          const value = evaluate(expr.operand, location);
	          if (typeof value === "number") {
	            switch (expr.operator) {
	              case 40 /* PlusToken */:
	                return value;
	              case 41 /* MinusToken */:
	                return -value;
	              case 55 /* TildeToken */:
	                return ~value;
	            }
	          }
	          break;
	        case 226 /* BinaryExpression */:
	          const left = evaluate(expr.left, location);
	          const right = evaluate(expr.right, location);
	          if (typeof left === "number" && typeof right === "number") {
	            switch (expr.operatorToken.kind) {
	              case 52 /* BarToken */:
	                return left | right;
	              case 51 /* AmpersandToken */:
	                return left & right;
	              case 49 /* GreaterThanGreaterThanToken */:
	                return left >> right;
	              case 50 /* GreaterThanGreaterThanGreaterThanToken */:
	                return left >>> right;
	              case 48 /* LessThanLessThanToken */:
	                return left << right;
	              case 53 /* CaretToken */:
	                return left ^ right;
	              case 42 /* AsteriskToken */:
	                return left * right;
	              case 44 /* SlashToken */:
	                return left / right;
	              case 40 /* PlusToken */:
	                return left + right;
	              case 41 /* MinusToken */:
	                return left - right;
	              case 45 /* PercentToken */:
	                return left % right;
	              case 43 /* AsteriskAsteriskToken */:
	                return left ** right;
	            }
	          } else if ((typeof left === "string" || typeof left === "number") && (typeof right === "string" || typeof right === "number") && expr.operatorToken.kind === 40 /* PlusToken */) {
	            return "" + left + right;
	          }
	          break;
	        case 11 /* StringLiteral */:
	        case 15 /* NoSubstitutionTemplateLiteral */:
	          return expr.text;
	        case 228 /* TemplateExpression */:
	          return evaluateTemplateExpression(expr, location);
	        case 9 /* NumericLiteral */:
	          checkGrammarNumericLiteral(expr);
	          return +expr.text;
	        case 217 /* ParenthesizedExpression */:
	          return evaluate(expr.expression, location);
	        case 80 /* Identifier */: {
	          const identifier = expr;
	          if (isInfinityOrNaNString(identifier.escapedText) && resolveEntityName(
	            identifier,
	            111551 /* Value */,
	            /*ignoreErrors*/
	            true
	          ) === getGlobalSymbol(
	            identifier.escapedText,
	            111551 /* Value */,
	            /*diagnostic*/
	            void 0
	          )) {
	            return +identifier.escapedText;
	          }
	        }
	        case 211 /* PropertyAccessExpression */:
	          if (isEntityNameExpression(expr)) {
	            const symbol = resolveEntityName(
	              expr,
	              111551 /* Value */,
	              /*ignoreErrors*/
	              true
	            );
	            if (symbol) {
	              if (symbol.flags & 8 /* EnumMember */) {
	                return location ? evaluateEnumMember(expr, symbol, location) : getEnumMemberValue(symbol.valueDeclaration);
	              }
	              if (isConstantVariable(symbol)) {
	                const declaration = symbol.valueDeclaration;
	                if (declaration && isVariableDeclaration(declaration) && !declaration.type && declaration.initializer && (!location || declaration !== location && isBlockScopedNameDeclaredBeforeUse(declaration, location))) {
	                  return evaluate(declaration.initializer, declaration);
	                }
	              }
	            }
	          }
	          break;
	        case 212 /* ElementAccessExpression */:
	          const root = expr.expression;
	          if (isEntityNameExpression(root) && isStringLiteralLike(expr.argumentExpression)) {
	            const rootSymbol = resolveEntityName(
	              root,
	              111551 /* Value */,
	              /*ignoreErrors*/
	              true
	            );
	            if (rootSymbol && rootSymbol.flags & 384 /* Enum */) {
	              const name = escapeLeadingUnderscores(expr.argumentExpression.text);
	              const member = rootSymbol.exports.get(name);
	              if (member) {
	                return location ? evaluateEnumMember(expr, member, location) : getEnumMemberValue(member.valueDeclaration);
	              }
	            }
	          }
	          break;
	      }
	      return void 0;
	    }
	    function evaluateEnumMember(expr, symbol, location) {
	      const declaration = symbol.valueDeclaration;
	      if (!declaration || declaration === location) {
	        error2(expr, Diagnostics.Property_0_is_used_before_being_assigned, symbolToString(symbol));
	        return void 0;
	      }
	      if (!isBlockScopedNameDeclaredBeforeUse(declaration, location)) {
	        error2(expr, Diagnostics.A_member_initializer_in_a_enum_declaration_cannot_reference_members_declared_after_it_including_members_defined_in_other_enums);
	        return 0;
	      }
	      return getEnumMemberValue(declaration);
	    }
	    function evaluateTemplateExpression(expr, location) {
	      let result = expr.head.text;
	      for (const span of expr.templateSpans) {
	        const value = evaluate(span.expression, location);
	        if (value === void 0) {
	          return void 0;
	        }
	        result += value;
	        result += span.literal.text;
	      }
	      return result;
	    }
	    function checkEnumDeclaration(node) {
	      addLazyDiagnostic(() => checkEnumDeclarationWorker(node));
	    }
	    function checkEnumDeclarationWorker(node) {
	      checkGrammarModifiers(node);
	      checkCollisionsForDeclarationName(node, node.name);
	      checkExportsOnMergedDeclarations(node);
	      node.members.forEach(checkEnumMember);
	      computeEnumMemberValues(node);
	      const enumSymbol = getSymbolOfDeclaration(node);
	      const firstDeclaration = getDeclarationOfKind(enumSymbol, node.kind);
	      if (node === firstDeclaration) {
	        if (enumSymbol.declarations && enumSymbol.declarations.length > 1) {
	          const enumIsConst = isEnumConst(node);
	          forEach(enumSymbol.declarations, (decl) => {
	            if (isEnumDeclaration(decl) && isEnumConst(decl) !== enumIsConst) {
	              error2(getNameOfDeclaration(decl), Diagnostics.Enum_declarations_must_all_be_const_or_non_const);
	            }
	          });
	        }
	        let seenEnumMissingInitialInitializer = false;
	        forEach(enumSymbol.declarations, (declaration) => {
	          if (declaration.kind !== 266 /* EnumDeclaration */) {
	            return false;
	          }
	          const enumDeclaration = declaration;
	          if (!enumDeclaration.members.length) {
	            return false;
	          }
	          const firstEnumMember = enumDeclaration.members[0];
	          if (!firstEnumMember.initializer) {
	            if (seenEnumMissingInitialInitializer) {
	              error2(firstEnumMember.name, Diagnostics.In_an_enum_with_multiple_declarations_only_one_declaration_can_omit_an_initializer_for_its_first_enum_element);
	            } else {
	              seenEnumMissingInitialInitializer = true;
	            }
	          }
	        });
	      }
	    }
	    function checkEnumMember(node) {
	      if (isPrivateIdentifier(node.name)) {
	        error2(node, Diagnostics.An_enum_member_cannot_be_named_with_a_private_identifier);
	      }
	      if (node.initializer) {
	        checkExpression(node.initializer);
	      }
	    }
	    function getFirstNonAmbientClassOrFunctionDeclaration(symbol) {
	      const declarations = symbol.declarations;
	      if (declarations) {
	        for (const declaration of declarations) {
	          if ((declaration.kind === 263 /* ClassDeclaration */ || declaration.kind === 262 /* FunctionDeclaration */ && nodeIsPresent(declaration.body)) && !(declaration.flags & 33554432 /* Ambient */)) {
	            return declaration;
	          }
	        }
	      }
	      return void 0;
	    }
	    function inSameLexicalScope(node1, node2) {
	      const container1 = getEnclosingBlockScopeContainer(node1);
	      const container2 = getEnclosingBlockScopeContainer(node2);
	      if (isGlobalSourceFile(container1)) {
	        return isGlobalSourceFile(container2);
	      } else if (isGlobalSourceFile(container2)) {
	        return false;
	      } else {
	        return container1 === container2;
	      }
	    }
	    function checkModuleDeclaration(node) {
	      if (node.body) {
	        checkSourceElement(node.body);
	        if (!isGlobalScopeAugmentation(node)) {
	          registerForUnusedIdentifiersCheck(node);
	        }
	      }
	      addLazyDiagnostic(checkModuleDeclarationDiagnostics);
	      function checkModuleDeclarationDiagnostics() {
	        var _a, _b;
	        const isGlobalAugmentation = isGlobalScopeAugmentation(node);
	        const inAmbientContext = node.flags & 33554432 /* Ambient */;
	        if (isGlobalAugmentation && !inAmbientContext) {
	          error2(node.name, Diagnostics.Augmentations_for_the_global_scope_should_have_declare_modifier_unless_they_appear_in_already_ambient_context);
	        }
	        const isAmbientExternalModule = isAmbientModule(node);
	        const contextErrorMessage = isAmbientExternalModule ? Diagnostics.An_ambient_module_declaration_is_only_allowed_at_the_top_level_in_a_file : Diagnostics.A_namespace_declaration_is_only_allowed_at_the_top_level_of_a_namespace_or_module;
	        if (checkGrammarModuleElementContext(node, contextErrorMessage)) {
	          return;
	        }
	        if (!checkGrammarModifiers(node)) {
	          if (!inAmbientContext && node.name.kind === 11 /* StringLiteral */) {
	            grammarErrorOnNode(node.name, Diagnostics.Only_ambient_modules_can_use_quoted_names);
	          }
	        }
	        if (isIdentifier(node.name)) {
	          checkCollisionsForDeclarationName(node, node.name);
	        }
	        checkExportsOnMergedDeclarations(node);
	        const symbol = getSymbolOfDeclaration(node);
	        if (symbol.flags & 512 /* ValueModule */ && !inAmbientContext && isInstantiatedModule(node, shouldPreserveConstEnums(compilerOptions))) {
	          if (getIsolatedModules(compilerOptions) && !getSourceFileOfNode(node).externalModuleIndicator) {
	            error2(node.name, Diagnostics.Namespaces_are_not_allowed_in_global_script_files_when_0_is_enabled_If_this_file_is_not_intended_to_be_a_global_script_set_moduleDetection_to_force_or_add_an_empty_export_statement, isolatedModulesLikeFlagName);
	          }
	          if (((_a = symbol.declarations) == null ? void 0 : _a.length) > 1) {
	            const firstNonAmbientClassOrFunc = getFirstNonAmbientClassOrFunctionDeclaration(symbol);
	            if (firstNonAmbientClassOrFunc) {
	              if (getSourceFileOfNode(node) !== getSourceFileOfNode(firstNonAmbientClassOrFunc)) {
	                error2(node.name, Diagnostics.A_namespace_declaration_cannot_be_in_a_different_file_from_a_class_or_function_with_which_it_is_merged);
	              } else if (node.pos < firstNonAmbientClassOrFunc.pos) {
	                error2(node.name, Diagnostics.A_namespace_declaration_cannot_be_located_prior_to_a_class_or_function_with_which_it_is_merged);
	              }
	            }
	            const mergedClass = getDeclarationOfKind(symbol, 263 /* ClassDeclaration */);
	            if (mergedClass && inSameLexicalScope(node, mergedClass)) {
	              getNodeLinks(node).flags |= 2048 /* LexicalModuleMergesWithClass */;
	            }
	          }
	          if (compilerOptions.verbatimModuleSyntax && node.parent.kind === 312 /* SourceFile */ && (moduleKind === 1 /* CommonJS */ || node.parent.impliedNodeFormat === 1 /* CommonJS */)) {
	            const exportModifier = (_b = node.modifiers) == null ? void 0 : _b.find((m) => m.kind === 95 /* ExportKeyword */);
	            if (exportModifier) {
	              error2(exportModifier, Diagnostics.A_top_level_export_modifier_cannot_be_used_on_value_declarations_in_a_CommonJS_module_when_verbatimModuleSyntax_is_enabled);
	            }
	          }
	        }
	        if (isAmbientExternalModule) {
	          if (isExternalModuleAugmentation(node)) {
	            const checkBody = isGlobalAugmentation || getSymbolOfDeclaration(node).flags & 33554432 /* Transient */;
	            if (checkBody && node.body) {
	              for (const statement of node.body.statements) {
	                checkModuleAugmentationElement(statement, isGlobalAugmentation);
	              }
	            }
	          } else if (isGlobalSourceFile(node.parent)) {
	            if (isGlobalAugmentation) {
	              error2(node.name, Diagnostics.Augmentations_for_the_global_scope_can_only_be_directly_nested_in_external_modules_or_ambient_module_declarations);
	            } else if (isExternalModuleNameRelative(getTextOfIdentifierOrLiteral(node.name))) {
	              error2(node.name, Diagnostics.Ambient_module_declaration_cannot_specify_relative_module_name);
	            }
	          } else {
	            if (isGlobalAugmentation) {
	              error2(node.name, Diagnostics.Augmentations_for_the_global_scope_can_only_be_directly_nested_in_external_modules_or_ambient_module_declarations);
	            } else {
	              error2(node.name, Diagnostics.Ambient_modules_cannot_be_nested_in_other_modules_or_namespaces);
	            }
	          }
	        }
	      }
	    }
	    function checkModuleAugmentationElement(node, isGlobalAugmentation) {
	      switch (node.kind) {
	        case 243 /* VariableStatement */:
	          for (const decl of node.declarationList.declarations) {
	            checkModuleAugmentationElement(decl, isGlobalAugmentation);
	          }
	          break;
	        case 277 /* ExportAssignment */:
	        case 278 /* ExportDeclaration */:
	          grammarErrorOnFirstToken(node, Diagnostics.Exports_and_export_assignments_are_not_permitted_in_module_augmentations);
	          break;
	        case 271 /* ImportEqualsDeclaration */:
	        case 272 /* ImportDeclaration */:
	          grammarErrorOnFirstToken(node, Diagnostics.Imports_are_not_permitted_in_module_augmentations_Consider_moving_them_to_the_enclosing_external_module);
	          break;
	        case 208 /* BindingElement */:
	        case 260 /* VariableDeclaration */:
	          const name = node.name;
	          if (isBindingPattern(name)) {
	            for (const el of name.elements) {
	              checkModuleAugmentationElement(el, isGlobalAugmentation);
	            }
	            break;
	          }
	        case 263 /* ClassDeclaration */:
	        case 266 /* EnumDeclaration */:
	        case 262 /* FunctionDeclaration */:
	        case 264 /* InterfaceDeclaration */:
	        case 267 /* ModuleDeclaration */:
	        case 265 /* TypeAliasDeclaration */:
	          if (isGlobalAugmentation) {
	            return;
	          }
	          break;
	      }
	    }
	    function getFirstNonModuleExportsIdentifier(node) {
	      switch (node.kind) {
	        case 80 /* Identifier */:
	          return node;
	        case 166 /* QualifiedName */:
	          do {
	            node = node.left;
	          } while (node.kind !== 80 /* Identifier */);
	          return node;
	        case 211 /* PropertyAccessExpression */:
	          do {
	            if (isModuleExportsAccessExpression(node.expression) && !isPrivateIdentifier(node.name)) {
	              return node.name;
	            }
	            node = node.expression;
	          } while (node.kind !== 80 /* Identifier */);
	          return node;
	      }
	    }
	    function checkExternalImportOrExportDeclaration(node) {
	      const moduleName = getExternalModuleName(node);
	      if (!moduleName || nodeIsMissing(moduleName)) {
	        return false;
	      }
	      if (!isStringLiteral(moduleName)) {
	        error2(moduleName, Diagnostics.String_literal_expected);
	        return false;
	      }
	      const inAmbientExternalModule = node.parent.kind === 268 /* ModuleBlock */ && isAmbientModule(node.parent.parent);
	      if (node.parent.kind !== 312 /* SourceFile */ && !inAmbientExternalModule) {
	        error2(
	          moduleName,
	          node.kind === 278 /* ExportDeclaration */ ? Diagnostics.Export_declarations_are_not_permitted_in_a_namespace : Diagnostics.Import_declarations_in_a_namespace_cannot_reference_a_module
	        );
	        return false;
	      }
	      if (inAmbientExternalModule && isExternalModuleNameRelative(moduleName.text)) {
	        if (!isTopLevelInExternalModuleAugmentation(node)) {
	          error2(node, Diagnostics.Import_or_export_declaration_in_an_ambient_module_declaration_cannot_reference_module_through_relative_module_name);
	          return false;
	        }
	      }
	      if (!isImportEqualsDeclaration(node) && node.attributes) {
	        const diagnostic = node.attributes.token === 118 /* WithKeyword */ ? Diagnostics.Import_attribute_values_must_be_string_literal_expressions : Diagnostics.Import_assertion_values_must_be_string_literal_expressions;
	        let hasError = false;
	        for (const attr of node.attributes.elements) {
	          if (!isStringLiteral(attr.value)) {
	            hasError = true;
	            error2(attr.value, diagnostic);
	          }
	        }
	        return !hasError;
	      }
	      return true;
	    }
	    function checkAliasSymbol(node) {
	      var _a, _b, _c, _d;
	      let symbol = getSymbolOfDeclaration(node);
	      const target = resolveAlias(symbol);
	      if (target !== unknownSymbol) {
	        symbol = getMergedSymbol(symbol.exportSymbol || symbol);
	        if (isInJSFile(node) && !(target.flags & 111551 /* Value */) && !isTypeOnlyImportOrExportDeclaration(node)) {
	          const errorNode = isImportOrExportSpecifier(node) ? node.propertyName || node.name : isNamedDeclaration(node) ? node.name : node;
	          Debug.assert(node.kind !== 280 /* NamespaceExport */);
	          if (node.kind === 281 /* ExportSpecifier */) {
	            const diag2 = error2(errorNode, Diagnostics.Types_cannot_appear_in_export_declarations_in_JavaScript_files);
	            const alreadyExportedSymbol = (_b = (_a = getSourceFileOfNode(node).symbol) == null ? void 0 : _a.exports) == null ? void 0 : _b.get((node.propertyName || node.name).escapedText);
	            if (alreadyExportedSymbol === target) {
	              const exportingDeclaration = (_c = alreadyExportedSymbol.declarations) == null ? void 0 : _c.find(isJSDocNode);
	              if (exportingDeclaration) {
	                addRelatedInfo(
	                  diag2,
	                  createDiagnosticForNode(
	                    exportingDeclaration,
	                    Diagnostics._0_is_automatically_exported_here,
	                    unescapeLeadingUnderscores(alreadyExportedSymbol.escapedName)
	                  )
	                );
	              }
	            }
	          } else {
	            Debug.assert(node.kind !== 260 /* VariableDeclaration */);
	            const importDeclaration = findAncestor(node, or(isImportDeclaration, isImportEqualsDeclaration));
	            const moduleSpecifier = (importDeclaration && ((_d = tryGetModuleSpecifierFromDeclaration(importDeclaration)) == null ? void 0 : _d.text)) ?? "...";
	            const importedIdentifier = unescapeLeadingUnderscores(isIdentifier(errorNode) ? errorNode.escapedText : symbol.escapedName);
	            error2(
	              errorNode,
	              Diagnostics._0_is_a_type_and_cannot_be_imported_in_JavaScript_files_Use_1_in_a_JSDoc_type_annotation,
	              importedIdentifier,
	              `import("${moduleSpecifier}").${importedIdentifier}`
	            );
	          }
	          return;
	        }
	        const targetFlags = getSymbolFlags(target);
	        const excludedMeanings = (symbol.flags & (111551 /* Value */ | 1048576 /* ExportValue */) ? 111551 /* Value */ : 0) | (symbol.flags & 788968 /* Type */ ? 788968 /* Type */ : 0) | (symbol.flags & 1920 /* Namespace */ ? 1920 /* Namespace */ : 0);
	        if (targetFlags & excludedMeanings) {
	          const message = node.kind === 281 /* ExportSpecifier */ ? Diagnostics.Export_declaration_conflicts_with_exported_declaration_of_0 : Diagnostics.Import_declaration_conflicts_with_local_declaration_of_0;
	          error2(node, message, symbolToString(symbol));
	        } else if (node.kind !== 281 /* ExportSpecifier */) {
	          const appearsValueyToTranspiler = compilerOptions.isolatedModules && !findAncestor(node, isTypeOnlyImportOrExportDeclaration);
	          if (appearsValueyToTranspiler && symbol.flags & (111551 /* Value */ | 1048576 /* ExportValue */)) {
	            error2(
	              node,
	              Diagnostics.Import_0_conflicts_with_local_value_so_must_be_declared_with_a_type_only_import_when_isolatedModules_is_enabled,
	              symbolToString(symbol),
	              isolatedModulesLikeFlagName
	            );
	          }
	        }
	        if (getIsolatedModules(compilerOptions) && !isTypeOnlyImportOrExportDeclaration(node) && !(node.flags & 33554432 /* Ambient */)) {
	          const typeOnlyAlias = getTypeOnlyAliasDeclaration(symbol);
	          const isType = !(targetFlags & 111551 /* Value */);
	          if (isType || typeOnlyAlias) {
	            switch (node.kind) {
	              case 273 /* ImportClause */:
	              case 276 /* ImportSpecifier */:
	              case 271 /* ImportEqualsDeclaration */: {
	                if (compilerOptions.preserveValueImports || compilerOptions.verbatimModuleSyntax) {
	                  Debug.assertIsDefined(node.name, "An ImportClause with a symbol should have a name");
	                  const message = compilerOptions.verbatimModuleSyntax && isInternalModuleImportEqualsDeclaration(node) ? Diagnostics.An_import_alias_cannot_resolve_to_a_type_or_type_only_declaration_when_verbatimModuleSyntax_is_enabled : isType ? compilerOptions.verbatimModuleSyntax ? Diagnostics._0_is_a_type_and_must_be_imported_using_a_type_only_import_when_verbatimModuleSyntax_is_enabled : Diagnostics._0_is_a_type_and_must_be_imported_using_a_type_only_import_when_preserveValueImports_and_isolatedModules_are_both_enabled : compilerOptions.verbatimModuleSyntax ? Diagnostics._0_resolves_to_a_type_only_declaration_and_must_be_imported_using_a_type_only_import_when_verbatimModuleSyntax_is_enabled : Diagnostics._0_resolves_to_a_type_only_declaration_and_must_be_imported_using_a_type_only_import_when_preserveValueImports_and_isolatedModules_are_both_enabled;
	                  const name = idText(node.kind === 276 /* ImportSpecifier */ ? node.propertyName || node.name : node.name);
	                  addTypeOnlyDeclarationRelatedInfo(
	                    error2(node, message, name),
	                    isType ? void 0 : typeOnlyAlias,
	                    name
	                  );
	                }
	                if (isType && node.kind === 271 /* ImportEqualsDeclaration */ && hasEffectiveModifier(node, 32 /* Export */)) {
	                  error2(node, Diagnostics.Cannot_use_export_import_on_a_type_or_type_only_namespace_when_0_is_enabled, isolatedModulesLikeFlagName);
	                }
	                break;
	              }
	              case 281 /* ExportSpecifier */: {
	                if (compilerOptions.verbatimModuleSyntax || getSourceFileOfNode(typeOnlyAlias) !== getSourceFileOfNode(node)) {
	                  const name = idText(node.propertyName || node.name);
	                  const diagnostic = isType ? error2(node, Diagnostics.Re_exporting_a_type_when_0_is_enabled_requires_using_export_type, isolatedModulesLikeFlagName) : error2(node, Diagnostics._0_resolves_to_a_type_only_declaration_and_must_be_re_exported_using_a_type_only_re_export_when_1_is_enabled, name, isolatedModulesLikeFlagName);
	                  addTypeOnlyDeclarationRelatedInfo(diagnostic, isType ? void 0 : typeOnlyAlias, name);
	                  break;
	                }
	              }
	            }
	          }
	          if (compilerOptions.verbatimModuleSyntax && node.kind !== 271 /* ImportEqualsDeclaration */ && !isInJSFile(node) && (moduleKind === 1 /* CommonJS */ || getSourceFileOfNode(node).impliedNodeFormat === 1 /* CommonJS */)) {
	            error2(node, Diagnostics.ESM_syntax_is_not_allowed_in_a_CommonJS_module_when_verbatimModuleSyntax_is_enabled);
	          }
	        }
	        if (isImportSpecifier(node)) {
	          const targetSymbol = resolveAliasWithDeprecationCheck(symbol, node);
	          if (isDeprecatedSymbol(targetSymbol) && targetSymbol.declarations) {
	            addDeprecatedSuggestion(node, targetSymbol.declarations, targetSymbol.escapedName);
	          }
	        }
	      }
	    }
	    function resolveAliasWithDeprecationCheck(symbol, location) {
	      if (!(symbol.flags & 2097152 /* Alias */) || isDeprecatedSymbol(symbol) || !getDeclarationOfAliasSymbol(symbol)) {
	        return symbol;
	      }
	      const targetSymbol = resolveAlias(symbol);
	      if (targetSymbol === unknownSymbol)
	        return targetSymbol;
	      while (symbol.flags & 2097152 /* Alias */) {
	        const target = getImmediateAliasedSymbol(symbol);
	        if (target) {
	          if (target === targetSymbol)
	            break;
	          if (target.declarations && length(target.declarations)) {
	            if (isDeprecatedSymbol(target)) {
	              addDeprecatedSuggestion(location, target.declarations, target.escapedName);
	              break;
	            } else {
	              if (symbol === targetSymbol)
	                break;
	              symbol = target;
	            }
	          }
	        } else {
	          break;
	        }
	      }
	      return targetSymbol;
	    }
	    function checkImportBinding(node) {
	      checkCollisionsForDeclarationName(node, node.name);
	      checkAliasSymbol(node);
	      if (node.kind === 276 /* ImportSpecifier */ && idText(node.propertyName || node.name) === "default" && getESModuleInterop(compilerOptions) && moduleKind !== 4 /* System */ && (moduleKind < 5 /* ES2015 */ || getSourceFileOfNode(node).impliedNodeFormat === 1 /* CommonJS */)) {
	        checkExternalEmitHelpers(node, 131072 /* ImportDefault */);
	      }
	    }
	    function checkImportAttributes(declaration) {
	      var _a;
	      const node = declaration.attributes;
	      if (node) {
	        const importAttributesType = getGlobalImportAttributesType(
	          /*reportErrors*/
	          true
	        );
	        if (importAttributesType !== emptyObjectType) {
	          checkTypeAssignableTo(getTypeFromImportAttributes(node), getNullableType(importAttributesType, 32768 /* Undefined */), node);
	        }
	        const validForTypeAttributes = isExclusivelyTypeOnlyImportOrExport(declaration);
	        const override = getResolutionModeOverride(node, validForTypeAttributes ? grammarErrorOnNode : void 0);
	        const isImportAttributes2 = declaration.attributes.token === 118 /* WithKeyword */;
	        if (validForTypeAttributes && override) {
	          return;
	        }
	        const mode = moduleKind === 199 /* NodeNext */ && declaration.moduleSpecifier && getUsageModeForExpression(declaration.moduleSpecifier);
	        if (mode !== 99 /* ESNext */ && moduleKind !== 99 /* ESNext */ && moduleKind !== 200 /* Preserve */) {
	          const message = isImportAttributes2 ? moduleKind === 199 /* NodeNext */ ? Diagnostics.Import_attributes_are_not_allowed_on_statements_that_compile_to_CommonJS_require_calls : Diagnostics.Import_attributes_are_only_supported_when_the_module_option_is_set_to_esnext_nodenext_or_preserve : moduleKind === 199 /* NodeNext */ ? Diagnostics.Import_assertions_are_not_allowed_on_statements_that_compile_to_CommonJS_require_calls : Diagnostics.Import_assertions_are_only_supported_when_the_module_option_is_set_to_esnext_nodenext_or_preserve;
	          return grammarErrorOnNode(node, message);
	        }
	        if (isImportDeclaration(declaration) ? (_a = declaration.importClause) == null ? void 0 : _a.isTypeOnly : declaration.isTypeOnly) {
	          return grammarErrorOnNode(node, isImportAttributes2 ? Diagnostics.Import_attributes_cannot_be_used_with_type_only_imports_or_exports : Diagnostics.Import_assertions_cannot_be_used_with_type_only_imports_or_exports);
	        }
	        if (override) {
	          return grammarErrorOnNode(node, Diagnostics.resolution_mode_can_only_be_set_for_type_only_imports);
	        }
	      }
	    }
	    function checkImportAttribute(node) {
	      return getRegularTypeOfLiteralType(checkExpressionCached(node.value));
	    }
	    function checkImportDeclaration(node) {
	      if (checkGrammarModuleElementContext(node, isInJSFile(node) ? Diagnostics.An_import_declaration_can_only_be_used_at_the_top_level_of_a_module : Diagnostics.An_import_declaration_can_only_be_used_at_the_top_level_of_a_namespace_or_module)) {
	        return;
	      }
	      if (!checkGrammarModifiers(node) && hasEffectiveModifiers(node)) {
	        grammarErrorOnFirstToken(node, Diagnostics.An_import_declaration_cannot_have_modifiers);
	      }
	      if (checkExternalImportOrExportDeclaration(node)) {
	        const importClause = node.importClause;
	        if (importClause && !checkGrammarImportClause(importClause)) {
	          if (importClause.name) {
	            checkImportBinding(importClause);
	          }
	          if (importClause.namedBindings) {
	            if (importClause.namedBindings.kind === 274 /* NamespaceImport */) {
	              checkImportBinding(importClause.namedBindings);
	              if (moduleKind !== 4 /* System */ && (moduleKind < 5 /* ES2015 */ || getSourceFileOfNode(node).impliedNodeFormat === 1 /* CommonJS */) && getESModuleInterop(compilerOptions)) {
	                checkExternalEmitHelpers(node, 65536 /* ImportStar */);
	              }
	            } else {
	              const moduleExisted = resolveExternalModuleName(node, node.moduleSpecifier);
	              if (moduleExisted) {
	                forEach(importClause.namedBindings.elements, checkImportBinding);
	              }
	            }
	          }
	        }
	      }
	      checkImportAttributes(node);
	    }
	    function checkImportEqualsDeclaration(node) {
	      if (checkGrammarModuleElementContext(node, isInJSFile(node) ? Diagnostics.An_import_declaration_can_only_be_used_at_the_top_level_of_a_module : Diagnostics.An_import_declaration_can_only_be_used_at_the_top_level_of_a_namespace_or_module)) {
	        return;
	      }
	      checkGrammarModifiers(node);
	      if (isInternalModuleImportEqualsDeclaration(node) || checkExternalImportOrExportDeclaration(node)) {
	        checkImportBinding(node);
	        if (hasSyntacticModifier(node, 32 /* Export */)) {
	          markExportAsReferenced(node);
	        }
	        if (node.moduleReference.kind !== 283 /* ExternalModuleReference */) {
	          const target = resolveAlias(getSymbolOfDeclaration(node));
	          if (target !== unknownSymbol) {
	            const targetFlags = getSymbolFlags(target);
	            if (targetFlags & 111551 /* Value */) {
	              const moduleName = getFirstIdentifier(node.moduleReference);
	              if (!(resolveEntityName(moduleName, 111551 /* Value */ | 1920 /* Namespace */).flags & 1920 /* Namespace */)) {
	                error2(moduleName, Diagnostics.Module_0_is_hidden_by_a_local_declaration_with_the_same_name, declarationNameToString(moduleName));
	              }
	            }
	            if (targetFlags & 788968 /* Type */) {
	              checkTypeNameIsReserved(node.name, Diagnostics.Import_name_cannot_be_0);
	            }
	          }
	          if (node.isTypeOnly) {
	            grammarErrorOnNode(node, Diagnostics.An_import_alias_cannot_use_import_type);
	          }
	        } else {
	          if (moduleKind >= 5 /* ES2015 */ && moduleKind !== 200 /* Preserve */ && getSourceFileOfNode(node).impliedNodeFormat === void 0 && !node.isTypeOnly && !(node.flags & 33554432 /* Ambient */)) {
	            grammarErrorOnNode(node, Diagnostics.Import_assignment_cannot_be_used_when_targeting_ECMAScript_modules_Consider_using_import_Asterisk_as_ns_from_mod_import_a_from_mod_import_d_from_mod_or_another_module_format_instead);
	          }
	        }
	      }
	    }
	    function checkExportDeclaration(node) {
	      if (checkGrammarModuleElementContext(node, isInJSFile(node) ? Diagnostics.An_export_declaration_can_only_be_used_at_the_top_level_of_a_module : Diagnostics.An_export_declaration_can_only_be_used_at_the_top_level_of_a_namespace_or_module)) {
	        return;
	      }
	      if (!checkGrammarModifiers(node) && hasSyntacticModifiers(node)) {
	        grammarErrorOnFirstToken(node, Diagnostics.An_export_declaration_cannot_have_modifiers);
	      }
	      if (node.moduleSpecifier && node.exportClause && isNamedExports(node.exportClause) && length(node.exportClause.elements) && languageVersion === 0 /* ES3 */) {
	        checkExternalEmitHelpers(node, 4194304 /* CreateBinding */);
	      }
	      checkGrammarExportDeclaration(node);
	      if (!node.moduleSpecifier || checkExternalImportOrExportDeclaration(node)) {
	        if (node.exportClause && !isNamespaceExport(node.exportClause)) {
	          forEach(node.exportClause.elements, checkExportSpecifier);
	          const inAmbientExternalModule = node.parent.kind === 268 /* ModuleBlock */ && isAmbientModule(node.parent.parent);
	          const inAmbientNamespaceDeclaration = !inAmbientExternalModule && node.parent.kind === 268 /* ModuleBlock */ && !node.moduleSpecifier && node.flags & 33554432 /* Ambient */;
	          if (node.parent.kind !== 312 /* SourceFile */ && !inAmbientExternalModule && !inAmbientNamespaceDeclaration) {
	            error2(node, Diagnostics.Export_declarations_are_not_permitted_in_a_namespace);
	          }
	        } else {
	          const moduleSymbol = resolveExternalModuleName(node, node.moduleSpecifier);
	          if (moduleSymbol && hasExportAssignmentSymbol(moduleSymbol)) {
	            error2(node.moduleSpecifier, Diagnostics.Module_0_uses_export_and_cannot_be_used_with_export_Asterisk, symbolToString(moduleSymbol));
	          } else if (node.exportClause) {
	            checkAliasSymbol(node.exportClause);
	          }
	          if (moduleKind !== 4 /* System */ && (moduleKind < 5 /* ES2015 */ || getSourceFileOfNode(node).impliedNodeFormat === 1 /* CommonJS */)) {
	            if (node.exportClause) {
	              if (getESModuleInterop(compilerOptions)) {
	                checkExternalEmitHelpers(node, 65536 /* ImportStar */);
	              }
	            } else {
	              checkExternalEmitHelpers(node, 32768 /* ExportStar */);
	            }
	          }
	        }
	      }
	      checkImportAttributes(node);
	    }
	    function checkGrammarExportDeclaration(node) {
	      var _a;
	      if (node.isTypeOnly && ((_a = node.exportClause) == null ? void 0 : _a.kind) === 279 /* NamedExports */) {
	        return checkGrammarNamedImportsOrExports(node.exportClause);
	      }
	      return false;
	    }
	    function checkGrammarModuleElementContext(node, errorMessage) {
	      const isInAppropriateContext = node.parent.kind === 312 /* SourceFile */ || node.parent.kind === 268 /* ModuleBlock */ || node.parent.kind === 267 /* ModuleDeclaration */;
	      if (!isInAppropriateContext) {
	        grammarErrorOnFirstToken(node, errorMessage);
	      }
	      return !isInAppropriateContext;
	    }
	    function importClauseContainsReferencedImport(importClause) {
	      return forEachImportClauseDeclaration(importClause, (declaration) => {
	        return !!getSymbolOfDeclaration(declaration).isReferenced;
	      });
	    }
	    function importClauseContainsConstEnumUsedAsValue(importClause) {
	      return forEachImportClauseDeclaration(importClause, (declaration) => {
	        return !!getSymbolLinks(getSymbolOfDeclaration(declaration)).constEnumReferenced;
	      });
	    }
	    function canConvertImportDeclarationToTypeOnly(statement) {
	      return isImportDeclaration(statement) && statement.importClause && !statement.importClause.isTypeOnly && importClauseContainsReferencedImport(statement.importClause) && !isReferencedAliasDeclaration(
	        statement.importClause,
	        /*checkChildren*/
	        true
	      ) && !importClauseContainsConstEnumUsedAsValue(statement.importClause);
	    }
	    function canConvertImportEqualsDeclarationToTypeOnly(statement) {
	      return isImportEqualsDeclaration(statement) && isExternalModuleReference(statement.moduleReference) && !statement.isTypeOnly && getSymbolOfDeclaration(statement).isReferenced && !isReferencedAliasDeclaration(
	        statement,
	        /*checkChildren*/
	        false
	      ) && !getSymbolLinks(getSymbolOfDeclaration(statement)).constEnumReferenced;
	    }
	    function checkImportsForTypeOnlyConversion(sourceFile) {
	      if (!canCollectSymbolAliasAccessabilityData) {
	        return;
	      }
	      for (const statement of sourceFile.statements) {
	        if (canConvertImportDeclarationToTypeOnly(statement) || canConvertImportEqualsDeclarationToTypeOnly(statement)) {
	          error2(
	            statement,
	            Diagnostics.This_import_is_never_used_as_a_value_and_must_use_import_type_because_importsNotUsedAsValues_is_set_to_error
	          );
	        }
	      }
	    }
	    function checkExportSpecifier(node) {
	      checkAliasSymbol(node);
	      if (getEmitDeclarations(compilerOptions)) {
	        collectLinkedAliases(
	          node.propertyName || node.name,
	          /*setVisibility*/
	          true
	        );
	      }
	      if (!node.parent.parent.moduleSpecifier) {
	        const exportedName = node.propertyName || node.name;
	        const symbol = resolveName(
	          exportedName,
	          exportedName.escapedText,
	          111551 /* Value */ | 788968 /* Type */ | 1920 /* Namespace */ | 2097152 /* Alias */,
	          /*nameNotFoundMessage*/
	          void 0,
	          /*nameArg*/
	          void 0,
	          /*isUse*/
	          true
	        );
	        if (symbol && (symbol === undefinedSymbol || symbol === globalThisSymbol || symbol.declarations && isGlobalSourceFile(getDeclarationContainer(symbol.declarations[0])))) {
	          error2(exportedName, Diagnostics.Cannot_export_0_Only_local_declarations_can_be_exported_from_a_module, idText(exportedName));
	        } else {
	          if (!node.isTypeOnly && !node.parent.parent.isTypeOnly) {
	            markExportAsReferenced(node);
	          }
	          const target = symbol && (symbol.flags & 2097152 /* Alias */ ? resolveAlias(symbol) : symbol);
	          if (!target || getSymbolFlags(target) & 111551 /* Value */) {
	            checkExpressionCached(node.propertyName || node.name);
	          }
	        }
	      } else {
	        if (getESModuleInterop(compilerOptions) && moduleKind !== 4 /* System */ && (moduleKind < 5 /* ES2015 */ || getSourceFileOfNode(node).impliedNodeFormat === 1 /* CommonJS */) && idText(node.propertyName || node.name) === "default") {
	          checkExternalEmitHelpers(node, 131072 /* ImportDefault */);
	        }
	      }
	    }
	    function checkExportAssignment(node) {
	      const illegalContextMessage = node.isExportEquals ? Diagnostics.An_export_assignment_must_be_at_the_top_level_of_a_file_or_module_declaration : Diagnostics.A_default_export_must_be_at_the_top_level_of_a_file_or_module_declaration;
	      if (checkGrammarModuleElementContext(node, illegalContextMessage)) {
	        return;
	      }
	      const container = node.parent.kind === 312 /* SourceFile */ ? node.parent : node.parent.parent;
	      if (container.kind === 267 /* ModuleDeclaration */ && !isAmbientModule(container)) {
	        if (node.isExportEquals) {
	          error2(node, Diagnostics.An_export_assignment_cannot_be_used_in_a_namespace);
	        } else {
	          error2(node, Diagnostics.A_default_export_can_only_be_used_in_an_ECMAScript_style_module);
	        }
	        return;
	      }
	      if (!checkGrammarModifiers(node) && hasEffectiveModifiers(node)) {
	        grammarErrorOnFirstToken(node, Diagnostics.An_export_assignment_cannot_have_modifiers);
	      }
	      const typeAnnotationNode = getEffectiveTypeAnnotationNode(node);
	      if (typeAnnotationNode) {
	        checkTypeAssignableTo(checkExpressionCached(node.expression), getTypeFromTypeNode(typeAnnotationNode), node.expression);
	      }
	      const isIllegalExportDefaultInCJS = !node.isExportEquals && !(node.flags & 33554432 /* Ambient */) && compilerOptions.verbatimModuleSyntax && (moduleKind === 1 /* CommonJS */ || getSourceFileOfNode(node).impliedNodeFormat === 1 /* CommonJS */);
	      if (node.expression.kind === 80 /* Identifier */) {
	        const id = node.expression;
	        const sym = getExportSymbolOfValueSymbolIfExported(resolveEntityName(
	          id,
	          -1 /* All */,
	          /*ignoreErrors*/
	          true,
	          /*dontResolveAlias*/
	          true,
	          node
	        ));
	        if (sym) {
	          const typeOnlyDeclaration = getTypeOnlyAliasDeclaration(sym, 111551 /* Value */);
	          markAliasReferenced(sym, id);
	          if (getSymbolFlags(sym) & 111551 /* Value */) {
	            checkExpressionCached(id);
	            if (!isIllegalExportDefaultInCJS && !(node.flags & 33554432 /* Ambient */) && compilerOptions.verbatimModuleSyntax && typeOnlyDeclaration) {
	              error2(
	                id,
	                node.isExportEquals ? Diagnostics.An_export_declaration_must_reference_a_real_value_when_verbatimModuleSyntax_is_enabled_but_0_resolves_to_a_type_only_declaration : Diagnostics.An_export_default_must_reference_a_real_value_when_verbatimModuleSyntax_is_enabled_but_0_resolves_to_a_type_only_declaration,
	                idText(id)
	              );
	            }
	          } else if (!isIllegalExportDefaultInCJS && !(node.flags & 33554432 /* Ambient */) && compilerOptions.verbatimModuleSyntax) {
	            error2(
	              id,
	              node.isExportEquals ? Diagnostics.An_export_declaration_must_reference_a_value_when_verbatimModuleSyntax_is_enabled_but_0_only_refers_to_a_type : Diagnostics.An_export_default_must_reference_a_value_when_verbatimModuleSyntax_is_enabled_but_0_only_refers_to_a_type,
	              idText(id)
	            );
	          }
	          if (!isIllegalExportDefaultInCJS && !(node.flags & 33554432 /* Ambient */) && getIsolatedModules(compilerOptions) && !(sym.flags & 111551 /* Value */)) {
	            const nonLocalMeanings = getSymbolFlags(
	              sym,
	              /*excludeTypeOnlyMeanings*/
	              false,
	              /*excludeLocalMeanings*/
	              true
	            );
	            if (sym.flags & 2097152 /* Alias */ && nonLocalMeanings & 788968 /* Type */ && !(nonLocalMeanings & 111551 /* Value */) && (!typeOnlyDeclaration || getSourceFileOfNode(typeOnlyDeclaration) !== getSourceFileOfNode(node))) {
	              error2(
	                id,
	                node.isExportEquals ? Diagnostics._0_resolves_to_a_type_and_must_be_marked_type_only_in_this_file_before_re_exporting_when_1_is_enabled_Consider_using_import_type_where_0_is_imported : Diagnostics._0_resolves_to_a_type_and_must_be_marked_type_only_in_this_file_before_re_exporting_when_1_is_enabled_Consider_using_export_type_0_as_default,
	                idText(id),
	                isolatedModulesLikeFlagName
	              );
	            } else if (typeOnlyDeclaration && getSourceFileOfNode(typeOnlyDeclaration) !== getSourceFileOfNode(node)) {
	              addTypeOnlyDeclarationRelatedInfo(
	                error2(
	                  id,
	                  node.isExportEquals ? Diagnostics._0_resolves_to_a_type_only_declaration_and_must_be_marked_type_only_in_this_file_before_re_exporting_when_1_is_enabled_Consider_using_import_type_where_0_is_imported : Diagnostics._0_resolves_to_a_type_only_declaration_and_must_be_marked_type_only_in_this_file_before_re_exporting_when_1_is_enabled_Consider_using_export_type_0_as_default,
	                  idText(id),
	                  isolatedModulesLikeFlagName
	                ),
	                typeOnlyDeclaration,
	                idText(id)
	              );
	            }
	          }
	        } else {
	          checkExpressionCached(id);
	        }
	        if (getEmitDeclarations(compilerOptions)) {
	          collectLinkedAliases(
	            id,
	            /*setVisibility*/
	            true
	          );
	        }
	      } else {
	        checkExpressionCached(node.expression);
	      }
	      if (isIllegalExportDefaultInCJS) {
	        error2(node, Diagnostics.ESM_syntax_is_not_allowed_in_a_CommonJS_module_when_verbatimModuleSyntax_is_enabled);
	      }
	      checkExternalModuleExports(container);
	      if (node.flags & 33554432 /* Ambient */ && !isEntityNameExpression(node.expression)) {
	        grammarErrorOnNode(node.expression, Diagnostics.The_expression_of_an_export_assignment_must_be_an_identifier_or_qualified_name_in_an_ambient_context);
	      }
	      if (node.isExportEquals) {
	        if (moduleKind >= 5 /* ES2015 */ && moduleKind !== 200 /* Preserve */ && (node.flags & 33554432 /* Ambient */ && getSourceFileOfNode(node).impliedNodeFormat === 99 /* ESNext */ || !(node.flags & 33554432 /* Ambient */) && getSourceFileOfNode(node).impliedNodeFormat !== 1 /* CommonJS */)) {
	          grammarErrorOnNode(node, Diagnostics.Export_assignment_cannot_be_used_when_targeting_ECMAScript_modules_Consider_using_export_default_or_another_module_format_instead);
	        } else if (moduleKind === 4 /* System */ && !(node.flags & 33554432 /* Ambient */)) {
	          grammarErrorOnNode(node, Diagnostics.Export_assignment_is_not_supported_when_module_flag_is_system);
	        }
	      }
	    }
	    function hasExportedMembers(moduleSymbol) {
	      return forEachEntry(moduleSymbol.exports, (_, id) => id !== "export=");
	    }
	    function checkExternalModuleExports(node) {
	      const moduleSymbol = getSymbolOfDeclaration(node);
	      const links = getSymbolLinks(moduleSymbol);
	      if (!links.exportsChecked) {
	        const exportEqualsSymbol = moduleSymbol.exports.get("export=");
	        if (exportEqualsSymbol && hasExportedMembers(moduleSymbol)) {
	          const declaration = getDeclarationOfAliasSymbol(exportEqualsSymbol) || exportEqualsSymbol.valueDeclaration;
	          if (declaration && !isTopLevelInExternalModuleAugmentation(declaration) && !isInJSFile(declaration)) {
	            error2(declaration, Diagnostics.An_export_assignment_cannot_be_used_in_a_module_with_other_exported_elements);
	          }
	        }
	        const exports = getExportsOfModule(moduleSymbol);
	        if (exports) {
	          exports.forEach(({ declarations, flags }, id) => {
	            if (id === "__export") {
	              return;
	            }
	            if (flags & (1920 /* Namespace */ | 384 /* Enum */)) {
	              return;
	            }
	            const exportedDeclarationsCount = countWhere(declarations, and(isNotOverloadAndNotAccessor, not(isInterfaceDeclaration)));
	            if (flags & 524288 /* TypeAlias */ && exportedDeclarationsCount <= 2) {
	              return;
	            }
	            if (exportedDeclarationsCount > 1) {
	              if (!isDuplicatedCommonJSExport(declarations)) {
	                for (const declaration of declarations) {
	                  if (isNotOverload(declaration)) {
	                    diagnostics.add(createDiagnosticForNode(declaration, Diagnostics.Cannot_redeclare_exported_variable_0, unescapeLeadingUnderscores(id)));
	                  }
	                }
	              }
	            }
	          });
	        }
	        links.exportsChecked = true;
	      }
	    }
	    function isDuplicatedCommonJSExport(declarations) {
	      return declarations && declarations.length > 1 && declarations.every((d) => isInJSFile(d) && isAccessExpression(d) && (isExportsIdentifier(d.expression) || isModuleExportsAccessExpression(d.expression)));
	    }
	    function checkSourceElement(node) {
	      if (node) {
	        const saveCurrentNode = currentNode;
	        currentNode = node;
	        instantiationCount = 0;
	        checkSourceElementWorker(node);
	        currentNode = saveCurrentNode;
	      }
	    }
	    function checkSourceElementWorker(node) {
	      if (canHaveJSDoc(node)) {
	        forEach(node.jsDoc, ({ comment, tags }) => {
	          checkJSDocCommentWorker(comment);
	          forEach(tags, (tag) => {
	            checkJSDocCommentWorker(tag.comment);
	            if (isInJSFile(node)) {
	              checkSourceElement(tag);
	            }
	          });
	        });
	      }
	      const kind = node.kind;
	      if (cancellationToken) {
	        switch (kind) {
	          case 267 /* ModuleDeclaration */:
	          case 263 /* ClassDeclaration */:
	          case 264 /* InterfaceDeclaration */:
	          case 262 /* FunctionDeclaration */:
	            cancellationToken.throwIfCancellationRequested();
	        }
	      }
	      if (kind >= 243 /* FirstStatement */ && kind <= 259 /* LastStatement */ && canHaveFlowNode(node) && node.flowNode && !isReachableFlowNode(node.flowNode)) {
	        errorOrSuggestion(compilerOptions.allowUnreachableCode === false, node, Diagnostics.Unreachable_code_detected);
	      }
	      switch (kind) {
	        case 168 /* TypeParameter */:
	          return checkTypeParameter(node);
	        case 169 /* Parameter */:
	          return checkParameter(node);
	        case 172 /* PropertyDeclaration */:
	          return checkPropertyDeclaration(node);
	        case 171 /* PropertySignature */:
	          return checkPropertySignature(node);
	        case 185 /* ConstructorType */:
	        case 184 /* FunctionType */:
	        case 179 /* CallSignature */:
	        case 180 /* ConstructSignature */:
	        case 181 /* IndexSignature */:
	          return checkSignatureDeclaration(node);
	        case 174 /* MethodDeclaration */:
	        case 173 /* MethodSignature */:
	          return checkMethodDeclaration(node);
	        case 175 /* ClassStaticBlockDeclaration */:
	          return checkClassStaticBlockDeclaration(node);
	        case 176 /* Constructor */:
	          return checkConstructorDeclaration(node);
	        case 177 /* GetAccessor */:
	        case 178 /* SetAccessor */:
	          return checkAccessorDeclaration(node);
	        case 183 /* TypeReference */:
	          return checkTypeReferenceNode(node);
	        case 182 /* TypePredicate */:
	          return checkTypePredicate(node);
	        case 186 /* TypeQuery */:
	          return checkTypeQuery(node);
	        case 187 /* TypeLiteral */:
	          return checkTypeLiteral(node);
	        case 188 /* ArrayType */:
	          return checkArrayType(node);
	        case 189 /* TupleType */:
	          return checkTupleType(node);
	        case 192 /* UnionType */:
	        case 193 /* IntersectionType */:
	          return checkUnionOrIntersectionType(node);
	        case 196 /* ParenthesizedType */:
	        case 190 /* OptionalType */:
	        case 191 /* RestType */:
	          return checkSourceElement(node.type);
	        case 197 /* ThisType */:
	          return checkThisType(node);
	        case 198 /* TypeOperator */:
	          return checkTypeOperator(node);
	        case 194 /* ConditionalType */:
	          return checkConditionalType(node);
	        case 195 /* InferType */:
	          return checkInferType(node);
	        case 203 /* TemplateLiteralType */:
	          return checkTemplateLiteralType(node);
	        case 205 /* ImportType */:
	          return checkImportType(node);
	        case 202 /* NamedTupleMember */:
	          return checkNamedTupleMember(node);
	        case 335 /* JSDocAugmentsTag */:
	          return checkJSDocAugmentsTag(node);
	        case 336 /* JSDocImplementsTag */:
	          return checkJSDocImplementsTag(node);
	        case 353 /* JSDocTypedefTag */:
	        case 345 /* JSDocCallbackTag */:
	        case 347 /* JSDocEnumTag */:
	          return checkJSDocTypeAliasTag(node);
	        case 352 /* JSDocTemplateTag */:
	          return checkJSDocTemplateTag(node);
	        case 351 /* JSDocTypeTag */:
	          return checkJSDocTypeTag(node);
	        case 331 /* JSDocLink */:
	        case 332 /* JSDocLinkCode */:
	        case 333 /* JSDocLinkPlain */:
	          return checkJSDocLinkLikeTag(node);
	        case 348 /* JSDocParameterTag */:
	          return checkJSDocParameterTag(node);
	        case 355 /* JSDocPropertyTag */:
	          return checkJSDocPropertyTag(node);
	        case 324 /* JSDocFunctionType */:
	          checkJSDocFunctionType(node);
	        case 322 /* JSDocNonNullableType */:
	        case 321 /* JSDocNullableType */:
	        case 319 /* JSDocAllType */:
	        case 320 /* JSDocUnknownType */:
	        case 329 /* JSDocTypeLiteral */:
	          checkJSDocTypeIsInJsFile(node);
	          forEachChild(node, checkSourceElement);
	          return;
	        case 325 /* JSDocVariadicType */:
	          checkJSDocVariadicType(node);
	          return;
	        case 316 /* JSDocTypeExpression */:
	          return checkSourceElement(node.type);
	        case 340 /* JSDocPublicTag */:
	        case 342 /* JSDocProtectedTag */:
	        case 341 /* JSDocPrivateTag */:
	          return checkJSDocAccessibilityModifiers(node);
	        case 357 /* JSDocSatisfiesTag */:
	          return checkJSDocSatisfiesTag(node);
	        case 350 /* JSDocThisTag */:
	          return checkJSDocThisTag(node);
	        case 199 /* IndexedAccessType */:
	          return checkIndexedAccessType(node);
	        case 200 /* MappedType */:
	          return checkMappedType(node);
	        case 262 /* FunctionDeclaration */:
	          return checkFunctionDeclaration(node);
	        case 241 /* Block */:
	        case 268 /* ModuleBlock */:
	          return checkBlock(node);
	        case 243 /* VariableStatement */:
	          return checkVariableStatement(node);
	        case 244 /* ExpressionStatement */:
	          return checkExpressionStatement(node);
	        case 245 /* IfStatement */:
	          return checkIfStatement(node);
	        case 246 /* DoStatement */:
	          return checkDoStatement(node);
	        case 247 /* WhileStatement */:
	          return checkWhileStatement(node);
	        case 248 /* ForStatement */:
	          return checkForStatement(node);
	        case 249 /* ForInStatement */:
	          return checkForInStatement(node);
	        case 250 /* ForOfStatement */:
	          return checkForOfStatement(node);
	        case 251 /* ContinueStatement */:
	        case 252 /* BreakStatement */:
	          return checkBreakOrContinueStatement(node);
	        case 253 /* ReturnStatement */:
	          return checkReturnStatement(node);
	        case 254 /* WithStatement */:
	          return checkWithStatement(node);
	        case 255 /* SwitchStatement */:
	          return checkSwitchStatement(node);
	        case 256 /* LabeledStatement */:
	          return checkLabeledStatement(node);
	        case 257 /* ThrowStatement */:
	          return checkThrowStatement(node);
	        case 258 /* TryStatement */:
	          return checkTryStatement(node);
	        case 260 /* VariableDeclaration */:
	          return checkVariableDeclaration(node);
	        case 208 /* BindingElement */:
	          return checkBindingElement(node);
	        case 263 /* ClassDeclaration */:
	          return checkClassDeclaration(node);
	        case 264 /* InterfaceDeclaration */:
	          return checkInterfaceDeclaration(node);
	        case 265 /* TypeAliasDeclaration */:
	          return checkTypeAliasDeclaration(node);
	        case 266 /* EnumDeclaration */:
	          return checkEnumDeclaration(node);
	        case 267 /* ModuleDeclaration */:
	          return checkModuleDeclaration(node);
	        case 272 /* ImportDeclaration */:
	          return checkImportDeclaration(node);
	        case 271 /* ImportEqualsDeclaration */:
	          return checkImportEqualsDeclaration(node);
	        case 278 /* ExportDeclaration */:
	          return checkExportDeclaration(node);
	        case 277 /* ExportAssignment */:
	          return checkExportAssignment(node);
	        case 242 /* EmptyStatement */:
	        case 259 /* DebuggerStatement */:
	          checkGrammarStatementInAmbientContext(node);
	          return;
	        case 282 /* MissingDeclaration */:
	          return checkMissingDeclaration(node);
	      }
	    }
	    function checkJSDocCommentWorker(node) {
	      if (isArray(node)) {
	        forEach(node, (tag) => {
	          if (isJSDocLinkLike(tag)) {
	            checkSourceElement(tag);
	          }
	        });
	      }
	    }
	    function checkJSDocTypeIsInJsFile(node) {
	      if (!isInJSFile(node)) {
	        if (isJSDocNonNullableType(node) || isJSDocNullableType(node)) {
	          const token = tokenToString(isJSDocNonNullableType(node) ? 54 /* ExclamationToken */ : 58 /* QuestionToken */);
	          const diagnostic = node.postfix ? Diagnostics._0_at_the_end_of_a_type_is_not_valid_TypeScript_syntax_Did_you_mean_to_write_1 : Diagnostics._0_at_the_start_of_a_type_is_not_valid_TypeScript_syntax_Did_you_mean_to_write_1;
	          const typeNode = node.type;
	          const type = getTypeFromTypeNode(typeNode);
	          grammarErrorOnNode(
	            node,
	            diagnostic,
	            token,
	            typeToString(
	              isJSDocNullableType(node) && !(type === neverType || type === voidType) ? getUnionType(append([type, undefinedType], node.postfix ? void 0 : nullType)) : type
	            )
	          );
	        } else {
	          grammarErrorOnNode(node, Diagnostics.JSDoc_types_can_only_be_used_inside_documentation_comments);
	        }
	      }
	    }
	    function checkJSDocVariadicType(node) {
	      checkJSDocTypeIsInJsFile(node);
	      checkSourceElement(node.type);
	      const { parent: parent2 } = node;
	      if (isParameter(parent2) && isJSDocFunctionType(parent2.parent)) {
	        if (last(parent2.parent.parameters) !== parent2) {
	          error2(node, Diagnostics.A_rest_parameter_must_be_last_in_a_parameter_list);
	        }
	        return;
	      }
	      if (!isJSDocTypeExpression(parent2)) {
	        error2(node, Diagnostics.JSDoc_may_only_appear_in_the_last_parameter_of_a_signature);
	      }
	      const paramTag = node.parent.parent;
	      if (!isJSDocParameterTag(paramTag)) {
	        error2(node, Diagnostics.JSDoc_may_only_appear_in_the_last_parameter_of_a_signature);
	        return;
	      }
	      const param = getParameterSymbolFromJSDoc(paramTag);
	      if (!param) {
	        return;
	      }
	      const host2 = getHostSignatureFromJSDoc(paramTag);
	      if (!host2 || last(host2.parameters).symbol !== param) {
	        error2(node, Diagnostics.A_rest_parameter_must_be_last_in_a_parameter_list);
	      }
	    }
	    function getTypeFromJSDocVariadicType(node) {
	      const type = getTypeFromTypeNode(node.type);
	      const { parent: parent2 } = node;
	      const paramTag = node.parent.parent;
	      if (isJSDocTypeExpression(node.parent) && isJSDocParameterTag(paramTag)) {
	        const host2 = getHostSignatureFromJSDoc(paramTag);
	        const isCallbackTag = isJSDocCallbackTag(paramTag.parent.parent);
	        if (host2 || isCallbackTag) {
	          const lastParamDeclaration = isCallbackTag ? lastOrUndefined(paramTag.parent.parent.typeExpression.parameters) : lastOrUndefined(host2.parameters);
	          const symbol = getParameterSymbolFromJSDoc(paramTag);
	          if (!lastParamDeclaration || symbol && lastParamDeclaration.symbol === symbol && isRestParameter(lastParamDeclaration)) {
	            return createArrayType(type);
	          }
	        }
	      }
	      if (isParameter(parent2) && isJSDocFunctionType(parent2.parent)) {
	        return createArrayType(type);
	      }
	      return addOptionality(type);
	    }
	    function checkNodeDeferred(node) {
	      const enclosingFile = getSourceFileOfNode(node);
	      const links = getNodeLinks(enclosingFile);
	      if (!(links.flags & 1 /* TypeChecked */)) {
	        links.deferredNodes || (links.deferredNodes = /* @__PURE__ */ new Set());
	        links.deferredNodes.add(node);
	      } else {
	        Debug.assert(!links.deferredNodes, "A type-checked file should have no deferred nodes.");
	      }
	    }
	    function checkDeferredNodes(context) {
	      const links = getNodeLinks(context);
	      if (links.deferredNodes) {
	        links.deferredNodes.forEach(checkDeferredNode);
	      }
	      links.deferredNodes = void 0;
	    }
	    function checkDeferredNode(node) {
	      var _a, _b;
	      (_a = tracing) == null ? void 0 : _a.push(tracing.Phase.Check, "checkDeferredNode", { kind: node.kind, pos: node.pos, end: node.end, path: node.tracingPath });
	      const saveCurrentNode = currentNode;
	      currentNode = node;
	      instantiationCount = 0;
	      switch (node.kind) {
	        case 213 /* CallExpression */:
	        case 214 /* NewExpression */:
	        case 215 /* TaggedTemplateExpression */:
	        case 170 /* Decorator */:
	        case 286 /* JsxOpeningElement */:
	          resolveUntypedCall(node);
	          break;
	        case 218 /* FunctionExpression */:
	        case 219 /* ArrowFunction */:
	        case 174 /* MethodDeclaration */:
	        case 173 /* MethodSignature */:
	          checkFunctionExpressionOrObjectLiteralMethodDeferred(node);
	          break;
	        case 177 /* GetAccessor */:
	        case 178 /* SetAccessor */:
	          checkAccessorDeclaration(node);
	          break;
	        case 231 /* ClassExpression */:
	          checkClassExpressionDeferred(node);
	          break;
	        case 168 /* TypeParameter */:
	          checkTypeParameterDeferred(node);
	          break;
	        case 285 /* JsxSelfClosingElement */:
	          checkJsxSelfClosingElementDeferred(node);
	          break;
	        case 284 /* JsxElement */:
	          checkJsxElementDeferred(node);
	          break;
	        case 216 /* TypeAssertionExpression */:
	        case 234 /* AsExpression */:
	        case 217 /* ParenthesizedExpression */:
	          checkAssertionDeferred(node);
	          break;
	        case 222 /* VoidExpression */:
	          checkExpression(node.expression);
	          break;
	        case 226 /* BinaryExpression */:
	          if (isInstanceOfExpression(node)) {
	            resolveUntypedCall(node);
	          }
	          break;
	      }
	      currentNode = saveCurrentNode;
	      (_b = tracing) == null ? void 0 : _b.pop();
	    }
	    function checkSourceFile(node) {
	      var _a, _b;
	      (_a = tracing) == null ? void 0 : _a.push(
	        tracing.Phase.Check,
	        "checkSourceFile",
	        { path: node.path },
	        /*separateBeginAndEnd*/
	        true
	      );
	      mark("beforeCheck");
	      checkSourceFileWorker(node);
	      mark("afterCheck");
	      measure("Check", "beforeCheck", "afterCheck");
	      (_b = tracing) == null ? void 0 : _b.pop();
	    }
	    function unusedIsError(kind, isAmbient) {
	      if (isAmbient) {
	        return false;
	      }
	      switch (kind) {
	        case 0 /* Local */:
	          return !!compilerOptions.noUnusedLocals;
	        case 1 /* Parameter */:
	          return !!compilerOptions.noUnusedParameters;
	        default:
	          return Debug.assertNever(kind);
	      }
	    }
	    function getPotentiallyUnusedIdentifiers(sourceFile) {
	      return allPotentiallyUnusedIdentifiers.get(sourceFile.path) || emptyArray;
	    }
	    function checkSourceFileWorker(node) {
	      const links = getNodeLinks(node);
	      if (!(links.flags & 1 /* TypeChecked */)) {
	        if (skipTypeChecking(node, compilerOptions, host)) {
	          return;
	        }
	        checkGrammarSourceFile(node);
	        clear(potentialThisCollisions);
	        clear(potentialNewTargetCollisions);
	        clear(potentialWeakMapSetCollisions);
	        clear(potentialReflectCollisions);
	        clear(potentialUnusedRenamedBindingElementsInTypes);
	        forEach(node.statements, checkSourceElement);
	        checkSourceElement(node.endOfFileToken);
	        checkDeferredNodes(node);
	        if (isExternalOrCommonJsModule(node)) {
	          registerForUnusedIdentifiersCheck(node);
	        }
	        addLazyDiagnostic(() => {
	          if (!node.isDeclarationFile && (compilerOptions.noUnusedLocals || compilerOptions.noUnusedParameters)) {
	            checkUnusedIdentifiers(getPotentiallyUnusedIdentifiers(node), (containingNode, kind, diag2) => {
	              if (!containsParseError(containingNode) && unusedIsError(kind, !!(containingNode.flags & 33554432 /* Ambient */))) {
	                diagnostics.add(diag2);
	              }
	            });
	          }
	          if (!node.isDeclarationFile) {
	            checkPotentialUncheckedRenamedBindingElementsInTypes();
	          }
	        });
	        if (compilerOptions.importsNotUsedAsValues === 2 /* Error */ && !node.isDeclarationFile && isExternalModule(node)) {
	          checkImportsForTypeOnlyConversion(node);
	        }
	        if (isExternalOrCommonJsModule(node)) {
	          checkExternalModuleExports(node);
	        }
	        if (potentialThisCollisions.length) {
	          forEach(potentialThisCollisions, checkIfThisIsCapturedInEnclosingScope);
	          clear(potentialThisCollisions);
	        }
	        if (potentialNewTargetCollisions.length) {
	          forEach(potentialNewTargetCollisions, checkIfNewTargetIsCapturedInEnclosingScope);
	          clear(potentialNewTargetCollisions);
	        }
	        if (potentialWeakMapSetCollisions.length) {
	          forEach(potentialWeakMapSetCollisions, checkWeakMapSetCollision);
	          clear(potentialWeakMapSetCollisions);
	        }
	        if (potentialReflectCollisions.length) {
	          forEach(potentialReflectCollisions, checkReflectCollision);
	          clear(potentialReflectCollisions);
	        }
	        links.flags |= 1 /* TypeChecked */;
	      }
	    }
	    function getDiagnostics2(sourceFile, ct) {
	      try {
	        cancellationToken = ct;
	        return getDiagnosticsWorker(sourceFile);
	      } finally {
	        cancellationToken = void 0;
	      }
	    }
	    function ensurePendingDiagnosticWorkComplete() {
	      for (const cb of deferredDiagnosticsCallbacks) {
	        cb();
	      }
	      deferredDiagnosticsCallbacks = [];
	    }
	    function checkSourceFileWithEagerDiagnostics(sourceFile) {
	      ensurePendingDiagnosticWorkComplete();
	      const oldAddLazyDiagnostics = addLazyDiagnostic;
	      addLazyDiagnostic = (cb) => cb();
	      checkSourceFile(sourceFile);
	      addLazyDiagnostic = oldAddLazyDiagnostics;
	    }
	    function getDiagnosticsWorker(sourceFile) {
	      if (sourceFile) {
	        ensurePendingDiagnosticWorkComplete();
	        const previousGlobalDiagnostics = diagnostics.getGlobalDiagnostics();
	        const previousGlobalDiagnosticsSize = previousGlobalDiagnostics.length;
	        checkSourceFileWithEagerDiagnostics(sourceFile);
	        const semanticDiagnostics = diagnostics.getDiagnostics(sourceFile.fileName);
	        const currentGlobalDiagnostics = diagnostics.getGlobalDiagnostics();
	        if (currentGlobalDiagnostics !== previousGlobalDiagnostics) {
	          const deferredGlobalDiagnostics = relativeComplement(previousGlobalDiagnostics, currentGlobalDiagnostics, compareDiagnostics);
	          return concatenate(deferredGlobalDiagnostics, semanticDiagnostics);
	        } else if (previousGlobalDiagnosticsSize === 0 && currentGlobalDiagnostics.length > 0) {
	          return concatenate(currentGlobalDiagnostics, semanticDiagnostics);
	        }
	        return semanticDiagnostics;
	      }
	      forEach(host.getSourceFiles(), checkSourceFileWithEagerDiagnostics);
	      return diagnostics.getDiagnostics();
	    }
	    function getGlobalDiagnostics() {
	      ensurePendingDiagnosticWorkComplete();
	      return diagnostics.getGlobalDiagnostics();
	    }
	    function getSymbolsInScope(location, meaning) {
	      if (location.flags & 67108864 /* InWithStatement */) {
	        return [];
	      }
	      const symbols = createSymbolTable();
	      let isStaticSymbol = false;
	      populateSymbols();
	      symbols.delete("this" /* This */);
	      return symbolsToArray(symbols);
	      function populateSymbols() {
	        while (location) {
	          if (canHaveLocals(location) && location.locals && !isGlobalSourceFile(location)) {
	            copySymbols(location.locals, meaning);
	          }
	          switch (location.kind) {
	            case 312 /* SourceFile */:
	              if (!isExternalModule(location))
	                break;
	            case 267 /* ModuleDeclaration */:
	              copyLocallyVisibleExportSymbols(getSymbolOfDeclaration(location).exports, meaning & 2623475 /* ModuleMember */);
	              break;
	            case 266 /* EnumDeclaration */:
	              copySymbols(getSymbolOfDeclaration(location).exports, meaning & 8 /* EnumMember */);
	              break;
	            case 231 /* ClassExpression */:
	              const className = location.name;
	              if (className) {
	                copySymbol(location.symbol, meaning);
	              }
	            case 263 /* ClassDeclaration */:
	            case 264 /* InterfaceDeclaration */:
	              if (!isStaticSymbol) {
	                copySymbols(getMembersOfSymbol(getSymbolOfDeclaration(location)), meaning & 788968 /* Type */);
	              }
	              break;
	            case 218 /* FunctionExpression */:
	              const funcName = location.name;
	              if (funcName) {
	                copySymbol(location.symbol, meaning);
	              }
	              break;
	          }
	          if (introducesArgumentsExoticObject(location)) {
	            copySymbol(argumentsSymbol, meaning);
	          }
	          isStaticSymbol = isStatic(location);
	          location = location.parent;
	        }
	        copySymbols(globals, meaning);
	      }
	      function copySymbol(symbol, meaning2) {
	        if (getCombinedLocalAndExportSymbolFlags(symbol) & meaning2) {
	          const id = symbol.escapedName;
	          if (!symbols.has(id)) {
	            symbols.set(id, symbol);
	          }
	        }
	      }
	      function copySymbols(source, meaning2) {
	        if (meaning2) {
	          source.forEach((symbol) => {
	            copySymbol(symbol, meaning2);
	          });
	        }
	      }
	      function copyLocallyVisibleExportSymbols(source, meaning2) {
	        if (meaning2) {
	          source.forEach((symbol) => {
	            if (!getDeclarationOfKind(symbol, 281 /* ExportSpecifier */) && !getDeclarationOfKind(symbol, 280 /* NamespaceExport */) && symbol.escapedName !== "default" /* Default */) {
	              copySymbol(symbol, meaning2);
	            }
	          });
	        }
	      }
	    }
	    function isTypeDeclarationName(name) {
	      return name.kind === 80 /* Identifier */ && isTypeDeclaration(name.parent) && getNameOfDeclaration(name.parent) === name;
	    }
	    function isTypeReferenceIdentifier(node) {
	      while (node.parent.kind === 166 /* QualifiedName */) {
	        node = node.parent;
	      }
	      return node.parent.kind === 183 /* TypeReference */;
	    }
	    function isInNameOfExpressionWithTypeArguments(node) {
	      while (node.parent.kind === 211 /* PropertyAccessExpression */) {
	        node = node.parent;
	      }
	      return node.parent.kind === 233 /* ExpressionWithTypeArguments */;
	    }
	    function forEachEnclosingClass(node, callback) {
	      let result;
	      let containingClass = getContainingClass(node);
	      while (containingClass) {
	        if (result = callback(containingClass))
	          break;
	        containingClass = getContainingClass(containingClass);
	      }
	      return result;
	    }
	    function isNodeUsedDuringClassInitialization(node) {
	      return !!findAncestor(node, (element) => {
	        if (isConstructorDeclaration(element) && nodeIsPresent(element.body) || isPropertyDeclaration(element)) {
	          return true;
	        } else if (isClassLike(element) || isFunctionLikeDeclaration(element)) {
	          return "quit";
	        }
	        return false;
	      });
	    }
	    function isNodeWithinClass(node, classDeclaration) {
	      return !!forEachEnclosingClass(node, (n) => n === classDeclaration);
	    }
	    function getLeftSideOfImportEqualsOrExportAssignment(nodeOnRightSide) {
	      while (nodeOnRightSide.parent.kind === 166 /* QualifiedName */) {
	        nodeOnRightSide = nodeOnRightSide.parent;
	      }
	      if (nodeOnRightSide.parent.kind === 271 /* ImportEqualsDeclaration */) {
	        return nodeOnRightSide.parent.moduleReference === nodeOnRightSide ? nodeOnRightSide.parent : void 0;
	      }
	      if (nodeOnRightSide.parent.kind === 277 /* ExportAssignment */) {
	        return nodeOnRightSide.parent.expression === nodeOnRightSide ? nodeOnRightSide.parent : void 0;
	      }
	      return void 0;
	    }
	    function isInRightSideOfImportOrExportAssignment(node) {
	      return getLeftSideOfImportEqualsOrExportAssignment(node) !== void 0;
	    }
	    function getSpecialPropertyAssignmentSymbolFromEntityName(entityName) {
	      const specialPropertyAssignmentKind = getAssignmentDeclarationKind(entityName.parent.parent);
	      switch (specialPropertyAssignmentKind) {
	        case 1 /* ExportsProperty */:
	        case 3 /* PrototypeProperty */:
	          return getSymbolOfNode(entityName.parent);
	        case 5 /* Property */:
	          if (isPropertyAccessExpression(entityName.parent) && getLeftmostAccessExpression(entityName.parent) === entityName) {
	            return void 0;
	          }
	        case 4 /* ThisProperty */:
	        case 2 /* ModuleExports */:
	          return getSymbolOfDeclaration(entityName.parent.parent);
	      }
	    }
	    function isImportTypeQualifierPart(node) {
	      let parent2 = node.parent;
	      while (isQualifiedName(parent2)) {
	        node = parent2;
	        parent2 = parent2.parent;
	      }
	      if (parent2 && parent2.kind === 205 /* ImportType */ && parent2.qualifier === node) {
	        return parent2;
	      }
	      return void 0;
	    }
	    function isThisPropertyAndThisTyped(node) {
	      if (node.expression.kind === 110 /* ThisKeyword */) {
	        const container = getThisContainer(
	          node,
	          /*includeArrowFunctions*/
	          false,
	          /*includeClassComputedPropertyName*/
	          false
	        );
	        if (isFunctionLike(container)) {
	          const containingLiteral = getContainingObjectLiteral(container);
	          if (containingLiteral) {
	            const contextualType = getApparentTypeOfContextualType(
	              containingLiteral,
	              /*contextFlags*/
	              void 0
	            );
	            const type = getThisTypeOfObjectLiteralFromContextualType(containingLiteral, contextualType);
	            return type && !isTypeAny(type);
	          }
	        }
	      }
	    }
	    function getSymbolOfNameOrPropertyAccessExpression(name) {
	      if (isDeclarationName(name)) {
	        return getSymbolOfNode(name.parent);
	      }
	      if (isInJSFile(name) && name.parent.kind === 211 /* PropertyAccessExpression */ && name.parent === name.parent.parent.left) {
	        if (!isPrivateIdentifier(name) && !isJSDocMemberName(name) && !isThisPropertyAndThisTyped(name.parent)) {
	          const specialPropertyAssignmentSymbol = getSpecialPropertyAssignmentSymbolFromEntityName(name);
	          if (specialPropertyAssignmentSymbol) {
	            return specialPropertyAssignmentSymbol;
	          }
	        }
	      }
	      if (name.parent.kind === 277 /* ExportAssignment */ && isEntityNameExpression(name)) {
	        const success = resolveEntityName(
	          name,
	          /*all meanings*/
	          111551 /* Value */ | 788968 /* Type */ | 1920 /* Namespace */ | 2097152 /* Alias */,
	          /*ignoreErrors*/
	          true
	        );
	        if (success && success !== unknownSymbol) {
	          return success;
	        }
	      } else if (isEntityName(name) && isInRightSideOfImportOrExportAssignment(name)) {
	        const importEqualsDeclaration = getAncestor(name, 271 /* ImportEqualsDeclaration */);
	        Debug.assert(importEqualsDeclaration !== void 0);
	        return getSymbolOfPartOfRightHandSideOfImportEquals(
	          name,
	          /*dontResolveAlias*/
	          true
	        );
	      }
	      if (isEntityName(name)) {
	        const possibleImportNode = isImportTypeQualifierPart(name);
	        if (possibleImportNode) {
	          getTypeFromTypeNode(possibleImportNode);
	          const sym = getNodeLinks(name).resolvedSymbol;
	          return sym === unknownSymbol ? void 0 : sym;
	        }
	      }
	      while (isRightSideOfQualifiedNameOrPropertyAccessOrJSDocMemberName(name)) {
	        name = name.parent;
	      }
	      if (isInNameOfExpressionWithTypeArguments(name)) {
	        let meaning = 0 /* None */;
	        if (name.parent.kind === 233 /* ExpressionWithTypeArguments */) {
	          meaning = isPartOfTypeNode(name) ? 788968 /* Type */ : 111551 /* Value */;
	          if (isExpressionWithTypeArgumentsInClassExtendsClause(name.parent)) {
	            meaning |= 111551 /* Value */;
	          }
	        } else {
	          meaning = 1920 /* Namespace */;
	        }
	        meaning |= 2097152 /* Alias */;
	        const entityNameSymbol = isEntityNameExpression(name) ? resolveEntityName(
	          name,
	          meaning,
	          /*ignoreErrors*/
	          true
	        ) : void 0;
	        if (entityNameSymbol) {
	          return entityNameSymbol;
	        }
	      }
	      if (name.parent.kind === 348 /* JSDocParameterTag */) {
	        return getParameterSymbolFromJSDoc(name.parent);
	      }
	      if (name.parent.kind === 168 /* TypeParameter */ && name.parent.parent.kind === 352 /* JSDocTemplateTag */) {
	        Debug.assert(!isInJSFile(name));
	        const typeParameter = getTypeParameterFromJsDoc(name.parent);
	        return typeParameter && typeParameter.symbol;
	      }
	      if (isExpressionNode(name)) {
	        if (nodeIsMissing(name)) {
	          return void 0;
	        }
	        const isJSDoc2 = findAncestor(name, or(isJSDocLinkLike, isJSDocNameReference, isJSDocMemberName));
	        const meaning = isJSDoc2 ? 788968 /* Type */ | 1920 /* Namespace */ | 111551 /* Value */ : 111551 /* Value */;
	        if (name.kind === 80 /* Identifier */) {
	          if (isJSXTagName(name) && isJsxIntrinsicTagName(name)) {
	            const symbol = getIntrinsicTagSymbol(name.parent);
	            return symbol === unknownSymbol ? void 0 : symbol;
	          }
	          const result = resolveEntityName(
	            name,
	            meaning,
	            /*ignoreErrors*/
	            true,
	            /*dontResolveAlias*/
	            true,
	            getHostSignatureFromJSDoc(name)
	          );
	          if (!result && isJSDoc2) {
	            const container = findAncestor(name, or(isClassLike, isInterfaceDeclaration));
	            if (container) {
	              return resolveJSDocMemberName(
	                name,
	                /*ignoreErrors*/
	                true,
	                getSymbolOfDeclaration(container)
	              );
	            }
	          }
	          if (result && isJSDoc2) {
	            const container = getJSDocHost(name);
	            if (container && isEnumMember(container) && container === result.valueDeclaration) {
	              return resolveEntityName(
	                name,
	                meaning,
	                /*ignoreErrors*/
	                true,
	                /*dontResolveAlias*/
	                true,
	                getSourceFileOfNode(container)
	              ) || result;
	            }
	          }
	          return result;
	        } else if (isPrivateIdentifier(name)) {
	          return getSymbolForPrivateIdentifierExpression(name);
	        } else if (name.kind === 211 /* PropertyAccessExpression */ || name.kind === 166 /* QualifiedName */) {
	          const links = getNodeLinks(name);
	          if (links.resolvedSymbol) {
	            return links.resolvedSymbol;
	          }
	          if (name.kind === 211 /* PropertyAccessExpression */) {
	            checkPropertyAccessExpression(name, 0 /* Normal */);
	            if (!links.resolvedSymbol) {
	              links.resolvedSymbol = getApplicableIndexSymbol(checkExpressionCached(name.expression), getLiteralTypeFromPropertyName(name.name));
	            }
	          } else {
	            checkQualifiedName(name, 0 /* Normal */);
	          }
	          if (!links.resolvedSymbol && isJSDoc2 && isQualifiedName(name)) {
	            return resolveJSDocMemberName(name);
	          }
	          return links.resolvedSymbol;
	        } else if (isJSDocMemberName(name)) {
	          return resolveJSDocMemberName(name);
	        }
	      } else if (isTypeReferenceIdentifier(name)) {
	        const meaning = name.parent.kind === 183 /* TypeReference */ ? 788968 /* Type */ : 1920 /* Namespace */;
	        const symbol = resolveEntityName(
	          name,
	          meaning,
	          /*ignoreErrors*/
	          false,
	          /*dontResolveAlias*/
	          true
	        );
	        return symbol && symbol !== unknownSymbol ? symbol : getUnresolvedSymbolForEntityName(name);
	      }
	      if (name.parent.kind === 182 /* TypePredicate */) {
	        return resolveEntityName(
	          name,
	          /*meaning*/
	          1 /* FunctionScopedVariable */
	        );
	      }
	      return void 0;
	    }
	    function getApplicableIndexSymbol(type, keyType) {
	      const infos = getApplicableIndexInfos(type, keyType);
	      if (infos.length && type.members) {
	        const symbol = getIndexSymbolFromSymbolTable(resolveStructuredTypeMembers(type).members);
	        if (infos === getIndexInfosOfType(type)) {
	          return symbol;
	        } else if (symbol) {
	          const symbolLinks2 = getSymbolLinks(symbol);
	          const declarationList = mapDefined(infos, (i) => i.declaration);
	          const nodeListId = map(declarationList, getNodeId).join(",");
	          if (!symbolLinks2.filteredIndexSymbolCache) {
	            symbolLinks2.filteredIndexSymbolCache = /* @__PURE__ */ new Map();
	          }
	          if (symbolLinks2.filteredIndexSymbolCache.has(nodeListId)) {
	            return symbolLinks2.filteredIndexSymbolCache.get(nodeListId);
	          } else {
	            const copy = createSymbol(131072 /* Signature */, "__index" /* Index */);
	            copy.declarations = mapDefined(infos, (i) => i.declaration);
	            copy.parent = type.aliasSymbol ? type.aliasSymbol : type.symbol ? type.symbol : getSymbolAtLocation(copy.declarations[0].parent);
	            symbolLinks2.filteredIndexSymbolCache.set(nodeListId, copy);
	            return copy;
	          }
	        }
	      }
	    }
	    function resolveJSDocMemberName(name, ignoreErrors, container) {
	      if (isEntityName(name)) {
	        const meaning = 788968 /* Type */ | 1920 /* Namespace */ | 111551 /* Value */;
	        let symbol = resolveEntityName(
	          name,
	          meaning,
	          ignoreErrors,
	          /*dontResolveAlias*/
	          true,
	          getHostSignatureFromJSDoc(name)
	        );
	        if (!symbol && isIdentifier(name) && container) {
	          symbol = getMergedSymbol(getSymbol2(getExportsOfSymbol(container), name.escapedText, meaning));
	        }
	        if (symbol) {
	          return symbol;
	        }
	      }
	      const left = isIdentifier(name) ? container : resolveJSDocMemberName(name.left, ignoreErrors, container);
	      const right = isIdentifier(name) ? name.escapedText : name.right.escapedText;
	      if (left) {
	        const proto = left.flags & 111551 /* Value */ && getPropertyOfType(getTypeOfSymbol(left), "prototype");
	        const t = proto ? getTypeOfSymbol(proto) : getDeclaredTypeOfSymbol(left);
	        return getPropertyOfType(t, right);
	      }
	    }
	    function getSymbolAtLocation(node, ignoreErrors) {
	      if (isSourceFile(node)) {
	        return isExternalModule(node) ? getMergedSymbol(node.symbol) : void 0;
	      }
	      const { parent: parent2 } = node;
	      const grandParent = parent2.parent;
	      if (node.flags & 67108864 /* InWithStatement */) {
	        return void 0;
	      }
	      if (isDeclarationNameOrImportPropertyName(node)) {
	        const parentSymbol = getSymbolOfDeclaration(parent2);
	        return isImportOrExportSpecifier(node.parent) && node.parent.propertyName === node ? getImmediateAliasedSymbol(parentSymbol) : parentSymbol;
	      } else if (isLiteralComputedPropertyDeclarationName(node)) {
	        return getSymbolOfDeclaration(parent2.parent);
	      }
	      if (node.kind === 80 /* Identifier */) {
	        if (isInRightSideOfImportOrExportAssignment(node)) {
	          return getSymbolOfNameOrPropertyAccessExpression(node);
	        } else if (parent2.kind === 208 /* BindingElement */ && grandParent.kind === 206 /* ObjectBindingPattern */ && node === parent2.propertyName) {
	          const typeOfPattern = getTypeOfNode(grandParent);
	          const propertyDeclaration = getPropertyOfType(typeOfPattern, node.escapedText);
	          if (propertyDeclaration) {
	            return propertyDeclaration;
	          }
	        } else if (isMetaProperty(parent2) && parent2.name === node) {
	          if (parent2.keywordToken === 105 /* NewKeyword */ && idText(node) === "target") {
	            return checkNewTargetMetaProperty(parent2).symbol;
	          }
	          if (parent2.keywordToken === 102 /* ImportKeyword */ && idText(node) === "meta") {
	            return getGlobalImportMetaExpressionType().members.get("meta");
	          }
	          return void 0;
	        }
	      }
	      switch (node.kind) {
	        case 80 /* Identifier */:
	        case 81 /* PrivateIdentifier */:
	        case 211 /* PropertyAccessExpression */:
	        case 166 /* QualifiedName */:
	          if (!isThisInTypeQuery(node)) {
	            return getSymbolOfNameOrPropertyAccessExpression(node);
	          }
	        case 110 /* ThisKeyword */:
	          const container = getThisContainer(
	            node,
	            /*includeArrowFunctions*/
	            false,
	            /*includeClassComputedPropertyName*/
	            false
	          );
	          if (isFunctionLike(container)) {
	            const sig = getSignatureFromDeclaration(container);
	            if (sig.thisParameter) {
	              return sig.thisParameter;
	            }
	          }
	          if (isInExpressionContext(node)) {
	            return checkExpression(node).symbol;
	          }
	        case 197 /* ThisType */:
	          return getTypeFromThisTypeNode(node).symbol;
	        case 108 /* SuperKeyword */:
	          return checkExpression(node).symbol;
	        case 137 /* ConstructorKeyword */:
	          const constructorDeclaration = node.parent;
	          if (constructorDeclaration && constructorDeclaration.kind === 176 /* Constructor */) {
	            return constructorDeclaration.parent.symbol;
	          }
	          return void 0;
	        case 11 /* StringLiteral */:
	        case 15 /* NoSubstitutionTemplateLiteral */:
	          if (isExternalModuleImportEqualsDeclaration(node.parent.parent) && getExternalModuleImportEqualsDeclarationExpression(node.parent.parent) === node || (node.parent.kind === 272 /* ImportDeclaration */ || node.parent.kind === 278 /* ExportDeclaration */) && node.parent.moduleSpecifier === node || (isInJSFile(node) && isRequireCall(
	            node.parent,
	            /*requireStringLiteralLikeArgument*/
	            false
	          ) || isImportCall(node.parent)) || isLiteralTypeNode(node.parent) && isLiteralImportTypeNode(node.parent.parent) && node.parent.parent.argument === node.parent) {
	            return resolveExternalModuleName(node, node, ignoreErrors);
	          }
	          if (isCallExpression(parent2) && isBindableObjectDefinePropertyCall(parent2) && parent2.arguments[1] === node) {
	            return getSymbolOfDeclaration(parent2);
	          }
	        case 9 /* NumericLiteral */:
	          const objectType = isElementAccessExpression(parent2) ? parent2.argumentExpression === node ? getTypeOfExpression(parent2.expression) : void 0 : isLiteralTypeNode(parent2) && isIndexedAccessTypeNode(grandParent) ? getTypeFromTypeNode(grandParent.objectType) : void 0;
	          return objectType && getPropertyOfType(objectType, escapeLeadingUnderscores(node.text));
	        case 90 /* DefaultKeyword */:
	        case 100 /* FunctionKeyword */:
	        case 39 /* EqualsGreaterThanToken */:
	        case 86 /* ClassKeyword */:
	          return getSymbolOfNode(node.parent);
	        case 205 /* ImportType */:
	          return isLiteralImportTypeNode(node) ? getSymbolAtLocation(node.argument.literal, ignoreErrors) : void 0;
	        case 95 /* ExportKeyword */:
	          return isExportAssignment(node.parent) ? Debug.checkDefined(node.parent.symbol) : void 0;
	        case 102 /* ImportKeyword */:
	        case 105 /* NewKeyword */:
	          return isMetaProperty(node.parent) ? checkMetaPropertyKeyword(node.parent).symbol : void 0;
	        case 104 /* InstanceOfKeyword */:
	          if (isBinaryExpression(node.parent)) {
	            const type = getTypeOfExpression(node.parent.right);
	            const hasInstanceMethodType = getSymbolHasInstanceMethodOfObjectType(type);
	            return (hasInstanceMethodType == null ? void 0 : hasInstanceMethodType.symbol) ?? type.symbol;
	          }
	          return void 0;
	        case 236 /* MetaProperty */:
	          return checkExpression(node).symbol;
	        case 295 /* JsxNamespacedName */:
	          if (isJSXTagName(node) && isJsxIntrinsicTagName(node)) {
	            const symbol = getIntrinsicTagSymbol(node.parent);
	            return symbol === unknownSymbol ? void 0 : symbol;
	          }
	        default:
	          return void 0;
	      }
	    }
	    function getIndexInfosAtLocation(node) {
	      if (isIdentifier(node) && isPropertyAccessExpression(node.parent) && node.parent.name === node) {
	        const keyType = getLiteralTypeFromPropertyName(node);
	        const objectType = getTypeOfExpression(node.parent.expression);
	        const objectTypes = objectType.flags & 1048576 /* Union */ ? objectType.types : [objectType];
	        return flatMap(objectTypes, (t) => filter(getIndexInfosOfType(t), (info) => isApplicableIndexType(keyType, info.keyType)));
	      }
	      return void 0;
	    }
	    function getShorthandAssignmentValueSymbol(location) {
	      if (location && location.kind === 304 /* ShorthandPropertyAssignment */) {
	        return resolveEntityName(location.name, 111551 /* Value */ | 2097152 /* Alias */);
	      }
	      return void 0;
	    }
	    function getExportSpecifierLocalTargetSymbol(node) {
	      if (isExportSpecifier(node)) {
	        return node.parent.parent.moduleSpecifier ? getExternalModuleMember(node.parent.parent, node) : resolveEntityName(node.propertyName || node.name, 111551 /* Value */ | 788968 /* Type */ | 1920 /* Namespace */ | 2097152 /* Alias */);
	      } else {
	        return resolveEntityName(node, 111551 /* Value */ | 788968 /* Type */ | 1920 /* Namespace */ | 2097152 /* Alias */);
	      }
	    }
	    function getTypeOfNode(node) {
	      if (isSourceFile(node) && !isExternalModule(node)) {
	        return errorType;
	      }
	      if (node.flags & 67108864 /* InWithStatement */) {
	        return errorType;
	      }
	      const classDecl = tryGetClassImplementingOrExtendingExpressionWithTypeArguments(node);
	      const classType = classDecl && getDeclaredTypeOfClassOrInterface(getSymbolOfDeclaration(classDecl.class));
	      if (isPartOfTypeNode(node)) {
	        const typeFromTypeNode = getTypeFromTypeNode(node);
	        return classType ? getTypeWithThisArgument(typeFromTypeNode, classType.thisType) : typeFromTypeNode;
	      }
	      if (isExpressionNode(node)) {
	        return getRegularTypeOfExpression(node);
	      }
	      if (classType && !classDecl.isImplements) {
	        const baseType = firstOrUndefined(getBaseTypes(classType));
	        return baseType ? getTypeWithThisArgument(baseType, classType.thisType) : errorType;
	      }
	      if (isTypeDeclaration(node)) {
	        const symbol = getSymbolOfDeclaration(node);
	        return getDeclaredTypeOfSymbol(symbol);
	      }
	      if (isTypeDeclarationName(node)) {
	        const symbol = getSymbolAtLocation(node);
	        return symbol ? getDeclaredTypeOfSymbol(symbol) : errorType;
	      }
	      if (isBindingElement(node)) {
	        return getTypeForVariableLikeDeclaration(
	          node,
	          /*includeOptionality*/
	          true,
	          0 /* Normal */
	        ) || errorType;
	      }
	      if (isDeclaration(node)) {
	        const symbol = getSymbolOfDeclaration(node);
	        return symbol ? getTypeOfSymbol(symbol) : errorType;
	      }
	      if (isDeclarationNameOrImportPropertyName(node)) {
	        const symbol = getSymbolAtLocation(node);
	        if (symbol) {
	          return getTypeOfSymbol(symbol);
	        }
	        return errorType;
	      }
	      if (isBindingPattern(node)) {
	        return getTypeForVariableLikeDeclaration(
	          node.parent,
	          /*includeOptionality*/
	          true,
	          0 /* Normal */
	        ) || errorType;
	      }
	      if (isInRightSideOfImportOrExportAssignment(node)) {
	        const symbol = getSymbolAtLocation(node);
	        if (symbol) {
	          const declaredType = getDeclaredTypeOfSymbol(symbol);
	          return !isErrorType(declaredType) ? declaredType : getTypeOfSymbol(symbol);
	        }
	      }
	      if (isMetaProperty(node.parent) && node.parent.keywordToken === node.kind) {
	        return checkMetaPropertyKeyword(node.parent);
	      }
	      if (isImportAttributes(node)) {
	        return getGlobalImportAttributesType(
	          /*reportErrors*/
	          false
	        );
	      }
	      return errorType;
	    }
	    function getTypeOfAssignmentPattern(expr) {
	      Debug.assert(expr.kind === 210 /* ObjectLiteralExpression */ || expr.kind === 209 /* ArrayLiteralExpression */);
	      if (expr.parent.kind === 250 /* ForOfStatement */) {
	        const iteratedType = checkRightHandSideOfForOf(expr.parent);
	        return checkDestructuringAssignment(expr, iteratedType || errorType);
	      }
	      if (expr.parent.kind === 226 /* BinaryExpression */) {
	        const iteratedType = getTypeOfExpression(expr.parent.right);
	        return checkDestructuringAssignment(expr, iteratedType || errorType);
	      }
	      if (expr.parent.kind === 303 /* PropertyAssignment */) {
	        const node2 = cast(expr.parent.parent, isObjectLiteralExpression);
	        const typeOfParentObjectLiteral = getTypeOfAssignmentPattern(node2) || errorType;
	        const propertyIndex = indexOfNode(node2.properties, expr.parent);
	        return checkObjectLiteralDestructuringPropertyAssignment(node2, typeOfParentObjectLiteral, propertyIndex);
	      }
	      const node = cast(expr.parent, isArrayLiteralExpression);
	      const typeOfArrayLiteral = getTypeOfAssignmentPattern(node) || errorType;
	      const elementType = checkIteratedTypeOrElementType(65 /* Destructuring */, typeOfArrayLiteral, undefinedType, expr.parent) || errorType;
	      return checkArrayLiteralDestructuringElementAssignment(node, typeOfArrayLiteral, node.elements.indexOf(expr), elementType);
	    }
	    function getPropertySymbolOfDestructuringAssignment(location) {
	      const typeOfObjectLiteral = getTypeOfAssignmentPattern(cast(location.parent.parent, isAssignmentPattern));
	      return typeOfObjectLiteral && getPropertyOfType(typeOfObjectLiteral, location.escapedText);
	    }
	    function getRegularTypeOfExpression(expr) {
	      if (isRightSideOfQualifiedNameOrPropertyAccess(expr)) {
	        expr = expr.parent;
	      }
	      return getRegularTypeOfLiteralType(getTypeOfExpression(expr));
	    }
	    function getParentTypeOfClassElement(node) {
	      const classSymbol = getSymbolOfNode(node.parent);
	      return isStatic(node) ? getTypeOfSymbol(classSymbol) : getDeclaredTypeOfSymbol(classSymbol);
	    }
	    function getClassElementPropertyKeyType(element) {
	      const name = element.name;
	      switch (name.kind) {
	        case 80 /* Identifier */:
	          return getStringLiteralType(idText(name));
	        case 9 /* NumericLiteral */:
	        case 11 /* StringLiteral */:
	          return getStringLiteralType(name.text);
	        case 167 /* ComputedPropertyName */:
	          const nameType = checkComputedPropertyName(name);
	          return isTypeAssignableToKind(nameType, 12288 /* ESSymbolLike */) ? nameType : stringType;
	        default:
	          return Debug.fail("Unsupported property name.");
	      }
	    }
	    function getAugmentedPropertiesOfType(type) {
	      type = getApparentType(type);
	      const propsByName = createSymbolTable(getPropertiesOfType(type));
	      const functionType = getSignaturesOfType(type, 0 /* Call */).length ? globalCallableFunctionType : getSignaturesOfType(type, 1 /* Construct */).length ? globalNewableFunctionType : void 0;
	      if (functionType) {
	        forEach(getPropertiesOfType(functionType), (p) => {
	          if (!propsByName.has(p.escapedName)) {
	            propsByName.set(p.escapedName, p);
	          }
	        });
	      }
	      return getNamedMembers(propsByName);
	    }
	    function typeHasCallOrConstructSignatures(type) {
	      return getSignaturesOfType(type, 0 /* Call */).length !== 0 || getSignaturesOfType(type, 1 /* Construct */).length !== 0;
	    }
	    function getRootSymbols(symbol) {
	      const roots = getImmediateRootSymbols(symbol);
	      return roots ? flatMap(roots, getRootSymbols) : [symbol];
	    }
	    function getImmediateRootSymbols(symbol) {
	      if (getCheckFlags(symbol) & 6 /* Synthetic */) {
	        return mapDefined(getSymbolLinks(symbol).containingType.types, (type) => getPropertyOfType(type, symbol.escapedName));
	      } else if (symbol.flags & 33554432 /* Transient */) {
	        const { links: { leftSpread, rightSpread, syntheticOrigin } } = symbol;
	        return leftSpread ? [leftSpread, rightSpread] : syntheticOrigin ? [syntheticOrigin] : singleElementArray(tryGetTarget(symbol));
	      }
	      return void 0;
	    }
	    function tryGetTarget(symbol) {
	      let target;
	      let next = symbol;
	      while (next = getSymbolLinks(next).target) {
	        target = next;
	      }
	      return target;
	    }
	    function isArgumentsLocalBinding(nodeIn) {
	      if (isGeneratedIdentifier(nodeIn))
	        return false;
	      const node = getParseTreeNode(nodeIn, isIdentifier);
	      if (!node)
	        return false;
	      const parent2 = node.parent;
	      if (!parent2)
	        return false;
	      const isPropertyName2 = (isPropertyAccessExpression(parent2) || isPropertyAssignment(parent2)) && parent2.name === node;
	      return !isPropertyName2 && getReferencedValueSymbol(node) === argumentsSymbol;
	    }
	    function moduleExportsSomeValue(moduleReferenceExpression) {
	      let moduleSymbol = resolveExternalModuleName(moduleReferenceExpression.parent, moduleReferenceExpression);
	      if (!moduleSymbol || isShorthandAmbientModuleSymbol(moduleSymbol)) {
	        return true;
	      }
	      const hasExportAssignment = hasExportAssignmentSymbol(moduleSymbol);
	      moduleSymbol = resolveExternalModuleSymbol(moduleSymbol);
	      const symbolLinks2 = getSymbolLinks(moduleSymbol);
	      if (symbolLinks2.exportsSomeValue === void 0) {
	        symbolLinks2.exportsSomeValue = hasExportAssignment ? !!(moduleSymbol.flags & 111551 /* Value */) : forEachEntry(getExportsOfModule(moduleSymbol), isValue);
	      }
	      return symbolLinks2.exportsSomeValue;
	      function isValue(s) {
	        s = resolveSymbol(s);
	        return s && !!(getSymbolFlags(s) & 111551 /* Value */);
	      }
	    }
	    function isNameOfModuleOrEnumDeclaration(node) {
	      return isModuleOrEnumDeclaration(node.parent) && node === node.parent.name;
	    }
	    function getReferencedExportContainer(nodeIn, prefixLocals) {
	      var _a;
	      const node = getParseTreeNode(nodeIn, isIdentifier);
	      if (node) {
	        let symbol = getReferencedValueSymbol(
	          node,
	          /*startInDeclarationContainer*/
	          isNameOfModuleOrEnumDeclaration(node)
	        );
	        if (symbol) {
	          if (symbol.flags & 1048576 /* ExportValue */) {
	            const exportSymbol = getMergedSymbol(symbol.exportSymbol);
	            if (!prefixLocals && exportSymbol.flags & 944 /* ExportHasLocal */ && !(exportSymbol.flags & 3 /* Variable */)) {
	              return void 0;
	            }
	            symbol = exportSymbol;
	          }
	          const parentSymbol = getParentOfSymbol(symbol);
	          if (parentSymbol) {
	            if (parentSymbol.flags & 512 /* ValueModule */ && ((_a = parentSymbol.valueDeclaration) == null ? void 0 : _a.kind) === 312 /* SourceFile */) {
	              const symbolFile = parentSymbol.valueDeclaration;
	              const referenceFile = getSourceFileOfNode(node);
	              const symbolIsUmdExport = symbolFile !== referenceFile;
	              return symbolIsUmdExport ? void 0 : symbolFile;
	            }
	            return findAncestor(node.parent, (n) => isModuleOrEnumDeclaration(n) && getSymbolOfDeclaration(n) === parentSymbol);
	          }
	        }
	      }
	    }
	    function getReferencedImportDeclaration(nodeIn) {
	      const specifier = getIdentifierGeneratedImportReference(nodeIn);
	      if (specifier) {
	        return specifier;
	      }
	      const node = getParseTreeNode(nodeIn, isIdentifier);
	      if (node) {
	        const symbol = getReferencedValueOrAliasSymbol(node);
	        if (isNonLocalAlias(
	          symbol,
	          /*excludes*/
	          111551 /* Value */
	        ) && !getTypeOnlyAliasDeclaration(symbol, 111551 /* Value */)) {
	          return getDeclarationOfAliasSymbol(symbol);
	        }
	      }
	      return void 0;
	    }
	    function isSymbolOfDestructuredElementOfCatchBinding(symbol) {
	      return symbol.valueDeclaration && isBindingElement(symbol.valueDeclaration) && walkUpBindingElementsAndPatterns(symbol.valueDeclaration).parent.kind === 299 /* CatchClause */;
	    }
	    function isSymbolOfDeclarationWithCollidingName(symbol) {
	      if (symbol.flags & 418 /* BlockScoped */ && symbol.valueDeclaration && !isSourceFile(symbol.valueDeclaration)) {
	        const links = getSymbolLinks(symbol);
	        if (links.isDeclarationWithCollidingName === void 0) {
	          const container = getEnclosingBlockScopeContainer(symbol.valueDeclaration);
	          if (isStatementWithLocals(container) || isSymbolOfDestructuredElementOfCatchBinding(symbol)) {
	            const nodeLinks2 = getNodeLinks(symbol.valueDeclaration);
	            if (resolveName(
	              container.parent,
	              symbol.escapedName,
	              111551 /* Value */,
	              /*nameNotFoundMessage*/
	              void 0,
	              /*nameArg*/
	              void 0,
	              /*isUse*/
	              false
	            )) {
	              links.isDeclarationWithCollidingName = true;
	            } else if (nodeLinks2.flags & 16384 /* CapturedBlockScopedBinding */) {
	              const isDeclaredInLoop = nodeLinks2.flags & 32768 /* BlockScopedBindingInLoop */;
	              const inLoopInitializer = isIterationStatement(
	                container,
	                /*lookInLabeledStatements*/
	                false
	              );
	              const inLoopBodyBlock = container.kind === 241 /* Block */ && isIterationStatement(
	                container.parent,
	                /*lookInLabeledStatements*/
	                false
	              );
	              links.isDeclarationWithCollidingName = !isBlockScopedContainerTopLevel(container) && (!isDeclaredInLoop || !inLoopInitializer && !inLoopBodyBlock);
	            } else {
	              links.isDeclarationWithCollidingName = false;
	            }
	          }
	        }
	        return links.isDeclarationWithCollidingName;
	      }
	      return false;
	    }
	    function getReferencedDeclarationWithCollidingName(nodeIn) {
	      if (!isGeneratedIdentifier(nodeIn)) {
	        const node = getParseTreeNode(nodeIn, isIdentifier);
	        if (node) {
	          const symbol = getReferencedValueSymbol(node);
	          if (symbol && isSymbolOfDeclarationWithCollidingName(symbol)) {
	            return symbol.valueDeclaration;
	          }
	        }
	      }
	      return void 0;
	    }
	    function isDeclarationWithCollidingName(nodeIn) {
	      const node = getParseTreeNode(nodeIn, isDeclaration);
	      if (node) {
	        const symbol = getSymbolOfDeclaration(node);
	        if (symbol) {
	          return isSymbolOfDeclarationWithCollidingName(symbol);
	        }
	      }
	      return false;
	    }
	    function isValueAliasDeclaration(node) {
	      Debug.assert(canCollectSymbolAliasAccessabilityData);
	      switch (node.kind) {
	        case 271 /* ImportEqualsDeclaration */:
	          return isAliasResolvedToValue(getSymbolOfDeclaration(node));
	        case 273 /* ImportClause */:
	        case 274 /* NamespaceImport */:
	        case 276 /* ImportSpecifier */:
	        case 281 /* ExportSpecifier */:
	          const symbol = getSymbolOfDeclaration(node);
	          return !!symbol && isAliasResolvedToValue(
	            symbol,
	            /*excludeTypeOnlyValues*/
	            true
	          );
	        case 278 /* ExportDeclaration */:
	          const exportClause = node.exportClause;
	          return !!exportClause && (isNamespaceExport(exportClause) || some(exportClause.elements, isValueAliasDeclaration));
	        case 277 /* ExportAssignment */:
	          return node.expression && node.expression.kind === 80 /* Identifier */ ? isAliasResolvedToValue(
	            getSymbolOfDeclaration(node),
	            /*excludeTypeOnlyValues*/
	            true
	          ) : true;
	      }
	      return false;
	    }
	    function isTopLevelValueImportEqualsWithEntityName(nodeIn) {
	      const node = getParseTreeNode(nodeIn, isImportEqualsDeclaration);
	      if (node === void 0 || node.parent.kind !== 312 /* SourceFile */ || !isInternalModuleImportEqualsDeclaration(node)) {
	        return false;
	      }
	      const isValue = isAliasResolvedToValue(getSymbolOfDeclaration(node));
	      return isValue && node.moduleReference && !nodeIsMissing(node.moduleReference);
	    }
	    function isAliasResolvedToValue(symbol, excludeTypeOnlyValues) {
	      if (!symbol) {
	        return false;
	      }
	      const target = getExportSymbolOfValueSymbolIfExported(resolveAlias(symbol));
	      if (target === unknownSymbol) {
	        return !excludeTypeOnlyValues || !getTypeOnlyAliasDeclaration(symbol);
	      }
	      return !!(getSymbolFlags(
	        symbol,
	        excludeTypeOnlyValues,
	        /*excludeLocalMeanings*/
	        true
	      ) & 111551 /* Value */) && (shouldPreserveConstEnums(compilerOptions) || !isConstEnumOrConstEnumOnlyModule(target));
	    }
	    function isConstEnumOrConstEnumOnlyModule(s) {
	      return isConstEnumSymbol(s) || !!s.constEnumOnlyModule;
	    }
	    function isReferencedAliasDeclaration(node, checkChildren) {
	      Debug.assert(canCollectSymbolAliasAccessabilityData);
	      if (isAliasSymbolDeclaration2(node)) {
	        const symbol = getSymbolOfDeclaration(node);
	        const links = symbol && getSymbolLinks(symbol);
	        if (links == null ? void 0 : links.referenced) {
	          return true;
	        }
	        const target = getSymbolLinks(symbol).aliasTarget;
	        if (target && getEffectiveModifierFlags(node) & 32 /* Export */ && getSymbolFlags(target) & 111551 /* Value */ && (shouldPreserveConstEnums(compilerOptions) || !isConstEnumOrConstEnumOnlyModule(target))) {
	          return true;
	        }
	      }
	      if (checkChildren) {
	        return !!forEachChild(node, (node2) => isReferencedAliasDeclaration(node2, checkChildren));
	      }
	      return false;
	    }
	    function isImplementationOfOverload(node) {
	      if (nodeIsPresent(node.body)) {
	        if (isGetAccessor(node) || isSetAccessor(node))
	          return false;
	        const symbol = getSymbolOfDeclaration(node);
	        const signaturesOfSymbol = getSignaturesOfSymbol(symbol);
	        return signaturesOfSymbol.length > 1 || // If there is single signature for the symbol, it is overload if that signature isn't coming from the node
	        // e.g.: function foo(a: string): string;
	        //       function foo(a: any) { // This is implementation of the overloads
	        //           return a;
	        //       }
	        signaturesOfSymbol.length === 1 && signaturesOfSymbol[0].declaration !== node;
	      }
	      return false;
	    }
	    function isRequiredInitializedParameter(parameter) {
	      return !!strictNullChecks && !isOptionalParameter(parameter) && !isJSDocParameterTag(parameter) && !!parameter.initializer && !hasSyntacticModifier(parameter, 31 /* ParameterPropertyModifier */);
	    }
	    function isOptionalUninitializedParameterProperty(parameter) {
	      return strictNullChecks && isOptionalParameter(parameter) && !parameter.initializer && hasSyntacticModifier(parameter, 31 /* ParameterPropertyModifier */);
	    }
	    function isExpandoFunctionDeclaration(node) {
	      const declaration = getParseTreeNode(node, isFunctionDeclaration);
	      if (!declaration) {
	        return false;
	      }
	      const symbol = getSymbolOfDeclaration(declaration);
	      if (!symbol || !(symbol.flags & 16 /* Function */)) {
	        return false;
	      }
	      return !!forEachEntry(getExportsOfSymbol(symbol), (p) => p.flags & 111551 /* Value */ && isExpandoPropertyDeclaration(p.valueDeclaration));
	    }
	    function getPropertiesOfContainerFunction(node) {
	      const declaration = getParseTreeNode(node, isFunctionDeclaration);
	      if (!declaration) {
	        return emptyArray;
	      }
	      const symbol = getSymbolOfDeclaration(declaration);
	      return symbol && getPropertiesOfType(getTypeOfSymbol(symbol)) || emptyArray;
	    }
	    function getNodeCheckFlags(node) {
	      var _a;
	      const nodeId = node.id || 0;
	      if (nodeId < 0 || nodeId >= nodeLinks.length)
	        return 0;
	      return ((_a = nodeLinks[nodeId]) == null ? void 0 : _a.flags) || 0;
	    }
	    function getEnumMemberValue(node) {
	      computeEnumMemberValues(node.parent);
	      return getNodeLinks(node).enumMemberValue;
	    }
	    function canHaveConstantValue(node) {
	      switch (node.kind) {
	        case 306 /* EnumMember */:
	        case 211 /* PropertyAccessExpression */:
	        case 212 /* ElementAccessExpression */:
	          return true;
	      }
	      return false;
	    }
	    function getConstantValue2(node) {
	      if (node.kind === 306 /* EnumMember */) {
	        return getEnumMemberValue(node);
	      }
	      const symbol = getNodeLinks(node).resolvedSymbol;
	      if (symbol && symbol.flags & 8 /* EnumMember */) {
	        const member = symbol.valueDeclaration;
	        if (isEnumConst(member.parent)) {
	          return getEnumMemberValue(member);
	        }
	      }
	      return void 0;
	    }
	    function isFunctionType(type) {
	      return !!(type.flags & 524288 /* Object */) && getSignaturesOfType(type, 0 /* Call */).length > 0;
	    }
	    function getTypeReferenceSerializationKind(typeNameIn, location) {
	      var _a;
	      const typeName = getParseTreeNode(typeNameIn, isEntityName);
	      if (!typeName)
	        return 0 /* Unknown */;
	      if (location) {
	        location = getParseTreeNode(location);
	        if (!location)
	          return 0 /* Unknown */;
	      }
	      let isTypeOnly = false;
	      if (isQualifiedName(typeName)) {
	        const rootValueSymbol = resolveEntityName(
	          getFirstIdentifier(typeName),
	          111551 /* Value */,
	          /*ignoreErrors*/
	          true,
	          /*dontResolveAlias*/
	          true,
	          location
	        );
	        isTypeOnly = !!((_a = rootValueSymbol == null ? void 0 : rootValueSymbol.declarations) == null ? void 0 : _a.every(isTypeOnlyImportOrExportDeclaration));
	      }
	      const valueSymbol = resolveEntityName(
	        typeName,
	        111551 /* Value */,
	        /*ignoreErrors*/
	        true,
	        /*dontResolveAlias*/
	        true,
	        location
	      );
	      const resolvedValueSymbol = valueSymbol && valueSymbol.flags & 2097152 /* Alias */ ? resolveAlias(valueSymbol) : valueSymbol;
	      isTypeOnly || (isTypeOnly = !!(valueSymbol && getTypeOnlyAliasDeclaration(valueSymbol, 111551 /* Value */)));
	      const typeSymbol = resolveEntityName(
	        typeName,
	        788968 /* Type */,
	        /*ignoreErrors*/
	        true,
	        /*dontResolveAlias*/
	        true,
	        location
	      );
	      const resolvedTypeSymbol = typeSymbol && typeSymbol.flags & 2097152 /* Alias */ ? resolveAlias(typeSymbol) : typeSymbol;
	      if (!valueSymbol) {
	        isTypeOnly || (isTypeOnly = !!(typeSymbol && getTypeOnlyAliasDeclaration(typeSymbol, 788968 /* Type */)));
	      }
	      if (resolvedValueSymbol && resolvedValueSymbol === resolvedTypeSymbol) {
	        const globalPromiseSymbol = getGlobalPromiseConstructorSymbol(
	          /*reportErrors*/
	          false
	        );
	        if (globalPromiseSymbol && resolvedValueSymbol === globalPromiseSymbol) {
	          return 9 /* Promise */;
	        }
	        const constructorType = getTypeOfSymbol(resolvedValueSymbol);
	        if (constructorType && isConstructorType(constructorType)) {
	          return isTypeOnly ? 10 /* TypeWithCallSignature */ : 1 /* TypeWithConstructSignatureAndValue */;
	        }
	      }
	      if (!resolvedTypeSymbol) {
	        return isTypeOnly ? 11 /* ObjectType */ : 0 /* Unknown */;
	      }
	      const type = getDeclaredTypeOfSymbol(resolvedTypeSymbol);
	      if (isErrorType(type)) {
	        return isTypeOnly ? 11 /* ObjectType */ : 0 /* Unknown */;
	      } else if (type.flags & 3 /* AnyOrUnknown */) {
	        return 11 /* ObjectType */;
	      } else if (isTypeAssignableToKind(type, 16384 /* Void */ | 98304 /* Nullable */ | 131072 /* Never */)) {
	        return 2 /* VoidNullableOrNeverType */;
	      } else if (isTypeAssignableToKind(type, 528 /* BooleanLike */)) {
	        return 6 /* BooleanType */;
	      } else if (isTypeAssignableToKind(type, 296 /* NumberLike */)) {
	        return 3 /* NumberLikeType */;
	      } else if (isTypeAssignableToKind(type, 2112 /* BigIntLike */)) {
	        return 4 /* BigIntLikeType */;
	      } else if (isTypeAssignableToKind(type, 402653316 /* StringLike */)) {
	        return 5 /* StringLikeType */;
	      } else if (isTupleType(type)) {
	        return 7 /* ArrayLikeType */;
	      } else if (isTypeAssignableToKind(type, 12288 /* ESSymbolLike */)) {
	        return 8 /* ESSymbolType */;
	      } else if (isFunctionType(type)) {
	        return 10 /* TypeWithCallSignature */;
	      } else if (isArrayType(type)) {
	        return 7 /* ArrayLikeType */;
	      } else {
	        return 11 /* ObjectType */;
	      }
	    }
	    function createTypeOfDeclaration(declarationIn, enclosingDeclaration, flags, tracker, addUndefined) {
	      const declaration = getParseTreeNode(declarationIn, isVariableLikeOrAccessor);
	      if (!declaration) {
	        return factory.createToken(133 /* AnyKeyword */);
	      }
	      const symbol = getSymbolOfDeclaration(declaration);
	      let type = symbol && !(symbol.flags & (2048 /* TypeLiteral */ | 131072 /* Signature */)) ? getWidenedLiteralType(getTypeOfSymbol(symbol)) : errorType;
	      if (type.flags & 8192 /* UniqueESSymbol */ && type.symbol === symbol) {
	        flags |= 1048576 /* AllowUniqueESSymbolType */;
	      }
	      if (addUndefined) {
	        type = getOptionalType(type);
	      }
	      return nodeBuilder.typeToTypeNode(type, enclosingDeclaration, flags | 1024 /* MultilineObjectLiterals */, tracker);
	    }
	    function createReturnTypeOfSignatureDeclaration(signatureDeclarationIn, enclosingDeclaration, flags, tracker) {
	      const signatureDeclaration = getParseTreeNode(signatureDeclarationIn, isFunctionLike);
	      if (!signatureDeclaration) {
	        return factory.createToken(133 /* AnyKeyword */);
	      }
	      const signature = getSignatureFromDeclaration(signatureDeclaration);
	      return nodeBuilder.typeToTypeNode(getReturnTypeOfSignature(signature), enclosingDeclaration, flags | 1024 /* MultilineObjectLiterals */, tracker);
	    }
	    function createTypeOfExpression(exprIn, enclosingDeclaration, flags, tracker) {
	      const expr = getParseTreeNode(exprIn, isExpression);
	      if (!expr) {
	        return factory.createToken(133 /* AnyKeyword */);
	      }
	      const type = getWidenedType(getRegularTypeOfExpression(expr));
	      return nodeBuilder.typeToTypeNode(type, enclosingDeclaration, flags | 1024 /* MultilineObjectLiterals */, tracker);
	    }
	    function hasGlobalName(name) {
	      return globals.has(escapeLeadingUnderscores(name));
	    }
	    function getReferencedValueSymbol(reference, startInDeclarationContainer) {
	      const resolvedSymbol = getNodeLinks(reference).resolvedSymbol;
	      if (resolvedSymbol) {
	        return resolvedSymbol;
	      }
	      let location = reference;
	      if (startInDeclarationContainer) {
	        const parent2 = reference.parent;
	        if (isDeclaration(parent2) && reference === parent2.name) {
	          location = getDeclarationContainer(parent2);
	        }
	      }
	      return resolveName(
	        location,
	        reference.escapedText,
	        111551 /* Value */ | 1048576 /* ExportValue */ | 2097152 /* Alias */,
	        /*nameNotFoundMessage*/
	        void 0,
	        /*nameArg*/
	        void 0,
	        /*isUse*/
	        true
	      );
	    }
	    function getReferencedValueOrAliasSymbol(reference) {
	      const resolvedSymbol = getNodeLinks(reference).resolvedSymbol;
	      if (resolvedSymbol && resolvedSymbol !== unknownSymbol) {
	        return resolvedSymbol;
	      }
	      return resolveName(
	        reference,
	        reference.escapedText,
	        111551 /* Value */ | 1048576 /* ExportValue */ | 2097152 /* Alias */,
	        /*nameNotFoundMessage*/
	        void 0,
	        /*nameArg*/
	        void 0,
	        /*isUse*/
	        true,
	        /*excludeGlobals*/
	        void 0,
	        /*getSpellingSuggestions*/
	        void 0
	      );
	    }
	    function getReferencedValueDeclaration(referenceIn) {
	      if (!isGeneratedIdentifier(referenceIn)) {
	        const reference = getParseTreeNode(referenceIn, isIdentifier);
	        if (reference) {
	          const symbol = getReferencedValueSymbol(reference);
	          if (symbol) {
	            return getExportSymbolOfValueSymbolIfExported(symbol).valueDeclaration;
	          }
	        }
	      }
	      return void 0;
	    }
	    function getReferencedValueDeclarations(referenceIn) {
	      if (!isGeneratedIdentifier(referenceIn)) {
	        const reference = getParseTreeNode(referenceIn, isIdentifier);
	        if (reference) {
	          const symbol = getReferencedValueSymbol(reference);
	          if (symbol) {
	            return filter(getExportSymbolOfValueSymbolIfExported(symbol).declarations, (declaration) => {
	              switch (declaration.kind) {
	                case 260 /* VariableDeclaration */:
	                case 169 /* Parameter */:
	                case 208 /* BindingElement */:
	                case 172 /* PropertyDeclaration */:
	                case 303 /* PropertyAssignment */:
	                case 304 /* ShorthandPropertyAssignment */:
	                case 306 /* EnumMember */:
	                case 210 /* ObjectLiteralExpression */:
	                case 262 /* FunctionDeclaration */:
	                case 218 /* FunctionExpression */:
	                case 219 /* ArrowFunction */:
	                case 263 /* ClassDeclaration */:
	                case 231 /* ClassExpression */:
	                case 266 /* EnumDeclaration */:
	                case 174 /* MethodDeclaration */:
	                case 177 /* GetAccessor */:
	                case 178 /* SetAccessor */:
	                case 267 /* ModuleDeclaration */:
	                  return true;
	              }
	              return false;
	            });
	          }
	        }
	      }
	      return void 0;
	    }
	    function isLiteralConstDeclaration(node) {
	      if (isDeclarationReadonly(node) || isVariableDeclaration(node) && isVarConstLike(node)) {
	        return isFreshLiteralType(getTypeOfSymbol(getSymbolOfDeclaration(node)));
	      }
	      return false;
	    }
	    function literalTypeToNode(type, enclosing, tracker) {
	      const enumResult = type.flags & 1056 /* EnumLike */ ? nodeBuilder.symbolToExpression(
	        type.symbol,
	        111551 /* Value */,
	        enclosing,
	        /*flags*/
	        void 0,
	        tracker
	      ) : type === trueType ? factory.createTrue() : type === falseType && factory.createFalse();
	      if (enumResult)
	        return enumResult;
	      const literalValue = type.value;
	      return typeof literalValue === "object" ? factory.createBigIntLiteral(literalValue) : typeof literalValue === "string" ? factory.createStringLiteral(literalValue) : literalValue < 0 ? factory.createPrefixUnaryExpression(41 /* MinusToken */, factory.createNumericLiteral(-literalValue)) : factory.createNumericLiteral(literalValue);
	    }
	    function createLiteralConstValue(node, tracker) {
	      const type = getTypeOfSymbol(getSymbolOfDeclaration(node));
	      return literalTypeToNode(type, node, tracker);
	    }
	    function getJsxFactoryEntity(location) {
	      return location ? (getJsxNamespace(location), getSourceFileOfNode(location).localJsxFactory || _jsxFactoryEntity) : _jsxFactoryEntity;
	    }
	    function getJsxFragmentFactoryEntity(location) {
	      if (location) {
	        const file = getSourceFileOfNode(location);
	        if (file) {
	          if (file.localJsxFragmentFactory) {
	            return file.localJsxFragmentFactory;
	          }
	          const jsxFragPragmas = file.pragmas.get("jsxfrag");
	          const jsxFragPragma = isArray(jsxFragPragmas) ? jsxFragPragmas[0] : jsxFragPragmas;
	          if (jsxFragPragma) {
	            file.localJsxFragmentFactory = parseIsolatedEntityName(jsxFragPragma.arguments.factory, languageVersion);
	            return file.localJsxFragmentFactory;
	          }
	        }
	      }
	      if (compilerOptions.jsxFragmentFactory) {
	        return parseIsolatedEntityName(compilerOptions.jsxFragmentFactory, languageVersion);
	      }
	    }
	    function createResolver() {
	      const resolvedTypeReferenceDirectives = host.getResolvedTypeReferenceDirectives();
	      let fileToDirective;
	      if (resolvedTypeReferenceDirectives) {
	        fileToDirective = /* @__PURE__ */ new Map();
	        resolvedTypeReferenceDirectives.forEach(({ resolvedTypeReferenceDirective }, key, mode) => {
	          if (!(resolvedTypeReferenceDirective == null ? void 0 : resolvedTypeReferenceDirective.resolvedFileName)) {
	            return;
	          }
	          const file = host.getSourceFile(resolvedTypeReferenceDirective.resolvedFileName);
	          if (file) {
	            addReferencedFilesToTypeDirective(file, key, mode);
	          }
	        });
	      }
	      return {
	        getReferencedExportContainer,
	        getReferencedImportDeclaration,
	        getReferencedDeclarationWithCollidingName,
	        isDeclarationWithCollidingName,
	        isValueAliasDeclaration: (nodeIn) => {
	          const node = getParseTreeNode(nodeIn);
	          return node && canCollectSymbolAliasAccessabilityData ? isValueAliasDeclaration(node) : true;
	        },
	        hasGlobalName,
	        isReferencedAliasDeclaration: (nodeIn, checkChildren) => {
	          const node = getParseTreeNode(nodeIn);
	          return node && canCollectSymbolAliasAccessabilityData ? isReferencedAliasDeclaration(node, checkChildren) : true;
	        },
	        getNodeCheckFlags: (nodeIn) => {
	          const node = getParseTreeNode(nodeIn);
	          return node ? getNodeCheckFlags(node) : 0;
	        },
	        isTopLevelValueImportEqualsWithEntityName,
	        isDeclarationVisible,
	        isImplementationOfOverload,
	        isRequiredInitializedParameter,
	        isOptionalUninitializedParameterProperty,
	        isExpandoFunctionDeclaration,
	        getPropertiesOfContainerFunction,
	        createTypeOfDeclaration,
	        createReturnTypeOfSignatureDeclaration,
	        createTypeOfExpression,
	        createLiteralConstValue,
	        isSymbolAccessible,
	        isEntityNameVisible,
	        getConstantValue: (nodeIn) => {
	          const node = getParseTreeNode(nodeIn, canHaveConstantValue);
	          return node ? getConstantValue2(node) : void 0;
	        },
	        collectLinkedAliases,
	        getReferencedValueDeclaration,
	        getReferencedValueDeclarations,
	        getTypeReferenceSerializationKind,
	        isOptionalParameter,
	        moduleExportsSomeValue,
	        isArgumentsLocalBinding,
	        getExternalModuleFileFromDeclaration: (nodeIn) => {
	          const node = getParseTreeNode(nodeIn, hasPossibleExternalModuleReference);
	          return node && getExternalModuleFileFromDeclaration(node);
	        },
	        getTypeReferenceDirectivesForEntityName,
	        getTypeReferenceDirectivesForSymbol,
	        isLiteralConstDeclaration,
	        isLateBound: (nodeIn) => {
	          const node = getParseTreeNode(nodeIn, isDeclaration);
	          const symbol = node && getSymbolOfDeclaration(node);
	          return !!(symbol && getCheckFlags(symbol) & 4096 /* Late */);
	        },
	        getJsxFactoryEntity,
	        getJsxFragmentFactoryEntity,
	        getAllAccessorDeclarations(accessor) {
	          accessor = getParseTreeNode(accessor, isGetOrSetAccessorDeclaration);
	          const otherKind = accessor.kind === 178 /* SetAccessor */ ? 177 /* GetAccessor */ : 178 /* SetAccessor */;
	          const otherAccessor = getDeclarationOfKind(getSymbolOfDeclaration(accessor), otherKind);
	          const firstAccessor = otherAccessor && otherAccessor.pos < accessor.pos ? otherAccessor : accessor;
	          const secondAccessor = otherAccessor && otherAccessor.pos < accessor.pos ? accessor : otherAccessor;
	          const setAccessor = accessor.kind === 178 /* SetAccessor */ ? accessor : otherAccessor;
	          const getAccessor = accessor.kind === 177 /* GetAccessor */ ? accessor : otherAccessor;
	          return {
	            firstAccessor,
	            secondAccessor,
	            setAccessor,
	            getAccessor
	          };
	        },
	        getSymbolOfExternalModuleSpecifier: (moduleName) => resolveExternalModuleNameWorker(
	          moduleName,
	          moduleName,
	          /*moduleNotFoundError*/
	          void 0
	        ),
	        isBindingCapturedByNode: (node, decl) => {
	          const parseNode = getParseTreeNode(node);
	          const parseDecl = getParseTreeNode(decl);
	          return !!parseNode && !!parseDecl && (isVariableDeclaration(parseDecl) || isBindingElement(parseDecl)) && isBindingCapturedByNode(parseNode, parseDecl);
	        },
	        getDeclarationStatementsForSourceFile: (node, flags, tracker, bundled) => {
	          const n = getParseTreeNode(node);
	          Debug.assert(n && n.kind === 312 /* SourceFile */, "Non-sourcefile node passed into getDeclarationsForSourceFile");
	          const sym = getSymbolOfDeclaration(node);
	          if (!sym) {
	            return !node.locals ? [] : nodeBuilder.symbolTableToDeclarationStatements(node.locals, node, flags, tracker, bundled);
	          }
	          return !sym.exports ? [] : nodeBuilder.symbolTableToDeclarationStatements(sym.exports, node, flags, tracker, bundled);
	        },
	        isImportRequiredByAugmentation,
	        tryFindAmbientModule: (moduleReferenceExpression) => {
	          const node = getParseTreeNode(moduleReferenceExpression);
	          const moduleSpecifier = node && isStringLiteralLike(node) ? node.text : void 0;
	          return moduleSpecifier !== void 0 ? tryFindAmbientModule(
	            moduleSpecifier,
	            /*withAugmentations*/
	            true
	          ) : void 0;
	        }
	      };
	      function isImportRequiredByAugmentation(node) {
	        const file = getSourceFileOfNode(node);
	        if (!file.symbol)
	          return false;
	        const importTarget = getExternalModuleFileFromDeclaration(node);
	        if (!importTarget)
	          return false;
	        if (importTarget === file)
	          return false;
	        const exports = getExportsOfModule(file.symbol);
	        for (const s of arrayFrom(exports.values())) {
	          if (s.mergeId) {
	            const merged = getMergedSymbol(s);
	            if (merged.declarations) {
	              for (const d of merged.declarations) {
	                const declFile = getSourceFileOfNode(d);
	                if (declFile === importTarget) {
	                  return true;
	                }
	              }
	            }
	          }
	        }
	        return false;
	      }
	      function isInHeritageClause(node) {
	        return node.parent && node.parent.kind === 233 /* ExpressionWithTypeArguments */ && node.parent.parent && node.parent.parent.kind === 298 /* HeritageClause */;
	      }
	      function getTypeReferenceDirectivesForEntityName(node) {
	        if (!fileToDirective) {
	          return void 0;
	        }
	        let meaning;
	        if (node.parent.kind === 167 /* ComputedPropertyName */) {
	          meaning = 111551 /* Value */ | 1048576 /* ExportValue */;
	        } else {
	          meaning = 788968 /* Type */ | 1920 /* Namespace */;
	          if (node.kind === 80 /* Identifier */ && isInTypeQuery(node) || node.kind === 211 /* PropertyAccessExpression */ && !isInHeritageClause(node)) {
	            meaning = 111551 /* Value */ | 1048576 /* ExportValue */;
	          }
	        }
	        const symbol = resolveEntityName(
	          node,
	          meaning,
	          /*ignoreErrors*/
	          true
	        );
	        return symbol && symbol !== unknownSymbol ? getTypeReferenceDirectivesForSymbol(symbol, meaning) : void 0;
	      }
	      function getTypeReferenceDirectivesForSymbol(symbol, meaning) {
	        if (!fileToDirective || !isSymbolFromTypeDeclarationFile(symbol)) {
	          return void 0;
	        }
	        let typeReferenceDirectives;
	        for (const decl of symbol.declarations) {
	          if (decl.symbol && decl.symbol.flags & meaning) {
	            const file = getSourceFileOfNode(decl);
	            const typeReferenceDirective = fileToDirective.get(file.path);
	            if (typeReferenceDirective) {
	              (typeReferenceDirectives || (typeReferenceDirectives = [])).push(typeReferenceDirective);
	            } else {
	              return void 0;
	            }
	          }
	        }
	        return typeReferenceDirectives;
	      }
	      function isSymbolFromTypeDeclarationFile(symbol) {
	        if (!symbol.declarations) {
	          return false;
	        }
	        let current = symbol;
	        while (true) {
	          const parent2 = getParentOfSymbol(current);
	          if (parent2) {
	            current = parent2;
	          } else {
	            break;
	          }
	        }
	        if (current.valueDeclaration && current.valueDeclaration.kind === 312 /* SourceFile */ && current.flags & 512 /* ValueModule */) {
	          return false;
	        }
	        for (const decl of symbol.declarations) {
	          const file = getSourceFileOfNode(decl);
	          if (fileToDirective.has(file.path)) {
	            return true;
	          }
	        }
	        return false;
	      }
	      function addReferencedFilesToTypeDirective(file, key, mode) {
	        if (fileToDirective.has(file.path))
	          return;
	        fileToDirective.set(file.path, [key, mode]);
	        for (const { fileName } of file.referencedFiles) {
	          const resolvedFile = resolveTripleslashReference(fileName, file.fileName);
	          const referencedFile = host.getSourceFile(resolvedFile);
	          if (referencedFile) {
	            addReferencedFilesToTypeDirective(referencedFile, key, mode || file.impliedNodeFormat);
	          }
	        }
	      }
	    }
	    function getExternalModuleFileFromDeclaration(declaration) {
	      const specifier = declaration.kind === 267 /* ModuleDeclaration */ ? tryCast(declaration.name, isStringLiteral) : getExternalModuleName(declaration);
	      const moduleSymbol = resolveExternalModuleNameWorker(
	        specifier,
	        specifier,
	        /*moduleNotFoundError*/
	        void 0
	      );
	      if (!moduleSymbol) {
	        return void 0;
	      }
	      return getDeclarationOfKind(moduleSymbol, 312 /* SourceFile */);
	    }
	    function initializeTypeChecker() {
	      for (const file of host.getSourceFiles()) {
	        bindSourceFile(file, compilerOptions);
	      }
	      amalgamatedDuplicates = /* @__PURE__ */ new Map();
	      let augmentations;
	      for (const file of host.getSourceFiles()) {
	        if (file.redirectInfo) {
	          continue;
	        }
	        if (!isExternalOrCommonJsModule(file)) {
	          const fileGlobalThisSymbol = file.locals.get("globalThis");
	          if (fileGlobalThisSymbol == null ? void 0 : fileGlobalThisSymbol.declarations) {
	            for (const declaration of fileGlobalThisSymbol.declarations) {
	              diagnostics.add(createDiagnosticForNode(declaration, Diagnostics.Declaration_name_conflicts_with_built_in_global_identifier_0, "globalThis"));
	            }
	          }
	          mergeSymbolTable(globals, file.locals);
	        }
	        if (file.jsGlobalAugmentations) {
	          mergeSymbolTable(globals, file.jsGlobalAugmentations);
	        }
	        if (file.patternAmbientModules && file.patternAmbientModules.length) {
	          patternAmbientModules = concatenate(patternAmbientModules, file.patternAmbientModules);
	        }
	        if (file.moduleAugmentations.length) {
	          (augmentations || (augmentations = [])).push(file.moduleAugmentations);
	        }
	        if (file.symbol && file.symbol.globalExports) {
	          const source = file.symbol.globalExports;
	          source.forEach((sourceSymbol, id) => {
	            if (!globals.has(id)) {
	              globals.set(id, sourceSymbol);
	            }
	          });
	        }
	      }
	      if (augmentations) {
	        for (const list of augmentations) {
	          for (const augmentation of list) {
	            if (!isGlobalScopeAugmentation(augmentation.parent))
	              continue;
	            mergeModuleAugmentation(augmentation);
	          }
	        }
	      }
	      addToSymbolTable(globals, builtinGlobals, Diagnostics.Declaration_name_conflicts_with_built_in_global_identifier_0);
	      getSymbolLinks(undefinedSymbol).type = undefinedWideningType;
	      getSymbolLinks(argumentsSymbol).type = getGlobalType(
	        "IArguments",
	        /*arity*/
	        0,
	        /*reportErrors*/
	        true
	      );
	      getSymbolLinks(unknownSymbol).type = errorType;
	      getSymbolLinks(globalThisSymbol).type = createObjectType(16 /* Anonymous */, globalThisSymbol);
	      globalArrayType = getGlobalType(
	        "Array",
	        /*arity*/
	        1,
	        /*reportErrors*/
	        true
	      );
	      globalObjectType = getGlobalType(
	        "Object",
	        /*arity*/
	        0,
	        /*reportErrors*/
	        true
	      );
	      globalFunctionType = getGlobalType(
	        "Function",
	        /*arity*/
	        0,
	        /*reportErrors*/
	        true
	      );
	      globalCallableFunctionType = strictBindCallApply && getGlobalType(
	        "CallableFunction",
	        /*arity*/
	        0,
	        /*reportErrors*/
	        true
	      ) || globalFunctionType;
	      globalNewableFunctionType = strictBindCallApply && getGlobalType(
	        "NewableFunction",
	        /*arity*/
	        0,
	        /*reportErrors*/
	        true
	      ) || globalFunctionType;
	      globalStringType = getGlobalType(
	        "String",
	        /*arity*/
	        0,
	        /*reportErrors*/
	        true
	      );
	      globalNumberType = getGlobalType(
	        "Number",
	        /*arity*/
	        0,
	        /*reportErrors*/
	        true
	      );
	      globalBooleanType = getGlobalType(
	        "Boolean",
	        /*arity*/
	        0,
	        /*reportErrors*/
	        true
	      );
	      globalRegExpType = getGlobalType(
	        "RegExp",
	        /*arity*/
	        0,
	        /*reportErrors*/
	        true
	      );
	      anyArrayType = createArrayType(anyType);
	      autoArrayType = createArrayType(autoType);
	      if (autoArrayType === emptyObjectType) {
	        autoArrayType = createAnonymousType(
	          /*symbol*/
	          void 0,
	          emptySymbols,
	          emptyArray,
	          emptyArray,
	          emptyArray
	        );
	      }
	      globalReadonlyArrayType = getGlobalTypeOrUndefined(
	        "ReadonlyArray",
	        /*arity*/
	        1
	      ) || globalArrayType;
	      anyReadonlyArrayType = globalReadonlyArrayType ? createTypeFromGenericGlobalType(globalReadonlyArrayType, [anyType]) : anyArrayType;
	      globalThisType = getGlobalTypeOrUndefined(
	        "ThisType",
	        /*arity*/
	        1
	      );
	      if (augmentations) {
	        for (const list of augmentations) {
	          for (const augmentation of list) {
	            if (isGlobalScopeAugmentation(augmentation.parent))
	              continue;
	            mergeModuleAugmentation(augmentation);
	          }
	        }
	      }
	      amalgamatedDuplicates.forEach(({ firstFile, secondFile, conflictingSymbols }) => {
	        if (conflictingSymbols.size < 8) {
	          conflictingSymbols.forEach(({ isBlockScoped, firstFileLocations, secondFileLocations }, symbolName2) => {
	            const message = isBlockScoped ? Diagnostics.Cannot_redeclare_block_scoped_variable_0 : Diagnostics.Duplicate_identifier_0;
	            for (const node of firstFileLocations) {
	              addDuplicateDeclarationError(node, message, symbolName2, secondFileLocations);
	            }
	            for (const node of secondFileLocations) {
	              addDuplicateDeclarationError(node, message, symbolName2, firstFileLocations);
	            }
	          });
	        } else {
	          const list = arrayFrom(conflictingSymbols.keys()).join(", ");
	          diagnostics.add(addRelatedInfo(
	            createDiagnosticForNode(firstFile, Diagnostics.Definitions_of_the_following_identifiers_conflict_with_those_in_another_file_Colon_0, list),
	            createDiagnosticForNode(secondFile, Diagnostics.Conflicts_are_in_this_file)
	          ));
	          diagnostics.add(addRelatedInfo(
	            createDiagnosticForNode(secondFile, Diagnostics.Definitions_of_the_following_identifiers_conflict_with_those_in_another_file_Colon_0, list),
	            createDiagnosticForNode(firstFile, Diagnostics.Conflicts_are_in_this_file)
	          ));
	        }
	      });
	      amalgamatedDuplicates = void 0;
	    }
	    function checkExternalEmitHelpers(location, helpers) {
	      if ((requestedExternalEmitHelpers & helpers) !== helpers && compilerOptions.importHelpers) {
	        const sourceFile = getSourceFileOfNode(location);
	        if (isEffectiveExternalModule(sourceFile, compilerOptions) && !(location.flags & 33554432 /* Ambient */)) {
	          const helpersModule = resolveHelpersModule(sourceFile, location);
	          if (helpersModule !== unknownSymbol) {
	            const uncheckedHelpers = helpers & ~requestedExternalEmitHelpers;
	            for (let helper = 1 /* FirstEmitHelper */; helper <= 33554432 /* LastEmitHelper */; helper <<= 1) {
	              if (uncheckedHelpers & helper) {
	                for (const name of getHelperNames(helper)) {
	                  if (requestedExternalEmitHelperNames.has(name))
	                    continue;
	                  requestedExternalEmitHelperNames.add(name);
	                  const symbol = resolveSymbol(getSymbol2(getExportsOfModule(helpersModule), escapeLeadingUnderscores(name), 111551 /* Value */));
	                  if (!symbol) {
	                    error2(location, Diagnostics.This_syntax_requires_an_imported_helper_named_1_which_does_not_exist_in_0_Consider_upgrading_your_version_of_0, externalHelpersModuleNameText, name);
	                  } else if (helper & 524288 /* ClassPrivateFieldGet */) {
	                    if (!some(getSignaturesOfSymbol(symbol), (signature) => getParameterCount(signature) > 3)) {
	                      error2(location, Diagnostics.This_syntax_requires_an_imported_helper_named_1_with_2_parameters_which_is_not_compatible_with_the_one_in_0_Consider_upgrading_your_version_of_0, externalHelpersModuleNameText, name, 4);
	                    }
	                  } else if (helper & 1048576 /* ClassPrivateFieldSet */) {
	                    if (!some(getSignaturesOfSymbol(symbol), (signature) => getParameterCount(signature) > 4)) {
	                      error2(location, Diagnostics.This_syntax_requires_an_imported_helper_named_1_with_2_parameters_which_is_not_compatible_with_the_one_in_0_Consider_upgrading_your_version_of_0, externalHelpersModuleNameText, name, 5);
	                    }
	                  } else if (helper & 1024 /* SpreadArray */) {
	                    if (!some(getSignaturesOfSymbol(symbol), (signature) => getParameterCount(signature) > 2)) {
	                      error2(location, Diagnostics.This_syntax_requires_an_imported_helper_named_1_with_2_parameters_which_is_not_compatible_with_the_one_in_0_Consider_upgrading_your_version_of_0, externalHelpersModuleNameText, name, 3);
	                    }
	                  }
	                }
	              }
	            }
	          }
	          requestedExternalEmitHelpers |= helpers;
	        }
	      }
	    }
	    function getHelperNames(helper) {
	      switch (helper) {
	        case 1 /* Extends */:
	          return ["__extends"];
	        case 2 /* Assign */:
	          return ["__assign"];
	        case 4 /* Rest */:
	          return ["__rest"];
	        case 8 /* Decorate */:
	          return legacyDecorators ? ["__decorate"] : ["__esDecorate", "__runInitializers"];
	        case 16 /* Metadata */:
	          return ["__metadata"];
	        case 32 /* Param */:
	          return ["__param"];
	        case 64 /* Awaiter */:
	          return ["__awaiter"];
	        case 128 /* Generator */:
	          return ["__generator"];
	        case 256 /* Values */:
	          return ["__values"];
	        case 512 /* Read */:
	          return ["__read"];
	        case 1024 /* SpreadArray */:
	          return ["__spreadArray"];
	        case 2048 /* Await */:
	          return ["__await"];
	        case 4096 /* AsyncGenerator */:
	          return ["__asyncGenerator"];
	        case 8192 /* AsyncDelegator */:
	          return ["__asyncDelegator"];
	        case 16384 /* AsyncValues */:
	          return ["__asyncValues"];
	        case 32768 /* ExportStar */:
	          return ["__exportStar"];
	        case 65536 /* ImportStar */:
	          return ["__importStar"];
	        case 131072 /* ImportDefault */:
	          return ["__importDefault"];
	        case 262144 /* MakeTemplateObject */:
	          return ["__makeTemplateObject"];
	        case 524288 /* ClassPrivateFieldGet */:
	          return ["__classPrivateFieldGet"];
	        case 1048576 /* ClassPrivateFieldSet */:
	          return ["__classPrivateFieldSet"];
	        case 2097152 /* ClassPrivateFieldIn */:
	          return ["__classPrivateFieldIn"];
	        case 4194304 /* CreateBinding */:
	          return ["__createBinding"];
	        case 8388608 /* SetFunctionName */:
	          return ["__setFunctionName"];
	        case 16777216 /* PropKey */:
	          return ["__propKey"];
	        case 33554432 /* AddDisposableResourceAndDisposeResources */:
	          return ["__addDisposableResource", "__disposeResources"];
	        default:
	          return Debug.fail("Unrecognized helper");
	      }
	    }
	    function resolveHelpersModule(node, errorNode) {
	      if (!externalHelpersModule) {
	        externalHelpersModule = resolveExternalModule(node, externalHelpersModuleNameText, Diagnostics.This_syntax_requires_an_imported_helper_but_module_0_cannot_be_found, errorNode) || unknownSymbol;
	      }
	      return externalHelpersModule;
	    }
	    function checkGrammarModifiers(node) {
	      var _a;
	      const quickResult = reportObviousDecoratorErrors(node) || reportObviousModifierErrors(node);
	      if (quickResult !== void 0) {
	        return quickResult;
	      }
	      if (isParameter(node) && parameterIsThisKeyword(node)) {
	        return grammarErrorOnFirstToken(node, Diagnostics.Neither_decorators_nor_modifiers_may_be_applied_to_this_parameters);
	      }
	      const blockScopeKind = isVariableStatement(node) ? node.declarationList.flags & 7 /* BlockScoped */ : 0 /* None */;
	      let lastStatic, lastDeclare, lastAsync, lastOverride, firstDecorator;
	      let flags = 0 /* None */;
	      let sawExportBeforeDecorators = false;
	      let hasLeadingDecorators = false;
	      for (const modifier of node.modifiers) {
	        if (isDecorator(modifier)) {
	          if (!nodeCanBeDecorated(legacyDecorators, node, node.parent, node.parent.parent)) {
	            if (node.kind === 174 /* MethodDeclaration */ && !nodeIsPresent(node.body)) {
	              return grammarErrorOnFirstToken(node, Diagnostics.A_decorator_can_only_decorate_a_method_implementation_not_an_overload);
	            } else {
	              return grammarErrorOnFirstToken(node, Diagnostics.Decorators_are_not_valid_here);
	            }
	          } else if (legacyDecorators && (node.kind === 177 /* GetAccessor */ || node.kind === 178 /* SetAccessor */)) {
	            const accessors = getAllAccessorDeclarations(node.parent.members, node);
	            if (hasDecorators(accessors.firstAccessor) && node === accessors.secondAccessor) {
	              return grammarErrorOnFirstToken(node, Diagnostics.Decorators_cannot_be_applied_to_multiple_get_Slashset_accessors_of_the_same_name);
	            }
	          }
	          if (flags & ~(2080 /* ExportDefault */ | 32768 /* Decorator */)) {
	            return grammarErrorOnNode(modifier, Diagnostics.Decorators_are_not_valid_here);
	          }
	          if (hasLeadingDecorators && flags & 98303 /* Modifier */) {
	            Debug.assertIsDefined(firstDecorator);
	            const sourceFile = getSourceFileOfNode(modifier);
	            if (!hasParseDiagnostics(sourceFile)) {
	              addRelatedInfo(
	                error2(modifier, Diagnostics.Decorators_may_not_appear_after_export_or_export_default_if_they_also_appear_before_export),
	                createDiagnosticForNode(firstDecorator, Diagnostics.Decorator_used_before_export_here)
	              );
	              return true;
	            }
	            return false;
	          }
	          flags |= 32768 /* Decorator */;
	          if (!(flags & 98303 /* Modifier */)) {
	            hasLeadingDecorators = true;
	          } else if (flags & 32 /* Export */) {
	            sawExportBeforeDecorators = true;
	          }
	          firstDecorator ?? (firstDecorator = modifier);
	        } else {
	          if (modifier.kind !== 148 /* ReadonlyKeyword */) {
	            if (node.kind === 171 /* PropertySignature */ || node.kind === 173 /* MethodSignature */) {
	              return grammarErrorOnNode(modifier, Diagnostics._0_modifier_cannot_appear_on_a_type_member, tokenToString(modifier.kind));
	            }
	            if (node.kind === 181 /* IndexSignature */ && (modifier.kind !== 126 /* StaticKeyword */ || !isClassLike(node.parent))) {
	              return grammarErrorOnNode(modifier, Diagnostics._0_modifier_cannot_appear_on_an_index_signature, tokenToString(modifier.kind));
	            }
	          }
	          if (modifier.kind !== 103 /* InKeyword */ && modifier.kind !== 147 /* OutKeyword */ && modifier.kind !== 87 /* ConstKeyword */) {
	            if (node.kind === 168 /* TypeParameter */) {
	              return grammarErrorOnNode(modifier, Diagnostics._0_modifier_cannot_appear_on_a_type_parameter, tokenToString(modifier.kind));
	            }
	          }
	          switch (modifier.kind) {
	            case 87 /* ConstKeyword */: {
	              if (node.kind !== 266 /* EnumDeclaration */ && node.kind !== 168 /* TypeParameter */) {
	                return grammarErrorOnNode(node, Diagnostics.A_class_member_cannot_have_the_0_keyword, tokenToString(87 /* ConstKeyword */));
	              }
	              const parent2 = isJSDocTemplateTag(node.parent) && getEffectiveJSDocHost(node.parent) || node.parent;
	              if (node.kind === 168 /* TypeParameter */ && !(isFunctionLikeDeclaration(parent2) || isClassLike(parent2) || isFunctionTypeNode(parent2) || isConstructorTypeNode(parent2) || isCallSignatureDeclaration(parent2) || isConstructSignatureDeclaration(parent2) || isMethodSignature(parent2))) {
	                return grammarErrorOnNode(modifier, Diagnostics._0_modifier_can_only_appear_on_a_type_parameter_of_a_function_method_or_class, tokenToString(modifier.kind));
	              }
	              break;
	            }
	            case 164 /* OverrideKeyword */:
	              if (flags & 16 /* Override */) {
	                return grammarErrorOnNode(modifier, Diagnostics._0_modifier_already_seen, "override");
	              } else if (flags & 128 /* Ambient */) {
	                return grammarErrorOnNode(modifier, Diagnostics._0_modifier_cannot_be_used_with_1_modifier, "override", "declare");
	              } else if (flags & 8 /* Readonly */) {
	                return grammarErrorOnNode(modifier, Diagnostics._0_modifier_must_precede_1_modifier, "override", "readonly");
	              } else if (flags & 512 /* Accessor */) {
	                return grammarErrorOnNode(modifier, Diagnostics._0_modifier_must_precede_1_modifier, "override", "accessor");
	              } else if (flags & 1024 /* Async */) {
	                return grammarErrorOnNode(modifier, Diagnostics._0_modifier_must_precede_1_modifier, "override", "async");
	              }
	              flags |= 16 /* Override */;
	              lastOverride = modifier;
	              break;
	            case 125 /* PublicKeyword */:
	            case 124 /* ProtectedKeyword */:
	            case 123 /* PrivateKeyword */:
	              const text = visibilityToString(modifierToFlag(modifier.kind));
	              if (flags & 7 /* AccessibilityModifier */) {
	                return grammarErrorOnNode(modifier, Diagnostics.Accessibility_modifier_already_seen);
	              } else if (flags & 16 /* Override */) {
	                return grammarErrorOnNode(modifier, Diagnostics._0_modifier_must_precede_1_modifier, text, "override");
	              } else if (flags & 256 /* Static */) {
	                return grammarErrorOnNode(modifier, Diagnostics._0_modifier_must_precede_1_modifier, text, "static");
	              } else if (flags & 512 /* Accessor */) {
	                return grammarErrorOnNode(modifier, Diagnostics._0_modifier_must_precede_1_modifier, text, "accessor");
	              } else if (flags & 8 /* Readonly */) {
	                return grammarErrorOnNode(modifier, Diagnostics._0_modifier_must_precede_1_modifier, text, "readonly");
	              } else if (flags & 1024 /* Async */) {
	                return grammarErrorOnNode(modifier, Diagnostics._0_modifier_must_precede_1_modifier, text, "async");
	              } else if (node.parent.kind === 268 /* ModuleBlock */ || node.parent.kind === 312 /* SourceFile */) {
	                return grammarErrorOnNode(modifier, Diagnostics._0_modifier_cannot_appear_on_a_module_or_namespace_element, text);
	              } else if (flags & 64 /* Abstract */) {
	                if (modifier.kind === 123 /* PrivateKeyword */) {
	                  return grammarErrorOnNode(modifier, Diagnostics._0_modifier_cannot_be_used_with_1_modifier, text, "abstract");
	                } else {
	                  return grammarErrorOnNode(modifier, Diagnostics._0_modifier_must_precede_1_modifier, text, "abstract");
	                }
	              } else if (isPrivateIdentifierClassElementDeclaration(node)) {
	                return grammarErrorOnNode(modifier, Diagnostics.An_accessibility_modifier_cannot_be_used_with_a_private_identifier);
	              }
	              flags |= modifierToFlag(modifier.kind);
	              break;
	            case 126 /* StaticKeyword */:
	              if (flags & 256 /* Static */) {
	                return grammarErrorOnNode(modifier, Diagnostics._0_modifier_already_seen, "static");
	              } else if (flags & 8 /* Readonly */) {
	                return grammarErrorOnNode(modifier, Diagnostics._0_modifier_must_precede_1_modifier, "static", "readonly");
	              } else if (flags & 1024 /* Async */) {
	                return grammarErrorOnNode(modifier, Diagnostics._0_modifier_must_precede_1_modifier, "static", "async");
	              } else if (flags & 512 /* Accessor */) {
	                return grammarErrorOnNode(modifier, Diagnostics._0_modifier_must_precede_1_modifier, "static", "accessor");
	              } else if (node.parent.kind === 268 /* ModuleBlock */ || node.parent.kind === 312 /* SourceFile */) {
	                return grammarErrorOnNode(modifier, Diagnostics._0_modifier_cannot_appear_on_a_module_or_namespace_element, "static");
	              } else if (node.kind === 169 /* Parameter */) {
	                return grammarErrorOnNode(modifier, Diagnostics._0_modifier_cannot_appear_on_a_parameter, "static");
	              } else if (flags & 64 /* Abstract */) {
	                return grammarErrorOnNode(modifier, Diagnostics._0_modifier_cannot_be_used_with_1_modifier, "static", "abstract");
	              } else if (flags & 16 /* Override */) {
	                return grammarErrorOnNode(modifier, Diagnostics._0_modifier_must_precede_1_modifier, "static", "override");
	              }
	              flags |= 256 /* Static */;
	              lastStatic = modifier;
	              break;
	            case 129 /* AccessorKeyword */:
	              if (flags & 512 /* Accessor */) {
	                return grammarErrorOnNode(modifier, Diagnostics._0_modifier_already_seen, "accessor");
	              } else if (flags & 8 /* Readonly */) {
	                return grammarErrorOnNode(modifier, Diagnostics._0_modifier_cannot_be_used_with_1_modifier, "accessor", "readonly");
	              } else if (flags & 128 /* Ambient */) {
	                return grammarErrorOnNode(modifier, Diagnostics._0_modifier_cannot_be_used_with_1_modifier, "accessor", "declare");
	              } else if (node.kind !== 172 /* PropertyDeclaration */) {
	                return grammarErrorOnNode(modifier, Diagnostics.accessor_modifier_can_only_appear_on_a_property_declaration);
	              }
	              flags |= 512 /* Accessor */;
	              break;
	            case 148 /* ReadonlyKeyword */:
	              if (flags & 8 /* Readonly */) {
	                return grammarErrorOnNode(modifier, Diagnostics._0_modifier_already_seen, "readonly");
	              } else if (node.kind !== 172 /* PropertyDeclaration */ && node.kind !== 171 /* PropertySignature */ && node.kind !== 181 /* IndexSignature */ && node.kind !== 169 /* Parameter */) {
	                return grammarErrorOnNode(modifier, Diagnostics.readonly_modifier_can_only_appear_on_a_property_declaration_or_index_signature);
	              } else if (flags & 512 /* Accessor */) {
	                return grammarErrorOnNode(modifier, Diagnostics._0_modifier_cannot_be_used_with_1_modifier, "readonly", "accessor");
	              }
	              flags |= 8 /* Readonly */;
	              break;
	            case 95 /* ExportKeyword */:
	              if (compilerOptions.verbatimModuleSyntax && !(node.flags & 33554432 /* Ambient */) && node.kind !== 265 /* TypeAliasDeclaration */ && node.kind !== 264 /* InterfaceDeclaration */ && // ModuleDeclaration needs to be checked that it is uninstantiated later
	              node.kind !== 267 /* ModuleDeclaration */ && node.parent.kind === 312 /* SourceFile */ && (moduleKind === 1 /* CommonJS */ || getSourceFileOfNode(node).impliedNodeFormat === 1 /* CommonJS */)) {
	                return grammarErrorOnNode(modifier, Diagnostics.A_top_level_export_modifier_cannot_be_used_on_value_declarations_in_a_CommonJS_module_when_verbatimModuleSyntax_is_enabled);
	              }
	              if (flags & 32 /* Export */) {
	                return grammarErrorOnNode(modifier, Diagnostics._0_modifier_already_seen, "export");
	              } else if (flags & 128 /* Ambient */) {
	                return grammarErrorOnNode(modifier, Diagnostics._0_modifier_must_precede_1_modifier, "export", "declare");
	              } else if (flags & 64 /* Abstract */) {
	                return grammarErrorOnNode(modifier, Diagnostics._0_modifier_must_precede_1_modifier, "export", "abstract");
	              } else if (flags & 1024 /* Async */) {
	                return grammarErrorOnNode(modifier, Diagnostics._0_modifier_must_precede_1_modifier, "export", "async");
	              } else if (isClassLike(node.parent)) {
	                return grammarErrorOnNode(modifier, Diagnostics._0_modifier_cannot_appear_on_class_elements_of_this_kind, "export");
	              } else if (node.kind === 169 /* Parameter */) {
	                return grammarErrorOnNode(modifier, Diagnostics._0_modifier_cannot_appear_on_a_parameter, "export");
	              } else if (blockScopeKind === 4 /* Using */) {
	                return grammarErrorOnNode(modifier, Diagnostics._0_modifier_cannot_appear_on_a_using_declaration, "export");
	              } else if (blockScopeKind === 6 /* AwaitUsing */) {
	                return grammarErrorOnNode(modifier, Diagnostics._0_modifier_cannot_appear_on_an_await_using_declaration, "export");
	              }
	              flags |= 32 /* Export */;
	              break;
	            case 90 /* DefaultKeyword */:
	              const container = node.parent.kind === 312 /* SourceFile */ ? node.parent : node.parent.parent;
	              if (container.kind === 267 /* ModuleDeclaration */ && !isAmbientModule(container)) {
	                return grammarErrorOnNode(modifier, Diagnostics.A_default_export_can_only_be_used_in_an_ECMAScript_style_module);
	              } else if (blockScopeKind === 4 /* Using */) {
	                return grammarErrorOnNode(modifier, Diagnostics._0_modifier_cannot_appear_on_a_using_declaration, "default");
	              } else if (blockScopeKind === 6 /* AwaitUsing */) {
	                return grammarErrorOnNode(modifier, Diagnostics._0_modifier_cannot_appear_on_an_await_using_declaration, "default");
	              } else if (!(flags & 32 /* Export */)) {
	                return grammarErrorOnNode(modifier, Diagnostics._0_modifier_must_precede_1_modifier, "export", "default");
	              } else if (sawExportBeforeDecorators) {
	                return grammarErrorOnNode(firstDecorator, Diagnostics.Decorators_are_not_valid_here);
	              }
	              flags |= 2048 /* Default */;
	              break;
	            case 138 /* DeclareKeyword */:
	              if (flags & 128 /* Ambient */) {
	                return grammarErrorOnNode(modifier, Diagnostics._0_modifier_already_seen, "declare");
	              } else if (flags & 1024 /* Async */) {
	                return grammarErrorOnNode(modifier, Diagnostics._0_modifier_cannot_be_used_in_an_ambient_context, "async");
	              } else if (flags & 16 /* Override */) {
	                return grammarErrorOnNode(modifier, Diagnostics._0_modifier_cannot_be_used_in_an_ambient_context, "override");
	              } else if (isClassLike(node.parent) && !isPropertyDeclaration(node)) {
	                return grammarErrorOnNode(modifier, Diagnostics._0_modifier_cannot_appear_on_class_elements_of_this_kind, "declare");
	              } else if (node.kind === 169 /* Parameter */) {
	                return grammarErrorOnNode(modifier, Diagnostics._0_modifier_cannot_appear_on_a_parameter, "declare");
	              } else if (blockScopeKind === 4 /* Using */) {
	                return grammarErrorOnNode(modifier, Diagnostics._0_modifier_cannot_appear_on_a_using_declaration, "declare");
	              } else if (blockScopeKind === 6 /* AwaitUsing */) {
	                return grammarErrorOnNode(modifier, Diagnostics._0_modifier_cannot_appear_on_an_await_using_declaration, "declare");
	              } else if (node.parent.flags & 33554432 /* Ambient */ && node.parent.kind === 268 /* ModuleBlock */) {
	                return grammarErrorOnNode(modifier, Diagnostics.A_declare_modifier_cannot_be_used_in_an_already_ambient_context);
	              } else if (isPrivateIdentifierClassElementDeclaration(node)) {
	                return grammarErrorOnNode(modifier, Diagnostics._0_modifier_cannot_be_used_with_a_private_identifier, "declare");
	              } else if (flags & 512 /* Accessor */) {
	                return grammarErrorOnNode(modifier, Diagnostics._0_modifier_cannot_be_used_with_1_modifier, "declare", "accessor");
	              }
	              flags |= 128 /* Ambient */;
	              lastDeclare = modifier;
	              break;
	            case 128 /* AbstractKeyword */:
	              if (flags & 64 /* Abstract */) {
	                return grammarErrorOnNode(modifier, Diagnostics._0_modifier_already_seen, "abstract");
	              }
	              if (node.kind !== 263 /* ClassDeclaration */ && node.kind !== 185 /* ConstructorType */) {
	                if (node.kind !== 174 /* MethodDeclaration */ && node.kind !== 172 /* PropertyDeclaration */ && node.kind !== 177 /* GetAccessor */ && node.kind !== 178 /* SetAccessor */) {
	                  return grammarErrorOnNode(modifier, Diagnostics.abstract_modifier_can_only_appear_on_a_class_method_or_property_declaration);
	                }
	                if (!(node.parent.kind === 263 /* ClassDeclaration */ && hasSyntacticModifier(node.parent, 64 /* Abstract */))) {
	                  const message = node.kind === 172 /* PropertyDeclaration */ ? Diagnostics.Abstract_properties_can_only_appear_within_an_abstract_class : Diagnostics.Abstract_methods_can_only_appear_within_an_abstract_class;
	                  return grammarErrorOnNode(modifier, message);
	                }
	                if (flags & 256 /* Static */) {
	                  return grammarErrorOnNode(modifier, Diagnostics._0_modifier_cannot_be_used_with_1_modifier, "static", "abstract");
	                }
	                if (flags & 2 /* Private */) {
	                  return grammarErrorOnNode(modifier, Diagnostics._0_modifier_cannot_be_used_with_1_modifier, "private", "abstract");
	                }
	                if (flags & 1024 /* Async */ && lastAsync) {
	                  return grammarErrorOnNode(lastAsync, Diagnostics._0_modifier_cannot_be_used_with_1_modifier, "async", "abstract");
	                }
	                if (flags & 16 /* Override */) {
	                  return grammarErrorOnNode(modifier, Diagnostics._0_modifier_must_precede_1_modifier, "abstract", "override");
	                }
	                if (flags & 512 /* Accessor */) {
	                  return grammarErrorOnNode(modifier, Diagnostics._0_modifier_must_precede_1_modifier, "abstract", "accessor");
	                }
	              }
	              if (isNamedDeclaration(node) && node.name.kind === 81 /* PrivateIdentifier */) {
	                return grammarErrorOnNode(modifier, Diagnostics._0_modifier_cannot_be_used_with_a_private_identifier, "abstract");
	              }
	              flags |= 64 /* Abstract */;
	              break;
	            case 134 /* AsyncKeyword */:
	              if (flags & 1024 /* Async */) {
	                return grammarErrorOnNode(modifier, Diagnostics._0_modifier_already_seen, "async");
	              } else if (flags & 128 /* Ambient */ || node.parent.flags & 33554432 /* Ambient */) {
	                return grammarErrorOnNode(modifier, Diagnostics._0_modifier_cannot_be_used_in_an_ambient_context, "async");
	              } else if (node.kind === 169 /* Parameter */) {
	                return grammarErrorOnNode(modifier, Diagnostics._0_modifier_cannot_appear_on_a_parameter, "async");
	              }
	              if (flags & 64 /* Abstract */) {
	                return grammarErrorOnNode(modifier, Diagnostics._0_modifier_cannot_be_used_with_1_modifier, "async", "abstract");
	              }
	              flags |= 1024 /* Async */;
	              lastAsync = modifier;
	              break;
	            case 103 /* InKeyword */:
	            case 147 /* OutKeyword */: {
	              const inOutFlag = modifier.kind === 103 /* InKeyword */ ? 8192 /* In */ : 16384 /* Out */;
	              const inOutText = modifier.kind === 103 /* InKeyword */ ? "in" : "out";
	              const parent2 = isJSDocTemplateTag(node.parent) && (getEffectiveJSDocHost(node.parent) || find((_a = getJSDocRoot(node.parent)) == null ? void 0 : _a.tags, isJSDocTypedefTag)) || node.parent;
	              if (node.kind !== 168 /* TypeParameter */ || parent2 && !(isInterfaceDeclaration(parent2) || isClassLike(parent2) || isTypeAliasDeclaration(parent2) || isJSDocTypedefTag(parent2))) {
	                return grammarErrorOnNode(modifier, Diagnostics._0_modifier_can_only_appear_on_a_type_parameter_of_a_class_interface_or_type_alias, inOutText);
	              }
	              if (flags & inOutFlag) {
	                return grammarErrorOnNode(modifier, Diagnostics._0_modifier_already_seen, inOutText);
	              }
	              if (inOutFlag & 8192 /* In */ && flags & 16384 /* Out */) {
	                return grammarErrorOnNode(modifier, Diagnostics._0_modifier_must_precede_1_modifier, "in", "out");
	              }
	              flags |= inOutFlag;
	              break;
	            }
	          }
	        }
	      }
	      if (node.kind === 176 /* Constructor */) {
	        if (flags & 256 /* Static */) {
	          return grammarErrorOnNode(lastStatic, Diagnostics._0_modifier_cannot_appear_on_a_constructor_declaration, "static");
	        }
	        if (flags & 16 /* Override */) {
	          return grammarErrorOnNode(lastOverride, Diagnostics._0_modifier_cannot_appear_on_a_constructor_declaration, "override");
	        }
	        if (flags & 1024 /* Async */) {
	          return grammarErrorOnNode(lastAsync, Diagnostics._0_modifier_cannot_appear_on_a_constructor_declaration, "async");
	        }
	        return false;
	      } else if ((node.kind === 272 /* ImportDeclaration */ || node.kind === 271 /* ImportEqualsDeclaration */) && flags & 128 /* Ambient */) {
	        return grammarErrorOnNode(lastDeclare, Diagnostics.A_0_modifier_cannot_be_used_with_an_import_declaration, "declare");
	      } else if (node.kind === 169 /* Parameter */ && flags & 31 /* ParameterPropertyModifier */ && isBindingPattern(node.name)) {
	        return grammarErrorOnNode(node, Diagnostics.A_parameter_property_may_not_be_declared_using_a_binding_pattern);
	      } else if (node.kind === 169 /* Parameter */ && flags & 31 /* ParameterPropertyModifier */ && node.dotDotDotToken) {
	        return grammarErrorOnNode(node, Diagnostics.A_parameter_property_cannot_be_declared_using_a_rest_parameter);
	      }
	      if (flags & 1024 /* Async */) {
	        return checkGrammarAsyncModifier(node, lastAsync);
	      }
	      return false;
	    }
	    function reportObviousModifierErrors(node) {
	      if (!node.modifiers)
	        return false;
	      const modifier = findFirstIllegalModifier(node);
	      return modifier && grammarErrorOnFirstToken(modifier, Diagnostics.Modifiers_cannot_appear_here);
	    }
	    function findFirstModifierExcept(node, allowedModifier) {
	      const modifier = find(node.modifiers, isModifier);
	      return modifier && modifier.kind !== allowedModifier ? modifier : void 0;
	    }
	    function findFirstIllegalModifier(node) {
	      switch (node.kind) {
	        case 177 /* GetAccessor */:
	        case 178 /* SetAccessor */:
	        case 176 /* Constructor */:
	        case 172 /* PropertyDeclaration */:
	        case 171 /* PropertySignature */:
	        case 174 /* MethodDeclaration */:
	        case 173 /* MethodSignature */:
	        case 181 /* IndexSignature */:
	        case 267 /* ModuleDeclaration */:
	        case 272 /* ImportDeclaration */:
	        case 271 /* ImportEqualsDeclaration */:
	        case 278 /* ExportDeclaration */:
	        case 277 /* ExportAssignment */:
	        case 218 /* FunctionExpression */:
	        case 219 /* ArrowFunction */:
	        case 169 /* Parameter */:
	        case 168 /* TypeParameter */:
	          return void 0;
	        case 175 /* ClassStaticBlockDeclaration */:
	        case 303 /* PropertyAssignment */:
	        case 304 /* ShorthandPropertyAssignment */:
	        case 270 /* NamespaceExportDeclaration */:
	        case 282 /* MissingDeclaration */:
	          return find(node.modifiers, isModifier);
	        default:
	          if (node.parent.kind === 268 /* ModuleBlock */ || node.parent.kind === 312 /* SourceFile */) {
	            return void 0;
	          }
	          switch (node.kind) {
	            case 262 /* FunctionDeclaration */:
	              return findFirstModifierExcept(node, 134 /* AsyncKeyword */);
	            case 263 /* ClassDeclaration */:
	            case 185 /* ConstructorType */:
	              return findFirstModifierExcept(node, 128 /* AbstractKeyword */);
	            case 231 /* ClassExpression */:
	            case 264 /* InterfaceDeclaration */:
	            case 265 /* TypeAliasDeclaration */:
	              return find(node.modifiers, isModifier);
	            case 243 /* VariableStatement */:
	              return node.declarationList.flags & 4 /* Using */ ? findFirstModifierExcept(node, 135 /* AwaitKeyword */) : find(node.modifiers, isModifier);
	            case 266 /* EnumDeclaration */:
	              return findFirstModifierExcept(node, 87 /* ConstKeyword */);
	            default:
	              Debug.assertNever(node);
	          }
	      }
	    }
	    function reportObviousDecoratorErrors(node) {
	      const decorator = findFirstIllegalDecorator(node);
	      return decorator && grammarErrorOnFirstToken(decorator, Diagnostics.Decorators_are_not_valid_here);
	    }
	    function findFirstIllegalDecorator(node) {
	      return canHaveIllegalDecorators(node) ? find(node.modifiers, isDecorator) : void 0;
	    }
	    function checkGrammarAsyncModifier(node, asyncModifier) {
	      switch (node.kind) {
	        case 174 /* MethodDeclaration */:
	        case 262 /* FunctionDeclaration */:
	        case 218 /* FunctionExpression */:
	        case 219 /* ArrowFunction */:
	          return false;
	      }
	      return grammarErrorOnNode(asyncModifier, Diagnostics._0_modifier_cannot_be_used_here, "async");
	    }
	    function checkGrammarForDisallowedTrailingComma(list, diag2 = Diagnostics.Trailing_comma_not_allowed) {
	      if (list && list.hasTrailingComma) {
	        return grammarErrorAtPos(list[0], list.end - ",".length, ",".length, diag2);
	      }
	      return false;
	    }
	    function checkGrammarTypeParameterList(typeParameters, file) {
	      if (typeParameters && typeParameters.length === 0) {
	        const start = typeParameters.pos - "<".length;
	        const end = skipTrivia(file.text, typeParameters.end) + ">".length;
	        return grammarErrorAtPos(file, start, end - start, Diagnostics.Type_parameter_list_cannot_be_empty);
	      }
	      return false;
	    }
	    function checkGrammarParameterList(parameters) {
	      let seenOptionalParameter = false;
	      const parameterCount = parameters.length;
	      for (let i = 0; i < parameterCount; i++) {
	        const parameter = parameters[i];
	        if (parameter.dotDotDotToken) {
	          if (i !== parameterCount - 1) {
	            return grammarErrorOnNode(parameter.dotDotDotToken, Diagnostics.A_rest_parameter_must_be_last_in_a_parameter_list);
	          }
	          if (!(parameter.flags & 33554432 /* Ambient */)) {
	            checkGrammarForDisallowedTrailingComma(parameters, Diagnostics.A_rest_parameter_or_binding_pattern_may_not_have_a_trailing_comma);
	          }
	          if (parameter.questionToken) {
	            return grammarErrorOnNode(parameter.questionToken, Diagnostics.A_rest_parameter_cannot_be_optional);
	          }
	          if (parameter.initializer) {
	            return grammarErrorOnNode(parameter.name, Diagnostics.A_rest_parameter_cannot_have_an_initializer);
	          }
	        } else if (isOptionalParameter(parameter)) {
	          seenOptionalParameter = true;
	          if (parameter.questionToken && parameter.initializer) {
	            return grammarErrorOnNode(parameter.name, Diagnostics.Parameter_cannot_have_question_mark_and_initializer);
	          }
	        } else if (seenOptionalParameter && !parameter.initializer) {
	          return grammarErrorOnNode(parameter.name, Diagnostics.A_required_parameter_cannot_follow_an_optional_parameter);
	        }
	      }
	    }
	    function getNonSimpleParameters(parameters) {
	      return filter(parameters, (parameter) => !!parameter.initializer || isBindingPattern(parameter.name) || isRestParameter(parameter));
	    }
	    function checkGrammarForUseStrictSimpleParameterList(node) {
	      if (languageVersion >= 3 /* ES2016 */) {
	        const useStrictDirective = node.body && isBlock(node.body) && findUseStrictPrologue(node.body.statements);
	        if (useStrictDirective) {
	          const nonSimpleParameters = getNonSimpleParameters(node.parameters);
	          if (length(nonSimpleParameters)) {
	            forEach(nonSimpleParameters, (parameter) => {
	              addRelatedInfo(
	                error2(parameter, Diagnostics.This_parameter_is_not_allowed_with_use_strict_directive),
	                createDiagnosticForNode(useStrictDirective, Diagnostics.use_strict_directive_used_here)
	              );
	            });
	            const diagnostics2 = nonSimpleParameters.map((parameter, index) => index === 0 ? createDiagnosticForNode(parameter, Diagnostics.Non_simple_parameter_declared_here) : createDiagnosticForNode(parameter, Diagnostics.and_here));
	            addRelatedInfo(error2(useStrictDirective, Diagnostics.use_strict_directive_cannot_be_used_with_non_simple_parameter_list), ...diagnostics2);
	            return true;
	          }
	        }
	      }
	      return false;
	    }
	    function checkGrammarFunctionLikeDeclaration(node) {
	      const file = getSourceFileOfNode(node);
	      return checkGrammarModifiers(node) || checkGrammarTypeParameterList(node.typeParameters, file) || checkGrammarParameterList(node.parameters) || checkGrammarArrowFunction(node, file) || isFunctionLikeDeclaration(node) && checkGrammarForUseStrictSimpleParameterList(node);
	    }
	    function checkGrammarClassLikeDeclaration(node) {
	      const file = getSourceFileOfNode(node);
	      return checkGrammarClassDeclarationHeritageClauses(node) || checkGrammarTypeParameterList(node.typeParameters, file);
	    }
	    function checkGrammarArrowFunction(node, file) {
	      if (!isArrowFunction(node)) {
	        return false;
	      }
	      if (node.typeParameters && !(length(node.typeParameters) > 1 || node.typeParameters.hasTrailingComma || node.typeParameters[0].constraint)) {
	        if (file && fileExtensionIsOneOf(file.fileName, [".mts" /* Mts */, ".cts" /* Cts */])) {
	          grammarErrorOnNode(node.typeParameters[0], Diagnostics.This_syntax_is_reserved_in_files_with_the_mts_or_cts_extension_Add_a_trailing_comma_or_explicit_constraint);
	        }
	      }
	      const { equalsGreaterThanToken } = node;
	      const startLine = getLineAndCharacterOfPosition(file, equalsGreaterThanToken.pos).line;
	      const endLine = getLineAndCharacterOfPosition(file, equalsGreaterThanToken.end).line;
	      return startLine !== endLine && grammarErrorOnNode(equalsGreaterThanToken, Diagnostics.Line_terminator_not_permitted_before_arrow);
	    }
	    function checkGrammarIndexSignatureParameters(node) {
	      const parameter = node.parameters[0];
	      if (node.parameters.length !== 1) {
	        if (parameter) {
	          return grammarErrorOnNode(parameter.name, Diagnostics.An_index_signature_must_have_exactly_one_parameter);
	        } else {
	          return grammarErrorOnNode(node, Diagnostics.An_index_signature_must_have_exactly_one_parameter);
	        }
	      }
	      checkGrammarForDisallowedTrailingComma(node.parameters, Diagnostics.An_index_signature_cannot_have_a_trailing_comma);
	      if (parameter.dotDotDotToken) {
	        return grammarErrorOnNode(parameter.dotDotDotToken, Diagnostics.An_index_signature_cannot_have_a_rest_parameter);
	      }
	      if (hasEffectiveModifiers(parameter)) {
	        return grammarErrorOnNode(parameter.name, Diagnostics.An_index_signature_parameter_cannot_have_an_accessibility_modifier);
	      }
	      if (parameter.questionToken) {
	        return grammarErrorOnNode(parameter.questionToken, Diagnostics.An_index_signature_parameter_cannot_have_a_question_mark);
	      }
	      if (parameter.initializer) {
	        return grammarErrorOnNode(parameter.name, Diagnostics.An_index_signature_parameter_cannot_have_an_initializer);
	      }
	      if (!parameter.type) {
	        return grammarErrorOnNode(parameter.name, Diagnostics.An_index_signature_parameter_must_have_a_type_annotation);
	      }
	      const type = getTypeFromTypeNode(parameter.type);
	      if (someType(type, (t) => !!(t.flags & 8576 /* StringOrNumberLiteralOrUnique */)) || isGenericType(type)) {
	        return grammarErrorOnNode(parameter.name, Diagnostics.An_index_signature_parameter_type_cannot_be_a_literal_type_or_generic_type_Consider_using_a_mapped_object_type_instead);
	      }
	      if (!everyType(type, isValidIndexKeyType)) {
	        return grammarErrorOnNode(parameter.name, Diagnostics.An_index_signature_parameter_type_must_be_string_number_symbol_or_a_template_literal_type);
	      }
	      if (!node.type) {
	        return grammarErrorOnNode(node, Diagnostics.An_index_signature_must_have_a_type_annotation);
	      }
	      return false;
	    }
	    function checkGrammarIndexSignature(node) {
	      return checkGrammarModifiers(node) || checkGrammarIndexSignatureParameters(node);
	    }
	    function checkGrammarForAtLeastOneTypeArgument(node, typeArguments) {
	      if (typeArguments && typeArguments.length === 0) {
	        const sourceFile = getSourceFileOfNode(node);
	        const start = typeArguments.pos - "<".length;
	        const end = skipTrivia(sourceFile.text, typeArguments.end) + ">".length;
	        return grammarErrorAtPos(sourceFile, start, end - start, Diagnostics.Type_argument_list_cannot_be_empty);
	      }
	      return false;
	    }
	    function checkGrammarTypeArguments(node, typeArguments) {
	      return checkGrammarForDisallowedTrailingComma(typeArguments) || checkGrammarForAtLeastOneTypeArgument(node, typeArguments);
	    }
	    function checkGrammarTaggedTemplateChain(node) {
	      if (node.questionDotToken || node.flags & 64 /* OptionalChain */) {
	        return grammarErrorOnNode(node.template, Diagnostics.Tagged_template_expressions_are_not_permitted_in_an_optional_chain);
	      }
	      return false;
	    }
	    function checkGrammarHeritageClause(node) {
	      const types = node.types;
	      if (checkGrammarForDisallowedTrailingComma(types)) {
	        return true;
	      }
	      if (types && types.length === 0) {
	        const listType = tokenToString(node.token);
	        return grammarErrorAtPos(node, types.pos, 0, Diagnostics._0_list_cannot_be_empty, listType);
	      }
	      return some(types, checkGrammarExpressionWithTypeArguments);
	    }
	    function checkGrammarExpressionWithTypeArguments(node) {
	      if (isExpressionWithTypeArguments(node) && isImportKeyword(node.expression) && node.typeArguments) {
	        return grammarErrorOnNode(node, Diagnostics.This_use_of_import_is_invalid_import_calls_can_be_written_but_they_must_have_parentheses_and_cannot_have_type_arguments);
	      }
	      return checkGrammarTypeArguments(node, node.typeArguments);
	    }
	    function checkGrammarClassDeclarationHeritageClauses(node) {
	      let seenExtendsClause = false;
	      let seenImplementsClause = false;
	      if (!checkGrammarModifiers(node) && node.heritageClauses) {
	        for (const heritageClause of node.heritageClauses) {
	          if (heritageClause.token === 96 /* ExtendsKeyword */) {
	            if (seenExtendsClause) {
	              return grammarErrorOnFirstToken(heritageClause, Diagnostics.extends_clause_already_seen);
	            }
	            if (seenImplementsClause) {
	              return grammarErrorOnFirstToken(heritageClause, Diagnostics.extends_clause_must_precede_implements_clause);
	            }
	            if (heritageClause.types.length > 1) {
	              return grammarErrorOnFirstToken(heritageClause.types[1], Diagnostics.Classes_can_only_extend_a_single_class);
	            }
	            seenExtendsClause = true;
	          } else {
	            Debug.assert(heritageClause.token === 119 /* ImplementsKeyword */);
	            if (seenImplementsClause) {
	              return grammarErrorOnFirstToken(heritageClause, Diagnostics.implements_clause_already_seen);
	            }
	            seenImplementsClause = true;
	          }
	          checkGrammarHeritageClause(heritageClause);
	        }
	      }
	    }
	    function checkGrammarInterfaceDeclaration(node) {
	      let seenExtendsClause = false;
	      if (node.heritageClauses) {
	        for (const heritageClause of node.heritageClauses) {
	          if (heritageClause.token === 96 /* ExtendsKeyword */) {
	            if (seenExtendsClause) {
	              return grammarErrorOnFirstToken(heritageClause, Diagnostics.extends_clause_already_seen);
	            }
	            seenExtendsClause = true;
	          } else {
	            Debug.assert(heritageClause.token === 119 /* ImplementsKeyword */);
	            return grammarErrorOnFirstToken(heritageClause, Diagnostics.Interface_declaration_cannot_have_implements_clause);
	          }
	          checkGrammarHeritageClause(heritageClause);
	        }
	      }
	      return false;
	    }
	    function checkGrammarComputedPropertyName(node) {
	      if (node.kind !== 167 /* ComputedPropertyName */) {
	        return false;
	      }
	      const computedPropertyName = node;
	      if (computedPropertyName.expression.kind === 226 /* BinaryExpression */ && computedPropertyName.expression.operatorToken.kind === 28 /* CommaToken */) {
	        return grammarErrorOnNode(computedPropertyName.expression, Diagnostics.A_comma_expression_is_not_allowed_in_a_computed_property_name);
	      }
	      return false;
	    }
	    function checkGrammarForGenerator(node) {
	      if (node.asteriskToken) {
	        Debug.assert(
	          node.kind === 262 /* FunctionDeclaration */ || node.kind === 218 /* FunctionExpression */ || node.kind === 174 /* MethodDeclaration */
	        );
	        if (node.flags & 33554432 /* Ambient */) {
	          return grammarErrorOnNode(node.asteriskToken, Diagnostics.Generators_are_not_allowed_in_an_ambient_context);
	        }
	        if (!node.body) {
	          return grammarErrorOnNode(node.asteriskToken, Diagnostics.An_overload_signature_cannot_be_declared_as_a_generator);
	        }
	      }
	    }
	    function checkGrammarForInvalidQuestionMark(questionToken, message) {
	      return !!questionToken && grammarErrorOnNode(questionToken, message);
	    }
	    function checkGrammarForInvalidExclamationToken(exclamationToken, message) {
	      return !!exclamationToken && grammarErrorOnNode(exclamationToken, message);
	    }
	    function checkGrammarObjectLiteralExpression(node, inDestructuring) {
	      const seen = /* @__PURE__ */ new Map();
	      for (const prop of node.properties) {
	        if (prop.kind === 305 /* SpreadAssignment */) {
	          if (inDestructuring) {
	            const expression = skipParentheses(prop.expression);
	            if (isArrayLiteralExpression(expression) || isObjectLiteralExpression(expression)) {
	              return grammarErrorOnNode(prop.expression, Diagnostics.A_rest_element_cannot_contain_a_binding_pattern);
	            }
	          }
	          continue;
	        }
	        const name = prop.name;
	        if (name.kind === 167 /* ComputedPropertyName */) {
	          checkGrammarComputedPropertyName(name);
	        }
	        if (prop.kind === 304 /* ShorthandPropertyAssignment */ && !inDestructuring && prop.objectAssignmentInitializer) {
	          grammarErrorOnNode(prop.equalsToken, Diagnostics.Did_you_mean_to_use_a_Colon_An_can_only_follow_a_property_name_when_the_containing_object_literal_is_part_of_a_destructuring_pattern);
	        }
	        if (name.kind === 81 /* PrivateIdentifier */) {
	          grammarErrorOnNode(name, Diagnostics.Private_identifiers_are_not_allowed_outside_class_bodies);
	        }
	        if (canHaveModifiers(prop) && prop.modifiers) {
	          for (const mod of prop.modifiers) {
	            if (isModifier(mod) && (mod.kind !== 134 /* AsyncKeyword */ || prop.kind !== 174 /* MethodDeclaration */)) {
	              grammarErrorOnNode(mod, Diagnostics._0_modifier_cannot_be_used_here, getTextOfNode(mod));
	            }
	          }
	        } else if (canHaveIllegalModifiers(prop) && prop.modifiers) {
	          for (const mod of prop.modifiers) {
	            if (isModifier(mod)) {
	              grammarErrorOnNode(mod, Diagnostics._0_modifier_cannot_be_used_here, getTextOfNode(mod));
	            }
	          }
	        }
	        let currentKind;
	        switch (prop.kind) {
	          case 304 /* ShorthandPropertyAssignment */:
	          case 303 /* PropertyAssignment */:
	            checkGrammarForInvalidExclamationToken(prop.exclamationToken, Diagnostics.A_definite_assignment_assertion_is_not_permitted_in_this_context);
	            checkGrammarForInvalidQuestionMark(prop.questionToken, Diagnostics.An_object_member_cannot_be_declared_optional);
	            if (name.kind === 9 /* NumericLiteral */) {
	              checkGrammarNumericLiteral(name);
	            }
	            currentKind = 4 /* PropertyAssignment */;
	            break;
	          case 174 /* MethodDeclaration */:
	            currentKind = 8 /* Method */;
	            break;
	          case 177 /* GetAccessor */:
	            currentKind = 1 /* GetAccessor */;
	            break;
	          case 178 /* SetAccessor */:
	            currentKind = 2 /* SetAccessor */;
	            break;
	          default:
	            Debug.assertNever(prop, "Unexpected syntax kind:" + prop.kind);
	        }
	        if (!inDestructuring) {
	          const effectiveName = getEffectivePropertyNameForPropertyNameNode(name);
	          if (effectiveName === void 0) {
	            continue;
	          }
	          const existingKind = seen.get(effectiveName);
	          if (!existingKind) {
	            seen.set(effectiveName, currentKind);
	          } else {
	            if (currentKind & 8 /* Method */ && existingKind & 8 /* Method */) {
	              grammarErrorOnNode(name, Diagnostics.Duplicate_identifier_0, getTextOfNode(name));
	            } else if (currentKind & 4 /* PropertyAssignment */ && existingKind & 4 /* PropertyAssignment */) {
	              grammarErrorOnNode(name, Diagnostics.An_object_literal_cannot_have_multiple_properties_with_the_same_name, getTextOfNode(name));
	            } else if (currentKind & 3 /* GetOrSetAccessor */ && existingKind & 3 /* GetOrSetAccessor */) {
	              if (existingKind !== 3 /* GetOrSetAccessor */ && currentKind !== existingKind) {
	                seen.set(effectiveName, currentKind | existingKind);
	              } else {
	                return grammarErrorOnNode(name, Diagnostics.An_object_literal_cannot_have_multiple_get_Slashset_accessors_with_the_same_name);
	              }
	            } else {
	              return grammarErrorOnNode(name, Diagnostics.An_object_literal_cannot_have_property_and_accessor_with_the_same_name);
	            }
	          }
	        }
	      }
	    }
	    function checkGrammarJsxElement(node) {
	      checkGrammarJsxName(node.tagName);
	      checkGrammarTypeArguments(node, node.typeArguments);
	      const seen = /* @__PURE__ */ new Map();
	      for (const attr of node.attributes.properties) {
	        if (attr.kind === 293 /* JsxSpreadAttribute */) {
	          continue;
	        }
	        const { name, initializer } = attr;
	        const escapedText = getEscapedTextOfJsxAttributeName(name);
	        if (!seen.get(escapedText)) {
	          seen.set(escapedText, true);
	        } else {
	          return grammarErrorOnNode(name, Diagnostics.JSX_elements_cannot_have_multiple_attributes_with_the_same_name);
	        }
	        if (initializer && initializer.kind === 294 /* JsxExpression */ && !initializer.expression) {
	          return grammarErrorOnNode(initializer, Diagnostics.JSX_attributes_must_only_be_assigned_a_non_empty_expression);
	        }
	      }
	    }
	    function checkGrammarJsxName(node) {
	      if (isPropertyAccessExpression(node) && isJsxNamespacedName(node.expression)) {
	        return grammarErrorOnNode(node.expression, Diagnostics.JSX_property_access_expressions_cannot_include_JSX_namespace_names);
	      }
	      if (isJsxNamespacedName(node) && getJSXTransformEnabled(compilerOptions) && !isIntrinsicJsxName(node.namespace.escapedText)) {
	        return grammarErrorOnNode(node, Diagnostics.React_components_cannot_include_JSX_namespace_names);
	      }
	    }
	    function checkGrammarJsxExpression(node) {
	      if (node.expression && isCommaSequence(node.expression)) {
	        return grammarErrorOnNode(node.expression, Diagnostics.JSX_expressions_may_not_use_the_comma_operator_Did_you_mean_to_write_an_array);
	      }
	    }
	    function checkGrammarForInOrForOfStatement(forInOrOfStatement) {
	      if (checkGrammarStatementInAmbientContext(forInOrOfStatement)) {
	        return true;
	      }
	      if (forInOrOfStatement.kind === 250 /* ForOfStatement */ && forInOrOfStatement.awaitModifier) {
	        if (!(forInOrOfStatement.flags & 65536 /* AwaitContext */)) {
	          const sourceFile = getSourceFileOfNode(forInOrOfStatement);
	          if (isInTopLevelContext(forInOrOfStatement)) {
	            if (!hasParseDiagnostics(sourceFile)) {
	              if (!isEffectiveExternalModule(sourceFile, compilerOptions)) {
	                diagnostics.add(createDiagnosticForNode(forInOrOfStatement.awaitModifier, Diagnostics.for_await_loops_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_file_has_no_imports_or_exports_Consider_adding_an_empty_export_to_make_this_file_a_module));
	              }
	              switch (moduleKind) {
	                case 100 /* Node16 */:
	                case 199 /* NodeNext */:
	                  if (sourceFile.impliedNodeFormat === 1 /* CommonJS */) {
	                    diagnostics.add(
	                      createDiagnosticForNode(forInOrOfStatement.awaitModifier, Diagnostics.The_current_file_is_a_CommonJS_module_and_cannot_use_await_at_the_top_level)
	                    );
	                    break;
	                  }
	                case 7 /* ES2022 */:
	                case 99 /* ESNext */:
	                case 4 /* System */:
	                  if (languageVersion >= 4 /* ES2017 */) {
	                    break;
	                  }
	                default:
	                  diagnostics.add(
	                    createDiagnosticForNode(forInOrOfStatement.awaitModifier, Diagnostics.Top_level_for_await_loops_are_only_allowed_when_the_module_option_is_set_to_es2022_esnext_system_node16_nodenext_or_preserve_and_the_target_option_is_set_to_es2017_or_higher)
	                  );
	                  break;
	              }
	            }
	          } else {
	            if (!hasParseDiagnostics(sourceFile)) {
	              const diagnostic = createDiagnosticForNode(forInOrOfStatement.awaitModifier, Diagnostics.for_await_loops_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules);
	              const func = getContainingFunction(forInOrOfStatement);
	              if (func && func.kind !== 176 /* Constructor */) {
	                Debug.assert((getFunctionFlags(func) & 2 /* Async */) === 0, "Enclosing function should never be an async function.");
	                const relatedInfo = createDiagnosticForNode(func, Diagnostics.Did_you_mean_to_mark_this_function_as_async);
	                addRelatedInfo(diagnostic, relatedInfo);
	              }
	              diagnostics.add(diagnostic);
	              return true;
	            }
	          }
	          return false;
	        }
	      }
	      if (isForOfStatement(forInOrOfStatement) && !(forInOrOfStatement.flags & 65536 /* AwaitContext */) && isIdentifier(forInOrOfStatement.initializer) && forInOrOfStatement.initializer.escapedText === "async") {
	        grammarErrorOnNode(forInOrOfStatement.initializer, Diagnostics.The_left_hand_side_of_a_for_of_statement_may_not_be_async);
	        return false;
	      }
	      if (forInOrOfStatement.initializer.kind === 261 /* VariableDeclarationList */) {
	        const variableList = forInOrOfStatement.initializer;
	        if (!checkGrammarVariableDeclarationList(variableList)) {
	          const declarations = variableList.declarations;
	          if (!declarations.length) {
	            return false;
	          }
	          if (declarations.length > 1) {
	            const diagnostic = forInOrOfStatement.kind === 249 /* ForInStatement */ ? Diagnostics.Only_a_single_variable_declaration_is_allowed_in_a_for_in_statement : Diagnostics.Only_a_single_variable_declaration_is_allowed_in_a_for_of_statement;
	            return grammarErrorOnFirstToken(variableList.declarations[1], diagnostic);
	          }
	          const firstDeclaration = declarations[0];
	          if (firstDeclaration.initializer) {
	            const diagnostic = forInOrOfStatement.kind === 249 /* ForInStatement */ ? Diagnostics.The_variable_declaration_of_a_for_in_statement_cannot_have_an_initializer : Diagnostics.The_variable_declaration_of_a_for_of_statement_cannot_have_an_initializer;
	            return grammarErrorOnNode(firstDeclaration.name, diagnostic);
	          }
	          if (firstDeclaration.type) {
	            const diagnostic = forInOrOfStatement.kind === 249 /* ForInStatement */ ? Diagnostics.The_left_hand_side_of_a_for_in_statement_cannot_use_a_type_annotation : Diagnostics.The_left_hand_side_of_a_for_of_statement_cannot_use_a_type_annotation;
	            return grammarErrorOnNode(firstDeclaration, diagnostic);
	          }
	        }
	      }
	      return false;
	    }
	    function checkGrammarAccessor(accessor) {
	      if (!(accessor.flags & 33554432 /* Ambient */) && accessor.parent.kind !== 187 /* TypeLiteral */ && accessor.parent.kind !== 264 /* InterfaceDeclaration */) {
	        if (languageVersion < 1 /* ES5 */) {
	          return grammarErrorOnNode(accessor.name, Diagnostics.Accessors_are_only_available_when_targeting_ECMAScript_5_and_higher);
	        }
	        if (languageVersion < 2 /* ES2015 */ && isPrivateIdentifier(accessor.name)) {
	          return grammarErrorOnNode(accessor.name, Diagnostics.Private_identifiers_are_only_available_when_targeting_ECMAScript_2015_and_higher);
	        }
	        if (accessor.body === void 0 && !hasSyntacticModifier(accessor, 64 /* Abstract */)) {
	          return grammarErrorAtPos(accessor, accessor.end - 1, ";".length, Diagnostics._0_expected, "{");
	        }
	      }
	      if (accessor.body) {
	        if (hasSyntacticModifier(accessor, 64 /* Abstract */)) {
	          return grammarErrorOnNode(accessor, Diagnostics.An_abstract_accessor_cannot_have_an_implementation);
	        }
	        if (accessor.parent.kind === 187 /* TypeLiteral */ || accessor.parent.kind === 264 /* InterfaceDeclaration */) {
	          return grammarErrorOnNode(accessor.body, Diagnostics.An_implementation_cannot_be_declared_in_ambient_contexts);
	        }
	      }
	      if (accessor.typeParameters) {
	        return grammarErrorOnNode(accessor.name, Diagnostics.An_accessor_cannot_have_type_parameters);
	      }
	      if (!doesAccessorHaveCorrectParameterCount(accessor)) {
	        return grammarErrorOnNode(
	          accessor.name,
	          accessor.kind === 177 /* GetAccessor */ ? Diagnostics.A_get_accessor_cannot_have_parameters : Diagnostics.A_set_accessor_must_have_exactly_one_parameter
	        );
	      }
	      if (accessor.kind === 178 /* SetAccessor */) {
	        if (accessor.type) {
	          return grammarErrorOnNode(accessor.name, Diagnostics.A_set_accessor_cannot_have_a_return_type_annotation);
	        }
	        const parameter = Debug.checkDefined(getSetAccessorValueParameter(accessor), "Return value does not match parameter count assertion.");
	        if (parameter.dotDotDotToken) {
	          return grammarErrorOnNode(parameter.dotDotDotToken, Diagnostics.A_set_accessor_cannot_have_rest_parameter);
	        }
	        if (parameter.questionToken) {
	          return grammarErrorOnNode(parameter.questionToken, Diagnostics.A_set_accessor_cannot_have_an_optional_parameter);
	        }
	        if (parameter.initializer) {
	          return grammarErrorOnNode(accessor.name, Diagnostics.A_set_accessor_parameter_cannot_have_an_initializer);
	        }
	      }
	      return false;
	    }
	    function doesAccessorHaveCorrectParameterCount(accessor) {
	      return getAccessorThisParameter(accessor) || accessor.parameters.length === (accessor.kind === 177 /* GetAccessor */ ? 0 : 1);
	    }
	    function getAccessorThisParameter(accessor) {
	      if (accessor.parameters.length === (accessor.kind === 177 /* GetAccessor */ ? 1 : 2)) {
	        return getThisParameter(accessor);
	      }
	    }
	    function checkGrammarTypeOperatorNode(node) {
	      if (node.operator === 158 /* UniqueKeyword */) {
	        if (node.type.kind !== 155 /* SymbolKeyword */) {
	          return grammarErrorOnNode(node.type, Diagnostics._0_expected, tokenToString(155 /* SymbolKeyword */));
	        }
	        let parent2 = walkUpParenthesizedTypes(node.parent);
	        if (isInJSFile(parent2) && isJSDocTypeExpression(parent2)) {
	          const host2 = getJSDocHost(parent2);
	          if (host2) {
	            parent2 = getSingleVariableOfVariableStatement(host2) || host2;
	          }
	        }
	        switch (parent2.kind) {
	          case 260 /* VariableDeclaration */:
	            const decl = parent2;
	            if (decl.name.kind !== 80 /* Identifier */) {
	              return grammarErrorOnNode(node, Diagnostics.unique_symbol_types_may_not_be_used_on_a_variable_declaration_with_a_binding_name);
	            }
	            if (!isVariableDeclarationInVariableStatement(decl)) {
	              return grammarErrorOnNode(node, Diagnostics.unique_symbol_types_are_only_allowed_on_variables_in_a_variable_statement);
	            }
	            if (!(decl.parent.flags & 2 /* Const */)) {
	              return grammarErrorOnNode(parent2.name, Diagnostics.A_variable_whose_type_is_a_unique_symbol_type_must_be_const);
	            }
	            break;
	          case 172 /* PropertyDeclaration */:
	            if (!isStatic(parent2) || !hasEffectiveReadonlyModifier(parent2)) {
	              return grammarErrorOnNode(parent2.name, Diagnostics.A_property_of_a_class_whose_type_is_a_unique_symbol_type_must_be_both_static_and_readonly);
	            }
	            break;
	          case 171 /* PropertySignature */:
	            if (!hasSyntacticModifier(parent2, 8 /* Readonly */)) {
	              return grammarErrorOnNode(parent2.name, Diagnostics.A_property_of_an_interface_or_type_literal_whose_type_is_a_unique_symbol_type_must_be_readonly);
	            }
	            break;
	          default:
	            return grammarErrorOnNode(node, Diagnostics.unique_symbol_types_are_not_allowed_here);
	        }
	      } else if (node.operator === 148 /* ReadonlyKeyword */) {
	        if (node.type.kind !== 188 /* ArrayType */ && node.type.kind !== 189 /* TupleType */) {
	          return grammarErrorOnFirstToken(node, Diagnostics.readonly_type_modifier_is_only_permitted_on_array_and_tuple_literal_types, tokenToString(155 /* SymbolKeyword */));
	        }
	      }
	    }
	    function checkGrammarForInvalidDynamicName(node, message) {
	      if (isNonBindableDynamicName(node)) {
	        return grammarErrorOnNode(node, message);
	      }
	    }
	    function checkGrammarMethod(node) {
	      if (checkGrammarFunctionLikeDeclaration(node)) {
	        return true;
	      }
	      if (node.kind === 174 /* MethodDeclaration */) {
	        if (node.parent.kind === 210 /* ObjectLiteralExpression */) {
	          if (node.modifiers && !(node.modifiers.length === 1 && first(node.modifiers).kind === 134 /* AsyncKeyword */)) {
	            return grammarErrorOnFirstToken(node, Diagnostics.Modifiers_cannot_appear_here);
	          } else if (checkGrammarForInvalidQuestionMark(node.questionToken, Diagnostics.An_object_member_cannot_be_declared_optional)) {
	            return true;
	          } else if (checkGrammarForInvalidExclamationToken(node.exclamationToken, Diagnostics.A_definite_assignment_assertion_is_not_permitted_in_this_context)) {
	            return true;
	          } else if (node.body === void 0) {
	            return grammarErrorAtPos(node, node.end - 1, ";".length, Diagnostics._0_expected, "{");
	          }
	        }
	        if (checkGrammarForGenerator(node)) {
	          return true;
	        }
	      }
	      if (isClassLike(node.parent)) {
	        if (languageVersion < 2 /* ES2015 */ && isPrivateIdentifier(node.name)) {
	          return grammarErrorOnNode(node.name, Diagnostics.Private_identifiers_are_only_available_when_targeting_ECMAScript_2015_and_higher);
	        }
	        if (node.flags & 33554432 /* Ambient */) {
	          return checkGrammarForInvalidDynamicName(node.name, Diagnostics.A_computed_property_name_in_an_ambient_context_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type);
	        } else if (node.kind === 174 /* MethodDeclaration */ && !node.body) {
	          return checkGrammarForInvalidDynamicName(node.name, Diagnostics.A_computed_property_name_in_a_method_overload_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type);
	        }
	      } else if (node.parent.kind === 264 /* InterfaceDeclaration */) {
	        return checkGrammarForInvalidDynamicName(node.name, Diagnostics.A_computed_property_name_in_an_interface_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type);
	      } else if (node.parent.kind === 187 /* TypeLiteral */) {
	        return checkGrammarForInvalidDynamicName(node.name, Diagnostics.A_computed_property_name_in_a_type_literal_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type);
	      }
	    }
	    function checkGrammarBreakOrContinueStatement(node) {
	      let current = node;
	      while (current) {
	        if (isFunctionLikeOrClassStaticBlockDeclaration(current)) {
	          return grammarErrorOnNode(node, Diagnostics.Jump_target_cannot_cross_function_boundary);
	        }
	        switch (current.kind) {
	          case 256 /* LabeledStatement */:
	            if (node.label && current.label.escapedText === node.label.escapedText) {
	              const isMisplacedContinueLabel = node.kind === 251 /* ContinueStatement */ && !isIterationStatement(
	                current.statement,
	                /*lookInLabeledStatements*/
	                true
	              );
	              if (isMisplacedContinueLabel) {
	                return grammarErrorOnNode(node, Diagnostics.A_continue_statement_can_only_jump_to_a_label_of_an_enclosing_iteration_statement);
	              }
	              return false;
	            }
	            break;
	          case 255 /* SwitchStatement */:
	            if (node.kind === 252 /* BreakStatement */ && !node.label) {
	              return false;
	            }
	            break;
	          default:
	            if (isIterationStatement(
	              current,
	              /*lookInLabeledStatements*/
	              false
	            ) && !node.label) {
	              return false;
	            }
	            break;
	        }
	        current = current.parent;
	      }
	      if (node.label) {
	        const message = node.kind === 252 /* BreakStatement */ ? Diagnostics.A_break_statement_can_only_jump_to_a_label_of_an_enclosing_statement : Diagnostics.A_continue_statement_can_only_jump_to_a_label_of_an_enclosing_iteration_statement;
	        return grammarErrorOnNode(node, message);
	      } else {
	        const message = node.kind === 252 /* BreakStatement */ ? Diagnostics.A_break_statement_can_only_be_used_within_an_enclosing_iteration_or_switch_statement : Diagnostics.A_continue_statement_can_only_be_used_within_an_enclosing_iteration_statement;
	        return grammarErrorOnNode(node, message);
	      }
	    }
	    function checkGrammarBindingElement(node) {
	      if (node.dotDotDotToken) {
	        const elements = node.parent.elements;
	        if (node !== last(elements)) {
	          return grammarErrorOnNode(node, Diagnostics.A_rest_element_must_be_last_in_a_destructuring_pattern);
	        }
	        checkGrammarForDisallowedTrailingComma(elements, Diagnostics.A_rest_parameter_or_binding_pattern_may_not_have_a_trailing_comma);
	        if (node.propertyName) {
	          return grammarErrorOnNode(node.name, Diagnostics.A_rest_element_cannot_have_a_property_name);
	        }
	      }
	      if (node.dotDotDotToken && node.initializer) {
	        return grammarErrorAtPos(node, node.initializer.pos - 1, 1, Diagnostics.A_rest_element_cannot_have_an_initializer);
	      }
	    }
	    function isStringOrNumberLiteralExpression(expr) {
	      return isStringOrNumericLiteralLike(expr) || expr.kind === 224 /* PrefixUnaryExpression */ && expr.operator === 41 /* MinusToken */ && expr.operand.kind === 9 /* NumericLiteral */;
	    }
	    function isBigIntLiteralExpression(expr) {
	      return expr.kind === 10 /* BigIntLiteral */ || expr.kind === 224 /* PrefixUnaryExpression */ && expr.operator === 41 /* MinusToken */ && expr.operand.kind === 10 /* BigIntLiteral */;
	    }
	    function isSimpleLiteralEnumReference(expr) {
	      if ((isPropertyAccessExpression(expr) || isElementAccessExpression(expr) && isStringOrNumberLiteralExpression(expr.argumentExpression)) && isEntityNameExpression(expr.expression)) {
	        return !!(checkExpressionCached(expr).flags & 1056 /* EnumLike */);
	      }
	    }
	    function checkAmbientInitializer(node) {
	      const initializer = node.initializer;
	      if (initializer) {
	        const isInvalidInitializer = !(isStringOrNumberLiteralExpression(initializer) || isSimpleLiteralEnumReference(initializer) || initializer.kind === 112 /* TrueKeyword */ || initializer.kind === 97 /* FalseKeyword */ || isBigIntLiteralExpression(initializer));
	        const isConstOrReadonly = isDeclarationReadonly(node) || isVariableDeclaration(node) && isVarConstLike(node);
	        if (isConstOrReadonly && !node.type) {
	          if (isInvalidInitializer) {
	            return grammarErrorOnNode(initializer, Diagnostics.A_const_initializer_in_an_ambient_context_must_be_a_string_or_numeric_literal_or_literal_enum_reference);
	          }
	        } else {
	          return grammarErrorOnNode(initializer, Diagnostics.Initializers_are_not_allowed_in_ambient_contexts);
	        }
	      }
	    }
	    function checkGrammarVariableDeclaration(node) {
	      const nodeFlags = getCombinedNodeFlagsCached(node);
	      const blockScopeKind = nodeFlags & 7 /* BlockScoped */;
	      if (isBindingPattern(node.name)) {
	        switch (blockScopeKind) {
	          case 6 /* AwaitUsing */:
	            return grammarErrorOnNode(node, Diagnostics._0_declarations_may_not_have_binding_patterns, "await using");
	          case 4 /* Using */:
	            return grammarErrorOnNode(node, Diagnostics._0_declarations_may_not_have_binding_patterns, "using");
	        }
	      }
	      if (node.parent.parent.kind !== 249 /* ForInStatement */ && node.parent.parent.kind !== 250 /* ForOfStatement */) {
	        if (nodeFlags & 33554432 /* Ambient */) {
	          checkAmbientInitializer(node);
	        } else if (!node.initializer) {
	          if (isBindingPattern(node.name) && !isBindingPattern(node.parent)) {
	            return grammarErrorOnNode(node, Diagnostics.A_destructuring_declaration_must_have_an_initializer);
	          }
	          switch (blockScopeKind) {
	            case 6 /* AwaitUsing */:
	              return grammarErrorOnNode(node, Diagnostics._0_declarations_must_be_initialized, "await using");
	            case 4 /* Using */:
	              return grammarErrorOnNode(node, Diagnostics._0_declarations_must_be_initialized, "using");
	            case 2 /* Const */:
	              return grammarErrorOnNode(node, Diagnostics._0_declarations_must_be_initialized, "const");
	          }
	        }
	      }
	      if (node.exclamationToken && (node.parent.parent.kind !== 243 /* VariableStatement */ || !node.type || node.initializer || nodeFlags & 33554432 /* Ambient */)) {
	        const message = node.initializer ? Diagnostics.Declarations_with_initializers_cannot_also_have_definite_assignment_assertions : !node.type ? Diagnostics.Declarations_with_definite_assignment_assertions_must_also_have_type_annotations : Diagnostics.A_definite_assignment_assertion_is_not_permitted_in_this_context;
	        return grammarErrorOnNode(node.exclamationToken, message);
	      }
	      if ((moduleKind < 5 /* ES2015 */ || getSourceFileOfNode(node).impliedNodeFormat === 1 /* CommonJS */) && moduleKind !== 4 /* System */ && !(node.parent.parent.flags & 33554432 /* Ambient */) && hasSyntacticModifier(node.parent.parent, 32 /* Export */)) {
	        checkESModuleMarker(node.name);
	      }
	      return !!blockScopeKind && checkGrammarNameInLetOrConstDeclarations(node.name);
	    }
	    function checkESModuleMarker(name) {
	      if (name.kind === 80 /* Identifier */) {
	        if (idText(name) === "__esModule") {
	          return grammarErrorOnNodeSkippedOn("noEmit", name, Diagnostics.Identifier_expected_esModule_is_reserved_as_an_exported_marker_when_transforming_ECMAScript_modules);
	        }
	      } else {
	        const elements = name.elements;
	        for (const element of elements) {
	          if (!isOmittedExpression(element)) {
	            return checkESModuleMarker(element.name);
	          }
	        }
	      }
	      return false;
	    }
	    function checkGrammarNameInLetOrConstDeclarations(name) {
	      if (name.kind === 80 /* Identifier */) {
	        if (name.escapedText === "let") {
	          return grammarErrorOnNode(name, Diagnostics.let_is_not_allowed_to_be_used_as_a_name_in_let_or_const_declarations);
	        }
	      } else {
	        const elements = name.elements;
	        for (const element of elements) {
	          if (!isOmittedExpression(element)) {
	            checkGrammarNameInLetOrConstDeclarations(element.name);
	          }
	        }
	      }
	      return false;
	    }
	    function checkGrammarVariableDeclarationList(declarationList) {
	      const declarations = declarationList.declarations;
	      if (checkGrammarForDisallowedTrailingComma(declarationList.declarations)) {
	        return true;
	      }
	      if (!declarationList.declarations.length) {
	        return grammarErrorAtPos(declarationList, declarations.pos, declarations.end - declarations.pos, Diagnostics.Variable_declaration_list_cannot_be_empty);
	      }
	      const blockScopeFlags = declarationList.flags & 7 /* BlockScoped */;
	      if ((blockScopeFlags === 4 /* Using */ || blockScopeFlags === 6 /* AwaitUsing */) && isForInStatement(declarationList.parent)) {
	        return grammarErrorOnNode(
	          declarationList,
	          blockScopeFlags === 4 /* Using */ ? Diagnostics.The_left_hand_side_of_a_for_in_statement_cannot_be_a_using_declaration : Diagnostics.The_left_hand_side_of_a_for_in_statement_cannot_be_an_await_using_declaration
	        );
	      }
	      if (blockScopeFlags === 6 /* AwaitUsing */) {
	        return checkAwaitGrammar(declarationList);
	      }
	      return false;
	    }
	    function allowLetAndConstDeclarations(parent2) {
	      switch (parent2.kind) {
	        case 245 /* IfStatement */:
	        case 246 /* DoStatement */:
	        case 247 /* WhileStatement */:
	        case 254 /* WithStatement */:
	        case 248 /* ForStatement */:
	        case 249 /* ForInStatement */:
	        case 250 /* ForOfStatement */:
	          return false;
	        case 256 /* LabeledStatement */:
	          return allowLetAndConstDeclarations(parent2.parent);
	      }
	      return true;
	    }
	    function checkGrammarForDisallowedBlockScopedVariableStatement(node) {
	      if (!allowLetAndConstDeclarations(node.parent)) {
	        const blockScopeKind = getCombinedNodeFlagsCached(node.declarationList) & 7 /* BlockScoped */;
	        if (blockScopeKind) {
	          const keyword = blockScopeKind === 1 /* Let */ ? "let" : blockScopeKind === 2 /* Const */ ? "const" : blockScopeKind === 4 /* Using */ ? "using" : blockScopeKind === 6 /* AwaitUsing */ ? "await using" : Debug.fail("Unknown BlockScope flag");
	          return grammarErrorOnNode(node, Diagnostics._0_declarations_can_only_be_declared_inside_a_block, keyword);
	        }
	      }
	    }
	    function checkGrammarMetaProperty(node) {
	      const escapedText = node.name.escapedText;
	      switch (node.keywordToken) {
	        case 105 /* NewKeyword */:
	          if (escapedText !== "target") {
	            return grammarErrorOnNode(node.name, Diagnostics._0_is_not_a_valid_meta_property_for_keyword_1_Did_you_mean_2, unescapeLeadingUnderscores(node.name.escapedText), tokenToString(node.keywordToken), "target");
	          }
	          break;
	        case 102 /* ImportKeyword */:
	          if (escapedText !== "meta") {
	            return grammarErrorOnNode(node.name, Diagnostics._0_is_not_a_valid_meta_property_for_keyword_1_Did_you_mean_2, unescapeLeadingUnderscores(node.name.escapedText), tokenToString(node.keywordToken), "meta");
	          }
	          break;
	      }
	    }
	    function hasParseDiagnostics(sourceFile) {
	      return sourceFile.parseDiagnostics.length > 0;
	    }
	    function grammarErrorOnFirstToken(node, message, ...args) {
	      const sourceFile = getSourceFileOfNode(node);
	      if (!hasParseDiagnostics(sourceFile)) {
	        const span = getSpanOfTokenAtPosition(sourceFile, node.pos);
	        diagnostics.add(createFileDiagnostic(sourceFile, span.start, span.length, message, ...args));
	        return true;
	      }
	      return false;
	    }
	    function grammarErrorAtPos(nodeForSourceFile, start, length2, message, ...args) {
	      const sourceFile = getSourceFileOfNode(nodeForSourceFile);
	      if (!hasParseDiagnostics(sourceFile)) {
	        diagnostics.add(createFileDiagnostic(sourceFile, start, length2, message, ...args));
	        return true;
	      }
	      return false;
	    }
	    function grammarErrorOnNodeSkippedOn(key, node, message, ...args) {
	      const sourceFile = getSourceFileOfNode(node);
	      if (!hasParseDiagnostics(sourceFile)) {
	        errorSkippedOn(key, node, message, ...args);
	        return true;
	      }
	      return false;
	    }
	    function grammarErrorOnNode(node, message, ...args) {
	      const sourceFile = getSourceFileOfNode(node);
	      if (!hasParseDiagnostics(sourceFile)) {
	        diagnostics.add(createDiagnosticForNode(node, message, ...args));
	        return true;
	      }
	      return false;
	    }
	    function checkGrammarConstructorTypeParameters(node) {
	      const jsdocTypeParameters = isInJSFile(node) ? getJSDocTypeParameterDeclarations(node) : void 0;
	      const range = node.typeParameters || jsdocTypeParameters && firstOrUndefined(jsdocTypeParameters);
	      if (range) {
	        const pos = range.pos === range.end ? range.pos : skipTrivia(getSourceFileOfNode(node).text, range.pos);
	        return grammarErrorAtPos(node, pos, range.end - pos, Diagnostics.Type_parameters_cannot_appear_on_a_constructor_declaration);
	      }
	    }
	    function checkGrammarConstructorTypeAnnotation(node) {
	      const type = node.type || getEffectiveReturnTypeNode(node);
	      if (type) {
	        return grammarErrorOnNode(type, Diagnostics.Type_annotation_cannot_appear_on_a_constructor_declaration);
	      }
	    }
	    function checkGrammarProperty(node) {
	      if (isComputedPropertyName(node.name) && isBinaryExpression(node.name.expression) && node.name.expression.operatorToken.kind === 103 /* InKeyword */) {
	        return grammarErrorOnNode(node.parent.members[0], Diagnostics.A_mapped_type_may_not_declare_properties_or_methods);
	      }
	      if (isClassLike(node.parent)) {
	        if (isStringLiteral(node.name) && node.name.text === "constructor") {
	          return grammarErrorOnNode(node.name, Diagnostics.Classes_may_not_have_a_field_named_constructor);
	        }
	        if (checkGrammarForInvalidDynamicName(node.name, Diagnostics.A_computed_property_name_in_a_class_property_declaration_must_have_a_simple_literal_type_or_a_unique_symbol_type)) {
	          return true;
	        }
	        if (languageVersion < 2 /* ES2015 */ && isPrivateIdentifier(node.name)) {
	          return grammarErrorOnNode(node.name, Diagnostics.Private_identifiers_are_only_available_when_targeting_ECMAScript_2015_and_higher);
	        }
	        if (languageVersion < 2 /* ES2015 */ && isAutoAccessorPropertyDeclaration(node)) {
	          return grammarErrorOnNode(node.name, Diagnostics.Properties_with_the_accessor_modifier_are_only_available_when_targeting_ECMAScript_2015_and_higher);
	        }
	        if (isAutoAccessorPropertyDeclaration(node) && checkGrammarForInvalidQuestionMark(node.questionToken, Diagnostics.An_accessor_property_cannot_be_declared_optional)) {
	          return true;
	        }
	      } else if (node.parent.kind === 264 /* InterfaceDeclaration */) {
	        if (checkGrammarForInvalidDynamicName(node.name, Diagnostics.A_computed_property_name_in_an_interface_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type)) {
	          return true;
	        }
	        Debug.assertNode(node, isPropertySignature);
	        if (node.initializer) {
	          return grammarErrorOnNode(node.initializer, Diagnostics.An_interface_property_cannot_have_an_initializer);
	        }
	      } else if (isTypeLiteralNode(node.parent)) {
	        if (checkGrammarForInvalidDynamicName(node.name, Diagnostics.A_computed_property_name_in_a_type_literal_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type)) {
	          return true;
	        }
	        Debug.assertNode(node, isPropertySignature);
	        if (node.initializer) {
	          return grammarErrorOnNode(node.initializer, Diagnostics.A_type_literal_property_cannot_have_an_initializer);
	        }
	      }
	      if (node.flags & 33554432 /* Ambient */) {
	        checkAmbientInitializer(node);
	      }
	      if (isPropertyDeclaration(node) && node.exclamationToken && (!isClassLike(node.parent) || !node.type || node.initializer || node.flags & 33554432 /* Ambient */ || isStatic(node) || hasAbstractModifier(node))) {
	        const message = node.initializer ? Diagnostics.Declarations_with_initializers_cannot_also_have_definite_assignment_assertions : !node.type ? Diagnostics.Declarations_with_definite_assignment_assertions_must_also_have_type_annotations : Diagnostics.A_definite_assignment_assertion_is_not_permitted_in_this_context;
	        return grammarErrorOnNode(node.exclamationToken, message);
	      }
	    }
	    function checkGrammarTopLevelElementForRequiredDeclareModifier(node) {
	      if (node.kind === 264 /* InterfaceDeclaration */ || node.kind === 265 /* TypeAliasDeclaration */ || node.kind === 272 /* ImportDeclaration */ || node.kind === 271 /* ImportEqualsDeclaration */ || node.kind === 278 /* ExportDeclaration */ || node.kind === 277 /* ExportAssignment */ || node.kind === 270 /* NamespaceExportDeclaration */ || hasSyntacticModifier(node, 128 /* Ambient */ | 32 /* Export */ | 2048 /* Default */)) {
	        return false;
	      }
	      return grammarErrorOnFirstToken(node, Diagnostics.Top_level_declarations_in_d_ts_files_must_start_with_either_a_declare_or_export_modifier);
	    }
	    function checkGrammarTopLevelElementsForRequiredDeclareModifier(file) {
	      for (const decl of file.statements) {
	        if (isDeclaration(decl) || decl.kind === 243 /* VariableStatement */) {
	          if (checkGrammarTopLevelElementForRequiredDeclareModifier(decl)) {
	            return true;
	          }
	        }
	      }
	      return false;
	    }
	    function checkGrammarSourceFile(node) {
	      return !!(node.flags & 33554432 /* Ambient */) && checkGrammarTopLevelElementsForRequiredDeclareModifier(node);
	    }
	    function checkGrammarStatementInAmbientContext(node) {
	      if (node.flags & 33554432 /* Ambient */) {
	        const links = getNodeLinks(node);
	        if (!links.hasReportedStatementInAmbientContext && (isFunctionLike(node.parent) || isAccessor(node.parent))) {
	          return getNodeLinks(node).hasReportedStatementInAmbientContext = grammarErrorOnFirstToken(node, Diagnostics.An_implementation_cannot_be_declared_in_ambient_contexts);
	        }
	        if (node.parent.kind === 241 /* Block */ || node.parent.kind === 268 /* ModuleBlock */ || node.parent.kind === 312 /* SourceFile */) {
	          const links2 = getNodeLinks(node.parent);
	          if (!links2.hasReportedStatementInAmbientContext) {
	            return links2.hasReportedStatementInAmbientContext = grammarErrorOnFirstToken(node, Diagnostics.Statements_are_not_allowed_in_ambient_contexts);
	          }
	        }
	      }
	      return false;
	    }
	    function checkGrammarNumericLiteral(node) {
	      const isFractional = getTextOfNode(node).includes(".");
	      const isScientific = node.numericLiteralFlags & 16 /* Scientific */;
	      if (isFractional || isScientific) {
	        return;
	      }
	      const value = +node.text;
	      if (value <= 2 ** 53 - 1) {
	        return;
	      }
	      addErrorOrSuggestion(
	        /*isError*/
	        false,
	        createDiagnosticForNode(node, Diagnostics.Numeric_literals_with_absolute_values_equal_to_2_53_or_greater_are_too_large_to_be_represented_accurately_as_integers)
	      );
	    }
	    function checkGrammarBigIntLiteral(node) {
	      const literalType = isLiteralTypeNode(node.parent) || isPrefixUnaryExpression(node.parent) && isLiteralTypeNode(node.parent.parent);
	      if (!literalType) {
	        if (languageVersion < 7 /* ES2020 */) {
	          if (grammarErrorOnNode(node, Diagnostics.BigInt_literals_are_not_available_when_targeting_lower_than_ES2020)) {
	            return true;
	          }
	        }
	      }
	      return false;
	    }
	    function grammarErrorAfterFirstToken(node, message, ...args) {
	      const sourceFile = getSourceFileOfNode(node);
	      if (!hasParseDiagnostics(sourceFile)) {
	        const span = getSpanOfTokenAtPosition(sourceFile, node.pos);
	        diagnostics.add(createFileDiagnostic(
	          sourceFile,
	          textSpanEnd(span),
	          /*length*/
	          0,
	          message,
	          ...args
	        ));
	        return true;
	      }
	      return false;
	    }
	    function getAmbientModules() {
	      if (!ambientModulesCache) {
	        ambientModulesCache = [];
	        globals.forEach((global2, sym) => {
	          if (ambientModuleSymbolRegex.test(sym)) {
	            ambientModulesCache.push(global2);
	          }
	        });
	      }
	      return ambientModulesCache;
	    }
	    function checkGrammarImportClause(node) {
	      var _a;
	      if (node.isTypeOnly && node.name && node.namedBindings) {
	        return grammarErrorOnNode(node, Diagnostics.A_type_only_import_can_specify_a_default_import_or_named_bindings_but_not_both);
	      }
	      if (node.isTypeOnly && ((_a = node.namedBindings) == null ? void 0 : _a.kind) === 275 /* NamedImports */) {
	        return checkGrammarNamedImportsOrExports(node.namedBindings);
	      }
	      return false;
	    }
	    function checkGrammarNamedImportsOrExports(namedBindings) {
	      return !!forEach(namedBindings.elements, (specifier) => {
	        if (specifier.isTypeOnly) {
	          return grammarErrorOnFirstToken(
	            specifier,
	            specifier.kind === 276 /* ImportSpecifier */ ? Diagnostics.The_type_modifier_cannot_be_used_on_a_named_import_when_import_type_is_used_on_its_import_statement : Diagnostics.The_type_modifier_cannot_be_used_on_a_named_export_when_export_type_is_used_on_its_export_statement
	          );
	        }
	      });
	    }
	    function checkGrammarImportCallExpression(node) {
	      if (compilerOptions.verbatimModuleSyntax && moduleKind === 1 /* CommonJS */) {
	        return grammarErrorOnNode(node, Diagnostics.ESM_syntax_is_not_allowed_in_a_CommonJS_module_when_verbatimModuleSyntax_is_enabled);
	      }
	      if (moduleKind === 5 /* ES2015 */) {
	        return grammarErrorOnNode(node, Diagnostics.Dynamic_imports_are_only_supported_when_the_module_flag_is_set_to_es2020_es2022_esnext_commonjs_amd_system_umd_node16_or_nodenext);
	      }
	      if (node.typeArguments) {
	        return grammarErrorOnNode(node, Diagnostics.This_use_of_import_is_invalid_import_calls_can_be_written_but_they_must_have_parentheses_and_cannot_have_type_arguments);
	      }
	      const nodeArguments = node.arguments;
	      if (moduleKind !== 99 /* ESNext */ && moduleKind !== 199 /* NodeNext */ && moduleKind !== 100 /* Node16 */) {
	        checkGrammarForDisallowedTrailingComma(nodeArguments);
	        if (nodeArguments.length > 1) {
	          const importAttributesArgument = nodeArguments[1];
	          return grammarErrorOnNode(importAttributesArgument, Diagnostics.Dynamic_imports_only_support_a_second_argument_when_the_module_option_is_set_to_esnext_node16_or_nodenext);
	        }
	      }
	      if (nodeArguments.length === 0 || nodeArguments.length > 2) {
	        return grammarErrorOnNode(node, Diagnostics.Dynamic_imports_can_only_accept_a_module_specifier_and_an_optional_set_of_attributes_as_arguments);
	      }
	      const spreadElement = find(nodeArguments, isSpreadElement);
	      if (spreadElement) {
	        return grammarErrorOnNode(spreadElement, Diagnostics.Argument_of_dynamic_import_cannot_be_spread_element);
	      }
	      return false;
	    }
	    function findMatchingTypeReferenceOrTypeAliasReference(source, unionTarget) {
	      const sourceObjectFlags = getObjectFlags(source);
	      if (sourceObjectFlags & (4 /* Reference */ | 16 /* Anonymous */) && unionTarget.flags & 1048576 /* Union */) {
	        return find(unionTarget.types, (target) => {
	          if (target.flags & 524288 /* Object */) {
	            const overlapObjFlags = sourceObjectFlags & getObjectFlags(target);
	            if (overlapObjFlags & 4 /* Reference */) {
	              return source.target === target.target;
	            }
	            if (overlapObjFlags & 16 /* Anonymous */) {
	              return !!source.aliasSymbol && source.aliasSymbol === target.aliasSymbol;
	            }
	          }
	          return false;
	        });
	      }
	    }
	    function findBestTypeForObjectLiteral(source, unionTarget) {
	      if (getObjectFlags(source) & 128 /* ObjectLiteral */ && someType(unionTarget, isArrayLikeType)) {
	        return find(unionTarget.types, (t) => !isArrayLikeType(t));
	      }
	    }
	    function findBestTypeForInvokable(source, unionTarget) {
	      let signatureKind = 0 /* Call */;
	      const hasSignatures = getSignaturesOfType(source, signatureKind).length > 0 || (signatureKind = 1 /* Construct */, getSignaturesOfType(source, signatureKind).length > 0);
	      if (hasSignatures) {
	        return find(unionTarget.types, (t) => getSignaturesOfType(t, signatureKind).length > 0);
	      }
	    }
	    function findMostOverlappyType(source, unionTarget) {
	      let bestMatch;
	      if (!(source.flags & (402784252 /* Primitive */ | 406847488 /* InstantiablePrimitive */))) {
	        let matchingCount = 0;
	        for (const target of unionTarget.types) {
	          if (!(target.flags & (402784252 /* Primitive */ | 406847488 /* InstantiablePrimitive */))) {
	            const overlap = getIntersectionType([getIndexType(source), getIndexType(target)]);
	            if (overlap.flags & 4194304 /* Index */) {
	              return target;
	            } else if (isUnitType(overlap) || overlap.flags & 1048576 /* Union */) {
	              const len = overlap.flags & 1048576 /* Union */ ? countWhere(overlap.types, isUnitType) : 1;
	              if (len >= matchingCount) {
	                bestMatch = target;
	                matchingCount = len;
	              }
	            }
	          }
	        }
	      }
	      return bestMatch;
	    }
	    function filterPrimitivesIfContainsNonPrimitive(type) {
	      if (maybeTypeOfKind(type, 67108864 /* NonPrimitive */)) {
	        const result = filterType(type, (t) => !(t.flags & 402784252 /* Primitive */));
	        if (!(result.flags & 131072 /* Never */)) {
	          return result;
	        }
	      }
	      return type;
	    }
	    function findMatchingDiscriminantType(source, target, isRelatedTo) {
	      if (target.flags & 1048576 /* Union */ && source.flags & (2097152 /* Intersection */ | 524288 /* Object */)) {
	        const match = getMatchingUnionConstituentForType(target, source);
	        if (match) {
	          return match;
	        }
	        const sourceProperties = getPropertiesOfType(source);
	        if (sourceProperties) {
	          const sourcePropertiesFiltered = findDiscriminantProperties(sourceProperties, target);
	          if (sourcePropertiesFiltered) {
	            const discriminated = discriminateTypeByDiscriminableItems(target, map(sourcePropertiesFiltered, (p) => [() => getTypeOfSymbol(p), p.escapedName]), isRelatedTo);
	            if (discriminated !== target) {
	              return discriminated;
	            }
	          }
	        }
	      }
	      return void 0;
	    }
	    function getEffectivePropertyNameForPropertyNameNode(node) {
	      const name = getPropertyNameForPropertyNameNode(node);
	      return name ? name : isComputedPropertyName(node) ? tryGetNameFromType(getTypeOfExpression(node.expression)) : void 0;
	    }
	    function getCombinedModifierFlagsCached(node) {
	      if (lastGetCombinedModifierFlagsNode === node) {
	        return lastGetCombinedModifierFlagsResult;
	      }
	      lastGetCombinedModifierFlagsNode = node;
	      lastGetCombinedModifierFlagsResult = getCombinedModifierFlags(node);
	      return lastGetCombinedModifierFlagsResult;
	    }
	    function getCombinedNodeFlagsCached(node) {
	      if (lastGetCombinedNodeFlagsNode === node) {
	        return lastGetCombinedNodeFlagsResult;
	      }
	      lastGetCombinedNodeFlagsNode = node;
	      lastGetCombinedNodeFlagsResult = getCombinedNodeFlags(node);
	      return lastGetCombinedNodeFlagsResult;
	    }
	    function isVarConstLike(node) {
	      const blockScopeKind = getCombinedNodeFlagsCached(node) & 7 /* BlockScoped */;
	      return blockScopeKind === 2 /* Const */ || blockScopeKind === 4 /* Using */ || blockScopeKind === 6 /* AwaitUsing */;
	    }
	  }
	  function isNotAccessor(declaration) {
	    return !isAccessor(declaration);
	  }
	  function isNotOverload(declaration) {
	    return declaration.kind !== 262 /* FunctionDeclaration */ && declaration.kind !== 174 /* MethodDeclaration */ || !!declaration.body;
	  }
	  function isDeclarationNameOrImportPropertyName(name) {
	    switch (name.parent.kind) {
	      case 276 /* ImportSpecifier */:
	      case 281 /* ExportSpecifier */:
	        return isIdentifier(name);
	      default:
	        return isDeclarationName(name);
	    }
	  }
	  function getIterationTypesKeyFromIterationTypeKind(typeKind) {
	    switch (typeKind) {
	      case 0 /* Yield */:
	        return "yieldType";
	      case 1 /* Return */:
	        return "returnType";
	      case 2 /* Next */:
	        return "nextType";
	    }
	  }
	  function signatureHasRestParameter(s) {
	    return !!(s.flags & 1 /* HasRestParameter */);
	  }
	  function signatureHasLiteralTypes(s) {
	    return !!(s.flags & 2 /* HasLiteralTypes */);
	  }
	  function createBasicNodeBuilderModuleSpecifierResolutionHost(host) {
	    return {
	      getCommonSourceDirectory: !!host.getCommonSourceDirectory ? () => host.getCommonSourceDirectory() : () => "",
	      getCurrentDirectory: () => host.getCurrentDirectory(),
	      getSymlinkCache: maybeBind(host, host.getSymlinkCache),
	      getPackageJsonInfoCache: () => {
	        var _a;
	        return (_a = host.getPackageJsonInfoCache) == null ? void 0 : _a.call(host);
	      },
	      useCaseSensitiveFileNames: maybeBind(host, host.useCaseSensitiveFileNames),
	      redirectTargetsMap: host.redirectTargetsMap,
	      getProjectReferenceRedirect: (fileName) => host.getProjectReferenceRedirect(fileName),
	      isSourceOfProjectReferenceRedirect: (fileName) => host.isSourceOfProjectReferenceRedirect(fileName),
	      fileExists: (fileName) => host.fileExists(fileName),
	      getFileIncludeReasons: () => host.getFileIncludeReasons(),
	      readFile: host.readFile ? (fileName) => host.readFile(fileName) : void 0
	    };
	  }
	  var ambientModuleSymbolRegex, anon, nextSymbolId, nextNodeId, nextMergeId, nextFlowId, TypeFacts, typeofNEFacts, CheckMode, SignatureCheckMode, isNotOverloadAndNotAccessor, intrinsicTypeKinds, SymbolLinks, JsxNames, SymbolTrackerImpl;
	  var init_checker = __esm({
	    "src/compiler/checker.ts"() {
	      init_ts2();
	      init_ts_moduleSpecifiers();
	      init_ts_performance();
	      ambientModuleSymbolRegex = /^".+"$/;
	      anon = "(anonymous)";
	      nextSymbolId = 1;
	      nextNodeId = 1;
	      nextMergeId = 1;
	      nextFlowId = 1;
	      TypeFacts = /* @__PURE__ */ ((TypeFacts3) => {
	        TypeFacts3[TypeFacts3["None"] = 0] = "None";
	        TypeFacts3[TypeFacts3["TypeofEQString"] = 1] = "TypeofEQString";
	        TypeFacts3[TypeFacts3["TypeofEQNumber"] = 2] = "TypeofEQNumber";
	        TypeFacts3[TypeFacts3["TypeofEQBigInt"] = 4] = "TypeofEQBigInt";
	        TypeFacts3[TypeFacts3["TypeofEQBoolean"] = 8] = "TypeofEQBoolean";
	        TypeFacts3[TypeFacts3["TypeofEQSymbol"] = 16] = "TypeofEQSymbol";
	        TypeFacts3[TypeFacts3["TypeofEQObject"] = 32] = "TypeofEQObject";
	        TypeFacts3[TypeFacts3["TypeofEQFunction"] = 64] = "TypeofEQFunction";
	        TypeFacts3[TypeFacts3["TypeofEQHostObject"] = 128] = "TypeofEQHostObject";
	        TypeFacts3[TypeFacts3["TypeofNEString"] = 256] = "TypeofNEString";
	        TypeFacts3[TypeFacts3["TypeofNENumber"] = 512] = "TypeofNENumber";
	        TypeFacts3[TypeFacts3["TypeofNEBigInt"] = 1024] = "TypeofNEBigInt";
	        TypeFacts3[TypeFacts3["TypeofNEBoolean"] = 2048] = "TypeofNEBoolean";
	        TypeFacts3[TypeFacts3["TypeofNESymbol"] = 4096] = "TypeofNESymbol";
	        TypeFacts3[TypeFacts3["TypeofNEObject"] = 8192] = "TypeofNEObject";
	        TypeFacts3[TypeFacts3["TypeofNEFunction"] = 16384] = "TypeofNEFunction";
	        TypeFacts3[TypeFacts3["TypeofNEHostObject"] = 32768] = "TypeofNEHostObject";
	        TypeFacts3[TypeFacts3["EQUndefined"] = 65536] = "EQUndefined";
	        TypeFacts3[TypeFacts3["EQNull"] = 131072] = "EQNull";
	        TypeFacts3[TypeFacts3["EQUndefinedOrNull"] = 262144] = "EQUndefinedOrNull";
	        TypeFacts3[TypeFacts3["NEUndefined"] = 524288] = "NEUndefined";
	        TypeFacts3[TypeFacts3["NENull"] = 1048576] = "NENull";
	        TypeFacts3[TypeFacts3["NEUndefinedOrNull"] = 2097152] = "NEUndefinedOrNull";
	        TypeFacts3[TypeFacts3["Truthy"] = 4194304] = "Truthy";
	        TypeFacts3[TypeFacts3["Falsy"] = 8388608] = "Falsy";
	        TypeFacts3[TypeFacts3["IsUndefined"] = 16777216] = "IsUndefined";
	        TypeFacts3[TypeFacts3["IsNull"] = 33554432] = "IsNull";
	        TypeFacts3[TypeFacts3["IsUndefinedOrNull"] = 50331648] = "IsUndefinedOrNull";
	        TypeFacts3[TypeFacts3["All"] = 134217727] = "All";
	        TypeFacts3[TypeFacts3["BaseStringStrictFacts"] = 3735041] = "BaseStringStrictFacts";
	        TypeFacts3[TypeFacts3["BaseStringFacts"] = 12582401] = "BaseStringFacts";
	        TypeFacts3[TypeFacts3["StringStrictFacts"] = 16317953] = "StringStrictFacts";
	        TypeFacts3[TypeFacts3["StringFacts"] = 16776705] = "StringFacts";
	        TypeFacts3[TypeFacts3["EmptyStringStrictFacts"] = 12123649] = "EmptyStringStrictFacts";
	        TypeFacts3[TypeFacts3["EmptyStringFacts"] = 12582401 /* BaseStringFacts */] = "EmptyStringFacts";
	        TypeFacts3[TypeFacts3["NonEmptyStringStrictFacts"] = 7929345] = "NonEmptyStringStrictFacts";
	        TypeFacts3[TypeFacts3["NonEmptyStringFacts"] = 16776705] = "NonEmptyStringFacts";
	        TypeFacts3[TypeFacts3["BaseNumberStrictFacts"] = 3734786] = "BaseNumberStrictFacts";
	        TypeFacts3[TypeFacts3["BaseNumberFacts"] = 12582146] = "BaseNumberFacts";
	        TypeFacts3[TypeFacts3["NumberStrictFacts"] = 16317698] = "NumberStrictFacts";
	        TypeFacts3[TypeFacts3["NumberFacts"] = 16776450] = "NumberFacts";
	        TypeFacts3[TypeFacts3["ZeroNumberStrictFacts"] = 12123394] = "ZeroNumberStrictFacts";
	        TypeFacts3[TypeFacts3["ZeroNumberFacts"] = 12582146 /* BaseNumberFacts */] = "ZeroNumberFacts";
	        TypeFacts3[TypeFacts3["NonZeroNumberStrictFacts"] = 7929090] = "NonZeroNumberStrictFacts";
	        TypeFacts3[TypeFacts3["NonZeroNumberFacts"] = 16776450] = "NonZeroNumberFacts";
	        TypeFacts3[TypeFacts3["BaseBigIntStrictFacts"] = 3734276] = "BaseBigIntStrictFacts";
	        TypeFacts3[TypeFacts3["BaseBigIntFacts"] = 12581636] = "BaseBigIntFacts";
	        TypeFacts3[TypeFacts3["BigIntStrictFacts"] = 16317188] = "BigIntStrictFacts";
	        TypeFacts3[TypeFacts3["BigIntFacts"] = 16775940] = "BigIntFacts";
	        TypeFacts3[TypeFacts3["ZeroBigIntStrictFacts"] = 12122884] = "ZeroBigIntStrictFacts";
	        TypeFacts3[TypeFacts3["ZeroBigIntFacts"] = 12581636 /* BaseBigIntFacts */] = "ZeroBigIntFacts";
	        TypeFacts3[TypeFacts3["NonZeroBigIntStrictFacts"] = 7928580] = "NonZeroBigIntStrictFacts";
	        TypeFacts3[TypeFacts3["NonZeroBigIntFacts"] = 16775940] = "NonZeroBigIntFacts";
	        TypeFacts3[TypeFacts3["BaseBooleanStrictFacts"] = 3733256] = "BaseBooleanStrictFacts";
	        TypeFacts3[TypeFacts3["BaseBooleanFacts"] = 12580616] = "BaseBooleanFacts";
	        TypeFacts3[TypeFacts3["BooleanStrictFacts"] = 16316168] = "BooleanStrictFacts";
	        TypeFacts3[TypeFacts3["BooleanFacts"] = 16774920] = "BooleanFacts";
	        TypeFacts3[TypeFacts3["FalseStrictFacts"] = 12121864] = "FalseStrictFacts";
	        TypeFacts3[TypeFacts3["FalseFacts"] = 12580616 /* BaseBooleanFacts */] = "FalseFacts";
	        TypeFacts3[TypeFacts3["TrueStrictFacts"] = 7927560] = "TrueStrictFacts";
	        TypeFacts3[TypeFacts3["TrueFacts"] = 16774920] = "TrueFacts";
	        TypeFacts3[TypeFacts3["SymbolStrictFacts"] = 7925520] = "SymbolStrictFacts";
	        TypeFacts3[TypeFacts3["SymbolFacts"] = 16772880] = "SymbolFacts";
	        TypeFacts3[TypeFacts3["ObjectStrictFacts"] = 7888800] = "ObjectStrictFacts";
	        TypeFacts3[TypeFacts3["ObjectFacts"] = 16736160] = "ObjectFacts";
	        TypeFacts3[TypeFacts3["FunctionStrictFacts"] = 7880640] = "FunctionStrictFacts";
	        TypeFacts3[TypeFacts3["FunctionFacts"] = 16728e3] = "FunctionFacts";
	        TypeFacts3[TypeFacts3["VoidFacts"] = 9830144] = "VoidFacts";
	        TypeFacts3[TypeFacts3["UndefinedFacts"] = 26607360] = "UndefinedFacts";
	        TypeFacts3[TypeFacts3["NullFacts"] = 42917664] = "NullFacts";
	        TypeFacts3[TypeFacts3["EmptyObjectStrictFacts"] = 83427327] = "EmptyObjectStrictFacts";
	        TypeFacts3[TypeFacts3["EmptyObjectFacts"] = 83886079] = "EmptyObjectFacts";
	        TypeFacts3[TypeFacts3["UnknownFacts"] = 83886079] = "UnknownFacts";
	        TypeFacts3[TypeFacts3["AllTypeofNE"] = 556800] = "AllTypeofNE";
	        TypeFacts3[TypeFacts3["OrFactsMask"] = 8256] = "OrFactsMask";
	        TypeFacts3[TypeFacts3["AndFactsMask"] = 134209471] = "AndFactsMask";
	        return TypeFacts3;
	      })(TypeFacts || {});
	      typeofNEFacts = new Map(Object.entries({
	        string: 256 /* TypeofNEString */,
	        number: 512 /* TypeofNENumber */,
	        bigint: 1024 /* TypeofNEBigInt */,
	        boolean: 2048 /* TypeofNEBoolean */,
	        symbol: 4096 /* TypeofNESymbol */,
	        undefined: 524288 /* NEUndefined */,
	        object: 8192 /* TypeofNEObject */,
	        function: 16384 /* TypeofNEFunction */
	      }));
	      CheckMode = /* @__PURE__ */ ((CheckMode3) => {
	        CheckMode3[CheckMode3["Normal"] = 0] = "Normal";
	        CheckMode3[CheckMode3["Contextual"] = 1] = "Contextual";
	        CheckMode3[CheckMode3["Inferential"] = 2] = "Inferential";
	        CheckMode3[CheckMode3["SkipContextSensitive"] = 4] = "SkipContextSensitive";
	        CheckMode3[CheckMode3["SkipGenericFunctions"] = 8] = "SkipGenericFunctions";
	        CheckMode3[CheckMode3["IsForSignatureHelp"] = 16] = "IsForSignatureHelp";
	        CheckMode3[CheckMode3["RestBindingElement"] = 32] = "RestBindingElement";
	        CheckMode3[CheckMode3["TypeOnly"] = 64] = "TypeOnly";
	        return CheckMode3;
	      })(CheckMode || {});
	      SignatureCheckMode = /* @__PURE__ */ ((SignatureCheckMode3) => {
	        SignatureCheckMode3[SignatureCheckMode3["None"] = 0] = "None";
	        SignatureCheckMode3[SignatureCheckMode3["BivariantCallback"] = 1] = "BivariantCallback";
	        SignatureCheckMode3[SignatureCheckMode3["StrictCallback"] = 2] = "StrictCallback";
	        SignatureCheckMode3[SignatureCheckMode3["IgnoreReturnTypes"] = 4] = "IgnoreReturnTypes";
	        SignatureCheckMode3[SignatureCheckMode3["StrictArity"] = 8] = "StrictArity";
	        SignatureCheckMode3[SignatureCheckMode3["StrictTopSignature"] = 16] = "StrictTopSignature";
	        SignatureCheckMode3[SignatureCheckMode3["Callback"] = 3] = "Callback";
	        return SignatureCheckMode3;
	      })(SignatureCheckMode || {});
	      isNotOverloadAndNotAccessor = and(isNotOverload, isNotAccessor);
	      intrinsicTypeKinds = new Map(Object.entries({
	        Uppercase: 0 /* Uppercase */,
	        Lowercase: 1 /* Lowercase */,
	        Capitalize: 2 /* Capitalize */,
	        Uncapitalize: 3 /* Uncapitalize */,
	        NoInfer: 4 /* NoInfer */
	      }));
	      SymbolLinks = class {
	      };
	      ((JsxNames2) => {
	        JsxNames2.JSX = "JSX";
	        JsxNames2.IntrinsicElements = "IntrinsicElements";
	        JsxNames2.ElementClass = "ElementClass";
	        JsxNames2.ElementAttributesPropertyNameContainer = "ElementAttributesProperty";
	        JsxNames2.ElementChildrenAttributeNameContainer = "ElementChildrenAttribute";
	        JsxNames2.Element = "Element";
	        JsxNames2.ElementType = "ElementType";
	        JsxNames2.IntrinsicAttributes = "IntrinsicAttributes";
	        JsxNames2.IntrinsicClassAttributes = "IntrinsicClassAttributes";
	        JsxNames2.LibraryManagedAttributes = "LibraryManagedAttributes";
	      })(JsxNames || (JsxNames = {}));
	      SymbolTrackerImpl = class _SymbolTrackerImpl {
	        constructor(context, tracker, moduleResolverHost) {
	          this.moduleResolverHost = void 0;
	          this.inner = void 0;
	          this.disableTrackSymbol = false;
	          var _a;
	          while (tracker instanceof _SymbolTrackerImpl) {
	            tracker = tracker.inner;
	          }
	          this.inner = tracker;
	          this.moduleResolverHost = moduleResolverHost;
	          this.context = context;
	          this.canTrackSymbol = !!((_a = this.inner) == null ? void 0 : _a.trackSymbol);
	        }
	        trackSymbol(symbol, enclosingDeclaration, meaning) {
	          var _a, _b;
	          if (((_a = this.inner) == null ? void 0 : _a.trackSymbol) && !this.disableTrackSymbol) {
	            if (this.inner.trackSymbol(symbol, enclosingDeclaration, meaning)) {
	              this.onDiagnosticReported();
	              return true;
	            }
	            if (!(symbol.flags & 262144 /* TypeParameter */))
	              ((_b = this.context).trackedSymbols ?? (_b.trackedSymbols = [])).push([symbol, enclosingDeclaration, meaning]);
	          }
	          return false;
	        }
	        reportInaccessibleThisError() {
	          var _a;
	          if ((_a = this.inner) == null ? void 0 : _a.reportInaccessibleThisError) {
	            this.onDiagnosticReported();
	            this.inner.reportInaccessibleThisError();
	          }
	        }
	        reportPrivateInBaseOfClassExpression(propertyName) {
	          var _a;
	          if ((_a = this.inner) == null ? void 0 : _a.reportPrivateInBaseOfClassExpression) {
	            this.onDiagnosticReported();
	            this.inner.reportPrivateInBaseOfClassExpression(propertyName);
	          }
	        }
	        reportInaccessibleUniqueSymbolError() {
	          var _a;
	          if ((_a = this.inner) == null ? void 0 : _a.reportInaccessibleUniqueSymbolError) {
	            this.onDiagnosticReported();
	            this.inner.reportInaccessibleUniqueSymbolError();
	          }
	        }
	        reportCyclicStructureError() {
	          var _a;
	          if ((_a = this.inner) == null ? void 0 : _a.reportCyclicStructureError) {
	            this.onDiagnosticReported();
	            this.inner.reportCyclicStructureError();
	          }
	        }
	        reportLikelyUnsafeImportRequiredError(specifier) {
	          var _a;
	          if ((_a = this.inner) == null ? void 0 : _a.reportLikelyUnsafeImportRequiredError) {
	            this.onDiagnosticReported();
	            this.inner.reportLikelyUnsafeImportRequiredError(specifier);
	          }
	        }
	        reportTruncationError() {
	          var _a;
	          if ((_a = this.inner) == null ? void 0 : _a.reportTruncationError) {
	            this.onDiagnosticReported();
	            this.inner.reportTruncationError();
	          }
	        }
	        trackReferencedAmbientModule(decl, symbol) {
	          var _a;
	          if ((_a = this.inner) == null ? void 0 : _a.trackReferencedAmbientModule) {
	            this.onDiagnosticReported();
	            this.inner.trackReferencedAmbientModule(decl, symbol);
	          }
	        }
	        trackExternalModuleSymbolOfImportTypeNode(symbol) {
	          var _a;
	          if ((_a = this.inner) == null ? void 0 : _a.trackExternalModuleSymbolOfImportTypeNode) {
	            this.onDiagnosticReported();
	            this.inner.trackExternalModuleSymbolOfImportTypeNode(symbol);
	          }
	        }
	        reportNonlocalAugmentation(containingFile, parentSymbol, augmentingSymbol) {
	          var _a;
	          if ((_a = this.inner) == null ? void 0 : _a.reportNonlocalAugmentation) {
	            this.onDiagnosticReported();
	            this.inner.reportNonlocalAugmentation(containingFile, parentSymbol, augmentingSymbol);
	          }
	        }
	        reportNonSerializableProperty(propertyName) {
	          var _a;
	          if ((_a = this.inner) == null ? void 0 : _a.reportNonSerializableProperty) {
	            this.onDiagnosticReported();
	            this.inner.reportNonSerializableProperty(propertyName);
	          }
	        }
	        onDiagnosticReported() {
	          this.context.reportedDiagnostic = true;
	        }
	      };
	    }
	  });

	  // src/compiler/visitorPublic.ts
	  function visitNode(node, visitor, test, lift) {
	    if (node === void 0) {
	      return node;
	    }
	    const visited = visitor(node);
	    let visitedNode;
	    if (visited === void 0) {
	      return void 0;
	    } else if (isArray(visited)) {
	      visitedNode = (lift || extractSingleNode)(visited);
	    } else {
	      visitedNode = visited;
	    }
	    Debug.assertNode(visitedNode, test);
	    return visitedNode;
	  }
	  function visitNodes2(nodes, visitor, test, start, count) {
	    if (nodes === void 0) {
	      return nodes;
	    }
	    const length2 = nodes.length;
	    if (start === void 0 || start < 0) {
	      start = 0;
	    }
	    if (count === void 0 || count > length2 - start) {
	      count = length2 - start;
	    }
	    let hasTrailingComma;
	    let pos = -1;
	    let end = -1;
	    if (start > 0 || count < length2) {
	      hasTrailingComma = nodes.hasTrailingComma && start + count === length2;
	    } else {
	      pos = nodes.pos;
	      end = nodes.end;
	      hasTrailingComma = nodes.hasTrailingComma;
	    }
	    const updated = visitArrayWorker(nodes, visitor, test, start, count);
	    if (updated !== nodes) {
	      const updatedArray = factory.createNodeArray(updated, hasTrailingComma);
	      setTextRangePosEnd(updatedArray, pos, end);
	      return updatedArray;
	    }
	    return nodes;
	  }
	  function visitArray(nodes, visitor, test, start, count) {
	    if (nodes === void 0) {
	      return nodes;
	    }
	    const length2 = nodes.length;
	    if (start === void 0 || start < 0) {
	      start = 0;
	    }
	    if (count === void 0 || count > length2 - start) {
	      count = length2 - start;
	    }
	    return visitArrayWorker(nodes, visitor, test, start, count);
	  }
	  function visitArrayWorker(nodes, visitor, test, start, count) {
	    let updated;
	    const length2 = nodes.length;
	    if (start > 0 || count < length2) {
	      updated = [];
	    }
	    for (let i = 0; i < count; i++) {
	      const node = nodes[i + start];
	      const visited = node !== void 0 ? visitor ? visitor(node) : node : void 0;
	      if (updated !== void 0 || visited === void 0 || visited !== node) {
	        if (updated === void 0) {
	          updated = nodes.slice(0, i);
	          Debug.assertEachNode(updated, test);
	        }
	        if (visited) {
	          if (isArray(visited)) {
	            for (const visitedNode of visited) {
	              Debug.assertNode(visitedNode, test);
	              updated.push(visitedNode);
	            }
	          } else {
	            Debug.assertNode(visited, test);
	            updated.push(visited);
	          }
	        }
	      }
	    }
	    if (updated) {
	      return updated;
	    }
	    Debug.assertEachNode(nodes, test);
	    return nodes;
	  }
	  function visitLexicalEnvironment(statements, visitor, context, start, ensureUseStrict, nodesVisitor = visitNodes2) {
	    context.startLexicalEnvironment();
	    statements = nodesVisitor(statements, visitor, isStatement, start);
	    if (ensureUseStrict)
	      statements = context.factory.ensureUseStrict(statements);
	    return factory.mergeLexicalEnvironment(statements, context.endLexicalEnvironment());
	  }
	  function visitParameterList(nodes, visitor, context, nodesVisitor = visitNodes2) {
	    let updated;
	    context.startLexicalEnvironment();
	    if (nodes) {
	      context.setLexicalEnvironmentFlags(1 /* InParameters */, true);
	      updated = nodesVisitor(nodes, visitor, isParameter);
	      if (context.getLexicalEnvironmentFlags() & 2 /* VariablesHoistedInParameters */ && getEmitScriptTarget(context.getCompilerOptions()) >= 2 /* ES2015 */) {
	        updated = addDefaultValueAssignmentsIfNeeded(updated, context);
	      }
	      context.setLexicalEnvironmentFlags(1 /* InParameters */, false);
	    }
	    context.suspendLexicalEnvironment();
	    return updated;
	  }
	  function addDefaultValueAssignmentsIfNeeded(parameters, context) {
	    let result;
	    for (let i = 0; i < parameters.length; i++) {
	      const parameter = parameters[i];
	      const updated = addDefaultValueAssignmentIfNeeded(parameter, context);
	      if (result || updated !== parameter) {
	        if (!result)
	          result = parameters.slice(0, i);
	        result[i] = updated;
	      }
	    }
	    if (result) {
	      return setTextRange(context.factory.createNodeArray(result, parameters.hasTrailingComma), parameters);
	    }
	    return parameters;
	  }
	  function addDefaultValueAssignmentIfNeeded(parameter, context) {
	    return parameter.dotDotDotToken ? parameter : isBindingPattern(parameter.name) ? addDefaultValueAssignmentForBindingPattern(parameter, context) : parameter.initializer ? addDefaultValueAssignmentForInitializer(parameter, parameter.name, parameter.initializer, context) : parameter;
	  }
	  function addDefaultValueAssignmentForBindingPattern(parameter, context) {
	    const { factory: factory2 } = context;
	    context.addInitializationStatement(
	      factory2.createVariableStatement(
	        /*modifiers*/
	        void 0,
	        factory2.createVariableDeclarationList([
	          factory2.createVariableDeclaration(
	            parameter.name,
	            /*exclamationToken*/
	            void 0,
	            parameter.type,
	            parameter.initializer ? factory2.createConditionalExpression(
	              factory2.createStrictEquality(
	                factory2.getGeneratedNameForNode(parameter),
	                factory2.createVoidZero()
	              ),
	              /*questionToken*/
	              void 0,
	              parameter.initializer,
	              /*colonToken*/
	              void 0,
	              factory2.getGeneratedNameForNode(parameter)
	            ) : factory2.getGeneratedNameForNode(parameter)
	          )
	        ])
	      )
	    );
	    return factory2.updateParameterDeclaration(
	      parameter,
	      parameter.modifiers,
	      parameter.dotDotDotToken,
	      factory2.getGeneratedNameForNode(parameter),
	      parameter.questionToken,
	      parameter.type,
	      /*initializer*/
	      void 0
	    );
	  }
	  function addDefaultValueAssignmentForInitializer(parameter, name, initializer, context) {
	    const factory2 = context.factory;
	    context.addInitializationStatement(
	      factory2.createIfStatement(
	        factory2.createTypeCheck(factory2.cloneNode(name), "undefined"),
	        setEmitFlags(
	          setTextRange(
	            factory2.createBlock([
	              factory2.createExpressionStatement(
	                setEmitFlags(
	                  setTextRange(
	                    factory2.createAssignment(
	                      setEmitFlags(factory2.cloneNode(name), 96 /* NoSourceMap */),
	                      setEmitFlags(initializer, 96 /* NoSourceMap */ | getEmitFlags(initializer) | 3072 /* NoComments */)
	                    ),
	                    parameter
	                  ),
	                  3072 /* NoComments */
	                )
	              )
	            ]),
	            parameter
	          ),
	          1 /* SingleLine */ | 64 /* NoTrailingSourceMap */ | 768 /* NoTokenSourceMaps */ | 3072 /* NoComments */
	        )
	      )
	    );
	    return factory2.updateParameterDeclaration(
	      parameter,
	      parameter.modifiers,
	      parameter.dotDotDotToken,
	      parameter.name,
	      parameter.questionToken,
	      parameter.type,
	      /*initializer*/
	      void 0
	    );
	  }
	  function visitFunctionBody(node, visitor, context, nodeVisitor = visitNode) {
	    context.resumeLexicalEnvironment();
	    const updated = nodeVisitor(node, visitor, isConciseBody);
	    const declarations = context.endLexicalEnvironment();
	    if (some(declarations)) {
	      if (!updated) {
	        return context.factory.createBlock(declarations);
	      }
	      const block = context.factory.converters.convertToFunctionBlock(updated);
	      const statements = factory.mergeLexicalEnvironment(block.statements, declarations);
	      return context.factory.updateBlock(block, statements);
	    }
	    return updated;
	  }
	  function visitIterationBody(body, visitor, context, nodeVisitor = visitNode) {
	    context.startBlockScope();
	    const updated = nodeVisitor(body, visitor, isStatement, context.factory.liftToBlock);
	    Debug.assert(updated);
	    const declarations = context.endBlockScope();
	    if (some(declarations)) {
	      if (isBlock(updated)) {
	        declarations.push(...updated.statements);
	        return context.factory.updateBlock(updated, declarations);
	      }
	      declarations.push(updated);
	      return context.factory.createBlock(declarations);
	    }
	    return updated;
	  }
	  function visitCommaListElements(elements, visitor, discardVisitor = visitor) {
	    if (discardVisitor === visitor || elements.length <= 1) {
	      return visitNodes2(elements, visitor, isExpression);
	    }
	    let i = 0;
	    const length2 = elements.length;
	    return visitNodes2(elements, (node) => {
	      const discarded = i < length2 - 1;
	      i++;
	      return discarded ? discardVisitor(node) : visitor(node);
	    }, isExpression);
	  }
	  function visitEachChild(node, visitor, context = nullTransformationContext, nodesVisitor = visitNodes2, tokenVisitor, nodeVisitor = visitNode) {
	    if (node === void 0) {
	      return void 0;
	    }
	    const fn = visitEachChildTable[node.kind];
	    return fn === void 0 ? node : fn(node, visitor, context, nodesVisitor, nodeVisitor, tokenVisitor);
	  }
	  function extractSingleNode(nodes) {
	    Debug.assert(nodes.length <= 1, "Too many nodes written to output.");
	    return singleOrUndefined(nodes);
	  }
	  var visitEachChildTable;
	  var init_visitorPublic = __esm({
	    "src/compiler/visitorPublic.ts"() {
	      init_ts2();
	      visitEachChildTable = {
	        [166 /* QualifiedName */]: function visitEachChildOfQualifiedName(node, visitor, context, _nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateQualifiedName(
	            node,
	            Debug.checkDefined(nodeVisitor(node.left, visitor, isEntityName)),
	            Debug.checkDefined(nodeVisitor(node.right, visitor, isIdentifier))
	          );
	        },
	        [167 /* ComputedPropertyName */]: function visitEachChildOfComputedPropertyName(node, visitor, context, _nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateComputedPropertyName(
	            node,
	            Debug.checkDefined(nodeVisitor(node.expression, visitor, isExpression))
	          );
	        },
	        // Signature elements
	        [168 /* TypeParameter */]: function visitEachChildOfTypeParameterDeclaration(node, visitor, context, nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateTypeParameterDeclaration(
	            node,
	            nodesVisitor(node.modifiers, visitor, isModifier),
	            Debug.checkDefined(nodeVisitor(node.name, visitor, isIdentifier)),
	            nodeVisitor(node.constraint, visitor, isTypeNode),
	            nodeVisitor(node.default, visitor, isTypeNode)
	          );
	        },
	        [169 /* Parameter */]: function visitEachChildOfParameterDeclaration(node, visitor, context, nodesVisitor, nodeVisitor, tokenVisitor) {
	          return context.factory.updateParameterDeclaration(
	            node,
	            nodesVisitor(node.modifiers, visitor, isModifierLike),
	            tokenVisitor ? nodeVisitor(node.dotDotDotToken, tokenVisitor, isDotDotDotToken) : node.dotDotDotToken,
	            Debug.checkDefined(nodeVisitor(node.name, visitor, isBindingName)),
	            tokenVisitor ? nodeVisitor(node.questionToken, tokenVisitor, isQuestionToken) : node.questionToken,
	            nodeVisitor(node.type, visitor, isTypeNode),
	            nodeVisitor(node.initializer, visitor, isExpression)
	          );
	        },
	        [170 /* Decorator */]: function visitEachChildOfDecorator(node, visitor, context, _nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateDecorator(
	            node,
	            Debug.checkDefined(nodeVisitor(node.expression, visitor, isExpression))
	          );
	        },
	        // Type elements
	        [171 /* PropertySignature */]: function visitEachChildOfPropertySignature(node, visitor, context, nodesVisitor, nodeVisitor, tokenVisitor) {
	          return context.factory.updatePropertySignature(
	            node,
	            nodesVisitor(node.modifiers, visitor, isModifier),
	            Debug.checkDefined(nodeVisitor(node.name, visitor, isPropertyName)),
	            tokenVisitor ? nodeVisitor(node.questionToken, tokenVisitor, isQuestionToken) : node.questionToken,
	            nodeVisitor(node.type, visitor, isTypeNode)
	          );
	        },
	        [172 /* PropertyDeclaration */]: function visitEachChildOfPropertyDeclaration(node, visitor, context, nodesVisitor, nodeVisitor, tokenVisitor) {
	          return context.factory.updatePropertyDeclaration(
	            node,
	            nodesVisitor(node.modifiers, visitor, isModifierLike),
	            Debug.checkDefined(nodeVisitor(node.name, visitor, isPropertyName)),
	            // QuestionToken and ExclamationToken are mutually exclusive in PropertyDeclaration
	            tokenVisitor ? nodeVisitor(node.questionToken ?? node.exclamationToken, tokenVisitor, isQuestionOrExclamationToken) : node.questionToken ?? node.exclamationToken,
	            nodeVisitor(node.type, visitor, isTypeNode),
	            nodeVisitor(node.initializer, visitor, isExpression)
	          );
	        },
	        [173 /* MethodSignature */]: function visitEachChildOfMethodSignature(node, visitor, context, nodesVisitor, nodeVisitor, tokenVisitor) {
	          return context.factory.updateMethodSignature(
	            node,
	            nodesVisitor(node.modifiers, visitor, isModifier),
	            Debug.checkDefined(nodeVisitor(node.name, visitor, isPropertyName)),
	            tokenVisitor ? nodeVisitor(node.questionToken, tokenVisitor, isQuestionToken) : node.questionToken,
	            nodesVisitor(node.typeParameters, visitor, isTypeParameterDeclaration),
	            nodesVisitor(node.parameters, visitor, isParameter),
	            nodeVisitor(node.type, visitor, isTypeNode)
	          );
	        },
	        [174 /* MethodDeclaration */]: function visitEachChildOfMethodDeclaration(node, visitor, context, nodesVisitor, nodeVisitor, tokenVisitor) {
	          return context.factory.updateMethodDeclaration(
	            node,
	            nodesVisitor(node.modifiers, visitor, isModifierLike),
	            tokenVisitor ? nodeVisitor(node.asteriskToken, tokenVisitor, isAsteriskToken) : node.asteriskToken,
	            Debug.checkDefined(nodeVisitor(node.name, visitor, isPropertyName)),
	            tokenVisitor ? nodeVisitor(node.questionToken, tokenVisitor, isQuestionToken) : node.questionToken,
	            nodesVisitor(node.typeParameters, visitor, isTypeParameterDeclaration),
	            visitParameterList(node.parameters, visitor, context, nodesVisitor),
	            nodeVisitor(node.type, visitor, isTypeNode),
	            visitFunctionBody(node.body, visitor, context, nodeVisitor)
	          );
	        },
	        [176 /* Constructor */]: function visitEachChildOfConstructorDeclaration(node, visitor, context, nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateConstructorDeclaration(
	            node,
	            nodesVisitor(node.modifiers, visitor, isModifierLike),
	            visitParameterList(node.parameters, visitor, context, nodesVisitor),
	            visitFunctionBody(node.body, visitor, context, nodeVisitor)
	          );
	        },
	        [177 /* GetAccessor */]: function visitEachChildOfGetAccessorDeclaration(node, visitor, context, nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateGetAccessorDeclaration(
	            node,
	            nodesVisitor(node.modifiers, visitor, isModifierLike),
	            Debug.checkDefined(nodeVisitor(node.name, visitor, isPropertyName)),
	            visitParameterList(node.parameters, visitor, context, nodesVisitor),
	            nodeVisitor(node.type, visitor, isTypeNode),
	            visitFunctionBody(node.body, visitor, context, nodeVisitor)
	          );
	        },
	        [178 /* SetAccessor */]: function visitEachChildOfSetAccessorDeclaration(node, visitor, context, nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateSetAccessorDeclaration(
	            node,
	            nodesVisitor(node.modifiers, visitor, isModifierLike),
	            Debug.checkDefined(nodeVisitor(node.name, visitor, isPropertyName)),
	            visitParameterList(node.parameters, visitor, context, nodesVisitor),
	            visitFunctionBody(node.body, visitor, context, nodeVisitor)
	          );
	        },
	        [175 /* ClassStaticBlockDeclaration */]: function visitEachChildOfClassStaticBlockDeclaration(node, visitor, context, _nodesVisitor, nodeVisitor, _tokenVisitor) {
	          context.startLexicalEnvironment();
	          context.suspendLexicalEnvironment();
	          return context.factory.updateClassStaticBlockDeclaration(
	            node,
	            visitFunctionBody(node.body, visitor, context, nodeVisitor)
	          );
	        },
	        [179 /* CallSignature */]: function visitEachChildOfCallSignatureDeclaration(node, visitor, context, nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateCallSignature(
	            node,
	            nodesVisitor(node.typeParameters, visitor, isTypeParameterDeclaration),
	            nodesVisitor(node.parameters, visitor, isParameter),
	            nodeVisitor(node.type, visitor, isTypeNode)
	          );
	        },
	        [180 /* ConstructSignature */]: function visitEachChildOfConstructSignatureDeclaration(node, visitor, context, nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateConstructSignature(
	            node,
	            nodesVisitor(node.typeParameters, visitor, isTypeParameterDeclaration),
	            nodesVisitor(node.parameters, visitor, isParameter),
	            nodeVisitor(node.type, visitor, isTypeNode)
	          );
	        },
	        [181 /* IndexSignature */]: function visitEachChildOfIndexSignatureDeclaration(node, visitor, context, nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateIndexSignature(
	            node,
	            nodesVisitor(node.modifiers, visitor, isModifierLike),
	            nodesVisitor(node.parameters, visitor, isParameter),
	            Debug.checkDefined(nodeVisitor(node.type, visitor, isTypeNode))
	          );
	        },
	        // Types
	        [182 /* TypePredicate */]: function visitEachChildOfTypePredicateNode(node, visitor, context, _nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateTypePredicateNode(
	            node,
	            nodeVisitor(node.assertsModifier, visitor, isAssertsKeyword),
	            Debug.checkDefined(nodeVisitor(node.parameterName, visitor, isIdentifierOrThisTypeNode)),
	            nodeVisitor(node.type, visitor, isTypeNode)
	          );
	        },
	        [183 /* TypeReference */]: function visitEachChildOfTypeReferenceNode(node, visitor, context, nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateTypeReferenceNode(
	            node,
	            Debug.checkDefined(nodeVisitor(node.typeName, visitor, isEntityName)),
	            nodesVisitor(node.typeArguments, visitor, isTypeNode)
	          );
	        },
	        [184 /* FunctionType */]: function visitEachChildOfFunctionTypeNode(node, visitor, context, nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateFunctionTypeNode(
	            node,
	            nodesVisitor(node.typeParameters, visitor, isTypeParameterDeclaration),
	            nodesVisitor(node.parameters, visitor, isParameter),
	            Debug.checkDefined(nodeVisitor(node.type, visitor, isTypeNode))
	          );
	        },
	        [185 /* ConstructorType */]: function visitEachChildOfConstructorTypeNode(node, visitor, context, nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateConstructorTypeNode(
	            node,
	            nodesVisitor(node.modifiers, visitor, isModifier),
	            nodesVisitor(node.typeParameters, visitor, isTypeParameterDeclaration),
	            nodesVisitor(node.parameters, visitor, isParameter),
	            Debug.checkDefined(nodeVisitor(node.type, visitor, isTypeNode))
	          );
	        },
	        [186 /* TypeQuery */]: function visitEachChildOfTypeQueryNode(node, visitor, context, nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateTypeQueryNode(
	            node,
	            Debug.checkDefined(nodeVisitor(node.exprName, visitor, isEntityName)),
	            nodesVisitor(node.typeArguments, visitor, isTypeNode)
	          );
	        },
	        [187 /* TypeLiteral */]: function visitEachChildOfTypeLiteralNode(node, visitor, context, nodesVisitor, _nodeVisitor, _tokenVisitor) {
	          return context.factory.updateTypeLiteralNode(
	            node,
	            nodesVisitor(node.members, visitor, isTypeElement)
	          );
	        },
	        [188 /* ArrayType */]: function visitEachChildOfArrayTypeNode(node, visitor, context, _nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateArrayTypeNode(
	            node,
	            Debug.checkDefined(nodeVisitor(node.elementType, visitor, isTypeNode))
	          );
	        },
	        [189 /* TupleType */]: function visitEachChildOfTupleTypeNode(node, visitor, context, nodesVisitor, _nodeVisitor, _tokenVisitor) {
	          return context.factory.updateTupleTypeNode(
	            node,
	            nodesVisitor(node.elements, visitor, isTypeNode)
	          );
	        },
	        [190 /* OptionalType */]: function visitEachChildOfOptionalTypeNode(node, visitor, context, _nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateOptionalTypeNode(
	            node,
	            Debug.checkDefined(nodeVisitor(node.type, visitor, isTypeNode))
	          );
	        },
	        [191 /* RestType */]: function visitEachChildOfRestTypeNode(node, visitor, context, _nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateRestTypeNode(
	            node,
	            Debug.checkDefined(nodeVisitor(node.type, visitor, isTypeNode))
	          );
	        },
	        [192 /* UnionType */]: function visitEachChildOfUnionTypeNode(node, visitor, context, nodesVisitor, _nodeVisitor, _tokenVisitor) {
	          return context.factory.updateUnionTypeNode(
	            node,
	            nodesVisitor(node.types, visitor, isTypeNode)
	          );
	        },
	        [193 /* IntersectionType */]: function visitEachChildOfIntersectionTypeNode(node, visitor, context, nodesVisitor, _nodeVisitor, _tokenVisitor) {
	          return context.factory.updateIntersectionTypeNode(
	            node,
	            nodesVisitor(node.types, visitor, isTypeNode)
	          );
	        },
	        [194 /* ConditionalType */]: function visitEachChildOfConditionalTypeNode(node, visitor, context, _nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateConditionalTypeNode(
	            node,
	            Debug.checkDefined(nodeVisitor(node.checkType, visitor, isTypeNode)),
	            Debug.checkDefined(nodeVisitor(node.extendsType, visitor, isTypeNode)),
	            Debug.checkDefined(nodeVisitor(node.trueType, visitor, isTypeNode)),
	            Debug.checkDefined(nodeVisitor(node.falseType, visitor, isTypeNode))
	          );
	        },
	        [195 /* InferType */]: function visitEachChildOfInferTypeNode(node, visitor, context, _nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateInferTypeNode(
	            node,
	            Debug.checkDefined(nodeVisitor(node.typeParameter, visitor, isTypeParameterDeclaration))
	          );
	        },
	        [205 /* ImportType */]: function visitEachChildOfImportTypeNode(node, visitor, context, nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateImportTypeNode(
	            node,
	            Debug.checkDefined(nodeVisitor(node.argument, visitor, isTypeNode)),
	            nodeVisitor(node.attributes, visitor, isImportAttributes),
	            nodeVisitor(node.qualifier, visitor, isEntityName),
	            nodesVisitor(node.typeArguments, visitor, isTypeNode),
	            node.isTypeOf
	          );
	        },
	        [302 /* ImportTypeAssertionContainer */]: function visitEachChildOfImportTypeAssertionContainer(node, visitor, context, _nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateImportTypeAssertionContainer(
	            node,
	            Debug.checkDefined(nodeVisitor(node.assertClause, visitor, isAssertClause)),
	            node.multiLine
	          );
	        },
	        [202 /* NamedTupleMember */]: function visitEachChildOfNamedTupleMember(node, visitor, context, _nodesVisitor, nodeVisitor, tokenVisitor) {
	          return context.factory.updateNamedTupleMember(
	            node,
	            tokenVisitor ? nodeVisitor(node.dotDotDotToken, tokenVisitor, isDotDotDotToken) : node.dotDotDotToken,
	            Debug.checkDefined(nodeVisitor(node.name, visitor, isIdentifier)),
	            tokenVisitor ? nodeVisitor(node.questionToken, tokenVisitor, isQuestionToken) : node.questionToken,
	            Debug.checkDefined(nodeVisitor(node.type, visitor, isTypeNode))
	          );
	        },
	        [196 /* ParenthesizedType */]: function visitEachChildOfParenthesizedType(node, visitor, context, _nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateParenthesizedType(
	            node,
	            Debug.checkDefined(nodeVisitor(node.type, visitor, isTypeNode))
	          );
	        },
	        [198 /* TypeOperator */]: function visitEachChildOfTypeOperatorNode(node, visitor, context, _nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateTypeOperatorNode(
	            node,
	            Debug.checkDefined(nodeVisitor(node.type, visitor, isTypeNode))
	          );
	        },
	        [199 /* IndexedAccessType */]: function visitEachChildOfIndexedAccessType(node, visitor, context, _nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateIndexedAccessTypeNode(
	            node,
	            Debug.checkDefined(nodeVisitor(node.objectType, visitor, isTypeNode)),
	            Debug.checkDefined(nodeVisitor(node.indexType, visitor, isTypeNode))
	          );
	        },
	        [200 /* MappedType */]: function visitEachChildOfMappedType(node, visitor, context, nodesVisitor, nodeVisitor, tokenVisitor) {
	          return context.factory.updateMappedTypeNode(
	            node,
	            tokenVisitor ? nodeVisitor(node.readonlyToken, tokenVisitor, isReadonlyKeywordOrPlusOrMinusToken) : node.readonlyToken,
	            Debug.checkDefined(nodeVisitor(node.typeParameter, visitor, isTypeParameterDeclaration)),
	            nodeVisitor(node.nameType, visitor, isTypeNode),
	            tokenVisitor ? nodeVisitor(node.questionToken, tokenVisitor, isQuestionOrPlusOrMinusToken) : node.questionToken,
	            nodeVisitor(node.type, visitor, isTypeNode),
	            nodesVisitor(node.members, visitor, isTypeElement)
	          );
	        },
	        [201 /* LiteralType */]: function visitEachChildOfLiteralTypeNode(node, visitor, context, _nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateLiteralTypeNode(
	            node,
	            Debug.checkDefined(nodeVisitor(node.literal, visitor, isLiteralTypeLiteral))
	          );
	        },
	        [203 /* TemplateLiteralType */]: function visitEachChildOfTemplateLiteralType(node, visitor, context, nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateTemplateLiteralType(
	            node,
	            Debug.checkDefined(nodeVisitor(node.head, visitor, isTemplateHead)),
	            nodesVisitor(node.templateSpans, visitor, isTemplateLiteralTypeSpan)
	          );
	        },
	        [204 /* TemplateLiteralTypeSpan */]: function visitEachChildOfTemplateLiteralTypeSpan(node, visitor, context, _nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateTemplateLiteralTypeSpan(
	            node,
	            Debug.checkDefined(nodeVisitor(node.type, visitor, isTypeNode)),
	            Debug.checkDefined(nodeVisitor(node.literal, visitor, isTemplateMiddleOrTemplateTail))
	          );
	        },
	        // Binding patterns
	        [206 /* ObjectBindingPattern */]: function visitEachChildOfObjectBindingPattern(node, visitor, context, nodesVisitor, _nodeVisitor, _tokenVisitor) {
	          return context.factory.updateObjectBindingPattern(
	            node,
	            nodesVisitor(node.elements, visitor, isBindingElement)
	          );
	        },
	        [207 /* ArrayBindingPattern */]: function visitEachChildOfArrayBindingPattern(node, visitor, context, nodesVisitor, _nodeVisitor, _tokenVisitor) {
	          return context.factory.updateArrayBindingPattern(
	            node,
	            nodesVisitor(node.elements, visitor, isArrayBindingElement)
	          );
	        },
	        [208 /* BindingElement */]: function visitEachChildOfBindingElement(node, visitor, context, _nodesVisitor, nodeVisitor, tokenVisitor) {
	          return context.factory.updateBindingElement(
	            node,
	            tokenVisitor ? nodeVisitor(node.dotDotDotToken, tokenVisitor, isDotDotDotToken) : node.dotDotDotToken,
	            nodeVisitor(node.propertyName, visitor, isPropertyName),
	            Debug.checkDefined(nodeVisitor(node.name, visitor, isBindingName)),
	            nodeVisitor(node.initializer, visitor, isExpression)
	          );
	        },
	        // Expression
	        [209 /* ArrayLiteralExpression */]: function visitEachChildOfArrayLiteralExpression(node, visitor, context, nodesVisitor, _nodeVisitor, _tokenVisitor) {
	          return context.factory.updateArrayLiteralExpression(
	            node,
	            nodesVisitor(node.elements, visitor, isExpression)
	          );
	        },
	        [210 /* ObjectLiteralExpression */]: function visitEachChildOfObjectLiteralExpression(node, visitor, context, nodesVisitor, _nodeVisitor, _tokenVisitor) {
	          return context.factory.updateObjectLiteralExpression(
	            node,
	            nodesVisitor(node.properties, visitor, isObjectLiteralElementLike)
	          );
	        },
	        [211 /* PropertyAccessExpression */]: function visitEachChildOfPropertyAccessExpression(node, visitor, context, _nodesVisitor, nodeVisitor, tokenVisitor) {
	          return isPropertyAccessChain(node) ? context.factory.updatePropertyAccessChain(
	            node,
	            Debug.checkDefined(nodeVisitor(node.expression, visitor, isExpression)),
	            tokenVisitor ? nodeVisitor(node.questionDotToken, tokenVisitor, isQuestionDotToken) : node.questionDotToken,
	            Debug.checkDefined(nodeVisitor(node.name, visitor, isMemberName))
	          ) : context.factory.updatePropertyAccessExpression(
	            node,
	            Debug.checkDefined(nodeVisitor(node.expression, visitor, isExpression)),
	            Debug.checkDefined(nodeVisitor(node.name, visitor, isMemberName))
	          );
	        },
	        [212 /* ElementAccessExpression */]: function visitEachChildOfElementAccessExpression(node, visitor, context, _nodesVisitor, nodeVisitor, tokenVisitor) {
	          return isElementAccessChain(node) ? context.factory.updateElementAccessChain(
	            node,
	            Debug.checkDefined(nodeVisitor(node.expression, visitor, isExpression)),
	            tokenVisitor ? nodeVisitor(node.questionDotToken, tokenVisitor, isQuestionDotToken) : node.questionDotToken,
	            Debug.checkDefined(nodeVisitor(node.argumentExpression, visitor, isExpression))
	          ) : context.factory.updateElementAccessExpression(
	            node,
	            Debug.checkDefined(nodeVisitor(node.expression, visitor, isExpression)),
	            Debug.checkDefined(nodeVisitor(node.argumentExpression, visitor, isExpression))
	          );
	        },
	        [213 /* CallExpression */]: function visitEachChildOfCallExpression(node, visitor, context, nodesVisitor, nodeVisitor, tokenVisitor) {
	          return isCallChain(node) ? context.factory.updateCallChain(
	            node,
	            Debug.checkDefined(nodeVisitor(node.expression, visitor, isExpression)),
	            tokenVisitor ? nodeVisitor(node.questionDotToken, tokenVisitor, isQuestionDotToken) : node.questionDotToken,
	            nodesVisitor(node.typeArguments, visitor, isTypeNode),
	            nodesVisitor(node.arguments, visitor, isExpression)
	          ) : context.factory.updateCallExpression(
	            node,
	            Debug.checkDefined(nodeVisitor(node.expression, visitor, isExpression)),
	            nodesVisitor(node.typeArguments, visitor, isTypeNode),
	            nodesVisitor(node.arguments, visitor, isExpression)
	          );
	        },
	        [214 /* NewExpression */]: function visitEachChildOfNewExpression(node, visitor, context, nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateNewExpression(
	            node,
	            Debug.checkDefined(nodeVisitor(node.expression, visitor, isExpression)),
	            nodesVisitor(node.typeArguments, visitor, isTypeNode),
	            nodesVisitor(node.arguments, visitor, isExpression)
	          );
	        },
	        [215 /* TaggedTemplateExpression */]: function visitEachChildOfTaggedTemplateExpression(node, visitor, context, nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateTaggedTemplateExpression(
	            node,
	            Debug.checkDefined(nodeVisitor(node.tag, visitor, isExpression)),
	            nodesVisitor(node.typeArguments, visitor, isTypeNode),
	            Debug.checkDefined(nodeVisitor(node.template, visitor, isTemplateLiteral))
	          );
	        },
	        [216 /* TypeAssertionExpression */]: function visitEachChildOfTypeAssertionExpression(node, visitor, context, _nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateTypeAssertion(
	            node,
	            Debug.checkDefined(nodeVisitor(node.type, visitor, isTypeNode)),
	            Debug.checkDefined(nodeVisitor(node.expression, visitor, isExpression))
	          );
	        },
	        [217 /* ParenthesizedExpression */]: function visitEachChildOfParenthesizedExpression(node, visitor, context, _nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateParenthesizedExpression(
	            node,
	            Debug.checkDefined(nodeVisitor(node.expression, visitor, isExpression))
	          );
	        },
	        [218 /* FunctionExpression */]: function visitEachChildOfFunctionExpression(node, visitor, context, nodesVisitor, nodeVisitor, tokenVisitor) {
	          return context.factory.updateFunctionExpression(
	            node,
	            nodesVisitor(node.modifiers, visitor, isModifier),
	            tokenVisitor ? nodeVisitor(node.asteriskToken, tokenVisitor, isAsteriskToken) : node.asteriskToken,
	            nodeVisitor(node.name, visitor, isIdentifier),
	            nodesVisitor(node.typeParameters, visitor, isTypeParameterDeclaration),
	            visitParameterList(node.parameters, visitor, context, nodesVisitor),
	            nodeVisitor(node.type, visitor, isTypeNode),
	            visitFunctionBody(node.body, visitor, context, nodeVisitor)
	          );
	        },
	        [219 /* ArrowFunction */]: function visitEachChildOfArrowFunction(node, visitor, context, nodesVisitor, nodeVisitor, tokenVisitor) {
	          return context.factory.updateArrowFunction(
	            node,
	            nodesVisitor(node.modifiers, visitor, isModifier),
	            nodesVisitor(node.typeParameters, visitor, isTypeParameterDeclaration),
	            visitParameterList(node.parameters, visitor, context, nodesVisitor),
	            nodeVisitor(node.type, visitor, isTypeNode),
	            tokenVisitor ? Debug.checkDefined(nodeVisitor(node.equalsGreaterThanToken, tokenVisitor, isEqualsGreaterThanToken)) : node.equalsGreaterThanToken,
	            visitFunctionBody(node.body, visitor, context, nodeVisitor)
	          );
	        },
	        [220 /* DeleteExpression */]: function visitEachChildOfDeleteExpression(node, visitor, context, _nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateDeleteExpression(
	            node,
	            Debug.checkDefined(nodeVisitor(node.expression, visitor, isExpression))
	          );
	        },
	        [221 /* TypeOfExpression */]: function visitEachChildOfTypeOfExpression(node, visitor, context, _nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateTypeOfExpression(
	            node,
	            Debug.checkDefined(nodeVisitor(node.expression, visitor, isExpression))
	          );
	        },
	        [222 /* VoidExpression */]: function visitEachChildOfVoidExpression(node, visitor, context, _nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateVoidExpression(
	            node,
	            Debug.checkDefined(nodeVisitor(node.expression, visitor, isExpression))
	          );
	        },
	        [223 /* AwaitExpression */]: function visitEachChildOfAwaitExpression(node, visitor, context, _nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateAwaitExpression(
	            node,
	            Debug.checkDefined(nodeVisitor(node.expression, visitor, isExpression))
	          );
	        },
	        [224 /* PrefixUnaryExpression */]: function visitEachChildOfPrefixUnaryExpression(node, visitor, context, _nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updatePrefixUnaryExpression(
	            node,
	            Debug.checkDefined(nodeVisitor(node.operand, visitor, isExpression))
	          );
	        },
	        [225 /* PostfixUnaryExpression */]: function visitEachChildOfPostfixUnaryExpression(node, visitor, context, _nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updatePostfixUnaryExpression(
	            node,
	            Debug.checkDefined(nodeVisitor(node.operand, visitor, isExpression))
	          );
	        },
	        [226 /* BinaryExpression */]: function visitEachChildOfBinaryExpression(node, visitor, context, _nodesVisitor, nodeVisitor, tokenVisitor) {
	          return context.factory.updateBinaryExpression(
	            node,
	            Debug.checkDefined(nodeVisitor(node.left, visitor, isExpression)),
	            tokenVisitor ? Debug.checkDefined(nodeVisitor(node.operatorToken, tokenVisitor, isBinaryOperatorToken)) : node.operatorToken,
	            Debug.checkDefined(nodeVisitor(node.right, visitor, isExpression))
	          );
	        },
	        [227 /* ConditionalExpression */]: function visitEachChildOfConditionalExpression(node, visitor, context, _nodesVisitor, nodeVisitor, tokenVisitor) {
	          return context.factory.updateConditionalExpression(
	            node,
	            Debug.checkDefined(nodeVisitor(node.condition, visitor, isExpression)),
	            tokenVisitor ? Debug.checkDefined(nodeVisitor(node.questionToken, tokenVisitor, isQuestionToken)) : node.questionToken,
	            Debug.checkDefined(nodeVisitor(node.whenTrue, visitor, isExpression)),
	            tokenVisitor ? Debug.checkDefined(nodeVisitor(node.colonToken, tokenVisitor, isColonToken)) : node.colonToken,
	            Debug.checkDefined(nodeVisitor(node.whenFalse, visitor, isExpression))
	          );
	        },
	        [228 /* TemplateExpression */]: function visitEachChildOfTemplateExpression(node, visitor, context, nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateTemplateExpression(
	            node,
	            Debug.checkDefined(nodeVisitor(node.head, visitor, isTemplateHead)),
	            nodesVisitor(node.templateSpans, visitor, isTemplateSpan)
	          );
	        },
	        [229 /* YieldExpression */]: function visitEachChildOfYieldExpression(node, visitor, context, _nodesVisitor, nodeVisitor, tokenVisitor) {
	          return context.factory.updateYieldExpression(
	            node,
	            tokenVisitor ? nodeVisitor(node.asteriskToken, tokenVisitor, isAsteriskToken) : node.asteriskToken,
	            nodeVisitor(node.expression, visitor, isExpression)
	          );
	        },
	        [230 /* SpreadElement */]: function visitEachChildOfSpreadElement(node, visitor, context, _nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateSpreadElement(
	            node,
	            Debug.checkDefined(nodeVisitor(node.expression, visitor, isExpression))
	          );
	        },
	        [231 /* ClassExpression */]: function visitEachChildOfClassExpression(node, visitor, context, nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateClassExpression(
	            node,
	            nodesVisitor(node.modifiers, visitor, isModifierLike),
	            nodeVisitor(node.name, visitor, isIdentifier),
	            nodesVisitor(node.typeParameters, visitor, isTypeParameterDeclaration),
	            nodesVisitor(node.heritageClauses, visitor, isHeritageClause),
	            nodesVisitor(node.members, visitor, isClassElement)
	          );
	        },
	        [233 /* ExpressionWithTypeArguments */]: function visitEachChildOfExpressionWithTypeArguments(node, visitor, context, nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateExpressionWithTypeArguments(
	            node,
	            Debug.checkDefined(nodeVisitor(node.expression, visitor, isExpression)),
	            nodesVisitor(node.typeArguments, visitor, isTypeNode)
	          );
	        },
	        [234 /* AsExpression */]: function visitEachChildOfAsExpression(node, visitor, context, _nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateAsExpression(
	            node,
	            Debug.checkDefined(nodeVisitor(node.expression, visitor, isExpression)),
	            Debug.checkDefined(nodeVisitor(node.type, visitor, isTypeNode))
	          );
	        },
	        [238 /* SatisfiesExpression */]: function visitEachChildOfSatisfiesExpression(node, visitor, context, _nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateSatisfiesExpression(
	            node,
	            Debug.checkDefined(nodeVisitor(node.expression, visitor, isExpression)),
	            Debug.checkDefined(nodeVisitor(node.type, visitor, isTypeNode))
	          );
	        },
	        [235 /* NonNullExpression */]: function visitEachChildOfNonNullExpression(node, visitor, context, _nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return isOptionalChain(node) ? context.factory.updateNonNullChain(
	            node,
	            Debug.checkDefined(nodeVisitor(node.expression, visitor, isExpression))
	          ) : context.factory.updateNonNullExpression(
	            node,
	            Debug.checkDefined(nodeVisitor(node.expression, visitor, isExpression))
	          );
	        },
	        [236 /* MetaProperty */]: function visitEachChildOfMetaProperty(node, visitor, context, _nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateMetaProperty(
	            node,
	            Debug.checkDefined(nodeVisitor(node.name, visitor, isIdentifier))
	          );
	        },
	        // Misc
	        [239 /* TemplateSpan */]: function visitEachChildOfTemplateSpan(node, visitor, context, _nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateTemplateSpan(
	            node,
	            Debug.checkDefined(nodeVisitor(node.expression, visitor, isExpression)),
	            Debug.checkDefined(nodeVisitor(node.literal, visitor, isTemplateMiddleOrTemplateTail))
	          );
	        },
	        // Element
	        [241 /* Block */]: function visitEachChildOfBlock(node, visitor, context, nodesVisitor, _nodeVisitor, _tokenVisitor) {
	          return context.factory.updateBlock(
	            node,
	            nodesVisitor(node.statements, visitor, isStatement)
	          );
	        },
	        [243 /* VariableStatement */]: function visitEachChildOfVariableStatement(node, visitor, context, nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateVariableStatement(
	            node,
	            nodesVisitor(node.modifiers, visitor, isModifierLike),
	            Debug.checkDefined(nodeVisitor(node.declarationList, visitor, isVariableDeclarationList))
	          );
	        },
	        [244 /* ExpressionStatement */]: function visitEachChildOfExpressionStatement(node, visitor, context, _nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateExpressionStatement(
	            node,
	            Debug.checkDefined(nodeVisitor(node.expression, visitor, isExpression))
	          );
	        },
	        [245 /* IfStatement */]: function visitEachChildOfIfStatement(node, visitor, context, _nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateIfStatement(
	            node,
	            Debug.checkDefined(nodeVisitor(node.expression, visitor, isExpression)),
	            Debug.checkDefined(nodeVisitor(node.thenStatement, visitor, isStatement, context.factory.liftToBlock)),
	            nodeVisitor(node.elseStatement, visitor, isStatement, context.factory.liftToBlock)
	          );
	        },
	        [246 /* DoStatement */]: function visitEachChildOfDoStatement(node, visitor, context, _nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateDoStatement(
	            node,
	            visitIterationBody(node.statement, visitor, context, nodeVisitor),
	            Debug.checkDefined(nodeVisitor(node.expression, visitor, isExpression))
	          );
	        },
	        [247 /* WhileStatement */]: function visitEachChildOfWhileStatement(node, visitor, context, _nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateWhileStatement(
	            node,
	            Debug.checkDefined(nodeVisitor(node.expression, visitor, isExpression)),
	            visitIterationBody(node.statement, visitor, context, nodeVisitor)
	          );
	        },
	        [248 /* ForStatement */]: function visitEachChildOfForStatement(node, visitor, context, _nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateForStatement(
	            node,
	            nodeVisitor(node.initializer, visitor, isForInitializer),
	            nodeVisitor(node.condition, visitor, isExpression),
	            nodeVisitor(node.incrementor, visitor, isExpression),
	            visitIterationBody(node.statement, visitor, context, nodeVisitor)
	          );
	        },
	        [249 /* ForInStatement */]: function visitEachChildOfForInStatement(node, visitor, context, _nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateForInStatement(
	            node,
	            Debug.checkDefined(nodeVisitor(node.initializer, visitor, isForInitializer)),
	            Debug.checkDefined(nodeVisitor(node.expression, visitor, isExpression)),
	            visitIterationBody(node.statement, visitor, context, nodeVisitor)
	          );
	        },
	        [250 /* ForOfStatement */]: function visitEachChildOfForOfStatement(node, visitor, context, _nodesVisitor, nodeVisitor, tokenVisitor) {
	          return context.factory.updateForOfStatement(
	            node,
	            tokenVisitor ? nodeVisitor(node.awaitModifier, tokenVisitor, isAwaitKeyword) : node.awaitModifier,
	            Debug.checkDefined(nodeVisitor(node.initializer, visitor, isForInitializer)),
	            Debug.checkDefined(nodeVisitor(node.expression, visitor, isExpression)),
	            visitIterationBody(node.statement, visitor, context, nodeVisitor)
	          );
	        },
	        [251 /* ContinueStatement */]: function visitEachChildOfContinueStatement(node, visitor, context, _nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateContinueStatement(
	            node,
	            nodeVisitor(node.label, visitor, isIdentifier)
	          );
	        },
	        [252 /* BreakStatement */]: function visitEachChildOfBreakStatement(node, visitor, context, _nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateBreakStatement(
	            node,
	            nodeVisitor(node.label, visitor, isIdentifier)
	          );
	        },
	        [253 /* ReturnStatement */]: function visitEachChildOfReturnStatement(node, visitor, context, _nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateReturnStatement(
	            node,
	            nodeVisitor(node.expression, visitor, isExpression)
	          );
	        },
	        [254 /* WithStatement */]: function visitEachChildOfWithStatement(node, visitor, context, _nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateWithStatement(
	            node,
	            Debug.checkDefined(nodeVisitor(node.expression, visitor, isExpression)),
	            Debug.checkDefined(nodeVisitor(node.statement, visitor, isStatement, context.factory.liftToBlock))
	          );
	        },
	        [255 /* SwitchStatement */]: function visitEachChildOfSwitchStatement(node, visitor, context, _nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateSwitchStatement(
	            node,
	            Debug.checkDefined(nodeVisitor(node.expression, visitor, isExpression)),
	            Debug.checkDefined(nodeVisitor(node.caseBlock, visitor, isCaseBlock))
	          );
	        },
	        [256 /* LabeledStatement */]: function visitEachChildOfLabeledStatement(node, visitor, context, _nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateLabeledStatement(
	            node,
	            Debug.checkDefined(nodeVisitor(node.label, visitor, isIdentifier)),
	            Debug.checkDefined(nodeVisitor(node.statement, visitor, isStatement, context.factory.liftToBlock))
	          );
	        },
	        [257 /* ThrowStatement */]: function visitEachChildOfThrowStatement(node, visitor, context, _nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateThrowStatement(
	            node,
	            Debug.checkDefined(nodeVisitor(node.expression, visitor, isExpression))
	          );
	        },
	        [258 /* TryStatement */]: function visitEachChildOfTryStatement(node, visitor, context, _nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateTryStatement(
	            node,
	            Debug.checkDefined(nodeVisitor(node.tryBlock, visitor, isBlock)),
	            nodeVisitor(node.catchClause, visitor, isCatchClause),
	            nodeVisitor(node.finallyBlock, visitor, isBlock)
	          );
	        },
	        [260 /* VariableDeclaration */]: function visitEachChildOfVariableDeclaration(node, visitor, context, _nodesVisitor, nodeVisitor, tokenVisitor) {
	          return context.factory.updateVariableDeclaration(
	            node,
	            Debug.checkDefined(nodeVisitor(node.name, visitor, isBindingName)),
	            tokenVisitor ? nodeVisitor(node.exclamationToken, tokenVisitor, isExclamationToken) : node.exclamationToken,
	            nodeVisitor(node.type, visitor, isTypeNode),
	            nodeVisitor(node.initializer, visitor, isExpression)
	          );
	        },
	        [261 /* VariableDeclarationList */]: function visitEachChildOfVariableDeclarationList(node, visitor, context, nodesVisitor, _nodeVisitor, _tokenVisitor) {
	          return context.factory.updateVariableDeclarationList(
	            node,
	            nodesVisitor(node.declarations, visitor, isVariableDeclaration)
	          );
	        },
	        [262 /* FunctionDeclaration */]: function visitEachChildOfFunctionDeclaration(node, visitor, context, nodesVisitor, nodeVisitor, tokenVisitor) {
	          return context.factory.updateFunctionDeclaration(
	            node,
	            nodesVisitor(node.modifiers, visitor, isModifier),
	            tokenVisitor ? nodeVisitor(node.asteriskToken, tokenVisitor, isAsteriskToken) : node.asteriskToken,
	            nodeVisitor(node.name, visitor, isIdentifier),
	            nodesVisitor(node.typeParameters, visitor, isTypeParameterDeclaration),
	            visitParameterList(node.parameters, visitor, context, nodesVisitor),
	            nodeVisitor(node.type, visitor, isTypeNode),
	            visitFunctionBody(node.body, visitor, context, nodeVisitor)
	          );
	        },
	        [263 /* ClassDeclaration */]: function visitEachChildOfClassDeclaration(node, visitor, context, nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateClassDeclaration(
	            node,
	            nodesVisitor(node.modifiers, visitor, isModifierLike),
	            nodeVisitor(node.name, visitor, isIdentifier),
	            nodesVisitor(node.typeParameters, visitor, isTypeParameterDeclaration),
	            nodesVisitor(node.heritageClauses, visitor, isHeritageClause),
	            nodesVisitor(node.members, visitor, isClassElement)
	          );
	        },
	        [264 /* InterfaceDeclaration */]: function visitEachChildOfInterfaceDeclaration(node, visitor, context, nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateInterfaceDeclaration(
	            node,
	            nodesVisitor(node.modifiers, visitor, isModifierLike),
	            Debug.checkDefined(nodeVisitor(node.name, visitor, isIdentifier)),
	            nodesVisitor(node.typeParameters, visitor, isTypeParameterDeclaration),
	            nodesVisitor(node.heritageClauses, visitor, isHeritageClause),
	            nodesVisitor(node.members, visitor, isTypeElement)
	          );
	        },
	        [265 /* TypeAliasDeclaration */]: function visitEachChildOfTypeAliasDeclaration(node, visitor, context, nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateTypeAliasDeclaration(
	            node,
	            nodesVisitor(node.modifiers, visitor, isModifierLike),
	            Debug.checkDefined(nodeVisitor(node.name, visitor, isIdentifier)),
	            nodesVisitor(node.typeParameters, visitor, isTypeParameterDeclaration),
	            Debug.checkDefined(nodeVisitor(node.type, visitor, isTypeNode))
	          );
	        },
	        [266 /* EnumDeclaration */]: function visitEachChildOfEnumDeclaration(node, visitor, context, nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateEnumDeclaration(
	            node,
	            nodesVisitor(node.modifiers, visitor, isModifierLike),
	            Debug.checkDefined(nodeVisitor(node.name, visitor, isIdentifier)),
	            nodesVisitor(node.members, visitor, isEnumMember)
	          );
	        },
	        [267 /* ModuleDeclaration */]: function visitEachChildOfModuleDeclaration(node, visitor, context, nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateModuleDeclaration(
	            node,
	            nodesVisitor(node.modifiers, visitor, isModifierLike),
	            Debug.checkDefined(nodeVisitor(node.name, visitor, isModuleName)),
	            nodeVisitor(node.body, visitor, isModuleBody)
	          );
	        },
	        [268 /* ModuleBlock */]: function visitEachChildOfModuleBlock(node, visitor, context, nodesVisitor, _nodeVisitor, _tokenVisitor) {
	          return context.factory.updateModuleBlock(
	            node,
	            nodesVisitor(node.statements, visitor, isStatement)
	          );
	        },
	        [269 /* CaseBlock */]: function visitEachChildOfCaseBlock(node, visitor, context, nodesVisitor, _nodeVisitor, _tokenVisitor) {
	          return context.factory.updateCaseBlock(
	            node,
	            nodesVisitor(node.clauses, visitor, isCaseOrDefaultClause)
	          );
	        },
	        [270 /* NamespaceExportDeclaration */]: function visitEachChildOfNamespaceExportDeclaration(node, visitor, context, _nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateNamespaceExportDeclaration(
	            node,
	            Debug.checkDefined(nodeVisitor(node.name, visitor, isIdentifier))
	          );
	        },
	        [271 /* ImportEqualsDeclaration */]: function visitEachChildOfImportEqualsDeclaration(node, visitor, context, nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateImportEqualsDeclaration(
	            node,
	            nodesVisitor(node.modifiers, visitor, isModifierLike),
	            node.isTypeOnly,
	            Debug.checkDefined(nodeVisitor(node.name, visitor, isIdentifier)),
	            Debug.checkDefined(nodeVisitor(node.moduleReference, visitor, isModuleReference))
	          );
	        },
	        [272 /* ImportDeclaration */]: function visitEachChildOfImportDeclaration(node, visitor, context, nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateImportDeclaration(
	            node,
	            nodesVisitor(node.modifiers, visitor, isModifierLike),
	            nodeVisitor(node.importClause, visitor, isImportClause),
	            Debug.checkDefined(nodeVisitor(node.moduleSpecifier, visitor, isExpression)),
	            nodeVisitor(node.attributes, visitor, isImportAttributes)
	          );
	        },
	        [300 /* ImportAttributes */]: function visitEachChildOfImportAttributes(node, visitor, context, nodesVisitor, _nodeVisitor, _tokenVisitor) {
	          return context.factory.updateImportAttributes(
	            node,
	            nodesVisitor(node.elements, visitor, isImportAttribute),
	            node.multiLine
	          );
	        },
	        [301 /* ImportAttribute */]: function visitEachChildOfImportAttribute(node, visitor, context, _nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateImportAttribute(
	            node,
	            Debug.checkDefined(nodeVisitor(node.name, visitor, isImportAttributeName)),
	            Debug.checkDefined(nodeVisitor(node.value, visitor, isExpression))
	          );
	        },
	        [273 /* ImportClause */]: function visitEachChildOfImportClause(node, visitor, context, _nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateImportClause(
	            node,
	            node.isTypeOnly,
	            nodeVisitor(node.name, visitor, isIdentifier),
	            nodeVisitor(node.namedBindings, visitor, isNamedImportBindings)
	          );
	        },
	        [274 /* NamespaceImport */]: function visitEachChildOfNamespaceImport(node, visitor, context, _nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateNamespaceImport(
	            node,
	            Debug.checkDefined(nodeVisitor(node.name, visitor, isIdentifier))
	          );
	        },
	        [280 /* NamespaceExport */]: function visitEachChildOfNamespaceExport(node, visitor, context, _nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateNamespaceExport(
	            node,
	            Debug.checkDefined(nodeVisitor(node.name, visitor, isIdentifier))
	          );
	        },
	        [275 /* NamedImports */]: function visitEachChildOfNamedImports(node, visitor, context, nodesVisitor, _nodeVisitor, _tokenVisitor) {
	          return context.factory.updateNamedImports(
	            node,
	            nodesVisitor(node.elements, visitor, isImportSpecifier)
	          );
	        },
	        [276 /* ImportSpecifier */]: function visitEachChildOfImportSpecifier(node, visitor, context, _nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateImportSpecifier(
	            node,
	            node.isTypeOnly,
	            nodeVisitor(node.propertyName, visitor, isIdentifier),
	            Debug.checkDefined(nodeVisitor(node.name, visitor, isIdentifier))
	          );
	        },
	        [277 /* ExportAssignment */]: function visitEachChildOfExportAssignment(node, visitor, context, nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateExportAssignment(
	            node,
	            nodesVisitor(node.modifiers, visitor, isModifierLike),
	            Debug.checkDefined(nodeVisitor(node.expression, visitor, isExpression))
	          );
	        },
	        [278 /* ExportDeclaration */]: function visitEachChildOfExportDeclaration(node, visitor, context, nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateExportDeclaration(
	            node,
	            nodesVisitor(node.modifiers, visitor, isModifierLike),
	            node.isTypeOnly,
	            nodeVisitor(node.exportClause, visitor, isNamedExportBindings),
	            nodeVisitor(node.moduleSpecifier, visitor, isExpression),
	            nodeVisitor(node.attributes, visitor, isImportAttributes)
	          );
	        },
	        [279 /* NamedExports */]: function visitEachChildOfNamedExports(node, visitor, context, nodesVisitor, _nodeVisitor, _tokenVisitor) {
	          return context.factory.updateNamedExports(
	            node,
	            nodesVisitor(node.elements, visitor, isExportSpecifier)
	          );
	        },
	        [281 /* ExportSpecifier */]: function visitEachChildOfExportSpecifier(node, visitor, context, _nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateExportSpecifier(
	            node,
	            node.isTypeOnly,
	            nodeVisitor(node.propertyName, visitor, isIdentifier),
	            Debug.checkDefined(nodeVisitor(node.name, visitor, isIdentifier))
	          );
	        },
	        // Module references
	        [283 /* ExternalModuleReference */]: function visitEachChildOfExternalModuleReference(node, visitor, context, _nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateExternalModuleReference(
	            node,
	            Debug.checkDefined(nodeVisitor(node.expression, visitor, isExpression))
	          );
	        },
	        // JSX
	        [284 /* JsxElement */]: function visitEachChildOfJsxElement(node, visitor, context, nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateJsxElement(
	            node,
	            Debug.checkDefined(nodeVisitor(node.openingElement, visitor, isJsxOpeningElement)),
	            nodesVisitor(node.children, visitor, isJsxChild),
	            Debug.checkDefined(nodeVisitor(node.closingElement, visitor, isJsxClosingElement))
	          );
	        },
	        [285 /* JsxSelfClosingElement */]: function visitEachChildOfJsxSelfClosingElement(node, visitor, context, nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateJsxSelfClosingElement(
	            node,
	            Debug.checkDefined(nodeVisitor(node.tagName, visitor, isJsxTagNameExpression)),
	            nodesVisitor(node.typeArguments, visitor, isTypeNode),
	            Debug.checkDefined(nodeVisitor(node.attributes, visitor, isJsxAttributes))
	          );
	        },
	        [286 /* JsxOpeningElement */]: function visitEachChildOfJsxOpeningElement(node, visitor, context, nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateJsxOpeningElement(
	            node,
	            Debug.checkDefined(nodeVisitor(node.tagName, visitor, isJsxTagNameExpression)),
	            nodesVisitor(node.typeArguments, visitor, isTypeNode),
	            Debug.checkDefined(nodeVisitor(node.attributes, visitor, isJsxAttributes))
	          );
	        },
	        [287 /* JsxClosingElement */]: function visitEachChildOfJsxClosingElement(node, visitor, context, _nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateJsxClosingElement(
	            node,
	            Debug.checkDefined(nodeVisitor(node.tagName, visitor, isJsxTagNameExpression))
	          );
	        },
	        [295 /* JsxNamespacedName */]: function forEachChildInJsxNamespacedName2(node, visitor, context, _nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateJsxNamespacedName(
	            node,
	            Debug.checkDefined(nodeVisitor(node.namespace, visitor, isIdentifier)),
	            Debug.checkDefined(nodeVisitor(node.name, visitor, isIdentifier))
	          );
	        },
	        [288 /* JsxFragment */]: function visitEachChildOfJsxFragment(node, visitor, context, nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateJsxFragment(
	            node,
	            Debug.checkDefined(nodeVisitor(node.openingFragment, visitor, isJsxOpeningFragment)),
	            nodesVisitor(node.children, visitor, isJsxChild),
	            Debug.checkDefined(nodeVisitor(node.closingFragment, visitor, isJsxClosingFragment))
	          );
	        },
	        [291 /* JsxAttribute */]: function visitEachChildOfJsxAttribute(node, visitor, context, _nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateJsxAttribute(
	            node,
	            Debug.checkDefined(nodeVisitor(node.name, visitor, isJsxAttributeName)),
	            nodeVisitor(node.initializer, visitor, isStringLiteralOrJsxExpression)
	          );
	        },
	        [292 /* JsxAttributes */]: function visitEachChildOfJsxAttributes(node, visitor, context, nodesVisitor, _nodeVisitor, _tokenVisitor) {
	          return context.factory.updateJsxAttributes(
	            node,
	            nodesVisitor(node.properties, visitor, isJsxAttributeLike)
	          );
	        },
	        [293 /* JsxSpreadAttribute */]: function visitEachChildOfJsxSpreadAttribute(node, visitor, context, _nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateJsxSpreadAttribute(
	            node,
	            Debug.checkDefined(nodeVisitor(node.expression, visitor, isExpression))
	          );
	        },
	        [294 /* JsxExpression */]: function visitEachChildOfJsxExpression(node, visitor, context, _nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateJsxExpression(
	            node,
	            nodeVisitor(node.expression, visitor, isExpression)
	          );
	        },
	        // Clauses
	        [296 /* CaseClause */]: function visitEachChildOfCaseClause(node, visitor, context, nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateCaseClause(
	            node,
	            Debug.checkDefined(nodeVisitor(node.expression, visitor, isExpression)),
	            nodesVisitor(node.statements, visitor, isStatement)
	          );
	        },
	        [297 /* DefaultClause */]: function visitEachChildOfDefaultClause(node, visitor, context, nodesVisitor, _nodeVisitor, _tokenVisitor) {
	          return context.factory.updateDefaultClause(
	            node,
	            nodesVisitor(node.statements, visitor, isStatement)
	          );
	        },
	        [298 /* HeritageClause */]: function visitEachChildOfHeritageClause(node, visitor, context, nodesVisitor, _nodeVisitor, _tokenVisitor) {
	          return context.factory.updateHeritageClause(
	            node,
	            nodesVisitor(node.types, visitor, isExpressionWithTypeArguments)
	          );
	        },
	        [299 /* CatchClause */]: function visitEachChildOfCatchClause(node, visitor, context, _nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateCatchClause(
	            node,
	            nodeVisitor(node.variableDeclaration, visitor, isVariableDeclaration),
	            Debug.checkDefined(nodeVisitor(node.block, visitor, isBlock))
	          );
	        },
	        // Property assignments
	        [303 /* PropertyAssignment */]: function visitEachChildOfPropertyAssignment(node, visitor, context, _nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updatePropertyAssignment(
	            node,
	            Debug.checkDefined(nodeVisitor(node.name, visitor, isPropertyName)),
	            Debug.checkDefined(nodeVisitor(node.initializer, visitor, isExpression))
	          );
	        },
	        [304 /* ShorthandPropertyAssignment */]: function visitEachChildOfShorthandPropertyAssignment(node, visitor, context, _nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateShorthandPropertyAssignment(
	            node,
	            Debug.checkDefined(nodeVisitor(node.name, visitor, isIdentifier)),
	            nodeVisitor(node.objectAssignmentInitializer, visitor, isExpression)
	          );
	        },
	        [305 /* SpreadAssignment */]: function visitEachChildOfSpreadAssignment(node, visitor, context, _nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateSpreadAssignment(
	            node,
	            Debug.checkDefined(nodeVisitor(node.expression, visitor, isExpression))
	          );
	        },
	        // Enum
	        [306 /* EnumMember */]: function visitEachChildOfEnumMember(node, visitor, context, _nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updateEnumMember(
	            node,
	            Debug.checkDefined(nodeVisitor(node.name, visitor, isPropertyName)),
	            nodeVisitor(node.initializer, visitor, isExpression)
	          );
	        },
	        // Top-level nodes
	        [312 /* SourceFile */]: function visitEachChildOfSourceFile(node, visitor, context, _nodesVisitor, _nodeVisitor, _tokenVisitor) {
	          return context.factory.updateSourceFile(
	            node,
	            visitLexicalEnvironment(node.statements, visitor, context)
	          );
	        },
	        // Transformation nodes
	        [360 /* PartiallyEmittedExpression */]: function visitEachChildOfPartiallyEmittedExpression(node, visitor, context, _nodesVisitor, nodeVisitor, _tokenVisitor) {
	          return context.factory.updatePartiallyEmittedExpression(
	            node,
	            Debug.checkDefined(nodeVisitor(node.expression, visitor, isExpression))
	          );
	        },
	        [361 /* CommaListExpression */]: function visitEachChildOfCommaListExpression(node, visitor, context, nodesVisitor, _nodeVisitor, _tokenVisitor) {
	          return context.factory.updateCommaListExpression(
	            node,
	            nodesVisitor(node.elements, visitor, isExpression)
	          );
	        }
	      };
	    }
	  });

	  // src/compiler/sourcemap.ts
	  function createSourceMapGenerator(host, file, sourceRoot, sourcesDirectoryPath, generatorOptions) {
	    var { enter, exit } = generatorOptions.extendedDiagnostics ? createTimer("Source Map", "beforeSourcemap", "afterSourcemap") : nullTimer;
	    var rawSources = [];
	    var sources = [];
	    var sourceToSourceIndexMap = /* @__PURE__ */ new Map();
	    var sourcesContent;
	    var names = [];
	    var nameToNameIndexMap;
	    var mappingCharCodes = [];
	    var mappings = "";
	    var lastGeneratedLine = 0;
	    var lastGeneratedCharacter = 0;
	    var lastSourceIndex = 0;
	    var lastSourceLine = 0;
	    var lastSourceCharacter = 0;
	    var lastNameIndex = 0;
	    var hasLast = false;
	    var pendingGeneratedLine = 0;
	    var pendingGeneratedCharacter = 0;
	    var pendingSourceIndex = 0;
	    var pendingSourceLine = 0;
	    var pendingSourceCharacter = 0;
	    var pendingNameIndex = 0;
	    var hasPending = false;
	    var hasPendingSource = false;
	    var hasPendingName = false;
	    return {
	      getSources: () => rawSources,
	      addSource,
	      setSourceContent,
	      addName,
	      addMapping,
	      appendSourceMap,
	      toJSON,
	      toString: () => JSON.stringify(toJSON())
	    };
	    function addSource(fileName) {
	      enter();
	      const source = getRelativePathToDirectoryOrUrl(
	        sourcesDirectoryPath,
	        fileName,
	        host.getCurrentDirectory(),
	        host.getCanonicalFileName,
	        /*isAbsolutePathAnUrl*/
	        true
	      );
	      let sourceIndex = sourceToSourceIndexMap.get(source);
	      if (sourceIndex === void 0) {
	        sourceIndex = sources.length;
	        sources.push(source);
	        rawSources.push(fileName);
	        sourceToSourceIndexMap.set(source, sourceIndex);
	      }
	      exit();
	      return sourceIndex;
	    }
	    function setSourceContent(sourceIndex, content) {
	      enter();
	      if (content !== null) {
	        if (!sourcesContent)
	          sourcesContent = [];
	        while (sourcesContent.length < sourceIndex) {
	          sourcesContent.push(null);
	        }
	        sourcesContent[sourceIndex] = content;
	      }
	      exit();
	    }
	    function addName(name) {
	      enter();
	      if (!nameToNameIndexMap)
	        nameToNameIndexMap = /* @__PURE__ */ new Map();
	      let nameIndex = nameToNameIndexMap.get(name);
	      if (nameIndex === void 0) {
	        nameIndex = names.length;
	        names.push(name);
	        nameToNameIndexMap.set(name, nameIndex);
	      }
	      exit();
	      return nameIndex;
	    }
	    function isNewGeneratedPosition(generatedLine, generatedCharacter) {
	      return !hasPending || pendingGeneratedLine !== generatedLine || pendingGeneratedCharacter !== generatedCharacter;
	    }
	    function isBacktrackingSourcePosition(sourceIndex, sourceLine, sourceCharacter) {
	      return sourceIndex !== void 0 && sourceLine !== void 0 && sourceCharacter !== void 0 && pendingSourceIndex === sourceIndex && (pendingSourceLine > sourceLine || pendingSourceLine === sourceLine && pendingSourceCharacter > sourceCharacter);
	    }
	    function addMapping(generatedLine, generatedCharacter, sourceIndex, sourceLine, sourceCharacter, nameIndex) {
	      Debug.assert(generatedLine >= pendingGeneratedLine, "generatedLine cannot backtrack");
	      Debug.assert(generatedCharacter >= 0, "generatedCharacter cannot be negative");
	      Debug.assert(sourceIndex === void 0 || sourceIndex >= 0, "sourceIndex cannot be negative");
	      Debug.assert(sourceLine === void 0 || sourceLine >= 0, "sourceLine cannot be negative");
	      Debug.assert(sourceCharacter === void 0 || sourceCharacter >= 0, "sourceCharacter cannot be negative");
	      enter();
	      if (isNewGeneratedPosition(generatedLine, generatedCharacter) || isBacktrackingSourcePosition(sourceIndex, sourceLine, sourceCharacter)) {
	        commitPendingMapping();
	        pendingGeneratedLine = generatedLine;
	        pendingGeneratedCharacter = generatedCharacter;
	        hasPendingSource = false;
	        hasPendingName = false;
	        hasPending = true;
	      }
	      if (sourceIndex !== void 0 && sourceLine !== void 0 && sourceCharacter !== void 0) {
	        pendingSourceIndex = sourceIndex;
	        pendingSourceLine = sourceLine;
	        pendingSourceCharacter = sourceCharacter;
	        hasPendingSource = true;
	        if (nameIndex !== void 0) {
	          pendingNameIndex = nameIndex;
	          hasPendingName = true;
	        }
	      }
	      exit();
	    }
	    function appendSourceMap(generatedLine, generatedCharacter, map2, sourceMapPath, start, end) {
	      Debug.assert(generatedLine >= pendingGeneratedLine, "generatedLine cannot backtrack");
	      Debug.assert(generatedCharacter >= 0, "generatedCharacter cannot be negative");
	      enter();
	      const sourceIndexToNewSourceIndexMap = [];
	      let nameIndexToNewNameIndexMap;
	      const mappingIterator = decodeMappings(map2.mappings);
	      for (const raw of mappingIterator) {
	        if (end && (raw.generatedLine > end.line || raw.generatedLine === end.line && raw.generatedCharacter > end.character)) {
	          break;
	        }
	        if (start && (raw.generatedLine < start.line || start.line === raw.generatedLine && raw.generatedCharacter < start.character)) {
	          continue;
	        }
	        let newSourceIndex;
	        let newSourceLine;
	        let newSourceCharacter;
	        let newNameIndex;
	        if (raw.sourceIndex !== void 0) {
	          newSourceIndex = sourceIndexToNewSourceIndexMap[raw.sourceIndex];
	          if (newSourceIndex === void 0) {
	            const rawPath = map2.sources[raw.sourceIndex];
	            const relativePath = map2.sourceRoot ? combinePaths(map2.sourceRoot, rawPath) : rawPath;
	            const combinedPath = combinePaths(getDirectoryPath(sourceMapPath), relativePath);
	            sourceIndexToNewSourceIndexMap[raw.sourceIndex] = newSourceIndex = addSource(combinedPath);
	            if (map2.sourcesContent && typeof map2.sourcesContent[raw.sourceIndex] === "string") {
	              setSourceContent(newSourceIndex, map2.sourcesContent[raw.sourceIndex]);
	            }
	          }
	          newSourceLine = raw.sourceLine;
	          newSourceCharacter = raw.sourceCharacter;
	          if (map2.names && raw.nameIndex !== void 0) {
	            if (!nameIndexToNewNameIndexMap)
	              nameIndexToNewNameIndexMap = [];
	            newNameIndex = nameIndexToNewNameIndexMap[raw.nameIndex];
	            if (newNameIndex === void 0) {
	              nameIndexToNewNameIndexMap[raw.nameIndex] = newNameIndex = addName(map2.names[raw.nameIndex]);
	            }
	          }
	        }
	        const rawGeneratedLine = raw.generatedLine - (start ? start.line : 0);
	        const newGeneratedLine = rawGeneratedLine + generatedLine;
	        const rawGeneratedCharacter = start && start.line === raw.generatedLine ? raw.generatedCharacter - start.character : raw.generatedCharacter;
	        const newGeneratedCharacter = rawGeneratedLine === 0 ? rawGeneratedCharacter + generatedCharacter : rawGeneratedCharacter;
	        addMapping(newGeneratedLine, newGeneratedCharacter, newSourceIndex, newSourceLine, newSourceCharacter, newNameIndex);
	      }
	      exit();
	    }
	    function shouldCommitMapping() {
	      return !hasLast || lastGeneratedLine !== pendingGeneratedLine || lastGeneratedCharacter !== pendingGeneratedCharacter || lastSourceIndex !== pendingSourceIndex || lastSourceLine !== pendingSourceLine || lastSourceCharacter !== pendingSourceCharacter || lastNameIndex !== pendingNameIndex;
	    }
	    function appendMappingCharCode(charCode) {
	      mappingCharCodes.push(charCode);
	      if (mappingCharCodes.length >= 1024) {
	        flushMappingBuffer();
	      }
	    }
	    function commitPendingMapping() {
	      if (!hasPending || !shouldCommitMapping()) {
	        return;
	      }
	      enter();
	      if (lastGeneratedLine < pendingGeneratedLine) {
	        do {
	          appendMappingCharCode(59 /* semicolon */);
	          lastGeneratedLine++;
	        } while (lastGeneratedLine < pendingGeneratedLine);
	        lastGeneratedCharacter = 0;
	      } else {
	        Debug.assertEqual(lastGeneratedLine, pendingGeneratedLine, "generatedLine cannot backtrack");
	        if (hasLast) {
	          appendMappingCharCode(44 /* comma */);
	        }
	      }
	      appendBase64VLQ(pendingGeneratedCharacter - lastGeneratedCharacter);
	      lastGeneratedCharacter = pendingGeneratedCharacter;
	      if (hasPendingSource) {
	        appendBase64VLQ(pendingSourceIndex - lastSourceIndex);
	        lastSourceIndex = pendingSourceIndex;
	        appendBase64VLQ(pendingSourceLine - lastSourceLine);
	        lastSourceLine = pendingSourceLine;
	        appendBase64VLQ(pendingSourceCharacter - lastSourceCharacter);
	        lastSourceCharacter = pendingSourceCharacter;
	        if (hasPendingName) {
	          appendBase64VLQ(pendingNameIndex - lastNameIndex);
	          lastNameIndex = pendingNameIndex;
	        }
	      }
	      hasLast = true;
	      exit();
	    }
	    function flushMappingBuffer() {
	      if (mappingCharCodes.length > 0) {
	        mappings += String.fromCharCode.apply(void 0, mappingCharCodes);
	        mappingCharCodes.length = 0;
	      }
	    }
	    function toJSON() {
	      commitPendingMapping();
	      flushMappingBuffer();
	      return {
	        version: 3,
	        file,
	        sourceRoot,
	        sources,
	        names,
	        mappings,
	        sourcesContent
	      };
	    }
	    function appendBase64VLQ(inValue) {
	      if (inValue < 0) {
	        inValue = (-inValue << 1) + 1;
	      } else {
	        inValue = inValue << 1;
	      }
	      do {
	        let currentDigit = inValue & 31;
	        inValue = inValue >> 5;
	        if (inValue > 0) {
	          currentDigit = currentDigit | 32;
	        }
	        appendMappingCharCode(base64FormatEncode(currentDigit));
	      } while (inValue > 0);
	    }
	  }
	  function getLineInfo(text, lineStarts) {
	    return {
	      getLineCount: () => lineStarts.length,
	      getLineText: (line) => text.substring(lineStarts[line], lineStarts[line + 1])
	    };
	  }
	  function tryGetSourceMappingURL(lineInfo) {
	    for (let index = lineInfo.getLineCount() - 1; index >= 0; index--) {
	      const line = lineInfo.getLineText(index);
	      const comment = sourceMapCommentRegExp.exec(line);
	      if (comment) {
	        return comment[1].trimEnd();
	      } else if (!line.match(whitespaceOrMapCommentRegExp)) {
	        break;
	      }
	    }
	  }
	  function isStringOrNull(x) {
	    return typeof x === "string" || x === null;
	  }
	  function isRawSourceMap(x) {
	    return x !== null && typeof x === "object" && x.version === 3 && typeof x.file === "string" && typeof x.mappings === "string" && isArray(x.sources) && every(x.sources, isString) && (x.sourceRoot === void 0 || x.sourceRoot === null || typeof x.sourceRoot === "string") && (x.sourcesContent === void 0 || x.sourcesContent === null || isArray(x.sourcesContent) && every(x.sourcesContent, isStringOrNull)) && (x.names === void 0 || x.names === null || isArray(x.names) && every(x.names, isString));
	  }
	  function tryParseRawSourceMap(text) {
	    try {
	      const parsed = JSON.parse(text);
	      if (isRawSourceMap(parsed)) {
	        return parsed;
	      }
	    } catch {
	    }
	    return void 0;
	  }
	  function decodeMappings(mappings) {
	    let done = false;
	    let pos = 0;
	    let generatedLine = 0;
	    let generatedCharacter = 0;
	    let sourceIndex = 0;
	    let sourceLine = 0;
	    let sourceCharacter = 0;
	    let nameIndex = 0;
	    let error2;
	    return {
	      get pos() {
	        return pos;
	      },
	      get error() {
	        return error2;
	      },
	      get state() {
	        return captureMapping(
	          /*hasSource*/
	          true,
	          /*hasName*/
	          true
	        );
	      },
	      next() {
	        while (!done && pos < mappings.length) {
	          const ch = mappings.charCodeAt(pos);
	          if (ch === 59 /* semicolon */) {
	            generatedLine++;
	            generatedCharacter = 0;
	            pos++;
	            continue;
	          }
	          if (ch === 44 /* comma */) {
	            pos++;
	            continue;
	          }
	          let hasSource = false;
	          let hasName = false;
	          generatedCharacter += base64VLQFormatDecode();
	          if (hasReportedError())
	            return stopIterating();
	          if (generatedCharacter < 0)
	            return setErrorAndStopIterating("Invalid generatedCharacter found");
	          if (!isSourceMappingSegmentEnd()) {
	            hasSource = true;
	            sourceIndex += base64VLQFormatDecode();
	            if (hasReportedError())
	              return stopIterating();
	            if (sourceIndex < 0)
	              return setErrorAndStopIterating("Invalid sourceIndex found");
	            if (isSourceMappingSegmentEnd())
	              return setErrorAndStopIterating("Unsupported Format: No entries after sourceIndex");
	            sourceLine += base64VLQFormatDecode();
	            if (hasReportedError())
	              return stopIterating();
	            if (sourceLine < 0)
	              return setErrorAndStopIterating("Invalid sourceLine found");
	            if (isSourceMappingSegmentEnd())
	              return setErrorAndStopIterating("Unsupported Format: No entries after sourceLine");
	            sourceCharacter += base64VLQFormatDecode();
	            if (hasReportedError())
	              return stopIterating();
	            if (sourceCharacter < 0)
	              return setErrorAndStopIterating("Invalid sourceCharacter found");
	            if (!isSourceMappingSegmentEnd()) {
	              hasName = true;
	              nameIndex += base64VLQFormatDecode();
	              if (hasReportedError())
	                return stopIterating();
	              if (nameIndex < 0)
	                return setErrorAndStopIterating("Invalid nameIndex found");
	              if (!isSourceMappingSegmentEnd())
	                return setErrorAndStopIterating("Unsupported Error Format: Entries after nameIndex");
	            }
	          }
	          return { value: captureMapping(hasSource, hasName), done };
	        }
	        return stopIterating();
	      },
	      [Symbol.iterator]() {
	        return this;
	      }
	    };
	    function captureMapping(hasSource, hasName) {
	      return {
	        generatedLine,
	        generatedCharacter,
	        sourceIndex: hasSource ? sourceIndex : void 0,
	        sourceLine: hasSource ? sourceLine : void 0,
	        sourceCharacter: hasSource ? sourceCharacter : void 0,
	        nameIndex: hasName ? nameIndex : void 0
	      };
	    }
	    function stopIterating() {
	      done = true;
	      return { value: void 0, done: true };
	    }
	    function setError(message) {
	      if (error2 === void 0) {
	        error2 = message;
	      }
	    }
	    function setErrorAndStopIterating(message) {
	      setError(message);
	      return stopIterating();
	    }
	    function hasReportedError() {
	      return error2 !== void 0;
	    }
	    function isSourceMappingSegmentEnd() {
	      return pos === mappings.length || mappings.charCodeAt(pos) === 44 /* comma */ || mappings.charCodeAt(pos) === 59 /* semicolon */;
	    }
	    function base64VLQFormatDecode() {
	      let moreDigits = true;
	      let shiftCount = 0;
	      let value = 0;
	      for (; moreDigits; pos++) {
	        if (pos >= mappings.length)
	          return setError("Error in decoding base64VLQFormatDecode, past the mapping string"), -1;
	        const currentByte = base64FormatDecode(mappings.charCodeAt(pos));
	        if (currentByte === -1)
	          return setError("Invalid character in VLQ"), -1;
	        moreDigits = (currentByte & 32) !== 0;
	        value = value | (currentByte & 31) << shiftCount;
	        shiftCount += 5;
	      }
	      if ((value & 1) === 0) {
	        value = value >> 1;
	      } else {
	        value = value >> 1;
	        value = -value;
	      }
	      return value;
	    }
	  }
	  function sameMapping(left, right) {
	    return left === right || left.generatedLine === right.generatedLine && left.generatedCharacter === right.generatedCharacter && left.sourceIndex === right.sourceIndex && left.sourceLine === right.sourceLine && left.sourceCharacter === right.sourceCharacter && left.nameIndex === right.nameIndex;
	  }
	  function isSourceMapping(mapping) {
	    return mapping.sourceIndex !== void 0 && mapping.sourceLine !== void 0 && mapping.sourceCharacter !== void 0;
	  }
	  function base64FormatEncode(value) {
	    return value >= 0 && value < 26 ? 65 /* A */ + value : value >= 26 && value < 52 ? 97 /* a */ + value - 26 : value >= 52 && value < 62 ? 48 /* _0 */ + value - 52 : value === 62 ? 43 /* plus */ : value === 63 ? 47 /* slash */ : Debug.fail(`${value}: not a base64 value`);
	  }
	  function base64FormatDecode(ch) {
	    return ch >= 65 /* A */ && ch <= 90 /* Z */ ? ch - 65 /* A */ : ch >= 97 /* a */ && ch <= 122 /* z */ ? ch - 97 /* a */ + 26 : ch >= 48 /* _0 */ && ch <= 57 /* _9 */ ? ch - 48 /* _0 */ + 52 : ch === 43 /* plus */ ? 62 : ch === 47 /* slash */ ? 63 : -1;
	  }
	  function isSourceMappedPosition(value) {
	    return value.sourceIndex !== void 0 && value.sourcePosition !== void 0;
	  }
	  function sameMappedPosition(left, right) {
	    return left.generatedPosition === right.generatedPosition && left.sourceIndex === right.sourceIndex && left.sourcePosition === right.sourcePosition;
	  }
	  function compareSourcePositions(left, right) {
	    Debug.assert(left.sourceIndex === right.sourceIndex);
	    return compareValues(left.sourcePosition, right.sourcePosition);
	  }
	  function compareGeneratedPositions(left, right) {
	    return compareValues(left.generatedPosition, right.generatedPosition);
	  }
	  function getSourcePositionOfMapping(value) {
	    return value.sourcePosition;
	  }
	  function getGeneratedPositionOfMapping(value) {
	    return value.generatedPosition;
	  }
	  function createDocumentPositionMapper(host, map2, mapPath) {
	    const mapDirectory = getDirectoryPath(mapPath);
	    const sourceRoot = map2.sourceRoot ? getNormalizedAbsolutePath(map2.sourceRoot, mapDirectory) : mapDirectory;
	    const generatedAbsoluteFilePath = getNormalizedAbsolutePath(map2.file, mapDirectory);
	    const generatedFile = host.getSourceFileLike(generatedAbsoluteFilePath);
	    const sourceFileAbsolutePaths = map2.sources.map((source) => getNormalizedAbsolutePath(source, sourceRoot));
	    const sourceToSourceIndexMap = new Map(sourceFileAbsolutePaths.map((source, i) => [host.getCanonicalFileName(source), i]));
	    let decodedMappings;
	    let generatedMappings;
	    let sourceMappings;
	    return {
	      getSourcePosition,
	      getGeneratedPosition
	    };
	    function processMapping(mapping) {
	      const generatedPosition = generatedFile !== void 0 ? getPositionOfLineAndCharacter(
	        generatedFile,
	        mapping.generatedLine,
	        mapping.generatedCharacter,
	        /*allowEdits*/
	        true
	      ) : -1;
	      let source;
	      let sourcePosition;
	      if (isSourceMapping(mapping)) {
	        const sourceFile = host.getSourceFileLike(sourceFileAbsolutePaths[mapping.sourceIndex]);
	        source = map2.sources[mapping.sourceIndex];
	        sourcePosition = sourceFile !== void 0 ? getPositionOfLineAndCharacter(
	          sourceFile,
	          mapping.sourceLine,
	          mapping.sourceCharacter,
	          /*allowEdits*/
	          true
	        ) : -1;
	      }
	      return {
	        generatedPosition,
	        source,
	        sourceIndex: mapping.sourceIndex,
	        sourcePosition,
	        nameIndex: mapping.nameIndex
	      };
	    }
	    function getDecodedMappings() {
	      if (decodedMappings === void 0) {
	        const decoder = decodeMappings(map2.mappings);
	        const mappings = arrayFrom(decoder, processMapping);
	        if (decoder.error !== void 0) {
	          if (host.log) {
	            host.log(`Encountered error while decoding sourcemap: ${decoder.error}`);
	          }
	          decodedMappings = emptyArray;
	        } else {
	          decodedMappings = mappings;
	        }
	      }
	      return decodedMappings;
	    }
	    function getSourceMappings(sourceIndex) {
	      if (sourceMappings === void 0) {
	        const lists = [];
	        for (const mapping of getDecodedMappings()) {
	          if (!isSourceMappedPosition(mapping))
	            continue;
	          let list = lists[mapping.sourceIndex];
	          if (!list)
	            lists[mapping.sourceIndex] = list = [];
	          list.push(mapping);
	        }
	        sourceMappings = lists.map((list) => sortAndDeduplicate(list, compareSourcePositions, sameMappedPosition));
	      }
	      return sourceMappings[sourceIndex];
	    }
	    function getGeneratedMappings() {
	      if (generatedMappings === void 0) {
	        const list = [];
	        for (const mapping of getDecodedMappings()) {
	          list.push(mapping);
	        }
	        generatedMappings = sortAndDeduplicate(list, compareGeneratedPositions, sameMappedPosition);
	      }
	      return generatedMappings;
	    }
	    function getGeneratedPosition(loc) {
	      const sourceIndex = sourceToSourceIndexMap.get(host.getCanonicalFileName(loc.fileName));
	      if (sourceIndex === void 0)
	        return loc;
	      const sourceMappings2 = getSourceMappings(sourceIndex);
	      if (!some(sourceMappings2))
	        return loc;
	      let targetIndex = binarySearchKey(sourceMappings2, loc.pos, getSourcePositionOfMapping, compareValues);
	      if (targetIndex < 0) {
	        targetIndex = ~targetIndex;
	      }
	      const mapping = sourceMappings2[targetIndex];
	      if (mapping === void 0 || mapping.sourceIndex !== sourceIndex) {
	        return loc;
	      }
	      return { fileName: generatedAbsoluteFilePath, pos: mapping.generatedPosition };
	    }
	    function getSourcePosition(loc) {
	      const generatedMappings2 = getGeneratedMappings();
	      if (!some(generatedMappings2))
	        return loc;
	      let targetIndex = binarySearchKey(generatedMappings2, loc.pos, getGeneratedPositionOfMapping, compareValues);
	      if (targetIndex < 0) {
	        targetIndex = ~targetIndex;
	      }
	      const mapping = generatedMappings2[targetIndex];
	      if (mapping === void 0 || !isSourceMappedPosition(mapping)) {
	        return loc;
	      }
	      return { fileName: sourceFileAbsolutePaths[mapping.sourceIndex], pos: mapping.sourcePosition };
	    }
	  }
	  var sourceMapCommentRegExpDontCareLineStart, sourceMapCommentRegExp, whitespaceOrMapCommentRegExp, identitySourceMapConsumer;
	  var init_sourcemap = __esm({
	    "src/compiler/sourcemap.ts"() {
	      init_ts2();
	      init_ts_performance();
	      sourceMapCommentRegExpDontCareLineStart = /\/\/[@#] source[M]appingURL=(.+)\r?\n?$/;
	      sourceMapCommentRegExp = /^\/\/[@#] source[M]appingURL=(.+)\r?\n?$/;
	      whitespaceOrMapCommentRegExp = /^\s*(\/\/[@#] .*)?$/;
	      identitySourceMapConsumer = {
	        getSourcePosition: identity,
	        getGeneratedPosition: identity
	      };
	    }
	  });

	  // src/compiler/transformers/utilities.ts
	  function getOriginalNodeId(node) {
	    node = getOriginalNode(node);
	    return node ? getNodeId(node) : 0;
	  }
	  function containsDefaultReference(node) {
	    if (!node)
	      return false;
	    if (!isNamedImports(node))
	      return false;
	    return some(node.elements, isNamedDefaultReference);
	  }
	  function isNamedDefaultReference(e) {
	    return e.propertyName !== void 0 && e.propertyName.escapedText === "default" /* Default */;
	  }
	  function chainBundle(context, transformSourceFile) {
	    return transformSourceFileOrBundle;
	    function transformSourceFileOrBundle(node) {
	      return node.kind === 312 /* SourceFile */ ? transformSourceFile(node) : transformBundle(node);
	    }
	    function transformBundle(node) {
	      return context.factory.createBundle(map(node.sourceFiles, transformSourceFile), node.prepends);
	    }
	  }
	  function getExportNeedsImportStarHelper(node) {
	    return !!getNamespaceDeclarationNode(node);
	  }
	  function getImportNeedsImportStarHelper(node) {
	    if (!!getNamespaceDeclarationNode(node)) {
	      return true;
	    }
	    const bindings = node.importClause && node.importClause.namedBindings;
	    if (!bindings) {
	      return false;
	    }
	    if (!isNamedImports(bindings))
	      return false;
	    let defaultRefCount = 0;
	    for (const binding of bindings.elements) {
	      if (isNamedDefaultReference(binding)) {
	        defaultRefCount++;
	      }
	    }
	    return defaultRefCount > 0 && defaultRefCount !== bindings.elements.length || !!(bindings.elements.length - defaultRefCount) && isDefaultImport(node);
	  }
	  function getImportNeedsImportDefaultHelper(node) {
	    return !getImportNeedsImportStarHelper(node) && (isDefaultImport(node) || !!node.importClause && isNamedImports(node.importClause.namedBindings) && containsDefaultReference(node.importClause.namedBindings));
	  }
	  function collectExternalModuleInfo(context, sourceFile) {
	    const resolver = context.getEmitResolver();
	    const compilerOptions = context.getCompilerOptions();
	    const externalImports = [];
	    const exportSpecifiers = new IdentifierNameMultiMap();
	    const exportedBindings = [];
	    const uniqueExports = /* @__PURE__ */ new Map();
	    let exportedNames;
	    let hasExportDefault = false;
	    let exportEquals;
	    let hasExportStarsToExportValues = false;
	    let hasImportStar = false;
	    let hasImportDefault = false;
	    for (const node of sourceFile.statements) {
	      switch (node.kind) {
	        case 272 /* ImportDeclaration */:
	          externalImports.push(node);
	          if (!hasImportStar && getImportNeedsImportStarHelper(node)) {
	            hasImportStar = true;
	          }
	          if (!hasImportDefault && getImportNeedsImportDefaultHelper(node)) {
	            hasImportDefault = true;
	          }
	          break;
	        case 271 /* ImportEqualsDeclaration */:
	          if (node.moduleReference.kind === 283 /* ExternalModuleReference */) {
	            externalImports.push(node);
	          }
	          break;
	        case 278 /* ExportDeclaration */:
	          if (node.moduleSpecifier) {
	            if (!node.exportClause) {
	              externalImports.push(node);
	              hasExportStarsToExportValues = true;
	            } else {
	              externalImports.push(node);
	              if (isNamedExports(node.exportClause)) {
	                addExportedNamesForExportDeclaration(node);
	              } else {
	                const name = node.exportClause.name;
	                if (!uniqueExports.get(idText(name))) {
	                  multiMapSparseArrayAdd(exportedBindings, getOriginalNodeId(node), name);
	                  uniqueExports.set(idText(name), true);
	                  exportedNames = append(exportedNames, name);
	                }
	                hasImportStar = true;
	              }
	            }
	          } else {
	            addExportedNamesForExportDeclaration(node);
	          }
	          break;
	        case 277 /* ExportAssignment */:
	          if (node.isExportEquals && !exportEquals) {
	            exportEquals = node;
	          }
	          break;
	        case 243 /* VariableStatement */:
	          if (hasSyntacticModifier(node, 32 /* Export */)) {
	            for (const decl of node.declarationList.declarations) {
	              exportedNames = collectExportedVariableInfo(decl, uniqueExports, exportedNames, exportedBindings);
	            }
	          }
	          break;
	        case 262 /* FunctionDeclaration */:
	          if (hasSyntacticModifier(node, 32 /* Export */)) {
	            if (hasSyntacticModifier(node, 2048 /* Default */)) {
	              if (!hasExportDefault) {
	                multiMapSparseArrayAdd(exportedBindings, getOriginalNodeId(node), context.factory.getDeclarationName(node));
	                hasExportDefault = true;
	              }
	            } else {
	              const name = node.name;
	              if (!uniqueExports.get(idText(name))) {
	                multiMapSparseArrayAdd(exportedBindings, getOriginalNodeId(node), name);
	                uniqueExports.set(idText(name), true);
	                exportedNames = append(exportedNames, name);
	              }
	            }
	          }
	          break;
	        case 263 /* ClassDeclaration */:
	          if (hasSyntacticModifier(node, 32 /* Export */)) {
	            if (hasSyntacticModifier(node, 2048 /* Default */)) {
	              if (!hasExportDefault) {
	                multiMapSparseArrayAdd(exportedBindings, getOriginalNodeId(node), context.factory.getDeclarationName(node));
	                hasExportDefault = true;
	              }
	            } else {
	              const name = node.name;
	              if (name && !uniqueExports.get(idText(name))) {
	                multiMapSparseArrayAdd(exportedBindings, getOriginalNodeId(node), name);
	                uniqueExports.set(idText(name), true);
	                exportedNames = append(exportedNames, name);
	              }
	            }
	          }
	          break;
	      }
	    }
	    const externalHelpersImportDeclaration = createExternalHelpersImportDeclarationIfNeeded(context.factory, context.getEmitHelperFactory(), sourceFile, compilerOptions, hasExportStarsToExportValues, hasImportStar, hasImportDefault);
	    if (externalHelpersImportDeclaration) {
	      externalImports.unshift(externalHelpersImportDeclaration);
	    }
	    return { externalImports, exportSpecifiers, exportEquals, hasExportStarsToExportValues, exportedBindings, exportedNames, externalHelpersImportDeclaration };
	    function addExportedNamesForExportDeclaration(node) {
	      for (const specifier of cast(node.exportClause, isNamedExports).elements) {
	        if (!uniqueExports.get(idText(specifier.name))) {
	          const name = specifier.propertyName || specifier.name;
	          if (!node.moduleSpecifier) {
	            exportSpecifiers.add(name, specifier);
	          }
	          const decl = resolver.getReferencedImportDeclaration(name) || resolver.getReferencedValueDeclaration(name);
	          if (decl) {
	            multiMapSparseArrayAdd(exportedBindings, getOriginalNodeId(decl), specifier.name);
	          }
	          uniqueExports.set(idText(specifier.name), true);
	          exportedNames = append(exportedNames, specifier.name);
	        }
	      }
	    }
	  }
	  function collectExportedVariableInfo(decl, uniqueExports, exportedNames, exportedBindings) {
	    if (isBindingPattern(decl.name)) {
	      for (const element of decl.name.elements) {
	        if (!isOmittedExpression(element)) {
	          exportedNames = collectExportedVariableInfo(element, uniqueExports, exportedNames, exportedBindings);
	        }
	      }
	    } else if (!isGeneratedIdentifier(decl.name)) {
	      const text = idText(decl.name);
	      if (!uniqueExports.get(text)) {
	        uniqueExports.set(text, true);
	        exportedNames = append(exportedNames, decl.name);
	        if (isLocalName(decl.name)) {
	          multiMapSparseArrayAdd(exportedBindings, getOriginalNodeId(decl), decl.name);
	        }
	      }
	    }
	    return exportedNames;
	  }
	  function multiMapSparseArrayAdd(map2, key, value) {
	    let values = map2[key];
	    if (values) {
	      values.push(value);
	    } else {
	      map2[key] = values = [value];
	    }
	    return values;
	  }
	  function isSimpleCopiableExpression(expression) {
	    return isStringLiteralLike(expression) || expression.kind === 9 /* NumericLiteral */ || isKeyword(expression.kind) || isIdentifier(expression);
	  }
	  function isSimpleInlineableExpression(expression) {
	    return !isIdentifier(expression) && isSimpleCopiableExpression(expression);
	  }
	  function isCompoundAssignment(kind) {
	    return kind >= 65 /* FirstCompoundAssignment */ && kind <= 79 /* LastCompoundAssignment */;
	  }
	  function getNonAssignmentOperatorForCompoundAssignment(kind) {
	    switch (kind) {
	      case 65 /* PlusEqualsToken */:
	        return 40 /* PlusToken */;
	      case 66 /* MinusEqualsToken */:
	        return 41 /* MinusToken */;
	      case 67 /* AsteriskEqualsToken */:
	        return 42 /* AsteriskToken */;
	      case 68 /* AsteriskAsteriskEqualsToken */:
	        return 43 /* AsteriskAsteriskToken */;
	      case 69 /* SlashEqualsToken */:
	        return 44 /* SlashToken */;
	      case 70 /* PercentEqualsToken */:
	        return 45 /* PercentToken */;
	      case 71 /* LessThanLessThanEqualsToken */:
	        return 48 /* LessThanLessThanToken */;
	      case 72 /* GreaterThanGreaterThanEqualsToken */:
	        return 49 /* GreaterThanGreaterThanToken */;
	      case 73 /* GreaterThanGreaterThanGreaterThanEqualsToken */:
	        return 50 /* GreaterThanGreaterThanGreaterThanToken */;
	      case 74 /* AmpersandEqualsToken */:
	        return 51 /* AmpersandToken */;
	      case 75 /* BarEqualsToken */:
	        return 52 /* BarToken */;
	      case 79 /* CaretEqualsToken */:
	        return 53 /* CaretToken */;
	      case 76 /* BarBarEqualsToken */:
	        return 57 /* BarBarToken */;
	      case 77 /* AmpersandAmpersandEqualsToken */:
	        return 56 /* AmpersandAmpersandToken */;
	      case 78 /* QuestionQuestionEqualsToken */:
	        return 61 /* QuestionQuestionToken */;
	    }
	  }
	  function getSuperCallFromStatement(statement) {
	    if (!isExpressionStatement(statement)) {
	      return void 0;
	    }
	    const expression = skipParentheses(statement.expression);
	    return isSuperCall(expression) ? expression : void 0;
	  }
	  function findSuperStatementIndexPathWorker(statements, start, indices) {
	    for (let i = start; i < statements.length; i += 1) {
	      const statement = statements[i];
	      if (getSuperCallFromStatement(statement)) {
	        indices.unshift(i);
	        return true;
	      } else if (isTryStatement(statement) && findSuperStatementIndexPathWorker(statement.tryBlock.statements, 0, indices)) {
	        indices.unshift(i);
	        return true;
	      }
	    }
	    return false;
	  }
	  function findSuperStatementIndexPath(statements, start) {
	    const indices = [];
	    findSuperStatementIndexPathWorker(statements, start, indices);
	    return indices;
	  }
	  function getProperties(node, requireInitializer, isStatic2) {
	    return filter(node.members, (m) => isInitializedOrStaticProperty(m, requireInitializer, isStatic2));
	  }
	  function isStaticPropertyDeclarationOrClassStaticBlockDeclaration(element) {
	    return isStaticPropertyDeclaration(element) || isClassStaticBlockDeclaration(element);
	  }
	  function getStaticPropertiesAndClassStaticBlock(node) {
	    return filter(node.members, isStaticPropertyDeclarationOrClassStaticBlockDeclaration);
	  }
	  function isInitializedOrStaticProperty(member, requireInitializer, isStatic2) {
	    return isPropertyDeclaration(member) && (!!member.initializer || !requireInitializer) && hasStaticModifier(member) === isStatic2;
	  }
	  function isStaticPropertyDeclaration(member) {
	    return isPropertyDeclaration(member) && hasStaticModifier(member);
	  }
	  function isInitializedProperty(member) {
	    return member.kind === 172 /* PropertyDeclaration */ && member.initializer !== void 0;
	  }
	  function isNonStaticMethodOrAccessorWithPrivateName(member) {
	    return !isStatic(member) && (isMethodOrAccessor(member) || isAutoAccessorPropertyDeclaration(member)) && isPrivateIdentifier(member.name);
	  }
	  function getDecoratorsOfParameters(node) {
	    let decorators;
	    if (node) {
	      const parameters = node.parameters;
	      const firstParameterIsThis = parameters.length > 0 && parameterIsThisKeyword(parameters[0]);
	      const firstParameterOffset = firstParameterIsThis ? 1 : 0;
	      const numParameters = firstParameterIsThis ? parameters.length - 1 : parameters.length;
	      for (let i = 0; i < numParameters; i++) {
	        const parameter = parameters[i + firstParameterOffset];
	        if (decorators || hasDecorators(parameter)) {
	          if (!decorators) {
	            decorators = new Array(numParameters);
	          }
	          decorators[i] = getDecorators(parameter);
	        }
	      }
	    }
	    return decorators;
	  }
	  function getAllDecoratorsOfClass(node) {
	    const decorators = getDecorators(node);
	    const parameters = getDecoratorsOfParameters(getFirstConstructorWithBody(node));
	    if (!some(decorators) && !some(parameters)) {
	      return void 0;
	    }
	    return {
	      decorators,
	      parameters
	    };
	  }
	  function getAllDecoratorsOfClassElement(member, parent2, useLegacyDecorators) {
	    switch (member.kind) {
	      case 177 /* GetAccessor */:
	      case 178 /* SetAccessor */:
	        if (!useLegacyDecorators) {
	          return getAllDecoratorsOfMethod(member);
	        }
	        return getAllDecoratorsOfAccessors(member, parent2);
	      case 174 /* MethodDeclaration */:
	        return getAllDecoratorsOfMethod(member);
	      case 172 /* PropertyDeclaration */:
	        return getAllDecoratorsOfProperty(member);
	      default:
	        return void 0;
	    }
	  }
	  function getAllDecoratorsOfAccessors(accessor, parent2) {
	    if (!accessor.body) {
	      return void 0;
	    }
	    const { firstAccessor, secondAccessor, getAccessor, setAccessor } = getAllAccessorDeclarations(parent2.members, accessor);
	    const firstAccessorWithDecorators = hasDecorators(firstAccessor) ? firstAccessor : secondAccessor && hasDecorators(secondAccessor) ? secondAccessor : void 0;
	    if (!firstAccessorWithDecorators || accessor !== firstAccessorWithDecorators) {
	      return void 0;
	    }
	    const decorators = getDecorators(firstAccessorWithDecorators);
	    const parameters = getDecoratorsOfParameters(setAccessor);
	    if (!some(decorators) && !some(parameters)) {
	      return void 0;
	    }
	    return {
	      decorators,
	      parameters,
	      getDecorators: getAccessor && getDecorators(getAccessor),
	      setDecorators: setAccessor && getDecorators(setAccessor)
	    };
	  }
	  function getAllDecoratorsOfMethod(method) {
	    if (!method.body) {
	      return void 0;
	    }
	    const decorators = getDecorators(method);
	    const parameters = getDecoratorsOfParameters(method);
	    if (!some(decorators) && !some(parameters)) {
	      return void 0;
	    }
	    return { decorators, parameters };
	  }
	  function getAllDecoratorsOfProperty(property) {
	    const decorators = getDecorators(property);
	    if (!some(decorators)) {
	      return void 0;
	    }
	    return { decorators };
	  }
	  function walkUpLexicalEnvironments(env, cb) {
	    while (env) {
	      const result = cb(env);
	      if (result !== void 0)
	        return result;
	      env = env.previous;
	    }
	  }
	  function newPrivateEnvironment(data) {
	    return { data };
	  }
	  function getPrivateIdentifier(privateEnv, name) {
	    var _a, _b;
	    return isGeneratedPrivateIdentifier(name) ? (_a = privateEnv == null ? void 0 : privateEnv.generatedIdentifiers) == null ? void 0 : _a.get(getNodeForGeneratedName(name)) : (_b = privateEnv == null ? void 0 : privateEnv.identifiers) == null ? void 0 : _b.get(name.escapedText);
	  }
	  function setPrivateIdentifier(privateEnv, name, entry) {
	    if (isGeneratedPrivateIdentifier(name)) {
	      privateEnv.generatedIdentifiers ?? (privateEnv.generatedIdentifiers = /* @__PURE__ */ new Map());
	      privateEnv.generatedIdentifiers.set(getNodeForGeneratedName(name), entry);
	    } else {
	      privateEnv.identifiers ?? (privateEnv.identifiers = /* @__PURE__ */ new Map());
	      privateEnv.identifiers.set(name.escapedText, entry);
	    }
	  }
	  function accessPrivateIdentifier(env, name) {
	    return walkUpLexicalEnvironments(env, (env2) => getPrivateIdentifier(env2.privateEnv, name));
	  }
	  function isSimpleParameter(node) {
	    return !node.initializer && isIdentifier(node.name);
	  }
	  function isSimpleParameterList(nodes) {
	    return every(nodes, isSimpleParameter);
	  }
	  var IdentifierNameMap, IdentifierNameMultiMap;
	  var init_utilities3 = __esm({
	    "src/compiler/transformers/utilities.ts"() {
	      init_ts2();
	      IdentifierNameMap = class _IdentifierNameMap {
	        constructor() {
	          this._map = /* @__PURE__ */ new Map();
	        }
	        get size() {
	          return this._map.size;
	        }
	        has(key) {
	          return this._map.has(_IdentifierNameMap.toKey(key));
	        }
	        get(key) {
	          return this._map.get(_IdentifierNameMap.toKey(key));
	        }
	        set(key, value) {
	          this._map.set(_IdentifierNameMap.toKey(key), value);
	          return this;
	        }
	        delete(key) {
	          var _a;
	          return ((_a = this._map) == null ? void 0 : _a.delete(_IdentifierNameMap.toKey(key))) ?? false;
	        }
	        clear() {
	          this._map.clear();
	        }
	        values() {
	          return this._map.values();
	        }
	        static toKey(name) {
	          if (isGeneratedPrivateIdentifier(name) || isGeneratedIdentifier(name)) {
	            const autoGenerate = name.emitNode.autoGenerate;
	            if ((autoGenerate.flags & 7 /* KindMask */) === 4 /* Node */) {
	              const node = getNodeForGeneratedName(name);
	              const baseName = isMemberName(node) && node !== name ? _IdentifierNameMap.toKey(node) : `(generated@${getNodeId(node)})`;
	              return formatGeneratedName(
	                /*privateName*/
	                false,
	                autoGenerate.prefix,
	                baseName,
	                autoGenerate.suffix,
	                _IdentifierNameMap.toKey
	              );
	            } else {
	              const baseName = `(auto@${autoGenerate.id})`;
	              return formatGeneratedName(
	                /*privateName*/
	                false,
	                autoGenerate.prefix,
	                baseName,
	                autoGenerate.suffix,
	                _IdentifierNameMap.toKey
	              );
	            }
	          }
	          if (isPrivateIdentifier(name)) {
	            return idText(name).slice(1);
	          }
	          return idText(name);
	        }
	      };
	      IdentifierNameMultiMap = class extends IdentifierNameMap {
	        add(key, value) {
	          let values = this.get(key);
	          if (values) {
	            values.push(value);
	          } else {
	            this.set(key, values = [value]);
	          }
	          return values;
	        }
	        remove(key, value) {
	          const values = this.get(key);
	          if (values) {
	            unorderedRemoveItem(values, value);
	            if (!values.length) {
	              this.delete(key);
	            }
	          }
	        }
	      };
	    }
	  });

	  // src/compiler/transformers/destructuring.ts
	  function flattenDestructuringAssignment(node, visitor, context, level, needsValue, createAssignmentCallback) {
	    let location = node;
	    let value;
	    if (isDestructuringAssignment(node)) {
	      value = node.right;
	      while (isEmptyArrayLiteral(node.left) || isEmptyObjectLiteral(node.left)) {
	        if (isDestructuringAssignment(value)) {
	          location = node = value;
	          value = node.right;
	        } else {
	          return Debug.checkDefined(visitNode(value, visitor, isExpression));
	        }
	      }
	    }
	    let expressions;
	    const flattenContext = {
	      context,
	      level,
	      downlevelIteration: !!context.getCompilerOptions().downlevelIteration,
	      hoistTempVariables: true,
	      emitExpression,
	      emitBindingOrAssignment,
	      createArrayBindingOrAssignmentPattern: (elements) => makeArrayAssignmentPattern(context.factory, elements),
	      createObjectBindingOrAssignmentPattern: (elements) => makeObjectAssignmentPattern(context.factory, elements),
	      createArrayBindingOrAssignmentElement: makeAssignmentElement,
	      visitor
	    };
	    if (value) {
	      value = visitNode(value, visitor, isExpression);
	      Debug.assert(value);
	      if (isIdentifier(value) && bindingOrAssignmentElementAssignsToName(node, value.escapedText) || bindingOrAssignmentElementContainsNonLiteralComputedName(node)) {
	        value = ensureIdentifier(
	          flattenContext,
	          value,
	          /*reuseIdentifierExpressions*/
	          false,
	          location
	        );
	      } else if (needsValue) {
	        value = ensureIdentifier(
	          flattenContext,
	          value,
	          /*reuseIdentifierExpressions*/
	          true,
	          location
	        );
	      } else if (nodeIsSynthesized(node)) {
	        location = value;
	      }
	    }
	    flattenBindingOrAssignmentElement(
	      flattenContext,
	      node,
	      value,
	      location,
	      /*skipInitializer*/
	      isDestructuringAssignment(node)
	    );
	    if (value && needsValue) {
	      if (!some(expressions)) {
	        return value;
	      }
	      expressions.push(value);
	    }
	    return context.factory.inlineExpressions(expressions) || context.factory.createOmittedExpression();
	    function emitExpression(expression) {
	      expressions = append(expressions, expression);
	    }
	    function emitBindingOrAssignment(target, value2, location2, original) {
	      Debug.assertNode(target, createAssignmentCallback ? isIdentifier : isExpression);
	      const expression = createAssignmentCallback ? createAssignmentCallback(target, value2, location2) : setTextRange(
	        context.factory.createAssignment(Debug.checkDefined(visitNode(target, visitor, isExpression)), value2),
	        location2
	      );
	      expression.original = original;
	      emitExpression(expression);
	    }
	  }
	  function bindingOrAssignmentElementAssignsToName(element, escapedName) {
	    const target = getTargetOfBindingOrAssignmentElement(element);
	    if (isBindingOrAssignmentPattern(target)) {
	      return bindingOrAssignmentPatternAssignsToName(target, escapedName);
	    } else if (isIdentifier(target)) {
	      return target.escapedText === escapedName;
	    }
	    return false;
	  }
	  function bindingOrAssignmentPatternAssignsToName(pattern, escapedName) {
	    const elements = getElementsOfBindingOrAssignmentPattern(pattern);
	    for (const element of elements) {
	      if (bindingOrAssignmentElementAssignsToName(element, escapedName)) {
	        return true;
	      }
	    }
	    return false;
	  }
	  function bindingOrAssignmentElementContainsNonLiteralComputedName(element) {
	    const propertyName = tryGetPropertyNameOfBindingOrAssignmentElement(element);
	    if (propertyName && isComputedPropertyName(propertyName) && !isLiteralExpression(propertyName.expression)) {
	      return true;
	    }
	    const target = getTargetOfBindingOrAssignmentElement(element);
	    return !!target && isBindingOrAssignmentPattern(target) && bindingOrAssignmentPatternContainsNonLiteralComputedName(target);
	  }
	  function bindingOrAssignmentPatternContainsNonLiteralComputedName(pattern) {
	    return !!forEach(getElementsOfBindingOrAssignmentPattern(pattern), bindingOrAssignmentElementContainsNonLiteralComputedName);
	  }
	  function flattenDestructuringBinding(node, visitor, context, level, rval, hoistTempVariables = false, skipInitializer) {
	    let pendingExpressions;
	    const pendingDeclarations = [];
	    const declarations = [];
	    const flattenContext = {
	      context,
	      level,
	      downlevelIteration: !!context.getCompilerOptions().downlevelIteration,
	      hoistTempVariables,
	      emitExpression,
	      emitBindingOrAssignment,
	      createArrayBindingOrAssignmentPattern: (elements) => makeArrayBindingPattern(context.factory, elements),
	      createObjectBindingOrAssignmentPattern: (elements) => makeObjectBindingPattern(context.factory, elements),
	      createArrayBindingOrAssignmentElement: (name) => makeBindingElement(context.factory, name),
	      visitor
	    };
	    if (isVariableDeclaration(node)) {
	      let initializer = getInitializerOfBindingOrAssignmentElement(node);
	      if (initializer && (isIdentifier(initializer) && bindingOrAssignmentElementAssignsToName(node, initializer.escapedText) || bindingOrAssignmentElementContainsNonLiteralComputedName(node))) {
	        initializer = ensureIdentifier(
	          flattenContext,
	          Debug.checkDefined(visitNode(initializer, flattenContext.visitor, isExpression)),
	          /*reuseIdentifierExpressions*/
	          false,
	          initializer
	        );
	        node = context.factory.updateVariableDeclaration(
	          node,
	          node.name,
	          /*exclamationToken*/
	          void 0,
	          /*type*/
	          void 0,
	          initializer
	        );
	      }
	    }
	    flattenBindingOrAssignmentElement(flattenContext, node, rval, node, skipInitializer);
	    if (pendingExpressions) {
	      const temp = context.factory.createTempVariable(
	        /*recordTempVariable*/
	        void 0
	      );
	      if (hoistTempVariables) {
	        const value = context.factory.inlineExpressions(pendingExpressions);
	        pendingExpressions = void 0;
	        emitBindingOrAssignment(
	          temp,
	          value,
	          /*location*/
	          void 0,
	          /*original*/
	          void 0
	        );
	      } else {
	        context.hoistVariableDeclaration(temp);
	        const pendingDeclaration = last(pendingDeclarations);
	        pendingDeclaration.pendingExpressions = append(
	          pendingDeclaration.pendingExpressions,
	          context.factory.createAssignment(temp, pendingDeclaration.value)
	        );
	        addRange(pendingDeclaration.pendingExpressions, pendingExpressions);
	        pendingDeclaration.value = temp;
	      }
	    }
	    for (const { pendingExpressions: pendingExpressions2, name, value, location, original } of pendingDeclarations) {
	      const variable = context.factory.createVariableDeclaration(
	        name,
	        /*exclamationToken*/
	        void 0,
	        /*type*/
	        void 0,
	        pendingExpressions2 ? context.factory.inlineExpressions(append(pendingExpressions2, value)) : value
	      );
	      variable.original = original;
	      setTextRange(variable, location);
	      declarations.push(variable);
	    }
	    return declarations;
	    function emitExpression(value) {
	      pendingExpressions = append(pendingExpressions, value);
	    }
	    function emitBindingOrAssignment(target, value, location, original) {
	      Debug.assertNode(target, isBindingName);
	      if (pendingExpressions) {
	        value = context.factory.inlineExpressions(append(pendingExpressions, value));
	        pendingExpressions = void 0;
	      }
	      pendingDeclarations.push({ pendingExpressions, name: target, value, location, original });
	    }
	  }
	  function flattenBindingOrAssignmentElement(flattenContext, element, value, location, skipInitializer) {
	    const bindingTarget = getTargetOfBindingOrAssignmentElement(element);
	    if (!skipInitializer) {
	      const initializer = visitNode(getInitializerOfBindingOrAssignmentElement(element), flattenContext.visitor, isExpression);
	      if (initializer) {
	        if (value) {
	          value = createDefaultValueCheck(flattenContext, value, initializer, location);
	          if (!isSimpleInlineableExpression(initializer) && isBindingOrAssignmentPattern(bindingTarget)) {
	            value = ensureIdentifier(
	              flattenContext,
	              value,
	              /*reuseIdentifierExpressions*/
	              true,
	              location
	            );
	          }
	        } else {
	          value = initializer;
	        }
	      } else if (!value) {
	        value = flattenContext.context.factory.createVoidZero();
	      }
	    }
	    if (isObjectBindingOrAssignmentPattern(bindingTarget)) {
	      flattenObjectBindingOrAssignmentPattern(flattenContext, element, bindingTarget, value, location);
	    } else if (isArrayBindingOrAssignmentPattern(bindingTarget)) {
	      flattenArrayBindingOrAssignmentPattern(flattenContext, element, bindingTarget, value, location);
	    } else {
	      flattenContext.emitBindingOrAssignment(
	        bindingTarget,
	        value,
	        location,
	        /*original*/
	        element
	      );
	    }
	  }
	  function flattenObjectBindingOrAssignmentPattern(flattenContext, parent2, pattern, value, location) {
	    const elements = getElementsOfBindingOrAssignmentPattern(pattern);
	    const numElements = elements.length;
	    if (numElements !== 1) {
	      const reuseIdentifierExpressions = !isDeclarationBindingElement(parent2) || numElements !== 0;
	      value = ensureIdentifier(flattenContext, value, reuseIdentifierExpressions, location);
	    }
	    let bindingElements;
	    let computedTempVariables;
	    for (let i = 0; i < numElements; i++) {
	      const element = elements[i];
	      if (!getRestIndicatorOfBindingOrAssignmentElement(element)) {
	        const propertyName = getPropertyNameOfBindingOrAssignmentElement(element);
	        if (flattenContext.level >= 1 /* ObjectRest */ && !(element.transformFlags & (32768 /* ContainsRestOrSpread */ | 65536 /* ContainsObjectRestOrSpread */)) && !(getTargetOfBindingOrAssignmentElement(element).transformFlags & (32768 /* ContainsRestOrSpread */ | 65536 /* ContainsObjectRestOrSpread */)) && !isComputedPropertyName(propertyName)) {
	          bindingElements = append(bindingElements, visitNode(element, flattenContext.visitor, isBindingOrAssignmentElement));
	        } else {
	          if (bindingElements) {
	            flattenContext.emitBindingOrAssignment(flattenContext.createObjectBindingOrAssignmentPattern(bindingElements), value, location, pattern);
	            bindingElements = void 0;
	          }
	          const rhsValue = createDestructuringPropertyAccess(flattenContext, value, propertyName);
	          if (isComputedPropertyName(propertyName)) {
	            computedTempVariables = append(computedTempVariables, rhsValue.argumentExpression);
	          }
	          flattenBindingOrAssignmentElement(
	            flattenContext,
	            element,
	            rhsValue,
	            /*location*/
	            element
	          );
	        }
	      } else if (i === numElements - 1) {
	        if (bindingElements) {
	          flattenContext.emitBindingOrAssignment(flattenContext.createObjectBindingOrAssignmentPattern(bindingElements), value, location, pattern);
	          bindingElements = void 0;
	        }
	        const rhsValue = flattenContext.context.getEmitHelperFactory().createRestHelper(value, elements, computedTempVariables, pattern);
	        flattenBindingOrAssignmentElement(flattenContext, element, rhsValue, element);
	      }
	    }
	    if (bindingElements) {
	      flattenContext.emitBindingOrAssignment(flattenContext.createObjectBindingOrAssignmentPattern(bindingElements), value, location, pattern);
	    }
	  }
	  function flattenArrayBindingOrAssignmentPattern(flattenContext, parent2, pattern, value, location) {
	    const elements = getElementsOfBindingOrAssignmentPattern(pattern);
	    const numElements = elements.length;
	    if (flattenContext.level < 1 /* ObjectRest */ && flattenContext.downlevelIteration) {
	      value = ensureIdentifier(
	        flattenContext,
	        setTextRange(
	          flattenContext.context.getEmitHelperFactory().createReadHelper(
	            value,
	            numElements > 0 && getRestIndicatorOfBindingOrAssignmentElement(elements[numElements - 1]) ? void 0 : numElements
	          ),
	          location
	        ),
	        /*reuseIdentifierExpressions*/
	        false,
	        location
	      );
	    } else if (numElements !== 1 && (flattenContext.level < 1 /* ObjectRest */ || numElements === 0) || every(elements, isOmittedExpression)) {
	      const reuseIdentifierExpressions = !isDeclarationBindingElement(parent2) || numElements !== 0;
	      value = ensureIdentifier(flattenContext, value, reuseIdentifierExpressions, location);
	    }
	    let bindingElements;
	    let restContainingElements;
	    for (let i = 0; i < numElements; i++) {
	      const element = elements[i];
	      if (flattenContext.level >= 1 /* ObjectRest */) {
	        if (element.transformFlags & 65536 /* ContainsObjectRestOrSpread */ || flattenContext.hasTransformedPriorElement && !isSimpleBindingOrAssignmentElement(element)) {
	          flattenContext.hasTransformedPriorElement = true;
	          const temp = flattenContext.context.factory.createTempVariable(
	            /*recordTempVariable*/
	            void 0
	          );
	          if (flattenContext.hoistTempVariables) {
	            flattenContext.context.hoistVariableDeclaration(temp);
	          }
	          restContainingElements = append(restContainingElements, [temp, element]);
	          bindingElements = append(bindingElements, flattenContext.createArrayBindingOrAssignmentElement(temp));
	        } else {
	          bindingElements = append(bindingElements, element);
	        }
	      } else if (isOmittedExpression(element)) {
	        continue;
	      } else if (!getRestIndicatorOfBindingOrAssignmentElement(element)) {
	        const rhsValue = flattenContext.context.factory.createElementAccessExpression(value, i);
	        flattenBindingOrAssignmentElement(
	          flattenContext,
	          element,
	          rhsValue,
	          /*location*/
	          element
	        );
	      } else if (i === numElements - 1) {
	        const rhsValue = flattenContext.context.factory.createArraySliceCall(value, i);
	        flattenBindingOrAssignmentElement(
	          flattenContext,
	          element,
	          rhsValue,
	          /*location*/
	          element
	        );
	      }
	    }
	    if (bindingElements) {
	      flattenContext.emitBindingOrAssignment(flattenContext.createArrayBindingOrAssignmentPattern(bindingElements), value, location, pattern);
	    }
	    if (restContainingElements) {
	      for (const [id, element] of restContainingElements) {
	        flattenBindingOrAssignmentElement(flattenContext, element, id, element);
	      }
	    }
	  }
	  function isSimpleBindingOrAssignmentElement(element) {
	    const target = getTargetOfBindingOrAssignmentElement(element);
	    if (!target || isOmittedExpression(target))
	      return true;
	    const propertyName = tryGetPropertyNameOfBindingOrAssignmentElement(element);
	    if (propertyName && !isPropertyNameLiteral(propertyName))
	      return false;
	    const initializer = getInitializerOfBindingOrAssignmentElement(element);
	    if (initializer && !isSimpleInlineableExpression(initializer))
	      return false;
	    if (isBindingOrAssignmentPattern(target))
	      return every(getElementsOfBindingOrAssignmentPattern(target), isSimpleBindingOrAssignmentElement);
	    return isIdentifier(target);
	  }
	  function createDefaultValueCheck(flattenContext, value, defaultValue, location) {
	    value = ensureIdentifier(
	      flattenContext,
	      value,
	      /*reuseIdentifierExpressions*/
	      true,
	      location
	    );
	    return flattenContext.context.factory.createConditionalExpression(
	      flattenContext.context.factory.createTypeCheck(value, "undefined"),
	      /*questionToken*/
	      void 0,
	      defaultValue,
	      /*colonToken*/
	      void 0,
	      value
	    );
	  }
	  function createDestructuringPropertyAccess(flattenContext, value, propertyName) {
	    const { factory: factory2 } = flattenContext.context;
	    if (isComputedPropertyName(propertyName)) {
	      const argumentExpression = ensureIdentifier(
	        flattenContext,
	        Debug.checkDefined(visitNode(propertyName.expression, flattenContext.visitor, isExpression)),
	        /*reuseIdentifierExpressions*/
	        false,
	        /*location*/
	        propertyName
	      );
	      return flattenContext.context.factory.createElementAccessExpression(value, argumentExpression);
	    } else if (isStringOrNumericLiteralLike(propertyName)) {
	      const argumentExpression = factory2.cloneNode(propertyName);
	      return flattenContext.context.factory.createElementAccessExpression(value, argumentExpression);
	    } else {
	      const name = flattenContext.context.factory.createIdentifier(idText(propertyName));
	      return flattenContext.context.factory.createPropertyAccessExpression(value, name);
	    }
	  }
	  function ensureIdentifier(flattenContext, value, reuseIdentifierExpressions, location) {
	    if (isIdentifier(value) && reuseIdentifierExpressions) {
	      return value;
	    } else {
	      const temp = flattenContext.context.factory.createTempVariable(
	        /*recordTempVariable*/
	        void 0
	      );
	      if (flattenContext.hoistTempVariables) {
	        flattenContext.context.hoistVariableDeclaration(temp);
	        flattenContext.emitExpression(setTextRange(flattenContext.context.factory.createAssignment(temp, value), location));
	      } else {
	        flattenContext.emitBindingOrAssignment(
	          temp,
	          value,
	          location,
	          /*original*/
	          void 0
	        );
	      }
	      return temp;
	    }
	  }
	  function makeArrayBindingPattern(factory2, elements) {
	    Debug.assertEachNode(elements, isArrayBindingElement);
	    return factory2.createArrayBindingPattern(elements);
	  }
	  function makeArrayAssignmentPattern(factory2, elements) {
	    Debug.assertEachNode(elements, isArrayBindingOrAssignmentElement);
	    return factory2.createArrayLiteralExpression(map(elements, factory2.converters.convertToArrayAssignmentElement));
	  }
	  function makeObjectBindingPattern(factory2, elements) {
	    Debug.assertEachNode(elements, isBindingElement);
	    return factory2.createObjectBindingPattern(elements);
	  }
	  function makeObjectAssignmentPattern(factory2, elements) {
	    Debug.assertEachNode(elements, isObjectBindingOrAssignmentElement);
	    return factory2.createObjectLiteralExpression(map(elements, factory2.converters.convertToObjectAssignmentElement));
	  }
	  function makeBindingElement(factory2, name) {
	    return factory2.createBindingElement(
	      /*dotDotDotToken*/
	      void 0,
	      /*propertyName*/
	      void 0,
	      name
	    );
	  }
	  function makeAssignmentElement(name) {
	    return name;
	  }
	  var FlattenLevel;
	  var init_destructuring = __esm({
	    "src/compiler/transformers/destructuring.ts"() {
	      init_ts2();
	      FlattenLevel = /* @__PURE__ */ ((FlattenLevel2) => {
	        FlattenLevel2[FlattenLevel2["All"] = 0] = "All";
	        FlattenLevel2[FlattenLevel2["ObjectRest"] = 1] = "ObjectRest";
	        return FlattenLevel2;
	      })(FlattenLevel || {});
	    }
	  });

	  // src/compiler/transformers/classThis.ts
	  function createClassThisAssignmentBlock(factory2, classThis, thisExpression = factory2.createThis()) {
	    const expression = factory2.createAssignment(classThis, thisExpression);
	    const statement = factory2.createExpressionStatement(expression);
	    const body = factory2.createBlock(
	      [statement],
	      /*multiLine*/
	      false
	    );
	    const block = factory2.createClassStaticBlockDeclaration(body);
	    getOrCreateEmitNode(block).classThis = classThis;
	    return block;
	  }
	  function isClassThisAssignmentBlock(node) {
	    var _a;
	    if (!isClassStaticBlockDeclaration(node) || node.body.statements.length !== 1) {
	      return false;
	    }
	    const statement = node.body.statements[0];
	    return isExpressionStatement(statement) && isAssignmentExpression(
	      statement.expression,
	      /*excludeCompoundAssignment*/
	      true
	    ) && isIdentifier(statement.expression.left) && ((_a = node.emitNode) == null ? void 0 : _a.classThis) === statement.expression.left && statement.expression.right.kind === 110 /* ThisKeyword */;
	  }
	  function classHasClassThisAssignment(node) {
	    var _a;
	    return !!((_a = node.emitNode) == null ? void 0 : _a.classThis) && some(node.members, isClassThisAssignmentBlock);
	  }
	  function injectClassThisAssignmentIfMissing(factory2, node, classThis, thisExpression) {
	    if (classHasClassThisAssignment(node)) {
	      return node;
	    }
	    const staticBlock = createClassThisAssignmentBlock(factory2, classThis, thisExpression);
	    if (node.name) {
	      setSourceMapRange(staticBlock.body.statements[0], node.name);
	    }
	    const members = factory2.createNodeArray([staticBlock, ...node.members]);
	    setTextRange(members, node.members);
	    const updatedNode = isClassDeclaration(node) ? factory2.updateClassDeclaration(
	      node,
	      node.modifiers,
	      node.name,
	      node.typeParameters,
	      node.heritageClauses,
	      members
	    ) : factory2.updateClassExpression(
	      node,
	      node.modifiers,
	      node.name,
	      node.typeParameters,
	      node.heritageClauses,
	      members
	    );
	    getOrCreateEmitNode(updatedNode).classThis = classThis;
	    return updatedNode;
	  }
	  var init_classThis = __esm({
	    "src/compiler/transformers/classThis.ts"() {
	      init_ts2();
	    }
	  });

	  // src/compiler/transformers/namedEvaluation.ts
	  function getAssignedNameOfIdentifier(factory2, name, expression) {
	    const original = getOriginalNode(skipOuterExpressions(expression));
	    if ((isClassDeclaration(original) || isFunctionDeclaration(original)) && !original.name && hasSyntacticModifier(original, 2048 /* Default */)) {
	      return factory2.createStringLiteral("default");
	    }
	    return factory2.createStringLiteralFromNode(name);
	  }
	  function getAssignedNameOfPropertyName(context, name, assignedNameText) {
	    const { factory: factory2 } = context;
	    if (assignedNameText !== void 0) {
	      const assignedName2 = factory2.createStringLiteral(assignedNameText);
	      return { assignedName: assignedName2, name };
	    }
	    if (isPropertyNameLiteral(name) || isPrivateIdentifier(name)) {
	      const assignedName2 = factory2.createStringLiteralFromNode(name);
	      return { assignedName: assignedName2, name };
	    }
	    if (isPropertyNameLiteral(name.expression) && !isIdentifier(name.expression)) {
	      const assignedName2 = factory2.createStringLiteralFromNode(name.expression);
	      return { assignedName: assignedName2, name };
	    }
	    const assignedName = factory2.getGeneratedNameForNode(name);
	    context.hoistVariableDeclaration(assignedName);
	    const key = context.getEmitHelperFactory().createPropKeyHelper(name.expression);
	    const assignment = factory2.createAssignment(assignedName, key);
	    const updatedName = factory2.updateComputedPropertyName(name, assignment);
	    return { assignedName, name: updatedName };
	  }
	  function createClassNamedEvaluationHelperBlock(context, assignedName, thisExpression = context.factory.createThis()) {
	    const { factory: factory2 } = context;
	    const expression = context.getEmitHelperFactory().createSetFunctionNameHelper(thisExpression, assignedName);
	    const statement = factory2.createExpressionStatement(expression);
	    const body = factory2.createBlock(
	      [statement],
	      /*multiLine*/
	      false
	    );
	    const block = factory2.createClassStaticBlockDeclaration(body);
	    getOrCreateEmitNode(block).assignedName = assignedName;
	    return block;
	  }
	  function isClassNamedEvaluationHelperBlock(node) {
	    var _a;
	    if (!isClassStaticBlockDeclaration(node) || node.body.statements.length !== 1) {
	      return false;
	    }
	    const statement = node.body.statements[0];
	    return isExpressionStatement(statement) && isCallToHelper(statement.expression, "___setFunctionName") && statement.expression.arguments.length >= 2 && statement.expression.arguments[1] === ((_a = node.emitNode) == null ? void 0 : _a.assignedName);
	  }
	  function classHasExplicitlyAssignedName(node) {
	    var _a;
	    return !!((_a = node.emitNode) == null ? void 0 : _a.assignedName) && some(node.members, isClassNamedEvaluationHelperBlock);
	  }
	  function classHasDeclaredOrExplicitlyAssignedName(node) {
	    return !!node.name || classHasExplicitlyAssignedName(node);
	  }
	  function injectClassNamedEvaluationHelperBlockIfMissing(context, node, assignedName, thisExpression) {
	    if (classHasExplicitlyAssignedName(node)) {
	      return node;
	    }
	    const { factory: factory2 } = context;
	    const namedEvaluationBlock = createClassNamedEvaluationHelperBlock(context, assignedName, thisExpression);
	    if (node.name) {
	      setSourceMapRange(namedEvaluationBlock.body.statements[0], node.name);
	    }
	    const insertionIndex = findIndex(node.members, isClassThisAssignmentBlock) + 1;
	    const leading = node.members.slice(0, insertionIndex);
	    const trailing = node.members.slice(insertionIndex);
	    const members = factory2.createNodeArray([...leading, namedEvaluationBlock, ...trailing]);
	    setTextRange(members, node.members);
	    node = isClassDeclaration(node) ? factory2.updateClassDeclaration(
	      node,
	      node.modifiers,
	      node.name,
	      node.typeParameters,
	      node.heritageClauses,
	      members
	    ) : factory2.updateClassExpression(
	      node,
	      node.modifiers,
	      node.name,
	      node.typeParameters,
	      node.heritageClauses,
	      members
	    );
	    getOrCreateEmitNode(node).assignedName = assignedName;
	    return node;
	  }
	  function finishTransformNamedEvaluation(context, expression, assignedName, ignoreEmptyStringLiteral) {
	    if (ignoreEmptyStringLiteral && isStringLiteral(assignedName) && isEmptyStringLiteral(assignedName)) {
	      return expression;
	    }
	    const { factory: factory2 } = context;
	    const innerExpression = skipOuterExpressions(expression);
	    const updatedExpression = isClassExpression(innerExpression) ? cast(injectClassNamedEvaluationHelperBlockIfMissing(context, innerExpression, assignedName), isClassExpression) : context.getEmitHelperFactory().createSetFunctionNameHelper(innerExpression, assignedName);
	    return factory2.restoreOuterExpressions(expression, updatedExpression);
	  }
	  function transformNamedEvaluationOfPropertyAssignment(context, node, ignoreEmptyStringLiteral, assignedNameText) {
	    const { factory: factory2 } = context;
	    const { assignedName, name } = getAssignedNameOfPropertyName(context, node.name, assignedNameText);
	    const initializer = finishTransformNamedEvaluation(context, node.initializer, assignedName, ignoreEmptyStringLiteral);
	    return factory2.updatePropertyAssignment(
	      node,
	      name,
	      initializer
	    );
	  }
	  function transformNamedEvaluationOfShorthandAssignmentProperty(context, node, ignoreEmptyStringLiteral, assignedNameText) {
	    const { factory: factory2 } = context;
	    const assignedName = assignedNameText !== void 0 ? factory2.createStringLiteral(assignedNameText) : getAssignedNameOfIdentifier(factory2, node.name, node.objectAssignmentInitializer);
	    const objectAssignmentInitializer = finishTransformNamedEvaluation(context, node.objectAssignmentInitializer, assignedName, ignoreEmptyStringLiteral);
	    return factory2.updateShorthandPropertyAssignment(
	      node,
	      node.name,
	      objectAssignmentInitializer
	    );
	  }
	  function transformNamedEvaluationOfVariableDeclaration(context, node, ignoreEmptyStringLiteral, assignedNameText) {
	    const { factory: factory2 } = context;
	    const assignedName = assignedNameText !== void 0 ? factory2.createStringLiteral(assignedNameText) : getAssignedNameOfIdentifier(factory2, node.name, node.initializer);
	    const initializer = finishTransformNamedEvaluation(context, node.initializer, assignedName, ignoreEmptyStringLiteral);
	    return factory2.updateVariableDeclaration(
	      node,
	      node.name,
	      node.exclamationToken,
	      node.type,
	      initializer
	    );
	  }
	  function transformNamedEvaluationOfParameterDeclaration(context, node, ignoreEmptyStringLiteral, assignedNameText) {
	    const { factory: factory2 } = context;
	    const assignedName = assignedNameText !== void 0 ? factory2.createStringLiteral(assignedNameText) : getAssignedNameOfIdentifier(factory2, node.name, node.initializer);
	    const initializer = finishTransformNamedEvaluation(context, node.initializer, assignedName, ignoreEmptyStringLiteral);
	    return factory2.updateParameterDeclaration(
	      node,
	      node.modifiers,
	      node.dotDotDotToken,
	      node.name,
	      node.questionToken,
	      node.type,
	      initializer
	    );
	  }
	  function transformNamedEvaluationOfBindingElement(context, node, ignoreEmptyStringLiteral, assignedNameText) {
	    const { factory: factory2 } = context;
	    const assignedName = assignedNameText !== void 0 ? factory2.createStringLiteral(assignedNameText) : getAssignedNameOfIdentifier(factory2, node.name, node.initializer);
	    const initializer = finishTransformNamedEvaluation(context, node.initializer, assignedName, ignoreEmptyStringLiteral);
	    return factory2.updateBindingElement(
	      node,
	      node.dotDotDotToken,
	      node.propertyName,
	      node.name,
	      initializer
	    );
	  }
	  function transformNamedEvaluationOfPropertyDeclaration(context, node, ignoreEmptyStringLiteral, assignedNameText) {
	    const { factory: factory2 } = context;
	    const { assignedName, name } = getAssignedNameOfPropertyName(context, node.name, assignedNameText);
	    const initializer = finishTransformNamedEvaluation(context, node.initializer, assignedName, ignoreEmptyStringLiteral);
	    return factory2.updatePropertyDeclaration(
	      node,
	      node.modifiers,
	      name,
	      node.questionToken ?? node.exclamationToken,
	      node.type,
	      initializer
	    );
	  }
	  function transformNamedEvaluationOfAssignmentExpression(context, node, ignoreEmptyStringLiteral, assignedNameText) {
	    const { factory: factory2 } = context;
	    const assignedName = assignedNameText !== void 0 ? factory2.createStringLiteral(assignedNameText) : getAssignedNameOfIdentifier(factory2, node.left, node.right);
	    const right = finishTransformNamedEvaluation(context, node.right, assignedName, ignoreEmptyStringLiteral);
	    return factory2.updateBinaryExpression(
	      node,
	      node.left,
	      node.operatorToken,
	      right
	    );
	  }
	  function transformNamedEvaluationOfExportAssignment(context, node, ignoreEmptyStringLiteral, assignedNameText) {
	    const { factory: factory2 } = context;
	    const assignedName = assignedNameText !== void 0 ? factory2.createStringLiteral(assignedNameText) : factory2.createStringLiteral(node.isExportEquals ? "" : "default");
	    const expression = finishTransformNamedEvaluation(context, node.expression, assignedName, ignoreEmptyStringLiteral);
	    return factory2.updateExportAssignment(
	      node,
	      node.modifiers,
	      expression
	    );
	  }
	  function transformNamedEvaluation(context, node, ignoreEmptyStringLiteral, assignedName) {
	    switch (node.kind) {
	      case 303 /* PropertyAssignment */:
	        return transformNamedEvaluationOfPropertyAssignment(context, node, ignoreEmptyStringLiteral, assignedName);
	      case 304 /* ShorthandPropertyAssignment */:
	        return transformNamedEvaluationOfShorthandAssignmentProperty(context, node, ignoreEmptyStringLiteral, assignedName);
	      case 260 /* VariableDeclaration */:
	        return transformNamedEvaluationOfVariableDeclaration(context, node, ignoreEmptyStringLiteral, assignedName);
	      case 169 /* Parameter */:
	        return transformNamedEvaluationOfParameterDeclaration(context, node, ignoreEmptyStringLiteral, assignedName);
	      case 208 /* BindingElement */:
	        return transformNamedEvaluationOfBindingElement(context, node, ignoreEmptyStringLiteral, assignedName);
	      case 172 /* PropertyDeclaration */:
	        return transformNamedEvaluationOfPropertyDeclaration(context, node, ignoreEmptyStringLiteral, assignedName);
	      case 226 /* BinaryExpression */:
	        return transformNamedEvaluationOfAssignmentExpression(context, node, ignoreEmptyStringLiteral, assignedName);
	      case 277 /* ExportAssignment */:
	        return transformNamedEvaluationOfExportAssignment(context, node, ignoreEmptyStringLiteral, assignedName);
	    }
	  }
	  var init_namedEvaluation = __esm({
	    "src/compiler/transformers/namedEvaluation.ts"() {
	      init_ts2();
	    }
	  });

	  // src/compiler/transformers/taggedTemplate.ts
	  function processTaggedTemplateExpression(context, node, visitor, currentSourceFile, recordTaggedTemplateString, level) {
	    const tag = visitNode(node.tag, visitor, isExpression);
	    Debug.assert(tag);
	    const templateArguments = [void 0];
	    const cookedStrings = [];
	    const rawStrings = [];
	    const template = node.template;
	    if (level === 0 /* LiftRestriction */ && !hasInvalidEscape(template)) {
	      return visitEachChild(node, visitor, context);
	    }
	    const { factory: factory2 } = context;
	    if (isNoSubstitutionTemplateLiteral(template)) {
	      cookedStrings.push(createTemplateCooked(factory2, template));
	      rawStrings.push(getRawLiteral(factory2, template, currentSourceFile));
	    } else {
	      cookedStrings.push(createTemplateCooked(factory2, template.head));
	      rawStrings.push(getRawLiteral(factory2, template.head, currentSourceFile));
	      for (const templateSpan of template.templateSpans) {
	        cookedStrings.push(createTemplateCooked(factory2, templateSpan.literal));
	        rawStrings.push(getRawLiteral(factory2, templateSpan.literal, currentSourceFile));
	        templateArguments.push(Debug.checkDefined(visitNode(templateSpan.expression, visitor, isExpression)));
	      }
	    }
	    const helperCall = context.getEmitHelperFactory().createTemplateObjectHelper(
	      factory2.createArrayLiteralExpression(cookedStrings),
	      factory2.createArrayLiteralExpression(rawStrings)
	    );
	    if (isExternalModule(currentSourceFile)) {
	      const tempVar = factory2.createUniqueName("templateObject");
	      recordTaggedTemplateString(tempVar);
	      templateArguments[0] = factory2.createLogicalOr(
	        tempVar,
	        factory2.createAssignment(
	          tempVar,
	          helperCall
	        )
	      );
	    } else {
	      templateArguments[0] = helperCall;
	    }
	    return factory2.createCallExpression(
	      tag,
	      /*typeArguments*/
	      void 0,
	      templateArguments
	    );
	  }
	  function createTemplateCooked(factory2, template) {
	    return template.templateFlags & 26656 /* IsInvalid */ ? factory2.createVoidZero() : factory2.createStringLiteral(template.text);
	  }
	  function getRawLiteral(factory2, node, currentSourceFile) {
	    let text = node.rawText;
	    if (text === void 0) {
	      Debug.assertIsDefined(currentSourceFile, "Template literal node is missing 'rawText' and does not have a source file. Possibly bad transform.");
	      text = getSourceTextOfNodeFromSourceFile(currentSourceFile, node);
	      const isLast = node.kind === 15 /* NoSubstitutionTemplateLiteral */ || node.kind === 18 /* TemplateTail */;
	      text = text.substring(1, text.length - (isLast ? 1 : 2));
	    }
	    text = text.replace(/\r\n?/g, "\n");
	    return setTextRange(factory2.createStringLiteral(text), node);
	  }
	  var ProcessLevel;
	  var init_taggedTemplate = __esm({
	    "src/compiler/transformers/taggedTemplate.ts"() {
	      init_ts2();
	      ProcessLevel = /* @__PURE__ */ ((ProcessLevel2) => {
	        ProcessLevel2[ProcessLevel2["LiftRestriction"] = 0] = "LiftRestriction";
	        ProcessLevel2[ProcessLevel2["All"] = 1] = "All";
	        return ProcessLevel2;
	      })(ProcessLevel || {});
	    }
	  });

	  // src/compiler/transformers/ts.ts
	  function transformTypeScript(context) {
	    const {
	      factory: factory2,
	      getEmitHelperFactory: emitHelpers,
	      startLexicalEnvironment,
	      resumeLexicalEnvironment,
	      endLexicalEnvironment,
	      hoistVariableDeclaration
	    } = context;
	    const resolver = context.getEmitResolver();
	    const compilerOptions = context.getCompilerOptions();
	    const languageVersion = getEmitScriptTarget(compilerOptions);
	    const moduleKind = getEmitModuleKind(compilerOptions);
	    const legacyDecorators = !!compilerOptions.experimentalDecorators;
	    const typeSerializer = compilerOptions.emitDecoratorMetadata ? createRuntimeTypeSerializer(context) : void 0;
	    const previousOnEmitNode = context.onEmitNode;
	    const previousOnSubstituteNode = context.onSubstituteNode;
	    context.onEmitNode = onEmitNode;
	    context.onSubstituteNode = onSubstituteNode;
	    context.enableSubstitution(211 /* PropertyAccessExpression */);
	    context.enableSubstitution(212 /* ElementAccessExpression */);
	    let currentSourceFile;
	    let currentNamespace;
	    let currentNamespaceContainerName;
	    let currentLexicalScope;
	    let currentScopeFirstDeclarationsOfName;
	    let currentClassHasParameterProperties;
	    let enabledSubstitutions;
	    let applicableSubstitutions;
	    return transformSourceFileOrBundle;
	    function transformSourceFileOrBundle(node) {
	      if (node.kind === 313 /* Bundle */) {
	        return transformBundle(node);
	      }
	      return transformSourceFile(node);
	    }
	    function transformBundle(node) {
	      return factory2.createBundle(
	        node.sourceFiles.map(transformSourceFile),
	        mapDefined(node.prepends, (prepend) => {
	          if (prepend.kind === 315 /* InputFiles */) {
	            return createUnparsedSourceFile(prepend, "js");
	          }
	          return prepend;
	        })
	      );
	    }
	    function transformSourceFile(node) {
	      if (node.isDeclarationFile) {
	        return node;
	      }
	      currentSourceFile = node;
	      const visited = saveStateAndInvoke(node, visitSourceFile);
	      addEmitHelpers(visited, context.readEmitHelpers());
	      currentSourceFile = void 0;
	      return visited;
	    }
	    function saveStateAndInvoke(node, f) {
	      const savedCurrentScope = currentLexicalScope;
	      const savedCurrentScopeFirstDeclarationsOfName = currentScopeFirstDeclarationsOfName;
	      const savedCurrentClassHasParameterProperties = currentClassHasParameterProperties;
	      onBeforeVisitNode(node);
	      const visited = f(node);
	      if (currentLexicalScope !== savedCurrentScope) {
	        currentScopeFirstDeclarationsOfName = savedCurrentScopeFirstDeclarationsOfName;
	      }
	      currentLexicalScope = savedCurrentScope;
	      currentClassHasParameterProperties = savedCurrentClassHasParameterProperties;
	      return visited;
	    }
	    function onBeforeVisitNode(node) {
	      switch (node.kind) {
	        case 312 /* SourceFile */:
	        case 269 /* CaseBlock */:
	        case 268 /* ModuleBlock */:
	        case 241 /* Block */:
	          currentLexicalScope = node;
	          currentScopeFirstDeclarationsOfName = void 0;
	          break;
	        case 263 /* ClassDeclaration */:
	        case 262 /* FunctionDeclaration */:
	          if (hasSyntacticModifier(node, 128 /* Ambient */)) {
	            break;
	          }
	          if (node.name) {
	            recordEmittedDeclarationInScope(node);
	          } else {
	            Debug.assert(node.kind === 263 /* ClassDeclaration */ || hasSyntacticModifier(node, 2048 /* Default */));
	          }
	          break;
	      }
	    }
	    function visitor(node) {
	      return saveStateAndInvoke(node, visitorWorker);
	    }
	    function visitorWorker(node) {
	      if (node.transformFlags & 1 /* ContainsTypeScript */) {
	        return visitTypeScript(node);
	      }
	      return node;
	    }
	    function sourceElementVisitor(node) {
	      return saveStateAndInvoke(node, sourceElementVisitorWorker);
	    }
	    function sourceElementVisitorWorker(node) {
	      switch (node.kind) {
	        case 272 /* ImportDeclaration */:
	        case 271 /* ImportEqualsDeclaration */:
	        case 277 /* ExportAssignment */:
	        case 278 /* ExportDeclaration */:
	          return visitElidableStatement(node);
	        default:
	          return visitorWorker(node);
	      }
	    }
	    function isElisionBlocked(node) {
	      const parsed = getParseTreeNode(node);
	      if (parsed === node || isExportAssignment(node)) {
	        return false;
	      }
	      if (!parsed || parsed.kind !== node.kind) {
	        return true;
	      }
	      switch (node.kind) {
	        case 272 /* ImportDeclaration */:
	          Debug.assertNode(parsed, isImportDeclaration);
	          if (node.importClause !== parsed.importClause) {
	            return true;
	          }
	          if (node.attributes !== parsed.attributes) {
	            return true;
	          }
	          break;
	        case 271 /* ImportEqualsDeclaration */:
	          Debug.assertNode(parsed, isImportEqualsDeclaration);
	          if (node.name !== parsed.name) {
	            return true;
	          }
	          if (node.isTypeOnly !== parsed.isTypeOnly) {
	            return true;
	          }
	          if (node.moduleReference !== parsed.moduleReference && (isEntityName(node.moduleReference) || isEntityName(parsed.moduleReference))) {
	            return true;
	          }
	          break;
	        case 278 /* ExportDeclaration */:
	          Debug.assertNode(parsed, isExportDeclaration);
	          if (node.exportClause !== parsed.exportClause) {
	            return true;
	          }
	          if (node.attributes !== parsed.attributes) {
	            return true;
	          }
	          break;
	      }
	      return false;
	    }
	    function visitElidableStatement(node) {
	      if (isElisionBlocked(node)) {
	        if (node.transformFlags & 1 /* ContainsTypeScript */) {
	          return visitEachChild(node, visitor, context);
	        }
	        return node;
	      }
	      switch (node.kind) {
	        case 272 /* ImportDeclaration */:
	          return visitImportDeclaration(node);
	        case 271 /* ImportEqualsDeclaration */:
	          return visitImportEqualsDeclaration(node);
	        case 277 /* ExportAssignment */:
	          return visitExportAssignment(node);
	        case 278 /* ExportDeclaration */:
	          return visitExportDeclaration(node);
	        default:
	          Debug.fail("Unhandled ellided statement");
	      }
	    }
	    function namespaceElementVisitor(node) {
	      return saveStateAndInvoke(node, namespaceElementVisitorWorker);
	    }
	    function namespaceElementVisitorWorker(node) {
	      if (node.kind === 278 /* ExportDeclaration */ || node.kind === 272 /* ImportDeclaration */ || node.kind === 273 /* ImportClause */ || node.kind === 271 /* ImportEqualsDeclaration */ && node.moduleReference.kind === 283 /* ExternalModuleReference */) {
	        return void 0;
	      } else if (node.transformFlags & 1 /* ContainsTypeScript */ || hasSyntacticModifier(node, 32 /* Export */)) {
	        return visitTypeScript(node);
	      }
	      return node;
	    }
	    function getClassElementVisitor(parent2) {
	      return (node) => saveStateAndInvoke(node, (n) => classElementVisitorWorker(n, parent2));
	    }
	    function classElementVisitorWorker(node, parent2) {
	      switch (node.kind) {
	        case 176 /* Constructor */:
	          return visitConstructor(node);
	        case 172 /* PropertyDeclaration */:
	          return visitPropertyDeclaration(node, parent2);
	        case 177 /* GetAccessor */:
	          return visitGetAccessor(node, parent2);
	        case 178 /* SetAccessor */:
	          return visitSetAccessor(node, parent2);
	        case 174 /* MethodDeclaration */:
	          return visitMethodDeclaration(node, parent2);
	        case 175 /* ClassStaticBlockDeclaration */:
	          return visitEachChild(node, visitor, context);
	        case 240 /* SemicolonClassElement */:
	          return node;
	        case 181 /* IndexSignature */:
	          return;
	        default:
	          return Debug.failBadSyntaxKind(node);
	      }
	    }
	    function getObjectLiteralElementVisitor(parent2) {
	      return (node) => saveStateAndInvoke(node, (n) => objectLiteralElementVisitorWorker(n, parent2));
	    }
	    function objectLiteralElementVisitorWorker(node, parent2) {
	      switch (node.kind) {
	        case 303 /* PropertyAssignment */:
	        case 304 /* ShorthandPropertyAssignment */:
	        case 305 /* SpreadAssignment */:
	          return visitor(node);
	        case 177 /* GetAccessor */:
	          return visitGetAccessor(node, parent2);
	        case 178 /* SetAccessor */:
	          return visitSetAccessor(node, parent2);
	        case 174 /* MethodDeclaration */:
	          return visitMethodDeclaration(node, parent2);
	        default:
	          return Debug.failBadSyntaxKind(node);
	      }
	    }
	    function decoratorElidingVisitor(node) {
	      return isDecorator(node) ? void 0 : visitor(node);
	    }
	    function modifierElidingVisitor(node) {
	      return isModifier(node) ? void 0 : visitor(node);
	    }
	    function modifierVisitor(node) {
	      if (isDecorator(node))
	        return void 0;
	      if (modifierToFlag(node.kind) & 28895 /* TypeScriptModifier */) {
	        return void 0;
	      } else if (currentNamespace && node.kind === 95 /* ExportKeyword */) {
	        return void 0;
	      }
	      return node;
	    }
	    function visitTypeScript(node) {
	      if (isStatement(node) && hasSyntacticModifier(node, 128 /* Ambient */)) {
	        return factory2.createNotEmittedStatement(node);
	      }
	      switch (node.kind) {
	        case 95 /* ExportKeyword */:
	        case 90 /* DefaultKeyword */:
	          return currentNamespace ? void 0 : node;
	        case 125 /* PublicKeyword */:
	        case 123 /* PrivateKeyword */:
	        case 124 /* ProtectedKeyword */:
	        case 128 /* AbstractKeyword */:
	        case 164 /* OverrideKeyword */:
	        case 87 /* ConstKeyword */:
	        case 138 /* DeclareKeyword */:
	        case 148 /* ReadonlyKeyword */:
	        case 103 /* InKeyword */:
	        case 147 /* OutKeyword */:
	        case 188 /* ArrayType */:
	        case 189 /* TupleType */:
	        case 190 /* OptionalType */:
	        case 191 /* RestType */:
	        case 187 /* TypeLiteral */:
	        case 182 /* TypePredicate */:
	        case 168 /* TypeParameter */:
	        case 133 /* AnyKeyword */:
	        case 159 /* UnknownKeyword */:
	        case 136 /* BooleanKeyword */:
	        case 154 /* StringKeyword */:
	        case 150 /* NumberKeyword */:
	        case 146 /* NeverKeyword */:
	        case 116 /* VoidKeyword */:
	        case 155 /* SymbolKeyword */:
	        case 185 /* ConstructorType */:
	        case 184 /* FunctionType */:
	        case 186 /* TypeQuery */:
	        case 183 /* TypeReference */:
	        case 192 /* UnionType */:
	        case 193 /* IntersectionType */:
	        case 194 /* ConditionalType */:
	        case 196 /* ParenthesizedType */:
	        case 197 /* ThisType */:
	        case 198 /* TypeOperator */:
	        case 199 /* IndexedAccessType */:
	        case 200 /* MappedType */:
	        case 201 /* LiteralType */:
	        case 181 /* IndexSignature */:
	          return void 0;
	        case 265 /* TypeAliasDeclaration */:
	          return factory2.createNotEmittedStatement(node);
	        case 270 /* NamespaceExportDeclaration */:
	          return void 0;
	        case 264 /* InterfaceDeclaration */:
	          return factory2.createNotEmittedStatement(node);
	        case 263 /* ClassDeclaration */:
	          return visitClassDeclaration(node);
	        case 231 /* ClassExpression */:
	          return visitClassExpression(node);
	        case 298 /* HeritageClause */:
	          return visitHeritageClause(node);
	        case 233 /* ExpressionWithTypeArguments */:
	          return visitExpressionWithTypeArguments(node);
	        case 210 /* ObjectLiteralExpression */:
	          return visitObjectLiteralExpression(node);
	        case 176 /* Constructor */:
	        case 172 /* PropertyDeclaration */:
	        case 174 /* MethodDeclaration */:
	        case 177 /* GetAccessor */:
	        case 178 /* SetAccessor */:
	        case 175 /* ClassStaticBlockDeclaration */:
	          return Debug.fail("Class and object literal elements must be visited with their respective visitors");
	        case 262 /* FunctionDeclaration */:
	          return visitFunctionDeclaration(node);
	        case 218 /* FunctionExpression */:
	          return visitFunctionExpression(node);
	        case 219 /* ArrowFunction */:
	          return visitArrowFunction(node);
	        case 169 /* Parameter */:
	          return visitParameter(node);
	        case 217 /* ParenthesizedExpression */:
	          return visitParenthesizedExpression(node);
	        case 216 /* TypeAssertionExpression */:
	        case 234 /* AsExpression */:
	          return visitAssertionExpression(node);
	        case 238 /* SatisfiesExpression */:
	          return visitSatisfiesExpression(node);
	        case 213 /* CallExpression */:
	          return visitCallExpression(node);
	        case 214 /* NewExpression */:
	          return visitNewExpression(node);
	        case 215 /* TaggedTemplateExpression */:
	          return visitTaggedTemplateExpression(node);
	        case 235 /* NonNullExpression */:
	          return visitNonNullExpression(node);
	        case 266 /* EnumDeclaration */:
	          return visitEnumDeclaration(node);
	        case 243 /* VariableStatement */:
	          return visitVariableStatement(node);
	        case 260 /* VariableDeclaration */:
	          return visitVariableDeclaration(node);
	        case 267 /* ModuleDeclaration */:
	          return visitModuleDeclaration(node);
	        case 271 /* ImportEqualsDeclaration */:
	          return visitImportEqualsDeclaration(node);
	        case 285 /* JsxSelfClosingElement */:
	          return visitJsxSelfClosingElement(node);
	        case 286 /* JsxOpeningElement */:
	          return visitJsxJsxOpeningElement(node);
	        default:
	          return visitEachChild(node, visitor, context);
	      }
	    }
	    function visitSourceFile(node) {
	      const alwaysStrict = getStrictOptionValue(compilerOptions, "alwaysStrict") && !(isExternalModule(node) && moduleKind >= 5 /* ES2015 */) && !isJsonSourceFile(node);
	      return factory2.updateSourceFile(
	        node,
	        visitLexicalEnvironment(
	          node.statements,
	          sourceElementVisitor,
	          context,
	          /*start*/
	          0,
	          alwaysStrict
	        )
	      );
	    }
	    function visitObjectLiteralExpression(node) {
	      return factory2.updateObjectLiteralExpression(
	        node,
	        visitNodes2(node.properties, getObjectLiteralElementVisitor(node), isObjectLiteralElementLike)
	      );
	    }
	    function getClassFacts(node) {
	      let facts = 0 /* None */;
	      if (some(getProperties(
	        node,
	        /*requireInitializer*/
	        true,
	        /*isStatic*/
	        true
	      )))
	        facts |= 1 /* HasStaticInitializedProperties */;
	      const extendsClauseElement = getEffectiveBaseTypeNode(node);
	      if (extendsClauseElement && skipOuterExpressions(extendsClauseElement.expression).kind !== 106 /* NullKeyword */)
	        facts |= 64 /* IsDerivedClass */;
	      if (classOrConstructorParameterIsDecorated(legacyDecorators, node))
	        facts |= 2 /* HasClassOrConstructorParameterDecorators */;
	      if (childIsDecorated(legacyDecorators, node))
	        facts |= 4 /* HasMemberDecorators */;
	      if (isExportOfNamespace(node))
	        facts |= 8 /* IsExportOfNamespace */;
	      else if (isDefaultExternalModuleExport(node))
	        facts |= 32 /* IsDefaultExternalExport */;
	      else if (isNamedExternalModuleExport(node))
	        facts |= 16 /* IsNamedExternalExport */;
	      return facts;
	    }
	    function hasTypeScriptClassSyntax(node) {
	      return !!(node.transformFlags & 8192 /* ContainsTypeScriptClassSyntax */);
	    }
	    function isClassLikeDeclarationWithTypeScriptSyntax(node) {
	      return hasDecorators(node) || some(node.typeParameters) || some(node.heritageClauses, hasTypeScriptClassSyntax) || some(node.members, hasTypeScriptClassSyntax);
	    }
	    function visitClassDeclaration(node) {
	      const facts = getClassFacts(node);
	      const promoteToIIFE = languageVersion <= 1 /* ES5 */ && !!(facts & 7 /* MayNeedImmediatelyInvokedFunctionExpression */);
	      if (!isClassLikeDeclarationWithTypeScriptSyntax(node) && !classOrConstructorParameterIsDecorated(legacyDecorators, node) && !isExportOfNamespace(node)) {
	        return factory2.updateClassDeclaration(
	          node,
	          visitNodes2(node.modifiers, modifierVisitor, isModifier),
	          node.name,
	          /*typeParameters*/
	          void 0,
	          visitNodes2(node.heritageClauses, visitor, isHeritageClause),
	          visitNodes2(node.members, getClassElementVisitor(node), isClassElement)
	        );
	      }
	      if (promoteToIIFE) {
	        context.startLexicalEnvironment();
	      }
	      const moveModifiers = promoteToIIFE || facts & 8 /* IsExportOfNamespace */;
	      let modifiers = moveModifiers ? visitNodes2(node.modifiers, modifierElidingVisitor, isModifierLike) : visitNodes2(node.modifiers, visitor, isModifierLike);
	      if (facts & 2 /* HasClassOrConstructorParameterDecorators */) {
	        modifiers = injectClassTypeMetadata(modifiers, node);
	      }
	      const needsName = moveModifiers && !node.name || facts & 4 /* HasMemberDecorators */ || facts & 1 /* HasStaticInitializedProperties */;
	      const name = needsName ? node.name ?? factory2.getGeneratedNameForNode(node) : node.name;
	      const classDeclaration = factory2.updateClassDeclaration(
	        node,
	        modifiers,
	        name,
	        /*typeParameters*/
	        void 0,
	        visitNodes2(node.heritageClauses, visitor, isHeritageClause),
	        transformClassMembers(node)
	      );
	      let emitFlags = getEmitFlags(node);
	      if (facts & 1 /* HasStaticInitializedProperties */) {
	        emitFlags |= 64 /* NoTrailingSourceMap */;
	      }
	      setEmitFlags(classDeclaration, emitFlags);
	      let statement;
	      if (promoteToIIFE) {
	        const statements = [classDeclaration];
	        const closingBraceLocation = createTokenRange(skipTrivia(currentSourceFile.text, node.members.end), 20 /* CloseBraceToken */);
	        const localName = factory2.getInternalName(node);
	        const outer = factory2.createPartiallyEmittedExpression(localName);
	        setTextRangeEnd(outer, closingBraceLocation.end);
	        setEmitFlags(outer, 3072 /* NoComments */);
	        const returnStatement = factory2.createReturnStatement(outer);
	        setTextRangePos(returnStatement, closingBraceLocation.pos);
	        setEmitFlags(returnStatement, 3072 /* NoComments */ | 768 /* NoTokenSourceMaps */);
	        statements.push(returnStatement);
	        insertStatementsAfterStandardPrologue(statements, context.endLexicalEnvironment());
	        const iife = factory2.createImmediatelyInvokedArrowFunction(statements);
	        setInternalEmitFlags(iife, 1 /* TypeScriptClassWrapper */);
	        const varDecl = factory2.createVariableDeclaration(
	          factory2.getLocalName(
	            node,
	            /*allowComments*/
	            false,
	            /*allowSourceMaps*/
	            false
	          ),
	          /*exclamationToken*/
	          void 0,
	          /*type*/
	          void 0,
	          iife
	        );
	        setOriginalNode(varDecl, node);
	        const varStatement = factory2.createVariableStatement(
	          /*modifiers*/
	          void 0,
	          factory2.createVariableDeclarationList([varDecl], 1 /* Let */)
	        );
	        setOriginalNode(varStatement, node);
	        setCommentRange(varStatement, node);
	        setSourceMapRange(varStatement, moveRangePastDecorators(node));
	        startOnNewLine(varStatement);
	        statement = varStatement;
	      } else {
	        statement = classDeclaration;
	      }
	      if (moveModifiers) {
	        if (facts & 8 /* IsExportOfNamespace */) {
	          return [
	            statement,
	            createExportMemberAssignmentStatement(node)
	          ];
	        }
	        if (facts & 32 /* IsDefaultExternalExport */) {
	          return [
	            statement,
	            factory2.createExportDefault(factory2.getLocalName(
	              node,
	              /*allowComments*/
	              false,
	              /*allowSourceMaps*/
	              true
	            ))
	          ];
	        }
	        if (facts & 16 /* IsNamedExternalExport */) {
	          return [
	            statement,
	            factory2.createExternalModuleExport(factory2.getDeclarationName(
	              node,
	              /*allowComments*/
	              false,
	              /*allowSourceMaps*/
	              true
	            ))
	          ];
	        }
	      }
	      return statement;
	    }
	    function visitClassExpression(node) {
	      let modifiers = visitNodes2(node.modifiers, modifierElidingVisitor, isModifierLike);
	      if (classOrConstructorParameterIsDecorated(legacyDecorators, node)) {
	        modifiers = injectClassTypeMetadata(modifiers, node);
	      }
	      return factory2.updateClassExpression(
	        node,
	        modifiers,
	        node.name,
	        /*typeParameters*/
	        void 0,
	        visitNodes2(node.heritageClauses, visitor, isHeritageClause),
	        transformClassMembers(node)
	      );
	    }
	    function transformClassMembers(node) {
	      const members = visitNodes2(node.members, getClassElementVisitor(node), isClassElement);
	      let newMembers;
	      const constructor = getFirstConstructorWithBody(node);
	      const parametersWithPropertyAssignments = constructor && filter(constructor.parameters, (p) => isParameterPropertyDeclaration(p, constructor));
	      if (parametersWithPropertyAssignments) {
	        for (const parameter of parametersWithPropertyAssignments) {
	          const parameterProperty = factory2.createPropertyDeclaration(
	            /*modifiers*/
	            void 0,
	            parameter.name,
	            /*questionOrExclamationToken*/
	            void 0,
	            /*type*/
	            void 0,
	            /*initializer*/
	            void 0
	          );
	          setOriginalNode(parameterProperty, parameter);
	          newMembers = append(newMembers, parameterProperty);
	        }
	      }
	      if (newMembers) {
	        newMembers = addRange(newMembers, members);
	        return setTextRange(
	          factory2.createNodeArray(newMembers),
	          /*location*/
	          node.members
	        );
	      }
	      return members;
	    }
	    function injectClassTypeMetadata(modifiers, node) {
	      const metadata = getTypeMetadata(node, node);
	      if (some(metadata)) {
	        const modifiersArray = [];
	        addRange(modifiersArray, takeWhile(modifiers, isExportOrDefaultModifier));
	        addRange(modifiersArray, filter(modifiers, isDecorator));
	        addRange(modifiersArray, metadata);
	        addRange(modifiersArray, filter(skipWhile(modifiers, isExportOrDefaultModifier), isModifier));
	        modifiers = setTextRange(factory2.createNodeArray(modifiersArray), modifiers);
	      }
	      return modifiers;
	    }
	    function injectClassElementTypeMetadata(modifiers, node, container) {
	      if (isClassLike(container) && classElementOrClassElementParameterIsDecorated(legacyDecorators, node, container)) {
	        const metadata = getTypeMetadata(node, container);
	        if (some(metadata)) {
	          const modifiersArray = [];
	          addRange(modifiersArray, filter(modifiers, isDecorator));
	          addRange(modifiersArray, metadata);
	          addRange(modifiersArray, filter(modifiers, isModifier));
	          modifiers = setTextRange(factory2.createNodeArray(modifiersArray), modifiers);
	        }
	      }
	      return modifiers;
	    }
	    function getTypeMetadata(node, container) {
	      if (!legacyDecorators)
	        return void 0;
	      return USE_NEW_TYPE_METADATA_FORMAT ? getNewTypeMetadata(node, container) : getOldTypeMetadata(node, container);
	    }
	    function getOldTypeMetadata(node, container) {
	      if (typeSerializer) {
	        let decorators;
	        if (shouldAddTypeMetadata(node)) {
	          const typeMetadata = emitHelpers().createMetadataHelper("design:type", typeSerializer.serializeTypeOfNode({ currentLexicalScope, currentNameScope: container }, node));
	          decorators = append(decorators, factory2.createDecorator(typeMetadata));
	        }
	        if (shouldAddParamTypesMetadata(node)) {
	          const paramTypesMetadata = emitHelpers().createMetadataHelper("design:paramtypes", typeSerializer.serializeParameterTypesOfNode({ currentLexicalScope, currentNameScope: container }, node, container));
	          decorators = append(decorators, factory2.createDecorator(paramTypesMetadata));
	        }
	        if (shouldAddReturnTypeMetadata(node)) {
	          const returnTypeMetadata = emitHelpers().createMetadataHelper("design:returntype", typeSerializer.serializeReturnTypeOfNode({ currentLexicalScope, currentNameScope: container }, node));
	          decorators = append(decorators, factory2.createDecorator(returnTypeMetadata));
	        }
	        return decorators;
	      }
	    }
	    function getNewTypeMetadata(node, container) {
	      if (typeSerializer) {
	        let properties;
	        if (shouldAddTypeMetadata(node)) {
	          const typeProperty = factory2.createPropertyAssignment("type", factory2.createArrowFunction(
	            /*modifiers*/
	            void 0,
	            /*typeParameters*/
	            void 0,
	            [],
	            /*type*/
	            void 0,
	            factory2.createToken(39 /* EqualsGreaterThanToken */),
	            typeSerializer.serializeTypeOfNode({ currentLexicalScope, currentNameScope: container }, node)
	          ));
	          properties = append(properties, typeProperty);
	        }
	        if (shouldAddParamTypesMetadata(node)) {
	          const paramTypeProperty = factory2.createPropertyAssignment("paramTypes", factory2.createArrowFunction(
	            /*modifiers*/
	            void 0,
	            /*typeParameters*/
	            void 0,
	            [],
	            /*type*/
	            void 0,
	            factory2.createToken(39 /* EqualsGreaterThanToken */),
	            typeSerializer.serializeParameterTypesOfNode({ currentLexicalScope, currentNameScope: container }, node, container)
	          ));
	          properties = append(properties, paramTypeProperty);
	        }
	        if (shouldAddReturnTypeMetadata(node)) {
	          const returnTypeProperty = factory2.createPropertyAssignment("returnType", factory2.createArrowFunction(
	            /*modifiers*/
	            void 0,
	            /*typeParameters*/
	            void 0,
	            [],
	            /*type*/
	            void 0,
	            factory2.createToken(39 /* EqualsGreaterThanToken */),
	            typeSerializer.serializeReturnTypeOfNode({ currentLexicalScope, currentNameScope: container }, node)
	          ));
	          properties = append(properties, returnTypeProperty);
	        }
	        if (properties) {
	          const typeInfoMetadata = emitHelpers().createMetadataHelper("design:typeinfo", factory2.createObjectLiteralExpression(
	            properties,
	            /*multiLine*/
	            true
	          ));
	          return [factory2.createDecorator(typeInfoMetadata)];
	        }
	      }
	    }
	    function shouldAddTypeMetadata(node) {
	      const kind = node.kind;
	      return kind === 174 /* MethodDeclaration */ || kind === 177 /* GetAccessor */ || kind === 178 /* SetAccessor */ || kind === 172 /* PropertyDeclaration */;
	    }
	    function shouldAddReturnTypeMetadata(node) {
	      return node.kind === 174 /* MethodDeclaration */;
	    }
	    function shouldAddParamTypesMetadata(node) {
	      switch (node.kind) {
	        case 263 /* ClassDeclaration */:
	        case 231 /* ClassExpression */:
	          return getFirstConstructorWithBody(node) !== void 0;
	        case 174 /* MethodDeclaration */:
	        case 177 /* GetAccessor */:
	        case 178 /* SetAccessor */:
	          return true;
	      }
	      return false;
	    }
	    function getExpressionForPropertyName(member, generateNameForComputedPropertyName) {
	      const name = member.name;
	      if (isPrivateIdentifier(name)) {
	        return factory2.createIdentifier("");
	      } else if (isComputedPropertyName(name)) {
	        return generateNameForComputedPropertyName && !isSimpleInlineableExpression(name.expression) ? factory2.getGeneratedNameForNode(name) : name.expression;
	      } else if (isIdentifier(name)) {
	        return factory2.createStringLiteral(idText(name));
	      } else {
	        return factory2.cloneNode(name);
	      }
	    }
	    function visitPropertyNameOfClassElement(member) {
	      const name = member.name;
	      if (isComputedPropertyName(name) && (!hasStaticModifier(member) && currentClassHasParameterProperties || hasDecorators(member) && legacyDecorators)) {
	        const expression = visitNode(name.expression, visitor, isExpression);
	        Debug.assert(expression);
	        const innerExpression = skipPartiallyEmittedExpressions(expression);
	        if (!isSimpleInlineableExpression(innerExpression)) {
	          const generatedName = factory2.getGeneratedNameForNode(name);
	          hoistVariableDeclaration(generatedName);
	          return factory2.updateComputedPropertyName(name, factory2.createAssignment(generatedName, expression));
	        }
	      }
	      return Debug.checkDefined(visitNode(name, visitor, isPropertyName));
	    }
	    function visitHeritageClause(node) {
	      if (node.token === 119 /* ImplementsKeyword */) {
	        return void 0;
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitExpressionWithTypeArguments(node) {
	      return factory2.updateExpressionWithTypeArguments(
	        node,
	        Debug.checkDefined(visitNode(node.expression, visitor, isLeftHandSideExpression)),
	        /*typeArguments*/
	        void 0
	      );
	    }
	    function shouldEmitFunctionLikeDeclaration(node) {
	      return !nodeIsMissing(node.body);
	    }
	    function visitPropertyDeclaration(node, parent2) {
	      const isAmbient = node.flags & 33554432 /* Ambient */ || hasSyntacticModifier(node, 64 /* Abstract */);
	      if (isAmbient && !(legacyDecorators && hasDecorators(node))) {
	        return void 0;
	      }
	      let modifiers = isClassLike(parent2) ? !isAmbient ? visitNodes2(node.modifiers, visitor, isModifierLike) : visitNodes2(node.modifiers, modifierElidingVisitor, isModifierLike) : visitNodes2(node.modifiers, decoratorElidingVisitor, isModifierLike);
	      modifiers = injectClassElementTypeMetadata(modifiers, node, parent2);
	      if (isAmbient) {
	        return factory2.updatePropertyDeclaration(
	          node,
	          concatenate(modifiers, factory2.createModifiersFromModifierFlags(128 /* Ambient */)),
	          Debug.checkDefined(visitNode(node.name, visitor, isPropertyName)),
	          /*questionOrExclamationToken*/
	          void 0,
	          /*type*/
	          void 0,
	          /*initializer*/
	          void 0
	        );
	      }
	      return factory2.updatePropertyDeclaration(
	        node,
	        modifiers,
	        visitPropertyNameOfClassElement(node),
	        /*questionOrExclamationToken*/
	        void 0,
	        /*type*/
	        void 0,
	        visitNode(node.initializer, visitor, isExpression)
	      );
	    }
	    function visitConstructor(node) {
	      if (!shouldEmitFunctionLikeDeclaration(node)) {
	        return void 0;
	      }
	      return factory2.updateConstructorDeclaration(
	        node,
	        /*modifiers*/
	        void 0,
	        visitParameterList(node.parameters, visitor, context),
	        transformConstructorBody(node.body, node)
	      );
	    }
	    function transformConstructorBodyWorker(statementsOut, statementsIn, statementOffset, superPath, superPathDepth, initializerStatements) {
	      const superStatementIndex = superPath[superPathDepth];
	      const superStatement = statementsIn[superStatementIndex];
	      addRange(statementsOut, visitNodes2(statementsIn, visitor, isStatement, statementOffset, superStatementIndex - statementOffset));
	      if (isTryStatement(superStatement)) {
	        const tryBlockStatements = [];
	        transformConstructorBodyWorker(
	          tryBlockStatements,
	          superStatement.tryBlock.statements,
	          /*statementOffset*/
	          0,
	          superPath,
	          superPathDepth + 1,
	          initializerStatements
	        );
	        const tryBlockStatementsArray = factory2.createNodeArray(tryBlockStatements);
	        setTextRange(tryBlockStatementsArray, superStatement.tryBlock.statements);
	        statementsOut.push(factory2.updateTryStatement(
	          superStatement,
	          factory2.updateBlock(superStatement.tryBlock, tryBlockStatements),
	          visitNode(superStatement.catchClause, visitor, isCatchClause),
	          visitNode(superStatement.finallyBlock, visitor, isBlock)
	        ));
	      } else {
	        addRange(statementsOut, visitNodes2(statementsIn, visitor, isStatement, superStatementIndex, 1));
	        addRange(statementsOut, initializerStatements);
	      }
	      addRange(statementsOut, visitNodes2(statementsIn, visitor, isStatement, superStatementIndex + 1));
	    }
	    function transformConstructorBody(body, constructor) {
	      const parametersWithPropertyAssignments = constructor && filter(constructor.parameters, (p) => isParameterPropertyDeclaration(p, constructor));
	      if (!some(parametersWithPropertyAssignments)) {
	        return visitFunctionBody(body, visitor, context);
	      }
	      let statements = [];
	      resumeLexicalEnvironment();
	      const prologueStatementCount = factory2.copyPrologue(
	        body.statements,
	        statements,
	        /*ensureUseStrict*/
	        false,
	        visitor
	      );
	      const superPath = findSuperStatementIndexPath(body.statements, prologueStatementCount);
	      const parameterPropertyAssignments = mapDefined(parametersWithPropertyAssignments, transformParameterWithPropertyAssignment);
	      if (superPath.length) {
	        transformConstructorBodyWorker(
	          statements,
	          body.statements,
	          prologueStatementCount,
	          superPath,
	          /*superPathDepth*/
	          0,
	          parameterPropertyAssignments
	        );
	      } else {
	        addRange(statements, parameterPropertyAssignments);
	        addRange(statements, visitNodes2(body.statements, visitor, isStatement, prologueStatementCount));
	      }
	      statements = factory2.mergeLexicalEnvironment(statements, endLexicalEnvironment());
	      const block = factory2.createBlock(
	        setTextRange(factory2.createNodeArray(statements), body.statements),
	        /*multiLine*/
	        true
	      );
	      setTextRange(
	        block,
	        /*location*/
	        body
	      );
	      setOriginalNode(block, body);
	      return block;
	    }
	    function transformParameterWithPropertyAssignment(node) {
	      const name = node.name;
	      if (!isIdentifier(name)) {
	        return void 0;
	      }
	      const propertyName = setParent(setTextRange(factory2.cloneNode(name), name), name.parent);
	      setEmitFlags(propertyName, 3072 /* NoComments */ | 96 /* NoSourceMap */);
	      const localName = setParent(setTextRange(factory2.cloneNode(name), name), name.parent);
	      setEmitFlags(localName, 3072 /* NoComments */);
	      return startOnNewLine(
	        removeAllComments(
	          setTextRange(
	            setOriginalNode(
	              factory2.createExpressionStatement(
	                factory2.createAssignment(
	                  setTextRange(
	                    factory2.createPropertyAccessExpression(
	                      factory2.createThis(),
	                      propertyName
	                    ),
	                    node.name
	                  ),
	                  localName
	                )
	              ),
	              node
	            ),
	            moveRangePos(node, -1)
	          )
	        )
	      );
	    }
	    function visitMethodDeclaration(node, parent2) {
	      if (!(node.transformFlags & 1 /* ContainsTypeScript */)) {
	        return node;
	      }
	      if (!shouldEmitFunctionLikeDeclaration(node)) {
	        return void 0;
	      }
	      let modifiers = isClassLike(parent2) ? visitNodes2(node.modifiers, visitor, isModifierLike) : visitNodes2(node.modifiers, decoratorElidingVisitor, isModifierLike);
	      modifiers = injectClassElementTypeMetadata(modifiers, node, parent2);
	      return factory2.updateMethodDeclaration(
	        node,
	        modifiers,
	        node.asteriskToken,
	        visitPropertyNameOfClassElement(node),
	        /*questionToken*/
	        void 0,
	        /*typeParameters*/
	        void 0,
	        visitParameterList(node.parameters, visitor, context),
	        /*type*/
	        void 0,
	        visitFunctionBody(node.body, visitor, context)
	      );
	    }
	    function shouldEmitAccessorDeclaration(node) {
	      return !(nodeIsMissing(node.body) && hasSyntacticModifier(node, 64 /* Abstract */));
	    }
	    function visitGetAccessor(node, parent2) {
	      if (!(node.transformFlags & 1 /* ContainsTypeScript */)) {
	        return node;
	      }
	      if (!shouldEmitAccessorDeclaration(node)) {
	        return void 0;
	      }
	      let modifiers = isClassLike(parent2) ? visitNodes2(node.modifiers, visitor, isModifierLike) : visitNodes2(node.modifiers, decoratorElidingVisitor, isModifierLike);
	      modifiers = injectClassElementTypeMetadata(modifiers, node, parent2);
	      return factory2.updateGetAccessorDeclaration(
	        node,
	        modifiers,
	        visitPropertyNameOfClassElement(node),
	        visitParameterList(node.parameters, visitor, context),
	        /*type*/
	        void 0,
	        visitFunctionBody(node.body, visitor, context) || factory2.createBlock([])
	      );
	    }
	    function visitSetAccessor(node, parent2) {
	      if (!(node.transformFlags & 1 /* ContainsTypeScript */)) {
	        return node;
	      }
	      if (!shouldEmitAccessorDeclaration(node)) {
	        return void 0;
	      }
	      let modifiers = isClassLike(parent2) ? visitNodes2(node.modifiers, visitor, isModifierLike) : visitNodes2(node.modifiers, decoratorElidingVisitor, isModifierLike);
	      modifiers = injectClassElementTypeMetadata(modifiers, node, parent2);
	      return factory2.updateSetAccessorDeclaration(
	        node,
	        modifiers,
	        visitPropertyNameOfClassElement(node),
	        visitParameterList(node.parameters, visitor, context),
	        visitFunctionBody(node.body, visitor, context) || factory2.createBlock([])
	      );
	    }
	    function visitFunctionDeclaration(node) {
	      if (!shouldEmitFunctionLikeDeclaration(node)) {
	        return factory2.createNotEmittedStatement(node);
	      }
	      const updated = factory2.updateFunctionDeclaration(
	        node,
	        visitNodes2(node.modifiers, modifierVisitor, isModifier),
	        node.asteriskToken,
	        node.name,
	        /*typeParameters*/
	        void 0,
	        visitParameterList(node.parameters, visitor, context),
	        /*type*/
	        void 0,
	        visitFunctionBody(node.body, visitor, context) || factory2.createBlock([])
	      );
	      if (isExportOfNamespace(node)) {
	        const statements = [updated];
	        addExportMemberAssignment(statements, node);
	        return statements;
	      }
	      return updated;
	    }
	    function visitFunctionExpression(node) {
	      if (!shouldEmitFunctionLikeDeclaration(node)) {
	        return factory2.createOmittedExpression();
	      }
	      const updated = factory2.updateFunctionExpression(
	        node,
	        visitNodes2(node.modifiers, modifierVisitor, isModifier),
	        node.asteriskToken,
	        node.name,
	        /*typeParameters*/
	        void 0,
	        visitParameterList(node.parameters, visitor, context),
	        /*type*/
	        void 0,
	        visitFunctionBody(node.body, visitor, context) || factory2.createBlock([])
	      );
	      return updated;
	    }
	    function visitArrowFunction(node) {
	      const updated = factory2.updateArrowFunction(
	        node,
	        visitNodes2(node.modifiers, modifierVisitor, isModifier),
	        /*typeParameters*/
	        void 0,
	        visitParameterList(node.parameters, visitor, context),
	        /*type*/
	        void 0,
	        node.equalsGreaterThanToken,
	        visitFunctionBody(node.body, visitor, context)
	      );
	      return updated;
	    }
	    function visitParameter(node) {
	      if (parameterIsThisKeyword(node)) {
	        return void 0;
	      }
	      const updated = factory2.updateParameterDeclaration(
	        node,
	        visitNodes2(node.modifiers, (node2) => isDecorator(node2) ? visitor(node2) : void 0, isModifierLike),
	        node.dotDotDotToken,
	        Debug.checkDefined(visitNode(node.name, visitor, isBindingName)),
	        /*questionToken*/
	        void 0,
	        /*type*/
	        void 0,
	        visitNode(node.initializer, visitor, isExpression)
	      );
	      if (updated !== node) {
	        setCommentRange(updated, node);
	        setTextRange(updated, moveRangePastModifiers(node));
	        setSourceMapRange(updated, moveRangePastModifiers(node));
	        setEmitFlags(updated.name, 64 /* NoTrailingSourceMap */);
	      }
	      return updated;
	    }
	    function visitVariableStatement(node) {
	      if (isExportOfNamespace(node)) {
	        const variables = getInitializedVariables(node.declarationList);
	        if (variables.length === 0) {
	          return void 0;
	        }
	        return setTextRange(
	          factory2.createExpressionStatement(
	            factory2.inlineExpressions(
	              map(variables, transformInitializedVariable)
	            )
	          ),
	          node
	        );
	      } else {
	        return visitEachChild(node, visitor, context);
	      }
	    }
	    function transformInitializedVariable(node) {
	      const name = node.name;
	      if (isBindingPattern(name)) {
	        return flattenDestructuringAssignment(
	          node,
	          visitor,
	          context,
	          0 /* All */,
	          /*needsValue*/
	          false,
	          createNamespaceExportExpression
	        );
	      } else {
	        return setTextRange(
	          factory2.createAssignment(
	            getNamespaceMemberNameWithSourceMapsAndWithoutComments(name),
	            Debug.checkDefined(visitNode(node.initializer, visitor, isExpression))
	          ),
	          /*location*/
	          node
	        );
	      }
	    }
	    function visitVariableDeclaration(node) {
	      const updated = factory2.updateVariableDeclaration(
	        node,
	        Debug.checkDefined(visitNode(node.name, visitor, isBindingName)),
	        /*exclamationToken*/
	        void 0,
	        /*type*/
	        void 0,
	        visitNode(node.initializer, visitor, isExpression)
	      );
	      if (node.type) {
	        setTypeNode(updated.name, node.type);
	      }
	      return updated;
	    }
	    function visitParenthesizedExpression(node) {
	      const innerExpression = skipOuterExpressions(node.expression, ~6 /* Assertions */);
	      if (isAssertionExpression(innerExpression)) {
	        const expression = visitNode(node.expression, visitor, isExpression);
	        Debug.assert(expression);
	        return factory2.createPartiallyEmittedExpression(expression, node);
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitAssertionExpression(node) {
	      const expression = visitNode(node.expression, visitor, isExpression);
	      Debug.assert(expression);
	      return factory2.createPartiallyEmittedExpression(expression, node);
	    }
	    function visitNonNullExpression(node) {
	      const expression = visitNode(node.expression, visitor, isLeftHandSideExpression);
	      Debug.assert(expression);
	      return factory2.createPartiallyEmittedExpression(expression, node);
	    }
	    function visitSatisfiesExpression(node) {
	      const expression = visitNode(node.expression, visitor, isExpression);
	      Debug.assert(expression);
	      return factory2.createPartiallyEmittedExpression(expression, node);
	    }
	    function visitCallExpression(node) {
	      return factory2.updateCallExpression(
	        node,
	        Debug.checkDefined(visitNode(node.expression, visitor, isExpression)),
	        /*typeArguments*/
	        void 0,
	        visitNodes2(node.arguments, visitor, isExpression)
	      );
	    }
	    function visitNewExpression(node) {
	      return factory2.updateNewExpression(
	        node,
	        Debug.checkDefined(visitNode(node.expression, visitor, isExpression)),
	        /*typeArguments*/
	        void 0,
	        visitNodes2(node.arguments, visitor, isExpression)
	      );
	    }
	    function visitTaggedTemplateExpression(node) {
	      return factory2.updateTaggedTemplateExpression(
	        node,
	        Debug.checkDefined(visitNode(node.tag, visitor, isExpression)),
	        /*typeArguments*/
	        void 0,
	        Debug.checkDefined(visitNode(node.template, visitor, isTemplateLiteral))
	      );
	    }
	    function visitJsxSelfClosingElement(node) {
	      return factory2.updateJsxSelfClosingElement(
	        node,
	        Debug.checkDefined(visitNode(node.tagName, visitor, isJsxTagNameExpression)),
	        /*typeArguments*/
	        void 0,
	        Debug.checkDefined(visitNode(node.attributes, visitor, isJsxAttributes))
	      );
	    }
	    function visitJsxJsxOpeningElement(node) {
	      return factory2.updateJsxOpeningElement(
	        node,
	        Debug.checkDefined(visitNode(node.tagName, visitor, isJsxTagNameExpression)),
	        /*typeArguments*/
	        void 0,
	        Debug.checkDefined(visitNode(node.attributes, visitor, isJsxAttributes))
	      );
	    }
	    function shouldEmitEnumDeclaration(node) {
	      return !isEnumConst(node) || shouldPreserveConstEnums(compilerOptions);
	    }
	    function visitEnumDeclaration(node) {
	      if (!shouldEmitEnumDeclaration(node)) {
	        return factory2.createNotEmittedStatement(node);
	      }
	      const statements = [];
	      let emitFlags = 4 /* AdviseOnEmitNode */;
	      const varAdded = addVarForEnumOrModuleDeclaration(statements, node);
	      if (varAdded) {
	        if (moduleKind !== 4 /* System */ || currentLexicalScope !== currentSourceFile) {
	          emitFlags |= 1024 /* NoLeadingComments */;
	        }
	      }
	      const parameterName = getNamespaceParameterName(node);
	      const containerName = getNamespaceContainerName(node);
	      const exportName = isExportOfNamespace(node) ? factory2.getExternalModuleOrNamespaceExportName(
	        currentNamespaceContainerName,
	        node,
	        /*allowComments*/
	        false,
	        /*allowSourceMaps*/
	        true
	      ) : factory2.getDeclarationName(
	        node,
	        /*allowComments*/
	        false,
	        /*allowSourceMaps*/
	        true
	      );
	      let moduleArg = factory2.createLogicalOr(
	        exportName,
	        factory2.createAssignment(
	          exportName,
	          factory2.createObjectLiteralExpression()
	        )
	      );
	      if (isExportOfNamespace(node)) {
	        const localName = factory2.getLocalName(
	          node,
	          /*allowComments*/
	          false,
	          /*allowSourceMaps*/
	          true
	        );
	        moduleArg = factory2.createAssignment(localName, moduleArg);
	      }
	      const enumStatement = factory2.createExpressionStatement(
	        factory2.createCallExpression(
	          factory2.createFunctionExpression(
	            /*modifiers*/
	            void 0,
	            /*asteriskToken*/
	            void 0,
	            /*name*/
	            void 0,
	            /*typeParameters*/
	            void 0,
	            [factory2.createParameterDeclaration(
	              /*modifiers*/
	              void 0,
	              /*dotDotDotToken*/
	              void 0,
	              parameterName
	            )],
	            /*type*/
	            void 0,
	            transformEnumBody(node, containerName)
	          ),
	          /*typeArguments*/
	          void 0,
	          [moduleArg]
	        )
	      );
	      setOriginalNode(enumStatement, node);
	      if (varAdded) {
	        setSyntheticLeadingComments(enumStatement, void 0);
	        setSyntheticTrailingComments(enumStatement, void 0);
	      }
	      setTextRange(enumStatement, node);
	      addEmitFlags(enumStatement, emitFlags);
	      statements.push(enumStatement);
	      return statements;
	    }
	    function transformEnumBody(node, localName) {
	      const savedCurrentNamespaceLocalName = currentNamespaceContainerName;
	      currentNamespaceContainerName = localName;
	      const statements = [];
	      startLexicalEnvironment();
	      const members = map(node.members, transformEnumMember);
	      insertStatementsAfterStandardPrologue(statements, endLexicalEnvironment());
	      addRange(statements, members);
	      currentNamespaceContainerName = savedCurrentNamespaceLocalName;
	      return factory2.createBlock(
	        setTextRange(
	          factory2.createNodeArray(statements),
	          /*location*/
	          node.members
	        ),
	        /*multiLine*/
	        true
	      );
	    }
	    function transformEnumMember(member) {
	      const name = getExpressionForPropertyName(
	        member,
	        /*generateNameForComputedPropertyName*/
	        false
	      );
	      const valueExpression = transformEnumMemberDeclarationValue(member);
	      const innerAssignment = factory2.createAssignment(
	        factory2.createElementAccessExpression(
	          currentNamespaceContainerName,
	          name
	        ),
	        valueExpression
	      );
	      const outerAssignment = valueExpression.kind === 11 /* StringLiteral */ ? innerAssignment : factory2.createAssignment(
	        factory2.createElementAccessExpression(
	          currentNamespaceContainerName,
	          innerAssignment
	        ),
	        name
	      );
	      return setTextRange(
	        factory2.createExpressionStatement(
	          setTextRange(
	            outerAssignment,
	            member
	          )
	        ),
	        member
	      );
	    }
	    function transformEnumMemberDeclarationValue(member) {
	      const value = resolver.getConstantValue(member);
	      if (value !== void 0) {
	        return typeof value === "string" ? factory2.createStringLiteral(value) : value < 0 ? factory2.createPrefixUnaryExpression(41 /* MinusToken */, factory2.createNumericLiteral(-value)) : factory2.createNumericLiteral(value);
	      } else {
	        enableSubstitutionForNonQualifiedEnumMembers();
	        if (member.initializer) {
	          return Debug.checkDefined(visitNode(member.initializer, visitor, isExpression));
	        } else {
	          return factory2.createVoidZero();
	        }
	      }
	    }
	    function shouldEmitModuleDeclaration(nodeIn) {
	      const node = getParseTreeNode(nodeIn, isModuleDeclaration);
	      if (!node) {
	        return true;
	      }
	      return isInstantiatedModule(node, shouldPreserveConstEnums(compilerOptions));
	    }
	    function recordEmittedDeclarationInScope(node) {
	      if (!currentScopeFirstDeclarationsOfName) {
	        currentScopeFirstDeclarationsOfName = /* @__PURE__ */ new Map();
	      }
	      const name = declaredNameInScope(node);
	      if (!currentScopeFirstDeclarationsOfName.has(name)) {
	        currentScopeFirstDeclarationsOfName.set(name, node);
	      }
	    }
	    function isFirstEmittedDeclarationInScope(node) {
	      if (currentScopeFirstDeclarationsOfName) {
	        const name = declaredNameInScope(node);
	        return currentScopeFirstDeclarationsOfName.get(name) === node;
	      }
	      return true;
	    }
	    function declaredNameInScope(node) {
	      Debug.assertNode(node.name, isIdentifier);
	      return node.name.escapedText;
	    }
	    function addVarForEnumOrModuleDeclaration(statements, node) {
	      const varDecl = factory2.createVariableDeclaration(factory2.getLocalName(
	        node,
	        /*allowComments*/
	        false,
	        /*allowSourceMaps*/
	        true
	      ));
	      const varFlags = currentLexicalScope.kind === 312 /* SourceFile */ ? 0 /* None */ : 1 /* Let */;
	      const statement = factory2.createVariableStatement(
	        visitNodes2(node.modifiers, modifierVisitor, isModifier),
	        factory2.createVariableDeclarationList([varDecl], varFlags)
	      );
	      setOriginalNode(varDecl, node);
	      setSyntheticLeadingComments(varDecl, void 0);
	      setSyntheticTrailingComments(varDecl, void 0);
	      setOriginalNode(statement, node);
	      recordEmittedDeclarationInScope(node);
	      if (isFirstEmittedDeclarationInScope(node)) {
	        if (node.kind === 266 /* EnumDeclaration */) {
	          setSourceMapRange(statement.declarationList, node);
	        } else {
	          setSourceMapRange(statement, node);
	        }
	        setCommentRange(statement, node);
	        addEmitFlags(statement, 2048 /* NoTrailingComments */);
	        statements.push(statement);
	        return true;
	      }
	      return false;
	    }
	    function visitModuleDeclaration(node) {
	      if (!shouldEmitModuleDeclaration(node)) {
	        return factory2.createNotEmittedStatement(node);
	      }
	      Debug.assertNode(node.name, isIdentifier, "A TypeScript namespace should have an Identifier name.");
	      enableSubstitutionForNamespaceExports();
	      const statements = [];
	      let emitFlags = 4 /* AdviseOnEmitNode */;
	      const varAdded = addVarForEnumOrModuleDeclaration(statements, node);
	      if (varAdded) {
	        if (moduleKind !== 4 /* System */ || currentLexicalScope !== currentSourceFile) {
	          emitFlags |= 1024 /* NoLeadingComments */;
	        }
	      }
	      const parameterName = getNamespaceParameterName(node);
	      const containerName = getNamespaceContainerName(node);
	      const exportName = isExportOfNamespace(node) ? factory2.getExternalModuleOrNamespaceExportName(
	        currentNamespaceContainerName,
	        node,
	        /*allowComments*/
	        false,
	        /*allowSourceMaps*/
	        true
	      ) : factory2.getDeclarationName(
	        node,
	        /*allowComments*/
	        false,
	        /*allowSourceMaps*/
	        true
	      );
	      let moduleArg = factory2.createLogicalOr(
	        exportName,
	        factory2.createAssignment(
	          exportName,
	          factory2.createObjectLiteralExpression()
	        )
	      );
	      if (isExportOfNamespace(node)) {
	        const localName = factory2.getLocalName(
	          node,
	          /*allowComments*/
	          false,
	          /*allowSourceMaps*/
	          true
	        );
	        moduleArg = factory2.createAssignment(localName, moduleArg);
	      }
	      const moduleStatement = factory2.createExpressionStatement(
	        factory2.createCallExpression(
	          factory2.createFunctionExpression(
	            /*modifiers*/
	            void 0,
	            /*asteriskToken*/
	            void 0,
	            /*name*/
	            void 0,
	            /*typeParameters*/
	            void 0,
	            [factory2.createParameterDeclaration(
	              /*modifiers*/
	              void 0,
	              /*dotDotDotToken*/
	              void 0,
	              parameterName
	            )],
	            /*type*/
	            void 0,
	            transformModuleBody(node, containerName)
	          ),
	          /*typeArguments*/
	          void 0,
	          [moduleArg]
	        )
	      );
	      setOriginalNode(moduleStatement, node);
	      if (varAdded) {
	        setSyntheticLeadingComments(moduleStatement, void 0);
	        setSyntheticTrailingComments(moduleStatement, void 0);
	      }
	      setTextRange(moduleStatement, node);
	      addEmitFlags(moduleStatement, emitFlags);
	      statements.push(moduleStatement);
	      return statements;
	    }
	    function transformModuleBody(node, namespaceLocalName) {
	      const savedCurrentNamespaceContainerName = currentNamespaceContainerName;
	      const savedCurrentNamespace = currentNamespace;
	      const savedCurrentScopeFirstDeclarationsOfName = currentScopeFirstDeclarationsOfName;
	      currentNamespaceContainerName = namespaceLocalName;
	      currentNamespace = node;
	      currentScopeFirstDeclarationsOfName = void 0;
	      const statements = [];
	      startLexicalEnvironment();
	      let statementsLocation;
	      let blockLocation;
	      if (node.body) {
	        if (node.body.kind === 268 /* ModuleBlock */) {
	          saveStateAndInvoke(node.body, (body) => addRange(statements, visitNodes2(body.statements, namespaceElementVisitor, isStatement)));
	          statementsLocation = node.body.statements;
	          blockLocation = node.body;
	        } else {
	          const result = visitModuleDeclaration(node.body);
	          if (result) {
	            if (isArray(result)) {
	              addRange(statements, result);
	            } else {
	              statements.push(result);
	            }
	          }
	          const moduleBlock = getInnerMostModuleDeclarationFromDottedModule(node).body;
	          statementsLocation = moveRangePos(moduleBlock.statements, -1);
	        }
	      }
	      insertStatementsAfterStandardPrologue(statements, endLexicalEnvironment());
	      currentNamespaceContainerName = savedCurrentNamespaceContainerName;
	      currentNamespace = savedCurrentNamespace;
	      currentScopeFirstDeclarationsOfName = savedCurrentScopeFirstDeclarationsOfName;
	      const block = factory2.createBlock(
	        setTextRange(
	          factory2.createNodeArray(statements),
	          /*location*/
	          statementsLocation
	        ),
	        /*multiLine*/
	        true
	      );
	      setTextRange(block, blockLocation);
	      if (!node.body || node.body.kind !== 268 /* ModuleBlock */) {
	        setEmitFlags(block, getEmitFlags(block) | 3072 /* NoComments */);
	      }
	      return block;
	    }
	    function getInnerMostModuleDeclarationFromDottedModule(moduleDeclaration) {
	      if (moduleDeclaration.body.kind === 267 /* ModuleDeclaration */) {
	        const recursiveInnerModule = getInnerMostModuleDeclarationFromDottedModule(moduleDeclaration.body);
	        return recursiveInnerModule || moduleDeclaration.body;
	      }
	    }
	    function visitImportDeclaration(node) {
	      if (!node.importClause) {
	        return node;
	      }
	      if (node.importClause.isTypeOnly) {
	        return void 0;
	      }
	      const importClause = visitNode(node.importClause, visitImportClause, isImportClause);
	      return importClause || compilerOptions.importsNotUsedAsValues === 1 /* Preserve */ || compilerOptions.importsNotUsedAsValues === 2 /* Error */ ? factory2.updateImportDeclaration(
	        node,
	        /*modifiers*/
	        void 0,
	        importClause,
	        node.moduleSpecifier,
	        node.attributes
	      ) : void 0;
	    }
	    function visitImportClause(node) {
	      Debug.assert(!node.isTypeOnly);
	      const name = shouldEmitAliasDeclaration(node) ? node.name : void 0;
	      const namedBindings = visitNode(node.namedBindings, visitNamedImportBindings, isNamedImportBindings);
	      return name || namedBindings ? factory2.updateImportClause(
	        node,
	        /*isTypeOnly*/
	        false,
	        name,
	        namedBindings
	      ) : void 0;
	    }
	    function visitNamedImportBindings(node) {
	      if (node.kind === 274 /* NamespaceImport */) {
	        return shouldEmitAliasDeclaration(node) ? node : void 0;
	      } else {
	        const allowEmpty = compilerOptions.verbatimModuleSyntax || compilerOptions.preserveValueImports && (compilerOptions.importsNotUsedAsValues === 1 /* Preserve */ || compilerOptions.importsNotUsedAsValues === 2 /* Error */);
	        const elements = visitNodes2(node.elements, visitImportSpecifier, isImportSpecifier);
	        return allowEmpty || some(elements) ? factory2.updateNamedImports(node, elements) : void 0;
	      }
	    }
	    function visitImportSpecifier(node) {
	      return !node.isTypeOnly && shouldEmitAliasDeclaration(node) ? node : void 0;
	    }
	    function visitExportAssignment(node) {
	      return compilerOptions.verbatimModuleSyntax || resolver.isValueAliasDeclaration(node) ? visitEachChild(node, visitor, context) : void 0;
	    }
	    function visitExportDeclaration(node) {
	      if (node.isTypeOnly) {
	        return void 0;
	      }
	      if (!node.exportClause || isNamespaceExport(node.exportClause)) {
	        return node;
	      }
	      const allowEmpty = compilerOptions.verbatimModuleSyntax || !!node.moduleSpecifier && (compilerOptions.importsNotUsedAsValues === 1 /* Preserve */ || compilerOptions.importsNotUsedAsValues === 2 /* Error */);
	      const exportClause = visitNode(
	        node.exportClause,
	        (bindings) => visitNamedExportBindings(bindings, allowEmpty),
	        isNamedExportBindings
	      );
	      return exportClause ? factory2.updateExportDeclaration(
	        node,
	        /*modifiers*/
	        void 0,
	        node.isTypeOnly,
	        exportClause,
	        node.moduleSpecifier,
	        node.attributes
	      ) : void 0;
	    }
	    function visitNamedExports(node, allowEmpty) {
	      const elements = visitNodes2(node.elements, visitExportSpecifier, isExportSpecifier);
	      return allowEmpty || some(elements) ? factory2.updateNamedExports(node, elements) : void 0;
	    }
	    function visitNamespaceExports(node) {
	      return factory2.updateNamespaceExport(node, Debug.checkDefined(visitNode(node.name, visitor, isIdentifier)));
	    }
	    function visitNamedExportBindings(node, allowEmpty) {
	      return isNamespaceExport(node) ? visitNamespaceExports(node) : visitNamedExports(node, allowEmpty);
	    }
	    function visitExportSpecifier(node) {
	      return !node.isTypeOnly && (compilerOptions.verbatimModuleSyntax || resolver.isValueAliasDeclaration(node)) ? node : void 0;
	    }
	    function shouldEmitImportEqualsDeclaration(node) {
	      return shouldEmitAliasDeclaration(node) || !isExternalModule(currentSourceFile) && resolver.isTopLevelValueImportEqualsWithEntityName(node);
	    }
	    function visitImportEqualsDeclaration(node) {
	      if (node.isTypeOnly) {
	        return void 0;
	      }
	      if (isExternalModuleImportEqualsDeclaration(node)) {
	        const isReferenced = shouldEmitAliasDeclaration(node);
	        if (!isReferenced && compilerOptions.importsNotUsedAsValues === 1 /* Preserve */) {
	          return setOriginalNode(
	            setTextRange(
	              factory2.createImportDeclaration(
	                /*modifiers*/
	                void 0,
	                /*importClause*/
	                void 0,
	                node.moduleReference.expression,
	                /*attributes*/
	                void 0
	              ),
	              node
	            ),
	            node
	          );
	        }
	        return isReferenced ? visitEachChild(node, visitor, context) : void 0;
	      }
	      if (!shouldEmitImportEqualsDeclaration(node)) {
	        return void 0;
	      }
	      const moduleReference = createExpressionFromEntityName(factory2, node.moduleReference);
	      setEmitFlags(moduleReference, 3072 /* NoComments */ | 4096 /* NoNestedComments */);
	      if (isNamedExternalModuleExport(node) || !isExportOfNamespace(node)) {
	        return setOriginalNode(
	          setTextRange(
	            factory2.createVariableStatement(
	              visitNodes2(node.modifiers, modifierVisitor, isModifier),
	              factory2.createVariableDeclarationList([
	                setOriginalNode(
	                  factory2.createVariableDeclaration(
	                    node.name,
	                    /*exclamationToken*/
	                    void 0,
	                    /*type*/
	                    void 0,
	                    moduleReference
	                  ),
	                  node
	                )
	              ])
	            ),
	            node
	          ),
	          node
	        );
	      } else {
	        return setOriginalNode(
	          createNamespaceExport(
	            node.name,
	            moduleReference,
	            node
	          ),
	          node
	        );
	      }
	    }
	    function isExportOfNamespace(node) {
	      return currentNamespace !== void 0 && hasSyntacticModifier(node, 32 /* Export */);
	    }
	    function isExternalModuleExport(node) {
	      return currentNamespace === void 0 && hasSyntacticModifier(node, 32 /* Export */);
	    }
	    function isNamedExternalModuleExport(node) {
	      return isExternalModuleExport(node) && !hasSyntacticModifier(node, 2048 /* Default */);
	    }
	    function isDefaultExternalModuleExport(node) {
	      return isExternalModuleExport(node) && hasSyntacticModifier(node, 2048 /* Default */);
	    }
	    function createExportMemberAssignmentStatement(node) {
	      const expression = factory2.createAssignment(
	        factory2.getExternalModuleOrNamespaceExportName(
	          currentNamespaceContainerName,
	          node,
	          /*allowComments*/
	          false,
	          /*allowSourceMaps*/
	          true
	        ),
	        factory2.getLocalName(node)
	      );
	      setSourceMapRange(expression, createRange(node.name ? node.name.pos : node.pos, node.end));
	      const statement = factory2.createExpressionStatement(expression);
	      setSourceMapRange(statement, createRange(-1, node.end));
	      return statement;
	    }
	    function addExportMemberAssignment(statements, node) {
	      statements.push(createExportMemberAssignmentStatement(node));
	    }
	    function createNamespaceExport(exportName, exportValue, location) {
	      return setTextRange(
	        factory2.createExpressionStatement(
	          factory2.createAssignment(
	            factory2.getNamespaceMemberName(
	              currentNamespaceContainerName,
	              exportName,
	              /*allowComments*/
	              false,
	              /*allowSourceMaps*/
	              true
	            ),
	            exportValue
	          )
	        ),
	        location
	      );
	    }
	    function createNamespaceExportExpression(exportName, exportValue, location) {
	      return setTextRange(factory2.createAssignment(getNamespaceMemberNameWithSourceMapsAndWithoutComments(exportName), exportValue), location);
	    }
	    function getNamespaceMemberNameWithSourceMapsAndWithoutComments(name) {
	      return factory2.getNamespaceMemberName(
	        currentNamespaceContainerName,
	        name,
	        /*allowComments*/
	        false,
	        /*allowSourceMaps*/
	        true
	      );
	    }
	    function getNamespaceParameterName(node) {
	      const name = factory2.getGeneratedNameForNode(node);
	      setSourceMapRange(name, node.name);
	      return name;
	    }
	    function getNamespaceContainerName(node) {
	      return factory2.getGeneratedNameForNode(node);
	    }
	    function enableSubstitutionForNonQualifiedEnumMembers() {
	      if ((enabledSubstitutions & 8 /* NonQualifiedEnumMembers */) === 0) {
	        enabledSubstitutions |= 8 /* NonQualifiedEnumMembers */;
	        context.enableSubstitution(80 /* Identifier */);
	      }
	    }
	    function enableSubstitutionForNamespaceExports() {
	      if ((enabledSubstitutions & 2 /* NamespaceExports */) === 0) {
	        enabledSubstitutions |= 2 /* NamespaceExports */;
	        context.enableSubstitution(80 /* Identifier */);
	        context.enableSubstitution(304 /* ShorthandPropertyAssignment */);
	        context.enableEmitNotification(267 /* ModuleDeclaration */);
	      }
	    }
	    function isTransformedModuleDeclaration(node) {
	      return getOriginalNode(node).kind === 267 /* ModuleDeclaration */;
	    }
	    function isTransformedEnumDeclaration(node) {
	      return getOriginalNode(node).kind === 266 /* EnumDeclaration */;
	    }
	    function onEmitNode(hint, node, emitCallback) {
	      const savedApplicableSubstitutions = applicableSubstitutions;
	      const savedCurrentSourceFile = currentSourceFile;
	      if (isSourceFile(node)) {
	        currentSourceFile = node;
	      }
	      if (enabledSubstitutions & 2 /* NamespaceExports */ && isTransformedModuleDeclaration(node)) {
	        applicableSubstitutions |= 2 /* NamespaceExports */;
	      }
	      if (enabledSubstitutions & 8 /* NonQualifiedEnumMembers */ && isTransformedEnumDeclaration(node)) {
	        applicableSubstitutions |= 8 /* NonQualifiedEnumMembers */;
	      }
	      previousOnEmitNode(hint, node, emitCallback);
	      applicableSubstitutions = savedApplicableSubstitutions;
	      currentSourceFile = savedCurrentSourceFile;
	    }
	    function onSubstituteNode(hint, node) {
	      node = previousOnSubstituteNode(hint, node);
	      if (hint === 1 /* Expression */) {
	        return substituteExpression(node);
	      } else if (isShorthandPropertyAssignment(node)) {
	        return substituteShorthandPropertyAssignment(node);
	      }
	      return node;
	    }
	    function substituteShorthandPropertyAssignment(node) {
	      if (enabledSubstitutions & 2 /* NamespaceExports */) {
	        const name = node.name;
	        const exportedName = trySubstituteNamespaceExportedName(name);
	        if (exportedName) {
	          if (node.objectAssignmentInitializer) {
	            const initializer = factory2.createAssignment(exportedName, node.objectAssignmentInitializer);
	            return setTextRange(factory2.createPropertyAssignment(name, initializer), node);
	          }
	          return setTextRange(factory2.createPropertyAssignment(name, exportedName), node);
	        }
	      }
	      return node;
	    }
	    function substituteExpression(node) {
	      switch (node.kind) {
	        case 80 /* Identifier */:
	          return substituteExpressionIdentifier(node);
	        case 211 /* PropertyAccessExpression */:
	          return substitutePropertyAccessExpression(node);
	        case 212 /* ElementAccessExpression */:
	          return substituteElementAccessExpression(node);
	      }
	      return node;
	    }
	    function substituteExpressionIdentifier(node) {
	      return trySubstituteNamespaceExportedName(node) || node;
	    }
	    function trySubstituteNamespaceExportedName(node) {
	      if (enabledSubstitutions & applicableSubstitutions && !isGeneratedIdentifier(node) && !isLocalName(node)) {
	        const container = resolver.getReferencedExportContainer(
	          node,
	          /*prefixLocals*/
	          false
	        );
	        if (container && container.kind !== 312 /* SourceFile */) {
	          const substitute = applicableSubstitutions & 2 /* NamespaceExports */ && container.kind === 267 /* ModuleDeclaration */ || applicableSubstitutions & 8 /* NonQualifiedEnumMembers */ && container.kind === 266 /* EnumDeclaration */;
	          if (substitute) {
	            return setTextRange(
	              factory2.createPropertyAccessExpression(factory2.getGeneratedNameForNode(container), node),
	              /*location*/
	              node
	            );
	          }
	        }
	      }
	      return void 0;
	    }
	    function substitutePropertyAccessExpression(node) {
	      return substituteConstantValue(node);
	    }
	    function substituteElementAccessExpression(node) {
	      return substituteConstantValue(node);
	    }
	    function safeMultiLineComment(value) {
	      return value.replace(/\*\//g, "*_/");
	    }
	    function substituteConstantValue(node) {
	      const constantValue = tryGetConstEnumValue(node);
	      if (constantValue !== void 0) {
	        setConstantValue(node, constantValue);
	        const substitute = typeof constantValue === "string" ? factory2.createStringLiteral(constantValue) : constantValue < 0 ? factory2.createPrefixUnaryExpression(41 /* MinusToken */, factory2.createNumericLiteral(-constantValue)) : factory2.createNumericLiteral(constantValue);
	        if (!compilerOptions.removeComments) {
	          const originalNode = getOriginalNode(node, isAccessExpression);
	          addSyntheticTrailingComment(substitute, 3 /* MultiLineCommentTrivia */, ` ${safeMultiLineComment(getTextOfNode(originalNode))} `);
	        }
	        return substitute;
	      }
	      return node;
	    }
	    function tryGetConstEnumValue(node) {
	      if (getIsolatedModules(compilerOptions)) {
	        return void 0;
	      }
	      return isPropertyAccessExpression(node) || isElementAccessExpression(node) ? resolver.getConstantValue(node) : void 0;
	    }
	    function shouldEmitAliasDeclaration(node) {
	      return compilerOptions.verbatimModuleSyntax || isInJSFile(node) || (compilerOptions.preserveValueImports ? resolver.isValueAliasDeclaration(node) : resolver.isReferencedAliasDeclaration(node));
	    }
	  }
	  var USE_NEW_TYPE_METADATA_FORMAT;
	  var init_ts = __esm({
	    "src/compiler/transformers/ts.ts"() {
	      init_ts2();
	      USE_NEW_TYPE_METADATA_FORMAT = false;
	    }
	  });

	  // src/compiler/transformers/classFields.ts
	  function transformClassFields(context) {
	    const {
	      factory: factory2,
	      getEmitHelperFactory: emitHelpers,
	      hoistVariableDeclaration,
	      endLexicalEnvironment,
	      startLexicalEnvironment,
	      resumeLexicalEnvironment,
	      addBlockScopedVariable
	    } = context;
	    const resolver = context.getEmitResolver();
	    const compilerOptions = context.getCompilerOptions();
	    const languageVersion = getEmitScriptTarget(compilerOptions);
	    const useDefineForClassFields = getUseDefineForClassFields(compilerOptions);
	    const legacyDecorators = !!compilerOptions.experimentalDecorators;
	    const shouldTransformInitializersUsingSet = !useDefineForClassFields;
	    const shouldTransformInitializersUsingDefine = useDefineForClassFields && languageVersion < 9 /* ES2022 */;
	    const shouldTransformInitializers = shouldTransformInitializersUsingSet || shouldTransformInitializersUsingDefine;
	    const shouldTransformPrivateElementsOrClassStaticBlocks = languageVersion < 9 /* ES2022 */;
	    const shouldTransformAutoAccessors = languageVersion < 99 /* ESNext */ ? -1 /* True */ : !useDefineForClassFields ? 3 /* Maybe */ : 0 /* False */;
	    const shouldTransformThisInStaticInitializers = languageVersion < 9 /* ES2022 */;
	    const shouldTransformSuperInStaticInitializers = shouldTransformThisInStaticInitializers && languageVersion >= 2 /* ES2015 */;
	    const shouldTransformAnything = shouldTransformInitializers || shouldTransformPrivateElementsOrClassStaticBlocks || shouldTransformAutoAccessors === -1 /* True */;
	    const previousOnSubstituteNode = context.onSubstituteNode;
	    context.onSubstituteNode = onSubstituteNode;
	    const previousOnEmitNode = context.onEmitNode;
	    context.onEmitNode = onEmitNode;
	    let shouldTransformPrivateStaticElementsInFile = false;
	    let enabledSubstitutions;
	    let classAliases;
	    let pendingExpressions;
	    let pendingStatements;
	    let lexicalEnvironment;
	    const lexicalEnvironmentMap = /* @__PURE__ */ new Map();
	    const noSubstitution = /* @__PURE__ */ new Set();
	    let currentClassContainer;
	    let currentClassElement;
	    let shouldSubstituteThisWithClassThis = false;
	    let previousShouldSubstituteThisWithClassThis = false;
	    return chainBundle(context, transformSourceFile);
	    function transformSourceFile(node) {
	      if (node.isDeclarationFile) {
	        return node;
	      }
	      lexicalEnvironment = void 0;
	      shouldTransformPrivateStaticElementsInFile = !!(getInternalEmitFlags(node) & 32 /* TransformPrivateStaticElements */);
	      if (!shouldTransformAnything && !shouldTransformPrivateStaticElementsInFile) {
	        return node;
	      }
	      const visited = visitEachChild(node, visitor, context);
	      addEmitHelpers(visited, context.readEmitHelpers());
	      return visited;
	    }
	    function modifierVisitor(node) {
	      switch (node.kind) {
	        case 129 /* AccessorKeyword */:
	          return shouldTransformAutoAccessorsInCurrentClass() ? void 0 : node;
	        default:
	          return tryCast(node, isModifier);
	      }
	    }
	    function visitor(node) {
	      if (!(node.transformFlags & 16777216 /* ContainsClassFields */) && !(node.transformFlags & 134234112 /* ContainsLexicalThisOrSuper */)) {
	        return node;
	      }
	      switch (node.kind) {
	        case 129 /* AccessorKeyword */:
	          return Debug.fail("Use `modifierVisitor` instead.");
	        case 263 /* ClassDeclaration */:
	          return visitClassDeclaration(node);
	        case 231 /* ClassExpression */:
	          return visitClassExpression(node);
	        case 175 /* ClassStaticBlockDeclaration */:
	        case 172 /* PropertyDeclaration */:
	          return Debug.fail("Use `classElementVisitor` instead.");
	        case 303 /* PropertyAssignment */:
	          return visitPropertyAssignment(node);
	        case 243 /* VariableStatement */:
	          return visitVariableStatement(node);
	        case 260 /* VariableDeclaration */:
	          return visitVariableDeclaration(node);
	        case 169 /* Parameter */:
	          return visitParameterDeclaration(node);
	        case 208 /* BindingElement */:
	          return visitBindingElement(node);
	        case 277 /* ExportAssignment */:
	          return visitExportAssignment(node);
	        case 81 /* PrivateIdentifier */:
	          return visitPrivateIdentifier(node);
	        case 211 /* PropertyAccessExpression */:
	          return visitPropertyAccessExpression(node);
	        case 212 /* ElementAccessExpression */:
	          return visitElementAccessExpression(node);
	        case 224 /* PrefixUnaryExpression */:
	        case 225 /* PostfixUnaryExpression */:
	          return visitPreOrPostfixUnaryExpression(
	            node,
	            /*discarded*/
	            false
	          );
	        case 226 /* BinaryExpression */:
	          return visitBinaryExpression(
	            node,
	            /*discarded*/
	            false
	          );
	        case 217 /* ParenthesizedExpression */:
	          return visitParenthesizedExpression(
	            node,
	            /*discarded*/
	            false
	          );
	        case 213 /* CallExpression */:
	          return visitCallExpression(node);
	        case 244 /* ExpressionStatement */:
	          return visitExpressionStatement(node);
	        case 215 /* TaggedTemplateExpression */:
	          return visitTaggedTemplateExpression(node);
	        case 248 /* ForStatement */:
	          return visitForStatement(node);
	        case 110 /* ThisKeyword */:
	          return visitThisExpression(node);
	        case 262 /* FunctionDeclaration */:
	        case 218 /* FunctionExpression */:
	          return setCurrentClassElementAnd(
	            /*classElement*/
	            void 0,
	            fallbackVisitor,
	            node
	          );
	        case 176 /* Constructor */:
	        case 174 /* MethodDeclaration */:
	        case 177 /* GetAccessor */:
	        case 178 /* SetAccessor */: {
	          return setCurrentClassElementAnd(
	            node,
	            fallbackVisitor,
	            node
	          );
	        }
	        default:
	          return fallbackVisitor(node);
	      }
	    }
	    function fallbackVisitor(node) {
	      return visitEachChild(node, visitor, context);
	    }
	    function discardedValueVisitor(node) {
	      switch (node.kind) {
	        case 224 /* PrefixUnaryExpression */:
	        case 225 /* PostfixUnaryExpression */:
	          return visitPreOrPostfixUnaryExpression(
	            node,
	            /*discarded*/
	            true
	          );
	        case 226 /* BinaryExpression */:
	          return visitBinaryExpression(
	            node,
	            /*discarded*/
	            true
	          );
	        case 361 /* CommaListExpression */:
	          return visitCommaListExpression(
	            node,
	            /*discarded*/
	            true
	          );
	        case 217 /* ParenthesizedExpression */:
	          return visitParenthesizedExpression(
	            node,
	            /*discarded*/
	            true
	          );
	        default:
	          return visitor(node);
	      }
	    }
	    function heritageClauseVisitor(node) {
	      switch (node.kind) {
	        case 298 /* HeritageClause */:
	          return visitEachChild(node, heritageClauseVisitor, context);
	        case 233 /* ExpressionWithTypeArguments */:
	          return visitExpressionWithTypeArgumentsInHeritageClause(node);
	        default:
	          return visitor(node);
	      }
	    }
	    function assignmentTargetVisitor(node) {
	      switch (node.kind) {
	        case 210 /* ObjectLiteralExpression */:
	        case 209 /* ArrayLiteralExpression */:
	          return visitAssignmentPattern(node);
	        default:
	          return visitor(node);
	      }
	    }
	    function classElementVisitor(node) {
	      switch (node.kind) {
	        case 176 /* Constructor */:
	          return setCurrentClassElementAnd(
	            node,
	            visitConstructorDeclaration,
	            node
	          );
	        case 177 /* GetAccessor */:
	        case 178 /* SetAccessor */:
	        case 174 /* MethodDeclaration */:
	          return setCurrentClassElementAnd(
	            node,
	            visitMethodOrAccessorDeclaration,
	            node
	          );
	        case 172 /* PropertyDeclaration */:
	          return setCurrentClassElementAnd(
	            node,
	            visitPropertyDeclaration,
	            node
	          );
	        case 175 /* ClassStaticBlockDeclaration */:
	          return setCurrentClassElementAnd(
	            node,
	            visitClassStaticBlockDeclaration,
	            node
	          );
	        case 167 /* ComputedPropertyName */:
	          return visitComputedPropertyName(node);
	        case 240 /* SemicolonClassElement */:
	          return node;
	        default:
	          return isModifierLike(node) ? modifierVisitor(node) : visitor(node);
	      }
	    }
	    function propertyNameVisitor(node) {
	      switch (node.kind) {
	        case 167 /* ComputedPropertyName */:
	          return visitComputedPropertyName(node);
	        default:
	          return visitor(node);
	      }
	    }
	    function accessorFieldResultVisitor(node) {
	      switch (node.kind) {
	        case 172 /* PropertyDeclaration */:
	          return transformFieldInitializer(node);
	        case 177 /* GetAccessor */:
	        case 178 /* SetAccessor */:
	          return classElementVisitor(node);
	        default:
	          Debug.assertMissingNode(node, "Expected node to either be a PropertyDeclaration, GetAccessorDeclaration, or SetAccessorDeclaration");
	          break;
	      }
	    }
	    function visitPrivateIdentifier(node) {
	      if (!shouldTransformPrivateElementsOrClassStaticBlocks) {
	        return node;
	      }
	      if (isStatement(node.parent)) {
	        return node;
	      }
	      return setOriginalNode(factory2.createIdentifier(""), node);
	    }
	    function transformPrivateIdentifierInInExpression(node) {
	      const info = accessPrivateIdentifier2(node.left);
	      if (info) {
	        const receiver = visitNode(node.right, visitor, isExpression);
	        return setOriginalNode(
	          emitHelpers().createClassPrivateFieldInHelper(info.brandCheckIdentifier, receiver),
	          node
	        );
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitPropertyAssignment(node) {
	      if (isNamedEvaluation(node, isAnonymousClassNeedingAssignedName)) {
	        node = transformNamedEvaluation(context, node);
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitVariableStatement(node) {
	      const savedPendingStatements = pendingStatements;
	      pendingStatements = [];
	      const visitedNode = visitEachChild(node, visitor, context);
	      const statement = some(pendingStatements) ? [visitedNode, ...pendingStatements] : visitedNode;
	      pendingStatements = savedPendingStatements;
	      return statement;
	    }
	    function visitVariableDeclaration(node) {
	      if (isNamedEvaluation(node, isAnonymousClassNeedingAssignedName)) {
	        node = transformNamedEvaluation(context, node);
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitParameterDeclaration(node) {
	      if (isNamedEvaluation(node, isAnonymousClassNeedingAssignedName)) {
	        node = transformNamedEvaluation(context, node);
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitBindingElement(node) {
	      if (isNamedEvaluation(node, isAnonymousClassNeedingAssignedName)) {
	        node = transformNamedEvaluation(context, node);
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitExportAssignment(node) {
	      if (isNamedEvaluation(node, isAnonymousClassNeedingAssignedName)) {
	        node = transformNamedEvaluation(
	          context,
	          node,
	          /*ignoreEmptyStringLiteral*/
	          true,
	          node.isExportEquals ? "" : "default"
	        );
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function injectPendingExpressions(expression) {
	      if (some(pendingExpressions)) {
	        if (isParenthesizedExpression(expression)) {
	          pendingExpressions.push(expression.expression);
	          expression = factory2.updateParenthesizedExpression(expression, factory2.inlineExpressions(pendingExpressions));
	        } else {
	          pendingExpressions.push(expression);
	          expression = factory2.inlineExpressions(pendingExpressions);
	        }
	        pendingExpressions = void 0;
	      }
	      return expression;
	    }
	    function visitComputedPropertyName(node) {
	      const expression = visitNode(node.expression, visitor, isExpression);
	      return factory2.updateComputedPropertyName(node, injectPendingExpressions(expression));
	    }
	    function visitConstructorDeclaration(node) {
	      if (currentClassContainer) {
	        return transformConstructor(node, currentClassContainer);
	      }
	      return fallbackVisitor(node);
	    }
	    function shouldTransformClassElementToWeakMap(node) {
	      if (shouldTransformPrivateElementsOrClassStaticBlocks)
	        return true;
	      if (hasStaticModifier(node) && getInternalEmitFlags(node) & 32 /* TransformPrivateStaticElements */)
	        return true;
	      return false;
	    }
	    function visitMethodOrAccessorDeclaration(node) {
	      Debug.assert(!hasDecorators(node));
	      if (!isPrivateIdentifierClassElementDeclaration(node) || !shouldTransformClassElementToWeakMap(node)) {
	        return visitEachChild(node, classElementVisitor, context);
	      }
	      const info = accessPrivateIdentifier2(node.name);
	      Debug.assert(info, "Undeclared private name for property declaration.");
	      if (!info.isValid) {
	        return node;
	      }
	      const functionName = getHoistedFunctionName(node);
	      if (functionName) {
	        getPendingExpressions().push(
	          factory2.createAssignment(
	            functionName,
	            factory2.createFunctionExpression(
	              filter(node.modifiers, (m) => isModifier(m) && !isStaticModifier(m) && !isAccessorModifier(m)),
	              node.asteriskToken,
	              functionName,
	              /*typeParameters*/
	              void 0,
	              visitParameterList(node.parameters, visitor, context),
	              /*type*/
	              void 0,
	              visitFunctionBody(node.body, visitor, context)
	            )
	          )
	        );
	      }
	      return void 0;
	    }
	    function setCurrentClassElementAnd(classElement, visitor2, arg) {
	      if (classElement !== currentClassElement) {
	        const savedCurrentClassElement = currentClassElement;
	        currentClassElement = classElement;
	        const result = visitor2(arg);
	        currentClassElement = savedCurrentClassElement;
	        return result;
	      }
	      return visitor2(arg);
	    }
	    function getHoistedFunctionName(node) {
	      Debug.assert(isPrivateIdentifier(node.name));
	      const info = accessPrivateIdentifier2(node.name);
	      Debug.assert(info, "Undeclared private name for property declaration.");
	      if (info.kind === "m" /* Method */) {
	        return info.methodName;
	      }
	      if (info.kind === "a" /* Accessor */) {
	        if (isGetAccessor(node)) {
	          return info.getterName;
	        }
	        if (isSetAccessor(node)) {
	          return info.setterName;
	        }
	      }
	    }
	    function getClassThis() {
	      const lex = getClassLexicalEnvironment();
	      const classThis = lex.classThis ?? lex.classConstructor ?? (currentClassContainer == null ? void 0 : currentClassContainer.name);
	      return Debug.checkDefined(classThis);
	    }
	    function transformAutoAccessor(node) {
	      const commentRange = getCommentRange(node);
	      const sourceMapRange = getSourceMapRange(node);
	      const name = node.name;
	      let getterName = name;
	      let setterName = name;
	      if (isComputedPropertyName(name) && !isSimpleInlineableExpression(name.expression)) {
	        const cacheAssignment = findComputedPropertyNameCacheAssignment(name);
	        if (cacheAssignment) {
	          getterName = factory2.updateComputedPropertyName(name, visitNode(name.expression, visitor, isExpression));
	          setterName = factory2.updateComputedPropertyName(name, cacheAssignment.left);
	        } else {
	          const temp = factory2.createTempVariable(hoistVariableDeclaration);
	          setSourceMapRange(temp, name.expression);
	          const expression = visitNode(name.expression, visitor, isExpression);
	          const assignment = factory2.createAssignment(temp, expression);
	          setSourceMapRange(assignment, name.expression);
	          getterName = factory2.updateComputedPropertyName(name, assignment);
	          setterName = factory2.updateComputedPropertyName(name, temp);
	        }
	      }
	      const modifiers = visitNodes2(node.modifiers, modifierVisitor, isModifier);
	      const backingField = createAccessorPropertyBackingField(factory2, node, modifiers, node.initializer);
	      setOriginalNode(backingField, node);
	      setEmitFlags(backingField, 3072 /* NoComments */);
	      setSourceMapRange(backingField, sourceMapRange);
	      const receiver = isStatic(node) ? getClassThis() : factory2.createThis();
	      const getter = createAccessorPropertyGetRedirector(factory2, node, modifiers, getterName, receiver);
	      setOriginalNode(getter, node);
	      setCommentRange(getter, commentRange);
	      setSourceMapRange(getter, sourceMapRange);
	      const setterModifiers = factory2.createModifiersFromModifierFlags(modifiersToFlags(modifiers));
	      const setter = createAccessorPropertySetRedirector(factory2, node, setterModifiers, setterName, receiver);
	      setOriginalNode(setter, node);
	      setEmitFlags(setter, 3072 /* NoComments */);
	      setSourceMapRange(setter, sourceMapRange);
	      return visitArray([backingField, getter, setter], accessorFieldResultVisitor, isClassElement);
	    }
	    function transformPrivateFieldInitializer(node) {
	      if (shouldTransformClassElementToWeakMap(node)) {
	        const info = accessPrivateIdentifier2(node.name);
	        Debug.assert(info, "Undeclared private name for property declaration.");
	        if (!info.isValid) {
	          return node;
	        }
	        if (info.isStatic && !shouldTransformPrivateElementsOrClassStaticBlocks) {
	          const statement = transformPropertyOrClassStaticBlock(node, factory2.createThis());
	          if (statement) {
	            return factory2.createClassStaticBlockDeclaration(factory2.createBlock(
	              [statement],
	              /*multiLine*/
	              true
	            ));
	          }
	        }
	        return void 0;
	      }
	      if (shouldTransformInitializersUsingSet && !isStatic(node) && (lexicalEnvironment == null ? void 0 : lexicalEnvironment.data) && lexicalEnvironment.data.facts & 16 /* WillHoistInitializersToConstructor */) {
	        return factory2.updatePropertyDeclaration(
	          node,
	          visitNodes2(node.modifiers, visitor, isModifierLike),
	          node.name,
	          /*questionOrExclamationToken*/
	          void 0,
	          /*type*/
	          void 0,
	          /*initializer*/
	          void 0
	        );
	      }
	      if (isNamedEvaluation(node, isAnonymousClassNeedingAssignedName)) {
	        node = transformNamedEvaluation(context, node);
	      }
	      return factory2.updatePropertyDeclaration(
	        node,
	        visitNodes2(node.modifiers, modifierVisitor, isModifier),
	        visitNode(node.name, propertyNameVisitor, isPropertyName),
	        /*questionOrExclamationToken*/
	        void 0,
	        /*type*/
	        void 0,
	        visitNode(node.initializer, visitor, isExpression)
	      );
	    }
	    function transformPublicFieldInitializer(node) {
	      if (shouldTransformInitializers && !isAutoAccessorPropertyDeclaration(node)) {
	        const expr = getPropertyNameExpressionIfNeeded(
	          node.name,
	          /*shouldHoist*/
	          !!node.initializer || useDefineForClassFields
	        );
	        if (expr) {
	          getPendingExpressions().push(...flattenCommaList(expr));
	        }
	        if (isStatic(node) && !shouldTransformPrivateElementsOrClassStaticBlocks) {
	          const initializerStatement = transformPropertyOrClassStaticBlock(node, factory2.createThis());
	          if (initializerStatement) {
	            const staticBlock = factory2.createClassStaticBlockDeclaration(
	              factory2.createBlock([initializerStatement])
	            );
	            setOriginalNode(staticBlock, node);
	            setCommentRange(staticBlock, node);
	            setCommentRange(initializerStatement, { pos: -1, end: -1 });
	            setSyntheticLeadingComments(initializerStatement, void 0);
	            setSyntheticTrailingComments(initializerStatement, void 0);
	            return staticBlock;
	          }
	        }
	        return void 0;
	      }
	      return factory2.updatePropertyDeclaration(
	        node,
	        visitNodes2(node.modifiers, modifierVisitor, isModifier),
	        visitNode(node.name, propertyNameVisitor, isPropertyName),
	        /*questionOrExclamationToken*/
	        void 0,
	        /*type*/
	        void 0,
	        visitNode(node.initializer, visitor, isExpression)
	      );
	    }
	    function transformFieldInitializer(node) {
	      Debug.assert(!hasDecorators(node), "Decorators should already have been transformed and elided.");
	      return isPrivateIdentifierClassElementDeclaration(node) ? transformPrivateFieldInitializer(node) : transformPublicFieldInitializer(node);
	    }
	    function shouldTransformAutoAccessorsInCurrentClass() {
	      return shouldTransformAutoAccessors === -1 /* True */ || shouldTransformAutoAccessors === 3 /* Maybe */ && !!(lexicalEnvironment == null ? void 0 : lexicalEnvironment.data) && !!(lexicalEnvironment.data.facts & 16 /* WillHoistInitializersToConstructor */);
	    }
	    function visitPropertyDeclaration(node) {
	      if (isAutoAccessorPropertyDeclaration(node) && (shouldTransformAutoAccessorsInCurrentClass() || hasStaticModifier(node) && getInternalEmitFlags(node) & 32 /* TransformPrivateStaticElements */)) {
	        return transformAutoAccessor(node);
	      }
	      return transformFieldInitializer(node);
	    }
	    function shouldForceDynamicThis() {
	      return !!currentClassElement && hasStaticModifier(currentClassElement) && isAccessor(currentClassElement) && isAutoAccessorPropertyDeclaration(getOriginalNode(currentClassElement));
	    }
	    function ensureDynamicThisIfNeeded(node) {
	      if (shouldForceDynamicThis()) {
	        const innerExpression = skipOuterExpressions(node);
	        if (innerExpression.kind === 110 /* ThisKeyword */) {
	          noSubstitution.add(innerExpression);
	        }
	      }
	    }
	    function createPrivateIdentifierAccess(info, receiver) {
	      receiver = visitNode(receiver, visitor, isExpression);
	      ensureDynamicThisIfNeeded(receiver);
	      return createPrivateIdentifierAccessHelper(info, receiver);
	    }
	    function createPrivateIdentifierAccessHelper(info, receiver) {
	      setCommentRange(receiver, moveRangePos(receiver, -1));
	      switch (info.kind) {
	        case "a" /* Accessor */:
	          return emitHelpers().createClassPrivateFieldGetHelper(
	            receiver,
	            info.brandCheckIdentifier,
	            info.kind,
	            info.getterName
	          );
	        case "m" /* Method */:
	          return emitHelpers().createClassPrivateFieldGetHelper(
	            receiver,
	            info.brandCheckIdentifier,
	            info.kind,
	            info.methodName
	          );
	        case "f" /* Field */:
	          return emitHelpers().createClassPrivateFieldGetHelper(
	            receiver,
	            info.brandCheckIdentifier,
	            info.kind,
	            info.isStatic ? info.variableName : void 0
	          );
	        case "untransformed":
	          return Debug.fail("Access helpers should not be created for untransformed private elements");
	        default:
	          Debug.assertNever(info, "Unknown private element type");
	      }
	    }
	    function visitPropertyAccessExpression(node) {
	      if (isPrivateIdentifier(node.name)) {
	        const privateIdentifierInfo = accessPrivateIdentifier2(node.name);
	        if (privateIdentifierInfo) {
	          return setTextRange(
	            setOriginalNode(
	              createPrivateIdentifierAccess(privateIdentifierInfo, node.expression),
	              node
	            ),
	            node
	          );
	        }
	      }
	      if (shouldTransformSuperInStaticInitializers && currentClassElement && isSuperProperty(node) && isIdentifier(node.name) && isStaticPropertyDeclarationOrClassStaticBlock(currentClassElement) && (lexicalEnvironment == null ? void 0 : lexicalEnvironment.data)) {
	        const { classConstructor, superClassReference, facts } = lexicalEnvironment.data;
	        if (facts & 1 /* ClassWasDecorated */) {
	          return visitInvalidSuperProperty(node);
	        }
	        if (classConstructor && superClassReference) {
	          const superProperty = factory2.createReflectGetCall(
	            superClassReference,
	            factory2.createStringLiteralFromNode(node.name),
	            classConstructor
	          );
	          setOriginalNode(superProperty, node.expression);
	          setTextRange(superProperty, node.expression);
	          return superProperty;
	        }
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitElementAccessExpression(node) {
	      if (shouldTransformSuperInStaticInitializers && currentClassElement && isSuperProperty(node) && isStaticPropertyDeclarationOrClassStaticBlock(currentClassElement) && (lexicalEnvironment == null ? void 0 : lexicalEnvironment.data)) {
	        const { classConstructor, superClassReference, facts } = lexicalEnvironment.data;
	        if (facts & 1 /* ClassWasDecorated */) {
	          return visitInvalidSuperProperty(node);
	        }
	        if (classConstructor && superClassReference) {
	          const superProperty = factory2.createReflectGetCall(
	            superClassReference,
	            visitNode(node.argumentExpression, visitor, isExpression),
	            classConstructor
	          );
	          setOriginalNode(superProperty, node.expression);
	          setTextRange(superProperty, node.expression);
	          return superProperty;
	        }
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitPreOrPostfixUnaryExpression(node, discarded) {
	      if (node.operator === 46 /* PlusPlusToken */ || node.operator === 47 /* MinusMinusToken */) {
	        const operand = skipParentheses(node.operand);
	        if (isPrivateIdentifierPropertyAccessExpression(operand)) {
	          let info;
	          if (info = accessPrivateIdentifier2(operand.name)) {
	            const receiver = visitNode(operand.expression, visitor, isExpression);
	            ensureDynamicThisIfNeeded(receiver);
	            const { readExpression, initializeExpression } = createCopiableReceiverExpr(receiver);
	            let expression = createPrivateIdentifierAccess(info, readExpression);
	            const temp = isPrefixUnaryExpression(node) || discarded ? void 0 : factory2.createTempVariable(hoistVariableDeclaration);
	            expression = expandPreOrPostfixIncrementOrDecrementExpression(factory2, node, expression, hoistVariableDeclaration, temp);
	            expression = createPrivateIdentifierAssignment(
	              info,
	              initializeExpression || readExpression,
	              expression,
	              64 /* EqualsToken */
	            );
	            setOriginalNode(expression, node);
	            setTextRange(expression, node);
	            if (temp) {
	              expression = factory2.createComma(expression, temp);
	              setTextRange(expression, node);
	            }
	            return expression;
	          }
	        } else if (shouldTransformSuperInStaticInitializers && currentClassElement && isSuperProperty(operand) && isStaticPropertyDeclarationOrClassStaticBlock(currentClassElement) && (lexicalEnvironment == null ? void 0 : lexicalEnvironment.data)) {
	          const { classConstructor, superClassReference, facts } = lexicalEnvironment.data;
	          if (facts & 1 /* ClassWasDecorated */) {
	            const expression = visitInvalidSuperProperty(operand);
	            return isPrefixUnaryExpression(node) ? factory2.updatePrefixUnaryExpression(node, expression) : factory2.updatePostfixUnaryExpression(node, expression);
	          }
	          if (classConstructor && superClassReference) {
	            let setterName;
	            let getterName;
	            if (isPropertyAccessExpression(operand)) {
	              if (isIdentifier(operand.name)) {
	                getterName = setterName = factory2.createStringLiteralFromNode(operand.name);
	              }
	            } else {
	              if (isSimpleInlineableExpression(operand.argumentExpression)) {
	                getterName = setterName = operand.argumentExpression;
	              } else {
	                getterName = factory2.createTempVariable(hoistVariableDeclaration);
	                setterName = factory2.createAssignment(getterName, visitNode(operand.argumentExpression, visitor, isExpression));
	              }
	            }
	            if (setterName && getterName) {
	              let expression = factory2.createReflectGetCall(superClassReference, getterName, classConstructor);
	              setTextRange(expression, operand);
	              const temp = discarded ? void 0 : factory2.createTempVariable(hoistVariableDeclaration);
	              expression = expandPreOrPostfixIncrementOrDecrementExpression(factory2, node, expression, hoistVariableDeclaration, temp);
	              expression = factory2.createReflectSetCall(superClassReference, setterName, expression, classConstructor);
	              setOriginalNode(expression, node);
	              setTextRange(expression, node);
	              if (temp) {
	                expression = factory2.createComma(expression, temp);
	                setTextRange(expression, node);
	              }
	              return expression;
	            }
	          }
	        }
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitForStatement(node) {
	      return factory2.updateForStatement(
	        node,
	        visitNode(node.initializer, discardedValueVisitor, isForInitializer),
	        visitNode(node.condition, visitor, isExpression),
	        visitNode(node.incrementor, discardedValueVisitor, isExpression),
	        visitIterationBody(node.statement, visitor, context)
	      );
	    }
	    function visitExpressionStatement(node) {
	      return factory2.updateExpressionStatement(
	        node,
	        visitNode(node.expression, discardedValueVisitor, isExpression)
	      );
	    }
	    function createCopiableReceiverExpr(receiver) {
	      const clone2 = nodeIsSynthesized(receiver) ? receiver : factory2.cloneNode(receiver);
	      if (receiver.kind === 110 /* ThisKeyword */ && noSubstitution.has(receiver)) {
	        noSubstitution.add(clone2);
	      }
	      if (isSimpleInlineableExpression(receiver)) {
	        return { readExpression: clone2, initializeExpression: void 0 };
	      }
	      const readExpression = factory2.createTempVariable(hoistVariableDeclaration);
	      const initializeExpression = factory2.createAssignment(readExpression, clone2);
	      return { readExpression, initializeExpression };
	    }
	    function visitCallExpression(node) {
	      var _a;
	      if (isPrivateIdentifierPropertyAccessExpression(node.expression) && accessPrivateIdentifier2(node.expression.name)) {
	        const { thisArg, target } = factory2.createCallBinding(node.expression, hoistVariableDeclaration, languageVersion);
	        if (isCallChain(node)) {
	          return factory2.updateCallChain(
	            node,
	            factory2.createPropertyAccessChain(visitNode(target, visitor, isExpression), node.questionDotToken, "call"),
	            /*questionDotToken*/
	            void 0,
	            /*typeArguments*/
	            void 0,
	            [visitNode(thisArg, visitor, isExpression), ...visitNodes2(node.arguments, visitor, isExpression)]
	          );
	        }
	        return factory2.updateCallExpression(
	          node,
	          factory2.createPropertyAccessExpression(visitNode(target, visitor, isExpression), "call"),
	          /*typeArguments*/
	          void 0,
	          [visitNode(thisArg, visitor, isExpression), ...visitNodes2(node.arguments, visitor, isExpression)]
	        );
	      }
	      if (shouldTransformSuperInStaticInitializers && currentClassElement && isSuperProperty(node.expression) && isStaticPropertyDeclarationOrClassStaticBlock(currentClassElement) && ((_a = lexicalEnvironment == null ? void 0 : lexicalEnvironment.data) == null ? void 0 : _a.classConstructor)) {
	        const invocation = factory2.createFunctionCallCall(
	          visitNode(node.expression, visitor, isExpression),
	          lexicalEnvironment.data.classConstructor,
	          visitNodes2(node.arguments, visitor, isExpression)
	        );
	        setOriginalNode(invocation, node);
	        setTextRange(invocation, node);
	        return invocation;
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitTaggedTemplateExpression(node) {
	      var _a;
	      if (isPrivateIdentifierPropertyAccessExpression(node.tag) && accessPrivateIdentifier2(node.tag.name)) {
	        const { thisArg, target } = factory2.createCallBinding(node.tag, hoistVariableDeclaration, languageVersion);
	        return factory2.updateTaggedTemplateExpression(
	          node,
	          factory2.createCallExpression(
	            factory2.createPropertyAccessExpression(visitNode(target, visitor, isExpression), "bind"),
	            /*typeArguments*/
	            void 0,
	            [visitNode(thisArg, visitor, isExpression)]
	          ),
	          /*typeArguments*/
	          void 0,
	          visitNode(node.template, visitor, isTemplateLiteral)
	        );
	      }
	      if (shouldTransformSuperInStaticInitializers && currentClassElement && isSuperProperty(node.tag) && isStaticPropertyDeclarationOrClassStaticBlock(currentClassElement) && ((_a = lexicalEnvironment == null ? void 0 : lexicalEnvironment.data) == null ? void 0 : _a.classConstructor)) {
	        const invocation = factory2.createFunctionBindCall(
	          visitNode(node.tag, visitor, isExpression),
	          lexicalEnvironment.data.classConstructor,
	          []
	        );
	        setOriginalNode(invocation, node);
	        setTextRange(invocation, node);
	        return factory2.updateTaggedTemplateExpression(
	          node,
	          invocation,
	          /*typeArguments*/
	          void 0,
	          visitNode(node.template, visitor, isTemplateLiteral)
	        );
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function transformClassStaticBlockDeclaration(node) {
	      if (lexicalEnvironment) {
	        lexicalEnvironmentMap.set(getOriginalNode(node), lexicalEnvironment);
	      }
	      if (shouldTransformPrivateElementsOrClassStaticBlocks) {
	        if (isClassThisAssignmentBlock(node)) {
	          const result = visitNode(node.body.statements[0].expression, visitor, isExpression);
	          if (isAssignmentExpression(
	            result,
	            /*excludeCompoundAssignment*/
	            true
	          ) && result.left === result.right) {
	            return void 0;
	          }
	          return result;
	        }
	        if (isClassNamedEvaluationHelperBlock(node)) {
	          return visitNode(node.body.statements[0].expression, visitor, isExpression);
	        }
	        startLexicalEnvironment();
	        let statements = setCurrentClassElementAnd(
	          node,
	          (statements2) => visitNodes2(statements2, visitor, isStatement),
	          node.body.statements
	        );
	        statements = factory2.mergeLexicalEnvironment(statements, endLexicalEnvironment());
	        const iife = factory2.createImmediatelyInvokedArrowFunction(statements);
	        setOriginalNode(skipParentheses(iife.expression), node);
	        addEmitFlags(skipParentheses(iife.expression), 4 /* AdviseOnEmitNode */);
	        setOriginalNode(iife, node);
	        setTextRange(iife, node);
	        return iife;
	      }
	    }
	    function isAnonymousClassNeedingAssignedName(node) {
	      if (isClassExpression(node) && !node.name) {
	        const staticPropertiesOrClassStaticBlocks = getStaticPropertiesAndClassStaticBlock(node);
	        if (some(staticPropertiesOrClassStaticBlocks, isClassNamedEvaluationHelperBlock)) {
	          return false;
	        }
	        const hasTransformableStatics = (shouldTransformPrivateElementsOrClassStaticBlocks || !!(getInternalEmitFlags(node) && 32 /* TransformPrivateStaticElements */)) && some(staticPropertiesOrClassStaticBlocks, (node2) => isClassStaticBlockDeclaration(node2) || isPrivateIdentifierClassElementDeclaration(node2) || shouldTransformInitializers && isInitializedProperty(node2));
	        return hasTransformableStatics;
	      }
	      return false;
	    }
	    function visitBinaryExpression(node, discarded) {
	      if (isDestructuringAssignment(node)) {
	        const savedPendingExpressions = pendingExpressions;
	        pendingExpressions = void 0;
	        node = factory2.updateBinaryExpression(
	          node,
	          visitNode(node.left, assignmentTargetVisitor, isExpression),
	          node.operatorToken,
	          visitNode(node.right, visitor, isExpression)
	        );
	        const expr = some(pendingExpressions) ? factory2.inlineExpressions(compact([...pendingExpressions, node])) : node;
	        pendingExpressions = savedPendingExpressions;
	        return expr;
	      }
	      if (isAssignmentExpression(node)) {
	        if (isNamedEvaluation(node, isAnonymousClassNeedingAssignedName)) {
	          node = transformNamedEvaluation(context, node);
	          Debug.assertNode(node, isAssignmentExpression);
	        }
	        const left = skipOuterExpressions(node.left, 8 /* PartiallyEmittedExpressions */ | 1 /* Parentheses */);
	        if (isPrivateIdentifierPropertyAccessExpression(left)) {
	          const info = accessPrivateIdentifier2(left.name);
	          if (info) {
	            return setTextRange(
	              setOriginalNode(
	                createPrivateIdentifierAssignment(info, left.expression, node.right, node.operatorToken.kind),
	                node
	              ),
	              node
	            );
	          }
	        } else if (shouldTransformSuperInStaticInitializers && currentClassElement && isSuperProperty(node.left) && isStaticPropertyDeclarationOrClassStaticBlock(currentClassElement) && (lexicalEnvironment == null ? void 0 : lexicalEnvironment.data)) {
	          const { classConstructor, superClassReference, facts } = lexicalEnvironment.data;
	          if (facts & 1 /* ClassWasDecorated */) {
	            return factory2.updateBinaryExpression(
	              node,
	              visitInvalidSuperProperty(node.left),
	              node.operatorToken,
	              visitNode(node.right, visitor, isExpression)
	            );
	          }
	          if (classConstructor && superClassReference) {
	            let setterName = isElementAccessExpression(node.left) ? visitNode(node.left.argumentExpression, visitor, isExpression) : isIdentifier(node.left.name) ? factory2.createStringLiteralFromNode(node.left.name) : void 0;
	            if (setterName) {
	              let expression = visitNode(node.right, visitor, isExpression);
	              if (isCompoundAssignment(node.operatorToken.kind)) {
	                let getterName = setterName;
	                if (!isSimpleInlineableExpression(setterName)) {
	                  getterName = factory2.createTempVariable(hoistVariableDeclaration);
	                  setterName = factory2.createAssignment(getterName, setterName);
	                }
	                const superPropertyGet = factory2.createReflectGetCall(
	                  superClassReference,
	                  getterName,
	                  classConstructor
	                );
	                setOriginalNode(superPropertyGet, node.left);
	                setTextRange(superPropertyGet, node.left);
	                expression = factory2.createBinaryExpression(
	                  superPropertyGet,
	                  getNonAssignmentOperatorForCompoundAssignment(node.operatorToken.kind),
	                  expression
	                );
	                setTextRange(expression, node);
	              }
	              const temp = discarded ? void 0 : factory2.createTempVariable(hoistVariableDeclaration);
	              if (temp) {
	                expression = factory2.createAssignment(temp, expression);
	                setTextRange(temp, node);
	              }
	              expression = factory2.createReflectSetCall(
	                superClassReference,
	                setterName,
	                expression,
	                classConstructor
	              );
	              setOriginalNode(expression, node);
	              setTextRange(expression, node);
	              if (temp) {
	                expression = factory2.createComma(expression, temp);
	                setTextRange(expression, node);
	              }
	              return expression;
	            }
	          }
	        }
	      }
	      if (isPrivateIdentifierInExpression(node)) {
	        return transformPrivateIdentifierInInExpression(node);
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitCommaListExpression(node, discarded) {
	      const elements = discarded ? visitCommaListElements(node.elements, discardedValueVisitor) : visitCommaListElements(node.elements, visitor, discardedValueVisitor);
	      return factory2.updateCommaListExpression(node, elements);
	    }
	    function visitParenthesizedExpression(node, discarded) {
	      const visitorFunc = discarded ? discardedValueVisitor : visitor;
	      const expression = visitNode(node.expression, visitorFunc, isExpression);
	      return factory2.updateParenthesizedExpression(node, expression);
	    }
	    function createPrivateIdentifierAssignment(info, receiver, right, operator) {
	      receiver = visitNode(receiver, visitor, isExpression);
	      right = visitNode(right, visitor, isExpression);
	      ensureDynamicThisIfNeeded(receiver);
	      if (isCompoundAssignment(operator)) {
	        const { readExpression, initializeExpression } = createCopiableReceiverExpr(receiver);
	        receiver = initializeExpression || readExpression;
	        right = factory2.createBinaryExpression(
	          createPrivateIdentifierAccessHelper(info, readExpression),
	          getNonAssignmentOperatorForCompoundAssignment(operator),
	          right
	        );
	      }
	      setCommentRange(receiver, moveRangePos(receiver, -1));
	      switch (info.kind) {
	        case "a" /* Accessor */:
	          return emitHelpers().createClassPrivateFieldSetHelper(
	            receiver,
	            info.brandCheckIdentifier,
	            right,
	            info.kind,
	            info.setterName
	          );
	        case "m" /* Method */:
	          return emitHelpers().createClassPrivateFieldSetHelper(
	            receiver,
	            info.brandCheckIdentifier,
	            right,
	            info.kind,
	            /*f*/
	            void 0
	          );
	        case "f" /* Field */:
	          return emitHelpers().createClassPrivateFieldSetHelper(
	            receiver,
	            info.brandCheckIdentifier,
	            right,
	            info.kind,
	            info.isStatic ? info.variableName : void 0
	          );
	        case "untransformed":
	          return Debug.fail("Access helpers should not be created for untransformed private elements");
	        default:
	          Debug.assertNever(info, "Unknown private element type");
	      }
	    }
	    function getPrivateInstanceMethodsAndAccessors(node) {
	      return filter(node.members, isNonStaticMethodOrAccessorWithPrivateName);
	    }
	    function getClassFacts(node) {
	      var _a;
	      let facts = 0 /* None */;
	      const original = getOriginalNode(node);
	      if (isClassDeclaration(original) && classOrConstructorParameterIsDecorated(legacyDecorators, original)) {
	        facts |= 1 /* ClassWasDecorated */;
	      }
	      if (shouldTransformPrivateElementsOrClassStaticBlocks && (classHasClassThisAssignment(node) || classHasExplicitlyAssignedName(node))) {
	        facts |= 2 /* NeedsClassConstructorReference */;
	      }
	      let containsPublicInstanceFields = false;
	      let containsInitializedPublicInstanceFields = false;
	      let containsInstancePrivateElements = false;
	      let containsInstanceAutoAccessors = false;
	      for (const member of node.members) {
	        if (isStatic(member)) {
	          if (member.name && (isPrivateIdentifier(member.name) || isAutoAccessorPropertyDeclaration(member)) && shouldTransformPrivateElementsOrClassStaticBlocks) {
	            facts |= 2 /* NeedsClassConstructorReference */;
	          } else if (isAutoAccessorPropertyDeclaration(member) && shouldTransformAutoAccessors === -1 /* True */ && !node.name && !((_a = node.emitNode) == null ? void 0 : _a.classThis)) {
	            facts |= 2 /* NeedsClassConstructorReference */;
	          }
	          if (isPropertyDeclaration(member) || isClassStaticBlockDeclaration(member)) {
	            if (shouldTransformThisInStaticInitializers && member.transformFlags & 16384 /* ContainsLexicalThis */) {
	              facts |= 8 /* NeedsSubstitutionForThisInClassStaticField */;
	              if (!(facts & 1 /* ClassWasDecorated */)) {
	                facts |= 2 /* NeedsClassConstructorReference */;
	              }
	            }
	            if (shouldTransformSuperInStaticInitializers && member.transformFlags & 134217728 /* ContainsLexicalSuper */) {
	              if (!(facts & 1 /* ClassWasDecorated */)) {
	                facts |= 2 /* NeedsClassConstructorReference */ | 4 /* NeedsClassSuperReference */;
	              }
	            }
	          }
	        } else if (!hasAbstractModifier(getOriginalNode(member))) {
	          if (isAutoAccessorPropertyDeclaration(member)) {
	            containsInstanceAutoAccessors = true;
	            containsInstancePrivateElements || (containsInstancePrivateElements = isPrivateIdentifierClassElementDeclaration(member));
	          } else if (isPrivateIdentifierClassElementDeclaration(member)) {
	            containsInstancePrivateElements = true;
	            if (resolver.getNodeCheckFlags(member) & 262144 /* ContainsConstructorReference */) {
	              facts |= 2 /* NeedsClassConstructorReference */;
	            }
	          } else if (isPropertyDeclaration(member)) {
	            containsPublicInstanceFields = true;
	            containsInitializedPublicInstanceFields || (containsInitializedPublicInstanceFields = !!member.initializer);
	          }
	        }
	      }
	      const willHoistInitializersToConstructor = shouldTransformInitializersUsingDefine && containsPublicInstanceFields || shouldTransformInitializersUsingSet && containsInitializedPublicInstanceFields || shouldTransformPrivateElementsOrClassStaticBlocks && containsInstancePrivateElements || shouldTransformPrivateElementsOrClassStaticBlocks && containsInstanceAutoAccessors && shouldTransformAutoAccessors === -1 /* True */;
	      if (willHoistInitializersToConstructor) {
	        facts |= 16 /* WillHoistInitializersToConstructor */;
	      }
	      return facts;
	    }
	    function visitExpressionWithTypeArgumentsInHeritageClause(node) {
	      var _a;
	      const facts = ((_a = lexicalEnvironment == null ? void 0 : lexicalEnvironment.data) == null ? void 0 : _a.facts) || 0 /* None */;
	      if (facts & 4 /* NeedsClassSuperReference */) {
	        const temp = factory2.createTempVariable(
	          hoistVariableDeclaration,
	          /*reservedInNestedScopes*/
	          true
	        );
	        getClassLexicalEnvironment().superClassReference = temp;
	        return factory2.updateExpressionWithTypeArguments(
	          node,
	          factory2.createAssignment(
	            temp,
	            visitNode(node.expression, visitor, isExpression)
	          ),
	          /*typeArguments*/
	          void 0
	        );
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitInNewClassLexicalEnvironment(node, visitor2) {
	      var _a;
	      const savedCurrentClassContainer = currentClassContainer;
	      const savedPendingExpressions = pendingExpressions;
	      const savedLexicalEnvironment = lexicalEnvironment;
	      currentClassContainer = node;
	      pendingExpressions = void 0;
	      startClassLexicalEnvironment();
	      const shouldAlwaysTransformPrivateStaticElements = getInternalEmitFlags(node) & 32 /* TransformPrivateStaticElements */;
	      if (shouldTransformPrivateElementsOrClassStaticBlocks || shouldAlwaysTransformPrivateStaticElements) {
	        const name = getNameOfDeclaration(node);
	        if (name && isIdentifier(name)) {
	          getPrivateIdentifierEnvironment().data.className = name;
	        } else if ((_a = node.emitNode) == null ? void 0 : _a.assignedName) {
	          if (isStringLiteral(node.emitNode.assignedName)) {
	            if (node.emitNode.assignedName.textSourceNode && isIdentifier(node.emitNode.assignedName.textSourceNode)) {
	              getPrivateIdentifierEnvironment().data.className = node.emitNode.assignedName.textSourceNode;
	            } else if (isIdentifierText(node.emitNode.assignedName.text, languageVersion)) {
	              const prefixName = factory2.createIdentifier(node.emitNode.assignedName.text);
	              getPrivateIdentifierEnvironment().data.className = prefixName;
	            }
	          }
	        }
	      }
	      if (shouldTransformPrivateElementsOrClassStaticBlocks) {
	        const privateInstanceMethodsAndAccessors = getPrivateInstanceMethodsAndAccessors(node);
	        if (some(privateInstanceMethodsAndAccessors)) {
	          getPrivateIdentifierEnvironment().data.weakSetName = createHoistedVariableForClass(
	            "instances",
	            privateInstanceMethodsAndAccessors[0].name
	          );
	        }
	      }
	      const facts = getClassFacts(node);
	      if (facts) {
	        getClassLexicalEnvironment().facts = facts;
	      }
	      if (facts & 8 /* NeedsSubstitutionForThisInClassStaticField */) {
	        enableSubstitutionForClassStaticThisOrSuperReference();
	      }
	      const result = visitor2(node, facts);
	      endClassLexicalEnvironment();
	      Debug.assert(lexicalEnvironment === savedLexicalEnvironment);
	      currentClassContainer = savedCurrentClassContainer;
	      pendingExpressions = savedPendingExpressions;
	      return result;
	    }
	    function visitClassDeclaration(node) {
	      return visitInNewClassLexicalEnvironment(node, visitClassDeclarationInNewClassLexicalEnvironment);
	    }
	    function visitClassDeclarationInNewClassLexicalEnvironment(node, facts) {
	      var _a, _b;
	      let pendingClassReferenceAssignment;
	      if (facts & 2 /* NeedsClassConstructorReference */) {
	        if (shouldTransformPrivateElementsOrClassStaticBlocks && ((_a = node.emitNode) == null ? void 0 : _a.classThis)) {
	          getClassLexicalEnvironment().classConstructor = node.emitNode.classThis;
	          pendingClassReferenceAssignment = factory2.createAssignment(node.emitNode.classThis, factory2.getInternalName(node));
	        } else {
	          const temp = factory2.createTempVariable(
	            hoistVariableDeclaration,
	            /*reservedInNestedScopes*/
	            true
	          );
	          getClassLexicalEnvironment().classConstructor = factory2.cloneNode(temp);
	          pendingClassReferenceAssignment = factory2.createAssignment(temp, factory2.getInternalName(node));
	        }
	      }
	      if ((_b = node.emitNode) == null ? void 0 : _b.classThis) {
	        getClassLexicalEnvironment().classThis = node.emitNode.classThis;
	      }
	      const isClassWithConstructorReference = resolver.getNodeCheckFlags(node) & 262144 /* ContainsConstructorReference */;
	      const isExport = hasSyntacticModifier(node, 32 /* Export */);
	      const isDefault = hasSyntacticModifier(node, 2048 /* Default */);
	      let modifiers = visitNodes2(node.modifiers, modifierVisitor, isModifier);
	      const heritageClauses = visitNodes2(node.heritageClauses, heritageClauseVisitor, isHeritageClause);
	      const { members, prologue } = transformClassMembers(node);
	      const statements = [];
	      if (pendingClassReferenceAssignment) {
	        getPendingExpressions().unshift(pendingClassReferenceAssignment);
	      }
	      if (some(pendingExpressions)) {
	        statements.push(factory2.createExpressionStatement(factory2.inlineExpressions(pendingExpressions)));
	      }
	      if (shouldTransformInitializersUsingSet || shouldTransformPrivateElementsOrClassStaticBlocks || getInternalEmitFlags(node) & 32 /* TransformPrivateStaticElements */) {
	        const staticProperties = getStaticPropertiesAndClassStaticBlock(node);
	        if (some(staticProperties)) {
	          addPropertyOrClassStaticBlockStatements(statements, staticProperties, factory2.getInternalName(node));
	        }
	      }
	      if (statements.length > 0 && isExport && isDefault) {
	        modifiers = visitNodes2(modifiers, (node2) => isExportOrDefaultModifier(node2) ? void 0 : node2, isModifier);
	        statements.push(factory2.createExportAssignment(
	          /*modifiers*/
	          void 0,
	          /*isExportEquals*/
	          false,
	          factory2.getLocalName(
	            node,
	            /*allowComments*/
	            false,
	            /*allowSourceMaps*/
	            true
	          )
	        ));
	      }
	      const alias = getClassLexicalEnvironment().classConstructor;
	      if (isClassWithConstructorReference && alias) {
	        enableSubstitutionForClassAliases();
	        classAliases[getOriginalNodeId(node)] = alias;
	      }
	      const classDecl = factory2.updateClassDeclaration(
	        node,
	        modifiers,
	        node.name,
	        /*typeParameters*/
	        void 0,
	        heritageClauses,
	        members
	      );
	      statements.unshift(classDecl);
	      if (prologue) {
	        statements.unshift(factory2.createExpressionStatement(prologue));
	      }
	      return statements;
	    }
	    function visitClassExpression(node) {
	      return visitInNewClassLexicalEnvironment(node, visitClassExpressionInNewClassLexicalEnvironment);
	    }
	    function visitClassExpressionInNewClassLexicalEnvironment(node, facts) {
	      var _a, _b, _c;
	      const isDecoratedClassDeclaration = !!(facts & 1 /* ClassWasDecorated */);
	      const staticPropertiesOrClassStaticBlocks = getStaticPropertiesAndClassStaticBlock(node);
	      const classCheckFlags = resolver.getNodeCheckFlags(node);
	      const isClassWithConstructorReference = classCheckFlags & 262144 /* ContainsConstructorReference */;
	      let temp;
	      function createClassTempVar() {
	        var _a2;
	        if (shouldTransformPrivateElementsOrClassStaticBlocks && ((_a2 = node.emitNode) == null ? void 0 : _a2.classThis)) {
	          return getClassLexicalEnvironment().classConstructor = node.emitNode.classThis;
	        }
	        const requiresBlockScopedVar = classCheckFlags & 32768 /* BlockScopedBindingInLoop */;
	        const temp2 = factory2.createTempVariable(
	          requiresBlockScopedVar ? addBlockScopedVariable : hoistVariableDeclaration,
	          /*reservedInNestedScopes*/
	          true
	        );
	        getClassLexicalEnvironment().classConstructor = factory2.cloneNode(temp2);
	        return temp2;
	      }
	      if ((_a = node.emitNode) == null ? void 0 : _a.classThis) {
	        getClassLexicalEnvironment().classThis = node.emitNode.classThis;
	      }
	      if (facts & 2 /* NeedsClassConstructorReference */) {
	        temp ?? (temp = createClassTempVar());
	      }
	      const modifiers = visitNodes2(node.modifiers, modifierVisitor, isModifier);
	      const heritageClauses = visitNodes2(node.heritageClauses, heritageClauseVisitor, isHeritageClause);
	      const { members, prologue } = transformClassMembers(node);
	      const classExpression = factory2.updateClassExpression(
	        node,
	        modifiers,
	        node.name,
	        /*typeParameters*/
	        void 0,
	        heritageClauses,
	        members
	      );
	      const expressions = [];
	      if (prologue) {
	        expressions.push(prologue);
	      }
	      const hasTransformableStatics = (shouldTransformPrivateElementsOrClassStaticBlocks || getInternalEmitFlags(node) & 32 /* TransformPrivateStaticElements */) && some(staticPropertiesOrClassStaticBlocks, (node2) => isClassStaticBlockDeclaration(node2) || isPrivateIdentifierClassElementDeclaration(node2) || shouldTransformInitializers && isInitializedProperty(node2));
	      if (hasTransformableStatics || some(pendingExpressions)) {
	        if (isDecoratedClassDeclaration) {
	          Debug.assertIsDefined(pendingStatements, "Decorated classes transformed by TypeScript are expected to be within a variable declaration.");
	          if (some(pendingExpressions)) {
	            addRange(pendingStatements, map(pendingExpressions, factory2.createExpressionStatement));
	          }
	          if (some(staticPropertiesOrClassStaticBlocks)) {
	            addPropertyOrClassStaticBlockStatements(pendingStatements, staticPropertiesOrClassStaticBlocks, ((_b = node.emitNode) == null ? void 0 : _b.classThis) ?? factory2.getInternalName(node));
	          }
	          if (temp) {
	            expressions.push(factory2.createAssignment(temp, classExpression));
	          } else if (shouldTransformPrivateElementsOrClassStaticBlocks && ((_c = node.emitNode) == null ? void 0 : _c.classThis)) {
	            expressions.push(factory2.createAssignment(node.emitNode.classThis, classExpression));
	          } else {
	            expressions.push(classExpression);
	          }
	        } else {
	          temp ?? (temp = createClassTempVar());
	          if (isClassWithConstructorReference) {
	            enableSubstitutionForClassAliases();
	            const alias = factory2.cloneNode(temp);
	            alias.emitNode.autoGenerate.flags &= ~8 /* ReservedInNestedScopes */;
	            classAliases[getOriginalNodeId(node)] = alias;
	          }
	          expressions.push(factory2.createAssignment(temp, classExpression));
	          addRange(expressions, pendingExpressions);
	          addRange(expressions, generateInitializedPropertyExpressionsOrClassStaticBlock(staticPropertiesOrClassStaticBlocks, temp));
	          expressions.push(factory2.cloneNode(temp));
	        }
	      } else {
	        expressions.push(classExpression);
	      }
	      if (expressions.length > 1) {
	        addEmitFlags(classExpression, 131072 /* Indented */);
	        expressions.forEach(startOnNewLine);
	      }
	      return factory2.inlineExpressions(expressions);
	    }
	    function visitClassStaticBlockDeclaration(node) {
	      if (!shouldTransformPrivateElementsOrClassStaticBlocks) {
	        return visitEachChild(node, visitor, context);
	      }
	      return void 0;
	    }
	    function visitThisExpression(node) {
	      if (shouldTransformThisInStaticInitializers && currentClassElement && isClassStaticBlockDeclaration(currentClassElement) && (lexicalEnvironment == null ? void 0 : lexicalEnvironment.data)) {
	        const { classThis, classConstructor } = lexicalEnvironment.data;
	        return classThis ?? classConstructor ?? node;
	      }
	      return node;
	    }
	    function transformClassMembers(node) {
	      const shouldTransformPrivateStaticElementsInClass = !!(getInternalEmitFlags(node) & 32 /* TransformPrivateStaticElements */);
	      if (shouldTransformPrivateElementsOrClassStaticBlocks || shouldTransformPrivateStaticElementsInFile) {
	        for (const member of node.members) {
	          if (isPrivateIdentifierClassElementDeclaration(member)) {
	            if (shouldTransformClassElementToWeakMap(member)) {
	              addPrivateIdentifierToEnvironment(member, member.name, addPrivateIdentifierClassElementToEnvironment);
	            } else {
	              const privateEnv = getPrivateIdentifierEnvironment();
	              setPrivateIdentifier(privateEnv, member.name, { kind: "untransformed" });
	            }
	          }
	        }
	        if (shouldTransformPrivateElementsOrClassStaticBlocks) {
	          if (some(getPrivateInstanceMethodsAndAccessors(node))) {
	            createBrandCheckWeakSetForPrivateMethods();
	          }
	        }
	        if (shouldTransformAutoAccessorsInCurrentClass()) {
	          for (const member of node.members) {
	            if (isAutoAccessorPropertyDeclaration(member)) {
	              const storageName = factory2.getGeneratedPrivateNameForNode(
	                member.name,
	                /*prefix*/
	                void 0,
	                "_accessor_storage"
	              );
	              if (shouldTransformPrivateElementsOrClassStaticBlocks || shouldTransformPrivateStaticElementsInClass && hasStaticModifier(member)) {
	                addPrivateIdentifierToEnvironment(member, storageName, addPrivateIdentifierPropertyDeclarationToEnvironment);
	              } else {
	                const privateEnv = getPrivateIdentifierEnvironment();
	                setPrivateIdentifier(privateEnv, storageName, { kind: "untransformed" });
	              }
	            }
	          }
	        }
	      }
	      let members = visitNodes2(node.members, classElementVisitor, isClassElement);
	      let syntheticConstructor;
	      if (!some(members, isConstructorDeclaration)) {
	        syntheticConstructor = transformConstructor(
	          /*constructor*/
	          void 0,
	          node
	        );
	      }
	      let prologue;
	      let syntheticStaticBlock;
	      if (!shouldTransformPrivateElementsOrClassStaticBlocks && some(pendingExpressions)) {
	        let statement = factory2.createExpressionStatement(factory2.inlineExpressions(pendingExpressions));
	        if (statement.transformFlags & 134234112 /* ContainsLexicalThisOrSuper */) {
	          const temp = factory2.createTempVariable(hoistVariableDeclaration);
	          const arrow = factory2.createArrowFunction(
	            /*modifiers*/
	            void 0,
	            /*typeParameters*/
	            void 0,
	            /*parameters*/
	            [],
	            /*type*/
	            void 0,
	            /*equalsGreaterThanToken*/
	            void 0,
	            factory2.createBlock([statement])
	          );
	          prologue = factory2.createAssignment(temp, arrow);
	          statement = factory2.createExpressionStatement(factory2.createCallExpression(
	            temp,
	            /*typeArguments*/
	            void 0,
	            []
	          ));
	        }
	        const block = factory2.createBlock([statement]);
	        syntheticStaticBlock = factory2.createClassStaticBlockDeclaration(block);
	        pendingExpressions = void 0;
	      }
	      if (syntheticConstructor || syntheticStaticBlock) {
	        let membersArray;
	        const classThisAssignmentBlock = find(members, isClassThisAssignmentBlock);
	        const classNamedEvaluationHelperBlock = find(members, isClassNamedEvaluationHelperBlock);
	        membersArray = append(membersArray, classThisAssignmentBlock);
	        membersArray = append(membersArray, classNamedEvaluationHelperBlock);
	        membersArray = append(membersArray, syntheticConstructor);
	        membersArray = append(membersArray, syntheticStaticBlock);
	        const remainingMembers = classThisAssignmentBlock || classNamedEvaluationHelperBlock ? filter(members, (member) => member !== classThisAssignmentBlock && member !== classNamedEvaluationHelperBlock) : members;
	        membersArray = addRange(membersArray, remainingMembers);
	        members = setTextRange(
	          factory2.createNodeArray(membersArray),
	          /*location*/
	          node.members
	        );
	      }
	      return { members, prologue };
	    }
	    function createBrandCheckWeakSetForPrivateMethods() {
	      const { weakSetName } = getPrivateIdentifierEnvironment().data;
	      Debug.assert(weakSetName, "weakSetName should be set in private identifier environment");
	      getPendingExpressions().push(
	        factory2.createAssignment(
	          weakSetName,
	          factory2.createNewExpression(
	            factory2.createIdentifier("WeakSet"),
	            /*typeArguments*/
	            void 0,
	            []
	          )
	        )
	      );
	    }
	    function transformConstructor(constructor, container) {
	      constructor = visitNode(constructor, visitor, isConstructorDeclaration);
	      if (!(lexicalEnvironment == null ? void 0 : lexicalEnvironment.data) || !(lexicalEnvironment.data.facts & 16 /* WillHoistInitializersToConstructor */)) {
	        return constructor;
	      }
	      const extendsClauseElement = getEffectiveBaseTypeNode(container);
	      const isDerivedClass = !!(extendsClauseElement && skipOuterExpressions(extendsClauseElement.expression).kind !== 106 /* NullKeyword */);
	      const parameters = visitParameterList(constructor ? constructor.parameters : void 0, visitor, context);
	      const body = transformConstructorBody(container, constructor, isDerivedClass);
	      if (!body) {
	        return constructor;
	      }
	      if (constructor) {
	        Debug.assert(parameters);
	        return factory2.updateConstructorDeclaration(
	          constructor,
	          /*modifiers*/
	          void 0,
	          parameters,
	          body
	        );
	      }
	      return startOnNewLine(
	        setOriginalNode(
	          setTextRange(
	            factory2.createConstructorDeclaration(
	              /*modifiers*/
	              void 0,
	              parameters ?? [],
	              body
	            ),
	            constructor || container
	          ),
	          constructor
	        )
	      );
	    }
	    function transformConstructorBodyWorker(statementsOut, statementsIn, statementOffset, superPath, superPathDepth, initializerStatements, constructor) {
	      const superStatementIndex = superPath[superPathDepth];
	      const superStatement = statementsIn[superStatementIndex];
	      addRange(statementsOut, visitNodes2(statementsIn, visitor, isStatement, statementOffset, superStatementIndex - statementOffset));
	      statementOffset = superStatementIndex + 1;
	      if (isTryStatement(superStatement)) {
	        const tryBlockStatements = [];
	        transformConstructorBodyWorker(
	          tryBlockStatements,
	          superStatement.tryBlock.statements,
	          /*statementOffset*/
	          0,
	          superPath,
	          superPathDepth + 1,
	          initializerStatements,
	          constructor
	        );
	        const tryBlockStatementsArray = factory2.createNodeArray(tryBlockStatements);
	        setTextRange(tryBlockStatementsArray, superStatement.tryBlock.statements);
	        statementsOut.push(factory2.updateTryStatement(
	          superStatement,
	          factory2.updateBlock(superStatement.tryBlock, tryBlockStatements),
	          visitNode(superStatement.catchClause, visitor, isCatchClause),
	          visitNode(superStatement.finallyBlock, visitor, isBlock)
	        ));
	      } else {
	        addRange(statementsOut, visitNodes2(statementsIn, visitor, isStatement, superStatementIndex, 1));
	        while (statementOffset < statementsIn.length) {
	          const statement = statementsIn[statementOffset];
	          if (isParameterPropertyDeclaration(getOriginalNode(statement), constructor)) {
	            statementOffset++;
	          } else {
	            break;
	          }
	        }
	        addRange(statementsOut, initializerStatements);
	      }
	      addRange(statementsOut, visitNodes2(statementsIn, visitor, isStatement, statementOffset));
	    }
	    function transformConstructorBody(node, constructor, isDerivedClass) {
	      const instanceProperties = getProperties(
	        node,
	        /*requireInitializer*/
	        false,
	        /*isStatic*/
	        false
	      );
	      let properties = instanceProperties;
	      if (!useDefineForClassFields) {
	        properties = filter(properties, (property) => !!property.initializer || isPrivateIdentifier(property.name) || hasAccessorModifier(property));
	      }
	      const privateMethodsAndAccessors = getPrivateInstanceMethodsAndAccessors(node);
	      const needsConstructorBody = some(properties) || some(privateMethodsAndAccessors);
	      if (!constructor && !needsConstructorBody) {
	        return visitFunctionBody(
	          /*node*/
	          void 0,
	          visitor,
	          context
	        );
	      }
	      resumeLexicalEnvironment();
	      const needsSyntheticConstructor = !constructor && isDerivedClass;
	      let statementOffset = 0;
	      let statements = [];
	      const initializerStatements = [];
	      const receiver = factory2.createThis();
	      addInstanceMethodStatements(initializerStatements, privateMethodsAndAccessors, receiver);
	      if (constructor) {
	        const parameterProperties = filter(instanceProperties, (prop) => isParameterPropertyDeclaration(getOriginalNode(prop), constructor));
	        const nonParameterProperties = filter(properties, (prop) => !isParameterPropertyDeclaration(getOriginalNode(prop), constructor));
	        addPropertyOrClassStaticBlockStatements(initializerStatements, parameterProperties, receiver);
	        addPropertyOrClassStaticBlockStatements(initializerStatements, nonParameterProperties, receiver);
	      } else {
	        addPropertyOrClassStaticBlockStatements(initializerStatements, properties, receiver);
	      }
	      if (constructor == null ? void 0 : constructor.body) {
	        statementOffset = factory2.copyPrologue(
	          constructor.body.statements,
	          statements,
	          /*ensureUseStrict*/
	          false,
	          visitor
	        );
	        const superStatementIndices = findSuperStatementIndexPath(constructor.body.statements, statementOffset);
	        if (superStatementIndices.length) {
	          transformConstructorBodyWorker(
	            statements,
	            constructor.body.statements,
	            statementOffset,
	            superStatementIndices,
	            /*superPathDepth*/
	            0,
	            initializerStatements,
	            constructor
	          );
	        } else {
	          while (statementOffset < constructor.body.statements.length) {
	            const statement = constructor.body.statements[statementOffset];
	            if (isParameterPropertyDeclaration(getOriginalNode(statement), constructor)) {
	              statementOffset++;
	            } else {
	              break;
	            }
	          }
	          addRange(statements, initializerStatements);
	          addRange(statements, visitNodes2(constructor.body.statements, visitor, isStatement, statementOffset));
	        }
	      } else {
	        if (needsSyntheticConstructor) {
	          statements.push(
	            factory2.createExpressionStatement(
	              factory2.createCallExpression(
	                factory2.createSuper(),
	                /*typeArguments*/
	                void 0,
	                [factory2.createSpreadElement(factory2.createIdentifier("arguments"))]
	              )
	            )
	          );
	        }
	        addRange(statements, initializerStatements);
	      }
	      statements = factory2.mergeLexicalEnvironment(statements, endLexicalEnvironment());
	      if (statements.length === 0 && !constructor) {
	        return void 0;
	      }
	      const multiLine = (constructor == null ? void 0 : constructor.body) && constructor.body.statements.length >= statements.length ? constructor.body.multiLine ?? statements.length > 0 : statements.length > 0;
	      return setTextRange(
	        factory2.createBlock(
	          setTextRange(
	            factory2.createNodeArray(statements),
	            /*location*/
	            constructor ? constructor.body.statements : node.members
	          ),
	          multiLine
	        ),
	        /*location*/
	        constructor ? constructor.body : void 0
	      );
	    }
	    function addPropertyOrClassStaticBlockStatements(statements, properties, receiver) {
	      for (const property of properties) {
	        if (isStatic(property) && !shouldTransformPrivateElementsOrClassStaticBlocks) {
	          continue;
	        }
	        const statement = transformPropertyOrClassStaticBlock(property, receiver);
	        if (!statement) {
	          continue;
	        }
	        statements.push(statement);
	      }
	    }
	    function transformPropertyOrClassStaticBlock(property, receiver) {
	      const expression = isClassStaticBlockDeclaration(property) ? setCurrentClassElementAnd(property, transformClassStaticBlockDeclaration, property) : transformProperty(property, receiver);
	      if (!expression) {
	        return void 0;
	      }
	      const statement = factory2.createExpressionStatement(expression);
	      setOriginalNode(statement, property);
	      addEmitFlags(statement, getEmitFlags(property) & 3072 /* NoComments */);
	      setCommentRange(statement, property);
	      const propertyOriginalNode = getOriginalNode(property);
	      if (isParameter(propertyOriginalNode)) {
	        setSourceMapRange(statement, propertyOriginalNode);
	        removeAllComments(statement);
	      } else {
	        setSourceMapRange(statement, moveRangePastModifiers(property));
	      }
	      setSyntheticLeadingComments(expression, void 0);
	      setSyntheticTrailingComments(expression, void 0);
	      if (hasAccessorModifier(propertyOriginalNode)) {
	        addEmitFlags(statement, 3072 /* NoComments */);
	      }
	      return statement;
	    }
	    function generateInitializedPropertyExpressionsOrClassStaticBlock(propertiesOrClassStaticBlocks, receiver) {
	      const expressions = [];
	      for (const property of propertiesOrClassStaticBlocks) {
	        const expression = isClassStaticBlockDeclaration(property) ? setCurrentClassElementAnd(property, transformClassStaticBlockDeclaration, property) : setCurrentClassElementAnd(
	          property,
	          () => transformProperty(property, receiver),
	          /*arg*/
	          void 0
	        );
	        if (!expression) {
	          continue;
	        }
	        startOnNewLine(expression);
	        setOriginalNode(expression, property);
	        addEmitFlags(expression, getEmitFlags(property) & 3072 /* NoComments */);
	        setSourceMapRange(expression, moveRangePastModifiers(property));
	        setCommentRange(expression, property);
	        expressions.push(expression);
	      }
	      return expressions;
	    }
	    function transformProperty(property, receiver) {
	      var _a;
	      const savedCurrentClassElement = currentClassElement;
	      const transformed = transformPropertyWorker(property, receiver);
	      if (transformed && hasStaticModifier(property) && ((_a = lexicalEnvironment == null ? void 0 : lexicalEnvironment.data) == null ? void 0 : _a.facts)) {
	        setOriginalNode(transformed, property);
	        addEmitFlags(transformed, 4 /* AdviseOnEmitNode */);
	        setSourceMapRange(transformed, getSourceMapRange(property.name));
	        lexicalEnvironmentMap.set(getOriginalNode(property), lexicalEnvironment);
	      }
	      currentClassElement = savedCurrentClassElement;
	      return transformed;
	    }
	    function transformPropertyWorker(property, receiver) {
	      const emitAssignment = !useDefineForClassFields;
	      if (isNamedEvaluation(property, isAnonymousClassNeedingAssignedName)) {
	        property = transformNamedEvaluation(context, property);
	      }
	      const propertyName = hasAccessorModifier(property) ? factory2.getGeneratedPrivateNameForNode(property.name) : isComputedPropertyName(property.name) && !isSimpleInlineableExpression(property.name.expression) ? factory2.updateComputedPropertyName(property.name, factory2.getGeneratedNameForNode(property.name)) : property.name;
	      if (hasStaticModifier(property)) {
	        currentClassElement = property;
	      }
	      if (isPrivateIdentifier(propertyName) && shouldTransformClassElementToWeakMap(property)) {
	        const privateIdentifierInfo = accessPrivateIdentifier2(propertyName);
	        if (privateIdentifierInfo) {
	          if (privateIdentifierInfo.kind === "f" /* Field */) {
	            if (!privateIdentifierInfo.isStatic) {
	              return createPrivateInstanceFieldInitializer(
	                factory2,
	                receiver,
	                visitNode(property.initializer, visitor, isExpression),
	                privateIdentifierInfo.brandCheckIdentifier
	              );
	            } else {
	              return createPrivateStaticFieldInitializer(
	                factory2,
	                privateIdentifierInfo.variableName,
	                visitNode(property.initializer, visitor, isExpression)
	              );
	            }
	          } else {
	            return void 0;
	          }
	        } else {
	          Debug.fail("Undeclared private name for property declaration.");
	        }
	      }
	      if ((isPrivateIdentifier(propertyName) || hasStaticModifier(property)) && !property.initializer) {
	        return void 0;
	      }
	      const propertyOriginalNode = getOriginalNode(property);
	      if (hasSyntacticModifier(propertyOriginalNode, 64 /* Abstract */)) {
	        return void 0;
	      }
	      let initializer = visitNode(property.initializer, visitor, isExpression);
	      if (isParameterPropertyDeclaration(propertyOriginalNode, propertyOriginalNode.parent) && isIdentifier(propertyName)) {
	        const localName = factory2.cloneNode(propertyName);
	        if (initializer) {
	          if (isParenthesizedExpression(initializer) && isCommaExpression(initializer.expression) && isCallToHelper(initializer.expression.left, "___runInitializers") && isVoidExpression(initializer.expression.right) && isNumericLiteral(initializer.expression.right.expression)) {
	            initializer = initializer.expression.left;
	          }
	          initializer = factory2.inlineExpressions([initializer, localName]);
	        } else {
	          initializer = localName;
	        }
	        setEmitFlags(propertyName, 3072 /* NoComments */ | 96 /* NoSourceMap */);
	        setSourceMapRange(localName, propertyOriginalNode.name);
	        setEmitFlags(localName, 3072 /* NoComments */);
	      } else {
	        initializer ?? (initializer = factory2.createVoidZero());
	      }
	      if (emitAssignment || isPrivateIdentifier(propertyName)) {
	        const memberAccess = createMemberAccessForPropertyName(
	          factory2,
	          receiver,
	          propertyName,
	          /*location*/
	          propertyName
	        );
	        addEmitFlags(memberAccess, 1024 /* NoLeadingComments */);
	        const expression = factory2.createAssignment(memberAccess, initializer);
	        return expression;
	      } else {
	        const name = isComputedPropertyName(propertyName) ? propertyName.expression : isIdentifier(propertyName) ? factory2.createStringLiteral(unescapeLeadingUnderscores(propertyName.escapedText)) : propertyName;
	        const descriptor = factory2.createPropertyDescriptor({ value: initializer, configurable: true, writable: true, enumerable: true });
	        return factory2.createObjectDefinePropertyCall(receiver, name, descriptor);
	      }
	    }
	    function enableSubstitutionForClassAliases() {
	      if ((enabledSubstitutions & 1 /* ClassAliases */) === 0) {
	        enabledSubstitutions |= 1 /* ClassAliases */;
	        context.enableSubstitution(80 /* Identifier */);
	        classAliases = [];
	      }
	    }
	    function enableSubstitutionForClassStaticThisOrSuperReference() {
	      if ((enabledSubstitutions & 2 /* ClassStaticThisOrSuperReference */) === 0) {
	        enabledSubstitutions |= 2 /* ClassStaticThisOrSuperReference */;
	        context.enableSubstitution(110 /* ThisKeyword */);
	        context.enableEmitNotification(262 /* FunctionDeclaration */);
	        context.enableEmitNotification(218 /* FunctionExpression */);
	        context.enableEmitNotification(176 /* Constructor */);
	        context.enableEmitNotification(177 /* GetAccessor */);
	        context.enableEmitNotification(178 /* SetAccessor */);
	        context.enableEmitNotification(174 /* MethodDeclaration */);
	        context.enableEmitNotification(172 /* PropertyDeclaration */);
	        context.enableEmitNotification(167 /* ComputedPropertyName */);
	      }
	    }
	    function addInstanceMethodStatements(statements, methods, receiver) {
	      if (!shouldTransformPrivateElementsOrClassStaticBlocks || !some(methods)) {
	        return;
	      }
	      const { weakSetName } = getPrivateIdentifierEnvironment().data;
	      Debug.assert(weakSetName, "weakSetName should be set in private identifier environment");
	      statements.push(
	        factory2.createExpressionStatement(
	          createPrivateInstanceMethodInitializer(factory2, receiver, weakSetName)
	        )
	      );
	    }
	    function visitInvalidSuperProperty(node) {
	      return isPropertyAccessExpression(node) ? factory2.updatePropertyAccessExpression(
	        node,
	        factory2.createVoidZero(),
	        node.name
	      ) : factory2.updateElementAccessExpression(
	        node,
	        factory2.createVoidZero(),
	        visitNode(node.argumentExpression, visitor, isExpression)
	      );
	    }
	    function getPropertyNameExpressionIfNeeded(name, shouldHoist) {
	      if (isComputedPropertyName(name)) {
	        const cacheAssignment = findComputedPropertyNameCacheAssignment(name);
	        const expression = visitNode(name.expression, visitor, isExpression);
	        const innerExpression = skipPartiallyEmittedExpressions(expression);
	        const inlinable = isSimpleInlineableExpression(innerExpression);
	        const alreadyTransformed = !!cacheAssignment || isAssignmentExpression(innerExpression) && isGeneratedIdentifier(innerExpression.left);
	        if (!alreadyTransformed && !inlinable && shouldHoist) {
	          const generatedName = factory2.getGeneratedNameForNode(name);
	          if (resolver.getNodeCheckFlags(name) & 32768 /* BlockScopedBindingInLoop */) {
	            addBlockScopedVariable(generatedName);
	          } else {
	            hoistVariableDeclaration(generatedName);
	          }
	          return factory2.createAssignment(generatedName, expression);
	        }
	        return inlinable || isIdentifier(innerExpression) ? void 0 : expression;
	      }
	    }
	    function startClassLexicalEnvironment() {
	      lexicalEnvironment = { previous: lexicalEnvironment, data: void 0 };
	    }
	    function endClassLexicalEnvironment() {
	      lexicalEnvironment = lexicalEnvironment == null ? void 0 : lexicalEnvironment.previous;
	    }
	    function getClassLexicalEnvironment() {
	      Debug.assert(lexicalEnvironment);
	      return lexicalEnvironment.data ?? (lexicalEnvironment.data = {
	        facts: 0 /* None */,
	        classConstructor: void 0,
	        classThis: void 0,
	        superClassReference: void 0
	        // privateIdentifierEnvironment: undefined,
	      });
	    }
	    function getPrivateIdentifierEnvironment() {
	      Debug.assert(lexicalEnvironment);
	      return lexicalEnvironment.privateEnv ?? (lexicalEnvironment.privateEnv = newPrivateEnvironment({
	        className: void 0,
	        weakSetName: void 0
	      }));
	    }
	    function getPendingExpressions() {
	      return pendingExpressions ?? (pendingExpressions = []);
	    }
	    function addPrivateIdentifierClassElementToEnvironment(node, name, lex, privateEnv, isStatic2, isValid, previousInfo) {
	      if (isAutoAccessorPropertyDeclaration(node)) {
	        addPrivateIdentifierAutoAccessorPropertyDeclarationToEnvironment(node, name, lex, privateEnv, isStatic2, isValid);
	      } else if (isPropertyDeclaration(node)) {
	        addPrivateIdentifierPropertyDeclarationToEnvironment(node, name, lex, privateEnv, isStatic2, isValid);
	      } else if (isMethodDeclaration(node)) {
	        addPrivateIdentifierMethodDeclarationToEnvironment(node, name, lex, privateEnv, isStatic2, isValid);
	      } else if (isGetAccessorDeclaration(node)) {
	        addPrivateIdentifierGetAccessorDeclarationToEnvironment(node, name, lex, privateEnv, isStatic2, isValid, previousInfo);
	      } else if (isSetAccessorDeclaration(node)) {
	        addPrivateIdentifierSetAccessorDeclarationToEnvironment(node, name, lex, privateEnv, isStatic2, isValid, previousInfo);
	      }
	    }
	    function addPrivateIdentifierPropertyDeclarationToEnvironment(_node, name, lex, privateEnv, isStatic2, isValid, _previousInfo) {
	      if (isStatic2) {
	        const brandCheckIdentifier = Debug.checkDefined(lex.classThis ?? lex.classConstructor, "classConstructor should be set in private identifier environment");
	        const variableName = createHoistedVariableForPrivateName(name);
	        setPrivateIdentifier(privateEnv, name, {
	          kind: "f" /* Field */,
	          isStatic: true,
	          brandCheckIdentifier,
	          variableName,
	          isValid
	        });
	      } else {
	        const weakMapName = createHoistedVariableForPrivateName(name);
	        setPrivateIdentifier(privateEnv, name, {
	          kind: "f" /* Field */,
	          isStatic: false,
	          brandCheckIdentifier: weakMapName,
	          isValid
	        });
	        getPendingExpressions().push(factory2.createAssignment(
	          weakMapName,
	          factory2.createNewExpression(
	            factory2.createIdentifier("WeakMap"),
	            /*typeArguments*/
	            void 0,
	            []
	          )
	        ));
	      }
	    }
	    function addPrivateIdentifierMethodDeclarationToEnvironment(_node, name, lex, privateEnv, isStatic2, isValid, _previousInfo) {
	      const methodName = createHoistedVariableForPrivateName(name);
	      const brandCheckIdentifier = isStatic2 ? Debug.checkDefined(lex.classThis ?? lex.classConstructor, "classConstructor should be set in private identifier environment") : Debug.checkDefined(privateEnv.data.weakSetName, "weakSetName should be set in private identifier environment");
	      setPrivateIdentifier(privateEnv, name, {
	        kind: "m" /* Method */,
	        methodName,
	        brandCheckIdentifier,
	        isStatic: isStatic2,
	        isValid
	      });
	    }
	    function addPrivateIdentifierGetAccessorDeclarationToEnvironment(_node, name, lex, privateEnv, isStatic2, isValid, previousInfo) {
	      const getterName = createHoistedVariableForPrivateName(name, "_get");
	      const brandCheckIdentifier = isStatic2 ? Debug.checkDefined(lex.classThis ?? lex.classConstructor, "classConstructor should be set in private identifier environment") : Debug.checkDefined(privateEnv.data.weakSetName, "weakSetName should be set in private identifier environment");
	      if ((previousInfo == null ? void 0 : previousInfo.kind) === "a" /* Accessor */ && previousInfo.isStatic === isStatic2 && !previousInfo.getterName) {
	        previousInfo.getterName = getterName;
	      } else {
	        setPrivateIdentifier(privateEnv, name, {
	          kind: "a" /* Accessor */,
	          getterName,
	          setterName: void 0,
	          brandCheckIdentifier,
	          isStatic: isStatic2,
	          isValid
	        });
	      }
	    }
	    function addPrivateIdentifierSetAccessorDeclarationToEnvironment(_node, name, lex, privateEnv, isStatic2, isValid, previousInfo) {
	      const setterName = createHoistedVariableForPrivateName(name, "_set");
	      const brandCheckIdentifier = isStatic2 ? Debug.checkDefined(lex.classThis ?? lex.classConstructor, "classConstructor should be set in private identifier environment") : Debug.checkDefined(privateEnv.data.weakSetName, "weakSetName should be set in private identifier environment");
	      if ((previousInfo == null ? void 0 : previousInfo.kind) === "a" /* Accessor */ && previousInfo.isStatic === isStatic2 && !previousInfo.setterName) {
	        previousInfo.setterName = setterName;
	      } else {
	        setPrivateIdentifier(privateEnv, name, {
	          kind: "a" /* Accessor */,
	          getterName: void 0,
	          setterName,
	          brandCheckIdentifier,
	          isStatic: isStatic2,
	          isValid
	        });
	      }
	    }
	    function addPrivateIdentifierAutoAccessorPropertyDeclarationToEnvironment(_node, name, lex, privateEnv, isStatic2, isValid, _previousInfo) {
	      const getterName = createHoistedVariableForPrivateName(name, "_get");
	      const setterName = createHoistedVariableForPrivateName(name, "_set");
	      const brandCheckIdentifier = isStatic2 ? Debug.checkDefined(lex.classThis ?? lex.classConstructor, "classConstructor should be set in private identifier environment") : Debug.checkDefined(privateEnv.data.weakSetName, "weakSetName should be set in private identifier environment");
	      setPrivateIdentifier(privateEnv, name, {
	        kind: "a" /* Accessor */,
	        getterName,
	        setterName,
	        brandCheckIdentifier,
	        isStatic: isStatic2,
	        isValid
	      });
	    }
	    function addPrivateIdentifierToEnvironment(node, name, addDeclaration) {
	      const lex = getClassLexicalEnvironment();
	      const privateEnv = getPrivateIdentifierEnvironment();
	      const previousInfo = getPrivateIdentifier(privateEnv, name);
	      const isStatic2 = hasStaticModifier(node);
	      const isValid = !isReservedPrivateName(name) && previousInfo === void 0;
	      addDeclaration(node, name, lex, privateEnv, isStatic2, isValid, previousInfo);
	    }
	    function createHoistedVariableForClass(name, node, suffix) {
	      const { className } = getPrivateIdentifierEnvironment().data;
	      const prefix = className ? { prefix: "_", node: className, suffix: "_" } : "_";
	      const identifier = typeof name === "object" ? factory2.getGeneratedNameForNode(name, 16 /* Optimistic */ | 8 /* ReservedInNestedScopes */, prefix, suffix) : typeof name === "string" ? factory2.createUniqueName(name, 16 /* Optimistic */, prefix, suffix) : factory2.createTempVariable(
	        /*recordTempVariable*/
	        void 0,
	        /*reservedInNestedScopes*/
	        true,
	        prefix,
	        suffix
	      );
	      if (resolver.getNodeCheckFlags(node) & 32768 /* BlockScopedBindingInLoop */) {
	        addBlockScopedVariable(identifier);
	      } else {
	        hoistVariableDeclaration(identifier);
	      }
	      return identifier;
	    }
	    function createHoistedVariableForPrivateName(name, suffix) {
	      const text = tryGetTextOfPropertyName(name);
	      return createHoistedVariableForClass((text == null ? void 0 : text.substring(1)) ?? name, name, suffix);
	    }
	    function accessPrivateIdentifier2(name) {
	      const info = accessPrivateIdentifier(lexicalEnvironment, name);
	      return (info == null ? void 0 : info.kind) === "untransformed" ? void 0 : info;
	    }
	    function wrapPrivateIdentifierForDestructuringTarget(node) {
	      const parameter = factory2.getGeneratedNameForNode(node);
	      const info = accessPrivateIdentifier2(node.name);
	      if (!info) {
	        return visitEachChild(node, visitor, context);
	      }
	      let receiver = node.expression;
	      if (isThisProperty(node) || isSuperProperty(node) || !isSimpleCopiableExpression(node.expression)) {
	        receiver = factory2.createTempVariable(
	          hoistVariableDeclaration,
	          /*reservedInNestedScopes*/
	          true
	        );
	        getPendingExpressions().push(factory2.createBinaryExpression(receiver, 64 /* EqualsToken */, visitNode(node.expression, visitor, isExpression)));
	      }
	      return factory2.createAssignmentTargetWrapper(
	        parameter,
	        createPrivateIdentifierAssignment(
	          info,
	          receiver,
	          parameter,
	          64 /* EqualsToken */
	        )
	      );
	    }
	    function visitDestructuringAssignmentTarget(node) {
	      if (isObjectLiteralExpression(node) || isArrayLiteralExpression(node)) {
	        return visitAssignmentPattern(node);
	      }
	      if (isPrivateIdentifierPropertyAccessExpression(node)) {
	        return wrapPrivateIdentifierForDestructuringTarget(node);
	      } else if (shouldTransformSuperInStaticInitializers && currentClassElement && isSuperProperty(node) && isStaticPropertyDeclarationOrClassStaticBlock(currentClassElement) && (lexicalEnvironment == null ? void 0 : lexicalEnvironment.data)) {
	        const { classConstructor, superClassReference, facts } = lexicalEnvironment.data;
	        if (facts & 1 /* ClassWasDecorated */) {
	          return visitInvalidSuperProperty(node);
	        } else if (classConstructor && superClassReference) {
	          const name = isElementAccessExpression(node) ? visitNode(node.argumentExpression, visitor, isExpression) : isIdentifier(node.name) ? factory2.createStringLiteralFromNode(node.name) : void 0;
	          if (name) {
	            const temp = factory2.createTempVariable(
	              /*recordTempVariable*/
	              void 0
	            );
	            return factory2.createAssignmentTargetWrapper(
	              temp,
	              factory2.createReflectSetCall(
	                superClassReference,
	                name,
	                temp,
	                classConstructor
	              )
	            );
	          }
	        }
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitAssignmentElement(node) {
	      if (isNamedEvaluation(node, isAnonymousClassNeedingAssignedName)) {
	        node = transformNamedEvaluation(context, node);
	      }
	      if (isAssignmentExpression(
	        node,
	        /*excludeCompoundAssignment*/
	        true
	      )) {
	        const left = visitDestructuringAssignmentTarget(node.left);
	        const right = visitNode(node.right, visitor, isExpression);
	        return factory2.updateBinaryExpression(node, left, node.operatorToken, right);
	      }
	      return visitDestructuringAssignmentTarget(node);
	    }
	    function visitAssignmentRestElement(node) {
	      if (isLeftHandSideExpression(node.expression)) {
	        const expression = visitDestructuringAssignmentTarget(node.expression);
	        return factory2.updateSpreadElement(node, expression);
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitArrayAssignmentElement(node) {
	      if (isArrayBindingOrAssignmentElement(node)) {
	        if (isSpreadElement(node))
	          return visitAssignmentRestElement(node);
	        if (!isOmittedExpression(node))
	          return visitAssignmentElement(node);
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitAssignmentProperty(node) {
	      const name = visitNode(node.name, visitor, isPropertyName);
	      if (isAssignmentExpression(
	        node.initializer,
	        /*excludeCompoundAssignment*/
	        true
	      )) {
	        const assignmentElement = visitAssignmentElement(node.initializer);
	        return factory2.updatePropertyAssignment(node, name, assignmentElement);
	      }
	      if (isLeftHandSideExpression(node.initializer)) {
	        const assignmentElement = visitDestructuringAssignmentTarget(node.initializer);
	        return factory2.updatePropertyAssignment(node, name, assignmentElement);
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitShorthandAssignmentProperty(node) {
	      if (isNamedEvaluation(node, isAnonymousClassNeedingAssignedName)) {
	        node = transformNamedEvaluation(context, node);
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitAssignmentRestProperty(node) {
	      if (isLeftHandSideExpression(node.expression)) {
	        const expression = visitDestructuringAssignmentTarget(node.expression);
	        return factory2.updateSpreadAssignment(node, expression);
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitObjectAssignmentElement(node) {
	      Debug.assertNode(node, isObjectBindingOrAssignmentElement);
	      if (isSpreadAssignment(node))
	        return visitAssignmentRestProperty(node);
	      if (isShorthandPropertyAssignment(node))
	        return visitShorthandAssignmentProperty(node);
	      if (isPropertyAssignment(node))
	        return visitAssignmentProperty(node);
	      return visitEachChild(node, visitor, context);
	    }
	    function visitAssignmentPattern(node) {
	      if (isArrayLiteralExpression(node)) {
	        return factory2.updateArrayLiteralExpression(
	          node,
	          visitNodes2(node.elements, visitArrayAssignmentElement, isExpression)
	        );
	      } else {
	        return factory2.updateObjectLiteralExpression(
	          node,
	          visitNodes2(node.properties, visitObjectAssignmentElement, isObjectLiteralElementLike)
	        );
	      }
	    }
	    function onEmitNode(hint, node, emitCallback) {
	      const original = getOriginalNode(node);
	      const lex = lexicalEnvironmentMap.get(original);
	      if (lex) {
	        const savedLexicalEnvironment = lexicalEnvironment;
	        const savedPreviousShouldSubstituteThisWithClassThis = previousShouldSubstituteThisWithClassThis;
	        lexicalEnvironment = lex;
	        previousShouldSubstituteThisWithClassThis = shouldSubstituteThisWithClassThis;
	        shouldSubstituteThisWithClassThis = !isClassStaticBlockDeclaration(original) || !(getInternalEmitFlags(original) & 32 /* TransformPrivateStaticElements */);
	        previousOnEmitNode(hint, node, emitCallback);
	        shouldSubstituteThisWithClassThis = previousShouldSubstituteThisWithClassThis;
	        previousShouldSubstituteThisWithClassThis = savedPreviousShouldSubstituteThisWithClassThis;
	        lexicalEnvironment = savedLexicalEnvironment;
	        return;
	      }
	      switch (node.kind) {
	        case 218 /* FunctionExpression */:
	          if (isArrowFunction(original) || getEmitFlags(node) & 524288 /* AsyncFunctionBody */) {
	            break;
	          }
	        case 262 /* FunctionDeclaration */:
	        case 176 /* Constructor */:
	        case 177 /* GetAccessor */:
	        case 178 /* SetAccessor */:
	        case 174 /* MethodDeclaration */:
	        case 172 /* PropertyDeclaration */: {
	          const savedLexicalEnvironment = lexicalEnvironment;
	          const savedPreviousShouldSubstituteThisWithClassThis = previousShouldSubstituteThisWithClassThis;
	          lexicalEnvironment = void 0;
	          previousShouldSubstituteThisWithClassThis = shouldSubstituteThisWithClassThis;
	          shouldSubstituteThisWithClassThis = false;
	          previousOnEmitNode(hint, node, emitCallback);
	          shouldSubstituteThisWithClassThis = previousShouldSubstituteThisWithClassThis;
	          previousShouldSubstituteThisWithClassThis = savedPreviousShouldSubstituteThisWithClassThis;
	          lexicalEnvironment = savedLexicalEnvironment;
	          return;
	        }
	        case 167 /* ComputedPropertyName */: {
	          const savedLexicalEnvironment = lexicalEnvironment;
	          const savedShouldSubstituteThisWithClassThis = shouldSubstituteThisWithClassThis;
	          lexicalEnvironment = lexicalEnvironment == null ? void 0 : lexicalEnvironment.previous;
	          shouldSubstituteThisWithClassThis = previousShouldSubstituteThisWithClassThis;
	          previousOnEmitNode(hint, node, emitCallback);
	          shouldSubstituteThisWithClassThis = savedShouldSubstituteThisWithClassThis;
	          lexicalEnvironment = savedLexicalEnvironment;
	          return;
	        }
	      }
	      previousOnEmitNode(hint, node, emitCallback);
	    }
	    function onSubstituteNode(hint, node) {
	      node = previousOnSubstituteNode(hint, node);
	      if (hint === 1 /* Expression */) {
	        return substituteExpression(node);
	      }
	      return node;
	    }
	    function substituteExpression(node) {
	      switch (node.kind) {
	        case 80 /* Identifier */:
	          return substituteExpressionIdentifier(node);
	        case 110 /* ThisKeyword */:
	          return substituteThisExpression(node);
	      }
	      return node;
	    }
	    function substituteThisExpression(node) {
	      if (enabledSubstitutions & 2 /* ClassStaticThisOrSuperReference */ && (lexicalEnvironment == null ? void 0 : lexicalEnvironment.data) && !noSubstitution.has(node)) {
	        const { facts, classConstructor, classThis } = lexicalEnvironment.data;
	        const substituteThis = shouldSubstituteThisWithClassThis ? classThis ?? classConstructor : classConstructor;
	        if (substituteThis) {
	          return setTextRange(
	            setOriginalNode(
	              factory2.cloneNode(substituteThis),
	              node
	            ),
	            node
	          );
	        }
	        if (facts & 1 /* ClassWasDecorated */ && legacyDecorators) {
	          return factory2.createParenthesizedExpression(factory2.createVoidZero());
	        }
	      }
	      return node;
	    }
	    function substituteExpressionIdentifier(node) {
	      return trySubstituteClassAlias(node) || node;
	    }
	    function trySubstituteClassAlias(node) {
	      if (enabledSubstitutions & 1 /* ClassAliases */) {
	        if (resolver.getNodeCheckFlags(node) & 536870912 /* ConstructorReference */) {
	          const declaration = resolver.getReferencedValueDeclaration(node);
	          if (declaration) {
	            const classAlias = classAliases[declaration.id];
	            if (classAlias) {
	              const clone2 = factory2.cloneNode(classAlias);
	              setSourceMapRange(clone2, node);
	              setCommentRange(clone2, node);
	              return clone2;
	            }
	          }
	        }
	      }
	      return void 0;
	    }
	  }
	  function createPrivateStaticFieldInitializer(factory2, variableName, initializer) {
	    return factory2.createAssignment(
	      variableName,
	      factory2.createObjectLiteralExpression([
	        factory2.createPropertyAssignment("value", initializer || factory2.createVoidZero())
	      ])
	    );
	  }
	  function createPrivateInstanceFieldInitializer(factory2, receiver, initializer, weakMapName) {
	    return factory2.createCallExpression(
	      factory2.createPropertyAccessExpression(weakMapName, "set"),
	      /*typeArguments*/
	      void 0,
	      [receiver, initializer || factory2.createVoidZero()]
	    );
	  }
	  function createPrivateInstanceMethodInitializer(factory2, receiver, weakSetName) {
	    return factory2.createCallExpression(
	      factory2.createPropertyAccessExpression(weakSetName, "add"),
	      /*typeArguments*/
	      void 0,
	      [receiver]
	    );
	  }
	  function isReservedPrivateName(node) {
	    return !isGeneratedPrivateIdentifier(node) && node.escapedText === "#constructor";
	  }
	  function isPrivateIdentifierInExpression(node) {
	    return isPrivateIdentifier(node.left) && node.operatorToken.kind === 103 /* InKeyword */;
	  }
	  function isStaticPropertyDeclaration2(node) {
	    return isPropertyDeclaration(node) && hasStaticModifier(node);
	  }
	  function isStaticPropertyDeclarationOrClassStaticBlock(node) {
	    return isClassStaticBlockDeclaration(node) || isStaticPropertyDeclaration2(node);
	  }
	  var init_classFields = __esm({
	    "src/compiler/transformers/classFields.ts"() {
	      init_ts2();
	    }
	  });

	  // src/compiler/transformers/typeSerializer.ts
	  function createRuntimeTypeSerializer(context) {
	    const {
	      factory: factory2,
	      hoistVariableDeclaration
	    } = context;
	    const resolver = context.getEmitResolver();
	    const compilerOptions = context.getCompilerOptions();
	    const languageVersion = getEmitScriptTarget(compilerOptions);
	    const strictNullChecks = getStrictOptionValue(compilerOptions, "strictNullChecks");
	    let currentLexicalScope;
	    let currentNameScope;
	    return {
	      serializeTypeNode: (serializerContext, node) => setSerializerContextAnd(serializerContext, serializeTypeNode, node),
	      serializeTypeOfNode: (serializerContext, node) => setSerializerContextAnd(serializerContext, serializeTypeOfNode, node),
	      serializeParameterTypesOfNode: (serializerContext, node, container) => setSerializerContextAnd(serializerContext, serializeParameterTypesOfNode, node, container),
	      serializeReturnTypeOfNode: (serializerContext, node) => setSerializerContextAnd(serializerContext, serializeReturnTypeOfNode, node)
	    };
	    function setSerializerContextAnd(serializerContext, cb, node, arg) {
	      const savedCurrentLexicalScope = currentLexicalScope;
	      const savedCurrentNameScope = currentNameScope;
	      currentLexicalScope = serializerContext.currentLexicalScope;
	      currentNameScope = serializerContext.currentNameScope;
	      const result = arg === void 0 ? cb(node) : cb(node, arg);
	      currentLexicalScope = savedCurrentLexicalScope;
	      currentNameScope = savedCurrentNameScope;
	      return result;
	    }
	    function getAccessorTypeNode(node) {
	      const accessors = resolver.getAllAccessorDeclarations(node);
	      return accessors.setAccessor && getSetAccessorTypeAnnotationNode(accessors.setAccessor) || accessors.getAccessor && getEffectiveReturnTypeNode(accessors.getAccessor);
	    }
	    function serializeTypeOfNode(node) {
	      switch (node.kind) {
	        case 172 /* PropertyDeclaration */:
	        case 169 /* Parameter */:
	          return serializeTypeNode(node.type);
	        case 178 /* SetAccessor */:
	        case 177 /* GetAccessor */:
	          return serializeTypeNode(getAccessorTypeNode(node));
	        case 263 /* ClassDeclaration */:
	        case 231 /* ClassExpression */:
	        case 174 /* MethodDeclaration */:
	          return factory2.createIdentifier("Function");
	        default:
	          return factory2.createVoidZero();
	      }
	    }
	    function serializeParameterTypesOfNode(node, container) {
	      const valueDeclaration = isClassLike(node) ? getFirstConstructorWithBody(node) : isFunctionLike(node) && nodeIsPresent(node.body) ? node : void 0;
	      const expressions = [];
	      if (valueDeclaration) {
	        const parameters = getParametersOfDecoratedDeclaration(valueDeclaration, container);
	        const numParameters = parameters.length;
	        for (let i = 0; i < numParameters; i++) {
	          const parameter = parameters[i];
	          if (i === 0 && isIdentifier(parameter.name) && parameter.name.escapedText === "this") {
	            continue;
	          }
	          if (parameter.dotDotDotToken) {
	            expressions.push(serializeTypeNode(getRestParameterElementType(parameter.type)));
	          } else {
	            expressions.push(serializeTypeOfNode(parameter));
	          }
	        }
	      }
	      return factory2.createArrayLiteralExpression(expressions);
	    }
	    function getParametersOfDecoratedDeclaration(node, container) {
	      if (container && node.kind === 177 /* GetAccessor */) {
	        const { setAccessor } = getAllAccessorDeclarations(container.members, node);
	        if (setAccessor) {
	          return setAccessor.parameters;
	        }
	      }
	      return node.parameters;
	    }
	    function serializeReturnTypeOfNode(node) {
	      if (isFunctionLike(node) && node.type) {
	        return serializeTypeNode(node.type);
	      } else if (isAsyncFunction(node)) {
	        return factory2.createIdentifier("Promise");
	      }
	      return factory2.createVoidZero();
	    }
	    function serializeTypeNode(node) {
	      if (node === void 0) {
	        return factory2.createIdentifier("Object");
	      }
	      node = skipTypeParentheses(node);
	      switch (node.kind) {
	        case 116 /* VoidKeyword */:
	        case 157 /* UndefinedKeyword */:
	        case 146 /* NeverKeyword */:
	          return factory2.createVoidZero();
	        case 184 /* FunctionType */:
	        case 185 /* ConstructorType */:
	          return factory2.createIdentifier("Function");
	        case 188 /* ArrayType */:
	        case 189 /* TupleType */:
	          return factory2.createIdentifier("Array");
	        case 182 /* TypePredicate */:
	          return node.assertsModifier ? factory2.createVoidZero() : factory2.createIdentifier("Boolean");
	        case 136 /* BooleanKeyword */:
	          return factory2.createIdentifier("Boolean");
	        case 203 /* TemplateLiteralType */:
	        case 154 /* StringKeyword */:
	          return factory2.createIdentifier("String");
	        case 151 /* ObjectKeyword */:
	          return factory2.createIdentifier("Object");
	        case 201 /* LiteralType */:
	          return serializeLiteralOfLiteralTypeNode(node.literal);
	        case 150 /* NumberKeyword */:
	          return factory2.createIdentifier("Number");
	        case 163 /* BigIntKeyword */:
	          return getGlobalConstructor("BigInt", 7 /* ES2020 */);
	        case 155 /* SymbolKeyword */:
	          return getGlobalConstructor("Symbol", 2 /* ES2015 */);
	        case 183 /* TypeReference */:
	          return serializeTypeReferenceNode(node);
	        case 193 /* IntersectionType */:
	          return serializeUnionOrIntersectionConstituents(
	            node.types,
	            /*isIntersection*/
	            true
	          );
	        case 192 /* UnionType */:
	          return serializeUnionOrIntersectionConstituents(
	            node.types,
	            /*isIntersection*/
	            false
	          );
	        case 194 /* ConditionalType */:
	          return serializeUnionOrIntersectionConstituents(
	            [node.trueType, node.falseType],
	            /*isIntersection*/
	            false
	          );
	        case 198 /* TypeOperator */:
	          if (node.operator === 148 /* ReadonlyKeyword */) {
	            return serializeTypeNode(node.type);
	          }
	          break;
	        case 186 /* TypeQuery */:
	        case 199 /* IndexedAccessType */:
	        case 200 /* MappedType */:
	        case 187 /* TypeLiteral */:
	        case 133 /* AnyKeyword */:
	        case 159 /* UnknownKeyword */:
	        case 197 /* ThisType */:
	        case 205 /* ImportType */:
	          break;
	        case 319 /* JSDocAllType */:
	        case 320 /* JSDocUnknownType */:
	        case 324 /* JSDocFunctionType */:
	        case 325 /* JSDocVariadicType */:
	        case 326 /* JSDocNamepathType */:
	          break;
	        case 321 /* JSDocNullableType */:
	        case 322 /* JSDocNonNullableType */:
	        case 323 /* JSDocOptionalType */:
	          return serializeTypeNode(node.type);
	        default:
	          return Debug.failBadSyntaxKind(node);
	      }
	      return factory2.createIdentifier("Object");
	    }
	    function serializeLiteralOfLiteralTypeNode(node) {
	      switch (node.kind) {
	        case 11 /* StringLiteral */:
	        case 15 /* NoSubstitutionTemplateLiteral */:
	          return factory2.createIdentifier("String");
	        case 224 /* PrefixUnaryExpression */: {
	          const operand = node.operand;
	          switch (operand.kind) {
	            case 9 /* NumericLiteral */:
	            case 10 /* BigIntLiteral */:
	              return serializeLiteralOfLiteralTypeNode(operand);
	            default:
	              return Debug.failBadSyntaxKind(operand);
	          }
	        }
	        case 9 /* NumericLiteral */:
	          return factory2.createIdentifier("Number");
	        case 10 /* BigIntLiteral */:
	          return getGlobalConstructor("BigInt", 7 /* ES2020 */);
	        case 112 /* TrueKeyword */:
	        case 97 /* FalseKeyword */:
	          return factory2.createIdentifier("Boolean");
	        case 106 /* NullKeyword */:
	          return factory2.createVoidZero();
	        default:
	          return Debug.failBadSyntaxKind(node);
	      }
	    }
	    function serializeUnionOrIntersectionConstituents(types, isIntersection) {
	      let serializedType;
	      for (let typeNode of types) {
	        typeNode = skipTypeParentheses(typeNode);
	        if (typeNode.kind === 146 /* NeverKeyword */) {
	          if (isIntersection)
	            return factory2.createVoidZero();
	          continue;
	        }
	        if (typeNode.kind === 159 /* UnknownKeyword */) {
	          if (!isIntersection)
	            return factory2.createIdentifier("Object");
	          continue;
	        }
	        if (typeNode.kind === 133 /* AnyKeyword */) {
	          return factory2.createIdentifier("Object");
	        }
	        if (!strictNullChecks && (isLiteralTypeNode(typeNode) && typeNode.literal.kind === 106 /* NullKeyword */ || typeNode.kind === 157 /* UndefinedKeyword */)) {
	          continue;
	        }
	        const serializedConstituent = serializeTypeNode(typeNode);
	        if (isIdentifier(serializedConstituent) && serializedConstituent.escapedText === "Object") {
	          return serializedConstituent;
	        }
	        if (serializedType) {
	          if (!equateSerializedTypeNodes(serializedType, serializedConstituent)) {
	            return factory2.createIdentifier("Object");
	          }
	        } else {
	          serializedType = serializedConstituent;
	        }
	      }
	      return serializedType ?? factory2.createVoidZero();
	    }
	    function equateSerializedTypeNodes(left, right) {
	      return (
	        // temp vars used in fallback
	        isGeneratedIdentifier(left) ? isGeneratedIdentifier(right) : (
	          // entity names
	          isIdentifier(left) ? isIdentifier(right) && left.escapedText === right.escapedText : isPropertyAccessExpression(left) ? isPropertyAccessExpression(right) && equateSerializedTypeNodes(left.expression, right.expression) && equateSerializedTypeNodes(left.name, right.name) : (
	            // `void 0`
	            isVoidExpression(left) ? isVoidExpression(right) && isNumericLiteral(left.expression) && left.expression.text === "0" && isNumericLiteral(right.expression) && right.expression.text === "0" : (
	              // `"undefined"` or `"function"` in `typeof` checks
	              isStringLiteral(left) ? isStringLiteral(right) && left.text === right.text : (
	                // used in `typeof` checks for fallback
	                isTypeOfExpression(left) ? isTypeOfExpression(right) && equateSerializedTypeNodes(left.expression, right.expression) : (
	                  // parens in `typeof` checks with temps
	                  isParenthesizedExpression(left) ? isParenthesizedExpression(right) && equateSerializedTypeNodes(left.expression, right.expression) : (
	                    // conditionals used in fallback
	                    isConditionalExpression(left) ? isConditionalExpression(right) && equateSerializedTypeNodes(left.condition, right.condition) && equateSerializedTypeNodes(left.whenTrue, right.whenTrue) && equateSerializedTypeNodes(left.whenFalse, right.whenFalse) : (
	                      // logical binary and assignments used in fallback
	                      isBinaryExpression(left) ? isBinaryExpression(right) && left.operatorToken.kind === right.operatorToken.kind && equateSerializedTypeNodes(left.left, right.left) && equateSerializedTypeNodes(left.right, right.right) : false
	                    )
	                  )
	                )
	              )
	            )
	          )
	        )
	      );
	    }
	    function serializeTypeReferenceNode(node) {
	      const kind = resolver.getTypeReferenceSerializationKind(node.typeName, currentNameScope ?? currentLexicalScope);
	      switch (kind) {
	        case 0 /* Unknown */:
	          if (findAncestor(node, (n) => n.parent && isConditionalTypeNode(n.parent) && (n.parent.trueType === n || n.parent.falseType === n))) {
	            return factory2.createIdentifier("Object");
	          }
	          const serialized = serializeEntityNameAsExpressionFallback(node.typeName);
	          const temp = factory2.createTempVariable(hoistVariableDeclaration);
	          return factory2.createConditionalExpression(
	            factory2.createTypeCheck(factory2.createAssignment(temp, serialized), "function"),
	            /*questionToken*/
	            void 0,
	            temp,
	            /*colonToken*/
	            void 0,
	            factory2.createIdentifier("Object")
	          );
	        case 1 /* TypeWithConstructSignatureAndValue */:
	          return serializeEntityNameAsExpression(node.typeName);
	        case 2 /* VoidNullableOrNeverType */:
	          return factory2.createVoidZero();
	        case 4 /* BigIntLikeType */:
	          return getGlobalConstructor("BigInt", 7 /* ES2020 */);
	        case 6 /* BooleanType */:
	          return factory2.createIdentifier("Boolean");
	        case 3 /* NumberLikeType */:
	          return factory2.createIdentifier("Number");
	        case 5 /* StringLikeType */:
	          return factory2.createIdentifier("String");
	        case 7 /* ArrayLikeType */:
	          return factory2.createIdentifier("Array");
	        case 8 /* ESSymbolType */:
	          return getGlobalConstructor("Symbol", 2 /* ES2015 */);
	        case 10 /* TypeWithCallSignature */:
	          return factory2.createIdentifier("Function");
	        case 9 /* Promise */:
	          return factory2.createIdentifier("Promise");
	        case 11 /* ObjectType */:
	          return factory2.createIdentifier("Object");
	        default:
	          return Debug.assertNever(kind);
	      }
	    }
	    function createCheckedValue(left, right) {
	      return factory2.createLogicalAnd(
	        factory2.createStrictInequality(factory2.createTypeOfExpression(left), factory2.createStringLiteral("undefined")),
	        right
	      );
	    }
	    function serializeEntityNameAsExpressionFallback(node) {
	      if (node.kind === 80 /* Identifier */) {
	        const copied = serializeEntityNameAsExpression(node);
	        return createCheckedValue(copied, copied);
	      }
	      if (node.left.kind === 80 /* Identifier */) {
	        return createCheckedValue(serializeEntityNameAsExpression(node.left), serializeEntityNameAsExpression(node));
	      }
	      const left = serializeEntityNameAsExpressionFallback(node.left);
	      const temp = factory2.createTempVariable(hoistVariableDeclaration);
	      return factory2.createLogicalAnd(
	        factory2.createLogicalAnd(
	          left.left,
	          factory2.createStrictInequality(factory2.createAssignment(temp, left.right), factory2.createVoidZero())
	        ),
	        factory2.createPropertyAccessExpression(temp, node.right)
	      );
	    }
	    function serializeEntityNameAsExpression(node) {
	      switch (node.kind) {
	        case 80 /* Identifier */:
	          const name = setParent(setTextRange(parseNodeFactory.cloneNode(node), node), node.parent);
	          name.original = void 0;
	          setParent(name, getParseTreeNode(currentLexicalScope));
	          return name;
	        case 166 /* QualifiedName */:
	          return serializeQualifiedNameAsExpression(node);
	      }
	    }
	    function serializeQualifiedNameAsExpression(node) {
	      return factory2.createPropertyAccessExpression(serializeEntityNameAsExpression(node.left), node.right);
	    }
	    function getGlobalConstructorWithFallback(name) {
	      return factory2.createConditionalExpression(
	        factory2.createTypeCheck(factory2.createIdentifier(name), "function"),
	        /*questionToken*/
	        void 0,
	        factory2.createIdentifier(name),
	        /*colonToken*/
	        void 0,
	        factory2.createIdentifier("Object")
	      );
	    }
	    function getGlobalConstructor(name, minLanguageVersion) {
	      return languageVersion < minLanguageVersion ? getGlobalConstructorWithFallback(name) : factory2.createIdentifier(name);
	    }
	  }
	  var init_typeSerializer = __esm({
	    "src/compiler/transformers/typeSerializer.ts"() {
	      init_ts2();
	    }
	  });

	  // src/compiler/transformers/legacyDecorators.ts
	  function transformLegacyDecorators(context) {
	    const {
	      factory: factory2,
	      getEmitHelperFactory: emitHelpers,
	      hoistVariableDeclaration
	    } = context;
	    const resolver = context.getEmitResolver();
	    const compilerOptions = context.getCompilerOptions();
	    const languageVersion = getEmitScriptTarget(compilerOptions);
	    const previousOnSubstituteNode = context.onSubstituteNode;
	    context.onSubstituteNode = onSubstituteNode;
	    let classAliases;
	    return chainBundle(context, transformSourceFile);
	    function transformSourceFile(node) {
	      const visited = visitEachChild(node, visitor, context);
	      addEmitHelpers(visited, context.readEmitHelpers());
	      return visited;
	    }
	    function modifierVisitor(node) {
	      return isDecorator(node) ? void 0 : node;
	    }
	    function visitor(node) {
	      if (!(node.transformFlags & 33554432 /* ContainsDecorators */)) {
	        return node;
	      }
	      switch (node.kind) {
	        case 170 /* Decorator */:
	          return void 0;
	        case 263 /* ClassDeclaration */:
	          return visitClassDeclaration(node);
	        case 231 /* ClassExpression */:
	          return visitClassExpression(node);
	        case 176 /* Constructor */:
	          return visitConstructorDeclaration(node);
	        case 174 /* MethodDeclaration */:
	          return visitMethodDeclaration(node);
	        case 178 /* SetAccessor */:
	          return visitSetAccessorDeclaration(node);
	        case 177 /* GetAccessor */:
	          return visitGetAccessorDeclaration(node);
	        case 172 /* PropertyDeclaration */:
	          return visitPropertyDeclaration(node);
	        case 169 /* Parameter */:
	          return visitParameterDeclaration(node);
	        default:
	          return visitEachChild(node, visitor, context);
	      }
	    }
	    function visitClassDeclaration(node) {
	      if (!(classOrConstructorParameterIsDecorated(
	        /*useLegacyDecorators*/
	        true,
	        node
	      ) || childIsDecorated(
	        /*useLegacyDecorators*/
	        true,
	        node
	      ))) {
	        return visitEachChild(node, visitor, context);
	      }
	      const statements = classOrConstructorParameterIsDecorated(
	        /*useLegacyDecorators*/
	        true,
	        node
	      ) ? transformClassDeclarationWithClassDecorators(node, node.name) : transformClassDeclarationWithoutClassDecorators(node, node.name);
	      return singleOrMany(statements);
	    }
	    function decoratorContainsPrivateIdentifierInExpression(decorator) {
	      return !!(decorator.transformFlags & 536870912 /* ContainsPrivateIdentifierInExpression */);
	    }
	    function parameterDecoratorsContainPrivateIdentifierInExpression(parameterDecorators) {
	      return some(parameterDecorators, decoratorContainsPrivateIdentifierInExpression);
	    }
	    function hasClassElementWithDecoratorContainingPrivateIdentifierInExpression(node) {
	      for (const member of node.members) {
	        if (!canHaveDecorators(member))
	          continue;
	        const allDecorators = getAllDecoratorsOfClassElement(
	          member,
	          node,
	          /*useLegacyDecorators*/
	          true
	        );
	        if (some(allDecorators == null ? void 0 : allDecorators.decorators, decoratorContainsPrivateIdentifierInExpression))
	          return true;
	        if (some(allDecorators == null ? void 0 : allDecorators.parameters, parameterDecoratorsContainPrivateIdentifierInExpression))
	          return true;
	      }
	      return false;
	    }
	    function transformDecoratorsOfClassElements(node, members) {
	      let decorationStatements = [];
	      addClassElementDecorationStatements(
	        decorationStatements,
	        node,
	        /*isStatic*/
	        false
	      );
	      addClassElementDecorationStatements(
	        decorationStatements,
	        node,
	        /*isStatic*/
	        true
	      );
	      if (hasClassElementWithDecoratorContainingPrivateIdentifierInExpression(node)) {
	        members = setTextRange(
	          factory2.createNodeArray([
	            ...members,
	            factory2.createClassStaticBlockDeclaration(
	              factory2.createBlock(
	                decorationStatements,
	                /*multiLine*/
	                true
	              )
	            )
	          ]),
	          members
	        );
	        decorationStatements = void 0;
	      }
	      return { decorationStatements, members };
	    }
	    function transformClassDeclarationWithoutClassDecorators(node, name) {
	      const modifiers = visitNodes2(node.modifiers, modifierVisitor, isModifier);
	      const heritageClauses = visitNodes2(node.heritageClauses, visitor, isHeritageClause);
	      let members = visitNodes2(node.members, visitor, isClassElement);
	      let decorationStatements = [];
	      ({ members, decorationStatements } = transformDecoratorsOfClassElements(node, members));
	      const updated = factory2.updateClassDeclaration(
	        node,
	        modifiers,
	        name,
	        /*typeParameters*/
	        void 0,
	        heritageClauses,
	        members
	      );
	      return addRange([updated], decorationStatements);
	    }
	    function transformClassDeclarationWithClassDecorators(node, name) {
	      const isExport = hasSyntacticModifier(node, 32 /* Export */);
	      const isDefault = hasSyntacticModifier(node, 2048 /* Default */);
	      const modifiers = visitNodes2(node.modifiers, (node2) => isExportOrDefaultModifier(node2) || isDecorator(node2) ? void 0 : node2, isModifierLike);
	      const location = moveRangePastModifiers(node);
	      const classAlias = getClassAliasIfNeeded(node);
	      const declName = languageVersion < 2 /* ES2015 */ ? factory2.getInternalName(
	        node,
	        /*allowComments*/
	        false,
	        /*allowSourceMaps*/
	        true
	      ) : factory2.getLocalName(
	        node,
	        /*allowComments*/
	        false,
	        /*allowSourceMaps*/
	        true
	      );
	      const heritageClauses = visitNodes2(node.heritageClauses, visitor, isHeritageClause);
	      let members = visitNodes2(node.members, visitor, isClassElement);
	      let decorationStatements = [];
	      ({ members, decorationStatements } = transformDecoratorsOfClassElements(node, members));
	      const assignClassAliasInStaticBlock = languageVersion >= 9 /* ES2022 */ && !!classAlias && some(members, (member) => isPropertyDeclaration(member) && hasSyntacticModifier(member, 256 /* Static */) || isClassStaticBlockDeclaration(member));
	      if (assignClassAliasInStaticBlock) {
	        members = setTextRange(
	          factory2.createNodeArray([
	            factory2.createClassStaticBlockDeclaration(
	              factory2.createBlock([
	                factory2.createExpressionStatement(
	                  factory2.createAssignment(classAlias, factory2.createThis())
	                )
	              ])
	            ),
	            ...members
	          ]),
	          members
	        );
	      }
	      const classExpression = factory2.createClassExpression(
	        modifiers,
	        name && isGeneratedIdentifier(name) ? void 0 : name,
	        /*typeParameters*/
	        void 0,
	        heritageClauses,
	        members
	      );
	      setOriginalNode(classExpression, node);
	      setTextRange(classExpression, location);
	      const varInitializer = classAlias && !assignClassAliasInStaticBlock ? factory2.createAssignment(classAlias, classExpression) : classExpression;
	      const varDecl = factory2.createVariableDeclaration(
	        declName,
	        /*exclamationToken*/
	        void 0,
	        /*type*/
	        void 0,
	        varInitializer
	      );
	      setOriginalNode(varDecl, node);
	      const varDeclList = factory2.createVariableDeclarationList([varDecl], 1 /* Let */);
	      const varStatement = factory2.createVariableStatement(
	        /*modifiers*/
	        void 0,
	        varDeclList
	      );
	      setOriginalNode(varStatement, node);
	      setTextRange(varStatement, location);
	      setCommentRange(varStatement, node);
	      const statements = [varStatement];
	      addRange(statements, decorationStatements);
	      addConstructorDecorationStatement(statements, node);
	      if (isExport) {
	        if (isDefault) {
	          const exportStatement = factory2.createExportDefault(declName);
	          statements.push(exportStatement);
	        } else {
	          const exportStatement = factory2.createExternalModuleExport(factory2.getDeclarationName(node));
	          statements.push(exportStatement);
	        }
	      }
	      return statements;
	    }
	    function visitClassExpression(node) {
	      return factory2.updateClassExpression(
	        node,
	        visitNodes2(node.modifiers, modifierVisitor, isModifier),
	        node.name,
	        /*typeParameters*/
	        void 0,
	        visitNodes2(node.heritageClauses, visitor, isHeritageClause),
	        visitNodes2(node.members, visitor, isClassElement)
	      );
	    }
	    function visitConstructorDeclaration(node) {
	      return factory2.updateConstructorDeclaration(
	        node,
	        visitNodes2(node.modifiers, modifierVisitor, isModifier),
	        visitNodes2(node.parameters, visitor, isParameter),
	        visitNode(node.body, visitor, isBlock)
	      );
	    }
	    function finishClassElement(updated, original) {
	      if (updated !== original) {
	        setCommentRange(updated, original);
	        setSourceMapRange(updated, moveRangePastModifiers(original));
	      }
	      return updated;
	    }
	    function visitMethodDeclaration(node) {
	      return finishClassElement(
	        factory2.updateMethodDeclaration(
	          node,
	          visitNodes2(node.modifiers, modifierVisitor, isModifier),
	          node.asteriskToken,
	          Debug.checkDefined(visitNode(node.name, visitor, isPropertyName)),
	          /*questionToken*/
	          void 0,
	          /*typeParameters*/
	          void 0,
	          visitNodes2(node.parameters, visitor, isParameter),
	          /*type*/
	          void 0,
	          visitNode(node.body, visitor, isBlock)
	        ),
	        node
	      );
	    }
	    function visitGetAccessorDeclaration(node) {
	      return finishClassElement(
	        factory2.updateGetAccessorDeclaration(
	          node,
	          visitNodes2(node.modifiers, modifierVisitor, isModifier),
	          Debug.checkDefined(visitNode(node.name, visitor, isPropertyName)),
	          visitNodes2(node.parameters, visitor, isParameter),
	          /*type*/
	          void 0,
	          visitNode(node.body, visitor, isBlock)
	        ),
	        node
	      );
	    }
	    function visitSetAccessorDeclaration(node) {
	      return finishClassElement(
	        factory2.updateSetAccessorDeclaration(
	          node,
	          visitNodes2(node.modifiers, modifierVisitor, isModifier),
	          Debug.checkDefined(visitNode(node.name, visitor, isPropertyName)),
	          visitNodes2(node.parameters, visitor, isParameter),
	          visitNode(node.body, visitor, isBlock)
	        ),
	        node
	      );
	    }
	    function visitPropertyDeclaration(node) {
	      if (node.flags & 33554432 /* Ambient */ || hasSyntacticModifier(node, 128 /* Ambient */)) {
	        return void 0;
	      }
	      return finishClassElement(
	        factory2.updatePropertyDeclaration(
	          node,
	          visitNodes2(node.modifiers, modifierVisitor, isModifier),
	          Debug.checkDefined(visitNode(node.name, visitor, isPropertyName)),
	          /*questionOrExclamationToken*/
	          void 0,
	          /*type*/
	          void 0,
	          visitNode(node.initializer, visitor, isExpression)
	        ),
	        node
	      );
	    }
	    function visitParameterDeclaration(node) {
	      const updated = factory2.updateParameterDeclaration(
	        node,
	        elideNodes(factory2, node.modifiers),
	        node.dotDotDotToken,
	        Debug.checkDefined(visitNode(node.name, visitor, isBindingName)),
	        /*questionToken*/
	        void 0,
	        /*type*/
	        void 0,
	        visitNode(node.initializer, visitor, isExpression)
	      );
	      if (updated !== node) {
	        setCommentRange(updated, node);
	        setTextRange(updated, moveRangePastModifiers(node));
	        setSourceMapRange(updated, moveRangePastModifiers(node));
	        setEmitFlags(updated.name, 64 /* NoTrailingSourceMap */);
	      }
	      return updated;
	    }
	    function isSyntheticMetadataDecorator(node) {
	      return isCallToHelper(node.expression, "___metadata");
	    }
	    function transformAllDecoratorsOfDeclaration(allDecorators) {
	      if (!allDecorators) {
	        return void 0;
	      }
	      const { false: decorators, true: metadata } = groupBy(allDecorators.decorators, isSyntheticMetadataDecorator);
	      const decoratorExpressions = [];
	      addRange(decoratorExpressions, map(decorators, transformDecorator));
	      addRange(decoratorExpressions, flatMap(allDecorators.parameters, transformDecoratorsOfParameter));
	      addRange(decoratorExpressions, map(metadata, transformDecorator));
	      return decoratorExpressions;
	    }
	    function addClassElementDecorationStatements(statements, node, isStatic2) {
	      addRange(statements, map(generateClassElementDecorationExpressions(node, isStatic2), (expr) => factory2.createExpressionStatement(expr)));
	    }
	    function isDecoratedClassElement(member, isStaticElement, parent2) {
	      return nodeOrChildIsDecorated(
	        /*useLegacyDecorators*/
	        true,
	        member,
	        parent2
	      ) && isStaticElement === isStatic(member);
	    }
	    function getDecoratedClassElements(node, isStatic2) {
	      return filter(node.members, (m) => isDecoratedClassElement(m, isStatic2, node));
	    }
	    function generateClassElementDecorationExpressions(node, isStatic2) {
	      const members = getDecoratedClassElements(node, isStatic2);
	      let expressions;
	      for (const member of members) {
	        expressions = append(expressions, generateClassElementDecorationExpression(node, member));
	      }
	      return expressions;
	    }
	    function generateClassElementDecorationExpression(node, member) {
	      const allDecorators = getAllDecoratorsOfClassElement(
	        member,
	        node,
	        /*useLegacyDecorators*/
	        true
	      );
	      const decoratorExpressions = transformAllDecoratorsOfDeclaration(allDecorators);
	      if (!decoratorExpressions) {
	        return void 0;
	      }
	      const prefix = getClassMemberPrefix(node, member);
	      const memberName = getExpressionForPropertyName(
	        member,
	        /*generateNameForComputedPropertyName*/
	        !hasSyntacticModifier(member, 128 /* Ambient */)
	      );
	      const descriptor = languageVersion > 0 /* ES3 */ ? isPropertyDeclaration(member) && !hasAccessorModifier(member) ? factory2.createVoidZero() : factory2.createNull() : void 0;
	      const helper = emitHelpers().createDecorateHelper(
	        decoratorExpressions,
	        prefix,
	        memberName,
	        descriptor
	      );
	      setEmitFlags(helper, 3072 /* NoComments */);
	      setSourceMapRange(helper, moveRangePastModifiers(member));
	      return helper;
	    }
	    function addConstructorDecorationStatement(statements, node) {
	      const expression = generateConstructorDecorationExpression(node);
	      if (expression) {
	        statements.push(setOriginalNode(factory2.createExpressionStatement(expression), node));
	      }
	    }
	    function generateConstructorDecorationExpression(node) {
	      const allDecorators = getAllDecoratorsOfClass(node);
	      const decoratorExpressions = transformAllDecoratorsOfDeclaration(allDecorators);
	      if (!decoratorExpressions) {
	        return void 0;
	      }
	      const classAlias = classAliases && classAliases[getOriginalNodeId(node)];
	      const localName = languageVersion < 2 /* ES2015 */ ? factory2.getInternalName(
	        node,
	        /*allowComments*/
	        false,
	        /*allowSourceMaps*/
	        true
	      ) : factory2.getDeclarationName(
	        node,
	        /*allowComments*/
	        false,
	        /*allowSourceMaps*/
	        true
	      );
	      const decorate = emitHelpers().createDecorateHelper(decoratorExpressions, localName);
	      const expression = factory2.createAssignment(localName, classAlias ? factory2.createAssignment(classAlias, decorate) : decorate);
	      setEmitFlags(expression, 3072 /* NoComments */);
	      setSourceMapRange(expression, moveRangePastModifiers(node));
	      return expression;
	    }
	    function transformDecorator(decorator) {
	      return Debug.checkDefined(visitNode(decorator.expression, visitor, isExpression));
	    }
	    function transformDecoratorsOfParameter(decorators, parameterOffset) {
	      let expressions;
	      if (decorators) {
	        expressions = [];
	        for (const decorator of decorators) {
	          const helper = emitHelpers().createParamHelper(
	            transformDecorator(decorator),
	            parameterOffset
	          );
	          setTextRange(helper, decorator.expression);
	          setEmitFlags(helper, 3072 /* NoComments */);
	          expressions.push(helper);
	        }
	      }
	      return expressions;
	    }
	    function getExpressionForPropertyName(member, generateNameForComputedPropertyName) {
	      const name = member.name;
	      if (isPrivateIdentifier(name)) {
	        return factory2.createIdentifier("");
	      } else if (isComputedPropertyName(name)) {
	        return generateNameForComputedPropertyName && !isSimpleInlineableExpression(name.expression) ? factory2.getGeneratedNameForNode(name) : name.expression;
	      } else if (isIdentifier(name)) {
	        return factory2.createStringLiteral(idText(name));
	      } else {
	        return factory2.cloneNode(name);
	      }
	    }
	    function enableSubstitutionForClassAliases() {
	      if (!classAliases) {
	        context.enableSubstitution(80 /* Identifier */);
	        classAliases = [];
	      }
	    }
	    function getClassAliasIfNeeded(node) {
	      if (resolver.getNodeCheckFlags(node) & 262144 /* ContainsConstructorReference */) {
	        enableSubstitutionForClassAliases();
	        const classAlias = factory2.createUniqueName(node.name && !isGeneratedIdentifier(node.name) ? idText(node.name) : "default");
	        classAliases[getOriginalNodeId(node)] = classAlias;
	        hoistVariableDeclaration(classAlias);
	        return classAlias;
	      }
	    }
	    function getClassPrototype(node) {
	      return factory2.createPropertyAccessExpression(factory2.getDeclarationName(node), "prototype");
	    }
	    function getClassMemberPrefix(node, member) {
	      return isStatic(member) ? factory2.getDeclarationName(node) : getClassPrototype(node);
	    }
	    function onSubstituteNode(hint, node) {
	      node = previousOnSubstituteNode(hint, node);
	      if (hint === 1 /* Expression */) {
	        return substituteExpression(node);
	      }
	      return node;
	    }
	    function substituteExpression(node) {
	      switch (node.kind) {
	        case 80 /* Identifier */:
	          return substituteExpressionIdentifier(node);
	      }
	      return node;
	    }
	    function substituteExpressionIdentifier(node) {
	      return trySubstituteClassAlias(node) ?? node;
	    }
	    function trySubstituteClassAlias(node) {
	      if (classAliases) {
	        if (resolver.getNodeCheckFlags(node) & 536870912 /* ConstructorReference */) {
	          const declaration = resolver.getReferencedValueDeclaration(node);
	          if (declaration) {
	            const classAlias = classAliases[declaration.id];
	            if (classAlias) {
	              const clone2 = factory2.cloneNode(classAlias);
	              setSourceMapRange(clone2, node);
	              setCommentRange(clone2, node);
	              return clone2;
	            }
	          }
	        }
	      }
	      return void 0;
	    }
	  }
	  var init_legacyDecorators = __esm({
	    "src/compiler/transformers/legacyDecorators.ts"() {
	      init_ts2();
	    }
	  });

	  // src/compiler/transformers/esDecorators.ts
	  function transformESDecorators(context) {
	    const {
	      factory: factory2,
	      getEmitHelperFactory: emitHelpers,
	      startLexicalEnvironment,
	      endLexicalEnvironment,
	      hoistVariableDeclaration
	    } = context;
	    const languageVersion = getEmitScriptTarget(context.getCompilerOptions());
	    let top;
	    let classInfo;
	    let classThis;
	    let classSuper;
	    let pendingExpressions;
	    let shouldTransformPrivateStaticElementsInFile;
	    return chainBundle(context, transformSourceFile);
	    function transformSourceFile(node) {
	      top = void 0;
	      shouldTransformPrivateStaticElementsInFile = false;
	      const visited = visitEachChild(node, visitor, context);
	      addEmitHelpers(visited, context.readEmitHelpers());
	      if (shouldTransformPrivateStaticElementsInFile) {
	        addInternalEmitFlags(visited, 32 /* TransformPrivateStaticElements */);
	        shouldTransformPrivateStaticElementsInFile = false;
	      }
	      return visited;
	    }
	    function updateState() {
	      classInfo = void 0;
	      classThis = void 0;
	      classSuper = void 0;
	      switch (top == null ? void 0 : top.kind) {
	        case "class":
	          classInfo = top.classInfo;
	          break;
	        case "class-element":
	          classInfo = top.next.classInfo;
	          classThis = top.classThis;
	          classSuper = top.classSuper;
	          break;
	        case "name":
	          const grandparent = top.next.next.next;
	          if ((grandparent == null ? void 0 : grandparent.kind) === "class-element") {
	            classInfo = grandparent.next.classInfo;
	            classThis = grandparent.classThis;
	            classSuper = grandparent.classSuper;
	          }
	          break;
	      }
	    }
	    function enterClass(classInfo2) {
	      top = { kind: "class", next: top, classInfo: classInfo2, savedPendingExpressions: pendingExpressions };
	      pendingExpressions = void 0;
	      updateState();
	    }
	    function exitClass() {
	      Debug.assert((top == null ? void 0 : top.kind) === "class", "Incorrect value for top.kind.", () => `Expected top.kind to be 'class' but got '${top == null ? void 0 : top.kind}' instead.`);
	      pendingExpressions = top.savedPendingExpressions;
	      top = top.next;
	      updateState();
	    }
	    function enterClassElement(node) {
	      var _a, _b;
	      Debug.assert((top == null ? void 0 : top.kind) === "class", "Incorrect value for top.kind.", () => `Expected top.kind to be 'class' but got '${top == null ? void 0 : top.kind}' instead.`);
	      top = { kind: "class-element", next: top };
	      if (isClassStaticBlockDeclaration(node) || isPropertyDeclaration(node) && hasStaticModifier(node)) {
	        top.classThis = (_a = top.next.classInfo) == null ? void 0 : _a.classThis;
	        top.classSuper = (_b = top.next.classInfo) == null ? void 0 : _b.classSuper;
	      }
	      updateState();
	    }
	    function exitClassElement() {
	      var _a;
	      Debug.assert((top == null ? void 0 : top.kind) === "class-element", "Incorrect value for top.kind.", () => `Expected top.kind to be 'class-element' but got '${top == null ? void 0 : top.kind}' instead.`);
	      Debug.assert(((_a = top.next) == null ? void 0 : _a.kind) === "class", "Incorrect value for top.next.kind.", () => {
	        var _a2;
	        return `Expected top.next.kind to be 'class' but got '${(_a2 = top.next) == null ? void 0 : _a2.kind}' instead.`;
	      });
	      top = top.next;
	      updateState();
	    }
	    function enterName() {
	      Debug.assert((top == null ? void 0 : top.kind) === "class-element", "Incorrect value for top.kind.", () => `Expected top.kind to be 'class-element' but got '${top == null ? void 0 : top.kind}' instead.`);
	      top = { kind: "name", next: top };
	      updateState();
	    }
	    function exitName() {
	      Debug.assert((top == null ? void 0 : top.kind) === "name", "Incorrect value for top.kind.", () => `Expected top.kind to be 'name' but got '${top == null ? void 0 : top.kind}' instead.`);
	      top = top.next;
	      updateState();
	    }
	    function enterOther() {
	      if ((top == null ? void 0 : top.kind) === "other") {
	        Debug.assert(!pendingExpressions);
	        top.depth++;
	      } else {
	        top = { kind: "other", next: top, depth: 0, savedPendingExpressions: pendingExpressions };
	        pendingExpressions = void 0;
	        updateState();
	      }
	    }
	    function exitOther() {
	      Debug.assert((top == null ? void 0 : top.kind) === "other", "Incorrect value for top.kind.", () => `Expected top.kind to be 'other' but got '${top == null ? void 0 : top.kind}' instead.`);
	      if (top.depth > 0) {
	        Debug.assert(!pendingExpressions);
	        top.depth--;
	      } else {
	        pendingExpressions = top.savedPendingExpressions;
	        top = top.next;
	        updateState();
	      }
	    }
	    function shouldVisitNode(node) {
	      return !!(node.transformFlags & 33554432 /* ContainsDecorators */) || !!classThis && !!(node.transformFlags & 16384 /* ContainsLexicalThis */) || !!classThis && !!classSuper && !!(node.transformFlags & 134217728 /* ContainsLexicalSuper */);
	    }
	    function visitor(node) {
	      if (!shouldVisitNode(node)) {
	        return node;
	      }
	      switch (node.kind) {
	        case 170 /* Decorator */:
	          return Debug.fail("Use `modifierVisitor` instead.");
	        case 263 /* ClassDeclaration */:
	          return visitClassDeclaration(node);
	        case 231 /* ClassExpression */:
	          return visitClassExpression(node);
	        case 176 /* Constructor */:
	        case 172 /* PropertyDeclaration */:
	        case 175 /* ClassStaticBlockDeclaration */:
	          return Debug.fail("Not supported outside of a class. Use 'classElementVisitor' instead.");
	        case 169 /* Parameter */:
	          return visitParameterDeclaration(node);
	        case 226 /* BinaryExpression */:
	          return visitBinaryExpression(
	            node,
	            /*discarded*/
	            false
	          );
	        case 303 /* PropertyAssignment */:
	          return visitPropertyAssignment(node);
	        case 260 /* VariableDeclaration */:
	          return visitVariableDeclaration(node);
	        case 208 /* BindingElement */:
	          return visitBindingElement(node);
	        case 277 /* ExportAssignment */:
	          return visitExportAssignment(node);
	        case 110 /* ThisKeyword */:
	          return visitThisExpression(node);
	        case 248 /* ForStatement */:
	          return visitForStatement(node);
	        case 244 /* ExpressionStatement */:
	          return visitExpressionStatement(node);
	        case 361 /* CommaListExpression */:
	          return visitCommaListExpression(
	            node,
	            /*discarded*/
	            false
	          );
	        case 217 /* ParenthesizedExpression */:
	          return visitParenthesizedExpression(
	            node,
	            /*discarded*/
	            false
	          );
	        case 360 /* PartiallyEmittedExpression */:
	          return visitPartiallyEmittedExpression(
	            node,
	            /*discarded*/
	            false
	          );
	        case 213 /* CallExpression */:
	          return visitCallExpression(node);
	        case 215 /* TaggedTemplateExpression */:
	          return visitTaggedTemplateExpression(node);
	        case 224 /* PrefixUnaryExpression */:
	        case 225 /* PostfixUnaryExpression */:
	          return visitPreOrPostfixUnaryExpression(
	            node,
	            /*discarded*/
	            false
	          );
	        case 211 /* PropertyAccessExpression */:
	          return visitPropertyAccessExpression(node);
	        case 212 /* ElementAccessExpression */:
	          return visitElementAccessExpression(node);
	        case 167 /* ComputedPropertyName */:
	          return visitComputedPropertyName(node);
	        case 174 /* MethodDeclaration */:
	        case 178 /* SetAccessor */:
	        case 177 /* GetAccessor */:
	        case 218 /* FunctionExpression */:
	        case 262 /* FunctionDeclaration */: {
	          enterOther();
	          const result = visitEachChild(node, fallbackVisitor, context);
	          exitOther();
	          return result;
	        }
	        default:
	          return visitEachChild(node, fallbackVisitor, context);
	      }
	    }
	    function fallbackVisitor(node) {
	      switch (node.kind) {
	        case 170 /* Decorator */:
	          return void 0;
	        default:
	          return visitor(node);
	      }
	    }
	    function modifierVisitor(node) {
	      switch (node.kind) {
	        case 170 /* Decorator */:
	          return void 0;
	        default:
	          return node;
	      }
	    }
	    function classElementVisitor(node) {
	      switch (node.kind) {
	        case 176 /* Constructor */:
	          return visitConstructorDeclaration(node);
	        case 174 /* MethodDeclaration */:
	          return visitMethodDeclaration(node);
	        case 177 /* GetAccessor */:
	          return visitGetAccessorDeclaration(node);
	        case 178 /* SetAccessor */:
	          return visitSetAccessorDeclaration(node);
	        case 172 /* PropertyDeclaration */:
	          return visitPropertyDeclaration(node);
	        case 175 /* ClassStaticBlockDeclaration */:
	          return visitClassStaticBlockDeclaration(node);
	        default:
	          return visitor(node);
	      }
	    }
	    function discardedValueVisitor(node) {
	      switch (node.kind) {
	        case 224 /* PrefixUnaryExpression */:
	        case 225 /* PostfixUnaryExpression */:
	          return visitPreOrPostfixUnaryExpression(
	            node,
	            /*discarded*/
	            true
	          );
	        case 226 /* BinaryExpression */:
	          return visitBinaryExpression(
	            node,
	            /*discarded*/
	            true
	          );
	        case 361 /* CommaListExpression */:
	          return visitCommaListExpression(
	            node,
	            /*discarded*/
	            true
	          );
	        case 217 /* ParenthesizedExpression */:
	          return visitParenthesizedExpression(
	            node,
	            /*discarded*/
	            true
	          );
	        default:
	          return visitor(node);
	      }
	    }
	    function getHelperVariableName(node) {
	      let declarationName = node.name && isIdentifier(node.name) && !isGeneratedIdentifier(node.name) ? idText(node.name) : node.name && isPrivateIdentifier(node.name) && !isGeneratedIdentifier(node.name) ? idText(node.name).slice(1) : node.name && isStringLiteral(node.name) && isIdentifierText(node.name.text, 99 /* ESNext */) ? node.name.text : isClassLike(node) ? "class" : "member";
	      if (isGetAccessor(node))
	        declarationName = `get_${declarationName}`;
	      if (isSetAccessor(node))
	        declarationName = `set_${declarationName}`;
	      if (node.name && isPrivateIdentifier(node.name))
	        declarationName = `private_${declarationName}`;
	      if (isStatic(node))
	        declarationName = `static_${declarationName}`;
	      return "_" + declarationName;
	    }
	    function createHelperVariable(node, suffix) {
	      return factory2.createUniqueName(`${getHelperVariableName(node)}_${suffix}`, 16 /* Optimistic */ | 8 /* ReservedInNestedScopes */);
	    }
	    function createLet(name, initializer) {
	      return factory2.createVariableStatement(
	        /*modifiers*/
	        void 0,
	        factory2.createVariableDeclarationList([
	          factory2.createVariableDeclaration(
	            name,
	            /*exclamationToken*/
	            void 0,
	            /*type*/
	            void 0,
	            initializer
	          )
	        ], 1 /* Let */)
	      );
	    }
	    function createClassInfo(node) {
	      const metadataReference = factory2.createUniqueName("_metadata", 16 /* Optimistic */ | 32 /* FileLevel */);
	      let instanceMethodExtraInitializersName;
	      let staticMethodExtraInitializersName;
	      let hasStaticInitializers = false;
	      let hasNonAmbientInstanceFields = false;
	      let hasStaticPrivateClassElements = false;
	      let classThis2;
	      let pendingStaticInitializers;
	      let pendingInstanceInitializers;
	      if (nodeIsDecorated(
	        /*useLegacyDecorators*/
	        false,
	        node
	      )) {
	        const needsUniqueClassThis = some(node.members, (member) => (isPrivateIdentifierClassElementDeclaration(member) || isAutoAccessorPropertyDeclaration(member)) && hasStaticModifier(member));
	        classThis2 = factory2.createUniqueName(
	          "_classThis",
	          needsUniqueClassThis ? 16 /* Optimistic */ | 8 /* ReservedInNestedScopes */ : 16 /* Optimistic */ | 32 /* FileLevel */
	        );
	      }
	      for (const member of node.members) {
	        if (isMethodOrAccessor(member) && nodeOrChildIsDecorated(
	          /*useLegacyDecorators*/
	          false,
	          member,
	          node
	        )) {
	          if (hasStaticModifier(member)) {
	            if (!staticMethodExtraInitializersName) {
	              staticMethodExtraInitializersName = factory2.createUniqueName("_staticExtraInitializers", 16 /* Optimistic */ | 32 /* FileLevel */);
	              const initializer = emitHelpers().createRunInitializersHelper(classThis2 ?? factory2.createThis(), staticMethodExtraInitializersName);
	              setSourceMapRange(initializer, node.name ?? moveRangePastDecorators(node));
	              pendingStaticInitializers ?? (pendingStaticInitializers = []);
	              pendingStaticInitializers.push(initializer);
	            }
	          } else {
	            if (!instanceMethodExtraInitializersName) {
	              instanceMethodExtraInitializersName = factory2.createUniqueName("_instanceExtraInitializers", 16 /* Optimistic */ | 32 /* FileLevel */);
	              const initializer = emitHelpers().createRunInitializersHelper(factory2.createThis(), instanceMethodExtraInitializersName);
	              setSourceMapRange(initializer, node.name ?? moveRangePastDecorators(node));
	              pendingInstanceInitializers ?? (pendingInstanceInitializers = []);
	              pendingInstanceInitializers.push(initializer);
	            }
	            instanceMethodExtraInitializersName ?? (instanceMethodExtraInitializersName = factory2.createUniqueName("_instanceExtraInitializers", 16 /* Optimistic */ | 32 /* FileLevel */));
	          }
	        }
	        if (isClassStaticBlockDeclaration(member)) {
	          if (!isClassNamedEvaluationHelperBlock(member)) {
	            hasStaticInitializers = true;
	          }
	        } else if (isPropertyDeclaration(member)) {
	          if (hasStaticModifier(member)) {
	            hasStaticInitializers || (hasStaticInitializers = !!member.initializer || hasDecorators(member));
	          } else {
	            hasNonAmbientInstanceFields || (hasNonAmbientInstanceFields = !isAmbientPropertyDeclaration(member));
	          }
	        }
	        if ((isPrivateIdentifierClassElementDeclaration(member) || isAutoAccessorPropertyDeclaration(member)) && hasStaticModifier(member)) {
	          hasStaticPrivateClassElements = true;
	        }
	        if (staticMethodExtraInitializersName && instanceMethodExtraInitializersName && hasStaticInitializers && hasNonAmbientInstanceFields && hasStaticPrivateClassElements) {
	          break;
	        }
	      }
	      return {
	        class: node,
	        classThis: classThis2,
	        metadataReference,
	        instanceMethodExtraInitializersName,
	        staticMethodExtraInitializersName,
	        hasStaticInitializers,
	        hasNonAmbientInstanceFields,
	        hasStaticPrivateClassElements,
	        pendingStaticInitializers,
	        pendingInstanceInitializers
	      };
	    }
	    function transformClassLike(node) {
	      startLexicalEnvironment();
	      if (!classHasDeclaredOrExplicitlyAssignedName(node) && classOrConstructorParameterIsDecorated(
	        /*useLegacyDecorators*/
	        false,
	        node
	      )) {
	        node = injectClassNamedEvaluationHelperBlockIfMissing(context, node, factory2.createStringLiteral(""));
	      }
	      const classReference = factory2.getLocalName(
	        node,
	        /*allowComments*/
	        false,
	        /*allowSourceMaps*/
	        false,
	        /*ignoreAssignedName*/
	        true
	      );
	      const classInfo2 = createClassInfo(node);
	      const classDefinitionStatements = [];
	      let leadingBlockStatements;
	      let trailingBlockStatements;
	      let syntheticConstructor;
	      let heritageClauses;
	      let shouldTransformPrivateStaticElementsInClass = false;
	      const classDecorators = transformAllDecoratorsOfDeclaration(getAllDecoratorsOfClass(node));
	      if (classDecorators) {
	        classInfo2.classDecoratorsName = factory2.createUniqueName("_classDecorators", 16 /* Optimistic */ | 32 /* FileLevel */);
	        classInfo2.classDescriptorName = factory2.createUniqueName("_classDescriptor", 16 /* Optimistic */ | 32 /* FileLevel */);
	        classInfo2.classExtraInitializersName = factory2.createUniqueName("_classExtraInitializers", 16 /* Optimistic */ | 32 /* FileLevel */);
	        Debug.assertIsDefined(classInfo2.classThis);
	        classDefinitionStatements.push(
	          createLet(classInfo2.classDecoratorsName, factory2.createArrayLiteralExpression(classDecorators)),
	          createLet(classInfo2.classDescriptorName),
	          createLet(classInfo2.classExtraInitializersName, factory2.createArrayLiteralExpression()),
	          createLet(classInfo2.classThis)
	        );
	        if (classInfo2.hasStaticPrivateClassElements) {
	          shouldTransformPrivateStaticElementsInClass = true;
	          shouldTransformPrivateStaticElementsInFile = true;
	        }
	      }
	      const extendsClause = getHeritageClause(node.heritageClauses, 96 /* ExtendsKeyword */);
	      const extendsElement = extendsClause && firstOrUndefined(extendsClause.types);
	      const extendsExpression = extendsElement && visitNode(extendsElement.expression, visitor, isExpression);
	      if (extendsExpression) {
	        classInfo2.classSuper = factory2.createUniqueName("_classSuper", 16 /* Optimistic */ | 32 /* FileLevel */);
	        const unwrapped = skipOuterExpressions(extendsExpression);
	        const safeExtendsExpression = isClassExpression(unwrapped) && !unwrapped.name || isFunctionExpression(unwrapped) && !unwrapped.name || isArrowFunction(unwrapped) ? factory2.createComma(factory2.createNumericLiteral(0), extendsExpression) : extendsExpression;
	        classDefinitionStatements.push(createLet(classInfo2.classSuper, safeExtendsExpression));
	        const updatedExtendsElement = factory2.updateExpressionWithTypeArguments(
	          extendsElement,
	          classInfo2.classSuper,
	          /*typeArguments*/
	          void 0
	        );
	        const updatedExtendsClause = factory2.updateHeritageClause(extendsClause, [updatedExtendsElement]);
	        heritageClauses = factory2.createNodeArray([updatedExtendsClause]);
	      }
	      const renamedClassThis = classInfo2.classThis ?? factory2.createThis();
	      enterClass(classInfo2);
	      leadingBlockStatements = append(leadingBlockStatements, createMetadata(classInfo2.metadataReference, classInfo2.classSuper));
	      let members = node.members;
	      members = visitNodes2(members, (node2) => isConstructorDeclaration(node2) ? node2 : classElementVisitor(node2), isClassElement);
	      members = visitNodes2(members, (node2) => isConstructorDeclaration(node2) ? classElementVisitor(node2) : node2, isClassElement);
	      if (pendingExpressions) {
	        let outerThis;
	        for (let expression of pendingExpressions) {
	          expression = visitNode(expression, function thisVisitor(node2) {
	            if (!(node2.transformFlags & 16384 /* ContainsLexicalThis */)) {
	              return node2;
	            }
	            switch (node2.kind) {
	              case 110 /* ThisKeyword */:
	                if (!outerThis) {
	                  outerThis = factory2.createUniqueName("_outerThis", 16 /* Optimistic */);
	                  classDefinitionStatements.unshift(createLet(outerThis, factory2.createThis()));
	                }
	                return outerThis;
	              default:
	                return visitEachChild(node2, thisVisitor, context);
	            }
	          }, isExpression);
	          const statement = factory2.createExpressionStatement(expression);
	          leadingBlockStatements = append(leadingBlockStatements, statement);
	        }
	        pendingExpressions = void 0;
	      }
	      exitClass();
	      if (some(classInfo2.pendingInstanceInitializers) && !getFirstConstructorWithBody(node)) {
	        const initializerStatements = prepareConstructor(node, classInfo2);
	        if (initializerStatements) {
	          const extendsClauseElement = getEffectiveBaseTypeNode(node);
	          const isDerivedClass = !!(extendsClauseElement && skipOuterExpressions(extendsClauseElement.expression).kind !== 106 /* NullKeyword */);
	          const constructorStatements = [];
	          if (isDerivedClass) {
	            const spreadArguments = factory2.createSpreadElement(factory2.createIdentifier("arguments"));
	            const superCall = factory2.createCallExpression(
	              factory2.createSuper(),
	              /*typeArguments*/
	              void 0,
	              [spreadArguments]
	            );
	            constructorStatements.push(factory2.createExpressionStatement(superCall));
	          }
	          addRange(constructorStatements, initializerStatements);
	          const constructorBody = factory2.createBlock(
	            constructorStatements,
	            /*multiLine*/
	            true
	          );
	          syntheticConstructor = factory2.createConstructorDeclaration(
	            /*modifiers*/
	            void 0,
	            [],
	            constructorBody
	          );
	        }
	      }
	      if (classInfo2.staticMethodExtraInitializersName) {
	        classDefinitionStatements.push(
	          createLet(classInfo2.staticMethodExtraInitializersName, factory2.createArrayLiteralExpression())
	        );
	      }
	      if (classInfo2.instanceMethodExtraInitializersName) {
	        classDefinitionStatements.push(
	          createLet(classInfo2.instanceMethodExtraInitializersName, factory2.createArrayLiteralExpression())
	        );
	      }
	      if (classInfo2.memberInfos) {
	        forEachEntry(classInfo2.memberInfos, (memberInfo, member) => {
	          if (isStatic(member)) {
	            classDefinitionStatements.push(createLet(memberInfo.memberDecoratorsName));
	            if (memberInfo.memberInitializersName) {
	              classDefinitionStatements.push(createLet(memberInfo.memberInitializersName, factory2.createArrayLiteralExpression()));
	            }
	            if (memberInfo.memberExtraInitializersName) {
	              classDefinitionStatements.push(createLet(memberInfo.memberExtraInitializersName, factory2.createArrayLiteralExpression()));
	            }
	            if (memberInfo.memberDescriptorName) {
	              classDefinitionStatements.push(createLet(memberInfo.memberDescriptorName));
	            }
	          }
	        });
	      }
	      if (classInfo2.memberInfos) {
	        forEachEntry(classInfo2.memberInfos, (memberInfo, member) => {
	          if (!isStatic(member)) {
	            classDefinitionStatements.push(createLet(memberInfo.memberDecoratorsName));
	            if (memberInfo.memberInitializersName) {
	              classDefinitionStatements.push(createLet(memberInfo.memberInitializersName, factory2.createArrayLiteralExpression()));
	            }
	            if (memberInfo.memberExtraInitializersName) {
	              classDefinitionStatements.push(createLet(memberInfo.memberExtraInitializersName, factory2.createArrayLiteralExpression()));
	            }
	            if (memberInfo.memberDescriptorName) {
	              classDefinitionStatements.push(createLet(memberInfo.memberDescriptorName));
	            }
	          }
	        });
	      }
	      leadingBlockStatements = addRange(leadingBlockStatements, classInfo2.staticNonFieldDecorationStatements);
	      leadingBlockStatements = addRange(leadingBlockStatements, classInfo2.nonStaticNonFieldDecorationStatements);
	      leadingBlockStatements = addRange(leadingBlockStatements, classInfo2.staticFieldDecorationStatements);
	      leadingBlockStatements = addRange(leadingBlockStatements, classInfo2.nonStaticFieldDecorationStatements);
	      if (classInfo2.classDescriptorName && classInfo2.classDecoratorsName && classInfo2.classExtraInitializersName && classInfo2.classThis) {
	        leadingBlockStatements ?? (leadingBlockStatements = []);
	        const valueProperty = factory2.createPropertyAssignment("value", renamedClassThis);
	        const classDescriptor = factory2.createObjectLiteralExpression([valueProperty]);
	        const classDescriptorAssignment = factory2.createAssignment(classInfo2.classDescriptorName, classDescriptor);
	        const classNameReference = factory2.createPropertyAccessExpression(renamedClassThis, "name");
	        const esDecorateHelper2 = emitHelpers().createESDecorateHelper(
	          factory2.createNull(),
	          classDescriptorAssignment,
	          classInfo2.classDecoratorsName,
	          { kind: "class", name: classNameReference, metadata: classInfo2.metadataReference },
	          factory2.createNull(),
	          classInfo2.classExtraInitializersName
	        );
	        const esDecorateStatement = factory2.createExpressionStatement(esDecorateHelper2);
	        setSourceMapRange(esDecorateStatement, moveRangePastDecorators(node));
	        leadingBlockStatements.push(esDecorateStatement);
	        const classDescriptorValueReference = factory2.createPropertyAccessExpression(classInfo2.classDescriptorName, "value");
	        const classThisAssignment = factory2.createAssignment(classInfo2.classThis, classDescriptorValueReference);
	        const classReferenceAssignment = factory2.createAssignment(classReference, classThisAssignment);
	        leadingBlockStatements.push(factory2.createExpressionStatement(classReferenceAssignment));
	      }
	      leadingBlockStatements.push(createSymbolMetadata(renamedClassThis, classInfo2.metadataReference));
	      if (some(classInfo2.pendingStaticInitializers)) {
	        for (const initializer of classInfo2.pendingStaticInitializers) {
	          const initializerStatement = factory2.createExpressionStatement(initializer);
	          setSourceMapRange(initializerStatement, getSourceMapRange(initializer));
	          trailingBlockStatements = append(trailingBlockStatements, initializerStatement);
	        }
	        classInfo2.pendingStaticInitializers = void 0;
	      }
	      if (classInfo2.classExtraInitializersName) {
	        const runClassInitializersHelper = emitHelpers().createRunInitializersHelper(renamedClassThis, classInfo2.classExtraInitializersName);
	        const runClassInitializersStatement = factory2.createExpressionStatement(runClassInitializersHelper);
	        setSourceMapRange(runClassInitializersStatement, node.name ?? moveRangePastDecorators(node));
	        trailingBlockStatements = append(trailingBlockStatements, runClassInitializersStatement);
	      }
	      if (leadingBlockStatements && trailingBlockStatements && !classInfo2.hasStaticInitializers) {
	        addRange(leadingBlockStatements, trailingBlockStatements);
	        trailingBlockStatements = void 0;
	      }
	      const leadingStaticBlock = leadingBlockStatements && factory2.createClassStaticBlockDeclaration(factory2.createBlock(
	        leadingBlockStatements,
	        /*multiLine*/
	        true
	      ));
	      if (leadingStaticBlock && shouldTransformPrivateStaticElementsInClass) {
	        setInternalEmitFlags(leadingStaticBlock, 32 /* TransformPrivateStaticElements */);
	      }
	      const trailingStaticBlock = trailingBlockStatements && factory2.createClassStaticBlockDeclaration(factory2.createBlock(
	        trailingBlockStatements,
	        /*multiLine*/
	        true
	      ));
	      if (leadingStaticBlock || syntheticConstructor || trailingStaticBlock) {
	        const newMembers = [];
	        const existingNamedEvaluationHelperBlockIndex = members.findIndex(isClassNamedEvaluationHelperBlock);
	        if (leadingStaticBlock) {
	          addRange(newMembers, members, 0, existingNamedEvaluationHelperBlockIndex + 1);
	          newMembers.push(leadingStaticBlock);
	          addRange(newMembers, members, existingNamedEvaluationHelperBlockIndex + 1);
	        } else {
	          addRange(newMembers, members);
	        }
	        if (syntheticConstructor) {
	          newMembers.push(syntheticConstructor);
	        }
	        if (trailingStaticBlock) {
	          newMembers.push(trailingStaticBlock);
	        }
	        members = setTextRange(factory2.createNodeArray(newMembers), members);
	      }
	      const lexicalEnvironment = endLexicalEnvironment();
	      let classExpression;
	      if (classDecorators) {
	        classExpression = factory2.createClassExpression(
	          /*modifiers*/
	          void 0,
	          /*name*/
	          void 0,
	          /*typeParameters*/
	          void 0,
	          heritageClauses,
	          members
	        );
	        if (classInfo2.classThis) {
	          classExpression = injectClassThisAssignmentIfMissing(factory2, classExpression, classInfo2.classThis);
	        }
	        const classReferenceDeclaration = factory2.createVariableDeclaration(
	          classReference,
	          /*exclamationToken*/
	          void 0,
	          /*type*/
	          void 0,
	          classExpression
	        );
	        const classReferenceVarDeclList = factory2.createVariableDeclarationList([classReferenceDeclaration]);
	        const returnExpr = classInfo2.classThis ? factory2.createAssignment(classReference, classInfo2.classThis) : classReference;
	        classDefinitionStatements.push(
	          factory2.createVariableStatement(
	            /*modifiers*/
	            void 0,
	            classReferenceVarDeclList
	          ),
	          factory2.createReturnStatement(returnExpr)
	        );
	      } else {
	        classExpression = factory2.createClassExpression(
	          /*modifiers*/
	          void 0,
	          node.name,
	          /*typeParameters*/
	          void 0,
	          heritageClauses,
	          members
	        );
	        classDefinitionStatements.push(factory2.createReturnStatement(classExpression));
	      }
	      if (shouldTransformPrivateStaticElementsInClass) {
	        addInternalEmitFlags(classExpression, 32 /* TransformPrivateStaticElements */);
	        for (const member of classExpression.members) {
	          if ((isPrivateIdentifierClassElementDeclaration(member) || isAutoAccessorPropertyDeclaration(member)) && hasStaticModifier(member)) {
	            addInternalEmitFlags(member, 32 /* TransformPrivateStaticElements */);
	          }
	        }
	      }
	      setOriginalNode(classExpression, node);
	      return factory2.createImmediatelyInvokedArrowFunction(factory2.mergeLexicalEnvironment(classDefinitionStatements, lexicalEnvironment));
	    }
	    function isDecoratedClassLike(node) {
	      return classOrConstructorParameterIsDecorated(
	        /*useLegacyDecorators*/
	        false,
	        node
	      ) || childIsDecorated(
	        /*useLegacyDecorators*/
	        false,
	        node
	      );
	    }
	    function visitClassDeclaration(node) {
	      if (isDecoratedClassLike(node)) {
	        const statements = [];
	        const originalClass = getOriginalNode(node, isClassLike) ?? node;
	        const className = originalClass.name ? factory2.createStringLiteralFromNode(originalClass.name) : factory2.createStringLiteral("default");
	        const isExport = hasSyntacticModifier(node, 32 /* Export */);
	        const isDefault = hasSyntacticModifier(node, 2048 /* Default */);
	        if (!node.name) {
	          node = injectClassNamedEvaluationHelperBlockIfMissing(context, node, className);
	        }
	        if (isExport && isDefault) {
	          const iife = transformClassLike(node);
	          if (node.name) {
	            const varDecl = factory2.createVariableDeclaration(
	              factory2.getLocalName(node),
	              /*exclamationToken*/
	              void 0,
	              /*type*/
	              void 0,
	              iife
	            );
	            setOriginalNode(varDecl, node);
	            const varDecls = factory2.createVariableDeclarationList([varDecl], 1 /* Let */);
	            const varStatement = factory2.createVariableStatement(
	              /*modifiers*/
	              void 0,
	              varDecls
	            );
	            statements.push(varStatement);
	            const exportStatement = factory2.createExportDefault(factory2.getDeclarationName(node));
	            setOriginalNode(exportStatement, node);
	            setCommentRange(exportStatement, getCommentRange(node));
	            setSourceMapRange(exportStatement, moveRangePastDecorators(node));
	            statements.push(exportStatement);
	          } else {
	            const exportStatement = factory2.createExportDefault(iife);
	            setOriginalNode(exportStatement, node);
	            setCommentRange(exportStatement, getCommentRange(node));
	            setSourceMapRange(exportStatement, moveRangePastDecorators(node));
	            statements.push(exportStatement);
	          }
	        } else {
	          Debug.assertIsDefined(node.name, "A class declaration that is not a default export must have a name.");
	          const iife = transformClassLike(node);
	          const modifierVisitorNoExport = isExport ? (node2) => isExportModifier(node2) ? void 0 : modifierVisitor(node2) : modifierVisitor;
	          const modifiers = visitNodes2(node.modifiers, modifierVisitorNoExport, isModifier);
	          const declName = factory2.getLocalName(
	            node,
	            /*allowComments*/
	            false,
	            /*allowSourceMaps*/
	            true
	          );
	          const varDecl = factory2.createVariableDeclaration(
	            declName,
	            /*exclamationToken*/
	            void 0,
	            /*type*/
	            void 0,
	            iife
	          );
	          setOriginalNode(varDecl, node);
	          const varDecls = factory2.createVariableDeclarationList([varDecl], 1 /* Let */);
	          const varStatement = factory2.createVariableStatement(modifiers, varDecls);
	          setOriginalNode(varStatement, node);
	          setCommentRange(varStatement, getCommentRange(node));
	          statements.push(varStatement);
	          if (isExport) {
	            const exportStatement = factory2.createExternalModuleExport(declName);
	            setOriginalNode(exportStatement, node);
	            statements.push(exportStatement);
	          }
	        }
	        return singleOrMany(statements);
	      } else {
	        const modifiers = visitNodes2(node.modifiers, modifierVisitor, isModifier);
	        const heritageClauses = visitNodes2(node.heritageClauses, visitor, isHeritageClause);
	        enterClass(
	          /*classInfo*/
	          void 0
	        );
	        const members = visitNodes2(node.members, classElementVisitor, isClassElement);
	        exitClass();
	        return factory2.updateClassDeclaration(
	          node,
	          modifiers,
	          node.name,
	          /*typeParameters*/
	          void 0,
	          heritageClauses,
	          members
	        );
	      }
	    }
	    function visitClassExpression(node) {
	      if (isDecoratedClassLike(node)) {
	        const iife = transformClassLike(node);
	        setOriginalNode(iife, node);
	        return iife;
	      } else {
	        const modifiers = visitNodes2(node.modifiers, modifierVisitor, isModifier);
	        const heritageClauses = visitNodes2(node.heritageClauses, visitor, isHeritageClause);
	        enterClass(
	          /*classInfo*/
	          void 0
	        );
	        const members = visitNodes2(node.members, classElementVisitor, isClassElement);
	        exitClass();
	        return factory2.updateClassExpression(
	          node,
	          modifiers,
	          node.name,
	          /*typeParameters*/
	          void 0,
	          heritageClauses,
	          members
	        );
	      }
	    }
	    function prepareConstructor(_parent, classInfo2) {
	      if (some(classInfo2.pendingInstanceInitializers)) {
	        const statements = [];
	        statements.push(
	          factory2.createExpressionStatement(
	            factory2.inlineExpressions(classInfo2.pendingInstanceInitializers)
	          )
	        );
	        classInfo2.pendingInstanceInitializers = void 0;
	        return statements;
	      }
	    }
	    function transformConstructorBodyWorker(statementsOut, statementsIn, statementOffset, superPath, superPathDepth, initializerStatements) {
	      const superStatementIndex = superPath[superPathDepth];
	      const superStatement = statementsIn[superStatementIndex];
	      addRange(statementsOut, visitNodes2(statementsIn, visitor, isStatement, statementOffset, superStatementIndex - statementOffset));
	      if (isTryStatement(superStatement)) {
	        const tryBlockStatements = [];
	        transformConstructorBodyWorker(
	          tryBlockStatements,
	          superStatement.tryBlock.statements,
	          /*statementOffset*/
	          0,
	          superPath,
	          superPathDepth + 1,
	          initializerStatements
	        );
	        const tryBlockStatementsArray = factory2.createNodeArray(tryBlockStatements);
	        setTextRange(tryBlockStatementsArray, superStatement.tryBlock.statements);
	        statementsOut.push(factory2.updateTryStatement(
	          superStatement,
	          factory2.updateBlock(superStatement.tryBlock, tryBlockStatements),
	          visitNode(superStatement.catchClause, visitor, isCatchClause),
	          visitNode(superStatement.finallyBlock, visitor, isBlock)
	        ));
	      } else {
	        addRange(statementsOut, visitNodes2(statementsIn, visitor, isStatement, superStatementIndex, 1));
	        addRange(statementsOut, initializerStatements);
	      }
	      addRange(statementsOut, visitNodes2(statementsIn, visitor, isStatement, superStatementIndex + 1));
	    }
	    function visitConstructorDeclaration(node) {
	      enterClassElement(node);
	      const modifiers = visitNodes2(node.modifiers, modifierVisitor, isModifier);
	      const parameters = visitNodes2(node.parameters, visitor, isParameter);
	      let body;
	      if (node.body && classInfo) {
	        const initializerStatements = prepareConstructor(classInfo.class, classInfo);
	        if (initializerStatements) {
	          const statements = [];
	          const nonPrologueStart = factory2.copyPrologue(
	            node.body.statements,
	            statements,
	            /*ensureUseStrict*/
	            false,
	            visitor
	          );
	          const superStatementIndices = findSuperStatementIndexPath(node.body.statements, nonPrologueStart);
	          if (superStatementIndices.length > 0) {
	            transformConstructorBodyWorker(statements, node.body.statements, nonPrologueStart, superStatementIndices, 0, initializerStatements);
	          } else {
	            addRange(statements, initializerStatements);
	            addRange(statements, visitNodes2(node.body.statements, visitor, isStatement));
	          }
	          body = factory2.createBlock(
	            statements,
	            /*multiLine*/
	            true
	          );
	          setOriginalNode(body, node.body);
	          setTextRange(body, node.body);
	        }
	      }
	      body ?? (body = visitNode(node.body, visitor, isBlock));
	      exitClassElement();
	      return factory2.updateConstructorDeclaration(node, modifiers, parameters, body);
	    }
	    function finishClassElement(updated, original) {
	      if (updated !== original) {
	        setCommentRange(updated, original);
	        setSourceMapRange(updated, moveRangePastDecorators(original));
	      }
	      return updated;
	    }
	    function partialTransformClassElement(member, classInfo2, createDescriptor) {
	      let referencedName;
	      let name;
	      let initializersName;
	      let extraInitializersName;
	      let thisArg;
	      let descriptorName;
	      if (!classInfo2) {
	        const modifiers2 = visitNodes2(member.modifiers, modifierVisitor, isModifier);
	        enterName();
	        name = visitPropertyName(member.name);
	        exitName();
	        return { modifiers: modifiers2, referencedName, name, initializersName, descriptorName, thisArg };
	      }
	      const memberDecorators = transformAllDecoratorsOfDeclaration(getAllDecoratorsOfClassElement(
	        member,
	        classInfo2.class,
	        /*useLegacyDecorators*/
	        false
	      ));
	      const modifiers = visitNodes2(member.modifiers, modifierVisitor, isModifier);
	      if (memberDecorators) {
	        const memberDecoratorsName = createHelperVariable(member, "decorators");
	        const memberDecoratorsArray = factory2.createArrayLiteralExpression(memberDecorators);
	        const memberDecoratorsAssignment = factory2.createAssignment(memberDecoratorsName, memberDecoratorsArray);
	        const memberInfo = { memberDecoratorsName };
	        classInfo2.memberInfos ?? (classInfo2.memberInfos = /* @__PURE__ */ new Map());
	        classInfo2.memberInfos.set(member, memberInfo);
	        pendingExpressions ?? (pendingExpressions = []);
	        pendingExpressions.push(memberDecoratorsAssignment);
	        const statements = isMethodOrAccessor(member) || isAutoAccessorPropertyDeclaration(member) ? isStatic(member) ? classInfo2.staticNonFieldDecorationStatements ?? (classInfo2.staticNonFieldDecorationStatements = []) : classInfo2.nonStaticNonFieldDecorationStatements ?? (classInfo2.nonStaticNonFieldDecorationStatements = []) : isPropertyDeclaration(member) && !isAutoAccessorPropertyDeclaration(member) ? isStatic(member) ? classInfo2.staticFieldDecorationStatements ?? (classInfo2.staticFieldDecorationStatements = []) : classInfo2.nonStaticFieldDecorationStatements ?? (classInfo2.nonStaticFieldDecorationStatements = []) : Debug.fail();
	        const kind = isGetAccessorDeclaration(member) ? "getter" : isSetAccessorDeclaration(member) ? "setter" : isMethodDeclaration(member) ? "method" : isAutoAccessorPropertyDeclaration(member) ? "accessor" : isPropertyDeclaration(member) ? "field" : Debug.fail();
	        let propertyName;
	        if (isIdentifier(member.name) || isPrivateIdentifier(member.name)) {
	          propertyName = { computed: false, name: member.name };
	        } else if (isPropertyNameLiteral(member.name)) {
	          propertyName = { computed: true, name: factory2.createStringLiteralFromNode(member.name) };
	        } else {
	          const expression = member.name.expression;
	          if (isPropertyNameLiteral(expression) && !isIdentifier(expression)) {
	            propertyName = { computed: true, name: factory2.createStringLiteralFromNode(expression) };
	          } else {
	            enterName();
	            ({ referencedName, name } = visitReferencedPropertyName(member.name));
	            propertyName = { computed: true, name: referencedName };
	            exitName();
	          }
	        }
	        const context2 = {
	          kind,
	          name: propertyName,
	          static: isStatic(member),
	          private: isPrivateIdentifier(member.name),
	          access: {
	            // 15.7.3 CreateDecoratorAccessObject (kind, name)
	            // 2. If _kind_ is ~field~, ~method~, ~accessor~, or ~getter~, then ...
	            get: isPropertyDeclaration(member) || isGetAccessorDeclaration(member) || isMethodDeclaration(member),
	            // 3. If _kind_ is ~field~, ~accessor~, or ~setter~, then ...
	            set: isPropertyDeclaration(member) || isSetAccessorDeclaration(member)
	          },
	          metadata: classInfo2.metadataReference
	        };
	        if (isMethodOrAccessor(member)) {
	          const methodExtraInitializersName = isStatic(member) ? classInfo2.staticMethodExtraInitializersName : classInfo2.instanceMethodExtraInitializersName;
	          Debug.assertIsDefined(methodExtraInitializersName);
	          let descriptor;
	          if (isPrivateIdentifierClassElementDeclaration(member) && createDescriptor) {
	            descriptor = createDescriptor(member, visitNodes2(modifiers, (node) => tryCast(node, isAsyncModifier), isModifier));
	            memberInfo.memberDescriptorName = descriptorName = createHelperVariable(member, "descriptor");
	            descriptor = factory2.createAssignment(descriptorName, descriptor);
	          }
	          const esDecorateExpression = emitHelpers().createESDecorateHelper(factory2.createThis(), descriptor ?? factory2.createNull(), memberDecoratorsName, context2, factory2.createNull(), methodExtraInitializersName);
	          const esDecorateStatement = factory2.createExpressionStatement(esDecorateExpression);
	          setSourceMapRange(esDecorateStatement, moveRangePastDecorators(member));
	          statements.push(esDecorateStatement);
	        } else if (isPropertyDeclaration(member)) {
	          initializersName = memberInfo.memberInitializersName ?? (memberInfo.memberInitializersName = createHelperVariable(member, "initializers"));
	          extraInitializersName = memberInfo.memberExtraInitializersName ?? (memberInfo.memberExtraInitializersName = createHelperVariable(member, "extraInitializers"));
	          if (isStatic(member)) {
	            thisArg = classInfo2.classThis;
	          }
	          let descriptor;
	          if (isPrivateIdentifierClassElementDeclaration(member) && hasAccessorModifier(member) && createDescriptor) {
	            descriptor = createDescriptor(
	              member,
	              /*modifiers*/
	              void 0
	            );
	            memberInfo.memberDescriptorName = descriptorName = createHelperVariable(member, "descriptor");
	            descriptor = factory2.createAssignment(descriptorName, descriptor);
	          }
	          const esDecorateExpression = emitHelpers().createESDecorateHelper(
	            isAutoAccessorPropertyDeclaration(member) ? factory2.createThis() : factory2.createNull(),
	            descriptor ?? factory2.createNull(),
	            memberDecoratorsName,
	            context2,
	            initializersName,
	            extraInitializersName
	          );
	          const esDecorateStatement = factory2.createExpressionStatement(esDecorateExpression);
	          setSourceMapRange(esDecorateStatement, moveRangePastDecorators(member));
	          statements.push(esDecorateStatement);
	        }
	      }
	      if (name === void 0) {
	        enterName();
	        name = visitPropertyName(member.name);
	        exitName();
	      }
	      if (!some(modifiers) && (isMethodDeclaration(member) || isPropertyDeclaration(member))) {
	        setEmitFlags(name, 1024 /* NoLeadingComments */);
	      }
	      return { modifiers, referencedName, name, initializersName, extraInitializersName, descriptorName, thisArg };
	    }
	    function visitMethodDeclaration(node) {
	      enterClassElement(node);
	      const { modifiers, name, descriptorName } = partialTransformClassElement(node, classInfo, createMethodDescriptorObject);
	      if (descriptorName) {
	        exitClassElement();
	        return finishClassElement(createMethodDescriptorForwarder(modifiers, name, descriptorName), node);
	      } else {
	        const parameters = visitNodes2(node.parameters, visitor, isParameter);
	        const body = visitNode(node.body, visitor, isBlock);
	        exitClassElement();
	        return finishClassElement(factory2.updateMethodDeclaration(
	          node,
	          modifiers,
	          node.asteriskToken,
	          name,
	          /*questionToken*/
	          void 0,
	          /*typeParameters*/
	          void 0,
	          parameters,
	          /*type*/
	          void 0,
	          body
	        ), node);
	      }
	    }
	    function visitGetAccessorDeclaration(node) {
	      enterClassElement(node);
	      const { modifiers, name, descriptorName } = partialTransformClassElement(node, classInfo, createGetAccessorDescriptorObject);
	      if (descriptorName) {
	        exitClassElement();
	        return finishClassElement(createGetAccessorDescriptorForwarder(modifiers, name, descriptorName), node);
	      } else {
	        const parameters = visitNodes2(node.parameters, visitor, isParameter);
	        const body = visitNode(node.body, visitor, isBlock);
	        exitClassElement();
	        return finishClassElement(factory2.updateGetAccessorDeclaration(
	          node,
	          modifiers,
	          name,
	          parameters,
	          /*type*/
	          void 0,
	          body
	        ), node);
	      }
	    }
	    function visitSetAccessorDeclaration(node) {
	      enterClassElement(node);
	      const { modifiers, name, descriptorName } = partialTransformClassElement(node, classInfo, createSetAccessorDescriptorObject);
	      if (descriptorName) {
	        exitClassElement();
	        return finishClassElement(createSetAccessorDescriptorForwarder(modifiers, name, descriptorName), node);
	      } else {
	        const parameters = visitNodes2(node.parameters, visitor, isParameter);
	        const body = visitNode(node.body, visitor, isBlock);
	        exitClassElement();
	        return finishClassElement(factory2.updateSetAccessorDeclaration(node, modifiers, name, parameters, body), node);
	      }
	    }
	    function visitClassStaticBlockDeclaration(node) {
	      enterClassElement(node);
	      let result;
	      if (isClassNamedEvaluationHelperBlock(node)) {
	        result = visitEachChild(node, visitor, context);
	      } else if (isClassThisAssignmentBlock(node)) {
	        const savedClassThis = classThis;
	        classThis = void 0;
	        result = visitEachChild(node, visitor, context);
	        classThis = savedClassThis;
	      } else {
	        node = visitEachChild(node, visitor, context);
	        result = node;
	        if (classInfo) {
	          classInfo.hasStaticInitializers = true;
	          if (some(classInfo.pendingStaticInitializers)) {
	            const statements = [];
	            for (const initializer of classInfo.pendingStaticInitializers) {
	              const initializerStatement = factory2.createExpressionStatement(initializer);
	              setSourceMapRange(initializerStatement, getSourceMapRange(initializer));
	              statements.push(initializerStatement);
	            }
	            const body = factory2.createBlock(
	              statements,
	              /*multiLine*/
	              true
	            );
	            const staticBlock = factory2.createClassStaticBlockDeclaration(body);
	            result = [staticBlock, result];
	            classInfo.pendingStaticInitializers = void 0;
	          }
	        }
	      }
	      exitClassElement();
	      return result;
	    }
	    function visitPropertyDeclaration(node) {
	      if (isNamedEvaluation(node, isAnonymousClassNeedingAssignedName)) {
	        node = transformNamedEvaluation(context, node, canIgnoreEmptyStringLiteralInAssignedName(node.initializer));
	      }
	      enterClassElement(node);
	      Debug.assert(!isAmbientPropertyDeclaration(node), "Not yet implemented.");
	      const { modifiers, name, initializersName, extraInitializersName, descriptorName, thisArg } = partialTransformClassElement(node, classInfo, hasAccessorModifier(node) ? createAccessorPropertyDescriptorObject : void 0);
	      startLexicalEnvironment();
	      let initializer = visitNode(node.initializer, visitor, isExpression);
	      if (initializersName) {
	        initializer = emitHelpers().createRunInitializersHelper(
	          thisArg ?? factory2.createThis(),
	          initializersName,
	          initializer ?? factory2.createVoidZero()
	        );
	      }
	      if (isStatic(node) && classInfo && initializer) {
	        classInfo.hasStaticInitializers = true;
	      }
	      const declarations = endLexicalEnvironment();
	      if (some(declarations)) {
	        initializer = factory2.createImmediatelyInvokedArrowFunction([
	          ...declarations,
	          factory2.createReturnStatement(initializer)
	        ]);
	      }
	      if (classInfo) {
	        if (isStatic(node)) {
	          initializer = injectPendingInitializers(
	            classInfo,
	            /*isStatic*/
	            true,
	            initializer
	          );
	          if (extraInitializersName) {
	            classInfo.pendingStaticInitializers ?? (classInfo.pendingStaticInitializers = []);
	            classInfo.pendingStaticInitializers.push(
	              emitHelpers().createRunInitializersHelper(
	                classInfo.classThis ?? factory2.createThis(),
	                extraInitializersName
	              )
	            );
	          }
	        } else {
	          initializer = injectPendingInitializers(
	            classInfo,
	            /*isStatic*/
	            false,
	            initializer
	          );
	          if (extraInitializersName) {
	            classInfo.pendingInstanceInitializers ?? (classInfo.pendingInstanceInitializers = []);
	            classInfo.pendingInstanceInitializers.push(
	              emitHelpers().createRunInitializersHelper(
	                factory2.createThis(),
	                extraInitializersName
	              )
	            );
	          }
	        }
	      }
	      exitClassElement();
	      if (hasAccessorModifier(node) && descriptorName) {
	        const commentRange = getCommentRange(node);
	        const sourceMapRange = getSourceMapRange(node);
	        const name2 = node.name;
	        let getterName = name2;
	        let setterName = name2;
	        if (isComputedPropertyName(name2) && !isSimpleInlineableExpression(name2.expression)) {
	          const cacheAssignment = findComputedPropertyNameCacheAssignment(name2);
	          if (cacheAssignment) {
	            getterName = factory2.updateComputedPropertyName(name2, visitNode(name2.expression, visitor, isExpression));
	            setterName = factory2.updateComputedPropertyName(name2, cacheAssignment.left);
	          } else {
	            const temp = factory2.createTempVariable(hoistVariableDeclaration);
	            setSourceMapRange(temp, name2.expression);
	            const expression = visitNode(name2.expression, visitor, isExpression);
	            const assignment = factory2.createAssignment(temp, expression);
	            setSourceMapRange(assignment, name2.expression);
	            getterName = factory2.updateComputedPropertyName(name2, assignment);
	            setterName = factory2.updateComputedPropertyName(name2, temp);
	          }
	        }
	        const modifiersWithoutAccessor = visitNodes2(modifiers, (node2) => node2.kind !== 129 /* AccessorKeyword */ ? node2 : void 0, isModifier);
	        const backingField = createAccessorPropertyBackingField(factory2, node, modifiersWithoutAccessor, initializer);
	        setOriginalNode(backingField, node);
	        setEmitFlags(backingField, 3072 /* NoComments */);
	        setSourceMapRange(backingField, sourceMapRange);
	        setSourceMapRange(backingField.name, node.name);
	        const getter = createGetAccessorDescriptorForwarder(modifiersWithoutAccessor, getterName, descriptorName);
	        setOriginalNode(getter, node);
	        setCommentRange(getter, commentRange);
	        setSourceMapRange(getter, sourceMapRange);
	        const setter = createSetAccessorDescriptorForwarder(modifiersWithoutAccessor, setterName, descriptorName);
	        setOriginalNode(setter, node);
	        setEmitFlags(setter, 3072 /* NoComments */);
	        setSourceMapRange(setter, sourceMapRange);
	        return [backingField, getter, setter];
	      }
	      return finishClassElement(factory2.updatePropertyDeclaration(
	        node,
	        modifiers,
	        name,
	        /*questionOrExclamationToken*/
	        void 0,
	        /*type*/
	        void 0,
	        initializer
	      ), node);
	    }
	    function visitThisExpression(node) {
	      return classThis ?? node;
	    }
	    function visitCallExpression(node) {
	      if (isSuperProperty(node.expression) && classThis) {
	        const expression = visitNode(node.expression, visitor, isExpression);
	        const argumentsList = visitNodes2(node.arguments, visitor, isExpression);
	        const invocation = factory2.createFunctionCallCall(expression, classThis, argumentsList);
	        setOriginalNode(invocation, node);
	        setTextRange(invocation, node);
	        return invocation;
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitTaggedTemplateExpression(node) {
	      if (isSuperProperty(node.tag) && classThis) {
	        const tag = visitNode(node.tag, visitor, isExpression);
	        const boundTag = factory2.createFunctionBindCall(tag, classThis, []);
	        setOriginalNode(boundTag, node);
	        setTextRange(boundTag, node);
	        const template = visitNode(node.template, visitor, isTemplateLiteral);
	        return factory2.updateTaggedTemplateExpression(
	          node,
	          boundTag,
	          /*typeArguments*/
	          void 0,
	          template
	        );
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitPropertyAccessExpression(node) {
	      if (isSuperProperty(node) && isIdentifier(node.name) && classThis && classSuper) {
	        const propertyName = factory2.createStringLiteralFromNode(node.name);
	        const superProperty = factory2.createReflectGetCall(classSuper, propertyName, classThis);
	        setOriginalNode(superProperty, node.expression);
	        setTextRange(superProperty, node.expression);
	        return superProperty;
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitElementAccessExpression(node) {
	      if (isSuperProperty(node) && classThis && classSuper) {
	        const propertyName = visitNode(node.argumentExpression, visitor, isExpression);
	        const superProperty = factory2.createReflectGetCall(classSuper, propertyName, classThis);
	        setOriginalNode(superProperty, node.expression);
	        setTextRange(superProperty, node.expression);
	        return superProperty;
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitParameterDeclaration(node) {
	      if (isNamedEvaluation(node, isAnonymousClassNeedingAssignedName)) {
	        node = transformNamedEvaluation(context, node, canIgnoreEmptyStringLiteralInAssignedName(node.initializer));
	      }
	      const updated = factory2.updateParameterDeclaration(
	        node,
	        /*modifiers*/
	        void 0,
	        node.dotDotDotToken,
	        visitNode(node.name, visitor, isBindingName),
	        /*questionToken*/
	        void 0,
	        /*type*/
	        void 0,
	        visitNode(node.initializer, visitor, isExpression)
	      );
	      if (updated !== node) {
	        setCommentRange(updated, node);
	        setTextRange(updated, moveRangePastModifiers(node));
	        setSourceMapRange(updated, moveRangePastModifiers(node));
	        setEmitFlags(updated.name, 64 /* NoTrailingSourceMap */);
	      }
	      return updated;
	    }
	    function isAnonymousClassNeedingAssignedName(node) {
	      return isClassExpression(node) && !node.name && isDecoratedClassLike(node);
	    }
	    function canIgnoreEmptyStringLiteralInAssignedName(node) {
	      const innerExpression = skipOuterExpressions(node);
	      return isClassExpression(innerExpression) && !innerExpression.name && !classOrConstructorParameterIsDecorated(
	        /*useLegacyDecorators*/
	        false,
	        innerExpression
	      );
	    }
	    function visitForStatement(node) {
	      return factory2.updateForStatement(
	        node,
	        visitNode(node.initializer, discardedValueVisitor, isForInitializer),
	        visitNode(node.condition, visitor, isExpression),
	        visitNode(node.incrementor, discardedValueVisitor, isExpression),
	        visitIterationBody(node.statement, visitor, context)
	      );
	    }
	    function visitExpressionStatement(node) {
	      return visitEachChild(node, discardedValueVisitor, context);
	    }
	    function visitBinaryExpression(node, discarded) {
	      if (isDestructuringAssignment(node)) {
	        const left = visitAssignmentPattern(node.left);
	        const right = visitNode(node.right, visitor, isExpression);
	        return factory2.updateBinaryExpression(node, left, node.operatorToken, right);
	      }
	      if (isAssignmentExpression(node)) {
	        if (isNamedEvaluation(node, isAnonymousClassNeedingAssignedName)) {
	          node = transformNamedEvaluation(context, node, canIgnoreEmptyStringLiteralInAssignedName(node.right));
	          return visitEachChild(node, visitor, context);
	        }
	        if (isSuperProperty(node.left) && classThis && classSuper) {
	          let setterName = isElementAccessExpression(node.left) ? visitNode(node.left.argumentExpression, visitor, isExpression) : isIdentifier(node.left.name) ? factory2.createStringLiteralFromNode(node.left.name) : void 0;
	          if (setterName) {
	            let expression = visitNode(node.right, visitor, isExpression);
	            if (isCompoundAssignment(node.operatorToken.kind)) {
	              let getterName = setterName;
	              if (!isSimpleInlineableExpression(setterName)) {
	                getterName = factory2.createTempVariable(hoistVariableDeclaration);
	                setterName = factory2.createAssignment(getterName, setterName);
	              }
	              const superPropertyGet = factory2.createReflectGetCall(
	                classSuper,
	                getterName,
	                classThis
	              );
	              setOriginalNode(superPropertyGet, node.left);
	              setTextRange(superPropertyGet, node.left);
	              expression = factory2.createBinaryExpression(
	                superPropertyGet,
	                getNonAssignmentOperatorForCompoundAssignment(node.operatorToken.kind),
	                expression
	              );
	              setTextRange(expression, node);
	            }
	            const temp = discarded ? void 0 : factory2.createTempVariable(hoistVariableDeclaration);
	            if (temp) {
	              expression = factory2.createAssignment(temp, expression);
	              setTextRange(temp, node);
	            }
	            expression = factory2.createReflectSetCall(
	              classSuper,
	              setterName,
	              expression,
	              classThis
	            );
	            setOriginalNode(expression, node);
	            setTextRange(expression, node);
	            if (temp) {
	              expression = factory2.createComma(expression, temp);
	              setTextRange(expression, node);
	            }
	            return expression;
	          }
	        }
	      }
	      if (node.operatorToken.kind === 28 /* CommaToken */) {
	        const left = visitNode(node.left, discardedValueVisitor, isExpression);
	        const right = visitNode(node.right, discarded ? discardedValueVisitor : visitor, isExpression);
	        return factory2.updateBinaryExpression(node, left, node.operatorToken, right);
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitPreOrPostfixUnaryExpression(node, discarded) {
	      if (node.operator === 46 /* PlusPlusToken */ || node.operator === 47 /* MinusMinusToken */) {
	        const operand = skipParentheses(node.operand);
	        if (isSuperProperty(operand) && classThis && classSuper) {
	          let setterName = isElementAccessExpression(operand) ? visitNode(operand.argumentExpression, visitor, isExpression) : isIdentifier(operand.name) ? factory2.createStringLiteralFromNode(operand.name) : void 0;
	          if (setterName) {
	            let getterName = setterName;
	            if (!isSimpleInlineableExpression(setterName)) {
	              getterName = factory2.createTempVariable(hoistVariableDeclaration);
	              setterName = factory2.createAssignment(getterName, setterName);
	            }
	            let expression = factory2.createReflectGetCall(classSuper, getterName, classThis);
	            setOriginalNode(expression, node);
	            setTextRange(expression, node);
	            const temp = discarded ? void 0 : factory2.createTempVariable(hoistVariableDeclaration);
	            expression = expandPreOrPostfixIncrementOrDecrementExpression(factory2, node, expression, hoistVariableDeclaration, temp);
	            expression = factory2.createReflectSetCall(classSuper, setterName, expression, classThis);
	            setOriginalNode(expression, node);
	            setTextRange(expression, node);
	            if (temp) {
	              expression = factory2.createComma(expression, temp);
	              setTextRange(expression, node);
	            }
	            return expression;
	          }
	        }
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitCommaListExpression(node, discarded) {
	      const elements = discarded ? visitCommaListElements(node.elements, discardedValueVisitor) : visitCommaListElements(node.elements, visitor, discardedValueVisitor);
	      return factory2.updateCommaListExpression(node, elements);
	    }
	    function visitReferencedPropertyName(node) {
	      if (isPropertyNameLiteral(node) || isPrivateIdentifier(node)) {
	        const referencedName2 = factory2.createStringLiteralFromNode(node);
	        const name2 = visitNode(node, visitor, isPropertyName);
	        return { referencedName: referencedName2, name: name2 };
	      }
	      if (isPropertyNameLiteral(node.expression) && !isIdentifier(node.expression)) {
	        const referencedName2 = factory2.createStringLiteralFromNode(node.expression);
	        const name2 = visitNode(node, visitor, isPropertyName);
	        return { referencedName: referencedName2, name: name2 };
	      }
	      const referencedName = factory2.getGeneratedNameForNode(node);
	      hoistVariableDeclaration(referencedName);
	      const key = emitHelpers().createPropKeyHelper(visitNode(node.expression, visitor, isExpression));
	      const assignment = factory2.createAssignment(referencedName, key);
	      const name = factory2.updateComputedPropertyName(node, injectPendingExpressions(assignment));
	      return { referencedName, name };
	    }
	    function visitPropertyName(node) {
	      if (isComputedPropertyName(node)) {
	        return visitComputedPropertyName(node);
	      }
	      return visitNode(node, visitor, isPropertyName);
	    }
	    function visitComputedPropertyName(node) {
	      let expression = visitNode(node.expression, visitor, isExpression);
	      if (!isSimpleInlineableExpression(expression)) {
	        expression = injectPendingExpressions(expression);
	      }
	      return factory2.updateComputedPropertyName(node, expression);
	    }
	    function visitPropertyAssignment(node) {
	      if (isNamedEvaluation(node, isAnonymousClassNeedingAssignedName)) {
	        node = transformNamedEvaluation(context, node, canIgnoreEmptyStringLiteralInAssignedName(node.initializer));
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitVariableDeclaration(node) {
	      if (isNamedEvaluation(node, isAnonymousClassNeedingAssignedName)) {
	        node = transformNamedEvaluation(context, node, canIgnoreEmptyStringLiteralInAssignedName(node.initializer));
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitBindingElement(node) {
	      if (isNamedEvaluation(node, isAnonymousClassNeedingAssignedName)) {
	        node = transformNamedEvaluation(context, node, canIgnoreEmptyStringLiteralInAssignedName(node.initializer));
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitDestructuringAssignmentTarget(node) {
	      if (isObjectLiteralExpression(node) || isArrayLiteralExpression(node)) {
	        return visitAssignmentPattern(node);
	      }
	      if (isSuperProperty(node) && classThis && classSuper) {
	        const propertyName = isElementAccessExpression(node) ? visitNode(node.argumentExpression, visitor, isExpression) : isIdentifier(node.name) ? factory2.createStringLiteralFromNode(node.name) : void 0;
	        if (propertyName) {
	          const paramName = factory2.createTempVariable(
	            /*recordTempVariable*/
	            void 0
	          );
	          const expression = factory2.createAssignmentTargetWrapper(
	            paramName,
	            factory2.createReflectSetCall(
	              classSuper,
	              propertyName,
	              paramName,
	              classThis
	            )
	          );
	          setOriginalNode(expression, node);
	          setTextRange(expression, node);
	          return expression;
	        }
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitAssignmentElement(node) {
	      if (isAssignmentExpression(
	        node,
	        /*excludeCompoundAssignment*/
	        true
	      )) {
	        if (isNamedEvaluation(node, isAnonymousClassNeedingAssignedName)) {
	          node = transformNamedEvaluation(context, node, canIgnoreEmptyStringLiteralInAssignedName(node.right));
	        }
	        const assignmentTarget = visitDestructuringAssignmentTarget(node.left);
	        const initializer = visitNode(node.right, visitor, isExpression);
	        return factory2.updateBinaryExpression(node, assignmentTarget, node.operatorToken, initializer);
	      } else {
	        return visitDestructuringAssignmentTarget(node);
	      }
	    }
	    function visitAssignmentRestElement(node) {
	      if (isLeftHandSideExpression(node.expression)) {
	        const expression = visitDestructuringAssignmentTarget(node.expression);
	        return factory2.updateSpreadElement(node, expression);
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitArrayAssignmentElement(node) {
	      Debug.assertNode(node, isArrayBindingOrAssignmentElement);
	      if (isSpreadElement(node))
	        return visitAssignmentRestElement(node);
	      if (!isOmittedExpression(node))
	        return visitAssignmentElement(node);
	      return visitEachChild(node, visitor, context);
	    }
	    function visitAssignmentProperty(node) {
	      const name = visitNode(node.name, visitor, isPropertyName);
	      if (isAssignmentExpression(
	        node.initializer,
	        /*excludeCompoundAssignment*/
	        true
	      )) {
	        const assignmentElement = visitAssignmentElement(node.initializer);
	        return factory2.updatePropertyAssignment(node, name, assignmentElement);
	      }
	      if (isLeftHandSideExpression(node.initializer)) {
	        const assignmentElement = visitDestructuringAssignmentTarget(node.initializer);
	        return factory2.updatePropertyAssignment(node, name, assignmentElement);
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitShorthandAssignmentProperty(node) {
	      if (isNamedEvaluation(node, isAnonymousClassNeedingAssignedName)) {
	        node = transformNamedEvaluation(context, node, canIgnoreEmptyStringLiteralInAssignedName(node.objectAssignmentInitializer));
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitAssignmentRestProperty(node) {
	      if (isLeftHandSideExpression(node.expression)) {
	        const expression = visitDestructuringAssignmentTarget(node.expression);
	        return factory2.updateSpreadAssignment(node, expression);
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitObjectAssignmentElement(node) {
	      Debug.assertNode(node, isObjectBindingOrAssignmentElement);
	      if (isSpreadAssignment(node))
	        return visitAssignmentRestProperty(node);
	      if (isShorthandPropertyAssignment(node))
	        return visitShorthandAssignmentProperty(node);
	      if (isPropertyAssignment(node))
	        return visitAssignmentProperty(node);
	      return visitEachChild(node, visitor, context);
	    }
	    function visitAssignmentPattern(node) {
	      if (isArrayLiteralExpression(node)) {
	        const elements = visitNodes2(node.elements, visitArrayAssignmentElement, isExpression);
	        return factory2.updateArrayLiteralExpression(node, elements);
	      } else {
	        const properties = visitNodes2(node.properties, visitObjectAssignmentElement, isObjectLiteralElementLike);
	        return factory2.updateObjectLiteralExpression(node, properties);
	      }
	    }
	    function visitExportAssignment(node) {
	      if (isNamedEvaluation(node, isAnonymousClassNeedingAssignedName)) {
	        node = transformNamedEvaluation(context, node, canIgnoreEmptyStringLiteralInAssignedName(node.expression));
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitParenthesizedExpression(node, discarded) {
	      const visitorFunc = discarded ? discardedValueVisitor : visitor;
	      const expression = visitNode(node.expression, visitorFunc, isExpression);
	      return factory2.updateParenthesizedExpression(node, expression);
	    }
	    function visitPartiallyEmittedExpression(node, discarded) {
	      const visitorFunc = discarded ? discardedValueVisitor : visitor;
	      const expression = visitNode(node.expression, visitorFunc, isExpression);
	      return factory2.updatePartiallyEmittedExpression(node, expression);
	    }
	    function injectPendingExpressionsCommon(pendingExpressions2, expression) {
	      if (some(pendingExpressions2)) {
	        if (expression) {
	          if (isParenthesizedExpression(expression)) {
	            pendingExpressions2.push(expression.expression);
	            expression = factory2.updateParenthesizedExpression(expression, factory2.inlineExpressions(pendingExpressions2));
	          } else {
	            pendingExpressions2.push(expression);
	            expression = factory2.inlineExpressions(pendingExpressions2);
	          }
	        } else {
	          expression = factory2.inlineExpressions(pendingExpressions2);
	        }
	      }
	      return expression;
	    }
	    function injectPendingExpressions(expression) {
	      const result = injectPendingExpressionsCommon(pendingExpressions, expression);
	      Debug.assertIsDefined(result);
	      if (result !== expression) {
	        pendingExpressions = void 0;
	      }
	      return result;
	    }
	    function injectPendingInitializers(classInfo2, isStatic2, expression) {
	      const result = injectPendingExpressionsCommon(isStatic2 ? classInfo2.pendingStaticInitializers : classInfo2.pendingInstanceInitializers, expression);
	      if (result !== expression) {
	        if (isStatic2) {
	          classInfo2.pendingStaticInitializers = void 0;
	        } else {
	          classInfo2.pendingInstanceInitializers = void 0;
	        }
	      }
	      return result;
	    }
	    function transformAllDecoratorsOfDeclaration(allDecorators) {
	      if (!allDecorators) {
	        return void 0;
	      }
	      const decoratorExpressions = [];
	      addRange(decoratorExpressions, map(allDecorators.decorators, transformDecorator));
	      return decoratorExpressions;
	    }
	    function transformDecorator(decorator) {
	      const expression = visitNode(decorator.expression, visitor, isExpression);
	      setEmitFlags(expression, 3072 /* NoComments */);
	      const innerExpression = skipOuterExpressions(expression);
	      if (isAccessExpression(innerExpression)) {
	        const { target, thisArg } = factory2.createCallBinding(
	          expression,
	          hoistVariableDeclaration,
	          languageVersion,
	          /*cacheIdentifiers*/
	          true
	        );
	        return factory2.restoreOuterExpressions(expression, factory2.createFunctionBindCall(target, thisArg, []));
	      }
	      return expression;
	    }
	    function createDescriptorMethod(original, name, modifiers, asteriskToken, kind, parameters, body) {
	      const func = factory2.createFunctionExpression(
	        modifiers,
	        asteriskToken,
	        /*name*/
	        void 0,
	        /*typeParameters*/
	        void 0,
	        parameters,
	        /*type*/
	        void 0,
	        body ?? factory2.createBlock([])
	      );
	      setOriginalNode(func, original);
	      setSourceMapRange(func, moveRangePastDecorators(original));
	      setEmitFlags(func, 3072 /* NoComments */);
	      const prefix = kind === "get" || kind === "set" ? kind : void 0;
	      const functionName = factory2.createStringLiteralFromNode(
	        name,
	        /*isSingleQuote*/
	        void 0
	      );
	      const namedFunction = emitHelpers().createSetFunctionNameHelper(func, functionName, prefix);
	      const method = factory2.createPropertyAssignment(factory2.createIdentifier(kind), namedFunction);
	      setOriginalNode(method, original);
	      setSourceMapRange(method, moveRangePastDecorators(original));
	      setEmitFlags(method, 3072 /* NoComments */);
	      return method;
	    }
	    function createMethodDescriptorObject(node, modifiers) {
	      return factory2.createObjectLiteralExpression([
	        createDescriptorMethod(
	          node,
	          node.name,
	          modifiers,
	          node.asteriskToken,
	          "value",
	          visitNodes2(node.parameters, visitor, isParameter),
	          visitNode(node.body, visitor, isBlock)
	        )
	      ]);
	    }
	    function createGetAccessorDescriptorObject(node, modifiers) {
	      return factory2.createObjectLiteralExpression([
	        createDescriptorMethod(
	          node,
	          node.name,
	          modifiers,
	          /*asteriskToken*/
	          void 0,
	          "get",
	          [],
	          visitNode(node.body, visitor, isBlock)
	        )
	      ]);
	    }
	    function createSetAccessorDescriptorObject(node, modifiers) {
	      return factory2.createObjectLiteralExpression([
	        createDescriptorMethod(
	          node,
	          node.name,
	          modifiers,
	          /*asteriskToken*/
	          void 0,
	          "set",
	          visitNodes2(node.parameters, visitor, isParameter),
	          visitNode(node.body, visitor, isBlock)
	        )
	      ]);
	    }
	    function createAccessorPropertyDescriptorObject(node, modifiers) {
	      return factory2.createObjectLiteralExpression([
	        createDescriptorMethod(
	          node,
	          node.name,
	          modifiers,
	          /*asteriskToken*/
	          void 0,
	          "get",
	          [],
	          factory2.createBlock([
	            factory2.createReturnStatement(
	              factory2.createPropertyAccessExpression(
	                factory2.createThis(),
	                factory2.getGeneratedPrivateNameForNode(node.name)
	              )
	            )
	          ])
	        ),
	        createDescriptorMethod(
	          node,
	          node.name,
	          modifiers,
	          /*asteriskToken*/
	          void 0,
	          "set",
	          [factory2.createParameterDeclaration(
	            /*modifiers*/
	            void 0,
	            /*dotDotDotToken*/
	            void 0,
	            "value"
	          )],
	          factory2.createBlock([
	            factory2.createExpressionStatement(
	              factory2.createAssignment(
	                factory2.createPropertyAccessExpression(
	                  factory2.createThis(),
	                  factory2.getGeneratedPrivateNameForNode(node.name)
	                ),
	                factory2.createIdentifier("value")
	              )
	            )
	          ])
	        )
	      ]);
	    }
	    function createMethodDescriptorForwarder(modifiers, name, descriptorName) {
	      modifiers = visitNodes2(modifiers, (node) => isStaticModifier(node) ? node : void 0, isModifier);
	      return factory2.createGetAccessorDeclaration(
	        modifiers,
	        name,
	        [],
	        /*type*/
	        void 0,
	        factory2.createBlock([
	          factory2.createReturnStatement(
	            factory2.createPropertyAccessExpression(
	              descriptorName,
	              factory2.createIdentifier("value")
	            )
	          )
	        ])
	      );
	    }
	    function createGetAccessorDescriptorForwarder(modifiers, name, descriptorName) {
	      modifiers = visitNodes2(modifiers, (node) => isStaticModifier(node) ? node : void 0, isModifier);
	      return factory2.createGetAccessorDeclaration(
	        modifiers,
	        name,
	        [],
	        /*type*/
	        void 0,
	        factory2.createBlock([
	          factory2.createReturnStatement(
	            factory2.createFunctionCallCall(
	              factory2.createPropertyAccessExpression(
	                descriptorName,
	                factory2.createIdentifier("get")
	              ),
	              factory2.createThis(),
	              []
	            )
	          )
	        ])
	      );
	    }
	    function createSetAccessorDescriptorForwarder(modifiers, name, descriptorName) {
	      modifiers = visitNodes2(modifiers, (node) => isStaticModifier(node) ? node : void 0, isModifier);
	      return factory2.createSetAccessorDeclaration(
	        modifiers,
	        name,
	        [factory2.createParameterDeclaration(
	          /*modifiers*/
	          void 0,
	          /*dotDotDotToken*/
	          void 0,
	          "value"
	        )],
	        factory2.createBlock([
	          factory2.createReturnStatement(
	            factory2.createFunctionCallCall(
	              factory2.createPropertyAccessExpression(
	                descriptorName,
	                factory2.createIdentifier("set")
	              ),
	              factory2.createThis(),
	              [factory2.createIdentifier("value")]
	            )
	          )
	        ])
	      );
	    }
	    function createMetadata(name, classSuper2) {
	      const varDecl = factory2.createVariableDeclaration(
	        name,
	        /*exclamationToken*/
	        void 0,
	        /*type*/
	        void 0,
	        factory2.createConditionalExpression(
	          factory2.createLogicalAnd(
	            factory2.createTypeCheck(factory2.createIdentifier("Symbol"), "function"),
	            factory2.createPropertyAccessExpression(factory2.createIdentifier("Symbol"), "metadata")
	          ),
	          factory2.createToken(58 /* QuestionToken */),
	          factory2.createCallExpression(
	            factory2.createPropertyAccessExpression(factory2.createIdentifier("Object"), "create"),
	            /*typeArguments*/
	            void 0,
	            [classSuper2 ? createSymbolMetadataReference(classSuper2) : factory2.createNull()]
	          ),
	          factory2.createToken(59 /* ColonToken */),
	          factory2.createVoidZero()
	        )
	      );
	      return factory2.createVariableStatement(
	        /*modifiers*/
	        void 0,
	        factory2.createVariableDeclarationList([varDecl], 2 /* Const */)
	      );
	    }
	    function createSymbolMetadata(target, value) {
	      const defineProperty = factory2.createObjectDefinePropertyCall(
	        target,
	        factory2.createPropertyAccessExpression(factory2.createIdentifier("Symbol"), "metadata"),
	        factory2.createPropertyDescriptor(
	          { configurable: true, writable: true, enumerable: true, value },
	          /*singleLine*/
	          true
	        )
	      );
	      return setEmitFlags(
	        factory2.createIfStatement(value, factory2.createExpressionStatement(defineProperty)),
	        1 /* SingleLine */
	      );
	    }
	    function createSymbolMetadataReference(classSuper2) {
	      return factory2.createBinaryExpression(
	        factory2.createElementAccessExpression(
	          classSuper2,
	          factory2.createPropertyAccessExpression(factory2.createIdentifier("Symbol"), "metadata")
	        ),
	        61 /* QuestionQuestionToken */,
	        factory2.createNull()
	      );
	    }
	  }
	  var init_esDecorators = __esm({
	    "src/compiler/transformers/esDecorators.ts"() {
	      init_ts2();
	    }
	  });

	  // src/compiler/transformers/es2017.ts
	  function transformES2017(context) {
	    const {
	      factory: factory2,
	      getEmitHelperFactory: emitHelpers,
	      resumeLexicalEnvironment,
	      endLexicalEnvironment,
	      hoistVariableDeclaration
	    } = context;
	    const resolver = context.getEmitResolver();
	    const compilerOptions = context.getCompilerOptions();
	    const languageVersion = getEmitScriptTarget(compilerOptions);
	    let enabledSubstitutions;
	    let enclosingSuperContainerFlags = 0;
	    let enclosingFunctionParameterNames;
	    let capturedSuperProperties;
	    let hasSuperElementAccess;
	    let lexicalArgumentsBinding;
	    const substitutedSuperAccessors = [];
	    let contextFlags = 0 /* None */;
	    const previousOnEmitNode = context.onEmitNode;
	    const previousOnSubstituteNode = context.onSubstituteNode;
	    context.onEmitNode = onEmitNode;
	    context.onSubstituteNode = onSubstituteNode;
	    return chainBundle(context, transformSourceFile);
	    function transformSourceFile(node) {
	      if (node.isDeclarationFile) {
	        return node;
	      }
	      setContextFlag(1 /* NonTopLevel */, false);
	      setContextFlag(2 /* HasLexicalThis */, !isEffectiveStrictModeSourceFile(node, compilerOptions));
	      const visited = visitEachChild(node, visitor, context);
	      addEmitHelpers(visited, context.readEmitHelpers());
	      return visited;
	    }
	    function setContextFlag(flag, val) {
	      contextFlags = val ? contextFlags | flag : contextFlags & ~flag;
	    }
	    function inContext(flags) {
	      return (contextFlags & flags) !== 0;
	    }
	    function inTopLevelContext() {
	      return !inContext(1 /* NonTopLevel */);
	    }
	    function inHasLexicalThisContext() {
	      return inContext(2 /* HasLexicalThis */);
	    }
	    function doWithContext(flags, cb, value) {
	      const contextFlagsToSet = flags & ~contextFlags;
	      if (contextFlagsToSet) {
	        setContextFlag(
	          contextFlagsToSet,
	          /*val*/
	          true
	        );
	        const result = cb(value);
	        setContextFlag(
	          contextFlagsToSet,
	          /*val*/
	          false
	        );
	        return result;
	      }
	      return cb(value);
	    }
	    function visitDefault(node) {
	      return visitEachChild(node, visitor, context);
	    }
	    function argumentsVisitor(node) {
	      switch (node.kind) {
	        case 218 /* FunctionExpression */:
	        case 262 /* FunctionDeclaration */:
	        case 174 /* MethodDeclaration */:
	        case 177 /* GetAccessor */:
	        case 178 /* SetAccessor */:
	        case 176 /* Constructor */:
	          return node;
	        case 169 /* Parameter */:
	        case 208 /* BindingElement */:
	        case 260 /* VariableDeclaration */:
	          break;
	        case 80 /* Identifier */:
	          if (lexicalArgumentsBinding && resolver.isArgumentsLocalBinding(node)) {
	            return lexicalArgumentsBinding;
	          }
	          break;
	      }
	      return visitEachChild(node, argumentsVisitor, context);
	    }
	    function visitor(node) {
	      if ((node.transformFlags & 256 /* ContainsES2017 */) === 0) {
	        return lexicalArgumentsBinding ? argumentsVisitor(node) : node;
	      }
	      switch (node.kind) {
	        case 134 /* AsyncKeyword */:
	          return void 0;
	        case 223 /* AwaitExpression */:
	          return visitAwaitExpression(node);
	        case 174 /* MethodDeclaration */:
	          return doWithContext(1 /* NonTopLevel */ | 2 /* HasLexicalThis */, visitMethodDeclaration, node);
	        case 262 /* FunctionDeclaration */:
	          return doWithContext(1 /* NonTopLevel */ | 2 /* HasLexicalThis */, visitFunctionDeclaration, node);
	        case 218 /* FunctionExpression */:
	          return doWithContext(1 /* NonTopLevel */ | 2 /* HasLexicalThis */, visitFunctionExpression, node);
	        case 219 /* ArrowFunction */:
	          return doWithContext(1 /* NonTopLevel */, visitArrowFunction, node);
	        case 211 /* PropertyAccessExpression */:
	          if (capturedSuperProperties && isPropertyAccessExpression(node) && node.expression.kind === 108 /* SuperKeyword */) {
	            capturedSuperProperties.add(node.name.escapedText);
	          }
	          return visitEachChild(node, visitor, context);
	        case 212 /* ElementAccessExpression */:
	          if (capturedSuperProperties && node.expression.kind === 108 /* SuperKeyword */) {
	            hasSuperElementAccess = true;
	          }
	          return visitEachChild(node, visitor, context);
	        case 177 /* GetAccessor */:
	          return doWithContext(1 /* NonTopLevel */ | 2 /* HasLexicalThis */, visitGetAccessorDeclaration, node);
	        case 178 /* SetAccessor */:
	          return doWithContext(1 /* NonTopLevel */ | 2 /* HasLexicalThis */, visitSetAccessorDeclaration, node);
	        case 176 /* Constructor */:
	          return doWithContext(1 /* NonTopLevel */ | 2 /* HasLexicalThis */, visitConstructorDeclaration, node);
	        case 263 /* ClassDeclaration */:
	        case 231 /* ClassExpression */:
	          return doWithContext(1 /* NonTopLevel */ | 2 /* HasLexicalThis */, visitDefault, node);
	        default:
	          return visitEachChild(node, visitor, context);
	      }
	    }
	    function asyncBodyVisitor(node) {
	      if (isNodeWithPossibleHoistedDeclaration(node)) {
	        switch (node.kind) {
	          case 243 /* VariableStatement */:
	            return visitVariableStatementInAsyncBody(node);
	          case 248 /* ForStatement */:
	            return visitForStatementInAsyncBody(node);
	          case 249 /* ForInStatement */:
	            return visitForInStatementInAsyncBody(node);
	          case 250 /* ForOfStatement */:
	            return visitForOfStatementInAsyncBody(node);
	          case 299 /* CatchClause */:
	            return visitCatchClauseInAsyncBody(node);
	          case 241 /* Block */:
	          case 255 /* SwitchStatement */:
	          case 269 /* CaseBlock */:
	          case 296 /* CaseClause */:
	          case 297 /* DefaultClause */:
	          case 258 /* TryStatement */:
	          case 246 /* DoStatement */:
	          case 247 /* WhileStatement */:
	          case 245 /* IfStatement */:
	          case 254 /* WithStatement */:
	          case 256 /* LabeledStatement */:
	            return visitEachChild(node, asyncBodyVisitor, context);
	          default:
	            return Debug.assertNever(node, "Unhandled node.");
	        }
	      }
	      return visitor(node);
	    }
	    function visitCatchClauseInAsyncBody(node) {
	      const catchClauseNames = /* @__PURE__ */ new Set();
	      recordDeclarationName(node.variableDeclaration, catchClauseNames);
	      let catchClauseUnshadowedNames;
	      catchClauseNames.forEach((_, escapedName) => {
	        if (enclosingFunctionParameterNames.has(escapedName)) {
	          if (!catchClauseUnshadowedNames) {
	            catchClauseUnshadowedNames = new Set(enclosingFunctionParameterNames);
	          }
	          catchClauseUnshadowedNames.delete(escapedName);
	        }
	      });
	      if (catchClauseUnshadowedNames) {
	        const savedEnclosingFunctionParameterNames = enclosingFunctionParameterNames;
	        enclosingFunctionParameterNames = catchClauseUnshadowedNames;
	        const result = visitEachChild(node, asyncBodyVisitor, context);
	        enclosingFunctionParameterNames = savedEnclosingFunctionParameterNames;
	        return result;
	      } else {
	        return visitEachChild(node, asyncBodyVisitor, context);
	      }
	    }
	    function visitVariableStatementInAsyncBody(node) {
	      if (isVariableDeclarationListWithCollidingName(node.declarationList)) {
	        const expression = visitVariableDeclarationListWithCollidingNames(
	          node.declarationList,
	          /*hasReceiver*/
	          false
	        );
	        return expression ? factory2.createExpressionStatement(expression) : void 0;
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitForInStatementInAsyncBody(node) {
	      return factory2.updateForInStatement(
	        node,
	        isVariableDeclarationListWithCollidingName(node.initializer) ? visitVariableDeclarationListWithCollidingNames(
	          node.initializer,
	          /*hasReceiver*/
	          true
	        ) : Debug.checkDefined(visitNode(node.initializer, visitor, isForInitializer)),
	        Debug.checkDefined(visitNode(node.expression, visitor, isExpression)),
	        visitIterationBody(node.statement, asyncBodyVisitor, context)
	      );
	    }
	    function visitForOfStatementInAsyncBody(node) {
	      return factory2.updateForOfStatement(
	        node,
	        visitNode(node.awaitModifier, visitor, isAwaitKeyword),
	        isVariableDeclarationListWithCollidingName(node.initializer) ? visitVariableDeclarationListWithCollidingNames(
	          node.initializer,
	          /*hasReceiver*/
	          true
	        ) : Debug.checkDefined(visitNode(node.initializer, visitor, isForInitializer)),
	        Debug.checkDefined(visitNode(node.expression, visitor, isExpression)),
	        visitIterationBody(node.statement, asyncBodyVisitor, context)
	      );
	    }
	    function visitForStatementInAsyncBody(node) {
	      const initializer = node.initializer;
	      return factory2.updateForStatement(
	        node,
	        isVariableDeclarationListWithCollidingName(initializer) ? visitVariableDeclarationListWithCollidingNames(
	          initializer,
	          /*hasReceiver*/
	          false
	        ) : visitNode(node.initializer, visitor, isForInitializer),
	        visitNode(node.condition, visitor, isExpression),
	        visitNode(node.incrementor, visitor, isExpression),
	        visitIterationBody(node.statement, asyncBodyVisitor, context)
	      );
	    }
	    function visitAwaitExpression(node) {
	      if (inTopLevelContext()) {
	        return visitEachChild(node, visitor, context);
	      }
	      return setOriginalNode(
	        setTextRange(
	          factory2.createYieldExpression(
	            /*asteriskToken*/
	            void 0,
	            visitNode(node.expression, visitor, isExpression)
	          ),
	          node
	        ),
	        node
	      );
	    }
	    function visitConstructorDeclaration(node) {
	      const savedLexicalArgumentsBinding = lexicalArgumentsBinding;
	      lexicalArgumentsBinding = void 0;
	      const updated = factory2.updateConstructorDeclaration(
	        node,
	        visitNodes2(node.modifiers, visitor, isModifier),
	        visitParameterList(node.parameters, visitor, context),
	        transformMethodBody(node)
	      );
	      lexicalArgumentsBinding = savedLexicalArgumentsBinding;
	      return updated;
	    }
	    function visitMethodDeclaration(node) {
	      let parameters;
	      const functionFlags = getFunctionFlags(node);
	      const savedLexicalArgumentsBinding = lexicalArgumentsBinding;
	      lexicalArgumentsBinding = void 0;
	      const updated = factory2.updateMethodDeclaration(
	        node,
	        visitNodes2(node.modifiers, visitor, isModifierLike),
	        node.asteriskToken,
	        node.name,
	        /*questionToken*/
	        void 0,
	        /*typeParameters*/
	        void 0,
	        parameters = functionFlags & 2 /* Async */ ? transformAsyncFunctionParameterList(node) : visitParameterList(node.parameters, visitor, context),
	        /*type*/
	        void 0,
	        functionFlags & 2 /* Async */ ? transformAsyncFunctionBody(node, parameters) : transformMethodBody(node)
	      );
	      lexicalArgumentsBinding = savedLexicalArgumentsBinding;
	      return updated;
	    }
	    function visitGetAccessorDeclaration(node) {
	      const savedLexicalArgumentsBinding = lexicalArgumentsBinding;
	      lexicalArgumentsBinding = void 0;
	      const updated = factory2.updateGetAccessorDeclaration(
	        node,
	        visitNodes2(node.modifiers, visitor, isModifierLike),
	        node.name,
	        visitParameterList(node.parameters, visitor, context),
	        /*type*/
	        void 0,
	        transformMethodBody(node)
	      );
	      lexicalArgumentsBinding = savedLexicalArgumentsBinding;
	      return updated;
	    }
	    function visitSetAccessorDeclaration(node) {
	      const savedLexicalArgumentsBinding = lexicalArgumentsBinding;
	      lexicalArgumentsBinding = void 0;
	      const updated = factory2.updateSetAccessorDeclaration(
	        node,
	        visitNodes2(node.modifiers, visitor, isModifierLike),
	        node.name,
	        visitParameterList(node.parameters, visitor, context),
	        transformMethodBody(node)
	      );
	      lexicalArgumentsBinding = savedLexicalArgumentsBinding;
	      return updated;
	    }
	    function visitFunctionDeclaration(node) {
	      let parameters;
	      const savedLexicalArgumentsBinding = lexicalArgumentsBinding;
	      lexicalArgumentsBinding = void 0;
	      const functionFlags = getFunctionFlags(node);
	      const updated = factory2.updateFunctionDeclaration(
	        node,
	        visitNodes2(node.modifiers, visitor, isModifierLike),
	        node.asteriskToken,
	        node.name,
	        /*typeParameters*/
	        void 0,
	        parameters = functionFlags & 2 /* Async */ ? transformAsyncFunctionParameterList(node) : visitParameterList(node.parameters, visitor, context),
	        /*type*/
	        void 0,
	        functionFlags & 2 /* Async */ ? transformAsyncFunctionBody(node, parameters) : visitFunctionBody(node.body, visitor, context)
	      );
	      lexicalArgumentsBinding = savedLexicalArgumentsBinding;
	      return updated;
	    }
	    function visitFunctionExpression(node) {
	      let parameters;
	      const savedLexicalArgumentsBinding = lexicalArgumentsBinding;
	      lexicalArgumentsBinding = void 0;
	      const functionFlags = getFunctionFlags(node);
	      const updated = factory2.updateFunctionExpression(
	        node,
	        visitNodes2(node.modifiers, visitor, isModifier),
	        node.asteriskToken,
	        node.name,
	        /*typeParameters*/
	        void 0,
	        parameters = functionFlags & 2 /* Async */ ? transformAsyncFunctionParameterList(node) : visitParameterList(node.parameters, visitor, context),
	        /*type*/
	        void 0,
	        functionFlags & 2 /* Async */ ? transformAsyncFunctionBody(node, parameters) : visitFunctionBody(node.body, visitor, context)
	      );
	      lexicalArgumentsBinding = savedLexicalArgumentsBinding;
	      return updated;
	    }
	    function visitArrowFunction(node) {
	      let parameters;
	      const functionFlags = getFunctionFlags(node);
	      return factory2.updateArrowFunction(
	        node,
	        visitNodes2(node.modifiers, visitor, isModifier),
	        /*typeParameters*/
	        void 0,
	        parameters = functionFlags & 2 /* Async */ ? transformAsyncFunctionParameterList(node) : visitParameterList(node.parameters, visitor, context),
	        /*type*/
	        void 0,
	        node.equalsGreaterThanToken,
	        functionFlags & 2 /* Async */ ? transformAsyncFunctionBody(node, parameters) : visitFunctionBody(node.body, visitor, context)
	      );
	    }
	    function recordDeclarationName({ name }, names) {
	      if (isIdentifier(name)) {
	        names.add(name.escapedText);
	      } else {
	        for (const element of name.elements) {
	          if (!isOmittedExpression(element)) {
	            recordDeclarationName(element, names);
	          }
	        }
	      }
	    }
	    function isVariableDeclarationListWithCollidingName(node) {
	      return !!node && isVariableDeclarationList(node) && !(node.flags & 7 /* BlockScoped */) && node.declarations.some(collidesWithParameterName);
	    }
	    function visitVariableDeclarationListWithCollidingNames(node, hasReceiver) {
	      hoistVariableDeclarationList(node);
	      const variables = getInitializedVariables(node);
	      if (variables.length === 0) {
	        if (hasReceiver) {
	          return visitNode(factory2.converters.convertToAssignmentElementTarget(node.declarations[0].name), visitor, isExpression);
	        }
	        return void 0;
	      }
	      return factory2.inlineExpressions(map(variables, transformInitializedVariable));
	    }
	    function hoistVariableDeclarationList(node) {
	      forEach(node.declarations, hoistVariable);
	    }
	    function hoistVariable({ name }) {
	      if (isIdentifier(name)) {
	        hoistVariableDeclaration(name);
	      } else {
	        for (const element of name.elements) {
	          if (!isOmittedExpression(element)) {
	            hoistVariable(element);
	          }
	        }
	      }
	    }
	    function transformInitializedVariable(node) {
	      const converted = setSourceMapRange(
	        factory2.createAssignment(
	          factory2.converters.convertToAssignmentElementTarget(node.name),
	          node.initializer
	        ),
	        node
	      );
	      return Debug.checkDefined(visitNode(converted, visitor, isExpression));
	    }
	    function collidesWithParameterName({ name }) {
	      if (isIdentifier(name)) {
	        return enclosingFunctionParameterNames.has(name.escapedText);
	      } else {
	        for (const element of name.elements) {
	          if (!isOmittedExpression(element) && collidesWithParameterName(element)) {
	            return true;
	          }
	        }
	      }
	      return false;
	    }
	    function transformMethodBody(node) {
	      Debug.assertIsDefined(node.body);
	      const savedCapturedSuperProperties = capturedSuperProperties;
	      const savedHasSuperElementAccess = hasSuperElementAccess;
	      capturedSuperProperties = /* @__PURE__ */ new Set();
	      hasSuperElementAccess = false;
	      let updated = visitFunctionBody(node.body, visitor, context);
	      const originalMethod = getOriginalNode(node, isFunctionLikeDeclaration);
	      const emitSuperHelpers = languageVersion >= 2 /* ES2015 */ && resolver.getNodeCheckFlags(node) & (256 /* MethodWithSuperPropertyAssignmentInAsync */ | 128 /* MethodWithSuperPropertyAccessInAsync */) && (getFunctionFlags(originalMethod) & 3 /* AsyncGenerator */) !== 3 /* AsyncGenerator */;
	      if (emitSuperHelpers) {
	        enableSubstitutionForAsyncMethodsWithSuper();
	        if (capturedSuperProperties.size) {
	          const variableStatement = createSuperAccessVariableStatement(factory2, resolver, node, capturedSuperProperties);
	          substitutedSuperAccessors[getNodeId(variableStatement)] = true;
	          const statements = updated.statements.slice();
	          insertStatementsAfterStandardPrologue(statements, [variableStatement]);
	          updated = factory2.updateBlock(updated, statements);
	        }
	        if (hasSuperElementAccess) {
	          if (resolver.getNodeCheckFlags(node) & 256 /* MethodWithSuperPropertyAssignmentInAsync */) {
	            addEmitHelper(updated, advancedAsyncSuperHelper);
	          } else if (resolver.getNodeCheckFlags(node) & 128 /* MethodWithSuperPropertyAccessInAsync */) {
	            addEmitHelper(updated, asyncSuperHelper);
	          }
	        }
	      }
	      capturedSuperProperties = savedCapturedSuperProperties;
	      hasSuperElementAccess = savedHasSuperElementAccess;
	      return updated;
	    }
	    function createCaptureArgumentsStatement() {
	      Debug.assert(lexicalArgumentsBinding);
	      const variable = factory2.createVariableDeclaration(
	        lexicalArgumentsBinding,
	        /*exclamationToken*/
	        void 0,
	        /*type*/
	        void 0,
	        factory2.createIdentifier("arguments")
	      );
	      const statement = factory2.createVariableStatement(
	        /*modifiers*/
	        void 0,
	        [variable]
	      );
	      startOnNewLine(statement);
	      addEmitFlags(statement, 2097152 /* CustomPrologue */);
	      return statement;
	    }
	    function transformAsyncFunctionParameterList(node) {
	      if (isSimpleParameterList(node.parameters)) {
	        return visitParameterList(node.parameters, visitor, context);
	      }
	      const newParameters = [];
	      for (const parameter of node.parameters) {
	        if (parameter.initializer || parameter.dotDotDotToken) {
	          if (node.kind === 219 /* ArrowFunction */) {
	            const restParameter = factory2.createParameterDeclaration(
	              /*modifiers*/
	              void 0,
	              factory2.createToken(26 /* DotDotDotToken */),
	              factory2.createUniqueName("args", 8 /* ReservedInNestedScopes */)
	            );
	            newParameters.push(restParameter);
	          }
	          break;
	        }
	        const newParameter = factory2.createParameterDeclaration(
	          /*modifiers*/
	          void 0,
	          /*dotDotDotToken*/
	          void 0,
	          factory2.getGeneratedNameForNode(parameter.name, 8 /* ReservedInNestedScopes */)
	        );
	        newParameters.push(newParameter);
	      }
	      const newParametersArray = factory2.createNodeArray(newParameters);
	      setTextRange(newParametersArray, node.parameters);
	      return newParametersArray;
	    }
	    function transformAsyncFunctionBody(node, outerParameters) {
	      const innerParameters = !isSimpleParameterList(node.parameters) ? visitParameterList(node.parameters, visitor, context) : void 0;
	      resumeLexicalEnvironment();
	      const original = getOriginalNode(node, isFunctionLike);
	      const nodeType = original.type;
	      const promiseConstructor = languageVersion < 2 /* ES2015 */ ? getPromiseConstructor(nodeType) : void 0;
	      const isArrowFunction2 = node.kind === 219 /* ArrowFunction */;
	      const savedLexicalArgumentsBinding = lexicalArgumentsBinding;
	      const hasLexicalArguments = (resolver.getNodeCheckFlags(node) & 512 /* CaptureArguments */) !== 0;
	      const captureLexicalArguments = hasLexicalArguments && !lexicalArgumentsBinding;
	      if (captureLexicalArguments) {
	        lexicalArgumentsBinding = factory2.createUniqueName("arguments");
	      }
	      let argumentsExpression;
	      if (innerParameters) {
	        if (isArrowFunction2) {
	          const parameterBindings = [];
	          Debug.assert(outerParameters.length <= node.parameters.length);
	          for (let i = 0; i < node.parameters.length; i++) {
	            Debug.assert(i < outerParameters.length);
	            const originalParameter = node.parameters[i];
	            const outerParameter = outerParameters[i];
	            Debug.assertNode(outerParameter.name, isIdentifier);
	            if (originalParameter.initializer || originalParameter.dotDotDotToken) {
	              Debug.assert(i === outerParameters.length - 1);
	              parameterBindings.push(factory2.createSpreadElement(outerParameter.name));
	              break;
	            }
	            parameterBindings.push(outerParameter.name);
	          }
	          argumentsExpression = factory2.createArrayLiteralExpression(parameterBindings);
	        } else {
	          argumentsExpression = factory2.createIdentifier("arguments");
	        }
	      }
	      const savedEnclosingFunctionParameterNames = enclosingFunctionParameterNames;
	      enclosingFunctionParameterNames = /* @__PURE__ */ new Set();
	      for (const parameter of node.parameters) {
	        recordDeclarationName(parameter, enclosingFunctionParameterNames);
	      }
	      const savedCapturedSuperProperties = capturedSuperProperties;
	      const savedHasSuperElementAccess = hasSuperElementAccess;
	      if (!isArrowFunction2) {
	        capturedSuperProperties = /* @__PURE__ */ new Set();
	        hasSuperElementAccess = false;
	      }
	      const hasLexicalThis = inHasLexicalThisContext();
	      let asyncBody = transformAsyncFunctionBodyWorker(node.body);
	      asyncBody = factory2.updateBlock(asyncBody, factory2.mergeLexicalEnvironment(asyncBody.statements, endLexicalEnvironment()));
	      let result;
	      if (!isArrowFunction2) {
	        const statements = [];
	        statements.push(
	          factory2.createReturnStatement(
	            emitHelpers().createAwaiterHelper(
	              hasLexicalThis,
	              argumentsExpression,
	              promiseConstructor,
	              innerParameters,
	              asyncBody
	            )
	          )
	        );
	        const emitSuperHelpers = languageVersion >= 2 /* ES2015 */ && resolver.getNodeCheckFlags(node) & (256 /* MethodWithSuperPropertyAssignmentInAsync */ | 128 /* MethodWithSuperPropertyAccessInAsync */);
	        if (emitSuperHelpers) {
	          enableSubstitutionForAsyncMethodsWithSuper();
	          if (capturedSuperProperties.size) {
	            const variableStatement = createSuperAccessVariableStatement(factory2, resolver, node, capturedSuperProperties);
	            substitutedSuperAccessors[getNodeId(variableStatement)] = true;
	            insertStatementsAfterStandardPrologue(statements, [variableStatement]);
	          }
	        }
	        if (captureLexicalArguments) {
	          insertStatementsAfterStandardPrologue(statements, [createCaptureArgumentsStatement()]);
	        }
	        const block = factory2.createBlock(
	          statements,
	          /*multiLine*/
	          true
	        );
	        setTextRange(block, node.body);
	        if (emitSuperHelpers && hasSuperElementAccess) {
	          if (resolver.getNodeCheckFlags(node) & 256 /* MethodWithSuperPropertyAssignmentInAsync */) {
	            addEmitHelper(block, advancedAsyncSuperHelper);
	          } else if (resolver.getNodeCheckFlags(node) & 128 /* MethodWithSuperPropertyAccessInAsync */) {
	            addEmitHelper(block, asyncSuperHelper);
	          }
	        }
	        result = block;
	      } else {
	        result = emitHelpers().createAwaiterHelper(
	          hasLexicalThis,
	          argumentsExpression,
	          promiseConstructor,
	          innerParameters,
	          asyncBody
	        );
	        if (captureLexicalArguments) {
	          const block = factory2.converters.convertToFunctionBlock(result);
	          result = factory2.updateBlock(block, factory2.mergeLexicalEnvironment(block.statements, [createCaptureArgumentsStatement()]));
	        }
	      }
	      enclosingFunctionParameterNames = savedEnclosingFunctionParameterNames;
	      if (!isArrowFunction2) {
	        capturedSuperProperties = savedCapturedSuperProperties;
	        hasSuperElementAccess = savedHasSuperElementAccess;
	        lexicalArgumentsBinding = savedLexicalArgumentsBinding;
	      }
	      return result;
	    }
	    function transformAsyncFunctionBodyWorker(body, start) {
	      if (isBlock(body)) {
	        return factory2.updateBlock(body, visitNodes2(body.statements, asyncBodyVisitor, isStatement, start));
	      } else {
	        return factory2.converters.convertToFunctionBlock(Debug.checkDefined(visitNode(body, asyncBodyVisitor, isConciseBody)));
	      }
	    }
	    function getPromiseConstructor(type) {
	      const typeName = type && getEntityNameFromTypeNode(type);
	      if (typeName && isEntityName(typeName)) {
	        const serializationKind = resolver.getTypeReferenceSerializationKind(typeName);
	        if (serializationKind === 1 /* TypeWithConstructSignatureAndValue */ || serializationKind === 0 /* Unknown */) {
	          return typeName;
	        }
	      }
	      return void 0;
	    }
	    function enableSubstitutionForAsyncMethodsWithSuper() {
	      if ((enabledSubstitutions & 1 /* AsyncMethodsWithSuper */) === 0) {
	        enabledSubstitutions |= 1 /* AsyncMethodsWithSuper */;
	        context.enableSubstitution(213 /* CallExpression */);
	        context.enableSubstitution(211 /* PropertyAccessExpression */);
	        context.enableSubstitution(212 /* ElementAccessExpression */);
	        context.enableEmitNotification(263 /* ClassDeclaration */);
	        context.enableEmitNotification(174 /* MethodDeclaration */);
	        context.enableEmitNotification(177 /* GetAccessor */);
	        context.enableEmitNotification(178 /* SetAccessor */);
	        context.enableEmitNotification(176 /* Constructor */);
	        context.enableEmitNotification(243 /* VariableStatement */);
	      }
	    }
	    function onEmitNode(hint, node, emitCallback) {
	      if (enabledSubstitutions & 1 /* AsyncMethodsWithSuper */ && isSuperContainer(node)) {
	        const superContainerFlags = resolver.getNodeCheckFlags(node) & (128 /* MethodWithSuperPropertyAccessInAsync */ | 256 /* MethodWithSuperPropertyAssignmentInAsync */);
	        if (superContainerFlags !== enclosingSuperContainerFlags) {
	          const savedEnclosingSuperContainerFlags = enclosingSuperContainerFlags;
	          enclosingSuperContainerFlags = superContainerFlags;
	          previousOnEmitNode(hint, node, emitCallback);
	          enclosingSuperContainerFlags = savedEnclosingSuperContainerFlags;
	          return;
	        }
	      } else if (enabledSubstitutions && substitutedSuperAccessors[getNodeId(node)]) {
	        const savedEnclosingSuperContainerFlags = enclosingSuperContainerFlags;
	        enclosingSuperContainerFlags = 0;
	        previousOnEmitNode(hint, node, emitCallback);
	        enclosingSuperContainerFlags = savedEnclosingSuperContainerFlags;
	        return;
	      }
	      previousOnEmitNode(hint, node, emitCallback);
	    }
	    function onSubstituteNode(hint, node) {
	      node = previousOnSubstituteNode(hint, node);
	      if (hint === 1 /* Expression */ && enclosingSuperContainerFlags) {
	        return substituteExpression(node);
	      }
	      return node;
	    }
	    function substituteExpression(node) {
	      switch (node.kind) {
	        case 211 /* PropertyAccessExpression */:
	          return substitutePropertyAccessExpression(node);
	        case 212 /* ElementAccessExpression */:
	          return substituteElementAccessExpression(node);
	        case 213 /* CallExpression */:
	          return substituteCallExpression(node);
	      }
	      return node;
	    }
	    function substitutePropertyAccessExpression(node) {
	      if (node.expression.kind === 108 /* SuperKeyword */) {
	        return setTextRange(
	          factory2.createPropertyAccessExpression(
	            factory2.createUniqueName("_super", 16 /* Optimistic */ | 32 /* FileLevel */),
	            node.name
	          ),
	          node
	        );
	      }
	      return node;
	    }
	    function substituteElementAccessExpression(node) {
	      if (node.expression.kind === 108 /* SuperKeyword */) {
	        return createSuperElementAccessInAsyncMethod(
	          node.argumentExpression,
	          node
	        );
	      }
	      return node;
	    }
	    function substituteCallExpression(node) {
	      const expression = node.expression;
	      if (isSuperProperty(expression)) {
	        const argumentExpression = isPropertyAccessExpression(expression) ? substitutePropertyAccessExpression(expression) : substituteElementAccessExpression(expression);
	        return factory2.createCallExpression(
	          factory2.createPropertyAccessExpression(argumentExpression, "call"),
	          /*typeArguments*/
	          void 0,
	          [
	            factory2.createThis(),
	            ...node.arguments
	          ]
	        );
	      }
	      return node;
	    }
	    function isSuperContainer(node) {
	      const kind = node.kind;
	      return kind === 263 /* ClassDeclaration */ || kind === 176 /* Constructor */ || kind === 174 /* MethodDeclaration */ || kind === 177 /* GetAccessor */ || kind === 178 /* SetAccessor */;
	    }
	    function createSuperElementAccessInAsyncMethod(argumentExpression, location) {
	      if (enclosingSuperContainerFlags & 256 /* MethodWithSuperPropertyAssignmentInAsync */) {
	        return setTextRange(
	          factory2.createPropertyAccessExpression(
	            factory2.createCallExpression(
	              factory2.createUniqueName("_superIndex", 16 /* Optimistic */ | 32 /* FileLevel */),
	              /*typeArguments*/
	              void 0,
	              [argumentExpression]
	            ),
	            "value"
	          ),
	          location
	        );
	      } else {
	        return setTextRange(
	          factory2.createCallExpression(
	            factory2.createUniqueName("_superIndex", 16 /* Optimistic */ | 32 /* FileLevel */),
	            /*typeArguments*/
	            void 0,
	            [argumentExpression]
	          ),
	          location
	        );
	      }
	    }
	  }
	  function createSuperAccessVariableStatement(factory2, resolver, node, names) {
	    const hasBinding = (resolver.getNodeCheckFlags(node) & 256 /* MethodWithSuperPropertyAssignmentInAsync */) !== 0;
	    const accessors = [];
	    names.forEach((_, key) => {
	      const name = unescapeLeadingUnderscores(key);
	      const getterAndSetter = [];
	      getterAndSetter.push(factory2.createPropertyAssignment(
	        "get",
	        factory2.createArrowFunction(
	          /*modifiers*/
	          void 0,
	          /*typeParameters*/
	          void 0,
	          /* parameters */
	          [],
	          /*type*/
	          void 0,
	          /*equalsGreaterThanToken*/
	          void 0,
	          setEmitFlags(
	            factory2.createPropertyAccessExpression(
	              setEmitFlags(
	                factory2.createSuper(),
	                8 /* NoSubstitution */
	              ),
	              name
	            ),
	            8 /* NoSubstitution */
	          )
	        )
	      ));
	      if (hasBinding) {
	        getterAndSetter.push(
	          factory2.createPropertyAssignment(
	            "set",
	            factory2.createArrowFunction(
	              /*modifiers*/
	              void 0,
	              /*typeParameters*/
	              void 0,
	              /* parameters */
	              [
	                factory2.createParameterDeclaration(
	                  /*modifiers*/
	                  void 0,
	                  /*dotDotDotToken*/
	                  void 0,
	                  "v",
	                  /*questionToken*/
	                  void 0,
	                  /*type*/
	                  void 0,
	                  /*initializer*/
	                  void 0
	                )
	              ],
	              /*type*/
	              void 0,
	              /*equalsGreaterThanToken*/
	              void 0,
	              factory2.createAssignment(
	                setEmitFlags(
	                  factory2.createPropertyAccessExpression(
	                    setEmitFlags(
	                      factory2.createSuper(),
	                      8 /* NoSubstitution */
	                    ),
	                    name
	                  ),
	                  8 /* NoSubstitution */
	                ),
	                factory2.createIdentifier("v")
	              )
	            )
	          )
	        );
	      }
	      accessors.push(
	        factory2.createPropertyAssignment(
	          name,
	          factory2.createObjectLiteralExpression(getterAndSetter)
	        )
	      );
	    });
	    return factory2.createVariableStatement(
	      /*modifiers*/
	      void 0,
	      factory2.createVariableDeclarationList(
	        [
	          factory2.createVariableDeclaration(
	            factory2.createUniqueName("_super", 16 /* Optimistic */ | 32 /* FileLevel */),
	            /*exclamationToken*/
	            void 0,
	            /*type*/
	            void 0,
	            factory2.createCallExpression(
	              factory2.createPropertyAccessExpression(
	                factory2.createIdentifier("Object"),
	                "create"
	              ),
	              /*typeArguments*/
	              void 0,
	              [
	                factory2.createNull(),
	                factory2.createObjectLiteralExpression(
	                  accessors,
	                  /*multiLine*/
	                  true
	                )
	              ]
	            )
	          )
	        ],
	        2 /* Const */
	      )
	    );
	  }
	  var init_es2017 = __esm({
	    "src/compiler/transformers/es2017.ts"() {
	      init_ts2();
	    }
	  });

	  // src/compiler/transformers/es2018.ts
	  function transformES2018(context) {
	    const {
	      factory: factory2,
	      getEmitHelperFactory: emitHelpers,
	      resumeLexicalEnvironment,
	      endLexicalEnvironment,
	      hoistVariableDeclaration
	    } = context;
	    const resolver = context.getEmitResolver();
	    const compilerOptions = context.getCompilerOptions();
	    const languageVersion = getEmitScriptTarget(compilerOptions);
	    const previousOnEmitNode = context.onEmitNode;
	    context.onEmitNode = onEmitNode;
	    const previousOnSubstituteNode = context.onSubstituteNode;
	    context.onSubstituteNode = onSubstituteNode;
	    let exportedVariableStatement = false;
	    let enabledSubstitutions;
	    let enclosingFunctionFlags;
	    let parametersWithPrecedingObjectRestOrSpread;
	    let enclosingSuperContainerFlags = 0;
	    let hierarchyFacts = 0;
	    let currentSourceFile;
	    let taggedTemplateStringDeclarations;
	    let capturedSuperProperties;
	    let hasSuperElementAccess;
	    const substitutedSuperAccessors = [];
	    return chainBundle(context, transformSourceFile);
	    function affectsSubtree(excludeFacts, includeFacts) {
	      return hierarchyFacts !== (hierarchyFacts & ~excludeFacts | includeFacts);
	    }
	    function enterSubtree(excludeFacts, includeFacts) {
	      const ancestorFacts = hierarchyFacts;
	      hierarchyFacts = (hierarchyFacts & ~excludeFacts | includeFacts) & 3 /* AncestorFactsMask */;
	      return ancestorFacts;
	    }
	    function exitSubtree(ancestorFacts) {
	      hierarchyFacts = ancestorFacts;
	    }
	    function recordTaggedTemplateString(temp) {
	      taggedTemplateStringDeclarations = append(
	        taggedTemplateStringDeclarations,
	        factory2.createVariableDeclaration(temp)
	      );
	    }
	    function transformSourceFile(node) {
	      if (node.isDeclarationFile) {
	        return node;
	      }
	      currentSourceFile = node;
	      const visited = visitSourceFile(node);
	      addEmitHelpers(visited, context.readEmitHelpers());
	      currentSourceFile = void 0;
	      taggedTemplateStringDeclarations = void 0;
	      return visited;
	    }
	    function visitor(node) {
	      return visitorWorker(
	        node,
	        /*expressionResultIsUnused*/
	        false
	      );
	    }
	    function visitorWithUnusedExpressionResult(node) {
	      return visitorWorker(
	        node,
	        /*expressionResultIsUnused*/
	        true
	      );
	    }
	    function visitorNoAsyncModifier(node) {
	      if (node.kind === 134 /* AsyncKeyword */) {
	        return void 0;
	      }
	      return node;
	    }
	    function doWithHierarchyFacts(cb, value, excludeFacts, includeFacts) {
	      if (affectsSubtree(excludeFacts, includeFacts)) {
	        const ancestorFacts = enterSubtree(excludeFacts, includeFacts);
	        const result = cb(value);
	        exitSubtree(ancestorFacts);
	        return result;
	      }
	      return cb(value);
	    }
	    function visitDefault(node) {
	      return visitEachChild(node, visitor, context);
	    }
	    function visitorWorker(node, expressionResultIsUnused2) {
	      if ((node.transformFlags & 128 /* ContainsES2018 */) === 0) {
	        return node;
	      }
	      switch (node.kind) {
	        case 223 /* AwaitExpression */:
	          return visitAwaitExpression(node);
	        case 229 /* YieldExpression */:
	          return visitYieldExpression(node);
	        case 253 /* ReturnStatement */:
	          return visitReturnStatement(node);
	        case 256 /* LabeledStatement */:
	          return visitLabeledStatement(node);
	        case 210 /* ObjectLiteralExpression */:
	          return visitObjectLiteralExpression(node);
	        case 226 /* BinaryExpression */:
	          return visitBinaryExpression(node, expressionResultIsUnused2);
	        case 361 /* CommaListExpression */:
	          return visitCommaListExpression(node, expressionResultIsUnused2);
	        case 299 /* CatchClause */:
	          return visitCatchClause(node);
	        case 243 /* VariableStatement */:
	          return visitVariableStatement(node);
	        case 260 /* VariableDeclaration */:
	          return visitVariableDeclaration(node);
	        case 246 /* DoStatement */:
	        case 247 /* WhileStatement */:
	        case 249 /* ForInStatement */:
	          return doWithHierarchyFacts(
	            visitDefault,
	            node,
	            0 /* IterationStatementExcludes */,
	            2 /* IterationStatementIncludes */
	          );
	        case 250 /* ForOfStatement */:
	          return visitForOfStatement(
	            node,
	            /*outermostLabeledStatement*/
	            void 0
	          );
	        case 248 /* ForStatement */:
	          return doWithHierarchyFacts(
	            visitForStatement,
	            node,
	            0 /* IterationStatementExcludes */,
	            2 /* IterationStatementIncludes */
	          );
	        case 222 /* VoidExpression */:
	          return visitVoidExpression(node);
	        case 176 /* Constructor */:
	          return doWithHierarchyFacts(
	            visitConstructorDeclaration,
	            node,
	            2 /* ClassOrFunctionExcludes */,
	            1 /* ClassOrFunctionIncludes */
	          );
	        case 174 /* MethodDeclaration */:
	          return doWithHierarchyFacts(
	            visitMethodDeclaration,
	            node,
	            2 /* ClassOrFunctionExcludes */,
	            1 /* ClassOrFunctionIncludes */
	          );
	        case 177 /* GetAccessor */:
	          return doWithHierarchyFacts(
	            visitGetAccessorDeclaration,
	            node,
	            2 /* ClassOrFunctionExcludes */,
	            1 /* ClassOrFunctionIncludes */
	          );
	        case 178 /* SetAccessor */:
	          return doWithHierarchyFacts(
	            visitSetAccessorDeclaration,
	            node,
	            2 /* ClassOrFunctionExcludes */,
	            1 /* ClassOrFunctionIncludes */
	          );
	        case 262 /* FunctionDeclaration */:
	          return doWithHierarchyFacts(
	            visitFunctionDeclaration,
	            node,
	            2 /* ClassOrFunctionExcludes */,
	            1 /* ClassOrFunctionIncludes */
	          );
	        case 218 /* FunctionExpression */:
	          return doWithHierarchyFacts(
	            visitFunctionExpression,
	            node,
	            2 /* ClassOrFunctionExcludes */,
	            1 /* ClassOrFunctionIncludes */
	          );
	        case 219 /* ArrowFunction */:
	          return doWithHierarchyFacts(
	            visitArrowFunction,
	            node,
	            2 /* ArrowFunctionExcludes */,
	            0 /* ArrowFunctionIncludes */
	          );
	        case 169 /* Parameter */:
	          return visitParameter(node);
	        case 244 /* ExpressionStatement */:
	          return visitExpressionStatement(node);
	        case 217 /* ParenthesizedExpression */:
	          return visitParenthesizedExpression(node, expressionResultIsUnused2);
	        case 215 /* TaggedTemplateExpression */:
	          return visitTaggedTemplateExpression(node);
	        case 211 /* PropertyAccessExpression */:
	          if (capturedSuperProperties && isPropertyAccessExpression(node) && node.expression.kind === 108 /* SuperKeyword */) {
	            capturedSuperProperties.add(node.name.escapedText);
	          }
	          return visitEachChild(node, visitor, context);
	        case 212 /* ElementAccessExpression */:
	          if (capturedSuperProperties && node.expression.kind === 108 /* SuperKeyword */) {
	            hasSuperElementAccess = true;
	          }
	          return visitEachChild(node, visitor, context);
	        case 263 /* ClassDeclaration */:
	        case 231 /* ClassExpression */:
	          return doWithHierarchyFacts(
	            visitDefault,
	            node,
	            2 /* ClassOrFunctionExcludes */,
	            1 /* ClassOrFunctionIncludes */
	          );
	        default:
	          return visitEachChild(node, visitor, context);
	      }
	    }
	    function visitAwaitExpression(node) {
	      if (enclosingFunctionFlags & 2 /* Async */ && enclosingFunctionFlags & 1 /* Generator */) {
	        return setOriginalNode(
	          setTextRange(
	            factory2.createYieldExpression(
	              /*asteriskToken*/
	              void 0,
	              emitHelpers().createAwaitHelper(visitNode(node.expression, visitor, isExpression))
	            ),
	            /*location*/
	            node
	          ),
	          node
	        );
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitYieldExpression(node) {
	      if (enclosingFunctionFlags & 2 /* Async */ && enclosingFunctionFlags & 1 /* Generator */) {
	        if (node.asteriskToken) {
	          const expression = visitNode(Debug.checkDefined(node.expression), visitor, isExpression);
	          return setOriginalNode(
	            setTextRange(
	              factory2.createYieldExpression(
	                /*asteriskToken*/
	                void 0,
	                emitHelpers().createAwaitHelper(
	                  factory2.updateYieldExpression(
	                    node,
	                    node.asteriskToken,
	                    setTextRange(
	                      emitHelpers().createAsyncDelegatorHelper(
	                        setTextRange(
	                          emitHelpers().createAsyncValuesHelper(expression),
	                          expression
	                        )
	                      ),
	                      expression
	                    )
	                  )
	                )
	              ),
	              node
	            ),
	            node
	          );
	        }
	        return setOriginalNode(
	          setTextRange(
	            factory2.createYieldExpression(
	              /*asteriskToken*/
	              void 0,
	              createDownlevelAwait(
	                node.expression ? visitNode(node.expression, visitor, isExpression) : factory2.createVoidZero()
	              )
	            ),
	            node
	          ),
	          node
	        );
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitReturnStatement(node) {
	      if (enclosingFunctionFlags & 2 /* Async */ && enclosingFunctionFlags & 1 /* Generator */) {
	        return factory2.updateReturnStatement(
	          node,
	          createDownlevelAwait(
	            node.expression ? visitNode(node.expression, visitor, isExpression) : factory2.createVoidZero()
	          )
	        );
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitLabeledStatement(node) {
	      if (enclosingFunctionFlags & 2 /* Async */) {
	        const statement = unwrapInnermostStatementOfLabel(node);
	        if (statement.kind === 250 /* ForOfStatement */ && statement.awaitModifier) {
	          return visitForOfStatement(statement, node);
	        }
	        return factory2.restoreEnclosingLabel(visitNode(statement, visitor, isStatement, factory2.liftToBlock), node);
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function chunkObjectLiteralElements(elements) {
	      let chunkObject;
	      const objects = [];
	      for (const e of elements) {
	        if (e.kind === 305 /* SpreadAssignment */) {
	          if (chunkObject) {
	            objects.push(factory2.createObjectLiteralExpression(chunkObject));
	            chunkObject = void 0;
	          }
	          const target = e.expression;
	          objects.push(visitNode(target, visitor, isExpression));
	        } else {
	          chunkObject = append(
	            chunkObject,
	            e.kind === 303 /* PropertyAssignment */ ? factory2.createPropertyAssignment(e.name, visitNode(e.initializer, visitor, isExpression)) : visitNode(e, visitor, isObjectLiteralElementLike)
	          );
	        }
	      }
	      if (chunkObject) {
	        objects.push(factory2.createObjectLiteralExpression(chunkObject));
	      }
	      return objects;
	    }
	    function visitObjectLiteralExpression(node) {
	      if (node.transformFlags & 65536 /* ContainsObjectRestOrSpread */) {
	        const objects = chunkObjectLiteralElements(node.properties);
	        if (objects.length && objects[0].kind !== 210 /* ObjectLiteralExpression */) {
	          objects.unshift(factory2.createObjectLiteralExpression());
	        }
	        let expression = objects[0];
	        if (objects.length > 1) {
	          for (let i = 1; i < objects.length; i++) {
	            expression = emitHelpers().createAssignHelper([expression, objects[i]]);
	          }
	          return expression;
	        } else {
	          return emitHelpers().createAssignHelper(objects);
	        }
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitExpressionStatement(node) {
	      return visitEachChild(node, visitorWithUnusedExpressionResult, context);
	    }
	    function visitParenthesizedExpression(node, expressionResultIsUnused2) {
	      return visitEachChild(node, expressionResultIsUnused2 ? visitorWithUnusedExpressionResult : visitor, context);
	    }
	    function visitSourceFile(node) {
	      const ancestorFacts = enterSubtree(
	        2 /* SourceFileExcludes */,
	        isEffectiveStrictModeSourceFile(node, compilerOptions) ? 0 /* StrictModeSourceFileIncludes */ : 1 /* SourceFileIncludes */
	      );
	      exportedVariableStatement = false;
	      const visited = visitEachChild(node, visitor, context);
	      const statement = concatenate(
	        visited.statements,
	        taggedTemplateStringDeclarations && [
	          factory2.createVariableStatement(
	            /*modifiers*/
	            void 0,
	            factory2.createVariableDeclarationList(taggedTemplateStringDeclarations)
	          )
	        ]
	      );
	      const result = factory2.updateSourceFile(visited, setTextRange(factory2.createNodeArray(statement), node.statements));
	      exitSubtree(ancestorFacts);
	      return result;
	    }
	    function visitTaggedTemplateExpression(node) {
	      return processTaggedTemplateExpression(
	        context,
	        node,
	        visitor,
	        currentSourceFile,
	        recordTaggedTemplateString,
	        0 /* LiftRestriction */
	      );
	    }
	    function visitBinaryExpression(node, expressionResultIsUnused2) {
	      if (isDestructuringAssignment(node) && containsObjectRestOrSpread(node.left)) {
	        return flattenDestructuringAssignment(
	          node,
	          visitor,
	          context,
	          1 /* ObjectRest */,
	          !expressionResultIsUnused2
	        );
	      }
	      if (node.operatorToken.kind === 28 /* CommaToken */) {
	        return factory2.updateBinaryExpression(
	          node,
	          visitNode(node.left, visitorWithUnusedExpressionResult, isExpression),
	          node.operatorToken,
	          visitNode(node.right, expressionResultIsUnused2 ? visitorWithUnusedExpressionResult : visitor, isExpression)
	        );
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitCommaListExpression(node, expressionResultIsUnused2) {
	      if (expressionResultIsUnused2) {
	        return visitEachChild(node, visitorWithUnusedExpressionResult, context);
	      }
	      let result;
	      for (let i = 0; i < node.elements.length; i++) {
	        const element = node.elements[i];
	        const visited = visitNode(element, i < node.elements.length - 1 ? visitorWithUnusedExpressionResult : visitor, isExpression);
	        if (result || visited !== element) {
	          result || (result = node.elements.slice(0, i));
	          result.push(visited);
	        }
	      }
	      const elements = result ? setTextRange(factory2.createNodeArray(result), node.elements) : node.elements;
	      return factory2.updateCommaListExpression(node, elements);
	    }
	    function visitCatchClause(node) {
	      if (node.variableDeclaration && isBindingPattern(node.variableDeclaration.name) && node.variableDeclaration.name.transformFlags & 65536 /* ContainsObjectRestOrSpread */) {
	        const name = factory2.getGeneratedNameForNode(node.variableDeclaration.name);
	        const updatedDecl = factory2.updateVariableDeclaration(
	          node.variableDeclaration,
	          node.variableDeclaration.name,
	          /*exclamationToken*/
	          void 0,
	          /*type*/
	          void 0,
	          name
	        );
	        const visitedBindings = flattenDestructuringBinding(updatedDecl, visitor, context, 1 /* ObjectRest */);
	        let block = visitNode(node.block, visitor, isBlock);
	        if (some(visitedBindings)) {
	          block = factory2.updateBlock(block, [
	            factory2.createVariableStatement(
	              /*modifiers*/
	              void 0,
	              visitedBindings
	            ),
	            ...block.statements
	          ]);
	        }
	        return factory2.updateCatchClause(
	          node,
	          factory2.updateVariableDeclaration(
	            node.variableDeclaration,
	            name,
	            /*exclamationToken*/
	            void 0,
	            /*type*/
	            void 0,
	            /*initializer*/
	            void 0
	          ),
	          block
	        );
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitVariableStatement(node) {
	      if (hasSyntacticModifier(node, 32 /* Export */)) {
	        const savedExportedVariableStatement = exportedVariableStatement;
	        exportedVariableStatement = true;
	        const visited = visitEachChild(node, visitor, context);
	        exportedVariableStatement = savedExportedVariableStatement;
	        return visited;
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitVariableDeclaration(node) {
	      if (exportedVariableStatement) {
	        const savedExportedVariableStatement = exportedVariableStatement;
	        exportedVariableStatement = false;
	        const visited = visitVariableDeclarationWorker(
	          node,
	          /*exportedVariableStatement*/
	          true
	        );
	        exportedVariableStatement = savedExportedVariableStatement;
	        return visited;
	      }
	      return visitVariableDeclarationWorker(
	        node,
	        /*exportedVariableStatement*/
	        false
	      );
	    }
	    function visitVariableDeclarationWorker(node, exportedVariableStatement2) {
	      if (isBindingPattern(node.name) && node.name.transformFlags & 65536 /* ContainsObjectRestOrSpread */) {
	        return flattenDestructuringBinding(
	          node,
	          visitor,
	          context,
	          1 /* ObjectRest */,
	          /*rval*/
	          void 0,
	          exportedVariableStatement2
	        );
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitForStatement(node) {
	      return factory2.updateForStatement(
	        node,
	        visitNode(node.initializer, visitorWithUnusedExpressionResult, isForInitializer),
	        visitNode(node.condition, visitor, isExpression),
	        visitNode(node.incrementor, visitorWithUnusedExpressionResult, isExpression),
	        visitIterationBody(node.statement, visitor, context)
	      );
	    }
	    function visitVoidExpression(node) {
	      return visitEachChild(node, visitorWithUnusedExpressionResult, context);
	    }
	    function visitForOfStatement(node, outermostLabeledStatement) {
	      const ancestorFacts = enterSubtree(0 /* IterationStatementExcludes */, 2 /* IterationStatementIncludes */);
	      if (node.initializer.transformFlags & 65536 /* ContainsObjectRestOrSpread */ || isAssignmentPattern(node.initializer) && containsObjectRestOrSpread(node.initializer)) {
	        node = transformForOfStatementWithObjectRest(node);
	      }
	      const result = node.awaitModifier ? transformForAwaitOfStatement(node, outermostLabeledStatement, ancestorFacts) : factory2.restoreEnclosingLabel(visitEachChild(node, visitor, context), outermostLabeledStatement);
	      exitSubtree(ancestorFacts);
	      return result;
	    }
	    function transformForOfStatementWithObjectRest(node) {
	      const initializerWithoutParens = skipParentheses(node.initializer);
	      if (isVariableDeclarationList(initializerWithoutParens) || isAssignmentPattern(initializerWithoutParens)) {
	        let bodyLocation;
	        let statementsLocation;
	        const temp = factory2.createTempVariable(
	          /*recordTempVariable*/
	          void 0
	        );
	        const statements = [createForOfBindingStatement(factory2, initializerWithoutParens, temp)];
	        if (isBlock(node.statement)) {
	          addRange(statements, node.statement.statements);
	          bodyLocation = node.statement;
	          statementsLocation = node.statement.statements;
	        } else if (node.statement) {
	          append(statements, node.statement);
	          bodyLocation = node.statement;
	          statementsLocation = node.statement;
	        }
	        return factory2.updateForOfStatement(
	          node,
	          node.awaitModifier,
	          setTextRange(
	            factory2.createVariableDeclarationList(
	              [
	                setTextRange(factory2.createVariableDeclaration(temp), node.initializer)
	              ],
	              1 /* Let */
	            ),
	            node.initializer
	          ),
	          node.expression,
	          setTextRange(
	            factory2.createBlock(
	              setTextRange(factory2.createNodeArray(statements), statementsLocation),
	              /*multiLine*/
	              true
	            ),
	            bodyLocation
	          )
	        );
	      }
	      return node;
	    }
	    function convertForOfStatementHead(node, boundValue, nonUserCode) {
	      const value = factory2.createTempVariable(hoistVariableDeclaration);
	      const iteratorValueExpression = factory2.createAssignment(value, boundValue);
	      const iteratorValueStatement = factory2.createExpressionStatement(iteratorValueExpression);
	      setSourceMapRange(iteratorValueStatement, node.expression);
	      const exitNonUserCodeExpression = factory2.createAssignment(nonUserCode, factory2.createFalse());
	      const exitNonUserCodeStatement = factory2.createExpressionStatement(exitNonUserCodeExpression);
	      setSourceMapRange(exitNonUserCodeStatement, node.expression);
	      const statements = [iteratorValueStatement, exitNonUserCodeStatement];
	      const binding = createForOfBindingStatement(factory2, node.initializer, value);
	      statements.push(visitNode(binding, visitor, isStatement));
	      let bodyLocation;
	      let statementsLocation;
	      const statement = visitIterationBody(node.statement, visitor, context);
	      if (isBlock(statement)) {
	        addRange(statements, statement.statements);
	        bodyLocation = statement;
	        statementsLocation = statement.statements;
	      } else {
	        statements.push(statement);
	      }
	      return setTextRange(
	        factory2.createBlock(
	          setTextRange(factory2.createNodeArray(statements), statementsLocation),
	          /*multiLine*/
	          true
	        ),
	        bodyLocation
	      );
	    }
	    function createDownlevelAwait(expression) {
	      return enclosingFunctionFlags & 1 /* Generator */ ? factory2.createYieldExpression(
	        /*asteriskToken*/
	        void 0,
	        emitHelpers().createAwaitHelper(expression)
	      ) : factory2.createAwaitExpression(expression);
	    }
	    function transformForAwaitOfStatement(node, outermostLabeledStatement, ancestorFacts) {
	      const expression = visitNode(node.expression, visitor, isExpression);
	      const iterator = isIdentifier(expression) ? factory2.getGeneratedNameForNode(expression) : factory2.createTempVariable(
	        /*recordTempVariable*/
	        void 0
	      );
	      const result = isIdentifier(expression) ? factory2.getGeneratedNameForNode(iterator) : factory2.createTempVariable(
	        /*recordTempVariable*/
	        void 0
	      );
	      const nonUserCode = factory2.createTempVariable(
	        /*recordTempVariable*/
	        void 0
	      );
	      const done = factory2.createTempVariable(hoistVariableDeclaration);
	      const errorRecord = factory2.createUniqueName("e");
	      const catchVariable = factory2.getGeneratedNameForNode(errorRecord);
	      const returnMethod = factory2.createTempVariable(
	        /*recordTempVariable*/
	        void 0
	      );
	      const callValues = setTextRange(emitHelpers().createAsyncValuesHelper(expression), node.expression);
	      const callNext = factory2.createCallExpression(
	        factory2.createPropertyAccessExpression(iterator, "next"),
	        /*typeArguments*/
	        void 0,
	        []
	      );
	      const getDone = factory2.createPropertyAccessExpression(result, "done");
	      const getValue = factory2.createPropertyAccessExpression(result, "value");
	      const callReturn = factory2.createFunctionCallCall(returnMethod, iterator, []);
	      hoistVariableDeclaration(errorRecord);
	      hoistVariableDeclaration(returnMethod);
	      const initializer = ancestorFacts & 2 /* IterationContainer */ ? factory2.inlineExpressions([factory2.createAssignment(errorRecord, factory2.createVoidZero()), callValues]) : callValues;
	      const forStatement = setEmitFlags(
	        setTextRange(
	          factory2.createForStatement(
	            /*initializer*/
	            setEmitFlags(
	              setTextRange(
	                factory2.createVariableDeclarationList([
	                  factory2.createVariableDeclaration(
	                    nonUserCode,
	                    /*exclamationToken*/
	                    void 0,
	                    /*type*/
	                    void 0,
	                    factory2.createTrue()
	                  ),
	                  setTextRange(factory2.createVariableDeclaration(
	                    iterator,
	                    /*exclamationToken*/
	                    void 0,
	                    /*type*/
	                    void 0,
	                    initializer
	                  ), node.expression),
	                  factory2.createVariableDeclaration(result)
	                ]),
	                node.expression
	              ),
	              4194304 /* NoHoisting */
	            ),
	            /*condition*/
	            factory2.inlineExpressions([
	              factory2.createAssignment(result, createDownlevelAwait(callNext)),
	              factory2.createAssignment(done, getDone),
	              factory2.createLogicalNot(done)
	            ]),
	            /*incrementor*/
	            factory2.createAssignment(nonUserCode, factory2.createTrue()),
	            /*statement*/
	            convertForOfStatementHead(node, getValue, nonUserCode)
	          ),
	          /*location*/
	          node
	        ),
	        512 /* NoTokenTrailingSourceMaps */
	      );
	      setOriginalNode(forStatement, node);
	      return factory2.createTryStatement(
	        factory2.createBlock([
	          factory2.restoreEnclosingLabel(
	            forStatement,
	            outermostLabeledStatement
	          )
	        ]),
	        factory2.createCatchClause(
	          factory2.createVariableDeclaration(catchVariable),
	          setEmitFlags(
	            factory2.createBlock([
	              factory2.createExpressionStatement(
	                factory2.createAssignment(
	                  errorRecord,
	                  factory2.createObjectLiteralExpression([
	                    factory2.createPropertyAssignment("error", catchVariable)
	                  ])
	                )
	              )
	            ]),
	            1 /* SingleLine */
	          )
	        ),
	        factory2.createBlock([
	          factory2.createTryStatement(
	            /*tryBlock*/
	            factory2.createBlock([
	              setEmitFlags(
	                factory2.createIfStatement(
	                  factory2.createLogicalAnd(
	                    factory2.createLogicalAnd(
	                      factory2.createLogicalNot(nonUserCode),
	                      factory2.createLogicalNot(done)
	                    ),
	                    factory2.createAssignment(
	                      returnMethod,
	                      factory2.createPropertyAccessExpression(iterator, "return")
	                    )
	                  ),
	                  factory2.createExpressionStatement(createDownlevelAwait(callReturn))
	                ),
	                1 /* SingleLine */
	              )
	            ]),
	            /*catchClause*/
	            void 0,
	            /*finallyBlock*/
	            setEmitFlags(
	              factory2.createBlock([
	                setEmitFlags(
	                  factory2.createIfStatement(
	                    errorRecord,
	                    factory2.createThrowStatement(
	                      factory2.createPropertyAccessExpression(errorRecord, "error")
	                    )
	                  ),
	                  1 /* SingleLine */
	                )
	              ]),
	              1 /* SingleLine */
	            )
	          )
	        ])
	      );
	    }
	    function parameterVisitor(node) {
	      Debug.assertNode(node, isParameter);
	      return visitParameter(node);
	    }
	    function visitParameter(node) {
	      if (parametersWithPrecedingObjectRestOrSpread == null ? void 0 : parametersWithPrecedingObjectRestOrSpread.has(node)) {
	        return factory2.updateParameterDeclaration(
	          node,
	          /*modifiers*/
	          void 0,
	          node.dotDotDotToken,
	          isBindingPattern(node.name) ? factory2.getGeneratedNameForNode(node) : node.name,
	          /*questionToken*/
	          void 0,
	          /*type*/
	          void 0,
	          /*initializer*/
	          void 0
	        );
	      }
	      if (node.transformFlags & 65536 /* ContainsObjectRestOrSpread */) {
	        return factory2.updateParameterDeclaration(
	          node,
	          /*modifiers*/
	          void 0,
	          node.dotDotDotToken,
	          factory2.getGeneratedNameForNode(node),
	          /*questionToken*/
	          void 0,
	          /*type*/
	          void 0,
	          visitNode(node.initializer, visitor, isExpression)
	        );
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function collectParametersWithPrecedingObjectRestOrSpread(node) {
	      let parameters;
	      for (const parameter of node.parameters) {
	        if (parameters) {
	          parameters.add(parameter);
	        } else if (parameter.transformFlags & 65536 /* ContainsObjectRestOrSpread */) {
	          parameters = /* @__PURE__ */ new Set();
	        }
	      }
	      return parameters;
	    }
	    function visitConstructorDeclaration(node) {
	      const savedEnclosingFunctionFlags = enclosingFunctionFlags;
	      const savedParametersWithPrecedingObjectRestOrSpread = parametersWithPrecedingObjectRestOrSpread;
	      enclosingFunctionFlags = getFunctionFlags(node);
	      parametersWithPrecedingObjectRestOrSpread = collectParametersWithPrecedingObjectRestOrSpread(node);
	      const updated = factory2.updateConstructorDeclaration(
	        node,
	        node.modifiers,
	        visitParameterList(node.parameters, parameterVisitor, context),
	        transformFunctionBody2(node)
	      );
	      enclosingFunctionFlags = savedEnclosingFunctionFlags;
	      parametersWithPrecedingObjectRestOrSpread = savedParametersWithPrecedingObjectRestOrSpread;
	      return updated;
	    }
	    function visitGetAccessorDeclaration(node) {
	      const savedEnclosingFunctionFlags = enclosingFunctionFlags;
	      const savedParametersWithPrecedingObjectRestOrSpread = parametersWithPrecedingObjectRestOrSpread;
	      enclosingFunctionFlags = getFunctionFlags(node);
	      parametersWithPrecedingObjectRestOrSpread = collectParametersWithPrecedingObjectRestOrSpread(node);
	      const updated = factory2.updateGetAccessorDeclaration(
	        node,
	        node.modifiers,
	        visitNode(node.name, visitor, isPropertyName),
	        visitParameterList(node.parameters, parameterVisitor, context),
	        /*type*/
	        void 0,
	        transformFunctionBody2(node)
	      );
	      enclosingFunctionFlags = savedEnclosingFunctionFlags;
	      parametersWithPrecedingObjectRestOrSpread = savedParametersWithPrecedingObjectRestOrSpread;
	      return updated;
	    }
	    function visitSetAccessorDeclaration(node) {
	      const savedEnclosingFunctionFlags = enclosingFunctionFlags;
	      const savedParametersWithPrecedingObjectRestOrSpread = parametersWithPrecedingObjectRestOrSpread;
	      enclosingFunctionFlags = getFunctionFlags(node);
	      parametersWithPrecedingObjectRestOrSpread = collectParametersWithPrecedingObjectRestOrSpread(node);
	      const updated = factory2.updateSetAccessorDeclaration(
	        node,
	        node.modifiers,
	        visitNode(node.name, visitor, isPropertyName),
	        visitParameterList(node.parameters, parameterVisitor, context),
	        transformFunctionBody2(node)
	      );
	      enclosingFunctionFlags = savedEnclosingFunctionFlags;
	      parametersWithPrecedingObjectRestOrSpread = savedParametersWithPrecedingObjectRestOrSpread;
	      return updated;
	    }
	    function visitMethodDeclaration(node) {
	      const savedEnclosingFunctionFlags = enclosingFunctionFlags;
	      const savedParametersWithPrecedingObjectRestOrSpread = parametersWithPrecedingObjectRestOrSpread;
	      enclosingFunctionFlags = getFunctionFlags(node);
	      parametersWithPrecedingObjectRestOrSpread = collectParametersWithPrecedingObjectRestOrSpread(node);
	      const updated = factory2.updateMethodDeclaration(
	        node,
	        enclosingFunctionFlags & 1 /* Generator */ ? visitNodes2(node.modifiers, visitorNoAsyncModifier, isModifierLike) : node.modifiers,
	        enclosingFunctionFlags & 2 /* Async */ ? void 0 : node.asteriskToken,
	        visitNode(node.name, visitor, isPropertyName),
	        visitNode(
	          /*node*/
	          void 0,
	          visitor,
	          isQuestionToken
	        ),
	        /*typeParameters*/
	        void 0,
	        enclosingFunctionFlags & 2 /* Async */ && enclosingFunctionFlags & 1 /* Generator */ ? transformAsyncGeneratorFunctionParameterList(node) : visitParameterList(node.parameters, parameterVisitor, context),
	        /*type*/
	        void 0,
	        enclosingFunctionFlags & 2 /* Async */ && enclosingFunctionFlags & 1 /* Generator */ ? transformAsyncGeneratorFunctionBody(node) : transformFunctionBody2(node)
	      );
	      enclosingFunctionFlags = savedEnclosingFunctionFlags;
	      parametersWithPrecedingObjectRestOrSpread = savedParametersWithPrecedingObjectRestOrSpread;
	      return updated;
	    }
	    function visitFunctionDeclaration(node) {
	      const savedEnclosingFunctionFlags = enclosingFunctionFlags;
	      const savedParametersWithPrecedingObjectRestOrSpread = parametersWithPrecedingObjectRestOrSpread;
	      enclosingFunctionFlags = getFunctionFlags(node);
	      parametersWithPrecedingObjectRestOrSpread = collectParametersWithPrecedingObjectRestOrSpread(node);
	      const updated = factory2.updateFunctionDeclaration(
	        node,
	        enclosingFunctionFlags & 1 /* Generator */ ? visitNodes2(node.modifiers, visitorNoAsyncModifier, isModifier) : node.modifiers,
	        enclosingFunctionFlags & 2 /* Async */ ? void 0 : node.asteriskToken,
	        node.name,
	        /*typeParameters*/
	        void 0,
	        enclosingFunctionFlags & 2 /* Async */ && enclosingFunctionFlags & 1 /* Generator */ ? transformAsyncGeneratorFunctionParameterList(node) : visitParameterList(node.parameters, parameterVisitor, context),
	        /*type*/
	        void 0,
	        enclosingFunctionFlags & 2 /* Async */ && enclosingFunctionFlags & 1 /* Generator */ ? transformAsyncGeneratorFunctionBody(node) : transformFunctionBody2(node)
	      );
	      enclosingFunctionFlags = savedEnclosingFunctionFlags;
	      parametersWithPrecedingObjectRestOrSpread = savedParametersWithPrecedingObjectRestOrSpread;
	      return updated;
	    }
	    function visitArrowFunction(node) {
	      const savedEnclosingFunctionFlags = enclosingFunctionFlags;
	      const savedParametersWithPrecedingObjectRestOrSpread = parametersWithPrecedingObjectRestOrSpread;
	      enclosingFunctionFlags = getFunctionFlags(node);
	      parametersWithPrecedingObjectRestOrSpread = collectParametersWithPrecedingObjectRestOrSpread(node);
	      const updated = factory2.updateArrowFunction(
	        node,
	        node.modifiers,
	        /*typeParameters*/
	        void 0,
	        visitParameterList(node.parameters, parameterVisitor, context),
	        /*type*/
	        void 0,
	        node.equalsGreaterThanToken,
	        transformFunctionBody2(node)
	      );
	      enclosingFunctionFlags = savedEnclosingFunctionFlags;
	      parametersWithPrecedingObjectRestOrSpread = savedParametersWithPrecedingObjectRestOrSpread;
	      return updated;
	    }
	    function visitFunctionExpression(node) {
	      const savedEnclosingFunctionFlags = enclosingFunctionFlags;
	      const savedParametersWithPrecedingObjectRestOrSpread = parametersWithPrecedingObjectRestOrSpread;
	      enclosingFunctionFlags = getFunctionFlags(node);
	      parametersWithPrecedingObjectRestOrSpread = collectParametersWithPrecedingObjectRestOrSpread(node);
	      const updated = factory2.updateFunctionExpression(
	        node,
	        enclosingFunctionFlags & 1 /* Generator */ ? visitNodes2(node.modifiers, visitorNoAsyncModifier, isModifier) : node.modifiers,
	        enclosingFunctionFlags & 2 /* Async */ ? void 0 : node.asteriskToken,
	        node.name,
	        /*typeParameters*/
	        void 0,
	        enclosingFunctionFlags & 2 /* Async */ && enclosingFunctionFlags & 1 /* Generator */ ? transformAsyncGeneratorFunctionParameterList(node) : visitParameterList(node.parameters, parameterVisitor, context),
	        /*type*/
	        void 0,
	        enclosingFunctionFlags & 2 /* Async */ && enclosingFunctionFlags & 1 /* Generator */ ? transformAsyncGeneratorFunctionBody(node) : transformFunctionBody2(node)
	      );
	      enclosingFunctionFlags = savedEnclosingFunctionFlags;
	      parametersWithPrecedingObjectRestOrSpread = savedParametersWithPrecedingObjectRestOrSpread;
	      return updated;
	    }
	    function transformAsyncGeneratorFunctionParameterList(node) {
	      if (isSimpleParameterList(node.parameters)) {
	        return visitParameterList(node.parameters, visitor, context);
	      }
	      const newParameters = [];
	      for (const parameter of node.parameters) {
	        if (parameter.initializer || parameter.dotDotDotToken) {
	          break;
	        }
	        const newParameter = factory2.createParameterDeclaration(
	          /*modifiers*/
	          void 0,
	          /*dotDotDotToken*/
	          void 0,
	          factory2.getGeneratedNameForNode(parameter.name, 8 /* ReservedInNestedScopes */)
	        );
	        newParameters.push(newParameter);
	      }
	      const newParametersArray = factory2.createNodeArray(newParameters);
	      setTextRange(newParametersArray, node.parameters);
	      return newParametersArray;
	    }
	    function transformAsyncGeneratorFunctionBody(node) {
	      const innerParameters = !isSimpleParameterList(node.parameters) ? visitParameterList(node.parameters, visitor, context) : void 0;
	      resumeLexicalEnvironment();
	      const savedCapturedSuperProperties = capturedSuperProperties;
	      const savedHasSuperElementAccess = hasSuperElementAccess;
	      capturedSuperProperties = /* @__PURE__ */ new Set();
	      hasSuperElementAccess = false;
	      const outerStatements = [];
	      let asyncBody = factory2.updateBlock(node.body, visitNodes2(node.body.statements, visitor, isStatement));
	      asyncBody = factory2.updateBlock(asyncBody, factory2.mergeLexicalEnvironment(asyncBody.statements, appendObjectRestAssignmentsIfNeeded(endLexicalEnvironment(), node)));
	      const returnStatement = factory2.createReturnStatement(
	        emitHelpers().createAsyncGeneratorHelper(
	          factory2.createFunctionExpression(
	            /*modifiers*/
	            void 0,
	            factory2.createToken(42 /* AsteriskToken */),
	            node.name && factory2.getGeneratedNameForNode(node.name),
	            /*typeParameters*/
	            void 0,
	            innerParameters ?? [],
	            /*type*/
	            void 0,
	            asyncBody
	          ),
	          !!(hierarchyFacts & 1 /* HasLexicalThis */)
	        )
	      );
	      const emitSuperHelpers = languageVersion >= 2 /* ES2015 */ && resolver.getNodeCheckFlags(node) & (256 /* MethodWithSuperPropertyAssignmentInAsync */ | 128 /* MethodWithSuperPropertyAccessInAsync */);
	      if (emitSuperHelpers) {
	        enableSubstitutionForAsyncMethodsWithSuper();
	        const variableStatement = createSuperAccessVariableStatement(factory2, resolver, node, capturedSuperProperties);
	        substitutedSuperAccessors[getNodeId(variableStatement)] = true;
	        insertStatementsAfterStandardPrologue(outerStatements, [variableStatement]);
	      }
	      outerStatements.push(returnStatement);
	      const block = factory2.updateBlock(node.body, outerStatements);
	      if (emitSuperHelpers && hasSuperElementAccess) {
	        if (resolver.getNodeCheckFlags(node) & 256 /* MethodWithSuperPropertyAssignmentInAsync */) {
	          addEmitHelper(block, advancedAsyncSuperHelper);
	        } else if (resolver.getNodeCheckFlags(node) & 128 /* MethodWithSuperPropertyAccessInAsync */) {
	          addEmitHelper(block, asyncSuperHelper);
	        }
	      }
	      capturedSuperProperties = savedCapturedSuperProperties;
	      hasSuperElementAccess = savedHasSuperElementAccess;
	      return block;
	    }
	    function transformFunctionBody2(node) {
	      resumeLexicalEnvironment();
	      let statementOffset = 0;
	      const statements = [];
	      const body = visitNode(node.body, visitor, isConciseBody) ?? factory2.createBlock([]);
	      if (isBlock(body)) {
	        statementOffset = factory2.copyPrologue(
	          body.statements,
	          statements,
	          /*ensureUseStrict*/
	          false,
	          visitor
	        );
	      }
	      addRange(statements, appendObjectRestAssignmentsIfNeeded(
	        /*statements*/
	        void 0,
	        node
	      ));
	      const leadingStatements = endLexicalEnvironment();
	      if (statementOffset > 0 || some(statements) || some(leadingStatements)) {
	        const block = factory2.converters.convertToFunctionBlock(
	          body,
	          /*multiLine*/
	          true
	        );
	        insertStatementsAfterStandardPrologue(statements, leadingStatements);
	        addRange(statements, block.statements.slice(statementOffset));
	        return factory2.updateBlock(block, setTextRange(factory2.createNodeArray(statements), block.statements));
	      }
	      return body;
	    }
	    function appendObjectRestAssignmentsIfNeeded(statements, node) {
	      let containsPrecedingObjectRestOrSpread = false;
	      for (const parameter of node.parameters) {
	        if (containsPrecedingObjectRestOrSpread) {
	          if (isBindingPattern(parameter.name)) {
	            if (parameter.name.elements.length > 0) {
	              const declarations = flattenDestructuringBinding(
	                parameter,
	                visitor,
	                context,
	                0 /* All */,
	                factory2.getGeneratedNameForNode(parameter)
	              );
	              if (some(declarations)) {
	                const declarationList = factory2.createVariableDeclarationList(declarations);
	                const statement = factory2.createVariableStatement(
	                  /*modifiers*/
	                  void 0,
	                  declarationList
	                );
	                setEmitFlags(statement, 2097152 /* CustomPrologue */);
	                statements = append(statements, statement);
	              }
	            } else if (parameter.initializer) {
	              const name = factory2.getGeneratedNameForNode(parameter);
	              const initializer = visitNode(parameter.initializer, visitor, isExpression);
	              const assignment = factory2.createAssignment(name, initializer);
	              const statement = factory2.createExpressionStatement(assignment);
	              setEmitFlags(statement, 2097152 /* CustomPrologue */);
	              statements = append(statements, statement);
	            }
	          } else if (parameter.initializer) {
	            const name = factory2.cloneNode(parameter.name);
	            setTextRange(name, parameter.name);
	            setEmitFlags(name, 96 /* NoSourceMap */);
	            const initializer = visitNode(parameter.initializer, visitor, isExpression);
	            addEmitFlags(initializer, 96 /* NoSourceMap */ | 3072 /* NoComments */);
	            const assignment = factory2.createAssignment(name, initializer);
	            setTextRange(assignment, parameter);
	            setEmitFlags(assignment, 3072 /* NoComments */);
	            const block = factory2.createBlock([factory2.createExpressionStatement(assignment)]);
	            setTextRange(block, parameter);
	            setEmitFlags(block, 1 /* SingleLine */ | 64 /* NoTrailingSourceMap */ | 768 /* NoTokenSourceMaps */ | 3072 /* NoComments */);
	            const typeCheck = factory2.createTypeCheck(factory2.cloneNode(parameter.name), "undefined");
	            const statement = factory2.createIfStatement(typeCheck, block);
	            startOnNewLine(statement);
	            setTextRange(statement, parameter);
	            setEmitFlags(statement, 768 /* NoTokenSourceMaps */ | 64 /* NoTrailingSourceMap */ | 2097152 /* CustomPrologue */ | 3072 /* NoComments */);
	            statements = append(statements, statement);
	          }
	        } else if (parameter.transformFlags & 65536 /* ContainsObjectRestOrSpread */) {
	          containsPrecedingObjectRestOrSpread = true;
	          const declarations = flattenDestructuringBinding(
	            parameter,
	            visitor,
	            context,
	            1 /* ObjectRest */,
	            factory2.getGeneratedNameForNode(parameter),
	            /*hoistTempVariables*/
	            false,
	            /*skipInitializer*/
	            true
	          );
	          if (some(declarations)) {
	            const declarationList = factory2.createVariableDeclarationList(declarations);
	            const statement = factory2.createVariableStatement(
	              /*modifiers*/
	              void 0,
	              declarationList
	            );
	            setEmitFlags(statement, 2097152 /* CustomPrologue */);
	            statements = append(statements, statement);
	          }
	        }
	      }
	      return statements;
	    }
	    function enableSubstitutionForAsyncMethodsWithSuper() {
	      if ((enabledSubstitutions & 1 /* AsyncMethodsWithSuper */) === 0) {
	        enabledSubstitutions |= 1 /* AsyncMethodsWithSuper */;
	        context.enableSubstitution(213 /* CallExpression */);
	        context.enableSubstitution(211 /* PropertyAccessExpression */);
	        context.enableSubstitution(212 /* ElementAccessExpression */);
	        context.enableEmitNotification(263 /* ClassDeclaration */);
	        context.enableEmitNotification(174 /* MethodDeclaration */);
	        context.enableEmitNotification(177 /* GetAccessor */);
	        context.enableEmitNotification(178 /* SetAccessor */);
	        context.enableEmitNotification(176 /* Constructor */);
	        context.enableEmitNotification(243 /* VariableStatement */);
	      }
	    }
	    function onEmitNode(hint, node, emitCallback) {
	      if (enabledSubstitutions & 1 /* AsyncMethodsWithSuper */ && isSuperContainer(node)) {
	        const superContainerFlags = resolver.getNodeCheckFlags(node) & (128 /* MethodWithSuperPropertyAccessInAsync */ | 256 /* MethodWithSuperPropertyAssignmentInAsync */);
	        if (superContainerFlags !== enclosingSuperContainerFlags) {
	          const savedEnclosingSuperContainerFlags = enclosingSuperContainerFlags;
	          enclosingSuperContainerFlags = superContainerFlags;
	          previousOnEmitNode(hint, node, emitCallback);
	          enclosingSuperContainerFlags = savedEnclosingSuperContainerFlags;
	          return;
	        }
	      } else if (enabledSubstitutions && substitutedSuperAccessors[getNodeId(node)]) {
	        const savedEnclosingSuperContainerFlags = enclosingSuperContainerFlags;
	        enclosingSuperContainerFlags = 0;
	        previousOnEmitNode(hint, node, emitCallback);
	        enclosingSuperContainerFlags = savedEnclosingSuperContainerFlags;
	        return;
	      }
	      previousOnEmitNode(hint, node, emitCallback);
	    }
	    function onSubstituteNode(hint, node) {
	      node = previousOnSubstituteNode(hint, node);
	      if (hint === 1 /* Expression */ && enclosingSuperContainerFlags) {
	        return substituteExpression(node);
	      }
	      return node;
	    }
	    function substituteExpression(node) {
	      switch (node.kind) {
	        case 211 /* PropertyAccessExpression */:
	          return substitutePropertyAccessExpression(node);
	        case 212 /* ElementAccessExpression */:
	          return substituteElementAccessExpression(node);
	        case 213 /* CallExpression */:
	          return substituteCallExpression(node);
	      }
	      return node;
	    }
	    function substitutePropertyAccessExpression(node) {
	      if (node.expression.kind === 108 /* SuperKeyword */) {
	        return setTextRange(
	          factory2.createPropertyAccessExpression(
	            factory2.createUniqueName("_super", 16 /* Optimistic */ | 32 /* FileLevel */),
	            node.name
	          ),
	          node
	        );
	      }
	      return node;
	    }
	    function substituteElementAccessExpression(node) {
	      if (node.expression.kind === 108 /* SuperKeyword */) {
	        return createSuperElementAccessInAsyncMethod(
	          node.argumentExpression,
	          node
	        );
	      }
	      return node;
	    }
	    function substituteCallExpression(node) {
	      const expression = node.expression;
	      if (isSuperProperty(expression)) {
	        const argumentExpression = isPropertyAccessExpression(expression) ? substitutePropertyAccessExpression(expression) : substituteElementAccessExpression(expression);
	        return factory2.createCallExpression(
	          factory2.createPropertyAccessExpression(argumentExpression, "call"),
	          /*typeArguments*/
	          void 0,
	          [
	            factory2.createThis(),
	            ...node.arguments
	          ]
	        );
	      }
	      return node;
	    }
	    function isSuperContainer(node) {
	      const kind = node.kind;
	      return kind === 263 /* ClassDeclaration */ || kind === 176 /* Constructor */ || kind === 174 /* MethodDeclaration */ || kind === 177 /* GetAccessor */ || kind === 178 /* SetAccessor */;
	    }
	    function createSuperElementAccessInAsyncMethod(argumentExpression, location) {
	      if (enclosingSuperContainerFlags & 256 /* MethodWithSuperPropertyAssignmentInAsync */) {
	        return setTextRange(
	          factory2.createPropertyAccessExpression(
	            factory2.createCallExpression(
	              factory2.createIdentifier("_superIndex"),
	              /*typeArguments*/
	              void 0,
	              [argumentExpression]
	            ),
	            "value"
	          ),
	          location
	        );
	      } else {
	        return setTextRange(
	          factory2.createCallExpression(
	            factory2.createIdentifier("_superIndex"),
	            /*typeArguments*/
	            void 0,
	            [argumentExpression]
	          ),
	          location
	        );
	      }
	    }
	  }
	  var init_es2018 = __esm({
	    "src/compiler/transformers/es2018.ts"() {
	      init_ts2();
	    }
	  });

	  // src/compiler/transformers/es2019.ts
	  function transformES2019(context) {
	    const factory2 = context.factory;
	    return chainBundle(context, transformSourceFile);
	    function transformSourceFile(node) {
	      if (node.isDeclarationFile) {
	        return node;
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitor(node) {
	      if ((node.transformFlags & 64 /* ContainsES2019 */) === 0) {
	        return node;
	      }
	      switch (node.kind) {
	        case 299 /* CatchClause */:
	          return visitCatchClause(node);
	        default:
	          return visitEachChild(node, visitor, context);
	      }
	    }
	    function visitCatchClause(node) {
	      if (!node.variableDeclaration) {
	        return factory2.updateCatchClause(
	          node,
	          factory2.createVariableDeclaration(factory2.createTempVariable(
	            /*recordTempVariable*/
	            void 0
	          )),
	          visitNode(node.block, visitor, isBlock)
	        );
	      }
	      return visitEachChild(node, visitor, context);
	    }
	  }
	  var init_es2019 = __esm({
	    "src/compiler/transformers/es2019.ts"() {
	      init_ts2();
	    }
	  });

	  // src/compiler/transformers/es2020.ts
	  function transformES2020(context) {
	    const {
	      factory: factory2,
	      hoistVariableDeclaration
	    } = context;
	    return chainBundle(context, transformSourceFile);
	    function transformSourceFile(node) {
	      if (node.isDeclarationFile) {
	        return node;
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitor(node) {
	      if ((node.transformFlags & 32 /* ContainsES2020 */) === 0) {
	        return node;
	      }
	      switch (node.kind) {
	        case 213 /* CallExpression */: {
	          const updated = visitNonOptionalCallExpression(
	            node,
	            /*captureThisArg*/
	            false
	          );
	          Debug.assertNotNode(updated, isSyntheticReference);
	          return updated;
	        }
	        case 211 /* PropertyAccessExpression */:
	        case 212 /* ElementAccessExpression */:
	          if (isOptionalChain(node)) {
	            const updated = visitOptionalExpression(
	              node,
	              /*captureThisArg*/
	              false,
	              /*isDelete*/
	              false
	            );
	            Debug.assertNotNode(updated, isSyntheticReference);
	            return updated;
	          }
	          return visitEachChild(node, visitor, context);
	        case 226 /* BinaryExpression */:
	          if (node.operatorToken.kind === 61 /* QuestionQuestionToken */) {
	            return transformNullishCoalescingExpression(node);
	          }
	          return visitEachChild(node, visitor, context);
	        case 220 /* DeleteExpression */:
	          return visitDeleteExpression(node);
	        default:
	          return visitEachChild(node, visitor, context);
	      }
	    }
	    function flattenChain(chain) {
	      Debug.assertNotNode(chain, isNonNullChain);
	      const links = [chain];
	      while (!chain.questionDotToken && !isTaggedTemplateExpression(chain)) {
	        chain = cast(skipPartiallyEmittedExpressions(chain.expression), isOptionalChain);
	        Debug.assertNotNode(chain, isNonNullChain);
	        links.unshift(chain);
	      }
	      return { expression: chain.expression, chain: links };
	    }
	    function visitNonOptionalParenthesizedExpression(node, captureThisArg, isDelete) {
	      const expression = visitNonOptionalExpression(node.expression, captureThisArg, isDelete);
	      if (isSyntheticReference(expression)) {
	        return factory2.createSyntheticReferenceExpression(factory2.updateParenthesizedExpression(node, expression.expression), expression.thisArg);
	      }
	      return factory2.updateParenthesizedExpression(node, expression);
	    }
	    function visitNonOptionalPropertyOrElementAccessExpression(node, captureThisArg, isDelete) {
	      if (isOptionalChain(node)) {
	        return visitOptionalExpression(node, captureThisArg, isDelete);
	      }
	      let expression = visitNode(node.expression, visitor, isExpression);
	      Debug.assertNotNode(expression, isSyntheticReference);
	      let thisArg;
	      if (captureThisArg) {
	        if (!isSimpleCopiableExpression(expression)) {
	          thisArg = factory2.createTempVariable(hoistVariableDeclaration);
	          expression = factory2.createAssignment(thisArg, expression);
	        } else {
	          thisArg = expression;
	        }
	      }
	      expression = node.kind === 211 /* PropertyAccessExpression */ ? factory2.updatePropertyAccessExpression(node, expression, visitNode(node.name, visitor, isIdentifier)) : factory2.updateElementAccessExpression(node, expression, visitNode(node.argumentExpression, visitor, isExpression));
	      return thisArg ? factory2.createSyntheticReferenceExpression(expression, thisArg) : expression;
	    }
	    function visitNonOptionalCallExpression(node, captureThisArg) {
	      if (isOptionalChain(node)) {
	        return visitOptionalExpression(
	          node,
	          captureThisArg,
	          /*isDelete*/
	          false
	        );
	      }
	      if (isParenthesizedExpression(node.expression) && isOptionalChain(skipParentheses(node.expression))) {
	        const expression = visitNonOptionalParenthesizedExpression(
	          node.expression,
	          /*captureThisArg*/
	          true,
	          /*isDelete*/
	          false
	        );
	        const args = visitNodes2(node.arguments, visitor, isExpression);
	        if (isSyntheticReference(expression)) {
	          return setTextRange(factory2.createFunctionCallCall(expression.expression, expression.thisArg, args), node);
	        }
	        return factory2.updateCallExpression(
	          node,
	          expression,
	          /*typeArguments*/
	          void 0,
	          args
	        );
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitNonOptionalExpression(node, captureThisArg, isDelete) {
	      switch (node.kind) {
	        case 217 /* ParenthesizedExpression */:
	          return visitNonOptionalParenthesizedExpression(node, captureThisArg, isDelete);
	        case 211 /* PropertyAccessExpression */:
	        case 212 /* ElementAccessExpression */:
	          return visitNonOptionalPropertyOrElementAccessExpression(node, captureThisArg, isDelete);
	        case 213 /* CallExpression */:
	          return visitNonOptionalCallExpression(node, captureThisArg);
	        default:
	          return visitNode(node, visitor, isExpression);
	      }
	    }
	    function visitOptionalExpression(node, captureThisArg, isDelete) {
	      const { expression, chain } = flattenChain(node);
	      const left = visitNonOptionalExpression(
	        skipPartiallyEmittedExpressions(expression),
	        isCallChain(chain[0]),
	        /*isDelete*/
	        false
	      );
	      let leftThisArg = isSyntheticReference(left) ? left.thisArg : void 0;
	      let capturedLeft = isSyntheticReference(left) ? left.expression : left;
	      let leftExpression = factory2.restoreOuterExpressions(expression, capturedLeft, 8 /* PartiallyEmittedExpressions */);
	      if (!isSimpleCopiableExpression(capturedLeft)) {
	        capturedLeft = factory2.createTempVariable(hoistVariableDeclaration);
	        leftExpression = factory2.createAssignment(capturedLeft, leftExpression);
	      }
	      let rightExpression = capturedLeft;
	      let thisArg;
	      for (let i = 0; i < chain.length; i++) {
	        const segment = chain[i];
	        switch (segment.kind) {
	          case 211 /* PropertyAccessExpression */:
	          case 212 /* ElementAccessExpression */:
	            if (i === chain.length - 1 && captureThisArg) {
	              if (!isSimpleCopiableExpression(rightExpression)) {
	                thisArg = factory2.createTempVariable(hoistVariableDeclaration);
	                rightExpression = factory2.createAssignment(thisArg, rightExpression);
	              } else {
	                thisArg = rightExpression;
	              }
	            }
	            rightExpression = segment.kind === 211 /* PropertyAccessExpression */ ? factory2.createPropertyAccessExpression(rightExpression, visitNode(segment.name, visitor, isIdentifier)) : factory2.createElementAccessExpression(rightExpression, visitNode(segment.argumentExpression, visitor, isExpression));
	            break;
	          case 213 /* CallExpression */:
	            if (i === 0 && leftThisArg) {
	              if (!isGeneratedIdentifier(leftThisArg)) {
	                leftThisArg = factory2.cloneNode(leftThisArg);
	                addEmitFlags(leftThisArg, 3072 /* NoComments */);
	              }
	              rightExpression = factory2.createFunctionCallCall(
	                rightExpression,
	                leftThisArg.kind === 108 /* SuperKeyword */ ? factory2.createThis() : leftThisArg,
	                visitNodes2(segment.arguments, visitor, isExpression)
	              );
	            } else {
	              rightExpression = factory2.createCallExpression(
	                rightExpression,
	                /*typeArguments*/
	                void 0,
	                visitNodes2(segment.arguments, visitor, isExpression)
	              );
	            }
	            break;
	        }
	        setOriginalNode(rightExpression, segment);
	      }
	      const target = isDelete ? factory2.createConditionalExpression(
	        createNotNullCondition(
	          leftExpression,
	          capturedLeft,
	          /*invert*/
	          true
	        ),
	        /*questionToken*/
	        void 0,
	        factory2.createTrue(),
	        /*colonToken*/
	        void 0,
	        factory2.createDeleteExpression(rightExpression)
	      ) : factory2.createConditionalExpression(
	        createNotNullCondition(
	          leftExpression,
	          capturedLeft,
	          /*invert*/
	          true
	        ),
	        /*questionToken*/
	        void 0,
	        factory2.createVoidZero(),
	        /*colonToken*/
	        void 0,
	        rightExpression
	      );
	      setTextRange(target, node);
	      return thisArg ? factory2.createSyntheticReferenceExpression(target, thisArg) : target;
	    }
	    function createNotNullCondition(left, right, invert) {
	      return factory2.createBinaryExpression(
	        factory2.createBinaryExpression(
	          left,
	          factory2.createToken(invert ? 37 /* EqualsEqualsEqualsToken */ : 38 /* ExclamationEqualsEqualsToken */),
	          factory2.createNull()
	        ),
	        factory2.createToken(invert ? 57 /* BarBarToken */ : 56 /* AmpersandAmpersandToken */),
	        factory2.createBinaryExpression(
	          right,
	          factory2.createToken(invert ? 37 /* EqualsEqualsEqualsToken */ : 38 /* ExclamationEqualsEqualsToken */),
	          factory2.createVoidZero()
	        )
	      );
	    }
	    function transformNullishCoalescingExpression(node) {
	      let left = visitNode(node.left, visitor, isExpression);
	      let right = left;
	      if (!isSimpleCopiableExpression(left)) {
	        right = factory2.createTempVariable(hoistVariableDeclaration);
	        left = factory2.createAssignment(right, left);
	      }
	      return setTextRange(
	        factory2.createConditionalExpression(
	          createNotNullCondition(left, right),
	          /*questionToken*/
	          void 0,
	          right,
	          /*colonToken*/
	          void 0,
	          visitNode(node.right, visitor, isExpression)
	        ),
	        node
	      );
	    }
	    function visitDeleteExpression(node) {
	      return isOptionalChain(skipParentheses(node.expression)) ? setOriginalNode(visitNonOptionalExpression(
	        node.expression,
	        /*captureThisArg*/
	        false,
	        /*isDelete*/
	        true
	      ), node) : factory2.updateDeleteExpression(node, visitNode(node.expression, visitor, isExpression));
	    }
	  }
	  var init_es2020 = __esm({
	    "src/compiler/transformers/es2020.ts"() {
	      init_ts2();
	    }
	  });

	  // src/compiler/transformers/es2021.ts
	  function transformES2021(context) {
	    const {
	      hoistVariableDeclaration,
	      factory: factory2
	    } = context;
	    return chainBundle(context, transformSourceFile);
	    function transformSourceFile(node) {
	      if (node.isDeclarationFile) {
	        return node;
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitor(node) {
	      if ((node.transformFlags & 16 /* ContainsES2021 */) === 0) {
	        return node;
	      }
	      if (isLogicalOrCoalescingAssignmentExpression(node)) {
	        return transformLogicalAssignment(node);
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function transformLogicalAssignment(binaryExpression) {
	      const operator = binaryExpression.operatorToken;
	      const nonAssignmentOperator = getNonAssignmentOperatorForCompoundAssignment(operator.kind);
	      let left = skipParentheses(visitNode(binaryExpression.left, visitor, isLeftHandSideExpression));
	      let assignmentTarget = left;
	      const right = skipParentheses(visitNode(binaryExpression.right, visitor, isExpression));
	      if (isAccessExpression(left)) {
	        const propertyAccessTargetSimpleCopiable = isSimpleCopiableExpression(left.expression);
	        const propertyAccessTarget = propertyAccessTargetSimpleCopiable ? left.expression : factory2.createTempVariable(hoistVariableDeclaration);
	        const propertyAccessTargetAssignment = propertyAccessTargetSimpleCopiable ? left.expression : factory2.createAssignment(
	          propertyAccessTarget,
	          left.expression
	        );
	        if (isPropertyAccessExpression(left)) {
	          assignmentTarget = factory2.createPropertyAccessExpression(
	            propertyAccessTarget,
	            left.name
	          );
	          left = factory2.createPropertyAccessExpression(
	            propertyAccessTargetAssignment,
	            left.name
	          );
	        } else {
	          const elementAccessArgumentSimpleCopiable = isSimpleCopiableExpression(left.argumentExpression);
	          const elementAccessArgument = elementAccessArgumentSimpleCopiable ? left.argumentExpression : factory2.createTempVariable(hoistVariableDeclaration);
	          assignmentTarget = factory2.createElementAccessExpression(
	            propertyAccessTarget,
	            elementAccessArgument
	          );
	          left = factory2.createElementAccessExpression(
	            propertyAccessTargetAssignment,
	            elementAccessArgumentSimpleCopiable ? left.argumentExpression : factory2.createAssignment(
	              elementAccessArgument,
	              left.argumentExpression
	            )
	          );
	        }
	      }
	      return factory2.createBinaryExpression(
	        left,
	        nonAssignmentOperator,
	        factory2.createParenthesizedExpression(
	          factory2.createAssignment(
	            assignmentTarget,
	            right
	          )
	        )
	      );
	    }
	  }
	  var init_es2021 = __esm({
	    "src/compiler/transformers/es2021.ts"() {
	      init_ts2();
	    }
	  });

	  // src/compiler/transformers/esnext.ts
	  function transformESNext(context) {
	    const {
	      factory: factory2,
	      getEmitHelperFactory: emitHelpers,
	      hoistVariableDeclaration,
	      startLexicalEnvironment,
	      endLexicalEnvironment
	    } = context;
	    let exportBindings;
	    let exportVars;
	    let defaultExportBinding;
	    let exportEqualsBinding;
	    return chainBundle(context, transformSourceFile);
	    function transformSourceFile(node) {
	      if (node.isDeclarationFile) {
	        return node;
	      }
	      const visited = visitNode(node, visitor, isSourceFile);
	      addEmitHelpers(visited, context.readEmitHelpers());
	      exportVars = void 0;
	      exportBindings = void 0;
	      defaultExportBinding = void 0;
	      return visited;
	    }
	    function visitor(node) {
	      if ((node.transformFlags & 4 /* ContainsESNext */) === 0) {
	        return node;
	      }
	      switch (node.kind) {
	        case 312 /* SourceFile */:
	          return visitSourceFile(node);
	        case 241 /* Block */:
	          return visitBlock(node);
	        case 248 /* ForStatement */:
	          return visitForStatement(node);
	        case 250 /* ForOfStatement */:
	          return visitForOfStatement(node);
	        case 255 /* SwitchStatement */:
	          return visitSwitchStatement(node);
	        default:
	          return visitEachChild(node, visitor, context);
	      }
	    }
	    function visitSourceFile(node) {
	      const usingKind = getUsingKindOfStatements(node.statements);
	      if (usingKind) {
	        startLexicalEnvironment();
	        exportBindings = new IdentifierNameMap();
	        exportVars = [];
	        const prologueCount = countPrologueStatements(node.statements);
	        const topLevelStatements = [];
	        addRange(topLevelStatements, visitArray(node.statements, visitor, isStatement, 0, prologueCount));
	        let pos = prologueCount;
	        while (pos < node.statements.length) {
	          const statement = node.statements[pos];
	          if (getUsingKind(statement) !== 0 /* None */) {
	            if (pos > prologueCount) {
	              addRange(topLevelStatements, visitNodes2(node.statements, visitor, isStatement, prologueCount, pos - prologueCount));
	            }
	            break;
	          }
	          pos++;
	        }
	        Debug.assert(pos < node.statements.length, "Should have encountered at least one 'using' statement.");
	        const envBinding = createEnvBinding();
	        const bodyStatements = transformUsingDeclarations(node.statements, pos, node.statements.length, envBinding, topLevelStatements);
	        if (exportBindings.size) {
	          append(
	            topLevelStatements,
	            factory2.createExportDeclaration(
	              /*modifiers*/
	              void 0,
	              /*isTypeOnly*/
	              false,
	              factory2.createNamedExports(arrayFrom(exportBindings.values()))
	            )
	          );
	        }
	        addRange(topLevelStatements, endLexicalEnvironment());
	        if (exportVars.length) {
	          topLevelStatements.push(factory2.createVariableStatement(
	            factory2.createModifiersFromModifierFlags(32 /* Export */),
	            factory2.createVariableDeclarationList(
	              exportVars,
	              1 /* Let */
	            )
	          ));
	        }
	        addRange(topLevelStatements, createDownlevelUsingStatements(bodyStatements, envBinding, usingKind === 2 /* Async */));
	        if (exportEqualsBinding) {
	          topLevelStatements.push(factory2.createExportAssignment(
	            /*modifiers*/
	            void 0,
	            /*isExportEquals*/
	            true,
	            exportEqualsBinding
	          ));
	        }
	        return factory2.updateSourceFile(node, topLevelStatements);
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitBlock(node) {
	      const usingKind = getUsingKindOfStatements(node.statements);
	      if (usingKind) {
	        const prologueCount = countPrologueStatements(node.statements);
	        const envBinding = createEnvBinding();
	        return factory2.updateBlock(
	          node,
	          [
	            ...visitArray(node.statements, visitor, isStatement, 0, prologueCount),
	            ...createDownlevelUsingStatements(
	              transformUsingDeclarations(
	                node.statements,
	                prologueCount,
	                node.statements.length,
	                envBinding,
	                /*topLevelStatements*/
	                void 0
	              ),
	              envBinding,
	              usingKind === 2 /* Async */
	            )
	          ]
	        );
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitForStatement(node) {
	      if (node.initializer && isUsingVariableDeclarationList(node.initializer)) {
	        return visitNode(
	          factory2.createBlock([
	            factory2.createVariableStatement(
	              /*modifiers*/
	              void 0,
	              node.initializer
	            ),
	            factory2.updateForStatement(
	              node,
	              /*initializer*/
	              void 0,
	              node.condition,
	              node.incrementor,
	              node.statement
	            )
	          ]),
	          visitor,
	          isStatement
	        );
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitForOfStatement(node) {
	      if (isUsingVariableDeclarationList(node.initializer)) {
	        const forInitializer = node.initializer;
	        Debug.assertNode(forInitializer, isUsingVariableDeclarationList);
	        Debug.assert(forInitializer.declarations.length === 1, "ForInitializer may only have one declaration");
	        const forDecl = forInitializer.declarations[0];
	        Debug.assert(!forDecl.initializer, "ForInitializer may not have an initializer");
	        const isAwaitUsing = getUsingKindOfVariableDeclarationList(forInitializer) === 2 /* Async */;
	        const temp = factory2.getGeneratedNameForNode(forDecl.name);
	        const usingVar = factory2.updateVariableDeclaration(
	          forDecl,
	          forDecl.name,
	          /*exclamationToken*/
	          void 0,
	          /*type*/
	          void 0,
	          temp
	        );
	        const usingVarList = factory2.createVariableDeclarationList([usingVar], isAwaitUsing ? 6 /* AwaitUsing */ : 4 /* Using */);
	        const usingVarStatement = factory2.createVariableStatement(
	          /*modifiers*/
	          void 0,
	          usingVarList
	        );
	        return visitNode(
	          factory2.updateForOfStatement(
	            node,
	            node.awaitModifier,
	            factory2.createVariableDeclarationList([
	              factory2.createVariableDeclaration(temp)
	            ], 2 /* Const */),
	            node.expression,
	            isBlock(node.statement) ? factory2.updateBlock(node.statement, [
	              usingVarStatement,
	              ...node.statement.statements
	            ]) : factory2.createBlock(
	              [
	                usingVarStatement,
	                node.statement
	              ],
	              /*multiLine*/
	              true
	            )
	          ),
	          visitor,
	          isStatement
	        );
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitCaseOrDefaultClause(node, envBinding) {
	      if (getUsingKindOfStatements(node.statements) !== 0 /* None */) {
	        if (isCaseClause(node)) {
	          return factory2.updateCaseClause(
	            node,
	            visitNode(node.expression, visitor, isExpression),
	            transformUsingDeclarations(
	              node.statements,
	              /*start*/
	              0,
	              node.statements.length,
	              envBinding,
	              /*topLevelStatements*/
	              void 0
	            )
	          );
	        } else {
	          return factory2.updateDefaultClause(
	            node,
	            transformUsingDeclarations(
	              node.statements,
	              /*start*/
	              0,
	              node.statements.length,
	              envBinding,
	              /*topLevelStatements*/
	              void 0
	            )
	          );
	        }
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitSwitchStatement(node) {
	      const usingKind = getUsingKindOfCaseOrDefaultClauses(node.caseBlock.clauses);
	      if (usingKind) {
	        const envBinding = createEnvBinding();
	        return createDownlevelUsingStatements(
	          [
	            factory2.updateSwitchStatement(
	              node,
	              visitNode(node.expression, visitor, isExpression),
	              factory2.updateCaseBlock(
	                node.caseBlock,
	                node.caseBlock.clauses.map((clause) => visitCaseOrDefaultClause(clause, envBinding))
	              )
	            )
	          ],
	          envBinding,
	          usingKind === 2 /* Async */
	        );
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function transformUsingDeclarations(statementsIn, start, end, envBinding, topLevelStatements) {
	      const statements = [];
	      for (let i = start; i < end; i++) {
	        const statement = statementsIn[i];
	        const usingKind = getUsingKind(statement);
	        if (usingKind) {
	          Debug.assertNode(statement, isVariableStatement);
	          const declarations = [];
	          for (let declaration of statement.declarationList.declarations) {
	            if (!isIdentifier(declaration.name)) {
	              declarations.length = 0;
	              break;
	            }
	            if (isNamedEvaluation(declaration)) {
	              declaration = transformNamedEvaluation(context, declaration);
	            }
	            const initializer = visitNode(declaration.initializer, visitor, isExpression) ?? factory2.createVoidZero();
	            declarations.push(factory2.updateVariableDeclaration(
	              declaration,
	              declaration.name,
	              /*exclamationToken*/
	              void 0,
	              /*type*/
	              void 0,
	              emitHelpers().createAddDisposableResourceHelper(
	                envBinding,
	                initializer,
	                usingKind === 2 /* Async */
	              )
	            ));
	          }
	          if (declarations.length) {
	            const varList = factory2.createVariableDeclarationList(declarations, 2 /* Const */);
	            setOriginalNode(varList, statement.declarationList);
	            setTextRange(varList, statement.declarationList);
	            hoistOrAppendNode(factory2.updateVariableStatement(
	              statement,
	              /*modifiers*/
	              void 0,
	              varList
	            ));
	            continue;
	          }
	        }
	        const result = visitor(statement);
	        if (isArray(result)) {
	          result.forEach(hoistOrAppendNode);
	        } else if (result) {
	          hoistOrAppendNode(result);
	        }
	      }
	      return statements;
	      function hoistOrAppendNode(node) {
	        Debug.assertNode(node, isStatement);
	        append(statements, hoist(node));
	      }
	      function hoist(node) {
	        if (!topLevelStatements)
	          return node;
	        switch (node.kind) {
	          case 272 /* ImportDeclaration */:
	          case 271 /* ImportEqualsDeclaration */:
	          case 278 /* ExportDeclaration */:
	          case 262 /* FunctionDeclaration */:
	            return hoistImportOrExportOrHoistedDeclaration(node, topLevelStatements);
	          case 277 /* ExportAssignment */:
	            return hoistExportAssignment(node);
	          case 263 /* ClassDeclaration */:
	            return hoistClassDeclaration(node);
	          case 243 /* VariableStatement */:
	            return hoistVariableStatement(node);
	        }
	        return node;
	      }
	    }
	    function hoistImportOrExportOrHoistedDeclaration(node, topLevelStatements) {
	      topLevelStatements.push(node);
	      return void 0;
	    }
	    function hoistExportAssignment(node) {
	      return node.isExportEquals ? hoistExportEquals(node) : hoistExportDefault(node);
	    }
	    function hoistExportDefault(node) {
	      if (defaultExportBinding) {
	        return node;
	      }
	      defaultExportBinding = factory2.createUniqueName("_default", 8 /* ReservedInNestedScopes */ | 32 /* FileLevel */ | 16 /* Optimistic */);
	      hoistBindingIdentifier(
	        defaultExportBinding,
	        /*isExport*/
	        true,
	        "default",
	        node
	      );
	      let expression = node.expression;
	      let innerExpression = skipOuterExpressions(expression);
	      if (isNamedEvaluation(innerExpression)) {
	        innerExpression = transformNamedEvaluation(
	          context,
	          innerExpression,
	          /*ignoreEmptyStringLiteral*/
	          false,
	          "default"
	        );
	        expression = factory2.restoreOuterExpressions(expression, innerExpression);
	      }
	      const assignment = factory2.createAssignment(defaultExportBinding, expression);
	      return factory2.createExpressionStatement(assignment);
	    }
	    function hoistExportEquals(node) {
	      if (exportEqualsBinding) {
	        return node;
	      }
	      exportEqualsBinding = factory2.createUniqueName("_default", 8 /* ReservedInNestedScopes */ | 32 /* FileLevel */ | 16 /* Optimistic */);
	      hoistVariableDeclaration(exportEqualsBinding);
	      const assignment = factory2.createAssignment(exportEqualsBinding, node.expression);
	      return factory2.createExpressionStatement(assignment);
	    }
	    function hoistClassDeclaration(node) {
	      if (!node.name && defaultExportBinding) {
	        return node;
	      }
	      const isExported2 = hasSyntacticModifier(node, 32 /* Export */);
	      const isDefault = hasSyntacticModifier(node, 2048 /* Default */);
	      let expression = factory2.converters.convertToClassExpression(node);
	      if (node.name) {
	        hoistBindingIdentifier(
	          factory2.getLocalName(node),
	          isExported2 && !isDefault,
	          /*exportAlias*/
	          void 0,
	          node
	        );
	        expression = factory2.createAssignment(factory2.getDeclarationName(node), expression);
	        if (isNamedEvaluation(expression)) {
	          expression = transformNamedEvaluation(
	            context,
	            expression,
	            /*ignoreEmptyStringLiteral*/
	            false
	          );
	        }
	        setOriginalNode(expression, node);
	        setSourceMapRange(expression, node);
	        setCommentRange(expression, node);
	      }
	      if (isDefault && !defaultExportBinding) {
	        defaultExportBinding = factory2.createUniqueName("_default", 8 /* ReservedInNestedScopes */ | 32 /* FileLevel */ | 16 /* Optimistic */);
	        hoistBindingIdentifier(
	          defaultExportBinding,
	          /*isExport*/
	          true,
	          "default",
	          node
	        );
	        expression = factory2.createAssignment(defaultExportBinding, expression);
	        if (isNamedEvaluation(expression)) {
	          expression = transformNamedEvaluation(
	            context,
	            expression,
	            /*ignoreEmptyStringLiteral*/
	            false,
	            "default"
	          );
	        }
	        setOriginalNode(expression, node);
	      }
	      return factory2.createExpressionStatement(expression);
	    }
	    function hoistVariableStatement(node) {
	      let expressions;
	      const isExported2 = hasSyntacticModifier(node, 32 /* Export */);
	      for (const variable of node.declarationList.declarations) {
	        hoistBindingElement(variable, isExported2, variable);
	        if (variable.initializer) {
	          expressions = append(expressions, hoistInitializedVariable(variable));
	        }
	      }
	      if (expressions) {
	        const statement = factory2.createExpressionStatement(factory2.inlineExpressions(expressions));
	        setOriginalNode(statement, node);
	        setCommentRange(statement, node);
	        setSourceMapRange(statement, node);
	        return statement;
	      }
	      return void 0;
	    }
	    function hoistInitializedVariable(node) {
	      Debug.assertIsDefined(node.initializer);
	      let target;
	      if (isIdentifier(node.name)) {
	        target = factory2.cloneNode(node.name);
	        setEmitFlags(target, getEmitFlags(target) & ~(32768 /* LocalName */ | 16384 /* ExportName */ | 65536 /* InternalName */));
	      } else {
	        target = factory2.converters.convertToAssignmentPattern(node.name);
	      }
	      const assignment = factory2.createAssignment(target, node.initializer);
	      setOriginalNode(assignment, node);
	      setCommentRange(assignment, node);
	      setSourceMapRange(assignment, node);
	      return assignment;
	    }
	    function hoistBindingElement(node, isExportedDeclaration, original) {
	      if (isBindingPattern(node.name)) {
	        for (const element of node.name.elements) {
	          if (!isOmittedExpression(element)) {
	            hoistBindingElement(element, isExportedDeclaration, original);
	          }
	        }
	      } else {
	        hoistBindingIdentifier(
	          node.name,
	          isExportedDeclaration,
	          /*exportAlias*/
	          void 0,
	          original
	        );
	      }
	    }
	    function hoistBindingIdentifier(node, isExport, exportAlias, original) {
	      const name = isGeneratedIdentifier(node) ? node : factory2.cloneNode(node);
	      if (isExport) {
	        if (exportAlias === void 0 && !isLocalName(name)) {
	          const varDecl = factory2.createVariableDeclaration(name);
	          if (original) {
	            setOriginalNode(varDecl, original);
	          }
	          exportVars.push(varDecl);
	          return;
	        }
	        const localName = exportAlias !== void 0 ? name : void 0;
	        const exportName = exportAlias !== void 0 ? exportAlias : name;
	        const specifier = factory2.createExportSpecifier(
	          /*isTypeOnly*/
	          false,
	          localName,
	          exportName
	        );
	        if (original) {
	          setOriginalNode(specifier, original);
	        }
	        exportBindings.set(name, specifier);
	      }
	      hoistVariableDeclaration(name);
	    }
	    function createEnvBinding() {
	      return factory2.createUniqueName("env");
	    }
	    function createDownlevelUsingStatements(bodyStatements, envBinding, async) {
	      const statements = [];
	      const envObject = factory2.createObjectLiteralExpression([
	        factory2.createPropertyAssignment("stack", factory2.createArrayLiteralExpression()),
	        factory2.createPropertyAssignment("error", factory2.createVoidZero()),
	        factory2.createPropertyAssignment("hasError", factory2.createFalse())
	      ]);
	      const envVar = factory2.createVariableDeclaration(
	        envBinding,
	        /*exclamationToken*/
	        void 0,
	        /*type*/
	        void 0,
	        envObject
	      );
	      const envVarList = factory2.createVariableDeclarationList([envVar], 2 /* Const */);
	      const envVarStatement = factory2.createVariableStatement(
	        /*modifiers*/
	        void 0,
	        envVarList
	      );
	      statements.push(envVarStatement);
	      const tryBlock = factory2.createBlock(
	        bodyStatements,
	        /*multiLine*/
	        true
	      );
	      const bodyCatchBinding = factory2.createUniqueName("e");
	      const catchClause = factory2.createCatchClause(
	        bodyCatchBinding,
	        factory2.createBlock(
	          [
	            factory2.createExpressionStatement(
	              factory2.createAssignment(
	                factory2.createPropertyAccessExpression(envBinding, "error"),
	                bodyCatchBinding
	              )
	            ),
	            factory2.createExpressionStatement(
	              factory2.createAssignment(
	                factory2.createPropertyAccessExpression(envBinding, "hasError"),
	                factory2.createTrue()
	              )
	            )
	          ],
	          /*multiLine*/
	          true
	        )
	      );
	      let finallyBlock;
	      if (async) {
	        const result = factory2.createUniqueName("result");
	        finallyBlock = factory2.createBlock(
	          [
	            factory2.createVariableStatement(
	              /*modifiers*/
	              void 0,
	              factory2.createVariableDeclarationList([
	                factory2.createVariableDeclaration(
	                  result,
	                  /*exclamationToken*/
	                  void 0,
	                  /*type*/
	                  void 0,
	                  emitHelpers().createDisposeResourcesHelper(envBinding)
	                )
	              ], 2 /* Const */)
	            ),
	            factory2.createIfStatement(result, factory2.createExpressionStatement(factory2.createAwaitExpression(result)))
	          ],
	          /*multiLine*/
	          true
	        );
	      } else {
	        finallyBlock = factory2.createBlock(
	          [
	            factory2.createExpressionStatement(
	              emitHelpers().createDisposeResourcesHelper(envBinding)
	            )
	          ],
	          /*multiLine*/
	          true
	        );
	      }
	      const tryStatement = factory2.createTryStatement(tryBlock, catchClause, finallyBlock);
	      statements.push(tryStatement);
	      return statements;
	    }
	  }
	  function countPrologueStatements(statements) {
	    for (let i = 0; i < statements.length; i++) {
	      if (!isPrologueDirective(statements[i]) && !isCustomPrologue(statements[i])) {
	        return i;
	      }
	    }
	    return 0;
	  }
	  function isUsingVariableDeclarationList(node) {
	    return isVariableDeclarationList(node) && getUsingKindOfVariableDeclarationList(node) !== 0 /* None */;
	  }
	  function getUsingKindOfVariableDeclarationList(node) {
	    return (node.flags & 7 /* BlockScoped */) === 6 /* AwaitUsing */ ? 2 /* Async */ : (node.flags & 7 /* BlockScoped */) === 4 /* Using */ ? 1 /* Sync */ : 0 /* None */;
	  }
	  function getUsingKindOfVariableStatement(node) {
	    return getUsingKindOfVariableDeclarationList(node.declarationList);
	  }
	  function getUsingKind(statement) {
	    return isVariableStatement(statement) ? getUsingKindOfVariableStatement(statement) : 0 /* None */;
	  }
	  function getUsingKindOfStatements(statements) {
	    let result = 0 /* None */;
	    for (const statement of statements) {
	      const usingKind = getUsingKind(statement);
	      if (usingKind === 2 /* Async */)
	        return 2 /* Async */;
	      if (usingKind > result)
	        result = usingKind;
	    }
	    return result;
	  }
	  function getUsingKindOfCaseOrDefaultClauses(clauses) {
	    let result = 0 /* None */;
	    for (const clause of clauses) {
	      const usingKind = getUsingKindOfStatements(clause.statements);
	      if (usingKind === 2 /* Async */)
	        return 2 /* Async */;
	      if (usingKind > result)
	        result = usingKind;
	    }
	    return result;
	  }
	  var init_esnext = __esm({
	    "src/compiler/transformers/esnext.ts"() {
	      init_ts2();
	    }
	  });

	  // src/compiler/transformers/jsx.ts
	  function transformJsx(context) {
	    const {
	      factory: factory2,
	      getEmitHelperFactory: emitHelpers
	    } = context;
	    const compilerOptions = context.getCompilerOptions();
	    let currentSourceFile;
	    let currentFileState;
	    return chainBundle(context, transformSourceFile);
	    function getCurrentFileNameExpression() {
	      if (currentFileState.filenameDeclaration) {
	        return currentFileState.filenameDeclaration.name;
	      }
	      const declaration = factory2.createVariableDeclaration(
	        factory2.createUniqueName("_jsxFileName", 16 /* Optimistic */ | 32 /* FileLevel */),
	        /*exclamationToken*/
	        void 0,
	        /*type*/
	        void 0,
	        factory2.createStringLiteral(currentSourceFile.fileName)
	      );
	      currentFileState.filenameDeclaration = declaration;
	      return currentFileState.filenameDeclaration.name;
	    }
	    function getJsxFactoryCalleePrimitive(isStaticChildren) {
	      return compilerOptions.jsx === 5 /* ReactJSXDev */ ? "jsxDEV" : isStaticChildren ? "jsxs" : "jsx";
	    }
	    function getJsxFactoryCallee(isStaticChildren) {
	      const type = getJsxFactoryCalleePrimitive(isStaticChildren);
	      return getImplicitImportForName(type);
	    }
	    function getImplicitJsxFragmentReference() {
	      return getImplicitImportForName("Fragment");
	    }
	    function getImplicitImportForName(name) {
	      var _a, _b;
	      const importSource = name === "createElement" ? currentFileState.importSpecifier : getJSXRuntimeImport(currentFileState.importSpecifier, compilerOptions);
	      const existing = (_b = (_a = currentFileState.utilizedImplicitRuntimeImports) == null ? void 0 : _a.get(importSource)) == null ? void 0 : _b.get(name);
	      if (existing) {
	        return existing.name;
	      }
	      if (!currentFileState.utilizedImplicitRuntimeImports) {
	        currentFileState.utilizedImplicitRuntimeImports = /* @__PURE__ */ new Map();
	      }
	      let specifierSourceImports = currentFileState.utilizedImplicitRuntimeImports.get(importSource);
	      if (!specifierSourceImports) {
	        specifierSourceImports = /* @__PURE__ */ new Map();
	        currentFileState.utilizedImplicitRuntimeImports.set(importSource, specifierSourceImports);
	      }
	      const generatedName = factory2.createUniqueName(`_${name}`, 16 /* Optimistic */ | 32 /* FileLevel */ | 64 /* AllowNameSubstitution */);
	      const specifier = factory2.createImportSpecifier(
	        /*isTypeOnly*/
	        false,
	        factory2.createIdentifier(name),
	        generatedName
	      );
	      setIdentifierGeneratedImportReference(generatedName, specifier);
	      specifierSourceImports.set(name, specifier);
	      return generatedName;
	    }
	    function transformSourceFile(node) {
	      if (node.isDeclarationFile) {
	        return node;
	      }
	      currentSourceFile = node;
	      currentFileState = {};
	      currentFileState.importSpecifier = getJSXImplicitImportBase(compilerOptions, node);
	      let visited = visitEachChild(node, visitor, context);
	      addEmitHelpers(visited, context.readEmitHelpers());
	      let statements = visited.statements;
	      if (currentFileState.filenameDeclaration) {
	        statements = insertStatementAfterCustomPrologue(statements.slice(), factory2.createVariableStatement(
	          /*modifiers*/
	          void 0,
	          factory2.createVariableDeclarationList([currentFileState.filenameDeclaration], 2 /* Const */)
	        ));
	      }
	      if (currentFileState.utilizedImplicitRuntimeImports) {
	        for (const [importSource, importSpecifiersMap] of arrayFrom(currentFileState.utilizedImplicitRuntimeImports.entries())) {
	          if (isExternalModule(node)) {
	            const importStatement = factory2.createImportDeclaration(
	              /*modifiers*/
	              void 0,
	              factory2.createImportClause(
	                /*isTypeOnly*/
	                false,
	                /*name*/
	                void 0,
	                factory2.createNamedImports(arrayFrom(importSpecifiersMap.values()))
	              ),
	              factory2.createStringLiteral(importSource),
	              /*attributes*/
	              void 0
	            );
	            setParentRecursive(
	              importStatement,
	              /*incremental*/
	              false
	            );
	            statements = insertStatementAfterCustomPrologue(statements.slice(), importStatement);
	          } else if (isExternalOrCommonJsModule(node)) {
	            const requireStatement = factory2.createVariableStatement(
	              /*modifiers*/
	              void 0,
	              factory2.createVariableDeclarationList([
	                factory2.createVariableDeclaration(
	                  factory2.createObjectBindingPattern(arrayFrom(importSpecifiersMap.values(), (s) => factory2.createBindingElement(
	                    /*dotDotDotToken*/
	                    void 0,
	                    s.propertyName,
	                    s.name
	                  ))),
	                  /*exclamationToken*/
	                  void 0,
	                  /*type*/
	                  void 0,
	                  factory2.createCallExpression(
	                    factory2.createIdentifier("require"),
	                    /*typeArguments*/
	                    void 0,
	                    [factory2.createStringLiteral(importSource)]
	                  )
	                )
	              ], 2 /* Const */)
	            );
	            setParentRecursive(
	              requireStatement,
	              /*incremental*/
	              false
	            );
	            statements = insertStatementAfterCustomPrologue(statements.slice(), requireStatement);
	          } else ;
	        }
	      }
	      if (statements !== visited.statements) {
	        visited = factory2.updateSourceFile(visited, statements);
	      }
	      currentFileState = void 0;
	      return visited;
	    }
	    function visitor(node) {
	      if (node.transformFlags & 2 /* ContainsJsx */) {
	        return visitorWorker(node);
	      } else {
	        return node;
	      }
	    }
	    function visitorWorker(node) {
	      switch (node.kind) {
	        case 284 /* JsxElement */:
	          return visitJsxElement(
	            node,
	            /*isChild*/
	            false
	          );
	        case 285 /* JsxSelfClosingElement */:
	          return visitJsxSelfClosingElement(
	            node,
	            /*isChild*/
	            false
	          );
	        case 288 /* JsxFragment */:
	          return visitJsxFragment(
	            node,
	            /*isChild*/
	            false
	          );
	        case 294 /* JsxExpression */:
	          return visitJsxExpression(node);
	        default:
	          return visitEachChild(node, visitor, context);
	      }
	    }
	    function transformJsxChildToExpression(node) {
	      switch (node.kind) {
	        case 12 /* JsxText */:
	          return visitJsxText(node);
	        case 294 /* JsxExpression */:
	          return visitJsxExpression(node);
	        case 284 /* JsxElement */:
	          return visitJsxElement(
	            node,
	            /*isChild*/
	            true
	          );
	        case 285 /* JsxSelfClosingElement */:
	          return visitJsxSelfClosingElement(
	            node,
	            /*isChild*/
	            true
	          );
	        case 288 /* JsxFragment */:
	          return visitJsxFragment(
	            node,
	            /*isChild*/
	            true
	          );
	        default:
	          return Debug.failBadSyntaxKind(node);
	      }
	    }
	    function hasProto(obj) {
	      return obj.properties.some(
	        (p) => isPropertyAssignment(p) && (isIdentifier(p.name) && idText(p.name) === "__proto__" || isStringLiteral(p.name) && p.name.text === "__proto__")
	      );
	    }
	    function hasKeyAfterPropsSpread(node) {
	      let spread = false;
	      for (const elem of node.attributes.properties) {
	        if (isJsxSpreadAttribute(elem) && (!isObjectLiteralExpression(elem.expression) || elem.expression.properties.some(isSpreadAssignment))) {
	          spread = true;
	        } else if (spread && isJsxAttribute(elem) && isIdentifier(elem.name) && elem.name.escapedText === "key") {
	          return true;
	        }
	      }
	      return false;
	    }
	    function shouldUseCreateElement(node) {
	      return currentFileState.importSpecifier === void 0 || hasKeyAfterPropsSpread(node);
	    }
	    function visitJsxElement(node, isChild) {
	      const tagTransform = shouldUseCreateElement(node.openingElement) ? visitJsxOpeningLikeElementCreateElement : visitJsxOpeningLikeElementJSX;
	      return tagTransform(
	        node.openingElement,
	        node.children,
	        isChild,
	        /*location*/
	        node
	      );
	    }
	    function visitJsxSelfClosingElement(node, isChild) {
	      const tagTransform = shouldUseCreateElement(node) ? visitJsxOpeningLikeElementCreateElement : visitJsxOpeningLikeElementJSX;
	      return tagTransform(
	        node,
	        /*children*/
	        void 0,
	        isChild,
	        /*location*/
	        node
	      );
	    }
	    function visitJsxFragment(node, isChild) {
	      const tagTransform = currentFileState.importSpecifier === void 0 ? visitJsxOpeningFragmentCreateElement : visitJsxOpeningFragmentJSX;
	      return tagTransform(
	        node.openingFragment,
	        node.children,
	        isChild,
	        /*location*/
	        node
	      );
	    }
	    function convertJsxChildrenToChildrenPropObject(children) {
	      const prop = convertJsxChildrenToChildrenPropAssignment(children);
	      return prop && factory2.createObjectLiteralExpression([prop]);
	    }
	    function convertJsxChildrenToChildrenPropAssignment(children) {
	      const nonWhitespaceChildren = getSemanticJsxChildren(children);
	      if (length(nonWhitespaceChildren) === 1 && !nonWhitespaceChildren[0].dotDotDotToken) {
	        const result2 = transformJsxChildToExpression(nonWhitespaceChildren[0]);
	        return result2 && factory2.createPropertyAssignment("children", result2);
	      }
	      const result = mapDefined(children, transformJsxChildToExpression);
	      return length(result) ? factory2.createPropertyAssignment("children", factory2.createArrayLiteralExpression(result)) : void 0;
	    }
	    function visitJsxOpeningLikeElementJSX(node, children, isChild, location) {
	      const tagName = getTagName(node);
	      const childrenProp = children && children.length ? convertJsxChildrenToChildrenPropAssignment(children) : void 0;
	      const keyAttr = find(node.attributes.properties, (p) => !!p.name && isIdentifier(p.name) && p.name.escapedText === "key");
	      const attrs = keyAttr ? filter(node.attributes.properties, (p) => p !== keyAttr) : node.attributes.properties;
	      const objectProperties = length(attrs) ? transformJsxAttributesToObjectProps(attrs, childrenProp) : factory2.createObjectLiteralExpression(childrenProp ? [childrenProp] : emptyArray);
	      return visitJsxOpeningLikeElementOrFragmentJSX(
	        tagName,
	        objectProperties,
	        keyAttr,
	        children || emptyArray,
	        isChild,
	        location
	      );
	    }
	    function visitJsxOpeningLikeElementOrFragmentJSX(tagName, objectProperties, keyAttr, children, isChild, location) {
	      var _a;
	      const nonWhitespaceChildren = getSemanticJsxChildren(children);
	      const isStaticChildren = length(nonWhitespaceChildren) > 1 || !!((_a = nonWhitespaceChildren[0]) == null ? void 0 : _a.dotDotDotToken);
	      const args = [tagName, objectProperties];
	      if (keyAttr) {
	        args.push(transformJsxAttributeInitializer(keyAttr.initializer));
	      }
	      if (compilerOptions.jsx === 5 /* ReactJSXDev */) {
	        const originalFile = getOriginalNode(currentSourceFile);
	        if (originalFile && isSourceFile(originalFile)) {
	          if (keyAttr === void 0) {
	            args.push(factory2.createVoidZero());
	          }
	          args.push(isStaticChildren ? factory2.createTrue() : factory2.createFalse());
	          const lineCol = getLineAndCharacterOfPosition(originalFile, location.pos);
	          args.push(factory2.createObjectLiteralExpression([
	            factory2.createPropertyAssignment("fileName", getCurrentFileNameExpression()),
	            factory2.createPropertyAssignment("lineNumber", factory2.createNumericLiteral(lineCol.line + 1)),
	            factory2.createPropertyAssignment("columnNumber", factory2.createNumericLiteral(lineCol.character + 1))
	          ]));
	          args.push(factory2.createThis());
	        }
	      }
	      const element = setTextRange(
	        factory2.createCallExpression(
	          getJsxFactoryCallee(isStaticChildren),
	          /*typeArguments*/
	          void 0,
	          args
	        ),
	        location
	      );
	      if (isChild) {
	        startOnNewLine(element);
	      }
	      return element;
	    }
	    function visitJsxOpeningLikeElementCreateElement(node, children, isChild, location) {
	      const tagName = getTagName(node);
	      const attrs = node.attributes.properties;
	      const objectProperties = length(attrs) ? transformJsxAttributesToObjectProps(attrs) : factory2.createNull();
	      const callee = currentFileState.importSpecifier === void 0 ? createJsxFactoryExpression(
	        factory2,
	        context.getEmitResolver().getJsxFactoryEntity(currentSourceFile),
	        compilerOptions.reactNamespace,
	        // TODO: GH#18217
	        node
	      ) : getImplicitImportForName("createElement");
	      const element = createExpressionForJsxElement(
	        factory2,
	        callee,
	        tagName,
	        objectProperties,
	        mapDefined(children, transformJsxChildToExpression),
	        location
	      );
	      if (isChild) {
	        startOnNewLine(element);
	      }
	      return element;
	    }
	    function visitJsxOpeningFragmentJSX(_node, children, isChild, location) {
	      let childrenProps;
	      if (children && children.length) {
	        const result = convertJsxChildrenToChildrenPropObject(children);
	        if (result) {
	          childrenProps = result;
	        }
	      }
	      return visitJsxOpeningLikeElementOrFragmentJSX(
	        getImplicitJsxFragmentReference(),
	        childrenProps || factory2.createObjectLiteralExpression([]),
	        /*keyAttr*/
	        void 0,
	        children,
	        isChild,
	        location
	      );
	    }
	    function visitJsxOpeningFragmentCreateElement(node, children, isChild, location) {
	      const element = createExpressionForJsxFragment(
	        factory2,
	        context.getEmitResolver().getJsxFactoryEntity(currentSourceFile),
	        context.getEmitResolver().getJsxFragmentFactoryEntity(currentSourceFile),
	        compilerOptions.reactNamespace,
	        // TODO: GH#18217
	        mapDefined(children, transformJsxChildToExpression),
	        node,
	        location
	      );
	      if (isChild) {
	        startOnNewLine(element);
	      }
	      return element;
	    }
	    function transformJsxSpreadAttributeToProps(node) {
	      if (isObjectLiteralExpression(node.expression) && !hasProto(node.expression)) {
	        return sameMap(node.expression.properties, (p) => Debug.checkDefined(visitNode(p, visitor, isObjectLiteralElementLike)));
	      }
	      return factory2.createSpreadAssignment(Debug.checkDefined(visitNode(node.expression, visitor, isExpression)));
	    }
	    function transformJsxAttributesToObjectProps(attrs, children) {
	      const target = getEmitScriptTarget(compilerOptions);
	      return target && target >= 5 /* ES2018 */ ? factory2.createObjectLiteralExpression(transformJsxAttributesToProps(attrs, children)) : transformJsxAttributesToExpression(attrs, children);
	    }
	    function transformJsxAttributesToProps(attrs, children) {
	      const props = flatten(spanMap(attrs, isJsxSpreadAttribute, (attrs2, isSpread) => flatten(map(attrs2, (attr) => isSpread ? transformJsxSpreadAttributeToProps(attr) : transformJsxAttributeToObjectLiteralElement(attr)))));
	      if (children) {
	        props.push(children);
	      }
	      return props;
	    }
	    function transformJsxAttributesToExpression(attrs, children) {
	      const expressions = [];
	      let properties = [];
	      for (const attr of attrs) {
	        if (isJsxSpreadAttribute(attr)) {
	          if (isObjectLiteralExpression(attr.expression) && !hasProto(attr.expression)) {
	            for (const prop of attr.expression.properties) {
	              if (isSpreadAssignment(prop)) {
	                finishObjectLiteralIfNeeded();
	                expressions.push(Debug.checkDefined(visitNode(prop.expression, visitor, isExpression)));
	                continue;
	              }
	              properties.push(Debug.checkDefined(visitNode(prop, visitor)));
	            }
	            continue;
	          }
	          finishObjectLiteralIfNeeded();
	          expressions.push(Debug.checkDefined(visitNode(attr.expression, visitor, isExpression)));
	          continue;
	        }
	        properties.push(transformJsxAttributeToObjectLiteralElement(attr));
	      }
	      if (children) {
	        properties.push(children);
	      }
	      finishObjectLiteralIfNeeded();
	      if (expressions.length && !isObjectLiteralExpression(expressions[0])) {
	        expressions.unshift(factory2.createObjectLiteralExpression());
	      }
	      return singleOrUndefined(expressions) || emitHelpers().createAssignHelper(expressions);
	      function finishObjectLiteralIfNeeded() {
	        if (properties.length) {
	          expressions.push(factory2.createObjectLiteralExpression(properties));
	          properties = [];
	        }
	      }
	    }
	    function transformJsxAttributeToObjectLiteralElement(node) {
	      const name = getAttributeName(node);
	      const expression = transformJsxAttributeInitializer(node.initializer);
	      return factory2.createPropertyAssignment(name, expression);
	    }
	    function transformJsxAttributeInitializer(node) {
	      if (node === void 0) {
	        return factory2.createTrue();
	      }
	      if (node.kind === 11 /* StringLiteral */) {
	        const singleQuote = node.singleQuote !== void 0 ? node.singleQuote : !isStringDoubleQuoted(node, currentSourceFile);
	        const literal = factory2.createStringLiteral(tryDecodeEntities(node.text) || node.text, singleQuote);
	        return setTextRange(literal, node);
	      }
	      if (node.kind === 294 /* JsxExpression */) {
	        if (node.expression === void 0) {
	          return factory2.createTrue();
	        }
	        return Debug.checkDefined(visitNode(node.expression, visitor, isExpression));
	      }
	      if (isJsxElement(node)) {
	        return visitJsxElement(
	          node,
	          /*isChild*/
	          false
	        );
	      }
	      if (isJsxSelfClosingElement(node)) {
	        return visitJsxSelfClosingElement(
	          node,
	          /*isChild*/
	          false
	        );
	      }
	      if (isJsxFragment(node)) {
	        return visitJsxFragment(
	          node,
	          /*isChild*/
	          false
	        );
	      }
	      return Debug.failBadSyntaxKind(node);
	    }
	    function visitJsxText(node) {
	      const fixed = fixupWhitespaceAndDecodeEntities(node.text);
	      return fixed === void 0 ? void 0 : factory2.createStringLiteral(fixed);
	    }
	    function fixupWhitespaceAndDecodeEntities(text) {
	      let acc;
	      let firstNonWhitespace = 0;
	      let lastNonWhitespace = -1;
	      for (let i = 0; i < text.length; i++) {
	        const c = text.charCodeAt(i);
	        if (isLineBreak(c)) {
	          if (firstNonWhitespace !== -1 && lastNonWhitespace !== -1) {
	            acc = addLineOfJsxText(acc, text.substr(firstNonWhitespace, lastNonWhitespace - firstNonWhitespace + 1));
	          }
	          firstNonWhitespace = -1;
	        } else if (!isWhiteSpaceSingleLine(c)) {
	          lastNonWhitespace = i;
	          if (firstNonWhitespace === -1) {
	            firstNonWhitespace = i;
	          }
	        }
	      }
	      return firstNonWhitespace !== -1 ? addLineOfJsxText(acc, text.substr(firstNonWhitespace)) : acc;
	    }
	    function addLineOfJsxText(acc, trimmedLine) {
	      const decoded = decodeEntities(trimmedLine);
	      return acc === void 0 ? decoded : acc + " " + decoded;
	    }
	    function decodeEntities(text) {
	      return text.replace(/&((#((\d+)|x([\da-fA-F]+)))|(\w+));/g, (match, _all, _number, _digits, decimal, hex, word) => {
	        if (decimal) {
	          return utf16EncodeAsString(parseInt(decimal, 10));
	        } else if (hex) {
	          return utf16EncodeAsString(parseInt(hex, 16));
	        } else {
	          const ch = entities.get(word);
	          return ch ? utf16EncodeAsString(ch) : match;
	        }
	      });
	    }
	    function tryDecodeEntities(text) {
	      const decoded = decodeEntities(text);
	      return decoded === text ? void 0 : decoded;
	    }
	    function getTagName(node) {
	      if (node.kind === 284 /* JsxElement */) {
	        return getTagName(node.openingElement);
	      } else {
	        const tagName = node.tagName;
	        if (isIdentifier(tagName) && isIntrinsicJsxName(tagName.escapedText)) {
	          return factory2.createStringLiteral(idText(tagName));
	        } else if (isJsxNamespacedName(tagName)) {
	          return factory2.createStringLiteral(idText(tagName.namespace) + ":" + idText(tagName.name));
	        } else {
	          return createExpressionFromEntityName(factory2, tagName);
	        }
	      }
	    }
	    function getAttributeName(node) {
	      const name = node.name;
	      if (isIdentifier(name)) {
	        const text = idText(name);
	        return /^[A-Za-z_]\w*$/.test(text) ? name : factory2.createStringLiteral(text);
	      }
	      return factory2.createStringLiteral(idText(name.namespace) + ":" + idText(name.name));
	    }
	    function visitJsxExpression(node) {
	      const expression = visitNode(node.expression, visitor, isExpression);
	      return node.dotDotDotToken ? factory2.createSpreadElement(expression) : expression;
	    }
	  }
	  var entities;
	  var init_jsx = __esm({
	    "src/compiler/transformers/jsx.ts"() {
	      init_ts2();
	      entities = new Map(Object.entries({
	        quot: 34,
	        amp: 38,
	        apos: 39,
	        lt: 60,
	        gt: 62,
	        nbsp: 160,
	        iexcl: 161,
	        cent: 162,
	        pound: 163,
	        curren: 164,
	        yen: 165,
	        brvbar: 166,
	        sect: 167,
	        uml: 168,
	        copy: 169,
	        ordf: 170,
	        laquo: 171,
	        not: 172,
	        shy: 173,
	        reg: 174,
	        macr: 175,
	        deg: 176,
	        plusmn: 177,
	        sup2: 178,
	        sup3: 179,
	        acute: 180,
	        micro: 181,
	        para: 182,
	        middot: 183,
	        cedil: 184,
	        sup1: 185,
	        ordm: 186,
	        raquo: 187,
	        frac14: 188,
	        frac12: 189,
	        frac34: 190,
	        iquest: 191,
	        Agrave: 192,
	        Aacute: 193,
	        Acirc: 194,
	        Atilde: 195,
	        Auml: 196,
	        Aring: 197,
	        AElig: 198,
	        Ccedil: 199,
	        Egrave: 200,
	        Eacute: 201,
	        Ecirc: 202,
	        Euml: 203,
	        Igrave: 204,
	        Iacute: 205,
	        Icirc: 206,
	        Iuml: 207,
	        ETH: 208,
	        Ntilde: 209,
	        Ograve: 210,
	        Oacute: 211,
	        Ocirc: 212,
	        Otilde: 213,
	        Ouml: 214,
	        times: 215,
	        Oslash: 216,
	        Ugrave: 217,
	        Uacute: 218,
	        Ucirc: 219,
	        Uuml: 220,
	        Yacute: 221,
	        THORN: 222,
	        szlig: 223,
	        agrave: 224,
	        aacute: 225,
	        acirc: 226,
	        atilde: 227,
	        auml: 228,
	        aring: 229,
	        aelig: 230,
	        ccedil: 231,
	        egrave: 232,
	        eacute: 233,
	        ecirc: 234,
	        euml: 235,
	        igrave: 236,
	        iacute: 237,
	        icirc: 238,
	        iuml: 239,
	        eth: 240,
	        ntilde: 241,
	        ograve: 242,
	        oacute: 243,
	        ocirc: 244,
	        otilde: 245,
	        ouml: 246,
	        divide: 247,
	        oslash: 248,
	        ugrave: 249,
	        uacute: 250,
	        ucirc: 251,
	        uuml: 252,
	        yacute: 253,
	        thorn: 254,
	        yuml: 255,
	        OElig: 338,
	        oelig: 339,
	        Scaron: 352,
	        scaron: 353,
	        Yuml: 376,
	        fnof: 402,
	        circ: 710,
	        tilde: 732,
	        Alpha: 913,
	        Beta: 914,
	        Gamma: 915,
	        Delta: 916,
	        Epsilon: 917,
	        Zeta: 918,
	        Eta: 919,
	        Theta: 920,
	        Iota: 921,
	        Kappa: 922,
	        Lambda: 923,
	        Mu: 924,
	        Nu: 925,
	        Xi: 926,
	        Omicron: 927,
	        Pi: 928,
	        Rho: 929,
	        Sigma: 931,
	        Tau: 932,
	        Upsilon: 933,
	        Phi: 934,
	        Chi: 935,
	        Psi: 936,
	        Omega: 937,
	        alpha: 945,
	        beta: 946,
	        gamma: 947,
	        delta: 948,
	        epsilon: 949,
	        zeta: 950,
	        eta: 951,
	        theta: 952,
	        iota: 953,
	        kappa: 954,
	        lambda: 955,
	        mu: 956,
	        nu: 957,
	        xi: 958,
	        omicron: 959,
	        pi: 960,
	        rho: 961,
	        sigmaf: 962,
	        sigma: 963,
	        tau: 964,
	        upsilon: 965,
	        phi: 966,
	        chi: 967,
	        psi: 968,
	        omega: 969,
	        thetasym: 977,
	        upsih: 978,
	        piv: 982,
	        ensp: 8194,
	        emsp: 8195,
	        thinsp: 8201,
	        zwnj: 8204,
	        zwj: 8205,
	        lrm: 8206,
	        rlm: 8207,
	        ndash: 8211,
	        mdash: 8212,
	        lsquo: 8216,
	        rsquo: 8217,
	        sbquo: 8218,
	        ldquo: 8220,
	        rdquo: 8221,
	        bdquo: 8222,
	        dagger: 8224,
	        Dagger: 8225,
	        bull: 8226,
	        hellip: 8230,
	        permil: 8240,
	        prime: 8242,
	        Prime: 8243,
	        lsaquo: 8249,
	        rsaquo: 8250,
	        oline: 8254,
	        frasl: 8260,
	        euro: 8364,
	        image: 8465,
	        weierp: 8472,
	        real: 8476,
	        trade: 8482,
	        alefsym: 8501,
	        larr: 8592,
	        uarr: 8593,
	        rarr: 8594,
	        darr: 8595,
	        harr: 8596,
	        crarr: 8629,
	        lArr: 8656,
	        uArr: 8657,
	        rArr: 8658,
	        dArr: 8659,
	        hArr: 8660,
	        forall: 8704,
	        part: 8706,
	        exist: 8707,
	        empty: 8709,
	        nabla: 8711,
	        isin: 8712,
	        notin: 8713,
	        ni: 8715,
	        prod: 8719,
	        sum: 8721,
	        minus: 8722,
	        lowast: 8727,
	        radic: 8730,
	        prop: 8733,
	        infin: 8734,
	        ang: 8736,
	        and: 8743,
	        or: 8744,
	        cap: 8745,
	        cup: 8746,
	        int: 8747,
	        there4: 8756,
	        sim: 8764,
	        cong: 8773,
	        asymp: 8776,
	        ne: 8800,
	        equiv: 8801,
	        le: 8804,
	        ge: 8805,
	        sub: 8834,
	        sup: 8835,
	        nsub: 8836,
	        sube: 8838,
	        supe: 8839,
	        oplus: 8853,
	        otimes: 8855,
	        perp: 8869,
	        sdot: 8901,
	        lceil: 8968,
	        rceil: 8969,
	        lfloor: 8970,
	        rfloor: 8971,
	        lang: 9001,
	        rang: 9002,
	        loz: 9674,
	        spades: 9824,
	        clubs: 9827,
	        hearts: 9829,
	        diams: 9830
	      }));
	    }
	  });

	  // src/compiler/transformers/es2016.ts
	  function transformES2016(context) {
	    const {
	      factory: factory2,
	      hoistVariableDeclaration
	    } = context;
	    return chainBundle(context, transformSourceFile);
	    function transformSourceFile(node) {
	      if (node.isDeclarationFile) {
	        return node;
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitor(node) {
	      if ((node.transformFlags & 512 /* ContainsES2016 */) === 0) {
	        return node;
	      }
	      switch (node.kind) {
	        case 226 /* BinaryExpression */:
	          return visitBinaryExpression(node);
	        default:
	          return visitEachChild(node, visitor, context);
	      }
	    }
	    function visitBinaryExpression(node) {
	      switch (node.operatorToken.kind) {
	        case 68 /* AsteriskAsteriskEqualsToken */:
	          return visitExponentiationAssignmentExpression(node);
	        case 43 /* AsteriskAsteriskToken */:
	          return visitExponentiationExpression(node);
	        default:
	          return visitEachChild(node, visitor, context);
	      }
	    }
	    function visitExponentiationAssignmentExpression(node) {
	      let target;
	      let value;
	      const left = visitNode(node.left, visitor, isExpression);
	      const right = visitNode(node.right, visitor, isExpression);
	      if (isElementAccessExpression(left)) {
	        const expressionTemp = factory2.createTempVariable(hoistVariableDeclaration);
	        const argumentExpressionTemp = factory2.createTempVariable(hoistVariableDeclaration);
	        target = setTextRange(
	          factory2.createElementAccessExpression(
	            setTextRange(factory2.createAssignment(expressionTemp, left.expression), left.expression),
	            setTextRange(factory2.createAssignment(argumentExpressionTemp, left.argumentExpression), left.argumentExpression)
	          ),
	          left
	        );
	        value = setTextRange(
	          factory2.createElementAccessExpression(
	            expressionTemp,
	            argumentExpressionTemp
	          ),
	          left
	        );
	      } else if (isPropertyAccessExpression(left)) {
	        const expressionTemp = factory2.createTempVariable(hoistVariableDeclaration);
	        target = setTextRange(
	          factory2.createPropertyAccessExpression(
	            setTextRange(factory2.createAssignment(expressionTemp, left.expression), left.expression),
	            left.name
	          ),
	          left
	        );
	        value = setTextRange(
	          factory2.createPropertyAccessExpression(
	            expressionTemp,
	            left.name
	          ),
	          left
	        );
	      } else {
	        target = left;
	        value = left;
	      }
	      return setTextRange(
	        factory2.createAssignment(
	          target,
	          setTextRange(factory2.createGlobalMethodCall("Math", "pow", [value, right]), node)
	        ),
	        node
	      );
	    }
	    function visitExponentiationExpression(node) {
	      const left = visitNode(node.left, visitor, isExpression);
	      const right = visitNode(node.right, visitor, isExpression);
	      return setTextRange(factory2.createGlobalMethodCall("Math", "pow", [left, right]), node);
	    }
	  }
	  var init_es2016 = __esm({
	    "src/compiler/transformers/es2016.ts"() {
	      init_ts2();
	    }
	  });

	  // src/compiler/transformers/es2015.ts
	  function createSpreadSegment(kind, expression) {
	    return { kind, expression };
	  }
	  function transformES2015(context) {
	    const {
	      factory: factory2,
	      getEmitHelperFactory: emitHelpers,
	      startLexicalEnvironment,
	      resumeLexicalEnvironment,
	      endLexicalEnvironment,
	      hoistVariableDeclaration
	    } = context;
	    const compilerOptions = context.getCompilerOptions();
	    const resolver = context.getEmitResolver();
	    const previousOnSubstituteNode = context.onSubstituteNode;
	    const previousOnEmitNode = context.onEmitNode;
	    context.onEmitNode = onEmitNode;
	    context.onSubstituteNode = onSubstituteNode;
	    let currentSourceFile;
	    let currentText;
	    let hierarchyFacts;
	    let taggedTemplateStringDeclarations;
	    function recordTaggedTemplateString(temp) {
	      taggedTemplateStringDeclarations = append(
	        taggedTemplateStringDeclarations,
	        factory2.createVariableDeclaration(temp)
	      );
	    }
	    let convertedLoopState;
	    let enabledSubstitutions;
	    return chainBundle(context, transformSourceFile);
	    function transformSourceFile(node) {
	      if (node.isDeclarationFile) {
	        return node;
	      }
	      currentSourceFile = node;
	      currentText = node.text;
	      const visited = visitSourceFile(node);
	      addEmitHelpers(visited, context.readEmitHelpers());
	      currentSourceFile = void 0;
	      currentText = void 0;
	      taggedTemplateStringDeclarations = void 0;
	      hierarchyFacts = 0 /* None */;
	      return visited;
	    }
	    function enterSubtree(excludeFacts, includeFacts) {
	      const ancestorFacts = hierarchyFacts;
	      hierarchyFacts = (hierarchyFacts & ~excludeFacts | includeFacts) & 32767 /* AncestorFactsMask */;
	      return ancestorFacts;
	    }
	    function exitSubtree(ancestorFacts, excludeFacts, includeFacts) {
	      hierarchyFacts = (hierarchyFacts & ~excludeFacts | includeFacts) & -32768 /* SubtreeFactsMask */ | ancestorFacts;
	    }
	    function isReturnVoidStatementInConstructorWithCapturedSuper(node) {
	      return (hierarchyFacts & 8192 /* ConstructorWithSuperCall */) !== 0 && node.kind === 253 /* ReturnStatement */ && !node.expression;
	    }
	    function isOrMayContainReturnCompletion(node) {
	      return node.transformFlags & 4194304 /* ContainsHoistedDeclarationOrCompletion */ && (isReturnStatement(node) || isIfStatement(node) || isWithStatement(node) || isSwitchStatement(node) || isCaseBlock(node) || isCaseClause(node) || isDefaultClause(node) || isTryStatement(node) || isCatchClause(node) || isLabeledStatement(node) || isIterationStatement(
	        node,
	        /*lookInLabeledStatements*/
	        false
	      ) || isBlock(node));
	    }
	    function shouldVisitNode(node) {
	      return (node.transformFlags & 1024 /* ContainsES2015 */) !== 0 || convertedLoopState !== void 0 || hierarchyFacts & 8192 /* ConstructorWithSuperCall */ && isOrMayContainReturnCompletion(node) || isIterationStatement(
	        node,
	        /*lookInLabeledStatements*/
	        false
	      ) && shouldConvertIterationStatement(node) || (getInternalEmitFlags(node) & 1 /* TypeScriptClassWrapper */) !== 0;
	    }
	    function visitor(node) {
	      return shouldVisitNode(node) ? visitorWorker(
	        node,
	        /*expressionResultIsUnused*/
	        false
	      ) : node;
	    }
	    function visitorWithUnusedExpressionResult(node) {
	      return shouldVisitNode(node) ? visitorWorker(
	        node,
	        /*expressionResultIsUnused*/
	        true
	      ) : node;
	    }
	    function classWrapperStatementVisitor(node) {
	      if (shouldVisitNode(node)) {
	        const original = getOriginalNode(node);
	        if (isPropertyDeclaration(original) && hasStaticModifier(original)) {
	          const ancestorFacts = enterSubtree(
	            32670 /* StaticInitializerExcludes */,
	            16449 /* StaticInitializerIncludes */
	          );
	          const result = visitorWorker(
	            node,
	            /*expressionResultIsUnused*/
	            false
	          );
	          exitSubtree(ancestorFacts, 229376 /* FunctionSubtreeExcludes */, 0 /* None */);
	          return result;
	        }
	        return visitorWorker(
	          node,
	          /*expressionResultIsUnused*/
	          false
	        );
	      }
	      return node;
	    }
	    function callExpressionVisitor(node) {
	      if (node.kind === 108 /* SuperKeyword */) {
	        return visitSuperKeyword(
	          node,
	          /*isExpressionOfCall*/
	          true
	        );
	      }
	      return visitor(node);
	    }
	    function visitorWorker(node, expressionResultIsUnused2) {
	      switch (node.kind) {
	        case 126 /* StaticKeyword */:
	          return void 0;
	        case 263 /* ClassDeclaration */:
	          return visitClassDeclaration(node);
	        case 231 /* ClassExpression */:
	          return visitClassExpression(node);
	        case 169 /* Parameter */:
	          return visitParameter(node);
	        case 262 /* FunctionDeclaration */:
	          return visitFunctionDeclaration(node);
	        case 219 /* ArrowFunction */:
	          return visitArrowFunction(node);
	        case 218 /* FunctionExpression */:
	          return visitFunctionExpression(node);
	        case 260 /* VariableDeclaration */:
	          return visitVariableDeclaration(node);
	        case 80 /* Identifier */:
	          return visitIdentifier(node);
	        case 261 /* VariableDeclarationList */:
	          return visitVariableDeclarationList(node);
	        case 255 /* SwitchStatement */:
	          return visitSwitchStatement(node);
	        case 269 /* CaseBlock */:
	          return visitCaseBlock(node);
	        case 241 /* Block */:
	          return visitBlock(
	            node,
	            /*isFunctionBody*/
	            false
	          );
	        case 252 /* BreakStatement */:
	        case 251 /* ContinueStatement */:
	          return visitBreakOrContinueStatement(node);
	        case 256 /* LabeledStatement */:
	          return visitLabeledStatement(node);
	        case 246 /* DoStatement */:
	        case 247 /* WhileStatement */:
	          return visitDoOrWhileStatement(
	            node,
	            /*outermostLabeledStatement*/
	            void 0
	          );
	        case 248 /* ForStatement */:
	          return visitForStatement(
	            node,
	            /*outermostLabeledStatement*/
	            void 0
	          );
	        case 249 /* ForInStatement */:
	          return visitForInStatement(
	            node,
	            /*outermostLabeledStatement*/
	            void 0
	          );
	        case 250 /* ForOfStatement */:
	          return visitForOfStatement(
	            node,
	            /*outermostLabeledStatement*/
	            void 0
	          );
	        case 244 /* ExpressionStatement */:
	          return visitExpressionStatement(node);
	        case 210 /* ObjectLiteralExpression */:
	          return visitObjectLiteralExpression(node);
	        case 299 /* CatchClause */:
	          return visitCatchClause(node);
	        case 304 /* ShorthandPropertyAssignment */:
	          return visitShorthandPropertyAssignment(node);
	        case 167 /* ComputedPropertyName */:
	          return visitComputedPropertyName(node);
	        case 209 /* ArrayLiteralExpression */:
	          return visitArrayLiteralExpression(node);
	        case 213 /* CallExpression */:
	          return visitCallExpression(node);
	        case 214 /* NewExpression */:
	          return visitNewExpression(node);
	        case 217 /* ParenthesizedExpression */:
	          return visitParenthesizedExpression(node, expressionResultIsUnused2);
	        case 226 /* BinaryExpression */:
	          return visitBinaryExpression(node, expressionResultIsUnused2);
	        case 361 /* CommaListExpression */:
	          return visitCommaListExpression(node, expressionResultIsUnused2);
	        case 15 /* NoSubstitutionTemplateLiteral */:
	        case 16 /* TemplateHead */:
	        case 17 /* TemplateMiddle */:
	        case 18 /* TemplateTail */:
	          return visitTemplateLiteral(node);
	        case 11 /* StringLiteral */:
	          return visitStringLiteral(node);
	        case 9 /* NumericLiteral */:
	          return visitNumericLiteral(node);
	        case 215 /* TaggedTemplateExpression */:
	          return visitTaggedTemplateExpression(node);
	        case 228 /* TemplateExpression */:
	          return visitTemplateExpression(node);
	        case 229 /* YieldExpression */:
	          return visitYieldExpression(node);
	        case 230 /* SpreadElement */:
	          return visitSpreadElement(node);
	        case 108 /* SuperKeyword */:
	          return visitSuperKeyword(
	            node,
	            /*isExpressionOfCall*/
	            false
	          );
	        case 110 /* ThisKeyword */:
	          return visitThisKeyword(node);
	        case 236 /* MetaProperty */:
	          return visitMetaProperty(node);
	        case 174 /* MethodDeclaration */:
	          return visitMethodDeclaration(node);
	        case 177 /* GetAccessor */:
	        case 178 /* SetAccessor */:
	          return visitAccessorDeclaration(node);
	        case 243 /* VariableStatement */:
	          return visitVariableStatement(node);
	        case 253 /* ReturnStatement */:
	          return visitReturnStatement(node);
	        case 222 /* VoidExpression */:
	          return visitVoidExpression(node);
	        default:
	          return visitEachChild(node, visitor, context);
	      }
	    }
	    function visitSourceFile(node) {
	      const ancestorFacts = enterSubtree(8064 /* SourceFileExcludes */, 64 /* SourceFileIncludes */);
	      const prologue = [];
	      const statements = [];
	      startLexicalEnvironment();
	      const statementOffset = factory2.copyPrologue(
	        node.statements,
	        prologue,
	        /*ensureUseStrict*/
	        false,
	        visitor
	      );
	      addRange(statements, visitNodes2(node.statements, visitor, isStatement, statementOffset));
	      if (taggedTemplateStringDeclarations) {
	        statements.push(
	          factory2.createVariableStatement(
	            /*modifiers*/
	            void 0,
	            factory2.createVariableDeclarationList(taggedTemplateStringDeclarations)
	          )
	        );
	      }
	      factory2.mergeLexicalEnvironment(prologue, endLexicalEnvironment());
	      insertCaptureThisForNodeIfNeeded(prologue, node);
	      exitSubtree(ancestorFacts, 0 /* None */, 0 /* None */);
	      return factory2.updateSourceFile(
	        node,
	        setTextRange(factory2.createNodeArray(concatenate(prologue, statements)), node.statements)
	      );
	    }
	    function visitSwitchStatement(node) {
	      if (convertedLoopState !== void 0) {
	        const savedAllowedNonLabeledJumps = convertedLoopState.allowedNonLabeledJumps;
	        convertedLoopState.allowedNonLabeledJumps |= 2 /* Break */;
	        const result = visitEachChild(node, visitor, context);
	        convertedLoopState.allowedNonLabeledJumps = savedAllowedNonLabeledJumps;
	        return result;
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitCaseBlock(node) {
	      const ancestorFacts = enterSubtree(7104 /* BlockScopeExcludes */, 0 /* BlockScopeIncludes */);
	      const updated = visitEachChild(node, visitor, context);
	      exitSubtree(ancestorFacts, 0 /* None */, 0 /* None */);
	      return updated;
	    }
	    function returnCapturedThis(node) {
	      return setOriginalNode(factory2.createReturnStatement(createCapturedThis()), node);
	    }
	    function createCapturedThis() {
	      return factory2.createUniqueName("_this", 16 /* Optimistic */ | 32 /* FileLevel */);
	    }
	    function visitReturnStatement(node) {
	      if (convertedLoopState) {
	        convertedLoopState.nonLocalJumps |= 8 /* Return */;
	        if (isReturnVoidStatementInConstructorWithCapturedSuper(node)) {
	          node = returnCapturedThis(node);
	        }
	        return factory2.createReturnStatement(
	          factory2.createObjectLiteralExpression(
	            [
	              factory2.createPropertyAssignment(
	                factory2.createIdentifier("value"),
	                node.expression ? Debug.checkDefined(visitNode(node.expression, visitor, isExpression)) : factory2.createVoidZero()
	              )
	            ]
	          )
	        );
	      } else if (isReturnVoidStatementInConstructorWithCapturedSuper(node)) {
	        return returnCapturedThis(node);
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitThisKeyword(node) {
	      hierarchyFacts |= 65536 /* LexicalThis */;
	      if (hierarchyFacts & 2 /* ArrowFunction */ && !(hierarchyFacts & 16384 /* StaticInitializer */)) {
	        hierarchyFacts |= 131072 /* CapturedLexicalThis */;
	      }
	      if (convertedLoopState) {
	        if (hierarchyFacts & 2 /* ArrowFunction */) {
	          convertedLoopState.containsLexicalThis = true;
	          return node;
	        }
	        return convertedLoopState.thisName || (convertedLoopState.thisName = factory2.createUniqueName("this"));
	      }
	      return node;
	    }
	    function visitVoidExpression(node) {
	      return visitEachChild(node, visitorWithUnusedExpressionResult, context);
	    }
	    function visitIdentifier(node) {
	      if (convertedLoopState) {
	        if (resolver.isArgumentsLocalBinding(node)) {
	          return convertedLoopState.argumentsName || (convertedLoopState.argumentsName = factory2.createUniqueName("arguments"));
	        }
	      }
	      if (node.flags & 256 /* IdentifierHasExtendedUnicodeEscape */) {
	        return setOriginalNode(
	          setTextRange(
	            factory2.createIdentifier(unescapeLeadingUnderscores(node.escapedText)),
	            node
	          ),
	          node
	        );
	      }
	      return node;
	    }
	    function visitBreakOrContinueStatement(node) {
	      if (convertedLoopState) {
	        const jump = node.kind === 252 /* BreakStatement */ ? 2 /* Break */ : 4 /* Continue */;
	        const canUseBreakOrContinue = node.label && convertedLoopState.labels && convertedLoopState.labels.get(idText(node.label)) || !node.label && convertedLoopState.allowedNonLabeledJumps & jump;
	        if (!canUseBreakOrContinue) {
	          let labelMarker;
	          const label = node.label;
	          if (!label) {
	            if (node.kind === 252 /* BreakStatement */) {
	              convertedLoopState.nonLocalJumps |= 2 /* Break */;
	              labelMarker = "break";
	            } else {
	              convertedLoopState.nonLocalJumps |= 4 /* Continue */;
	              labelMarker = "continue";
	            }
	          } else {
	            if (node.kind === 252 /* BreakStatement */) {
	              labelMarker = `break-${label.escapedText}`;
	              setLabeledJump(
	                convertedLoopState,
	                /*isBreak*/
	                true,
	                idText(label),
	                labelMarker
	              );
	            } else {
	              labelMarker = `continue-${label.escapedText}`;
	              setLabeledJump(
	                convertedLoopState,
	                /*isBreak*/
	                false,
	                idText(label),
	                labelMarker
	              );
	            }
	          }
	          let returnExpression = factory2.createStringLiteral(labelMarker);
	          if (convertedLoopState.loopOutParameters.length) {
	            const outParams = convertedLoopState.loopOutParameters;
	            let expr;
	            for (let i = 0; i < outParams.length; i++) {
	              const copyExpr = copyOutParameter(outParams[i], 1 /* ToOutParameter */);
	              if (i === 0) {
	                expr = copyExpr;
	              } else {
	                expr = factory2.createBinaryExpression(expr, 28 /* CommaToken */, copyExpr);
	              }
	            }
	            returnExpression = factory2.createBinaryExpression(expr, 28 /* CommaToken */, returnExpression);
	          }
	          return factory2.createReturnStatement(returnExpression);
	        }
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitClassDeclaration(node) {
	      const variable = factory2.createVariableDeclaration(
	        factory2.getLocalName(
	          node,
	          /*allowComments*/
	          true
	        ),
	        /*exclamationToken*/
	        void 0,
	        /*type*/
	        void 0,
	        transformClassLikeDeclarationToExpression(node)
	      );
	      setOriginalNode(variable, node);
	      const statements = [];
	      const statement = factory2.createVariableStatement(
	        /*modifiers*/
	        void 0,
	        factory2.createVariableDeclarationList([variable])
	      );
	      setOriginalNode(statement, node);
	      setTextRange(statement, node);
	      startOnNewLine(statement);
	      statements.push(statement);
	      if (hasSyntacticModifier(node, 32 /* Export */)) {
	        const exportStatement = hasSyntacticModifier(node, 2048 /* Default */) ? factory2.createExportDefault(factory2.getLocalName(node)) : factory2.createExternalModuleExport(factory2.getLocalName(node));
	        setOriginalNode(exportStatement, statement);
	        statements.push(exportStatement);
	      }
	      return singleOrMany(statements);
	    }
	    function visitClassExpression(node) {
	      return transformClassLikeDeclarationToExpression(node);
	    }
	    function transformClassLikeDeclarationToExpression(node) {
	      if (node.name) {
	        enableSubstitutionsForBlockScopedBindings();
	      }
	      const extendsClauseElement = getClassExtendsHeritageElement(node);
	      const classFunction = factory2.createFunctionExpression(
	        /*modifiers*/
	        void 0,
	        /*asteriskToken*/
	        void 0,
	        /*name*/
	        void 0,
	        /*typeParameters*/
	        void 0,
	        extendsClauseElement ? [factory2.createParameterDeclaration(
	          /*modifiers*/
	          void 0,
	          /*dotDotDotToken*/
	          void 0,
	          createSyntheticSuper()
	        )] : [],
	        /*type*/
	        void 0,
	        transformClassBody(node, extendsClauseElement)
	      );
	      setEmitFlags(classFunction, getEmitFlags(node) & 131072 /* Indented */ | 1048576 /* ReuseTempVariableScope */);
	      const inner = factory2.createPartiallyEmittedExpression(classFunction);
	      setTextRangeEnd(inner, node.end);
	      setEmitFlags(inner, 3072 /* NoComments */);
	      const outer = factory2.createPartiallyEmittedExpression(inner);
	      setTextRangeEnd(outer, skipTrivia(currentText, node.pos));
	      setEmitFlags(outer, 3072 /* NoComments */);
	      const result = factory2.createParenthesizedExpression(
	        factory2.createCallExpression(
	          outer,
	          /*typeArguments*/
	          void 0,
	          extendsClauseElement ? [Debug.checkDefined(visitNode(extendsClauseElement.expression, visitor, isExpression))] : []
	        )
	      );
	      addSyntheticLeadingComment(result, 3 /* MultiLineCommentTrivia */, "* @class ");
	      return result;
	    }
	    function transformClassBody(node, extendsClauseElement) {
	      const statements = [];
	      const name = factory2.getInternalName(node);
	      const constructorLikeName = isIdentifierANonContextualKeyword(name) ? factory2.getGeneratedNameForNode(name) : name;
	      startLexicalEnvironment();
	      addExtendsHelperIfNeeded(statements, node, extendsClauseElement);
	      addConstructor(statements, node, constructorLikeName, extendsClauseElement);
	      addClassMembers(statements, node);
	      const closingBraceLocation = createTokenRange(skipTrivia(currentText, node.members.end), 20 /* CloseBraceToken */);
	      const outer = factory2.createPartiallyEmittedExpression(constructorLikeName);
	      setTextRangeEnd(outer, closingBraceLocation.end);
	      setEmitFlags(outer, 3072 /* NoComments */);
	      const statement = factory2.createReturnStatement(outer);
	      setTextRangePos(statement, closingBraceLocation.pos);
	      setEmitFlags(statement, 3072 /* NoComments */ | 768 /* NoTokenSourceMaps */);
	      statements.push(statement);
	      insertStatementsAfterStandardPrologue(statements, endLexicalEnvironment());
	      const block = factory2.createBlock(
	        setTextRange(
	          factory2.createNodeArray(statements),
	          /*location*/
	          node.members
	        ),
	        /*multiLine*/
	        true
	      );
	      setEmitFlags(block, 3072 /* NoComments */);
	      return block;
	    }
	    function addExtendsHelperIfNeeded(statements, node, extendsClauseElement) {
	      if (extendsClauseElement) {
	        statements.push(
	          setTextRange(
	            factory2.createExpressionStatement(
	              emitHelpers().createExtendsHelper(factory2.getInternalName(node))
	            ),
	            /*location*/
	            extendsClauseElement
	          )
	        );
	      }
	    }
	    function addConstructor(statements, node, name, extendsClauseElement) {
	      const savedConvertedLoopState = convertedLoopState;
	      convertedLoopState = void 0;
	      const ancestorFacts = enterSubtree(32662 /* ConstructorExcludes */, 73 /* ConstructorIncludes */);
	      const constructor = getFirstConstructorWithBody(node);
	      const hasSynthesizedSuper = hasSynthesizedDefaultSuperCall(constructor, extendsClauseElement !== void 0);
	      const constructorFunction = factory2.createFunctionDeclaration(
	        /*modifiers*/
	        void 0,
	        /*asteriskToken*/
	        void 0,
	        name,
	        /*typeParameters*/
	        void 0,
	        transformConstructorParameters(constructor, hasSynthesizedSuper),
	        /*type*/
	        void 0,
	        transformConstructorBody(constructor, node, extendsClauseElement, hasSynthesizedSuper)
	      );
	      setTextRange(constructorFunction, constructor || node);
	      if (extendsClauseElement) {
	        setEmitFlags(constructorFunction, 16 /* CapturesThis */);
	      }
	      statements.push(constructorFunction);
	      exitSubtree(ancestorFacts, 229376 /* FunctionSubtreeExcludes */, 0 /* None */);
	      convertedLoopState = savedConvertedLoopState;
	    }
	    function transformConstructorParameters(constructor, hasSynthesizedSuper) {
	      return visitParameterList(constructor && !hasSynthesizedSuper ? constructor.parameters : void 0, visitor, context) || [];
	    }
	    function createDefaultConstructorBody(node, isDerivedClass) {
	      const statements = [];
	      resumeLexicalEnvironment();
	      factory2.mergeLexicalEnvironment(statements, endLexicalEnvironment());
	      if (isDerivedClass) {
	        statements.push(factory2.createReturnStatement(createDefaultSuperCallOrThis()));
	      }
	      const statementsArray = factory2.createNodeArray(statements);
	      setTextRange(statementsArray, node.members);
	      const block = factory2.createBlock(
	        statementsArray,
	        /*multiLine*/
	        true
	      );
	      setTextRange(block, node);
	      setEmitFlags(block, 3072 /* NoComments */);
	      return block;
	    }
	    function isUninitializedVariableStatement(node) {
	      return isVariableStatement(node) && every(node.declarationList.declarations, (decl) => isIdentifier(decl.name) && !decl.initializer);
	    }
	    function containsSuperCall(node) {
	      if (isSuperCall(node)) {
	        return true;
	      }
	      if (!(node.transformFlags & 134217728 /* ContainsLexicalSuper */)) {
	        return false;
	      }
	      switch (node.kind) {
	        case 219 /* ArrowFunction */:
	        case 218 /* FunctionExpression */:
	        case 262 /* FunctionDeclaration */:
	        case 176 /* Constructor */:
	        case 175 /* ClassStaticBlockDeclaration */:
	          return false;
	        case 177 /* GetAccessor */:
	        case 178 /* SetAccessor */:
	        case 174 /* MethodDeclaration */:
	        case 172 /* PropertyDeclaration */: {
	          const named = node;
	          if (isComputedPropertyName(named.name)) {
	            return !!forEachChild(named.name, containsSuperCall);
	          }
	          return false;
	        }
	      }
	      return !!forEachChild(node, containsSuperCall);
	    }
	    function transformConstructorBody(constructor, node, extendsClauseElement, hasSynthesizedSuper) {
	      const isDerivedClass = !!extendsClauseElement && skipOuterExpressions(extendsClauseElement.expression).kind !== 106 /* NullKeyword */;
	      if (!constructor)
	        return createDefaultConstructorBody(node, isDerivedClass);
	      const prologue = [];
	      const statements = [];
	      resumeLexicalEnvironment();
	      const standardPrologueEnd = factory2.copyStandardPrologue(
	        constructor.body.statements,
	        prologue,
	        /*statementOffset*/
	        0
	      );
	      if (hasSynthesizedSuper || containsSuperCall(constructor.body)) {
	        hierarchyFacts |= 8192 /* ConstructorWithSuperCall */;
	      }
	      addRange(statements, visitNodes2(constructor.body.statements, visitor, isStatement, standardPrologueEnd));
	      const mayReplaceThis = isDerivedClass || hierarchyFacts & 8192 /* ConstructorWithSuperCall */;
	      addDefaultValueAssignmentsIfNeeded2(prologue, constructor);
	      addRestParameterIfNeeded(prologue, constructor, hasSynthesizedSuper);
	      insertCaptureNewTargetIfNeeded(prologue, constructor);
	      if (mayReplaceThis) {
	        insertCaptureThisForNode(prologue, constructor, createActualThis());
	      } else {
	        insertCaptureThisForNodeIfNeeded(prologue, constructor);
	      }
	      factory2.mergeLexicalEnvironment(prologue, endLexicalEnvironment());
	      if (mayReplaceThis && !isSufficientlyCoveredByReturnStatements(constructor.body)) {
	        statements.push(factory2.createReturnStatement(createCapturedThis()));
	      }
	      const body = factory2.createBlock(
	        setTextRange(
	          factory2.createNodeArray(
	            [
	              ...prologue,
	              ...statements
	            ]
	          ),
	          /*location*/
	          constructor.body.statements
	        ),
	        /*multiLine*/
	        true
	      );
	      setTextRange(body, constructor.body);
	      return simplifyConstructor(body, constructor.body, hasSynthesizedSuper);
	    }
	    function isCapturedThis(node) {
	      return isGeneratedIdentifier(node) && idText(node) === "_this";
	    }
	    function isSyntheticSuper(node) {
	      return isGeneratedIdentifier(node) && idText(node) === "_super";
	    }
	    function isThisCapturingVariableStatement(node) {
	      return isVariableStatement(node) && node.declarationList.declarations.length === 1 && isThisCapturingVariableDeclaration(node.declarationList.declarations[0]);
	    }
	    function isThisCapturingVariableDeclaration(node) {
	      return isVariableDeclaration(node) && isCapturedThis(node.name) && !!node.initializer;
	    }
	    function isThisCapturingAssignment(node) {
	      return isAssignmentExpression(
	        node,
	        /*excludeCompoundAssignment*/
	        true
	      ) && isCapturedThis(node.left);
	    }
	    function isTransformedSuperCall(node) {
	      return isCallExpression(node) && isPropertyAccessExpression(node.expression) && isSyntheticSuper(node.expression.expression) && isIdentifier(node.expression.name) && (idText(node.expression.name) === "call" || idText(node.expression.name) === "apply") && node.arguments.length >= 1 && node.arguments[0].kind === 110 /* ThisKeyword */;
	    }
	    function isTransformedSuperCallWithFallback(node) {
	      return isBinaryExpression(node) && node.operatorToken.kind === 57 /* BarBarToken */ && node.right.kind === 110 /* ThisKeyword */ && isTransformedSuperCall(node.left);
	    }
	    function isImplicitSuperCall(node) {
	      return isBinaryExpression(node) && node.operatorToken.kind === 56 /* AmpersandAmpersandToken */ && isBinaryExpression(node.left) && node.left.operatorToken.kind === 38 /* ExclamationEqualsEqualsToken */ && isSyntheticSuper(node.left.left) && node.left.right.kind === 106 /* NullKeyword */ && isTransformedSuperCall(node.right) && idText(node.right.expression.name) === "apply";
	    }
	    function isImplicitSuperCallWithFallback(node) {
	      return isBinaryExpression(node) && node.operatorToken.kind === 57 /* BarBarToken */ && node.right.kind === 110 /* ThisKeyword */ && isImplicitSuperCall(node.left);
	    }
	    function isThisCapturingTransformedSuperCallWithFallback(node) {
	      return isThisCapturingAssignment(node) && isTransformedSuperCallWithFallback(node.right);
	    }
	    function isThisCapturingImplicitSuperCallWithFallback(node) {
	      return isThisCapturingAssignment(node) && isImplicitSuperCallWithFallback(node.right);
	    }
	    function isTransformedSuperCallLike(node) {
	      return isTransformedSuperCall(node) || isTransformedSuperCallWithFallback(node) || isThisCapturingTransformedSuperCallWithFallback(node) || isImplicitSuperCall(node) || isImplicitSuperCallWithFallback(node) || isThisCapturingImplicitSuperCallWithFallback(node);
	    }
	    function simplifyConstructorInlineSuperInThisCaptureVariable(body) {
	      for (let i = 0; i < body.statements.length - 1; i++) {
	        const statement = body.statements[i];
	        if (!isThisCapturingVariableStatement(statement)) {
	          continue;
	        }
	        const varDecl = statement.declarationList.declarations[0];
	        if (varDecl.initializer.kind !== 110 /* ThisKeyword */) {
	          continue;
	        }
	        const thisCaptureStatementIndex = i;
	        let superCallIndex = i + 1;
	        while (superCallIndex < body.statements.length) {
	          const statement2 = body.statements[superCallIndex];
	          if (isExpressionStatement(statement2)) {
	            if (isTransformedSuperCallLike(skipOuterExpressions(statement2.expression))) {
	              break;
	            }
	          }
	          if (isUninitializedVariableStatement(statement2)) {
	            superCallIndex++;
	            continue;
	          }
	          return body;
	        }
	        const following = body.statements[superCallIndex];
	        let expression = following.expression;
	        if (isThisCapturingAssignment(expression)) {
	          expression = expression.right;
	        }
	        const newVarDecl = factory2.updateVariableDeclaration(
	          varDecl,
	          varDecl.name,
	          /*exclamationToken*/
	          void 0,
	          /*type*/
	          void 0,
	          expression
	        );
	        const newDeclList = factory2.updateVariableDeclarationList(statement.declarationList, [newVarDecl]);
	        const newVarStatement = factory2.createVariableStatement(statement.modifiers, newDeclList);
	        setOriginalNode(newVarStatement, following);
	        setTextRange(newVarStatement, following);
	        const newStatements = factory2.createNodeArray([
	          ...body.statements.slice(0, thisCaptureStatementIndex),
	          // copy statements preceding to `var _this`
	          ...body.statements.slice(thisCaptureStatementIndex + 1, superCallIndex),
	          // copy intervening temp variables
	          newVarStatement,
	          ...body.statements.slice(superCallIndex + 1)
	          // copy statements following `super.call(this, ...)`
	        ]);
	        setTextRange(newStatements, body.statements);
	        return factory2.updateBlock(body, newStatements);
	      }
	      return body;
	    }
	    function simplifyConstructorInlineSuperReturn(body, original) {
	      for (const statement of original.statements) {
	        if (statement.transformFlags & 134217728 /* ContainsLexicalSuper */ && !getSuperCallFromStatement(statement)) {
	          return body;
	        }
	      }
	      const canElideThisCapturingVariable = !(original.transformFlags & 16384 /* ContainsLexicalThis */) && !(hierarchyFacts & 65536 /* LexicalThis */) && !(hierarchyFacts & 131072 /* CapturedLexicalThis */);
	      for (let i = body.statements.length - 1; i > 0; i--) {
	        const statement = body.statements[i];
	        if (isReturnStatement(statement) && statement.expression && isCapturedThis(statement.expression)) {
	          const preceding = body.statements[i - 1];
	          let expression;
	          if (isExpressionStatement(preceding) && isThisCapturingTransformedSuperCallWithFallback(skipOuterExpressions(preceding.expression))) {
	            expression = preceding.expression;
	          } else if (canElideThisCapturingVariable && isThisCapturingVariableStatement(preceding)) {
	            const varDecl = preceding.declarationList.declarations[0];
	            if (isTransformedSuperCallLike(skipOuterExpressions(varDecl.initializer))) {
	              expression = factory2.createAssignment(
	                createCapturedThis(),
	                varDecl.initializer
	              );
	            }
	          }
	          if (!expression) {
	            break;
	          }
	          const newReturnStatement = factory2.createReturnStatement(expression);
	          setOriginalNode(newReturnStatement, preceding);
	          setTextRange(newReturnStatement, preceding);
	          const newStatements = factory2.createNodeArray([
	            ...body.statements.slice(0, i - 1),
	            // copy all statements preceding `_super.call(this, ...)`
	            newReturnStatement,
	            ...body.statements.slice(i + 1)
	            // copy all statements following `return _this;`
	          ]);
	          setTextRange(newStatements, body.statements);
	          return factory2.updateBlock(body, newStatements);
	        }
	      }
	      return body;
	    }
	    function elideUnusedThisCaptureWorker(node) {
	      if (isThisCapturingVariableStatement(node)) {
	        const varDecl = node.declarationList.declarations[0];
	        if (varDecl.initializer.kind === 110 /* ThisKeyword */) {
	          return void 0;
	        }
	      } else if (isThisCapturingAssignment(node)) {
	        return factory2.createPartiallyEmittedExpression(node.right, node);
	      }
	      switch (node.kind) {
	        case 219 /* ArrowFunction */:
	        case 218 /* FunctionExpression */:
	        case 262 /* FunctionDeclaration */:
	        case 176 /* Constructor */:
	        case 175 /* ClassStaticBlockDeclaration */:
	          return node;
	        case 177 /* GetAccessor */:
	        case 178 /* SetAccessor */:
	        case 174 /* MethodDeclaration */:
	        case 172 /* PropertyDeclaration */: {
	          const named = node;
	          if (isComputedPropertyName(named.name)) {
	            return factory2.replacePropertyName(named, visitEachChild(
	              named.name,
	              elideUnusedThisCaptureWorker,
	              /*context*/
	              void 0
	            ));
	          }
	          return node;
	        }
	      }
	      return visitEachChild(
	        node,
	        elideUnusedThisCaptureWorker,
	        /*context*/
	        void 0
	      );
	    }
	    function simplifyConstructorElideUnusedThisCapture(body, original) {
	      if (original.transformFlags & 16384 /* ContainsLexicalThis */ || hierarchyFacts & 65536 /* LexicalThis */ || hierarchyFacts & 131072 /* CapturedLexicalThis */) {
	        return body;
	      }
	      for (const statement of original.statements) {
	        if (statement.transformFlags & 134217728 /* ContainsLexicalSuper */ && !getSuperCallFromStatement(statement)) {
	          return body;
	        }
	      }
	      return factory2.updateBlock(body, visitNodes2(body.statements, elideUnusedThisCaptureWorker, isStatement));
	    }
	    function injectSuperPresenceCheckWorker(node) {
	      if (isTransformedSuperCall(node) && node.arguments.length === 2 && isIdentifier(node.arguments[1]) && idText(node.arguments[1]) === "arguments") {
	        return factory2.createLogicalAnd(
	          factory2.createStrictInequality(
	            createSyntheticSuper(),
	            factory2.createNull()
	          ),
	          node
	        );
	      }
	      switch (node.kind) {
	        case 219 /* ArrowFunction */:
	        case 218 /* FunctionExpression */:
	        case 262 /* FunctionDeclaration */:
	        case 176 /* Constructor */:
	        case 175 /* ClassStaticBlockDeclaration */:
	          return node;
	        case 177 /* GetAccessor */:
	        case 178 /* SetAccessor */:
	        case 174 /* MethodDeclaration */:
	        case 172 /* PropertyDeclaration */: {
	          const named = node;
	          if (isComputedPropertyName(named.name)) {
	            return factory2.replacePropertyName(named, visitEachChild(
	              named.name,
	              injectSuperPresenceCheckWorker,
	              /*context*/
	              void 0
	            ));
	          }
	          return node;
	        }
	      }
	      return visitEachChild(
	        node,
	        injectSuperPresenceCheckWorker,
	        /*context*/
	        void 0
	      );
	    }
	    function complicateConstructorInjectSuperPresenceCheck(body) {
	      return factory2.updateBlock(body, visitNodes2(body.statements, injectSuperPresenceCheckWorker, isStatement));
	    }
	    function simplifyConstructor(body, original, hasSynthesizedSuper) {
	      const inputBody = body;
	      body = simplifyConstructorInlineSuperInThisCaptureVariable(body);
	      body = simplifyConstructorInlineSuperReturn(body, original);
	      if (body !== inputBody) {
	        body = simplifyConstructorElideUnusedThisCapture(body, original);
	      }
	      if (hasSynthesizedSuper) {
	        body = complicateConstructorInjectSuperPresenceCheck(body);
	      }
	      return body;
	    }
	    function isSufficientlyCoveredByReturnStatements(statement) {
	      if (statement.kind === 253 /* ReturnStatement */) {
	        return true;
	      } else if (statement.kind === 245 /* IfStatement */) {
	        const ifStatement = statement;
	        if (ifStatement.elseStatement) {
	          return isSufficientlyCoveredByReturnStatements(ifStatement.thenStatement) && isSufficientlyCoveredByReturnStatements(ifStatement.elseStatement);
	        }
	      } else if (statement.kind === 241 /* Block */) {
	        const lastStatement = lastOrUndefined(statement.statements);
	        if (lastStatement && isSufficientlyCoveredByReturnStatements(lastStatement)) {
	          return true;
	        }
	      }
	      return false;
	    }
	    function createActualThis() {
	      return setEmitFlags(factory2.createThis(), 8 /* NoSubstitution */);
	    }
	    function createDefaultSuperCallOrThis() {
	      return factory2.createLogicalOr(
	        factory2.createLogicalAnd(
	          factory2.createStrictInequality(
	            createSyntheticSuper(),
	            factory2.createNull()
	          ),
	          factory2.createFunctionApplyCall(
	            createSyntheticSuper(),
	            createActualThis(),
	            factory2.createIdentifier("arguments")
	          )
	        ),
	        createActualThis()
	      );
	    }
	    function visitParameter(node) {
	      if (node.dotDotDotToken) {
	        return void 0;
	      } else if (isBindingPattern(node.name)) {
	        return setOriginalNode(
	          setTextRange(
	            factory2.createParameterDeclaration(
	              /*modifiers*/
	              void 0,
	              /*dotDotDotToken*/
	              void 0,
	              factory2.getGeneratedNameForNode(node),
	              /*questionToken*/
	              void 0,
	              /*type*/
	              void 0,
	              /*initializer*/
	              void 0
	            ),
	            /*location*/
	            node
	          ),
	          /*original*/
	          node
	        );
	      } else if (node.initializer) {
	        return setOriginalNode(
	          setTextRange(
	            factory2.createParameterDeclaration(
	              /*modifiers*/
	              void 0,
	              /*dotDotDotToken*/
	              void 0,
	              node.name,
	              /*questionToken*/
	              void 0,
	              /*type*/
	              void 0,
	              /*initializer*/
	              void 0
	            ),
	            /*location*/
	            node
	          ),
	          /*original*/
	          node
	        );
	      } else {
	        return node;
	      }
	    }
	    function hasDefaultValueOrBindingPattern(node) {
	      return node.initializer !== void 0 || isBindingPattern(node.name);
	    }
	    function addDefaultValueAssignmentsIfNeeded2(statements, node) {
	      if (!some(node.parameters, hasDefaultValueOrBindingPattern)) {
	        return false;
	      }
	      let added = false;
	      for (const parameter of node.parameters) {
	        const { name, initializer, dotDotDotToken } = parameter;
	        if (dotDotDotToken) {
	          continue;
	        }
	        if (isBindingPattern(name)) {
	          added = insertDefaultValueAssignmentForBindingPattern(statements, parameter, name, initializer) || added;
	        } else if (initializer) {
	          insertDefaultValueAssignmentForInitializer(statements, parameter, name, initializer);
	          added = true;
	        }
	      }
	      return added;
	    }
	    function insertDefaultValueAssignmentForBindingPattern(statements, parameter, name, initializer) {
	      if (name.elements.length > 0) {
	        insertStatementAfterCustomPrologue(
	          statements,
	          setEmitFlags(
	            factory2.createVariableStatement(
	              /*modifiers*/
	              void 0,
	              factory2.createVariableDeclarationList(
	                flattenDestructuringBinding(
	                  parameter,
	                  visitor,
	                  context,
	                  0 /* All */,
	                  factory2.getGeneratedNameForNode(parameter)
	                )
	              )
	            ),
	            2097152 /* CustomPrologue */
	          )
	        );
	        return true;
	      } else if (initializer) {
	        insertStatementAfterCustomPrologue(
	          statements,
	          setEmitFlags(
	            factory2.createExpressionStatement(
	              factory2.createAssignment(
	                factory2.getGeneratedNameForNode(parameter),
	                Debug.checkDefined(visitNode(initializer, visitor, isExpression))
	              )
	            ),
	            2097152 /* CustomPrologue */
	          )
	        );
	        return true;
	      }
	      return false;
	    }
	    function insertDefaultValueAssignmentForInitializer(statements, parameter, name, initializer) {
	      initializer = Debug.checkDefined(visitNode(initializer, visitor, isExpression));
	      const statement = factory2.createIfStatement(
	        factory2.createTypeCheck(factory2.cloneNode(name), "undefined"),
	        setEmitFlags(
	          setTextRange(
	            factory2.createBlock([
	              factory2.createExpressionStatement(
	                setEmitFlags(
	                  setTextRange(
	                    factory2.createAssignment(
	                      // TODO(rbuckton): Does this need to be parented?
	                      setEmitFlags(setParent(setTextRange(factory2.cloneNode(name), name), name.parent), 96 /* NoSourceMap */),
	                      setEmitFlags(initializer, 96 /* NoSourceMap */ | getEmitFlags(initializer) | 3072 /* NoComments */)
	                    ),
	                    parameter
	                  ),
	                  3072 /* NoComments */
	                )
	              )
	            ]),
	            parameter
	          ),
	          1 /* SingleLine */ | 64 /* NoTrailingSourceMap */ | 768 /* NoTokenSourceMaps */ | 3072 /* NoComments */
	        )
	      );
	      startOnNewLine(statement);
	      setTextRange(statement, parameter);
	      setEmitFlags(statement, 768 /* NoTokenSourceMaps */ | 64 /* NoTrailingSourceMap */ | 2097152 /* CustomPrologue */ | 3072 /* NoComments */);
	      insertStatementAfterCustomPrologue(statements, statement);
	    }
	    function shouldAddRestParameter(node, inConstructorWithSynthesizedSuper) {
	      return !!(node && node.dotDotDotToken && !inConstructorWithSynthesizedSuper);
	    }
	    function addRestParameterIfNeeded(statements, node, inConstructorWithSynthesizedSuper) {
	      const prologueStatements = [];
	      const parameter = lastOrUndefined(node.parameters);
	      if (!shouldAddRestParameter(parameter, inConstructorWithSynthesizedSuper)) {
	        return false;
	      }
	      const declarationName = parameter.name.kind === 80 /* Identifier */ ? setParent(setTextRange(factory2.cloneNode(parameter.name), parameter.name), parameter.name.parent) : factory2.createTempVariable(
	        /*recordTempVariable*/
	        void 0
	      );
	      setEmitFlags(declarationName, 96 /* NoSourceMap */);
	      const expressionName = parameter.name.kind === 80 /* Identifier */ ? factory2.cloneNode(parameter.name) : declarationName;
	      const restIndex = node.parameters.length - 1;
	      const temp = factory2.createLoopVariable();
	      prologueStatements.push(
	        setEmitFlags(
	          setTextRange(
	            factory2.createVariableStatement(
	              /*modifiers*/
	              void 0,
	              factory2.createVariableDeclarationList([
	                factory2.createVariableDeclaration(
	                  declarationName,
	                  /*exclamationToken*/
	                  void 0,
	                  /*type*/
	                  void 0,
	                  factory2.createArrayLiteralExpression([])
	                )
	              ])
	            ),
	            /*location*/
	            parameter
	          ),
	          2097152 /* CustomPrologue */
	        )
	      );
	      const forStatement = factory2.createForStatement(
	        setTextRange(
	          factory2.createVariableDeclarationList([
	            factory2.createVariableDeclaration(
	              temp,
	              /*exclamationToken*/
	              void 0,
	              /*type*/
	              void 0,
	              factory2.createNumericLiteral(restIndex)
	            )
	          ]),
	          parameter
	        ),
	        setTextRange(
	          factory2.createLessThan(
	            temp,
	            factory2.createPropertyAccessExpression(factory2.createIdentifier("arguments"), "length")
	          ),
	          parameter
	        ),
	        setTextRange(factory2.createPostfixIncrement(temp), parameter),
	        factory2.createBlock([
	          startOnNewLine(
	            setTextRange(
	              factory2.createExpressionStatement(
	                factory2.createAssignment(
	                  factory2.createElementAccessExpression(
	                    expressionName,
	                    restIndex === 0 ? temp : factory2.createSubtract(temp, factory2.createNumericLiteral(restIndex))
	                  ),
	                  factory2.createElementAccessExpression(factory2.createIdentifier("arguments"), temp)
	                )
	              ),
	              /*location*/
	              parameter
	            )
	          )
	        ])
	      );
	      setEmitFlags(forStatement, 2097152 /* CustomPrologue */);
	      startOnNewLine(forStatement);
	      prologueStatements.push(forStatement);
	      if (parameter.name.kind !== 80 /* Identifier */) {
	        prologueStatements.push(
	          setEmitFlags(
	            setTextRange(
	              factory2.createVariableStatement(
	                /*modifiers*/
	                void 0,
	                factory2.createVariableDeclarationList(
	                  flattenDestructuringBinding(parameter, visitor, context, 0 /* All */, expressionName)
	                )
	              ),
	              parameter
	            ),
	            2097152 /* CustomPrologue */
	          )
	        );
	      }
	      insertStatementsAfterCustomPrologue(statements, prologueStatements);
	      return true;
	    }
	    function insertCaptureThisForNodeIfNeeded(statements, node) {
	      if (hierarchyFacts & 131072 /* CapturedLexicalThis */ && node.kind !== 219 /* ArrowFunction */) {
	        insertCaptureThisForNode(statements, node, factory2.createThis());
	        return true;
	      }
	      return false;
	    }
	    function insertCaptureThisForNode(statements, node, initializer) {
	      enableSubstitutionsForCapturedThis();
	      const captureThisStatement = factory2.createVariableStatement(
	        /*modifiers*/
	        void 0,
	        factory2.createVariableDeclarationList([
	          factory2.createVariableDeclaration(
	            createCapturedThis(),
	            /*exclamationToken*/
	            void 0,
	            /*type*/
	            void 0,
	            initializer
	          )
	        ])
	      );
	      setEmitFlags(captureThisStatement, 3072 /* NoComments */ | 2097152 /* CustomPrologue */);
	      setSourceMapRange(captureThisStatement, node);
	      insertStatementAfterCustomPrologue(statements, captureThisStatement);
	    }
	    function insertCaptureNewTargetIfNeeded(statements, node) {
	      if (hierarchyFacts & 32768 /* NewTarget */) {
	        let newTarget;
	        switch (node.kind) {
	          case 219 /* ArrowFunction */:
	            return statements;
	          case 174 /* MethodDeclaration */:
	          case 177 /* GetAccessor */:
	          case 178 /* SetAccessor */:
	            newTarget = factory2.createVoidZero();
	            break;
	          case 176 /* Constructor */:
	            newTarget = factory2.createPropertyAccessExpression(
	              setEmitFlags(factory2.createThis(), 8 /* NoSubstitution */),
	              "constructor"
	            );
	            break;
	          case 262 /* FunctionDeclaration */:
	          case 218 /* FunctionExpression */:
	            newTarget = factory2.createConditionalExpression(
	              factory2.createLogicalAnd(
	                setEmitFlags(factory2.createThis(), 8 /* NoSubstitution */),
	                factory2.createBinaryExpression(
	                  setEmitFlags(factory2.createThis(), 8 /* NoSubstitution */),
	                  104 /* InstanceOfKeyword */,
	                  factory2.getLocalName(node)
	                )
	              ),
	              /*questionToken*/
	              void 0,
	              factory2.createPropertyAccessExpression(
	                setEmitFlags(factory2.createThis(), 8 /* NoSubstitution */),
	                "constructor"
	              ),
	              /*colonToken*/
	              void 0,
	              factory2.createVoidZero()
	            );
	            break;
	          default:
	            return Debug.failBadSyntaxKind(node);
	        }
	        const captureNewTargetStatement = factory2.createVariableStatement(
	          /*modifiers*/
	          void 0,
	          factory2.createVariableDeclarationList([
	            factory2.createVariableDeclaration(
	              factory2.createUniqueName("_newTarget", 16 /* Optimistic */ | 32 /* FileLevel */),
	              /*exclamationToken*/
	              void 0,
	              /*type*/
	              void 0,
	              newTarget
	            )
	          ])
	        );
	        setEmitFlags(captureNewTargetStatement, 3072 /* NoComments */ | 2097152 /* CustomPrologue */);
	        insertStatementAfterCustomPrologue(statements, captureNewTargetStatement);
	      }
	      return statements;
	    }
	    function addClassMembers(statements, node) {
	      for (const member of node.members) {
	        switch (member.kind) {
	          case 240 /* SemicolonClassElement */:
	            statements.push(transformSemicolonClassElementToStatement(member));
	            break;
	          case 174 /* MethodDeclaration */:
	            statements.push(transformClassMethodDeclarationToStatement(getClassMemberPrefix(node, member), member, node));
	            break;
	          case 177 /* GetAccessor */:
	          case 178 /* SetAccessor */:
	            const accessors = getAllAccessorDeclarations(node.members, member);
	            if (member === accessors.firstAccessor) {
	              statements.push(transformAccessorsToStatement(getClassMemberPrefix(node, member), accessors, node));
	            }
	            break;
	          case 176 /* Constructor */:
	          case 175 /* ClassStaticBlockDeclaration */:
	            break;
	          default:
	            Debug.failBadSyntaxKind(member, currentSourceFile && currentSourceFile.fileName);
	            break;
	        }
	      }
	    }
	    function transformSemicolonClassElementToStatement(member) {
	      return setTextRange(factory2.createEmptyStatement(), member);
	    }
	    function transformClassMethodDeclarationToStatement(receiver, member, container) {
	      const commentRange = getCommentRange(member);
	      const sourceMapRange = getSourceMapRange(member);
	      const memberFunction = transformFunctionLikeToExpression(
	        member,
	        /*location*/
	        member,
	        /*name*/
	        void 0,
	        container
	      );
	      const propertyName = visitNode(member.name, visitor, isPropertyName);
	      Debug.assert(propertyName);
	      let e;
	      if (!isPrivateIdentifier(propertyName) && getUseDefineForClassFields(context.getCompilerOptions())) {
	        const name = isComputedPropertyName(propertyName) ? propertyName.expression : isIdentifier(propertyName) ? factory2.createStringLiteral(unescapeLeadingUnderscores(propertyName.escapedText)) : propertyName;
	        e = factory2.createObjectDefinePropertyCall(receiver, name, factory2.createPropertyDescriptor({ value: memberFunction, enumerable: false, writable: true, configurable: true }));
	      } else {
	        const memberName = createMemberAccessForPropertyName(
	          factory2,
	          receiver,
	          propertyName,
	          /*location*/
	          member.name
	        );
	        e = factory2.createAssignment(memberName, memberFunction);
	      }
	      setEmitFlags(memberFunction, 3072 /* NoComments */);
	      setSourceMapRange(memberFunction, sourceMapRange);
	      const statement = setTextRange(
	        factory2.createExpressionStatement(e),
	        /*location*/
	        member
	      );
	      setOriginalNode(statement, member);
	      setCommentRange(statement, commentRange);
	      setEmitFlags(statement, 96 /* NoSourceMap */);
	      return statement;
	    }
	    function transformAccessorsToStatement(receiver, accessors, container) {
	      const statement = factory2.createExpressionStatement(transformAccessorsToExpression(
	        receiver,
	        accessors,
	        container,
	        /*startsOnNewLine*/
	        false
	      ));
	      setEmitFlags(statement, 3072 /* NoComments */);
	      setSourceMapRange(statement, getSourceMapRange(accessors.firstAccessor));
	      return statement;
	    }
	    function transformAccessorsToExpression(receiver, { firstAccessor, getAccessor, setAccessor }, container, startsOnNewLine) {
	      const target = setParent(setTextRange(factory2.cloneNode(receiver), receiver), receiver.parent);
	      setEmitFlags(target, 3072 /* NoComments */ | 64 /* NoTrailingSourceMap */);
	      setSourceMapRange(target, firstAccessor.name);
	      const visitedAccessorName = visitNode(firstAccessor.name, visitor, isPropertyName);
	      Debug.assert(visitedAccessorName);
	      if (isPrivateIdentifier(visitedAccessorName)) {
	        return Debug.failBadSyntaxKind(visitedAccessorName, "Encountered unhandled private identifier while transforming ES2015.");
	      }
	      const propertyName = createExpressionForPropertyName(factory2, visitedAccessorName);
	      setEmitFlags(propertyName, 3072 /* NoComments */ | 32 /* NoLeadingSourceMap */);
	      setSourceMapRange(propertyName, firstAccessor.name);
	      const properties = [];
	      if (getAccessor) {
	        const getterFunction = transformFunctionLikeToExpression(
	          getAccessor,
	          /*location*/
	          void 0,
	          /*name*/
	          void 0,
	          container
	        );
	        setSourceMapRange(getterFunction, getSourceMapRange(getAccessor));
	        setEmitFlags(getterFunction, 1024 /* NoLeadingComments */);
	        const getter = factory2.createPropertyAssignment("get", getterFunction);
	        setCommentRange(getter, getCommentRange(getAccessor));
	        properties.push(getter);
	      }
	      if (setAccessor) {
	        const setterFunction = transformFunctionLikeToExpression(
	          setAccessor,
	          /*location*/
	          void 0,
	          /*name*/
	          void 0,
	          container
	        );
	        setSourceMapRange(setterFunction, getSourceMapRange(setAccessor));
	        setEmitFlags(setterFunction, 1024 /* NoLeadingComments */);
	        const setter = factory2.createPropertyAssignment("set", setterFunction);
	        setCommentRange(setter, getCommentRange(setAccessor));
	        properties.push(setter);
	      }
	      properties.push(
	        factory2.createPropertyAssignment("enumerable", getAccessor || setAccessor ? factory2.createFalse() : factory2.createTrue()),
	        factory2.createPropertyAssignment("configurable", factory2.createTrue())
	      );
	      const call = factory2.createCallExpression(
	        factory2.createPropertyAccessExpression(factory2.createIdentifier("Object"), "defineProperty"),
	        /*typeArguments*/
	        void 0,
	        [
	          target,
	          propertyName,
	          factory2.createObjectLiteralExpression(
	            properties,
	            /*multiLine*/
	            true
	          )
	        ]
	      );
	      if (startsOnNewLine) {
	        startOnNewLine(call);
	      }
	      return call;
	    }
	    function visitArrowFunction(node) {
	      if (node.transformFlags & 16384 /* ContainsLexicalThis */ && !(hierarchyFacts & 16384 /* StaticInitializer */)) {
	        hierarchyFacts |= 131072 /* CapturedLexicalThis */;
	      }
	      const savedConvertedLoopState = convertedLoopState;
	      convertedLoopState = void 0;
	      const ancestorFacts = enterSubtree(15232 /* ArrowFunctionExcludes */, 66 /* ArrowFunctionIncludes */);
	      const func = factory2.createFunctionExpression(
	        /*modifiers*/
	        void 0,
	        /*asteriskToken*/
	        void 0,
	        /*name*/
	        void 0,
	        /*typeParameters*/
	        void 0,
	        visitParameterList(node.parameters, visitor, context),
	        /*type*/
	        void 0,
	        transformFunctionBody2(node)
	      );
	      setTextRange(func, node);
	      setOriginalNode(func, node);
	      setEmitFlags(func, 16 /* CapturesThis */);
	      exitSubtree(ancestorFacts, 0 /* ArrowFunctionSubtreeExcludes */, 0 /* None */);
	      convertedLoopState = savedConvertedLoopState;
	      return func;
	    }
	    function visitFunctionExpression(node) {
	      const ancestorFacts = getEmitFlags(node) & 524288 /* AsyncFunctionBody */ ? enterSubtree(32662 /* AsyncFunctionBodyExcludes */, 69 /* AsyncFunctionBodyIncludes */) : enterSubtree(32670 /* FunctionExcludes */, 65 /* FunctionIncludes */);
	      const savedConvertedLoopState = convertedLoopState;
	      convertedLoopState = void 0;
	      const parameters = visitParameterList(node.parameters, visitor, context);
	      const body = transformFunctionBody2(node);
	      const name = hierarchyFacts & 32768 /* NewTarget */ ? factory2.getLocalName(node) : node.name;
	      exitSubtree(ancestorFacts, 229376 /* FunctionSubtreeExcludes */, 0 /* None */);
	      convertedLoopState = savedConvertedLoopState;
	      return factory2.updateFunctionExpression(
	        node,
	        /*modifiers*/
	        void 0,
	        node.asteriskToken,
	        name,
	        /*typeParameters*/
	        void 0,
	        parameters,
	        /*type*/
	        void 0,
	        body
	      );
	    }
	    function visitFunctionDeclaration(node) {
	      const savedConvertedLoopState = convertedLoopState;
	      convertedLoopState = void 0;
	      const ancestorFacts = enterSubtree(32670 /* FunctionExcludes */, 65 /* FunctionIncludes */);
	      const parameters = visitParameterList(node.parameters, visitor, context);
	      const body = transformFunctionBody2(node);
	      const name = hierarchyFacts & 32768 /* NewTarget */ ? factory2.getLocalName(node) : node.name;
	      exitSubtree(ancestorFacts, 229376 /* FunctionSubtreeExcludes */, 0 /* None */);
	      convertedLoopState = savedConvertedLoopState;
	      return factory2.updateFunctionDeclaration(
	        node,
	        visitNodes2(node.modifiers, visitor, isModifier),
	        node.asteriskToken,
	        name,
	        /*typeParameters*/
	        void 0,
	        parameters,
	        /*type*/
	        void 0,
	        body
	      );
	    }
	    function transformFunctionLikeToExpression(node, location, name, container) {
	      const savedConvertedLoopState = convertedLoopState;
	      convertedLoopState = void 0;
	      const ancestorFacts = container && isClassLike(container) && !isStatic(node) ? enterSubtree(32670 /* FunctionExcludes */, 65 /* FunctionIncludes */ | 8 /* NonStaticClassElement */) : enterSubtree(32670 /* FunctionExcludes */, 65 /* FunctionIncludes */);
	      const parameters = visitParameterList(node.parameters, visitor, context);
	      const body = transformFunctionBody2(node);
	      if (hierarchyFacts & 32768 /* NewTarget */ && !name && (node.kind === 262 /* FunctionDeclaration */ || node.kind === 218 /* FunctionExpression */)) {
	        name = factory2.getGeneratedNameForNode(node);
	      }
	      exitSubtree(ancestorFacts, 229376 /* FunctionSubtreeExcludes */, 0 /* None */);
	      convertedLoopState = savedConvertedLoopState;
	      return setOriginalNode(
	        setTextRange(
	          factory2.createFunctionExpression(
	            /*modifiers*/
	            void 0,
	            node.asteriskToken,
	            name,
	            /*typeParameters*/
	            void 0,
	            parameters,
	            /*type*/
	            void 0,
	            body
	          ),
	          location
	        ),
	        /*original*/
	        node
	      );
	    }
	    function transformFunctionBody2(node) {
	      let multiLine = false;
	      let singleLine = false;
	      let statementsLocation;
	      let closeBraceLocation;
	      const prologue = [];
	      const statements = [];
	      const body = node.body;
	      let statementOffset;
	      resumeLexicalEnvironment();
	      if (isBlock(body)) {
	        statementOffset = factory2.copyStandardPrologue(
	          body.statements,
	          prologue,
	          0,
	          /*ensureUseStrict*/
	          false
	        );
	        statementOffset = factory2.copyCustomPrologue(body.statements, statements, statementOffset, visitor, isHoistedFunction);
	        statementOffset = factory2.copyCustomPrologue(body.statements, statements, statementOffset, visitor, isHoistedVariableStatement);
	      }
	      multiLine = addDefaultValueAssignmentsIfNeeded2(statements, node) || multiLine;
	      multiLine = addRestParameterIfNeeded(
	        statements,
	        node,
	        /*inConstructorWithSynthesizedSuper*/
	        false
	      ) || multiLine;
	      if (isBlock(body)) {
	        statementOffset = factory2.copyCustomPrologue(body.statements, statements, statementOffset, visitor);
	        statementsLocation = body.statements;
	        addRange(statements, visitNodes2(body.statements, visitor, isStatement, statementOffset));
	        if (!multiLine && body.multiLine) {
	          multiLine = true;
	        }
	      } else {
	        Debug.assert(node.kind === 219 /* ArrowFunction */);
	        statementsLocation = moveRangeEnd(body, -1);
	        const equalsGreaterThanToken = node.equalsGreaterThanToken;
	        if (!nodeIsSynthesized(equalsGreaterThanToken) && !nodeIsSynthesized(body)) {
	          if (rangeEndIsOnSameLineAsRangeStart(equalsGreaterThanToken, body, currentSourceFile)) {
	            singleLine = true;
	          } else {
	            multiLine = true;
	          }
	        }
	        const expression = visitNode(body, visitor, isExpression);
	        const returnStatement = factory2.createReturnStatement(expression);
	        setTextRange(returnStatement, body);
	        moveSyntheticComments(returnStatement, body);
	        setEmitFlags(returnStatement, 768 /* NoTokenSourceMaps */ | 64 /* NoTrailingSourceMap */ | 2048 /* NoTrailingComments */);
	        statements.push(returnStatement);
	        closeBraceLocation = body;
	      }
	      factory2.mergeLexicalEnvironment(prologue, endLexicalEnvironment());
	      insertCaptureNewTargetIfNeeded(prologue, node);
	      insertCaptureThisForNodeIfNeeded(prologue, node);
	      if (some(prologue)) {
	        multiLine = true;
	      }
	      statements.unshift(...prologue);
	      if (isBlock(body) && arrayIsEqualTo(statements, body.statements)) {
	        return body;
	      }
	      const block = factory2.createBlock(setTextRange(factory2.createNodeArray(statements), statementsLocation), multiLine);
	      setTextRange(block, node.body);
	      if (!multiLine && singleLine) {
	        setEmitFlags(block, 1 /* SingleLine */);
	      }
	      if (closeBraceLocation) {
	        setTokenSourceMapRange(block, 20 /* CloseBraceToken */, closeBraceLocation);
	      }
	      setOriginalNode(block, node.body);
	      return block;
	    }
	    function visitBlock(node, isFunctionBody2) {
	      if (isFunctionBody2) {
	        return visitEachChild(node, visitor, context);
	      }
	      const ancestorFacts = hierarchyFacts & 256 /* IterationStatement */ ? enterSubtree(7104 /* IterationStatementBlockExcludes */, 512 /* IterationStatementBlockIncludes */) : enterSubtree(6976 /* BlockExcludes */, 128 /* BlockIncludes */);
	      const updated = visitEachChild(node, visitor, context);
	      exitSubtree(ancestorFacts, 0 /* None */, 0 /* None */);
	      return updated;
	    }
	    function visitExpressionStatement(node) {
	      return visitEachChild(node, visitorWithUnusedExpressionResult, context);
	    }
	    function visitParenthesizedExpression(node, expressionResultIsUnused2) {
	      return visitEachChild(node, expressionResultIsUnused2 ? visitorWithUnusedExpressionResult : visitor, context);
	    }
	    function visitBinaryExpression(node, expressionResultIsUnused2) {
	      if (isDestructuringAssignment(node)) {
	        return flattenDestructuringAssignment(
	          node,
	          visitor,
	          context,
	          0 /* All */,
	          !expressionResultIsUnused2
	        );
	      }
	      if (node.operatorToken.kind === 28 /* CommaToken */) {
	        return factory2.updateBinaryExpression(
	          node,
	          Debug.checkDefined(visitNode(node.left, visitorWithUnusedExpressionResult, isExpression)),
	          node.operatorToken,
	          Debug.checkDefined(visitNode(node.right, expressionResultIsUnused2 ? visitorWithUnusedExpressionResult : visitor, isExpression))
	        );
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitCommaListExpression(node, expressionResultIsUnused2) {
	      if (expressionResultIsUnused2) {
	        return visitEachChild(node, visitorWithUnusedExpressionResult, context);
	      }
	      let result;
	      for (let i = 0; i < node.elements.length; i++) {
	        const element = node.elements[i];
	        const visited = visitNode(element, i < node.elements.length - 1 ? visitorWithUnusedExpressionResult : visitor, isExpression);
	        if (result || visited !== element) {
	          result || (result = node.elements.slice(0, i));
	          Debug.assert(visited);
	          result.push(visited);
	        }
	      }
	      const elements = result ? setTextRange(factory2.createNodeArray(result), node.elements) : node.elements;
	      return factory2.updateCommaListExpression(node, elements);
	    }
	    function isVariableStatementOfTypeScriptClassWrapper(node) {
	      return node.declarationList.declarations.length === 1 && !!node.declarationList.declarations[0].initializer && !!(getInternalEmitFlags(node.declarationList.declarations[0].initializer) & 1 /* TypeScriptClassWrapper */);
	    }
	    function visitVariableStatement(node) {
	      const ancestorFacts = enterSubtree(0 /* None */, hasSyntacticModifier(node, 32 /* Export */) ? 32 /* ExportedVariableStatement */ : 0 /* None */);
	      let updated;
	      if (convertedLoopState && (node.declarationList.flags & 7 /* BlockScoped */) === 0 && !isVariableStatementOfTypeScriptClassWrapper(node)) {
	        let assignments;
	        for (const decl of node.declarationList.declarations) {
	          hoistVariableDeclarationDeclaredInConvertedLoop(convertedLoopState, decl);
	          if (decl.initializer) {
	            let assignment;
	            if (isBindingPattern(decl.name)) {
	              assignment = flattenDestructuringAssignment(
	                decl,
	                visitor,
	                context,
	                0 /* All */
	              );
	            } else {
	              assignment = factory2.createBinaryExpression(decl.name, 64 /* EqualsToken */, Debug.checkDefined(visitNode(decl.initializer, visitor, isExpression)));
	              setTextRange(assignment, decl);
	            }
	            assignments = append(assignments, assignment);
	          }
	        }
	        if (assignments) {
	          updated = setTextRange(factory2.createExpressionStatement(factory2.inlineExpressions(assignments)), node);
	        } else {
	          updated = void 0;
	        }
	      } else {
	        updated = visitEachChild(node, visitor, context);
	      }
	      exitSubtree(ancestorFacts, 0 /* None */, 0 /* None */);
	      return updated;
	    }
	    function visitVariableDeclarationList(node) {
	      if (node.flags & 7 /* BlockScoped */ || node.transformFlags & 524288 /* ContainsBindingPattern */) {
	        if (node.flags & 7 /* BlockScoped */) {
	          enableSubstitutionsForBlockScopedBindings();
	        }
	        const declarations = visitNodes2(
	          node.declarations,
	          node.flags & 1 /* Let */ ? visitVariableDeclarationInLetDeclarationList : visitVariableDeclaration,
	          isVariableDeclaration
	        );
	        const declarationList = factory2.createVariableDeclarationList(declarations);
	        setOriginalNode(declarationList, node);
	        setTextRange(declarationList, node);
	        setCommentRange(declarationList, node);
	        if (node.transformFlags & 524288 /* ContainsBindingPattern */ && (isBindingPattern(node.declarations[0].name) || isBindingPattern(last(node.declarations).name))) {
	          setSourceMapRange(declarationList, getRangeUnion(declarations));
	        }
	        return declarationList;
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function getRangeUnion(declarations) {
	      let pos = -1, end = -1;
	      for (const node of declarations) {
	        pos = pos === -1 ? node.pos : node.pos === -1 ? pos : Math.min(pos, node.pos);
	        end = Math.max(end, node.end);
	      }
	      return createRange(pos, end);
	    }
	    function shouldEmitExplicitInitializerForLetDeclaration(node) {
	      const flags = resolver.getNodeCheckFlags(node);
	      const isCapturedInFunction = flags & 16384 /* CapturedBlockScopedBinding */;
	      const isDeclaredInLoop = flags & 32768 /* BlockScopedBindingInLoop */;
	      const emittedAsTopLevel = (hierarchyFacts & 64 /* TopLevel */) !== 0 || isCapturedInFunction && isDeclaredInLoop && (hierarchyFacts & 512 /* IterationStatementBlock */) !== 0;
	      const emitExplicitInitializer = !emittedAsTopLevel && (hierarchyFacts & 4096 /* ForInOrForOfStatement */) === 0 && (!resolver.isDeclarationWithCollidingName(node) || isDeclaredInLoop && !isCapturedInFunction && (hierarchyFacts & (2048 /* ForStatement */ | 4096 /* ForInOrForOfStatement */)) === 0);
	      return emitExplicitInitializer;
	    }
	    function visitVariableDeclarationInLetDeclarationList(node) {
	      const name = node.name;
	      if (isBindingPattern(name)) {
	        return visitVariableDeclaration(node);
	      }
	      if (!node.initializer && shouldEmitExplicitInitializerForLetDeclaration(node)) {
	        return factory2.updateVariableDeclaration(
	          node,
	          node.name,
	          /*exclamationToken*/
	          void 0,
	          /*type*/
	          void 0,
	          factory2.createVoidZero()
	        );
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitVariableDeclaration(node) {
	      const ancestorFacts = enterSubtree(32 /* ExportedVariableStatement */, 0 /* None */);
	      let updated;
	      if (isBindingPattern(node.name)) {
	        updated = flattenDestructuringBinding(
	          node,
	          visitor,
	          context,
	          0 /* All */,
	          /*rval*/
	          void 0,
	          (ancestorFacts & 32 /* ExportedVariableStatement */) !== 0
	        );
	      } else {
	        updated = visitEachChild(node, visitor, context);
	      }
	      exitSubtree(ancestorFacts, 0 /* None */, 0 /* None */);
	      return updated;
	    }
	    function recordLabel(node) {
	      convertedLoopState.labels.set(idText(node.label), true);
	    }
	    function resetLabel(node) {
	      convertedLoopState.labels.set(idText(node.label), false);
	    }
	    function visitLabeledStatement(node) {
	      if (convertedLoopState && !convertedLoopState.labels) {
	        convertedLoopState.labels = /* @__PURE__ */ new Map();
	      }
	      const statement = unwrapInnermostStatementOfLabel(node, convertedLoopState && recordLabel);
	      return isIterationStatement(
	        statement,
	        /*lookInLabeledStatements*/
	        false
	      ) ? visitIterationStatement(
	        statement,
	        /*outermostLabeledStatement*/
	        node
	      ) : factory2.restoreEnclosingLabel(Debug.checkDefined(visitNode(statement, visitor, isStatement, factory2.liftToBlock)), node, convertedLoopState && resetLabel);
	    }
	    function visitIterationStatement(node, outermostLabeledStatement) {
	      switch (node.kind) {
	        case 246 /* DoStatement */:
	        case 247 /* WhileStatement */:
	          return visitDoOrWhileStatement(node, outermostLabeledStatement);
	        case 248 /* ForStatement */:
	          return visitForStatement(node, outermostLabeledStatement);
	        case 249 /* ForInStatement */:
	          return visitForInStatement(node, outermostLabeledStatement);
	        case 250 /* ForOfStatement */:
	          return visitForOfStatement(node, outermostLabeledStatement);
	      }
	    }
	    function visitIterationStatementWithFacts(excludeFacts, includeFacts, node, outermostLabeledStatement, convert) {
	      const ancestorFacts = enterSubtree(excludeFacts, includeFacts);
	      const updated = convertIterationStatementBodyIfNecessary(node, outermostLabeledStatement, ancestorFacts, convert);
	      exitSubtree(ancestorFacts, 0 /* None */, 0 /* None */);
	      return updated;
	    }
	    function visitDoOrWhileStatement(node, outermostLabeledStatement) {
	      return visitIterationStatementWithFacts(
	        0 /* DoOrWhileStatementExcludes */,
	        1280 /* DoOrWhileStatementIncludes */,
	        node,
	        outermostLabeledStatement
	      );
	    }
	    function visitForStatement(node, outermostLabeledStatement) {
	      return visitIterationStatementWithFacts(
	        5056 /* ForStatementExcludes */,
	        3328 /* ForStatementIncludes */,
	        node,
	        outermostLabeledStatement
	      );
	    }
	    function visitEachChildOfForStatement2(node) {
	      return factory2.updateForStatement(
	        node,
	        visitNode(node.initializer, visitorWithUnusedExpressionResult, isForInitializer),
	        visitNode(node.condition, visitor, isExpression),
	        visitNode(node.incrementor, visitorWithUnusedExpressionResult, isExpression),
	        Debug.checkDefined(visitNode(node.statement, visitor, isStatement, factory2.liftToBlock))
	      );
	    }
	    function visitForInStatement(node, outermostLabeledStatement) {
	      return visitIterationStatementWithFacts(
	        3008 /* ForInOrForOfStatementExcludes */,
	        5376 /* ForInOrForOfStatementIncludes */,
	        node,
	        outermostLabeledStatement
	      );
	    }
	    function visitForOfStatement(node, outermostLabeledStatement) {
	      return visitIterationStatementWithFacts(
	        3008 /* ForInOrForOfStatementExcludes */,
	        5376 /* ForInOrForOfStatementIncludes */,
	        node,
	        outermostLabeledStatement,
	        compilerOptions.downlevelIteration ? convertForOfStatementForIterable : convertForOfStatementForArray
	      );
	    }
	    function convertForOfStatementHead(node, boundValue, convertedLoopBodyStatements) {
	      const statements = [];
	      const initializer = node.initializer;
	      if (isVariableDeclarationList(initializer)) {
	        if (node.initializer.flags & 7 /* BlockScoped */) {
	          enableSubstitutionsForBlockScopedBindings();
	        }
	        const firstOriginalDeclaration = firstOrUndefined(initializer.declarations);
	        if (firstOriginalDeclaration && isBindingPattern(firstOriginalDeclaration.name)) {
	          const declarations = flattenDestructuringBinding(
	            firstOriginalDeclaration,
	            visitor,
	            context,
	            0 /* All */,
	            boundValue
	          );
	          const declarationList = setTextRange(factory2.createVariableDeclarationList(declarations), node.initializer);
	          setOriginalNode(declarationList, node.initializer);
	          setSourceMapRange(declarationList, createRange(declarations[0].pos, last(declarations).end));
	          statements.push(
	            factory2.createVariableStatement(
	              /*modifiers*/
	              void 0,
	              declarationList
	            )
	          );
	        } else {
	          statements.push(
	            setTextRange(
	              factory2.createVariableStatement(
	                /*modifiers*/
	                void 0,
	                setOriginalNode(
	                  setTextRange(
	                    factory2.createVariableDeclarationList([
	                      factory2.createVariableDeclaration(
	                        firstOriginalDeclaration ? firstOriginalDeclaration.name : factory2.createTempVariable(
	                          /*recordTempVariable*/
	                          void 0
	                        ),
	                        /*exclamationToken*/
	                        void 0,
	                        /*type*/
	                        void 0,
	                        boundValue
	                      )
	                    ]),
	                    moveRangePos(initializer, -1)
	                  ),
	                  initializer
	                )
	              ),
	              moveRangeEnd(initializer, -1)
	            )
	          );
	        }
	      } else {
	        const assignment = factory2.createAssignment(initializer, boundValue);
	        if (isDestructuringAssignment(assignment)) {
	          statements.push(factory2.createExpressionStatement(visitBinaryExpression(
	            assignment,
	            /*expressionResultIsUnused*/
	            true
	          )));
	        } else {
	          setTextRangeEnd(assignment, initializer.end);
	          statements.push(setTextRange(factory2.createExpressionStatement(Debug.checkDefined(visitNode(assignment, visitor, isExpression))), moveRangeEnd(initializer, -1)));
	        }
	      }
	      if (convertedLoopBodyStatements) {
	        return createSyntheticBlockForConvertedStatements(addRange(statements, convertedLoopBodyStatements));
	      } else {
	        const statement = visitNode(node.statement, visitor, isStatement, factory2.liftToBlock);
	        Debug.assert(statement);
	        if (isBlock(statement)) {
	          return factory2.updateBlock(statement, setTextRange(factory2.createNodeArray(concatenate(statements, statement.statements)), statement.statements));
	        } else {
	          statements.push(statement);
	          return createSyntheticBlockForConvertedStatements(statements);
	        }
	      }
	    }
	    function createSyntheticBlockForConvertedStatements(statements) {
	      return setEmitFlags(
	        factory2.createBlock(
	          factory2.createNodeArray(statements),
	          /*multiLine*/
	          true
	        ),
	        96 /* NoSourceMap */ | 768 /* NoTokenSourceMaps */
	      );
	    }
	    function convertForOfStatementForArray(node, outermostLabeledStatement, convertedLoopBodyStatements) {
	      const expression = visitNode(node.expression, visitor, isExpression);
	      Debug.assert(expression);
	      const counter = factory2.createLoopVariable();
	      const rhsReference = isIdentifier(expression) ? factory2.getGeneratedNameForNode(expression) : factory2.createTempVariable(
	        /*recordTempVariable*/
	        void 0
	      );
	      setEmitFlags(expression, 96 /* NoSourceMap */ | getEmitFlags(expression));
	      const forStatement = setTextRange(
	        factory2.createForStatement(
	          /*initializer*/
	          setEmitFlags(
	            setTextRange(
	              factory2.createVariableDeclarationList([
	                setTextRange(factory2.createVariableDeclaration(
	                  counter,
	                  /*exclamationToken*/
	                  void 0,
	                  /*type*/
	                  void 0,
	                  factory2.createNumericLiteral(0)
	                ), moveRangePos(node.expression, -1)),
	                setTextRange(factory2.createVariableDeclaration(
	                  rhsReference,
	                  /*exclamationToken*/
	                  void 0,
	                  /*type*/
	                  void 0,
	                  expression
	                ), node.expression)
	              ]),
	              node.expression
	            ),
	            4194304 /* NoHoisting */
	          ),
	          /*condition*/
	          setTextRange(
	            factory2.createLessThan(
	              counter,
	              factory2.createPropertyAccessExpression(rhsReference, "length")
	            ),
	            node.expression
	          ),
	          /*incrementor*/
	          setTextRange(factory2.createPostfixIncrement(counter), node.expression),
	          /*statement*/
	          convertForOfStatementHead(
	            node,
	            factory2.createElementAccessExpression(rhsReference, counter),
	            convertedLoopBodyStatements
	          )
	        ),
	        /*location*/
	        node
	      );
	      setEmitFlags(forStatement, 512 /* NoTokenTrailingSourceMaps */);
	      setTextRange(forStatement, node);
	      return factory2.restoreEnclosingLabel(forStatement, outermostLabeledStatement, convertedLoopState && resetLabel);
	    }
	    function convertForOfStatementForIterable(node, outermostLabeledStatement, convertedLoopBodyStatements, ancestorFacts) {
	      const expression = visitNode(node.expression, visitor, isExpression);
	      Debug.assert(expression);
	      const iterator = isIdentifier(expression) ? factory2.getGeneratedNameForNode(expression) : factory2.createTempVariable(
	        /*recordTempVariable*/
	        void 0
	      );
	      const result = isIdentifier(expression) ? factory2.getGeneratedNameForNode(iterator) : factory2.createTempVariable(
	        /*recordTempVariable*/
	        void 0
	      );
	      const errorRecord = factory2.createUniqueName("e");
	      const catchVariable = factory2.getGeneratedNameForNode(errorRecord);
	      const returnMethod = factory2.createTempVariable(
	        /*recordTempVariable*/
	        void 0
	      );
	      const values = setTextRange(emitHelpers().createValuesHelper(expression), node.expression);
	      const next = factory2.createCallExpression(
	        factory2.createPropertyAccessExpression(iterator, "next"),
	        /*typeArguments*/
	        void 0,
	        []
	      );
	      hoistVariableDeclaration(errorRecord);
	      hoistVariableDeclaration(returnMethod);
	      const initializer = ancestorFacts & 1024 /* IterationContainer */ ? factory2.inlineExpressions([factory2.createAssignment(errorRecord, factory2.createVoidZero()), values]) : values;
	      const forStatement = setEmitFlags(
	        setTextRange(
	          factory2.createForStatement(
	            /*initializer*/
	            setEmitFlags(
	              setTextRange(
	                factory2.createVariableDeclarationList([
	                  setTextRange(factory2.createVariableDeclaration(
	                    iterator,
	                    /*exclamationToken*/
	                    void 0,
	                    /*type*/
	                    void 0,
	                    initializer
	                  ), node.expression),
	                  factory2.createVariableDeclaration(
	                    result,
	                    /*exclamationToken*/
	                    void 0,
	                    /*type*/
	                    void 0,
	                    next
	                  )
	                ]),
	                node.expression
	              ),
	              4194304 /* NoHoisting */
	            ),
	            /*condition*/
	            factory2.createLogicalNot(factory2.createPropertyAccessExpression(result, "done")),
	            /*incrementor*/
	            factory2.createAssignment(result, next),
	            /*statement*/
	            convertForOfStatementHead(
	              node,
	              factory2.createPropertyAccessExpression(result, "value"),
	              convertedLoopBodyStatements
	            )
	          ),
	          /*location*/
	          node
	        ),
	        512 /* NoTokenTrailingSourceMaps */
	      );
	      return factory2.createTryStatement(
	        factory2.createBlock([
	          factory2.restoreEnclosingLabel(
	            forStatement,
	            outermostLabeledStatement,
	            convertedLoopState && resetLabel
	          )
	        ]),
	        factory2.createCatchClause(
	          factory2.createVariableDeclaration(catchVariable),
	          setEmitFlags(
	            factory2.createBlock([
	              factory2.createExpressionStatement(
	                factory2.createAssignment(
	                  errorRecord,
	                  factory2.createObjectLiteralExpression([
	                    factory2.createPropertyAssignment("error", catchVariable)
	                  ])
	                )
	              )
	            ]),
	            1 /* SingleLine */
	          )
	        ),
	        factory2.createBlock([
	          factory2.createTryStatement(
	            /*tryBlock*/
	            factory2.createBlock([
	              setEmitFlags(
	                factory2.createIfStatement(
	                  factory2.createLogicalAnd(
	                    factory2.createLogicalAnd(
	                      result,
	                      factory2.createLogicalNot(
	                        factory2.createPropertyAccessExpression(result, "done")
	                      )
	                    ),
	                    factory2.createAssignment(
	                      returnMethod,
	                      factory2.createPropertyAccessExpression(iterator, "return")
	                    )
	                  ),
	                  factory2.createExpressionStatement(
	                    factory2.createFunctionCallCall(returnMethod, iterator, [])
	                  )
	                ),
	                1 /* SingleLine */
	              )
	            ]),
	            /*catchClause*/
	            void 0,
	            /*finallyBlock*/
	            setEmitFlags(
	              factory2.createBlock([
	                setEmitFlags(
	                  factory2.createIfStatement(
	                    errorRecord,
	                    factory2.createThrowStatement(
	                      factory2.createPropertyAccessExpression(errorRecord, "error")
	                    )
	                  ),
	                  1 /* SingleLine */
	                )
	              ]),
	              1 /* SingleLine */
	            )
	          )
	        ])
	      );
	    }
	    function visitObjectLiteralExpression(node) {
	      const properties = node.properties;
	      let numInitialProperties = -1, hasComputed = false;
	      for (let i = 0; i < properties.length; i++) {
	        const property = properties[i];
	        if (property.transformFlags & 1048576 /* ContainsYield */ && hierarchyFacts & 4 /* AsyncFunctionBody */ || (hasComputed = Debug.checkDefined(property.name).kind === 167 /* ComputedPropertyName */)) {
	          numInitialProperties = i;
	          break;
	        }
	      }
	      if (numInitialProperties < 0) {
	        return visitEachChild(node, visitor, context);
	      }
	      const temp = factory2.createTempVariable(hoistVariableDeclaration);
	      const expressions = [];
	      const assignment = factory2.createAssignment(
	        temp,
	        setEmitFlags(
	          factory2.createObjectLiteralExpression(
	            visitNodes2(properties, visitor, isObjectLiteralElementLike, 0, numInitialProperties),
	            node.multiLine
	          ),
	          hasComputed ? 131072 /* Indented */ : 0
	        )
	      );
	      if (node.multiLine) {
	        startOnNewLine(assignment);
	      }
	      expressions.push(assignment);
	      addObjectLiteralMembers(expressions, node, temp, numInitialProperties);
	      expressions.push(node.multiLine ? startOnNewLine(setParent(setTextRange(factory2.cloneNode(temp), temp), temp.parent)) : temp);
	      return factory2.inlineExpressions(expressions);
	    }
	    function shouldConvertPartOfIterationStatement(node) {
	      return (resolver.getNodeCheckFlags(node) & 8192 /* ContainsCapturedBlockScopeBinding */) !== 0;
	    }
	    function shouldConvertInitializerOfForStatement(node) {
	      return isForStatement(node) && !!node.initializer && shouldConvertPartOfIterationStatement(node.initializer);
	    }
	    function shouldConvertConditionOfForStatement(node) {
	      return isForStatement(node) && !!node.condition && shouldConvertPartOfIterationStatement(node.condition);
	    }
	    function shouldConvertIncrementorOfForStatement(node) {
	      return isForStatement(node) && !!node.incrementor && shouldConvertPartOfIterationStatement(node.incrementor);
	    }
	    function shouldConvertIterationStatement(node) {
	      return shouldConvertBodyOfIterationStatement(node) || shouldConvertInitializerOfForStatement(node);
	    }
	    function shouldConvertBodyOfIterationStatement(node) {
	      return (resolver.getNodeCheckFlags(node) & 4096 /* LoopWithCapturedBlockScopedBinding */) !== 0;
	    }
	    function hoistVariableDeclarationDeclaredInConvertedLoop(state, node) {
	      if (!state.hoistedLocalVariables) {
	        state.hoistedLocalVariables = [];
	      }
	      visit(node.name);
	      function visit(node2) {
	        if (node2.kind === 80 /* Identifier */) {
	          state.hoistedLocalVariables.push(node2);
	        } else {
	          for (const element of node2.elements) {
	            if (!isOmittedExpression(element)) {
	              visit(element.name);
	            }
	          }
	        }
	      }
	    }
	    function convertIterationStatementBodyIfNecessary(node, outermostLabeledStatement, ancestorFacts, convert) {
	      if (!shouldConvertIterationStatement(node)) {
	        let saveAllowedNonLabeledJumps;
	        if (convertedLoopState) {
	          saveAllowedNonLabeledJumps = convertedLoopState.allowedNonLabeledJumps;
	          convertedLoopState.allowedNonLabeledJumps = 2 /* Break */ | 4 /* Continue */;
	        }
	        const result = convert ? convert(
	          node,
	          outermostLabeledStatement,
	          /*convertedLoopBodyStatements*/
	          void 0,
	          ancestorFacts
	        ) : factory2.restoreEnclosingLabel(
	          isForStatement(node) ? visitEachChildOfForStatement2(node) : visitEachChild(node, visitor, context),
	          outermostLabeledStatement,
	          convertedLoopState && resetLabel
	        );
	        if (convertedLoopState) {
	          convertedLoopState.allowedNonLabeledJumps = saveAllowedNonLabeledJumps;
	        }
	        return result;
	      }
	      const currentState = createConvertedLoopState(node);
	      const statements = [];
	      const outerConvertedLoopState = convertedLoopState;
	      convertedLoopState = currentState;
	      const initializerFunction = shouldConvertInitializerOfForStatement(node) ? createFunctionForInitializerOfForStatement(node, currentState) : void 0;
	      const bodyFunction = shouldConvertBodyOfIterationStatement(node) ? createFunctionForBodyOfIterationStatement(node, currentState, outerConvertedLoopState) : void 0;
	      convertedLoopState = outerConvertedLoopState;
	      if (initializerFunction)
	        statements.push(initializerFunction.functionDeclaration);
	      if (bodyFunction)
	        statements.push(bodyFunction.functionDeclaration);
	      addExtraDeclarationsForConvertedLoop(statements, currentState, outerConvertedLoopState);
	      if (initializerFunction) {
	        statements.push(generateCallToConvertedLoopInitializer(initializerFunction.functionName, initializerFunction.containsYield));
	      }
	      let loop;
	      if (bodyFunction) {
	        if (convert) {
	          loop = convert(node, outermostLabeledStatement, bodyFunction.part, ancestorFacts);
	        } else {
	          const clone2 = convertIterationStatementCore(node, initializerFunction, factory2.createBlock(
	            bodyFunction.part,
	            /*multiLine*/
	            true
	          ));
	          loop = factory2.restoreEnclosingLabel(clone2, outermostLabeledStatement, convertedLoopState && resetLabel);
	        }
	      } else {
	        const clone2 = convertIterationStatementCore(node, initializerFunction, Debug.checkDefined(visitNode(node.statement, visitor, isStatement, factory2.liftToBlock)));
	        loop = factory2.restoreEnclosingLabel(clone2, outermostLabeledStatement, convertedLoopState && resetLabel);
	      }
	      statements.push(loop);
	      return statements;
	    }
	    function convertIterationStatementCore(node, initializerFunction, convertedLoopBody) {
	      switch (node.kind) {
	        case 248 /* ForStatement */:
	          return convertForStatement(node, initializerFunction, convertedLoopBody);
	        case 249 /* ForInStatement */:
	          return convertForInStatement(node, convertedLoopBody);
	        case 250 /* ForOfStatement */:
	          return convertForOfStatement(node, convertedLoopBody);
	        case 246 /* DoStatement */:
	          return convertDoStatement(node, convertedLoopBody);
	        case 247 /* WhileStatement */:
	          return convertWhileStatement(node, convertedLoopBody);
	        default:
	          return Debug.failBadSyntaxKind(node, "IterationStatement expected");
	      }
	    }
	    function convertForStatement(node, initializerFunction, convertedLoopBody) {
	      const shouldConvertCondition = node.condition && shouldConvertPartOfIterationStatement(node.condition);
	      const shouldConvertIncrementor = shouldConvertCondition || node.incrementor && shouldConvertPartOfIterationStatement(node.incrementor);
	      return factory2.updateForStatement(
	        node,
	        visitNode(initializerFunction ? initializerFunction.part : node.initializer, visitorWithUnusedExpressionResult, isForInitializer),
	        visitNode(shouldConvertCondition ? void 0 : node.condition, visitor, isExpression),
	        visitNode(shouldConvertIncrementor ? void 0 : node.incrementor, visitorWithUnusedExpressionResult, isExpression),
	        convertedLoopBody
	      );
	    }
	    function convertForOfStatement(node, convertedLoopBody) {
	      return factory2.updateForOfStatement(
	        node,
	        /*awaitModifier*/
	        void 0,
	        Debug.checkDefined(visitNode(node.initializer, visitor, isForInitializer)),
	        Debug.checkDefined(visitNode(node.expression, visitor, isExpression)),
	        convertedLoopBody
	      );
	    }
	    function convertForInStatement(node, convertedLoopBody) {
	      return factory2.updateForInStatement(
	        node,
	        Debug.checkDefined(visitNode(node.initializer, visitor, isForInitializer)),
	        Debug.checkDefined(visitNode(node.expression, visitor, isExpression)),
	        convertedLoopBody
	      );
	    }
	    function convertDoStatement(node, convertedLoopBody) {
	      return factory2.updateDoStatement(
	        node,
	        convertedLoopBody,
	        Debug.checkDefined(visitNode(node.expression, visitor, isExpression))
	      );
	    }
	    function convertWhileStatement(node, convertedLoopBody) {
	      return factory2.updateWhileStatement(
	        node,
	        Debug.checkDefined(visitNode(node.expression, visitor, isExpression)),
	        convertedLoopBody
	      );
	    }
	    function createConvertedLoopState(node) {
	      let loopInitializer;
	      switch (node.kind) {
	        case 248 /* ForStatement */:
	        case 249 /* ForInStatement */:
	        case 250 /* ForOfStatement */:
	          const initializer = node.initializer;
	          if (initializer && initializer.kind === 261 /* VariableDeclarationList */) {
	            loopInitializer = initializer;
	          }
	          break;
	      }
	      const loopParameters = [];
	      const loopOutParameters = [];
	      if (loopInitializer && getCombinedNodeFlags(loopInitializer) & 7 /* BlockScoped */) {
	        const hasCapturedBindingsInForHead = shouldConvertInitializerOfForStatement(node) || shouldConvertConditionOfForStatement(node) || shouldConvertIncrementorOfForStatement(node);
	        for (const decl of loopInitializer.declarations) {
	          processLoopVariableDeclaration(node, decl, loopParameters, loopOutParameters, hasCapturedBindingsInForHead);
	        }
	      }
	      const currentState = { loopParameters, loopOutParameters };
	      if (convertedLoopState) {
	        if (convertedLoopState.argumentsName) {
	          currentState.argumentsName = convertedLoopState.argumentsName;
	        }
	        if (convertedLoopState.thisName) {
	          currentState.thisName = convertedLoopState.thisName;
	        }
	        if (convertedLoopState.hoistedLocalVariables) {
	          currentState.hoistedLocalVariables = convertedLoopState.hoistedLocalVariables;
	        }
	      }
	      return currentState;
	    }
	    function addExtraDeclarationsForConvertedLoop(statements, state, outerState) {
	      let extraVariableDeclarations;
	      if (state.argumentsName) {
	        if (outerState) {
	          outerState.argumentsName = state.argumentsName;
	        } else {
	          (extraVariableDeclarations || (extraVariableDeclarations = [])).push(
	            factory2.createVariableDeclaration(
	              state.argumentsName,
	              /*exclamationToken*/
	              void 0,
	              /*type*/
	              void 0,
	              factory2.createIdentifier("arguments")
	            )
	          );
	        }
	      }
	      if (state.thisName) {
	        if (outerState) {
	          outerState.thisName = state.thisName;
	        } else {
	          (extraVariableDeclarations || (extraVariableDeclarations = [])).push(
	            factory2.createVariableDeclaration(
	              state.thisName,
	              /*exclamationToken*/
	              void 0,
	              /*type*/
	              void 0,
	              factory2.createIdentifier("this")
	            )
	          );
	        }
	      }
	      if (state.hoistedLocalVariables) {
	        if (outerState) {
	          outerState.hoistedLocalVariables = state.hoistedLocalVariables;
	        } else {
	          if (!extraVariableDeclarations) {
	            extraVariableDeclarations = [];
	          }
	          for (const identifier of state.hoistedLocalVariables) {
	            extraVariableDeclarations.push(factory2.createVariableDeclaration(identifier));
	          }
	        }
	      }
	      if (state.loopOutParameters.length) {
	        if (!extraVariableDeclarations) {
	          extraVariableDeclarations = [];
	        }
	        for (const outParam of state.loopOutParameters) {
	          extraVariableDeclarations.push(factory2.createVariableDeclaration(outParam.outParamName));
	        }
	      }
	      if (state.conditionVariable) {
	        if (!extraVariableDeclarations) {
	          extraVariableDeclarations = [];
	        }
	        extraVariableDeclarations.push(factory2.createVariableDeclaration(
	          state.conditionVariable,
	          /*exclamationToken*/
	          void 0,
	          /*type*/
	          void 0,
	          factory2.createFalse()
	        ));
	      }
	      if (extraVariableDeclarations) {
	        statements.push(factory2.createVariableStatement(
	          /*modifiers*/
	          void 0,
	          factory2.createVariableDeclarationList(extraVariableDeclarations)
	        ));
	      }
	    }
	    function createOutVariable(p) {
	      return factory2.createVariableDeclaration(
	        p.originalName,
	        /*exclamationToken*/
	        void 0,
	        /*type*/
	        void 0,
	        p.outParamName
	      );
	    }
	    function createFunctionForInitializerOfForStatement(node, currentState) {
	      const functionName = factory2.createUniqueName("_loop_init");
	      const containsYield = (node.initializer.transformFlags & 1048576 /* ContainsYield */) !== 0;
	      let emitFlags = 0 /* None */;
	      if (currentState.containsLexicalThis)
	        emitFlags |= 16 /* CapturesThis */;
	      if (containsYield && hierarchyFacts & 4 /* AsyncFunctionBody */)
	        emitFlags |= 524288 /* AsyncFunctionBody */;
	      const statements = [];
	      statements.push(factory2.createVariableStatement(
	        /*modifiers*/
	        void 0,
	        node.initializer
	      ));
	      copyOutParameters(currentState.loopOutParameters, 2 /* Initializer */, 1 /* ToOutParameter */, statements);
	      const functionDeclaration = factory2.createVariableStatement(
	        /*modifiers*/
	        void 0,
	        setEmitFlags(
	          factory2.createVariableDeclarationList([
	            factory2.createVariableDeclaration(
	              functionName,
	              /*exclamationToken*/
	              void 0,
	              /*type*/
	              void 0,
	              setEmitFlags(
	                factory2.createFunctionExpression(
	                  /*modifiers*/
	                  void 0,
	                  containsYield ? factory2.createToken(42 /* AsteriskToken */) : void 0,
	                  /*name*/
	                  void 0,
	                  /*typeParameters*/
	                  void 0,
	                  /*parameters*/
	                  void 0,
	                  /*type*/
	                  void 0,
	                  Debug.checkDefined(visitNode(
	                    factory2.createBlock(
	                      statements,
	                      /*multiLine*/
	                      true
	                    ),
	                    visitor,
	                    isBlock
	                  ))
	                ),
	                emitFlags
	              )
	            )
	          ]),
	          4194304 /* NoHoisting */
	        )
	      );
	      const part = factory2.createVariableDeclarationList(map(currentState.loopOutParameters, createOutVariable));
	      return { functionName, containsYield, functionDeclaration, part };
	    }
	    function createFunctionForBodyOfIterationStatement(node, currentState, outerState) {
	      const functionName = factory2.createUniqueName("_loop");
	      startLexicalEnvironment();
	      const statement = visitNode(node.statement, visitor, isStatement, factory2.liftToBlock);
	      const lexicalEnvironment = endLexicalEnvironment();
	      const statements = [];
	      if (shouldConvertConditionOfForStatement(node) || shouldConvertIncrementorOfForStatement(node)) {
	        currentState.conditionVariable = factory2.createUniqueName("inc");
	        if (node.incrementor) {
	          statements.push(factory2.createIfStatement(
	            currentState.conditionVariable,
	            factory2.createExpressionStatement(Debug.checkDefined(visitNode(node.incrementor, visitor, isExpression))),
	            factory2.createExpressionStatement(factory2.createAssignment(currentState.conditionVariable, factory2.createTrue()))
	          ));
	        } else {
	          statements.push(factory2.createIfStatement(
	            factory2.createLogicalNot(currentState.conditionVariable),
	            factory2.createExpressionStatement(factory2.createAssignment(currentState.conditionVariable, factory2.createTrue()))
	          ));
	        }
	        if (shouldConvertConditionOfForStatement(node)) {
	          statements.push(factory2.createIfStatement(
	            factory2.createPrefixUnaryExpression(54 /* ExclamationToken */, Debug.checkDefined(visitNode(node.condition, visitor, isExpression))),
	            Debug.checkDefined(visitNode(factory2.createBreakStatement(), visitor, isStatement))
	          ));
	        }
	      }
	      Debug.assert(statement);
	      if (isBlock(statement)) {
	        addRange(statements, statement.statements);
	      } else {
	        statements.push(statement);
	      }
	      copyOutParameters(currentState.loopOutParameters, 1 /* Body */, 1 /* ToOutParameter */, statements);
	      insertStatementsAfterStandardPrologue(statements, lexicalEnvironment);
	      const loopBody = factory2.createBlock(
	        statements,
	        /*multiLine*/
	        true
	      );
	      if (isBlock(statement))
	        setOriginalNode(loopBody, statement);
	      const containsYield = (node.statement.transformFlags & 1048576 /* ContainsYield */) !== 0;
	      let emitFlags = 1048576 /* ReuseTempVariableScope */;
	      if (currentState.containsLexicalThis)
	        emitFlags |= 16 /* CapturesThis */;
	      if (containsYield && (hierarchyFacts & 4 /* AsyncFunctionBody */) !== 0)
	        emitFlags |= 524288 /* AsyncFunctionBody */;
	      const functionDeclaration = factory2.createVariableStatement(
	        /*modifiers*/
	        void 0,
	        setEmitFlags(
	          factory2.createVariableDeclarationList(
	            [
	              factory2.createVariableDeclaration(
	                functionName,
	                /*exclamationToken*/
	                void 0,
	                /*type*/
	                void 0,
	                setEmitFlags(
	                  factory2.createFunctionExpression(
	                    /*modifiers*/
	                    void 0,
	                    containsYield ? factory2.createToken(42 /* AsteriskToken */) : void 0,
	                    /*name*/
	                    void 0,
	                    /*typeParameters*/
	                    void 0,
	                    currentState.loopParameters,
	                    /*type*/
	                    void 0,
	                    loopBody
	                  ),
	                  emitFlags
	                )
	              )
	            ]
	          ),
	          4194304 /* NoHoisting */
	        )
	      );
	      const part = generateCallToConvertedLoop(functionName, currentState, outerState, containsYield);
	      return { functionName, containsYield, functionDeclaration, part };
	    }
	    function copyOutParameter(outParam, copyDirection) {
	      const source = copyDirection === 0 /* ToOriginal */ ? outParam.outParamName : outParam.originalName;
	      const target = copyDirection === 0 /* ToOriginal */ ? outParam.originalName : outParam.outParamName;
	      return factory2.createBinaryExpression(target, 64 /* EqualsToken */, source);
	    }
	    function copyOutParameters(outParams, partFlags, copyDirection, statements) {
	      for (const outParam of outParams) {
	        if (outParam.flags & partFlags) {
	          statements.push(factory2.createExpressionStatement(copyOutParameter(outParam, copyDirection)));
	        }
	      }
	    }
	    function generateCallToConvertedLoopInitializer(initFunctionExpressionName, containsYield) {
	      const call = factory2.createCallExpression(
	        initFunctionExpressionName,
	        /*typeArguments*/
	        void 0,
	        []
	      );
	      const callResult = containsYield ? factory2.createYieldExpression(
	        factory2.createToken(42 /* AsteriskToken */),
	        setEmitFlags(call, 8388608 /* Iterator */)
	      ) : call;
	      return factory2.createExpressionStatement(callResult);
	    }
	    function generateCallToConvertedLoop(loopFunctionExpressionName, state, outerState, containsYield) {
	      const statements = [];
	      const isSimpleLoop = !(state.nonLocalJumps & ~4 /* Continue */) && !state.labeledNonLocalBreaks && !state.labeledNonLocalContinues;
	      const call = factory2.createCallExpression(
	        loopFunctionExpressionName,
	        /*typeArguments*/
	        void 0,
	        map(state.loopParameters, (p) => p.name)
	      );
	      const callResult = containsYield ? factory2.createYieldExpression(
	        factory2.createToken(42 /* AsteriskToken */),
	        setEmitFlags(call, 8388608 /* Iterator */)
	      ) : call;
	      if (isSimpleLoop) {
	        statements.push(factory2.createExpressionStatement(callResult));
	        copyOutParameters(state.loopOutParameters, 1 /* Body */, 0 /* ToOriginal */, statements);
	      } else {
	        const loopResultName = factory2.createUniqueName("state");
	        const stateVariable = factory2.createVariableStatement(
	          /*modifiers*/
	          void 0,
	          factory2.createVariableDeclarationList(
	            [factory2.createVariableDeclaration(
	              loopResultName,
	              /*exclamationToken*/
	              void 0,
	              /*type*/
	              void 0,
	              callResult
	            )]
	          )
	        );
	        statements.push(stateVariable);
	        copyOutParameters(state.loopOutParameters, 1 /* Body */, 0 /* ToOriginal */, statements);
	        if (state.nonLocalJumps & 8 /* Return */) {
	          let returnStatement;
	          if (outerState) {
	            outerState.nonLocalJumps |= 8 /* Return */;
	            returnStatement = factory2.createReturnStatement(loopResultName);
	          } else {
	            returnStatement = factory2.createReturnStatement(factory2.createPropertyAccessExpression(loopResultName, "value"));
	          }
	          statements.push(
	            factory2.createIfStatement(
	              factory2.createTypeCheck(loopResultName, "object"),
	              returnStatement
	            )
	          );
	        }
	        if (state.nonLocalJumps & 2 /* Break */) {
	          statements.push(
	            factory2.createIfStatement(
	              factory2.createStrictEquality(
	                loopResultName,
	                factory2.createStringLiteral("break")
	              ),
	              factory2.createBreakStatement()
	            )
	          );
	        }
	        if (state.labeledNonLocalBreaks || state.labeledNonLocalContinues) {
	          const caseClauses = [];
	          processLabeledJumps(
	            state.labeledNonLocalBreaks,
	            /*isBreak*/
	            true,
	            loopResultName,
	            outerState,
	            caseClauses
	          );
	          processLabeledJumps(
	            state.labeledNonLocalContinues,
	            /*isBreak*/
	            false,
	            loopResultName,
	            outerState,
	            caseClauses
	          );
	          statements.push(
	            factory2.createSwitchStatement(
	              loopResultName,
	              factory2.createCaseBlock(caseClauses)
	            )
	          );
	        }
	      }
	      return statements;
	    }
	    function setLabeledJump(state, isBreak, labelText, labelMarker) {
	      if (isBreak) {
	        if (!state.labeledNonLocalBreaks) {
	          state.labeledNonLocalBreaks = /* @__PURE__ */ new Map();
	        }
	        state.labeledNonLocalBreaks.set(labelText, labelMarker);
	      } else {
	        if (!state.labeledNonLocalContinues) {
	          state.labeledNonLocalContinues = /* @__PURE__ */ new Map();
	        }
	        state.labeledNonLocalContinues.set(labelText, labelMarker);
	      }
	    }
	    function processLabeledJumps(table, isBreak, loopResultName, outerLoop, caseClauses) {
	      if (!table) {
	        return;
	      }
	      table.forEach((labelMarker, labelText) => {
	        const statements = [];
	        if (!outerLoop || outerLoop.labels && outerLoop.labels.get(labelText)) {
	          const label = factory2.createIdentifier(labelText);
	          statements.push(isBreak ? factory2.createBreakStatement(label) : factory2.createContinueStatement(label));
	        } else {
	          setLabeledJump(outerLoop, isBreak, labelText, labelMarker);
	          statements.push(factory2.createReturnStatement(loopResultName));
	        }
	        caseClauses.push(factory2.createCaseClause(factory2.createStringLiteral(labelMarker), statements));
	      });
	    }
	    function processLoopVariableDeclaration(container, decl, loopParameters, loopOutParameters, hasCapturedBindingsInForHead) {
	      const name = decl.name;
	      if (isBindingPattern(name)) {
	        for (const element of name.elements) {
	          if (!isOmittedExpression(element)) {
	            processLoopVariableDeclaration(container, element, loopParameters, loopOutParameters, hasCapturedBindingsInForHead);
	          }
	        }
	      } else {
	        loopParameters.push(factory2.createParameterDeclaration(
	          /*modifiers*/
	          void 0,
	          /*dotDotDotToken*/
	          void 0,
	          name
	        ));
	        const checkFlags = resolver.getNodeCheckFlags(decl);
	        if (checkFlags & 65536 /* NeedsLoopOutParameter */ || hasCapturedBindingsInForHead) {
	          const outParamName = factory2.createUniqueName("out_" + idText(name));
	          let flags = 0 /* None */;
	          if (checkFlags & 65536 /* NeedsLoopOutParameter */) {
	            flags |= 1 /* Body */;
	          }
	          if (isForStatement(container)) {
	            if (container.initializer && resolver.isBindingCapturedByNode(container.initializer, decl)) {
	              flags |= 2 /* Initializer */;
	            }
	            if (container.condition && resolver.isBindingCapturedByNode(container.condition, decl) || container.incrementor && resolver.isBindingCapturedByNode(container.incrementor, decl)) {
	              flags |= 1 /* Body */;
	            }
	          }
	          loopOutParameters.push({ flags, originalName: name, outParamName });
	        }
	      }
	    }
	    function addObjectLiteralMembers(expressions, node, receiver, start) {
	      const properties = node.properties;
	      const numProperties = properties.length;
	      for (let i = start; i < numProperties; i++) {
	        const property = properties[i];
	        switch (property.kind) {
	          case 177 /* GetAccessor */:
	          case 178 /* SetAccessor */:
	            const accessors = getAllAccessorDeclarations(node.properties, property);
	            if (property === accessors.firstAccessor) {
	              expressions.push(transformAccessorsToExpression(receiver, accessors, node, !!node.multiLine));
	            }
	            break;
	          case 174 /* MethodDeclaration */:
	            expressions.push(transformObjectLiteralMethodDeclarationToExpression(property, receiver, node, node.multiLine));
	            break;
	          case 303 /* PropertyAssignment */:
	            expressions.push(transformPropertyAssignmentToExpression(property, receiver, node.multiLine));
	            break;
	          case 304 /* ShorthandPropertyAssignment */:
	            expressions.push(transformShorthandPropertyAssignmentToExpression(property, receiver, node.multiLine));
	            break;
	          default:
	            Debug.failBadSyntaxKind(node);
	            break;
	        }
	      }
	    }
	    function transformPropertyAssignmentToExpression(property, receiver, startsOnNewLine) {
	      const expression = factory2.createAssignment(
	        createMemberAccessForPropertyName(
	          factory2,
	          receiver,
	          Debug.checkDefined(visitNode(property.name, visitor, isPropertyName))
	        ),
	        Debug.checkDefined(visitNode(property.initializer, visitor, isExpression))
	      );
	      setTextRange(expression, property);
	      if (startsOnNewLine) {
	        startOnNewLine(expression);
	      }
	      return expression;
	    }
	    function transformShorthandPropertyAssignmentToExpression(property, receiver, startsOnNewLine) {
	      const expression = factory2.createAssignment(
	        createMemberAccessForPropertyName(
	          factory2,
	          receiver,
	          Debug.checkDefined(visitNode(property.name, visitor, isPropertyName))
	        ),
	        factory2.cloneNode(property.name)
	      );
	      setTextRange(expression, property);
	      if (startsOnNewLine) {
	        startOnNewLine(expression);
	      }
	      return expression;
	    }
	    function transformObjectLiteralMethodDeclarationToExpression(method, receiver, container, startsOnNewLine) {
	      const expression = factory2.createAssignment(
	        createMemberAccessForPropertyName(
	          factory2,
	          receiver,
	          Debug.checkDefined(visitNode(method.name, visitor, isPropertyName))
	        ),
	        transformFunctionLikeToExpression(
	          method,
	          /*location*/
	          method,
	          /*name*/
	          void 0,
	          container
	        )
	      );
	      setTextRange(expression, method);
	      if (startsOnNewLine) {
	        startOnNewLine(expression);
	      }
	      return expression;
	    }
	    function visitCatchClause(node) {
	      const ancestorFacts = enterSubtree(7104 /* BlockScopeExcludes */, 0 /* BlockScopeIncludes */);
	      let updated;
	      Debug.assert(!!node.variableDeclaration, "Catch clause variable should always be present when downleveling ES2015.");
	      if (isBindingPattern(node.variableDeclaration.name)) {
	        const temp = factory2.createTempVariable(
	          /*recordTempVariable*/
	          void 0
	        );
	        const newVariableDeclaration = factory2.createVariableDeclaration(temp);
	        setTextRange(newVariableDeclaration, node.variableDeclaration);
	        const vars = flattenDestructuringBinding(
	          node.variableDeclaration,
	          visitor,
	          context,
	          0 /* All */,
	          temp
	        );
	        const list = factory2.createVariableDeclarationList(vars);
	        setTextRange(list, node.variableDeclaration);
	        const destructure = factory2.createVariableStatement(
	          /*modifiers*/
	          void 0,
	          list
	        );
	        updated = factory2.updateCatchClause(node, newVariableDeclaration, addStatementToStartOfBlock(node.block, destructure));
	      } else {
	        updated = visitEachChild(node, visitor, context);
	      }
	      exitSubtree(ancestorFacts, 0 /* None */, 0 /* None */);
	      return updated;
	    }
	    function addStatementToStartOfBlock(block, statement) {
	      const transformedStatements = visitNodes2(block.statements, visitor, isStatement);
	      return factory2.updateBlock(block, [statement, ...transformedStatements]);
	    }
	    function visitMethodDeclaration(node) {
	      Debug.assert(!isComputedPropertyName(node.name));
	      const functionExpression = transformFunctionLikeToExpression(
	        node,
	        /*location*/
	        moveRangePos(node, -1),
	        /*name*/
	        void 0,
	        /*container*/
	        void 0
	      );
	      setEmitFlags(functionExpression, 1024 /* NoLeadingComments */ | getEmitFlags(functionExpression));
	      return setTextRange(
	        factory2.createPropertyAssignment(
	          node.name,
	          functionExpression
	        ),
	        /*location*/
	        node
	      );
	    }
	    function visitAccessorDeclaration(node) {
	      Debug.assert(!isComputedPropertyName(node.name));
	      const savedConvertedLoopState = convertedLoopState;
	      convertedLoopState = void 0;
	      const ancestorFacts = enterSubtree(32670 /* FunctionExcludes */, 65 /* FunctionIncludes */);
	      let updated;
	      const parameters = visitParameterList(node.parameters, visitor, context);
	      const body = transformFunctionBody2(node);
	      if (node.kind === 177 /* GetAccessor */) {
	        updated = factory2.updateGetAccessorDeclaration(node, node.modifiers, node.name, parameters, node.type, body);
	      } else {
	        updated = factory2.updateSetAccessorDeclaration(node, node.modifiers, node.name, parameters, body);
	      }
	      exitSubtree(ancestorFacts, 229376 /* FunctionSubtreeExcludes */, 0 /* None */);
	      convertedLoopState = savedConvertedLoopState;
	      return updated;
	    }
	    function visitShorthandPropertyAssignment(node) {
	      return setTextRange(
	        factory2.createPropertyAssignment(
	          node.name,
	          visitIdentifier(factory2.cloneNode(node.name))
	        ),
	        /*location*/
	        node
	      );
	    }
	    function visitComputedPropertyName(node) {
	      return visitEachChild(node, visitor, context);
	    }
	    function visitYieldExpression(node) {
	      return visitEachChild(node, visitor, context);
	    }
	    function visitArrayLiteralExpression(node) {
	      if (some(node.elements, isSpreadElement)) {
	        return transformAndSpreadElements(
	          node.elements,
	          /*isArgumentList*/
	          false,
	          !!node.multiLine,
	          /*hasTrailingComma*/
	          !!node.elements.hasTrailingComma
	        );
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitCallExpression(node) {
	      if (getInternalEmitFlags(node) & 1 /* TypeScriptClassWrapper */) {
	        return visitTypeScriptClassWrapper(node);
	      }
	      const expression = skipOuterExpressions(node.expression);
	      if (expression.kind === 108 /* SuperKeyword */ || isSuperProperty(expression) || some(node.arguments, isSpreadElement)) {
	        return visitCallExpressionWithPotentialCapturedThisAssignment(
	          node,
	          /*assignToCapturedThis*/
	          true
	        );
	      }
	      return factory2.updateCallExpression(
	        node,
	        Debug.checkDefined(visitNode(node.expression, callExpressionVisitor, isExpression)),
	        /*typeArguments*/
	        void 0,
	        visitNodes2(node.arguments, visitor, isExpression)
	      );
	    }
	    function visitTypeScriptClassWrapper(node) {
	      const body = cast(cast(skipOuterExpressions(node.expression), isArrowFunction).body, isBlock);
	      const isVariableStatementWithInitializer = (stmt) => isVariableStatement(stmt) && !!first(stmt.declarationList.declarations).initializer;
	      const savedConvertedLoopState = convertedLoopState;
	      convertedLoopState = void 0;
	      const bodyStatements = visitNodes2(body.statements, classWrapperStatementVisitor, isStatement);
	      convertedLoopState = savedConvertedLoopState;
	      const classStatements = filter(bodyStatements, isVariableStatementWithInitializer);
	      const remainingStatements = filter(bodyStatements, (stmt) => !isVariableStatementWithInitializer(stmt));
	      const varStatement = cast(first(classStatements), isVariableStatement);
	      const variable = varStatement.declarationList.declarations[0];
	      const initializer = skipOuterExpressions(variable.initializer);
	      let aliasAssignment = tryCast(initializer, isAssignmentExpression);
	      if (!aliasAssignment && isBinaryExpression(initializer) && initializer.operatorToken.kind === 28 /* CommaToken */) {
	        aliasAssignment = tryCast(initializer.left, isAssignmentExpression);
	      }
	      const call = cast(aliasAssignment ? skipOuterExpressions(aliasAssignment.right) : initializer, isCallExpression);
	      const func = cast(skipOuterExpressions(call.expression), isFunctionExpression);
	      const funcStatements = func.body.statements;
	      let classBodyStart = 0;
	      let classBodyEnd = -1;
	      const statements = [];
	      if (aliasAssignment) {
	        const extendsCall = tryCast(funcStatements[classBodyStart], isExpressionStatement);
	        if (extendsCall) {
	          statements.push(extendsCall);
	          classBodyStart++;
	        }
	        statements.push(funcStatements[classBodyStart]);
	        classBodyStart++;
	        statements.push(
	          factory2.createExpressionStatement(
	            factory2.createAssignment(
	              aliasAssignment.left,
	              cast(variable.name, isIdentifier)
	            )
	          )
	        );
	      }
	      while (!isReturnStatement(elementAt(funcStatements, classBodyEnd))) {
	        classBodyEnd--;
	      }
	      addRange(statements, funcStatements, classBodyStart, classBodyEnd);
	      if (classBodyEnd < -1) {
	        addRange(statements, funcStatements, classBodyEnd + 1);
	      }
	      const returnStatement = tryCast(elementAt(funcStatements, classBodyEnd), isReturnStatement);
	      for (const statement of remainingStatements) {
	        if (isReturnStatement(statement) && (returnStatement == null ? void 0 : returnStatement.expression) && !isIdentifier(returnStatement.expression)) {
	          statements.push(returnStatement);
	        } else {
	          statements.push(statement);
	        }
	      }
	      addRange(
	        statements,
	        classStatements,
	        /*start*/
	        1
	      );
	      return factory2.restoreOuterExpressions(
	        node.expression,
	        factory2.restoreOuterExpressions(
	          variable.initializer,
	          factory2.restoreOuterExpressions(
	            aliasAssignment && aliasAssignment.right,
	            factory2.updateCallExpression(
	              call,
	              factory2.restoreOuterExpressions(
	                call.expression,
	                factory2.updateFunctionExpression(
	                  func,
	                  /*modifiers*/
	                  void 0,
	                  /*asteriskToken*/
	                  void 0,
	                  /*name*/
	                  void 0,
	                  /*typeParameters*/
	                  void 0,
	                  func.parameters,
	                  /*type*/
	                  void 0,
	                  factory2.updateBlock(
	                    func.body,
	                    statements
	                  )
	                )
	              ),
	              /*typeArguments*/
	              void 0,
	              call.arguments
	            )
	          )
	        )
	      );
	    }
	    function visitCallExpressionWithPotentialCapturedThisAssignment(node, assignToCapturedThis) {
	      if (node.transformFlags & 32768 /* ContainsRestOrSpread */ || node.expression.kind === 108 /* SuperKeyword */ || isSuperProperty(skipOuterExpressions(node.expression))) {
	        const { target, thisArg } = factory2.createCallBinding(node.expression, hoistVariableDeclaration);
	        if (node.expression.kind === 108 /* SuperKeyword */) {
	          setEmitFlags(thisArg, 8 /* NoSubstitution */);
	        }
	        let resultingCall;
	        if (node.transformFlags & 32768 /* ContainsRestOrSpread */) {
	          resultingCall = factory2.createFunctionApplyCall(
	            Debug.checkDefined(visitNode(target, callExpressionVisitor, isExpression)),
	            node.expression.kind === 108 /* SuperKeyword */ ? thisArg : Debug.checkDefined(visitNode(thisArg, visitor, isExpression)),
	            transformAndSpreadElements(
	              node.arguments,
	              /*isArgumentList*/
	              true,
	              /*multiLine*/
	              false,
	              /*hasTrailingComma*/
	              false
	            )
	          );
	        } else {
	          resultingCall = setTextRange(
	            factory2.createFunctionCallCall(
	              Debug.checkDefined(visitNode(target, callExpressionVisitor, isExpression)),
	              node.expression.kind === 108 /* SuperKeyword */ ? thisArg : Debug.checkDefined(visitNode(thisArg, visitor, isExpression)),
	              visitNodes2(node.arguments, visitor, isExpression)
	            ),
	            node
	          );
	        }
	        if (node.expression.kind === 108 /* SuperKeyword */) {
	          const initializer = factory2.createLogicalOr(
	            resultingCall,
	            createActualThis()
	          );
	          resultingCall = assignToCapturedThis ? factory2.createAssignment(createCapturedThis(), initializer) : initializer;
	        }
	        return setOriginalNode(resultingCall, node);
	      }
	      if (isSuperCall(node)) {
	        hierarchyFacts |= 131072 /* CapturedLexicalThis */;
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitNewExpression(node) {
	      if (some(node.arguments, isSpreadElement)) {
	        const { target, thisArg } = factory2.createCallBinding(factory2.createPropertyAccessExpression(node.expression, "bind"), hoistVariableDeclaration);
	        return factory2.createNewExpression(
	          factory2.createFunctionApplyCall(
	            Debug.checkDefined(visitNode(target, visitor, isExpression)),
	            thisArg,
	            transformAndSpreadElements(
	              factory2.createNodeArray([factory2.createVoidZero(), ...node.arguments]),
	              /*isArgumentList*/
	              true,
	              /*multiLine*/
	              false,
	              /*hasTrailingComma*/
	              false
	            )
	          ),
	          /*typeArguments*/
	          void 0,
	          []
	        );
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function transformAndSpreadElements(elements, isArgumentList, multiLine, hasTrailingComma) {
	      const numElements = elements.length;
	      const segments = flatten(
	        // As we visit each element, we return one of two functions to use as the "key":
	        // - `visitSpanOfSpreads` for one or more contiguous `...` spread expressions, i.e. `...a, ...b` in `[1, 2, ...a, ...b]`
	        // - `visitSpanOfNonSpreads` for one or more contiguous non-spread elements, i.e. `1, 2`, in `[1, 2, ...a, ...b]`
	        spanMap(elements, partitionSpread, (partition, visitPartition, _start, end) => visitPartition(partition, multiLine, hasTrailingComma && end === numElements))
	      );
	      if (segments.length === 1) {
	        const firstSegment = segments[0];
	        if (isArgumentList && !compilerOptions.downlevelIteration || isPackedArrayLiteral(firstSegment.expression) || isCallToHelper(firstSegment.expression, "___spreadArray")) {
	          return firstSegment.expression;
	        }
	      }
	      const helpers = emitHelpers();
	      const startsWithSpread = segments[0].kind !== 0 /* None */;
	      let expression = startsWithSpread ? factory2.createArrayLiteralExpression() : segments[0].expression;
	      for (let i = startsWithSpread ? 0 : 1; i < segments.length; i++) {
	        const segment = segments[i];
	        expression = helpers.createSpreadArrayHelper(
	          expression,
	          segment.expression,
	          segment.kind === 1 /* UnpackedSpread */ && !isArgumentList
	        );
	      }
	      return expression;
	    }
	    function partitionSpread(node) {
	      return isSpreadElement(node) ? visitSpanOfSpreads : visitSpanOfNonSpreads;
	    }
	    function visitSpanOfSpreads(chunk) {
	      return map(chunk, visitExpressionOfSpread);
	    }
	    function visitExpressionOfSpread(node) {
	      Debug.assertNode(node, isSpreadElement);
	      let expression = visitNode(node.expression, visitor, isExpression);
	      Debug.assert(expression);
	      const isCallToReadHelper = isCallToHelper(expression, "___read");
	      let kind = isCallToReadHelper || isPackedArrayLiteral(expression) ? 2 /* PackedSpread */ : 1 /* UnpackedSpread */;
	      if (compilerOptions.downlevelIteration && kind === 1 /* UnpackedSpread */ && !isArrayLiteralExpression(expression) && !isCallToReadHelper) {
	        expression = emitHelpers().createReadHelper(
	          expression,
	          /*count*/
	          void 0
	        );
	        kind = 2 /* PackedSpread */;
	      }
	      return createSpreadSegment(kind, expression);
	    }
	    function visitSpanOfNonSpreads(chunk, multiLine, hasTrailingComma) {
	      const expression = factory2.createArrayLiteralExpression(
	        visitNodes2(factory2.createNodeArray(chunk, hasTrailingComma), visitor, isExpression),
	        multiLine
	      );
	      return createSpreadSegment(0 /* None */, expression);
	    }
	    function visitSpreadElement(node) {
	      return visitNode(node.expression, visitor, isExpression);
	    }
	    function visitTemplateLiteral(node) {
	      return setTextRange(factory2.createStringLiteral(node.text), node);
	    }
	    function visitStringLiteral(node) {
	      if (node.hasExtendedUnicodeEscape) {
	        return setTextRange(factory2.createStringLiteral(node.text), node);
	      }
	      return node;
	    }
	    function visitNumericLiteral(node) {
	      if (node.numericLiteralFlags & 384 /* BinaryOrOctalSpecifier */) {
	        return setTextRange(factory2.createNumericLiteral(node.text), node);
	      }
	      return node;
	    }
	    function visitTaggedTemplateExpression(node) {
	      return processTaggedTemplateExpression(
	        context,
	        node,
	        visitor,
	        currentSourceFile,
	        recordTaggedTemplateString,
	        1 /* All */
	      );
	    }
	    function visitTemplateExpression(node) {
	      let expression = factory2.createStringLiteral(node.head.text);
	      for (const span of node.templateSpans) {
	        const args = [Debug.checkDefined(visitNode(span.expression, visitor, isExpression))];
	        if (span.literal.text.length > 0) {
	          args.push(factory2.createStringLiteral(span.literal.text));
	        }
	        expression = factory2.createCallExpression(
	          factory2.createPropertyAccessExpression(expression, "concat"),
	          /*typeArguments*/
	          void 0,
	          args
	        );
	      }
	      return setTextRange(expression, node);
	    }
	    function createSyntheticSuper() {
	      return factory2.createUniqueName("_super", 16 /* Optimistic */ | 32 /* FileLevel */);
	    }
	    function visitSuperKeyword(node, isExpressionOfCall) {
	      const expression = hierarchyFacts & 8 /* NonStaticClassElement */ && !isExpressionOfCall ? factory2.createPropertyAccessExpression(setOriginalNode(createSyntheticSuper(), node), "prototype") : createSyntheticSuper();
	      setOriginalNode(expression, node);
	      setCommentRange(expression, node);
	      setSourceMapRange(expression, node);
	      return expression;
	    }
	    function visitMetaProperty(node) {
	      if (node.keywordToken === 105 /* NewKeyword */ && node.name.escapedText === "target") {
	        hierarchyFacts |= 32768 /* NewTarget */;
	        return factory2.createUniqueName("_newTarget", 16 /* Optimistic */ | 32 /* FileLevel */);
	      }
	      return node;
	    }
	    function onEmitNode(hint, node, emitCallback) {
	      if (enabledSubstitutions & 1 /* CapturedThis */ && isFunctionLike(node)) {
	        const ancestorFacts = enterSubtree(
	          32670 /* FunctionExcludes */,
	          getEmitFlags(node) & 16 /* CapturesThis */ ? 65 /* FunctionIncludes */ | 16 /* CapturesThis */ : 65 /* FunctionIncludes */
	        );
	        previousOnEmitNode(hint, node, emitCallback);
	        exitSubtree(ancestorFacts, 0 /* None */, 0 /* None */);
	        return;
	      }
	      previousOnEmitNode(hint, node, emitCallback);
	    }
	    function enableSubstitutionsForBlockScopedBindings() {
	      if ((enabledSubstitutions & 2 /* BlockScopedBindings */) === 0) {
	        enabledSubstitutions |= 2 /* BlockScopedBindings */;
	        context.enableSubstitution(80 /* Identifier */);
	      }
	    }
	    function enableSubstitutionsForCapturedThis() {
	      if ((enabledSubstitutions & 1 /* CapturedThis */) === 0) {
	        enabledSubstitutions |= 1 /* CapturedThis */;
	        context.enableSubstitution(110 /* ThisKeyword */);
	        context.enableEmitNotification(176 /* Constructor */);
	        context.enableEmitNotification(174 /* MethodDeclaration */);
	        context.enableEmitNotification(177 /* GetAccessor */);
	        context.enableEmitNotification(178 /* SetAccessor */);
	        context.enableEmitNotification(219 /* ArrowFunction */);
	        context.enableEmitNotification(218 /* FunctionExpression */);
	        context.enableEmitNotification(262 /* FunctionDeclaration */);
	      }
	    }
	    function onSubstituteNode(hint, node) {
	      node = previousOnSubstituteNode(hint, node);
	      if (hint === 1 /* Expression */) {
	        return substituteExpression(node);
	      }
	      if (isIdentifier(node)) {
	        return substituteIdentifier(node);
	      }
	      return node;
	    }
	    function substituteIdentifier(node) {
	      if (enabledSubstitutions & 2 /* BlockScopedBindings */ && !isInternalName(node)) {
	        const original = getParseTreeNode(node, isIdentifier);
	        if (original && isNameOfDeclarationWithCollidingName(original)) {
	          return setTextRange(factory2.getGeneratedNameForNode(original), node);
	        }
	      }
	      return node;
	    }
	    function isNameOfDeclarationWithCollidingName(node) {
	      switch (node.parent.kind) {
	        case 208 /* BindingElement */:
	        case 263 /* ClassDeclaration */:
	        case 266 /* EnumDeclaration */:
	        case 260 /* VariableDeclaration */:
	          return node.parent.name === node && resolver.isDeclarationWithCollidingName(node.parent);
	      }
	      return false;
	    }
	    function substituteExpression(node) {
	      switch (node.kind) {
	        case 80 /* Identifier */:
	          return substituteExpressionIdentifier(node);
	        case 110 /* ThisKeyword */:
	          return substituteThisKeyword(node);
	      }
	      return node;
	    }
	    function substituteExpressionIdentifier(node) {
	      if (enabledSubstitutions & 2 /* BlockScopedBindings */ && !isInternalName(node)) {
	        const declaration = resolver.getReferencedDeclarationWithCollidingName(node);
	        if (declaration && !(isClassLike(declaration) && isPartOfClassBody(declaration, node))) {
	          return setTextRange(factory2.getGeneratedNameForNode(getNameOfDeclaration(declaration)), node);
	        }
	      }
	      return node;
	    }
	    function isPartOfClassBody(declaration, node) {
	      let currentNode = getParseTreeNode(node);
	      if (!currentNode || currentNode === declaration || currentNode.end <= declaration.pos || currentNode.pos >= declaration.end) {
	        return false;
	      }
	      const blockScope = getEnclosingBlockScopeContainer(declaration);
	      while (currentNode) {
	        if (currentNode === blockScope || currentNode === declaration) {
	          return false;
	        }
	        if (isClassElement(currentNode) && currentNode.parent === declaration) {
	          return true;
	        }
	        currentNode = currentNode.parent;
	      }
	      return false;
	    }
	    function substituteThisKeyword(node) {
	      if (enabledSubstitutions & 1 /* CapturedThis */ && hierarchyFacts & 16 /* CapturesThis */) {
	        return setTextRange(createCapturedThis(), node);
	      }
	      return node;
	    }
	    function getClassMemberPrefix(node, member) {
	      return isStatic(member) ? factory2.getInternalName(node) : factory2.createPropertyAccessExpression(factory2.getInternalName(node), "prototype");
	    }
	    function hasSynthesizedDefaultSuperCall(constructor, hasExtendsClause) {
	      if (!constructor || !hasExtendsClause) {
	        return false;
	      }
	      if (some(constructor.parameters)) {
	        return false;
	      }
	      const statement = firstOrUndefined(constructor.body.statements);
	      if (!statement || !nodeIsSynthesized(statement) || statement.kind !== 244 /* ExpressionStatement */) {
	        return false;
	      }
	      const statementExpression = statement.expression;
	      if (!nodeIsSynthesized(statementExpression) || statementExpression.kind !== 213 /* CallExpression */) {
	        return false;
	      }
	      const callTarget = statementExpression.expression;
	      if (!nodeIsSynthesized(callTarget) || callTarget.kind !== 108 /* SuperKeyword */) {
	        return false;
	      }
	      const callArgument = singleOrUndefined(statementExpression.arguments);
	      if (!callArgument || !nodeIsSynthesized(callArgument) || callArgument.kind !== 230 /* SpreadElement */) {
	        return false;
	      }
	      const expression = callArgument.expression;
	      return isIdentifier(expression) && expression.escapedText === "arguments";
	    }
	  }
	  var init_es2015 = __esm({
	    "src/compiler/transformers/es2015.ts"() {
	      init_ts2();
	    }
	  });

	  // src/compiler/transformers/es5.ts
	  function transformES5(context) {
	    const { factory: factory2 } = context;
	    const compilerOptions = context.getCompilerOptions();
	    let previousOnEmitNode;
	    let noSubstitution;
	    if (compilerOptions.jsx === 1 /* Preserve */ || compilerOptions.jsx === 3 /* ReactNative */) {
	      previousOnEmitNode = context.onEmitNode;
	      context.onEmitNode = onEmitNode;
	      context.enableEmitNotification(286 /* JsxOpeningElement */);
	      context.enableEmitNotification(287 /* JsxClosingElement */);
	      context.enableEmitNotification(285 /* JsxSelfClosingElement */);
	      noSubstitution = [];
	    }
	    const previousOnSubstituteNode = context.onSubstituteNode;
	    context.onSubstituteNode = onSubstituteNode;
	    context.enableSubstitution(211 /* PropertyAccessExpression */);
	    context.enableSubstitution(303 /* PropertyAssignment */);
	    return chainBundle(context, transformSourceFile);
	    function transformSourceFile(node) {
	      return node;
	    }
	    function onEmitNode(hint, node, emitCallback) {
	      switch (node.kind) {
	        case 286 /* JsxOpeningElement */:
	        case 287 /* JsxClosingElement */:
	        case 285 /* JsxSelfClosingElement */:
	          const tagName = node.tagName;
	          noSubstitution[getOriginalNodeId(tagName)] = true;
	          break;
	      }
	      previousOnEmitNode(hint, node, emitCallback);
	    }
	    function onSubstituteNode(hint, node) {
	      if (node.id && noSubstitution && noSubstitution[node.id]) {
	        return previousOnSubstituteNode(hint, node);
	      }
	      node = previousOnSubstituteNode(hint, node);
	      if (isPropertyAccessExpression(node)) {
	        return substitutePropertyAccessExpression(node);
	      } else if (isPropertyAssignment(node)) {
	        return substitutePropertyAssignment(node);
	      }
	      return node;
	    }
	    function substitutePropertyAccessExpression(node) {
	      if (isPrivateIdentifier(node.name)) {
	        return node;
	      }
	      const literalName = trySubstituteReservedName(node.name);
	      if (literalName) {
	        return setTextRange(factory2.createElementAccessExpression(node.expression, literalName), node);
	      }
	      return node;
	    }
	    function substitutePropertyAssignment(node) {
	      const literalName = isIdentifier(node.name) && trySubstituteReservedName(node.name);
	      if (literalName) {
	        return factory2.updatePropertyAssignment(node, literalName, node.initializer);
	      }
	      return node;
	    }
	    function trySubstituteReservedName(name) {
	      const token = identifierToKeywordKind(name);
	      if (token !== void 0 && token >= 83 /* FirstReservedWord */ && token <= 118 /* LastReservedWord */) {
	        return setTextRange(factory2.createStringLiteralFromNode(name), name);
	      }
	      return void 0;
	    }
	  }
	  var init_es5 = __esm({
	    "src/compiler/transformers/es5.ts"() {
	      init_ts2();
	    }
	  });

	  // src/compiler/transformers/generators.ts
	  function getInstructionName(instruction) {
	    switch (instruction) {
	      case 2 /* Return */:
	        return "return";
	      case 3 /* Break */:
	        return "break";
	      case 4 /* Yield */:
	        return "yield";
	      case 5 /* YieldStar */:
	        return "yield*";
	      case 7 /* Endfinally */:
	        return "endfinally";
	      default:
	        return void 0;
	    }
	  }
	  function transformGenerators(context) {
	    const {
	      factory: factory2,
	      getEmitHelperFactory: emitHelpers,
	      resumeLexicalEnvironment,
	      endLexicalEnvironment,
	      hoistFunctionDeclaration,
	      hoistVariableDeclaration
	    } = context;
	    const compilerOptions = context.getCompilerOptions();
	    const languageVersion = getEmitScriptTarget(compilerOptions);
	    const resolver = context.getEmitResolver();
	    const previousOnSubstituteNode = context.onSubstituteNode;
	    context.onSubstituteNode = onSubstituteNode;
	    let renamedCatchVariables;
	    let renamedCatchVariableDeclarations;
	    let inGeneratorFunctionBody;
	    let inStatementContainingYield;
	    let blocks;
	    let blockOffsets;
	    let blockActions;
	    let blockStack;
	    let labelOffsets;
	    let labelExpressions;
	    let nextLabelId = 1;
	    let operations;
	    let operationArguments;
	    let operationLocations;
	    let state;
	    let blockIndex = 0;
	    let labelNumber = 0;
	    let labelNumbers;
	    let lastOperationWasAbrupt;
	    let lastOperationWasCompletion;
	    let clauses;
	    let statements;
	    let exceptionBlockStack;
	    let currentExceptionBlock;
	    let withBlockStack;
	    return chainBundle(context, transformSourceFile);
	    function transformSourceFile(node) {
	      if (node.isDeclarationFile || (node.transformFlags & 2048 /* ContainsGenerator */) === 0) {
	        return node;
	      }
	      const visited = visitEachChild(node, visitor, context);
	      addEmitHelpers(visited, context.readEmitHelpers());
	      return visited;
	    }
	    function visitor(node) {
	      const transformFlags = node.transformFlags;
	      if (inStatementContainingYield) {
	        return visitJavaScriptInStatementContainingYield(node);
	      } else if (inGeneratorFunctionBody) {
	        return visitJavaScriptInGeneratorFunctionBody(node);
	      } else if (isFunctionLikeDeclaration(node) && node.asteriskToken) {
	        return visitGenerator(node);
	      } else if (transformFlags & 2048 /* ContainsGenerator */) {
	        return visitEachChild(node, visitor, context);
	      } else {
	        return node;
	      }
	    }
	    function visitJavaScriptInStatementContainingYield(node) {
	      switch (node.kind) {
	        case 246 /* DoStatement */:
	          return visitDoStatement(node);
	        case 247 /* WhileStatement */:
	          return visitWhileStatement(node);
	        case 255 /* SwitchStatement */:
	          return visitSwitchStatement(node);
	        case 256 /* LabeledStatement */:
	          return visitLabeledStatement(node);
	        default:
	          return visitJavaScriptInGeneratorFunctionBody(node);
	      }
	    }
	    function visitJavaScriptInGeneratorFunctionBody(node) {
	      switch (node.kind) {
	        case 262 /* FunctionDeclaration */:
	          return visitFunctionDeclaration(node);
	        case 218 /* FunctionExpression */:
	          return visitFunctionExpression(node);
	        case 177 /* GetAccessor */:
	        case 178 /* SetAccessor */:
	          return visitAccessorDeclaration(node);
	        case 243 /* VariableStatement */:
	          return visitVariableStatement(node);
	        case 248 /* ForStatement */:
	          return visitForStatement(node);
	        case 249 /* ForInStatement */:
	          return visitForInStatement(node);
	        case 252 /* BreakStatement */:
	          return visitBreakStatement(node);
	        case 251 /* ContinueStatement */:
	          return visitContinueStatement(node);
	        case 253 /* ReturnStatement */:
	          return visitReturnStatement(node);
	        default:
	          if (node.transformFlags & 1048576 /* ContainsYield */) {
	            return visitJavaScriptContainingYield(node);
	          } else if (node.transformFlags & (2048 /* ContainsGenerator */ | 4194304 /* ContainsHoistedDeclarationOrCompletion */)) {
	            return visitEachChild(node, visitor, context);
	          } else {
	            return node;
	          }
	      }
	    }
	    function visitJavaScriptContainingYield(node) {
	      switch (node.kind) {
	        case 226 /* BinaryExpression */:
	          return visitBinaryExpression(node);
	        case 361 /* CommaListExpression */:
	          return visitCommaListExpression(node);
	        case 227 /* ConditionalExpression */:
	          return visitConditionalExpression(node);
	        case 229 /* YieldExpression */:
	          return visitYieldExpression(node);
	        case 209 /* ArrayLiteralExpression */:
	          return visitArrayLiteralExpression(node);
	        case 210 /* ObjectLiteralExpression */:
	          return visitObjectLiteralExpression(node);
	        case 212 /* ElementAccessExpression */:
	          return visitElementAccessExpression(node);
	        case 213 /* CallExpression */:
	          return visitCallExpression(node);
	        case 214 /* NewExpression */:
	          return visitNewExpression(node);
	        default:
	          return visitEachChild(node, visitor, context);
	      }
	    }
	    function visitGenerator(node) {
	      switch (node.kind) {
	        case 262 /* FunctionDeclaration */:
	          return visitFunctionDeclaration(node);
	        case 218 /* FunctionExpression */:
	          return visitFunctionExpression(node);
	        default:
	          return Debug.failBadSyntaxKind(node);
	      }
	    }
	    function visitFunctionDeclaration(node) {
	      if (node.asteriskToken) {
	        node = setOriginalNode(
	          setTextRange(
	            factory2.createFunctionDeclaration(
	              node.modifiers,
	              /*asteriskToken*/
	              void 0,
	              node.name,
	              /*typeParameters*/
	              void 0,
	              visitParameterList(node.parameters, visitor, context),
	              /*type*/
	              void 0,
	              transformGeneratorFunctionBody(node.body)
	            ),
	            /*location*/
	            node
	          ),
	          node
	        );
	      } else {
	        const savedInGeneratorFunctionBody = inGeneratorFunctionBody;
	        const savedInStatementContainingYield = inStatementContainingYield;
	        inGeneratorFunctionBody = false;
	        inStatementContainingYield = false;
	        node = visitEachChild(node, visitor, context);
	        inGeneratorFunctionBody = savedInGeneratorFunctionBody;
	        inStatementContainingYield = savedInStatementContainingYield;
	      }
	      if (inGeneratorFunctionBody) {
	        hoistFunctionDeclaration(node);
	        return void 0;
	      } else {
	        return node;
	      }
	    }
	    function visitFunctionExpression(node) {
	      if (node.asteriskToken) {
	        node = setOriginalNode(
	          setTextRange(
	            factory2.createFunctionExpression(
	              /*modifiers*/
	              void 0,
	              /*asteriskToken*/
	              void 0,
	              node.name,
	              /*typeParameters*/
	              void 0,
	              visitParameterList(node.parameters, visitor, context),
	              /*type*/
	              void 0,
	              transformGeneratorFunctionBody(node.body)
	            ),
	            /*location*/
	            node
	          ),
	          node
	        );
	      } else {
	        const savedInGeneratorFunctionBody = inGeneratorFunctionBody;
	        const savedInStatementContainingYield = inStatementContainingYield;
	        inGeneratorFunctionBody = false;
	        inStatementContainingYield = false;
	        node = visitEachChild(node, visitor, context);
	        inGeneratorFunctionBody = savedInGeneratorFunctionBody;
	        inStatementContainingYield = savedInStatementContainingYield;
	      }
	      return node;
	    }
	    function visitAccessorDeclaration(node) {
	      const savedInGeneratorFunctionBody = inGeneratorFunctionBody;
	      const savedInStatementContainingYield = inStatementContainingYield;
	      inGeneratorFunctionBody = false;
	      inStatementContainingYield = false;
	      node = visitEachChild(node, visitor, context);
	      inGeneratorFunctionBody = savedInGeneratorFunctionBody;
	      inStatementContainingYield = savedInStatementContainingYield;
	      return node;
	    }
	    function transformGeneratorFunctionBody(body) {
	      const statements2 = [];
	      const savedInGeneratorFunctionBody = inGeneratorFunctionBody;
	      const savedInStatementContainingYield = inStatementContainingYield;
	      const savedBlocks = blocks;
	      const savedBlockOffsets = blockOffsets;
	      const savedBlockActions = blockActions;
	      const savedBlockStack = blockStack;
	      const savedLabelOffsets = labelOffsets;
	      const savedLabelExpressions = labelExpressions;
	      const savedNextLabelId = nextLabelId;
	      const savedOperations = operations;
	      const savedOperationArguments = operationArguments;
	      const savedOperationLocations = operationLocations;
	      const savedState = state;
	      inGeneratorFunctionBody = true;
	      inStatementContainingYield = false;
	      blocks = void 0;
	      blockOffsets = void 0;
	      blockActions = void 0;
	      blockStack = void 0;
	      labelOffsets = void 0;
	      labelExpressions = void 0;
	      nextLabelId = 1;
	      operations = void 0;
	      operationArguments = void 0;
	      operationLocations = void 0;
	      state = factory2.createTempVariable(
	        /*recordTempVariable*/
	        void 0
	      );
	      resumeLexicalEnvironment();
	      const statementOffset = factory2.copyPrologue(
	        body.statements,
	        statements2,
	        /*ensureUseStrict*/
	        false,
	        visitor
	      );
	      transformAndEmitStatements(body.statements, statementOffset);
	      const buildResult = build2();
	      insertStatementsAfterStandardPrologue(statements2, endLexicalEnvironment());
	      statements2.push(factory2.createReturnStatement(buildResult));
	      inGeneratorFunctionBody = savedInGeneratorFunctionBody;
	      inStatementContainingYield = savedInStatementContainingYield;
	      blocks = savedBlocks;
	      blockOffsets = savedBlockOffsets;
	      blockActions = savedBlockActions;
	      blockStack = savedBlockStack;
	      labelOffsets = savedLabelOffsets;
	      labelExpressions = savedLabelExpressions;
	      nextLabelId = savedNextLabelId;
	      operations = savedOperations;
	      operationArguments = savedOperationArguments;
	      operationLocations = savedOperationLocations;
	      state = savedState;
	      return setTextRange(factory2.createBlock(statements2, body.multiLine), body);
	    }
	    function visitVariableStatement(node) {
	      if (node.transformFlags & 1048576 /* ContainsYield */) {
	        transformAndEmitVariableDeclarationList(node.declarationList);
	        return void 0;
	      } else {
	        if (getEmitFlags(node) & 2097152 /* CustomPrologue */) {
	          return node;
	        }
	        for (const variable of node.declarationList.declarations) {
	          hoistVariableDeclaration(variable.name);
	        }
	        const variables = getInitializedVariables(node.declarationList);
	        if (variables.length === 0) {
	          return void 0;
	        }
	        return setSourceMapRange(
	          factory2.createExpressionStatement(
	            factory2.inlineExpressions(
	              map(variables, transformInitializedVariable)
	            )
	          ),
	          node
	        );
	      }
	    }
	    function visitBinaryExpression(node) {
	      const assoc = getExpressionAssociativity(node);
	      switch (assoc) {
	        case 0 /* Left */:
	          return visitLeftAssociativeBinaryExpression(node);
	        case 1 /* Right */:
	          return visitRightAssociativeBinaryExpression(node);
	        default:
	          return Debug.assertNever(assoc);
	      }
	    }
	    function visitRightAssociativeBinaryExpression(node) {
	      const { left, right } = node;
	      if (containsYield(right)) {
	        let target;
	        switch (left.kind) {
	          case 211 /* PropertyAccessExpression */:
	            target = factory2.updatePropertyAccessExpression(
	              left,
	              cacheExpression(Debug.checkDefined(visitNode(left.expression, visitor, isLeftHandSideExpression))),
	              left.name
	            );
	            break;
	          case 212 /* ElementAccessExpression */:
	            target = factory2.updateElementAccessExpression(left, cacheExpression(Debug.checkDefined(visitNode(left.expression, visitor, isLeftHandSideExpression))), cacheExpression(Debug.checkDefined(visitNode(left.argumentExpression, visitor, isExpression))));
	            break;
	          default:
	            target = Debug.checkDefined(visitNode(left, visitor, isExpression));
	            break;
	        }
	        const operator = node.operatorToken.kind;
	        if (isCompoundAssignment(operator)) {
	          return setTextRange(
	            factory2.createAssignment(
	              target,
	              setTextRange(
	                factory2.createBinaryExpression(
	                  cacheExpression(target),
	                  getNonAssignmentOperatorForCompoundAssignment(operator),
	                  Debug.checkDefined(visitNode(right, visitor, isExpression))
	                ),
	                node
	              )
	            ),
	            node
	          );
	        } else {
	          return factory2.updateBinaryExpression(node, target, node.operatorToken, Debug.checkDefined(visitNode(right, visitor, isExpression)));
	        }
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitLeftAssociativeBinaryExpression(node) {
	      if (containsYield(node.right)) {
	        if (isLogicalOperator(node.operatorToken.kind)) {
	          return visitLogicalBinaryExpression(node);
	        } else if (node.operatorToken.kind === 28 /* CommaToken */) {
	          return visitCommaExpression(node);
	        }
	        return factory2.updateBinaryExpression(node, cacheExpression(Debug.checkDefined(visitNode(node.left, visitor, isExpression))), node.operatorToken, Debug.checkDefined(visitNode(node.right, visitor, isExpression)));
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitCommaExpression(node) {
	      let pendingExpressions = [];
	      visit(node.left);
	      visit(node.right);
	      return factory2.inlineExpressions(pendingExpressions);
	      function visit(node2) {
	        if (isBinaryExpression(node2) && node2.operatorToken.kind === 28 /* CommaToken */) {
	          visit(node2.left);
	          visit(node2.right);
	        } else {
	          if (containsYield(node2) && pendingExpressions.length > 0) {
	            emitWorker(1 /* Statement */, [factory2.createExpressionStatement(factory2.inlineExpressions(pendingExpressions))]);
	            pendingExpressions = [];
	          }
	          pendingExpressions.push(Debug.checkDefined(visitNode(node2, visitor, isExpression)));
	        }
	      }
	    }
	    function visitCommaListExpression(node) {
	      let pendingExpressions = [];
	      for (const elem of node.elements) {
	        if (isBinaryExpression(elem) && elem.operatorToken.kind === 28 /* CommaToken */) {
	          pendingExpressions.push(visitCommaExpression(elem));
	        } else {
	          if (containsYield(elem) && pendingExpressions.length > 0) {
	            emitWorker(1 /* Statement */, [factory2.createExpressionStatement(factory2.inlineExpressions(pendingExpressions))]);
	            pendingExpressions = [];
	          }
	          pendingExpressions.push(Debug.checkDefined(visitNode(elem, visitor, isExpression)));
	        }
	      }
	      return factory2.inlineExpressions(pendingExpressions);
	    }
	    function visitLogicalBinaryExpression(node) {
	      const resultLabel = defineLabel();
	      const resultLocal = declareLocal();
	      emitAssignment(
	        resultLocal,
	        Debug.checkDefined(visitNode(node.left, visitor, isExpression)),
	        /*location*/
	        node.left
	      );
	      if (node.operatorToken.kind === 56 /* AmpersandAmpersandToken */) {
	        emitBreakWhenFalse(
	          resultLabel,
	          resultLocal,
	          /*location*/
	          node.left
	        );
	      } else {
	        emitBreakWhenTrue(
	          resultLabel,
	          resultLocal,
	          /*location*/
	          node.left
	        );
	      }
	      emitAssignment(
	        resultLocal,
	        Debug.checkDefined(visitNode(node.right, visitor, isExpression)),
	        /*location*/
	        node.right
	      );
	      markLabel(resultLabel);
	      return resultLocal;
	    }
	    function visitConditionalExpression(node) {
	      if (containsYield(node.whenTrue) || containsYield(node.whenFalse)) {
	        const whenFalseLabel = defineLabel();
	        const resultLabel = defineLabel();
	        const resultLocal = declareLocal();
	        emitBreakWhenFalse(
	          whenFalseLabel,
	          Debug.checkDefined(visitNode(node.condition, visitor, isExpression)),
	          /*location*/
	          node.condition
	        );
	        emitAssignment(
	          resultLocal,
	          Debug.checkDefined(visitNode(node.whenTrue, visitor, isExpression)),
	          /*location*/
	          node.whenTrue
	        );
	        emitBreak(resultLabel);
	        markLabel(whenFalseLabel);
	        emitAssignment(
	          resultLocal,
	          Debug.checkDefined(visitNode(node.whenFalse, visitor, isExpression)),
	          /*location*/
	          node.whenFalse
	        );
	        markLabel(resultLabel);
	        return resultLocal;
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitYieldExpression(node) {
	      const resumeLabel = defineLabel();
	      const expression = visitNode(node.expression, visitor, isExpression);
	      if (node.asteriskToken) {
	        const iterator = (getEmitFlags(node.expression) & 8388608 /* Iterator */) === 0 ? setTextRange(emitHelpers().createValuesHelper(expression), node) : expression;
	        emitYieldStar(
	          iterator,
	          /*location*/
	          node
	        );
	      } else {
	        emitYield(
	          expression,
	          /*location*/
	          node
	        );
	      }
	      markLabel(resumeLabel);
	      return createGeneratorResume(
	        /*location*/
	        node
	      );
	    }
	    function visitArrayLiteralExpression(node) {
	      return visitElements(
	        node.elements,
	        /*leadingElement*/
	        void 0,
	        /*location*/
	        void 0,
	        node.multiLine
	      );
	    }
	    function visitElements(elements, leadingElement, location, multiLine) {
	      const numInitialElements = countInitialNodesWithoutYield(elements);
	      let temp;
	      if (numInitialElements > 0) {
	        temp = declareLocal();
	        const initialElements = visitNodes2(elements, visitor, isExpression, 0, numInitialElements);
	        emitAssignment(
	          temp,
	          factory2.createArrayLiteralExpression(
	            leadingElement ? [leadingElement, ...initialElements] : initialElements
	          )
	        );
	        leadingElement = void 0;
	      }
	      const expressions = reduceLeft(elements, reduceElement, [], numInitialElements);
	      return temp ? factory2.createArrayConcatCall(temp, [factory2.createArrayLiteralExpression(expressions, multiLine)]) : setTextRange(
	        factory2.createArrayLiteralExpression(leadingElement ? [leadingElement, ...expressions] : expressions, multiLine),
	        location
	      );
	      function reduceElement(expressions2, element) {
	        if (containsYield(element) && expressions2.length > 0) {
	          const hasAssignedTemp = temp !== void 0;
	          if (!temp) {
	            temp = declareLocal();
	          }
	          emitAssignment(
	            temp,
	            hasAssignedTemp ? factory2.createArrayConcatCall(
	              temp,
	              [factory2.createArrayLiteralExpression(expressions2, multiLine)]
	            ) : factory2.createArrayLiteralExpression(
	              leadingElement ? [leadingElement, ...expressions2] : expressions2,
	              multiLine
	            )
	          );
	          leadingElement = void 0;
	          expressions2 = [];
	        }
	        expressions2.push(Debug.checkDefined(visitNode(element, visitor, isExpression)));
	        return expressions2;
	      }
	    }
	    function visitObjectLiteralExpression(node) {
	      const properties = node.properties;
	      const multiLine = node.multiLine;
	      const numInitialProperties = countInitialNodesWithoutYield(properties);
	      const temp = declareLocal();
	      emitAssignment(
	        temp,
	        factory2.createObjectLiteralExpression(
	          visitNodes2(properties, visitor, isObjectLiteralElementLike, 0, numInitialProperties),
	          multiLine
	        )
	      );
	      const expressions = reduceLeft(properties, reduceProperty, [], numInitialProperties);
	      expressions.push(multiLine ? startOnNewLine(setParent(setTextRange(factory2.cloneNode(temp), temp), temp.parent)) : temp);
	      return factory2.inlineExpressions(expressions);
	      function reduceProperty(expressions2, property) {
	        if (containsYield(property) && expressions2.length > 0) {
	          emitStatement(factory2.createExpressionStatement(factory2.inlineExpressions(expressions2)));
	          expressions2 = [];
	        }
	        const expression = createExpressionForObjectLiteralElementLike(factory2, node, property, temp);
	        const visited = visitNode(expression, visitor, isExpression);
	        if (visited) {
	          if (multiLine) {
	            startOnNewLine(visited);
	          }
	          expressions2.push(visited);
	        }
	        return expressions2;
	      }
	    }
	    function visitElementAccessExpression(node) {
	      if (containsYield(node.argumentExpression)) {
	        return factory2.updateElementAccessExpression(node, cacheExpression(Debug.checkDefined(visitNode(node.expression, visitor, isLeftHandSideExpression))), Debug.checkDefined(visitNode(node.argumentExpression, visitor, isExpression)));
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitCallExpression(node) {
	      if (!isImportCall(node) && forEach(node.arguments, containsYield)) {
	        const { target, thisArg } = factory2.createCallBinding(
	          node.expression,
	          hoistVariableDeclaration,
	          languageVersion,
	          /*cacheIdentifiers*/
	          true
	        );
	        return setOriginalNode(
	          setTextRange(
	            factory2.createFunctionApplyCall(
	              cacheExpression(Debug.checkDefined(visitNode(target, visitor, isLeftHandSideExpression))),
	              thisArg,
	              visitElements(node.arguments)
	            ),
	            node
	          ),
	          node
	        );
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitNewExpression(node) {
	      if (forEach(node.arguments, containsYield)) {
	        const { target, thisArg } = factory2.createCallBinding(factory2.createPropertyAccessExpression(node.expression, "bind"), hoistVariableDeclaration);
	        return setOriginalNode(
	          setTextRange(
	            factory2.createNewExpression(
	              factory2.createFunctionApplyCall(
	                cacheExpression(Debug.checkDefined(visitNode(target, visitor, isExpression))),
	                thisArg,
	                visitElements(
	                  node.arguments,
	                  /*leadingElement*/
	                  factory2.createVoidZero()
	                )
	              ),
	              /*typeArguments*/
	              void 0,
	              []
	            ),
	            node
	          ),
	          node
	        );
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function transformAndEmitStatements(statements2, start = 0) {
	      const numStatements = statements2.length;
	      for (let i = start; i < numStatements; i++) {
	        transformAndEmitStatement(statements2[i]);
	      }
	    }
	    function transformAndEmitEmbeddedStatement(node) {
	      if (isBlock(node)) {
	        transformAndEmitStatements(node.statements);
	      } else {
	        transformAndEmitStatement(node);
	      }
	    }
	    function transformAndEmitStatement(node) {
	      const savedInStatementContainingYield = inStatementContainingYield;
	      if (!inStatementContainingYield) {
	        inStatementContainingYield = containsYield(node);
	      }
	      transformAndEmitStatementWorker(node);
	      inStatementContainingYield = savedInStatementContainingYield;
	    }
	    function transformAndEmitStatementWorker(node) {
	      switch (node.kind) {
	        case 241 /* Block */:
	          return transformAndEmitBlock(node);
	        case 244 /* ExpressionStatement */:
	          return transformAndEmitExpressionStatement(node);
	        case 245 /* IfStatement */:
	          return transformAndEmitIfStatement(node);
	        case 246 /* DoStatement */:
	          return transformAndEmitDoStatement(node);
	        case 247 /* WhileStatement */:
	          return transformAndEmitWhileStatement(node);
	        case 248 /* ForStatement */:
	          return transformAndEmitForStatement(node);
	        case 249 /* ForInStatement */:
	          return transformAndEmitForInStatement(node);
	        case 251 /* ContinueStatement */:
	          return transformAndEmitContinueStatement(node);
	        case 252 /* BreakStatement */:
	          return transformAndEmitBreakStatement(node);
	        case 253 /* ReturnStatement */:
	          return transformAndEmitReturnStatement(node);
	        case 254 /* WithStatement */:
	          return transformAndEmitWithStatement(node);
	        case 255 /* SwitchStatement */:
	          return transformAndEmitSwitchStatement(node);
	        case 256 /* LabeledStatement */:
	          return transformAndEmitLabeledStatement(node);
	        case 257 /* ThrowStatement */:
	          return transformAndEmitThrowStatement(node);
	        case 258 /* TryStatement */:
	          return transformAndEmitTryStatement(node);
	        default:
	          return emitStatement(visitNode(node, visitor, isStatement));
	      }
	    }
	    function transformAndEmitBlock(node) {
	      if (containsYield(node)) {
	        transformAndEmitStatements(node.statements);
	      } else {
	        emitStatement(visitNode(node, visitor, isStatement));
	      }
	    }
	    function transformAndEmitExpressionStatement(node) {
	      emitStatement(visitNode(node, visitor, isStatement));
	    }
	    function transformAndEmitVariableDeclarationList(node) {
	      for (const variable of node.declarations) {
	        const name = factory2.cloneNode(variable.name);
	        setCommentRange(name, variable.name);
	        hoistVariableDeclaration(name);
	      }
	      const variables = getInitializedVariables(node);
	      const numVariables = variables.length;
	      let variablesWritten = 0;
	      let pendingExpressions = [];
	      while (variablesWritten < numVariables) {
	        for (let i = variablesWritten; i < numVariables; i++) {
	          const variable = variables[i];
	          if (containsYield(variable.initializer) && pendingExpressions.length > 0) {
	            break;
	          }
	          pendingExpressions.push(transformInitializedVariable(variable));
	        }
	        if (pendingExpressions.length) {
	          emitStatement(factory2.createExpressionStatement(factory2.inlineExpressions(pendingExpressions)));
	          variablesWritten += pendingExpressions.length;
	          pendingExpressions = [];
	        }
	      }
	      return void 0;
	    }
	    function transformInitializedVariable(node) {
	      return setSourceMapRange(
	        factory2.createAssignment(
	          setSourceMapRange(factory2.cloneNode(node.name), node.name),
	          Debug.checkDefined(visitNode(node.initializer, visitor, isExpression))
	        ),
	        node
	      );
	    }
	    function transformAndEmitIfStatement(node) {
	      if (containsYield(node)) {
	        if (containsYield(node.thenStatement) || containsYield(node.elseStatement)) {
	          const endLabel = defineLabel();
	          const elseLabel = node.elseStatement ? defineLabel() : void 0;
	          emitBreakWhenFalse(
	            node.elseStatement ? elseLabel : endLabel,
	            Debug.checkDefined(visitNode(node.expression, visitor, isExpression)),
	            /*location*/
	            node.expression
	          );
	          transformAndEmitEmbeddedStatement(node.thenStatement);
	          if (node.elseStatement) {
	            emitBreak(endLabel);
	            markLabel(elseLabel);
	            transformAndEmitEmbeddedStatement(node.elseStatement);
	          }
	          markLabel(endLabel);
	        } else {
	          emitStatement(visitNode(node, visitor, isStatement));
	        }
	      } else {
	        emitStatement(visitNode(node, visitor, isStatement));
	      }
	    }
	    function transformAndEmitDoStatement(node) {
	      if (containsYield(node)) {
	        const conditionLabel = defineLabel();
	        const loopLabel = defineLabel();
	        beginLoopBlock(
	          /*continueLabel*/
	          conditionLabel
	        );
	        markLabel(loopLabel);
	        transformAndEmitEmbeddedStatement(node.statement);
	        markLabel(conditionLabel);
	        emitBreakWhenTrue(loopLabel, Debug.checkDefined(visitNode(node.expression, visitor, isExpression)));
	        endLoopBlock();
	      } else {
	        emitStatement(visitNode(node, visitor, isStatement));
	      }
	    }
	    function visitDoStatement(node) {
	      if (inStatementContainingYield) {
	        beginScriptLoopBlock();
	        node = visitEachChild(node, visitor, context);
	        endLoopBlock();
	        return node;
	      } else {
	        return visitEachChild(node, visitor, context);
	      }
	    }
	    function transformAndEmitWhileStatement(node) {
	      if (containsYield(node)) {
	        const loopLabel = defineLabel();
	        const endLabel = beginLoopBlock(loopLabel);
	        markLabel(loopLabel);
	        emitBreakWhenFalse(endLabel, Debug.checkDefined(visitNode(node.expression, visitor, isExpression)));
	        transformAndEmitEmbeddedStatement(node.statement);
	        emitBreak(loopLabel);
	        endLoopBlock();
	      } else {
	        emitStatement(visitNode(node, visitor, isStatement));
	      }
	    }
	    function visitWhileStatement(node) {
	      if (inStatementContainingYield) {
	        beginScriptLoopBlock();
	        node = visitEachChild(node, visitor, context);
	        endLoopBlock();
	        return node;
	      } else {
	        return visitEachChild(node, visitor, context);
	      }
	    }
	    function transformAndEmitForStatement(node) {
	      if (containsYield(node)) {
	        const conditionLabel = defineLabel();
	        const incrementLabel = defineLabel();
	        const endLabel = beginLoopBlock(incrementLabel);
	        if (node.initializer) {
	          const initializer = node.initializer;
	          if (isVariableDeclarationList(initializer)) {
	            transformAndEmitVariableDeclarationList(initializer);
	          } else {
	            emitStatement(
	              setTextRange(
	                factory2.createExpressionStatement(
	                  Debug.checkDefined(visitNode(initializer, visitor, isExpression))
	                ),
	                initializer
	              )
	            );
	          }
	        }
	        markLabel(conditionLabel);
	        if (node.condition) {
	          emitBreakWhenFalse(endLabel, Debug.checkDefined(visitNode(node.condition, visitor, isExpression)));
	        }
	        transformAndEmitEmbeddedStatement(node.statement);
	        markLabel(incrementLabel);
	        if (node.incrementor) {
	          emitStatement(
	            setTextRange(
	              factory2.createExpressionStatement(
	                Debug.checkDefined(visitNode(node.incrementor, visitor, isExpression))
	              ),
	              node.incrementor
	            )
	          );
	        }
	        emitBreak(conditionLabel);
	        endLoopBlock();
	      } else {
	        emitStatement(visitNode(node, visitor, isStatement));
	      }
	    }
	    function visitForStatement(node) {
	      if (inStatementContainingYield) {
	        beginScriptLoopBlock();
	      }
	      const initializer = node.initializer;
	      if (initializer && isVariableDeclarationList(initializer)) {
	        for (const variable of initializer.declarations) {
	          hoistVariableDeclaration(variable.name);
	        }
	        const variables = getInitializedVariables(initializer);
	        node = factory2.updateForStatement(
	          node,
	          variables.length > 0 ? factory2.inlineExpressions(map(variables, transformInitializedVariable)) : void 0,
	          visitNode(node.condition, visitor, isExpression),
	          visitNode(node.incrementor, visitor, isExpression),
	          visitIterationBody(node.statement, visitor, context)
	        );
	      } else {
	        node = visitEachChild(node, visitor, context);
	      }
	      if (inStatementContainingYield) {
	        endLoopBlock();
	      }
	      return node;
	    }
	    function transformAndEmitForInStatement(node) {
	      if (containsYield(node)) {
	        const obj = declareLocal();
	        const keysArray = declareLocal();
	        const key = declareLocal();
	        const keysIndex = factory2.createLoopVariable();
	        const initializer = node.initializer;
	        hoistVariableDeclaration(keysIndex);
	        emitAssignment(obj, Debug.checkDefined(visitNode(node.expression, visitor, isExpression)));
	        emitAssignment(keysArray, factory2.createArrayLiteralExpression());
	        emitStatement(
	          factory2.createForInStatement(
	            key,
	            obj,
	            factory2.createExpressionStatement(
	              factory2.createCallExpression(
	                factory2.createPropertyAccessExpression(keysArray, "push"),
	                /*typeArguments*/
	                void 0,
	                [key]
	              )
	            )
	          )
	        );
	        emitAssignment(keysIndex, factory2.createNumericLiteral(0));
	        const conditionLabel = defineLabel();
	        const incrementLabel = defineLabel();
	        const endLoopLabel = beginLoopBlock(incrementLabel);
	        markLabel(conditionLabel);
	        emitBreakWhenFalse(endLoopLabel, factory2.createLessThan(keysIndex, factory2.createPropertyAccessExpression(keysArray, "length")));
	        emitAssignment(key, factory2.createElementAccessExpression(keysArray, keysIndex));
	        emitBreakWhenFalse(incrementLabel, factory2.createBinaryExpression(key, 103 /* InKeyword */, obj));
	        let variable;
	        if (isVariableDeclarationList(initializer)) {
	          for (const variable2 of initializer.declarations) {
	            hoistVariableDeclaration(variable2.name);
	          }
	          variable = factory2.cloneNode(initializer.declarations[0].name);
	        } else {
	          variable = Debug.checkDefined(visitNode(initializer, visitor, isExpression));
	          Debug.assert(isLeftHandSideExpression(variable));
	        }
	        emitAssignment(variable, key);
	        transformAndEmitEmbeddedStatement(node.statement);
	        markLabel(incrementLabel);
	        emitStatement(factory2.createExpressionStatement(factory2.createPostfixIncrement(keysIndex)));
	        emitBreak(conditionLabel);
	        endLoopBlock();
	      } else {
	        emitStatement(visitNode(node, visitor, isStatement));
	      }
	    }
	    function visitForInStatement(node) {
	      if (inStatementContainingYield) {
	        beginScriptLoopBlock();
	      }
	      const initializer = node.initializer;
	      if (isVariableDeclarationList(initializer)) {
	        for (const variable of initializer.declarations) {
	          hoistVariableDeclaration(variable.name);
	        }
	        node = factory2.updateForInStatement(node, initializer.declarations[0].name, Debug.checkDefined(visitNode(node.expression, visitor, isExpression)), Debug.checkDefined(visitNode(node.statement, visitor, isStatement, factory2.liftToBlock)));
	      } else {
	        node = visitEachChild(node, visitor, context);
	      }
	      if (inStatementContainingYield) {
	        endLoopBlock();
	      }
	      return node;
	    }
	    function transformAndEmitContinueStatement(node) {
	      const label = findContinueTarget(node.label ? idText(node.label) : void 0);
	      if (label > 0) {
	        emitBreak(
	          label,
	          /*location*/
	          node
	        );
	      } else {
	        emitStatement(node);
	      }
	    }
	    function visitContinueStatement(node) {
	      if (inStatementContainingYield) {
	        const label = findContinueTarget(node.label && idText(node.label));
	        if (label > 0) {
	          return createInlineBreak(
	            label,
	            /*location*/
	            node
	          );
	        }
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function transformAndEmitBreakStatement(node) {
	      const label = findBreakTarget(node.label ? idText(node.label) : void 0);
	      if (label > 0) {
	        emitBreak(
	          label,
	          /*location*/
	          node
	        );
	      } else {
	        emitStatement(node);
	      }
	    }
	    function visitBreakStatement(node) {
	      if (inStatementContainingYield) {
	        const label = findBreakTarget(node.label && idText(node.label));
	        if (label > 0) {
	          return createInlineBreak(
	            label,
	            /*location*/
	            node
	          );
	        }
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function transformAndEmitReturnStatement(node) {
	      emitReturn(
	        visitNode(node.expression, visitor, isExpression),
	        /*location*/
	        node
	      );
	    }
	    function visitReturnStatement(node) {
	      return createInlineReturn(
	        visitNode(node.expression, visitor, isExpression),
	        /*location*/
	        node
	      );
	    }
	    function transformAndEmitWithStatement(node) {
	      if (containsYield(node)) {
	        beginWithBlock(cacheExpression(Debug.checkDefined(visitNode(node.expression, visitor, isExpression))));
	        transformAndEmitEmbeddedStatement(node.statement);
	        endWithBlock();
	      } else {
	        emitStatement(visitNode(node, visitor, isStatement));
	      }
	    }
	    function transformAndEmitSwitchStatement(node) {
	      if (containsYield(node.caseBlock)) {
	        const caseBlock = node.caseBlock;
	        const numClauses = caseBlock.clauses.length;
	        const endLabel = beginSwitchBlock();
	        const expression = cacheExpression(Debug.checkDefined(visitNode(node.expression, visitor, isExpression)));
	        const clauseLabels = [];
	        let defaultClauseIndex = -1;
	        for (let i = 0; i < numClauses; i++) {
	          const clause = caseBlock.clauses[i];
	          clauseLabels.push(defineLabel());
	          if (clause.kind === 297 /* DefaultClause */ && defaultClauseIndex === -1) {
	            defaultClauseIndex = i;
	          }
	        }
	        let clausesWritten = 0;
	        let pendingClauses = [];
	        while (clausesWritten < numClauses) {
	          let defaultClausesSkipped = 0;
	          for (let i = clausesWritten; i < numClauses; i++) {
	            const clause = caseBlock.clauses[i];
	            if (clause.kind === 296 /* CaseClause */) {
	              if (containsYield(clause.expression) && pendingClauses.length > 0) {
	                break;
	              }
	              pendingClauses.push(
	                factory2.createCaseClause(
	                  Debug.checkDefined(visitNode(clause.expression, visitor, isExpression)),
	                  [
	                    createInlineBreak(
	                      clauseLabels[i],
	                      /*location*/
	                      clause.expression
	                    )
	                  ]
	                )
	              );
	            } else {
	              defaultClausesSkipped++;
	            }
	          }
	          if (pendingClauses.length) {
	            emitStatement(factory2.createSwitchStatement(expression, factory2.createCaseBlock(pendingClauses)));
	            clausesWritten += pendingClauses.length;
	            pendingClauses = [];
	          }
	          if (defaultClausesSkipped > 0) {
	            clausesWritten += defaultClausesSkipped;
	            defaultClausesSkipped = 0;
	          }
	        }
	        if (defaultClauseIndex >= 0) {
	          emitBreak(clauseLabels[defaultClauseIndex]);
	        } else {
	          emitBreak(endLabel);
	        }
	        for (let i = 0; i < numClauses; i++) {
	          markLabel(clauseLabels[i]);
	          transformAndEmitStatements(caseBlock.clauses[i].statements);
	        }
	        endSwitchBlock();
	      } else {
	        emitStatement(visitNode(node, visitor, isStatement));
	      }
	    }
	    function visitSwitchStatement(node) {
	      if (inStatementContainingYield) {
	        beginScriptSwitchBlock();
	      }
	      node = visitEachChild(node, visitor, context);
	      if (inStatementContainingYield) {
	        endSwitchBlock();
	      }
	      return node;
	    }
	    function transformAndEmitLabeledStatement(node) {
	      if (containsYield(node)) {
	        beginLabeledBlock(idText(node.label));
	        transformAndEmitEmbeddedStatement(node.statement);
	        endLabeledBlock();
	      } else {
	        emitStatement(visitNode(node, visitor, isStatement));
	      }
	    }
	    function visitLabeledStatement(node) {
	      if (inStatementContainingYield) {
	        beginScriptLabeledBlock(idText(node.label));
	      }
	      node = visitEachChild(node, visitor, context);
	      if (inStatementContainingYield) {
	        endLabeledBlock();
	      }
	      return node;
	    }
	    function transformAndEmitThrowStatement(node) {
	      emitThrow(
	        Debug.checkDefined(visitNode(node.expression ?? factory2.createVoidZero(), visitor, isExpression)),
	        /*location*/
	        node
	      );
	    }
	    function transformAndEmitTryStatement(node) {
	      if (containsYield(node)) {
	        beginExceptionBlock();
	        transformAndEmitEmbeddedStatement(node.tryBlock);
	        if (node.catchClause) {
	          beginCatchBlock(node.catchClause.variableDeclaration);
	          transformAndEmitEmbeddedStatement(node.catchClause.block);
	        }
	        if (node.finallyBlock) {
	          beginFinallyBlock();
	          transformAndEmitEmbeddedStatement(node.finallyBlock);
	        }
	        endExceptionBlock();
	      } else {
	        emitStatement(visitEachChild(node, visitor, context));
	      }
	    }
	    function containsYield(node) {
	      return !!node && (node.transformFlags & 1048576 /* ContainsYield */) !== 0;
	    }
	    function countInitialNodesWithoutYield(nodes) {
	      const numNodes = nodes.length;
	      for (let i = 0; i < numNodes; i++) {
	        if (containsYield(nodes[i])) {
	          return i;
	        }
	      }
	      return -1;
	    }
	    function onSubstituteNode(hint, node) {
	      node = previousOnSubstituteNode(hint, node);
	      if (hint === 1 /* Expression */) {
	        return substituteExpression(node);
	      }
	      return node;
	    }
	    function substituteExpression(node) {
	      if (isIdentifier(node)) {
	        return substituteExpressionIdentifier(node);
	      }
	      return node;
	    }
	    function substituteExpressionIdentifier(node) {
	      if (!isGeneratedIdentifier(node) && renamedCatchVariables && renamedCatchVariables.has(idText(node))) {
	        const original = getOriginalNode(node);
	        if (isIdentifier(original) && original.parent) {
	          const declaration = resolver.getReferencedValueDeclaration(original);
	          if (declaration) {
	            const name = renamedCatchVariableDeclarations[getOriginalNodeId(declaration)];
	            if (name) {
	              const clone2 = setParent(setTextRange(factory2.cloneNode(name), name), name.parent);
	              setSourceMapRange(clone2, node);
	              setCommentRange(clone2, node);
	              return clone2;
	            }
	          }
	        }
	      }
	      return node;
	    }
	    function cacheExpression(node) {
	      if (isGeneratedIdentifier(node) || getEmitFlags(node) & 8192 /* HelperName */) {
	        return node;
	      }
	      const temp = factory2.createTempVariable(hoistVariableDeclaration);
	      emitAssignment(
	        temp,
	        node,
	        /*location*/
	        node
	      );
	      return temp;
	    }
	    function declareLocal(name) {
	      const temp = name ? factory2.createUniqueName(name) : factory2.createTempVariable(
	        /*recordTempVariable*/
	        void 0
	      );
	      hoistVariableDeclaration(temp);
	      return temp;
	    }
	    function defineLabel() {
	      if (!labelOffsets) {
	        labelOffsets = [];
	      }
	      const label = nextLabelId;
	      nextLabelId++;
	      labelOffsets[label] = -1;
	      return label;
	    }
	    function markLabel(label) {
	      Debug.assert(labelOffsets !== void 0, "No labels were defined.");
	      labelOffsets[label] = operations ? operations.length : 0;
	    }
	    function beginBlock(block) {
	      if (!blocks) {
	        blocks = [];
	        blockActions = [];
	        blockOffsets = [];
	        blockStack = [];
	      }
	      const index = blockActions.length;
	      blockActions[index] = 0 /* Open */;
	      blockOffsets[index] = operations ? operations.length : 0;
	      blocks[index] = block;
	      blockStack.push(block);
	      return index;
	    }
	    function endBlock() {
	      const block = peekBlock();
	      if (block === void 0)
	        return Debug.fail("beginBlock was never called.");
	      const index = blockActions.length;
	      blockActions[index] = 1 /* Close */;
	      blockOffsets[index] = operations ? operations.length : 0;
	      blocks[index] = block;
	      blockStack.pop();
	      return block;
	    }
	    function peekBlock() {
	      return lastOrUndefined(blockStack);
	    }
	    function peekBlockKind() {
	      const block = peekBlock();
	      return block && block.kind;
	    }
	    function beginWithBlock(expression) {
	      const startLabel = defineLabel();
	      const endLabel = defineLabel();
	      markLabel(startLabel);
	      beginBlock({
	        kind: 1 /* With */,
	        expression,
	        startLabel,
	        endLabel
	      });
	    }
	    function endWithBlock() {
	      Debug.assert(peekBlockKind() === 1 /* With */);
	      const block = endBlock();
	      markLabel(block.endLabel);
	    }
	    function beginExceptionBlock() {
	      const startLabel = defineLabel();
	      const endLabel = defineLabel();
	      markLabel(startLabel);
	      beginBlock({
	        kind: 0 /* Exception */,
	        state: 0 /* Try */,
	        startLabel,
	        endLabel
	      });
	      emitNop();
	      return endLabel;
	    }
	    function beginCatchBlock(variable) {
	      Debug.assert(peekBlockKind() === 0 /* Exception */);
	      let name;
	      if (isGeneratedIdentifier(variable.name)) {
	        name = variable.name;
	        hoistVariableDeclaration(variable.name);
	      } else {
	        const text = idText(variable.name);
	        name = declareLocal(text);
	        if (!renamedCatchVariables) {
	          renamedCatchVariables = /* @__PURE__ */ new Map();
	          renamedCatchVariableDeclarations = [];
	          context.enableSubstitution(80 /* Identifier */);
	        }
	        renamedCatchVariables.set(text, true);
	        renamedCatchVariableDeclarations[getOriginalNodeId(variable)] = name;
	      }
	      const exception = peekBlock();
	      Debug.assert(exception.state < 1 /* Catch */);
	      const endLabel = exception.endLabel;
	      emitBreak(endLabel);
	      const catchLabel = defineLabel();
	      markLabel(catchLabel);
	      exception.state = 1 /* Catch */;
	      exception.catchVariable = name;
	      exception.catchLabel = catchLabel;
	      emitAssignment(name, factory2.createCallExpression(
	        factory2.createPropertyAccessExpression(state, "sent"),
	        /*typeArguments*/
	        void 0,
	        []
	      ));
	      emitNop();
	    }
	    function beginFinallyBlock() {
	      Debug.assert(peekBlockKind() === 0 /* Exception */);
	      const exception = peekBlock();
	      Debug.assert(exception.state < 2 /* Finally */);
	      const endLabel = exception.endLabel;
	      emitBreak(endLabel);
	      const finallyLabel = defineLabel();
	      markLabel(finallyLabel);
	      exception.state = 2 /* Finally */;
	      exception.finallyLabel = finallyLabel;
	    }
	    function endExceptionBlock() {
	      Debug.assert(peekBlockKind() === 0 /* Exception */);
	      const exception = endBlock();
	      const state2 = exception.state;
	      if (state2 < 2 /* Finally */) {
	        emitBreak(exception.endLabel);
	      } else {
	        emitEndfinally();
	      }
	      markLabel(exception.endLabel);
	      emitNop();
	      exception.state = 3 /* Done */;
	    }
	    function beginScriptLoopBlock() {
	      beginBlock({
	        kind: 3 /* Loop */,
	        isScript: true,
	        breakLabel: -1,
	        continueLabel: -1
	      });
	    }
	    function beginLoopBlock(continueLabel) {
	      const breakLabel = defineLabel();
	      beginBlock({
	        kind: 3 /* Loop */,
	        isScript: false,
	        breakLabel,
	        continueLabel
	      });
	      return breakLabel;
	    }
	    function endLoopBlock() {
	      Debug.assert(peekBlockKind() === 3 /* Loop */);
	      const block = endBlock();
	      const breakLabel = block.breakLabel;
	      if (!block.isScript) {
	        markLabel(breakLabel);
	      }
	    }
	    function beginScriptSwitchBlock() {
	      beginBlock({
	        kind: 2 /* Switch */,
	        isScript: true,
	        breakLabel: -1
	      });
	    }
	    function beginSwitchBlock() {
	      const breakLabel = defineLabel();
	      beginBlock({
	        kind: 2 /* Switch */,
	        isScript: false,
	        breakLabel
	      });
	      return breakLabel;
	    }
	    function endSwitchBlock() {
	      Debug.assert(peekBlockKind() === 2 /* Switch */);
	      const block = endBlock();
	      const breakLabel = block.breakLabel;
	      if (!block.isScript) {
	        markLabel(breakLabel);
	      }
	    }
	    function beginScriptLabeledBlock(labelText) {
	      beginBlock({
	        kind: 4 /* Labeled */,
	        isScript: true,
	        labelText,
	        breakLabel: -1
	      });
	    }
	    function beginLabeledBlock(labelText) {
	      const breakLabel = defineLabel();
	      beginBlock({
	        kind: 4 /* Labeled */,
	        isScript: false,
	        labelText,
	        breakLabel
	      });
	    }
	    function endLabeledBlock() {
	      Debug.assert(peekBlockKind() === 4 /* Labeled */);
	      const block = endBlock();
	      if (!block.isScript) {
	        markLabel(block.breakLabel);
	      }
	    }
	    function supportsUnlabeledBreak(block) {
	      return block.kind === 2 /* Switch */ || block.kind === 3 /* Loop */;
	    }
	    function supportsLabeledBreakOrContinue(block) {
	      return block.kind === 4 /* Labeled */;
	    }
	    function supportsUnlabeledContinue(block) {
	      return block.kind === 3 /* Loop */;
	    }
	    function hasImmediateContainingLabeledBlock(labelText, start) {
	      for (let j = start; j >= 0; j--) {
	        const containingBlock = blockStack[j];
	        if (supportsLabeledBreakOrContinue(containingBlock)) {
	          if (containingBlock.labelText === labelText) {
	            return true;
	          }
	        } else {
	          break;
	        }
	      }
	      return false;
	    }
	    function findBreakTarget(labelText) {
	      if (blockStack) {
	        if (labelText) {
	          for (let i = blockStack.length - 1; i >= 0; i--) {
	            const block = blockStack[i];
	            if (supportsLabeledBreakOrContinue(block) && block.labelText === labelText) {
	              return block.breakLabel;
	            } else if (supportsUnlabeledBreak(block) && hasImmediateContainingLabeledBlock(labelText, i - 1)) {
	              return block.breakLabel;
	            }
	          }
	        } else {
	          for (let i = blockStack.length - 1; i >= 0; i--) {
	            const block = blockStack[i];
	            if (supportsUnlabeledBreak(block)) {
	              return block.breakLabel;
	            }
	          }
	        }
	      }
	      return 0;
	    }
	    function findContinueTarget(labelText) {
	      if (blockStack) {
	        if (labelText) {
	          for (let i = blockStack.length - 1; i >= 0; i--) {
	            const block = blockStack[i];
	            if (supportsUnlabeledContinue(block) && hasImmediateContainingLabeledBlock(labelText, i - 1)) {
	              return block.continueLabel;
	            }
	          }
	        } else {
	          for (let i = blockStack.length - 1; i >= 0; i--) {
	            const block = blockStack[i];
	            if (supportsUnlabeledContinue(block)) {
	              return block.continueLabel;
	            }
	          }
	        }
	      }
	      return 0;
	    }
	    function createLabel(label) {
	      if (label !== void 0 && label > 0) {
	        if (labelExpressions === void 0) {
	          labelExpressions = [];
	        }
	        const expression = factory2.createNumericLiteral(Number.MAX_SAFE_INTEGER);
	        if (labelExpressions[label] === void 0) {
	          labelExpressions[label] = [expression];
	        } else {
	          labelExpressions[label].push(expression);
	        }
	        return expression;
	      }
	      return factory2.createOmittedExpression();
	    }
	    function createInstruction(instruction) {
	      const literal = factory2.createNumericLiteral(instruction);
	      addSyntheticTrailingComment(literal, 3 /* MultiLineCommentTrivia */, getInstructionName(instruction));
	      return literal;
	    }
	    function createInlineBreak(label, location) {
	      Debug.assertLessThan(0, label, "Invalid label");
	      return setTextRange(
	        factory2.createReturnStatement(
	          factory2.createArrayLiteralExpression([
	            createInstruction(3 /* Break */),
	            createLabel(label)
	          ])
	        ),
	        location
	      );
	    }
	    function createInlineReturn(expression, location) {
	      return setTextRange(
	        factory2.createReturnStatement(
	          factory2.createArrayLiteralExpression(
	            expression ? [createInstruction(2 /* Return */), expression] : [createInstruction(2 /* Return */)]
	          )
	        ),
	        location
	      );
	    }
	    function createGeneratorResume(location) {
	      return setTextRange(
	        factory2.createCallExpression(
	          factory2.createPropertyAccessExpression(state, "sent"),
	          /*typeArguments*/
	          void 0,
	          []
	        ),
	        location
	      );
	    }
	    function emitNop() {
	      emitWorker(0 /* Nop */);
	    }
	    function emitStatement(node) {
	      if (node) {
	        emitWorker(1 /* Statement */, [node]);
	      } else {
	        emitNop();
	      }
	    }
	    function emitAssignment(left, right, location) {
	      emitWorker(2 /* Assign */, [left, right], location);
	    }
	    function emitBreak(label, location) {
	      emitWorker(3 /* Break */, [label], location);
	    }
	    function emitBreakWhenTrue(label, condition, location) {
	      emitWorker(4 /* BreakWhenTrue */, [label, condition], location);
	    }
	    function emitBreakWhenFalse(label, condition, location) {
	      emitWorker(5 /* BreakWhenFalse */, [label, condition], location);
	    }
	    function emitYieldStar(expression, location) {
	      emitWorker(7 /* YieldStar */, [expression], location);
	    }
	    function emitYield(expression, location) {
	      emitWorker(6 /* Yield */, [expression], location);
	    }
	    function emitReturn(expression, location) {
	      emitWorker(8 /* Return */, [expression], location);
	    }
	    function emitThrow(expression, location) {
	      emitWorker(9 /* Throw */, [expression], location);
	    }
	    function emitEndfinally() {
	      emitWorker(10 /* Endfinally */);
	    }
	    function emitWorker(code, args, location) {
	      if (operations === void 0) {
	        operations = [];
	        operationArguments = [];
	        operationLocations = [];
	      }
	      if (labelOffsets === void 0) {
	        markLabel(defineLabel());
	      }
	      const operationIndex = operations.length;
	      operations[operationIndex] = code;
	      operationArguments[operationIndex] = args;
	      operationLocations[operationIndex] = location;
	    }
	    function build2() {
	      blockIndex = 0;
	      labelNumber = 0;
	      labelNumbers = void 0;
	      lastOperationWasAbrupt = false;
	      lastOperationWasCompletion = false;
	      clauses = void 0;
	      statements = void 0;
	      exceptionBlockStack = void 0;
	      currentExceptionBlock = void 0;
	      withBlockStack = void 0;
	      const buildResult = buildStatements();
	      return emitHelpers().createGeneratorHelper(
	        setEmitFlags(
	          factory2.createFunctionExpression(
	            /*modifiers*/
	            void 0,
	            /*asteriskToken*/
	            void 0,
	            /*name*/
	            void 0,
	            /*typeParameters*/
	            void 0,
	            [factory2.createParameterDeclaration(
	              /*modifiers*/
	              void 0,
	              /*dotDotDotToken*/
	              void 0,
	              state
	            )],
	            /*type*/
	            void 0,
	            factory2.createBlock(
	              buildResult,
	              /*multiLine*/
	              buildResult.length > 0
	            )
	          ),
	          1048576 /* ReuseTempVariableScope */
	        )
	      );
	    }
	    function buildStatements() {
	      if (operations) {
	        for (let operationIndex = 0; operationIndex < operations.length; operationIndex++) {
	          writeOperation(operationIndex);
	        }
	        flushFinalLabel(operations.length);
	      } else {
	        flushFinalLabel(0);
	      }
	      if (clauses) {
	        const labelExpression = factory2.createPropertyAccessExpression(state, "label");
	        const switchStatement = factory2.createSwitchStatement(labelExpression, factory2.createCaseBlock(clauses));
	        return [startOnNewLine(switchStatement)];
	      }
	      if (statements) {
	        return statements;
	      }
	      return [];
	    }
	    function flushLabel() {
	      if (!statements) {
	        return;
	      }
	      appendLabel(
	        /*markLabelEnd*/
	        !lastOperationWasAbrupt
	      );
	      lastOperationWasAbrupt = false;
	      lastOperationWasCompletion = false;
	      labelNumber++;
	    }
	    function flushFinalLabel(operationIndex) {
	      if (isFinalLabelReachable(operationIndex)) {
	        tryEnterLabel(operationIndex);
	        withBlockStack = void 0;
	        writeReturn(
	          /*expression*/
	          void 0,
	          /*operationLocation*/
	          void 0
	        );
	      }
	      if (statements && clauses) {
	        appendLabel(
	          /*markLabelEnd*/
	          false
	        );
	      }
	      updateLabelExpressions();
	    }
	    function isFinalLabelReachable(operationIndex) {
	      if (!lastOperationWasCompletion) {
	        return true;
	      }
	      if (!labelOffsets || !labelExpressions) {
	        return false;
	      }
	      for (let label = 0; label < labelOffsets.length; label++) {
	        if (labelOffsets[label] === operationIndex && labelExpressions[label]) {
	          return true;
	        }
	      }
	      return false;
	    }
	    function appendLabel(markLabelEnd) {
	      if (!clauses) {
	        clauses = [];
	      }
	      if (statements) {
	        if (withBlockStack) {
	          for (let i = withBlockStack.length - 1; i >= 0; i--) {
	            const withBlock = withBlockStack[i];
	            statements = [factory2.createWithStatement(withBlock.expression, factory2.createBlock(statements))];
	          }
	        }
	        if (currentExceptionBlock) {
	          const { startLabel, catchLabel, finallyLabel, endLabel } = currentExceptionBlock;
	          statements.unshift(
	            factory2.createExpressionStatement(
	              factory2.createCallExpression(
	                factory2.createPropertyAccessExpression(factory2.createPropertyAccessExpression(state, "trys"), "push"),
	                /*typeArguments*/
	                void 0,
	                [
	                  factory2.createArrayLiteralExpression([
	                    createLabel(startLabel),
	                    createLabel(catchLabel),
	                    createLabel(finallyLabel),
	                    createLabel(endLabel)
	                  ])
	                ]
	              )
	            )
	          );
	          currentExceptionBlock = void 0;
	        }
	        if (markLabelEnd) {
	          statements.push(
	            factory2.createExpressionStatement(
	              factory2.createAssignment(
	                factory2.createPropertyAccessExpression(state, "label"),
	                factory2.createNumericLiteral(labelNumber + 1)
	              )
	            )
	          );
	        }
	      }
	      clauses.push(
	        factory2.createCaseClause(
	          factory2.createNumericLiteral(labelNumber),
	          statements || []
	        )
	      );
	      statements = void 0;
	    }
	    function tryEnterLabel(operationIndex) {
	      if (!labelOffsets) {
	        return;
	      }
	      for (let label = 0; label < labelOffsets.length; label++) {
	        if (labelOffsets[label] === operationIndex) {
	          flushLabel();
	          if (labelNumbers === void 0) {
	            labelNumbers = [];
	          }
	          if (labelNumbers[labelNumber] === void 0) {
	            labelNumbers[labelNumber] = [label];
	          } else {
	            labelNumbers[labelNumber].push(label);
	          }
	        }
	      }
	    }
	    function updateLabelExpressions() {
	      if (labelExpressions !== void 0 && labelNumbers !== void 0) {
	        for (let labelNumber2 = 0; labelNumber2 < labelNumbers.length; labelNumber2++) {
	          const labels = labelNumbers[labelNumber2];
	          if (labels !== void 0) {
	            for (const label of labels) {
	              const expressions = labelExpressions[label];
	              if (expressions !== void 0) {
	                for (const expression of expressions) {
	                  expression.text = String(labelNumber2);
	                }
	              }
	            }
	          }
	        }
	      }
	    }
	    function tryEnterOrLeaveBlock(operationIndex) {
	      if (blocks) {
	        for (; blockIndex < blockActions.length && blockOffsets[blockIndex] <= operationIndex; blockIndex++) {
	          const block = blocks[blockIndex];
	          const blockAction = blockActions[blockIndex];
	          switch (block.kind) {
	            case 0 /* Exception */:
	              if (blockAction === 0 /* Open */) {
	                if (!exceptionBlockStack) {
	                  exceptionBlockStack = [];
	                }
	                if (!statements) {
	                  statements = [];
	                }
	                exceptionBlockStack.push(currentExceptionBlock);
	                currentExceptionBlock = block;
	              } else if (blockAction === 1 /* Close */) {
	                currentExceptionBlock = exceptionBlockStack.pop();
	              }
	              break;
	            case 1 /* With */:
	              if (blockAction === 0 /* Open */) {
	                if (!withBlockStack) {
	                  withBlockStack = [];
	                }
	                withBlockStack.push(block);
	              } else if (blockAction === 1 /* Close */) {
	                withBlockStack.pop();
	              }
	              break;
	          }
	        }
	      }
	    }
	    function writeOperation(operationIndex) {
	      tryEnterLabel(operationIndex);
	      tryEnterOrLeaveBlock(operationIndex);
	      if (lastOperationWasAbrupt) {
	        return;
	      }
	      lastOperationWasAbrupt = false;
	      lastOperationWasCompletion = false;
	      const opcode = operations[operationIndex];
	      if (opcode === 0 /* Nop */) {
	        return;
	      } else if (opcode === 10 /* Endfinally */) {
	        return writeEndfinally();
	      }
	      const args = operationArguments[operationIndex];
	      if (opcode === 1 /* Statement */) {
	        return writeStatement(args[0]);
	      }
	      const location = operationLocations[operationIndex];
	      switch (opcode) {
	        case 2 /* Assign */:
	          return writeAssign(args[0], args[1], location);
	        case 3 /* Break */:
	          return writeBreak(args[0], location);
	        case 4 /* BreakWhenTrue */:
	          return writeBreakWhenTrue(args[0], args[1], location);
	        case 5 /* BreakWhenFalse */:
	          return writeBreakWhenFalse(args[0], args[1], location);
	        case 6 /* Yield */:
	          return writeYield(args[0], location);
	        case 7 /* YieldStar */:
	          return writeYieldStar(args[0], location);
	        case 8 /* Return */:
	          return writeReturn(args[0], location);
	        case 9 /* Throw */:
	          return writeThrow(args[0], location);
	      }
	    }
	    function writeStatement(statement) {
	      if (statement) {
	        if (!statements) {
	          statements = [statement];
	        } else {
	          statements.push(statement);
	        }
	      }
	    }
	    function writeAssign(left, right, operationLocation) {
	      writeStatement(setTextRange(factory2.createExpressionStatement(factory2.createAssignment(left, right)), operationLocation));
	    }
	    function writeThrow(expression, operationLocation) {
	      lastOperationWasAbrupt = true;
	      lastOperationWasCompletion = true;
	      writeStatement(setTextRange(factory2.createThrowStatement(expression), operationLocation));
	    }
	    function writeReturn(expression, operationLocation) {
	      lastOperationWasAbrupt = true;
	      lastOperationWasCompletion = true;
	      writeStatement(
	        setEmitFlags(
	          setTextRange(
	            factory2.createReturnStatement(
	              factory2.createArrayLiteralExpression(
	                expression ? [createInstruction(2 /* Return */), expression] : [createInstruction(2 /* Return */)]
	              )
	            ),
	            operationLocation
	          ),
	          768 /* NoTokenSourceMaps */
	        )
	      );
	    }
	    function writeBreak(label, operationLocation) {
	      lastOperationWasAbrupt = true;
	      writeStatement(
	        setEmitFlags(
	          setTextRange(
	            factory2.createReturnStatement(
	              factory2.createArrayLiteralExpression([
	                createInstruction(3 /* Break */),
	                createLabel(label)
	              ])
	            ),
	            operationLocation
	          ),
	          768 /* NoTokenSourceMaps */
	        )
	      );
	    }
	    function writeBreakWhenTrue(label, condition, operationLocation) {
	      writeStatement(
	        setEmitFlags(
	          factory2.createIfStatement(
	            condition,
	            setEmitFlags(
	              setTextRange(
	                factory2.createReturnStatement(
	                  factory2.createArrayLiteralExpression([
	                    createInstruction(3 /* Break */),
	                    createLabel(label)
	                  ])
	                ),
	                operationLocation
	              ),
	              768 /* NoTokenSourceMaps */
	            )
	          ),
	          1 /* SingleLine */
	        )
	      );
	    }
	    function writeBreakWhenFalse(label, condition, operationLocation) {
	      writeStatement(
	        setEmitFlags(
	          factory2.createIfStatement(
	            factory2.createLogicalNot(condition),
	            setEmitFlags(
	              setTextRange(
	                factory2.createReturnStatement(
	                  factory2.createArrayLiteralExpression([
	                    createInstruction(3 /* Break */),
	                    createLabel(label)
	                  ])
	                ),
	                operationLocation
	              ),
	              768 /* NoTokenSourceMaps */
	            )
	          ),
	          1 /* SingleLine */
	        )
	      );
	    }
	    function writeYield(expression, operationLocation) {
	      lastOperationWasAbrupt = true;
	      writeStatement(
	        setEmitFlags(
	          setTextRange(
	            factory2.createReturnStatement(
	              factory2.createArrayLiteralExpression(
	                expression ? [createInstruction(4 /* Yield */), expression] : [createInstruction(4 /* Yield */)]
	              )
	            ),
	            operationLocation
	          ),
	          768 /* NoTokenSourceMaps */
	        )
	      );
	    }
	    function writeYieldStar(expression, operationLocation) {
	      lastOperationWasAbrupt = true;
	      writeStatement(
	        setEmitFlags(
	          setTextRange(
	            factory2.createReturnStatement(
	              factory2.createArrayLiteralExpression([
	                createInstruction(5 /* YieldStar */),
	                expression
	              ])
	            ),
	            operationLocation
	          ),
	          768 /* NoTokenSourceMaps */
	        )
	      );
	    }
	    function writeEndfinally() {
	      lastOperationWasAbrupt = true;
	      writeStatement(
	        factory2.createReturnStatement(
	          factory2.createArrayLiteralExpression([
	            createInstruction(7 /* Endfinally */)
	          ])
	        )
	      );
	    }
	  }
	  var init_generators = __esm({
	    "src/compiler/transformers/generators.ts"() {
	      init_ts2();
	    }
	  });

	  // src/compiler/transformers/module/module.ts
	  function transformModule(context) {
	    function getTransformModuleDelegate(moduleKind2) {
	      switch (moduleKind2) {
	        case 2 /* AMD */:
	          return transformAMDModule;
	        case 3 /* UMD */:
	          return transformUMDModule;
	        default:
	          return transformCommonJSModule;
	      }
	    }
	    const {
	      factory: factory2,
	      getEmitHelperFactory: emitHelpers,
	      startLexicalEnvironment,
	      endLexicalEnvironment,
	      hoistVariableDeclaration
	    } = context;
	    const compilerOptions = context.getCompilerOptions();
	    const resolver = context.getEmitResolver();
	    const host = context.getEmitHost();
	    const languageVersion = getEmitScriptTarget(compilerOptions);
	    const moduleKind = getEmitModuleKind(compilerOptions);
	    const previousOnSubstituteNode = context.onSubstituteNode;
	    const previousOnEmitNode = context.onEmitNode;
	    context.onSubstituteNode = onSubstituteNode;
	    context.onEmitNode = onEmitNode;
	    context.enableSubstitution(213 /* CallExpression */);
	    context.enableSubstitution(215 /* TaggedTemplateExpression */);
	    context.enableSubstitution(80 /* Identifier */);
	    context.enableSubstitution(226 /* BinaryExpression */);
	    context.enableSubstitution(304 /* ShorthandPropertyAssignment */);
	    context.enableEmitNotification(312 /* SourceFile */);
	    const moduleInfoMap = [];
	    let currentSourceFile;
	    let currentModuleInfo;
	    const noSubstitution = [];
	    let needUMDDynamicImportHelper;
	    return chainBundle(context, transformSourceFile);
	    function transformSourceFile(node) {
	      if (node.isDeclarationFile || !(isEffectiveExternalModule(node, compilerOptions) || node.transformFlags & 8388608 /* ContainsDynamicImport */ || isJsonSourceFile(node) && hasJsonModuleEmitEnabled(compilerOptions) && outFile(compilerOptions))) {
	        return node;
	      }
	      currentSourceFile = node;
	      currentModuleInfo = collectExternalModuleInfo(context, node);
	      moduleInfoMap[getOriginalNodeId(node)] = currentModuleInfo;
	      const transformModule2 = getTransformModuleDelegate(moduleKind);
	      const updated = transformModule2(node);
	      currentSourceFile = void 0;
	      currentModuleInfo = void 0;
	      needUMDDynamicImportHelper = false;
	      return updated;
	    }
	    function shouldEmitUnderscoreUnderscoreESModule() {
	      if (!currentModuleInfo.exportEquals && isExternalModule(currentSourceFile)) {
	        return true;
	      }
	      return false;
	    }
	    function transformCommonJSModule(node) {
	      startLexicalEnvironment();
	      const statements = [];
	      const ensureUseStrict = getStrictOptionValue(compilerOptions, "alwaysStrict") || !compilerOptions.noImplicitUseStrict && isExternalModule(currentSourceFile);
	      const statementOffset = factory2.copyPrologue(node.statements, statements, ensureUseStrict && !isJsonSourceFile(node), topLevelVisitor);
	      if (shouldEmitUnderscoreUnderscoreESModule()) {
	        append(statements, createUnderscoreUnderscoreESModule());
	      }
	      if (length(currentModuleInfo.exportedNames)) {
	        const chunkSize = 50;
	        for (let i = 0; i < currentModuleInfo.exportedNames.length; i += chunkSize) {
	          append(
	            statements,
	            factory2.createExpressionStatement(
	              reduceLeft(
	                currentModuleInfo.exportedNames.slice(i, i + chunkSize),
	                (prev, nextId) => factory2.createAssignment(factory2.createPropertyAccessExpression(factory2.createIdentifier("exports"), factory2.createIdentifier(idText(nextId))), prev),
	                factory2.createVoidZero()
	              )
	            )
	          );
	        }
	      }
	      append(statements, visitNode(currentModuleInfo.externalHelpersImportDeclaration, topLevelVisitor, isStatement));
	      addRange(statements, visitNodes2(node.statements, topLevelVisitor, isStatement, statementOffset));
	      addExportEqualsIfNeeded(
	        statements,
	        /*emitAsReturn*/
	        false
	      );
	      insertStatementsAfterStandardPrologue(statements, endLexicalEnvironment());
	      const updated = factory2.updateSourceFile(node, setTextRange(factory2.createNodeArray(statements), node.statements));
	      addEmitHelpers(updated, context.readEmitHelpers());
	      return updated;
	    }
	    function transformAMDModule(node) {
	      const define = factory2.createIdentifier("define");
	      const moduleName = tryGetModuleNameFromFile(factory2, node, host, compilerOptions);
	      const jsonSourceFile = isJsonSourceFile(node) && node;
	      const { aliasedModuleNames, unaliasedModuleNames, importAliasNames } = collectAsynchronousDependencies(
	        node,
	        /*includeNonAmdDependencies*/
	        true
	      );
	      const updated = factory2.updateSourceFile(
	        node,
	        setTextRange(
	          factory2.createNodeArray([
	            factory2.createExpressionStatement(
	              factory2.createCallExpression(
	                define,
	                /*typeArguments*/
	                void 0,
	                [
	                  // Add the module name (if provided).
	                  ...moduleName ? [moduleName] : [],
	                  // Add the dependency array argument:
	                  //
	                  //     ["require", "exports", module1", "module2", ...]
	                  factory2.createArrayLiteralExpression(
	                    jsonSourceFile ? emptyArray : [
	                      factory2.createStringLiteral("require"),
	                      factory2.createStringLiteral("exports"),
	                      ...aliasedModuleNames,
	                      ...unaliasedModuleNames
	                    ]
	                  ),
	                  // Add the module body function argument:
	                  //
	                  //     function (require, exports, module1, module2) ...
	                  jsonSourceFile ? jsonSourceFile.statements.length ? jsonSourceFile.statements[0].expression : factory2.createObjectLiteralExpression() : factory2.createFunctionExpression(
	                    /*modifiers*/
	                    void 0,
	                    /*asteriskToken*/
	                    void 0,
	                    /*name*/
	                    void 0,
	                    /*typeParameters*/
	                    void 0,
	                    [
	                      factory2.createParameterDeclaration(
	                        /*modifiers*/
	                        void 0,
	                        /*dotDotDotToken*/
	                        void 0,
	                        "require"
	                      ),
	                      factory2.createParameterDeclaration(
	                        /*modifiers*/
	                        void 0,
	                        /*dotDotDotToken*/
	                        void 0,
	                        "exports"
	                      ),
	                      ...importAliasNames
	                    ],
	                    /*type*/
	                    void 0,
	                    transformAsynchronousModuleBody(node)
	                  )
	                ]
	              )
	            )
	          ]),
	          /*location*/
	          node.statements
	        )
	      );
	      addEmitHelpers(updated, context.readEmitHelpers());
	      return updated;
	    }
	    function transformUMDModule(node) {
	      const { aliasedModuleNames, unaliasedModuleNames, importAliasNames } = collectAsynchronousDependencies(
	        node,
	        /*includeNonAmdDependencies*/
	        false
	      );
	      const moduleName = tryGetModuleNameFromFile(factory2, node, host, compilerOptions);
	      const umdHeader = factory2.createFunctionExpression(
	        /*modifiers*/
	        void 0,
	        /*asteriskToken*/
	        void 0,
	        /*name*/
	        void 0,
	        /*typeParameters*/
	        void 0,
	        [factory2.createParameterDeclaration(
	          /*modifiers*/
	          void 0,
	          /*dotDotDotToken*/
	          void 0,
	          "factory"
	        )],
	        /*type*/
	        void 0,
	        setTextRange(
	          factory2.createBlock(
	            [
	              factory2.createIfStatement(
	                factory2.createLogicalAnd(
	                  factory2.createTypeCheck(factory2.createIdentifier("module"), "object"),
	                  factory2.createTypeCheck(factory2.createPropertyAccessExpression(factory2.createIdentifier("module"), "exports"), "object")
	                ),
	                factory2.createBlock([
	                  factory2.createVariableStatement(
	                    /*modifiers*/
	                    void 0,
	                    [
	                      factory2.createVariableDeclaration(
	                        "v",
	                        /*exclamationToken*/
	                        void 0,
	                        /*type*/
	                        void 0,
	                        factory2.createCallExpression(
	                          factory2.createIdentifier("factory"),
	                          /*typeArguments*/
	                          void 0,
	                          [
	                            factory2.createIdentifier("require"),
	                            factory2.createIdentifier("exports")
	                          ]
	                        )
	                      )
	                    ]
	                  ),
	                  setEmitFlags(
	                    factory2.createIfStatement(
	                      factory2.createStrictInequality(
	                        factory2.createIdentifier("v"),
	                        factory2.createIdentifier("undefined")
	                      ),
	                      factory2.createExpressionStatement(
	                        factory2.createAssignment(
	                          factory2.createPropertyAccessExpression(factory2.createIdentifier("module"), "exports"),
	                          factory2.createIdentifier("v")
	                        )
	                      )
	                    ),
	                    1 /* SingleLine */
	                  )
	                ]),
	                factory2.createIfStatement(
	                  factory2.createLogicalAnd(
	                    factory2.createTypeCheck(factory2.createIdentifier("define"), "function"),
	                    factory2.createPropertyAccessExpression(factory2.createIdentifier("define"), "amd")
	                  ),
	                  factory2.createBlock([
	                    factory2.createExpressionStatement(
	                      factory2.createCallExpression(
	                        factory2.createIdentifier("define"),
	                        /*typeArguments*/
	                        void 0,
	                        [
	                          // Add the module name (if provided).
	                          ...moduleName ? [moduleName] : [],
	                          factory2.createArrayLiteralExpression([
	                            factory2.createStringLiteral("require"),
	                            factory2.createStringLiteral("exports"),
	                            ...aliasedModuleNames,
	                            ...unaliasedModuleNames
	                          ]),
	                          factory2.createIdentifier("factory")
	                        ]
	                      )
	                    )
	                  ])
	                )
	              )
	            ],
	            /*multiLine*/
	            true
	          ),
	          /*location*/
	          void 0
	        )
	      );
	      const updated = factory2.updateSourceFile(
	        node,
	        setTextRange(
	          factory2.createNodeArray([
	            factory2.createExpressionStatement(
	              factory2.createCallExpression(
	                umdHeader,
	                /*typeArguments*/
	                void 0,
	                [
	                  // Add the module body function argument:
	                  //
	                  //     function (require, exports) ...
	                  factory2.createFunctionExpression(
	                    /*modifiers*/
	                    void 0,
	                    /*asteriskToken*/
	                    void 0,
	                    /*name*/
	                    void 0,
	                    /*typeParameters*/
	                    void 0,
	                    [
	                      factory2.createParameterDeclaration(
	                        /*modifiers*/
	                        void 0,
	                        /*dotDotDotToken*/
	                        void 0,
	                        "require"
	                      ),
	                      factory2.createParameterDeclaration(
	                        /*modifiers*/
	                        void 0,
	                        /*dotDotDotToken*/
	                        void 0,
	                        "exports"
	                      ),
	                      ...importAliasNames
	                    ],
	                    /*type*/
	                    void 0,
	                    transformAsynchronousModuleBody(node)
	                  )
	                ]
	              )
	            )
	          ]),
	          /*location*/
	          node.statements
	        )
	      );
	      addEmitHelpers(updated, context.readEmitHelpers());
	      return updated;
	    }
	    function collectAsynchronousDependencies(node, includeNonAmdDependencies) {
	      const aliasedModuleNames = [];
	      const unaliasedModuleNames = [];
	      const importAliasNames = [];
	      for (const amdDependency of node.amdDependencies) {
	        if (amdDependency.name) {
	          aliasedModuleNames.push(factory2.createStringLiteral(amdDependency.path));
	          importAliasNames.push(factory2.createParameterDeclaration(
	            /*modifiers*/
	            void 0,
	            /*dotDotDotToken*/
	            void 0,
	            amdDependency.name
	          ));
	        } else {
	          unaliasedModuleNames.push(factory2.createStringLiteral(amdDependency.path));
	        }
	      }
	      for (const importNode of currentModuleInfo.externalImports) {
	        const externalModuleName = getExternalModuleNameLiteral(factory2, importNode, currentSourceFile, host, resolver, compilerOptions);
	        const importAliasName = getLocalNameForExternalImport(factory2, importNode, currentSourceFile);
	        if (externalModuleName) {
	          if (includeNonAmdDependencies && importAliasName) {
	            setEmitFlags(importAliasName, 8 /* NoSubstitution */);
	            aliasedModuleNames.push(externalModuleName);
	            importAliasNames.push(factory2.createParameterDeclaration(
	              /*modifiers*/
	              void 0,
	              /*dotDotDotToken*/
	              void 0,
	              importAliasName
	            ));
	          } else {
	            unaliasedModuleNames.push(externalModuleName);
	          }
	        }
	      }
	      return { aliasedModuleNames, unaliasedModuleNames, importAliasNames };
	    }
	    function getAMDImportExpressionForImport(node) {
	      if (isImportEqualsDeclaration(node) || isExportDeclaration(node) || !getExternalModuleNameLiteral(factory2, node, currentSourceFile, host, resolver, compilerOptions)) {
	        return void 0;
	      }
	      const name = getLocalNameForExternalImport(factory2, node, currentSourceFile);
	      const expr = getHelperExpressionForImport(node, name);
	      if (expr === name) {
	        return void 0;
	      }
	      return factory2.createExpressionStatement(factory2.createAssignment(name, expr));
	    }
	    function transformAsynchronousModuleBody(node) {
	      startLexicalEnvironment();
	      const statements = [];
	      const statementOffset = factory2.copyPrologue(
	        node.statements,
	        statements,
	        /*ensureUseStrict*/
	        !compilerOptions.noImplicitUseStrict,
	        topLevelVisitor
	      );
	      if (shouldEmitUnderscoreUnderscoreESModule()) {
	        append(statements, createUnderscoreUnderscoreESModule());
	      }
	      if (length(currentModuleInfo.exportedNames)) {
	        append(statements, factory2.createExpressionStatement(reduceLeft(currentModuleInfo.exportedNames, (prev, nextId) => factory2.createAssignment(factory2.createPropertyAccessExpression(factory2.createIdentifier("exports"), factory2.createIdentifier(idText(nextId))), prev), factory2.createVoidZero())));
	      }
	      append(statements, visitNode(currentModuleInfo.externalHelpersImportDeclaration, topLevelVisitor, isStatement));
	      if (moduleKind === 2 /* AMD */) {
	        addRange(statements, mapDefined(currentModuleInfo.externalImports, getAMDImportExpressionForImport));
	      }
	      addRange(statements, visitNodes2(node.statements, topLevelVisitor, isStatement, statementOffset));
	      addExportEqualsIfNeeded(
	        statements,
	        /*emitAsReturn*/
	        true
	      );
	      insertStatementsAfterStandardPrologue(statements, endLexicalEnvironment());
	      const body = factory2.createBlock(
	        statements,
	        /*multiLine*/
	        true
	      );
	      if (needUMDDynamicImportHelper) {
	        addEmitHelper(body, dynamicImportUMDHelper);
	      }
	      return body;
	    }
	    function addExportEqualsIfNeeded(statements, emitAsReturn) {
	      if (currentModuleInfo.exportEquals) {
	        const expressionResult = visitNode(currentModuleInfo.exportEquals.expression, visitor, isExpression);
	        if (expressionResult) {
	          if (emitAsReturn) {
	            const statement = factory2.createReturnStatement(expressionResult);
	            setTextRange(statement, currentModuleInfo.exportEquals);
	            setEmitFlags(statement, 768 /* NoTokenSourceMaps */ | 3072 /* NoComments */);
	            statements.push(statement);
	          } else {
	            const statement = factory2.createExpressionStatement(
	              factory2.createAssignment(
	                factory2.createPropertyAccessExpression(
	                  factory2.createIdentifier("module"),
	                  "exports"
	                ),
	                expressionResult
	              )
	            );
	            setTextRange(statement, currentModuleInfo.exportEquals);
	            setEmitFlags(statement, 3072 /* NoComments */);
	            statements.push(statement);
	          }
	        }
	      }
	    }
	    function topLevelVisitor(node) {
	      switch (node.kind) {
	        case 272 /* ImportDeclaration */:
	          return visitTopLevelImportDeclaration(node);
	        case 271 /* ImportEqualsDeclaration */:
	          return visitTopLevelImportEqualsDeclaration(node);
	        case 278 /* ExportDeclaration */:
	          return visitTopLevelExportDeclaration(node);
	        case 277 /* ExportAssignment */:
	          return visitTopLevelExportAssignment(node);
	        default:
	          return topLevelNestedVisitor(node);
	      }
	    }
	    function topLevelNestedVisitor(node) {
	      switch (node.kind) {
	        case 243 /* VariableStatement */:
	          return visitVariableStatement(node);
	        case 262 /* FunctionDeclaration */:
	          return visitFunctionDeclaration(node);
	        case 263 /* ClassDeclaration */:
	          return visitClassDeclaration(node);
	        case 248 /* ForStatement */:
	          return visitForStatement(
	            node,
	            /*isTopLevel*/
	            true
	          );
	        case 249 /* ForInStatement */:
	          return visitForInStatement(node);
	        case 250 /* ForOfStatement */:
	          return visitForOfStatement(node);
	        case 246 /* DoStatement */:
	          return visitDoStatement(node);
	        case 247 /* WhileStatement */:
	          return visitWhileStatement(node);
	        case 256 /* LabeledStatement */:
	          return visitLabeledStatement(node);
	        case 254 /* WithStatement */:
	          return visitWithStatement(node);
	        case 245 /* IfStatement */:
	          return visitIfStatement(node);
	        case 255 /* SwitchStatement */:
	          return visitSwitchStatement(node);
	        case 269 /* CaseBlock */:
	          return visitCaseBlock(node);
	        case 296 /* CaseClause */:
	          return visitCaseClause(node);
	        case 297 /* DefaultClause */:
	          return visitDefaultClause(node);
	        case 258 /* TryStatement */:
	          return visitTryStatement(node);
	        case 299 /* CatchClause */:
	          return visitCatchClause(node);
	        case 241 /* Block */:
	          return visitBlock(node);
	        default:
	          return visitor(node);
	      }
	    }
	    function visitorWorker(node, valueIsDiscarded) {
	      if (!(node.transformFlags & (8388608 /* ContainsDynamicImport */ | 4096 /* ContainsDestructuringAssignment */ | 268435456 /* ContainsUpdateExpressionForIdentifier */))) {
	        return node;
	      }
	      switch (node.kind) {
	        case 248 /* ForStatement */:
	          return visitForStatement(
	            node,
	            /*isTopLevel*/
	            false
	          );
	        case 244 /* ExpressionStatement */:
	          return visitExpressionStatement(node);
	        case 217 /* ParenthesizedExpression */:
	          return visitParenthesizedExpression(node, valueIsDiscarded);
	        case 360 /* PartiallyEmittedExpression */:
	          return visitPartiallyEmittedExpression(node, valueIsDiscarded);
	        case 213 /* CallExpression */:
	          if (isImportCall(node) && currentSourceFile.impliedNodeFormat === void 0) {
	            return visitImportCallExpression(node);
	          }
	          break;
	        case 226 /* BinaryExpression */:
	          if (isDestructuringAssignment(node)) {
	            return visitDestructuringAssignment(node, valueIsDiscarded);
	          }
	          break;
	        case 224 /* PrefixUnaryExpression */:
	        case 225 /* PostfixUnaryExpression */:
	          return visitPreOrPostfixUnaryExpression(node, valueIsDiscarded);
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitor(node) {
	      return visitorWorker(
	        node,
	        /*valueIsDiscarded*/
	        false
	      );
	    }
	    function discardedValueVisitor(node) {
	      return visitorWorker(
	        node,
	        /*valueIsDiscarded*/
	        true
	      );
	    }
	    function destructuringNeedsFlattening(node) {
	      if (isObjectLiteralExpression(node)) {
	        for (const elem of node.properties) {
	          switch (elem.kind) {
	            case 303 /* PropertyAssignment */:
	              if (destructuringNeedsFlattening(elem.initializer)) {
	                return true;
	              }
	              break;
	            case 304 /* ShorthandPropertyAssignment */:
	              if (destructuringNeedsFlattening(elem.name)) {
	                return true;
	              }
	              break;
	            case 305 /* SpreadAssignment */:
	              if (destructuringNeedsFlattening(elem.expression)) {
	                return true;
	              }
	              break;
	            case 174 /* MethodDeclaration */:
	            case 177 /* GetAccessor */:
	            case 178 /* SetAccessor */:
	              return false;
	            default:
	              Debug.assertNever(elem, "Unhandled object member kind");
	          }
	        }
	      } else if (isArrayLiteralExpression(node)) {
	        for (const elem of node.elements) {
	          if (isSpreadElement(elem)) {
	            if (destructuringNeedsFlattening(elem.expression)) {
	              return true;
	            }
	          } else if (destructuringNeedsFlattening(elem)) {
	            return true;
	          }
	        }
	      } else if (isIdentifier(node)) {
	        return length(getExports(node)) > (isExportName(node) ? 1 : 0);
	      }
	      return false;
	    }
	    function visitDestructuringAssignment(node, valueIsDiscarded) {
	      if (destructuringNeedsFlattening(node.left)) {
	        return flattenDestructuringAssignment(node, visitor, context, 0 /* All */, !valueIsDiscarded, createAllExportExpressions);
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitForStatement(node, isTopLevel) {
	      if (isTopLevel && node.initializer && isVariableDeclarationList(node.initializer) && !(node.initializer.flags & 7 /* BlockScoped */)) {
	        const exportStatements = appendExportsOfVariableDeclarationList(
	          /*statements*/
	          void 0,
	          node.initializer,
	          /*isForInOrOfInitializer*/
	          false
	        );
	        if (exportStatements) {
	          const statements = [];
	          const varDeclList = visitNode(node.initializer, discardedValueVisitor, isVariableDeclarationList);
	          const varStatement = factory2.createVariableStatement(
	            /*modifiers*/
	            void 0,
	            varDeclList
	          );
	          statements.push(varStatement);
	          addRange(statements, exportStatements);
	          const condition = visitNode(node.condition, visitor, isExpression);
	          const incrementor = visitNode(node.incrementor, discardedValueVisitor, isExpression);
	          const body = visitIterationBody(node.statement, isTopLevel ? topLevelNestedVisitor : visitor, context);
	          statements.push(factory2.updateForStatement(
	            node,
	            /*initializer*/
	            void 0,
	            condition,
	            incrementor,
	            body
	          ));
	          return statements;
	        }
	      }
	      return factory2.updateForStatement(
	        node,
	        visitNode(node.initializer, discardedValueVisitor, isForInitializer),
	        visitNode(node.condition, visitor, isExpression),
	        visitNode(node.incrementor, discardedValueVisitor, isExpression),
	        visitIterationBody(node.statement, isTopLevel ? topLevelNestedVisitor : visitor, context)
	      );
	    }
	    function visitForInStatement(node) {
	      if (isVariableDeclarationList(node.initializer) && !(node.initializer.flags & 7 /* BlockScoped */)) {
	        const exportStatements = appendExportsOfVariableDeclarationList(
	          /*statements*/
	          void 0,
	          node.initializer,
	          /*isForInOrOfInitializer*/
	          true
	        );
	        if (some(exportStatements)) {
	          const initializer = visitNode(node.initializer, discardedValueVisitor, isForInitializer);
	          const expression = visitNode(node.expression, visitor, isExpression);
	          const body = visitIterationBody(node.statement, topLevelNestedVisitor, context);
	          const mergedBody = isBlock(body) ? factory2.updateBlock(body, [...exportStatements, ...body.statements]) : factory2.createBlock(
	            [...exportStatements, body],
	            /*multiLine*/
	            true
	          );
	          return factory2.updateForInStatement(node, initializer, expression, mergedBody);
	        }
	      }
	      return factory2.updateForInStatement(
	        node,
	        visitNode(node.initializer, discardedValueVisitor, isForInitializer),
	        visitNode(node.expression, visitor, isExpression),
	        visitIterationBody(node.statement, topLevelNestedVisitor, context)
	      );
	    }
	    function visitForOfStatement(node) {
	      if (isVariableDeclarationList(node.initializer) && !(node.initializer.flags & 7 /* BlockScoped */)) {
	        const exportStatements = appendExportsOfVariableDeclarationList(
	          /*statements*/
	          void 0,
	          node.initializer,
	          /*isForInOrOfInitializer*/
	          true
	        );
	        const initializer = visitNode(node.initializer, discardedValueVisitor, isForInitializer);
	        const expression = visitNode(node.expression, visitor, isExpression);
	        let body = visitIterationBody(node.statement, topLevelNestedVisitor, context);
	        if (some(exportStatements)) {
	          body = isBlock(body) ? factory2.updateBlock(body, [...exportStatements, ...body.statements]) : factory2.createBlock(
	            [...exportStatements, body],
	            /*multiLine*/
	            true
	          );
	        }
	        return factory2.updateForOfStatement(node, node.awaitModifier, initializer, expression, body);
	      }
	      return factory2.updateForOfStatement(
	        node,
	        node.awaitModifier,
	        visitNode(node.initializer, discardedValueVisitor, isForInitializer),
	        visitNode(node.expression, visitor, isExpression),
	        visitIterationBody(node.statement, topLevelNestedVisitor, context)
	      );
	    }
	    function visitDoStatement(node) {
	      return factory2.updateDoStatement(
	        node,
	        visitIterationBody(node.statement, topLevelNestedVisitor, context),
	        visitNode(node.expression, visitor, isExpression)
	      );
	    }
	    function visitWhileStatement(node) {
	      return factory2.updateWhileStatement(
	        node,
	        visitNode(node.expression, visitor, isExpression),
	        visitIterationBody(node.statement, topLevelNestedVisitor, context)
	      );
	    }
	    function visitLabeledStatement(node) {
	      return factory2.updateLabeledStatement(
	        node,
	        node.label,
	        Debug.checkDefined(visitNode(node.statement, topLevelNestedVisitor, isStatement, factory2.liftToBlock))
	      );
	    }
	    function visitWithStatement(node) {
	      return factory2.updateWithStatement(
	        node,
	        visitNode(node.expression, visitor, isExpression),
	        Debug.checkDefined(visitNode(node.statement, topLevelNestedVisitor, isStatement, factory2.liftToBlock))
	      );
	    }
	    function visitIfStatement(node) {
	      return factory2.updateIfStatement(
	        node,
	        visitNode(node.expression, visitor, isExpression),
	        Debug.checkDefined(visitNode(node.thenStatement, topLevelNestedVisitor, isStatement, factory2.liftToBlock)),
	        visitNode(node.elseStatement, topLevelNestedVisitor, isStatement, factory2.liftToBlock)
	      );
	    }
	    function visitSwitchStatement(node) {
	      return factory2.updateSwitchStatement(
	        node,
	        visitNode(node.expression, visitor, isExpression),
	        Debug.checkDefined(visitNode(node.caseBlock, topLevelNestedVisitor, isCaseBlock))
	      );
	    }
	    function visitCaseBlock(node) {
	      return factory2.updateCaseBlock(
	        node,
	        visitNodes2(node.clauses, topLevelNestedVisitor, isCaseOrDefaultClause)
	      );
	    }
	    function visitCaseClause(node) {
	      return factory2.updateCaseClause(
	        node,
	        visitNode(node.expression, visitor, isExpression),
	        visitNodes2(node.statements, topLevelNestedVisitor, isStatement)
	      );
	    }
	    function visitDefaultClause(node) {
	      return visitEachChild(node, topLevelNestedVisitor, context);
	    }
	    function visitTryStatement(node) {
	      return visitEachChild(node, topLevelNestedVisitor, context);
	    }
	    function visitCatchClause(node) {
	      return factory2.updateCatchClause(
	        node,
	        node.variableDeclaration,
	        Debug.checkDefined(visitNode(node.block, topLevelNestedVisitor, isBlock))
	      );
	    }
	    function visitBlock(node) {
	      node = visitEachChild(node, topLevelNestedVisitor, context);
	      return node;
	    }
	    function visitExpressionStatement(node) {
	      return factory2.updateExpressionStatement(
	        node,
	        visitNode(node.expression, discardedValueVisitor, isExpression)
	      );
	    }
	    function visitParenthesizedExpression(node, valueIsDiscarded) {
	      return factory2.updateParenthesizedExpression(node, visitNode(node.expression, valueIsDiscarded ? discardedValueVisitor : visitor, isExpression));
	    }
	    function visitPartiallyEmittedExpression(node, valueIsDiscarded) {
	      return factory2.updatePartiallyEmittedExpression(node, visitNode(node.expression, valueIsDiscarded ? discardedValueVisitor : visitor, isExpression));
	    }
	    function visitPreOrPostfixUnaryExpression(node, valueIsDiscarded) {
	      if ((node.operator === 46 /* PlusPlusToken */ || node.operator === 47 /* MinusMinusToken */) && isIdentifier(node.operand) && !isGeneratedIdentifier(node.operand) && !isLocalName(node.operand) && !isDeclarationNameOfEnumOrNamespace(node.operand)) {
	        const exportedNames = getExports(node.operand);
	        if (exportedNames) {
	          let temp;
	          let expression = visitNode(node.operand, visitor, isExpression);
	          if (isPrefixUnaryExpression(node)) {
	            expression = factory2.updatePrefixUnaryExpression(node, expression);
	          } else {
	            expression = factory2.updatePostfixUnaryExpression(node, expression);
	            if (!valueIsDiscarded) {
	              temp = factory2.createTempVariable(hoistVariableDeclaration);
	              expression = factory2.createAssignment(temp, expression);
	              setTextRange(expression, node);
	            }
	            expression = factory2.createComma(expression, factory2.cloneNode(node.operand));
	            setTextRange(expression, node);
	          }
	          for (const exportName of exportedNames) {
	            noSubstitution[getNodeId(expression)] = true;
	            expression = createExportExpression(exportName, expression);
	            setTextRange(expression, node);
	          }
	          if (temp) {
	            noSubstitution[getNodeId(expression)] = true;
	            expression = factory2.createComma(expression, temp);
	            setTextRange(expression, node);
	          }
	          return expression;
	        }
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitImportCallExpression(node) {
	      if (moduleKind === 0 /* None */ && languageVersion >= 7 /* ES2020 */) {
	        return visitEachChild(node, visitor, context);
	      }
	      const externalModuleName = getExternalModuleNameLiteral(factory2, node, currentSourceFile, host, resolver, compilerOptions);
	      const firstArgument = visitNode(firstOrUndefined(node.arguments), visitor, isExpression);
	      const argument = externalModuleName && (!firstArgument || !isStringLiteral(firstArgument) || firstArgument.text !== externalModuleName.text) ? externalModuleName : firstArgument;
	      const containsLexicalThis = !!(node.transformFlags & 16384 /* ContainsLexicalThis */);
	      switch (compilerOptions.module) {
	        case 2 /* AMD */:
	          return createImportCallExpressionAMD(argument, containsLexicalThis);
	        case 3 /* UMD */:
	          return createImportCallExpressionUMD(argument ?? factory2.createVoidZero(), containsLexicalThis);
	        case 1 /* CommonJS */:
	        default:
	          return createImportCallExpressionCommonJS(argument);
	      }
	    }
	    function createImportCallExpressionUMD(arg, containsLexicalThis) {
	      needUMDDynamicImportHelper = true;
	      if (isSimpleCopiableExpression(arg)) {
	        const argClone = isGeneratedIdentifier(arg) ? arg : isStringLiteral(arg) ? factory2.createStringLiteralFromNode(arg) : setEmitFlags(setTextRange(factory2.cloneNode(arg), arg), 3072 /* NoComments */);
	        return factory2.createConditionalExpression(
	          /*condition*/
	          factory2.createIdentifier("__syncRequire"),
	          /*questionToken*/
	          void 0,
	          /*whenTrue*/
	          createImportCallExpressionCommonJS(arg),
	          /*colonToken*/
	          void 0,
	          /*whenFalse*/
	          createImportCallExpressionAMD(argClone, containsLexicalThis)
	        );
	      } else {
	        const temp = factory2.createTempVariable(hoistVariableDeclaration);
	        return factory2.createComma(
	          factory2.createAssignment(temp, arg),
	          factory2.createConditionalExpression(
	            /*condition*/
	            factory2.createIdentifier("__syncRequire"),
	            /*questionToken*/
	            void 0,
	            /*whenTrue*/
	            createImportCallExpressionCommonJS(
	              temp,
	              /*isInlineable*/
	              true
	            ),
	            /*colonToken*/
	            void 0,
	            /*whenFalse*/
	            createImportCallExpressionAMD(temp, containsLexicalThis)
	          )
	        );
	      }
	    }
	    function createImportCallExpressionAMD(arg, containsLexicalThis) {
	      const resolve = factory2.createUniqueName("resolve");
	      const reject = factory2.createUniqueName("reject");
	      const parameters = [
	        factory2.createParameterDeclaration(
	          /*modifiers*/
	          void 0,
	          /*dotDotDotToken*/
	          void 0,
	          /*name*/
	          resolve
	        ),
	        factory2.createParameterDeclaration(
	          /*modifiers*/
	          void 0,
	          /*dotDotDotToken*/
	          void 0,
	          /*name*/
	          reject
	        )
	      ];
	      const body = factory2.createBlock([
	        factory2.createExpressionStatement(
	          factory2.createCallExpression(
	            factory2.createIdentifier("require"),
	            /*typeArguments*/
	            void 0,
	            [factory2.createArrayLiteralExpression([arg || factory2.createOmittedExpression()]), resolve, reject]
	          )
	        )
	      ]);
	      let func;
	      if (languageVersion >= 2 /* ES2015 */) {
	        func = factory2.createArrowFunction(
	          /*modifiers*/
	          void 0,
	          /*typeParameters*/
	          void 0,
	          parameters,
	          /*type*/
	          void 0,
	          /*equalsGreaterThanToken*/
	          void 0,
	          body
	        );
	      } else {
	        func = factory2.createFunctionExpression(
	          /*modifiers*/
	          void 0,
	          /*asteriskToken*/
	          void 0,
	          /*name*/
	          void 0,
	          /*typeParameters*/
	          void 0,
	          parameters,
	          /*type*/
	          void 0,
	          body
	        );
	        if (containsLexicalThis) {
	          setEmitFlags(func, 16 /* CapturesThis */);
	        }
	      }
	      const promise = factory2.createNewExpression(
	        factory2.createIdentifier("Promise"),
	        /*typeArguments*/
	        void 0,
	        [func]
	      );
	      if (getESModuleInterop(compilerOptions)) {
	        return factory2.createCallExpression(
	          factory2.createPropertyAccessExpression(promise, factory2.createIdentifier("then")),
	          /*typeArguments*/
	          void 0,
	          [emitHelpers().createImportStarCallbackHelper()]
	        );
	      }
	      return promise;
	    }
	    function createImportCallExpressionCommonJS(arg, isInlineable) {
	      const needSyncEval = arg && !isSimpleInlineableExpression(arg) && !isInlineable;
	      const promiseResolveCall = factory2.createCallExpression(
	        factory2.createPropertyAccessExpression(factory2.createIdentifier("Promise"), "resolve"),
	        /*typeArguments*/
	        void 0,
	        /*argumentsArray*/
	        needSyncEval ? languageVersion >= 2 /* ES2015 */ ? [
	          factory2.createTemplateExpression(factory2.createTemplateHead(""), [
	            factory2.createTemplateSpan(arg, factory2.createTemplateTail(""))
	          ])
	        ] : [
	          factory2.createCallExpression(
	            factory2.createPropertyAccessExpression(factory2.createStringLiteral(""), "concat"),
	            /*typeArguments*/
	            void 0,
	            [arg]
	          )
	        ] : []
	      );
	      let requireCall = factory2.createCallExpression(
	        factory2.createIdentifier("require"),
	        /*typeArguments*/
	        void 0,
	        needSyncEval ? [factory2.createIdentifier("s")] : arg ? [arg] : []
	      );
	      if (getESModuleInterop(compilerOptions)) {
	        requireCall = emitHelpers().createImportStarHelper(requireCall);
	      }
	      const parameters = needSyncEval ? [
	        factory2.createParameterDeclaration(
	          /*modifiers*/
	          void 0,
	          /*dotDotDotToken*/
	          void 0,
	          /*name*/
	          "s"
	        )
	      ] : [];
	      let func;
	      if (languageVersion >= 2 /* ES2015 */) {
	        func = factory2.createArrowFunction(
	          /*modifiers*/
	          void 0,
	          /*typeParameters*/
	          void 0,
	          /*parameters*/
	          parameters,
	          /*type*/
	          void 0,
	          /*equalsGreaterThanToken*/
	          void 0,
	          requireCall
	        );
	      } else {
	        func = factory2.createFunctionExpression(
	          /*modifiers*/
	          void 0,
	          /*asteriskToken*/
	          void 0,
	          /*name*/
	          void 0,
	          /*typeParameters*/
	          void 0,
	          /*parameters*/
	          parameters,
	          /*type*/
	          void 0,
	          factory2.createBlock([factory2.createReturnStatement(requireCall)])
	        );
	      }
	      const downleveledImport = factory2.createCallExpression(
	        factory2.createPropertyAccessExpression(promiseResolveCall, "then"),
	        /*typeArguments*/
	        void 0,
	        [func]
	      );
	      return downleveledImport;
	    }
	    function getHelperExpressionForExport(node, innerExpr) {
	      if (!getESModuleInterop(compilerOptions) || getInternalEmitFlags(node) & 2 /* NeverApplyImportHelper */) {
	        return innerExpr;
	      }
	      if (getExportNeedsImportStarHelper(node)) {
	        return emitHelpers().createImportStarHelper(innerExpr);
	      }
	      return innerExpr;
	    }
	    function getHelperExpressionForImport(node, innerExpr) {
	      if (!getESModuleInterop(compilerOptions) || getInternalEmitFlags(node) & 2 /* NeverApplyImportHelper */) {
	        return innerExpr;
	      }
	      if (getImportNeedsImportStarHelper(node)) {
	        return emitHelpers().createImportStarHelper(innerExpr);
	      }
	      if (getImportNeedsImportDefaultHelper(node)) {
	        return emitHelpers().createImportDefaultHelper(innerExpr);
	      }
	      return innerExpr;
	    }
	    function visitTopLevelImportDeclaration(node) {
	      let statements;
	      const namespaceDeclaration = getNamespaceDeclarationNode(node);
	      if (moduleKind !== 2 /* AMD */) {
	        if (!node.importClause) {
	          return setOriginalNode(setTextRange(factory2.createExpressionStatement(createRequireCall2(node)), node), node);
	        } else {
	          const variables = [];
	          if (namespaceDeclaration && !isDefaultImport(node)) {
	            variables.push(
	              factory2.createVariableDeclaration(
	                factory2.cloneNode(namespaceDeclaration.name),
	                /*exclamationToken*/
	                void 0,
	                /*type*/
	                void 0,
	                getHelperExpressionForImport(node, createRequireCall2(node))
	              )
	            );
	          } else {
	            variables.push(
	              factory2.createVariableDeclaration(
	                factory2.getGeneratedNameForNode(node),
	                /*exclamationToken*/
	                void 0,
	                /*type*/
	                void 0,
	                getHelperExpressionForImport(node, createRequireCall2(node))
	              )
	            );
	            if (namespaceDeclaration && isDefaultImport(node)) {
	              variables.push(
	                factory2.createVariableDeclaration(
	                  factory2.cloneNode(namespaceDeclaration.name),
	                  /*exclamationToken*/
	                  void 0,
	                  /*type*/
	                  void 0,
	                  factory2.getGeneratedNameForNode(node)
	                )
	              );
	            }
	          }
	          statements = append(
	            statements,
	            setOriginalNode(
	              setTextRange(
	                factory2.createVariableStatement(
	                  /*modifiers*/
	                  void 0,
	                  factory2.createVariableDeclarationList(
	                    variables,
	                    languageVersion >= 2 /* ES2015 */ ? 2 /* Const */ : 0 /* None */
	                  )
	                ),
	                /*location*/
	                node
	              ),
	              /*original*/
	              node
	            )
	          );
	        }
	      } else if (namespaceDeclaration && isDefaultImport(node)) {
	        statements = append(
	          statements,
	          factory2.createVariableStatement(
	            /*modifiers*/
	            void 0,
	            factory2.createVariableDeclarationList(
	              [
	                setOriginalNode(
	                  setTextRange(
	                    factory2.createVariableDeclaration(
	                      factory2.cloneNode(namespaceDeclaration.name),
	                      /*exclamationToken*/
	                      void 0,
	                      /*type*/
	                      void 0,
	                      factory2.getGeneratedNameForNode(node)
	                    ),
	                    /*location*/
	                    node
	                  ),
	                  /*original*/
	                  node
	                )
	              ],
	              languageVersion >= 2 /* ES2015 */ ? 2 /* Const */ : 0 /* None */
	            )
	          )
	        );
	      }
	      statements = appendExportsOfImportDeclaration(statements, node);
	      return singleOrMany(statements);
	    }
	    function createRequireCall2(importNode) {
	      const moduleName = getExternalModuleNameLiteral(factory2, importNode, currentSourceFile, host, resolver, compilerOptions);
	      const args = [];
	      if (moduleName) {
	        args.push(moduleName);
	      }
	      return factory2.createCallExpression(
	        factory2.createIdentifier("require"),
	        /*typeArguments*/
	        void 0,
	        args
	      );
	    }
	    function visitTopLevelImportEqualsDeclaration(node) {
	      Debug.assert(isExternalModuleImportEqualsDeclaration(node), "import= for internal module references should be handled in an earlier transformer.");
	      let statements;
	      if (moduleKind !== 2 /* AMD */) {
	        if (hasSyntacticModifier(node, 32 /* Export */)) {
	          statements = append(
	            statements,
	            setOriginalNode(
	              setTextRange(
	                factory2.createExpressionStatement(
	                  createExportExpression(
	                    node.name,
	                    createRequireCall2(node)
	                  )
	                ),
	                node
	              ),
	              node
	            )
	          );
	        } else {
	          statements = append(
	            statements,
	            setOriginalNode(
	              setTextRange(
	                factory2.createVariableStatement(
	                  /*modifiers*/
	                  void 0,
	                  factory2.createVariableDeclarationList(
	                    [
	                      factory2.createVariableDeclaration(
	                        factory2.cloneNode(node.name),
	                        /*exclamationToken*/
	                        void 0,
	                        /*type*/
	                        void 0,
	                        createRequireCall2(node)
	                      )
	                    ],
	                    /*flags*/
	                    languageVersion >= 2 /* ES2015 */ ? 2 /* Const */ : 0 /* None */
	                  )
	                ),
	                node
	              ),
	              node
	            )
	          );
	        }
	      } else {
	        if (hasSyntacticModifier(node, 32 /* Export */)) {
	          statements = append(
	            statements,
	            setOriginalNode(
	              setTextRange(
	                factory2.createExpressionStatement(
	                  createExportExpression(factory2.getExportName(node), factory2.getLocalName(node))
	                ),
	                node
	              ),
	              node
	            )
	          );
	        }
	      }
	      statements = appendExportsOfImportEqualsDeclaration(statements, node);
	      return singleOrMany(statements);
	    }
	    function visitTopLevelExportDeclaration(node) {
	      if (!node.moduleSpecifier) {
	        return void 0;
	      }
	      const generatedName = factory2.getGeneratedNameForNode(node);
	      if (node.exportClause && isNamedExports(node.exportClause)) {
	        const statements = [];
	        if (moduleKind !== 2 /* AMD */) {
	          statements.push(
	            setOriginalNode(
	              setTextRange(
	                factory2.createVariableStatement(
	                  /*modifiers*/
	                  void 0,
	                  factory2.createVariableDeclarationList([
	                    factory2.createVariableDeclaration(
	                      generatedName,
	                      /*exclamationToken*/
	                      void 0,
	                      /*type*/
	                      void 0,
	                      createRequireCall2(node)
	                    )
	                  ])
	                ),
	                /*location*/
	                node
	              ),
	              /* original */
	              node
	            )
	          );
	        }
	        for (const specifier of node.exportClause.elements) {
	          if (languageVersion === 0 /* ES3 */) {
	            statements.push(
	              setOriginalNode(
	                setTextRange(
	                  factory2.createExpressionStatement(
	                    emitHelpers().createCreateBindingHelper(generatedName, factory2.createStringLiteralFromNode(specifier.propertyName || specifier.name), specifier.propertyName ? factory2.createStringLiteralFromNode(specifier.name) : void 0)
	                  ),
	                  specifier
	                ),
	                specifier
	              )
	            );
	          } else {
	            const exportNeedsImportDefault = !!getESModuleInterop(compilerOptions) && !(getInternalEmitFlags(node) & 2 /* NeverApplyImportHelper */) && idText(specifier.propertyName || specifier.name) === "default";
	            const exportedValue = factory2.createPropertyAccessExpression(
	              exportNeedsImportDefault ? emitHelpers().createImportDefaultHelper(generatedName) : generatedName,
	              specifier.propertyName || specifier.name
	            );
	            statements.push(
	              setOriginalNode(
	                setTextRange(
	                  factory2.createExpressionStatement(
	                    createExportExpression(
	                      factory2.getExportName(specifier),
	                      exportedValue,
	                      /*location*/
	                      void 0,
	                      /*liveBinding*/
	                      true
	                    )
	                  ),
	                  specifier
	                ),
	                specifier
	              )
	            );
	          }
	        }
	        return singleOrMany(statements);
	      } else if (node.exportClause) {
	        const statements = [];
	        statements.push(
	          setOriginalNode(
	            setTextRange(
	              factory2.createExpressionStatement(
	                createExportExpression(
	                  factory2.cloneNode(node.exportClause.name),
	                  getHelperExpressionForExport(
	                    node,
	                    moduleKind !== 2 /* AMD */ ? createRequireCall2(node) : isExportNamespaceAsDefaultDeclaration(node) ? generatedName : factory2.createIdentifier(idText(node.exportClause.name))
	                  )
	                )
	              ),
	              node
	            ),
	            node
	          )
	        );
	        return singleOrMany(statements);
	      } else {
	        return setOriginalNode(
	          setTextRange(
	            factory2.createExpressionStatement(
	              emitHelpers().createExportStarHelper(moduleKind !== 2 /* AMD */ ? createRequireCall2(node) : generatedName)
	            ),
	            node
	          ),
	          node
	        );
	      }
	    }
	    function visitTopLevelExportAssignment(node) {
	      if (node.isExportEquals) {
	        return void 0;
	      }
	      return createExportStatement(
	        factory2.createIdentifier("default"),
	        visitNode(node.expression, visitor, isExpression),
	        /*location*/
	        node,
	        /*allowComments*/
	        true
	      );
	    }
	    function visitFunctionDeclaration(node) {
	      let statements;
	      if (hasSyntacticModifier(node, 32 /* Export */)) {
	        statements = append(
	          statements,
	          setOriginalNode(
	            setTextRange(
	              factory2.createFunctionDeclaration(
	                visitNodes2(node.modifiers, modifierVisitor, isModifier),
	                node.asteriskToken,
	                factory2.getDeclarationName(
	                  node,
	                  /*allowComments*/
	                  true,
	                  /*allowSourceMaps*/
	                  true
	                ),
	                /*typeParameters*/
	                void 0,
	                visitNodes2(node.parameters, visitor, isParameter),
	                /*type*/
	                void 0,
	                visitEachChild(node.body, visitor, context)
	              ),
	              /*location*/
	              node
	            ),
	            /*original*/
	            node
	          )
	        );
	      } else {
	        statements = append(statements, visitEachChild(node, visitor, context));
	      }
	      statements = appendExportsOfHoistedDeclaration(statements, node);
	      return singleOrMany(statements);
	    }
	    function visitClassDeclaration(node) {
	      let statements;
	      if (hasSyntacticModifier(node, 32 /* Export */)) {
	        statements = append(
	          statements,
	          setOriginalNode(
	            setTextRange(
	              factory2.createClassDeclaration(
	                visitNodes2(node.modifiers, modifierVisitor, isModifierLike),
	                factory2.getDeclarationName(
	                  node,
	                  /*allowComments*/
	                  true,
	                  /*allowSourceMaps*/
	                  true
	                ),
	                /*typeParameters*/
	                void 0,
	                visitNodes2(node.heritageClauses, visitor, isHeritageClause),
	                visitNodes2(node.members, visitor, isClassElement)
	              ),
	              node
	            ),
	            node
	          )
	        );
	      } else {
	        statements = append(statements, visitEachChild(node, visitor, context));
	      }
	      statements = appendExportsOfHoistedDeclaration(statements, node);
	      return singleOrMany(statements);
	    }
	    function visitVariableStatement(node) {
	      let statements;
	      let variables;
	      let expressions;
	      if (hasSyntacticModifier(node, 32 /* Export */)) {
	        let modifiers;
	        let removeCommentsOnExpressions = false;
	        for (const variable of node.declarationList.declarations) {
	          if (isIdentifier(variable.name) && isLocalName(variable.name)) {
	            if (!modifiers) {
	              modifiers = visitNodes2(node.modifiers, modifierVisitor, isModifier);
	            }
	            if (variable.initializer) {
	              const updatedVariable = factory2.updateVariableDeclaration(
	                variable,
	                variable.name,
	                /*exclamationToken*/
	                void 0,
	                /*type*/
	                void 0,
	                createExportExpression(
	                  variable.name,
	                  visitNode(variable.initializer, visitor, isExpression)
	                )
	              );
	              variables = append(variables, updatedVariable);
	            } else {
	              variables = append(variables, variable);
	            }
	          } else if (variable.initializer) {
	            if (!isBindingPattern(variable.name) && (isArrowFunction(variable.initializer) || isFunctionExpression(variable.initializer) || isClassExpression(variable.initializer))) {
	              const expression = factory2.createAssignment(
	                setTextRange(
	                  factory2.createPropertyAccessExpression(
	                    factory2.createIdentifier("exports"),
	                    variable.name
	                  ),
	                  /*location*/
	                  variable.name
	                ),
	                factory2.createIdentifier(getTextOfIdentifierOrLiteral(variable.name))
	              );
	              const updatedVariable = factory2.createVariableDeclaration(
	                variable.name,
	                variable.exclamationToken,
	                variable.type,
	                visitNode(variable.initializer, visitor, isExpression)
	              );
	              variables = append(variables, updatedVariable);
	              expressions = append(expressions, expression);
	              removeCommentsOnExpressions = true;
	            } else {
	              expressions = append(expressions, transformInitializedVariable(variable));
	            }
	          }
	        }
	        if (variables) {
	          statements = append(statements, factory2.updateVariableStatement(node, modifiers, factory2.updateVariableDeclarationList(node.declarationList, variables)));
	        }
	        if (expressions) {
	          const statement = setOriginalNode(setTextRange(factory2.createExpressionStatement(factory2.inlineExpressions(expressions)), node), node);
	          if (removeCommentsOnExpressions) {
	            removeAllComments(statement);
	          }
	          statements = append(statements, statement);
	        }
	      } else {
	        statements = append(statements, visitEachChild(node, visitor, context));
	      }
	      statements = appendExportsOfVariableStatement(statements, node);
	      return singleOrMany(statements);
	    }
	    function createAllExportExpressions(name, value, location) {
	      const exportedNames = getExports(name);
	      if (exportedNames) {
	        let expression = isExportName(name) ? value : factory2.createAssignment(name, value);
	        for (const exportName of exportedNames) {
	          setEmitFlags(expression, 8 /* NoSubstitution */);
	          expression = createExportExpression(
	            exportName,
	            expression,
	            /*location*/
	            location
	          );
	        }
	        return expression;
	      }
	      return factory2.createAssignment(name, value);
	    }
	    function transformInitializedVariable(node) {
	      if (isBindingPattern(node.name)) {
	        return flattenDestructuringAssignment(
	          visitNode(node, visitor, isInitializedVariable),
	          visitor,
	          context,
	          0 /* All */,
	          /*needsValue*/
	          false,
	          createAllExportExpressions
	        );
	      } else {
	        return factory2.createAssignment(
	          setTextRange(
	            factory2.createPropertyAccessExpression(
	              factory2.createIdentifier("exports"),
	              node.name
	            ),
	            /*location*/
	            node.name
	          ),
	          node.initializer ? visitNode(node.initializer, visitor, isExpression) : factory2.createVoidZero()
	        );
	      }
	    }
	    function appendExportsOfImportDeclaration(statements, decl) {
	      if (currentModuleInfo.exportEquals) {
	        return statements;
	      }
	      const importClause = decl.importClause;
	      if (!importClause) {
	        return statements;
	      }
	      const seen = new IdentifierNameMap();
	      if (importClause.name) {
	        statements = appendExportsOfDeclaration(statements, seen, importClause);
	      }
	      const namedBindings = importClause.namedBindings;
	      if (namedBindings) {
	        switch (namedBindings.kind) {
	          case 274 /* NamespaceImport */:
	            statements = appendExportsOfDeclaration(statements, seen, namedBindings);
	            break;
	          case 275 /* NamedImports */:
	            for (const importBinding of namedBindings.elements) {
	              statements = appendExportsOfDeclaration(
	                statements,
	                seen,
	                importBinding,
	                /*liveBinding*/
	                true
	              );
	            }
	            break;
	        }
	      }
	      return statements;
	    }
	    function appendExportsOfImportEqualsDeclaration(statements, decl) {
	      if (currentModuleInfo.exportEquals) {
	        return statements;
	      }
	      return appendExportsOfDeclaration(statements, new IdentifierNameMap(), decl);
	    }
	    function appendExportsOfVariableStatement(statements, node) {
	      return appendExportsOfVariableDeclarationList(
	        statements,
	        node.declarationList,
	        /*isForInOrOfInitializer*/
	        false
	      );
	    }
	    function appendExportsOfVariableDeclarationList(statements, node, isForInOrOfInitializer) {
	      if (currentModuleInfo.exportEquals) {
	        return statements;
	      }
	      for (const decl of node.declarations) {
	        statements = appendExportsOfBindingElement(statements, decl, isForInOrOfInitializer);
	      }
	      return statements;
	    }
	    function appendExportsOfBindingElement(statements, decl, isForInOrOfInitializer) {
	      if (currentModuleInfo.exportEquals) {
	        return statements;
	      }
	      if (isBindingPattern(decl.name)) {
	        for (const element of decl.name.elements) {
	          if (!isOmittedExpression(element)) {
	            statements = appendExportsOfBindingElement(statements, element, isForInOrOfInitializer);
	          }
	        }
	      } else if (!isGeneratedIdentifier(decl.name) && (!isVariableDeclaration(decl) || decl.initializer || isForInOrOfInitializer)) {
	        statements = appendExportsOfDeclaration(statements, new IdentifierNameMap(), decl);
	      }
	      return statements;
	    }
	    function appendExportsOfHoistedDeclaration(statements, decl) {
	      if (currentModuleInfo.exportEquals) {
	        return statements;
	      }
	      const seen = new IdentifierNameMap();
	      if (hasSyntacticModifier(decl, 32 /* Export */)) {
	        const exportName = hasSyntacticModifier(decl, 2048 /* Default */) ? factory2.createIdentifier("default") : factory2.getDeclarationName(decl);
	        statements = appendExportStatement(
	          statements,
	          seen,
	          exportName,
	          factory2.getLocalName(decl),
	          /*location*/
	          decl
	        );
	      }
	      if (decl.name) {
	        statements = appendExportsOfDeclaration(statements, seen, decl);
	      }
	      return statements;
	    }
	    function appendExportsOfDeclaration(statements, seen, decl, liveBinding) {
	      const name = factory2.getDeclarationName(decl);
	      const exportSpecifiers = currentModuleInfo.exportSpecifiers.get(name);
	      if (exportSpecifiers) {
	        for (const exportSpecifier of exportSpecifiers) {
	          statements = appendExportStatement(
	            statements,
	            seen,
	            exportSpecifier.name,
	            name,
	            /*location*/
	            exportSpecifier.name,
	            /*allowComments*/
	            void 0,
	            liveBinding
	          );
	        }
	      }
	      return statements;
	    }
	    function appendExportStatement(statements, seen, exportName, expression, location, allowComments, liveBinding) {
	      if (!seen.has(exportName)) {
	        seen.set(exportName, true);
	        statements = append(statements, createExportStatement(exportName, expression, location, allowComments, liveBinding));
	      }
	      return statements;
	    }
	    function createUnderscoreUnderscoreESModule() {
	      let statement;
	      if (languageVersion === 0 /* ES3 */) {
	        statement = factory2.createExpressionStatement(
	          createExportExpression(
	            factory2.createIdentifier("__esModule"),
	            factory2.createTrue()
	          )
	        );
	      } else {
	        statement = factory2.createExpressionStatement(
	          factory2.createCallExpression(
	            factory2.createPropertyAccessExpression(factory2.createIdentifier("Object"), "defineProperty"),
	            /*typeArguments*/
	            void 0,
	            [
	              factory2.createIdentifier("exports"),
	              factory2.createStringLiteral("__esModule"),
	              factory2.createObjectLiteralExpression([
	                factory2.createPropertyAssignment("value", factory2.createTrue())
	              ])
	            ]
	          )
	        );
	      }
	      setEmitFlags(statement, 2097152 /* CustomPrologue */);
	      return statement;
	    }
	    function createExportStatement(name, value, location, allowComments, liveBinding) {
	      const statement = setTextRange(factory2.createExpressionStatement(createExportExpression(
	        name,
	        value,
	        /*location*/
	        void 0,
	        liveBinding
	      )), location);
	      startOnNewLine(statement);
	      if (!allowComments) {
	        setEmitFlags(statement, 3072 /* NoComments */);
	      }
	      return statement;
	    }
	    function createExportExpression(name, value, location, liveBinding) {
	      return setTextRange(
	        liveBinding && languageVersion !== 0 /* ES3 */ ? factory2.createCallExpression(
	          factory2.createPropertyAccessExpression(
	            factory2.createIdentifier("Object"),
	            "defineProperty"
	          ),
	          /*typeArguments*/
	          void 0,
	          [
	            factory2.createIdentifier("exports"),
	            factory2.createStringLiteralFromNode(name),
	            factory2.createObjectLiteralExpression([
	              factory2.createPropertyAssignment("enumerable", factory2.createTrue()),
	              factory2.createPropertyAssignment(
	                "get",
	                factory2.createFunctionExpression(
	                  /*modifiers*/
	                  void 0,
	                  /*asteriskToken*/
	                  void 0,
	                  /*name*/
	                  void 0,
	                  /*typeParameters*/
	                  void 0,
	                  /*parameters*/
	                  [],
	                  /*type*/
	                  void 0,
	                  factory2.createBlock([factory2.createReturnStatement(value)])
	                )
	              )
	            ])
	          ]
	        ) : factory2.createAssignment(
	          factory2.createPropertyAccessExpression(
	            factory2.createIdentifier("exports"),
	            factory2.cloneNode(name)
	          ),
	          value
	        ),
	        location
	      );
	    }
	    function modifierVisitor(node) {
	      switch (node.kind) {
	        case 95 /* ExportKeyword */:
	        case 90 /* DefaultKeyword */:
	          return void 0;
	      }
	      return node;
	    }
	    function onEmitNode(hint, node, emitCallback) {
	      if (node.kind === 312 /* SourceFile */) {
	        currentSourceFile = node;
	        currentModuleInfo = moduleInfoMap[getOriginalNodeId(currentSourceFile)];
	        previousOnEmitNode(hint, node, emitCallback);
	        currentSourceFile = void 0;
	        currentModuleInfo = void 0;
	      } else {
	        previousOnEmitNode(hint, node, emitCallback);
	      }
	    }
	    function onSubstituteNode(hint, node) {
	      node = previousOnSubstituteNode(hint, node);
	      if (node.id && noSubstitution[node.id]) {
	        return node;
	      }
	      if (hint === 1 /* Expression */) {
	        return substituteExpression(node);
	      } else if (isShorthandPropertyAssignment(node)) {
	        return substituteShorthandPropertyAssignment(node);
	      }
	      return node;
	    }
	    function substituteShorthandPropertyAssignment(node) {
	      const name = node.name;
	      const exportedOrImportedName = substituteExpressionIdentifier(name);
	      if (exportedOrImportedName !== name) {
	        if (node.objectAssignmentInitializer) {
	          const initializer = factory2.createAssignment(exportedOrImportedName, node.objectAssignmentInitializer);
	          return setTextRange(factory2.createPropertyAssignment(name, initializer), node);
	        }
	        return setTextRange(factory2.createPropertyAssignment(name, exportedOrImportedName), node);
	      }
	      return node;
	    }
	    function substituteExpression(node) {
	      switch (node.kind) {
	        case 80 /* Identifier */:
	          return substituteExpressionIdentifier(node);
	        case 213 /* CallExpression */:
	          return substituteCallExpression(node);
	        case 215 /* TaggedTemplateExpression */:
	          return substituteTaggedTemplateExpression(node);
	        case 226 /* BinaryExpression */:
	          return substituteBinaryExpression(node);
	      }
	      return node;
	    }
	    function substituteCallExpression(node) {
	      if (isIdentifier(node.expression)) {
	        const expression = substituteExpressionIdentifier(node.expression);
	        noSubstitution[getNodeId(expression)] = true;
	        if (!isIdentifier(expression) && !(getEmitFlags(node.expression) & 8192 /* HelperName */)) {
	          return addInternalEmitFlags(
	            factory2.updateCallExpression(
	              node,
	              expression,
	              /*typeArguments*/
	              void 0,
	              node.arguments
	            ),
	            16 /* IndirectCall */
	          );
	        }
	      }
	      return node;
	    }
	    function substituteTaggedTemplateExpression(node) {
	      if (isIdentifier(node.tag)) {
	        const tag = substituteExpressionIdentifier(node.tag);
	        noSubstitution[getNodeId(tag)] = true;
	        if (!isIdentifier(tag) && !(getEmitFlags(node.tag) & 8192 /* HelperName */)) {
	          return addInternalEmitFlags(
	            factory2.updateTaggedTemplateExpression(
	              node,
	              tag,
	              /*typeArguments*/
	              void 0,
	              node.template
	            ),
	            16 /* IndirectCall */
	          );
	        }
	      }
	      return node;
	    }
	    function substituteExpressionIdentifier(node) {
	      var _a, _b;
	      if (getEmitFlags(node) & 8192 /* HelperName */) {
	        const externalHelpersModuleName = getExternalHelpersModuleName(currentSourceFile);
	        if (externalHelpersModuleName) {
	          return factory2.createPropertyAccessExpression(externalHelpersModuleName, node);
	        }
	        return node;
	      } else if (!(isGeneratedIdentifier(node) && !(node.emitNode.autoGenerate.flags & 64 /* AllowNameSubstitution */)) && !isLocalName(node)) {
	        const exportContainer = resolver.getReferencedExportContainer(node, isExportName(node));
	        if (exportContainer && exportContainer.kind === 312 /* SourceFile */) {
	          return setTextRange(
	            factory2.createPropertyAccessExpression(
	              factory2.createIdentifier("exports"),
	              factory2.cloneNode(node)
	            ),
	            /*location*/
	            node
	          );
	        }
	        const importDeclaration = resolver.getReferencedImportDeclaration(node);
	        if (importDeclaration) {
	          if (isImportClause(importDeclaration)) {
	            return setTextRange(
	              factory2.createPropertyAccessExpression(
	                factory2.getGeneratedNameForNode(importDeclaration.parent),
	                factory2.createIdentifier("default")
	              ),
	              /*location*/
	              node
	            );
	          } else if (isImportSpecifier(importDeclaration)) {
	            const name = importDeclaration.propertyName || importDeclaration.name;
	            return setTextRange(
	              factory2.createPropertyAccessExpression(
	                factory2.getGeneratedNameForNode(((_b = (_a = importDeclaration.parent) == null ? void 0 : _a.parent) == null ? void 0 : _b.parent) || importDeclaration),
	                factory2.cloneNode(name)
	              ),
	              /*location*/
	              node
	            );
	          }
	        }
	      }
	      return node;
	    }
	    function substituteBinaryExpression(node) {
	      if (isAssignmentOperator(node.operatorToken.kind) && isIdentifier(node.left) && (!isGeneratedIdentifier(node.left) || isFileLevelReservedGeneratedIdentifier(node.left)) && !isLocalName(node.left)) {
	        const exportedNames = getExports(node.left);
	        if (exportedNames) {
	          let expression = node;
	          for (const exportName of exportedNames) {
	            noSubstitution[getNodeId(expression)] = true;
	            expression = createExportExpression(
	              exportName,
	              expression,
	              /*location*/
	              node
	            );
	          }
	          return expression;
	        }
	      }
	      return node;
	    }
	    function getExports(name) {
	      if (!isGeneratedIdentifier(name)) {
	        const importDeclaration = resolver.getReferencedImportDeclaration(name);
	        if (importDeclaration) {
	          return currentModuleInfo == null ? void 0 : currentModuleInfo.exportedBindings[getOriginalNodeId(importDeclaration)];
	        }
	        const bindingsSet = /* @__PURE__ */ new Set();
	        const declarations = resolver.getReferencedValueDeclarations(name);
	        if (declarations) {
	          for (const declaration of declarations) {
	            const bindings = currentModuleInfo == null ? void 0 : currentModuleInfo.exportedBindings[getOriginalNodeId(declaration)];
	            if (bindings) {
	              for (const binding of bindings) {
	                bindingsSet.add(binding);
	              }
	            }
	          }
	          if (bindingsSet.size) {
	            return arrayFrom(bindingsSet);
	          }
	        }
	      } else if (isFileLevelReservedGeneratedIdentifier(name)) {
	        const exportSpecifiers = currentModuleInfo == null ? void 0 : currentModuleInfo.exportSpecifiers.get(name);
	        if (exportSpecifiers) {
	          const exportedNames = [];
	          for (const exportSpecifier of exportSpecifiers) {
	            exportedNames.push(exportSpecifier.name);
	          }
	          return exportedNames;
	        }
	      }
	    }
	  }
	  var dynamicImportUMDHelper;
	  var init_module = __esm({
	    "src/compiler/transformers/module/module.ts"() {
	      init_ts2();
	      dynamicImportUMDHelper = {
	        name: "typescript:dynamicimport-sync-require",
	        scoped: true,
	        text: `
            var __syncRequire = typeof module === "object" && typeof module.exports === "object";`
	      };
	    }
	  });

	  // src/compiler/transformers/module/system.ts
	  function transformSystemModule(context) {
	    const {
	      factory: factory2,
	      startLexicalEnvironment,
	      endLexicalEnvironment,
	      hoistVariableDeclaration
	    } = context;
	    const compilerOptions = context.getCompilerOptions();
	    const resolver = context.getEmitResolver();
	    const host = context.getEmitHost();
	    const previousOnSubstituteNode = context.onSubstituteNode;
	    const previousOnEmitNode = context.onEmitNode;
	    context.onSubstituteNode = onSubstituteNode;
	    context.onEmitNode = onEmitNode;
	    context.enableSubstitution(80 /* Identifier */);
	    context.enableSubstitution(304 /* ShorthandPropertyAssignment */);
	    context.enableSubstitution(226 /* BinaryExpression */);
	    context.enableSubstitution(236 /* MetaProperty */);
	    context.enableEmitNotification(312 /* SourceFile */);
	    const moduleInfoMap = [];
	    const exportFunctionsMap = [];
	    const noSubstitutionMap = [];
	    const contextObjectMap = [];
	    let currentSourceFile;
	    let moduleInfo;
	    let exportFunction;
	    let contextObject;
	    let hoistedStatements;
	    let enclosingBlockScopedContainer;
	    let noSubstitution;
	    return chainBundle(context, transformSourceFile);
	    function transformSourceFile(node) {
	      if (node.isDeclarationFile || !(isEffectiveExternalModule(node, compilerOptions) || node.transformFlags & 8388608 /* ContainsDynamicImport */)) {
	        return node;
	      }
	      const id = getOriginalNodeId(node);
	      currentSourceFile = node;
	      enclosingBlockScopedContainer = node;
	      moduleInfo = moduleInfoMap[id] = collectExternalModuleInfo(context, node);
	      exportFunction = factory2.createUniqueName("exports");
	      exportFunctionsMap[id] = exportFunction;
	      contextObject = contextObjectMap[id] = factory2.createUniqueName("context");
	      const dependencyGroups = collectDependencyGroups(moduleInfo.externalImports);
	      const moduleBodyBlock = createSystemModuleBody(node, dependencyGroups);
	      const moduleBodyFunction = factory2.createFunctionExpression(
	        /*modifiers*/
	        void 0,
	        /*asteriskToken*/
	        void 0,
	        /*name*/
	        void 0,
	        /*typeParameters*/
	        void 0,
	        [
	          factory2.createParameterDeclaration(
	            /*modifiers*/
	            void 0,
	            /*dotDotDotToken*/
	            void 0,
	            exportFunction
	          ),
	          factory2.createParameterDeclaration(
	            /*modifiers*/
	            void 0,
	            /*dotDotDotToken*/
	            void 0,
	            contextObject
	          )
	        ],
	        /*type*/
	        void 0,
	        moduleBodyBlock
	      );
	      const moduleName = tryGetModuleNameFromFile(factory2, node, host, compilerOptions);
	      const dependencies = factory2.createArrayLiteralExpression(map(dependencyGroups, (dependencyGroup) => dependencyGroup.name));
	      const updated = setEmitFlags(
	        factory2.updateSourceFile(
	          node,
	          setTextRange(
	            factory2.createNodeArray([
	              factory2.createExpressionStatement(
	                factory2.createCallExpression(
	                  factory2.createPropertyAccessExpression(factory2.createIdentifier("System"), "register"),
	                  /*typeArguments*/
	                  void 0,
	                  moduleName ? [moduleName, dependencies, moduleBodyFunction] : [dependencies, moduleBodyFunction]
	                )
	              )
	            ]),
	            node.statements
	          )
	        ),
	        2048 /* NoTrailingComments */
	      );
	      if (!outFile(compilerOptions)) {
	        moveEmitHelpers(updated, moduleBodyBlock, (helper) => !helper.scoped);
	      }
	      if (noSubstitution) {
	        noSubstitutionMap[id] = noSubstitution;
	        noSubstitution = void 0;
	      }
	      currentSourceFile = void 0;
	      moduleInfo = void 0;
	      exportFunction = void 0;
	      contextObject = void 0;
	      hoistedStatements = void 0;
	      enclosingBlockScopedContainer = void 0;
	      return updated;
	    }
	    function collectDependencyGroups(externalImports) {
	      const groupIndices = /* @__PURE__ */ new Map();
	      const dependencyGroups = [];
	      for (const externalImport of externalImports) {
	        const externalModuleName = getExternalModuleNameLiteral(factory2, externalImport, currentSourceFile, host, resolver, compilerOptions);
	        if (externalModuleName) {
	          const text = externalModuleName.text;
	          const groupIndex = groupIndices.get(text);
	          if (groupIndex !== void 0) {
	            dependencyGroups[groupIndex].externalImports.push(externalImport);
	          } else {
	            groupIndices.set(text, dependencyGroups.length);
	            dependencyGroups.push({
	              name: externalModuleName,
	              externalImports: [externalImport]
	            });
	          }
	        }
	      }
	      return dependencyGroups;
	    }
	    function createSystemModuleBody(node, dependencyGroups) {
	      const statements = [];
	      startLexicalEnvironment();
	      const ensureUseStrict = getStrictOptionValue(compilerOptions, "alwaysStrict") || !compilerOptions.noImplicitUseStrict && isExternalModule(currentSourceFile);
	      const statementOffset = factory2.copyPrologue(node.statements, statements, ensureUseStrict, topLevelVisitor);
	      statements.push(
	        factory2.createVariableStatement(
	          /*modifiers*/
	          void 0,
	          factory2.createVariableDeclarationList([
	            factory2.createVariableDeclaration(
	              "__moduleName",
	              /*exclamationToken*/
	              void 0,
	              /*type*/
	              void 0,
	              factory2.createLogicalAnd(
	                contextObject,
	                factory2.createPropertyAccessExpression(contextObject, "id")
	              )
	            )
	          ])
	        )
	      );
	      visitNode(moduleInfo.externalHelpersImportDeclaration, topLevelVisitor, isStatement);
	      const executeStatements = visitNodes2(node.statements, topLevelVisitor, isStatement, statementOffset);
	      addRange(statements, hoistedStatements);
	      insertStatementsAfterStandardPrologue(statements, endLexicalEnvironment());
	      const exportStarFunction = addExportStarIfNeeded(statements);
	      const modifiers = node.transformFlags & 2097152 /* ContainsAwait */ ? factory2.createModifiersFromModifierFlags(1024 /* Async */) : void 0;
	      const moduleObject = factory2.createObjectLiteralExpression(
	        [
	          factory2.createPropertyAssignment("setters", createSettersArray(exportStarFunction, dependencyGroups)),
	          factory2.createPropertyAssignment(
	            "execute",
	            factory2.createFunctionExpression(
	              modifiers,
	              /*asteriskToken*/
	              void 0,
	              /*name*/
	              void 0,
	              /*typeParameters*/
	              void 0,
	              /*parameters*/
	              [],
	              /*type*/
	              void 0,
	              factory2.createBlock(
	                executeStatements,
	                /*multiLine*/
	                true
	              )
	            )
	          )
	        ],
	        /*multiLine*/
	        true
	      );
	      statements.push(factory2.createReturnStatement(moduleObject));
	      return factory2.createBlock(
	        statements,
	        /*multiLine*/
	        true
	      );
	    }
	    function addExportStarIfNeeded(statements) {
	      if (!moduleInfo.hasExportStarsToExportValues) {
	        return;
	      }
	      if (!moduleInfo.exportedNames && moduleInfo.exportSpecifiers.size === 0) {
	        let hasExportDeclarationWithExportClause = false;
	        for (const externalImport of moduleInfo.externalImports) {
	          if (externalImport.kind === 278 /* ExportDeclaration */ && externalImport.exportClause) {
	            hasExportDeclarationWithExportClause = true;
	            break;
	          }
	        }
	        if (!hasExportDeclarationWithExportClause) {
	          const exportStarFunction2 = createExportStarFunction(
	            /*localNames*/
	            void 0
	          );
	          statements.push(exportStarFunction2);
	          return exportStarFunction2.name;
	        }
	      }
	      const exportedNames = [];
	      if (moduleInfo.exportedNames) {
	        for (const exportedLocalName of moduleInfo.exportedNames) {
	          if (exportedLocalName.escapedText === "default") {
	            continue;
	          }
	          exportedNames.push(
	            factory2.createPropertyAssignment(
	              factory2.createStringLiteralFromNode(exportedLocalName),
	              factory2.createTrue()
	            )
	          );
	        }
	      }
	      const exportedNamesStorageRef = factory2.createUniqueName("exportedNames");
	      statements.push(
	        factory2.createVariableStatement(
	          /*modifiers*/
	          void 0,
	          factory2.createVariableDeclarationList([
	            factory2.createVariableDeclaration(
	              exportedNamesStorageRef,
	              /*exclamationToken*/
	              void 0,
	              /*type*/
	              void 0,
	              factory2.createObjectLiteralExpression(
	                exportedNames,
	                /*multiLine*/
	                true
	              )
	            )
	          ])
	        )
	      );
	      const exportStarFunction = createExportStarFunction(exportedNamesStorageRef);
	      statements.push(exportStarFunction);
	      return exportStarFunction.name;
	    }
	    function createExportStarFunction(localNames) {
	      const exportStarFunction = factory2.createUniqueName("exportStar");
	      const m = factory2.createIdentifier("m");
	      const n = factory2.createIdentifier("n");
	      const exports = factory2.createIdentifier("exports");
	      let condition = factory2.createStrictInequality(n, factory2.createStringLiteral("default"));
	      if (localNames) {
	        condition = factory2.createLogicalAnd(
	          condition,
	          factory2.createLogicalNot(
	            factory2.createCallExpression(
	              factory2.createPropertyAccessExpression(localNames, "hasOwnProperty"),
	              /*typeArguments*/
	              void 0,
	              [n]
	            )
	          )
	        );
	      }
	      return factory2.createFunctionDeclaration(
	        /*modifiers*/
	        void 0,
	        /*asteriskToken*/
	        void 0,
	        exportStarFunction,
	        /*typeParameters*/
	        void 0,
	        [factory2.createParameterDeclaration(
	          /*modifiers*/
	          void 0,
	          /*dotDotDotToken*/
	          void 0,
	          m
	        )],
	        /*type*/
	        void 0,
	        factory2.createBlock(
	          [
	            factory2.createVariableStatement(
	              /*modifiers*/
	              void 0,
	              factory2.createVariableDeclarationList([
	                factory2.createVariableDeclaration(
	                  exports,
	                  /*exclamationToken*/
	                  void 0,
	                  /*type*/
	                  void 0,
	                  factory2.createObjectLiteralExpression([])
	                )
	              ])
	            ),
	            factory2.createForInStatement(
	              factory2.createVariableDeclarationList([
	                factory2.createVariableDeclaration(n)
	              ]),
	              m,
	              factory2.createBlock([
	                setEmitFlags(
	                  factory2.createIfStatement(
	                    condition,
	                    factory2.createExpressionStatement(
	                      factory2.createAssignment(
	                        factory2.createElementAccessExpression(exports, n),
	                        factory2.createElementAccessExpression(m, n)
	                      )
	                    )
	                  ),
	                  1 /* SingleLine */
	                )
	              ])
	            ),
	            factory2.createExpressionStatement(
	              factory2.createCallExpression(
	                exportFunction,
	                /*typeArguments*/
	                void 0,
	                [exports]
	              )
	            )
	          ],
	          /*multiLine*/
	          true
	        )
	      );
	    }
	    function createSettersArray(exportStarFunction, dependencyGroups) {
	      const setters = [];
	      for (const group2 of dependencyGroups) {
	        const localName = forEach(group2.externalImports, (i) => getLocalNameForExternalImport(factory2, i, currentSourceFile));
	        const parameterName = localName ? factory2.getGeneratedNameForNode(localName) : factory2.createUniqueName("");
	        const statements = [];
	        for (const entry of group2.externalImports) {
	          const importVariableName = getLocalNameForExternalImport(factory2, entry, currentSourceFile);
	          switch (entry.kind) {
	            case 272 /* ImportDeclaration */:
	              if (!entry.importClause) {
	                break;
	              }
	            case 271 /* ImportEqualsDeclaration */:
	              Debug.assert(importVariableName !== void 0);
	              statements.push(
	                factory2.createExpressionStatement(
	                  factory2.createAssignment(importVariableName, parameterName)
	                )
	              );
	              if (hasSyntacticModifier(entry, 32 /* Export */)) {
	                statements.push(
	                  factory2.createExpressionStatement(
	                    factory2.createCallExpression(
	                      exportFunction,
	                      /*typeArguments*/
	                      void 0,
	                      [
	                        factory2.createStringLiteral(idText(importVariableName)),
	                        parameterName
	                      ]
	                    )
	                  )
	                );
	              }
	              break;
	            case 278 /* ExportDeclaration */:
	              Debug.assert(importVariableName !== void 0);
	              if (entry.exportClause) {
	                if (isNamedExports(entry.exportClause)) {
	                  const properties = [];
	                  for (const e of entry.exportClause.elements) {
	                    properties.push(
	                      factory2.createPropertyAssignment(
	                        factory2.createStringLiteral(idText(e.name)),
	                        factory2.createElementAccessExpression(
	                          parameterName,
	                          factory2.createStringLiteral(idText(e.propertyName || e.name))
	                        )
	                      )
	                    );
	                  }
	                  statements.push(
	                    factory2.createExpressionStatement(
	                      factory2.createCallExpression(
	                        exportFunction,
	                        /*typeArguments*/
	                        void 0,
	                        [factory2.createObjectLiteralExpression(
	                          properties,
	                          /*multiLine*/
	                          true
	                        )]
	                      )
	                    )
	                  );
	                } else {
	                  statements.push(
	                    factory2.createExpressionStatement(
	                      factory2.createCallExpression(
	                        exportFunction,
	                        /*typeArguments*/
	                        void 0,
	                        [
	                          factory2.createStringLiteral(idText(entry.exportClause.name)),
	                          parameterName
	                        ]
	                      )
	                    )
	                  );
	                }
	              } else {
	                statements.push(
	                  factory2.createExpressionStatement(
	                    factory2.createCallExpression(
	                      exportStarFunction,
	                      /*typeArguments*/
	                      void 0,
	                      [parameterName]
	                    )
	                  )
	                );
	              }
	              break;
	          }
	        }
	        setters.push(
	          factory2.createFunctionExpression(
	            /*modifiers*/
	            void 0,
	            /*asteriskToken*/
	            void 0,
	            /*name*/
	            void 0,
	            /*typeParameters*/
	            void 0,
	            [factory2.createParameterDeclaration(
	              /*modifiers*/
	              void 0,
	              /*dotDotDotToken*/
	              void 0,
	              parameterName
	            )],
	            /*type*/
	            void 0,
	            factory2.createBlock(
	              statements,
	              /*multiLine*/
	              true
	            )
	          )
	        );
	      }
	      return factory2.createArrayLiteralExpression(
	        setters,
	        /*multiLine*/
	        true
	      );
	    }
	    function topLevelVisitor(node) {
	      switch (node.kind) {
	        case 272 /* ImportDeclaration */:
	          return visitImportDeclaration(node);
	        case 271 /* ImportEqualsDeclaration */:
	          return visitImportEqualsDeclaration(node);
	        case 278 /* ExportDeclaration */:
	          return visitExportDeclaration(node);
	        case 277 /* ExportAssignment */:
	          return visitExportAssignment(node);
	        default:
	          return topLevelNestedVisitor(node);
	      }
	    }
	    function visitImportDeclaration(node) {
	      let statements;
	      if (node.importClause) {
	        hoistVariableDeclaration(getLocalNameForExternalImport(factory2, node, currentSourceFile));
	      }
	      return singleOrMany(appendExportsOfImportDeclaration(statements, node));
	    }
	    function visitExportDeclaration(node) {
	      Debug.assertIsDefined(node);
	      return void 0;
	    }
	    function visitImportEqualsDeclaration(node) {
	      Debug.assert(isExternalModuleImportEqualsDeclaration(node), "import= for internal module references should be handled in an earlier transformer.");
	      let statements;
	      hoistVariableDeclaration(getLocalNameForExternalImport(factory2, node, currentSourceFile));
	      return singleOrMany(appendExportsOfImportEqualsDeclaration(statements, node));
	    }
	    function visitExportAssignment(node) {
	      if (node.isExportEquals) {
	        return void 0;
	      }
	      const expression = visitNode(node.expression, visitor, isExpression);
	      return createExportStatement(
	        factory2.createIdentifier("default"),
	        expression,
	        /*allowComments*/
	        true
	      );
	    }
	    function visitFunctionDeclaration(node) {
	      if (hasSyntacticModifier(node, 32 /* Export */)) {
	        hoistedStatements = append(
	          hoistedStatements,
	          factory2.updateFunctionDeclaration(
	            node,
	            visitNodes2(node.modifiers, modifierVisitor, isModifierLike),
	            node.asteriskToken,
	            factory2.getDeclarationName(
	              node,
	              /*allowComments*/
	              true,
	              /*allowSourceMaps*/
	              true
	            ),
	            /*typeParameters*/
	            void 0,
	            visitNodes2(node.parameters, visitor, isParameter),
	            /*type*/
	            void 0,
	            visitNode(node.body, visitor, isBlock)
	          )
	        );
	      } else {
	        hoistedStatements = append(hoistedStatements, visitEachChild(node, visitor, context));
	      }
	      hoistedStatements = appendExportsOfHoistedDeclaration(hoistedStatements, node);
	      return void 0;
	    }
	    function visitClassDeclaration(node) {
	      let statements;
	      const name = factory2.getLocalName(node);
	      hoistVariableDeclaration(name);
	      statements = append(
	        statements,
	        setTextRange(
	          factory2.createExpressionStatement(
	            factory2.createAssignment(
	              name,
	              setTextRange(
	                factory2.createClassExpression(
	                  visitNodes2(node.modifiers, modifierVisitor, isModifierLike),
	                  node.name,
	                  /*typeParameters*/
	                  void 0,
	                  visitNodes2(node.heritageClauses, visitor, isHeritageClause),
	                  visitNodes2(node.members, visitor, isClassElement)
	                ),
	                node
	              )
	            )
	          ),
	          node
	        )
	      );
	      statements = appendExportsOfHoistedDeclaration(statements, node);
	      return singleOrMany(statements);
	    }
	    function visitVariableStatement(node) {
	      if (!shouldHoistVariableDeclarationList(node.declarationList)) {
	        return visitNode(node, visitor, isStatement);
	      }
	      let statements;
	      if (isVarUsing(node.declarationList) || isVarAwaitUsing(node.declarationList)) {
	        const modifiers = visitNodes2(node.modifiers, modifierVisitor, isModifierLike);
	        const declarations = [];
	        for (const variable of node.declarationList.declarations) {
	          declarations.push(factory2.updateVariableDeclaration(
	            variable,
	            factory2.getGeneratedNameForNode(variable.name),
	            /*exclamationToken*/
	            void 0,
	            /*type*/
	            void 0,
	            transformInitializedVariable(
	              variable,
	              /*isExportedDeclaration*/
	              false
	            )
	          ));
	        }
	        const declarationList = factory2.updateVariableDeclarationList(
	          node.declarationList,
	          declarations
	        );
	        statements = append(statements, factory2.updateVariableStatement(node, modifiers, declarationList));
	      } else {
	        let expressions;
	        const isExportedDeclaration = hasSyntacticModifier(node, 32 /* Export */);
	        for (const variable of node.declarationList.declarations) {
	          if (variable.initializer) {
	            expressions = append(expressions, transformInitializedVariable(variable, isExportedDeclaration));
	          } else {
	            hoistBindingElement(variable);
	          }
	        }
	        if (expressions) {
	          statements = append(statements, setTextRange(factory2.createExpressionStatement(factory2.inlineExpressions(expressions)), node));
	        }
	      }
	      statements = appendExportsOfVariableStatement(
	        statements,
	        node,
	        /*exportSelf*/
	        false
	      );
	      return singleOrMany(statements);
	    }
	    function hoistBindingElement(node) {
	      if (isBindingPattern(node.name)) {
	        for (const element of node.name.elements) {
	          if (!isOmittedExpression(element)) {
	            hoistBindingElement(element);
	          }
	        }
	      } else {
	        hoistVariableDeclaration(factory2.cloneNode(node.name));
	      }
	    }
	    function shouldHoistVariableDeclarationList(node) {
	      return (getEmitFlags(node) & 4194304 /* NoHoisting */) === 0 && (enclosingBlockScopedContainer.kind === 312 /* SourceFile */ || (getOriginalNode(node).flags & 7 /* BlockScoped */) === 0);
	    }
	    function transformInitializedVariable(node, isExportedDeclaration) {
	      const createAssignment = isExportedDeclaration ? createExportedVariableAssignment : createNonExportedVariableAssignment;
	      return isBindingPattern(node.name) ? flattenDestructuringAssignment(
	        node,
	        visitor,
	        context,
	        0 /* All */,
	        /*needsValue*/
	        false,
	        createAssignment
	      ) : node.initializer ? createAssignment(node.name, visitNode(node.initializer, visitor, isExpression)) : node.name;
	    }
	    function createExportedVariableAssignment(name, value, location) {
	      return createVariableAssignment(
	        name,
	        value,
	        location,
	        /*isExportedDeclaration*/
	        true
	      );
	    }
	    function createNonExportedVariableAssignment(name, value, location) {
	      return createVariableAssignment(
	        name,
	        value,
	        location,
	        /*isExportedDeclaration*/
	        false
	      );
	    }
	    function createVariableAssignment(name, value, location, isExportedDeclaration) {
	      hoistVariableDeclaration(factory2.cloneNode(name));
	      return isExportedDeclaration ? createExportExpression(name, preventSubstitution(setTextRange(factory2.createAssignment(name, value), location))) : preventSubstitution(setTextRange(factory2.createAssignment(name, value), location));
	    }
	    function appendExportsOfImportDeclaration(statements, decl) {
	      if (moduleInfo.exportEquals) {
	        return statements;
	      }
	      const importClause = decl.importClause;
	      if (!importClause) {
	        return statements;
	      }
	      if (importClause.name) {
	        statements = appendExportsOfDeclaration(statements, importClause);
	      }
	      const namedBindings = importClause.namedBindings;
	      if (namedBindings) {
	        switch (namedBindings.kind) {
	          case 274 /* NamespaceImport */:
	            statements = appendExportsOfDeclaration(statements, namedBindings);
	            break;
	          case 275 /* NamedImports */:
	            for (const importBinding of namedBindings.elements) {
	              statements = appendExportsOfDeclaration(statements, importBinding);
	            }
	            break;
	        }
	      }
	      return statements;
	    }
	    function appendExportsOfImportEqualsDeclaration(statements, decl) {
	      if (moduleInfo.exportEquals) {
	        return statements;
	      }
	      return appendExportsOfDeclaration(statements, decl);
	    }
	    function appendExportsOfVariableStatement(statements, node, exportSelf) {
	      if (moduleInfo.exportEquals) {
	        return statements;
	      }
	      for (const decl of node.declarationList.declarations) {
	        if (decl.initializer || exportSelf) {
	          statements = appendExportsOfBindingElement(statements, decl, exportSelf);
	        }
	      }
	      return statements;
	    }
	    function appendExportsOfBindingElement(statements, decl, exportSelf) {
	      if (moduleInfo.exportEquals) {
	        return statements;
	      }
	      if (isBindingPattern(decl.name)) {
	        for (const element of decl.name.elements) {
	          if (!isOmittedExpression(element)) {
	            statements = appendExportsOfBindingElement(statements, element, exportSelf);
	          }
	        }
	      } else if (!isGeneratedIdentifier(decl.name)) {
	        let excludeName;
	        if (exportSelf) {
	          statements = appendExportStatement(statements, decl.name, factory2.getLocalName(decl));
	          excludeName = idText(decl.name);
	        }
	        statements = appendExportsOfDeclaration(statements, decl, excludeName);
	      }
	      return statements;
	    }
	    function appendExportsOfHoistedDeclaration(statements, decl) {
	      if (moduleInfo.exportEquals) {
	        return statements;
	      }
	      let excludeName;
	      if (hasSyntacticModifier(decl, 32 /* Export */)) {
	        const exportName = hasSyntacticModifier(decl, 2048 /* Default */) ? factory2.createStringLiteral("default") : decl.name;
	        statements = appendExportStatement(statements, exportName, factory2.getLocalName(decl));
	        excludeName = getTextOfIdentifierOrLiteral(exportName);
	      }
	      if (decl.name) {
	        statements = appendExportsOfDeclaration(statements, decl, excludeName);
	      }
	      return statements;
	    }
	    function appendExportsOfDeclaration(statements, decl, excludeName) {
	      if (moduleInfo.exportEquals) {
	        return statements;
	      }
	      const name = factory2.getDeclarationName(decl);
	      const exportSpecifiers = moduleInfo.exportSpecifiers.get(name);
	      if (exportSpecifiers) {
	        for (const exportSpecifier of exportSpecifiers) {
	          if (exportSpecifier.name.escapedText !== excludeName) {
	            statements = appendExportStatement(statements, exportSpecifier.name, name);
	          }
	        }
	      }
	      return statements;
	    }
	    function appendExportStatement(statements, exportName, expression, allowComments) {
	      statements = append(statements, createExportStatement(exportName, expression, allowComments));
	      return statements;
	    }
	    function createExportStatement(name, value, allowComments) {
	      const statement = factory2.createExpressionStatement(createExportExpression(name, value));
	      startOnNewLine(statement);
	      if (!allowComments) {
	        setEmitFlags(statement, 3072 /* NoComments */);
	      }
	      return statement;
	    }
	    function createExportExpression(name, value) {
	      const exportName = isIdentifier(name) ? factory2.createStringLiteralFromNode(name) : name;
	      setEmitFlags(value, getEmitFlags(value) | 3072 /* NoComments */);
	      return setCommentRange(factory2.createCallExpression(
	        exportFunction,
	        /*typeArguments*/
	        void 0,
	        [exportName, value]
	      ), value);
	    }
	    function topLevelNestedVisitor(node) {
	      switch (node.kind) {
	        case 243 /* VariableStatement */:
	          return visitVariableStatement(node);
	        case 262 /* FunctionDeclaration */:
	          return visitFunctionDeclaration(node);
	        case 263 /* ClassDeclaration */:
	          return visitClassDeclaration(node);
	        case 248 /* ForStatement */:
	          return visitForStatement(
	            node,
	            /*isTopLevel*/
	            true
	          );
	        case 249 /* ForInStatement */:
	          return visitForInStatement(node);
	        case 250 /* ForOfStatement */:
	          return visitForOfStatement(node);
	        case 246 /* DoStatement */:
	          return visitDoStatement(node);
	        case 247 /* WhileStatement */:
	          return visitWhileStatement(node);
	        case 256 /* LabeledStatement */:
	          return visitLabeledStatement(node);
	        case 254 /* WithStatement */:
	          return visitWithStatement(node);
	        case 245 /* IfStatement */:
	          return visitIfStatement(node);
	        case 255 /* SwitchStatement */:
	          return visitSwitchStatement(node);
	        case 269 /* CaseBlock */:
	          return visitCaseBlock(node);
	        case 296 /* CaseClause */:
	          return visitCaseClause(node);
	        case 297 /* DefaultClause */:
	          return visitDefaultClause(node);
	        case 258 /* TryStatement */:
	          return visitTryStatement(node);
	        case 299 /* CatchClause */:
	          return visitCatchClause(node);
	        case 241 /* Block */:
	          return visitBlock(node);
	        default:
	          return visitor(node);
	      }
	    }
	    function visitForStatement(node, isTopLevel) {
	      const savedEnclosingBlockScopedContainer = enclosingBlockScopedContainer;
	      enclosingBlockScopedContainer = node;
	      node = factory2.updateForStatement(
	        node,
	        visitNode(node.initializer, isTopLevel ? visitForInitializer : discardedValueVisitor, isForInitializer),
	        visitNode(node.condition, visitor, isExpression),
	        visitNode(node.incrementor, discardedValueVisitor, isExpression),
	        visitIterationBody(node.statement, isTopLevel ? topLevelNestedVisitor : visitor, context)
	      );
	      enclosingBlockScopedContainer = savedEnclosingBlockScopedContainer;
	      return node;
	    }
	    function visitForInStatement(node) {
	      const savedEnclosingBlockScopedContainer = enclosingBlockScopedContainer;
	      enclosingBlockScopedContainer = node;
	      node = factory2.updateForInStatement(
	        node,
	        visitForInitializer(node.initializer),
	        visitNode(node.expression, visitor, isExpression),
	        visitIterationBody(node.statement, topLevelNestedVisitor, context)
	      );
	      enclosingBlockScopedContainer = savedEnclosingBlockScopedContainer;
	      return node;
	    }
	    function visitForOfStatement(node) {
	      const savedEnclosingBlockScopedContainer = enclosingBlockScopedContainer;
	      enclosingBlockScopedContainer = node;
	      node = factory2.updateForOfStatement(
	        node,
	        node.awaitModifier,
	        visitForInitializer(node.initializer),
	        visitNode(node.expression, visitor, isExpression),
	        visitIterationBody(node.statement, topLevelNestedVisitor, context)
	      );
	      enclosingBlockScopedContainer = savedEnclosingBlockScopedContainer;
	      return node;
	    }
	    function shouldHoistForInitializer(node) {
	      return isVariableDeclarationList(node) && shouldHoistVariableDeclarationList(node);
	    }
	    function visitForInitializer(node) {
	      if (shouldHoistForInitializer(node)) {
	        let expressions;
	        for (const variable of node.declarations) {
	          expressions = append(expressions, transformInitializedVariable(
	            variable,
	            /*isExportedDeclaration*/
	            false
	          ));
	          if (!variable.initializer) {
	            hoistBindingElement(variable);
	          }
	        }
	        return expressions ? factory2.inlineExpressions(expressions) : factory2.createOmittedExpression();
	      } else {
	        return visitNode(node, discardedValueVisitor, isForInitializer);
	      }
	    }
	    function visitDoStatement(node) {
	      return factory2.updateDoStatement(
	        node,
	        visitIterationBody(node.statement, topLevelNestedVisitor, context),
	        visitNode(node.expression, visitor, isExpression)
	      );
	    }
	    function visitWhileStatement(node) {
	      return factory2.updateWhileStatement(
	        node,
	        visitNode(node.expression, visitor, isExpression),
	        visitIterationBody(node.statement, topLevelNestedVisitor, context)
	      );
	    }
	    function visitLabeledStatement(node) {
	      return factory2.updateLabeledStatement(
	        node,
	        node.label,
	        Debug.checkDefined(visitNode(node.statement, topLevelNestedVisitor, isStatement, factory2.liftToBlock))
	      );
	    }
	    function visitWithStatement(node) {
	      return factory2.updateWithStatement(
	        node,
	        visitNode(node.expression, visitor, isExpression),
	        Debug.checkDefined(visitNode(node.statement, topLevelNestedVisitor, isStatement, factory2.liftToBlock))
	      );
	    }
	    function visitIfStatement(node) {
	      return factory2.updateIfStatement(
	        node,
	        visitNode(node.expression, visitor, isExpression),
	        Debug.checkDefined(visitNode(node.thenStatement, topLevelNestedVisitor, isStatement, factory2.liftToBlock)),
	        visitNode(node.elseStatement, topLevelNestedVisitor, isStatement, factory2.liftToBlock)
	      );
	    }
	    function visitSwitchStatement(node) {
	      return factory2.updateSwitchStatement(
	        node,
	        visitNode(node.expression, visitor, isExpression),
	        Debug.checkDefined(visitNode(node.caseBlock, topLevelNestedVisitor, isCaseBlock))
	      );
	    }
	    function visitCaseBlock(node) {
	      const savedEnclosingBlockScopedContainer = enclosingBlockScopedContainer;
	      enclosingBlockScopedContainer = node;
	      node = factory2.updateCaseBlock(
	        node,
	        visitNodes2(node.clauses, topLevelNestedVisitor, isCaseOrDefaultClause)
	      );
	      enclosingBlockScopedContainer = savedEnclosingBlockScopedContainer;
	      return node;
	    }
	    function visitCaseClause(node) {
	      return factory2.updateCaseClause(
	        node,
	        visitNode(node.expression, visitor, isExpression),
	        visitNodes2(node.statements, topLevelNestedVisitor, isStatement)
	      );
	    }
	    function visitDefaultClause(node) {
	      return visitEachChild(node, topLevelNestedVisitor, context);
	    }
	    function visitTryStatement(node) {
	      return visitEachChild(node, topLevelNestedVisitor, context);
	    }
	    function visitCatchClause(node) {
	      const savedEnclosingBlockScopedContainer = enclosingBlockScopedContainer;
	      enclosingBlockScopedContainer = node;
	      node = factory2.updateCatchClause(
	        node,
	        node.variableDeclaration,
	        Debug.checkDefined(visitNode(node.block, topLevelNestedVisitor, isBlock))
	      );
	      enclosingBlockScopedContainer = savedEnclosingBlockScopedContainer;
	      return node;
	    }
	    function visitBlock(node) {
	      const savedEnclosingBlockScopedContainer = enclosingBlockScopedContainer;
	      enclosingBlockScopedContainer = node;
	      node = visitEachChild(node, topLevelNestedVisitor, context);
	      enclosingBlockScopedContainer = savedEnclosingBlockScopedContainer;
	      return node;
	    }
	    function visitorWorker(node, valueIsDiscarded) {
	      if (!(node.transformFlags & (4096 /* ContainsDestructuringAssignment */ | 8388608 /* ContainsDynamicImport */ | 268435456 /* ContainsUpdateExpressionForIdentifier */))) {
	        return node;
	      }
	      switch (node.kind) {
	        case 248 /* ForStatement */:
	          return visitForStatement(
	            node,
	            /*isTopLevel*/
	            false
	          );
	        case 244 /* ExpressionStatement */:
	          return visitExpressionStatement(node);
	        case 217 /* ParenthesizedExpression */:
	          return visitParenthesizedExpression(node, valueIsDiscarded);
	        case 360 /* PartiallyEmittedExpression */:
	          return visitPartiallyEmittedExpression(node, valueIsDiscarded);
	        case 226 /* BinaryExpression */:
	          if (isDestructuringAssignment(node)) {
	            return visitDestructuringAssignment(node, valueIsDiscarded);
	          }
	          break;
	        case 213 /* CallExpression */:
	          if (isImportCall(node)) {
	            return visitImportCallExpression(node);
	          }
	          break;
	        case 224 /* PrefixUnaryExpression */:
	        case 225 /* PostfixUnaryExpression */:
	          return visitPrefixOrPostfixUnaryExpression(node, valueIsDiscarded);
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function visitor(node) {
	      return visitorWorker(
	        node,
	        /*valueIsDiscarded*/
	        false
	      );
	    }
	    function discardedValueVisitor(node) {
	      return visitorWorker(
	        node,
	        /*valueIsDiscarded*/
	        true
	      );
	    }
	    function visitExpressionStatement(node) {
	      return factory2.updateExpressionStatement(node, visitNode(node.expression, discardedValueVisitor, isExpression));
	    }
	    function visitParenthesizedExpression(node, valueIsDiscarded) {
	      return factory2.updateParenthesizedExpression(node, visitNode(node.expression, valueIsDiscarded ? discardedValueVisitor : visitor, isExpression));
	    }
	    function visitPartiallyEmittedExpression(node, valueIsDiscarded) {
	      return factory2.updatePartiallyEmittedExpression(node, visitNode(node.expression, valueIsDiscarded ? discardedValueVisitor : visitor, isExpression));
	    }
	    function visitImportCallExpression(node) {
	      const externalModuleName = getExternalModuleNameLiteral(factory2, node, currentSourceFile, host, resolver, compilerOptions);
	      const firstArgument = visitNode(firstOrUndefined(node.arguments), visitor, isExpression);
	      const argument = externalModuleName && (!firstArgument || !isStringLiteral(firstArgument) || firstArgument.text !== externalModuleName.text) ? externalModuleName : firstArgument;
	      return factory2.createCallExpression(
	        factory2.createPropertyAccessExpression(
	          contextObject,
	          factory2.createIdentifier("import")
	        ),
	        /*typeArguments*/
	        void 0,
	        argument ? [argument] : []
	      );
	    }
	    function visitDestructuringAssignment(node, valueIsDiscarded) {
	      if (hasExportedReferenceInDestructuringTarget(node.left)) {
	        return flattenDestructuringAssignment(
	          node,
	          visitor,
	          context,
	          0 /* All */,
	          !valueIsDiscarded
	        );
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function hasExportedReferenceInDestructuringTarget(node) {
	      if (isAssignmentExpression(
	        node,
	        /*excludeCompoundAssignment*/
	        true
	      )) {
	        return hasExportedReferenceInDestructuringTarget(node.left);
	      } else if (isSpreadElement(node)) {
	        return hasExportedReferenceInDestructuringTarget(node.expression);
	      } else if (isObjectLiteralExpression(node)) {
	        return some(node.properties, hasExportedReferenceInDestructuringTarget);
	      } else if (isArrayLiteralExpression(node)) {
	        return some(node.elements, hasExportedReferenceInDestructuringTarget);
	      } else if (isShorthandPropertyAssignment(node)) {
	        return hasExportedReferenceInDestructuringTarget(node.name);
	      } else if (isPropertyAssignment(node)) {
	        return hasExportedReferenceInDestructuringTarget(node.initializer);
	      } else if (isIdentifier(node)) {
	        const container = resolver.getReferencedExportContainer(node);
	        return container !== void 0 && container.kind === 312 /* SourceFile */;
	      } else {
	        return false;
	      }
	    }
	    function visitPrefixOrPostfixUnaryExpression(node, valueIsDiscarded) {
	      if ((node.operator === 46 /* PlusPlusToken */ || node.operator === 47 /* MinusMinusToken */) && isIdentifier(node.operand) && !isGeneratedIdentifier(node.operand) && !isLocalName(node.operand) && !isDeclarationNameOfEnumOrNamespace(node.operand)) {
	        const exportedNames = getExports(node.operand);
	        if (exportedNames) {
	          let temp;
	          let expression = visitNode(node.operand, visitor, isExpression);
	          if (isPrefixUnaryExpression(node)) {
	            expression = factory2.updatePrefixUnaryExpression(node, expression);
	          } else {
	            expression = factory2.updatePostfixUnaryExpression(node, expression);
	            if (!valueIsDiscarded) {
	              temp = factory2.createTempVariable(hoistVariableDeclaration);
	              expression = factory2.createAssignment(temp, expression);
	              setTextRange(expression, node);
	            }
	            expression = factory2.createComma(expression, factory2.cloneNode(node.operand));
	            setTextRange(expression, node);
	          }
	          for (const exportName of exportedNames) {
	            expression = createExportExpression(exportName, preventSubstitution(expression));
	          }
	          if (temp) {
	            expression = factory2.createComma(expression, temp);
	            setTextRange(expression, node);
	          }
	          return expression;
	        }
	      }
	      return visitEachChild(node, visitor, context);
	    }
	    function modifierVisitor(node) {
	      switch (node.kind) {
	        case 95 /* ExportKeyword */:
	        case 90 /* DefaultKeyword */:
	          return void 0;
	      }
	      return node;
	    }
	    function onEmitNode(hint, node, emitCallback) {
	      if (node.kind === 312 /* SourceFile */) {
	        const id = getOriginalNodeId(node);
	        currentSourceFile = node;
	        moduleInfo = moduleInfoMap[id];
	        exportFunction = exportFunctionsMap[id];
	        noSubstitution = noSubstitutionMap[id];
	        contextObject = contextObjectMap[id];
	        if (noSubstitution) {
	          delete noSubstitutionMap[id];
	        }
	        previousOnEmitNode(hint, node, emitCallback);
	        currentSourceFile = void 0;
	        moduleInfo = void 0;
	        exportFunction = void 0;
	        contextObject = void 0;
	        noSubstitution = void 0;
	      } else {
	        previousOnEmitNode(hint, node, emitCallback);
	      }
	    }
	    function onSubstituteNode(hint, node) {
	      node = previousOnSubstituteNode(hint, node);
	      if (isSubstitutionPrevented(node)) {
	        return node;
	      }
	      if (hint === 1 /* Expression */) {
	        return substituteExpression(node);
	      } else if (hint === 4 /* Unspecified */) {
	        return substituteUnspecified(node);
	      }
	      return node;
	    }
	    function substituteUnspecified(node) {
	      switch (node.kind) {
	        case 304 /* ShorthandPropertyAssignment */:
	          return substituteShorthandPropertyAssignment(node);
	      }
	      return node;
	    }
	    function substituteShorthandPropertyAssignment(node) {
	      var _a, _b;
	      const name = node.name;
	      if (!isGeneratedIdentifier(name) && !isLocalName(name)) {
	        const importDeclaration = resolver.getReferencedImportDeclaration(name);
	        if (importDeclaration) {
	          if (isImportClause(importDeclaration)) {
	            return setTextRange(
	              factory2.createPropertyAssignment(
	                factory2.cloneNode(name),
	                factory2.createPropertyAccessExpression(
	                  factory2.getGeneratedNameForNode(importDeclaration.parent),
	                  factory2.createIdentifier("default")
	                )
	              ),
	              /*location*/
	              node
	            );
	          } else if (isImportSpecifier(importDeclaration)) {
	            return setTextRange(
	              factory2.createPropertyAssignment(
	                factory2.cloneNode(name),
	                factory2.createPropertyAccessExpression(
	                  factory2.getGeneratedNameForNode(((_b = (_a = importDeclaration.parent) == null ? void 0 : _a.parent) == null ? void 0 : _b.parent) || importDeclaration),
	                  factory2.cloneNode(importDeclaration.propertyName || importDeclaration.name)
	                )
	              ),
	              /*location*/
	              node
	            );
	          }
	        }
	      }
	      return node;
	    }
	    function substituteExpression(node) {
	      switch (node.kind) {
	        case 80 /* Identifier */:
	          return substituteExpressionIdentifier(node);
	        case 226 /* BinaryExpression */:
	          return substituteBinaryExpression(node);
	        case 236 /* MetaProperty */:
	          return substituteMetaProperty(node);
	      }
	      return node;
	    }
	    function substituteExpressionIdentifier(node) {
	      var _a, _b;
	      if (getEmitFlags(node) & 8192 /* HelperName */) {
	        const externalHelpersModuleName = getExternalHelpersModuleName(currentSourceFile);
	        if (externalHelpersModuleName) {
	          return factory2.createPropertyAccessExpression(externalHelpersModuleName, node);
	        }
	        return node;
	      }
	      if (!isGeneratedIdentifier(node) && !isLocalName(node)) {
	        const importDeclaration = resolver.getReferencedImportDeclaration(node);
	        if (importDeclaration) {
	          if (isImportClause(importDeclaration)) {
	            return setTextRange(
	              factory2.createPropertyAccessExpression(
	                factory2.getGeneratedNameForNode(importDeclaration.parent),
	                factory2.createIdentifier("default")
	              ),
	              /*location*/
	              node
	            );
	          } else if (isImportSpecifier(importDeclaration)) {
	            return setTextRange(
	              factory2.createPropertyAccessExpression(
	                factory2.getGeneratedNameForNode(((_b = (_a = importDeclaration.parent) == null ? void 0 : _a.parent) == null ? void 0 : _b.parent) || importDeclaration),
	                factory2.cloneNode(importDeclaration.propertyName || importDeclaration.name)
	              ),
	              /*location*/
	              node
	            );
	          }
	        }
	      }
	      return node;
	    }
	    function substituteBinaryExpression(node) {
	      if (isAssignmentOperator(node.operatorToken.kind) && isIdentifier(node.left) && (!isGeneratedIdentifier(node.left) || isFileLevelReservedGeneratedIdentifier(node.left)) && !isLocalName(node.left)) {
	        const exportedNames = getExports(node.left);
	        if (exportedNames) {
	          let expression = node;
	          for (const exportName of exportedNames) {
	            expression = createExportExpression(exportName, preventSubstitution(expression));
	          }
	          return expression;
	        }
	      }
	      return node;
	    }
	    function substituteMetaProperty(node) {
	      if (isImportMeta(node)) {
	        return factory2.createPropertyAccessExpression(contextObject, factory2.createIdentifier("meta"));
	      }
	      return node;
	    }
	    function getExports(name) {
	      let exportedNames;
	      const valueDeclaration = getReferencedDeclaration(name);
	      if (valueDeclaration) {
	        const exportContainer = resolver.getReferencedExportContainer(
	          name,
	          /*prefixLocals*/
	          false
	        );
	        if (exportContainer && exportContainer.kind === 312 /* SourceFile */) {
	          exportedNames = append(exportedNames, factory2.getDeclarationName(valueDeclaration));
	        }
	        exportedNames = addRange(exportedNames, moduleInfo == null ? void 0 : moduleInfo.exportedBindings[getOriginalNodeId(valueDeclaration)]);
	      } else if (isGeneratedIdentifier(name) && isFileLevelReservedGeneratedIdentifier(name)) {
	        const exportSpecifiers = moduleInfo == null ? void 0 : moduleInfo.exportSpecifiers.get(name);
	        if (exportSpecifiers) {
	          const exportedNames2 = [];
	          for (const exportSpecifier of exportSpecifiers) {
	            exportedNames2.push(exportSpecifier.name);
	          }
	          return exportedNames2;
	        }
	      }
	      return exportedNames;
	    }
	    function getReferencedDeclaration(name) {
	      if (!isGeneratedIdentifier(name)) {
	        const importDeclaration = resolver.getReferencedImportDeclaration(name);
	        if (importDeclaration)
	          return importDeclaration;
	        const valueDeclaration = resolver.getReferencedValueDeclaration(name);
	        if (valueDeclaration && (moduleInfo == null ? void 0 : moduleInfo.exportedBindings[getOriginalNodeId(valueDeclaration)]))
	          return valueDeclaration;
	        const declarations = resolver.getReferencedValueDeclarations(name);
	        if (declarations) {
	          for (const declaration of declarations) {
	            if (declaration !== valueDeclaration && (moduleInfo == null ? void 0 : moduleInfo.exportedBindings[getOriginalNodeId(declaration)]))
	              return declaration;
	          }
	        }
	        return valueDeclaration;
	      }
	    }
	    function preventSubstitution(node) {
	      if (noSubstitution === void 0)
	        noSubstitution = [];
	      noSubstitution[getNodeId(node)] = true;
	      return node;
	    }
	    function isSubstitutionPrevented(node) {
	      return noSubstitution && node.id && noSubstitution[node.id];
	    }
	  }
	  var init_system = __esm({
	    "src/compiler/transformers/module/system.ts"() {
	      init_ts2();
	    }
	  });

	  // src/compiler/transformers/module/esnextAnd2015.ts
	  function transformECMAScriptModule(context) {
	    const {
	      factory: factory2,
	      getEmitHelperFactory: emitHelpers
	    } = context;
	    const host = context.getEmitHost();
	    const resolver = context.getEmitResolver();
	    const compilerOptions = context.getCompilerOptions();
	    const languageVersion = getEmitScriptTarget(compilerOptions);
	    const previousOnEmitNode = context.onEmitNode;
	    const previousOnSubstituteNode = context.onSubstituteNode;
	    context.onEmitNode = onEmitNode;
	    context.onSubstituteNode = onSubstituteNode;
	    context.enableEmitNotification(312 /* SourceFile */);
	    context.enableSubstitution(80 /* Identifier */);
	    let helperNameSubstitutions;
	    let currentSourceFile;
	    let importRequireStatements;
	    return chainBundle(context, transformSourceFile);
	    function transformSourceFile(node) {
	      if (node.isDeclarationFile) {
	        return node;
	      }
	      if (isExternalModule(node) || getIsolatedModules(compilerOptions)) {
	        currentSourceFile = node;
	        importRequireStatements = void 0;
	        let result = updateExternalModule(node);
	        currentSourceFile = void 0;
	        if (importRequireStatements) {
	          result = factory2.updateSourceFile(
	            result,
	            setTextRange(factory2.createNodeArray(insertStatementsAfterCustomPrologue(result.statements.slice(), importRequireStatements)), result.statements)
	          );
	        }
	        if (!isExternalModule(node) || getEmitModuleKind(compilerOptions) === 200 /* Preserve */ || some(result.statements, isExternalModuleIndicator)) {
	          return result;
	        }
	        return factory2.updateSourceFile(
	          result,
	          setTextRange(factory2.createNodeArray([...result.statements, createEmptyExports(factory2)]), result.statements)
	        );
	      }
	      return node;
	    }
	    function updateExternalModule(node) {
	      const externalHelpersImportDeclaration = createExternalHelpersImportDeclarationIfNeeded(factory2, emitHelpers(), node, compilerOptions);
	      if (externalHelpersImportDeclaration) {
	        const statements = [];
	        const statementOffset = factory2.copyPrologue(node.statements, statements);
	        append(statements, externalHelpersImportDeclaration);
	        addRange(statements, visitNodes2(node.statements, visitor, isStatement, statementOffset));
	        return factory2.updateSourceFile(
	          node,
	          setTextRange(factory2.createNodeArray(statements), node.statements)
	        );
	      } else {
	        return visitEachChild(node, visitor, context);
	      }
	    }
	    function visitor(node) {
	      switch (node.kind) {
	        case 271 /* ImportEqualsDeclaration */:
	          return getEmitModuleKind(compilerOptions) >= 100 /* Node16 */ ? visitImportEqualsDeclaration(node) : void 0;
	        case 277 /* ExportAssignment */:
	          return visitExportAssignment(node);
	        case 278 /* ExportDeclaration */:
	          const exportDecl = node;
	          return visitExportDeclaration(exportDecl);
	      }
	      return node;
	    }
	    function createRequireCall2(importNode) {
	      const moduleName = getExternalModuleNameLiteral(factory2, importNode, Debug.checkDefined(currentSourceFile), host, resolver, compilerOptions);
	      const args = [];
	      if (moduleName) {
	        args.push(moduleName);
	      }
	      if (getEmitModuleKind(compilerOptions) === 200 /* Preserve */) {
	        return factory2.createCallExpression(
	          factory2.createIdentifier("require"),
	          /*typeArguments*/
	          void 0,
	          args
	        );
	      }
	      if (!importRequireStatements) {
	        const createRequireName = factory2.createUniqueName("_createRequire", 16 /* Optimistic */ | 32 /* FileLevel */);
	        const importStatement = factory2.createImportDeclaration(
	          /*modifiers*/
	          void 0,
	          factory2.createImportClause(
	            /*isTypeOnly*/
	            false,
	            /*name*/
	            void 0,
	            factory2.createNamedImports([
	              factory2.createImportSpecifier(
	                /*isTypeOnly*/
	                false,
	                factory2.createIdentifier("createRequire"),
	                createRequireName
	              )
	            ])
	          ),
	          factory2.createStringLiteral("module"),
	          /*attributes*/
	          void 0
	        );
	        const requireHelperName = factory2.createUniqueName("__require", 16 /* Optimistic */ | 32 /* FileLevel */);
	        const requireStatement = factory2.createVariableStatement(
	          /*modifiers*/
	          void 0,
	          factory2.createVariableDeclarationList(
	            [
	              factory2.createVariableDeclaration(
	                requireHelperName,
	                /*exclamationToken*/
	                void 0,
	                /*type*/
	                void 0,
	                factory2.createCallExpression(
	                  factory2.cloneNode(createRequireName),
	                  /*typeArguments*/
	                  void 0,
	                  [
	                    factory2.createPropertyAccessExpression(factory2.createMetaProperty(102 /* ImportKeyword */, factory2.createIdentifier("meta")), factory2.createIdentifier("url"))
	                  ]
	                )
	              )
	            ],
	            /*flags*/
	            languageVersion >= 2 /* ES2015 */ ? 2 /* Const */ : 0 /* None */
	          )
	        );
	        importRequireStatements = [importStatement, requireStatement];
	      }
	      const name = importRequireStatements[1].declarationList.declarations[0].name;
	      Debug.assertNode(name, isIdentifier);
	      return factory2.createCallExpression(
	        factory2.cloneNode(name),
	        /*typeArguments*/
	        void 0,
	        args
	      );
	    }
	    function visitImportEqualsDeclaration(node) {
	      Debug.assert(isExternalModuleImportEqualsDeclaration(node), "import= for internal module references should be handled in an earlier transformer.");
	      let statements;
	      statements = append(
	        statements,
	        setOriginalNode(
	          setTextRange(
	            factory2.createVariableStatement(
	              /*modifiers*/
	              void 0,
	              factory2.createVariableDeclarationList(
	                [
	                  factory2.createVariableDeclaration(
	                    factory2.cloneNode(node.name),
	                    /*exclamationToken*/
	                    void 0,
	                    /*type*/
	                    void 0,
	                    createRequireCall2(node)
	                  )
	                ],
	                /*flags*/
	                languageVersion >= 2 /* ES2015 */ ? 2 /* Const */ : 0 /* None */
	              )
	            ),
	            node
	          ),
	          node
	        )
	      );
	      statements = appendExportsOfImportEqualsDeclaration(statements, node);
	      return singleOrMany(statements);
	    }
	    function appendExportsOfImportEqualsDeclaration(statements, node) {
	      if (hasSyntacticModifier(node, 32 /* Export */)) {
	        statements = append(
	          statements,
	          factory2.createExportDeclaration(
	            /*modifiers*/
	            void 0,
	            node.isTypeOnly,
	            factory2.createNamedExports([factory2.createExportSpecifier(
	              /*isTypeOnly*/
	              false,
	              /*propertyName*/
	              void 0,
	              idText(node.name)
	            )])
	          )
	        );
	      }
	      return statements;
	    }
	    function visitExportAssignment(node) {
	      if (node.isExportEquals) {
	        if (getEmitModuleKind(compilerOptions) === 200 /* Preserve */) {
	          const statement = setOriginalNode(
	            factory2.createExpressionStatement(
	              factory2.createAssignment(
	                factory2.createPropertyAccessExpression(
	                  factory2.createIdentifier("module"),
	                  "exports"
	                ),
	                node.expression
	              )
	            ),
	            node
	          );
	          return statement;
	        }
	        return void 0;
	      }
	      return node;
	    }
	    function visitExportDeclaration(node) {
	      if (compilerOptions.module !== void 0 && compilerOptions.module > 5 /* ES2015 */) {
	        return node;
	      }
	      if (!node.exportClause || !isNamespaceExport(node.exportClause) || !node.moduleSpecifier) {
	        return node;
	      }
	      const oldIdentifier = node.exportClause.name;
	      const synthName = factory2.getGeneratedNameForNode(oldIdentifier);
	      const importDecl = factory2.createImportDeclaration(
	        /*modifiers*/
	        void 0,
	        factory2.createImportClause(
	          /*isTypeOnly*/
	          false,
	          /*name*/
	          void 0,
	          factory2.createNamespaceImport(
	            synthName
	          )
	        ),
	        node.moduleSpecifier,
	        node.attributes
	      );
	      setOriginalNode(importDecl, node.exportClause);
	      const exportDecl = isExportNamespaceAsDefaultDeclaration(node) ? factory2.createExportDefault(synthName) : factory2.createExportDeclaration(
	        /*modifiers*/
	        void 0,
	        /*isTypeOnly*/
	        false,
	        factory2.createNamedExports([factory2.createExportSpecifier(
	          /*isTypeOnly*/
	          false,
	          synthName,
	          oldIdentifier
	        )])
	      );
	      setOriginalNode(exportDecl, node);
	      return [importDecl, exportDecl];
	    }
	    function onEmitNode(hint, node, emitCallback) {
	      if (isSourceFile(node)) {
	        if ((isExternalModule(node) || getIsolatedModules(compilerOptions)) && compilerOptions.importHelpers) {
	          helperNameSubstitutions = /* @__PURE__ */ new Map();
	        }
	        previousOnEmitNode(hint, node, emitCallback);
	        helperNameSubstitutions = void 0;
	      } else {
	        previousOnEmitNode(hint, node, emitCallback);
	      }
	    }
	    function onSubstituteNode(hint, node) {
	      node = previousOnSubstituteNode(hint, node);
	      if (helperNameSubstitutions && isIdentifier(node) && getEmitFlags(node) & 8192 /* HelperName */) {
	        return substituteHelperName(node);
	      }
	      return node;
	    }
	    function substituteHelperName(node) {
	      const name = idText(node);
	      let substitution = helperNameSubstitutions.get(name);
	      if (!substitution) {
	        helperNameSubstitutions.set(name, substitution = factory2.createUniqueName(name, 16 /* Optimistic */ | 32 /* FileLevel */));
	      }
	      return substitution;
	    }
	  }
	  var init_esnextAnd2015 = __esm({
	    "src/compiler/transformers/module/esnextAnd2015.ts"() {
	      init_ts2();
	    }
	  });

	  // src/compiler/transformers/module/node.ts
	  function transformNodeModule(context) {
	    const previousOnSubstituteNode = context.onSubstituteNode;
	    const previousOnEmitNode = context.onEmitNode;
	    const esmTransform = transformECMAScriptModule(context);
	    const esmOnSubstituteNode = context.onSubstituteNode;
	    const esmOnEmitNode = context.onEmitNode;
	    context.onSubstituteNode = previousOnSubstituteNode;
	    context.onEmitNode = previousOnEmitNode;
	    const cjsTransform = transformModule(context);
	    const cjsOnSubstituteNode = context.onSubstituteNode;
	    const cjsOnEmitNode = context.onEmitNode;
	    context.onSubstituteNode = onSubstituteNode;
	    context.onEmitNode = onEmitNode;
	    context.enableSubstitution(312 /* SourceFile */);
	    context.enableEmitNotification(312 /* SourceFile */);
	    let currentSourceFile;
	    return transformSourceFileOrBundle;
	    function onSubstituteNode(hint, node) {
	      if (isSourceFile(node)) {
	        currentSourceFile = node;
	        return previousOnSubstituteNode(hint, node);
	      } else {
	        if (!currentSourceFile) {
	          return previousOnSubstituteNode(hint, node);
	        }
	        if (currentSourceFile.impliedNodeFormat === 99 /* ESNext */) {
	          return esmOnSubstituteNode(hint, node);
	        }
	        return cjsOnSubstituteNode(hint, node);
	      }
	    }
	    function onEmitNode(hint, node, emitCallback) {
	      if (isSourceFile(node)) {
	        currentSourceFile = node;
	      }
	      if (!currentSourceFile) {
	        return previousOnEmitNode(hint, node, emitCallback);
	      }
	      if (currentSourceFile.impliedNodeFormat === 99 /* ESNext */) {
	        return esmOnEmitNode(hint, node, emitCallback);
	      }
	      return cjsOnEmitNode(hint, node, emitCallback);
	    }
	    function getModuleTransformForFile(file) {
	      return file.impliedNodeFormat === 99 /* ESNext */ ? esmTransform : cjsTransform;
	    }
	    function transformSourceFile(node) {
	      if (node.isDeclarationFile) {
	        return node;
	      }
	      currentSourceFile = node;
	      const result = getModuleTransformForFile(node)(node);
	      currentSourceFile = void 0;
	      Debug.assert(isSourceFile(result));
	      return result;
	    }
	    function transformSourceFileOrBundle(node) {
	      return node.kind === 312 /* SourceFile */ ? transformSourceFile(node) : transformBundle(node);
	    }
	    function transformBundle(node) {
	      return context.factory.createBundle(map(node.sourceFiles, transformSourceFile), node.prepends);
	    }
	  }
	  var init_node = __esm({
	    "src/compiler/transformers/module/node.ts"() {
	      init_ts2();
	    }
	  });

	  // src/compiler/transformers/declarations/diagnostics.ts
	  function canProduceDiagnostics(node) {
	    return isVariableDeclaration(node) || isPropertyDeclaration(node) || isPropertySignature(node) || isBindingElement(node) || isSetAccessor(node) || isGetAccessor(node) || isConstructSignatureDeclaration(node) || isCallSignatureDeclaration(node) || isMethodDeclaration(node) || isMethodSignature(node) || isFunctionDeclaration(node) || isParameter(node) || isTypeParameterDeclaration(node) || isExpressionWithTypeArguments(node) || isImportEqualsDeclaration(node) || isTypeAliasDeclaration(node) || isConstructorDeclaration(node) || isIndexSignatureDeclaration(node) || isPropertyAccessExpression(node) || isElementAccessExpression(node) || isBinaryExpression(node) || isJSDocTypeAlias(node);
	  }
	  function createGetSymbolAccessibilityDiagnosticForNodeName(node) {
	    if (isSetAccessor(node) || isGetAccessor(node)) {
	      return getAccessorNameVisibilityError;
	    } else if (isMethodSignature(node) || isMethodDeclaration(node)) {
	      return getMethodNameVisibilityError;
	    } else {
	      return createGetSymbolAccessibilityDiagnosticForNode(node);
	    }
	    function getAccessorNameVisibilityError(symbolAccessibilityResult) {
	      const diagnosticMessage = getAccessorNameVisibilityDiagnosticMessage(symbolAccessibilityResult);
	      return diagnosticMessage !== void 0 ? {
	        diagnosticMessage,
	        errorNode: node,
	        typeName: node.name
	      } : void 0;
	    }
	    function getAccessorNameVisibilityDiagnosticMessage(symbolAccessibilityResult) {
	      if (isStatic(node)) {
	        return symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 /* CannotBeNamed */ ? Diagnostics.Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : Diagnostics.Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2 : Diagnostics.Public_static_property_0_of_exported_class_has_or_is_using_private_name_1;
	      } else if (node.parent.kind === 263 /* ClassDeclaration */) {
	        return symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 /* CannotBeNamed */ ? Diagnostics.Public_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : Diagnostics.Public_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2 : Diagnostics.Public_property_0_of_exported_class_has_or_is_using_private_name_1;
	      } else {
	        return symbolAccessibilityResult.errorModuleName ? Diagnostics.Property_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2 : Diagnostics.Property_0_of_exported_interface_has_or_is_using_private_name_1;
	      }
	    }
	    function getMethodNameVisibilityError(symbolAccessibilityResult) {
	      const diagnosticMessage = getMethodNameVisibilityDiagnosticMessage(symbolAccessibilityResult);
	      return diagnosticMessage !== void 0 ? {
	        diagnosticMessage,
	        errorNode: node,
	        typeName: node.name
	      } : void 0;
	    }
	    function getMethodNameVisibilityDiagnosticMessage(symbolAccessibilityResult) {
	      if (isStatic(node)) {
	        return symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 /* CannotBeNamed */ ? Diagnostics.Public_static_method_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : Diagnostics.Public_static_method_0_of_exported_class_has_or_is_using_name_1_from_private_module_2 : Diagnostics.Public_static_method_0_of_exported_class_has_or_is_using_private_name_1;
	      } else if (node.parent.kind === 263 /* ClassDeclaration */) {
	        return symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 /* CannotBeNamed */ ? Diagnostics.Public_method_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : Diagnostics.Public_method_0_of_exported_class_has_or_is_using_name_1_from_private_module_2 : Diagnostics.Public_method_0_of_exported_class_has_or_is_using_private_name_1;
	      } else {
	        return symbolAccessibilityResult.errorModuleName ? Diagnostics.Method_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2 : Diagnostics.Method_0_of_exported_interface_has_or_is_using_private_name_1;
	      }
	    }
	  }
	  function createGetSymbolAccessibilityDiagnosticForNode(node) {
	    if (isVariableDeclaration(node) || isPropertyDeclaration(node) || isPropertySignature(node) || isPropertyAccessExpression(node) || isElementAccessExpression(node) || isBinaryExpression(node) || isBindingElement(node) || isConstructorDeclaration(node)) {
	      return getVariableDeclarationTypeVisibilityError;
	    } else if (isSetAccessor(node) || isGetAccessor(node)) {
	      return getAccessorDeclarationTypeVisibilityError;
	    } else if (isConstructSignatureDeclaration(node) || isCallSignatureDeclaration(node) || isMethodDeclaration(node) || isMethodSignature(node) || isFunctionDeclaration(node) || isIndexSignatureDeclaration(node)) {
	      return getReturnTypeVisibilityError;
	    } else if (isParameter(node)) {
	      if (isParameterPropertyDeclaration(node, node.parent) && hasSyntacticModifier(node.parent, 2 /* Private */)) {
	        return getVariableDeclarationTypeVisibilityError;
	      }
	      return getParameterDeclarationTypeVisibilityError;
	    } else if (isTypeParameterDeclaration(node)) {
	      return getTypeParameterConstraintVisibilityError;
	    } else if (isExpressionWithTypeArguments(node)) {
	      return getHeritageClauseVisibilityError;
	    } else if (isImportEqualsDeclaration(node)) {
	      return getImportEntityNameVisibilityError;
	    } else if (isTypeAliasDeclaration(node) || isJSDocTypeAlias(node)) {
	      return getTypeAliasDeclarationVisibilityError;
	    } else {
	      return Debug.assertNever(node, `Attempted to set a declaration diagnostic context for unhandled node kind: ${Debug.formatSyntaxKind(node.kind)}`);
	    }
	    function getVariableDeclarationTypeVisibilityDiagnosticMessage(symbolAccessibilityResult) {
	      if (node.kind === 260 /* VariableDeclaration */ || node.kind === 208 /* BindingElement */) {
	        return symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 /* CannotBeNamed */ ? Diagnostics.Exported_variable_0_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : Diagnostics.Exported_variable_0_has_or_is_using_name_1_from_private_module_2 : Diagnostics.Exported_variable_0_has_or_is_using_private_name_1;
	      } else if (node.kind === 172 /* PropertyDeclaration */ || node.kind === 211 /* PropertyAccessExpression */ || node.kind === 212 /* ElementAccessExpression */ || node.kind === 226 /* BinaryExpression */ || node.kind === 171 /* PropertySignature */ || node.kind === 169 /* Parameter */ && hasSyntacticModifier(node.parent, 2 /* Private */)) {
	        if (isStatic(node)) {
	          return symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 /* CannotBeNamed */ ? Diagnostics.Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : Diagnostics.Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2 : Diagnostics.Public_static_property_0_of_exported_class_has_or_is_using_private_name_1;
	        } else if (node.parent.kind === 263 /* ClassDeclaration */ || node.kind === 169 /* Parameter */) {
	          return symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 /* CannotBeNamed */ ? Diagnostics.Public_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : Diagnostics.Public_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2 : Diagnostics.Public_property_0_of_exported_class_has_or_is_using_private_name_1;
	        } else {
	          return symbolAccessibilityResult.errorModuleName ? Diagnostics.Property_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2 : Diagnostics.Property_0_of_exported_interface_has_or_is_using_private_name_1;
	        }
	      }
	    }
	    function getVariableDeclarationTypeVisibilityError(symbolAccessibilityResult) {
	      const diagnosticMessage = getVariableDeclarationTypeVisibilityDiagnosticMessage(symbolAccessibilityResult);
	      return diagnosticMessage !== void 0 ? {
	        diagnosticMessage,
	        errorNode: node,
	        typeName: node.name
	      } : void 0;
	    }
	    function getAccessorDeclarationTypeVisibilityError(symbolAccessibilityResult) {
	      let diagnosticMessage;
	      if (node.kind === 178 /* SetAccessor */) {
	        if (isStatic(node)) {
	          diagnosticMessage = symbolAccessibilityResult.errorModuleName ? Diagnostics.Parameter_type_of_public_static_setter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2 : Diagnostics.Parameter_type_of_public_static_setter_0_from_exported_class_has_or_is_using_private_name_1;
	        } else {
	          diagnosticMessage = symbolAccessibilityResult.errorModuleName ? Diagnostics.Parameter_type_of_public_setter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2 : Diagnostics.Parameter_type_of_public_setter_0_from_exported_class_has_or_is_using_private_name_1;
	        }
	      } else {
	        if (isStatic(node)) {
	          diagnosticMessage = symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 /* CannotBeNamed */ ? Diagnostics.Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : Diagnostics.Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2 : Diagnostics.Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_private_name_1;
	        } else {
	          diagnosticMessage = symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 /* CannotBeNamed */ ? Diagnostics.Return_type_of_public_getter_0_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : Diagnostics.Return_type_of_public_getter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2 : Diagnostics.Return_type_of_public_getter_0_from_exported_class_has_or_is_using_private_name_1;
	        }
	      }
	      return {
	        diagnosticMessage,
	        errorNode: node.name,
	        typeName: node.name
	      };
	    }
	    function getReturnTypeVisibilityError(symbolAccessibilityResult) {
	      let diagnosticMessage;
	      switch (node.kind) {
	        case 180 /* ConstructSignature */:
	          diagnosticMessage = symbolAccessibilityResult.errorModuleName ? Diagnostics.Return_type_of_constructor_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1 : Diagnostics.Return_type_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_0;
	          break;
	        case 179 /* CallSignature */:
	          diagnosticMessage = symbolAccessibilityResult.errorModuleName ? Diagnostics.Return_type_of_call_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1 : Diagnostics.Return_type_of_call_signature_from_exported_interface_has_or_is_using_private_name_0;
	          break;
	        case 181 /* IndexSignature */:
	          diagnosticMessage = symbolAccessibilityResult.errorModuleName ? Diagnostics.Return_type_of_index_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1 : Diagnostics.Return_type_of_index_signature_from_exported_interface_has_or_is_using_private_name_0;
	          break;
	        case 174 /* MethodDeclaration */:
	        case 173 /* MethodSignature */:
	          if (isStatic(node)) {
	            diagnosticMessage = symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 /* CannotBeNamed */ ? Diagnostics.Return_type_of_public_static_method_from_exported_class_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named : Diagnostics.Return_type_of_public_static_method_from_exported_class_has_or_is_using_name_0_from_private_module_1 : Diagnostics.Return_type_of_public_static_method_from_exported_class_has_or_is_using_private_name_0;
	          } else if (node.parent.kind === 263 /* ClassDeclaration */) {
	            diagnosticMessage = symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 /* CannotBeNamed */ ? Diagnostics.Return_type_of_public_method_from_exported_class_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named : Diagnostics.Return_type_of_public_method_from_exported_class_has_or_is_using_name_0_from_private_module_1 : Diagnostics.Return_type_of_public_method_from_exported_class_has_or_is_using_private_name_0;
	          } else {
	            diagnosticMessage = symbolAccessibilityResult.errorModuleName ? Diagnostics.Return_type_of_method_from_exported_interface_has_or_is_using_name_0_from_private_module_1 : Diagnostics.Return_type_of_method_from_exported_interface_has_or_is_using_private_name_0;
	          }
	          break;
	        case 262 /* FunctionDeclaration */:
	          diagnosticMessage = symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 /* CannotBeNamed */ ? Diagnostics.Return_type_of_exported_function_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named : Diagnostics.Return_type_of_exported_function_has_or_is_using_name_0_from_private_module_1 : Diagnostics.Return_type_of_exported_function_has_or_is_using_private_name_0;
	          break;
	        default:
	          return Debug.fail("This is unknown kind for signature: " + node.kind);
	      }
	      return {
	        diagnosticMessage,
	        errorNode: node.name || node
	      };
	    }
	    function getParameterDeclarationTypeVisibilityError(symbolAccessibilityResult) {
	      const diagnosticMessage = getParameterDeclarationTypeVisibilityDiagnosticMessage(symbolAccessibilityResult);
	      return diagnosticMessage !== void 0 ? {
	        diagnosticMessage,
	        errorNode: node,
	        typeName: node.name
	      } : void 0;
	    }
	    function getParameterDeclarationTypeVisibilityDiagnosticMessage(symbolAccessibilityResult) {
	      switch (node.parent.kind) {
	        case 176 /* Constructor */:
	          return symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 /* CannotBeNamed */ ? Diagnostics.Parameter_0_of_constructor_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : Diagnostics.Parameter_0_of_constructor_from_exported_class_has_or_is_using_name_1_from_private_module_2 : Diagnostics.Parameter_0_of_constructor_from_exported_class_has_or_is_using_private_name_1;
	        case 180 /* ConstructSignature */:
	        case 185 /* ConstructorType */:
	          return symbolAccessibilityResult.errorModuleName ? Diagnostics.Parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2 : Diagnostics.Parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_1;
	        case 179 /* CallSignature */:
	          return symbolAccessibilityResult.errorModuleName ? Diagnostics.Parameter_0_of_call_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2 : Diagnostics.Parameter_0_of_call_signature_from_exported_interface_has_or_is_using_private_name_1;
	        case 181 /* IndexSignature */:
	          return symbolAccessibilityResult.errorModuleName ? Diagnostics.Parameter_0_of_index_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2 : Diagnostics.Parameter_0_of_index_signature_from_exported_interface_has_or_is_using_private_name_1;
	        case 174 /* MethodDeclaration */:
	        case 173 /* MethodSignature */:
	          if (isStatic(node.parent)) {
	            return symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 /* CannotBeNamed */ ? Diagnostics.Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : Diagnostics.Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_name_1_from_private_module_2 : Diagnostics.Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_private_name_1;
	          } else if (node.parent.parent.kind === 263 /* ClassDeclaration */) {
	            return symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 /* CannotBeNamed */ ? Diagnostics.Parameter_0_of_public_method_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : Diagnostics.Parameter_0_of_public_method_from_exported_class_has_or_is_using_name_1_from_private_module_2 : Diagnostics.Parameter_0_of_public_method_from_exported_class_has_or_is_using_private_name_1;
	          } else {
	            return symbolAccessibilityResult.errorModuleName ? Diagnostics.Parameter_0_of_method_from_exported_interface_has_or_is_using_name_1_from_private_module_2 : Diagnostics.Parameter_0_of_method_from_exported_interface_has_or_is_using_private_name_1;
	          }
	        case 262 /* FunctionDeclaration */:
	        case 184 /* FunctionType */:
	          return symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 /* CannotBeNamed */ ? Diagnostics.Parameter_0_of_exported_function_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : Diagnostics.Parameter_0_of_exported_function_has_or_is_using_name_1_from_private_module_2 : Diagnostics.Parameter_0_of_exported_function_has_or_is_using_private_name_1;
	        case 178 /* SetAccessor */:
	        case 177 /* GetAccessor */:
	          return symbolAccessibilityResult.errorModuleName ? symbolAccessibilityResult.accessibility === 2 /* CannotBeNamed */ ? Diagnostics.Parameter_0_of_accessor_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : Diagnostics.Parameter_0_of_accessor_has_or_is_using_name_1_from_private_module_2 : Diagnostics.Parameter_0_of_accessor_has_or_is_using_private_name_1;
	        default:
	          return Debug.fail(`Unknown parent for parameter: ${Debug.formatSyntaxKind(node.parent.kind)}`);
	      }
	    }
	    function getTypeParameterConstraintVisibilityError() {
	      let diagnosticMessage;
	      switch (node.parent.kind) {
	        case 263 /* ClassDeclaration */:
	          diagnosticMessage = Diagnostics.Type_parameter_0_of_exported_class_has_or_is_using_private_name_1;
	          break;
	        case 264 /* InterfaceDeclaration */:
	          diagnosticMessage = Diagnostics.Type_parameter_0_of_exported_interface_has_or_is_using_private_name_1;
	          break;
	        case 200 /* MappedType */:
	          diagnosticMessage = Diagnostics.Type_parameter_0_of_exported_mapped_object_type_is_using_private_name_1;
	          break;
	        case 185 /* ConstructorType */:
	        case 180 /* ConstructSignature */:
	          diagnosticMessage = Diagnostics.Type_parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_1;
	          break;
	        case 179 /* CallSignature */:
	          diagnosticMessage = Diagnostics.Type_parameter_0_of_call_signature_from_exported_interface_has_or_is_using_private_name_1;
	          break;
	        case 174 /* MethodDeclaration */:
	        case 173 /* MethodSignature */:
	          if (isStatic(node.parent)) {
	            diagnosticMessage = Diagnostics.Type_parameter_0_of_public_static_method_from_exported_class_has_or_is_using_private_name_1;
	          } else if (node.parent.parent.kind === 263 /* ClassDeclaration */) {
	            diagnosticMessage = Diagnostics.Type_parameter_0_of_public_method_from_exported_class_has_or_is_using_private_name_1;
	          } else {
	            diagnosticMessage = Diagnostics.Type_parameter_0_of_method_from_exported_interface_has_or_is_using_private_name_1;
	          }
	          break;
	        case 184 /* FunctionType */:
	        case 262 /* FunctionDeclaration */:
	          diagnosticMessage = Diagnostics.Type_parameter_0_of_exported_function_has_or_is_using_private_name_1;
	          break;
	        case 195 /* InferType */:
	          diagnosticMessage = Diagnostics.Extends_clause_for_inferred_type_0_has_or_is_using_private_name_1;
	          break;
	        case 265 /* TypeAliasDeclaration */:
	          diagnosticMessage = Diagnostics.Type_parameter_0_of_exported_type_alias_has_or_is_using_private_name_1;
	          break;
	        default:
	          return Debug.fail("This is unknown parent for type parameter: " + node.parent.kind);
	      }
	      return {
	        diagnosticMessage,
	        errorNode: node,
	        typeName: node.name
	      };
	    }
	    function getHeritageClauseVisibilityError() {
	      let diagnosticMessage;
	      if (isClassDeclaration(node.parent.parent)) {
	        diagnosticMessage = isHeritageClause(node.parent) && node.parent.token === 119 /* ImplementsKeyword */ ? Diagnostics.Implements_clause_of_exported_class_0_has_or_is_using_private_name_1 : node.parent.parent.name ? Diagnostics.extends_clause_of_exported_class_0_has_or_is_using_private_name_1 : Diagnostics.extends_clause_of_exported_class_has_or_is_using_private_name_0;
	      } else {
	        diagnosticMessage = Diagnostics.extends_clause_of_exported_interface_0_has_or_is_using_private_name_1;
	      }
	      return {
	        diagnosticMessage,
	        errorNode: node,
	        typeName: getNameOfDeclaration(node.parent.parent)
	      };
	    }
	    function getImportEntityNameVisibilityError() {
	      return {
	        diagnosticMessage: Diagnostics.Import_declaration_0_is_using_private_name_1,
	        errorNode: node,
	        typeName: node.name
	      };
	    }
	    function getTypeAliasDeclarationVisibilityError(symbolAccessibilityResult) {
	      return {
	        diagnosticMessage: symbolAccessibilityResult.errorModuleName ? Diagnostics.Exported_type_alias_0_has_or_is_using_private_name_1_from_module_2 : Diagnostics.Exported_type_alias_0_has_or_is_using_private_name_1,
	        errorNode: isJSDocTypeAlias(node) ? Debug.checkDefined(node.typeExpression) : node.type,
	        typeName: isJSDocTypeAlias(node) ? getNameOfDeclaration(node) : node.name
	      };
	    }
	  }
	  var init_diagnostics = __esm({
	    "src/compiler/transformers/declarations/diagnostics.ts"() {
	      init_ts2();
	    }
	  });

	  // src/compiler/transformers/declarations.ts
	  function getDeclarationDiagnostics(host, resolver, file) {
	    const compilerOptions = host.getCompilerOptions();
	    const result = transformNodes(
	      resolver,
	      host,
	      factory,
	      compilerOptions,
	      file ? [file] : filter(host.getSourceFiles(), isSourceFileNotJson),
	      [transformDeclarations],
	      /*allowDtsFiles*/
	      false
	    );
	    return result.diagnostics;
	  }
	  function transformDeclarations(context) {
	    const throwDiagnostic = () => Debug.fail("Diagnostic emitted without context");
	    let getSymbolAccessibilityDiagnostic = throwDiagnostic;
	    let needsDeclare = true;
	    let isBundledEmit = false;
	    let resultHasExternalModuleIndicator = false;
	    let needsScopeFixMarker = false;
	    let resultHasScopeMarker = false;
	    let enclosingDeclaration;
	    let necessaryTypeReferences;
	    let lateMarkedStatements;
	    let lateStatementReplacementMap;
	    let suppressNewDiagnosticContexts;
	    let exportedModulesFromDeclarationEmit;
	    const { factory: factory2 } = context;
	    const host = context.getEmitHost();
	    const symbolTracker = {
	      trackSymbol,
	      reportInaccessibleThisError,
	      reportInaccessibleUniqueSymbolError,
	      reportCyclicStructureError,
	      reportPrivateInBaseOfClassExpression,
	      reportLikelyUnsafeImportRequiredError,
	      reportTruncationError,
	      moduleResolverHost: host,
	      trackReferencedAmbientModule,
	      trackExternalModuleSymbolOfImportTypeNode,
	      reportNonlocalAugmentation,
	      reportNonSerializableProperty
	    };
	    let errorNameNode;
	    let errorFallbackNode;
	    let currentSourceFile;
	    let refs;
	    let libs2;
	    let emittedImports;
	    const resolver = context.getEmitResolver();
	    const options = context.getCompilerOptions();
	    const { noResolve, stripInternal } = options;
	    return transformRoot;
	    function recordTypeReferenceDirectivesIfNecessary(typeReferenceDirectives) {
	      if (!typeReferenceDirectives) {
	        return;
	      }
	      necessaryTypeReferences = necessaryTypeReferences || /* @__PURE__ */ new Set();
	      for (const ref of typeReferenceDirectives) {
	        necessaryTypeReferences.add(ref);
	      }
	    }
	    function trackReferencedAmbientModule(node, symbol) {
	      const directives = resolver.getTypeReferenceDirectivesForSymbol(symbol, -1 /* All */);
	      if (length(directives)) {
	        return recordTypeReferenceDirectivesIfNecessary(directives);
	      }
	      const container = getSourceFileOfNode(node);
	      refs.set(getOriginalNodeId(container), container);
	    }
	    function trackReferencedAmbientModuleFromImport(node) {
	      const moduleSpecifier = tryGetModuleSpecifierFromDeclaration(node);
	      const symbol = moduleSpecifier && resolver.tryFindAmbientModule(moduleSpecifier);
	      if (symbol == null ? void 0 : symbol.declarations) {
	        for (const decl of symbol.declarations) {
	          if (isAmbientModule(decl) && getSourceFileOfNode(decl) !== currentSourceFile) {
	            trackReferencedAmbientModule(decl, symbol);
	          }
	        }
	      }
	    }
	    function handleSymbolAccessibilityError(symbolAccessibilityResult) {
	      if (symbolAccessibilityResult.accessibility === 0 /* Accessible */) {
	        if (symbolAccessibilityResult.aliasesToMakeVisible) {
	          if (!lateMarkedStatements) {
	            lateMarkedStatements = symbolAccessibilityResult.aliasesToMakeVisible;
	          } else {
	            for (const ref of symbolAccessibilityResult.aliasesToMakeVisible) {
	              pushIfUnique(lateMarkedStatements, ref);
	            }
	          }
	        }
	      } else {
	        const errorInfo = getSymbolAccessibilityDiagnostic(symbolAccessibilityResult);
	        if (errorInfo) {
	          if (errorInfo.typeName) {
	            context.addDiagnostic(createDiagnosticForNode(symbolAccessibilityResult.errorNode || errorInfo.errorNode, errorInfo.diagnosticMessage, getTextOfNode(errorInfo.typeName), symbolAccessibilityResult.errorSymbolName, symbolAccessibilityResult.errorModuleName));
	          } else {
	            context.addDiagnostic(createDiagnosticForNode(symbolAccessibilityResult.errorNode || errorInfo.errorNode, errorInfo.diagnosticMessage, symbolAccessibilityResult.errorSymbolName, symbolAccessibilityResult.errorModuleName));
	          }
	          return true;
	        }
	      }
	      return false;
	    }
	    function trackExternalModuleSymbolOfImportTypeNode(symbol) {
	      if (!isBundledEmit) {
	        (exportedModulesFromDeclarationEmit || (exportedModulesFromDeclarationEmit = [])).push(symbol);
	      }
	    }
	    function trackSymbol(symbol, enclosingDeclaration2, meaning) {
	      if (symbol.flags & 262144 /* TypeParameter */)
	        return false;
	      const issuedDiagnostic = handleSymbolAccessibilityError(resolver.isSymbolAccessible(
	        symbol,
	        enclosingDeclaration2,
	        meaning,
	        /*shouldComputeAliasToMarkVisible*/
	        true
	      ));
	      recordTypeReferenceDirectivesIfNecessary(resolver.getTypeReferenceDirectivesForSymbol(symbol, meaning));
	      return issuedDiagnostic;
	    }
	    function reportPrivateInBaseOfClassExpression(propertyName) {
	      if (errorNameNode || errorFallbackNode) {
	        context.addDiagnostic(
	          createDiagnosticForNode(errorNameNode || errorFallbackNode, Diagnostics.Property_0_of_exported_class_expression_may_not_be_private_or_protected, propertyName)
	        );
	      }
	    }
	    function errorDeclarationNameWithFallback() {
	      return errorNameNode ? declarationNameToString(errorNameNode) : errorFallbackNode && getNameOfDeclaration(errorFallbackNode) ? declarationNameToString(getNameOfDeclaration(errorFallbackNode)) : errorFallbackNode && isExportAssignment(errorFallbackNode) ? errorFallbackNode.isExportEquals ? "export=" : "default" : "(Missing)";
	    }
	    function reportInaccessibleUniqueSymbolError() {
	      if (errorNameNode || errorFallbackNode) {
	        context.addDiagnostic(createDiagnosticForNode(errorNameNode || errorFallbackNode, Diagnostics.The_inferred_type_of_0_references_an_inaccessible_1_type_A_type_annotation_is_necessary, errorDeclarationNameWithFallback(), "unique symbol"));
	      }
	    }
	    function reportCyclicStructureError() {
	      if (errorNameNode || errorFallbackNode) {
	        context.addDiagnostic(createDiagnosticForNode(errorNameNode || errorFallbackNode, Diagnostics.The_inferred_type_of_0_references_a_type_with_a_cyclic_structure_which_cannot_be_trivially_serialized_A_type_annotation_is_necessary, errorDeclarationNameWithFallback()));
	      }
	    }
	    function reportInaccessibleThisError() {
	      if (errorNameNode || errorFallbackNode) {
	        context.addDiagnostic(createDiagnosticForNode(errorNameNode || errorFallbackNode, Diagnostics.The_inferred_type_of_0_references_an_inaccessible_1_type_A_type_annotation_is_necessary, errorDeclarationNameWithFallback(), "this"));
	      }
	    }
	    function reportLikelyUnsafeImportRequiredError(specifier) {
	      if (errorNameNode || errorFallbackNode) {
	        context.addDiagnostic(createDiagnosticForNode(errorNameNode || errorFallbackNode, Diagnostics.The_inferred_type_of_0_cannot_be_named_without_a_reference_to_1_This_is_likely_not_portable_A_type_annotation_is_necessary, errorDeclarationNameWithFallback(), specifier));
	      }
	    }
	    function reportTruncationError() {
	      if (errorNameNode || errorFallbackNode) {
	        context.addDiagnostic(createDiagnosticForNode(errorNameNode || errorFallbackNode, Diagnostics.The_inferred_type_of_this_node_exceeds_the_maximum_length_the_compiler_will_serialize_An_explicit_type_annotation_is_needed));
	      }
	    }
	    function reportNonlocalAugmentation(containingFile, parentSymbol, symbol) {
	      var _a;
	      const primaryDeclaration = (_a = parentSymbol.declarations) == null ? void 0 : _a.find((d) => getSourceFileOfNode(d) === containingFile);
	      const augmentingDeclarations = filter(symbol.declarations, (d) => getSourceFileOfNode(d) !== containingFile);
	      if (primaryDeclaration && augmentingDeclarations) {
	        for (const augmentations of augmentingDeclarations) {
	          context.addDiagnostic(addRelatedInfo(
	            createDiagnosticForNode(augmentations, Diagnostics.Declaration_augments_declaration_in_another_file_This_cannot_be_serialized),
	            createDiagnosticForNode(primaryDeclaration, Diagnostics.This_is_the_declaration_being_augmented_Consider_moving_the_augmenting_declaration_into_the_same_file)
	          ));
	        }
	      }
	    }
	    function reportNonSerializableProperty(propertyName) {
	      if (errorNameNode || errorFallbackNode) {
	        context.addDiagnostic(createDiagnosticForNode(errorNameNode || errorFallbackNode, Diagnostics.The_type_of_this_node_cannot_be_serialized_because_its_property_0_cannot_be_serialized, propertyName));
	      }
	    }
	    function transformDeclarationsForJS(sourceFile, bundled) {
	      const oldDiag = getSymbolAccessibilityDiagnostic;
	      getSymbolAccessibilityDiagnostic = (s) => s.errorNode && canProduceDiagnostics(s.errorNode) ? createGetSymbolAccessibilityDiagnosticForNode(s.errorNode)(s) : {
	        diagnosticMessage: s.errorModuleName ? Diagnostics.Declaration_emit_for_this_file_requires_using_private_name_0_from_module_1_An_explicit_type_annotation_may_unblock_declaration_emit : Diagnostics.Declaration_emit_for_this_file_requires_using_private_name_0_An_explicit_type_annotation_may_unblock_declaration_emit,
	        errorNode: s.errorNode || sourceFile
	      };
	      const result = resolver.getDeclarationStatementsForSourceFile(sourceFile, declarationEmitNodeBuilderFlags, symbolTracker, bundled);
	      getSymbolAccessibilityDiagnostic = oldDiag;
	      return result;
	    }
	    function transformRoot(node) {
	      if (node.kind === 312 /* SourceFile */ && node.isDeclarationFile) {
	        return node;
	      }
	      if (node.kind === 313 /* Bundle */) {
	        isBundledEmit = true;
	        refs = /* @__PURE__ */ new Map();
	        libs2 = /* @__PURE__ */ new Map();
	        let hasNoDefaultLib = false;
	        const bundle = factory2.createBundle(
	          map(node.sourceFiles, (sourceFile) => {
	            if (sourceFile.isDeclarationFile)
	              return void 0;
	            hasNoDefaultLib = hasNoDefaultLib || sourceFile.hasNoDefaultLib;
	            currentSourceFile = sourceFile;
	            enclosingDeclaration = sourceFile;
	            lateMarkedStatements = void 0;
	            suppressNewDiagnosticContexts = false;
	            lateStatementReplacementMap = /* @__PURE__ */ new Map();
	            getSymbolAccessibilityDiagnostic = throwDiagnostic;
	            needsScopeFixMarker = false;
	            resultHasScopeMarker = false;
	            collectReferences(sourceFile, refs);
	            collectLibs(sourceFile, libs2);
	            if (isExternalOrCommonJsModule(sourceFile) || isJsonSourceFile(sourceFile)) {
	              resultHasExternalModuleIndicator = false;
	              needsDeclare = false;
	              const statements = isSourceFileJS(sourceFile) ? factory2.createNodeArray(transformDeclarationsForJS(
	                sourceFile,
	                /*bundled*/
	                true
	              )) : visitNodes2(sourceFile.statements, visitDeclarationStatements, isStatement);
	              const newFile = factory2.updateSourceFile(
	                sourceFile,
	                [factory2.createModuleDeclaration(
	                  [factory2.createModifier(138 /* DeclareKeyword */)],
	                  factory2.createStringLiteral(getResolvedExternalModuleName(context.getEmitHost(), sourceFile)),
	                  factory2.createModuleBlock(setTextRange(factory2.createNodeArray(transformAndReplaceLatePaintedStatements(statements)), sourceFile.statements))
	                )],
	                /*isDeclarationFile*/
	                true,
	                /*referencedFiles*/
	                [],
	                /*typeReferences*/
	                [],
	                /*hasNoDefaultLib*/
	                false,
	                /*libReferences*/
	                []
	              );
	              return newFile;
	            }
	            needsDeclare = true;
	            const updated2 = isSourceFileJS(sourceFile) ? factory2.createNodeArray(transformDeclarationsForJS(sourceFile)) : visitNodes2(sourceFile.statements, visitDeclarationStatements, isStatement);
	            return factory2.updateSourceFile(
	              sourceFile,
	              transformAndReplaceLatePaintedStatements(updated2),
	              /*isDeclarationFile*/
	              true,
	              /*referencedFiles*/
	              [],
	              /*typeReferences*/
	              [],
	              /*hasNoDefaultLib*/
	              false,
	              /*libReferences*/
	              []
	            );
	          }),
	          mapDefined(node.prepends, (prepend) => {
	            if (prepend.kind === 315 /* InputFiles */) {
	              const sourceFile = createUnparsedSourceFile(prepend, "dts", stripInternal);
	              hasNoDefaultLib = hasNoDefaultLib || !!sourceFile.hasNoDefaultLib;
	              collectReferences(sourceFile, refs);
	              recordTypeReferenceDirectivesIfNecessary(map(sourceFile.typeReferenceDirectives, (ref) => [ref.fileName, ref.resolutionMode]));
	              collectLibs(sourceFile, libs2);
	              return sourceFile;
	            }
	            return prepend;
	          })
	        );
	        bundle.syntheticFileReferences = [];
	        bundle.syntheticTypeReferences = getFileReferencesForUsedTypeReferences();
	        bundle.syntheticLibReferences = getLibReferences();
	        bundle.hasNoDefaultLib = hasNoDefaultLib;
	        const outputFilePath2 = getDirectoryPath(normalizeSlashes(getOutputPathsFor(
	          node,
	          host,
	          /*forceDtsPaths*/
	          true
	        ).declarationFilePath));
	        const referenceVisitor2 = mapReferencesIntoArray(bundle.syntheticFileReferences, outputFilePath2);
	        refs.forEach(referenceVisitor2);
	        return bundle;
	      }
	      needsDeclare = true;
	      needsScopeFixMarker = false;
	      resultHasScopeMarker = false;
	      enclosingDeclaration = node;
	      currentSourceFile = node;
	      getSymbolAccessibilityDiagnostic = throwDiagnostic;
	      isBundledEmit = false;
	      resultHasExternalModuleIndicator = false;
	      suppressNewDiagnosticContexts = false;
	      lateMarkedStatements = void 0;
	      lateStatementReplacementMap = /* @__PURE__ */ new Map();
	      necessaryTypeReferences = void 0;
	      refs = collectReferences(currentSourceFile, /* @__PURE__ */ new Map());
	      libs2 = collectLibs(currentSourceFile, /* @__PURE__ */ new Map());
	      const references = [];
	      const outputFilePath = getDirectoryPath(normalizeSlashes(getOutputPathsFor(
	        node,
	        host,
	        /*forceDtsPaths*/
	        true
	      ).declarationFilePath));
	      const referenceVisitor = mapReferencesIntoArray(references, outputFilePath);
	      let combinedStatements;
	      if (isSourceFileJS(currentSourceFile)) {
	        combinedStatements = factory2.createNodeArray(transformDeclarationsForJS(node));
	        refs.forEach(referenceVisitor);
	        emittedImports = filter(combinedStatements, isAnyImportSyntax);
	      } else {
	        const statements = visitNodes2(node.statements, visitDeclarationStatements, isStatement);
	        combinedStatements = setTextRange(factory2.createNodeArray(transformAndReplaceLatePaintedStatements(statements)), node.statements);
	        refs.forEach(referenceVisitor);
	        emittedImports = filter(combinedStatements, isAnyImportSyntax);
	        if (isExternalModule(node) && (!resultHasExternalModuleIndicator || needsScopeFixMarker && !resultHasScopeMarker)) {
	          combinedStatements = setTextRange(factory2.createNodeArray([...combinedStatements, createEmptyExports(factory2)]), combinedStatements);
	        }
	      }
	      const updated = factory2.updateSourceFile(
	        node,
	        combinedStatements,
	        /*isDeclarationFile*/
	        true,
	        references,
	        getFileReferencesForUsedTypeReferences(),
	        node.hasNoDefaultLib,
	        getLibReferences()
	      );
	      updated.exportedModulesFromDeclarationEmit = exportedModulesFromDeclarationEmit;
	      return updated;
	      function getLibReferences() {
	        return arrayFrom(libs2.keys(), (lib) => ({ fileName: lib, pos: -1, end: -1 }));
	      }
	      function getFileReferencesForUsedTypeReferences() {
	        return necessaryTypeReferences ? mapDefined(arrayFrom(necessaryTypeReferences.keys()), getFileReferenceForSpecifierModeTuple) : [];
	      }
	      function getFileReferenceForSpecifierModeTuple([typeName, mode]) {
	        if (emittedImports) {
	          for (const importStatement of emittedImports) {
	            if (isImportEqualsDeclaration(importStatement) && isExternalModuleReference(importStatement.moduleReference)) {
	              const expr = importStatement.moduleReference.expression;
	              if (isStringLiteralLike(expr) && expr.text === typeName) {
	                return void 0;
	              }
	            } else if (isImportDeclaration(importStatement) && isStringLiteral(importStatement.moduleSpecifier) && importStatement.moduleSpecifier.text === typeName) {
	              return void 0;
	            }
	          }
	        }
	        return { fileName: typeName, pos: -1, end: -1, ...mode ? { resolutionMode: mode } : void 0 };
	      }
	      function mapReferencesIntoArray(references2, outputFilePath2) {
	        return (file) => {
	          if (exportedModulesFromDeclarationEmit == null ? void 0 : exportedModulesFromDeclarationEmit.includes(file.symbol)) {
	            return;
	          }
	          let declFileName;
	          if (file.isDeclarationFile) {
	            declFileName = file.fileName;
	          } else {
	            if (isBundledEmit && contains(node.sourceFiles, file))
	              return;
	            const paths = getOutputPathsFor(
	              file,
	              host,
	              /*forceDtsPaths*/
	              true
	            );
	            declFileName = paths.declarationFilePath || paths.jsFilePath || file.fileName;
	          }
	          if (declFileName) {
	            const specifier = getModuleSpecifier(
	              options,
	              currentSourceFile,
	              getNormalizedAbsolutePath(outputFilePath2, host.getCurrentDirectory()),
	              getNormalizedAbsolutePath(declFileName, host.getCurrentDirectory()),
	              host
	            );
	            if (!pathIsRelative(specifier)) {
	              recordTypeReferenceDirectivesIfNecessary([[
	                specifier,
	                /*mode*/
	                void 0
	              ]]);
	              return;
	            }
	            let fileName = getRelativePathToDirectoryOrUrl(
	              outputFilePath2,
	              declFileName,
	              host.getCurrentDirectory(),
	              host.getCanonicalFileName,
	              /*isAbsolutePathAnUrl*/
	              false
	            );
	            if (startsWith(fileName, "./") && hasExtension(fileName)) {
	              fileName = fileName.substring(2);
	            }
	            if (startsWith(fileName, "node_modules/") || pathContainsNodeModules(fileName)) {
	              return;
	            }
	            references2.push({ pos: -1, end: -1, fileName });
	          }
	        };
	      }
	    }
	    function collectReferences(sourceFile, ret) {
	      if (noResolve || !isUnparsedSource(sourceFile) && isSourceFileJS(sourceFile))
	        return ret;
	      forEach(sourceFile.referencedFiles, (f) => {
	        const elem = host.getSourceFileFromReference(sourceFile, f);
	        if (elem) {
	          ret.set(getOriginalNodeId(elem), elem);
	        }
	      });
	      return ret;
	    }
	    function collectLibs(sourceFile, ret) {
	      forEach(sourceFile.libReferenceDirectives, (ref) => {
	        const lib = host.getLibFileFromReference(ref);
	        if (lib) {
	          ret.set(toFileNameLowerCase(ref.fileName), true);
	        }
	      });
	      return ret;
	    }
	    function filterBindingPatternInitializers(name) {
	      if (name.kind === 80 /* Identifier */) {
	        return name;
	      } else {
	        if (name.kind === 207 /* ArrayBindingPattern */) {
	          return factory2.updateArrayBindingPattern(name, visitNodes2(name.elements, visitBindingElement, isArrayBindingElement));
	        } else {
	          return factory2.updateObjectBindingPattern(name, visitNodes2(name.elements, visitBindingElement, isBindingElement));
	        }
	      }
	      function visitBindingElement(elem) {
	        if (elem.kind === 232 /* OmittedExpression */) {
	          return elem;
	        }
	        if (elem.propertyName && isComputedPropertyName(elem.propertyName) && isEntityNameExpression(elem.propertyName.expression)) {
	          checkEntityNameVisibility(elem.propertyName.expression, enclosingDeclaration);
	        }
	        return factory2.updateBindingElement(
	          elem,
	          elem.dotDotDotToken,
	          elem.propertyName,
	          filterBindingPatternInitializers(elem.name),
	          shouldPrintWithInitializer(elem) ? elem.initializer : void 0
	        );
	      }
	    }
	    function ensureParameter(p, modifierMask, type) {
	      let oldDiag;
	      if (!suppressNewDiagnosticContexts) {
	        oldDiag = getSymbolAccessibilityDiagnostic;
	        getSymbolAccessibilityDiagnostic = createGetSymbolAccessibilityDiagnosticForNode(p);
	      }
	      const newParam = factory2.updateParameterDeclaration(
	        p,
	        maskModifiers(factory2, p, modifierMask),
	        p.dotDotDotToken,
	        filterBindingPatternInitializers(p.name),
	        resolver.isOptionalParameter(p) ? p.questionToken || factory2.createToken(58 /* QuestionToken */) : void 0,
	        ensureType(
	          p,
	          type || p.type,
	          /*ignorePrivate*/
	          true
	        ),
	        // Ignore private param props, since this type is going straight back into a param
	        ensureNoInitializer(p)
	      );
	      if (!suppressNewDiagnosticContexts) {
	        getSymbolAccessibilityDiagnostic = oldDiag;
	      }
	      return newParam;
	    }
	    function shouldPrintWithInitializer(node) {
	      return canHaveLiteralInitializer(node) && resolver.isLiteralConstDeclaration(getParseTreeNode(node));
	    }
	    function ensureNoInitializer(node) {
	      if (shouldPrintWithInitializer(node)) {
	        return resolver.createLiteralConstValue(getParseTreeNode(node), symbolTracker);
	      }
	      return void 0;
	    }
	    function ensureType(node, type, ignorePrivate) {
	      if (!ignorePrivate && hasEffectiveModifier(node, 2 /* Private */)) {
	        return;
	      }
	      if (shouldPrintWithInitializer(node)) {
	        return;
	      }
	      const shouldUseResolverType = node.kind === 169 /* Parameter */ && (resolver.isRequiredInitializedParameter(node) || resolver.isOptionalUninitializedParameterProperty(node));
	      if (type && !shouldUseResolverType) {
	        return visitNode(type, visitDeclarationSubtree, isTypeNode);
	      }
	      if (!getParseTreeNode(node)) {
	        return type ? visitNode(type, visitDeclarationSubtree, isTypeNode) : factory2.createKeywordTypeNode(133 /* AnyKeyword */);
	      }
	      if (node.kind === 178 /* SetAccessor */) {
	        return factory2.createKeywordTypeNode(133 /* AnyKeyword */);
	      }
	      errorNameNode = node.name;
	      let oldDiag;
	      if (!suppressNewDiagnosticContexts) {
	        oldDiag = getSymbolAccessibilityDiagnostic;
	        getSymbolAccessibilityDiagnostic = createGetSymbolAccessibilityDiagnosticForNode(node);
	      }
	      if (node.kind === 260 /* VariableDeclaration */ || node.kind === 208 /* BindingElement */) {
	        return cleanup(resolver.createTypeOfDeclaration(node, enclosingDeclaration, declarationEmitNodeBuilderFlags, symbolTracker));
	      }
	      if (node.kind === 169 /* Parameter */ || node.kind === 172 /* PropertyDeclaration */ || node.kind === 171 /* PropertySignature */) {
	        if (isPropertySignature(node) || !node.initializer)
	          return cleanup(resolver.createTypeOfDeclaration(node, enclosingDeclaration, declarationEmitNodeBuilderFlags, symbolTracker, shouldUseResolverType));
	        return cleanup(resolver.createTypeOfDeclaration(node, enclosingDeclaration, declarationEmitNodeBuilderFlags, symbolTracker, shouldUseResolverType) || resolver.createTypeOfExpression(node.initializer, enclosingDeclaration, declarationEmitNodeBuilderFlags, symbolTracker));
	      }
	      return cleanup(resolver.createReturnTypeOfSignatureDeclaration(node, enclosingDeclaration, declarationEmitNodeBuilderFlags, symbolTracker));
	      function cleanup(returnValue) {
	        errorNameNode = void 0;
	        if (!suppressNewDiagnosticContexts) {
	          getSymbolAccessibilityDiagnostic = oldDiag;
	        }
	        return returnValue || factory2.createKeywordTypeNode(133 /* AnyKeyword */);
	      }
	    }
	    function isDeclarationAndNotVisible(node) {
	      node = getParseTreeNode(node);
	      switch (node.kind) {
	        case 262 /* FunctionDeclaration */:
	        case 267 /* ModuleDeclaration */:
	        case 264 /* InterfaceDeclaration */:
	        case 263 /* ClassDeclaration */:
	        case 265 /* TypeAliasDeclaration */:
	        case 266 /* EnumDeclaration */:
	          return !resolver.isDeclarationVisible(node);
	        case 260 /* VariableDeclaration */:
	          return !getBindingNameVisible(node);
	        case 271 /* ImportEqualsDeclaration */:
	        case 272 /* ImportDeclaration */:
	        case 278 /* ExportDeclaration */:
	        case 277 /* ExportAssignment */:
	          return false;
	        case 175 /* ClassStaticBlockDeclaration */:
	          return true;
	      }
	      return false;
	    }
	    function shouldEmitFunctionProperties(input) {
	      var _a;
	      if (input.body) {
	        return true;
	      }
	      const overloadSignatures = (_a = input.symbol.declarations) == null ? void 0 : _a.filter((decl) => isFunctionDeclaration(decl) && !decl.body);
	      return !overloadSignatures || overloadSignatures.indexOf(input) === overloadSignatures.length - 1;
	    }
	    function getBindingNameVisible(elem) {
	      if (isOmittedExpression(elem)) {
	        return false;
	      }
	      if (isBindingPattern(elem.name)) {
	        return some(elem.name.elements, getBindingNameVisible);
	      } else {
	        return resolver.isDeclarationVisible(elem);
	      }
	    }
	    function updateParamsList(node, params, modifierMask) {
	      if (hasEffectiveModifier(node, 2 /* Private */)) {
	        return factory2.createNodeArray();
	      }
	      const newParams = map(params, (p) => ensureParameter(p, modifierMask));
	      if (!newParams) {
	        return factory2.createNodeArray();
	      }
	      return factory2.createNodeArray(newParams, params.hasTrailingComma);
	    }
	    function updateAccessorParamsList(input, isPrivate) {
	      let newParams;
	      if (!isPrivate) {
	        const thisParameter = getThisParameter(input);
	        if (thisParameter) {
	          newParams = [ensureParameter(thisParameter)];
	        }
	      }
	      if (isSetAccessorDeclaration(input)) {
	        let newValueParameter;
	        if (!isPrivate) {
	          const valueParameter = getSetAccessorValueParameter(input);
	          if (valueParameter) {
	            const accessorType = getTypeAnnotationFromAllAccessorDeclarations(input, resolver.getAllAccessorDeclarations(input));
	            newValueParameter = ensureParameter(
	              valueParameter,
	              /*modifierMask*/
	              void 0,
	              accessorType
	            );
	          }
	        }
	        if (!newValueParameter) {
	          newValueParameter = factory2.createParameterDeclaration(
	            /*modifiers*/
	            void 0,
	            /*dotDotDotToken*/
	            void 0,
	            "value"
	          );
	        }
	        newParams = append(newParams, newValueParameter);
	      }
	      return factory2.createNodeArray(newParams || emptyArray);
	    }
	    function ensureTypeParams(node, params) {
	      return hasEffectiveModifier(node, 2 /* Private */) ? void 0 : visitNodes2(params, visitDeclarationSubtree, isTypeParameterDeclaration);
	    }
	    function isEnclosingDeclaration(node) {
	      return isSourceFile(node) || isTypeAliasDeclaration(node) || isModuleDeclaration(node) || isClassDeclaration(node) || isInterfaceDeclaration(node) || isFunctionLike(node) || isIndexSignatureDeclaration(node) || isMappedTypeNode(node);
	    }
	    function checkEntityNameVisibility(entityName, enclosingDeclaration2) {
	      const visibilityResult = resolver.isEntityNameVisible(entityName, enclosingDeclaration2);
	      handleSymbolAccessibilityError(visibilityResult);
	      recordTypeReferenceDirectivesIfNecessary(resolver.getTypeReferenceDirectivesForEntityName(entityName));
	    }
	    function preserveJsDoc(updated, original) {
	      if (hasJSDocNodes(updated) && hasJSDocNodes(original)) {
	        updated.jsDoc = original.jsDoc;
	      }
	      return setCommentRange(updated, getCommentRange(original));
	    }
	    function rewriteModuleSpecifier(parent2, input) {
	      if (!input)
	        return void 0;
	      resultHasExternalModuleIndicator = resultHasExternalModuleIndicator || parent2.kind !== 267 /* ModuleDeclaration */ && parent2.kind !== 205 /* ImportType */;
	      if (isStringLiteralLike(input)) {
	        if (isBundledEmit) {
	          const newName = getExternalModuleNameFromDeclaration(context.getEmitHost(), resolver, parent2);
	          if (newName) {
	            return factory2.createStringLiteral(newName);
	          }
	        } else {
	          const symbol = resolver.getSymbolOfExternalModuleSpecifier(input);
	          if (symbol) {
	            (exportedModulesFromDeclarationEmit || (exportedModulesFromDeclarationEmit = [])).push(symbol);
	          }
	        }
	      }
	      return input;
	    }
	    function transformImportEqualsDeclaration(decl) {
	      if (!resolver.isDeclarationVisible(decl))
	        return;
	      if (decl.moduleReference.kind === 283 /* ExternalModuleReference */) {
	        const specifier = getExternalModuleImportEqualsDeclarationExpression(decl);
	        return factory2.updateImportEqualsDeclaration(
	          decl,
	          decl.modifiers,
	          decl.isTypeOnly,
	          decl.name,
	          factory2.updateExternalModuleReference(decl.moduleReference, rewriteModuleSpecifier(decl, specifier))
	        );
	      } else {
	        const oldDiag = getSymbolAccessibilityDiagnostic;
	        getSymbolAccessibilityDiagnostic = createGetSymbolAccessibilityDiagnosticForNode(decl);
	        checkEntityNameVisibility(decl.moduleReference, enclosingDeclaration);
	        getSymbolAccessibilityDiagnostic = oldDiag;
	        return decl;
	      }
	    }
	    function transformImportDeclaration(decl) {
	      if (!decl.importClause) {
	        return factory2.updateImportDeclaration(
	          decl,
	          decl.modifiers,
	          decl.importClause,
	          rewriteModuleSpecifier(decl, decl.moduleSpecifier),
	          tryGetResolutionModeOverride(decl.attributes)
	        );
	      }
	      const visibleDefaultBinding = decl.importClause && decl.importClause.name && resolver.isDeclarationVisible(decl.importClause) ? decl.importClause.name : void 0;
	      if (!decl.importClause.namedBindings) {
	        return visibleDefaultBinding && factory2.updateImportDeclaration(
	          decl,
	          decl.modifiers,
	          factory2.updateImportClause(
	            decl.importClause,
	            decl.importClause.isTypeOnly,
	            visibleDefaultBinding,
	            /*namedBindings*/
	            void 0
	          ),
	          rewriteModuleSpecifier(decl, decl.moduleSpecifier),
	          tryGetResolutionModeOverride(decl.attributes)
	        );
	      }
	      if (decl.importClause.namedBindings.kind === 274 /* NamespaceImport */) {
	        const namedBindings = resolver.isDeclarationVisible(decl.importClause.namedBindings) ? decl.importClause.namedBindings : (
	          /*namedBindings*/
	          void 0
	        );
	        return visibleDefaultBinding || namedBindings ? factory2.updateImportDeclaration(
	          decl,
	          decl.modifiers,
	          factory2.updateImportClause(
	            decl.importClause,
	            decl.importClause.isTypeOnly,
	            visibleDefaultBinding,
	            namedBindings
	          ),
	          rewriteModuleSpecifier(decl, decl.moduleSpecifier),
	          tryGetResolutionModeOverride(decl.attributes)
	        ) : void 0;
	      }
	      const bindingList = mapDefined(decl.importClause.namedBindings.elements, (b) => resolver.isDeclarationVisible(b) ? b : void 0);
	      if (bindingList && bindingList.length || visibleDefaultBinding) {
	        return factory2.updateImportDeclaration(
	          decl,
	          decl.modifiers,
	          factory2.updateImportClause(
	            decl.importClause,
	            decl.importClause.isTypeOnly,
	            visibleDefaultBinding,
	            bindingList && bindingList.length ? factory2.updateNamedImports(decl.importClause.namedBindings, bindingList) : void 0
	          ),
	          rewriteModuleSpecifier(decl, decl.moduleSpecifier),
	          tryGetResolutionModeOverride(decl.attributes)
	        );
	      }
	      if (resolver.isImportRequiredByAugmentation(decl)) {
	        return factory2.updateImportDeclaration(
	          decl,
	          decl.modifiers,
	          /*importClause*/
	          void 0,
	          rewriteModuleSpecifier(decl, decl.moduleSpecifier),
	          tryGetResolutionModeOverride(decl.attributes)
	        );
	      }
	    }
	    function tryGetResolutionModeOverride(node) {
	      const mode = getResolutionModeOverride(node);
	      return node && mode !== void 0 ? node : void 0;
	    }
	    function transformAndReplaceLatePaintedStatements(statements) {
	      while (length(lateMarkedStatements)) {
	        const i = lateMarkedStatements.shift();
	        if (!isLateVisibilityPaintedStatement(i)) {
	          return Debug.fail(`Late replaced statement was found which is not handled by the declaration transformer!: ${Debug.formatSyntaxKind(i.kind)}`);
	        }
	        const priorNeedsDeclare = needsDeclare;
	        needsDeclare = i.parent && isSourceFile(i.parent) && !(isExternalModule(i.parent) && isBundledEmit);
	        const result = transformTopLevelDeclaration(i);
	        needsDeclare = priorNeedsDeclare;
	        lateStatementReplacementMap.set(getOriginalNodeId(i), result);
	      }
	      return visitNodes2(statements, visitLateVisibilityMarkedStatements, isStatement);
	      function visitLateVisibilityMarkedStatements(statement) {
	        if (isLateVisibilityPaintedStatement(statement)) {
	          const key = getOriginalNodeId(statement);
	          if (lateStatementReplacementMap.has(key)) {
	            const result = lateStatementReplacementMap.get(key);
	            lateStatementReplacementMap.delete(key);
	            if (result) {
	              if (isArray(result) ? some(result, needsScopeMarker) : needsScopeMarker(result)) {
	                needsScopeFixMarker = true;
	              }
	              if (isSourceFile(statement.parent) && (isArray(result) ? some(result, isExternalModuleIndicator) : isExternalModuleIndicator(result))) {
	                resultHasExternalModuleIndicator = true;
	              }
	            }
	            return result;
	          }
	        }
	        return statement;
	      }
	    }
	    function visitDeclarationSubtree(input) {
	      if (shouldStripInternal(input))
	        return;
	      if (isDeclaration(input)) {
	        if (isDeclarationAndNotVisible(input))
	          return;
	        if (hasDynamicName(input) && !resolver.isLateBound(getParseTreeNode(input))) {
	          return;
	        }
	      }
	      if (isFunctionLike(input) && resolver.isImplementationOfOverload(input))
	        return;
	      if (isSemicolonClassElement(input))
	        return;
	      let previousEnclosingDeclaration;
	      if (isEnclosingDeclaration(input)) {
	        previousEnclosingDeclaration = enclosingDeclaration;
	        enclosingDeclaration = input;
	      }
	      const oldDiag = getSymbolAccessibilityDiagnostic;
	      const canProduceDiagnostic = canProduceDiagnostics(input);
	      const oldWithinObjectLiteralType = suppressNewDiagnosticContexts;
	      let shouldEnterSuppressNewDiagnosticsContextContext = (input.kind === 187 /* TypeLiteral */ || input.kind === 200 /* MappedType */) && input.parent.kind !== 265 /* TypeAliasDeclaration */;
	      if (isMethodDeclaration(input) || isMethodSignature(input)) {
	        if (hasEffectiveModifier(input, 2 /* Private */)) {
	          if (input.symbol && input.symbol.declarations && input.symbol.declarations[0] !== input)
	            return;
	          return cleanup(factory2.createPropertyDeclaration(
	            ensureModifiers(input),
	            input.name,
	            /*questionOrExclamationToken*/
	            void 0,
	            /*type*/
	            void 0,
	            /*initializer*/
	            void 0
	          ));
	        }
	      }
	      if (canProduceDiagnostic && !suppressNewDiagnosticContexts) {
	        getSymbolAccessibilityDiagnostic = createGetSymbolAccessibilityDiagnosticForNode(input);
	      }
	      if (isTypeQueryNode(input)) {
	        checkEntityNameVisibility(input.exprName, enclosingDeclaration);
	      }
	      if (shouldEnterSuppressNewDiagnosticsContextContext) {
	        suppressNewDiagnosticContexts = true;
	      }
	      if (isProcessedComponent(input)) {
	        switch (input.kind) {
	          case 233 /* ExpressionWithTypeArguments */: {
	            if (isEntityName(input.expression) || isEntityNameExpression(input.expression)) {
	              checkEntityNameVisibility(input.expression, enclosingDeclaration);
	            }
	            const node = visitEachChild(input, visitDeclarationSubtree, context);
	            return cleanup(factory2.updateExpressionWithTypeArguments(node, node.expression, node.typeArguments));
	          }
	          case 183 /* TypeReference */: {
	            checkEntityNameVisibility(input.typeName, enclosingDeclaration);
	            const node = visitEachChild(input, visitDeclarationSubtree, context);
	            return cleanup(factory2.updateTypeReferenceNode(node, node.typeName, node.typeArguments));
	          }
	          case 180 /* ConstructSignature */:
	            return cleanup(factory2.updateConstructSignature(
	              input,
	              ensureTypeParams(input, input.typeParameters),
	              updateParamsList(input, input.parameters),
	              ensureType(input, input.type)
	            ));
	          case 176 /* Constructor */: {
	            const ctor = factory2.createConstructorDeclaration(
	              /*modifiers*/
	              ensureModifiers(input),
	              updateParamsList(input, input.parameters, 0 /* None */),
	              /*body*/
	              void 0
	            );
	            return cleanup(ctor);
	          }
	          case 174 /* MethodDeclaration */: {
	            if (isPrivateIdentifier(input.name)) {
	              return cleanup(
	                /*returnValue*/
	                void 0
	              );
	            }
	            const sig = factory2.createMethodDeclaration(
	              ensureModifiers(input),
	              /*asteriskToken*/
	              void 0,
	              input.name,
	              input.questionToken,
	              ensureTypeParams(input, input.typeParameters),
	              updateParamsList(input, input.parameters),
	              ensureType(input, input.type),
	              /*body*/
	              void 0
	            );
	            return cleanup(sig);
	          }
	          case 177 /* GetAccessor */: {
	            if (isPrivateIdentifier(input.name)) {
	              return cleanup(
	                /*returnValue*/
	                void 0
	              );
	            }
	            const accessorType = getTypeAnnotationFromAllAccessorDeclarations(input, resolver.getAllAccessorDeclarations(input));
	            return cleanup(factory2.updateGetAccessorDeclaration(
	              input,
	              ensureModifiers(input),
	              input.name,
	              updateAccessorParamsList(input, hasEffectiveModifier(input, 2 /* Private */)),
	              ensureType(input, accessorType),
	              /*body*/
	              void 0
	            ));
	          }
	          case 178 /* SetAccessor */: {
	            if (isPrivateIdentifier(input.name)) {
	              return cleanup(
	                /*returnValue*/
	                void 0
	              );
	            }
	            return cleanup(factory2.updateSetAccessorDeclaration(
	              input,
	              ensureModifiers(input),
	              input.name,
	              updateAccessorParamsList(input, hasEffectiveModifier(input, 2 /* Private */)),
	              /*body*/
	              void 0
	            ));
	          }
	          case 172 /* PropertyDeclaration */:
	            if (isPrivateIdentifier(input.name)) {
	              return cleanup(
	                /*returnValue*/
	                void 0
	              );
	            }
	            return cleanup(factory2.updatePropertyDeclaration(
	              input,
	              ensureModifiers(input),
	              input.name,
	              input.questionToken,
	              ensureType(input, input.type),
	              ensureNoInitializer(input)
	            ));
	          case 171 /* PropertySignature */:
	            if (isPrivateIdentifier(input.name)) {
	              return cleanup(
	                /*returnValue*/
	                void 0
	              );
	            }
	            return cleanup(factory2.updatePropertySignature(
	              input,
	              ensureModifiers(input),
	              input.name,
	              input.questionToken,
	              ensureType(input, input.type)
	            ));
	          case 173 /* MethodSignature */: {
	            if (isPrivateIdentifier(input.name)) {
	              return cleanup(
	                /*returnValue*/
	                void 0
	              );
	            }
	            return cleanup(factory2.updateMethodSignature(
	              input,
	              ensureModifiers(input),
	              input.name,
	              input.questionToken,
	              ensureTypeParams(input, input.typeParameters),
	              updateParamsList(input, input.parameters),
	              ensureType(input, input.type)
	            ));
	          }
	          case 179 /* CallSignature */: {
	            return cleanup(
	              factory2.updateCallSignature(
	                input,
	                ensureTypeParams(input, input.typeParameters),
	                updateParamsList(input, input.parameters),
	                ensureType(input, input.type)
	              )
	            );
	          }
	          case 181 /* IndexSignature */: {
	            return cleanup(factory2.updateIndexSignature(
	              input,
	              ensureModifiers(input),
	              updateParamsList(input, input.parameters),
	              visitNode(input.type, visitDeclarationSubtree, isTypeNode) || factory2.createKeywordTypeNode(133 /* AnyKeyword */)
	            ));
	          }
	          case 260 /* VariableDeclaration */: {
	            if (isBindingPattern(input.name)) {
	              return recreateBindingPattern(input.name);
	            }
	            shouldEnterSuppressNewDiagnosticsContextContext = true;
	            suppressNewDiagnosticContexts = true;
	            return cleanup(factory2.updateVariableDeclaration(
	              input,
	              input.name,
	              /*exclamationToken*/
	              void 0,
	              ensureType(input, input.type),
	              ensureNoInitializer(input)
	            ));
	          }
	          case 168 /* TypeParameter */: {
	            if (isPrivateMethodTypeParameter(input) && (input.default || input.constraint)) {
	              return cleanup(factory2.updateTypeParameterDeclaration(
	                input,
	                input.modifiers,
	                input.name,
	                /*constraint*/
	                void 0,
	                /*defaultType*/
	                void 0
	              ));
	            }
	            return cleanup(visitEachChild(input, visitDeclarationSubtree, context));
	          }
	          case 194 /* ConditionalType */: {
	            const checkType = visitNode(input.checkType, visitDeclarationSubtree, isTypeNode);
	            const extendsType = visitNode(input.extendsType, visitDeclarationSubtree, isTypeNode);
	            const oldEnclosingDecl = enclosingDeclaration;
	            enclosingDeclaration = input.trueType;
	            const trueType = visitNode(input.trueType, visitDeclarationSubtree, isTypeNode);
	            enclosingDeclaration = oldEnclosingDecl;
	            const falseType = visitNode(input.falseType, visitDeclarationSubtree, isTypeNode);
	            Debug.assert(checkType);
	            Debug.assert(extendsType);
	            Debug.assert(trueType);
	            Debug.assert(falseType);
	            return cleanup(factory2.updateConditionalTypeNode(input, checkType, extendsType, trueType, falseType));
	          }
	          case 184 /* FunctionType */: {
	            return cleanup(factory2.updateFunctionTypeNode(
	              input,
	              visitNodes2(input.typeParameters, visitDeclarationSubtree, isTypeParameterDeclaration),
	              updateParamsList(input, input.parameters),
	              Debug.checkDefined(visitNode(input.type, visitDeclarationSubtree, isTypeNode))
	            ));
	          }
	          case 185 /* ConstructorType */: {
	            return cleanup(factory2.updateConstructorTypeNode(
	              input,
	              ensureModifiers(input),
	              visitNodes2(input.typeParameters, visitDeclarationSubtree, isTypeParameterDeclaration),
	              updateParamsList(input, input.parameters),
	              Debug.checkDefined(visitNode(input.type, visitDeclarationSubtree, isTypeNode))
	            ));
	          }
	          case 205 /* ImportType */: {
	            if (!isLiteralImportTypeNode(input))
	              return cleanup(input);
	            trackReferencedAmbientModuleFromImport(input);
	            return cleanup(factory2.updateImportTypeNode(
	              input,
	              factory2.updateLiteralTypeNode(input.argument, rewriteModuleSpecifier(input, input.argument.literal)),
	              input.attributes,
	              input.qualifier,
	              visitNodes2(input.typeArguments, visitDeclarationSubtree, isTypeNode),
	              input.isTypeOf
	            ));
	          }
	          default:
	            Debug.assertNever(input, `Attempted to process unhandled node kind: ${Debug.formatSyntaxKind(input.kind)}`);
	        }
	      }
	      if (isTupleTypeNode(input) && getLineAndCharacterOfPosition(currentSourceFile, input.pos).line === getLineAndCharacterOfPosition(currentSourceFile, input.end).line) {
	        setEmitFlags(input, 1 /* SingleLine */);
	      }
	      return cleanup(visitEachChild(input, visitDeclarationSubtree, context));
	      function cleanup(returnValue) {
	        if (returnValue && canProduceDiagnostic && hasDynamicName(input)) {
	          checkName(input);
	        }
	        if (isEnclosingDeclaration(input)) {
	          enclosingDeclaration = previousEnclosingDeclaration;
	        }
	        if (canProduceDiagnostic && !suppressNewDiagnosticContexts) {
	          getSymbolAccessibilityDiagnostic = oldDiag;
	        }
	        if (shouldEnterSuppressNewDiagnosticsContextContext) {
	          suppressNewDiagnosticContexts = oldWithinObjectLiteralType;
	        }
	        if (returnValue === input) {
	          return returnValue;
	        }
	        return returnValue && setOriginalNode(preserveJsDoc(returnValue, input), input);
	      }
	    }
	    function isPrivateMethodTypeParameter(node) {
	      return node.parent.kind === 174 /* MethodDeclaration */ && hasEffectiveModifier(node.parent, 2 /* Private */);
	    }
	    function visitDeclarationStatements(input) {
	      if (!isPreservedDeclarationStatement(input)) {
	        return;
	      }
	      if (shouldStripInternal(input))
	        return;
	      switch (input.kind) {
	        case 278 /* ExportDeclaration */: {
	          if (isSourceFile(input.parent)) {
	            resultHasExternalModuleIndicator = true;
	          }
	          resultHasScopeMarker = true;
	          trackReferencedAmbientModuleFromImport(input);
	          return factory2.updateExportDeclaration(
	            input,
	            input.modifiers,
	            input.isTypeOnly,
	            input.exportClause,
	            rewriteModuleSpecifier(input, input.moduleSpecifier),
	            tryGetResolutionModeOverride(input.attributes)
	          );
	        }
	        case 277 /* ExportAssignment */: {
	          if (isSourceFile(input.parent)) {
	            resultHasExternalModuleIndicator = true;
	          }
	          resultHasScopeMarker = true;
	          if (input.expression.kind === 80 /* Identifier */) {
	            return input;
	          } else {
	            const newId = factory2.createUniqueName("_default", 16 /* Optimistic */);
	            getSymbolAccessibilityDiagnostic = () => ({
	              diagnosticMessage: Diagnostics.Default_export_of_the_module_has_or_is_using_private_name_0,
	              errorNode: input
	            });
	            errorFallbackNode = input;
	            const varDecl = factory2.createVariableDeclaration(
	              newId,
	              /*exclamationToken*/
	              void 0,
	              resolver.createTypeOfExpression(input.expression, input, declarationEmitNodeBuilderFlags, symbolTracker),
	              /*initializer*/
	              void 0
	            );
	            errorFallbackNode = void 0;
	            const statement = factory2.createVariableStatement(needsDeclare ? [factory2.createModifier(138 /* DeclareKeyword */)] : [], factory2.createVariableDeclarationList([varDecl], 2 /* Const */));
	            preserveJsDoc(statement, input);
	            removeAllComments(input);
	            return [statement, factory2.updateExportAssignment(input, input.modifiers, newId)];
	          }
	        }
	      }
	      const result = transformTopLevelDeclaration(input);
	      lateStatementReplacementMap.set(getOriginalNodeId(input), result);
	      return input;
	    }
	    function stripExportModifiers(statement) {
	      if (isImportEqualsDeclaration(statement) || hasEffectiveModifier(statement, 2048 /* Default */) || !canHaveModifiers(statement)) {
	        return statement;
	      }
	      const modifiers = factory2.createModifiersFromModifierFlags(getEffectiveModifierFlags(statement) & (131071 /* All */ ^ 32 /* Export */));
	      return factory2.replaceModifiers(statement, modifiers);
	    }
	    function updateModuleDeclarationAndKeyword(node, modifiers, name, body) {
	      const updated = factory2.updateModuleDeclaration(node, modifiers, name, body);
	      if (isAmbientModule(updated) || updated.flags & 32 /* Namespace */) {
	        return updated;
	      }
	      const fixed = factory2.createModuleDeclaration(
	        updated.modifiers,
	        updated.name,
	        updated.body,
	        updated.flags | 32 /* Namespace */
	      );
	      setOriginalNode(fixed, updated);
	      setTextRange(fixed, updated);
	      return fixed;
	    }
	    function transformTopLevelDeclaration(input) {
	      if (lateMarkedStatements) {
	        while (orderedRemoveItem(lateMarkedStatements, input))
	          ;
	      }
	      if (shouldStripInternal(input))
	        return;
	      switch (input.kind) {
	        case 271 /* ImportEqualsDeclaration */: {
	          const transformed = transformImportEqualsDeclaration(input);
	          if (transformed) {
	            trackReferencedAmbientModuleFromImport(input);
	          }
	          return transformed;
	        }
	        case 272 /* ImportDeclaration */: {
	          const transformed = transformImportDeclaration(input);
	          if (transformed) {
	            trackReferencedAmbientModuleFromImport(input);
	          }
	          return transformed;
	        }
	      }
	      if (isDeclaration(input) && isDeclarationAndNotVisible(input))
	        return;
	      if (isFunctionLike(input) && resolver.isImplementationOfOverload(input))
	        return;
	      let previousEnclosingDeclaration;
	      if (isEnclosingDeclaration(input)) {
	        previousEnclosingDeclaration = enclosingDeclaration;
	        enclosingDeclaration = input;
	      }
	      const canProdiceDiagnostic = canProduceDiagnostics(input);
	      const oldDiag = getSymbolAccessibilityDiagnostic;
	      if (canProdiceDiagnostic) {
	        getSymbolAccessibilityDiagnostic = createGetSymbolAccessibilityDiagnosticForNode(input);
	      }
	      const previousNeedsDeclare = needsDeclare;
	      switch (input.kind) {
	        case 265 /* TypeAliasDeclaration */: {
	          needsDeclare = false;
	          const clean2 = cleanup(factory2.updateTypeAliasDeclaration(
	            input,
	            ensureModifiers(input),
	            input.name,
	            visitNodes2(input.typeParameters, visitDeclarationSubtree, isTypeParameterDeclaration),
	            Debug.checkDefined(visitNode(input.type, visitDeclarationSubtree, isTypeNode))
	          ));
	          needsDeclare = previousNeedsDeclare;
	          return clean2;
	        }
	        case 264 /* InterfaceDeclaration */: {
	          return cleanup(factory2.updateInterfaceDeclaration(
	            input,
	            ensureModifiers(input),
	            input.name,
	            ensureTypeParams(input, input.typeParameters),
	            transformHeritageClauses(input.heritageClauses),
	            visitNodes2(input.members, visitDeclarationSubtree, isTypeElement)
	          ));
	        }
	        case 262 /* FunctionDeclaration */: {
	          const clean2 = cleanup(factory2.updateFunctionDeclaration(
	            input,
	            ensureModifiers(input),
	            /*asteriskToken*/
	            void 0,
	            input.name,
	            ensureTypeParams(input, input.typeParameters),
	            updateParamsList(input, input.parameters),
	            ensureType(input, input.type),
	            /*body*/
	            void 0
	          ));
	          if (clean2 && resolver.isExpandoFunctionDeclaration(input) && shouldEmitFunctionProperties(input)) {
	            const props = resolver.getPropertiesOfContainerFunction(input);
	            const fakespace = parseNodeFactory.createModuleDeclaration(
	              /*modifiers*/
	              void 0,
	              clean2.name || factory2.createIdentifier("_default"),
	              factory2.createModuleBlock([]),
	              32 /* Namespace */
	            );
	            setParent(fakespace, enclosingDeclaration);
	            fakespace.locals = createSymbolTable(props);
	            fakespace.symbol = props[0].parent;
	            const exportMappings = [];
	            let declarations = mapDefined(props, (p) => {
	              if (!isExpandoPropertyDeclaration(p.valueDeclaration)) {
	                return void 0;
	              }
	              const nameStr = unescapeLeadingUnderscores(p.escapedName);
	              if (!isIdentifierText(nameStr, 99 /* ESNext */)) {
	                return void 0;
	              }
	              getSymbolAccessibilityDiagnostic = createGetSymbolAccessibilityDiagnosticForNode(p.valueDeclaration);
	              const type = resolver.createTypeOfDeclaration(p.valueDeclaration, fakespace, declarationEmitNodeBuilderFlags, symbolTracker);
	              getSymbolAccessibilityDiagnostic = oldDiag;
	              const isNonContextualKeywordName = isStringANonContextualKeyword(nameStr);
	              const name = isNonContextualKeywordName ? factory2.getGeneratedNameForNode(p.valueDeclaration) : factory2.createIdentifier(nameStr);
	              if (isNonContextualKeywordName) {
	                exportMappings.push([name, nameStr]);
	              }
	              const varDecl = factory2.createVariableDeclaration(
	                name,
	                /*exclamationToken*/
	                void 0,
	                type,
	                /*initializer*/
	                void 0
	              );
	              return factory2.createVariableStatement(isNonContextualKeywordName ? void 0 : [factory2.createToken(95 /* ExportKeyword */)], factory2.createVariableDeclarationList([varDecl]));
	            });
	            if (!exportMappings.length) {
	              declarations = mapDefined(declarations, (declaration) => factory2.replaceModifiers(declaration, 0 /* None */));
	            } else {
	              declarations.push(factory2.createExportDeclaration(
	                /*modifiers*/
	                void 0,
	                /*isTypeOnly*/
	                false,
	                factory2.createNamedExports(map(exportMappings, ([gen, exp]) => {
	                  return factory2.createExportSpecifier(
	                    /*isTypeOnly*/
	                    false,
	                    gen,
	                    exp
	                  );
	                }))
	              ));
	            }
	            const namespaceDecl = factory2.createModuleDeclaration(ensureModifiers(input), input.name, factory2.createModuleBlock(declarations), 32 /* Namespace */);
	            if (!hasEffectiveModifier(clean2, 2048 /* Default */)) {
	              return [clean2, namespaceDecl];
	            }
	            const modifiers = factory2.createModifiersFromModifierFlags(getEffectiveModifierFlags(clean2) & ~2080 /* ExportDefault */ | 128 /* Ambient */);
	            const cleanDeclaration = factory2.updateFunctionDeclaration(
	              clean2,
	              modifiers,
	              /*asteriskToken*/
	              void 0,
	              clean2.name,
	              clean2.typeParameters,
	              clean2.parameters,
	              clean2.type,
	              /*body*/
	              void 0
	            );
	            const namespaceDeclaration = factory2.updateModuleDeclaration(
	              namespaceDecl,
	              modifiers,
	              namespaceDecl.name,
	              namespaceDecl.body
	            );
	            const exportDefaultDeclaration = factory2.createExportAssignment(
	              /*modifiers*/
	              void 0,
	              /*isExportEquals*/
	              false,
	              namespaceDecl.name
	            );
	            if (isSourceFile(input.parent)) {
	              resultHasExternalModuleIndicator = true;
	            }
	            resultHasScopeMarker = true;
	            return [cleanDeclaration, namespaceDeclaration, exportDefaultDeclaration];
	          } else {
	            return clean2;
	          }
	        }
	        case 267 /* ModuleDeclaration */: {
	          needsDeclare = false;
	          const inner = input.body;
	          if (inner && inner.kind === 268 /* ModuleBlock */) {
	            const oldNeedsScopeFix = needsScopeFixMarker;
	            const oldHasScopeFix = resultHasScopeMarker;
	            resultHasScopeMarker = false;
	            needsScopeFixMarker = false;
	            const statements = visitNodes2(inner.statements, visitDeclarationStatements, isStatement);
	            let lateStatements = transformAndReplaceLatePaintedStatements(statements);
	            if (input.flags & 33554432 /* Ambient */) {
	              needsScopeFixMarker = false;
	            }
	            if (!isGlobalScopeAugmentation(input) && !hasScopeMarker2(lateStatements) && !resultHasScopeMarker) {
	              if (needsScopeFixMarker) {
	                lateStatements = factory2.createNodeArray([...lateStatements, createEmptyExports(factory2)]);
	              } else {
	                lateStatements = visitNodes2(lateStatements, stripExportModifiers, isStatement);
	              }
	            }
	            const body = factory2.updateModuleBlock(inner, lateStatements);
	            needsDeclare = previousNeedsDeclare;
	            needsScopeFixMarker = oldNeedsScopeFix;
	            resultHasScopeMarker = oldHasScopeFix;
	            const mods = ensureModifiers(input);
	            return cleanup(updateModuleDeclarationAndKeyword(
	              input,
	              mods,
	              isExternalModuleAugmentation(input) ? rewriteModuleSpecifier(input, input.name) : input.name,
	              body
	            ));
	          } else {
	            needsDeclare = previousNeedsDeclare;
	            const mods = ensureModifiers(input);
	            needsDeclare = false;
	            visitNode(inner, visitDeclarationStatements);
	            const id = getOriginalNodeId(inner);
	            const body = lateStatementReplacementMap.get(id);
	            lateStatementReplacementMap.delete(id);
	            return cleanup(updateModuleDeclarationAndKeyword(
	              input,
	              mods,
	              input.name,
	              body
	            ));
	          }
	        }
	        case 263 /* ClassDeclaration */: {
	          errorNameNode = input.name;
	          errorFallbackNode = input;
	          const modifiers = factory2.createNodeArray(ensureModifiers(input));
	          const typeParameters = ensureTypeParams(input, input.typeParameters);
	          const ctor = getFirstConstructorWithBody(input);
	          let parameterProperties;
	          if (ctor) {
	            const oldDiag2 = getSymbolAccessibilityDiagnostic;
	            parameterProperties = compact(flatMap(ctor.parameters, (param) => {
	              if (!hasSyntacticModifier(param, 31 /* ParameterPropertyModifier */) || shouldStripInternal(param))
	                return;
	              getSymbolAccessibilityDiagnostic = createGetSymbolAccessibilityDiagnosticForNode(param);
	              if (param.name.kind === 80 /* Identifier */) {
	                return preserveJsDoc(
	                  factory2.createPropertyDeclaration(
	                    ensureModifiers(param),
	                    param.name,
	                    param.questionToken,
	                    ensureType(param, param.type),
	                    ensureNoInitializer(param)
	                  ),
	                  param
	                );
	              } else {
	                return walkBindingPattern(param.name);
	              }
	              function walkBindingPattern(pattern) {
	                let elems;
	                for (const elem of pattern.elements) {
	                  if (isOmittedExpression(elem))
	                    continue;
	                  if (isBindingPattern(elem.name)) {
	                    elems = concatenate(elems, walkBindingPattern(elem.name));
	                  }
	                  elems = elems || [];
	                  elems.push(factory2.createPropertyDeclaration(
	                    ensureModifiers(param),
	                    elem.name,
	                    /*questionOrExclamationToken*/
	                    void 0,
	                    ensureType(
	                      elem,
	                      /*type*/
	                      void 0
	                    ),
	                    /*initializer*/
	                    void 0
	                  ));
	                }
	                return elems;
	              }
	            }));
	            getSymbolAccessibilityDiagnostic = oldDiag2;
	          }
	          const hasPrivateIdentifier = some(input.members, (member) => !!member.name && isPrivateIdentifier(member.name));
	          const privateIdentifier = hasPrivateIdentifier ? [
	            factory2.createPropertyDeclaration(
	              /*modifiers*/
	              void 0,
	              factory2.createPrivateIdentifier("#private"),
	              /*questionOrExclamationToken*/
	              void 0,
	              /*type*/
	              void 0,
	              /*initializer*/
	              void 0
	            )
	          ] : void 0;
	          const memberNodes = concatenate(concatenate(privateIdentifier, parameterProperties), visitNodes2(input.members, visitDeclarationSubtree, isClassElement));
	          const members = factory2.createNodeArray(memberNodes);
	          const extendsClause = getEffectiveBaseTypeNode(input);
	          if (extendsClause && !isEntityNameExpression(extendsClause.expression) && extendsClause.expression.kind !== 106 /* NullKeyword */) {
	            const oldId = input.name ? unescapeLeadingUnderscores(input.name.escapedText) : "default";
	            const newId = factory2.createUniqueName(`${oldId}_base`, 16 /* Optimistic */);
	            getSymbolAccessibilityDiagnostic = () => ({
	              diagnosticMessage: Diagnostics.extends_clause_of_exported_class_0_has_or_is_using_private_name_1,
	              errorNode: extendsClause,
	              typeName: input.name
	            });
	            const varDecl = factory2.createVariableDeclaration(
	              newId,
	              /*exclamationToken*/
	              void 0,
	              resolver.createTypeOfExpression(extendsClause.expression, input, declarationEmitNodeBuilderFlags, symbolTracker),
	              /*initializer*/
	              void 0
	            );
	            const statement = factory2.createVariableStatement(needsDeclare ? [factory2.createModifier(138 /* DeclareKeyword */)] : [], factory2.createVariableDeclarationList([varDecl], 2 /* Const */));
	            const heritageClauses = factory2.createNodeArray(map(input.heritageClauses, (clause) => {
	              if (clause.token === 96 /* ExtendsKeyword */) {
	                const oldDiag2 = getSymbolAccessibilityDiagnostic;
	                getSymbolAccessibilityDiagnostic = createGetSymbolAccessibilityDiagnosticForNode(clause.types[0]);
	                const newClause = factory2.updateHeritageClause(clause, map(clause.types, (t) => factory2.updateExpressionWithTypeArguments(t, newId, visitNodes2(t.typeArguments, visitDeclarationSubtree, isTypeNode))));
	                getSymbolAccessibilityDiagnostic = oldDiag2;
	                return newClause;
	              }
	              return factory2.updateHeritageClause(clause, visitNodes2(factory2.createNodeArray(filter(clause.types, (t) => isEntityNameExpression(t.expression) || t.expression.kind === 106 /* NullKeyword */)), visitDeclarationSubtree, isExpressionWithTypeArguments));
	            }));
	            return [
	              statement,
	              cleanup(factory2.updateClassDeclaration(
	                input,
	                modifiers,
	                input.name,
	                typeParameters,
	                heritageClauses,
	                members
	              ))
	            ];
	          } else {
	            const heritageClauses = transformHeritageClauses(input.heritageClauses);
	            return cleanup(factory2.updateClassDeclaration(
	              input,
	              modifiers,
	              input.name,
	              typeParameters,
	              heritageClauses,
	              members
	            ));
	          }
	        }
	        case 243 /* VariableStatement */: {
	          return cleanup(transformVariableStatement(input));
	        }
	        case 266 /* EnumDeclaration */: {
	          return cleanup(factory2.updateEnumDeclaration(
	            input,
	            factory2.createNodeArray(ensureModifiers(input)),
	            input.name,
	            factory2.createNodeArray(mapDefined(input.members, (m) => {
	              if (shouldStripInternal(m))
	                return;
	              const constValue = resolver.getConstantValue(m);
	              const newInitializer = constValue === void 0 ? void 0 : typeof constValue === "string" ? factory2.createStringLiteral(constValue) : constValue < 0 ? factory2.createPrefixUnaryExpression(41 /* MinusToken */, factory2.createNumericLiteral(-constValue)) : factory2.createNumericLiteral(constValue);
	              return preserveJsDoc(factory2.updateEnumMember(m, m.name, newInitializer), m);
	            }))
	          ));
	        }
	      }
	      return Debug.assertNever(input, `Unhandled top-level node in declaration emit: ${Debug.formatSyntaxKind(input.kind)}`);
	      function cleanup(node) {
	        if (isEnclosingDeclaration(input)) {
	          enclosingDeclaration = previousEnclosingDeclaration;
	        }
	        if (canProdiceDiagnostic) {
	          getSymbolAccessibilityDiagnostic = oldDiag;
	        }
	        if (input.kind === 267 /* ModuleDeclaration */) {
	          needsDeclare = previousNeedsDeclare;
	        }
	        if (node === input) {
	          return node;
	        }
	        errorFallbackNode = void 0;
	        errorNameNode = void 0;
	        return node && setOriginalNode(preserveJsDoc(node, input), input);
	      }
	    }
	    function transformVariableStatement(input) {
	      if (!forEach(input.declarationList.declarations, getBindingNameVisible))
	        return;
	      const nodes = visitNodes2(input.declarationList.declarations, visitDeclarationSubtree, isVariableDeclaration);
	      if (!length(nodes))
	        return;
	      const modifiers = factory2.createNodeArray(ensureModifiers(input));
	      let declList;
	      if (isVarUsing(input.declarationList) || isVarAwaitUsing(input.declarationList)) {
	        declList = factory2.createVariableDeclarationList(nodes, 2 /* Const */);
	        setOriginalNode(declList, input.declarationList);
	        setTextRange(declList, input.declarationList);
	        setCommentRange(declList, input.declarationList);
	      } else {
	        declList = factory2.updateVariableDeclarationList(input.declarationList, nodes);
	      }
	      return factory2.updateVariableStatement(input, modifiers, declList);
	    }
	    function recreateBindingPattern(d) {
	      return flatten(mapDefined(d.elements, (e) => recreateBindingElement(e)));
	    }
	    function recreateBindingElement(e) {
	      if (e.kind === 232 /* OmittedExpression */) {
	        return;
	      }
	      if (e.name) {
	        if (!getBindingNameVisible(e))
	          return;
	        if (isBindingPattern(e.name)) {
	          return recreateBindingPattern(e.name);
	        } else {
	          return factory2.createVariableDeclaration(
	            e.name,
	            /*exclamationToken*/
	            void 0,
	            ensureType(
	              e,
	              /*type*/
	              void 0
	            ),
	            /*initializer*/
	            void 0
	          );
	        }
	      }
	    }
	    function checkName(node) {
	      let oldDiag;
	      if (!suppressNewDiagnosticContexts) {
	        oldDiag = getSymbolAccessibilityDiagnostic;
	        getSymbolAccessibilityDiagnostic = createGetSymbolAccessibilityDiagnosticForNodeName(node);
	      }
	      errorNameNode = node.name;
	      Debug.assert(resolver.isLateBound(getParseTreeNode(node)));
	      const decl = node;
	      const entityName = decl.name.expression;
	      checkEntityNameVisibility(entityName, enclosingDeclaration);
	      if (!suppressNewDiagnosticContexts) {
	        getSymbolAccessibilityDiagnostic = oldDiag;
	      }
	      errorNameNode = void 0;
	    }
	    function shouldStripInternal(node) {
	      return !!stripInternal && !!node && isInternalDeclaration(node, currentSourceFile);
	    }
	    function isScopeMarker2(node) {
	      return isExportAssignment(node) || isExportDeclaration(node);
	    }
	    function hasScopeMarker2(statements) {
	      return some(statements, isScopeMarker2);
	    }
	    function ensureModifiers(node) {
	      const currentFlags = getEffectiveModifierFlags(node);
	      const newFlags = ensureModifierFlags(node);
	      if (currentFlags === newFlags) {
	        return visitArray(node.modifiers, (n) => tryCast(n, isModifier), isModifier);
	      }
	      return factory2.createModifiersFromModifierFlags(newFlags);
	    }
	    function ensureModifierFlags(node) {
	      let mask2 = 131071 /* All */ ^ (1 /* Public */ | 1024 /* Async */ | 16 /* Override */);
	      let additions = needsDeclare && !isAlwaysType(node) ? 128 /* Ambient */ : 0 /* None */;
	      const parentIsFile = node.parent.kind === 312 /* SourceFile */;
	      if (!parentIsFile || isBundledEmit && parentIsFile && isExternalModule(node.parent)) {
	        mask2 ^= 128 /* Ambient */;
	        additions = 0 /* None */;
	      }
	      return maskModifierFlags(node, mask2, additions);
	    }
	    function getTypeAnnotationFromAllAccessorDeclarations(node, accessors) {
	      let accessorType = getTypeAnnotationFromAccessor(node);
	      if (!accessorType && node !== accessors.firstAccessor) {
	        accessorType = getTypeAnnotationFromAccessor(accessors.firstAccessor);
	        getSymbolAccessibilityDiagnostic = createGetSymbolAccessibilityDiagnosticForNode(accessors.firstAccessor);
	      }
	      if (!accessorType && accessors.secondAccessor && node !== accessors.secondAccessor) {
	        accessorType = getTypeAnnotationFromAccessor(accessors.secondAccessor);
	        getSymbolAccessibilityDiagnostic = createGetSymbolAccessibilityDiagnosticForNode(accessors.secondAccessor);
	      }
	      return accessorType;
	    }
	    function transformHeritageClauses(nodes) {
	      return factory2.createNodeArray(filter(
	        map(nodes, (clause) => factory2.updateHeritageClause(
	          clause,
	          visitNodes2(
	            factory2.createNodeArray(filter(clause.types, (t) => {
	              return isEntityNameExpression(t.expression) || clause.token === 96 /* ExtendsKeyword */ && t.expression.kind === 106 /* NullKeyword */;
	            })),
	            visitDeclarationSubtree,
	            isExpressionWithTypeArguments
	          )
	        )),
	        (clause) => clause.types && !!clause.types.length
	      ));
	    }
	  }
	  function isAlwaysType(node) {
	    if (node.kind === 264 /* InterfaceDeclaration */) {
	      return true;
	    }
	    return false;
	  }
	  function maskModifiers(factory2, node, modifierMask, modifierAdditions) {
	    return factory2.createModifiersFromModifierFlags(maskModifierFlags(node, modifierMask, modifierAdditions));
	  }
	  function maskModifierFlags(node, modifierMask = 131071 /* All */ ^ 1 /* Public */, modifierAdditions = 0 /* None */) {
	    let flags = getEffectiveModifierFlags(node) & modifierMask | modifierAdditions;
	    if (flags & 2048 /* Default */ && !(flags & 32 /* Export */)) {
	      flags ^= 32 /* Export */;
	    }
	    if (flags & 2048 /* Default */ && flags & 128 /* Ambient */) {
	      flags ^= 128 /* Ambient */;
	    }
	    return flags;
	  }
	  function getTypeAnnotationFromAccessor(accessor) {
	    if (accessor) {
	      return accessor.kind === 177 /* GetAccessor */ ? accessor.type : accessor.parameters.length > 0 ? accessor.parameters[0].type : void 0;
	    }
	  }
	  function canHaveLiteralInitializer(node) {
	    switch (node.kind) {
	      case 172 /* PropertyDeclaration */:
	      case 171 /* PropertySignature */:
	        return !hasEffectiveModifier(node, 2 /* Private */);
	      case 169 /* Parameter */:
	      case 260 /* VariableDeclaration */:
	        return true;
	    }
	    return false;
	  }
	  function isPreservedDeclarationStatement(node) {
	    switch (node.kind) {
	      case 262 /* FunctionDeclaration */:
	      case 267 /* ModuleDeclaration */:
	      case 271 /* ImportEqualsDeclaration */:
	      case 264 /* InterfaceDeclaration */:
	      case 263 /* ClassDeclaration */:
	      case 265 /* TypeAliasDeclaration */:
	      case 266 /* EnumDeclaration */:
	      case 243 /* VariableStatement */:
	      case 272 /* ImportDeclaration */:
	      case 278 /* ExportDeclaration */:
	      case 277 /* ExportAssignment */:
	        return true;
	    }
	    return false;
	  }
	  function isProcessedComponent(node) {
	    switch (node.kind) {
	      case 180 /* ConstructSignature */:
	      case 176 /* Constructor */:
	      case 174 /* MethodDeclaration */:
	      case 177 /* GetAccessor */:
	      case 178 /* SetAccessor */:
	      case 172 /* PropertyDeclaration */:
	      case 171 /* PropertySignature */:
	      case 173 /* MethodSignature */:
	      case 179 /* CallSignature */:
	      case 181 /* IndexSignature */:
	      case 260 /* VariableDeclaration */:
	      case 168 /* TypeParameter */:
	      case 233 /* ExpressionWithTypeArguments */:
	      case 183 /* TypeReference */:
	      case 194 /* ConditionalType */:
	      case 184 /* FunctionType */:
	      case 185 /* ConstructorType */:
	      case 205 /* ImportType */:
	        return true;
	    }
	    return false;
	  }
	  var declarationEmitNodeBuilderFlags;
	  var init_declarations = __esm({
	    "src/compiler/transformers/declarations.ts"() {
	      init_ts2();
	      init_ts_moduleSpecifiers();
	      declarationEmitNodeBuilderFlags = 1024 /* MultilineObjectLiterals */ | 2048 /* WriteClassExpressionAsTypeLiteral */ | 4096 /* UseTypeOfFunction */ | 8 /* UseStructuralFallback */ | 524288 /* AllowEmptyTuple */ | 4 /* GenerateNamesForShadowedTypeParams */ | 1 /* NoTruncation */;
	    }
	  });

	  // src/compiler/transformer.ts
	  function getModuleTransformer(moduleKind) {
	    switch (moduleKind) {
	      case 99 /* ESNext */:
	      case 7 /* ES2022 */:
	      case 6 /* ES2020 */:
	      case 5 /* ES2015 */:
	      case 200 /* Preserve */:
	        return transformECMAScriptModule;
	      case 4 /* System */:
	        return transformSystemModule;
	      case 100 /* Node16 */:
	      case 199 /* NodeNext */:
	        return transformNodeModule;
	      default:
	        return transformModule;
	    }
	  }
	  function getTransformers(compilerOptions, customTransformers, emitOnly) {
	    return {
	      scriptTransformers: getScriptTransformers(compilerOptions, customTransformers, emitOnly),
	      declarationTransformers: getDeclarationTransformers(customTransformers)
	    };
	  }
	  function getScriptTransformers(compilerOptions, customTransformers, emitOnly) {
	    if (emitOnly)
	      return emptyArray;
	    const languageVersion = getEmitScriptTarget(compilerOptions);
	    const moduleKind = getEmitModuleKind(compilerOptions);
	    const useDefineForClassFields = getUseDefineForClassFields(compilerOptions);
	    const transformers = [];
	    addRange(transformers, customTransformers && map(customTransformers.before, wrapScriptTransformerFactory));
	    transformers.push(transformTypeScript);
	    if (compilerOptions.experimentalDecorators) {
	      transformers.push(transformLegacyDecorators);
	    }
	    if (getJSXTransformEnabled(compilerOptions)) {
	      transformers.push(transformJsx);
	    }
	    if (languageVersion < 99 /* ESNext */) {
	      transformers.push(transformESNext);
	    }
	    if (!compilerOptions.experimentalDecorators && (languageVersion < 99 /* ESNext */ || !useDefineForClassFields)) {
	      transformers.push(transformESDecorators);
	    }
	    transformers.push(transformClassFields);
	    if (languageVersion < 8 /* ES2021 */) {
	      transformers.push(transformES2021);
	    }
	    if (languageVersion < 7 /* ES2020 */) {
	      transformers.push(transformES2020);
	    }
	    if (languageVersion < 6 /* ES2019 */) {
	      transformers.push(transformES2019);
	    }
	    if (languageVersion < 5 /* ES2018 */) {
	      transformers.push(transformES2018);
	    }
	    if (languageVersion < 4 /* ES2017 */) {
	      transformers.push(transformES2017);
	    }
	    if (languageVersion < 3 /* ES2016 */) {
	      transformers.push(transformES2016);
	    }
	    if (languageVersion < 2 /* ES2015 */) {
	      transformers.push(transformES2015);
	      transformers.push(transformGenerators);
	    }
	    transformers.push(getModuleTransformer(moduleKind));
	    if (languageVersion < 1 /* ES5 */) {
	      transformers.push(transformES5);
	    }
	    addRange(transformers, customTransformers && map(customTransformers.after, wrapScriptTransformerFactory));
	    return transformers;
	  }
	  function getDeclarationTransformers(customTransformers) {
	    const transformers = [];
	    transformers.push(transformDeclarations);
	    addRange(transformers, customTransformers && map(customTransformers.afterDeclarations, wrapDeclarationTransformerFactory));
	    return transformers;
	  }
	  function wrapCustomTransformer(transformer) {
	    return (node) => isBundle(node) ? transformer.transformBundle(node) : transformer.transformSourceFile(node);
	  }
	  function wrapCustomTransformerFactory(transformer, handleDefault) {
	    return (context) => {
	      const customTransformer = transformer(context);
	      return typeof customTransformer === "function" ? handleDefault(context, customTransformer) : wrapCustomTransformer(customTransformer);
	    };
	  }
	  function wrapScriptTransformerFactory(transformer) {
	    return wrapCustomTransformerFactory(transformer, chainBundle);
	  }
	  function wrapDeclarationTransformerFactory(transformer) {
	    return wrapCustomTransformerFactory(transformer, (_, node) => node);
	  }
	  function noEmitSubstitution(_hint, node) {
	    return node;
	  }
	  function noEmitNotification(hint, node, callback) {
	    callback(hint, node);
	  }
	  function transformNodes(resolver, host, factory2, options, nodes, transformers, allowDtsFiles) {
	    var _a, _b;
	    const enabledSyntaxKindFeatures = new Array(363 /* Count */);
	    let lexicalEnvironmentVariableDeclarations;
	    let lexicalEnvironmentFunctionDeclarations;
	    let lexicalEnvironmentStatements;
	    let lexicalEnvironmentFlags = 0 /* None */;
	    let lexicalEnvironmentVariableDeclarationsStack = [];
	    let lexicalEnvironmentFunctionDeclarationsStack = [];
	    let lexicalEnvironmentStatementsStack = [];
	    let lexicalEnvironmentFlagsStack = [];
	    let lexicalEnvironmentStackOffset = 0;
	    let lexicalEnvironmentSuspended = false;
	    let blockScopedVariableDeclarationsStack = [];
	    let blockScopeStackOffset = 0;
	    let blockScopedVariableDeclarations;
	    let emitHelpers;
	    let onSubstituteNode = noEmitSubstitution;
	    let onEmitNode = noEmitNotification;
	    let state = 0 /* Uninitialized */;
	    const diagnostics = [];
	    const context = {
	      factory: factory2,
	      getCompilerOptions: () => options,
	      getEmitResolver: () => resolver,
	      // TODO: GH#18217
	      getEmitHost: () => host,
	      // TODO: GH#18217
	      getEmitHelperFactory: memoize(() => createEmitHelperFactory(context)),
	      startLexicalEnvironment,
	      suspendLexicalEnvironment,
	      resumeLexicalEnvironment,
	      endLexicalEnvironment,
	      setLexicalEnvironmentFlags,
	      getLexicalEnvironmentFlags,
	      hoistVariableDeclaration,
	      hoistFunctionDeclaration,
	      addInitializationStatement,
	      startBlockScope,
	      endBlockScope,
	      addBlockScopedVariable,
	      requestEmitHelper,
	      readEmitHelpers,
	      enableSubstitution,
	      enableEmitNotification,
	      isSubstitutionEnabled,
	      isEmitNotificationEnabled,
	      get onSubstituteNode() {
	        return onSubstituteNode;
	      },
	      set onSubstituteNode(value) {
	        Debug.assert(state < 1 /* Initialized */, "Cannot modify transformation hooks after initialization has completed.");
	        Debug.assert(value !== void 0, "Value must not be 'undefined'");
	        onSubstituteNode = value;
	      },
	      get onEmitNode() {
	        return onEmitNode;
	      },
	      set onEmitNode(value) {
	        Debug.assert(state < 1 /* Initialized */, "Cannot modify transformation hooks after initialization has completed.");
	        Debug.assert(value !== void 0, "Value must not be 'undefined'");
	        onEmitNode = value;
	      },
	      addDiagnostic(diag2) {
	        diagnostics.push(diag2);
	      }
	    };
	    for (const node of nodes) {
	      disposeEmitNodes(getSourceFileOfNode(getParseTreeNode(node)));
	    }
	    mark("beforeTransform");
	    const transformersWithContext = transformers.map((t) => t(context));
	    const transformation = (node) => {
	      for (const transform2 of transformersWithContext) {
	        node = transform2(node);
	      }
	      return node;
	    };
	    state = 1 /* Initialized */;
	    const transformed = [];
	    for (const node of nodes) {
	      (_a = tracing) == null ? void 0 : _a.push(tracing.Phase.Emit, "transformNodes", node.kind === 312 /* SourceFile */ ? { path: node.path } : { kind: node.kind, pos: node.pos, end: node.end });
	      transformed.push((allowDtsFiles ? transformation : transformRoot)(node));
	      (_b = tracing) == null ? void 0 : _b.pop();
	    }
	    state = 2 /* Completed */;
	    mark("afterTransform");
	    measure("transformTime", "beforeTransform", "afterTransform");
	    return {
	      transformed,
	      substituteNode,
	      emitNodeWithNotification,
	      isEmitNotificationEnabled,
	      dispose,
	      diagnostics
	    };
	    function transformRoot(node) {
	      return node && (!isSourceFile(node) || !node.isDeclarationFile) ? transformation(node) : node;
	    }
	    function enableSubstitution(kind) {
	      Debug.assert(state < 2 /* Completed */, "Cannot modify the transformation context after transformation has completed.");
	      enabledSyntaxKindFeatures[kind] |= 1 /* Substitution */;
	    }
	    function isSubstitutionEnabled(node) {
	      return (enabledSyntaxKindFeatures[node.kind] & 1 /* Substitution */) !== 0 && (getEmitFlags(node) & 8 /* NoSubstitution */) === 0;
	    }
	    function substituteNode(hint, node) {
	      Debug.assert(state < 3 /* Disposed */, "Cannot substitute a node after the result is disposed.");
	      return node && isSubstitutionEnabled(node) && onSubstituteNode(hint, node) || node;
	    }
	    function enableEmitNotification(kind) {
	      Debug.assert(state < 2 /* Completed */, "Cannot modify the transformation context after transformation has completed.");
	      enabledSyntaxKindFeatures[kind] |= 2 /* EmitNotifications */;
	    }
	    function isEmitNotificationEnabled(node) {
	      return (enabledSyntaxKindFeatures[node.kind] & 2 /* EmitNotifications */) !== 0 || (getEmitFlags(node) & 4 /* AdviseOnEmitNode */) !== 0;
	    }
	    function emitNodeWithNotification(hint, node, emitCallback) {
	      Debug.assert(state < 3 /* Disposed */, "Cannot invoke TransformationResult callbacks after the result is disposed.");
	      if (node) {
	        if (isEmitNotificationEnabled(node)) {
	          onEmitNode(hint, node, emitCallback);
	        } else {
	          emitCallback(hint, node);
	        }
	      }
	    }
	    function hoistVariableDeclaration(name) {
	      Debug.assert(state > 0 /* Uninitialized */, "Cannot modify the lexical environment during initialization.");
	      Debug.assert(state < 2 /* Completed */, "Cannot modify the lexical environment after transformation has completed.");
	      const decl = setEmitFlags(factory2.createVariableDeclaration(name), 128 /* NoNestedSourceMaps */);
	      if (!lexicalEnvironmentVariableDeclarations) {
	        lexicalEnvironmentVariableDeclarations = [decl];
	      } else {
	        lexicalEnvironmentVariableDeclarations.push(decl);
	      }
	      if (lexicalEnvironmentFlags & 1 /* InParameters */) {
	        lexicalEnvironmentFlags |= 2 /* VariablesHoistedInParameters */;
	      }
	    }
	    function hoistFunctionDeclaration(func) {
	      Debug.assert(state > 0 /* Uninitialized */, "Cannot modify the lexical environment during initialization.");
	      Debug.assert(state < 2 /* Completed */, "Cannot modify the lexical environment after transformation has completed.");
	      setEmitFlags(func, 2097152 /* CustomPrologue */);
	      if (!lexicalEnvironmentFunctionDeclarations) {
	        lexicalEnvironmentFunctionDeclarations = [func];
	      } else {
	        lexicalEnvironmentFunctionDeclarations.push(func);
	      }
	    }
	    function addInitializationStatement(node) {
	      Debug.assert(state > 0 /* Uninitialized */, "Cannot modify the lexical environment during initialization.");
	      Debug.assert(state < 2 /* Completed */, "Cannot modify the lexical environment after transformation has completed.");
	      setEmitFlags(node, 2097152 /* CustomPrologue */);
	      if (!lexicalEnvironmentStatements) {
	        lexicalEnvironmentStatements = [node];
	      } else {
	        lexicalEnvironmentStatements.push(node);
	      }
	    }
	    function startLexicalEnvironment() {
	      Debug.assert(state > 0 /* Uninitialized */, "Cannot modify the lexical environment during initialization.");
	      Debug.assert(state < 2 /* Completed */, "Cannot modify the lexical environment after transformation has completed.");
	      Debug.assert(!lexicalEnvironmentSuspended, "Lexical environment is suspended.");
	      lexicalEnvironmentVariableDeclarationsStack[lexicalEnvironmentStackOffset] = lexicalEnvironmentVariableDeclarations;
	      lexicalEnvironmentFunctionDeclarationsStack[lexicalEnvironmentStackOffset] = lexicalEnvironmentFunctionDeclarations;
	      lexicalEnvironmentStatementsStack[lexicalEnvironmentStackOffset] = lexicalEnvironmentStatements;
	      lexicalEnvironmentFlagsStack[lexicalEnvironmentStackOffset] = lexicalEnvironmentFlags;
	      lexicalEnvironmentStackOffset++;
	      lexicalEnvironmentVariableDeclarations = void 0;
	      lexicalEnvironmentFunctionDeclarations = void 0;
	      lexicalEnvironmentStatements = void 0;
	      lexicalEnvironmentFlags = 0 /* None */;
	    }
	    function suspendLexicalEnvironment() {
	      Debug.assert(state > 0 /* Uninitialized */, "Cannot modify the lexical environment during initialization.");
	      Debug.assert(state < 2 /* Completed */, "Cannot modify the lexical environment after transformation has completed.");
	      Debug.assert(!lexicalEnvironmentSuspended, "Lexical environment is already suspended.");
	      lexicalEnvironmentSuspended = true;
	    }
	    function resumeLexicalEnvironment() {
	      Debug.assert(state > 0 /* Uninitialized */, "Cannot modify the lexical environment during initialization.");
	      Debug.assert(state < 2 /* Completed */, "Cannot modify the lexical environment after transformation has completed.");
	      Debug.assert(lexicalEnvironmentSuspended, "Lexical environment is not suspended.");
	      lexicalEnvironmentSuspended = false;
	    }
	    function endLexicalEnvironment() {
	      Debug.assert(state > 0 /* Uninitialized */, "Cannot modify the lexical environment during initialization.");
	      Debug.assert(state < 2 /* Completed */, "Cannot modify the lexical environment after transformation has completed.");
	      Debug.assert(!lexicalEnvironmentSuspended, "Lexical environment is suspended.");
	      let statements;
	      if (lexicalEnvironmentVariableDeclarations || lexicalEnvironmentFunctionDeclarations || lexicalEnvironmentStatements) {
	        if (lexicalEnvironmentFunctionDeclarations) {
	          statements = [...lexicalEnvironmentFunctionDeclarations];
	        }
	        if (lexicalEnvironmentVariableDeclarations) {
	          const statement = factory2.createVariableStatement(
	            /*modifiers*/
	            void 0,
	            factory2.createVariableDeclarationList(lexicalEnvironmentVariableDeclarations)
	          );
	          setEmitFlags(statement, 2097152 /* CustomPrologue */);
	          if (!statements) {
	            statements = [statement];
	          } else {
	            statements.push(statement);
	          }
	        }
	        if (lexicalEnvironmentStatements) {
	          if (!statements) {
	            statements = [...lexicalEnvironmentStatements];
	          } else {
	            statements = [...statements, ...lexicalEnvironmentStatements];
	          }
	        }
	      }
	      lexicalEnvironmentStackOffset--;
	      lexicalEnvironmentVariableDeclarations = lexicalEnvironmentVariableDeclarationsStack[lexicalEnvironmentStackOffset];
	      lexicalEnvironmentFunctionDeclarations = lexicalEnvironmentFunctionDeclarationsStack[lexicalEnvironmentStackOffset];
	      lexicalEnvironmentStatements = lexicalEnvironmentStatementsStack[lexicalEnvironmentStackOffset];
	      lexicalEnvironmentFlags = lexicalEnvironmentFlagsStack[lexicalEnvironmentStackOffset];
	      if (lexicalEnvironmentStackOffset === 0) {
	        lexicalEnvironmentVariableDeclarationsStack = [];
	        lexicalEnvironmentFunctionDeclarationsStack = [];
	        lexicalEnvironmentStatementsStack = [];
	        lexicalEnvironmentFlagsStack = [];
	      }
	      return statements;
	    }
	    function setLexicalEnvironmentFlags(flags, value) {
	      lexicalEnvironmentFlags = value ? lexicalEnvironmentFlags | flags : lexicalEnvironmentFlags & ~flags;
	    }
	    function getLexicalEnvironmentFlags() {
	      return lexicalEnvironmentFlags;
	    }
	    function startBlockScope() {
	      Debug.assert(state > 0 /* Uninitialized */, "Cannot start a block scope during initialization.");
	      Debug.assert(state < 2 /* Completed */, "Cannot start a block scope after transformation has completed.");
	      blockScopedVariableDeclarationsStack[blockScopeStackOffset] = blockScopedVariableDeclarations;
	      blockScopeStackOffset++;
	      blockScopedVariableDeclarations = void 0;
	    }
	    function endBlockScope() {
	      Debug.assert(state > 0 /* Uninitialized */, "Cannot end a block scope during initialization.");
	      Debug.assert(state < 2 /* Completed */, "Cannot end a block scope after transformation has completed.");
	      const statements = some(blockScopedVariableDeclarations) ? [
	        factory2.createVariableStatement(
	          /*modifiers*/
	          void 0,
	          factory2.createVariableDeclarationList(
	            blockScopedVariableDeclarations.map((identifier) => factory2.createVariableDeclaration(identifier)),
	            1 /* Let */
	          )
	        )
	      ] : void 0;
	      blockScopeStackOffset--;
	      blockScopedVariableDeclarations = blockScopedVariableDeclarationsStack[blockScopeStackOffset];
	      if (blockScopeStackOffset === 0) {
	        blockScopedVariableDeclarationsStack = [];
	      }
	      return statements;
	    }
	    function addBlockScopedVariable(name) {
	      Debug.assert(blockScopeStackOffset > 0, "Cannot add a block scoped variable outside of an iteration body.");
	      (blockScopedVariableDeclarations || (blockScopedVariableDeclarations = [])).push(name);
	    }
	    function requestEmitHelper(helper) {
	      Debug.assert(state > 0 /* Uninitialized */, "Cannot modify the transformation context during initialization.");
	      Debug.assert(state < 2 /* Completed */, "Cannot modify the transformation context after transformation has completed.");
	      Debug.assert(!helper.scoped, "Cannot request a scoped emit helper.");
	      if (helper.dependencies) {
	        for (const h of helper.dependencies) {
	          requestEmitHelper(h);
	        }
	      }
	      emitHelpers = append(emitHelpers, helper);
	    }
	    function readEmitHelpers() {
	      Debug.assert(state > 0 /* Uninitialized */, "Cannot modify the transformation context during initialization.");
	      Debug.assert(state < 2 /* Completed */, "Cannot modify the transformation context after transformation has completed.");
	      const helpers = emitHelpers;
	      emitHelpers = void 0;
	      return helpers;
	    }
	    function dispose() {
	      if (state < 3 /* Disposed */) {
	        for (const node of nodes) {
	          disposeEmitNodes(getSourceFileOfNode(getParseTreeNode(node)));
	        }
	        lexicalEnvironmentVariableDeclarations = void 0;
	        lexicalEnvironmentVariableDeclarationsStack = void 0;
	        lexicalEnvironmentFunctionDeclarations = void 0;
	        lexicalEnvironmentFunctionDeclarationsStack = void 0;
	        onSubstituteNode = void 0;
	        onEmitNode = void 0;
	        emitHelpers = void 0;
	        state = 3 /* Disposed */;
	      }
	    }
	  }
	  var noTransformers, nullTransformationContext;
	  var init_transformer = __esm({
	    "src/compiler/transformer.ts"() {
	      init_ts2();
	      init_ts_performance();
	      noTransformers = { scriptTransformers: emptyArray, declarationTransformers: emptyArray };
	      nullTransformationContext = {
	        factory,
	        // eslint-disable-line object-shorthand
	        getCompilerOptions: () => ({}),
	        getEmitResolver: notImplemented,
	        getEmitHost: notImplemented,
	        getEmitHelperFactory: notImplemented,
	        startLexicalEnvironment: noop,
	        resumeLexicalEnvironment: noop,
	        suspendLexicalEnvironment: noop,
	        endLexicalEnvironment: returnUndefined,
	        setLexicalEnvironmentFlags: noop,
	        getLexicalEnvironmentFlags: () => 0,
	        hoistVariableDeclaration: noop,
	        hoistFunctionDeclaration: noop,
	        addInitializationStatement: noop,
	        startBlockScope: noop,
	        endBlockScope: returnUndefined,
	        addBlockScopedVariable: noop,
	        requestEmitHelper: noop,
	        readEmitHelpers: notImplemented,
	        enableSubstitution: noop,
	        enableEmitNotification: noop,
	        isSubstitutionEnabled: notImplemented,
	        isEmitNotificationEnabled: notImplemented,
	        onSubstituteNode: noEmitSubstitution,
	        onEmitNode: noEmitNotification,
	        addDiagnostic: noop
	      };
	    }
	  });

	  // src/compiler/emitter.ts
	  function isBuildInfoFile(file) {
	    return fileExtensionIs(file, ".tsbuildinfo" /* TsBuildInfo */);
	  }
	  function forEachEmittedFile(host, action, sourceFilesOrTargetSourceFile, forceDtsEmit = false, onlyBuildInfo, includeBuildInfo) {
	    const sourceFiles = isArray(sourceFilesOrTargetSourceFile) ? sourceFilesOrTargetSourceFile : getSourceFilesToEmit(host, sourceFilesOrTargetSourceFile, forceDtsEmit);
	    const options = host.getCompilerOptions();
	    if (outFile(options)) {
	      const prepends = host.getPrependNodes();
	      if (sourceFiles.length || prepends.length) {
	        const bundle = factory.createBundle(sourceFiles, prepends);
	        const result = action(getOutputPathsFor(bundle, host, forceDtsEmit), bundle);
	        if (result) {
	          return result;
	        }
	      }
	    } else {
	      if (!onlyBuildInfo) {
	        for (const sourceFile of sourceFiles) {
	          const result = action(getOutputPathsFor(sourceFile, host, forceDtsEmit), sourceFile);
	          if (result) {
	            return result;
	          }
	        }
	      }
	      if (includeBuildInfo) {
	        const buildInfoPath = getTsBuildInfoEmitOutputFilePath(options);
	        if (buildInfoPath)
	          return action(
	            { buildInfoPath },
	            /*sourceFileOrBundle*/
	            void 0
	          );
	      }
	    }
	  }
	  function getTsBuildInfoEmitOutputFilePath(options) {
	    const configFile = options.configFilePath;
	    if (!isIncrementalCompilation(options))
	      return void 0;
	    if (options.tsBuildInfoFile)
	      return options.tsBuildInfoFile;
	    const outPath = outFile(options);
	    let buildInfoExtensionLess;
	    if (outPath) {
	      buildInfoExtensionLess = removeFileExtension(outPath);
	    } else {
	      if (!configFile)
	        return void 0;
	      const configFileExtensionLess = removeFileExtension(configFile);
	      buildInfoExtensionLess = options.outDir ? options.rootDir ? resolvePath(options.outDir, getRelativePathFromDirectory(
	        options.rootDir,
	        configFileExtensionLess,
	        /*ignoreCase*/
	        true
	      )) : combinePaths(options.outDir, getBaseFileName(configFileExtensionLess)) : configFileExtensionLess;
	    }
	    return buildInfoExtensionLess + ".tsbuildinfo" /* TsBuildInfo */;
	  }
	  function getOutputPathsForBundle(options, forceDtsPaths) {
	    const outPath = outFile(options);
	    const jsFilePath = options.emitDeclarationOnly ? void 0 : outPath;
	    const sourceMapFilePath = jsFilePath && getSourceMapFilePath(jsFilePath, options);
	    const declarationFilePath = forceDtsPaths || getEmitDeclarations(options) ? removeFileExtension(outPath) + ".d.ts" /* Dts */ : void 0;
	    const declarationMapPath = declarationFilePath && getAreDeclarationMapsEnabled(options) ? declarationFilePath + ".map" : void 0;
	    const buildInfoPath = getTsBuildInfoEmitOutputFilePath(options);
	    return { jsFilePath, sourceMapFilePath, declarationFilePath, declarationMapPath, buildInfoPath };
	  }
	  function getOutputPathsFor(sourceFile, host, forceDtsPaths) {
	    const options = host.getCompilerOptions();
	    if (sourceFile.kind === 313 /* Bundle */) {
	      return getOutputPathsForBundle(options, forceDtsPaths);
	    } else {
	      const ownOutputFilePath = getOwnEmitOutputFilePath(sourceFile.fileName, host, getOutputExtension(sourceFile.fileName, options));
	      const isJsonFile = isJsonSourceFile(sourceFile);
	      const isJsonEmittedToSameLocation = isJsonFile && comparePaths(sourceFile.fileName, ownOutputFilePath, host.getCurrentDirectory(), !host.useCaseSensitiveFileNames()) === 0 /* EqualTo */;
	      const jsFilePath = options.emitDeclarationOnly || isJsonEmittedToSameLocation ? void 0 : ownOutputFilePath;
	      const sourceMapFilePath = !jsFilePath || isJsonSourceFile(sourceFile) ? void 0 : getSourceMapFilePath(jsFilePath, options);
	      const declarationFilePath = forceDtsPaths || getEmitDeclarations(options) && !isJsonFile ? getDeclarationEmitOutputFilePath(sourceFile.fileName, host) : void 0;
	      const declarationMapPath = declarationFilePath && getAreDeclarationMapsEnabled(options) ? declarationFilePath + ".map" : void 0;
	      return { jsFilePath, sourceMapFilePath, declarationFilePath, declarationMapPath, buildInfoPath: void 0 };
	    }
	  }
	  function getSourceMapFilePath(jsFilePath, options) {
	    return options.sourceMap && !options.inlineSourceMap ? jsFilePath + ".map" : void 0;
	  }
	  function getOutputExtension(fileName, options) {
	    return fileExtensionIs(fileName, ".json" /* Json */) ? ".json" /* Json */ : options.jsx === 1 /* Preserve */ && fileExtensionIsOneOf(fileName, [".jsx" /* Jsx */, ".tsx" /* Tsx */]) ? ".jsx" /* Jsx */ : fileExtensionIsOneOf(fileName, [".mts" /* Mts */, ".mjs" /* Mjs */]) ? ".mjs" /* Mjs */ : fileExtensionIsOneOf(fileName, [".cts" /* Cts */, ".cjs" /* Cjs */]) ? ".cjs" /* Cjs */ : ".js" /* Js */;
	  }
	  function getOutputPathWithoutChangingExt(inputFileName, ignoreCase, outputDir, getCommonSourceDirectory2) {
	    return outputDir ? resolvePath(
	      outputDir,
	      getRelativePathFromDirectory(getCommonSourceDirectory2(), inputFileName, ignoreCase)
	    ) : inputFileName;
	  }
	  function getOutputDeclarationFileName(inputFileName, configFile, ignoreCase, getCommonSourceDirectory2 = () => getCommonSourceDirectoryOfConfig(configFile, ignoreCase)) {
	    return getOutputDeclarationFileNameWorker(inputFileName, configFile.options, ignoreCase, getCommonSourceDirectory2);
	  }
	  function getOutputDeclarationFileNameWorker(inputFileName, options, ignoreCase, getCommonSourceDirectory2) {
	    return changeExtension(
	      getOutputPathWithoutChangingExt(inputFileName, ignoreCase, options.declarationDir || options.outDir, getCommonSourceDirectory2),
	      getDeclarationEmitExtensionForPath(inputFileName)
	    );
	  }
	  function getOutputJSFileName(inputFileName, configFile, ignoreCase, getCommonSourceDirectory2 = () => getCommonSourceDirectoryOfConfig(configFile, ignoreCase)) {
	    if (configFile.options.emitDeclarationOnly)
	      return void 0;
	    const isJsonFile = fileExtensionIs(inputFileName, ".json" /* Json */);
	    const outputFileName = getOutputJSFileNameWorker(inputFileName, configFile.options, ignoreCase, getCommonSourceDirectory2);
	    return !isJsonFile || comparePaths(inputFileName, outputFileName, Debug.checkDefined(configFile.options.configFilePath), ignoreCase) !== 0 /* EqualTo */ ? outputFileName : void 0;
	  }
	  function getOutputJSFileNameWorker(inputFileName, options, ignoreCase, getCommonSourceDirectory2) {
	    return changeExtension(
	      getOutputPathWithoutChangingExt(inputFileName, ignoreCase, options.outDir, getCommonSourceDirectory2),
	      getOutputExtension(inputFileName, options)
	    );
	  }
	  function createAddOutput() {
	    let outputs;
	    return { addOutput, getOutputs };
	    function addOutput(path) {
	      if (path) {
	        (outputs || (outputs = [])).push(path);
	      }
	    }
	    function getOutputs() {
	      return outputs || emptyArray;
	    }
	  }
	  function getSingleOutputFileNames(configFile, addOutput) {
	    const { jsFilePath, sourceMapFilePath, declarationFilePath, declarationMapPath, buildInfoPath } = getOutputPathsForBundle(
	      configFile.options,
	      /*forceDtsPaths*/
	      false
	    );
	    addOutput(jsFilePath);
	    addOutput(sourceMapFilePath);
	    addOutput(declarationFilePath);
	    addOutput(declarationMapPath);
	    addOutput(buildInfoPath);
	  }
	  function getOwnOutputFileNames(configFile, inputFileName, ignoreCase, addOutput, getCommonSourceDirectory2) {
	    if (isDeclarationFileName(inputFileName))
	      return;
	    const js = getOutputJSFileName(inputFileName, configFile, ignoreCase, getCommonSourceDirectory2);
	    addOutput(js);
	    if (fileExtensionIs(inputFileName, ".json" /* Json */))
	      return;
	    if (js && configFile.options.sourceMap) {
	      addOutput(`${js}.map`);
	    }
	    if (getEmitDeclarations(configFile.options)) {
	      const dts = getOutputDeclarationFileName(inputFileName, configFile, ignoreCase, getCommonSourceDirectory2);
	      addOutput(dts);
	      if (configFile.options.declarationMap) {
	        addOutput(`${dts}.map`);
	      }
	    }
	  }
	  function getCommonSourceDirectory(options, emittedFiles, currentDirectory, getCanonicalFileName, checkSourceFilesBelongToPath) {
	    let commonSourceDirectory;
	    if (options.rootDir) {
	      commonSourceDirectory = getNormalizedAbsolutePath(options.rootDir, currentDirectory);
	      checkSourceFilesBelongToPath == null ? void 0 : checkSourceFilesBelongToPath(options.rootDir);
	    } else if (options.composite && options.configFilePath) {
	      commonSourceDirectory = getDirectoryPath(normalizeSlashes(options.configFilePath));
	      checkSourceFilesBelongToPath == null ? void 0 : checkSourceFilesBelongToPath(commonSourceDirectory);
	    } else {
	      commonSourceDirectory = computeCommonSourceDirectoryOfFilenames(emittedFiles(), currentDirectory, getCanonicalFileName);
	    }
	    if (commonSourceDirectory && commonSourceDirectory[commonSourceDirectory.length - 1] !== directorySeparator) {
	      commonSourceDirectory += directorySeparator;
	    }
	    return commonSourceDirectory;
	  }
	  function getCommonSourceDirectoryOfConfig({ options, fileNames }, ignoreCase) {
	    return getCommonSourceDirectory(
	      options,
	      () => filter(fileNames, (file) => !(options.noEmitForJsFiles && fileExtensionIsOneOf(file, supportedJSExtensionsFlat)) && !isDeclarationFileName(file)),
	      getDirectoryPath(normalizeSlashes(Debug.checkDefined(options.configFilePath))),
	      createGetCanonicalFileName(!ignoreCase)
	    );
	  }
	  function getAllProjectOutputs(configFile, ignoreCase) {
	    const { addOutput, getOutputs } = createAddOutput();
	    if (outFile(configFile.options)) {
	      getSingleOutputFileNames(configFile, addOutput);
	    } else {
	      const getCommonSourceDirectory2 = memoize(() => getCommonSourceDirectoryOfConfig(configFile, ignoreCase));
	      for (const inputFileName of configFile.fileNames) {
	        getOwnOutputFileNames(configFile, inputFileName, ignoreCase, addOutput, getCommonSourceDirectory2);
	      }
	      addOutput(getTsBuildInfoEmitOutputFilePath(configFile.options));
	    }
	    return getOutputs();
	  }
	  function getOutputFileNames(commandLine, inputFileName, ignoreCase) {
	    inputFileName = normalizePath(inputFileName);
	    Debug.assert(contains(commandLine.fileNames, inputFileName), `Expected fileName to be present in command line`);
	    const { addOutput, getOutputs } = createAddOutput();
	    if (outFile(commandLine.options)) {
	      getSingleOutputFileNames(commandLine, addOutput);
	    } else {
	      getOwnOutputFileNames(commandLine, inputFileName, ignoreCase, addOutput);
	    }
	    return getOutputs();
	  }
	  function getFirstProjectOutput(configFile, ignoreCase) {
	    if (outFile(configFile.options)) {
	      const { jsFilePath, declarationFilePath } = getOutputPathsForBundle(
	        configFile.options,
	        /*forceDtsPaths*/
	        false
	      );
	      return Debug.checkDefined(jsFilePath || declarationFilePath, `project ${configFile.options.configFilePath} expected to have at least one output`);
	    }
	    const getCommonSourceDirectory2 = memoize(() => getCommonSourceDirectoryOfConfig(configFile, ignoreCase));
	    for (const inputFileName of configFile.fileNames) {
	      if (isDeclarationFileName(inputFileName))
	        continue;
	      const jsFilePath = getOutputJSFileName(inputFileName, configFile, ignoreCase, getCommonSourceDirectory2);
	      if (jsFilePath)
	        return jsFilePath;
	      if (fileExtensionIs(inputFileName, ".json" /* Json */))
	        continue;
	      if (getEmitDeclarations(configFile.options)) {
	        return getOutputDeclarationFileName(inputFileName, configFile, ignoreCase, getCommonSourceDirectory2);
	      }
	    }
	    const buildInfoPath = getTsBuildInfoEmitOutputFilePath(configFile.options);
	    if (buildInfoPath)
	      return buildInfoPath;
	    return Debug.fail(`project ${configFile.options.configFilePath} expected to have at least one output`);
	  }
	  function emitFiles(resolver, host, targetSourceFile, { scriptTransformers, declarationTransformers }, emitOnly, onlyBuildInfo, forceDtsEmit) {
	    var compilerOptions = host.getCompilerOptions();
	    var sourceMapDataList = compilerOptions.sourceMap || compilerOptions.inlineSourceMap || getAreDeclarationMapsEnabled(compilerOptions) ? [] : void 0;
	    var emittedFilesList = compilerOptions.listEmittedFiles ? [] : void 0;
	    var emitterDiagnostics = createDiagnosticCollection();
	    var newLine = getNewLineCharacter(compilerOptions);
	    var writer = createTextWriter(newLine);
	    var { enter, exit } = createTimer("printTime", "beforePrint", "afterPrint");
	    var bundleBuildInfo;
	    var emitSkipped = false;
	    enter();
	    forEachEmittedFile(
	      host,
	      emitSourceFileOrBundle,
	      getSourceFilesToEmit(host, targetSourceFile, forceDtsEmit),
	      forceDtsEmit,
	      onlyBuildInfo,
	      !targetSourceFile
	    );
	    exit();
	    return {
	      emitSkipped,
	      diagnostics: emitterDiagnostics.getDiagnostics(),
	      emittedFiles: emittedFilesList,
	      sourceMaps: sourceMapDataList
	    };
	    function emitSourceFileOrBundle({ jsFilePath, sourceMapFilePath, declarationFilePath, declarationMapPath, buildInfoPath }, sourceFileOrBundle) {
	      var _a, _b, _c, _d, _e, _f;
	      let buildInfoDirectory;
	      if (buildInfoPath && sourceFileOrBundle && isBundle(sourceFileOrBundle)) {
	        buildInfoDirectory = getDirectoryPath(getNormalizedAbsolutePath(buildInfoPath, host.getCurrentDirectory()));
	        bundleBuildInfo = {
	          commonSourceDirectory: relativeToBuildInfo(host.getCommonSourceDirectory()),
	          sourceFiles: sourceFileOrBundle.sourceFiles.map((file) => relativeToBuildInfo(getNormalizedAbsolutePath(file.fileName, host.getCurrentDirectory())))
	        };
	      }
	      (_a = tracing) == null ? void 0 : _a.push(tracing.Phase.Emit, "emitJsFileOrBundle", { jsFilePath });
	      emitJsFileOrBundle(sourceFileOrBundle, jsFilePath, sourceMapFilePath, relativeToBuildInfo);
	      (_b = tracing) == null ? void 0 : _b.pop();
	      (_c = tracing) == null ? void 0 : _c.push(tracing.Phase.Emit, "emitDeclarationFileOrBundle", { declarationFilePath });
	      emitDeclarationFileOrBundle(sourceFileOrBundle, declarationFilePath, declarationMapPath, relativeToBuildInfo);
	      (_d = tracing) == null ? void 0 : _d.pop();
	      (_e = tracing) == null ? void 0 : _e.push(tracing.Phase.Emit, "emitBuildInfo", { buildInfoPath });
	      emitBuildInfo(bundleBuildInfo, buildInfoPath);
	      (_f = tracing) == null ? void 0 : _f.pop();
	      function relativeToBuildInfo(path) {
	        return ensurePathIsNonModuleName(getRelativePathFromDirectory(buildInfoDirectory, path, host.getCanonicalFileName));
	      }
	    }
	    function emitBuildInfo(bundle, buildInfoPath) {
	      if (!buildInfoPath || targetSourceFile || emitSkipped)
	        return;
	      if (host.isEmitBlocked(buildInfoPath)) {
	        emitSkipped = true;
	        return;
	      }
	      const buildInfo = host.getBuildInfo(bundle) || createBuildInfo(
	        /*program*/
	        void 0,
	        bundle
	      );
	      writeFile(
	        host,
	        emitterDiagnostics,
	        buildInfoPath,
	        getBuildInfoText(buildInfo),
	        /*writeByteOrderMark*/
	        false,
	        /*sourceFiles*/
	        void 0,
	        { buildInfo }
	      );
	      emittedFilesList == null ? void 0 : emittedFilesList.push(buildInfoPath);
	    }
	    function emitJsFileOrBundle(sourceFileOrBundle, jsFilePath, sourceMapFilePath, relativeToBuildInfo) {
	      if (!sourceFileOrBundle || emitOnly || !jsFilePath) {
	        return;
	      }
	      if (host.isEmitBlocked(jsFilePath) || compilerOptions.noEmit) {
	        emitSkipped = true;
	        return;
	      }
	      const transform2 = transformNodes(
	        resolver,
	        host,
	        factory,
	        compilerOptions,
	        [sourceFileOrBundle],
	        scriptTransformers,
	        /*allowDtsFiles*/
	        false
	      );
	      const printerOptions = {
	        removeComments: compilerOptions.removeComments,
	        newLine: compilerOptions.newLine,
	        noEmitHelpers: compilerOptions.noEmitHelpers,
	        module: compilerOptions.module,
	        target: compilerOptions.target,
	        sourceMap: compilerOptions.sourceMap,
	        inlineSourceMap: compilerOptions.inlineSourceMap,
	        inlineSources: compilerOptions.inlineSources,
	        extendedDiagnostics: compilerOptions.extendedDiagnostics,
	        writeBundleFileInfo: !!bundleBuildInfo,
	        relativeToBuildInfo
	      };
	      const printer = createPrinter(printerOptions, {
	        // resolver hooks
	        hasGlobalName: resolver.hasGlobalName,
	        // transform hooks
	        onEmitNode: transform2.emitNodeWithNotification,
	        isEmitNotificationEnabled: transform2.isEmitNotificationEnabled,
	        substituteNode: transform2.substituteNode
	      });
	      Debug.assert(transform2.transformed.length === 1, "Should only see one output from the transform");
	      printSourceFileOrBundle(jsFilePath, sourceMapFilePath, transform2, printer, compilerOptions);
	      transform2.dispose();
	      if (bundleBuildInfo)
	        bundleBuildInfo.js = printer.bundleFileInfo;
	      if (emittedFilesList) {
	        emittedFilesList.push(jsFilePath);
	        if (sourceMapFilePath) {
	          emittedFilesList.push(sourceMapFilePath);
	        }
	      }
	    }
	    function emitDeclarationFileOrBundle(sourceFileOrBundle, declarationFilePath, declarationMapPath, relativeToBuildInfo) {
	      if (!sourceFileOrBundle || emitOnly === 0 /* Js */)
	        return;
	      if (!declarationFilePath) {
	        if (emitOnly || compilerOptions.emitDeclarationOnly)
	          emitSkipped = true;
	        return;
	      }
	      const sourceFiles = isSourceFile(sourceFileOrBundle) ? [sourceFileOrBundle] : sourceFileOrBundle.sourceFiles;
	      const filesForEmit = forceDtsEmit ? sourceFiles : filter(sourceFiles, isSourceFileNotJson);
	      const inputListOrBundle = outFile(compilerOptions) ? [factory.createBundle(filesForEmit, !isSourceFile(sourceFileOrBundle) ? sourceFileOrBundle.prepends : void 0)] : filesForEmit;
	      if (emitOnly && !getEmitDeclarations(compilerOptions)) {
	        filesForEmit.forEach(collectLinkedAliases);
	      }
	      const declarationTransform = transformNodes(
	        resolver,
	        host,
	        factory,
	        compilerOptions,
	        inputListOrBundle,
	        declarationTransformers,
	        /*allowDtsFiles*/
	        false
	      );
	      if (length(declarationTransform.diagnostics)) {
	        for (const diagnostic of declarationTransform.diagnostics) {
	          emitterDiagnostics.add(diagnostic);
	        }
	      }
	      const declBlocked = !!declarationTransform.diagnostics && !!declarationTransform.diagnostics.length || !!host.isEmitBlocked(declarationFilePath) || !!compilerOptions.noEmit;
	      emitSkipped = emitSkipped || declBlocked;
	      if (!declBlocked || forceDtsEmit) {
	        Debug.assert(declarationTransform.transformed.length === 1, "Should only see one output from the decl transform");
	        const printerOptions = {
	          removeComments: compilerOptions.removeComments,
	          newLine: compilerOptions.newLine,
	          noEmitHelpers: true,
	          module: compilerOptions.module,
	          target: compilerOptions.target,
	          sourceMap: !forceDtsEmit && compilerOptions.declarationMap,
	          inlineSourceMap: compilerOptions.inlineSourceMap,
	          extendedDiagnostics: compilerOptions.extendedDiagnostics,
	          onlyPrintJsDocStyle: true,
	          omitBraceSourceMapPositions: true,
	          writeBundleFileInfo: !!bundleBuildInfo,
	          recordInternalSection: !!bundleBuildInfo,
	          relativeToBuildInfo
	        };
	        const declarationPrinter = createPrinter(printerOptions, {
	          // resolver hooks
	          hasGlobalName: resolver.hasGlobalName,
	          // transform hooks
	          onEmitNode: declarationTransform.emitNodeWithNotification,
	          isEmitNotificationEnabled: declarationTransform.isEmitNotificationEnabled,
	          substituteNode: declarationTransform.substituteNode
	        });
	        printSourceFileOrBundle(
	          declarationFilePath,
	          declarationMapPath,
	          declarationTransform,
	          declarationPrinter,
	          {
	            sourceMap: printerOptions.sourceMap,
	            sourceRoot: compilerOptions.sourceRoot,
	            mapRoot: compilerOptions.mapRoot,
	            extendedDiagnostics: compilerOptions.extendedDiagnostics
	            // Explicitly do not passthru either `inline` option
	          }
	        );
	        if (emittedFilesList) {
	          emittedFilesList.push(declarationFilePath);
	          if (declarationMapPath) {
	            emittedFilesList.push(declarationMapPath);
	          }
	        }
	        if (bundleBuildInfo)
	          bundleBuildInfo.dts = declarationPrinter.bundleFileInfo;
	      }
	      declarationTransform.dispose();
	    }
	    function collectLinkedAliases(node) {
	      if (isExportAssignment(node)) {
	        if (node.expression.kind === 80 /* Identifier */) {
	          resolver.collectLinkedAliases(
	            node.expression,
	            /*setVisibility*/
	            true
	          );
	        }
	        return;
	      } else if (isExportSpecifier(node)) {
	        resolver.collectLinkedAliases(
	          node.propertyName || node.name,
	          /*setVisibility*/
	          true
	        );
	        return;
	      }
	      forEachChild(node, collectLinkedAliases);
	    }
	    function printSourceFileOrBundle(jsFilePath, sourceMapFilePath, transform2, printer, mapOptions) {
	      const sourceFileOrBundle = transform2.transformed[0];
	      const bundle = sourceFileOrBundle.kind === 313 /* Bundle */ ? sourceFileOrBundle : void 0;
	      const sourceFile = sourceFileOrBundle.kind === 312 /* SourceFile */ ? sourceFileOrBundle : void 0;
	      const sourceFiles = bundle ? bundle.sourceFiles : [sourceFile];
	      let sourceMapGenerator;
	      if (shouldEmitSourceMaps(mapOptions, sourceFileOrBundle)) {
	        sourceMapGenerator = createSourceMapGenerator(
	          host,
	          getBaseFileName(normalizeSlashes(jsFilePath)),
	          getSourceRoot(mapOptions),
	          getSourceMapDirectory(mapOptions, jsFilePath, sourceFile),
	          mapOptions
	        );
	      }
	      if (bundle) {
	        printer.writeBundle(bundle, writer, sourceMapGenerator);
	      } else {
	        printer.writeFile(sourceFile, writer, sourceMapGenerator);
	      }
	      let sourceMapUrlPos;
	      if (sourceMapGenerator) {
	        if (sourceMapDataList) {
	          sourceMapDataList.push({
	            inputSourceFileNames: sourceMapGenerator.getSources(),
	            sourceMap: sourceMapGenerator.toJSON()
	          });
	        }
	        const sourceMappingURL = getSourceMappingURL(
	          mapOptions,
	          sourceMapGenerator,
	          jsFilePath,
	          sourceMapFilePath,
	          sourceFile
	        );
	        if (sourceMappingURL) {
	          if (!writer.isAtStartOfLine())
	            writer.rawWrite(newLine);
	          sourceMapUrlPos = writer.getTextPos();
	          writer.writeComment(`//# ${"sourceMappingURL"}=${sourceMappingURL}`);
	        }
	        if (sourceMapFilePath) {
	          const sourceMap = sourceMapGenerator.toString();
	          writeFile(
	            host,
	            emitterDiagnostics,
	            sourceMapFilePath,
	            sourceMap,
	            /*writeByteOrderMark*/
	            false,
	            sourceFiles
	          );
	          if (printer.bundleFileInfo)
	            printer.bundleFileInfo.mapHash = computeSignature(sourceMap, host);
	        }
	      } else {
	        writer.writeLine();
	      }
	      const text = writer.getText();
	      writeFile(host, emitterDiagnostics, jsFilePath, text, !!compilerOptions.emitBOM, sourceFiles, { sourceMapUrlPos, diagnostics: transform2.diagnostics });
	      if (printer.bundleFileInfo)
	        printer.bundleFileInfo.hash = computeSignature(text, host);
	      writer.clear();
	    }
	    function shouldEmitSourceMaps(mapOptions, sourceFileOrBundle) {
	      return (mapOptions.sourceMap || mapOptions.inlineSourceMap) && (sourceFileOrBundle.kind !== 312 /* SourceFile */ || !fileExtensionIs(sourceFileOrBundle.fileName, ".json" /* Json */));
	    }
	    function getSourceRoot(mapOptions) {
	      const sourceRoot = normalizeSlashes(mapOptions.sourceRoot || "");
	      return sourceRoot ? ensureTrailingDirectorySeparator(sourceRoot) : sourceRoot;
	    }
	    function getSourceMapDirectory(mapOptions, filePath, sourceFile) {
	      if (mapOptions.sourceRoot)
	        return host.getCommonSourceDirectory();
	      if (mapOptions.mapRoot) {
	        let sourceMapDir = normalizeSlashes(mapOptions.mapRoot);
	        if (sourceFile) {
	          sourceMapDir = getDirectoryPath(getSourceFilePathInNewDir(sourceFile.fileName, host, sourceMapDir));
	        }
	        if (getRootLength(sourceMapDir) === 0) {
	          sourceMapDir = combinePaths(host.getCommonSourceDirectory(), sourceMapDir);
	        }
	        return sourceMapDir;
	      }
	      return getDirectoryPath(normalizePath(filePath));
	    }
	    function getSourceMappingURL(mapOptions, sourceMapGenerator, filePath, sourceMapFilePath, sourceFile) {
	      if (mapOptions.inlineSourceMap) {
	        const sourceMapText = sourceMapGenerator.toString();
	        const base64SourceMapText = base64encode(sys, sourceMapText);
	        return `data:application/json;base64,${base64SourceMapText}`;
	      }
	      const sourceMapFile = getBaseFileName(normalizeSlashes(Debug.checkDefined(sourceMapFilePath)));
	      if (mapOptions.mapRoot) {
	        let sourceMapDir = normalizeSlashes(mapOptions.mapRoot);
	        if (sourceFile) {
	          sourceMapDir = getDirectoryPath(getSourceFilePathInNewDir(sourceFile.fileName, host, sourceMapDir));
	        }
	        if (getRootLength(sourceMapDir) === 0) {
	          sourceMapDir = combinePaths(host.getCommonSourceDirectory(), sourceMapDir);
	          return encodeURI(
	            getRelativePathToDirectoryOrUrl(
	              getDirectoryPath(normalizePath(filePath)),
	              // get the relative sourceMapDir path based on jsFilePath
	              combinePaths(sourceMapDir, sourceMapFile),
	              // this is where user expects to see sourceMap
	              host.getCurrentDirectory(),
	              host.getCanonicalFileName,
	              /*isAbsolutePathAnUrl*/
	              true
	            )
	          );
	        } else {
	          return encodeURI(combinePaths(sourceMapDir, sourceMapFile));
	        }
	      }
	      return encodeURI(sourceMapFile);
	    }
	  }
	  function createBuildInfo(program, bundle) {
	    return { bundle, program, version };
	  }
	  function getBuildInfoText(buildInfo) {
	    return JSON.stringify(buildInfo);
	  }
	  function getBuildInfo(buildInfoFile, buildInfoText) {
	    return readJsonOrUndefined(buildInfoFile, buildInfoText);
	  }
	  function createSourceFilesFromBundleBuildInfo(bundle, buildInfoDirectory, host) {
	    var _a;
	    const jsBundle = Debug.checkDefined(bundle.js);
	    const prologueMap = ((_a = jsBundle.sources) == null ? void 0 : _a.prologues) && arrayToMap(jsBundle.sources.prologues, (prologueInfo) => prologueInfo.file);
	    return bundle.sourceFiles.map((fileName, index) => {
	      const prologueInfo = prologueMap == null ? void 0 : prologueMap.get(index);
	      const statements = prologueInfo == null ? void 0 : prologueInfo.directives.map((directive) => {
	        const literal = setTextRange(factory.createStringLiteral(directive.expression.text), directive.expression);
	        const statement = setTextRange(factory.createExpressionStatement(literal), directive);
	        setParent(literal, statement);
	        return statement;
	      });
	      const eofToken = factory.createToken(1 /* EndOfFileToken */);
	      const sourceFile = factory.createSourceFile(statements ?? [], eofToken, 0 /* None */);
	      sourceFile.fileName = getRelativePathFromDirectory(
	        host.getCurrentDirectory(),
	        getNormalizedAbsolutePath(fileName, buildInfoDirectory),
	        !host.useCaseSensitiveFileNames()
	      );
	      sourceFile.text = (prologueInfo == null ? void 0 : prologueInfo.text) ?? "";
	      setTextRangePosWidth(sourceFile, 0, (prologueInfo == null ? void 0 : prologueInfo.text.length) ?? 0);
	      setEachParent(sourceFile.statements, sourceFile);
	      setTextRangePosWidth(eofToken, sourceFile.end, 0);
	      setParent(eofToken, sourceFile);
	      return sourceFile;
	    });
	  }
	  function emitUsingBuildInfo(config, host, getCommandLine, customTransformers) {
	    var _a, _b;
	    (_a = tracing) == null ? void 0 : _a.push(
	      tracing.Phase.Emit,
	      "emitUsingBuildInfo",
	      {},
	      /*separateBeginAndEnd*/
	      true
	    );
	    mark("beforeEmit");
	    const result = emitUsingBuildInfoWorker(config, host, getCommandLine, customTransformers);
	    mark("afterEmit");
	    measure("Emit", "beforeEmit", "afterEmit");
	    (_b = tracing) == null ? void 0 : _b.pop();
	    return result;
	  }
	  function emitUsingBuildInfoWorker(config, host, getCommandLine, customTransformers) {
	    const { buildInfoPath, jsFilePath, sourceMapFilePath, declarationFilePath, declarationMapPath } = getOutputPathsForBundle(
	      config.options,
	      /*forceDtsPaths*/
	      false
	    );
	    const buildInfo = host.getBuildInfo(buildInfoPath, config.options.configFilePath);
	    if (!buildInfo)
	      return buildInfoPath;
	    if (!buildInfo.bundle || !buildInfo.bundle.js || declarationFilePath && !buildInfo.bundle.dts)
	      return buildInfoPath;
	    const jsFileText = host.readFile(Debug.checkDefined(jsFilePath));
	    if (!jsFileText)
	      return jsFilePath;
	    if (computeSignature(jsFileText, host) !== buildInfo.bundle.js.hash)
	      return jsFilePath;
	    const sourceMapText = sourceMapFilePath && host.readFile(sourceMapFilePath);
	    if (sourceMapFilePath && !sourceMapText || config.options.inlineSourceMap)
	      return sourceMapFilePath || "inline sourcemap decoding";
	    if (sourceMapFilePath && computeSignature(sourceMapText, host) !== buildInfo.bundle.js.mapHash)
	      return sourceMapFilePath;
	    const declarationText = declarationFilePath && host.readFile(declarationFilePath);
	    if (declarationFilePath && !declarationText)
	      return declarationFilePath;
	    if (declarationFilePath && computeSignature(declarationText, host) !== buildInfo.bundle.dts.hash)
	      return declarationFilePath;
	    const declarationMapText = declarationMapPath && host.readFile(declarationMapPath);
	    if (declarationMapPath && !declarationMapText || config.options.inlineSourceMap)
	      return declarationMapPath || "inline sourcemap decoding";
	    if (declarationMapPath && computeSignature(declarationMapText, host) !== buildInfo.bundle.dts.mapHash)
	      return declarationMapPath;
	    const buildInfoDirectory = getDirectoryPath(getNormalizedAbsolutePath(buildInfoPath, host.getCurrentDirectory()));
	    const ownPrependInput = createInputFilesWithFileTexts(
	      jsFilePath,
	      jsFileText,
	      sourceMapFilePath,
	      sourceMapText,
	      declarationFilePath,
	      declarationText,
	      declarationMapPath,
	      declarationMapText,
	      buildInfoPath,
	      buildInfo,
	      /*oldFileOfCurrentEmit*/
	      true
	    );
	    const outputFiles = [];
	    const prependNodes = createPrependNodes(config.projectReferences, getCommandLine, (f) => host.readFile(f), host);
	    const sourceFilesForJsEmit = createSourceFilesFromBundleBuildInfo(buildInfo.bundle, buildInfoDirectory, host);
	    let changedDtsText;
	    let changedDtsData;
	    const emitHost = {
	      getPrependNodes: memoize(() => [...prependNodes, ownPrependInput]),
	      getCanonicalFileName: host.getCanonicalFileName,
	      getCommonSourceDirectory: () => getNormalizedAbsolutePath(buildInfo.bundle.commonSourceDirectory, buildInfoDirectory),
	      getCompilerOptions: () => config.options,
	      getCurrentDirectory: () => host.getCurrentDirectory(),
	      getSourceFile: returnUndefined,
	      getSourceFileByPath: returnUndefined,
	      getSourceFiles: () => sourceFilesForJsEmit,
	      getLibFileFromReference: notImplemented,
	      isSourceFileFromExternalLibrary: returnFalse,
	      getResolvedProjectReferenceToRedirect: returnUndefined,
	      getProjectReferenceRedirect: returnUndefined,
	      isSourceOfProjectReferenceRedirect: returnFalse,
	      writeFile: (name, text, writeByteOrderMark, _onError, _sourceFiles, data) => {
	        switch (name) {
	          case jsFilePath:
	            if (jsFileText === text)
	              return;
	            break;
	          case sourceMapFilePath:
	            if (sourceMapText === text)
	              return;
	            break;
	          case buildInfoPath:
	            break;
	          case declarationFilePath:
	            if (declarationText === text)
	              return;
	            changedDtsText = text;
	            changedDtsData = data;
	            break;
	          case declarationMapPath:
	            if (declarationMapText === text)
	              return;
	            break;
	          default:
	            Debug.fail(`Unexpected path: ${name}`);
	        }
	        outputFiles.push({ name, text, writeByteOrderMark, data });
	      },
	      isEmitBlocked: returnFalse,
	      readFile: (f) => host.readFile(f),
	      fileExists: (f) => host.fileExists(f),
	      useCaseSensitiveFileNames: () => host.useCaseSensitiveFileNames(),
	      getBuildInfo: (bundle) => {
	        const program = buildInfo.program;
	        if (program && changedDtsText !== void 0 && config.options.composite) {
	          program.outSignature = computeSignature(changedDtsText, host, changedDtsData);
	        }
	        const { js, dts, sourceFiles } = buildInfo.bundle;
	        bundle.js.sources = js.sources;
	        if (dts) {
	          bundle.dts.sources = dts.sources;
	        }
	        bundle.sourceFiles = sourceFiles;
	        return createBuildInfo(program, bundle);
	      },
	      getSourceFileFromReference: returnUndefined,
	      redirectTargetsMap: createMultiMap(),
	      getFileIncludeReasons: notImplemented,
	      createHash: maybeBind(host, host.createHash)
	    };
	    emitFiles(
	      notImplementedResolver,
	      emitHost,
	      /*targetSourceFile*/
	      void 0,
	      getTransformers(config.options, customTransformers)
	    );
	    return outputFiles;
	  }
	  function createPrinter(printerOptions = {}, handlers = {}) {
	    var {
	      hasGlobalName,
	      onEmitNode = noEmitNotification,
	      isEmitNotificationEnabled,
	      substituteNode = noEmitSubstitution,
	      onBeforeEmitNode,
	      onAfterEmitNode,
	      onBeforeEmitNodeArray,
	      onAfterEmitNodeArray,
	      onBeforeEmitToken,
	      onAfterEmitToken
	    } = handlers;
	    var extendedDiagnostics = !!printerOptions.extendedDiagnostics;
	    var omitBraceSourcePositions = !!printerOptions.omitBraceSourceMapPositions;
	    var newLine = getNewLineCharacter(printerOptions);
	    var moduleKind = getEmitModuleKind(printerOptions);
	    var bundledHelpers = /* @__PURE__ */ new Map();
	    var currentSourceFile;
	    var nodeIdToGeneratedName;
	    var nodeIdToGeneratedPrivateName;
	    var autoGeneratedIdToGeneratedName;
	    var generatedNames;
	    var formattedNameTempFlagsStack;
	    var formattedNameTempFlags;
	    var privateNameTempFlagsStack;
	    var privateNameTempFlags;
	    var tempFlagsStack;
	    var tempFlags;
	    var reservedNamesStack;
	    var reservedNames;
	    var reservedPrivateNamesStack;
	    var reservedPrivateNames;
	    var preserveSourceNewlines = printerOptions.preserveSourceNewlines;
	    var nextListElementPos;
	    var writer;
	    var ownWriter;
	    var write = writeBase;
	    var isOwnFileEmit;
	    var bundleFileInfo = printerOptions.writeBundleFileInfo ? { sections: [] } : void 0;
	    var relativeToBuildInfo = bundleFileInfo ? Debug.checkDefined(printerOptions.relativeToBuildInfo) : void 0;
	    var recordInternalSection = printerOptions.recordInternalSection;
	    var sourceFileTextPos = 0;
	    var sourceFileTextKind = "text" /* Text */;
	    var sourceMapsDisabled = true;
	    var sourceMapGenerator;
	    var sourceMapSource;
	    var sourceMapSourceIndex = -1;
	    var mostRecentlyAddedSourceMapSource;
	    var mostRecentlyAddedSourceMapSourceIndex = -1;
	    var containerPos = -1;
	    var containerEnd = -1;
	    var declarationListContainerEnd = -1;
	    var currentLineMap;
	    var detachedCommentsInfo;
	    var hasWrittenComment = false;
	    var commentsDisabled = !!printerOptions.removeComments;
	    var lastSubstitution;
	    var currentParenthesizerRule;
	    var { enter: enterComment, exit: exitComment } = createTimerIf(extendedDiagnostics, "commentTime", "beforeComment", "afterComment");
	    var parenthesizer = factory.parenthesizer;
	    var typeArgumentParenthesizerRuleSelector = {
	      select: (index) => index === 0 ? parenthesizer.parenthesizeLeadingTypeArgument : void 0
	    };
	    var emitBinaryExpression = createEmitBinaryExpression();
	    reset2();
	    return {
	      // public API
	      printNode,
	      printList,
	      printFile,
	      printBundle,
	      // internal API
	      writeNode,
	      writeList,
	      writeFile: writeFile2,
	      writeBundle,
	      bundleFileInfo
	    };
	    function printNode(hint, node, sourceFile) {
	      switch (hint) {
	        case 0 /* SourceFile */:
	          Debug.assert(isSourceFile(node), "Expected a SourceFile node.");
	          break;
	        case 2 /* IdentifierName */:
	          Debug.assert(isIdentifier(node), "Expected an Identifier node.");
	          break;
	        case 1 /* Expression */:
	          Debug.assert(isExpression(node), "Expected an Expression node.");
	          break;
	      }
	      switch (node.kind) {
	        case 312 /* SourceFile */:
	          return printFile(node);
	        case 313 /* Bundle */:
	          return printBundle(node);
	        case 314 /* UnparsedSource */:
	          return printUnparsedSource(node);
	      }
	      writeNode(hint, node, sourceFile, beginPrint());
	      return endPrint();
	    }
	    function printList(format, nodes, sourceFile) {
	      writeList(format, nodes, sourceFile, beginPrint());
	      return endPrint();
	    }
	    function printBundle(bundle) {
	      writeBundle(
	        bundle,
	        beginPrint(),
	        /*sourceMapGenerator*/
	        void 0
	      );
	      return endPrint();
	    }
	    function printFile(sourceFile) {
	      writeFile2(
	        sourceFile,
	        beginPrint(),
	        /*sourceMapGenerator*/
	        void 0
	      );
	      return endPrint();
	    }
	    function printUnparsedSource(unparsed) {
	      writeUnparsedSource(unparsed, beginPrint());
	      return endPrint();
	    }
	    function writeNode(hint, node, sourceFile, output) {
	      const previousWriter = writer;
	      setWriter(
	        output,
	        /*_sourceMapGenerator*/
	        void 0
	      );
	      print(hint, node, sourceFile);
	      reset2();
	      writer = previousWriter;
	    }
	    function writeList(format, nodes, sourceFile, output) {
	      const previousWriter = writer;
	      setWriter(
	        output,
	        /*_sourceMapGenerator*/
	        void 0
	      );
	      if (sourceFile) {
	        setSourceFile(sourceFile);
	      }
	      emitList(
	        /*parentNode*/
	        void 0,
	        nodes,
	        format
	      );
	      reset2();
	      writer = previousWriter;
	    }
	    function getTextPosWithWriteLine() {
	      return writer.getTextPosWithWriteLine ? writer.getTextPosWithWriteLine() : writer.getTextPos();
	    }
	    function updateOrPushBundleFileTextLike(pos, end, kind) {
	      const last2 = lastOrUndefined(bundleFileInfo.sections);
	      if (last2 && last2.kind === kind) {
	        last2.end = end;
	      } else {
	        bundleFileInfo.sections.push({ pos, end, kind });
	      }
	    }
	    function recordBundleFileInternalSectionStart(node) {
	      if (recordInternalSection && bundleFileInfo && currentSourceFile && (isDeclaration(node) || isVariableStatement(node)) && isInternalDeclaration(node, currentSourceFile) && sourceFileTextKind !== "internal" /* Internal */) {
	        const prevSourceFileTextKind = sourceFileTextKind;
	        recordBundleFileTextLikeSection(writer.getTextPos());
	        sourceFileTextPos = getTextPosWithWriteLine();
	        sourceFileTextKind = "internal" /* Internal */;
	        return prevSourceFileTextKind;
	      }
	      return void 0;
	    }
	    function recordBundleFileInternalSectionEnd(prevSourceFileTextKind) {
	      if (prevSourceFileTextKind) {
	        recordBundleFileTextLikeSection(writer.getTextPos());
	        sourceFileTextPos = getTextPosWithWriteLine();
	        sourceFileTextKind = prevSourceFileTextKind;
	      }
	    }
	    function recordBundleFileTextLikeSection(end) {
	      if (sourceFileTextPos < end) {
	        updateOrPushBundleFileTextLike(sourceFileTextPos, end, sourceFileTextKind);
	        return true;
	      }
	      return false;
	    }
	    function writeBundle(bundle, output, sourceMapGenerator2) {
	      isOwnFileEmit = false;
	      const previousWriter = writer;
	      setWriter(output, sourceMapGenerator2);
	      emitShebangIfNeeded(bundle);
	      emitPrologueDirectivesIfNeeded(bundle);
	      emitHelpers(bundle);
	      emitSyntheticTripleSlashReferencesIfNeeded(bundle);
	      for (const prepend of bundle.prepends) {
	        writeLine();
	        const pos = writer.getTextPos();
	        const savedSections = bundleFileInfo && bundleFileInfo.sections;
	        if (savedSections)
	          bundleFileInfo.sections = [];
	        print(
	          4 /* Unspecified */,
	          prepend,
	          /*sourceFile*/
	          void 0
	        );
	        if (bundleFileInfo) {
	          const newSections = bundleFileInfo.sections;
	          bundleFileInfo.sections = savedSections;
	          if (prepend.oldFileOfCurrentEmit)
	            bundleFileInfo.sections.push(...newSections);
	          else {
	            newSections.forEach((section) => Debug.assert(isBundleFileTextLike(section)));
	            bundleFileInfo.sections.push({
	              pos,
	              end: writer.getTextPos(),
	              kind: "prepend" /* Prepend */,
	              data: relativeToBuildInfo(prepend.fileName),
	              texts: newSections
	            });
	          }
	        }
	      }
	      sourceFileTextPos = getTextPosWithWriteLine();
	      for (const sourceFile of bundle.sourceFiles) {
	        print(0 /* SourceFile */, sourceFile, sourceFile);
	      }
	      if (bundleFileInfo && bundle.sourceFiles.length) {
	        const end = writer.getTextPos();
	        if (recordBundleFileTextLikeSection(end)) {
	          const prologues = getPrologueDirectivesFromBundledSourceFiles(bundle);
	          if (prologues) {
	            if (!bundleFileInfo.sources)
	              bundleFileInfo.sources = {};
	            bundleFileInfo.sources.prologues = prologues;
	          }
	          const helpers = getHelpersFromBundledSourceFiles(bundle);
	          if (helpers) {
	            if (!bundleFileInfo.sources)
	              bundleFileInfo.sources = {};
	            bundleFileInfo.sources.helpers = helpers;
	          }
	        }
	      }
	      reset2();
	      writer = previousWriter;
	    }
	    function writeUnparsedSource(unparsed, output) {
	      const previousWriter = writer;
	      setWriter(
	        output,
	        /*_sourceMapGenerator*/
	        void 0
	      );
	      print(
	        4 /* Unspecified */,
	        unparsed,
	        /*sourceFile*/
	        void 0
	      );
	      reset2();
	      writer = previousWriter;
	    }
	    function writeFile2(sourceFile, output, sourceMapGenerator2) {
	      isOwnFileEmit = true;
	      const previousWriter = writer;
	      setWriter(output, sourceMapGenerator2);
	      emitShebangIfNeeded(sourceFile);
	      emitPrologueDirectivesIfNeeded(sourceFile);
	      print(0 /* SourceFile */, sourceFile, sourceFile);
	      reset2();
	      writer = previousWriter;
	    }
	    function beginPrint() {
	      return ownWriter || (ownWriter = createTextWriter(newLine));
	    }
	    function endPrint() {
	      const text = ownWriter.getText();
	      ownWriter.clear();
	      return text;
	    }
	    function print(hint, node, sourceFile) {
	      if (sourceFile) {
	        setSourceFile(sourceFile);
	      }
	      pipelineEmit(
	        hint,
	        node,
	        /*parenthesizerRule*/
	        void 0
	      );
	    }
	    function setSourceFile(sourceFile) {
	      currentSourceFile = sourceFile;
	      currentLineMap = void 0;
	      detachedCommentsInfo = void 0;
	      if (sourceFile) {
	        setSourceMapSource(sourceFile);
	      }
	    }
	    function setWriter(_writer, _sourceMapGenerator) {
	      if (_writer && printerOptions.omitTrailingSemicolon) {
	        _writer = getTrailingSemicolonDeferringWriter(_writer);
	      }
	      writer = _writer;
	      sourceMapGenerator = _sourceMapGenerator;
	      sourceMapsDisabled = !writer || !sourceMapGenerator;
	    }
	    function reset2() {
	      nodeIdToGeneratedName = [];
	      nodeIdToGeneratedPrivateName = [];
	      autoGeneratedIdToGeneratedName = [];
	      generatedNames = /* @__PURE__ */ new Set();
	      formattedNameTempFlagsStack = [];
	      formattedNameTempFlags = /* @__PURE__ */ new Map();
	      privateNameTempFlagsStack = [];
	      privateNameTempFlags = 0 /* Auto */;
	      tempFlagsStack = [];
	      tempFlags = 0 /* Auto */;
	      reservedNamesStack = [];
	      reservedNames = void 0;
	      reservedPrivateNamesStack = [];
	      reservedPrivateNames = void 0;
	      currentSourceFile = void 0;
	      currentLineMap = void 0;
	      detachedCommentsInfo = void 0;
	      setWriter(
	        /*output*/
	        void 0,
	        /*_sourceMapGenerator*/
	        void 0
	      );
	    }
	    function getCurrentLineMap() {
	      return currentLineMap || (currentLineMap = getLineStarts(Debug.checkDefined(currentSourceFile)));
	    }
	    function emit(node, parenthesizerRule) {
	      if (node === void 0)
	        return;
	      const prevSourceFileTextKind = recordBundleFileInternalSectionStart(node);
	      pipelineEmit(4 /* Unspecified */, node, parenthesizerRule);
	      recordBundleFileInternalSectionEnd(prevSourceFileTextKind);
	    }
	    function emitIdentifierName(node) {
	      if (node === void 0)
	        return;
	      pipelineEmit(
	        2 /* IdentifierName */,
	        node,
	        /*parenthesizerRule*/
	        void 0
	      );
	    }
	    function emitExpression(node, parenthesizerRule) {
	      if (node === void 0)
	        return;
	      pipelineEmit(1 /* Expression */, node, parenthesizerRule);
	    }
	    function emitJsxAttributeValue(node) {
	      pipelineEmit(isStringLiteral(node) ? 6 /* JsxAttributeValue */ : 4 /* Unspecified */, node);
	    }
	    function beforeEmitNode(node) {
	      if (preserveSourceNewlines && getInternalEmitFlags(node) & 4 /* IgnoreSourceNewlines */) {
	        preserveSourceNewlines = false;
	      }
	    }
	    function afterEmitNode(savedPreserveSourceNewlines) {
	      preserveSourceNewlines = savedPreserveSourceNewlines;
	    }
	    function pipelineEmit(emitHint, node, parenthesizerRule) {
	      currentParenthesizerRule = parenthesizerRule;
	      const pipelinePhase = getPipelinePhase(0 /* Notification */, emitHint, node);
	      pipelinePhase(emitHint, node);
	      currentParenthesizerRule = void 0;
	    }
	    function shouldEmitComments(node) {
	      return !commentsDisabled && !isSourceFile(node);
	    }
	    function shouldEmitSourceMaps(node) {
	      return !sourceMapsDisabled && !isSourceFile(node) && !isInJsonFile(node) && !isUnparsedSource(node) && !isUnparsedPrepend(node);
	    }
	    function getPipelinePhase(phase, emitHint, node) {
	      switch (phase) {
	        case 0 /* Notification */:
	          if (onEmitNode !== noEmitNotification && (!isEmitNotificationEnabled || isEmitNotificationEnabled(node))) {
	            return pipelineEmitWithNotification;
	          }
	        case 1 /* Substitution */:
	          if (substituteNode !== noEmitSubstitution && (lastSubstitution = substituteNode(emitHint, node) || node) !== node) {
	            if (currentParenthesizerRule) {
	              lastSubstitution = currentParenthesizerRule(lastSubstitution);
	            }
	            return pipelineEmitWithSubstitution;
	          }
	        case 2 /* Comments */:
	          if (shouldEmitComments(node)) {
	            return pipelineEmitWithComments;
	          }
	        case 3 /* SourceMaps */:
	          if (shouldEmitSourceMaps(node)) {
	            return pipelineEmitWithSourceMaps;
	          }
	        case 4 /* Emit */:
	          return pipelineEmitWithHint;
	        default:
	          return Debug.assertNever(phase);
	      }
	    }
	    function getNextPipelinePhase(currentPhase, emitHint, node) {
	      return getPipelinePhase(currentPhase + 1, emitHint, node);
	    }
	    function pipelineEmitWithNotification(hint, node) {
	      const pipelinePhase = getNextPipelinePhase(0 /* Notification */, hint, node);
	      onEmitNode(hint, node, pipelinePhase);
	    }
	    function pipelineEmitWithHint(hint, node) {
	      onBeforeEmitNode == null ? void 0 : onBeforeEmitNode(node);
	      if (preserveSourceNewlines) {
	        const savedPreserveSourceNewlines = preserveSourceNewlines;
	        beforeEmitNode(node);
	        pipelineEmitWithHintWorker(hint, node);
	        afterEmitNode(savedPreserveSourceNewlines);
	      } else {
	        pipelineEmitWithHintWorker(hint, node);
	      }
	      onAfterEmitNode == null ? void 0 : onAfterEmitNode(node);
	      currentParenthesizerRule = void 0;
	    }
	    function pipelineEmitWithHintWorker(hint, node, allowSnippets = true) {
	      if (allowSnippets) {
	        const snippet = getSnippetElement(node);
	        if (snippet) {
	          return emitSnippetNode(hint, node, snippet);
	        }
	      }
	      if (hint === 0 /* SourceFile */)
	        return emitSourceFile(cast(node, isSourceFile));
	      if (hint === 2 /* IdentifierName */)
	        return emitIdentifier(cast(node, isIdentifier));
	      if (hint === 6 /* JsxAttributeValue */)
	        return emitLiteral(
	          cast(node, isStringLiteral),
	          /*jsxAttributeEscape*/
	          true
	        );
	      if (hint === 3 /* MappedTypeParameter */)
	        return emitMappedTypeParameter(cast(node, isTypeParameterDeclaration));
	      if (hint === 7 /* ImportTypeNodeAttributes */)
	        return emitImportTypeNodeAttributes(cast(node, isImportAttributes));
	      if (hint === 5 /* EmbeddedStatement */) {
	        Debug.assertNode(node, isEmptyStatement);
	        return emitEmptyStatement(
	          /*isEmbeddedStatement*/
	          true
	        );
	      }
	      if (hint === 4 /* Unspecified */) {
	        switch (node.kind) {
	          case 16 /* TemplateHead */:
	          case 17 /* TemplateMiddle */:
	          case 18 /* TemplateTail */:
	            return emitLiteral(
	              node,
	              /*jsxAttributeEscape*/
	              false
	            );
	          case 80 /* Identifier */:
	            return emitIdentifier(node);
	          case 81 /* PrivateIdentifier */:
	            return emitPrivateIdentifier(node);
	          case 166 /* QualifiedName */:
	            return emitQualifiedName(node);
	          case 167 /* ComputedPropertyName */:
	            return emitComputedPropertyName(node);
	          case 168 /* TypeParameter */:
	            return emitTypeParameter(node);
	          case 169 /* Parameter */:
	            return emitParameter(node);
	          case 170 /* Decorator */:
	            return emitDecorator(node);
	          case 171 /* PropertySignature */:
	            return emitPropertySignature(node);
	          case 172 /* PropertyDeclaration */:
	            return emitPropertyDeclaration(node);
	          case 173 /* MethodSignature */:
	            return emitMethodSignature(node);
	          case 174 /* MethodDeclaration */:
	            return emitMethodDeclaration(node);
	          case 175 /* ClassStaticBlockDeclaration */:
	            return emitClassStaticBlockDeclaration(node);
	          case 176 /* Constructor */:
	            return emitConstructor(node);
	          case 177 /* GetAccessor */:
	          case 178 /* SetAccessor */:
	            return emitAccessorDeclaration(node);
	          case 179 /* CallSignature */:
	            return emitCallSignature(node);
	          case 180 /* ConstructSignature */:
	            return emitConstructSignature(node);
	          case 181 /* IndexSignature */:
	            return emitIndexSignature(node);
	          case 182 /* TypePredicate */:
	            return emitTypePredicate(node);
	          case 183 /* TypeReference */:
	            return emitTypeReference(node);
	          case 184 /* FunctionType */:
	            return emitFunctionType(node);
	          case 185 /* ConstructorType */:
	            return emitConstructorType(node);
	          case 186 /* TypeQuery */:
	            return emitTypeQuery(node);
	          case 187 /* TypeLiteral */:
	            return emitTypeLiteral(node);
	          case 188 /* ArrayType */:
	            return emitArrayType(node);
	          case 189 /* TupleType */:
	            return emitTupleType(node);
	          case 190 /* OptionalType */:
	            return emitOptionalType(node);
	          case 192 /* UnionType */:
	            return emitUnionType(node);
	          case 193 /* IntersectionType */:
	            return emitIntersectionType(node);
	          case 194 /* ConditionalType */:
	            return emitConditionalType(node);
	          case 195 /* InferType */:
	            return emitInferType(node);
	          case 196 /* ParenthesizedType */:
	            return emitParenthesizedType(node);
	          case 233 /* ExpressionWithTypeArguments */:
	            return emitExpressionWithTypeArguments(node);
	          case 197 /* ThisType */:
	            return emitThisType();
	          case 198 /* TypeOperator */:
	            return emitTypeOperator(node);
	          case 199 /* IndexedAccessType */:
	            return emitIndexedAccessType(node);
	          case 200 /* MappedType */:
	            return emitMappedType(node);
	          case 201 /* LiteralType */:
	            return emitLiteralType(node);
	          case 202 /* NamedTupleMember */:
	            return emitNamedTupleMember(node);
	          case 203 /* TemplateLiteralType */:
	            return emitTemplateType(node);
	          case 204 /* TemplateLiteralTypeSpan */:
	            return emitTemplateTypeSpan(node);
	          case 205 /* ImportType */:
	            return emitImportTypeNode(node);
	          case 206 /* ObjectBindingPattern */:
	            return emitObjectBindingPattern(node);
	          case 207 /* ArrayBindingPattern */:
	            return emitArrayBindingPattern(node);
	          case 208 /* BindingElement */:
	            return emitBindingElement(node);
	          case 239 /* TemplateSpan */:
	            return emitTemplateSpan(node);
	          case 240 /* SemicolonClassElement */:
	            return emitSemicolonClassElement();
	          case 241 /* Block */:
	            return emitBlock(node);
	          case 243 /* VariableStatement */:
	            return emitVariableStatement(node);
	          case 242 /* EmptyStatement */:
	            return emitEmptyStatement(
	              /*isEmbeddedStatement*/
	              false
	            );
	          case 244 /* ExpressionStatement */:
	            return emitExpressionStatement(node);
	          case 245 /* IfStatement */:
	            return emitIfStatement(node);
	          case 246 /* DoStatement */:
	            return emitDoStatement(node);
	          case 247 /* WhileStatement */:
	            return emitWhileStatement(node);
	          case 248 /* ForStatement */:
	            return emitForStatement(node);
	          case 249 /* ForInStatement */:
	            return emitForInStatement(node);
	          case 250 /* ForOfStatement */:
	            return emitForOfStatement(node);
	          case 251 /* ContinueStatement */:
	            return emitContinueStatement(node);
	          case 252 /* BreakStatement */:
	            return emitBreakStatement(node);
	          case 253 /* ReturnStatement */:
	            return emitReturnStatement(node);
	          case 254 /* WithStatement */:
	            return emitWithStatement(node);
	          case 255 /* SwitchStatement */:
	            return emitSwitchStatement(node);
	          case 256 /* LabeledStatement */:
	            return emitLabeledStatement(node);
	          case 257 /* ThrowStatement */:
	            return emitThrowStatement(node);
	          case 258 /* TryStatement */:
	            return emitTryStatement(node);
	          case 259 /* DebuggerStatement */:
	            return emitDebuggerStatement(node);
	          case 260 /* VariableDeclaration */:
	            return emitVariableDeclaration(node);
	          case 261 /* VariableDeclarationList */:
	            return emitVariableDeclarationList(node);
	          case 262 /* FunctionDeclaration */:
	            return emitFunctionDeclaration(node);
	          case 263 /* ClassDeclaration */:
	            return emitClassDeclaration(node);
	          case 264 /* InterfaceDeclaration */:
	            return emitInterfaceDeclaration(node);
	          case 265 /* TypeAliasDeclaration */:
	            return emitTypeAliasDeclaration(node);
	          case 266 /* EnumDeclaration */:
	            return emitEnumDeclaration(node);
	          case 267 /* ModuleDeclaration */:
	            return emitModuleDeclaration(node);
	          case 268 /* ModuleBlock */:
	            return emitModuleBlock(node);
	          case 269 /* CaseBlock */:
	            return emitCaseBlock(node);
	          case 270 /* NamespaceExportDeclaration */:
	            return emitNamespaceExportDeclaration(node);
	          case 271 /* ImportEqualsDeclaration */:
	            return emitImportEqualsDeclaration(node);
	          case 272 /* ImportDeclaration */:
	            return emitImportDeclaration(node);
	          case 273 /* ImportClause */:
	            return emitImportClause(node);
	          case 274 /* NamespaceImport */:
	            return emitNamespaceImport(node);
	          case 280 /* NamespaceExport */:
	            return emitNamespaceExport(node);
	          case 275 /* NamedImports */:
	            return emitNamedImports(node);
	          case 276 /* ImportSpecifier */:
	            return emitImportSpecifier(node);
	          case 277 /* ExportAssignment */:
	            return emitExportAssignment(node);
	          case 278 /* ExportDeclaration */:
	            return emitExportDeclaration(node);
	          case 279 /* NamedExports */:
	            return emitNamedExports(node);
	          case 281 /* ExportSpecifier */:
	            return emitExportSpecifier(node);
	          case 300 /* ImportAttributes */:
	            return emitImportAttributes(node);
	          case 301 /* ImportAttribute */:
	            return emitImportAttribute(node);
	          case 282 /* MissingDeclaration */:
	            return;
	          case 283 /* ExternalModuleReference */:
	            return emitExternalModuleReference(node);
	          case 12 /* JsxText */:
	            return emitJsxText(node);
	          case 286 /* JsxOpeningElement */:
	          case 289 /* JsxOpeningFragment */:
	            return emitJsxOpeningElementOrFragment(node);
	          case 287 /* JsxClosingElement */:
	          case 290 /* JsxClosingFragment */:
	            return emitJsxClosingElementOrFragment(node);
	          case 291 /* JsxAttribute */:
	            return emitJsxAttribute(node);
	          case 292 /* JsxAttributes */:
	            return emitJsxAttributes(node);
	          case 293 /* JsxSpreadAttribute */:
	            return emitJsxSpreadAttribute(node);
	          case 294 /* JsxExpression */:
	            return emitJsxExpression(node);
	          case 295 /* JsxNamespacedName */:
	            return emitJsxNamespacedName(node);
	          case 296 /* CaseClause */:
	            return emitCaseClause(node);
	          case 297 /* DefaultClause */:
	            return emitDefaultClause(node);
	          case 298 /* HeritageClause */:
	            return emitHeritageClause(node);
	          case 299 /* CatchClause */:
	            return emitCatchClause(node);
	          case 303 /* PropertyAssignment */:
	            return emitPropertyAssignment(node);
	          case 304 /* ShorthandPropertyAssignment */:
	            return emitShorthandPropertyAssignment(node);
	          case 305 /* SpreadAssignment */:
	            return emitSpreadAssignment(node);
	          case 306 /* EnumMember */:
	            return emitEnumMember(node);
	          case 307 /* UnparsedPrologue */:
	            return writeUnparsedNode(node);
	          case 314 /* UnparsedSource */:
	          case 308 /* UnparsedPrepend */:
	            return emitUnparsedSourceOrPrepend(node);
	          case 309 /* UnparsedText */:
	          case 310 /* UnparsedInternalText */:
	            return emitUnparsedTextLike(node);
	          case 311 /* UnparsedSyntheticReference */:
	            return emitUnparsedSyntheticReference(node);
	          case 312 /* SourceFile */:
	            return emitSourceFile(node);
	          case 313 /* Bundle */:
	            return Debug.fail("Bundles should be printed using printBundle");
	          case 315 /* InputFiles */:
	            return Debug.fail("InputFiles should not be printed");
	          case 316 /* JSDocTypeExpression */:
	            return emitJSDocTypeExpression(node);
	          case 317 /* JSDocNameReference */:
	            return emitJSDocNameReference(node);
	          case 319 /* JSDocAllType */:
	            return writePunctuation("*");
	          case 320 /* JSDocUnknownType */:
	            return writePunctuation("?");
	          case 321 /* JSDocNullableType */:
	            return emitJSDocNullableType(node);
	          case 322 /* JSDocNonNullableType */:
	            return emitJSDocNonNullableType(node);
	          case 323 /* JSDocOptionalType */:
	            return emitJSDocOptionalType(node);
	          case 324 /* JSDocFunctionType */:
	            return emitJSDocFunctionType(node);
	          case 191 /* RestType */:
	          case 325 /* JSDocVariadicType */:
	            return emitRestOrJSDocVariadicType(node);
	          case 326 /* JSDocNamepathType */:
	            return;
	          case 327 /* JSDoc */:
	            return emitJSDoc(node);
	          case 329 /* JSDocTypeLiteral */:
	            return emitJSDocTypeLiteral(node);
	          case 330 /* JSDocSignature */:
	            return emitJSDocSignature(node);
	          case 334 /* JSDocTag */:
	          case 339 /* JSDocClassTag */:
	          case 344 /* JSDocOverrideTag */:
	            return emitJSDocSimpleTag(node);
	          case 335 /* JSDocAugmentsTag */:
	          case 336 /* JSDocImplementsTag */:
	            return emitJSDocHeritageTag(node);
	          case 337 /* JSDocAuthorTag */:
	          case 338 /* JSDocDeprecatedTag */:
	            return;
	          case 340 /* JSDocPublicTag */:
	          case 341 /* JSDocPrivateTag */:
	          case 342 /* JSDocProtectedTag */:
	          case 343 /* JSDocReadonlyTag */:
	            return;
	          case 345 /* JSDocCallbackTag */:
	            return emitJSDocCallbackTag(node);
	          case 346 /* JSDocOverloadTag */:
	            return emitJSDocOverloadTag(node);
	          case 348 /* JSDocParameterTag */:
	          case 355 /* JSDocPropertyTag */:
	            return emitJSDocPropertyLikeTag(node);
	          case 347 /* JSDocEnumTag */:
	          case 349 /* JSDocReturnTag */:
	          case 350 /* JSDocThisTag */:
	          case 351 /* JSDocTypeTag */:
	          case 356 /* JSDocThrowsTag */:
	          case 357 /* JSDocSatisfiesTag */:
	            return emitJSDocSimpleTypedTag(node);
	          case 352 /* JSDocTemplateTag */:
	            return emitJSDocTemplateTag(node);
	          case 353 /* JSDocTypedefTag */:
	            return emitJSDocTypedefTag(node);
	          case 354 /* JSDocSeeTag */:
	            return emitJSDocSeeTag(node);
	          case 359 /* NotEmittedStatement */:
	            return;
	        }
	        if (isExpression(node)) {
	          hint = 1 /* Expression */;
	          if (substituteNode !== noEmitSubstitution) {
	            const substitute = substituteNode(hint, node) || node;
	            if (substitute !== node) {
	              node = substitute;
	              if (currentParenthesizerRule) {
	                node = currentParenthesizerRule(node);
	              }
	            }
	          }
	        }
	      }
	      if (hint === 1 /* Expression */) {
	        switch (node.kind) {
	          case 9 /* NumericLiteral */:
	          case 10 /* BigIntLiteral */:
	            return emitNumericOrBigIntLiteral(node);
	          case 11 /* StringLiteral */:
	          case 14 /* RegularExpressionLiteral */:
	          case 15 /* NoSubstitutionTemplateLiteral */:
	            return emitLiteral(
	              node,
	              /*jsxAttributeEscape*/
	              false
	            );
	          case 80 /* Identifier */:
	            return emitIdentifier(node);
	          case 81 /* PrivateIdentifier */:
	            return emitPrivateIdentifier(node);
	          case 209 /* ArrayLiteralExpression */:
	            return emitArrayLiteralExpression(node);
	          case 210 /* ObjectLiteralExpression */:
	            return emitObjectLiteralExpression(node);
	          case 211 /* PropertyAccessExpression */:
	            return emitPropertyAccessExpression(node);
	          case 212 /* ElementAccessExpression */:
	            return emitElementAccessExpression(node);
	          case 213 /* CallExpression */:
	            return emitCallExpression(node);
	          case 214 /* NewExpression */:
	            return emitNewExpression(node);
	          case 215 /* TaggedTemplateExpression */:
	            return emitTaggedTemplateExpression(node);
	          case 216 /* TypeAssertionExpression */:
	            return emitTypeAssertionExpression(node);
	          case 217 /* ParenthesizedExpression */:
	            return emitParenthesizedExpression(node);
	          case 218 /* FunctionExpression */:
	            return emitFunctionExpression(node);
	          case 219 /* ArrowFunction */:
	            return emitArrowFunction(node);
	          case 220 /* DeleteExpression */:
	            return emitDeleteExpression(node);
	          case 221 /* TypeOfExpression */:
	            return emitTypeOfExpression(node);
	          case 222 /* VoidExpression */:
	            return emitVoidExpression(node);
	          case 223 /* AwaitExpression */:
	            return emitAwaitExpression(node);
	          case 224 /* PrefixUnaryExpression */:
	            return emitPrefixUnaryExpression(node);
	          case 225 /* PostfixUnaryExpression */:
	            return emitPostfixUnaryExpression(node);
	          case 226 /* BinaryExpression */:
	            return emitBinaryExpression(node);
	          case 227 /* ConditionalExpression */:
	            return emitConditionalExpression(node);
	          case 228 /* TemplateExpression */:
	            return emitTemplateExpression(node);
	          case 229 /* YieldExpression */:
	            return emitYieldExpression(node);
	          case 230 /* SpreadElement */:
	            return emitSpreadElement(node);
	          case 231 /* ClassExpression */:
	            return emitClassExpression(node);
	          case 232 /* OmittedExpression */:
	            return;
	          case 234 /* AsExpression */:
	            return emitAsExpression(node);
	          case 235 /* NonNullExpression */:
	            return emitNonNullExpression(node);
	          case 233 /* ExpressionWithTypeArguments */:
	            return emitExpressionWithTypeArguments(node);
	          case 238 /* SatisfiesExpression */:
	            return emitSatisfiesExpression(node);
	          case 236 /* MetaProperty */:
	            return emitMetaProperty(node);
	          case 237 /* SyntheticExpression */:
	            return Debug.fail("SyntheticExpression should never be printed.");
	          case 282 /* MissingDeclaration */:
	            return;
	          case 284 /* JsxElement */:
	            return emitJsxElement(node);
	          case 285 /* JsxSelfClosingElement */:
	            return emitJsxSelfClosingElement(node);
	          case 288 /* JsxFragment */:
	            return emitJsxFragment(node);
	          case 358 /* SyntaxList */:
	            return Debug.fail("SyntaxList should not be printed");
	          case 359 /* NotEmittedStatement */:
	            return;
	          case 360 /* PartiallyEmittedExpression */:
	            return emitPartiallyEmittedExpression(node);
	          case 361 /* CommaListExpression */:
	            return emitCommaList(node);
	          case 362 /* SyntheticReferenceExpression */:
	            return Debug.fail("SyntheticReferenceExpression should not be printed");
	        }
	      }
	      if (isKeyword(node.kind))
	        return writeTokenNode(node, writeKeyword);
	      if (isTokenKind(node.kind))
	        return writeTokenNode(node, writePunctuation);
	      Debug.fail(`Unhandled SyntaxKind: ${Debug.formatSyntaxKind(node.kind)}.`);
	    }
	    function emitMappedTypeParameter(node) {
	      emit(node.name);
	      writeSpace();
	      writeKeyword("in");
	      writeSpace();
	      emit(node.constraint);
	    }
	    function pipelineEmitWithSubstitution(hint, node) {
	      const pipelinePhase = getNextPipelinePhase(1 /* Substitution */, hint, node);
	      Debug.assertIsDefined(lastSubstitution);
	      node = lastSubstitution;
	      lastSubstitution = void 0;
	      pipelinePhase(hint, node);
	    }
	    function getHelpersFromBundledSourceFiles(bundle) {
	      let result;
	      if (moduleKind === 0 /* None */ || printerOptions.noEmitHelpers) {
	        return void 0;
	      }
	      const bundledHelpers2 = /* @__PURE__ */ new Map();
	      for (const sourceFile of bundle.sourceFiles) {
	        const shouldSkip = getExternalHelpersModuleName(sourceFile) !== void 0;
	        const helpers = getSortedEmitHelpers(sourceFile);
	        if (!helpers)
	          continue;
	        for (const helper of helpers) {
	          if (!helper.scoped && !shouldSkip && !bundledHelpers2.get(helper.name)) {
	            bundledHelpers2.set(helper.name, true);
	            (result || (result = [])).push(helper.name);
	          }
	        }
	      }
	      return result;
	    }
	    function emitHelpers(node) {
	      let helpersEmitted = false;
	      const bundle = node.kind === 313 /* Bundle */ ? node : void 0;
	      if (bundle && moduleKind === 0 /* None */) {
	        return;
	      }
	      const numPrepends = bundle ? bundle.prepends.length : 0;
	      const numNodes = bundle ? bundle.sourceFiles.length + numPrepends : 1;
	      for (let i = 0; i < numNodes; i++) {
	        const currentNode = bundle ? i < numPrepends ? bundle.prepends[i] : bundle.sourceFiles[i - numPrepends] : node;
	        const sourceFile = isSourceFile(currentNode) ? currentNode : isUnparsedSource(currentNode) ? void 0 : currentSourceFile;
	        const shouldSkip = printerOptions.noEmitHelpers || !!sourceFile && hasRecordedExternalHelpers(sourceFile);
	        const shouldBundle = (isSourceFile(currentNode) || isUnparsedSource(currentNode)) && !isOwnFileEmit;
	        const helpers = isUnparsedSource(currentNode) ? currentNode.helpers : getSortedEmitHelpers(currentNode);
	        if (helpers) {
	          for (const helper of helpers) {
	            if (!helper.scoped) {
	              if (shouldSkip)
	                continue;
	              if (shouldBundle) {
	                if (bundledHelpers.get(helper.name)) {
	                  continue;
	                }
	                bundledHelpers.set(helper.name, true);
	              }
	            } else if (bundle) {
	              continue;
	            }
	            const pos = getTextPosWithWriteLine();
	            if (typeof helper.text === "string") {
	              writeLines(helper.text);
	            } else {
	              writeLines(helper.text(makeFileLevelOptimisticUniqueName));
	            }
	            if (bundleFileInfo)
	              bundleFileInfo.sections.push({ pos, end: writer.getTextPos(), kind: "emitHelpers" /* EmitHelpers */, data: helper.name });
	            helpersEmitted = true;
	          }
	        }
	      }
	      return helpersEmitted;
	    }
	    function getSortedEmitHelpers(node) {
	      const helpers = getEmitHelpers(node);
	      return helpers && stableSort(helpers, compareEmitHelpers);
	    }
	    function emitNumericOrBigIntLiteral(node) {
	      emitLiteral(
	        node,
	        /*jsxAttributeEscape*/
	        false
	      );
	    }
	    function emitLiteral(node, jsxAttributeEscape) {
	      const text = getLiteralTextOfNode(node, printerOptions.neverAsciiEscape, jsxAttributeEscape);
	      if ((printerOptions.sourceMap || printerOptions.inlineSourceMap) && (node.kind === 11 /* StringLiteral */ || isTemplateLiteralKind(node.kind))) {
	        writeLiteral(text);
	      } else {
	        writeStringLiteral(text);
	      }
	    }
	    function emitUnparsedSourceOrPrepend(unparsed) {
	      for (const text of unparsed.texts) {
	        writeLine();
	        emit(text);
	      }
	    }
	    function writeUnparsedNode(unparsed) {
	      writer.rawWrite(unparsed.parent.text.substring(unparsed.pos, unparsed.end));
	    }
	    function emitUnparsedTextLike(unparsed) {
	      const pos = getTextPosWithWriteLine();
	      writeUnparsedNode(unparsed);
	      if (bundleFileInfo) {
	        updateOrPushBundleFileTextLike(
	          pos,
	          writer.getTextPos(),
	          unparsed.kind === 309 /* UnparsedText */ ? "text" /* Text */ : "internal" /* Internal */
	        );
	      }
	    }
	    function emitUnparsedSyntheticReference(unparsed) {
	      const pos = getTextPosWithWriteLine();
	      writeUnparsedNode(unparsed);
	      if (bundleFileInfo) {
	        const section = clone(unparsed.section);
	        section.pos = pos;
	        section.end = writer.getTextPos();
	        bundleFileInfo.sections.push(section);
	      }
	    }
	    function emitSnippetNode(hint, node, snippet) {
	      switch (snippet.kind) {
	        case 1 /* Placeholder */:
	          emitPlaceholder(hint, node, snippet);
	          break;
	        case 0 /* TabStop */:
	          emitTabStop(hint, node, snippet);
	          break;
	      }
	    }
	    function emitPlaceholder(hint, node, snippet) {
	      nonEscapingWrite(`\${${snippet.order}:`);
	      pipelineEmitWithHintWorker(
	        hint,
	        node,
	        /*allowSnippets*/
	        false
	      );
	      nonEscapingWrite(`}`);
	    }
	    function emitTabStop(hint, node, snippet) {
	      Debug.assert(node.kind === 242 /* EmptyStatement */, `A tab stop cannot be attached to a node of kind ${Debug.formatSyntaxKind(node.kind)}.`);
	      Debug.assert(hint !== 5 /* EmbeddedStatement */, `A tab stop cannot be attached to an embedded statement.`);
	      nonEscapingWrite(`$${snippet.order}`);
	    }
	    function emitIdentifier(node) {
	      const writeText = node.symbol ? writeSymbol : write;
	      writeText(getTextOfNode2(
	        node,
	        /*includeTrivia*/
	        false
	      ), node.symbol);
	      emitList(node, getIdentifierTypeArguments(node), 53776 /* TypeParameters */);
	    }
	    function emitPrivateIdentifier(node) {
	      write(getTextOfNode2(
	        node,
	        /*includeTrivia*/
	        false
	      ));
	    }
	    function emitQualifiedName(node) {
	      emitEntityName(node.left);
	      writePunctuation(".");
	      emit(node.right);
	    }
	    function emitEntityName(node) {
	      if (node.kind === 80 /* Identifier */) {
	        emitExpression(node);
	      } else {
	        emit(node);
	      }
	    }
	    function emitComputedPropertyName(node) {
	      const savedPrivateNameTempFlags = privateNameTempFlags;
	      const savedReservedMemberNames = reservedPrivateNames;
	      popPrivateNameGenerationScope();
	      writePunctuation("[");
	      emitExpression(node.expression, parenthesizer.parenthesizeExpressionOfComputedPropertyName);
	      writePunctuation("]");
	      pushPrivateNameGenerationScope(savedPrivateNameTempFlags, savedReservedMemberNames);
	    }
	    function emitTypeParameter(node) {
	      emitModifierList(node, node.modifiers);
	      emit(node.name);
	      if (node.constraint) {
	        writeSpace();
	        writeKeyword("extends");
	        writeSpace();
	        emit(node.constraint);
	      }
	      if (node.default) {
	        writeSpace();
	        writeOperator("=");
	        writeSpace();
	        emit(node.default);
	      }
	    }
	    function emitParameter(node) {
	      emitDecoratorsAndModifiers(
	        node,
	        node.modifiers,
	        /*allowDecorators*/
	        true
	      );
	      emit(node.dotDotDotToken);
	      emitNodeWithWriter(node.name, writeParameter);
	      emit(node.questionToken);
	      if (node.parent && node.parent.kind === 324 /* JSDocFunctionType */ && !node.name) {
	        emit(node.type);
	      } else {
	        emitTypeAnnotation(node.type);
	      }
	      emitInitializer(node.initializer, node.type ? node.type.end : node.questionToken ? node.questionToken.end : node.name ? node.name.end : node.modifiers ? node.modifiers.end : node.pos, node, parenthesizer.parenthesizeExpressionForDisallowedComma);
	    }
	    function emitDecorator(decorator) {
	      writePunctuation("@");
	      emitExpression(decorator.expression, parenthesizer.parenthesizeLeftSideOfAccess);
	    }
	    function emitPropertySignature(node) {
	      emitModifierList(node, node.modifiers);
	      emitNodeWithWriter(node.name, writeProperty);
	      emit(node.questionToken);
	      emitTypeAnnotation(node.type);
	      writeTrailingSemicolon();
	    }
	    function emitPropertyDeclaration(node) {
	      emitDecoratorsAndModifiers(
	        node,
	        node.modifiers,
	        /*allowDecorators*/
	        true
	      );
	      emit(node.name);
	      emit(node.questionToken);
	      emit(node.exclamationToken);
	      emitTypeAnnotation(node.type);
	      emitInitializer(node.initializer, node.type ? node.type.end : node.questionToken ? node.questionToken.end : node.name.end, node);
	      writeTrailingSemicolon();
	    }
	    function emitMethodSignature(node) {
	      pushNameGenerationScope(node);
	      emitModifierList(node, node.modifiers);
	      emit(node.name);
	      emit(node.questionToken);
	      emitTypeParameters(node, node.typeParameters);
	      emitParameters(node, node.parameters);
	      emitTypeAnnotation(node.type);
	      writeTrailingSemicolon();
	      popNameGenerationScope(node);
	    }
	    function emitMethodDeclaration(node) {
	      emitDecoratorsAndModifiers(
	        node,
	        node.modifiers,
	        /*allowDecorators*/
	        true
	      );
	      emit(node.asteriskToken);
	      emit(node.name);
	      emit(node.questionToken);
	      emitSignatureAndBody(node, emitSignatureHead);
	    }
	    function emitClassStaticBlockDeclaration(node) {
	      writeKeyword("static");
	      emitBlockFunctionBody(node.body);
	    }
	    function emitConstructor(node) {
	      emitDecoratorsAndModifiers(
	        node,
	        node.modifiers,
	        /*allowDecorators*/
	        false
	      );
	      writeKeyword("constructor");
	      emitSignatureAndBody(node, emitSignatureHead);
	    }
	    function emitAccessorDeclaration(node) {
	      const pos = emitDecoratorsAndModifiers(
	        node,
	        node.modifiers,
	        /*allowDecorators*/
	        true
	      );
	      const token = node.kind === 177 /* GetAccessor */ ? 139 /* GetKeyword */ : 153 /* SetKeyword */;
	      emitTokenWithComment(token, pos, writeKeyword, node);
	      writeSpace();
	      emit(node.name);
	      emitSignatureAndBody(node, emitSignatureHead);
	    }
	    function emitCallSignature(node) {
	      pushNameGenerationScope(node);
	      emitTypeParameters(node, node.typeParameters);
	      emitParameters(node, node.parameters);
	      emitTypeAnnotation(node.type);
	      writeTrailingSemicolon();
	      popNameGenerationScope(node);
	    }
	    function emitConstructSignature(node) {
	      pushNameGenerationScope(node);
	      writeKeyword("new");
	      writeSpace();
	      emitTypeParameters(node, node.typeParameters);
	      emitParameters(node, node.parameters);
	      emitTypeAnnotation(node.type);
	      writeTrailingSemicolon();
	      popNameGenerationScope(node);
	    }
	    function emitIndexSignature(node) {
	      emitDecoratorsAndModifiers(
	        node,
	        node.modifiers,
	        /*allowDecorators*/
	        false
	      );
	      emitParametersForIndexSignature(node, node.parameters);
	      emitTypeAnnotation(node.type);
	      writeTrailingSemicolon();
	    }
	    function emitTemplateTypeSpan(node) {
	      emit(node.type);
	      emit(node.literal);
	    }
	    function emitSemicolonClassElement() {
	      writeTrailingSemicolon();
	    }
	    function emitTypePredicate(node) {
	      if (node.assertsModifier) {
	        emit(node.assertsModifier);
	        writeSpace();
	      }
	      emit(node.parameterName);
	      if (node.type) {
	        writeSpace();
	        writeKeyword("is");
	        writeSpace();
	        emit(node.type);
	      }
	    }
	    function emitTypeReference(node) {
	      emit(node.typeName);
	      emitTypeArguments(node, node.typeArguments);
	    }
	    function emitFunctionType(node) {
	      pushNameGenerationScope(node);
	      emitTypeParameters(node, node.typeParameters);
	      emitParametersForArrow(node, node.parameters);
	      writeSpace();
	      writePunctuation("=>");
	      writeSpace();
	      emit(node.type);
	      popNameGenerationScope(node);
	    }
	    function emitJSDocFunctionType(node) {
	      writeKeyword("function");
	      emitParameters(node, node.parameters);
	      writePunctuation(":");
	      emit(node.type);
	    }
	    function emitJSDocNullableType(node) {
	      writePunctuation("?");
	      emit(node.type);
	    }
	    function emitJSDocNonNullableType(node) {
	      writePunctuation("!");
	      emit(node.type);
	    }
	    function emitJSDocOptionalType(node) {
	      emit(node.type);
	      writePunctuation("=");
	    }
	    function emitConstructorType(node) {
	      pushNameGenerationScope(node);
	      emitModifierList(node, node.modifiers);
	      writeKeyword("new");
	      writeSpace();
	      emitTypeParameters(node, node.typeParameters);
	      emitParameters(node, node.parameters);
	      writeSpace();
	      writePunctuation("=>");
	      writeSpace();
	      emit(node.type);
	      popNameGenerationScope(node);
	    }
	    function emitTypeQuery(node) {
	      writeKeyword("typeof");
	      writeSpace();
	      emit(node.exprName);
	      emitTypeArguments(node, node.typeArguments);
	    }
	    function emitTypeLiteral(node) {
	      pushPrivateNameGenerationScope(
	        0 /* Auto */,
	        /*newReservedMemberNames*/
	        void 0
	      );
	      writePunctuation("{");
	      const flags = getEmitFlags(node) & 1 /* SingleLine */ ? 768 /* SingleLineTypeLiteralMembers */ : 32897 /* MultiLineTypeLiteralMembers */;
	      emitList(node, node.members, flags | 524288 /* NoSpaceIfEmpty */);
	      writePunctuation("}");
	      popPrivateNameGenerationScope();
	    }
	    function emitArrayType(node) {
	      emit(node.elementType, parenthesizer.parenthesizeNonArrayTypeOfPostfixType);
	      writePunctuation("[");
	      writePunctuation("]");
	    }
	    function emitRestOrJSDocVariadicType(node) {
	      writePunctuation("...");
	      emit(node.type);
	    }
	    function emitTupleType(node) {
	      emitTokenWithComment(23 /* OpenBracketToken */, node.pos, writePunctuation, node);
	      const flags = getEmitFlags(node) & 1 /* SingleLine */ ? 528 /* SingleLineTupleTypeElements */ : 657 /* MultiLineTupleTypeElements */;
	      emitList(node, node.elements, flags | 524288 /* NoSpaceIfEmpty */, parenthesizer.parenthesizeElementTypeOfTupleType);
	      emitTokenWithComment(24 /* CloseBracketToken */, node.elements.end, writePunctuation, node);
	    }
	    function emitNamedTupleMember(node) {
	      emit(node.dotDotDotToken);
	      emit(node.name);
	      emit(node.questionToken);
	      emitTokenWithComment(59 /* ColonToken */, node.name.end, writePunctuation, node);
	      writeSpace();
	      emit(node.type);
	    }
	    function emitOptionalType(node) {
	      emit(node.type, parenthesizer.parenthesizeTypeOfOptionalType);
	      writePunctuation("?");
	    }
	    function emitUnionType(node) {
	      emitList(node, node.types, 516 /* UnionTypeConstituents */, parenthesizer.parenthesizeConstituentTypeOfUnionType);
	    }
	    function emitIntersectionType(node) {
	      emitList(node, node.types, 520 /* IntersectionTypeConstituents */, parenthesizer.parenthesizeConstituentTypeOfIntersectionType);
	    }
	    function emitConditionalType(node) {
	      emit(node.checkType, parenthesizer.parenthesizeCheckTypeOfConditionalType);
	      writeSpace();
	      writeKeyword("extends");
	      writeSpace();
	      emit(node.extendsType, parenthesizer.parenthesizeExtendsTypeOfConditionalType);
	      writeSpace();
	      writePunctuation("?");
	      writeSpace();
	      emit(node.trueType);
	      writeSpace();
	      writePunctuation(":");
	      writeSpace();
	      emit(node.falseType);
	    }
	    function emitInferType(node) {
	      writeKeyword("infer");
	      writeSpace();
	      emit(node.typeParameter);
	    }
	    function emitParenthesizedType(node) {
	      writePunctuation("(");
	      emit(node.type);
	      writePunctuation(")");
	    }
	    function emitThisType() {
	      writeKeyword("this");
	    }
	    function emitTypeOperator(node) {
	      writeTokenText(node.operator, writeKeyword);
	      writeSpace();
	      const parenthesizerRule = node.operator === 148 /* ReadonlyKeyword */ ? parenthesizer.parenthesizeOperandOfReadonlyTypeOperator : parenthesizer.parenthesizeOperandOfTypeOperator;
	      emit(node.type, parenthesizerRule);
	    }
	    function emitIndexedAccessType(node) {
	      emit(node.objectType, parenthesizer.parenthesizeNonArrayTypeOfPostfixType);
	      writePunctuation("[");
	      emit(node.indexType);
	      writePunctuation("]");
	    }
	    function emitMappedType(node) {
	      const emitFlags = getEmitFlags(node);
	      writePunctuation("{");
	      if (emitFlags & 1 /* SingleLine */) {
	        writeSpace();
	      } else {
	        writeLine();
	        increaseIndent();
	      }
	      if (node.readonlyToken) {
	        emit(node.readonlyToken);
	        if (node.readonlyToken.kind !== 148 /* ReadonlyKeyword */) {
	          writeKeyword("readonly");
	        }
	        writeSpace();
	      }
	      writePunctuation("[");
	      pipelineEmit(3 /* MappedTypeParameter */, node.typeParameter);
	      if (node.nameType) {
	        writeSpace();
	        writeKeyword("as");
	        writeSpace();
	        emit(node.nameType);
	      }
	      writePunctuation("]");
	      if (node.questionToken) {
	        emit(node.questionToken);
	        if (node.questionToken.kind !== 58 /* QuestionToken */) {
	          writePunctuation("?");
	        }
	      }
	      writePunctuation(":");
	      writeSpace();
	      emit(node.type);
	      writeTrailingSemicolon();
	      if (emitFlags & 1 /* SingleLine */) {
	        writeSpace();
	      } else {
	        writeLine();
	        decreaseIndent();
	      }
	      emitList(node, node.members, 2 /* PreserveLines */);
	      writePunctuation("}");
	    }
	    function emitLiteralType(node) {
	      emitExpression(node.literal);
	    }
	    function emitTemplateType(node) {
	      emit(node.head);
	      emitList(node, node.templateSpans, 262144 /* TemplateExpressionSpans */);
	    }
	    function emitImportTypeNode(node) {
	      if (node.isTypeOf) {
	        writeKeyword("typeof");
	        writeSpace();
	      }
	      writeKeyword("import");
	      writePunctuation("(");
	      emit(node.argument);
	      if (node.attributes) {
	        writePunctuation(",");
	        writeSpace();
	        pipelineEmit(7 /* ImportTypeNodeAttributes */, node.attributes);
	      }
	      writePunctuation(")");
	      if (node.qualifier) {
	        writePunctuation(".");
	        emit(node.qualifier);
	      }
	      emitTypeArguments(node, node.typeArguments);
	    }
	    function emitObjectBindingPattern(node) {
	      writePunctuation("{");
	      emitList(node, node.elements, 525136 /* ObjectBindingPatternElements */);
	      writePunctuation("}");
	    }
	    function emitArrayBindingPattern(node) {
	      writePunctuation("[");
	      emitList(node, node.elements, 524880 /* ArrayBindingPatternElements */);
	      writePunctuation("]");
	    }
	    function emitBindingElement(node) {
	      emit(node.dotDotDotToken);
	      if (node.propertyName) {
	        emit(node.propertyName);
	        writePunctuation(":");
	        writeSpace();
	      }
	      emit(node.name);
	      emitInitializer(node.initializer, node.name.end, node, parenthesizer.parenthesizeExpressionForDisallowedComma);
	    }
	    function emitArrayLiteralExpression(node) {
	      const elements = node.elements;
	      const preferNewLine = node.multiLine ? 65536 /* PreferNewLine */ : 0 /* None */;
	      emitExpressionList(node, elements, 8914 /* ArrayLiteralExpressionElements */ | preferNewLine, parenthesizer.parenthesizeExpressionForDisallowedComma);
	    }
	    function emitObjectLiteralExpression(node) {
	      pushPrivateNameGenerationScope(
	        0 /* Auto */,
	        /*newReservedMemberNames*/
	        void 0
	      );
	      forEach(node.properties, generateMemberNames);
	      const indentedFlag = getEmitFlags(node) & 131072 /* Indented */;
	      if (indentedFlag) {
	        increaseIndent();
	      }
	      const preferNewLine = node.multiLine ? 65536 /* PreferNewLine */ : 0 /* None */;
	      const allowTrailingComma = currentSourceFile && currentSourceFile.languageVersion >= 1 /* ES5 */ && !isJsonSourceFile(currentSourceFile) ? 64 /* AllowTrailingComma */ : 0 /* None */;
	      emitList(node, node.properties, 526226 /* ObjectLiteralExpressionProperties */ | allowTrailingComma | preferNewLine);
	      if (indentedFlag) {
	        decreaseIndent();
	      }
	      popPrivateNameGenerationScope();
	    }
	    function emitPropertyAccessExpression(node) {
	      emitExpression(node.expression, parenthesizer.parenthesizeLeftSideOfAccess);
	      const token = node.questionDotToken || setTextRangePosEnd(factory.createToken(25 /* DotToken */), node.expression.end, node.name.pos);
	      const linesBeforeDot = getLinesBetweenNodes(node, node.expression, token);
	      const linesAfterDot = getLinesBetweenNodes(node, token, node.name);
	      writeLinesAndIndent(
	        linesBeforeDot,
	        /*writeSpaceIfNotIndenting*/
	        false
	      );
	      const shouldEmitDotDot = token.kind !== 29 /* QuestionDotToken */ && mayNeedDotDotForPropertyAccess(node.expression) && !writer.hasTrailingComment() && !writer.hasTrailingWhitespace();
	      if (shouldEmitDotDot) {
	        writePunctuation(".");
	      }
	      if (node.questionDotToken) {
	        emit(token);
	      } else {
	        emitTokenWithComment(token.kind, node.expression.end, writePunctuation, node);
	      }
	      writeLinesAndIndent(
	        linesAfterDot,
	        /*writeSpaceIfNotIndenting*/
	        false
	      );
	      emit(node.name);
	      decreaseIndentIf(linesBeforeDot, linesAfterDot);
	    }
	    function mayNeedDotDotForPropertyAccess(expression) {
	      expression = skipPartiallyEmittedExpressions(expression);
	      if (isNumericLiteral(expression)) {
	        const text = getLiteralTextOfNode(
	          expression,
	          /*neverAsciiEscape*/
	          true,
	          /*jsxAttributeEscape*/
	          false
	        );
	        return !(expression.numericLiteralFlags & 448 /* WithSpecifier */) && !text.includes(tokenToString(25 /* DotToken */)) && !text.includes(String.fromCharCode(69 /* E */)) && !text.includes(String.fromCharCode(101 /* e */));
	      } else if (isAccessExpression(expression)) {
	        const constantValue = getConstantValue(expression);
	        return typeof constantValue === "number" && isFinite(constantValue) && constantValue >= 0 && Math.floor(constantValue) === constantValue;
	      }
	    }
	    function emitElementAccessExpression(node) {
	      emitExpression(node.expression, parenthesizer.parenthesizeLeftSideOfAccess);
	      emit(node.questionDotToken);
	      emitTokenWithComment(23 /* OpenBracketToken */, node.expression.end, writePunctuation, node);
	      emitExpression(node.argumentExpression);
	      emitTokenWithComment(24 /* CloseBracketToken */, node.argumentExpression.end, writePunctuation, node);
	    }
	    function emitCallExpression(node) {
	      const indirectCall = getInternalEmitFlags(node) & 16 /* IndirectCall */;
	      if (indirectCall) {
	        writePunctuation("(");
	        writeLiteral("0");
	        writePunctuation(",");
	        writeSpace();
	      }
	      emitExpression(node.expression, parenthesizer.parenthesizeLeftSideOfAccess);
	      if (indirectCall) {
	        writePunctuation(")");
	      }
	      emit(node.questionDotToken);
	      emitTypeArguments(node, node.typeArguments);
	      emitExpressionList(node, node.arguments, 2576 /* CallExpressionArguments */, parenthesizer.parenthesizeExpressionForDisallowedComma);
	    }
	    function emitNewExpression(node) {
	      emitTokenWithComment(105 /* NewKeyword */, node.pos, writeKeyword, node);
	      writeSpace();
	      emitExpression(node.expression, parenthesizer.parenthesizeExpressionOfNew);
	      emitTypeArguments(node, node.typeArguments);
	      emitExpressionList(node, node.arguments, 18960 /* NewExpressionArguments */, parenthesizer.parenthesizeExpressionForDisallowedComma);
	    }
	    function emitTaggedTemplateExpression(node) {
	      const indirectCall = getInternalEmitFlags(node) & 16 /* IndirectCall */;
	      if (indirectCall) {
	        writePunctuation("(");
	        writeLiteral("0");
	        writePunctuation(",");
	        writeSpace();
	      }
	      emitExpression(node.tag, parenthesizer.parenthesizeLeftSideOfAccess);
	      if (indirectCall) {
	        writePunctuation(")");
	      }
	      emitTypeArguments(node, node.typeArguments);
	      writeSpace();
	      emitExpression(node.template);
	    }
	    function emitTypeAssertionExpression(node) {
	      writePunctuation("<");
	      emit(node.type);
	      writePunctuation(">");
	      emitExpression(node.expression, parenthesizer.parenthesizeOperandOfPrefixUnary);
	    }
	    function emitParenthesizedExpression(node) {
	      const openParenPos = emitTokenWithComment(21 /* OpenParenToken */, node.pos, writePunctuation, node);
	      const indented = writeLineSeparatorsAndIndentBefore(node.expression, node);
	      emitExpression(
	        node.expression,
	        /*parenthesizerRule*/
	        void 0
	      );
	      writeLineSeparatorsAfter(node.expression, node);
	      decreaseIndentIf(indented);
	      emitTokenWithComment(22 /* CloseParenToken */, node.expression ? node.expression.end : openParenPos, writePunctuation, node);
	    }
	    function emitFunctionExpression(node) {
	      generateNameIfNeeded(node.name);
	      emitFunctionDeclarationOrExpression(node);
	    }
	    function emitArrowFunction(node) {
	      emitModifierList(node, node.modifiers);
	      emitSignatureAndBody(node, emitArrowFunctionHead);
	    }
	    function emitArrowFunctionHead(node) {
	      emitTypeParameters(node, node.typeParameters);
	      emitParametersForArrow(node, node.parameters);
	      emitTypeAnnotation(node.type);
	      writeSpace();
	      emit(node.equalsGreaterThanToken);
	    }
	    function emitDeleteExpression(node) {
	      emitTokenWithComment(91 /* DeleteKeyword */, node.pos, writeKeyword, node);
	      writeSpace();
	      emitExpression(node.expression, parenthesizer.parenthesizeOperandOfPrefixUnary);
	    }
	    function emitTypeOfExpression(node) {
	      emitTokenWithComment(114 /* TypeOfKeyword */, node.pos, writeKeyword, node);
	      writeSpace();
	      emitExpression(node.expression, parenthesizer.parenthesizeOperandOfPrefixUnary);
	    }
	    function emitVoidExpression(node) {
	      emitTokenWithComment(116 /* VoidKeyword */, node.pos, writeKeyword, node);
	      writeSpace();
	      emitExpression(node.expression, parenthesizer.parenthesizeOperandOfPrefixUnary);
	    }
	    function emitAwaitExpression(node) {
	      emitTokenWithComment(135 /* AwaitKeyword */, node.pos, writeKeyword, node);
	      writeSpace();
	      emitExpression(node.expression, parenthesizer.parenthesizeOperandOfPrefixUnary);
	    }
	    function emitPrefixUnaryExpression(node) {
	      writeTokenText(node.operator, writeOperator);
	      if (shouldEmitWhitespaceBeforeOperand(node)) {
	        writeSpace();
	      }
	      emitExpression(node.operand, parenthesizer.parenthesizeOperandOfPrefixUnary);
	    }
	    function shouldEmitWhitespaceBeforeOperand(node) {
	      const operand = node.operand;
	      return operand.kind === 224 /* PrefixUnaryExpression */ && (node.operator === 40 /* PlusToken */ && (operand.operator === 40 /* PlusToken */ || operand.operator === 46 /* PlusPlusToken */) || node.operator === 41 /* MinusToken */ && (operand.operator === 41 /* MinusToken */ || operand.operator === 47 /* MinusMinusToken */));
	    }
	    function emitPostfixUnaryExpression(node) {
	      emitExpression(node.operand, parenthesizer.parenthesizeOperandOfPostfixUnary);
	      writeTokenText(node.operator, writeOperator);
	    }
	    function createEmitBinaryExpression() {
	      return createBinaryExpressionTrampoline(
	        onEnter,
	        onLeft,
	        onOperator,
	        onRight,
	        onExit,
	        /*foldState*/
	        void 0
	      );
	      function onEnter(node, state) {
	        if (state) {
	          state.stackIndex++;
	          state.preserveSourceNewlinesStack[state.stackIndex] = preserveSourceNewlines;
	          state.containerPosStack[state.stackIndex] = containerPos;
	          state.containerEndStack[state.stackIndex] = containerEnd;
	          state.declarationListContainerEndStack[state.stackIndex] = declarationListContainerEnd;
	          const emitComments2 = state.shouldEmitCommentsStack[state.stackIndex] = shouldEmitComments(node);
	          const emitSourceMaps = state.shouldEmitSourceMapsStack[state.stackIndex] = shouldEmitSourceMaps(node);
	          onBeforeEmitNode == null ? void 0 : onBeforeEmitNode(node);
	          if (emitComments2)
	            emitCommentsBeforeNode(node);
	          if (emitSourceMaps)
	            emitSourceMapsBeforeNode(node);
	          beforeEmitNode(node);
	        } else {
	          state = {
	            stackIndex: 0,
	            preserveSourceNewlinesStack: [void 0],
	            containerPosStack: [-1],
	            containerEndStack: [-1],
	            declarationListContainerEndStack: [-1],
	            shouldEmitCommentsStack: [false],
	            shouldEmitSourceMapsStack: [false]
	          };
	        }
	        return state;
	      }
	      function onLeft(next, _workArea, parent2) {
	        return maybeEmitExpression(next, parent2, "left");
	      }
	      function onOperator(operatorToken, _state, node) {
	        const isCommaOperator = operatorToken.kind !== 28 /* CommaToken */;
	        const linesBeforeOperator = getLinesBetweenNodes(node, node.left, operatorToken);
	        const linesAfterOperator = getLinesBetweenNodes(node, operatorToken, node.right);
	        writeLinesAndIndent(linesBeforeOperator, isCommaOperator);
	        emitLeadingCommentsOfPosition(operatorToken.pos);
	        writeTokenNode(operatorToken, operatorToken.kind === 103 /* InKeyword */ ? writeKeyword : writeOperator);
	        emitTrailingCommentsOfPosition(
	          operatorToken.end,
	          /*prefixSpace*/
	          true
	        );
	        writeLinesAndIndent(
	          linesAfterOperator,
	          /*writeSpaceIfNotIndenting*/
	          true
	        );
	      }
	      function onRight(next, _workArea, parent2) {
	        return maybeEmitExpression(next, parent2, "right");
	      }
	      function onExit(node, state) {
	        const linesBeforeOperator = getLinesBetweenNodes(node, node.left, node.operatorToken);
	        const linesAfterOperator = getLinesBetweenNodes(node, node.operatorToken, node.right);
	        decreaseIndentIf(linesBeforeOperator, linesAfterOperator);
	        if (state.stackIndex > 0) {
	          const savedPreserveSourceNewlines = state.preserveSourceNewlinesStack[state.stackIndex];
	          const savedContainerPos = state.containerPosStack[state.stackIndex];
	          const savedContainerEnd = state.containerEndStack[state.stackIndex];
	          const savedDeclarationListContainerEnd = state.declarationListContainerEndStack[state.stackIndex];
	          const shouldEmitComments2 = state.shouldEmitCommentsStack[state.stackIndex];
	          const shouldEmitSourceMaps2 = state.shouldEmitSourceMapsStack[state.stackIndex];
	          afterEmitNode(savedPreserveSourceNewlines);
	          if (shouldEmitSourceMaps2)
	            emitSourceMapsAfterNode(node);
	          if (shouldEmitComments2)
	            emitCommentsAfterNode(node, savedContainerPos, savedContainerEnd, savedDeclarationListContainerEnd);
	          onAfterEmitNode == null ? void 0 : onAfterEmitNode(node);
	          state.stackIndex--;
	        }
	      }
	      function maybeEmitExpression(next, parent2, side) {
	        const parenthesizerRule = side === "left" ? parenthesizer.getParenthesizeLeftSideOfBinaryForOperator(parent2.operatorToken.kind) : parenthesizer.getParenthesizeRightSideOfBinaryForOperator(parent2.operatorToken.kind);
	        let pipelinePhase = getPipelinePhase(0 /* Notification */, 1 /* Expression */, next);
	        if (pipelinePhase === pipelineEmitWithSubstitution) {
	          Debug.assertIsDefined(lastSubstitution);
	          next = parenthesizerRule(cast(lastSubstitution, isExpression));
	          pipelinePhase = getNextPipelinePhase(1 /* Substitution */, 1 /* Expression */, next);
	          lastSubstitution = void 0;
	        }
	        if (pipelinePhase === pipelineEmitWithComments || pipelinePhase === pipelineEmitWithSourceMaps || pipelinePhase === pipelineEmitWithHint) {
	          if (isBinaryExpression(next)) {
	            return next;
	          }
	        }
	        currentParenthesizerRule = parenthesizerRule;
	        pipelinePhase(1 /* Expression */, next);
	      }
	    }
	    function emitConditionalExpression(node) {
	      const linesBeforeQuestion = getLinesBetweenNodes(node, node.condition, node.questionToken);
	      const linesAfterQuestion = getLinesBetweenNodes(node, node.questionToken, node.whenTrue);
	      const linesBeforeColon = getLinesBetweenNodes(node, node.whenTrue, node.colonToken);
	      const linesAfterColon = getLinesBetweenNodes(node, node.colonToken, node.whenFalse);
	      emitExpression(node.condition, parenthesizer.parenthesizeConditionOfConditionalExpression);
	      writeLinesAndIndent(
	        linesBeforeQuestion,
	        /*writeSpaceIfNotIndenting*/
	        true
	      );
	      emit(node.questionToken);
	      writeLinesAndIndent(
	        linesAfterQuestion,
	        /*writeSpaceIfNotIndenting*/
	        true
	      );
	      emitExpression(node.whenTrue, parenthesizer.parenthesizeBranchOfConditionalExpression);
	      decreaseIndentIf(linesBeforeQuestion, linesAfterQuestion);
	      writeLinesAndIndent(
	        linesBeforeColon,
	        /*writeSpaceIfNotIndenting*/
	        true
	      );
	      emit(node.colonToken);
	      writeLinesAndIndent(
	        linesAfterColon,
	        /*writeSpaceIfNotIndenting*/
	        true
	      );
	      emitExpression(node.whenFalse, parenthesizer.parenthesizeBranchOfConditionalExpression);
	      decreaseIndentIf(linesBeforeColon, linesAfterColon);
	    }
	    function emitTemplateExpression(node) {
	      emit(node.head);
	      emitList(node, node.templateSpans, 262144 /* TemplateExpressionSpans */);
	    }
	    function emitYieldExpression(node) {
	      emitTokenWithComment(127 /* YieldKeyword */, node.pos, writeKeyword, node);
	      emit(node.asteriskToken);
	      emitExpressionWithLeadingSpace(node.expression && parenthesizeExpressionForNoAsi(node.expression), parenthesizeExpressionForNoAsiAndDisallowedComma);
	    }
	    function emitSpreadElement(node) {
	      emitTokenWithComment(26 /* DotDotDotToken */, node.pos, writePunctuation, node);
	      emitExpression(node.expression, parenthesizer.parenthesizeExpressionForDisallowedComma);
	    }
	    function emitClassExpression(node) {
	      generateNameIfNeeded(node.name);
	      emitClassDeclarationOrExpression(node);
	    }
	    function emitExpressionWithTypeArguments(node) {
	      emitExpression(node.expression, parenthesizer.parenthesizeLeftSideOfAccess);
	      emitTypeArguments(node, node.typeArguments);
	    }
	    function emitAsExpression(node) {
	      emitExpression(
	        node.expression,
	        /*parenthesizerRule*/
	        void 0
	      );
	      if (node.type) {
	        writeSpace();
	        writeKeyword("as");
	        writeSpace();
	        emit(node.type);
	      }
	    }
	    function emitNonNullExpression(node) {
	      emitExpression(node.expression, parenthesizer.parenthesizeLeftSideOfAccess);
	      writeOperator("!");
	    }
	    function emitSatisfiesExpression(node) {
	      emitExpression(
	        node.expression,
	        /*parenthesizerRule*/
	        void 0
	      );
	      if (node.type) {
	        writeSpace();
	        writeKeyword("satisfies");
	        writeSpace();
	        emit(node.type);
	      }
	    }
	    function emitMetaProperty(node) {
	      writeToken(node.keywordToken, node.pos, writePunctuation);
	      writePunctuation(".");
	      emit(node.name);
	    }
	    function emitTemplateSpan(node) {
	      emitExpression(node.expression);
	      emit(node.literal);
	    }
	    function emitBlock(node) {
	      emitBlockStatements(
	        node,
	        /*forceSingleLine*/
	        !node.multiLine && isEmptyBlock(node)
	      );
	    }
	    function emitBlockStatements(node, forceSingleLine) {
	      emitTokenWithComment(
	        19 /* OpenBraceToken */,
	        node.pos,
	        writePunctuation,
	        /*contextNode*/
	        node
	      );
	      const format = forceSingleLine || getEmitFlags(node) & 1 /* SingleLine */ ? 768 /* SingleLineBlockStatements */ : 129 /* MultiLineBlockStatements */;
	      emitList(node, node.statements, format);
	      emitTokenWithComment(
	        20 /* CloseBraceToken */,
	        node.statements.end,
	        writePunctuation,
	        /*contextNode*/
	        node,
	        /*indentLeading*/
	        !!(format & 1 /* MultiLine */)
	      );
	    }
	    function emitVariableStatement(node) {
	      emitDecoratorsAndModifiers(
	        node,
	        node.modifiers,
	        /*allowDecorators*/
	        false
	      );
	      emit(node.declarationList);
	      writeTrailingSemicolon();
	    }
	    function emitEmptyStatement(isEmbeddedStatement) {
	      if (isEmbeddedStatement) {
	        writePunctuation(";");
	      } else {
	        writeTrailingSemicolon();
	      }
	    }
	    function emitExpressionStatement(node) {
	      emitExpression(node.expression, parenthesizer.parenthesizeExpressionOfExpressionStatement);
	      if (!currentSourceFile || !isJsonSourceFile(currentSourceFile) || nodeIsSynthesized(node.expression)) {
	        writeTrailingSemicolon();
	      }
	    }
	    function emitIfStatement(node) {
	      const openParenPos = emitTokenWithComment(101 /* IfKeyword */, node.pos, writeKeyword, node);
	      writeSpace();
	      emitTokenWithComment(21 /* OpenParenToken */, openParenPos, writePunctuation, node);
	      emitExpression(node.expression);
	      emitTokenWithComment(22 /* CloseParenToken */, node.expression.end, writePunctuation, node);
	      emitEmbeddedStatement(node, node.thenStatement);
	      if (node.elseStatement) {
	        writeLineOrSpace(node, node.thenStatement, node.elseStatement);
	        emitTokenWithComment(93 /* ElseKeyword */, node.thenStatement.end, writeKeyword, node);
	        if (node.elseStatement.kind === 245 /* IfStatement */) {
	          writeSpace();
	          emit(node.elseStatement);
	        } else {
	          emitEmbeddedStatement(node, node.elseStatement);
	        }
	      }
	    }
	    function emitWhileClause(node, startPos) {
	      const openParenPos = emitTokenWithComment(117 /* WhileKeyword */, startPos, writeKeyword, node);
	      writeSpace();
	      emitTokenWithComment(21 /* OpenParenToken */, openParenPos, writePunctuation, node);
	      emitExpression(node.expression);
	      emitTokenWithComment(22 /* CloseParenToken */, node.expression.end, writePunctuation, node);
	    }
	    function emitDoStatement(node) {
	      emitTokenWithComment(92 /* DoKeyword */, node.pos, writeKeyword, node);
	      emitEmbeddedStatement(node, node.statement);
	      if (isBlock(node.statement) && !preserveSourceNewlines) {
	        writeSpace();
	      } else {
	        writeLineOrSpace(node, node.statement, node.expression);
	      }
	      emitWhileClause(node, node.statement.end);
	      writeTrailingSemicolon();
	    }
	    function emitWhileStatement(node) {
	      emitWhileClause(node, node.pos);
	      emitEmbeddedStatement(node, node.statement);
	    }
	    function emitForStatement(node) {
	      const openParenPos = emitTokenWithComment(99 /* ForKeyword */, node.pos, writeKeyword, node);
	      writeSpace();
	      let pos = emitTokenWithComment(
	        21 /* OpenParenToken */,
	        openParenPos,
	        writePunctuation,
	        /*contextNode*/
	        node
	      );
	      emitForBinding(node.initializer);
	      pos = emitTokenWithComment(27 /* SemicolonToken */, node.initializer ? node.initializer.end : pos, writePunctuation, node);
	      emitExpressionWithLeadingSpace(node.condition);
	      pos = emitTokenWithComment(27 /* SemicolonToken */, node.condition ? node.condition.end : pos, writePunctuation, node);
	      emitExpressionWithLeadingSpace(node.incrementor);
	      emitTokenWithComment(22 /* CloseParenToken */, node.incrementor ? node.incrementor.end : pos, writePunctuation, node);
	      emitEmbeddedStatement(node, node.statement);
	    }
	    function emitForInStatement(node) {
	      const openParenPos = emitTokenWithComment(99 /* ForKeyword */, node.pos, writeKeyword, node);
	      writeSpace();
	      emitTokenWithComment(21 /* OpenParenToken */, openParenPos, writePunctuation, node);
	      emitForBinding(node.initializer);
	      writeSpace();
	      emitTokenWithComment(103 /* InKeyword */, node.initializer.end, writeKeyword, node);
	      writeSpace();
	      emitExpression(node.expression);
	      emitTokenWithComment(22 /* CloseParenToken */, node.expression.end, writePunctuation, node);
	      emitEmbeddedStatement(node, node.statement);
	    }
	    function emitForOfStatement(node) {
	      const openParenPos = emitTokenWithComment(99 /* ForKeyword */, node.pos, writeKeyword, node);
	      writeSpace();
	      emitWithTrailingSpace(node.awaitModifier);
	      emitTokenWithComment(21 /* OpenParenToken */, openParenPos, writePunctuation, node);
	      emitForBinding(node.initializer);
	      writeSpace();
	      emitTokenWithComment(165 /* OfKeyword */, node.initializer.end, writeKeyword, node);
	      writeSpace();
	      emitExpression(node.expression);
	      emitTokenWithComment(22 /* CloseParenToken */, node.expression.end, writePunctuation, node);
	      emitEmbeddedStatement(node, node.statement);
	    }
	    function emitForBinding(node) {
	      if (node !== void 0) {
	        if (node.kind === 261 /* VariableDeclarationList */) {
	          emit(node);
	        } else {
	          emitExpression(node);
	        }
	      }
	    }
	    function emitContinueStatement(node) {
	      emitTokenWithComment(88 /* ContinueKeyword */, node.pos, writeKeyword, node);
	      emitWithLeadingSpace(node.label);
	      writeTrailingSemicolon();
	    }
	    function emitBreakStatement(node) {
	      emitTokenWithComment(83 /* BreakKeyword */, node.pos, writeKeyword, node);
	      emitWithLeadingSpace(node.label);
	      writeTrailingSemicolon();
	    }
	    function emitTokenWithComment(token, pos, writer2, contextNode, indentLeading) {
	      const node = getParseTreeNode(contextNode);
	      const isSimilarNode = node && node.kind === contextNode.kind;
	      const startPos = pos;
	      if (isSimilarNode && currentSourceFile) {
	        pos = skipTrivia(currentSourceFile.text, pos);
	      }
	      if (isSimilarNode && contextNode.pos !== startPos) {
	        const needsIndent = indentLeading && currentSourceFile && !positionsAreOnSameLine(startPos, pos, currentSourceFile);
	        if (needsIndent) {
	          increaseIndent();
	        }
	        emitLeadingCommentsOfPosition(startPos);
	        if (needsIndent) {
	          decreaseIndent();
	        }
	      }
	      if (!omitBraceSourcePositions && (token === 19 /* OpenBraceToken */ || token === 20 /* CloseBraceToken */)) {
	        pos = writeToken(token, pos, writer2, contextNode);
	      } else {
	        pos = writeTokenText(token, writer2, pos);
	      }
	      if (isSimilarNode && contextNode.end !== pos) {
	        const isJsxExprContext = contextNode.kind === 294 /* JsxExpression */;
	        emitTrailingCommentsOfPosition(
	          pos,
	          /*prefixSpace*/
	          !isJsxExprContext,
	          /*forceNoNewline*/
	          isJsxExprContext
	        );
	      }
	      return pos;
	    }
	    function commentWillEmitNewLine(node) {
	      return node.kind === 2 /* SingleLineCommentTrivia */ || !!node.hasTrailingNewLine;
	    }
	    function willEmitLeadingNewLine(node) {
	      if (!currentSourceFile)
	        return false;
	      const leadingCommentRanges = getLeadingCommentRanges(currentSourceFile.text, node.pos);
	      if (leadingCommentRanges) {
	        const parseNode = getParseTreeNode(node);
	        if (parseNode && isParenthesizedExpression(parseNode.parent)) {
	          return true;
	        }
	      }
	      if (some(leadingCommentRanges, commentWillEmitNewLine))
	        return true;
	      if (some(getSyntheticLeadingComments(node), commentWillEmitNewLine))
	        return true;
	      if (isPartiallyEmittedExpression(node)) {
	        if (node.pos !== node.expression.pos) {
	          if (some(getTrailingCommentRanges(currentSourceFile.text, node.expression.pos), commentWillEmitNewLine))
	            return true;
	        }
	        return willEmitLeadingNewLine(node.expression);
	      }
	      return false;
	    }
	    function parenthesizeExpressionForNoAsi(node) {
	      if (!commentsDisabled && isPartiallyEmittedExpression(node) && willEmitLeadingNewLine(node)) {
	        const parseNode = getParseTreeNode(node);
	        if (parseNode && isParenthesizedExpression(parseNode)) {
	          const parens = factory.createParenthesizedExpression(node.expression);
	          setOriginalNode(parens, node);
	          setTextRange(parens, parseNode);
	          return parens;
	        }
	        return factory.createParenthesizedExpression(node);
	      }
	      return node;
	    }
	    function parenthesizeExpressionForNoAsiAndDisallowedComma(node) {
	      return parenthesizeExpressionForNoAsi(parenthesizer.parenthesizeExpressionForDisallowedComma(node));
	    }
	    function emitReturnStatement(node) {
	      emitTokenWithComment(
	        107 /* ReturnKeyword */,
	        node.pos,
	        writeKeyword,
	        /*contextNode*/
	        node
	      );
	      emitExpressionWithLeadingSpace(node.expression && parenthesizeExpressionForNoAsi(node.expression), parenthesizeExpressionForNoAsi);
	      writeTrailingSemicolon();
	    }
	    function emitWithStatement(node) {
	      const openParenPos = emitTokenWithComment(118 /* WithKeyword */, node.pos, writeKeyword, node);
	      writeSpace();
	      emitTokenWithComment(21 /* OpenParenToken */, openParenPos, writePunctuation, node);
	      emitExpression(node.expression);
	      emitTokenWithComment(22 /* CloseParenToken */, node.expression.end, writePunctuation, node);
	      emitEmbeddedStatement(node, node.statement);
	    }
	    function emitSwitchStatement(node) {
	      const openParenPos = emitTokenWithComment(109 /* SwitchKeyword */, node.pos, writeKeyword, node);
	      writeSpace();
	      emitTokenWithComment(21 /* OpenParenToken */, openParenPos, writePunctuation, node);
	      emitExpression(node.expression);
	      emitTokenWithComment(22 /* CloseParenToken */, node.expression.end, writePunctuation, node);
	      writeSpace();
	      emit(node.caseBlock);
	    }
	    function emitLabeledStatement(node) {
	      emit(node.label);
	      emitTokenWithComment(59 /* ColonToken */, node.label.end, writePunctuation, node);
	      writeSpace();
	      emit(node.statement);
	    }
	    function emitThrowStatement(node) {
	      emitTokenWithComment(111 /* ThrowKeyword */, node.pos, writeKeyword, node);
	      emitExpressionWithLeadingSpace(parenthesizeExpressionForNoAsi(node.expression), parenthesizeExpressionForNoAsi);
	      writeTrailingSemicolon();
	    }
	    function emitTryStatement(node) {
	      emitTokenWithComment(113 /* TryKeyword */, node.pos, writeKeyword, node);
	      writeSpace();
	      emit(node.tryBlock);
	      if (node.catchClause) {
	        writeLineOrSpace(node, node.tryBlock, node.catchClause);
	        emit(node.catchClause);
	      }
	      if (node.finallyBlock) {
	        writeLineOrSpace(node, node.catchClause || node.tryBlock, node.finallyBlock);
	        emitTokenWithComment(98 /* FinallyKeyword */, (node.catchClause || node.tryBlock).end, writeKeyword, node);
	        writeSpace();
	        emit(node.finallyBlock);
	      }
	    }
	    function emitDebuggerStatement(node) {
	      writeToken(89 /* DebuggerKeyword */, node.pos, writeKeyword);
	      writeTrailingSemicolon();
	    }
	    function emitVariableDeclaration(node) {
	      var _a, _b, _c;
	      emit(node.name);
	      emit(node.exclamationToken);
	      emitTypeAnnotation(node.type);
	      emitInitializer(node.initializer, ((_a = node.type) == null ? void 0 : _a.end) ?? ((_c = (_b = node.name.emitNode) == null ? void 0 : _b.typeNode) == null ? void 0 : _c.end) ?? node.name.end, node, parenthesizer.parenthesizeExpressionForDisallowedComma);
	    }
	    function emitVariableDeclarationList(node) {
	      if (isVarAwaitUsing(node)) {
	        writeKeyword("await");
	        writeSpace();
	        writeKeyword("using");
	      } else {
	        const head = isLet(node) ? "let" : isVarConst(node) ? "const" : isVarUsing(node) ? "using" : "var";
	        writeKeyword(head);
	      }
	      writeSpace();
	      emitList(node, node.declarations, 528 /* VariableDeclarationList */);
	    }
	    function emitFunctionDeclaration(node) {
	      emitFunctionDeclarationOrExpression(node);
	    }
	    function emitFunctionDeclarationOrExpression(node) {
	      emitDecoratorsAndModifiers(
	        node,
	        node.modifiers,
	        /*allowDecorators*/
	        false
	      );
	      writeKeyword("function");
	      emit(node.asteriskToken);
	      writeSpace();
	      emitIdentifierName(node.name);
	      emitSignatureAndBody(node, emitSignatureHead);
	    }
	    function emitSignatureAndBody(node, emitSignatureHead2) {
	      const body = node.body;
	      if (body) {
	        if (isBlock(body)) {
	          const indentedFlag = getEmitFlags(node) & 131072 /* Indented */;
	          if (indentedFlag) {
	            increaseIndent();
	          }
	          pushNameGenerationScope(node);
	          forEach(node.parameters, generateNames);
	          generateNames(node.body);
	          emitSignatureHead2(node);
	          emitBlockFunctionBody(body);
	          popNameGenerationScope(node);
	          if (indentedFlag) {
	            decreaseIndent();
	          }
	        } else {
	          emitSignatureHead2(node);
	          writeSpace();
	          emitExpression(body, parenthesizer.parenthesizeConciseBodyOfArrowFunction);
	        }
	      } else {
	        emitSignatureHead2(node);
	        writeTrailingSemicolon();
	      }
	    }
	    function emitSignatureHead(node) {
	      emitTypeParameters(node, node.typeParameters);
	      emitParameters(node, node.parameters);
	      emitTypeAnnotation(node.type);
	    }
	    function shouldEmitBlockFunctionBodyOnSingleLine(body) {
	      if (getEmitFlags(body) & 1 /* SingleLine */) {
	        return true;
	      }
	      if (body.multiLine) {
	        return false;
	      }
	      if (!nodeIsSynthesized(body) && currentSourceFile && !rangeIsOnSingleLine(body, currentSourceFile)) {
	        return false;
	      }
	      if (getLeadingLineTerminatorCount(body, firstOrUndefined(body.statements), 2 /* PreserveLines */) || getClosingLineTerminatorCount(body, lastOrUndefined(body.statements), 2 /* PreserveLines */, body.statements)) {
	        return false;
	      }
	      let previousStatement;
	      for (const statement of body.statements) {
	        if (getSeparatingLineTerminatorCount(previousStatement, statement, 2 /* PreserveLines */) > 0) {
	          return false;
	        }
	        previousStatement = statement;
	      }
	      return true;
	    }
	    function emitBlockFunctionBody(body) {
	      onBeforeEmitNode == null ? void 0 : onBeforeEmitNode(body);
	      writeSpace();
	      writePunctuation("{");
	      increaseIndent();
	      const emitBlockFunctionBody2 = shouldEmitBlockFunctionBodyOnSingleLine(body) ? emitBlockFunctionBodyOnSingleLine : emitBlockFunctionBodyWorker;
	      emitBodyWithDetachedComments(body, body.statements, emitBlockFunctionBody2);
	      decreaseIndent();
	      writeToken(20 /* CloseBraceToken */, body.statements.end, writePunctuation, body);
	      onAfterEmitNode == null ? void 0 : onAfterEmitNode(body);
	    }
	    function emitBlockFunctionBodyOnSingleLine(body) {
	      emitBlockFunctionBodyWorker(
	        body,
	        /*emitBlockFunctionBodyOnSingleLine*/
	        true
	      );
	    }
	    function emitBlockFunctionBodyWorker(body, emitBlockFunctionBodyOnSingleLine2) {
	      const statementOffset = emitPrologueDirectives(body.statements);
	      const pos = writer.getTextPos();
	      emitHelpers(body);
	      if (statementOffset === 0 && pos === writer.getTextPos() && emitBlockFunctionBodyOnSingleLine2) {
	        decreaseIndent();
	        emitList(body, body.statements, 768 /* SingleLineFunctionBodyStatements */);
	        increaseIndent();
	      } else {
	        emitList(
	          body,
	          body.statements,
	          1 /* MultiLineFunctionBodyStatements */,
	          /*parenthesizerRule*/
	          void 0,
	          statementOffset
	        );
	      }
	    }
	    function emitClassDeclaration(node) {
	      emitClassDeclarationOrExpression(node);
	    }
	    function emitClassDeclarationOrExpression(node) {
	      pushPrivateNameGenerationScope(
	        0 /* Auto */,
	        /*newReservedMemberNames*/
	        void 0
	      );
	      forEach(node.members, generateMemberNames);
	      emitDecoratorsAndModifiers(
	        node,
	        node.modifiers,
	        /*allowDecorators*/
	        true
	      );
	      emitTokenWithComment(86 /* ClassKeyword */, moveRangePastModifiers(node).pos, writeKeyword, node);
	      if (node.name) {
	        writeSpace();
	        emitIdentifierName(node.name);
	      }
	      const indentedFlag = getEmitFlags(node) & 131072 /* Indented */;
	      if (indentedFlag) {
	        increaseIndent();
	      }
	      emitTypeParameters(node, node.typeParameters);
	      emitList(node, node.heritageClauses, 0 /* ClassHeritageClauses */);
	      writeSpace();
	      writePunctuation("{");
	      emitList(node, node.members, 129 /* ClassMembers */);
	      writePunctuation("}");
	      if (indentedFlag) {
	        decreaseIndent();
	      }
	      popPrivateNameGenerationScope();
	    }
	    function emitInterfaceDeclaration(node) {
	      pushPrivateNameGenerationScope(
	        0 /* Auto */,
	        /*newReservedMemberNames*/
	        void 0
	      );
	      emitDecoratorsAndModifiers(
	        node,
	        node.modifiers,
	        /*allowDecorators*/
	        false
	      );
	      writeKeyword("interface");
	      writeSpace();
	      emit(node.name);
	      emitTypeParameters(node, node.typeParameters);
	      emitList(node, node.heritageClauses, 512 /* HeritageClauses */);
	      writeSpace();
	      writePunctuation("{");
	      emitList(node, node.members, 129 /* InterfaceMembers */);
	      writePunctuation("}");
	      popPrivateNameGenerationScope();
	    }
	    function emitTypeAliasDeclaration(node) {
	      emitDecoratorsAndModifiers(
	        node,
	        node.modifiers,
	        /*allowDecorators*/
	        false
	      );
	      writeKeyword("type");
	      writeSpace();
	      emit(node.name);
	      emitTypeParameters(node, node.typeParameters);
	      writeSpace();
	      writePunctuation("=");
	      writeSpace();
	      emit(node.type);
	      writeTrailingSemicolon();
	    }
	    function emitEnumDeclaration(node) {
	      emitDecoratorsAndModifiers(
	        node,
	        node.modifiers,
	        /*allowDecorators*/
	        false
	      );
	      writeKeyword("enum");
	      writeSpace();
	      emit(node.name);
	      writeSpace();
	      writePunctuation("{");
	      emitList(node, node.members, 145 /* EnumMembers */);
	      writePunctuation("}");
	    }
	    function emitModuleDeclaration(node) {
	      emitDecoratorsAndModifiers(
	        node,
	        node.modifiers,
	        /*allowDecorators*/
	        false
	      );
	      if (~node.flags & 2048 /* GlobalAugmentation */) {
	        writeKeyword(node.flags & 32 /* Namespace */ ? "namespace" : "module");
	        writeSpace();
	      }
	      emit(node.name);
	      let body = node.body;
	      if (!body)
	        return writeTrailingSemicolon();
	      while (body && isModuleDeclaration(body)) {
	        writePunctuation(".");
	        emit(body.name);
	        body = body.body;
	      }
	      writeSpace();
	      emit(body);
	    }
	    function emitModuleBlock(node) {
	      pushNameGenerationScope(node);
	      forEach(node.statements, generateNames);
	      emitBlockStatements(
	        node,
	        /*forceSingleLine*/
	        isEmptyBlock(node)
	      );
	      popNameGenerationScope(node);
	    }
	    function emitCaseBlock(node) {
	      emitTokenWithComment(19 /* OpenBraceToken */, node.pos, writePunctuation, node);
	      emitList(node, node.clauses, 129 /* CaseBlockClauses */);
	      emitTokenWithComment(
	        20 /* CloseBraceToken */,
	        node.clauses.end,
	        writePunctuation,
	        node,
	        /*indentLeading*/
	        true
	      );
	    }
	    function emitImportEqualsDeclaration(node) {
	      emitDecoratorsAndModifiers(
	        node,
	        node.modifiers,
	        /*allowDecorators*/
	        false
	      );
	      emitTokenWithComment(102 /* ImportKeyword */, node.modifiers ? node.modifiers.end : node.pos, writeKeyword, node);
	      writeSpace();
	      if (node.isTypeOnly) {
	        emitTokenWithComment(156 /* TypeKeyword */, node.pos, writeKeyword, node);
	        writeSpace();
	      }
	      emit(node.name);
	      writeSpace();
	      emitTokenWithComment(64 /* EqualsToken */, node.name.end, writePunctuation, node);
	      writeSpace();
	      emitModuleReference(node.moduleReference);
	      writeTrailingSemicolon();
	    }
	    function emitModuleReference(node) {
	      if (node.kind === 80 /* Identifier */) {
	        emitExpression(node);
	      } else {
	        emit(node);
	      }
	    }
	    function emitImportDeclaration(node) {
	      emitDecoratorsAndModifiers(
	        node,
	        node.modifiers,
	        /*allowDecorators*/
	        false
	      );
	      emitTokenWithComment(102 /* ImportKeyword */, node.modifiers ? node.modifiers.end : node.pos, writeKeyword, node);
	      writeSpace();
	      if (node.importClause) {
	        emit(node.importClause);
	        writeSpace();
	        emitTokenWithComment(161 /* FromKeyword */, node.importClause.end, writeKeyword, node);
	        writeSpace();
	      }
	      emitExpression(node.moduleSpecifier);
	      if (node.attributes) {
	        emitWithLeadingSpace(node.attributes);
	      }
	      writeTrailingSemicolon();
	    }
	    function emitImportClause(node) {
	      if (node.isTypeOnly) {
	        emitTokenWithComment(156 /* TypeKeyword */, node.pos, writeKeyword, node);
	        writeSpace();
	      }
	      emit(node.name);
	      if (node.name && node.namedBindings) {
	        emitTokenWithComment(28 /* CommaToken */, node.name.end, writePunctuation, node);
	        writeSpace();
	      }
	      emit(node.namedBindings);
	    }
	    function emitNamespaceImport(node) {
	      const asPos = emitTokenWithComment(42 /* AsteriskToken */, node.pos, writePunctuation, node);
	      writeSpace();
	      emitTokenWithComment(130 /* AsKeyword */, asPos, writeKeyword, node);
	      writeSpace();
	      emit(node.name);
	    }
	    function emitNamedImports(node) {
	      emitNamedImportsOrExports(node);
	    }
	    function emitImportSpecifier(node) {
	      emitImportOrExportSpecifier(node);
	    }
	    function emitExportAssignment(node) {
	      const nextPos = emitTokenWithComment(95 /* ExportKeyword */, node.pos, writeKeyword, node);
	      writeSpace();
	      if (node.isExportEquals) {
	        emitTokenWithComment(64 /* EqualsToken */, nextPos, writeOperator, node);
	      } else {
	        emitTokenWithComment(90 /* DefaultKeyword */, nextPos, writeKeyword, node);
	      }
	      writeSpace();
	      emitExpression(
	        node.expression,
	        node.isExportEquals ? parenthesizer.getParenthesizeRightSideOfBinaryForOperator(64 /* EqualsToken */) : parenthesizer.parenthesizeExpressionOfExportDefault
	      );
	      writeTrailingSemicolon();
	    }
	    function emitExportDeclaration(node) {
	      emitDecoratorsAndModifiers(
	        node,
	        node.modifiers,
	        /*allowDecorators*/
	        false
	      );
	      let nextPos = emitTokenWithComment(95 /* ExportKeyword */, node.pos, writeKeyword, node);
	      writeSpace();
	      if (node.isTypeOnly) {
	        nextPos = emitTokenWithComment(156 /* TypeKeyword */, nextPos, writeKeyword, node);
	        writeSpace();
	      }
	      if (node.exportClause) {
	        emit(node.exportClause);
	      } else {
	        nextPos = emitTokenWithComment(42 /* AsteriskToken */, nextPos, writePunctuation, node);
	      }
	      if (node.moduleSpecifier) {
	        writeSpace();
	        const fromPos = node.exportClause ? node.exportClause.end : nextPos;
	        emitTokenWithComment(161 /* FromKeyword */, fromPos, writeKeyword, node);
	        writeSpace();
	        emitExpression(node.moduleSpecifier);
	      }
	      if (node.attributes) {
	        emitWithLeadingSpace(node.attributes);
	      }
	      writeTrailingSemicolon();
	    }
	    function emitImportTypeNodeAttributes(node) {
	      writePunctuation("{");
	      writeSpace();
	      writeKeyword(node.token === 132 /* AssertKeyword */ ? "assert" : "with");
	      writePunctuation(":");
	      writeSpace();
	      const elements = node.elements;
	      emitList(node, elements, 526226 /* ImportAttributes */);
	      writeSpace();
	      writePunctuation("}");
	    }
	    function emitImportAttributes(node) {
	      emitTokenWithComment(node.token, node.pos, writeKeyword, node);
	      writeSpace();
	      const elements = node.elements;
	      emitList(node, elements, 526226 /* ImportAttributes */);
	    }
	    function emitImportAttribute(node) {
	      emit(node.name);
	      writePunctuation(":");
	      writeSpace();
	      const value = node.value;
	      if ((getEmitFlags(value) & 1024 /* NoLeadingComments */) === 0) {
	        const commentRange = getCommentRange(value);
	        emitTrailingCommentsOfPosition(commentRange.pos);
	      }
	      emit(value);
	    }
	    function emitNamespaceExportDeclaration(node) {
	      let nextPos = emitTokenWithComment(95 /* ExportKeyword */, node.pos, writeKeyword, node);
	      writeSpace();
	      nextPos = emitTokenWithComment(130 /* AsKeyword */, nextPos, writeKeyword, node);
	      writeSpace();
	      nextPos = emitTokenWithComment(145 /* NamespaceKeyword */, nextPos, writeKeyword, node);
	      writeSpace();
	      emit(node.name);
	      writeTrailingSemicolon();
	    }
	    function emitNamespaceExport(node) {
	      const asPos = emitTokenWithComment(42 /* AsteriskToken */, node.pos, writePunctuation, node);
	      writeSpace();
	      emitTokenWithComment(130 /* AsKeyword */, asPos, writeKeyword, node);
	      writeSpace();
	      emit(node.name);
	    }
	    function emitNamedExports(node) {
	      emitNamedImportsOrExports(node);
	    }
	    function emitExportSpecifier(node) {
	      emitImportOrExportSpecifier(node);
	    }
	    function emitNamedImportsOrExports(node) {
	      writePunctuation("{");
	      emitList(node, node.elements, 525136 /* NamedImportsOrExportsElements */);
	      writePunctuation("}");
	    }
	    function emitImportOrExportSpecifier(node) {
	      if (node.isTypeOnly) {
	        writeKeyword("type");
	        writeSpace();
	      }
	      if (node.propertyName) {
	        emit(node.propertyName);
	        writeSpace();
	        emitTokenWithComment(130 /* AsKeyword */, node.propertyName.end, writeKeyword, node);
	        writeSpace();
	      }
	      emit(node.name);
	    }
	    function emitExternalModuleReference(node) {
	      writeKeyword("require");
	      writePunctuation("(");
	      emitExpression(node.expression);
	      writePunctuation(")");
	    }
	    function emitJsxElement(node) {
	      emit(node.openingElement);
	      emitList(node, node.children, 262144 /* JsxElementOrFragmentChildren */);
	      emit(node.closingElement);
	    }
	    function emitJsxSelfClosingElement(node) {
	      writePunctuation("<");
	      emitJsxTagName(node.tagName);
	      emitTypeArguments(node, node.typeArguments);
	      writeSpace();
	      emit(node.attributes);
	      writePunctuation("/>");
	    }
	    function emitJsxFragment(node) {
	      emit(node.openingFragment);
	      emitList(node, node.children, 262144 /* JsxElementOrFragmentChildren */);
	      emit(node.closingFragment);
	    }
	    function emitJsxOpeningElementOrFragment(node) {
	      writePunctuation("<");
	      if (isJsxOpeningElement(node)) {
	        const indented = writeLineSeparatorsAndIndentBefore(node.tagName, node);
	        emitJsxTagName(node.tagName);
	        emitTypeArguments(node, node.typeArguments);
	        if (node.attributes.properties && node.attributes.properties.length > 0) {
	          writeSpace();
	        }
	        emit(node.attributes);
	        writeLineSeparatorsAfter(node.attributes, node);
	        decreaseIndentIf(indented);
	      }
	      writePunctuation(">");
	    }
	    function emitJsxText(node) {
	      writer.writeLiteral(node.text);
	    }
	    function emitJsxClosingElementOrFragment(node) {
	      writePunctuation("</");
	      if (isJsxClosingElement(node)) {
	        emitJsxTagName(node.tagName);
	      }
	      writePunctuation(">");
	    }
	    function emitJsxAttributes(node) {
	      emitList(node, node.properties, 262656 /* JsxElementAttributes */);
	    }
	    function emitJsxAttribute(node) {
	      emit(node.name);
	      emitNodeWithPrefix("=", writePunctuation, node.initializer, emitJsxAttributeValue);
	    }
	    function emitJsxSpreadAttribute(node) {
	      writePunctuation("{...");
	      emitExpression(node.expression);
	      writePunctuation("}");
	    }
	    function hasTrailingCommentsAtPosition(pos) {
	      let result = false;
	      forEachTrailingCommentRange((currentSourceFile == null ? void 0 : currentSourceFile.text) || "", pos + 1, () => result = true);
	      return result;
	    }
	    function hasLeadingCommentsAtPosition(pos) {
	      let result = false;
	      forEachLeadingCommentRange((currentSourceFile == null ? void 0 : currentSourceFile.text) || "", pos + 1, () => result = true);
	      return result;
	    }
	    function hasCommentsAtPosition(pos) {
	      return hasTrailingCommentsAtPosition(pos) || hasLeadingCommentsAtPosition(pos);
	    }
	    function emitJsxExpression(node) {
	      var _a;
	      if (node.expression || !commentsDisabled && !nodeIsSynthesized(node) && hasCommentsAtPosition(node.pos)) {
	        const isMultiline = currentSourceFile && !nodeIsSynthesized(node) && getLineAndCharacterOfPosition(currentSourceFile, node.pos).line !== getLineAndCharacterOfPosition(currentSourceFile, node.end).line;
	        if (isMultiline) {
	          writer.increaseIndent();
	        }
	        const end = emitTokenWithComment(19 /* OpenBraceToken */, node.pos, writePunctuation, node);
	        emit(node.dotDotDotToken);
	        emitExpression(node.expression);
	        emitTokenWithComment(20 /* CloseBraceToken */, ((_a = node.expression) == null ? void 0 : _a.end) || end, writePunctuation, node);
	        if (isMultiline) {
	          writer.decreaseIndent();
	        }
	      }
	    }
	    function emitJsxNamespacedName(node) {
	      emitIdentifierName(node.namespace);
	      writePunctuation(":");
	      emitIdentifierName(node.name);
	    }
	    function emitJsxTagName(node) {
	      if (node.kind === 80 /* Identifier */) {
	        emitExpression(node);
	      } else {
	        emit(node);
	      }
	    }
	    function emitCaseClause(node) {
	      emitTokenWithComment(84 /* CaseKeyword */, node.pos, writeKeyword, node);
	      writeSpace();
	      emitExpression(node.expression, parenthesizer.parenthesizeExpressionForDisallowedComma);
	      emitCaseOrDefaultClauseRest(node, node.statements, node.expression.end);
	    }
	    function emitDefaultClause(node) {
	      const pos = emitTokenWithComment(90 /* DefaultKeyword */, node.pos, writeKeyword, node);
	      emitCaseOrDefaultClauseRest(node, node.statements, pos);
	    }
	    function emitCaseOrDefaultClauseRest(parentNode, statements, colonPos) {
	      const emitAsSingleStatement = statements.length === 1 && // treat synthesized nodes as located on the same line for emit purposes
	      (!currentSourceFile || nodeIsSynthesized(parentNode) || nodeIsSynthesized(statements[0]) || rangeStartPositionsAreOnSameLine(parentNode, statements[0], currentSourceFile));
	      let format = 163969 /* CaseOrDefaultClauseStatements */;
	      if (emitAsSingleStatement) {
	        writeToken(59 /* ColonToken */, colonPos, writePunctuation, parentNode);
	        writeSpace();
	        format &= ~(1 /* MultiLine */ | 128 /* Indented */);
	      } else {
	        emitTokenWithComment(59 /* ColonToken */, colonPos, writePunctuation, parentNode);
	      }
	      emitList(parentNode, statements, format);
	    }
	    function emitHeritageClause(node) {
	      writeSpace();
	      writeTokenText(node.token, writeKeyword);
	      writeSpace();
	      emitList(node, node.types, 528 /* HeritageClauseTypes */);
	    }
	    function emitCatchClause(node) {
	      const openParenPos = emitTokenWithComment(85 /* CatchKeyword */, node.pos, writeKeyword, node);
	      writeSpace();
	      if (node.variableDeclaration) {
	        emitTokenWithComment(21 /* OpenParenToken */, openParenPos, writePunctuation, node);
	        emit(node.variableDeclaration);
	        emitTokenWithComment(22 /* CloseParenToken */, node.variableDeclaration.end, writePunctuation, node);
	        writeSpace();
	      }
	      emit(node.block);
	    }
	    function emitPropertyAssignment(node) {
	      emit(node.name);
	      writePunctuation(":");
	      writeSpace();
	      const initializer = node.initializer;
	      if ((getEmitFlags(initializer) & 1024 /* NoLeadingComments */) === 0) {
	        const commentRange = getCommentRange(initializer);
	        emitTrailingCommentsOfPosition(commentRange.pos);
	      }
	      emitExpression(initializer, parenthesizer.parenthesizeExpressionForDisallowedComma);
	    }
	    function emitShorthandPropertyAssignment(node) {
	      emit(node.name);
	      if (node.objectAssignmentInitializer) {
	        writeSpace();
	        writePunctuation("=");
	        writeSpace();
	        emitExpression(node.objectAssignmentInitializer, parenthesizer.parenthesizeExpressionForDisallowedComma);
	      }
	    }
	    function emitSpreadAssignment(node) {
	      if (node.expression) {
	        emitTokenWithComment(26 /* DotDotDotToken */, node.pos, writePunctuation, node);
	        emitExpression(node.expression, parenthesizer.parenthesizeExpressionForDisallowedComma);
	      }
	    }
	    function emitEnumMember(node) {
	      emit(node.name);
	      emitInitializer(node.initializer, node.name.end, node, parenthesizer.parenthesizeExpressionForDisallowedComma);
	    }
	    function emitJSDoc(node) {
	      write("/**");
	      if (node.comment) {
	        const text = getTextOfJSDocComment(node.comment);
	        if (text) {
	          const lines = text.split(/\r\n?|\n/g);
	          for (const line of lines) {
	            writeLine();
	            writeSpace();
	            writePunctuation("*");
	            writeSpace();
	            write(line);
	          }
	        }
	      }
	      if (node.tags) {
	        if (node.tags.length === 1 && node.tags[0].kind === 351 /* JSDocTypeTag */ && !node.comment) {
	          writeSpace();
	          emit(node.tags[0]);
	        } else {
	          emitList(node, node.tags, 33 /* JSDocComment */);
	        }
	      }
	      writeSpace();
	      write("*/");
	    }
	    function emitJSDocSimpleTypedTag(tag) {
	      emitJSDocTagName(tag.tagName);
	      emitJSDocTypeExpression(tag.typeExpression);
	      emitJSDocComment(tag.comment);
	    }
	    function emitJSDocSeeTag(tag) {
	      emitJSDocTagName(tag.tagName);
	      emit(tag.name);
	      emitJSDocComment(tag.comment);
	    }
	    function emitJSDocNameReference(node) {
	      writeSpace();
	      writePunctuation("{");
	      emit(node.name);
	      writePunctuation("}");
	    }
	    function emitJSDocHeritageTag(tag) {
	      emitJSDocTagName(tag.tagName);
	      writeSpace();
	      writePunctuation("{");
	      emit(tag.class);
	      writePunctuation("}");
	      emitJSDocComment(tag.comment);
	    }
	    function emitJSDocTemplateTag(tag) {
	      emitJSDocTagName(tag.tagName);
	      emitJSDocTypeExpression(tag.constraint);
	      writeSpace();
	      emitList(tag, tag.typeParameters, 528 /* CommaListElements */);
	      emitJSDocComment(tag.comment);
	    }
	    function emitJSDocTypedefTag(tag) {
	      emitJSDocTagName(tag.tagName);
	      if (tag.typeExpression) {
	        if (tag.typeExpression.kind === 316 /* JSDocTypeExpression */) {
	          emitJSDocTypeExpression(tag.typeExpression);
	        } else {
	          writeSpace();
	          writePunctuation("{");
	          write("Object");
	          if (tag.typeExpression.isArrayType) {
	            writePunctuation("[");
	            writePunctuation("]");
	          }
	          writePunctuation("}");
	        }
	      }
	      if (tag.fullName) {
	        writeSpace();
	        emit(tag.fullName);
	      }
	      emitJSDocComment(tag.comment);
	      if (tag.typeExpression && tag.typeExpression.kind === 329 /* JSDocTypeLiteral */) {
	        emitJSDocTypeLiteral(tag.typeExpression);
	      }
	    }
	    function emitJSDocCallbackTag(tag) {
	      emitJSDocTagName(tag.tagName);
	      if (tag.name) {
	        writeSpace();
	        emit(tag.name);
	      }
	      emitJSDocComment(tag.comment);
	      emitJSDocSignature(tag.typeExpression);
	    }
	    function emitJSDocOverloadTag(tag) {
	      emitJSDocComment(tag.comment);
	      emitJSDocSignature(tag.typeExpression);
	    }
	    function emitJSDocSimpleTag(tag) {
	      emitJSDocTagName(tag.tagName);
	      emitJSDocComment(tag.comment);
	    }
	    function emitJSDocTypeLiteral(lit) {
	      emitList(lit, factory.createNodeArray(lit.jsDocPropertyTags), 33 /* JSDocComment */);
	    }
	    function emitJSDocSignature(sig) {
	      if (sig.typeParameters) {
	        emitList(sig, factory.createNodeArray(sig.typeParameters), 33 /* JSDocComment */);
	      }
	      if (sig.parameters) {
	        emitList(sig, factory.createNodeArray(sig.parameters), 33 /* JSDocComment */);
	      }
	      if (sig.type) {
	        writeLine();
	        writeSpace();
	        writePunctuation("*");
	        writeSpace();
	        emit(sig.type);
	      }
	    }
	    function emitJSDocPropertyLikeTag(param) {
	      emitJSDocTagName(param.tagName);
	      emitJSDocTypeExpression(param.typeExpression);
	      writeSpace();
	      if (param.isBracketed) {
	        writePunctuation("[");
	      }
	      emit(param.name);
	      if (param.isBracketed) {
	        writePunctuation("]");
	      }
	      emitJSDocComment(param.comment);
	    }
	    function emitJSDocTagName(tagName) {
	      writePunctuation("@");
	      emit(tagName);
	    }
	    function emitJSDocComment(comment) {
	      const text = getTextOfJSDocComment(comment);
	      if (text) {
	        writeSpace();
	        write(text);
	      }
	    }
	    function emitJSDocTypeExpression(typeExpression) {
	      if (typeExpression) {
	        writeSpace();
	        writePunctuation("{");
	        emit(typeExpression.type);
	        writePunctuation("}");
	      }
	    }
	    function emitSourceFile(node) {
	      writeLine();
	      const statements = node.statements;
	      const shouldEmitDetachedComment = statements.length === 0 || !isPrologueDirective(statements[0]) || nodeIsSynthesized(statements[0]);
	      if (shouldEmitDetachedComment) {
	        emitBodyWithDetachedComments(node, statements, emitSourceFileWorker);
	        return;
	      }
	      emitSourceFileWorker(node);
	    }
	    function emitSyntheticTripleSlashReferencesIfNeeded(node) {
	      emitTripleSlashDirectives(!!node.hasNoDefaultLib, node.syntheticFileReferences || [], node.syntheticTypeReferences || [], node.syntheticLibReferences || []);
	      for (const prepend of node.prepends) {
	        if (isUnparsedSource(prepend) && prepend.syntheticReferences) {
	          for (const ref of prepend.syntheticReferences) {
	            emit(ref);
	            writeLine();
	          }
	        }
	      }
	    }
	    function emitTripleSlashDirectivesIfNeeded(node) {
	      if (node.isDeclarationFile)
	        emitTripleSlashDirectives(node.hasNoDefaultLib, node.referencedFiles, node.typeReferenceDirectives, node.libReferenceDirectives);
	    }
	    function emitTripleSlashDirectives(hasNoDefaultLib, files, types, libs2) {
	      if (hasNoDefaultLib) {
	        const pos = writer.getTextPos();
	        writeComment(`/// <reference no-default-lib="true"/>`);
	        if (bundleFileInfo)
	          bundleFileInfo.sections.push({ pos, end: writer.getTextPos(), kind: "no-default-lib" /* NoDefaultLib */ });
	        writeLine();
	      }
	      if (currentSourceFile && currentSourceFile.moduleName) {
	        writeComment(`/// <amd-module name="${currentSourceFile.moduleName}" />`);
	        writeLine();
	      }
	      if (currentSourceFile && currentSourceFile.amdDependencies) {
	        for (const dep of currentSourceFile.amdDependencies) {
	          if (dep.name) {
	            writeComment(`/// <amd-dependency name="${dep.name}" path="${dep.path}" />`);
	          } else {
	            writeComment(`/// <amd-dependency path="${dep.path}" />`);
	          }
	          writeLine();
	        }
	      }
	      for (const directive of files) {
	        const pos = writer.getTextPos();
	        writeComment(`/// <reference path="${directive.fileName}" />`);
	        if (bundleFileInfo)
	          bundleFileInfo.sections.push({ pos, end: writer.getTextPos(), kind: "reference" /* Reference */, data: directive.fileName });
	        writeLine();
	      }
	      for (const directive of types) {
	        const pos = writer.getTextPos();
	        const resolutionMode = directive.resolutionMode && directive.resolutionMode !== (currentSourceFile == null ? void 0 : currentSourceFile.impliedNodeFormat) ? `resolution-mode="${directive.resolutionMode === 99 /* ESNext */ ? "import" : "require"}"` : "";
	        writeComment(`/// <reference types="${directive.fileName}" ${resolutionMode}/>`);
	        if (bundleFileInfo)
	          bundleFileInfo.sections.push({ pos, end: writer.getTextPos(), kind: !directive.resolutionMode ? "type" /* Type */ : directive.resolutionMode === 99 /* ESNext */ ? "type-import" /* TypeResolutionModeImport */ : "type-require" /* TypeResolutionModeRequire */, data: directive.fileName });
	        writeLine();
	      }
	      for (const directive of libs2) {
	        const pos = writer.getTextPos();
	        writeComment(`/// <reference lib="${directive.fileName}" />`);
	        if (bundleFileInfo)
	          bundleFileInfo.sections.push({ pos, end: writer.getTextPos(), kind: "lib" /* Lib */, data: directive.fileName });
	        writeLine();
	      }
	    }
	    function emitSourceFileWorker(node) {
	      const statements = node.statements;
	      pushNameGenerationScope(node);
	      forEach(node.statements, generateNames);
	      emitHelpers(node);
	      const index = findIndex(statements, (statement) => !isPrologueDirective(statement));
	      emitTripleSlashDirectivesIfNeeded(node);
	      emitList(
	        node,
	        statements,
	        1 /* MultiLine */,
	        /*parenthesizerRule*/
	        void 0,
	        index === -1 ? statements.length : index
	      );
	      popNameGenerationScope(node);
	    }
	    function emitPartiallyEmittedExpression(node) {
	      const emitFlags = getEmitFlags(node);
	      if (!(emitFlags & 1024 /* NoLeadingComments */) && node.pos !== node.expression.pos) {
	        emitTrailingCommentsOfPosition(node.expression.pos);
	      }
	      emitExpression(node.expression);
	      if (!(emitFlags & 2048 /* NoTrailingComments */) && node.end !== node.expression.end) {
	        emitLeadingCommentsOfPosition(node.expression.end);
	      }
	    }
	    function emitCommaList(node) {
	      emitExpressionList(
	        node,
	        node.elements,
	        528 /* CommaListElements */,
	        /*parenthesizerRule*/
	        void 0
	      );
	    }
	    function emitPrologueDirectives(statements, sourceFile, seenPrologueDirectives, recordBundleFileSection) {
	      let needsToSetSourceFile = !!sourceFile;
	      for (let i = 0; i < statements.length; i++) {
	        const statement = statements[i];
	        if (isPrologueDirective(statement)) {
	          const shouldEmitPrologueDirective = seenPrologueDirectives ? !seenPrologueDirectives.has(statement.expression.text) : true;
	          if (shouldEmitPrologueDirective) {
	            if (needsToSetSourceFile) {
	              needsToSetSourceFile = false;
	              setSourceFile(sourceFile);
	            }
	            writeLine();
	            const pos = writer.getTextPos();
	            emit(statement);
	            if (recordBundleFileSection && bundleFileInfo)
	              bundleFileInfo.sections.push({ pos, end: writer.getTextPos(), kind: "prologue" /* Prologue */, data: statement.expression.text });
	            if (seenPrologueDirectives) {
	              seenPrologueDirectives.add(statement.expression.text);
	            }
	          }
	        } else {
	          return i;
	        }
	      }
	      return statements.length;
	    }
	    function emitUnparsedPrologues(prologues, seenPrologueDirectives) {
	      for (const prologue of prologues) {
	        if (!seenPrologueDirectives.has(prologue.data)) {
	          writeLine();
	          const pos = writer.getTextPos();
	          emit(prologue);
	          if (bundleFileInfo)
	            bundleFileInfo.sections.push({ pos, end: writer.getTextPos(), kind: "prologue" /* Prologue */, data: prologue.data });
	          if (seenPrologueDirectives) {
	            seenPrologueDirectives.add(prologue.data);
	          }
	        }
	      }
	    }
	    function emitPrologueDirectivesIfNeeded(sourceFileOrBundle) {
	      if (isSourceFile(sourceFileOrBundle)) {
	        emitPrologueDirectives(sourceFileOrBundle.statements, sourceFileOrBundle);
	      } else {
	        const seenPrologueDirectives = /* @__PURE__ */ new Set();
	        for (const prepend of sourceFileOrBundle.prepends) {
	          emitUnparsedPrologues(prepend.prologues, seenPrologueDirectives);
	        }
	        for (const sourceFile of sourceFileOrBundle.sourceFiles) {
	          emitPrologueDirectives(
	            sourceFile.statements,
	            sourceFile,
	            seenPrologueDirectives,
	            /*recordBundleFileSection*/
	            true
	          );
	        }
	        setSourceFile(void 0);
	      }
	    }
	    function getPrologueDirectivesFromBundledSourceFiles(bundle) {
	      const seenPrologueDirectives = /* @__PURE__ */ new Set();
	      let prologues;
	      for (let index = 0; index < bundle.sourceFiles.length; index++) {
	        const sourceFile = bundle.sourceFiles[index];
	        let directives;
	        let end = 0;
	        for (const statement of sourceFile.statements) {
	          if (!isPrologueDirective(statement))
	            break;
	          if (seenPrologueDirectives.has(statement.expression.text))
	            continue;
	          seenPrologueDirectives.add(statement.expression.text);
	          (directives || (directives = [])).push({
	            pos: statement.pos,
	            end: statement.end,
	            expression: {
	              pos: statement.expression.pos,
	              end: statement.expression.end,
	              text: statement.expression.text
	            }
	          });
	          end = end < statement.end ? statement.end : end;
	        }
	        if (directives)
	          (prologues || (prologues = [])).push({ file: index, text: sourceFile.text.substring(0, end), directives });
	      }
	      return prologues;
	    }
	    function emitShebangIfNeeded(sourceFileOrBundle) {
	      if (isSourceFile(sourceFileOrBundle) || isUnparsedSource(sourceFileOrBundle)) {
	        const shebang = getShebang(sourceFileOrBundle.text);
	        if (shebang) {
	          writeComment(shebang);
	          writeLine();
	          return true;
	        }
	      } else {
	        for (const prepend of sourceFileOrBundle.prepends) {
	          Debug.assertNode(prepend, isUnparsedSource);
	          if (emitShebangIfNeeded(prepend)) {
	            return true;
	          }
	        }
	        for (const sourceFile of sourceFileOrBundle.sourceFiles) {
	          if (emitShebangIfNeeded(sourceFile)) {
	            return true;
	          }
	        }
	      }
	    }
	    function emitNodeWithWriter(node, writer2) {
	      if (!node)
	        return;
	      const savedWrite = write;
	      write = writer2;
	      emit(node);
	      write = savedWrite;
	    }
	    function emitDecoratorsAndModifiers(node, modifiers, allowDecorators) {
	      if (modifiers == null ? void 0 : modifiers.length) {
	        if (every(modifiers, isModifier)) {
	          return emitModifierList(node, modifiers);
	        }
	        if (every(modifiers, isDecorator)) {
	          if (allowDecorators) {
	            return emitDecoratorList(node, modifiers);
	          }
	          return node.pos;
	        }
	        onBeforeEmitNodeArray == null ? void 0 : onBeforeEmitNodeArray(modifiers);
	        let lastMode;
	        let mode;
	        let start = 0;
	        let pos = 0;
	        let lastModifier;
	        while (start < modifiers.length) {
	          while (pos < modifiers.length) {
	            lastModifier = modifiers[pos];
	            mode = isDecorator(lastModifier) ? "decorators" : "modifiers";
	            if (lastMode === void 0) {
	              lastMode = mode;
	            } else if (mode !== lastMode) {
	              break;
	            }
	            pos++;
	          }
	          const textRange = { pos: -1, end: -1 };
	          if (start === 0)
	            textRange.pos = modifiers.pos;
	          if (pos === modifiers.length - 1)
	            textRange.end = modifiers.end;
	          if (lastMode === "modifiers" || allowDecorators) {
	            emitNodeListItems(
	              emit,
	              node,
	              modifiers,
	              lastMode === "modifiers" ? 2359808 /* Modifiers */ : 2146305 /* Decorators */,
	              /*parenthesizerRule*/
	              void 0,
	              start,
	              pos - start,
	              /*hasTrailingComma*/
	              false,
	              textRange
	            );
	          }
	          start = pos;
	          lastMode = mode;
	          pos++;
	        }
	        onAfterEmitNodeArray == null ? void 0 : onAfterEmitNodeArray(modifiers);
	        if (lastModifier && !positionIsSynthesized(lastModifier.end)) {
	          return lastModifier.end;
	        }
	      }
	      return node.pos;
	    }
	    function emitModifierList(node, modifiers) {
	      emitList(node, modifiers, 2359808 /* Modifiers */);
	      const lastModifier = lastOrUndefined(modifiers);
	      return lastModifier && !positionIsSynthesized(lastModifier.end) ? lastModifier.end : node.pos;
	    }
	    function emitTypeAnnotation(node) {
	      if (node) {
	        writePunctuation(":");
	        writeSpace();
	        emit(node);
	      }
	    }
	    function emitInitializer(node, equalCommentStartPos, container, parenthesizerRule) {
	      if (node) {
	        writeSpace();
	        emitTokenWithComment(64 /* EqualsToken */, equalCommentStartPos, writeOperator, container);
	        writeSpace();
	        emitExpression(node, parenthesizerRule);
	      }
	    }
	    function emitNodeWithPrefix(prefix, prefixWriter, node, emit2) {
	      if (node) {
	        prefixWriter(prefix);
	        emit2(node);
	      }
	    }
	    function emitWithLeadingSpace(node) {
	      if (node) {
	        writeSpace();
	        emit(node);
	      }
	    }
	    function emitExpressionWithLeadingSpace(node, parenthesizerRule) {
	      if (node) {
	        writeSpace();
	        emitExpression(node, parenthesizerRule);
	      }
	    }
	    function emitWithTrailingSpace(node) {
	      if (node) {
	        emit(node);
	        writeSpace();
	      }
	    }
	    function emitEmbeddedStatement(parent2, node) {
	      if (isBlock(node) || getEmitFlags(parent2) & 1 /* SingleLine */ || preserveSourceNewlines && !getLeadingLineTerminatorCount(parent2, node, 0 /* None */)) {
	        writeSpace();
	        emit(node);
	      } else {
	        writeLine();
	        increaseIndent();
	        if (isEmptyStatement(node)) {
	          pipelineEmit(5 /* EmbeddedStatement */, node);
	        } else {
	          emit(node);
	        }
	        decreaseIndent();
	      }
	    }
	    function emitDecoratorList(parentNode, decorators) {
	      emitList(parentNode, decorators, 2146305 /* Decorators */);
	      const lastDecorator = lastOrUndefined(decorators);
	      return lastDecorator && !positionIsSynthesized(lastDecorator.end) ? lastDecorator.end : parentNode.pos;
	    }
	    function emitTypeArguments(parentNode, typeArguments) {
	      emitList(parentNode, typeArguments, 53776 /* TypeArguments */, typeArgumentParenthesizerRuleSelector);
	    }
	    function emitTypeParameters(parentNode, typeParameters) {
	      if (isFunctionLike(parentNode) && parentNode.typeArguments) {
	        return emitTypeArguments(parentNode, parentNode.typeArguments);
	      }
	      emitList(parentNode, typeParameters, 53776 /* TypeParameters */);
	    }
	    function emitParameters(parentNode, parameters) {
	      emitList(parentNode, parameters, 2576 /* Parameters */);
	    }
	    function canEmitSimpleArrowHead(parentNode, parameters) {
	      const parameter = singleOrUndefined(parameters);
	      return parameter && parameter.pos === parentNode.pos && isArrowFunction(parentNode) && !parentNode.type && !some(parentNode.modifiers) && !some(parentNode.typeParameters) && !some(parameter.modifiers) && !parameter.dotDotDotToken && !parameter.questionToken && !parameter.type && !parameter.initializer && isIdentifier(parameter.name);
	    }
	    function emitParametersForArrow(parentNode, parameters) {
	      if (canEmitSimpleArrowHead(parentNode, parameters)) {
	        emitList(parentNode, parameters, 2576 /* Parameters */ & ~2048 /* Parenthesis */);
	      } else {
	        emitParameters(parentNode, parameters);
	      }
	    }
	    function emitParametersForIndexSignature(parentNode, parameters) {
	      emitList(parentNode, parameters, 8848 /* IndexSignatureParameters */);
	    }
	    function writeDelimiter(format) {
	      switch (format & 60 /* DelimitersMask */) {
	        case 0 /* None */:
	          break;
	        case 16 /* CommaDelimited */:
	          writePunctuation(",");
	          break;
	        case 4 /* BarDelimited */:
	          writeSpace();
	          writePunctuation("|");
	          break;
	        case 32 /* AsteriskDelimited */:
	          writeSpace();
	          writePunctuation("*");
	          writeSpace();
	          break;
	        case 8 /* AmpersandDelimited */:
	          writeSpace();
	          writePunctuation("&");
	          break;
	      }
	    }
	    function emitList(parentNode, children, format, parenthesizerRule, start, count) {
	      emitNodeList(
	        emit,
	        parentNode,
	        children,
	        format | (parentNode && getEmitFlags(parentNode) & 2 /* MultiLine */ ? 65536 /* PreferNewLine */ : 0),
	        parenthesizerRule,
	        start,
	        count
	      );
	    }
	    function emitExpressionList(parentNode, children, format, parenthesizerRule, start, count) {
	      emitNodeList(emitExpression, parentNode, children, format, parenthesizerRule, start, count);
	    }
	    function emitNodeList(emit2, parentNode, children, format, parenthesizerRule, start = 0, count = children ? children.length - start : 0) {
	      const isUndefined = children === void 0;
	      if (isUndefined && format & 16384 /* OptionalIfUndefined */) {
	        return;
	      }
	      const isEmpty = children === void 0 || start >= children.length || count === 0;
	      if (isEmpty && format & 32768 /* OptionalIfEmpty */) {
	        onBeforeEmitNodeArray == null ? void 0 : onBeforeEmitNodeArray(children);
	        onAfterEmitNodeArray == null ? void 0 : onAfterEmitNodeArray(children);
	        return;
	      }
	      if (format & 15360 /* BracketsMask */) {
	        writePunctuation(getOpeningBracket(format));
	        if (isEmpty && children) {
	          emitTrailingCommentsOfPosition(
	            children.pos,
	            /*prefixSpace*/
	            true
	          );
	        }
	      }
	      onBeforeEmitNodeArray == null ? void 0 : onBeforeEmitNodeArray(children);
	      if (isEmpty) {
	        if (format & 1 /* MultiLine */ && !(preserveSourceNewlines && (!parentNode || currentSourceFile && rangeIsOnSingleLine(parentNode, currentSourceFile)))) {
	          writeLine();
	        } else if (format & 256 /* SpaceBetweenBraces */ && !(format & 524288 /* NoSpaceIfEmpty */)) {
	          writeSpace();
	        }
	      } else {
	        emitNodeListItems(emit2, parentNode, children, format, parenthesizerRule, start, count, children.hasTrailingComma, children);
	      }
	      onAfterEmitNodeArray == null ? void 0 : onAfterEmitNodeArray(children);
	      if (format & 15360 /* BracketsMask */) {
	        if (isEmpty && children) {
	          emitLeadingCommentsOfPosition(children.end);
	        }
	        writePunctuation(getClosingBracket(format));
	      }
	    }
	    function emitNodeListItems(emit2, parentNode, children, format, parenthesizerRule, start, count, hasTrailingComma, childrenTextRange) {
	      const mayEmitInterveningComments = (format & 262144 /* NoInterveningComments */) === 0;
	      let shouldEmitInterveningComments = mayEmitInterveningComments;
	      const leadingLineTerminatorCount = getLeadingLineTerminatorCount(parentNode, children[start], format);
	      if (leadingLineTerminatorCount) {
	        writeLine(leadingLineTerminatorCount);
	        shouldEmitInterveningComments = false;
	      } else if (format & 256 /* SpaceBetweenBraces */) {
	        writeSpace();
	      }
	      if (format & 128 /* Indented */) {
	        increaseIndent();
	      }
	      const emitListItem = getEmitListItem(emit2, parenthesizerRule);
	      let previousSibling;
	      let previousSourceFileTextKind;
	      let shouldDecreaseIndentAfterEmit = false;
	      for (let i = 0; i < count; i++) {
	        const child = children[start + i];
	        if (format & 32 /* AsteriskDelimited */) {
	          writeLine();
	          writeDelimiter(format);
	        } else if (previousSibling) {
	          if (format & 60 /* DelimitersMask */ && previousSibling.end !== (parentNode ? parentNode.end : -1)) {
	            const previousSiblingEmitFlags = getEmitFlags(previousSibling);
	            if (!(previousSiblingEmitFlags & 2048 /* NoTrailingComments */)) {
	              emitLeadingCommentsOfPosition(previousSibling.end);
	            }
	          }
	          writeDelimiter(format);
	          recordBundleFileInternalSectionEnd(previousSourceFileTextKind);
	          const separatingLineTerminatorCount = getSeparatingLineTerminatorCount(previousSibling, child, format);
	          if (separatingLineTerminatorCount > 0) {
	            if ((format & (3 /* LinesMask */ | 128 /* Indented */)) === 0 /* SingleLine */) {
	              increaseIndent();
	              shouldDecreaseIndentAfterEmit = true;
	            }
	            if (shouldEmitInterveningComments && format & 60 /* DelimitersMask */ && !positionIsSynthesized(child.pos)) {
	              const commentRange = getCommentRange(child);
	              emitTrailingCommentsOfPosition(
	                commentRange.pos,
	                /*prefixSpace*/
	                !!(format & 512 /* SpaceBetweenSiblings */),
	                /*forceNoNewline*/
	                true
	              );
	            }
	            writeLine(separatingLineTerminatorCount);
	            shouldEmitInterveningComments = false;
	          } else if (previousSibling && format & 512 /* SpaceBetweenSiblings */) {
	            writeSpace();
	          }
	        }
	        previousSourceFileTextKind = recordBundleFileInternalSectionStart(child);
	        if (shouldEmitInterveningComments) {
	          const commentRange = getCommentRange(child);
	          emitTrailingCommentsOfPosition(commentRange.pos);
	        } else {
	          shouldEmitInterveningComments = mayEmitInterveningComments;
	        }
	        nextListElementPos = child.pos;
	        emitListItem(child, emit2, parenthesizerRule, i);
	        if (shouldDecreaseIndentAfterEmit) {
	          decreaseIndent();
	          shouldDecreaseIndentAfterEmit = false;
	        }
	        previousSibling = child;
	      }
	      const emitFlags = previousSibling ? getEmitFlags(previousSibling) : 0;
	      const skipTrailingComments = commentsDisabled || !!(emitFlags & 2048 /* NoTrailingComments */);
	      const emitTrailingComma = hasTrailingComma && format & 64 /* AllowTrailingComma */ && format & 16 /* CommaDelimited */;
	      if (emitTrailingComma) {
	        if (previousSibling && !skipTrailingComments) {
	          emitTokenWithComment(28 /* CommaToken */, previousSibling.end, writePunctuation, previousSibling);
	        } else {
	          writePunctuation(",");
	        }
	      }
	      if (previousSibling && (parentNode ? parentNode.end : -1) !== previousSibling.end && format & 60 /* DelimitersMask */ && !skipTrailingComments) {
	        emitLeadingCommentsOfPosition(emitTrailingComma && (childrenTextRange == null ? void 0 : childrenTextRange.end) ? childrenTextRange.end : previousSibling.end);
	      }
	      if (format & 128 /* Indented */) {
	        decreaseIndent();
	      }
	      recordBundleFileInternalSectionEnd(previousSourceFileTextKind);
	      const closingLineTerminatorCount = getClosingLineTerminatorCount(parentNode, children[start + count - 1], format, childrenTextRange);
	      if (closingLineTerminatorCount) {
	        writeLine(closingLineTerminatorCount);
	      } else if (format & (2097152 /* SpaceAfterList */ | 256 /* SpaceBetweenBraces */)) {
	        writeSpace();
	      }
	    }
	    function writeLiteral(s) {
	      writer.writeLiteral(s);
	    }
	    function writeStringLiteral(s) {
	      writer.writeStringLiteral(s);
	    }
	    function writeBase(s) {
	      writer.write(s);
	    }
	    function writeSymbol(s, sym) {
	      writer.writeSymbol(s, sym);
	    }
	    function writePunctuation(s) {
	      writer.writePunctuation(s);
	    }
	    function writeTrailingSemicolon() {
	      writer.writeTrailingSemicolon(";");
	    }
	    function writeKeyword(s) {
	      writer.writeKeyword(s);
	    }
	    function writeOperator(s) {
	      writer.writeOperator(s);
	    }
	    function writeParameter(s) {
	      writer.writeParameter(s);
	    }
	    function writeComment(s) {
	      writer.writeComment(s);
	    }
	    function writeSpace() {
	      writer.writeSpace(" ");
	    }
	    function writeProperty(s) {
	      writer.writeProperty(s);
	    }
	    function nonEscapingWrite(s) {
	      if (writer.nonEscapingWrite) {
	        writer.nonEscapingWrite(s);
	      } else {
	        writer.write(s);
	      }
	    }
	    function writeLine(count = 1) {
	      for (let i = 0; i < count; i++) {
	        writer.writeLine(i > 0);
	      }
	    }
	    function increaseIndent() {
	      writer.increaseIndent();
	    }
	    function decreaseIndent() {
	      writer.decreaseIndent();
	    }
	    function writeToken(token, pos, writer2, contextNode) {
	      return !sourceMapsDisabled ? emitTokenWithSourceMap(contextNode, token, writer2, pos, writeTokenText) : writeTokenText(token, writer2, pos);
	    }
	    function writeTokenNode(node, writer2) {
	      if (onBeforeEmitToken) {
	        onBeforeEmitToken(node);
	      }
	      writer2(tokenToString(node.kind));
	      if (onAfterEmitToken) {
	        onAfterEmitToken(node);
	      }
	    }
	    function writeTokenText(token, writer2, pos) {
	      const tokenString = tokenToString(token);
	      writer2(tokenString);
	      return pos < 0 ? pos : pos + tokenString.length;
	    }
	    function writeLineOrSpace(parentNode, prevChildNode, nextChildNode) {
	      if (getEmitFlags(parentNode) & 1 /* SingleLine */) {
	        writeSpace();
	      } else if (preserveSourceNewlines) {
	        const lines = getLinesBetweenNodes(parentNode, prevChildNode, nextChildNode);
	        if (lines) {
	          writeLine(lines);
	        } else {
	          writeSpace();
	        }
	      } else {
	        writeLine();
	      }
	    }
	    function writeLines(text) {
	      const lines = text.split(/\r\n?|\n/g);
	      const indentation = guessIndentation(lines);
	      for (const lineText of lines) {
	        const line = indentation ? lineText.slice(indentation) : lineText;
	        if (line.length) {
	          writeLine();
	          write(line);
	        }
	      }
	    }
	    function writeLinesAndIndent(lineCount, writeSpaceIfNotIndenting) {
	      if (lineCount) {
	        increaseIndent();
	        writeLine(lineCount);
	      } else if (writeSpaceIfNotIndenting) {
	        writeSpace();
	      }
	    }
	    function decreaseIndentIf(value1, value2) {
	      if (value1) {
	        decreaseIndent();
	      }
	      if (value2) {
	        decreaseIndent();
	      }
	    }
	    function getLeadingLineTerminatorCount(parentNode, firstChild, format) {
	      if (format & 2 /* PreserveLines */ || preserveSourceNewlines) {
	        if (format & 65536 /* PreferNewLine */) {
	          return 1;
	        }
	        if (firstChild === void 0) {
	          return !parentNode || currentSourceFile && rangeIsOnSingleLine(parentNode, currentSourceFile) ? 0 : 1;
	        }
	        if (firstChild.pos === nextListElementPos) {
	          return 0;
	        }
	        if (firstChild.kind === 12 /* JsxText */) {
	          return 0;
	        }
	        if (currentSourceFile && parentNode && !positionIsSynthesized(parentNode.pos) && !nodeIsSynthesized(firstChild) && (!firstChild.parent || getOriginalNode(firstChild.parent) === getOriginalNode(parentNode))) {
	          if (preserveSourceNewlines) {
	            return getEffectiveLines(
	              (includeComments) => getLinesBetweenPositionAndPrecedingNonWhitespaceCharacter(
	                firstChild.pos,
	                parentNode.pos,
	                currentSourceFile,
	                includeComments
	              )
	            );
	          }
	          return rangeStartPositionsAreOnSameLine(parentNode, firstChild, currentSourceFile) ? 0 : 1;
	        }
	        if (synthesizedNodeStartsOnNewLine(firstChild, format)) {
	          return 1;
	        }
	      }
	      return format & 1 /* MultiLine */ ? 1 : 0;
	    }
	    function getSeparatingLineTerminatorCount(previousNode, nextNode, format) {
	      if (format & 2 /* PreserveLines */ || preserveSourceNewlines) {
	        if (previousNode === void 0 || nextNode === void 0) {
	          return 0;
	        }
	        if (nextNode.kind === 12 /* JsxText */) {
	          return 0;
	        } else if (currentSourceFile && !nodeIsSynthesized(previousNode) && !nodeIsSynthesized(nextNode)) {
	          if (preserveSourceNewlines && siblingNodePositionsAreComparable(previousNode, nextNode)) {
	            return getEffectiveLines(
	              (includeComments) => getLinesBetweenRangeEndAndRangeStart(
	                previousNode,
	                nextNode,
	                currentSourceFile,
	                includeComments
	              )
	            );
	          } else if (!preserveSourceNewlines && originalNodesHaveSameParent(previousNode, nextNode)) {
	            return rangeEndIsOnSameLineAsRangeStart(previousNode, nextNode, currentSourceFile) ? 0 : 1;
	          }
	          return format & 65536 /* PreferNewLine */ ? 1 : 0;
	        } else if (synthesizedNodeStartsOnNewLine(previousNode, format) || synthesizedNodeStartsOnNewLine(nextNode, format)) {
	          return 1;
	        }
	      } else if (getStartsOnNewLine(nextNode)) {
	        return 1;
	      }
	      return format & 1 /* MultiLine */ ? 1 : 0;
	    }
	    function getClosingLineTerminatorCount(parentNode, lastChild, format, childrenTextRange) {
	      if (format & 2 /* PreserveLines */ || preserveSourceNewlines) {
	        if (format & 65536 /* PreferNewLine */) {
	          return 1;
	        }
	        if (lastChild === void 0) {
	          return !parentNode || currentSourceFile && rangeIsOnSingleLine(parentNode, currentSourceFile) ? 0 : 1;
	        }
	        if (currentSourceFile && parentNode && !positionIsSynthesized(parentNode.pos) && !nodeIsSynthesized(lastChild) && (!lastChild.parent || lastChild.parent === parentNode)) {
	          if (preserveSourceNewlines) {
	            const end = childrenTextRange && !positionIsSynthesized(childrenTextRange.end) ? childrenTextRange.end : lastChild.end;
	            return getEffectiveLines(
	              (includeComments) => getLinesBetweenPositionAndNextNonWhitespaceCharacter(
	                end,
	                parentNode.end,
	                currentSourceFile,
	                includeComments
	              )
	            );
	          }
	          return rangeEndPositionsAreOnSameLine(parentNode, lastChild, currentSourceFile) ? 0 : 1;
	        }
	        if (synthesizedNodeStartsOnNewLine(lastChild, format)) {
	          return 1;
	        }
	      }
	      if (format & 1 /* MultiLine */ && !(format & 131072 /* NoTrailingNewLine */)) {
	        return 1;
	      }
	      return 0;
	    }
	    function getEffectiveLines(getLineDifference) {
	      Debug.assert(!!preserveSourceNewlines);
	      const lines = getLineDifference(
	        /*includeComments*/
	        true
	      );
	      if (lines === 0) {
	        return getLineDifference(
	          /*includeComments*/
	          false
	        );
	      }
	      return lines;
	    }
	    function writeLineSeparatorsAndIndentBefore(node, parent2) {
	      const leadingNewlines = preserveSourceNewlines && getLeadingLineTerminatorCount(parent2, node, 0 /* None */);
	      if (leadingNewlines) {
	        writeLinesAndIndent(
	          leadingNewlines,
	          /*writeSpaceIfNotIndenting*/
	          false
	        );
	      }
	      return !!leadingNewlines;
	    }
	    function writeLineSeparatorsAfter(node, parent2) {
	      const trailingNewlines = preserveSourceNewlines && getClosingLineTerminatorCount(
	        parent2,
	        node,
	        0 /* None */,
	        /*childrenTextRange*/
	        void 0
	      );
	      if (trailingNewlines) {
	        writeLine(trailingNewlines);
	      }
	    }
	    function synthesizedNodeStartsOnNewLine(node, format) {
	      if (nodeIsSynthesized(node)) {
	        const startsOnNewLine = getStartsOnNewLine(node);
	        if (startsOnNewLine === void 0) {
	          return (format & 65536 /* PreferNewLine */) !== 0;
	        }
	        return startsOnNewLine;
	      }
	      return (format & 65536 /* PreferNewLine */) !== 0;
	    }
	    function getLinesBetweenNodes(parent2, node1, node2) {
	      if (getEmitFlags(parent2) & 262144 /* NoIndentation */) {
	        return 0;
	      }
	      parent2 = skipSynthesizedParentheses(parent2);
	      node1 = skipSynthesizedParentheses(node1);
	      node2 = skipSynthesizedParentheses(node2);
	      if (getStartsOnNewLine(node2)) {
	        return 1;
	      }
	      if (currentSourceFile && !nodeIsSynthesized(parent2) && !nodeIsSynthesized(node1) && !nodeIsSynthesized(node2)) {
	        if (preserveSourceNewlines) {
	          return getEffectiveLines(
	            (includeComments) => getLinesBetweenRangeEndAndRangeStart(
	              node1,
	              node2,
	              currentSourceFile,
	              includeComments
	            )
	          );
	        }
	        return rangeEndIsOnSameLineAsRangeStart(node1, node2, currentSourceFile) ? 0 : 1;
	      }
	      return 0;
	    }
	    function isEmptyBlock(block) {
	      return block.statements.length === 0 && (!currentSourceFile || rangeEndIsOnSameLineAsRangeStart(block, block, currentSourceFile));
	    }
	    function skipSynthesizedParentheses(node) {
	      while (node.kind === 217 /* ParenthesizedExpression */ && nodeIsSynthesized(node)) {
	        node = node.expression;
	      }
	      return node;
	    }
	    function getTextOfNode2(node, includeTrivia) {
	      if (isGeneratedIdentifier(node) || isGeneratedPrivateIdentifier(node)) {
	        return generateName(node);
	      }
	      if (isStringLiteral(node) && node.textSourceNode) {
	        return getTextOfNode2(node.textSourceNode, includeTrivia);
	      }
	      const sourceFile = currentSourceFile;
	      const canUseSourceFile = !!sourceFile && !!node.parent && !nodeIsSynthesized(node);
	      if (isMemberName(node)) {
	        if (!canUseSourceFile || getSourceFileOfNode(node) !== getOriginalNode(sourceFile)) {
	          return idText(node);
	        }
	      } else if (isJsxNamespacedName(node)) {
	        if (!canUseSourceFile || getSourceFileOfNode(node) !== getOriginalNode(sourceFile)) {
	          return getTextOfJsxNamespacedName(node);
	        }
	      } else {
	        Debug.assertNode(node, isLiteralExpression);
	        if (!canUseSourceFile) {
	          return node.text;
	        }
	      }
	      return getSourceTextOfNodeFromSourceFile(sourceFile, node, includeTrivia);
	    }
	    function getLiteralTextOfNode(node, neverAsciiEscape, jsxAttributeEscape) {
	      if (node.kind === 11 /* StringLiteral */ && node.textSourceNode) {
	        const textSourceNode = node.textSourceNode;
	        if (isIdentifier(textSourceNode) || isPrivateIdentifier(textSourceNode) || isNumericLiteral(textSourceNode) || isJsxNamespacedName(textSourceNode)) {
	          const text = isNumericLiteral(textSourceNode) ? textSourceNode.text : getTextOfNode2(textSourceNode);
	          return jsxAttributeEscape ? `"${escapeJsxAttributeString(text)}"` : neverAsciiEscape || getEmitFlags(node) & 16777216 /* NoAsciiEscaping */ ? `"${escapeString(text)}"` : `"${escapeNonAsciiString(text)}"`;
	        } else {
	          return getLiteralTextOfNode(textSourceNode, neverAsciiEscape, jsxAttributeEscape);
	        }
	      }
	      const flags = (neverAsciiEscape ? 1 /* NeverAsciiEscape */ : 0) | (jsxAttributeEscape ? 2 /* JsxAttributeEscape */ : 0) | (printerOptions.terminateUnterminatedLiterals ? 4 /* TerminateUnterminatedLiterals */ : 0) | (printerOptions.target && printerOptions.target >= 8 /* ES2021 */ ? 8 /* AllowNumericSeparator */ : 0);
	      return getLiteralText(node, currentSourceFile, flags);
	    }
	    function pushNameGenerationScope(node) {
	      if (node && getEmitFlags(node) & 1048576 /* ReuseTempVariableScope */) {
	        return;
	      }
	      tempFlagsStack.push(tempFlags);
	      tempFlags = 0 /* Auto */;
	      formattedNameTempFlagsStack.push(formattedNameTempFlags);
	      formattedNameTempFlags = void 0;
	      reservedNamesStack.push(reservedNames);
	    }
	    function popNameGenerationScope(node) {
	      if (node && getEmitFlags(node) & 1048576 /* ReuseTempVariableScope */) {
	        return;
	      }
	      tempFlags = tempFlagsStack.pop();
	      formattedNameTempFlags = formattedNameTempFlagsStack.pop();
	      reservedNames = reservedNamesStack.pop();
	    }
	    function reserveNameInNestedScopes(name) {
	      if (!reservedNames || reservedNames === lastOrUndefined(reservedNamesStack)) {
	        reservedNames = /* @__PURE__ */ new Set();
	      }
	      reservedNames.add(name);
	    }
	    function pushPrivateNameGenerationScope(newPrivateNameTempFlags, newReservedMemberNames) {
	      privateNameTempFlagsStack.push(privateNameTempFlags);
	      privateNameTempFlags = newPrivateNameTempFlags;
	      reservedPrivateNamesStack.push(reservedNames);
	      reservedPrivateNames = newReservedMemberNames;
	    }
	    function popPrivateNameGenerationScope() {
	      privateNameTempFlags = privateNameTempFlagsStack.pop();
	      reservedPrivateNames = reservedPrivateNamesStack.pop();
	    }
	    function reservePrivateNameInNestedScopes(name) {
	      if (!reservedPrivateNames || reservedPrivateNames === lastOrUndefined(reservedPrivateNamesStack)) {
	        reservedPrivateNames = /* @__PURE__ */ new Set();
	      }
	      reservedPrivateNames.add(name);
	    }
	    function generateNames(node) {
	      if (!node)
	        return;
	      switch (node.kind) {
	        case 241 /* Block */:
	          forEach(node.statements, generateNames);
	          break;
	        case 256 /* LabeledStatement */:
	        case 254 /* WithStatement */:
	        case 246 /* DoStatement */:
	        case 247 /* WhileStatement */:
	          generateNames(node.statement);
	          break;
	        case 245 /* IfStatement */:
	          generateNames(node.thenStatement);
	          generateNames(node.elseStatement);
	          break;
	        case 248 /* ForStatement */:
	        case 250 /* ForOfStatement */:
	        case 249 /* ForInStatement */:
	          generateNames(node.initializer);
	          generateNames(node.statement);
	          break;
	        case 255 /* SwitchStatement */:
	          generateNames(node.caseBlock);
	          break;
	        case 269 /* CaseBlock */:
	          forEach(node.clauses, generateNames);
	          break;
	        case 296 /* CaseClause */:
	        case 297 /* DefaultClause */:
	          forEach(node.statements, generateNames);
	          break;
	        case 258 /* TryStatement */:
	          generateNames(node.tryBlock);
	          generateNames(node.catchClause);
	          generateNames(node.finallyBlock);
	          break;
	        case 299 /* CatchClause */:
	          generateNames(node.variableDeclaration);
	          generateNames(node.block);
	          break;
	        case 243 /* VariableStatement */:
	          generateNames(node.declarationList);
	          break;
	        case 261 /* VariableDeclarationList */:
	          forEach(node.declarations, generateNames);
	          break;
	        case 260 /* VariableDeclaration */:
	        case 169 /* Parameter */:
	        case 208 /* BindingElement */:
	        case 263 /* ClassDeclaration */:
	          generateNameIfNeeded(node.name);
	          break;
	        case 262 /* FunctionDeclaration */:
	          generateNameIfNeeded(node.name);
	          if (getEmitFlags(node) & 1048576 /* ReuseTempVariableScope */) {
	            forEach(node.parameters, generateNames);
	            generateNames(node.body);
	          }
	          break;
	        case 206 /* ObjectBindingPattern */:
	        case 207 /* ArrayBindingPattern */:
	          forEach(node.elements, generateNames);
	          break;
	        case 272 /* ImportDeclaration */:
	          generateNames(node.importClause);
	          break;
	        case 273 /* ImportClause */:
	          generateNameIfNeeded(node.name);
	          generateNames(node.namedBindings);
	          break;
	        case 274 /* NamespaceImport */:
	          generateNameIfNeeded(node.name);
	          break;
	        case 280 /* NamespaceExport */:
	          generateNameIfNeeded(node.name);
	          break;
	        case 275 /* NamedImports */:
	          forEach(node.elements, generateNames);
	          break;
	        case 276 /* ImportSpecifier */:
	          generateNameIfNeeded(node.propertyName || node.name);
	          break;
	      }
	    }
	    function generateMemberNames(node) {
	      if (!node)
	        return;
	      switch (node.kind) {
	        case 303 /* PropertyAssignment */:
	        case 304 /* ShorthandPropertyAssignment */:
	        case 172 /* PropertyDeclaration */:
	        case 174 /* MethodDeclaration */:
	        case 177 /* GetAccessor */:
	        case 178 /* SetAccessor */:
	          generateNameIfNeeded(node.name);
	          break;
	      }
	    }
	    function generateNameIfNeeded(name) {
	      if (name) {
	        if (isGeneratedIdentifier(name) || isGeneratedPrivateIdentifier(name)) {
	          generateName(name);
	        } else if (isBindingPattern(name)) {
	          generateNames(name);
	        }
	      }
	    }
	    function generateName(name) {
	      const autoGenerate = name.emitNode.autoGenerate;
	      if ((autoGenerate.flags & 7 /* KindMask */) === 4 /* Node */) {
	        return generateNameCached(getNodeForGeneratedName(name), isPrivateIdentifier(name), autoGenerate.flags, autoGenerate.prefix, autoGenerate.suffix);
	      } else {
	        const autoGenerateId = autoGenerate.id;
	        return autoGeneratedIdToGeneratedName[autoGenerateId] || (autoGeneratedIdToGeneratedName[autoGenerateId] = makeName(name));
	      }
	    }
	    function generateNameCached(node, privateName, flags, prefix, suffix) {
	      const nodeId = getNodeId(node);
	      const cache = privateName ? nodeIdToGeneratedPrivateName : nodeIdToGeneratedName;
	      return cache[nodeId] || (cache[nodeId] = generateNameForNode(node, privateName, flags ?? 0 /* None */, formatGeneratedNamePart(prefix, generateName), formatGeneratedNamePart(suffix)));
	    }
	    function isUniqueName(name, privateName) {
	      return isFileLevelUniqueNameInCurrentFile(name) && !isReservedName(name, privateName) && !generatedNames.has(name);
	    }
	    function isReservedName(name, privateName) {
	      return privateName ? !!(reservedPrivateNames == null ? void 0 : reservedPrivateNames.has(name)) : !!(reservedNames == null ? void 0 : reservedNames.has(name));
	    }
	    function isFileLevelUniqueNameInCurrentFile(name, _isPrivate) {
	      return currentSourceFile ? isFileLevelUniqueName(currentSourceFile, name, hasGlobalName) : true;
	    }
	    function isUniqueLocalName(name, container) {
	      for (let node = container; node && isNodeDescendantOf(node, container); node = node.nextContainer) {
	        if (canHaveLocals(node) && node.locals) {
	          const local = node.locals.get(escapeLeadingUnderscores(name));
	          if (local && local.flags & (111551 /* Value */ | 1048576 /* ExportValue */ | 2097152 /* Alias */)) {
	            return false;
	          }
	        }
	      }
	      return true;
	    }
	    function getTempFlags(formattedNameKey) {
	      switch (formattedNameKey) {
	        case "":
	          return tempFlags;
	        case "#":
	          return privateNameTempFlags;
	        default:
	          return (formattedNameTempFlags == null ? void 0 : formattedNameTempFlags.get(formattedNameKey)) ?? 0 /* Auto */;
	      }
	    }
	    function setTempFlags(formattedNameKey, flags) {
	      switch (formattedNameKey) {
	        case "":
	          tempFlags = flags;
	          break;
	        case "#":
	          privateNameTempFlags = flags;
	          break;
	        default:
	          formattedNameTempFlags ?? (formattedNameTempFlags = /* @__PURE__ */ new Map());
	          formattedNameTempFlags.set(formattedNameKey, flags);
	          break;
	      }
	    }
	    function makeTempVariableName(flags, reservedInNestedScopes, privateName, prefix, suffix) {
	      if (prefix.length > 0 && prefix.charCodeAt(0) === 35 /* hash */) {
	        prefix = prefix.slice(1);
	      }
	      const key = formatGeneratedName(privateName, prefix, "", suffix);
	      let tempFlags2 = getTempFlags(key);
	      if (flags && !(tempFlags2 & flags)) {
	        const name = flags === 268435456 /* _i */ ? "_i" : "_n";
	        const fullName = formatGeneratedName(privateName, prefix, name, suffix);
	        if (isUniqueName(fullName, privateName)) {
	          tempFlags2 |= flags;
	          if (privateName) {
	            reservePrivateNameInNestedScopes(fullName);
	          } else if (reservedInNestedScopes) {
	            reserveNameInNestedScopes(fullName);
	          }
	          setTempFlags(key, tempFlags2);
	          return fullName;
	        }
	      }
	      while (true) {
	        const count = tempFlags2 & 268435455 /* CountMask */;
	        tempFlags2++;
	        if (count !== 8 && count !== 13) {
	          const name = count < 26 ? "_" + String.fromCharCode(97 /* a */ + count) : "_" + (count - 26);
	          const fullName = formatGeneratedName(privateName, prefix, name, suffix);
	          if (isUniqueName(fullName, privateName)) {
	            if (privateName) {
	              reservePrivateNameInNestedScopes(fullName);
	            } else if (reservedInNestedScopes) {
	              reserveNameInNestedScopes(fullName);
	            }
	            setTempFlags(key, tempFlags2);
	            return fullName;
	          }
	        }
	      }
	    }
	    function makeUniqueName2(baseName, checkFn = isUniqueName, optimistic, scoped, privateName, prefix, suffix) {
	      if (baseName.length > 0 && baseName.charCodeAt(0) === 35 /* hash */) {
	        baseName = baseName.slice(1);
	      }
	      if (prefix.length > 0 && prefix.charCodeAt(0) === 35 /* hash */) {
	        prefix = prefix.slice(1);
	      }
	      if (optimistic) {
	        const fullName = formatGeneratedName(privateName, prefix, baseName, suffix);
	        if (checkFn(fullName, privateName)) {
	          if (privateName) {
	            reservePrivateNameInNestedScopes(fullName);
	          } else if (scoped) {
	            reserveNameInNestedScopes(fullName);
	          } else {
	            generatedNames.add(fullName);
	          }
	          return fullName;
	        }
	      }
	      if (baseName.charCodeAt(baseName.length - 1) !== 95 /* _ */) {
	        baseName += "_";
	      }
	      let i = 1;
	      while (true) {
	        const fullName = formatGeneratedName(privateName, prefix, baseName + i, suffix);
	        if (checkFn(fullName, privateName)) {
	          if (privateName) {
	            reservePrivateNameInNestedScopes(fullName);
	          } else if (scoped) {
	            reserveNameInNestedScopes(fullName);
	          } else {
	            generatedNames.add(fullName);
	          }
	          return fullName;
	        }
	        i++;
	      }
	    }
	    function makeFileLevelOptimisticUniqueName(name) {
	      return makeUniqueName2(
	        name,
	        isFileLevelUniqueNameInCurrentFile,
	        /*optimistic*/
	        true,
	        /*scoped*/
	        false,
	        /*privateName*/
	        false,
	        /*prefix*/
	        "",
	        /*suffix*/
	        ""
	      );
	    }
	    function generateNameForModuleOrEnum(node) {
	      const name = getTextOfNode2(node.name);
	      return isUniqueLocalName(name, tryCast(node, canHaveLocals)) ? name : makeUniqueName2(
	        name,
	        isUniqueName,
	        /*optimistic*/
	        false,
	        /*scoped*/
	        false,
	        /*privateName*/
	        false,
	        /*prefix*/
	        "",
	        /*suffix*/
	        ""
	      );
	    }
	    function generateNameForImportOrExportDeclaration(node) {
	      const expr = getExternalModuleName(node);
	      const baseName = isStringLiteral(expr) ? makeIdentifierFromModuleName(expr.text) : "module";
	      return makeUniqueName2(
	        baseName,
	        isUniqueName,
	        /*optimistic*/
	        false,
	        /*scoped*/
	        false,
	        /*privateName*/
	        false,
	        /*prefix*/
	        "",
	        /*suffix*/
	        ""
	      );
	    }
	    function generateNameForExportDefault() {
	      return makeUniqueName2(
	        "default",
	        isUniqueName,
	        /*optimistic*/
	        false,
	        /*scoped*/
	        false,
	        /*privateName*/
	        false,
	        /*prefix*/
	        "",
	        /*suffix*/
	        ""
	      );
	    }
	    function generateNameForClassExpression() {
	      return makeUniqueName2(
	        "class",
	        isUniqueName,
	        /*optimistic*/
	        false,
	        /*scoped*/
	        false,
	        /*privateName*/
	        false,
	        /*prefix*/
	        "",
	        /*suffix*/
	        ""
	      );
	    }
	    function generateNameForMethodOrAccessor(node, privateName, prefix, suffix) {
	      if (isIdentifier(node.name)) {
	        return generateNameCached(node.name, privateName);
	      }
	      return makeTempVariableName(
	        0 /* Auto */,
	        /*reservedInNestedScopes*/
	        false,
	        privateName,
	        prefix,
	        suffix
	      );
	    }
	    function generateNameForNode(node, privateName, flags, prefix, suffix) {
	      switch (node.kind) {
	        case 80 /* Identifier */:
	        case 81 /* PrivateIdentifier */:
	          return makeUniqueName2(
	            getTextOfNode2(node),
	            isUniqueName,
	            !!(flags & 16 /* Optimistic */),
	            !!(flags & 8 /* ReservedInNestedScopes */),
	            privateName,
	            prefix,
	            suffix
	          );
	        case 267 /* ModuleDeclaration */:
	        case 266 /* EnumDeclaration */:
	          Debug.assert(!prefix && !suffix && !privateName);
	          return generateNameForModuleOrEnum(node);
	        case 272 /* ImportDeclaration */:
	        case 278 /* ExportDeclaration */:
	          Debug.assert(!prefix && !suffix && !privateName);
	          return generateNameForImportOrExportDeclaration(node);
	        case 262 /* FunctionDeclaration */:
	        case 263 /* ClassDeclaration */: {
	          Debug.assert(!prefix && !suffix && !privateName);
	          const name = node.name;
	          if (name && !isGeneratedIdentifier(name)) {
	            return generateNameForNode(
	              name,
	              /*privateName*/
	              false,
	              flags,
	              prefix,
	              suffix
	            );
	          }
	          return generateNameForExportDefault();
	        }
	        case 277 /* ExportAssignment */:
	          Debug.assert(!prefix && !suffix && !privateName);
	          return generateNameForExportDefault();
	        case 231 /* ClassExpression */:
	          Debug.assert(!prefix && !suffix && !privateName);
	          return generateNameForClassExpression();
	        case 174 /* MethodDeclaration */:
	        case 177 /* GetAccessor */:
	        case 178 /* SetAccessor */:
	          return generateNameForMethodOrAccessor(node, privateName, prefix, suffix);
	        case 167 /* ComputedPropertyName */:
	          return makeTempVariableName(
	            0 /* Auto */,
	            /*reservedInNestedScopes*/
	            true,
	            privateName,
	            prefix,
	            suffix
	          );
	        default:
	          return makeTempVariableName(
	            0 /* Auto */,
	            /*reservedInNestedScopes*/
	            false,
	            privateName,
	            prefix,
	            suffix
	          );
	      }
	    }
	    function makeName(name) {
	      const autoGenerate = name.emitNode.autoGenerate;
	      const prefix = formatGeneratedNamePart(autoGenerate.prefix, generateName);
	      const suffix = formatGeneratedNamePart(autoGenerate.suffix);
	      switch (autoGenerate.flags & 7 /* KindMask */) {
	        case 1 /* Auto */:
	          return makeTempVariableName(0 /* Auto */, !!(autoGenerate.flags & 8 /* ReservedInNestedScopes */), isPrivateIdentifier(name), prefix, suffix);
	        case 2 /* Loop */:
	          Debug.assertNode(name, isIdentifier);
	          return makeTempVariableName(
	            268435456 /* _i */,
	            !!(autoGenerate.flags & 8 /* ReservedInNestedScopes */),
	            /*privateName*/
	            false,
	            prefix,
	            suffix
	          );
	        case 3 /* Unique */:
	          return makeUniqueName2(
	            idText(name),
	            autoGenerate.flags & 32 /* FileLevel */ ? isFileLevelUniqueNameInCurrentFile : isUniqueName,
	            !!(autoGenerate.flags & 16 /* Optimistic */),
	            !!(autoGenerate.flags & 8 /* ReservedInNestedScopes */),
	            isPrivateIdentifier(name),
	            prefix,
	            suffix
	          );
	      }
	      return Debug.fail(`Unsupported GeneratedIdentifierKind: ${Debug.formatEnum(
	        autoGenerate.flags & 7 /* KindMask */,
	        GeneratedIdentifierFlags,
	        /*isFlags*/
	        true
	      )}.`);
	    }
	    function pipelineEmitWithComments(hint, node) {
	      const pipelinePhase = getNextPipelinePhase(2 /* Comments */, hint, node);
	      const savedContainerPos = containerPos;
	      const savedContainerEnd = containerEnd;
	      const savedDeclarationListContainerEnd = declarationListContainerEnd;
	      emitCommentsBeforeNode(node);
	      pipelinePhase(hint, node);
	      emitCommentsAfterNode(node, savedContainerPos, savedContainerEnd, savedDeclarationListContainerEnd);
	    }
	    function emitCommentsBeforeNode(node) {
	      const emitFlags = getEmitFlags(node);
	      const commentRange = getCommentRange(node);
	      emitLeadingCommentsOfNode(node, emitFlags, commentRange.pos, commentRange.end);
	      if (emitFlags & 4096 /* NoNestedComments */) {
	        commentsDisabled = true;
	      }
	    }
	    function emitCommentsAfterNode(node, savedContainerPos, savedContainerEnd, savedDeclarationListContainerEnd) {
	      const emitFlags = getEmitFlags(node);
	      const commentRange = getCommentRange(node);
	      if (emitFlags & 4096 /* NoNestedComments */) {
	        commentsDisabled = false;
	      }
	      emitTrailingCommentsOfNode(node, emitFlags, commentRange.pos, commentRange.end, savedContainerPos, savedContainerEnd, savedDeclarationListContainerEnd);
	      const typeNode = getTypeNode(node);
	      if (typeNode) {
	        emitTrailingCommentsOfNode(node, emitFlags, typeNode.pos, typeNode.end, savedContainerPos, savedContainerEnd, savedDeclarationListContainerEnd);
	      }
	    }
	    function emitLeadingCommentsOfNode(node, emitFlags, pos, end) {
	      enterComment();
	      hasWrittenComment = false;
	      const skipLeadingComments = pos < 0 || (emitFlags & 1024 /* NoLeadingComments */) !== 0 || node.kind === 12 /* JsxText */;
	      const skipTrailingComments = end < 0 || (emitFlags & 2048 /* NoTrailingComments */) !== 0 || node.kind === 12 /* JsxText */;
	      if ((pos > 0 || end > 0) && pos !== end) {
	        if (!skipLeadingComments) {
	          emitLeadingComments(
	            pos,
	            /*isEmittedNode*/
	            node.kind !== 359 /* NotEmittedStatement */
	          );
	        }
	        if (!skipLeadingComments || pos >= 0 && (emitFlags & 1024 /* NoLeadingComments */) !== 0) {
	          containerPos = pos;
	        }
	        if (!skipTrailingComments || end >= 0 && (emitFlags & 2048 /* NoTrailingComments */) !== 0) {
	          containerEnd = end;
	          if (node.kind === 261 /* VariableDeclarationList */) {
	            declarationListContainerEnd = end;
	          }
	        }
	      }
	      forEach(getSyntheticLeadingComments(node), emitLeadingSynthesizedComment);
	      exitComment();
	    }
	    function emitTrailingCommentsOfNode(node, emitFlags, pos, end, savedContainerPos, savedContainerEnd, savedDeclarationListContainerEnd) {
	      enterComment();
	      const skipTrailingComments = end < 0 || (emitFlags & 2048 /* NoTrailingComments */) !== 0 || node.kind === 12 /* JsxText */;
	      forEach(getSyntheticTrailingComments(node), emitTrailingSynthesizedComment);
	      if ((pos > 0 || end > 0) && pos !== end) {
	        containerPos = savedContainerPos;
	        containerEnd = savedContainerEnd;
	        declarationListContainerEnd = savedDeclarationListContainerEnd;
	        if (!skipTrailingComments && node.kind !== 359 /* NotEmittedStatement */) {
	          emitTrailingComments(end);
	        }
	      }
	      exitComment();
	    }
	    function emitLeadingSynthesizedComment(comment) {
	      if (comment.hasLeadingNewline || comment.kind === 2 /* SingleLineCommentTrivia */) {
	        writer.writeLine();
	      }
	      writeSynthesizedComment(comment);
	      if (comment.hasTrailingNewLine || comment.kind === 2 /* SingleLineCommentTrivia */) {
	        writer.writeLine();
	      } else {
	        writer.writeSpace(" ");
	      }
	    }
	    function emitTrailingSynthesizedComment(comment) {
	      if (!writer.isAtStartOfLine()) {
	        writer.writeSpace(" ");
	      }
	      writeSynthesizedComment(comment);
	      if (comment.hasTrailingNewLine) {
	        writer.writeLine();
	      }
	    }
	    function writeSynthesizedComment(comment) {
	      const text = formatSynthesizedComment(comment);
	      const lineMap = comment.kind === 3 /* MultiLineCommentTrivia */ ? computeLineStarts(text) : void 0;
	      writeCommentRange(text, lineMap, writer, 0, text.length, newLine);
	    }
	    function formatSynthesizedComment(comment) {
	      return comment.kind === 3 /* MultiLineCommentTrivia */ ? `/*${comment.text}*/` : `//${comment.text}`;
	    }
	    function emitBodyWithDetachedComments(node, detachedRange, emitCallback) {
	      enterComment();
	      const { pos, end } = detachedRange;
	      const emitFlags = getEmitFlags(node);
	      const skipLeadingComments = pos < 0 || (emitFlags & 1024 /* NoLeadingComments */) !== 0;
	      const skipTrailingComments = commentsDisabled || end < 0 || (emitFlags & 2048 /* NoTrailingComments */) !== 0;
	      if (!skipLeadingComments) {
	        emitDetachedCommentsAndUpdateCommentsInfo(detachedRange);
	      }
	      exitComment();
	      if (emitFlags & 4096 /* NoNestedComments */ && !commentsDisabled) {
	        commentsDisabled = true;
	        emitCallback(node);
	        commentsDisabled = false;
	      } else {
	        emitCallback(node);
	      }
	      enterComment();
	      if (!skipTrailingComments) {
	        emitLeadingComments(
	          detachedRange.end,
	          /*isEmittedNode*/
	          true
	        );
	        if (hasWrittenComment && !writer.isAtStartOfLine()) {
	          writer.writeLine();
	        }
	      }
	      exitComment();
	    }
	    function originalNodesHaveSameParent(nodeA, nodeB) {
	      nodeA = getOriginalNode(nodeA);
	      return nodeA.parent && nodeA.parent === getOriginalNode(nodeB).parent;
	    }
	    function siblingNodePositionsAreComparable(previousNode, nextNode) {
	      if (nextNode.pos < previousNode.end) {
	        return false;
	      }
	      previousNode = getOriginalNode(previousNode);
	      nextNode = getOriginalNode(nextNode);
	      const parent2 = previousNode.parent;
	      if (!parent2 || parent2 !== nextNode.parent) {
	        return false;
	      }
	      const parentNodeArray = getContainingNodeArray(previousNode);
	      const prevNodeIndex = parentNodeArray == null ? void 0 : parentNodeArray.indexOf(previousNode);
	      return prevNodeIndex !== void 0 && prevNodeIndex > -1 && parentNodeArray.indexOf(nextNode) === prevNodeIndex + 1;
	    }
	    function emitLeadingComments(pos, isEmittedNode) {
	      hasWrittenComment = false;
	      if (isEmittedNode) {
	        if (pos === 0 && (currentSourceFile == null ? void 0 : currentSourceFile.isDeclarationFile)) {
	          forEachLeadingCommentToEmit(pos, emitNonTripleSlashLeadingComment);
	        } else {
	          forEachLeadingCommentToEmit(pos, emitLeadingComment);
	        }
	      } else if (pos === 0) {
	        forEachLeadingCommentToEmit(pos, emitTripleSlashLeadingComment);
	      }
	    }
	    function emitTripleSlashLeadingComment(commentPos, commentEnd, kind, hasTrailingNewLine, rangePos) {
	      if (isTripleSlashComment(commentPos, commentEnd)) {
	        emitLeadingComment(commentPos, commentEnd, kind, hasTrailingNewLine, rangePos);
	      }
	    }
	    function emitNonTripleSlashLeadingComment(commentPos, commentEnd, kind, hasTrailingNewLine, rangePos) {
	      if (!isTripleSlashComment(commentPos, commentEnd)) {
	        emitLeadingComment(commentPos, commentEnd, kind, hasTrailingNewLine, rangePos);
	      }
	    }
	    function shouldWriteComment(text, pos) {
	      if (printerOptions.onlyPrintJsDocStyle) {
	        return isJSDocLikeText(text, pos) || isPinnedComment(text, pos);
	      }
	      return true;
	    }
	    function emitLeadingComment(commentPos, commentEnd, kind, hasTrailingNewLine, rangePos) {
	      if (!currentSourceFile || !shouldWriteComment(currentSourceFile.text, commentPos))
	        return;
	      if (!hasWrittenComment) {
	        emitNewLineBeforeLeadingCommentOfPosition(getCurrentLineMap(), writer, rangePos, commentPos);
	        hasWrittenComment = true;
	      }
	      emitPos(commentPos);
	      writeCommentRange(currentSourceFile.text, getCurrentLineMap(), writer, commentPos, commentEnd, newLine);
	      emitPos(commentEnd);
	      if (hasTrailingNewLine) {
	        writer.writeLine();
	      } else if (kind === 3 /* MultiLineCommentTrivia */) {
	        writer.writeSpace(" ");
	      }
	    }
	    function emitLeadingCommentsOfPosition(pos) {
	      if (commentsDisabled || pos === -1) {
	        return;
	      }
	      emitLeadingComments(
	        pos,
	        /*isEmittedNode*/
	        true
	      );
	    }
	    function emitTrailingComments(pos) {
	      forEachTrailingCommentToEmit(pos, emitTrailingComment);
	    }
	    function emitTrailingComment(commentPos, commentEnd, _kind, hasTrailingNewLine) {
	      if (!currentSourceFile || !shouldWriteComment(currentSourceFile.text, commentPos))
	        return;
	      if (!writer.isAtStartOfLine()) {
	        writer.writeSpace(" ");
	      }
	      emitPos(commentPos);
	      writeCommentRange(currentSourceFile.text, getCurrentLineMap(), writer, commentPos, commentEnd, newLine);
	      emitPos(commentEnd);
	      if (hasTrailingNewLine) {
	        writer.writeLine();
	      }
	    }
	    function emitTrailingCommentsOfPosition(pos, prefixSpace, forceNoNewline) {
	      if (commentsDisabled) {
	        return;
	      }
	      enterComment();
	      forEachTrailingCommentToEmit(pos, prefixSpace ? emitTrailingComment : forceNoNewline ? emitTrailingCommentOfPositionNoNewline : emitTrailingCommentOfPosition);
	      exitComment();
	    }
	    function emitTrailingCommentOfPositionNoNewline(commentPos, commentEnd, kind) {
	      if (!currentSourceFile)
	        return;
	      emitPos(commentPos);
	      writeCommentRange(currentSourceFile.text, getCurrentLineMap(), writer, commentPos, commentEnd, newLine);
	      emitPos(commentEnd);
	      if (kind === 2 /* SingleLineCommentTrivia */) {
	        writer.writeLine();
	      }
	    }
	    function emitTrailingCommentOfPosition(commentPos, commentEnd, _kind, hasTrailingNewLine) {
	      if (!currentSourceFile)
	        return;
	      emitPos(commentPos);
	      writeCommentRange(currentSourceFile.text, getCurrentLineMap(), writer, commentPos, commentEnd, newLine);
	      emitPos(commentEnd);
	      if (hasTrailingNewLine) {
	        writer.writeLine();
	      } else {
	        writer.writeSpace(" ");
	      }
	    }
	    function forEachLeadingCommentToEmit(pos, cb) {
	      if (currentSourceFile && (containerPos === -1 || pos !== containerPos)) {
	        if (hasDetachedComments(pos)) {
	          forEachLeadingCommentWithoutDetachedComments(cb);
	        } else {
	          forEachLeadingCommentRange(
	            currentSourceFile.text,
	            pos,
	            cb,
	            /*state*/
	            pos
	          );
	        }
	      }
	    }
	    function forEachTrailingCommentToEmit(end, cb) {
	      if (currentSourceFile && (containerEnd === -1 || end !== containerEnd && end !== declarationListContainerEnd)) {
	        forEachTrailingCommentRange(currentSourceFile.text, end, cb);
	      }
	    }
	    function hasDetachedComments(pos) {
	      return detachedCommentsInfo !== void 0 && last(detachedCommentsInfo).nodePos === pos;
	    }
	    function forEachLeadingCommentWithoutDetachedComments(cb) {
	      if (!currentSourceFile)
	        return;
	      const pos = last(detachedCommentsInfo).detachedCommentEndPos;
	      if (detachedCommentsInfo.length - 1) {
	        detachedCommentsInfo.pop();
	      } else {
	        detachedCommentsInfo = void 0;
	      }
	      forEachLeadingCommentRange(
	        currentSourceFile.text,
	        pos,
	        cb,
	        /*state*/
	        pos
	      );
	    }
	    function emitDetachedCommentsAndUpdateCommentsInfo(range) {
	      const currentDetachedCommentInfo = currentSourceFile && emitDetachedComments(currentSourceFile.text, getCurrentLineMap(), writer, emitComment, range, newLine, commentsDisabled);
	      if (currentDetachedCommentInfo) {
	        if (detachedCommentsInfo) {
	          detachedCommentsInfo.push(currentDetachedCommentInfo);
	        } else {
	          detachedCommentsInfo = [currentDetachedCommentInfo];
	        }
	      }
	    }
	    function emitComment(text, lineMap, writer2, commentPos, commentEnd, newLine2) {
	      if (!currentSourceFile || !shouldWriteComment(currentSourceFile.text, commentPos))
	        return;
	      emitPos(commentPos);
	      writeCommentRange(text, lineMap, writer2, commentPos, commentEnd, newLine2);
	      emitPos(commentEnd);
	    }
	    function isTripleSlashComment(commentPos, commentEnd) {
	      return !!currentSourceFile && isRecognizedTripleSlashComment(currentSourceFile.text, commentPos, commentEnd);
	    }
	    function getParsedSourceMap(node) {
	      if (node.parsedSourceMap === void 0 && node.sourceMapText !== void 0) {
	        node.parsedSourceMap = tryParseRawSourceMap(node.sourceMapText) || false;
	      }
	      return node.parsedSourceMap || void 0;
	    }
	    function pipelineEmitWithSourceMaps(hint, node) {
	      const pipelinePhase = getNextPipelinePhase(3 /* SourceMaps */, hint, node);
	      emitSourceMapsBeforeNode(node);
	      pipelinePhase(hint, node);
	      emitSourceMapsAfterNode(node);
	    }
	    function emitSourceMapsBeforeNode(node) {
	      const emitFlags = getEmitFlags(node);
	      const sourceMapRange = getSourceMapRange(node);
	      if (isUnparsedNode(node)) {
	        Debug.assertIsDefined(node.parent, "UnparsedNodes must have parent pointers");
	        const parsed = getParsedSourceMap(node.parent);
	        if (parsed && sourceMapGenerator) {
	          sourceMapGenerator.appendSourceMap(
	            writer.getLine(),
	            writer.getColumn(),
	            parsed,
	            node.parent.sourceMapPath,
	            node.parent.getLineAndCharacterOfPosition(node.pos),
	            node.parent.getLineAndCharacterOfPosition(node.end)
	          );
	        }
	      } else {
	        const source = sourceMapRange.source || sourceMapSource;
	        if (node.kind !== 359 /* NotEmittedStatement */ && (emitFlags & 32 /* NoLeadingSourceMap */) === 0 && sourceMapRange.pos >= 0) {
	          emitSourcePos(sourceMapRange.source || sourceMapSource, skipSourceTrivia(source, sourceMapRange.pos));
	        }
	        if (emitFlags & 128 /* NoNestedSourceMaps */) {
	          sourceMapsDisabled = true;
	        }
	      }
	    }
	    function emitSourceMapsAfterNode(node) {
	      const emitFlags = getEmitFlags(node);
	      const sourceMapRange = getSourceMapRange(node);
	      if (!isUnparsedNode(node)) {
	        if (emitFlags & 128 /* NoNestedSourceMaps */) {
	          sourceMapsDisabled = false;
	        }
	        if (node.kind !== 359 /* NotEmittedStatement */ && (emitFlags & 64 /* NoTrailingSourceMap */) === 0 && sourceMapRange.end >= 0) {
	          emitSourcePos(sourceMapRange.source || sourceMapSource, sourceMapRange.end);
	        }
	      }
	    }
	    function skipSourceTrivia(source, pos) {
	      return source.skipTrivia ? source.skipTrivia(pos) : skipTrivia(source.text, pos);
	    }
	    function emitPos(pos) {
	      if (sourceMapsDisabled || positionIsSynthesized(pos) || isJsonSourceMapSource(sourceMapSource)) {
	        return;
	      }
	      const { line: sourceLine, character: sourceCharacter } = getLineAndCharacterOfPosition(sourceMapSource, pos);
	      sourceMapGenerator.addMapping(
	        writer.getLine(),
	        writer.getColumn(),
	        sourceMapSourceIndex,
	        sourceLine,
	        sourceCharacter,
	        /*nameIndex*/
	        void 0
	      );
	    }
	    function emitSourcePos(source, pos) {
	      if (source !== sourceMapSource) {
	        const savedSourceMapSource = sourceMapSource;
	        const savedSourceMapSourceIndex = sourceMapSourceIndex;
	        setSourceMapSource(source);
	        emitPos(pos);
	        resetSourceMapSource(savedSourceMapSource, savedSourceMapSourceIndex);
	      } else {
	        emitPos(pos);
	      }
	    }
	    function emitTokenWithSourceMap(node, token, writer2, tokenPos, emitCallback) {
	      if (sourceMapsDisabled || node && isInJsonFile(node)) {
	        return emitCallback(token, writer2, tokenPos);
	      }
	      const emitNode = node && node.emitNode;
	      const emitFlags = emitNode && emitNode.flags || 0 /* None */;
	      const range = emitNode && emitNode.tokenSourceMapRanges && emitNode.tokenSourceMapRanges[token];
	      const source = range && range.source || sourceMapSource;
	      tokenPos = skipSourceTrivia(source, range ? range.pos : tokenPos);
	      if ((emitFlags & 256 /* NoTokenLeadingSourceMaps */) === 0 && tokenPos >= 0) {
	        emitSourcePos(source, tokenPos);
	      }
	      tokenPos = emitCallback(token, writer2, tokenPos);
	      if (range)
	        tokenPos = range.end;
	      if ((emitFlags & 512 /* NoTokenTrailingSourceMaps */) === 0 && tokenPos >= 0) {
	        emitSourcePos(source, tokenPos);
	      }
	      return tokenPos;
	    }
	    function setSourceMapSource(source) {
	      if (sourceMapsDisabled) {
	        return;
	      }
	      sourceMapSource = source;
	      if (source === mostRecentlyAddedSourceMapSource) {
	        sourceMapSourceIndex = mostRecentlyAddedSourceMapSourceIndex;
	        return;
	      }
	      if (isJsonSourceMapSource(source)) {
	        return;
	      }
	      sourceMapSourceIndex = sourceMapGenerator.addSource(source.fileName);
	      if (printerOptions.inlineSources) {
	        sourceMapGenerator.setSourceContent(sourceMapSourceIndex, source.text);
	      }
	      mostRecentlyAddedSourceMapSource = source;
	      mostRecentlyAddedSourceMapSourceIndex = sourceMapSourceIndex;
	    }
	    function resetSourceMapSource(source, sourceIndex) {
	      sourceMapSource = source;
	      sourceMapSourceIndex = sourceIndex;
	    }
	    function isJsonSourceMapSource(sourceFile) {
	      return fileExtensionIs(sourceFile.fileName, ".json" /* Json */);
	    }
	  }
	  function createBracketsMap() {
	    const brackets2 = [];
	    brackets2[1024 /* Braces */] = ["{", "}"];
	    brackets2[2048 /* Parenthesis */] = ["(", ")"];
	    brackets2[4096 /* AngleBrackets */] = ["<", ">"];
	    brackets2[8192 /* SquareBrackets */] = ["[", "]"];
	    return brackets2;
	  }
	  function getOpeningBracket(format) {
	    return brackets[format & 15360 /* BracketsMask */][0];
	  }
	  function getClosingBracket(format) {
	    return brackets[format & 15360 /* BracketsMask */][1];
	  }
	  function emitListItemNoParenthesizer(node, emit, _parenthesizerRule, _index) {
	    emit(node);
	  }
	  function emitListItemWithParenthesizerRuleSelector(node, emit, parenthesizerRuleSelector, index) {
	    emit(node, parenthesizerRuleSelector.select(index));
	  }
	  function emitListItemWithParenthesizerRule(node, emit, parenthesizerRule, _index) {
	    emit(node, parenthesizerRule);
	  }
	  function getEmitListItem(emit, parenthesizerRule) {
	    return emit.length === 1 ? emitListItemNoParenthesizer : typeof parenthesizerRule === "object" ? emitListItemWithParenthesizerRuleSelector : emitListItemWithParenthesizerRule;
	  }
	  var brackets, notImplementedResolver, createPrinterWithDefaults, createPrinterWithRemoveComments, createPrinterWithRemoveCommentsNeverAsciiEscape, createPrinterWithRemoveCommentsOmitTrailingSemicolon;
	  var init_emitter = __esm({
	    "src/compiler/emitter.ts"() {
	      init_ts2();
	      init_ts2();
	      init_ts_performance();
	      brackets = createBracketsMap();
	      notImplementedResolver = {
	        hasGlobalName: notImplemented,
	        getReferencedExportContainer: notImplemented,
	        getReferencedImportDeclaration: notImplemented,
	        getReferencedDeclarationWithCollidingName: notImplemented,
	        isDeclarationWithCollidingName: notImplemented,
	        isValueAliasDeclaration: notImplemented,
	        isReferencedAliasDeclaration: notImplemented,
	        isTopLevelValueImportEqualsWithEntityName: notImplemented,
	        getNodeCheckFlags: notImplemented,
	        isDeclarationVisible: notImplemented,
	        isLateBound: (_node) => false,
	        collectLinkedAliases: notImplemented,
	        isImplementationOfOverload: notImplemented,
	        isRequiredInitializedParameter: notImplemented,
	        isOptionalUninitializedParameterProperty: notImplemented,
	        isExpandoFunctionDeclaration: notImplemented,
	        getPropertiesOfContainerFunction: notImplemented,
	        createTypeOfDeclaration: notImplemented,
	        createReturnTypeOfSignatureDeclaration: notImplemented,
	        createTypeOfExpression: notImplemented,
	        createLiteralConstValue: notImplemented,
	        isSymbolAccessible: notImplemented,
	        isEntityNameVisible: notImplemented,
	        // Returns the constant value this property access resolves to: notImplemented, or 'undefined' for a non-constant
	        getConstantValue: notImplemented,
	        getReferencedValueDeclaration: notImplemented,
	        getReferencedValueDeclarations: notImplemented,
	        getTypeReferenceSerializationKind: notImplemented,
	        isOptionalParameter: notImplemented,
	        moduleExportsSomeValue: notImplemented,
	        isArgumentsLocalBinding: notImplemented,
	        getExternalModuleFileFromDeclaration: notImplemented,
	        getTypeReferenceDirectivesForEntityName: notImplemented,
	        getTypeReferenceDirectivesForSymbol: notImplemented,
	        isLiteralConstDeclaration: notImplemented,
	        getJsxFactoryEntity: notImplemented,
	        getJsxFragmentFactoryEntity: notImplemented,
	        getAllAccessorDeclarations: notImplemented,
	        getSymbolOfExternalModuleSpecifier: notImplemented,
	        isBindingCapturedByNode: notImplemented,
	        getDeclarationStatementsForSourceFile: notImplemented,
	        isImportRequiredByAugmentation: notImplemented,
	        tryFindAmbientModule: notImplemented
	      };
	      createPrinterWithDefaults = /* @__PURE__ */ memoize(() => createPrinter({}));
	      createPrinterWithRemoveComments = /* @__PURE__ */ memoize(() => createPrinter({ removeComments: true }));
	      createPrinterWithRemoveCommentsNeverAsciiEscape = /* @__PURE__ */ memoize(() => createPrinter({ removeComments: true, neverAsciiEscape: true }));
	      createPrinterWithRemoveCommentsOmitTrailingSemicolon = /* @__PURE__ */ memoize(() => createPrinter({ removeComments: true, omitTrailingSemicolon: true }));
	    }
	  });

	  // src/compiler/watchUtilities.ts
	  function createCachedDirectoryStructureHost(host, currentDirectory, useCaseSensitiveFileNames2) {
	    if (!host.getDirectories || !host.readDirectory) {
	      return void 0;
	    }
	    const cachedReadDirectoryResult = /* @__PURE__ */ new Map();
	    const getCanonicalFileName = createGetCanonicalFileName(useCaseSensitiveFileNames2);
	    return {
	      useCaseSensitiveFileNames: useCaseSensitiveFileNames2,
	      fileExists,
	      readFile: (path, encoding) => host.readFile(path, encoding),
	      directoryExists: host.directoryExists && directoryExists,
	      getDirectories,
	      readDirectory,
	      createDirectory: host.createDirectory && createDirectory,
	      writeFile: host.writeFile && writeFile2,
	      addOrDeleteFileOrDirectory,
	      addOrDeleteFile,
	      clearCache,
	      realpath: host.realpath && realpath
	    };
	    function toPath3(fileName) {
	      return toPath(fileName, currentDirectory, getCanonicalFileName);
	    }
	    function getCachedFileSystemEntries(rootDirPath) {
	      return cachedReadDirectoryResult.get(ensureTrailingDirectorySeparator(rootDirPath));
	    }
	    function getCachedFileSystemEntriesForBaseDir(path) {
	      const entries = getCachedFileSystemEntries(getDirectoryPath(path));
	      if (!entries) {
	        return entries;
	      }
	      if (!entries.sortedAndCanonicalizedFiles) {
	        entries.sortedAndCanonicalizedFiles = entries.files.map(getCanonicalFileName).sort();
	        entries.sortedAndCanonicalizedDirectories = entries.directories.map(getCanonicalFileName).sort();
	      }
	      return entries;
	    }
	    function getBaseNameOfFileName(fileName) {
	      return getBaseFileName(normalizePath(fileName));
	    }
	    function createCachedFileSystemEntries(rootDir, rootDirPath) {
	      var _a;
	      if (!host.realpath || ensureTrailingDirectorySeparator(toPath3(host.realpath(rootDir))) === rootDirPath) {
	        const resultFromHost = {
	          files: map(host.readDirectory(
	            rootDir,
	            /*extensions*/
	            void 0,
	            /*exclude*/
	            void 0,
	            /*include*/
	            ["*.*"]
	          ), getBaseNameOfFileName) || [],
	          directories: host.getDirectories(rootDir) || []
	        };
	        cachedReadDirectoryResult.set(ensureTrailingDirectorySeparator(rootDirPath), resultFromHost);
	        return resultFromHost;
	      }
	      if ((_a = host.directoryExists) == null ? void 0 : _a.call(host, rootDir)) {
	        cachedReadDirectoryResult.set(rootDirPath, false);
	        return false;
	      }
	      return void 0;
	    }
	    function tryReadDirectory2(rootDir, rootDirPath) {
	      rootDirPath = ensureTrailingDirectorySeparator(rootDirPath);
	      const cachedResult = getCachedFileSystemEntries(rootDirPath);
	      if (cachedResult) {
	        return cachedResult;
	      }
	      try {
	        return createCachedFileSystemEntries(rootDir, rootDirPath);
	      } catch (_e) {
	        Debug.assert(!cachedReadDirectoryResult.has(ensureTrailingDirectorySeparator(rootDirPath)));
	        return void 0;
	      }
	    }
	    function hasEntry(entries, name) {
	      const index = binarySearch(entries, name, identity, compareStringsCaseSensitive);
	      return index >= 0;
	    }
	    function writeFile2(fileName, data, writeByteOrderMark) {
	      const path = toPath3(fileName);
	      const result = getCachedFileSystemEntriesForBaseDir(path);
	      if (result) {
	        updateFilesOfFileSystemEntry(
	          result,
	          getBaseNameOfFileName(fileName),
	          /*fileExists*/
	          true
	        );
	      }
	      return host.writeFile(fileName, data, writeByteOrderMark);
	    }
	    function fileExists(fileName) {
	      const path = toPath3(fileName);
	      const result = getCachedFileSystemEntriesForBaseDir(path);
	      return result && hasEntry(result.sortedAndCanonicalizedFiles, getCanonicalFileName(getBaseNameOfFileName(fileName))) || host.fileExists(fileName);
	    }
	    function directoryExists(dirPath) {
	      const path = toPath3(dirPath);
	      return cachedReadDirectoryResult.has(ensureTrailingDirectorySeparator(path)) || host.directoryExists(dirPath);
	    }
	    function createDirectory(dirPath) {
	      const path = toPath3(dirPath);
	      const result = getCachedFileSystemEntriesForBaseDir(path);
	      if (result) {
	        const baseName = getBaseNameOfFileName(dirPath);
	        const canonicalizedBaseName = getCanonicalFileName(baseName);
	        const canonicalizedDirectories = result.sortedAndCanonicalizedDirectories;
	        if (insertSorted(canonicalizedDirectories, canonicalizedBaseName, compareStringsCaseSensitive)) {
	          result.directories.push(baseName);
	        }
	      }
	      host.createDirectory(dirPath);
	    }
	    function getDirectories(rootDir) {
	      const rootDirPath = toPath3(rootDir);
	      const result = tryReadDirectory2(rootDir, rootDirPath);
	      if (result) {
	        return result.directories.slice();
	      }
	      return host.getDirectories(rootDir);
	    }
	    function readDirectory(rootDir, extensions, excludes, includes, depth) {
	      const rootDirPath = toPath3(rootDir);
	      const rootResult = tryReadDirectory2(rootDir, rootDirPath);
	      let rootSymLinkResult;
	      if (rootResult !== void 0) {
	        return matchFiles(rootDir, extensions, excludes, includes, useCaseSensitiveFileNames2, currentDirectory, depth, getFileSystemEntries, realpath);
	      }
	      return host.readDirectory(rootDir, extensions, excludes, includes, depth);
	      function getFileSystemEntries(dir) {
	        const path = toPath3(dir);
	        if (path === rootDirPath) {
	          return rootResult || getFileSystemEntriesFromHost(dir, path);
	        }
	        const result = tryReadDirectory2(dir, path);
	        return result !== void 0 ? result || getFileSystemEntriesFromHost(dir, path) : emptyFileSystemEntries;
	      }
	      function getFileSystemEntriesFromHost(dir, path) {
	        if (rootSymLinkResult && path === rootDirPath)
	          return rootSymLinkResult;
	        const result = {
	          files: map(host.readDirectory(
	            dir,
	            /*extensions*/
	            void 0,
	            /*exclude*/
	            void 0,
	            /*include*/
	            ["*.*"]
	          ), getBaseNameOfFileName) || emptyArray,
	          directories: host.getDirectories(dir) || emptyArray
	        };
	        if (path === rootDirPath)
	          rootSymLinkResult = result;
	        return result;
	      }
	    }
	    function realpath(s) {
	      return host.realpath ? host.realpath(s) : s;
	    }
	    function addOrDeleteFileOrDirectory(fileOrDirectory, fileOrDirectoryPath) {
	      const existingResult = getCachedFileSystemEntries(fileOrDirectoryPath);
	      if (existingResult !== void 0) {
	        clearCache();
	        return void 0;
	      }
	      const parentResult = getCachedFileSystemEntriesForBaseDir(fileOrDirectoryPath);
	      if (!parentResult) {
	        return void 0;
	      }
	      if (!host.directoryExists) {
	        clearCache();
	        return void 0;
	      }
	      const baseName = getBaseNameOfFileName(fileOrDirectory);
	      const fsQueryResult = {
	        fileExists: host.fileExists(fileOrDirectory),
	        directoryExists: host.directoryExists(fileOrDirectory)
	      };
	      if (fsQueryResult.directoryExists || hasEntry(parentResult.sortedAndCanonicalizedDirectories, getCanonicalFileName(baseName))) {
	        clearCache();
	      } else {
	        updateFilesOfFileSystemEntry(parentResult, baseName, fsQueryResult.fileExists);
	      }
	      return fsQueryResult;
	    }
	    function addOrDeleteFile(fileName, filePath, eventKind) {
	      if (eventKind === 1 /* Changed */) {
	        return;
	      }
	      const parentResult = getCachedFileSystemEntriesForBaseDir(filePath);
	      if (parentResult) {
	        updateFilesOfFileSystemEntry(parentResult, getBaseNameOfFileName(fileName), eventKind === 0 /* Created */);
	      }
	    }
	    function updateFilesOfFileSystemEntry(parentResult, baseName, fileExists2) {
	      const canonicalizedFiles = parentResult.sortedAndCanonicalizedFiles;
	      const canonicalizedBaseName = getCanonicalFileName(baseName);
	      if (fileExists2) {
	        if (insertSorted(canonicalizedFiles, canonicalizedBaseName, compareStringsCaseSensitive)) {
	          parentResult.files.push(baseName);
	        }
	      } else {
	        const sortedIndex = binarySearch(canonicalizedFiles, canonicalizedBaseName, identity, compareStringsCaseSensitive);
	        if (sortedIndex >= 0) {
	          canonicalizedFiles.splice(sortedIndex, 1);
	          const unsortedIndex = parentResult.files.findIndex((entry) => getCanonicalFileName(entry) === canonicalizedBaseName);
	          parentResult.files.splice(unsortedIndex, 1);
	        }
	      }
	    }
	    function clearCache() {
	      cachedReadDirectoryResult.clear();
	    }
	  }
	  function updateSharedExtendedConfigFileWatcher(projectPath, options, extendedConfigFilesMap, createExtendedConfigFileWatch, toPath3) {
	    var _a;
	    const extendedConfigs = arrayToMap(((_a = options == null ? void 0 : options.configFile) == null ? void 0 : _a.extendedSourceFiles) || emptyArray, toPath3);
	    extendedConfigFilesMap.forEach((watcher, extendedConfigFilePath) => {
	      if (!extendedConfigs.has(extendedConfigFilePath)) {
	        watcher.projects.delete(projectPath);
	        watcher.close();
	      }
	    });
	    extendedConfigs.forEach((extendedConfigFileName, extendedConfigFilePath) => {
	      const existing = extendedConfigFilesMap.get(extendedConfigFilePath);
	      if (existing) {
	        existing.projects.add(projectPath);
	      } else {
	        extendedConfigFilesMap.set(extendedConfigFilePath, {
	          projects: /* @__PURE__ */ new Set([projectPath]),
	          watcher: createExtendedConfigFileWatch(extendedConfigFileName, extendedConfigFilePath),
	          close: () => {
	            const existing2 = extendedConfigFilesMap.get(extendedConfigFilePath);
	            if (!existing2 || existing2.projects.size !== 0)
	              return;
	            existing2.watcher.close();
	            extendedConfigFilesMap.delete(extendedConfigFilePath);
	          }
	        });
	      }
	    });
	  }
	  function clearSharedExtendedConfigFileWatcher(projectPath, extendedConfigFilesMap) {
	    extendedConfigFilesMap.forEach((watcher) => {
	      if (watcher.projects.delete(projectPath))
	        watcher.close();
	    });
	  }
	  function cleanExtendedConfigCache(extendedConfigCache, extendedConfigFilePath, toPath3) {
	    if (!extendedConfigCache.delete(extendedConfigFilePath))
	      return;
	    extendedConfigCache.forEach(({ extendedResult }, key) => {
	      var _a;
	      if ((_a = extendedResult.extendedSourceFiles) == null ? void 0 : _a.some((extendedFile) => toPath3(extendedFile) === extendedConfigFilePath)) {
	        cleanExtendedConfigCache(extendedConfigCache, key, toPath3);
	      }
	    });
	  }
	  function updateMissingFilePathsWatch(program, missingFileWatches, createMissingFileWatch) {
	    mutateMap(
	      missingFileWatches,
	      program.getMissingFilePaths(),
	      {
	        // Watch the missing files
	        createNewValue: createMissingFileWatch,
	        // Files that are no longer missing (e.g. because they are no longer required)
	        // should no longer be watched.
	        onDeleteValue: closeFileWatcher
	      }
	    );
	  }
	  function updateWatchingWildcardDirectories(existingWatchedForWildcards, wildcardDirectories, watchDirectory) {
	    if (wildcardDirectories) {
	      mutateMap(
	        existingWatchedForWildcards,
	        new Map(Object.entries(wildcardDirectories)),
	        {
	          // Create new watch and recursive info
	          createNewValue: createWildcardDirectoryWatcher,
	          // Close existing watch thats not needed any more
	          onDeleteValue: closeFileWatcherOf,
	          // Close existing watch that doesnt match in the flags
	          onExistingValue: updateWildcardDirectoryWatcher
	        }
	      );
	    } else {
	      clearMap(existingWatchedForWildcards, closeFileWatcherOf);
	    }
	    function createWildcardDirectoryWatcher(directory, flags) {
	      return {
	        watcher: watchDirectory(directory, flags),
	        flags
	      };
	    }
	    function updateWildcardDirectoryWatcher(existingWatcher, flags, directory) {
	      if (existingWatcher.flags === flags) {
	        return;
	      }
	      existingWatcher.watcher.close();
	      existingWatchedForWildcards.set(directory, createWildcardDirectoryWatcher(directory, flags));
	    }
	  }
	  function isIgnoredFileFromWildCardWatching({
	    watchedDirPath,
	    fileOrDirectory,
	    fileOrDirectoryPath,
	    configFileName,
	    options,
	    program,
	    extraFileExtensions,
	    currentDirectory,
	    useCaseSensitiveFileNames: useCaseSensitiveFileNames2,
	    writeLog,
	    toPath: toPath3,
	    getScriptKind: getScriptKind2
	  }) {
	    const newPath = removeIgnoredPath(fileOrDirectoryPath);
	    if (!newPath) {
	      writeLog(`Project: ${configFileName} Detected ignored path: ${fileOrDirectory}`);
	      return true;
	    }
	    fileOrDirectoryPath = newPath;
	    if (fileOrDirectoryPath === watchedDirPath)
	      return false;
	    if (hasExtension(fileOrDirectoryPath) && !(isSupportedSourceFileName(fileOrDirectory, options, extraFileExtensions) || isSupportedScriptKind())) {
	      writeLog(`Project: ${configFileName} Detected file add/remove of non supported extension: ${fileOrDirectory}`);
	      return true;
	    }
	    if (isExcludedFile(fileOrDirectory, options.configFile.configFileSpecs, getNormalizedAbsolutePath(getDirectoryPath(configFileName), currentDirectory), useCaseSensitiveFileNames2, currentDirectory)) {
	      writeLog(`Project: ${configFileName} Detected excluded file: ${fileOrDirectory}`);
	      return true;
	    }
	    if (!program)
	      return false;
	    if (outFile(options) || options.outDir)
	      return false;
	    if (isDeclarationFileName(fileOrDirectoryPath)) {
	      if (options.declarationDir)
	        return false;
	    } else if (!fileExtensionIsOneOf(fileOrDirectoryPath, supportedJSExtensionsFlat)) {
	      return false;
	    }
	    const filePathWithoutExtension = removeFileExtension(fileOrDirectoryPath);
	    const realProgram = isArray(program) ? void 0 : isBuilderProgram(program) ? program.getProgramOrUndefined() : program;
	    const builderProgram = !realProgram && !isArray(program) ? program : void 0;
	    if (hasSourceFile(filePathWithoutExtension + ".ts" /* Ts */) || hasSourceFile(filePathWithoutExtension + ".tsx" /* Tsx */)) {
	      writeLog(`Project: ${configFileName} Detected output file: ${fileOrDirectory}`);
	      return true;
	    }
	    return false;
	    function hasSourceFile(file) {
	      return realProgram ? !!realProgram.getSourceFileByPath(file) : builderProgram ? builderProgram.getState().fileInfos.has(file) : !!find(program, (rootFile) => toPath3(rootFile) === file);
	    }
	    function isSupportedScriptKind() {
	      if (!getScriptKind2)
	        return false;
	      const scriptKind = getScriptKind2(fileOrDirectory);
	      switch (scriptKind) {
	        case 3 /* TS */:
	        case 4 /* TSX */:
	        case 7 /* Deferred */:
	        case 5 /* External */:
	          return true;
	        case 1 /* JS */:
	        case 2 /* JSX */:
	          return getAllowJSCompilerOption(options);
	        case 6 /* JSON */:
	          return getResolveJsonModule(options);
	        case 0 /* Unknown */:
	          return false;
	      }
	    }
	  }
	  function isBuilderProgram(program) {
	    return !!program.getState;
	  }
	  function isEmittedFileOfProgram(program, file) {
	    if (!program) {
	      return false;
	    }
	    return program.isEmittedFile(file);
	  }
	  function getWatchFactory(host, watchLogLevel, log, getDetailWatchInfo2) {
	    setSysLog(watchLogLevel === 2 /* Verbose */ ? log : noop);
	    const plainInvokeFactory = {
	      watchFile: (file, callback, pollingInterval, options) => host.watchFile(file, callback, pollingInterval, options),
	      watchDirectory: (directory, callback, flags, options) => host.watchDirectory(directory, callback, (flags & 1 /* Recursive */) !== 0, options)
	    };
	    const triggerInvokingFactory = watchLogLevel !== 0 /* None */ ? {
	      watchFile: createTriggerLoggingAddWatch("watchFile"),
	      watchDirectory: createTriggerLoggingAddWatch("watchDirectory")
	    } : void 0;
	    const factory2 = watchLogLevel === 2 /* Verbose */ ? {
	      watchFile: createFileWatcherWithLogging,
	      watchDirectory: createDirectoryWatcherWithLogging
	    } : triggerInvokingFactory || plainInvokeFactory;
	    const excludeWatcherFactory = watchLogLevel === 2 /* Verbose */ ? createExcludeWatcherWithLogging : returnNoopFileWatcher;
	    return {
	      watchFile: createExcludeHandlingAddWatch("watchFile"),
	      watchDirectory: createExcludeHandlingAddWatch("watchDirectory")
	    };
	    function createExcludeHandlingAddWatch(key) {
	      return (file, cb, flags, options, detailInfo1, detailInfo2) => {
	        var _a;
	        return !matchesExclude(file, key === "watchFile" ? options == null ? void 0 : options.excludeFiles : options == null ? void 0 : options.excludeDirectories, useCaseSensitiveFileNames2(), ((_a = host.getCurrentDirectory) == null ? void 0 : _a.call(host)) || "") ? factory2[key].call(
	          /*thisArgs*/
	          void 0,
	          file,
	          cb,
	          flags,
	          options,
	          detailInfo1,
	          detailInfo2
	        ) : excludeWatcherFactory(file, flags, options, detailInfo1, detailInfo2);
	      };
	    }
	    function useCaseSensitiveFileNames2() {
	      return typeof host.useCaseSensitiveFileNames === "boolean" ? host.useCaseSensitiveFileNames : host.useCaseSensitiveFileNames();
	    }
	    function createExcludeWatcherWithLogging(file, flags, options, detailInfo1, detailInfo2) {
	      log(`ExcludeWatcher:: Added:: ${getWatchInfo(file, flags, options, detailInfo1, detailInfo2, getDetailWatchInfo2)}`);
	      return {
	        close: () => log(`ExcludeWatcher:: Close:: ${getWatchInfo(file, flags, options, detailInfo1, detailInfo2, getDetailWatchInfo2)}`)
	      };
	    }
	    function createFileWatcherWithLogging(file, cb, flags, options, detailInfo1, detailInfo2) {
	      log(`FileWatcher:: Added:: ${getWatchInfo(file, flags, options, detailInfo1, detailInfo2, getDetailWatchInfo2)}`);
	      const watcher = triggerInvokingFactory.watchFile(file, cb, flags, options, detailInfo1, detailInfo2);
	      return {
	        close: () => {
	          log(`FileWatcher:: Close:: ${getWatchInfo(file, flags, options, detailInfo1, detailInfo2, getDetailWatchInfo2)}`);
	          watcher.close();
	        }
	      };
	    }
	    function createDirectoryWatcherWithLogging(file, cb, flags, options, detailInfo1, detailInfo2) {
	      const watchInfo = `DirectoryWatcher:: Added:: ${getWatchInfo(file, flags, options, detailInfo1, detailInfo2, getDetailWatchInfo2)}`;
	      log(watchInfo);
	      const start = timestamp();
	      const watcher = triggerInvokingFactory.watchDirectory(file, cb, flags, options, detailInfo1, detailInfo2);
	      const elapsed = timestamp() - start;
	      log(`Elapsed:: ${elapsed}ms ${watchInfo}`);
	      return {
	        close: () => {
	          const watchInfo2 = `DirectoryWatcher:: Close:: ${getWatchInfo(file, flags, options, detailInfo1, detailInfo2, getDetailWatchInfo2)}`;
	          log(watchInfo2);
	          const start2 = timestamp();
	          watcher.close();
	          const elapsed2 = timestamp() - start2;
	          log(`Elapsed:: ${elapsed2}ms ${watchInfo2}`);
	        }
	      };
	    }
	    function createTriggerLoggingAddWatch(key) {
	      return (file, cb, flags, options, detailInfo1, detailInfo2) => plainInvokeFactory[key].call(
	        /*thisArgs*/
	        void 0,
	        file,
	        (...args) => {
	          const triggerredInfo = `${key === "watchFile" ? "FileWatcher" : "DirectoryWatcher"}:: Triggered with ${args[0]} ${args[1] !== void 0 ? args[1] : ""}:: ${getWatchInfo(file, flags, options, detailInfo1, detailInfo2, getDetailWatchInfo2)}`;
	          log(triggerredInfo);
	          const start = timestamp();
	          cb.call(
	            /*thisArg*/
	            void 0,
	            ...args
	          );
	          const elapsed = timestamp() - start;
	          log(`Elapsed:: ${elapsed}ms ${triggerredInfo}`);
	        },
	        flags,
	        options,
	        detailInfo1,
	        detailInfo2
	      );
	    }
	    function getWatchInfo(file, flags, options, detailInfo1, detailInfo2, getDetailWatchInfo3) {
	      return `WatchInfo: ${file} ${flags} ${JSON.stringify(options)} ${getDetailWatchInfo3 ? getDetailWatchInfo3(detailInfo1, detailInfo2) : detailInfo2 === void 0 ? detailInfo1 : `${detailInfo1} ${detailInfo2}`}`;
	    }
	  }
	  function getFallbackOptions(options) {
	    const fallbackPolling = options == null ? void 0 : options.fallbackPolling;
	    return {
	      watchFile: fallbackPolling !== void 0 ? fallbackPolling : 1 /* PriorityPollingInterval */
	    };
	  }
	  function closeFileWatcherOf(objWithWatcher) {
	    objWithWatcher.watcher.close();
	  }
	  var ProgramUpdateLevel, WatchLogLevel;
	  var init_watchUtilities = __esm({
	    "src/compiler/watchUtilities.ts"() {
	      init_ts2();
	      ProgramUpdateLevel = /* @__PURE__ */ ((ProgramUpdateLevel2) => {
	        ProgramUpdateLevel2[ProgramUpdateLevel2["Update"] = 0] = "Update";
	        ProgramUpdateLevel2[ProgramUpdateLevel2["RootNamesAndUpdate"] = 1] = "RootNamesAndUpdate";
	        ProgramUpdateLevel2[ProgramUpdateLevel2["Full"] = 2] = "Full";
	        return ProgramUpdateLevel2;
	      })(ProgramUpdateLevel || {});
	      WatchLogLevel = /* @__PURE__ */ ((WatchLogLevel2) => {
	        WatchLogLevel2[WatchLogLevel2["None"] = 0] = "None";
	        WatchLogLevel2[WatchLogLevel2["TriggerOnly"] = 1] = "TriggerOnly";
	        WatchLogLevel2[WatchLogLevel2["Verbose"] = 2] = "Verbose";
	        return WatchLogLevel2;
	      })(WatchLogLevel || {});
	    }
	  });

	  // src/compiler/program.ts
	  function findConfigFile(searchPath, fileExists, configName = "tsconfig.json") {
	    return forEachAncestorDirectory(searchPath, (ancestor) => {
	      const fileName = combinePaths(ancestor, configName);
	      return fileExists(fileName) ? fileName : void 0;
	    });
	  }
	  function resolveTripleslashReference(moduleName, containingFile) {
	    const basePath = getDirectoryPath(containingFile);
	    const referencedFileName = isRootedDiskPath(moduleName) ? moduleName : combinePaths(basePath, moduleName);
	    return normalizePath(referencedFileName);
	  }
	  function computeCommonSourceDirectoryOfFilenames(fileNames, currentDirectory, getCanonicalFileName) {
	    let commonPathComponents;
	    const failed = forEach(fileNames, (sourceFile) => {
	      const sourcePathComponents = getNormalizedPathComponents(sourceFile, currentDirectory);
	      sourcePathComponents.pop();
	      if (!commonPathComponents) {
	        commonPathComponents = sourcePathComponents;
	        return;
	      }
	      const n = Math.min(commonPathComponents.length, sourcePathComponents.length);
	      for (let i = 0; i < n; i++) {
	        if (getCanonicalFileName(commonPathComponents[i]) !== getCanonicalFileName(sourcePathComponents[i])) {
	          if (i === 0) {
	            return true;
	          }
	          commonPathComponents.length = i;
	          break;
	        }
	      }
	      if (sourcePathComponents.length < commonPathComponents.length) {
	        commonPathComponents.length = sourcePathComponents.length;
	      }
	    });
	    if (failed) {
	      return "";
	    }
	    if (!commonPathComponents) {
	      return currentDirectory;
	    }
	    return getPathFromPathComponents(commonPathComponents);
	  }
	  function createCompilerHost(options, setParentNodes) {
	    return createCompilerHostWorker(options, setParentNodes);
	  }
	  function createGetSourceFile(readFile, getCompilerOptions, setParentNodes) {
	    return (fileName, languageVersionOrOptions, onError) => {
	      let text;
	      try {
	        mark("beforeIORead");
	        text = readFile(fileName, getCompilerOptions().charset);
	        mark("afterIORead");
	        measure("I/O Read", "beforeIORead", "afterIORead");
	      } catch (e) {
	        if (onError) {
	          onError(e.message);
	        }
	        text = "";
	      }
	      return text !== void 0 ? createSourceFile(fileName, text, languageVersionOrOptions, setParentNodes) : void 0;
	    };
	  }
	  function createWriteFileMeasuringIO(actualWriteFile, createDirectory, directoryExists) {
	    return (fileName, data, writeByteOrderMark, onError) => {
	      try {
	        mark("beforeIOWrite");
	        writeFileEnsuringDirectories(
	          fileName,
	          data,
	          writeByteOrderMark,
	          actualWriteFile,
	          createDirectory,
	          directoryExists
	        );
	        mark("afterIOWrite");
	        measure("I/O Write", "beforeIOWrite", "afterIOWrite");
	      } catch (e) {
	        if (onError) {
	          onError(e.message);
	        }
	      }
	    };
	  }
	  function createCompilerHostWorker(options, setParentNodes, system = sys) {
	    const existingDirectories = /* @__PURE__ */ new Map();
	    const getCanonicalFileName = createGetCanonicalFileName(system.useCaseSensitiveFileNames);
	    function directoryExists(directoryPath) {
	      if (existingDirectories.has(directoryPath)) {
	        return true;
	      }
	      if ((compilerHost.directoryExists || system.directoryExists)(directoryPath)) {
	        existingDirectories.set(directoryPath, true);
	        return true;
	      }
	      return false;
	    }
	    function getDefaultLibLocation() {
	      return getDirectoryPath(normalizePath(system.getExecutingFilePath()));
	    }
	    const newLine = getNewLineCharacter(options);
	    const realpath = system.realpath && ((path) => system.realpath(path));
	    const compilerHost = {
	      getSourceFile: createGetSourceFile((fileName) => compilerHost.readFile(fileName), () => options, setParentNodes),
	      getDefaultLibLocation,
	      getDefaultLibFileName: (options2) => combinePaths(getDefaultLibLocation(), getDefaultLibFileName(options2)),
	      writeFile: createWriteFileMeasuringIO(
	        (path, data, writeByteOrderMark) => system.writeFile(path, data, writeByteOrderMark),
	        (path) => (compilerHost.createDirectory || system.createDirectory)(path),
	        (path) => directoryExists(path)
	      ),
	      getCurrentDirectory: memoize(() => system.getCurrentDirectory()),
	      useCaseSensitiveFileNames: () => system.useCaseSensitiveFileNames,
	      getCanonicalFileName,
	      getNewLine: () => newLine,
	      fileExists: (fileName) => system.fileExists(fileName),
	      readFile: (fileName) => system.readFile(fileName),
	      trace: (s) => system.write(s + newLine),
	      directoryExists: (directoryName) => system.directoryExists(directoryName),
	      getEnvironmentVariable: (name) => system.getEnvironmentVariable ? system.getEnvironmentVariable(name) : "",
	      getDirectories: (path) => system.getDirectories(path),
	      realpath,
	      readDirectory: (path, extensions, include, exclude, depth) => system.readDirectory(path, extensions, include, exclude, depth),
	      createDirectory: (d) => system.createDirectory(d),
	      createHash: maybeBind(system, system.createHash)
	    };
	    return compilerHost;
	  }
	  function changeCompilerHostLikeToUseCache(host, toPath3, getSourceFile) {
	    const originalReadFile = host.readFile;
	    const originalFileExists = host.fileExists;
	    const originalDirectoryExists = host.directoryExists;
	    const originalCreateDirectory = host.createDirectory;
	    const originalWriteFile = host.writeFile;
	    const readFileCache = /* @__PURE__ */ new Map();
	    const fileExistsCache = /* @__PURE__ */ new Map();
	    const directoryExistsCache = /* @__PURE__ */ new Map();
	    const sourceFileCache = /* @__PURE__ */ new Map();
	    const readFileWithCache = (fileName) => {
	      const key = toPath3(fileName);
	      const value = readFileCache.get(key);
	      if (value !== void 0)
	        return value !== false ? value : void 0;
	      return setReadFileCache(key, fileName);
	    };
	    const setReadFileCache = (key, fileName) => {
	      const newValue = originalReadFile.call(host, fileName);
	      readFileCache.set(key, newValue !== void 0 ? newValue : false);
	      return newValue;
	    };
	    host.readFile = (fileName) => {
	      const key = toPath3(fileName);
	      const value = readFileCache.get(key);
	      if (value !== void 0)
	        return value !== false ? value : void 0;
	      if (!fileExtensionIs(fileName, ".json" /* Json */) && !isBuildInfoFile(fileName)) {
	        return originalReadFile.call(host, fileName);
	      }
	      return setReadFileCache(key, fileName);
	    };
	    const getSourceFileWithCache = getSourceFile ? (fileName, languageVersionOrOptions, onError, shouldCreateNewSourceFile) => {
	      const key = toPath3(fileName);
	      const impliedNodeFormat = typeof languageVersionOrOptions === "object" ? languageVersionOrOptions.impliedNodeFormat : void 0;
	      const forImpliedNodeFormat = sourceFileCache.get(impliedNodeFormat);
	      const value = forImpliedNodeFormat == null ? void 0 : forImpliedNodeFormat.get(key);
	      if (value)
	        return value;
	      const sourceFile = getSourceFile(fileName, languageVersionOrOptions, onError, shouldCreateNewSourceFile);
	      if (sourceFile && (isDeclarationFileName(fileName) || fileExtensionIs(fileName, ".json" /* Json */))) {
	        sourceFileCache.set(impliedNodeFormat, (forImpliedNodeFormat || /* @__PURE__ */ new Map()).set(key, sourceFile));
	      }
	      return sourceFile;
	    } : void 0;
	    host.fileExists = (fileName) => {
	      const key = toPath3(fileName);
	      const value = fileExistsCache.get(key);
	      if (value !== void 0)
	        return value;
	      const newValue = originalFileExists.call(host, fileName);
	      fileExistsCache.set(key, !!newValue);
	      return newValue;
	    };
	    if (originalWriteFile) {
	      host.writeFile = (fileName, data, ...rest) => {
	        const key = toPath3(fileName);
	        fileExistsCache.delete(key);
	        const value = readFileCache.get(key);
	        if (value !== void 0 && value !== data) {
	          readFileCache.delete(key);
	          sourceFileCache.forEach((map2) => map2.delete(key));
	        } else if (getSourceFileWithCache) {
	          sourceFileCache.forEach((map2) => {
	            const sourceFile = map2.get(key);
	            if (sourceFile && sourceFile.text !== data) {
	              map2.delete(key);
	            }
	          });
	        }
	        originalWriteFile.call(host, fileName, data, ...rest);
	      };
	    }
	    if (originalDirectoryExists) {
	      host.directoryExists = (directory) => {
	        const key = toPath3(directory);
	        const value = directoryExistsCache.get(key);
	        if (value !== void 0)
	          return value;
	        const newValue = originalDirectoryExists.call(host, directory);
	        directoryExistsCache.set(key, !!newValue);
	        return newValue;
	      };
	      if (originalCreateDirectory) {
	        host.createDirectory = (directory) => {
	          const key = toPath3(directory);
	          directoryExistsCache.delete(key);
	          originalCreateDirectory.call(host, directory);
	        };
	      }
	    }
	    return {
	      originalReadFile,
	      originalFileExists,
	      originalDirectoryExists,
	      originalCreateDirectory,
	      originalWriteFile,
	      getSourceFileWithCache,
	      readFileWithCache
	    };
	  }
	  function getPreEmitDiagnostics(program, sourceFile, cancellationToken) {
	    let diagnostics;
	    diagnostics = addRange(diagnostics, program.getConfigFileParsingDiagnostics());
	    diagnostics = addRange(diagnostics, program.getOptionsDiagnostics(cancellationToken));
	    diagnostics = addRange(diagnostics, program.getSyntacticDiagnostics(sourceFile, cancellationToken));
	    diagnostics = addRange(diagnostics, program.getGlobalDiagnostics(cancellationToken));
	    diagnostics = addRange(diagnostics, program.getSemanticDiagnostics(sourceFile, cancellationToken));
	    if (getEmitDeclarations(program.getCompilerOptions())) {
	      diagnostics = addRange(diagnostics, program.getDeclarationDiagnostics(sourceFile, cancellationToken));
	    }
	    return sortAndDeduplicateDiagnostics(diagnostics || emptyArray);
	  }
	  function formatDiagnostics(diagnostics, host) {
	    let output = "";
	    for (const diagnostic of diagnostics) {
	      output += formatDiagnostic(diagnostic, host);
	    }
	    return output;
	  }
	  function formatDiagnostic(diagnostic, host) {
	    const errorMessage = `${diagnosticCategoryName(diagnostic)} TS${diagnostic.code}: ${flattenDiagnosticMessageText(diagnostic.messageText, host.getNewLine())}${host.getNewLine()}`;
	    if (diagnostic.file) {
	      const { line, character } = getLineAndCharacterOfPosition(diagnostic.file, diagnostic.start);
	      const fileName = diagnostic.file.fileName;
	      const relativeFileName = convertToRelativePath(fileName, host.getCurrentDirectory(), (fileName2) => host.getCanonicalFileName(fileName2));
	      return `${relativeFileName}(${line + 1},${character + 1}): ` + errorMessage;
	    }
	    return errorMessage;
	  }
	  function getCategoryFormat(category) {
	    switch (category) {
	      case 1 /* Error */:
	        return "\x1B[91m" /* Red */;
	      case 0 /* Warning */:
	        return "\x1B[93m" /* Yellow */;
	      case 2 /* Suggestion */:
	        return Debug.fail("Should never get an Info diagnostic on the command line.");
	      case 3 /* Message */:
	        return "\x1B[94m" /* Blue */;
	    }
	  }
	  function formatColorAndReset(text, formatStyle) {
	    return formatStyle + text + resetEscapeSequence;
	  }
	  function formatCodeSpan(file, start, length2, indent3, squiggleColor, host) {
	    const { line: firstLine, character: firstLineChar } = getLineAndCharacterOfPosition(file, start);
	    const { line: lastLine, character: lastLineChar } = getLineAndCharacterOfPosition(file, start + length2);
	    const lastLineInFile = getLineAndCharacterOfPosition(file, file.text.length).line;
	    const hasMoreThanFiveLines = lastLine - firstLine >= 4;
	    let gutterWidth = (lastLine + 1 + "").length;
	    if (hasMoreThanFiveLines) {
	      gutterWidth = Math.max(ellipsis.length, gutterWidth);
	    }
	    let context = "";
	    for (let i = firstLine; i <= lastLine; i++) {
	      context += host.getNewLine();
	      if (hasMoreThanFiveLines && firstLine + 1 < i && i < lastLine - 1) {
	        context += indent3 + formatColorAndReset(ellipsis.padStart(gutterWidth), gutterStyleSequence) + gutterSeparator + host.getNewLine();
	        i = lastLine - 1;
	      }
	      const lineStart = getPositionOfLineAndCharacter(file, i, 0);
	      const lineEnd = i < lastLineInFile ? getPositionOfLineAndCharacter(file, i + 1, 0) : file.text.length;
	      let lineContent = file.text.slice(lineStart, lineEnd);
	      lineContent = lineContent.trimEnd();
	      lineContent = lineContent.replace(/\t/g, " ");
	      context += indent3 + formatColorAndReset((i + 1 + "").padStart(gutterWidth), gutterStyleSequence) + gutterSeparator;
	      context += lineContent + host.getNewLine();
	      context += indent3 + formatColorAndReset("".padStart(gutterWidth), gutterStyleSequence) + gutterSeparator;
	      context += squiggleColor;
	      if (i === firstLine) {
	        const lastCharForLine = i === lastLine ? lastLineChar : void 0;
	        context += lineContent.slice(0, firstLineChar).replace(/\S/g, " ");
	        context += lineContent.slice(firstLineChar, lastCharForLine).replace(/./g, "~");
	      } else if (i === lastLine) {
	        context += lineContent.slice(0, lastLineChar).replace(/./g, "~");
	      } else {
	        context += lineContent.replace(/./g, "~");
	      }
	      context += resetEscapeSequence;
	    }
	    return context;
	  }
	  function formatLocation(file, start, host, color = formatColorAndReset) {
	    const { line: firstLine, character: firstLineChar } = getLineAndCharacterOfPosition(file, start);
	    const relativeFileName = host ? convertToRelativePath(file.fileName, host.getCurrentDirectory(), (fileName) => host.getCanonicalFileName(fileName)) : file.fileName;
	    let output = "";
	    output += color(relativeFileName, "\x1B[96m" /* Cyan */);
	    output += ":";
	    output += color(`${firstLine + 1}`, "\x1B[93m" /* Yellow */);
	    output += ":";
	    output += color(`${firstLineChar + 1}`, "\x1B[93m" /* Yellow */);
	    return output;
	  }
	  function formatDiagnosticsWithColorAndContext(diagnostics, host) {
	    let output = "";
	    for (const diagnostic of diagnostics) {
	      if (diagnostic.file) {
	        const { file, start } = diagnostic;
	        output += formatLocation(file, start, host);
	        output += " - ";
	      }
	      output += formatColorAndReset(diagnosticCategoryName(diagnostic), getCategoryFormat(diagnostic.category));
	      output += formatColorAndReset(` TS${diagnostic.code}: `, "\x1B[90m" /* Grey */);
	      output += flattenDiagnosticMessageText(diagnostic.messageText, host.getNewLine());
	      if (diagnostic.file && diagnostic.code !== Diagnostics.File_appears_to_be_binary.code) {
	        output += host.getNewLine();
	        output += formatCodeSpan(diagnostic.file, diagnostic.start, diagnostic.length, "", getCategoryFormat(diagnostic.category), host);
	      }
	      if (diagnostic.relatedInformation) {
	        output += host.getNewLine();
	        for (const { file, start, length: length2, messageText } of diagnostic.relatedInformation) {
	          if (file) {
	            output += host.getNewLine();
	            output += halfIndent + formatLocation(file, start, host);
	            output += formatCodeSpan(file, start, length2, indent, "\x1B[96m" /* Cyan */, host);
	          }
	          output += host.getNewLine();
	          output += indent + flattenDiagnosticMessageText(messageText, host.getNewLine());
	        }
	      }
	      output += host.getNewLine();
	    }
	    return output;
	  }
	  function flattenDiagnosticMessageText(diag2, newLine, indent3 = 0) {
	    if (isString(diag2)) {
	      return diag2;
	    } else if (diag2 === void 0) {
	      return "";
	    }
	    let result = "";
	    if (indent3) {
	      result += newLine;
	      for (let i = 0; i < indent3; i++) {
	        result += "  ";
	      }
	    }
	    result += diag2.messageText;
	    indent3++;
	    if (diag2.next) {
	      for (const kid of diag2.next) {
	        result += flattenDiagnosticMessageText(kid, newLine, indent3);
	      }
	    }
	    return result;
	  }
	  function getModeForFileReference(ref, containingFileMode) {
	    return (isString(ref) ? containingFileMode : ref.resolutionMode) || containingFileMode;
	  }
	  function getModeForResolutionAtIndex(file, index, compilerOptions) {
	    return getModeForUsageLocationWorker(file, getModuleNameStringLiteralAt(file, index), compilerOptions);
	  }
	  function isExclusivelyTypeOnlyImportOrExport(decl) {
	    var _a;
	    if (isExportDeclaration(decl)) {
	      return decl.isTypeOnly;
	    }
	    if ((_a = decl.importClause) == null ? void 0 : _a.isTypeOnly) {
	      return true;
	    }
	    return false;
	  }
	  function getModeForUsageLocation(file, usage, compilerOptions) {
	    return getModeForUsageLocationWorker(file, usage, compilerOptions);
	  }
	  function getModeForUsageLocationWorker(file, usage, compilerOptions) {
	    var _a;
	    if (isImportDeclaration(usage.parent) || isExportDeclaration(usage.parent)) {
	      const isTypeOnly = isExclusivelyTypeOnlyImportOrExport(usage.parent);
	      if (isTypeOnly) {
	        const override = getResolutionModeOverride(usage.parent.attributes);
	        if (override) {
	          return override;
	        }
	      }
	    }
	    if (usage.parent.parent && isImportTypeNode(usage.parent.parent)) {
	      const override = getResolutionModeOverride(usage.parent.parent.attributes);
	      if (override) {
	        return override;
	      }
	    }
	    if (compilerOptions && getEmitModuleKind(compilerOptions) === 200 /* Preserve */) {
	      return usage.parent.parent && isImportEqualsDeclaration(usage.parent.parent) || isRequireCall(
	        usage.parent,
	        /*requireStringLiteralLikeArgument*/
	        false
	      ) ? 1 /* CommonJS */ : 99 /* ESNext */;
	    }
	    if (file.impliedNodeFormat === void 0)
	      return void 0;
	    if (file.impliedNodeFormat !== 99 /* ESNext */) {
	      return isImportCall(walkUpParenthesizedExpressions(usage.parent)) ? 99 /* ESNext */ : 1 /* CommonJS */;
	    }
	    const exprParentParent = (_a = walkUpParenthesizedExpressions(usage.parent)) == null ? void 0 : _a.parent;
	    return exprParentParent && isImportEqualsDeclaration(exprParentParent) ? 1 /* CommonJS */ : 99 /* ESNext */;
	  }
	  function getResolutionModeOverride(node, grammarErrorOnNode) {
	    if (!node)
	      return void 0;
	    if (length(node.elements) !== 1) {
	      grammarErrorOnNode == null ? void 0 : grammarErrorOnNode(
	        node,
	        node.token === 118 /* WithKeyword */ ? Diagnostics.Type_import_attributes_should_have_exactly_one_key_resolution_mode_with_value_import_or_require : Diagnostics.Type_import_assertions_should_have_exactly_one_key_resolution_mode_with_value_import_or_require
	      );
	      return void 0;
	    }
	    const elem = node.elements[0];
	    if (!isStringLiteralLike(elem.name))
	      return void 0;
	    if (elem.name.text !== "resolution-mode") {
	      grammarErrorOnNode == null ? void 0 : grammarErrorOnNode(
	        elem.name,
	        node.token === 118 /* WithKeyword */ ? Diagnostics.resolution_mode_is_the_only_valid_key_for_type_import_attributes : Diagnostics.resolution_mode_is_the_only_valid_key_for_type_import_assertions
	      );
	      return void 0;
	    }
	    if (!isStringLiteralLike(elem.value))
	      return void 0;
	    if (elem.value.text !== "import" && elem.value.text !== "require") {
	      grammarErrorOnNode == null ? void 0 : grammarErrorOnNode(elem.value, Diagnostics.resolution_mode_should_be_either_require_or_import);
	      return void 0;
	    }
	    return elem.value.text === "import" ? 99 /* ESNext */ : 1 /* CommonJS */;
	  }
	  function getModuleResolutionName(literal) {
	    return literal.text;
	  }
	  function createModuleResolutionLoader(containingFile, redirectedReference, options, host, cache) {
	    return {
	      nameAndMode: moduleResolutionNameAndModeGetter,
	      resolve: (moduleName, resolutionMode) => resolveModuleName(
	        moduleName,
	        containingFile,
	        options,
	        host,
	        cache,
	        redirectedReference,
	        resolutionMode
	      )
	    };
	  }
	  function getTypeReferenceResolutionName(entry) {
	    return !isString(entry) ? toFileNameLowerCase(entry.fileName) : entry;
	  }
	  function createTypeReferenceResolutionLoader(containingFile, redirectedReference, options, host, cache) {
	    return {
	      nameAndMode: typeReferenceResolutionNameAndModeGetter,
	      resolve: (typeRef, resoluionMode) => resolveTypeReferenceDirective(
	        typeRef,
	        containingFile,
	        options,
	        host,
	        redirectedReference,
	        cache,
	        resoluionMode
	      )
	    };
	  }
	  function loadWithModeAwareCache(entries, containingFile, redirectedReference, options, containingSourceFile, host, resolutionCache, createLoader) {
	    if (entries.length === 0)
	      return emptyArray;
	    const resolutions = [];
	    const cache = /* @__PURE__ */ new Map();
	    const loader = createLoader(containingFile, redirectedReference, options, host, resolutionCache);
	    for (const entry of entries) {
	      const name = loader.nameAndMode.getName(entry);
	      const mode = loader.nameAndMode.getMode(entry, containingSourceFile, (redirectedReference == null ? void 0 : redirectedReference.commandLine.options) || options);
	      const key = createModeAwareCacheKey(name, mode);
	      let result = cache.get(key);
	      if (!result) {
	        cache.set(key, result = loader.resolve(name, mode));
	      }
	      resolutions.push(result);
	    }
	    return resolutions;
	  }
	  function forEachResolvedProjectReference(resolvedProjectReferences, cb) {
	    return forEachProjectReference(
	      /*projectReferences*/
	      void 0,
	      resolvedProjectReferences,
	      (resolvedRef, parent2) => resolvedRef && cb(resolvedRef, parent2)
	    );
	  }
	  function forEachProjectReference(projectReferences, resolvedProjectReferences, cbResolvedRef, cbRef) {
	    let seenResolvedRefs;
	    return worker(
	      projectReferences,
	      resolvedProjectReferences,
	      /*parent*/
	      void 0
	    );
	    function worker(projectReferences2, resolvedProjectReferences2, parent2) {
	      if (cbRef) {
	        const result = cbRef(projectReferences2, parent2);
	        if (result)
	          return result;
	      }
	      return forEach(resolvedProjectReferences2, (resolvedRef, index) => {
	        if (resolvedRef && (seenResolvedRefs == null ? void 0 : seenResolvedRefs.has(resolvedRef.sourceFile.path))) {
	          return void 0;
	        }
	        const result = cbResolvedRef(resolvedRef, parent2, index);
	        if (result || !resolvedRef)
	          return result;
	        (seenResolvedRefs || (seenResolvedRefs = /* @__PURE__ */ new Set())).add(resolvedRef.sourceFile.path);
	        return worker(resolvedRef.commandLine.projectReferences, resolvedRef.references, resolvedRef);
	      });
	    }
	  }
	  function getInferredLibraryNameResolveFrom(options, currentDirectory, libFileName) {
	    const containingDirectory = options.configFilePath ? getDirectoryPath(options.configFilePath) : currentDirectory;
	    return combinePaths(containingDirectory, `__lib_node_modules_lookup_${libFileName}__.ts`);
	  }
	  function getLibraryNameFromLibFileName(libFileName) {
	    const components = libFileName.split(".");
	    let path = components[1];
	    let i = 2;
	    while (components[i] && components[i] !== "d") {
	      path += (i === 2 ? "/" : "-") + components[i];
	      i++;
	    }
	    return "@typescript/lib-" + path;
	  }
	  function getLibFileNameFromLibReference(libReference) {
	    const libName = toFileNameLowerCase(libReference.fileName);
	    const libFileName = libMap.get(libName);
	    return { libName, libFileName };
	  }
	  function isReferencedFile(reason) {
	    switch (reason == null ? void 0 : reason.kind) {
	      case 3 /* Import */:
	      case 4 /* ReferenceFile */:
	      case 5 /* TypeReferenceDirective */:
	      case 7 /* LibReferenceDirective */:
	        return true;
	      default:
	        return false;
	    }
	  }
	  function isReferenceFileLocation(location) {
	    return location.pos !== void 0;
	  }
	  function getReferencedFileLocation(program, ref) {
	    var _a, _b, _c, _d;
	    const file = Debug.checkDefined(program.getSourceFileByPath(ref.file));
	    const { kind, index } = ref;
	    let pos, end, packageId, resolutionMode;
	    switch (kind) {
	      case 3 /* Import */:
	        const importLiteral = getModuleNameStringLiteralAt(file, index);
	        packageId = (_b = (_a = program.getResolvedModule(file, importLiteral.text, program.getModeForUsageLocation(file, importLiteral))) == null ? void 0 : _a.resolvedModule) == null ? void 0 : _b.packageId;
	        if (importLiteral.pos === -1)
	          return { file, packageId, text: importLiteral.text };
	        pos = skipTrivia(file.text, importLiteral.pos);
	        end = importLiteral.end;
	        break;
	      case 4 /* ReferenceFile */:
	        ({ pos, end } = file.referencedFiles[index]);
	        break;
	      case 5 /* TypeReferenceDirective */:
	        ({ pos, end, resolutionMode } = file.typeReferenceDirectives[index]);
	        packageId = (_d = (_c = program.getResolvedTypeReferenceDirective(file, toFileNameLowerCase(file.typeReferenceDirectives[index].fileName), resolutionMode || file.impliedNodeFormat)) == null ? void 0 : _c.resolvedTypeReferenceDirective) == null ? void 0 : _d.packageId;
	        break;
	      case 7 /* LibReferenceDirective */:
	        ({ pos, end } = file.libReferenceDirectives[index]);
	        break;
	      default:
	        return Debug.assertNever(kind);
	    }
	    return { file, pos, end, packageId };
	  }
	  function isProgramUptoDate(program, rootFileNames, newOptions, getSourceVersion, fileExists, hasInvalidatedResolutions, hasInvalidatedLibResolutions, hasChangedAutomaticTypeDirectiveNames, getParsedCommandLine, projectReferences) {
	    if (!program || (hasChangedAutomaticTypeDirectiveNames == null ? void 0 : hasChangedAutomaticTypeDirectiveNames()))
	      return false;
	    if (!arrayIsEqualTo(program.getRootFileNames(), rootFileNames))
	      return false;
	    let seenResolvedRefs;
	    if (!arrayIsEqualTo(program.getProjectReferences(), projectReferences, projectReferenceUptoDate))
	      return false;
	    if (program.getSourceFiles().some(sourceFileNotUptoDate))
	      return false;
	    const missingPaths = program.getMissingFilePaths();
	    if (missingPaths && forEachEntry(missingPaths, fileExists))
	      return false;
	    const currentOptions = program.getCompilerOptions();
	    if (!compareDataObjects(currentOptions, newOptions))
	      return false;
	    if (program.resolvedLibReferences && forEachEntry(program.resolvedLibReferences, (_value, libFileName) => hasInvalidatedLibResolutions(libFileName)))
	      return false;
	    if (currentOptions.configFile && newOptions.configFile)
	      return currentOptions.configFile.text === newOptions.configFile.text;
	    return true;
	    function sourceFileNotUptoDate(sourceFile) {
	      return !sourceFileVersionUptoDate(sourceFile) || hasInvalidatedResolutions(sourceFile.path);
	    }
	    function sourceFileVersionUptoDate(sourceFile) {
	      return sourceFile.version === getSourceVersion(sourceFile.resolvedPath, sourceFile.fileName);
	    }
	    function projectReferenceUptoDate(oldRef, newRef, index) {
	      return projectReferenceIsEqualTo(oldRef, newRef) && resolvedProjectReferenceUptoDate(program.getResolvedProjectReferences()[index], oldRef);
	    }
	    function resolvedProjectReferenceUptoDate(oldResolvedRef, oldRef) {
	      if (oldResolvedRef) {
	        if (contains(seenResolvedRefs, oldResolvedRef))
	          return true;
	        const refPath2 = resolveProjectReferencePath(oldRef);
	        const newParsedCommandLine = getParsedCommandLine(refPath2);
	        if (!newParsedCommandLine)
	          return false;
	        if (oldResolvedRef.commandLine.options.configFile !== newParsedCommandLine.options.configFile)
	          return false;
	        if (!arrayIsEqualTo(oldResolvedRef.commandLine.fileNames, newParsedCommandLine.fileNames))
	          return false;
	        (seenResolvedRefs || (seenResolvedRefs = [])).push(oldResolvedRef);
	        return !forEach(oldResolvedRef.references, (childResolvedRef, index) => !resolvedProjectReferenceUptoDate(childResolvedRef, oldResolvedRef.commandLine.projectReferences[index]));
	      }
	      const refPath = resolveProjectReferencePath(oldRef);
	      return !getParsedCommandLine(refPath);
	    }
	  }
	  function getConfigFileParsingDiagnostics(configFileParseResult) {
	    return configFileParseResult.options.configFile ? [...configFileParseResult.options.configFile.parseDiagnostics, ...configFileParseResult.errors] : configFileParseResult.errors;
	  }
	  function getImpliedNodeFormatForFile(fileName, packageJsonInfoCache, host, options) {
	    const result = getImpliedNodeFormatForFileWorker(fileName, packageJsonInfoCache, host, options);
	    return typeof result === "object" ? result.impliedNodeFormat : result;
	  }
	  function getImpliedNodeFormatForFileWorker(fileName, packageJsonInfoCache, host, options) {
	    switch (getEmitModuleResolutionKind(options)) {
	      case 3 /* Node16 */:
	      case 99 /* NodeNext */:
	        return fileExtensionIsOneOf(fileName, [".d.mts" /* Dmts */, ".mts" /* Mts */, ".mjs" /* Mjs */]) ? 99 /* ESNext */ : fileExtensionIsOneOf(fileName, [".d.cts" /* Dcts */, ".cts" /* Cts */, ".cjs" /* Cjs */]) ? 1 /* CommonJS */ : fileExtensionIsOneOf(fileName, [".d.ts" /* Dts */, ".ts" /* Ts */, ".tsx" /* Tsx */, ".js" /* Js */, ".jsx" /* Jsx */]) ? lookupFromPackageJson() : void 0;
	      default:
	        return void 0;
	    }
	    function lookupFromPackageJson() {
	      const state = getTemporaryModuleResolutionState(packageJsonInfoCache, host, options);
	      const packageJsonLocations = [];
	      state.failedLookupLocations = packageJsonLocations;
	      state.affectingLocations = packageJsonLocations;
	      const packageJsonScope = getPackageScopeForPath(fileName, state);
	      const impliedNodeFormat = (packageJsonScope == null ? void 0 : packageJsonScope.contents.packageJsonContent.type) === "module" ? 99 /* ESNext */ : 1 /* CommonJS */;
	      return { impliedNodeFormat, packageJsonLocations, packageJsonScope };
	    }
	  }
	  function shouldProgramCreateNewSourceFiles(program, newOptions) {
	    if (!program)
	      return false;
	    return optionsHaveChanges(program.getCompilerOptions(), newOptions, sourceFileAffectingCompilerOptions);
	  }
	  function createCreateProgramOptions(rootNames, options, host, oldProgram, configFileParsingDiagnostics, typeScriptVersion3) {
	    return {
	      rootNames,
	      options,
	      host,
	      oldProgram,
	      configFileParsingDiagnostics,
	      typeScriptVersion: typeScriptVersion3
	    };
	  }
	  function createProgram(rootNamesOrOptions, _options, _host, _oldProgram, _configFileParsingDiagnostics) {
	    var _a, _b, _c, _d, _e, _f, _g, _h, _i, _j, _k, _l, _m, _n, _o, _p;
	    const createProgramOptions = isArray(rootNamesOrOptions) ? createCreateProgramOptions(rootNamesOrOptions, _options, _host, _oldProgram, _configFileParsingDiagnostics) : rootNamesOrOptions;
	    const { rootNames, options, configFileParsingDiagnostics, projectReferences, typeScriptVersion: typeScriptVersion3 } = createProgramOptions;
	    let { oldProgram } = createProgramOptions;
	    const reportInvalidIgnoreDeprecations = memoize(() => createOptionValueDiagnostic("ignoreDeprecations", Diagnostics.Invalid_value_for_ignoreDeprecations));
	    let processingDefaultLibFiles;
	    let processingOtherFiles;
	    let files;
	    let symlinks;
	    let commonSourceDirectory;
	    let typeChecker;
	    let classifiableNames;
	    const ambientModuleNameToUnmodifiedFileName = /* @__PURE__ */ new Map();
	    let fileReasons = createMultiMap();
	    const cachedBindAndCheckDiagnosticsForFile = {};
	    const cachedDeclarationDiagnosticsForFile = {};
	    let resolvedTypeReferenceDirectives = createModeAwareCache();
	    let fileProcessingDiagnostics;
	    let automaticTypeDirectiveNames;
	    let automaticTypeDirectiveResolutions;
	    let resolvedLibReferences;
	    let resolvedLibProcessing;
	    let resolvedModules;
	    let resolvedModulesProcessing;
	    let resolvedTypeReferenceDirectiveNames;
	    let resolvedTypeReferenceDirectiveNamesProcessing;
	    let packageMap;
	    const maxNodeModuleJsDepth = typeof options.maxNodeModuleJsDepth === "number" ? options.maxNodeModuleJsDepth : 0;
	    let currentNodeModulesDepth = 0;
	    const modulesWithElidedImports = /* @__PURE__ */ new Map();
	    const sourceFilesFoundSearchingNodeModules = /* @__PURE__ */ new Map();
	    (_a = tracing) == null ? void 0 : _a.push(
	      tracing.Phase.Program,
	      "createProgram",
	      { configFilePath: options.configFilePath, rootDir: options.rootDir },
	      /*separateBeginAndEnd*/
	      true
	    );
	    mark("beforeProgram");
	    const host = createProgramOptions.host || createCompilerHost(options);
	    const configParsingHost = parseConfigHostFromCompilerHostLike(host);
	    let skipDefaultLib = options.noLib;
	    const getDefaultLibraryFileName = memoize(() => host.getDefaultLibFileName(options));
	    const defaultLibraryPath = host.getDefaultLibLocation ? host.getDefaultLibLocation() : getDirectoryPath(getDefaultLibraryFileName());
	    const programDiagnostics = createDiagnosticCollection();
	    const currentDirectory = host.getCurrentDirectory();
	    const supportedExtensions = getSupportedExtensions(options);
	    const supportedExtensionsWithJsonIfResolveJsonModule = getSupportedExtensionsWithJsonIfResolveJsonModule(options, supportedExtensions);
	    const hasEmitBlockingDiagnostics = /* @__PURE__ */ new Map();
	    let _compilerOptionsObjectLiteralSyntax;
	    let moduleResolutionCache;
	    let actualResolveModuleNamesWorker;
	    const hasInvalidatedResolutions = host.hasInvalidatedResolutions || returnFalse;
	    if (host.resolveModuleNameLiterals) {
	      actualResolveModuleNamesWorker = host.resolveModuleNameLiterals.bind(host);
	      moduleResolutionCache = (_b = host.getModuleResolutionCache) == null ? void 0 : _b.call(host);
	    } else if (host.resolveModuleNames) {
	      actualResolveModuleNamesWorker = (moduleNames, containingFile, redirectedReference, options2, containingSourceFile, reusedNames) => host.resolveModuleNames(
	        moduleNames.map(getModuleResolutionName),
	        containingFile,
	        reusedNames == null ? void 0 : reusedNames.map(getModuleResolutionName),
	        redirectedReference,
	        options2,
	        containingSourceFile
	      ).map(
	        (resolved) => resolved ? resolved.extension !== void 0 ? { resolvedModule: resolved } : (
	          // An older host may have omitted extension, in which case we should infer it from the file extension of resolvedFileName.
	          { resolvedModule: { ...resolved, extension: extensionFromPath(resolved.resolvedFileName) } }
	        ) : emptyResolution
	      );
	      moduleResolutionCache = (_c = host.getModuleResolutionCache) == null ? void 0 : _c.call(host);
	    } else {
	      moduleResolutionCache = createModuleResolutionCache(currentDirectory, getCanonicalFileName, options);
	      actualResolveModuleNamesWorker = (moduleNames, containingFile, redirectedReference, options2, containingSourceFile) => loadWithModeAwareCache(
	        moduleNames,
	        containingFile,
	        redirectedReference,
	        options2,
	        containingSourceFile,
	        host,
	        moduleResolutionCache,
	        createModuleResolutionLoader
	      );
	    }
	    let actualResolveTypeReferenceDirectiveNamesWorker;
	    if (host.resolveTypeReferenceDirectiveReferences) {
	      actualResolveTypeReferenceDirectiveNamesWorker = host.resolveTypeReferenceDirectiveReferences.bind(host);
	    } else if (host.resolveTypeReferenceDirectives) {
	      actualResolveTypeReferenceDirectiveNamesWorker = (typeDirectiveNames, containingFile, redirectedReference, options2, containingSourceFile) => host.resolveTypeReferenceDirectives(
	        typeDirectiveNames.map(getTypeReferenceResolutionName),
	        containingFile,
	        redirectedReference,
	        options2,
	        containingSourceFile == null ? void 0 : containingSourceFile.impliedNodeFormat
	      ).map((resolvedTypeReferenceDirective) => ({ resolvedTypeReferenceDirective }));
	    } else {
	      const typeReferenceDirectiveResolutionCache = createTypeReferenceDirectiveResolutionCache(
	        currentDirectory,
	        getCanonicalFileName,
	        /*options*/
	        void 0,
	        moduleResolutionCache == null ? void 0 : moduleResolutionCache.getPackageJsonInfoCache(),
	        moduleResolutionCache == null ? void 0 : moduleResolutionCache.optionsToRedirectsKey
	      );
	      actualResolveTypeReferenceDirectiveNamesWorker = (typeDirectiveNames, containingFile, redirectedReference, options2, containingSourceFile) => loadWithModeAwareCache(
	        typeDirectiveNames,
	        containingFile,
	        redirectedReference,
	        options2,
	        containingSourceFile,
	        host,
	        typeReferenceDirectiveResolutionCache,
	        createTypeReferenceResolutionLoader
	      );
	    }
	    const hasInvalidatedLibResolutions = host.hasInvalidatedLibResolutions || returnFalse;
	    let actualResolveLibrary;
	    if (host.resolveLibrary) {
	      actualResolveLibrary = host.resolveLibrary.bind(host);
	    } else {
	      const libraryResolutionCache = createModuleResolutionCache(currentDirectory, getCanonicalFileName, options, moduleResolutionCache == null ? void 0 : moduleResolutionCache.getPackageJsonInfoCache());
	      actualResolveLibrary = (libraryName, resolveFrom, options2) => resolveLibrary(libraryName, resolveFrom, options2, host, libraryResolutionCache);
	    }
	    const packageIdToSourceFile = /* @__PURE__ */ new Map();
	    let sourceFileToPackageName = /* @__PURE__ */ new Map();
	    let redirectTargetsMap = createMultiMap();
	    let usesUriStyleNodeCoreModules = false;
	    const filesByName = /* @__PURE__ */ new Map();
	    let missingFileNames = /* @__PURE__ */ new Map();
	    const filesByNameIgnoreCase = host.useCaseSensitiveFileNames() ? /* @__PURE__ */ new Map() : void 0;
	    let resolvedProjectReferences;
	    let projectReferenceRedirects;
	    let mapFromFileToProjectReferenceRedirects;
	    let mapFromToProjectReferenceRedirectSource;
	    const useSourceOfProjectReferenceRedirect = !!((_d = host.useSourceOfProjectReferenceRedirect) == null ? void 0 : _d.call(host)) && !options.disableSourceOfProjectReferenceRedirect;
	    const { onProgramCreateComplete, fileExists, directoryExists } = updateHostForUseSourceOfProjectReferenceRedirect({
	      compilerHost: host,
	      getSymlinkCache,
	      useSourceOfProjectReferenceRedirect,
	      toPath: toPath3,
	      getResolvedProjectReferences,
	      getSourceOfProjectReferenceRedirect,
	      forEachResolvedProjectReference: forEachResolvedProjectReference2
	    });
	    const readFile = host.readFile.bind(host);
	    (_e = tracing) == null ? void 0 : _e.push(tracing.Phase.Program, "shouldProgramCreateNewSourceFiles", { hasOldProgram: !!oldProgram });
	    const shouldCreateNewSourceFile = shouldProgramCreateNewSourceFiles(oldProgram, options);
	    (_f = tracing) == null ? void 0 : _f.pop();
	    let structureIsReused;
	    (_g = tracing) == null ? void 0 : _g.push(tracing.Phase.Program, "tryReuseStructureFromOldProgram", {});
	    structureIsReused = tryReuseStructureFromOldProgram();
	    (_h = tracing) == null ? void 0 : _h.pop();
	    if (structureIsReused !== 2 /* Completely */) {
	      processingDefaultLibFiles = [];
	      processingOtherFiles = [];
	      if (projectReferences) {
	        if (!resolvedProjectReferences) {
	          resolvedProjectReferences = projectReferences.map(parseProjectReferenceConfigFile);
	        }
	        if (rootNames.length) {
	          resolvedProjectReferences == null ? void 0 : resolvedProjectReferences.forEach((parsedRef, index) => {
	            if (!parsedRef)
	              return;
	            const out = outFile(parsedRef.commandLine.options);
	            if (useSourceOfProjectReferenceRedirect) {
	              if (out || getEmitModuleKind(parsedRef.commandLine.options) === 0 /* None */) {
	                for (const fileName of parsedRef.commandLine.fileNames) {
	                  processProjectReferenceFile(fileName, { kind: 1 /* SourceFromProjectReference */, index });
	                }
	              }
	            } else {
	              if (out) {
	                processProjectReferenceFile(changeExtension(out, ".d.ts"), { kind: 2 /* OutputFromProjectReference */, index });
	              } else if (getEmitModuleKind(parsedRef.commandLine.options) === 0 /* None */) {
	                const getCommonSourceDirectory3 = memoize(() => getCommonSourceDirectoryOfConfig(parsedRef.commandLine, !host.useCaseSensitiveFileNames()));
	                for (const fileName of parsedRef.commandLine.fileNames) {
	                  if (!isDeclarationFileName(fileName) && !fileExtensionIs(fileName, ".json" /* Json */)) {
	                    processProjectReferenceFile(getOutputDeclarationFileName(fileName, parsedRef.commandLine, !host.useCaseSensitiveFileNames(), getCommonSourceDirectory3), { kind: 2 /* OutputFromProjectReference */, index });
	                  }
	                }
	              }
	            }
	          });
	        }
	      }
	      (_i = tracing) == null ? void 0 : _i.push(tracing.Phase.Program, "processRootFiles", { count: rootNames.length });
	      forEach(rootNames, (name, index) => processRootFile(
	        name,
	        /*isDefaultLib*/
	        false,
	        /*ignoreNoDefaultLib*/
	        false,
	        { kind: 0 /* RootFile */, index }
	      ));
	      (_j = tracing) == null ? void 0 : _j.pop();
	      automaticTypeDirectiveNames ?? (automaticTypeDirectiveNames = rootNames.length ? getAutomaticTypeDirectiveNames(options, host) : emptyArray);
	      automaticTypeDirectiveResolutions = createModeAwareCache();
	      if (automaticTypeDirectiveNames.length) {
	        (_k = tracing) == null ? void 0 : _k.push(tracing.Phase.Program, "processTypeReferences", { count: automaticTypeDirectiveNames.length });
	        const containingDirectory = options.configFilePath ? getDirectoryPath(options.configFilePath) : currentDirectory;
	        const containingFilename = combinePaths(containingDirectory, inferredTypesContainingFile);
	        const resolutions = resolveTypeReferenceDirectiveNamesReusingOldState(automaticTypeDirectiveNames, containingFilename);
	        for (let i = 0; i < automaticTypeDirectiveNames.length; i++) {
	          automaticTypeDirectiveResolutions.set(
	            automaticTypeDirectiveNames[i],
	            /*mode*/
	            void 0,
	            resolutions[i]
	          );
	          processTypeReferenceDirective(
	            automaticTypeDirectiveNames[i],
	            /*mode*/
	            void 0,
	            resolutions[i],
	            {
	              kind: 8 /* AutomaticTypeDirectiveFile */,
	              typeReference: automaticTypeDirectiveNames[i],
	              packageId: (_m = (_l = resolutions[i]) == null ? void 0 : _l.resolvedTypeReferenceDirective) == null ? void 0 : _m.packageId
	            }
	          );
	        }
	        (_n = tracing) == null ? void 0 : _n.pop();
	      }
	      if (rootNames.length && !skipDefaultLib) {
	        const defaultLibraryFileName = getDefaultLibraryFileName();
	        if (!options.lib && defaultLibraryFileName) {
	          processRootFile(
	            defaultLibraryFileName,
	            /*isDefaultLib*/
	            true,
	            /*ignoreNoDefaultLib*/
	            false,
	            { kind: 6 /* LibFile */ }
	          );
	        } else {
	          forEach(options.lib, (libFileName, index) => {
	            processRootFile(
	              pathForLibFile(libFileName),
	              /*isDefaultLib*/
	              true,
	              /*ignoreNoDefaultLib*/
	              false,
	              { kind: 6 /* LibFile */, index }
	            );
	          });
	        }
	      }
	      files = stableSort(processingDefaultLibFiles, compareDefaultLibFiles).concat(processingOtherFiles);
	      processingDefaultLibFiles = void 0;
	      processingOtherFiles = void 0;
	    }
	    if (oldProgram && host.onReleaseOldSourceFile) {
	      const oldSourceFiles = oldProgram.getSourceFiles();
	      for (const oldSourceFile of oldSourceFiles) {
	        const newFile = getSourceFileByPath(oldSourceFile.resolvedPath);
	        if (shouldCreateNewSourceFile || !newFile || newFile.impliedNodeFormat !== oldSourceFile.impliedNodeFormat || // old file wasn't redirect but new file is
	        oldSourceFile.resolvedPath === oldSourceFile.path && newFile.resolvedPath !== oldSourceFile.path) {
	          host.onReleaseOldSourceFile(oldSourceFile, oldProgram.getCompilerOptions(), !!getSourceFileByPath(oldSourceFile.path));
	        }
	      }
	      if (!host.getParsedCommandLine) {
	        oldProgram.forEachResolvedProjectReference((resolvedProjectReference) => {
	          if (!getResolvedProjectReferenceByPath(resolvedProjectReference.sourceFile.path)) {
	            host.onReleaseOldSourceFile(
	              resolvedProjectReference.sourceFile,
	              oldProgram.getCompilerOptions(),
	              /*hasSourceFileByPath*/
	              false
	            );
	          }
	        });
	      }
	    }
	    if (oldProgram && host.onReleaseParsedCommandLine) {
	      forEachProjectReference(
	        oldProgram.getProjectReferences(),
	        oldProgram.getResolvedProjectReferences(),
	        (oldResolvedRef, parent2, index) => {
	          const oldReference = (parent2 == null ? void 0 : parent2.commandLine.projectReferences[index]) || oldProgram.getProjectReferences()[index];
	          const oldRefPath = resolveProjectReferencePath(oldReference);
	          if (!(projectReferenceRedirects == null ? void 0 : projectReferenceRedirects.has(toPath3(oldRefPath)))) {
	            host.onReleaseParsedCommandLine(oldRefPath, oldResolvedRef, oldProgram.getCompilerOptions());
	          }
	        }
	      );
	    }
	    oldProgram = void 0;
	    resolvedLibProcessing = void 0;
	    resolvedModulesProcessing = void 0;
	    resolvedTypeReferenceDirectiveNamesProcessing = void 0;
	    const program = {
	      getRootFileNames: () => rootNames,
	      getSourceFile,
	      getSourceFileByPath,
	      getSourceFiles: () => files,
	      getMissingFilePaths: () => missingFileNames,
	      getModuleResolutionCache: () => moduleResolutionCache,
	      getFilesByNameMap: () => filesByName,
	      getCompilerOptions: () => options,
	      getSyntacticDiagnostics,
	      getOptionsDiagnostics,
	      getGlobalDiagnostics,
	      getSemanticDiagnostics,
	      getCachedSemanticDiagnostics,
	      getSuggestionDiagnostics,
	      getDeclarationDiagnostics: getDeclarationDiagnostics2,
	      getBindAndCheckDiagnostics,
	      getProgramDiagnostics,
	      getTypeChecker,
	      getClassifiableNames,
	      getCommonSourceDirectory: getCommonSourceDirectory2,
	      emit,
	      getCurrentDirectory: () => currentDirectory,
	      getNodeCount: () => getTypeChecker().getNodeCount(),
	      getIdentifierCount: () => getTypeChecker().getIdentifierCount(),
	      getSymbolCount: () => getTypeChecker().getSymbolCount(),
	      getTypeCount: () => getTypeChecker().getTypeCount(),
	      getInstantiationCount: () => getTypeChecker().getInstantiationCount(),
	      getRelationCacheSizes: () => getTypeChecker().getRelationCacheSizes(),
	      getFileProcessingDiagnostics: () => fileProcessingDiagnostics,
	      getResolvedTypeReferenceDirectives: () => resolvedTypeReferenceDirectives,
	      getAutomaticTypeDirectiveNames: () => automaticTypeDirectiveNames,
	      getAutomaticTypeDirectiveResolutions: () => automaticTypeDirectiveResolutions,
	      isSourceFileFromExternalLibrary,
	      isSourceFileDefaultLibrary,
	      getModeForUsageLocation: getModeForUsageLocation2,
	      getModeForResolutionAtIndex: getModeForResolutionAtIndex2,
	      getSourceFileFromReference,
	      getLibFileFromReference,
	      sourceFileToPackageName,
	      redirectTargetsMap,
	      usesUriStyleNodeCoreModules,
	      resolvedModules,
	      resolvedTypeReferenceDirectiveNames,
	      resolvedLibReferences,
	      getResolvedModule,
	      getResolvedModuleFromModuleSpecifier,
	      getResolvedTypeReferenceDirective,
	      forEachResolvedModule,
	      forEachResolvedTypeReferenceDirective,
	      getCurrentPackagesMap: () => packageMap,
	      typesPackageExists,
	      packageBundlesTypes,
	      isEmittedFile,
	      getConfigFileParsingDiagnostics: getConfigFileParsingDiagnostics2,
	      getProjectReferences,
	      getResolvedProjectReferences,
	      getProjectReferenceRedirect,
	      getResolvedProjectReferenceToRedirect,
	      getResolvedProjectReferenceByPath,
	      forEachResolvedProjectReference: forEachResolvedProjectReference2,
	      isSourceOfProjectReferenceRedirect,
	      emitBuildInfo,
	      fileExists,
	      readFile,
	      directoryExists,
	      getSymlinkCache,
	      realpath: (_o = host.realpath) == null ? void 0 : _o.bind(host),
	      useCaseSensitiveFileNames: () => host.useCaseSensitiveFileNames(),
	      getCanonicalFileName,
	      getFileIncludeReasons: () => fileReasons,
	      structureIsReused,
	      writeFile: writeFile2
	    };
	    onProgramCreateComplete();
	    fileProcessingDiagnostics == null ? void 0 : fileProcessingDiagnostics.forEach((diagnostic) => {
	      switch (diagnostic.kind) {
	        case 1 /* FilePreprocessingFileExplainingDiagnostic */:
	          return programDiagnostics.add(createDiagnosticExplainingFile(diagnostic.file && getSourceFileByPath(diagnostic.file), diagnostic.fileProcessingReason, diagnostic.diagnostic, diagnostic.args || emptyArray));
	        case 0 /* FilePreprocessingReferencedDiagnostic */:
	          const { file, pos, end } = getReferencedFileLocation(program, diagnostic.reason);
	          return programDiagnostics.add(createFileDiagnostic(file, Debug.checkDefined(pos), Debug.checkDefined(end) - pos, diagnostic.diagnostic, ...diagnostic.args || emptyArray));
	        case 2 /* ResolutionDiagnostics */:
	          return diagnostic.diagnostics.forEach((d) => programDiagnostics.add(d));
	        default:
	          Debug.assertNever(diagnostic);
	      }
	    });
	    verifyCompilerOptions();
	    mark("afterProgram");
	    measure("Program", "beforeProgram", "afterProgram");
	    (_p = tracing) == null ? void 0 : _p.pop();
	    return program;
	    function getResolvedModule(file, moduleName, mode) {
	      var _a2;
	      return (_a2 = resolvedModules == null ? void 0 : resolvedModules.get(file.path)) == null ? void 0 : _a2.get(moduleName, mode);
	    }
	    function getResolvedModuleFromModuleSpecifier(moduleSpecifier) {
	      const sourceFile = getSourceFileOfNode(moduleSpecifier);
	      Debug.assertIsDefined(sourceFile, "`moduleSpecifier` must have a `SourceFile` ancestor. Use `program.getResolvedModule` instead to provide the containing file and resolution mode.");
	      return getResolvedModule(sourceFile, moduleSpecifier.text, getModeForUsageLocation2(sourceFile, moduleSpecifier));
	    }
	    function getResolvedTypeReferenceDirective(file, typeDirectiveName, mode) {
	      var _a2;
	      return (_a2 = resolvedTypeReferenceDirectiveNames == null ? void 0 : resolvedTypeReferenceDirectiveNames.get(file.path)) == null ? void 0 : _a2.get(typeDirectiveName, mode);
	    }
	    function forEachResolvedModule(callback, file) {
	      forEachResolution(resolvedModules, callback, file);
	    }
	    function forEachResolvedTypeReferenceDirective(callback, file) {
	      forEachResolution(resolvedTypeReferenceDirectiveNames, callback, file);
	    }
	    function forEachResolution(resolutionCache, callback, file) {
	      var _a2;
	      if (file)
	        (_a2 = resolutionCache == null ? void 0 : resolutionCache.get(file.path)) == null ? void 0 : _a2.forEach((resolution, name, mode) => callback(resolution, name, mode, file.path));
	      else
	        resolutionCache == null ? void 0 : resolutionCache.forEach((resolutions, filePath) => resolutions.forEach((resolution, name, mode) => callback(resolution, name, mode, filePath)));
	    }
	    function getPackagesMap() {
	      if (packageMap)
	        return packageMap;
	      packageMap = /* @__PURE__ */ new Map();
	      forEachResolvedModule(({ resolvedModule }) => {
	        if (resolvedModule == null ? void 0 : resolvedModule.packageId)
	          packageMap.set(resolvedModule.packageId.name, resolvedModule.extension === ".d.ts" /* Dts */ || !!packageMap.get(resolvedModule.packageId.name));
	      });
	      return packageMap;
	    }
	    function typesPackageExists(packageName) {
	      return getPackagesMap().has(getTypesPackageName(packageName));
	    }
	    function packageBundlesTypes(packageName) {
	      return !!getPackagesMap().get(packageName);
	    }
	    function addResolutionDiagnostics(resolution) {
	      var _a2;
	      if (!((_a2 = resolution.resolutionDiagnostics) == null ? void 0 : _a2.length))
	        return;
	      (fileProcessingDiagnostics ?? (fileProcessingDiagnostics = [])).push({
	        kind: 2 /* ResolutionDiagnostics */,
	        diagnostics: resolution.resolutionDiagnostics
	      });
	    }
	    function addResolutionDiagnosticsFromResolutionOrCache(containingFile, name, resolution, mode) {
	      if (host.resolveModuleNameLiterals || !host.resolveModuleNames)
	        return addResolutionDiagnostics(resolution);
	      if (!moduleResolutionCache || isExternalModuleNameRelative(name))
	        return;
	      const containingFileName = getNormalizedAbsolutePath(containingFile.originalFileName, currentDirectory);
	      const containingDir = getDirectoryPath(containingFileName);
	      const redirectedReference = getRedirectReferenceForResolution(containingFile);
	      const fromCache = moduleResolutionCache.getFromNonRelativeNameCache(name, mode, containingDir, redirectedReference);
	      if (fromCache)
	        addResolutionDiagnostics(fromCache);
	    }
	    function resolveModuleNamesWorker(moduleNames, containingFile, reusedNames) {
	      var _a2, _b2;
	      if (!moduleNames.length)
	        return emptyArray;
	      const containingFileName = getNormalizedAbsolutePath(containingFile.originalFileName, currentDirectory);
	      const redirectedReference = getRedirectReferenceForResolution(containingFile);
	      (_a2 = tracing) == null ? void 0 : _a2.push(tracing.Phase.Program, "resolveModuleNamesWorker", { containingFileName });
	      mark("beforeResolveModule");
	      const result = actualResolveModuleNamesWorker(moduleNames, containingFileName, redirectedReference, options, containingFile, reusedNames);
	      mark("afterResolveModule");
	      measure("ResolveModule", "beforeResolveModule", "afterResolveModule");
	      (_b2 = tracing) == null ? void 0 : _b2.pop();
	      return result;
	    }
	    function resolveTypeReferenceDirectiveNamesWorker(typeDirectiveNames, containingFile, reusedNames) {
	      var _a2, _b2;
	      if (!typeDirectiveNames.length)
	        return [];
	      const containingSourceFile = !isString(containingFile) ? containingFile : void 0;
	      const containingFileName = !isString(containingFile) ? getNormalizedAbsolutePath(containingFile.originalFileName, currentDirectory) : containingFile;
	      const redirectedReference = containingSourceFile && getRedirectReferenceForResolution(containingSourceFile);
	      (_a2 = tracing) == null ? void 0 : _a2.push(tracing.Phase.Program, "resolveTypeReferenceDirectiveNamesWorker", { containingFileName });
	      mark("beforeResolveTypeReference");
	      const result = actualResolveTypeReferenceDirectiveNamesWorker(typeDirectiveNames, containingFileName, redirectedReference, options, containingSourceFile, reusedNames);
	      mark("afterResolveTypeReference");
	      measure("ResolveTypeReference", "beforeResolveTypeReference", "afterResolveTypeReference");
	      (_b2 = tracing) == null ? void 0 : _b2.pop();
	      return result;
	    }
	    function getRedirectReferenceForResolution(file) {
	      const redirect = getResolvedProjectReferenceToRedirect(file.originalFileName);
	      if (redirect || !isDeclarationFileName(file.originalFileName))
	        return redirect;
	      const resultFromDts = getRedirectReferenceForResolutionFromSourceOfProject(file.path);
	      if (resultFromDts)
	        return resultFromDts;
	      if (!host.realpath || !options.preserveSymlinks || !file.originalFileName.includes(nodeModulesPathPart))
	        return void 0;
	      const realDeclarationPath = toPath3(host.realpath(file.originalFileName));
	      return realDeclarationPath === file.path ? void 0 : getRedirectReferenceForResolutionFromSourceOfProject(realDeclarationPath);
	    }
	    function getRedirectReferenceForResolutionFromSourceOfProject(filePath) {
	      const source = getSourceOfProjectReferenceRedirect(filePath);
	      if (isString(source))
	        return getResolvedProjectReferenceToRedirect(source);
	      if (!source)
	        return void 0;
	      return forEachResolvedProjectReference2((resolvedRef) => {
	        const out = outFile(resolvedRef.commandLine.options);
	        if (!out)
	          return void 0;
	        return toPath3(out) === filePath ? resolvedRef : void 0;
	      });
	    }
	    function compareDefaultLibFiles(a, b) {
	      return compareValues(getDefaultLibFilePriority(a), getDefaultLibFilePriority(b));
	    }
	    function getDefaultLibFilePriority(a) {
	      if (containsPath(
	        defaultLibraryPath,
	        a.fileName,
	        /*ignoreCase*/
	        false
	      )) {
	        const basename = getBaseFileName(a.fileName);
	        if (basename === "lib.d.ts" || basename === "lib.es6.d.ts")
	          return 0;
	        const name = removeSuffix(removePrefix(basename, "lib."), ".d.ts");
	        const index = libs.indexOf(name);
	        if (index !== -1)
	          return index + 1;
	      }
	      return libs.length + 2;
	    }
	    function toPath3(fileName) {
	      return toPath(fileName, currentDirectory, getCanonicalFileName);
	    }
	    function getCommonSourceDirectory2() {
	      if (commonSourceDirectory === void 0) {
	        const emittedFiles = filter(files, (file) => sourceFileMayBeEmitted(file, program));
	        commonSourceDirectory = getCommonSourceDirectory(
	          options,
	          () => mapDefined(emittedFiles, (file) => file.isDeclarationFile ? void 0 : file.fileName),
	          currentDirectory,
	          getCanonicalFileName,
	          (commonSourceDirectory2) => checkSourceFilesBelongToPath(emittedFiles, commonSourceDirectory2)
	        );
	      }
	      return commonSourceDirectory;
	    }
	    function getClassifiableNames() {
	      var _a2;
	      if (!classifiableNames) {
	        getTypeChecker();
	        classifiableNames = /* @__PURE__ */ new Set();
	        for (const sourceFile of files) {
	          (_a2 = sourceFile.classifiableNames) == null ? void 0 : _a2.forEach((value) => classifiableNames.add(value));
	        }
	      }
	      return classifiableNames;
	    }
	    function resolveModuleNamesReusingOldState(moduleNames, file) {
	      if (structureIsReused === 0 /* Not */ && !file.ambientModuleNames.length) {
	        return resolveModuleNamesWorker(
	          moduleNames,
	          file,
	          /*reusedNames*/
	          void 0
	        );
	      }
	      let unknownModuleNames;
	      let result;
	      let reusedNames;
	      const predictedToResolveToAmbientModuleMarker = emptyResolution;
	      const oldSourceFile = oldProgram && oldProgram.getSourceFile(file.fileName);
	      for (let i = 0; i < moduleNames.length; i++) {
	        const moduleName = moduleNames[i];
	        if (file === oldSourceFile && !hasInvalidatedResolutions(file.path)) {
	          const oldResolution = oldProgram == null ? void 0 : oldProgram.getResolvedModule(file, moduleName.text, getModeForUsageLocation2(file, moduleName));
	          if (oldResolution == null ? void 0 : oldResolution.resolvedModule) {
	            if (isTraceEnabled(options, host)) {
	              trace(
	                host,
	                oldResolution.resolvedModule.packageId ? Diagnostics.Reusing_resolution_of_module_0_from_1_of_old_program_it_was_successfully_resolved_to_2_with_Package_ID_3 : Diagnostics.Reusing_resolution_of_module_0_from_1_of_old_program_it_was_successfully_resolved_to_2,
	                moduleName.text,
	                getNormalizedAbsolutePath(file.originalFileName, currentDirectory),
	                oldResolution.resolvedModule.resolvedFileName,
	                oldResolution.resolvedModule.packageId && packageIdToString(oldResolution.resolvedModule.packageId)
	              );
	            }
	            (result ?? (result = new Array(moduleNames.length)))[i] = oldResolution;
	            (reusedNames ?? (reusedNames = [])).push(moduleName);
	            continue;
	          }
	        }
	        let resolvesToAmbientModuleInNonModifiedFile = false;
	        if (contains(file.ambientModuleNames, moduleName.text)) {
	          resolvesToAmbientModuleInNonModifiedFile = true;
	          if (isTraceEnabled(options, host)) {
	            trace(host, Diagnostics.Module_0_was_resolved_as_locally_declared_ambient_module_in_file_1, moduleName.text, getNormalizedAbsolutePath(file.originalFileName, currentDirectory));
	          }
	        } else {
	          resolvesToAmbientModuleInNonModifiedFile = moduleNameResolvesToAmbientModuleInNonModifiedFile(moduleName);
	        }
	        if (resolvesToAmbientModuleInNonModifiedFile) {
	          (result || (result = new Array(moduleNames.length)))[i] = predictedToResolveToAmbientModuleMarker;
	        } else {
	          (unknownModuleNames ?? (unknownModuleNames = [])).push(moduleName);
	        }
	      }
	      const resolutions = unknownModuleNames && unknownModuleNames.length ? resolveModuleNamesWorker(unknownModuleNames, file, reusedNames) : emptyArray;
	      if (!result) {
	        Debug.assert(resolutions.length === moduleNames.length);
	        return resolutions;
	      }
	      let j = 0;
	      for (let i = 0; i < result.length; i++) {
	        if (!result[i]) {
	          result[i] = resolutions[j];
	          j++;
	        }
	      }
	      Debug.assert(j === resolutions.length);
	      return result;
	      function moduleNameResolvesToAmbientModuleInNonModifiedFile(moduleName) {
	        var _a2;
	        const resolutionToFile = (_a2 = oldProgram == null ? void 0 : oldProgram.getResolvedModule(file, moduleName.text, getModeForUsageLocation2(file, moduleName))) == null ? void 0 : _a2.resolvedModule;
	        const resolvedFile = resolutionToFile && oldProgram.getSourceFile(resolutionToFile.resolvedFileName);
	        if (resolutionToFile && resolvedFile) {
	          return false;
	        }
	        const unmodifiedFile = ambientModuleNameToUnmodifiedFileName.get(moduleName.text);
	        if (!unmodifiedFile) {
	          return false;
	        }
	        if (isTraceEnabled(options, host)) {
	          trace(host, Diagnostics.Module_0_was_resolved_as_ambient_module_declared_in_1_since_this_file_was_not_modified, moduleName.text, unmodifiedFile);
	        }
	        return true;
	      }
	    }
	    function resolveTypeReferenceDirectiveNamesReusingOldState(typeDirectiveNames, containingFile) {
	      var _a2;
	      if (structureIsReused === 0 /* Not */) {
	        return resolveTypeReferenceDirectiveNamesWorker(
	          typeDirectiveNames,
	          containingFile,
	          /*reusedNames*/
	          void 0
	        );
	      }
	      let unknownTypeReferenceDirectiveNames;
	      let result;
	      let reusedNames;
	      const containingSourceFile = !isString(containingFile) ? containingFile : void 0;
	      const oldSourceFile = !isString(containingFile) ? oldProgram && oldProgram.getSourceFile(containingFile.fileName) : void 0;
	      const canReuseResolutions = !isString(containingFile) ? containingFile === oldSourceFile && !hasInvalidatedResolutions(containingFile.path) : !hasInvalidatedResolutions(toPath3(containingFile));
	      for (let i = 0; i < typeDirectiveNames.length; i++) {
	        const entry = typeDirectiveNames[i];
	        if (canReuseResolutions) {
	          const typeDirectiveName = getTypeReferenceResolutionName(entry);
	          const mode = getModeForFileReference(entry, containingSourceFile == null ? void 0 : containingSourceFile.impliedNodeFormat);
	          const oldResolution = !isString(containingFile) ? oldProgram == null ? void 0 : oldProgram.getResolvedTypeReferenceDirective(containingFile, typeDirectiveName, mode) : (_a2 = oldProgram == null ? void 0 : oldProgram.getAutomaticTypeDirectiveResolutions()) == null ? void 0 : _a2.get(typeDirectiveName, mode);
	          if (oldResolution == null ? void 0 : oldResolution.resolvedTypeReferenceDirective) {
	            if (isTraceEnabled(options, host)) {
	              trace(
	                host,
	                oldResolution.resolvedTypeReferenceDirective.packageId ? Diagnostics.Reusing_resolution_of_type_reference_directive_0_from_1_of_old_program_it_was_successfully_resolved_to_2_with_Package_ID_3 : Diagnostics.Reusing_resolution_of_type_reference_directive_0_from_1_of_old_program_it_was_successfully_resolved_to_2,
	                typeDirectiveName,
	                !isString(containingFile) ? getNormalizedAbsolutePath(containingFile.originalFileName, currentDirectory) : containingFile,
	                oldResolution.resolvedTypeReferenceDirective.resolvedFileName,
	                oldResolution.resolvedTypeReferenceDirective.packageId && packageIdToString(oldResolution.resolvedTypeReferenceDirective.packageId)
	              );
	            }
	            (result ?? (result = new Array(typeDirectiveNames.length)))[i] = oldResolution;
	            (reusedNames ?? (reusedNames = [])).push(entry);
	            continue;
	          }
	        }
	        (unknownTypeReferenceDirectiveNames ?? (unknownTypeReferenceDirectiveNames = [])).push(entry);
	      }
	      if (!unknownTypeReferenceDirectiveNames)
	        return result || emptyArray;
	      const resolutions = resolveTypeReferenceDirectiveNamesWorker(
	        unknownTypeReferenceDirectiveNames,
	        containingFile,
	        reusedNames
	      );
	      if (!result) {
	        Debug.assert(resolutions.length === typeDirectiveNames.length);
	        return resolutions;
	      }
	      let j = 0;
	      for (let i = 0; i < result.length; i++) {
	        if (!result[i]) {
	          result[i] = resolutions[j];
	          j++;
	        }
	      }
	      Debug.assert(j === resolutions.length);
	      return result;
	    }
	    function canReuseProjectReferences() {
	      return !forEachProjectReference(
	        oldProgram.getProjectReferences(),
	        oldProgram.getResolvedProjectReferences(),
	        (oldResolvedRef, parent2, index) => {
	          const newRef = (parent2 ? parent2.commandLine.projectReferences : projectReferences)[index];
	          const newResolvedRef = parseProjectReferenceConfigFile(newRef);
	          if (oldResolvedRef) {
	            return !newResolvedRef || newResolvedRef.sourceFile !== oldResolvedRef.sourceFile || !arrayIsEqualTo(oldResolvedRef.commandLine.fileNames, newResolvedRef.commandLine.fileNames);
	          } else {
	            return newResolvedRef !== void 0;
	          }
	        },
	        (oldProjectReferences, parent2) => {
	          const newReferences = parent2 ? getResolvedProjectReferenceByPath(parent2.sourceFile.path).commandLine.projectReferences : projectReferences;
	          return !arrayIsEqualTo(oldProjectReferences, newReferences, projectReferenceIsEqualTo);
	        }
	      );
	    }
	    function tryReuseStructureFromOldProgram() {
	      var _a2;
	      if (!oldProgram) {
	        return 0 /* Not */;
	      }
	      const oldOptions = oldProgram.getCompilerOptions();
	      if (changesAffectModuleResolution(oldOptions, options)) {
	        return 0 /* Not */;
	      }
	      const oldRootNames = oldProgram.getRootFileNames();
	      if (!arrayIsEqualTo(oldRootNames, rootNames)) {
	        return 0 /* Not */;
	      }
	      if (!canReuseProjectReferences()) {
	        return 0 /* Not */;
	      }
	      if (projectReferences) {
	        resolvedProjectReferences = projectReferences.map(parseProjectReferenceConfigFile);
	      }
	      const newSourceFiles = [];
	      const modifiedSourceFiles = [];
	      structureIsReused = 2 /* Completely */;
	      if (forEachEntry(oldProgram.getMissingFilePaths(), (missingFileName) => host.fileExists(missingFileName))) {
	        return 0 /* Not */;
	      }
	      const oldSourceFiles = oldProgram.getSourceFiles();
	      let SeenPackageName;
	      ((SeenPackageName2) => {
	        SeenPackageName2[SeenPackageName2["Exists"] = 0] = "Exists";
	        SeenPackageName2[SeenPackageName2["Modified"] = 1] = "Modified";
	      })(SeenPackageName || (SeenPackageName = {}));
	      const seenPackageNames = /* @__PURE__ */ new Map();
	      for (const oldSourceFile of oldSourceFiles) {
	        const sourceFileOptions = getCreateSourceFileOptions(oldSourceFile.fileName, moduleResolutionCache, host, options);
	        let newSourceFile = host.getSourceFileByPath ? host.getSourceFileByPath(
	          oldSourceFile.fileName,
	          oldSourceFile.resolvedPath,
	          sourceFileOptions,
	          /*onError*/
	          void 0,
	          shouldCreateNewSourceFile
	        ) : host.getSourceFile(
	          oldSourceFile.fileName,
	          sourceFileOptions,
	          /*onError*/
	          void 0,
	          shouldCreateNewSourceFile
	        );
	        if (!newSourceFile) {
	          return 0 /* Not */;
	        }
	        newSourceFile.packageJsonLocations = ((_a2 = sourceFileOptions.packageJsonLocations) == null ? void 0 : _a2.length) ? sourceFileOptions.packageJsonLocations : void 0;
	        newSourceFile.packageJsonScope = sourceFileOptions.packageJsonScope;
	        Debug.assert(!newSourceFile.redirectInfo, "Host should not return a redirect source file from `getSourceFile`");
	        let fileChanged;
	        if (oldSourceFile.redirectInfo) {
	          if (newSourceFile !== oldSourceFile.redirectInfo.unredirected) {
	            return 0 /* Not */;
	          }
	          fileChanged = false;
	          newSourceFile = oldSourceFile;
	        } else if (oldProgram.redirectTargetsMap.has(oldSourceFile.path)) {
	          if (newSourceFile !== oldSourceFile) {
	            return 0 /* Not */;
	          }
	          fileChanged = false;
	        } else {
	          fileChanged = newSourceFile !== oldSourceFile;
	        }
	        newSourceFile.path = oldSourceFile.path;
	        newSourceFile.originalFileName = oldSourceFile.originalFileName;
	        newSourceFile.resolvedPath = oldSourceFile.resolvedPath;
	        newSourceFile.fileName = oldSourceFile.fileName;
	        const packageName = oldProgram.sourceFileToPackageName.get(oldSourceFile.path);
	        if (packageName !== void 0) {
	          const prevKind = seenPackageNames.get(packageName);
	          const newKind = fileChanged ? 1 /* Modified */ : 0 /* Exists */;
	          if (prevKind !== void 0 && newKind === 1 /* Modified */ || prevKind === 1 /* Modified */) {
	            return 0 /* Not */;
	          }
	          seenPackageNames.set(packageName, newKind);
	        }
	        if (fileChanged) {
	          if (oldSourceFile.impliedNodeFormat !== newSourceFile.impliedNodeFormat) {
	            structureIsReused = 1 /* SafeModules */;
	          } else if (!arrayIsEqualTo(oldSourceFile.libReferenceDirectives, newSourceFile.libReferenceDirectives, fileReferenceIsEqualTo)) {
	            structureIsReused = 1 /* SafeModules */;
	          } else if (oldSourceFile.hasNoDefaultLib !== newSourceFile.hasNoDefaultLib) {
	            structureIsReused = 1 /* SafeModules */;
	          } else if (!arrayIsEqualTo(oldSourceFile.referencedFiles, newSourceFile.referencedFiles, fileReferenceIsEqualTo)) {
	            structureIsReused = 1 /* SafeModules */;
	          } else {
	            collectExternalModuleReferences(newSourceFile);
	            if (!arrayIsEqualTo(oldSourceFile.imports, newSourceFile.imports, moduleNameIsEqualTo)) {
	              structureIsReused = 1 /* SafeModules */;
	            } else if (!arrayIsEqualTo(oldSourceFile.moduleAugmentations, newSourceFile.moduleAugmentations, moduleNameIsEqualTo)) {
	              structureIsReused = 1 /* SafeModules */;
	            } else if ((oldSourceFile.flags & 12582912 /* PermanentlySetIncrementalFlags */) !== (newSourceFile.flags & 12582912 /* PermanentlySetIncrementalFlags */)) {
	              structureIsReused = 1 /* SafeModules */;
	            } else if (!arrayIsEqualTo(oldSourceFile.typeReferenceDirectives, newSourceFile.typeReferenceDirectives, fileReferenceIsEqualTo)) {
	              structureIsReused = 1 /* SafeModules */;
	            }
	          }
	          modifiedSourceFiles.push(newSourceFile);
	        } else if (hasInvalidatedResolutions(oldSourceFile.path)) {
	          structureIsReused = 1 /* SafeModules */;
	          modifiedSourceFiles.push(newSourceFile);
	        } else {
	          for (const moduleName of oldSourceFile.ambientModuleNames) {
	            ambientModuleNameToUnmodifiedFileName.set(moduleName, oldSourceFile.fileName);
	          }
	        }
	        newSourceFiles.push(newSourceFile);
	      }
	      if (structureIsReused !== 2 /* Completely */) {
	        return structureIsReused;
	      }
	      for (const newSourceFile of modifiedSourceFiles) {
	        const moduleNames = getModuleNames(newSourceFile);
	        const resolutions = resolveModuleNamesReusingOldState(moduleNames, newSourceFile);
	        (resolvedModulesProcessing ?? (resolvedModulesProcessing = /* @__PURE__ */ new Map())).set(newSourceFile.path, resolutions);
	        const resolutionsChanged = hasChangesInResolutions(
	          moduleNames,
	          resolutions,
	          (name) => oldProgram.getResolvedModule(newSourceFile, name.text, getModeForUsageLocation2(newSourceFile, name)),
	          moduleResolutionIsEqualTo
	        );
	        if (resolutionsChanged)
	          structureIsReused = 1 /* SafeModules */;
	        const typesReferenceDirectives = newSourceFile.typeReferenceDirectives;
	        const typeReferenceResolutions = resolveTypeReferenceDirectiveNamesReusingOldState(typesReferenceDirectives, newSourceFile);
	        (resolvedTypeReferenceDirectiveNamesProcessing ?? (resolvedTypeReferenceDirectiveNamesProcessing = /* @__PURE__ */ new Map())).set(newSourceFile.path, typeReferenceResolutions);
	        const typeReferenceResolutionsChanged = hasChangesInResolutions(
	          typesReferenceDirectives,
	          typeReferenceResolutions,
	          (name) => oldProgram.getResolvedTypeReferenceDirective(newSourceFile, getTypeReferenceResolutionName(name), getModeForFileReference(name, newSourceFile.impliedNodeFormat)),
	          typeDirectiveIsEqualTo
	        );
	        if (typeReferenceResolutionsChanged)
	          structureIsReused = 1 /* SafeModules */;
	      }
	      if (structureIsReused !== 2 /* Completely */) {
	        return structureIsReused;
	      }
	      if (changesAffectingProgramStructure(oldOptions, options)) {
	        return 1 /* SafeModules */;
	      }
	      if (oldProgram.resolvedLibReferences && forEachEntry(oldProgram.resolvedLibReferences, (resolution, libFileName) => pathForLibFileWorker(libFileName).actual !== resolution.actual)) {
	        return 1 /* SafeModules */;
	      }
	      if (host.hasChangedAutomaticTypeDirectiveNames) {
	        if (host.hasChangedAutomaticTypeDirectiveNames())
	          return 1 /* SafeModules */;
	      } else {
	        automaticTypeDirectiveNames = getAutomaticTypeDirectiveNames(options, host);
	        if (!arrayIsEqualTo(oldProgram.getAutomaticTypeDirectiveNames(), automaticTypeDirectiveNames))
	          return 1 /* SafeModules */;
	      }
	      missingFileNames = oldProgram.getMissingFilePaths();
	      Debug.assert(newSourceFiles.length === oldProgram.getSourceFiles().length);
	      for (const newSourceFile of newSourceFiles) {
	        filesByName.set(newSourceFile.path, newSourceFile);
	      }
	      const oldFilesByNameMap = oldProgram.getFilesByNameMap();
	      oldFilesByNameMap.forEach((oldFile, path) => {
	        if (!oldFile) {
	          filesByName.set(path, oldFile);
	          return;
	        }
	        if (oldFile.path === path) {
	          if (oldProgram.isSourceFileFromExternalLibrary(oldFile)) {
	            sourceFilesFoundSearchingNodeModules.set(oldFile.path, true);
	          }
	          return;
	        }
	        filesByName.set(path, filesByName.get(oldFile.path));
	      });
	      files = newSourceFiles;
	      fileReasons = oldProgram.getFileIncludeReasons();
	      fileProcessingDiagnostics = oldProgram.getFileProcessingDiagnostics();
	      resolvedTypeReferenceDirectives = oldProgram.getResolvedTypeReferenceDirectives();
	      automaticTypeDirectiveNames = oldProgram.getAutomaticTypeDirectiveNames();
	      automaticTypeDirectiveResolutions = oldProgram.getAutomaticTypeDirectiveResolutions();
	      sourceFileToPackageName = oldProgram.sourceFileToPackageName;
	      redirectTargetsMap = oldProgram.redirectTargetsMap;
	      usesUriStyleNodeCoreModules = oldProgram.usesUriStyleNodeCoreModules;
	      resolvedModules = oldProgram.resolvedModules;
	      resolvedTypeReferenceDirectiveNames = oldProgram.resolvedTypeReferenceDirectiveNames;
	      resolvedLibReferences = oldProgram.resolvedLibReferences;
	      packageMap = oldProgram.getCurrentPackagesMap();
	      return 2 /* Completely */;
	    }
	    function getEmitHost(writeFileCallback) {
	      return {
	        getPrependNodes,
	        getCanonicalFileName,
	        getCommonSourceDirectory: program.getCommonSourceDirectory,
	        getCompilerOptions: program.getCompilerOptions,
	        getCurrentDirectory: () => currentDirectory,
	        getSourceFile: program.getSourceFile,
	        getSourceFileByPath: program.getSourceFileByPath,
	        getSourceFiles: program.getSourceFiles,
	        getLibFileFromReference: program.getLibFileFromReference,
	        isSourceFileFromExternalLibrary,
	        getResolvedProjectReferenceToRedirect,
	        getProjectReferenceRedirect,
	        isSourceOfProjectReferenceRedirect,
	        getSymlinkCache,
	        writeFile: writeFileCallback || writeFile2,
	        isEmitBlocked,
	        readFile: (f) => host.readFile(f),
	        fileExists: (f) => {
	          const path = toPath3(f);
	          if (getSourceFileByPath(path))
	            return true;
	          if (missingFileNames.has(path))
	            return false;
	          return host.fileExists(f);
	        },
	        useCaseSensitiveFileNames: () => host.useCaseSensitiveFileNames(),
	        getBuildInfo: (bundle) => {
	          var _a2;
	          return (_a2 = program.getBuildInfo) == null ? void 0 : _a2.call(program, bundle);
	        },
	        getSourceFileFromReference: (file, ref) => program.getSourceFileFromReference(file, ref),
	        redirectTargetsMap,
	        getFileIncludeReasons: program.getFileIncludeReasons,
	        createHash: maybeBind(host, host.createHash)
	      };
	    }
	    function writeFile2(fileName, text, writeByteOrderMark, onError, sourceFiles, data) {
	      host.writeFile(fileName, text, writeByteOrderMark, onError, sourceFiles, data);
	    }
	    function emitBuildInfo(writeFileCallback) {
	      var _a2, _b2;
	      Debug.assert(!outFile(options));
	      (_a2 = tracing) == null ? void 0 : _a2.push(
	        tracing.Phase.Emit,
	        "emitBuildInfo",
	        {},
	        /*separateBeginAndEnd*/
	        true
	      );
	      mark("beforeEmit");
	      const emitResult = emitFiles(
	        notImplementedResolver,
	        getEmitHost(writeFileCallback),
	        /*targetSourceFile*/
	        void 0,
	        /*transformers*/
	        noTransformers,
	        /*emitOnly*/
	        false,
	        /*onlyBuildInfo*/
	        true
	      );
	      mark("afterEmit");
	      measure("Emit", "beforeEmit", "afterEmit");
	      (_b2 = tracing) == null ? void 0 : _b2.pop();
	      return emitResult;
	    }
	    function getResolvedProjectReferences() {
	      return resolvedProjectReferences;
	    }
	    function getProjectReferences() {
	      return projectReferences;
	    }
	    function getPrependNodes() {
	      return createPrependNodes(
	        projectReferences,
	        (_ref, index) => {
	          var _a2;
	          return (_a2 = resolvedProjectReferences[index]) == null ? void 0 : _a2.commandLine;
	        },
	        (fileName) => {
	          const path = toPath3(fileName);
	          const sourceFile = getSourceFileByPath(path);
	          return sourceFile ? sourceFile.text : filesByName.has(path) ? void 0 : host.readFile(path);
	        },
	        host
	      );
	    }
	    function isSourceFileFromExternalLibrary(file) {
	      return !!sourceFilesFoundSearchingNodeModules.get(file.path);
	    }
	    function isSourceFileDefaultLibrary(file) {
	      if (!file.isDeclarationFile) {
	        return false;
	      }
	      if (file.hasNoDefaultLib) {
	        return true;
	      }
	      if (!options.noLib) {
	        return false;
	      }
	      const equalityComparer = host.useCaseSensitiveFileNames() ? equateStringsCaseSensitive : equateStringsCaseInsensitive;
	      if (!options.lib) {
	        return equalityComparer(file.fileName, getDefaultLibraryFileName());
	      } else {
	        return some(options.lib, (libFileName) => equalityComparer(file.fileName, resolvedLibReferences.get(libFileName).actual));
	      }
	    }
	    function getTypeChecker() {
	      return typeChecker || (typeChecker = createTypeChecker(program));
	    }
	    function emit(sourceFile, writeFileCallback, cancellationToken, emitOnly, transformers, forceDtsEmit) {
	      var _a2, _b2;
	      (_a2 = tracing) == null ? void 0 : _a2.push(
	        tracing.Phase.Emit,
	        "emit",
	        { path: sourceFile == null ? void 0 : sourceFile.path },
	        /*separateBeginAndEnd*/
	        true
	      );
	      const result = runWithCancellationToken(() => emitWorker(program, sourceFile, writeFileCallback, cancellationToken, emitOnly, transformers, forceDtsEmit));
	      (_b2 = tracing) == null ? void 0 : _b2.pop();
	      return result;
	    }
	    function isEmitBlocked(emitFileName) {
	      return hasEmitBlockingDiagnostics.has(toPath3(emitFileName));
	    }
	    function emitWorker(program2, sourceFile, writeFileCallback, cancellationToken, emitOnly, customTransformers, forceDtsEmit) {
	      if (!forceDtsEmit) {
	        const result = handleNoEmitOptions(program2, sourceFile, writeFileCallback, cancellationToken);
	        if (result)
	          return result;
	      }
	      const emitResolver = getTypeChecker().getEmitResolver(outFile(options) ? void 0 : sourceFile, cancellationToken);
	      mark("beforeEmit");
	      const emitResult = emitFiles(
	        emitResolver,
	        getEmitHost(writeFileCallback),
	        sourceFile,
	        getTransformers(options, customTransformers, emitOnly),
	        emitOnly,
	        /*onlyBuildInfo*/
	        false,
	        forceDtsEmit
	      );
	      mark("afterEmit");
	      measure("Emit", "beforeEmit", "afterEmit");
	      return emitResult;
	    }
	    function getSourceFile(fileName) {
	      return getSourceFileByPath(toPath3(fileName));
	    }
	    function getSourceFileByPath(path) {
	      return filesByName.get(path) || void 0;
	    }
	    function getDiagnosticsHelper(sourceFile, getDiagnostics2, cancellationToken) {
	      if (sourceFile) {
	        return sortAndDeduplicateDiagnostics(getDiagnostics2(sourceFile, cancellationToken));
	      }
	      return sortAndDeduplicateDiagnostics(flatMap(program.getSourceFiles(), (sourceFile2) => {
	        if (cancellationToken) {
	          cancellationToken.throwIfCancellationRequested();
	        }
	        return getDiagnostics2(sourceFile2, cancellationToken);
	      }));
	    }
	    function getSyntacticDiagnostics(sourceFile, cancellationToken) {
	      return getDiagnosticsHelper(sourceFile, getSyntacticDiagnosticsForFile, cancellationToken);
	    }
	    function getSemanticDiagnostics(sourceFile, cancellationToken) {
	      return getDiagnosticsHelper(sourceFile, getSemanticDiagnosticsForFile, cancellationToken);
	    }
	    function getCachedSemanticDiagnostics(sourceFile) {
	      var _a2;
	      return sourceFile ? (_a2 = cachedBindAndCheckDiagnosticsForFile.perFile) == null ? void 0 : _a2.get(sourceFile.path) : cachedBindAndCheckDiagnosticsForFile.allDiagnostics;
	    }
	    function getBindAndCheckDiagnostics(sourceFile, cancellationToken) {
	      return getBindAndCheckDiagnosticsForFile(sourceFile, cancellationToken);
	    }
	    function getProgramDiagnostics(sourceFile) {
	      var _a2;
	      if (skipTypeChecking(sourceFile, options, program)) {
	        return emptyArray;
	      }
	      const programDiagnosticsInFile = programDiagnostics.getDiagnostics(sourceFile.fileName);
	      if (!((_a2 = sourceFile.commentDirectives) == null ? void 0 : _a2.length)) {
	        return programDiagnosticsInFile;
	      }
	      return getDiagnosticsWithPrecedingDirectives(sourceFile, sourceFile.commentDirectives, programDiagnosticsInFile).diagnostics;
	    }
	    function getDeclarationDiagnostics2(sourceFile, cancellationToken) {
	      const options2 = program.getCompilerOptions();
	      if (!sourceFile || outFile(options2)) {
	        return getDeclarationDiagnosticsWorker(sourceFile, cancellationToken);
	      } else {
	        return getDiagnosticsHelper(sourceFile, getDeclarationDiagnosticsForFile, cancellationToken);
	      }
	    }
	    function getSyntacticDiagnosticsForFile(sourceFile) {
	      if (isSourceFileJS(sourceFile)) {
	        if (!sourceFile.additionalSyntacticDiagnostics) {
	          sourceFile.additionalSyntacticDiagnostics = getJSSyntacticDiagnosticsForFile(sourceFile);
	        }
	        return concatenate(sourceFile.additionalSyntacticDiagnostics, sourceFile.parseDiagnostics);
	      }
	      return sourceFile.parseDiagnostics;
	    }
	    function runWithCancellationToken(func) {
	      try {
	        return func();
	      } catch (e) {
	        if (e instanceof OperationCanceledException) {
	          typeChecker = void 0;
	        }
	        throw e;
	      }
	    }
	    function getSemanticDiagnosticsForFile(sourceFile, cancellationToken) {
	      return concatenate(
	        filterSemanticDiagnostics(getBindAndCheckDiagnosticsForFile(sourceFile, cancellationToken), options),
	        getProgramDiagnostics(sourceFile)
	      );
	    }
	    function getBindAndCheckDiagnosticsForFile(sourceFile, cancellationToken) {
	      return getAndCacheDiagnostics(sourceFile, cancellationToken, cachedBindAndCheckDiagnosticsForFile, getBindAndCheckDiagnosticsForFileNoCache);
	    }
	    function getBindAndCheckDiagnosticsForFileNoCache(sourceFile, cancellationToken) {
	      return runWithCancellationToken(() => {
	        if (skipTypeChecking(sourceFile, options, program)) {
	          return emptyArray;
	        }
	        const typeChecker2 = getTypeChecker();
	        Debug.assert(!!sourceFile.bindDiagnostics);
	        const isJs = sourceFile.scriptKind === 1 /* JS */ || sourceFile.scriptKind === 2 /* JSX */;
	        const isCheckJs = isJs && isCheckJsEnabledForFile(sourceFile, options);
	        const isPlainJs = isPlainJsFile(sourceFile, options.checkJs);
	        const isTsNoCheck = !!sourceFile.checkJsDirective && sourceFile.checkJsDirective.enabled === false;
	        const includeBindAndCheckDiagnostics = !isTsNoCheck && (sourceFile.scriptKind === 3 /* TS */ || sourceFile.scriptKind === 4 /* TSX */ || sourceFile.scriptKind === 5 /* External */ || isPlainJs || isCheckJs || sourceFile.scriptKind === 7 /* Deferred */);
	        let bindDiagnostics = includeBindAndCheckDiagnostics ? sourceFile.bindDiagnostics : emptyArray;
	        let checkDiagnostics = includeBindAndCheckDiagnostics ? typeChecker2.getDiagnostics(sourceFile, cancellationToken) : emptyArray;
	        if (isPlainJs) {
	          bindDiagnostics = filter(bindDiagnostics, (d) => plainJSErrors.has(d.code));
	          checkDiagnostics = filter(checkDiagnostics, (d) => plainJSErrors.has(d.code));
	        }
	        return getMergedBindAndCheckDiagnostics(sourceFile, includeBindAndCheckDiagnostics && !isPlainJs, bindDiagnostics, checkDiagnostics, isCheckJs ? sourceFile.jsDocDiagnostics : void 0);
	      });
	    }
	    function getMergedBindAndCheckDiagnostics(sourceFile, includeBindAndCheckDiagnostics, ...allDiagnostics) {
	      var _a2;
	      const flatDiagnostics = flatten(allDiagnostics);
	      if (!includeBindAndCheckDiagnostics || !((_a2 = sourceFile.commentDirectives) == null ? void 0 : _a2.length)) {
	        return flatDiagnostics;
	      }
	      const { diagnostics, directives } = getDiagnosticsWithPrecedingDirectives(sourceFile, sourceFile.commentDirectives, flatDiagnostics);
	      for (const errorExpectation of directives.getUnusedExpectations()) {
	        diagnostics.push(createDiagnosticForRange(sourceFile, errorExpectation.range, Diagnostics.Unused_ts_expect_error_directive));
	      }
	      return diagnostics;
	    }
	    function getDiagnosticsWithPrecedingDirectives(sourceFile, commentDirectives, flatDiagnostics) {
	      const directives = createCommentDirectivesMap(sourceFile, commentDirectives);
	      const diagnostics = flatDiagnostics.filter((diagnostic) => markPrecedingCommentDirectiveLine(diagnostic, directives) === -1);
	      return { diagnostics, directives };
	    }
	    function getSuggestionDiagnostics(sourceFile, cancellationToken) {
	      return runWithCancellationToken(() => {
	        return getTypeChecker().getSuggestionDiagnostics(sourceFile, cancellationToken);
	      });
	    }
	    function markPrecedingCommentDirectiveLine(diagnostic, directives) {
	      const { file, start } = diagnostic;
	      if (!file) {
	        return -1;
	      }
	      const lineStarts = getLineStarts(file);
	      let line = computeLineAndCharacterOfPosition(lineStarts, start).line - 1;
	      while (line >= 0) {
	        if (directives.markUsed(line)) {
	          return line;
	        }
	        const lineText = file.text.slice(lineStarts[line], lineStarts[line + 1]).trim();
	        if (lineText !== "" && !/^(\s*)\/\/(.*)$/.test(lineText)) {
	          return -1;
	        }
	        line--;
	      }
	      return -1;
	    }
	    function getJSSyntacticDiagnosticsForFile(sourceFile) {
	      return runWithCancellationToken(() => {
	        const diagnostics = [];
	        walk(sourceFile, sourceFile);
	        forEachChildRecursively(sourceFile, walk, walkArray);
	        return diagnostics;
	        function walk(node, parent2) {
	          switch (parent2.kind) {
	            case 169 /* Parameter */:
	            case 172 /* PropertyDeclaration */:
	            case 174 /* MethodDeclaration */:
	              if (parent2.questionToken === node) {
	                diagnostics.push(createDiagnosticForNode2(node, Diagnostics.The_0_modifier_can_only_be_used_in_TypeScript_files, "?"));
	                return "skip";
	              }
	            case 173 /* MethodSignature */:
	            case 176 /* Constructor */:
	            case 177 /* GetAccessor */:
	            case 178 /* SetAccessor */:
	            case 218 /* FunctionExpression */:
	            case 262 /* FunctionDeclaration */:
	            case 219 /* ArrowFunction */:
	            case 260 /* VariableDeclaration */:
	              if (parent2.type === node) {
	                diagnostics.push(createDiagnosticForNode2(node, Diagnostics.Type_annotations_can_only_be_used_in_TypeScript_files));
	                return "skip";
	              }
	          }
	          switch (node.kind) {
	            case 273 /* ImportClause */:
	              if (node.isTypeOnly) {
	                diagnostics.push(createDiagnosticForNode2(parent2, Diagnostics._0_declarations_can_only_be_used_in_TypeScript_files, "import type"));
	                return "skip";
	              }
	              break;
	            case 278 /* ExportDeclaration */:
	              if (node.isTypeOnly) {
	                diagnostics.push(createDiagnosticForNode2(node, Diagnostics._0_declarations_can_only_be_used_in_TypeScript_files, "export type"));
	                return "skip";
	              }
	              break;
	            case 276 /* ImportSpecifier */:
	            case 281 /* ExportSpecifier */:
	              if (node.isTypeOnly) {
	                diagnostics.push(createDiagnosticForNode2(node, Diagnostics._0_declarations_can_only_be_used_in_TypeScript_files, isImportSpecifier(node) ? "import...type" : "export...type"));
	                return "skip";
	              }
	              break;
	            case 271 /* ImportEqualsDeclaration */:
	              diagnostics.push(createDiagnosticForNode2(node, Diagnostics.import_can_only_be_used_in_TypeScript_files));
	              return "skip";
	            case 277 /* ExportAssignment */:
	              if (node.isExportEquals) {
	                diagnostics.push(createDiagnosticForNode2(node, Diagnostics.export_can_only_be_used_in_TypeScript_files));
	                return "skip";
	              }
	              break;
	            case 298 /* HeritageClause */:
	              const heritageClause = node;
	              if (heritageClause.token === 119 /* ImplementsKeyword */) {
	                diagnostics.push(createDiagnosticForNode2(node, Diagnostics.implements_clauses_can_only_be_used_in_TypeScript_files));
	                return "skip";
	              }
	              break;
	            case 264 /* InterfaceDeclaration */:
	              const interfaceKeyword = tokenToString(120 /* InterfaceKeyword */);
	              Debug.assertIsDefined(interfaceKeyword);
	              diagnostics.push(createDiagnosticForNode2(node, Diagnostics._0_declarations_can_only_be_used_in_TypeScript_files, interfaceKeyword));
	              return "skip";
	            case 267 /* ModuleDeclaration */:
	              const moduleKeyword = node.flags & 32 /* Namespace */ ? tokenToString(145 /* NamespaceKeyword */) : tokenToString(144 /* ModuleKeyword */);
	              Debug.assertIsDefined(moduleKeyword);
	              diagnostics.push(createDiagnosticForNode2(node, Diagnostics._0_declarations_can_only_be_used_in_TypeScript_files, moduleKeyword));
	              return "skip";
	            case 265 /* TypeAliasDeclaration */:
	              diagnostics.push(createDiagnosticForNode2(node, Diagnostics.Type_aliases_can_only_be_used_in_TypeScript_files));
	              return "skip";
	            case 176 /* Constructor */:
	            case 174 /* MethodDeclaration */:
	            case 262 /* FunctionDeclaration */:
	              if (!node.body) {
	                diagnostics.push(createDiagnosticForNode2(node, Diagnostics.Signature_declarations_can_only_be_used_in_TypeScript_files));
	                return "skip";
	              }
	              return;
	            case 266 /* EnumDeclaration */:
	              const enumKeyword = Debug.checkDefined(tokenToString(94 /* EnumKeyword */));
	              diagnostics.push(createDiagnosticForNode2(node, Diagnostics._0_declarations_can_only_be_used_in_TypeScript_files, enumKeyword));
	              return "skip";
	            case 235 /* NonNullExpression */:
	              diagnostics.push(createDiagnosticForNode2(node, Diagnostics.Non_null_assertions_can_only_be_used_in_TypeScript_files));
	              return "skip";
	            case 234 /* AsExpression */:
	              diagnostics.push(createDiagnosticForNode2(node.type, Diagnostics.Type_assertion_expressions_can_only_be_used_in_TypeScript_files));
	              return "skip";
	            case 238 /* SatisfiesExpression */:
	              diagnostics.push(createDiagnosticForNode2(node.type, Diagnostics.Type_satisfaction_expressions_can_only_be_used_in_TypeScript_files));
	              return "skip";
	            case 216 /* TypeAssertionExpression */:
	              Debug.fail();
	          }
	        }
	        function walkArray(nodes, parent2) {
	          if (canHaveIllegalDecorators(parent2)) {
	            const decorator = find(parent2.modifiers, isDecorator);
	            if (decorator) {
	              diagnostics.push(createDiagnosticForNode2(decorator, Diagnostics.Decorators_are_not_valid_here));
	            }
	          } else if (canHaveDecorators(parent2) && parent2.modifiers) {
	            const decoratorIndex = findIndex(parent2.modifiers, isDecorator);
	            if (decoratorIndex >= 0) {
	              if (isParameter(parent2) && !options.experimentalDecorators) {
	                diagnostics.push(createDiagnosticForNode2(parent2.modifiers[decoratorIndex], Diagnostics.Decorators_are_not_valid_here));
	              } else if (isClassDeclaration(parent2)) {
	                const exportIndex = findIndex(parent2.modifiers, isExportModifier);
	                if (exportIndex >= 0) {
	                  const defaultIndex = findIndex(parent2.modifiers, isDefaultModifier);
	                  if (decoratorIndex > exportIndex && defaultIndex >= 0 && decoratorIndex < defaultIndex) {
	                    diagnostics.push(createDiagnosticForNode2(parent2.modifiers[decoratorIndex], Diagnostics.Decorators_are_not_valid_here));
	                  } else if (exportIndex >= 0 && decoratorIndex < exportIndex) {
	                    const trailingDecoratorIndex = findIndex(parent2.modifiers, isDecorator, exportIndex);
	                    if (trailingDecoratorIndex >= 0) {
	                      diagnostics.push(addRelatedInfo(
	                        createDiagnosticForNode2(parent2.modifiers[trailingDecoratorIndex], Diagnostics.Decorators_may_not_appear_after_export_or_export_default_if_they_also_appear_before_export),
	                        createDiagnosticForNode2(parent2.modifiers[decoratorIndex], Diagnostics.Decorator_used_before_export_here)
	                      ));
	                    }
	                  }
	                }
	              }
	            }
	          }
	          switch (parent2.kind) {
	            case 263 /* ClassDeclaration */:
	            case 231 /* ClassExpression */:
	            case 174 /* MethodDeclaration */:
	            case 176 /* Constructor */:
	            case 177 /* GetAccessor */:
	            case 178 /* SetAccessor */:
	            case 218 /* FunctionExpression */:
	            case 262 /* FunctionDeclaration */:
	            case 219 /* ArrowFunction */:
	              if (nodes === parent2.typeParameters) {
	                diagnostics.push(createDiagnosticForNodeArray2(nodes, Diagnostics.Type_parameter_declarations_can_only_be_used_in_TypeScript_files));
	                return "skip";
	              }
	            case 243 /* VariableStatement */:
	              if (nodes === parent2.modifiers) {
	                checkModifiers(parent2.modifiers, parent2.kind === 243 /* VariableStatement */);
	                return "skip";
	              }
	              break;
	            case 172 /* PropertyDeclaration */:
	              if (nodes === parent2.modifiers) {
	                for (const modifier of nodes) {
	                  if (isModifier(modifier) && modifier.kind !== 126 /* StaticKeyword */ && modifier.kind !== 129 /* AccessorKeyword */) {
	                    diagnostics.push(createDiagnosticForNode2(modifier, Diagnostics.The_0_modifier_can_only_be_used_in_TypeScript_files, tokenToString(modifier.kind)));
	                  }
	                }
	                return "skip";
	              }
	              break;
	            case 169 /* Parameter */:
	              if (nodes === parent2.modifiers && some(nodes, isModifier)) {
	                diagnostics.push(createDiagnosticForNodeArray2(nodes, Diagnostics.Parameter_modifiers_can_only_be_used_in_TypeScript_files));
	                return "skip";
	              }
	              break;
	            case 213 /* CallExpression */:
	            case 214 /* NewExpression */:
	            case 233 /* ExpressionWithTypeArguments */:
	            case 285 /* JsxSelfClosingElement */:
	            case 286 /* JsxOpeningElement */:
	            case 215 /* TaggedTemplateExpression */:
	              if (nodes === parent2.typeArguments) {
	                diagnostics.push(createDiagnosticForNodeArray2(nodes, Diagnostics.Type_arguments_can_only_be_used_in_TypeScript_files));
	                return "skip";
	              }
	              break;
	          }
	        }
	        function checkModifiers(modifiers, isConstValid) {
	          for (const modifier of modifiers) {
	            switch (modifier.kind) {
	              case 87 /* ConstKeyword */:
	                if (isConstValid) {
	                  continue;
	                }
	              case 125 /* PublicKeyword */:
	              case 123 /* PrivateKeyword */:
	              case 124 /* ProtectedKeyword */:
	              case 148 /* ReadonlyKeyword */:
	              case 138 /* DeclareKeyword */:
	              case 128 /* AbstractKeyword */:
	              case 164 /* OverrideKeyword */:
	              case 103 /* InKeyword */:
	              case 147 /* OutKeyword */:
	                diagnostics.push(createDiagnosticForNode2(modifier, Diagnostics.The_0_modifier_can_only_be_used_in_TypeScript_files, tokenToString(modifier.kind)));
	                break;
	              case 126 /* StaticKeyword */:
	              case 95 /* ExportKeyword */:
	              case 90 /* DefaultKeyword */:
	              case 129 /* AccessorKeyword */:
	            }
	          }
	        }
	        function createDiagnosticForNodeArray2(nodes, message, ...args) {
	          const start = nodes.pos;
	          return createFileDiagnostic(sourceFile, start, nodes.end - start, message, ...args);
	        }
	        function createDiagnosticForNode2(node, message, ...args) {
	          return createDiagnosticForNodeInSourceFile(sourceFile, node, message, ...args);
	        }
	      });
	    }
	    function getDeclarationDiagnosticsWorker(sourceFile, cancellationToken) {
	      return getAndCacheDiagnostics(sourceFile, cancellationToken, cachedDeclarationDiagnosticsForFile, getDeclarationDiagnosticsForFileNoCache);
	    }
	    function getDeclarationDiagnosticsForFileNoCache(sourceFile, cancellationToken) {
	      return runWithCancellationToken(() => {
	        const resolver = getTypeChecker().getEmitResolver(sourceFile, cancellationToken);
	        return getDeclarationDiagnostics(getEmitHost(noop), resolver, sourceFile) || emptyArray;
	      });
	    }
	    function getAndCacheDiagnostics(sourceFile, cancellationToken, cache, getDiagnostics2) {
	      var _a2;
	      const cachedResult = sourceFile ? (_a2 = cache.perFile) == null ? void 0 : _a2.get(sourceFile.path) : cache.allDiagnostics;
	      if (cachedResult) {
	        return cachedResult;
	      }
	      const result = getDiagnostics2(sourceFile, cancellationToken);
	      if (sourceFile) {
	        (cache.perFile || (cache.perFile = /* @__PURE__ */ new Map())).set(sourceFile.path, result);
	      } else {
	        cache.allDiagnostics = result;
	      }
	      return result;
	    }
	    function getDeclarationDiagnosticsForFile(sourceFile, cancellationToken) {
	      return sourceFile.isDeclarationFile ? [] : getDeclarationDiagnosticsWorker(sourceFile, cancellationToken);
	    }
	    function getOptionsDiagnostics() {
	      return sortAndDeduplicateDiagnostics(concatenate(
	        programDiagnostics.getGlobalDiagnostics(),
	        getOptionsDiagnosticsOfConfigFile()
	      ));
	    }
	    function getOptionsDiagnosticsOfConfigFile() {
	      if (!options.configFile)
	        return emptyArray;
	      let diagnostics = programDiagnostics.getDiagnostics(options.configFile.fileName);
	      forEachResolvedProjectReference2((resolvedRef) => {
	        diagnostics = concatenate(diagnostics, programDiagnostics.getDiagnostics(resolvedRef.sourceFile.fileName));
	      });
	      return diagnostics;
	    }
	    function getGlobalDiagnostics() {
	      return rootNames.length ? sortAndDeduplicateDiagnostics(getTypeChecker().getGlobalDiagnostics().slice()) : emptyArray;
	    }
	    function getConfigFileParsingDiagnostics2() {
	      return configFileParsingDiagnostics || emptyArray;
	    }
	    function processRootFile(fileName, isDefaultLib, ignoreNoDefaultLib, reason) {
	      processSourceFile(
	        normalizePath(fileName),
	        isDefaultLib,
	        ignoreNoDefaultLib,
	        /*packageId*/
	        void 0,
	        reason
	      );
	    }
	    function fileReferenceIsEqualTo(a, b) {
	      return a.fileName === b.fileName;
	    }
	    function moduleNameIsEqualTo(a, b) {
	      return a.kind === 80 /* Identifier */ ? b.kind === 80 /* Identifier */ && a.escapedText === b.escapedText : b.kind === 11 /* StringLiteral */ && a.text === b.text;
	    }
	    function createSyntheticImport(text, file) {
	      const externalHelpersModuleReference = factory.createStringLiteral(text);
	      const importDecl = factory.createImportDeclaration(
	        /*modifiers*/
	        void 0,
	        /*importClause*/
	        void 0,
	        externalHelpersModuleReference,
	        /*attributes*/
	        void 0
	      );
	      addInternalEmitFlags(importDecl, 2 /* NeverApplyImportHelper */);
	      setParent(externalHelpersModuleReference, importDecl);
	      setParent(importDecl, file);
	      externalHelpersModuleReference.flags &= ~16 /* Synthesized */;
	      importDecl.flags &= ~16 /* Synthesized */;
	      return externalHelpersModuleReference;
	    }
	    function collectExternalModuleReferences(file) {
	      if (file.imports) {
	        return;
	      }
	      const isJavaScriptFile = isSourceFileJS(file);
	      const isExternalModuleFile = isExternalModule(file);
	      let imports;
	      let moduleAugmentations;
	      let ambientModules;
	      if ((getIsolatedModules(options) || isExternalModuleFile) && !file.isDeclarationFile) {
	        if (options.importHelpers) {
	          imports = [createSyntheticImport(externalHelpersModuleNameText, file)];
	        }
	        const jsxImport = getJSXRuntimeImport(getJSXImplicitImportBase(options, file), options);
	        if (jsxImport) {
	          (imports || (imports = [])).push(createSyntheticImport(jsxImport, file));
	        }
	      }
	      for (const node of file.statements) {
	        collectModuleReferences(
	          node,
	          /*inAmbientModule*/
	          false
	        );
	      }
	      if (file.flags & 4194304 /* PossiblyContainsDynamicImport */ || isJavaScriptFile) {
	        collectDynamicImportOrRequireCalls(file);
	      }
	      file.imports = imports || emptyArray;
	      file.moduleAugmentations = moduleAugmentations || emptyArray;
	      file.ambientModuleNames = ambientModules || emptyArray;
	      return;
	      function collectModuleReferences(node, inAmbientModule) {
	        if (isAnyImportOrReExport(node)) {
	          const moduleNameExpr = getExternalModuleName(node);
	          if (moduleNameExpr && isStringLiteral(moduleNameExpr) && moduleNameExpr.text && (!inAmbientModule || !isExternalModuleNameRelative(moduleNameExpr.text))) {
	            setParentRecursive(
	              node,
	              /*incremental*/
	              false
	            );
	            imports = append(imports, moduleNameExpr);
	            if (!usesUriStyleNodeCoreModules && currentNodeModulesDepth === 0 && !file.isDeclarationFile) {
	              usesUriStyleNodeCoreModules = startsWith(moduleNameExpr.text, "node:");
	            }
	          }
	        } else if (isModuleDeclaration(node)) {
	          if (isAmbientModule(node) && (inAmbientModule || hasSyntacticModifier(node, 128 /* Ambient */) || file.isDeclarationFile)) {
	            node.name.parent = node;
	            const nameText = getTextOfIdentifierOrLiteral(node.name);
	            if (isExternalModuleFile || inAmbientModule && !isExternalModuleNameRelative(nameText)) {
	              (moduleAugmentations || (moduleAugmentations = [])).push(node.name);
	            } else if (!inAmbientModule) {
	              if (file.isDeclarationFile) {
	                (ambientModules || (ambientModules = [])).push(nameText);
	              }
	              const body = node.body;
	              if (body) {
	                for (const statement of body.statements) {
	                  collectModuleReferences(
	                    statement,
	                    /*inAmbientModule*/
	                    true
	                  );
	                }
	              }
	            }
	          }
	        }
	      }
	      function collectDynamicImportOrRequireCalls(file2) {
	        const r = /import|require/g;
	        while (r.exec(file2.text) !== null) {
	          const node = getNodeAtPosition(file2, r.lastIndex);
	          if (isJavaScriptFile && isRequireCall(
	            node,
	            /*requireStringLiteralLikeArgument*/
	            true
	          )) {
	            setParentRecursive(
	              node,
	              /*incremental*/
	              false
	            );
	            imports = append(imports, node.arguments[0]);
	          } else if (isImportCall(node) && node.arguments.length >= 1 && isStringLiteralLike(node.arguments[0])) {
	            setParentRecursive(
	              node,
	              /*incremental*/
	              false
	            );
	            imports = append(imports, node.arguments[0]);
	          } else if (isLiteralImportTypeNode(node)) {
	            setParentRecursive(
	              node,
	              /*incremental*/
	              false
	            );
	            imports = append(imports, node.argument.literal);
	          }
	        }
	      }
	      function getNodeAtPosition(sourceFile, position) {
	        let current = sourceFile;
	        const getContainingChild = (child) => {
	          if (child.pos <= position && (position < child.end || position === child.end && child.kind === 1 /* EndOfFileToken */)) {
	            return child;
	          }
	        };
	        while (true) {
	          const child = isJavaScriptFile && hasJSDocNodes(current) && forEach(current.jsDoc, getContainingChild) || forEachChild(current, getContainingChild);
	          if (!child) {
	            return current;
	          }
	          current = child;
	        }
	      }
	    }
	    function getLibFileFromReference(ref) {
	      var _a2;
	      const { libFileName } = getLibFileNameFromLibReference(ref);
	      const actualFileName = libFileName && ((_a2 = resolvedLibReferences == null ? void 0 : resolvedLibReferences.get(libFileName)) == null ? void 0 : _a2.actual);
	      return actualFileName !== void 0 ? getSourceFile(actualFileName) : void 0;
	    }
	    function getSourceFileFromReference(referencingFile, ref) {
	      return getSourceFileFromReferenceWorker(resolveTripleslashReference(ref.fileName, referencingFile.fileName), getSourceFile);
	    }
	    function getSourceFileFromReferenceWorker(fileName, getSourceFile2, fail, reason) {
	      if (hasExtension(fileName)) {
	        const canonicalFileName = host.getCanonicalFileName(fileName);
	        if (!options.allowNonTsExtensions && !forEach(flatten(supportedExtensionsWithJsonIfResolveJsonModule), (extension) => fileExtensionIs(canonicalFileName, extension))) {
	          if (fail) {
	            if (hasJSFileExtension(canonicalFileName)) {
	              fail(Diagnostics.File_0_is_a_JavaScript_file_Did_you_mean_to_enable_the_allowJs_option, fileName);
	            } else {
	              fail(Diagnostics.File_0_has_an_unsupported_extension_The_only_supported_extensions_are_1, fileName, "'" + flatten(supportedExtensions).join("', '") + "'");
	            }
	          }
	          return void 0;
	        }
	        const sourceFile = getSourceFile2(fileName);
	        if (fail) {
	          if (!sourceFile) {
	            const redirect = getProjectReferenceRedirect(fileName);
	            if (redirect) {
	              fail(Diagnostics.Output_file_0_has_not_been_built_from_source_file_1, redirect, fileName);
	            } else {
	              fail(Diagnostics.File_0_not_found, fileName);
	            }
	          } else if (isReferencedFile(reason) && canonicalFileName === host.getCanonicalFileName(getSourceFileByPath(reason.file).fileName)) {
	            fail(Diagnostics.A_file_cannot_have_a_reference_to_itself);
	          }
	        }
	        return sourceFile;
	      } else {
	        const sourceFileNoExtension = options.allowNonTsExtensions && getSourceFile2(fileName);
	        if (sourceFileNoExtension)
	          return sourceFileNoExtension;
	        if (fail && options.allowNonTsExtensions) {
	          fail(Diagnostics.File_0_not_found, fileName);
	          return void 0;
	        }
	        const sourceFileWithAddedExtension = forEach(supportedExtensions[0], (extension) => getSourceFile2(fileName + extension));
	        if (fail && !sourceFileWithAddedExtension)
	          fail(Diagnostics.Could_not_resolve_the_path_0_with_the_extensions_Colon_1, fileName, "'" + flatten(supportedExtensions).join("', '") + "'");
	        return sourceFileWithAddedExtension;
	      }
	    }
	    function processSourceFile(fileName, isDefaultLib, ignoreNoDefaultLib, packageId, reason) {
	      getSourceFileFromReferenceWorker(
	        fileName,
	        (fileName2) => findSourceFile(fileName2, isDefaultLib, ignoreNoDefaultLib, reason, packageId),
	        // TODO: GH#18217
	        (diagnostic, ...args) => addFilePreprocessingFileExplainingDiagnostic(
	          /*file*/
	          void 0,
	          reason,
	          diagnostic,
	          args
	        ),
	        reason
	      );
	    }
	    function processProjectReferenceFile(fileName, reason) {
	      return processSourceFile(
	        fileName,
	        /*isDefaultLib*/
	        false,
	        /*ignoreNoDefaultLib*/
	        false,
	        /*packageId*/
	        void 0,
	        reason
	      );
	    }
	    function reportFileNamesDifferOnlyInCasingError(fileName, existingFile, reason) {
	      const hasExistingReasonToReportErrorOn = !isReferencedFile(reason) && some(fileReasons.get(existingFile.path), isReferencedFile);
	      if (hasExistingReasonToReportErrorOn) {
	        addFilePreprocessingFileExplainingDiagnostic(existingFile, reason, Diagnostics.Already_included_file_name_0_differs_from_file_name_1_only_in_casing, [existingFile.fileName, fileName]);
	      } else {
	        addFilePreprocessingFileExplainingDiagnostic(existingFile, reason, Diagnostics.File_name_0_differs_from_already_included_file_name_1_only_in_casing, [fileName, existingFile.fileName]);
	      }
	    }
	    function createRedirectedSourceFile(redirectTarget, unredirected, fileName, path, resolvedPath, originalFileName, sourceFileOptions) {
	      var _a2;
	      const redirect = parseNodeFactory.createRedirectedSourceFile({ redirectTarget, unredirected });
	      redirect.fileName = fileName;
	      redirect.path = path;
	      redirect.resolvedPath = resolvedPath;
	      redirect.originalFileName = originalFileName;
	      redirect.packageJsonLocations = ((_a2 = sourceFileOptions.packageJsonLocations) == null ? void 0 : _a2.length) ? sourceFileOptions.packageJsonLocations : void 0;
	      redirect.packageJsonScope = sourceFileOptions.packageJsonScope;
	      sourceFilesFoundSearchingNodeModules.set(path, currentNodeModulesDepth > 0);
	      return redirect;
	    }
	    function findSourceFile(fileName, isDefaultLib, ignoreNoDefaultLib, reason, packageId) {
	      var _a2, _b2;
	      (_a2 = tracing) == null ? void 0 : _a2.push(tracing.Phase.Program, "findSourceFile", {
	        fileName,
	        isDefaultLib: isDefaultLib || void 0,
	        fileIncludeKind: FileIncludeKind[reason.kind]
	      });
	      const result = findSourceFileWorker(fileName, isDefaultLib, ignoreNoDefaultLib, reason, packageId);
	      (_b2 = tracing) == null ? void 0 : _b2.pop();
	      return result;
	    }
	    function getCreateSourceFileOptions(fileName, moduleResolutionCache2, host2, options2) {
	      const result = getImpliedNodeFormatForFileWorker(getNormalizedAbsolutePath(fileName, currentDirectory), moduleResolutionCache2 == null ? void 0 : moduleResolutionCache2.getPackageJsonInfoCache(), host2, options2);
	      const languageVersion = getEmitScriptTarget(options2);
	      const setExternalModuleIndicator2 = getSetExternalModuleIndicator(options2);
	      return typeof result === "object" ? { ...result, languageVersion, setExternalModuleIndicator: setExternalModuleIndicator2, jsDocParsingMode: host2.jsDocParsingMode } : { languageVersion, impliedNodeFormat: result, setExternalModuleIndicator: setExternalModuleIndicator2, jsDocParsingMode: host2.jsDocParsingMode };
	    }
	    function findSourceFileWorker(fileName, isDefaultLib, ignoreNoDefaultLib, reason, packageId) {
	      var _a2;
	      const path = toPath3(fileName);
	      if (useSourceOfProjectReferenceRedirect) {
	        let source = getSourceOfProjectReferenceRedirect(path);
	        if (!source && host.realpath && options.preserveSymlinks && isDeclarationFileName(fileName) && fileName.includes(nodeModulesPathPart)) {
	          const realPath2 = toPath3(host.realpath(fileName));
	          if (realPath2 !== path)
	            source = getSourceOfProjectReferenceRedirect(realPath2);
	        }
	        if (source) {
	          const file2 = isString(source) ? findSourceFile(source, isDefaultLib, ignoreNoDefaultLib, reason, packageId) : void 0;
	          if (file2)
	            addFileToFilesByName(
	              file2,
	              path,
	              fileName,
	              /*redirectedPath*/
	              void 0
	            );
	          return file2;
	        }
	      }
	      const originalFileName = fileName;
	      if (filesByName.has(path)) {
	        const file2 = filesByName.get(path);
	        addFileIncludeReason(file2 || void 0, reason);
	        if (file2 && !(options.forceConsistentCasingInFileNames === false)) {
	          const checkedName = file2.fileName;
	          const isRedirect = toPath3(checkedName) !== toPath3(fileName);
	          if (isRedirect) {
	            fileName = getProjectReferenceRedirect(fileName) || fileName;
	          }
	          const checkedAbsolutePath = getNormalizedAbsolutePathWithoutRoot(checkedName, currentDirectory);
	          const inputAbsolutePath = getNormalizedAbsolutePathWithoutRoot(fileName, currentDirectory);
	          if (checkedAbsolutePath !== inputAbsolutePath) {
	            reportFileNamesDifferOnlyInCasingError(fileName, file2, reason);
	          }
	        }
	        if (file2 && sourceFilesFoundSearchingNodeModules.get(file2.path) && currentNodeModulesDepth === 0) {
	          sourceFilesFoundSearchingNodeModules.set(file2.path, false);
	          if (!options.noResolve) {
	            processReferencedFiles(file2, isDefaultLib);
	            processTypeReferenceDirectives(file2);
	          }
	          if (!options.noLib) {
	            processLibReferenceDirectives(file2);
	          }
	          modulesWithElidedImports.set(file2.path, false);
	          processImportedModules(file2);
	        } else if (file2 && modulesWithElidedImports.get(file2.path)) {
	          if (currentNodeModulesDepth < maxNodeModuleJsDepth) {
	            modulesWithElidedImports.set(file2.path, false);
	            processImportedModules(file2);
	          }
	        }
	        return file2 || void 0;
	      }
	      let redirectedPath;
	      if (isReferencedFile(reason) && !useSourceOfProjectReferenceRedirect) {
	        const redirectProject = getProjectReferenceRedirectProject(fileName);
	        if (redirectProject) {
	          if (outFile(redirectProject.commandLine.options)) {
	            return void 0;
	          }
	          const redirect = getProjectReferenceOutputName(redirectProject, fileName);
	          fileName = redirect;
	          redirectedPath = toPath3(redirect);
	        }
	      }
	      const sourceFileOptions = getCreateSourceFileOptions(fileName, moduleResolutionCache, host, options);
	      const file = host.getSourceFile(
	        fileName,
	        sourceFileOptions,
	        (hostErrorMessage) => addFilePreprocessingFileExplainingDiagnostic(
	          /*file*/
	          void 0,
	          reason,
	          Diagnostics.Cannot_read_file_0_Colon_1,
	          [fileName, hostErrorMessage]
	        ),
	        shouldCreateNewSourceFile
	      );
	      if (packageId) {
	        const packageIdKey = packageIdToString(packageId);
	        const fileFromPackageId = packageIdToSourceFile.get(packageIdKey);
	        if (fileFromPackageId) {
	          const dupFile = createRedirectedSourceFile(fileFromPackageId, file, fileName, path, toPath3(fileName), originalFileName, sourceFileOptions);
	          redirectTargetsMap.add(fileFromPackageId.path, fileName);
	          addFileToFilesByName(dupFile, path, fileName, redirectedPath);
	          addFileIncludeReason(dupFile, reason);
	          sourceFileToPackageName.set(path, packageIdToPackageName(packageId));
	          processingOtherFiles.push(dupFile);
	          return dupFile;
	        } else if (file) {
	          packageIdToSourceFile.set(packageIdKey, file);
	          sourceFileToPackageName.set(path, packageIdToPackageName(packageId));
	        }
	      }
	      addFileToFilesByName(file, path, fileName, redirectedPath);
	      if (file) {
	        sourceFilesFoundSearchingNodeModules.set(path, currentNodeModulesDepth > 0);
	        file.fileName = fileName;
	        file.path = path;
	        file.resolvedPath = toPath3(fileName);
	        file.originalFileName = originalFileName;
	        file.packageJsonLocations = ((_a2 = sourceFileOptions.packageJsonLocations) == null ? void 0 : _a2.length) ? sourceFileOptions.packageJsonLocations : void 0;
	        file.packageJsonScope = sourceFileOptions.packageJsonScope;
	        addFileIncludeReason(file, reason);
	        if (host.useCaseSensitiveFileNames()) {
	          const pathLowerCase = toFileNameLowerCase(path);
	          const existingFile = filesByNameIgnoreCase.get(pathLowerCase);
	          if (existingFile) {
	            reportFileNamesDifferOnlyInCasingError(fileName, existingFile, reason);
	          } else {
	            filesByNameIgnoreCase.set(pathLowerCase, file);
	          }
	        }
	        skipDefaultLib = skipDefaultLib || file.hasNoDefaultLib && !ignoreNoDefaultLib;
	        if (!options.noResolve) {
	          processReferencedFiles(file, isDefaultLib);
	          processTypeReferenceDirectives(file);
	        }
	        if (!options.noLib) {
	          processLibReferenceDirectives(file);
	        }
	        processImportedModules(file);
	        if (isDefaultLib) {
	          processingDefaultLibFiles.push(file);
	        } else {
	          processingOtherFiles.push(file);
	        }
	      }
	      return file;
	    }
	    function addFileIncludeReason(file, reason) {
	      if (file)
	        fileReasons.add(file.path, reason);
	    }
	    function addFileToFilesByName(file, path, fileName, redirectedPath) {
	      if (redirectedPath) {
	        updateFilesByNameMap(fileName, redirectedPath, file);
	        updateFilesByNameMap(fileName, path, file || false);
	      } else {
	        updateFilesByNameMap(fileName, path, file);
	      }
	    }
	    function updateFilesByNameMap(fileName, path, file) {
	      filesByName.set(path, file);
	      if (file !== void 0)
	        missingFileNames.delete(path);
	      else
	        missingFileNames.set(path, fileName);
	    }
	    function getProjectReferenceRedirect(fileName) {
	      const referencedProject = getProjectReferenceRedirectProject(fileName);
	      return referencedProject && getProjectReferenceOutputName(referencedProject, fileName);
	    }
	    function getProjectReferenceRedirectProject(fileName) {
	      if (!resolvedProjectReferences || !resolvedProjectReferences.length || isDeclarationFileName(fileName) || fileExtensionIs(fileName, ".json" /* Json */)) {
	        return void 0;
	      }
	      return getResolvedProjectReferenceToRedirect(fileName);
	    }
	    function getProjectReferenceOutputName(referencedProject, fileName) {
	      const out = outFile(referencedProject.commandLine.options);
	      return out ? changeExtension(out, ".d.ts" /* Dts */) : getOutputDeclarationFileName(fileName, referencedProject.commandLine, !host.useCaseSensitiveFileNames());
	    }
	    function getResolvedProjectReferenceToRedirect(fileName) {
	      if (mapFromFileToProjectReferenceRedirects === void 0) {
	        mapFromFileToProjectReferenceRedirects = /* @__PURE__ */ new Map();
	        forEachResolvedProjectReference2((referencedProject) => {
	          if (toPath3(options.configFilePath) !== referencedProject.sourceFile.path) {
	            referencedProject.commandLine.fileNames.forEach((f) => mapFromFileToProjectReferenceRedirects.set(toPath3(f), referencedProject.sourceFile.path));
	          }
	        });
	      }
	      const referencedProjectPath = mapFromFileToProjectReferenceRedirects.get(toPath3(fileName));
	      return referencedProjectPath && getResolvedProjectReferenceByPath(referencedProjectPath);
	    }
	    function forEachResolvedProjectReference2(cb) {
	      return forEachResolvedProjectReference(resolvedProjectReferences, cb);
	    }
	    function getSourceOfProjectReferenceRedirect(path) {
	      if (!isDeclarationFileName(path))
	        return void 0;
	      if (mapFromToProjectReferenceRedirectSource === void 0) {
	        mapFromToProjectReferenceRedirectSource = /* @__PURE__ */ new Map();
	        forEachResolvedProjectReference2((resolvedRef) => {
	          const out = outFile(resolvedRef.commandLine.options);
	          if (out) {
	            const outputDts = changeExtension(out, ".d.ts" /* Dts */);
	            mapFromToProjectReferenceRedirectSource.set(toPath3(outputDts), true);
	          } else {
	            const getCommonSourceDirectory3 = memoize(() => getCommonSourceDirectoryOfConfig(resolvedRef.commandLine, !host.useCaseSensitiveFileNames()));
	            forEach(resolvedRef.commandLine.fileNames, (fileName) => {
	              if (!isDeclarationFileName(fileName) && !fileExtensionIs(fileName, ".json" /* Json */)) {
	                const outputDts = getOutputDeclarationFileName(fileName, resolvedRef.commandLine, !host.useCaseSensitiveFileNames(), getCommonSourceDirectory3);
	                mapFromToProjectReferenceRedirectSource.set(toPath3(outputDts), fileName);
	              }
	            });
	          }
	        });
	      }
	      return mapFromToProjectReferenceRedirectSource.get(path);
	    }
	    function isSourceOfProjectReferenceRedirect(fileName) {
	      return useSourceOfProjectReferenceRedirect && !!getResolvedProjectReferenceToRedirect(fileName);
	    }
	    function getResolvedProjectReferenceByPath(projectReferencePath) {
	      if (!projectReferenceRedirects) {
	        return void 0;
	      }
	      return projectReferenceRedirects.get(projectReferencePath) || void 0;
	    }
	    function processReferencedFiles(file, isDefaultLib) {
	      forEach(file.referencedFiles, (ref, index) => {
	        processSourceFile(
	          resolveTripleslashReference(ref.fileName, file.fileName),
	          isDefaultLib,
	          /*ignoreNoDefaultLib*/
	          false,
	          /*packageId*/
	          void 0,
	          { kind: 4 /* ReferenceFile */, file: file.path, index }
	        );
	      });
	    }
	    function processTypeReferenceDirectives(file) {
	      const typeDirectives = file.typeReferenceDirectives;
	      if (!typeDirectives.length)
	        return;
	      const resolutions = (resolvedTypeReferenceDirectiveNamesProcessing == null ? void 0 : resolvedTypeReferenceDirectiveNamesProcessing.get(file.path)) || resolveTypeReferenceDirectiveNamesReusingOldState(typeDirectives, file);
	      const resolutionsInFile = createModeAwareCache();
	      (resolvedTypeReferenceDirectiveNames ?? (resolvedTypeReferenceDirectiveNames = /* @__PURE__ */ new Map())).set(file.path, resolutionsInFile);
	      for (let index = 0; index < typeDirectives.length; index++) {
	        const ref = file.typeReferenceDirectives[index];
	        const resolvedTypeReferenceDirective = resolutions[index];
	        const fileName = toFileNameLowerCase(ref.fileName);
	        resolutionsInFile.set(fileName, getModeForFileReference(ref, file.impliedNodeFormat), resolvedTypeReferenceDirective);
	        const mode = ref.resolutionMode || file.impliedNodeFormat;
	        processTypeReferenceDirective(fileName, mode, resolvedTypeReferenceDirective, { kind: 5 /* TypeReferenceDirective */, file: file.path, index });
	      }
	    }
	    function processTypeReferenceDirective(typeReferenceDirective, mode, resolution, reason) {
	      var _a2, _b2;
	      (_a2 = tracing) == null ? void 0 : _a2.push(tracing.Phase.Program, "processTypeReferenceDirective", { directive: typeReferenceDirective, hasResolved: !!resolution.resolvedTypeReferenceDirective, refKind: reason.kind, refPath: isReferencedFile(reason) ? reason.file : void 0 });
	      processTypeReferenceDirectiveWorker(typeReferenceDirective, mode, resolution, reason);
	      (_b2 = tracing) == null ? void 0 : _b2.pop();
	    }
	    function processTypeReferenceDirectiveWorker(typeReferenceDirective, mode, resolution, reason) {
	      var _a2;
	      addResolutionDiagnostics(resolution);
	      const previousResolution = (_a2 = resolvedTypeReferenceDirectives.get(typeReferenceDirective, mode)) == null ? void 0 : _a2.resolvedTypeReferenceDirective;
	      if (previousResolution && previousResolution.primary) {
	        return;
	      }
	      let saveResolution = true;
	      const { resolvedTypeReferenceDirective } = resolution;
	      if (resolvedTypeReferenceDirective) {
	        if (resolvedTypeReferenceDirective.isExternalLibraryImport)
	          currentNodeModulesDepth++;
	        if (resolvedTypeReferenceDirective.primary) {
	          processSourceFile(
	            resolvedTypeReferenceDirective.resolvedFileName,
	            /*isDefaultLib*/
	            false,
	            /*ignoreNoDefaultLib*/
	            false,
	            resolvedTypeReferenceDirective.packageId,
	            reason
	          );
	        } else {
	          if (previousResolution) {
	            if (resolvedTypeReferenceDirective.resolvedFileName !== previousResolution.resolvedFileName) {
	              const otherFileText = host.readFile(resolvedTypeReferenceDirective.resolvedFileName);
	              const existingFile = getSourceFile(previousResolution.resolvedFileName);
	              if (otherFileText !== existingFile.text) {
	                addFilePreprocessingFileExplainingDiagnostic(
	                  existingFile,
	                  reason,
	                  Diagnostics.Conflicting_definitions_for_0_found_at_1_and_2_Consider_installing_a_specific_version_of_this_library_to_resolve_the_conflict,
	                  [typeReferenceDirective, resolvedTypeReferenceDirective.resolvedFileName, previousResolution.resolvedFileName]
	                );
	              }
	            }
	            saveResolution = false;
	          } else {
	            processSourceFile(
	              resolvedTypeReferenceDirective.resolvedFileName,
	              /*isDefaultLib*/
	              false,
	              /*ignoreNoDefaultLib*/
	              false,
	              resolvedTypeReferenceDirective.packageId,
	              reason
	            );
	          }
	        }
	        if (resolvedTypeReferenceDirective.isExternalLibraryImport)
	          currentNodeModulesDepth--;
	      } else {
	        addFilePreprocessingFileExplainingDiagnostic(
	          /*file*/
	          void 0,
	          reason,
	          Diagnostics.Cannot_find_type_definition_file_for_0,
	          [typeReferenceDirective]
	        );
	      }
	      if (saveResolution) {
	        resolvedTypeReferenceDirectives.set(typeReferenceDirective, mode, resolution);
	      }
	    }
	    function pathForLibFile(libFileName) {
	      const existing = resolvedLibReferences == null ? void 0 : resolvedLibReferences.get(libFileName);
	      if (existing)
	        return existing.actual;
	      const result = pathForLibFileWorker(libFileName);
	      (resolvedLibReferences ?? (resolvedLibReferences = /* @__PURE__ */ new Map())).set(libFileName, result);
	      return result.actual;
	    }
	    function pathForLibFileWorker(libFileName) {
	      var _a2, _b2, _c2, _d2, _e2;
	      const existing = resolvedLibProcessing == null ? void 0 : resolvedLibProcessing.get(libFileName);
	      if (existing)
	        return existing;
	      if (structureIsReused !== 0 /* Not */ && oldProgram && !hasInvalidatedLibResolutions(libFileName)) {
	        const oldResolution = (_a2 = oldProgram.resolvedLibReferences) == null ? void 0 : _a2.get(libFileName);
	        if (oldResolution) {
	          if (oldResolution.resolution && isTraceEnabled(options, host)) {
	            const libraryName2 = getLibraryNameFromLibFileName(libFileName);
	            const resolveFrom2 = getInferredLibraryNameResolveFrom(options, currentDirectory, libFileName);
	            trace(
	              host,
	              oldResolution.resolution.resolvedModule ? oldResolution.resolution.resolvedModule.packageId ? Diagnostics.Reusing_resolution_of_module_0_from_1_of_old_program_it_was_successfully_resolved_to_2_with_Package_ID_3 : Diagnostics.Reusing_resolution_of_module_0_from_1_of_old_program_it_was_successfully_resolved_to_2 : Diagnostics.Reusing_resolution_of_module_0_from_1_of_old_program_it_was_not_resolved,
	              libraryName2,
	              getNormalizedAbsolutePath(resolveFrom2, currentDirectory),
	              (_b2 = oldResolution.resolution.resolvedModule) == null ? void 0 : _b2.resolvedFileName,
	              ((_c2 = oldResolution.resolution.resolvedModule) == null ? void 0 : _c2.packageId) && packageIdToString(oldResolution.resolution.resolvedModule.packageId)
	            );
	          }
	          (resolvedLibProcessing ?? (resolvedLibProcessing = /* @__PURE__ */ new Map())).set(libFileName, oldResolution);
	          return oldResolution;
	        }
	      }
	      const libraryName = getLibraryNameFromLibFileName(libFileName);
	      const resolveFrom = getInferredLibraryNameResolveFrom(options, currentDirectory, libFileName);
	      (_d2 = tracing) == null ? void 0 : _d2.push(tracing.Phase.Program, "resolveLibrary", { resolveFrom });
	      mark("beforeResolveLibrary");
	      const resolution = actualResolveLibrary(libraryName, resolveFrom, options, libFileName);
	      mark("afterResolveLibrary");
	      measure("ResolveLibrary", "beforeResolveLibrary", "afterResolveLibrary");
	      (_e2 = tracing) == null ? void 0 : _e2.pop();
	      const result = {
	        resolution,
	        actual: resolution.resolvedModule ? resolution.resolvedModule.resolvedFileName : combinePaths(defaultLibraryPath, libFileName)
	      };
	      (resolvedLibProcessing ?? (resolvedLibProcessing = /* @__PURE__ */ new Map())).set(libFileName, result);
	      return result;
	    }
	    function processLibReferenceDirectives(file) {
	      forEach(file.libReferenceDirectives, (libReference, index) => {
	        const { libName, libFileName } = getLibFileNameFromLibReference(libReference);
	        if (libFileName) {
	          processRootFile(
	            pathForLibFile(libFileName),
	            /*isDefaultLib*/
	            true,
	            /*ignoreNoDefaultLib*/
	            true,
	            { kind: 7 /* LibReferenceDirective */, file: file.path, index }
	          );
	        } else {
	          const unqualifiedLibName = removeSuffix(removePrefix(libName, "lib."), ".d.ts");
	          const suggestion = getSpellingSuggestion(unqualifiedLibName, libs, identity);
	          const diagnostic = suggestion ? Diagnostics.Cannot_find_lib_definition_for_0_Did_you_mean_1 : Diagnostics.Cannot_find_lib_definition_for_0;
	          const args = suggestion ? [libName, suggestion] : [libName];
	          (fileProcessingDiagnostics || (fileProcessingDiagnostics = [])).push({
	            kind: 0 /* FilePreprocessingReferencedDiagnostic */,
	            reason: { kind: 7 /* LibReferenceDirective */, file: file.path, index },
	            diagnostic,
	            args
	          });
	        }
	      });
	    }
	    function getCanonicalFileName(fileName) {
	      return host.getCanonicalFileName(fileName);
	    }
	    function processImportedModules(file) {
	      var _a2;
	      collectExternalModuleReferences(file);
	      if (file.imports.length || file.moduleAugmentations.length) {
	        const moduleNames = getModuleNames(file);
	        const resolutions = (resolvedModulesProcessing == null ? void 0 : resolvedModulesProcessing.get(file.path)) || resolveModuleNamesReusingOldState(moduleNames, file);
	        Debug.assert(resolutions.length === moduleNames.length);
	        const optionsForFile = ((_a2 = getRedirectReferenceForResolution(file)) == null ? void 0 : _a2.commandLine.options) || options;
	        const resolutionsInFile = createModeAwareCache();
	        (resolvedModules ?? (resolvedModules = /* @__PURE__ */ new Map())).set(file.path, resolutionsInFile);
	        for (let index = 0; index < moduleNames.length; index++) {
	          const resolution = resolutions[index].resolvedModule;
	          const moduleName = moduleNames[index].text;
	          const mode = getModeForUsageLocationWorker(file, moduleNames[index], optionsForFile);
	          resolutionsInFile.set(moduleName, mode, resolutions[index]);
	          addResolutionDiagnosticsFromResolutionOrCache(file, moduleName, resolutions[index], mode);
	          if (!resolution) {
	            continue;
	          }
	          const isFromNodeModulesSearch = resolution.isExternalLibraryImport;
	          const isJsFile = !resolutionExtensionIsTSOrJson(resolution.extension);
	          const isJsFileFromNodeModules = isFromNodeModulesSearch && isJsFile && (!resolution.originalPath || pathContainsNodeModules(resolution.resolvedFileName));
	          const resolvedFileName = resolution.resolvedFileName;
	          if (isFromNodeModulesSearch) {
	            currentNodeModulesDepth++;
	          }
	          const elideImport = isJsFileFromNodeModules && currentNodeModulesDepth > maxNodeModuleJsDepth;
	          const shouldAddFile = resolvedFileName && !getResolutionDiagnostic(optionsForFile, resolution, file) && !optionsForFile.noResolve && index < file.imports.length && !elideImport && !(isJsFile && !getAllowJSCompilerOption(optionsForFile)) && (isInJSFile(file.imports[index]) || !(file.imports[index].flags & 16777216 /* JSDoc */));
	          if (elideImport) {
	            modulesWithElidedImports.set(file.path, true);
	          } else if (shouldAddFile) {
	            findSourceFile(
	              resolvedFileName,
	              /*isDefaultLib*/
	              false,
	              /*ignoreNoDefaultLib*/
	              false,
	              { kind: 3 /* Import */, file: file.path, index },
	              resolution.packageId
	            );
	          }
	          if (isFromNodeModulesSearch) {
	            currentNodeModulesDepth--;
	          }
	        }
	      }
	    }
	    function checkSourceFilesBelongToPath(sourceFiles, rootDirectory) {
	      let allFilesBelongToPath = true;
	      const absoluteRootDirectoryPath = host.getCanonicalFileName(getNormalizedAbsolutePath(rootDirectory, currentDirectory));
	      for (const sourceFile of sourceFiles) {
	        if (!sourceFile.isDeclarationFile) {
	          const absoluteSourceFilePath = host.getCanonicalFileName(getNormalizedAbsolutePath(sourceFile.fileName, currentDirectory));
	          if (absoluteSourceFilePath.indexOf(absoluteRootDirectoryPath) !== 0) {
	            addProgramDiagnosticExplainingFile(
	              sourceFile,
	              Diagnostics.File_0_is_not_under_rootDir_1_rootDir_is_expected_to_contain_all_source_files,
	              [sourceFile.fileName, rootDirectory]
	            );
	            allFilesBelongToPath = false;
	          }
	        }
	      }
	      return allFilesBelongToPath;
	    }
	    function parseProjectReferenceConfigFile(ref) {
	      if (!projectReferenceRedirects) {
	        projectReferenceRedirects = /* @__PURE__ */ new Map();
	      }
	      const refPath = resolveProjectReferencePath(ref);
	      const sourceFilePath = toPath3(refPath);
	      const fromCache = projectReferenceRedirects.get(sourceFilePath);
	      if (fromCache !== void 0) {
	        return fromCache || void 0;
	      }
	      let commandLine;
	      let sourceFile;
	      if (host.getParsedCommandLine) {
	        commandLine = host.getParsedCommandLine(refPath);
	        if (!commandLine) {
	          addFileToFilesByName(
	            /*file*/
	            void 0,
	            sourceFilePath,
	            refPath,
	            /*redirectedPath*/
	            void 0
	          );
	          projectReferenceRedirects.set(sourceFilePath, false);
	          return void 0;
	        }
	        sourceFile = Debug.checkDefined(commandLine.options.configFile);
	        Debug.assert(!sourceFile.path || sourceFile.path === sourceFilePath);
	        addFileToFilesByName(
	          sourceFile,
	          sourceFilePath,
	          refPath,
	          /*redirectedPath*/
	          void 0
	        );
	      } else {
	        const basePath = getNormalizedAbsolutePath(getDirectoryPath(refPath), currentDirectory);
	        sourceFile = host.getSourceFile(refPath, 100 /* JSON */);
	        addFileToFilesByName(
	          sourceFile,
	          sourceFilePath,
	          refPath,
	          /*redirectedPath*/
	          void 0
	        );
	        if (sourceFile === void 0) {
	          projectReferenceRedirects.set(sourceFilePath, false);
	          return void 0;
	        }
	        commandLine = parseJsonSourceFileConfigFileContent(
	          sourceFile,
	          configParsingHost,
	          basePath,
	          /*existingOptions*/
	          void 0,
	          refPath
	        );
	      }
	      sourceFile.fileName = refPath;
	      sourceFile.path = sourceFilePath;
	      sourceFile.resolvedPath = sourceFilePath;
	      sourceFile.originalFileName = refPath;
	      const resolvedRef = { commandLine, sourceFile };
	      projectReferenceRedirects.set(sourceFilePath, resolvedRef);
	      if (commandLine.projectReferences) {
	        resolvedRef.references = commandLine.projectReferences.map(parseProjectReferenceConfigFile);
	      }
	      return resolvedRef;
	    }
	    function verifyCompilerOptions() {
	      if (options.strictPropertyInitialization && !getStrictOptionValue(options, "strictNullChecks")) {
	        createDiagnosticForOptionName(Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1, "strictPropertyInitialization", "strictNullChecks");
	      }
	      if (options.exactOptionalPropertyTypes && !getStrictOptionValue(options, "strictNullChecks")) {
	        createDiagnosticForOptionName(Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1, "exactOptionalPropertyTypes", "strictNullChecks");
	      }
	      if (options.isolatedModules || options.verbatimModuleSyntax) {
	        if (options.out) {
	          createDiagnosticForOptionName(Diagnostics.Option_0_cannot_be_specified_with_option_1, "out", options.verbatimModuleSyntax ? "verbatimModuleSyntax" : "isolatedModules");
	        }
	        if (options.outFile) {
	          createDiagnosticForOptionName(Diagnostics.Option_0_cannot_be_specified_with_option_1, "outFile", options.verbatimModuleSyntax ? "verbatimModuleSyntax" : "isolatedModules");
	        }
	      }
	      if (options.inlineSourceMap) {
	        if (options.sourceMap) {
	          createDiagnosticForOptionName(Diagnostics.Option_0_cannot_be_specified_with_option_1, "sourceMap", "inlineSourceMap");
	        }
	        if (options.mapRoot) {
	          createDiagnosticForOptionName(Diagnostics.Option_0_cannot_be_specified_with_option_1, "mapRoot", "inlineSourceMap");
	        }
	      }
	      if (options.composite) {
	        if (options.declaration === false) {
	          createDiagnosticForOptionName(Diagnostics.Composite_projects_may_not_disable_declaration_emit, "declaration");
	        }
	        if (options.incremental === false) {
	          createDiagnosticForOptionName(Diagnostics.Composite_projects_may_not_disable_incremental_compilation, "declaration");
	        }
	      }
	      const outputFile = outFile(options);
	      if (options.tsBuildInfoFile) {
	        if (!isIncrementalCompilation(options)) {
	          createDiagnosticForOptionName(Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1_or_option_2, "tsBuildInfoFile", "incremental", "composite");
	        }
	      } else if (options.incremental && !outputFile && !options.configFilePath) {
	        programDiagnostics.add(createCompilerDiagnostic(Diagnostics.Option_incremental_can_only_be_specified_using_tsconfig_emitting_to_single_file_or_when_option_tsBuildInfoFile_is_specified));
	      }
	      verifyDeprecatedCompilerOptions();
	      verifyProjectReferences();
	      if (options.composite) {
	        const rootPaths = new Set(rootNames.map(toPath3));
	        for (const file of files) {
	          if (sourceFileMayBeEmitted(file, program) && !rootPaths.has(file.path)) {
	            addProgramDiagnosticExplainingFile(
	              file,
	              Diagnostics.File_0_is_not_listed_within_the_file_list_of_project_1_Projects_must_list_all_files_or_use_an_include_pattern,
	              [file.fileName, options.configFilePath || ""]
	            );
	          }
	        }
	      }
	      if (options.paths) {
	        for (const key in options.paths) {
	          if (!hasProperty(options.paths, key)) {
	            continue;
	          }
	          if (!hasZeroOrOneAsteriskCharacter(key)) {
	            createDiagnosticForOptionPaths(
	              /*onKey*/
	              true,
	              key,
	              Diagnostics.Pattern_0_can_have_at_most_one_Asterisk_character,
	              key
	            );
	          }
	          if (isArray(options.paths[key])) {
	            const len = options.paths[key].length;
	            if (len === 0) {
	              createDiagnosticForOptionPaths(
	                /*onKey*/
	                false,
	                key,
	                Diagnostics.Substitutions_for_pattern_0_shouldn_t_be_an_empty_array,
	                key
	              );
	            }
	            for (let i = 0; i < len; i++) {
	              const subst = options.paths[key][i];
	              const typeOfSubst = typeof subst;
	              if (typeOfSubst === "string") {
	                if (!hasZeroOrOneAsteriskCharacter(subst)) {
	                  createDiagnosticForOptionPathKeyValue(key, i, Diagnostics.Substitution_0_in_pattern_1_can_have_at_most_one_Asterisk_character, subst, key);
	                }
	                if (!options.baseUrl && !pathIsRelative(subst) && !pathIsAbsolute(subst)) {
	                  createDiagnosticForOptionPathKeyValue(key, i, Diagnostics.Non_relative_paths_are_not_allowed_when_baseUrl_is_not_set_Did_you_forget_a_leading_Slash);
	                }
	              } else {
	                createDiagnosticForOptionPathKeyValue(key, i, Diagnostics.Substitution_0_for_pattern_1_has_incorrect_type_expected_string_got_2, subst, key, typeOfSubst);
	              }
	            }
	          } else {
	            createDiagnosticForOptionPaths(
	              /*onKey*/
	              false,
	              key,
	              Diagnostics.Substitutions_for_pattern_0_should_be_an_array,
	              key
	            );
	          }
	        }
	      }
	      if (!options.sourceMap && !options.inlineSourceMap) {
	        if (options.inlineSources) {
	          createDiagnosticForOptionName(Diagnostics.Option_0_can_only_be_used_when_either_option_inlineSourceMap_or_option_sourceMap_is_provided, "inlineSources");
	        }
	        if (options.sourceRoot) {
	          createDiagnosticForOptionName(Diagnostics.Option_0_can_only_be_used_when_either_option_inlineSourceMap_or_option_sourceMap_is_provided, "sourceRoot");
	        }
	      }
	      if (options.out && options.outFile) {
	        createDiagnosticForOptionName(Diagnostics.Option_0_cannot_be_specified_with_option_1, "out", "outFile");
	      }
	      if (options.mapRoot && !(options.sourceMap || options.declarationMap)) {
	        createDiagnosticForOptionName(Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1_or_option_2, "mapRoot", "sourceMap", "declarationMap");
	      }
	      if (options.declarationDir) {
	        if (!getEmitDeclarations(options)) {
	          createDiagnosticForOptionName(Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1_or_option_2, "declarationDir", "declaration", "composite");
	        }
	        if (outputFile) {
	          createDiagnosticForOptionName(Diagnostics.Option_0_cannot_be_specified_with_option_1, "declarationDir", options.out ? "out" : "outFile");
	        }
	      }
	      if (options.declarationMap && !getEmitDeclarations(options)) {
	        createDiagnosticForOptionName(Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1_or_option_2, "declarationMap", "declaration", "composite");
	      }
	      if (options.lib && options.noLib) {
	        createDiagnosticForOptionName(Diagnostics.Option_0_cannot_be_specified_with_option_1, "lib", "noLib");
	      }
	      if (options.noImplicitUseStrict && getStrictOptionValue(options, "alwaysStrict")) {
	        createDiagnosticForOptionName(Diagnostics.Option_0_cannot_be_specified_with_option_1, "noImplicitUseStrict", "alwaysStrict");
	      }
	      const languageVersion = getEmitScriptTarget(options);
	      const firstNonAmbientExternalModuleSourceFile = find(files, (f) => isExternalModule(f) && !f.isDeclarationFile);
	      if (options.isolatedModules || options.verbatimModuleSyntax) {
	        if (options.module === 0 /* None */ && languageVersion < 2 /* ES2015 */ && options.isolatedModules) {
	          createDiagnosticForOptionName(Diagnostics.Option_isolatedModules_can_only_be_used_when_either_option_module_is_provided_or_option_target_is_ES2015_or_higher, "isolatedModules", "target");
	        }
	        if (options.preserveConstEnums === false) {
	          createDiagnosticForOptionName(Diagnostics.Option_preserveConstEnums_cannot_be_disabled_when_0_is_enabled, options.verbatimModuleSyntax ? "verbatimModuleSyntax" : "isolatedModules", "preserveConstEnums");
	        }
	      } else if (firstNonAmbientExternalModuleSourceFile && languageVersion < 2 /* ES2015 */ && options.module === 0 /* None */) {
	        const span = getErrorSpanForNode(firstNonAmbientExternalModuleSourceFile, typeof firstNonAmbientExternalModuleSourceFile.externalModuleIndicator === "boolean" ? firstNonAmbientExternalModuleSourceFile : firstNonAmbientExternalModuleSourceFile.externalModuleIndicator);
	        programDiagnostics.add(createFileDiagnostic(firstNonAmbientExternalModuleSourceFile, span.start, span.length, Diagnostics.Cannot_use_imports_exports_or_module_augmentations_when_module_is_none));
	      }
	      if (outputFile && !options.emitDeclarationOnly) {
	        if (options.module && !(options.module === 2 /* AMD */ || options.module === 4 /* System */)) {
	          createDiagnosticForOptionName(Diagnostics.Only_amd_and_system_modules_are_supported_alongside_0, options.out ? "out" : "outFile", "module");
	        } else if (options.module === void 0 && firstNonAmbientExternalModuleSourceFile) {
	          const span = getErrorSpanForNode(firstNonAmbientExternalModuleSourceFile, typeof firstNonAmbientExternalModuleSourceFile.externalModuleIndicator === "boolean" ? firstNonAmbientExternalModuleSourceFile : firstNonAmbientExternalModuleSourceFile.externalModuleIndicator);
	          programDiagnostics.add(createFileDiagnostic(firstNonAmbientExternalModuleSourceFile, span.start, span.length, Diagnostics.Cannot_compile_modules_using_option_0_unless_the_module_flag_is_amd_or_system, options.out ? "out" : "outFile"));
	        }
	      }
	      if (getResolveJsonModule(options)) {
	        if (getEmitModuleResolutionKind(options) === 1 /* Classic */) {
	          createDiagnosticForOptionName(Diagnostics.Option_resolveJsonModule_cannot_be_specified_when_moduleResolution_is_set_to_classic, "resolveJsonModule");
	        } else if (!hasJsonModuleEmitEnabled(options)) {
	          createDiagnosticForOptionName(Diagnostics.Option_resolveJsonModule_cannot_be_specified_when_module_is_set_to_none_system_or_umd, "resolveJsonModule", "module");
	        }
	      }
	      if (options.outDir || // there is --outDir specified
	      options.rootDir || // there is --rootDir specified
	      options.sourceRoot || // there is --sourceRoot specified
	      options.mapRoot) {
	        const dir = getCommonSourceDirectory2();
	        if (options.outDir && dir === "" && files.some((file) => getRootLength(file.fileName) > 1)) {
	          createDiagnosticForOptionName(Diagnostics.Cannot_find_the_common_subdirectory_path_for_the_input_files, "outDir");
	        }
	      }
	      if (options.useDefineForClassFields && languageVersion === 0 /* ES3 */) {
	        createDiagnosticForOptionName(Diagnostics.Option_0_cannot_be_specified_when_option_target_is_ES3, "useDefineForClassFields");
	      }
	      if (options.checkJs && !getAllowJSCompilerOption(options)) {
	        programDiagnostics.add(createCompilerDiagnostic(Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1, "checkJs", "allowJs"));
	      }
	      if (options.emitDeclarationOnly) {
	        if (!getEmitDeclarations(options)) {
	          createDiagnosticForOptionName(Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1_or_option_2, "emitDeclarationOnly", "declaration", "composite");
	        }
	        if (options.noEmit) {
	          createDiagnosticForOptionName(Diagnostics.Option_0_cannot_be_specified_with_option_1, "emitDeclarationOnly", "noEmit");
	        }
	      }
	      if (options.emitDecoratorMetadata && !options.experimentalDecorators) {
	        createDiagnosticForOptionName(Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1, "emitDecoratorMetadata", "experimentalDecorators");
	      }
	      if (options.jsxFactory) {
	        if (options.reactNamespace) {
	          createDiagnosticForOptionName(Diagnostics.Option_0_cannot_be_specified_with_option_1, "reactNamespace", "jsxFactory");
	        }
	        if (options.jsx === 4 /* ReactJSX */ || options.jsx === 5 /* ReactJSXDev */) {
	          createDiagnosticForOptionName(Diagnostics.Option_0_cannot_be_specified_when_option_jsx_is_1, "jsxFactory", inverseJsxOptionMap.get("" + options.jsx));
	        }
	        if (!parseIsolatedEntityName(options.jsxFactory, languageVersion)) {
	          createOptionValueDiagnostic("jsxFactory", Diagnostics.Invalid_value_for_jsxFactory_0_is_not_a_valid_identifier_or_qualified_name, options.jsxFactory);
	        }
	      } else if (options.reactNamespace && !isIdentifierText(options.reactNamespace, languageVersion)) {
	        createOptionValueDiagnostic("reactNamespace", Diagnostics.Invalid_value_for_reactNamespace_0_is_not_a_valid_identifier, options.reactNamespace);
	      }
	      if (options.jsxFragmentFactory) {
	        if (!options.jsxFactory) {
	          createDiagnosticForOptionName(Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1, "jsxFragmentFactory", "jsxFactory");
	        }
	        if (options.jsx === 4 /* ReactJSX */ || options.jsx === 5 /* ReactJSXDev */) {
	          createDiagnosticForOptionName(Diagnostics.Option_0_cannot_be_specified_when_option_jsx_is_1, "jsxFragmentFactory", inverseJsxOptionMap.get("" + options.jsx));
	        }
	        if (!parseIsolatedEntityName(options.jsxFragmentFactory, languageVersion)) {
	          createOptionValueDiagnostic("jsxFragmentFactory", Diagnostics.Invalid_value_for_jsxFragmentFactory_0_is_not_a_valid_identifier_or_qualified_name, options.jsxFragmentFactory);
	        }
	      }
	      if (options.reactNamespace) {
	        if (options.jsx === 4 /* ReactJSX */ || options.jsx === 5 /* ReactJSXDev */) {
	          createDiagnosticForOptionName(Diagnostics.Option_0_cannot_be_specified_when_option_jsx_is_1, "reactNamespace", inverseJsxOptionMap.get("" + options.jsx));
	        }
	      }
	      if (options.jsxImportSource) {
	        if (options.jsx === 2 /* React */) {
	          createDiagnosticForOptionName(Diagnostics.Option_0_cannot_be_specified_when_option_jsx_is_1, "jsxImportSource", inverseJsxOptionMap.get("" + options.jsx));
	        }
	      }
	      if (options.preserveValueImports && getEmitModuleKind(options) < 5 /* ES2015 */) {
	        createDiagnosticForOptionName(Diagnostics.Option_0_can_only_be_used_when_module_is_set_to_preserve_or_to_es2015_or_later, "preserveValueImports");
	      }
	      const moduleKind = getEmitModuleKind(options);
	      if (options.verbatimModuleSyntax) {
	        if (moduleKind === 2 /* AMD */ || moduleKind === 3 /* UMD */ || moduleKind === 4 /* System */) {
	          createDiagnosticForOptionName(Diagnostics.Option_verbatimModuleSyntax_cannot_be_used_when_module_is_set_to_UMD_AMD_or_System, "verbatimModuleSyntax");
	        }
	        if (options.preserveValueImports) {
	          createRedundantOptionDiagnostic("preserveValueImports", "verbatimModuleSyntax");
	        }
	        if (options.importsNotUsedAsValues) {
	          createRedundantOptionDiagnostic("importsNotUsedAsValues", "verbatimModuleSyntax");
	        }
	      }
	      if (options.allowImportingTsExtensions && !(options.noEmit || options.emitDeclarationOnly)) {
	        createOptionValueDiagnostic("allowImportingTsExtensions", Diagnostics.Option_allowImportingTsExtensions_can_only_be_used_when_either_noEmit_or_emitDeclarationOnly_is_set);
	      }
	      const moduleResolution = getEmitModuleResolutionKind(options);
	      if (options.resolvePackageJsonExports && !moduleResolutionSupportsPackageJsonExportsAndImports(moduleResolution)) {
	        createDiagnosticForOptionName(Diagnostics.Option_0_can_only_be_used_when_moduleResolution_is_set_to_node16_nodenext_or_bundler, "resolvePackageJsonExports");
	      }
	      if (options.resolvePackageJsonImports && !moduleResolutionSupportsPackageJsonExportsAndImports(moduleResolution)) {
	        createDiagnosticForOptionName(Diagnostics.Option_0_can_only_be_used_when_moduleResolution_is_set_to_node16_nodenext_or_bundler, "resolvePackageJsonImports");
	      }
	      if (options.customConditions && !moduleResolutionSupportsPackageJsonExportsAndImports(moduleResolution)) {
	        createDiagnosticForOptionName(Diagnostics.Option_0_can_only_be_used_when_moduleResolution_is_set_to_node16_nodenext_or_bundler, "customConditions");
	      }
	      if (moduleResolution === 100 /* Bundler */ && !emitModuleKindIsNonNodeESM(moduleKind) && moduleKind !== 200 /* Preserve */) {
	        createOptionValueDiagnostic("moduleResolution", Diagnostics.Option_0_can_only_be_used_when_module_is_set_to_preserve_or_to_es2015_or_later, "bundler");
	      }
	      if (ModuleKind[moduleKind] && (100 /* Node16 */ <= moduleKind && moduleKind <= 199 /* NodeNext */) && !(3 /* Node16 */ <= moduleResolution && moduleResolution <= 99 /* NodeNext */)) {
	        const moduleKindName = ModuleKind[moduleKind];
	        createOptionValueDiagnostic("moduleResolution", Diagnostics.Option_moduleResolution_must_be_set_to_0_or_left_unspecified_when_option_module_is_set_to_1, moduleKindName, moduleKindName);
	      } else if (ModuleResolutionKind[moduleResolution] && (3 /* Node16 */ <= moduleResolution && moduleResolution <= 99 /* NodeNext */) && !(100 /* Node16 */ <= moduleKind && moduleKind <= 199 /* NodeNext */)) {
	        const moduleResolutionName = ModuleResolutionKind[moduleResolution];
	        createOptionValueDiagnostic("module", Diagnostics.Option_module_must_be_set_to_0_when_option_moduleResolution_is_set_to_1, moduleResolutionName, moduleResolutionName);
	      }
	      if (!options.noEmit && !options.suppressOutputPathCheck) {
	        const emitHost = getEmitHost();
	        const emitFilesSeen = /* @__PURE__ */ new Set();
	        forEachEmittedFile(emitHost, (emitFileNames) => {
	          if (!options.emitDeclarationOnly) {
	            verifyEmitFilePath(emitFileNames.jsFilePath, emitFilesSeen);
	          }
	          verifyEmitFilePath(emitFileNames.declarationFilePath, emitFilesSeen);
	        });
	      }
	      function verifyEmitFilePath(emitFileName, emitFilesSeen) {
	        if (emitFileName) {
	          const emitFilePath = toPath3(emitFileName);
	          if (filesByName.has(emitFilePath)) {
	            let chain;
	            if (!options.configFilePath) {
	              chain = chainDiagnosticMessages(
	                /*details*/
	                void 0,
	                Diagnostics.Adding_a_tsconfig_json_file_will_help_organize_projects_that_contain_both_TypeScript_and_JavaScript_files_Learn_more_at_https_Colon_Slash_Slashaka_ms_Slashtsconfig
	              );
	            }
	            chain = chainDiagnosticMessages(chain, Diagnostics.Cannot_write_file_0_because_it_would_overwrite_input_file, emitFileName);
	            blockEmittingOfFile(emitFileName, createCompilerDiagnosticFromMessageChain(chain));
	          }
	          const emitFileKey = !host.useCaseSensitiveFileNames() ? toFileNameLowerCase(emitFilePath) : emitFilePath;
	          if (emitFilesSeen.has(emitFileKey)) {
	            blockEmittingOfFile(emitFileName, createCompilerDiagnostic(Diagnostics.Cannot_write_file_0_because_it_would_be_overwritten_by_multiple_input_files, emitFileName));
	          } else {
	            emitFilesSeen.add(emitFileKey);
	          }
	        }
	      }
	    }
	    function getIgnoreDeprecationsVersion() {
	      const ignoreDeprecations = options.ignoreDeprecations;
	      if (ignoreDeprecations) {
	        if (ignoreDeprecations === "5.0") {
	          return new Version(ignoreDeprecations);
	        }
	        reportInvalidIgnoreDeprecations();
	      }
	      return Version.zero;
	    }
	    function checkDeprecations(deprecatedIn, removedIn, createDiagnostic, fn) {
	      const deprecatedInVersion = new Version(deprecatedIn);
	      const removedInVersion = new Version(removedIn);
	      const typescriptVersion = new Version(typeScriptVersion3 || versionMajorMinor);
	      const ignoreDeprecationsVersion = getIgnoreDeprecationsVersion();
	      const mustBeRemoved = !(removedInVersion.compareTo(typescriptVersion) === 1 /* GreaterThan */);
	      const canBeSilenced = !mustBeRemoved && ignoreDeprecationsVersion.compareTo(deprecatedInVersion) === -1 /* LessThan */;
	      if (mustBeRemoved || canBeSilenced) {
	        fn((name, value, useInstead) => {
	          if (mustBeRemoved) {
	            if (value === void 0) {
	              createDiagnostic(name, value, useInstead, Diagnostics.Option_0_has_been_removed_Please_remove_it_from_your_configuration, name);
	            } else {
	              createDiagnostic(name, value, useInstead, Diagnostics.Option_0_1_has_been_removed_Please_remove_it_from_your_configuration, name, value);
	            }
	          } else {
	            if (value === void 0) {
	              createDiagnostic(name, value, useInstead, Diagnostics.Option_0_is_deprecated_and_will_stop_functioning_in_TypeScript_1_Specify_compilerOption_ignoreDeprecations_Colon_2_to_silence_this_error, name, removedIn, deprecatedIn);
	            } else {
	              createDiagnostic(name, value, useInstead, Diagnostics.Option_0_1_is_deprecated_and_will_stop_functioning_in_TypeScript_2_Specify_compilerOption_ignoreDeprecations_Colon_3_to_silence_this_error, name, value, removedIn, deprecatedIn);
	            }
	          }
	        });
	      }
	    }
	    function verifyDeprecatedCompilerOptions() {
	      function createDiagnostic(name, value, useInstead, message, ...args) {
	        if (useInstead) {
	          const details = chainDiagnosticMessages(
	            /*details*/
	            void 0,
	            Diagnostics.Use_0_instead,
	            useInstead
	          );
	          const chain = chainDiagnosticMessages(details, message, ...args);
	          createDiagnosticForOption(
	            /*onKey*/
	            !value,
	            name,
	            /*option2*/
	            void 0,
	            chain
	          );
	        } else {
	          createDiagnosticForOption(
	            /*onKey*/
	            !value,
	            name,
	            /*option2*/
	            void 0,
	            message,
	            ...args
	          );
	        }
	      }
	      checkDeprecations("5.0", "5.5", createDiagnostic, (createDeprecatedDiagnostic) => {
	        if (options.target === 0 /* ES3 */) {
	          createDeprecatedDiagnostic("target", "ES3");
	        }
	        if (options.noImplicitUseStrict) {
	          createDeprecatedDiagnostic("noImplicitUseStrict");
	        }
	        if (options.keyofStringsOnly) {
	          createDeprecatedDiagnostic("keyofStringsOnly");
	        }
	        if (options.suppressExcessPropertyErrors) {
	          createDeprecatedDiagnostic("suppressExcessPropertyErrors");
	        }
	        if (options.suppressImplicitAnyIndexErrors) {
	          createDeprecatedDiagnostic("suppressImplicitAnyIndexErrors");
	        }
	        if (options.noStrictGenericChecks) {
	          createDeprecatedDiagnostic("noStrictGenericChecks");
	        }
	        if (options.charset) {
	          createDeprecatedDiagnostic("charset");
	        }
	        if (options.out) {
	          createDeprecatedDiagnostic(
	            "out",
	            /*value*/
	            void 0,
	            "outFile"
	          );
	        }
	        if (options.importsNotUsedAsValues) {
	          createDeprecatedDiagnostic(
	            "importsNotUsedAsValues",
	            /*value*/
	            void 0,
	            "verbatimModuleSyntax"
	          );
	        }
	        if (options.preserveValueImports) {
	          createDeprecatedDiagnostic(
	            "preserveValueImports",
	            /*value*/
	            void 0,
	            "verbatimModuleSyntax"
	          );
	        }
	      });
	    }
	    function verifyDeprecatedProjectReference(ref, parentFile, index) {
	      function createDiagnostic(_name, _value, _useInstead, message, ...args) {
	        createDiagnosticForReference(parentFile, index, message, ...args);
	      }
	      checkDeprecations("5.0", "5.5", createDiagnostic, (createDeprecatedDiagnostic) => {
	        if (ref.prepend) {
	          createDeprecatedDiagnostic("prepend");
	        }
	      });
	    }
	    function createDiagnosticExplainingFile(file, fileProcessingReason, diagnostic, args) {
	      var _a2;
	      let fileIncludeReasons;
	      let relatedInfo;
	      let locationReason = isReferencedFile(fileProcessingReason) ? fileProcessingReason : void 0;
	      if (file)
	        (_a2 = fileReasons.get(file.path)) == null ? void 0 : _a2.forEach(processReason);
	      if (fileProcessingReason)
	        processReason(fileProcessingReason);
	      if (locationReason && (fileIncludeReasons == null ? void 0 : fileIncludeReasons.length) === 1)
	        fileIncludeReasons = void 0;
	      const location = locationReason && getReferencedFileLocation(program, locationReason);
	      const fileIncludeReasonDetails = fileIncludeReasons && chainDiagnosticMessages(fileIncludeReasons, Diagnostics.The_file_is_in_the_program_because_Colon);
	      const redirectInfo = file && explainIfFileIsRedirectAndImpliedFormat(file);
	      const chain = chainDiagnosticMessages(redirectInfo ? fileIncludeReasonDetails ? [fileIncludeReasonDetails, ...redirectInfo] : redirectInfo : fileIncludeReasonDetails, diagnostic, ...args || emptyArray);
	      return location && isReferenceFileLocation(location) ? createFileDiagnosticFromMessageChain(location.file, location.pos, location.end - location.pos, chain, relatedInfo) : createCompilerDiagnosticFromMessageChain(chain, relatedInfo);
	      function processReason(reason) {
	        (fileIncludeReasons || (fileIncludeReasons = [])).push(fileIncludeReasonToDiagnostics(program, reason));
	        if (!locationReason && isReferencedFile(reason)) {
	          locationReason = reason;
	        } else if (locationReason !== reason) {
	          relatedInfo = append(relatedInfo, fileIncludeReasonToRelatedInformation(reason));
	        }
	        if (reason === fileProcessingReason)
	          fileProcessingReason = void 0;
	      }
	    }
	    function addFilePreprocessingFileExplainingDiagnostic(file, fileProcessingReason, diagnostic, args) {
	      (fileProcessingDiagnostics || (fileProcessingDiagnostics = [])).push({
	        kind: 1 /* FilePreprocessingFileExplainingDiagnostic */,
	        file: file && file.path,
	        fileProcessingReason,
	        diagnostic,
	        args
	      });
	    }
	    function addProgramDiagnosticExplainingFile(file, diagnostic, args) {
	      programDiagnostics.add(createDiagnosticExplainingFile(
	        file,
	        /*fileProcessingReason*/
	        void 0,
	        diagnostic,
	        args
	      ));
	    }
	    function fileIncludeReasonToRelatedInformation(reason) {
	      if (isReferencedFile(reason)) {
	        const referenceLocation = getReferencedFileLocation(program, reason);
	        let message2;
	        switch (reason.kind) {
	          case 3 /* Import */:
	            message2 = Diagnostics.File_is_included_via_import_here;
	            break;
	          case 4 /* ReferenceFile */:
	            message2 = Diagnostics.File_is_included_via_reference_here;
	            break;
	          case 5 /* TypeReferenceDirective */:
	            message2 = Diagnostics.File_is_included_via_type_library_reference_here;
	            break;
	          case 7 /* LibReferenceDirective */:
	            message2 = Diagnostics.File_is_included_via_library_reference_here;
	            break;
	          default:
	            Debug.assertNever(reason);
	        }
	        return isReferenceFileLocation(referenceLocation) ? createFileDiagnostic(
	          referenceLocation.file,
	          referenceLocation.pos,
	          referenceLocation.end - referenceLocation.pos,
	          message2
	        ) : void 0;
	      }
	      if (!options.configFile)
	        return void 0;
	      let configFileNode;
	      let message;
	      switch (reason.kind) {
	        case 0 /* RootFile */:
	          if (!options.configFile.configFileSpecs)
	            return void 0;
	          const fileName = getNormalizedAbsolutePath(rootNames[reason.index], currentDirectory);
	          const matchedByFiles = getMatchedFileSpec(program, fileName);
	          if (matchedByFiles) {
	            configFileNode = getTsConfigPropArrayElementValue(options.configFile, "files", matchedByFiles);
	            message = Diagnostics.File_is_matched_by_files_list_specified_here;
	            break;
	          }
	          const matchedByInclude = getMatchedIncludeSpec(program, fileName);
	          if (!matchedByInclude || !isString(matchedByInclude))
	            return void 0;
	          configFileNode = getTsConfigPropArrayElementValue(options.configFile, "include", matchedByInclude);
	          message = Diagnostics.File_is_matched_by_include_pattern_specified_here;
	          break;
	        case 1 /* SourceFromProjectReference */:
	        case 2 /* OutputFromProjectReference */:
	          const referencedResolvedRef = Debug.checkDefined(resolvedProjectReferences == null ? void 0 : resolvedProjectReferences[reason.index]);
	          const referenceInfo = forEachProjectReference(projectReferences, resolvedProjectReferences, (resolvedRef, parent2, index2) => resolvedRef === referencedResolvedRef ? { sourceFile: (parent2 == null ? void 0 : parent2.sourceFile) || options.configFile, index: index2 } : void 0);
	          if (!referenceInfo)
	            return void 0;
	          const { sourceFile, index } = referenceInfo;
	          const referencesSyntax = forEachTsConfigPropArray(sourceFile, "references", (property) => isArrayLiteralExpression(property.initializer) ? property.initializer : void 0);
	          return referencesSyntax && referencesSyntax.elements.length > index ? createDiagnosticForNodeInSourceFile(
	            sourceFile,
	            referencesSyntax.elements[index],
	            reason.kind === 2 /* OutputFromProjectReference */ ? Diagnostics.File_is_output_from_referenced_project_specified_here : Diagnostics.File_is_source_from_referenced_project_specified_here
	          ) : void 0;
	        case 8 /* AutomaticTypeDirectiveFile */:
	          if (!options.types)
	            return void 0;
	          configFileNode = getOptionsSyntaxByArrayElementValue("types", reason.typeReference);
	          message = Diagnostics.File_is_entry_point_of_type_library_specified_here;
	          break;
	        case 6 /* LibFile */:
	          if (reason.index !== void 0) {
	            configFileNode = getOptionsSyntaxByArrayElementValue("lib", options.lib[reason.index]);
	            message = Diagnostics.File_is_library_specified_here;
	            break;
	          }
	          const target = forEachEntry(targetOptionDeclaration.type, (value, key) => value === getEmitScriptTarget(options) ? key : void 0);
	          configFileNode = target ? getOptionsSyntaxByValue("target", target) : void 0;
	          message = Diagnostics.File_is_default_library_for_target_specified_here;
	          break;
	        default:
	          Debug.assertNever(reason);
	      }
	      return configFileNode && createDiagnosticForNodeInSourceFile(
	        options.configFile,
	        configFileNode,
	        message
	      );
	    }
	    function verifyProjectReferences() {
	      const buildInfoPath = !options.suppressOutputPathCheck ? getTsBuildInfoEmitOutputFilePath(options) : void 0;
	      forEachProjectReference(projectReferences, resolvedProjectReferences, (resolvedRef, parent2, index) => {
	        const ref = (parent2 ? parent2.commandLine.projectReferences : projectReferences)[index];
	        const parentFile = parent2 && parent2.sourceFile;
	        verifyDeprecatedProjectReference(ref, parentFile, index);
	        if (!resolvedRef) {
	          createDiagnosticForReference(parentFile, index, Diagnostics.File_0_not_found, ref.path);
	          return;
	        }
	        const options2 = resolvedRef.commandLine.options;
	        if (!options2.composite || options2.noEmit) {
	          const inputs = parent2 ? parent2.commandLine.fileNames : rootNames;
	          if (inputs.length) {
	            if (!options2.composite)
	              createDiagnosticForReference(parentFile, index, Diagnostics.Referenced_project_0_must_have_setting_composite_Colon_true, ref.path);
	            if (options2.noEmit)
	              createDiagnosticForReference(parentFile, index, Diagnostics.Referenced_project_0_may_not_disable_emit, ref.path);
	          }
	        }
	        if (ref.prepend) {
	          const out = outFile(options2);
	          if (out) {
	            if (!host.fileExists(out)) {
	              createDiagnosticForReference(parentFile, index, Diagnostics.Output_file_0_from_project_1_does_not_exist, out, ref.path);
	            }
	          } else {
	            createDiagnosticForReference(parentFile, index, Diagnostics.Cannot_prepend_project_0_because_it_does_not_have_outFile_set, ref.path);
	          }
	        }
	        if (!parent2 && buildInfoPath && buildInfoPath === getTsBuildInfoEmitOutputFilePath(options2)) {
	          createDiagnosticForReference(parentFile, index, Diagnostics.Cannot_write_file_0_because_it_will_overwrite_tsbuildinfo_file_generated_by_referenced_project_1, buildInfoPath, ref.path);
	          hasEmitBlockingDiagnostics.set(toPath3(buildInfoPath), true);
	        }
	      });
	    }
	    function createDiagnosticForOptionPathKeyValue(key, valueIndex, message, ...args) {
	      let needCompilerDiagnostic = true;
	      forEachOptionPathsSyntax((pathProp) => {
	        if (isObjectLiteralExpression(pathProp.initializer)) {
	          forEachPropertyAssignment(pathProp.initializer, key, (keyProps) => {
	            const initializer = keyProps.initializer;
	            if (isArrayLiteralExpression(initializer) && initializer.elements.length > valueIndex) {
	              programDiagnostics.add(createDiagnosticForNodeInSourceFile(options.configFile, initializer.elements[valueIndex], message, ...args));
	              needCompilerDiagnostic = false;
	            }
	          });
	        }
	      });
	      if (needCompilerDiagnostic) {
	        programDiagnostics.add(createCompilerDiagnostic(message, ...args));
	      }
	    }
	    function createDiagnosticForOptionPaths(onKey, key, message, ...args) {
	      let needCompilerDiagnostic = true;
	      forEachOptionPathsSyntax((pathProp) => {
	        if (isObjectLiteralExpression(pathProp.initializer) && createOptionDiagnosticInObjectLiteralSyntax(
	          pathProp.initializer,
	          onKey,
	          key,
	          /*key2*/
	          void 0,
	          message,
	          ...args
	        )) {
	          needCompilerDiagnostic = false;
	        }
	      });
	      if (needCompilerDiagnostic) {
	        programDiagnostics.add(createCompilerDiagnostic(message, ...args));
	      }
	    }
	    function forEachOptionsSyntaxByName(name, callback) {
	      return forEachPropertyAssignment(getCompilerOptionsObjectLiteralSyntax(), name, callback);
	    }
	    function forEachOptionPathsSyntax(callback) {
	      return forEachOptionsSyntaxByName("paths", callback);
	    }
	    function getOptionsSyntaxByValue(name, value) {
	      return forEachOptionsSyntaxByName(name, (property) => isStringLiteral(property.initializer) && property.initializer.text === value ? property.initializer : void 0);
	    }
	    function getOptionsSyntaxByArrayElementValue(name, value) {
	      const compilerOptionsObjectLiteralSyntax = getCompilerOptionsObjectLiteralSyntax();
	      return compilerOptionsObjectLiteralSyntax && getPropertyArrayElementValue(compilerOptionsObjectLiteralSyntax, name, value);
	    }
	    function createDiagnosticForOptionName(message, option1, option2, option3) {
	      createDiagnosticForOption(
	        /*onKey*/
	        true,
	        option1,
	        option2,
	        message,
	        option1,
	        option2,
	        option3
	      );
	    }
	    function createOptionValueDiagnostic(option1, message, ...args) {
	      createDiagnosticForOption(
	        /*onKey*/
	        false,
	        option1,
	        /*option2*/
	        void 0,
	        message,
	        ...args
	      );
	    }
	    function createDiagnosticForReference(sourceFile, index, message, ...args) {
	      const referencesSyntax = forEachTsConfigPropArray(sourceFile || options.configFile, "references", (property) => isArrayLiteralExpression(property.initializer) ? property.initializer : void 0);
	      if (referencesSyntax && referencesSyntax.elements.length > index) {
	        programDiagnostics.add(createDiagnosticForNodeInSourceFile(sourceFile || options.configFile, referencesSyntax.elements[index], message, ...args));
	      } else {
	        programDiagnostics.add(createCompilerDiagnostic(message, ...args));
	      }
	    }
	    function createDiagnosticForOption(onKey, option1, option2, message, ...args) {
	      const compilerOptionsObjectLiteralSyntax = getCompilerOptionsObjectLiteralSyntax();
	      const needCompilerDiagnostic = !compilerOptionsObjectLiteralSyntax || !createOptionDiagnosticInObjectLiteralSyntax(compilerOptionsObjectLiteralSyntax, onKey, option1, option2, message, ...args);
	      if (needCompilerDiagnostic) {
	        if ("messageText" in message) {
	          programDiagnostics.add(createCompilerDiagnosticFromMessageChain(message));
	        } else {
	          programDiagnostics.add(createCompilerDiagnostic(message, ...args));
	        }
	      }
	    }
	    function getCompilerOptionsObjectLiteralSyntax() {
	      if (_compilerOptionsObjectLiteralSyntax === void 0) {
	        _compilerOptionsObjectLiteralSyntax = forEachPropertyAssignment(
	          getTsConfigObjectLiteralExpression(options.configFile),
	          "compilerOptions",
	          (prop) => isObjectLiteralExpression(prop.initializer) ? prop.initializer : void 0
	        ) || false;
	      }
	      return _compilerOptionsObjectLiteralSyntax || void 0;
	    }
	    function createOptionDiagnosticInObjectLiteralSyntax(objectLiteral, onKey, key1, key2, message, ...args) {
	      let needsCompilerDiagnostic = false;
	      forEachPropertyAssignment(objectLiteral, key1, (prop) => {
	        if ("messageText" in message) {
	          programDiagnostics.add(createDiagnosticForNodeFromMessageChain(options.configFile, onKey ? prop.name : prop.initializer, message));
	        } else {
	          programDiagnostics.add(createDiagnosticForNodeInSourceFile(options.configFile, onKey ? prop.name : prop.initializer, message, ...args));
	        }
	        needsCompilerDiagnostic = true;
	      }, key2);
	      return needsCompilerDiagnostic;
	    }
	    function createRedundantOptionDiagnostic(errorOnOption, redundantWithOption) {
	      const compilerOptionsObjectLiteralSyntax = getCompilerOptionsObjectLiteralSyntax();
	      if (compilerOptionsObjectLiteralSyntax) {
	        createOptionDiagnosticInObjectLiteralSyntax(
	          compilerOptionsObjectLiteralSyntax,
	          /*onKey*/
	          true,
	          errorOnOption,
	          /*key2*/
	          void 0,
	          Diagnostics.Option_0_is_redundant_and_cannot_be_specified_with_option_1,
	          errorOnOption,
	          redundantWithOption
	        );
	      } else {
	        createDiagnosticForOptionName(Diagnostics.Option_0_is_redundant_and_cannot_be_specified_with_option_1, errorOnOption, redundantWithOption);
	      }
	    }
	    function blockEmittingOfFile(emitFileName, diag2) {
	      hasEmitBlockingDiagnostics.set(toPath3(emitFileName), true);
	      programDiagnostics.add(diag2);
	    }
	    function isEmittedFile(file) {
	      if (options.noEmit) {
	        return false;
	      }
	      const filePath = toPath3(file);
	      if (getSourceFileByPath(filePath)) {
	        return false;
	      }
	      const out = outFile(options);
	      if (out) {
	        return isSameFile(filePath, out) || isSameFile(filePath, removeFileExtension(out) + ".d.ts" /* Dts */);
	      }
	      if (options.declarationDir && containsPath(options.declarationDir, filePath, currentDirectory, !host.useCaseSensitiveFileNames())) {
	        return true;
	      }
	      if (options.outDir) {
	        return containsPath(options.outDir, filePath, currentDirectory, !host.useCaseSensitiveFileNames());
	      }
	      if (fileExtensionIsOneOf(filePath, supportedJSExtensionsFlat) || isDeclarationFileName(filePath)) {
	        const filePathWithoutExtension = removeFileExtension(filePath);
	        return !!getSourceFileByPath(filePathWithoutExtension + ".ts" /* Ts */) || !!getSourceFileByPath(filePathWithoutExtension + ".tsx" /* Tsx */);
	      }
	      return false;
	    }
	    function isSameFile(file1, file2) {
	      return comparePaths(file1, file2, currentDirectory, !host.useCaseSensitiveFileNames()) === 0 /* EqualTo */;
	    }
	    function getSymlinkCache() {
	      if (host.getSymlinkCache) {
	        return host.getSymlinkCache();
	      }
	      if (!symlinks) {
	        symlinks = createSymlinkCache(currentDirectory, getCanonicalFileName);
	      }
	      if (files && !symlinks.hasProcessedResolutions()) {
	        symlinks.setSymlinksFromResolutions(forEachResolvedModule, forEachResolvedTypeReferenceDirective, automaticTypeDirectiveResolutions);
	      }
	      return symlinks;
	    }
	    function getModeForUsageLocation2(file, usage) {
	      var _a2;
	      const optionsForFile = ((_a2 = getRedirectReferenceForResolution(file)) == null ? void 0 : _a2.commandLine.options) || options;
	      return getModeForUsageLocationWorker(file, usage, optionsForFile);
	    }
	    function getModeForResolutionAtIndex2(file, index) {
	      return getModeForUsageLocation2(file, getModuleNameStringLiteralAt(file, index));
	    }
	  }
	  function updateHostForUseSourceOfProjectReferenceRedirect(host) {
	    let setOfDeclarationDirectories;
	    const originalFileExists = host.compilerHost.fileExists;
	    const originalDirectoryExists = host.compilerHost.directoryExists;
	    const originalGetDirectories = host.compilerHost.getDirectories;
	    const originalRealpath = host.compilerHost.realpath;
	    if (!host.useSourceOfProjectReferenceRedirect)
	      return { onProgramCreateComplete: noop, fileExists };
	    host.compilerHost.fileExists = fileExists;
	    let directoryExists;
	    if (originalDirectoryExists) {
	      directoryExists = host.compilerHost.directoryExists = (path) => {
	        if (originalDirectoryExists.call(host.compilerHost, path)) {
	          handleDirectoryCouldBeSymlink(path);
	          return true;
	        }
	        if (!host.getResolvedProjectReferences())
	          return false;
	        if (!setOfDeclarationDirectories) {
	          setOfDeclarationDirectories = /* @__PURE__ */ new Set();
	          host.forEachResolvedProjectReference((ref) => {
	            const out = outFile(ref.commandLine.options);
	            if (out) {
	              setOfDeclarationDirectories.add(getDirectoryPath(host.toPath(out)));
	            } else {
	              const declarationDir = ref.commandLine.options.declarationDir || ref.commandLine.options.outDir;
	              if (declarationDir) {
	                setOfDeclarationDirectories.add(host.toPath(declarationDir));
	              }
	            }
	          });
	        }
	        return fileOrDirectoryExistsUsingSource(
	          path,
	          /*isFile*/
	          false
	        );
	      };
	    }
	    if (originalGetDirectories) {
	      host.compilerHost.getDirectories = (path) => !host.getResolvedProjectReferences() || originalDirectoryExists && originalDirectoryExists.call(host.compilerHost, path) ? originalGetDirectories.call(host.compilerHost, path) : [];
	    }
	    if (originalRealpath) {
	      host.compilerHost.realpath = (s) => {
	        var _a;
	        return ((_a = host.getSymlinkCache().getSymlinkedFiles()) == null ? void 0 : _a.get(host.toPath(s))) || originalRealpath.call(host.compilerHost, s);
	      };
	    }
	    return { onProgramCreateComplete, fileExists, directoryExists };
	    function onProgramCreateComplete() {
	      host.compilerHost.fileExists = originalFileExists;
	      host.compilerHost.directoryExists = originalDirectoryExists;
	      host.compilerHost.getDirectories = originalGetDirectories;
	    }
	    function fileExists(file) {
	      if (originalFileExists.call(host.compilerHost, file))
	        return true;
	      if (!host.getResolvedProjectReferences())
	        return false;
	      if (!isDeclarationFileName(file))
	        return false;
	      return fileOrDirectoryExistsUsingSource(
	        file,
	        /*isFile*/
	        true
	      );
	    }
	    function fileExistsIfProjectReferenceDts(file) {
	      const source = host.getSourceOfProjectReferenceRedirect(host.toPath(file));
	      return source !== void 0 ? isString(source) ? originalFileExists.call(host.compilerHost, source) : true : void 0;
	    }
	    function directoryExistsIfProjectReferenceDeclDir(dir) {
	      const dirPath = host.toPath(dir);
	      const dirPathWithTrailingDirectorySeparator = `${dirPath}${directorySeparator}`;
	      return forEachKey(
	        setOfDeclarationDirectories,
	        (declDirPath) => dirPath === declDirPath || // Any parent directory of declaration dir
	        startsWith(declDirPath, dirPathWithTrailingDirectorySeparator) || // Any directory inside declaration dir
	        startsWith(dirPath, `${declDirPath}/`)
	      );
	    }
	    function handleDirectoryCouldBeSymlink(directory) {
	      var _a;
	      if (!host.getResolvedProjectReferences() || containsIgnoredPath(directory))
	        return;
	      if (!originalRealpath || !directory.includes(nodeModulesPathPart))
	        return;
	      const symlinkCache = host.getSymlinkCache();
	      const directoryPath = ensureTrailingDirectorySeparator(host.toPath(directory));
	      if ((_a = symlinkCache.getSymlinkedDirectories()) == null ? void 0 : _a.has(directoryPath))
	        return;
	      const real = normalizePath(originalRealpath.call(host.compilerHost, directory));
	      let realPath2;
	      if (real === directory || (realPath2 = ensureTrailingDirectorySeparator(host.toPath(real))) === directoryPath) {
	        symlinkCache.setSymlinkedDirectory(directoryPath, false);
	        return;
	      }
	      symlinkCache.setSymlinkedDirectory(directory, {
	        real: ensureTrailingDirectorySeparator(real),
	        realPath: realPath2
	      });
	    }
	    function fileOrDirectoryExistsUsingSource(fileOrDirectory, isFile) {
	      var _a;
	      const fileOrDirectoryExistsUsingSource2 = isFile ? (file) => fileExistsIfProjectReferenceDts(file) : (dir) => directoryExistsIfProjectReferenceDeclDir(dir);
	      const result = fileOrDirectoryExistsUsingSource2(fileOrDirectory);
	      if (result !== void 0)
	        return result;
	      const symlinkCache = host.getSymlinkCache();
	      const symlinkedDirectories = symlinkCache.getSymlinkedDirectories();
	      if (!symlinkedDirectories)
	        return false;
	      const fileOrDirectoryPath = host.toPath(fileOrDirectory);
	      if (!fileOrDirectoryPath.includes(nodeModulesPathPart))
	        return false;
	      if (isFile && ((_a = symlinkCache.getSymlinkedFiles()) == null ? void 0 : _a.has(fileOrDirectoryPath)))
	        return true;
	      return firstDefinedIterator(
	        symlinkedDirectories.entries(),
	        ([directoryPath, symlinkedDirectory]) => {
	          if (!symlinkedDirectory || !startsWith(fileOrDirectoryPath, directoryPath))
	            return void 0;
	          const result2 = fileOrDirectoryExistsUsingSource2(fileOrDirectoryPath.replace(directoryPath, symlinkedDirectory.realPath));
	          if (isFile && result2) {
	            const absolutePath = getNormalizedAbsolutePath(fileOrDirectory, host.compilerHost.getCurrentDirectory());
	            symlinkCache.setSymlinkedFile(
	              fileOrDirectoryPath,
	              `${symlinkedDirectory.real}${absolutePath.replace(new RegExp(directoryPath, "i"), "")}`
	            );
	          }
	          return result2;
	        }
	      ) || false;
	    }
	  }
	  function handleNoEmitOptions(program, sourceFile, writeFile2, cancellationToken) {
	    const options = program.getCompilerOptions();
	    if (options.noEmit) {
	      program.getSemanticDiagnostics(sourceFile, cancellationToken);
	      return sourceFile || outFile(options) ? emitSkippedWithNoDiagnostics : program.emitBuildInfo(writeFile2, cancellationToken);
	    }
	    if (!options.noEmitOnError)
	      return void 0;
	    let diagnostics = [
	      ...program.getOptionsDiagnostics(cancellationToken),
	      ...program.getSyntacticDiagnostics(sourceFile, cancellationToken),
	      ...program.getGlobalDiagnostics(cancellationToken),
	      ...program.getSemanticDiagnostics(sourceFile, cancellationToken)
	    ];
	    if (diagnostics.length === 0 && getEmitDeclarations(program.getCompilerOptions())) {
	      diagnostics = program.getDeclarationDiagnostics(
	        /*sourceFile*/
	        void 0,
	        cancellationToken
	      );
	    }
	    if (!diagnostics.length)
	      return void 0;
	    let emittedFiles;
	    if (!sourceFile && !outFile(options)) {
	      const emitResult = program.emitBuildInfo(writeFile2, cancellationToken);
	      if (emitResult.diagnostics)
	        diagnostics = [...diagnostics, ...emitResult.diagnostics];
	      emittedFiles = emitResult.emittedFiles;
	    }
	    return { diagnostics, sourceMaps: void 0, emittedFiles, emitSkipped: true };
	  }
	  function filterSemanticDiagnostics(diagnostic, option) {
	    return filter(diagnostic, (d) => !d.skippedOn || !option[d.skippedOn]);
	  }
	  function parseConfigHostFromCompilerHostLike(host, directoryStructureHost = host) {
	    return {
	      fileExists: (f) => directoryStructureHost.fileExists(f),
	      readDirectory(root, extensions, excludes, includes, depth) {
	        Debug.assertIsDefined(directoryStructureHost.readDirectory, "'CompilerHost.readDirectory' must be implemented to correctly process 'projectReferences'");
	        return directoryStructureHost.readDirectory(root, extensions, excludes, includes, depth);
	      },
	      readFile: (f) => directoryStructureHost.readFile(f),
	      directoryExists: maybeBind(directoryStructureHost, directoryStructureHost.directoryExists),
	      getDirectories: maybeBind(directoryStructureHost, directoryStructureHost.getDirectories),
	      realpath: maybeBind(directoryStructureHost, directoryStructureHost.realpath),
	      useCaseSensitiveFileNames: host.useCaseSensitiveFileNames(),
	      getCurrentDirectory: () => host.getCurrentDirectory(),
	      onUnRecoverableConfigFileDiagnostic: host.onUnRecoverableConfigFileDiagnostic || returnUndefined,
	      trace: host.trace ? (s) => host.trace(s) : void 0
	    };
	  }
	  function createPrependNodes(projectReferences, getCommandLine, readFile, host) {
	    if (!projectReferences)
	      return emptyArray;
	    let nodes;
	    for (let i = 0; i < projectReferences.length; i++) {
	      const ref = projectReferences[i];
	      const resolvedRefOpts = getCommandLine(ref, i);
	      if (ref.prepend && resolvedRefOpts && resolvedRefOpts.options) {
	        const out = outFile(resolvedRefOpts.options);
	        if (!out)
	          continue;
	        const { jsFilePath, sourceMapFilePath, declarationFilePath, declarationMapPath, buildInfoPath } = getOutputPathsForBundle(
	          resolvedRefOpts.options,
	          /*forceDtsPaths*/
	          true
	        );
	        const node = createInputFilesWithFilePaths(readFile, jsFilePath, sourceMapFilePath, declarationFilePath, declarationMapPath, buildInfoPath, host, resolvedRefOpts.options);
	        (nodes || (nodes = [])).push(node);
	      }
	    }
	    return nodes || emptyArray;
	  }
	  function resolveProjectReferencePath(ref) {
	    return resolveConfigFileProjectName(ref.path);
	  }
	  function getResolutionDiagnostic(options, { extension }, { isDeclarationFile }) {
	    switch (extension) {
	      case ".ts" /* Ts */:
	      case ".d.ts" /* Dts */:
	      case ".mts" /* Mts */:
	      case ".d.mts" /* Dmts */:
	      case ".cts" /* Cts */:
	      case ".d.cts" /* Dcts */:
	        return void 0;
	      case ".tsx" /* Tsx */:
	        return needJsx();
	      case ".jsx" /* Jsx */:
	        return needJsx() || needAllowJs();
	      case ".js" /* Js */:
	      case ".mjs" /* Mjs */:
	      case ".cjs" /* Cjs */:
	        return needAllowJs();
	      case ".json" /* Json */:
	        return needResolveJsonModule();
	      default:
	        return needAllowArbitraryExtensions();
	    }
	    function needJsx() {
	      return options.jsx ? void 0 : Diagnostics.Module_0_was_resolved_to_1_but_jsx_is_not_set;
	    }
	    function needAllowJs() {
	      return getAllowJSCompilerOption(options) || !getStrictOptionValue(options, "noImplicitAny") ? void 0 : Diagnostics.Could_not_find_a_declaration_file_for_module_0_1_implicitly_has_an_any_type;
	    }
	    function needResolveJsonModule() {
	      return getResolveJsonModule(options) ? void 0 : Diagnostics.Module_0_was_resolved_to_1_but_resolveJsonModule_is_not_used;
	    }
	    function needAllowArbitraryExtensions() {
	      return isDeclarationFile || options.allowArbitraryExtensions ? void 0 : Diagnostics.Module_0_was_resolved_to_1_but_allowArbitraryExtensions_is_not_set;
	    }
	  }
	  function getModuleNames({ imports, moduleAugmentations }) {
	    const res = imports.map((i) => i);
	    for (const aug of moduleAugmentations) {
	      if (aug.kind === 11 /* StringLiteral */) {
	        res.push(aug);
	      }
	    }
	    return res;
	  }
	  function getModuleNameStringLiteralAt({ imports, moduleAugmentations }, index) {
	    if (index < imports.length)
	      return imports[index];
	    let augIndex = imports.length;
	    for (const aug of moduleAugmentations) {
	      if (aug.kind === 11 /* StringLiteral */) {
	        if (index === augIndex)
	          return aug;
	        augIndex++;
	      }
	    }
	    Debug.fail("should never ask for module name at index higher than possible module name");
	  }
	  var ForegroundColorEscapeSequences, gutterStyleSequence, gutterSeparator, resetEscapeSequence, ellipsis, halfIndent, indent, emptyResolution, moduleResolutionNameAndModeGetter, typeReferenceResolutionNameAndModeGetter, inferredTypesContainingFile, plainJSErrors, emitSkippedWithNoDiagnostics;
	  var init_program = __esm({
	    "src/compiler/program.ts"() {
	      init_ts2();
	      init_ts_performance();
	      ForegroundColorEscapeSequences = /* @__PURE__ */ ((ForegroundColorEscapeSequences2) => {
	        ForegroundColorEscapeSequences2["Grey"] = "\x1B[90m";
	        ForegroundColorEscapeSequences2["Red"] = "\x1B[91m";
	        ForegroundColorEscapeSequences2["Yellow"] = "\x1B[93m";
	        ForegroundColorEscapeSequences2["Blue"] = "\x1B[94m";
	        ForegroundColorEscapeSequences2["Cyan"] = "\x1B[96m";
	        return ForegroundColorEscapeSequences2;
	      })(ForegroundColorEscapeSequences || {});
	      gutterStyleSequence = "\x1B[7m";
	      gutterSeparator = " ";
	      resetEscapeSequence = "\x1B[0m";
	      ellipsis = "...";
	      halfIndent = "  ";
	      indent = "    ";
	      emptyResolution = {
	        resolvedModule: void 0,
	        resolvedTypeReferenceDirective: void 0
	      };
	      moduleResolutionNameAndModeGetter = {
	        getName: getModuleResolutionName,
	        getMode: (entry, file, compilerOptions) => getModeForUsageLocation(file, entry, compilerOptions)
	      };
	      typeReferenceResolutionNameAndModeGetter = {
	        getName: getTypeReferenceResolutionName,
	        getMode: (entry, file) => getModeForFileReference(entry, file == null ? void 0 : file.impliedNodeFormat)
	      };
	      inferredTypesContainingFile = "__inferred type names__.ts";
	      plainJSErrors = /* @__PURE__ */ new Set([
	        // binder errors
	        Diagnostics.Cannot_redeclare_block_scoped_variable_0.code,
	        Diagnostics.A_module_cannot_have_multiple_default_exports.code,
	        Diagnostics.Another_export_default_is_here.code,
	        Diagnostics.The_first_export_default_is_here.code,
	        Diagnostics.Identifier_expected_0_is_a_reserved_word_at_the_top_level_of_a_module.code,
	        Diagnostics.Identifier_expected_0_is_a_reserved_word_in_strict_mode_Modules_are_automatically_in_strict_mode.code,
	        Diagnostics.Identifier_expected_0_is_a_reserved_word_that_cannot_be_used_here.code,
	        Diagnostics.constructor_is_a_reserved_word.code,
	        Diagnostics.delete_cannot_be_called_on_an_identifier_in_strict_mode.code,
	        Diagnostics.Code_contained_in_a_class_is_evaluated_in_JavaScript_s_strict_mode_which_does_not_allow_this_use_of_0_For_more_information_see_https_Colon_Slash_Slashdeveloper_mozilla_org_Slashen_US_Slashdocs_SlashWeb_SlashJavaScript_SlashReference_SlashStrict_mode.code,
	        Diagnostics.Invalid_use_of_0_Modules_are_automatically_in_strict_mode.code,
	        Diagnostics.Invalid_use_of_0_in_strict_mode.code,
	        Diagnostics.A_label_is_not_allowed_here.code,
	        Diagnostics.with_statements_are_not_allowed_in_strict_mode.code,
	        // grammar errors
	        Diagnostics.A_break_statement_can_only_be_used_within_an_enclosing_iteration_or_switch_statement.code,
	        Diagnostics.A_break_statement_can_only_jump_to_a_label_of_an_enclosing_statement.code,
	        Diagnostics.A_class_declaration_without_the_default_modifier_must_have_a_name.code,
	        Diagnostics.A_class_member_cannot_have_the_0_keyword.code,
	        Diagnostics.A_comma_expression_is_not_allowed_in_a_computed_property_name.code,
	        Diagnostics.A_continue_statement_can_only_be_used_within_an_enclosing_iteration_statement.code,
	        Diagnostics.A_continue_statement_can_only_jump_to_a_label_of_an_enclosing_iteration_statement.code,
	        Diagnostics.A_continue_statement_can_only_jump_to_a_label_of_an_enclosing_iteration_statement.code,
	        Diagnostics.A_default_clause_cannot_appear_more_than_once_in_a_switch_statement.code,
	        Diagnostics.A_default_export_must_be_at_the_top_level_of_a_file_or_module_declaration.code,
	        Diagnostics.A_definite_assignment_assertion_is_not_permitted_in_this_context.code,
	        Diagnostics.A_destructuring_declaration_must_have_an_initializer.code,
	        Diagnostics.A_get_accessor_cannot_have_parameters.code,
	        Diagnostics.A_rest_element_cannot_contain_a_binding_pattern.code,
	        Diagnostics.A_rest_element_cannot_have_a_property_name.code,
	        Diagnostics.A_rest_element_cannot_have_an_initializer.code,
	        Diagnostics.A_rest_element_must_be_last_in_a_destructuring_pattern.code,
	        Diagnostics.A_rest_parameter_cannot_have_an_initializer.code,
	        Diagnostics.A_rest_parameter_must_be_last_in_a_parameter_list.code,
	        Diagnostics.A_rest_parameter_or_binding_pattern_may_not_have_a_trailing_comma.code,
	        Diagnostics.A_return_statement_cannot_be_used_inside_a_class_static_block.code,
	        Diagnostics.A_set_accessor_cannot_have_rest_parameter.code,
	        Diagnostics.A_set_accessor_must_have_exactly_one_parameter.code,
	        Diagnostics.An_export_declaration_can_only_be_used_at_the_top_level_of_a_module.code,
	        Diagnostics.An_export_declaration_cannot_have_modifiers.code,
	        Diagnostics.An_import_declaration_can_only_be_used_at_the_top_level_of_a_module.code,
	        Diagnostics.An_import_declaration_cannot_have_modifiers.code,
	        Diagnostics.An_object_member_cannot_be_declared_optional.code,
	        Diagnostics.Argument_of_dynamic_import_cannot_be_spread_element.code,
	        Diagnostics.Cannot_assign_to_private_method_0_Private_methods_are_not_writable.code,
	        Diagnostics.Cannot_redeclare_identifier_0_in_catch_clause.code,
	        Diagnostics.Catch_clause_variable_cannot_have_an_initializer.code,
	        Diagnostics.Class_decorators_can_t_be_used_with_static_private_identifier_Consider_removing_the_experimental_decorator.code,
	        Diagnostics.Classes_can_only_extend_a_single_class.code,
	        Diagnostics.Classes_may_not_have_a_field_named_constructor.code,
	        Diagnostics.Did_you_mean_to_use_a_Colon_An_can_only_follow_a_property_name_when_the_containing_object_literal_is_part_of_a_destructuring_pattern.code,
	        Diagnostics.Duplicate_label_0.code,
	        Diagnostics.Dynamic_imports_can_only_accept_a_module_specifier_and_an_optional_set_of_attributes_as_arguments.code,
	        Diagnostics.for_await_loops_cannot_be_used_inside_a_class_static_block.code,
	        Diagnostics.JSX_attributes_must_only_be_assigned_a_non_empty_expression.code,
	        Diagnostics.JSX_elements_cannot_have_multiple_attributes_with_the_same_name.code,
	        Diagnostics.JSX_expressions_may_not_use_the_comma_operator_Did_you_mean_to_write_an_array.code,
	        Diagnostics.JSX_property_access_expressions_cannot_include_JSX_namespace_names.code,
	        Diagnostics.Jump_target_cannot_cross_function_boundary.code,
	        Diagnostics.Line_terminator_not_permitted_before_arrow.code,
	        Diagnostics.Modifiers_cannot_appear_here.code,
	        Diagnostics.Only_a_single_variable_declaration_is_allowed_in_a_for_in_statement.code,
	        Diagnostics.Only_a_single_variable_declaration_is_allowed_in_a_for_of_statement.code,
	        Diagnostics.Private_identifiers_are_not_allowed_outside_class_bodies.code,
	        Diagnostics.Private_identifiers_are_only_allowed_in_class_bodies_and_may_only_be_used_as_part_of_a_class_member_declaration_property_access_or_on_the_left_hand_side_of_an_in_expression.code,
	        Diagnostics.Property_0_is_not_accessible_outside_class_1_because_it_has_a_private_identifier.code,
	        Diagnostics.Tagged_template_expressions_are_not_permitted_in_an_optional_chain.code,
	        Diagnostics.The_left_hand_side_of_a_for_of_statement_may_not_be_async.code,
	        Diagnostics.The_variable_declaration_of_a_for_in_statement_cannot_have_an_initializer.code,
	        Diagnostics.The_variable_declaration_of_a_for_of_statement_cannot_have_an_initializer.code,
	        Diagnostics.Trailing_comma_not_allowed.code,
	        Diagnostics.Variable_declaration_list_cannot_be_empty.code,
	        Diagnostics._0_and_1_operations_cannot_be_mixed_without_parentheses.code,
	        Diagnostics._0_expected.code,
	        Diagnostics._0_is_not_a_valid_meta_property_for_keyword_1_Did_you_mean_2.code,
	        Diagnostics._0_list_cannot_be_empty.code,
	        Diagnostics._0_modifier_already_seen.code,
	        Diagnostics._0_modifier_cannot_appear_on_a_constructor_declaration.code,
	        Diagnostics._0_modifier_cannot_appear_on_a_module_or_namespace_element.code,
	        Diagnostics._0_modifier_cannot_appear_on_a_parameter.code,
	        Diagnostics._0_modifier_cannot_appear_on_class_elements_of_this_kind.code,
	        Diagnostics._0_modifier_cannot_be_used_here.code,
	        Diagnostics._0_modifier_must_precede_1_modifier.code,
	        Diagnostics._0_declarations_can_only_be_declared_inside_a_block.code,
	        Diagnostics._0_declarations_must_be_initialized.code,
	        Diagnostics.extends_clause_already_seen.code,
	        Diagnostics.let_is_not_allowed_to_be_used_as_a_name_in_let_or_const_declarations.code,
	        Diagnostics.Class_constructor_may_not_be_a_generator.code,
	        Diagnostics.Class_constructor_may_not_be_an_accessor.code,
	        Diagnostics.await_expressions_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules.code,
	        Diagnostics.await_using_statements_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules.code,
	        Diagnostics.Private_field_0_must_be_declared_in_an_enclosing_class.code,
	        // Type errors
	        Diagnostics.This_condition_will_always_return_0_since_JavaScript_compares_objects_by_reference_not_value.code
	      ]);
	      emitSkippedWithNoDiagnostics = { diagnostics: emptyArray, sourceMaps: void 0, emittedFiles: void 0, emitSkipped: true };
	    }
	  });

	  // src/compiler/builderStatePublic.ts
	  var init_builderStatePublic = __esm({
	    "src/compiler/builderStatePublic.ts"() {
	    }
	  });

	  // src/compiler/builderState.ts
	  function getFileEmitOutput(program, sourceFile, emitOnlyDtsFiles, cancellationToken, customTransformers, forceDtsEmit) {
	    const outputFiles = [];
	    const { emitSkipped, diagnostics } = program.emit(sourceFile, writeFile2, cancellationToken, emitOnlyDtsFiles, customTransformers, forceDtsEmit);
	    return { outputFiles, emitSkipped, diagnostics };
	    function writeFile2(fileName, text, writeByteOrderMark) {
	      outputFiles.push({ name: fileName, writeByteOrderMark, text });
	    }
	  }
	  var BuilderState;
	  var init_builderState = __esm({
	    "src/compiler/builderState.ts"() {
	      init_ts2();
	      ((BuilderState2) => {
	        function createManyToManyPathMap() {
	          function create2(forward, reverse, deleted) {
	            const map2 = {
	              getKeys: (v) => reverse.get(v),
	              getValues: (k) => forward.get(k),
	              keys: () => forward.keys(),
	              deleteKey: (k) => {
	                (deleted || (deleted = /* @__PURE__ */ new Set())).add(k);
	                const set = forward.get(k);
	                if (!set) {
	                  return false;
	                }
	                set.forEach((v) => deleteFromMultimap(reverse, v, k));
	                forward.delete(k);
	                return true;
	              },
	              set: (k, vSet) => {
	                deleted == null ? void 0 : deleted.delete(k);
	                const existingVSet = forward.get(k);
	                forward.set(k, vSet);
	                existingVSet == null ? void 0 : existingVSet.forEach((v) => {
	                  if (!vSet.has(v)) {
	                    deleteFromMultimap(reverse, v, k);
	                  }
	                });
	                vSet.forEach((v) => {
	                  if (!(existingVSet == null ? void 0 : existingVSet.has(v))) {
	                    addToMultimap(reverse, v, k);
	                  }
	                });
	                return map2;
	              }
	            };
	            return map2;
	          }
	          return create2(
	            /* @__PURE__ */ new Map(),
	            /* @__PURE__ */ new Map(),
	            /*deleted*/
	            void 0
	          );
	        }
	        BuilderState2.createManyToManyPathMap = createManyToManyPathMap;
	        function addToMultimap(map2, k, v) {
	          let set = map2.get(k);
	          if (!set) {
	            set = /* @__PURE__ */ new Set();
	            map2.set(k, set);
	          }
	          set.add(v);
	        }
	        function deleteFromMultimap(map2, k, v) {
	          const set = map2.get(k);
	          if (set == null ? void 0 : set.delete(v)) {
	            if (!set.size) {
	              map2.delete(k);
	            }
	            return true;
	          }
	          return false;
	        }
	        function getReferencedFilesFromImportedModuleSymbol(symbol) {
	          return mapDefined(symbol.declarations, (declaration) => {
	            var _a;
	            return (_a = getSourceFileOfNode(declaration)) == null ? void 0 : _a.resolvedPath;
	          });
	        }
	        function getReferencedFilesFromImportLiteral(checker, importName) {
	          const symbol = checker.getSymbolAtLocation(importName);
	          return symbol && getReferencedFilesFromImportedModuleSymbol(symbol);
	        }
	        function getReferencedFileFromFileName(program, fileName, sourceFileDirectory, getCanonicalFileName) {
	          return toPath(program.getProjectReferenceRedirect(fileName) || fileName, sourceFileDirectory, getCanonicalFileName);
	        }
	        function getReferencedFiles(program, sourceFile, getCanonicalFileName) {
	          let referencedFiles;
	          if (sourceFile.imports && sourceFile.imports.length > 0) {
	            const checker = program.getTypeChecker();
	            for (const importName of sourceFile.imports) {
	              const declarationSourceFilePaths = getReferencedFilesFromImportLiteral(checker, importName);
	              declarationSourceFilePaths == null ? void 0 : declarationSourceFilePaths.forEach(addReferencedFile);
	            }
	          }
	          const sourceFileDirectory = getDirectoryPath(sourceFile.resolvedPath);
	          if (sourceFile.referencedFiles && sourceFile.referencedFiles.length > 0) {
	            for (const referencedFile of sourceFile.referencedFiles) {
	              const referencedPath = getReferencedFileFromFileName(program, referencedFile.fileName, sourceFileDirectory, getCanonicalFileName);
	              addReferencedFile(referencedPath);
	            }
	          }
	          program.forEachResolvedTypeReferenceDirective(({ resolvedTypeReferenceDirective }) => {
	            if (!resolvedTypeReferenceDirective) {
	              return;
	            }
	            const fileName = resolvedTypeReferenceDirective.resolvedFileName;
	            const typeFilePath = getReferencedFileFromFileName(program, fileName, sourceFileDirectory, getCanonicalFileName);
	            addReferencedFile(typeFilePath);
	          }, sourceFile);
	          if (sourceFile.moduleAugmentations.length) {
	            const checker = program.getTypeChecker();
	            for (const moduleName of sourceFile.moduleAugmentations) {
	              if (!isStringLiteral(moduleName))
	                continue;
	              const symbol = checker.getSymbolAtLocation(moduleName);
	              if (!symbol)
	                continue;
	              addReferenceFromAmbientModule(symbol);
	            }
	          }
	          for (const ambientModule of program.getTypeChecker().getAmbientModules()) {
	            if (ambientModule.declarations && ambientModule.declarations.length > 1) {
	              addReferenceFromAmbientModule(ambientModule);
	            }
	          }
	          return referencedFiles;
	          function addReferenceFromAmbientModule(symbol) {
	            if (!symbol.declarations) {
	              return;
	            }
	            for (const declaration of symbol.declarations) {
	              const declarationSourceFile = getSourceFileOfNode(declaration);
	              if (declarationSourceFile && declarationSourceFile !== sourceFile) {
	                addReferencedFile(declarationSourceFile.resolvedPath);
	              }
	            }
	          }
	          function addReferencedFile(referencedPath) {
	            (referencedFiles || (referencedFiles = /* @__PURE__ */ new Set())).add(referencedPath);
	          }
	        }
	        function canReuseOldState(newReferencedMap, oldState) {
	          return oldState && !oldState.referencedMap === !newReferencedMap;
	        }
	        BuilderState2.canReuseOldState = canReuseOldState;
	        function create(newProgram, oldState, disableUseFileVersionAsSignature) {
	          var _a, _b, _c;
	          const fileInfos = /* @__PURE__ */ new Map();
	          const options = newProgram.getCompilerOptions();
	          const isOutFile = outFile(options);
	          const referencedMap = options.module !== 0 /* None */ && !isOutFile ? createManyToManyPathMap() : void 0;
	          const exportedModulesMap = referencedMap ? createManyToManyPathMap() : void 0;
	          const useOldState = canReuseOldState(referencedMap, oldState);
	          newProgram.getTypeChecker();
	          for (const sourceFile of newProgram.getSourceFiles()) {
	            const version2 = Debug.checkDefined(sourceFile.version, "Program intended to be used with Builder should have source files with versions set");
	            const oldUncommittedSignature = useOldState ? (_a = oldState.oldSignatures) == null ? void 0 : _a.get(sourceFile.resolvedPath) : void 0;
	            const signature = oldUncommittedSignature === void 0 ? useOldState ? (_b = oldState.fileInfos.get(sourceFile.resolvedPath)) == null ? void 0 : _b.signature : void 0 : oldUncommittedSignature || void 0;
	            if (referencedMap) {
	              const newReferences = getReferencedFiles(newProgram, sourceFile, newProgram.getCanonicalFileName);
	              if (newReferences) {
	                referencedMap.set(sourceFile.resolvedPath, newReferences);
	              }
	              if (useOldState) {
	                const oldUncommittedExportedModules = (_c = oldState.oldExportedModulesMap) == null ? void 0 : _c.get(sourceFile.resolvedPath);
	                const exportedModules = oldUncommittedExportedModules === void 0 ? oldState.exportedModulesMap.getValues(sourceFile.resolvedPath) : oldUncommittedExportedModules || void 0;
	                if (exportedModules) {
	                  exportedModulesMap.set(sourceFile.resolvedPath, exportedModules);
	                }
	              }
	            }
	            fileInfos.set(sourceFile.resolvedPath, {
	              version: version2,
	              signature,
	              // No need to calculate affectsGlobalScope with --out since its not used at all
	              affectsGlobalScope: !isOutFile ? isFileAffectingGlobalScope(sourceFile) || void 0 : void 0,
	              impliedFormat: sourceFile.impliedNodeFormat
	            });
	          }
	          return {
	            fileInfos,
	            referencedMap,
	            exportedModulesMap,
	            useFileVersionAsSignature: !disableUseFileVersionAsSignature && !useOldState
	          };
	        }
	        BuilderState2.create = create;
	        function releaseCache2(state) {
	          state.allFilesExcludingDefaultLibraryFile = void 0;
	          state.allFileNames = void 0;
	        }
	        BuilderState2.releaseCache = releaseCache2;
	        function getFilesAffectedBy(state, programOfThisState, path, cancellationToken, host) {
	          var _a, _b;
	          const result = getFilesAffectedByWithOldState(
	            state,
	            programOfThisState,
	            path,
	            cancellationToken,
	            host
	          );
	          (_a = state.oldSignatures) == null ? void 0 : _a.clear();
	          (_b = state.oldExportedModulesMap) == null ? void 0 : _b.clear();
	          return result;
	        }
	        BuilderState2.getFilesAffectedBy = getFilesAffectedBy;
	        function getFilesAffectedByWithOldState(state, programOfThisState, path, cancellationToken, host) {
	          const sourceFile = programOfThisState.getSourceFileByPath(path);
	          if (!sourceFile) {
	            return emptyArray;
	          }
	          if (!updateShapeSignature(state, programOfThisState, sourceFile, cancellationToken, host)) {
	            return [sourceFile];
	          }
	          return (state.referencedMap ? getFilesAffectedByUpdatedShapeWhenModuleEmit : getFilesAffectedByUpdatedShapeWhenNonModuleEmit)(state, programOfThisState, sourceFile, cancellationToken, host);
	        }
	        BuilderState2.getFilesAffectedByWithOldState = getFilesAffectedByWithOldState;
	        function updateSignatureOfFile(state, signature, path) {
	          state.fileInfos.get(path).signature = signature;
	          (state.hasCalledUpdateShapeSignature || (state.hasCalledUpdateShapeSignature = /* @__PURE__ */ new Set())).add(path);
	        }
	        BuilderState2.updateSignatureOfFile = updateSignatureOfFile;
	        function computeDtsSignature(programOfThisState, sourceFile, cancellationToken, host, onNewSignature) {
	          programOfThisState.emit(
	            sourceFile,
	            (fileName, text, _writeByteOrderMark, _onError, sourceFiles, data) => {
	              Debug.assert(isDeclarationFileName(fileName), `File extension for signature expected to be dts: Got:: ${fileName}`);
	              onNewSignature(
	                computeSignatureWithDiagnostics(
	                  programOfThisState,
	                  sourceFile,
	                  text,
	                  host,
	                  data
	                ),
	                sourceFiles
	              );
	            },
	            cancellationToken,
	            /*emitOnly*/
	            true,
	            /*customTransformers*/
	            void 0,
	            /*forceDtsEmit*/
	            true
	          );
	        }
	        BuilderState2.computeDtsSignature = computeDtsSignature;
	        function updateShapeSignature(state, programOfThisState, sourceFile, cancellationToken, host, useFileVersionAsSignature = state.useFileVersionAsSignature) {
	          var _a;
	          if ((_a = state.hasCalledUpdateShapeSignature) == null ? void 0 : _a.has(sourceFile.resolvedPath))
	            return false;
	          const info = state.fileInfos.get(sourceFile.resolvedPath);
	          const prevSignature = info.signature;
	          let latestSignature;
	          if (!sourceFile.isDeclarationFile && !useFileVersionAsSignature) {
	            computeDtsSignature(programOfThisState, sourceFile, cancellationToken, host, (signature, sourceFiles) => {
	              latestSignature = signature;
	              if (latestSignature !== prevSignature) {
	                updateExportedModules(state, sourceFile, sourceFiles[0].exportedModulesFromDeclarationEmit);
	              }
	            });
	          }
	          if (latestSignature === void 0) {
	            latestSignature = sourceFile.version;
	            if (state.exportedModulesMap && latestSignature !== prevSignature) {
	              (state.oldExportedModulesMap || (state.oldExportedModulesMap = /* @__PURE__ */ new Map())).set(sourceFile.resolvedPath, state.exportedModulesMap.getValues(sourceFile.resolvedPath) || false);
	              const references = state.referencedMap ? state.referencedMap.getValues(sourceFile.resolvedPath) : void 0;
	              if (references) {
	                state.exportedModulesMap.set(sourceFile.resolvedPath, references);
	              } else {
	                state.exportedModulesMap.deleteKey(sourceFile.resolvedPath);
	              }
	            }
	          }
	          (state.oldSignatures || (state.oldSignatures = /* @__PURE__ */ new Map())).set(sourceFile.resolvedPath, prevSignature || false);
	          (state.hasCalledUpdateShapeSignature || (state.hasCalledUpdateShapeSignature = /* @__PURE__ */ new Set())).add(sourceFile.resolvedPath);
	          info.signature = latestSignature;
	          return latestSignature !== prevSignature;
	        }
	        BuilderState2.updateShapeSignature = updateShapeSignature;
	        function updateExportedModules(state, sourceFile, exportedModulesFromDeclarationEmit) {
	          if (!state.exportedModulesMap)
	            return;
	          (state.oldExportedModulesMap || (state.oldExportedModulesMap = /* @__PURE__ */ new Map())).set(sourceFile.resolvedPath, state.exportedModulesMap.getValues(sourceFile.resolvedPath) || false);
	          const exportedModules = getExportedModules(exportedModulesFromDeclarationEmit);
	          if (exportedModules) {
	            state.exportedModulesMap.set(sourceFile.resolvedPath, exportedModules);
	          } else {
	            state.exportedModulesMap.deleteKey(sourceFile.resolvedPath);
	          }
	        }
	        BuilderState2.updateExportedModules = updateExportedModules;
	        function getExportedModules(exportedModulesFromDeclarationEmit) {
	          let exportedModules;
	          exportedModulesFromDeclarationEmit == null ? void 0 : exportedModulesFromDeclarationEmit.forEach(
	            (symbol) => getReferencedFilesFromImportedModuleSymbol(symbol).forEach(
	              (path) => (exportedModules ?? (exportedModules = /* @__PURE__ */ new Set())).add(path)
	            )
	          );
	          return exportedModules;
	        }
	        BuilderState2.getExportedModules = getExportedModules;
	        function getAllDependencies(state, programOfThisState, sourceFile) {
	          const compilerOptions = programOfThisState.getCompilerOptions();
	          if (outFile(compilerOptions)) {
	            return getAllFileNames(state, programOfThisState);
	          }
	          if (!state.referencedMap || isFileAffectingGlobalScope(sourceFile)) {
	            return getAllFileNames(state, programOfThisState);
	          }
	          const seenMap = /* @__PURE__ */ new Set();
	          const queue = [sourceFile.resolvedPath];
	          while (queue.length) {
	            const path = queue.pop();
	            if (!seenMap.has(path)) {
	              seenMap.add(path);
	              const references = state.referencedMap.getValues(path);
	              if (references) {
	                for (const key of references.keys()) {
	                  queue.push(key);
	                }
	              }
	            }
	          }
	          return arrayFrom(mapDefinedIterator(seenMap.keys(), (path) => {
	            var _a;
	            return ((_a = programOfThisState.getSourceFileByPath(path)) == null ? void 0 : _a.fileName) ?? path;
	          }));
	        }
	        BuilderState2.getAllDependencies = getAllDependencies;
	        function getAllFileNames(state, programOfThisState) {
	          if (!state.allFileNames) {
	            const sourceFiles = programOfThisState.getSourceFiles();
	            state.allFileNames = sourceFiles === emptyArray ? emptyArray : sourceFiles.map((file) => file.fileName);
	          }
	          return state.allFileNames;
	        }
	        function getReferencedByPaths(state, referencedFilePath) {
	          const keys = state.referencedMap.getKeys(referencedFilePath);
	          return keys ? arrayFrom(keys.keys()) : [];
	        }
	        BuilderState2.getReferencedByPaths = getReferencedByPaths;
	        function containsOnlyAmbientModules(sourceFile) {
	          for (const statement of sourceFile.statements) {
	            if (!isModuleWithStringLiteralName(statement)) {
	              return false;
	            }
	          }
	          return true;
	        }
	        function containsGlobalScopeAugmentation(sourceFile) {
	          return some(sourceFile.moduleAugmentations, (augmentation) => isGlobalScopeAugmentation(augmentation.parent));
	        }
	        function isFileAffectingGlobalScope(sourceFile) {
	          return containsGlobalScopeAugmentation(sourceFile) || !isExternalOrCommonJsModule(sourceFile) && !isJsonSourceFile(sourceFile) && !containsOnlyAmbientModules(sourceFile);
	        }
	        function getAllFilesExcludingDefaultLibraryFile(state, programOfThisState, firstSourceFile) {
	          if (state.allFilesExcludingDefaultLibraryFile) {
	            return state.allFilesExcludingDefaultLibraryFile;
	          }
	          let result;
	          if (firstSourceFile)
	            addSourceFile(firstSourceFile);
	          for (const sourceFile of programOfThisState.getSourceFiles()) {
	            if (sourceFile !== firstSourceFile) {
	              addSourceFile(sourceFile);
	            }
	          }
	          state.allFilesExcludingDefaultLibraryFile = result || emptyArray;
	          return state.allFilesExcludingDefaultLibraryFile;
	          function addSourceFile(sourceFile) {
	            if (!programOfThisState.isSourceFileDefaultLibrary(sourceFile)) {
	              (result || (result = [])).push(sourceFile);
	            }
	          }
	        }
	        BuilderState2.getAllFilesExcludingDefaultLibraryFile = getAllFilesExcludingDefaultLibraryFile;
	        function getFilesAffectedByUpdatedShapeWhenNonModuleEmit(state, programOfThisState, sourceFileWithUpdatedShape) {
	          const compilerOptions = programOfThisState.getCompilerOptions();
	          if (compilerOptions && outFile(compilerOptions)) {
	            return [sourceFileWithUpdatedShape];
	          }
	          return getAllFilesExcludingDefaultLibraryFile(state, programOfThisState, sourceFileWithUpdatedShape);
	        }
	        function getFilesAffectedByUpdatedShapeWhenModuleEmit(state, programOfThisState, sourceFileWithUpdatedShape, cancellationToken, host) {
	          if (isFileAffectingGlobalScope(sourceFileWithUpdatedShape)) {
	            return getAllFilesExcludingDefaultLibraryFile(state, programOfThisState, sourceFileWithUpdatedShape);
	          }
	          const compilerOptions = programOfThisState.getCompilerOptions();
	          if (compilerOptions && (getIsolatedModules(compilerOptions) || outFile(compilerOptions))) {
	            return [sourceFileWithUpdatedShape];
	          }
	          const seenFileNamesMap = /* @__PURE__ */ new Map();
	          seenFileNamesMap.set(sourceFileWithUpdatedShape.resolvedPath, sourceFileWithUpdatedShape);
	          const queue = getReferencedByPaths(state, sourceFileWithUpdatedShape.resolvedPath);
	          while (queue.length > 0) {
	            const currentPath = queue.pop();
	            if (!seenFileNamesMap.has(currentPath)) {
	              const currentSourceFile = programOfThisState.getSourceFileByPath(currentPath);
	              seenFileNamesMap.set(currentPath, currentSourceFile);
	              if (currentSourceFile && updateShapeSignature(state, programOfThisState, currentSourceFile, cancellationToken, host)) {
	                queue.push(...getReferencedByPaths(state, currentSourceFile.resolvedPath));
	              }
	            }
	          }
	          return arrayFrom(mapDefinedIterator(seenFileNamesMap.values(), (value) => value));
	        }
	      })(BuilderState || (BuilderState = {}));
	    }
	  });

	  // src/compiler/builder.ts
	  function getBuilderFileEmit(options) {
	    let result = 1 /* Js */;
	    if (options.sourceMap)
	      result = result | 2 /* JsMap */;
	    if (options.inlineSourceMap)
	      result = result | 4 /* JsInlineMap */;
	    if (getEmitDeclarations(options))
	      result = result | 8 /* Dts */;
	    if (options.declarationMap)
	      result = result | 16 /* DtsMap */;
	    if (options.emitDeclarationOnly)
	      result = result & 24 /* AllDts */;
	    return result;
	  }
	  function getPendingEmitKind(optionsOrEmitKind, oldOptionsOrEmitKind) {
	    const oldEmitKind = oldOptionsOrEmitKind && (isNumber(oldOptionsOrEmitKind) ? oldOptionsOrEmitKind : getBuilderFileEmit(oldOptionsOrEmitKind));
	    const emitKind = isNumber(optionsOrEmitKind) ? optionsOrEmitKind : getBuilderFileEmit(optionsOrEmitKind);
	    if (oldEmitKind === emitKind)
	      return 0 /* None */;
	    if (!oldEmitKind || !emitKind)
	      return emitKind;
	    const diff = oldEmitKind ^ emitKind;
	    let result = 0 /* None */;
	    if (diff & 7 /* AllJs */)
	      result = emitKind & 7 /* AllJs */;
	    if (diff & 24 /* AllDts */)
	      result = result | emitKind & 24 /* AllDts */;
	    return result;
	  }
	  function hasSameKeys(map1, map2) {
	    return map1 === map2 || map1 !== void 0 && map2 !== void 0 && map1.size === map2.size && !forEachKey(map1, (key) => !map2.has(key));
	  }
	  function createBuilderProgramState(newProgram, oldState) {
	    var _a, _b;
	    const state = BuilderState.create(
	      newProgram,
	      oldState,
	      /*disableUseFileVersionAsSignature*/
	      false
	    );
	    state.program = newProgram;
	    const compilerOptions = newProgram.getCompilerOptions();
	    state.compilerOptions = compilerOptions;
	    const outFilePath = outFile(compilerOptions);
	    if (!outFilePath) {
	      state.semanticDiagnosticsPerFile = /* @__PURE__ */ new Map();
	    } else if (compilerOptions.composite && (oldState == null ? void 0 : oldState.outSignature) && outFilePath === outFile(oldState == null ? void 0 : oldState.compilerOptions)) {
	      state.outSignature = oldState.outSignature && getEmitSignatureFromOldSignature(compilerOptions, oldState.compilerOptions, oldState.outSignature);
	    }
	    state.changedFilesSet = /* @__PURE__ */ new Set();
	    state.latestChangedDtsFile = compilerOptions.composite ? oldState == null ? void 0 : oldState.latestChangedDtsFile : void 0;
	    const useOldState = BuilderState.canReuseOldState(state.referencedMap, oldState);
	    const oldCompilerOptions = useOldState ? oldState.compilerOptions : void 0;
	    const canCopySemanticDiagnostics = useOldState && oldState.semanticDiagnosticsPerFile && !!state.semanticDiagnosticsPerFile && !compilerOptionsAffectSemanticDiagnostics(compilerOptions, oldCompilerOptions);
	    const canCopyEmitSignatures = compilerOptions.composite && (oldState == null ? void 0 : oldState.emitSignatures) && !outFilePath && !compilerOptionsAffectDeclarationPath(compilerOptions, oldState.compilerOptions);
	    if (useOldState) {
	      (_a = oldState.changedFilesSet) == null ? void 0 : _a.forEach((value) => state.changedFilesSet.add(value));
	      if (!outFilePath && ((_b = oldState.affectedFilesPendingEmit) == null ? void 0 : _b.size)) {
	        state.affectedFilesPendingEmit = new Map(oldState.affectedFilesPendingEmit);
	        state.seenAffectedFiles = /* @__PURE__ */ new Set();
	      }
	      state.programEmitPending = oldState.programEmitPending;
	    } else {
	      state.buildInfoEmitPending = true;
	    }
	    const referencedMap = state.referencedMap;
	    const oldReferencedMap = useOldState ? oldState.referencedMap : void 0;
	    const copyDeclarationFileDiagnostics = canCopySemanticDiagnostics && !compilerOptions.skipLibCheck === !oldCompilerOptions.skipLibCheck;
	    const copyLibFileDiagnostics = copyDeclarationFileDiagnostics && !compilerOptions.skipDefaultLibCheck === !oldCompilerOptions.skipDefaultLibCheck;
	    state.fileInfos.forEach((info, sourceFilePath) => {
	      var _a2;
	      let oldInfo;
	      let newReferences;
	      if (!useOldState || // File wasn't present in old state
	      !(oldInfo = oldState.fileInfos.get(sourceFilePath)) || // versions dont match
	      oldInfo.version !== info.version || // Implied formats dont match
	      oldInfo.impliedFormat !== info.impliedFormat || // Referenced files changed
	      !hasSameKeys(newReferences = referencedMap && referencedMap.getValues(sourceFilePath), oldReferencedMap && oldReferencedMap.getValues(sourceFilePath)) || // Referenced file was deleted in the new program
	      newReferences && forEachKey(newReferences, (path) => !state.fileInfos.has(path) && oldState.fileInfos.has(path))) {
	        addFileToChangeSet(state, sourceFilePath);
	      } else {
	        const sourceFile = newProgram.getSourceFileByPath(sourceFilePath);
	        const emitDiagnostics = (_a2 = oldState.emitDiagnosticsPerFile) == null ? void 0 : _a2.get(sourceFilePath);
	        if (emitDiagnostics) {
	          (state.emitDiagnosticsPerFile ?? (state.emitDiagnosticsPerFile = /* @__PURE__ */ new Map())).set(
	            sourceFilePath,
	            oldState.hasReusableDiagnostic ? convertToDiagnostics(emitDiagnostics, newProgram) : repopulateDiagnostics(emitDiagnostics, newProgram)
	          );
	        }
	        if (canCopySemanticDiagnostics) {
	          if (sourceFile.isDeclarationFile && !copyDeclarationFileDiagnostics)
	            return;
	          if (sourceFile.hasNoDefaultLib && !copyLibFileDiagnostics)
	            return;
	          const diagnostics = oldState.semanticDiagnosticsPerFile.get(sourceFilePath);
	          if (diagnostics) {
	            state.semanticDiagnosticsPerFile.set(
	              sourceFilePath,
	              oldState.hasReusableDiagnostic ? convertToDiagnostics(diagnostics, newProgram) : repopulateDiagnostics(diagnostics, newProgram)
	            );
	            (state.semanticDiagnosticsFromOldState ?? (state.semanticDiagnosticsFromOldState = /* @__PURE__ */ new Set())).add(sourceFilePath);
	          }
	        }
	      }
	      if (canCopyEmitSignatures) {
	        const oldEmitSignature = oldState.emitSignatures.get(sourceFilePath);
	        if (oldEmitSignature) {
	          (state.emitSignatures ?? (state.emitSignatures = /* @__PURE__ */ new Map())).set(sourceFilePath, getEmitSignatureFromOldSignature(compilerOptions, oldState.compilerOptions, oldEmitSignature));
	        }
	      }
	    });
	    if (useOldState && forEachEntry(oldState.fileInfos, (info, sourceFilePath) => {
	      if (state.fileInfos.has(sourceFilePath))
	        return false;
	      if (outFilePath || info.affectsGlobalScope)
	        return true;
	      state.buildInfoEmitPending = true;
	      return false;
	    })) {
	      BuilderState.getAllFilesExcludingDefaultLibraryFile(
	        state,
	        newProgram,
	        /*firstSourceFile*/
	        void 0
	      ).forEach((file) => addFileToChangeSet(state, file.resolvedPath));
	    } else if (oldCompilerOptions) {
	      const pendingEmitKind = compilerOptionsAffectEmit(compilerOptions, oldCompilerOptions) ? getBuilderFileEmit(compilerOptions) : getPendingEmitKind(compilerOptions, oldCompilerOptions);
	      if (pendingEmitKind !== 0 /* None */) {
	        if (!outFilePath) {
	          newProgram.getSourceFiles().forEach((f) => {
	            if (!state.changedFilesSet.has(f.resolvedPath)) {
	              addToAffectedFilesPendingEmit(
	                state,
	                f.resolvedPath,
	                pendingEmitKind
	              );
	            }
	          });
	          Debug.assert(!state.seenAffectedFiles || !state.seenAffectedFiles.size);
	          state.seenAffectedFiles = state.seenAffectedFiles || /* @__PURE__ */ new Set();
	          state.buildInfoEmitPending = true;
	        } else {
	          state.programEmitPending = state.programEmitPending ? state.programEmitPending | pendingEmitKind : pendingEmitKind;
	        }
	      }
	    }
	    if (outFilePath && !state.changedFilesSet.size) {
	      if (useOldState)
	        state.bundle = oldState.bundle;
	      if (some(newProgram.getProjectReferences(), (ref) => !!ref.prepend))
	        state.programEmitPending = getBuilderFileEmit(compilerOptions);
	    }
	    return state;
	  }
	  function addFileToChangeSet(state, path) {
	    state.changedFilesSet.add(path);
	    state.buildInfoEmitPending = true;
	    state.programEmitPending = void 0;
	  }
	  function getEmitSignatureFromOldSignature(options, oldOptions, oldEmitSignature) {
	    return !!options.declarationMap === !!oldOptions.declarationMap ? (
	      // Use same format of signature
	      oldEmitSignature
	    ) : (
	      // Convert to different format
	      isString(oldEmitSignature) ? [oldEmitSignature] : oldEmitSignature[0]
	    );
	  }
	  function repopulateDiagnostics(diagnostics, newProgram) {
	    if (!diagnostics.length)
	      return diagnostics;
	    return sameMap(diagnostics, (diag2) => {
	      if (isString(diag2.messageText))
	        return diag2;
	      const repopulatedChain = convertOrRepopulateDiagnosticMessageChain(diag2.messageText, diag2.file, newProgram, (chain) => {
	        var _a;
	        return (_a = chain.repopulateInfo) == null ? void 0 : _a.call(chain);
	      });
	      return repopulatedChain === diag2.messageText ? diag2 : { ...diag2, messageText: repopulatedChain };
	    });
	  }
	  function convertOrRepopulateDiagnosticMessageChain(chain, sourceFile, newProgram, repopulateInfo) {
	    const info = repopulateInfo(chain);
	    if (info) {
	      return {
	        ...createModuleNotFoundChain(sourceFile, newProgram, info.moduleReference, info.mode, info.packageName || info.moduleReference),
	        next: convertOrRepopulateDiagnosticMessageChainArray(chain.next, sourceFile, newProgram, repopulateInfo)
	      };
	    }
	    const next = convertOrRepopulateDiagnosticMessageChainArray(chain.next, sourceFile, newProgram, repopulateInfo);
	    return next === chain.next ? chain : { ...chain, next };
	  }
	  function convertOrRepopulateDiagnosticMessageChainArray(array, sourceFile, newProgram, repopulateInfo) {
	    return sameMap(array, (chain) => convertOrRepopulateDiagnosticMessageChain(chain, sourceFile, newProgram, repopulateInfo));
	  }
	  function convertToDiagnostics(diagnostics, newProgram) {
	    if (!diagnostics.length)
	      return emptyArray;
	    let buildInfoDirectory;
	    return diagnostics.map((diagnostic) => {
	      const result = convertToDiagnosticRelatedInformation(diagnostic, newProgram, toPathInBuildInfoDirectory);
	      result.reportsUnnecessary = diagnostic.reportsUnnecessary;
	      result.reportsDeprecated = diagnostic.reportDeprecated;
	      result.source = diagnostic.source;
	      result.skippedOn = diagnostic.skippedOn;
	      const { relatedInformation } = diagnostic;
	      result.relatedInformation = relatedInformation ? relatedInformation.length ? relatedInformation.map((r) => convertToDiagnosticRelatedInformation(r, newProgram, toPathInBuildInfoDirectory)) : [] : void 0;
	      return result;
	    });
	    function toPathInBuildInfoDirectory(path) {
	      buildInfoDirectory ?? (buildInfoDirectory = getDirectoryPath(getNormalizedAbsolutePath(getTsBuildInfoEmitOutputFilePath(newProgram.getCompilerOptions()), newProgram.getCurrentDirectory())));
	      return toPath(path, buildInfoDirectory, newProgram.getCanonicalFileName);
	    }
	  }
	  function convertToDiagnosticRelatedInformation(diagnostic, newProgram, toPath3) {
	    const { file } = diagnostic;
	    const sourceFile = file ? newProgram.getSourceFileByPath(toPath3(file)) : void 0;
	    return {
	      ...diagnostic,
	      file: sourceFile,
	      messageText: isString(diagnostic.messageText) ? diagnostic.messageText : convertOrRepopulateDiagnosticMessageChain(diagnostic.messageText, sourceFile, newProgram, (chain) => chain.info)
	    };
	  }
	  function releaseCache(state) {
	    BuilderState.releaseCache(state);
	    state.program = void 0;
	  }
	  function backupBuilderProgramEmitState(state) {
	    const outFilePath = outFile(state.compilerOptions);
	    Debug.assert(!state.changedFilesSet.size || outFilePath);
	    return {
	      affectedFilesPendingEmit: state.affectedFilesPendingEmit && new Map(state.affectedFilesPendingEmit),
	      seenEmittedFiles: state.seenEmittedFiles && new Map(state.seenEmittedFiles),
	      programEmitPending: state.programEmitPending,
	      emitSignatures: state.emitSignatures && new Map(state.emitSignatures),
	      outSignature: state.outSignature,
	      latestChangedDtsFile: state.latestChangedDtsFile,
	      hasChangedEmitSignature: state.hasChangedEmitSignature,
	      changedFilesSet: outFilePath ? new Set(state.changedFilesSet) : void 0,
	      buildInfoEmitPending: state.buildInfoEmitPending,
	      emitDiagnosticsPerFile: state.emitDiagnosticsPerFile && new Map(state.emitDiagnosticsPerFile)
	    };
	  }
	  function restoreBuilderProgramEmitState(state, savedEmitState) {
	    state.affectedFilesPendingEmit = savedEmitState.affectedFilesPendingEmit;
	    state.seenEmittedFiles = savedEmitState.seenEmittedFiles;
	    state.programEmitPending = savedEmitState.programEmitPending;
	    state.emitSignatures = savedEmitState.emitSignatures;
	    state.outSignature = savedEmitState.outSignature;
	    state.latestChangedDtsFile = savedEmitState.latestChangedDtsFile;
	    state.hasChangedEmitSignature = savedEmitState.hasChangedEmitSignature;
	    state.buildInfoEmitPending = savedEmitState.buildInfoEmitPending;
	    state.emitDiagnosticsPerFile = savedEmitState.emitDiagnosticsPerFile;
	    if (savedEmitState.changedFilesSet)
	      state.changedFilesSet = savedEmitState.changedFilesSet;
	  }
	  function assertSourceFileOkWithoutNextAffectedCall(state, sourceFile) {
	    Debug.assert(!sourceFile || !state.affectedFiles || state.affectedFiles[state.affectedFilesIndex - 1] !== sourceFile || !state.semanticDiagnosticsPerFile.has(sourceFile.resolvedPath));
	  }
	  function getNextAffectedFile(state, cancellationToken, host) {
	    var _a, _b;
	    while (true) {
	      const { affectedFiles } = state;
	      if (affectedFiles) {
	        const seenAffectedFiles = state.seenAffectedFiles;
	        let affectedFilesIndex = state.affectedFilesIndex;
	        while (affectedFilesIndex < affectedFiles.length) {
	          const affectedFile = affectedFiles[affectedFilesIndex];
	          if (!seenAffectedFiles.has(affectedFile.resolvedPath)) {
	            state.affectedFilesIndex = affectedFilesIndex;
	            addToAffectedFilesPendingEmit(state, affectedFile.resolvedPath, getBuilderFileEmit(state.compilerOptions));
	            handleDtsMayChangeOfAffectedFile(
	              state,
	              affectedFile,
	              cancellationToken,
	              host
	            );
	            return affectedFile;
	          }
	          affectedFilesIndex++;
	        }
	        state.changedFilesSet.delete(state.currentChangedFilePath);
	        state.currentChangedFilePath = void 0;
	        (_a = state.oldSignatures) == null ? void 0 : _a.clear();
	        (_b = state.oldExportedModulesMap) == null ? void 0 : _b.clear();
	        state.affectedFiles = void 0;
	      }
	      const nextKey = state.changedFilesSet.keys().next();
	      if (nextKey.done) {
	        return void 0;
	      }
	      const program = Debug.checkDefined(state.program);
	      const compilerOptions = program.getCompilerOptions();
	      if (outFile(compilerOptions)) {
	        Debug.assert(!state.semanticDiagnosticsPerFile);
	        return program;
	      }
	      state.affectedFiles = BuilderState.getFilesAffectedByWithOldState(
	        state,
	        program,
	        nextKey.value,
	        cancellationToken,
	        host
	      );
	      state.currentChangedFilePath = nextKey.value;
	      state.affectedFilesIndex = 0;
	      if (!state.seenAffectedFiles)
	        state.seenAffectedFiles = /* @__PURE__ */ new Set();
	    }
	  }
	  function clearAffectedFilesPendingEmit(state, emitOnlyDtsFiles) {
	    var _a;
	    if (!((_a = state.affectedFilesPendingEmit) == null ? void 0 : _a.size))
	      return;
	    if (!emitOnlyDtsFiles)
	      return state.affectedFilesPendingEmit = void 0;
	    state.affectedFilesPendingEmit.forEach((emitKind, path) => {
	      const pending = emitKind & 7 /* AllJs */;
	      if (!pending)
	        state.affectedFilesPendingEmit.delete(path);
	      else
	        state.affectedFilesPendingEmit.set(path, pending);
	    });
	  }
	  function getNextAffectedFilePendingEmit(state, emitOnlyDtsFiles) {
	    var _a;
	    if (!((_a = state.affectedFilesPendingEmit) == null ? void 0 : _a.size))
	      return void 0;
	    return forEachEntry(state.affectedFilesPendingEmit, (emitKind, path) => {
	      var _a2;
	      const affectedFile = state.program.getSourceFileByPath(path);
	      if (!affectedFile || !sourceFileMayBeEmitted(affectedFile, state.program)) {
	        state.affectedFilesPendingEmit.delete(path);
	        return void 0;
	      }
	      const seenKind = (_a2 = state.seenEmittedFiles) == null ? void 0 : _a2.get(affectedFile.resolvedPath);
	      let pendingKind = getPendingEmitKind(emitKind, seenKind);
	      if (emitOnlyDtsFiles)
	        pendingKind = pendingKind & 24 /* AllDts */;
	      if (pendingKind)
	        return { affectedFile, emitKind: pendingKind };
	    });
	  }
	  function getNextPendingEmitDiagnosticsFile(state) {
	    var _a;
	    if (!((_a = state.emitDiagnosticsPerFile) == null ? void 0 : _a.size))
	      return void 0;
	    return forEachEntry(state.emitDiagnosticsPerFile, (diagnostics, path) => {
	      var _a2;
	      const affectedFile = state.program.getSourceFileByPath(path);
	      if (!affectedFile || !sourceFileMayBeEmitted(affectedFile, state.program)) {
	        state.emitDiagnosticsPerFile.delete(path);
	        return void 0;
	      }
	      const seenKind = ((_a2 = state.seenEmittedFiles) == null ? void 0 : _a2.get(affectedFile.resolvedPath)) || 0 /* None */;
	      if (!(seenKind & 24 /* AllDts */))
	        return { affectedFile, diagnostics, seenKind };
	    });
	  }
	  function removeDiagnosticsOfLibraryFiles(state) {
	    if (!state.cleanedDiagnosticsOfLibFiles) {
	      state.cleanedDiagnosticsOfLibFiles = true;
	      const program = Debug.checkDefined(state.program);
	      const options = program.getCompilerOptions();
	      forEach(program.getSourceFiles(), (f) => program.isSourceFileDefaultLibrary(f) && !skipTypeChecking(f, options, program) && removeSemanticDiagnosticsOf(state, f.resolvedPath));
	    }
	  }
	  function handleDtsMayChangeOfAffectedFile(state, affectedFile, cancellationToken, host) {
	    removeSemanticDiagnosticsOf(state, affectedFile.resolvedPath);
	    if (state.allFilesExcludingDefaultLibraryFile === state.affectedFiles) {
	      removeDiagnosticsOfLibraryFiles(state);
	      BuilderState.updateShapeSignature(
	        state,
	        Debug.checkDefined(state.program),
	        affectedFile,
	        cancellationToken,
	        host
	      );
	      return;
	    }
	    if (state.compilerOptions.assumeChangesOnlyAffectDirectDependencies)
	      return;
	    handleDtsMayChangeOfReferencingExportOfAffectedFile(
	      state,
	      affectedFile,
	      cancellationToken,
	      host
	    );
	  }
	  function handleDtsMayChangeOf(state, path, cancellationToken, host) {
	    removeSemanticDiagnosticsOf(state, path);
	    if (!state.changedFilesSet.has(path)) {
	      const program = Debug.checkDefined(state.program);
	      const sourceFile = program.getSourceFileByPath(path);
	      if (sourceFile) {
	        BuilderState.updateShapeSignature(
	          state,
	          program,
	          sourceFile,
	          cancellationToken,
	          host,
	          /*useFileVersionAsSignature*/
	          true
	        );
	        if (getEmitDeclarations(state.compilerOptions)) {
	          addToAffectedFilesPendingEmit(state, path, state.compilerOptions.declarationMap ? 24 /* AllDts */ : 8 /* Dts */);
	        }
	      }
	    }
	  }
	  function removeSemanticDiagnosticsOf(state, path) {
	    if (!state.semanticDiagnosticsFromOldState) {
	      return true;
	    }
	    state.semanticDiagnosticsFromOldState.delete(path);
	    state.semanticDiagnosticsPerFile.delete(path);
	    return !state.semanticDiagnosticsFromOldState.size;
	  }
	  function isChangedSignature(state, path) {
	    const oldSignature = Debug.checkDefined(state.oldSignatures).get(path) || void 0;
	    const newSignature = Debug.checkDefined(state.fileInfos.get(path)).signature;
	    return newSignature !== oldSignature;
	  }
	  function handleDtsMayChangeOfGlobalScope(state, filePath, cancellationToken, host) {
	    var _a;
	    if (!((_a = state.fileInfos.get(filePath)) == null ? void 0 : _a.affectsGlobalScope))
	      return false;
	    BuilderState.getAllFilesExcludingDefaultLibraryFile(
	      state,
	      state.program,
	      /*firstSourceFile*/
	      void 0
	    ).forEach(
	      (file) => handleDtsMayChangeOf(
	        state,
	        file.resolvedPath,
	        cancellationToken,
	        host
	      )
	    );
	    removeDiagnosticsOfLibraryFiles(state);
	    return true;
	  }
	  function handleDtsMayChangeOfReferencingExportOfAffectedFile(state, affectedFile, cancellationToken, host) {
	    var _a;
	    if (!state.exportedModulesMap || !state.changedFilesSet.has(affectedFile.resolvedPath))
	      return;
	    if (!isChangedSignature(state, affectedFile.resolvedPath))
	      return;
	    if (getIsolatedModules(state.compilerOptions)) {
	      const seenFileNamesMap = /* @__PURE__ */ new Map();
	      seenFileNamesMap.set(affectedFile.resolvedPath, true);
	      const queue = BuilderState.getReferencedByPaths(state, affectedFile.resolvedPath);
	      while (queue.length > 0) {
	        const currentPath = queue.pop();
	        if (!seenFileNamesMap.has(currentPath)) {
	          seenFileNamesMap.set(currentPath, true);
	          if (handleDtsMayChangeOfGlobalScope(state, currentPath, cancellationToken, host))
	            return;
	          handleDtsMayChangeOf(state, currentPath, cancellationToken, host);
	          if (isChangedSignature(state, currentPath)) {
	            const currentSourceFile = Debug.checkDefined(state.program).getSourceFileByPath(currentPath);
	            queue.push(...BuilderState.getReferencedByPaths(state, currentSourceFile.resolvedPath));
	          }
	        }
	      }
	    }
	    const seenFileAndExportsOfFile = /* @__PURE__ */ new Set();
	    (_a = state.exportedModulesMap.getKeys(affectedFile.resolvedPath)) == null ? void 0 : _a.forEach((exportedFromPath) => {
	      if (handleDtsMayChangeOfGlobalScope(state, exportedFromPath, cancellationToken, host))
	        return true;
	      const references = state.referencedMap.getKeys(exportedFromPath);
	      return references && forEachKey(references, (filePath) => handleDtsMayChangeOfFileAndExportsOfFile(
	        state,
	        filePath,
	        seenFileAndExportsOfFile,
	        cancellationToken,
	        host
	      ));
	    });
	  }
	  function handleDtsMayChangeOfFileAndExportsOfFile(state, filePath, seenFileAndExportsOfFile, cancellationToken, host) {
	    var _a, _b;
	    if (!tryAddToSet(seenFileAndExportsOfFile, filePath))
	      return void 0;
	    if (handleDtsMayChangeOfGlobalScope(state, filePath, cancellationToken, host))
	      return true;
	    handleDtsMayChangeOf(state, filePath, cancellationToken, host);
	    (_a = state.exportedModulesMap.getKeys(filePath)) == null ? void 0 : _a.forEach(
	      (exportedFromPath) => handleDtsMayChangeOfFileAndExportsOfFile(
	        state,
	        exportedFromPath,
	        seenFileAndExportsOfFile,
	        cancellationToken,
	        host
	      )
	    );
	    (_b = state.referencedMap.getKeys(filePath)) == null ? void 0 : _b.forEach(
	      (referencingFilePath) => !seenFileAndExportsOfFile.has(referencingFilePath) && // Not already removed diagnostic file
	      handleDtsMayChangeOf(
	        // Dont add to seen since this is not yet done with the export removal
	        state,
	        referencingFilePath,
	        cancellationToken,
	        host
	      )
	    );
	    return void 0;
	  }
	  function getSemanticDiagnosticsOfFile(state, sourceFile, cancellationToken) {
	    return concatenate(
	      getBinderAndCheckerDiagnosticsOfFile(state, sourceFile, cancellationToken),
	      Debug.checkDefined(state.program).getProgramDiagnostics(sourceFile)
	    );
	  }
	  function getBinderAndCheckerDiagnosticsOfFile(state, sourceFile, cancellationToken) {
	    const path = sourceFile.resolvedPath;
	    if (state.semanticDiagnosticsPerFile) {
	      const cachedDiagnostics = state.semanticDiagnosticsPerFile.get(path);
	      if (cachedDiagnostics) {
	        return filterSemanticDiagnostics(cachedDiagnostics, state.compilerOptions);
	      }
	    }
	    const diagnostics = Debug.checkDefined(state.program).getBindAndCheckDiagnostics(sourceFile, cancellationToken);
	    if (state.semanticDiagnosticsPerFile) {
	      state.semanticDiagnosticsPerFile.set(path, diagnostics);
	    }
	    return filterSemanticDiagnostics(diagnostics, state.compilerOptions);
	  }
	  function isProgramBundleEmitBuildInfo(info) {
	    return !!outFile(info.options || {});
	  }
	  function getBuildInfo2(state, bundle) {
	    var _a, _b, _c;
	    const currentDirectory = Debug.checkDefined(state.program).getCurrentDirectory();
	    const buildInfoDirectory = getDirectoryPath(getNormalizedAbsolutePath(getTsBuildInfoEmitOutputFilePath(state.compilerOptions), currentDirectory));
	    const latestChangedDtsFile = state.latestChangedDtsFile ? relativeToBuildInfoEnsuringAbsolutePath(state.latestChangedDtsFile) : void 0;
	    const fileNames = [];
	    const fileNameToFileId = /* @__PURE__ */ new Map();
	    const root = [];
	    if (outFile(state.compilerOptions)) {
	      const fileInfos2 = arrayFrom(state.fileInfos.entries(), ([key, value]) => {
	        const fileId = toFileId(key);
	        tryAddRoot(key, fileId);
	        return value.impliedFormat ? { version: value.version, impliedFormat: value.impliedFormat, signature: void 0, affectsGlobalScope: void 0 } : value.version;
	      });
	      const program2 = {
	        fileNames,
	        fileInfos: fileInfos2,
	        root,
	        options: convertToProgramBuildInfoCompilerOptions(state.compilerOptions),
	        outSignature: state.outSignature,
	        latestChangedDtsFile,
	        pendingEmit: !state.programEmitPending ? void 0 : (
	          // Pending is undefined or None is encoded as undefined
	          state.programEmitPending === getBuilderFileEmit(state.compilerOptions) ? false : (
	            // Pending emit is same as deteremined by compilerOptions
	            state.programEmitPending
	          )
	        )
	        // Actual value
	      };
	      const { js, dts, commonSourceDirectory, sourceFiles } = bundle;
	      state.bundle = bundle = {
	        commonSourceDirectory,
	        sourceFiles,
	        js: js || (!state.compilerOptions.emitDeclarationOnly ? (_a = state.bundle) == null ? void 0 : _a.js : void 0),
	        dts: dts || (getEmitDeclarations(state.compilerOptions) ? (_b = state.bundle) == null ? void 0 : _b.dts : void 0)
	      };
	      return createBuildInfo(program2, bundle);
	    }
	    let fileIdsList;
	    let fileNamesToFileIdListId;
	    let emitSignatures;
	    const fileInfos = arrayFrom(state.fileInfos.entries(), ([key, value]) => {
	      var _a2, _b2;
	      const fileId = toFileId(key);
	      tryAddRoot(key, fileId);
	      Debug.assert(fileNames[fileId - 1] === relativeToBuildInfo(key));
	      const oldSignature = (_a2 = state.oldSignatures) == null ? void 0 : _a2.get(key);
	      const actualSignature = oldSignature !== void 0 ? oldSignature || void 0 : value.signature;
	      if (state.compilerOptions.composite) {
	        const file = state.program.getSourceFileByPath(key);
	        if (!isJsonSourceFile(file) && sourceFileMayBeEmitted(file, state.program)) {
	          const emitSignature = (_b2 = state.emitSignatures) == null ? void 0 : _b2.get(key);
	          if (emitSignature !== actualSignature) {
	            (emitSignatures || (emitSignatures = [])).push(
	              emitSignature === void 0 ? fileId : (
	                // There is no emit, encode as false
	                // fileId, signature: emptyArray if signature only differs in dtsMap option than our own compilerOptions otherwise EmitSignature
	                [fileId, !isString(emitSignature) && emitSignature[0] === actualSignature ? emptyArray : emitSignature]
	              )
	            );
	          }
	        }
	      }
	      return value.version === actualSignature ? value.affectsGlobalScope || value.impliedFormat ? (
	        // If file version is same as signature, dont serialize signature
	        { version: value.version, signature: void 0, affectsGlobalScope: value.affectsGlobalScope, impliedFormat: value.impliedFormat }
	      ) : (
	        // If file info only contains version and signature and both are same we can just write string
	        value.version
	      ) : actualSignature !== void 0 ? (
	        // If signature is not same as version, encode signature in the fileInfo
	        oldSignature === void 0 ? (
	          // If we havent computed signature, use fileInfo as is
	          value
	        ) : (
	          // Serialize fileInfo with new updated signature
	          { version: value.version, signature: actualSignature, affectsGlobalScope: value.affectsGlobalScope, impliedFormat: value.impliedFormat }
	        )
	      ) : (
	        // Signature of the FileInfo is undefined, serialize it as false
	        { version: value.version, signature: false, affectsGlobalScope: value.affectsGlobalScope, impliedFormat: value.impliedFormat }
	      );
	    });
	    let referencedMap;
	    if (state.referencedMap) {
	      referencedMap = arrayFrom(state.referencedMap.keys()).sort(compareStringsCaseSensitive).map((key) => [
	        toFileId(key),
	        toFileIdListId(state.referencedMap.getValues(key))
	      ]);
	    }
	    let exportedModulesMap;
	    if (state.exportedModulesMap) {
	      exportedModulesMap = mapDefined(arrayFrom(state.exportedModulesMap.keys()).sort(compareStringsCaseSensitive), (key) => {
	        var _a2;
	        const oldValue = (_a2 = state.oldExportedModulesMap) == null ? void 0 : _a2.get(key);
	        if (oldValue === void 0)
	          return [toFileId(key), toFileIdListId(state.exportedModulesMap.getValues(key))];
	        if (oldValue)
	          return [toFileId(key), toFileIdListId(oldValue)];
	        return void 0;
	      });
	    }
	    const semanticDiagnosticsPerFile = convertToProgramBuildInfoDiagnostics(state.semanticDiagnosticsPerFile);
	    let affectedFilesPendingEmit;
	    if ((_c = state.affectedFilesPendingEmit) == null ? void 0 : _c.size) {
	      const fullEmitForOptions = getBuilderFileEmit(state.compilerOptions);
	      const seenFiles = /* @__PURE__ */ new Set();
	      for (const path of arrayFrom(state.affectedFilesPendingEmit.keys()).sort(compareStringsCaseSensitive)) {
	        if (tryAddToSet(seenFiles, path)) {
	          const file = state.program.getSourceFileByPath(path);
	          if (!file || !sourceFileMayBeEmitted(file, state.program))
	            continue;
	          const fileId = toFileId(path), pendingEmit = state.affectedFilesPendingEmit.get(path);
	          (affectedFilesPendingEmit || (affectedFilesPendingEmit = [])).push(
	            pendingEmit === fullEmitForOptions ? fileId : (
	              // Pending full emit per options
	              pendingEmit === 8 /* Dts */ ? [fileId] : (
	                // Pending on Dts only
	                [fileId, pendingEmit]
	              )
	            )
	            // Anything else
	          );
	        }
	      }
	    }
	    let changeFileSet;
	    if (state.changedFilesSet.size) {
	      for (const path of arrayFrom(state.changedFilesSet.keys()).sort(compareStringsCaseSensitive)) {
	        (changeFileSet || (changeFileSet = [])).push(toFileId(path));
	      }
	    }
	    const emitDiagnosticsPerFile = convertToProgramBuildInfoDiagnostics(state.emitDiagnosticsPerFile);
	    const program = {
	      fileNames,
	      fileInfos,
	      root,
	      options: convertToProgramBuildInfoCompilerOptions(state.compilerOptions),
	      fileIdsList,
	      referencedMap,
	      exportedModulesMap,
	      semanticDiagnosticsPerFile,
	      emitDiagnosticsPerFile,
	      affectedFilesPendingEmit,
	      changeFileSet,
	      emitSignatures,
	      latestChangedDtsFile
	    };
	    return createBuildInfo(program, bundle);
	    function relativeToBuildInfoEnsuringAbsolutePath(path) {
	      return relativeToBuildInfo(getNormalizedAbsolutePath(path, currentDirectory));
	    }
	    function relativeToBuildInfo(path) {
	      return ensurePathIsNonModuleName(getRelativePathFromDirectory(buildInfoDirectory, path, state.program.getCanonicalFileName));
	    }
	    function toFileId(path) {
	      let fileId = fileNameToFileId.get(path);
	      if (fileId === void 0) {
	        fileNames.push(relativeToBuildInfo(path));
	        fileNameToFileId.set(path, fileId = fileNames.length);
	      }
	      return fileId;
	    }
	    function toFileIdListId(set) {
	      const fileIds = arrayFrom(set.keys(), toFileId).sort(compareValues);
	      const key = fileIds.join();
	      let fileIdListId = fileNamesToFileIdListId == null ? void 0 : fileNamesToFileIdListId.get(key);
	      if (fileIdListId === void 0) {
	        (fileIdsList || (fileIdsList = [])).push(fileIds);
	        (fileNamesToFileIdListId || (fileNamesToFileIdListId = /* @__PURE__ */ new Map())).set(key, fileIdListId = fileIdsList.length);
	      }
	      return fileIdListId;
	    }
	    function tryAddRoot(path, fileId) {
	      const file = state.program.getSourceFile(path);
	      if (!state.program.getFileIncludeReasons().get(file.path).some((r) => r.kind === 0 /* RootFile */))
	        return;
	      if (!root.length)
	        return root.push(fileId);
	      const last2 = root[root.length - 1];
	      const isLastStartEnd = isArray(last2);
	      if (isLastStartEnd && last2[1] === fileId - 1)
	        return last2[1] = fileId;
	      if (isLastStartEnd || root.length === 1 || last2 !== fileId - 1)
	        return root.push(fileId);
	      const lastButOne = root[root.length - 2];
	      if (!isNumber(lastButOne) || lastButOne !== last2 - 1)
	        return root.push(fileId);
	      root[root.length - 2] = [lastButOne, fileId];
	      return root.length = root.length - 1;
	    }
	    function convertToProgramBuildInfoCompilerOptions(options) {
	      let result;
	      const { optionsNameMap } = getOptionsNameMap();
	      for (const name of getOwnKeys(options).sort(compareStringsCaseSensitive)) {
	        const optionInfo = optionsNameMap.get(name.toLowerCase());
	        if (optionInfo == null ? void 0 : optionInfo.affectsBuildInfo) {
	          (result || (result = {}))[name] = convertToReusableCompilerOptionValue(
	            optionInfo,
	            options[name]
	          );
	        }
	      }
	      return result;
	    }
	    function convertToReusableCompilerOptionValue(option, value) {
	      if (option) {
	        Debug.assert(option.type !== "listOrElement");
	        if (option.type === "list") {
	          const values = value;
	          if (option.element.isFilePath && values.length) {
	            return values.map(relativeToBuildInfoEnsuringAbsolutePath);
	          }
	        } else if (option.isFilePath) {
	          return relativeToBuildInfoEnsuringAbsolutePath(value);
	        }
	      }
	      return value;
	    }
	    function convertToProgramBuildInfoDiagnostics(diagnostics) {
	      let result;
	      if (diagnostics) {
	        for (const key of arrayFrom(diagnostics.keys()).sort(compareStringsCaseSensitive)) {
	          const value = diagnostics.get(key);
	          (result || (result = [])).push(
	            value.length ? [
	              toFileId(key),
	              convertToReusableDiagnostics(value)
	            ] : toFileId(key)
	          );
	        }
	      }
	      return result;
	    }
	    function convertToReusableDiagnostics(diagnostics) {
	      Debug.assert(!!diagnostics.length);
	      return diagnostics.map((diagnostic) => {
	        const result = convertToReusableDiagnosticRelatedInformation(diagnostic);
	        result.reportsUnnecessary = diagnostic.reportsUnnecessary;
	        result.reportDeprecated = diagnostic.reportsDeprecated;
	        result.source = diagnostic.source;
	        result.skippedOn = diagnostic.skippedOn;
	        const { relatedInformation } = diagnostic;
	        result.relatedInformation = relatedInformation ? relatedInformation.length ? relatedInformation.map((r) => convertToReusableDiagnosticRelatedInformation(r)) : [] : void 0;
	        return result;
	      });
	    }
	    function convertToReusableDiagnosticRelatedInformation(diagnostic) {
	      const { file } = diagnostic;
	      return {
	        ...diagnostic,
	        file: file ? relativeToBuildInfo(file.resolvedPath) : void 0,
	        messageText: isString(diagnostic.messageText) ? diagnostic.messageText : convertToReusableDiagnosticMessageChain(diagnostic.messageText)
	      };
	    }
	    function convertToReusableDiagnosticMessageChain(chain) {
	      if (chain.repopulateInfo) {
	        return {
	          info: chain.repopulateInfo(),
	          next: convertToReusableDiagnosticMessageChainArray(chain.next)
	        };
	      }
	      const next = convertToReusableDiagnosticMessageChainArray(chain.next);
	      return next === chain.next ? chain : { ...chain, next };
	    }
	    function convertToReusableDiagnosticMessageChainArray(array) {
	      if (!array)
	        return array;
	      return forEach(array, (chain, index) => {
	        const reusable = convertToReusableDiagnosticMessageChain(chain);
	        if (chain === reusable)
	          return void 0;
	        const result = index > 0 ? array.slice(0, index - 1) : [];
	        result.push(reusable);
	        for (let i = index + 1; i < array.length; i++) {
	          result.push(convertToReusableDiagnosticMessageChain(array[i]));
	        }
	        return result;
	      }) || array;
	    }
	  }
	  function getBuilderCreationParameters(newProgramOrRootNames, hostOrOptions, oldProgramOrHost, configFileParsingDiagnosticsOrOldProgram, configFileParsingDiagnostics, projectReferences) {
	    let host;
	    let newProgram;
	    let oldProgram;
	    if (newProgramOrRootNames === void 0) {
	      Debug.assert(hostOrOptions === void 0);
	      host = oldProgramOrHost;
	      oldProgram = configFileParsingDiagnosticsOrOldProgram;
	      Debug.assert(!!oldProgram);
	      newProgram = oldProgram.getProgram();
	    } else if (isArray(newProgramOrRootNames)) {
	      oldProgram = configFileParsingDiagnosticsOrOldProgram;
	      newProgram = createProgram({
	        rootNames: newProgramOrRootNames,
	        options: hostOrOptions,
	        host: oldProgramOrHost,
	        oldProgram: oldProgram && oldProgram.getProgramOrUndefined(),
	        configFileParsingDiagnostics,
	        projectReferences
	      });
	      host = oldProgramOrHost;
	    } else {
	      newProgram = newProgramOrRootNames;
	      host = hostOrOptions;
	      oldProgram = oldProgramOrHost;
	      configFileParsingDiagnostics = configFileParsingDiagnosticsOrOldProgram;
	    }
	    return { host, newProgram, oldProgram, configFileParsingDiagnostics: configFileParsingDiagnostics || emptyArray };
	  }
	  function getTextHandlingSourceMapForSignature(text, data) {
	    return (data == null ? void 0 : data.sourceMapUrlPos) !== void 0 ? text.substring(0, data.sourceMapUrlPos) : text;
	  }
	  function computeSignatureWithDiagnostics(program, sourceFile, text, host, data) {
	    var _a;
	    text = getTextHandlingSourceMapForSignature(text, data);
	    let sourceFileDirectory;
	    if ((_a = data == null ? void 0 : data.diagnostics) == null ? void 0 : _a.length) {
	      text += data.diagnostics.map((diagnostic) => `${locationInfo(diagnostic)}${DiagnosticCategory[diagnostic.category]}${diagnostic.code}: ${flattenDiagnosticMessageText2(diagnostic.messageText)}`).join("\n");
	    }
	    return (host.createHash ?? generateDjb2Hash)(text);
	    function flattenDiagnosticMessageText2(diagnostic) {
	      return isString(diagnostic) ? diagnostic : diagnostic === void 0 ? "" : !diagnostic.next ? diagnostic.messageText : diagnostic.messageText + diagnostic.next.map(flattenDiagnosticMessageText2).join("\n");
	    }
	    function locationInfo(diagnostic) {
	      if (diagnostic.file.resolvedPath === sourceFile.resolvedPath)
	        return `(${diagnostic.start},${diagnostic.length})`;
	      if (sourceFileDirectory === void 0)
	        sourceFileDirectory = getDirectoryPath(sourceFile.resolvedPath);
	      return `${ensurePathIsNonModuleName(getRelativePathFromDirectory(
	        sourceFileDirectory,
	        diagnostic.file.resolvedPath,
	        program.getCanonicalFileName
	      ))}(${diagnostic.start},${diagnostic.length})`;
	    }
	  }
	  function computeSignature(text, host, data) {
	    return (host.createHash ?? generateDjb2Hash)(getTextHandlingSourceMapForSignature(text, data));
	  }
	  function createBuilderProgram(kind, { newProgram, host, oldProgram, configFileParsingDiagnostics }) {
	    let oldState = oldProgram && oldProgram.getState();
	    if (oldState && newProgram === oldState.program && configFileParsingDiagnostics === newProgram.getConfigFileParsingDiagnostics()) {
	      newProgram = void 0;
	      oldState = void 0;
	      return oldProgram;
	    }
	    const state = createBuilderProgramState(newProgram, oldState);
	    newProgram.getBuildInfo = (bundle) => getBuildInfo2(state, bundle);
	    newProgram = void 0;
	    oldProgram = void 0;
	    oldState = void 0;
	    const getState = () => state;
	    const builderProgram = createRedirectedBuilderProgram(getState, configFileParsingDiagnostics);
	    builderProgram.getState = getState;
	    builderProgram.saveEmitState = () => backupBuilderProgramEmitState(state);
	    builderProgram.restoreEmitState = (saved) => restoreBuilderProgramEmitState(state, saved);
	    builderProgram.hasChangedEmitSignature = () => !!state.hasChangedEmitSignature;
	    builderProgram.getAllDependencies = (sourceFile) => BuilderState.getAllDependencies(state, Debug.checkDefined(state.program), sourceFile);
	    builderProgram.getSemanticDiagnostics = getSemanticDiagnostics;
	    builderProgram.emit = emit;
	    builderProgram.releaseProgram = () => releaseCache(state);
	    if (kind === 0 /* SemanticDiagnosticsBuilderProgram */) {
	      builderProgram.getSemanticDiagnosticsOfNextAffectedFile = getSemanticDiagnosticsOfNextAffectedFile;
	    } else if (kind === 1 /* EmitAndSemanticDiagnosticsBuilderProgram */) {
	      builderProgram.getSemanticDiagnosticsOfNextAffectedFile = getSemanticDiagnosticsOfNextAffectedFile;
	      builderProgram.emitNextAffectedFile = emitNextAffectedFile;
	      builderProgram.emitBuildInfo = emitBuildInfo;
	    } else {
	      notImplemented();
	    }
	    return builderProgram;
	    function emitBuildInfo(writeFile2, cancellationToken) {
	      if (state.buildInfoEmitPending) {
	        const result = Debug.checkDefined(state.program).emitBuildInfo(writeFile2 || maybeBind(host, host.writeFile), cancellationToken);
	        state.buildInfoEmitPending = false;
	        return result;
	      }
	      return emitSkippedWithNoDiagnostics;
	    }
	    function emitNextAffectedFile(writeFile2, cancellationToken, emitOnlyDtsFiles, customTransformers) {
	      var _a, _b, _c;
	      let affected = getNextAffectedFile(state, cancellationToken, host);
	      const programEmitKind = getBuilderFileEmit(state.compilerOptions);
	      let emitKind = emitOnlyDtsFiles ? programEmitKind & 24 /* AllDts */ : programEmitKind;
	      if (!affected) {
	        if (!outFile(state.compilerOptions)) {
	          const pendingAffectedFile = getNextAffectedFilePendingEmit(state, emitOnlyDtsFiles);
	          if (!pendingAffectedFile) {
	            const pendingForDiagnostics = getNextPendingEmitDiagnosticsFile(state);
	            if (pendingForDiagnostics) {
	              (state.seenEmittedFiles ?? (state.seenEmittedFiles = /* @__PURE__ */ new Map())).set(pendingForDiagnostics.affectedFile.resolvedPath, pendingForDiagnostics.seenKind | 24 /* AllDts */);
	              return {
	                result: { emitSkipped: true, diagnostics: pendingForDiagnostics.diagnostics },
	                affected: pendingForDiagnostics.affectedFile
	              };
	            }
	            if (!state.buildInfoEmitPending)
	              return void 0;
	            const affected2 = state.program;
	            const result2 = affected2.emitBuildInfo(writeFile2 || maybeBind(host, host.writeFile), cancellationToken);
	            state.buildInfoEmitPending = false;
	            return { result: result2, affected: affected2 };
	          }
	          ({ affectedFile: affected, emitKind } = pendingAffectedFile);
	        } else {
	          if (!state.programEmitPending)
	            return void 0;
	          emitKind = state.programEmitPending;
	          if (emitOnlyDtsFiles)
	            emitKind = emitKind & 24 /* AllDts */;
	          if (!emitKind)
	            return void 0;
	          affected = state.program;
	        }
	      }
	      let emitOnly;
	      if (emitKind & 7 /* AllJs */)
	        emitOnly = 0 /* Js */;
	      if (emitKind & 24 /* AllDts */)
	        emitOnly = emitOnly === void 0 ? 1 /* Dts */ : void 0;
	      if (affected === state.program) {
	        state.programEmitPending = state.changedFilesSet.size ? getPendingEmitKind(programEmitKind, emitKind) : state.programEmitPending ? getPendingEmitKind(state.programEmitPending, emitKind) : void 0;
	      }
	      const result = state.program.emit(
	        affected === state.program ? void 0 : affected,
	        getWriteFileCallback(writeFile2, customTransformers),
	        cancellationToken,
	        emitOnly,
	        customTransformers
	      );
	      if (affected !== state.program) {
	        const affectedSourceFile = affected;
	        state.seenAffectedFiles.add(affectedSourceFile.resolvedPath);
	        if (state.affectedFilesIndex !== void 0)
	          state.affectedFilesIndex++;
	        state.buildInfoEmitPending = true;
	        const existing = ((_a = state.seenEmittedFiles) == null ? void 0 : _a.get(affectedSourceFile.resolvedPath)) || 0 /* None */;
	        (state.seenEmittedFiles ?? (state.seenEmittedFiles = /* @__PURE__ */ new Map())).set(affectedSourceFile.resolvedPath, emitKind | existing);
	        const existingPending = ((_b = state.affectedFilesPendingEmit) == null ? void 0 : _b.get(affectedSourceFile.resolvedPath)) || programEmitKind;
	        const pendingKind = getPendingEmitKind(existingPending, emitKind | existing);
	        if (pendingKind)
	          (state.affectedFilesPendingEmit ?? (state.affectedFilesPendingEmit = /* @__PURE__ */ new Map())).set(affectedSourceFile.resolvedPath, pendingKind);
	        else
	          (_c = state.affectedFilesPendingEmit) == null ? void 0 : _c.delete(affectedSourceFile.resolvedPath);
	        if (result.diagnostics.length)
	          (state.emitDiagnosticsPerFile ?? (state.emitDiagnosticsPerFile = /* @__PURE__ */ new Map())).set(affectedSourceFile.resolvedPath, result.diagnostics);
	      } else {
	        state.changedFilesSet.clear();
	      }
	      return { result, affected };
	    }
	    function getWriteFileCallback(writeFile2, customTransformers) {
	      if (!getEmitDeclarations(state.compilerOptions))
	        return writeFile2 || maybeBind(host, host.writeFile);
	      return (fileName, text, writeByteOrderMark, onError, sourceFiles, data) => {
	        var _a, _b, _c, _d;
	        if (isDeclarationFileName(fileName)) {
	          if (!outFile(state.compilerOptions)) {
	            Debug.assert((sourceFiles == null ? void 0 : sourceFiles.length) === 1);
	            let emitSignature;
	            if (!customTransformers) {
	              const file = sourceFiles[0];
	              const info = state.fileInfos.get(file.resolvedPath);
	              if (info.signature === file.version) {
	                const signature = computeSignatureWithDiagnostics(
	                  state.program,
	                  file,
	                  text,
	                  host,
	                  data
	                );
	                if (!((_a = data == null ? void 0 : data.diagnostics) == null ? void 0 : _a.length))
	                  emitSignature = signature;
	                if (signature !== file.version) {
	                  if (host.storeFilesChangingSignatureDuringEmit)
	                    (state.filesChangingSignature ?? (state.filesChangingSignature = /* @__PURE__ */ new Set())).add(file.resolvedPath);
	                  if (state.exportedModulesMap)
	                    BuilderState.updateExportedModules(state, file, file.exportedModulesFromDeclarationEmit);
	                  if (state.affectedFiles) {
	                    const existing = (_b = state.oldSignatures) == null ? void 0 : _b.get(file.resolvedPath);
	                    if (existing === void 0)
	                      (state.oldSignatures ?? (state.oldSignatures = /* @__PURE__ */ new Map())).set(file.resolvedPath, info.signature || false);
	                    info.signature = signature;
	                  } else {
	                    info.signature = signature;
	                    (_c = state.oldExportedModulesMap) == null ? void 0 : _c.clear();
	                  }
	                }
	              }
	            }
	            if (state.compilerOptions.composite) {
	              const filePath = sourceFiles[0].resolvedPath;
	              emitSignature = handleNewSignature((_d = state.emitSignatures) == null ? void 0 : _d.get(filePath), emitSignature);
	              if (!emitSignature)
	                return;
	              (state.emitSignatures ?? (state.emitSignatures = /* @__PURE__ */ new Map())).set(filePath, emitSignature);
	            }
	          } else if (state.compilerOptions.composite) {
	            const newSignature = handleNewSignature(
	              state.outSignature,
	              /*newSignature*/
	              void 0
	            );
	            if (!newSignature)
	              return;
	            state.outSignature = newSignature;
	          }
	        }
	        if (writeFile2)
	          writeFile2(fileName, text, writeByteOrderMark, onError, sourceFiles, data);
	        else if (host.writeFile)
	          host.writeFile(fileName, text, writeByteOrderMark, onError, sourceFiles, data);
	        else
	          state.program.writeFile(fileName, text, writeByteOrderMark, onError, sourceFiles, data);
	        function handleNewSignature(oldSignatureFormat, newSignature) {
	          const oldSignature = !oldSignatureFormat || isString(oldSignatureFormat) ? oldSignatureFormat : oldSignatureFormat[0];
	          newSignature ?? (newSignature = computeSignature(text, host, data));
	          if (newSignature === oldSignature) {
	            if (oldSignatureFormat === oldSignature)
	              return void 0;
	            else if (data)
	              data.differsOnlyInMap = true;
	            else
	              data = { differsOnlyInMap: true };
	          } else {
	            state.hasChangedEmitSignature = true;
	            state.latestChangedDtsFile = fileName;
	          }
	          return newSignature;
	        }
	      };
	    }
	    function emit(targetSourceFile, writeFile2, cancellationToken, emitOnlyDtsFiles, customTransformers) {
	      if (kind === 1 /* EmitAndSemanticDiagnosticsBuilderProgram */) {
	        assertSourceFileOkWithoutNextAffectedCall(state, targetSourceFile);
	      }
	      const result = handleNoEmitOptions(builderProgram, targetSourceFile, writeFile2, cancellationToken);
	      if (result)
	        return result;
	      if (!targetSourceFile) {
	        if (kind === 1 /* EmitAndSemanticDiagnosticsBuilderProgram */) {
	          let sourceMaps = [];
	          let emitSkipped = false;
	          let diagnostics;
	          let emittedFiles = [];
	          let affectedEmitResult;
	          while (affectedEmitResult = emitNextAffectedFile(writeFile2, cancellationToken, emitOnlyDtsFiles, customTransformers)) {
	            emitSkipped = emitSkipped || affectedEmitResult.result.emitSkipped;
	            diagnostics = addRange(diagnostics, affectedEmitResult.result.diagnostics);
	            emittedFiles = addRange(emittedFiles, affectedEmitResult.result.emittedFiles);
	            sourceMaps = addRange(sourceMaps, affectedEmitResult.result.sourceMaps);
	          }
	          return {
	            emitSkipped,
	            diagnostics: diagnostics || emptyArray,
	            emittedFiles,
	            sourceMaps
	          };
	        } else {
	          clearAffectedFilesPendingEmit(state, emitOnlyDtsFiles);
	        }
	      }
	      return Debug.checkDefined(state.program).emit(
	        targetSourceFile,
	        getWriteFileCallback(writeFile2, customTransformers),
	        cancellationToken,
	        emitOnlyDtsFiles,
	        customTransformers
	      );
	    }
	    function getSemanticDiagnosticsOfNextAffectedFile(cancellationToken, ignoreSourceFile) {
	      while (true) {
	        const affected = getNextAffectedFile(state, cancellationToken, host);
	        let result;
	        if (!affected)
	          return void 0;
	        else if (affected !== state.program) {
	          const affectedSourceFile = affected;
	          if (!ignoreSourceFile || !ignoreSourceFile(affectedSourceFile)) {
	            result = getSemanticDiagnosticsOfFile(state, affectedSourceFile, cancellationToken);
	          }
	          state.seenAffectedFiles.add(affectedSourceFile.resolvedPath);
	          state.affectedFilesIndex++;
	          state.buildInfoEmitPending = true;
	          if (!result)
	            continue;
	        } else {
	          result = state.program.getSemanticDiagnostics(
	            /*sourceFile*/
	            void 0,
	            cancellationToken
	          );
	          state.changedFilesSet.clear();
	          state.programEmitPending = getBuilderFileEmit(state.compilerOptions);
	        }
	        return { result, affected };
	      }
	    }
	    function getSemanticDiagnostics(sourceFile, cancellationToken) {
	      assertSourceFileOkWithoutNextAffectedCall(state, sourceFile);
	      const compilerOptions = Debug.checkDefined(state.program).getCompilerOptions();
	      if (outFile(compilerOptions)) {
	        Debug.assert(!state.semanticDiagnosticsPerFile);
	        return Debug.checkDefined(state.program).getSemanticDiagnostics(sourceFile, cancellationToken);
	      }
	      if (sourceFile) {
	        return getSemanticDiagnosticsOfFile(state, sourceFile, cancellationToken);
	      }
	      while (getSemanticDiagnosticsOfNextAffectedFile(cancellationToken)) {
	      }
	      let diagnostics;
	      for (const sourceFile2 of Debug.checkDefined(state.program).getSourceFiles()) {
	        diagnostics = addRange(diagnostics, getSemanticDiagnosticsOfFile(state, sourceFile2, cancellationToken));
	      }
	      return diagnostics || emptyArray;
	    }
	  }
	  function addToAffectedFilesPendingEmit(state, affectedFilePendingEmit, kind) {
	    var _a, _b;
	    const existingKind = ((_a = state.affectedFilesPendingEmit) == null ? void 0 : _a.get(affectedFilePendingEmit)) || 0 /* None */;
	    (state.affectedFilesPendingEmit ?? (state.affectedFilesPendingEmit = /* @__PURE__ */ new Map())).set(affectedFilePendingEmit, existingKind | kind);
	    (_b = state.emitDiagnosticsPerFile) == null ? void 0 : _b.delete(affectedFilePendingEmit);
	  }
	  function toBuilderStateFileInfoForMultiEmit(fileInfo) {
	    return isString(fileInfo) ? { version: fileInfo, signature: fileInfo, affectsGlobalScope: void 0, impliedFormat: void 0 } : isString(fileInfo.signature) ? fileInfo : { version: fileInfo.version, signature: fileInfo.signature === false ? void 0 : fileInfo.version, affectsGlobalScope: fileInfo.affectsGlobalScope, impliedFormat: fileInfo.impliedFormat };
	  }
	  function toBuilderFileEmit(value, fullEmitForOptions) {
	    return isNumber(value) ? fullEmitForOptions : value[1] || 8 /* Dts */;
	  }
	  function toProgramEmitPending(value, options) {
	    return !value ? getBuilderFileEmit(options || {}) : value;
	  }
	  function createBuilderProgramUsingProgramBuildInfo(buildInfo, buildInfoPath, host) {
	    var _a, _b, _c, _d;
	    const program = buildInfo.program;
	    const buildInfoDirectory = getDirectoryPath(getNormalizedAbsolutePath(buildInfoPath, host.getCurrentDirectory()));
	    const getCanonicalFileName = createGetCanonicalFileName(host.useCaseSensitiveFileNames());
	    let state;
	    const filePaths = (_a = program.fileNames) == null ? void 0 : _a.map(toPathInBuildInfoDirectory);
	    let filePathsSetList;
	    const latestChangedDtsFile = program.latestChangedDtsFile ? toAbsolutePath(program.latestChangedDtsFile) : void 0;
	    if (isProgramBundleEmitBuildInfo(program)) {
	      const fileInfos = /* @__PURE__ */ new Map();
	      program.fileInfos.forEach((fileInfo, index) => {
	        const path = toFilePath(index + 1);
	        fileInfos.set(path, isString(fileInfo) ? { version: fileInfo, signature: void 0, affectsGlobalScope: void 0, impliedFormat: void 0 } : fileInfo);
	      });
	      state = {
	        fileInfos,
	        compilerOptions: program.options ? convertToOptionsWithAbsolutePaths(program.options, toAbsolutePath) : {},
	        latestChangedDtsFile,
	        outSignature: program.outSignature,
	        programEmitPending: program.pendingEmit === void 0 ? void 0 : toProgramEmitPending(program.pendingEmit, program.options),
	        bundle: buildInfo.bundle
	      };
	    } else {
	      filePathsSetList = (_b = program.fileIdsList) == null ? void 0 : _b.map((fileIds) => new Set(fileIds.map(toFilePath)));
	      const fileInfos = /* @__PURE__ */ new Map();
	      const emitSignatures = ((_c = program.options) == null ? void 0 : _c.composite) && !outFile(program.options) ? /* @__PURE__ */ new Map() : void 0;
	      program.fileInfos.forEach((fileInfo, index) => {
	        const path = toFilePath(index + 1);
	        const stateFileInfo = toBuilderStateFileInfoForMultiEmit(fileInfo);
	        fileInfos.set(path, stateFileInfo);
	        if (emitSignatures && stateFileInfo.signature)
	          emitSignatures.set(path, stateFileInfo.signature);
	      });
	      (_d = program.emitSignatures) == null ? void 0 : _d.forEach((value) => {
	        if (isNumber(value))
	          emitSignatures.delete(toFilePath(value));
	        else {
	          const key = toFilePath(value[0]);
	          emitSignatures.set(
	            key,
	            !isString(value[1]) && !value[1].length ? (
	              // File signature is emit signature but differs in map
	              [emitSignatures.get(key)]
	            ) : value[1]
	          );
	        }
	      });
	      const fullEmitForOptions = program.affectedFilesPendingEmit ? getBuilderFileEmit(program.options || {}) : void 0;
	      state = {
	        fileInfos,
	        compilerOptions: program.options ? convertToOptionsWithAbsolutePaths(program.options, toAbsolutePath) : {},
	        referencedMap: toManyToManyPathMap(program.referencedMap),
	        exportedModulesMap: toManyToManyPathMap(program.exportedModulesMap),
	        semanticDiagnosticsPerFile: toPerFileDiagnostics(program.semanticDiagnosticsPerFile),
	        emitDiagnosticsPerFile: toPerFileDiagnostics(program.emitDiagnosticsPerFile),
	        hasReusableDiagnostic: true,
	        affectedFilesPendingEmit: program.affectedFilesPendingEmit && arrayToMap(program.affectedFilesPendingEmit, (value) => toFilePath(isNumber(value) ? value : value[0]), (value) => toBuilderFileEmit(value, fullEmitForOptions)),
	        changedFilesSet: new Set(map(program.changeFileSet, toFilePath)),
	        latestChangedDtsFile,
	        emitSignatures: (emitSignatures == null ? void 0 : emitSignatures.size) ? emitSignatures : void 0
	      };
	    }
	    return {
	      getState: () => state,
	      saveEmitState: noop,
	      restoreEmitState: noop,
	      getProgram: notImplemented,
	      getProgramOrUndefined: returnUndefined,
	      releaseProgram: noop,
	      getCompilerOptions: () => state.compilerOptions,
	      getSourceFile: notImplemented,
	      getSourceFiles: notImplemented,
	      getOptionsDiagnostics: notImplemented,
	      getGlobalDiagnostics: notImplemented,
	      getConfigFileParsingDiagnostics: notImplemented,
	      getSyntacticDiagnostics: notImplemented,
	      getDeclarationDiagnostics: notImplemented,
	      getSemanticDiagnostics: notImplemented,
	      emit: notImplemented,
	      getAllDependencies: notImplemented,
	      getCurrentDirectory: notImplemented,
	      emitNextAffectedFile: notImplemented,
	      getSemanticDiagnosticsOfNextAffectedFile: notImplemented,
	      emitBuildInfo: notImplemented,
	      close: noop,
	      hasChangedEmitSignature: returnFalse
	    };
	    function toPathInBuildInfoDirectory(path) {
	      return toPath(path, buildInfoDirectory, getCanonicalFileName);
	    }
	    function toAbsolutePath(path) {
	      return getNormalizedAbsolutePath(path, buildInfoDirectory);
	    }
	    function toFilePath(fileId) {
	      return filePaths[fileId - 1];
	    }
	    function toFilePathsSet(fileIdsListId) {
	      return filePathsSetList[fileIdsListId - 1];
	    }
	    function toManyToManyPathMap(referenceMap) {
	      if (!referenceMap) {
	        return void 0;
	      }
	      const map2 = BuilderState.createManyToManyPathMap();
	      referenceMap.forEach(([fileId, fileIdListId]) => map2.set(toFilePath(fileId), toFilePathsSet(fileIdListId)));
	      return map2;
	    }
	    function toPerFileDiagnostics(diagnostics) {
	      return diagnostics && arrayToMap(diagnostics, (value) => toFilePath(isNumber(value) ? value : value[0]), (value) => isNumber(value) ? emptyArray : value[1]);
	    }
	  }
	  function getBuildInfoFileVersionMap(program, buildInfoPath, host) {
	    const buildInfoDirectory = getDirectoryPath(getNormalizedAbsolutePath(buildInfoPath, host.getCurrentDirectory()));
	    const getCanonicalFileName = createGetCanonicalFileName(host.useCaseSensitiveFileNames());
	    const fileInfos = /* @__PURE__ */ new Map();
	    let rootIndex = 0;
	    const roots = [];
	    program.fileInfos.forEach((fileInfo, index) => {
	      const path = toPath(program.fileNames[index], buildInfoDirectory, getCanonicalFileName);
	      const version2 = isString(fileInfo) ? fileInfo : fileInfo.version;
	      fileInfos.set(path, version2);
	      if (rootIndex < program.root.length) {
	        const current = program.root[rootIndex];
	        const fileId = index + 1;
	        if (isArray(current)) {
	          if (current[0] <= fileId && fileId <= current[1]) {
	            roots.push(path);
	            if (current[1] === fileId)
	              rootIndex++;
	          }
	        } else if (current === fileId) {
	          roots.push(path);
	          rootIndex++;
	        }
	      }
	    });
	    return { fileInfos, roots };
	  }
	  function createRedirectedBuilderProgram(getState, configFileParsingDiagnostics) {
	    return {
	      getState: notImplemented,
	      saveEmitState: noop,
	      restoreEmitState: noop,
	      getProgram,
	      getProgramOrUndefined: () => getState().program,
	      releaseProgram: () => getState().program = void 0,
	      getCompilerOptions: () => getState().compilerOptions,
	      getSourceFile: (fileName) => getProgram().getSourceFile(fileName),
	      getSourceFiles: () => getProgram().getSourceFiles(),
	      getOptionsDiagnostics: (cancellationToken) => getProgram().getOptionsDiagnostics(cancellationToken),
	      getGlobalDiagnostics: (cancellationToken) => getProgram().getGlobalDiagnostics(cancellationToken),
	      getConfigFileParsingDiagnostics: () => configFileParsingDiagnostics,
	      getSyntacticDiagnostics: (sourceFile, cancellationToken) => getProgram().getSyntacticDiagnostics(sourceFile, cancellationToken),
	      getDeclarationDiagnostics: (sourceFile, cancellationToken) => getProgram().getDeclarationDiagnostics(sourceFile, cancellationToken),
	      getSemanticDiagnostics: (sourceFile, cancellationToken) => getProgram().getSemanticDiagnostics(sourceFile, cancellationToken),
	      emit: (sourceFile, writeFile2, cancellationToken, emitOnlyDts, customTransformers) => getProgram().emit(sourceFile, writeFile2, cancellationToken, emitOnlyDts, customTransformers),
	      emitBuildInfo: (writeFile2, cancellationToken) => getProgram().emitBuildInfo(writeFile2, cancellationToken),
	      getAllDependencies: notImplemented,
	      getCurrentDirectory: () => getProgram().getCurrentDirectory(),
	      close: noop
	    };
	    function getProgram() {
	      return Debug.checkDefined(getState().program);
	    }
	  }
	  var BuilderFileEmit, BuilderProgramKind;
	  var init_builder = __esm({
	    "src/compiler/builder.ts"() {
	      init_ts2();
	      BuilderFileEmit = /* @__PURE__ */ ((BuilderFileEmit2) => {
	        BuilderFileEmit2[BuilderFileEmit2["None"] = 0] = "None";
	        BuilderFileEmit2[BuilderFileEmit2["Js"] = 1] = "Js";
	        BuilderFileEmit2[BuilderFileEmit2["JsMap"] = 2] = "JsMap";
	        BuilderFileEmit2[BuilderFileEmit2["JsInlineMap"] = 4] = "JsInlineMap";
	        BuilderFileEmit2[BuilderFileEmit2["Dts"] = 8] = "Dts";
	        BuilderFileEmit2[BuilderFileEmit2["DtsMap"] = 16] = "DtsMap";
	        BuilderFileEmit2[BuilderFileEmit2["AllJs"] = 7] = "AllJs";
	        BuilderFileEmit2[BuilderFileEmit2["AllDts"] = 24] = "AllDts";
	        BuilderFileEmit2[BuilderFileEmit2["All"] = 31] = "All";
	        return BuilderFileEmit2;
	      })(BuilderFileEmit || {});
	      BuilderProgramKind = /* @__PURE__ */ ((BuilderProgramKind2) => {
	        BuilderProgramKind2[BuilderProgramKind2["SemanticDiagnosticsBuilderProgram"] = 0] = "SemanticDiagnosticsBuilderProgram";
	        BuilderProgramKind2[BuilderProgramKind2["EmitAndSemanticDiagnosticsBuilderProgram"] = 1] = "EmitAndSemanticDiagnosticsBuilderProgram";
	        return BuilderProgramKind2;
	      })(BuilderProgramKind || {});
	    }
	  });

	  // src/compiler/builderPublic.ts
	  function createSemanticDiagnosticsBuilderProgram(newProgramOrRootNames, hostOrOptions, oldProgramOrHost, configFileParsingDiagnosticsOrOldProgram, configFileParsingDiagnostics, projectReferences) {
	    return createBuilderProgram(0 /* SemanticDiagnosticsBuilderProgram */, getBuilderCreationParameters(newProgramOrRootNames, hostOrOptions, oldProgramOrHost, configFileParsingDiagnosticsOrOldProgram, configFileParsingDiagnostics, projectReferences));
	  }
	  function createEmitAndSemanticDiagnosticsBuilderProgram(newProgramOrRootNames, hostOrOptions, oldProgramOrHost, configFileParsingDiagnosticsOrOldProgram, configFileParsingDiagnostics, projectReferences) {
	    return createBuilderProgram(1 /* EmitAndSemanticDiagnosticsBuilderProgram */, getBuilderCreationParameters(newProgramOrRootNames, hostOrOptions, oldProgramOrHost, configFileParsingDiagnosticsOrOldProgram, configFileParsingDiagnostics, projectReferences));
	  }
	  function createAbstractBuilder(newProgramOrRootNames, hostOrOptions, oldProgramOrHost, configFileParsingDiagnosticsOrOldProgram, configFileParsingDiagnostics, projectReferences) {
	    const { newProgram, configFileParsingDiagnostics: newConfigFileParsingDiagnostics } = getBuilderCreationParameters(newProgramOrRootNames, hostOrOptions, oldProgramOrHost, configFileParsingDiagnosticsOrOldProgram, configFileParsingDiagnostics, projectReferences);
	    return createRedirectedBuilderProgram(() => ({ program: newProgram, compilerOptions: newProgram.getCompilerOptions() }), newConfigFileParsingDiagnostics);
	  }
	  var init_builderPublic = __esm({
	    "src/compiler/builderPublic.ts"() {
	      init_ts2();
	    }
	  });

	  // src/compiler/resolutionCache.ts
	  function removeIgnoredPath(path) {
	    if (endsWith(path, "/node_modules/.staging")) {
	      return removeSuffix(path, "/.staging");
	    }
	    return some(ignoredPaths, (searchPath) => path.includes(searchPath)) ? void 0 : path;
	  }
	  function perceivedOsRootLengthForWatching(pathComponents2, length2) {
	    if (length2 <= 1)
	      return 1;
	    let indexAfterOsRoot = 1;
	    let isDosStyle = pathComponents2[0].search(/[a-zA-Z]:/) === 0;
	    if (pathComponents2[0] !== directorySeparator && !isDosStyle && // Non dos style paths
	    pathComponents2[1].search(/[a-zA-Z]\$$/) === 0) {
	      if (length2 === 2)
	        return 2;
	      indexAfterOsRoot = 2;
	      isDosStyle = true;
	    }
	    if (isDosStyle && !pathComponents2[indexAfterOsRoot].match(/^users$/i)) {
	      return indexAfterOsRoot;
	    }
	    if (pathComponents2[indexAfterOsRoot].match(/^workspaces$/i)) {
	      return indexAfterOsRoot + 1;
	    }
	    return indexAfterOsRoot + 2;
	  }
	  function canWatchDirectoryOrFile(pathComponents2, length2) {
	    if (length2 === void 0)
	      length2 = pathComponents2.length;
	    if (length2 <= 2)
	      return false;
	    const perceivedOsRootLength = perceivedOsRootLengthForWatching(pathComponents2, length2);
	    return length2 > perceivedOsRootLength + 1;
	  }
	  function canWatchAtTypes(atTypes) {
	    return canWatchAffectedPackageJsonOrNodeModulesOfAtTypes(getDirectoryPath(atTypes));
	  }
	  function isInDirectoryPath(dirComponents, fileOrDirComponents) {
	    if (fileOrDirComponents.length < fileOrDirComponents.length)
	      return false;
	    for (let i = 0; i < dirComponents.length; i++) {
	      if (fileOrDirComponents[i] !== dirComponents[i])
	        return false;
	    }
	    return true;
	  }
	  function canWatchAffectedPackageJsonOrNodeModulesOfAtTypes(fileOrDirPath) {
	    return canWatchDirectoryOrFile(getPathComponents(fileOrDirPath));
	  }
	  function canWatchAffectingLocation(filePath) {
	    return canWatchAffectedPackageJsonOrNodeModulesOfAtTypes(filePath);
	  }
	  function getDirectoryToWatchFailedLookupLocation(failedLookupLocation, failedLookupLocationPath, rootDir, rootPath, rootPathComponents, getCurrentDirectory) {
	    const failedLookupPathComponents = getPathComponents(failedLookupLocationPath);
	    failedLookupLocation = isRootedDiskPath(failedLookupLocation) ? normalizePath(failedLookupLocation) : getNormalizedAbsolutePath(failedLookupLocation, getCurrentDirectory());
	    const failedLookupComponents = getPathComponents(failedLookupLocation);
	    const perceivedOsRootLength = perceivedOsRootLengthForWatching(failedLookupPathComponents, failedLookupPathComponents.length);
	    if (failedLookupPathComponents.length <= perceivedOsRootLength + 1)
	      return void 0;
	    const nodeModulesIndex = failedLookupPathComponents.indexOf("node_modules");
	    if (nodeModulesIndex !== -1 && nodeModulesIndex + 1 <= perceivedOsRootLength + 1)
	      return void 0;
	    if (isInDirectoryPath(rootPathComponents, failedLookupPathComponents)) {
	      if (failedLookupPathComponents.length > rootPathComponents.length + 1) {
	        return getDirectoryOfFailedLookupWatch(failedLookupComponents, failedLookupPathComponents, Math.max(rootPathComponents.length + 1, perceivedOsRootLength + 1));
	      } else {
	        return {
	          dir: rootDir,
	          dirPath: rootPath,
	          nonRecursive: true
	        };
	      }
	    }
	    return getDirectoryToWatchFromFailedLookupLocationDirectory(
	      failedLookupComponents,
	      failedLookupPathComponents,
	      failedLookupPathComponents.length - 1,
	      perceivedOsRootLength,
	      nodeModulesIndex,
	      rootPathComponents
	    );
	  }
	  function getDirectoryToWatchFromFailedLookupLocationDirectory(dirComponents, dirPathComponents, dirPathComponentsLength, perceivedOsRootLength, nodeModulesIndex, rootPathComponents) {
	    if (nodeModulesIndex !== -1) {
	      return getDirectoryOfFailedLookupWatch(dirComponents, dirPathComponents, nodeModulesIndex + 1);
	    }
	    let nonRecursive = true;
	    let length2 = dirPathComponentsLength;
	    for (let i = 0; i < dirPathComponentsLength; i++) {
	      if (dirPathComponents[i] !== rootPathComponents[i]) {
	        nonRecursive = false;
	        length2 = Math.max(i + 1, perceivedOsRootLength + 1);
	        break;
	      }
	    }
	    return getDirectoryOfFailedLookupWatch(dirComponents, dirPathComponents, length2, nonRecursive);
	  }
	  function getDirectoryOfFailedLookupWatch(dirComponents, dirPathComponents, length2, nonRecursive) {
	    return {
	      dir: getPathFromPathComponents(dirComponents, length2),
	      dirPath: getPathFromPathComponents(dirPathComponents, length2),
	      nonRecursive
	    };
	  }
	  function getDirectoryToWatchFailedLookupLocationFromTypeRoot(typeRoot, typeRootPath, rootPath, rootPathComponents, getCurrentDirectory, filterCustomPath) {
	    const typeRootPathComponents = getPathComponents(typeRootPath);
	    if (isInDirectoryPath(rootPathComponents, typeRootPathComponents)) {
	      return rootPath;
	    }
	    typeRoot = isRootedDiskPath(typeRoot) ? normalizePath(typeRoot) : getNormalizedAbsolutePath(typeRoot, getCurrentDirectory());
	    const toWatch = getDirectoryToWatchFromFailedLookupLocationDirectory(
	      getPathComponents(typeRoot),
	      typeRootPathComponents,
	      typeRootPathComponents.length,
	      perceivedOsRootLengthForWatching(typeRootPathComponents, typeRootPathComponents.length),
	      typeRootPathComponents.indexOf("node_modules"),
	      rootPathComponents
	    );
	    return toWatch && filterCustomPath(toWatch.dirPath) ? toWatch.dirPath : void 0;
	  }
	  function getRootDirectoryOfResolutionCache(rootDirForResolution, getCurrentDirectory) {
	    const normalized = getNormalizedAbsolutePath(rootDirForResolution, getCurrentDirectory());
	    return !isDiskPathRoot(normalized) ? removeTrailingDirectorySeparator(normalized) : normalized;
	  }
	  function getRootPathSplitLength(rootPath) {
	    return rootPath.split(directorySeparator).length - (hasTrailingDirectorySeparator(rootPath) ? 1 : 0);
	  }
	  function getModuleResolutionHost(resolutionHost) {
	    var _a;
	    return ((_a = resolutionHost.getCompilerHost) == null ? void 0 : _a.call(resolutionHost)) || resolutionHost;
	  }
	  function createModuleResolutionLoaderUsingGlobalCache(containingFile, redirectedReference, options, resolutionHost, moduleResolutionCache) {
	    return {
	      nameAndMode: moduleResolutionNameAndModeGetter,
	      resolve: (moduleName, resoluionMode) => resolveModuleNameUsingGlobalCache(
	        resolutionHost,
	        moduleResolutionCache,
	        moduleName,
	        containingFile,
	        options,
	        redirectedReference,
	        resoluionMode
	      )
	    };
	  }
	  function resolveModuleNameUsingGlobalCache(resolutionHost, moduleResolutionCache, moduleName, containingFile, compilerOptions, redirectedReference, mode) {
	    const host = getModuleResolutionHost(resolutionHost);
	    const primaryResult = resolveModuleName(moduleName, containingFile, compilerOptions, host, moduleResolutionCache, redirectedReference, mode);
	    if (!resolutionHost.getGlobalCache) {
	      return primaryResult;
	    }
	    const globalCache = resolutionHost.getGlobalCache();
	    if (globalCache !== void 0 && !isExternalModuleNameRelative(moduleName) && !(primaryResult.resolvedModule && extensionIsTS(primaryResult.resolvedModule.extension))) {
	      const { resolvedModule, failedLookupLocations, affectingLocations, resolutionDiagnostics } = loadModuleFromGlobalCache(
	        Debug.checkDefined(resolutionHost.globalCacheResolutionModuleName)(moduleName),
	        resolutionHost.projectName,
	        compilerOptions,
	        host,
	        globalCache,
	        moduleResolutionCache
	      );
	      if (resolvedModule) {
	        primaryResult.resolvedModule = resolvedModule;
	        primaryResult.failedLookupLocations = updateResolutionField(primaryResult.failedLookupLocations, failedLookupLocations);
	        primaryResult.affectingLocations = updateResolutionField(primaryResult.affectingLocations, affectingLocations);
	        primaryResult.resolutionDiagnostics = updateResolutionField(primaryResult.resolutionDiagnostics, resolutionDiagnostics);
	        return primaryResult;
	      }
	    }
	    return primaryResult;
	  }
	  function createResolutionCache(resolutionHost, rootDirForResolution, logChangesWhenResolvingModule) {
	    let filesWithChangedSetOfUnresolvedImports;
	    let filesWithInvalidatedResolutions;
	    let filesWithInvalidatedNonRelativeUnresolvedImports;
	    const nonRelativeExternalModuleResolutions = createMultiMap();
	    const resolutionsWithFailedLookups = /* @__PURE__ */ new Set();
	    const resolutionsWithOnlyAffectingLocations = /* @__PURE__ */ new Set();
	    const resolvedFileToResolution = /* @__PURE__ */ new Map();
	    const impliedFormatPackageJsons = /* @__PURE__ */ new Map();
	    let hasChangedAutomaticTypeDirectiveNames = false;
	    let affectingPathChecksForFile;
	    let affectingPathChecks;
	    let failedLookupChecks;
	    let startsWithPathChecks;
	    let isInDirectoryChecks;
	    let allModuleAndTypeResolutionsAreInvalidated = false;
	    const getCurrentDirectory = memoize(() => resolutionHost.getCurrentDirectory());
	    const cachedDirectoryStructureHost = resolutionHost.getCachedDirectoryStructureHost();
	    const resolvedModuleNames = /* @__PURE__ */ new Map();
	    const moduleResolutionCache = createModuleResolutionCache(
	      getCurrentDirectory(),
	      resolutionHost.getCanonicalFileName,
	      resolutionHost.getCompilationSettings()
	    );
	    const resolvedTypeReferenceDirectives = /* @__PURE__ */ new Map();
	    const typeReferenceDirectiveResolutionCache = createTypeReferenceDirectiveResolutionCache(
	      getCurrentDirectory(),
	      resolutionHost.getCanonicalFileName,
	      resolutionHost.getCompilationSettings(),
	      moduleResolutionCache.getPackageJsonInfoCache(),
	      moduleResolutionCache.optionsToRedirectsKey
	    );
	    const resolvedLibraries = /* @__PURE__ */ new Map();
	    const libraryResolutionCache = createModuleResolutionCache(
	      getCurrentDirectory(),
	      resolutionHost.getCanonicalFileName,
	      getOptionsForLibraryResolution(resolutionHost.getCompilationSettings()),
	      moduleResolutionCache.getPackageJsonInfoCache()
	    );
	    const directoryWatchesOfFailedLookups = /* @__PURE__ */ new Map();
	    const fileWatchesOfAffectingLocations = /* @__PURE__ */ new Map();
	    const rootDir = getRootDirectoryOfResolutionCache(rootDirForResolution, getCurrentDirectory);
	    const rootPath = resolutionHost.toPath(rootDir);
	    const rootPathComponents = getPathComponents(rootPath);
	    const typeRootsWatches = /* @__PURE__ */ new Map();
	    return {
	      rootDirForResolution,
	      resolvedModuleNames,
	      resolvedTypeReferenceDirectives,
	      resolvedLibraries,
	      resolvedFileToResolution,
	      resolutionsWithFailedLookups,
	      resolutionsWithOnlyAffectingLocations,
	      directoryWatchesOfFailedLookups,
	      fileWatchesOfAffectingLocations,
	      watchFailedLookupLocationsOfExternalModuleResolutions,
	      getModuleResolutionCache: () => moduleResolutionCache,
	      startRecordingFilesWithChangedResolutions,
	      finishRecordingFilesWithChangedResolutions,
	      // perDirectoryResolvedModuleNames and perDirectoryResolvedTypeReferenceDirectives could be non empty if there was exception during program update
	      // (between startCachingPerDirectoryResolution and finishCachingPerDirectoryResolution)
	      startCachingPerDirectoryResolution,
	      finishCachingPerDirectoryResolution,
	      resolveModuleNameLiterals,
	      resolveTypeReferenceDirectiveReferences,
	      resolveLibrary: resolveLibrary2,
	      resolveSingleModuleNameWithoutWatching,
	      removeResolutionsFromProjectReferenceRedirects,
	      removeResolutionsOfFile,
	      hasChangedAutomaticTypeDirectiveNames: () => hasChangedAutomaticTypeDirectiveNames,
	      invalidateResolutionOfFile,
	      invalidateResolutionsOfFailedLookupLocations,
	      setFilesWithInvalidatedNonRelativeUnresolvedImports,
	      createHasInvalidatedResolutions,
	      isFileWithInvalidatedNonRelativeUnresolvedImports,
	      updateTypeRootsWatch,
	      closeTypeRootsWatch,
	      clear: clear2,
	      onChangesAffectModuleResolution
	    };
	    function getResolvedModule(resolution) {
	      return resolution.resolvedModule;
	    }
	    function getResolvedTypeReferenceDirective(resolution) {
	      return resolution.resolvedTypeReferenceDirective;
	    }
	    function clear2() {
	      clearMap(directoryWatchesOfFailedLookups, closeFileWatcherOf);
	      clearMap(fileWatchesOfAffectingLocations, closeFileWatcherOf);
	      nonRelativeExternalModuleResolutions.clear();
	      closeTypeRootsWatch();
	      resolvedModuleNames.clear();
	      resolvedTypeReferenceDirectives.clear();
	      resolvedFileToResolution.clear();
	      resolutionsWithFailedLookups.clear();
	      resolutionsWithOnlyAffectingLocations.clear();
	      failedLookupChecks = void 0;
	      startsWithPathChecks = void 0;
	      isInDirectoryChecks = void 0;
	      affectingPathChecks = void 0;
	      affectingPathChecksForFile = void 0;
	      allModuleAndTypeResolutionsAreInvalidated = false;
	      moduleResolutionCache.clear();
	      typeReferenceDirectiveResolutionCache.clear();
	      moduleResolutionCache.update(resolutionHost.getCompilationSettings());
	      typeReferenceDirectiveResolutionCache.update(resolutionHost.getCompilationSettings());
	      libraryResolutionCache.clear();
	      impliedFormatPackageJsons.clear();
	      resolvedLibraries.clear();
	      hasChangedAutomaticTypeDirectiveNames = false;
	    }
	    function onChangesAffectModuleResolution() {
	      allModuleAndTypeResolutionsAreInvalidated = true;
	      moduleResolutionCache.clearAllExceptPackageJsonInfoCache();
	      typeReferenceDirectiveResolutionCache.clearAllExceptPackageJsonInfoCache();
	      moduleResolutionCache.update(resolutionHost.getCompilationSettings());
	      typeReferenceDirectiveResolutionCache.update(resolutionHost.getCompilationSettings());
	    }
	    function startRecordingFilesWithChangedResolutions() {
	      filesWithChangedSetOfUnresolvedImports = [];
	    }
	    function finishRecordingFilesWithChangedResolutions() {
	      const collected = filesWithChangedSetOfUnresolvedImports;
	      filesWithChangedSetOfUnresolvedImports = void 0;
	      return collected;
	    }
	    function isFileWithInvalidatedNonRelativeUnresolvedImports(path) {
	      if (!filesWithInvalidatedNonRelativeUnresolvedImports) {
	        return false;
	      }
	      const value = filesWithInvalidatedNonRelativeUnresolvedImports.get(path);
	      return !!value && !!value.length;
	    }
	    function createHasInvalidatedResolutions(customHasInvalidatedResolutions, customHasInvalidatedLibResolutions) {
	      invalidateResolutionsOfFailedLookupLocations();
	      const collected = filesWithInvalidatedResolutions;
	      filesWithInvalidatedResolutions = void 0;
	      return {
	        hasInvalidatedResolutions: (path) => customHasInvalidatedResolutions(path) || allModuleAndTypeResolutionsAreInvalidated || !!(collected == null ? void 0 : collected.has(path)) || isFileWithInvalidatedNonRelativeUnresolvedImports(path),
	        hasInvalidatedLibResolutions: (libFileName) => {
	          var _a;
	          return customHasInvalidatedLibResolutions(libFileName) || !!((_a = resolvedLibraries == null ? void 0 : resolvedLibraries.get(libFileName)) == null ? void 0 : _a.isInvalidated);
	        }
	      };
	    }
	    function startCachingPerDirectoryResolution() {
	      moduleResolutionCache.isReadonly = void 0;
	      typeReferenceDirectiveResolutionCache.isReadonly = void 0;
	      libraryResolutionCache.isReadonly = void 0;
	      moduleResolutionCache.getPackageJsonInfoCache().isReadonly = void 0;
	      moduleResolutionCache.clearAllExceptPackageJsonInfoCache();
	      typeReferenceDirectiveResolutionCache.clearAllExceptPackageJsonInfoCache();
	      libraryResolutionCache.clearAllExceptPackageJsonInfoCache();
	      nonRelativeExternalModuleResolutions.forEach(watchFailedLookupLocationOfNonRelativeModuleResolutions);
	      nonRelativeExternalModuleResolutions.clear();
	    }
	    function cleanupLibResolutionWatching(newProgram) {
	      resolvedLibraries.forEach((resolution, libFileName) => {
	        var _a;
	        if (!((_a = newProgram == null ? void 0 : newProgram.resolvedLibReferences) == null ? void 0 : _a.has(libFileName))) {
	          stopWatchFailedLookupLocationOfResolution(
	            resolution,
	            resolutionHost.toPath(getInferredLibraryNameResolveFrom(resolutionHost.getCompilationSettings(), getCurrentDirectory(), libFileName)),
	            getResolvedModule
	          );
	          resolvedLibraries.delete(libFileName);
	        }
	      });
	    }
	    function finishCachingPerDirectoryResolution(newProgram, oldProgram) {
	      filesWithInvalidatedNonRelativeUnresolvedImports = void 0;
	      allModuleAndTypeResolutionsAreInvalidated = false;
	      nonRelativeExternalModuleResolutions.forEach(watchFailedLookupLocationOfNonRelativeModuleResolutions);
	      nonRelativeExternalModuleResolutions.clear();
	      if (newProgram !== oldProgram) {
	        cleanupLibResolutionWatching(newProgram);
	        newProgram == null ? void 0 : newProgram.getSourceFiles().forEach((newFile) => {
	          var _a;
	          const expected = isExternalOrCommonJsModule(newFile) ? ((_a = newFile.packageJsonLocations) == null ? void 0 : _a.length) ?? 0 : 0;
	          const existing = impliedFormatPackageJsons.get(newFile.path) ?? emptyArray;
	          for (let i = existing.length; i < expected; i++) {
	            createFileWatcherOfAffectingLocation(
	              newFile.packageJsonLocations[i],
	              /*forResolution*/
	              false
	            );
	          }
	          if (existing.length > expected) {
	            for (let i = expected; i < existing.length; i++) {
	              fileWatchesOfAffectingLocations.get(existing[i]).files--;
	            }
	          }
	          if (expected)
	            impliedFormatPackageJsons.set(newFile.path, newFile.packageJsonLocations);
	          else
	            impliedFormatPackageJsons.delete(newFile.path);
	        });
	        impliedFormatPackageJsons.forEach((existing, path) => {
	          if (!(newProgram == null ? void 0 : newProgram.getSourceFileByPath(path))) {
	            existing.forEach((location) => fileWatchesOfAffectingLocations.get(location).files--);
	            impliedFormatPackageJsons.delete(path);
	          }
	        });
	      }
	      directoryWatchesOfFailedLookups.forEach(closeDirectoryWatchesOfFailedLookup);
	      fileWatchesOfAffectingLocations.forEach(closeFileWatcherOfAffectingLocation);
	      hasChangedAutomaticTypeDirectiveNames = false;
	      moduleResolutionCache.isReadonly = true;
	      typeReferenceDirectiveResolutionCache.isReadonly = true;
	      libraryResolutionCache.isReadonly = true;
	      moduleResolutionCache.getPackageJsonInfoCache().isReadonly = true;
	    }
	    function closeDirectoryWatchesOfFailedLookup(watcher, path) {
	      if (watcher.refCount === 0) {
	        directoryWatchesOfFailedLookups.delete(path);
	        watcher.watcher.close();
	      }
	    }
	    function closeFileWatcherOfAffectingLocation(watcher, path) {
	      var _a;
	      if (watcher.files === 0 && watcher.resolutions === 0 && !((_a = watcher.symlinks) == null ? void 0 : _a.size)) {
	        fileWatchesOfAffectingLocations.delete(path);
	        watcher.watcher.close();
	      }
	    }
	    function resolveNamesWithLocalCache({
	      entries,
	      containingFile,
	      containingSourceFile,
	      redirectedReference,
	      options,
	      perFileCache,
	      reusedNames,
	      loader,
	      getResolutionWithResolvedFileName,
	      deferWatchingNonRelativeResolution,
	      shouldRetryResolution,
	      logChanges
	    }) {
	      const path = resolutionHost.toPath(containingFile);
	      const resolutionsInFile = perFileCache.get(path) || perFileCache.set(path, createModeAwareCache()).get(path);
	      const resolvedModules = [];
	      const hasInvalidatedNonRelativeUnresolvedImport = logChanges && isFileWithInvalidatedNonRelativeUnresolvedImports(path);
	      const program = resolutionHost.getCurrentProgram();
	      const oldRedirect = program && program.getResolvedProjectReferenceToRedirect(containingFile);
	      const unmatchedRedirects = oldRedirect ? !redirectedReference || redirectedReference.sourceFile.path !== oldRedirect.sourceFile.path : !!redirectedReference;
	      const seenNamesInFile = createModeAwareCache();
	      for (const entry of entries) {
	        const name = loader.nameAndMode.getName(entry);
	        const mode = loader.nameAndMode.getMode(entry, containingSourceFile, (redirectedReference == null ? void 0 : redirectedReference.commandLine.options) || options);
	        let resolution = resolutionsInFile.get(name, mode);
	        if (!seenNamesInFile.has(name, mode) && (allModuleAndTypeResolutionsAreInvalidated || unmatchedRedirects || !resolution || resolution.isInvalidated || // If the name is unresolved import that was invalidated, recalculate
	        hasInvalidatedNonRelativeUnresolvedImport && !isExternalModuleNameRelative(name) && shouldRetryResolution(resolution))) {
	          const existingResolution = resolution;
	          resolution = loader.resolve(name, mode);
	          if (resolutionHost.onDiscoveredSymlink && resolutionIsSymlink(resolution)) {
	            resolutionHost.onDiscoveredSymlink();
	          }
	          resolutionsInFile.set(name, mode, resolution);
	          if (resolution !== existingResolution) {
	            watchFailedLookupLocationsOfExternalModuleResolutions(name, resolution, path, getResolutionWithResolvedFileName, deferWatchingNonRelativeResolution);
	            if (existingResolution) {
	              stopWatchFailedLookupLocationOfResolution(existingResolution, path, getResolutionWithResolvedFileName);
	            }
	          }
	          if (logChanges && filesWithChangedSetOfUnresolvedImports && !resolutionIsEqualTo(existingResolution, resolution)) {
	            filesWithChangedSetOfUnresolvedImports.push(path);
	            logChanges = false;
	          }
	        } else {
	          const host = getModuleResolutionHost(resolutionHost);
	          if (isTraceEnabled(options, host) && !seenNamesInFile.has(name, mode)) {
	            const resolved = getResolutionWithResolvedFileName(resolution);
	            trace(
	              host,
	              perFileCache === resolvedModuleNames ? (resolved == null ? void 0 : resolved.resolvedFileName) ? resolved.packageId ? Diagnostics.Reusing_resolution_of_module_0_from_1_of_old_program_it_was_successfully_resolved_to_2_with_Package_ID_3 : Diagnostics.Reusing_resolution_of_module_0_from_1_of_old_program_it_was_successfully_resolved_to_2 : Diagnostics.Reusing_resolution_of_module_0_from_1_of_old_program_it_was_not_resolved : (resolved == null ? void 0 : resolved.resolvedFileName) ? resolved.packageId ? Diagnostics.Reusing_resolution_of_type_reference_directive_0_from_1_of_old_program_it_was_successfully_resolved_to_2_with_Package_ID_3 : Diagnostics.Reusing_resolution_of_type_reference_directive_0_from_1_of_old_program_it_was_successfully_resolved_to_2 : Diagnostics.Reusing_resolution_of_type_reference_directive_0_from_1_of_old_program_it_was_not_resolved,
	              name,
	              containingFile,
	              resolved == null ? void 0 : resolved.resolvedFileName,
	              (resolved == null ? void 0 : resolved.packageId) && packageIdToString(resolved.packageId)
	            );
	          }
	        }
	        Debug.assert(resolution !== void 0 && !resolution.isInvalidated);
	        seenNamesInFile.set(name, mode, true);
	        resolvedModules.push(resolution);
	      }
	      reusedNames == null ? void 0 : reusedNames.forEach(
	        (entry) => seenNamesInFile.set(
	          loader.nameAndMode.getName(entry),
	          loader.nameAndMode.getMode(entry, containingSourceFile, (redirectedReference == null ? void 0 : redirectedReference.commandLine.options) || options),
	          true
	        )
	      );
	      if (resolutionsInFile.size() !== seenNamesInFile.size()) {
	        resolutionsInFile.forEach((resolution, name, mode) => {
	          if (!seenNamesInFile.has(name, mode)) {
	            stopWatchFailedLookupLocationOfResolution(resolution, path, getResolutionWithResolvedFileName);
	            resolutionsInFile.delete(name, mode);
	          }
	        });
	      }
	      return resolvedModules;
	      function resolutionIsEqualTo(oldResolution, newResolution) {
	        if (oldResolution === newResolution) {
	          return true;
	        }
	        if (!oldResolution || !newResolution) {
	          return false;
	        }
	        const oldResult = getResolutionWithResolvedFileName(oldResolution);
	        const newResult = getResolutionWithResolvedFileName(newResolution);
	        if (oldResult === newResult) {
	          return true;
	        }
	        if (!oldResult || !newResult) {
	          return false;
	        }
	        return oldResult.resolvedFileName === newResult.resolvedFileName;
	      }
	    }
	    function resolveTypeReferenceDirectiveReferences(typeDirectiveReferences, containingFile, redirectedReference, options, containingSourceFile, reusedNames) {
	      return resolveNamesWithLocalCache({
	        entries: typeDirectiveReferences,
	        containingFile,
	        containingSourceFile,
	        redirectedReference,
	        options,
	        reusedNames,
	        perFileCache: resolvedTypeReferenceDirectives,
	        loader: createTypeReferenceResolutionLoader(
	          containingFile,
	          redirectedReference,
	          options,
	          getModuleResolutionHost(resolutionHost),
	          typeReferenceDirectiveResolutionCache
	        ),
	        getResolutionWithResolvedFileName: getResolvedTypeReferenceDirective,
	        shouldRetryResolution: (resolution) => resolution.resolvedTypeReferenceDirective === void 0,
	        deferWatchingNonRelativeResolution: false
	      });
	    }
	    function resolveModuleNameLiterals(moduleLiterals, containingFile, redirectedReference, options, containingSourceFile, reusedNames) {
	      return resolveNamesWithLocalCache({
	        entries: moduleLiterals,
	        containingFile,
	        containingSourceFile,
	        redirectedReference,
	        options,
	        reusedNames,
	        perFileCache: resolvedModuleNames,
	        loader: createModuleResolutionLoaderUsingGlobalCache(
	          containingFile,
	          redirectedReference,
	          options,
	          resolutionHost,
	          moduleResolutionCache
	        ),
	        getResolutionWithResolvedFileName: getResolvedModule,
	        shouldRetryResolution: (resolution) => !resolution.resolvedModule || !resolutionExtensionIsTSOrJson(resolution.resolvedModule.extension),
	        logChanges: logChangesWhenResolvingModule,
	        deferWatchingNonRelativeResolution: true
	        // Defer non relative resolution watch because we could be using ambient modules
	      });
	    }
	    function resolveLibrary2(libraryName, resolveFrom, options, libFileName) {
	      const host = getModuleResolutionHost(resolutionHost);
	      let resolution = resolvedLibraries == null ? void 0 : resolvedLibraries.get(libFileName);
	      if (!resolution || resolution.isInvalidated) {
	        const existingResolution = resolution;
	        resolution = resolveLibrary(libraryName, resolveFrom, options, host, libraryResolutionCache);
	        const path = resolutionHost.toPath(resolveFrom);
	        watchFailedLookupLocationsOfExternalModuleResolutions(
	          libraryName,
	          resolution,
	          path,
	          getResolvedModule,
	          /*deferWatchingNonRelativeResolution*/
	          false
	        );
	        resolvedLibraries.set(libFileName, resolution);
	        if (existingResolution) {
	          stopWatchFailedLookupLocationOfResolution(existingResolution, path, getResolvedModule);
	        }
	      } else {
	        if (isTraceEnabled(options, host)) {
	          const resolved = getResolvedModule(resolution);
	          trace(
	            host,
	            (resolved == null ? void 0 : resolved.resolvedFileName) ? resolved.packageId ? Diagnostics.Reusing_resolution_of_module_0_from_1_of_old_program_it_was_successfully_resolved_to_2_with_Package_ID_3 : Diagnostics.Reusing_resolution_of_module_0_from_1_of_old_program_it_was_successfully_resolved_to_2 : Diagnostics.Reusing_resolution_of_module_0_from_1_of_old_program_it_was_not_resolved,
	            libraryName,
	            resolveFrom,
	            resolved == null ? void 0 : resolved.resolvedFileName,
	            (resolved == null ? void 0 : resolved.packageId) && packageIdToString(resolved.packageId)
	          );
	        }
	      }
	      return resolution;
	    }
	    function resolveSingleModuleNameWithoutWatching(moduleName, containingFile) {
	      var _a, _b;
	      const path = resolutionHost.toPath(containingFile);
	      const resolutionsInFile = resolvedModuleNames.get(path);
	      const resolution = resolutionsInFile == null ? void 0 : resolutionsInFile.get(
	        moduleName,
	        /*mode*/
	        void 0
	      );
	      if (resolution && !resolution.isInvalidated)
	        return resolution;
	      const data = (_a = resolutionHost.beforeResolveSingleModuleNameWithoutWatching) == null ? void 0 : _a.call(resolutionHost, moduleResolutionCache);
	      const host = getModuleResolutionHost(resolutionHost);
	      const result = resolveModuleName(
	        moduleName,
	        containingFile,
	        resolutionHost.getCompilationSettings(),
	        host,
	        moduleResolutionCache
	      );
	      (_b = resolutionHost.afterResolveSingleModuleNameWithoutWatching) == null ? void 0 : _b.call(resolutionHost, moduleResolutionCache, moduleName, containingFile, result, data);
	      return result;
	    }
	    function isNodeModulesAtTypesDirectory(dirPath) {
	      return endsWith(dirPath, "/node_modules/@types");
	    }
	    function watchFailedLookupLocationsOfExternalModuleResolutions(name, resolution, filePath, getResolutionWithResolvedFileName, deferWatchingNonRelativeResolution) {
	      var _a;
	      if (resolution.refCount) {
	        resolution.refCount++;
	        Debug.assertIsDefined(resolution.files);
	      } else {
	        resolution.refCount = 1;
	        Debug.assert(!((_a = resolution.files) == null ? void 0 : _a.size));
	        if (!deferWatchingNonRelativeResolution || isExternalModuleNameRelative(name)) {
	          watchFailedLookupLocationOfResolution(resolution);
	        } else {
	          nonRelativeExternalModuleResolutions.add(name, resolution);
	        }
	        const resolved = getResolutionWithResolvedFileName(resolution);
	        if (resolved && resolved.resolvedFileName) {
	          const key = resolutionHost.toPath(resolved.resolvedFileName);
	          let resolutions = resolvedFileToResolution.get(key);
	          if (!resolutions)
	            resolvedFileToResolution.set(key, resolutions = /* @__PURE__ */ new Set());
	          resolutions.add(resolution);
	        }
	      }
	      (resolution.files ?? (resolution.files = /* @__PURE__ */ new Set())).add(filePath);
	    }
	    function watchFailedLookupLocation(failedLookupLocation, setAtRoot) {
	      const failedLookupLocationPath = resolutionHost.toPath(failedLookupLocation);
	      const toWatch = getDirectoryToWatchFailedLookupLocation(
	        failedLookupLocation,
	        failedLookupLocationPath,
	        rootDir,
	        rootPath,
	        rootPathComponents,
	        getCurrentDirectory
	      );
	      if (toWatch) {
	        const { dir, dirPath, nonRecursive } = toWatch;
	        if (dirPath === rootPath) {
	          Debug.assert(nonRecursive);
	          setAtRoot = true;
	        } else {
	          setDirectoryWatcher(dir, dirPath, nonRecursive);
	        }
	      }
	      return setAtRoot;
	    }
	    function watchFailedLookupLocationOfResolution(resolution) {
	      Debug.assert(!!resolution.refCount);
	      const { failedLookupLocations, affectingLocations, alternateResult } = resolution;
	      if (!(failedLookupLocations == null ? void 0 : failedLookupLocations.length) && !(affectingLocations == null ? void 0 : affectingLocations.length) && !alternateResult)
	        return;
	      if ((failedLookupLocations == null ? void 0 : failedLookupLocations.length) || alternateResult)
	        resolutionsWithFailedLookups.add(resolution);
	      let setAtRoot = false;
	      if (failedLookupLocations) {
	        for (const failedLookupLocation of failedLookupLocations) {
	          setAtRoot = watchFailedLookupLocation(failedLookupLocation, setAtRoot);
	        }
	      }
	      if (alternateResult)
	        setAtRoot = watchFailedLookupLocation(alternateResult, setAtRoot);
	      if (setAtRoot) {
	        setDirectoryWatcher(
	          rootDir,
	          rootPath,
	          /*nonRecursive*/
	          true
	        );
	      }
	      watchAffectingLocationsOfResolution(resolution, !(failedLookupLocations == null ? void 0 : failedLookupLocations.length) && !alternateResult);
	    }
	    function watchAffectingLocationsOfResolution(resolution, addToResolutionsWithOnlyAffectingLocations) {
	      Debug.assert(!!resolution.refCount);
	      const { affectingLocations } = resolution;
	      if (!(affectingLocations == null ? void 0 : affectingLocations.length))
	        return;
	      if (addToResolutionsWithOnlyAffectingLocations)
	        resolutionsWithOnlyAffectingLocations.add(resolution);
	      for (const affectingLocation of affectingLocations) {
	        createFileWatcherOfAffectingLocation(
	          affectingLocation,
	          /*forResolution*/
	          true
	        );
	      }
	    }
	    function createFileWatcherOfAffectingLocation(affectingLocation, forResolution) {
	      const fileWatcher = fileWatchesOfAffectingLocations.get(affectingLocation);
	      if (fileWatcher) {
	        if (forResolution)
	          fileWatcher.resolutions++;
	        else
	          fileWatcher.files++;
	        return;
	      }
	      let locationToWatch = affectingLocation;
	      let isSymlink = false;
	      let symlinkWatcher;
	      if (resolutionHost.realpath) {
	        locationToWatch = resolutionHost.realpath(affectingLocation);
	        if (affectingLocation !== locationToWatch) {
	          isSymlink = true;
	          symlinkWatcher = fileWatchesOfAffectingLocations.get(locationToWatch);
	        }
	      }
	      const resolutions = forResolution ? 1 : 0;
	      const files = forResolution ? 0 : 1;
	      if (!isSymlink || !symlinkWatcher) {
	        const watcher = {
	          watcher: canWatchAffectingLocation(resolutionHost.toPath(locationToWatch)) ? resolutionHost.watchAffectingFileLocation(locationToWatch, (fileName, eventKind) => {
	            cachedDirectoryStructureHost == null ? void 0 : cachedDirectoryStructureHost.addOrDeleteFile(fileName, resolutionHost.toPath(locationToWatch), eventKind);
	            invalidateAffectingFileWatcher(locationToWatch, moduleResolutionCache.getPackageJsonInfoCache().getInternalMap());
	            resolutionHost.scheduleInvalidateResolutionsOfFailedLookupLocations();
	          }) : noopFileWatcher,
	          resolutions: isSymlink ? 0 : resolutions,
	          files: isSymlink ? 0 : files,
	          symlinks: void 0
	        };
	        fileWatchesOfAffectingLocations.set(locationToWatch, watcher);
	        if (isSymlink)
	          symlinkWatcher = watcher;
	      }
	      if (isSymlink) {
	        Debug.assert(!!symlinkWatcher);
	        const watcher = {
	          watcher: {
	            close: () => {
	              var _a;
	              const symlinkWatcher2 = fileWatchesOfAffectingLocations.get(locationToWatch);
	              if (((_a = symlinkWatcher2 == null ? void 0 : symlinkWatcher2.symlinks) == null ? void 0 : _a.delete(affectingLocation)) && !symlinkWatcher2.symlinks.size && !symlinkWatcher2.resolutions && !symlinkWatcher2.files) {
	                fileWatchesOfAffectingLocations.delete(locationToWatch);
	                symlinkWatcher2.watcher.close();
	              }
	            }
	          },
	          resolutions,
	          files,
	          symlinks: void 0
	        };
	        fileWatchesOfAffectingLocations.set(affectingLocation, watcher);
	        (symlinkWatcher.symlinks ?? (symlinkWatcher.symlinks = /* @__PURE__ */ new Set())).add(affectingLocation);
	      }
	    }
	    function invalidateAffectingFileWatcher(path, packageJsonMap) {
	      var _a;
	      const watcher = fileWatchesOfAffectingLocations.get(path);
	      if (watcher == null ? void 0 : watcher.resolutions)
	        (affectingPathChecks ?? (affectingPathChecks = /* @__PURE__ */ new Set())).add(path);
	      if (watcher == null ? void 0 : watcher.files)
	        (affectingPathChecksForFile ?? (affectingPathChecksForFile = /* @__PURE__ */ new Set())).add(path);
	      (_a = watcher == null ? void 0 : watcher.symlinks) == null ? void 0 : _a.forEach((path2) => invalidateAffectingFileWatcher(path2, packageJsonMap));
	      packageJsonMap == null ? void 0 : packageJsonMap.delete(resolutionHost.toPath(path));
	    }
	    function watchFailedLookupLocationOfNonRelativeModuleResolutions(resolutions, name) {
	      const program = resolutionHost.getCurrentProgram();
	      if (!program || !program.getTypeChecker().tryFindAmbientModuleWithoutAugmentations(name)) {
	        resolutions.forEach(watchFailedLookupLocationOfResolution);
	      } else {
	        resolutions.forEach((resolution) => watchAffectingLocationsOfResolution(
	          resolution,
	          /*addToResolutionsWithOnlyAffectingLocations*/
	          true
	        ));
	      }
	    }
	    function setDirectoryWatcher(dir, dirPath, nonRecursive) {
	      const dirWatcher = directoryWatchesOfFailedLookups.get(dirPath);
	      if (dirWatcher) {
	        Debug.assert(!!nonRecursive === !!dirWatcher.nonRecursive);
	        dirWatcher.refCount++;
	      } else {
	        directoryWatchesOfFailedLookups.set(dirPath, { watcher: createDirectoryWatcher(dir, dirPath, nonRecursive), refCount: 1, nonRecursive });
	      }
	    }
	    function stopWatchFailedLookupLocation(failedLookupLocation, removeAtRoot, syncDirWatcherRemove) {
	      const failedLookupLocationPath = resolutionHost.toPath(failedLookupLocation);
	      const toWatch = getDirectoryToWatchFailedLookupLocation(
	        failedLookupLocation,
	        failedLookupLocationPath,
	        rootDir,
	        rootPath,
	        rootPathComponents,
	        getCurrentDirectory
	      );
	      if (toWatch) {
	        const { dirPath } = toWatch;
	        if (dirPath === rootPath) {
	          removeAtRoot = true;
	        } else {
	          removeDirectoryWatcher(dirPath, syncDirWatcherRemove);
	        }
	      }
	      return removeAtRoot;
	    }
	    function stopWatchFailedLookupLocationOfResolution(resolution, filePath, getResolutionWithResolvedFileName, syncDirWatcherRemove) {
	      Debug.checkDefined(resolution.files).delete(filePath);
	      resolution.refCount--;
	      if (resolution.refCount) {
	        return;
	      }
	      const resolved = getResolutionWithResolvedFileName(resolution);
	      if (resolved && resolved.resolvedFileName) {
	        const key = resolutionHost.toPath(resolved.resolvedFileName);
	        const resolutions = resolvedFileToResolution.get(key);
	        if ((resolutions == null ? void 0 : resolutions.delete(resolution)) && !resolutions.size)
	          resolvedFileToResolution.delete(key);
	      }
	      const { failedLookupLocations, affectingLocations, alternateResult } = resolution;
	      if (resolutionsWithFailedLookups.delete(resolution)) {
	        let removeAtRoot = false;
	        if (failedLookupLocations) {
	          for (const failedLookupLocation of failedLookupLocations) {
	            removeAtRoot = stopWatchFailedLookupLocation(failedLookupLocation, removeAtRoot, syncDirWatcherRemove);
	          }
	        }
	        if (alternateResult)
	          removeAtRoot = stopWatchFailedLookupLocation(alternateResult, removeAtRoot, syncDirWatcherRemove);
	        if (removeAtRoot)
	          removeDirectoryWatcher(rootPath, syncDirWatcherRemove);
	      } else if (affectingLocations == null ? void 0 : affectingLocations.length) {
	        resolutionsWithOnlyAffectingLocations.delete(resolution);
	      }
	      if (affectingLocations) {
	        for (const affectingLocation of affectingLocations) {
	          const watcher = fileWatchesOfAffectingLocations.get(affectingLocation);
	          watcher.resolutions--;
	          if (syncDirWatcherRemove)
	            closeFileWatcherOfAffectingLocation(watcher, affectingLocation);
	        }
	      }
	    }
	    function removeDirectoryWatcher(dirPath, syncDirWatcherRemove) {
	      const dirWatcher = directoryWatchesOfFailedLookups.get(dirPath);
	      dirWatcher.refCount--;
	      if (syncDirWatcherRemove)
	        closeDirectoryWatchesOfFailedLookup(dirWatcher, dirPath);
	    }
	    function createDirectoryWatcher(directory, dirPath, nonRecursive) {
	      return resolutionHost.watchDirectoryOfFailedLookupLocation(directory, (fileOrDirectory) => {
	        const fileOrDirectoryPath = resolutionHost.toPath(fileOrDirectory);
	        if (cachedDirectoryStructureHost) {
	          cachedDirectoryStructureHost.addOrDeleteFileOrDirectory(fileOrDirectory, fileOrDirectoryPath);
	        }
	        scheduleInvalidateResolutionOfFailedLookupLocation(fileOrDirectoryPath, dirPath === fileOrDirectoryPath);
	      }, nonRecursive ? 0 /* None */ : 1 /* Recursive */);
	    }
	    function removeResolutionsOfFileFromCache(cache, filePath, getResolutionWithResolvedFileName, syncDirWatcherRemove) {
	      const resolutions = cache.get(filePath);
	      if (resolutions) {
	        resolutions.forEach(
	          (resolution) => stopWatchFailedLookupLocationOfResolution(
	            resolution,
	            filePath,
	            getResolutionWithResolvedFileName,
	            syncDirWatcherRemove
	          )
	        );
	        cache.delete(filePath);
	      }
	    }
	    function removeResolutionsFromProjectReferenceRedirects(filePath) {
	      if (!fileExtensionIs(filePath, ".json" /* Json */))
	        return;
	      const program = resolutionHost.getCurrentProgram();
	      if (!program)
	        return;
	      const resolvedProjectReference = program.getResolvedProjectReferenceByPath(filePath);
	      if (!resolvedProjectReference)
	        return;
	      resolvedProjectReference.commandLine.fileNames.forEach((f) => removeResolutionsOfFile(resolutionHost.toPath(f)));
	    }
	    function removeResolutionsOfFile(filePath, syncDirWatcherRemove) {
	      removeResolutionsOfFileFromCache(resolvedModuleNames, filePath, getResolvedModule, syncDirWatcherRemove);
	      removeResolutionsOfFileFromCache(resolvedTypeReferenceDirectives, filePath, getResolvedTypeReferenceDirective, syncDirWatcherRemove);
	    }
	    function invalidateResolutions(resolutions, canInvalidate) {
	      if (!resolutions)
	        return false;
	      let invalidated = false;
	      resolutions.forEach((resolution) => {
	        if (resolution.isInvalidated || !canInvalidate(resolution))
	          return;
	        resolution.isInvalidated = invalidated = true;
	        for (const containingFilePath of Debug.checkDefined(resolution.files)) {
	          (filesWithInvalidatedResolutions ?? (filesWithInvalidatedResolutions = /* @__PURE__ */ new Set())).add(containingFilePath);
	          hasChangedAutomaticTypeDirectiveNames = hasChangedAutomaticTypeDirectiveNames || endsWith(containingFilePath, inferredTypesContainingFile);
	        }
	      });
	      return invalidated;
	    }
	    function invalidateResolutionOfFile(filePath) {
	      removeResolutionsOfFile(filePath);
	      const prevHasChangedAutomaticTypeDirectiveNames = hasChangedAutomaticTypeDirectiveNames;
	      if (invalidateResolutions(resolvedFileToResolution.get(filePath), returnTrue) && hasChangedAutomaticTypeDirectiveNames && !prevHasChangedAutomaticTypeDirectiveNames) {
	        resolutionHost.onChangedAutomaticTypeDirectiveNames();
	      }
	    }
	    function setFilesWithInvalidatedNonRelativeUnresolvedImports(filesMap) {
	      Debug.assert(filesWithInvalidatedNonRelativeUnresolvedImports === filesMap || filesWithInvalidatedNonRelativeUnresolvedImports === void 0);
	      filesWithInvalidatedNonRelativeUnresolvedImports = filesMap;
	    }
	    function scheduleInvalidateResolutionOfFailedLookupLocation(fileOrDirectoryPath, isCreatingWatchedDirectory) {
	      if (isCreatingWatchedDirectory) {
	        (isInDirectoryChecks || (isInDirectoryChecks = /* @__PURE__ */ new Set())).add(fileOrDirectoryPath);
	      } else {
	        const updatedPath = removeIgnoredPath(fileOrDirectoryPath);
	        if (!updatedPath)
	          return false;
	        fileOrDirectoryPath = updatedPath;
	        if (resolutionHost.fileIsOpen(fileOrDirectoryPath)) {
	          return false;
	        }
	        const dirOfFileOrDirectory = getDirectoryPath(fileOrDirectoryPath);
	        if (isNodeModulesAtTypesDirectory(fileOrDirectoryPath) || isNodeModulesDirectory(fileOrDirectoryPath) || isNodeModulesAtTypesDirectory(dirOfFileOrDirectory) || isNodeModulesDirectory(dirOfFileOrDirectory)) {
	          (failedLookupChecks || (failedLookupChecks = /* @__PURE__ */ new Set())).add(fileOrDirectoryPath);
	          (startsWithPathChecks || (startsWithPathChecks = /* @__PURE__ */ new Set())).add(fileOrDirectoryPath);
	        } else {
	          if (isEmittedFileOfProgram(resolutionHost.getCurrentProgram(), fileOrDirectoryPath)) {
	            return false;
	          }
	          if (fileExtensionIs(fileOrDirectoryPath, ".map")) {
	            return false;
	          }
	          (failedLookupChecks || (failedLookupChecks = /* @__PURE__ */ new Set())).add(fileOrDirectoryPath);
	          const packagePath = parseNodeModuleFromPath(
	            fileOrDirectoryPath,
	            /*isFolder*/
	            true
	          );
	          if (packagePath)
	            (startsWithPathChecks || (startsWithPathChecks = /* @__PURE__ */ new Set())).add(packagePath);
	        }
	      }
	      resolutionHost.scheduleInvalidateResolutionsOfFailedLookupLocations();
	    }
	    function invalidatePackageJsonMap() {
	      const packageJsonMap = moduleResolutionCache.getPackageJsonInfoCache().getInternalMap();
	      if (packageJsonMap && (failedLookupChecks || startsWithPathChecks || isInDirectoryChecks)) {
	        packageJsonMap.forEach((_value, path) => isInvalidatedFailedLookup(path) ? packageJsonMap.delete(path) : void 0);
	      }
	    }
	    function invalidateResolutionsOfFailedLookupLocations() {
	      var _a;
	      if (allModuleAndTypeResolutionsAreInvalidated) {
	        affectingPathChecksForFile = void 0;
	        invalidatePackageJsonMap();
	        if (failedLookupChecks || startsWithPathChecks || isInDirectoryChecks || affectingPathChecks) {
	          invalidateResolutions(resolvedLibraries, canInvalidateFailedLookupResolution);
	        }
	        failedLookupChecks = void 0;
	        startsWithPathChecks = void 0;
	        isInDirectoryChecks = void 0;
	        affectingPathChecks = void 0;
	        return true;
	      }
	      let invalidated = false;
	      if (affectingPathChecksForFile) {
	        (_a = resolutionHost.getCurrentProgram()) == null ? void 0 : _a.getSourceFiles().forEach((f) => {
	          if (some(f.packageJsonLocations, (location) => affectingPathChecksForFile.has(location))) {
	            (filesWithInvalidatedResolutions ?? (filesWithInvalidatedResolutions = /* @__PURE__ */ new Set())).add(f.path);
	            invalidated = true;
	          }
	        });
	        affectingPathChecksForFile = void 0;
	      }
	      if (!failedLookupChecks && !startsWithPathChecks && !isInDirectoryChecks && !affectingPathChecks) {
	        return invalidated;
	      }
	      invalidated = invalidateResolutions(resolutionsWithFailedLookups, canInvalidateFailedLookupResolution) || invalidated;
	      invalidatePackageJsonMap();
	      failedLookupChecks = void 0;
	      startsWithPathChecks = void 0;
	      isInDirectoryChecks = void 0;
	      invalidated = invalidateResolutions(resolutionsWithOnlyAffectingLocations, canInvalidatedFailedLookupResolutionWithAffectingLocation) || invalidated;
	      affectingPathChecks = void 0;
	      return invalidated;
	    }
	    function canInvalidateFailedLookupResolution(resolution) {
	      var _a;
	      if (canInvalidatedFailedLookupResolutionWithAffectingLocation(resolution))
	        return true;
	      if (!failedLookupChecks && !startsWithPathChecks && !isInDirectoryChecks)
	        return false;
	      return ((_a = resolution.failedLookupLocations) == null ? void 0 : _a.some((location) => isInvalidatedFailedLookup(resolutionHost.toPath(location)))) || !!resolution.alternateResult && isInvalidatedFailedLookup(resolutionHost.toPath(resolution.alternateResult));
	    }
	    function isInvalidatedFailedLookup(locationPath) {
	      return (failedLookupChecks == null ? void 0 : failedLookupChecks.has(locationPath)) || firstDefinedIterator((startsWithPathChecks == null ? void 0 : startsWithPathChecks.keys()) || [], (fileOrDirectoryPath) => startsWith(locationPath, fileOrDirectoryPath) ? true : void 0) || firstDefinedIterator((isInDirectoryChecks == null ? void 0 : isInDirectoryChecks.keys()) || [], (dirPath) => locationPath.length > dirPath.length && startsWith(locationPath, dirPath) && (isDiskPathRoot(dirPath) || locationPath[dirPath.length] === directorySeparator) ? true : void 0);
	    }
	    function canInvalidatedFailedLookupResolutionWithAffectingLocation(resolution) {
	      var _a;
	      return !!affectingPathChecks && ((_a = resolution.affectingLocations) == null ? void 0 : _a.some((location) => affectingPathChecks.has(location)));
	    }
	    function closeTypeRootsWatch() {
	      clearMap(typeRootsWatches, closeFileWatcher);
	    }
	    function createTypeRootsWatch(typeRoot) {
	      return canWatchTypeRootPath(typeRoot) ? resolutionHost.watchTypeRootsDirectory(typeRoot, (fileOrDirectory) => {
	        const fileOrDirectoryPath = resolutionHost.toPath(fileOrDirectory);
	        if (cachedDirectoryStructureHost) {
	          cachedDirectoryStructureHost.addOrDeleteFileOrDirectory(fileOrDirectory, fileOrDirectoryPath);
	        }
	        hasChangedAutomaticTypeDirectiveNames = true;
	        resolutionHost.onChangedAutomaticTypeDirectiveNames();
	        const dirPath = getDirectoryToWatchFailedLookupLocationFromTypeRoot(
	          typeRoot,
	          resolutionHost.toPath(typeRoot),
	          rootPath,
	          rootPathComponents,
	          getCurrentDirectory,
	          (dirPath2) => directoryWatchesOfFailedLookups.has(dirPath2)
	        );
	        if (dirPath) {
	          scheduleInvalidateResolutionOfFailedLookupLocation(fileOrDirectoryPath, dirPath === fileOrDirectoryPath);
	        }
	      }, 1 /* Recursive */) : noopFileWatcher;
	    }
	    function updateTypeRootsWatch() {
	      const options = resolutionHost.getCompilationSettings();
	      if (options.types) {
	        closeTypeRootsWatch();
	        return;
	      }
	      const typeRoots = getEffectiveTypeRoots(options, { getCurrentDirectory });
	      if (typeRoots) {
	        mutateMap(
	          typeRootsWatches,
	          new Set(typeRoots),
	          {
	            createNewValue: createTypeRootsWatch,
	            onDeleteValue: closeFileWatcher
	          }
	        );
	      } else {
	        closeTypeRootsWatch();
	      }
	    }
	    function canWatchTypeRootPath(typeRoot) {
	      if (resolutionHost.getCompilationSettings().typeRoots)
	        return true;
	      return canWatchAtTypes(resolutionHost.toPath(typeRoot));
	    }
	  }
	  function resolutionIsSymlink(resolution) {
	    var _a, _b;
	    return !!(((_a = resolution.resolvedModule) == null ? void 0 : _a.originalPath) || ((_b = resolution.resolvedTypeReferenceDirective) == null ? void 0 : _b.originalPath));
	  }
	  var init_resolutionCache = __esm({
	    "src/compiler/resolutionCache.ts"() {
	      init_ts2();
	    }
	  });

	  // src/compiler/watch.ts
	  function createDiagnosticReporter(system, pretty) {
	    const host = system === sys && sysFormatDiagnosticsHost ? sysFormatDiagnosticsHost : {
	      getCurrentDirectory: () => system.getCurrentDirectory(),
	      getNewLine: () => system.newLine,
	      getCanonicalFileName: createGetCanonicalFileName(system.useCaseSensitiveFileNames)
	    };
	    if (!pretty) {
	      return (diagnostic) => system.write(formatDiagnostic(diagnostic, host));
	    }
	    const diagnostics = new Array(1);
	    return (diagnostic) => {
	      diagnostics[0] = diagnostic;
	      system.write(formatDiagnosticsWithColorAndContext(diagnostics, host) + host.getNewLine());
	      diagnostics[0] = void 0;
	    };
	  }
	  function clearScreenIfNotWatchingForFileChanges(system, diagnostic, options) {
	    if (system.clearScreen && !options.preserveWatchOutput && !options.extendedDiagnostics && !options.diagnostics && contains(screenStartingMessageCodes, diagnostic.code)) {
	      system.clearScreen();
	      return true;
	    }
	    return false;
	  }
	  function getPlainDiagnosticFollowingNewLines(diagnostic, newLine) {
	    return contains(screenStartingMessageCodes, diagnostic.code) ? newLine + newLine : newLine;
	  }
	  function getLocaleTimeString(system) {
	    return !system.now ? (/* @__PURE__ */ new Date()).toLocaleTimeString() : (
	      // On some systems / builds of Node, there's a non-breaking space between the time and AM/PM.
	      // This branch is solely for testing, so just switch it to a normal space for baseline stability.
	      // See:
	      //     - https://github.com/nodejs/node/issues/45171
	      //     - https://github.com/nodejs/node/issues/45753
	      system.now().toLocaleTimeString("en-US", { timeZone: "UTC" }).replace("\u202F", " ")
	    );
	  }
	  function createWatchStatusReporter(system, pretty) {
	    return pretty ? (diagnostic, newLine, options) => {
	      clearScreenIfNotWatchingForFileChanges(system, diagnostic, options);
	      let output = `[${formatColorAndReset(getLocaleTimeString(system), "\x1B[90m" /* Grey */)}] `;
	      output += `${flattenDiagnosticMessageText(diagnostic.messageText, system.newLine)}${newLine + newLine}`;
	      system.write(output);
	    } : (diagnostic, newLine, options) => {
	      let output = "";
	      if (!clearScreenIfNotWatchingForFileChanges(system, diagnostic, options)) {
	        output += newLine;
	      }
	      output += `${getLocaleTimeString(system)} - `;
	      output += `${flattenDiagnosticMessageText(diagnostic.messageText, system.newLine)}${getPlainDiagnosticFollowingNewLines(diagnostic, newLine)}`;
	      system.write(output);
	    };
	  }
	  function parseConfigFileWithSystem(configFileName, optionsToExtend, extendedConfigCache, watchOptionsToExtend, system, reportDiagnostic) {
	    const host = system;
	    host.onUnRecoverableConfigFileDiagnostic = (diagnostic) => reportUnrecoverableDiagnostic(system, reportDiagnostic, diagnostic);
	    const result = getParsedCommandLineOfConfigFile(configFileName, optionsToExtend, host, extendedConfigCache, watchOptionsToExtend);
	    host.onUnRecoverableConfigFileDiagnostic = void 0;
	    return result;
	  }
	  function getErrorCountForSummary(diagnostics) {
	    return countWhere(diagnostics, (diagnostic) => diagnostic.category === 1 /* Error */);
	  }
	  function getFilesInErrorForSummary(diagnostics) {
	    const filesInError = filter(diagnostics, (diagnostic) => diagnostic.category === 1 /* Error */).map(
	      (errorDiagnostic) => {
	        if (errorDiagnostic.file === void 0)
	          return;
	        return `${errorDiagnostic.file.fileName}`;
	      }
	    );
	    return filesInError.map((fileName) => {
	      if (fileName === void 0) {
	        return void 0;
	      }
	      const diagnosticForFileName = find(diagnostics, (diagnostic) => diagnostic.file !== void 0 && diagnostic.file.fileName === fileName);
	      if (diagnosticForFileName !== void 0) {
	        const { line } = getLineAndCharacterOfPosition(diagnosticForFileName.file, diagnosticForFileName.start);
	        return {
	          fileName,
	          line: line + 1
	        };
	      }
	    });
	  }
	  function getWatchErrorSummaryDiagnosticMessage(errorCount) {
	    return errorCount === 1 ? Diagnostics.Found_1_error_Watching_for_file_changes : Diagnostics.Found_0_errors_Watching_for_file_changes;
	  }
	  function prettyPathForFileError(error2, cwd) {
	    const line = formatColorAndReset(":" + error2.line, "\x1B[90m" /* Grey */);
	    if (pathIsAbsolute(error2.fileName) && pathIsAbsolute(cwd)) {
	      return getRelativePathFromDirectory(
	        cwd,
	        error2.fileName,
	        /*ignoreCase*/
	        false
	      ) + line;
	    }
	    return error2.fileName + line;
	  }
	  function getErrorSummaryText(errorCount, filesInError, newLine, host) {
	    if (errorCount === 0)
	      return "";
	    const nonNilFiles = filesInError.filter((fileInError) => fileInError !== void 0);
	    const distinctFileNamesWithLines = nonNilFiles.map((fileInError) => `${fileInError.fileName}:${fileInError.line}`).filter((value, index, self) => self.indexOf(value) === index);
	    const firstFileReference = nonNilFiles[0] && prettyPathForFileError(nonNilFiles[0], host.getCurrentDirectory());
	    let messageAndArgs;
	    if (errorCount === 1) {
	      messageAndArgs = filesInError[0] !== void 0 ? [Diagnostics.Found_1_error_in_0, firstFileReference] : [Diagnostics.Found_1_error];
	    } else {
	      messageAndArgs = distinctFileNamesWithLines.length === 0 ? [Diagnostics.Found_0_errors, errorCount] : distinctFileNamesWithLines.length === 1 ? [Diagnostics.Found_0_errors_in_the_same_file_starting_at_Colon_1, errorCount, firstFileReference] : [Diagnostics.Found_0_errors_in_1_files, errorCount, distinctFileNamesWithLines.length];
	    }
	    const d = createCompilerDiagnostic(...messageAndArgs);
	    const suffix = distinctFileNamesWithLines.length > 1 ? createTabularErrorsDisplay(nonNilFiles, host) : "";
	    return `${newLine}${flattenDiagnosticMessageText(d.messageText, newLine)}${newLine}${newLine}${suffix}`;
	  }
	  function createTabularErrorsDisplay(filesInError, host) {
	    const distinctFiles = filesInError.filter((value, index, self) => index === self.findIndex((file) => (file == null ? void 0 : file.fileName) === (value == null ? void 0 : value.fileName)));
	    if (distinctFiles.length === 0)
	      return "";
	    const numberLength = (num) => Math.log(num) * Math.LOG10E + 1;
	    const fileToErrorCount = distinctFiles.map((file) => [file, countWhere(filesInError, (fileInError) => fileInError.fileName === file.fileName)]);
	    const maxErrors = fileToErrorCount.reduce((acc, value) => Math.max(acc, value[1] || 0), 0);
	    const headerRow = Diagnostics.Errors_Files.message;
	    const leftColumnHeadingLength = headerRow.split(" ")[0].length;
	    const leftPaddingGoal = Math.max(leftColumnHeadingLength, numberLength(maxErrors));
	    const headerPadding = Math.max(numberLength(maxErrors) - leftColumnHeadingLength, 0);
	    let tabularData = "";
	    tabularData += " ".repeat(headerPadding) + headerRow + "\n";
	    fileToErrorCount.forEach((row) => {
	      const [file, errorCount] = row;
	      const errorCountDigitsLength = Math.log(errorCount) * Math.LOG10E + 1 | 0;
	      const leftPadding = errorCountDigitsLength < leftPaddingGoal ? " ".repeat(leftPaddingGoal - errorCountDigitsLength) : "";
	      const fileRef = prettyPathForFileError(file, host.getCurrentDirectory());
	      tabularData += `${leftPadding}${errorCount}  ${fileRef}
`;
	    });
	    return tabularData;
	  }
	  function isBuilderProgram2(program) {
	    return !!program.getState;
	  }
	  function listFiles(program, write) {
	    const options = program.getCompilerOptions();
	    if (options.explainFiles) {
	      explainFiles(isBuilderProgram2(program) ? program.getProgram() : program, write);
	    } else if (options.listFiles || options.listFilesOnly) {
	      forEach(program.getSourceFiles(), (file) => {
	        write(file.fileName);
	      });
	    }
	  }
	  function explainFiles(program, write) {
	    var _a, _b;
	    const reasons = program.getFileIncludeReasons();
	    const relativeFileName = (fileName) => convertToRelativePath(fileName, program.getCurrentDirectory(), program.getCanonicalFileName);
	    for (const file of program.getSourceFiles()) {
	      write(`${toFileName(file, relativeFileName)}`);
	      (_a = reasons.get(file.path)) == null ? void 0 : _a.forEach((reason) => write(`  ${fileIncludeReasonToDiagnostics(program, reason, relativeFileName).messageText}`));
	      (_b = explainIfFileIsRedirectAndImpliedFormat(file, relativeFileName)) == null ? void 0 : _b.forEach((d) => write(`  ${d.messageText}`));
	    }
	  }
	  function explainIfFileIsRedirectAndImpliedFormat(file, fileNameConvertor) {
	    var _a;
	    let result;
	    if (file.path !== file.resolvedPath) {
	      (result ?? (result = [])).push(chainDiagnosticMessages(
	        /*details*/
	        void 0,
	        Diagnostics.File_is_output_of_project_reference_source_0,
	        toFileName(file.originalFileName, fileNameConvertor)
	      ));
	    }
	    if (file.redirectInfo) {
	      (result ?? (result = [])).push(chainDiagnosticMessages(
	        /*details*/
	        void 0,
	        Diagnostics.File_redirects_to_file_0,
	        toFileName(file.redirectInfo.redirectTarget, fileNameConvertor)
	      ));
	    }
	    if (isExternalOrCommonJsModule(file)) {
	      switch (file.impliedNodeFormat) {
	        case 99 /* ESNext */:
	          if (file.packageJsonScope) {
	            (result ?? (result = [])).push(chainDiagnosticMessages(
	              /*details*/
	              void 0,
	              Diagnostics.File_is_ECMAScript_module_because_0_has_field_type_with_value_module,
	              toFileName(last(file.packageJsonLocations), fileNameConvertor)
	            ));
	          }
	          break;
	        case 1 /* CommonJS */:
	          if (file.packageJsonScope) {
	            (result ?? (result = [])).push(chainDiagnosticMessages(
	              /*details*/
	              void 0,
	              file.packageJsonScope.contents.packageJsonContent.type ? Diagnostics.File_is_CommonJS_module_because_0_has_field_type_whose_value_is_not_module : Diagnostics.File_is_CommonJS_module_because_0_does_not_have_field_type,
	              toFileName(last(file.packageJsonLocations), fileNameConvertor)
	            ));
	          } else if ((_a = file.packageJsonLocations) == null ? void 0 : _a.length) {
	            (result ?? (result = [])).push(chainDiagnosticMessages(
	              /*details*/
	              void 0,
	              Diagnostics.File_is_CommonJS_module_because_package_json_was_not_found
	            ));
	          }
	          break;
	      }
	    }
	    return result;
	  }
	  function getMatchedFileSpec(program, fileName) {
	    var _a;
	    const configFile = program.getCompilerOptions().configFile;
	    if (!((_a = configFile == null ? void 0 : configFile.configFileSpecs) == null ? void 0 : _a.validatedFilesSpec))
	      return void 0;
	    const filePath = program.getCanonicalFileName(fileName);
	    const basePath = getDirectoryPath(getNormalizedAbsolutePath(configFile.fileName, program.getCurrentDirectory()));
	    return find(configFile.configFileSpecs.validatedFilesSpec, (fileSpec) => program.getCanonicalFileName(getNormalizedAbsolutePath(fileSpec, basePath)) === filePath);
	  }
	  function getMatchedIncludeSpec(program, fileName) {
	    var _a, _b;
	    const configFile = program.getCompilerOptions().configFile;
	    if (!((_a = configFile == null ? void 0 : configFile.configFileSpecs) == null ? void 0 : _a.validatedIncludeSpecs))
	      return void 0;
	    if (configFile.configFileSpecs.isDefaultIncludeSpec)
	      return true;
	    const isJsonFile = fileExtensionIs(fileName, ".json" /* Json */);
	    const basePath = getDirectoryPath(getNormalizedAbsolutePath(configFile.fileName, program.getCurrentDirectory()));
	    const useCaseSensitiveFileNames2 = program.useCaseSensitiveFileNames();
	    return find((_b = configFile == null ? void 0 : configFile.configFileSpecs) == null ? void 0 : _b.validatedIncludeSpecs, (includeSpec) => {
	      if (isJsonFile && !endsWith(includeSpec, ".json" /* Json */))
	        return false;
	      const pattern = getPatternFromSpec(includeSpec, basePath, "files");
	      return !!pattern && getRegexFromPattern(`(${pattern})$`, useCaseSensitiveFileNames2).test(fileName);
	    });
	  }
	  function fileIncludeReasonToDiagnostics(program, reason, fileNameConvertor) {
	    var _a, _b;
	    const options = program.getCompilerOptions();
	    if (isReferencedFile(reason)) {
	      const referenceLocation = getReferencedFileLocation(program, reason);
	      const referenceText = isReferenceFileLocation(referenceLocation) ? referenceLocation.file.text.substring(referenceLocation.pos, referenceLocation.end) : `"${referenceLocation.text}"`;
	      let message;
	      Debug.assert(isReferenceFileLocation(referenceLocation) || reason.kind === 3 /* Import */, "Only synthetic references are imports");
	      switch (reason.kind) {
	        case 3 /* Import */:
	          if (isReferenceFileLocation(referenceLocation)) {
	            message = referenceLocation.packageId ? Diagnostics.Imported_via_0_from_file_1_with_packageId_2 : Diagnostics.Imported_via_0_from_file_1;
	          } else if (referenceLocation.text === externalHelpersModuleNameText) {
	            message = referenceLocation.packageId ? Diagnostics.Imported_via_0_from_file_1_with_packageId_2_to_import_importHelpers_as_specified_in_compilerOptions : Diagnostics.Imported_via_0_from_file_1_to_import_importHelpers_as_specified_in_compilerOptions;
	          } else {
	            message = referenceLocation.packageId ? Diagnostics.Imported_via_0_from_file_1_with_packageId_2_to_import_jsx_and_jsxs_factory_functions : Diagnostics.Imported_via_0_from_file_1_to_import_jsx_and_jsxs_factory_functions;
	          }
	          break;
	        case 4 /* ReferenceFile */:
	          Debug.assert(!referenceLocation.packageId);
	          message = Diagnostics.Referenced_via_0_from_file_1;
	          break;
	        case 5 /* TypeReferenceDirective */:
	          message = referenceLocation.packageId ? Diagnostics.Type_library_referenced_via_0_from_file_1_with_packageId_2 : Diagnostics.Type_library_referenced_via_0_from_file_1;
	          break;
	        case 7 /* LibReferenceDirective */:
	          Debug.assert(!referenceLocation.packageId);
	          message = Diagnostics.Library_referenced_via_0_from_file_1;
	          break;
	        default:
	          Debug.assertNever(reason);
	      }
	      return chainDiagnosticMessages(
	        /*details*/
	        void 0,
	        message,
	        referenceText,
	        toFileName(referenceLocation.file, fileNameConvertor),
	        referenceLocation.packageId && packageIdToString(referenceLocation.packageId)
	      );
	    }
	    switch (reason.kind) {
	      case 0 /* RootFile */:
	        if (!((_a = options.configFile) == null ? void 0 : _a.configFileSpecs))
	          return chainDiagnosticMessages(
	            /*details*/
	            void 0,
	            Diagnostics.Root_file_specified_for_compilation
	          );
	        const fileName = getNormalizedAbsolutePath(program.getRootFileNames()[reason.index], program.getCurrentDirectory());
	        const matchedByFiles = getMatchedFileSpec(program, fileName);
	        if (matchedByFiles)
	          return chainDiagnosticMessages(
	            /*details*/
	            void 0,
	            Diagnostics.Part_of_files_list_in_tsconfig_json
	          );
	        const matchedByInclude = getMatchedIncludeSpec(program, fileName);
	        return isString(matchedByInclude) ? chainDiagnosticMessages(
	          /*details*/
	          void 0,
	          Diagnostics.Matched_by_include_pattern_0_in_1,
	          matchedByInclude,
	          toFileName(options.configFile, fileNameConvertor)
	        ) : (
	          // Could be additional files specified as roots or matched by default include
	          chainDiagnosticMessages(
	            /*details*/
	            void 0,
	            matchedByInclude ? Diagnostics.Matched_by_default_include_pattern_Asterisk_Asterisk_Slash_Asterisk : Diagnostics.Root_file_specified_for_compilation
	          )
	        );
	      case 1 /* SourceFromProjectReference */:
	      case 2 /* OutputFromProjectReference */:
	        const isOutput = reason.kind === 2 /* OutputFromProjectReference */;
	        const referencedResolvedRef = Debug.checkDefined((_b = program.getResolvedProjectReferences()) == null ? void 0 : _b[reason.index]);
	        return chainDiagnosticMessages(
	          /*details*/
	          void 0,
	          outFile(options) ? isOutput ? Diagnostics.Output_from_referenced_project_0_included_because_1_specified : Diagnostics.Source_from_referenced_project_0_included_because_1_specified : isOutput ? Diagnostics.Output_from_referenced_project_0_included_because_module_is_specified_as_none : Diagnostics.Source_from_referenced_project_0_included_because_module_is_specified_as_none,
	          toFileName(referencedResolvedRef.sourceFile.fileName, fileNameConvertor),
	          options.outFile ? "--outFile" : "--out"
	        );
	      case 8 /* AutomaticTypeDirectiveFile */: {
	        const messageAndArgs = options.types ? reason.packageId ? [Diagnostics.Entry_point_of_type_library_0_specified_in_compilerOptions_with_packageId_1, reason.typeReference, packageIdToString(reason.packageId)] : [Diagnostics.Entry_point_of_type_library_0_specified_in_compilerOptions, reason.typeReference] : reason.packageId ? [Diagnostics.Entry_point_for_implicit_type_library_0_with_packageId_1, reason.typeReference, packageIdToString(reason.packageId)] : [Diagnostics.Entry_point_for_implicit_type_library_0, reason.typeReference];
	        return chainDiagnosticMessages(
	          /*details*/
	          void 0,
	          ...messageAndArgs
	        );
	      }
	      case 6 /* LibFile */: {
	        if (reason.index !== void 0)
	          return chainDiagnosticMessages(
	            /*details*/
	            void 0,
	            Diagnostics.Library_0_specified_in_compilerOptions,
	            options.lib[reason.index]
	          );
	        const target = forEachEntry(targetOptionDeclaration.type, (value, key) => value === getEmitScriptTarget(options) ? key : void 0);
	        const messageAndArgs = target ? [Diagnostics.Default_library_for_target_0, target] : [Diagnostics.Default_library];
	        return chainDiagnosticMessages(
	          /*details*/
	          void 0,
	          ...messageAndArgs
	        );
	      }
	      default:
	        Debug.assertNever(reason);
	    }
	  }
	  function toFileName(file, fileNameConvertor) {
	    const fileName = isString(file) ? file : file.fileName;
	    return fileNameConvertor ? fileNameConvertor(fileName) : fileName;
	  }
	  function emitFilesAndReportErrors(program, reportDiagnostic, write, reportSummary, writeFile2, cancellationToken, emitOnlyDtsFiles, customTransformers) {
	    const isListFilesOnly = !!program.getCompilerOptions().listFilesOnly;
	    const allDiagnostics = program.getConfigFileParsingDiagnostics().slice();
	    const configFileParsingDiagnosticsLength = allDiagnostics.length;
	    addRange(allDiagnostics, program.getSyntacticDiagnostics(
	      /*sourceFile*/
	      void 0,
	      cancellationToken
	    ));
	    if (allDiagnostics.length === configFileParsingDiagnosticsLength) {
	      addRange(allDiagnostics, program.getOptionsDiagnostics(cancellationToken));
	      if (!isListFilesOnly) {
	        addRange(allDiagnostics, program.getGlobalDiagnostics(cancellationToken));
	        if (allDiagnostics.length === configFileParsingDiagnosticsLength) {
	          addRange(allDiagnostics, program.getSemanticDiagnostics(
	            /*sourceFile*/
	            void 0,
	            cancellationToken
	          ));
	        }
	      }
	    }
	    const emitResult = isListFilesOnly ? { emitSkipped: true, diagnostics: emptyArray } : program.emit(
	      /*targetSourceFile*/
	      void 0,
	      writeFile2,
	      cancellationToken,
	      emitOnlyDtsFiles,
	      customTransformers
	    );
	    const { emittedFiles, diagnostics: emitDiagnostics } = emitResult;
	    addRange(allDiagnostics, emitDiagnostics);
	    const diagnostics = sortAndDeduplicateDiagnostics(allDiagnostics);
	    diagnostics.forEach(reportDiagnostic);
	    if (write) {
	      const currentDir = program.getCurrentDirectory();
	      forEach(emittedFiles, (file) => {
	        const filepath = getNormalizedAbsolutePath(file, currentDir);
	        write(`TSFILE: ${filepath}`);
	      });
	      listFiles(program, write);
	    }
	    if (reportSummary) {
	      reportSummary(getErrorCountForSummary(diagnostics), getFilesInErrorForSummary(diagnostics));
	    }
	    return {
	      emitResult,
	      diagnostics
	    };
	  }
	  function emitFilesAndReportErrorsAndGetExitStatus(program, reportDiagnostic, write, reportSummary, writeFile2, cancellationToken, emitOnlyDtsFiles, customTransformers) {
	    const { emitResult, diagnostics } = emitFilesAndReportErrors(
	      program,
	      reportDiagnostic,
	      write,
	      reportSummary,
	      writeFile2,
	      cancellationToken,
	      emitOnlyDtsFiles,
	      customTransformers
	    );
	    if (emitResult.emitSkipped && diagnostics.length > 0) {
	      return 1 /* DiagnosticsPresent_OutputsSkipped */;
	    } else if (diagnostics.length > 0) {
	      return 2 /* DiagnosticsPresent_OutputsGenerated */;
	    }
	    return 0 /* Success */;
	  }
	  function createWatchHost(system = sys, reportWatchStatus2) {
	    const onWatchStatusChange = reportWatchStatus2 || createWatchStatusReporter(system);
	    return {
	      onWatchStatusChange,
	      watchFile: maybeBind(system, system.watchFile) || returnNoopFileWatcher,
	      watchDirectory: maybeBind(system, system.watchDirectory) || returnNoopFileWatcher,
	      setTimeout: maybeBind(system, system.setTimeout) || noop,
	      clearTimeout: maybeBind(system, system.clearTimeout) || noop
	    };
	  }
	  function createWatchFactory(host, options) {
	    const watchLogLevel = host.trace ? options.extendedDiagnostics ? 2 /* Verbose */ : options.diagnostics ? 1 /* TriggerOnly */ : 0 /* None */ : 0 /* None */;
	    const writeLog = watchLogLevel !== 0 /* None */ ? (s) => host.trace(s) : noop;
	    const result = getWatchFactory(host, watchLogLevel, writeLog);
	    result.writeLog = writeLog;
	    return result;
	  }
	  function createCompilerHostFromProgramHost(host, getCompilerOptions, directoryStructureHost = host) {
	    const useCaseSensitiveFileNames2 = host.useCaseSensitiveFileNames();
	    const compilerHost = {
	      getSourceFile: createGetSourceFile(
	        (fileName, encoding) => !encoding ? compilerHost.readFile(fileName) : host.readFile(fileName, encoding),
	        getCompilerOptions,
	        /*setParentNodes*/
	        void 0
	      ),
	      getDefaultLibLocation: maybeBind(host, host.getDefaultLibLocation),
	      getDefaultLibFileName: (options) => host.getDefaultLibFileName(options),
	      writeFile: createWriteFileMeasuringIO(
	        (path, data, writeByteOrderMark) => host.writeFile(path, data, writeByteOrderMark),
	        (path) => host.createDirectory(path),
	        (path) => host.directoryExists(path)
	      ),
	      getCurrentDirectory: memoize(() => host.getCurrentDirectory()),
	      useCaseSensitiveFileNames: () => useCaseSensitiveFileNames2,
	      getCanonicalFileName: createGetCanonicalFileName(useCaseSensitiveFileNames2),
	      getNewLine: () => getNewLineCharacter(getCompilerOptions()),
	      fileExists: (f) => host.fileExists(f),
	      readFile: (f) => host.readFile(f),
	      trace: maybeBind(host, host.trace),
	      directoryExists: maybeBind(directoryStructureHost, directoryStructureHost.directoryExists),
	      getDirectories: maybeBind(directoryStructureHost, directoryStructureHost.getDirectories),
	      realpath: maybeBind(host, host.realpath),
	      getEnvironmentVariable: maybeBind(host, host.getEnvironmentVariable) || (() => ""),
	      createHash: maybeBind(host, host.createHash),
	      readDirectory: maybeBind(host, host.readDirectory),
	      storeFilesChangingSignatureDuringEmit: host.storeFilesChangingSignatureDuringEmit,
	      jsDocParsingMode: host.jsDocParsingMode
	    };
	    return compilerHost;
	  }
	  function getSourceFileVersionAsHashFromText(host, text) {
	    if (text.match(sourceMapCommentRegExpDontCareLineStart)) {
	      let lineEnd = text.length;
	      let lineStart = lineEnd;
	      for (let pos = lineEnd - 1; pos >= 0; pos--) {
	        const ch = text.charCodeAt(pos);
	        switch (ch) {
	          case 10 /* lineFeed */:
	            if (pos && text.charCodeAt(pos - 1) === 13 /* carriageReturn */) {
	              pos--;
	            }
	          case 13 /* carriageReturn */:
	            break;
	          default:
	            if (ch < 127 /* maxAsciiCharacter */ || !isLineBreak(ch)) {
	              lineStart = pos;
	              continue;
	            }
	            break;
	        }
	        const line = text.substring(lineStart, lineEnd);
	        if (line.match(sourceMapCommentRegExp)) {
	          text = text.substring(0, lineStart);
	          break;
	        } else if (!line.match(whitespaceOrMapCommentRegExp)) {
	          break;
	        }
	        lineEnd = lineStart;
	      }
	    }
	    return (host.createHash || generateDjb2Hash)(text);
	  }
	  function setGetSourceFileAsHashVersioned(compilerHost) {
	    const originalGetSourceFile = compilerHost.getSourceFile;
	    compilerHost.getSourceFile = (...args) => {
	      const result = originalGetSourceFile.call(compilerHost, ...args);
	      if (result) {
	        result.version = getSourceFileVersionAsHashFromText(compilerHost, result.text);
	      }
	      return result;
	    };
	  }
	  function createProgramHost(system, createProgram2) {
	    const getDefaultLibLocation = memoize(() => getDirectoryPath(normalizePath(system.getExecutingFilePath())));
	    return {
	      useCaseSensitiveFileNames: () => system.useCaseSensitiveFileNames,
	      getNewLine: () => system.newLine,
	      getCurrentDirectory: memoize(() => system.getCurrentDirectory()),
	      getDefaultLibLocation,
	      getDefaultLibFileName: (options) => combinePaths(getDefaultLibLocation(), getDefaultLibFileName(options)),
	      fileExists: (path) => system.fileExists(path),
	      readFile: (path, encoding) => system.readFile(path, encoding),
	      directoryExists: (path) => system.directoryExists(path),
	      getDirectories: (path) => system.getDirectories(path),
	      readDirectory: (path, extensions, exclude, include, depth) => system.readDirectory(path, extensions, exclude, include, depth),
	      realpath: maybeBind(system, system.realpath),
	      getEnvironmentVariable: maybeBind(system, system.getEnvironmentVariable),
	      trace: (s) => system.write(s + system.newLine),
	      createDirectory: (path) => system.createDirectory(path),
	      writeFile: (path, data, writeByteOrderMark) => system.writeFile(path, data, writeByteOrderMark),
	      createHash: maybeBind(system, system.createHash),
	      createProgram: createProgram2 || createEmitAndSemanticDiagnosticsBuilderProgram,
	      storeFilesChangingSignatureDuringEmit: system.storeFilesChangingSignatureDuringEmit,
	      now: maybeBind(system, system.now)
	    };
	  }
	  function createWatchCompilerHost(system = sys, createProgram2, reportDiagnostic, reportWatchStatus2) {
	    const write = (s) => system.write(s + system.newLine);
	    const result = createProgramHost(system, createProgram2);
	    copyProperties(result, createWatchHost(system, reportWatchStatus2));
	    result.afterProgramCreate = (builderProgram) => {
	      const compilerOptions = builderProgram.getCompilerOptions();
	      const newLine = getNewLineCharacter(compilerOptions);
	      emitFilesAndReportErrors(
	        builderProgram,
	        reportDiagnostic,
	        write,
	        (errorCount) => result.onWatchStatusChange(
	          createCompilerDiagnostic(getWatchErrorSummaryDiagnosticMessage(errorCount), errorCount),
	          newLine,
	          compilerOptions,
	          errorCount
	        )
	      );
	    };
	    return result;
	  }
	  function reportUnrecoverableDiagnostic(system, reportDiagnostic, diagnostic) {
	    reportDiagnostic(diagnostic);
	    system.exit(1 /* DiagnosticsPresent_OutputsSkipped */);
	  }
	  function createWatchCompilerHostOfConfigFile({
	    configFileName,
	    optionsToExtend,
	    watchOptionsToExtend,
	    extraFileExtensions,
	    system,
	    createProgram: createProgram2,
	    reportDiagnostic,
	    reportWatchStatus: reportWatchStatus2
	  }) {
	    const diagnosticReporter = reportDiagnostic || createDiagnosticReporter(system);
	    const host = createWatchCompilerHost(system, createProgram2, diagnosticReporter, reportWatchStatus2);
	    host.onUnRecoverableConfigFileDiagnostic = (diagnostic) => reportUnrecoverableDiagnostic(system, diagnosticReporter, diagnostic);
	    host.configFileName = configFileName;
	    host.optionsToExtend = optionsToExtend;
	    host.watchOptionsToExtend = watchOptionsToExtend;
	    host.extraFileExtensions = extraFileExtensions;
	    return host;
	  }
	  function createWatchCompilerHostOfFilesAndCompilerOptions({
	    rootFiles,
	    options,
	    watchOptions,
	    projectReferences,
	    system,
	    createProgram: createProgram2,
	    reportDiagnostic,
	    reportWatchStatus: reportWatchStatus2
	  }) {
	    const host = createWatchCompilerHost(system, createProgram2, reportDiagnostic || createDiagnosticReporter(system), reportWatchStatus2);
	    host.rootFiles = rootFiles;
	    host.options = options;
	    host.watchOptions = watchOptions;
	    host.projectReferences = projectReferences;
	    return host;
	  }
	  function performIncrementalCompilation(input) {
	    const system = input.system || sys;
	    const host = input.host || (input.host = createIncrementalCompilerHost(input.options, system));
	    const builderProgram = createIncrementalProgram(input);
	    const exitStatus = emitFilesAndReportErrorsAndGetExitStatus(
	      builderProgram,
	      input.reportDiagnostic || createDiagnosticReporter(system),
	      (s) => host.trace && host.trace(s),
	      input.reportErrorSummary || input.options.pretty ? (errorCount, filesInError) => system.write(getErrorSummaryText(errorCount, filesInError, system.newLine, host)) : void 0
	    );
	    if (input.afterProgramEmitAndDiagnostics)
	      input.afterProgramEmitAndDiagnostics(builderProgram);
	    return exitStatus;
	  }
	  var sysFormatDiagnosticsHost, screenStartingMessageCodes, noopFileWatcher, returnNoopFileWatcher, WatchType;
	  var init_watch = __esm({
	    "src/compiler/watch.ts"() {
	      init_ts2();
	      sysFormatDiagnosticsHost = sys ? {
	        getCurrentDirectory: () => sys.getCurrentDirectory(),
	        getNewLine: () => sys.newLine,
	        getCanonicalFileName: createGetCanonicalFileName(sys.useCaseSensitiveFileNames)
	      } : void 0;
	      screenStartingMessageCodes = [
	        Diagnostics.Starting_compilation_in_watch_mode.code,
	        Diagnostics.File_change_detected_Starting_incremental_compilation.code
	      ];
	      noopFileWatcher = { close: noop };
	      returnNoopFileWatcher = () => noopFileWatcher;
	      WatchType = {
	        ConfigFile: "Config file",
	        ExtendedConfigFile: "Extended config file",
	        SourceFile: "Source file",
	        MissingFile: "Missing file",
	        WildcardDirectory: "Wild card directory",
	        FailedLookupLocations: "Failed Lookup Locations",
	        AffectingFileLocation: "File location affecting resolution",
	        TypeRoots: "Type roots",
	        ConfigFileOfReferencedProject: "Config file of referened project",
	        ExtendedConfigOfReferencedProject: "Extended config file of referenced project",
	        WildcardDirectoryOfReferencedProject: "Wild card directory of referenced project",
	        PackageJson: "package.json file",
	        ClosedScriptInfo: "Closed Script info",
	        ConfigFileForInferredRoot: "Config file for the inferred project root",
	        NodeModules: "node_modules for closed script infos and package.jsons affecting module specifier cache",
	        MissingSourceMapFile: "Missing source map file",
	        NoopConfigFileForInferredRoot: "Noop Config file for the inferred project root",
	        MissingGeneratedFile: "Missing generated file",
	        NodeModulesForModuleSpecifierCache: "node_modules for module specifier cache invalidation",
	        TypingInstallerLocationFile: "File location for typing installer",
	        TypingInstallerLocationDirectory: "Directory location for typing installer"
	      };
	    }
	  });

	  // src/compiler/watchPublic.ts
	  function readBuilderProgram(compilerOptions, host) {
	    const buildInfoPath = getTsBuildInfoEmitOutputFilePath(compilerOptions);
	    if (!buildInfoPath)
	      return void 0;
	    let buildInfo;
	    if (host.getBuildInfo) {
	      buildInfo = host.getBuildInfo(buildInfoPath, compilerOptions.configFilePath);
	    } else {
	      const content = host.readFile(buildInfoPath);
	      if (!content)
	        return void 0;
	      buildInfo = getBuildInfo(buildInfoPath, content);
	    }
	    if (!buildInfo || buildInfo.version !== version || !buildInfo.program)
	      return void 0;
	    return createBuilderProgramUsingProgramBuildInfo(buildInfo, buildInfoPath, host);
	  }
	  function createIncrementalCompilerHost(options, system = sys) {
	    const host = createCompilerHostWorker(
	      options,
	      /*setParentNodes*/
	      void 0,
	      system
	    );
	    host.createHash = maybeBind(system, system.createHash);
	    host.storeFilesChangingSignatureDuringEmit = system.storeFilesChangingSignatureDuringEmit;
	    setGetSourceFileAsHashVersioned(host);
	    changeCompilerHostLikeToUseCache(host, (fileName) => toPath(fileName, host.getCurrentDirectory(), host.getCanonicalFileName));
	    return host;
	  }
	  function createIncrementalProgram({
	    rootNames,
	    options,
	    configFileParsingDiagnostics,
	    projectReferences,
	    host,
	    createProgram: createProgram2
	  }) {
	    host = host || createIncrementalCompilerHost(options);
	    createProgram2 = createProgram2 || createEmitAndSemanticDiagnosticsBuilderProgram;
	    const oldProgram = readBuilderProgram(options, host);
	    return createProgram2(rootNames, options, host, oldProgram, configFileParsingDiagnostics, projectReferences);
	  }
	  function createWatchCompilerHost2(rootFilesOrConfigFileName, options, system, createProgram2, reportDiagnostic, reportWatchStatus2, projectReferencesOrWatchOptionsToExtend, watchOptionsOrExtraFileExtensions) {
	    if (isArray(rootFilesOrConfigFileName)) {
	      return createWatchCompilerHostOfFilesAndCompilerOptions({
	        rootFiles: rootFilesOrConfigFileName,
	        options,
	        watchOptions: watchOptionsOrExtraFileExtensions,
	        projectReferences: projectReferencesOrWatchOptionsToExtend,
	        system,
	        createProgram: createProgram2,
	        reportDiagnostic,
	        reportWatchStatus: reportWatchStatus2
	      });
	    } else {
	      return createWatchCompilerHostOfConfigFile({
	        configFileName: rootFilesOrConfigFileName,
	        optionsToExtend: options,
	        watchOptionsToExtend: projectReferencesOrWatchOptionsToExtend,
	        extraFileExtensions: watchOptionsOrExtraFileExtensions,
	        system,
	        createProgram: createProgram2,
	        reportDiagnostic,
	        reportWatchStatus: reportWatchStatus2
	      });
	    }
	  }
	  function createWatchProgram(host) {
	    let builderProgram;
	    let updateLevel;
	    let missingFilesMap;
	    let watchedWildcardDirectories;
	    let timerToUpdateProgram;
	    let timerToInvalidateFailedLookupResolutions;
	    let parsedConfigs;
	    let sharedExtendedConfigFileWatchers;
	    let extendedConfigCache = host.extendedConfigCache;
	    let reportFileChangeDetectedOnCreateProgram = false;
	    const sourceFilesCache = /* @__PURE__ */ new Map();
	    let missingFilePathsRequestedForRelease;
	    let hasChangedCompilerOptions = false;
	    const useCaseSensitiveFileNames2 = host.useCaseSensitiveFileNames();
	    const currentDirectory = host.getCurrentDirectory();
	    const { configFileName, optionsToExtend: optionsToExtendForConfigFile = {}, watchOptionsToExtend, extraFileExtensions, createProgram: createProgram2 } = host;
	    let { rootFiles: rootFileNames, options: compilerOptions, watchOptions, projectReferences } = host;
	    let wildcardDirectories;
	    let configFileParsingDiagnostics;
	    let canConfigFileJsonReportNoInputFiles = false;
	    let hasChangedConfigFileParsingErrors = false;
	    const cachedDirectoryStructureHost = configFileName === void 0 ? void 0 : createCachedDirectoryStructureHost(host, currentDirectory, useCaseSensitiveFileNames2);
	    const directoryStructureHost = cachedDirectoryStructureHost || host;
	    const parseConfigFileHost = parseConfigHostFromCompilerHostLike(host, directoryStructureHost);
	    let newLine = updateNewLine();
	    if (configFileName && host.configFileParsingResult) {
	      setConfigFileParsingResult(host.configFileParsingResult);
	      newLine = updateNewLine();
	    }
	    reportWatchDiagnostic(Diagnostics.Starting_compilation_in_watch_mode);
	    if (configFileName && !host.configFileParsingResult) {
	      newLine = getNewLineCharacter(optionsToExtendForConfigFile);
	      Debug.assert(!rootFileNames);
	      parseConfigFile2();
	      newLine = updateNewLine();
	    }
	    Debug.assert(compilerOptions);
	    Debug.assert(rootFileNames);
	    const { watchFile: watchFile2, watchDirectory, writeLog } = createWatchFactory(host, compilerOptions);
	    const getCanonicalFileName = createGetCanonicalFileName(useCaseSensitiveFileNames2);
	    writeLog(`Current directory: ${currentDirectory} CaseSensitiveFileNames: ${useCaseSensitiveFileNames2}`);
	    let configFileWatcher;
	    if (configFileName) {
	      configFileWatcher = watchFile2(configFileName, scheduleProgramReload, 2e3 /* High */, watchOptions, WatchType.ConfigFile);
	    }
	    const compilerHost = createCompilerHostFromProgramHost(host, () => compilerOptions, directoryStructureHost);
	    setGetSourceFileAsHashVersioned(compilerHost);
	    const getNewSourceFile = compilerHost.getSourceFile;
	    compilerHost.getSourceFile = (fileName, ...args) => getVersionedSourceFileByPath(fileName, toPath3(fileName), ...args);
	    compilerHost.getSourceFileByPath = getVersionedSourceFileByPath;
	    compilerHost.getNewLine = () => newLine;
	    compilerHost.fileExists = fileExists;
	    compilerHost.onReleaseOldSourceFile = onReleaseOldSourceFile;
	    compilerHost.onReleaseParsedCommandLine = onReleaseParsedCommandLine;
	    compilerHost.toPath = toPath3;
	    compilerHost.getCompilationSettings = () => compilerOptions;
	    compilerHost.useSourceOfProjectReferenceRedirect = maybeBind(host, host.useSourceOfProjectReferenceRedirect);
	    compilerHost.watchDirectoryOfFailedLookupLocation = (dir, cb, flags) => watchDirectory(dir, cb, flags, watchOptions, WatchType.FailedLookupLocations);
	    compilerHost.watchAffectingFileLocation = (file, cb) => watchFile2(file, cb, 2e3 /* High */, watchOptions, WatchType.AffectingFileLocation);
	    compilerHost.watchTypeRootsDirectory = (dir, cb, flags) => watchDirectory(dir, cb, flags, watchOptions, WatchType.TypeRoots);
	    compilerHost.getCachedDirectoryStructureHost = () => cachedDirectoryStructureHost;
	    compilerHost.scheduleInvalidateResolutionsOfFailedLookupLocations = scheduleInvalidateResolutionsOfFailedLookupLocations;
	    compilerHost.onInvalidatedResolution = scheduleProgramUpdate;
	    compilerHost.onChangedAutomaticTypeDirectiveNames = scheduleProgramUpdate;
	    compilerHost.fileIsOpen = returnFalse;
	    compilerHost.getCurrentProgram = getCurrentProgram;
	    compilerHost.writeLog = writeLog;
	    compilerHost.getParsedCommandLine = getParsedCommandLine;
	    const resolutionCache = createResolutionCache(
	      compilerHost,
	      configFileName ? getDirectoryPath(getNormalizedAbsolutePath(configFileName, currentDirectory)) : currentDirectory,
	      /*logChangesWhenResolvingModule*/
	      false
	    );
	    compilerHost.resolveModuleNameLiterals = maybeBind(host, host.resolveModuleNameLiterals);
	    compilerHost.resolveModuleNames = maybeBind(host, host.resolveModuleNames);
	    if (!compilerHost.resolveModuleNameLiterals && !compilerHost.resolveModuleNames) {
	      compilerHost.resolveModuleNameLiterals = resolutionCache.resolveModuleNameLiterals.bind(resolutionCache);
	    }
	    compilerHost.resolveTypeReferenceDirectiveReferences = maybeBind(host, host.resolveTypeReferenceDirectiveReferences);
	    compilerHost.resolveTypeReferenceDirectives = maybeBind(host, host.resolveTypeReferenceDirectives);
	    if (!compilerHost.resolveTypeReferenceDirectiveReferences && !compilerHost.resolveTypeReferenceDirectives) {
	      compilerHost.resolveTypeReferenceDirectiveReferences = resolutionCache.resolveTypeReferenceDirectiveReferences.bind(resolutionCache);
	    }
	    compilerHost.resolveLibrary = !host.resolveLibrary ? resolutionCache.resolveLibrary.bind(resolutionCache) : host.resolveLibrary.bind(host);
	    compilerHost.getModuleResolutionCache = host.resolveModuleNameLiterals || host.resolveModuleNames ? maybeBind(host, host.getModuleResolutionCache) : () => resolutionCache.getModuleResolutionCache();
	    const userProvidedResolution = !!host.resolveModuleNameLiterals || !!host.resolveTypeReferenceDirectiveReferences || !!host.resolveModuleNames || !!host.resolveTypeReferenceDirectives;
	    const customHasInvalidatedResolutions = userProvidedResolution ? maybeBind(host, host.hasInvalidatedResolutions) || returnTrue : returnFalse;
	    const customHasInvalidLibResolutions = host.resolveLibrary ? maybeBind(host, host.hasInvalidatedLibResolutions) || returnTrue : returnFalse;
	    builderProgram = readBuilderProgram(compilerOptions, compilerHost);
	    synchronizeProgram();
	    watchConfigFileWildCardDirectories();
	    if (configFileName)
	      updateExtendedConfigFilesWatches(toPath3(configFileName), compilerOptions, watchOptions, WatchType.ExtendedConfigFile);
	    return configFileName ? { getCurrentProgram: getCurrentBuilderProgram, getProgram: updateProgram, close, getResolutionCache } : { getCurrentProgram: getCurrentBuilderProgram, getProgram: updateProgram, updateRootFileNames, close, getResolutionCache };
	    function close() {
	      clearInvalidateResolutionsOfFailedLookupLocations();
	      resolutionCache.clear();
	      clearMap(sourceFilesCache, (value) => {
	        if (value && value.fileWatcher) {
	          value.fileWatcher.close();
	          value.fileWatcher = void 0;
	        }
	      });
	      if (configFileWatcher) {
	        configFileWatcher.close();
	        configFileWatcher = void 0;
	      }
	      extendedConfigCache == null ? void 0 : extendedConfigCache.clear();
	      extendedConfigCache = void 0;
	      if (sharedExtendedConfigFileWatchers) {
	        clearMap(sharedExtendedConfigFileWatchers, closeFileWatcherOf);
	        sharedExtendedConfigFileWatchers = void 0;
	      }
	      if (watchedWildcardDirectories) {
	        clearMap(watchedWildcardDirectories, closeFileWatcherOf);
	        watchedWildcardDirectories = void 0;
	      }
	      if (missingFilesMap) {
	        clearMap(missingFilesMap, closeFileWatcher);
	        missingFilesMap = void 0;
	      }
	      if (parsedConfigs) {
	        clearMap(parsedConfigs, (config) => {
	          var _a;
	          (_a = config.watcher) == null ? void 0 : _a.close();
	          config.watcher = void 0;
	          if (config.watchedDirectories)
	            clearMap(config.watchedDirectories, closeFileWatcherOf);
	          config.watchedDirectories = void 0;
	        });
	        parsedConfigs = void 0;
	      }
	    }
	    function getResolutionCache() {
	      return resolutionCache;
	    }
	    function getCurrentBuilderProgram() {
	      return builderProgram;
	    }
	    function getCurrentProgram() {
	      return builderProgram && builderProgram.getProgramOrUndefined();
	    }
	    function synchronizeProgram() {
	      writeLog(`Synchronizing program`);
	      Debug.assert(compilerOptions);
	      Debug.assert(rootFileNames);
	      clearInvalidateResolutionsOfFailedLookupLocations();
	      const program = getCurrentBuilderProgram();
	      if (hasChangedCompilerOptions) {
	        newLine = updateNewLine();
	        if (program && changesAffectModuleResolution(program.getCompilerOptions(), compilerOptions)) {
	          resolutionCache.onChangesAffectModuleResolution();
	        }
	      }
	      const { hasInvalidatedResolutions, hasInvalidatedLibResolutions } = resolutionCache.createHasInvalidatedResolutions(customHasInvalidatedResolutions, customHasInvalidLibResolutions);
	      const {
	        originalReadFile,
	        originalFileExists,
	        originalDirectoryExists,
	        originalCreateDirectory,
	        originalWriteFile,
	        readFileWithCache
	      } = changeCompilerHostLikeToUseCache(compilerHost, toPath3);
	      if (isProgramUptoDate(getCurrentProgram(), rootFileNames, compilerOptions, (path) => getSourceVersion(path, readFileWithCache), (fileName) => compilerHost.fileExists(fileName), hasInvalidatedResolutions, hasInvalidatedLibResolutions, hasChangedAutomaticTypeDirectiveNames, getParsedCommandLine, projectReferences)) {
	        if (hasChangedConfigFileParsingErrors) {
	          if (reportFileChangeDetectedOnCreateProgram) {
	            reportWatchDiagnostic(Diagnostics.File_change_detected_Starting_incremental_compilation);
	          }
	          builderProgram = createProgram2(
	            /*rootNames*/
	            void 0,
	            /*options*/
	            void 0,
	            compilerHost,
	            builderProgram,
	            configFileParsingDiagnostics,
	            projectReferences
	          );
	          hasChangedConfigFileParsingErrors = false;
	        }
	      } else {
	        if (reportFileChangeDetectedOnCreateProgram) {
	          reportWatchDiagnostic(Diagnostics.File_change_detected_Starting_incremental_compilation);
	        }
	        createNewProgram(hasInvalidatedResolutions, hasInvalidatedLibResolutions);
	      }
	      reportFileChangeDetectedOnCreateProgram = false;
	      if (host.afterProgramCreate && program !== builderProgram) {
	        host.afterProgramCreate(builderProgram);
	      }
	      compilerHost.readFile = originalReadFile;
	      compilerHost.fileExists = originalFileExists;
	      compilerHost.directoryExists = originalDirectoryExists;
	      compilerHost.createDirectory = originalCreateDirectory;
	      compilerHost.writeFile = originalWriteFile;
	      return builderProgram;
	    }
	    function createNewProgram(hasInvalidatedResolutions, hasInvalidatedLibResolutions) {
	      writeLog("CreatingProgramWith::");
	      writeLog(`  roots: ${JSON.stringify(rootFileNames)}`);
	      writeLog(`  options: ${JSON.stringify(compilerOptions)}`);
	      if (projectReferences)
	        writeLog(`  projectReferences: ${JSON.stringify(projectReferences)}`);
	      const needsUpdateInTypeRootWatch = hasChangedCompilerOptions || !getCurrentProgram();
	      hasChangedCompilerOptions = false;
	      hasChangedConfigFileParsingErrors = false;
	      resolutionCache.startCachingPerDirectoryResolution();
	      compilerHost.hasInvalidatedResolutions = hasInvalidatedResolutions;
	      compilerHost.hasInvalidatedLibResolutions = hasInvalidatedLibResolutions;
	      compilerHost.hasChangedAutomaticTypeDirectiveNames = hasChangedAutomaticTypeDirectiveNames;
	      const oldProgram = getCurrentProgram();
	      builderProgram = createProgram2(rootFileNames, compilerOptions, compilerHost, builderProgram, configFileParsingDiagnostics, projectReferences);
	      resolutionCache.finishCachingPerDirectoryResolution(builderProgram.getProgram(), oldProgram);
	      updateMissingFilePathsWatch(
	        builderProgram.getProgram(),
	        missingFilesMap || (missingFilesMap = /* @__PURE__ */ new Map()),
	        watchMissingFilePath
	      );
	      if (needsUpdateInTypeRootWatch) {
	        resolutionCache.updateTypeRootsWatch();
	      }
	      if (missingFilePathsRequestedForRelease) {
	        for (const missingFilePath of missingFilePathsRequestedForRelease) {
	          if (!missingFilesMap.has(missingFilePath)) {
	            sourceFilesCache.delete(missingFilePath);
	          }
	        }
	        missingFilePathsRequestedForRelease = void 0;
	      }
	    }
	    function updateRootFileNames(files) {
	      Debug.assert(!configFileName, "Cannot update root file names with config file watch mode");
	      rootFileNames = files;
	      scheduleProgramUpdate();
	    }
	    function updateNewLine() {
	      return getNewLineCharacter(compilerOptions || optionsToExtendForConfigFile);
	    }
	    function toPath3(fileName) {
	      return toPath(fileName, currentDirectory, getCanonicalFileName);
	    }
	    function isFileMissingOnHost(hostSourceFile) {
	      return typeof hostSourceFile === "boolean";
	    }
	    function isFilePresenceUnknownOnHost(hostSourceFile) {
	      return typeof hostSourceFile.version === "boolean";
	    }
	    function fileExists(fileName) {
	      const path = toPath3(fileName);
	      if (isFileMissingOnHost(sourceFilesCache.get(path))) {
	        return false;
	      }
	      return directoryStructureHost.fileExists(fileName);
	    }
	    function getVersionedSourceFileByPath(fileName, path, languageVersionOrOptions, onError, shouldCreateNewSourceFile) {
	      const hostSourceFile = sourceFilesCache.get(path);
	      if (isFileMissingOnHost(hostSourceFile)) {
	        return void 0;
	      }
	      const impliedNodeFormat = typeof languageVersionOrOptions === "object" ? languageVersionOrOptions.impliedNodeFormat : void 0;
	      if (hostSourceFile === void 0 || shouldCreateNewSourceFile || isFilePresenceUnknownOnHost(hostSourceFile) || hostSourceFile.sourceFile.impliedNodeFormat !== impliedNodeFormat) {
	        const sourceFile = getNewSourceFile(fileName, languageVersionOrOptions, onError);
	        if (hostSourceFile) {
	          if (sourceFile) {
	            hostSourceFile.sourceFile = sourceFile;
	            hostSourceFile.version = sourceFile.version;
	            if (!hostSourceFile.fileWatcher) {
	              hostSourceFile.fileWatcher = watchFilePath(path, fileName, onSourceFileChange, 250 /* Low */, watchOptions, WatchType.SourceFile);
	            }
	          } else {
	            if (hostSourceFile.fileWatcher) {
	              hostSourceFile.fileWatcher.close();
	            }
	            sourceFilesCache.set(path, false);
	          }
	        } else {
	          if (sourceFile) {
	            const fileWatcher = watchFilePath(path, fileName, onSourceFileChange, 250 /* Low */, watchOptions, WatchType.SourceFile);
	            sourceFilesCache.set(path, { sourceFile, version: sourceFile.version, fileWatcher });
	          } else {
	            sourceFilesCache.set(path, false);
	          }
	        }
	        return sourceFile;
	      }
	      return hostSourceFile.sourceFile;
	    }
	    function nextSourceFileVersion(path) {
	      const hostSourceFile = sourceFilesCache.get(path);
	      if (hostSourceFile !== void 0) {
	        if (isFileMissingOnHost(hostSourceFile)) {
	          sourceFilesCache.set(path, { version: false });
	        } else {
	          hostSourceFile.version = false;
	        }
	      }
	    }
	    function getSourceVersion(path, readFileWithCache) {
	      const hostSourceFile = sourceFilesCache.get(path);
	      if (!hostSourceFile)
	        return void 0;
	      if (hostSourceFile.version)
	        return hostSourceFile.version;
	      const text = readFileWithCache(path);
	      return text !== void 0 ? getSourceFileVersionAsHashFromText(compilerHost, text) : void 0;
	    }
	    function onReleaseOldSourceFile(oldSourceFile, _oldOptions, hasSourceFileByPath) {
	      const hostSourceFileInfo = sourceFilesCache.get(oldSourceFile.resolvedPath);
	      if (hostSourceFileInfo !== void 0) {
	        if (isFileMissingOnHost(hostSourceFileInfo)) {
	          (missingFilePathsRequestedForRelease || (missingFilePathsRequestedForRelease = [])).push(oldSourceFile.path);
	        } else if (hostSourceFileInfo.sourceFile === oldSourceFile) {
	          if (hostSourceFileInfo.fileWatcher) {
	            hostSourceFileInfo.fileWatcher.close();
	          }
	          sourceFilesCache.delete(oldSourceFile.resolvedPath);
	          if (!hasSourceFileByPath) {
	            resolutionCache.removeResolutionsOfFile(oldSourceFile.path);
	          }
	        }
	      }
	    }
	    function reportWatchDiagnostic(message) {
	      if (host.onWatchStatusChange) {
	        host.onWatchStatusChange(createCompilerDiagnostic(message), newLine, compilerOptions || optionsToExtendForConfigFile);
	      }
	    }
	    function hasChangedAutomaticTypeDirectiveNames() {
	      return resolutionCache.hasChangedAutomaticTypeDirectiveNames();
	    }
	    function clearInvalidateResolutionsOfFailedLookupLocations() {
	      if (!timerToInvalidateFailedLookupResolutions)
	        return false;
	      host.clearTimeout(timerToInvalidateFailedLookupResolutions);
	      timerToInvalidateFailedLookupResolutions = void 0;
	      return true;
	    }
	    function scheduleInvalidateResolutionsOfFailedLookupLocations() {
	      if (!host.setTimeout || !host.clearTimeout) {
	        return resolutionCache.invalidateResolutionsOfFailedLookupLocations();
	      }
	      const pending = clearInvalidateResolutionsOfFailedLookupLocations();
	      writeLog(`Scheduling invalidateFailedLookup${pending ? ", Cancelled earlier one" : ""}`);
	      timerToInvalidateFailedLookupResolutions = host.setTimeout(invalidateResolutionsOfFailedLookup, 250, "timerToInvalidateFailedLookupResolutions");
	    }
	    function invalidateResolutionsOfFailedLookup() {
	      timerToInvalidateFailedLookupResolutions = void 0;
	      if (resolutionCache.invalidateResolutionsOfFailedLookupLocations()) {
	        scheduleProgramUpdate();
	      }
	    }
	    function scheduleProgramUpdate() {
	      if (!host.setTimeout || !host.clearTimeout) {
	        return;
	      }
	      if (timerToUpdateProgram) {
	        host.clearTimeout(timerToUpdateProgram);
	      }
	      writeLog("Scheduling update");
	      timerToUpdateProgram = host.setTimeout(updateProgramWithWatchStatus, 250, "timerToUpdateProgram");
	    }
	    function scheduleProgramReload() {
	      Debug.assert(!!configFileName);
	      updateLevel = 2 /* Full */;
	      scheduleProgramUpdate();
	    }
	    function updateProgramWithWatchStatus() {
	      timerToUpdateProgram = void 0;
	      reportFileChangeDetectedOnCreateProgram = true;
	      updateProgram();
	    }
	    function updateProgram() {
	      var _a, _b, _c, _d;
	      switch (updateLevel) {
	        case 1 /* RootNamesAndUpdate */:
	          (_a = perfLogger) == null ? void 0 : _a.logStartUpdateProgram("PartialConfigReload");
	          reloadFileNamesFromConfigFile();
	          break;
	        case 2 /* Full */:
	          (_b = perfLogger) == null ? void 0 : _b.logStartUpdateProgram("FullConfigReload");
	          reloadConfigFile();
	          break;
	        default:
	          (_c = perfLogger) == null ? void 0 : _c.logStartUpdateProgram("SynchronizeProgram");
	          synchronizeProgram();
	          break;
	      }
	      (_d = perfLogger) == null ? void 0 : _d.logStopUpdateProgram("Done");
	      return getCurrentBuilderProgram();
	    }
	    function reloadFileNamesFromConfigFile() {
	      writeLog("Reloading new file names and options");
	      Debug.assert(compilerOptions);
	      Debug.assert(configFileName);
	      updateLevel = 0 /* Update */;
	      rootFileNames = getFileNamesFromConfigSpecs(compilerOptions.configFile.configFileSpecs, getNormalizedAbsolutePath(getDirectoryPath(configFileName), currentDirectory), compilerOptions, parseConfigFileHost, extraFileExtensions);
	      if (updateErrorForNoInputFiles(rootFileNames, getNormalizedAbsolutePath(configFileName, currentDirectory), compilerOptions.configFile.configFileSpecs, configFileParsingDiagnostics, canConfigFileJsonReportNoInputFiles)) {
	        hasChangedConfigFileParsingErrors = true;
	      }
	      synchronizeProgram();
	    }
	    function reloadConfigFile() {
	      Debug.assert(configFileName);
	      writeLog(`Reloading config file: ${configFileName}`);
	      updateLevel = 0 /* Update */;
	      if (cachedDirectoryStructureHost) {
	        cachedDirectoryStructureHost.clearCache();
	      }
	      parseConfigFile2();
	      hasChangedCompilerOptions = true;
	      synchronizeProgram();
	      watchConfigFileWildCardDirectories();
	      updateExtendedConfigFilesWatches(toPath3(configFileName), compilerOptions, watchOptions, WatchType.ExtendedConfigFile);
	    }
	    function parseConfigFile2() {
	      Debug.assert(configFileName);
	      setConfigFileParsingResult(
	        getParsedCommandLineOfConfigFile(
	          configFileName,
	          optionsToExtendForConfigFile,
	          parseConfigFileHost,
	          extendedConfigCache || (extendedConfigCache = /* @__PURE__ */ new Map()),
	          watchOptionsToExtend,
	          extraFileExtensions
	        )
	      );
	    }
	    function setConfigFileParsingResult(configFileParseResult) {
	      rootFileNames = configFileParseResult.fileNames;
	      compilerOptions = configFileParseResult.options;
	      watchOptions = configFileParseResult.watchOptions;
	      projectReferences = configFileParseResult.projectReferences;
	      wildcardDirectories = configFileParseResult.wildcardDirectories;
	      configFileParsingDiagnostics = getConfigFileParsingDiagnostics(configFileParseResult).slice();
	      canConfigFileJsonReportNoInputFiles = canJsonReportNoInputFiles(configFileParseResult.raw);
	      hasChangedConfigFileParsingErrors = true;
	    }
	    function getParsedCommandLine(configFileName2) {
	      const configPath = toPath3(configFileName2);
	      let config = parsedConfigs == null ? void 0 : parsedConfigs.get(configPath);
	      if (config) {
	        if (!config.updateLevel)
	          return config.parsedCommandLine;
	        if (config.parsedCommandLine && config.updateLevel === 1 /* RootNamesAndUpdate */ && !host.getParsedCommandLine) {
	          writeLog("Reloading new file names and options");
	          Debug.assert(compilerOptions);
	          const fileNames = getFileNamesFromConfigSpecs(
	            config.parsedCommandLine.options.configFile.configFileSpecs,
	            getNormalizedAbsolutePath(getDirectoryPath(configFileName2), currentDirectory),
	            compilerOptions,
	            parseConfigFileHost
	          );
	          config.parsedCommandLine = { ...config.parsedCommandLine, fileNames };
	          config.updateLevel = void 0;
	          return config.parsedCommandLine;
	        }
	      }
	      writeLog(`Loading config file: ${configFileName2}`);
	      const parsedCommandLine = host.getParsedCommandLine ? host.getParsedCommandLine(configFileName2) : getParsedCommandLineFromConfigFileHost(configFileName2);
	      if (config) {
	        config.parsedCommandLine = parsedCommandLine;
	        config.updateLevel = void 0;
	      } else {
	        (parsedConfigs || (parsedConfigs = /* @__PURE__ */ new Map())).set(configPath, config = { parsedCommandLine });
	      }
	      watchReferencedProject(configFileName2, configPath, config);
	      return parsedCommandLine;
	    }
	    function getParsedCommandLineFromConfigFileHost(configFileName2) {
	      const onUnRecoverableConfigFileDiagnostic = parseConfigFileHost.onUnRecoverableConfigFileDiagnostic;
	      parseConfigFileHost.onUnRecoverableConfigFileDiagnostic = noop;
	      const parsedCommandLine = getParsedCommandLineOfConfigFile(
	        configFileName2,
	        /*optionsToExtend*/
	        void 0,
	        parseConfigFileHost,
	        extendedConfigCache || (extendedConfigCache = /* @__PURE__ */ new Map()),
	        watchOptionsToExtend
	      );
	      parseConfigFileHost.onUnRecoverableConfigFileDiagnostic = onUnRecoverableConfigFileDiagnostic;
	      return parsedCommandLine;
	    }
	    function onReleaseParsedCommandLine(fileName) {
	      var _a;
	      const path = toPath3(fileName);
	      const config = parsedConfigs == null ? void 0 : parsedConfigs.get(path);
	      if (!config)
	        return;
	      parsedConfigs.delete(path);
	      if (config.watchedDirectories)
	        clearMap(config.watchedDirectories, closeFileWatcherOf);
	      (_a = config.watcher) == null ? void 0 : _a.close();
	      clearSharedExtendedConfigFileWatcher(path, sharedExtendedConfigFileWatchers);
	    }
	    function watchFilePath(path, file, callback, pollingInterval, options, watchType) {
	      return watchFile2(file, (fileName, eventKind) => callback(fileName, eventKind, path), pollingInterval, options, watchType);
	    }
	    function onSourceFileChange(fileName, eventKind, path) {
	      updateCachedSystemWithFile(fileName, path, eventKind);
	      if (eventKind === 2 /* Deleted */ && sourceFilesCache.has(path)) {
	        resolutionCache.invalidateResolutionOfFile(path);
	      }
	      nextSourceFileVersion(path);
	      scheduleProgramUpdate();
	    }
	    function updateCachedSystemWithFile(fileName, path, eventKind) {
	      if (cachedDirectoryStructureHost) {
	        cachedDirectoryStructureHost.addOrDeleteFile(fileName, path, eventKind);
	      }
	    }
	    function watchMissingFilePath(missingFilePath, missingFileName) {
	      return (parsedConfigs == null ? void 0 : parsedConfigs.has(missingFilePath)) ? noopFileWatcher : watchFilePath(
	        missingFilePath,
	        missingFileName,
	        onMissingFileChange,
	        500 /* Medium */,
	        watchOptions,
	        WatchType.MissingFile
	      );
	    }
	    function onMissingFileChange(fileName, eventKind, missingFilePath) {
	      updateCachedSystemWithFile(fileName, missingFilePath, eventKind);
	      if (eventKind === 0 /* Created */ && missingFilesMap.has(missingFilePath)) {
	        missingFilesMap.get(missingFilePath).close();
	        missingFilesMap.delete(missingFilePath);
	        nextSourceFileVersion(missingFilePath);
	        scheduleProgramUpdate();
	      }
	    }
	    function watchConfigFileWildCardDirectories() {
	      updateWatchingWildcardDirectories(
	        watchedWildcardDirectories || (watchedWildcardDirectories = /* @__PURE__ */ new Map()),
	        wildcardDirectories,
	        watchWildcardDirectory
	      );
	    }
	    function watchWildcardDirectory(directory, flags) {
	      return watchDirectory(
	        directory,
	        (fileOrDirectory) => {
	          Debug.assert(configFileName);
	          Debug.assert(compilerOptions);
	          const fileOrDirectoryPath = toPath3(fileOrDirectory);
	          if (cachedDirectoryStructureHost) {
	            cachedDirectoryStructureHost.addOrDeleteFileOrDirectory(fileOrDirectory, fileOrDirectoryPath);
	          }
	          nextSourceFileVersion(fileOrDirectoryPath);
	          if (isIgnoredFileFromWildCardWatching({
	            watchedDirPath: toPath3(directory),
	            fileOrDirectory,
	            fileOrDirectoryPath,
	            configFileName,
	            extraFileExtensions,
	            options: compilerOptions,
	            program: getCurrentBuilderProgram() || rootFileNames,
	            currentDirectory,
	            useCaseSensitiveFileNames: useCaseSensitiveFileNames2,
	            writeLog,
	            toPath: toPath3
	          }))
	            return;
	          if (updateLevel !== 2 /* Full */) {
	            updateLevel = 1 /* RootNamesAndUpdate */;
	            scheduleProgramUpdate();
	          }
	        },
	        flags,
	        watchOptions,
	        WatchType.WildcardDirectory
	      );
	    }
	    function updateExtendedConfigFilesWatches(forProjectPath, options, watchOptions2, watchType) {
	      updateSharedExtendedConfigFileWatcher(
	        forProjectPath,
	        options,
	        sharedExtendedConfigFileWatchers || (sharedExtendedConfigFileWatchers = /* @__PURE__ */ new Map()),
	        (extendedConfigFileName, extendedConfigFilePath) => watchFile2(
	          extendedConfigFileName,
	          (_fileName, eventKind) => {
	            var _a;
	            updateCachedSystemWithFile(extendedConfigFileName, extendedConfigFilePath, eventKind);
	            if (extendedConfigCache)
	              cleanExtendedConfigCache(extendedConfigCache, extendedConfigFilePath, toPath3);
	            const projects = (_a = sharedExtendedConfigFileWatchers.get(extendedConfigFilePath)) == null ? void 0 : _a.projects;
	            if (!(projects == null ? void 0 : projects.size))
	              return;
	            projects.forEach((projectPath) => {
	              if (configFileName && toPath3(configFileName) === projectPath) {
	                updateLevel = 2 /* Full */;
	              } else {
	                const config = parsedConfigs == null ? void 0 : parsedConfigs.get(projectPath);
	                if (config)
	                  config.updateLevel = 2 /* Full */;
	                resolutionCache.removeResolutionsFromProjectReferenceRedirects(projectPath);
	              }
	              scheduleProgramUpdate();
	            });
	          },
	          2e3 /* High */,
	          watchOptions2,
	          watchType
	        ),
	        toPath3
	      );
	    }
	    function watchReferencedProject(configFileName2, configPath, commandLine) {
	      var _a, _b, _c, _d;
	      commandLine.watcher || (commandLine.watcher = watchFile2(
	        configFileName2,
	        (_fileName, eventKind) => {
	          updateCachedSystemWithFile(configFileName2, configPath, eventKind);
	          const config = parsedConfigs == null ? void 0 : parsedConfigs.get(configPath);
	          if (config)
	            config.updateLevel = 2 /* Full */;
	          resolutionCache.removeResolutionsFromProjectReferenceRedirects(configPath);
	          scheduleProgramUpdate();
	        },
	        2e3 /* High */,
	        ((_a = commandLine.parsedCommandLine) == null ? void 0 : _a.watchOptions) || watchOptions,
	        WatchType.ConfigFileOfReferencedProject
	      ));
	      updateWatchingWildcardDirectories(
	        commandLine.watchedDirectories || (commandLine.watchedDirectories = /* @__PURE__ */ new Map()),
	        (_b = commandLine.parsedCommandLine) == null ? void 0 : _b.wildcardDirectories,
	        (directory, flags) => {
	          var _a2;
	          return watchDirectory(
	            directory,
	            (fileOrDirectory) => {
	              const fileOrDirectoryPath = toPath3(fileOrDirectory);
	              if (cachedDirectoryStructureHost) {
	                cachedDirectoryStructureHost.addOrDeleteFileOrDirectory(fileOrDirectory, fileOrDirectoryPath);
	              }
	              nextSourceFileVersion(fileOrDirectoryPath);
	              const config = parsedConfigs == null ? void 0 : parsedConfigs.get(configPath);
	              if (!(config == null ? void 0 : config.parsedCommandLine))
	                return;
	              if (isIgnoredFileFromWildCardWatching({
	                watchedDirPath: toPath3(directory),
	                fileOrDirectory,
	                fileOrDirectoryPath,
	                configFileName: configFileName2,
	                options: config.parsedCommandLine.options,
	                program: config.parsedCommandLine.fileNames,
	                currentDirectory,
	                useCaseSensitiveFileNames: useCaseSensitiveFileNames2,
	                writeLog,
	                toPath: toPath3
	              }))
	                return;
	              if (config.updateLevel !== 2 /* Full */) {
	                config.updateLevel = 1 /* RootNamesAndUpdate */;
	                scheduleProgramUpdate();
	              }
	            },
	            flags,
	            ((_a2 = commandLine.parsedCommandLine) == null ? void 0 : _a2.watchOptions) || watchOptions,
	            WatchType.WildcardDirectoryOfReferencedProject
	          );
	        }
	      );
	      updateExtendedConfigFilesWatches(
	        configPath,
	        (_c = commandLine.parsedCommandLine) == null ? void 0 : _c.options,
	        ((_d = commandLine.parsedCommandLine) == null ? void 0 : _d.watchOptions) || watchOptions,
	        WatchType.ExtendedConfigOfReferencedProject
	      );
	    }
	  }
	  var init_watchPublic = __esm({
	    "src/compiler/watchPublic.ts"() {
	      init_ts2();
	    }
	  });

	  // src/compiler/tsbuild.ts
	  function resolveConfigFileProjectName(project) {
	    if (fileExtensionIs(project, ".json" /* Json */)) {
	      return project;
	    }
	    return combinePaths(project, "tsconfig.json");
	  }
	  var UpToDateStatusType;
	  var init_tsbuild = __esm({
	    "src/compiler/tsbuild.ts"() {
	      init_ts2();
	      UpToDateStatusType = /* @__PURE__ */ ((UpToDateStatusType2) => {
	        UpToDateStatusType2[UpToDateStatusType2["Unbuildable"] = 0] = "Unbuildable";
	        UpToDateStatusType2[UpToDateStatusType2["UpToDate"] = 1] = "UpToDate";
	        UpToDateStatusType2[UpToDateStatusType2["UpToDateWithUpstreamTypes"] = 2] = "UpToDateWithUpstreamTypes";
	        UpToDateStatusType2[UpToDateStatusType2["OutOfDateWithPrepend"] = 3] = "OutOfDateWithPrepend";
	        UpToDateStatusType2[UpToDateStatusType2["OutputMissing"] = 4] = "OutputMissing";
	        UpToDateStatusType2[UpToDateStatusType2["ErrorReadingFile"] = 5] = "ErrorReadingFile";
	        UpToDateStatusType2[UpToDateStatusType2["OutOfDateWithSelf"] = 6] = "OutOfDateWithSelf";
	        UpToDateStatusType2[UpToDateStatusType2["OutOfDateWithUpstream"] = 7] = "OutOfDateWithUpstream";
	        UpToDateStatusType2[UpToDateStatusType2["OutOfDateBuildInfo"] = 8] = "OutOfDateBuildInfo";
	        UpToDateStatusType2[UpToDateStatusType2["OutOfDateOptions"] = 9] = "OutOfDateOptions";
	        UpToDateStatusType2[UpToDateStatusType2["OutOfDateRoots"] = 10] = "OutOfDateRoots";
	        UpToDateStatusType2[UpToDateStatusType2["UpstreamOutOfDate"] = 11] = "UpstreamOutOfDate";
	        UpToDateStatusType2[UpToDateStatusType2["UpstreamBlocked"] = 12] = "UpstreamBlocked";
	        UpToDateStatusType2[UpToDateStatusType2["ComputingUpstream"] = 13] = "ComputingUpstream";
	        UpToDateStatusType2[UpToDateStatusType2["TsVersionOutputOfDate"] = 14] = "TsVersionOutputOfDate";
	        UpToDateStatusType2[UpToDateStatusType2["UpToDateWithInputFileText"] = 15] = "UpToDateWithInputFileText";
	        UpToDateStatusType2[UpToDateStatusType2["ContainerOnly"] = 16] = "ContainerOnly";
	        UpToDateStatusType2[UpToDateStatusType2["ForceBuild"] = 17] = "ForceBuild";
	        return UpToDateStatusType2;
	      })(UpToDateStatusType || {});
	    }
	  });

	  // src/compiler/tsbuildPublic.ts
	  function getOrCreateValueFromConfigFileMap(configFileMap, resolved, createT) {
	    const existingValue = configFileMap.get(resolved);
	    let newValue;
	    if (!existingValue) {
	      newValue = createT();
	      configFileMap.set(resolved, newValue);
	    }
	    return existingValue || newValue;
	  }
	  function getOrCreateValueMapFromConfigFileMap(configFileMap, resolved) {
	    return getOrCreateValueFromConfigFileMap(configFileMap, resolved, () => /* @__PURE__ */ new Map());
	  }
	  function getCurrentTime(host) {
	    return host.now ? host.now() : /* @__PURE__ */ new Date();
	  }
	  function isCircularBuildOrder(buildOrder) {
	    return !!buildOrder && !!buildOrder.buildOrder;
	  }
	  function getBuildOrderFromAnyBuildOrder(anyBuildOrder) {
	    return isCircularBuildOrder(anyBuildOrder) ? anyBuildOrder.buildOrder : anyBuildOrder;
	  }
	  function createBuilderStatusReporter(system, pretty) {
	    return (diagnostic) => {
	      let output = pretty ? `[${formatColorAndReset(getLocaleTimeString(system), "\x1B[90m" /* Grey */)}] ` : `${getLocaleTimeString(system)} - `;
	      output += `${flattenDiagnosticMessageText(diagnostic.messageText, system.newLine)}${system.newLine + system.newLine}`;
	      system.write(output);
	    };
	  }
	  function createSolutionBuilderHostBase(system, createProgram2, reportDiagnostic, reportSolutionBuilderStatus) {
	    const host = createProgramHost(system, createProgram2);
	    host.getModifiedTime = system.getModifiedTime ? (path) => system.getModifiedTime(path) : returnUndefined;
	    host.setModifiedTime = system.setModifiedTime ? (path, date) => system.setModifiedTime(path, date) : noop;
	    host.deleteFile = system.deleteFile ? (path) => system.deleteFile(path) : noop;
	    host.reportDiagnostic = reportDiagnostic || createDiagnosticReporter(system);
	    host.reportSolutionBuilderStatus = reportSolutionBuilderStatus || createBuilderStatusReporter(system);
	    host.now = maybeBind(system, system.now);
	    return host;
	  }
	  function createSolutionBuilderHost(system = sys, createProgram2, reportDiagnostic, reportSolutionBuilderStatus, reportErrorSummary2) {
	    const host = createSolutionBuilderHostBase(system, createProgram2, reportDiagnostic, reportSolutionBuilderStatus);
	    host.reportErrorSummary = reportErrorSummary2;
	    return host;
	  }
	  function createSolutionBuilderWithWatchHost(system = sys, createProgram2, reportDiagnostic, reportSolutionBuilderStatus, reportWatchStatus2) {
	    const host = createSolutionBuilderHostBase(system, createProgram2, reportDiagnostic, reportSolutionBuilderStatus);
	    const watchHost = createWatchHost(system, reportWatchStatus2);
	    copyProperties(host, watchHost);
	    return host;
	  }
	  function getCompilerOptionsOfBuildOptions(buildOptions) {
	    const result = {};
	    commonOptionsWithBuild.forEach((option) => {
	      if (hasProperty(buildOptions, option.name))
	        result[option.name] = buildOptions[option.name];
	    });
	    return result;
	  }
	  function createSolutionBuilder(host, rootNames, defaultOptions) {
	    return createSolutionBuilderWorker(
	      /*watch*/
	      false,
	      host,
	      rootNames,
	      defaultOptions
	    );
	  }
	  function createSolutionBuilderWithWatch(host, rootNames, defaultOptions, baseWatchOptions) {
	    return createSolutionBuilderWorker(
	      /*watch*/
	      true,
	      host,
	      rootNames,
	      defaultOptions,
	      baseWatchOptions
	    );
	  }
	  function createSolutionBuilderState(watch, hostOrHostWithWatch, rootNames, options, baseWatchOptions) {
	    const host = hostOrHostWithWatch;
	    const hostWithWatch = hostOrHostWithWatch;
	    const baseCompilerOptions = getCompilerOptionsOfBuildOptions(options);
	    const compilerHost = createCompilerHostFromProgramHost(host, () => state.projectCompilerOptions);
	    setGetSourceFileAsHashVersioned(compilerHost);
	    compilerHost.getParsedCommandLine = (fileName) => parseConfigFile(state, fileName, toResolvedConfigFilePath(state, fileName));
	    compilerHost.resolveModuleNameLiterals = maybeBind(host, host.resolveModuleNameLiterals);
	    compilerHost.resolveTypeReferenceDirectiveReferences = maybeBind(host, host.resolveTypeReferenceDirectiveReferences);
	    compilerHost.resolveLibrary = maybeBind(host, host.resolveLibrary);
	    compilerHost.resolveModuleNames = maybeBind(host, host.resolveModuleNames);
	    compilerHost.resolveTypeReferenceDirectives = maybeBind(host, host.resolveTypeReferenceDirectives);
	    compilerHost.getModuleResolutionCache = maybeBind(host, host.getModuleResolutionCache);
	    let moduleResolutionCache, typeReferenceDirectiveResolutionCache;
	    if (!compilerHost.resolveModuleNameLiterals && !compilerHost.resolveModuleNames) {
	      moduleResolutionCache = createModuleResolutionCache(compilerHost.getCurrentDirectory(), compilerHost.getCanonicalFileName);
	      compilerHost.resolveModuleNameLiterals = (moduleNames, containingFile, redirectedReference, options2, containingSourceFile) => loadWithModeAwareCache(
	        moduleNames,
	        containingFile,
	        redirectedReference,
	        options2,
	        containingSourceFile,
	        host,
	        moduleResolutionCache,
	        createModuleResolutionLoader
	      );
	      compilerHost.getModuleResolutionCache = () => moduleResolutionCache;
	    }
	    if (!compilerHost.resolveTypeReferenceDirectiveReferences && !compilerHost.resolveTypeReferenceDirectives) {
	      typeReferenceDirectiveResolutionCache = createTypeReferenceDirectiveResolutionCache(
	        compilerHost.getCurrentDirectory(),
	        compilerHost.getCanonicalFileName,
	        /*options*/
	        void 0,
	        moduleResolutionCache == null ? void 0 : moduleResolutionCache.getPackageJsonInfoCache(),
	        moduleResolutionCache == null ? void 0 : moduleResolutionCache.optionsToRedirectsKey
	      );
	      compilerHost.resolveTypeReferenceDirectiveReferences = (typeDirectiveNames, containingFile, redirectedReference, options2, containingSourceFile) => loadWithModeAwareCache(
	        typeDirectiveNames,
	        containingFile,
	        redirectedReference,
	        options2,
	        containingSourceFile,
	        host,
	        typeReferenceDirectiveResolutionCache,
	        createTypeReferenceResolutionLoader
	      );
	    }
	    let libraryResolutionCache;
	    if (!compilerHost.resolveLibrary) {
	      libraryResolutionCache = createModuleResolutionCache(
	        compilerHost.getCurrentDirectory(),
	        compilerHost.getCanonicalFileName,
	        /*options*/
	        void 0,
	        moduleResolutionCache == null ? void 0 : moduleResolutionCache.getPackageJsonInfoCache()
	      );
	      compilerHost.resolveLibrary = (libraryName, resolveFrom, options2) => resolveLibrary(
	        libraryName,
	        resolveFrom,
	        options2,
	        host,
	        libraryResolutionCache
	      );
	    }
	    compilerHost.getBuildInfo = (fileName, configFilePath) => getBuildInfo3(
	      state,
	      fileName,
	      toResolvedConfigFilePath(state, configFilePath),
	      /*modifiedTime*/
	      void 0
	    );
	    const { watchFile: watchFile2, watchDirectory, writeLog } = createWatchFactory(hostWithWatch, options);
	    const state = {
	      host,
	      hostWithWatch,
	      parseConfigFileHost: parseConfigHostFromCompilerHostLike(host),
	      write: maybeBind(host, host.trace),
	      // State of solution
	      options,
	      baseCompilerOptions,
	      rootNames,
	      baseWatchOptions,
	      resolvedConfigFilePaths: /* @__PURE__ */ new Map(),
	      configFileCache: /* @__PURE__ */ new Map(),
	      projectStatus: /* @__PURE__ */ new Map(),
	      extendedConfigCache: /* @__PURE__ */ new Map(),
	      buildInfoCache: /* @__PURE__ */ new Map(),
	      outputTimeStamps: /* @__PURE__ */ new Map(),
	      builderPrograms: /* @__PURE__ */ new Map(),
	      diagnostics: /* @__PURE__ */ new Map(),
	      projectPendingBuild: /* @__PURE__ */ new Map(),
	      projectErrorsReported: /* @__PURE__ */ new Map(),
	      compilerHost,
	      moduleResolutionCache,
	      typeReferenceDirectiveResolutionCache,
	      libraryResolutionCache,
	      // Mutable state
	      buildOrder: void 0,
	      readFileWithCache: (f) => host.readFile(f),
	      projectCompilerOptions: baseCompilerOptions,
	      cache: void 0,
	      allProjectBuildPending: true,
	      needsSummary: true,
	      watchAllProjectsPending: watch,
	      // Watch state
	      watch,
	      allWatchedWildcardDirectories: /* @__PURE__ */ new Map(),
	      allWatchedInputFiles: /* @__PURE__ */ new Map(),
	      allWatchedConfigFiles: /* @__PURE__ */ new Map(),
	      allWatchedExtendedConfigFiles: /* @__PURE__ */ new Map(),
	      allWatchedPackageJsonFiles: /* @__PURE__ */ new Map(),
	      filesWatched: /* @__PURE__ */ new Map(),
	      lastCachedPackageJsonLookups: /* @__PURE__ */ new Map(),
	      timerToBuildInvalidatedProject: void 0,
	      reportFileChangeDetected: false,
	      watchFile: watchFile2,
	      watchDirectory,
	      writeLog
	    };
	    return state;
	  }
	  function toPath2(state, fileName) {
	    return toPath(fileName, state.compilerHost.getCurrentDirectory(), state.compilerHost.getCanonicalFileName);
	  }
	  function toResolvedConfigFilePath(state, fileName) {
	    const { resolvedConfigFilePaths } = state;
	    const path = resolvedConfigFilePaths.get(fileName);
	    if (path !== void 0)
	      return path;
	    const resolvedPath = toPath2(state, fileName);
	    resolvedConfigFilePaths.set(fileName, resolvedPath);
	    return resolvedPath;
	  }
	  function isParsedCommandLine(entry) {
	    return !!entry.options;
	  }
	  function getCachedParsedConfigFile(state, configFilePath) {
	    const value = state.configFileCache.get(configFilePath);
	    return value && isParsedCommandLine(value) ? value : void 0;
	  }
	  function parseConfigFile(state, configFileName, configFilePath) {
	    const { configFileCache } = state;
	    const value = configFileCache.get(configFilePath);
	    if (value) {
	      return isParsedCommandLine(value) ? value : void 0;
	    }
	    mark("SolutionBuilder::beforeConfigFileParsing");
	    let diagnostic;
	    const { parseConfigFileHost, baseCompilerOptions, baseWatchOptions, extendedConfigCache, host } = state;
	    let parsed;
	    if (host.getParsedCommandLine) {
	      parsed = host.getParsedCommandLine(configFileName);
	      if (!parsed)
	        diagnostic = createCompilerDiagnostic(Diagnostics.File_0_not_found, configFileName);
	    } else {
	      parseConfigFileHost.onUnRecoverableConfigFileDiagnostic = (d) => diagnostic = d;
	      parsed = getParsedCommandLineOfConfigFile(configFileName, baseCompilerOptions, parseConfigFileHost, extendedConfigCache, baseWatchOptions);
	      parseConfigFileHost.onUnRecoverableConfigFileDiagnostic = noop;
	    }
	    configFileCache.set(configFilePath, parsed || diagnostic);
	    mark("SolutionBuilder::afterConfigFileParsing");
	    measure("SolutionBuilder::Config file parsing", "SolutionBuilder::beforeConfigFileParsing", "SolutionBuilder::afterConfigFileParsing");
	    return parsed;
	  }
	  function resolveProjectName(state, name) {
	    return resolveConfigFileProjectName(resolvePath(state.compilerHost.getCurrentDirectory(), name));
	  }
	  function createBuildOrder(state, roots) {
	    const temporaryMarks = /* @__PURE__ */ new Map();
	    const permanentMarks = /* @__PURE__ */ new Map();
	    const circularityReportStack = [];
	    let buildOrder;
	    let circularDiagnostics;
	    for (const root of roots) {
	      visit(root);
	    }
	    return circularDiagnostics ? { buildOrder: buildOrder || emptyArray, circularDiagnostics } : buildOrder || emptyArray;
	    function visit(configFileName, inCircularContext) {
	      const projPath = toResolvedConfigFilePath(state, configFileName);
	      if (permanentMarks.has(projPath))
	        return;
	      if (temporaryMarks.has(projPath)) {
	        if (!inCircularContext) {
	          (circularDiagnostics || (circularDiagnostics = [])).push(
	            createCompilerDiagnostic(
	              Diagnostics.Project_references_may_not_form_a_circular_graph_Cycle_detected_Colon_0,
	              circularityReportStack.join("\r\n")
	            )
	          );
	        }
	        return;
	      }
	      temporaryMarks.set(projPath, true);
	      circularityReportStack.push(configFileName);
	      const parsed = parseConfigFile(state, configFileName, projPath);
	      if (parsed && parsed.projectReferences) {
	        for (const ref of parsed.projectReferences) {
	          const resolvedRefPath = resolveProjectName(state, ref.path);
	          visit(resolvedRefPath, inCircularContext || ref.circular);
	        }
	      }
	      circularityReportStack.pop();
	      permanentMarks.set(projPath, true);
	      (buildOrder || (buildOrder = [])).push(configFileName);
	    }
	  }
	  function getBuildOrder(state) {
	    return state.buildOrder || createStateBuildOrder(state);
	  }
	  function createStateBuildOrder(state) {
	    const buildOrder = createBuildOrder(state, state.rootNames.map((f) => resolveProjectName(state, f)));
	    state.resolvedConfigFilePaths.clear();
	    const currentProjects = new Set(
	      getBuildOrderFromAnyBuildOrder(buildOrder).map(
	        (resolved) => toResolvedConfigFilePath(state, resolved)
	      )
	    );
	    const noopOnDelete = { onDeleteValue: noop };
	    mutateMapSkippingNewValues(state.configFileCache, currentProjects, noopOnDelete);
	    mutateMapSkippingNewValues(state.projectStatus, currentProjects, noopOnDelete);
	    mutateMapSkippingNewValues(state.builderPrograms, currentProjects, noopOnDelete);
	    mutateMapSkippingNewValues(state.diagnostics, currentProjects, noopOnDelete);
	    mutateMapSkippingNewValues(state.projectPendingBuild, currentProjects, noopOnDelete);
	    mutateMapSkippingNewValues(state.projectErrorsReported, currentProjects, noopOnDelete);
	    mutateMapSkippingNewValues(state.buildInfoCache, currentProjects, noopOnDelete);
	    mutateMapSkippingNewValues(state.outputTimeStamps, currentProjects, noopOnDelete);
	    mutateMapSkippingNewValues(state.lastCachedPackageJsonLookups, currentProjects, noopOnDelete);
	    if (state.watch) {
	      mutateMapSkippingNewValues(
	        state.allWatchedConfigFiles,
	        currentProjects,
	        { onDeleteValue: closeFileWatcher }
	      );
	      state.allWatchedExtendedConfigFiles.forEach((watcher) => {
	        watcher.projects.forEach((project) => {
	          if (!currentProjects.has(project)) {
	            watcher.projects.delete(project);
	          }
	        });
	        watcher.close();
	      });
	      mutateMapSkippingNewValues(
	        state.allWatchedWildcardDirectories,
	        currentProjects,
	        { onDeleteValue: (existingMap) => existingMap.forEach(closeFileWatcherOf) }
	      );
	      mutateMapSkippingNewValues(
	        state.allWatchedInputFiles,
	        currentProjects,
	        { onDeleteValue: (existingMap) => existingMap.forEach(closeFileWatcher) }
	      );
	      mutateMapSkippingNewValues(
	        state.allWatchedPackageJsonFiles,
	        currentProjects,
	        { onDeleteValue: (existingMap) => existingMap.forEach(closeFileWatcher) }
	      );
	    }
	    return state.buildOrder = buildOrder;
	  }
	  function getBuildOrderFor(state, project, onlyReferences) {
	    const resolvedProject = project && resolveProjectName(state, project);
	    const buildOrderFromState = getBuildOrder(state);
	    if (isCircularBuildOrder(buildOrderFromState))
	      return buildOrderFromState;
	    if (resolvedProject) {
	      const projectPath = toResolvedConfigFilePath(state, resolvedProject);
	      const projectIndex = findIndex(
	        buildOrderFromState,
	        (configFileName) => toResolvedConfigFilePath(state, configFileName) === projectPath
	      );
	      if (projectIndex === -1)
	        return void 0;
	    }
	    const buildOrder = resolvedProject ? createBuildOrder(state, [resolvedProject]) : buildOrderFromState;
	    Debug.assert(!isCircularBuildOrder(buildOrder));
	    Debug.assert(!onlyReferences || resolvedProject !== void 0);
	    Debug.assert(!onlyReferences || buildOrder[buildOrder.length - 1] === resolvedProject);
	    return onlyReferences ? buildOrder.slice(0, buildOrder.length - 1) : buildOrder;
	  }
	  function enableCache(state) {
	    if (state.cache) {
	      disableCache(state);
	    }
	    const { compilerHost, host } = state;
	    const originalReadFileWithCache = state.readFileWithCache;
	    const originalGetSourceFile = compilerHost.getSourceFile;
	    const {
	      originalReadFile,
	      originalFileExists,
	      originalDirectoryExists,
	      originalCreateDirectory,
	      originalWriteFile,
	      getSourceFileWithCache,
	      readFileWithCache
	    } = changeCompilerHostLikeToUseCache(
	      host,
	      (fileName) => toPath2(state, fileName),
	      (...args) => originalGetSourceFile.call(compilerHost, ...args)
	    );
	    state.readFileWithCache = readFileWithCache;
	    compilerHost.getSourceFile = getSourceFileWithCache;
	    state.cache = {
	      originalReadFile,
	      originalFileExists,
	      originalDirectoryExists,
	      originalCreateDirectory,
	      originalWriteFile,
	      originalReadFileWithCache,
	      originalGetSourceFile
	    };
	  }
	  function disableCache(state) {
	    if (!state.cache)
	      return;
	    const { cache, host, compilerHost, extendedConfigCache, moduleResolutionCache, typeReferenceDirectiveResolutionCache, libraryResolutionCache } = state;
	    host.readFile = cache.originalReadFile;
	    host.fileExists = cache.originalFileExists;
	    host.directoryExists = cache.originalDirectoryExists;
	    host.createDirectory = cache.originalCreateDirectory;
	    host.writeFile = cache.originalWriteFile;
	    compilerHost.getSourceFile = cache.originalGetSourceFile;
	    state.readFileWithCache = cache.originalReadFileWithCache;
	    extendedConfigCache.clear();
	    moduleResolutionCache == null ? void 0 : moduleResolutionCache.clear();
	    typeReferenceDirectiveResolutionCache == null ? void 0 : typeReferenceDirectiveResolutionCache.clear();
	    libraryResolutionCache == null ? void 0 : libraryResolutionCache.clear();
	    state.cache = void 0;
	  }
	  function clearProjectStatus(state, resolved) {
	    state.projectStatus.delete(resolved);
	    state.diagnostics.delete(resolved);
	  }
	  function addProjToQueue({ projectPendingBuild }, proj, updateLevel) {
	    const value = projectPendingBuild.get(proj);
	    if (value === void 0) {
	      projectPendingBuild.set(proj, updateLevel);
	    } else if (value < updateLevel) {
	      projectPendingBuild.set(proj, updateLevel);
	    }
	  }
	  function setupInitialBuild(state, cancellationToken) {
	    if (!state.allProjectBuildPending)
	      return;
	    state.allProjectBuildPending = false;
	    if (state.options.watch)
	      reportWatchStatus(state, Diagnostics.Starting_compilation_in_watch_mode);
	    enableCache(state);
	    const buildOrder = getBuildOrderFromAnyBuildOrder(getBuildOrder(state));
	    buildOrder.forEach(
	      (configFileName) => state.projectPendingBuild.set(
	        toResolvedConfigFilePath(state, configFileName),
	        0 /* Update */
	      )
	    );
	    if (cancellationToken) {
	      cancellationToken.throwIfCancellationRequested();
	    }
	  }
	  function doneInvalidatedProject(state, projectPath) {
	    state.projectPendingBuild.delete(projectPath);
	    return state.diagnostics.has(projectPath) ? 1 /* DiagnosticsPresent_OutputsSkipped */ : 0 /* Success */;
	  }
	  function createUpdateOutputFileStampsProject(state, project, projectPath, config, buildOrder) {
	    let updateOutputFileStampsPending = true;
	    return {
	      kind: 2 /* UpdateOutputFileStamps */,
	      project,
	      projectPath,
	      buildOrder,
	      getCompilerOptions: () => config.options,
	      getCurrentDirectory: () => state.compilerHost.getCurrentDirectory(),
	      updateOutputFileStatmps: () => {
	        updateOutputTimestamps(state, config, projectPath);
	        updateOutputFileStampsPending = false;
	      },
	      done: () => {
	        if (updateOutputFileStampsPending) {
	          updateOutputTimestamps(state, config, projectPath);
	        }
	        mark("SolutionBuilder::Timestamps only updates");
	        return doneInvalidatedProject(state, projectPath);
	      }
	    };
	  }
	  function createBuildOrUpdateInvalidedProject(kind, state, project, projectPath, projectIndex, config, buildOrder) {
	    let step = kind === 0 /* Build */ ? 0 /* CreateProgram */ : 4 /* EmitBundle */;
	    let program;
	    let buildResult;
	    let invalidatedProjectOfBundle;
	    return kind === 0 /* Build */ ? {
	      kind,
	      project,
	      projectPath,
	      buildOrder,
	      getCompilerOptions: () => config.options,
	      getCurrentDirectory: () => state.compilerHost.getCurrentDirectory(),
	      getBuilderProgram: () => withProgramOrUndefined(identity),
	      getProgram: () => withProgramOrUndefined(
	        (program2) => program2.getProgramOrUndefined()
	      ),
	      getSourceFile: (fileName) => withProgramOrUndefined(
	        (program2) => program2.getSourceFile(fileName)
	      ),
	      getSourceFiles: () => withProgramOrEmptyArray(
	        (program2) => program2.getSourceFiles()
	      ),
	      getOptionsDiagnostics: (cancellationToken) => withProgramOrEmptyArray(
	        (program2) => program2.getOptionsDiagnostics(cancellationToken)
	      ),
	      getGlobalDiagnostics: (cancellationToken) => withProgramOrEmptyArray(
	        (program2) => program2.getGlobalDiagnostics(cancellationToken)
	      ),
	      getConfigFileParsingDiagnostics: () => withProgramOrEmptyArray(
	        (program2) => program2.getConfigFileParsingDiagnostics()
	      ),
	      getSyntacticDiagnostics: (sourceFile, cancellationToken) => withProgramOrEmptyArray(
	        (program2) => program2.getSyntacticDiagnostics(sourceFile, cancellationToken)
	      ),
	      getAllDependencies: (sourceFile) => withProgramOrEmptyArray(
	        (program2) => program2.getAllDependencies(sourceFile)
	      ),
	      getSemanticDiagnostics: (sourceFile, cancellationToken) => withProgramOrEmptyArray(
	        (program2) => program2.getSemanticDiagnostics(sourceFile, cancellationToken)
	      ),
	      getSemanticDiagnosticsOfNextAffectedFile: (cancellationToken, ignoreSourceFile) => withProgramOrUndefined(
	        (program2) => program2.getSemanticDiagnosticsOfNextAffectedFile && program2.getSemanticDiagnosticsOfNextAffectedFile(cancellationToken, ignoreSourceFile)
	      ),
	      emit: (targetSourceFile, writeFile2, cancellationToken, emitOnlyDtsFiles, customTransformers) => {
	        if (targetSourceFile || emitOnlyDtsFiles) {
	          return withProgramOrUndefined(
	            (program2) => {
	              var _a, _b;
	              return program2.emit(targetSourceFile, writeFile2, cancellationToken, emitOnlyDtsFiles, customTransformers || ((_b = (_a = state.host).getCustomTransformers) == null ? void 0 : _b.call(_a, project)));
	            }
	          );
	        }
	        executeSteps(2 /* SemanticDiagnostics */, cancellationToken);
	        if (step === 5 /* EmitBuildInfo */) {
	          return emitBuildInfo(writeFile2, cancellationToken);
	        }
	        if (step !== 3 /* Emit */)
	          return void 0;
	        return emit(writeFile2, cancellationToken, customTransformers);
	      },
	      done
	    } : {
	      kind,
	      project,
	      projectPath,
	      buildOrder,
	      getCompilerOptions: () => config.options,
	      getCurrentDirectory: () => state.compilerHost.getCurrentDirectory(),
	      emit: (writeFile2, customTransformers) => {
	        if (step !== 4 /* EmitBundle */)
	          return invalidatedProjectOfBundle;
	        return emitBundle(writeFile2, customTransformers);
	      },
	      done
	    };
	    function done(cancellationToken, writeFile2, customTransformers) {
	      executeSteps(8 /* Done */, cancellationToken, writeFile2, customTransformers);
	      if (kind === 0 /* Build */)
	        mark("SolutionBuilder::Projects built");
	      else
	        mark("SolutionBuilder::Bundles updated");
	      return doneInvalidatedProject(state, projectPath);
	    }
	    function withProgramOrUndefined(action) {
	      executeSteps(0 /* CreateProgram */);
	      return program && action(program);
	    }
	    function withProgramOrEmptyArray(action) {
	      return withProgramOrUndefined(action) || emptyArray;
	    }
	    function createProgram2() {
	      var _a, _b, _c;
	      Debug.assert(program === void 0);
	      if (state.options.dry) {
	        reportStatus(state, Diagnostics.A_non_dry_build_would_build_project_0, project);
	        buildResult = 1 /* Success */;
	        step = 7 /* QueueReferencingProjects */;
	        return;
	      }
	      if (state.options.verbose)
	        reportStatus(state, Diagnostics.Building_project_0, project);
	      if (config.fileNames.length === 0) {
	        reportAndStoreErrors(state, projectPath, getConfigFileParsingDiagnostics(config));
	        buildResult = 0 /* None */;
	        step = 7 /* QueueReferencingProjects */;
	        return;
	      }
	      const { host, compilerHost } = state;
	      state.projectCompilerOptions = config.options;
	      (_a = state.moduleResolutionCache) == null ? void 0 : _a.update(config.options);
	      (_b = state.typeReferenceDirectiveResolutionCache) == null ? void 0 : _b.update(config.options);
	      program = host.createProgram(
	        config.fileNames,
	        config.options,
	        compilerHost,
	        getOldProgram(state, projectPath, config),
	        getConfigFileParsingDiagnostics(config),
	        config.projectReferences
	      );
	      if (state.watch) {
	        const internalMap = (_c = state.moduleResolutionCache) == null ? void 0 : _c.getPackageJsonInfoCache().getInternalMap();
	        state.lastCachedPackageJsonLookups.set(
	          projectPath,
	          internalMap && new Set(arrayFrom(
	            internalMap.values(),
	            (data) => state.host.realpath && (isPackageJsonInfo(data) || data.directoryExists) ? state.host.realpath(combinePaths(data.packageDirectory, "package.json")) : combinePaths(data.packageDirectory, "package.json")
	          ))
	        );
	        state.builderPrograms.set(projectPath, program);
	      }
	      step++;
	    }
	    function handleDiagnostics(diagnostics, errorFlags, errorType) {
	      if (diagnostics.length) {
	        ({ buildResult, step } = buildErrors(
	          state,
	          projectPath,
	          program,
	          config,
	          diagnostics,
	          errorFlags,
	          errorType
	        ));
	      } else {
	        step++;
	      }
	    }
	    function getSyntaxDiagnostics(cancellationToken) {
	      Debug.assertIsDefined(program);
	      handleDiagnostics(
	        [
	          ...program.getConfigFileParsingDiagnostics(),
	          ...program.getOptionsDiagnostics(cancellationToken),
	          ...program.getGlobalDiagnostics(cancellationToken),
	          ...program.getSyntacticDiagnostics(
	            /*sourceFile*/
	            void 0,
	            cancellationToken
	          )
	        ],
	        8 /* SyntaxErrors */,
	        "Syntactic"
	      );
	    }
	    function getSemanticDiagnostics(cancellationToken) {
	      handleDiagnostics(
	        Debug.checkDefined(program).getSemanticDiagnostics(
	          /*sourceFile*/
	          void 0,
	          cancellationToken
	        ),
	        16 /* TypeErrors */,
	        "Semantic"
	      );
	    }
	    function emit(writeFileCallback, cancellationToken, customTransformers) {
	      var _a, _b, _c;
	      Debug.assertIsDefined(program);
	      Debug.assert(step === 3 /* Emit */);
	      const saved = program.saveEmitState();
	      let declDiagnostics;
	      const reportDeclarationDiagnostics = (d) => (declDiagnostics || (declDiagnostics = [])).push(d);
	      const outputFiles = [];
	      const { emitResult } = emitFilesAndReportErrors(
	        program,
	        reportDeclarationDiagnostics,
	        /*write*/
	        void 0,
	        /*reportSummary*/
	        void 0,
	        (name, text, writeByteOrderMark, _onError, _sourceFiles, data) => outputFiles.push({ name, text, writeByteOrderMark, data }),
	        cancellationToken,
	        /*emitOnlyDtsFiles*/
	        false,
	        customTransformers || ((_b = (_a = state.host).getCustomTransformers) == null ? void 0 : _b.call(_a, project))
	      );
	      if (declDiagnostics) {
	        program.restoreEmitState(saved);
	        ({ buildResult, step } = buildErrors(
	          state,
	          projectPath,
	          program,
	          config,
	          declDiagnostics,
	          32 /* DeclarationEmitErrors */,
	          "Declaration file"
	        ));
	        return {
	          emitSkipped: true,
	          diagnostics: emitResult.diagnostics
	        };
	      }
	      const { host, compilerHost } = state;
	      const resultFlags = ((_c = program.hasChangedEmitSignature) == null ? void 0 : _c.call(program)) ? 0 /* None */ : 2 /* DeclarationOutputUnchanged */;
	      const emitterDiagnostics = createDiagnosticCollection();
	      const emittedOutputs = /* @__PURE__ */ new Map();
	      const options = program.getCompilerOptions();
	      const isIncremental = isIncrementalCompilation(options);
	      let outputTimeStampMap;
	      let now;
	      outputFiles.forEach(({ name, text, writeByteOrderMark, data }) => {
	        const path = toPath2(state, name);
	        emittedOutputs.set(toPath2(state, name), name);
	        if (data == null ? void 0 : data.buildInfo)
	          setBuildInfo(state, data.buildInfo, projectPath, options, resultFlags);
	        const modifiedTime = (data == null ? void 0 : data.differsOnlyInMap) ? getModifiedTime(state.host, name) : void 0;
	        writeFile(writeFileCallback ? { writeFile: writeFileCallback } : compilerHost, emitterDiagnostics, name, text, writeByteOrderMark);
	        if (data == null ? void 0 : data.differsOnlyInMap)
	          state.host.setModifiedTime(name, modifiedTime);
	        else if (!isIncremental && state.watch) {
	          (outputTimeStampMap || (outputTimeStampMap = getOutputTimeStampMap(state, projectPath))).set(path, now || (now = getCurrentTime(state.host)));
	        }
	      });
	      finishEmit(
	        emitterDiagnostics,
	        emittedOutputs,
	        outputFiles.length ? outputFiles[0].name : getFirstProjectOutput(config, !host.useCaseSensitiveFileNames()),
	        resultFlags
	      );
	      return emitResult;
	    }
	    function emitBuildInfo(writeFileCallback, cancellationToken) {
	      Debug.assertIsDefined(program);
	      Debug.assert(step === 5 /* EmitBuildInfo */);
	      const emitResult = program.emitBuildInfo((name, text, writeByteOrderMark, onError, sourceFiles, data) => {
	        if (data == null ? void 0 : data.buildInfo)
	          setBuildInfo(state, data.buildInfo, projectPath, program.getCompilerOptions(), 2 /* DeclarationOutputUnchanged */);
	        if (writeFileCallback)
	          writeFileCallback(name, text, writeByteOrderMark, onError, sourceFiles, data);
	        else
	          state.compilerHost.writeFile(name, text, writeByteOrderMark, onError, sourceFiles, data);
	      }, cancellationToken);
	      if (emitResult.diagnostics.length) {
	        reportErrors(state, emitResult.diagnostics);
	        state.diagnostics.set(projectPath, [...state.diagnostics.get(projectPath), ...emitResult.diagnostics]);
	        buildResult = 64 /* EmitErrors */ & buildResult;
	      }
	      if (emitResult.emittedFiles && state.write) {
	        emitResult.emittedFiles.forEach((name) => listEmittedFile(state, config, name));
	      }
	      afterProgramDone(state, program, config);
	      step = 7 /* QueueReferencingProjects */;
	      return emitResult;
	    }
	    function finishEmit(emitterDiagnostics, emittedOutputs, oldestOutputFileName, resultFlags) {
	      const emitDiagnostics = emitterDiagnostics.getDiagnostics();
	      if (emitDiagnostics.length) {
	        ({ buildResult, step } = buildErrors(
	          state,
	          projectPath,
	          program,
	          config,
	          emitDiagnostics,
	          64 /* EmitErrors */,
	          "Emit"
	        ));
	        return emitDiagnostics;
	      }
	      if (state.write) {
	        emittedOutputs.forEach((name) => listEmittedFile(state, config, name));
	      }
	      updateOutputTimestampsWorker(state, config, projectPath, Diagnostics.Updating_unchanged_output_timestamps_of_project_0, emittedOutputs);
	      state.diagnostics.delete(projectPath);
	      state.projectStatus.set(projectPath, {
	        type: 1 /* UpToDate */,
	        oldestOutputFileName
	      });
	      afterProgramDone(state, program, config);
	      step = 7 /* QueueReferencingProjects */;
	      buildResult = resultFlags;
	      return emitDiagnostics;
	    }
	    function emitBundle(writeFileCallback, customTransformers) {
	      var _a, _b, _c, _d;
	      Debug.assert(kind === 1 /* UpdateBundle */);
	      if (state.options.dry) {
	        reportStatus(state, Diagnostics.A_non_dry_build_would_update_output_of_project_0, project);
	        buildResult = 1 /* Success */;
	        step = 7 /* QueueReferencingProjects */;
	        return void 0;
	      }
	      if (state.options.verbose)
	        reportStatus(state, Diagnostics.Updating_output_of_project_0, project);
	      const { compilerHost } = state;
	      state.projectCompilerOptions = config.options;
	      (_b = (_a = state.host).beforeEmitBundle) == null ? void 0 : _b.call(_a, config);
	      const outputFiles = emitUsingBuildInfo(
	        config,
	        compilerHost,
	        (ref) => {
	          const refName = resolveProjectName(state, ref.path);
	          return parseConfigFile(state, refName, toResolvedConfigFilePath(state, refName));
	        },
	        customTransformers || ((_d = (_c = state.host).getCustomTransformers) == null ? void 0 : _d.call(_c, project))
	      );
	      if (isString(outputFiles)) {
	        reportStatus(state, Diagnostics.Cannot_update_output_of_project_0_because_there_was_error_reading_file_1, project, relName(state, outputFiles));
	        step = 6 /* BuildInvalidatedProjectOfBundle */;
	        return invalidatedProjectOfBundle = createBuildOrUpdateInvalidedProject(
	          0 /* Build */,
	          state,
	          project,
	          projectPath,
	          projectIndex,
	          config,
	          buildOrder
	        );
	      }
	      Debug.assert(!!outputFiles.length);
	      const emitterDiagnostics = createDiagnosticCollection();
	      const emittedOutputs = /* @__PURE__ */ new Map();
	      let resultFlags = 2 /* DeclarationOutputUnchanged */;
	      const existingBuildInfo = state.buildInfoCache.get(projectPath).buildInfo || void 0;
	      outputFiles.forEach(({ name, text, writeByteOrderMark, data }) => {
	        var _a2, _b2;
	        emittedOutputs.set(toPath2(state, name), name);
	        if (data == null ? void 0 : data.buildInfo) {
	          if (((_a2 = data.buildInfo.program) == null ? void 0 : _a2.outSignature) !== ((_b2 = existingBuildInfo == null ? void 0 : existingBuildInfo.program) == null ? void 0 : _b2.outSignature)) {
	            resultFlags &= ~2 /* DeclarationOutputUnchanged */;
	          }
	          setBuildInfo(state, data.buildInfo, projectPath, config.options, resultFlags);
	        }
	        writeFile(writeFileCallback ? { writeFile: writeFileCallback } : compilerHost, emitterDiagnostics, name, text, writeByteOrderMark);
	      });
	      const emitDiagnostics = finishEmit(
	        emitterDiagnostics,
	        emittedOutputs,
	        outputFiles[0].name,
	        resultFlags
	      );
	      return { emitSkipped: false, diagnostics: emitDiagnostics };
	    }
	    function executeSteps(till, cancellationToken, writeFile2, customTransformers) {
	      while (step <= till && step < 8 /* Done */) {
	        const currentStep = step;
	        switch (step) {
	          case 0 /* CreateProgram */:
	            createProgram2();
	            break;
	          case 1 /* SyntaxDiagnostics */:
	            getSyntaxDiagnostics(cancellationToken);
	            break;
	          case 2 /* SemanticDiagnostics */:
	            getSemanticDiagnostics(cancellationToken);
	            break;
	          case 3 /* Emit */:
	            emit(writeFile2, cancellationToken, customTransformers);
	            break;
	          case 5 /* EmitBuildInfo */:
	            emitBuildInfo(writeFile2, cancellationToken);
	            break;
	          case 4 /* EmitBundle */:
	            emitBundle(writeFile2, customTransformers);
	            break;
	          case 6 /* BuildInvalidatedProjectOfBundle */:
	            Debug.checkDefined(invalidatedProjectOfBundle).done(cancellationToken, writeFile2, customTransformers);
	            step = 8 /* Done */;
	            break;
	          case 7 /* QueueReferencingProjects */:
	            queueReferencingProjects(state, project, projectPath, projectIndex, config, buildOrder, Debug.checkDefined(buildResult));
	            step++;
	            break;
	        }
	        Debug.assert(step > currentStep);
	      }
	    }
	  }
	  function needsBuild({ options }, status, config) {
	    if (status.type !== 3 /* OutOfDateWithPrepend */ || options.force)
	      return true;
	    return config.fileNames.length === 0 || !!getConfigFileParsingDiagnostics(config).length || !isIncrementalCompilation(config.options);
	  }
	  function getNextInvalidatedProjectCreateInfo(state, buildOrder, reportQueue) {
	    if (!state.projectPendingBuild.size)
	      return void 0;
	    if (isCircularBuildOrder(buildOrder))
	      return void 0;
	    const { options, projectPendingBuild } = state;
	    for (let projectIndex = 0; projectIndex < buildOrder.length; projectIndex++) {
	      const project = buildOrder[projectIndex];
	      const projectPath = toResolvedConfigFilePath(state, project);
	      const updateLevel = state.projectPendingBuild.get(projectPath);
	      if (updateLevel === void 0)
	        continue;
	      if (reportQueue) {
	        reportQueue = false;
	        reportBuildQueue(state, buildOrder);
	      }
	      const config = parseConfigFile(state, project, projectPath);
	      if (!config) {
	        reportParseConfigFileDiagnostic(state, projectPath);
	        projectPendingBuild.delete(projectPath);
	        continue;
	      }
	      if (updateLevel === 2 /* Full */) {
	        watchConfigFile(state, project, projectPath, config);
	        watchExtendedConfigFiles(state, projectPath, config);
	        watchWildCardDirectories(state, project, projectPath, config);
	        watchInputFiles(state, project, projectPath, config);
	        watchPackageJsonFiles(state, project, projectPath, config);
	      } else if (updateLevel === 1 /* RootNamesAndUpdate */) {
	        config.fileNames = getFileNamesFromConfigSpecs(config.options.configFile.configFileSpecs, getDirectoryPath(project), config.options, state.parseConfigFileHost);
	        updateErrorForNoInputFiles(config.fileNames, project, config.options.configFile.configFileSpecs, config.errors, canJsonReportNoInputFiles(config.raw));
	        watchInputFiles(state, project, projectPath, config);
	        watchPackageJsonFiles(state, project, projectPath, config);
	      }
	      const status = getUpToDateStatus(state, config, projectPath);
	      if (!options.force) {
	        if (status.type === 1 /* UpToDate */) {
	          verboseReportProjectStatus(state, project, status);
	          reportAndStoreErrors(state, projectPath, getConfigFileParsingDiagnostics(config));
	          projectPendingBuild.delete(projectPath);
	          if (options.dry) {
	            reportStatus(state, Diagnostics.Project_0_is_up_to_date, project);
	          }
	          continue;
	        }
	        if (status.type === 2 /* UpToDateWithUpstreamTypes */ || status.type === 15 /* UpToDateWithInputFileText */) {
	          reportAndStoreErrors(state, projectPath, getConfigFileParsingDiagnostics(config));
	          return {
	            kind: 2 /* UpdateOutputFileStamps */,
	            status,
	            project,
	            projectPath,
	            projectIndex,
	            config
	          };
	        }
	      }
	      if (status.type === 12 /* UpstreamBlocked */) {
	        verboseReportProjectStatus(state, project, status);
	        reportAndStoreErrors(state, projectPath, getConfigFileParsingDiagnostics(config));
	        projectPendingBuild.delete(projectPath);
	        if (options.verbose) {
	          reportStatus(
	            state,
	            status.upstreamProjectBlocked ? Diagnostics.Skipping_build_of_project_0_because_its_dependency_1_was_not_built : Diagnostics.Skipping_build_of_project_0_because_its_dependency_1_has_errors,
	            project,
	            status.upstreamProjectName
	          );
	        }
	        continue;
	      }
	      if (status.type === 16 /* ContainerOnly */) {
	        verboseReportProjectStatus(state, project, status);
	        reportAndStoreErrors(state, projectPath, getConfigFileParsingDiagnostics(config));
	        projectPendingBuild.delete(projectPath);
	        continue;
	      }
	      return {
	        kind: needsBuild(state, status, config) ? 0 /* Build */ : 1 /* UpdateBundle */,
	        status,
	        project,
	        projectPath,
	        projectIndex,
	        config
	      };
	    }
	    return void 0;
	  }
	  function createInvalidatedProjectWithInfo(state, info, buildOrder) {
	    verboseReportProjectStatus(state, info.project, info.status);
	    return info.kind !== 2 /* UpdateOutputFileStamps */ ? createBuildOrUpdateInvalidedProject(
	      info.kind,
	      state,
	      info.project,
	      info.projectPath,
	      info.projectIndex,
	      info.config,
	      buildOrder
	    ) : createUpdateOutputFileStampsProject(
	      state,
	      info.project,
	      info.projectPath,
	      info.config,
	      buildOrder
	    );
	  }
	  function getNextInvalidatedProject(state, buildOrder, reportQueue) {
	    const info = getNextInvalidatedProjectCreateInfo(state, buildOrder, reportQueue);
	    if (!info)
	      return info;
	    return createInvalidatedProjectWithInfo(state, info, buildOrder);
	  }
	  function listEmittedFile({ write }, proj, file) {
	    if (write && proj.options.listEmittedFiles) {
	      write(`TSFILE: ${file}`);
	    }
	  }
	  function getOldProgram({ options, builderPrograms, compilerHost }, proj, parsed) {
	    if (options.force)
	      return void 0;
	    const value = builderPrograms.get(proj);
	    if (value)
	      return value;
	    return readBuilderProgram(parsed.options, compilerHost);
	  }
	  function afterProgramDone(state, program, config) {
	    if (program) {
	      if (state.write)
	        listFiles(program, state.write);
	      if (state.host.afterProgramEmitAndDiagnostics) {
	        state.host.afterProgramEmitAndDiagnostics(program);
	      }
	      program.releaseProgram();
	    } else if (state.host.afterEmitBundle) {
	      state.host.afterEmitBundle(config);
	    }
	    state.projectCompilerOptions = state.baseCompilerOptions;
	  }
	  function buildErrors(state, resolvedPath, program, config, diagnostics, buildResult, errorType) {
	    const canEmitBuildInfo = program && !outFile(program.getCompilerOptions());
	    reportAndStoreErrors(state, resolvedPath, diagnostics);
	    state.projectStatus.set(resolvedPath, { type: 0 /* Unbuildable */, reason: `${errorType} errors` });
	    if (canEmitBuildInfo)
	      return { buildResult, step: 5 /* EmitBuildInfo */ };
	    afterProgramDone(state, program, config);
	    return { buildResult, step: 7 /* QueueReferencingProjects */ };
	  }
	  function isFileWatcherWithModifiedTime(value) {
	    return !!value.watcher;
	  }
	  function getModifiedTime2(state, fileName) {
	    const path = toPath2(state, fileName);
	    const existing = state.filesWatched.get(path);
	    if (state.watch && !!existing) {
	      if (!isFileWatcherWithModifiedTime(existing))
	        return existing;
	      if (existing.modifiedTime)
	        return existing.modifiedTime;
	    }
	    const result = getModifiedTime(state.host, fileName);
	    if (state.watch) {
	      if (existing)
	        existing.modifiedTime = result;
	      else
	        state.filesWatched.set(path, result);
	    }
	    return result;
	  }
	  function watchFile(state, file, callback, pollingInterval, options, watchType, project) {
	    const path = toPath2(state, file);
	    const existing = state.filesWatched.get(path);
	    if (existing && isFileWatcherWithModifiedTime(existing)) {
	      existing.callbacks.push(callback);
	    } else {
	      const watcher = state.watchFile(
	        file,
	        (fileName, eventKind, modifiedTime) => {
	          const existing2 = Debug.checkDefined(state.filesWatched.get(path));
	          Debug.assert(isFileWatcherWithModifiedTime(existing2));
	          existing2.modifiedTime = modifiedTime;
	          existing2.callbacks.forEach((cb) => cb(fileName, eventKind, modifiedTime));
	        },
	        pollingInterval,
	        options,
	        watchType,
	        project
	      );
	      state.filesWatched.set(path, { callbacks: [callback], watcher, modifiedTime: existing });
	    }
	    return {
	      close: () => {
	        const existing2 = Debug.checkDefined(state.filesWatched.get(path));
	        Debug.assert(isFileWatcherWithModifiedTime(existing2));
	        if (existing2.callbacks.length === 1) {
	          state.filesWatched.delete(path);
	          closeFileWatcherOf(existing2);
	        } else {
	          unorderedRemoveItem(existing2.callbacks, callback);
	        }
	      }
	    };
	  }
	  function getOutputTimeStampMap(state, resolvedConfigFilePath) {
	    if (!state.watch)
	      return void 0;
	    let result = state.outputTimeStamps.get(resolvedConfigFilePath);
	    if (!result)
	      state.outputTimeStamps.set(resolvedConfigFilePath, result = /* @__PURE__ */ new Map());
	    return result;
	  }
	  function setBuildInfo(state, buildInfo, resolvedConfigPath, options, resultFlags) {
	    const buildInfoPath = getTsBuildInfoEmitOutputFilePath(options);
	    const existing = getBuildInfoCacheEntry(state, buildInfoPath, resolvedConfigPath);
	    const modifiedTime = getCurrentTime(state.host);
	    if (existing) {
	      existing.buildInfo = buildInfo;
	      existing.modifiedTime = modifiedTime;
	      if (!(resultFlags & 2 /* DeclarationOutputUnchanged */))
	        existing.latestChangedDtsTime = modifiedTime;
	    } else {
	      state.buildInfoCache.set(resolvedConfigPath, {
	        path: toPath2(state, buildInfoPath),
	        buildInfo,
	        modifiedTime,
	        latestChangedDtsTime: resultFlags & 2 /* DeclarationOutputUnchanged */ ? void 0 : modifiedTime
	      });
	    }
	  }
	  function getBuildInfoCacheEntry(state, buildInfoPath, resolvedConfigPath) {
	    const path = toPath2(state, buildInfoPath);
	    const existing = state.buildInfoCache.get(resolvedConfigPath);
	    return (existing == null ? void 0 : existing.path) === path ? existing : void 0;
	  }
	  function getBuildInfo3(state, buildInfoPath, resolvedConfigPath, modifiedTime) {
	    const path = toPath2(state, buildInfoPath);
	    const existing = state.buildInfoCache.get(resolvedConfigPath);
	    if (existing !== void 0 && existing.path === path) {
	      return existing.buildInfo || void 0;
	    }
	    const value = state.readFileWithCache(buildInfoPath);
	    const buildInfo = value ? getBuildInfo(buildInfoPath, value) : void 0;
	    state.buildInfoCache.set(resolvedConfigPath, { path, buildInfo: buildInfo || false, modifiedTime: modifiedTime || missingFileModifiedTime });
	    return buildInfo;
	  }
	  function checkConfigFileUpToDateStatus(state, configFile, oldestOutputFileTime, oldestOutputFileName) {
	    const tsconfigTime = getModifiedTime2(state, configFile);
	    if (oldestOutputFileTime < tsconfigTime) {
	      return {
	        type: 6 /* OutOfDateWithSelf */,
	        outOfDateOutputFileName: oldestOutputFileName,
	        newerInputFileName: configFile
	      };
	    }
	  }
	  function getUpToDateStatusWorker(state, project, resolvedPath) {
	    var _a, _b, _c;
	    if (!project.fileNames.length && !canJsonReportNoInputFiles(project.raw)) {
	      return {
	        type: 16 /* ContainerOnly */
	      };
	    }
	    let referenceStatuses;
	    const force = !!state.options.force;
	    if (project.projectReferences) {
	      state.projectStatus.set(resolvedPath, { type: 13 /* ComputingUpstream */ });
	      for (const ref of project.projectReferences) {
	        const resolvedRef = resolveProjectReferencePath(ref);
	        const resolvedRefPath = toResolvedConfigFilePath(state, resolvedRef);
	        const resolvedConfig = parseConfigFile(state, resolvedRef, resolvedRefPath);
	        const refStatus = getUpToDateStatus(state, resolvedConfig, resolvedRefPath);
	        if (refStatus.type === 13 /* ComputingUpstream */ || refStatus.type === 16 /* ContainerOnly */) {
	          continue;
	        }
	        if (refStatus.type === 0 /* Unbuildable */ || refStatus.type === 12 /* UpstreamBlocked */) {
	          return {
	            type: 12 /* UpstreamBlocked */,
	            upstreamProjectName: ref.path,
	            upstreamProjectBlocked: refStatus.type === 12 /* UpstreamBlocked */
	          };
	        }
	        if (refStatus.type !== 1 /* UpToDate */) {
	          return {
	            type: 11 /* UpstreamOutOfDate */,
	            upstreamProjectName: ref.path
	          };
	        }
	        if (!force)
	          (referenceStatuses || (referenceStatuses = [])).push({ ref, refStatus, resolvedRefPath, resolvedConfig });
	      }
	    }
	    if (force)
	      return { type: 17 /* ForceBuild */ };
	    const { host } = state;
	    const buildInfoPath = getTsBuildInfoEmitOutputFilePath(project.options);
	    let oldestOutputFileName;
	    let oldestOutputFileTime = maximumDate;
	    let buildInfoTime;
	    let buildInfoProgram;
	    let buildInfoVersionMap;
	    if (buildInfoPath) {
	      const buildInfoCacheEntry2 = getBuildInfoCacheEntry(state, buildInfoPath, resolvedPath);
	      buildInfoTime = (buildInfoCacheEntry2 == null ? void 0 : buildInfoCacheEntry2.modifiedTime) || getModifiedTime(host, buildInfoPath);
	      if (buildInfoTime === missingFileModifiedTime) {
	        if (!buildInfoCacheEntry2) {
	          state.buildInfoCache.set(resolvedPath, {
	            path: toPath2(state, buildInfoPath),
	            buildInfo: false,
	            modifiedTime: buildInfoTime
	          });
	        }
	        return {
	          type: 4 /* OutputMissing */,
	          missingOutputFileName: buildInfoPath
	        };
	      }
	      const buildInfo = getBuildInfo3(state, buildInfoPath, resolvedPath, buildInfoTime);
	      if (!buildInfo) {
	        return {
	          type: 5 /* ErrorReadingFile */,
	          fileName: buildInfoPath
	        };
	      }
	      if ((buildInfo.bundle || buildInfo.program) && buildInfo.version !== version) {
	        return {
	          type: 14 /* TsVersionOutputOfDate */,
	          version: buildInfo.version
	        };
	      }
	      if (buildInfo.program) {
	        if (((_a = buildInfo.program.changeFileSet) == null ? void 0 : _a.length) || (!project.options.noEmit ? ((_b = buildInfo.program.affectedFilesPendingEmit) == null ? void 0 : _b.length) || ((_c = buildInfo.program.emitDiagnosticsPerFile) == null ? void 0 : _c.length) : some(buildInfo.program.semanticDiagnosticsPerFile, isArray))) {
	          return {
	            type: 8 /* OutOfDateBuildInfo */,
	            buildInfoFile: buildInfoPath
	          };
	        }
	        if (!project.options.noEmit && getPendingEmitKind(project.options, buildInfo.program.options || {})) {
	          return {
	            type: 9 /* OutOfDateOptions */,
	            buildInfoFile: buildInfoPath
	          };
	        }
	        buildInfoProgram = buildInfo.program;
	      }
	      oldestOutputFileTime = buildInfoTime;
	      oldestOutputFileName = buildInfoPath;
	    }
	    let newestInputFileName = void 0;
	    let newestInputFileTime = minimumDate;
	    let pseudoInputUpToDate = false;
	    const seenRoots = /* @__PURE__ */ new Set();
	    for (const inputFile of project.fileNames) {
	      const inputTime = getModifiedTime2(state, inputFile);
	      if (inputTime === missingFileModifiedTime) {
	        return {
	          type: 0 /* Unbuildable */,
	          reason: `${inputFile} does not exist`
	        };
	      }
	      if (buildInfoTime && buildInfoTime < inputTime) {
	        let version2;
	        let currentVersion;
	        if (buildInfoProgram) {
	          if (!buildInfoVersionMap)
	            buildInfoVersionMap = getBuildInfoFileVersionMap(buildInfoProgram, buildInfoPath, host);
	          version2 = buildInfoVersionMap.fileInfos.get(toPath2(state, inputFile));
	          const text = version2 ? state.readFileWithCache(inputFile) : void 0;
	          currentVersion = text !== void 0 ? getSourceFileVersionAsHashFromText(host, text) : void 0;
	          if (version2 && version2 === currentVersion)
	            pseudoInputUpToDate = true;
	        }
	        if (!version2 || version2 !== currentVersion) {
	          return {
	            type: 6 /* OutOfDateWithSelf */,
	            outOfDateOutputFileName: buildInfoPath,
	            newerInputFileName: inputFile
	          };
	        }
	      }
	      if (inputTime > newestInputFileTime) {
	        newestInputFileName = inputFile;
	        newestInputFileTime = inputTime;
	      }
	      if (buildInfoProgram)
	        seenRoots.add(toPath2(state, inputFile));
	    }
	    if (buildInfoProgram) {
	      if (!buildInfoVersionMap)
	        buildInfoVersionMap = getBuildInfoFileVersionMap(buildInfoProgram, buildInfoPath, host);
	      for (const existingRoot of buildInfoVersionMap.roots) {
	        if (!seenRoots.has(existingRoot)) {
	          return {
	            type: 10 /* OutOfDateRoots */,
	            buildInfoFile: buildInfoPath,
	            inputFile: existingRoot
	          };
	        }
	      }
	    }
	    if (!buildInfoPath) {
	      const outputs = getAllProjectOutputs(project, !host.useCaseSensitiveFileNames());
	      const outputTimeStampMap = getOutputTimeStampMap(state, resolvedPath);
	      for (const output of outputs) {
	        const path = toPath2(state, output);
	        let outputTime = outputTimeStampMap == null ? void 0 : outputTimeStampMap.get(path);
	        if (!outputTime) {
	          outputTime = getModifiedTime(state.host, output);
	          outputTimeStampMap == null ? void 0 : outputTimeStampMap.set(path, outputTime);
	        }
	        if (outputTime === missingFileModifiedTime) {
	          return {
	            type: 4 /* OutputMissing */,
	            missingOutputFileName: output
	          };
	        }
	        if (outputTime < newestInputFileTime) {
	          return {
	            type: 6 /* OutOfDateWithSelf */,
	            outOfDateOutputFileName: output,
	            newerInputFileName: newestInputFileName
	          };
	        }
	        if (outputTime < oldestOutputFileTime) {
	          oldestOutputFileTime = outputTime;
	          oldestOutputFileName = output;
	        }
	      }
	    }
	    const buildInfoCacheEntry = state.buildInfoCache.get(resolvedPath);
	    let pseudoUpToDate = false;
	    let usesPrepend = false;
	    let upstreamChangedProject;
	    if (referenceStatuses) {
	      for (const { ref, refStatus, resolvedConfig, resolvedRefPath } of referenceStatuses) {
	        usesPrepend = usesPrepend || !!ref.prepend;
	        if (refStatus.newestInputFileTime && refStatus.newestInputFileTime <= oldestOutputFileTime) {
	          continue;
	        }
	        if (buildInfoCacheEntry && hasSameBuildInfo(state, buildInfoCacheEntry, resolvedRefPath)) {
	          return {
	            type: 7 /* OutOfDateWithUpstream */,
	            outOfDateOutputFileName: buildInfoPath,
	            newerProjectName: ref.path
	          };
	        }
	        const newestDeclarationFileContentChangedTime = getLatestChangedDtsTime(state, resolvedConfig.options, resolvedRefPath);
	        if (newestDeclarationFileContentChangedTime && newestDeclarationFileContentChangedTime <= oldestOutputFileTime) {
	          pseudoUpToDate = true;
	          upstreamChangedProject = ref.path;
	          continue;
	        }
	        Debug.assert(oldestOutputFileName !== void 0, "Should have an oldest output filename here");
	        return {
	          type: 7 /* OutOfDateWithUpstream */,
	          outOfDateOutputFileName: oldestOutputFileName,
	          newerProjectName: ref.path
	        };
	      }
	    }
	    const configStatus = checkConfigFileUpToDateStatus(state, project.options.configFilePath, oldestOutputFileTime, oldestOutputFileName);
	    if (configStatus)
	      return configStatus;
	    const extendedConfigStatus = forEach(project.options.configFile.extendedSourceFiles || emptyArray, (configFile) => checkConfigFileUpToDateStatus(state, configFile, oldestOutputFileTime, oldestOutputFileName));
	    if (extendedConfigStatus)
	      return extendedConfigStatus;
	    const packageJsonLookups = state.lastCachedPackageJsonLookups.get(resolvedPath);
	    const dependentPackageFileStatus = packageJsonLookups && forEachKey(
	      packageJsonLookups,
	      (path) => checkConfigFileUpToDateStatus(state, path, oldestOutputFileTime, oldestOutputFileName)
	    );
	    if (dependentPackageFileStatus)
	      return dependentPackageFileStatus;
	    if (usesPrepend && pseudoUpToDate) {
	      return {
	        type: 3 /* OutOfDateWithPrepend */,
	        outOfDateOutputFileName: oldestOutputFileName,
	        newerProjectName: upstreamChangedProject
	      };
	    }
	    return {
	      type: pseudoUpToDate ? 2 /* UpToDateWithUpstreamTypes */ : pseudoInputUpToDate ? 15 /* UpToDateWithInputFileText */ : 1 /* UpToDate */,
	      newestInputFileTime,
	      newestInputFileName,
	      oldestOutputFileName
	    };
	  }
	  function hasSameBuildInfo(state, buildInfoCacheEntry, resolvedRefPath) {
	    const refBuildInfo = state.buildInfoCache.get(resolvedRefPath);
	    return refBuildInfo.path === buildInfoCacheEntry.path;
	  }
	  function getUpToDateStatus(state, project, resolvedPath) {
	    if (project === void 0) {
	      return { type: 0 /* Unbuildable */, reason: "File deleted mid-build" };
	    }
	    const prior = state.projectStatus.get(resolvedPath);
	    if (prior !== void 0) {
	      return prior;
	    }
	    mark("SolutionBuilder::beforeUpToDateCheck");
	    const actual = getUpToDateStatusWorker(state, project, resolvedPath);
	    mark("SolutionBuilder::afterUpToDateCheck");
	    measure("SolutionBuilder::Up-to-date check", "SolutionBuilder::beforeUpToDateCheck", "SolutionBuilder::afterUpToDateCheck");
	    state.projectStatus.set(resolvedPath, actual);
	    return actual;
	  }
	  function updateOutputTimestampsWorker(state, proj, projectPath, verboseMessage, skipOutputs) {
	    if (proj.options.noEmit)
	      return;
	    let now;
	    const buildInfoPath = getTsBuildInfoEmitOutputFilePath(proj.options);
	    if (buildInfoPath) {
	      if (!(skipOutputs == null ? void 0 : skipOutputs.has(toPath2(state, buildInfoPath)))) {
	        if (!!state.options.verbose)
	          reportStatus(state, verboseMessage, proj.options.configFilePath);
	        state.host.setModifiedTime(buildInfoPath, now = getCurrentTime(state.host));
	        getBuildInfoCacheEntry(state, buildInfoPath, projectPath).modifiedTime = now;
	      }
	      state.outputTimeStamps.delete(projectPath);
	      return;
	    }
	    const { host } = state;
	    const outputs = getAllProjectOutputs(proj, !host.useCaseSensitiveFileNames());
	    const outputTimeStampMap = getOutputTimeStampMap(state, projectPath);
	    const modifiedOutputs = outputTimeStampMap ? /* @__PURE__ */ new Set() : void 0;
	    if (!skipOutputs || outputs.length !== skipOutputs.size) {
	      let reportVerbose = !!state.options.verbose;
	      for (const file of outputs) {
	        const path = toPath2(state, file);
	        if (skipOutputs == null ? void 0 : skipOutputs.has(path))
	          continue;
	        if (reportVerbose) {
	          reportVerbose = false;
	          reportStatus(state, verboseMessage, proj.options.configFilePath);
	        }
	        host.setModifiedTime(file, now || (now = getCurrentTime(state.host)));
	        if (outputTimeStampMap) {
	          outputTimeStampMap.set(path, now);
	          modifiedOutputs.add(path);
	        }
	      }
	    }
	    outputTimeStampMap == null ? void 0 : outputTimeStampMap.forEach((_value, key) => {
	      if (!(skipOutputs == null ? void 0 : skipOutputs.has(key)) && !modifiedOutputs.has(key))
	        outputTimeStampMap.delete(key);
	    });
	  }
	  function getLatestChangedDtsTime(state, options, resolvedConfigPath) {
	    if (!options.composite)
	      return void 0;
	    const entry = Debug.checkDefined(state.buildInfoCache.get(resolvedConfigPath));
	    if (entry.latestChangedDtsTime !== void 0)
	      return entry.latestChangedDtsTime || void 0;
	    const latestChangedDtsTime = entry.buildInfo && entry.buildInfo.program && entry.buildInfo.program.latestChangedDtsFile ? state.host.getModifiedTime(getNormalizedAbsolutePath(entry.buildInfo.program.latestChangedDtsFile, getDirectoryPath(entry.path))) : void 0;
	    entry.latestChangedDtsTime = latestChangedDtsTime || false;
	    return latestChangedDtsTime;
	  }
	  function updateOutputTimestamps(state, proj, resolvedPath) {
	    if (state.options.dry) {
	      return reportStatus(state, Diagnostics.A_non_dry_build_would_update_timestamps_for_output_of_project_0, proj.options.configFilePath);
	    }
	    updateOutputTimestampsWorker(state, proj, resolvedPath, Diagnostics.Updating_output_timestamps_of_project_0);
	    state.projectStatus.set(resolvedPath, {
	      type: 1 /* UpToDate */,
	      oldestOutputFileName: getFirstProjectOutput(proj, !state.host.useCaseSensitiveFileNames())
	    });
	  }
	  function queueReferencingProjects(state, project, projectPath, projectIndex, config, buildOrder, buildResult) {
	    if (buildResult & 124 /* AnyErrors */)
	      return;
	    if (!config.options.composite)
	      return;
	    for (let index = projectIndex + 1; index < buildOrder.length; index++) {
	      const nextProject = buildOrder[index];
	      const nextProjectPath = toResolvedConfigFilePath(state, nextProject);
	      if (state.projectPendingBuild.has(nextProjectPath))
	        continue;
	      const nextProjectConfig = parseConfigFile(state, nextProject, nextProjectPath);
	      if (!nextProjectConfig || !nextProjectConfig.projectReferences)
	        continue;
	      for (const ref of nextProjectConfig.projectReferences) {
	        const resolvedRefPath = resolveProjectName(state, ref.path);
	        if (toResolvedConfigFilePath(state, resolvedRefPath) !== projectPath)
	          continue;
	        const status = state.projectStatus.get(nextProjectPath);
	        if (status) {
	          switch (status.type) {
	            case 1 /* UpToDate */:
	              if (buildResult & 2 /* DeclarationOutputUnchanged */) {
	                if (ref.prepend) {
	                  state.projectStatus.set(nextProjectPath, {
	                    type: 3 /* OutOfDateWithPrepend */,
	                    outOfDateOutputFileName: status.oldestOutputFileName,
	                    newerProjectName: project
	                  });
	                } else {
	                  status.type = 2 /* UpToDateWithUpstreamTypes */;
	                }
	                break;
	              }
	            case 15 /* UpToDateWithInputFileText */:
	            case 2 /* UpToDateWithUpstreamTypes */:
	            case 3 /* OutOfDateWithPrepend */:
	              if (!(buildResult & 2 /* DeclarationOutputUnchanged */)) {
	                state.projectStatus.set(nextProjectPath, {
	                  type: 7 /* OutOfDateWithUpstream */,
	                  outOfDateOutputFileName: status.type === 3 /* OutOfDateWithPrepend */ ? status.outOfDateOutputFileName : status.oldestOutputFileName,
	                  newerProjectName: project
	                });
	              }
	              break;
	            case 12 /* UpstreamBlocked */:
	              if (toResolvedConfigFilePath(state, resolveProjectName(state, status.upstreamProjectName)) === projectPath) {
	                clearProjectStatus(state, nextProjectPath);
	              }
	              break;
	          }
	        }
	        addProjToQueue(state, nextProjectPath, 0 /* Update */);
	        break;
	      }
	    }
	  }
	  function build(state, project, cancellationToken, writeFile2, getCustomTransformers, onlyReferences) {
	    mark("SolutionBuilder::beforeBuild");
	    const result = buildWorker(state, project, cancellationToken, writeFile2, getCustomTransformers, onlyReferences);
	    mark("SolutionBuilder::afterBuild");
	    measure("SolutionBuilder::Build", "SolutionBuilder::beforeBuild", "SolutionBuilder::afterBuild");
	    return result;
	  }
	  function buildWorker(state, project, cancellationToken, writeFile2, getCustomTransformers, onlyReferences) {
	    const buildOrder = getBuildOrderFor(state, project, onlyReferences);
	    if (!buildOrder)
	      return 3 /* InvalidProject_OutputsSkipped */;
	    setupInitialBuild(state, cancellationToken);
	    let reportQueue = true;
	    let successfulProjects = 0;
	    while (true) {
	      const invalidatedProject = getNextInvalidatedProject(state, buildOrder, reportQueue);
	      if (!invalidatedProject)
	        break;
	      reportQueue = false;
	      invalidatedProject.done(cancellationToken, writeFile2, getCustomTransformers == null ? void 0 : getCustomTransformers(invalidatedProject.project));
	      if (!state.diagnostics.has(invalidatedProject.projectPath))
	        successfulProjects++;
	    }
	    disableCache(state);
	    reportErrorSummary(state, buildOrder);
	    startWatching(state, buildOrder);
	    return isCircularBuildOrder(buildOrder) ? 4 /* ProjectReferenceCycle_OutputsSkipped */ : !buildOrder.some((p) => state.diagnostics.has(toResolvedConfigFilePath(state, p))) ? 0 /* Success */ : successfulProjects ? 2 /* DiagnosticsPresent_OutputsGenerated */ : 1 /* DiagnosticsPresent_OutputsSkipped */;
	  }
	  function clean(state, project, onlyReferences) {
	    mark("SolutionBuilder::beforeClean");
	    const result = cleanWorker(state, project, onlyReferences);
	    mark("SolutionBuilder::afterClean");
	    measure("SolutionBuilder::Clean", "SolutionBuilder::beforeClean", "SolutionBuilder::afterClean");
	    return result;
	  }
	  function cleanWorker(state, project, onlyReferences) {
	    const buildOrder = getBuildOrderFor(state, project, onlyReferences);
	    if (!buildOrder)
	      return 3 /* InvalidProject_OutputsSkipped */;
	    if (isCircularBuildOrder(buildOrder)) {
	      reportErrors(state, buildOrder.circularDiagnostics);
	      return 4 /* ProjectReferenceCycle_OutputsSkipped */;
	    }
	    const { options, host } = state;
	    const filesToDelete = options.dry ? [] : void 0;
	    for (const proj of buildOrder) {
	      const resolvedPath = toResolvedConfigFilePath(state, proj);
	      const parsed = parseConfigFile(state, proj, resolvedPath);
	      if (parsed === void 0) {
	        reportParseConfigFileDiagnostic(state, resolvedPath);
	        continue;
	      }
	      const outputs = getAllProjectOutputs(parsed, !host.useCaseSensitiveFileNames());
	      if (!outputs.length)
	        continue;
	      const inputFileNames = new Set(parsed.fileNames.map((f) => toPath2(state, f)));
	      for (const output of outputs) {
	        if (inputFileNames.has(toPath2(state, output)))
	          continue;
	        if (host.fileExists(output)) {
	          if (filesToDelete) {
	            filesToDelete.push(output);
	          } else {
	            host.deleteFile(output);
	            invalidateProject(state, resolvedPath, 0 /* Update */);
	          }
	        }
	      }
	    }
	    if (filesToDelete) {
	      reportStatus(state, Diagnostics.A_non_dry_build_would_delete_the_following_files_Colon_0, filesToDelete.map((f) => `\r
 * ${f}`).join(""));
	    }
	    return 0 /* Success */;
	  }
	  function invalidateProject(state, resolved, updateLevel) {
	    if (state.host.getParsedCommandLine && updateLevel === 1 /* RootNamesAndUpdate */) {
	      updateLevel = 2 /* Full */;
	    }
	    if (updateLevel === 2 /* Full */) {
	      state.configFileCache.delete(resolved);
	      state.buildOrder = void 0;
	    }
	    state.needsSummary = true;
	    clearProjectStatus(state, resolved);
	    addProjToQueue(state, resolved, updateLevel);
	    enableCache(state);
	  }
	  function invalidateProjectAndScheduleBuilds(state, resolvedPath, updateLevel) {
	    state.reportFileChangeDetected = true;
	    invalidateProject(state, resolvedPath, updateLevel);
	    scheduleBuildInvalidatedProject(
	      state,
	      250,
	      /*changeDetected*/
	      true
	    );
	  }
	  function scheduleBuildInvalidatedProject(state, time, changeDetected) {
	    const { hostWithWatch } = state;
	    if (!hostWithWatch.setTimeout || !hostWithWatch.clearTimeout) {
	      return;
	    }
	    if (state.timerToBuildInvalidatedProject) {
	      hostWithWatch.clearTimeout(state.timerToBuildInvalidatedProject);
	    }
	    state.timerToBuildInvalidatedProject = hostWithWatch.setTimeout(buildNextInvalidatedProject, time, "timerToBuildInvalidatedProject", state, changeDetected);
	  }
	  function buildNextInvalidatedProject(_timeoutType, state, changeDetected) {
	    mark("SolutionBuilder::beforeBuild");
	    const buildOrder = buildNextInvalidatedProjectWorker(state, changeDetected);
	    mark("SolutionBuilder::afterBuild");
	    measure("SolutionBuilder::Build", "SolutionBuilder::beforeBuild", "SolutionBuilder::afterBuild");
	    if (buildOrder)
	      reportErrorSummary(state, buildOrder);
	  }
	  function buildNextInvalidatedProjectWorker(state, changeDetected) {
	    state.timerToBuildInvalidatedProject = void 0;
	    if (state.reportFileChangeDetected) {
	      state.reportFileChangeDetected = false;
	      state.projectErrorsReported.clear();
	      reportWatchStatus(state, Diagnostics.File_change_detected_Starting_incremental_compilation);
	    }
	    let projectsBuilt = 0;
	    const buildOrder = getBuildOrder(state);
	    const invalidatedProject = getNextInvalidatedProject(
	      state,
	      buildOrder,
	      /*reportQueue*/
	      false
	    );
	    if (invalidatedProject) {
	      invalidatedProject.done();
	      projectsBuilt++;
	      while (state.projectPendingBuild.size) {
	        if (state.timerToBuildInvalidatedProject)
	          return;
	        const info = getNextInvalidatedProjectCreateInfo(
	          state,
	          buildOrder,
	          /*reportQueue*/
	          false
	        );
	        if (!info)
	          break;
	        if (info.kind !== 2 /* UpdateOutputFileStamps */ && (changeDetected || projectsBuilt === 5)) {
	          scheduleBuildInvalidatedProject(
	            state,
	            100,
	            /*changeDetected*/
	            false
	          );
	          return;
	        }
	        const project = createInvalidatedProjectWithInfo(state, info, buildOrder);
	        project.done();
	        if (info.kind !== 2 /* UpdateOutputFileStamps */)
	          projectsBuilt++;
	      }
	    }
	    disableCache(state);
	    return buildOrder;
	  }
	  function watchConfigFile(state, resolved, resolvedPath, parsed) {
	    if (!state.watch || state.allWatchedConfigFiles.has(resolvedPath))
	      return;
	    state.allWatchedConfigFiles.set(
	      resolvedPath,
	      watchFile(
	        state,
	        resolved,
	        () => invalidateProjectAndScheduleBuilds(state, resolvedPath, 2 /* Full */),
	        2e3 /* High */,
	        parsed == null ? void 0 : parsed.watchOptions,
	        WatchType.ConfigFile,
	        resolved
	      )
	    );
	  }
	  function watchExtendedConfigFiles(state, resolvedPath, parsed) {
	    updateSharedExtendedConfigFileWatcher(
	      resolvedPath,
	      parsed == null ? void 0 : parsed.options,
	      state.allWatchedExtendedConfigFiles,
	      (extendedConfigFileName, extendedConfigFilePath) => watchFile(
	        state,
	        extendedConfigFileName,
	        () => {
	          var _a;
	          return (_a = state.allWatchedExtendedConfigFiles.get(extendedConfigFilePath)) == null ? void 0 : _a.projects.forEach((projectConfigFilePath) => invalidateProjectAndScheduleBuilds(state, projectConfigFilePath, 2 /* Full */));
	        },
	        2e3 /* High */,
	        parsed == null ? void 0 : parsed.watchOptions,
	        WatchType.ExtendedConfigFile
	      ),
	      (fileName) => toPath2(state, fileName)
	    );
	  }
	  function watchWildCardDirectories(state, resolved, resolvedPath, parsed) {
	    if (!state.watch)
	      return;
	    updateWatchingWildcardDirectories(
	      getOrCreateValueMapFromConfigFileMap(state.allWatchedWildcardDirectories, resolvedPath),
	      parsed.wildcardDirectories,
	      (dir, flags) => state.watchDirectory(
	        dir,
	        (fileOrDirectory) => {
	          var _a;
	          if (isIgnoredFileFromWildCardWatching({
	            watchedDirPath: toPath2(state, dir),
	            fileOrDirectory,
	            fileOrDirectoryPath: toPath2(state, fileOrDirectory),
	            configFileName: resolved,
	            currentDirectory: state.compilerHost.getCurrentDirectory(),
	            options: parsed.options,
	            program: state.builderPrograms.get(resolvedPath) || ((_a = getCachedParsedConfigFile(state, resolvedPath)) == null ? void 0 : _a.fileNames),
	            useCaseSensitiveFileNames: state.parseConfigFileHost.useCaseSensitiveFileNames,
	            writeLog: (s) => state.writeLog(s),
	            toPath: (fileName) => toPath2(state, fileName)
	          }))
	            return;
	          invalidateProjectAndScheduleBuilds(state, resolvedPath, 1 /* RootNamesAndUpdate */);
	        },
	        flags,
	        parsed == null ? void 0 : parsed.watchOptions,
	        WatchType.WildcardDirectory,
	        resolved
	      )
	    );
	  }
	  function watchInputFiles(state, resolved, resolvedPath, parsed) {
	    if (!state.watch)
	      return;
	    mutateMap(
	      getOrCreateValueMapFromConfigFileMap(state.allWatchedInputFiles, resolvedPath),
	      new Set(parsed.fileNames),
	      {
	        createNewValue: (input) => watchFile(
	          state,
	          input,
	          () => invalidateProjectAndScheduleBuilds(state, resolvedPath, 0 /* Update */),
	          250 /* Low */,
	          parsed == null ? void 0 : parsed.watchOptions,
	          WatchType.SourceFile,
	          resolved
	        ),
	        onDeleteValue: closeFileWatcher
	      }
	    );
	  }
	  function watchPackageJsonFiles(state, resolved, resolvedPath, parsed) {
	    if (!state.watch || !state.lastCachedPackageJsonLookups)
	      return;
	    mutateMap(
	      getOrCreateValueMapFromConfigFileMap(state.allWatchedPackageJsonFiles, resolvedPath),
	      state.lastCachedPackageJsonLookups.get(resolvedPath),
	      {
	        createNewValue: (input) => watchFile(
	          state,
	          input,
	          () => invalidateProjectAndScheduleBuilds(state, resolvedPath, 0 /* Update */),
	          2e3 /* High */,
	          parsed == null ? void 0 : parsed.watchOptions,
	          WatchType.PackageJson,
	          resolved
	        ),
	        onDeleteValue: closeFileWatcher
	      }
	    );
	  }
	  function startWatching(state, buildOrder) {
	    if (!state.watchAllProjectsPending)
	      return;
	    mark("SolutionBuilder::beforeWatcherCreation");
	    state.watchAllProjectsPending = false;
	    for (const resolved of getBuildOrderFromAnyBuildOrder(buildOrder)) {
	      const resolvedPath = toResolvedConfigFilePath(state, resolved);
	      const cfg = parseConfigFile(state, resolved, resolvedPath);
	      watchConfigFile(state, resolved, resolvedPath, cfg);
	      watchExtendedConfigFiles(state, resolvedPath, cfg);
	      if (cfg) {
	        watchWildCardDirectories(state, resolved, resolvedPath, cfg);
	        watchInputFiles(state, resolved, resolvedPath, cfg);
	        watchPackageJsonFiles(state, resolved, resolvedPath, cfg);
	      }
	    }
	    mark("SolutionBuilder::afterWatcherCreation");
	    measure("SolutionBuilder::Watcher creation", "SolutionBuilder::beforeWatcherCreation", "SolutionBuilder::afterWatcherCreation");
	  }
	  function stopWatching(state) {
	    clearMap(state.allWatchedConfigFiles, closeFileWatcher);
	    clearMap(state.allWatchedExtendedConfigFiles, closeFileWatcherOf);
	    clearMap(state.allWatchedWildcardDirectories, (watchedWildcardDirectories) => clearMap(watchedWildcardDirectories, closeFileWatcherOf));
	    clearMap(state.allWatchedInputFiles, (watchedWildcardDirectories) => clearMap(watchedWildcardDirectories, closeFileWatcher));
	    clearMap(state.allWatchedPackageJsonFiles, (watchedPacageJsonFiles) => clearMap(watchedPacageJsonFiles, closeFileWatcher));
	  }
	  function createSolutionBuilderWorker(watch, hostOrHostWithWatch, rootNames, options, baseWatchOptions) {
	    const state = createSolutionBuilderState(watch, hostOrHostWithWatch, rootNames, options, baseWatchOptions);
	    return {
	      build: (project, cancellationToken, writeFile2, getCustomTransformers) => build(state, project, cancellationToken, writeFile2, getCustomTransformers),
	      clean: (project) => clean(state, project),
	      buildReferences: (project, cancellationToken, writeFile2, getCustomTransformers) => build(
	        state,
	        project,
	        cancellationToken,
	        writeFile2,
	        getCustomTransformers,
	        /*onlyReferences*/
	        true
	      ),
	      cleanReferences: (project) => clean(
	        state,
	        project,
	        /*onlyReferences*/
	        true
	      ),
	      getNextInvalidatedProject: (cancellationToken) => {
	        setupInitialBuild(state, cancellationToken);
	        return getNextInvalidatedProject(
	          state,
	          getBuildOrder(state),
	          /*reportQueue*/
	          false
	        );
	      },
	      getBuildOrder: () => getBuildOrder(state),
	      getUpToDateStatusOfProject: (project) => {
	        const configFileName = resolveProjectName(state, project);
	        const configFilePath = toResolvedConfigFilePath(state, configFileName);
	        return getUpToDateStatus(state, parseConfigFile(state, configFileName, configFilePath), configFilePath);
	      },
	      invalidateProject: (configFilePath, updateLevel) => invalidateProject(state, configFilePath, updateLevel || 0 /* Update */),
	      close: () => stopWatching(state)
	    };
	  }
	  function relName(state, path) {
	    return convertToRelativePath(path, state.compilerHost.getCurrentDirectory(), state.compilerHost.getCanonicalFileName);
	  }
	  function reportStatus(state, message, ...args) {
	    state.host.reportSolutionBuilderStatus(createCompilerDiagnostic(message, ...args));
	  }
	  function reportWatchStatus(state, message, ...args) {
	    var _a, _b;
	    (_b = (_a = state.hostWithWatch).onWatchStatusChange) == null ? void 0 : _b.call(_a, createCompilerDiagnostic(message, ...args), state.host.getNewLine(), state.baseCompilerOptions);
	  }
	  function reportErrors({ host }, errors) {
	    errors.forEach((err) => host.reportDiagnostic(err));
	  }
	  function reportAndStoreErrors(state, proj, errors) {
	    reportErrors(state, errors);
	    state.projectErrorsReported.set(proj, true);
	    if (errors.length) {
	      state.diagnostics.set(proj, errors);
	    }
	  }
	  function reportParseConfigFileDiagnostic(state, proj) {
	    reportAndStoreErrors(state, proj, [state.configFileCache.get(proj)]);
	  }
	  function reportErrorSummary(state, buildOrder) {
	    if (!state.needsSummary)
	      return;
	    state.needsSummary = false;
	    const canReportSummary = state.watch || !!state.host.reportErrorSummary;
	    const { diagnostics } = state;
	    let totalErrors = 0;
	    let filesInError = [];
	    if (isCircularBuildOrder(buildOrder)) {
	      reportBuildQueue(state, buildOrder.buildOrder);
	      reportErrors(state, buildOrder.circularDiagnostics);
	      if (canReportSummary)
	        totalErrors += getErrorCountForSummary(buildOrder.circularDiagnostics);
	      if (canReportSummary)
	        filesInError = [...filesInError, ...getFilesInErrorForSummary(buildOrder.circularDiagnostics)];
	    } else {
	      buildOrder.forEach((project) => {
	        const projectPath = toResolvedConfigFilePath(state, project);
	        if (!state.projectErrorsReported.has(projectPath)) {
	          reportErrors(state, diagnostics.get(projectPath) || emptyArray);
	        }
	      });
	      if (canReportSummary)
	        diagnostics.forEach((singleProjectErrors) => totalErrors += getErrorCountForSummary(singleProjectErrors));
	      if (canReportSummary)
	        diagnostics.forEach((singleProjectErrors) => [...filesInError, ...getFilesInErrorForSummary(singleProjectErrors)]);
	    }
	    if (state.watch) {
	      reportWatchStatus(state, getWatchErrorSummaryDiagnosticMessage(totalErrors), totalErrors);
	    } else if (state.host.reportErrorSummary) {
	      state.host.reportErrorSummary(totalErrors, filesInError);
	    }
	  }
	  function reportBuildQueue(state, buildQueue) {
	    if (state.options.verbose) {
	      reportStatus(state, Diagnostics.Projects_in_this_build_Colon_0, buildQueue.map((s) => "\r\n    * " + relName(state, s)).join(""));
	    }
	  }
	  function reportUpToDateStatus(state, configFileName, status) {
	    switch (status.type) {
	      case 6 /* OutOfDateWithSelf */:
	        return reportStatus(
	          state,
	          Diagnostics.Project_0_is_out_of_date_because_output_1_is_older_than_input_2,
	          relName(state, configFileName),
	          relName(state, status.outOfDateOutputFileName),
	          relName(state, status.newerInputFileName)
	        );
	      case 7 /* OutOfDateWithUpstream */:
	        return reportStatus(
	          state,
	          Diagnostics.Project_0_is_out_of_date_because_output_1_is_older_than_input_2,
	          relName(state, configFileName),
	          relName(state, status.outOfDateOutputFileName),
	          relName(state, status.newerProjectName)
	        );
	      case 4 /* OutputMissing */:
	        return reportStatus(
	          state,
	          Diagnostics.Project_0_is_out_of_date_because_output_file_1_does_not_exist,
	          relName(state, configFileName),
	          relName(state, status.missingOutputFileName)
	        );
	      case 5 /* ErrorReadingFile */:
	        return reportStatus(
	          state,
	          Diagnostics.Project_0_is_out_of_date_because_there_was_error_reading_file_1,
	          relName(state, configFileName),
	          relName(state, status.fileName)
	        );
	      case 8 /* OutOfDateBuildInfo */:
	        return reportStatus(
	          state,
	          Diagnostics.Project_0_is_out_of_date_because_buildinfo_file_1_indicates_that_some_of_the_changes_were_not_emitted,
	          relName(state, configFileName),
	          relName(state, status.buildInfoFile)
	        );
	      case 9 /* OutOfDateOptions */:
	        return reportStatus(
	          state,
	          Diagnostics.Project_0_is_out_of_date_because_buildinfo_file_1_indicates_there_is_change_in_compilerOptions,
	          relName(state, configFileName),
	          relName(state, status.buildInfoFile)
	        );
	      case 10 /* OutOfDateRoots */:
	        return reportStatus(
	          state,
	          Diagnostics.Project_0_is_out_of_date_because_buildinfo_file_1_indicates_that_file_2_was_root_file_of_compilation_but_not_any_more,
	          relName(state, configFileName),
	          relName(state, status.buildInfoFile),
	          relName(state, status.inputFile)
	        );
	      case 1 /* UpToDate */:
	        if (status.newestInputFileTime !== void 0) {
	          return reportStatus(
	            state,
	            Diagnostics.Project_0_is_up_to_date_because_newest_input_1_is_older_than_output_2,
	            relName(state, configFileName),
	            relName(state, status.newestInputFileName || ""),
	            relName(state, status.oldestOutputFileName || "")
	          );
	        }
	        break;
	      case 3 /* OutOfDateWithPrepend */:
	        return reportStatus(
	          state,
	          Diagnostics.Project_0_is_out_of_date_because_output_of_its_dependency_1_has_changed,
	          relName(state, configFileName),
	          relName(state, status.newerProjectName)
	        );
	      case 2 /* UpToDateWithUpstreamTypes */:
	        return reportStatus(
	          state,
	          Diagnostics.Project_0_is_up_to_date_with_d_ts_files_from_its_dependencies,
	          relName(state, configFileName)
	        );
	      case 15 /* UpToDateWithInputFileText */:
	        return reportStatus(
	          state,
	          Diagnostics.Project_0_is_up_to_date_but_needs_to_update_timestamps_of_output_files_that_are_older_than_input_files,
	          relName(state, configFileName)
	        );
	      case 11 /* UpstreamOutOfDate */:
	        return reportStatus(
	          state,
	          Diagnostics.Project_0_is_out_of_date_because_its_dependency_1_is_out_of_date,
	          relName(state, configFileName),
	          relName(state, status.upstreamProjectName)
	        );
	      case 12 /* UpstreamBlocked */:
	        return reportStatus(
	          state,
	          status.upstreamProjectBlocked ? Diagnostics.Project_0_can_t_be_built_because_its_dependency_1_was_not_built : Diagnostics.Project_0_can_t_be_built_because_its_dependency_1_has_errors,
	          relName(state, configFileName),
	          relName(state, status.upstreamProjectName)
	        );
	      case 0 /* Unbuildable */:
	        return reportStatus(
	          state,
	          Diagnostics.Failed_to_parse_file_0_Colon_1,
	          relName(state, configFileName),
	          status.reason
	        );
	      case 14 /* TsVersionOutputOfDate */:
	        return reportStatus(
	          state,
	          Diagnostics.Project_0_is_out_of_date_because_output_for_it_was_generated_with_version_1_that_differs_with_current_version_2,
	          relName(state, configFileName),
	          status.version,
	          version
	        );
	      case 17 /* ForceBuild */:
	        return reportStatus(
	          state,
	          Diagnostics.Project_0_is_being_forcibly_rebuilt,
	          relName(state, configFileName)
	        );
	    }
	  }
	  function verboseReportProjectStatus(state, configFileName, status) {
	    if (state.options.verbose) {
	      reportUpToDateStatus(state, configFileName, status);
	    }
	  }
	  var minimumDate, maximumDate, InvalidatedProjectKind;
	  var init_tsbuildPublic = __esm({
	    "src/compiler/tsbuildPublic.ts"() {
	      init_ts2();
	      init_ts_performance();
	      minimumDate = /* @__PURE__ */ new Date(-864e13);
	      maximumDate = /* @__PURE__ */ new Date(864e13);
	      InvalidatedProjectKind = /* @__PURE__ */ ((InvalidatedProjectKind2) => {
	        InvalidatedProjectKind2[InvalidatedProjectKind2["Build"] = 0] = "Build";
	        InvalidatedProjectKind2[InvalidatedProjectKind2["UpdateBundle"] = 1] = "UpdateBundle";
	        InvalidatedProjectKind2[InvalidatedProjectKind2["UpdateOutputFileStamps"] = 2] = "UpdateOutputFileStamps";
	        return InvalidatedProjectKind2;
	      })(InvalidatedProjectKind || {});
	    }
	  });

	  // src/compiler/_namespaces/ts.ts
	  var init_ts2 = __esm({
	    "src/compiler/_namespaces/ts.ts"() {
	      init_corePublic();
	      init_core();
	      init_debug();
	      init_semver();
	      init_performanceCore();
	      init_perfLogger();
	      init_tracing();
	      init_types();
	      init_sys();
	      init_path();
	      init_diagnosticInformationMap_generated();
	      init_scanner();
	      init_utilitiesPublic();
	      init_utilities();
	      init_baseNodeFactory();
	      init_parenthesizerRules();
	      init_nodeConverters();
	      init_nodeFactory();
	      init_emitNode();
	      init_emitHelpers();
	      init_nodeTests();
	      init_utilities2();
	      init_utilitiesPublic2();
	      init_parser();
	      init_commandLineParser();
	      init_moduleNameResolver();
	      init_binder();
	      init_symbolWalker();
	      init_checker();
	      init_visitorPublic();
	      init_sourcemap();
	      init_utilities3();
	      init_destructuring();
	      init_classThis();
	      init_namedEvaluation();
	      init_taggedTemplate();
	      init_ts();
	      init_classFields();
	      init_typeSerializer();
	      init_legacyDecorators();
	      init_esDecorators();
	      init_es2017();
	      init_es2018();
	      init_es2019();
	      init_es2020();
	      init_es2021();
	      init_esnext();
	      init_jsx();
	      init_es2016();
	      init_es2015();
	      init_es5();
	      init_generators();
	      init_module();
	      init_system();
	      init_esnextAnd2015();
	      init_node();
	      init_diagnostics();
	      init_declarations();
	      init_transformer();
	      init_emitter();
	      init_watchUtilities();
	      init_program();
	      init_builderStatePublic();
	      init_builderState();
	      init_builder();
	      init_builderPublic();
	      init_resolutionCache();
	      init_watch();
	      init_watchPublic();
	      init_tsbuild();
	      init_tsbuildPublic();
	      init_ts_moduleSpecifiers();
	      init_ts_performance();
	    }
	  });

	  // src/jsTyping/shared.ts
	  function hasArgument(argumentName) {
	    return sys.args.includes(argumentName);
	  }
	  function findArgument(argumentName) {
	    const index = sys.args.indexOf(argumentName);
	    return index >= 0 && index < sys.args.length - 1 ? sys.args[index + 1] : void 0;
	  }
	  function nowString() {
	    const d = /* @__PURE__ */ new Date();
	    return `${d.getHours().toString().padStart(2, "0")}:${d.getMinutes().toString().padStart(2, "0")}:${d.getSeconds().toString().padStart(2, "0")}.${d.getMilliseconds().toString().padStart(3, "0")}`;
	  }
	  function indent2(str) {
	    return indentStr + str.replace(/\n/g, indentStr);
	  }
	  function stringifyIndented(json) {
	    return indent2(JSON.stringify(json, void 0, 2));
	  }
	  var ActionSet, ActionInvalidate, ActionPackageInstalled, EventTypesRegistry, EventBeginInstallTypes, EventEndInstallTypes, EventInitializationFailed, ActionWatchTypingLocations, Arguments, indentStr;
	  var init_shared = __esm({
	    "src/jsTyping/shared.ts"() {
	      init_ts3();
	      ActionSet = "action::set";
	      ActionInvalidate = "action::invalidate";
	      ActionPackageInstalled = "action::packageInstalled";
	      EventTypesRegistry = "event::typesRegistry";
	      EventBeginInstallTypes = "event::beginInstallTypes";
	      EventEndInstallTypes = "event::endInstallTypes";
	      EventInitializationFailed = "event::initializationFailed";
	      ActionWatchTypingLocations = "action::watchTypingLocations";
	      ((Arguments2) => {
	        Arguments2.GlobalCacheLocation = "--globalTypingsCacheLocation";
	        Arguments2.LogFile = "--logFile";
	        Arguments2.EnableTelemetry = "--enableTelemetry";
	        Arguments2.TypingSafeListLocation = "--typingSafeListLocation";
	        Arguments2.TypesMapLocation = "--typesMapLocation";
	        Arguments2.NpmLocation = "--npmLocation";
	        Arguments2.ValidateDefaultNpmLocation = "--validateDefaultNpmLocation";
	      })(Arguments || (Arguments = {}));
	      indentStr = "\n    ";
	    }
	  });

	  // src/jsTyping/types.ts
	  var init_types2 = __esm({
	    "src/jsTyping/types.ts"() {
	    }
	  });

	  // src/jsTyping/_namespaces/ts.server.ts
	  var init_ts_server = __esm({
	    "src/jsTyping/_namespaces/ts.server.ts"() {
	      init_shared();
	      init_types2();
	    }
	  });

	  // src/jsTyping/jsTyping.ts
	  function isTypingUpToDate(cachedTyping, availableTypingVersions) {
	    const availableVersion = new Version(getProperty(availableTypingVersions, `ts${versionMajorMinor}`) || getProperty(availableTypingVersions, "latest"));
	    return availableVersion.compareTo(cachedTyping.version) <= 0;
	  }
	  function nonRelativeModuleNameForTypingCache(moduleName) {
	    return nodeCoreModules.has(moduleName) ? "node" : moduleName;
	  }
	  function loadSafeList(host, safeListPath) {
	    const result = readConfigFile(safeListPath, (path) => host.readFile(path));
	    return new Map(Object.entries(result.config));
	  }
	  function loadTypesMap(host, typesMapPath) {
	    var _a;
	    const result = readConfigFile(typesMapPath, (path) => host.readFile(path));
	    if ((_a = result.config) == null ? void 0 : _a.simpleMap) {
	      return new Map(Object.entries(result.config.simpleMap));
	    }
	    return void 0;
	  }
	  function discoverTypings(host, log, fileNames, projectRootPath, safeList, packageNameToTypingLocation, typeAcquisition, unresolvedImports, typesRegistry, compilerOptions) {
	    if (!typeAcquisition || !typeAcquisition.enable) {
	      return { cachedTypingPaths: [], newTypingNames: [], filesToWatch: [] };
	    }
	    const inferredTypings = /* @__PURE__ */ new Map();
	    fileNames = mapDefined(fileNames, (fileName) => {
	      const path = normalizePath(fileName);
	      if (hasJSFileExtension(path)) {
	        return path;
	      }
	    });
	    const filesToWatch = [];
	    if (typeAcquisition.include)
	      addInferredTypings(typeAcquisition.include, "Explicitly included types");
	    const exclude = typeAcquisition.exclude || [];
	    if (!compilerOptions.types) {
	      const possibleSearchDirs = new Set(fileNames.map(getDirectoryPath));
	      possibleSearchDirs.add(projectRootPath);
	      possibleSearchDirs.forEach((searchDir) => {
	        getTypingNames(searchDir, "bower.json", "bower_components", filesToWatch);
	        getTypingNames(searchDir, "package.json", "node_modules", filesToWatch);
	      });
	    }
	    if (!typeAcquisition.disableFilenameBasedTypeAcquisition) {
	      getTypingNamesFromSourceFileNames(fileNames);
	    }
	    if (unresolvedImports) {
	      const module2 = deduplicate(
	        unresolvedImports.map(nonRelativeModuleNameForTypingCache),
	        equateStringsCaseSensitive,
	        compareStringsCaseSensitive
	      );
	      addInferredTypings(module2, "Inferred typings from unresolved imports");
	    }
	    for (const excludeTypingName of exclude) {
	      const didDelete = inferredTypings.delete(excludeTypingName);
	      if (didDelete && log)
	        log(`Typing for ${excludeTypingName} is in exclude list, will be ignored.`);
	    }
	    packageNameToTypingLocation.forEach((typing, name) => {
	      const registryEntry = typesRegistry.get(name);
	      if (inferredTypings.get(name) === false && registryEntry !== void 0 && isTypingUpToDate(typing, registryEntry)) {
	        inferredTypings.set(name, typing.typingLocation);
	      }
	    });
	    const newTypingNames = [];
	    const cachedTypingPaths = [];
	    inferredTypings.forEach((inferred, typing) => {
	      if (inferred) {
	        cachedTypingPaths.push(inferred);
	      } else {
	        newTypingNames.push(typing);
	      }
	    });
	    const result = { cachedTypingPaths, newTypingNames, filesToWatch };
	    if (log)
	      log(`Finished typings discovery:${stringifyIndented(result)}`);
	    return result;
	    function addInferredTyping(typingName) {
	      if (!inferredTypings.has(typingName)) {
	        inferredTypings.set(typingName, false);
	      }
	    }
	    function addInferredTypings(typingNames, message) {
	      if (log)
	        log(`${message}: ${JSON.stringify(typingNames)}`);
	      forEach(typingNames, addInferredTyping);
	    }
	    function getTypingNames(projectRootPath2, manifestName, modulesDirName, filesToWatch2) {
	      const manifestPath = combinePaths(projectRootPath2, manifestName);
	      let manifest;
	      let manifestTypingNames;
	      if (host.fileExists(manifestPath)) {
	        filesToWatch2.push(manifestPath);
	        manifest = readConfigFile(manifestPath, (path) => host.readFile(path)).config;
	        manifestTypingNames = flatMap([manifest.dependencies, manifest.devDependencies, manifest.optionalDependencies, manifest.peerDependencies], getOwnKeys);
	        addInferredTypings(manifestTypingNames, `Typing names in '${manifestPath}' dependencies`);
	      }
	      const packagesFolderPath = combinePaths(projectRootPath2, modulesDirName);
	      filesToWatch2.push(packagesFolderPath);
	      if (!host.directoryExists(packagesFolderPath)) {
	        return;
	      }
	      const packageNames = [];
	      const dependencyManifestNames = manifestTypingNames ? manifestTypingNames.map((typingName) => combinePaths(packagesFolderPath, typingName, manifestName)) : host.readDirectory(
	        packagesFolderPath,
	        [".json" /* Json */],
	        /*excludes*/
	        void 0,
	        /*includes*/
	        void 0,
	        /*depth*/
	        3
	      ).filter((manifestPath2) => {
	        if (getBaseFileName(manifestPath2) !== manifestName) {
	          return false;
	        }
	        const pathComponents2 = getPathComponents(normalizePath(manifestPath2));
	        const isScoped = pathComponents2[pathComponents2.length - 3][0] === "@";
	        return isScoped && toFileNameLowerCase(pathComponents2[pathComponents2.length - 4]) === modulesDirName || // `node_modules/@foo/bar`
	        !isScoped && toFileNameLowerCase(pathComponents2[pathComponents2.length - 3]) === modulesDirName;
	      });
	      if (log)
	        log(`Searching for typing names in ${packagesFolderPath}; all files: ${JSON.stringify(dependencyManifestNames)}`);
	      for (const manifestPath2 of dependencyManifestNames) {
	        const normalizedFileName = normalizePath(manifestPath2);
	        const result2 = readConfigFile(normalizedFileName, (path) => host.readFile(path));
	        const manifest2 = result2.config;
	        if (!manifest2.name) {
	          continue;
	        }
	        const ownTypes = manifest2.types || manifest2.typings;
	        if (ownTypes) {
	          const absolutePath = getNormalizedAbsolutePath(ownTypes, getDirectoryPath(normalizedFileName));
	          if (host.fileExists(absolutePath)) {
	            if (log)
	              log(`    Package '${manifest2.name}' provides its own types.`);
	            inferredTypings.set(manifest2.name, absolutePath);
	          } else {
	            if (log)
	              log(`    Package '${manifest2.name}' provides its own types but they are missing.`);
	          }
	        } else {
	          packageNames.push(manifest2.name);
	        }
	      }
	      addInferredTypings(packageNames, "    Found package names");
	    }
	    function getTypingNamesFromSourceFileNames(fileNames2) {
	      const fromFileNames = mapDefined(fileNames2, (j) => {
	        if (!hasJSFileExtension(j))
	          return void 0;
	        const inferredTypingName = removeFileExtension(toFileNameLowerCase(getBaseFileName(j)));
	        const cleanedTypingName = removeMinAndVersionNumbers(inferredTypingName);
	        return safeList.get(cleanedTypingName);
	      });
	      if (fromFileNames.length) {
	        addInferredTypings(fromFileNames, "Inferred typings from file names");
	      }
	      const hasJsxFile = some(fileNames2, (f) => fileExtensionIs(f, ".jsx" /* Jsx */));
	      if (hasJsxFile) {
	        if (log)
	          log(`Inferred 'react' typings due to presence of '.jsx' extension`);
	        addInferredTyping("react");
	      }
	    }
	  }
	  function validatePackageName(packageName) {
	    return validatePackageNameWorker(
	      packageName,
	      /*supportScopedPackage*/
	      true
	    );
	  }
	  function validatePackageNameWorker(packageName, supportScopedPackage) {
	    if (!packageName) {
	      return 1 /* EmptyName */;
	    }
	    if (packageName.length > maxPackageNameLength) {
	      return 2 /* NameTooLong */;
	    }
	    if (packageName.charCodeAt(0) === 46 /* dot */) {
	      return 3 /* NameStartsWithDot */;
	    }
	    if (packageName.charCodeAt(0) === 95 /* _ */) {
	      return 4 /* NameStartsWithUnderscore */;
	    }
	    if (supportScopedPackage) {
	      const matches = /^@([^/]+)\/([^/]+)$/.exec(packageName);
	      if (matches) {
	        const scopeResult = validatePackageNameWorker(
	          matches[1],
	          /*supportScopedPackage*/
	          false
	        );
	        if (scopeResult !== 0 /* Ok */) {
	          return { name: matches[1], isScopeName: true, result: scopeResult };
	        }
	        const packageResult = validatePackageNameWorker(
	          matches[2],
	          /*supportScopedPackage*/
	          false
	        );
	        if (packageResult !== 0 /* Ok */) {
	          return { name: matches[2], isScopeName: false, result: packageResult };
	        }
	        return 0 /* Ok */;
	      }
	    }
	    if (encodeURIComponent(packageName) !== packageName) {
	      return 5 /* NameContainsNonURISafeCharacters */;
	    }
	    return 0 /* Ok */;
	  }
	  function renderPackageNameValidationFailure(result, typing) {
	    return typeof result === "object" ? renderPackageNameValidationFailureWorker(typing, result.result, result.name, result.isScopeName) : renderPackageNameValidationFailureWorker(
	      typing,
	      result,
	      typing,
	      /*isScopeName*/
	      false
	    );
	  }
	  function renderPackageNameValidationFailureWorker(typing, result, name, isScopeName) {
	    const kind = isScopeName ? "Scope" : "Package";
	    switch (result) {
	      case 1 /* EmptyName */:
	        return `'${typing}':: ${kind} name '${name}' cannot be empty`;
	      case 2 /* NameTooLong */:
	        return `'${typing}':: ${kind} name '${name}' should be less than ${maxPackageNameLength} characters`;
	      case 3 /* NameStartsWithDot */:
	        return `'${typing}':: ${kind} name '${name}' cannot start with '.'`;
	      case 4 /* NameStartsWithUnderscore */:
	        return `'${typing}':: ${kind} name '${name}' cannot start with '_'`;
	      case 5 /* NameContainsNonURISafeCharacters */:
	        return `'${typing}':: ${kind} name '${name}' contains non URI safe characters`;
	      case 0 /* Ok */:
	        return Debug.fail();
	      default:
	        Debug.assertNever(result);
	    }
	  }
	  var unprefixedNodeCoreModuleList, prefixedNodeCoreModuleList, nodeCoreModuleList, nodeCoreModules, NameValidationResult, maxPackageNameLength;
	  var init_jsTyping = __esm({
	    "src/jsTyping/jsTyping.ts"() {
	      init_ts3();
	      init_ts_server();
	      unprefixedNodeCoreModuleList = [
	        "assert",
	        "assert/strict",
	        "async_hooks",
	        "buffer",
	        "child_process",
	        "cluster",
	        "console",
	        "constants",
	        "crypto",
	        "dgram",
	        "diagnostics_channel",
	        "dns",
	        "dns/promises",
	        "domain",
	        "events",
	        "fs",
	        "fs/promises",
	        "http",
	        "https",
	        "http2",
	        "inspector",
	        "module",
	        "net",
	        "os",
	        "path",
	        "perf_hooks",
	        "process",
	        "punycode",
	        "querystring",
	        "readline",
	        "repl",
	        "stream",
	        "stream/promises",
	        "string_decoder",
	        "timers",
	        "timers/promises",
	        "tls",
	        "trace_events",
	        "tty",
	        "url",
	        "util",
	        "util/types",
	        "v8",
	        "vm",
	        "wasi",
	        "worker_threads",
	        "zlib"
	      ];
	      prefixedNodeCoreModuleList = unprefixedNodeCoreModuleList.map((name) => `node:${name}`);
	      nodeCoreModuleList = [...unprefixedNodeCoreModuleList, ...prefixedNodeCoreModuleList];
	      nodeCoreModules = new Set(nodeCoreModuleList);
	      NameValidationResult = /* @__PURE__ */ ((NameValidationResult2) => {
	        NameValidationResult2[NameValidationResult2["Ok"] = 0] = "Ok";
	        NameValidationResult2[NameValidationResult2["EmptyName"] = 1] = "EmptyName";
	        NameValidationResult2[NameValidationResult2["NameTooLong"] = 2] = "NameTooLong";
	        NameValidationResult2[NameValidationResult2["NameStartsWithDot"] = 3] = "NameStartsWithDot";
	        NameValidationResult2[NameValidationResult2["NameStartsWithUnderscore"] = 4] = "NameStartsWithUnderscore";
	        NameValidationResult2[NameValidationResult2["NameContainsNonURISafeCharacters"] = 5] = "NameContainsNonURISafeCharacters";
	        return NameValidationResult2;
	      })(NameValidationResult || {});
	      maxPackageNameLength = 214;
	    }
	  });

	  // src/jsTyping/_namespaces/ts.JsTyping.ts
	  var ts_JsTyping_exports = {};
	  __export(ts_JsTyping_exports, {
	    NameValidationResult: () => NameValidationResult,
	    discoverTypings: () => discoverTypings,
	    isTypingUpToDate: () => isTypingUpToDate,
	    loadSafeList: () => loadSafeList,
	    loadTypesMap: () => loadTypesMap,
	    nodeCoreModuleList: () => nodeCoreModuleList,
	    nodeCoreModules: () => nodeCoreModules,
	    nonRelativeModuleNameForTypingCache: () => nonRelativeModuleNameForTypingCache,
	    prefixedNodeCoreModuleList: () => prefixedNodeCoreModuleList,
	    renderPackageNameValidationFailure: () => renderPackageNameValidationFailure,
	    validatePackageName: () => validatePackageName
	  });
	  var init_ts_JsTyping = __esm({
	    "src/jsTyping/_namespaces/ts.JsTyping.ts"() {
	      init_jsTyping();
	    }
	  });

	  // src/jsTyping/_namespaces/ts.ts
	  var init_ts3 = __esm({
	    "src/jsTyping/_namespaces/ts.ts"() {
	      init_ts2();
	      init_ts_JsTyping();
	      init_ts_server();
	    }
	  });

	  // src/services/types.ts
	  function getDefaultFormatCodeSettings(newLineCharacter) {
	    return {
	      indentSize: 4,
	      tabSize: 4,
	      newLineCharacter: newLineCharacter || "\n",
	      convertTabsToSpaces: true,
	      indentStyle: 2 /* Smart */,
	      insertSpaceAfterConstructor: false,
	      insertSpaceAfterCommaDelimiter: true,
	      insertSpaceAfterSemicolonInForStatements: true,
	      insertSpaceBeforeAndAfterBinaryOperators: true,
	      insertSpaceAfterKeywordsInControlFlowStatements: true,
	      insertSpaceAfterFunctionKeywordForAnonymousFunctions: false,
	      insertSpaceAfterOpeningAndBeforeClosingNonemptyParenthesis: false,
	      insertSpaceAfterOpeningAndBeforeClosingNonemptyBrackets: false,
	      insertSpaceAfterOpeningAndBeforeClosingNonemptyBraces: true,
	      insertSpaceAfterOpeningAndBeforeClosingTemplateStringBraces: false,
	      insertSpaceAfterOpeningAndBeforeClosingJsxExpressionBraces: false,
	      insertSpaceBeforeFunctionParenthesis: false,
	      placeOpenBraceOnNewLineForFunctions: false,
	      placeOpenBraceOnNewLineForControlBlocks: false,
	      semicolons: "ignore" /* Ignore */,
	      trimTrailingWhitespace: true,
	      indentSwitchCase: true
	    };
	  }
	  var ScriptSnapshot, PackageJsonDependencyGroup, PackageJsonAutoImportPreference, LanguageServiceMode, emptyOptions, SemanticClassificationFormat, OrganizeImportsMode, CompletionTriggerKind, InlayHintKind, HighlightSpanKind, IndentStyle, SemicolonPreference, testFormatSettings, SymbolDisplayPartKind, CompletionInfoFlags, OutliningSpanKind, OutputFileType, EndOfLineState, TokenClass, ScriptElementKind, ScriptElementKindModifier, ClassificationTypeNames, ClassificationType;
	  var init_types3 = __esm({
	    "src/services/types.ts"() {
	      ((ScriptSnapshot2) => {
	        class StringScriptSnapshot {
	          constructor(text) {
	            this.text = text;
	          }
	          getText(start, end) {
	            return start === 0 && end === this.text.length ? this.text : this.text.substring(start, end);
	          }
	          getLength() {
	            return this.text.length;
	          }
	          getChangeRange() {
	            return void 0;
	          }
	        }
	        function fromString(text) {
	          return new StringScriptSnapshot(text);
	        }
	        ScriptSnapshot2.fromString = fromString;
	      })(ScriptSnapshot || (ScriptSnapshot = {}));
	      PackageJsonDependencyGroup = /* @__PURE__ */ ((PackageJsonDependencyGroup2) => {
	        PackageJsonDependencyGroup2[PackageJsonDependencyGroup2["Dependencies"] = 1] = "Dependencies";
	        PackageJsonDependencyGroup2[PackageJsonDependencyGroup2["DevDependencies"] = 2] = "DevDependencies";
	        PackageJsonDependencyGroup2[PackageJsonDependencyGroup2["PeerDependencies"] = 4] = "PeerDependencies";
	        PackageJsonDependencyGroup2[PackageJsonDependencyGroup2["OptionalDependencies"] = 8] = "OptionalDependencies";
	        PackageJsonDependencyGroup2[PackageJsonDependencyGroup2["All"] = 15] = "All";
	        return PackageJsonDependencyGroup2;
	      })(PackageJsonDependencyGroup || {});
	      PackageJsonAutoImportPreference = /* @__PURE__ */ ((PackageJsonAutoImportPreference2) => {
	        PackageJsonAutoImportPreference2[PackageJsonAutoImportPreference2["Off"] = 0] = "Off";
	        PackageJsonAutoImportPreference2[PackageJsonAutoImportPreference2["On"] = 1] = "On";
	        PackageJsonAutoImportPreference2[PackageJsonAutoImportPreference2["Auto"] = 2] = "Auto";
	        return PackageJsonAutoImportPreference2;
	      })(PackageJsonAutoImportPreference || {});
	      LanguageServiceMode = /* @__PURE__ */ ((LanguageServiceMode2) => {
	        LanguageServiceMode2[LanguageServiceMode2["Semantic"] = 0] = "Semantic";
	        LanguageServiceMode2[LanguageServiceMode2["PartialSemantic"] = 1] = "PartialSemantic";
	        LanguageServiceMode2[LanguageServiceMode2["Syntactic"] = 2] = "Syntactic";
	        return LanguageServiceMode2;
	      })(LanguageServiceMode || {});
	      emptyOptions = {};
	      SemanticClassificationFormat = /* @__PURE__ */ ((SemanticClassificationFormat2) => {
	        SemanticClassificationFormat2["Original"] = "original";
	        SemanticClassificationFormat2["TwentyTwenty"] = "2020";
	        return SemanticClassificationFormat2;
	      })(SemanticClassificationFormat || {});
	      OrganizeImportsMode = /* @__PURE__ */ ((OrganizeImportsMode3) => {
	        OrganizeImportsMode3["All"] = "All";
	        OrganizeImportsMode3["SortAndCombine"] = "SortAndCombine";
	        OrganizeImportsMode3["RemoveUnused"] = "RemoveUnused";
	        return OrganizeImportsMode3;
	      })(OrganizeImportsMode || {});
	      CompletionTriggerKind = /* @__PURE__ */ ((CompletionTriggerKind4) => {
	        CompletionTriggerKind4[CompletionTriggerKind4["Invoked"] = 1] = "Invoked";
	        CompletionTriggerKind4[CompletionTriggerKind4["TriggerCharacter"] = 2] = "TriggerCharacter";
	        CompletionTriggerKind4[CompletionTriggerKind4["TriggerForIncompleteCompletions"] = 3] = "TriggerForIncompleteCompletions";
	        return CompletionTriggerKind4;
	      })(CompletionTriggerKind || {});
	      InlayHintKind = /* @__PURE__ */ ((InlayHintKind2) => {
	        InlayHintKind2["Type"] = "Type";
	        InlayHintKind2["Parameter"] = "Parameter";
	        InlayHintKind2["Enum"] = "Enum";
	        return InlayHintKind2;
	      })(InlayHintKind || {});
	      HighlightSpanKind = /* @__PURE__ */ ((HighlightSpanKind2) => {
	        HighlightSpanKind2["none"] = "none";
	        HighlightSpanKind2["definition"] = "definition";
	        HighlightSpanKind2["reference"] = "reference";
	        HighlightSpanKind2["writtenReference"] = "writtenReference";
	        return HighlightSpanKind2;
	      })(HighlightSpanKind || {});
	      IndentStyle = /* @__PURE__ */ ((IndentStyle3) => {
	        IndentStyle3[IndentStyle3["None"] = 0] = "None";
	        IndentStyle3[IndentStyle3["Block"] = 1] = "Block";
	        IndentStyle3[IndentStyle3["Smart"] = 2] = "Smart";
	        return IndentStyle3;
	      })(IndentStyle || {});
	      SemicolonPreference = /* @__PURE__ */ ((SemicolonPreference3) => {
	        SemicolonPreference3["Ignore"] = "ignore";
	        SemicolonPreference3["Insert"] = "insert";
	        SemicolonPreference3["Remove"] = "remove";
	        return SemicolonPreference3;
	      })(SemicolonPreference || {});
	      testFormatSettings = getDefaultFormatCodeSettings("\n");
	      SymbolDisplayPartKind = /* @__PURE__ */ ((SymbolDisplayPartKind2) => {
	        SymbolDisplayPartKind2[SymbolDisplayPartKind2["aliasName"] = 0] = "aliasName";
	        SymbolDisplayPartKind2[SymbolDisplayPartKind2["className"] = 1] = "className";
	        SymbolDisplayPartKind2[SymbolDisplayPartKind2["enumName"] = 2] = "enumName";
	        SymbolDisplayPartKind2[SymbolDisplayPartKind2["fieldName"] = 3] = "fieldName";
	        SymbolDisplayPartKind2[SymbolDisplayPartKind2["interfaceName"] = 4] = "interfaceName";
	        SymbolDisplayPartKind2[SymbolDisplayPartKind2["keyword"] = 5] = "keyword";
	        SymbolDisplayPartKind2[SymbolDisplayPartKind2["lineBreak"] = 6] = "lineBreak";
	        SymbolDisplayPartKind2[SymbolDisplayPartKind2["numericLiteral"] = 7] = "numericLiteral";
	        SymbolDisplayPartKind2[SymbolDisplayPartKind2["stringLiteral"] = 8] = "stringLiteral";
	        SymbolDisplayPartKind2[SymbolDisplayPartKind2["localName"] = 9] = "localName";
	        SymbolDisplayPartKind2[SymbolDisplayPartKind2["methodName"] = 10] = "methodName";
	        SymbolDisplayPartKind2[SymbolDisplayPartKind2["moduleName"] = 11] = "moduleName";
	        SymbolDisplayPartKind2[SymbolDisplayPartKind2["operator"] = 12] = "operator";
	        SymbolDisplayPartKind2[SymbolDisplayPartKind2["parameterName"] = 13] = "parameterName";
	        SymbolDisplayPartKind2[SymbolDisplayPartKind2["propertyName"] = 14] = "propertyName";
	        SymbolDisplayPartKind2[SymbolDisplayPartKind2["punctuation"] = 15] = "punctuation";
	        SymbolDisplayPartKind2[SymbolDisplayPartKind2["space"] = 16] = "space";
	        SymbolDisplayPartKind2[SymbolDisplayPartKind2["text"] = 17] = "text";
	        SymbolDisplayPartKind2[SymbolDisplayPartKind2["typeParameterName"] = 18] = "typeParameterName";
	        SymbolDisplayPartKind2[SymbolDisplayPartKind2["enumMemberName"] = 19] = "enumMemberName";
	        SymbolDisplayPartKind2[SymbolDisplayPartKind2["functionName"] = 20] = "functionName";
	        SymbolDisplayPartKind2[SymbolDisplayPartKind2["regularExpressionLiteral"] = 21] = "regularExpressionLiteral";
	        SymbolDisplayPartKind2[SymbolDisplayPartKind2["link"] = 22] = "link";
	        SymbolDisplayPartKind2[SymbolDisplayPartKind2["linkName"] = 23] = "linkName";
	        SymbolDisplayPartKind2[SymbolDisplayPartKind2["linkText"] = 24] = "linkText";
	        return SymbolDisplayPartKind2;
	      })(SymbolDisplayPartKind || {});
	      CompletionInfoFlags = /* @__PURE__ */ ((CompletionInfoFlags2) => {
	        CompletionInfoFlags2[CompletionInfoFlags2["None"] = 0] = "None";
	        CompletionInfoFlags2[CompletionInfoFlags2["MayIncludeAutoImports"] = 1] = "MayIncludeAutoImports";
	        CompletionInfoFlags2[CompletionInfoFlags2["IsImportStatementCompletion"] = 2] = "IsImportStatementCompletion";
	        CompletionInfoFlags2[CompletionInfoFlags2["IsContinuation"] = 4] = "IsContinuation";
	        CompletionInfoFlags2[CompletionInfoFlags2["ResolvedModuleSpecifiers"] = 8] = "ResolvedModuleSpecifiers";
	        CompletionInfoFlags2[CompletionInfoFlags2["ResolvedModuleSpecifiersBeyondLimit"] = 16] = "ResolvedModuleSpecifiersBeyondLimit";
	        CompletionInfoFlags2[CompletionInfoFlags2["MayIncludeMethodSnippets"] = 32] = "MayIncludeMethodSnippets";
	        return CompletionInfoFlags2;
	      })(CompletionInfoFlags || {});
	      OutliningSpanKind = /* @__PURE__ */ ((OutliningSpanKind2) => {
	        OutliningSpanKind2["Comment"] = "comment";
	        OutliningSpanKind2["Region"] = "region";
	        OutliningSpanKind2["Code"] = "code";
	        OutliningSpanKind2["Imports"] = "imports";
	        return OutliningSpanKind2;
	      })(OutliningSpanKind || {});
	      OutputFileType = /* @__PURE__ */ ((OutputFileType2) => {
	        OutputFileType2[OutputFileType2["JavaScript"] = 0] = "JavaScript";
	        OutputFileType2[OutputFileType2["SourceMap"] = 1] = "SourceMap";
	        OutputFileType2[OutputFileType2["Declaration"] = 2] = "Declaration";
	        return OutputFileType2;
	      })(OutputFileType || {});
	      EndOfLineState = /* @__PURE__ */ ((EndOfLineState2) => {
	        EndOfLineState2[EndOfLineState2["None"] = 0] = "None";
	        EndOfLineState2[EndOfLineState2["InMultiLineCommentTrivia"] = 1] = "InMultiLineCommentTrivia";
	        EndOfLineState2[EndOfLineState2["InSingleQuoteStringLiteral"] = 2] = "InSingleQuoteStringLiteral";
	        EndOfLineState2[EndOfLineState2["InDoubleQuoteStringLiteral"] = 3] = "InDoubleQuoteStringLiteral";
	        EndOfLineState2[EndOfLineState2["InTemplateHeadOrNoSubstitutionTemplate"] = 4] = "InTemplateHeadOrNoSubstitutionTemplate";
	        EndOfLineState2[EndOfLineState2["InTemplateMiddleOrTail"] = 5] = "InTemplateMiddleOrTail";
	        EndOfLineState2[EndOfLineState2["InTemplateSubstitutionPosition"] = 6] = "InTemplateSubstitutionPosition";
	        return EndOfLineState2;
	      })(EndOfLineState || {});
	      TokenClass = /* @__PURE__ */ ((TokenClass2) => {
	        TokenClass2[TokenClass2["Punctuation"] = 0] = "Punctuation";
	        TokenClass2[TokenClass2["Keyword"] = 1] = "Keyword";
	        TokenClass2[TokenClass2["Operator"] = 2] = "Operator";
	        TokenClass2[TokenClass2["Comment"] = 3] = "Comment";
	        TokenClass2[TokenClass2["Whitespace"] = 4] = "Whitespace";
	        TokenClass2[TokenClass2["Identifier"] = 5] = "Identifier";
	        TokenClass2[TokenClass2["NumberLiteral"] = 6] = "NumberLiteral";
	        TokenClass2[TokenClass2["BigIntLiteral"] = 7] = "BigIntLiteral";
	        TokenClass2[TokenClass2["StringLiteral"] = 8] = "StringLiteral";
	        TokenClass2[TokenClass2["RegExpLiteral"] = 9] = "RegExpLiteral";
	        return TokenClass2;
	      })(TokenClass || {});
	      ScriptElementKind = /* @__PURE__ */ ((ScriptElementKind2) => {
	        ScriptElementKind2["unknown"] = "";
	        ScriptElementKind2["warning"] = "warning";
	        ScriptElementKind2["keyword"] = "keyword";
	        ScriptElementKind2["scriptElement"] = "script";
	        ScriptElementKind2["moduleElement"] = "module";
	        ScriptElementKind2["classElement"] = "class";
	        ScriptElementKind2["localClassElement"] = "local class";
	        ScriptElementKind2["interfaceElement"] = "interface";
	        ScriptElementKind2["typeElement"] = "type";
	        ScriptElementKind2["enumElement"] = "enum";
	        ScriptElementKind2["enumMemberElement"] = "enum member";
	        ScriptElementKind2["variableElement"] = "var";
	        ScriptElementKind2["localVariableElement"] = "local var";
	        ScriptElementKind2["variableUsingElement"] = "using";
	        ScriptElementKind2["variableAwaitUsingElement"] = "await using";
	        ScriptElementKind2["functionElement"] = "function";
	        ScriptElementKind2["localFunctionElement"] = "local function";
	        ScriptElementKind2["memberFunctionElement"] = "method";
	        ScriptElementKind2["memberGetAccessorElement"] = "getter";
	        ScriptElementKind2["memberSetAccessorElement"] = "setter";
	        ScriptElementKind2["memberVariableElement"] = "property";
	        ScriptElementKind2["memberAccessorVariableElement"] = "accessor";
	        ScriptElementKind2["constructorImplementationElement"] = "constructor";
	        ScriptElementKind2["callSignatureElement"] = "call";
	        ScriptElementKind2["indexSignatureElement"] = "index";
	        ScriptElementKind2["constructSignatureElement"] = "construct";
	        ScriptElementKind2["parameterElement"] = "parameter";
	        ScriptElementKind2["typeParameterElement"] = "type parameter";
	        ScriptElementKind2["primitiveType"] = "primitive type";
	        ScriptElementKind2["label"] = "label";
	        ScriptElementKind2["alias"] = "alias";
	        ScriptElementKind2["constElement"] = "const";
	        ScriptElementKind2["letElement"] = "let";
	        ScriptElementKind2["directory"] = "directory";
	        ScriptElementKind2["externalModuleName"] = "external module name";
	        ScriptElementKind2["jsxAttribute"] = "JSX attribute";
	        ScriptElementKind2["string"] = "string";
	        ScriptElementKind2["link"] = "link";
	        ScriptElementKind2["linkName"] = "link name";
	        ScriptElementKind2["linkText"] = "link text";
	        return ScriptElementKind2;
	      })(ScriptElementKind || {});
	      ScriptElementKindModifier = /* @__PURE__ */ ((ScriptElementKindModifier2) => {
	        ScriptElementKindModifier2["none"] = "";
	        ScriptElementKindModifier2["publicMemberModifier"] = "public";
	        ScriptElementKindModifier2["privateMemberModifier"] = "private";
	        ScriptElementKindModifier2["protectedMemberModifier"] = "protected";
	        ScriptElementKindModifier2["exportedModifier"] = "export";
	        ScriptElementKindModifier2["ambientModifier"] = "declare";
	        ScriptElementKindModifier2["staticModifier"] = "static";
	        ScriptElementKindModifier2["abstractModifier"] = "abstract";
	        ScriptElementKindModifier2["optionalModifier"] = "optional";
	        ScriptElementKindModifier2["deprecatedModifier"] = "deprecated";
	        ScriptElementKindModifier2["dtsModifier"] = ".d.ts";
	        ScriptElementKindModifier2["tsModifier"] = ".ts";
	        ScriptElementKindModifier2["tsxModifier"] = ".tsx";
	        ScriptElementKindModifier2["jsModifier"] = ".js";
	        ScriptElementKindModifier2["jsxModifier"] = ".jsx";
	        ScriptElementKindModifier2["jsonModifier"] = ".json";
	        ScriptElementKindModifier2["dmtsModifier"] = ".d.mts";
	        ScriptElementKindModifier2["mtsModifier"] = ".mts";
	        ScriptElementKindModifier2["mjsModifier"] = ".mjs";
	        ScriptElementKindModifier2["dctsModifier"] = ".d.cts";
	        ScriptElementKindModifier2["ctsModifier"] = ".cts";
	        ScriptElementKindModifier2["cjsModifier"] = ".cjs";
	        return ScriptElementKindModifier2;
	      })(ScriptElementKindModifier || {});
	      ClassificationTypeNames = /* @__PURE__ */ ((ClassificationTypeNames2) => {
	        ClassificationTypeNames2["comment"] = "comment";
	        ClassificationTypeNames2["identifier"] = "identifier";
	        ClassificationTypeNames2["keyword"] = "keyword";
	        ClassificationTypeNames2["numericLiteral"] = "number";
	        ClassificationTypeNames2["bigintLiteral"] = "bigint";
	        ClassificationTypeNames2["operator"] = "operator";
	        ClassificationTypeNames2["stringLiteral"] = "string";
	        ClassificationTypeNames2["whiteSpace"] = "whitespace";
	        ClassificationTypeNames2["text"] = "text";
	        ClassificationTypeNames2["punctuation"] = "punctuation";
	        ClassificationTypeNames2["className"] = "class name";
	        ClassificationTypeNames2["enumName"] = "enum name";
	        ClassificationTypeNames2["interfaceName"] = "interface name";
	        ClassificationTypeNames2["moduleName"] = "module name";
	        ClassificationTypeNames2["typeParameterName"] = "type parameter name";
	        ClassificationTypeNames2["typeAliasName"] = "type alias name";
	        ClassificationTypeNames2["parameterName"] = "parameter name";
	        ClassificationTypeNames2["docCommentTagName"] = "doc comment tag name";
	        ClassificationTypeNames2["jsxOpenTagName"] = "jsx open tag name";
	        ClassificationTypeNames2["jsxCloseTagName"] = "jsx close tag name";
	        ClassificationTypeNames2["jsxSelfClosingTagName"] = "jsx self closing tag name";
	        ClassificationTypeNames2["jsxAttribute"] = "jsx attribute";
	        ClassificationTypeNames2["jsxText"] = "jsx text";
	        ClassificationTypeNames2["jsxAttributeStringLiteralValue"] = "jsx attribute string literal value";
	        return ClassificationTypeNames2;
	      })(ClassificationTypeNames || {});
	      ClassificationType = /* @__PURE__ */ ((ClassificationType3) => {
	        ClassificationType3[ClassificationType3["comment"] = 1] = "comment";
	        ClassificationType3[ClassificationType3["identifier"] = 2] = "identifier";
	        ClassificationType3[ClassificationType3["keyword"] = 3] = "keyword";
	        ClassificationType3[ClassificationType3["numericLiteral"] = 4] = "numericLiteral";
	        ClassificationType3[ClassificationType3["operator"] = 5] = "operator";
	        ClassificationType3[ClassificationType3["stringLiteral"] = 6] = "stringLiteral";
	        ClassificationType3[ClassificationType3["regularExpressionLiteral"] = 7] = "regularExpressionLiteral";
	        ClassificationType3[ClassificationType3["whiteSpace"] = 8] = "whiteSpace";
	        ClassificationType3[ClassificationType3["text"] = 9] = "text";
	        ClassificationType3[ClassificationType3["punctuation"] = 10] = "punctuation";
	        ClassificationType3[ClassificationType3["className"] = 11] = "className";
	        ClassificationType3[ClassificationType3["enumName"] = 12] = "enumName";
	        ClassificationType3[ClassificationType3["interfaceName"] = 13] = "interfaceName";
	        ClassificationType3[ClassificationType3["moduleName"] = 14] = "moduleName";
	        ClassificationType3[ClassificationType3["typeParameterName"] = 15] = "typeParameterName";
	        ClassificationType3[ClassificationType3["typeAliasName"] = 16] = "typeAliasName";
	        ClassificationType3[ClassificationType3["parameterName"] = 17] = "parameterName";
	        ClassificationType3[ClassificationType3["docCommentTagName"] = 18] = "docCommentTagName";
	        ClassificationType3[ClassificationType3["jsxOpenTagName"] = 19] = "jsxOpenTagName";
	        ClassificationType3[ClassificationType3["jsxCloseTagName"] = 20] = "jsxCloseTagName";
	        ClassificationType3[ClassificationType3["jsxSelfClosingTagName"] = 21] = "jsxSelfClosingTagName";
	        ClassificationType3[ClassificationType3["jsxAttribute"] = 22] = "jsxAttribute";
	        ClassificationType3[ClassificationType3["jsxText"] = 23] = "jsxText";
	        ClassificationType3[ClassificationType3["jsxAttributeStringLiteralValue"] = 24] = "jsxAttributeStringLiteralValue";
	        ClassificationType3[ClassificationType3["bigintLiteral"] = 25] = "bigintLiteral";
	        return ClassificationType3;
	      })(ClassificationType || {});
	    }
	  });

	  // src/services/utilities.ts
	  function getMeaningFromDeclaration(node) {
	    switch (node.kind) {
	      case 260 /* VariableDeclaration */:
	        return isInJSFile(node) && getJSDocEnumTag(node) ? 7 /* All */ : 1 /* Value */;
	      case 169 /* Parameter */:
	      case 208 /* BindingElement */:
	      case 172 /* PropertyDeclaration */:
	      case 171 /* PropertySignature */:
	      case 303 /* PropertyAssignment */:
	      case 304 /* ShorthandPropertyAssignment */:
	      case 174 /* MethodDeclaration */:
	      case 173 /* MethodSignature */:
	      case 176 /* Constructor */:
	      case 177 /* GetAccessor */:
	      case 178 /* SetAccessor */:
	      case 262 /* FunctionDeclaration */:
	      case 218 /* FunctionExpression */:
	      case 219 /* ArrowFunction */:
	      case 299 /* CatchClause */:
	      case 291 /* JsxAttribute */:
	        return 1 /* Value */;
	      case 168 /* TypeParameter */:
	      case 264 /* InterfaceDeclaration */:
	      case 265 /* TypeAliasDeclaration */:
	      case 187 /* TypeLiteral */:
	        return 2 /* Type */;
	      case 353 /* JSDocTypedefTag */:
	        return node.name === void 0 ? 1 /* Value */ | 2 /* Type */ : 2 /* Type */;
	      case 306 /* EnumMember */:
	      case 263 /* ClassDeclaration */:
	        return 1 /* Value */ | 2 /* Type */;
	      case 267 /* ModuleDeclaration */:
	        if (isAmbientModule(node)) {
	          return 4 /* Namespace */ | 1 /* Value */;
	        } else if (getModuleInstanceState(node) === 1 /* Instantiated */) {
	          return 4 /* Namespace */ | 1 /* Value */;
	        } else {
	          return 4 /* Namespace */;
	        }
	      case 266 /* EnumDeclaration */:
	      case 275 /* NamedImports */:
	      case 276 /* ImportSpecifier */:
	      case 271 /* ImportEqualsDeclaration */:
	      case 272 /* ImportDeclaration */:
	      case 277 /* ExportAssignment */:
	      case 278 /* ExportDeclaration */:
	        return 7 /* All */;
	      case 312 /* SourceFile */:
	        return 4 /* Namespace */ | 1 /* Value */;
	    }
	    return 7 /* All */;
	  }
	  function getMeaningFromLocation(node) {
	    node = getAdjustedReferenceLocation(node);
	    const parent2 = node.parent;
	    if (node.kind === 312 /* SourceFile */) {
	      return 1 /* Value */;
	    } else if (isExportAssignment(parent2) || isExportSpecifier(parent2) || isExternalModuleReference(parent2) || isImportSpecifier(parent2) || isImportClause(parent2) || isImportEqualsDeclaration(parent2) && node === parent2.name) {
	      return 7 /* All */;
	    } else if (isInRightSideOfInternalImportEqualsDeclaration(node)) {
	      return getMeaningFromRightHandSideOfImportEquals(node);
	    } else if (isDeclarationName(node)) {
	      return getMeaningFromDeclaration(parent2);
	    } else if (isEntityName(node) && findAncestor(node, or(isJSDocNameReference, isJSDocLinkLike, isJSDocMemberName))) {
	      return 7 /* All */;
	    } else if (isTypeReference(node)) {
	      return 2 /* Type */;
	    } else if (isNamespaceReference(node)) {
	      return 4 /* Namespace */;
	    } else if (isTypeParameterDeclaration(parent2)) {
	      Debug.assert(isJSDocTemplateTag(parent2.parent));
	      return 2 /* Type */;
	    } else if (isLiteralTypeNode(parent2)) {
	      return 2 /* Type */ | 1 /* Value */;
	    } else {
	      return 1 /* Value */;
	    }
	  }
	  function getMeaningFromRightHandSideOfImportEquals(node) {
	    const name = node.kind === 166 /* QualifiedName */ ? node : isQualifiedName(node.parent) && node.parent.right === node ? node.parent : void 0;
	    return name && name.parent.kind === 271 /* ImportEqualsDeclaration */ ? 7 /* All */ : 4 /* Namespace */;
	  }
	  function isInRightSideOfInternalImportEqualsDeclaration(node) {
	    while (node.parent.kind === 166 /* QualifiedName */) {
	      node = node.parent;
	    }
	    return isInternalModuleImportEqualsDeclaration(node.parent) && node.parent.moduleReference === node;
	  }
	  function isNamespaceReference(node) {
	    return isQualifiedNameNamespaceReference(node) || isPropertyAccessNamespaceReference(node);
	  }
	  function isQualifiedNameNamespaceReference(node) {
	    let root = node;
	    let isLastClause = true;
	    if (root.parent.kind === 166 /* QualifiedName */) {
	      while (root.parent && root.parent.kind === 166 /* QualifiedName */) {
	        root = root.parent;
	      }
	      isLastClause = root.right === node;
	    }
	    return root.parent.kind === 183 /* TypeReference */ && !isLastClause;
	  }
	  function isPropertyAccessNamespaceReference(node) {
	    let root = node;
	    let isLastClause = true;
	    if (root.parent.kind === 211 /* PropertyAccessExpression */) {
	      while (root.parent && root.parent.kind === 211 /* PropertyAccessExpression */) {
	        root = root.parent;
	      }
	      isLastClause = root.name === node;
	    }
	    if (!isLastClause && root.parent.kind === 233 /* ExpressionWithTypeArguments */ && root.parent.parent.kind === 298 /* HeritageClause */) {
	      const decl = root.parent.parent.parent;
	      return decl.kind === 263 /* ClassDeclaration */ && root.parent.parent.token === 119 /* ImplementsKeyword */ || decl.kind === 264 /* InterfaceDeclaration */ && root.parent.parent.token === 96 /* ExtendsKeyword */;
	    }
	    return false;
	  }
	  function isTypeReference(node) {
	    if (isRightSideOfQualifiedNameOrPropertyAccess(node)) {
	      node = node.parent;
	    }
	    switch (node.kind) {
	      case 110 /* ThisKeyword */:
	        return !isExpressionNode(node);
	      case 197 /* ThisType */:
	        return true;
	    }
	    switch (node.parent.kind) {
	      case 183 /* TypeReference */:
	        return true;
	      case 205 /* ImportType */:
	        return !node.parent.isTypeOf;
	      case 233 /* ExpressionWithTypeArguments */:
	        return isPartOfTypeNode(node.parent);
	    }
	    return false;
	  }
	  function isCallExpressionTarget(node, includeElementAccess = false, skipPastOuterExpressions = false) {
	    return isCalleeWorker(node, isCallExpression, selectExpressionOfCallOrNewExpressionOrDecorator, includeElementAccess, skipPastOuterExpressions);
	  }
	  function isNewExpressionTarget(node, includeElementAccess = false, skipPastOuterExpressions = false) {
	    return isCalleeWorker(node, isNewExpression, selectExpressionOfCallOrNewExpressionOrDecorator, includeElementAccess, skipPastOuterExpressions);
	  }
	  function isCallOrNewExpressionTarget(node, includeElementAccess = false, skipPastOuterExpressions = false) {
	    return isCalleeWorker(node, isCallOrNewExpression, selectExpressionOfCallOrNewExpressionOrDecorator, includeElementAccess, skipPastOuterExpressions);
	  }
	  function isTaggedTemplateTag(node, includeElementAccess = false, skipPastOuterExpressions = false) {
	    return isCalleeWorker(node, isTaggedTemplateExpression, selectTagOfTaggedTemplateExpression, includeElementAccess, skipPastOuterExpressions);
	  }
	  function isDecoratorTarget(node, includeElementAccess = false, skipPastOuterExpressions = false) {
	    return isCalleeWorker(node, isDecorator, selectExpressionOfCallOrNewExpressionOrDecorator, includeElementAccess, skipPastOuterExpressions);
	  }
	  function isJsxOpeningLikeElementTagName(node, includeElementAccess = false, skipPastOuterExpressions = false) {
	    return isCalleeWorker(node, isJsxOpeningLikeElement, selectTagNameOfJsxOpeningLikeElement, includeElementAccess, skipPastOuterExpressions);
	  }
	  function selectExpressionOfCallOrNewExpressionOrDecorator(node) {
	    return node.expression;
	  }
	  function selectTagOfTaggedTemplateExpression(node) {
	    return node.tag;
	  }
	  function selectTagNameOfJsxOpeningLikeElement(node) {
	    return node.tagName;
	  }
	  function isCalleeWorker(node, pred, calleeSelector, includeElementAccess, skipPastOuterExpressions) {
	    let target = includeElementAccess ? climbPastPropertyOrElementAccess(node) : climbPastPropertyAccess(node);
	    if (skipPastOuterExpressions) {
	      target = skipOuterExpressions(target);
	    }
	    return !!target && !!target.parent && pred(target.parent) && calleeSelector(target.parent) === target;
	  }
	  function climbPastPropertyAccess(node) {
	    return isRightSideOfPropertyAccess(node) ? node.parent : node;
	  }
	  function climbPastPropertyOrElementAccess(node) {
	    return isRightSideOfPropertyAccess(node) || isArgumentExpressionOfElementAccess(node) ? node.parent : node;
	  }
	  function getTargetLabel(referenceNode, labelName) {
	    while (referenceNode) {
	      if (referenceNode.kind === 256 /* LabeledStatement */ && referenceNode.label.escapedText === labelName) {
	        return referenceNode.label;
	      }
	      referenceNode = referenceNode.parent;
	    }
	    return void 0;
	  }
	  function hasPropertyAccessExpressionWithName(node, funcName) {
	    if (!isPropertyAccessExpression(node.expression)) {
	      return false;
	    }
	    return node.expression.name.text === funcName;
	  }
	  function isJumpStatementTarget(node) {
	    var _a;
	    return isIdentifier(node) && ((_a = tryCast(node.parent, isBreakOrContinueStatement)) == null ? void 0 : _a.label) === node;
	  }
	  function isLabelOfLabeledStatement(node) {
	    var _a;
	    return isIdentifier(node) && ((_a = tryCast(node.parent, isLabeledStatement)) == null ? void 0 : _a.label) === node;
	  }
	  function isLabelName(node) {
	    return isLabelOfLabeledStatement(node) || isJumpStatementTarget(node);
	  }
	  function isTagName(node) {
	    var _a;
	    return ((_a = tryCast(node.parent, isJSDocTag)) == null ? void 0 : _a.tagName) === node;
	  }
	  function isRightSideOfQualifiedName(node) {
	    var _a;
	    return ((_a = tryCast(node.parent, isQualifiedName)) == null ? void 0 : _a.right) === node;
	  }
	  function isRightSideOfPropertyAccess(node) {
	    var _a;
	    return ((_a = tryCast(node.parent, isPropertyAccessExpression)) == null ? void 0 : _a.name) === node;
	  }
	  function isArgumentExpressionOfElementAccess(node) {
	    var _a;
	    return ((_a = tryCast(node.parent, isElementAccessExpression)) == null ? void 0 : _a.argumentExpression) === node;
	  }
	  function isNameOfModuleDeclaration(node) {
	    var _a;
	    return ((_a = tryCast(node.parent, isModuleDeclaration)) == null ? void 0 : _a.name) === node;
	  }
	  function isNameOfFunctionDeclaration(node) {
	    var _a;
	    return isIdentifier(node) && ((_a = tryCast(node.parent, isFunctionLike)) == null ? void 0 : _a.name) === node;
	  }
	  function isLiteralNameOfPropertyDeclarationOrIndexAccess(node) {
	    switch (node.parent.kind) {
	      case 172 /* PropertyDeclaration */:
	      case 171 /* PropertySignature */:
	      case 303 /* PropertyAssignment */:
	      case 306 /* EnumMember */:
	      case 174 /* MethodDeclaration */:
	      case 173 /* MethodSignature */:
	      case 177 /* GetAccessor */:
	      case 178 /* SetAccessor */:
	      case 267 /* ModuleDeclaration */:
	        return getNameOfDeclaration(node.parent) === node;
	      case 212 /* ElementAccessExpression */:
	        return node.parent.argumentExpression === node;
	      case 167 /* ComputedPropertyName */:
	        return true;
	      case 201 /* LiteralType */:
	        return node.parent.parent.kind === 199 /* IndexedAccessType */;
	      default:
	        return false;
	    }
	  }
	  function isExpressionOfExternalModuleImportEqualsDeclaration(node) {
	    return isExternalModuleImportEqualsDeclaration(node.parent.parent) && getExternalModuleImportEqualsDeclarationExpression(node.parent.parent) === node;
	  }
	  function getContainerNode(node) {
	    if (isJSDocTypeAlias(node)) {
	      node = node.parent.parent;
	    }
	    while (true) {
	      node = node.parent;
	      if (!node) {
	        return void 0;
	      }
	      switch (node.kind) {
	        case 312 /* SourceFile */:
	        case 174 /* MethodDeclaration */:
	        case 173 /* MethodSignature */:
	        case 262 /* FunctionDeclaration */:
	        case 218 /* FunctionExpression */:
	        case 177 /* GetAccessor */:
	        case 178 /* SetAccessor */:
	        case 263 /* ClassDeclaration */:
	        case 264 /* InterfaceDeclaration */:
	        case 266 /* EnumDeclaration */:
	        case 267 /* ModuleDeclaration */:
	          return node;
	      }
	    }
	  }
	  function getNodeKind(node) {
	    switch (node.kind) {
	      case 312 /* SourceFile */:
	        return isExternalModule(node) ? "module" /* moduleElement */ : "script" /* scriptElement */;
	      case 267 /* ModuleDeclaration */:
	        return "module" /* moduleElement */;
	      case 263 /* ClassDeclaration */:
	      case 231 /* ClassExpression */:
	        return "class" /* classElement */;
	      case 264 /* InterfaceDeclaration */:
	        return "interface" /* interfaceElement */;
	      case 265 /* TypeAliasDeclaration */:
	      case 345 /* JSDocCallbackTag */:
	      case 353 /* JSDocTypedefTag */:
	        return "type" /* typeElement */;
	      case 266 /* EnumDeclaration */:
	        return "enum" /* enumElement */;
	      case 260 /* VariableDeclaration */:
	        return getKindOfVariableDeclaration(node);
	      case 208 /* BindingElement */:
	        return getKindOfVariableDeclaration(getRootDeclaration(node));
	      case 219 /* ArrowFunction */:
	      case 262 /* FunctionDeclaration */:
	      case 218 /* FunctionExpression */:
	        return "function" /* functionElement */;
	      case 177 /* GetAccessor */:
	        return "getter" /* memberGetAccessorElement */;
	      case 178 /* SetAccessor */:
	        return "setter" /* memberSetAccessorElement */;
	      case 174 /* MethodDeclaration */:
	      case 173 /* MethodSignature */:
	        return "method" /* memberFunctionElement */;
	      case 303 /* PropertyAssignment */:
	        const { initializer } = node;
	        return isFunctionLike(initializer) ? "method" /* memberFunctionElement */ : "property" /* memberVariableElement */;
	      case 172 /* PropertyDeclaration */:
	      case 171 /* PropertySignature */:
	      case 304 /* ShorthandPropertyAssignment */:
	      case 305 /* SpreadAssignment */:
	        return "property" /* memberVariableElement */;
	      case 181 /* IndexSignature */:
	        return "index" /* indexSignatureElement */;
	      case 180 /* ConstructSignature */:
	        return "construct" /* constructSignatureElement */;
	      case 179 /* CallSignature */:
	        return "call" /* callSignatureElement */;
	      case 176 /* Constructor */:
	      case 175 /* ClassStaticBlockDeclaration */:
	        return "constructor" /* constructorImplementationElement */;
	      case 168 /* TypeParameter */:
	        return "type parameter" /* typeParameterElement */;
	      case 306 /* EnumMember */:
	        return "enum member" /* enumMemberElement */;
	      case 169 /* Parameter */:
	        return hasSyntacticModifier(node, 31 /* ParameterPropertyModifier */) ? "property" /* memberVariableElement */ : "parameter" /* parameterElement */;
	      case 271 /* ImportEqualsDeclaration */:
	      case 276 /* ImportSpecifier */:
	      case 281 /* ExportSpecifier */:
	      case 274 /* NamespaceImport */:
	      case 280 /* NamespaceExport */:
	        return "alias" /* alias */;
	      case 226 /* BinaryExpression */:
	        const kind = getAssignmentDeclarationKind(node);
	        const { right } = node;
	        switch (kind) {
	          case 7 /* ObjectDefinePropertyValue */:
	          case 8 /* ObjectDefinePropertyExports */:
	          case 9 /* ObjectDefinePrototypeProperty */:
	          case 0 /* None */:
	            return "" /* unknown */;
	          case 1 /* ExportsProperty */:
	          case 2 /* ModuleExports */:
	            const rightKind = getNodeKind(right);
	            return rightKind === "" /* unknown */ ? "const" /* constElement */ : rightKind;
	          case 3 /* PrototypeProperty */:
	            return isFunctionExpression(right) ? "method" /* memberFunctionElement */ : "property" /* memberVariableElement */;
	          case 4 /* ThisProperty */:
	            return "property" /* memberVariableElement */;
	          case 5 /* Property */:
	            return isFunctionExpression(right) ? "method" /* memberFunctionElement */ : "property" /* memberVariableElement */;
	          case 6 /* Prototype */:
	            return "local class" /* localClassElement */;
	          default: {
	            return "" /* unknown */;
	          }
	        }
	      case 80 /* Identifier */:
	        return isImportClause(node.parent) ? "alias" /* alias */ : "" /* unknown */;
	      case 277 /* ExportAssignment */:
	        const scriptKind = getNodeKind(node.expression);
	        return scriptKind === "" /* unknown */ ? "const" /* constElement */ : scriptKind;
	      default:
	        return "" /* unknown */;
	    }
	    function getKindOfVariableDeclaration(v) {
	      return isVarConst(v) ? "const" /* constElement */ : isLet(v) ? "let" /* letElement */ : "var" /* variableElement */;
	    }
	  }
	  function isThis(node) {
	    switch (node.kind) {
	      case 110 /* ThisKeyword */:
	        return true;
	      case 80 /* Identifier */:
	        return identifierIsThisKeyword(node) && node.parent.kind === 169 /* Parameter */;
	      default:
	        return false;
	    }
	  }
	  function getLineStartPositionForPosition(position, sourceFile) {
	    const lineStarts = getLineStarts(sourceFile);
	    const line = sourceFile.getLineAndCharacterOfPosition(position).line;
	    return lineStarts[line];
	  }
	  function rangeContainsRange(r1, r2) {
	    return startEndContainsRange(r1.pos, r1.end, r2);
	  }
	  function rangeContainsRangeExclusive(r1, r2) {
	    return rangeContainsPositionExclusive(r1, r2.pos) && rangeContainsPositionExclusive(r1, r2.end);
	  }
	  function rangeContainsPosition(r, pos) {
	    return r.pos <= pos && pos <= r.end;
	  }
	  function rangeContainsPositionExclusive(r, pos) {
	    return r.pos < pos && pos < r.end;
	  }
	  function startEndContainsRange(start, end, range) {
	    return start <= range.pos && end >= range.end;
	  }
	  function rangeContainsStartEnd(range, start, end) {
	    return range.pos <= start && range.end >= end;
	  }
	  function rangeOverlapsWithStartEnd(r1, start, end) {
	    return startEndOverlapsWithStartEnd(r1.pos, r1.end, start, end);
	  }
	  function nodeOverlapsWithStartEnd(node, sourceFile, start, end) {
	    return startEndOverlapsWithStartEnd(node.getStart(sourceFile), node.end, start, end);
	  }
	  function startEndOverlapsWithStartEnd(start1, end1, start2, end2) {
	    const start = Math.max(start1, start2);
	    const end = Math.min(end1, end2);
	    return start < end;
	  }
	  function positionBelongsToNode(candidate, position, sourceFile) {
	    Debug.assert(candidate.pos <= position);
	    return position < candidate.end || !isCompletedNode(candidate, sourceFile);
	  }
	  function isCompletedNode(n, sourceFile) {
	    if (n === void 0 || nodeIsMissing(n)) {
	      return false;
	    }
	    switch (n.kind) {
	      case 263 /* ClassDeclaration */:
	      case 264 /* InterfaceDeclaration */:
	      case 266 /* EnumDeclaration */:
	      case 210 /* ObjectLiteralExpression */:
	      case 206 /* ObjectBindingPattern */:
	      case 187 /* TypeLiteral */:
	      case 241 /* Block */:
	      case 268 /* ModuleBlock */:
	      case 269 /* CaseBlock */:
	      case 275 /* NamedImports */:
	      case 279 /* NamedExports */:
	        return nodeEndsWith(n, 20 /* CloseBraceToken */, sourceFile);
	      case 299 /* CatchClause */:
	        return isCompletedNode(n.block, sourceFile);
	      case 214 /* NewExpression */:
	        if (!n.arguments) {
	          return true;
	        }
	      case 213 /* CallExpression */:
	      case 217 /* ParenthesizedExpression */:
	      case 196 /* ParenthesizedType */:
	        return nodeEndsWith(n, 22 /* CloseParenToken */, sourceFile);
	      case 184 /* FunctionType */:
	      case 185 /* ConstructorType */:
	        return isCompletedNode(n.type, sourceFile);
	      case 176 /* Constructor */:
	      case 177 /* GetAccessor */:
	      case 178 /* SetAccessor */:
	      case 262 /* FunctionDeclaration */:
	      case 218 /* FunctionExpression */:
	      case 174 /* MethodDeclaration */:
	      case 173 /* MethodSignature */:
	      case 180 /* ConstructSignature */:
	      case 179 /* CallSignature */:
	      case 219 /* ArrowFunction */:
	        if (n.body) {
	          return isCompletedNode(n.body, sourceFile);
	        }
	        if (n.type) {
	          return isCompletedNode(n.type, sourceFile);
	        }
	        return hasChildOfKind(n, 22 /* CloseParenToken */, sourceFile);
	      case 267 /* ModuleDeclaration */:
	        return !!n.body && isCompletedNode(n.body, sourceFile);
	      case 245 /* IfStatement */:
	        if (n.elseStatement) {
	          return isCompletedNode(n.elseStatement, sourceFile);
	        }
	        return isCompletedNode(n.thenStatement, sourceFile);
	      case 244 /* ExpressionStatement */:
	        return isCompletedNode(n.expression, sourceFile) || hasChildOfKind(n, 27 /* SemicolonToken */, sourceFile);
	      case 209 /* ArrayLiteralExpression */:
	      case 207 /* ArrayBindingPattern */:
	      case 212 /* ElementAccessExpression */:
	      case 167 /* ComputedPropertyName */:
	      case 189 /* TupleType */:
	        return nodeEndsWith(n, 24 /* CloseBracketToken */, sourceFile);
	      case 181 /* IndexSignature */:
	        if (n.type) {
	          return isCompletedNode(n.type, sourceFile);
	        }
	        return hasChildOfKind(n, 24 /* CloseBracketToken */, sourceFile);
	      case 296 /* CaseClause */:
	      case 297 /* DefaultClause */:
	        return false;
	      case 248 /* ForStatement */:
	      case 249 /* ForInStatement */:
	      case 250 /* ForOfStatement */:
	      case 247 /* WhileStatement */:
	        return isCompletedNode(n.statement, sourceFile);
	      case 246 /* DoStatement */:
	        return hasChildOfKind(n, 117 /* WhileKeyword */, sourceFile) ? nodeEndsWith(n, 22 /* CloseParenToken */, sourceFile) : isCompletedNode(n.statement, sourceFile);
	      case 186 /* TypeQuery */:
	        return isCompletedNode(n.exprName, sourceFile);
	      case 221 /* TypeOfExpression */:
	      case 220 /* DeleteExpression */:
	      case 222 /* VoidExpression */:
	      case 229 /* YieldExpression */:
	      case 230 /* SpreadElement */:
	        const unaryWordExpression = n;
	        return isCompletedNode(unaryWordExpression.expression, sourceFile);
	      case 215 /* TaggedTemplateExpression */:
	        return isCompletedNode(n.template, sourceFile);
	      case 228 /* TemplateExpression */:
	        const lastSpan = lastOrUndefined(n.templateSpans);
	        return isCompletedNode(lastSpan, sourceFile);
	      case 239 /* TemplateSpan */:
	        return nodeIsPresent(n.literal);
	      case 278 /* ExportDeclaration */:
	      case 272 /* ImportDeclaration */:
	        return nodeIsPresent(n.moduleSpecifier);
	      case 224 /* PrefixUnaryExpression */:
	        return isCompletedNode(n.operand, sourceFile);
	      case 226 /* BinaryExpression */:
	        return isCompletedNode(n.right, sourceFile);
	      case 227 /* ConditionalExpression */:
	        return isCompletedNode(n.whenFalse, sourceFile);
	      default:
	        return true;
	    }
	  }
	  function nodeEndsWith(n, expectedLastToken, sourceFile) {
	    const children = n.getChildren(sourceFile);
	    if (children.length) {
	      const lastChild = last(children);
	      if (lastChild.kind === expectedLastToken) {
	        return true;
	      } else if (lastChild.kind === 27 /* SemicolonToken */ && children.length !== 1) {
	        return children[children.length - 2].kind === expectedLastToken;
	      }
	    }
	    return false;
	  }
	  function findListItemInfo(node) {
	    const list = findContainingList(node);
	    if (!list) {
	      return void 0;
	    }
	    const children = list.getChildren();
	    const listItemIndex = indexOfNode(children, node);
	    return {
	      listItemIndex,
	      list
	    };
	  }
	  function hasChildOfKind(n, kind, sourceFile) {
	    return !!findChildOfKind(n, kind, sourceFile);
	  }
	  function findChildOfKind(n, kind, sourceFile) {
	    return find(n.getChildren(sourceFile), (c) => c.kind === kind);
	  }
	  function findContainingList(node) {
	    const syntaxList = find(node.parent.getChildren(), (c) => isSyntaxList(c) && rangeContainsRange(c, node));
	    Debug.assert(!syntaxList || contains(syntaxList.getChildren(), node));
	    return syntaxList;
	  }
	  function isDefaultModifier2(node) {
	    return node.kind === 90 /* DefaultKeyword */;
	  }
	  function isClassKeyword(node) {
	    return node.kind === 86 /* ClassKeyword */;
	  }
	  function isFunctionKeyword(node) {
	    return node.kind === 100 /* FunctionKeyword */;
	  }
	  function getAdjustedLocationForClass(node) {
	    if (isNamedDeclaration(node)) {
	      return node.name;
	    }
	    if (isClassDeclaration(node)) {
	      const defaultModifier = node.modifiers && find(node.modifiers, isDefaultModifier2);
	      if (defaultModifier)
	        return defaultModifier;
	    }
	    if (isClassExpression(node)) {
	      const classKeyword = find(node.getChildren(), isClassKeyword);
	      if (classKeyword)
	        return classKeyword;
	    }
	  }
	  function getAdjustedLocationForFunction(node) {
	    if (isNamedDeclaration(node)) {
	      return node.name;
	    }
	    if (isFunctionDeclaration(node)) {
	      const defaultModifier = find(node.modifiers, isDefaultModifier2);
	      if (defaultModifier)
	        return defaultModifier;
	    }
	    if (isFunctionExpression(node)) {
	      const functionKeyword = find(node.getChildren(), isFunctionKeyword);
	      if (functionKeyword)
	        return functionKeyword;
	    }
	  }
	  function getAncestorTypeNode(node) {
	    let lastTypeNode;
	    findAncestor(node, (a) => {
	      if (isTypeNode(a)) {
	        lastTypeNode = a;
	      }
	      return !isQualifiedName(a.parent) && !isTypeNode(a.parent) && !isTypeElement(a.parent);
	    });
	    return lastTypeNode;
	  }
	  function getContextualTypeFromParentOrAncestorTypeNode(node, checker) {
	    if (node.flags & (16777216 /* JSDoc */ & ~524288 /* JavaScriptFile */))
	      return void 0;
	    const contextualType = getContextualTypeFromParent(node, checker);
	    if (contextualType)
	      return contextualType;
	    const ancestorTypeNode = getAncestorTypeNode(node);
	    return ancestorTypeNode && checker.getTypeAtLocation(ancestorTypeNode);
	  }
	  function getAdjustedLocationForDeclaration(node, forRename) {
	    if (!forRename) {
	      switch (node.kind) {
	        case 263 /* ClassDeclaration */:
	        case 231 /* ClassExpression */:
	          return getAdjustedLocationForClass(node);
	        case 262 /* FunctionDeclaration */:
	        case 218 /* FunctionExpression */:
	          return getAdjustedLocationForFunction(node);
	        case 176 /* Constructor */:
	          return node;
	      }
	    }
	    if (isNamedDeclaration(node)) {
	      return node.name;
	    }
	  }
	  function getAdjustedLocationForImportDeclaration(node, forRename) {
	    if (node.importClause) {
	      if (node.importClause.name && node.importClause.namedBindings) {
	        return;
	      }
	      if (node.importClause.name) {
	        return node.importClause.name;
	      }
	      if (node.importClause.namedBindings) {
	        if (isNamedImports(node.importClause.namedBindings)) {
	          const onlyBinding = singleOrUndefined(node.importClause.namedBindings.elements);
	          if (!onlyBinding) {
	            return;
	          }
	          return onlyBinding.name;
	        } else if (isNamespaceImport(node.importClause.namedBindings)) {
	          return node.importClause.namedBindings.name;
	        }
	      }
	    }
	    if (!forRename) {
	      return node.moduleSpecifier;
	    }
	  }
	  function getAdjustedLocationForExportDeclaration(node, forRename) {
	    if (node.exportClause) {
	      if (isNamedExports(node.exportClause)) {
	        const onlyBinding = singleOrUndefined(node.exportClause.elements);
	        if (!onlyBinding) {
	          return;
	        }
	        return node.exportClause.elements[0].name;
	      } else if (isNamespaceExport(node.exportClause)) {
	        return node.exportClause.name;
	      }
	    }
	    if (!forRename) {
	      return node.moduleSpecifier;
	    }
	  }
	  function getAdjustedLocationForHeritageClause(node) {
	    if (node.types.length === 1) {
	      return node.types[0].expression;
	    }
	  }
	  function getAdjustedLocation(node, forRename) {
	    const { parent: parent2 } = node;
	    if (isModifier(node) && (forRename || node.kind !== 90 /* DefaultKeyword */) ? canHaveModifiers(parent2) && contains(parent2.modifiers, node) : node.kind === 86 /* ClassKeyword */ ? isClassDeclaration(parent2) || isClassExpression(node) : node.kind === 100 /* FunctionKeyword */ ? isFunctionDeclaration(parent2) || isFunctionExpression(node) : node.kind === 120 /* InterfaceKeyword */ ? isInterfaceDeclaration(parent2) : node.kind === 94 /* EnumKeyword */ ? isEnumDeclaration(parent2) : node.kind === 156 /* TypeKeyword */ ? isTypeAliasDeclaration(parent2) : node.kind === 145 /* NamespaceKeyword */ || node.kind === 144 /* ModuleKeyword */ ? isModuleDeclaration(parent2) : node.kind === 102 /* ImportKeyword */ ? isImportEqualsDeclaration(parent2) : node.kind === 139 /* GetKeyword */ ? isGetAccessorDeclaration(parent2) : node.kind === 153 /* SetKeyword */ && isSetAccessorDeclaration(parent2)) {
	      const location = getAdjustedLocationForDeclaration(parent2, forRename);
	      if (location) {
	        return location;
	      }
	    }
	    if ((node.kind === 115 /* VarKeyword */ || node.kind === 87 /* ConstKeyword */ || node.kind === 121 /* LetKeyword */) && isVariableDeclarationList(parent2) && parent2.declarations.length === 1) {
	      const decl = parent2.declarations[0];
	      if (isIdentifier(decl.name)) {
	        return decl.name;
	      }
	    }
	    if (node.kind === 156 /* TypeKeyword */) {
	      if (isImportClause(parent2) && parent2.isTypeOnly) {
	        const location = getAdjustedLocationForImportDeclaration(parent2.parent, forRename);
	        if (location) {
	          return location;
	        }
	      }
	      if (isExportDeclaration(parent2) && parent2.isTypeOnly) {
	        const location = getAdjustedLocationForExportDeclaration(parent2, forRename);
	        if (location) {
	          return location;
	        }
	      }
	    }
	    if (node.kind === 130 /* AsKeyword */) {
	      if (isImportSpecifier(parent2) && parent2.propertyName || isExportSpecifier(parent2) && parent2.propertyName || isNamespaceImport(parent2) || isNamespaceExport(parent2)) {
	        return parent2.name;
	      }
	      if (isExportDeclaration(parent2) && parent2.exportClause && isNamespaceExport(parent2.exportClause)) {
	        return parent2.exportClause.name;
	      }
	    }
	    if (node.kind === 102 /* ImportKeyword */ && isImportDeclaration(parent2)) {
	      const location = getAdjustedLocationForImportDeclaration(parent2, forRename);
	      if (location) {
	        return location;
	      }
	    }
	    if (node.kind === 95 /* ExportKeyword */) {
	      if (isExportDeclaration(parent2)) {
	        const location = getAdjustedLocationForExportDeclaration(parent2, forRename);
	        if (location) {
	          return location;
	        }
	      }
	      if (isExportAssignment(parent2)) {
	        return skipOuterExpressions(parent2.expression);
	      }
	    }
	    if (node.kind === 149 /* RequireKeyword */ && isExternalModuleReference(parent2)) {
	      return parent2.expression;
	    }
	    if (node.kind === 161 /* FromKeyword */ && (isImportDeclaration(parent2) || isExportDeclaration(parent2)) && parent2.moduleSpecifier) {
	      return parent2.moduleSpecifier;
	    }
	    if ((node.kind === 96 /* ExtendsKeyword */ || node.kind === 119 /* ImplementsKeyword */) && isHeritageClause(parent2) && parent2.token === node.kind) {
	      const location = getAdjustedLocationForHeritageClause(parent2);
	      if (location) {
	        return location;
	      }
	    }
	    if (node.kind === 96 /* ExtendsKeyword */) {
	      if (isTypeParameterDeclaration(parent2) && parent2.constraint && isTypeReferenceNode(parent2.constraint)) {
	        return parent2.constraint.typeName;
	      }
	      if (isConditionalTypeNode(parent2) && isTypeReferenceNode(parent2.extendsType)) {
	        return parent2.extendsType.typeName;
	      }
	    }
	    if (node.kind === 140 /* InferKeyword */ && isInferTypeNode(parent2)) {
	      return parent2.typeParameter.name;
	    }
	    if (node.kind === 103 /* InKeyword */ && isTypeParameterDeclaration(parent2) && isMappedTypeNode(parent2.parent)) {
	      return parent2.name;
	    }
	    if (node.kind === 143 /* KeyOfKeyword */ && isTypeOperatorNode(parent2) && parent2.operator === 143 /* KeyOfKeyword */ && isTypeReferenceNode(parent2.type)) {
	      return parent2.type.typeName;
	    }
	    if (node.kind === 148 /* ReadonlyKeyword */ && isTypeOperatorNode(parent2) && parent2.operator === 148 /* ReadonlyKeyword */ && isArrayTypeNode(parent2.type) && isTypeReferenceNode(parent2.type.elementType)) {
	      return parent2.type.elementType.typeName;
	    }
	    if (!forRename) {
	      if (node.kind === 105 /* NewKeyword */ && isNewExpression(parent2) || node.kind === 116 /* VoidKeyword */ && isVoidExpression(parent2) || node.kind === 114 /* TypeOfKeyword */ && isTypeOfExpression(parent2) || node.kind === 135 /* AwaitKeyword */ && isAwaitExpression(parent2) || node.kind === 127 /* YieldKeyword */ && isYieldExpression(parent2) || node.kind === 91 /* DeleteKeyword */ && isDeleteExpression(parent2)) {
	        if (parent2.expression) {
	          return skipOuterExpressions(parent2.expression);
	        }
	      }
	      if ((node.kind === 103 /* InKeyword */ || node.kind === 104 /* InstanceOfKeyword */) && isBinaryExpression(parent2) && parent2.operatorToken === node) {
	        return skipOuterExpressions(parent2.right);
	      }
	      if (node.kind === 130 /* AsKeyword */ && isAsExpression(parent2) && isTypeReferenceNode(parent2.type)) {
	        return parent2.type.typeName;
	      }
	      if (node.kind === 103 /* InKeyword */ && isForInStatement(parent2) || node.kind === 165 /* OfKeyword */ && isForOfStatement(parent2)) {
	        return skipOuterExpressions(parent2.expression);
	      }
	    }
	    return node;
	  }
	  function getAdjustedReferenceLocation(node) {
	    return getAdjustedLocation(
	      node,
	      /*forRename*/
	      false
	    );
	  }
	  function getAdjustedRenameLocation(node) {
	    return getAdjustedLocation(
	      node,
	      /*forRename*/
	      true
	    );
	  }
	  function getTouchingPropertyName(sourceFile, position) {
	    return getTouchingToken(sourceFile, position, (n) => isPropertyNameLiteral(n) || isKeyword(n.kind) || isPrivateIdentifier(n));
	  }
	  function getTouchingToken(sourceFile, position, includePrecedingTokenAtEndPosition) {
	    return getTokenAtPositionWorker(
	      sourceFile,
	      position,
	      /*allowPositionInLeadingTrivia*/
	      false,
	      includePrecedingTokenAtEndPosition,
	      /*includeEndPosition*/
	      false
	    );
	  }
	  function getTokenAtPosition(sourceFile, position) {
	    return getTokenAtPositionWorker(
	      sourceFile,
	      position,
	      /*allowPositionInLeadingTrivia*/
	      true,
	      /*includePrecedingTokenAtEndPosition*/
	      void 0,
	      /*includeEndPosition*/
	      false
	    );
	  }
	  function getTokenAtPositionWorker(sourceFile, position, allowPositionInLeadingTrivia, includePrecedingTokenAtEndPosition, includeEndPosition) {
	    let current = sourceFile;
	    let foundToken;
	    outer:
	      while (true) {
	        const children = current.getChildren(sourceFile);
	        const i = binarySearchKey(children, position, (_, i2) => i2, (middle, _) => {
	          const end = children[middle].getEnd();
	          if (end < position) {
	            return -1 /* LessThan */;
	          }
	          const start = allowPositionInLeadingTrivia ? children[middle].getFullStart() : children[middle].getStart(
	            sourceFile,
	            /*includeJsDocComment*/
	            true
	          );
	          if (start > position) {
	            return 1 /* GreaterThan */;
	          }
	          if (nodeContainsPosition(children[middle], start, end)) {
	            if (children[middle - 1]) {
	              if (nodeContainsPosition(children[middle - 1])) {
	                return 1 /* GreaterThan */;
	              }
	            }
	            return 0 /* EqualTo */;
	          }
	          if (includePrecedingTokenAtEndPosition && start === position && children[middle - 1] && children[middle - 1].getEnd() === position && nodeContainsPosition(children[middle - 1])) {
	            return 1 /* GreaterThan */;
	          }
	          return -1 /* LessThan */;
	        });
	        if (foundToken) {
	          return foundToken;
	        }
	        if (i >= 0 && children[i]) {
	          current = children[i];
	          continue outer;
	        }
	        return current;
	      }
	    function nodeContainsPosition(node, start, end) {
	      end ?? (end = node.getEnd());
	      if (end < position) {
	        return false;
	      }
	      start ?? (start = allowPositionInLeadingTrivia ? node.getFullStart() : node.getStart(
	        sourceFile,
	        /*includeJsDocComment*/
	        true
	      ));
	      if (start > position) {
	        return false;
	      }
	      if (position < end || position === end && (node.kind === 1 /* EndOfFileToken */ || includeEndPosition)) {
	        return true;
	      } else if (includePrecedingTokenAtEndPosition && end === position) {
	        const previousToken = findPrecedingToken(position, sourceFile, node);
	        if (previousToken && includePrecedingTokenAtEndPosition(previousToken)) {
	          foundToken = previousToken;
	          return true;
	        }
	      }
	      return false;
	    }
	  }
	  function findFirstNonJsxWhitespaceToken(sourceFile, position) {
	    let tokenAtPosition = getTokenAtPosition(sourceFile, position);
	    while (isWhiteSpaceOnlyJsxText(tokenAtPosition)) {
	      const nextToken = findNextToken(tokenAtPosition, tokenAtPosition.parent, sourceFile);
	      if (!nextToken)
	        return;
	      tokenAtPosition = nextToken;
	    }
	    return tokenAtPosition;
	  }
	  function findTokenOnLeftOfPosition(file, position) {
	    const tokenAtPosition = getTokenAtPosition(file, position);
	    if (isToken(tokenAtPosition) && position > tokenAtPosition.getStart(file) && position < tokenAtPosition.getEnd()) {
	      return tokenAtPosition;
	    }
	    return findPrecedingToken(position, file);
	  }
	  function findNextToken(previousToken, parent2, sourceFile) {
	    return find2(parent2);
	    function find2(n) {
	      if (isToken(n) && n.pos === previousToken.end) {
	        return n;
	      }
	      return firstDefined(n.getChildren(sourceFile), (child) => {
	        const shouldDiveInChildNode = (
	          // previous token is enclosed somewhere in the child
	          child.pos <= previousToken.pos && child.end > previousToken.end || // previous token ends exactly at the beginning of child
	          child.pos === previousToken.end
	        );
	        return shouldDiveInChildNode && nodeHasTokens(child, sourceFile) ? find2(child) : void 0;
	      });
	    }
	  }
	  function findPrecedingToken(position, sourceFile, startNode2, excludeJsdoc) {
	    const result = find2(startNode2 || sourceFile);
	    Debug.assert(!(result && isWhiteSpaceOnlyJsxText(result)));
	    return result;
	    function find2(n) {
	      if (isNonWhitespaceToken(n) && n.kind !== 1 /* EndOfFileToken */) {
	        return n;
	      }
	      const children = n.getChildren(sourceFile);
	      const i = binarySearchKey(children, position, (_, i2) => i2, (middle, _) => {
	        if (position < children[middle].end) {
	          if (!children[middle - 1] || position >= children[middle - 1].end) {
	            return 0 /* EqualTo */;
	          }
	          return 1 /* GreaterThan */;
	        }
	        return -1 /* LessThan */;
	      });
	      if (i >= 0 && children[i]) {
	        const child = children[i];
	        if (position < child.end) {
	          const start = child.getStart(
	            sourceFile,
	            /*includeJsDoc*/
	            !excludeJsdoc
	          );
	          const lookInPreviousChild = start >= position || // cursor in the leading trivia
	          !nodeHasTokens(child, sourceFile) || isWhiteSpaceOnlyJsxText(child);
	          if (lookInPreviousChild) {
	            const candidate2 = findRightmostChildNodeWithTokens(
	              children,
	              /*exclusiveStartPosition*/
	              i,
	              sourceFile,
	              n.kind
	            );
	            if (candidate2) {
	              if (!excludeJsdoc && isJSDocCommentContainingNode(candidate2) && candidate2.getChildren(sourceFile).length) {
	                return find2(candidate2);
	              }
	              return findRightmostToken(candidate2, sourceFile);
	            }
	            return void 0;
	          } else {
	            return find2(child);
	          }
	        }
	      }
	      Debug.assert(startNode2 !== void 0 || n.kind === 312 /* SourceFile */ || n.kind === 1 /* EndOfFileToken */ || isJSDocCommentContainingNode(n));
	      const candidate = findRightmostChildNodeWithTokens(
	        children,
	        /*exclusiveStartPosition*/
	        children.length,
	        sourceFile,
	        n.kind
	      );
	      return candidate && findRightmostToken(candidate, sourceFile);
	    }
	  }
	  function isNonWhitespaceToken(n) {
	    return isToken(n) && !isWhiteSpaceOnlyJsxText(n);
	  }
	  function findRightmostToken(n, sourceFile) {
	    if (isNonWhitespaceToken(n)) {
	      return n;
	    }
	    const children = n.getChildren(sourceFile);
	    if (children.length === 0) {
	      return n;
	    }
	    const candidate = findRightmostChildNodeWithTokens(
	      children,
	      /*exclusiveStartPosition*/
	      children.length,
	      sourceFile,
	      n.kind
	    );
	    return candidate && findRightmostToken(candidate, sourceFile);
	  }
	  function findRightmostChildNodeWithTokens(children, exclusiveStartPosition, sourceFile, parentKind) {
	    for (let i = exclusiveStartPosition - 1; i >= 0; i--) {
	      const child = children[i];
	      if (isWhiteSpaceOnlyJsxText(child)) {
	        if (i === 0 && (parentKind === 12 /* JsxText */ || parentKind === 285 /* JsxSelfClosingElement */)) {
	          Debug.fail("`JsxText` tokens should not be the first child of `JsxElement | JsxSelfClosingElement`");
	        }
	      } else if (nodeHasTokens(children[i], sourceFile)) {
	        return children[i];
	      }
	    }
	  }
	  function isInString(sourceFile, position, previousToken = findPrecedingToken(position, sourceFile)) {
	    if (previousToken && isStringTextContainingNode(previousToken)) {
	      const start = previousToken.getStart(sourceFile);
	      const end = previousToken.getEnd();
	      if (start < position && position < end) {
	        return true;
	      }
	      if (position === end) {
	        return !!previousToken.isUnterminated;
	      }
	    }
	    return false;
	  }
	  function isInsideJsxElementOrAttribute(sourceFile, position) {
	    const token = getTokenAtPosition(sourceFile, position);
	    if (!token) {
	      return false;
	    }
	    if (token.kind === 12 /* JsxText */) {
	      return true;
	    }
	    if (token.kind === 30 /* LessThanToken */ && token.parent.kind === 12 /* JsxText */) {
	      return true;
	    }
	    if (token.kind === 30 /* LessThanToken */ && token.parent.kind === 294 /* JsxExpression */) {
	      return true;
	    }
	    if (token && token.kind === 20 /* CloseBraceToken */ && token.parent.kind === 294 /* JsxExpression */) {
	      return true;
	    }
	    if (token.kind === 30 /* LessThanToken */ && token.parent.kind === 287 /* JsxClosingElement */) {
	      return true;
	    }
	    return false;
	  }
	  function isWhiteSpaceOnlyJsxText(node) {
	    return isJsxText(node) && node.containsOnlyTriviaWhiteSpaces;
	  }
	  function isInTemplateString(sourceFile, position) {
	    const token = getTokenAtPosition(sourceFile, position);
	    return isTemplateLiteralKind(token.kind) && position > token.getStart(sourceFile);
	  }
	  function isInJSXText(sourceFile, position) {
	    const token = getTokenAtPosition(sourceFile, position);
	    if (isJsxText(token)) {
	      return true;
	    }
	    if (token.kind === 19 /* OpenBraceToken */ && isJsxExpression(token.parent) && isJsxElement(token.parent.parent)) {
	      return true;
	    }
	    if (token.kind === 30 /* LessThanToken */ && isJsxOpeningLikeElement(token.parent) && isJsxElement(token.parent.parent)) {
	      return true;
	    }
	    return false;
	  }
	  function isInsideJsxElement(sourceFile, position) {
	    function isInsideJsxElementTraversal(node) {
	      while (node) {
	        if (node.kind >= 285 /* JsxSelfClosingElement */ && node.kind <= 294 /* JsxExpression */ || node.kind === 12 /* JsxText */ || node.kind === 30 /* LessThanToken */ || node.kind === 32 /* GreaterThanToken */ || node.kind === 80 /* Identifier */ || node.kind === 20 /* CloseBraceToken */ || node.kind === 19 /* OpenBraceToken */ || node.kind === 44 /* SlashToken */) {
	          node = node.parent;
	        } else if (node.kind === 284 /* JsxElement */) {
	          if (position > node.getStart(sourceFile))
	            return true;
	          node = node.parent;
	        } else {
	          return false;
	        }
	      }
	      return false;
	    }
	    return isInsideJsxElementTraversal(getTokenAtPosition(sourceFile, position));
	  }
	  function findPrecedingMatchingToken(token, matchingTokenKind, sourceFile) {
	    const closeTokenText = tokenToString(token.kind);
	    const matchingTokenText = tokenToString(matchingTokenKind);
	    const tokenFullStart = token.getFullStart();
	    const bestGuessIndex = sourceFile.text.lastIndexOf(matchingTokenText, tokenFullStart);
	    if (bestGuessIndex === -1) {
	      return void 0;
	    }
	    if (sourceFile.text.lastIndexOf(closeTokenText, tokenFullStart - 1) < bestGuessIndex) {
	      const nodeAtGuess = findPrecedingToken(bestGuessIndex + 1, sourceFile);
	      if (nodeAtGuess && nodeAtGuess.kind === matchingTokenKind) {
	        return nodeAtGuess;
	      }
	    }
	    const tokenKind = token.kind;
	    let remainingMatchingTokens = 0;
	    while (true) {
	      const preceding = findPrecedingToken(token.getFullStart(), sourceFile);
	      if (!preceding) {
	        return void 0;
	      }
	      token = preceding;
	      if (token.kind === matchingTokenKind) {
	        if (remainingMatchingTokens === 0) {
	          return token;
	        }
	        remainingMatchingTokens--;
	      } else if (token.kind === tokenKind) {
	        remainingMatchingTokens++;
	      }
	    }
	  }
	  function removeOptionality(type, isOptionalExpression, isOptionalChain2) {
	    return isOptionalExpression ? type.getNonNullableType() : isOptionalChain2 ? type.getNonOptionalType() : type;
	  }
	  function isPossiblyTypeArgumentPosition(token, sourceFile, checker) {
	    const info = getPossibleTypeArgumentsInfo(token, sourceFile);
	    return info !== void 0 && (isPartOfTypeNode(info.called) || getPossibleGenericSignatures(info.called, info.nTypeArguments, checker).length !== 0 || isPossiblyTypeArgumentPosition(info.called, sourceFile, checker));
	  }
	  function getPossibleGenericSignatures(called, typeArgumentCount, checker) {
	    let type = checker.getTypeAtLocation(called);
	    if (isOptionalChain(called.parent)) {
	      type = removeOptionality(
	        type,
	        isOptionalChainRoot(called.parent),
	        /*isOptionalChain*/
	        true
	      );
	    }
	    const signatures = isNewExpression(called.parent) ? type.getConstructSignatures() : type.getCallSignatures();
	    return signatures.filter((candidate) => !!candidate.typeParameters && candidate.typeParameters.length >= typeArgumentCount);
	  }
	  function getPossibleTypeArgumentsInfo(tokenIn, sourceFile) {
	    if (sourceFile.text.lastIndexOf("<", tokenIn ? tokenIn.pos : sourceFile.text.length) === -1) {
	      return void 0;
	    }
	    let token = tokenIn;
	    let remainingLessThanTokens = 0;
	    let nTypeArguments = 0;
	    while (token) {
	      switch (token.kind) {
	        case 30 /* LessThanToken */:
	          token = findPrecedingToken(token.getFullStart(), sourceFile);
	          if (token && token.kind === 29 /* QuestionDotToken */) {
	            token = findPrecedingToken(token.getFullStart(), sourceFile);
	          }
	          if (!token || !isIdentifier(token))
	            return void 0;
	          if (!remainingLessThanTokens) {
	            return isDeclarationName(token) ? void 0 : { called: token, nTypeArguments };
	          }
	          remainingLessThanTokens--;
	          break;
	        case 50 /* GreaterThanGreaterThanGreaterThanToken */:
	          remainingLessThanTokens = 3;
	          break;
	        case 49 /* GreaterThanGreaterThanToken */:
	          remainingLessThanTokens = 2;
	          break;
	        case 32 /* GreaterThanToken */:
	          remainingLessThanTokens++;
	          break;
	        case 20 /* CloseBraceToken */:
	          token = findPrecedingMatchingToken(token, 19 /* OpenBraceToken */, sourceFile);
	          if (!token)
	            return void 0;
	          break;
	        case 22 /* CloseParenToken */:
	          token = findPrecedingMatchingToken(token, 21 /* OpenParenToken */, sourceFile);
	          if (!token)
	            return void 0;
	          break;
	        case 24 /* CloseBracketToken */:
	          token = findPrecedingMatchingToken(token, 23 /* OpenBracketToken */, sourceFile);
	          if (!token)
	            return void 0;
	          break;
	        case 28 /* CommaToken */:
	          nTypeArguments++;
	          break;
	        case 39 /* EqualsGreaterThanToken */:
	        case 80 /* Identifier */:
	        case 11 /* StringLiteral */:
	        case 9 /* NumericLiteral */:
	        case 10 /* BigIntLiteral */:
	        case 112 /* TrueKeyword */:
	        case 97 /* FalseKeyword */:
	        case 114 /* TypeOfKeyword */:
	        case 96 /* ExtendsKeyword */:
	        case 143 /* KeyOfKeyword */:
	        case 25 /* DotToken */:
	        case 52 /* BarToken */:
	        case 58 /* QuestionToken */:
	        case 59 /* ColonToken */:
	          break;
	        default:
	          if (isTypeNode(token)) {
	            break;
	          }
	          return void 0;
	      }
	      token = findPrecedingToken(token.getFullStart(), sourceFile);
	    }
	    return void 0;
	  }
	  function isInComment(sourceFile, position, tokenAtPosition) {
	    return ts_formatting_exports.getRangeOfEnclosingComment(
	      sourceFile,
	      position,
	      /*precedingToken*/
	      void 0,
	      tokenAtPosition
	    );
	  }
	  function hasDocComment(sourceFile, position) {
	    const token = getTokenAtPosition(sourceFile, position);
	    return !!findAncestor(token, isJSDoc);
	  }
	  function nodeHasTokens(n, sourceFile) {
	    return n.kind === 1 /* EndOfFileToken */ ? !!n.jsDoc : n.getWidth(sourceFile) !== 0;
	  }
	  function getNodeModifiers(node, excludeFlags = 0 /* None */) {
	    const result = [];
	    const flags = isDeclaration(node) ? getCombinedNodeFlagsAlwaysIncludeJSDoc(node) & ~excludeFlags : 0 /* None */;
	    if (flags & 2 /* Private */)
	      result.push("private" /* privateMemberModifier */);
	    if (flags & 4 /* Protected */)
	      result.push("protected" /* protectedMemberModifier */);
	    if (flags & 1 /* Public */)
	      result.push("public" /* publicMemberModifier */);
	    if (flags & 256 /* Static */ || isClassStaticBlockDeclaration(node))
	      result.push("static" /* staticModifier */);
	    if (flags & 64 /* Abstract */)
	      result.push("abstract" /* abstractModifier */);
	    if (flags & 32 /* Export */)
	      result.push("export" /* exportedModifier */);
	    if (flags & 65536 /* Deprecated */)
	      result.push("deprecated" /* deprecatedModifier */);
	    if (node.flags & 33554432 /* Ambient */)
	      result.push("declare" /* ambientModifier */);
	    if (node.kind === 277 /* ExportAssignment */)
	      result.push("export" /* exportedModifier */);
	    return result.length > 0 ? result.join(",") : "" /* none */;
	  }
	  function getTypeArgumentOrTypeParameterList(node) {
	    if (node.kind === 183 /* TypeReference */ || node.kind === 213 /* CallExpression */) {
	      return node.typeArguments;
	    }
	    if (isFunctionLike(node) || node.kind === 263 /* ClassDeclaration */ || node.kind === 264 /* InterfaceDeclaration */) {
	      return node.typeParameters;
	    }
	    return void 0;
	  }
	  function isComment(kind) {
	    return kind === 2 /* SingleLineCommentTrivia */ || kind === 3 /* MultiLineCommentTrivia */;
	  }
	  function isStringOrRegularExpressionOrTemplateLiteral(kind) {
	    if (kind === 11 /* StringLiteral */ || kind === 14 /* RegularExpressionLiteral */ || isTemplateLiteralKind(kind)) {
	      return true;
	    }
	    return false;
	  }
	  function areIntersectedTypesAvoidingStringReduction(checker, t1, t2) {
	    return !!(t1.flags & 4 /* String */) && checker.isEmptyAnonymousObjectType(t2);
	  }
	  function isStringAndEmptyAnonymousObjectIntersection(type) {
	    if (!type.isIntersection()) {
	      return false;
	    }
	    const { types, checker } = type;
	    return types.length === 2 && (areIntersectedTypesAvoidingStringReduction(checker, types[0], types[1]) || areIntersectedTypesAvoidingStringReduction(checker, types[1], types[0]));
	  }
	  function isInsideTemplateLiteral(node, position, sourceFile) {
	    return isTemplateLiteralKind(node.kind) && (node.getStart(sourceFile) < position && position < node.end) || !!node.isUnterminated && position === node.end;
	  }
	  function isAccessibilityModifier(kind) {
	    switch (kind) {
	      case 125 /* PublicKeyword */:
	      case 123 /* PrivateKeyword */:
	      case 124 /* ProtectedKeyword */:
	        return true;
	    }
	    return false;
	  }
	  function cloneCompilerOptions(options) {
	    const result = clone(options);
	    setConfigFileInOptions(result, options && options.configFile);
	    return result;
	  }
	  function isArrayLiteralOrObjectLiteralDestructuringPattern(node) {
	    if (node.kind === 209 /* ArrayLiteralExpression */ || node.kind === 210 /* ObjectLiteralExpression */) {
	      if (node.parent.kind === 226 /* BinaryExpression */ && node.parent.left === node && node.parent.operatorToken.kind === 64 /* EqualsToken */) {
	        return true;
	      }
	      if (node.parent.kind === 250 /* ForOfStatement */ && node.parent.initializer === node) {
	        return true;
	      }
	      if (isArrayLiteralOrObjectLiteralDestructuringPattern(node.parent.kind === 303 /* PropertyAssignment */ ? node.parent.parent : node.parent)) {
	        return true;
	      }
	    }
	    return false;
	  }
	  function isInReferenceComment(sourceFile, position) {
	    return isInReferenceCommentWorker(
	      sourceFile,
	      position,
	      /*shouldBeReference*/
	      true
	    );
	  }
	  function isInNonReferenceComment(sourceFile, position) {
	    return isInReferenceCommentWorker(
	      sourceFile,
	      position,
	      /*shouldBeReference*/
	      false
	    );
	  }
	  function isInReferenceCommentWorker(sourceFile, position, shouldBeReference) {
	    const range = isInComment(
	      sourceFile,
	      position,
	      /*tokenAtPosition*/
	      void 0
	    );
	    return !!range && shouldBeReference === tripleSlashDirectivePrefixRegex.test(sourceFile.text.substring(range.pos, range.end));
	  }
	  function getReplacementSpanForContextToken(contextToken) {
	    if (!contextToken)
	      return void 0;
	    switch (contextToken.kind) {
	      case 11 /* StringLiteral */:
	      case 15 /* NoSubstitutionTemplateLiteral */:
	        return createTextSpanFromStringLiteralLikeContent(contextToken);
	      default:
	        return createTextSpanFromNode(contextToken);
	    }
	  }
	  function createTextSpanFromNode(node, sourceFile, endNode2) {
	    return createTextSpanFromBounds(node.getStart(sourceFile), (endNode2 || node).getEnd());
	  }
	  function createTextSpanFromStringLiteralLikeContent(node) {
	    if (node.isUnterminated)
	      return void 0;
	    return createTextSpanFromBounds(node.getStart() + 1, node.getEnd() - 1);
	  }
	  function createTextRangeFromNode(node, sourceFile) {
	    return createRange(node.getStart(sourceFile), node.end);
	  }
	  function createTextSpanFromRange(range) {
	    return createTextSpanFromBounds(range.pos, range.end);
	  }
	  function createTextRangeFromSpan(span) {
	    return createRange(span.start, span.start + span.length);
	  }
	  function createTextChangeFromStartLength(start, length2, newText) {
	    return createTextChange(createTextSpan(start, length2), newText);
	  }
	  function createTextChange(span, newText) {
	    return { span, newText };
	  }
	  function isTypeKeyword(kind) {
	    return contains(typeKeywords, kind);
	  }
	  function isTypeKeywordToken(node) {
	    return node.kind === 156 /* TypeKeyword */;
	  }
	  function isTypeKeywordTokenOrIdentifier(node) {
	    return isTypeKeywordToken(node) || isIdentifier(node) && node.text === "type";
	  }
	  function isExternalModuleSymbol(moduleSymbol) {
	    return !!(moduleSymbol.flags & 1536 /* Module */) && moduleSymbol.name.charCodeAt(0) === 34 /* doubleQuote */;
	  }
	  function nodeSeenTracker() {
	    const seen = [];
	    return (node) => {
	      const id = getNodeId(node);
	      return !seen[id] && (seen[id] = true);
	    };
	  }
	  function getSnapshotText(snap) {
	    return snap.getText(0, snap.getLength());
	  }
	  function repeatString(str, count) {
	    let result = "";
	    for (let i = 0; i < count; i++) {
	      result += str;
	    }
	    return result;
	  }
	  function skipConstraint(type) {
	    return type.isTypeParameter() ? type.getConstraint() || type : type;
	  }
	  function getNameFromPropertyName(name) {
	    return name.kind === 167 /* ComputedPropertyName */ ? isStringOrNumericLiteralLike(name.expression) ? name.expression.text : void 0 : isPrivateIdentifier(name) ? idText(name) : getTextOfIdentifierOrLiteral(name);
	  }
	  function programContainsModules(program) {
	    return program.getSourceFiles().some((s) => !s.isDeclarationFile && !program.isSourceFileFromExternalLibrary(s) && !!(s.externalModuleIndicator || s.commonJsModuleIndicator));
	  }
	  function programContainsEsModules(program) {
	    return program.getSourceFiles().some((s) => !s.isDeclarationFile && !program.isSourceFileFromExternalLibrary(s) && !!s.externalModuleIndicator);
	  }
	  function compilerOptionsIndicateEsModules(compilerOptions) {
	    return !!compilerOptions.module || getEmitScriptTarget(compilerOptions) >= 2 /* ES2015 */ || !!compilerOptions.noEmit;
	  }
	  function createModuleSpecifierResolutionHost(program, host) {
	    return {
	      fileExists: (fileName) => program.fileExists(fileName),
	      getCurrentDirectory: () => host.getCurrentDirectory(),
	      readFile: maybeBind(host, host.readFile),
	      useCaseSensitiveFileNames: maybeBind(host, host.useCaseSensitiveFileNames),
	      getSymlinkCache: maybeBind(host, host.getSymlinkCache) || program.getSymlinkCache,
	      getModuleSpecifierCache: maybeBind(host, host.getModuleSpecifierCache),
	      getPackageJsonInfoCache: () => {
	        var _a;
	        return (_a = program.getModuleResolutionCache()) == null ? void 0 : _a.getPackageJsonInfoCache();
	      },
	      getGlobalTypingsCacheLocation: maybeBind(host, host.getGlobalTypingsCacheLocation),
	      redirectTargetsMap: program.redirectTargetsMap,
	      getProjectReferenceRedirect: (fileName) => program.getProjectReferenceRedirect(fileName),
	      isSourceOfProjectReferenceRedirect: (fileName) => program.isSourceOfProjectReferenceRedirect(fileName),
	      getNearestAncestorDirectoryWithPackageJson: maybeBind(host, host.getNearestAncestorDirectoryWithPackageJson),
	      getFileIncludeReasons: () => program.getFileIncludeReasons(),
	      getCommonSourceDirectory: () => program.getCommonSourceDirectory()
	    };
	  }
	  function getModuleSpecifierResolverHost(program, host) {
	    return {
	      ...createModuleSpecifierResolutionHost(program, host),
	      getCommonSourceDirectory: () => program.getCommonSourceDirectory()
	    };
	  }
	  function moduleResolutionUsesNodeModules(moduleResolution) {
	    return moduleResolution === 2 /* Node10 */ || moduleResolution >= 3 /* Node16 */ && moduleResolution <= 99 /* NodeNext */ || moduleResolution === 100 /* Bundler */;
	  }
	  function makeImportIfNecessary(defaultImport, namedImports, moduleSpecifier, quotePreference) {
	    return defaultImport || namedImports && namedImports.length ? makeImport(defaultImport, namedImports, moduleSpecifier, quotePreference) : void 0;
	  }
	  function makeImport(defaultImport, namedImports, moduleSpecifier, quotePreference, isTypeOnly) {
	    return factory.createImportDeclaration(
	      /*modifiers*/
	      void 0,
	      defaultImport || namedImports ? factory.createImportClause(!!isTypeOnly, defaultImport, namedImports && namedImports.length ? factory.createNamedImports(namedImports) : void 0) : void 0,
	      typeof moduleSpecifier === "string" ? makeStringLiteral(moduleSpecifier, quotePreference) : moduleSpecifier,
	      /*attributes*/
	      void 0
	    );
	  }
	  function makeStringLiteral(text, quotePreference) {
	    return factory.createStringLiteral(text, quotePreference === 0 /* Single */);
	  }
	  function quotePreferenceFromString(str, sourceFile) {
	    return isStringDoubleQuoted(str, sourceFile) ? 1 /* Double */ : 0 /* Single */;
	  }
	  function getQuotePreference(sourceFile, preferences) {
	    if (preferences.quotePreference && preferences.quotePreference !== "auto") {
	      return preferences.quotePreference === "single" ? 0 /* Single */ : 1 /* Double */;
	    } else {
	      const firstModuleSpecifier = sourceFile.imports && find(sourceFile.imports, (n) => isStringLiteral(n) && !nodeIsSynthesized(n.parent));
	      return firstModuleSpecifier ? quotePreferenceFromString(firstModuleSpecifier, sourceFile) : 1 /* Double */;
	    }
	  }
	  function getQuoteFromPreference(qp) {
	    switch (qp) {
	      case 0 /* Single */:
	        return "'";
	      case 1 /* Double */:
	        return '"';
	      default:
	        return Debug.assertNever(qp);
	    }
	  }
	  function symbolNameNoDefault(symbol) {
	    const escaped = symbolEscapedNameNoDefault(symbol);
	    return escaped === void 0 ? void 0 : unescapeLeadingUnderscores(escaped);
	  }
	  function symbolEscapedNameNoDefault(symbol) {
	    if (symbol.escapedName !== "default" /* Default */) {
	      return symbol.escapedName;
	    }
	    return firstDefined(symbol.declarations, (decl) => {
	      const name = getNameOfDeclaration(decl);
	      return name && name.kind === 80 /* Identifier */ ? name.escapedText : void 0;
	    });
	  }
	  function isModuleSpecifierLike(node) {
	    return isStringLiteralLike(node) && (isExternalModuleReference(node.parent) || isImportDeclaration(node.parent) || isRequireCall(
	      node.parent,
	      /*requireStringLiteralLikeArgument*/
	      false
	    ) && node.parent.arguments[0] === node || isImportCall(node.parent) && node.parent.arguments[0] === node);
	  }
	  function isObjectBindingElementWithoutPropertyName(bindingElement) {
	    return isBindingElement(bindingElement) && isObjectBindingPattern(bindingElement.parent) && isIdentifier(bindingElement.name) && !bindingElement.propertyName;
	  }
	  function getPropertySymbolFromBindingElement(checker, bindingElement) {
	    const typeOfPattern = checker.getTypeAtLocation(bindingElement.parent);
	    return typeOfPattern && checker.getPropertyOfType(typeOfPattern, bindingElement.name.text);
	  }
	  function getParentNodeInSpan(node, file, span) {
	    if (!node)
	      return void 0;
	    while (node.parent) {
	      if (isSourceFile(node.parent) || !spanContainsNode(span, node.parent, file)) {
	        return node;
	      }
	      node = node.parent;
	    }
	  }
	  function spanContainsNode(span, node, file) {
	    return textSpanContainsPosition(span, node.getStart(file)) && node.getEnd() <= textSpanEnd(span);
	  }
	  function findModifier(node, kind) {
	    return canHaveModifiers(node) ? find(node.modifiers, (m) => m.kind === kind) : void 0;
	  }
	  function insertImports(changes, sourceFile, imports, blankLineBetween, preferences) {
	    const decl = isArray(imports) ? imports[0] : imports;
	    const importKindPredicate = decl.kind === 243 /* VariableStatement */ ? isRequireVariableStatement : isAnyImportSyntax;
	    const existingImportStatements = filter(sourceFile.statements, importKindPredicate);
	    let sortKind = isArray(imports) ? ts_OrganizeImports_exports.detectImportDeclarationSorting(imports, preferences) : 3 /* Both */;
	    const comparer = ts_OrganizeImports_exports.getOrganizeImportsComparer(preferences, sortKind === 2 /* CaseInsensitive */);
	    const sortedNewImports = isArray(imports) ? stableSort(imports, (a, b) => ts_OrganizeImports_exports.compareImportsOrRequireStatements(a, b, comparer)) : [imports];
	    if (!existingImportStatements.length) {
	      changes.insertNodesAtTopOfFile(sourceFile, sortedNewImports, blankLineBetween);
	    } else if (existingImportStatements && (sortKind = ts_OrganizeImports_exports.detectImportDeclarationSorting(existingImportStatements, preferences))) {
	      const comparer2 = ts_OrganizeImports_exports.getOrganizeImportsComparer(preferences, sortKind === 2 /* CaseInsensitive */);
	      for (const newImport of sortedNewImports) {
	        const insertionIndex = ts_OrganizeImports_exports.getImportDeclarationInsertionIndex(existingImportStatements, newImport, comparer2);
	        if (insertionIndex === 0) {
	          const options = existingImportStatements[0] === sourceFile.statements[0] ? { leadingTriviaOption: ts_textChanges_exports.LeadingTriviaOption.Exclude } : {};
	          changes.insertNodeBefore(
	            sourceFile,
	            existingImportStatements[0],
	            newImport,
	            /*blankLineBetween*/
	            false,
	            options
	          );
	        } else {
	          const prevImport = existingImportStatements[insertionIndex - 1];
	          changes.insertNodeAfter(sourceFile, prevImport, newImport);
	        }
	      }
	    } else {
	      const lastExistingImport = lastOrUndefined(existingImportStatements);
	      if (lastExistingImport) {
	        changes.insertNodesAfter(sourceFile, lastExistingImport, sortedNewImports);
	      } else {
	        changes.insertNodesAtTopOfFile(sourceFile, sortedNewImports, blankLineBetween);
	      }
	    }
	  }
	  function getTypeKeywordOfTypeOnlyImport(importClause, sourceFile) {
	    Debug.assert(importClause.isTypeOnly);
	    return cast(importClause.getChildAt(0, sourceFile), isTypeKeywordToken);
	  }
	  function textSpansEqual(a, b) {
	    return !!a && !!b && a.start === b.start && a.length === b.length;
	  }
	  function documentSpansEqual(a, b, useCaseSensitiveFileNames2) {
	    return (useCaseSensitiveFileNames2 ? equateStringsCaseSensitive : equateStringsCaseInsensitive)(a.fileName, b.fileName) && textSpansEqual(a.textSpan, b.textSpan);
	  }
	  function getDocumentSpansEqualityComparer(useCaseSensitiveFileNames2) {
	    return (a, b) => documentSpansEqual(a, b, useCaseSensitiveFileNames2);
	  }
	  function forEachUnique(array, callback) {
	    if (array) {
	      for (let i = 0; i < array.length; i++) {
	        if (array.indexOf(array[i]) === i) {
	          const result = callback(array[i], i);
	          if (result) {
	            return result;
	          }
	        }
	      }
	    }
	    return void 0;
	  }
	  function isTextWhiteSpaceLike(text, startPos, endPos) {
	    for (let i = startPos; i < endPos; i++) {
	      if (!isWhiteSpaceLike(text.charCodeAt(i))) {
	        return false;
	      }
	    }
	    return true;
	  }
	  function getMappedLocation(location, sourceMapper, fileExists) {
	    const mapsTo = sourceMapper.tryGetSourcePosition(location);
	    return mapsTo && (!fileExists || fileExists(normalizePath(mapsTo.fileName)) ? mapsTo : void 0);
	  }
	  function getMappedDocumentSpan(documentSpan, sourceMapper, fileExists) {
	    const { fileName, textSpan } = documentSpan;
	    const newPosition = getMappedLocation({ fileName, pos: textSpan.start }, sourceMapper, fileExists);
	    if (!newPosition)
	      return void 0;
	    const newEndPosition = getMappedLocation({ fileName, pos: textSpan.start + textSpan.length }, sourceMapper, fileExists);
	    const newLength = newEndPosition ? newEndPosition.pos - newPosition.pos : textSpan.length;
	    return {
	      fileName: newPosition.fileName,
	      textSpan: {
	        start: newPosition.pos,
	        length: newLength
	      },
	      originalFileName: documentSpan.fileName,
	      originalTextSpan: documentSpan.textSpan,
	      contextSpan: getMappedContextSpan(documentSpan, sourceMapper, fileExists),
	      originalContextSpan: documentSpan.contextSpan
	    };
	  }
	  function getMappedContextSpan(documentSpan, sourceMapper, fileExists) {
	    const contextSpanStart = documentSpan.contextSpan && getMappedLocation(
	      { fileName: documentSpan.fileName, pos: documentSpan.contextSpan.start },
	      sourceMapper,
	      fileExists
	    );
	    const contextSpanEnd = documentSpan.contextSpan && getMappedLocation(
	      { fileName: documentSpan.fileName, pos: documentSpan.contextSpan.start + documentSpan.contextSpan.length },
	      sourceMapper,
	      fileExists
	    );
	    return contextSpanStart && contextSpanEnd ? { start: contextSpanStart.pos, length: contextSpanEnd.pos - contextSpanStart.pos } : void 0;
	  }
	  function isFirstDeclarationOfSymbolParameter(symbol) {
	    const declaration = symbol.declarations ? firstOrUndefined(symbol.declarations) : void 0;
	    return !!findAncestor(declaration, (n) => isParameter(n) ? true : isBindingElement(n) || isObjectBindingPattern(n) || isArrayBindingPattern(n) ? false : "quit");
	  }
	  function getDisplayPartWriter() {
	    const absoluteMaximumLength = defaultMaximumTruncationLength * 10;
	    let displayParts;
	    let lineStart;
	    let indent3;
	    let length2;
	    resetWriter();
	    const unknownWrite = (text) => writeKind(text, 17 /* text */);
	    return {
	      displayParts: () => {
	        const finalText = displayParts.length && displayParts[displayParts.length - 1].text;
	        if (length2 > absoluteMaximumLength && finalText && finalText !== "...") {
	          if (!isWhiteSpaceLike(finalText.charCodeAt(finalText.length - 1))) {
	            displayParts.push(displayPart(" ", 16 /* space */));
	          }
	          displayParts.push(displayPart("...", 15 /* punctuation */));
	        }
	        return displayParts;
	      },
	      writeKeyword: (text) => writeKind(text, 5 /* keyword */),
	      writeOperator: (text) => writeKind(text, 12 /* operator */),
	      writePunctuation: (text) => writeKind(text, 15 /* punctuation */),
	      writeTrailingSemicolon: (text) => writeKind(text, 15 /* punctuation */),
	      writeSpace: (text) => writeKind(text, 16 /* space */),
	      writeStringLiteral: (text) => writeKind(text, 8 /* stringLiteral */),
	      writeParameter: (text) => writeKind(text, 13 /* parameterName */),
	      writeProperty: (text) => writeKind(text, 14 /* propertyName */),
	      writeLiteral: (text) => writeKind(text, 8 /* stringLiteral */),
	      writeSymbol,
	      writeLine,
	      write: unknownWrite,
	      writeComment: unknownWrite,
	      getText: () => "",
	      getTextPos: () => 0,
	      getColumn: () => 0,
	      getLine: () => 0,
	      isAtStartOfLine: () => false,
	      hasTrailingWhitespace: () => false,
	      hasTrailingComment: () => false,
	      rawWrite: notImplemented,
	      getIndent: () => indent3,
	      increaseIndent: () => {
	        indent3++;
	      },
	      decreaseIndent: () => {
	        indent3--;
	      },
	      clear: resetWriter
	    };
	    function writeIndent() {
	      if (length2 > absoluteMaximumLength)
	        return;
	      if (lineStart) {
	        const indentString = getIndentString(indent3);
	        if (indentString) {
	          length2 += indentString.length;
	          displayParts.push(displayPart(indentString, 16 /* space */));
	        }
	        lineStart = false;
	      }
	    }
	    function writeKind(text, kind) {
	      if (length2 > absoluteMaximumLength)
	        return;
	      writeIndent();
	      length2 += text.length;
	      displayParts.push(displayPart(text, kind));
	    }
	    function writeSymbol(text, symbol) {
	      if (length2 > absoluteMaximumLength)
	        return;
	      writeIndent();
	      length2 += text.length;
	      displayParts.push(symbolPart(text, symbol));
	    }
	    function writeLine() {
	      if (length2 > absoluteMaximumLength)
	        return;
	      length2 += 1;
	      displayParts.push(lineBreakPart());
	      lineStart = true;
	    }
	    function resetWriter() {
	      displayParts = [];
	      lineStart = true;
	      indent3 = 0;
	      length2 = 0;
	    }
	  }
	  function symbolPart(text, symbol) {
	    return displayPart(text, displayPartKind(symbol));
	    function displayPartKind(symbol2) {
	      const flags = symbol2.flags;
	      if (flags & 3 /* Variable */) {
	        return isFirstDeclarationOfSymbolParameter(symbol2) ? 13 /* parameterName */ : 9 /* localName */;
	      }
	      if (flags & 4 /* Property */)
	        return 14 /* propertyName */;
	      if (flags & 32768 /* GetAccessor */)
	        return 14 /* propertyName */;
	      if (flags & 65536 /* SetAccessor */)
	        return 14 /* propertyName */;
	      if (flags & 8 /* EnumMember */)
	        return 19 /* enumMemberName */;
	      if (flags & 16 /* Function */)
	        return 20 /* functionName */;
	      if (flags & 32 /* Class */)
	        return 1 /* className */;
	      if (flags & 64 /* Interface */)
	        return 4 /* interfaceName */;
	      if (flags & 384 /* Enum */)
	        return 2 /* enumName */;
	      if (flags & 1536 /* Module */)
	        return 11 /* moduleName */;
	      if (flags & 8192 /* Method */)
	        return 10 /* methodName */;
	      if (flags & 262144 /* TypeParameter */)
	        return 18 /* typeParameterName */;
	      if (flags & 524288 /* TypeAlias */)
	        return 0 /* aliasName */;
	      if (flags & 2097152 /* Alias */)
	        return 0 /* aliasName */;
	      return 17 /* text */;
	    }
	  }
	  function displayPart(text, kind) {
	    return { text, kind: SymbolDisplayPartKind[kind] };
	  }
	  function spacePart() {
	    return displayPart(" ", 16 /* space */);
	  }
	  function keywordPart(kind) {
	    return displayPart(tokenToString(kind), 5 /* keyword */);
	  }
	  function punctuationPart(kind) {
	    return displayPart(tokenToString(kind), 15 /* punctuation */);
	  }
	  function operatorPart(kind) {
	    return displayPart(tokenToString(kind), 12 /* operator */);
	  }
	  function parameterNamePart(text) {
	    return displayPart(text, 13 /* parameterName */);
	  }
	  function propertyNamePart(text) {
	    return displayPart(text, 14 /* propertyName */);
	  }
	  function textOrKeywordPart(text) {
	    const kind = stringToToken(text);
	    return kind === void 0 ? textPart(text) : keywordPart(kind);
	  }
	  function textPart(text) {
	    return displayPart(text, 17 /* text */);
	  }
	  function typeAliasNamePart(text) {
	    return displayPart(text, 0 /* aliasName */);
	  }
	  function typeParameterNamePart(text) {
	    return displayPart(text, 18 /* typeParameterName */);
	  }
	  function linkTextPart(text) {
	    return displayPart(text, 24 /* linkText */);
	  }
	  function linkNamePart(text, target) {
	    return {
	      text,
	      kind: SymbolDisplayPartKind[23 /* linkName */],
	      target: {
	        fileName: getSourceFileOfNode(target).fileName,
	        textSpan: createTextSpanFromNode(target)
	      }
	    };
	  }
	  function linkPart(text) {
	    return displayPart(text, 22 /* link */);
	  }
	  function buildLinkParts(link, checker) {
	    var _a;
	    const prefix = isJSDocLink(link) ? "link" : isJSDocLinkCode(link) ? "linkcode" : "linkplain";
	    const parts = [linkPart(`{@${prefix} `)];
	    if (!link.name) {
	      if (link.text) {
	        parts.push(linkTextPart(link.text));
	      }
	    } else {
	      const symbol = checker == null ? void 0 : checker.getSymbolAtLocation(link.name);
	      const targetSymbol = symbol && checker ? getSymbolTarget(symbol, checker) : void 0;
	      const suffix = findLinkNameEnd(link.text);
	      const name = getTextOfNode(link.name) + link.text.slice(0, suffix);
	      const text = skipSeparatorFromLinkText(link.text.slice(suffix));
	      const decl = (targetSymbol == null ? void 0 : targetSymbol.valueDeclaration) || ((_a = targetSymbol == null ? void 0 : targetSymbol.declarations) == null ? void 0 : _a[0]);
	      if (decl) {
	        parts.push(linkNamePart(name, decl));
	        if (text)
	          parts.push(linkTextPart(text));
	      } else {
	        const separator = suffix === 0 || link.text.charCodeAt(suffix) === 124 /* bar */ && name.charCodeAt(name.length - 1) !== 32 /* space */ ? " " : "";
	        parts.push(linkTextPart(name + separator + text));
	      }
	    }
	    parts.push(linkPart("}"));
	    return parts;
	  }
	  function skipSeparatorFromLinkText(text) {
	    let pos = 0;
	    if (text.charCodeAt(pos++) === 124 /* bar */) {
	      while (pos < text.length && text.charCodeAt(pos) === 32 /* space */)
	        pos++;
	      return text.slice(pos);
	    }
	    return text;
	  }
	  function findLinkNameEnd(text) {
	    let pos = text.indexOf("://");
	    if (pos === 0) {
	      while (pos < text.length && text.charCodeAt(pos) !== 124 /* bar */)
	        pos++;
	      return pos;
	    }
	    if (text.indexOf("()") === 0)
	      return 2;
	    if (text.charAt(0) === "<") {
	      let brackets2 = 0;
	      let i = 0;
	      while (i < text.length) {
	        if (text[i] === "<")
	          brackets2++;
	        if (text[i] === ">")
	          brackets2--;
	        i++;
	        if (!brackets2)
	          return i;
	      }
	    }
	    return 0;
	  }
	  function getNewLineOrDefaultFromHost(host, formatSettings) {
	    var _a;
	    return (formatSettings == null ? void 0 : formatSettings.newLineCharacter) || ((_a = host.getNewLine) == null ? void 0 : _a.call(host)) || lineFeed2;
	  }
	  function lineBreakPart() {
	    return displayPart("\n", 6 /* lineBreak */);
	  }
	  function mapToDisplayParts(writeDisplayParts) {
	    try {
	      writeDisplayParts(displayPartWriter);
	      return displayPartWriter.displayParts();
	    } finally {
	      displayPartWriter.clear();
	    }
	  }
	  function typeToDisplayParts(typechecker, type, enclosingDeclaration, flags = 0 /* None */) {
	    return mapToDisplayParts((writer) => {
	      typechecker.writeType(type, enclosingDeclaration, flags | 1024 /* MultilineObjectLiterals */ | 16384 /* UseAliasDefinedOutsideCurrentScope */, writer);
	    });
	  }
	  function symbolToDisplayParts(typeChecker, symbol, enclosingDeclaration, meaning, flags = 0 /* None */) {
	    return mapToDisplayParts((writer) => {
	      typeChecker.writeSymbol(symbol, enclosingDeclaration, meaning, flags | 8 /* UseAliasDefinedOutsideCurrentScope */, writer);
	    });
	  }
	  function signatureToDisplayParts(typechecker, signature, enclosingDeclaration, flags = 0 /* None */) {
	    flags |= 16384 /* UseAliasDefinedOutsideCurrentScope */ | 1024 /* MultilineObjectLiterals */ | 32 /* WriteTypeArgumentsOfSignature */ | 8192 /* OmitParameterModifiers */;
	    return mapToDisplayParts((writer) => {
	      typechecker.writeSignature(
	        signature,
	        enclosingDeclaration,
	        flags,
	        /*kind*/
	        void 0,
	        writer
	      );
	    });
	  }
	  function nodeToDisplayParts(node, enclosingDeclaration) {
	    const file = enclosingDeclaration.getSourceFile();
	    return mapToDisplayParts((writer) => {
	      const printer = createPrinterWithRemoveCommentsOmitTrailingSemicolon();
	      printer.writeNode(4 /* Unspecified */, node, file, writer);
	    });
	  }
	  function isImportOrExportSpecifierName(location) {
	    return !!location.parent && isImportOrExportSpecifier(location.parent) && location.parent.propertyName === location;
	  }
	  function getScriptKind(fileName, host) {
	    return ensureScriptKind(fileName, host.getScriptKind && host.getScriptKind(fileName));
	  }
	  function getSymbolTarget(symbol, checker) {
	    let next = symbol;
	    while (isAliasSymbol(next) || isTransientSymbol(next) && next.links.target) {
	      if (isTransientSymbol(next) && next.links.target) {
	        next = next.links.target;
	      } else {
	        next = skipAlias(next, checker);
	      }
	    }
	    return next;
	  }
	  function isAliasSymbol(symbol) {
	    return (symbol.flags & 2097152 /* Alias */) !== 0;
	  }
	  function getUniqueSymbolId(symbol, checker) {
	    return getSymbolId(skipAlias(symbol, checker));
	  }
	  function getFirstNonSpaceCharacterPosition(text, position) {
	    while (isWhiteSpaceLike(text.charCodeAt(position))) {
	      position += 1;
	    }
	    return position;
	  }
	  function getPrecedingNonSpaceCharacterPosition(text, position) {
	    while (position > -1 && isWhiteSpaceSingleLine(text.charCodeAt(position))) {
	      position -= 1;
	    }
	    return position + 1;
	  }
	  function getSynthesizedDeepClone(node, includeTrivia = true) {
	    const clone2 = node && getSynthesizedDeepCloneWorker(node);
	    if (clone2 && !includeTrivia)
	      suppressLeadingAndTrailingTrivia(clone2);
	    return clone2;
	  }
	  function getSynthesizedDeepCloneWithReplacements(node, includeTrivia, replaceNode) {
	    let clone2 = replaceNode(node);
	    if (clone2) {
	      setOriginalNode(clone2, node);
	    } else {
	      clone2 = getSynthesizedDeepCloneWorker(node, replaceNode);
	    }
	    if (clone2 && !includeTrivia)
	      suppressLeadingAndTrailingTrivia(clone2);
	    return clone2;
	  }
	  function getSynthesizedDeepCloneWorker(node, replaceNode) {
	    const nodeClone = replaceNode ? (n) => getSynthesizedDeepCloneWithReplacements(
	      n,
	      /*includeTrivia*/
	      true,
	      replaceNode
	    ) : getSynthesizedDeepClone;
	    const nodesClone = replaceNode ? (ns) => ns && getSynthesizedDeepClonesWithReplacements(
	      ns,
	      /*includeTrivia*/
	      true,
	      replaceNode
	    ) : (ns) => ns && getSynthesizedDeepClones(ns);
	    const visited = visitEachChild(
	      node,
	      nodeClone,
	      /*context*/
	      void 0,
	      nodesClone,
	      nodeClone
	    );
	    if (visited === node) {
	      const clone2 = isStringLiteral(node) ? setOriginalNode(factory.createStringLiteralFromNode(node), node) : isNumericLiteral(node) ? setOriginalNode(factory.createNumericLiteral(node.text, node.numericLiteralFlags), node) : factory.cloneNode(node);
	      return setTextRange(clone2, node);
	    }
	    visited.parent = void 0;
	    return visited;
	  }
	  function getSynthesizedDeepClones(nodes, includeTrivia = true) {
	    if (nodes) {
	      const cloned = factory.createNodeArray(nodes.map((n) => getSynthesizedDeepClone(n, includeTrivia)), nodes.hasTrailingComma);
	      setTextRange(cloned, nodes);
	      return cloned;
	    }
	    return nodes;
	  }
	  function getSynthesizedDeepClonesWithReplacements(nodes, includeTrivia, replaceNode) {
	    return factory.createNodeArray(nodes.map((n) => getSynthesizedDeepCloneWithReplacements(n, includeTrivia, replaceNode)), nodes.hasTrailingComma);
	  }
	  function suppressLeadingAndTrailingTrivia(node) {
	    suppressLeadingTrivia(node);
	    suppressTrailingTrivia(node);
	  }
	  function suppressLeadingTrivia(node) {
	    addEmitFlagsRecursively(node, 1024 /* NoLeadingComments */, getFirstChild);
	  }
	  function suppressTrailingTrivia(node) {
	    addEmitFlagsRecursively(node, 2048 /* NoTrailingComments */, getLastChild);
	  }
	  function copyComments(sourceNode, targetNode) {
	    const sourceFile = sourceNode.getSourceFile();
	    const text = sourceFile.text;
	    if (hasLeadingLineBreak(sourceNode, text)) {
	      copyLeadingComments(sourceNode, targetNode, sourceFile);
	    } else {
	      copyTrailingAsLeadingComments(sourceNode, targetNode, sourceFile);
	    }
	    copyTrailingComments(sourceNode, targetNode, sourceFile);
	  }
	  function hasLeadingLineBreak(node, text) {
	    const start = node.getFullStart();
	    const end = node.getStart();
	    for (let i = start; i < end; i++) {
	      if (text.charCodeAt(i) === 10 /* lineFeed */)
	        return true;
	    }
	    return false;
	  }
	  function addEmitFlagsRecursively(node, flag, getChild) {
	    addEmitFlags(node, flag);
	    const child = getChild(node);
	    if (child)
	      addEmitFlagsRecursively(child, flag, getChild);
	  }
	  function getFirstChild(node) {
	    return node.forEachChild((child) => child);
	  }
	  function getUniqueName(baseName, sourceFile) {
	    let nameText = baseName;
	    for (let i = 1; !isFileLevelUniqueName(sourceFile, nameText); i++) {
	      nameText = `${baseName}_${i}`;
	    }
	    return nameText;
	  }
	  function getRenameLocation(edits, renameFilename, name, preferLastLocation) {
	    let delta = 0;
	    let lastPos = -1;
	    for (const { fileName, textChanges: textChanges2 } of edits) {
	      Debug.assert(fileName === renameFilename);
	      for (const change of textChanges2) {
	        const { span, newText } = change;
	        const index = indexInTextChange(newText, escapeString(name));
	        if (index !== -1) {
	          lastPos = span.start + delta + index;
	          if (!preferLastLocation) {
	            return lastPos;
	          }
	        }
	        delta += newText.length - span.length;
	      }
	    }
	    Debug.assert(preferLastLocation);
	    Debug.assert(lastPos >= 0);
	    return lastPos;
	  }
	  function copyLeadingComments(sourceNode, targetNode, sourceFile, commentKind, hasTrailingNewLine) {
	    forEachLeadingCommentRange(sourceFile.text, sourceNode.pos, getAddCommentsFunction(targetNode, sourceFile, commentKind, hasTrailingNewLine, addSyntheticLeadingComment));
	  }
	  function copyTrailingComments(sourceNode, targetNode, sourceFile, commentKind, hasTrailingNewLine) {
	    forEachTrailingCommentRange(sourceFile.text, sourceNode.end, getAddCommentsFunction(targetNode, sourceFile, commentKind, hasTrailingNewLine, addSyntheticTrailingComment));
	  }
	  function copyTrailingAsLeadingComments(sourceNode, targetNode, sourceFile, commentKind, hasTrailingNewLine) {
	    forEachTrailingCommentRange(sourceFile.text, sourceNode.pos, getAddCommentsFunction(targetNode, sourceFile, commentKind, hasTrailingNewLine, addSyntheticLeadingComment));
	  }
	  function getAddCommentsFunction(targetNode, sourceFile, commentKind, hasTrailingNewLine, cb) {
	    return (pos, end, kind, htnl) => {
	      if (kind === 3 /* MultiLineCommentTrivia */) {
	        pos += 2;
	        end -= 2;
	      } else {
	        pos += 2;
	      }
	      cb(targetNode, commentKind || kind, sourceFile.text.slice(pos, end), hasTrailingNewLine !== void 0 ? hasTrailingNewLine : htnl);
	    };
	  }
	  function indexInTextChange(change, name) {
	    if (startsWith(change, name))
	      return 0;
	    let idx = change.indexOf(" " + name);
	    if (idx === -1)
	      idx = change.indexOf("." + name);
	    if (idx === -1)
	      idx = change.indexOf('"' + name);
	    return idx === -1 ? -1 : idx + 1;
	  }
	  function needsParentheses(expression) {
	    return isBinaryExpression(expression) && expression.operatorToken.kind === 28 /* CommaToken */ || isObjectLiteralExpression(expression) || (isAsExpression(expression) || isSatisfiesExpression(expression)) && isObjectLiteralExpression(expression.expression);
	  }
	  function getContextualTypeFromParent(node, checker, contextFlags) {
	    const parent2 = walkUpParenthesizedExpressions(node.parent);
	    switch (parent2.kind) {
	      case 214 /* NewExpression */:
	        return checker.getContextualType(parent2, contextFlags);
	      case 226 /* BinaryExpression */: {
	        const { left, operatorToken, right } = parent2;
	        return isEqualityOperatorKind(operatorToken.kind) ? checker.getTypeAtLocation(node === right ? left : right) : checker.getContextualType(node, contextFlags);
	      }
	      case 296 /* CaseClause */:
	        return getSwitchedType(parent2, checker);
	      default:
	        return checker.getContextualType(node, contextFlags);
	    }
	  }
	  function quote(sourceFile, preferences, text) {
	    const quotePreference = getQuotePreference(sourceFile, preferences);
	    const quoted = JSON.stringify(text);
	    return quotePreference === 0 /* Single */ ? `'${stripQuotes(quoted).replace(/'/g, () => "\\'").replace(/\\"/g, '"')}'` : quoted;
	  }
	  function isEqualityOperatorKind(kind) {
	    switch (kind) {
	      case 37 /* EqualsEqualsEqualsToken */:
	      case 35 /* EqualsEqualsToken */:
	      case 38 /* ExclamationEqualsEqualsToken */:
	      case 36 /* ExclamationEqualsToken */:
	        return true;
	      default:
	        return false;
	    }
	  }
	  function isStringLiteralOrTemplate(node) {
	    switch (node.kind) {
	      case 11 /* StringLiteral */:
	      case 15 /* NoSubstitutionTemplateLiteral */:
	      case 228 /* TemplateExpression */:
	      case 215 /* TaggedTemplateExpression */:
	        return true;
	      default:
	        return false;
	    }
	  }
	  function hasIndexSignature(type) {
	    return !!type.getStringIndexType() || !!type.getNumberIndexType();
	  }
	  function getSwitchedType(caseClause, checker) {
	    return checker.getTypeAtLocation(caseClause.parent.parent.expression);
	  }
	  function getTypeNodeIfAccessible(type, enclosingScope, program, host) {
	    const checker = program.getTypeChecker();
	    let typeIsAccessible = true;
	    const notAccessible = () => typeIsAccessible = false;
	    const res = checker.typeToTypeNode(type, enclosingScope, 1 /* NoTruncation */, {
	      trackSymbol: (symbol, declaration, meaning) => {
	        typeIsAccessible = typeIsAccessible && checker.isSymbolAccessible(
	          symbol,
	          declaration,
	          meaning,
	          /*shouldComputeAliasToMarkVisible*/
	          false
	        ).accessibility === 0 /* Accessible */;
	        return !typeIsAccessible;
	      },
	      reportInaccessibleThisError: notAccessible,
	      reportPrivateInBaseOfClassExpression: notAccessible,
	      reportInaccessibleUniqueSymbolError: notAccessible,
	      moduleResolverHost: getModuleSpecifierResolverHost(program, host)
	    });
	    return typeIsAccessible ? res : void 0;
	  }
	  function syntaxRequiresTrailingCommaOrSemicolonOrASI(kind) {
	    return kind === 179 /* CallSignature */ || kind === 180 /* ConstructSignature */ || kind === 181 /* IndexSignature */ || kind === 171 /* PropertySignature */ || kind === 173 /* MethodSignature */;
	  }
	  function syntaxRequiresTrailingFunctionBlockOrSemicolonOrASI(kind) {
	    return kind === 262 /* FunctionDeclaration */ || kind === 176 /* Constructor */ || kind === 174 /* MethodDeclaration */ || kind === 177 /* GetAccessor */ || kind === 178 /* SetAccessor */;
	  }
	  function syntaxRequiresTrailingModuleBlockOrSemicolonOrASI(kind) {
	    return kind === 267 /* ModuleDeclaration */;
	  }
	  function syntaxRequiresTrailingSemicolonOrASI(kind) {
	    return kind === 243 /* VariableStatement */ || kind === 244 /* ExpressionStatement */ || kind === 246 /* DoStatement */ || kind === 251 /* ContinueStatement */ || kind === 252 /* BreakStatement */ || kind === 253 /* ReturnStatement */ || kind === 257 /* ThrowStatement */ || kind === 259 /* DebuggerStatement */ || kind === 172 /* PropertyDeclaration */ || kind === 265 /* TypeAliasDeclaration */ || kind === 272 /* ImportDeclaration */ || kind === 271 /* ImportEqualsDeclaration */ || kind === 278 /* ExportDeclaration */ || kind === 270 /* NamespaceExportDeclaration */ || kind === 277 /* ExportAssignment */;
	  }
	  function nodeIsASICandidate(node, sourceFile) {
	    const lastToken = node.getLastToken(sourceFile);
	    if (lastToken && lastToken.kind === 27 /* SemicolonToken */) {
	      return false;
	    }
	    if (syntaxRequiresTrailingCommaOrSemicolonOrASI(node.kind)) {
	      if (lastToken && lastToken.kind === 28 /* CommaToken */) {
	        return false;
	      }
	    } else if (syntaxRequiresTrailingModuleBlockOrSemicolonOrASI(node.kind)) {
	      const lastChild = last(node.getChildren(sourceFile));
	      if (lastChild && isModuleBlock(lastChild)) {
	        return false;
	      }
	    } else if (syntaxRequiresTrailingFunctionBlockOrSemicolonOrASI(node.kind)) {
	      const lastChild = last(node.getChildren(sourceFile));
	      if (lastChild && isFunctionBlock(lastChild)) {
	        return false;
	      }
	    } else if (!syntaxRequiresTrailingSemicolonOrASI(node.kind)) {
	      return false;
	    }
	    if (node.kind === 246 /* DoStatement */) {
	      return true;
	    }
	    const topNode = findAncestor(node, (ancestor) => !ancestor.parent);
	    const nextToken = findNextToken(node, topNode, sourceFile);
	    if (!nextToken || nextToken.kind === 20 /* CloseBraceToken */) {
	      return true;
	    }
	    const startLine = sourceFile.getLineAndCharacterOfPosition(node.getEnd()).line;
	    const endLine = sourceFile.getLineAndCharacterOfPosition(nextToken.getStart(sourceFile)).line;
	    return startLine !== endLine;
	  }
	  function positionIsASICandidate(pos, context, sourceFile) {
	    const contextAncestor = findAncestor(context, (ancestor) => {
	      if (ancestor.end !== pos) {
	        return "quit";
	      }
	      return syntaxMayBeASICandidate(ancestor.kind);
	    });
	    return !!contextAncestor && nodeIsASICandidate(contextAncestor, sourceFile);
	  }
	  function probablyUsesSemicolons(sourceFile) {
	    let withSemicolon = 0;
	    let withoutSemicolon = 0;
	    const nStatementsToObserve = 5;
	    forEachChild(sourceFile, function visit(node) {
	      if (syntaxRequiresTrailingSemicolonOrASI(node.kind)) {
	        const lastToken = node.getLastToken(sourceFile);
	        if ((lastToken == null ? void 0 : lastToken.kind) === 27 /* SemicolonToken */) {
	          withSemicolon++;
	        } else {
	          withoutSemicolon++;
	        }
	      } else if (syntaxRequiresTrailingCommaOrSemicolonOrASI(node.kind)) {
	        const lastToken = node.getLastToken(sourceFile);
	        if ((lastToken == null ? void 0 : lastToken.kind) === 27 /* SemicolonToken */) {
	          withSemicolon++;
	        } else if (lastToken && lastToken.kind !== 28 /* CommaToken */) {
	          const lastTokenLine = getLineAndCharacterOfPosition(sourceFile, lastToken.getStart(sourceFile)).line;
	          const nextTokenLine = getLineAndCharacterOfPosition(sourceFile, getSpanOfTokenAtPosition(sourceFile, lastToken.end).start).line;
	          if (lastTokenLine !== nextTokenLine) {
	            withoutSemicolon++;
	          }
	        }
	      }
	      if (withSemicolon + withoutSemicolon >= nStatementsToObserve) {
	        return true;
	      }
	      return forEachChild(node, visit);
	    });
	    if (withSemicolon === 0 && withoutSemicolon <= 1) {
	      return true;
	    }
	    return withSemicolon / withoutSemicolon > 1 / nStatementsToObserve;
	  }
	  function tryGetDirectories(host, directoryName) {
	    return tryIOAndConsumeErrors(host, host.getDirectories, directoryName) || [];
	  }
	  function tryReadDirectory(host, path, extensions, exclude, include) {
	    return tryIOAndConsumeErrors(host, host.readDirectory, path, extensions, exclude, include) || emptyArray;
	  }
	  function tryFileExists(host, path) {
	    return tryIOAndConsumeErrors(host, host.fileExists, path);
	  }
	  function tryDirectoryExists(host, path) {
	    return tryAndIgnoreErrors(() => directoryProbablyExists(path, host)) || false;
	  }
	  function tryAndIgnoreErrors(cb) {
	    try {
	      return cb();
	    } catch {
	      return void 0;
	    }
	  }
	  function tryIOAndConsumeErrors(host, toApply, ...args) {
	    return tryAndIgnoreErrors(() => toApply && toApply.apply(host, args));
	  }
	  function findPackageJsons(startDirectory, host, stopDirectory) {
	    const paths = [];
	    forEachAncestorDirectory(startDirectory, (ancestor) => {
	      if (ancestor === stopDirectory) {
	        return true;
	      }
	      const currentConfigPath = combinePaths(ancestor, "package.json");
	      if (tryFileExists(host, currentConfigPath)) {
	        paths.push(currentConfigPath);
	      }
	    });
	    return paths;
	  }
	  function findPackageJson(directory, host) {
	    let packageJson;
	    forEachAncestorDirectory(directory, (ancestor) => {
	      if (ancestor === "node_modules")
	        return true;
	      packageJson = findConfigFile(ancestor, (f) => tryFileExists(host, f), "package.json");
	      if (packageJson) {
	        return true;
	      }
	    });
	    return packageJson;
	  }
	  function getPackageJsonsVisibleToFile(fileName, host) {
	    if (!host.fileExists) {
	      return [];
	    }
	    const packageJsons = [];
	    forEachAncestorDirectory(getDirectoryPath(fileName), (ancestor) => {
	      const packageJsonFileName = combinePaths(ancestor, "package.json");
	      if (host.fileExists(packageJsonFileName)) {
	        const info = createPackageJsonInfo(packageJsonFileName, host);
	        if (info) {
	          packageJsons.push(info);
	        }
	      }
	    });
	    return packageJsons;
	  }
	  function createPackageJsonInfo(fileName, host) {
	    if (!host.readFile) {
	      return void 0;
	    }
	    const dependencyKeys = ["dependencies", "devDependencies", "optionalDependencies", "peerDependencies"];
	    const stringContent = host.readFile(fileName) || "";
	    const content = tryParseJson(stringContent);
	    const info = {};
	    if (content) {
	      for (const key of dependencyKeys) {
	        const dependencies = content[key];
	        if (!dependencies) {
	          continue;
	        }
	        const dependencyMap = /* @__PURE__ */ new Map();
	        for (const packageName in dependencies) {
	          dependencyMap.set(packageName, dependencies[packageName]);
	        }
	        info[key] = dependencyMap;
	      }
	    }
	    const dependencyGroups = [
	      [1 /* Dependencies */, info.dependencies],
	      [2 /* DevDependencies */, info.devDependencies],
	      [8 /* OptionalDependencies */, info.optionalDependencies],
	      [4 /* PeerDependencies */, info.peerDependencies]
	    ];
	    return {
	      ...info,
	      parseable: !!content,
	      fileName,
	      get,
	      has(dependencyName, inGroups) {
	        return !!get(dependencyName, inGroups);
	      }
	    };
	    function get(dependencyName, inGroups = 15 /* All */) {
	      for (const [group2, deps] of dependencyGroups) {
	        if (deps && inGroups & group2) {
	          const dep = deps.get(dependencyName);
	          if (dep !== void 0) {
	            return dep;
	          }
	        }
	      }
	    }
	  }
	  function createPackageJsonImportFilter(fromFile, preferences, host) {
	    const packageJsons = (host.getPackageJsonsVisibleToFile && host.getPackageJsonsVisibleToFile(fromFile.fileName) || getPackageJsonsVisibleToFile(fromFile.fileName, host)).filter((p) => p.parseable);
	    let usesNodeCoreModules;
	    let ambientModuleCache;
	    let sourceFileCache;
	    return {
	      allowsImportingAmbientModule,
	      allowsImportingSourceFile,
	      allowsImportingSpecifier
	    };
	    function moduleSpecifierIsCoveredByPackageJson(specifier) {
	      const packageName = getNodeModuleRootSpecifier(specifier);
	      for (const packageJson of packageJsons) {
	        if (packageJson.has(packageName) || packageJson.has(getTypesPackageName(packageName))) {
	          return true;
	        }
	      }
	      return false;
	    }
	    function allowsImportingAmbientModule(moduleSymbol, moduleSpecifierResolutionHost) {
	      if (!packageJsons.length || !moduleSymbol.valueDeclaration) {
	        return true;
	      }
	      if (!ambientModuleCache) {
	        ambientModuleCache = /* @__PURE__ */ new Map();
	      } else {
	        const cached = ambientModuleCache.get(moduleSymbol);
	        if (cached !== void 0) {
	          return cached;
	        }
	      }
	      const declaredModuleSpecifier = stripQuotes(moduleSymbol.getName());
	      if (isAllowedCoreNodeModulesImport(declaredModuleSpecifier)) {
	        ambientModuleCache.set(moduleSymbol, true);
	        return true;
	      }
	      const declaringSourceFile = moduleSymbol.valueDeclaration.getSourceFile();
	      const declaringNodeModuleName = getNodeModulesPackageNameFromFileName(declaringSourceFile.fileName, moduleSpecifierResolutionHost);
	      if (typeof declaringNodeModuleName === "undefined") {
	        ambientModuleCache.set(moduleSymbol, true);
	        return true;
	      }
	      const result = moduleSpecifierIsCoveredByPackageJson(declaringNodeModuleName) || moduleSpecifierIsCoveredByPackageJson(declaredModuleSpecifier);
	      ambientModuleCache.set(moduleSymbol, result);
	      return result;
	    }
	    function allowsImportingSourceFile(sourceFile, moduleSpecifierResolutionHost) {
	      if (!packageJsons.length) {
	        return true;
	      }
	      if (!sourceFileCache) {
	        sourceFileCache = /* @__PURE__ */ new Map();
	      } else {
	        const cached = sourceFileCache.get(sourceFile);
	        if (cached !== void 0) {
	          return cached;
	        }
	      }
	      const moduleSpecifier = getNodeModulesPackageNameFromFileName(sourceFile.fileName, moduleSpecifierResolutionHost);
	      if (!moduleSpecifier) {
	        sourceFileCache.set(sourceFile, true);
	        return true;
	      }
	      const result = moduleSpecifierIsCoveredByPackageJson(moduleSpecifier);
	      sourceFileCache.set(sourceFile, result);
	      return result;
	    }
	    function allowsImportingSpecifier(moduleSpecifier) {
	      if (!packageJsons.length || isAllowedCoreNodeModulesImport(moduleSpecifier)) {
	        return true;
	      }
	      if (pathIsRelative(moduleSpecifier) || isRootedDiskPath(moduleSpecifier)) {
	        return true;
	      }
	      return moduleSpecifierIsCoveredByPackageJson(moduleSpecifier);
	    }
	    function isAllowedCoreNodeModulesImport(moduleSpecifier) {
	      if (isSourceFileJS(fromFile) && ts_JsTyping_exports.nodeCoreModules.has(moduleSpecifier)) {
	        if (usesNodeCoreModules === void 0) {
	          usesNodeCoreModules = consumesNodeCoreModules(fromFile);
	        }
	        if (usesNodeCoreModules) {
	          return true;
	        }
	      }
	      return false;
	    }
	    function getNodeModulesPackageNameFromFileName(importedFileName, moduleSpecifierResolutionHost) {
	      if (!importedFileName.includes("node_modules")) {
	        return void 0;
	      }
	      const specifier = ts_moduleSpecifiers_exports.getNodeModulesPackageName(
	        host.getCompilationSettings(),
	        fromFile,
	        importedFileName,
	        moduleSpecifierResolutionHost,
	        preferences
	      );
	      if (!specifier) {
	        return void 0;
	      }
	      if (!pathIsRelative(specifier) && !isRootedDiskPath(specifier)) {
	        return getNodeModuleRootSpecifier(specifier);
	      }
	    }
	    function getNodeModuleRootSpecifier(fullSpecifier) {
	      const components = getPathComponents(getPackageNameFromTypesPackageName(fullSpecifier)).slice(1);
	      if (startsWith(components[0], "@")) {
	        return `${components[0]}/${components[1]}`;
	      }
	      return components[0];
	    }
	  }
	  function consumesNodeCoreModules(sourceFile) {
	    return some(sourceFile.imports, ({ text }) => ts_JsTyping_exports.nodeCoreModules.has(text));
	  }
	  function isInsideNodeModules(fileOrDirectory) {
	    return contains(getPathComponents(fileOrDirectory), "node_modules");
	  }
	  function isDiagnosticWithLocation(diagnostic) {
	    return diagnostic.file !== void 0 && diagnostic.start !== void 0 && diagnostic.length !== void 0;
	  }
	  function findDiagnosticForNode(node, sortedFileDiagnostics) {
	    const span = createTextSpanFromNode(node);
	    const index = binarySearchKey(sortedFileDiagnostics, span, identity, compareTextSpans);
	    if (index >= 0) {
	      const diagnostic = sortedFileDiagnostics[index];
	      Debug.assertEqual(diagnostic.file, node.getSourceFile(), "Diagnostics proided to 'findDiagnosticForNode' must be from a single SourceFile");
	      return cast(diagnostic, isDiagnosticWithLocation);
	    }
	  }
	  function getDiagnosticsWithinSpan(span, sortedFileDiagnostics) {
	    var _a;
	    let index = binarySearchKey(sortedFileDiagnostics, span.start, (diag2) => diag2.start, compareValues);
	    if (index < 0) {
	      index = ~index;
	    }
	    while (((_a = sortedFileDiagnostics[index - 1]) == null ? void 0 : _a.start) === span.start) {
	      index--;
	    }
	    const result = [];
	    const end = textSpanEnd(span);
	    while (true) {
	      const diagnostic = tryCast(sortedFileDiagnostics[index], isDiagnosticWithLocation);
	      if (!diagnostic || diagnostic.start > end) {
	        break;
	      }
	      if (textSpanContainsTextSpan(span, diagnostic)) {
	        result.push(diagnostic);
	      }
	      index++;
	    }
	    return result;
	  }
	  function getRefactorContextSpan({ startPosition, endPosition }) {
	    return createTextSpanFromBounds(startPosition, endPosition === void 0 ? startPosition : endPosition);
	  }
	  function getFixableErrorSpanExpression(sourceFile, span) {
	    const token = getTokenAtPosition(sourceFile, span.start);
	    const expression = findAncestor(token, (node) => {
	      if (node.getStart(sourceFile) < span.start || node.getEnd() > textSpanEnd(span)) {
	        return "quit";
	      }
	      return isExpression(node) && textSpansEqual(span, createTextSpanFromNode(node, sourceFile));
	    });
	    return expression;
	  }
	  function mapOneOrMany(valueOrArray, f, resultSelector = identity) {
	    return valueOrArray ? isArray(valueOrArray) ? resultSelector(map(valueOrArray, f)) : f(valueOrArray, 0) : void 0;
	  }
	  function firstOrOnly(valueOrArray) {
	    return isArray(valueOrArray) ? first(valueOrArray) : valueOrArray;
	  }
	  function getNamesForExportedSymbol(symbol, scriptTarget) {
	    if (needsNameFromDeclaration(symbol)) {
	      const fromDeclaration = getDefaultLikeExportNameFromDeclaration(symbol);
	      if (fromDeclaration)
	        return fromDeclaration;
	      const fileNameCase = ts_codefix_exports.moduleSymbolToValidIdentifier(
	        getSymbolParentOrFail(symbol),
	        scriptTarget,
	        /*forceCapitalize*/
	        false
	      );
	      const capitalized = ts_codefix_exports.moduleSymbolToValidIdentifier(
	        getSymbolParentOrFail(symbol),
	        scriptTarget,
	        /*forceCapitalize*/
	        true
	      );
	      if (fileNameCase === capitalized)
	        return fileNameCase;
	      return [fileNameCase, capitalized];
	    }
	    return symbol.name;
	  }
	  function getNameForExportedSymbol(symbol, scriptTarget, preferCapitalized) {
	    if (needsNameFromDeclaration(symbol)) {
	      return getDefaultLikeExportNameFromDeclaration(symbol) || ts_codefix_exports.moduleSymbolToValidIdentifier(getSymbolParentOrFail(symbol), scriptTarget, !!preferCapitalized);
	    }
	    return symbol.name;
	  }
	  function needsNameFromDeclaration(symbol) {
	    return !(symbol.flags & 33554432 /* Transient */) && (symbol.escapedName === "export=" /* ExportEquals */ || symbol.escapedName === "default" /* Default */);
	  }
	  function getDefaultLikeExportNameFromDeclaration(symbol) {
	    return firstDefined(symbol.declarations, (d) => {
	      var _a, _b, _c;
	      if (isExportAssignment(d)) {
	        return (_a = tryCast(skipOuterExpressions(d.expression), isIdentifier)) == null ? void 0 : _a.text;
	      }
	      if (isExportSpecifier(d) && d.symbol.flags === 2097152 /* Alias */) {
	        return (_b = tryCast(d.propertyName, isIdentifier)) == null ? void 0 : _b.text;
	      }
	      return (_c = tryCast(getNameOfDeclaration(d), isIdentifier)) == null ? void 0 : _c.text;
	    });
	  }
	  function getSymbolParentOrFail(symbol) {
	    var _a;
	    return Debug.checkDefined(
	      symbol.parent,
	      `Symbol parent was undefined. Flags: ${Debug.formatSymbolFlags(symbol.flags)}. Declarations: ${(_a = symbol.declarations) == null ? void 0 : _a.map((d) => {
	        const kind = Debug.formatSyntaxKind(d.kind);
	        const inJS = isInJSFile(d);
	        const { expression } = d;
	        return (inJS ? "[JS]" : "") + kind + (expression ? ` (expression: ${Debug.formatSyntaxKind(expression.kind)})` : "");
	      }).join(", ")}.`
	    );
	  }
	  function stringContainsAt(haystack, needle, startIndex) {
	    const needleLength = needle.length;
	    if (needleLength + startIndex > haystack.length) {
	      return false;
	    }
	    for (let i = 0; i < needleLength; i++) {
	      if (needle.charCodeAt(i) !== haystack.charCodeAt(i + startIndex))
	        return false;
	    }
	    return true;
	  }
	  function startsWithUnderscore(name) {
	    return name.charCodeAt(0) === 95 /* _ */;
	  }
	  function isGlobalDeclaration(declaration) {
	    return !isNonGlobalDeclaration(declaration);
	  }
	  function isNonGlobalDeclaration(declaration) {
	    const sourceFile = declaration.getSourceFile();
	    if (!sourceFile.externalModuleIndicator && !sourceFile.commonJsModuleIndicator) {
	      return false;
	    }
	    return isInJSFile(declaration) || !findAncestor(declaration, (d) => isModuleDeclaration(d) && isGlobalScopeAugmentation(d));
	  }
	  function isDeprecatedDeclaration(decl) {
	    return !!(getCombinedNodeFlagsAlwaysIncludeJSDoc(decl) & 65536 /* Deprecated */);
	  }
	  function shouldUseUriStyleNodeCoreModules(file, program) {
	    const decisionFromFile = firstDefined(file.imports, (node) => {
	      if (ts_JsTyping_exports.nodeCoreModules.has(node.text)) {
	        return startsWith(node.text, "node:");
	      }
	    });
	    return decisionFromFile ?? program.usesUriStyleNodeCoreModules;
	  }
	  function getNewLineKind(newLineCharacter) {
	    return newLineCharacter === "\n" ? 1 /* LineFeed */ : 0 /* CarriageReturnLineFeed */;
	  }
	  function diagnosticToString(diag2) {
	    return isArray(diag2) ? formatStringFromArgs(getLocaleSpecificMessage(diag2[0]), diag2.slice(1)) : getLocaleSpecificMessage(diag2);
	  }
	  function getFormatCodeSettingsForWriting({ options }, sourceFile) {
	    const shouldAutoDetectSemicolonPreference = !options.semicolons || options.semicolons === "ignore" /* Ignore */;
	    const shouldRemoveSemicolons = options.semicolons === "remove" /* Remove */ || shouldAutoDetectSemicolonPreference && !probablyUsesSemicolons(sourceFile);
	    return {
	      ...options,
	      semicolons: shouldRemoveSemicolons ? "remove" /* Remove */ : "ignore" /* Ignore */
	    };
	  }
	  function jsxModeNeedsExplicitImport(jsx) {
	    return jsx === 2 /* React */ || jsx === 3 /* ReactNative */;
	  }
	  function isSourceFileFromLibrary(program, node) {
	    return program.isSourceFileFromExternalLibrary(node) || program.isSourceFileDefaultLibrary(node);
	  }
	  function newCaseClauseTracker(checker, clauses) {
	    const existingStrings = /* @__PURE__ */ new Set();
	    const existingNumbers = /* @__PURE__ */ new Set();
	    const existingBigInts = /* @__PURE__ */ new Set();
	    for (const clause of clauses) {
	      if (!isDefaultClause(clause)) {
	        const expression = skipParentheses(clause.expression);
	        if (isLiteralExpression(expression)) {
	          switch (expression.kind) {
	            case 15 /* NoSubstitutionTemplateLiteral */:
	            case 11 /* StringLiteral */:
	              existingStrings.add(expression.text);
	              break;
	            case 9 /* NumericLiteral */:
	              existingNumbers.add(parseInt(expression.text));
	              break;
	            case 10 /* BigIntLiteral */:
	              const parsedBigInt = parseBigInt(endsWith(expression.text, "n") ? expression.text.slice(0, -1) : expression.text);
	              if (parsedBigInt) {
	                existingBigInts.add(pseudoBigIntToString(parsedBigInt));
	              }
	              break;
	          }
	        } else {
	          const symbol = checker.getSymbolAtLocation(clause.expression);
	          if (symbol && symbol.valueDeclaration && isEnumMember(symbol.valueDeclaration)) {
	            const enumValue = checker.getConstantValue(symbol.valueDeclaration);
	            if (enumValue !== void 0) {
	              addValue(enumValue);
	            }
	          }
	        }
	      }
	    }
	    return {
	      addValue,
	      hasValue
	    };
	    function addValue(value) {
	      switch (typeof value) {
	        case "string":
	          existingStrings.add(value);
	          break;
	        case "number":
	          existingNumbers.add(value);
	      }
	    }
	    function hasValue(value) {
	      switch (typeof value) {
	        case "string":
	          return existingStrings.has(value);
	        case "number":
	          return existingNumbers.has(value);
	        case "object":
	          return existingBigInts.has(pseudoBigIntToString(value));
	      }
	    }
	  }
	  function fileShouldUseJavaScriptRequire(file, program, host, preferRequire) {
	    var _a;
	    const fileName = typeof file === "string" ? file : file.fileName;
	    if (!hasJSFileExtension(fileName)) {
	      return false;
	    }
	    const compilerOptions = program.getCompilerOptions();
	    const moduleKind = getEmitModuleKind(compilerOptions);
	    const impliedNodeFormat = typeof file === "string" ? getImpliedNodeFormatForFile(toPath(file, host.getCurrentDirectory(), hostGetCanonicalFileName(host)), (_a = program.getPackageJsonInfoCache) == null ? void 0 : _a.call(program), host, compilerOptions) : file.impliedNodeFormat;
	    if (impliedNodeFormat === 99 /* ESNext */) {
	      return false;
	    }
	    if (impliedNodeFormat === 1 /* CommonJS */) {
	      return true;
	    }
	    if (compilerOptions.verbatimModuleSyntax && moduleKind === 1 /* CommonJS */) {
	      return true;
	    }
	    if (compilerOptions.verbatimModuleSyntax && emitModuleKindIsNonNodeESM(moduleKind)) {
	      return false;
	    }
	    if (typeof file === "object") {
	      if (file.commonJsModuleIndicator) {
	        return true;
	      }
	      if (file.externalModuleIndicator) {
	        return false;
	      }
	    }
	    return preferRequire;
	  }
	  var scanner, SemanticMeaning, tripleSlashDirectivePrefixRegex, typeKeywords, QuotePreference, displayPartWriter, lineFeed2, ANONYMOUS, syntaxMayBeASICandidate;
	  var init_utilities4 = __esm({
	    "src/services/utilities.ts"() {
	      init_ts4();
	      scanner = createScanner(
	        99 /* Latest */,
	        /*skipTrivia*/
	        true
	      );
	      SemanticMeaning = /* @__PURE__ */ ((SemanticMeaning3) => {
	        SemanticMeaning3[SemanticMeaning3["None"] = 0] = "None";
	        SemanticMeaning3[SemanticMeaning3["Value"] = 1] = "Value";
	        SemanticMeaning3[SemanticMeaning3["Type"] = 2] = "Type";
	        SemanticMeaning3[SemanticMeaning3["Namespace"] = 4] = "Namespace";
	        SemanticMeaning3[SemanticMeaning3["All"] = 7] = "All";
	        return SemanticMeaning3;
	      })(SemanticMeaning || {});
	      tripleSlashDirectivePrefixRegex = /^\/\/\/\s*</;
	      typeKeywords = [
	        133 /* AnyKeyword */,
	        131 /* AssertsKeyword */,
	        163 /* BigIntKeyword */,
	        136 /* BooleanKeyword */,
	        97 /* FalseKeyword */,
	        140 /* InferKeyword */,
	        143 /* KeyOfKeyword */,
	        146 /* NeverKeyword */,
	        106 /* NullKeyword */,
	        150 /* NumberKeyword */,
	        151 /* ObjectKeyword */,
	        148 /* ReadonlyKeyword */,
	        154 /* StringKeyword */,
	        155 /* SymbolKeyword */,
	        114 /* TypeOfKeyword */,
	        112 /* TrueKeyword */,
	        116 /* VoidKeyword */,
	        157 /* UndefinedKeyword */,
	        158 /* UniqueKeyword */,
	        159 /* UnknownKeyword */
	      ];
	      QuotePreference = /* @__PURE__ */ ((QuotePreference7) => {
	        QuotePreference7[QuotePreference7["Single"] = 0] = "Single";
	        QuotePreference7[QuotePreference7["Double"] = 1] = "Double";
	        return QuotePreference7;
	      })(QuotePreference || {});
	      displayPartWriter = getDisplayPartWriter();
	      lineFeed2 = "\n";
	      ANONYMOUS = "anonymous function";
	      syntaxMayBeASICandidate = or(
	        syntaxRequiresTrailingCommaOrSemicolonOrASI,
	        syntaxRequiresTrailingFunctionBlockOrSemicolonOrASI,
	        syntaxRequiresTrailingModuleBlockOrSemicolonOrASI,
	        syntaxRequiresTrailingSemicolonOrASI
	      );
	    }
	  });

	  // src/services/exportInfoMap.ts
	  function createCacheableExportInfoMap(host) {
	    let exportInfoId = 1;
	    const exportInfo = createMultiMap();
	    const symbols = /* @__PURE__ */ new Map();
	    const packages = /* @__PURE__ */ new Map();
	    let usableByFileName;
	    const cache = {
	      isUsableByFile: (importingFile) => importingFile === usableByFileName,
	      isEmpty: () => !exportInfo.size,
	      clear: () => {
	        exportInfo.clear();
	        symbols.clear();
	        usableByFileName = void 0;
	      },
	      add: (importingFile, symbol, symbolTableKey, moduleSymbol, moduleFile, exportKind, isFromPackageJson, checker) => {
	        if (importingFile !== usableByFileName) {
	          cache.clear();
	          usableByFileName = importingFile;
	        }
	        let packageName;
	        if (moduleFile) {
	          const nodeModulesPathParts = getNodeModulePathParts(moduleFile.fileName);
	          if (nodeModulesPathParts) {
	            const { topLevelNodeModulesIndex, topLevelPackageNameIndex, packageRootIndex } = nodeModulesPathParts;
	            packageName = unmangleScopedPackageName(getPackageNameFromTypesPackageName(moduleFile.fileName.substring(topLevelPackageNameIndex + 1, packageRootIndex)));
	            if (startsWith(importingFile, moduleFile.path.substring(0, topLevelNodeModulesIndex))) {
	              const prevDeepestNodeModulesPath = packages.get(packageName);
	              const nodeModulesPath = moduleFile.fileName.substring(0, topLevelPackageNameIndex + 1);
	              if (prevDeepestNodeModulesPath) {
	                const prevDeepestNodeModulesIndex = prevDeepestNodeModulesPath.indexOf(nodeModulesPathPart);
	                if (topLevelNodeModulesIndex > prevDeepestNodeModulesIndex) {
	                  packages.set(packageName, nodeModulesPath);
	                }
	              } else {
	                packages.set(packageName, nodeModulesPath);
	              }
	            }
	          }
	        }
	        const isDefault = exportKind === 1 /* Default */;
	        const namedSymbol = isDefault && getLocalSymbolForExportDefault(symbol) || symbol;
	        const names = exportKind === 0 /* Named */ || isExternalModuleSymbol(namedSymbol) ? unescapeLeadingUnderscores(symbolTableKey) : getNamesForExportedSymbol(
	          namedSymbol,
	          /*scriptTarget*/
	          void 0
	        );
	        const symbolName2 = typeof names === "string" ? names : names[0];
	        const capitalizedSymbolName = typeof names === "string" ? void 0 : names[1];
	        const moduleName = stripQuotes(moduleSymbol.name);
	        const id = exportInfoId++;
	        const target = skipAlias(symbol, checker);
	        const storedSymbol = symbol.flags & 33554432 /* Transient */ ? void 0 : symbol;
	        const storedModuleSymbol = moduleSymbol.flags & 33554432 /* Transient */ ? void 0 : moduleSymbol;
	        if (!storedSymbol || !storedModuleSymbol)
	          symbols.set(id, [symbol, moduleSymbol]);
	        exportInfo.add(key(symbolName2, symbol, isExternalModuleNameRelative(moduleName) ? void 0 : moduleName, checker), {
	          id,
	          symbolTableKey,
	          symbolName: symbolName2,
	          capitalizedSymbolName,
	          moduleName,
	          moduleFile,
	          moduleFileName: moduleFile == null ? void 0 : moduleFile.fileName,
	          packageName,
	          exportKind,
	          targetFlags: target.flags,
	          isFromPackageJson,
	          symbol: storedSymbol,
	          moduleSymbol: storedModuleSymbol
	        });
	      },
	      get: (importingFile, key2) => {
	        if (importingFile !== usableByFileName)
	          return;
	        const result = exportInfo.get(key2);
	        return result == null ? void 0 : result.map(rehydrateCachedInfo);
	      },
	      search: (importingFile, preferCapitalized, matches, action) => {
	        if (importingFile !== usableByFileName)
	          return;
	        return forEachEntry(exportInfo, (info, key2) => {
	          const { symbolName: symbolName2, ambientModuleName } = parseKey(key2);
	          const name = preferCapitalized && info[0].capitalizedSymbolName || symbolName2;
	          if (matches(name, info[0].targetFlags)) {
	            const rehydrated = info.map(rehydrateCachedInfo);
	            const filtered = rehydrated.filter((r, i) => isNotShadowedByDeeperNodeModulesPackage(r, info[i].packageName));
	            if (filtered.length) {
	              const res = action(filtered, name, !!ambientModuleName, key2);
	              if (res !== void 0)
	                return res;
	            }
	          }
	        });
	      },
	      releaseSymbols: () => {
	        symbols.clear();
	      },
	      onFileChanged: (oldSourceFile, newSourceFile, typeAcquisitionEnabled) => {
	        if (fileIsGlobalOnly(oldSourceFile) && fileIsGlobalOnly(newSourceFile)) {
	          return false;
	        }
	        if (usableByFileName && usableByFileName !== newSourceFile.path || // If ATA is enabled, auto-imports uses existing imports to guess whether you want auto-imports from node.
	        // Adding or removing imports from node could change the outcome of that guess, so could change the suggestions list.
	        typeAcquisitionEnabled && consumesNodeCoreModules(oldSourceFile) !== consumesNodeCoreModules(newSourceFile) || // Module agumentation and ambient module changes can add or remove exports available to be auto-imported.
	        // Changes elsewhere in the file can change the *type* of an export in a module augmentation,
	        // but type info is gathered in getCompletionEntryDetails, which doesn't use the cache.
	        !arrayIsEqualTo(oldSourceFile.moduleAugmentations, newSourceFile.moduleAugmentations) || !ambientModuleDeclarationsAreEqual(oldSourceFile, newSourceFile)) {
	          cache.clear();
	          return true;
	        }
	        usableByFileName = newSourceFile.path;
	        return false;
	      }
	    };
	    if (Debug.isDebugging) {
	      Object.defineProperty(cache, "__cache", { value: exportInfo });
	    }
	    return cache;
	    function rehydrateCachedInfo(info) {
	      if (info.symbol && info.moduleSymbol)
	        return info;
	      const { id, exportKind, targetFlags, isFromPackageJson, moduleFileName } = info;
	      const [cachedSymbol, cachedModuleSymbol] = symbols.get(id) || emptyArray;
	      if (cachedSymbol && cachedModuleSymbol) {
	        return {
	          symbol: cachedSymbol,
	          moduleSymbol: cachedModuleSymbol,
	          moduleFileName,
	          exportKind,
	          targetFlags,
	          isFromPackageJson
	        };
	      }
	      const checker = (isFromPackageJson ? host.getPackageJsonAutoImportProvider() : host.getCurrentProgram()).getTypeChecker();
	      const moduleSymbol = info.moduleSymbol || cachedModuleSymbol || Debug.checkDefined(
	        info.moduleFile ? checker.getMergedSymbol(info.moduleFile.symbol) : checker.tryFindAmbientModule(info.moduleName)
	      );
	      const symbol = info.symbol || cachedSymbol || Debug.checkDefined(
	        exportKind === 2 /* ExportEquals */ ? checker.resolveExternalModuleSymbol(moduleSymbol) : checker.tryGetMemberInModuleExportsAndProperties(unescapeLeadingUnderscores(info.symbolTableKey), moduleSymbol),
	        `Could not find symbol '${info.symbolName}' by key '${info.symbolTableKey}' in module ${moduleSymbol.name}`
	      );
	      symbols.set(id, [symbol, moduleSymbol]);
	      return {
	        symbol,
	        moduleSymbol,
	        moduleFileName,
	        exportKind,
	        targetFlags,
	        isFromPackageJson
	      };
	    }
	    function key(importedName, symbol, ambientModuleName, checker) {
	      const moduleKey = ambientModuleName || "";
	      return `${importedName.length} ${getSymbolId(skipAlias(symbol, checker))} ${importedName} ${moduleKey}`;
	    }
	    function parseKey(key2) {
	      const firstSpace = key2.indexOf(" ");
	      const secondSpace = key2.indexOf(" ", firstSpace + 1);
	      const symbolNameLength = parseInt(key2.substring(0, firstSpace), 10);
	      const data = key2.substring(secondSpace + 1);
	      const symbolName2 = data.substring(0, symbolNameLength);
	      const moduleKey = data.substring(symbolNameLength + 1);
	      const ambientModuleName = moduleKey === "" ? void 0 : moduleKey;
	      return { symbolName: symbolName2, ambientModuleName };
	    }
	    function fileIsGlobalOnly(file) {
	      return !file.commonJsModuleIndicator && !file.externalModuleIndicator && !file.moduleAugmentations && !file.ambientModuleNames;
	    }
	    function ambientModuleDeclarationsAreEqual(oldSourceFile, newSourceFile) {
	      if (!arrayIsEqualTo(oldSourceFile.ambientModuleNames, newSourceFile.ambientModuleNames)) {
	        return false;
	      }
	      let oldFileStatementIndex = -1;
	      let newFileStatementIndex = -1;
	      for (const ambientModuleName of newSourceFile.ambientModuleNames) {
	        const isMatchingModuleDeclaration = (node) => isNonGlobalAmbientModule(node) && node.name.text === ambientModuleName;
	        oldFileStatementIndex = findIndex(oldSourceFile.statements, isMatchingModuleDeclaration, oldFileStatementIndex + 1);
	        newFileStatementIndex = findIndex(newSourceFile.statements, isMatchingModuleDeclaration, newFileStatementIndex + 1);
	        if (oldSourceFile.statements[oldFileStatementIndex] !== newSourceFile.statements[newFileStatementIndex]) {
	          return false;
	        }
	      }
	      return true;
	    }
	    function isNotShadowedByDeeperNodeModulesPackage(info, packageName) {
	      if (!packageName || !info.moduleFileName)
	        return true;
	      const typingsCacheLocation = host.getGlobalTypingsCacheLocation();
	      if (typingsCacheLocation && startsWith(info.moduleFileName, typingsCacheLocation))
	        return true;
	      const packageDeepestNodeModulesPath = packages.get(packageName);
	      return !packageDeepestNodeModulesPath || startsWith(info.moduleFileName, packageDeepestNodeModulesPath);
	    }
	  }
	  function isImportableFile(program, from, to, preferences, packageJsonFilter, moduleSpecifierResolutionHost, moduleSpecifierCache) {
	    var _a;
	    if (from === to)
	      return false;
	    const cachedResult = moduleSpecifierCache == null ? void 0 : moduleSpecifierCache.get(from.path, to.path, preferences, {});
	    if ((cachedResult == null ? void 0 : cachedResult.isBlockedByPackageJsonDependencies) !== void 0) {
	      return !cachedResult.isBlockedByPackageJsonDependencies;
	    }
	    const getCanonicalFileName = hostGetCanonicalFileName(moduleSpecifierResolutionHost);
	    const globalTypingsCache = (_a = moduleSpecifierResolutionHost.getGlobalTypingsCacheLocation) == null ? void 0 : _a.call(moduleSpecifierResolutionHost);
	    const hasImportablePath = !!ts_moduleSpecifiers_exports.forEachFileNameOfModule(
	      from.fileName,
	      to.fileName,
	      moduleSpecifierResolutionHost,
	      /*preferSymlinks*/
	      false,
	      (toPath3) => {
	        const toFile = program.getSourceFile(toPath3);
	        return (toFile === to || !toFile) && isImportablePath(from.fileName, toPath3, getCanonicalFileName, globalTypingsCache);
	      }
	    );
	    if (packageJsonFilter) {
	      const isAutoImportable = hasImportablePath && packageJsonFilter.allowsImportingSourceFile(to, moduleSpecifierResolutionHost);
	      moduleSpecifierCache == null ? void 0 : moduleSpecifierCache.setBlockedByPackageJsonDependencies(from.path, to.path, preferences, {}, !isAutoImportable);
	      return isAutoImportable;
	    }
	    return hasImportablePath;
	  }
	  function isImportablePath(fromPath, toPath3, getCanonicalFileName, globalCachePath) {
	    const toNodeModules = forEachAncestorDirectory(toPath3, (ancestor) => getBaseFileName(ancestor) === "node_modules" ? ancestor : void 0);
	    const toNodeModulesParent = toNodeModules && getDirectoryPath(getCanonicalFileName(toNodeModules));
	    return toNodeModulesParent === void 0 || startsWith(getCanonicalFileName(fromPath), toNodeModulesParent) || !!globalCachePath && startsWith(getCanonicalFileName(globalCachePath), toNodeModulesParent);
	  }
	  function forEachExternalModuleToImportFrom(program, host, preferences, useAutoImportProvider, cb) {
	    var _a, _b;
	    const useCaseSensitiveFileNames2 = hostUsesCaseSensitiveFileNames(host);
	    const excludePatterns = preferences.autoImportFileExcludePatterns && mapDefined(preferences.autoImportFileExcludePatterns, (spec) => {
	      const pattern = getSubPatternFromSpec(spec, "", "exclude");
	      return pattern ? getRegexFromPattern(pattern, useCaseSensitiveFileNames2) : void 0;
	    });
	    forEachExternalModule(program.getTypeChecker(), program.getSourceFiles(), excludePatterns, host, (module2, file) => cb(
	      module2,
	      file,
	      program,
	      /*isFromPackageJson*/
	      false
	    ));
	    const autoImportProvider = useAutoImportProvider && ((_a = host.getPackageJsonAutoImportProvider) == null ? void 0 : _a.call(host));
	    if (autoImportProvider) {
	      const start = timestamp();
	      const checker = program.getTypeChecker();
	      forEachExternalModule(autoImportProvider.getTypeChecker(), autoImportProvider.getSourceFiles(), excludePatterns, host, (module2, file) => {
	        if (file && !program.getSourceFile(file.fileName) || !file && !checker.resolveName(
	          module2.name,
	          /*location*/
	          void 0,
	          1536 /* Module */,
	          /*excludeGlobals*/
	          false
	        )) {
	          cb(
	            module2,
	            file,
	            autoImportProvider,
	            /*isFromPackageJson*/
	            true
	          );
	        }
	      });
	      (_b = host.log) == null ? void 0 : _b.call(host, `forEachExternalModuleToImportFrom autoImportProvider: ${timestamp() - start}`);
	    }
	  }
	  function forEachExternalModule(checker, allSourceFiles, excludePatterns, host, cb) {
	    var _a, _b;
	    const realpathsWithSymlinks = (_a = host.getSymlinkCache) == null ? void 0 : _a.call(host).getSymlinkedDirectoriesByRealpath();
	    const isExcluded = excludePatterns && (({ fileName, path }) => {
	      if (excludePatterns.some((p) => p.test(fileName)))
	        return true;
	      if ((realpathsWithSymlinks == null ? void 0 : realpathsWithSymlinks.size) && pathContainsNodeModules(fileName)) {
	        let dir = getDirectoryPath(fileName);
	        return forEachAncestorDirectory(getDirectoryPath(path), (dirPath) => {
	          const symlinks = realpathsWithSymlinks.get(ensureTrailingDirectorySeparator(dirPath));
	          if (symlinks) {
	            return symlinks.some((s) => excludePatterns.some((p) => p.test(fileName.replace(dir, s))));
	          }
	          dir = getDirectoryPath(dir);
	        }) ?? false;
	      }
	      return false;
	    });
	    for (const ambient of checker.getAmbientModules()) {
	      if (!ambient.name.includes("*") && !(excludePatterns && ((_b = ambient.declarations) == null ? void 0 : _b.every((d) => isExcluded(d.getSourceFile()))))) {
	        cb(
	          ambient,
	          /*sourceFile*/
	          void 0
	        );
	      }
	    }
	    for (const sourceFile of allSourceFiles) {
	      if (isExternalOrCommonJsModule(sourceFile) && !(isExcluded == null ? void 0 : isExcluded(sourceFile))) {
	        cb(checker.getMergedSymbol(sourceFile.symbol), sourceFile);
	      }
	    }
	  }
	  function getExportInfoMap(importingFile, host, program, preferences, cancellationToken) {
	    var _a, _b, _c, _d, _e;
	    const start = timestamp();
	    (_a = host.getPackageJsonAutoImportProvider) == null ? void 0 : _a.call(host);
	    const cache = ((_b = host.getCachedExportInfoMap) == null ? void 0 : _b.call(host)) || createCacheableExportInfoMap({
	      getCurrentProgram: () => program,
	      getPackageJsonAutoImportProvider: () => {
	        var _a2;
	        return (_a2 = host.getPackageJsonAutoImportProvider) == null ? void 0 : _a2.call(host);
	      },
	      getGlobalTypingsCacheLocation: () => {
	        var _a2;
	        return (_a2 = host.getGlobalTypingsCacheLocation) == null ? void 0 : _a2.call(host);
	      }
	    });
	    if (cache.isUsableByFile(importingFile.path)) {
	      (_c = host.log) == null ? void 0 : _c.call(host, "getExportInfoMap: cache hit");
	      return cache;
	    }
	    (_d = host.log) == null ? void 0 : _d.call(host, "getExportInfoMap: cache miss or empty; calculating new results");
	    const compilerOptions = program.getCompilerOptions();
	    let moduleCount = 0;
	    try {
	      forEachExternalModuleToImportFrom(
	        program,
	        host,
	        preferences,
	        /*useAutoImportProvider*/
	        true,
	        (moduleSymbol, moduleFile, program2, isFromPackageJson) => {
	          if (++moduleCount % 100 === 0)
	            cancellationToken == null ? void 0 : cancellationToken.throwIfCancellationRequested();
	          const seenExports = /* @__PURE__ */ new Map();
	          const checker = program2.getTypeChecker();
	          const defaultInfo = getDefaultLikeExportInfo(moduleSymbol, checker, compilerOptions);
	          if (defaultInfo && isImportableSymbol(defaultInfo.symbol, checker)) {
	            cache.add(
	              importingFile.path,
	              defaultInfo.symbol,
	              defaultInfo.exportKind === 1 /* Default */ ? "default" /* Default */ : "export=" /* ExportEquals */,
	              moduleSymbol,
	              moduleFile,
	              defaultInfo.exportKind,
	              isFromPackageJson,
	              checker
	            );
	          }
	          checker.forEachExportAndPropertyOfModule(moduleSymbol, (exported, key) => {
	            if (exported !== (defaultInfo == null ? void 0 : defaultInfo.symbol) && isImportableSymbol(exported, checker) && addToSeen(seenExports, key)) {
	              cache.add(
	                importingFile.path,
	                exported,
	                key,
	                moduleSymbol,
	                moduleFile,
	                0 /* Named */,
	                isFromPackageJson,
	                checker
	              );
	            }
	          });
	        }
	      );
	    } catch (err) {
	      cache.clear();
	      throw err;
	    }
	    (_e = host.log) == null ? void 0 : _e.call(host, `getExportInfoMap: done in ${timestamp() - start} ms`);
	    return cache;
	  }
	  function getDefaultLikeExportInfo(moduleSymbol, checker, compilerOptions) {
	    const exported = getDefaultLikeExportWorker(moduleSymbol, checker);
	    if (!exported)
	      return void 0;
	    const { symbol, exportKind } = exported;
	    const info = getDefaultExportInfoWorker(symbol, checker, compilerOptions);
	    return info && { symbol, exportKind, ...info };
	  }
	  function isImportableSymbol(symbol, checker) {
	    return !checker.isUndefinedSymbol(symbol) && !checker.isUnknownSymbol(symbol) && !isKnownSymbol(symbol) && !isPrivateIdentifierSymbol(symbol);
	  }
	  function getDefaultLikeExportWorker(moduleSymbol, checker) {
	    const exportEquals = checker.resolveExternalModuleSymbol(moduleSymbol);
	    if (exportEquals !== moduleSymbol)
	      return { symbol: exportEquals, exportKind: 2 /* ExportEquals */ };
	    const defaultExport = checker.tryGetMemberInModuleExports("default" /* Default */, moduleSymbol);
	    if (defaultExport)
	      return { symbol: defaultExport, exportKind: 1 /* Default */ };
	  }
	  function getDefaultExportInfoWorker(defaultExport, checker, compilerOptions) {
	    const localSymbol = getLocalSymbolForExportDefault(defaultExport);
	    if (localSymbol)
	      return { resolvedSymbol: localSymbol, name: localSymbol.name };
	    const name = getNameForExportDefault(defaultExport);
	    if (name !== void 0)
	      return { resolvedSymbol: defaultExport, name };
	    if (defaultExport.flags & 2097152 /* Alias */) {
	      const aliased = checker.getImmediateAliasedSymbol(defaultExport);
	      if (aliased && aliased.parent) {
	        return getDefaultExportInfoWorker(aliased, checker, compilerOptions);
	      }
	    }
	    if (defaultExport.escapedName !== "default" /* Default */ && defaultExport.escapedName !== "export=" /* ExportEquals */) {
	      return { resolvedSymbol: defaultExport, name: defaultExport.getName() };
	    }
	    return { resolvedSymbol: defaultExport, name: getNameForExportedSymbol(defaultExport, compilerOptions.target) };
	  }
	  function getNameForExportDefault(symbol) {
	    return symbol.declarations && firstDefined(symbol.declarations, (declaration) => {
	      var _a;
	      if (isExportAssignment(declaration)) {
	        return (_a = tryCast(skipOuterExpressions(declaration.expression), isIdentifier)) == null ? void 0 : _a.text;
	      } else if (isExportSpecifier(declaration)) {
	        Debug.assert(declaration.name.text === "default" /* Default */, "Expected the specifier to be a default export");
	        return declaration.propertyName && declaration.propertyName.text;
	      }
	    });
	  }
	  var ImportKind, ExportKind;
	  var init_exportInfoMap = __esm({
	    "src/services/exportInfoMap.ts"() {
	      init_ts4();
	      ImportKind = /* @__PURE__ */ ((ImportKind2) => {
	        ImportKind2[ImportKind2["Named"] = 0] = "Named";
	        ImportKind2[ImportKind2["Default"] = 1] = "Default";
	        ImportKind2[ImportKind2["Namespace"] = 2] = "Namespace";
	        ImportKind2[ImportKind2["CommonJS"] = 3] = "CommonJS";
	        return ImportKind2;
	      })(ImportKind || {});
	      ExportKind = /* @__PURE__ */ ((ExportKind3) => {
	        ExportKind3[ExportKind3["Named"] = 0] = "Named";
	        ExportKind3[ExportKind3["Default"] = 1] = "Default";
	        ExportKind3[ExportKind3["ExportEquals"] = 2] = "ExportEquals";
	        ExportKind3[ExportKind3["UMD"] = 3] = "UMD";
	        return ExportKind3;
	      })(ExportKind || {});
	    }
	  });

	  // src/services/classifier.ts
	  function createClassifier() {
	    const scanner2 = createScanner(
	      99 /* Latest */,
	      /*skipTrivia*/
	      false
	    );
	    function getClassificationsForLine(text, lexState, syntacticClassifierAbsent) {
	      return convertClassificationsToResult(getEncodedLexicalClassifications(text, lexState, syntacticClassifierAbsent), text);
	    }
	    function getEncodedLexicalClassifications(text, lexState, syntacticClassifierAbsent) {
	      let token = 0 /* Unknown */;
	      let lastNonTriviaToken = 0 /* Unknown */;
	      const templateStack = [];
	      const { prefix, pushTemplate } = getPrefixFromLexState(lexState);
	      text = prefix + text;
	      const offset = prefix.length;
	      if (pushTemplate) {
	        templateStack.push(16 /* TemplateHead */);
	      }
	      scanner2.setText(text);
	      let endOfLineState = 0 /* None */;
	      const spans = [];
	      let angleBracketStack = 0;
	      do {
	        token = scanner2.scan();
	        if (!isTrivia(token)) {
	          handleToken();
	          lastNonTriviaToken = token;
	        }
	        const end = scanner2.getTokenEnd();
	        pushEncodedClassification(scanner2.getTokenStart(), end, offset, classFromKind(token), spans);
	        if (end >= text.length) {
	          const end2 = getNewEndOfLineState(scanner2, token, lastOrUndefined(templateStack));
	          if (end2 !== void 0) {
	            endOfLineState = end2;
	          }
	        }
	      } while (token !== 1 /* EndOfFileToken */);
	      function handleToken() {
	        switch (token) {
	          case 44 /* SlashToken */:
	          case 69 /* SlashEqualsToken */:
	            if (!noRegexTable[lastNonTriviaToken] && scanner2.reScanSlashToken() === 14 /* RegularExpressionLiteral */) {
	              token = 14 /* RegularExpressionLiteral */;
	            }
	            break;
	          case 30 /* LessThanToken */:
	            if (lastNonTriviaToken === 80 /* Identifier */) {
	              angleBracketStack++;
	            }
	            break;
	          case 32 /* GreaterThanToken */:
	            if (angleBracketStack > 0) {
	              angleBracketStack--;
	            }
	            break;
	          case 133 /* AnyKeyword */:
	          case 154 /* StringKeyword */:
	          case 150 /* NumberKeyword */:
	          case 136 /* BooleanKeyword */:
	          case 155 /* SymbolKeyword */:
	            if (angleBracketStack > 0 && !syntacticClassifierAbsent) {
	              token = 80 /* Identifier */;
	            }
	            break;
	          case 16 /* TemplateHead */:
	            templateStack.push(token);
	            break;
	          case 19 /* OpenBraceToken */:
	            if (templateStack.length > 0) {
	              templateStack.push(token);
	            }
	            break;
	          case 20 /* CloseBraceToken */:
	            if (templateStack.length > 0) {
	              const lastTemplateStackToken = lastOrUndefined(templateStack);
	              if (lastTemplateStackToken === 16 /* TemplateHead */) {
	                token = scanner2.reScanTemplateToken(
	                  /*isTaggedTemplate*/
	                  false
	                );
	                if (token === 18 /* TemplateTail */) {
	                  templateStack.pop();
	                } else {
	                  Debug.assertEqual(token, 17 /* TemplateMiddle */, "Should have been a template middle.");
	                }
	              } else {
	                Debug.assertEqual(lastTemplateStackToken, 19 /* OpenBraceToken */, "Should have been an open brace");
	                templateStack.pop();
	              }
	            }
	            break;
	          default:
	            if (!isKeyword(token)) {
	              break;
	            }
	            if (lastNonTriviaToken === 25 /* DotToken */) {
	              token = 80 /* Identifier */;
	            } else if (isKeyword(lastNonTriviaToken) && isKeyword(token) && !canFollow(lastNonTriviaToken, token)) {
	              token = 80 /* Identifier */;
	            }
	        }
	      }
	      return { endOfLineState, spans };
	    }
	    return { getClassificationsForLine, getEncodedLexicalClassifications };
	  }
	  function getNewEndOfLineState(scanner2, token, lastOnTemplateStack) {
	    switch (token) {
	      case 11 /* StringLiteral */: {
	        if (!scanner2.isUnterminated())
	          return void 0;
	        const tokenText = scanner2.getTokenText();
	        const lastCharIndex = tokenText.length - 1;
	        let numBackslashes = 0;
	        while (tokenText.charCodeAt(lastCharIndex - numBackslashes) === 92 /* backslash */) {
	          numBackslashes++;
	        }
	        if ((numBackslashes & 1) === 0)
	          return void 0;
	        return tokenText.charCodeAt(0) === 34 /* doubleQuote */ ? 3 /* InDoubleQuoteStringLiteral */ : 2 /* InSingleQuoteStringLiteral */;
	      }
	      case 3 /* MultiLineCommentTrivia */:
	        return scanner2.isUnterminated() ? 1 /* InMultiLineCommentTrivia */ : void 0;
	      default:
	        if (isTemplateLiteralKind(token)) {
	          if (!scanner2.isUnterminated()) {
	            return void 0;
	          }
	          switch (token) {
	            case 18 /* TemplateTail */:
	              return 5 /* InTemplateMiddleOrTail */;
	            case 15 /* NoSubstitutionTemplateLiteral */:
	              return 4 /* InTemplateHeadOrNoSubstitutionTemplate */;
	            default:
	              return Debug.fail("Only 'NoSubstitutionTemplateLiteral's and 'TemplateTail's can be unterminated; got SyntaxKind #" + token);
	          }
	        }
	        return lastOnTemplateStack === 16 /* TemplateHead */ ? 6 /* InTemplateSubstitutionPosition */ : void 0;
	    }
	  }
	  function pushEncodedClassification(start, end, offset, classification, result) {
	    if (classification === 8 /* whiteSpace */) {
	      return;
	    }
	    if (start === 0 && offset > 0) {
	      start += offset;
	    }
	    const length2 = end - start;
	    if (length2 > 0) {
	      result.push(start - offset, length2, classification);
	    }
	  }
	  function convertClassificationsToResult(classifications, text) {
	    const entries = [];
	    const dense = classifications.spans;
	    let lastEnd = 0;
	    for (let i = 0; i < dense.length; i += 3) {
	      const start = dense[i];
	      const length2 = dense[i + 1];
	      const type = dense[i + 2];
	      if (lastEnd >= 0) {
	        const whitespaceLength2 = start - lastEnd;
	        if (whitespaceLength2 > 0) {
	          entries.push({ length: whitespaceLength2, classification: 4 /* Whitespace */ });
	        }
	      }
	      entries.push({ length: length2, classification: convertClassification(type) });
	      lastEnd = start + length2;
	    }
	    const whitespaceLength = text.length - lastEnd;
	    if (whitespaceLength > 0) {
	      entries.push({ length: whitespaceLength, classification: 4 /* Whitespace */ });
	    }
	    return { entries, finalLexState: classifications.endOfLineState };
	  }
	  function convertClassification(type) {
	    switch (type) {
	      case 1 /* comment */:
	        return 3 /* Comment */;
	      case 3 /* keyword */:
	        return 1 /* Keyword */;
	      case 4 /* numericLiteral */:
	        return 6 /* NumberLiteral */;
	      case 25 /* bigintLiteral */:
	        return 7 /* BigIntLiteral */;
	      case 5 /* operator */:
	        return 2 /* Operator */;
	      case 6 /* stringLiteral */:
	        return 8 /* StringLiteral */;
	      case 8 /* whiteSpace */:
	        return 4 /* Whitespace */;
	      case 10 /* punctuation */:
	        return 0 /* Punctuation */;
	      case 2 /* identifier */:
	      case 11 /* className */:
	      case 12 /* enumName */:
	      case 13 /* interfaceName */:
	      case 14 /* moduleName */:
	      case 15 /* typeParameterName */:
	      case 16 /* typeAliasName */:
	      case 9 /* text */:
	      case 17 /* parameterName */:
	        return 5 /* Identifier */;
	      default:
	        return void 0;
	    }
	  }
	  function canFollow(keyword1, keyword2) {
	    if (!isAccessibilityModifier(keyword1)) {
	      return true;
	    }
	    switch (keyword2) {
	      case 139 /* GetKeyword */:
	      case 153 /* SetKeyword */:
	      case 137 /* ConstructorKeyword */:
	      case 126 /* StaticKeyword */:
	      case 129 /* AccessorKeyword */:
	        return true;
	      default:
	        return false;
	    }
	  }
	  function getPrefixFromLexState(lexState) {
	    switch (lexState) {
	      case 3 /* InDoubleQuoteStringLiteral */:
	        return { prefix: '"\\\n' };
	      case 2 /* InSingleQuoteStringLiteral */:
	        return { prefix: "'\\\n" };
	      case 1 /* InMultiLineCommentTrivia */:
	        return { prefix: "/*\n" };
	      case 4 /* InTemplateHeadOrNoSubstitutionTemplate */:
	        return { prefix: "`\n" };
	      case 5 /* InTemplateMiddleOrTail */:
	        return { prefix: "}\n", pushTemplate: true };
	      case 6 /* InTemplateSubstitutionPosition */:
	        return { prefix: "", pushTemplate: true };
	      case 0 /* None */:
	        return { prefix: "" };
	      default:
	        return Debug.assertNever(lexState);
	    }
	  }
	  function isBinaryExpressionOperatorToken(token) {
	    switch (token) {
	      case 42 /* AsteriskToken */:
	      case 44 /* SlashToken */:
	      case 45 /* PercentToken */:
	      case 40 /* PlusToken */:
	      case 41 /* MinusToken */:
	      case 48 /* LessThanLessThanToken */:
	      case 49 /* GreaterThanGreaterThanToken */:
	      case 50 /* GreaterThanGreaterThanGreaterThanToken */:
	      case 30 /* LessThanToken */:
	      case 32 /* GreaterThanToken */:
	      case 33 /* LessThanEqualsToken */:
	      case 34 /* GreaterThanEqualsToken */:
	      case 104 /* InstanceOfKeyword */:
	      case 103 /* InKeyword */:
	      case 130 /* AsKeyword */:
	      case 152 /* SatisfiesKeyword */:
	      case 35 /* EqualsEqualsToken */:
	      case 36 /* ExclamationEqualsToken */:
	      case 37 /* EqualsEqualsEqualsToken */:
	      case 38 /* ExclamationEqualsEqualsToken */:
	      case 51 /* AmpersandToken */:
	      case 53 /* CaretToken */:
	      case 52 /* BarToken */:
	      case 56 /* AmpersandAmpersandToken */:
	      case 57 /* BarBarToken */:
	      case 75 /* BarEqualsToken */:
	      case 74 /* AmpersandEqualsToken */:
	      case 79 /* CaretEqualsToken */:
	      case 71 /* LessThanLessThanEqualsToken */:
	      case 72 /* GreaterThanGreaterThanEqualsToken */:
	      case 73 /* GreaterThanGreaterThanGreaterThanEqualsToken */:
	      case 65 /* PlusEqualsToken */:
	      case 66 /* MinusEqualsToken */:
	      case 67 /* AsteriskEqualsToken */:
	      case 69 /* SlashEqualsToken */:
	      case 70 /* PercentEqualsToken */:
	      case 64 /* EqualsToken */:
	      case 28 /* CommaToken */:
	      case 61 /* QuestionQuestionToken */:
	      case 76 /* BarBarEqualsToken */:
	      case 77 /* AmpersandAmpersandEqualsToken */:
	      case 78 /* QuestionQuestionEqualsToken */:
	        return true;
	      default:
	        return false;
	    }
	  }
	  function isPrefixUnaryExpressionOperatorToken(token) {
	    switch (token) {
	      case 40 /* PlusToken */:
	      case 41 /* MinusToken */:
	      case 55 /* TildeToken */:
	      case 54 /* ExclamationToken */:
	      case 46 /* PlusPlusToken */:
	      case 47 /* MinusMinusToken */:
	        return true;
	      default:
	        return false;
	    }
	  }
	  function classFromKind(token) {
	    if (isKeyword(token)) {
	      return 3 /* keyword */;
	    } else if (isBinaryExpressionOperatorToken(token) || isPrefixUnaryExpressionOperatorToken(token)) {
	      return 5 /* operator */;
	    } else if (token >= 19 /* FirstPunctuation */ && token <= 79 /* LastPunctuation */) {
	      return 10 /* punctuation */;
	    }
	    switch (token) {
	      case 9 /* NumericLiteral */:
	        return 4 /* numericLiteral */;
	      case 10 /* BigIntLiteral */:
	        return 25 /* bigintLiteral */;
	      case 11 /* StringLiteral */:
	        return 6 /* stringLiteral */;
	      case 14 /* RegularExpressionLiteral */:
	        return 7 /* regularExpressionLiteral */;
	      case 7 /* ConflictMarkerTrivia */:
	      case 3 /* MultiLineCommentTrivia */:
	      case 2 /* SingleLineCommentTrivia */:
	        return 1 /* comment */;
	      case 5 /* WhitespaceTrivia */:
	      case 4 /* NewLineTrivia */:
	        return 8 /* whiteSpace */;
	      case 80 /* Identifier */:
	      default:
	        if (isTemplateLiteralKind(token)) {
	          return 6 /* stringLiteral */;
	        }
	        return 2 /* identifier */;
	    }
	  }
	  function getSemanticClassifications(typeChecker, cancellationToken, sourceFile, classifiableNames, span) {
	    return convertClassificationsToSpans(getEncodedSemanticClassifications(typeChecker, cancellationToken, sourceFile, classifiableNames, span));
	  }
	  function checkForClassificationCancellation(cancellationToken, kind) {
	    switch (kind) {
	      case 267 /* ModuleDeclaration */:
	      case 263 /* ClassDeclaration */:
	      case 264 /* InterfaceDeclaration */:
	      case 262 /* FunctionDeclaration */:
	      case 231 /* ClassExpression */:
	      case 218 /* FunctionExpression */:
	      case 219 /* ArrowFunction */:
	        cancellationToken.throwIfCancellationRequested();
	    }
	  }
	  function getEncodedSemanticClassifications(typeChecker, cancellationToken, sourceFile, classifiableNames, span) {
	    const spans = [];
	    sourceFile.forEachChild(function cb(node) {
	      if (!node || !textSpanIntersectsWith(span, node.pos, node.getFullWidth())) {
	        return;
	      }
	      checkForClassificationCancellation(cancellationToken, node.kind);
	      if (isIdentifier(node) && !nodeIsMissing(node) && classifiableNames.has(node.escapedText)) {
	        const symbol = typeChecker.getSymbolAtLocation(node);
	        const type = symbol && classifySymbol(symbol, getMeaningFromLocation(node), typeChecker);
	        if (type) {
	          pushClassification(node.getStart(sourceFile), node.getEnd(), type);
	        }
	      }
	      node.forEachChild(cb);
	    });
	    return { spans, endOfLineState: 0 /* None */ };
	    function pushClassification(start, end, type) {
	      const length2 = end - start;
	      Debug.assert(length2 > 0, `Classification had non-positive length of ${length2}`);
	      spans.push(start);
	      spans.push(length2);
	      spans.push(type);
	    }
	  }
	  function classifySymbol(symbol, meaningAtPosition, checker) {
	    const flags = symbol.getFlags();
	    if ((flags & 2885600 /* Classifiable */) === 0 /* None */) {
	      return void 0;
	    } else if (flags & 32 /* Class */) {
	      return 11 /* className */;
	    } else if (flags & 384 /* Enum */) {
	      return 12 /* enumName */;
	    } else if (flags & 524288 /* TypeAlias */) {
	      return 16 /* typeAliasName */;
	    } else if (flags & 1536 /* Module */) {
	      return meaningAtPosition & 4 /* Namespace */ || meaningAtPosition & 1 /* Value */ && hasValueSideModule(symbol) ? 14 /* moduleName */ : void 0;
	    } else if (flags & 2097152 /* Alias */) {
	      return classifySymbol(checker.getAliasedSymbol(symbol), meaningAtPosition, checker);
	    } else if (meaningAtPosition & 2 /* Type */) {
	      return flags & 64 /* Interface */ ? 13 /* interfaceName */ : flags & 262144 /* TypeParameter */ ? 15 /* typeParameterName */ : void 0;
	    } else {
	      return void 0;
	    }
	  }
	  function hasValueSideModule(symbol) {
	    return some(symbol.declarations, (declaration) => isModuleDeclaration(declaration) && getModuleInstanceState(declaration) === 1 /* Instantiated */);
	  }
	  function getClassificationTypeName(type) {
	    switch (type) {
	      case 1 /* comment */:
	        return "comment" /* comment */;
	      case 2 /* identifier */:
	        return "identifier" /* identifier */;
	      case 3 /* keyword */:
	        return "keyword" /* keyword */;
	      case 4 /* numericLiteral */:
	        return "number" /* numericLiteral */;
	      case 25 /* bigintLiteral */:
	        return "bigint" /* bigintLiteral */;
	      case 5 /* operator */:
	        return "operator" /* operator */;
	      case 6 /* stringLiteral */:
	        return "string" /* stringLiteral */;
	      case 8 /* whiteSpace */:
	        return "whitespace" /* whiteSpace */;
	      case 9 /* text */:
	        return "text" /* text */;
	      case 10 /* punctuation */:
	        return "punctuation" /* punctuation */;
	      case 11 /* className */:
	        return "class name" /* className */;
	      case 12 /* enumName */:
	        return "enum name" /* enumName */;
	      case 13 /* interfaceName */:
	        return "interface name" /* interfaceName */;
	      case 14 /* moduleName */:
	        return "module name" /* moduleName */;
	      case 15 /* typeParameterName */:
	        return "type parameter name" /* typeParameterName */;
	      case 16 /* typeAliasName */:
	        return "type alias name" /* typeAliasName */;
	      case 17 /* parameterName */:
	        return "parameter name" /* parameterName */;
	      case 18 /* docCommentTagName */:
	        return "doc comment tag name" /* docCommentTagName */;
	      case 19 /* jsxOpenTagName */:
	        return "jsx open tag name" /* jsxOpenTagName */;
	      case 20 /* jsxCloseTagName */:
	        return "jsx close tag name" /* jsxCloseTagName */;
	      case 21 /* jsxSelfClosingTagName */:
	        return "jsx self closing tag name" /* jsxSelfClosingTagName */;
	      case 22 /* jsxAttribute */:
	        return "jsx attribute" /* jsxAttribute */;
	      case 23 /* jsxText */:
	        return "jsx text" /* jsxText */;
	      case 24 /* jsxAttributeStringLiteralValue */:
	        return "jsx attribute string literal value" /* jsxAttributeStringLiteralValue */;
	      default:
	        return void 0;
	    }
	  }
	  function convertClassificationsToSpans(classifications) {
	    Debug.assert(classifications.spans.length % 3 === 0);
	    const dense = classifications.spans;
	    const result = [];
	    for (let i = 0; i < dense.length; i += 3) {
	      result.push({
	        textSpan: createTextSpan(dense[i], dense[i + 1]),
	        classificationType: getClassificationTypeName(dense[i + 2])
	      });
	    }
	    return result;
	  }
	  function getSyntacticClassifications(cancellationToken, sourceFile, span) {
	    return convertClassificationsToSpans(getEncodedSyntacticClassifications(cancellationToken, sourceFile, span));
	  }
	  function getEncodedSyntacticClassifications(cancellationToken, sourceFile, span) {
	    const spanStart = span.start;
	    const spanLength = span.length;
	    const triviaScanner = createScanner(
	      99 /* Latest */,
	      /*skipTrivia*/
	      false,
	      sourceFile.languageVariant,
	      sourceFile.text
	    );
	    const mergeConflictScanner = createScanner(
	      99 /* Latest */,
	      /*skipTrivia*/
	      false,
	      sourceFile.languageVariant,
	      sourceFile.text
	    );
	    const result = [];
	    processElement(sourceFile);
	    return { spans: result, endOfLineState: 0 /* None */ };
	    function pushClassification(start, length2, type) {
	      result.push(start);
	      result.push(length2);
	      result.push(type);
	    }
	    function classifyLeadingTriviaAndGetTokenStart(token) {
	      triviaScanner.resetTokenState(token.pos);
	      while (true) {
	        const start = triviaScanner.getTokenEnd();
	        if (!couldStartTrivia(sourceFile.text, start)) {
	          return start;
	        }
	        const kind = triviaScanner.scan();
	        const end = triviaScanner.getTokenEnd();
	        const width = end - start;
	        if (!isTrivia(kind)) {
	          return start;
	        }
	        switch (kind) {
	          case 4 /* NewLineTrivia */:
	          case 5 /* WhitespaceTrivia */:
	            continue;
	          case 2 /* SingleLineCommentTrivia */:
	          case 3 /* MultiLineCommentTrivia */:
	            classifyComment(token, kind, start, width);
	            triviaScanner.resetTokenState(end);
	            continue;
	          case 7 /* ConflictMarkerTrivia */:
	            const text = sourceFile.text;
	            const ch = text.charCodeAt(start);
	            if (ch === 60 /* lessThan */ || ch === 62 /* greaterThan */) {
	              pushClassification(start, width, 1 /* comment */);
	              continue;
	            }
	            Debug.assert(ch === 124 /* bar */ || ch === 61 /* equals */);
	            classifyDisabledMergeCode(text, start, end);
	            break;
	          case 6 /* ShebangTrivia */:
	            break;
	          default:
	            Debug.assertNever(kind);
	        }
	      }
	    }
	    function classifyComment(token, kind, start, width) {
	      if (kind === 3 /* MultiLineCommentTrivia */) {
	        const docCommentAndDiagnostics = parseIsolatedJSDocComment(sourceFile.text, start, width);
	        if (docCommentAndDiagnostics && docCommentAndDiagnostics.jsDoc) {
	          setParent(docCommentAndDiagnostics.jsDoc, token);
	          classifyJSDocComment(docCommentAndDiagnostics.jsDoc);
	          return;
	        }
	      } else if (kind === 2 /* SingleLineCommentTrivia */) {
	        if (tryClassifyTripleSlashComment(start, width)) {
	          return;
	        }
	      }
	      pushCommentRange(start, width);
	    }
	    function pushCommentRange(start, width) {
	      pushClassification(start, width, 1 /* comment */);
	    }
	    function classifyJSDocComment(docComment) {
	      var _a, _b, _c, _d, _e, _f, _g, _h;
	      let pos = docComment.pos;
	      if (docComment.tags) {
	        for (const tag of docComment.tags) {
	          if (tag.pos !== pos) {
	            pushCommentRange(pos, tag.pos - pos);
	          }
	          pushClassification(tag.pos, 1, 10 /* punctuation */);
	          pushClassification(tag.tagName.pos, tag.tagName.end - tag.tagName.pos, 18 /* docCommentTagName */);
	          pos = tag.tagName.end;
	          let commentStart = tag.tagName.end;
	          switch (tag.kind) {
	            case 348 /* JSDocParameterTag */:
	              const param = tag;
	              processJSDocParameterTag(param);
	              commentStart = param.isNameFirst && ((_a = param.typeExpression) == null ? void 0 : _a.end) || param.name.end;
	              break;
	            case 355 /* JSDocPropertyTag */:
	              const prop = tag;
	              commentStart = prop.isNameFirst && ((_b = prop.typeExpression) == null ? void 0 : _b.end) || prop.name.end;
	              break;
	            case 352 /* JSDocTemplateTag */:
	              processJSDocTemplateTag(tag);
	              pos = tag.end;
	              commentStart = tag.typeParameters.end;
	              break;
	            case 353 /* JSDocTypedefTag */:
	              const type = tag;
	              commentStart = ((_c = type.typeExpression) == null ? void 0 : _c.kind) === 316 /* JSDocTypeExpression */ && ((_d = type.fullName) == null ? void 0 : _d.end) || ((_e = type.typeExpression) == null ? void 0 : _e.end) || commentStart;
	              break;
	            case 345 /* JSDocCallbackTag */:
	              commentStart = tag.typeExpression.end;
	              break;
	            case 351 /* JSDocTypeTag */:
	              processElement(tag.typeExpression);
	              pos = tag.end;
	              commentStart = tag.typeExpression.end;
	              break;
	            case 350 /* JSDocThisTag */:
	            case 347 /* JSDocEnumTag */:
	              commentStart = tag.typeExpression.end;
	              break;
	            case 349 /* JSDocReturnTag */:
	              processElement(tag.typeExpression);
	              pos = tag.end;
	              commentStart = ((_f = tag.typeExpression) == null ? void 0 : _f.end) || commentStart;
	              break;
	            case 354 /* JSDocSeeTag */:
	              commentStart = ((_g = tag.name) == null ? void 0 : _g.end) || commentStart;
	              break;
	            case 335 /* JSDocAugmentsTag */:
	            case 336 /* JSDocImplementsTag */:
	              commentStart = tag.class.end;
	              break;
	            case 356 /* JSDocThrowsTag */:
	              processElement(tag.typeExpression);
	              pos = tag.end;
	              commentStart = ((_h = tag.typeExpression) == null ? void 0 : _h.end) || commentStart;
	              break;
	          }
	          if (typeof tag.comment === "object") {
	            pushCommentRange(tag.comment.pos, tag.comment.end - tag.comment.pos);
	          } else if (typeof tag.comment === "string") {
	            pushCommentRange(commentStart, tag.end - commentStart);
	          }
	        }
	      }
	      if (pos !== docComment.end) {
	        pushCommentRange(pos, docComment.end - pos);
	      }
	      return;
	      function processJSDocParameterTag(tag) {
	        if (tag.isNameFirst) {
	          pushCommentRange(pos, tag.name.pos - pos);
	          pushClassification(tag.name.pos, tag.name.end - tag.name.pos, 17 /* parameterName */);
	          pos = tag.name.end;
	        }
	        if (tag.typeExpression) {
	          pushCommentRange(pos, tag.typeExpression.pos - pos);
	          processElement(tag.typeExpression);
	          pos = tag.typeExpression.end;
	        }
	        if (!tag.isNameFirst) {
	          pushCommentRange(pos, tag.name.pos - pos);
	          pushClassification(tag.name.pos, tag.name.end - tag.name.pos, 17 /* parameterName */);
	          pos = tag.name.end;
	        }
	      }
	    }
	    function tryClassifyTripleSlashComment(start, width) {
	      const tripleSlashXMLCommentRegEx = /^(\/\/\/\s*)(<)(?:(\S+)((?:[^/]|\/[^>])*)(\/>)?)?/im;
	      const attributeRegex = /(\s)(\S+)(\s*)(=)(\s*)('[^']+'|"[^"]+")/img;
	      const text = sourceFile.text.substr(start, width);
	      const match = tripleSlashXMLCommentRegEx.exec(text);
	      if (!match) {
	        return false;
	      }
	      if (!match[3] || !(match[3] in commentPragmas)) {
	        return false;
	      }
	      let pos = start;
	      pushCommentRange(pos, match[1].length);
	      pos += match[1].length;
	      pushClassification(pos, match[2].length, 10 /* punctuation */);
	      pos += match[2].length;
	      pushClassification(pos, match[3].length, 21 /* jsxSelfClosingTagName */);
	      pos += match[3].length;
	      const attrText = match[4];
	      let attrPos = pos;
	      while (true) {
	        const attrMatch = attributeRegex.exec(attrText);
	        if (!attrMatch) {
	          break;
	        }
	        const newAttrPos = pos + attrMatch.index + attrMatch[1].length;
	        if (newAttrPos > attrPos) {
	          pushCommentRange(attrPos, newAttrPos - attrPos);
	          attrPos = newAttrPos;
	        }
	        pushClassification(attrPos, attrMatch[2].length, 22 /* jsxAttribute */);
	        attrPos += attrMatch[2].length;
	        if (attrMatch[3].length) {
	          pushCommentRange(attrPos, attrMatch[3].length);
	          attrPos += attrMatch[3].length;
	        }
	        pushClassification(attrPos, attrMatch[4].length, 5 /* operator */);
	        attrPos += attrMatch[4].length;
	        if (attrMatch[5].length) {
	          pushCommentRange(attrPos, attrMatch[5].length);
	          attrPos += attrMatch[5].length;
	        }
	        pushClassification(attrPos, attrMatch[6].length, 24 /* jsxAttributeStringLiteralValue */);
	        attrPos += attrMatch[6].length;
	      }
	      pos += match[4].length;
	      if (pos > attrPos) {
	        pushCommentRange(attrPos, pos - attrPos);
	      }
	      if (match[5]) {
	        pushClassification(pos, match[5].length, 10 /* punctuation */);
	        pos += match[5].length;
	      }
	      const end = start + width;
	      if (pos < end) {
	        pushCommentRange(pos, end - pos);
	      }
	      return true;
	    }
	    function processJSDocTemplateTag(tag) {
	      for (const child of tag.getChildren()) {
	        processElement(child);
	      }
	    }
	    function classifyDisabledMergeCode(text, start, end) {
	      let i;
	      for (i = start; i < end; i++) {
	        if (isLineBreak(text.charCodeAt(i))) {
	          break;
	        }
	      }
	      pushClassification(start, i - start, 1 /* comment */);
	      mergeConflictScanner.resetTokenState(i);
	      while (mergeConflictScanner.getTokenEnd() < end) {
	        classifyDisabledCodeToken();
	      }
	    }
	    function classifyDisabledCodeToken() {
	      const start = mergeConflictScanner.getTokenEnd();
	      const tokenKind = mergeConflictScanner.scan();
	      const end = mergeConflictScanner.getTokenEnd();
	      const type = classifyTokenType(tokenKind);
	      if (type) {
	        pushClassification(start, end - start, type);
	      }
	    }
	    function tryClassifyNode(node) {
	      if (isJSDoc(node)) {
	        return true;
	      }
	      if (nodeIsMissing(node)) {
	        return true;
	      }
	      const classifiedElementName = tryClassifyJsxElementName(node);
	      if (!isToken(node) && node.kind !== 12 /* JsxText */ && classifiedElementName === void 0) {
	        return false;
	      }
	      const tokenStart = node.kind === 12 /* JsxText */ ? node.pos : classifyLeadingTriviaAndGetTokenStart(node);
	      const tokenWidth = node.end - tokenStart;
	      Debug.assert(tokenWidth >= 0);
	      if (tokenWidth > 0) {
	        const type = classifiedElementName || classifyTokenType(node.kind, node);
	        if (type) {
	          pushClassification(tokenStart, tokenWidth, type);
	        }
	      }
	      return true;
	    }
	    function tryClassifyJsxElementName(token) {
	      switch (token.parent && token.parent.kind) {
	        case 286 /* JsxOpeningElement */:
	          if (token.parent.tagName === token) {
	            return 19 /* jsxOpenTagName */;
	          }
	          break;
	        case 287 /* JsxClosingElement */:
	          if (token.parent.tagName === token) {
	            return 20 /* jsxCloseTagName */;
	          }
	          break;
	        case 285 /* JsxSelfClosingElement */:
	          if (token.parent.tagName === token) {
	            return 21 /* jsxSelfClosingTagName */;
	          }
	          break;
	        case 291 /* JsxAttribute */:
	          if (token.parent.name === token) {
	            return 22 /* jsxAttribute */;
	          }
	          break;
	      }
	      return void 0;
	    }
	    function classifyTokenType(tokenKind, token) {
	      if (isKeyword(tokenKind)) {
	        return 3 /* keyword */;
	      }
	      if (tokenKind === 30 /* LessThanToken */ || tokenKind === 32 /* GreaterThanToken */) {
	        if (token && getTypeArgumentOrTypeParameterList(token.parent)) {
	          return 10 /* punctuation */;
	        }
	      }
	      if (isPunctuation(tokenKind)) {
	        if (token) {
	          const parent2 = token.parent;
	          if (tokenKind === 64 /* EqualsToken */) {
	            if (parent2.kind === 260 /* VariableDeclaration */ || parent2.kind === 172 /* PropertyDeclaration */ || parent2.kind === 169 /* Parameter */ || parent2.kind === 291 /* JsxAttribute */) {
	              return 5 /* operator */;
	            }
	          }
	          if (parent2.kind === 226 /* BinaryExpression */ || parent2.kind === 224 /* PrefixUnaryExpression */ || parent2.kind === 225 /* PostfixUnaryExpression */ || parent2.kind === 227 /* ConditionalExpression */) {
	            return 5 /* operator */;
	          }
	        }
	        return 10 /* punctuation */;
	      } else if (tokenKind === 9 /* NumericLiteral */) {
	        return 4 /* numericLiteral */;
	      } else if (tokenKind === 10 /* BigIntLiteral */) {
	        return 25 /* bigintLiteral */;
	      } else if (tokenKind === 11 /* StringLiteral */) {
	        return token && token.parent.kind === 291 /* JsxAttribute */ ? 24 /* jsxAttributeStringLiteralValue */ : 6 /* stringLiteral */;
	      } else if (tokenKind === 14 /* RegularExpressionLiteral */) {
	        return 6 /* stringLiteral */;
	      } else if (isTemplateLiteralKind(tokenKind)) {
	        return 6 /* stringLiteral */;
	      } else if (tokenKind === 12 /* JsxText */) {
	        return 23 /* jsxText */;
	      } else if (tokenKind === 80 /* Identifier */) {
	        if (token) {
	          switch (token.parent.kind) {
	            case 263 /* ClassDeclaration */:
	              if (token.parent.name === token) {
	                return 11 /* className */;
	              }
	              return;
	            case 168 /* TypeParameter */:
	              if (token.parent.name === token) {
	                return 15 /* typeParameterName */;
	              }
	              return;
	            case 264 /* InterfaceDeclaration */:
	              if (token.parent.name === token) {
	                return 13 /* interfaceName */;
	              }
	              return;
	            case 266 /* EnumDeclaration */:
	              if (token.parent.name === token) {
	                return 12 /* enumName */;
	              }
	              return;
	            case 267 /* ModuleDeclaration */:
	              if (token.parent.name === token) {
	                return 14 /* moduleName */;
	              }
	              return;
	            case 169 /* Parameter */:
	              if (token.parent.name === token) {
	                return isThisIdentifier(token) ? 3 /* keyword */ : 17 /* parameterName */;
	              }
	              return;
	          }
	          if (isConstTypeReference(token.parent)) {
	            return 3 /* keyword */;
	          }
	        }
	        return 2 /* identifier */;
	      }
	    }
	    function processElement(element) {
	      if (!element) {
	        return;
	      }
	      if (decodedTextSpanIntersectsWith(spanStart, spanLength, element.pos, element.getFullWidth())) {
	        checkForClassificationCancellation(cancellationToken, element.kind);
	        for (const child of element.getChildren(sourceFile)) {
	          if (!tryClassifyNode(child)) {
	            processElement(child);
	          }
	        }
	      }
	    }
	  }
	  var noRegexTable;
	  var init_classifier = __esm({
	    "src/services/classifier.ts"() {
	      init_ts4();
	      noRegexTable = arrayToNumericMap(
	        [
	          80 /* Identifier */,
	          11 /* StringLiteral */,
	          9 /* NumericLiteral */,
	          10 /* BigIntLiteral */,
	          14 /* RegularExpressionLiteral */,
	          110 /* ThisKeyword */,
	          46 /* PlusPlusToken */,
	          47 /* MinusMinusToken */,
	          22 /* CloseParenToken */,
	          24 /* CloseBracketToken */,
	          20 /* CloseBraceToken */,
	          112 /* TrueKeyword */,
	          97 /* FalseKeyword */
	        ],
	        (token) => token,
	        () => true
	      );
	    }
	  });

	  // src/services/documentHighlights.ts
	  var DocumentHighlights;
	  var init_documentHighlights = __esm({
	    "src/services/documentHighlights.ts"() {
	      init_ts4();
	      ((DocumentHighlights3) => {
	        function getDocumentHighlights(program, cancellationToken, sourceFile, position, sourceFilesToSearch) {
	          const node = getTouchingPropertyName(sourceFile, position);
	          if (node.parent && (isJsxOpeningElement(node.parent) && node.parent.tagName === node || isJsxClosingElement(node.parent))) {
	            const { openingElement, closingElement } = node.parent.parent;
	            const highlightSpans = [openingElement, closingElement].map(({ tagName }) => getHighlightSpanForNode(tagName, sourceFile));
	            return [{ fileName: sourceFile.fileName, highlightSpans }];
	          }
	          return getSemanticDocumentHighlights(position, node, program, cancellationToken, sourceFilesToSearch) || getSyntacticDocumentHighlights(node, sourceFile);
	        }
	        DocumentHighlights3.getDocumentHighlights = getDocumentHighlights;
	        function getHighlightSpanForNode(node, sourceFile) {
	          return {
	            fileName: sourceFile.fileName,
	            textSpan: createTextSpanFromNode(node, sourceFile),
	            kind: "none" /* none */
	          };
	        }
	        function getSemanticDocumentHighlights(position, node, program, cancellationToken, sourceFilesToSearch) {
	          const sourceFilesSet = new Set(sourceFilesToSearch.map((f) => f.fileName));
	          const referenceEntries = ts_FindAllReferences_exports.getReferenceEntriesForNode(
	            position,
	            node,
	            program,
	            sourceFilesToSearch,
	            cancellationToken,
	            /*options*/
	            void 0,
	            sourceFilesSet
	          );
	          if (!referenceEntries)
	            return void 0;
	          const map2 = arrayToMultiMap(referenceEntries.map(ts_FindAllReferences_exports.toHighlightSpan), (e) => e.fileName, (e) => e.span);
	          const getCanonicalFileName = createGetCanonicalFileName(program.useCaseSensitiveFileNames());
	          return arrayFrom(mapDefinedIterator(map2.entries(), ([fileName, highlightSpans]) => {
	            if (!sourceFilesSet.has(fileName)) {
	              if (!program.redirectTargetsMap.has(toPath(fileName, program.getCurrentDirectory(), getCanonicalFileName))) {
	                return void 0;
	              }
	              const redirectTarget = program.getSourceFile(fileName);
	              const redirect = find(sourceFilesToSearch, (f) => !!f.redirectInfo && f.redirectInfo.redirectTarget === redirectTarget);
	              fileName = redirect.fileName;
	              Debug.assert(sourceFilesSet.has(fileName));
	            }
	            return { fileName, highlightSpans };
	          }));
	        }
	        function getSyntacticDocumentHighlights(node, sourceFile) {
	          const highlightSpans = getHighlightSpans(node, sourceFile);
	          return highlightSpans && [{ fileName: sourceFile.fileName, highlightSpans }];
	        }
	        function getHighlightSpans(node, sourceFile) {
	          switch (node.kind) {
	            case 101 /* IfKeyword */:
	            case 93 /* ElseKeyword */:
	              return isIfStatement(node.parent) ? getIfElseOccurrences(node.parent, sourceFile) : void 0;
	            case 107 /* ReturnKeyword */:
	              return useParent(node.parent, isReturnStatement, getReturnOccurrences);
	            case 111 /* ThrowKeyword */:
	              return useParent(node.parent, isThrowStatement, getThrowOccurrences);
	            case 113 /* TryKeyword */:
	            case 85 /* CatchKeyword */:
	            case 98 /* FinallyKeyword */:
	              const tryStatement = node.kind === 85 /* CatchKeyword */ ? node.parent.parent : node.parent;
	              return useParent(tryStatement, isTryStatement, getTryCatchFinallyOccurrences);
	            case 109 /* SwitchKeyword */:
	              return useParent(node.parent, isSwitchStatement, getSwitchCaseDefaultOccurrences);
	            case 84 /* CaseKeyword */:
	            case 90 /* DefaultKeyword */: {
	              if (isDefaultClause(node.parent) || isCaseClause(node.parent)) {
	                return useParent(node.parent.parent.parent, isSwitchStatement, getSwitchCaseDefaultOccurrences);
	              }
	              return void 0;
	            }
	            case 83 /* BreakKeyword */:
	            case 88 /* ContinueKeyword */:
	              return useParent(node.parent, isBreakOrContinueStatement, getBreakOrContinueStatementOccurrences);
	            case 99 /* ForKeyword */:
	            case 117 /* WhileKeyword */:
	            case 92 /* DoKeyword */:
	              return useParent(node.parent, (n) => isIterationStatement(
	                n,
	                /*lookInLabeledStatements*/
	                true
	              ), getLoopBreakContinueOccurrences);
	            case 137 /* ConstructorKeyword */:
	              return getFromAllDeclarations(isConstructorDeclaration, [137 /* ConstructorKeyword */]);
	            case 139 /* GetKeyword */:
	            case 153 /* SetKeyword */:
	              return getFromAllDeclarations(isAccessor, [139 /* GetKeyword */, 153 /* SetKeyword */]);
	            case 135 /* AwaitKeyword */:
	              return useParent(node.parent, isAwaitExpression, getAsyncAndAwaitOccurrences);
	            case 134 /* AsyncKeyword */:
	              return highlightSpans(getAsyncAndAwaitOccurrences(node));
	            case 127 /* YieldKeyword */:
	              return highlightSpans(getYieldOccurrences(node));
	            case 103 /* InKeyword */:
	            case 147 /* OutKeyword */:
	              return void 0;
	            default:
	              return isModifierKind(node.kind) && (isDeclaration(node.parent) || isVariableStatement(node.parent)) ? highlightSpans(getModifierOccurrences(node.kind, node.parent)) : void 0;
	          }
	          function getFromAllDeclarations(nodeTest, keywords) {
	            return useParent(node.parent, nodeTest, (decl) => {
	              var _a;
	              return mapDefined((_a = tryCast(decl, canHaveSymbol)) == null ? void 0 : _a.symbol.declarations, (d) => nodeTest(d) ? find(d.getChildren(sourceFile), (c) => contains(keywords, c.kind)) : void 0);
	            });
	          }
	          function useParent(node2, nodeTest, getNodes4) {
	            return nodeTest(node2) ? highlightSpans(getNodes4(node2, sourceFile)) : void 0;
	          }
	          function highlightSpans(nodes) {
	            return nodes && nodes.map((node2) => getHighlightSpanForNode(node2, sourceFile));
	          }
	        }
	        function aggregateOwnedThrowStatements(node) {
	          if (isThrowStatement(node)) {
	            return [node];
	          } else if (isTryStatement(node)) {
	            return concatenate(
	              node.catchClause ? aggregateOwnedThrowStatements(node.catchClause) : node.tryBlock && aggregateOwnedThrowStatements(node.tryBlock),
	              node.finallyBlock && aggregateOwnedThrowStatements(node.finallyBlock)
	            );
	          }
	          return isFunctionLike(node) ? void 0 : flatMapChildren(node, aggregateOwnedThrowStatements);
	        }
	        function getThrowStatementOwner(throwStatement) {
	          let child = throwStatement;
	          while (child.parent) {
	            const parent2 = child.parent;
	            if (isFunctionBlock(parent2) || parent2.kind === 312 /* SourceFile */) {
	              return parent2;
	            }
	            if (isTryStatement(parent2) && parent2.tryBlock === child && parent2.catchClause) {
	              return child;
	            }
	            child = parent2;
	          }
	          return void 0;
	        }
	        function aggregateAllBreakAndContinueStatements(node) {
	          return isBreakOrContinueStatement(node) ? [node] : isFunctionLike(node) ? void 0 : flatMapChildren(node, aggregateAllBreakAndContinueStatements);
	        }
	        function flatMapChildren(node, cb) {
	          const result = [];
	          node.forEachChild((child) => {
	            const value = cb(child);
	            if (value !== void 0) {
	              result.push(...toArray(value));
	            }
	          });
	          return result;
	        }
	        function ownsBreakOrContinueStatement(owner, statement) {
	          const actualOwner = getBreakOrContinueOwner(statement);
	          return !!actualOwner && actualOwner === owner;
	        }
	        function getBreakOrContinueOwner(statement) {
	          return findAncestor(statement, (node) => {
	            switch (node.kind) {
	              case 255 /* SwitchStatement */:
	                if (statement.kind === 251 /* ContinueStatement */) {
	                  return false;
	                }
	              case 248 /* ForStatement */:
	              case 249 /* ForInStatement */:
	              case 250 /* ForOfStatement */:
	              case 247 /* WhileStatement */:
	              case 246 /* DoStatement */:
	                return !statement.label || isLabeledBy(node, statement.label.escapedText);
	              default:
	                return isFunctionLike(node) && "quit";
	            }
	          });
	        }
	        function getModifierOccurrences(modifier, declaration) {
	          return mapDefined(getNodesToSearchForModifier(declaration, modifierToFlag(modifier)), (node) => findModifier(node, modifier));
	        }
	        function getNodesToSearchForModifier(declaration, modifierFlag) {
	          const container = declaration.parent;
	          switch (container.kind) {
	            case 268 /* ModuleBlock */:
	            case 312 /* SourceFile */:
	            case 241 /* Block */:
	            case 296 /* CaseClause */:
	            case 297 /* DefaultClause */:
	              if (modifierFlag & 64 /* Abstract */ && isClassDeclaration(declaration)) {
	                return [...declaration.members, declaration];
	              } else {
	                return container.statements;
	              }
	            case 176 /* Constructor */:
	            case 174 /* MethodDeclaration */:
	            case 262 /* FunctionDeclaration */:
	              return [...container.parameters, ...isClassLike(container.parent) ? container.parent.members : []];
	            case 263 /* ClassDeclaration */:
	            case 231 /* ClassExpression */:
	            case 264 /* InterfaceDeclaration */:
	            case 187 /* TypeLiteral */:
	              const nodes = container.members;
	              if (modifierFlag & (7 /* AccessibilityModifier */ | 8 /* Readonly */)) {
	                const constructor = find(container.members, isConstructorDeclaration);
	                if (constructor) {
	                  return [...nodes, ...constructor.parameters];
	                }
	              } else if (modifierFlag & 64 /* Abstract */) {
	                return [...nodes, container];
	              }
	              return nodes;
	            case 210 /* ObjectLiteralExpression */:
	              return void 0;
	            default:
	              Debug.assertNever(container, "Invalid container kind.");
	          }
	        }
	        function pushKeywordIf(keywordList, token, ...expected) {
	          if (token && contains(expected, token.kind)) {
	            keywordList.push(token);
	            return true;
	          }
	          return false;
	        }
	        function getLoopBreakContinueOccurrences(loopNode) {
	          const keywords = [];
	          if (pushKeywordIf(keywords, loopNode.getFirstToken(), 99 /* ForKeyword */, 117 /* WhileKeyword */, 92 /* DoKeyword */)) {
	            if (loopNode.kind === 246 /* DoStatement */) {
	              const loopTokens = loopNode.getChildren();
	              for (let i = loopTokens.length - 1; i >= 0; i--) {
	                if (pushKeywordIf(keywords, loopTokens[i], 117 /* WhileKeyword */)) {
	                  break;
	                }
	              }
	            }
	          }
	          forEach(aggregateAllBreakAndContinueStatements(loopNode.statement), (statement) => {
	            if (ownsBreakOrContinueStatement(loopNode, statement)) {
	              pushKeywordIf(keywords, statement.getFirstToken(), 83 /* BreakKeyword */, 88 /* ContinueKeyword */);
	            }
	          });
	          return keywords;
	        }
	        function getBreakOrContinueStatementOccurrences(breakOrContinueStatement) {
	          const owner = getBreakOrContinueOwner(breakOrContinueStatement);
	          if (owner) {
	            switch (owner.kind) {
	              case 248 /* ForStatement */:
	              case 249 /* ForInStatement */:
	              case 250 /* ForOfStatement */:
	              case 246 /* DoStatement */:
	              case 247 /* WhileStatement */:
	                return getLoopBreakContinueOccurrences(owner);
	              case 255 /* SwitchStatement */:
	                return getSwitchCaseDefaultOccurrences(owner);
	            }
	          }
	          return void 0;
	        }
	        function getSwitchCaseDefaultOccurrences(switchStatement) {
	          const keywords = [];
	          pushKeywordIf(keywords, switchStatement.getFirstToken(), 109 /* SwitchKeyword */);
	          forEach(switchStatement.caseBlock.clauses, (clause) => {
	            pushKeywordIf(keywords, clause.getFirstToken(), 84 /* CaseKeyword */, 90 /* DefaultKeyword */);
	            forEach(aggregateAllBreakAndContinueStatements(clause), (statement) => {
	              if (ownsBreakOrContinueStatement(switchStatement, statement)) {
	                pushKeywordIf(keywords, statement.getFirstToken(), 83 /* BreakKeyword */);
	              }
	            });
	          });
	          return keywords;
	        }
	        function getTryCatchFinallyOccurrences(tryStatement, sourceFile) {
	          const keywords = [];
	          pushKeywordIf(keywords, tryStatement.getFirstToken(), 113 /* TryKeyword */);
	          if (tryStatement.catchClause) {
	            pushKeywordIf(keywords, tryStatement.catchClause.getFirstToken(), 85 /* CatchKeyword */);
	          }
	          if (tryStatement.finallyBlock) {
	            const finallyKeyword = findChildOfKind(tryStatement, 98 /* FinallyKeyword */, sourceFile);
	            pushKeywordIf(keywords, finallyKeyword, 98 /* FinallyKeyword */);
	          }
	          return keywords;
	        }
	        function getThrowOccurrences(throwStatement, sourceFile) {
	          const owner = getThrowStatementOwner(throwStatement);
	          if (!owner) {
	            return void 0;
	          }
	          const keywords = [];
	          forEach(aggregateOwnedThrowStatements(owner), (throwStatement2) => {
	            keywords.push(findChildOfKind(throwStatement2, 111 /* ThrowKeyword */, sourceFile));
	          });
	          if (isFunctionBlock(owner)) {
	            forEachReturnStatement(owner, (returnStatement) => {
	              keywords.push(findChildOfKind(returnStatement, 107 /* ReturnKeyword */, sourceFile));
	            });
	          }
	          return keywords;
	        }
	        function getReturnOccurrences(returnStatement, sourceFile) {
	          const func = getContainingFunction(returnStatement);
	          if (!func) {
	            return void 0;
	          }
	          const keywords = [];
	          forEachReturnStatement(cast(func.body, isBlock), (returnStatement2) => {
	            keywords.push(findChildOfKind(returnStatement2, 107 /* ReturnKeyword */, sourceFile));
	          });
	          forEach(aggregateOwnedThrowStatements(func.body), (throwStatement) => {
	            keywords.push(findChildOfKind(throwStatement, 111 /* ThrowKeyword */, sourceFile));
	          });
	          return keywords;
	        }
	        function getAsyncAndAwaitOccurrences(node) {
	          const func = getContainingFunction(node);
	          if (!func) {
	            return void 0;
	          }
	          const keywords = [];
	          if (func.modifiers) {
	            func.modifiers.forEach((modifier) => {
	              pushKeywordIf(keywords, modifier, 134 /* AsyncKeyword */);
	            });
	          }
	          forEachChild(func, (child) => {
	            traverseWithoutCrossingFunction(child, (node2) => {
	              if (isAwaitExpression(node2)) {
	                pushKeywordIf(keywords, node2.getFirstToken(), 135 /* AwaitKeyword */);
	              }
	            });
	          });
	          return keywords;
	        }
	        function getYieldOccurrences(node) {
	          const func = getContainingFunction(node);
	          if (!func) {
	            return void 0;
	          }
	          const keywords = [];
	          forEachChild(func, (child) => {
	            traverseWithoutCrossingFunction(child, (node2) => {
	              if (isYieldExpression(node2)) {
	                pushKeywordIf(keywords, node2.getFirstToken(), 127 /* YieldKeyword */);
	              }
	            });
	          });
	          return keywords;
	        }
	        function traverseWithoutCrossingFunction(node, cb) {
	          cb(node);
	          if (!isFunctionLike(node) && !isClassLike(node) && !isInterfaceDeclaration(node) && !isModuleDeclaration(node) && !isTypeAliasDeclaration(node) && !isTypeNode(node)) {
	            forEachChild(node, (child) => traverseWithoutCrossingFunction(child, cb));
	          }
	        }
	        function getIfElseOccurrences(ifStatement, sourceFile) {
	          const keywords = getIfElseKeywords(ifStatement, sourceFile);
	          const result = [];
	          for (let i = 0; i < keywords.length; i++) {
	            if (keywords[i].kind === 93 /* ElseKeyword */ && i < keywords.length - 1) {
	              const elseKeyword = keywords[i];
	              const ifKeyword = keywords[i + 1];
	              let shouldCombineElseAndIf = true;
	              for (let j = ifKeyword.getStart(sourceFile) - 1; j >= elseKeyword.end; j--) {
	                if (!isWhiteSpaceSingleLine(sourceFile.text.charCodeAt(j))) {
	                  shouldCombineElseAndIf = false;
	                  break;
	                }
	              }
	              if (shouldCombineElseAndIf) {
	                result.push({
	                  fileName: sourceFile.fileName,
	                  textSpan: createTextSpanFromBounds(elseKeyword.getStart(), ifKeyword.end),
	                  kind: "reference" /* reference */
	                });
	                i++;
	                continue;
	              }
	            }
	            result.push(getHighlightSpanForNode(keywords[i], sourceFile));
	          }
	          return result;
	        }
	        function getIfElseKeywords(ifStatement, sourceFile) {
	          const keywords = [];
	          while (isIfStatement(ifStatement.parent) && ifStatement.parent.elseStatement === ifStatement) {
	            ifStatement = ifStatement.parent;
	          }
	          while (true) {
	            const children = ifStatement.getChildren(sourceFile);
	            pushKeywordIf(keywords, children[0], 101 /* IfKeyword */);
	            for (let i = children.length - 1; i >= 0; i--) {
	              if (pushKeywordIf(keywords, children[i], 93 /* ElseKeyword */)) {
	                break;
	              }
	            }
	            if (!ifStatement.elseStatement || !isIfStatement(ifStatement.elseStatement)) {
	              break;
	            }
	            ifStatement = ifStatement.elseStatement;
	          }
	          return keywords;
	        }
	        function isLabeledBy(node, labelName) {
	          return !!findAncestor(node.parent, (owner) => !isLabeledStatement(owner) ? "quit" : owner.label.escapedText === labelName);
	        }
	      })(DocumentHighlights || (DocumentHighlights = {}));
	    }
	  });

	  // src/services/documentRegistry.ts
	  function isDocumentRegistryEntry(entry) {
	    return !!entry.sourceFile;
	  }
	  function createDocumentRegistry(useCaseSensitiveFileNames2, currentDirectory, jsDocParsingMode) {
	    return createDocumentRegistryInternal(useCaseSensitiveFileNames2, currentDirectory, jsDocParsingMode);
	  }
	  function createDocumentRegistryInternal(useCaseSensitiveFileNames2, currentDirectory = "", jsDocParsingMode, externalCache) {
	    const buckets = /* @__PURE__ */ new Map();
	    const getCanonicalFileName = createGetCanonicalFileName(!!useCaseSensitiveFileNames2);
	    function reportStats() {
	      const bucketInfoArray = arrayFrom(buckets.keys()).filter((name) => name && name.charAt(0) === "_").map((name) => {
	        const entries = buckets.get(name);
	        const sourceFiles = [];
	        entries.forEach((entry, name2) => {
	          if (isDocumentRegistryEntry(entry)) {
	            sourceFiles.push({
	              name: name2,
	              scriptKind: entry.sourceFile.scriptKind,
	              refCount: entry.languageServiceRefCount
	            });
	          } else {
	            entry.forEach((value, scriptKind) => sourceFiles.push({ name: name2, scriptKind, refCount: value.languageServiceRefCount }));
	          }
	        });
	        sourceFiles.sort((x, y) => y.refCount - x.refCount);
	        return {
	          bucket: name,
	          sourceFiles
	        };
	      });
	      return JSON.stringify(bucketInfoArray, void 0, 2);
	    }
	    function getCompilationSettings(settingsOrHost) {
	      if (typeof settingsOrHost.getCompilationSettings === "function") {
	        return settingsOrHost.getCompilationSettings();
	      }
	      return settingsOrHost;
	    }
	    function acquireDocument(fileName, compilationSettings, scriptSnapshot, version2, scriptKind, languageVersionOrOptions) {
	      const path = toPath(fileName, currentDirectory, getCanonicalFileName);
	      const key = getKeyForCompilationSettings(getCompilationSettings(compilationSettings));
	      return acquireDocumentWithKey(fileName, path, compilationSettings, key, scriptSnapshot, version2, scriptKind, languageVersionOrOptions);
	    }
	    function acquireDocumentWithKey(fileName, path, compilationSettings, key, scriptSnapshot, version2, scriptKind, languageVersionOrOptions) {
	      return acquireOrUpdateDocument(
	        fileName,
	        path,
	        compilationSettings,
	        key,
	        scriptSnapshot,
	        version2,
	        /*acquiring*/
	        true,
	        scriptKind,
	        languageVersionOrOptions
	      );
	    }
	    function updateDocument(fileName, compilationSettings, scriptSnapshot, version2, scriptKind, languageVersionOrOptions) {
	      const path = toPath(fileName, currentDirectory, getCanonicalFileName);
	      const key = getKeyForCompilationSettings(getCompilationSettings(compilationSettings));
	      return updateDocumentWithKey(fileName, path, compilationSettings, key, scriptSnapshot, version2, scriptKind, languageVersionOrOptions);
	    }
	    function updateDocumentWithKey(fileName, path, compilationSettings, key, scriptSnapshot, version2, scriptKind, languageVersionOrOptions) {
	      return acquireOrUpdateDocument(
	        fileName,
	        path,
	        getCompilationSettings(compilationSettings),
	        key,
	        scriptSnapshot,
	        version2,
	        /*acquiring*/
	        false,
	        scriptKind,
	        languageVersionOrOptions
	      );
	    }
	    function getDocumentRegistryEntry(bucketEntry, scriptKind) {
	      const entry = isDocumentRegistryEntry(bucketEntry) ? bucketEntry : bucketEntry.get(Debug.checkDefined(scriptKind, "If there are more than one scriptKind's for same document the scriptKind should be provided"));
	      Debug.assert(scriptKind === void 0 || !entry || entry.sourceFile.scriptKind === scriptKind, `Script kind should match provided ScriptKind:${scriptKind} and sourceFile.scriptKind: ${entry == null ? void 0 : entry.sourceFile.scriptKind}, !entry: ${!entry}`);
	      return entry;
	    }
	    function acquireOrUpdateDocument(fileName, path, compilationSettingsOrHost, key, scriptSnapshot, version2, acquiring, scriptKind, languageVersionOrOptions) {
	      var _a, _b, _c, _d;
	      scriptKind = ensureScriptKind(fileName, scriptKind);
	      const compilationSettings = getCompilationSettings(compilationSettingsOrHost);
	      const host = compilationSettingsOrHost === compilationSettings ? void 0 : compilationSettingsOrHost;
	      const scriptTarget = scriptKind === 6 /* JSON */ ? 100 /* JSON */ : getEmitScriptTarget(compilationSettings);
	      const sourceFileOptions = typeof languageVersionOrOptions === "object" ? languageVersionOrOptions : {
	        languageVersion: scriptTarget,
	        impliedNodeFormat: host && getImpliedNodeFormatForFile(path, (_d = (_c = (_b = (_a = host.getCompilerHost) == null ? void 0 : _a.call(host)) == null ? void 0 : _b.getModuleResolutionCache) == null ? void 0 : _c.call(_b)) == null ? void 0 : _d.getPackageJsonInfoCache(), host, compilationSettings),
	        setExternalModuleIndicator: getSetExternalModuleIndicator(compilationSettings),
	        jsDocParsingMode
	      };
	      sourceFileOptions.languageVersion = scriptTarget;
	      Debug.assertEqual(jsDocParsingMode, sourceFileOptions.jsDocParsingMode);
	      const oldBucketCount = buckets.size;
	      const keyWithMode = getDocumentRegistryBucketKeyWithMode(key, sourceFileOptions.impliedNodeFormat);
	      const bucket = getOrUpdate(buckets, keyWithMode, () => /* @__PURE__ */ new Map());
	      if (tracing) {
	        if (buckets.size > oldBucketCount) {
	          tracing.instant(tracing.Phase.Session, "createdDocumentRegistryBucket", { configFilePath: compilationSettings.configFilePath, key: keyWithMode });
	        }
	        const otherBucketKey = !isDeclarationFileName(path) && forEachEntry(buckets, (bucket2, bucketKey) => bucketKey !== keyWithMode && bucket2.has(path) && bucketKey);
	        if (otherBucketKey) {
	          tracing.instant(tracing.Phase.Session, "documentRegistryBucketOverlap", { path, key1: otherBucketKey, key2: keyWithMode });
	        }
	      }
	      const bucketEntry = bucket.get(path);
	      let entry = bucketEntry && getDocumentRegistryEntry(bucketEntry, scriptKind);
	      if (!entry && externalCache) {
	        const sourceFile = externalCache.getDocument(keyWithMode, path);
	        if (sourceFile) {
	          Debug.assert(acquiring);
	          entry = {
	            sourceFile,
	            languageServiceRefCount: 0
	          };
	          setBucketEntry();
	        }
	      }
	      if (!entry) {
	        const sourceFile = createLanguageServiceSourceFile(
	          fileName,
	          scriptSnapshot,
	          sourceFileOptions,
	          version2,
	          /*setNodeParents*/
	          false,
	          scriptKind
	        );
	        if (externalCache) {
	          externalCache.setDocument(keyWithMode, path, sourceFile);
	        }
	        entry = {
	          sourceFile,
	          languageServiceRefCount: 1
	        };
	        setBucketEntry();
	      } else {
	        if (entry.sourceFile.version !== version2) {
	          entry.sourceFile = updateLanguageServiceSourceFile(entry.sourceFile, scriptSnapshot, version2, scriptSnapshot.getChangeRange(entry.sourceFile.scriptSnapshot));
	          if (externalCache) {
	            externalCache.setDocument(keyWithMode, path, entry.sourceFile);
	          }
	        }
	        if (acquiring) {
	          entry.languageServiceRefCount++;
	        }
	      }
	      Debug.assert(entry.languageServiceRefCount !== 0);
	      return entry.sourceFile;
	      function setBucketEntry() {
	        if (!bucketEntry) {
	          bucket.set(path, entry);
	        } else if (isDocumentRegistryEntry(bucketEntry)) {
	          const scriptKindMap = /* @__PURE__ */ new Map();
	          scriptKindMap.set(bucketEntry.sourceFile.scriptKind, bucketEntry);
	          scriptKindMap.set(scriptKind, entry);
	          bucket.set(path, scriptKindMap);
	        } else {
	          bucketEntry.set(scriptKind, entry);
	        }
	      }
	    }
	    function releaseDocument(fileName, compilationSettings, scriptKind, impliedNodeFormat) {
	      const path = toPath(fileName, currentDirectory, getCanonicalFileName);
	      const key = getKeyForCompilationSettings(compilationSettings);
	      return releaseDocumentWithKey(path, key, scriptKind, impliedNodeFormat);
	    }
	    function releaseDocumentWithKey(path, key, scriptKind, impliedNodeFormat) {
	      const bucket = Debug.checkDefined(buckets.get(getDocumentRegistryBucketKeyWithMode(key, impliedNodeFormat)));
	      const bucketEntry = bucket.get(path);
	      const entry = getDocumentRegistryEntry(bucketEntry, scriptKind);
	      entry.languageServiceRefCount--;
	      Debug.assert(entry.languageServiceRefCount >= 0);
	      if (entry.languageServiceRefCount === 0) {
	        if (isDocumentRegistryEntry(bucketEntry)) {
	          bucket.delete(path);
	        } else {
	          bucketEntry.delete(scriptKind);
	          if (bucketEntry.size === 1) {
	            bucket.set(path, firstDefinedIterator(bucketEntry.values(), identity));
	          }
	        }
	      }
	    }
	    return {
	      acquireDocument,
	      acquireDocumentWithKey,
	      updateDocument,
	      updateDocumentWithKey,
	      releaseDocument,
	      releaseDocumentWithKey,
	      getKeyForCompilationSettings,
	      getDocumentRegistryBucketKeyWithMode,
	      reportStats,
	      getBuckets: () => buckets
	    };
	  }
	  function getKeyForCompilationSettings(settings) {
	    return getKeyForCompilerOptions(settings, sourceFileAffectingCompilerOptions);
	  }
	  function getDocumentRegistryBucketKeyWithMode(key, mode) {
	    return mode ? `${key}|${mode}` : key;
	  }
	  var init_documentRegistry = __esm({
	    "src/services/documentRegistry.ts"() {
	      init_ts4();
	    }
	  });

	  // src/services/getEditsForFileRename.ts
	  function getEditsForFileRename(program, oldFileOrDirPath, newFileOrDirPath, host, formatContext, preferences, sourceMapper) {
	    const useCaseSensitiveFileNames2 = hostUsesCaseSensitiveFileNames(host);
	    const getCanonicalFileName = createGetCanonicalFileName(useCaseSensitiveFileNames2);
	    const oldToNew = getPathUpdater(oldFileOrDirPath, newFileOrDirPath, getCanonicalFileName, sourceMapper);
	    const newToOld = getPathUpdater(newFileOrDirPath, oldFileOrDirPath, getCanonicalFileName, sourceMapper);
	    return ts_textChanges_exports.ChangeTracker.with({ host, formatContext, preferences }, (changeTracker) => {
	      updateTsconfigFiles(program, changeTracker, oldToNew, oldFileOrDirPath, newFileOrDirPath, host.getCurrentDirectory(), useCaseSensitiveFileNames2);
	      updateImports(program, changeTracker, oldToNew, newToOld, host, getCanonicalFileName);
	    });
	  }
	  function getPathUpdater(oldFileOrDirPath, newFileOrDirPath, getCanonicalFileName, sourceMapper) {
	    const canonicalOldPath = getCanonicalFileName(oldFileOrDirPath);
	    return (path) => {
	      const originalPath = sourceMapper && sourceMapper.tryGetSourcePosition({ fileName: path, pos: 0 });
	      const updatedPath = getUpdatedPath(originalPath ? originalPath.fileName : path);
	      return originalPath ? updatedPath === void 0 ? void 0 : makeCorrespondingRelativeChange(originalPath.fileName, updatedPath, path, getCanonicalFileName) : updatedPath;
	    };
	    function getUpdatedPath(pathToUpdate) {
	      if (getCanonicalFileName(pathToUpdate) === canonicalOldPath)
	        return newFileOrDirPath;
	      const suffix = tryRemoveDirectoryPrefix(pathToUpdate, canonicalOldPath, getCanonicalFileName);
	      return suffix === void 0 ? void 0 : newFileOrDirPath + "/" + suffix;
	    }
	  }
	  function makeCorrespondingRelativeChange(a0, b0, a1, getCanonicalFileName) {
	    const rel = getRelativePathFromFile(a0, b0, getCanonicalFileName);
	    return combinePathsSafe(getDirectoryPath(a1), rel);
	  }
	  function updateTsconfigFiles(program, changeTracker, oldToNew, oldFileOrDirPath, newFileOrDirPath, currentDirectory, useCaseSensitiveFileNames2) {
	    const { configFile } = program.getCompilerOptions();
	    if (!configFile)
	      return;
	    const configDir = getDirectoryPath(configFile.fileName);
	    const jsonObjectLiteral = getTsConfigObjectLiteralExpression(configFile);
	    if (!jsonObjectLiteral)
	      return;
	    forEachProperty(jsonObjectLiteral, (property, propertyName) => {
	      switch (propertyName) {
	        case "files":
	        case "include":
	        case "exclude": {
	          const foundExactMatch = updatePaths(property);
	          if (foundExactMatch || propertyName !== "include" || !isArrayLiteralExpression(property.initializer))
	            return;
	          const includes = mapDefined(property.initializer.elements, (e) => isStringLiteral(e) ? e.text : void 0);
	          if (includes.length === 0)
	            return;
	          const matchers = getFileMatcherPatterns(
	            configDir,
	            /*excludes*/
	            [],
	            includes,
	            useCaseSensitiveFileNames2,
	            currentDirectory
	          );
	          if (getRegexFromPattern(Debug.checkDefined(matchers.includeFilePattern), useCaseSensitiveFileNames2).test(oldFileOrDirPath) && !getRegexFromPattern(Debug.checkDefined(matchers.includeFilePattern), useCaseSensitiveFileNames2).test(newFileOrDirPath)) {
	            changeTracker.insertNodeAfter(configFile, last(property.initializer.elements), factory.createStringLiteral(relativePath(newFileOrDirPath)));
	          }
	          return;
	        }
	        case "compilerOptions":
	          forEachProperty(property.initializer, (property2, propertyName2) => {
	            const option = getOptionFromName(propertyName2);
	            Debug.assert((option == null ? void 0 : option.type) !== "listOrElement");
	            if (option && (option.isFilePath || option.type === "list" && option.element.isFilePath)) {
	              updatePaths(property2);
	            } else if (propertyName2 === "paths") {
	              forEachProperty(property2.initializer, (pathsProperty) => {
	                if (!isArrayLiteralExpression(pathsProperty.initializer))
	                  return;
	                for (const e of pathsProperty.initializer.elements) {
	                  tryUpdateString(e);
	                }
	              });
	            }
	          });
	          return;
	      }
	    });
	    function updatePaths(property) {
	      const elements = isArrayLiteralExpression(property.initializer) ? property.initializer.elements : [property.initializer];
	      let foundExactMatch = false;
	      for (const element of elements) {
	        foundExactMatch = tryUpdateString(element) || foundExactMatch;
	      }
	      return foundExactMatch;
	    }
	    function tryUpdateString(element) {
	      if (!isStringLiteral(element))
	        return false;
	      const elementFileName = combinePathsSafe(configDir, element.text);
	      const updated = oldToNew(elementFileName);
	      if (updated !== void 0) {
	        changeTracker.replaceRangeWithText(configFile, createStringRange(element, configFile), relativePath(updated));
	        return true;
	      }
	      return false;
	    }
	    function relativePath(path) {
	      return getRelativePathFromDirectory(
	        configDir,
	        path,
	        /*ignoreCase*/
	        !useCaseSensitiveFileNames2
	      );
	    }
	  }
	  function updateImports(program, changeTracker, oldToNew, newToOld, host, getCanonicalFileName) {
	    const allFiles = program.getSourceFiles();
	    for (const sourceFile of allFiles) {
	      const newFromOld = oldToNew(sourceFile.fileName);
	      const newImportFromPath = newFromOld ?? sourceFile.fileName;
	      const newImportFromDirectory = getDirectoryPath(newImportFromPath);
	      const oldFromNew = newToOld(sourceFile.fileName);
	      const oldImportFromPath = oldFromNew || sourceFile.fileName;
	      const oldImportFromDirectory = getDirectoryPath(oldImportFromPath);
	      const importingSourceFileMoved = newFromOld !== void 0 || oldFromNew !== void 0;
	      updateImportsWorker(sourceFile, changeTracker, (referenceText) => {
	        if (!pathIsRelative(referenceText))
	          return void 0;
	        const oldAbsolute = combinePathsSafe(oldImportFromDirectory, referenceText);
	        const newAbsolute = oldToNew(oldAbsolute);
	        return newAbsolute === void 0 ? void 0 : ensurePathIsNonModuleName(getRelativePathFromDirectory(newImportFromDirectory, newAbsolute, getCanonicalFileName));
	      }, (importLiteral) => {
	        const importedModuleSymbol = program.getTypeChecker().getSymbolAtLocation(importLiteral);
	        if ((importedModuleSymbol == null ? void 0 : importedModuleSymbol.declarations) && importedModuleSymbol.declarations.some((d) => isAmbientModule(d)))
	          return void 0;
	        const toImport = oldFromNew !== void 0 ? getSourceFileToImportFromResolved(importLiteral, resolveModuleName(importLiteral.text, oldImportFromPath, program.getCompilerOptions(), host), oldToNew, allFiles) : getSourceFileToImport(importedModuleSymbol, importLiteral, sourceFile, program, host, oldToNew);
	        return toImport !== void 0 && (toImport.updated || importingSourceFileMoved && pathIsRelative(importLiteral.text)) ? ts_moduleSpecifiers_exports.updateModuleSpecifier(program.getCompilerOptions(), sourceFile, newImportFromPath, toImport.newFileName, createModuleSpecifierResolutionHost(program, host), importLiteral.text) : void 0;
	      });
	    }
	  }
	  function combineNormal(pathA, pathB) {
	    return normalizePath(combinePaths(pathA, pathB));
	  }
	  function combinePathsSafe(pathA, pathB) {
	    return ensurePathIsNonModuleName(combineNormal(pathA, pathB));
	  }
	  function getSourceFileToImport(importedModuleSymbol, importLiteral, importingSourceFile, program, host, oldToNew) {
	    if (importedModuleSymbol) {
	      const oldFileName = find(importedModuleSymbol.declarations, isSourceFile).fileName;
	      const newFileName = oldToNew(oldFileName);
	      return newFileName === void 0 ? { newFileName: oldFileName, updated: false } : { newFileName, updated: true };
	    } else {
	      const mode = program.getModeForUsageLocation(importingSourceFile, importLiteral);
	      const resolved = host.resolveModuleNameLiterals || !host.resolveModuleNames ? program.getResolvedModuleFromModuleSpecifier(importLiteral) : host.getResolvedModuleWithFailedLookupLocationsFromCache && host.getResolvedModuleWithFailedLookupLocationsFromCache(importLiteral.text, importingSourceFile.fileName, mode);
	      return getSourceFileToImportFromResolved(importLiteral, resolved, oldToNew, program.getSourceFiles());
	    }
	  }
	  function getSourceFileToImportFromResolved(importLiteral, resolved, oldToNew, sourceFiles) {
	    if (!resolved)
	      return void 0;
	    if (resolved.resolvedModule) {
	      const result2 = tryChange(resolved.resolvedModule.resolvedFileName);
	      if (result2)
	        return result2;
	    }
	    const result = forEach(resolved.failedLookupLocations, tryChangeWithIgnoringPackageJsonExisting) || pathIsRelative(importLiteral.text) && forEach(resolved.failedLookupLocations, tryChangeWithIgnoringPackageJson);
	    if (result)
	      return result;
	    return resolved.resolvedModule && { newFileName: resolved.resolvedModule.resolvedFileName, updated: false };
	    function tryChangeWithIgnoringPackageJsonExisting(oldFileName) {
	      const newFileName = oldToNew(oldFileName);
	      return newFileName && find(sourceFiles, (src) => src.fileName === newFileName) ? tryChangeWithIgnoringPackageJson(oldFileName) : void 0;
	    }
	    function tryChangeWithIgnoringPackageJson(oldFileName) {
	      return !endsWith(oldFileName, "/package.json") ? tryChange(oldFileName) : void 0;
	    }
	    function tryChange(oldFileName) {
	      const newFileName = oldToNew(oldFileName);
	      return newFileName && { newFileName, updated: true };
	    }
	  }
	  function updateImportsWorker(sourceFile, changeTracker, updateRef, updateImport2) {
	    for (const ref of sourceFile.referencedFiles || emptyArray) {
	      const updated = updateRef(ref.fileName);
	      if (updated !== void 0 && updated !== sourceFile.text.slice(ref.pos, ref.end))
	        changeTracker.replaceRangeWithText(sourceFile, ref, updated);
	    }
	    for (const importStringLiteral of sourceFile.imports) {
	      const updated = updateImport2(importStringLiteral);
	      if (updated !== void 0 && updated !== importStringLiteral.text)
	        changeTracker.replaceRangeWithText(sourceFile, createStringRange(importStringLiteral, sourceFile), updated);
	    }
	  }
	  function createStringRange(node, sourceFile) {
	    return createRange(node.getStart(sourceFile) + 1, node.end - 1);
	  }
	  function forEachProperty(objectLiteral, cb) {
	    if (!isObjectLiteralExpression(objectLiteral))
	      return;
	    for (const property of objectLiteral.properties) {
	      if (isPropertyAssignment(property) && isStringLiteral(property.name)) {
	        cb(property, property.name.text);
	      }
	    }
	  }
	  var init_getEditsForFileRename = __esm({
	    "src/services/getEditsForFileRename.ts"() {
	      init_ts4();
	    }
	  });

	  // src/services/patternMatcher.ts
	  function createPatternMatch(kind, isCaseSensitive) {
	    return {
	      kind,
	      isCaseSensitive
	    };
	  }
	  function createPatternMatcher(pattern) {
	    const stringToWordSpans = /* @__PURE__ */ new Map();
	    const dotSeparatedSegments = pattern.trim().split(".").map((p) => createSegment(p.trim()));
	    if (dotSeparatedSegments.length === 1 && dotSeparatedSegments[0].totalTextChunk.text === "") {
	      return {
	        getMatchForLastSegmentOfPattern: () => createPatternMatch(
	          2 /* substring */,
	          /*isCaseSensitive*/
	          true
	        ),
	        getFullMatch: () => createPatternMatch(
	          2 /* substring */,
	          /*isCaseSensitive*/
	          true
	        ),
	        patternContainsDots: false
	      };
	    }
	    if (dotSeparatedSegments.some((segment) => !segment.subWordTextChunks.length))
	      return void 0;
	    return {
	      getFullMatch: (containers, candidate) => getFullMatch(containers, candidate, dotSeparatedSegments, stringToWordSpans),
	      getMatchForLastSegmentOfPattern: (candidate) => matchSegment(candidate, last(dotSeparatedSegments), stringToWordSpans),
	      patternContainsDots: dotSeparatedSegments.length > 1
	    };
	  }
	  function getFullMatch(candidateContainers, candidate, dotSeparatedSegments, stringToWordSpans) {
	    const candidateMatch = matchSegment(candidate, last(dotSeparatedSegments), stringToWordSpans);
	    if (!candidateMatch) {
	      return void 0;
	    }
	    if (dotSeparatedSegments.length - 1 > candidateContainers.length) {
	      return void 0;
	    }
	    let bestMatch;
	    for (let i = dotSeparatedSegments.length - 2, j = candidateContainers.length - 1; i >= 0; i -= 1, j -= 1) {
	      bestMatch = betterMatch(bestMatch, matchSegment(candidateContainers[j], dotSeparatedSegments[i], stringToWordSpans));
	    }
	    return bestMatch;
	  }
	  function getWordSpans(word, stringToWordSpans) {
	    let spans = stringToWordSpans.get(word);
	    if (!spans) {
	      stringToWordSpans.set(word, spans = breakIntoWordSpans(word));
	    }
	    return spans;
	  }
	  function matchTextChunk(candidate, chunk, stringToWordSpans) {
	    const index = indexOfIgnoringCase(candidate, chunk.textLowerCase);
	    if (index === 0) {
	      return createPatternMatch(
	        chunk.text.length === candidate.length ? 0 /* exact */ : 1 /* prefix */,
	        /*isCaseSensitive:*/
	        startsWith(candidate, chunk.text)
	      );
	    }
	    if (chunk.isLowerCase) {
	      if (index === -1)
	        return void 0;
	      const wordSpans = getWordSpans(candidate, stringToWordSpans);
	      for (const span of wordSpans) {
	        if (partStartsWith(
	          candidate,
	          span,
	          chunk.text,
	          /*ignoreCase*/
	          true
	        )) {
	          return createPatternMatch(
	            2 /* substring */,
	            /*isCaseSensitive:*/
	            partStartsWith(
	              candidate,
	              span,
	              chunk.text,
	              /*ignoreCase*/
	              false
	            )
	          );
	        }
	      }
	      if (chunk.text.length < candidate.length && isUpperCaseLetter(candidate.charCodeAt(index))) {
	        return createPatternMatch(
	          2 /* substring */,
	          /*isCaseSensitive*/
	          false
	        );
	      }
	    } else {
	      if (candidate.indexOf(chunk.text) > 0) {
	        return createPatternMatch(
	          2 /* substring */,
	          /*isCaseSensitive*/
	          true
	        );
	      }
	      if (chunk.characterSpans.length > 0) {
	        const candidateParts = getWordSpans(candidate, stringToWordSpans);
	        const isCaseSensitive = tryCamelCaseMatch(
	          candidate,
	          candidateParts,
	          chunk,
	          /*ignoreCase*/
	          false
	        ) ? true : tryCamelCaseMatch(
	          candidate,
	          candidateParts,
	          chunk,
	          /*ignoreCase*/
	          true
	        ) ? false : void 0;
	        if (isCaseSensitive !== void 0) {
	          return createPatternMatch(3 /* camelCase */, isCaseSensitive);
	        }
	      }
	    }
	  }
	  function matchSegment(candidate, segment, stringToWordSpans) {
	    if (every2(segment.totalTextChunk.text, (ch) => ch !== 32 /* space */ && ch !== 42 /* asterisk */)) {
	      const match = matchTextChunk(candidate, segment.totalTextChunk, stringToWordSpans);
	      if (match)
	        return match;
	    }
	    const subWordTextChunks = segment.subWordTextChunks;
	    let bestMatch;
	    for (const subWordTextChunk of subWordTextChunks) {
	      bestMatch = betterMatch(bestMatch, matchTextChunk(candidate, subWordTextChunk, stringToWordSpans));
	    }
	    return bestMatch;
	  }
	  function betterMatch(a, b) {
	    return min([a, b], compareMatches);
	  }
	  function compareMatches(a, b) {
	    return a === void 0 ? 1 /* GreaterThan */ : b === void 0 ? -1 /* LessThan */ : compareValues(a.kind, b.kind) || compareBooleans(!a.isCaseSensitive, !b.isCaseSensitive);
	  }
	  function partStartsWith(candidate, candidateSpan, pattern, ignoreCase, patternSpan = { start: 0, length: pattern.length }) {
	    return patternSpan.length <= candidateSpan.length && everyInRange(0, patternSpan.length, (i) => equalChars(pattern.charCodeAt(patternSpan.start + i), candidate.charCodeAt(candidateSpan.start + i), ignoreCase));
	  }
	  function equalChars(ch1, ch2, ignoreCase) {
	    return ignoreCase ? toLowerCase2(ch1) === toLowerCase2(ch2) : ch1 === ch2;
	  }
	  function tryCamelCaseMatch(candidate, candidateParts, chunk, ignoreCase) {
	    const chunkCharacterSpans = chunk.characterSpans;
	    let currentCandidate = 0;
	    let currentChunkSpan = 0;
	    while (true) {
	      if (currentChunkSpan === chunkCharacterSpans.length) {
	        return true;
	      } else if (currentCandidate === candidateParts.length) {
	        return false;
	      }
	      let candidatePart = candidateParts[currentCandidate];
	      let gotOneMatchThisCandidate = false;
	      for (; currentChunkSpan < chunkCharacterSpans.length; currentChunkSpan++) {
	        const chunkCharacterSpan = chunkCharacterSpans[currentChunkSpan];
	        if (gotOneMatchThisCandidate) {
	          if (!isUpperCaseLetter(chunk.text.charCodeAt(chunkCharacterSpans[currentChunkSpan - 1].start)) || !isUpperCaseLetter(chunk.text.charCodeAt(chunkCharacterSpans[currentChunkSpan].start))) {
	            break;
	          }
	        }
	        if (!partStartsWith(candidate, candidatePart, chunk.text, ignoreCase, chunkCharacterSpan)) {
	          break;
	        }
	        gotOneMatchThisCandidate = true;
	        candidatePart = createTextSpan(candidatePart.start + chunkCharacterSpan.length, candidatePart.length - chunkCharacterSpan.length);
	      }
	      currentCandidate++;
	    }
	  }
	  function createSegment(text) {
	    return {
	      totalTextChunk: createTextChunk(text),
	      subWordTextChunks: breakPatternIntoTextChunks(text)
	    };
	  }
	  function isUpperCaseLetter(ch) {
	    if (ch >= 65 /* A */ && ch <= 90 /* Z */) {
	      return true;
	    }
	    if (ch < 127 /* maxAsciiCharacter */ || !isUnicodeIdentifierStart(ch, 99 /* Latest */)) {
	      return false;
	    }
	    const str = String.fromCharCode(ch);
	    return str === str.toUpperCase();
	  }
	  function isLowerCaseLetter(ch) {
	    if (ch >= 97 /* a */ && ch <= 122 /* z */) {
	      return true;
	    }
	    if (ch < 127 /* maxAsciiCharacter */ || !isUnicodeIdentifierStart(ch, 99 /* Latest */)) {
	      return false;
	    }
	    const str = String.fromCharCode(ch);
	    return str === str.toLowerCase();
	  }
	  function indexOfIgnoringCase(str, value) {
	    const n = str.length - value.length;
	    for (let start = 0; start <= n; start++) {
	      if (every2(value, (valueChar, i) => toLowerCase2(str.charCodeAt(i + start)) === valueChar)) {
	        return start;
	      }
	    }
	    return -1;
	  }
	  function toLowerCase2(ch) {
	    if (ch >= 65 /* A */ && ch <= 90 /* Z */) {
	      return 97 /* a */ + (ch - 65 /* A */);
	    }
	    if (ch < 127 /* maxAsciiCharacter */) {
	      return ch;
	    }
	    return String.fromCharCode(ch).toLowerCase().charCodeAt(0);
	  }
	  function isDigit2(ch) {
	    return ch >= 48 /* _0 */ && ch <= 57 /* _9 */;
	  }
	  function isWordChar(ch) {
	    return isUpperCaseLetter(ch) || isLowerCaseLetter(ch) || isDigit2(ch) || ch === 95 /* _ */ || ch === 36 /* $ */;
	  }
	  function breakPatternIntoTextChunks(pattern) {
	    const result = [];
	    let wordStart = 0;
	    let wordLength = 0;
	    for (let i = 0; i < pattern.length; i++) {
	      const ch = pattern.charCodeAt(i);
	      if (isWordChar(ch)) {
	        if (wordLength === 0) {
	          wordStart = i;
	        }
	        wordLength++;
	      } else {
	        if (wordLength > 0) {
	          result.push(createTextChunk(pattern.substr(wordStart, wordLength)));
	          wordLength = 0;
	        }
	      }
	    }
	    if (wordLength > 0) {
	      result.push(createTextChunk(pattern.substr(wordStart, wordLength)));
	    }
	    return result;
	  }
	  function createTextChunk(text) {
	    const textLowerCase = text.toLowerCase();
	    return {
	      text,
	      textLowerCase,
	      isLowerCase: text === textLowerCase,
	      characterSpans: breakIntoCharacterSpans(text)
	    };
	  }
	  function breakIntoCharacterSpans(identifier) {
	    return breakIntoSpans(
	      identifier,
	      /*word*/
	      false
	    );
	  }
	  function breakIntoWordSpans(identifier) {
	    return breakIntoSpans(
	      identifier,
	      /*word*/
	      true
	    );
	  }
	  function breakIntoSpans(identifier, word) {
	    const result = [];
	    let wordStart = 0;
	    for (let i = 1; i < identifier.length; i++) {
	      const lastIsDigit = isDigit2(identifier.charCodeAt(i - 1));
	      const currentIsDigit = isDigit2(identifier.charCodeAt(i));
	      const hasTransitionFromLowerToUpper = transitionFromLowerToUpper(identifier, word, i);
	      const hasTransitionFromUpperToLower = word && transitionFromUpperToLower(identifier, i, wordStart);
	      if (charIsPunctuation(identifier.charCodeAt(i - 1)) || charIsPunctuation(identifier.charCodeAt(i)) || lastIsDigit !== currentIsDigit || hasTransitionFromLowerToUpper || hasTransitionFromUpperToLower) {
	        if (!isAllPunctuation(identifier, wordStart, i)) {
	          result.push(createTextSpan(wordStart, i - wordStart));
	        }
	        wordStart = i;
	      }
	    }
	    if (!isAllPunctuation(identifier, wordStart, identifier.length)) {
	      result.push(createTextSpan(wordStart, identifier.length - wordStart));
	    }
	    return result;
	  }
	  function charIsPunctuation(ch) {
	    switch (ch) {
	      case 33 /* exclamation */:
	      case 34 /* doubleQuote */:
	      case 35 /* hash */:
	      case 37 /* percent */:
	      case 38 /* ampersand */:
	      case 39 /* singleQuote */:
	      case 40 /* openParen */:
	      case 41 /* closeParen */:
	      case 42 /* asterisk */:
	      case 44 /* comma */:
	      case 45 /* minus */:
	      case 46 /* dot */:
	      case 47 /* slash */:
	      case 58 /* colon */:
	      case 59 /* semicolon */:
	      case 63 /* question */:
	      case 64 /* at */:
	      case 91 /* openBracket */:
	      case 92 /* backslash */:
	      case 93 /* closeBracket */:
	      case 95 /* _ */:
	      case 123 /* openBrace */:
	      case 125 /* closeBrace */:
	        return true;
	    }
	    return false;
	  }
	  function isAllPunctuation(identifier, start, end) {
	    return every2(identifier, (ch) => charIsPunctuation(ch) && ch !== 95 /* _ */, start, end);
	  }
	  function transitionFromUpperToLower(identifier, index, wordStart) {
	    return index !== wordStart && index + 1 < identifier.length && isUpperCaseLetter(identifier.charCodeAt(index)) && isLowerCaseLetter(identifier.charCodeAt(index + 1)) && every2(identifier, isUpperCaseLetter, wordStart, index);
	  }
	  function transitionFromLowerToUpper(identifier, word, index) {
	    const lastIsUpper = isUpperCaseLetter(identifier.charCodeAt(index - 1));
	    const currentIsUpper = isUpperCaseLetter(identifier.charCodeAt(index));
	    return currentIsUpper && (!word || !lastIsUpper);
	  }
	  function everyInRange(start, end, pred) {
	    for (let i = start; i < end; i++) {
	      if (!pred(i)) {
	        return false;
	      }
	    }
	    return true;
	  }
	  function every2(s, pred, start = 0, end = s.length) {
	    return everyInRange(start, end, (i) => pred(s.charCodeAt(i), i));
	  }
	  var PatternMatchKind;
	  var init_patternMatcher = __esm({
	    "src/services/patternMatcher.ts"() {
	      init_ts4();
	      PatternMatchKind = /* @__PURE__ */ ((PatternMatchKind2) => {
	        PatternMatchKind2[PatternMatchKind2["exact"] = 0] = "exact";
	        PatternMatchKind2[PatternMatchKind2["prefix"] = 1] = "prefix";
	        PatternMatchKind2[PatternMatchKind2["substring"] = 2] = "substring";
	        PatternMatchKind2[PatternMatchKind2["camelCase"] = 3] = "camelCase";
	        return PatternMatchKind2;
	      })(PatternMatchKind || {});
	    }
	  });

	  // src/services/preProcess.ts
	  function preProcessFile(sourceText, readImportFiles = true, detectJavaScriptImports = false) {
	    const pragmaContext = {
	      languageVersion: 1 /* ES5 */,
	      // controls whether the token scanner considers unicode identifiers or not - shouldn't matter, since we're only using it for trivia
	      pragmas: void 0,
	      checkJsDirective: void 0,
	      referencedFiles: [],
	      typeReferenceDirectives: [],
	      libReferenceDirectives: [],
	      amdDependencies: [],
	      hasNoDefaultLib: void 0,
	      moduleName: void 0
	    };
	    const importedFiles = [];
	    let ambientExternalModules;
	    let lastToken;
	    let currentToken;
	    let braceNesting = 0;
	    let externalModule = false;
	    function nextToken() {
	      lastToken = currentToken;
	      currentToken = scanner.scan();
	      if (currentToken === 19 /* OpenBraceToken */) {
	        braceNesting++;
	      } else if (currentToken === 20 /* CloseBraceToken */) {
	        braceNesting--;
	      }
	      return currentToken;
	    }
	    function getFileReference() {
	      const fileName = scanner.getTokenValue();
	      const pos = scanner.getTokenStart();
	      return { fileName, pos, end: pos + fileName.length };
	    }
	    function recordAmbientExternalModule() {
	      if (!ambientExternalModules) {
	        ambientExternalModules = [];
	      }
	      ambientExternalModules.push({ ref: getFileReference(), depth: braceNesting });
	    }
	    function recordModuleName() {
	      importedFiles.push(getFileReference());
	      markAsExternalModuleIfTopLevel();
	    }
	    function markAsExternalModuleIfTopLevel() {
	      if (braceNesting === 0) {
	        externalModule = true;
	      }
	    }
	    function tryConsumeDeclare() {
	      let token = scanner.getToken();
	      if (token === 138 /* DeclareKeyword */) {
	        token = nextToken();
	        if (token === 144 /* ModuleKeyword */) {
	          token = nextToken();
	          if (token === 11 /* StringLiteral */) {
	            recordAmbientExternalModule();
	          }
	        }
	        return true;
	      }
	      return false;
	    }
	    function tryConsumeImport() {
	      if (lastToken === 25 /* DotToken */) {
	        return false;
	      }
	      let token = scanner.getToken();
	      if (token === 102 /* ImportKeyword */) {
	        token = nextToken();
	        if (token === 21 /* OpenParenToken */) {
	          token = nextToken();
	          if (token === 11 /* StringLiteral */ || token === 15 /* NoSubstitutionTemplateLiteral */) {
	            recordModuleName();
	            return true;
	          }
	        } else if (token === 11 /* StringLiteral */) {
	          recordModuleName();
	          return true;
	        } else {
	          if (token === 156 /* TypeKeyword */) {
	            const skipTypeKeyword = scanner.lookAhead(() => {
	              const token2 = scanner.scan();
	              return token2 !== 161 /* FromKeyword */ && (token2 === 42 /* AsteriskToken */ || token2 === 19 /* OpenBraceToken */ || token2 === 80 /* Identifier */ || isKeyword(token2));
	            });
	            if (skipTypeKeyword) {
	              token = nextToken();
	            }
	          }
	          if (token === 80 /* Identifier */ || isKeyword(token)) {
	            token = nextToken();
	            if (token === 161 /* FromKeyword */) {
	              token = nextToken();
	              if (token === 11 /* StringLiteral */) {
	                recordModuleName();
	                return true;
	              }
	            } else if (token === 64 /* EqualsToken */) {
	              if (tryConsumeRequireCall(
	                /*skipCurrentToken*/
	                true
	              )) {
	                return true;
	              }
	            } else if (token === 28 /* CommaToken */) {
	              token = nextToken();
	            } else {
	              return true;
	            }
	          }
	          if (token === 19 /* OpenBraceToken */) {
	            token = nextToken();
	            while (token !== 20 /* CloseBraceToken */ && token !== 1 /* EndOfFileToken */) {
	              token = nextToken();
	            }
	            if (token === 20 /* CloseBraceToken */) {
	              token = nextToken();
	              if (token === 161 /* FromKeyword */) {
	                token = nextToken();
	                if (token === 11 /* StringLiteral */) {
	                  recordModuleName();
	                }
	              }
	            }
	          } else if (token === 42 /* AsteriskToken */) {
	            token = nextToken();
	            if (token === 130 /* AsKeyword */) {
	              token = nextToken();
	              if (token === 80 /* Identifier */ || isKeyword(token)) {
	                token = nextToken();
	                if (token === 161 /* FromKeyword */) {
	                  token = nextToken();
	                  if (token === 11 /* StringLiteral */) {
	                    recordModuleName();
	                  }
	                }
	              }
	            }
	          }
	        }
	        return true;
	      }
	      return false;
	    }
	    function tryConsumeExport() {
	      let token = scanner.getToken();
	      if (token === 95 /* ExportKeyword */) {
	        markAsExternalModuleIfTopLevel();
	        token = nextToken();
	        if (token === 156 /* TypeKeyword */) {
	          const skipTypeKeyword = scanner.lookAhead(() => {
	            const token2 = scanner.scan();
	            return token2 === 42 /* AsteriskToken */ || token2 === 19 /* OpenBraceToken */;
	          });
	          if (skipTypeKeyword) {
	            token = nextToken();
	          }
	        }
	        if (token === 19 /* OpenBraceToken */) {
	          token = nextToken();
	          while (token !== 20 /* CloseBraceToken */ && token !== 1 /* EndOfFileToken */) {
	            token = nextToken();
	          }
	          if (token === 20 /* CloseBraceToken */) {
	            token = nextToken();
	            if (token === 161 /* FromKeyword */) {
	              token = nextToken();
	              if (token === 11 /* StringLiteral */) {
	                recordModuleName();
	              }
	            }
	          }
	        } else if (token === 42 /* AsteriskToken */) {
	          token = nextToken();
	          if (token === 161 /* FromKeyword */) {
	            token = nextToken();
	            if (token === 11 /* StringLiteral */) {
	              recordModuleName();
	            }
	          }
	        } else if (token === 102 /* ImportKeyword */) {
	          token = nextToken();
	          if (token === 156 /* TypeKeyword */) {
	            const skipTypeKeyword = scanner.lookAhead(() => {
	              const token2 = scanner.scan();
	              return token2 === 80 /* Identifier */ || isKeyword(token2);
	            });
	            if (skipTypeKeyword) {
	              token = nextToken();
	            }
	          }
	          if (token === 80 /* Identifier */ || isKeyword(token)) {
	            token = nextToken();
	            if (token === 64 /* EqualsToken */) {
	              if (tryConsumeRequireCall(
	                /*skipCurrentToken*/
	                true
	              )) {
	                return true;
	              }
	            }
	          }
	        }
	        return true;
	      }
	      return false;
	    }
	    function tryConsumeRequireCall(skipCurrentToken, allowTemplateLiterals = false) {
	      let token = skipCurrentToken ? nextToken() : scanner.getToken();
	      if (token === 149 /* RequireKeyword */) {
	        token = nextToken();
	        if (token === 21 /* OpenParenToken */) {
	          token = nextToken();
	          if (token === 11 /* StringLiteral */ || allowTemplateLiterals && token === 15 /* NoSubstitutionTemplateLiteral */) {
	            recordModuleName();
	          }
	        }
	        return true;
	      }
	      return false;
	    }
	    function tryConsumeDefine() {
	      let token = scanner.getToken();
	      if (token === 80 /* Identifier */ && scanner.getTokenValue() === "define") {
	        token = nextToken();
	        if (token !== 21 /* OpenParenToken */) {
	          return true;
	        }
	        token = nextToken();
	        if (token === 11 /* StringLiteral */ || token === 15 /* NoSubstitutionTemplateLiteral */) {
	          token = nextToken();
	          if (token === 28 /* CommaToken */) {
	            token = nextToken();
	          } else {
	            return true;
	          }
	        }
	        if (token !== 23 /* OpenBracketToken */) {
	          return true;
	        }
	        token = nextToken();
	        while (token !== 24 /* CloseBracketToken */ && token !== 1 /* EndOfFileToken */) {
	          if (token === 11 /* StringLiteral */ || token === 15 /* NoSubstitutionTemplateLiteral */) {
	            recordModuleName();
	          }
	          token = nextToken();
	        }
	        return true;
	      }
	      return false;
	    }
	    function processImports() {
	      scanner.setText(sourceText);
	      nextToken();
	      while (true) {
	        if (scanner.getToken() === 1 /* EndOfFileToken */) {
	          break;
	        }
	        if (scanner.getToken() === 16 /* TemplateHead */) {
	          const stack = [scanner.getToken()];
	          loop:
	            while (length(stack)) {
	              const token = scanner.scan();
	              switch (token) {
	                case 1 /* EndOfFileToken */:
	                  break loop;
	                case 102 /* ImportKeyword */:
	                  tryConsumeImport();
	                  break;
	                case 16 /* TemplateHead */:
	                  stack.push(token);
	                  break;
	                case 19 /* OpenBraceToken */:
	                  if (length(stack)) {
	                    stack.push(token);
	                  }
	                  break;
	                case 20 /* CloseBraceToken */:
	                  if (length(stack)) {
	                    if (lastOrUndefined(stack) === 16 /* TemplateHead */) {
	                      if (scanner.reScanTemplateToken(
	                        /*isTaggedTemplate*/
	                        false
	                      ) === 18 /* TemplateTail */) {
	                        stack.pop();
	                      }
	                    } else {
	                      stack.pop();
	                    }
	                  }
	                  break;
	              }
	            }
	          nextToken();
	        }
	        if (tryConsumeDeclare() || tryConsumeImport() || tryConsumeExport() || detectJavaScriptImports && (tryConsumeRequireCall(
	          /*skipCurrentToken*/
	          false,
	          /*allowTemplateLiterals*/
	          true
	        ) || tryConsumeDefine())) {
	          continue;
	        } else {
	          nextToken();
	        }
	      }
	      scanner.setText(void 0);
	    }
	    if (readImportFiles) {
	      processImports();
	    }
	    processCommentPragmas(pragmaContext, sourceText);
	    processPragmasIntoFields(pragmaContext, noop);
	    if (externalModule) {
	      if (ambientExternalModules) {
	        for (const decl of ambientExternalModules) {
	          importedFiles.push(decl.ref);
	        }
	      }
	      return { referencedFiles: pragmaContext.referencedFiles, typeReferenceDirectives: pragmaContext.typeReferenceDirectives, libReferenceDirectives: pragmaContext.libReferenceDirectives, importedFiles, isLibFile: !!pragmaContext.hasNoDefaultLib, ambientExternalModules: void 0 };
	    } else {
	      let ambientModuleNames;
	      if (ambientExternalModules) {
	        for (const decl of ambientExternalModules) {
	          if (decl.depth === 0) {
	            if (!ambientModuleNames) {
	              ambientModuleNames = [];
	            }
	            ambientModuleNames.push(decl.ref.fileName);
	          } else {
	            importedFiles.push(decl.ref);
	          }
	        }
	      }
	      return { referencedFiles: pragmaContext.referencedFiles, typeReferenceDirectives: pragmaContext.typeReferenceDirectives, libReferenceDirectives: pragmaContext.libReferenceDirectives, importedFiles, isLibFile: !!pragmaContext.hasNoDefaultLib, ambientExternalModules: ambientModuleNames };
	    }
	  }
	  var init_preProcess = __esm({
	    "src/services/preProcess.ts"() {
	      init_ts4();
	    }
	  });

	  // src/services/sourcemaps.ts
	  function getSourceMapper(host) {
	    const getCanonicalFileName = createGetCanonicalFileName(host.useCaseSensitiveFileNames());
	    const currentDirectory = host.getCurrentDirectory();
	    const sourceFileLike = /* @__PURE__ */ new Map();
	    const documentPositionMappers = /* @__PURE__ */ new Map();
	    return { tryGetSourcePosition, tryGetGeneratedPosition, toLineColumnOffset, clearCache };
	    function toPath3(fileName) {
	      return toPath(fileName, currentDirectory, getCanonicalFileName);
	    }
	    function getDocumentPositionMapper2(generatedFileName, sourceFileName) {
	      const path = toPath3(generatedFileName);
	      const value = documentPositionMappers.get(path);
	      if (value)
	        return value;
	      let mapper;
	      if (host.getDocumentPositionMapper) {
	        mapper = host.getDocumentPositionMapper(generatedFileName, sourceFileName);
	      } else if (host.readFile) {
	        const file = getSourceFileLike(generatedFileName);
	        mapper = file && getDocumentPositionMapper(
	          { getSourceFileLike, getCanonicalFileName, log: (s) => host.log(s) },
	          generatedFileName,
	          getLineInfo(file.text, getLineStarts(file)),
	          (f) => !host.fileExists || host.fileExists(f) ? host.readFile(f) : void 0
	        );
	      }
	      documentPositionMappers.set(path, mapper || identitySourceMapConsumer);
	      return mapper || identitySourceMapConsumer;
	    }
	    function tryGetSourcePosition(info) {
	      if (!isDeclarationFileName(info.fileName))
	        return void 0;
	      const file = getSourceFile(info.fileName);
	      if (!file)
	        return void 0;
	      const newLoc = getDocumentPositionMapper2(info.fileName).getSourcePosition(info);
	      return !newLoc || newLoc === info ? void 0 : tryGetSourcePosition(newLoc) || newLoc;
	    }
	    function tryGetGeneratedPosition(info) {
	      if (isDeclarationFileName(info.fileName))
	        return void 0;
	      const sourceFile = getSourceFile(info.fileName);
	      if (!sourceFile)
	        return void 0;
	      const program = host.getProgram();
	      if (program.isSourceOfProjectReferenceRedirect(sourceFile.fileName)) {
	        return void 0;
	      }
	      const options = program.getCompilerOptions();
	      const outPath = outFile(options);
	      const declarationPath = outPath ? removeFileExtension(outPath) + ".d.ts" /* Dts */ : getDeclarationEmitOutputFilePathWorker(info.fileName, program.getCompilerOptions(), currentDirectory, program.getCommonSourceDirectory(), getCanonicalFileName);
	      if (declarationPath === void 0)
	        return void 0;
	      const newLoc = getDocumentPositionMapper2(declarationPath, info.fileName).getGeneratedPosition(info);
	      return newLoc === info ? void 0 : newLoc;
	    }
	    function getSourceFile(fileName) {
	      const program = host.getProgram();
	      if (!program)
	        return void 0;
	      const path = toPath3(fileName);
	      const file = program.getSourceFileByPath(path);
	      return file && file.resolvedPath === path ? file : void 0;
	    }
	    function getOrCreateSourceFileLike(fileName) {
	      const path = toPath3(fileName);
	      const fileFromCache = sourceFileLike.get(path);
	      if (fileFromCache !== void 0)
	        return fileFromCache ? fileFromCache : void 0;
	      if (!host.readFile || host.fileExists && !host.fileExists(fileName)) {
	        sourceFileLike.set(path, false);
	        return void 0;
	      }
	      const text = host.readFile(fileName);
	      const file = text ? createSourceFileLike(text) : false;
	      sourceFileLike.set(path, file);
	      return file ? file : void 0;
	    }
	    function getSourceFileLike(fileName) {
	      return !host.getSourceFileLike ? getSourceFile(fileName) || getOrCreateSourceFileLike(fileName) : host.getSourceFileLike(fileName);
	    }
	    function toLineColumnOffset(fileName, position) {
	      const file = getSourceFileLike(fileName);
	      return file.getLineAndCharacterOfPosition(position);
	    }
	    function clearCache() {
	      sourceFileLike.clear();
	      documentPositionMappers.clear();
	    }
	  }
	  function getDocumentPositionMapper(host, generatedFileName, generatedFileLineInfo, readMapFile) {
	    let mapFileName = tryGetSourceMappingURL(generatedFileLineInfo);
	    if (mapFileName) {
	      const match = base64UrlRegExp.exec(mapFileName);
	      if (match) {
	        if (match[1]) {
	          const base64Object = match[1];
	          return convertDocumentToSourceMapper(host, base64decode(sys, base64Object), generatedFileName);
	        }
	        mapFileName = void 0;
	      }
	    }
	    const possibleMapLocations = [];
	    if (mapFileName) {
	      possibleMapLocations.push(mapFileName);
	    }
	    possibleMapLocations.push(generatedFileName + ".map");
	    const originalMapFileName = mapFileName && getNormalizedAbsolutePath(mapFileName, getDirectoryPath(generatedFileName));
	    for (const location of possibleMapLocations) {
	      const mapFileName2 = getNormalizedAbsolutePath(location, getDirectoryPath(generatedFileName));
	      const mapFileContents = readMapFile(mapFileName2, originalMapFileName);
	      if (isString(mapFileContents)) {
	        return convertDocumentToSourceMapper(host, mapFileContents, mapFileName2);
	      }
	      if (mapFileContents !== void 0) {
	        return mapFileContents || void 0;
	      }
	    }
	    return void 0;
	  }
	  function convertDocumentToSourceMapper(host, contents, mapFileName) {
	    const map2 = tryParseRawSourceMap(contents);
	    if (!map2 || !map2.sources || !map2.file || !map2.mappings) {
	      return void 0;
	    }
	    if (map2.sourcesContent && map2.sourcesContent.some(isString))
	      return void 0;
	    return createDocumentPositionMapper(host, map2, mapFileName);
	  }
	  function createSourceFileLike(text, lineMap) {
	    return {
	      text,
	      lineMap,
	      getLineAndCharacterOfPosition(pos) {
	        return computeLineAndCharacterOfPosition(getLineStarts(this), pos);
	      }
	    };
	  }
	  var base64UrlRegExp;
	  var init_sourcemaps = __esm({
	    "src/services/sourcemaps.ts"() {
	      init_ts4();
	      base64UrlRegExp = /^data:(?:application\/json(?:;charset=[uU][tT][fF]-8);base64,([A-Za-z0-9+/=]+)$)?/;
	    }
	  });

	  // src/services/suggestionDiagnostics.ts
	  function computeSuggestionDiagnostics(sourceFile, program, cancellationToken) {
	    var _a;
	    program.getSemanticDiagnostics(sourceFile, cancellationToken);
	    const diags = [];
	    const checker = program.getTypeChecker();
	    const isCommonJSFile = sourceFile.impliedNodeFormat === 1 /* CommonJS */ || fileExtensionIsOneOf(sourceFile.fileName, [".cts" /* Cts */, ".cjs" /* Cjs */]);
	    if (!isCommonJSFile && sourceFile.commonJsModuleIndicator && (programContainsEsModules(program) || compilerOptionsIndicateEsModules(program.getCompilerOptions())) && containsTopLevelCommonjs(sourceFile)) {
	      diags.push(createDiagnosticForNode(getErrorNodeFromCommonJsIndicator(sourceFile.commonJsModuleIndicator), Diagnostics.File_is_a_CommonJS_module_it_may_be_converted_to_an_ES_module));
	    }
	    const isJsFile = isSourceFileJS(sourceFile);
	    visitedNestedConvertibleFunctions.clear();
	    check(sourceFile);
	    if (getAllowSyntheticDefaultImports(program.getCompilerOptions())) {
	      for (const moduleSpecifier of sourceFile.imports) {
	        const importNode = importFromModuleSpecifier(moduleSpecifier);
	        const name = importNameForConvertToDefaultImport(importNode);
	        if (!name)
	          continue;
	        const module2 = (_a = program.getResolvedModuleFromModuleSpecifier(moduleSpecifier)) == null ? void 0 : _a.resolvedModule;
	        const resolvedFile = module2 && program.getSourceFile(module2.resolvedFileName);
	        if (resolvedFile && resolvedFile.externalModuleIndicator && resolvedFile.externalModuleIndicator !== true && isExportAssignment(resolvedFile.externalModuleIndicator) && resolvedFile.externalModuleIndicator.isExportEquals) {
	          diags.push(createDiagnosticForNode(name, Diagnostics.Import_may_be_converted_to_a_default_import));
	        }
	      }
	    }
	    addRange(diags, sourceFile.bindSuggestionDiagnostics);
	    addRange(diags, program.getSuggestionDiagnostics(sourceFile, cancellationToken));
	    return diags.sort((d1, d2) => d1.start - d2.start);
	    function check(node) {
	      if (isJsFile) {
	        if (canBeConvertedToClass(node, checker)) {
	          diags.push(createDiagnosticForNode(isVariableDeclaration(node.parent) ? node.parent.name : node, Diagnostics.This_constructor_function_may_be_converted_to_a_class_declaration));
	        }
	      } else {
	        if (isVariableStatement(node) && node.parent === sourceFile && node.declarationList.flags & 2 /* Const */ && node.declarationList.declarations.length === 1) {
	          const init = node.declarationList.declarations[0].initializer;
	          if (init && isRequireCall(
	            init,
	            /*requireStringLiteralLikeArgument*/
	            true
	          )) {
	            diags.push(createDiagnosticForNode(init, Diagnostics.require_call_may_be_converted_to_an_import));
	          }
	        }
	        const jsdocTypedefNodes = ts_codefix_exports.getJSDocTypedefNodes(node);
	        for (const jsdocTypedefNode of jsdocTypedefNodes) {
	          diags.push(createDiagnosticForNode(jsdocTypedefNode, Diagnostics.JSDoc_typedef_may_be_converted_to_TypeScript_type));
	        }
	        if (ts_codefix_exports.parameterShouldGetTypeFromJSDoc(node)) {
	          diags.push(createDiagnosticForNode(node.name || node, Diagnostics.JSDoc_types_may_be_moved_to_TypeScript_types));
	        }
	      }
	      if (canBeConvertedToAsync(node)) {
	        addConvertToAsyncFunctionDiagnostics(node, checker, diags);
	      }
	      node.forEachChild(check);
	    }
	  }
	  function containsTopLevelCommonjs(sourceFile) {
	    return sourceFile.statements.some((statement) => {
	      switch (statement.kind) {
	        case 243 /* VariableStatement */:
	          return statement.declarationList.declarations.some((decl) => !!decl.initializer && isRequireCall(
	            propertyAccessLeftHandSide(decl.initializer),
	            /*requireStringLiteralLikeArgument*/
	            true
	          ));
	        case 244 /* ExpressionStatement */: {
	          const { expression } = statement;
	          if (!isBinaryExpression(expression))
	            return isRequireCall(
	              expression,
	              /*requireStringLiteralLikeArgument*/
	              true
	            );
	          const kind = getAssignmentDeclarationKind(expression);
	          return kind === 1 /* ExportsProperty */ || kind === 2 /* ModuleExports */;
	        }
	        default:
	          return false;
	      }
	    });
	  }
	  function propertyAccessLeftHandSide(node) {
	    return isPropertyAccessExpression(node) ? propertyAccessLeftHandSide(node.expression) : node;
	  }
	  function importNameForConvertToDefaultImport(node) {
	    switch (node.kind) {
	      case 272 /* ImportDeclaration */:
	        const { importClause, moduleSpecifier } = node;
	        return importClause && !importClause.name && importClause.namedBindings && importClause.namedBindings.kind === 274 /* NamespaceImport */ && isStringLiteral(moduleSpecifier) ? importClause.namedBindings.name : void 0;
	      case 271 /* ImportEqualsDeclaration */:
	        return node.name;
	      default:
	        return void 0;
	    }
	  }
	  function addConvertToAsyncFunctionDiagnostics(node, checker, diags) {
	    if (isConvertibleFunction(node, checker) && !visitedNestedConvertibleFunctions.has(getKeyFromNode(node))) {
	      diags.push(createDiagnosticForNode(
	        !node.name && isVariableDeclaration(node.parent) && isIdentifier(node.parent.name) ? node.parent.name : node,
	        Diagnostics.This_may_be_converted_to_an_async_function
	      ));
	    }
	  }
	  function isConvertibleFunction(node, checker) {
	    return !isAsyncFunction(node) && node.body && isBlock(node.body) && hasReturnStatementWithPromiseHandler(node.body, checker) && returnsPromise(node, checker);
	  }
	  function returnsPromise(node, checker) {
	    const signature = checker.getSignatureFromDeclaration(node);
	    const returnType = signature ? checker.getReturnTypeOfSignature(signature) : void 0;
	    return !!returnType && !!checker.getPromisedTypeOfPromise(returnType);
	  }
	  function getErrorNodeFromCommonJsIndicator(commonJsModuleIndicator) {
	    return isBinaryExpression(commonJsModuleIndicator) ? commonJsModuleIndicator.left : commonJsModuleIndicator;
	  }
	  function hasReturnStatementWithPromiseHandler(body, checker) {
	    return !!forEachReturnStatement(body, (statement) => isReturnStatementWithFixablePromiseHandler(statement, checker));
	  }
	  function isReturnStatementWithFixablePromiseHandler(node, checker) {
	    return isReturnStatement(node) && !!node.expression && isFixablePromiseHandler(node.expression, checker);
	  }
	  function isFixablePromiseHandler(node, checker) {
	    if (!isPromiseHandler(node) || !hasSupportedNumberOfArguments(node) || !node.arguments.every((arg) => isFixablePromiseArgument(arg, checker))) {
	      return false;
	    }
	    let currentNode = node.expression.expression;
	    while (isPromiseHandler(currentNode) || isPropertyAccessExpression(currentNode)) {
	      if (isCallExpression(currentNode)) {
	        if (!hasSupportedNumberOfArguments(currentNode) || !currentNode.arguments.every((arg) => isFixablePromiseArgument(arg, checker))) {
	          return false;
	        }
	        currentNode = currentNode.expression.expression;
	      } else {
	        currentNode = currentNode.expression;
	      }
	    }
	    return true;
	  }
	  function isPromiseHandler(node) {
	    return isCallExpression(node) && (hasPropertyAccessExpressionWithName(node, "then") || hasPropertyAccessExpressionWithName(node, "catch") || hasPropertyAccessExpressionWithName(node, "finally"));
	  }
	  function hasSupportedNumberOfArguments(node) {
	    const name = node.expression.name.text;
	    const maxArguments = name === "then" ? 2 : name === "catch" ? 1 : name === "finally" ? 1 : 0;
	    if (node.arguments.length > maxArguments)
	      return false;
	    if (node.arguments.length < maxArguments)
	      return true;
	    return maxArguments === 1 || some(node.arguments, (arg) => {
	      return arg.kind === 106 /* NullKeyword */ || isIdentifier(arg) && arg.text === "undefined";
	    });
	  }
	  function isFixablePromiseArgument(arg, checker) {
	    switch (arg.kind) {
	      case 262 /* FunctionDeclaration */:
	      case 218 /* FunctionExpression */:
	        const functionFlags = getFunctionFlags(arg);
	        if (functionFlags & 1 /* Generator */) {
	          return false;
	        }
	      case 219 /* ArrowFunction */:
	        visitedNestedConvertibleFunctions.set(getKeyFromNode(arg), true);
	      case 106 /* NullKeyword */:
	        return true;
	      case 80 /* Identifier */:
	      case 211 /* PropertyAccessExpression */: {
	        const symbol = checker.getSymbolAtLocation(arg);
	        if (!symbol) {
	          return false;
	        }
	        return checker.isUndefinedSymbol(symbol) || some(skipAlias(symbol, checker).declarations, (d) => isFunctionLike(d) || hasInitializer(d) && !!d.initializer && isFunctionLike(d.initializer));
	      }
	      default:
	        return false;
	    }
	  }
	  function getKeyFromNode(exp) {
	    return `${exp.pos.toString()}:${exp.end.toString()}`;
	  }
	  function canBeConvertedToClass(node, checker) {
	    var _a, _b, _c, _d;
	    if (isFunctionExpression(node)) {
	      if (isVariableDeclaration(node.parent) && ((_a = node.symbol.members) == null ? void 0 : _a.size)) {
	        return true;
	      }
	      const symbol = checker.getSymbolOfExpando(
	        node,
	        /*allowDeclaration*/
	        false
	      );
	      return !!(symbol && (((_b = symbol.exports) == null ? void 0 : _b.size) || ((_c = symbol.members) == null ? void 0 : _c.size)));
	    }
	    if (isFunctionDeclaration(node)) {
	      return !!((_d = node.symbol.members) == null ? void 0 : _d.size);
	    }
	    return false;
	  }
	  function canBeConvertedToAsync(node) {
	    switch (node.kind) {
	      case 262 /* FunctionDeclaration */:
	      case 174 /* MethodDeclaration */:
	      case 218 /* FunctionExpression */:
	      case 219 /* ArrowFunction */:
	        return true;
	      default:
	        return false;
	    }
	  }
	  var visitedNestedConvertibleFunctions;
	  var init_suggestionDiagnostics = __esm({
	    "src/services/suggestionDiagnostics.ts"() {
	      init_ts4();
	      visitedNestedConvertibleFunctions = /* @__PURE__ */ new Map();
	    }
	  });

	  // src/services/transpile.ts
	  function transpileModule(input, transpileOptions) {
	    const diagnostics = [];
	    const options = transpileOptions.compilerOptions ? fixupCompilerOptions(transpileOptions.compilerOptions, diagnostics) : {};
	    const defaultOptions = getDefaultCompilerOptions2();
	    for (const key in defaultOptions) {
	      if (hasProperty(defaultOptions, key) && options[key] === void 0) {
	        options[key] = defaultOptions[key];
	      }
	    }
	    for (const option of transpileOptionValueCompilerOptions) {
	      if (options.verbatimModuleSyntax && optionsRedundantWithVerbatimModuleSyntax.has(option.name)) {
	        continue;
	      }
	      options[option.name] = option.transpileOptionValue;
	    }
	    options.suppressOutputPathCheck = true;
	    options.allowNonTsExtensions = true;
	    const newLine = getNewLineCharacter(options);
	    const compilerHost = {
	      getSourceFile: (fileName) => fileName === normalizePath(inputFileName) ? sourceFile : void 0,
	      writeFile: (name, text) => {
	        if (fileExtensionIs(name, ".map")) {
	          Debug.assertEqual(sourceMapText, void 0, "Unexpected multiple source map outputs, file:", name);
	          sourceMapText = text;
	        } else {
	          Debug.assertEqual(outputText, void 0, "Unexpected multiple outputs, file:", name);
	          outputText = text;
	        }
	      },
	      getDefaultLibFileName: () => "lib.d.ts",
	      useCaseSensitiveFileNames: () => false,
	      getCanonicalFileName: (fileName) => fileName,
	      getCurrentDirectory: () => "",
	      getNewLine: () => newLine,
	      fileExists: (fileName) => fileName === inputFileName,
	      readFile: () => "",
	      directoryExists: () => true,
	      getDirectories: () => []
	    };
	    const inputFileName = transpileOptions.fileName || (transpileOptions.compilerOptions && transpileOptions.compilerOptions.jsx ? "module.tsx" : "module.ts");
	    const sourceFile = createSourceFile(
	      inputFileName,
	      input,
	      {
	        languageVersion: getEmitScriptTarget(options),
	        impliedNodeFormat: getImpliedNodeFormatForFile(
	          toPath(inputFileName, "", compilerHost.getCanonicalFileName),
	          /*packageJsonInfoCache*/
	          void 0,
	          compilerHost,
	          options
	        ),
	        setExternalModuleIndicator: getSetExternalModuleIndicator(options),
	        jsDocParsingMode: transpileOptions.jsDocParsingMode ?? 0 /* ParseAll */
	      }
	    );
	    if (transpileOptions.moduleName) {
	      sourceFile.moduleName = transpileOptions.moduleName;
	    }
	    if (transpileOptions.renamedDependencies) {
	      sourceFile.renamedDependencies = new Map(Object.entries(transpileOptions.renamedDependencies));
	    }
	    let outputText;
	    let sourceMapText;
	    const program = createProgram([inputFileName], options, compilerHost);
	    if (transpileOptions.reportDiagnostics) {
	      addRange(
	        /*to*/
	        diagnostics,
	        /*from*/
	        program.getSyntacticDiagnostics(sourceFile)
	      );
	      addRange(
	        /*to*/
	        diagnostics,
	        /*from*/
	        program.getOptionsDiagnostics()
	      );
	    }
	    program.emit(
	      /*targetSourceFile*/
	      void 0,
	      /*writeFile*/
	      void 0,
	      /*cancellationToken*/
	      void 0,
	      /*emitOnlyDtsFiles*/
	      void 0,
	      transpileOptions.transformers
	    );
	    if (outputText === void 0)
	      return Debug.fail("Output generation failed");
	    return { outputText, diagnostics, sourceMapText };
	  }
	  function transpile(input, compilerOptions, fileName, diagnostics, moduleName) {
	    const output = transpileModule(input, { compilerOptions, fileName, reportDiagnostics: !!diagnostics, moduleName });
	    addRange(diagnostics, output.diagnostics);
	    return output.outputText;
	  }
	  function fixupCompilerOptions(options, diagnostics) {
	    commandLineOptionsStringToEnum = commandLineOptionsStringToEnum || filter(optionDeclarations, (o) => typeof o.type === "object" && !forEachEntry(o.type, (v) => typeof v !== "number"));
	    options = cloneCompilerOptions(options);
	    for (const opt of commandLineOptionsStringToEnum) {
	      if (!hasProperty(options, opt.name)) {
	        continue;
	      }
	      const value = options[opt.name];
	      if (isString(value)) {
	        options[opt.name] = parseCustomTypeOption(opt, value, diagnostics);
	      } else {
	        if (!forEachEntry(opt.type, (v) => v === value)) {
	          diagnostics.push(createCompilerDiagnosticForInvalidCustomType(opt));
	        }
	      }
	    }
	    return options;
	  }
	  var optionsRedundantWithVerbatimModuleSyntax, commandLineOptionsStringToEnum;
	  var init_transpile = __esm({
	    "src/services/transpile.ts"() {
	      init_ts4();
	      optionsRedundantWithVerbatimModuleSyntax = /* @__PURE__ */ new Set([
	        "isolatedModules",
	        "preserveValueImports",
	        "importsNotUsedAsValues"
	      ]);
	    }
	  });

	  // src/services/navigateTo.ts
	  function getNavigateToItems(sourceFiles, checker, cancellationToken, searchValue, maxResultCount, excludeDtsFiles, excludeLibFiles) {
	    const patternMatcher = createPatternMatcher(searchValue);
	    if (!patternMatcher)
	      return emptyArray;
	    const rawItems = [];
	    const singleCurrentFile = sourceFiles.length === 1 ? sourceFiles[0] : void 0;
	    for (const sourceFile of sourceFiles) {
	      cancellationToken.throwIfCancellationRequested();
	      if (excludeDtsFiles && sourceFile.isDeclarationFile) {
	        continue;
	      }
	      if (shouldExcludeFile(sourceFile, !!excludeLibFiles, singleCurrentFile)) {
	        continue;
	      }
	      sourceFile.getNamedDeclarations().forEach((declarations, name) => {
	        getItemsFromNamedDeclaration(patternMatcher, name, declarations, checker, sourceFile.fileName, !!excludeLibFiles, singleCurrentFile, rawItems);
	      });
	    }
	    rawItems.sort(compareNavigateToItems);
	    return (maxResultCount === void 0 ? rawItems : rawItems.slice(0, maxResultCount)).map(createNavigateToItem);
	  }
	  function shouldExcludeFile(file, excludeLibFiles, singleCurrentFile) {
	    return file !== singleCurrentFile && excludeLibFiles && (isInsideNodeModules(file.path) || file.hasNoDefaultLib);
	  }
	  function getItemsFromNamedDeclaration(patternMatcher, name, declarations, checker, fileName, excludeLibFiles, singleCurrentFile, rawItems) {
	    const match = patternMatcher.getMatchForLastSegmentOfPattern(name);
	    if (!match) {
	      return;
	    }
	    for (const declaration of declarations) {
	      if (!shouldKeepItem(declaration, checker, excludeLibFiles, singleCurrentFile))
	        continue;
	      if (patternMatcher.patternContainsDots) {
	        const fullMatch = patternMatcher.getFullMatch(getContainers(declaration), name);
	        if (fullMatch) {
	          rawItems.push({ name, fileName, matchKind: fullMatch.kind, isCaseSensitive: fullMatch.isCaseSensitive, declaration });
	        }
	      } else {
	        rawItems.push({ name, fileName, matchKind: match.kind, isCaseSensitive: match.isCaseSensitive, declaration });
	      }
	    }
	  }
	  function shouldKeepItem(declaration, checker, excludeLibFiles, singleCurrentFile) {
	    var _a;
	    switch (declaration.kind) {
	      case 273 /* ImportClause */:
	      case 276 /* ImportSpecifier */:
	      case 271 /* ImportEqualsDeclaration */:
	        const importer = checker.getSymbolAtLocation(declaration.name);
	        const imported = checker.getAliasedSymbol(importer);
	        return importer.escapedName !== imported.escapedName && !((_a = imported.declarations) == null ? void 0 : _a.every((d) => shouldExcludeFile(d.getSourceFile(), excludeLibFiles, singleCurrentFile)));
	      default:
	        return true;
	    }
	  }
	  function tryAddSingleDeclarationName(declaration, containers) {
	    const name = getNameOfDeclaration(declaration);
	    return !!name && (pushLiteral(name, containers) || name.kind === 167 /* ComputedPropertyName */ && tryAddComputedPropertyName(name.expression, containers));
	  }
	  function tryAddComputedPropertyName(expression, containers) {
	    return pushLiteral(expression, containers) || isPropertyAccessExpression(expression) && (containers.push(expression.name.text), true) && tryAddComputedPropertyName(expression.expression, containers);
	  }
	  function pushLiteral(node, containers) {
	    return isPropertyNameLiteral(node) && (containers.push(getTextOfIdentifierOrLiteral(node)), true);
	  }
	  function getContainers(declaration) {
	    const containers = [];
	    const name = getNameOfDeclaration(declaration);
	    if (name && name.kind === 167 /* ComputedPropertyName */ && !tryAddComputedPropertyName(name.expression, containers)) {
	      return emptyArray;
	    }
	    containers.shift();
	    let container = getContainerNode(declaration);
	    while (container) {
	      if (!tryAddSingleDeclarationName(container, containers)) {
	        return emptyArray;
	      }
	      container = getContainerNode(container);
	    }
	    return containers.reverse();
	  }
	  function compareNavigateToItems(i1, i2) {
	    return compareValues(i1.matchKind, i2.matchKind) || compareStringsCaseSensitiveUI(i1.name, i2.name);
	  }
	  function createNavigateToItem(rawItem) {
	    const declaration = rawItem.declaration;
	    const container = getContainerNode(declaration);
	    const containerName = container && getNameOfDeclaration(container);
	    return {
	      name: rawItem.name,
	      kind: getNodeKind(declaration),
	      kindModifiers: getNodeModifiers(declaration),
	      matchKind: PatternMatchKind[rawItem.matchKind],
	      isCaseSensitive: rawItem.isCaseSensitive,
	      fileName: rawItem.fileName,
	      textSpan: createTextSpanFromNode(declaration),
	      // TODO(jfreeman): What should be the containerName when the container has a computed name?
	      containerName: containerName ? containerName.text : "",
	      containerKind: containerName ? getNodeKind(container) : "" /* unknown */
	    };
	  }
	  var init_navigateTo = __esm({
	    "src/services/navigateTo.ts"() {
	      init_ts4();
	    }
	  });

	  // src/services/_namespaces/ts.NavigateTo.ts
	  var ts_NavigateTo_exports = {};
	  __export(ts_NavigateTo_exports, {
	    getNavigateToItems: () => getNavigateToItems
	  });
	  var init_ts_NavigateTo = __esm({
	    "src/services/_namespaces/ts.NavigateTo.ts"() {
	      init_navigateTo();
	    }
	  });

	  // src/services/navigationBar.ts
	  function getNavigationBarItems(sourceFile, cancellationToken) {
	    curCancellationToken = cancellationToken;
	    curSourceFile = sourceFile;
	    try {
	      return map(primaryNavBarMenuItems(rootNavigationBarNode(sourceFile)), convertToPrimaryNavBarMenuItem);
	    } finally {
	      reset();
	    }
	  }
	  function getNavigationTree(sourceFile, cancellationToken) {
	    curCancellationToken = cancellationToken;
	    curSourceFile = sourceFile;
	    try {
	      return convertToTree(rootNavigationBarNode(sourceFile));
	    } finally {
	      reset();
	    }
	  }
	  function reset() {
	    curSourceFile = void 0;
	    curCancellationToken = void 0;
	    parentsStack = [];
	    parent = void 0;
	    emptyChildItemArray = [];
	  }
	  function nodeText(node) {
	    return cleanText(node.getText(curSourceFile));
	  }
	  function navigationBarNodeKind(n) {
	    return n.node.kind;
	  }
	  function pushChild(parent2, child) {
	    if (parent2.children) {
	      parent2.children.push(child);
	    } else {
	      parent2.children = [child];
	    }
	  }
	  function rootNavigationBarNode(sourceFile) {
	    Debug.assert(!parentsStack.length);
	    const root = { node: sourceFile, name: void 0, additionalNodes: void 0, parent: void 0, children: void 0, indent: 0 };
	    parent = root;
	    for (const statement of sourceFile.statements) {
	      addChildrenRecursively(statement);
	    }
	    endNode();
	    Debug.assert(!parent && !parentsStack.length);
	    return root;
	  }
	  function addLeafNode(node, name) {
	    pushChild(parent, emptyNavigationBarNode(node, name));
	  }
	  function emptyNavigationBarNode(node, name) {
	    return {
	      node,
	      name: name || (isDeclaration(node) || isExpression(node) ? getNameOfDeclaration(node) : void 0),
	      additionalNodes: void 0,
	      parent,
	      children: void 0,
	      indent: parent.indent + 1
	    };
	  }
	  function addTrackedEs5Class(name) {
	    if (!trackedEs5Classes) {
	      trackedEs5Classes = /* @__PURE__ */ new Map();
	    }
	    trackedEs5Classes.set(name, true);
	  }
	  function endNestedNodes(depth) {
	    for (let i = 0; i < depth; i++)
	      endNode();
	  }
	  function startNestedNodes(targetNode, entityName) {
	    const names = [];
	    while (!isPropertyNameLiteral(entityName)) {
	      const name = getNameOrArgument(entityName);
	      const nameText = getElementOrPropertyAccessName(entityName);
	      entityName = entityName.expression;
	      if (nameText === "prototype" || isPrivateIdentifier(name))
	        continue;
	      names.push(name);
	    }
	    names.push(entityName);
	    for (let i = names.length - 1; i > 0; i--) {
	      const name = names[i];
	      startNode(targetNode, name);
	    }
	    return [names.length - 1, names[0]];
	  }
	  function startNode(node, name) {
	    const navNode = emptyNavigationBarNode(node, name);
	    pushChild(parent, navNode);
	    parentsStack.push(parent);
	    trackedEs5ClassesStack.push(trackedEs5Classes);
	    trackedEs5Classes = void 0;
	    parent = navNode;
	  }
	  function endNode() {
	    if (parent.children) {
	      mergeChildren(parent.children, parent);
	      sortChildren(parent.children);
	    }
	    parent = parentsStack.pop();
	    trackedEs5Classes = trackedEs5ClassesStack.pop();
	  }
	  function addNodeWithRecursiveChild(node, child, name) {
	    startNode(node, name);
	    addChildrenRecursively(child);
	    endNode();
	  }
	  function addNodeWithRecursiveInitializer(node) {
	    if (node.initializer && isFunctionOrClassExpression(node.initializer)) {
	      startNode(node);
	      forEachChild(node.initializer, addChildrenRecursively);
	      endNode();
	    } else {
	      addNodeWithRecursiveChild(node, node.initializer);
	    }
	  }
	  function hasNavigationBarName(node) {
	    const name = getNameOfDeclaration(node);
	    if (name === void 0)
	      return false;
	    if (isComputedPropertyName(name)) {
	      const expression = name.expression;
	      return isEntityNameExpression(expression) || isNumericLiteral(expression) || isStringOrNumericLiteralLike(expression);
	    }
	    return !!name;
	  }
	  function addChildrenRecursively(node) {
	    curCancellationToken.throwIfCancellationRequested();
	    if (!node || isToken(node)) {
	      return;
	    }
	    switch (node.kind) {
	      case 176 /* Constructor */:
	        const ctr = node;
	        addNodeWithRecursiveChild(ctr, ctr.body);
	        for (const param of ctr.parameters) {
	          if (isParameterPropertyDeclaration(param, ctr)) {
	            addLeafNode(param);
	          }
	        }
	        break;
	      case 174 /* MethodDeclaration */:
	      case 177 /* GetAccessor */:
	      case 178 /* SetAccessor */:
	      case 173 /* MethodSignature */:
	        if (hasNavigationBarName(node)) {
	          addNodeWithRecursiveChild(node, node.body);
	        }
	        break;
	      case 172 /* PropertyDeclaration */:
	        if (hasNavigationBarName(node)) {
	          addNodeWithRecursiveInitializer(node);
	        }
	        break;
	      case 171 /* PropertySignature */:
	        if (hasNavigationBarName(node)) {
	          addLeafNode(node);
	        }
	        break;
	      case 273 /* ImportClause */:
	        const importClause = node;
	        if (importClause.name) {
	          addLeafNode(importClause.name);
	        }
	        const { namedBindings } = importClause;
	        if (namedBindings) {
	          if (namedBindings.kind === 274 /* NamespaceImport */) {
	            addLeafNode(namedBindings);
	          } else {
	            for (const element of namedBindings.elements) {
	              addLeafNode(element);
	            }
	          }
	        }
	        break;
	      case 304 /* ShorthandPropertyAssignment */:
	        addNodeWithRecursiveChild(node, node.name);
	        break;
	      case 305 /* SpreadAssignment */:
	        const { expression } = node;
	        isIdentifier(expression) ? addLeafNode(node, expression) : addLeafNode(node);
	        break;
	      case 208 /* BindingElement */:
	      case 303 /* PropertyAssignment */:
	      case 260 /* VariableDeclaration */: {
	        const child = node;
	        if (isBindingPattern(child.name)) {
	          addChildrenRecursively(child.name);
	        } else {
	          addNodeWithRecursiveInitializer(child);
	        }
	        break;
	      }
	      case 262 /* FunctionDeclaration */:
	        const nameNode = node.name;
	        if (nameNode && isIdentifier(nameNode)) {
	          addTrackedEs5Class(nameNode.text);
	        }
	        addNodeWithRecursiveChild(node, node.body);
	        break;
	      case 219 /* ArrowFunction */:
	      case 218 /* FunctionExpression */:
	        addNodeWithRecursiveChild(node, node.body);
	        break;
	      case 266 /* EnumDeclaration */:
	        startNode(node);
	        for (const member of node.members) {
	          if (!isComputedProperty(member)) {
	            addLeafNode(member);
	          }
	        }
	        endNode();
	        break;
	      case 263 /* ClassDeclaration */:
	      case 231 /* ClassExpression */:
	      case 264 /* InterfaceDeclaration */:
	        startNode(node);
	        for (const member of node.members) {
	          addChildrenRecursively(member);
	        }
	        endNode();
	        break;
	      case 267 /* ModuleDeclaration */:
	        addNodeWithRecursiveChild(node, getInteriorModule(node).body);
	        break;
	      case 277 /* ExportAssignment */: {
	        const expression2 = node.expression;
	        const child = isObjectLiteralExpression(expression2) || isCallExpression(expression2) ? expression2 : isArrowFunction(expression2) || isFunctionExpression(expression2) ? expression2.body : void 0;
	        if (child) {
	          startNode(node);
	          addChildrenRecursively(child);
	          endNode();
	        } else {
	          addLeafNode(node);
	        }
	        break;
	      }
	      case 281 /* ExportSpecifier */:
	      case 271 /* ImportEqualsDeclaration */:
	      case 181 /* IndexSignature */:
	      case 179 /* CallSignature */:
	      case 180 /* ConstructSignature */:
	      case 265 /* TypeAliasDeclaration */:
	        addLeafNode(node);
	        break;
	      case 213 /* CallExpression */:
	      case 226 /* BinaryExpression */: {
	        const special = getAssignmentDeclarationKind(node);
	        switch (special) {
	          case 1 /* ExportsProperty */:
	          case 2 /* ModuleExports */:
	            addNodeWithRecursiveChild(node, node.right);
	            return;
	          case 6 /* Prototype */:
	          case 3 /* PrototypeProperty */: {
	            const binaryExpression = node;
	            const assignmentTarget = binaryExpression.left;
	            const prototypeAccess = special === 3 /* PrototypeProperty */ ? assignmentTarget.expression : assignmentTarget;
	            let depth = 0;
	            let className;
	            if (isIdentifier(prototypeAccess.expression)) {
	              addTrackedEs5Class(prototypeAccess.expression.text);
	              className = prototypeAccess.expression;
	            } else {
	              [depth, className] = startNestedNodes(binaryExpression, prototypeAccess.expression);
	            }
	            if (special === 6 /* Prototype */) {
	              if (isObjectLiteralExpression(binaryExpression.right)) {
	                if (binaryExpression.right.properties.length > 0) {
	                  startNode(binaryExpression, className);
	                  forEachChild(binaryExpression.right, addChildrenRecursively);
	                  endNode();
	                }
	              }
	            } else if (isFunctionExpression(binaryExpression.right) || isArrowFunction(binaryExpression.right)) {
	              addNodeWithRecursiveChild(node, binaryExpression.right, className);
	            } else {
	              startNode(binaryExpression, className);
	              addNodeWithRecursiveChild(node, binaryExpression.right, assignmentTarget.name);
	              endNode();
	            }
	            endNestedNodes(depth);
	            return;
	          }
	          case 7 /* ObjectDefinePropertyValue */:
	          case 9 /* ObjectDefinePrototypeProperty */: {
	            const defineCall = node;
	            const className = special === 7 /* ObjectDefinePropertyValue */ ? defineCall.arguments[0] : defineCall.arguments[0].expression;
	            const memberName = defineCall.arguments[1];
	            const [depth, classNameIdentifier] = startNestedNodes(node, className);
	            startNode(node, classNameIdentifier);
	            startNode(node, setTextRange(factory.createIdentifier(memberName.text), memberName));
	            addChildrenRecursively(node.arguments[2]);
	            endNode();
	            endNode();
	            endNestedNodes(depth);
	            return;
	          }
	          case 5 /* Property */: {
	            const binaryExpression = node;
	            const assignmentTarget = binaryExpression.left;
	            const targetFunction = assignmentTarget.expression;
	            if (isIdentifier(targetFunction) && getElementOrPropertyAccessName(assignmentTarget) !== "prototype" && trackedEs5Classes && trackedEs5Classes.has(targetFunction.text)) {
	              if (isFunctionExpression(binaryExpression.right) || isArrowFunction(binaryExpression.right)) {
	                addNodeWithRecursiveChild(node, binaryExpression.right, targetFunction);
	              } else if (isBindableStaticAccessExpression(assignmentTarget)) {
	                startNode(binaryExpression, targetFunction);
	                addNodeWithRecursiveChild(binaryExpression.left, binaryExpression.right, getNameOrArgument(assignmentTarget));
	                endNode();
	              }
	              return;
	            }
	            break;
	          }
	          case 4 /* ThisProperty */:
	          case 0 /* None */:
	          case 8 /* ObjectDefinePropertyExports */:
	            break;
	          default:
	            Debug.assertNever(special);
	        }
	      }
	      default:
	        if (hasJSDocNodes(node)) {
	          forEach(node.jsDoc, (jsDoc) => {
	            forEach(jsDoc.tags, (tag) => {
	              if (isJSDocTypeAlias(tag)) {
	                addLeafNode(tag);
	              }
	            });
	          });
	        }
	        forEachChild(node, addChildrenRecursively);
	    }
	  }
	  function mergeChildren(children, node) {
	    const nameToItems = /* @__PURE__ */ new Map();
	    filterMutate(children, (child, index) => {
	      const declName = child.name || getNameOfDeclaration(child.node);
	      const name = declName && nodeText(declName);
	      if (!name) {
	        return true;
	      }
	      const itemsWithSameName = nameToItems.get(name);
	      if (!itemsWithSameName) {
	        nameToItems.set(name, child);
	        return true;
	      }
	      if (itemsWithSameName instanceof Array) {
	        for (const itemWithSameName of itemsWithSameName) {
	          if (tryMerge(itemWithSameName, child, index, node)) {
	            return false;
	          }
	        }
	        itemsWithSameName.push(child);
	        return true;
	      } else {
	        const itemWithSameName = itemsWithSameName;
	        if (tryMerge(itemWithSameName, child, index, node)) {
	          return false;
	        }
	        nameToItems.set(name, [itemWithSameName, child]);
	        return true;
	      }
	    });
	  }
	  function tryMergeEs5Class(a, b, bIndex, parent2) {
	    function isPossibleConstructor(node) {
	      return isFunctionExpression(node) || isFunctionDeclaration(node) || isVariableDeclaration(node);
	    }
	    const bAssignmentDeclarationKind = isBinaryExpression(b.node) || isCallExpression(b.node) ? getAssignmentDeclarationKind(b.node) : 0 /* None */;
	    const aAssignmentDeclarationKind = isBinaryExpression(a.node) || isCallExpression(a.node) ? getAssignmentDeclarationKind(a.node) : 0 /* None */;
	    if (isEs5ClassMember[bAssignmentDeclarationKind] && isEs5ClassMember[aAssignmentDeclarationKind] || isPossibleConstructor(a.node) && isEs5ClassMember[bAssignmentDeclarationKind] || isPossibleConstructor(b.node) && isEs5ClassMember[aAssignmentDeclarationKind] || isClassDeclaration(a.node) && isSynthesized(a.node) && isEs5ClassMember[bAssignmentDeclarationKind] || isClassDeclaration(b.node) && isEs5ClassMember[aAssignmentDeclarationKind] || isClassDeclaration(a.node) && isSynthesized(a.node) && isPossibleConstructor(b.node) || isClassDeclaration(b.node) && isPossibleConstructor(a.node) && isSynthesized(a.node)) {
	      let lastANode = a.additionalNodes && lastOrUndefined(a.additionalNodes) || a.node;
	      if (!isClassDeclaration(a.node) && !isClassDeclaration(b.node) || isPossibleConstructor(a.node) || isPossibleConstructor(b.node)) {
	        const ctorFunction = isPossibleConstructor(a.node) ? a.node : isPossibleConstructor(b.node) ? b.node : void 0;
	        if (ctorFunction !== void 0) {
	          const ctorNode = setTextRange(
	            factory.createConstructorDeclaration(
	              /*modifiers*/
	              void 0,
	              [],
	              /*body*/
	              void 0
	            ),
	            ctorFunction
	          );
	          const ctor = emptyNavigationBarNode(ctorNode);
	          ctor.indent = a.indent + 1;
	          ctor.children = a.node === ctorFunction ? a.children : b.children;
	          a.children = a.node === ctorFunction ? concatenate([ctor], b.children || [b]) : concatenate(a.children || [{ ...a }], [ctor]);
	        } else {
	          if (a.children || b.children) {
	            a.children = concatenate(a.children || [{ ...a }], b.children || [b]);
	            if (a.children) {
	              mergeChildren(a.children, a);
	              sortChildren(a.children);
	            }
	          }
	        }
	        lastANode = a.node = setTextRange(
	          factory.createClassDeclaration(
	            /*modifiers*/
	            void 0,
	            a.name || factory.createIdentifier("__class__"),
	            /*typeParameters*/
	            void 0,
	            /*heritageClauses*/
	            void 0,
	            []
	          ),
	          a.node
	        );
	      } else {
	        a.children = concatenate(a.children, b.children);
	        if (a.children) {
	          mergeChildren(a.children, a);
	        }
	      }
	      const bNode = b.node;
	      if (parent2.children[bIndex - 1].node.end === lastANode.end) {
	        setTextRange(lastANode, { pos: lastANode.pos, end: bNode.end });
	      } else {
	        if (!a.additionalNodes)
	          a.additionalNodes = [];
	        a.additionalNodes.push(setTextRange(
	          factory.createClassDeclaration(
	            /*modifiers*/
	            void 0,
	            a.name || factory.createIdentifier("__class__"),
	            /*typeParameters*/
	            void 0,
	            /*heritageClauses*/
	            void 0,
	            []
	          ),
	          b.node
	        ));
	      }
	      return true;
	    }
	    return bAssignmentDeclarationKind === 0 /* None */ ? false : true;
	  }
	  function tryMerge(a, b, bIndex, parent2) {
	    if (tryMergeEs5Class(a, b, bIndex, parent2)) {
	      return true;
	    }
	    if (shouldReallyMerge(a.node, b.node, parent2)) {
	      merge(a, b);
	      return true;
	    }
	    return false;
	  }
	  function shouldReallyMerge(a, b, parent2) {
	    if (a.kind !== b.kind || a.parent !== b.parent && !(isOwnChild(a, parent2) && isOwnChild(b, parent2))) {
	      return false;
	    }
	    switch (a.kind) {
	      case 172 /* PropertyDeclaration */:
	      case 174 /* MethodDeclaration */:
	      case 177 /* GetAccessor */:
	      case 178 /* SetAccessor */:
	        return isStatic(a) === isStatic(b);
	      case 267 /* ModuleDeclaration */:
	        return areSameModule(a, b) && getFullyQualifiedModuleName(a) === getFullyQualifiedModuleName(b);
	      default:
	        return true;
	    }
	  }
	  function isSynthesized(node) {
	    return !!(node.flags & 16 /* Synthesized */);
	  }
	  function isOwnChild(n, parent2) {
	    const par = isModuleBlock(n.parent) ? n.parent.parent : n.parent;
	    return par === parent2.node || contains(parent2.additionalNodes, par);
	  }
	  function areSameModule(a, b) {
	    if (!a.body || !b.body) {
	      return a.body === b.body;
	    }
	    return a.body.kind === b.body.kind && (a.body.kind !== 267 /* ModuleDeclaration */ || areSameModule(a.body, b.body));
	  }
	  function merge(target, source) {
	    target.additionalNodes = target.additionalNodes || [];
	    target.additionalNodes.push(source.node);
	    if (source.additionalNodes) {
	      target.additionalNodes.push(...source.additionalNodes);
	    }
	    target.children = concatenate(target.children, source.children);
	    if (target.children) {
	      mergeChildren(target.children, target);
	      sortChildren(target.children);
	    }
	  }
	  function sortChildren(children) {
	    children.sort(compareChildren);
	  }
	  function compareChildren(child1, child2) {
	    return compareStringsCaseSensitiveUI(tryGetName(child1.node), tryGetName(child2.node)) || compareValues(navigationBarNodeKind(child1), navigationBarNodeKind(child2));
	  }
	  function tryGetName(node) {
	    if (node.kind === 267 /* ModuleDeclaration */) {
	      return getModuleName(node);
	    }
	    const declName = getNameOfDeclaration(node);
	    if (declName && isPropertyName(declName)) {
	      const propertyName = getPropertyNameForPropertyNameNode(declName);
	      return propertyName && unescapeLeadingUnderscores(propertyName);
	    }
	    switch (node.kind) {
	      case 218 /* FunctionExpression */:
	      case 219 /* ArrowFunction */:
	      case 231 /* ClassExpression */:
	        return getFunctionOrClassName(node);
	      default:
	        return void 0;
	    }
	  }
	  function getItemName(node, name) {
	    if (node.kind === 267 /* ModuleDeclaration */) {
	      return cleanText(getModuleName(node));
	    }
	    if (name) {
	      const text = isIdentifier(name) ? name.text : isElementAccessExpression(name) ? `[${nodeText(name.argumentExpression)}]` : nodeText(name);
	      if (text.length > 0) {
	        return cleanText(text);
	      }
	    }
	    switch (node.kind) {
	      case 312 /* SourceFile */:
	        const sourceFile = node;
	        return isExternalModule(sourceFile) ? `"${escapeString(getBaseFileName(removeFileExtension(normalizePath(sourceFile.fileName))))}"` : "<global>";
	      case 277 /* ExportAssignment */:
	        return isExportAssignment(node) && node.isExportEquals ? "export=" /* ExportEquals */ : "default" /* Default */;
	      case 219 /* ArrowFunction */:
	      case 262 /* FunctionDeclaration */:
	      case 218 /* FunctionExpression */:
	      case 263 /* ClassDeclaration */:
	      case 231 /* ClassExpression */:
	        if (getSyntacticModifierFlags(node) & 2048 /* Default */) {
	          return "default";
	        }
	        return getFunctionOrClassName(node);
	      case 176 /* Constructor */:
	        return "constructor";
	      case 180 /* ConstructSignature */:
	        return "new()";
	      case 179 /* CallSignature */:
	        return "()";
	      case 181 /* IndexSignature */:
	        return "[]";
	      default:
	        return "<unknown>";
	    }
	  }
	  function primaryNavBarMenuItems(root) {
	    const primaryNavBarMenuItems2 = [];
	    function recur(item) {
	      if (shouldAppearInPrimaryNavBarMenu(item)) {
	        primaryNavBarMenuItems2.push(item);
	        if (item.children) {
	          for (const child of item.children) {
	            recur(child);
	          }
	        }
	      }
	    }
	    recur(root);
	    return primaryNavBarMenuItems2;
	    function shouldAppearInPrimaryNavBarMenu(item) {
	      if (item.children) {
	        return true;
	      }
	      switch (navigationBarNodeKind(item)) {
	        case 263 /* ClassDeclaration */:
	        case 231 /* ClassExpression */:
	        case 266 /* EnumDeclaration */:
	        case 264 /* InterfaceDeclaration */:
	        case 267 /* ModuleDeclaration */:
	        case 312 /* SourceFile */:
	        case 265 /* TypeAliasDeclaration */:
	        case 353 /* JSDocTypedefTag */:
	        case 345 /* JSDocCallbackTag */:
	          return true;
	        case 219 /* ArrowFunction */:
	        case 262 /* FunctionDeclaration */:
	        case 218 /* FunctionExpression */:
	          return isTopLevelFunctionDeclaration(item);
	        default:
	          return false;
	      }
	      function isTopLevelFunctionDeclaration(item2) {
	        if (!item2.node.body) {
	          return false;
	        }
	        switch (navigationBarNodeKind(item2.parent)) {
	          case 268 /* ModuleBlock */:
	          case 312 /* SourceFile */:
	          case 174 /* MethodDeclaration */:
	          case 176 /* Constructor */:
	            return true;
	          default:
	            return false;
	        }
	      }
	    }
	  }
	  function convertToTree(n) {
	    return {
	      text: getItemName(n.node, n.name),
	      kind: getNodeKind(n.node),
	      kindModifiers: getModifiers2(n.node),
	      spans: getSpans(n),
	      nameSpan: n.name && getNodeSpan(n.name),
	      childItems: map(n.children, convertToTree)
	    };
	  }
	  function convertToPrimaryNavBarMenuItem(n) {
	    return {
	      text: getItemName(n.node, n.name),
	      kind: getNodeKind(n.node),
	      kindModifiers: getModifiers2(n.node),
	      spans: getSpans(n),
	      childItems: map(n.children, convertToSecondaryNavBarMenuItem) || emptyChildItemArray,
	      indent: n.indent,
	      bolded: false,
	      grayed: false
	    };
	    function convertToSecondaryNavBarMenuItem(n2) {
	      return {
	        text: getItemName(n2.node, n2.name),
	        kind: getNodeKind(n2.node),
	        kindModifiers: getNodeModifiers(n2.node),
	        spans: getSpans(n2),
	        childItems: emptyChildItemArray,
	        indent: 0,
	        bolded: false,
	        grayed: false
	      };
	    }
	  }
	  function getSpans(n) {
	    const spans = [getNodeSpan(n.node)];
	    if (n.additionalNodes) {
	      for (const node of n.additionalNodes) {
	        spans.push(getNodeSpan(node));
	      }
	    }
	    return spans;
	  }
	  function getModuleName(moduleDeclaration) {
	    if (isAmbientModule(moduleDeclaration)) {
	      return getTextOfNode(moduleDeclaration.name);
	    }
	    return getFullyQualifiedModuleName(moduleDeclaration);
	  }
	  function getFullyQualifiedModuleName(moduleDeclaration) {
	    const result = [getTextOfIdentifierOrLiteral(moduleDeclaration.name)];
	    while (moduleDeclaration.body && moduleDeclaration.body.kind === 267 /* ModuleDeclaration */) {
	      moduleDeclaration = moduleDeclaration.body;
	      result.push(getTextOfIdentifierOrLiteral(moduleDeclaration.name));
	    }
	    return result.join(".");
	  }
	  function getInteriorModule(decl) {
	    return decl.body && isModuleDeclaration(decl.body) ? getInteriorModule(decl.body) : decl;
	  }
	  function isComputedProperty(member) {
	    return !member.name || member.name.kind === 167 /* ComputedPropertyName */;
	  }
	  function getNodeSpan(node) {
	    return node.kind === 312 /* SourceFile */ ? createTextSpanFromRange(node) : createTextSpanFromNode(node, curSourceFile);
	  }
	  function getModifiers2(node) {
	    if (node.parent && node.parent.kind === 260 /* VariableDeclaration */) {
	      node = node.parent;
	    }
	    return getNodeModifiers(node);
	  }
	  function getFunctionOrClassName(node) {
	    const { parent: parent2 } = node;
	    if (node.name && getFullWidth(node.name) > 0) {
	      return cleanText(declarationNameToString(node.name));
	    } else if (isVariableDeclaration(parent2)) {
	      return cleanText(declarationNameToString(parent2.name));
	    } else if (isBinaryExpression(parent2) && parent2.operatorToken.kind === 64 /* EqualsToken */) {
	      return nodeText(parent2.left).replace(whiteSpaceRegex, "");
	    } else if (isPropertyAssignment(parent2)) {
	      return nodeText(parent2.name);
	    } else if (getSyntacticModifierFlags(node) & 2048 /* Default */) {
	      return "default";
	    } else if (isClassLike(node)) {
	      return "<class>";
	    } else if (isCallExpression(parent2)) {
	      let name = getCalledExpressionName(parent2.expression);
	      if (name !== void 0) {
	        name = cleanText(name);
	        if (name.length > maxLength) {
	          return `${name} callback`;
	        }
	        const args = cleanText(mapDefined(parent2.arguments, (a) => isStringLiteralLike(a) || isTemplateLiteral(a) ? a.getText(curSourceFile) : void 0).join(", "));
	        return `${name}(${args}) callback`;
	      }
	    }
	    return "<function>";
	  }
	  function getCalledExpressionName(expr) {
	    if (isIdentifier(expr)) {
	      return expr.text;
	    } else if (isPropertyAccessExpression(expr)) {
	      const left = getCalledExpressionName(expr.expression);
	      const right = expr.name.text;
	      return left === void 0 ? right : `${left}.${right}`;
	    } else {
	      return void 0;
	    }
	  }
	  function isFunctionOrClassExpression(node) {
	    switch (node.kind) {
	      case 219 /* ArrowFunction */:
	      case 218 /* FunctionExpression */:
	      case 231 /* ClassExpression */:
	        return true;
	      default:
	        return false;
	    }
	  }
	  function cleanText(text) {
	    text = text.length > maxLength ? text.substring(0, maxLength) + "..." : text;
	    return text.replace(/\\?(\r?\n|\r|\u2028|\u2029)/g, "");
	  }
	  var whiteSpaceRegex, maxLength, curCancellationToken, curSourceFile, parentsStack, parent, trackedEs5ClassesStack, trackedEs5Classes, emptyChildItemArray, isEs5ClassMember;
	  var init_navigationBar = __esm({
	    "src/services/navigationBar.ts"() {
	      init_ts4();
	      whiteSpaceRegex = /\s+/g;
	      maxLength = 150;
	      parentsStack = [];
	      trackedEs5ClassesStack = [];
	      emptyChildItemArray = [];
	      isEs5ClassMember = {
	        [5 /* Property */]: true,
	        [3 /* PrototypeProperty */]: true,
	        [7 /* ObjectDefinePropertyValue */]: true,
	        [9 /* ObjectDefinePrototypeProperty */]: true,
	        [0 /* None */]: false,
	        [1 /* ExportsProperty */]: false,
	        [2 /* ModuleExports */]: false,
	        [8 /* ObjectDefinePropertyExports */]: false,
	        [6 /* Prototype */]: true,
	        [4 /* ThisProperty */]: false
	      };
	    }
	  });

	  // src/services/_namespaces/ts.NavigationBar.ts
	  var ts_NavigationBar_exports = {};
	  __export(ts_NavigationBar_exports, {
	    getNavigationBarItems: () => getNavigationBarItems,
	    getNavigationTree: () => getNavigationTree
	  });
	  var init_ts_NavigationBar = __esm({
	    "src/services/_namespaces/ts.NavigationBar.ts"() {
	      init_navigationBar();
	    }
	  });

	  // src/services/refactorProvider.ts
	  function registerRefactor(name, refactor) {
	    refactors.set(name, refactor);
	  }
	  function getApplicableRefactors(context, includeInteractiveActions) {
	    return arrayFrom(flatMapIterator(refactors.values(), (refactor) => {
	      var _a;
	      return context.cancellationToken && context.cancellationToken.isCancellationRequested() || !((_a = refactor.kinds) == null ? void 0 : _a.some((kind) => refactorKindBeginsWith(kind, context.kind))) ? void 0 : refactor.getAvailableActions(context, includeInteractiveActions);
	    }));
	  }
	  function getEditsForRefactor(context, refactorName14, actionName2, interactiveRefactorArguments) {
	    const refactor = refactors.get(refactorName14);
	    return refactor && refactor.getEditsForAction(context, actionName2, interactiveRefactorArguments);
	  }
	  var refactors;
	  var init_refactorProvider = __esm({
	    "src/services/refactorProvider.ts"() {
	      init_ts4();
	      init_ts_refactor();
	      refactors = /* @__PURE__ */ new Map();
	    }
	  });

	  // src/services/refactors/convertExport.ts
	  function getInfo2(context, considerPartialSpans = true) {
	    const { file, program } = context;
	    const span = getRefactorContextSpan(context);
	    const token = getTokenAtPosition(file, span.start);
	    const exportNode = !!(token.parent && getSyntacticModifierFlags(token.parent) & 32 /* Export */) && considerPartialSpans ? token.parent : getParentNodeInSpan(token, file, span);
	    if (!exportNode || !isSourceFile(exportNode.parent) && !(isModuleBlock(exportNode.parent) && isAmbientModule(exportNode.parent.parent))) {
	      return { error: getLocaleSpecificMessage(Diagnostics.Could_not_find_export_statement) };
	    }
	    const checker = program.getTypeChecker();
	    const exportingModuleSymbol = getExportingModuleSymbol(exportNode.parent, checker);
	    const flags = getSyntacticModifierFlags(exportNode) || (isExportAssignment(exportNode) && !exportNode.isExportEquals ? 2080 /* ExportDefault */ : 0 /* None */);
	    const wasDefault = !!(flags & 2048 /* Default */);
	    if (!(flags & 32 /* Export */) || !wasDefault && exportingModuleSymbol.exports.has("default" /* Default */)) {
	      return { error: getLocaleSpecificMessage(Diagnostics.This_file_already_has_a_default_export) };
	    }
	    const noSymbolError = (id) => isIdentifier(id) && checker.getSymbolAtLocation(id) ? void 0 : { error: getLocaleSpecificMessage(Diagnostics.Can_only_convert_named_export) };
	    switch (exportNode.kind) {
	      case 262 /* FunctionDeclaration */:
	      case 263 /* ClassDeclaration */:
	      case 264 /* InterfaceDeclaration */:
	      case 266 /* EnumDeclaration */:
	      case 265 /* TypeAliasDeclaration */:
	      case 267 /* ModuleDeclaration */: {
	        const node = exportNode;
	        if (!node.name)
	          return void 0;
	        return noSymbolError(node.name) || { exportNode: node, exportName: node.name, wasDefault, exportingModuleSymbol };
	      }
	      case 243 /* VariableStatement */: {
	        const vs = exportNode;
	        if (!(vs.declarationList.flags & 2 /* Const */) || vs.declarationList.declarations.length !== 1) {
	          return void 0;
	        }
	        const decl = first(vs.declarationList.declarations);
	        if (!decl.initializer)
	          return void 0;
	        Debug.assert(!wasDefault, "Can't have a default flag here");
	        return noSymbolError(decl.name) || { exportNode: vs, exportName: decl.name, wasDefault, exportingModuleSymbol };
	      }
	      case 277 /* ExportAssignment */: {
	        const node = exportNode;
	        if (node.isExportEquals)
	          return void 0;
	        return noSymbolError(node.expression) || { exportNode: node, exportName: node.expression, wasDefault, exportingModuleSymbol };
	      }
	      default:
	        return void 0;
	    }
	  }
	  function doChange(exportingSourceFile, program, info, changes, cancellationToken) {
	    changeExport(exportingSourceFile, info, changes, program.getTypeChecker());
	    changeImports(program, info, changes, cancellationToken);
	  }
	  function changeExport(exportingSourceFile, { wasDefault, exportNode, exportName }, changes, checker) {
	    if (wasDefault) {
	      if (isExportAssignment(exportNode) && !exportNode.isExportEquals) {
	        const exp = exportNode.expression;
	        const spec = makeExportSpecifier(exp.text, exp.text);
	        changes.replaceNode(exportingSourceFile, exportNode, factory.createExportDeclaration(
	          /*modifiers*/
	          void 0,
	          /*isTypeOnly*/
	          false,
	          factory.createNamedExports([spec])
	        ));
	      } else {
	        changes.delete(exportingSourceFile, Debug.checkDefined(findModifier(exportNode, 90 /* DefaultKeyword */), "Should find a default keyword in modifier list"));
	      }
	    } else {
	      const exportKeyword = Debug.checkDefined(findModifier(exportNode, 95 /* ExportKeyword */), "Should find an export keyword in modifier list");
	      switch (exportNode.kind) {
	        case 262 /* FunctionDeclaration */:
	        case 263 /* ClassDeclaration */:
	        case 264 /* InterfaceDeclaration */:
	          changes.insertNodeAfter(exportingSourceFile, exportKeyword, factory.createToken(90 /* DefaultKeyword */));
	          break;
	        case 243 /* VariableStatement */:
	          const decl = first(exportNode.declarationList.declarations);
	          if (!ts_FindAllReferences_exports.Core.isSymbolReferencedInFile(exportName, checker, exportingSourceFile) && !decl.type) {
	            changes.replaceNode(exportingSourceFile, exportNode, factory.createExportDefault(Debug.checkDefined(decl.initializer, "Initializer was previously known to be present")));
	            break;
	          }
	        case 266 /* EnumDeclaration */:
	        case 265 /* TypeAliasDeclaration */:
	        case 267 /* ModuleDeclaration */:
	          changes.deleteModifier(exportingSourceFile, exportKeyword);
	          changes.insertNodeAfter(exportingSourceFile, exportNode, factory.createExportDefault(factory.createIdentifier(exportName.text)));
	          break;
	        default:
	          Debug.fail(`Unexpected exportNode kind ${exportNode.kind}`);
	      }
	    }
	  }
	  function changeImports(program, { wasDefault, exportName, exportingModuleSymbol }, changes, cancellationToken) {
	    const checker = program.getTypeChecker();
	    const exportSymbol = Debug.checkDefined(checker.getSymbolAtLocation(exportName), "Export name should resolve to a symbol");
	    ts_FindAllReferences_exports.Core.eachExportReference(program.getSourceFiles(), checker, cancellationToken, exportSymbol, exportingModuleSymbol, exportName.text, wasDefault, (ref) => {
	      if (exportName === ref)
	        return;
	      const importingSourceFile = ref.getSourceFile();
	      if (wasDefault) {
	        changeDefaultToNamedImport(importingSourceFile, ref, changes, exportName.text);
	      } else {
	        changeNamedToDefaultImport(importingSourceFile, ref, changes);
	      }
	    });
	  }
	  function changeDefaultToNamedImport(importingSourceFile, ref, changes, exportName) {
	    const { parent: parent2 } = ref;
	    switch (parent2.kind) {
	      case 211 /* PropertyAccessExpression */:
	        changes.replaceNode(importingSourceFile, ref, factory.createIdentifier(exportName));
	        break;
	      case 276 /* ImportSpecifier */:
	      case 281 /* ExportSpecifier */: {
	        const spec = parent2;
	        changes.replaceNode(importingSourceFile, spec, makeImportSpecifier(exportName, spec.name.text));
	        break;
	      }
	      case 273 /* ImportClause */: {
	        const clause = parent2;
	        Debug.assert(clause.name === ref, "Import clause name should match provided ref");
	        const spec = makeImportSpecifier(exportName, ref.text);
	        const { namedBindings } = clause;
	        if (!namedBindings) {
	          changes.replaceNode(importingSourceFile, ref, factory.createNamedImports([spec]));
	        } else if (namedBindings.kind === 274 /* NamespaceImport */) {
	          changes.deleteRange(importingSourceFile, { pos: ref.getStart(importingSourceFile), end: namedBindings.getStart(importingSourceFile) });
	          const quotePreference = isStringLiteral(clause.parent.moduleSpecifier) ? quotePreferenceFromString(clause.parent.moduleSpecifier, importingSourceFile) : 1 /* Double */;
	          const newImport = makeImport(
	            /*defaultImport*/
	            void 0,
	            [makeImportSpecifier(exportName, ref.text)],
	            clause.parent.moduleSpecifier,
	            quotePreference
	          );
	          changes.insertNodeAfter(importingSourceFile, clause.parent, newImport);
	        } else {
	          changes.delete(importingSourceFile, ref);
	          changes.insertNodeAtEndOfList(importingSourceFile, namedBindings.elements, spec);
	        }
	        break;
	      }
	      case 205 /* ImportType */:
	        const importTypeNode = parent2;
	        changes.replaceNode(importingSourceFile, parent2, factory.createImportTypeNode(importTypeNode.argument, importTypeNode.attributes, factory.createIdentifier(exportName), importTypeNode.typeArguments, importTypeNode.isTypeOf));
	        break;
	      default:
	        Debug.failBadSyntaxKind(parent2);
	    }
	  }
	  function changeNamedToDefaultImport(importingSourceFile, ref, changes) {
	    const parent2 = ref.parent;
	    switch (parent2.kind) {
	      case 211 /* PropertyAccessExpression */:
	        changes.replaceNode(importingSourceFile, ref, factory.createIdentifier("default"));
	        break;
	      case 276 /* ImportSpecifier */: {
	        const defaultImport = factory.createIdentifier(parent2.name.text);
	        if (parent2.parent.elements.length === 1) {
	          changes.replaceNode(importingSourceFile, parent2.parent, defaultImport);
	        } else {
	          changes.delete(importingSourceFile, parent2);
	          changes.insertNodeBefore(importingSourceFile, parent2.parent, defaultImport);
	        }
	        break;
	      }
	      case 281 /* ExportSpecifier */: {
	        changes.replaceNode(importingSourceFile, parent2, makeExportSpecifier("default", parent2.name.text));
	        break;
	      }
	      default:
	        Debug.assertNever(parent2, `Unexpected parent kind ${parent2.kind}`);
	    }
	  }
	  function makeImportSpecifier(propertyName, name) {
	    return factory.createImportSpecifier(
	      /*isTypeOnly*/
	      false,
	      propertyName === name ? void 0 : factory.createIdentifier(propertyName),
	      factory.createIdentifier(name)
	    );
	  }
	  function makeExportSpecifier(propertyName, name) {
	    return factory.createExportSpecifier(
	      /*isTypeOnly*/
	      false,
	      propertyName === name ? void 0 : factory.createIdentifier(propertyName),
	      factory.createIdentifier(name)
	    );
	  }
	  function getExportingModuleSymbol(parent2, checker) {
	    if (isSourceFile(parent2)) {
	      return parent2.symbol;
	    }
	    const symbol = parent2.parent.symbol;
	    if (symbol.valueDeclaration && isExternalModuleAugmentation(symbol.valueDeclaration)) {
	      return checker.getMergedSymbol(symbol);
	    }
	    return symbol;
	  }
	  var refactorName, defaultToNamedAction, namedToDefaultAction;
	  var init_convertExport = __esm({
	    "src/services/refactors/convertExport.ts"() {
	      init_ts4();
	      init_ts_refactor();
	      refactorName = "Convert export";
	      defaultToNamedAction = {
	        name: "Convert default export to named export",
	        description: getLocaleSpecificMessage(Diagnostics.Convert_default_export_to_named_export),
	        kind: "refactor.rewrite.export.named"
	      };
	      namedToDefaultAction = {
	        name: "Convert named export to default export",
	        description: getLocaleSpecificMessage(Diagnostics.Convert_named_export_to_default_export),
	        kind: "refactor.rewrite.export.default"
	      };
	      registerRefactor(refactorName, {
	        kinds: [
	          defaultToNamedAction.kind,
	          namedToDefaultAction.kind
	        ],
	        getAvailableActions: function getRefactorActionsToConvertBetweenNamedAndDefaultExports(context) {
	          const info = getInfo2(context, context.triggerReason === "invoked");
	          if (!info)
	            return emptyArray;
	          if (!isRefactorErrorInfo(info)) {
	            const action = info.wasDefault ? defaultToNamedAction : namedToDefaultAction;
	            return [{ name: refactorName, description: action.description, actions: [action] }];
	          }
	          if (context.preferences.provideRefactorNotApplicableReason) {
	            return [
	              {
	                name: refactorName,
	                description: getLocaleSpecificMessage(Diagnostics.Convert_default_export_to_named_export),
	                actions: [
	                  { ...defaultToNamedAction, notApplicableReason: info.error },
	                  { ...namedToDefaultAction, notApplicableReason: info.error }
	                ]
	              }
	            ];
	          }
	          return emptyArray;
	        },
	        getEditsForAction: function getRefactorEditsToConvertBetweenNamedAndDefaultExports(context, actionName2) {
	          Debug.assert(actionName2 === defaultToNamedAction.name || actionName2 === namedToDefaultAction.name, "Unexpected action name");
	          const info = getInfo2(context);
	          Debug.assert(info && !isRefactorErrorInfo(info), "Expected applicable refactor info");
	          const edits = ts_textChanges_exports.ChangeTracker.with(context, (t) => doChange(context.file, context.program, info, t, context.cancellationToken));
	          return { edits, renameFilename: void 0, renameLocation: void 0 };
	        }
	      });
	    }
	  });

	  // src/services/refactors/convertImport.ts
	  function getImportConversionInfo(context, considerPartialSpans = true) {
	    const { file } = context;
	    const span = getRefactorContextSpan(context);
	    const token = getTokenAtPosition(file, span.start);
	    const importDecl = considerPartialSpans ? findAncestor(token, isImportDeclaration) : getParentNodeInSpan(token, file, span);
	    if (!importDecl || !isImportDeclaration(importDecl))
	      return { error: "Selection is not an import declaration." };
	    const end = span.start + span.length;
	    const nextToken = findNextToken(importDecl, importDecl.parent, file);
	    if (nextToken && end > nextToken.getStart())
	      return void 0;
	    const { importClause } = importDecl;
	    if (!importClause) {
	      return { error: getLocaleSpecificMessage(Diagnostics.Could_not_find_import_clause) };
	    }
	    if (!importClause.namedBindings) {
	      return { error: getLocaleSpecificMessage(Diagnostics.Could_not_find_namespace_import_or_named_imports) };
	    }
	    if (importClause.namedBindings.kind === 274 /* NamespaceImport */) {
	      return { convertTo: 0 /* Named */, import: importClause.namedBindings };
	    }
	    const shouldUseDefault = getShouldUseDefault(context.program, importClause);
	    return shouldUseDefault ? { convertTo: 1 /* Default */, import: importClause.namedBindings } : { convertTo: 2 /* Namespace */, import: importClause.namedBindings };
	  }
	  function getShouldUseDefault(program, importClause) {
	    return getAllowSyntheticDefaultImports(program.getCompilerOptions()) && isExportEqualsModule(importClause.parent.moduleSpecifier, program.getTypeChecker());
	  }
	  function doChange2(sourceFile, program, changes, info) {
	    const checker = program.getTypeChecker();
	    if (info.convertTo === 0 /* Named */) {
	      doChangeNamespaceToNamed(sourceFile, checker, changes, info.import, getAllowSyntheticDefaultImports(program.getCompilerOptions()));
	    } else {
	      doChangeNamedToNamespaceOrDefault(sourceFile, program, changes, info.import, info.convertTo === 1 /* Default */);
	    }
	  }
	  function doChangeNamespaceToNamed(sourceFile, checker, changes, toConvert, allowSyntheticDefaultImports) {
	    let usedAsNamespaceOrDefault = false;
	    const nodesToReplace = [];
	    const conflictingNames = /* @__PURE__ */ new Map();
	    ts_FindAllReferences_exports.Core.eachSymbolReferenceInFile(toConvert.name, checker, sourceFile, (id) => {
	      if (!isPropertyAccessOrQualifiedName(id.parent)) {
	        usedAsNamespaceOrDefault = true;
	      } else {
	        const exportName = getRightOfPropertyAccessOrQualifiedName(id.parent).text;
	        if (checker.resolveName(
	          exportName,
	          id,
	          -1 /* All */,
	          /*excludeGlobals*/
	          true
	        )) {
	          conflictingNames.set(exportName, true);
	        }
	        Debug.assert(getLeftOfPropertyAccessOrQualifiedName(id.parent) === id, "Parent expression should match id");
	        nodesToReplace.push(id.parent);
	      }
	    });
	    const exportNameToImportName = /* @__PURE__ */ new Map();
	    for (const propertyAccessOrQualifiedName of nodesToReplace) {
	      const exportName = getRightOfPropertyAccessOrQualifiedName(propertyAccessOrQualifiedName).text;
	      let importName = exportNameToImportName.get(exportName);
	      if (importName === void 0) {
	        exportNameToImportName.set(exportName, importName = conflictingNames.has(exportName) ? getUniqueName(exportName, sourceFile) : exportName);
	      }
	      changes.replaceNode(sourceFile, propertyAccessOrQualifiedName, factory.createIdentifier(importName));
	    }
	    const importSpecifiers = [];
	    exportNameToImportName.forEach((name, propertyName) => {
	      importSpecifiers.push(factory.createImportSpecifier(
	        /*isTypeOnly*/
	        false,
	        name === propertyName ? void 0 : factory.createIdentifier(propertyName),
	        factory.createIdentifier(name)
	      ));
	    });
	    const importDecl = toConvert.parent.parent;
	    if (usedAsNamespaceOrDefault && !allowSyntheticDefaultImports) {
	      changes.insertNodeAfter(sourceFile, importDecl, updateImport(
	        importDecl,
	        /*defaultImportName*/
	        void 0,
	        importSpecifiers
	      ));
	    } else {
	      changes.replaceNode(sourceFile, importDecl, updateImport(importDecl, usedAsNamespaceOrDefault ? factory.createIdentifier(toConvert.name.text) : void 0, importSpecifiers));
	    }
	  }
	  function getRightOfPropertyAccessOrQualifiedName(propertyAccessOrQualifiedName) {
	    return isPropertyAccessExpression(propertyAccessOrQualifiedName) ? propertyAccessOrQualifiedName.name : propertyAccessOrQualifiedName.right;
	  }
	  function getLeftOfPropertyAccessOrQualifiedName(propertyAccessOrQualifiedName) {
	    return isPropertyAccessExpression(propertyAccessOrQualifiedName) ? propertyAccessOrQualifiedName.expression : propertyAccessOrQualifiedName.left;
	  }
	  function doChangeNamedToNamespaceOrDefault(sourceFile, program, changes, toConvert, shouldUseDefault = getShouldUseDefault(program, toConvert.parent)) {
	    const checker = program.getTypeChecker();
	    const importDecl = toConvert.parent.parent;
	    const { moduleSpecifier } = importDecl;
	    const toConvertSymbols = /* @__PURE__ */ new Set();
	    toConvert.elements.forEach((namedImport) => {
	      const symbol = checker.getSymbolAtLocation(namedImport.name);
	      if (symbol) {
	        toConvertSymbols.add(symbol);
	      }
	    });
	    const preferredName = moduleSpecifier && isStringLiteral(moduleSpecifier) ? ts_codefix_exports.moduleSpecifierToValidIdentifier(moduleSpecifier.text, 99 /* ESNext */) : "module";
	    function hasNamespaceNameConflict(namedImport) {
	      return !!ts_FindAllReferences_exports.Core.eachSymbolReferenceInFile(namedImport.name, checker, sourceFile, (id) => {
	        const symbol = checker.resolveName(
	          preferredName,
	          id,
	          -1 /* All */,
	          /*excludeGlobals*/
	          true
	        );
	        if (symbol) {
	          if (toConvertSymbols.has(symbol)) {
	            return isExportSpecifier(id.parent);
	          }
	          return true;
	        }
	        return false;
	      });
	    }
	    const namespaceNameConflicts = toConvert.elements.some(hasNamespaceNameConflict);
	    const namespaceImportName = namespaceNameConflicts ? getUniqueName(preferredName, sourceFile) : preferredName;
	    const neededNamedImports = /* @__PURE__ */ new Set();
	    for (const element of toConvert.elements) {
	      const propertyName = (element.propertyName || element.name).text;
	      ts_FindAllReferences_exports.Core.eachSymbolReferenceInFile(element.name, checker, sourceFile, (id) => {
	        const access = factory.createPropertyAccessExpression(factory.createIdentifier(namespaceImportName), propertyName);
	        if (isShorthandPropertyAssignment(id.parent)) {
	          changes.replaceNode(sourceFile, id.parent, factory.createPropertyAssignment(id.text, access));
	        } else if (isExportSpecifier(id.parent)) {
	          neededNamedImports.add(element);
	        } else {
	          changes.replaceNode(sourceFile, id, access);
	        }
	      });
	    }
	    changes.replaceNode(
	      sourceFile,
	      toConvert,
	      shouldUseDefault ? factory.createIdentifier(namespaceImportName) : factory.createNamespaceImport(factory.createIdentifier(namespaceImportName))
	    );
	    if (neededNamedImports.size) {
	      const newNamedImports = arrayFrom(neededNamedImports.values(), (element) => factory.createImportSpecifier(element.isTypeOnly, element.propertyName && factory.createIdentifier(element.propertyName.text), factory.createIdentifier(element.name.text)));
	      changes.insertNodeAfter(sourceFile, toConvert.parent.parent, updateImport(
	        importDecl,
	        /*defaultImportName*/
	        void 0,
	        newNamedImports
	      ));
	    }
	  }
	  function isExportEqualsModule(moduleSpecifier, checker) {
	    const externalModule = checker.resolveExternalModuleName(moduleSpecifier);
	    if (!externalModule)
	      return false;
	    const exportEquals = checker.resolveExternalModuleSymbol(externalModule);
	    return externalModule !== exportEquals;
	  }
	  function updateImport(old, defaultImportName, elements) {
	    return factory.createImportDeclaration(
	      /*modifiers*/
	      void 0,
	      factory.createImportClause(
	        /*isTypeOnly*/
	        false,
	        defaultImportName,
	        elements && elements.length ? factory.createNamedImports(elements) : void 0
	      ),
	      old.moduleSpecifier,
	      /*attributes*/
	      void 0
	    );
	  }
	  var refactorName2, actions;
	  var init_convertImport = __esm({
	    "src/services/refactors/convertImport.ts"() {
	      init_ts4();
	      init_ts_refactor();
	      refactorName2 = "Convert import";
	      actions = {
	        [0 /* Named */]: {
	          name: "Convert namespace import to named imports",
	          description: getLocaleSpecificMessage(Diagnostics.Convert_namespace_import_to_named_imports),
	          kind: "refactor.rewrite.import.named"
	        },
	        [2 /* Namespace */]: {
	          name: "Convert named imports to namespace import",
	          description: getLocaleSpecificMessage(Diagnostics.Convert_named_imports_to_namespace_import),
	          kind: "refactor.rewrite.import.namespace"
	        },
	        [1 /* Default */]: {
	          name: "Convert named imports to default import",
	          description: getLocaleSpecificMessage(Diagnostics.Convert_named_imports_to_default_import),
	          kind: "refactor.rewrite.import.default"
	        }
	      };
	      registerRefactor(refactorName2, {
	        kinds: getOwnValues(actions).map((a) => a.kind),
	        getAvailableActions: function getRefactorActionsToConvertBetweenNamedAndNamespacedImports(context) {
	          const info = getImportConversionInfo(context, context.triggerReason === "invoked");
	          if (!info)
	            return emptyArray;
	          if (!isRefactorErrorInfo(info)) {
	            const action = actions[info.convertTo];
	            return [{ name: refactorName2, description: action.description, actions: [action] }];
	          }
	          if (context.preferences.provideRefactorNotApplicableReason) {
	            return getOwnValues(actions).map((action) => ({
	              name: refactorName2,
	              description: action.description,
	              actions: [{ ...action, notApplicableReason: info.error }]
	            }));
	          }
	          return emptyArray;
	        },
	        getEditsForAction: function getRefactorEditsToConvertBetweenNamedAndNamespacedImports(context, actionName2) {
	          Debug.assert(some(getOwnValues(actions), (action) => action.name === actionName2), "Unexpected action name");
	          const info = getImportConversionInfo(context);
	          Debug.assert(info && !isRefactorErrorInfo(info), "Expected applicable refactor info");
	          const edits = ts_textChanges_exports.ChangeTracker.with(context, (t) => doChange2(context.file, context.program, t, info));
	          return { edits, renameFilename: void 0, renameLocation: void 0 };
	        }
	      });
	    }
	  });

	  // src/services/refactors/extractType.ts
	  function getRangeToExtract(context, considerEmptySpans = true) {
	    const { file, startPosition } = context;
	    const isJS = isSourceFileJS(file);
	    const range = createTextRangeFromSpan(getRefactorContextSpan(context));
	    const isCursorRequest = range.pos === range.end && considerEmptySpans;
	    const firstType = getFirstTypeAt(file, startPosition, range, isCursorRequest);
	    if (!firstType || !isTypeNode(firstType))
	      return { error: getLocaleSpecificMessage(Diagnostics.Selection_is_not_a_valid_type_node) };
	    const checker = context.program.getTypeChecker();
	    const enclosingNode = getEnclosingNode(firstType, isJS);
	    if (enclosingNode === void 0)
	      return { error: getLocaleSpecificMessage(Diagnostics.No_type_could_be_extracted_from_this_type_node) };
	    const expandedFirstType = getExpandedSelectionNode(firstType, enclosingNode);
	    if (!isTypeNode(expandedFirstType))
	      return { error: getLocaleSpecificMessage(Diagnostics.Selection_is_not_a_valid_type_node) };
	    const typeList = [];
	    if ((isUnionTypeNode(expandedFirstType.parent) || isIntersectionTypeNode(expandedFirstType.parent)) && range.end > firstType.end) {
	      addRange(
	        typeList,
	        expandedFirstType.parent.types.filter((type) => {
	          return nodeOverlapsWithStartEnd(type, file, range.pos, range.end);
	        })
	      );
	    }
	    const selection = typeList.length > 1 ? typeList : expandedFirstType;
	    const typeParameters = collectTypeParameters(checker, selection, enclosingNode, file);
	    if (!typeParameters)
	      return { error: getLocaleSpecificMessage(Diagnostics.No_type_could_be_extracted_from_this_type_node) };
	    const typeElements = flattenTypeLiteralNodeReference(checker, selection);
	    return { isJS, selection, enclosingNode, typeParameters, typeElements };
	  }
	  function getFirstTypeAt(file, startPosition, range, isCursorRequest) {
	    const currentNodes = [
	      () => getTokenAtPosition(file, startPosition),
	      () => getTouchingToken(file, startPosition, () => true)
	    ];
	    for (const f of currentNodes) {
	      const current = f();
	      const overlappingRange = nodeOverlapsWithStartEnd(current, file, range.pos, range.end);
	      const firstType = findAncestor(current, (node) => node.parent && isTypeNode(node) && !rangeContainsSkipTrivia(range, node.parent, file) && (isCursorRequest || overlappingRange));
	      if (firstType) {
	        return firstType;
	      }
	    }
	    return void 0;
	  }
	  function flattenTypeLiteralNodeReference(checker, selection) {
	    if (!selection)
	      return void 0;
	    if (isArray(selection)) {
	      const result = [];
	      for (const type of selection) {
	        const flattenedTypeMembers = flattenTypeLiteralNodeReference(checker, type);
	        if (!flattenedTypeMembers)
	          return void 0;
	        addRange(result, flattenedTypeMembers);
	      }
	      return result;
	    }
	    if (isIntersectionTypeNode(selection)) {
	      const result = [];
	      const seen = /* @__PURE__ */ new Map();
	      for (const type of selection.types) {
	        const flattenedTypeMembers = flattenTypeLiteralNodeReference(checker, type);
	        if (!flattenedTypeMembers || !flattenedTypeMembers.every((type2) => type2.name && addToSeen(seen, getNameFromPropertyName(type2.name)))) {
	          return void 0;
	        }
	        addRange(result, flattenedTypeMembers);
	      }
	      return result;
	    } else if (isParenthesizedTypeNode(selection)) {
	      return flattenTypeLiteralNodeReference(checker, selection.type);
	    } else if (isTypeLiteralNode(selection)) {
	      return selection.members;
	    }
	    return void 0;
	  }
	  function rangeContainsSkipTrivia(r1, node, file) {
	    return rangeContainsStartEnd(r1, skipTrivia(file.text, node.pos), node.end);
	  }
	  function collectTypeParameters(checker, selection, enclosingNode, file) {
	    const result = [];
	    const selectionArray = toArray(selection);
	    const selectionRange = { pos: selectionArray[0].pos, end: selectionArray[selectionArray.length - 1].end };
	    for (const t of selectionArray) {
	      if (visitor(t))
	        return void 0;
	    }
	    return result;
	    function visitor(node) {
	      if (isTypeReferenceNode(node)) {
	        if (isIdentifier(node.typeName)) {
	          const typeName = node.typeName;
	          const symbol = checker.resolveName(
	            typeName.text,
	            typeName,
	            262144 /* TypeParameter */,
	            /*excludeGlobals*/
	            true
	          );
	          for (const decl of (symbol == null ? void 0 : symbol.declarations) || emptyArray) {
	            if (isTypeParameterDeclaration(decl) && decl.getSourceFile() === file) {
	              if (decl.name.escapedText === typeName.escapedText && rangeContainsSkipTrivia(decl, selectionRange, file)) {
	                return true;
	              }
	              if (rangeContainsSkipTrivia(enclosingNode, decl, file) && !rangeContainsSkipTrivia(selectionRange, decl, file)) {
	                pushIfUnique(result, decl);
	                break;
	              }
	            }
	          }
	        }
	      } else if (isInferTypeNode(node)) {
	        const conditionalTypeNode = findAncestor(node, (n) => isConditionalTypeNode(n) && rangeContainsSkipTrivia(n.extendsType, node, file));
	        if (!conditionalTypeNode || !rangeContainsSkipTrivia(selectionRange, conditionalTypeNode, file)) {
	          return true;
	        }
	      } else if (isTypePredicateNode(node) || isThisTypeNode(node)) {
	        const functionLikeNode = findAncestor(node.parent, isFunctionLike);
	        if (functionLikeNode && functionLikeNode.type && rangeContainsSkipTrivia(functionLikeNode.type, node, file) && !rangeContainsSkipTrivia(selectionRange, functionLikeNode, file)) {
	          return true;
	        }
	      } else if (isTypeQueryNode(node)) {
	        if (isIdentifier(node.exprName)) {
	          const symbol = checker.resolveName(
	            node.exprName.text,
	            node.exprName,
	            111551 /* Value */,
	            /*excludeGlobals*/
	            false
	          );
	          if ((symbol == null ? void 0 : symbol.valueDeclaration) && rangeContainsSkipTrivia(enclosingNode, symbol.valueDeclaration, file) && !rangeContainsSkipTrivia(selectionRange, symbol.valueDeclaration, file)) {
	            return true;
	          }
	        } else {
	          if (isThisIdentifier(node.exprName.left) && !rangeContainsSkipTrivia(selectionRange, node.parent, file)) {
	            return true;
	          }
	        }
	      }
	      if (file && isTupleTypeNode(node) && getLineAndCharacterOfPosition(file, node.pos).line === getLineAndCharacterOfPosition(file, node.end).line) {
	        setEmitFlags(node, 1 /* SingleLine */);
	      }
	      return forEachChild(node, visitor);
	    }
	  }
	  function doTypeAliasChange(changes, file, name, info) {
	    const { enclosingNode, typeParameters } = info;
	    const { firstTypeNode, lastTypeNode, newTypeNode } = getNodesToEdit(info);
	    const newTypeDeclaration = factory.createTypeAliasDeclaration(
	      /*modifiers*/
	      void 0,
	      name,
	      typeParameters.map((id) => factory.updateTypeParameterDeclaration(
	        id,
	        id.modifiers,
	        id.name,
	        id.constraint,
	        /*defaultType*/
	        void 0
	      )),
	      newTypeNode
	    );
	    changes.insertNodeBefore(
	      file,
	      enclosingNode,
	      ignoreSourceNewlines(newTypeDeclaration),
	      /*blankLineBetween*/
	      true
	    );
	    changes.replaceNodeRange(file, firstTypeNode, lastTypeNode, factory.createTypeReferenceNode(name, typeParameters.map((id) => factory.createTypeReferenceNode(
	      id.name,
	      /*typeArguments*/
	      void 0
	    ))), { leadingTriviaOption: ts_textChanges_exports.LeadingTriviaOption.Exclude, trailingTriviaOption: ts_textChanges_exports.TrailingTriviaOption.ExcludeWhitespace });
	  }
	  function doInterfaceChange(changes, file, name, info) {
	    var _a;
	    const { enclosingNode, typeParameters, typeElements } = info;
	    const newTypeNode = factory.createInterfaceDeclaration(
	      /*modifiers*/
	      void 0,
	      name,
	      typeParameters,
	      /*heritageClauses*/
	      void 0,
	      typeElements
	    );
	    setTextRange(newTypeNode, (_a = typeElements[0]) == null ? void 0 : _a.parent);
	    changes.insertNodeBefore(
	      file,
	      enclosingNode,
	      ignoreSourceNewlines(newTypeNode),
	      /*blankLineBetween*/
	      true
	    );
	    const { firstTypeNode, lastTypeNode } = getNodesToEdit(info);
	    changes.replaceNodeRange(file, firstTypeNode, lastTypeNode, factory.createTypeReferenceNode(name, typeParameters.map((id) => factory.createTypeReferenceNode(
	      id.name,
	      /*typeArguments*/
	      void 0
	    ))), { leadingTriviaOption: ts_textChanges_exports.LeadingTriviaOption.Exclude, trailingTriviaOption: ts_textChanges_exports.TrailingTriviaOption.ExcludeWhitespace });
	  }
	  function doTypedefChange(changes, context, file, name, info) {
	    var _a;
	    toArray(info.selection).forEach((typeNode) => {
	      setEmitFlags(typeNode, 3072 /* NoComments */ | 4096 /* NoNestedComments */);
	    });
	    const { enclosingNode, typeParameters } = info;
	    const { firstTypeNode, lastTypeNode, newTypeNode } = getNodesToEdit(info);
	    const node = factory.createJSDocTypedefTag(
	      factory.createIdentifier("typedef"),
	      factory.createJSDocTypeExpression(newTypeNode),
	      factory.createIdentifier(name)
	    );
	    const templates = [];
	    forEach(typeParameters, (typeParameter) => {
	      const constraint = getEffectiveConstraintOfTypeParameter(typeParameter);
	      const parameter = factory.createTypeParameterDeclaration(
	        /*modifiers*/
	        void 0,
	        typeParameter.name
	      );
	      const template = factory.createJSDocTemplateTag(
	        factory.createIdentifier("template"),
	        constraint && cast(constraint, isJSDocTypeExpression),
	        [parameter]
	      );
	      templates.push(template);
	    });
	    const jsDoc = factory.createJSDocComment(
	      /*comment*/
	      void 0,
	      factory.createNodeArray(concatenate(templates, [node]))
	    );
	    if (isJSDoc(enclosingNode)) {
	      const pos = enclosingNode.getStart(file);
	      const newLineCharacter = getNewLineOrDefaultFromHost(context.host, (_a = context.formatContext) == null ? void 0 : _a.options);
	      changes.insertNodeAt(file, enclosingNode.getStart(file), jsDoc, {
	        suffix: newLineCharacter + newLineCharacter + file.text.slice(getPrecedingNonSpaceCharacterPosition(file.text, pos - 1), pos)
	      });
	    } else {
	      changes.insertNodeBefore(
	        file,
	        enclosingNode,
	        jsDoc,
	        /*blankLineBetween*/
	        true
	      );
	    }
	    changes.replaceNodeRange(file, firstTypeNode, lastTypeNode, factory.createTypeReferenceNode(name, typeParameters.map((id) => factory.createTypeReferenceNode(
	      id.name,
	      /*typeArguments*/
	      void 0
	    ))));
	  }
	  function getNodesToEdit(info) {
	    if (isArray(info.selection)) {
	      return {
	        firstTypeNode: info.selection[0],
	        lastTypeNode: info.selection[info.selection.length - 1],
	        newTypeNode: isUnionTypeNode(info.selection[0].parent) ? factory.createUnionTypeNode(info.selection) : factory.createIntersectionTypeNode(info.selection)
	      };
	    }
	    return {
	      firstTypeNode: info.selection,
	      lastTypeNode: info.selection,
	      newTypeNode: info.selection
	    };
	  }
	  function getEnclosingNode(node, isJS) {
	    return findAncestor(node, isStatement) || (isJS ? findAncestor(node, isJSDoc) : void 0);
	  }
	  function getExpandedSelectionNode(firstType, enclosingNode) {
	    return findAncestor(firstType, (node) => {
	      if (node === enclosingNode)
	        return "quit";
	      if (isUnionTypeNode(node.parent) || isIntersectionTypeNode(node.parent)) {
	        return true;
	      }
	      return false;
	    }) ?? firstType;
	  }
	  var refactorName3, extractToTypeAliasAction, extractToInterfaceAction, extractToTypeDefAction;
	  var init_extractType = __esm({
	    "src/services/refactors/extractType.ts"() {
	      init_ts4();
	      init_ts_refactor();
	      refactorName3 = "Extract type";
	      extractToTypeAliasAction = {
	        name: "Extract to type alias",
	        description: getLocaleSpecificMessage(Diagnostics.Extract_to_type_alias),
	        kind: "refactor.extract.type"
	      };
	      extractToInterfaceAction = {
	        name: "Extract to interface",
	        description: getLocaleSpecificMessage(Diagnostics.Extract_to_interface),
	        kind: "refactor.extract.interface"
	      };
	      extractToTypeDefAction = {
	        name: "Extract to typedef",
	        description: getLocaleSpecificMessage(Diagnostics.Extract_to_typedef),
	        kind: "refactor.extract.typedef"
	      };
	      registerRefactor(refactorName3, {
	        kinds: [
	          extractToTypeAliasAction.kind,
	          extractToInterfaceAction.kind,
	          extractToTypeDefAction.kind
	        ],
	        getAvailableActions: function getRefactorActionsToExtractType(context) {
	          const info = getRangeToExtract(context, context.triggerReason === "invoked");
	          if (!info)
	            return emptyArray;
	          if (!isRefactorErrorInfo(info)) {
	            return [{
	              name: refactorName3,
	              description: getLocaleSpecificMessage(Diagnostics.Extract_type),
	              actions: info.isJS ? [extractToTypeDefAction] : append([extractToTypeAliasAction], info.typeElements && extractToInterfaceAction)
	            }];
	          }
	          if (context.preferences.provideRefactorNotApplicableReason) {
	            return [{
	              name: refactorName3,
	              description: getLocaleSpecificMessage(Diagnostics.Extract_type),
	              actions: [
	                { ...extractToTypeDefAction, notApplicableReason: info.error },
	                { ...extractToTypeAliasAction, notApplicableReason: info.error },
	                { ...extractToInterfaceAction, notApplicableReason: info.error }
	              ]
	            }];
	          }
	          return emptyArray;
	        },
	        getEditsForAction: function getRefactorEditsToExtractType(context, actionName2) {
	          const { file } = context;
	          const info = getRangeToExtract(context);
	          Debug.assert(info && !isRefactorErrorInfo(info), "Expected to find a range to extract");
	          const name = getUniqueName("NewType", file);
	          const edits = ts_textChanges_exports.ChangeTracker.with(context, (changes) => {
	            switch (actionName2) {
	              case extractToTypeAliasAction.name:
	                Debug.assert(!info.isJS, "Invalid actionName/JS combo");
	                return doTypeAliasChange(changes, file, name, info);
	              case extractToTypeDefAction.name:
	                Debug.assert(info.isJS, "Invalid actionName/JS combo");
	                return doTypedefChange(changes, context, file, name, info);
	              case extractToInterfaceAction.name:
	                Debug.assert(!info.isJS && !!info.typeElements, "Invalid actionName/JS combo");
	                return doInterfaceChange(changes, file, name, info);
	              default:
	                Debug.fail("Unexpected action name");
	            }
	          });
	          const renameFilename = file.fileName;
	          const renameLocation = getRenameLocation(
	            edits,
	            renameFilename,
	            name,
	            /*preferLastLocation*/
	            false
	          );
	          return { edits, renameFilename, renameLocation };
	        }
	      });
	    }
	  });

	  // src/services/refactors/helpers.ts
	  function isRefactorErrorInfo(info) {
	    return info.error !== void 0;
	  }
	  function refactorKindBeginsWith(known, requested) {
	    if (!requested)
	      return true;
	    return known.substr(0, requested.length) === requested;
	  }
	  var init_helpers = __esm({
	    "src/services/refactors/helpers.ts"() {
	    }
	  });

	  // src/services/refactors/inlineVariable.ts
	  function getInliningInfo(file, startPosition, tryWithReferenceToken, program) {
	    var _a, _b;
	    const checker = program.getTypeChecker();
	    const token = getTouchingPropertyName(file, startPosition);
	    const parent2 = token.parent;
	    if (!isIdentifier(token)) {
	      return void 0;
	    }
	    if (isInitializedVariable(parent2) && isVariableDeclarationInVariableStatement(parent2) && isIdentifier(parent2.name)) {
	      if (((_a = checker.getMergedSymbol(parent2.symbol).declarations) == null ? void 0 : _a.length) !== 1) {
	        return { error: getLocaleSpecificMessage(Diagnostics.Variables_with_multiple_declarations_cannot_be_inlined) };
	      }
	      if (isDeclarationExported(parent2)) {
	        return void 0;
	      }
	      const references = getReferenceNodes(parent2, checker, file);
	      return references && { references, declaration: parent2, replacement: parent2.initializer };
	    }
	    if (tryWithReferenceToken) {
	      let definition = checker.resolveName(
	        token.text,
	        token,
	        111551 /* Value */,
	        /*excludeGlobals*/
	        false
	      );
	      definition = definition && checker.getMergedSymbol(definition);
	      if (((_b = definition == null ? void 0 : definition.declarations) == null ? void 0 : _b.length) !== 1) {
	        return { error: getLocaleSpecificMessage(Diagnostics.Variables_with_multiple_declarations_cannot_be_inlined) };
	      }
	      const declaration = definition.declarations[0];
	      if (!isInitializedVariable(declaration) || !isVariableDeclarationInVariableStatement(declaration) || !isIdentifier(declaration.name)) {
	        return void 0;
	      }
	      if (isDeclarationExported(declaration)) {
	        return void 0;
	      }
	      const references = getReferenceNodes(declaration, checker, file);
	      return references && { references, declaration, replacement: declaration.initializer };
	    }
	    return { error: getLocaleSpecificMessage(Diagnostics.Could_not_find_variable_to_inline) };
	  }
	  function isDeclarationExported(declaration) {
	    const variableStatement = cast(declaration.parent.parent, isVariableStatement);
	    return some(variableStatement.modifiers, isExportModifier);
	  }
	  function getReferenceNodes(declaration, checker, file) {
	    const references = [];
	    const cannotInline = ts_FindAllReferences_exports.Core.eachSymbolReferenceInFile(declaration.name, checker, file, (ref) => {
	      if (ts_FindAllReferences_exports.isWriteAccessForReference(ref) && !isShorthandPropertyAssignment(ref.parent)) {
	        return true;
	      }
	      if (isExportSpecifier(ref.parent) || isExportAssignment(ref.parent)) {
	        return true;
	      }
	      if (isTypeQueryNode(ref.parent)) {
	        return true;
	      }
	      if (textRangeContainsPositionInclusive(declaration, ref.pos)) {
	        return true;
	      }
	      references.push(ref);
	    });
	    return references.length === 0 || cannotInline ? void 0 : references;
	  }
	  function getReplacementExpression(reference, replacement) {
	    replacement = getSynthesizedDeepClone(replacement);
	    const { parent: parent2 } = reference;
	    if (isExpression(parent2) && (getExpressionPrecedence(replacement) < getExpressionPrecedence(parent2) || needsParentheses(parent2))) {
	      return factory.createParenthesizedExpression(replacement);
	    }
	    if (isFunctionLike(replacement) && (isCallLikeExpression(parent2) || isPropertyAccessExpression(parent2))) {
	      return factory.createParenthesizedExpression(replacement);
	    }
	    if (isPropertyAccessExpression(parent2) && (isNumericLiteral(replacement) || isObjectLiteralExpression(replacement))) {
	      return factory.createParenthesizedExpression(replacement);
	    }
	    if (isIdentifier(reference) && isShorthandPropertyAssignment(parent2)) {
	      return factory.createPropertyAssignment(reference, replacement);
	    }
	    return replacement;
	  }
	  var refactorName4, refactorDescription, inlineVariableAction;
	  var init_inlineVariable = __esm({
	    "src/services/refactors/inlineVariable.ts"() {
	      init_ts4();
	      init_ts_refactor();
	      refactorName4 = "Inline variable";
	      refactorDescription = getLocaleSpecificMessage(Diagnostics.Inline_variable);
	      inlineVariableAction = {
	        name: refactorName4,
	        description: refactorDescription,
	        kind: "refactor.inline.variable"
	      };
	      registerRefactor(refactorName4, {
	        kinds: [inlineVariableAction.kind],
	        getAvailableActions(context) {
	          const {
	            file,
	            program,
	            preferences,
	            startPosition,
	            triggerReason
	          } = context;
	          const info = getInliningInfo(file, startPosition, triggerReason === "invoked", program);
	          if (!info) {
	            return emptyArray;
	          }
	          if (!ts_refactor_exports.isRefactorErrorInfo(info)) {
	            return [{
	              name: refactorName4,
	              description: refactorDescription,
	              actions: [inlineVariableAction]
	            }];
	          }
	          if (preferences.provideRefactorNotApplicableReason) {
	            return [{
	              name: refactorName4,
	              description: refactorDescription,
	              actions: [{
	                ...inlineVariableAction,
	                notApplicableReason: info.error
	              }]
	            }];
	          }
	          return emptyArray;
	        },
	        getEditsForAction(context, actionName2) {
	          Debug.assert(actionName2 === refactorName4, "Unexpected refactor invoked");
	          const { file, program, startPosition } = context;
	          const info = getInliningInfo(
	            file,
	            startPosition,
	            /*tryWithReferenceToken*/
	            true,
	            program
	          );
	          if (!info || ts_refactor_exports.isRefactorErrorInfo(info)) {
	            return void 0;
	          }
	          const { references, declaration, replacement } = info;
	          const edits = ts_textChanges_exports.ChangeTracker.with(context, (tracker) => {
	            for (const node of references) {
	              tracker.replaceNode(file, node, getReplacementExpression(node, replacement));
	            }
	            tracker.delete(file, declaration);
	          });
	          return { edits };
	        }
	      });
	    }
	  });

	  // src/services/refactors/moveToNewFile.ts
	  function doChange3(oldFile, program, toMove, changes, host, preferences) {
	    const checker = program.getTypeChecker();
	    const usage = getUsageInfo(oldFile, toMove.all, checker);
	    const newFilename = createNewFileName(oldFile, program, host, toMove);
	    changes.createNewFile(oldFile, newFilename, getNewStatementsAndRemoveFromOldFile(oldFile, usage, changes, toMove, program, host, newFilename, preferences));
	    addNewFileToTsconfig(program, changes, oldFile.fileName, newFilename, hostGetCanonicalFileName(host));
	  }
	  function getNewStatementsAndRemoveFromOldFile(oldFile, usage, changes, toMove, program, host, newFilename, preferences) {
	    const checker = program.getTypeChecker();
	    const prologueDirectives = takeWhile(oldFile.statements, isPrologueDirective);
	    if (oldFile.externalModuleIndicator === void 0 && oldFile.commonJsModuleIndicator === void 0 && usage.oldImportsNeededByTargetFile.size === 0) {
	      deleteMovedStatements(oldFile, toMove.ranges, changes);
	      return [...prologueDirectives, ...toMove.all];
	    }
	    const useEsModuleSyntax = !fileShouldUseJavaScriptRequire(newFilename, program, host, !!oldFile.commonJsModuleIndicator);
	    const quotePreference = getQuotePreference(oldFile, preferences);
	    const importsFromNewFile = createOldFileImportsFromTargetFile(oldFile, usage.oldFileImportsFromTargetFile, newFilename, program, host, useEsModuleSyntax, quotePreference);
	    if (importsFromNewFile) {
	      insertImports(
	        changes,
	        oldFile,
	        importsFromNewFile,
	        /*blankLineBetween*/
	        true,
	        preferences
	      );
	    }
	    deleteUnusedOldImports(oldFile, toMove.all, changes, usage.unusedImportsFromOldFile, checker);
	    deleteMovedStatements(oldFile, toMove.ranges, changes);
	    updateImportsInOtherFiles(changes, program, host, oldFile, usage.movedSymbols, newFilename, quotePreference);
	    const imports = getNewFileImportsAndAddExportInOldFile(oldFile, usage.oldImportsNeededByTargetFile, usage.targetFileImportsFromOldFile, changes, checker, program, host, useEsModuleSyntax, quotePreference);
	    const body = addExports(oldFile, toMove.all, usage.oldFileImportsFromTargetFile, useEsModuleSyntax);
	    if (imports.length && body.length) {
	      return [
	        ...prologueDirectives,
	        ...imports,
	        4 /* NewLineTrivia */,
	        ...body
	      ];
	    }
	    return [
	      ...prologueDirectives,
	      ...imports,
	      ...body
	    ];
	  }
	  function getNewFileImportsAndAddExportInOldFile(oldFile, importsToCopy, newFileImportsFromOldFile, changes, checker, program, host, useEsModuleSyntax, quotePreference) {
	    const copiedOldImports = [];
	    for (const oldStatement of oldFile.statements) {
	      forEachImportInStatement(oldStatement, (i) => {
	        append(copiedOldImports, filterImport(i, moduleSpecifierFromImport(i), (name) => importsToCopy.has(checker.getSymbolAtLocation(name))));
	      });
	    }
	    let oldFileDefault;
	    const oldFileNamedImports = [];
	    const markSeenTop = nodeSeenTracker();
	    newFileImportsFromOldFile.forEach((symbol) => {
	      if (!symbol.declarations) {
	        return;
	      }
	      for (const decl of symbol.declarations) {
	        if (!isTopLevelDeclaration(decl))
	          continue;
	        const name = nameOfTopLevelDeclaration(decl);
	        if (!name)
	          continue;
	        const top = getTopLevelDeclarationStatement(decl);
	        if (markSeenTop(top)) {
	          addExportToChanges(oldFile, top, name, changes, useEsModuleSyntax);
	        }
	        if (hasSyntacticModifier(decl, 2048 /* Default */)) {
	          oldFileDefault = name;
	        } else {
	          oldFileNamedImports.push(name.text);
	        }
	      }
	    });
	    append(copiedOldImports, makeImportOrRequire(oldFile, oldFileDefault, oldFileNamedImports, getBaseFileName(oldFile.fileName), program, host, useEsModuleSyntax, quotePreference));
	    return copiedOldImports;
	  }
	  var refactorName5, description, moveToNewFileAction;
	  var init_moveToNewFile = __esm({
	    "src/services/refactors/moveToNewFile.ts"() {
	      init_ts4();
	      init_ts_refactor();
	      refactorName5 = "Move to a new file";
	      description = getLocaleSpecificMessage(Diagnostics.Move_to_a_new_file);
	      moveToNewFileAction = {
	        name: refactorName5,
	        description,
	        kind: "refactor.move.newFile"
	      };
	      registerRefactor(refactorName5, {
	        kinds: [moveToNewFileAction.kind],
	        getAvailableActions: function getRefactorActionsToMoveToNewFile(context) {
	          const statements = getStatementsToMove(context);
	          if (context.preferences.allowTextChangesInNewFiles && statements) {
	            return [{ name: refactorName5, description, actions: [moveToNewFileAction] }];
	          }
	          if (context.preferences.provideRefactorNotApplicableReason) {
	            return [{ name: refactorName5, description, actions: [{ ...moveToNewFileAction, notApplicableReason: getLocaleSpecificMessage(Diagnostics.Selection_is_not_a_valid_statement_or_statements) }] }];
	          }
	          return emptyArray;
	        },
	        getEditsForAction: function getRefactorEditsToMoveToNewFile(context, actionName2) {
	          Debug.assert(actionName2 === refactorName5, "Wrong refactor invoked");
	          const statements = Debug.checkDefined(getStatementsToMove(context));
	          const edits = ts_textChanges_exports.ChangeTracker.with(context, (t) => doChange3(context.file, context.program, statements, t, context.host, context.preferences));
	          return { edits, renameFilename: void 0, renameLocation: void 0 };
	        }
	      });
	    }
	  });

	  // src/services/refactors/moveToFile.ts
	  function error(notApplicableReason) {
	    return { edits: [], renameFilename: void 0, renameLocation: void 0, notApplicableReason };
	  }
	  function doChange4(context, oldFile, targetFile, program, toMove, changes, host, preferences) {
	    const checker = program.getTypeChecker();
	    if (!host.fileExists(targetFile)) {
	      changes.createNewFile(oldFile, targetFile, getNewStatementsAndRemoveFromOldFile2(oldFile, targetFile, getUsageInfo(oldFile, toMove.all, checker), changes, toMove, program, host, preferences));
	      addNewFileToTsconfig(program, changes, oldFile.fileName, targetFile, hostGetCanonicalFileName(host));
	    } else {
	      const targetSourceFile = Debug.checkDefined(program.getSourceFile(targetFile));
	      const importAdder = ts_codefix_exports.createImportAdder(targetSourceFile, context.program, context.preferences, context.host);
	      getNewStatementsAndRemoveFromOldFile2(oldFile, targetSourceFile, getUsageInfo(oldFile, toMove.all, checker, getExistingLocals(targetSourceFile, toMove.all, checker)), changes, toMove, program, host, preferences, importAdder);
	    }
	  }
	  function getNewStatementsAndRemoveFromOldFile2(oldFile, targetFile, usage, changes, toMove, program, host, preferences, importAdder) {
	    const checker = program.getTypeChecker();
	    const prologueDirectives = takeWhile(oldFile.statements, isPrologueDirective);
	    if (oldFile.externalModuleIndicator === void 0 && oldFile.commonJsModuleIndicator === void 0 && usage.oldImportsNeededByTargetFile.size === 0 && usage.targetFileImportsFromOldFile.size === 0 && typeof targetFile === "string") {
	      deleteMovedStatements(oldFile, toMove.ranges, changes);
	      return [...prologueDirectives, ...toMove.all];
	    }
	    const targetFileName = typeof targetFile === "string" ? targetFile : targetFile.fileName;
	    const useEsModuleSyntax = !fileShouldUseJavaScriptRequire(targetFileName, program, host, !!oldFile.commonJsModuleIndicator);
	    const quotePreference = getQuotePreference(oldFile, preferences);
	    const importsFromTargetFile = createOldFileImportsFromTargetFile(oldFile, usage.oldFileImportsFromTargetFile, targetFileName, program, host, useEsModuleSyntax, quotePreference);
	    if (importsFromTargetFile) {
	      insertImports(
	        changes,
	        oldFile,
	        importsFromTargetFile,
	        /*blankLineBetween*/
	        true,
	        preferences
	      );
	    }
	    deleteUnusedOldImports(oldFile, toMove.all, changes, usage.unusedImportsFromOldFile, checker);
	    deleteMovedStatements(oldFile, toMove.ranges, changes);
	    updateImportsInOtherFiles(changes, program, host, oldFile, usage.movedSymbols, targetFileName, quotePreference);
	    const imports = getTargetFileImportsAndAddExportInOldFile(oldFile, targetFileName, usage.oldImportsNeededByTargetFile, usage.targetFileImportsFromOldFile, changes, checker, program, host, useEsModuleSyntax, quotePreference, importAdder);
	    const body = addExports(oldFile, toMove.all, usage.oldFileImportsFromTargetFile, useEsModuleSyntax);
	    if (typeof targetFile !== "string") {
	      if (targetFile.statements.length > 0) {
	        moveStatementsToTargetFile(changes, program, body, targetFile, toMove);
	      } else {
	        changes.insertNodesAtEndOfFile(
	          targetFile,
	          body,
	          /*blankLineBetween*/
	          false
	        );
	      }
	      if (imports.length > 0) {
	        insertImports(
	          changes,
	          targetFile,
	          imports,
	          /*blankLineBetween*/
	          true,
	          preferences
	        );
	      }
	    }
	    if (importAdder) {
	      importAdder.writeFixes(changes, quotePreference);
	    }
	    if (imports.length && body.length) {
	      return [
	        ...prologueDirectives,
	        ...imports,
	        4 /* NewLineTrivia */,
	        ...body
	      ];
	    }
	    return [
	      ...prologueDirectives,
	      ...imports,
	      ...body
	    ];
	  }
	  function getTargetFileImportsAndAddExportInOldFile(oldFile, targetFile, importsToCopy, targetFileImportsFromOldFile, changes, checker, program, host, useEsModuleSyntax, quotePreference, importAdder) {
	    const copiedOldImports = [];
	    if (importAdder) {
	      importsToCopy.forEach((isValidTypeOnlyUseSite, symbol) => {
	        try {
	          importAdder.addImportFromExportedSymbol(skipAlias(symbol, checker), isValidTypeOnlyUseSite);
	        } catch {
	          for (const oldStatement of oldFile.statements) {
	            forEachImportInStatement(oldStatement, (i) => {
	              append(copiedOldImports, filterImport(i, factory.createStringLiteral(moduleSpecifierFromImport(i).text), (name) => importsToCopy.has(checker.getSymbolAtLocation(name))));
	            });
	          }
	        }
	      });
	    } else {
	      const targetSourceFile = program.getSourceFile(targetFile);
	      for (const oldStatement of oldFile.statements) {
	        forEachImportInStatement(oldStatement, (i) => {
	          var _a;
	          const moduleSpecifier = moduleSpecifierFromImport(i);
	          const compilerOptions = program.getCompilerOptions();
	          const resolved = program.getResolvedModuleFromModuleSpecifier(moduleSpecifier);
	          const fileName = (_a = resolved == null ? void 0 : resolved.resolvedModule) == null ? void 0 : _a.resolvedFileName;
	          if (fileName && targetSourceFile) {
	            const newModuleSpecifier = getModuleSpecifier(compilerOptions, targetSourceFile, targetSourceFile.fileName, fileName, createModuleSpecifierResolutionHost(program, host));
	            append(copiedOldImports, filterImport(i, makeStringLiteral(newModuleSpecifier, quotePreference), (name) => importsToCopy.has(checker.getSymbolAtLocation(name))));
	          } else {
	            append(copiedOldImports, filterImport(i, factory.createStringLiteral(moduleSpecifierFromImport(i).text), (name) => importsToCopy.has(checker.getSymbolAtLocation(name))));
	          }
	        });
	      }
	    }
	    const targetFileSourceFile = program.getSourceFile(targetFile);
	    let oldFileDefault;
	    const oldFileNamedImports = [];
	    const markSeenTop = nodeSeenTracker();
	    targetFileImportsFromOldFile.forEach((symbol) => {
	      if (!symbol.declarations) {
	        return;
	      }
	      for (const decl of symbol.declarations) {
	        if (!isTopLevelDeclaration(decl))
	          continue;
	        const name = nameOfTopLevelDeclaration(decl);
	        if (!name)
	          continue;
	        const top = getTopLevelDeclarationStatement(decl);
	        if (markSeenTop(top)) {
	          addExportToChanges(oldFile, top, name, changes, useEsModuleSyntax);
	        }
	        if (importAdder && checker.isUnknownSymbol(symbol)) {
	          importAdder.addImportFromExportedSymbol(skipAlias(symbol, checker));
	        } else {
	          if (hasSyntacticModifier(decl, 2048 /* Default */)) {
	            oldFileDefault = name;
	          } else {
	            oldFileNamedImports.push(name.text);
	          }
	        }
	      }
	    });
	    return targetFileSourceFile ? append(copiedOldImports, makeImportOrRequire(targetFileSourceFile, oldFileDefault, oldFileNamedImports, oldFile.fileName, program, host, useEsModuleSyntax, quotePreference)) : append(copiedOldImports, makeImportOrRequire(oldFile, oldFileDefault, oldFileNamedImports, oldFile.fileName, program, host, useEsModuleSyntax, quotePreference));
	  }
	  function addNewFileToTsconfig(program, changes, oldFileName, newFileNameWithExtension, getCanonicalFileName) {
	    const cfg = program.getCompilerOptions().configFile;
	    if (!cfg)
	      return;
	    const newFileAbsolutePath = normalizePath(combinePaths(oldFileName, "..", newFileNameWithExtension));
	    const newFilePath = getRelativePathFromFile(cfg.fileName, newFileAbsolutePath, getCanonicalFileName);
	    const cfgObject = cfg.statements[0] && tryCast(cfg.statements[0].expression, isObjectLiteralExpression);
	    const filesProp = cfgObject && find(cfgObject.properties, (prop) => isPropertyAssignment(prop) && isStringLiteral(prop.name) && prop.name.text === "files");
	    if (filesProp && isArrayLiteralExpression(filesProp.initializer)) {
	      changes.insertNodeInListAfter(cfg, last(filesProp.initializer.elements), factory.createStringLiteral(newFilePath), filesProp.initializer.elements);
	    }
	  }
	  function deleteMovedStatements(sourceFile, moved, changes) {
	    for (const { first: first2, afterLast } of moved) {
	      changes.deleteNodeRangeExcludingEnd(sourceFile, first2, afterLast);
	    }
	  }
	  function deleteUnusedOldImports(oldFile, toMove, changes, toDelete, checker) {
	    for (const statement of oldFile.statements) {
	      if (contains(toMove, statement))
	        continue;
	      forEachImportInStatement(statement, (i) => deleteUnusedImports(oldFile, i, changes, (name) => toDelete.has(checker.getSymbolAtLocation(name))));
	    }
	  }
	  function updateImportsInOtherFiles(changes, program, host, oldFile, movedSymbols, targetFileName, quotePreference) {
	    const checker = program.getTypeChecker();
	    for (const sourceFile of program.getSourceFiles()) {
	      if (sourceFile === oldFile)
	        continue;
	      for (const statement of sourceFile.statements) {
	        forEachImportInStatement(statement, (importNode) => {
	          if (checker.getSymbolAtLocation(moduleSpecifierFromImport(importNode)) !== oldFile.symbol)
	            return;
	          const shouldMove = (name) => {
	            const symbol = isBindingElement(name.parent) ? getPropertySymbolFromBindingElement(checker, name.parent) : skipAlias(checker.getSymbolAtLocation(name), checker);
	            return !!symbol && movedSymbols.has(symbol);
	          };
	          deleteUnusedImports(sourceFile, importNode, changes, shouldMove);
	          const pathToTargetFileWithExtension = resolvePath(getDirectoryPath(oldFile.path), targetFileName);
	          const newModuleSpecifier = getModuleSpecifier(program.getCompilerOptions(), sourceFile, sourceFile.fileName, pathToTargetFileWithExtension, createModuleSpecifierResolutionHost(program, host));
	          const newImportDeclaration = filterImport(importNode, makeStringLiteral(newModuleSpecifier, quotePreference), shouldMove);
	          if (newImportDeclaration)
	            changes.insertNodeAfter(sourceFile, statement, newImportDeclaration);
	          const ns = getNamespaceLikeImport(importNode);
	          if (ns)
	            updateNamespaceLikeImport(changes, sourceFile, checker, movedSymbols, newModuleSpecifier, ns, importNode, quotePreference);
	        });
	      }
	    }
	  }
	  function getNamespaceLikeImport(node) {
	    switch (node.kind) {
	      case 272 /* ImportDeclaration */:
	        return node.importClause && node.importClause.namedBindings && node.importClause.namedBindings.kind === 274 /* NamespaceImport */ ? node.importClause.namedBindings.name : void 0;
	      case 271 /* ImportEqualsDeclaration */:
	        return node.name;
	      case 260 /* VariableDeclaration */:
	        return tryCast(node.name, isIdentifier);
	      default:
	        return Debug.assertNever(node, `Unexpected node kind ${node.kind}`);
	    }
	  }
	  function updateNamespaceLikeImport(changes, sourceFile, checker, movedSymbols, newModuleSpecifier, oldImportId, oldImportNode, quotePreference) {
	    const preferredNewNamespaceName = ts_codefix_exports.moduleSpecifierToValidIdentifier(newModuleSpecifier, 99 /* ESNext */);
	    let needUniqueName = false;
	    const toChange = [];
	    ts_FindAllReferences_exports.Core.eachSymbolReferenceInFile(oldImportId, checker, sourceFile, (ref) => {
	      if (!isPropertyAccessExpression(ref.parent))
	        return;
	      needUniqueName = needUniqueName || !!checker.resolveName(
	        preferredNewNamespaceName,
	        ref,
	        -1 /* All */,
	        /*excludeGlobals*/
	        true
	      );
	      if (movedSymbols.has(checker.getSymbolAtLocation(ref.parent.name))) {
	        toChange.push(ref);
	      }
	    });
	    if (toChange.length) {
	      const newNamespaceName = needUniqueName ? getUniqueName(preferredNewNamespaceName, sourceFile) : preferredNewNamespaceName;
	      for (const ref of toChange) {
	        changes.replaceNode(sourceFile, ref, factory.createIdentifier(newNamespaceName));
	      }
	      changes.insertNodeAfter(sourceFile, oldImportNode, updateNamespaceLikeImportNode(oldImportNode, preferredNewNamespaceName, newModuleSpecifier, quotePreference));
	    }
	  }
	  function updateNamespaceLikeImportNode(node, newNamespaceName, newModuleSpecifier, quotePreference) {
	    const newNamespaceId = factory.createIdentifier(newNamespaceName);
	    const newModuleString = makeStringLiteral(newModuleSpecifier, quotePreference);
	    switch (node.kind) {
	      case 272 /* ImportDeclaration */:
	        return factory.createImportDeclaration(
	          /*modifiers*/
	          void 0,
	          factory.createImportClause(
	            /*isTypeOnly*/
	            false,
	            /*name*/
	            void 0,
	            factory.createNamespaceImport(newNamespaceId)
	          ),
	          newModuleString,
	          /*attributes*/
	          void 0
	        );
	      case 271 /* ImportEqualsDeclaration */:
	        return factory.createImportEqualsDeclaration(
	          /*modifiers*/
	          void 0,
	          /*isTypeOnly*/
	          false,
	          newNamespaceId,
	          factory.createExternalModuleReference(newModuleString)
	        );
	      case 260 /* VariableDeclaration */:
	        return factory.createVariableDeclaration(
	          newNamespaceId,
	          /*exclamationToken*/
	          void 0,
	          /*type*/
	          void 0,
	          createRequireCall(newModuleString)
	        );
	      default:
	        return Debug.assertNever(node, `Unexpected node kind ${node.kind}`);
	    }
	  }
	  function createRequireCall(moduleSpecifier) {
	    return factory.createCallExpression(
	      factory.createIdentifier("require"),
	      /*typeArguments*/
	      void 0,
	      [moduleSpecifier]
	    );
	  }
	  function moduleSpecifierFromImport(i) {
	    return i.kind === 272 /* ImportDeclaration */ ? i.moduleSpecifier : i.kind === 271 /* ImportEqualsDeclaration */ ? i.moduleReference.expression : i.initializer.arguments[0];
	  }
	  function forEachImportInStatement(statement, cb) {
	    if (isImportDeclaration(statement)) {
	      if (isStringLiteral(statement.moduleSpecifier))
	        cb(statement);
	    } else if (isImportEqualsDeclaration(statement)) {
	      if (isExternalModuleReference(statement.moduleReference) && isStringLiteralLike(statement.moduleReference.expression)) {
	        cb(statement);
	      }
	    } else if (isVariableStatement(statement)) {
	      for (const decl of statement.declarationList.declarations) {
	        if (decl.initializer && isRequireCall(
	          decl.initializer,
	          /*requireStringLiteralLikeArgument*/
	          true
	        )) {
	          cb(decl);
	        }
	      }
	    }
	  }
	  function createOldFileImportsFromTargetFile(sourceFile, targetFileNeedExport, targetFileNameWithExtension, program, host, useEs6Imports, quotePreference) {
	    let defaultImport;
	    const imports = [];
	    targetFileNeedExport.forEach((symbol) => {
	      if (symbol.escapedName === "default" /* Default */) {
	        defaultImport = factory.createIdentifier(symbolNameNoDefault(symbol));
	      } else {
	        imports.push(symbol.name);
	      }
	    });
	    return makeImportOrRequire(sourceFile, defaultImport, imports, targetFileNameWithExtension, program, host, useEs6Imports, quotePreference);
	  }
	  function makeImportOrRequire(sourceFile, defaultImport, imports, targetFileNameWithExtension, program, host, useEs6Imports, quotePreference) {
	    const pathToTargetFile = resolvePath(getDirectoryPath(sourceFile.path), targetFileNameWithExtension);
	    const pathToTargetFileWithCorrectExtension = getModuleSpecifier(program.getCompilerOptions(), sourceFile, sourceFile.fileName, pathToTargetFile, createModuleSpecifierResolutionHost(program, host));
	    if (useEs6Imports) {
	      const specifiers = imports.map((i) => factory.createImportSpecifier(
	        /*isTypeOnly*/
	        false,
	        /*propertyName*/
	        void 0,
	        factory.createIdentifier(i)
	      ));
	      return makeImportIfNecessary(defaultImport, specifiers, pathToTargetFileWithCorrectExtension, quotePreference);
	    } else {
	      Debug.assert(!defaultImport, "No default import should exist");
	      const bindingElements = imports.map((i) => factory.createBindingElement(
	        /*dotDotDotToken*/
	        void 0,
	        /*propertyName*/
	        void 0,
	        i
	      ));
	      return bindingElements.length ? makeVariableStatement(
	        factory.createObjectBindingPattern(bindingElements),
	        /*type*/
	        void 0,
	        createRequireCall(makeStringLiteral(pathToTargetFileWithCorrectExtension, quotePreference))
	      ) : void 0;
	    }
	  }
	  function makeVariableStatement(name, type, initializer, flags = 2 /* Const */) {
	    return factory.createVariableStatement(
	      /*modifiers*/
	      void 0,
	      factory.createVariableDeclarationList([factory.createVariableDeclaration(
	        name,
	        /*exclamationToken*/
	        void 0,
	        type,
	        initializer
	      )], flags)
	    );
	  }
	  function addExports(sourceFile, toMove, needExport, useEs6Exports) {
	    return flatMap(toMove, (statement) => {
	      if (isTopLevelDeclarationStatement(statement) && !isExported(sourceFile, statement, useEs6Exports) && forEachTopLevelDeclaration(statement, (d) => {
	        var _a;
	        return needExport.has(Debug.checkDefined((_a = tryCast(d, canHaveSymbol)) == null ? void 0 : _a.symbol));
	      })) {
	        const exports = addExport(getSynthesizedDeepClone(statement), useEs6Exports);
	        if (exports)
	          return exports;
	      }
	      return getSynthesizedDeepClone(statement);
	    });
	  }
	  function isExported(sourceFile, decl, useEs6Exports, name) {
	    var _a;
	    if (useEs6Exports) {
	      return !isExpressionStatement(decl) && hasSyntacticModifier(decl, 32 /* Export */) || !!(name && sourceFile.symbol && ((_a = sourceFile.symbol.exports) == null ? void 0 : _a.has(name.escapedText)));
	    }
	    return !!sourceFile.symbol && !!sourceFile.symbol.exports && getNamesToExportInCommonJS(decl).some((name2) => sourceFile.symbol.exports.has(escapeLeadingUnderscores(name2)));
	  }
	  function deleteUnusedImports(sourceFile, importDecl, changes, isUnused) {
	    switch (importDecl.kind) {
	      case 272 /* ImportDeclaration */:
	        deleteUnusedImportsInDeclaration(sourceFile, importDecl, changes, isUnused);
	        break;
	      case 271 /* ImportEqualsDeclaration */:
	        if (isUnused(importDecl.name)) {
	          changes.delete(sourceFile, importDecl);
	        }
	        break;
	      case 260 /* VariableDeclaration */:
	        deleteUnusedImportsInVariableDeclaration(sourceFile, importDecl, changes, isUnused);
	        break;
	      default:
	        Debug.assertNever(importDecl, `Unexpected import decl kind ${importDecl.kind}`);
	    }
	  }
	  function deleteUnusedImportsInDeclaration(sourceFile, importDecl, changes, isUnused) {
	    if (!importDecl.importClause)
	      return;
	    const { name, namedBindings } = importDecl.importClause;
	    const defaultUnused = !name || isUnused(name);
	    const namedBindingsUnused = !namedBindings || (namedBindings.kind === 274 /* NamespaceImport */ ? isUnused(namedBindings.name) : namedBindings.elements.length !== 0 && namedBindings.elements.every((e) => isUnused(e.name)));
	    if (defaultUnused && namedBindingsUnused) {
	      changes.delete(sourceFile, importDecl);
	    } else {
	      if (name && defaultUnused) {
	        changes.delete(sourceFile, name);
	      }
	      if (namedBindings) {
	        if (namedBindingsUnused) {
	          changes.replaceNode(
	            sourceFile,
	            importDecl.importClause,
	            factory.updateImportClause(
	              importDecl.importClause,
	              importDecl.importClause.isTypeOnly,
	              name,
	              /*namedBindings*/
	              void 0
	            )
	          );
	        } else if (namedBindings.kind === 275 /* NamedImports */) {
	          for (const element of namedBindings.elements) {
	            if (isUnused(element.name))
	              changes.delete(sourceFile, element);
	          }
	        }
	      }
	    }
	  }
	  function deleteUnusedImportsInVariableDeclaration(sourceFile, varDecl, changes, isUnused) {
	    const { name } = varDecl;
	    switch (name.kind) {
	      case 80 /* Identifier */:
	        if (isUnused(name)) {
	          if (varDecl.initializer && isRequireCall(
	            varDecl.initializer,
	            /*requireStringLiteralLikeArgument*/
	            true
	          )) {
	            changes.delete(sourceFile, isVariableDeclarationList(varDecl.parent) && length(varDecl.parent.declarations) === 1 ? varDecl.parent.parent : varDecl);
	          } else {
	            changes.delete(sourceFile, name);
	          }
	        }
	        break;
	      case 207 /* ArrayBindingPattern */:
	        break;
	      case 206 /* ObjectBindingPattern */:
	        if (name.elements.every((e) => isIdentifier(e.name) && isUnused(e.name))) {
	          changes.delete(sourceFile, isVariableDeclarationList(varDecl.parent) && varDecl.parent.declarations.length === 1 ? varDecl.parent.parent : varDecl);
	        } else {
	          for (const element of name.elements) {
	            if (isIdentifier(element.name) && isUnused(element.name)) {
	              changes.delete(sourceFile, element.name);
	            }
	          }
	        }
	        break;
	    }
	  }
	  function isTopLevelDeclarationStatement(node) {
	    Debug.assert(isSourceFile(node.parent), "Node parent should be a SourceFile");
	    return isNonVariableTopLevelDeclaration(node) || isVariableStatement(node);
	  }
	  function addExport(decl, useEs6Exports) {
	    return useEs6Exports ? [addEs6Export(decl)] : addCommonjsExport(decl);
	  }
	  function addEs6Export(d) {
	    const modifiers = canHaveModifiers(d) ? concatenate([factory.createModifier(95 /* ExportKeyword */)], getModifiers(d)) : void 0;
	    switch (d.kind) {
	      case 262 /* FunctionDeclaration */:
	        return factory.updateFunctionDeclaration(d, modifiers, d.asteriskToken, d.name, d.typeParameters, d.parameters, d.type, d.body);
	      case 263 /* ClassDeclaration */:
	        const decorators = canHaveDecorators(d) ? getDecorators(d) : void 0;
	        return factory.updateClassDeclaration(d, concatenate(decorators, modifiers), d.name, d.typeParameters, d.heritageClauses, d.members);
	      case 243 /* VariableStatement */:
	        return factory.updateVariableStatement(d, modifiers, d.declarationList);
	      case 267 /* ModuleDeclaration */:
	        return factory.updateModuleDeclaration(d, modifiers, d.name, d.body);
	      case 266 /* EnumDeclaration */:
	        return factory.updateEnumDeclaration(d, modifiers, d.name, d.members);
	      case 265 /* TypeAliasDeclaration */:
	        return factory.updateTypeAliasDeclaration(d, modifiers, d.name, d.typeParameters, d.type);
	      case 264 /* InterfaceDeclaration */:
	        return factory.updateInterfaceDeclaration(d, modifiers, d.name, d.typeParameters, d.heritageClauses, d.members);
	      case 271 /* ImportEqualsDeclaration */:
	        return factory.updateImportEqualsDeclaration(d, modifiers, d.isTypeOnly, d.name, d.moduleReference);
	      case 244 /* ExpressionStatement */:
	        return Debug.fail();
	      default:
	        return Debug.assertNever(d, `Unexpected declaration kind ${d.kind}`);
	    }
	  }
	  function addCommonjsExport(decl) {
	    return [decl, ...getNamesToExportInCommonJS(decl).map(createExportAssignment)];
	  }
	  function createExportAssignment(name) {
	    return factory.createExpressionStatement(
	      factory.createBinaryExpression(
	        factory.createPropertyAccessExpression(factory.createIdentifier("exports"), factory.createIdentifier(name)),
	        64 /* EqualsToken */,
	        factory.createIdentifier(name)
	      )
	    );
	  }
	  function getNamesToExportInCommonJS(decl) {
	    switch (decl.kind) {
	      case 262 /* FunctionDeclaration */:
	      case 263 /* ClassDeclaration */:
	        return [decl.name.text];
	      case 243 /* VariableStatement */:
	        return mapDefined(decl.declarationList.declarations, (d) => isIdentifier(d.name) ? d.name.text : void 0);
	      case 267 /* ModuleDeclaration */:
	      case 266 /* EnumDeclaration */:
	      case 265 /* TypeAliasDeclaration */:
	      case 264 /* InterfaceDeclaration */:
	      case 271 /* ImportEqualsDeclaration */:
	        return emptyArray;
	      case 244 /* ExpressionStatement */:
	        return Debug.fail("Can't export an ExpressionStatement");
	      default:
	        return Debug.assertNever(decl, `Unexpected decl kind ${decl.kind}`);
	    }
	  }
	  function filterImport(i, moduleSpecifier, keep) {
	    switch (i.kind) {
	      case 272 /* ImportDeclaration */: {
	        const clause = i.importClause;
	        if (!clause)
	          return void 0;
	        const defaultImport = clause.name && keep(clause.name) ? clause.name : void 0;
	        const namedBindings = clause.namedBindings && filterNamedBindings(clause.namedBindings, keep);
	        return defaultImport || namedBindings ? factory.createImportDeclaration(
	          /*modifiers*/
	          void 0,
	          factory.createImportClause(clause.isTypeOnly, defaultImport, namedBindings),
	          getSynthesizedDeepClone(moduleSpecifier),
	          /*attributes*/
	          void 0
	        ) : void 0;
	      }
	      case 271 /* ImportEqualsDeclaration */:
	        return keep(i.name) ? i : void 0;
	      case 260 /* VariableDeclaration */: {
	        const name = filterBindingName(i.name, keep);
	        return name ? makeVariableStatement(name, i.type, createRequireCall(moduleSpecifier), i.parent.flags) : void 0;
	      }
	      default:
	        return Debug.assertNever(i, `Unexpected import kind ${i.kind}`);
	    }
	  }
	  function filterNamedBindings(namedBindings, keep) {
	    if (namedBindings.kind === 274 /* NamespaceImport */) {
	      return keep(namedBindings.name) ? namedBindings : void 0;
	    } else {
	      const newElements = namedBindings.elements.filter((e) => keep(e.name));
	      return newElements.length ? factory.createNamedImports(newElements) : void 0;
	    }
	  }
	  function filterBindingName(name, keep) {
	    switch (name.kind) {
	      case 80 /* Identifier */:
	        return keep(name) ? name : void 0;
	      case 207 /* ArrayBindingPattern */:
	        return name;
	      case 206 /* ObjectBindingPattern */: {
	        const newElements = name.elements.filter((prop) => prop.propertyName || !isIdentifier(prop.name) || keep(prop.name));
	        return newElements.length ? factory.createObjectBindingPattern(newElements) : void 0;
	      }
	    }
	  }
	  function nameOfTopLevelDeclaration(d) {
	    return isExpressionStatement(d) ? tryCast(d.expression.left.name, isIdentifier) : tryCast(d.name, isIdentifier);
	  }
	  function getTopLevelDeclarationStatement(d) {
	    switch (d.kind) {
	      case 260 /* VariableDeclaration */:
	        return d.parent.parent;
	      case 208 /* BindingElement */:
	        return getTopLevelDeclarationStatement(
	          cast(d.parent.parent, (p) => isVariableDeclaration(p) || isBindingElement(p))
	        );
	      default:
	        return d;
	    }
	  }
	  function addExportToChanges(sourceFile, decl, name, changes, useEs6Exports) {
	    if (isExported(sourceFile, decl, useEs6Exports, name))
	      return;
	    if (useEs6Exports) {
	      if (!isExpressionStatement(decl))
	        changes.insertExportModifier(sourceFile, decl);
	    } else {
	      const names = getNamesToExportInCommonJS(decl);
	      if (names.length !== 0)
	        changes.insertNodesAfter(sourceFile, decl, names.map(createExportAssignment));
	    }
	  }
	  function createNewFileName(oldFile, program, host, toMove) {
	    const checker = program.getTypeChecker();
	    if (toMove) {
	      const usage = getUsageInfo(oldFile, toMove.all, checker);
	      const currentDirectory = getDirectoryPath(oldFile.fileName);
	      const extension = extensionFromPath(oldFile.fileName);
	      const newFileName = combinePaths(
	        // new file is always placed in the same directory as the old file
	        currentDirectory,
	        // ensures the filename computed below isn't already taken
	        makeUniqueFilename(
	          // infers a name for the new file from the symbols being moved
	          inferNewFileName(usage.oldFileImportsFromTargetFile, usage.movedSymbols),
	          extension,
	          currentDirectory,
	          host
	        )
	      ) + extension;
	      return newFileName;
	    }
	    return "";
	  }
	  function getRangeToMove(context) {
	    const { file } = context;
	    const range = createTextRangeFromSpan(getRefactorContextSpan(context));
	    const { statements } = file;
	    let startNodeIndex = findIndex(statements, (s) => s.end > range.pos);
	    if (startNodeIndex === -1)
	      return void 0;
	    const startStatement = statements[startNodeIndex];
	    const overloadRangeToMove = getOverloadRangeToMove(file, startStatement);
	    if (overloadRangeToMove) {
	      startNodeIndex = overloadRangeToMove.start;
	    }
	    let endNodeIndex = findIndex(statements, (s) => s.end >= range.end, startNodeIndex);
	    if (endNodeIndex !== -1 && range.end <= statements[endNodeIndex].getStart()) {
	      endNodeIndex--;
	    }
	    const endingOverloadRangeToMove = getOverloadRangeToMove(file, statements[endNodeIndex]);
	    if (endingOverloadRangeToMove) {
	      endNodeIndex = endingOverloadRangeToMove.end;
	    }
	    return {
	      toMove: statements.slice(startNodeIndex, endNodeIndex === -1 ? statements.length : endNodeIndex + 1),
	      afterLast: endNodeIndex === -1 ? void 0 : statements[endNodeIndex + 1]
	    };
	  }
	  function getStatementsToMove(context) {
	    const rangeToMove = getRangeToMove(context);
	    if (rangeToMove === void 0)
	      return void 0;
	    const all = [];
	    const ranges = [];
	    const { toMove, afterLast } = rangeToMove;
	    getRangesWhere(toMove, isAllowedStatementToMove, (start, afterEndIndex) => {
	      for (let i = start; i < afterEndIndex; i++)
	        all.push(toMove[i]);
	      ranges.push({ first: toMove[start], afterLast });
	    });
	    return all.length === 0 ? void 0 : { all, ranges };
	  }
	  function containsJsx(statements) {
	    return find(statements, (statement) => !!(statement.transformFlags & 2 /* ContainsJsx */));
	  }
	  function isAllowedStatementToMove(statement) {
	    return !isPureImport(statement) && !isPrologueDirective(statement);
	  }
	  function isPureImport(node) {
	    switch (node.kind) {
	      case 272 /* ImportDeclaration */:
	        return true;
	      case 271 /* ImportEqualsDeclaration */:
	        return !hasSyntacticModifier(node, 32 /* Export */);
	      case 243 /* VariableStatement */:
	        return node.declarationList.declarations.every((d) => !!d.initializer && isRequireCall(
	          d.initializer,
	          /*requireStringLiteralLikeArgument*/
	          true
	        ));
	      default:
	        return false;
	    }
	  }
	  function getUsageInfo(oldFile, toMove, checker, existingTargetLocals = /* @__PURE__ */ new Set()) {
	    const movedSymbols = /* @__PURE__ */ new Set();
	    const oldImportsNeededByTargetFile = /* @__PURE__ */ new Map();
	    const targetFileImportsFromOldFile = /* @__PURE__ */ new Set();
	    const jsxNamespaceSymbol = getJsxNamespaceSymbol(containsJsx(toMove));
	    if (jsxNamespaceSymbol) {
	      oldImportsNeededByTargetFile.set(jsxNamespaceSymbol, false);
	    }
	    for (const statement of toMove) {
	      forEachTopLevelDeclaration(statement, (decl) => {
	        movedSymbols.add(Debug.checkDefined(isExpressionStatement(decl) ? checker.getSymbolAtLocation(decl.expression.left) : decl.symbol, "Need a symbol here"));
	      });
	    }
	    const unusedImportsFromOldFile = /* @__PURE__ */ new Set();
	    for (const statement of toMove) {
	      forEachReference(statement, checker, (symbol, isValidTypeOnlyUseSite) => {
	        if (!symbol.declarations) {
	          return;
	        }
	        if (existingTargetLocals.has(skipAlias(symbol, checker))) {
	          unusedImportsFromOldFile.add(symbol);
	          return;
	        }
	        for (const decl of symbol.declarations) {
	          if (isInImport(decl)) {
	            const prevIsTypeOnly = oldImportsNeededByTargetFile.get(symbol);
	            oldImportsNeededByTargetFile.set(symbol, prevIsTypeOnly === void 0 ? isValidTypeOnlyUseSite : prevIsTypeOnly && isValidTypeOnlyUseSite);
	          } else if (isTopLevelDeclaration(decl) && sourceFileOfTopLevelDeclaration(decl) === oldFile && !movedSymbols.has(symbol)) {
	            targetFileImportsFromOldFile.add(symbol);
	          }
	        }
	      });
	    }
	    for (const unusedImport of oldImportsNeededByTargetFile.keys()) {
	      unusedImportsFromOldFile.add(unusedImport);
	    }
	    const oldFileImportsFromTargetFile = /* @__PURE__ */ new Set();
	    for (const statement of oldFile.statements) {
	      if (contains(toMove, statement))
	        continue;
	      if (jsxNamespaceSymbol && !!(statement.transformFlags & 2 /* ContainsJsx */)) {
	        unusedImportsFromOldFile.delete(jsxNamespaceSymbol);
	      }
	      forEachReference(statement, checker, (symbol) => {
	        if (movedSymbols.has(symbol))
	          oldFileImportsFromTargetFile.add(symbol);
	        unusedImportsFromOldFile.delete(symbol);
	      });
	    }
	    return { movedSymbols, targetFileImportsFromOldFile, oldFileImportsFromTargetFile, oldImportsNeededByTargetFile, unusedImportsFromOldFile };
	    function getJsxNamespaceSymbol(containsJsx2) {
	      if (containsJsx2 === void 0) {
	        return void 0;
	      }
	      const jsxNamespace = checker.getJsxNamespace(containsJsx2);
	      const jsxNamespaceSymbol2 = checker.resolveName(
	        jsxNamespace,
	        containsJsx2,
	        1920 /* Namespace */,
	        /*excludeGlobals*/
	        true
	      );
	      return !!jsxNamespaceSymbol2 && some(jsxNamespaceSymbol2.declarations, isInImport) ? jsxNamespaceSymbol2 : void 0;
	    }
	  }
	  function makeUniqueFilename(proposedFilename, extension, inDirectory, host) {
	    let newFilename = proposedFilename;
	    for (let i = 1; ; i++) {
	      const name = combinePaths(inDirectory, newFilename + extension);
	      if (!host.fileExists(name))
	        return newFilename;
	      newFilename = `${proposedFilename}.${i}`;
	    }
	  }
	  function inferNewFileName(importsFromNewFile, movedSymbols) {
	    return forEachKey(importsFromNewFile, symbolNameNoDefault) || forEachKey(movedSymbols, symbolNameNoDefault) || "newFile";
	  }
	  function forEachReference(node, checker, onReference) {
	    node.forEachChild(function cb(node2) {
	      if (isIdentifier(node2) && !isDeclarationName(node2)) {
	        const sym = checker.getSymbolAtLocation(node2);
	        if (sym)
	          onReference(sym, isValidTypeOnlyAliasUseSite(node2));
	      } else {
	        node2.forEachChild(cb);
	      }
	    });
	  }
	  function forEachTopLevelDeclaration(statement, cb) {
	    switch (statement.kind) {
	      case 262 /* FunctionDeclaration */:
	      case 263 /* ClassDeclaration */:
	      case 267 /* ModuleDeclaration */:
	      case 266 /* EnumDeclaration */:
	      case 265 /* TypeAliasDeclaration */:
	      case 264 /* InterfaceDeclaration */:
	      case 271 /* ImportEqualsDeclaration */:
	        return cb(statement);
	      case 243 /* VariableStatement */:
	        return firstDefined(statement.declarationList.declarations, (decl) => forEachTopLevelDeclarationInBindingName(decl.name, cb));
	      case 244 /* ExpressionStatement */: {
	        const { expression } = statement;
	        return isBinaryExpression(expression) && getAssignmentDeclarationKind(expression) === 1 /* ExportsProperty */ ? cb(statement) : void 0;
	      }
	    }
	  }
	  function isInImport(decl) {
	    switch (decl.kind) {
	      case 271 /* ImportEqualsDeclaration */:
	      case 276 /* ImportSpecifier */:
	      case 273 /* ImportClause */:
	      case 274 /* NamespaceImport */:
	        return true;
	      case 260 /* VariableDeclaration */:
	        return isVariableDeclarationInImport(decl);
	      case 208 /* BindingElement */:
	        return isVariableDeclaration(decl.parent.parent) && isVariableDeclarationInImport(decl.parent.parent);
	      default:
	        return false;
	    }
	  }
	  function isVariableDeclarationInImport(decl) {
	    return isSourceFile(decl.parent.parent.parent) && !!decl.initializer && isRequireCall(
	      decl.initializer,
	      /*requireStringLiteralLikeArgument*/
	      true
	    );
	  }
	  function isTopLevelDeclaration(node) {
	    return isNonVariableTopLevelDeclaration(node) && isSourceFile(node.parent) || isVariableDeclaration(node) && isSourceFile(node.parent.parent.parent);
	  }
	  function sourceFileOfTopLevelDeclaration(node) {
	    return isVariableDeclaration(node) ? node.parent.parent.parent : node.parent;
	  }
	  function forEachTopLevelDeclarationInBindingName(name, cb) {
	    switch (name.kind) {
	      case 80 /* Identifier */:
	        return cb(cast(name.parent, (x) => isVariableDeclaration(x) || isBindingElement(x)));
	      case 207 /* ArrayBindingPattern */:
	      case 206 /* ObjectBindingPattern */:
	        return firstDefined(name.elements, (em) => isOmittedExpression(em) ? void 0 : forEachTopLevelDeclarationInBindingName(em.name, cb));
	      default:
	        return Debug.assertNever(name, `Unexpected name kind ${name.kind}`);
	    }
	  }
	  function isNonVariableTopLevelDeclaration(node) {
	    switch (node.kind) {
	      case 262 /* FunctionDeclaration */:
	      case 263 /* ClassDeclaration */:
	      case 267 /* ModuleDeclaration */:
	      case 266 /* EnumDeclaration */:
	      case 265 /* TypeAliasDeclaration */:
	      case 264 /* InterfaceDeclaration */:
	      case 271 /* ImportEqualsDeclaration */:
	        return true;
	      default:
	        return false;
	    }
	  }
	  function moveStatementsToTargetFile(changes, program, statements, targetFile, toMove) {
	    var _a;
	    const removedExports = /* @__PURE__ */ new Set();
	    const targetExports = (_a = targetFile.symbol) == null ? void 0 : _a.exports;
	    if (targetExports) {
	      const checker = program.getTypeChecker();
	      const targetToSourceExports = /* @__PURE__ */ new Map();
	      for (const node of toMove.all) {
	        if (isTopLevelDeclarationStatement(node) && hasSyntacticModifier(node, 32 /* Export */)) {
	          forEachTopLevelDeclaration(node, (declaration) => {
	            var _a2;
	            const targetDeclarations = canHaveSymbol(declaration) ? (_a2 = targetExports.get(declaration.symbol.escapedName)) == null ? void 0 : _a2.declarations : void 0;
	            const exportDeclaration = firstDefined(targetDeclarations, (d) => isExportDeclaration(d) ? d : isExportSpecifier(d) ? tryCast(d.parent.parent, isExportDeclaration) : void 0);
	            if (exportDeclaration && exportDeclaration.moduleSpecifier) {
	              targetToSourceExports.set(exportDeclaration, (targetToSourceExports.get(exportDeclaration) || /* @__PURE__ */ new Set()).add(declaration));
	            }
	          });
	        }
	      }
	      for (const [exportDeclaration, topLevelDeclarations] of arrayFrom(targetToSourceExports)) {
	        if (exportDeclaration.exportClause && isNamedExports(exportDeclaration.exportClause) && length(exportDeclaration.exportClause.elements)) {
	          const elements = exportDeclaration.exportClause.elements;
	          const updatedElements = filter(elements, (elem) => find(skipAlias(elem.symbol, checker).declarations, (d) => isTopLevelDeclaration(d) && topLevelDeclarations.has(d)) === void 0);
	          if (length(updatedElements) === 0) {
	            changes.deleteNode(targetFile, exportDeclaration);
	            removedExports.add(exportDeclaration);
	            continue;
	          }
	          if (length(updatedElements) < length(elements)) {
	            changes.replaceNode(targetFile, exportDeclaration, factory.updateExportDeclaration(exportDeclaration, exportDeclaration.modifiers, exportDeclaration.isTypeOnly, factory.updateNamedExports(exportDeclaration.exportClause, factory.createNodeArray(updatedElements, elements.hasTrailingComma)), exportDeclaration.moduleSpecifier, exportDeclaration.attributes));
	          }
	        }
	      }
	    }
	    const lastReExport = findLast(targetFile.statements, (n) => isExportDeclaration(n) && !!n.moduleSpecifier && !removedExports.has(n));
	    if (lastReExport) {
	      changes.insertNodesBefore(
	        targetFile,
	        lastReExport,
	        statements,
	        /*blankLineBetween*/
	        true
	      );
	    } else {
	      changes.insertNodesAfter(targetFile, targetFile.statements[targetFile.statements.length - 1], statements);
	    }
	  }
	  function getOverloadRangeToMove(sourceFile, statement) {
	    if (isFunctionLikeDeclaration(statement)) {
	      const declarations = statement.symbol.declarations;
	      if (declarations === void 0 || length(declarations) <= 1 || !contains(declarations, statement)) {
	        return void 0;
	      }
	      const firstDecl = declarations[0];
	      const lastDecl = declarations[length(declarations) - 1];
	      const statementsToMove = mapDefined(declarations, (d) => getSourceFileOfNode(d) === sourceFile && isStatement(d) ? d : void 0);
	      const end = findIndex(sourceFile.statements, (s) => s.end >= lastDecl.end);
	      const start = findIndex(sourceFile.statements, (s) => s.end >= firstDecl.end);
	      return { toMove: statementsToMove, start, end };
	    }
	    return void 0;
	  }
	  function getExistingLocals(sourceFile, statements, checker) {
	    const existingLocals = /* @__PURE__ */ new Set();
	    for (const moduleSpecifier of sourceFile.imports) {
	      const declaration = importFromModuleSpecifier(moduleSpecifier);
	      if (isImportDeclaration(declaration) && declaration.importClause && declaration.importClause.namedBindings && isNamedImports(declaration.importClause.namedBindings)) {
	        for (const e of declaration.importClause.namedBindings.elements) {
	          const symbol = checker.getSymbolAtLocation(e.propertyName || e.name);
	          if (symbol) {
	            existingLocals.add(skipAlias(symbol, checker));
	          }
	        }
	      }
	      if (isVariableDeclarationInitializedToRequire(declaration.parent) && isObjectBindingPattern(declaration.parent.name)) {
	        for (const e of declaration.parent.name.elements) {
	          const symbol = checker.getSymbolAtLocation(e.propertyName || e.name);
	          if (symbol) {
	            existingLocals.add(skipAlias(symbol, checker));
	          }
	        }
	      }
	    }
	    for (const statement of statements) {
	      forEachReference(statement, checker, (s) => {
	        const symbol = skipAlias(s, checker);
	        if (symbol.valueDeclaration && getSourceFileOfNode(symbol.valueDeclaration) === sourceFile) {
	          existingLocals.add(symbol);
	        }
	      });
	    }
	    return existingLocals;
	  }
	  var refactorNameForMoveToFile, description2, moveToFileAction;
	  var init_moveToFile = __esm({
	    "src/services/refactors/moveToFile.ts"() {
	      init_moduleSpecifiers();
	      init_ts4();
	      init_refactorProvider();
	      refactorNameForMoveToFile = "Move to file";
	      description2 = getLocaleSpecificMessage(Diagnostics.Move_to_file);
	      moveToFileAction = {
	        name: "Move to file",
	        description: description2,
	        kind: "refactor.move.file"
	      };
	      registerRefactor(refactorNameForMoveToFile, {
	        kinds: [moveToFileAction.kind],
	        getAvailableActions: function getRefactorActionsToMoveToFile(context, interactiveRefactorArguments) {
	          const statements = getStatementsToMove(context);
	          if (!interactiveRefactorArguments) {
	            return emptyArray;
	          }
	          if (context.preferences.allowTextChangesInNewFiles && statements) {
	            return [{ name: refactorNameForMoveToFile, description: description2, actions: [moveToFileAction] }];
	          }
	          if (context.preferences.provideRefactorNotApplicableReason) {
	            return [{ name: refactorNameForMoveToFile, description: description2, actions: [{ ...moveToFileAction, notApplicableReason: getLocaleSpecificMessage(Diagnostics.Selection_is_not_a_valid_statement_or_statements) }] }];
	          }
	          return emptyArray;
	        },
	        getEditsForAction: function getRefactorEditsToMoveToFile(context, actionName2, interactiveRefactorArguments) {
	          Debug.assert(actionName2 === refactorNameForMoveToFile, "Wrong refactor invoked");
	          const statements = Debug.checkDefined(getStatementsToMove(context));
	          const { host, program } = context;
	          Debug.assert(interactiveRefactorArguments, "No interactive refactor arguments available");
	          const targetFile = interactiveRefactorArguments.targetFile;
	          if (hasJSFileExtension(targetFile) || hasTSFileExtension(targetFile)) {
	            if (host.fileExists(targetFile) && program.getSourceFile(targetFile) === void 0) {
	              return error(getLocaleSpecificMessage(Diagnostics.Cannot_move_statements_to_the_selected_file));
	            }
	            const edits = ts_textChanges_exports.ChangeTracker.with(context, (t) => doChange4(context, context.file, interactiveRefactorArguments.targetFile, context.program, statements, t, context.host, context.preferences));
	            return { edits, renameFilename: void 0, renameLocation: void 0 };
	          }
	          return error(getLocaleSpecificMessage(Diagnostics.Cannot_move_to_file_selected_file_is_invalid));
	        }
	      });
	    }
	  });

	  // src/services/refactors/convertOverloadListToSingleSignature.ts
	  function getRefactorActionsToConvertOverloadsToOneSignature(context) {
	    const { file, startPosition, program } = context;
	    const info = getConvertableOverloadListAtPosition(file, startPosition, program);
	    if (!info)
	      return emptyArray;
	    return [{
	      name: refactorName6,
	      description: refactorDescription2,
	      actions: [functionOverloadAction]
	    }];
	  }
	  function getRefactorEditsToConvertOverloadsToOneSignature(context) {
	    const { file, startPosition, program } = context;
	    const signatureDecls = getConvertableOverloadListAtPosition(file, startPosition, program);
	    if (!signatureDecls)
	      return void 0;
	    const checker = program.getTypeChecker();
	    const lastDeclaration = signatureDecls[signatureDecls.length - 1];
	    let updated = lastDeclaration;
	    switch (lastDeclaration.kind) {
	      case 173 /* MethodSignature */: {
	        updated = factory.updateMethodSignature(
	          lastDeclaration,
	          lastDeclaration.modifiers,
	          lastDeclaration.name,
	          lastDeclaration.questionToken,
	          lastDeclaration.typeParameters,
	          getNewParametersForCombinedSignature(signatureDecls),
	          lastDeclaration.type
	        );
	        break;
	      }
	      case 174 /* MethodDeclaration */: {
	        updated = factory.updateMethodDeclaration(
	          lastDeclaration,
	          lastDeclaration.modifiers,
	          lastDeclaration.asteriskToken,
	          lastDeclaration.name,
	          lastDeclaration.questionToken,
	          lastDeclaration.typeParameters,
	          getNewParametersForCombinedSignature(signatureDecls),
	          lastDeclaration.type,
	          lastDeclaration.body
	        );
	        break;
	      }
	      case 179 /* CallSignature */: {
	        updated = factory.updateCallSignature(
	          lastDeclaration,
	          lastDeclaration.typeParameters,
	          getNewParametersForCombinedSignature(signatureDecls),
	          lastDeclaration.type
	        );
	        break;
	      }
	      case 176 /* Constructor */: {
	        updated = factory.updateConstructorDeclaration(
	          lastDeclaration,
	          lastDeclaration.modifiers,
	          getNewParametersForCombinedSignature(signatureDecls),
	          lastDeclaration.body
	        );
	        break;
	      }
	      case 180 /* ConstructSignature */: {
	        updated = factory.updateConstructSignature(
	          lastDeclaration,
	          lastDeclaration.typeParameters,
	          getNewParametersForCombinedSignature(signatureDecls),
	          lastDeclaration.type
	        );
	        break;
	      }
	      case 262 /* FunctionDeclaration */: {
	        updated = factory.updateFunctionDeclaration(
	          lastDeclaration,
	          lastDeclaration.modifiers,
	          lastDeclaration.asteriskToken,
	          lastDeclaration.name,
	          lastDeclaration.typeParameters,
	          getNewParametersForCombinedSignature(signatureDecls),
	          lastDeclaration.type,
	          lastDeclaration.body
	        );
	        break;
	      }
	      default:
	        return Debug.failBadSyntaxKind(lastDeclaration, "Unhandled signature kind in overload list conversion refactoring");
	    }
	    if (updated === lastDeclaration) {
	      return;
	    }
	    const edits = ts_textChanges_exports.ChangeTracker.with(context, (t) => {
	      t.replaceNodeRange(file, signatureDecls[0], signatureDecls[signatureDecls.length - 1], updated);
	    });
	    return { renameFilename: void 0, renameLocation: void 0, edits };
	    function getNewParametersForCombinedSignature(signatureDeclarations) {
	      const lastSig = signatureDeclarations[signatureDeclarations.length - 1];
	      if (isFunctionLikeDeclaration(lastSig) && lastSig.body) {
	        signatureDeclarations = signatureDeclarations.slice(0, signatureDeclarations.length - 1);
	      }
	      return factory.createNodeArray([
	        factory.createParameterDeclaration(
	          /*modifiers*/
	          void 0,
	          factory.createToken(26 /* DotDotDotToken */),
	          "args",
	          /*questionToken*/
	          void 0,
	          factory.createUnionTypeNode(map(signatureDeclarations, convertSignatureParametersToTuple))
	        )
	      ]);
	    }
	    function convertSignatureParametersToTuple(decl) {
	      const members = map(decl.parameters, convertParameterToNamedTupleMember);
	      return setEmitFlags(factory.createTupleTypeNode(members), some(members, (m) => !!length(getSyntheticLeadingComments(m))) ? 0 /* None */ : 1 /* SingleLine */);
	    }
	    function convertParameterToNamedTupleMember(p) {
	      Debug.assert(isIdentifier(p.name));
	      const result = setTextRange(
	        factory.createNamedTupleMember(
	          p.dotDotDotToken,
	          p.name,
	          p.questionToken,
	          p.type || factory.createKeywordTypeNode(133 /* AnyKeyword */)
	        ),
	        p
	      );
	      const parameterDocComment = p.symbol && p.symbol.getDocumentationComment(checker);
	      if (parameterDocComment) {
	        const newComment = displayPartsToString(parameterDocComment);
	        if (newComment.length) {
	          setSyntheticLeadingComments(result, [{
	            text: `*
${newComment.split("\n").map((c) => ` * ${c}`).join("\n")}
 `,
	            kind: 3 /* MultiLineCommentTrivia */,
	            pos: -1,
	            end: -1,
	            hasTrailingNewLine: true,
	            hasLeadingNewline: true
	          }]);
	        }
	      }
	      return result;
	    }
	  }
	  function isConvertableSignatureDeclaration(d) {
	    switch (d.kind) {
	      case 173 /* MethodSignature */:
	      case 174 /* MethodDeclaration */:
	      case 179 /* CallSignature */:
	      case 176 /* Constructor */:
	      case 180 /* ConstructSignature */:
	      case 262 /* FunctionDeclaration */:
	        return true;
	    }
	    return false;
	  }
	  function getConvertableOverloadListAtPosition(file, startPosition, program) {
	    const node = getTokenAtPosition(file, startPosition);
	    const containingDecl = findAncestor(node, isConvertableSignatureDeclaration);
	    if (!containingDecl) {
	      return;
	    }
	    if (isFunctionLikeDeclaration(containingDecl) && containingDecl.body && rangeContainsPosition(containingDecl.body, startPosition)) {
	      return;
	    }
	    const checker = program.getTypeChecker();
	    const signatureSymbol = containingDecl.symbol;
	    if (!signatureSymbol) {
	      return;
	    }
	    const decls = signatureSymbol.declarations;
	    if (length(decls) <= 1) {
	      return;
	    }
	    if (!every(decls, (d) => getSourceFileOfNode(d) === file)) {
	      return;
	    }
	    if (!isConvertableSignatureDeclaration(decls[0])) {
	      return;
	    }
	    const kindOne = decls[0].kind;
	    if (!every(decls, (d) => d.kind === kindOne)) {
	      return;
	    }
	    const signatureDecls = decls;
	    if (some(signatureDecls, (d) => !!d.typeParameters || some(d.parameters, (p) => !!p.modifiers || !isIdentifier(p.name)))) {
	      return;
	    }
	    const signatures = mapDefined(signatureDecls, (d) => checker.getSignatureFromDeclaration(d));
	    if (length(signatures) !== length(decls)) {
	      return;
	    }
	    const returnOne = checker.getReturnTypeOfSignature(signatures[0]);
	    if (!every(signatures, (s) => checker.getReturnTypeOfSignature(s) === returnOne)) {
	      return;
	    }
	    return signatureDecls;
	  }
	  var refactorName6, refactorDescription2, functionOverloadAction;
	  var init_convertOverloadListToSingleSignature = __esm({
	    "src/services/refactors/convertOverloadListToSingleSignature.ts"() {
	      init_ts4();
	      init_ts_refactor();
	      refactorName6 = "Convert overload list to single signature";
	      refactorDescription2 = getLocaleSpecificMessage(Diagnostics.Convert_overload_list_to_single_signature);
	      functionOverloadAction = {
	        name: refactorName6,
	        description: refactorDescription2,
	        kind: "refactor.rewrite.function.overloadList"
	      };
	      registerRefactor(refactorName6, {
	        kinds: [functionOverloadAction.kind],
	        getEditsForAction: getRefactorEditsToConvertOverloadsToOneSignature,
	        getAvailableActions: getRefactorActionsToConvertOverloadsToOneSignature
	      });
	    }
	  });

	  // src/services/refactors/addOrRemoveBracesToArrowFunction.ts
	  function getRefactorActionsToRemoveFunctionBraces(context) {
	    const { file, startPosition, triggerReason } = context;
	    const info = getConvertibleArrowFunctionAtPosition(file, startPosition, triggerReason === "invoked");
	    if (!info)
	      return emptyArray;
	    if (!isRefactorErrorInfo(info)) {
	      return [{
	        name: refactorName7,
	        description: refactorDescription3,
	        actions: [
	          info.addBraces ? addBracesAction : removeBracesAction
	        ]
	      }];
	    }
	    if (context.preferences.provideRefactorNotApplicableReason) {
	      return [{
	        name: refactorName7,
	        description: refactorDescription3,
	        actions: [
	          { ...addBracesAction, notApplicableReason: info.error },
	          { ...removeBracesAction, notApplicableReason: info.error }
	        ]
	      }];
	    }
	    return emptyArray;
	  }
	  function getRefactorEditsToRemoveFunctionBraces(context, actionName2) {
	    const { file, startPosition } = context;
	    const info = getConvertibleArrowFunctionAtPosition(file, startPosition);
	    Debug.assert(info && !isRefactorErrorInfo(info), "Expected applicable refactor info");
	    const { expression, returnStatement, func } = info;
	    let body;
	    if (actionName2 === addBracesAction.name) {
	      const returnStatement2 = factory.createReturnStatement(expression);
	      body = factory.createBlock(
	        [returnStatement2],
	        /*multiLine*/
	        true
	      );
	      copyLeadingComments(
	        expression,
	        returnStatement2,
	        file,
	        3 /* MultiLineCommentTrivia */,
	        /*hasTrailingNewLine*/
	        true
	      );
	    } else if (actionName2 === removeBracesAction.name && returnStatement) {
	      const actualExpression = expression || factory.createVoidZero();
	      body = needsParentheses(actualExpression) ? factory.createParenthesizedExpression(actualExpression) : actualExpression;
	      copyTrailingAsLeadingComments(
	        returnStatement,
	        body,
	        file,
	        3 /* MultiLineCommentTrivia */,
	        /*hasTrailingNewLine*/
	        false
	      );
	      copyLeadingComments(
	        returnStatement,
	        body,
	        file,
	        3 /* MultiLineCommentTrivia */,
	        /*hasTrailingNewLine*/
	        false
	      );
	      copyTrailingComments(
	        returnStatement,
	        body,
	        file,
	        3 /* MultiLineCommentTrivia */,
	        /*hasTrailingNewLine*/
	        false
	      );
	    } else {
	      Debug.fail("invalid action");
	    }
	    const edits = ts_textChanges_exports.ChangeTracker.with(context, (t) => {
	      t.replaceNode(file, func.body, body);
	    });
	    return { renameFilename: void 0, renameLocation: void 0, edits };
	  }
	  function getConvertibleArrowFunctionAtPosition(file, startPosition, considerFunctionBodies = true, kind) {
	    const node = getTokenAtPosition(file, startPosition);
	    const func = getContainingFunction(node);
	    if (!func) {
	      return {
	        error: getLocaleSpecificMessage(Diagnostics.Could_not_find_a_containing_arrow_function)
	      };
	    }
	    if (!isArrowFunction(func)) {
	      return {
	        error: getLocaleSpecificMessage(Diagnostics.Containing_function_is_not_an_arrow_function)
	      };
	    }
	    if (!rangeContainsRange(func, node) || rangeContainsRange(func.body, node) && !considerFunctionBodies) {
	      return void 0;
	    }
	    if (refactorKindBeginsWith(addBracesAction.kind, kind) && isExpression(func.body)) {
	      return { func, addBraces: true, expression: func.body };
	    } else if (refactorKindBeginsWith(removeBracesAction.kind, kind) && isBlock(func.body) && func.body.statements.length === 1) {
	      const firstStatement = first(func.body.statements);
	      if (isReturnStatement(firstStatement)) {
	        const expression = firstStatement.expression && isObjectLiteralExpression(getLeftmostExpression(
	          firstStatement.expression,
	          /*stopAtCallExpressions*/
	          false
	        )) ? factory.createParenthesizedExpression(firstStatement.expression) : firstStatement.expression;
	        return { func, addBraces: false, expression, returnStatement: firstStatement };
	      }
	    }
	    return void 0;
	  }
	  var refactorName7, refactorDescription3, addBracesAction, removeBracesAction;
	  var init_addOrRemoveBracesToArrowFunction = __esm({
	    "src/services/refactors/addOrRemoveBracesToArrowFunction.ts"() {
	      init_ts4();
	      init_ts_refactor();
	      refactorName7 = "Add or remove braces in an arrow function";
	      refactorDescription3 = getLocaleSpecificMessage(Diagnostics.Add_or_remove_braces_in_an_arrow_function);
	      addBracesAction = {
	        name: "Add braces to arrow function",
	        description: getLocaleSpecificMessage(Diagnostics.Add_braces_to_arrow_function),
	        kind: "refactor.rewrite.arrow.braces.add"
	      };
	      removeBracesAction = {
	        name: "Remove braces from arrow function",
	        description: getLocaleSpecificMessage(Diagnostics.Remove_braces_from_arrow_function),
	        kind: "refactor.rewrite.arrow.braces.remove"
	      };
	      registerRefactor(refactorName7, {
	        kinds: [removeBracesAction.kind],
	        getEditsForAction: getRefactorEditsToRemoveFunctionBraces,
	        getAvailableActions: getRefactorActionsToRemoveFunctionBraces
	      });
	    }
	  });

	  // src/services/_namespaces/ts.refactor.addOrRemoveBracesToArrowFunction.ts
	  var ts_refactor_addOrRemoveBracesToArrowFunction_exports = {};
	  var init_ts_refactor_addOrRemoveBracesToArrowFunction = __esm({
	    "src/services/_namespaces/ts.refactor.addOrRemoveBracesToArrowFunction.ts"() {
	      init_convertOverloadListToSingleSignature();
	      init_addOrRemoveBracesToArrowFunction();
	    }
	  });

	  // src/services/refactors/convertArrowFunctionOrFunctionExpression.ts
	  function getRefactorActionsToConvertFunctionExpressions(context) {
	    const { file, startPosition, program, kind } = context;
	    const info = getFunctionInfo(file, startPosition, program);
	    if (!info)
	      return emptyArray;
	    const { selectedVariableDeclaration, func } = info;
	    const possibleActions = [];
	    const errors = [];
	    if (refactorKindBeginsWith(toNamedFunctionAction.kind, kind)) {
	      const error2 = selectedVariableDeclaration || isArrowFunction(func) && isVariableDeclaration(func.parent) ? void 0 : getLocaleSpecificMessage(Diagnostics.Could_not_convert_to_named_function);
	      if (error2) {
	        errors.push({ ...toNamedFunctionAction, notApplicableReason: error2 });
	      } else {
	        possibleActions.push(toNamedFunctionAction);
	      }
	    }
	    if (refactorKindBeginsWith(toAnonymousFunctionAction.kind, kind)) {
	      const error2 = !selectedVariableDeclaration && isArrowFunction(func) ? void 0 : getLocaleSpecificMessage(Diagnostics.Could_not_convert_to_anonymous_function);
	      if (error2) {
	        errors.push({ ...toAnonymousFunctionAction, notApplicableReason: error2 });
	      } else {
	        possibleActions.push(toAnonymousFunctionAction);
	      }
	    }
	    if (refactorKindBeginsWith(toArrowFunctionAction.kind, kind)) {
	      const error2 = isFunctionExpression(func) ? void 0 : getLocaleSpecificMessage(Diagnostics.Could_not_convert_to_arrow_function);
	      if (error2) {
	        errors.push({ ...toArrowFunctionAction, notApplicableReason: error2 });
	      } else {
	        possibleActions.push(toArrowFunctionAction);
	      }
	    }
	    return [{
	      name: refactorName8,
	      description: refactorDescription4,
	      actions: possibleActions.length === 0 && context.preferences.provideRefactorNotApplicableReason ? errors : possibleActions
	    }];
	  }
	  function getRefactorEditsToConvertFunctionExpressions(context, actionName2) {
	    const { file, startPosition, program } = context;
	    const info = getFunctionInfo(file, startPosition, program);
	    if (!info)
	      return void 0;
	    const { func } = info;
	    const edits = [];
	    switch (actionName2) {
	      case toAnonymousFunctionAction.name:
	        edits.push(...getEditInfoForConvertToAnonymousFunction(context, func));
	        break;
	      case toNamedFunctionAction.name:
	        const variableInfo = getVariableInfo(func);
	        if (!variableInfo)
	          return void 0;
	        edits.push(...getEditInfoForConvertToNamedFunction(context, func, variableInfo));
	        break;
	      case toArrowFunctionAction.name:
	        if (!isFunctionExpression(func))
	          return void 0;
	        edits.push(...getEditInfoForConvertToArrowFunction(context, func));
	        break;
	      default:
	        return Debug.fail("invalid action");
	    }
	    return { renameFilename: void 0, renameLocation: void 0, edits };
	  }
	  function containingThis(node) {
	    let containsThis = false;
	    node.forEachChild(function checkThis(child) {
	      if (isThis(child)) {
	        containsThis = true;
	        return;
	      }
	      if (!isClassLike(child) && !isFunctionDeclaration(child) && !isFunctionExpression(child)) {
	        forEachChild(child, checkThis);
	      }
	    });
	    return containsThis;
	  }
	  function getFunctionInfo(file, startPosition, program) {
	    const token = getTokenAtPosition(file, startPosition);
	    const typeChecker = program.getTypeChecker();
	    const func = tryGetFunctionFromVariableDeclaration(file, typeChecker, token.parent);
	    if (func && !containingThis(func.body) && !typeChecker.containsArgumentsReference(func)) {
	      return { selectedVariableDeclaration: true, func };
	    }
	    const maybeFunc = getContainingFunction(token);
	    if (maybeFunc && (isFunctionExpression(maybeFunc) || isArrowFunction(maybeFunc)) && !rangeContainsRange(maybeFunc.body, token) && !containingThis(maybeFunc.body) && !typeChecker.containsArgumentsReference(maybeFunc)) {
	      if (isFunctionExpression(maybeFunc) && isFunctionReferencedInFile(file, typeChecker, maybeFunc))
	        return void 0;
	      return { selectedVariableDeclaration: false, func: maybeFunc };
	    }
	    return void 0;
	  }
	  function isSingleVariableDeclaration(parent2) {
	    return isVariableDeclaration(parent2) || isVariableDeclarationList(parent2) && parent2.declarations.length === 1;
	  }
	  function tryGetFunctionFromVariableDeclaration(sourceFile, typeChecker, parent2) {
	    if (!isSingleVariableDeclaration(parent2)) {
	      return void 0;
	    }
	    const variableDeclaration = isVariableDeclaration(parent2) ? parent2 : first(parent2.declarations);
	    const initializer = variableDeclaration.initializer;
	    if (initializer && (isArrowFunction(initializer) || isFunctionExpression(initializer) && !isFunctionReferencedInFile(sourceFile, typeChecker, initializer))) {
	      return initializer;
	    }
	    return void 0;
	  }
	  function convertToBlock(body) {
	    if (isExpression(body)) {
	      const returnStatement = factory.createReturnStatement(body);
	      const file = body.getSourceFile();
	      setTextRange(returnStatement, body);
	      suppressLeadingAndTrailingTrivia(returnStatement);
	      copyTrailingAsLeadingComments(
	        body,
	        returnStatement,
	        file,
	        /*commentKind*/
	        void 0,
	        /*hasTrailingNewLine*/
	        true
	      );
	      return factory.createBlock(
	        [returnStatement],
	        /*multiLine*/
	        true
	      );
	    } else {
	      return body;
	    }
	  }
	  function getVariableInfo(func) {
	    const variableDeclaration = func.parent;
	    if (!isVariableDeclaration(variableDeclaration) || !isVariableDeclarationInVariableStatement(variableDeclaration))
	      return void 0;
	    const variableDeclarationList = variableDeclaration.parent;
	    const statement = variableDeclarationList.parent;
	    if (!isVariableDeclarationList(variableDeclarationList) || !isVariableStatement(statement) || !isIdentifier(variableDeclaration.name))
	      return void 0;
	    return { variableDeclaration, variableDeclarationList, statement, name: variableDeclaration.name };
	  }
	  function getEditInfoForConvertToAnonymousFunction(context, func) {
	    const { file } = context;
	    const body = convertToBlock(func.body);
	    const newNode = factory.createFunctionExpression(
	      func.modifiers,
	      func.asteriskToken,
	      /*name*/
	      void 0,
	      func.typeParameters,
	      func.parameters,
	      func.type,
	      body
	    );
	    return ts_textChanges_exports.ChangeTracker.with(context, (t) => t.replaceNode(file, func, newNode));
	  }
	  function getEditInfoForConvertToNamedFunction(context, func, variableInfo) {
	    const { file } = context;
	    const body = convertToBlock(func.body);
	    const { variableDeclaration, variableDeclarationList, statement, name } = variableInfo;
	    suppressLeadingTrivia(statement);
	    const modifiersFlags = getCombinedModifierFlags(variableDeclaration) & 32 /* Export */ | getEffectiveModifierFlags(func);
	    const modifiers = factory.createModifiersFromModifierFlags(modifiersFlags);
	    const newNode = factory.createFunctionDeclaration(length(modifiers) ? modifiers : void 0, func.asteriskToken, name, func.typeParameters, func.parameters, func.type, body);
	    if (variableDeclarationList.declarations.length === 1) {
	      return ts_textChanges_exports.ChangeTracker.with(context, (t) => t.replaceNode(file, statement, newNode));
	    } else {
	      return ts_textChanges_exports.ChangeTracker.with(context, (t) => {
	        t.delete(file, variableDeclaration);
	        t.insertNodeAfter(file, statement, newNode);
	      });
	    }
	  }
	  function getEditInfoForConvertToArrowFunction(context, func) {
	    const { file } = context;
	    const statements = func.body.statements;
	    const head = statements[0];
	    let body;
	    if (canBeConvertedToExpression(func.body, head)) {
	      body = head.expression;
	      suppressLeadingAndTrailingTrivia(body);
	      copyComments(head, body);
	    } else {
	      body = func.body;
	    }
	    const newNode = factory.createArrowFunction(func.modifiers, func.typeParameters, func.parameters, func.type, factory.createToken(39 /* EqualsGreaterThanToken */), body);
	    return ts_textChanges_exports.ChangeTracker.with(context, (t) => t.replaceNode(file, func, newNode));
	  }
	  function canBeConvertedToExpression(body, head) {
	    return body.statements.length === 1 && (isReturnStatement(head) && !!head.expression);
	  }
	  function isFunctionReferencedInFile(sourceFile, typeChecker, node) {
	    return !!node.name && ts_FindAllReferences_exports.Core.isSymbolReferencedInFile(node.name, typeChecker, sourceFile);
	  }
	  var refactorName8, refactorDescription4, toAnonymousFunctionAction, toNamedFunctionAction, toArrowFunctionAction;
	  var init_convertArrowFunctionOrFunctionExpression = __esm({
	    "src/services/refactors/convertArrowFunctionOrFunctionExpression.ts"() {
	      init_ts4();
	      init_ts_refactor();
	      refactorName8 = "Convert arrow function or function expression";
	      refactorDescription4 = getLocaleSpecificMessage(Diagnostics.Convert_arrow_function_or_function_expression);
	      toAnonymousFunctionAction = {
	        name: "Convert to anonymous function",
	        description: getLocaleSpecificMessage(Diagnostics.Convert_to_anonymous_function),
	        kind: "refactor.rewrite.function.anonymous"
	      };
	      toNamedFunctionAction = {
	        name: "Convert to named function",
	        description: getLocaleSpecificMessage(Diagnostics.Convert_to_named_function),
	        kind: "refactor.rewrite.function.named"
	      };
	      toArrowFunctionAction = {
	        name: "Convert to arrow function",
	        description: getLocaleSpecificMessage(Diagnostics.Convert_to_arrow_function),
	        kind: "refactor.rewrite.function.arrow"
	      };
	      registerRefactor(refactorName8, {
	        kinds: [
	          toAnonymousFunctionAction.kind,
	          toNamedFunctionAction.kind,
	          toArrowFunctionAction.kind
	        ],
	        getEditsForAction: getRefactorEditsToConvertFunctionExpressions,
	        getAvailableActions: getRefactorActionsToConvertFunctionExpressions
	      });
	    }
	  });

	  // src/services/_namespaces/ts.refactor.convertArrowFunctionOrFunctionExpression.ts
	  var ts_refactor_convertArrowFunctionOrFunctionExpression_exports = {};
	  var init_ts_refactor_convertArrowFunctionOrFunctionExpression = __esm({
	    "src/services/_namespaces/ts.refactor.convertArrowFunctionOrFunctionExpression.ts"() {
	      init_convertArrowFunctionOrFunctionExpression();
	    }
	  });

	  // src/services/refactors/convertParamsToDestructuredObject.ts
	  function getRefactorActionsToConvertParametersToDestructuredObject(context) {
	    const { file, startPosition } = context;
	    const isJSFile = isSourceFileJS(file);
	    if (isJSFile)
	      return emptyArray;
	    const functionDeclaration = getFunctionDeclarationAtPosition(file, startPosition, context.program.getTypeChecker());
	    if (!functionDeclaration)
	      return emptyArray;
	    return [{
	      name: refactorName9,
	      description: refactorDescription5,
	      actions: [toDestructuredAction]
	    }];
	  }
	  function getRefactorEditsToConvertParametersToDestructuredObject(context, actionName2) {
	    Debug.assert(actionName2 === refactorName9, "Unexpected action name");
	    const { file, startPosition, program, cancellationToken, host } = context;
	    const functionDeclaration = getFunctionDeclarationAtPosition(file, startPosition, program.getTypeChecker());
	    if (!functionDeclaration || !cancellationToken)
	      return void 0;
	    const groupedReferences = getGroupedReferences(functionDeclaration, program, cancellationToken);
	    if (groupedReferences.valid) {
	      const edits = ts_textChanges_exports.ChangeTracker.with(context, (t) => doChange5(file, program, host, t, functionDeclaration, groupedReferences));
	      return { renameFilename: void 0, renameLocation: void 0, edits };
	    }
	    return { edits: [] };
	  }
	  function doChange5(sourceFile, program, host, changes, functionDeclaration, groupedReferences) {
	    const signature = groupedReferences.signature;
	    const newFunctionDeclarationParams = map(createNewParameters(functionDeclaration, program, host), (param) => getSynthesizedDeepClone(param));
	    if (signature) {
	      const newSignatureParams = map(createNewParameters(signature, program, host), (param) => getSynthesizedDeepClone(param));
	      replaceParameters(signature, newSignatureParams);
	    }
	    replaceParameters(functionDeclaration, newFunctionDeclarationParams);
	    const functionCalls = sortAndDeduplicate(
	      groupedReferences.functionCalls,
	      /*comparer*/
	      (a, b) => compareValues(a.pos, b.pos)
	    );
	    for (const call of functionCalls) {
	      if (call.arguments && call.arguments.length) {
	        const newArgument = getSynthesizedDeepClone(
	          createNewArgument(functionDeclaration, call.arguments),
	          /*includeTrivia*/
	          true
	        );
	        changes.replaceNodeRange(
	          getSourceFileOfNode(call),
	          first(call.arguments),
	          last(call.arguments),
	          newArgument,
	          { leadingTriviaOption: ts_textChanges_exports.LeadingTriviaOption.IncludeAll, trailingTriviaOption: ts_textChanges_exports.TrailingTriviaOption.Include }
	        );
	      }
	    }
	    function replaceParameters(declarationOrSignature, parameterDeclarations) {
	      changes.replaceNodeRangeWithNodes(
	        sourceFile,
	        first(declarationOrSignature.parameters),
	        last(declarationOrSignature.parameters),
	        parameterDeclarations,
	        {
	          joiner: ", ",
	          // indentation is set to 0 because otherwise the object parameter will be indented if there is a `this` parameter
	          indentation: 0,
	          leadingTriviaOption: ts_textChanges_exports.LeadingTriviaOption.IncludeAll,
	          trailingTriviaOption: ts_textChanges_exports.TrailingTriviaOption.Include
	        }
	      );
	    }
	  }
	  function getGroupedReferences(functionDeclaration, program, cancellationToken) {
	    const functionNames = getFunctionNames(functionDeclaration);
	    const classNames = isConstructorDeclaration(functionDeclaration) ? getClassNames(functionDeclaration) : [];
	    const names = deduplicate([...functionNames, ...classNames], equateValues);
	    const checker = program.getTypeChecker();
	    const references = flatMap(
	      names,
	      /*mapfn*/
	      (name) => ts_FindAllReferences_exports.getReferenceEntriesForNode(-1, name, program, program.getSourceFiles(), cancellationToken)
	    );
	    const groupedReferences = groupReferences(references);
	    if (!every(
	      groupedReferences.declarations,
	      /*callback*/
	      (decl) => contains(names, decl)
	    )) {
	      groupedReferences.valid = false;
	    }
	    return groupedReferences;
	    function groupReferences(referenceEntries) {
	      const classReferences = { accessExpressions: [], typeUsages: [] };
	      const groupedReferences2 = { functionCalls: [], declarations: [], classReferences, valid: true };
	      const functionSymbols = map(functionNames, getSymbolTargetAtLocation);
	      const classSymbols = map(classNames, getSymbolTargetAtLocation);
	      const isConstructor = isConstructorDeclaration(functionDeclaration);
	      const contextualSymbols = map(functionNames, (name) => getSymbolForContextualType(name, checker));
	      for (const entry of referenceEntries) {
	        if (entry.kind === ts_FindAllReferences_exports.EntryKind.Span) {
	          groupedReferences2.valid = false;
	          continue;
	        }
	        if (contains(contextualSymbols, getSymbolTargetAtLocation(entry.node))) {
	          if (isValidMethodSignature(entry.node.parent)) {
	            groupedReferences2.signature = entry.node.parent;
	            continue;
	          }
	          const call = entryToFunctionCall(entry);
	          if (call) {
	            groupedReferences2.functionCalls.push(call);
	            continue;
	          }
	        }
	        const contextualSymbol = getSymbolForContextualType(entry.node, checker);
	        if (contextualSymbol && contains(contextualSymbols, contextualSymbol)) {
	          const decl = entryToDeclaration(entry);
	          if (decl) {
	            groupedReferences2.declarations.push(decl);
	            continue;
	          }
	        }
	        if (contains(functionSymbols, getSymbolTargetAtLocation(entry.node)) || isNewExpressionTarget(entry.node)) {
	          const importOrExportReference = entryToImportOrExport(entry);
	          if (importOrExportReference) {
	            continue;
	          }
	          const decl = entryToDeclaration(entry);
	          if (decl) {
	            groupedReferences2.declarations.push(decl);
	            continue;
	          }
	          const call = entryToFunctionCall(entry);
	          if (call) {
	            groupedReferences2.functionCalls.push(call);
	            continue;
	          }
	        }
	        if (isConstructor && contains(classSymbols, getSymbolTargetAtLocation(entry.node))) {
	          const importOrExportReference = entryToImportOrExport(entry);
	          if (importOrExportReference) {
	            continue;
	          }
	          const decl = entryToDeclaration(entry);
	          if (decl) {
	            groupedReferences2.declarations.push(decl);
	            continue;
	          }
	          const accessExpression = entryToAccessExpression(entry);
	          if (accessExpression) {
	            classReferences.accessExpressions.push(accessExpression);
	            continue;
	          }
	          if (isClassDeclaration(functionDeclaration.parent)) {
	            const type = entryToType(entry);
	            if (type) {
	              classReferences.typeUsages.push(type);
	              continue;
	            }
	          }
	        }
	        groupedReferences2.valid = false;
	      }
	      return groupedReferences2;
	    }
	    function getSymbolTargetAtLocation(node) {
	      const symbol = checker.getSymbolAtLocation(node);
	      return symbol && getSymbolTarget(symbol, checker);
	    }
	  }
	  function getSymbolForContextualType(node, checker) {
	    const element = getContainingObjectLiteralElement(node);
	    if (element) {
	      const contextualType = checker.getContextualTypeForObjectLiteralElement(element);
	      const symbol = contextualType == null ? void 0 : contextualType.getSymbol();
	      if (symbol && !(getCheckFlags(symbol) & 6 /* Synthetic */)) {
	        return symbol;
	      }
	    }
	  }
	  function entryToImportOrExport(entry) {
	    const node = entry.node;
	    if (isImportSpecifier(node.parent) || isImportClause(node.parent) || isImportEqualsDeclaration(node.parent) || isNamespaceImport(node.parent)) {
	      return node;
	    }
	    if (isExportSpecifier(node.parent) || isExportAssignment(node.parent)) {
	      return node;
	    }
	    return void 0;
	  }
	  function entryToDeclaration(entry) {
	    if (isDeclaration(entry.node.parent)) {
	      return entry.node;
	    }
	    return void 0;
	  }
	  function entryToFunctionCall(entry) {
	    if (entry.node.parent) {
	      const functionReference = entry.node;
	      const parent2 = functionReference.parent;
	      switch (parent2.kind) {
	        case 213 /* CallExpression */:
	        case 214 /* NewExpression */:
	          const callOrNewExpression = tryCast(parent2, isCallOrNewExpression);
	          if (callOrNewExpression && callOrNewExpression.expression === functionReference) {
	            return callOrNewExpression;
	          }
	          break;
	        case 211 /* PropertyAccessExpression */:
	          const propertyAccessExpression = tryCast(parent2, isPropertyAccessExpression);
	          if (propertyAccessExpression && propertyAccessExpression.parent && propertyAccessExpression.name === functionReference) {
	            const callOrNewExpression2 = tryCast(propertyAccessExpression.parent, isCallOrNewExpression);
	            if (callOrNewExpression2 && callOrNewExpression2.expression === propertyAccessExpression) {
	              return callOrNewExpression2;
	            }
	          }
	          break;
	        case 212 /* ElementAccessExpression */:
	          const elementAccessExpression = tryCast(parent2, isElementAccessExpression);
	          if (elementAccessExpression && elementAccessExpression.parent && elementAccessExpression.argumentExpression === functionReference) {
	            const callOrNewExpression2 = tryCast(elementAccessExpression.parent, isCallOrNewExpression);
	            if (callOrNewExpression2 && callOrNewExpression2.expression === elementAccessExpression) {
	              return callOrNewExpression2;
	            }
	          }
	          break;
	      }
	    }
	    return void 0;
	  }
	  function entryToAccessExpression(entry) {
	    if (entry.node.parent) {
	      const reference = entry.node;
	      const parent2 = reference.parent;
	      switch (parent2.kind) {
	        case 211 /* PropertyAccessExpression */:
	          const propertyAccessExpression = tryCast(parent2, isPropertyAccessExpression);
	          if (propertyAccessExpression && propertyAccessExpression.expression === reference) {
	            return propertyAccessExpression;
	          }
	          break;
	        case 212 /* ElementAccessExpression */:
	          const elementAccessExpression = tryCast(parent2, isElementAccessExpression);
	          if (elementAccessExpression && elementAccessExpression.expression === reference) {
	            return elementAccessExpression;
	          }
	          break;
	      }
	    }
	    return void 0;
	  }
	  function entryToType(entry) {
	    const reference = entry.node;
	    if (getMeaningFromLocation(reference) === 2 /* Type */ || isExpressionWithTypeArgumentsInClassExtendsClause(reference.parent)) {
	      return reference;
	    }
	    return void 0;
	  }
	  function getFunctionDeclarationAtPosition(file, startPosition, checker) {
	    const node = getTouchingToken(file, startPosition);
	    const functionDeclaration = getContainingFunctionDeclaration(node);
	    if (isTopLevelJSDoc(node))
	      return void 0;
	    if (functionDeclaration && isValidFunctionDeclaration(functionDeclaration, checker) && rangeContainsRange(functionDeclaration, node) && !(functionDeclaration.body && rangeContainsRange(functionDeclaration.body, node)))
	      return functionDeclaration;
	    return void 0;
	  }
	  function isTopLevelJSDoc(node) {
	    const containingJSDoc = findAncestor(node, isJSDocNode);
	    if (containingJSDoc) {
	      const containingNonJSDoc = findAncestor(containingJSDoc, (n) => !isJSDocNode(n));
	      return !!containingNonJSDoc && isFunctionLikeDeclaration(containingNonJSDoc);
	    }
	    return false;
	  }
	  function isValidMethodSignature(node) {
	    return isMethodSignature(node) && (isInterfaceDeclaration(node.parent) || isTypeLiteralNode(node.parent));
	  }
	  function isValidFunctionDeclaration(functionDeclaration, checker) {
	    var _a;
	    if (!isValidParameterNodeArray(functionDeclaration.parameters, checker))
	      return false;
	    switch (functionDeclaration.kind) {
	      case 262 /* FunctionDeclaration */:
	        return hasNameOrDefault(functionDeclaration) && isSingleImplementation(functionDeclaration, checker);
	      case 174 /* MethodDeclaration */:
	        if (isObjectLiteralExpression(functionDeclaration.parent)) {
	          const contextualSymbol = getSymbolForContextualType(functionDeclaration.name, checker);
	          return ((_a = contextualSymbol == null ? void 0 : contextualSymbol.declarations) == null ? void 0 : _a.length) === 1 && isSingleImplementation(functionDeclaration, checker);
	        }
	        return isSingleImplementation(functionDeclaration, checker);
	      case 176 /* Constructor */:
	        if (isClassDeclaration(functionDeclaration.parent)) {
	          return hasNameOrDefault(functionDeclaration.parent) && isSingleImplementation(functionDeclaration, checker);
	        } else {
	          return isValidVariableDeclaration(functionDeclaration.parent.parent) && isSingleImplementation(functionDeclaration, checker);
	        }
	      case 218 /* FunctionExpression */:
	      case 219 /* ArrowFunction */:
	        return isValidVariableDeclaration(functionDeclaration.parent);
	    }
	    return false;
	  }
	  function isSingleImplementation(functionDeclaration, checker) {
	    return !!functionDeclaration.body && !checker.isImplementationOfOverload(functionDeclaration);
	  }
	  function hasNameOrDefault(functionOrClassDeclaration) {
	    if (!functionOrClassDeclaration.name) {
	      const defaultKeyword = findModifier(functionOrClassDeclaration, 90 /* DefaultKeyword */);
	      return !!defaultKeyword;
	    }
	    return true;
	  }
	  function isValidParameterNodeArray(parameters, checker) {
	    return getRefactorableParametersLength(parameters) >= minimumParameterLength && every(
	      parameters,
	      /*callback*/
	      (paramDecl) => isValidParameterDeclaration(paramDecl, checker)
	    );
	  }
	  function isValidParameterDeclaration(parameterDeclaration, checker) {
	    if (isRestParameter(parameterDeclaration)) {
	      const type = checker.getTypeAtLocation(parameterDeclaration);
	      if (!checker.isArrayType(type) && !checker.isTupleType(type))
	        return false;
	    }
	    return !parameterDeclaration.modifiers && isIdentifier(parameterDeclaration.name);
	  }
	  function isValidVariableDeclaration(node) {
	    return isVariableDeclaration(node) && isVarConst(node) && isIdentifier(node.name) && !node.type;
	  }
	  function hasThisParameter(parameters) {
	    return parameters.length > 0 && isThis(parameters[0].name);
	  }
	  function getRefactorableParametersLength(parameters) {
	    if (hasThisParameter(parameters)) {
	      return parameters.length - 1;
	    }
	    return parameters.length;
	  }
	  function getRefactorableParameters(parameters) {
	    if (hasThisParameter(parameters)) {
	      parameters = factory.createNodeArray(parameters.slice(1), parameters.hasTrailingComma);
	    }
	    return parameters;
	  }
	  function createPropertyOrShorthandAssignment(name, initializer) {
	    if (isIdentifier(initializer) && getTextOfIdentifierOrLiteral(initializer) === name) {
	      return factory.createShorthandPropertyAssignment(name);
	    }
	    return factory.createPropertyAssignment(name, initializer);
	  }
	  function createNewArgument(functionDeclaration, functionArguments) {
	    const parameters = getRefactorableParameters(functionDeclaration.parameters);
	    const hasRestParameter2 = isRestParameter(last(parameters));
	    const nonRestArguments = hasRestParameter2 ? functionArguments.slice(0, parameters.length - 1) : functionArguments;
	    const properties = map(nonRestArguments, (arg, i) => {
	      const parameterName = getParameterName(parameters[i]);
	      const property = createPropertyOrShorthandAssignment(parameterName, arg);
	      suppressLeadingAndTrailingTrivia(property.name);
	      if (isPropertyAssignment(property))
	        suppressLeadingAndTrailingTrivia(property.initializer);
	      copyComments(arg, property);
	      return property;
	    });
	    if (hasRestParameter2 && functionArguments.length >= parameters.length) {
	      const restArguments = functionArguments.slice(parameters.length - 1);
	      const restProperty = factory.createPropertyAssignment(getParameterName(last(parameters)), factory.createArrayLiteralExpression(restArguments));
	      properties.push(restProperty);
	    }
	    const objectLiteral = factory.createObjectLiteralExpression(
	      properties,
	      /*multiLine*/
	      false
	    );
	    return objectLiteral;
	  }
	  function createNewParameters(functionDeclaration, program, host) {
	    const checker = program.getTypeChecker();
	    const refactorableParameters = getRefactorableParameters(functionDeclaration.parameters);
	    const bindingElements = map(refactorableParameters, createBindingElementFromParameterDeclaration);
	    const objectParameterName = factory.createObjectBindingPattern(bindingElements);
	    const objectParameterType = createParameterTypeNode(refactorableParameters);
	    let objectInitializer;
	    if (every(refactorableParameters, isOptionalParameter)) {
	      objectInitializer = factory.createObjectLiteralExpression();
	    }
	    const objectParameter = factory.createParameterDeclaration(
	      /*modifiers*/
	      void 0,
	      /*dotDotDotToken*/
	      void 0,
	      objectParameterName,
	      /*questionToken*/
	      void 0,
	      objectParameterType,
	      objectInitializer
	    );
	    if (hasThisParameter(functionDeclaration.parameters)) {
	      const thisParameter = functionDeclaration.parameters[0];
	      const newThisParameter = factory.createParameterDeclaration(
	        /*modifiers*/
	        void 0,
	        /*dotDotDotToken*/
	        void 0,
	        thisParameter.name,
	        /*questionToken*/
	        void 0,
	        thisParameter.type
	      );
	      suppressLeadingAndTrailingTrivia(newThisParameter.name);
	      copyComments(thisParameter.name, newThisParameter.name);
	      if (thisParameter.type) {
	        suppressLeadingAndTrailingTrivia(newThisParameter.type);
	        copyComments(thisParameter.type, newThisParameter.type);
	      }
	      return factory.createNodeArray([newThisParameter, objectParameter]);
	    }
	    return factory.createNodeArray([objectParameter]);
	    function createBindingElementFromParameterDeclaration(parameterDeclaration) {
	      const element = factory.createBindingElement(
	        /*dotDotDotToken*/
	        void 0,
	        /*propertyName*/
	        void 0,
	        getParameterName(parameterDeclaration),
	        isRestParameter(parameterDeclaration) && isOptionalParameter(parameterDeclaration) ? factory.createArrayLiteralExpression() : parameterDeclaration.initializer
	      );
	      suppressLeadingAndTrailingTrivia(element);
	      if (parameterDeclaration.initializer && element.initializer) {
	        copyComments(parameterDeclaration.initializer, element.initializer);
	      }
	      return element;
	    }
	    function createParameterTypeNode(parameters) {
	      const members = map(parameters, createPropertySignatureFromParameterDeclaration);
	      const typeNode = addEmitFlags(factory.createTypeLiteralNode(members), 1 /* SingleLine */);
	      return typeNode;
	    }
	    function createPropertySignatureFromParameterDeclaration(parameterDeclaration) {
	      let parameterType = parameterDeclaration.type;
	      if (!parameterType && (parameterDeclaration.initializer || isRestParameter(parameterDeclaration))) {
	        parameterType = getTypeNode3(parameterDeclaration);
	      }
	      const propertySignature = factory.createPropertySignature(
	        /*modifiers*/
	        void 0,
	        getParameterName(parameterDeclaration),
	        isOptionalParameter(parameterDeclaration) ? factory.createToken(58 /* QuestionToken */) : parameterDeclaration.questionToken,
	        parameterType
	      );
	      suppressLeadingAndTrailingTrivia(propertySignature);
	      copyComments(parameterDeclaration.name, propertySignature.name);
	      if (parameterDeclaration.type && propertySignature.type) {
	        copyComments(parameterDeclaration.type, propertySignature.type);
	      }
	      return propertySignature;
	    }
	    function getTypeNode3(node) {
	      const type = checker.getTypeAtLocation(node);
	      return getTypeNodeIfAccessible(type, node, program, host);
	    }
	    function isOptionalParameter(parameterDeclaration) {
	      if (isRestParameter(parameterDeclaration)) {
	        const type = checker.getTypeAtLocation(parameterDeclaration);
	        return !checker.isTupleType(type);
	      }
	      return checker.isOptionalParameter(parameterDeclaration);
	    }
	  }
	  function getParameterName(paramDeclaration) {
	    return getTextOfIdentifierOrLiteral(paramDeclaration.name);
	  }
	  function getClassNames(constructorDeclaration) {
	    switch (constructorDeclaration.parent.kind) {
	      case 263 /* ClassDeclaration */:
	        const classDeclaration = constructorDeclaration.parent;
	        if (classDeclaration.name)
	          return [classDeclaration.name];
	        const defaultModifier = Debug.checkDefined(
	          findModifier(classDeclaration, 90 /* DefaultKeyword */),
	          "Nameless class declaration should be a default export"
	        );
	        return [defaultModifier];
	      case 231 /* ClassExpression */:
	        const classExpression = constructorDeclaration.parent;
	        const variableDeclaration = constructorDeclaration.parent.parent;
	        const className = classExpression.name;
	        if (className)
	          return [className, variableDeclaration.name];
	        return [variableDeclaration.name];
	    }
	  }
	  function getFunctionNames(functionDeclaration) {
	    switch (functionDeclaration.kind) {
	      case 262 /* FunctionDeclaration */:
	        if (functionDeclaration.name)
	          return [functionDeclaration.name];
	        const defaultModifier = Debug.checkDefined(
	          findModifier(functionDeclaration, 90 /* DefaultKeyword */),
	          "Nameless function declaration should be a default export"
	        );
	        return [defaultModifier];
	      case 174 /* MethodDeclaration */:
	        return [functionDeclaration.name];
	      case 176 /* Constructor */:
	        const ctrKeyword = Debug.checkDefined(
	          findChildOfKind(functionDeclaration, 137 /* ConstructorKeyword */, functionDeclaration.getSourceFile()),
	          "Constructor declaration should have constructor keyword"
	        );
	        if (functionDeclaration.parent.kind === 231 /* ClassExpression */) {
	          const variableDeclaration = functionDeclaration.parent.parent;
	          return [variableDeclaration.name, ctrKeyword];
	        }
	        return [ctrKeyword];
	      case 219 /* ArrowFunction */:
	        return [functionDeclaration.parent.name];
	      case 218 /* FunctionExpression */:
	        if (functionDeclaration.name)
	          return [functionDeclaration.name, functionDeclaration.parent.name];
	        return [functionDeclaration.parent.name];
	      default:
	        return Debug.assertNever(functionDeclaration, `Unexpected function declaration kind ${functionDeclaration.kind}`);
	    }
	  }
	  var refactorName9, minimumParameterLength, refactorDescription5, toDestructuredAction;
	  var init_convertParamsToDestructuredObject = __esm({
	    "src/services/refactors/convertParamsToDestructuredObject.ts"() {
	      init_ts4();
	      init_ts_refactor();
	      refactorName9 = "Convert parameters to destructured object";
	      minimumParameterLength = 1;
	      refactorDescription5 = getLocaleSpecificMessage(Diagnostics.Convert_parameters_to_destructured_object);
	      toDestructuredAction = {
	        name: refactorName9,
	        description: refactorDescription5,
	        kind: "refactor.rewrite.parameters.toDestructured"
	      };
	      registerRefactor(refactorName9, {
	        kinds: [toDestructuredAction.kind],
	        getEditsForAction: getRefactorEditsToConvertParametersToDestructuredObject,
	        getAvailableActions: getRefactorActionsToConvertParametersToDestructuredObject
	      });
	    }
	  });

	  // src/services/_namespaces/ts.refactor.convertParamsToDestructuredObject.ts
	  var ts_refactor_convertParamsToDestructuredObject_exports = {};
	  var init_ts_refactor_convertParamsToDestructuredObject = __esm({
	    "src/services/_namespaces/ts.refactor.convertParamsToDestructuredObject.ts"() {
	      init_convertParamsToDestructuredObject();
	    }
	  });

	  // src/services/refactors/convertStringOrTemplateLiteral.ts
	  function getRefactorActionsToConvertToTemplateString(context) {
	    const { file, startPosition } = context;
	    const node = getNodeOrParentOfParentheses(file, startPosition);
	    const maybeBinary = getParentBinaryExpression(node);
	    const nodeIsStringLiteral = isStringLiteral(maybeBinary);
	    const refactorInfo = { name: refactorName10, description: refactorDescription6, actions: [] };
	    if (nodeIsStringLiteral && context.triggerReason !== "invoked") {
	      return emptyArray;
	    }
	    if (isExpressionNode(maybeBinary) && (nodeIsStringLiteral || isBinaryExpression(maybeBinary) && treeToArray(maybeBinary).isValidConcatenation)) {
	      refactorInfo.actions.push(convertStringAction);
	      return [refactorInfo];
	    } else if (context.preferences.provideRefactorNotApplicableReason) {
	      refactorInfo.actions.push({ ...convertStringAction, notApplicableReason: getLocaleSpecificMessage(Diagnostics.Can_only_convert_string_concatenations_and_string_literals) });
	      return [refactorInfo];
	    }
	    return emptyArray;
	  }
	  function getNodeOrParentOfParentheses(file, startPosition) {
	    const node = getTokenAtPosition(file, startPosition);
	    const nestedBinary = getParentBinaryExpression(node);
	    const isNonStringBinary = !treeToArray(nestedBinary).isValidConcatenation;
	    if (isNonStringBinary && isParenthesizedExpression(nestedBinary.parent) && isBinaryExpression(nestedBinary.parent.parent)) {
	      return nestedBinary.parent.parent;
	    }
	    return node;
	  }
	  function getRefactorEditsToConvertToTemplateString(context, actionName2) {
	    const { file, startPosition } = context;
	    const node = getNodeOrParentOfParentheses(file, startPosition);
	    switch (actionName2) {
	      case refactorDescription6:
	        return { edits: getEditsForToTemplateLiteral(context, node) };
	      default:
	        return Debug.fail("invalid action");
	    }
	  }
	  function getEditsForToTemplateLiteral(context, node) {
	    const maybeBinary = getParentBinaryExpression(node);
	    const file = context.file;
	    const templateLiteral = nodesToTemplate(treeToArray(maybeBinary), file);
	    const trailingCommentRanges = getTrailingCommentRanges(file.text, maybeBinary.end);
	    if (trailingCommentRanges) {
	      const lastComment = trailingCommentRanges[trailingCommentRanges.length - 1];
	      const trailingRange = { pos: trailingCommentRanges[0].pos, end: lastComment.end };
	      return ts_textChanges_exports.ChangeTracker.with(context, (t) => {
	        t.deleteRange(file, trailingRange);
	        t.replaceNode(file, maybeBinary, templateLiteral);
	      });
	    } else {
	      return ts_textChanges_exports.ChangeTracker.with(context, (t) => t.replaceNode(file, maybeBinary, templateLiteral));
	    }
	  }
	  function isNotEqualsOperator(node) {
	    return !(node.operatorToken.kind === 64 /* EqualsToken */ || node.operatorToken.kind === 65 /* PlusEqualsToken */);
	  }
	  function getParentBinaryExpression(expr) {
	    const container = findAncestor(expr.parent, (n) => {
	      switch (n.kind) {
	        case 211 /* PropertyAccessExpression */:
	        case 212 /* ElementAccessExpression */:
	          return false;
	        case 228 /* TemplateExpression */:
	        case 226 /* BinaryExpression */:
	          return !(isBinaryExpression(n.parent) && isNotEqualsOperator(n.parent));
	        default:
	          return "quit";
	      }
	    });
	    return container || expr;
	  }
	  function treeToArray(current) {
	    const loop = (current2) => {
	      if (!isBinaryExpression(current2)) {
	        return { nodes: [current2], operators: [], validOperators: true, hasString: isStringLiteral(current2) || isNoSubstitutionTemplateLiteral(current2) };
	      }
	      const { nodes: nodes2, operators: operators2, hasString: leftHasString, validOperators: leftOperatorValid } = loop(current2.left);
	      if (!(leftHasString || isStringLiteral(current2.right) || isTemplateExpression(current2.right))) {
	        return { nodes: [current2], operators: [], hasString: false, validOperators: true };
	      }
	      const currentOperatorValid = current2.operatorToken.kind === 40 /* PlusToken */;
	      const validOperators2 = leftOperatorValid && currentOperatorValid;
	      nodes2.push(current2.right);
	      operators2.push(current2.operatorToken);
	      return { nodes: nodes2, operators: operators2, hasString: true, validOperators: validOperators2 };
	    };
	    const { nodes, operators, validOperators, hasString } = loop(current);
	    return { nodes, operators, isValidConcatenation: validOperators && hasString };
	  }
	  function escapeRawStringForTemplate(s) {
	    return s.replace(/\\.|[$`]/g, (m) => m[0] === "\\" ? m : "\\" + m);
	  }
	  function getRawTextOfTemplate(node) {
	    const rightShaving = isTemplateHead(node) || isTemplateMiddle(node) ? -2 : -1;
	    return getTextOfNode(node).slice(1, rightShaving);
	  }
	  function concatConsecutiveString(index, nodes) {
	    const indexes = [];
	    let text = "", rawText = "";
	    while (index < nodes.length) {
	      const node = nodes[index];
	      if (isStringLiteralLike(node)) {
	        text += node.text;
	        rawText += escapeRawStringForTemplate(getTextOfNode(node).slice(1, -1));
	        indexes.push(index);
	        index++;
	      } else if (isTemplateExpression(node)) {
	        text += node.head.text;
	        rawText += getRawTextOfTemplate(node.head);
	        break;
	      } else {
	        break;
	      }
	    }
	    return [index, text, rawText, indexes];
	  }
	  function nodesToTemplate({ nodes, operators }, file) {
	    const copyOperatorComments = copyTrailingOperatorComments(operators, file);
	    const copyCommentFromStringLiterals = copyCommentFromMultiNode(nodes, file, copyOperatorComments);
	    const [begin, headText, rawHeadText, headIndexes] = concatConsecutiveString(0, nodes);
	    if (begin === nodes.length) {
	      const noSubstitutionTemplateLiteral = factory.createNoSubstitutionTemplateLiteral(headText, rawHeadText);
	      copyCommentFromStringLiterals(headIndexes, noSubstitutionTemplateLiteral);
	      return noSubstitutionTemplateLiteral;
	    }
	    const templateSpans = [];
	    const templateHead = factory.createTemplateHead(headText, rawHeadText);
	    copyCommentFromStringLiterals(headIndexes, templateHead);
	    for (let i = begin; i < nodes.length; i++) {
	      const currentNode = getExpressionFromParenthesesOrExpression(nodes[i]);
	      copyOperatorComments(i, currentNode);
	      const [newIndex, subsequentText, rawSubsequentText, stringIndexes] = concatConsecutiveString(i + 1, nodes);
	      i = newIndex - 1;
	      const isLast = i === nodes.length - 1;
	      if (isTemplateExpression(currentNode)) {
	        const spans = map(currentNode.templateSpans, (span, index) => {
	          copyExpressionComments(span);
	          const isLastSpan = index === currentNode.templateSpans.length - 1;
	          const text = span.literal.text + (isLastSpan ? subsequentText : "");
	          const rawText = getRawTextOfTemplate(span.literal) + (isLastSpan ? rawSubsequentText : "");
	          return factory.createTemplateSpan(
	            span.expression,
	            isLast && isLastSpan ? factory.createTemplateTail(text, rawText) : factory.createTemplateMiddle(text, rawText)
	          );
	        });
	        templateSpans.push(...spans);
	      } else {
	        const templatePart = isLast ? factory.createTemplateTail(subsequentText, rawSubsequentText) : factory.createTemplateMiddle(subsequentText, rawSubsequentText);
	        copyCommentFromStringLiterals(stringIndexes, templatePart);
	        templateSpans.push(factory.createTemplateSpan(currentNode, templatePart));
	      }
	    }
	    return factory.createTemplateExpression(templateHead, templateSpans);
	  }
	  function copyExpressionComments(node) {
	    const file = node.getSourceFile();
	    copyTrailingComments(
	      node,
	      node.expression,
	      file,
	      3 /* MultiLineCommentTrivia */,
	      /*hasTrailingNewLine*/
	      false
	    );
	    copyTrailingAsLeadingComments(
	      node.expression,
	      node.expression,
	      file,
	      3 /* MultiLineCommentTrivia */,
	      /*hasTrailingNewLine*/
	      false
	    );
	  }
	  function getExpressionFromParenthesesOrExpression(node) {
	    if (isParenthesizedExpression(node)) {
	      copyExpressionComments(node);
	      node = node.expression;
	    }
	    return node;
	  }
	  var refactorName10, refactorDescription6, convertStringAction, copyTrailingOperatorComments, copyCommentFromMultiNode;
	  var init_convertStringOrTemplateLiteral = __esm({
	    "src/services/refactors/convertStringOrTemplateLiteral.ts"() {
	      init_ts4();
	      init_ts_refactor();
	      refactorName10 = "Convert to template string";
	      refactorDescription6 = getLocaleSpecificMessage(Diagnostics.Convert_to_template_string);
	      convertStringAction = {
	        name: refactorName10,
	        description: refactorDescription6,
	        kind: "refactor.rewrite.string"
	      };
	      registerRefactor(refactorName10, {
	        kinds: [convertStringAction.kind],
	        getEditsForAction: getRefactorEditsToConvertToTemplateString,
	        getAvailableActions: getRefactorActionsToConvertToTemplateString
	      });
	      copyTrailingOperatorComments = (operators, file) => (index, targetNode) => {
	        if (index < operators.length) {
	          copyTrailingComments(
	            operators[index],
	            targetNode,
	            file,
	            3 /* MultiLineCommentTrivia */,
	            /*hasTrailingNewLine*/
	            false
	          );
	        }
	      };
	      copyCommentFromMultiNode = (nodes, file, copyOperatorComments) => (indexes, targetNode) => {
	        while (indexes.length > 0) {
	          const index = indexes.shift();
	          copyTrailingComments(
	            nodes[index],
	            targetNode,
	            file,
	            3 /* MultiLineCommentTrivia */,
	            /*hasTrailingNewLine*/
	            false
	          );
	          copyOperatorComments(index, targetNode);
	        }
	      };
	    }
	  });

	  // src/services/_namespaces/ts.refactor.convertStringOrTemplateLiteral.ts
	  var ts_refactor_convertStringOrTemplateLiteral_exports = {};
	  var init_ts_refactor_convertStringOrTemplateLiteral = __esm({
	    "src/services/_namespaces/ts.refactor.convertStringOrTemplateLiteral.ts"() {
	      init_convertStringOrTemplateLiteral();
	    }
	  });

	  // src/services/refactors/convertToOptionalChainExpression.ts
	  function getRefactorActionsToConvertToOptionalChain(context) {
	    const info = getInfo3(context, context.triggerReason === "invoked");
	    if (!info)
	      return emptyArray;
	    if (!isRefactorErrorInfo(info)) {
	      return [{
	        name: refactorName11,
	        description: convertToOptionalChainExpressionMessage,
	        actions: [toOptionalChainAction]
	      }];
	    }
	    if (context.preferences.provideRefactorNotApplicableReason) {
	      return [{
	        name: refactorName11,
	        description: convertToOptionalChainExpressionMessage,
	        actions: [{ ...toOptionalChainAction, notApplicableReason: info.error }]
	      }];
	    }
	    return emptyArray;
	  }
	  function getRefactorEditsToConvertToOptionalChain(context, actionName2) {
	    const info = getInfo3(context);
	    Debug.assert(info && !isRefactorErrorInfo(info), "Expected applicable refactor info");
	    const edits = ts_textChanges_exports.ChangeTracker.with(context, (t) => doChange6(context.file, context.program.getTypeChecker(), t, info));
	    return { edits, renameFilename: void 0, renameLocation: void 0 };
	  }
	  function isValidExpression(node) {
	    return isBinaryExpression(node) || isConditionalExpression(node);
	  }
	  function isValidStatement(node) {
	    return isExpressionStatement(node) || isReturnStatement(node) || isVariableStatement(node);
	  }
	  function isValidExpressionOrStatement(node) {
	    return isValidExpression(node) || isValidStatement(node);
	  }
	  function getInfo3(context, considerEmptySpans = true) {
	    const { file, program } = context;
	    const span = getRefactorContextSpan(context);
	    const forEmptySpan = span.length === 0;
	    if (forEmptySpan && !considerEmptySpans)
	      return void 0;
	    const startToken = getTokenAtPosition(file, span.start);
	    const endToken = findTokenOnLeftOfPosition(file, span.start + span.length);
	    const adjustedSpan = createTextSpanFromBounds(startToken.pos, endToken && endToken.end >= startToken.pos ? endToken.getEnd() : startToken.getEnd());
	    const parent2 = forEmptySpan ? getValidParentNodeOfEmptySpan(startToken) : getValidParentNodeContainingSpan(startToken, adjustedSpan);
	    const expression = parent2 && isValidExpressionOrStatement(parent2) ? getExpression(parent2) : void 0;
	    if (!expression)
	      return { error: getLocaleSpecificMessage(Diagnostics.Could_not_find_convertible_access_expression) };
	    const checker = program.getTypeChecker();
	    return isConditionalExpression(expression) ? getConditionalInfo(expression, checker) : getBinaryInfo(expression);
	  }
	  function getConditionalInfo(expression, checker) {
	    const condition = expression.condition;
	    const finalExpression = getFinalExpressionInChain(expression.whenTrue);
	    if (!finalExpression || checker.isNullableType(checker.getTypeAtLocation(finalExpression))) {
	      return { error: getLocaleSpecificMessage(Diagnostics.Could_not_find_convertible_access_expression) };
	    }
	    if ((isPropertyAccessExpression(condition) || isIdentifier(condition)) && getMatchingStart(condition, finalExpression.expression)) {
	      return { finalExpression, occurrences: [condition], expression };
	    } else if (isBinaryExpression(condition)) {
	      const occurrences = getOccurrencesInExpression(finalExpression.expression, condition);
	      return occurrences ? { finalExpression, occurrences, expression } : { error: getLocaleSpecificMessage(Diagnostics.Could_not_find_matching_access_expressions) };
	    }
	  }
	  function getBinaryInfo(expression) {
	    if (expression.operatorToken.kind !== 56 /* AmpersandAmpersandToken */) {
	      return { error: getLocaleSpecificMessage(Diagnostics.Can_only_convert_logical_AND_access_chains) };
	    }
	    const finalExpression = getFinalExpressionInChain(expression.right);
	    if (!finalExpression)
	      return { error: getLocaleSpecificMessage(Diagnostics.Could_not_find_convertible_access_expression) };
	    const occurrences = getOccurrencesInExpression(finalExpression.expression, expression.left);
	    return occurrences ? { finalExpression, occurrences, expression } : { error: getLocaleSpecificMessage(Diagnostics.Could_not_find_matching_access_expressions) };
	  }
	  function getOccurrencesInExpression(matchTo, expression) {
	    const occurrences = [];
	    while (isBinaryExpression(expression) && expression.operatorToken.kind === 56 /* AmpersandAmpersandToken */) {
	      const match = getMatchingStart(skipParentheses(matchTo), skipParentheses(expression.right));
	      if (!match) {
	        break;
	      }
	      occurrences.push(match);
	      matchTo = match;
	      expression = expression.left;
	    }
	    const finalMatch = getMatchingStart(matchTo, expression);
	    if (finalMatch) {
	      occurrences.push(finalMatch);
	    }
	    return occurrences.length > 0 ? occurrences : void 0;
	  }
	  function getMatchingStart(chain, subchain) {
	    if (!isIdentifier(subchain) && !isPropertyAccessExpression(subchain) && !isElementAccessExpression(subchain)) {
	      return void 0;
	    }
	    return chainStartsWith(chain, subchain) ? subchain : void 0;
	  }
	  function chainStartsWith(chain, subchain) {
	    while (isCallExpression(chain) || isPropertyAccessExpression(chain) || isElementAccessExpression(chain)) {
	      if (getTextOfChainNode(chain) === getTextOfChainNode(subchain))
	        break;
	      chain = chain.expression;
	    }
	    while (isPropertyAccessExpression(chain) && isPropertyAccessExpression(subchain) || isElementAccessExpression(chain) && isElementAccessExpression(subchain)) {
	      if (getTextOfChainNode(chain) !== getTextOfChainNode(subchain))
	        return false;
	      chain = chain.expression;
	      subchain = subchain.expression;
	    }
	    return isIdentifier(chain) && isIdentifier(subchain) && chain.getText() === subchain.getText();
	  }
	  function getTextOfChainNode(node) {
	    if (isIdentifier(node) || isStringOrNumericLiteralLike(node)) {
	      return node.getText();
	    }
	    if (isPropertyAccessExpression(node)) {
	      return getTextOfChainNode(node.name);
	    }
	    if (isElementAccessExpression(node)) {
	      return getTextOfChainNode(node.argumentExpression);
	    }
	    return void 0;
	  }
	  function getValidParentNodeContainingSpan(node, span) {
	    while (node.parent) {
	      if (isValidExpressionOrStatement(node) && span.length !== 0 && node.end >= span.start + span.length) {
	        return node;
	      }
	      node = node.parent;
	    }
	    return void 0;
	  }
	  function getValidParentNodeOfEmptySpan(node) {
	    while (node.parent) {
	      if (isValidExpressionOrStatement(node) && !isValidExpressionOrStatement(node.parent)) {
	        return node;
	      }
	      node = node.parent;
	    }
	    return void 0;
	  }
	  function getExpression(node) {
	    if (isValidExpression(node)) {
	      return node;
	    }
	    if (isVariableStatement(node)) {
	      const variable = getSingleVariableOfVariableStatement(node);
	      const initializer = variable == null ? void 0 : variable.initializer;
	      return initializer && isValidExpression(initializer) ? initializer : void 0;
	    }
	    return node.expression && isValidExpression(node.expression) ? node.expression : void 0;
	  }
	  function getFinalExpressionInChain(node) {
	    node = skipParentheses(node);
	    if (isBinaryExpression(node)) {
	      return getFinalExpressionInChain(node.left);
	    } else if ((isPropertyAccessExpression(node) || isElementAccessExpression(node) || isCallExpression(node)) && !isOptionalChain(node)) {
	      return node;
	    }
	    return void 0;
	  }
	  function convertOccurrences(checker, toConvert, occurrences) {
	    if (isPropertyAccessExpression(toConvert) || isElementAccessExpression(toConvert) || isCallExpression(toConvert)) {
	      const chain = convertOccurrences(checker, toConvert.expression, occurrences);
	      const lastOccurrence = occurrences.length > 0 ? occurrences[occurrences.length - 1] : void 0;
	      const isOccurrence = (lastOccurrence == null ? void 0 : lastOccurrence.getText()) === toConvert.expression.getText();
	      if (isOccurrence)
	        occurrences.pop();
	      if (isCallExpression(toConvert)) {
	        return isOccurrence ? factory.createCallChain(chain, factory.createToken(29 /* QuestionDotToken */), toConvert.typeArguments, toConvert.arguments) : factory.createCallChain(chain, toConvert.questionDotToken, toConvert.typeArguments, toConvert.arguments);
	      } else if (isPropertyAccessExpression(toConvert)) {
	        return isOccurrence ? factory.createPropertyAccessChain(chain, factory.createToken(29 /* QuestionDotToken */), toConvert.name) : factory.createPropertyAccessChain(chain, toConvert.questionDotToken, toConvert.name);
	      } else if (isElementAccessExpression(toConvert)) {
	        return isOccurrence ? factory.createElementAccessChain(chain, factory.createToken(29 /* QuestionDotToken */), toConvert.argumentExpression) : factory.createElementAccessChain(chain, toConvert.questionDotToken, toConvert.argumentExpression);
	      }
	    }
	    return toConvert;
	  }
	  function doChange6(sourceFile, checker, changes, info, _actionName) {
	    const { finalExpression, occurrences, expression } = info;
	    const firstOccurrence = occurrences[occurrences.length - 1];
	    const convertedChain = convertOccurrences(checker, finalExpression, occurrences);
	    if (convertedChain && (isPropertyAccessExpression(convertedChain) || isElementAccessExpression(convertedChain) || isCallExpression(convertedChain))) {
	      if (isBinaryExpression(expression)) {
	        changes.replaceNodeRange(sourceFile, firstOccurrence, finalExpression, convertedChain);
	      } else if (isConditionalExpression(expression)) {
	        changes.replaceNode(sourceFile, expression, factory.createBinaryExpression(convertedChain, factory.createToken(61 /* QuestionQuestionToken */), expression.whenFalse));
	      }
	    }
	  }
	  var refactorName11, convertToOptionalChainExpressionMessage, toOptionalChainAction;
	  var init_convertToOptionalChainExpression = __esm({
	    "src/services/refactors/convertToOptionalChainExpression.ts"() {
	      init_ts4();
	      init_ts_refactor();
	      refactorName11 = "Convert to optional chain expression";
	      convertToOptionalChainExpressionMessage = getLocaleSpecificMessage(Diagnostics.Convert_to_optional_chain_expression);
	      toOptionalChainAction = {
	        name: refactorName11,
	        description: convertToOptionalChainExpressionMessage,
	        kind: "refactor.rewrite.expression.optionalChain"
	      };
	      registerRefactor(refactorName11, {
	        kinds: [toOptionalChainAction.kind],
	        getEditsForAction: getRefactorEditsToConvertToOptionalChain,
	        getAvailableActions: getRefactorActionsToConvertToOptionalChain
	      });
	    }
	  });

	  // src/services/_namespaces/ts.refactor.convertToOptionalChainExpression.ts
	  var ts_refactor_convertToOptionalChainExpression_exports = {};
	  var init_ts_refactor_convertToOptionalChainExpression = __esm({
	    "src/services/_namespaces/ts.refactor.convertToOptionalChainExpression.ts"() {
	      init_convertToOptionalChainExpression();
	    }
	  });

	  // src/services/refactors/extractSymbol.ts
	  function getRefactorActionsToExtractSymbol(context) {
	    const requestedRefactor = context.kind;
	    const rangeToExtract = getRangeToExtract2(context.file, getRefactorContextSpan(context), context.triggerReason === "invoked");
	    const targetRange = rangeToExtract.targetRange;
	    if (targetRange === void 0) {
	      if (!rangeToExtract.errors || rangeToExtract.errors.length === 0 || !context.preferences.provideRefactorNotApplicableReason) {
	        return emptyArray;
	      }
	      const errors = [];
	      if (refactorKindBeginsWith(extractFunctionAction.kind, requestedRefactor)) {
	        errors.push({
	          name: refactorName12,
	          description: extractFunctionAction.description,
	          actions: [{ ...extractFunctionAction, notApplicableReason: getStringError(rangeToExtract.errors) }]
	        });
	      }
	      if (refactorKindBeginsWith(extractConstantAction.kind, requestedRefactor)) {
	        errors.push({
	          name: refactorName12,
	          description: extractConstantAction.description,
	          actions: [{ ...extractConstantAction, notApplicableReason: getStringError(rangeToExtract.errors) }]
	        });
	      }
	      return errors;
	    }
	    const extractions = getPossibleExtractions(targetRange, context);
	    if (extractions === void 0) {
	      return emptyArray;
	    }
	    const functionActions = [];
	    const usedFunctionNames = /* @__PURE__ */ new Map();
	    let innermostErrorFunctionAction;
	    const constantActions = [];
	    const usedConstantNames = /* @__PURE__ */ new Map();
	    let innermostErrorConstantAction;
	    let i = 0;
	    for (const { functionExtraction, constantExtraction } of extractions) {
	      if (refactorKindBeginsWith(extractFunctionAction.kind, requestedRefactor)) {
	        const description3 = functionExtraction.description;
	        if (functionExtraction.errors.length === 0) {
	          if (!usedFunctionNames.has(description3)) {
	            usedFunctionNames.set(description3, true);
	            functionActions.push({
	              description: description3,
	              name: `function_scope_${i}`,
	              kind: extractFunctionAction.kind
	            });
	          }
	        } else if (!innermostErrorFunctionAction) {
	          innermostErrorFunctionAction = {
	            description: description3,
	            name: `function_scope_${i}`,
	            notApplicableReason: getStringError(functionExtraction.errors),
	            kind: extractFunctionAction.kind
	          };
	        }
	      }
	      if (refactorKindBeginsWith(extractConstantAction.kind, requestedRefactor)) {
	        const description3 = constantExtraction.description;
	        if (constantExtraction.errors.length === 0) {
	          if (!usedConstantNames.has(description3)) {
	            usedConstantNames.set(description3, true);
	            constantActions.push({
	              description: description3,
	              name: `constant_scope_${i}`,
	              kind: extractConstantAction.kind
	            });
	          }
	        } else if (!innermostErrorConstantAction) {
	          innermostErrorConstantAction = {
	            description: description3,
	            name: `constant_scope_${i}`,
	            notApplicableReason: getStringError(constantExtraction.errors),
	            kind: extractConstantAction.kind
	          };
	        }
	      }
	      i++;
	    }
	    const infos = [];
	    if (functionActions.length) {
	      infos.push({
	        name: refactorName12,
	        description: getLocaleSpecificMessage(Diagnostics.Extract_function),
	        actions: functionActions
	      });
	    } else if (context.preferences.provideRefactorNotApplicableReason && innermostErrorFunctionAction) {
	      infos.push({
	        name: refactorName12,
	        description: getLocaleSpecificMessage(Diagnostics.Extract_function),
	        actions: [innermostErrorFunctionAction]
	      });
	    }
	    if (constantActions.length) {
	      infos.push({
	        name: refactorName12,
	        description: getLocaleSpecificMessage(Diagnostics.Extract_constant),
	        actions: constantActions
	      });
	    } else if (context.preferences.provideRefactorNotApplicableReason && innermostErrorConstantAction) {
	      infos.push({
	        name: refactorName12,
	        description: getLocaleSpecificMessage(Diagnostics.Extract_constant),
	        actions: [innermostErrorConstantAction]
	      });
	    }
	    return infos.length ? infos : emptyArray;
	    function getStringError(errors) {
	      let error2 = errors[0].messageText;
	      if (typeof error2 !== "string") {
	        error2 = error2.messageText;
	      }
	      return error2;
	    }
	  }
	  function getRefactorEditsToExtractSymbol(context, actionName2) {
	    const rangeToExtract = getRangeToExtract2(context.file, getRefactorContextSpan(context));
	    const targetRange = rangeToExtract.targetRange;
	    const parsedFunctionIndexMatch = /^function_scope_(\d+)$/.exec(actionName2);
	    if (parsedFunctionIndexMatch) {
	      const index = +parsedFunctionIndexMatch[1];
	      Debug.assert(isFinite(index), "Expected to parse a finite number from the function scope index");
	      return getFunctionExtractionAtIndex(targetRange, context, index);
	    }
	    const parsedConstantIndexMatch = /^constant_scope_(\d+)$/.exec(actionName2);
	    if (parsedConstantIndexMatch) {
	      const index = +parsedConstantIndexMatch[1];
	      Debug.assert(isFinite(index), "Expected to parse a finite number from the constant scope index");
	      return getConstantExtractionAtIndex(targetRange, context, index);
	    }
	    Debug.fail("Unrecognized action name");
	  }
	  function getRangeToExtract2(sourceFile, span, invoked = true) {
	    const { length: length2 } = span;
	    if (length2 === 0 && !invoked) {
	      return { errors: [createFileDiagnostic(sourceFile, span.start, length2, Messages.cannotExtractEmpty)] };
	    }
	    const cursorRequest = length2 === 0 && invoked;
	    const startToken = findFirstNonJsxWhitespaceToken(sourceFile, span.start);
	    const endToken = findTokenOnLeftOfPosition(sourceFile, textSpanEnd(span));
	    const adjustedSpan = startToken && endToken && invoked ? getAdjustedSpanFromNodes(startToken, endToken, sourceFile) : span;
	    const start = cursorRequest ? getExtractableParent(startToken) : getParentNodeInSpan(startToken, sourceFile, adjustedSpan);
	    const end = cursorRequest ? start : getParentNodeInSpan(endToken, sourceFile, adjustedSpan);
	    let rangeFacts = 0 /* None */;
	    let thisNode;
	    if (!start || !end) {
	      return { errors: [createFileDiagnostic(sourceFile, span.start, length2, Messages.cannotExtractRange)] };
	    }
	    if (start.flags & 16777216 /* JSDoc */) {
	      return { errors: [createFileDiagnostic(sourceFile, span.start, length2, Messages.cannotExtractJSDoc)] };
	    }
	    if (start.parent !== end.parent) {
	      return { errors: [createFileDiagnostic(sourceFile, span.start, length2, Messages.cannotExtractRange)] };
	    }
	    if (start !== end) {
	      if (!isBlockLike(start.parent)) {
	        return { errors: [createFileDiagnostic(sourceFile, span.start, length2, Messages.cannotExtractRange)] };
	      }
	      const statements = [];
	      for (const statement of start.parent.statements) {
	        if (statement === start || statements.length) {
	          const errors2 = checkNode(statement);
	          if (errors2) {
	            return { errors: errors2 };
	          }
	          statements.push(statement);
	        }
	        if (statement === end) {
	          break;
	        }
	      }
	      if (!statements.length) {
	        return { errors: [createFileDiagnostic(sourceFile, span.start, length2, Messages.cannotExtractRange)] };
	      }
	      return { targetRange: { range: statements, facts: rangeFacts, thisNode } };
	    }
	    if (isReturnStatement(start) && !start.expression) {
	      return { errors: [createFileDiagnostic(sourceFile, span.start, length2, Messages.cannotExtractRange)] };
	    }
	    const node = refineNode(start);
	    const errors = checkRootNode(node) || checkNode(node);
	    if (errors) {
	      return { errors };
	    }
	    return { targetRange: { range: getStatementOrExpressionRange(node), facts: rangeFacts, thisNode } };
	    function refineNode(node2) {
	      if (isReturnStatement(node2)) {
	        if (node2.expression) {
	          return node2.expression;
	        }
	      } else if (isVariableStatement(node2) || isVariableDeclarationList(node2)) {
	        const declarations = isVariableStatement(node2) ? node2.declarationList.declarations : node2.declarations;
	        let numInitializers = 0;
	        let lastInitializer;
	        for (const declaration of declarations) {
	          if (declaration.initializer) {
	            numInitializers++;
	            lastInitializer = declaration.initializer;
	          }
	        }
	        if (numInitializers === 1) {
	          return lastInitializer;
	        }
	      } else if (isVariableDeclaration(node2)) {
	        if (node2.initializer) {
	          return node2.initializer;
	        }
	      }
	      return node2;
	    }
	    function checkRootNode(node2) {
	      if (isIdentifier(isExpressionStatement(node2) ? node2.expression : node2)) {
	        return [createDiagnosticForNode(node2, Messages.cannotExtractIdentifier)];
	      }
	      return void 0;
	    }
	    function checkForStaticContext(nodeToCheck, containingClass) {
	      let current = nodeToCheck;
	      while (current !== containingClass) {
	        if (current.kind === 172 /* PropertyDeclaration */) {
	          if (isStatic(current)) {
	            rangeFacts |= 32 /* InStaticRegion */;
	          }
	          break;
	        } else if (current.kind === 169 /* Parameter */) {
	          const ctorOrMethod = getContainingFunction(current);
	          if (ctorOrMethod.kind === 176 /* Constructor */) {
	            rangeFacts |= 32 /* InStaticRegion */;
	          }
	          break;
	        } else if (current.kind === 174 /* MethodDeclaration */) {
	          if (isStatic(current)) {
	            rangeFacts |= 32 /* InStaticRegion */;
	          }
	        }
	        current = current.parent;
	      }
	    }
	    function checkNode(nodeToCheck) {
	      let PermittedJumps;
	      ((PermittedJumps2) => {
	        PermittedJumps2[PermittedJumps2["None"] = 0] = "None";
	        PermittedJumps2[PermittedJumps2["Break"] = 1] = "Break";
	        PermittedJumps2[PermittedJumps2["Continue"] = 2] = "Continue";
	        PermittedJumps2[PermittedJumps2["Return"] = 4] = "Return";
	      })(PermittedJumps || (PermittedJumps = {}));
	      Debug.assert(nodeToCheck.pos <= nodeToCheck.end, "This failure could trigger https://github.com/Microsoft/TypeScript/issues/20809 (1)");
	      Debug.assert(!positionIsSynthesized(nodeToCheck.pos), "This failure could trigger https://github.com/Microsoft/TypeScript/issues/20809 (2)");
	      if (!isStatement(nodeToCheck) && !(isExpressionNode(nodeToCheck) && isExtractableExpression(nodeToCheck)) && !isStringLiteralJsxAttribute(nodeToCheck)) {
	        return [createDiagnosticForNode(nodeToCheck, Messages.statementOrExpressionExpected)];
	      }
	      if (nodeToCheck.flags & 33554432 /* Ambient */) {
	        return [createDiagnosticForNode(nodeToCheck, Messages.cannotExtractAmbientBlock)];
	      }
	      const containingClass = getContainingClass(nodeToCheck);
	      if (containingClass) {
	        checkForStaticContext(nodeToCheck, containingClass);
	      }
	      let errors2;
	      let permittedJumps = 4 /* Return */;
	      let seenLabels;
	      visit(nodeToCheck);
	      if (rangeFacts & 8 /* UsesThis */) {
	        const container = getThisContainer(
	          nodeToCheck,
	          /*includeArrowFunctions*/
	          false,
	          /*includeClassComputedPropertyName*/
	          false
	        );
	        if (container.kind === 262 /* FunctionDeclaration */ || container.kind === 174 /* MethodDeclaration */ && container.parent.kind === 210 /* ObjectLiteralExpression */ || container.kind === 218 /* FunctionExpression */) {
	          rangeFacts |= 16 /* UsesThisInFunction */;
	        }
	      }
	      return errors2;
	      function visit(node2) {
	        if (errors2) {
	          return true;
	        }
	        if (isDeclaration(node2)) {
	          const declaringNode = node2.kind === 260 /* VariableDeclaration */ ? node2.parent.parent : node2;
	          if (hasSyntacticModifier(declaringNode, 32 /* Export */)) {
	            (errors2 || (errors2 = [])).push(createDiagnosticForNode(node2, Messages.cannotExtractExportedEntity));
	            return true;
	          }
	        }
	        switch (node2.kind) {
	          case 272 /* ImportDeclaration */:
	            (errors2 || (errors2 = [])).push(createDiagnosticForNode(node2, Messages.cannotExtractImport));
	            return true;
	          case 277 /* ExportAssignment */:
	            (errors2 || (errors2 = [])).push(createDiagnosticForNode(node2, Messages.cannotExtractExportedEntity));
	            return true;
	          case 108 /* SuperKeyword */:
	            if (node2.parent.kind === 213 /* CallExpression */) {
	              const containingClass2 = getContainingClass(node2);
	              if (containingClass2 === void 0 || containingClass2.pos < span.start || containingClass2.end >= span.start + span.length) {
	                (errors2 || (errors2 = [])).push(createDiagnosticForNode(node2, Messages.cannotExtractSuper));
	                return true;
	              }
	            } else {
	              rangeFacts |= 8 /* UsesThis */;
	              thisNode = node2;
	            }
	            break;
	          case 219 /* ArrowFunction */:
	            forEachChild(node2, function check(n) {
	              if (isThis(n)) {
	                rangeFacts |= 8 /* UsesThis */;
	                thisNode = node2;
	              } else if (isClassLike(n) || isFunctionLike(n) && !isArrowFunction(n)) {
	                return false;
	              } else {
	                forEachChild(n, check);
	              }
	            });
	          case 263 /* ClassDeclaration */:
	          case 262 /* FunctionDeclaration */:
	            if (isSourceFile(node2.parent) && node2.parent.externalModuleIndicator === void 0) {
	              (errors2 || (errors2 = [])).push(createDiagnosticForNode(node2, Messages.functionWillNotBeVisibleInTheNewScope));
	            }
	          case 231 /* ClassExpression */:
	          case 218 /* FunctionExpression */:
	          case 174 /* MethodDeclaration */:
	          case 176 /* Constructor */:
	          case 177 /* GetAccessor */:
	          case 178 /* SetAccessor */:
	            return false;
	        }
	        const savedPermittedJumps = permittedJumps;
	        switch (node2.kind) {
	          case 245 /* IfStatement */:
	            permittedJumps &= ~4 /* Return */;
	            break;
	          case 258 /* TryStatement */:
	            permittedJumps = 0 /* None */;
	            break;
	          case 241 /* Block */:
	            if (node2.parent && node2.parent.kind === 258 /* TryStatement */ && node2.parent.finallyBlock === node2) {
	              permittedJumps = 4 /* Return */;
	            }
	            break;
	          case 297 /* DefaultClause */:
	          case 296 /* CaseClause */:
	            permittedJumps |= 1 /* Break */;
	            break;
	          default:
	            if (isIterationStatement(
	              node2,
	              /*lookInLabeledStatements*/
	              false
	            )) {
	              permittedJumps |= 1 /* Break */ | 2 /* Continue */;
	            }
	            break;
	        }
	        switch (node2.kind) {
	          case 197 /* ThisType */:
	          case 110 /* ThisKeyword */:
	            rangeFacts |= 8 /* UsesThis */;
	            thisNode = node2;
	            break;
	          case 256 /* LabeledStatement */: {
	            const label = node2.label;
	            (seenLabels || (seenLabels = [])).push(label.escapedText);
	            forEachChild(node2, visit);
	            seenLabels.pop();
	            break;
	          }
	          case 252 /* BreakStatement */:
	          case 251 /* ContinueStatement */: {
	            const label = node2.label;
	            if (label) {
	              if (!contains(seenLabels, label.escapedText)) {
	                (errors2 || (errors2 = [])).push(createDiagnosticForNode(node2, Messages.cannotExtractRangeContainingLabeledBreakOrContinueStatementWithTargetOutsideOfTheRange));
	              }
	            } else {
	              if (!(permittedJumps & (node2.kind === 252 /* BreakStatement */ ? 1 /* Break */ : 2 /* Continue */))) {
	                (errors2 || (errors2 = [])).push(createDiagnosticForNode(node2, Messages.cannotExtractRangeContainingConditionalBreakOrContinueStatements));
	              }
	            }
	            break;
	          }
	          case 223 /* AwaitExpression */:
	            rangeFacts |= 4 /* IsAsyncFunction */;
	            break;
	          case 229 /* YieldExpression */:
	            rangeFacts |= 2 /* IsGenerator */;
	            break;
	          case 253 /* ReturnStatement */:
	            if (permittedJumps & 4 /* Return */) {
	              rangeFacts |= 1 /* HasReturn */;
	            } else {
	              (errors2 || (errors2 = [])).push(createDiagnosticForNode(node2, Messages.cannotExtractRangeContainingConditionalReturnStatement));
	            }
	            break;
	          default:
	            forEachChild(node2, visit);
	            break;
	        }
	        permittedJumps = savedPermittedJumps;
	      }
	    }
	  }
	  function getAdjustedSpanFromNodes(startNode2, endNode2, sourceFile) {
	    const start = startNode2.getStart(sourceFile);
	    let end = endNode2.getEnd();
	    if (sourceFile.text.charCodeAt(end) === 59 /* semicolon */) {
	      end++;
	    }
	    return { start, length: end - start };
	  }
	  function getStatementOrExpressionRange(node) {
	    if (isStatement(node)) {
	      return [node];
	    }
	    if (isExpressionNode(node)) {
	      return isExpressionStatement(node.parent) ? [node.parent] : node;
	    }
	    if (isStringLiteralJsxAttribute(node)) {
	      return node;
	    }
	    return void 0;
	  }
	  function isScope(node) {
	    return isArrowFunction(node) ? isFunctionBody(node.body) : isFunctionLikeDeclaration(node) || isSourceFile(node) || isModuleBlock(node) || isClassLike(node);
	  }
	  function collectEnclosingScopes(range) {
	    let current = isReadonlyArray(range.range) ? first(range.range) : range.range;
	    if (range.facts & 8 /* UsesThis */ && !(range.facts & 16 /* UsesThisInFunction */)) {
	      const containingClass = getContainingClass(current);
	      if (containingClass) {
	        const containingFunction = findAncestor(current, isFunctionLikeDeclaration);
	        return containingFunction ? [containingFunction, containingClass] : [containingClass];
	      }
	    }
	    const scopes = [];
	    while (true) {
	      current = current.parent;
	      if (current.kind === 169 /* Parameter */) {
	        current = findAncestor(current, (parent2) => isFunctionLikeDeclaration(parent2)).parent;
	      }
	      if (isScope(current)) {
	        scopes.push(current);
	        if (current.kind === 312 /* SourceFile */) {
	          return scopes;
	        }
	      }
	    }
	  }
	  function getFunctionExtractionAtIndex(targetRange, context, requestedChangesIndex) {
	    const { scopes, readsAndWrites: { target, usagesPerScope, functionErrorsPerScope, exposedVariableDeclarations } } = getPossibleExtractionsWorker(targetRange, context);
	    Debug.assert(!functionErrorsPerScope[requestedChangesIndex].length, "The extraction went missing? How?");
	    context.cancellationToken.throwIfCancellationRequested();
	    return extractFunctionInScope(target, scopes[requestedChangesIndex], usagesPerScope[requestedChangesIndex], exposedVariableDeclarations, targetRange, context);
	  }
	  function getConstantExtractionAtIndex(targetRange, context, requestedChangesIndex) {
	    const { scopes, readsAndWrites: { target, usagesPerScope, constantErrorsPerScope, exposedVariableDeclarations } } = getPossibleExtractionsWorker(targetRange, context);
	    Debug.assert(!constantErrorsPerScope[requestedChangesIndex].length, "The extraction went missing? How?");
	    Debug.assert(exposedVariableDeclarations.length === 0, "Extract constant accepted a range containing a variable declaration?");
	    context.cancellationToken.throwIfCancellationRequested();
	    const expression = isExpression(target) ? target : target.statements[0].expression;
	    return extractConstantInScope(expression, scopes[requestedChangesIndex], usagesPerScope[requestedChangesIndex], targetRange.facts, context);
	  }
	  function getPossibleExtractions(targetRange, context) {
	    const { scopes, readsAndWrites: { functionErrorsPerScope, constantErrorsPerScope } } = getPossibleExtractionsWorker(targetRange, context);
	    const extractions = scopes.map((scope, i) => {
	      const functionDescriptionPart = getDescriptionForFunctionInScope(scope);
	      const constantDescriptionPart = getDescriptionForConstantInScope(scope);
	      const scopeDescription = isFunctionLikeDeclaration(scope) ? getDescriptionForFunctionLikeDeclaration(scope) : isClassLike(scope) ? getDescriptionForClassLikeDeclaration(scope) : getDescriptionForModuleLikeDeclaration(scope);
	      let functionDescription;
	      let constantDescription;
	      if (scopeDescription === 1 /* Global */) {
	        functionDescription = formatStringFromArgs(getLocaleSpecificMessage(Diagnostics.Extract_to_0_in_1_scope), [functionDescriptionPart, "global"]);
	        constantDescription = formatStringFromArgs(getLocaleSpecificMessage(Diagnostics.Extract_to_0_in_1_scope), [constantDescriptionPart, "global"]);
	      } else if (scopeDescription === 0 /* Module */) {
	        functionDescription = formatStringFromArgs(getLocaleSpecificMessage(Diagnostics.Extract_to_0_in_1_scope), [functionDescriptionPart, "module"]);
	        constantDescription = formatStringFromArgs(getLocaleSpecificMessage(Diagnostics.Extract_to_0_in_1_scope), [constantDescriptionPart, "module"]);
	      } else {
	        functionDescription = formatStringFromArgs(getLocaleSpecificMessage(Diagnostics.Extract_to_0_in_1), [functionDescriptionPart, scopeDescription]);
	        constantDescription = formatStringFromArgs(getLocaleSpecificMessage(Diagnostics.Extract_to_0_in_1), [constantDescriptionPart, scopeDescription]);
	      }
	      if (i === 0 && !isClassLike(scope)) {
	        constantDescription = formatStringFromArgs(getLocaleSpecificMessage(Diagnostics.Extract_to_0_in_enclosing_scope), [constantDescriptionPart]);
	      }
	      return {
	        functionExtraction: {
	          description: functionDescription,
	          errors: functionErrorsPerScope[i]
	        },
	        constantExtraction: {
	          description: constantDescription,
	          errors: constantErrorsPerScope[i]
	        }
	      };
	    });
	    return extractions;
	  }
	  function getPossibleExtractionsWorker(targetRange, context) {
	    const { file: sourceFile } = context;
	    const scopes = collectEnclosingScopes(targetRange);
	    const enclosingTextRange = getEnclosingTextRange(targetRange, sourceFile);
	    const readsAndWrites = collectReadsAndWrites(
	      targetRange,
	      scopes,
	      enclosingTextRange,
	      sourceFile,
	      context.program.getTypeChecker(),
	      context.cancellationToken
	    );
	    return { scopes, readsAndWrites };
	  }
	  function getDescriptionForFunctionInScope(scope) {
	    return isFunctionLikeDeclaration(scope) ? "inner function" : isClassLike(scope) ? "method" : "function";
	  }
	  function getDescriptionForConstantInScope(scope) {
	    return isClassLike(scope) ? "readonly field" : "constant";
	  }
	  function getDescriptionForFunctionLikeDeclaration(scope) {
	    switch (scope.kind) {
	      case 176 /* Constructor */:
	        return "constructor";
	      case 218 /* FunctionExpression */:
	      case 262 /* FunctionDeclaration */:
	        return scope.name ? `function '${scope.name.text}'` : ANONYMOUS;
	      case 219 /* ArrowFunction */:
	        return "arrow function";
	      case 174 /* MethodDeclaration */:
	        return `method '${scope.name.getText()}'`;
	      case 177 /* GetAccessor */:
	        return `'get ${scope.name.getText()}'`;
	      case 178 /* SetAccessor */:
	        return `'set ${scope.name.getText()}'`;
	      default:
	        Debug.assertNever(scope, `Unexpected scope kind ${scope.kind}`);
	    }
	  }
	  function getDescriptionForClassLikeDeclaration(scope) {
	    return scope.kind === 263 /* ClassDeclaration */ ? scope.name ? `class '${scope.name.text}'` : "anonymous class declaration" : scope.name ? `class expression '${scope.name.text}'` : "anonymous class expression";
	  }
	  function getDescriptionForModuleLikeDeclaration(scope) {
	    return scope.kind === 268 /* ModuleBlock */ ? `namespace '${scope.parent.name.getText()}'` : scope.externalModuleIndicator ? 0 /* Module */ : 1 /* Global */;
	  }
	  function extractFunctionInScope(node, scope, { usages: usagesInScope, typeParameterUsages, substitutions }, exposedVariableDeclarations, range, context) {
	    const checker = context.program.getTypeChecker();
	    const scriptTarget = getEmitScriptTarget(context.program.getCompilerOptions());
	    const importAdder = ts_codefix_exports.createImportAdder(context.file, context.program, context.preferences, context.host);
	    const file = scope.getSourceFile();
	    const functionNameText = getUniqueName(isClassLike(scope) ? "newMethod" : "newFunction", file);
	    const isJS = isInJSFile(scope);
	    const functionName = factory.createIdentifier(functionNameText);
	    let returnType;
	    const parameters = [];
	    const callArguments = [];
	    let writes;
	    usagesInScope.forEach((usage, name) => {
	      let typeNode;
	      if (!isJS) {
	        let type = checker.getTypeOfSymbolAtLocation(usage.symbol, usage.node);
	        type = checker.getBaseTypeOfLiteralType(type);
	        typeNode = ts_codefix_exports.typeToAutoImportableTypeNode(checker, importAdder, type, scope, scriptTarget, 1 /* NoTruncation */);
	      }
	      const paramDecl = factory.createParameterDeclaration(
	        /*modifiers*/
	        void 0,
	        /*dotDotDotToken*/
	        void 0,
	        /*name*/
	        name,
	        /*questionToken*/
	        void 0,
	        typeNode
	      );
	      parameters.push(paramDecl);
	      if (usage.usage === 2 /* Write */) {
	        (writes || (writes = [])).push(usage);
	      }
	      callArguments.push(factory.createIdentifier(name));
	    });
	    const typeParametersAndDeclarations = arrayFrom(typeParameterUsages.values(), (type) => ({ type, declaration: getFirstDeclarationBeforePosition(type, context.startPosition) }));
	    const sortedTypeParametersAndDeclarations = typeParametersAndDeclarations.sort(compareTypesByDeclarationOrder);
	    const typeParameters = sortedTypeParametersAndDeclarations.length === 0 ? void 0 : mapDefined(sortedTypeParametersAndDeclarations, ({ declaration }) => declaration);
	    const callTypeArguments = typeParameters !== void 0 ? typeParameters.map((decl) => factory.createTypeReferenceNode(
	      decl.name,
	      /*typeArguments*/
	      void 0
	    )) : void 0;
	    if (isExpression(node) && !isJS) {
	      const contextualType = checker.getContextualType(node);
	      returnType = checker.typeToTypeNode(contextualType, scope, 1 /* NoTruncation */);
	    }
	    const { body, returnValueProperty } = transformFunctionBody(node, exposedVariableDeclarations, writes, substitutions, !!(range.facts & 1 /* HasReturn */));
	    suppressLeadingAndTrailingTrivia(body);
	    let newFunction;
	    const callThis = !!(range.facts & 16 /* UsesThisInFunction */);
	    if (isClassLike(scope)) {
	      const modifiers = isJS ? [] : [factory.createModifier(123 /* PrivateKeyword */)];
	      if (range.facts & 32 /* InStaticRegion */) {
	        modifiers.push(factory.createModifier(126 /* StaticKeyword */));
	      }
	      if (range.facts & 4 /* IsAsyncFunction */) {
	        modifiers.push(factory.createModifier(134 /* AsyncKeyword */));
	      }
	      newFunction = factory.createMethodDeclaration(
	        modifiers.length ? modifiers : void 0,
	        range.facts & 2 /* IsGenerator */ ? factory.createToken(42 /* AsteriskToken */) : void 0,
	        functionName,
	        /*questionToken*/
	        void 0,
	        typeParameters,
	        parameters,
	        returnType,
	        body
	      );
	    } else {
	      if (callThis) {
	        parameters.unshift(
	          factory.createParameterDeclaration(
	            /*modifiers*/
	            void 0,
	            /*dotDotDotToken*/
	            void 0,
	            /*name*/
	            "this",
	            /*questionToken*/
	            void 0,
	            checker.typeToTypeNode(
	              checker.getTypeAtLocation(range.thisNode),
	              scope,
	              1 /* NoTruncation */
	            ),
	            /*initializer*/
	            void 0
	          )
	        );
	      }
	      newFunction = factory.createFunctionDeclaration(
	        range.facts & 4 /* IsAsyncFunction */ ? [factory.createToken(134 /* AsyncKeyword */)] : void 0,
	        range.facts & 2 /* IsGenerator */ ? factory.createToken(42 /* AsteriskToken */) : void 0,
	        functionName,
	        typeParameters,
	        parameters,
	        returnType,
	        body
	      );
	    }
	    const changeTracker = ts_textChanges_exports.ChangeTracker.fromContext(context);
	    const minInsertionPos = (isReadonlyArray(range.range) ? last(range.range) : range.range).end;
	    const nodeToInsertBefore = getNodeToInsertFunctionBefore(minInsertionPos, scope);
	    if (nodeToInsertBefore) {
	      changeTracker.insertNodeBefore(
	        context.file,
	        nodeToInsertBefore,
	        newFunction,
	        /*blankLineBetween*/
	        true
	      );
	    } else {
	      changeTracker.insertNodeAtEndOfScope(context.file, scope, newFunction);
	    }
	    importAdder.writeFixes(changeTracker);
	    const newNodes = [];
	    const called = getCalledExpression(scope, range, functionNameText);
	    if (callThis) {
	      callArguments.unshift(factory.createIdentifier("this"));
	    }
	    let call = factory.createCallExpression(
	      callThis ? factory.createPropertyAccessExpression(
	        called,
	        "call"
	      ) : called,
	      callTypeArguments,
	      // Note that no attempt is made to take advantage of type argument inference
	      callArguments
	    );
	    if (range.facts & 2 /* IsGenerator */) {
	      call = factory.createYieldExpression(factory.createToken(42 /* AsteriskToken */), call);
	    }
	    if (range.facts & 4 /* IsAsyncFunction */) {
	      call = factory.createAwaitExpression(call);
	    }
	    if (isInJSXContent(node)) {
	      call = factory.createJsxExpression(
	        /*dotDotDotToken*/
	        void 0,
	        call
	      );
	    }
	    if (exposedVariableDeclarations.length && !writes) {
	      Debug.assert(!returnValueProperty, "Expected no returnValueProperty");
	      Debug.assert(!(range.facts & 1 /* HasReturn */), "Expected RangeFacts.HasReturn flag to be unset");
	      if (exposedVariableDeclarations.length === 1) {
	        const variableDeclaration = exposedVariableDeclarations[0];
	        newNodes.push(factory.createVariableStatement(
	          /*modifiers*/
	          void 0,
	          factory.createVariableDeclarationList(
	            [factory.createVariableDeclaration(
	              getSynthesizedDeepClone(variableDeclaration.name),
	              /*exclamationToken*/
	              void 0,
	              /*type*/
	              getSynthesizedDeepClone(variableDeclaration.type),
	              /*initializer*/
	              call
	            )],
	            variableDeclaration.parent.flags
	          )
	        ));
	      } else {
	        const bindingElements = [];
	        const typeElements = [];
	        let commonNodeFlags = exposedVariableDeclarations[0].parent.flags;
	        let sawExplicitType = false;
	        for (const variableDeclaration of exposedVariableDeclarations) {
	          bindingElements.push(factory.createBindingElement(
	            /*dotDotDotToken*/
	            void 0,
	            /*propertyName*/
	            void 0,
	            /*name*/
	            getSynthesizedDeepClone(variableDeclaration.name)
	          ));
	          const variableType = checker.typeToTypeNode(
	            checker.getBaseTypeOfLiteralType(checker.getTypeAtLocation(variableDeclaration)),
	            scope,
	            1 /* NoTruncation */
	          );
	          typeElements.push(factory.createPropertySignature(
	            /*modifiers*/
	            void 0,
	            /*name*/
	            variableDeclaration.symbol.name,
	            /*questionToken*/
	            void 0,
	            /*type*/
	            variableType
	          ));
	          sawExplicitType = sawExplicitType || variableDeclaration.type !== void 0;
	          commonNodeFlags = commonNodeFlags & variableDeclaration.parent.flags;
	        }
	        const typeLiteral = sawExplicitType ? factory.createTypeLiteralNode(typeElements) : void 0;
	        if (typeLiteral) {
	          setEmitFlags(typeLiteral, 1 /* SingleLine */);
	        }
	        newNodes.push(factory.createVariableStatement(
	          /*modifiers*/
	          void 0,
	          factory.createVariableDeclarationList(
	            [factory.createVariableDeclaration(
	              factory.createObjectBindingPattern(bindingElements),
	              /*exclamationToken*/
	              void 0,
	              /*type*/
	              typeLiteral,
	              /*initializer*/
	              call
	            )],
	            commonNodeFlags
	          )
	        ));
	      }
	    } else if (exposedVariableDeclarations.length || writes) {
	      if (exposedVariableDeclarations.length) {
	        for (const variableDeclaration of exposedVariableDeclarations) {
	          let flags = variableDeclaration.parent.flags;
	          if (flags & 2 /* Const */) {
	            flags = flags & ~2 /* Const */ | 1 /* Let */;
	          }
	          newNodes.push(factory.createVariableStatement(
	            /*modifiers*/
	            void 0,
	            factory.createVariableDeclarationList(
	              [factory.createVariableDeclaration(
	                variableDeclaration.symbol.name,
	                /*exclamationToken*/
	                void 0,
	                getTypeDeepCloneUnionUndefined(variableDeclaration.type)
	              )],
	              flags
	            )
	          ));
	        }
	      }
	      if (returnValueProperty) {
	        newNodes.push(factory.createVariableStatement(
	          /*modifiers*/
	          void 0,
	          factory.createVariableDeclarationList(
	            [factory.createVariableDeclaration(
	              returnValueProperty,
	              /*exclamationToken*/
	              void 0,
	              getTypeDeepCloneUnionUndefined(returnType)
	            )],
	            1 /* Let */
	          )
	        ));
	      }
	      const assignments = getPropertyAssignmentsForWritesAndVariableDeclarations(exposedVariableDeclarations, writes);
	      if (returnValueProperty) {
	        assignments.unshift(factory.createShorthandPropertyAssignment(returnValueProperty));
	      }
	      if (assignments.length === 1) {
	        Debug.assert(!returnValueProperty, "Shouldn't have returnValueProperty here");
	        newNodes.push(factory.createExpressionStatement(factory.createAssignment(assignments[0].name, call)));
	        if (range.facts & 1 /* HasReturn */) {
	          newNodes.push(factory.createReturnStatement());
	        }
	      } else {
	        newNodes.push(factory.createExpressionStatement(factory.createAssignment(factory.createObjectLiteralExpression(assignments), call)));
	        if (returnValueProperty) {
	          newNodes.push(factory.createReturnStatement(factory.createIdentifier(returnValueProperty)));
	        }
	      }
	    } else {
	      if (range.facts & 1 /* HasReturn */) {
	        newNodes.push(factory.createReturnStatement(call));
	      } else if (isReadonlyArray(range.range)) {
	        newNodes.push(factory.createExpressionStatement(call));
	      } else {
	        newNodes.push(call);
	      }
	    }
	    if (isReadonlyArray(range.range)) {
	      changeTracker.replaceNodeRangeWithNodes(context.file, first(range.range), last(range.range), newNodes);
	    } else {
	      changeTracker.replaceNodeWithNodes(context.file, range.range, newNodes);
	    }
	    const edits = changeTracker.getChanges();
	    const renameRange = isReadonlyArray(range.range) ? first(range.range) : range.range;
	    const renameFilename = renameRange.getSourceFile().fileName;
	    const renameLocation = getRenameLocation(
	      edits,
	      renameFilename,
	      functionNameText,
	      /*preferLastLocation*/
	      false
	    );
	    return { renameFilename, renameLocation, edits };
	    function getTypeDeepCloneUnionUndefined(typeNode) {
	      if (typeNode === void 0) {
	        return void 0;
	      }
	      const clone2 = getSynthesizedDeepClone(typeNode);
	      let withoutParens = clone2;
	      while (isParenthesizedTypeNode(withoutParens)) {
	        withoutParens = withoutParens.type;
	      }
	      return isUnionTypeNode(withoutParens) && find(withoutParens.types, (t) => t.kind === 157 /* UndefinedKeyword */) ? clone2 : factory.createUnionTypeNode([clone2, factory.createKeywordTypeNode(157 /* UndefinedKeyword */)]);
	    }
	  }
	  function extractConstantInScope(node, scope, { substitutions }, rangeFacts, context) {
	    const checker = context.program.getTypeChecker();
	    const file = scope.getSourceFile();
	    const localNameText = isPropertyAccessExpression(node) && !isClassLike(scope) && !checker.resolveName(
	      node.name.text,
	      node,
	      111551 /* Value */,
	      /*excludeGlobals*/
	      false
	    ) && !isPrivateIdentifier(node.name) && !identifierToKeywordKind(node.name) ? node.name.text : getUniqueName(isClassLike(scope) ? "newProperty" : "newLocal", file);
	    const isJS = isInJSFile(scope);
	    let variableType = isJS || !checker.isContextSensitive(node) ? void 0 : checker.typeToTypeNode(checker.getContextualType(node), scope, 1 /* NoTruncation */);
	    let initializer = transformConstantInitializer(skipParentheses(node), substitutions);
	    ({ variableType, initializer } = transformFunctionInitializerAndType(variableType, initializer));
	    suppressLeadingAndTrailingTrivia(initializer);
	    const changeTracker = ts_textChanges_exports.ChangeTracker.fromContext(context);
	    if (isClassLike(scope)) {
	      Debug.assert(!isJS, "Cannot extract to a JS class");
	      const modifiers = [];
	      modifiers.push(factory.createModifier(123 /* PrivateKeyword */));
	      if (rangeFacts & 32 /* InStaticRegion */) {
	        modifiers.push(factory.createModifier(126 /* StaticKeyword */));
	      }
	      modifiers.push(factory.createModifier(148 /* ReadonlyKeyword */));
	      const newVariable = factory.createPropertyDeclaration(
	        modifiers,
	        localNameText,
	        /*questionOrExclamationToken*/
	        void 0,
	        variableType,
	        initializer
	      );
	      let localReference = factory.createPropertyAccessExpression(
	        rangeFacts & 32 /* InStaticRegion */ ? factory.createIdentifier(scope.name.getText()) : factory.createThis(),
	        factory.createIdentifier(localNameText)
	      );
	      if (isInJSXContent(node)) {
	        localReference = factory.createJsxExpression(
	          /*dotDotDotToken*/
	          void 0,
	          localReference
	        );
	      }
	      const maxInsertionPos = node.pos;
	      const nodeToInsertBefore = getNodeToInsertPropertyBefore(maxInsertionPos, scope);
	      changeTracker.insertNodeBefore(
	        context.file,
	        nodeToInsertBefore,
	        newVariable,
	        /*blankLineBetween*/
	        true
	      );
	      changeTracker.replaceNode(context.file, node, localReference);
	    } else {
	      const newVariableDeclaration = factory.createVariableDeclaration(
	        localNameText,
	        /*exclamationToken*/
	        void 0,
	        variableType,
	        initializer
	      );
	      const oldVariableDeclaration = getContainingVariableDeclarationIfInList(node, scope);
	      if (oldVariableDeclaration) {
	        changeTracker.insertNodeBefore(context.file, oldVariableDeclaration, newVariableDeclaration);
	        const localReference = factory.createIdentifier(localNameText);
	        changeTracker.replaceNode(context.file, node, localReference);
	      } else if (node.parent.kind === 244 /* ExpressionStatement */ && scope === findAncestor(node, isScope)) {
	        const newVariableStatement = factory.createVariableStatement(
	          /*modifiers*/
	          void 0,
	          factory.createVariableDeclarationList([newVariableDeclaration], 2 /* Const */)
	        );
	        changeTracker.replaceNode(context.file, node.parent, newVariableStatement);
	      } else {
	        const newVariableStatement = factory.createVariableStatement(
	          /*modifiers*/
	          void 0,
	          factory.createVariableDeclarationList([newVariableDeclaration], 2 /* Const */)
	        );
	        const nodeToInsertBefore = getNodeToInsertConstantBefore(node, scope);
	        if (nodeToInsertBefore.pos === 0) {
	          changeTracker.insertNodeAtTopOfFile(
	            context.file,
	            newVariableStatement,
	            /*blankLineBetween*/
	            false
	          );
	        } else {
	          changeTracker.insertNodeBefore(
	            context.file,
	            nodeToInsertBefore,
	            newVariableStatement,
	            /*blankLineBetween*/
	            false
	          );
	        }
	        if (node.parent.kind === 244 /* ExpressionStatement */) {
	          changeTracker.delete(context.file, node.parent);
	        } else {
	          let localReference = factory.createIdentifier(localNameText);
	          if (isInJSXContent(node)) {
	            localReference = factory.createJsxExpression(
	              /*dotDotDotToken*/
	              void 0,
	              localReference
	            );
	          }
	          changeTracker.replaceNode(context.file, node, localReference);
	        }
	      }
	    }
	    const edits = changeTracker.getChanges();
	    const renameFilename = node.getSourceFile().fileName;
	    const renameLocation = getRenameLocation(
	      edits,
	      renameFilename,
	      localNameText,
	      /*preferLastLocation*/
	      true
	    );
	    return { renameFilename, renameLocation, edits };
	    function transformFunctionInitializerAndType(variableType2, initializer2) {
	      if (variableType2 === void 0)
	        return { variableType: variableType2, initializer: initializer2 };
	      if (!isFunctionExpression(initializer2) && !isArrowFunction(initializer2) || !!initializer2.typeParameters)
	        return { variableType: variableType2, initializer: initializer2 };
	      const functionType = checker.getTypeAtLocation(node);
	      const functionSignature = singleOrUndefined(checker.getSignaturesOfType(functionType, 0 /* Call */));
	      if (!functionSignature)
	        return { variableType: variableType2, initializer: initializer2 };
	      if (!!functionSignature.getTypeParameters())
	        return { variableType: variableType2, initializer: initializer2 };
	      const parameters = [];
	      let hasAny = false;
	      for (const p of initializer2.parameters) {
	        if (p.type) {
	          parameters.push(p);
	        } else {
	          const paramType = checker.getTypeAtLocation(p);
	          if (paramType === checker.getAnyType())
	            hasAny = true;
	          parameters.push(factory.updateParameterDeclaration(p, p.modifiers, p.dotDotDotToken, p.name, p.questionToken, p.type || checker.typeToTypeNode(paramType, scope, 1 /* NoTruncation */), p.initializer));
	        }
	      }
	      if (hasAny)
	        return { variableType: variableType2, initializer: initializer2 };
	      variableType2 = void 0;
	      if (isArrowFunction(initializer2)) {
	        initializer2 = factory.updateArrowFunction(initializer2, canHaveModifiers(node) ? getModifiers(node) : void 0, initializer2.typeParameters, parameters, initializer2.type || checker.typeToTypeNode(functionSignature.getReturnType(), scope, 1 /* NoTruncation */), initializer2.equalsGreaterThanToken, initializer2.body);
	      } else {
	        if (functionSignature && !!functionSignature.thisParameter) {
	          const firstParameter = firstOrUndefined(parameters);
	          if (!firstParameter || isIdentifier(firstParameter.name) && firstParameter.name.escapedText !== "this") {
	            const thisType = checker.getTypeOfSymbolAtLocation(functionSignature.thisParameter, node);
	            parameters.splice(
	              0,
	              0,
	              factory.createParameterDeclaration(
	                /*modifiers*/
	                void 0,
	                /*dotDotDotToken*/
	                void 0,
	                "this",
	                /*questionToken*/
	                void 0,
	                checker.typeToTypeNode(thisType, scope, 1 /* NoTruncation */)
	              )
	            );
	          }
	        }
	        initializer2 = factory.updateFunctionExpression(initializer2, canHaveModifiers(node) ? getModifiers(node) : void 0, initializer2.asteriskToken, initializer2.name, initializer2.typeParameters, parameters, initializer2.type || checker.typeToTypeNode(functionSignature.getReturnType(), scope, 1 /* NoTruncation */), initializer2.body);
	      }
	      return { variableType: variableType2, initializer: initializer2 };
	    }
	  }
	  function getContainingVariableDeclarationIfInList(node, scope) {
	    let prevNode;
	    while (node !== void 0 && node !== scope) {
	      if (isVariableDeclaration(node) && node.initializer === prevNode && isVariableDeclarationList(node.parent) && node.parent.declarations.length > 1) {
	        return node;
	      }
	      prevNode = node;
	      node = node.parent;
	    }
	  }
	  function getFirstDeclarationBeforePosition(type, position) {
	    let firstDeclaration;
	    const symbol = type.symbol;
	    if (symbol && symbol.declarations) {
	      for (const declaration of symbol.declarations) {
	        if ((firstDeclaration === void 0 || declaration.pos < firstDeclaration.pos) && declaration.pos < position) {
	          firstDeclaration = declaration;
	        }
	      }
	    }
	    return firstDeclaration;
	  }
	  function compareTypesByDeclarationOrder({ type: type1, declaration: declaration1 }, { type: type2, declaration: declaration2 }) {
	    return compareProperties(declaration1, declaration2, "pos", compareValues) || compareStringsCaseSensitive(
	      type1.symbol ? type1.symbol.getName() : "",
	      type2.symbol ? type2.symbol.getName() : ""
	    ) || compareValues(type1.id, type2.id);
	  }
	  function getCalledExpression(scope, range, functionNameText) {
	    const functionReference = factory.createIdentifier(functionNameText);
	    if (isClassLike(scope)) {
	      const lhs = range.facts & 32 /* InStaticRegion */ ? factory.createIdentifier(scope.name.text) : factory.createThis();
	      return factory.createPropertyAccessExpression(lhs, functionReference);
	    } else {
	      return functionReference;
	    }
	  }
	  function transformFunctionBody(body, exposedVariableDeclarations, writes, substitutions, hasReturn2) {
	    const hasWritesOrVariableDeclarations = writes !== void 0 || exposedVariableDeclarations.length > 0;
	    if (isBlock(body) && !hasWritesOrVariableDeclarations && substitutions.size === 0) {
	      return { body: factory.createBlock(
	        body.statements,
	        /*multiLine*/
	        true
	      ), returnValueProperty: void 0 };
	    }
	    let returnValueProperty;
	    let ignoreReturns = false;
	    const statements = factory.createNodeArray(isBlock(body) ? body.statements.slice(0) : [isStatement(body) ? body : factory.createReturnStatement(skipParentheses(body))]);
	    if (hasWritesOrVariableDeclarations || substitutions.size) {
	      const rewrittenStatements = visitNodes2(statements, visitor, isStatement).slice();
	      if (hasWritesOrVariableDeclarations && !hasReturn2 && isStatement(body)) {
	        const assignments = getPropertyAssignmentsForWritesAndVariableDeclarations(exposedVariableDeclarations, writes);
	        if (assignments.length === 1) {
	          rewrittenStatements.push(factory.createReturnStatement(assignments[0].name));
	        } else {
	          rewrittenStatements.push(factory.createReturnStatement(factory.createObjectLiteralExpression(assignments)));
	        }
	      }
	      return { body: factory.createBlock(
	        rewrittenStatements,
	        /*multiLine*/
	        true
	      ), returnValueProperty };
	    } else {
	      return { body: factory.createBlock(
	        statements,
	        /*multiLine*/
	        true
	      ), returnValueProperty: void 0 };
	    }
	    function visitor(node) {
	      if (!ignoreReturns && isReturnStatement(node) && hasWritesOrVariableDeclarations) {
	        const assignments = getPropertyAssignmentsForWritesAndVariableDeclarations(exposedVariableDeclarations, writes);
	        if (node.expression) {
	          if (!returnValueProperty) {
	            returnValueProperty = "__return";
	          }
	          assignments.unshift(factory.createPropertyAssignment(returnValueProperty, visitNode(node.expression, visitor, isExpression)));
	        }
	        if (assignments.length === 1) {
	          return factory.createReturnStatement(assignments[0].name);
	        } else {
	          return factory.createReturnStatement(factory.createObjectLiteralExpression(assignments));
	        }
	      } else {
	        const oldIgnoreReturns = ignoreReturns;
	        ignoreReturns = ignoreReturns || isFunctionLikeDeclaration(node) || isClassLike(node);
	        const substitution = substitutions.get(getNodeId(node).toString());
	        const result = substitution ? getSynthesizedDeepClone(substitution) : visitEachChild(
	          node,
	          visitor,
	          /*context*/
	          void 0
	        );
	        ignoreReturns = oldIgnoreReturns;
	        return result;
	      }
	    }
	  }
	  function transformConstantInitializer(initializer, substitutions) {
	    return substitutions.size ? visitor(initializer) : initializer;
	    function visitor(node) {
	      const substitution = substitutions.get(getNodeId(node).toString());
	      return substitution ? getSynthesizedDeepClone(substitution) : visitEachChild(
	        node,
	        visitor,
	        /*context*/
	        void 0
	      );
	    }
	  }
	  function getStatementsOrClassElements(scope) {
	    if (isFunctionLikeDeclaration(scope)) {
	      const body = scope.body;
	      if (isBlock(body)) {
	        return body.statements;
	      }
	    } else if (isModuleBlock(scope) || isSourceFile(scope)) {
	      return scope.statements;
	    } else if (isClassLike(scope)) {
	      return scope.members;
	    } else ;
	    return emptyArray;
	  }
	  function getNodeToInsertFunctionBefore(minPos, scope) {
	    return find(getStatementsOrClassElements(scope), (child) => child.pos >= minPos && isFunctionLikeDeclaration(child) && !isConstructorDeclaration(child));
	  }
	  function getNodeToInsertPropertyBefore(maxPos, scope) {
	    const members = scope.members;
	    Debug.assert(members.length > 0, "Found no members");
	    let prevMember;
	    let allProperties = true;
	    for (const member of members) {
	      if (member.pos > maxPos) {
	        return prevMember || members[0];
	      }
	      if (allProperties && !isPropertyDeclaration(member)) {
	        if (prevMember !== void 0) {
	          return member;
	        }
	        allProperties = false;
	      }
	      prevMember = member;
	    }
	    if (prevMember === void 0)
	      return Debug.fail();
	    return prevMember;
	  }
	  function getNodeToInsertConstantBefore(node, scope) {
	    Debug.assert(!isClassLike(scope));
	    let prevScope;
	    for (let curr = node; curr !== scope; curr = curr.parent) {
	      if (isScope(curr)) {
	        prevScope = curr;
	      }
	    }
	    for (let curr = (prevScope || node).parent; ; curr = curr.parent) {
	      if (isBlockLike(curr)) {
	        let prevStatement;
	        for (const statement of curr.statements) {
	          if (statement.pos > node.pos) {
	            break;
	          }
	          prevStatement = statement;
	        }
	        if (!prevStatement && isCaseClause(curr)) {
	          Debug.assert(isSwitchStatement(curr.parent.parent), "Grandparent isn't a switch statement");
	          return curr.parent.parent;
	        }
	        return Debug.checkDefined(prevStatement, "prevStatement failed to get set");
	      }
	      Debug.assert(curr !== scope, "Didn't encounter a block-like before encountering scope");
	    }
	  }
	  function getPropertyAssignmentsForWritesAndVariableDeclarations(exposedVariableDeclarations, writes) {
	    const variableAssignments = map(exposedVariableDeclarations, (v) => factory.createShorthandPropertyAssignment(v.symbol.name));
	    const writeAssignments = map(writes, (w) => factory.createShorthandPropertyAssignment(w.symbol.name));
	    return variableAssignments === void 0 ? writeAssignments : writeAssignments === void 0 ? variableAssignments : variableAssignments.concat(writeAssignments);
	  }
	  function isReadonlyArray(v) {
	    return isArray(v);
	  }
	  function getEnclosingTextRange(targetRange, sourceFile) {
	    return isReadonlyArray(targetRange.range) ? { pos: first(targetRange.range).getStart(sourceFile), end: last(targetRange.range).getEnd() } : targetRange.range;
	  }
	  function collectReadsAndWrites(targetRange, scopes, enclosingTextRange, sourceFile, checker, cancellationToken) {
	    const allTypeParameterUsages = /* @__PURE__ */ new Map();
	    const usagesPerScope = [];
	    const substitutionsPerScope = [];
	    const functionErrorsPerScope = [];
	    const constantErrorsPerScope = [];
	    const visibleDeclarationsInExtractedRange = [];
	    const exposedVariableSymbolSet = /* @__PURE__ */ new Map();
	    const exposedVariableDeclarations = [];
	    let firstExposedNonVariableDeclaration;
	    const expression = !isReadonlyArray(targetRange.range) ? targetRange.range : targetRange.range.length === 1 && isExpressionStatement(targetRange.range[0]) ? targetRange.range[0].expression : void 0;
	    let expressionDiagnostic;
	    if (expression === void 0) {
	      const statements = targetRange.range;
	      const start = first(statements).getStart();
	      const end = last(statements).end;
	      expressionDiagnostic = createFileDiagnostic(sourceFile, start, end - start, Messages.expressionExpected);
	    } else if (checker.getTypeAtLocation(expression).flags & (16384 /* Void */ | 131072 /* Never */)) {
	      expressionDiagnostic = createDiagnosticForNode(expression, Messages.uselessConstantType);
	    }
	    for (const scope of scopes) {
	      usagesPerScope.push({ usages: /* @__PURE__ */ new Map(), typeParameterUsages: /* @__PURE__ */ new Map(), substitutions: /* @__PURE__ */ new Map() });
	      substitutionsPerScope.push(/* @__PURE__ */ new Map());
	      functionErrorsPerScope.push([]);
	      const constantErrors = [];
	      if (expressionDiagnostic) {
	        constantErrors.push(expressionDiagnostic);
	      }
	      if (isClassLike(scope) && isInJSFile(scope)) {
	        constantErrors.push(createDiagnosticForNode(scope, Messages.cannotExtractToJSClass));
	      }
	      if (isArrowFunction(scope) && !isBlock(scope.body)) {
	        constantErrors.push(createDiagnosticForNode(scope, Messages.cannotExtractToExpressionArrowFunction));
	      }
	      constantErrorsPerScope.push(constantErrors);
	    }
	    const seenUsages = /* @__PURE__ */ new Map();
	    const target = isReadonlyArray(targetRange.range) ? factory.createBlock(targetRange.range) : targetRange.range;
	    const unmodifiedNode = isReadonlyArray(targetRange.range) ? first(targetRange.range) : targetRange.range;
	    const inGenericContext = isInGenericContext(unmodifiedNode);
	    collectUsages(target);
	    if (inGenericContext && !isReadonlyArray(targetRange.range) && !isJsxAttribute(targetRange.range)) {
	      const contextualType = checker.getContextualType(targetRange.range);
	      recordTypeParameterUsages(contextualType);
	    }
	    if (allTypeParameterUsages.size > 0) {
	      const seenTypeParameterUsages = /* @__PURE__ */ new Map();
	      let i = 0;
	      for (let curr = unmodifiedNode; curr !== void 0 && i < scopes.length; curr = curr.parent) {
	        if (curr === scopes[i]) {
	          seenTypeParameterUsages.forEach((typeParameter, id) => {
	            usagesPerScope[i].typeParameterUsages.set(id, typeParameter);
	          });
	          i++;
	        }
	        if (isDeclarationWithTypeParameters(curr)) {
	          for (const typeParameterDecl of getEffectiveTypeParameterDeclarations(curr)) {
	            const typeParameter = checker.getTypeAtLocation(typeParameterDecl);
	            if (allTypeParameterUsages.has(typeParameter.id.toString())) {
	              seenTypeParameterUsages.set(typeParameter.id.toString(), typeParameter);
	            }
	          }
	        }
	      }
	      Debug.assert(i === scopes.length, "Should have iterated all scopes");
	    }
	    if (visibleDeclarationsInExtractedRange.length) {
	      const containingLexicalScopeOfExtraction = isBlockScope(scopes[0], scopes[0].parent) ? scopes[0] : getEnclosingBlockScopeContainer(scopes[0]);
	      forEachChild(containingLexicalScopeOfExtraction, checkForUsedDeclarations);
	    }
	    for (let i = 0; i < scopes.length; i++) {
	      const scopeUsages = usagesPerScope[i];
	      if (i > 0 && (scopeUsages.usages.size > 0 || scopeUsages.typeParameterUsages.size > 0)) {
	        const errorNode = isReadonlyArray(targetRange.range) ? targetRange.range[0] : targetRange.range;
	        constantErrorsPerScope[i].push(createDiagnosticForNode(errorNode, Messages.cannotAccessVariablesFromNestedScopes));
	      }
	      if (targetRange.facts & 16 /* UsesThisInFunction */ && isClassLike(scopes[i])) {
	        functionErrorsPerScope[i].push(createDiagnosticForNode(targetRange.thisNode, Messages.cannotExtractFunctionsContainingThisToMethod));
	      }
	      let hasWrite = false;
	      let readonlyClassPropertyWrite;
	      usagesPerScope[i].usages.forEach((value) => {
	        if (value.usage === 2 /* Write */) {
	          hasWrite = true;
	          if (value.symbol.flags & 106500 /* ClassMember */ && value.symbol.valueDeclaration && hasEffectiveModifier(value.symbol.valueDeclaration, 8 /* Readonly */)) {
	            readonlyClassPropertyWrite = value.symbol.valueDeclaration;
	          }
	        }
	      });
	      Debug.assert(isReadonlyArray(targetRange.range) || exposedVariableDeclarations.length === 0, "No variable declarations expected if something was extracted");
	      if (hasWrite && !isReadonlyArray(targetRange.range)) {
	        const diag2 = createDiagnosticForNode(targetRange.range, Messages.cannotWriteInExpression);
	        functionErrorsPerScope[i].push(diag2);
	        constantErrorsPerScope[i].push(diag2);
	      } else if (readonlyClassPropertyWrite && i > 0) {
	        const diag2 = createDiagnosticForNode(readonlyClassPropertyWrite, Messages.cannotExtractReadonlyPropertyInitializerOutsideConstructor);
	        functionErrorsPerScope[i].push(diag2);
	        constantErrorsPerScope[i].push(diag2);
	      } else if (firstExposedNonVariableDeclaration) {
	        const diag2 = createDiagnosticForNode(firstExposedNonVariableDeclaration, Messages.cannotExtractExportedEntity);
	        functionErrorsPerScope[i].push(diag2);
	        constantErrorsPerScope[i].push(diag2);
	      }
	    }
	    return { target, usagesPerScope, functionErrorsPerScope, constantErrorsPerScope, exposedVariableDeclarations };
	    function isInGenericContext(node) {
	      return !!findAncestor(node, (n) => isDeclarationWithTypeParameters(n) && getEffectiveTypeParameterDeclarations(n).length !== 0);
	    }
	    function recordTypeParameterUsages(type) {
	      const symbolWalker = checker.getSymbolWalker(() => (cancellationToken.throwIfCancellationRequested(), true));
	      const { visitedTypes } = symbolWalker.walkType(type);
	      for (const visitedType of visitedTypes) {
	        if (visitedType.isTypeParameter()) {
	          allTypeParameterUsages.set(visitedType.id.toString(), visitedType);
	        }
	      }
	    }
	    function collectUsages(node, valueUsage = 1 /* Read */) {
	      if (inGenericContext) {
	        const type = checker.getTypeAtLocation(node);
	        recordTypeParameterUsages(type);
	      }
	      if (isDeclaration(node) && node.symbol) {
	        visibleDeclarationsInExtractedRange.push(node);
	      }
	      if (isAssignmentExpression(node)) {
	        collectUsages(node.left, 2 /* Write */);
	        collectUsages(node.right);
	      } else if (isUnaryExpressionWithWrite(node)) {
	        collectUsages(node.operand, 2 /* Write */);
	      } else if (isPropertyAccessExpression(node) || isElementAccessExpression(node)) {
	        forEachChild(node, collectUsages);
	      } else if (isIdentifier(node)) {
	        if (!node.parent) {
	          return;
	        }
	        if (isQualifiedName(node.parent) && node !== node.parent.left) {
	          return;
	        }
	        if (isPropertyAccessExpression(node.parent) && node !== node.parent.expression) {
	          return;
	        }
	        recordUsage(
	          node,
	          valueUsage,
	          /*isTypeNode*/
	          isPartOfTypeNode(node)
	        );
	      } else {
	        forEachChild(node, collectUsages);
	      }
	    }
	    function recordUsage(n, usage, isTypeNode2) {
	      const symbolId = recordUsagebySymbol(n, usage, isTypeNode2);
	      if (symbolId) {
	        for (let i = 0; i < scopes.length; i++) {
	          const substitution = substitutionsPerScope[i].get(symbolId);
	          if (substitution) {
	            usagesPerScope[i].substitutions.set(getNodeId(n).toString(), substitution);
	          }
	        }
	      }
	    }
	    function recordUsagebySymbol(identifier, usage, isTypeName) {
	      const symbol = getSymbolReferencedByIdentifier(identifier);
	      if (!symbol) {
	        return void 0;
	      }
	      const symbolId = getSymbolId(symbol).toString();
	      const lastUsage = seenUsages.get(symbolId);
	      if (lastUsage && lastUsage >= usage) {
	        return symbolId;
	      }
	      seenUsages.set(symbolId, usage);
	      if (lastUsage) {
	        for (const perScope of usagesPerScope) {
	          const prevEntry = perScope.usages.get(identifier.text);
	          if (prevEntry) {
	            perScope.usages.set(identifier.text, { usage, symbol, node: identifier });
	          }
	        }
	        return symbolId;
	      }
	      const decls = symbol.getDeclarations();
	      const declInFile = decls && find(decls, (d) => d.getSourceFile() === sourceFile);
	      if (!declInFile) {
	        return void 0;
	      }
	      if (rangeContainsStartEnd(enclosingTextRange, declInFile.getStart(), declInFile.end)) {
	        return void 0;
	      }
	      if (targetRange.facts & 2 /* IsGenerator */ && usage === 2 /* Write */) {
	        const diag2 = createDiagnosticForNode(identifier, Messages.cannotExtractRangeThatContainsWritesToReferencesLocatedOutsideOfTheTargetRangeInGenerators);
	        for (const errors of functionErrorsPerScope) {
	          errors.push(diag2);
	        }
	        for (const errors of constantErrorsPerScope) {
	          errors.push(diag2);
	        }
	      }
	      for (let i = 0; i < scopes.length; i++) {
	        const scope = scopes[i];
	        const resolvedSymbol = checker.resolveName(
	          symbol.name,
	          scope,
	          symbol.flags,
	          /*excludeGlobals*/
	          false
	        );
	        if (resolvedSymbol === symbol) {
	          continue;
	        }
	        if (!substitutionsPerScope[i].has(symbolId)) {
	          const substitution = tryReplaceWithQualifiedNameOrPropertyAccess(symbol.exportSymbol || symbol, scope, isTypeName);
	          if (substitution) {
	            substitutionsPerScope[i].set(symbolId, substitution);
	          } else if (isTypeName) {
	            if (!(symbol.flags & 262144 /* TypeParameter */)) {
	              const diag2 = createDiagnosticForNode(identifier, Messages.typeWillNotBeVisibleInTheNewScope);
	              functionErrorsPerScope[i].push(diag2);
	              constantErrorsPerScope[i].push(diag2);
	            }
	          } else {
	            usagesPerScope[i].usages.set(identifier.text, { usage, symbol, node: identifier });
	          }
	        }
	      }
	      return symbolId;
	    }
	    function checkForUsedDeclarations(node) {
	      if (node === targetRange.range || isReadonlyArray(targetRange.range) && targetRange.range.includes(node)) {
	        return;
	      }
	      const sym = isIdentifier(node) ? getSymbolReferencedByIdentifier(node) : checker.getSymbolAtLocation(node);
	      if (sym) {
	        const decl = find(visibleDeclarationsInExtractedRange, (d) => d.symbol === sym);
	        if (decl) {
	          if (isVariableDeclaration(decl)) {
	            const idString = decl.symbol.id.toString();
	            if (!exposedVariableSymbolSet.has(idString)) {
	              exposedVariableDeclarations.push(decl);
	              exposedVariableSymbolSet.set(idString, true);
	            }
	          } else {
	            firstExposedNonVariableDeclaration = firstExposedNonVariableDeclaration || decl;
	          }
	        }
	      }
	      forEachChild(node, checkForUsedDeclarations);
	    }
	    function getSymbolReferencedByIdentifier(identifier) {
	      return identifier.parent && isShorthandPropertyAssignment(identifier.parent) && identifier.parent.name === identifier ? checker.getShorthandAssignmentValueSymbol(identifier.parent) : checker.getSymbolAtLocation(identifier);
	    }
	    function tryReplaceWithQualifiedNameOrPropertyAccess(symbol, scopeDecl, isTypeNode2) {
	      if (!symbol) {
	        return void 0;
	      }
	      const decls = symbol.getDeclarations();
	      if (decls && decls.some((d) => d.parent === scopeDecl)) {
	        return factory.createIdentifier(symbol.name);
	      }
	      const prefix = tryReplaceWithQualifiedNameOrPropertyAccess(symbol.parent, scopeDecl, isTypeNode2);
	      if (prefix === void 0) {
	        return void 0;
	      }
	      return isTypeNode2 ? factory.createQualifiedName(prefix, factory.createIdentifier(symbol.name)) : factory.createPropertyAccessExpression(prefix, symbol.name);
	    }
	  }
	  function getExtractableParent(node) {
	    return findAncestor(node, (node2) => node2.parent && isExtractableExpression(node2) && !isBinaryExpression(node2.parent));
	  }
	  function isExtractableExpression(node) {
	    const { parent: parent2 } = node;
	    switch (parent2.kind) {
	      case 306 /* EnumMember */:
	        return false;
	    }
	    switch (node.kind) {
	      case 11 /* StringLiteral */:
	        return parent2.kind !== 272 /* ImportDeclaration */ && parent2.kind !== 276 /* ImportSpecifier */;
	      case 230 /* SpreadElement */:
	      case 206 /* ObjectBindingPattern */:
	      case 208 /* BindingElement */:
	        return false;
	      case 80 /* Identifier */:
	        return parent2.kind !== 208 /* BindingElement */ && parent2.kind !== 276 /* ImportSpecifier */ && parent2.kind !== 281 /* ExportSpecifier */;
	    }
	    return true;
	  }
	  function isBlockLike(node) {
	    switch (node.kind) {
	      case 241 /* Block */:
	      case 312 /* SourceFile */:
	      case 268 /* ModuleBlock */:
	      case 296 /* CaseClause */:
	        return true;
	      default:
	        return false;
	    }
	  }
	  function isInJSXContent(node) {
	    return isStringLiteralJsxAttribute(node) || (isJsxElement(node) || isJsxSelfClosingElement(node) || isJsxFragment(node)) && (isJsxElement(node.parent) || isJsxFragment(node.parent));
	  }
	  function isStringLiteralJsxAttribute(node) {
	    return isStringLiteral(node) && node.parent && isJsxAttribute(node.parent);
	  }
	  var refactorName12, extractConstantAction, extractFunctionAction, Messages, RangeFacts;
	  var init_extractSymbol = __esm({
	    "src/services/refactors/extractSymbol.ts"() {
	      init_ts4();
	      init_ts_refactor();
	      refactorName12 = "Extract Symbol";
	      extractConstantAction = {
	        name: "Extract Constant",
	        description: getLocaleSpecificMessage(Diagnostics.Extract_constant),
	        kind: "refactor.extract.constant"
	      };
	      extractFunctionAction = {
	        name: "Extract Function",
	        description: getLocaleSpecificMessage(Diagnostics.Extract_function),
	        kind: "refactor.extract.function"
	      };
	      registerRefactor(refactorName12, {
	        kinds: [
	          extractConstantAction.kind,
	          extractFunctionAction.kind
	        ],
	        getEditsForAction: getRefactorEditsToExtractSymbol,
	        getAvailableActions: getRefactorActionsToExtractSymbol
	      });
	      ((Messages2) => {
	        function createMessage(message) {
	          return { message, code: 0, category: 3 /* Message */, key: message };
	        }
	        Messages2.cannotExtractRange = createMessage("Cannot extract range.");
	        Messages2.cannotExtractImport = createMessage("Cannot extract import statement.");
	        Messages2.cannotExtractSuper = createMessage("Cannot extract super call.");
	        Messages2.cannotExtractJSDoc = createMessage("Cannot extract JSDoc.");
	        Messages2.cannotExtractEmpty = createMessage("Cannot extract empty range.");
	        Messages2.expressionExpected = createMessage("expression expected.");
	        Messages2.uselessConstantType = createMessage("No reason to extract constant of type.");
	        Messages2.statementOrExpressionExpected = createMessage("Statement or expression expected.");
	        Messages2.cannotExtractRangeContainingConditionalBreakOrContinueStatements = createMessage("Cannot extract range containing conditional break or continue statements.");
	        Messages2.cannotExtractRangeContainingConditionalReturnStatement = createMessage("Cannot extract range containing conditional return statement.");
	        Messages2.cannotExtractRangeContainingLabeledBreakOrContinueStatementWithTargetOutsideOfTheRange = createMessage("Cannot extract range containing labeled break or continue with target outside of the range.");
	        Messages2.cannotExtractRangeThatContainsWritesToReferencesLocatedOutsideOfTheTargetRangeInGenerators = createMessage("Cannot extract range containing writes to references located outside of the target range in generators.");
	        Messages2.typeWillNotBeVisibleInTheNewScope = createMessage("Type will not visible in the new scope.");
	        Messages2.functionWillNotBeVisibleInTheNewScope = createMessage("Function will not visible in the new scope.");
	        Messages2.cannotExtractIdentifier = createMessage("Select more than a single identifier.");
	        Messages2.cannotExtractExportedEntity = createMessage("Cannot extract exported declaration");
	        Messages2.cannotWriteInExpression = createMessage("Cannot write back side-effects when extracting an expression");
	        Messages2.cannotExtractReadonlyPropertyInitializerOutsideConstructor = createMessage("Cannot move initialization of read-only class property outside of the constructor");
	        Messages2.cannotExtractAmbientBlock = createMessage("Cannot extract code from ambient contexts");
	        Messages2.cannotAccessVariablesFromNestedScopes = createMessage("Cannot access variables from nested scopes");
	        Messages2.cannotExtractToJSClass = createMessage("Cannot extract constant to a class scope in JS");
	        Messages2.cannotExtractToExpressionArrowFunction = createMessage("Cannot extract constant to an arrow function without a block");
	        Messages2.cannotExtractFunctionsContainingThisToMethod = createMessage("Cannot extract functions containing this to method");
	      })(Messages || (Messages = {}));
	      RangeFacts = /* @__PURE__ */ ((RangeFacts2) => {
	        RangeFacts2[RangeFacts2["None"] = 0] = "None";
	        RangeFacts2[RangeFacts2["HasReturn"] = 1] = "HasReturn";
	        RangeFacts2[RangeFacts2["IsGenerator"] = 2] = "IsGenerator";
	        RangeFacts2[RangeFacts2["IsAsyncFunction"] = 4] = "IsAsyncFunction";
	        RangeFacts2[RangeFacts2["UsesThis"] = 8] = "UsesThis";
	        RangeFacts2[RangeFacts2["UsesThisInFunction"] = 16] = "UsesThisInFunction";
	        RangeFacts2[RangeFacts2["InStaticRegion"] = 32] = "InStaticRegion";
	        return RangeFacts2;
	      })(RangeFacts || {});
	    }
	  });

	  // src/services/_namespaces/ts.refactor.extractSymbol.ts
	  var ts_refactor_extractSymbol_exports = {};
	  __export(ts_refactor_extractSymbol_exports, {
	    Messages: () => Messages,
	    RangeFacts: () => RangeFacts,
	    getRangeToExtract: () => getRangeToExtract2,
	    getRefactorActionsToExtractSymbol: () => getRefactorActionsToExtractSymbol,
	    getRefactorEditsToExtractSymbol: () => getRefactorEditsToExtractSymbol
	  });
	  var init_ts_refactor_extractSymbol = __esm({
	    "src/services/_namespaces/ts.refactor.extractSymbol.ts"() {
	      init_extractSymbol();
	    }
	  });

	  // src/services/refactors/generateGetAccessorAndSetAccessor.ts
	  var actionName, actionDescription, generateGetSetAction;
	  var init_generateGetAccessorAndSetAccessor = __esm({
	    "src/services/refactors/generateGetAccessorAndSetAccessor.ts"() {
	      init_ts4();
	      init_ts_refactor();
	      actionName = "Generate 'get' and 'set' accessors";
	      actionDescription = getLocaleSpecificMessage(Diagnostics.Generate_get_and_set_accessors);
	      generateGetSetAction = {
	        name: actionName,
	        description: actionDescription,
	        kind: "refactor.rewrite.property.generateAccessors"
	      };
	      registerRefactor(actionName, {
	        kinds: [generateGetSetAction.kind],
	        getEditsForAction: function getRefactorActionsToGenerateGetAndSetAccessors(context, actionName2) {
	          if (!context.endPosition)
	            return void 0;
	          const info = ts_codefix_exports.getAccessorConvertiblePropertyAtPosition(context.file, context.program, context.startPosition, context.endPosition);
	          Debug.assert(info && !isRefactorErrorInfo(info), "Expected applicable refactor info");
	          const edits = ts_codefix_exports.generateAccessorFromProperty(context.file, context.program, context.startPosition, context.endPosition, context, actionName2);
	          if (!edits)
	            return void 0;
	          const renameFilename = context.file.fileName;
	          const nameNeedRename = info.renameAccessor ? info.accessorName : info.fieldName;
	          const renameLocationOffset = isIdentifier(nameNeedRename) ? 0 : -1;
	          const renameLocation = renameLocationOffset + getRenameLocation(
	            edits,
	            renameFilename,
	            nameNeedRename.text,
	            /*preferLastLocation*/
	            isParameter(info.declaration)
	          );
	          return { renameFilename, renameLocation, edits };
	        },
	        getAvailableActions(context) {
	          if (!context.endPosition)
	            return emptyArray;
	          const info = ts_codefix_exports.getAccessorConvertiblePropertyAtPosition(context.file, context.program, context.startPosition, context.endPosition, context.triggerReason === "invoked");
	          if (!info)
	            return emptyArray;
	          if (!isRefactorErrorInfo(info)) {
	            return [{
	              name: actionName,
	              description: actionDescription,
	              actions: [generateGetSetAction]
	            }];
	          }
	          if (context.preferences.provideRefactorNotApplicableReason) {
	            return [{
	              name: actionName,
	              description: actionDescription,
	              actions: [{ ...generateGetSetAction, notApplicableReason: info.error }]
	            }];
	          }
	          return emptyArray;
	        }
	      });
	    }
	  });

	  // src/services/_namespaces/ts.refactor.generateGetAccessorAndSetAccessor.ts
	  var ts_refactor_generateGetAccessorAndSetAccessor_exports = {};
	  var init_ts_refactor_generateGetAccessorAndSetAccessor = __esm({
	    "src/services/_namespaces/ts.refactor.generateGetAccessorAndSetAccessor.ts"() {
	      init_generateGetAccessorAndSetAccessor();
	    }
	  });

	  // src/services/refactors/inferFunctionReturnType.ts
	  function getRefactorEditsToInferReturnType(context) {
	    const info = getInfo4(context);
	    if (info && !isRefactorErrorInfo(info)) {
	      const edits = ts_textChanges_exports.ChangeTracker.with(context, (t) => doChange7(context.file, t, info.declaration, info.returnTypeNode));
	      return { renameFilename: void 0, renameLocation: void 0, edits };
	    }
	    return void 0;
	  }
	  function getRefactorActionsToInferReturnType(context) {
	    const info = getInfo4(context);
	    if (!info)
	      return emptyArray;
	    if (!isRefactorErrorInfo(info)) {
	      return [{
	        name: refactorName13,
	        description: refactorDescription7,
	        actions: [inferReturnTypeAction]
	      }];
	    }
	    if (context.preferences.provideRefactorNotApplicableReason) {
	      return [{
	        name: refactorName13,
	        description: refactorDescription7,
	        actions: [{ ...inferReturnTypeAction, notApplicableReason: info.error }]
	      }];
	    }
	    return emptyArray;
	  }
	  function doChange7(sourceFile, changes, declaration, typeNode) {
	    const closeParen = findChildOfKind(declaration, 22 /* CloseParenToken */, sourceFile);
	    const needParens = isArrowFunction(declaration) && closeParen === void 0;
	    const endNode2 = needParens ? first(declaration.parameters) : closeParen;
	    if (endNode2) {
	      if (needParens) {
	        changes.insertNodeBefore(sourceFile, endNode2, factory.createToken(21 /* OpenParenToken */));
	        changes.insertNodeAfter(sourceFile, endNode2, factory.createToken(22 /* CloseParenToken */));
	      }
	      changes.insertNodeAt(sourceFile, endNode2.end, typeNode, { prefix: ": " });
	    }
	  }
	  function getInfo4(context) {
	    if (isInJSFile(context.file) || !refactorKindBeginsWith(inferReturnTypeAction.kind, context.kind))
	      return;
	    const token = getTouchingPropertyName(context.file, context.startPosition);
	    const declaration = findAncestor(token, (n) => isBlock(n) || n.parent && isArrowFunction(n.parent) && (n.kind === 39 /* EqualsGreaterThanToken */ || n.parent.body === n) ? "quit" : isConvertibleDeclaration(n));
	    if (!declaration || !declaration.body || declaration.type) {
	      return { error: getLocaleSpecificMessage(Diagnostics.Return_type_must_be_inferred_from_a_function) };
	    }
	    const typeChecker = context.program.getTypeChecker();
	    const returnType = tryGetReturnType(typeChecker, declaration);
	    if (!returnType) {
	      return { error: getLocaleSpecificMessage(Diagnostics.Could_not_determine_function_return_type) };
	    }
	    const returnTypeNode = typeChecker.typeToTypeNode(returnType, declaration, 1 /* NoTruncation */);
	    if (returnTypeNode) {
	      return { declaration, returnTypeNode };
	    }
	  }
	  function isConvertibleDeclaration(node) {
	    switch (node.kind) {
	      case 262 /* FunctionDeclaration */:
	      case 218 /* FunctionExpression */:
	      case 219 /* ArrowFunction */:
	      case 174 /* MethodDeclaration */:
	        return true;
	      default:
	        return false;
	    }
	  }
	  function tryGetReturnType(typeChecker, node) {
	    if (typeChecker.isImplementationOfOverload(node)) {
	      const signatures = typeChecker.getTypeAtLocation(node).getCallSignatures();
	      if (signatures.length > 1) {
	        return typeChecker.getUnionType(mapDefined(signatures, (s) => s.getReturnType()));
	      }
	    }
	    const signature = typeChecker.getSignatureFromDeclaration(node);
	    if (signature) {
	      return typeChecker.getReturnTypeOfSignature(signature);
	    }
	  }
	  var refactorName13, refactorDescription7, inferReturnTypeAction;
	  var init_inferFunctionReturnType = __esm({
	    "src/services/refactors/inferFunctionReturnType.ts"() {
	      init_ts4();
	      init_ts_refactor();
	      refactorName13 = "Infer function return type";
	      refactorDescription7 = getLocaleSpecificMessage(Diagnostics.Infer_function_return_type);
	      inferReturnTypeAction = {
	        name: refactorName13,
	        description: refactorDescription7,
	        kind: "refactor.rewrite.function.returnType"
	      };
	      registerRefactor(refactorName13, {
	        kinds: [inferReturnTypeAction.kind],
	        getEditsForAction: getRefactorEditsToInferReturnType,
	        getAvailableActions: getRefactorActionsToInferReturnType
	      });
	    }
	  });

	  // src/services/_namespaces/ts.refactor.inferFunctionReturnType.ts
	  var ts_refactor_inferFunctionReturnType_exports = {};
	  var init_ts_refactor_inferFunctionReturnType = __esm({
	    "src/services/_namespaces/ts.refactor.inferFunctionReturnType.ts"() {
	      init_inferFunctionReturnType();
	    }
	  });

	  // src/services/_namespaces/ts.refactor.ts
	  var ts_refactor_exports = {};
	  __export(ts_refactor_exports, {
	    addExportToChanges: () => addExportToChanges,
	    addExports: () => addExports,
	    addNewFileToTsconfig: () => addNewFileToTsconfig,
	    addOrRemoveBracesToArrowFunction: () => ts_refactor_addOrRemoveBracesToArrowFunction_exports,
	    containsJsx: () => containsJsx,
	    convertArrowFunctionOrFunctionExpression: () => ts_refactor_convertArrowFunctionOrFunctionExpression_exports,
	    convertParamsToDestructuredObject: () => ts_refactor_convertParamsToDestructuredObject_exports,
	    convertStringOrTemplateLiteral: () => ts_refactor_convertStringOrTemplateLiteral_exports,
	    convertToOptionalChainExpression: () => ts_refactor_convertToOptionalChainExpression_exports,
	    createNewFileName: () => createNewFileName,
	    createOldFileImportsFromTargetFile: () => createOldFileImportsFromTargetFile,
	    deleteMovedStatements: () => deleteMovedStatements,
	    deleteUnusedImports: () => deleteUnusedImports,
	    deleteUnusedOldImports: () => deleteUnusedOldImports,
	    doChangeNamedToNamespaceOrDefault: () => doChangeNamedToNamespaceOrDefault,
	    extractSymbol: () => ts_refactor_extractSymbol_exports,
	    filterImport: () => filterImport,
	    forEachImportInStatement: () => forEachImportInStatement,
	    generateGetAccessorAndSetAccessor: () => ts_refactor_generateGetAccessorAndSetAccessor_exports,
	    getApplicableRefactors: () => getApplicableRefactors,
	    getEditsForRefactor: () => getEditsForRefactor,
	    getStatementsToMove: () => getStatementsToMove,
	    getTopLevelDeclarationStatement: () => getTopLevelDeclarationStatement,
	    getUsageInfo: () => getUsageInfo,
	    inferFunctionReturnType: () => ts_refactor_inferFunctionReturnType_exports,
	    isRefactorErrorInfo: () => isRefactorErrorInfo,
	    isTopLevelDeclaration: () => isTopLevelDeclaration,
	    makeImportOrRequire: () => makeImportOrRequire,
	    moduleSpecifierFromImport: () => moduleSpecifierFromImport,
	    nameOfTopLevelDeclaration: () => nameOfTopLevelDeclaration,
	    refactorKindBeginsWith: () => refactorKindBeginsWith,
	    registerRefactor: () => registerRefactor,
	    updateImportsInOtherFiles: () => updateImportsInOtherFiles
	  });
	  var init_ts_refactor = __esm({
	    "src/services/_namespaces/ts.refactor.ts"() {
	      init_refactorProvider();
	      init_convertExport();
	      init_convertImport();
	      init_extractType();
	      init_helpers();
	      init_inlineVariable();
	      init_moveToNewFile();
	      init_moveToFile();
	      init_ts_refactor_addOrRemoveBracesToArrowFunction();
	      init_ts_refactor_convertArrowFunctionOrFunctionExpression();
	      init_ts_refactor_convertParamsToDestructuredObject();
	      init_ts_refactor_convertStringOrTemplateLiteral();
	      init_ts_refactor_convertToOptionalChainExpression();
	      init_ts_refactor_extractSymbol();
	      init_ts_refactor_generateGetAccessorAndSetAccessor();
	      init_ts_refactor_inferFunctionReturnType();
	    }
	  });

	  // src/services/classifier2020.ts
	  function getSemanticClassifications2(program, cancellationToken, sourceFile, span) {
	    const classifications = getEncodedSemanticClassifications2(program, cancellationToken, sourceFile, span);
	    Debug.assert(classifications.spans.length % 3 === 0);
	    const dense = classifications.spans;
	    const result = [];
	    for (let i = 0; i < dense.length; i += 3) {
	      result.push({
	        textSpan: createTextSpan(dense[i], dense[i + 1]),
	        classificationType: dense[i + 2]
	      });
	    }
	    return result;
	  }
	  function getEncodedSemanticClassifications2(program, cancellationToken, sourceFile, span) {
	    return {
	      spans: getSemanticTokens(program, sourceFile, span, cancellationToken),
	      endOfLineState: 0 /* None */
	    };
	  }
	  function getSemanticTokens(program, sourceFile, span, cancellationToken) {
	    const resultTokens = [];
	    const collector = (node, typeIdx, modifierSet) => {
	      resultTokens.push(node.getStart(sourceFile), node.getWidth(sourceFile), (typeIdx + 1 << 8 /* typeOffset */) + modifierSet);
	    };
	    if (program && sourceFile) {
	      collectTokens(program, sourceFile, span, collector, cancellationToken);
	    }
	    return resultTokens;
	  }
	  function collectTokens(program, sourceFile, span, collector, cancellationToken) {
	    const typeChecker = program.getTypeChecker();
	    let inJSXElement = false;
	    function visit(node) {
	      switch (node.kind) {
	        case 267 /* ModuleDeclaration */:
	        case 263 /* ClassDeclaration */:
	        case 264 /* InterfaceDeclaration */:
	        case 262 /* FunctionDeclaration */:
	        case 231 /* ClassExpression */:
	        case 218 /* FunctionExpression */:
	        case 219 /* ArrowFunction */:
	          cancellationToken.throwIfCancellationRequested();
	      }
	      if (!node || !textSpanIntersectsWith(span, node.pos, node.getFullWidth()) || node.getFullWidth() === 0) {
	        return;
	      }
	      const prevInJSXElement = inJSXElement;
	      if (isJsxElement(node) || isJsxSelfClosingElement(node)) {
	        inJSXElement = true;
	      }
	      if (isJsxExpression(node)) {
	        inJSXElement = false;
	      }
	      if (isIdentifier(node) && !inJSXElement && !inImportClause(node) && !isInfinityOrNaNString(node.escapedText)) {
	        let symbol = typeChecker.getSymbolAtLocation(node);
	        if (symbol) {
	          if (symbol.flags & 2097152 /* Alias */) {
	            symbol = typeChecker.getAliasedSymbol(symbol);
	          }
	          let typeIdx = classifySymbol2(symbol, getMeaningFromLocation(node));
	          if (typeIdx !== void 0) {
	            let modifierSet = 0;
	            if (node.parent) {
	              const parentIsDeclaration = isBindingElement(node.parent) || tokenFromDeclarationMapping.get(node.parent.kind) === typeIdx;
	              if (parentIsDeclaration && node.parent.name === node) {
	                modifierSet = 1 << 0 /* declaration */;
	              }
	            }
	            if (typeIdx === 6 /* parameter */ && isRightSideOfQualifiedNameOrPropertyAccess2(node)) {
	              typeIdx = 9 /* property */;
	            }
	            typeIdx = reclassifyByType(typeChecker, node, typeIdx);
	            const decl = symbol.valueDeclaration;
	            if (decl) {
	              const modifiers = getCombinedModifierFlags(decl);
	              const nodeFlags = getCombinedNodeFlags(decl);
	              if (modifiers & 256 /* Static */) {
	                modifierSet |= 1 << 1 /* static */;
	              }
	              if (modifiers & 1024 /* Async */) {
	                modifierSet |= 1 << 2 /* async */;
	              }
	              if (typeIdx !== 0 /* class */ && typeIdx !== 2 /* interface */) {
	                if (modifiers & 8 /* Readonly */ || nodeFlags & 2 /* Const */ || symbol.getFlags() & 8 /* EnumMember */) {
	                  modifierSet |= 1 << 3 /* readonly */;
	                }
	              }
	              if ((typeIdx === 7 /* variable */ || typeIdx === 10 /* function */) && isLocalDeclaration(decl, sourceFile)) {
	                modifierSet |= 1 << 5 /* local */;
	              }
	              if (program.isSourceFileDefaultLibrary(decl.getSourceFile())) {
	                modifierSet |= 1 << 4 /* defaultLibrary */;
	              }
	            } else if (symbol.declarations && symbol.declarations.some((d) => program.isSourceFileDefaultLibrary(d.getSourceFile()))) {
	              modifierSet |= 1 << 4 /* defaultLibrary */;
	            }
	            collector(node, typeIdx, modifierSet);
	          }
	        }
	      }
	      forEachChild(node, visit);
	      inJSXElement = prevInJSXElement;
	    }
	    visit(sourceFile);
	  }
	  function classifySymbol2(symbol, meaning) {
	    const flags = symbol.getFlags();
	    if (flags & 32 /* Class */) {
	      return 0 /* class */;
	    } else if (flags & 384 /* Enum */) {
	      return 1 /* enum */;
	    } else if (flags & 524288 /* TypeAlias */) {
	      return 5 /* type */;
	    } else if (flags & 64 /* Interface */) {
	      if (meaning & 2 /* Type */) {
	        return 2 /* interface */;
	      }
	    } else if (flags & 262144 /* TypeParameter */) {
	      return 4 /* typeParameter */;
	    }
	    let decl = symbol.valueDeclaration || symbol.declarations && symbol.declarations[0];
	    if (decl && isBindingElement(decl)) {
	      decl = getDeclarationForBindingElement(decl);
	    }
	    return decl && tokenFromDeclarationMapping.get(decl.kind);
	  }
	  function reclassifyByType(typeChecker, node, typeIdx) {
	    if (typeIdx === 7 /* variable */ || typeIdx === 9 /* property */ || typeIdx === 6 /* parameter */) {
	      const type = typeChecker.getTypeAtLocation(node);
	      if (type) {
	        const test = (condition) => {
	          return condition(type) || type.isUnion() && type.types.some(condition);
	        };
	        if (typeIdx !== 6 /* parameter */ && test((t) => t.getConstructSignatures().length > 0)) {
	          return 0 /* class */;
	        }
	        if (test((t) => t.getCallSignatures().length > 0) && !test((t) => t.getProperties().length > 0) || isExpressionInCallExpression(node)) {
	          return typeIdx === 9 /* property */ ? 11 /* member */ : 10 /* function */;
	        }
	      }
	    }
	    return typeIdx;
	  }
	  function isLocalDeclaration(decl, sourceFile) {
	    if (isBindingElement(decl)) {
	      decl = getDeclarationForBindingElement(decl);
	    }
	    if (isVariableDeclaration(decl)) {
	      return (!isSourceFile(decl.parent.parent.parent) || isCatchClause(decl.parent)) && decl.getSourceFile() === sourceFile;
	    } else if (isFunctionDeclaration(decl)) {
	      return !isSourceFile(decl.parent) && decl.getSourceFile() === sourceFile;
	    }
	    return false;
	  }
	  function getDeclarationForBindingElement(element) {
	    while (true) {
	      if (isBindingElement(element.parent.parent)) {
	        element = element.parent.parent;
	      } else {
	        return element.parent.parent;
	      }
	    }
	  }
	  function inImportClause(node) {
	    const parent2 = node.parent;
	    return parent2 && (isImportClause(parent2) || isImportSpecifier(parent2) || isNamespaceImport(parent2));
	  }
	  function isExpressionInCallExpression(node) {
	    while (isRightSideOfQualifiedNameOrPropertyAccess2(node)) {
	      node = node.parent;
	    }
	    return isCallExpression(node.parent) && node.parent.expression === node;
	  }
	  function isRightSideOfQualifiedNameOrPropertyAccess2(node) {
	    return isQualifiedName(node.parent) && node.parent.right === node || isPropertyAccessExpression(node.parent) && node.parent.name === node;
	  }
	  var TokenEncodingConsts, TokenType, TokenModifier, tokenFromDeclarationMapping;
	  var init_classifier2020 = __esm({
	    "src/services/classifier2020.ts"() {
	      init_ts4();
	      TokenEncodingConsts = /* @__PURE__ */ ((TokenEncodingConsts2) => {
	        TokenEncodingConsts2[TokenEncodingConsts2["typeOffset"] = 8] = "typeOffset";
	        TokenEncodingConsts2[TokenEncodingConsts2["modifierMask"] = 255] = "modifierMask";
	        return TokenEncodingConsts2;
	      })(TokenEncodingConsts || {});
	      TokenType = /* @__PURE__ */ ((TokenType2) => {
	        TokenType2[TokenType2["class"] = 0] = "class";
	        TokenType2[TokenType2["enum"] = 1] = "enum";
	        TokenType2[TokenType2["interface"] = 2] = "interface";
	        TokenType2[TokenType2["namespace"] = 3] = "namespace";
	        TokenType2[TokenType2["typeParameter"] = 4] = "typeParameter";
	        TokenType2[TokenType2["type"] = 5] = "type";
	        TokenType2[TokenType2["parameter"] = 6] = "parameter";
	        TokenType2[TokenType2["variable"] = 7] = "variable";
	        TokenType2[TokenType2["enumMember"] = 8] = "enumMember";
	        TokenType2[TokenType2["property"] = 9] = "property";
	        TokenType2[TokenType2["function"] = 10] = "function";
	        TokenType2[TokenType2["member"] = 11] = "member";
	        return TokenType2;
	      })(TokenType || {});
	      TokenModifier = /* @__PURE__ */ ((TokenModifier2) => {
	        TokenModifier2[TokenModifier2["declaration"] = 0] = "declaration";
	        TokenModifier2[TokenModifier2["static"] = 1] = "static";
	        TokenModifier2[TokenModifier2["async"] = 2] = "async";
	        TokenModifier2[TokenModifier2["readonly"] = 3] = "readonly";
	        TokenModifier2[TokenModifier2["defaultLibrary"] = 4] = "defaultLibrary";
	        TokenModifier2[TokenModifier2["local"] = 5] = "local";
	        return TokenModifier2;
	      })(TokenModifier || {});
	      tokenFromDeclarationMapping = /* @__PURE__ */ new Map([
	        [260 /* VariableDeclaration */, 7 /* variable */],
	        [169 /* Parameter */, 6 /* parameter */],
	        [172 /* PropertyDeclaration */, 9 /* property */],
	        [267 /* ModuleDeclaration */, 3 /* namespace */],
	        [266 /* EnumDeclaration */, 1 /* enum */],
	        [306 /* EnumMember */, 8 /* enumMember */],
	        [263 /* ClassDeclaration */, 0 /* class */],
	        [174 /* MethodDeclaration */, 11 /* member */],
	        [262 /* FunctionDeclaration */, 10 /* function */],
	        [218 /* FunctionExpression */, 10 /* function */],
	        [173 /* MethodSignature */, 11 /* member */],
	        [177 /* GetAccessor */, 9 /* property */],
	        [178 /* SetAccessor */, 9 /* property */],
	        [171 /* PropertySignature */, 9 /* property */],
	        [264 /* InterfaceDeclaration */, 2 /* interface */],
	        [265 /* TypeAliasDeclaration */, 5 /* type */],
	        [168 /* TypeParameter */, 4 /* typeParameter */],
	        [303 /* PropertyAssignment */, 9 /* property */],
	        [304 /* ShorthandPropertyAssignment */, 9 /* property */]
	      ]);
	    }
	  });

	  // src/services/services.ts
	  function createNode(kind, pos, end, parent2) {
	    const node = isNodeKind(kind) ? new NodeObject(kind, pos, end) : kind === 80 /* Identifier */ ? new IdentifierObject(80 /* Identifier */, pos, end) : kind === 81 /* PrivateIdentifier */ ? new PrivateIdentifierObject(81 /* PrivateIdentifier */, pos, end) : new TokenObject(kind, pos, end);
	    node.parent = parent2;
	    node.flags = parent2.flags & 101441536 /* ContextFlags */;
	    return node;
	  }
	  function createChildren(node, sourceFile) {
	    if (!isNodeKind(node.kind)) {
	      return emptyArray;
	    }
	    const children = [];
	    if (isJSDocCommentContainingNode(node)) {
	      node.forEachChild((child) => {
	        children.push(child);
	      });
	      return children;
	    }
	    scanner.setText((sourceFile || node.getSourceFile()).text);
	    let pos = node.pos;
	    const processNode = (child) => {
	      addSyntheticNodes(children, pos, child.pos, node);
	      children.push(child);
	      pos = child.end;
	    };
	    const processNodes = (nodes) => {
	      addSyntheticNodes(children, pos, nodes.pos, node);
	      children.push(createSyntaxList(nodes, node));
	      pos = nodes.end;
	    };
	    forEach(node.jsDoc, processNode);
	    pos = node.pos;
	    node.forEachChild(processNode, processNodes);
	    addSyntheticNodes(children, pos, node.end, node);
	    scanner.setText(void 0);
	    return children;
	  }
	  function addSyntheticNodes(nodes, pos, end, parent2) {
	    scanner.resetTokenState(pos);
	    while (pos < end) {
	      const token = scanner.scan();
	      const textPos = scanner.getTokenEnd();
	      if (textPos <= end) {
	        if (token === 80 /* Identifier */) {
	          if (hasTabstop(parent2)) {
	            continue;
	          }
	          Debug.fail(`Did not expect ${Debug.formatSyntaxKind(parent2.kind)} to have an Identifier in its trivia`);
	        }
	        nodes.push(createNode(token, pos, textPos, parent2));
	      }
	      pos = textPos;
	      if (token === 1 /* EndOfFileToken */) {
	        break;
	      }
	    }
	  }
	  function createSyntaxList(nodes, parent2) {
	    const list = createNode(358 /* SyntaxList */, nodes.pos, nodes.end, parent2);
	    list._children = [];
	    let pos = nodes.pos;
	    for (const node of nodes) {
	      addSyntheticNodes(list._children, pos, node.pos, parent2);
	      list._children.push(node);
	      pos = node.end;
	    }
	    addSyntheticNodes(list._children, pos, nodes.end, parent2);
	    return list;
	  }
	  function hasJSDocInheritDocTag(node) {
	    return getJSDocTags(node).some((tag) => tag.tagName.text === "inheritDoc" || tag.tagName.text === "inheritdoc");
	  }
	  function getJsDocTagsOfDeclarations(declarations, checker) {
	    if (!declarations)
	      return emptyArray;
	    let tags = ts_JsDoc_exports.getJsDocTagsFromDeclarations(declarations, checker);
	    if (checker && (tags.length === 0 || declarations.some(hasJSDocInheritDocTag))) {
	      const seenSymbols = /* @__PURE__ */ new Set();
	      for (const declaration of declarations) {
	        const inheritedTags = findBaseOfDeclaration(checker, declaration, (symbol) => {
	          var _a;
	          if (!seenSymbols.has(symbol)) {
	            seenSymbols.add(symbol);
	            if (declaration.kind === 177 /* GetAccessor */ || declaration.kind === 178 /* SetAccessor */) {
	              return symbol.getContextualJsDocTags(declaration, checker);
	            }
	            return ((_a = symbol.declarations) == null ? void 0 : _a.length) === 1 ? symbol.getJsDocTags() : void 0;
	          }
	        });
	        if (inheritedTags) {
	          tags = [...inheritedTags, ...tags];
	        }
	      }
	    }
	    return tags;
	  }
	  function getDocumentationComment(declarations, checker) {
	    if (!declarations)
	      return emptyArray;
	    let doc = ts_JsDoc_exports.getJsDocCommentsFromDeclarations(declarations, checker);
	    if (checker && (doc.length === 0 || declarations.some(hasJSDocInheritDocTag))) {
	      const seenSymbols = /* @__PURE__ */ new Set();
	      for (const declaration of declarations) {
	        const inheritedDocs = findBaseOfDeclaration(checker, declaration, (symbol) => {
	          if (!seenSymbols.has(symbol)) {
	            seenSymbols.add(symbol);
	            if (declaration.kind === 177 /* GetAccessor */ || declaration.kind === 178 /* SetAccessor */) {
	              return symbol.getContextualDocumentationComment(declaration, checker);
	            }
	            return symbol.getDocumentationComment(checker);
	          }
	        });
	        if (inheritedDocs)
	          doc = doc.length === 0 ? inheritedDocs.slice() : inheritedDocs.concat(lineBreakPart(), doc);
	      }
	    }
	    return doc;
	  }
	  function findBaseOfDeclaration(checker, declaration, cb) {
	    var _a;
	    const classOrInterfaceDeclaration = ((_a = declaration.parent) == null ? void 0 : _a.kind) === 176 /* Constructor */ ? declaration.parent.parent : declaration.parent;
	    if (!classOrInterfaceDeclaration)
	      return;
	    const isStaticMember = hasStaticModifier(declaration);
	    return firstDefined(getAllSuperTypeNodes(classOrInterfaceDeclaration), (superTypeNode) => {
	      const baseType = checker.getTypeAtLocation(superTypeNode);
	      const type = isStaticMember && baseType.symbol ? checker.getTypeOfSymbol(baseType.symbol) : baseType;
	      const symbol = checker.getPropertyOfType(type, declaration.symbol.name);
	      return symbol ? cb(symbol) : void 0;
	    });
	  }
	  function getServicesObjectAllocator() {
	    return {
	      getNodeConstructor: () => NodeObject,
	      getTokenConstructor: () => TokenObject,
	      getIdentifierConstructor: () => IdentifierObject,
	      getPrivateIdentifierConstructor: () => PrivateIdentifierObject,
	      getSourceFileConstructor: () => SourceFileObject,
	      getSymbolConstructor: () => SymbolObject,
	      getTypeConstructor: () => TypeObject,
	      getSignatureConstructor: () => SignatureObject,
	      getSourceMapSourceConstructor: () => SourceMapSourceObject
	    };
	  }
	  function toEditorSettings(optionsAsMap) {
	    let allPropertiesAreCamelCased = true;
	    for (const key in optionsAsMap) {
	      if (hasProperty(optionsAsMap, key) && !isCamelCase(key)) {
	        allPropertiesAreCamelCased = false;
	        break;
	      }
	    }
	    if (allPropertiesAreCamelCased) {
	      return optionsAsMap;
	    }
	    const settings = {};
	    for (const key in optionsAsMap) {
	      if (hasProperty(optionsAsMap, key)) {
	        const newKey = isCamelCase(key) ? key : key.charAt(0).toLowerCase() + key.substr(1);
	        settings[newKey] = optionsAsMap[key];
	      }
	    }
	    return settings;
	  }
	  function isCamelCase(s) {
	    return !s.length || s.charAt(0) === s.charAt(0).toLowerCase();
	  }
	  function displayPartsToString(displayParts) {
	    if (displayParts) {
	      return map(displayParts, (displayPart2) => displayPart2.text).join("");
	    }
	    return "";
	  }
	  function getDefaultCompilerOptions2() {
	    return {
	      target: 1 /* ES5 */,
	      jsx: 1 /* Preserve */
	    };
	  }
	  function getSupportedCodeFixes() {
	    return ts_codefix_exports.getSupportedErrorCodes();
	  }
	  function setSourceFileFields(sourceFile, scriptSnapshot, version2) {
	    sourceFile.version = version2;
	    sourceFile.scriptSnapshot = scriptSnapshot;
	  }
	  function createLanguageServiceSourceFile(fileName, scriptSnapshot, scriptTargetOrOptions, version2, setNodeParents, scriptKind) {
	    const sourceFile = createSourceFile(fileName, getSnapshotText(scriptSnapshot), scriptTargetOrOptions, setNodeParents, scriptKind);
	    setSourceFileFields(sourceFile, scriptSnapshot, version2);
	    return sourceFile;
	  }
	  function updateLanguageServiceSourceFile(sourceFile, scriptSnapshot, version2, textChangeRange, aggressiveChecks) {
	    if (textChangeRange) {
	      if (version2 !== sourceFile.version) {
	        let newText;
	        const prefix = textChangeRange.span.start !== 0 ? sourceFile.text.substr(0, textChangeRange.span.start) : "";
	        const suffix = textSpanEnd(textChangeRange.span) !== sourceFile.text.length ? sourceFile.text.substr(textSpanEnd(textChangeRange.span)) : "";
	        if (textChangeRange.newLength === 0) {
	          newText = prefix && suffix ? prefix + suffix : prefix || suffix;
	        } else {
	          const changedText = scriptSnapshot.getText(textChangeRange.span.start, textChangeRange.span.start + textChangeRange.newLength);
	          newText = prefix && suffix ? prefix + changedText + suffix : prefix ? prefix + changedText : changedText + suffix;
	        }
	        const newSourceFile = updateSourceFile(sourceFile, newText, textChangeRange, aggressiveChecks);
	        setSourceFileFields(newSourceFile, scriptSnapshot, version2);
	        newSourceFile.nameTable = void 0;
	        if (sourceFile !== newSourceFile && sourceFile.scriptSnapshot) {
	          if (sourceFile.scriptSnapshot.dispose) {
	            sourceFile.scriptSnapshot.dispose();
	          }
	          sourceFile.scriptSnapshot = void 0;
	        }
	        return newSourceFile;
	      }
	    }
	    const options = {
	      languageVersion: sourceFile.languageVersion,
	      impliedNodeFormat: sourceFile.impliedNodeFormat,
	      setExternalModuleIndicator: sourceFile.setExternalModuleIndicator,
	      jsDocParsingMode: sourceFile.jsDocParsingMode
	    };
	    return createLanguageServiceSourceFile(
	      sourceFile.fileName,
	      scriptSnapshot,
	      options,
	      version2,
	      /*setNodeParents*/
	      true,
	      sourceFile.scriptKind
	    );
	  }
	  function createLanguageService(host, documentRegistry = createDocumentRegistry(host.useCaseSensitiveFileNames && host.useCaseSensitiveFileNames(), host.getCurrentDirectory()), syntaxOnlyOrLanguageServiceMode) {
	    var _a;
	    let languageServiceMode;
	    if (syntaxOnlyOrLanguageServiceMode === void 0) {
	      languageServiceMode = 0 /* Semantic */;
	    } else if (typeof syntaxOnlyOrLanguageServiceMode === "boolean") {
	      languageServiceMode = syntaxOnlyOrLanguageServiceMode ? 2 /* Syntactic */ : 0 /* Semantic */;
	    } else {
	      languageServiceMode = syntaxOnlyOrLanguageServiceMode;
	    }
	    const syntaxTreeCache = new SyntaxTreeCache(host);
	    let program;
	    let lastProjectVersion;
	    let lastTypesRootVersion = 0;
	    const cancellationToken = host.getCancellationToken ? new CancellationTokenObject(host.getCancellationToken()) : NoopCancellationToken;
	    const currentDirectory = host.getCurrentDirectory();
	    maybeSetLocalizedDiagnosticMessages((_a = host.getLocalizedDiagnosticMessages) == null ? void 0 : _a.bind(host));
	    function log(message) {
	      if (host.log) {
	        host.log(message);
	      }
	    }
	    const useCaseSensitiveFileNames2 = hostUsesCaseSensitiveFileNames(host);
	    const getCanonicalFileName = createGetCanonicalFileName(useCaseSensitiveFileNames2);
	    const sourceMapper = getSourceMapper({
	      useCaseSensitiveFileNames: () => useCaseSensitiveFileNames2,
	      getCurrentDirectory: () => currentDirectory,
	      getProgram,
	      fileExists: maybeBind(host, host.fileExists),
	      readFile: maybeBind(host, host.readFile),
	      getDocumentPositionMapper: maybeBind(host, host.getDocumentPositionMapper),
	      getSourceFileLike: maybeBind(host, host.getSourceFileLike),
	      log
	    });
	    function getValidSourceFile(fileName) {
	      const sourceFile = program.getSourceFile(fileName);
	      if (!sourceFile) {
	        const error2 = new Error(`Could not find source file: '${fileName}'.`);
	        error2.ProgramFiles = program.getSourceFiles().map((f) => f.fileName);
	        throw error2;
	      }
	      return sourceFile;
	    }
	    function synchronizeHostData() {
	      if (host.updateFromProject && !host.updateFromProjectInProgress) {
	        host.updateFromProject();
	      } else {
	        synchronizeHostDataWorker();
	      }
	    }
	    function synchronizeHostDataWorker() {
	      var _a2, _b, _c;
	      Debug.assert(languageServiceMode !== 2 /* Syntactic */);
	      if (host.getProjectVersion) {
	        const hostProjectVersion = host.getProjectVersion();
	        if (hostProjectVersion) {
	          if (lastProjectVersion === hostProjectVersion && !((_a2 = host.hasChangedAutomaticTypeDirectiveNames) == null ? void 0 : _a2.call(host))) {
	            return;
	          }
	          lastProjectVersion = hostProjectVersion;
	        }
	      }
	      const typeRootsVersion = host.getTypeRootsVersion ? host.getTypeRootsVersion() : 0;
	      if (lastTypesRootVersion !== typeRootsVersion) {
	        log("TypeRoots version has changed; provide new program");
	        program = void 0;
	        lastTypesRootVersion = typeRootsVersion;
	      }
	      const rootFileNames = host.getScriptFileNames().slice();
	      const newSettings = host.getCompilationSettings() || getDefaultCompilerOptions2();
	      const hasInvalidatedResolutions = host.hasInvalidatedResolutions || returnFalse;
	      const hasInvalidatedLibResolutions = maybeBind(host, host.hasInvalidatedLibResolutions) || returnFalse;
	      const hasChangedAutomaticTypeDirectiveNames = maybeBind(host, host.hasChangedAutomaticTypeDirectiveNames);
	      const projectReferences = (_b = host.getProjectReferences) == null ? void 0 : _b.call(host);
	      let parsedCommandLines;
	      let compilerHost = {
	        getSourceFile: getOrCreateSourceFile,
	        getSourceFileByPath: getOrCreateSourceFileByPath,
	        getCancellationToken: () => cancellationToken,
	        getCanonicalFileName,
	        useCaseSensitiveFileNames: () => useCaseSensitiveFileNames2,
	        getNewLine: () => getNewLineCharacter(newSettings),
	        getDefaultLibFileName: (options2) => host.getDefaultLibFileName(options2),
	        writeFile: noop,
	        getCurrentDirectory: () => currentDirectory,
	        fileExists: (fileName) => host.fileExists(fileName),
	        readFile: (fileName) => host.readFile && host.readFile(fileName),
	        getSymlinkCache: maybeBind(host, host.getSymlinkCache),
	        realpath: maybeBind(host, host.realpath),
	        directoryExists: (directoryName) => {
	          return directoryProbablyExists(directoryName, host);
	        },
	        getDirectories: (path) => {
	          return host.getDirectories ? host.getDirectories(path) : [];
	        },
	        readDirectory: (path, extensions, exclude, include, depth) => {
	          Debug.checkDefined(host.readDirectory, "'LanguageServiceHost.readDirectory' must be implemented to correctly process 'projectReferences'");
	          return host.readDirectory(path, extensions, exclude, include, depth);
	        },
	        onReleaseOldSourceFile,
	        onReleaseParsedCommandLine,
	        hasInvalidatedResolutions,
	        hasInvalidatedLibResolutions,
	        hasChangedAutomaticTypeDirectiveNames,
	        trace: maybeBind(host, host.trace),
	        resolveModuleNames: maybeBind(host, host.resolveModuleNames),
	        getModuleResolutionCache: maybeBind(host, host.getModuleResolutionCache),
	        createHash: maybeBind(host, host.createHash),
	        resolveTypeReferenceDirectives: maybeBind(host, host.resolveTypeReferenceDirectives),
	        resolveModuleNameLiterals: maybeBind(host, host.resolveModuleNameLiterals),
	        resolveTypeReferenceDirectiveReferences: maybeBind(host, host.resolveTypeReferenceDirectiveReferences),
	        resolveLibrary: maybeBind(host, host.resolveLibrary),
	        useSourceOfProjectReferenceRedirect: maybeBind(host, host.useSourceOfProjectReferenceRedirect),
	        getParsedCommandLine,
	        jsDocParsingMode: host.jsDocParsingMode
	      };
	      const originalGetSourceFile = compilerHost.getSourceFile;
	      const { getSourceFileWithCache } = changeCompilerHostLikeToUseCache(
	        compilerHost,
	        (fileName) => toPath(fileName, currentDirectory, getCanonicalFileName),
	        (...args) => originalGetSourceFile.call(compilerHost, ...args)
	      );
	      compilerHost.getSourceFile = getSourceFileWithCache;
	      (_c = host.setCompilerHost) == null ? void 0 : _c.call(host, compilerHost);
	      const parseConfigHost = {
	        useCaseSensitiveFileNames: useCaseSensitiveFileNames2,
	        fileExists: (fileName) => compilerHost.fileExists(fileName),
	        readFile: (fileName) => compilerHost.readFile(fileName),
	        directoryExists: (f) => compilerHost.directoryExists(f),
	        getDirectories: (f) => compilerHost.getDirectories(f),
	        realpath: compilerHost.realpath,
	        readDirectory: (...args) => compilerHost.readDirectory(...args),
	        trace: compilerHost.trace,
	        getCurrentDirectory: compilerHost.getCurrentDirectory,
	        onUnRecoverableConfigFileDiagnostic: noop
	      };
	      const documentRegistryBucketKey = documentRegistry.getKeyForCompilationSettings(newSettings);
	      let releasedScriptKinds = /* @__PURE__ */ new Set();
	      if (isProgramUptoDate(program, rootFileNames, newSettings, (_path, fileName) => host.getScriptVersion(fileName), (fileName) => compilerHost.fileExists(fileName), hasInvalidatedResolutions, hasInvalidatedLibResolutions, hasChangedAutomaticTypeDirectiveNames, getParsedCommandLine, projectReferences)) {
	        compilerHost = void 0;
	        parsedCommandLines = void 0;
	        releasedScriptKinds = void 0;
	        return;
	      }
	      const options = {
	        rootNames: rootFileNames,
	        options: newSettings,
	        host: compilerHost,
	        oldProgram: program,
	        projectReferences
	      };
	      program = createProgram(options);
	      compilerHost = void 0;
	      parsedCommandLines = void 0;
	      releasedScriptKinds = void 0;
	      sourceMapper.clearCache();
	      program.getTypeChecker();
	      return;
	      function getParsedCommandLine(fileName) {
	        const path = toPath(fileName, currentDirectory, getCanonicalFileName);
	        const existing = parsedCommandLines == null ? void 0 : parsedCommandLines.get(path);
	        if (existing !== void 0)
	          return existing || void 0;
	        const result = host.getParsedCommandLine ? host.getParsedCommandLine(fileName) : getParsedCommandLineOfConfigFileUsingSourceFile(fileName);
	        (parsedCommandLines || (parsedCommandLines = /* @__PURE__ */ new Map())).set(path, result || false);
	        return result;
	      }
	      function getParsedCommandLineOfConfigFileUsingSourceFile(configFileName) {
	        const result = getOrCreateSourceFile(configFileName, 100 /* JSON */);
	        if (!result)
	          return void 0;
	        result.path = toPath(configFileName, currentDirectory, getCanonicalFileName);
	        result.resolvedPath = result.path;
	        result.originalFileName = result.fileName;
	        return parseJsonSourceFileConfigFileContent(
	          result,
	          parseConfigHost,
	          getNormalizedAbsolutePath(getDirectoryPath(configFileName), currentDirectory),
	          /*existingOptions*/
	          void 0,
	          getNormalizedAbsolutePath(configFileName, currentDirectory)
	        );
	      }
	      function onReleaseParsedCommandLine(configFileName, oldResolvedRef, oldOptions) {
	        var _a3;
	        if (host.getParsedCommandLine) {
	          (_a3 = host.onReleaseParsedCommandLine) == null ? void 0 : _a3.call(host, configFileName, oldResolvedRef, oldOptions);
	        } else if (oldResolvedRef) {
	          onReleaseOldSourceFile(oldResolvedRef.sourceFile, oldOptions);
	        }
	      }
	      function onReleaseOldSourceFile(oldSourceFile, oldOptions) {
	        const oldSettingsKey = documentRegistry.getKeyForCompilationSettings(oldOptions);
	        documentRegistry.releaseDocumentWithKey(oldSourceFile.resolvedPath, oldSettingsKey, oldSourceFile.scriptKind, oldSourceFile.impliedNodeFormat);
	      }
	      function getOrCreateSourceFile(fileName, languageVersionOrOptions, onError, shouldCreateNewSourceFile) {
	        return getOrCreateSourceFileByPath(fileName, toPath(fileName, currentDirectory, getCanonicalFileName), languageVersionOrOptions, onError, shouldCreateNewSourceFile);
	      }
	      function getOrCreateSourceFileByPath(fileName, path, languageVersionOrOptions, _onError, shouldCreateNewSourceFile) {
	        Debug.assert(compilerHost, "getOrCreateSourceFileByPath called after typical CompilerHost lifetime, check the callstack something with a reference to an old host.");
	        const scriptSnapshot = host.getScriptSnapshot(fileName);
	        if (!scriptSnapshot) {
	          return void 0;
	        }
	        const scriptKind = getScriptKind(fileName, host);
	        const scriptVersion = host.getScriptVersion(fileName);
	        if (!shouldCreateNewSourceFile) {
	          const oldSourceFile = program && program.getSourceFileByPath(path);
	          if (oldSourceFile) {
	            if (scriptKind === oldSourceFile.scriptKind || releasedScriptKinds.has(oldSourceFile.resolvedPath)) {
	              return documentRegistry.updateDocumentWithKey(fileName, path, host, documentRegistryBucketKey, scriptSnapshot, scriptVersion, scriptKind, languageVersionOrOptions);
	            } else {
	              documentRegistry.releaseDocumentWithKey(oldSourceFile.resolvedPath, documentRegistry.getKeyForCompilationSettings(program.getCompilerOptions()), oldSourceFile.scriptKind, oldSourceFile.impliedNodeFormat);
	              releasedScriptKinds.add(oldSourceFile.resolvedPath);
	            }
	          }
	        }
	        return documentRegistry.acquireDocumentWithKey(fileName, path, host, documentRegistryBucketKey, scriptSnapshot, scriptVersion, scriptKind, languageVersionOrOptions);
	      }
	    }
	    function getProgram() {
	      if (languageServiceMode === 2 /* Syntactic */) {
	        Debug.assert(program === void 0);
	        return void 0;
	      }
	      synchronizeHostData();
	      return program;
	    }
	    function getAutoImportProvider() {
	      var _a2;
	      return (_a2 = host.getPackageJsonAutoImportProvider) == null ? void 0 : _a2.call(host);
	    }
	    function updateIsDefinitionOfReferencedSymbols(referencedSymbols, knownSymbolSpans) {
	      const checker = program.getTypeChecker();
	      const symbol = getSymbolForProgram();
	      if (!symbol)
	        return false;
	      for (const referencedSymbol of referencedSymbols) {
	        for (const ref of referencedSymbol.references) {
	          const refNode = getNodeForSpan(ref);
	          Debug.assertIsDefined(refNode);
	          if (knownSymbolSpans.has(ref) || ts_FindAllReferences_exports.isDeclarationOfSymbol(refNode, symbol)) {
	            knownSymbolSpans.add(ref);
	            ref.isDefinition = true;
	            const mappedSpan = getMappedDocumentSpan(ref, sourceMapper, maybeBind(host, host.fileExists));
	            if (mappedSpan) {
	              knownSymbolSpans.add(mappedSpan);
	            }
	          } else {
	            ref.isDefinition = false;
	          }
	        }
	      }
	      return true;
	      function getSymbolForProgram() {
	        for (const referencedSymbol of referencedSymbols) {
	          for (const ref of referencedSymbol.references) {
	            if (knownSymbolSpans.has(ref)) {
	              const refNode = getNodeForSpan(ref);
	              Debug.assertIsDefined(refNode);
	              return checker.getSymbolAtLocation(refNode);
	            }
	            const mappedSpan = getMappedDocumentSpan(ref, sourceMapper, maybeBind(host, host.fileExists));
	            if (mappedSpan && knownSymbolSpans.has(mappedSpan)) {
	              const refNode = getNodeForSpan(mappedSpan);
	              if (refNode) {
	                return checker.getSymbolAtLocation(refNode);
	              }
	            }
	          }
	        }
	        return void 0;
	      }
	      function getNodeForSpan(docSpan) {
	        const sourceFile = program.getSourceFile(docSpan.fileName);
	        if (!sourceFile)
	          return void 0;
	        const rawNode = getTouchingPropertyName(sourceFile, docSpan.textSpan.start);
	        const adjustedNode = ts_FindAllReferences_exports.Core.getAdjustedNode(rawNode, { use: ts_FindAllReferences_exports.FindReferencesUse.References });
	        return adjustedNode;
	      }
	    }
	    function cleanupSemanticCache() {
	      if (program) {
	        const key = documentRegistry.getKeyForCompilationSettings(program.getCompilerOptions());
	        forEach(program.getSourceFiles(), (f) => documentRegistry.releaseDocumentWithKey(f.resolvedPath, key, f.scriptKind, f.impliedNodeFormat));
	        program = void 0;
	      }
	    }
	    function dispose() {
	      cleanupSemanticCache();
	      host = void 0;
	    }
	    function getSyntacticDiagnostics(fileName) {
	      synchronizeHostData();
	      return program.getSyntacticDiagnostics(getValidSourceFile(fileName), cancellationToken).slice();
	    }
	    function getSemanticDiagnostics(fileName) {
	      synchronizeHostData();
	      const targetSourceFile = getValidSourceFile(fileName);
	      const semanticDiagnostics = program.getSemanticDiagnostics(targetSourceFile, cancellationToken);
	      if (!getEmitDeclarations(program.getCompilerOptions())) {
	        return semanticDiagnostics.slice();
	      }
	      const declarationDiagnostics = program.getDeclarationDiagnostics(targetSourceFile, cancellationToken);
	      return [...semanticDiagnostics, ...declarationDiagnostics];
	    }
	    function getSuggestionDiagnostics(fileName) {
	      synchronizeHostData();
	      return computeSuggestionDiagnostics(getValidSourceFile(fileName), program, cancellationToken);
	    }
	    function getCompilerOptionsDiagnostics() {
	      synchronizeHostData();
	      return [...program.getOptionsDiagnostics(cancellationToken), ...program.getGlobalDiagnostics(cancellationToken)];
	    }
	    function getCompletionsAtPosition2(fileName, position, options = emptyOptions, formattingSettings) {
	      const fullPreferences = {
	        ...identity(options),
	        // avoid excess property check
	        includeCompletionsForModuleExports: options.includeCompletionsForModuleExports || options.includeExternalModuleExports,
	        includeCompletionsWithInsertText: options.includeCompletionsWithInsertText || options.includeInsertTextCompletions
	      };
	      synchronizeHostData();
	      return ts_Completions_exports.getCompletionsAtPosition(
	        host,
	        program,
	        log,
	        getValidSourceFile(fileName),
	        position,
	        fullPreferences,
	        options.triggerCharacter,
	        options.triggerKind,
	        cancellationToken,
	        formattingSettings && ts_formatting_exports.getFormatContext(formattingSettings, host),
	        options.includeSymbol
	      );
	    }
	    function getCompletionEntryDetails2(fileName, position, name, formattingOptions, source, preferences = emptyOptions, data) {
	      synchronizeHostData();
	      return ts_Completions_exports.getCompletionEntryDetails(
	        program,
	        log,
	        getValidSourceFile(fileName),
	        position,
	        { name, source, data },
	        host,
	        formattingOptions && ts_formatting_exports.getFormatContext(formattingOptions, host),
	        // TODO: GH#18217
	        preferences,
	        cancellationToken
	      );
	    }
	    function getCompletionEntrySymbol2(fileName, position, name, source, preferences = emptyOptions) {
	      synchronizeHostData();
	      return ts_Completions_exports.getCompletionEntrySymbol(program, log, getValidSourceFile(fileName), position, { name, source }, host, preferences);
	    }
	    function getQuickInfoAtPosition(fileName, position) {
	      synchronizeHostData();
	      const sourceFile = getValidSourceFile(fileName);
	      const node = getTouchingPropertyName(sourceFile, position);
	      if (node === sourceFile) {
	        return void 0;
	      }
	      const typeChecker = program.getTypeChecker();
	      const nodeForQuickInfo = getNodeForQuickInfo(node);
	      const symbol = getSymbolAtLocationForQuickInfo(nodeForQuickInfo, typeChecker);
	      if (!symbol || typeChecker.isUnknownSymbol(symbol)) {
	        const type = shouldGetType(sourceFile, nodeForQuickInfo, position) ? typeChecker.getTypeAtLocation(nodeForQuickInfo) : void 0;
	        return type && {
	          kind: "" /* unknown */,
	          kindModifiers: "" /* none */,
	          textSpan: createTextSpanFromNode(nodeForQuickInfo, sourceFile),
	          displayParts: typeChecker.runWithCancellationToken(cancellationToken, (typeChecker2) => typeToDisplayParts(typeChecker2, type, getContainerNode(nodeForQuickInfo))),
	          documentation: type.symbol ? type.symbol.getDocumentationComment(typeChecker) : void 0,
	          tags: type.symbol ? type.symbol.getJsDocTags(typeChecker) : void 0
	        };
	      }
	      const { symbolKind, displayParts, documentation, tags } = typeChecker.runWithCancellationToken(cancellationToken, (typeChecker2) => ts_SymbolDisplay_exports.getSymbolDisplayPartsDocumentationAndSymbolKind(typeChecker2, symbol, sourceFile, getContainerNode(nodeForQuickInfo), nodeForQuickInfo));
	      return {
	        kind: symbolKind,
	        kindModifiers: ts_SymbolDisplay_exports.getSymbolModifiers(typeChecker, symbol),
	        textSpan: createTextSpanFromNode(nodeForQuickInfo, sourceFile),
	        displayParts,
	        documentation,
	        tags
	      };
	    }
	    function getNodeForQuickInfo(node) {
	      if (isNewExpression(node.parent) && node.pos === node.parent.pos) {
	        return node.parent.expression;
	      }
	      if (isNamedTupleMember(node.parent) && node.pos === node.parent.pos) {
	        return node.parent;
	      }
	      if (isImportMeta(node.parent) && node.parent.name === node) {
	        return node.parent;
	      }
	      if (isJsxNamespacedName(node.parent)) {
	        return node.parent;
	      }
	      return node;
	    }
	    function shouldGetType(sourceFile, node, position) {
	      switch (node.kind) {
	        case 80 /* Identifier */:
	          return !isLabelName(node) && !isTagName(node) && !isConstTypeReference(node.parent);
	        case 211 /* PropertyAccessExpression */:
	        case 166 /* QualifiedName */:
	          return !isInComment(sourceFile, position);
	        case 110 /* ThisKeyword */:
	        case 197 /* ThisType */:
	        case 108 /* SuperKeyword */:
	        case 202 /* NamedTupleMember */:
	          return true;
	        case 236 /* MetaProperty */:
	          return isImportMeta(node);
	        default:
	          return false;
	      }
	    }
	    function getDefinitionAtPosition2(fileName, position, searchOtherFilesOnly, stopAtAlias) {
	      synchronizeHostData();
	      return ts_GoToDefinition_exports.getDefinitionAtPosition(program, getValidSourceFile(fileName), position, searchOtherFilesOnly, stopAtAlias);
	    }
	    function getDefinitionAndBoundSpan2(fileName, position) {
	      synchronizeHostData();
	      return ts_GoToDefinition_exports.getDefinitionAndBoundSpan(program, getValidSourceFile(fileName), position);
	    }
	    function getTypeDefinitionAtPosition2(fileName, position) {
	      synchronizeHostData();
	      return ts_GoToDefinition_exports.getTypeDefinitionAtPosition(program.getTypeChecker(), getValidSourceFile(fileName), position);
	    }
	    function getImplementationAtPosition(fileName, position) {
	      synchronizeHostData();
	      return ts_FindAllReferences_exports.getImplementationsAtPosition(program, cancellationToken, program.getSourceFiles(), getValidSourceFile(fileName), position);
	    }
	    function getDocumentHighlights(fileName, position, filesToSearch) {
	      const normalizedFileName = normalizePath(fileName);
	      Debug.assert(filesToSearch.some((f) => normalizePath(f) === normalizedFileName));
	      synchronizeHostData();
	      const sourceFilesToSearch = mapDefined(filesToSearch, (fileName2) => program.getSourceFile(fileName2));
	      const sourceFile = getValidSourceFile(fileName);
	      return DocumentHighlights.getDocumentHighlights(program, cancellationToken, sourceFile, position, sourceFilesToSearch);
	    }
	    function findRenameLocations(fileName, position, findInStrings, findInComments, preferences) {
	      synchronizeHostData();
	      const sourceFile = getValidSourceFile(fileName);
	      const node = getAdjustedRenameLocation(getTouchingPropertyName(sourceFile, position));
	      if (!ts_Rename_exports.nodeIsEligibleForRename(node))
	        return void 0;
	      if (isIdentifier(node) && (isJsxOpeningElement(node.parent) || isJsxClosingElement(node.parent)) && isIntrinsicJsxName(node.escapedText)) {
	        const { openingElement, closingElement } = node.parent.parent;
	        return [openingElement, closingElement].map((node2) => {
	          const textSpan = createTextSpanFromNode(node2.tagName, sourceFile);
	          return {
	            fileName: sourceFile.fileName,
	            textSpan,
	            ...ts_FindAllReferences_exports.toContextSpan(textSpan, sourceFile, node2.parent)
	          };
	        });
	      } else {
	        const quotePreference = getQuotePreference(sourceFile, preferences ?? emptyOptions);
	        const providePrefixAndSuffixTextForRename = typeof preferences === "boolean" ? preferences : preferences == null ? void 0 : preferences.providePrefixAndSuffixTextForRename;
	        return getReferencesWorker2(node, position, { findInStrings, findInComments, providePrefixAndSuffixTextForRename, use: ts_FindAllReferences_exports.FindReferencesUse.Rename }, (entry, originalNode, checker) => ts_FindAllReferences_exports.toRenameLocation(entry, originalNode, checker, providePrefixAndSuffixTextForRename || false, quotePreference));
	      }
	    }
	    function getReferencesAtPosition(fileName, position) {
	      synchronizeHostData();
	      return getReferencesWorker2(getTouchingPropertyName(getValidSourceFile(fileName), position), position, { use: ts_FindAllReferences_exports.FindReferencesUse.References }, ts_FindAllReferences_exports.toReferenceEntry);
	    }
	    function getReferencesWorker2(node, position, options, cb) {
	      synchronizeHostData();
	      const sourceFiles = options && options.use === ts_FindAllReferences_exports.FindReferencesUse.Rename ? program.getSourceFiles().filter((sourceFile) => !program.isSourceFileDefaultLibrary(sourceFile)) : program.getSourceFiles();
	      return ts_FindAllReferences_exports.findReferenceOrRenameEntries(program, cancellationToken, sourceFiles, node, position, options, cb);
	    }
	    function findReferences(fileName, position) {
	      synchronizeHostData();
	      return ts_FindAllReferences_exports.findReferencedSymbols(program, cancellationToken, program.getSourceFiles(), getValidSourceFile(fileName), position);
	    }
	    function getFileReferences(fileName) {
	      synchronizeHostData();
	      return ts_FindAllReferences_exports.Core.getReferencesForFileName(fileName, program, program.getSourceFiles()).map(ts_FindAllReferences_exports.toReferenceEntry);
	    }
	    function getNavigateToItems2(searchValue, maxResultCount, fileName, excludeDtsFiles = false, excludeLibFiles = false) {
	      synchronizeHostData();
	      const sourceFiles = fileName ? [getValidSourceFile(fileName)] : program.getSourceFiles();
	      return getNavigateToItems(sourceFiles, program.getTypeChecker(), cancellationToken, searchValue, maxResultCount, excludeDtsFiles, excludeLibFiles);
	    }
	    function getEmitOutput(fileName, emitOnlyDtsFiles, forceDtsEmit) {
	      synchronizeHostData();
	      const sourceFile = getValidSourceFile(fileName);
	      const customTransformers = host.getCustomTransformers && host.getCustomTransformers();
	      return getFileEmitOutput(program, sourceFile, !!emitOnlyDtsFiles, cancellationToken, customTransformers, forceDtsEmit);
	    }
	    function getSignatureHelpItems2(fileName, position, { triggerReason } = emptyOptions) {
	      synchronizeHostData();
	      const sourceFile = getValidSourceFile(fileName);
	      return ts_SignatureHelp_exports.getSignatureHelpItems(program, sourceFile, position, triggerReason, cancellationToken);
	    }
	    function getNonBoundSourceFile(fileName) {
	      return syntaxTreeCache.getCurrentSourceFile(fileName);
	    }
	    function getNameOrDottedNameSpan(fileName, startPos, _endPos) {
	      const sourceFile = syntaxTreeCache.getCurrentSourceFile(fileName);
	      const node = getTouchingPropertyName(sourceFile, startPos);
	      if (node === sourceFile) {
	        return void 0;
	      }
	      switch (node.kind) {
	        case 211 /* PropertyAccessExpression */:
	        case 166 /* QualifiedName */:
	        case 11 /* StringLiteral */:
	        case 97 /* FalseKeyword */:
	        case 112 /* TrueKeyword */:
	        case 106 /* NullKeyword */:
	        case 108 /* SuperKeyword */:
	        case 110 /* ThisKeyword */:
	        case 197 /* ThisType */:
	        case 80 /* Identifier */:
	          break;
	        default:
	          return void 0;
	      }
	      let nodeForStartPos = node;
	      while (true) {
	        if (isRightSideOfPropertyAccess(nodeForStartPos) || isRightSideOfQualifiedName(nodeForStartPos)) {
	          nodeForStartPos = nodeForStartPos.parent;
	        } else if (isNameOfModuleDeclaration(nodeForStartPos)) {
	          if (nodeForStartPos.parent.parent.kind === 267 /* ModuleDeclaration */ && nodeForStartPos.parent.parent.body === nodeForStartPos.parent) {
	            nodeForStartPos = nodeForStartPos.parent.parent.name;
	          } else {
	            break;
	          }
	        } else {
	          break;
	        }
	      }
	      return createTextSpanFromBounds(nodeForStartPos.getStart(), node.getEnd());
	    }
	    function getBreakpointStatementAtPosition(fileName, position) {
	      const sourceFile = syntaxTreeCache.getCurrentSourceFile(fileName);
	      return ts_BreakpointResolver_exports.spanInSourceFileAtLocation(sourceFile, position);
	    }
	    function getNavigationBarItems2(fileName) {
	      return getNavigationBarItems(syntaxTreeCache.getCurrentSourceFile(fileName), cancellationToken);
	    }
	    function getNavigationTree2(fileName) {
	      return getNavigationTree(syntaxTreeCache.getCurrentSourceFile(fileName), cancellationToken);
	    }
	    function getSemanticClassifications3(fileName, span, format) {
	      synchronizeHostData();
	      const responseFormat = format || "original" /* Original */;
	      if (responseFormat === "2020" /* TwentyTwenty */) {
	        return getSemanticClassifications2(program, cancellationToken, getValidSourceFile(fileName), span);
	      } else {
	        return getSemanticClassifications(program.getTypeChecker(), cancellationToken, getValidSourceFile(fileName), program.getClassifiableNames(), span);
	      }
	    }
	    function getEncodedSemanticClassifications3(fileName, span, format) {
	      synchronizeHostData();
	      const responseFormat = format || "original" /* Original */;
	      if (responseFormat === "original" /* Original */) {
	        return getEncodedSemanticClassifications(program.getTypeChecker(), cancellationToken, getValidSourceFile(fileName), program.getClassifiableNames(), span);
	      } else {
	        return getEncodedSemanticClassifications2(program, cancellationToken, getValidSourceFile(fileName), span);
	      }
	    }
	    function getSyntacticClassifications2(fileName, span) {
	      return getSyntacticClassifications(cancellationToken, syntaxTreeCache.getCurrentSourceFile(fileName), span);
	    }
	    function getEncodedSyntacticClassifications2(fileName, span) {
	      return getEncodedSyntacticClassifications(cancellationToken, syntaxTreeCache.getCurrentSourceFile(fileName), span);
	    }
	    function getOutliningSpans(fileName) {
	      const sourceFile = syntaxTreeCache.getCurrentSourceFile(fileName);
	      return ts_OutliningElementsCollector_exports.collectElements(sourceFile, cancellationToken);
	    }
	    const braceMatching = new Map(Object.entries({
	      [19 /* OpenBraceToken */]: 20 /* CloseBraceToken */,
	      [21 /* OpenParenToken */]: 22 /* CloseParenToken */,
	      [23 /* OpenBracketToken */]: 24 /* CloseBracketToken */,
	      [32 /* GreaterThanToken */]: 30 /* LessThanToken */
	    }));
	    braceMatching.forEach((value, key) => braceMatching.set(value.toString(), Number(key)));
	    function getBraceMatchingAtPosition(fileName, position) {
	      const sourceFile = syntaxTreeCache.getCurrentSourceFile(fileName);
	      const token = getTouchingToken(sourceFile, position);
	      const matchKind = token.getStart(sourceFile) === position ? braceMatching.get(token.kind.toString()) : void 0;
	      const match = matchKind && findChildOfKind(token.parent, matchKind, sourceFile);
	      return match ? [createTextSpanFromNode(token, sourceFile), createTextSpanFromNode(match, sourceFile)].sort((a, b) => a.start - b.start) : emptyArray;
	    }
	    function getIndentationAtPosition(fileName, position, editorOptions) {
	      let start = timestamp();
	      const settings = toEditorSettings(editorOptions);
	      const sourceFile = syntaxTreeCache.getCurrentSourceFile(fileName);
	      log("getIndentationAtPosition: getCurrentSourceFile: " + (timestamp() - start));
	      start = timestamp();
	      const result = ts_formatting_exports.SmartIndenter.getIndentation(position, sourceFile, settings);
	      log("getIndentationAtPosition: computeIndentation  : " + (timestamp() - start));
	      return result;
	    }
	    function getFormattingEditsForRange(fileName, start, end, options) {
	      const sourceFile = syntaxTreeCache.getCurrentSourceFile(fileName);
	      return ts_formatting_exports.formatSelection(start, end, sourceFile, ts_formatting_exports.getFormatContext(toEditorSettings(options), host));
	    }
	    function getFormattingEditsForDocument(fileName, options) {
	      return ts_formatting_exports.formatDocument(syntaxTreeCache.getCurrentSourceFile(fileName), ts_formatting_exports.getFormatContext(toEditorSettings(options), host));
	    }
	    function getFormattingEditsAfterKeystroke(fileName, position, key, options) {
	      const sourceFile = syntaxTreeCache.getCurrentSourceFile(fileName);
	      const formatContext = ts_formatting_exports.getFormatContext(toEditorSettings(options), host);
	      if (!isInComment(sourceFile, position)) {
	        switch (key) {
	          case "{":
	            return ts_formatting_exports.formatOnOpeningCurly(position, sourceFile, formatContext);
	          case "}":
	            return ts_formatting_exports.formatOnClosingCurly(position, sourceFile, formatContext);
	          case ";":
	            return ts_formatting_exports.formatOnSemicolon(position, sourceFile, formatContext);
	          case "\n":
	            return ts_formatting_exports.formatOnEnter(position, sourceFile, formatContext);
	        }
	      }
	      return [];
	    }
	    function getCodeFixesAtPosition(fileName, start, end, errorCodes65, formatOptions, preferences = emptyOptions) {
	      synchronizeHostData();
	      const sourceFile = getValidSourceFile(fileName);
	      const span = createTextSpanFromBounds(start, end);
	      const formatContext = ts_formatting_exports.getFormatContext(formatOptions, host);
	      return flatMap(deduplicate(errorCodes65, equateValues, compareValues), (errorCode) => {
	        cancellationToken.throwIfCancellationRequested();
	        return ts_codefix_exports.getFixes({ errorCode, sourceFile, span, program, host, cancellationToken, formatContext, preferences });
	      });
	    }
	    function getCombinedCodeFix(scope, fixId52, formatOptions, preferences = emptyOptions) {
	      synchronizeHostData();
	      Debug.assert(scope.type === "file");
	      const sourceFile = getValidSourceFile(scope.fileName);
	      const formatContext = ts_formatting_exports.getFormatContext(formatOptions, host);
	      return ts_codefix_exports.getAllFixes({ fixId: fixId52, sourceFile, program, host, cancellationToken, formatContext, preferences });
	    }
	    function organizeImports2(args, formatOptions, preferences = emptyOptions) {
	      synchronizeHostData();
	      Debug.assert(args.type === "file");
	      const sourceFile = getValidSourceFile(args.fileName);
	      const formatContext = ts_formatting_exports.getFormatContext(formatOptions, host);
	      const mode = args.mode ?? (args.skipDestructiveCodeActions ? "SortAndCombine" /* SortAndCombine */ : "All" /* All */);
	      return ts_OrganizeImports_exports.organizeImports(sourceFile, formatContext, host, program, preferences, mode);
	    }
	    function getEditsForFileRename2(oldFilePath, newFilePath, formatOptions, preferences = emptyOptions) {
	      return getEditsForFileRename(getProgram(), oldFilePath, newFilePath, host, ts_formatting_exports.getFormatContext(formatOptions, host), preferences, sourceMapper);
	    }
	    function applyCodeActionCommand(fileName, actionOrFormatSettingsOrUndefined) {
	      const action = typeof fileName === "string" ? actionOrFormatSettingsOrUndefined : fileName;
	      return isArray(action) ? Promise.all(action.map((a) => applySingleCodeActionCommand(a))) : applySingleCodeActionCommand(action);
	    }
	    function applySingleCodeActionCommand(action) {
	      const getPath = (path) => toPath(path, currentDirectory, getCanonicalFileName);
	      Debug.assertEqual(action.type, "install package");
	      return host.installPackage ? host.installPackage({ fileName: getPath(action.file), packageName: action.packageName }) : Promise.reject("Host does not implement `installPackage`");
	    }
	    function getDocCommentTemplateAtPosition2(fileName, position, options, formatOptions) {
	      const formatSettings = formatOptions ? ts_formatting_exports.getFormatContext(formatOptions, host).options : void 0;
	      return ts_JsDoc_exports.getDocCommentTemplateAtPosition(getNewLineOrDefaultFromHost(host, formatSettings), syntaxTreeCache.getCurrentSourceFile(fileName), position, options);
	    }
	    function isValidBraceCompletionAtPosition(fileName, position, openingBrace) {
	      if (openingBrace === 60 /* lessThan */) {
	        return false;
	      }
	      const sourceFile = syntaxTreeCache.getCurrentSourceFile(fileName);
	      if (isInString(sourceFile, position)) {
	        return false;
	      }
	      if (isInsideJsxElementOrAttribute(sourceFile, position)) {
	        return openingBrace === 123 /* openBrace */;
	      }
	      if (isInTemplateString(sourceFile, position)) {
	        return false;
	      }
	      switch (openingBrace) {
	        case 39 /* singleQuote */:
	        case 34 /* doubleQuote */:
	        case 96 /* backtick */:
	          return !isInComment(sourceFile, position);
	      }
	      return true;
	    }
	    function getJsxClosingTagAtPosition(fileName, position) {
	      const sourceFile = syntaxTreeCache.getCurrentSourceFile(fileName);
	      const token = findPrecedingToken(position, sourceFile);
	      if (!token)
	        return void 0;
	      const element = token.kind === 32 /* GreaterThanToken */ && isJsxOpeningElement(token.parent) ? token.parent.parent : isJsxText(token) && isJsxElement(token.parent) ? token.parent : void 0;
	      if (element && isUnclosedTag(element)) {
	        return { newText: `</${element.openingElement.tagName.getText(sourceFile)}>` };
	      }
	      const fragment = token.kind === 32 /* GreaterThanToken */ && isJsxOpeningFragment(token.parent) ? token.parent.parent : isJsxText(token) && isJsxFragment(token.parent) ? token.parent : void 0;
	      if (fragment && isUnclosedFragment(fragment)) {
	        return { newText: "</>" };
	      }
	    }
	    function getLinkedEditingRangeAtPosition(fileName, position) {
	      const sourceFile = syntaxTreeCache.getCurrentSourceFile(fileName);
	      const token = findPrecedingToken(position, sourceFile);
	      if (!token || token.parent.kind === 312 /* SourceFile */)
	        return void 0;
	      const jsxTagWordPattern = "[a-zA-Z0-9:\\-\\._$]*";
	      if (isJsxFragment(token.parent.parent)) {
	        const openFragment = token.parent.parent.openingFragment;
	        const closeFragment = token.parent.parent.closingFragment;
	        if (containsParseError(openFragment) || containsParseError(closeFragment))
	          return void 0;
	        const openPos = openFragment.getStart(sourceFile) + 1;
	        const closePos = closeFragment.getStart(sourceFile) + 2;
	        if (position !== openPos && position !== closePos)
	          return void 0;
	        return {
	          ranges: [{ start: openPos, length: 0 }, { start: closePos, length: 0 }],
	          wordPattern: jsxTagWordPattern
	        };
	      } else {
	        const tag = findAncestor(token.parent, (n) => {
	          if (isJsxOpeningElement(n) || isJsxClosingElement(n)) {
	            return true;
	          }
	          return false;
	        });
	        if (!tag)
	          return void 0;
	        Debug.assert(isJsxOpeningElement(tag) || isJsxClosingElement(tag), "tag should be opening or closing element");
	        const openTag = tag.parent.openingElement;
	        const closeTag = tag.parent.closingElement;
	        const openTagNameStart = openTag.tagName.getStart(sourceFile);
	        const openTagNameEnd = openTag.tagName.end;
	        const closeTagNameStart = closeTag.tagName.getStart(sourceFile);
	        const closeTagNameEnd = closeTag.tagName.end;
	        if (openTagNameStart === openTag.getStart(sourceFile) || closeTagNameStart === closeTag.getStart(sourceFile) || openTagNameEnd === openTag.getEnd() || closeTagNameEnd === closeTag.getEnd())
	          return void 0;
	        if (!(openTagNameStart <= position && position <= openTagNameEnd || closeTagNameStart <= position && position <= closeTagNameEnd))
	          return void 0;
	        const openingTagText = openTag.tagName.getText(sourceFile);
	        if (openingTagText !== closeTag.tagName.getText(sourceFile))
	          return void 0;
	        return {
	          ranges: [{ start: openTagNameStart, length: openTagNameEnd - openTagNameStart }, { start: closeTagNameStart, length: closeTagNameEnd - closeTagNameStart }],
	          wordPattern: jsxTagWordPattern
	        };
	      }
	    }
	    function getLinesForRange(sourceFile, textRange) {
	      return {
	        lineStarts: sourceFile.getLineStarts(),
	        firstLine: sourceFile.getLineAndCharacterOfPosition(textRange.pos).line,
	        lastLine: sourceFile.getLineAndCharacterOfPosition(textRange.end).line
	      };
	    }
	    function toggleLineComment(fileName, textRange, insertComment) {
	      const sourceFile = syntaxTreeCache.getCurrentSourceFile(fileName);
	      const textChanges2 = [];
	      const { lineStarts, firstLine, lastLine } = getLinesForRange(sourceFile, textRange);
	      let isCommenting = insertComment || false;
	      let leftMostPosition = Number.MAX_VALUE;
	      const lineTextStarts = /* @__PURE__ */ new Map();
	      const firstNonWhitespaceCharacterRegex = new RegExp(/\S/);
	      const isJsx = isInsideJsxElement(sourceFile, lineStarts[firstLine]);
	      const openComment = isJsx ? "{/*" : "//";
	      for (let i = firstLine; i <= lastLine; i++) {
	        const lineText = sourceFile.text.substring(lineStarts[i], sourceFile.getLineEndOfPosition(lineStarts[i]));
	        const regExec = firstNonWhitespaceCharacterRegex.exec(lineText);
	        if (regExec) {
	          leftMostPosition = Math.min(leftMostPosition, regExec.index);
	          lineTextStarts.set(i.toString(), regExec.index);
	          if (lineText.substr(regExec.index, openComment.length) !== openComment) {
	            isCommenting = insertComment === void 0 || insertComment;
	          }
	        }
	      }
	      for (let i = firstLine; i <= lastLine; i++) {
	        if (firstLine !== lastLine && lineStarts[i] === textRange.end) {
	          continue;
	        }
	        const lineTextStart = lineTextStarts.get(i.toString());
	        if (lineTextStart !== void 0) {
	          if (isJsx) {
	            textChanges2.push(...toggleMultilineComment(fileName, { pos: lineStarts[i] + leftMostPosition, end: sourceFile.getLineEndOfPosition(lineStarts[i]) }, isCommenting, isJsx));
	          } else if (isCommenting) {
	            textChanges2.push({
	              newText: openComment,
	              span: {
	                length: 0,
	                start: lineStarts[i] + leftMostPosition
	              }
	            });
	          } else if (sourceFile.text.substr(lineStarts[i] + lineTextStart, openComment.length) === openComment) {
	            textChanges2.push({
	              newText: "",
	              span: {
	                length: openComment.length,
	                start: lineStarts[i] + lineTextStart
	              }
	            });
	          }
	        }
	      }
	      return textChanges2;
	    }
	    function toggleMultilineComment(fileName, textRange, insertComment, isInsideJsx) {
	      var _a2;
	      const sourceFile = syntaxTreeCache.getCurrentSourceFile(fileName);
	      const textChanges2 = [];
	      const { text } = sourceFile;
	      let hasComment = false;
	      let isCommenting = insertComment || false;
	      const positions = [];
	      let { pos } = textRange;
	      const isJsx = isInsideJsx !== void 0 ? isInsideJsx : isInsideJsxElement(sourceFile, pos);
	      const openMultiline = isJsx ? "{/*" : "/*";
	      const closeMultiline = isJsx ? "*/}" : "*/";
	      const openMultilineRegex = isJsx ? "\\{\\/\\*" : "\\/\\*";
	      const closeMultilineRegex = isJsx ? "\\*\\/\\}" : "\\*\\/";
	      while (pos <= textRange.end) {
	        const offset = text.substr(pos, openMultiline.length) === openMultiline ? openMultiline.length : 0;
	        const commentRange = isInComment(sourceFile, pos + offset);
	        if (commentRange) {
	          if (isJsx) {
	            commentRange.pos--;
	            commentRange.end++;
	          }
	          positions.push(commentRange.pos);
	          if (commentRange.kind === 3 /* MultiLineCommentTrivia */) {
	            positions.push(commentRange.end);
	          }
	          hasComment = true;
	          pos = commentRange.end + 1;
	        } else {
	          const newPos = text.substring(pos, textRange.end).search(`(${openMultilineRegex})|(${closeMultilineRegex})`);
	          isCommenting = insertComment !== void 0 ? insertComment : isCommenting || !isTextWhiteSpaceLike(text, pos, newPos === -1 ? textRange.end : pos + newPos);
	          pos = newPos === -1 ? textRange.end + 1 : pos + newPos + closeMultiline.length;
	        }
	      }
	      if (isCommenting || !hasComment) {
	        if (((_a2 = isInComment(sourceFile, textRange.pos)) == null ? void 0 : _a2.kind) !== 2 /* SingleLineCommentTrivia */) {
	          insertSorted(positions, textRange.pos, compareValues);
	        }
	        insertSorted(positions, textRange.end, compareValues);
	        const firstPos = positions[0];
	        if (text.substr(firstPos, openMultiline.length) !== openMultiline) {
	          textChanges2.push({
	            newText: openMultiline,
	            span: {
	              length: 0,
	              start: firstPos
	            }
	          });
	        }
	        for (let i = 1; i < positions.length - 1; i++) {
	          if (text.substr(positions[i] - closeMultiline.length, closeMultiline.length) !== closeMultiline) {
	            textChanges2.push({
	              newText: closeMultiline,
	              span: {
	                length: 0,
	                start: positions[i]
	              }
	            });
	          }
	          if (text.substr(positions[i], openMultiline.length) !== openMultiline) {
	            textChanges2.push({
	              newText: openMultiline,
	              span: {
	                length: 0,
	                start: positions[i]
	              }
	            });
	          }
	        }
	        if (textChanges2.length % 2 !== 0) {
	          textChanges2.push({
	            newText: closeMultiline,
	            span: {
	              length: 0,
	              start: positions[positions.length - 1]
	            }
	          });
	        }
	      } else {
	        for (const pos2 of positions) {
	          const from = pos2 - closeMultiline.length > 0 ? pos2 - closeMultiline.length : 0;
	          const offset = text.substr(from, closeMultiline.length) === closeMultiline ? closeMultiline.length : 0;
	          textChanges2.push({
	            newText: "",
	            span: {
	              length: openMultiline.length,
	              start: pos2 - offset
	            }
	          });
	        }
	      }
	      return textChanges2;
	    }
	    function commentSelection(fileName, textRange) {
	      const sourceFile = syntaxTreeCache.getCurrentSourceFile(fileName);
	      const { firstLine, lastLine } = getLinesForRange(sourceFile, textRange);
	      return firstLine === lastLine && textRange.pos !== textRange.end ? toggleMultilineComment(
	        fileName,
	        textRange,
	        /*insertComment*/
	        true
	      ) : toggleLineComment(
	        fileName,
	        textRange,
	        /*insertComment*/
	        true
	      );
	    }
	    function uncommentSelection(fileName, textRange) {
	      const sourceFile = syntaxTreeCache.getCurrentSourceFile(fileName);
	      const textChanges2 = [];
	      const { pos } = textRange;
	      let { end } = textRange;
	      if (pos === end) {
	        end += isInsideJsxElement(sourceFile, pos) ? 2 : 1;
	      }
	      for (let i = pos; i <= end; i++) {
	        const commentRange = isInComment(sourceFile, i);
	        if (commentRange) {
	          switch (commentRange.kind) {
	            case 2 /* SingleLineCommentTrivia */:
	              textChanges2.push(...toggleLineComment(
	                fileName,
	                { end: commentRange.end, pos: commentRange.pos + 1 },
	                /*insertComment*/
	                false
	              ));
	              break;
	            case 3 /* MultiLineCommentTrivia */:
	              textChanges2.push(...toggleMultilineComment(
	                fileName,
	                { end: commentRange.end, pos: commentRange.pos + 1 },
	                /*insertComment*/
	                false
	              ));
	          }
	          i = commentRange.end + 1;
	        }
	      }
	      return textChanges2;
	    }
	    function isUnclosedTag({ openingElement, closingElement, parent: parent2 }) {
	      return !tagNamesAreEquivalent(openingElement.tagName, closingElement.tagName) || isJsxElement(parent2) && tagNamesAreEquivalent(openingElement.tagName, parent2.openingElement.tagName) && isUnclosedTag(parent2);
	    }
	    function isUnclosedFragment({ closingFragment, parent: parent2 }) {
	      return !!(closingFragment.flags & 262144 /* ThisNodeHasError */) || isJsxFragment(parent2) && isUnclosedFragment(parent2);
	    }
	    function getSpanOfEnclosingComment(fileName, position, onlyMultiLine) {
	      const sourceFile = syntaxTreeCache.getCurrentSourceFile(fileName);
	      const range = ts_formatting_exports.getRangeOfEnclosingComment(sourceFile, position);
	      return range && (!onlyMultiLine || range.kind === 3 /* MultiLineCommentTrivia */) ? createTextSpanFromRange(range) : void 0;
	    }
	    function getTodoComments(fileName, descriptors) {
	      synchronizeHostData();
	      const sourceFile = getValidSourceFile(fileName);
	      cancellationToken.throwIfCancellationRequested();
	      const fileContents = sourceFile.text;
	      const result = [];
	      if (descriptors.length > 0 && !isNodeModulesFile(sourceFile.fileName)) {
	        const regExp = getTodoCommentsRegExp();
	        let matchArray;
	        while (matchArray = regExp.exec(fileContents)) {
	          cancellationToken.throwIfCancellationRequested();
	          const firstDescriptorCaptureIndex = 3;
	          Debug.assert(matchArray.length === descriptors.length + firstDescriptorCaptureIndex);
	          const preamble = matchArray[1];
	          const matchPosition = matchArray.index + preamble.length;
	          if (!isInComment(sourceFile, matchPosition)) {
	            continue;
	          }
	          let descriptor;
	          for (let i = 0; i < descriptors.length; i++) {
	            if (matchArray[i + firstDescriptorCaptureIndex]) {
	              descriptor = descriptors[i];
	            }
	          }
	          if (descriptor === void 0)
	            return Debug.fail();
	          if (isLetterOrDigit(fileContents.charCodeAt(matchPosition + descriptor.text.length))) {
	            continue;
	          }
	          const message = matchArray[2];
	          result.push({ descriptor, message, position: matchPosition });
	        }
	      }
	      return result;
	      function escapeRegExp(str) {
	        return str.replace(/[-[\]/{}()*+?.\\^$|]/g, "\\$&");
	      }
	      function getTodoCommentsRegExp() {
	        const singleLineCommentStart = /(?:\/\/+\s*)/.source;
	        const multiLineCommentStart = /(?:\/\*+\s*)/.source;
	        const anyNumberOfSpacesAndAsterisksAtStartOfLine = /(?:^(?:\s|\*)*)/.source;
	        const preamble = "(" + anyNumberOfSpacesAndAsterisksAtStartOfLine + "|" + singleLineCommentStart + "|" + multiLineCommentStart + ")";
	        const literals = "(?:" + map(descriptors, (d) => "(" + escapeRegExp(d.text) + ")").join("|") + ")";
	        const endOfLineOrEndOfComment = /(?:$|\*\/)/.source;
	        const messageRemainder = /(?:.*?)/.source;
	        const messagePortion = "(" + literals + messageRemainder + ")";
	        const regExpString = preamble + messagePortion + endOfLineOrEndOfComment;
	        return new RegExp(regExpString, "gim");
	      }
	      function isLetterOrDigit(char) {
	        return char >= 97 /* a */ && char <= 122 /* z */ || char >= 65 /* A */ && char <= 90 /* Z */ || char >= 48 /* _0 */ && char <= 57 /* _9 */;
	      }
	      function isNodeModulesFile(path) {
	        return path.includes("/node_modules/");
	      }
	    }
	    function getRenameInfo2(fileName, position, preferences) {
	      synchronizeHostData();
	      return ts_Rename_exports.getRenameInfo(program, getValidSourceFile(fileName), position, preferences || {});
	    }
	    function getRefactorContext(file, positionOrRange, preferences, formatOptions, triggerReason, kind) {
	      const [startPosition, endPosition] = typeof positionOrRange === "number" ? [positionOrRange, void 0] : [positionOrRange.pos, positionOrRange.end];
	      return {
	        file,
	        startPosition,
	        endPosition,
	        program: getProgram(),
	        host,
	        formatContext: ts_formatting_exports.getFormatContext(formatOptions, host),
	        // TODO: GH#18217
	        cancellationToken,
	        preferences,
	        triggerReason,
	        kind
	      };
	    }
	    function getInlayHintsContext(file, span, preferences) {
	      return {
	        file,
	        program: getProgram(),
	        host,
	        span,
	        preferences,
	        cancellationToken
	      };
	    }
	    function getSmartSelectionRange2(fileName, position) {
	      return ts_SmartSelectionRange_exports.getSmartSelectionRange(position, syntaxTreeCache.getCurrentSourceFile(fileName));
	    }
	    function getApplicableRefactors2(fileName, positionOrRange, preferences = emptyOptions, triggerReason, kind, includeInteractiveActions) {
	      synchronizeHostData();
	      const file = getValidSourceFile(fileName);
	      return ts_refactor_exports.getApplicableRefactors(getRefactorContext(file, positionOrRange, preferences, emptyOptions, triggerReason, kind), includeInteractiveActions);
	    }
	    function getMoveToRefactoringFileSuggestions(fileName, positionOrRange, preferences = emptyOptions) {
	      synchronizeHostData();
	      const sourceFile = getValidSourceFile(fileName);
	      const allFiles = Debug.checkDefined(program.getSourceFiles());
	      const extension = extensionFromPath(fileName);
	      const toMove = getStatementsToMove(getRefactorContext(sourceFile, positionOrRange, preferences, emptyOptions));
	      const toMoveContainsJsx = containsJsx(toMove == null ? void 0 : toMove.all);
	      const files = mapDefined(allFiles, (file) => {
	        const fileNameExtension = extensionFromPath(file.fileName);
	        const isValidSourceFile = !(program == null ? void 0 : program.isSourceFileFromExternalLibrary(sourceFile)) && !(sourceFile === getValidSourceFile(file.fileName) || extension === ".ts" /* Ts */ && fileNameExtension === ".d.ts" /* Dts */ || extension === ".d.ts" /* Dts */ && startsWith(getBaseFileName(file.fileName), "lib.") && fileNameExtension === ".d.ts" /* Dts */);
	        return isValidSourceFile && (extension === fileNameExtension || (extension === ".tsx" /* Tsx */ && fileNameExtension === ".ts" /* Ts */ || extension === ".jsx" /* Jsx */ && fileNameExtension === ".js" /* Js */) && !toMoveContainsJsx) ? file.fileName : void 0;
	      });
	      return { newFileName: createNewFileName(sourceFile, program, host, toMove), files };
	    }
	    function getEditsForRefactor2(fileName, formatOptions, positionOrRange, refactorName14, actionName2, preferences = emptyOptions, interactiveRefactorArguments) {
	      synchronizeHostData();
	      const file = getValidSourceFile(fileName);
	      return ts_refactor_exports.getEditsForRefactor(getRefactorContext(file, positionOrRange, preferences, formatOptions), refactorName14, actionName2, interactiveRefactorArguments);
	    }
	    function toLineColumnOffset(fileName, position) {
	      if (position === 0) {
	        return { line: 0, character: 0 };
	      }
	      return sourceMapper.toLineColumnOffset(fileName, position);
	    }
	    function prepareCallHierarchy(fileName, position) {
	      synchronizeHostData();
	      const declarations = ts_CallHierarchy_exports.resolveCallHierarchyDeclaration(program, getTouchingPropertyName(getValidSourceFile(fileName), position));
	      return declarations && mapOneOrMany(declarations, (declaration) => ts_CallHierarchy_exports.createCallHierarchyItem(program, declaration));
	    }
	    function provideCallHierarchyIncomingCalls(fileName, position) {
	      synchronizeHostData();
	      const sourceFile = getValidSourceFile(fileName);
	      const declaration = firstOrOnly(ts_CallHierarchy_exports.resolveCallHierarchyDeclaration(program, position === 0 ? sourceFile : getTouchingPropertyName(sourceFile, position)));
	      return declaration ? ts_CallHierarchy_exports.getIncomingCalls(program, declaration, cancellationToken) : [];
	    }
	    function provideCallHierarchyOutgoingCalls(fileName, position) {
	      synchronizeHostData();
	      const sourceFile = getValidSourceFile(fileName);
	      const declaration = firstOrOnly(ts_CallHierarchy_exports.resolveCallHierarchyDeclaration(program, position === 0 ? sourceFile : getTouchingPropertyName(sourceFile, position)));
	      return declaration ? ts_CallHierarchy_exports.getOutgoingCalls(program, declaration) : [];
	    }
	    function provideInlayHints2(fileName, span, preferences = emptyOptions) {
	      synchronizeHostData();
	      const sourceFile = getValidSourceFile(fileName);
	      return ts_InlayHints_exports.provideInlayHints(getInlayHintsContext(sourceFile, span, preferences));
	    }
	    const ls = {
	      dispose,
	      cleanupSemanticCache,
	      getSyntacticDiagnostics,
	      getSemanticDiagnostics,
	      getSuggestionDiagnostics,
	      getCompilerOptionsDiagnostics,
	      getSyntacticClassifications: getSyntacticClassifications2,
	      getSemanticClassifications: getSemanticClassifications3,
	      getEncodedSyntacticClassifications: getEncodedSyntacticClassifications2,
	      getEncodedSemanticClassifications: getEncodedSemanticClassifications3,
	      getCompletionsAtPosition: getCompletionsAtPosition2,
	      getCompletionEntryDetails: getCompletionEntryDetails2,
	      getCompletionEntrySymbol: getCompletionEntrySymbol2,
	      getSignatureHelpItems: getSignatureHelpItems2,
	      getQuickInfoAtPosition,
	      getDefinitionAtPosition: getDefinitionAtPosition2,
	      getDefinitionAndBoundSpan: getDefinitionAndBoundSpan2,
	      getImplementationAtPosition,
	      getTypeDefinitionAtPosition: getTypeDefinitionAtPosition2,
	      getReferencesAtPosition,
	      findReferences,
	      getFileReferences,
	      getDocumentHighlights,
	      getNameOrDottedNameSpan,
	      getBreakpointStatementAtPosition,
	      getNavigateToItems: getNavigateToItems2,
	      getRenameInfo: getRenameInfo2,
	      getSmartSelectionRange: getSmartSelectionRange2,
	      findRenameLocations,
	      getNavigationBarItems: getNavigationBarItems2,
	      getNavigationTree: getNavigationTree2,
	      getOutliningSpans,
	      getTodoComments,
	      getBraceMatchingAtPosition,
	      getIndentationAtPosition,
	      getFormattingEditsForRange,
	      getFormattingEditsForDocument,
	      getFormattingEditsAfterKeystroke,
	      getDocCommentTemplateAtPosition: getDocCommentTemplateAtPosition2,
	      isValidBraceCompletionAtPosition,
	      getJsxClosingTagAtPosition,
	      getLinkedEditingRangeAtPosition,
	      getSpanOfEnclosingComment,
	      getCodeFixesAtPosition,
	      getCombinedCodeFix,
	      applyCodeActionCommand,
	      organizeImports: organizeImports2,
	      getEditsForFileRename: getEditsForFileRename2,
	      getEmitOutput,
	      getNonBoundSourceFile,
	      getProgram,
	      getCurrentProgram: () => program,
	      getAutoImportProvider,
	      updateIsDefinitionOfReferencedSymbols,
	      getApplicableRefactors: getApplicableRefactors2,
	      getEditsForRefactor: getEditsForRefactor2,
	      getMoveToRefactoringFileSuggestions,
	      toLineColumnOffset,
	      getSourceMapper: () => sourceMapper,
	      clearSourceMapperCache: () => sourceMapper.clearCache(),
	      prepareCallHierarchy,
	      provideCallHierarchyIncomingCalls,
	      provideCallHierarchyOutgoingCalls,
	      toggleLineComment,
	      toggleMultilineComment,
	      commentSelection,
	      uncommentSelection,
	      provideInlayHints: provideInlayHints2,
	      getSupportedCodeFixes
	    };
	    switch (languageServiceMode) {
	      case 0 /* Semantic */:
	        break;
	      case 1 /* PartialSemantic */:
	        invalidOperationsInPartialSemanticMode.forEach(
	          (key) => ls[key] = () => {
	            throw new Error(`LanguageService Operation: ${key} not allowed in LanguageServiceMode.PartialSemantic`);
	          }
	        );
	        break;
	      case 2 /* Syntactic */:
	        invalidOperationsInSyntacticMode.forEach(
	          (key) => ls[key] = () => {
	            throw new Error(`LanguageService Operation: ${key} not allowed in LanguageServiceMode.Syntactic`);
	          }
	        );
	        break;
	      default:
	        Debug.assertNever(languageServiceMode);
	    }
	    return ls;
	  }
	  function getNameTable(sourceFile) {
	    if (!sourceFile.nameTable) {
	      initializeNameTable(sourceFile);
	    }
	    return sourceFile.nameTable;
	  }
	  function initializeNameTable(sourceFile) {
	    const nameTable = sourceFile.nameTable = /* @__PURE__ */ new Map();
	    sourceFile.forEachChild(function walk(node) {
	      if (isIdentifier(node) && !isTagName(node) && node.escapedText || isStringOrNumericLiteralLike(node) && literalIsName(node)) {
	        const text = getEscapedTextOfIdentifierOrLiteral(node);
	        nameTable.set(text, nameTable.get(text) === void 0 ? node.pos : -1);
	      } else if (isPrivateIdentifier(node)) {
	        const text = node.escapedText;
	        nameTable.set(text, nameTable.get(text) === void 0 ? node.pos : -1);
	      }
	      forEachChild(node, walk);
	      if (hasJSDocNodes(node)) {
	        for (const jsDoc of node.jsDoc) {
	          forEachChild(jsDoc, walk);
	        }
	      }
	    });
	  }
	  function literalIsName(node) {
	    return isDeclarationName(node) || node.parent.kind === 283 /* ExternalModuleReference */ || isArgumentOfElementAccessExpression(node) || isLiteralComputedPropertyDeclarationName(node);
	  }
	  function getContainingObjectLiteralElement(node) {
	    const element = getContainingObjectLiteralElementWorker(node);
	    return element && (isObjectLiteralExpression(element.parent) || isJsxAttributes(element.parent)) ? element : void 0;
	  }
	  function getContainingObjectLiteralElementWorker(node) {
	    switch (node.kind) {
	      case 11 /* StringLiteral */:
	      case 15 /* NoSubstitutionTemplateLiteral */:
	      case 9 /* NumericLiteral */:
	        if (node.parent.kind === 167 /* ComputedPropertyName */) {
	          return isObjectLiteralElement(node.parent.parent) ? node.parent.parent : void 0;
	        }
	      case 80 /* Identifier */:
	        return isObjectLiteralElement(node.parent) && (node.parent.parent.kind === 210 /* ObjectLiteralExpression */ || node.parent.parent.kind === 292 /* JsxAttributes */) && node.parent.name === node ? node.parent : void 0;
	    }
	    return void 0;
	  }
	  function getSymbolAtLocationForQuickInfo(node, checker) {
	    const object = getContainingObjectLiteralElement(node);
	    if (object) {
	      const contextualType = checker.getContextualType(object.parent);
	      const properties = contextualType && getPropertySymbolsFromContextualType(
	        object,
	        checker,
	        contextualType,
	        /*unionSymbolOk*/
	        false
	      );
	      if (properties && properties.length === 1) {
	        return first(properties);
	      }
	    }
	    return checker.getSymbolAtLocation(node);
	  }
	  function getPropertySymbolsFromContextualType(node, checker, contextualType, unionSymbolOk) {
	    const name = getNameFromPropertyName(node.name);
	    if (!name)
	      return emptyArray;
	    if (!contextualType.isUnion()) {
	      const symbol = contextualType.getProperty(name);
	      return symbol ? [symbol] : emptyArray;
	    }
	    const filteredTypes = isObjectLiteralExpression(node.parent) || isJsxAttributes(node.parent) ? filter(contextualType.types, (t) => !checker.isTypeInvalidDueToUnionDiscriminant(t, node.parent)) : contextualType.types;
	    const discriminatedPropertySymbols = mapDefined(filteredTypes, (t) => t.getProperty(name));
	    if (unionSymbolOk && (discriminatedPropertySymbols.length === 0 || discriminatedPropertySymbols.length === contextualType.types.length)) {
	      const symbol = contextualType.getProperty(name);
	      if (symbol)
	        return [symbol];
	    }
	    if (!filteredTypes.length && !discriminatedPropertySymbols.length) {
	      return mapDefined(contextualType.types, (t) => t.getProperty(name));
	    }
	    return deduplicate(discriminatedPropertySymbols, equateValues);
	  }
	  function isArgumentOfElementAccessExpression(node) {
	    return node && node.parent && node.parent.kind === 212 /* ElementAccessExpression */ && node.parent.argumentExpression === node;
	  }
	  function getDefaultLibFilePath(options) {
	    if (sys) {
	      return combinePaths(getDirectoryPath(normalizePath(sys.getExecutingFilePath())), getDefaultLibFileName(options));
	    }
	    throw new Error("getDefaultLibFilePath is only supported when consumed as a node module. ");
	  }
	  var servicesVersion, NodeObject, TokenOrIdentifierObject, SymbolObject, TokenObject, IdentifierObject, PrivateIdentifierObject, TypeObject, SignatureObject, SourceFileObject, SourceMapSourceObject, SyntaxTreeCache, NoopCancellationToken, CancellationTokenObject, ThrottledCancellationToken, invalidOperationsInPartialSemanticMode, invalidOperationsInSyntacticMode;
	  var init_services = __esm({
	    "src/services/services.ts"() {
	      init_ts4();
	      init_ts_NavigateTo();
	      init_ts_NavigationBar();
	      init_ts_refactor();
	      init_classifier();
	      init_classifier2020();
	      servicesVersion = "0.8";
	      NodeObject = class {
	        constructor(kind, pos, end) {
	          this.pos = pos;
	          this.end = end;
	          this.flags = 0 /* None */;
	          this.modifierFlagsCache = 0 /* None */;
	          this.transformFlags = 0 /* None */;
	          this.parent = void 0;
	          this.kind = kind;
	        }
	        assertHasRealPosition(message) {
	          Debug.assert(!positionIsSynthesized(this.pos) && !positionIsSynthesized(this.end), message || "Node must have a real position for this operation");
	        }
	        getSourceFile() {
	          return getSourceFileOfNode(this);
	        }
	        getStart(sourceFile, includeJsDocComment) {
	          this.assertHasRealPosition();
	          return getTokenPosOfNode(this, sourceFile, includeJsDocComment);
	        }
	        getFullStart() {
	          this.assertHasRealPosition();
	          return this.pos;
	        }
	        getEnd() {
	          this.assertHasRealPosition();
	          return this.end;
	        }
	        getWidth(sourceFile) {
	          this.assertHasRealPosition();
	          return this.getEnd() - this.getStart(sourceFile);
	        }
	        getFullWidth() {
	          this.assertHasRealPosition();
	          return this.end - this.pos;
	        }
	        getLeadingTriviaWidth(sourceFile) {
	          this.assertHasRealPosition();
	          return this.getStart(sourceFile) - this.pos;
	        }
	        getFullText(sourceFile) {
	          this.assertHasRealPosition();
	          return (sourceFile || this.getSourceFile()).text.substring(this.pos, this.end);
	        }
	        getText(sourceFile) {
	          this.assertHasRealPosition();
	          if (!sourceFile) {
	            sourceFile = this.getSourceFile();
	          }
	          return sourceFile.text.substring(this.getStart(sourceFile), this.getEnd());
	        }
	        getChildCount(sourceFile) {
	          return this.getChildren(sourceFile).length;
	        }
	        getChildAt(index, sourceFile) {
	          return this.getChildren(sourceFile)[index];
	        }
	        getChildren(sourceFile) {
	          this.assertHasRealPosition("Node without a real position cannot be scanned and thus has no token nodes - use forEachChild and collect the result if that's fine");
	          return this._children || (this._children = createChildren(this, sourceFile));
	        }
	        getFirstToken(sourceFile) {
	          this.assertHasRealPosition();
	          const children = this.getChildren(sourceFile);
	          if (!children.length) {
	            return void 0;
	          }
	          const child = find(children, (kid) => kid.kind < 316 /* FirstJSDocNode */ || kid.kind > 357 /* LastJSDocNode */);
	          return child.kind < 166 /* FirstNode */ ? child : child.getFirstToken(sourceFile);
	        }
	        getLastToken(sourceFile) {
	          this.assertHasRealPosition();
	          const children = this.getChildren(sourceFile);
	          const child = lastOrUndefined(children);
	          if (!child) {
	            return void 0;
	          }
	          return child.kind < 166 /* FirstNode */ ? child : child.getLastToken(sourceFile);
	        }
	        forEachChild(cbNode, cbNodeArray) {
	          return forEachChild(this, cbNode, cbNodeArray);
	        }
	      };
	      TokenOrIdentifierObject = class {
	        constructor(pos, end) {
	          this.pos = pos;
	          this.end = end;
	          this.flags = 0 /* None */;
	          this.modifierFlagsCache = 0 /* None */;
	          this.transformFlags = 0 /* None */;
	          this.parent = void 0;
	        }
	        getSourceFile() {
	          return getSourceFileOfNode(this);
	        }
	        getStart(sourceFile, includeJsDocComment) {
	          return getTokenPosOfNode(this, sourceFile, includeJsDocComment);
	        }
	        getFullStart() {
	          return this.pos;
	        }
	        getEnd() {
	          return this.end;
	        }
	        getWidth(sourceFile) {
	          return this.getEnd() - this.getStart(sourceFile);
	        }
	        getFullWidth() {
	          return this.end - this.pos;
	        }
	        getLeadingTriviaWidth(sourceFile) {
	          return this.getStart(sourceFile) - this.pos;
	        }
	        getFullText(sourceFile) {
	          return (sourceFile || this.getSourceFile()).text.substring(this.pos, this.end);
	        }
	        getText(sourceFile) {
	          if (!sourceFile) {
	            sourceFile = this.getSourceFile();
	          }
	          return sourceFile.text.substring(this.getStart(sourceFile), this.getEnd());
	        }
	        getChildCount() {
	          return this.getChildren().length;
	        }
	        getChildAt(index) {
	          return this.getChildren()[index];
	        }
	        getChildren() {
	          return this.kind === 1 /* EndOfFileToken */ ? this.jsDoc || emptyArray : emptyArray;
	        }
	        getFirstToken() {
	          return void 0;
	        }
	        getLastToken() {
	          return void 0;
	        }
	        forEachChild() {
	          return void 0;
	        }
	      };
	      SymbolObject = class {
	        constructor(flags, name) {
	          this.id = 0;
	          this.mergeId = 0;
	          this.flags = flags;
	          this.escapedName = name;
	        }
	        getFlags() {
	          return this.flags;
	        }
	        get name() {
	          return symbolName(this);
	        }
	        getEscapedName() {
	          return this.escapedName;
	        }
	        getName() {
	          return this.name;
	        }
	        getDeclarations() {
	          return this.declarations;
	        }
	        getDocumentationComment(checker) {
	          if (!this.documentationComment) {
	            this.documentationComment = emptyArray;
	            if (!this.declarations && isTransientSymbol(this) && this.links.target && isTransientSymbol(this.links.target) && this.links.target.links.tupleLabelDeclaration) {
	              const labelDecl = this.links.target.links.tupleLabelDeclaration;
	              this.documentationComment = getDocumentationComment([labelDecl], checker);
	            } else {
	              this.documentationComment = getDocumentationComment(this.declarations, checker);
	            }
	          }
	          return this.documentationComment;
	        }
	        getContextualDocumentationComment(context, checker) {
	          if (context) {
	            if (isGetAccessor(context)) {
	              if (!this.contextualGetAccessorDocumentationComment) {
	                this.contextualGetAccessorDocumentationComment = getDocumentationComment(filter(this.declarations, isGetAccessor), checker);
	              }
	              if (length(this.contextualGetAccessorDocumentationComment)) {
	                return this.contextualGetAccessorDocumentationComment;
	              }
	            }
	            if (isSetAccessor(context)) {
	              if (!this.contextualSetAccessorDocumentationComment) {
	                this.contextualSetAccessorDocumentationComment = getDocumentationComment(filter(this.declarations, isSetAccessor), checker);
	              }
	              if (length(this.contextualSetAccessorDocumentationComment)) {
	                return this.contextualSetAccessorDocumentationComment;
	              }
	            }
	          }
	          return this.getDocumentationComment(checker);
	        }
	        getJsDocTags(checker) {
	          if (this.tags === void 0) {
	            this.tags = getJsDocTagsOfDeclarations(this.declarations, checker);
	          }
	          return this.tags;
	        }
	        getContextualJsDocTags(context, checker) {
	          if (context) {
	            if (isGetAccessor(context)) {
	              if (!this.contextualGetAccessorTags) {
	                this.contextualGetAccessorTags = getJsDocTagsOfDeclarations(filter(this.declarations, isGetAccessor), checker);
	              }
	              if (length(this.contextualGetAccessorTags)) {
	                return this.contextualGetAccessorTags;
	              }
	            }
	            if (isSetAccessor(context)) {
	              if (!this.contextualSetAccessorTags) {
	                this.contextualSetAccessorTags = getJsDocTagsOfDeclarations(filter(this.declarations, isSetAccessor), checker);
	              }
	              if (length(this.contextualSetAccessorTags)) {
	                return this.contextualSetAccessorTags;
	              }
	            }
	          }
	          return this.getJsDocTags(checker);
	        }
	      };
	      TokenObject = class extends TokenOrIdentifierObject {
	        constructor(kind, pos, end) {
	          super(pos, end);
	          this.kind = kind;
	        }
	      };
	      IdentifierObject = class extends TokenOrIdentifierObject {
	        constructor(_kind, pos, end) {
	          super(pos, end);
	          this.kind = 80 /* Identifier */;
	        }
	        get text() {
	          return idText(this);
	        }
	      };
	      IdentifierObject.prototype.kind = 80 /* Identifier */;
	      PrivateIdentifierObject = class extends TokenOrIdentifierObject {
	        constructor(_kind, pos, end) {
	          super(pos, end);
	          this.kind = 81 /* PrivateIdentifier */;
	        }
	        get text() {
	          return idText(this);
	        }
	      };
	      PrivateIdentifierObject.prototype.kind = 81 /* PrivateIdentifier */;
	      TypeObject = class {
	        constructor(checker, flags) {
	          this.checker = checker;
	          this.flags = flags;
	        }
	        getFlags() {
	          return this.flags;
	        }
	        getSymbol() {
	          return this.symbol;
	        }
	        getProperties() {
	          return this.checker.getPropertiesOfType(this);
	        }
	        getProperty(propertyName) {
	          return this.checker.getPropertyOfType(this, propertyName);
	        }
	        getApparentProperties() {
	          return this.checker.getAugmentedPropertiesOfType(this);
	        }
	        getCallSignatures() {
	          return this.checker.getSignaturesOfType(this, 0 /* Call */);
	        }
	        getConstructSignatures() {
	          return this.checker.getSignaturesOfType(this, 1 /* Construct */);
	        }
	        getStringIndexType() {
	          return this.checker.getIndexTypeOfType(this, 0 /* String */);
	        }
	        getNumberIndexType() {
	          return this.checker.getIndexTypeOfType(this, 1 /* Number */);
	        }
	        getBaseTypes() {
	          return this.isClassOrInterface() ? this.checker.getBaseTypes(this) : void 0;
	        }
	        isNullableType() {
	          return this.checker.isNullableType(this);
	        }
	        getNonNullableType() {
	          return this.checker.getNonNullableType(this);
	        }
	        getNonOptionalType() {
	          return this.checker.getNonOptionalType(this);
	        }
	        getConstraint() {
	          return this.checker.getBaseConstraintOfType(this);
	        }
	        getDefault() {
	          return this.checker.getDefaultFromTypeParameter(this);
	        }
	        isUnion() {
	          return !!(this.flags & 1048576 /* Union */);
	        }
	        isIntersection() {
	          return !!(this.flags & 2097152 /* Intersection */);
	        }
	        isUnionOrIntersection() {
	          return !!(this.flags & 3145728 /* UnionOrIntersection */);
	        }
	        isLiteral() {
	          return !!(this.flags & (128 /* StringLiteral */ | 256 /* NumberLiteral */ | 2048 /* BigIntLiteral */));
	        }
	        isStringLiteral() {
	          return !!(this.flags & 128 /* StringLiteral */);
	        }
	        isNumberLiteral() {
	          return !!(this.flags & 256 /* NumberLiteral */);
	        }
	        isTypeParameter() {
	          return !!(this.flags & 262144 /* TypeParameter */);
	        }
	        isClassOrInterface() {
	          return !!(getObjectFlags(this) & 3 /* ClassOrInterface */);
	        }
	        isClass() {
	          return !!(getObjectFlags(this) & 1 /* Class */);
	        }
	        isIndexType() {
	          return !!(this.flags & 4194304 /* Index */);
	        }
	        /**
	         * This polyfills `referenceType.typeArguments` for API consumers
	         */
	        get typeArguments() {
	          if (getObjectFlags(this) & 4 /* Reference */) {
	            return this.checker.getTypeArguments(this);
	          }
	          return void 0;
	        }
	      };
	      SignatureObject = class {
	        // same
	        constructor(checker, flags) {
	          this.checker = checker;
	          this.flags = flags;
	        }
	        getDeclaration() {
	          return this.declaration;
	        }
	        getTypeParameters() {
	          return this.typeParameters;
	        }
	        getParameters() {
	          return this.parameters;
	        }
	        getReturnType() {
	          return this.checker.getReturnTypeOfSignature(this);
	        }
	        getTypeParameterAtPosition(pos) {
	          const type = this.checker.getParameterType(this, pos);
	          if (type.isIndexType() && isThisTypeParameter(type.type)) {
	            const constraint = type.type.getConstraint();
	            if (constraint) {
	              return this.checker.getIndexType(constraint);
	            }
	          }
	          return type;
	        }
	        getDocumentationComment() {
	          return this.documentationComment || (this.documentationComment = getDocumentationComment(singleElementArray(this.declaration), this.checker));
	        }
	        getJsDocTags() {
	          return this.jsDocTags || (this.jsDocTags = getJsDocTagsOfDeclarations(singleElementArray(this.declaration), this.checker));
	        }
	      };
	      SourceFileObject = class extends NodeObject {
	        constructor(kind, pos, end) {
	          super(kind, pos, end);
	          this.kind = 312 /* SourceFile */;
	        }
	        update(newText, textChangeRange) {
	          return updateSourceFile(this, newText, textChangeRange);
	        }
	        getLineAndCharacterOfPosition(position) {
	          return getLineAndCharacterOfPosition(this, position);
	        }
	        getLineStarts() {
	          return getLineStarts(this);
	        }
	        getPositionOfLineAndCharacter(line, character, allowEdits) {
	          return computePositionOfLineAndCharacter(getLineStarts(this), line, character, this.text, allowEdits);
	        }
	        getLineEndOfPosition(pos) {
	          const { line } = this.getLineAndCharacterOfPosition(pos);
	          const lineStarts = this.getLineStarts();
	          let lastCharPos;
	          if (line + 1 >= lineStarts.length) {
	            lastCharPos = this.getEnd();
	          }
	          if (!lastCharPos) {
	            lastCharPos = lineStarts[line + 1] - 1;
	          }
	          const fullText = this.getFullText();
	          return fullText[lastCharPos] === "\n" && fullText[lastCharPos - 1] === "\r" ? lastCharPos - 1 : lastCharPos;
	        }
	        getNamedDeclarations() {
	          if (!this.namedDeclarations) {
	            this.namedDeclarations = this.computeNamedDeclarations();
	          }
	          return this.namedDeclarations;
	        }
	        computeNamedDeclarations() {
	          const result = createMultiMap();
	          this.forEachChild(visit);
	          return result;
	          function addDeclaration(declaration) {
	            const name = getDeclarationName(declaration);
	            if (name) {
	              result.add(name, declaration);
	            }
	          }
	          function getDeclarations(name) {
	            let declarations = result.get(name);
	            if (!declarations) {
	              result.set(name, declarations = []);
	            }
	            return declarations;
	          }
	          function getDeclarationName(declaration) {
	            const name = getNonAssignedNameOfDeclaration(declaration);
	            return name && (isComputedPropertyName(name) && isPropertyAccessExpression(name.expression) ? name.expression.name.text : isPropertyName(name) ? getNameFromPropertyName(name) : void 0);
	          }
	          function visit(node) {
	            switch (node.kind) {
	              case 262 /* FunctionDeclaration */:
	              case 218 /* FunctionExpression */:
	              case 174 /* MethodDeclaration */:
	              case 173 /* MethodSignature */:
	                const functionDeclaration = node;
	                const declarationName = getDeclarationName(functionDeclaration);
	                if (declarationName) {
	                  const declarations = getDeclarations(declarationName);
	                  const lastDeclaration = lastOrUndefined(declarations);
	                  if (lastDeclaration && functionDeclaration.parent === lastDeclaration.parent && functionDeclaration.symbol === lastDeclaration.symbol) {
	                    if (functionDeclaration.body && !lastDeclaration.body) {
	                      declarations[declarations.length - 1] = functionDeclaration;
	                    }
	                  } else {
	                    declarations.push(functionDeclaration);
	                  }
	                }
	                forEachChild(node, visit);
	                break;
	              case 263 /* ClassDeclaration */:
	              case 231 /* ClassExpression */:
	              case 264 /* InterfaceDeclaration */:
	              case 265 /* TypeAliasDeclaration */:
	              case 266 /* EnumDeclaration */:
	              case 267 /* ModuleDeclaration */:
	              case 271 /* ImportEqualsDeclaration */:
	              case 281 /* ExportSpecifier */:
	              case 276 /* ImportSpecifier */:
	              case 273 /* ImportClause */:
	              case 274 /* NamespaceImport */:
	              case 177 /* GetAccessor */:
	              case 178 /* SetAccessor */:
	              case 187 /* TypeLiteral */:
	                addDeclaration(node);
	                forEachChild(node, visit);
	                break;
	              case 169 /* Parameter */:
	                if (!hasSyntacticModifier(node, 31 /* ParameterPropertyModifier */)) {
	                  break;
	                }
	              case 260 /* VariableDeclaration */:
	              case 208 /* BindingElement */: {
	                const decl = node;
	                if (isBindingPattern(decl.name)) {
	                  forEachChild(decl.name, visit);
	                  break;
	                }
	                if (decl.initializer) {
	                  visit(decl.initializer);
	                }
	              }
	              case 306 /* EnumMember */:
	              case 172 /* PropertyDeclaration */:
	              case 171 /* PropertySignature */:
	                addDeclaration(node);
	                break;
	              case 278 /* ExportDeclaration */:
	                const exportDeclaration = node;
	                if (exportDeclaration.exportClause) {
	                  if (isNamedExports(exportDeclaration.exportClause)) {
	                    forEach(exportDeclaration.exportClause.elements, visit);
	                  } else {
	                    visit(exportDeclaration.exportClause.name);
	                  }
	                }
	                break;
	              case 272 /* ImportDeclaration */:
	                const importClause = node.importClause;
	                if (importClause) {
	                  if (importClause.name) {
	                    addDeclaration(importClause.name);
	                  }
	                  if (importClause.namedBindings) {
	                    if (importClause.namedBindings.kind === 274 /* NamespaceImport */) {
	                      addDeclaration(importClause.namedBindings);
	                    } else {
	                      forEach(importClause.namedBindings.elements, visit);
	                    }
	                  }
	                }
	                break;
	              case 226 /* BinaryExpression */:
	                if (getAssignmentDeclarationKind(node) !== 0 /* None */) {
	                  addDeclaration(node);
	                }
	              default:
	                forEachChild(node, visit);
	            }
	          }
	        }
	      };
	      SourceMapSourceObject = class {
	        constructor(fileName, text, skipTrivia2) {
	          this.fileName = fileName;
	          this.text = text;
	          this.skipTrivia = skipTrivia2;
	        }
	        getLineAndCharacterOfPosition(pos) {
	          return getLineAndCharacterOfPosition(this, pos);
	        }
	      };
	      SyntaxTreeCache = class {
	        constructor(host) {
	          this.host = host;
	        }
	        getCurrentSourceFile(fileName) {
	          var _a, _b, _c, _d, _e, _f, _g, _h;
	          const scriptSnapshot = this.host.getScriptSnapshot(fileName);
	          if (!scriptSnapshot) {
	            throw new Error("Could not find file: '" + fileName + "'.");
	          }
	          const scriptKind = getScriptKind(fileName, this.host);
	          const version2 = this.host.getScriptVersion(fileName);
	          let sourceFile;
	          if (this.currentFileName !== fileName) {
	            const options = {
	              languageVersion: 99 /* Latest */,
	              impliedNodeFormat: getImpliedNodeFormatForFile(
	                toPath(fileName, this.host.getCurrentDirectory(), ((_c = (_b = (_a = this.host).getCompilerHost) == null ? void 0 : _b.call(_a)) == null ? void 0 : _c.getCanonicalFileName) || hostGetCanonicalFileName(this.host)),
	                (_h = (_g = (_f = (_e = (_d = this.host).getCompilerHost) == null ? void 0 : _e.call(_d)) == null ? void 0 : _f.getModuleResolutionCache) == null ? void 0 : _g.call(_f)) == null ? void 0 : _h.getPackageJsonInfoCache(),
	                this.host,
	                this.host.getCompilationSettings()
	              ),
	              setExternalModuleIndicator: getSetExternalModuleIndicator(this.host.getCompilationSettings()),
	              // These files are used to produce syntax-based highlighting, which reads JSDoc, so we must use ParseAll.
	              jsDocParsingMode: 0 /* ParseAll */
	            };
	            sourceFile = createLanguageServiceSourceFile(
	              fileName,
	              scriptSnapshot,
	              options,
	              version2,
	              /*setNodeParents*/
	              true,
	              scriptKind
	            );
	          } else if (this.currentFileVersion !== version2) {
	            const editRange = scriptSnapshot.getChangeRange(this.currentFileScriptSnapshot);
	            sourceFile = updateLanguageServiceSourceFile(this.currentSourceFile, scriptSnapshot, version2, editRange);
	          }
	          if (sourceFile) {
	            this.currentFileVersion = version2;
	            this.currentFileName = fileName;
	            this.currentFileScriptSnapshot = scriptSnapshot;
	            this.currentSourceFile = sourceFile;
	          }
	          return this.currentSourceFile;
	        }
	      };
	      NoopCancellationToken = {
	        isCancellationRequested: returnFalse,
	        throwIfCancellationRequested: noop
	      };
	      CancellationTokenObject = class {
	        constructor(cancellationToken) {
	          this.cancellationToken = cancellationToken;
	        }
	        isCancellationRequested() {
	          return this.cancellationToken.isCancellationRequested();
	        }
	        throwIfCancellationRequested() {
	          var _a;
	          if (this.isCancellationRequested()) {
	            (_a = tracing) == null ? void 0 : _a.instant(tracing.Phase.Session, "cancellationThrown", { kind: "CancellationTokenObject" });
	            throw new OperationCanceledException();
	          }
	        }
	      };
	      ThrottledCancellationToken = class {
	        constructor(hostCancellationToken, throttleWaitMilliseconds = 20) {
	          this.hostCancellationToken = hostCancellationToken;
	          this.throttleWaitMilliseconds = throttleWaitMilliseconds;
	          // Store when we last tried to cancel.  Checking cancellation can be expensive (as we have
	          // to marshall over to the host layer).  So we only bother actually checking once enough
	          // time has passed.
	          this.lastCancellationCheckTime = 0;
	        }
	        isCancellationRequested() {
	          const time = timestamp();
	          const duration = Math.abs(time - this.lastCancellationCheckTime);
	          if (duration >= this.throttleWaitMilliseconds) {
	            this.lastCancellationCheckTime = time;
	            return this.hostCancellationToken.isCancellationRequested();
	          }
	          return false;
	        }
	        throwIfCancellationRequested() {
	          var _a;
	          if (this.isCancellationRequested()) {
	            (_a = tracing) == null ? void 0 : _a.instant(tracing.Phase.Session, "cancellationThrown", { kind: "ThrottledCancellationToken" });
	            throw new OperationCanceledException();
	          }
	        }
	      };
	      invalidOperationsInPartialSemanticMode = [
	        "getSemanticDiagnostics",
	        "getSuggestionDiagnostics",
	        "getCompilerOptionsDiagnostics",
	        "getSemanticClassifications",
	        "getEncodedSemanticClassifications",
	        "getCodeFixesAtPosition",
	        "getCombinedCodeFix",
	        "applyCodeActionCommand",
	        "organizeImports",
	        "getEditsForFileRename",
	        "getEmitOutput",
	        "getApplicableRefactors",
	        "getEditsForRefactor",
	        "prepareCallHierarchy",
	        "provideCallHierarchyIncomingCalls",
	        "provideCallHierarchyOutgoingCalls",
	        "provideInlayHints",
	        "getSupportedCodeFixes"
	      ];
	      invalidOperationsInSyntacticMode = [
	        ...invalidOperationsInPartialSemanticMode,
	        "getCompletionsAtPosition",
	        "getCompletionEntryDetails",
	        "getCompletionEntrySymbol",
	        "getSignatureHelpItems",
	        "getQuickInfoAtPosition",
	        "getDefinitionAtPosition",
	        "getDefinitionAndBoundSpan",
	        "getImplementationAtPosition",
	        "getTypeDefinitionAtPosition",
	        "getReferencesAtPosition",
	        "findReferences",
	        "getDocumentHighlights",
	        "getNavigateToItems",
	        "getRenameInfo",
	        "findRenameLocations",
	        "getApplicableRefactors"
	      ];
	      setObjectAllocator(getServicesObjectAllocator());
	    }
	  });

	  // src/services/transform.ts
	  function transform(source, transformers, compilerOptions) {
	    const diagnostics = [];
	    compilerOptions = fixupCompilerOptions(compilerOptions, diagnostics);
	    const nodes = isArray(source) ? source : [source];
	    const result = transformNodes(
	      /*resolver*/
	      void 0,
	      /*host*/
	      void 0,
	      factory,
	      compilerOptions,
	      nodes,
	      transformers,
	      /*allowDtsFiles*/
	      true
	    );
	    result.diagnostics = concatenate(result.diagnostics, diagnostics);
	    return result;
	  }
	  var init_transform = __esm({
	    "src/services/transform.ts"() {
	      init_ts4();
	    }
	  });

	  // src/services/breakpoints.ts
	  function spanInSourceFileAtLocation(sourceFile, position) {
	    if (sourceFile.isDeclarationFile) {
	      return void 0;
	    }
	    let tokenAtLocation = getTokenAtPosition(sourceFile, position);
	    const lineOfPosition = sourceFile.getLineAndCharacterOfPosition(position).line;
	    if (sourceFile.getLineAndCharacterOfPosition(tokenAtLocation.getStart(sourceFile)).line > lineOfPosition) {
	      const preceding = findPrecedingToken(tokenAtLocation.pos, sourceFile);
	      if (!preceding || sourceFile.getLineAndCharacterOfPosition(preceding.getEnd()).line !== lineOfPosition) {
	        return void 0;
	      }
	      tokenAtLocation = preceding;
	    }
	    if (tokenAtLocation.flags & 33554432 /* Ambient */) {
	      return void 0;
	    }
	    return spanInNode(tokenAtLocation);
	    function textSpan(startNode2, endNode2) {
	      const lastDecorator = canHaveDecorators(startNode2) ? findLast(startNode2.modifiers, isDecorator) : void 0;
	      const start = lastDecorator ? skipTrivia(sourceFile.text, lastDecorator.end) : startNode2.getStart(sourceFile);
	      return createTextSpanFromBounds(start, (endNode2 || startNode2).getEnd());
	    }
	    function textSpanEndingAtNextToken(startNode2, previousTokenToFindNextEndToken) {
	      return textSpan(startNode2, findNextToken(previousTokenToFindNextEndToken, previousTokenToFindNextEndToken.parent, sourceFile));
	    }
	    function spanInNodeIfStartsOnSameLine(node, otherwiseOnNode) {
	      if (node && lineOfPosition === sourceFile.getLineAndCharacterOfPosition(node.getStart(sourceFile)).line) {
	        return spanInNode(node);
	      }
	      return spanInNode(otherwiseOnNode);
	    }
	    function spanInNodeArray(nodeArray, node, match) {
	      if (nodeArray) {
	        const index = nodeArray.indexOf(node);
	        if (index >= 0) {
	          let start = index;
	          let end = index + 1;
	          while (start > 0 && match(nodeArray[start - 1]))
	            start--;
	          while (end < nodeArray.length && match(nodeArray[end]))
	            end++;
	          return createTextSpanFromBounds(skipTrivia(sourceFile.text, nodeArray[start].pos), nodeArray[end - 1].end);
	        }
	      }
	      return textSpan(node);
	    }
	    function spanInPreviousNode(node) {
	      return spanInNode(findPrecedingToken(node.pos, sourceFile));
	    }
	    function spanInNextNode(node) {
	      return spanInNode(findNextToken(node, node.parent, sourceFile));
	    }
	    function spanInNode(node) {
	      if (node) {
	        const { parent: parent2 } = node;
	        switch (node.kind) {
	          case 243 /* VariableStatement */:
	            return spanInVariableDeclaration(node.declarationList.declarations[0]);
	          case 260 /* VariableDeclaration */:
	          case 172 /* PropertyDeclaration */:
	          case 171 /* PropertySignature */:
	            return spanInVariableDeclaration(node);
	          case 169 /* Parameter */:
	            return spanInParameterDeclaration(node);
	          case 262 /* FunctionDeclaration */:
	          case 174 /* MethodDeclaration */:
	          case 173 /* MethodSignature */:
	          case 177 /* GetAccessor */:
	          case 178 /* SetAccessor */:
	          case 176 /* Constructor */:
	          case 218 /* FunctionExpression */:
	          case 219 /* ArrowFunction */:
	            return spanInFunctionDeclaration(node);
	          case 241 /* Block */:
	            if (isFunctionBlock(node)) {
	              return spanInFunctionBlock(node);
	            }
	          case 268 /* ModuleBlock */:
	            return spanInBlock(node);
	          case 299 /* CatchClause */:
	            return spanInBlock(node.block);
	          case 244 /* ExpressionStatement */:
	            return textSpan(node.expression);
	          case 253 /* ReturnStatement */:
	            return textSpan(node.getChildAt(0), node.expression);
	          case 247 /* WhileStatement */:
	            return textSpanEndingAtNextToken(node, node.expression);
	          case 246 /* DoStatement */:
	            return spanInNode(node.statement);
	          case 259 /* DebuggerStatement */:
	            return textSpan(node.getChildAt(0));
	          case 245 /* IfStatement */:
	            return textSpanEndingAtNextToken(node, node.expression);
	          case 256 /* LabeledStatement */:
	            return spanInNode(node.statement);
	          case 252 /* BreakStatement */:
	          case 251 /* ContinueStatement */:
	            return textSpan(node.getChildAt(0), node.label);
	          case 248 /* ForStatement */:
	            return spanInForStatement(node);
	          case 249 /* ForInStatement */:
	            return textSpanEndingAtNextToken(node, node.expression);
	          case 250 /* ForOfStatement */:
	            return spanInInitializerOfForLike(node);
	          case 255 /* SwitchStatement */:
	            return textSpanEndingAtNextToken(node, node.expression);
	          case 296 /* CaseClause */:
	          case 297 /* DefaultClause */:
	            return spanInNode(node.statements[0]);
	          case 258 /* TryStatement */:
	            return spanInBlock(node.tryBlock);
	          case 257 /* ThrowStatement */:
	            return textSpan(node, node.expression);
	          case 277 /* ExportAssignment */:
	            return textSpan(node, node.expression);
	          case 271 /* ImportEqualsDeclaration */:
	            return textSpan(node, node.moduleReference);
	          case 272 /* ImportDeclaration */:
	            return textSpan(node, node.moduleSpecifier);
	          case 278 /* ExportDeclaration */:
	            return textSpan(node, node.moduleSpecifier);
	          case 267 /* ModuleDeclaration */:
	            if (getModuleInstanceState(node) !== 1 /* Instantiated */) {
	              return void 0;
	            }
	          case 263 /* ClassDeclaration */:
	          case 266 /* EnumDeclaration */:
	          case 306 /* EnumMember */:
	          case 208 /* BindingElement */:
	            return textSpan(node);
	          case 254 /* WithStatement */:
	            return spanInNode(node.statement);
	          case 170 /* Decorator */:
	            return spanInNodeArray(parent2.modifiers, node, isDecorator);
	          case 206 /* ObjectBindingPattern */:
	          case 207 /* ArrayBindingPattern */:
	            return spanInBindingPattern(node);
	          case 264 /* InterfaceDeclaration */:
	          case 265 /* TypeAliasDeclaration */:
	            return void 0;
	          case 27 /* SemicolonToken */:
	          case 1 /* EndOfFileToken */:
	            return spanInNodeIfStartsOnSameLine(findPrecedingToken(node.pos, sourceFile));
	          case 28 /* CommaToken */:
	            return spanInPreviousNode(node);
	          case 19 /* OpenBraceToken */:
	            return spanInOpenBraceToken(node);
	          case 20 /* CloseBraceToken */:
	            return spanInCloseBraceToken(node);
	          case 24 /* CloseBracketToken */:
	            return spanInCloseBracketToken(node);
	          case 21 /* OpenParenToken */:
	            return spanInOpenParenToken(node);
	          case 22 /* CloseParenToken */:
	            return spanInCloseParenToken(node);
	          case 59 /* ColonToken */:
	            return spanInColonToken(node);
	          case 32 /* GreaterThanToken */:
	          case 30 /* LessThanToken */:
	            return spanInGreaterThanOrLessThanToken(node);
	          case 117 /* WhileKeyword */:
	            return spanInWhileKeyword(node);
	          case 93 /* ElseKeyword */:
	          case 85 /* CatchKeyword */:
	          case 98 /* FinallyKeyword */:
	            return spanInNextNode(node);
	          case 165 /* OfKeyword */:
	            return spanInOfKeyword(node);
	          default:
	            if (isArrayLiteralOrObjectLiteralDestructuringPattern(node)) {
	              return spanInArrayLiteralOrObjectLiteralDestructuringPattern(node);
	            }
	            if ((node.kind === 80 /* Identifier */ || node.kind === 230 /* SpreadElement */ || node.kind === 303 /* PropertyAssignment */ || node.kind === 304 /* ShorthandPropertyAssignment */) && isArrayLiteralOrObjectLiteralDestructuringPattern(parent2)) {
	              return textSpan(node);
	            }
	            if (node.kind === 226 /* BinaryExpression */) {
	              const { left, operatorToken } = node;
	              if (isArrayLiteralOrObjectLiteralDestructuringPattern(left)) {
	                return spanInArrayLiteralOrObjectLiteralDestructuringPattern(
	                  left
	                );
	              }
	              if (operatorToken.kind === 64 /* EqualsToken */ && isArrayLiteralOrObjectLiteralDestructuringPattern(node.parent)) {
	                return textSpan(node);
	              }
	              if (operatorToken.kind === 28 /* CommaToken */) {
	                return spanInNode(left);
	              }
	            }
	            if (isExpressionNode(node)) {
	              switch (parent2.kind) {
	                case 246 /* DoStatement */:
	                  return spanInPreviousNode(node);
	                case 170 /* Decorator */:
	                  return spanInNode(node.parent);
	                case 248 /* ForStatement */:
	                case 250 /* ForOfStatement */:
	                  return textSpan(node);
	                case 226 /* BinaryExpression */:
	                  if (node.parent.operatorToken.kind === 28 /* CommaToken */) {
	                    return textSpan(node);
	                  }
	                  break;
	                case 219 /* ArrowFunction */:
	                  if (node.parent.body === node) {
	                    return textSpan(node);
	                  }
	                  break;
	              }
	            }
	            switch (node.parent.kind) {
	              case 303 /* PropertyAssignment */:
	                if (node.parent.name === node && !isArrayLiteralOrObjectLiteralDestructuringPattern(node.parent.parent)) {
	                  return spanInNode(node.parent.initializer);
	                }
	                break;
	              case 216 /* TypeAssertionExpression */:
	                if (node.parent.type === node) {
	                  return spanInNextNode(node.parent.type);
	                }
	                break;
	              case 260 /* VariableDeclaration */:
	              case 169 /* Parameter */: {
	                const { initializer, type } = node.parent;
	                if (initializer === node || type === node || isAssignmentOperator(node.kind)) {
	                  return spanInPreviousNode(node);
	                }
	                break;
	              }
	              case 226 /* BinaryExpression */: {
	                const { left } = node.parent;
	                if (isArrayLiteralOrObjectLiteralDestructuringPattern(left) && node !== left) {
	                  return spanInPreviousNode(node);
	                }
	                break;
	              }
	              default:
	                if (isFunctionLike(node.parent) && node.parent.type === node) {
	                  return spanInPreviousNode(node);
	                }
	            }
	            return spanInNode(node.parent);
	        }
	      }
	      function textSpanFromVariableDeclaration(variableDeclaration) {
	        if (isVariableDeclarationList(variableDeclaration.parent) && variableDeclaration.parent.declarations[0] === variableDeclaration) {
	          return textSpan(findPrecedingToken(variableDeclaration.pos, sourceFile, variableDeclaration.parent), variableDeclaration);
	        } else {
	          return textSpan(variableDeclaration);
	        }
	      }
	      function spanInVariableDeclaration(variableDeclaration) {
	        if (variableDeclaration.parent.parent.kind === 249 /* ForInStatement */) {
	          return spanInNode(variableDeclaration.parent.parent);
	        }
	        const parent2 = variableDeclaration.parent;
	        if (isBindingPattern(variableDeclaration.name)) {
	          return spanInBindingPattern(variableDeclaration.name);
	        }
	        if (hasOnlyExpressionInitializer(variableDeclaration) && variableDeclaration.initializer || hasSyntacticModifier(variableDeclaration, 32 /* Export */) || parent2.parent.kind === 250 /* ForOfStatement */) {
	          return textSpanFromVariableDeclaration(variableDeclaration);
	        }
	        if (isVariableDeclarationList(variableDeclaration.parent) && variableDeclaration.parent.declarations[0] !== variableDeclaration) {
	          return spanInNode(findPrecedingToken(variableDeclaration.pos, sourceFile, variableDeclaration.parent));
	        }
	      }
	      function canHaveSpanInParameterDeclaration(parameter) {
	        return !!parameter.initializer || parameter.dotDotDotToken !== void 0 || hasSyntacticModifier(parameter, 1 /* Public */ | 2 /* Private */);
	      }
	      function spanInParameterDeclaration(parameter) {
	        if (isBindingPattern(parameter.name)) {
	          return spanInBindingPattern(parameter.name);
	        } else if (canHaveSpanInParameterDeclaration(parameter)) {
	          return textSpan(parameter);
	        } else {
	          const functionDeclaration = parameter.parent;
	          const indexOfParameter = functionDeclaration.parameters.indexOf(parameter);
	          Debug.assert(indexOfParameter !== -1);
	          if (indexOfParameter !== 0) {
	            return spanInParameterDeclaration(functionDeclaration.parameters[indexOfParameter - 1]);
	          } else {
	            return spanInNode(functionDeclaration.body);
	          }
	        }
	      }
	      function canFunctionHaveSpanInWholeDeclaration(functionDeclaration) {
	        return hasSyntacticModifier(functionDeclaration, 32 /* Export */) || functionDeclaration.parent.kind === 263 /* ClassDeclaration */ && functionDeclaration.kind !== 176 /* Constructor */;
	      }
	      function spanInFunctionDeclaration(functionDeclaration) {
	        if (!functionDeclaration.body) {
	          return void 0;
	        }
	        if (canFunctionHaveSpanInWholeDeclaration(functionDeclaration)) {
	          return textSpan(functionDeclaration);
	        }
	        return spanInNode(functionDeclaration.body);
	      }
	      function spanInFunctionBlock(block) {
	        const nodeForSpanInBlock = block.statements.length ? block.statements[0] : block.getLastToken();
	        if (canFunctionHaveSpanInWholeDeclaration(block.parent)) {
	          return spanInNodeIfStartsOnSameLine(block.parent, nodeForSpanInBlock);
	        }
	        return spanInNode(nodeForSpanInBlock);
	      }
	      function spanInBlock(block) {
	        switch (block.parent.kind) {
	          case 267 /* ModuleDeclaration */:
	            if (getModuleInstanceState(block.parent) !== 1 /* Instantiated */) {
	              return void 0;
	            }
	          case 247 /* WhileStatement */:
	          case 245 /* IfStatement */:
	          case 249 /* ForInStatement */:
	            return spanInNodeIfStartsOnSameLine(block.parent, block.statements[0]);
	          case 248 /* ForStatement */:
	          case 250 /* ForOfStatement */:
	            return spanInNodeIfStartsOnSameLine(findPrecedingToken(block.pos, sourceFile, block.parent), block.statements[0]);
	        }
	        return spanInNode(block.statements[0]);
	      }
	      function spanInInitializerOfForLike(forLikeStatement) {
	        if (forLikeStatement.initializer.kind === 261 /* VariableDeclarationList */) {
	          const variableDeclarationList = forLikeStatement.initializer;
	          if (variableDeclarationList.declarations.length > 0) {
	            return spanInNode(variableDeclarationList.declarations[0]);
	          }
	        } else {
	          return spanInNode(forLikeStatement.initializer);
	        }
	      }
	      function spanInForStatement(forStatement) {
	        if (forStatement.initializer) {
	          return spanInInitializerOfForLike(forStatement);
	        }
	        if (forStatement.condition) {
	          return textSpan(forStatement.condition);
	        }
	        if (forStatement.incrementor) {
	          return textSpan(forStatement.incrementor);
	        }
	      }
	      function spanInBindingPattern(bindingPattern) {
	        const firstBindingElement = forEach(bindingPattern.elements, (element) => element.kind !== 232 /* OmittedExpression */ ? element : void 0);
	        if (firstBindingElement) {
	          return spanInNode(firstBindingElement);
	        }
	        if (bindingPattern.parent.kind === 208 /* BindingElement */) {
	          return textSpan(bindingPattern.parent);
	        }
	        return textSpanFromVariableDeclaration(bindingPattern.parent);
	      }
	      function spanInArrayLiteralOrObjectLiteralDestructuringPattern(node2) {
	        Debug.assert(node2.kind !== 207 /* ArrayBindingPattern */ && node2.kind !== 206 /* ObjectBindingPattern */);
	        const elements = node2.kind === 209 /* ArrayLiteralExpression */ ? node2.elements : node2.properties;
	        const firstBindingElement = forEach(elements, (element) => element.kind !== 232 /* OmittedExpression */ ? element : void 0);
	        if (firstBindingElement) {
	          return spanInNode(firstBindingElement);
	        }
	        return textSpan(node2.parent.kind === 226 /* BinaryExpression */ ? node2.parent : node2);
	      }
	      function spanInOpenBraceToken(node2) {
	        switch (node2.parent.kind) {
	          case 266 /* EnumDeclaration */:
	            const enumDeclaration = node2.parent;
	            return spanInNodeIfStartsOnSameLine(findPrecedingToken(node2.pos, sourceFile, node2.parent), enumDeclaration.members.length ? enumDeclaration.members[0] : enumDeclaration.getLastToken(sourceFile));
	          case 263 /* ClassDeclaration */:
	            const classDeclaration = node2.parent;
	            return spanInNodeIfStartsOnSameLine(findPrecedingToken(node2.pos, sourceFile, node2.parent), classDeclaration.members.length ? classDeclaration.members[0] : classDeclaration.getLastToken(sourceFile));
	          case 269 /* CaseBlock */:
	            return spanInNodeIfStartsOnSameLine(node2.parent.parent, node2.parent.clauses[0]);
	        }
	        return spanInNode(node2.parent);
	      }
	      function spanInCloseBraceToken(node2) {
	        switch (node2.parent.kind) {
	          case 268 /* ModuleBlock */:
	            if (getModuleInstanceState(node2.parent.parent) !== 1 /* Instantiated */) {
	              return void 0;
	            }
	          case 266 /* EnumDeclaration */:
	          case 263 /* ClassDeclaration */:
	            return textSpan(node2);
	          case 241 /* Block */:
	            if (isFunctionBlock(node2.parent)) {
	              return textSpan(node2);
	            }
	          case 299 /* CatchClause */:
	            return spanInNode(lastOrUndefined(node2.parent.statements));
	          case 269 /* CaseBlock */:
	            const caseBlock = node2.parent;
	            const lastClause = lastOrUndefined(caseBlock.clauses);
	            if (lastClause) {
	              return spanInNode(lastOrUndefined(lastClause.statements));
	            }
	            return void 0;
	          case 206 /* ObjectBindingPattern */:
	            const bindingPattern = node2.parent;
	            return spanInNode(lastOrUndefined(bindingPattern.elements) || bindingPattern);
	          default:
	            if (isArrayLiteralOrObjectLiteralDestructuringPattern(node2.parent)) {
	              const objectLiteral = node2.parent;
	              return textSpan(lastOrUndefined(objectLiteral.properties) || objectLiteral);
	            }
	            return spanInNode(node2.parent);
	        }
	      }
	      function spanInCloseBracketToken(node2) {
	        switch (node2.parent.kind) {
	          case 207 /* ArrayBindingPattern */:
	            const bindingPattern = node2.parent;
	            return textSpan(lastOrUndefined(bindingPattern.elements) || bindingPattern);
	          default:
	            if (isArrayLiteralOrObjectLiteralDestructuringPattern(node2.parent)) {
	              const arrayLiteral = node2.parent;
	              return textSpan(lastOrUndefined(arrayLiteral.elements) || arrayLiteral);
	            }
	            return spanInNode(node2.parent);
	        }
	      }
	      function spanInOpenParenToken(node2) {
	        if (node2.parent.kind === 246 /* DoStatement */ || // Go to while keyword and do action instead
	        node2.parent.kind === 213 /* CallExpression */ || node2.parent.kind === 214 /* NewExpression */) {
	          return spanInPreviousNode(node2);
	        }
	        if (node2.parent.kind === 217 /* ParenthesizedExpression */) {
	          return spanInNextNode(node2);
	        }
	        return spanInNode(node2.parent);
	      }
	      function spanInCloseParenToken(node2) {
	        switch (node2.parent.kind) {
	          case 218 /* FunctionExpression */:
	          case 262 /* FunctionDeclaration */:
	          case 219 /* ArrowFunction */:
	          case 174 /* MethodDeclaration */:
	          case 173 /* MethodSignature */:
	          case 177 /* GetAccessor */:
	          case 178 /* SetAccessor */:
	          case 176 /* Constructor */:
	          case 247 /* WhileStatement */:
	          case 246 /* DoStatement */:
	          case 248 /* ForStatement */:
	          case 250 /* ForOfStatement */:
	          case 213 /* CallExpression */:
	          case 214 /* NewExpression */:
	          case 217 /* ParenthesizedExpression */:
	            return spanInPreviousNode(node2);
	          default:
	            return spanInNode(node2.parent);
	        }
	      }
	      function spanInColonToken(node2) {
	        if (isFunctionLike(node2.parent) || node2.parent.kind === 303 /* PropertyAssignment */ || node2.parent.kind === 169 /* Parameter */) {
	          return spanInPreviousNode(node2);
	        }
	        return spanInNode(node2.parent);
	      }
	      function spanInGreaterThanOrLessThanToken(node2) {
	        if (node2.parent.kind === 216 /* TypeAssertionExpression */) {
	          return spanInNextNode(node2);
	        }
	        return spanInNode(node2.parent);
	      }
	      function spanInWhileKeyword(node2) {
	        if (node2.parent.kind === 246 /* DoStatement */) {
	          return textSpanEndingAtNextToken(node2, node2.parent.expression);
	        }
	        return spanInNode(node2.parent);
	      }
	      function spanInOfKeyword(node2) {
	        if (node2.parent.kind === 250 /* ForOfStatement */) {
	          return spanInNextNode(node2);
	        }
	        return spanInNode(node2.parent);
	      }
	    }
	  }
	  var init_breakpoints = __esm({
	    "src/services/breakpoints.ts"() {
	      init_ts4();
	    }
	  });

	  // src/services/_namespaces/ts.BreakpointResolver.ts
	  var ts_BreakpointResolver_exports = {};
	  __export(ts_BreakpointResolver_exports, {
	    spanInSourceFileAtLocation: () => spanInSourceFileAtLocation
	  });
	  var init_ts_BreakpointResolver = __esm({
	    "src/services/_namespaces/ts.BreakpointResolver.ts"() {
	      init_breakpoints();
	    }
	  });

	  // src/services/callHierarchy.ts
	  function isNamedExpression(node) {
	    return (isFunctionExpression(node) || isClassExpression(node)) && isNamedDeclaration(node);
	  }
	  function isVariableLike2(node) {
	    return isPropertyDeclaration(node) || isVariableDeclaration(node);
	  }
	  function isAssignedExpression(node) {
	    return (isFunctionExpression(node) || isArrowFunction(node) || isClassExpression(node)) && isVariableLike2(node.parent) && node === node.parent.initializer && isIdentifier(node.parent.name) && (!!(getCombinedNodeFlags(node.parent) & 2 /* Const */) || isPropertyDeclaration(node.parent));
	  }
	  function isPossibleCallHierarchyDeclaration(node) {
	    return isSourceFile(node) || isModuleDeclaration(node) || isFunctionDeclaration(node) || isFunctionExpression(node) || isClassDeclaration(node) || isClassExpression(node) || isClassStaticBlockDeclaration(node) || isMethodDeclaration(node) || isMethodSignature(node) || isGetAccessorDeclaration(node) || isSetAccessorDeclaration(node);
	  }
	  function isValidCallHierarchyDeclaration(node) {
	    return isSourceFile(node) || isModuleDeclaration(node) && isIdentifier(node.name) || isFunctionDeclaration(node) || isClassDeclaration(node) || isClassStaticBlockDeclaration(node) || isMethodDeclaration(node) || isMethodSignature(node) || isGetAccessorDeclaration(node) || isSetAccessorDeclaration(node) || isNamedExpression(node) || isAssignedExpression(node);
	  }
	  function getCallHierarchyDeclarationReferenceNode(node) {
	    if (isSourceFile(node))
	      return node;
	    if (isNamedDeclaration(node))
	      return node.name;
	    if (isAssignedExpression(node))
	      return node.parent.name;
	    return Debug.checkDefined(node.modifiers && find(node.modifiers, isDefaultModifier3));
	  }
	  function isDefaultModifier3(node) {
	    return node.kind === 90 /* DefaultKeyword */;
	  }
	  function getSymbolOfCallHierarchyDeclaration(typeChecker, node) {
	    const location = getCallHierarchyDeclarationReferenceNode(node);
	    return location && typeChecker.getSymbolAtLocation(location);
	  }
	  function getCallHierarchyItemName(program, node) {
	    if (isSourceFile(node)) {
	      return { text: node.fileName, pos: 0, end: 0 };
	    }
	    if ((isFunctionDeclaration(node) || isClassDeclaration(node)) && !isNamedDeclaration(node)) {
	      const defaultModifier = node.modifiers && find(node.modifiers, isDefaultModifier3);
	      if (defaultModifier) {
	        return { text: "default", pos: defaultModifier.getStart(), end: defaultModifier.getEnd() };
	      }
	    }
	    if (isClassStaticBlockDeclaration(node)) {
	      const sourceFile = node.getSourceFile();
	      const pos = skipTrivia(sourceFile.text, moveRangePastModifiers(node).pos);
	      const end = pos + 6;
	      const typeChecker = program.getTypeChecker();
	      const symbol = typeChecker.getSymbolAtLocation(node.parent);
	      const prefix = symbol ? `${typeChecker.symbolToString(symbol, node.parent)} ` : "";
	      return { text: `${prefix}static {}`, pos, end };
	    }
	    const declName = isAssignedExpression(node) ? node.parent.name : Debug.checkDefined(getNameOfDeclaration(node), "Expected call hierarchy item to have a name");
	    let text = isIdentifier(declName) ? idText(declName) : isStringOrNumericLiteralLike(declName) ? declName.text : isComputedPropertyName(declName) ? isStringOrNumericLiteralLike(declName.expression) ? declName.expression.text : void 0 : void 0;
	    if (text === void 0) {
	      const typeChecker = program.getTypeChecker();
	      const symbol = typeChecker.getSymbolAtLocation(declName);
	      if (symbol) {
	        text = typeChecker.symbolToString(symbol, node);
	      }
	    }
	    if (text === void 0) {
	      const printer = createPrinterWithRemoveCommentsOmitTrailingSemicolon();
	      text = usingSingleLineStringWriter((writer) => printer.writeNode(4 /* Unspecified */, node, node.getSourceFile(), writer));
	    }
	    return { text, pos: declName.getStart(), end: declName.getEnd() };
	  }
	  function getCallHierarchItemContainerName(node) {
	    var _a, _b, _c, _d;
	    if (isAssignedExpression(node)) {
	      if (isPropertyDeclaration(node.parent) && isClassLike(node.parent.parent)) {
	        return isClassExpression(node.parent.parent) ? (_a = getAssignedName(node.parent.parent)) == null ? void 0 : _a.getText() : (_b = node.parent.parent.name) == null ? void 0 : _b.getText();
	      }
	      if (isModuleBlock(node.parent.parent.parent.parent) && isIdentifier(node.parent.parent.parent.parent.parent.name)) {
	        return node.parent.parent.parent.parent.parent.name.getText();
	      }
	      return;
	    }
	    switch (node.kind) {
	      case 177 /* GetAccessor */:
	      case 178 /* SetAccessor */:
	      case 174 /* MethodDeclaration */:
	        if (node.parent.kind === 210 /* ObjectLiteralExpression */) {
	          return (_c = getAssignedName(node.parent)) == null ? void 0 : _c.getText();
	        }
	        return (_d = getNameOfDeclaration(node.parent)) == null ? void 0 : _d.getText();
	      case 262 /* FunctionDeclaration */:
	      case 263 /* ClassDeclaration */:
	      case 267 /* ModuleDeclaration */:
	        if (isModuleBlock(node.parent) && isIdentifier(node.parent.parent.name)) {
	          return node.parent.parent.name.getText();
	        }
	    }
	  }
	  function findImplementation(typeChecker, node) {
	    if (node.body) {
	      return node;
	    }
	    if (isConstructorDeclaration(node)) {
	      return getFirstConstructorWithBody(node.parent);
	    }
	    if (isFunctionDeclaration(node) || isMethodDeclaration(node)) {
	      const symbol = getSymbolOfCallHierarchyDeclaration(typeChecker, node);
	      if (symbol && symbol.valueDeclaration && isFunctionLikeDeclaration(symbol.valueDeclaration) && symbol.valueDeclaration.body) {
	        return symbol.valueDeclaration;
	      }
	      return void 0;
	    }
	    return node;
	  }
	  function findAllInitialDeclarations(typeChecker, node) {
	    const symbol = getSymbolOfCallHierarchyDeclaration(typeChecker, node);
	    let declarations;
	    if (symbol && symbol.declarations) {
	      const indices = indicesOf(symbol.declarations);
	      const keys = map(symbol.declarations, (decl) => ({ file: decl.getSourceFile().fileName, pos: decl.pos }));
	      indices.sort((a, b) => compareStringsCaseSensitive(keys[a].file, keys[b].file) || keys[a].pos - keys[b].pos);
	      const sortedDeclarations = map(indices, (i) => symbol.declarations[i]);
	      let lastDecl;
	      for (const decl of sortedDeclarations) {
	        if (isValidCallHierarchyDeclaration(decl)) {
	          if (!lastDecl || lastDecl.parent !== decl.parent || lastDecl.end !== decl.pos) {
	            declarations = append(declarations, decl);
	          }
	          lastDecl = decl;
	        }
	      }
	    }
	    return declarations;
	  }
	  function findImplementationOrAllInitialDeclarations(typeChecker, node) {
	    if (isClassStaticBlockDeclaration(node)) {
	      return node;
	    }
	    if (isFunctionLikeDeclaration(node)) {
	      return findImplementation(typeChecker, node) ?? findAllInitialDeclarations(typeChecker, node) ?? node;
	    }
	    return findAllInitialDeclarations(typeChecker, node) ?? node;
	  }
	  function resolveCallHierarchyDeclaration(program, location) {
	    const typeChecker = program.getTypeChecker();
	    let followingSymbol = false;
	    while (true) {
	      if (isValidCallHierarchyDeclaration(location)) {
	        return findImplementationOrAllInitialDeclarations(typeChecker, location);
	      }
	      if (isPossibleCallHierarchyDeclaration(location)) {
	        const ancestor = findAncestor(location, isValidCallHierarchyDeclaration);
	        return ancestor && findImplementationOrAllInitialDeclarations(typeChecker, ancestor);
	      }
	      if (isDeclarationName(location)) {
	        if (isValidCallHierarchyDeclaration(location.parent)) {
	          return findImplementationOrAllInitialDeclarations(typeChecker, location.parent);
	        }
	        if (isPossibleCallHierarchyDeclaration(location.parent)) {
	          const ancestor = findAncestor(location.parent, isValidCallHierarchyDeclaration);
	          return ancestor && findImplementationOrAllInitialDeclarations(typeChecker, ancestor);
	        }
	        if (isVariableLike2(location.parent) && location.parent.initializer && isAssignedExpression(location.parent.initializer)) {
	          return location.parent.initializer;
	        }
	        return void 0;
	      }
	      if (isConstructorDeclaration(location)) {
	        if (isValidCallHierarchyDeclaration(location.parent)) {
	          return location.parent;
	        }
	        return void 0;
	      }
	      if (location.kind === 126 /* StaticKeyword */ && isClassStaticBlockDeclaration(location.parent)) {
	        location = location.parent;
	        continue;
	      }
	      if (isVariableDeclaration(location) && location.initializer && isAssignedExpression(location.initializer)) {
	        return location.initializer;
	      }
	      if (!followingSymbol) {
	        let symbol = typeChecker.getSymbolAtLocation(location);
	        if (symbol) {
	          if (symbol.flags & 2097152 /* Alias */) {
	            symbol = typeChecker.getAliasedSymbol(symbol);
	          }
	          if (symbol.valueDeclaration) {
	            followingSymbol = true;
	            location = symbol.valueDeclaration;
	            continue;
	          }
	        }
	      }
	      return void 0;
	    }
	  }
	  function createCallHierarchyItem(program, node) {
	    const sourceFile = node.getSourceFile();
	    const name = getCallHierarchyItemName(program, node);
	    const containerName = getCallHierarchItemContainerName(node);
	    const kind = getNodeKind(node);
	    const kindModifiers = getNodeModifiers(node);
	    const span = createTextSpanFromBounds(skipTrivia(
	      sourceFile.text,
	      node.getFullStart(),
	      /*stopAfterLineBreak*/
	      false,
	      /*stopAtComments*/
	      true
	    ), node.getEnd());
	    const selectionSpan = createTextSpanFromBounds(name.pos, name.end);
	    return { file: sourceFile.fileName, kind, kindModifiers, name: name.text, containerName, span, selectionSpan };
	  }
	  function isDefined(x) {
	    return x !== void 0;
	  }
	  function convertEntryToCallSite(entry) {
	    if (entry.kind === ts_FindAllReferences_exports.EntryKind.Node) {
	      const { node } = entry;
	      if (isCallOrNewExpressionTarget(
	        node,
	        /*includeElementAccess*/
	        true,
	        /*skipPastOuterExpressions*/
	        true
	      ) || isTaggedTemplateTag(
	        node,
	        /*includeElementAccess*/
	        true,
	        /*skipPastOuterExpressions*/
	        true
	      ) || isDecoratorTarget(
	        node,
	        /*includeElementAccess*/
	        true,
	        /*skipPastOuterExpressions*/
	        true
	      ) || isJsxOpeningLikeElementTagName(
	        node,
	        /*includeElementAccess*/
	        true,
	        /*skipPastOuterExpressions*/
	        true
	      ) || isRightSideOfPropertyAccess(node) || isArgumentExpressionOfElementAccess(node)) {
	        const sourceFile = node.getSourceFile();
	        const ancestor = findAncestor(node, isValidCallHierarchyDeclaration) || sourceFile;
	        return { declaration: ancestor, range: createTextRangeFromNode(node, sourceFile) };
	      }
	    }
	  }
	  function getCallSiteGroupKey(entry) {
	    return getNodeId(entry.declaration);
	  }
	  function createCallHierarchyIncomingCall(from, fromSpans) {
	    return { from, fromSpans };
	  }
	  function convertCallSiteGroupToIncomingCall(program, entries) {
	    return createCallHierarchyIncomingCall(createCallHierarchyItem(program, entries[0].declaration), map(entries, (entry) => createTextSpanFromRange(entry.range)));
	  }
	  function getIncomingCalls(program, declaration, cancellationToken) {
	    if (isSourceFile(declaration) || isModuleDeclaration(declaration) || isClassStaticBlockDeclaration(declaration)) {
	      return [];
	    }
	    const location = getCallHierarchyDeclarationReferenceNode(declaration);
	    const calls = filter(ts_FindAllReferences_exports.findReferenceOrRenameEntries(
	      program,
	      cancellationToken,
	      program.getSourceFiles(),
	      location,
	      /*position*/
	      0,
	      { use: ts_FindAllReferences_exports.FindReferencesUse.References },
	      convertEntryToCallSite
	    ), isDefined);
	    return calls ? group(calls, getCallSiteGroupKey, (entries) => convertCallSiteGroupToIncomingCall(program, entries)) : [];
	  }
	  function createCallSiteCollector(program, callSites) {
	    function recordCallSite(node) {
	      const target = isTaggedTemplateExpression(node) ? node.tag : isJsxOpeningLikeElement(node) ? node.tagName : isAccessExpression(node) ? node : isClassStaticBlockDeclaration(node) ? node : node.expression;
	      const declaration = resolveCallHierarchyDeclaration(program, target);
	      if (declaration) {
	        const range = createTextRangeFromNode(target, node.getSourceFile());
	        if (isArray(declaration)) {
	          for (const decl of declaration) {
	            callSites.push({ declaration: decl, range });
	          }
	        } else {
	          callSites.push({ declaration, range });
	        }
	      }
	    }
	    function collect(node) {
	      if (!node)
	        return;
	      if (node.flags & 33554432 /* Ambient */) {
	        return;
	      }
	      if (isValidCallHierarchyDeclaration(node)) {
	        if (isClassLike(node)) {
	          for (const member of node.members) {
	            if (member.name && isComputedPropertyName(member.name)) {
	              collect(member.name.expression);
	            }
	          }
	        }
	        return;
	      }
	      switch (node.kind) {
	        case 80 /* Identifier */:
	        case 271 /* ImportEqualsDeclaration */:
	        case 272 /* ImportDeclaration */:
	        case 278 /* ExportDeclaration */:
	        case 264 /* InterfaceDeclaration */:
	        case 265 /* TypeAliasDeclaration */:
	          return;
	        case 175 /* ClassStaticBlockDeclaration */:
	          recordCallSite(node);
	          return;
	        case 216 /* TypeAssertionExpression */:
	        case 234 /* AsExpression */:
	          collect(node.expression);
	          return;
	        case 260 /* VariableDeclaration */:
	        case 169 /* Parameter */:
	          collect(node.name);
	          collect(node.initializer);
	          return;
	        case 213 /* CallExpression */:
	          recordCallSite(node);
	          collect(node.expression);
	          forEach(node.arguments, collect);
	          return;
	        case 214 /* NewExpression */:
	          recordCallSite(node);
	          collect(node.expression);
	          forEach(node.arguments, collect);
	          return;
	        case 215 /* TaggedTemplateExpression */:
	          recordCallSite(node);
	          collect(node.tag);
	          collect(node.template);
	          return;
	        case 286 /* JsxOpeningElement */:
	        case 285 /* JsxSelfClosingElement */:
	          recordCallSite(node);
	          collect(node.tagName);
	          collect(node.attributes);
	          return;
	        case 170 /* Decorator */:
	          recordCallSite(node);
	          collect(node.expression);
	          return;
	        case 211 /* PropertyAccessExpression */:
	        case 212 /* ElementAccessExpression */:
	          recordCallSite(node);
	          forEachChild(node, collect);
	          break;
	        case 238 /* SatisfiesExpression */:
	          collect(node.expression);
	          return;
	      }
	      if (isPartOfTypeNode(node)) {
	        return;
	      }
	      forEachChild(node, collect);
	    }
	    return collect;
	  }
	  function collectCallSitesOfSourceFile(node, collect) {
	    forEach(node.statements, collect);
	  }
	  function collectCallSitesOfModuleDeclaration(node, collect) {
	    if (!hasSyntacticModifier(node, 128 /* Ambient */) && node.body && isModuleBlock(node.body)) {
	      forEach(node.body.statements, collect);
	    }
	  }
	  function collectCallSitesOfFunctionLikeDeclaration(typeChecker, node, collect) {
	    const implementation = findImplementation(typeChecker, node);
	    if (implementation) {
	      forEach(implementation.parameters, collect);
	      collect(implementation.body);
	    }
	  }
	  function collectCallSitesOfClassStaticBlockDeclaration(node, collect) {
	    collect(node.body);
	  }
	  function collectCallSitesOfClassLikeDeclaration(node, collect) {
	    forEach(node.modifiers, collect);
	    const heritage = getClassExtendsHeritageElement(node);
	    if (heritage) {
	      collect(heritage.expression);
	    }
	    for (const member of node.members) {
	      if (canHaveModifiers(member)) {
	        forEach(member.modifiers, collect);
	      }
	      if (isPropertyDeclaration(member)) {
	        collect(member.initializer);
	      } else if (isConstructorDeclaration(member) && member.body) {
	        forEach(member.parameters, collect);
	        collect(member.body);
	      } else if (isClassStaticBlockDeclaration(member)) {
	        collect(member);
	      }
	    }
	  }
	  function collectCallSites(program, node) {
	    const callSites = [];
	    const collect = createCallSiteCollector(program, callSites);
	    switch (node.kind) {
	      case 312 /* SourceFile */:
	        collectCallSitesOfSourceFile(node, collect);
	        break;
	      case 267 /* ModuleDeclaration */:
	        collectCallSitesOfModuleDeclaration(node, collect);
	        break;
	      case 262 /* FunctionDeclaration */:
	      case 218 /* FunctionExpression */:
	      case 219 /* ArrowFunction */:
	      case 174 /* MethodDeclaration */:
	      case 177 /* GetAccessor */:
	      case 178 /* SetAccessor */:
	        collectCallSitesOfFunctionLikeDeclaration(program.getTypeChecker(), node, collect);
	        break;
	      case 263 /* ClassDeclaration */:
	      case 231 /* ClassExpression */:
	        collectCallSitesOfClassLikeDeclaration(node, collect);
	        break;
	      case 175 /* ClassStaticBlockDeclaration */:
	        collectCallSitesOfClassStaticBlockDeclaration(node, collect);
	        break;
	      default:
	        Debug.assertNever(node);
	    }
	    return callSites;
	  }
	  function createCallHierarchyOutgoingCall(to, fromSpans) {
	    return { to, fromSpans };
	  }
	  function convertCallSiteGroupToOutgoingCall(program, entries) {
	    return createCallHierarchyOutgoingCall(createCallHierarchyItem(program, entries[0].declaration), map(entries, (entry) => createTextSpanFromRange(entry.range)));
	  }
	  function getOutgoingCalls(program, declaration) {
	    if (declaration.flags & 33554432 /* Ambient */ || isMethodSignature(declaration)) {
	      return [];
	    }
	    return group(collectCallSites(program, declaration), getCallSiteGroupKey, (entries) => convertCallSiteGroupToOutgoingCall(program, entries));
	  }
	  var init_callHierarchy = __esm({
	    "src/services/callHierarchy.ts"() {
	      init_ts4();
	    }
	  });

	  // src/services/_namespaces/ts.CallHierarchy.ts
	  var ts_CallHierarchy_exports = {};
	  __export(ts_CallHierarchy_exports, {
	    createCallHierarchyItem: () => createCallHierarchyItem,
	    getIncomingCalls: () => getIncomingCalls,
	    getOutgoingCalls: () => getOutgoingCalls,
	    resolveCallHierarchyDeclaration: () => resolveCallHierarchyDeclaration
	  });
	  var init_ts_CallHierarchy = __esm({
	    "src/services/_namespaces/ts.CallHierarchy.ts"() {
	      init_callHierarchy();
	    }
	  });

	  // src/services/_namespaces/ts.classifier.v2020.ts
	  var ts_classifier_v2020_exports = {};
	  __export(ts_classifier_v2020_exports, {
	    TokenEncodingConsts: () => TokenEncodingConsts,
	    TokenModifier: () => TokenModifier,
	    TokenType: () => TokenType,
	    getEncodedSemanticClassifications: () => getEncodedSemanticClassifications2,
	    getSemanticClassifications: () => getSemanticClassifications2
	  });
	  var init_ts_classifier_v2020 = __esm({
	    "src/services/_namespaces/ts.classifier.v2020.ts"() {
	      init_classifier2020();
	    }
	  });

	  // src/services/_namespaces/ts.classifier.ts
	  var ts_classifier_exports = {};
	  __export(ts_classifier_exports, {
	    v2020: () => ts_classifier_v2020_exports
	  });
	  var init_ts_classifier = __esm({
	    "src/services/_namespaces/ts.classifier.ts"() {
	      init_ts_classifier_v2020();
	    }
	  });

	  // src/services/codeFixProvider.ts
	  function createCodeFixActionWithoutFixAll(fixName8, changes, description3) {
	    return createCodeFixActionWorker(
	      fixName8,
	      diagnosticToString(description3),
	      changes,
	      /*fixId*/
	      void 0,
	      /*fixAllDescription*/
	      void 0
	    );
	  }
	  function createCodeFixAction(fixName8, changes, description3, fixId52, fixAllDescription, command) {
	    return createCodeFixActionWorker(fixName8, diagnosticToString(description3), changes, fixId52, diagnosticToString(fixAllDescription), command);
	  }
	  function createCodeFixActionMaybeFixAll(fixName8, changes, description3, fixId52, fixAllDescription, command) {
	    return createCodeFixActionWorker(fixName8, diagnosticToString(description3), changes, fixId52, fixAllDescription && diagnosticToString(fixAllDescription), command);
	  }
	  function createCodeFixActionWorker(fixName8, description3, changes, fixId52, fixAllDescription, command) {
	    return { fixName: fixName8, description: description3, changes, fixId: fixId52, fixAllDescription, commands: command ? [command] : void 0 };
	  }
	  function registerCodeFix(reg) {
	    for (const error2 of reg.errorCodes) {
	      errorCodeToFixesArray = void 0;
	      errorCodeToFixes.add(String(error2), reg);
	    }
	    if (reg.fixIds) {
	      for (const fixId52 of reg.fixIds) {
	        Debug.assert(!fixIdToRegistration.has(fixId52));
	        fixIdToRegistration.set(fixId52, reg);
	      }
	    }
	  }
	  function getSupportedErrorCodes() {
	    return errorCodeToFixesArray ?? (errorCodeToFixesArray = arrayFrom(errorCodeToFixes.keys()));
	  }
	  function removeFixIdIfFixAllUnavailable(registration, diagnostics) {
	    const { errorCodes: errorCodes65 } = registration;
	    let maybeFixableDiagnostics = 0;
	    for (const diag2 of diagnostics) {
	      if (contains(errorCodes65, diag2.code))
	        maybeFixableDiagnostics++;
	      if (maybeFixableDiagnostics > 1)
	        break;
	    }
	    const fixAllUnavailable = maybeFixableDiagnostics < 2;
	    return ({ fixId: fixId52, fixAllDescription, ...action }) => {
	      return fixAllUnavailable ? action : { ...action, fixId: fixId52, fixAllDescription };
	    };
	  }
	  function getFixes(context) {
	    const diagnostics = getDiagnostics(context);
	    const registrations = errorCodeToFixes.get(String(context.errorCode));
	    return flatMap(registrations, (f) => map(f.getCodeActions(context), removeFixIdIfFixAllUnavailable(f, diagnostics)));
	  }
	  function getAllFixes(context) {
	    return fixIdToRegistration.get(cast(context.fixId, isString)).getAllCodeActions(context);
	  }
	  function createCombinedCodeActions(changes, commands) {
	    return { changes, commands };
	  }
	  function createFileTextChanges(fileName, textChanges2) {
	    return { fileName, textChanges: textChanges2 };
	  }
	  function codeFixAll(context, errorCodes65, use) {
	    const commands = [];
	    const changes = ts_textChanges_exports.ChangeTracker.with(context, (t) => eachDiagnostic(context, errorCodes65, (diag2) => use(t, diag2, commands)));
	    return createCombinedCodeActions(changes, commands.length === 0 ? void 0 : commands);
	  }
	  function eachDiagnostic(context, errorCodes65, cb) {
	    for (const diag2 of getDiagnostics(context)) {
	      if (contains(errorCodes65, diag2.code)) {
	        cb(diag2);
	      }
	    }
	  }
	  function getDiagnostics({ program, sourceFile, cancellationToken }) {
	    return [
	      ...program.getSemanticDiagnostics(sourceFile, cancellationToken),
	      ...program.getSyntacticDiagnostics(sourceFile, cancellationToken),
	      ...computeSuggestionDiagnostics(sourceFile, program, cancellationToken)
	    ];
	  }
	  var errorCodeToFixes, fixIdToRegistration, errorCodeToFixesArray;
	  var init_codeFixProvider = __esm({
	    "src/services/codeFixProvider.ts"() {
	      init_ts4();
	      errorCodeToFixes = createMultiMap();
	      fixIdToRegistration = /* @__PURE__ */ new Map();
	    }
	  });

	  // src/services/codefixes/addConvertToUnknownForNonOverlappingTypes.ts
	  function makeChange(changeTracker, sourceFile, assertion) {
	    const replacement = isAsExpression(assertion) ? factory.createAsExpression(assertion.expression, factory.createKeywordTypeNode(159 /* UnknownKeyword */)) : factory.createTypeAssertion(factory.createKeywordTypeNode(159 /* UnknownKeyword */), assertion.expression);
	    changeTracker.replaceNode(sourceFile, assertion.expression, replacement);
	  }
	  function getAssertion(sourceFile, pos) {
	    if (isInJSFile(sourceFile))
	      return void 0;
	    return findAncestor(getTokenAtPosition(sourceFile, pos), (n) => isAsExpression(n) || isTypeAssertionExpression(n));
	  }
	  var fixId, errorCodes;
	  var init_addConvertToUnknownForNonOverlappingTypes = __esm({
	    "src/services/codefixes/addConvertToUnknownForNonOverlappingTypes.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      fixId = "addConvertToUnknownForNonOverlappingTypes";
	      errorCodes = [Diagnostics.Conversion_of_type_0_to_type_1_may_be_a_mistake_because_neither_type_sufficiently_overlaps_with_the_other_If_this_was_intentional_convert_the_expression_to_unknown_first.code];
	      registerCodeFix({
	        errorCodes,
	        getCodeActions: function getCodeActionsToAddConvertToUnknownForNonOverlappingTypes(context) {
	          const assertion = getAssertion(context.sourceFile, context.span.start);
	          if (assertion === void 0)
	            return void 0;
	          const changes = ts_textChanges_exports.ChangeTracker.with(context, (t) => makeChange(t, context.sourceFile, assertion));
	          return [createCodeFixAction(fixId, changes, Diagnostics.Add_unknown_conversion_for_non_overlapping_types, fixId, Diagnostics.Add_unknown_to_all_conversions_of_non_overlapping_types)];
	        },
	        fixIds: [fixId],
	        getAllCodeActions: (context) => codeFixAll(context, errorCodes, (changes, diag2) => {
	          const assertion = getAssertion(diag2.file, diag2.start);
	          if (assertion) {
	            makeChange(changes, diag2.file, assertion);
	          }
	        })
	      });
	    }
	  });

	  // src/services/codefixes/addEmptyExportDeclaration.ts
	  var init_addEmptyExportDeclaration = __esm({
	    "src/services/codefixes/addEmptyExportDeclaration.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      registerCodeFix({
	        errorCodes: [
	          Diagnostics.await_expressions_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_file_has_no_imports_or_exports_Consider_adding_an_empty_export_to_make_this_file_a_module.code,
	          Diagnostics.await_using_statements_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_file_has_no_imports_or_exports_Consider_adding_an_empty_export_to_make_this_file_a_module.code,
	          Diagnostics.for_await_loops_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_file_has_no_imports_or_exports_Consider_adding_an_empty_export_to_make_this_file_a_module.code
	        ],
	        getCodeActions: function getCodeActionsToAddEmptyExportDeclaration(context) {
	          const { sourceFile } = context;
	          const changes = ts_textChanges_exports.ChangeTracker.with(context, (changes2) => {
	            const exportDeclaration = factory.createExportDeclaration(
	              /*modifiers*/
	              void 0,
	              /*isTypeOnly*/
	              false,
	              factory.createNamedExports([]),
	              /*moduleSpecifier*/
	              void 0
	            );
	            changes2.insertNodeAtEndOfScope(sourceFile, sourceFile, exportDeclaration);
	          });
	          return [createCodeFixActionWithoutFixAll("addEmptyExportDeclaration", changes, Diagnostics.Add_export_to_make_this_file_into_a_module)];
	        }
	      });
	    }
	  });

	  // src/services/codefixes/addMissingAsync.ts
	  function getFix(context, decl, trackChanges, fixedDeclarations) {
	    const changes = trackChanges((t) => makeChange2(t, context.sourceFile, decl, fixedDeclarations));
	    return createCodeFixAction(fixId2, changes, Diagnostics.Add_async_modifier_to_containing_function, fixId2, Diagnostics.Add_all_missing_async_modifiers);
	  }
	  function makeChange2(changeTracker, sourceFile, insertionSite, fixedDeclarations) {
	    if (fixedDeclarations) {
	      if (fixedDeclarations.has(getNodeId(insertionSite))) {
	        return;
	      }
	    }
	    fixedDeclarations == null ? void 0 : fixedDeclarations.add(getNodeId(insertionSite));
	    const cloneWithModifier = factory.replaceModifiers(
	      getSynthesizedDeepClone(
	        insertionSite,
	        /*includeTrivia*/
	        true
	      ),
	      factory.createNodeArray(factory.createModifiersFromModifierFlags(getSyntacticModifierFlags(insertionSite) | 1024 /* Async */))
	    );
	    changeTracker.replaceNode(
	      sourceFile,
	      insertionSite,
	      cloneWithModifier
	    );
	  }
	  function getFixableErrorSpanDeclaration(sourceFile, span) {
	    if (!span)
	      return void 0;
	    const token = getTokenAtPosition(sourceFile, span.start);
	    const decl = findAncestor(token, (node) => {
	      if (node.getStart(sourceFile) < span.start || node.getEnd() > textSpanEnd(span)) {
	        return "quit";
	      }
	      return (isArrowFunction(node) || isMethodDeclaration(node) || isFunctionExpression(node) || isFunctionDeclaration(node)) && textSpansEqual(span, createTextSpanFromNode(node, sourceFile));
	    });
	    return decl;
	  }
	  function getIsMatchingAsyncError(span, errorCode) {
	    return ({ start, length: length2, relatedInformation, code }) => isNumber(start) && isNumber(length2) && textSpansEqual({ start, length: length2 }, span) && code === errorCode && !!relatedInformation && some(relatedInformation, (related) => related.code === Diagnostics.Did_you_mean_to_mark_this_function_as_async.code);
	  }
	  var fixId2, errorCodes2;
	  var init_addMissingAsync = __esm({
	    "src/services/codefixes/addMissingAsync.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      fixId2 = "addMissingAsync";
	      errorCodes2 = [
	        Diagnostics.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1.code,
	        Diagnostics.Type_0_is_not_assignable_to_type_1.code,
	        Diagnostics.Type_0_is_not_comparable_to_type_1.code
	      ];
	      registerCodeFix({
	        fixIds: [fixId2],
	        errorCodes: errorCodes2,
	        getCodeActions: function getCodeActionsToAddMissingAsync(context) {
	          const { sourceFile, errorCode, cancellationToken, program, span } = context;
	          const diagnostic = find(program.getTypeChecker().getDiagnostics(sourceFile, cancellationToken), getIsMatchingAsyncError(span, errorCode));
	          const directSpan = diagnostic && diagnostic.relatedInformation && find(diagnostic.relatedInformation, (r) => r.code === Diagnostics.Did_you_mean_to_mark_this_function_as_async.code);
	          const decl = getFixableErrorSpanDeclaration(sourceFile, directSpan);
	          if (!decl) {
	            return;
	          }
	          const trackChanges = (cb) => ts_textChanges_exports.ChangeTracker.with(context, cb);
	          return [getFix(context, decl, trackChanges)];
	        },
	        getAllCodeActions: (context) => {
	          const { sourceFile } = context;
	          const fixedDeclarations = /* @__PURE__ */ new Set();
	          return codeFixAll(context, errorCodes2, (t, diagnostic) => {
	            const span = diagnostic.relatedInformation && find(diagnostic.relatedInformation, (r) => r.code === Diagnostics.Did_you_mean_to_mark_this_function_as_async.code);
	            const decl = getFixableErrorSpanDeclaration(sourceFile, span);
	            if (!decl) {
	              return;
	            }
	            const trackChanges = (cb) => (cb(t), []);
	            return getFix(context, decl, trackChanges, fixedDeclarations);
	          });
	        }
	      });
	    }
	  });

	  // src/services/codefixes/addMissingAwait.ts
	  function getAwaitErrorSpanExpression(sourceFile, errorCode, span, cancellationToken, program) {
	    const expression = getFixableErrorSpanExpression(sourceFile, span);
	    return expression && isMissingAwaitError(sourceFile, errorCode, span, cancellationToken, program) && isInsideAwaitableBody(expression) ? expression : void 0;
	  }
	  function getDeclarationSiteFix(context, expression, errorCode, checker, trackChanges, fixedDeclarations) {
	    const { sourceFile, program, cancellationToken } = context;
	    const awaitableInitializers = findAwaitableInitializers(expression, sourceFile, cancellationToken, program, checker);
	    if (awaitableInitializers) {
	      const initializerChanges = trackChanges((t) => {
	        forEach(awaitableInitializers.initializers, ({ expression: expression2 }) => makeChange3(t, errorCode, sourceFile, checker, expression2, fixedDeclarations));
	        if (fixedDeclarations && awaitableInitializers.needsSecondPassForFixAll) {
	          makeChange3(t, errorCode, sourceFile, checker, expression, fixedDeclarations);
	        }
	      });
	      return createCodeFixActionWithoutFixAll(
	        "addMissingAwaitToInitializer",
	        initializerChanges,
	        awaitableInitializers.initializers.length === 1 ? [Diagnostics.Add_await_to_initializer_for_0, awaitableInitializers.initializers[0].declarationSymbol.name] : Diagnostics.Add_await_to_initializers
	      );
	    }
	  }
	  function getUseSiteFix(context, expression, errorCode, checker, trackChanges, fixedDeclarations) {
	    const changes = trackChanges((t) => makeChange3(t, errorCode, context.sourceFile, checker, expression, fixedDeclarations));
	    return createCodeFixAction(fixId3, changes, Diagnostics.Add_await, fixId3, Diagnostics.Fix_all_expressions_possibly_missing_await);
	  }
	  function isMissingAwaitError(sourceFile, errorCode, span, cancellationToken, program) {
	    const checker = program.getTypeChecker();
	    const diagnostics = checker.getDiagnostics(sourceFile, cancellationToken);
	    return some(diagnostics, ({ start, length: length2, relatedInformation, code }) => isNumber(start) && isNumber(length2) && textSpansEqual({ start, length: length2 }, span) && code === errorCode && !!relatedInformation && some(relatedInformation, (related) => related.code === Diagnostics.Did_you_forget_to_use_await.code));
	  }
	  function findAwaitableInitializers(expression, sourceFile, cancellationToken, program, checker) {
	    const identifiers = getIdentifiersFromErrorSpanExpression(expression, checker);
	    if (!identifiers) {
	      return;
	    }
	    let isCompleteFix = identifiers.isCompleteFix;
	    let initializers;
	    for (const identifier of identifiers.identifiers) {
	      const symbol = checker.getSymbolAtLocation(identifier);
	      if (!symbol) {
	        continue;
	      }
	      const declaration = tryCast(symbol.valueDeclaration, isVariableDeclaration);
	      const variableName = declaration && tryCast(declaration.name, isIdentifier);
	      const variableStatement = getAncestor(declaration, 243 /* VariableStatement */);
	      if (!declaration || !variableStatement || declaration.type || !declaration.initializer || variableStatement.getSourceFile() !== sourceFile || hasSyntacticModifier(variableStatement, 32 /* Export */) || !variableName || !isInsideAwaitableBody(declaration.initializer)) {
	        isCompleteFix = false;
	        continue;
	      }
	      const diagnostics = program.getSemanticDiagnostics(sourceFile, cancellationToken);
	      const isUsedElsewhere = ts_FindAllReferences_exports.Core.eachSymbolReferenceInFile(variableName, checker, sourceFile, (reference) => {
	        return identifier !== reference && !symbolReferenceIsAlsoMissingAwait(reference, diagnostics, sourceFile, checker);
	      });
	      if (isUsedElsewhere) {
	        isCompleteFix = false;
	        continue;
	      }
	      (initializers || (initializers = [])).push({
	        expression: declaration.initializer,
	        declarationSymbol: symbol
	      });
	    }
	    return initializers && {
	      initializers,
	      needsSecondPassForFixAll: !isCompleteFix
	    };
	  }
	  function getIdentifiersFromErrorSpanExpression(expression, checker) {
	    if (isPropertyAccessExpression(expression.parent) && isIdentifier(expression.parent.expression)) {
	      return { identifiers: [expression.parent.expression], isCompleteFix: true };
	    }
	    if (isIdentifier(expression)) {
	      return { identifiers: [expression], isCompleteFix: true };
	    }
	    if (isBinaryExpression(expression)) {
	      let sides;
	      let isCompleteFix = true;
	      for (const side of [expression.left, expression.right]) {
	        const type = checker.getTypeAtLocation(side);
	        if (checker.getPromisedTypeOfPromise(type)) {
	          if (!isIdentifier(side)) {
	            isCompleteFix = false;
	            continue;
	          }
	          (sides || (sides = [])).push(side);
	        }
	      }
	      return sides && { identifiers: sides, isCompleteFix };
	    }
	  }
	  function symbolReferenceIsAlsoMissingAwait(reference, diagnostics, sourceFile, checker) {
	    const errorNode = isPropertyAccessExpression(reference.parent) ? reference.parent.name : isBinaryExpression(reference.parent) ? reference.parent : reference;
	    const diagnostic = find(diagnostics, (diagnostic2) => diagnostic2.start === errorNode.getStart(sourceFile) && diagnostic2.start + diagnostic2.length === errorNode.getEnd());
	    return diagnostic && contains(errorCodes3, diagnostic.code) || // A Promise is usually not correct in a binary expression (it's not valid
	    // in an arithmetic expression and an equality comparison seems unusual),
	    // but if the other side of the binary expression has an error, the side
	    // is typed `any` which will squash the error that would identify this
	    // Promise as an invalid operand. So if the whole binary expression is
	    // typed `any` as a result, there is a strong likelihood that this Promise
	    // is accidentally missing `await`.
	    checker.getTypeAtLocation(errorNode).flags & 1 /* Any */;
	  }
	  function isInsideAwaitableBody(node) {
	    return node.flags & 65536 /* AwaitContext */ || !!findAncestor(node, (ancestor) => ancestor.parent && isArrowFunction(ancestor.parent) && ancestor.parent.body === ancestor || isBlock(ancestor) && (ancestor.parent.kind === 262 /* FunctionDeclaration */ || ancestor.parent.kind === 218 /* FunctionExpression */ || ancestor.parent.kind === 219 /* ArrowFunction */ || ancestor.parent.kind === 174 /* MethodDeclaration */));
	  }
	  function makeChange3(changeTracker, errorCode, sourceFile, checker, insertionSite, fixedDeclarations) {
	    if (isForOfStatement(insertionSite.parent) && !insertionSite.parent.awaitModifier) {
	      const exprType = checker.getTypeAtLocation(insertionSite);
	      const asyncIter = checker.getAsyncIterableType();
	      if (asyncIter && checker.isTypeAssignableTo(exprType, asyncIter)) {
	        const forOf = insertionSite.parent;
	        changeTracker.replaceNode(sourceFile, forOf, factory.updateForOfStatement(forOf, factory.createToken(135 /* AwaitKeyword */), forOf.initializer, forOf.expression, forOf.statement));
	        return;
	      }
	    }
	    if (isBinaryExpression(insertionSite)) {
	      for (const side of [insertionSite.left, insertionSite.right]) {
	        if (fixedDeclarations && isIdentifier(side)) {
	          const symbol = checker.getSymbolAtLocation(side);
	          if (symbol && fixedDeclarations.has(getSymbolId(symbol))) {
	            continue;
	          }
	        }
	        const type = checker.getTypeAtLocation(side);
	        const newNode = checker.getPromisedTypeOfPromise(type) ? factory.createAwaitExpression(side) : side;
	        changeTracker.replaceNode(sourceFile, side, newNode);
	      }
	    } else if (errorCode === propertyAccessCode && isPropertyAccessExpression(insertionSite.parent)) {
	      if (fixedDeclarations && isIdentifier(insertionSite.parent.expression)) {
	        const symbol = checker.getSymbolAtLocation(insertionSite.parent.expression);
	        if (symbol && fixedDeclarations.has(getSymbolId(symbol))) {
	          return;
	        }
	      }
	      changeTracker.replaceNode(
	        sourceFile,
	        insertionSite.parent.expression,
	        factory.createParenthesizedExpression(factory.createAwaitExpression(insertionSite.parent.expression))
	      );
	      insertLeadingSemicolonIfNeeded(changeTracker, insertionSite.parent.expression, sourceFile);
	    } else if (contains(callableConstructableErrorCodes, errorCode) && isCallOrNewExpression(insertionSite.parent)) {
	      if (fixedDeclarations && isIdentifier(insertionSite)) {
	        const symbol = checker.getSymbolAtLocation(insertionSite);
	        if (symbol && fixedDeclarations.has(getSymbolId(symbol))) {
	          return;
	        }
	      }
	      changeTracker.replaceNode(sourceFile, insertionSite, factory.createParenthesizedExpression(factory.createAwaitExpression(insertionSite)));
	      insertLeadingSemicolonIfNeeded(changeTracker, insertionSite, sourceFile);
	    } else {
	      if (fixedDeclarations && isVariableDeclaration(insertionSite.parent) && isIdentifier(insertionSite.parent.name)) {
	        const symbol = checker.getSymbolAtLocation(insertionSite.parent.name);
	        if (symbol && !tryAddToSet(fixedDeclarations, getSymbolId(symbol))) {
	          return;
	        }
	      }
	      changeTracker.replaceNode(sourceFile, insertionSite, factory.createAwaitExpression(insertionSite));
	    }
	  }
	  function insertLeadingSemicolonIfNeeded(changeTracker, beforeNode, sourceFile) {
	    const precedingToken = findPrecedingToken(beforeNode.pos, sourceFile);
	    if (precedingToken && positionIsASICandidate(precedingToken.end, precedingToken.parent, sourceFile)) {
	      changeTracker.insertText(sourceFile, beforeNode.getStart(sourceFile), ";");
	    }
	  }
	  var fixId3, propertyAccessCode, callableConstructableErrorCodes, errorCodes3;
	  var init_addMissingAwait = __esm({
	    "src/services/codefixes/addMissingAwait.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      fixId3 = "addMissingAwait";
	      propertyAccessCode = Diagnostics.Property_0_does_not_exist_on_type_1.code;
	      callableConstructableErrorCodes = [
	        Diagnostics.This_expression_is_not_callable.code,
	        Diagnostics.This_expression_is_not_constructable.code
	      ];
	      errorCodes3 = [
	        Diagnostics.An_arithmetic_operand_must_be_of_type_any_number_bigint_or_an_enum_type.code,
	        Diagnostics.The_left_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type.code,
	        Diagnostics.The_right_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type.code,
	        Diagnostics.Operator_0_cannot_be_applied_to_type_1.code,
	        Diagnostics.Operator_0_cannot_be_applied_to_types_1_and_2.code,
	        Diagnostics.This_comparison_appears_to_be_unintentional_because_the_types_0_and_1_have_no_overlap.code,
	        Diagnostics.This_condition_will_always_return_true_since_this_0_is_always_defined.code,
	        Diagnostics.Type_0_is_not_an_array_type.code,
	        Diagnostics.Type_0_is_not_an_array_type_or_a_string_type.code,
	        Diagnostics.Type_0_can_only_be_iterated_through_when_using_the_downlevelIteration_flag_or_with_a_target_of_es2015_or_higher.code,
	        Diagnostics.Type_0_is_not_an_array_type_or_a_string_type_or_does_not_have_a_Symbol_iterator_method_that_returns_an_iterator.code,
	        Diagnostics.Type_0_is_not_an_array_type_or_does_not_have_a_Symbol_iterator_method_that_returns_an_iterator.code,
	        Diagnostics.Type_0_must_have_a_Symbol_iterator_method_that_returns_an_iterator.code,
	        Diagnostics.Type_0_must_have_a_Symbol_asyncIterator_method_that_returns_an_async_iterator.code,
	        Diagnostics.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1.code,
	        propertyAccessCode,
	        ...callableConstructableErrorCodes
	      ];
	      registerCodeFix({
	        fixIds: [fixId3],
	        errorCodes: errorCodes3,
	        getCodeActions: function getCodeActionsToAddMissingAwait(context) {
	          const { sourceFile, errorCode, span, cancellationToken, program } = context;
	          const expression = getAwaitErrorSpanExpression(sourceFile, errorCode, span, cancellationToken, program);
	          if (!expression) {
	            return;
	          }
	          const checker = context.program.getTypeChecker();
	          const trackChanges = (cb) => ts_textChanges_exports.ChangeTracker.with(context, cb);
	          return compact([
	            getDeclarationSiteFix(context, expression, errorCode, checker, trackChanges),
	            getUseSiteFix(context, expression, errorCode, checker, trackChanges)
	          ]);
	        },
	        getAllCodeActions: (context) => {
	          const { sourceFile, program, cancellationToken } = context;
	          const checker = context.program.getTypeChecker();
	          const fixedDeclarations = /* @__PURE__ */ new Set();
	          return codeFixAll(context, errorCodes3, (t, diagnostic) => {
	            const expression = getAwaitErrorSpanExpression(sourceFile, diagnostic.code, diagnostic, cancellationToken, program);
	            if (!expression) {
	              return;
	            }
	            const trackChanges = (cb) => (cb(t), []);
	            return getDeclarationSiteFix(context, expression, diagnostic.code, checker, trackChanges, fixedDeclarations) || getUseSiteFix(context, expression, diagnostic.code, checker, trackChanges, fixedDeclarations);
	          });
	        }
	      });
	    }
	  });

	  // src/services/codefixes/addMissingConst.ts
	  function makeChange4(changeTracker, sourceFile, pos, program, fixedNodes) {
	    const token = getTokenAtPosition(sourceFile, pos);
	    const forInitializer = findAncestor(token, (node) => isForInOrOfStatement(node.parent) ? node.parent.initializer === node : isPossiblyPartOfDestructuring(node) ? false : "quit");
	    if (forInitializer)
	      return applyChange(changeTracker, forInitializer, sourceFile, fixedNodes);
	    const parent2 = token.parent;
	    if (isBinaryExpression(parent2) && parent2.operatorToken.kind === 64 /* EqualsToken */ && isExpressionStatement(parent2.parent)) {
	      return applyChange(changeTracker, token, sourceFile, fixedNodes);
	    }
	    if (isArrayLiteralExpression(parent2)) {
	      const checker = program.getTypeChecker();
	      if (!every(parent2.elements, (element) => arrayElementCouldBeVariableDeclaration(element, checker))) {
	        return;
	      }
	      return applyChange(changeTracker, parent2, sourceFile, fixedNodes);
	    }
	    const commaExpression = findAncestor(token, (node) => isExpressionStatement(node.parent) ? true : isPossiblyPartOfCommaSeperatedInitializer(node) ? false : "quit");
	    if (commaExpression) {
	      const checker = program.getTypeChecker();
	      if (!expressionCouldBeVariableDeclaration(commaExpression, checker)) {
	        return;
	      }
	      return applyChange(changeTracker, commaExpression, sourceFile, fixedNodes);
	    }
	  }
	  function applyChange(changeTracker, initializer, sourceFile, fixedNodes) {
	    if (!fixedNodes || tryAddToSet(fixedNodes, initializer)) {
	      changeTracker.insertModifierBefore(sourceFile, 87 /* ConstKeyword */, initializer);
	    }
	  }
	  function isPossiblyPartOfDestructuring(node) {
	    switch (node.kind) {
	      case 80 /* Identifier */:
	      case 209 /* ArrayLiteralExpression */:
	      case 210 /* ObjectLiteralExpression */:
	      case 303 /* PropertyAssignment */:
	      case 304 /* ShorthandPropertyAssignment */:
	        return true;
	      default:
	        return false;
	    }
	  }
	  function arrayElementCouldBeVariableDeclaration(expression, checker) {
	    const identifier = isIdentifier(expression) ? expression : isAssignmentExpression(
	      expression,
	      /*excludeCompoundAssignment*/
	      true
	    ) && isIdentifier(expression.left) ? expression.left : void 0;
	    return !!identifier && !checker.getSymbolAtLocation(identifier);
	  }
	  function isPossiblyPartOfCommaSeperatedInitializer(node) {
	    switch (node.kind) {
	      case 80 /* Identifier */:
	      case 226 /* BinaryExpression */:
	      case 28 /* CommaToken */:
	        return true;
	      default:
	        return false;
	    }
	  }
	  function expressionCouldBeVariableDeclaration(expression, checker) {
	    if (!isBinaryExpression(expression)) {
	      return false;
	    }
	    if (expression.operatorToken.kind === 28 /* CommaToken */) {
	      return every([expression.left, expression.right], (expression2) => expressionCouldBeVariableDeclaration(expression2, checker));
	    }
	    return expression.operatorToken.kind === 64 /* EqualsToken */ && isIdentifier(expression.left) && !checker.getSymbolAtLocation(expression.left);
	  }
	  var fixId4, errorCodes4;
	  var init_addMissingConst = __esm({
	    "src/services/codefixes/addMissingConst.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      fixId4 = "addMissingConst";
	      errorCodes4 = [
	        Diagnostics.Cannot_find_name_0.code,
	        Diagnostics.No_value_exists_in_scope_for_the_shorthand_property_0_Either_declare_one_or_provide_an_initializer.code
	      ];
	      registerCodeFix({
	        errorCodes: errorCodes4,
	        getCodeActions: function getCodeActionsToAddMissingConst(context) {
	          const changes = ts_textChanges_exports.ChangeTracker.with(context, (t) => makeChange4(t, context.sourceFile, context.span.start, context.program));
	          if (changes.length > 0) {
	            return [createCodeFixAction(fixId4, changes, Diagnostics.Add_const_to_unresolved_variable, fixId4, Diagnostics.Add_const_to_all_unresolved_variables)];
	          }
	        },
	        fixIds: [fixId4],
	        getAllCodeActions: (context) => {
	          const fixedNodes = /* @__PURE__ */ new Set();
	          return codeFixAll(context, errorCodes4, (changes, diag2) => makeChange4(changes, diag2.file, diag2.start, context.program, fixedNodes));
	        }
	      });
	    }
	  });

	  // src/services/codefixes/addMissingDeclareProperty.ts
	  function makeChange5(changeTracker, sourceFile, pos, fixedNodes) {
	    const token = getTokenAtPosition(sourceFile, pos);
	    if (!isIdentifier(token)) {
	      return;
	    }
	    const declaration = token.parent;
	    if (declaration.kind === 172 /* PropertyDeclaration */ && (!fixedNodes || tryAddToSet(fixedNodes, declaration))) {
	      changeTracker.insertModifierBefore(sourceFile, 138 /* DeclareKeyword */, declaration);
	    }
	  }
	  var fixId5, errorCodes5;
	  var init_addMissingDeclareProperty = __esm({
	    "src/services/codefixes/addMissingDeclareProperty.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      fixId5 = "addMissingDeclareProperty";
	      errorCodes5 = [
	        Diagnostics.Property_0_will_overwrite_the_base_property_in_1_If_this_is_intentional_add_an_initializer_Otherwise_add_a_declare_modifier_or_remove_the_redundant_declaration.code
	      ];
	      registerCodeFix({
	        errorCodes: errorCodes5,
	        getCodeActions: function getCodeActionsToAddMissingDeclareOnProperty(context) {
	          const changes = ts_textChanges_exports.ChangeTracker.with(context, (t) => makeChange5(t, context.sourceFile, context.span.start));
	          if (changes.length > 0) {
	            return [createCodeFixAction(fixId5, changes, Diagnostics.Prefix_with_declare, fixId5, Diagnostics.Prefix_all_incorrect_property_declarations_with_declare)];
	          }
	        },
	        fixIds: [fixId5],
	        getAllCodeActions: (context) => {
	          const fixedNodes = /* @__PURE__ */ new Set();
	          return codeFixAll(context, errorCodes5, (changes, diag2) => makeChange5(changes, diag2.file, diag2.start, fixedNodes));
	        }
	      });
	    }
	  });

	  // src/services/codefixes/addMissingInvocationForDecorator.ts
	  function makeChange6(changeTracker, sourceFile, pos) {
	    const token = getTokenAtPosition(sourceFile, pos);
	    const decorator = findAncestor(token, isDecorator);
	    Debug.assert(!!decorator, "Expected position to be owned by a decorator.");
	    const replacement = factory.createCallExpression(
	      decorator.expression,
	      /*typeArguments*/
	      void 0,
	      /*argumentsArray*/
	      void 0
	    );
	    changeTracker.replaceNode(sourceFile, decorator.expression, replacement);
	  }
	  var fixId6, errorCodes6;
	  var init_addMissingInvocationForDecorator = __esm({
	    "src/services/codefixes/addMissingInvocationForDecorator.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      fixId6 = "addMissingInvocationForDecorator";
	      errorCodes6 = [Diagnostics._0_accepts_too_few_arguments_to_be_used_as_a_decorator_here_Did_you_mean_to_call_it_first_and_write_0.code];
	      registerCodeFix({
	        errorCodes: errorCodes6,
	        getCodeActions: function getCodeActionsToAddMissingInvocationForDecorator(context) {
	          const changes = ts_textChanges_exports.ChangeTracker.with(context, (t) => makeChange6(t, context.sourceFile, context.span.start));
	          return [createCodeFixAction(fixId6, changes, Diagnostics.Call_decorator_expression, fixId6, Diagnostics.Add_to_all_uncalled_decorators)];
	        },
	        fixIds: [fixId6],
	        getAllCodeActions: (context) => codeFixAll(context, errorCodes6, (changes, diag2) => makeChange6(changes, diag2.file, diag2.start))
	      });
	    }
	  });

	  // src/services/codefixes/addNameToNamelessParameter.ts
	  function makeChange7(changeTracker, sourceFile, start) {
	    const token = getTokenAtPosition(sourceFile, start);
	    const param = token.parent;
	    if (!isParameter(param)) {
	      return Debug.fail("Tried to add a parameter name to a non-parameter: " + Debug.formatSyntaxKind(token.kind));
	    }
	    const i = param.parent.parameters.indexOf(param);
	    Debug.assert(!param.type, "Tried to add a parameter name to a parameter that already had one.");
	    Debug.assert(i > -1, "Parameter not found in parent parameter list.");
	    let end = param.name.getEnd();
	    let typeNode = factory.createTypeReferenceNode(
	      param.name,
	      /*typeArguments*/
	      void 0
	    );
	    let nextParam = tryGetNextParam(sourceFile, param);
	    while (nextParam) {
	      typeNode = factory.createArrayTypeNode(typeNode);
	      end = nextParam.getEnd();
	      nextParam = tryGetNextParam(sourceFile, nextParam);
	    }
	    const replacement = factory.createParameterDeclaration(
	      param.modifiers,
	      param.dotDotDotToken,
	      "arg" + i,
	      param.questionToken,
	      param.dotDotDotToken && !isArrayTypeNode(typeNode) ? factory.createArrayTypeNode(typeNode) : typeNode,
	      param.initializer
	    );
	    changeTracker.replaceRange(sourceFile, createRange(param.getStart(sourceFile), end), replacement);
	  }
	  function tryGetNextParam(sourceFile, param) {
	    const nextToken = findNextToken(param.name, param.parent, sourceFile);
	    if (nextToken && nextToken.kind === 23 /* OpenBracketToken */ && isArrayBindingPattern(nextToken.parent) && isParameter(nextToken.parent.parent)) {
	      return nextToken.parent.parent;
	    }
	    return void 0;
	  }
	  var fixId7, errorCodes7;
	  var init_addNameToNamelessParameter = __esm({
	    "src/services/codefixes/addNameToNamelessParameter.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      fixId7 = "addNameToNamelessParameter";
	      errorCodes7 = [Diagnostics.Parameter_has_a_name_but_no_type_Did_you_mean_0_Colon_1.code];
	      registerCodeFix({
	        errorCodes: errorCodes7,
	        getCodeActions: function getCodeActionsToAddNameToNamelessParameter(context) {
	          const changes = ts_textChanges_exports.ChangeTracker.with(context, (t) => makeChange7(t, context.sourceFile, context.span.start));
	          return [createCodeFixAction(fixId7, changes, Diagnostics.Add_parameter_name, fixId7, Diagnostics.Add_names_to_all_parameters_without_names)];
	        },
	        fixIds: [fixId7],
	        getAllCodeActions: (context) => codeFixAll(context, errorCodes7, (changes, diag2) => makeChange7(changes, diag2.file, diag2.start))
	      });
	    }
	  });

	  // src/services/codefixes/addOptionalPropertyUndefined.ts
	  function getPropertiesToAdd(file, span, checker) {
	    var _a, _b;
	    const sourceTarget = getSourceTarget(getFixableErrorSpanExpression(file, span), checker);
	    if (!sourceTarget) {
	      return emptyArray;
	    }
	    const { source: sourceNode, target: targetNode } = sourceTarget;
	    const target = shouldUseParentTypeOfProperty(sourceNode, targetNode, checker) ? checker.getTypeAtLocation(targetNode.expression) : checker.getTypeAtLocation(targetNode);
	    if ((_b = (_a = target.symbol) == null ? void 0 : _a.declarations) == null ? void 0 : _b.some((d) => getSourceFileOfNode(d).fileName.match(/\.d\.ts$/))) {
	      return emptyArray;
	    }
	    return checker.getExactOptionalProperties(target);
	  }
	  function shouldUseParentTypeOfProperty(sourceNode, targetNode, checker) {
	    return isPropertyAccessExpression(targetNode) && !!checker.getExactOptionalProperties(checker.getTypeAtLocation(targetNode.expression)).length && checker.getTypeAtLocation(sourceNode) === checker.getUndefinedType();
	  }
	  function getSourceTarget(errorNode, checker) {
	    var _a;
	    if (!errorNode) {
	      return void 0;
	    } else if (isBinaryExpression(errorNode.parent) && errorNode.parent.operatorToken.kind === 64 /* EqualsToken */) {
	      return { source: errorNode.parent.right, target: errorNode.parent.left };
	    } else if (isVariableDeclaration(errorNode.parent) && errorNode.parent.initializer) {
	      return { source: errorNode.parent.initializer, target: errorNode.parent.name };
	    } else if (isCallExpression(errorNode.parent)) {
	      const n = checker.getSymbolAtLocation(errorNode.parent.expression);
	      if (!(n == null ? void 0 : n.valueDeclaration) || !isFunctionLikeKind(n.valueDeclaration.kind))
	        return void 0;
	      if (!isExpression(errorNode))
	        return void 0;
	      const i = errorNode.parent.arguments.indexOf(errorNode);
	      if (i === -1)
	        return void 0;
	      const name = n.valueDeclaration.parameters[i].name;
	      if (isIdentifier(name))
	        return { source: errorNode, target: name };
	    } else if (isPropertyAssignment(errorNode.parent) && isIdentifier(errorNode.parent.name) || isShorthandPropertyAssignment(errorNode.parent)) {
	      const parentTarget = getSourceTarget(errorNode.parent.parent, checker);
	      if (!parentTarget)
	        return void 0;
	      const prop = checker.getPropertyOfType(checker.getTypeAtLocation(parentTarget.target), errorNode.parent.name.text);
	      const declaration = (_a = prop == null ? void 0 : prop.declarations) == null ? void 0 : _a[0];
	      if (!declaration)
	        return void 0;
	      return {
	        source: isPropertyAssignment(errorNode.parent) ? errorNode.parent.initializer : errorNode.parent.name,
	        target: declaration
	      };
	    }
	    return void 0;
	  }
	  function addUndefinedToOptionalProperty(changes, toAdd) {
	    for (const add of toAdd) {
	      const d = add.valueDeclaration;
	      if (d && (isPropertySignature(d) || isPropertyDeclaration(d)) && d.type) {
	        const t = factory.createUnionTypeNode([
	          ...d.type.kind === 192 /* UnionType */ ? d.type.types : [d.type],
	          factory.createTypeReferenceNode("undefined")
	        ]);
	        changes.replaceNode(d.getSourceFile(), d.type, t);
	      }
	    }
	  }
	  var addOptionalPropertyUndefined, errorCodes8;
	  var init_addOptionalPropertyUndefined = __esm({
	    "src/services/codefixes/addOptionalPropertyUndefined.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      addOptionalPropertyUndefined = "addOptionalPropertyUndefined";
	      errorCodes8 = [
	        Diagnostics.Type_0_is_not_assignable_to_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_type_of_the_target.code,
	        Diagnostics.Type_0_is_not_assignable_to_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_types_of_the_target_s_properties.code,
	        Diagnostics.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_types_of_the_target_s_properties.code
	      ];
	      registerCodeFix({
	        errorCodes: errorCodes8,
	        getCodeActions(context) {
	          const typeChecker = context.program.getTypeChecker();
	          const toAdd = getPropertiesToAdd(context.sourceFile, context.span, typeChecker);
	          if (!toAdd.length) {
	            return void 0;
	          }
	          const changes = ts_textChanges_exports.ChangeTracker.with(context, (t) => addUndefinedToOptionalProperty(t, toAdd));
	          return [createCodeFixActionWithoutFixAll(addOptionalPropertyUndefined, changes, Diagnostics.Add_undefined_to_optional_property_type)];
	        },
	        fixIds: [addOptionalPropertyUndefined]
	      });
	    }
	  });

	  // src/services/codefixes/annotateWithTypeFromJSDoc.ts
	  function getDeclaration(file, pos) {
	    const name = getTokenAtPosition(file, pos);
	    return tryCast(isParameter(name.parent) ? name.parent.parent : name.parent, parameterShouldGetTypeFromJSDoc);
	  }
	  function parameterShouldGetTypeFromJSDoc(node) {
	    return isDeclarationWithType(node) && hasUsableJSDoc(node);
	  }
	  function hasUsableJSDoc(decl) {
	    return isFunctionLikeDeclaration(decl) ? decl.parameters.some(hasUsableJSDoc) || !decl.type && !!getJSDocReturnType(decl) : !decl.type && !!getJSDocType(decl);
	  }
	  function doChange8(changes, sourceFile, decl) {
	    if (isFunctionLikeDeclaration(decl) && (getJSDocReturnType(decl) || decl.parameters.some((p) => !!getJSDocType(p)))) {
	      if (!decl.typeParameters) {
	        const typeParameters = getJSDocTypeParameterDeclarations(decl);
	        if (typeParameters.length)
	          changes.insertTypeParameters(sourceFile, decl, typeParameters);
	      }
	      const needParens = isArrowFunction(decl) && !findChildOfKind(decl, 21 /* OpenParenToken */, sourceFile);
	      if (needParens)
	        changes.insertNodeBefore(sourceFile, first(decl.parameters), factory.createToken(21 /* OpenParenToken */));
	      for (const param of decl.parameters) {
	        if (!param.type) {
	          const paramType = getJSDocType(param);
	          if (paramType)
	            changes.tryInsertTypeAnnotation(sourceFile, param, visitNode(paramType, transformJSDocType, isTypeNode));
	        }
	      }
	      if (needParens)
	        changes.insertNodeAfter(sourceFile, last(decl.parameters), factory.createToken(22 /* CloseParenToken */));
	      if (!decl.type) {
	        const returnType = getJSDocReturnType(decl);
	        if (returnType)
	          changes.tryInsertTypeAnnotation(sourceFile, decl, visitNode(returnType, transformJSDocType, isTypeNode));
	      }
	    } else {
	      const jsdocType = Debug.checkDefined(getJSDocType(decl), "A JSDocType for this declaration should exist");
	      Debug.assert(!decl.type, "The JSDocType decl should have a type");
	      changes.tryInsertTypeAnnotation(sourceFile, decl, visitNode(jsdocType, transformJSDocType, isTypeNode));
	    }
	  }
	  function isDeclarationWithType(node) {
	    return isFunctionLikeDeclaration(node) || node.kind === 260 /* VariableDeclaration */ || node.kind === 171 /* PropertySignature */ || node.kind === 172 /* PropertyDeclaration */;
	  }
	  function transformJSDocType(node) {
	    switch (node.kind) {
	      case 319 /* JSDocAllType */:
	      case 320 /* JSDocUnknownType */:
	        return factory.createTypeReferenceNode("any", emptyArray);
	      case 323 /* JSDocOptionalType */:
	        return transformJSDocOptionalType(node);
	      case 322 /* JSDocNonNullableType */:
	        return transformJSDocType(node.type);
	      case 321 /* JSDocNullableType */:
	        return transformJSDocNullableType(node);
	      case 325 /* JSDocVariadicType */:
	        return transformJSDocVariadicType(node);
	      case 324 /* JSDocFunctionType */:
	        return transformJSDocFunctionType(node);
	      case 183 /* TypeReference */:
	        return transformJSDocTypeReference(node);
	      case 329 /* JSDocTypeLiteral */:
	        return transformJSDocTypeLiteral(node);
	      default:
	        const visited = visitEachChild(
	          node,
	          transformJSDocType,
	          /*context*/
	          void 0
	        );
	        setEmitFlags(visited, 1 /* SingleLine */);
	        return visited;
	    }
	  }
	  function transformJSDocTypeLiteral(node) {
	    const typeNode = factory.createTypeLiteralNode(map(node.jsDocPropertyTags, (tag) => factory.createPropertySignature(
	      /*modifiers*/
	      void 0,
	      isIdentifier(tag.name) ? tag.name : tag.name.right,
	      isOptionalJSDocPropertyLikeTag(tag) ? factory.createToken(58 /* QuestionToken */) : void 0,
	      tag.typeExpression && visitNode(tag.typeExpression.type, transformJSDocType, isTypeNode) || factory.createKeywordTypeNode(133 /* AnyKeyword */)
	    )));
	    setEmitFlags(typeNode, 1 /* SingleLine */);
	    return typeNode;
	  }
	  function transformJSDocOptionalType(node) {
	    return factory.createUnionTypeNode([visitNode(node.type, transformJSDocType, isTypeNode), factory.createTypeReferenceNode("undefined", emptyArray)]);
	  }
	  function transformJSDocNullableType(node) {
	    return factory.createUnionTypeNode([visitNode(node.type, transformJSDocType, isTypeNode), factory.createTypeReferenceNode("null", emptyArray)]);
	  }
	  function transformJSDocVariadicType(node) {
	    return factory.createArrayTypeNode(visitNode(node.type, transformJSDocType, isTypeNode));
	  }
	  function transformJSDocFunctionType(node) {
	    return factory.createFunctionTypeNode(emptyArray, node.parameters.map(transformJSDocParameter), node.type ?? factory.createKeywordTypeNode(133 /* AnyKeyword */));
	  }
	  function transformJSDocParameter(node) {
	    const index = node.parent.parameters.indexOf(node);
	    const isRest = node.type.kind === 325 /* JSDocVariadicType */ && index === node.parent.parameters.length - 1;
	    const name = node.name || (isRest ? "rest" : "arg" + index);
	    const dotdotdot = isRest ? factory.createToken(26 /* DotDotDotToken */) : node.dotDotDotToken;
	    return factory.createParameterDeclaration(node.modifiers, dotdotdot, name, node.questionToken, visitNode(node.type, transformJSDocType, isTypeNode), node.initializer);
	  }
	  function transformJSDocTypeReference(node) {
	    let name = node.typeName;
	    let args = node.typeArguments;
	    if (isIdentifier(node.typeName)) {
	      if (isJSDocIndexSignature(node)) {
	        return transformJSDocIndexSignature(node);
	      }
	      let text = node.typeName.text;
	      switch (node.typeName.text) {
	        case "String":
	        case "Boolean":
	        case "Object":
	        case "Number":
	          text = text.toLowerCase();
	          break;
	        case "array":
	        case "date":
	        case "promise":
	          text = text[0].toUpperCase() + text.slice(1);
	          break;
	      }
	      name = factory.createIdentifier(text);
	      if ((text === "Array" || text === "Promise") && !node.typeArguments) {
	        args = factory.createNodeArray([factory.createTypeReferenceNode("any", emptyArray)]);
	      } else {
	        args = visitNodes2(node.typeArguments, transformJSDocType, isTypeNode);
	      }
	    }
	    return factory.createTypeReferenceNode(name, args);
	  }
	  function transformJSDocIndexSignature(node) {
	    const index = factory.createParameterDeclaration(
	      /*modifiers*/
	      void 0,
	      /*dotDotDotToken*/
	      void 0,
	      node.typeArguments[0].kind === 150 /* NumberKeyword */ ? "n" : "s",
	      /*questionToken*/
	      void 0,
	      factory.createTypeReferenceNode(node.typeArguments[0].kind === 150 /* NumberKeyword */ ? "number" : "string", []),
	      /*initializer*/
	      void 0
	    );
	    const indexSignature = factory.createTypeLiteralNode([factory.createIndexSignature(
	      /*modifiers*/
	      void 0,
	      [index],
	      node.typeArguments[1]
	    )]);
	    setEmitFlags(indexSignature, 1 /* SingleLine */);
	    return indexSignature;
	  }
	  var fixId8, errorCodes9;
	  var init_annotateWithTypeFromJSDoc = __esm({
	    "src/services/codefixes/annotateWithTypeFromJSDoc.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      fixId8 = "annotateWithTypeFromJSDoc";
	      errorCodes9 = [Diagnostics.JSDoc_types_may_be_moved_to_TypeScript_types.code];
	      registerCodeFix({
	        errorCodes: errorCodes9,
	        getCodeActions(context) {
	          const decl = getDeclaration(context.sourceFile, context.span.start);
	          if (!decl)
	            return;
	          const changes = ts_textChanges_exports.ChangeTracker.with(context, (t) => doChange8(t, context.sourceFile, decl));
	          return [createCodeFixAction(fixId8, changes, Diagnostics.Annotate_with_type_from_JSDoc, fixId8, Diagnostics.Annotate_everything_with_types_from_JSDoc)];
	        },
	        fixIds: [fixId8],
	        getAllCodeActions: (context) => codeFixAll(context, errorCodes9, (changes, diag2) => {
	          const decl = getDeclaration(diag2.file, diag2.start);
	          if (decl)
	            doChange8(changes, diag2.file, decl);
	        })
	      });
	    }
	  });

	  // src/services/codefixes/convertFunctionToEs6Class.ts
	  function doChange9(changes, sourceFile, position, checker, preferences, compilerOptions) {
	    const ctorSymbol = checker.getSymbolAtLocation(getTokenAtPosition(sourceFile, position));
	    if (!ctorSymbol || !ctorSymbol.valueDeclaration || !(ctorSymbol.flags & (16 /* Function */ | 3 /* Variable */))) {
	      return void 0;
	    }
	    const ctorDeclaration = ctorSymbol.valueDeclaration;
	    if (isFunctionDeclaration(ctorDeclaration) || isFunctionExpression(ctorDeclaration)) {
	      changes.replaceNode(sourceFile, ctorDeclaration, createClassFromFunction(ctorDeclaration));
	    } else if (isVariableDeclaration(ctorDeclaration)) {
	      const classDeclaration = createClassFromVariableDeclaration(ctorDeclaration);
	      if (!classDeclaration) {
	        return void 0;
	      }
	      const ancestor = ctorDeclaration.parent.parent;
	      if (isVariableDeclarationList(ctorDeclaration.parent) && ctorDeclaration.parent.declarations.length > 1) {
	        changes.delete(sourceFile, ctorDeclaration);
	        changes.insertNodeAfter(sourceFile, ancestor, classDeclaration);
	      } else {
	        changes.replaceNode(sourceFile, ancestor, classDeclaration);
	      }
	    }
	    function createClassElementsFromSymbol(symbol) {
	      const memberElements = [];
	      if (symbol.exports) {
	        symbol.exports.forEach((member) => {
	          if (member.name === "prototype" && member.declarations) {
	            const firstDeclaration = member.declarations[0];
	            if (member.declarations.length === 1 && isPropertyAccessExpression(firstDeclaration) && isBinaryExpression(firstDeclaration.parent) && firstDeclaration.parent.operatorToken.kind === 64 /* EqualsToken */ && isObjectLiteralExpression(firstDeclaration.parent.right)) {
	              const prototypes = firstDeclaration.parent.right;
	              createClassElement(
	                prototypes.symbol,
	                /*modifiers*/
	                void 0,
	                memberElements
	              );
	            }
	          } else {
	            createClassElement(member, [factory.createToken(126 /* StaticKeyword */)], memberElements);
	          }
	        });
	      }
	      if (symbol.members) {
	        symbol.members.forEach((member, key) => {
	          var _a, _b, _c, _d;
	          if (key === "constructor" && member.valueDeclaration) {
	            const prototypeAssignment = (_d = (_c = (_b = (_a = symbol.exports) == null ? void 0 : _a.get("prototype")) == null ? void 0 : _b.declarations) == null ? void 0 : _c[0]) == null ? void 0 : _d.parent;
	            if (prototypeAssignment && isBinaryExpression(prototypeAssignment) && isObjectLiteralExpression(prototypeAssignment.right) && some(prototypeAssignment.right.properties, isConstructorAssignment)) ; else {
	              changes.delete(sourceFile, member.valueDeclaration.parent);
	            }
	            return;
	          }
	          createClassElement(
	            member,
	            /*modifiers*/
	            void 0,
	            memberElements
	          );
	        });
	      }
	      return memberElements;
	      function shouldConvertDeclaration(_target, source) {
	        if (isAccessExpression(_target)) {
	          if (isPropertyAccessExpression(_target) && isConstructorAssignment(_target))
	            return true;
	          return isFunctionLike(source);
	        } else {
	          return every(_target.properties, (property) => {
	            if (isMethodDeclaration(property) || isGetOrSetAccessorDeclaration(property))
	              return true;
	            if (isPropertyAssignment(property) && isFunctionExpression(property.initializer) && !!property.name)
	              return true;
	            if (isConstructorAssignment(property))
	              return true;
	            return false;
	          });
	        }
	      }
	      function createClassElement(symbol2, modifiers, members) {
	        if (!(symbol2.flags & 8192 /* Method */) && !(symbol2.flags & 4096 /* ObjectLiteral */)) {
	          return;
	        }
	        const memberDeclaration = symbol2.valueDeclaration;
	        const assignmentBinaryExpression = memberDeclaration.parent;
	        const assignmentExpr = assignmentBinaryExpression.right;
	        if (!shouldConvertDeclaration(memberDeclaration, assignmentExpr)) {
	          return;
	        }
	        if (some(members, (m) => {
	          const name = getNameOfDeclaration(m);
	          if (name && isIdentifier(name) && idText(name) === symbolName(symbol2)) {
	            return true;
	          }
	          return false;
	        })) {
	          return;
	        }
	        const nodeToDelete = assignmentBinaryExpression.parent && assignmentBinaryExpression.parent.kind === 244 /* ExpressionStatement */ ? assignmentBinaryExpression.parent : assignmentBinaryExpression;
	        changes.delete(sourceFile, nodeToDelete);
	        if (!assignmentExpr) {
	          members.push(factory.createPropertyDeclaration(
	            modifiers,
	            symbol2.name,
	            /*questionOrExclamationToken*/
	            void 0,
	            /*type*/
	            void 0,
	            /*initializer*/
	            void 0
	          ));
	          return;
	        }
	        if (isAccessExpression(memberDeclaration) && (isFunctionExpression(assignmentExpr) || isArrowFunction(assignmentExpr))) {
	          const quotePreference = getQuotePreference(sourceFile, preferences);
	          const name = tryGetPropertyName(memberDeclaration, compilerOptions, quotePreference);
	          if (name) {
	            createFunctionLikeExpressionMember(members, assignmentExpr, name);
	          }
	          return;
	        } else if (isObjectLiteralExpression(assignmentExpr)) {
	          forEach(
	            assignmentExpr.properties,
	            (property) => {
	              if (isMethodDeclaration(property) || isGetOrSetAccessorDeclaration(property)) {
	                members.push(property);
	              }
	              if (isPropertyAssignment(property) && isFunctionExpression(property.initializer)) {
	                createFunctionLikeExpressionMember(members, property.initializer, property.name);
	              }
	              if (isConstructorAssignment(property))
	                return;
	              return;
	            }
	          );
	          return;
	        } else {
	          if (isSourceFileJS(sourceFile))
	            return;
	          if (!isPropertyAccessExpression(memberDeclaration))
	            return;
	          const prop = factory.createPropertyDeclaration(
	            modifiers,
	            memberDeclaration.name,
	            /*questionOrExclamationToken*/
	            void 0,
	            /*type*/
	            void 0,
	            assignmentExpr
	          );
	          copyLeadingComments(assignmentBinaryExpression.parent, prop, sourceFile);
	          members.push(prop);
	          return;
	        }
	        function createFunctionLikeExpressionMember(members2, expression, name) {
	          if (isFunctionExpression(expression))
	            return createFunctionExpressionMember(members2, expression, name);
	          else
	            return createArrowFunctionExpressionMember(members2, expression, name);
	        }
	        function createFunctionExpressionMember(members2, functionExpression, name) {
	          const fullModifiers = concatenate(modifiers, getModifierKindFromSource(functionExpression, 134 /* AsyncKeyword */));
	          const method = factory.createMethodDeclaration(
	            fullModifiers,
	            /*asteriskToken*/
	            void 0,
	            name,
	            /*questionToken*/
	            void 0,
	            /*typeParameters*/
	            void 0,
	            functionExpression.parameters,
	            /*type*/
	            void 0,
	            functionExpression.body
	          );
	          copyLeadingComments(assignmentBinaryExpression, method, sourceFile);
	          members2.push(method);
	          return;
	        }
	        function createArrowFunctionExpressionMember(members2, arrowFunction, name) {
	          const arrowFunctionBody = arrowFunction.body;
	          let bodyBlock;
	          if (arrowFunctionBody.kind === 241 /* Block */) {
	            bodyBlock = arrowFunctionBody;
	          } else {
	            bodyBlock = factory.createBlock([factory.createReturnStatement(arrowFunctionBody)]);
	          }
	          const fullModifiers = concatenate(modifiers, getModifierKindFromSource(arrowFunction, 134 /* AsyncKeyword */));
	          const method = factory.createMethodDeclaration(
	            fullModifiers,
	            /*asteriskToken*/
	            void 0,
	            name,
	            /*questionToken*/
	            void 0,
	            /*typeParameters*/
	            void 0,
	            arrowFunction.parameters,
	            /*type*/
	            void 0,
	            bodyBlock
	          );
	          copyLeadingComments(assignmentBinaryExpression, method, sourceFile);
	          members2.push(method);
	        }
	      }
	    }
	    function createClassFromVariableDeclaration(node) {
	      const initializer = node.initializer;
	      if (!initializer || !isFunctionExpression(initializer) || !isIdentifier(node.name)) {
	        return void 0;
	      }
	      const memberElements = createClassElementsFromSymbol(node.symbol);
	      if (initializer.body) {
	        memberElements.unshift(factory.createConstructorDeclaration(
	          /*modifiers*/
	          void 0,
	          initializer.parameters,
	          initializer.body
	        ));
	      }
	      const modifiers = getModifierKindFromSource(node.parent.parent, 95 /* ExportKeyword */);
	      const cls = factory.createClassDeclaration(
	        modifiers,
	        node.name,
	        /*typeParameters*/
	        void 0,
	        /*heritageClauses*/
	        void 0,
	        memberElements
	      );
	      return cls;
	    }
	    function createClassFromFunction(node) {
	      const memberElements = createClassElementsFromSymbol(ctorSymbol);
	      if (node.body) {
	        memberElements.unshift(factory.createConstructorDeclaration(
	          /*modifiers*/
	          void 0,
	          node.parameters,
	          node.body
	        ));
	      }
	      const modifiers = getModifierKindFromSource(node, 95 /* ExportKeyword */);
	      const cls = factory.createClassDeclaration(
	        modifiers,
	        node.name,
	        /*typeParameters*/
	        void 0,
	        /*heritageClauses*/
	        void 0,
	        memberElements
	      );
	      return cls;
	    }
	  }
	  function getModifierKindFromSource(source, kind) {
	    return canHaveModifiers(source) ? filter(source.modifiers, (modifier) => modifier.kind === kind) : void 0;
	  }
	  function isConstructorAssignment(x) {
	    if (!x.name)
	      return false;
	    if (isIdentifier(x.name) && x.name.text === "constructor")
	      return true;
	    return false;
	  }
	  function tryGetPropertyName(node, compilerOptions, quotePreference) {
	    if (isPropertyAccessExpression(node)) {
	      return node.name;
	    }
	    const propName = node.argumentExpression;
	    if (isNumericLiteral(propName)) {
	      return propName;
	    }
	    if (isStringLiteralLike(propName)) {
	      return isIdentifierText(propName.text, getEmitScriptTarget(compilerOptions)) ? factory.createIdentifier(propName.text) : isNoSubstitutionTemplateLiteral(propName) ? factory.createStringLiteral(propName.text, quotePreference === 0 /* Single */) : propName;
	    }
	    return void 0;
	  }
	  var fixId9, errorCodes10;
	  var init_convertFunctionToEs6Class = __esm({
	    "src/services/codefixes/convertFunctionToEs6Class.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      fixId9 = "convertFunctionToEs6Class";
	      errorCodes10 = [Diagnostics.This_constructor_function_may_be_converted_to_a_class_declaration.code];
	      registerCodeFix({
	        errorCodes: errorCodes10,
	        getCodeActions(context) {
	          const changes = ts_textChanges_exports.ChangeTracker.with(context, (t) => doChange9(t, context.sourceFile, context.span.start, context.program.getTypeChecker(), context.preferences, context.program.getCompilerOptions()));
	          return [createCodeFixAction(fixId9, changes, Diagnostics.Convert_function_to_an_ES2015_class, fixId9, Diagnostics.Convert_all_constructor_functions_to_classes)];
	        },
	        fixIds: [fixId9],
	        getAllCodeActions: (context) => codeFixAll(context, errorCodes10, (changes, err) => doChange9(changes, err.file, err.start, context.program.getTypeChecker(), context.preferences, context.program.getCompilerOptions()))
	      });
	    }
	  });

	  // src/services/codefixes/convertToAsyncFunction.ts
	  function convertToAsyncFunction(changes, sourceFile, position, checker) {
	    const tokenAtPosition = getTokenAtPosition(sourceFile, position);
	    let functionToConvert;
	    if (isIdentifier(tokenAtPosition) && isVariableDeclaration(tokenAtPosition.parent) && tokenAtPosition.parent.initializer && isFunctionLikeDeclaration(tokenAtPosition.parent.initializer)) {
	      functionToConvert = tokenAtPosition.parent.initializer;
	    } else {
	      functionToConvert = tryCast(getContainingFunction(getTokenAtPosition(sourceFile, position)), canBeConvertedToAsync);
	    }
	    if (!functionToConvert) {
	      return;
	    }
	    const synthNamesMap = /* @__PURE__ */ new Map();
	    const isInJavascript = isInJSFile(functionToConvert);
	    const setOfExpressionsToReturn = getAllPromiseExpressionsToReturn(functionToConvert, checker);
	    const functionToConvertRenamed = renameCollidingVarNames(functionToConvert, checker, synthNamesMap);
	    if (!returnsPromise(functionToConvertRenamed, checker)) {
	      return;
	    }
	    const returnStatements = functionToConvertRenamed.body && isBlock(functionToConvertRenamed.body) ? getReturnStatementsWithPromiseHandlers(functionToConvertRenamed.body, checker) : emptyArray;
	    const transformer = { checker, synthNamesMap, setOfExpressionsToReturn, isInJSFile: isInJavascript };
	    if (!returnStatements.length) {
	      return;
	    }
	    const pos = skipTrivia(sourceFile.text, moveRangePastModifiers(functionToConvert).pos);
	    changes.insertModifierAt(sourceFile, pos, 134 /* AsyncKeyword */, { suffix: " " });
	    for (const returnStatement of returnStatements) {
	      forEachChild(returnStatement, function visit(node) {
	        if (isCallExpression(node)) {
	          const newNodes = transformExpression(
	            node,
	            node,
	            transformer,
	            /*hasContinuation*/
	            false
	          );
	          if (hasFailed()) {
	            return true;
	          }
	          changes.replaceNodeWithNodes(sourceFile, returnStatement, newNodes);
	        } else if (!isFunctionLike(node)) {
	          forEachChild(node, visit);
	          if (hasFailed()) {
	            return true;
	          }
	        }
	      });
	      if (hasFailed()) {
	        return;
	      }
	    }
	  }
	  function getReturnStatementsWithPromiseHandlers(body, checker) {
	    const res = [];
	    forEachReturnStatement(body, (ret) => {
	      if (isReturnStatementWithFixablePromiseHandler(ret, checker))
	        res.push(ret);
	    });
	    return res;
	  }
	  function getAllPromiseExpressionsToReturn(func, checker) {
	    if (!func.body) {
	      return /* @__PURE__ */ new Set();
	    }
	    const setOfExpressionsToReturn = /* @__PURE__ */ new Set();
	    forEachChild(func.body, function visit(node) {
	      if (isPromiseReturningCallExpression(node, checker, "then")) {
	        setOfExpressionsToReturn.add(getNodeId(node));
	        forEach(node.arguments, visit);
	      } else if (isPromiseReturningCallExpression(node, checker, "catch") || isPromiseReturningCallExpression(node, checker, "finally")) {
	        setOfExpressionsToReturn.add(getNodeId(node));
	        forEachChild(node, visit);
	      } else if (isPromiseTypedExpression(node, checker)) {
	        setOfExpressionsToReturn.add(getNodeId(node));
	      } else {
	        forEachChild(node, visit);
	      }
	    });
	    return setOfExpressionsToReturn;
	  }
	  function isPromiseReturningCallExpression(node, checker, name) {
	    if (!isCallExpression(node))
	      return false;
	    const isExpressionOfName = hasPropertyAccessExpressionWithName(node, name);
	    const nodeType = isExpressionOfName && checker.getTypeAtLocation(node);
	    return !!(nodeType && checker.getPromisedTypeOfPromise(nodeType));
	  }
	  function isReferenceToType(type, target) {
	    return (getObjectFlags(type) & 4 /* Reference */) !== 0 && type.target === target;
	  }
	  function getExplicitPromisedTypeOfPromiseReturningCallExpression(node, callback, checker) {
	    if (node.expression.name.escapedText === "finally") {
	      return void 0;
	    }
	    const promiseType = checker.getTypeAtLocation(node.expression.expression);
	    if (isReferenceToType(promiseType, checker.getPromiseType()) || isReferenceToType(promiseType, checker.getPromiseLikeType())) {
	      if (node.expression.name.escapedText === "then") {
	        if (callback === elementAt(node.arguments, 0)) {
	          return elementAt(node.typeArguments, 0);
	        } else if (callback === elementAt(node.arguments, 1)) {
	          return elementAt(node.typeArguments, 1);
	        }
	      } else {
	        return elementAt(node.typeArguments, 0);
	      }
	    }
	  }
	  function isPromiseTypedExpression(node, checker) {
	    if (!isExpression(node))
	      return false;
	    return !!checker.getPromisedTypeOfPromise(checker.getTypeAtLocation(node));
	  }
	  function renameCollidingVarNames(nodeToRename, checker, synthNamesMap) {
	    const identsToRenameMap = /* @__PURE__ */ new Map();
	    const collidingSymbolMap = createMultiMap();
	    forEachChild(nodeToRename, function visit(node) {
	      if (!isIdentifier(node)) {
	        forEachChild(node, visit);
	        return;
	      }
	      const symbol = checker.getSymbolAtLocation(node);
	      if (symbol) {
	        const type = checker.getTypeAtLocation(node);
	        const lastCallSignature = getLastCallSignature(type, checker);
	        const symbolIdString = getSymbolId(symbol).toString();
	        if (lastCallSignature && !isParameter(node.parent) && !isFunctionLikeDeclaration(node.parent) && !synthNamesMap.has(symbolIdString)) {
	          const firstParameter = firstOrUndefined(lastCallSignature.parameters);
	          const ident = (firstParameter == null ? void 0 : firstParameter.valueDeclaration) && isParameter(firstParameter.valueDeclaration) && tryCast(firstParameter.valueDeclaration.name, isIdentifier) || factory.createUniqueName("result", 16 /* Optimistic */);
	          const synthName = getNewNameIfConflict(ident, collidingSymbolMap);
	          synthNamesMap.set(symbolIdString, synthName);
	          collidingSymbolMap.add(ident.text, symbol);
	        } else if (node.parent && (isParameter(node.parent) || isVariableDeclaration(node.parent) || isBindingElement(node.parent))) {
	          const originalName = node.text;
	          const collidingSymbols = collidingSymbolMap.get(originalName);
	          if (collidingSymbols && collidingSymbols.some((prevSymbol) => prevSymbol !== symbol)) {
	            const newName = getNewNameIfConflict(node, collidingSymbolMap);
	            identsToRenameMap.set(symbolIdString, newName.identifier);
	            synthNamesMap.set(symbolIdString, newName);
	            collidingSymbolMap.add(originalName, symbol);
	          } else {
	            const identifier = getSynthesizedDeepClone(node);
	            synthNamesMap.set(symbolIdString, createSynthIdentifier(identifier));
	            collidingSymbolMap.add(originalName, symbol);
	          }
	        }
	      }
	    });
	    return getSynthesizedDeepCloneWithReplacements(
	      nodeToRename,
	      /*includeTrivia*/
	      true,
	      (original) => {
	        if (isBindingElement(original) && isIdentifier(original.name) && isObjectBindingPattern(original.parent)) {
	          const symbol = checker.getSymbolAtLocation(original.name);
	          const renameInfo = symbol && identsToRenameMap.get(String(getSymbolId(symbol)));
	          if (renameInfo && renameInfo.text !== (original.name || original.propertyName).getText()) {
	            return factory.createBindingElement(
	              original.dotDotDotToken,
	              original.propertyName || original.name,
	              renameInfo,
	              original.initializer
	            );
	          }
	        } else if (isIdentifier(original)) {
	          const symbol = checker.getSymbolAtLocation(original);
	          const renameInfo = symbol && identsToRenameMap.get(String(getSymbolId(symbol)));
	          if (renameInfo) {
	            return factory.createIdentifier(renameInfo.text);
	          }
	        }
	      }
	    );
	  }
	  function getNewNameIfConflict(name, originalNames) {
	    const numVarsSameName = (originalNames.get(name.text) || emptyArray).length;
	    const identifier = numVarsSameName === 0 ? name : factory.createIdentifier(name.text + "_" + numVarsSameName);
	    return createSynthIdentifier(identifier);
	  }
	  function hasFailed() {
	    return !codeActionSucceeded;
	  }
	  function silentFail() {
	    codeActionSucceeded = false;
	    return emptyArray;
	  }
	  function transformExpression(returnContextNode, node, transformer, hasContinuation, continuationArgName) {
	    if (isPromiseReturningCallExpression(node, transformer.checker, "then")) {
	      return transformThen(node, elementAt(node.arguments, 0), elementAt(node.arguments, 1), transformer, hasContinuation, continuationArgName);
	    }
	    if (isPromiseReturningCallExpression(node, transformer.checker, "catch")) {
	      return transformCatch(node, elementAt(node.arguments, 0), transformer, hasContinuation, continuationArgName);
	    }
	    if (isPromiseReturningCallExpression(node, transformer.checker, "finally")) {
	      return transformFinally(node, elementAt(node.arguments, 0), transformer, hasContinuation, continuationArgName);
	    }
	    if (isPropertyAccessExpression(node)) {
	      return transformExpression(returnContextNode, node.expression, transformer, hasContinuation, continuationArgName);
	    }
	    const nodeType = transformer.checker.getTypeAtLocation(node);
	    if (nodeType && transformer.checker.getPromisedTypeOfPromise(nodeType)) {
	      Debug.assertNode(getOriginalNode(node).parent, isPropertyAccessExpression);
	      return transformPromiseExpressionOfPropertyAccess(returnContextNode, node, transformer, hasContinuation, continuationArgName);
	    }
	    return silentFail();
	  }
	  function isNullOrUndefined2({ checker }, node) {
	    if (node.kind === 106 /* NullKeyword */)
	      return true;
	    if (isIdentifier(node) && !isGeneratedIdentifier(node) && idText(node) === "undefined") {
	      const symbol = checker.getSymbolAtLocation(node);
	      return !symbol || checker.isUndefinedSymbol(symbol);
	    }
	    return false;
	  }
	  function createUniqueSynthName(prevArgName) {
	    const renamedPrevArg = factory.createUniqueName(prevArgName.identifier.text, 16 /* Optimistic */);
	    return createSynthIdentifier(renamedPrevArg);
	  }
	  function getPossibleNameForVarDecl(node, transformer, continuationArgName) {
	    let possibleNameForVarDecl;
	    if (continuationArgName && !shouldReturn(node, transformer)) {
	      if (isSynthIdentifier(continuationArgName)) {
	        possibleNameForVarDecl = continuationArgName;
	        transformer.synthNamesMap.forEach((val, key) => {
	          if (val.identifier.text === continuationArgName.identifier.text) {
	            const newSynthName = createUniqueSynthName(continuationArgName);
	            transformer.synthNamesMap.set(key, newSynthName);
	          }
	        });
	      } else {
	        possibleNameForVarDecl = createSynthIdentifier(factory.createUniqueName("result", 16 /* Optimistic */), continuationArgName.types);
	      }
	      declareSynthIdentifier(possibleNameForVarDecl);
	    }
	    return possibleNameForVarDecl;
	  }
	  function finishCatchOrFinallyTransform(node, transformer, tryStatement, possibleNameForVarDecl, continuationArgName) {
	    const statements = [];
	    let varDeclIdentifier;
	    if (possibleNameForVarDecl && !shouldReturn(node, transformer)) {
	      varDeclIdentifier = getSynthesizedDeepClone(declareSynthIdentifier(possibleNameForVarDecl));
	      const typeArray = possibleNameForVarDecl.types;
	      const unionType = transformer.checker.getUnionType(typeArray, 2 /* Subtype */);
	      const unionTypeNode = transformer.isInJSFile ? void 0 : transformer.checker.typeToTypeNode(
	        unionType,
	        /*enclosingDeclaration*/
	        void 0,
	        /*flags*/
	        void 0
	      );
	      const varDecl = [factory.createVariableDeclaration(
	        varDeclIdentifier,
	        /*exclamationToken*/
	        void 0,
	        unionTypeNode
	      )];
	      const varDeclList = factory.createVariableStatement(
	        /*modifiers*/
	        void 0,
	        factory.createVariableDeclarationList(varDecl, 1 /* Let */)
	      );
	      statements.push(varDeclList);
	    }
	    statements.push(tryStatement);
	    if (continuationArgName && varDeclIdentifier && isSynthBindingPattern(continuationArgName)) {
	      statements.push(factory.createVariableStatement(
	        /*modifiers*/
	        void 0,
	        factory.createVariableDeclarationList([
	          factory.createVariableDeclaration(
	            getSynthesizedDeepClone(declareSynthBindingPattern(continuationArgName)),
	            /*exclamationToken*/
	            void 0,
	            /*type*/
	            void 0,
	            varDeclIdentifier
	          )
	        ], 2 /* Const */)
	      ));
	    }
	    return statements;
	  }
	  function transformFinally(node, onFinally, transformer, hasContinuation, continuationArgName) {
	    if (!onFinally || isNullOrUndefined2(transformer, onFinally)) {
	      return transformExpression(
	        /* returnContextNode */
	        node,
	        node.expression.expression,
	        transformer,
	        hasContinuation,
	        continuationArgName
	      );
	    }
	    const possibleNameForVarDecl = getPossibleNameForVarDecl(node, transformer, continuationArgName);
	    const inlinedLeftHandSide = transformExpression(
	      /*returnContextNode*/
	      node,
	      node.expression.expression,
	      transformer,
	      /*hasContinuation*/
	      true,
	      possibleNameForVarDecl
	    );
	    if (hasFailed())
	      return silentFail();
	    const inlinedCallback = transformCallbackArgument(
	      onFinally,
	      hasContinuation,
	      /*continuationArgName*/
	      void 0,
	      /*inputArgName*/
	      void 0,
	      node,
	      transformer
	    );
	    if (hasFailed())
	      return silentFail();
	    const tryBlock = factory.createBlock(inlinedLeftHandSide);
	    const finallyBlock = factory.createBlock(inlinedCallback);
	    const tryStatement = factory.createTryStatement(
	      tryBlock,
	      /*catchClause*/
	      void 0,
	      finallyBlock
	    );
	    return finishCatchOrFinallyTransform(node, transformer, tryStatement, possibleNameForVarDecl, continuationArgName);
	  }
	  function transformCatch(node, onRejected, transformer, hasContinuation, continuationArgName) {
	    if (!onRejected || isNullOrUndefined2(transformer, onRejected)) {
	      return transformExpression(
	        /* returnContextNode */
	        node,
	        node.expression.expression,
	        transformer,
	        hasContinuation,
	        continuationArgName
	      );
	    }
	    const inputArgName = getArgBindingName(onRejected, transformer);
	    const possibleNameForVarDecl = getPossibleNameForVarDecl(node, transformer, continuationArgName);
	    const inlinedLeftHandSide = transformExpression(
	      /*returnContextNode*/
	      node,
	      node.expression.expression,
	      transformer,
	      /*hasContinuation*/
	      true,
	      possibleNameForVarDecl
	    );
	    if (hasFailed())
	      return silentFail();
	    const inlinedCallback = transformCallbackArgument(onRejected, hasContinuation, possibleNameForVarDecl, inputArgName, node, transformer);
	    if (hasFailed())
	      return silentFail();
	    const tryBlock = factory.createBlock(inlinedLeftHandSide);
	    const catchClause = factory.createCatchClause(inputArgName && getSynthesizedDeepClone(declareSynthBindingName(inputArgName)), factory.createBlock(inlinedCallback));
	    const tryStatement = factory.createTryStatement(
	      tryBlock,
	      catchClause,
	      /*finallyBlock*/
	      void 0
	    );
	    return finishCatchOrFinallyTransform(node, transformer, tryStatement, possibleNameForVarDecl, continuationArgName);
	  }
	  function transformThen(node, onFulfilled, onRejected, transformer, hasContinuation, continuationArgName) {
	    if (!onFulfilled || isNullOrUndefined2(transformer, onFulfilled)) {
	      return transformCatch(node, onRejected, transformer, hasContinuation, continuationArgName);
	    }
	    if (onRejected && !isNullOrUndefined2(transformer, onRejected)) {
	      return silentFail();
	    }
	    const inputArgName = getArgBindingName(onFulfilled, transformer);
	    const inlinedLeftHandSide = transformExpression(
	      node.expression.expression,
	      node.expression.expression,
	      transformer,
	      /*hasContinuation*/
	      true,
	      inputArgName
	    );
	    if (hasFailed())
	      return silentFail();
	    const inlinedCallback = transformCallbackArgument(onFulfilled, hasContinuation, continuationArgName, inputArgName, node, transformer);
	    if (hasFailed())
	      return silentFail();
	    return concatenate(inlinedLeftHandSide, inlinedCallback);
	  }
	  function transformPromiseExpressionOfPropertyAccess(returnContextNode, node, transformer, hasContinuation, continuationArgName) {
	    if (shouldReturn(returnContextNode, transformer)) {
	      let returnValue = getSynthesizedDeepClone(node);
	      if (hasContinuation) {
	        returnValue = factory.createAwaitExpression(returnValue);
	      }
	      return [factory.createReturnStatement(returnValue)];
	    }
	    return createVariableOrAssignmentOrExpressionStatement(
	      continuationArgName,
	      factory.createAwaitExpression(node),
	      /*typeAnnotation*/
	      void 0
	    );
	  }
	  function createVariableOrAssignmentOrExpressionStatement(variableName, rightHandSide, typeAnnotation) {
	    if (!variableName || isEmptyBindingName(variableName)) {
	      return [factory.createExpressionStatement(rightHandSide)];
	    }
	    if (isSynthIdentifier(variableName) && variableName.hasBeenDeclared) {
	      return [factory.createExpressionStatement(factory.createAssignment(getSynthesizedDeepClone(referenceSynthIdentifier(variableName)), rightHandSide))];
	    }
	    return [
	      factory.createVariableStatement(
	        /*modifiers*/
	        void 0,
	        factory.createVariableDeclarationList([
	          factory.createVariableDeclaration(
	            getSynthesizedDeepClone(declareSynthBindingName(variableName)),
	            /*exclamationToken*/
	            void 0,
	            typeAnnotation,
	            rightHandSide
	          )
	        ], 2 /* Const */)
	      )
	    ];
	  }
	  function maybeAnnotateAndReturn(expressionToReturn, typeAnnotation) {
	    if (typeAnnotation && expressionToReturn) {
	      const name = factory.createUniqueName("result", 16 /* Optimistic */);
	      return [
	        ...createVariableOrAssignmentOrExpressionStatement(createSynthIdentifier(name), expressionToReturn, typeAnnotation),
	        factory.createReturnStatement(name)
	      ];
	    }
	    return [factory.createReturnStatement(expressionToReturn)];
	  }
	  function transformCallbackArgument(func, hasContinuation, continuationArgName, inputArgName, parent2, transformer) {
	    var _a;
	    switch (func.kind) {
	      case 106 /* NullKeyword */:
	        break;
	      case 211 /* PropertyAccessExpression */:
	      case 80 /* Identifier */:
	        if (!inputArgName) {
	          break;
	        }
	        const synthCall = factory.createCallExpression(
	          getSynthesizedDeepClone(func),
	          /*typeArguments*/
	          void 0,
	          isSynthIdentifier(inputArgName) ? [referenceSynthIdentifier(inputArgName)] : []
	        );
	        if (shouldReturn(parent2, transformer)) {
	          return maybeAnnotateAndReturn(synthCall, getExplicitPromisedTypeOfPromiseReturningCallExpression(parent2, func, transformer.checker));
	        }
	        const type = transformer.checker.getTypeAtLocation(func);
	        const callSignatures = transformer.checker.getSignaturesOfType(type, 0 /* Call */);
	        if (!callSignatures.length) {
	          return silentFail();
	        }
	        const returnType = callSignatures[0].getReturnType();
	        const varDeclOrAssignment = createVariableOrAssignmentOrExpressionStatement(continuationArgName, factory.createAwaitExpression(synthCall), getExplicitPromisedTypeOfPromiseReturningCallExpression(parent2, func, transformer.checker));
	        if (continuationArgName) {
	          continuationArgName.types.push(transformer.checker.getAwaitedType(returnType) || returnType);
	        }
	        return varDeclOrAssignment;
	      case 218 /* FunctionExpression */:
	      case 219 /* ArrowFunction */: {
	        const funcBody = func.body;
	        const returnType2 = (_a = getLastCallSignature(transformer.checker.getTypeAtLocation(func), transformer.checker)) == null ? void 0 : _a.getReturnType();
	        if (isBlock(funcBody)) {
	          let refactoredStmts = [];
	          let seenReturnStatement = false;
	          for (const statement of funcBody.statements) {
	            if (isReturnStatement(statement)) {
	              seenReturnStatement = true;
	              if (isReturnStatementWithFixablePromiseHandler(statement, transformer.checker)) {
	                refactoredStmts = refactoredStmts.concat(transformReturnStatementWithFixablePromiseHandler(transformer, statement, hasContinuation, continuationArgName));
	              } else {
	                const possiblyAwaitedRightHandSide = returnType2 && statement.expression ? getPossiblyAwaitedRightHandSide(transformer.checker, returnType2, statement.expression) : statement.expression;
	                refactoredStmts.push(...maybeAnnotateAndReturn(possiblyAwaitedRightHandSide, getExplicitPromisedTypeOfPromiseReturningCallExpression(parent2, func, transformer.checker)));
	              }
	            } else if (hasContinuation && forEachReturnStatement(statement, returnTrue)) {
	              return silentFail();
	            } else {
	              refactoredStmts.push(statement);
	            }
	          }
	          return shouldReturn(parent2, transformer) ? refactoredStmts.map((s) => getSynthesizedDeepClone(s)) : removeReturns(
	            refactoredStmts,
	            continuationArgName,
	            transformer,
	            seenReturnStatement
	          );
	        } else {
	          const inlinedStatements = isFixablePromiseHandler(funcBody, transformer.checker) ? transformReturnStatementWithFixablePromiseHandler(transformer, factory.createReturnStatement(funcBody), hasContinuation, continuationArgName) : emptyArray;
	          if (inlinedStatements.length > 0) {
	            return inlinedStatements;
	          }
	          if (returnType2) {
	            const possiblyAwaitedRightHandSide = getPossiblyAwaitedRightHandSide(transformer.checker, returnType2, funcBody);
	            if (!shouldReturn(parent2, transformer)) {
	              const transformedStatement = createVariableOrAssignmentOrExpressionStatement(
	                continuationArgName,
	                possiblyAwaitedRightHandSide,
	                /*typeAnnotation*/
	                void 0
	              );
	              if (continuationArgName) {
	                continuationArgName.types.push(transformer.checker.getAwaitedType(returnType2) || returnType2);
	              }
	              return transformedStatement;
	            } else {
	              return maybeAnnotateAndReturn(possiblyAwaitedRightHandSide, getExplicitPromisedTypeOfPromiseReturningCallExpression(parent2, func, transformer.checker));
	            }
	          } else {
	            return silentFail();
	          }
	        }
	      }
	      default:
	        return silentFail();
	    }
	    return emptyArray;
	  }
	  function getPossiblyAwaitedRightHandSide(checker, type, expr) {
	    const rightHandSide = getSynthesizedDeepClone(expr);
	    return !!checker.getPromisedTypeOfPromise(type) ? factory.createAwaitExpression(rightHandSide) : rightHandSide;
	  }
	  function getLastCallSignature(type, checker) {
	    const callSignatures = checker.getSignaturesOfType(type, 0 /* Call */);
	    return lastOrUndefined(callSignatures);
	  }
	  function removeReturns(stmts, prevArgName, transformer, seenReturnStatement) {
	    const ret = [];
	    for (const stmt of stmts) {
	      if (isReturnStatement(stmt)) {
	        if (stmt.expression) {
	          const possiblyAwaitedExpression = isPromiseTypedExpression(stmt.expression, transformer.checker) ? factory.createAwaitExpression(stmt.expression) : stmt.expression;
	          if (prevArgName === void 0) {
	            ret.push(factory.createExpressionStatement(possiblyAwaitedExpression));
	          } else if (isSynthIdentifier(prevArgName) && prevArgName.hasBeenDeclared) {
	            ret.push(factory.createExpressionStatement(factory.createAssignment(referenceSynthIdentifier(prevArgName), possiblyAwaitedExpression)));
	          } else {
	            ret.push(factory.createVariableStatement(
	              /*modifiers*/
	              void 0,
	              factory.createVariableDeclarationList([factory.createVariableDeclaration(
	                declareSynthBindingName(prevArgName),
	                /*exclamationToken*/
	                void 0,
	                /*type*/
	                void 0,
	                possiblyAwaitedExpression
	              )], 2 /* Const */)
	            ));
	          }
	        }
	      } else {
	        ret.push(getSynthesizedDeepClone(stmt));
	      }
	    }
	    if (!seenReturnStatement && prevArgName !== void 0) {
	      ret.push(factory.createVariableStatement(
	        /*modifiers*/
	        void 0,
	        factory.createVariableDeclarationList([factory.createVariableDeclaration(
	          declareSynthBindingName(prevArgName),
	          /*exclamationToken*/
	          void 0,
	          /*type*/
	          void 0,
	          factory.createIdentifier("undefined")
	        )], 2 /* Const */)
	      ));
	    }
	    return ret;
	  }
	  function transformReturnStatementWithFixablePromiseHandler(transformer, innerRetStmt, hasContinuation, continuationArgName) {
	    let innerCbBody = [];
	    forEachChild(innerRetStmt, function visit(node) {
	      if (isCallExpression(node)) {
	        const temp = transformExpression(node, node, transformer, hasContinuation, continuationArgName);
	        innerCbBody = innerCbBody.concat(temp);
	        if (innerCbBody.length > 0) {
	          return;
	        }
	      } else if (!isFunctionLike(node)) {
	        forEachChild(node, visit);
	      }
	    });
	    return innerCbBody;
	  }
	  function getArgBindingName(funcNode, transformer) {
	    const types = [];
	    let name;
	    if (isFunctionLikeDeclaration(funcNode)) {
	      if (funcNode.parameters.length > 0) {
	        const param = funcNode.parameters[0].name;
	        name = getMappedBindingNameOrDefault(param);
	      }
	    } else if (isIdentifier(funcNode)) {
	      name = getMapEntryOrDefault(funcNode);
	    } else if (isPropertyAccessExpression(funcNode) && isIdentifier(funcNode.name)) {
	      name = getMapEntryOrDefault(funcNode.name);
	    }
	    if (!name || "identifier" in name && name.identifier.text === "undefined") {
	      return void 0;
	    }
	    return name;
	    function getMappedBindingNameOrDefault(bindingName) {
	      if (isIdentifier(bindingName))
	        return getMapEntryOrDefault(bindingName);
	      const elements = flatMap(bindingName.elements, (element) => {
	        if (isOmittedExpression(element))
	          return [];
	        return [getMappedBindingNameOrDefault(element.name)];
	      });
	      return createSynthBindingPattern(bindingName, elements);
	    }
	    function getMapEntryOrDefault(identifier) {
	      const originalNode = getOriginalNode2(identifier);
	      const symbol = getSymbol2(originalNode);
	      if (!symbol) {
	        return createSynthIdentifier(identifier, types);
	      }
	      const mapEntry = transformer.synthNamesMap.get(getSymbolId(symbol).toString());
	      return mapEntry || createSynthIdentifier(identifier, types);
	    }
	    function getSymbol2(node) {
	      var _a;
	      return ((_a = tryCast(node, canHaveSymbol)) == null ? void 0 : _a.symbol) ?? transformer.checker.getSymbolAtLocation(node);
	    }
	    function getOriginalNode2(node) {
	      return node.original ? node.original : node;
	    }
	  }
	  function isEmptyBindingName(bindingName) {
	    if (!bindingName) {
	      return true;
	    }
	    if (isSynthIdentifier(bindingName)) {
	      return !bindingName.identifier.text;
	    }
	    return every(bindingName.elements, isEmptyBindingName);
	  }
	  function createSynthIdentifier(identifier, types = []) {
	    return { kind: 0 /* Identifier */, identifier, types, hasBeenDeclared: false, hasBeenReferenced: false };
	  }
	  function createSynthBindingPattern(bindingPattern, elements = emptyArray, types = []) {
	    return { kind: 1 /* BindingPattern */, bindingPattern, elements, types };
	  }
	  function referenceSynthIdentifier(synthId) {
	    synthId.hasBeenReferenced = true;
	    return synthId.identifier;
	  }
	  function declareSynthBindingName(synthName) {
	    return isSynthIdentifier(synthName) ? declareSynthIdentifier(synthName) : declareSynthBindingPattern(synthName);
	  }
	  function declareSynthBindingPattern(synthPattern) {
	    for (const element of synthPattern.elements) {
	      declareSynthBindingName(element);
	    }
	    return synthPattern.bindingPattern;
	  }
	  function declareSynthIdentifier(synthId) {
	    synthId.hasBeenDeclared = true;
	    return synthId.identifier;
	  }
	  function isSynthIdentifier(bindingName) {
	    return bindingName.kind === 0 /* Identifier */;
	  }
	  function isSynthBindingPattern(bindingName) {
	    return bindingName.kind === 1 /* BindingPattern */;
	  }
	  function shouldReturn(expression, transformer) {
	    return !!expression.original && transformer.setOfExpressionsToReturn.has(getNodeId(expression.original));
	  }
	  var fixId10, errorCodes11, codeActionSucceeded;
	  var init_convertToAsyncFunction = __esm({
	    "src/services/codefixes/convertToAsyncFunction.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      fixId10 = "convertToAsyncFunction";
	      errorCodes11 = [Diagnostics.This_may_be_converted_to_an_async_function.code];
	      codeActionSucceeded = true;
	      registerCodeFix({
	        errorCodes: errorCodes11,
	        getCodeActions(context) {
	          codeActionSucceeded = true;
	          const changes = ts_textChanges_exports.ChangeTracker.with(context, (t) => convertToAsyncFunction(t, context.sourceFile, context.span.start, context.program.getTypeChecker()));
	          return codeActionSucceeded ? [createCodeFixAction(fixId10, changes, Diagnostics.Convert_to_async_function, fixId10, Diagnostics.Convert_all_to_async_functions)] : [];
	        },
	        fixIds: [fixId10],
	        getAllCodeActions: (context) => codeFixAll(context, errorCodes11, (changes, err) => convertToAsyncFunction(changes, err.file, err.start, context.program.getTypeChecker()))
	      });
	    }
	  });

	  // src/services/codefixes/convertToEsModule.ts
	  function fixImportOfModuleExports(importingFile, exportingFile, program, changes, quotePreference) {
	    var _a;
	    for (const moduleSpecifier of importingFile.imports) {
	      const imported = (_a = program.getResolvedModuleFromModuleSpecifier(moduleSpecifier)) == null ? void 0 : _a.resolvedModule;
	      if (!imported || imported.resolvedFileName !== exportingFile.fileName) {
	        continue;
	      }
	      const importNode = importFromModuleSpecifier(moduleSpecifier);
	      switch (importNode.kind) {
	        case 271 /* ImportEqualsDeclaration */:
	          changes.replaceNode(importingFile, importNode, makeImport(
	            importNode.name,
	            /*namedImports*/
	            void 0,
	            moduleSpecifier,
	            quotePreference
	          ));
	          break;
	        case 213 /* CallExpression */:
	          if (isRequireCall(
	            importNode,
	            /*requireStringLiteralLikeArgument*/
	            false
	          )) {
	            changes.replaceNode(importingFile, importNode, factory.createPropertyAccessExpression(getSynthesizedDeepClone(importNode), "default"));
	          }
	          break;
	      }
	    }
	  }
	  function convertFileToEsModule(sourceFile, checker, changes, target, quotePreference) {
	    const identifiers = { original: collectFreeIdentifiers(sourceFile), additional: /* @__PURE__ */ new Set() };
	    const exports = collectExportRenames(sourceFile, checker, identifiers);
	    convertExportsAccesses(sourceFile, exports, changes);
	    let moduleExportsChangedToDefault = false;
	    let useSitesToUnqualify;
	    for (const statement of filter(sourceFile.statements, isVariableStatement)) {
	      const newUseSites = convertVariableStatement(sourceFile, statement, changes, checker, identifiers, target, quotePreference);
	      if (newUseSites) {
	        copyEntries(newUseSites, useSitesToUnqualify ?? (useSitesToUnqualify = /* @__PURE__ */ new Map()));
	      }
	    }
	    for (const statement of filter(sourceFile.statements, (s) => !isVariableStatement(s))) {
	      const moduleExportsChanged = convertStatement(sourceFile, statement, checker, changes, identifiers, target, exports, useSitesToUnqualify, quotePreference);
	      moduleExportsChangedToDefault = moduleExportsChangedToDefault || moduleExportsChanged;
	    }
	    useSitesToUnqualify == null ? void 0 : useSitesToUnqualify.forEach((replacement, original) => {
	      changes.replaceNode(sourceFile, original, replacement);
	    });
	    return moduleExportsChangedToDefault;
	  }
	  function collectExportRenames(sourceFile, checker, identifiers) {
	    const res = /* @__PURE__ */ new Map();
	    forEachExportReference(sourceFile, (node) => {
	      const { text } = node.name;
	      if (!res.has(text) && (isIdentifierANonContextualKeyword(node.name) || checker.resolveName(
	        text,
	        node,
	        111551 /* Value */,
	        /*excludeGlobals*/
	        true
	      ))) {
	        res.set(text, makeUniqueName(`_${text}`, identifiers));
	      }
	    });
	    return res;
	  }
	  function convertExportsAccesses(sourceFile, exports, changes) {
	    forEachExportReference(sourceFile, (node, isAssignmentLhs) => {
	      if (isAssignmentLhs) {
	        return;
	      }
	      const { text } = node.name;
	      changes.replaceNode(sourceFile, node, factory.createIdentifier(exports.get(text) || text));
	    });
	  }
	  function forEachExportReference(sourceFile, cb) {
	    sourceFile.forEachChild(function recur(node) {
	      if (isPropertyAccessExpression(node) && isExportsOrModuleExportsOrAlias(sourceFile, node.expression) && isIdentifier(node.name)) {
	        const { parent: parent2 } = node;
	        cb(node, isBinaryExpression(parent2) && parent2.left === node && parent2.operatorToken.kind === 64 /* EqualsToken */);
	      }
	      node.forEachChild(recur);
	    });
	  }
	  function convertStatement(sourceFile, statement, checker, changes, identifiers, target, exports, useSitesToUnqualify, quotePreference) {
	    switch (statement.kind) {
	      case 243 /* VariableStatement */:
	        convertVariableStatement(sourceFile, statement, changes, checker, identifiers, target, quotePreference);
	        return false;
	      case 244 /* ExpressionStatement */: {
	        const { expression } = statement;
	        switch (expression.kind) {
	          case 213 /* CallExpression */: {
	            if (isRequireCall(
	              expression,
	              /*requireStringLiteralLikeArgument*/
	              true
	            )) {
	              changes.replaceNode(sourceFile, statement, makeImport(
	                /*defaultImport*/
	                void 0,
	                /*namedImports*/
	                void 0,
	                expression.arguments[0],
	                quotePreference
	              ));
	            }
	            return false;
	          }
	          case 226 /* BinaryExpression */: {
	            const { operatorToken } = expression;
	            return operatorToken.kind === 64 /* EqualsToken */ && convertAssignment(sourceFile, checker, expression, changes, exports, useSitesToUnqualify);
	          }
	        }
	      }
	      default:
	        return false;
	    }
	  }
	  function convertVariableStatement(sourceFile, statement, changes, checker, identifiers, target, quotePreference) {
	    const { declarationList } = statement;
	    let foundImport = false;
	    const converted = map(declarationList.declarations, (decl) => {
	      const { name, initializer } = decl;
	      if (initializer) {
	        if (isExportsOrModuleExportsOrAlias(sourceFile, initializer)) {
	          foundImport = true;
	          return convertedImports([]);
	        } else if (isRequireCall(
	          initializer,
	          /*requireStringLiteralLikeArgument*/
	          true
	        )) {
	          foundImport = true;
	          return convertSingleImport(name, initializer.arguments[0], checker, identifiers, target, quotePreference);
	        } else if (isPropertyAccessExpression(initializer) && isRequireCall(
	          initializer.expression,
	          /*requireStringLiteralLikeArgument*/
	          true
	        )) {
	          foundImport = true;
	          return convertPropertyAccessImport(name, initializer.name.text, initializer.expression.arguments[0], identifiers, quotePreference);
	        }
	      }
	      return convertedImports([factory.createVariableStatement(
	        /*modifiers*/
	        void 0,
	        factory.createVariableDeclarationList([decl], declarationList.flags)
	      )]);
	    });
	    if (foundImport) {
	      changes.replaceNodeWithNodes(sourceFile, statement, flatMap(converted, (c) => c.newImports));
	      let combinedUseSites;
	      forEach(converted, (c) => {
	        if (c.useSitesToUnqualify) {
	          copyEntries(c.useSitesToUnqualify, combinedUseSites ?? (combinedUseSites = /* @__PURE__ */ new Map()));
	        }
	      });
	      return combinedUseSites;
	    }
	  }
	  function convertPropertyAccessImport(name, propertyName, moduleSpecifier, identifiers, quotePreference) {
	    switch (name.kind) {
	      case 206 /* ObjectBindingPattern */:
	      case 207 /* ArrayBindingPattern */: {
	        const tmp = makeUniqueName(propertyName, identifiers);
	        return convertedImports([
	          makeSingleImport(tmp, propertyName, moduleSpecifier, quotePreference),
	          makeConst(
	            /*modifiers*/
	            void 0,
	            name,
	            factory.createIdentifier(tmp)
	          )
	        ]);
	      }
	      case 80 /* Identifier */:
	        return convertedImports([makeSingleImport(name.text, propertyName, moduleSpecifier, quotePreference)]);
	      default:
	        return Debug.assertNever(name, `Convert to ES module got invalid syntax form ${name.kind}`);
	    }
	  }
	  function convertAssignment(sourceFile, checker, assignment, changes, exports, useSitesToUnqualify) {
	    const { left, right } = assignment;
	    if (!isPropertyAccessExpression(left)) {
	      return false;
	    }
	    if (isExportsOrModuleExportsOrAlias(sourceFile, left)) {
	      if (isExportsOrModuleExportsOrAlias(sourceFile, right)) {
	        changes.delete(sourceFile, assignment.parent);
	      } else {
	        const replacement = isObjectLiteralExpression(right) ? tryChangeModuleExportsObject(right, useSitesToUnqualify) : isRequireCall(
	          right,
	          /*requireStringLiteralLikeArgument*/
	          true
	        ) ? convertReExportAll(right.arguments[0], checker) : void 0;
	        if (replacement) {
	          changes.replaceNodeWithNodes(sourceFile, assignment.parent, replacement[0]);
	          return replacement[1];
	        } else {
	          changes.replaceRangeWithText(sourceFile, createRange(left.getStart(sourceFile), right.pos), "export default");
	          return true;
	        }
	      }
	    } else if (isExportsOrModuleExportsOrAlias(sourceFile, left.expression)) {
	      convertNamedExport(sourceFile, assignment, changes, exports);
	    }
	    return false;
	  }
	  function tryChangeModuleExportsObject(object, useSitesToUnqualify) {
	    const statements = mapAllOrFail(object.properties, (prop) => {
	      switch (prop.kind) {
	        case 177 /* GetAccessor */:
	        case 178 /* SetAccessor */:
	        case 304 /* ShorthandPropertyAssignment */:
	        case 305 /* SpreadAssignment */:
	          return void 0;
	        case 303 /* PropertyAssignment */:
	          return !isIdentifier(prop.name) ? void 0 : convertExportsDotXEquals_replaceNode(prop.name.text, prop.initializer, useSitesToUnqualify);
	        case 174 /* MethodDeclaration */:
	          return !isIdentifier(prop.name) ? void 0 : functionExpressionToDeclaration(prop.name.text, [factory.createToken(95 /* ExportKeyword */)], prop, useSitesToUnqualify);
	        default:
	          Debug.assertNever(prop, `Convert to ES6 got invalid prop kind ${prop.kind}`);
	      }
	    });
	    return statements && [statements, false];
	  }
	  function convertNamedExport(sourceFile, assignment, changes, exports) {
	    const { text } = assignment.left.name;
	    const rename = exports.get(text);
	    if (rename !== void 0) {
	      const newNodes = [
	        makeConst(
	          /*modifiers*/
	          void 0,
	          rename,
	          assignment.right
	        ),
	        makeExportDeclaration([factory.createExportSpecifier(
	          /*isTypeOnly*/
	          false,
	          rename,
	          text
	        )])
	      ];
	      changes.replaceNodeWithNodes(sourceFile, assignment.parent, newNodes);
	    } else {
	      convertExportsPropertyAssignment(assignment, sourceFile, changes);
	    }
	  }
	  function convertReExportAll(reExported, checker) {
	    const moduleSpecifier = reExported.text;
	    const moduleSymbol = checker.getSymbolAtLocation(reExported);
	    const exports = moduleSymbol ? moduleSymbol.exports : emptyMap;
	    return exports.has("export=" /* ExportEquals */) ? [[reExportDefault(moduleSpecifier)], true] : !exports.has("default" /* Default */) ? [[reExportStar(moduleSpecifier)], false] : (
	      // If there's some non-default export, must include both `export *` and `export default`.
	      exports.size > 1 ? [[reExportStar(moduleSpecifier), reExportDefault(moduleSpecifier)], true] : [[reExportDefault(moduleSpecifier)], true]
	    );
	  }
	  function reExportStar(moduleSpecifier) {
	    return makeExportDeclaration(
	      /*exportSpecifiers*/
	      void 0,
	      moduleSpecifier
	    );
	  }
	  function reExportDefault(moduleSpecifier) {
	    return makeExportDeclaration([factory.createExportSpecifier(
	      /*isTypeOnly*/
	      false,
	      /*propertyName*/
	      void 0,
	      "default"
	    )], moduleSpecifier);
	  }
	  function convertExportsPropertyAssignment({ left, right, parent: parent2 }, sourceFile, changes) {
	    const name = left.name.text;
	    if ((isFunctionExpression(right) || isArrowFunction(right) || isClassExpression(right)) && (!right.name || right.name.text === name)) {
	      changes.replaceRange(sourceFile, { pos: left.getStart(sourceFile), end: right.getStart(sourceFile) }, factory.createToken(95 /* ExportKeyword */), { suffix: " " });
	      if (!right.name)
	        changes.insertName(sourceFile, right, name);
	      const semi = findChildOfKind(parent2, 27 /* SemicolonToken */, sourceFile);
	      if (semi)
	        changes.delete(sourceFile, semi);
	    } else {
	      changes.replaceNodeRangeWithNodes(sourceFile, left.expression, findChildOfKind(left, 25 /* DotToken */, sourceFile), [factory.createToken(95 /* ExportKeyword */), factory.createToken(87 /* ConstKeyword */)], { joiner: " ", suffix: " " });
	    }
	  }
	  function convertExportsDotXEquals_replaceNode(name, exported, useSitesToUnqualify) {
	    const modifiers = [factory.createToken(95 /* ExportKeyword */)];
	    switch (exported.kind) {
	      case 218 /* FunctionExpression */: {
	        const { name: expressionName } = exported;
	        if (expressionName && expressionName.text !== name) {
	          return exportConst();
	        }
	      }
	      case 219 /* ArrowFunction */:
	        return functionExpressionToDeclaration(name, modifiers, exported, useSitesToUnqualify);
	      case 231 /* ClassExpression */:
	        return classExpressionToDeclaration(name, modifiers, exported, useSitesToUnqualify);
	      default:
	        return exportConst();
	    }
	    function exportConst() {
	      return makeConst(modifiers, factory.createIdentifier(name), replaceImportUseSites(exported, useSitesToUnqualify));
	    }
	  }
	  function replaceImportUseSites(nodeOrNodes, useSitesToUnqualify) {
	    if (!useSitesToUnqualify || !some(arrayFrom(useSitesToUnqualify.keys()), (original) => rangeContainsRange(nodeOrNodes, original))) {
	      return nodeOrNodes;
	    }
	    return isArray(nodeOrNodes) ? getSynthesizedDeepClonesWithReplacements(
	      nodeOrNodes,
	      /*includeTrivia*/
	      true,
	      replaceNode
	    ) : getSynthesizedDeepCloneWithReplacements(
	      nodeOrNodes,
	      /*includeTrivia*/
	      true,
	      replaceNode
	    );
	    function replaceNode(original) {
	      if (original.kind === 211 /* PropertyAccessExpression */) {
	        const replacement = useSitesToUnqualify.get(original);
	        useSitesToUnqualify.delete(original);
	        return replacement;
	      }
	    }
	  }
	  function convertSingleImport(name, moduleSpecifier, checker, identifiers, target, quotePreference) {
	    switch (name.kind) {
	      case 206 /* ObjectBindingPattern */: {
	        const importSpecifiers = mapAllOrFail(name.elements, (e) => e.dotDotDotToken || e.initializer || e.propertyName && !isIdentifier(e.propertyName) || !isIdentifier(e.name) ? void 0 : makeImportSpecifier2(e.propertyName && e.propertyName.text, e.name.text));
	        if (importSpecifiers) {
	          return convertedImports([makeImport(
	            /*defaultImport*/
	            void 0,
	            importSpecifiers,
	            moduleSpecifier,
	            quotePreference
	          )]);
	        }
	      }
	      case 207 /* ArrayBindingPattern */: {
	        const tmp = makeUniqueName(moduleSpecifierToValidIdentifier(moduleSpecifier.text, target), identifiers);
	        return convertedImports([
	          makeImport(
	            factory.createIdentifier(tmp),
	            /*namedImports*/
	            void 0,
	            moduleSpecifier,
	            quotePreference
	          ),
	          makeConst(
	            /*modifiers*/
	            void 0,
	            getSynthesizedDeepClone(name),
	            factory.createIdentifier(tmp)
	          )
	        ]);
	      }
	      case 80 /* Identifier */:
	        return convertSingleIdentifierImport(name, moduleSpecifier, checker, identifiers, quotePreference);
	      default:
	        return Debug.assertNever(name, `Convert to ES module got invalid name kind ${name.kind}`);
	    }
	  }
	  function convertSingleIdentifierImport(name, moduleSpecifier, checker, identifiers, quotePreference) {
	    const nameSymbol = checker.getSymbolAtLocation(name);
	    const namedBindingsNames = /* @__PURE__ */ new Map();
	    let needDefaultImport = false;
	    let useSitesToUnqualify;
	    for (const use of identifiers.original.get(name.text)) {
	      if (checker.getSymbolAtLocation(use) !== nameSymbol || use === name) {
	        continue;
	      }
	      const { parent: parent2 } = use;
	      if (isPropertyAccessExpression(parent2)) {
	        const { name: { text: propertyName } } = parent2;
	        if (propertyName === "default") {
	          needDefaultImport = true;
	          const importDefaultName = use.getText();
	          (useSitesToUnqualify ?? (useSitesToUnqualify = /* @__PURE__ */ new Map())).set(parent2, factory.createIdentifier(importDefaultName));
	        } else {
	          Debug.assert(parent2.expression === use, "Didn't expect expression === use");
	          let idName = namedBindingsNames.get(propertyName);
	          if (idName === void 0) {
	            idName = makeUniqueName(propertyName, identifiers);
	            namedBindingsNames.set(propertyName, idName);
	          }
	          (useSitesToUnqualify ?? (useSitesToUnqualify = /* @__PURE__ */ new Map())).set(parent2, factory.createIdentifier(idName));
	        }
	      } else {
	        needDefaultImport = true;
	      }
	    }
	    const namedBindings = namedBindingsNames.size === 0 ? void 0 : arrayFrom(mapIterator(namedBindingsNames.entries(), ([propertyName, idName]) => factory.createImportSpecifier(
	      /*isTypeOnly*/
	      false,
	      propertyName === idName ? void 0 : factory.createIdentifier(propertyName),
	      factory.createIdentifier(idName)
	    )));
	    if (!namedBindings) {
	      needDefaultImport = true;
	    }
	    return convertedImports(
	      [makeImport(needDefaultImport ? getSynthesizedDeepClone(name) : void 0, namedBindings, moduleSpecifier, quotePreference)],
	      useSitesToUnqualify
	    );
	  }
	  function makeUniqueName(name, identifiers) {
	    while (identifiers.original.has(name) || identifiers.additional.has(name)) {
	      name = `_${name}`;
	    }
	    identifiers.additional.add(name);
	    return name;
	  }
	  function collectFreeIdentifiers(file) {
	    const map2 = createMultiMap();
	    forEachFreeIdentifier(file, (id) => map2.add(id.text, id));
	    return map2;
	  }
	  function forEachFreeIdentifier(node, cb) {
	    if (isIdentifier(node) && isFreeIdentifier(node))
	      cb(node);
	    node.forEachChild((child) => forEachFreeIdentifier(child, cb));
	  }
	  function isFreeIdentifier(node) {
	    const { parent: parent2 } = node;
	    switch (parent2.kind) {
	      case 211 /* PropertyAccessExpression */:
	        return parent2.name !== node;
	      case 208 /* BindingElement */:
	        return parent2.propertyName !== node;
	      case 276 /* ImportSpecifier */:
	        return parent2.propertyName !== node;
	      default:
	        return true;
	    }
	  }
	  function functionExpressionToDeclaration(name, additionalModifiers, fn, useSitesToUnqualify) {
	    return factory.createFunctionDeclaration(
	      concatenate(additionalModifiers, getSynthesizedDeepClones(fn.modifiers)),
	      getSynthesizedDeepClone(fn.asteriskToken),
	      name,
	      getSynthesizedDeepClones(fn.typeParameters),
	      getSynthesizedDeepClones(fn.parameters),
	      getSynthesizedDeepClone(fn.type),
	      factory.converters.convertToFunctionBlock(replaceImportUseSites(fn.body, useSitesToUnqualify))
	    );
	  }
	  function classExpressionToDeclaration(name, additionalModifiers, cls, useSitesToUnqualify) {
	    return factory.createClassDeclaration(
	      concatenate(additionalModifiers, getSynthesizedDeepClones(cls.modifiers)),
	      name,
	      getSynthesizedDeepClones(cls.typeParameters),
	      getSynthesizedDeepClones(cls.heritageClauses),
	      replaceImportUseSites(cls.members, useSitesToUnqualify)
	    );
	  }
	  function makeSingleImport(localName, propertyName, moduleSpecifier, quotePreference) {
	    return propertyName === "default" ? makeImport(
	      factory.createIdentifier(localName),
	      /*namedImports*/
	      void 0,
	      moduleSpecifier,
	      quotePreference
	    ) : makeImport(
	      /*defaultImport*/
	      void 0,
	      [makeImportSpecifier2(propertyName, localName)],
	      moduleSpecifier,
	      quotePreference
	    );
	  }
	  function makeImportSpecifier2(propertyName, name) {
	    return factory.createImportSpecifier(
	      /*isTypeOnly*/
	      false,
	      propertyName !== void 0 && propertyName !== name ? factory.createIdentifier(propertyName) : void 0,
	      factory.createIdentifier(name)
	    );
	  }
	  function makeConst(modifiers, name, init) {
	    return factory.createVariableStatement(
	      modifiers,
	      factory.createVariableDeclarationList(
	        [factory.createVariableDeclaration(
	          name,
	          /*exclamationToken*/
	          void 0,
	          /*type*/
	          void 0,
	          init
	        )],
	        2 /* Const */
	      )
	    );
	  }
	  function makeExportDeclaration(exportSpecifiers, moduleSpecifier) {
	    return factory.createExportDeclaration(
	      /*modifiers*/
	      void 0,
	      /*isTypeOnly*/
	      false,
	      exportSpecifiers && factory.createNamedExports(exportSpecifiers),
	      moduleSpecifier === void 0 ? void 0 : factory.createStringLiteral(moduleSpecifier)
	    );
	  }
	  function convertedImports(newImports, useSitesToUnqualify) {
	    return {
	      newImports,
	      useSitesToUnqualify
	    };
	  }
	  var init_convertToEsModule = __esm({
	    "src/services/codefixes/convertToEsModule.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      registerCodeFix({
	        errorCodes: [Diagnostics.File_is_a_CommonJS_module_it_may_be_converted_to_an_ES_module.code],
	        getCodeActions(context) {
	          const { sourceFile, program, preferences } = context;
	          const changes = ts_textChanges_exports.ChangeTracker.with(context, (changes2) => {
	            const moduleExportsChangedToDefault = convertFileToEsModule(sourceFile, program.getTypeChecker(), changes2, getEmitScriptTarget(program.getCompilerOptions()), getQuotePreference(sourceFile, preferences));
	            if (moduleExportsChangedToDefault) {
	              for (const importingFile of program.getSourceFiles()) {
	                fixImportOfModuleExports(importingFile, sourceFile, program, changes2, getQuotePreference(importingFile, preferences));
	              }
	            }
	          });
	          return [createCodeFixActionWithoutFixAll("convertToEsModule", changes, Diagnostics.Convert_to_ES_module)];
	        }
	      });
	    }
	  });

	  // src/services/codefixes/correctQualifiedNameToIndexedAccessType.ts
	  function getQualifiedName(sourceFile, pos) {
	    const qualifiedName = findAncestor(getTokenAtPosition(sourceFile, pos), isQualifiedName);
	    Debug.assert(!!qualifiedName, "Expected position to be owned by a qualified name.");
	    return isIdentifier(qualifiedName.left) ? qualifiedName : void 0;
	  }
	  function doChange10(changeTracker, sourceFile, qualifiedName) {
	    const rightText = qualifiedName.right.text;
	    const replacement = factory.createIndexedAccessTypeNode(
	      factory.createTypeReferenceNode(
	        qualifiedName.left,
	        /*typeArguments*/
	        void 0
	      ),
	      factory.createLiteralTypeNode(factory.createStringLiteral(rightText))
	    );
	    changeTracker.replaceNode(sourceFile, qualifiedName, replacement);
	  }
	  var fixId11, errorCodes12;
	  var init_correctQualifiedNameToIndexedAccessType = __esm({
	    "src/services/codefixes/correctQualifiedNameToIndexedAccessType.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      fixId11 = "correctQualifiedNameToIndexedAccessType";
	      errorCodes12 = [Diagnostics.Cannot_access_0_1_because_0_is_a_type_but_not_a_namespace_Did_you_mean_to_retrieve_the_type_of_the_property_1_in_0_with_0_1.code];
	      registerCodeFix({
	        errorCodes: errorCodes12,
	        getCodeActions(context) {
	          const qualifiedName = getQualifiedName(context.sourceFile, context.span.start);
	          if (!qualifiedName)
	            return void 0;
	          const changes = ts_textChanges_exports.ChangeTracker.with(context, (t) => doChange10(t, context.sourceFile, qualifiedName));
	          const newText = `${qualifiedName.left.text}["${qualifiedName.right.text}"]`;
	          return [createCodeFixAction(fixId11, changes, [Diagnostics.Rewrite_as_the_indexed_access_type_0, newText], fixId11, Diagnostics.Rewrite_all_as_indexed_access_types)];
	        },
	        fixIds: [fixId11],
	        getAllCodeActions: (context) => codeFixAll(context, errorCodes12, (changes, diag2) => {
	          const q = getQualifiedName(diag2.file, diag2.start);
	          if (q) {
	            doChange10(changes, diag2.file, q);
	          }
	        })
	      });
	    }
	  });

	  // src/services/codefixes/convertToTypeOnlyExport.ts
	  function getExportSpecifierForDiagnosticSpan(span, sourceFile) {
	    return tryCast(getTokenAtPosition(sourceFile, span.start).parent, isExportSpecifier);
	  }
	  function fixSingleExportDeclaration(changes, exportSpecifier, context) {
	    if (!exportSpecifier) {
	      return;
	    }
	    const exportClause = exportSpecifier.parent;
	    const exportDeclaration = exportClause.parent;
	    const typeExportSpecifiers = getTypeExportSpecifiers(exportSpecifier, context);
	    if (typeExportSpecifiers.length === exportClause.elements.length) {
	      changes.insertModifierBefore(context.sourceFile, 156 /* TypeKeyword */, exportClause);
	    } else {
	      const valueExportDeclaration = factory.updateExportDeclaration(
	        exportDeclaration,
	        exportDeclaration.modifiers,
	        /*isTypeOnly*/
	        false,
	        factory.updateNamedExports(exportClause, filter(exportClause.elements, (e) => !contains(typeExportSpecifiers, e))),
	        exportDeclaration.moduleSpecifier,
	        /*attributes*/
	        void 0
	      );
	      const typeExportDeclaration = factory.createExportDeclaration(
	        /*modifiers*/
	        void 0,
	        /*isTypeOnly*/
	        true,
	        factory.createNamedExports(typeExportSpecifiers),
	        exportDeclaration.moduleSpecifier,
	        /*attributes*/
	        void 0
	      );
	      changes.replaceNode(context.sourceFile, exportDeclaration, valueExportDeclaration, {
	        leadingTriviaOption: ts_textChanges_exports.LeadingTriviaOption.IncludeAll,
	        trailingTriviaOption: ts_textChanges_exports.TrailingTriviaOption.Exclude
	      });
	      changes.insertNodeAfter(context.sourceFile, exportDeclaration, typeExportDeclaration);
	    }
	  }
	  function getTypeExportSpecifiers(originExportSpecifier, context) {
	    const exportClause = originExportSpecifier.parent;
	    if (exportClause.elements.length === 1) {
	      return exportClause.elements;
	    }
	    const diagnostics = getDiagnosticsWithinSpan(
	      createTextSpanFromNode(exportClause),
	      context.program.getSemanticDiagnostics(context.sourceFile, context.cancellationToken)
	    );
	    return filter(exportClause.elements, (element) => {
	      var _a;
	      return element === originExportSpecifier || ((_a = findDiagnosticForNode(element, diagnostics)) == null ? void 0 : _a.code) === errorCodes13[0];
	    });
	  }
	  var errorCodes13, fixId12;
	  var init_convertToTypeOnlyExport = __esm({
	    "src/services/codefixes/convertToTypeOnlyExport.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      errorCodes13 = [Diagnostics.Re_exporting_a_type_when_0_is_enabled_requires_using_export_type.code];
	      fixId12 = "convertToTypeOnlyExport";
	      registerCodeFix({
	        errorCodes: errorCodes13,
	        getCodeActions: function getCodeActionsToConvertToTypeOnlyExport(context) {
	          const changes = ts_textChanges_exports.ChangeTracker.with(context, (t) => fixSingleExportDeclaration(t, getExportSpecifierForDiagnosticSpan(context.span, context.sourceFile), context));
	          if (changes.length) {
	            return [createCodeFixAction(fixId12, changes, Diagnostics.Convert_to_type_only_export, fixId12, Diagnostics.Convert_all_re_exported_types_to_type_only_exports)];
	          }
	        },
	        fixIds: [fixId12],
	        getAllCodeActions: function getAllCodeActionsToConvertToTypeOnlyExport(context) {
	          const fixedExportDeclarations = /* @__PURE__ */ new Map();
	          return codeFixAll(context, errorCodes13, (changes, diag2) => {
	            const exportSpecifier = getExportSpecifierForDiagnosticSpan(diag2, context.sourceFile);
	            if (exportSpecifier && addToSeen(fixedExportDeclarations, getNodeId(exportSpecifier.parent.parent))) {
	              fixSingleExportDeclaration(changes, exportSpecifier, context);
	            }
	          });
	        }
	      });
	    }
	  });

	  // src/services/codefixes/convertToTypeOnlyImport.ts
	  function getDeclaration2(sourceFile, pos) {
	    const { parent: parent2 } = getTokenAtPosition(sourceFile, pos);
	    return isImportSpecifier(parent2) || isImportDeclaration(parent2) && parent2.importClause ? parent2 : void 0;
	  }
	  function canConvertImportDeclarationForSpecifier(specifier, sourceFile, program) {
	    if (specifier.parent.parent.name) {
	      return false;
	    }
	    const nonTypeOnlySpecifiers = specifier.parent.elements.filter((e) => !e.isTypeOnly);
	    if (nonTypeOnlySpecifiers.length === 1) {
	      return true;
	    }
	    const checker = program.getTypeChecker();
	    for (const specifier2 of nonTypeOnlySpecifiers) {
	      const isUsedAsValue = ts_FindAllReferences_exports.Core.eachSymbolReferenceInFile(specifier2.name, checker, sourceFile, (usage) => {
	        return !isValidTypeOnlyAliasUseSite(usage);
	      });
	      if (isUsedAsValue) {
	        return false;
	      }
	    }
	    return true;
	  }
	  function doChange11(changes, sourceFile, declaration) {
	    var _a;
	    if (isImportSpecifier(declaration)) {
	      changes.replaceNode(sourceFile, declaration, factory.updateImportSpecifier(
	        declaration,
	        /*isTypeOnly*/
	        true,
	        declaration.propertyName,
	        declaration.name
	      ));
	    } else {
	      const importClause = declaration.importClause;
	      if (importClause.name && importClause.namedBindings) {
	        changes.replaceNodeWithNodes(sourceFile, declaration, [
	          factory.createImportDeclaration(
	            getSynthesizedDeepClones(
	              declaration.modifiers,
	              /*includeTrivia*/
	              true
	            ),
	            factory.createImportClause(
	              /*isTypeOnly*/
	              true,
	              getSynthesizedDeepClone(
	                importClause.name,
	                /*includeTrivia*/
	                true
	              ),
	              /*namedBindings*/
	              void 0
	            ),
	            getSynthesizedDeepClone(
	              declaration.moduleSpecifier,
	              /*includeTrivia*/
	              true
	            ),
	            getSynthesizedDeepClone(
	              declaration.attributes,
	              /*includeTrivia*/
	              true
	            )
	          ),
	          factory.createImportDeclaration(
	            getSynthesizedDeepClones(
	              declaration.modifiers,
	              /*includeTrivia*/
	              true
	            ),
	            factory.createImportClause(
	              /*isTypeOnly*/
	              true,
	              /*name*/
	              void 0,
	              getSynthesizedDeepClone(
	                importClause.namedBindings,
	                /*includeTrivia*/
	                true
	              )
	            ),
	            getSynthesizedDeepClone(
	              declaration.moduleSpecifier,
	              /*includeTrivia*/
	              true
	            ),
	            getSynthesizedDeepClone(
	              declaration.attributes,
	              /*includeTrivia*/
	              true
	            )
	          )
	        ]);
	      } else {
	        const newNamedBindings = ((_a = importClause.namedBindings) == null ? void 0 : _a.kind) === 275 /* NamedImports */ ? factory.updateNamedImports(
	          importClause.namedBindings,
	          sameMap(importClause.namedBindings.elements, (e) => factory.updateImportSpecifier(
	            e,
	            /*isTypeOnly*/
	            false,
	            e.propertyName,
	            e.name
	          ))
	        ) : importClause.namedBindings;
	        const importDeclaration = factory.updateImportDeclaration(declaration, declaration.modifiers, factory.updateImportClause(
	          importClause,
	          /*isTypeOnly*/
	          true,
	          importClause.name,
	          newNamedBindings
	        ), declaration.moduleSpecifier, declaration.attributes);
	        changes.replaceNode(sourceFile, declaration, importDeclaration);
	      }
	    }
	  }
	  var errorCodes14, fixId13;
	  var init_convertToTypeOnlyImport = __esm({
	    "src/services/codefixes/convertToTypeOnlyImport.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      errorCodes14 = [
	        Diagnostics.This_import_is_never_used_as_a_value_and_must_use_import_type_because_importsNotUsedAsValues_is_set_to_error.code,
	        Diagnostics._0_is_a_type_and_must_be_imported_using_a_type_only_import_when_verbatimModuleSyntax_is_enabled.code,
	        Diagnostics._0_resolves_to_a_type_only_declaration_and_must_be_imported_using_a_type_only_import_when_verbatimModuleSyntax_is_enabled.code
	      ];
	      fixId13 = "convertToTypeOnlyImport";
	      registerCodeFix({
	        errorCodes: errorCodes14,
	        getCodeActions: function getCodeActionsToConvertToTypeOnlyImport(context) {
	          var _a;
	          const declaration = getDeclaration2(context.sourceFile, context.span.start);
	          if (declaration) {
	            const changes = ts_textChanges_exports.ChangeTracker.with(context, (t) => doChange11(t, context.sourceFile, declaration));
	            const importDeclarationChanges = declaration.kind === 276 /* ImportSpecifier */ && canConvertImportDeclarationForSpecifier(declaration, context.sourceFile, context.program) ? ts_textChanges_exports.ChangeTracker.with(context, (t) => doChange11(t, context.sourceFile, declaration.parent.parent.parent)) : void 0;
	            const mainAction = createCodeFixAction(
	              fixId13,
	              changes,
	              declaration.kind === 276 /* ImportSpecifier */ ? [Diagnostics.Use_type_0, ((_a = declaration.propertyName) == null ? void 0 : _a.text) ?? declaration.name.text] : Diagnostics.Use_import_type,
	              fixId13,
	              Diagnostics.Fix_all_with_type_only_imports
	            );
	            if (some(importDeclarationChanges)) {
	              return [
	                createCodeFixActionWithoutFixAll(fixId13, importDeclarationChanges, Diagnostics.Use_import_type),
	                mainAction
	              ];
	            }
	            return [mainAction];
	          }
	          return void 0;
	        },
	        fixIds: [fixId13],
	        getAllCodeActions: function getAllCodeActionsToConvertToTypeOnlyImport(context) {
	          const fixedImportDeclarations = /* @__PURE__ */ new Set();
	          return codeFixAll(context, errorCodes14, (changes, diag2) => {
	            const errorDeclaration = getDeclaration2(diag2.file, diag2.start);
	            if ((errorDeclaration == null ? void 0 : errorDeclaration.kind) === 272 /* ImportDeclaration */ && !fixedImportDeclarations.has(errorDeclaration)) {
	              doChange11(changes, diag2.file, errorDeclaration);
	              fixedImportDeclarations.add(errorDeclaration);
	            } else if ((errorDeclaration == null ? void 0 : errorDeclaration.kind) === 276 /* ImportSpecifier */ && !fixedImportDeclarations.has(errorDeclaration.parent.parent.parent) && canConvertImportDeclarationForSpecifier(errorDeclaration, diag2.file, context.program)) {
	              doChange11(changes, diag2.file, errorDeclaration.parent.parent.parent);
	              fixedImportDeclarations.add(errorDeclaration.parent.parent.parent);
	            } else if ((errorDeclaration == null ? void 0 : errorDeclaration.kind) === 276 /* ImportSpecifier */) {
	              doChange11(changes, diag2.file, errorDeclaration);
	            }
	          });
	        }
	      });
	    }
	  });

	  // src/services/codefixes/convertTypedefToType.ts
	  function doChange12(changes, node, sourceFile, newLine, fixAll = false) {
	    if (!isJSDocTypedefTag(node))
	      return;
	    const declaration = createDeclaration(node);
	    if (!declaration)
	      return;
	    const commentNode = node.parent;
	    const { leftSibling, rightSibling } = getLeftAndRightSiblings(node);
	    let pos = commentNode.getStart();
	    let prefix = "";
	    if (!leftSibling && commentNode.comment) {
	      pos = findEndOfTextBetween(commentNode, commentNode.getStart(), node.getStart());
	      prefix = `${newLine} */${newLine}`;
	    }
	    if (leftSibling) {
	      if (fixAll && isJSDocTypedefTag(leftSibling)) {
	        pos = node.getStart();
	        prefix = "";
	      } else {
	        pos = findEndOfTextBetween(commentNode, leftSibling.getStart(), node.getStart());
	        prefix = `${newLine} */${newLine}`;
	      }
	    }
	    let end = commentNode.getEnd();
	    let suffix = "";
	    if (rightSibling) {
	      if (fixAll && isJSDocTypedefTag(rightSibling)) {
	        end = rightSibling.getStart();
	        suffix = `${newLine}${newLine}`;
	      } else {
	        end = rightSibling.getStart();
	        suffix = `${newLine}/**${newLine} * `;
	      }
	    }
	    changes.replaceRange(sourceFile, { pos, end }, declaration, { prefix, suffix });
	  }
	  function getLeftAndRightSiblings(typedefNode) {
	    const commentNode = typedefNode.parent;
	    const maxChildIndex = commentNode.getChildCount() - 1;
	    const currentNodeIndex = commentNode.getChildren().findIndex(
	      (n) => n.getStart() === typedefNode.getStart() && n.getEnd() === typedefNode.getEnd()
	    );
	    const leftSibling = currentNodeIndex > 0 ? commentNode.getChildAt(currentNodeIndex - 1) : void 0;
	    const rightSibling = currentNodeIndex < maxChildIndex ? commentNode.getChildAt(currentNodeIndex + 1) : void 0;
	    return { leftSibling, rightSibling };
	  }
	  function findEndOfTextBetween(jsDocComment, from, to) {
	    const comment = jsDocComment.getText().substring(from - jsDocComment.getStart(), to - jsDocComment.getStart());
	    for (let i = comment.length; i > 0; i--) {
	      if (!/[*/\s]/g.test(comment.substring(i - 1, i))) {
	        return from + i;
	      }
	    }
	    return to;
	  }
	  function createDeclaration(tag) {
	    var _a;
	    const { typeExpression } = tag;
	    if (!typeExpression)
	      return;
	    const typeName = (_a = tag.name) == null ? void 0 : _a.getText();
	    if (!typeName)
	      return;
	    if (typeExpression.kind === 329 /* JSDocTypeLiteral */) {
	      return createInterfaceForTypeLiteral(typeName, typeExpression);
	    }
	    if (typeExpression.kind === 316 /* JSDocTypeExpression */) {
	      return createTypeAliasForTypeExpression(typeName, typeExpression);
	    }
	  }
	  function createInterfaceForTypeLiteral(typeName, typeLiteral) {
	    const propertySignatures = createSignatureFromTypeLiteral(typeLiteral);
	    if (!some(propertySignatures))
	      return;
	    return factory.createInterfaceDeclaration(
	      /*modifiers*/
	      void 0,
	      typeName,
	      /*typeParameters*/
	      void 0,
	      /*heritageClauses*/
	      void 0,
	      propertySignatures
	    );
	  }
	  function createTypeAliasForTypeExpression(typeName, typeExpression) {
	    const typeReference = getSynthesizedDeepClone(typeExpression.type);
	    if (!typeReference)
	      return;
	    return factory.createTypeAliasDeclaration(
	      /*modifiers*/
	      void 0,
	      factory.createIdentifier(typeName),
	      /*typeParameters*/
	      void 0,
	      typeReference
	    );
	  }
	  function createSignatureFromTypeLiteral(typeLiteral) {
	    const propertyTags = typeLiteral.jsDocPropertyTags;
	    if (!some(propertyTags))
	      return;
	    const getSignature = (tag) => {
	      var _a;
	      const name = getPropertyName(tag);
	      const type = (_a = tag.typeExpression) == null ? void 0 : _a.type;
	      const isOptional = tag.isBracketed;
	      let typeReference;
	      if (type && isJSDocTypeLiteral(type)) {
	        const signatures = createSignatureFromTypeLiteral(type);
	        typeReference = factory.createTypeLiteralNode(signatures);
	      } else if (type) {
	        typeReference = getSynthesizedDeepClone(type);
	      }
	      if (typeReference && name) {
	        const questionToken = isOptional ? factory.createToken(58 /* QuestionToken */) : void 0;
	        return factory.createPropertySignature(
	          /*modifiers*/
	          void 0,
	          name,
	          questionToken,
	          typeReference
	        );
	      }
	    };
	    return mapDefined(propertyTags, getSignature);
	  }
	  function getPropertyName(tag) {
	    return tag.name.kind === 80 /* Identifier */ ? tag.name.text : tag.name.right.text;
	  }
	  function getJSDocTypedefNodes(node) {
	    if (hasJSDocNodes(node)) {
	      return flatMap(node.jsDoc, (doc) => {
	        var _a;
	        return (_a = doc.tags) == null ? void 0 : _a.filter((tag) => isJSDocTypedefTag(tag));
	      });
	    }
	    return [];
	  }
	  var fixId14, errorCodes15;
	  var init_convertTypedefToType = __esm({
	    "src/services/codefixes/convertTypedefToType.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      fixId14 = "convertTypedefToType";
	      errorCodes15 = [Diagnostics.JSDoc_typedef_may_be_converted_to_TypeScript_type.code];
	      registerCodeFix({
	        fixIds: [fixId14],
	        errorCodes: errorCodes15,
	        getCodeActions(context) {
	          const newLineCharacter = getNewLineOrDefaultFromHost(context.host, context.formatContext.options);
	          const node = getTokenAtPosition(
	            context.sourceFile,
	            context.span.start
	          );
	          if (!node)
	            return;
	          const changes = ts_textChanges_exports.ChangeTracker.with(context, (t) => doChange12(t, node, context.sourceFile, newLineCharacter));
	          if (changes.length > 0) {
	            return [
	              createCodeFixAction(
	                fixId14,
	                changes,
	                Diagnostics.Convert_typedef_to_TypeScript_type,
	                fixId14,
	                Diagnostics.Convert_all_typedef_to_TypeScript_types
	              )
	            ];
	          }
	        },
	        getAllCodeActions: (context) => codeFixAll(
	          context,
	          errorCodes15,
	          (changes, diag2) => {
	            const newLineCharacter = getNewLineOrDefaultFromHost(context.host, context.formatContext.options);
	            const node = getTokenAtPosition(diag2.file, diag2.start);
	            const fixAll = true;
	            if (node)
	              doChange12(changes, node, diag2.file, newLineCharacter, fixAll);
	          }
	        )
	      });
	    }
	  });

	  // src/services/codefixes/convertLiteralTypeToMappedType.ts
	  function getInfo5(sourceFile, pos) {
	    const token = getTokenAtPosition(sourceFile, pos);
	    if (isIdentifier(token)) {
	      const propertySignature = cast(token.parent.parent, isPropertySignature);
	      const propertyName = token.getText(sourceFile);
	      return {
	        container: cast(propertySignature.parent, isTypeLiteralNode),
	        typeNode: propertySignature.type,
	        constraint: propertyName,
	        name: propertyName === "K" ? "P" : "K"
	      };
	    }
	    return void 0;
	  }
	  function doChange13(changes, sourceFile, { container, typeNode, constraint, name }) {
	    changes.replaceNode(
	      sourceFile,
	      container,
	      factory.createMappedTypeNode(
	        /*readonlyToken*/
	        void 0,
	        factory.createTypeParameterDeclaration(
	          /*modifiers*/
	          void 0,
	          name,
	          factory.createTypeReferenceNode(constraint)
	        ),
	        /*nameType*/
	        void 0,
	        /*questionToken*/
	        void 0,
	        typeNode,
	        /*members*/
	        void 0
	      )
	    );
	  }
	  var fixId15, errorCodes16;
	  var init_convertLiteralTypeToMappedType = __esm({
	    "src/services/codefixes/convertLiteralTypeToMappedType.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      fixId15 = "convertLiteralTypeToMappedType";
	      errorCodes16 = [Diagnostics._0_only_refers_to_a_type_but_is_being_used_as_a_value_here_Did_you_mean_to_use_1_in_0.code];
	      registerCodeFix({
	        errorCodes: errorCodes16,
	        getCodeActions: function getCodeActionsToConvertLiteralTypeToMappedType(context) {
	          const { sourceFile, span } = context;
	          const info = getInfo5(sourceFile, span.start);
	          if (!info) {
	            return void 0;
	          }
	          const { name, constraint } = info;
	          const changes = ts_textChanges_exports.ChangeTracker.with(context, (t) => doChange13(t, sourceFile, info));
	          return [createCodeFixAction(fixId15, changes, [Diagnostics.Convert_0_to_1_in_0, constraint, name], fixId15, Diagnostics.Convert_all_type_literals_to_mapped_type)];
	        },
	        fixIds: [fixId15],
	        getAllCodeActions: (context) => codeFixAll(context, errorCodes16, (changes, diag2) => {
	          const info = getInfo5(diag2.file, diag2.start);
	          if (info) {
	            doChange13(changes, diag2.file, info);
	          }
	        })
	      });
	    }
	  });

	  // src/services/codefixes/fixClassIncorrectlyImplementsInterface.ts
	  function getClass(sourceFile, pos) {
	    return Debug.checkDefined(getContainingClass(getTokenAtPosition(sourceFile, pos)), "There should be a containing class");
	  }
	  function symbolPointsToNonPrivateMember(symbol) {
	    return !symbol.valueDeclaration || !(getEffectiveModifierFlags(symbol.valueDeclaration) & 2 /* Private */);
	  }
	  function addMissingDeclarations(context, implementedTypeNode, sourceFile, classDeclaration, changeTracker, preferences) {
	    const checker = context.program.getTypeChecker();
	    const maybeHeritageClauseSymbol = getHeritageClauseSymbolTable(classDeclaration, checker);
	    const implementedType = checker.getTypeAtLocation(implementedTypeNode);
	    const implementedTypeSymbols = checker.getPropertiesOfType(implementedType);
	    const nonPrivateAndNotExistedInHeritageClauseMembers = implementedTypeSymbols.filter(and(symbolPointsToNonPrivateMember, (symbol) => !maybeHeritageClauseSymbol.has(symbol.escapedName)));
	    const classType = checker.getTypeAtLocation(classDeclaration);
	    const constructor = find(classDeclaration.members, (m) => isConstructorDeclaration(m));
	    if (!classType.getNumberIndexType()) {
	      createMissingIndexSignatureDeclaration(implementedType, 1 /* Number */);
	    }
	    if (!classType.getStringIndexType()) {
	      createMissingIndexSignatureDeclaration(implementedType, 0 /* String */);
	    }
	    const importAdder = createImportAdder(sourceFile, context.program, preferences, context.host);
	    createMissingMemberNodes(classDeclaration, nonPrivateAndNotExistedInHeritageClauseMembers, sourceFile, context, preferences, importAdder, (member) => insertInterfaceMemberNode(sourceFile, classDeclaration, member));
	    importAdder.writeFixes(changeTracker);
	    function createMissingIndexSignatureDeclaration(type, kind) {
	      const indexInfoOfKind = checker.getIndexInfoOfType(type, kind);
	      if (indexInfoOfKind) {
	        insertInterfaceMemberNode(sourceFile, classDeclaration, checker.indexInfoToIndexSignatureDeclaration(
	          indexInfoOfKind,
	          classDeclaration,
	          /*flags*/
	          void 0,
	          getNoopSymbolTrackerWithResolver(context)
	        ));
	      }
	    }
	    function insertInterfaceMemberNode(sourceFile2, cls, newElement) {
	      if (constructor) {
	        changeTracker.insertNodeAfter(sourceFile2, constructor, newElement);
	      } else {
	        changeTracker.insertMemberAtStart(sourceFile2, cls, newElement);
	      }
	    }
	  }
	  function getHeritageClauseSymbolTable(classDeclaration, checker) {
	    const heritageClauseNode = getEffectiveBaseTypeNode(classDeclaration);
	    if (!heritageClauseNode)
	      return createSymbolTable();
	    const heritageClauseType = checker.getTypeAtLocation(heritageClauseNode);
	    const heritageClauseTypeSymbols = checker.getPropertiesOfType(heritageClauseType);
	    return createSymbolTable(heritageClauseTypeSymbols.filter(symbolPointsToNonPrivateMember));
	  }
	  var errorCodes17, fixId16;
	  var init_fixClassIncorrectlyImplementsInterface = __esm({
	    "src/services/codefixes/fixClassIncorrectlyImplementsInterface.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      errorCodes17 = [
	        Diagnostics.Class_0_incorrectly_implements_interface_1.code,
	        Diagnostics.Class_0_incorrectly_implements_class_1_Did_you_mean_to_extend_1_and_inherit_its_members_as_a_subclass.code
	      ];
	      fixId16 = "fixClassIncorrectlyImplementsInterface";
	      registerCodeFix({
	        errorCodes: errorCodes17,
	        getCodeActions(context) {
	          const { sourceFile, span } = context;
	          const classDeclaration = getClass(sourceFile, span.start);
	          return mapDefined(getEffectiveImplementsTypeNodes(classDeclaration), (implementedTypeNode) => {
	            const changes = ts_textChanges_exports.ChangeTracker.with(context, (t) => addMissingDeclarations(context, implementedTypeNode, sourceFile, classDeclaration, t, context.preferences));
	            return changes.length === 0 ? void 0 : createCodeFixAction(fixId16, changes, [Diagnostics.Implement_interface_0, implementedTypeNode.getText(sourceFile)], fixId16, Diagnostics.Implement_all_unimplemented_interfaces);
	          });
	        },
	        fixIds: [fixId16],
	        getAllCodeActions(context) {
	          const seenClassDeclarations = /* @__PURE__ */ new Map();
	          return codeFixAll(context, errorCodes17, (changes, diag2) => {
	            const classDeclaration = getClass(diag2.file, diag2.start);
	            if (addToSeen(seenClassDeclarations, getNodeId(classDeclaration))) {
	              for (const implementedTypeNode of getEffectiveImplementsTypeNodes(classDeclaration)) {
	                addMissingDeclarations(context, implementedTypeNode, diag2.file, classDeclaration, changes, context.preferences);
	              }
	            }
	          });
	        }
	      });
	    }
	  });

	  // src/services/codefixes/importFixes.ts
	  function createImportAdder(sourceFile, program, preferences, host, cancellationToken) {
	    return createImportAdderWorker(
	      sourceFile,
	      program,
	      /*useAutoImportProvider*/
	      false,
	      preferences,
	      host,
	      cancellationToken
	    );
	  }
	  function createImportAdderWorker(sourceFile, program, useAutoImportProvider, preferences, host, cancellationToken) {
	    const compilerOptions = program.getCompilerOptions();
	    const addToNamespace = [];
	    const importType = [];
	    const addToExisting = /* @__PURE__ */ new Map();
	    const newImports = /* @__PURE__ */ new Map();
	    return { addImportFromDiagnostic, addImportFromExportedSymbol, writeFixes, hasFixes };
	    function addImportFromDiagnostic(diagnostic, context) {
	      const info = getFixInfos(context, diagnostic.code, diagnostic.start, useAutoImportProvider);
	      if (!info || !info.length)
	        return;
	      addImport(first(info));
	    }
	    function addImportFromExportedSymbol(exportedSymbol, isValidTypeOnlyUseSite) {
	      const moduleSymbol = Debug.checkDefined(exportedSymbol.parent);
	      const symbolName2 = getNameForExportedSymbol(exportedSymbol, getEmitScriptTarget(compilerOptions));
	      const checker = program.getTypeChecker();
	      const symbol = checker.getMergedSymbol(skipAlias(exportedSymbol, checker));
	      const exportInfo = getAllExportInfoForSymbol(
	        sourceFile,
	        symbol,
	        symbolName2,
	        moduleSymbol,
	        /*preferCapitalized*/
	        false,
	        program,
	        host,
	        preferences,
	        cancellationToken
	      );
	      const useRequire = shouldUseRequire(sourceFile, program);
	      const fix = getImportFixForSymbol(
	        sourceFile,
	        Debug.checkDefined(exportInfo),
	        program,
	        /*position*/
	        void 0,
	        !!isValidTypeOnlyUseSite,
	        useRequire,
	        host,
	        preferences
	      );
	      if (fix) {
	        addImport({ fix, symbolName: symbolName2, errorIdentifierText: void 0 });
	      }
	    }
	    function addImport(info) {
	      var _a, _b;
	      const { fix, symbolName: symbolName2 } = info;
	      switch (fix.kind) {
	        case 0 /* UseNamespace */:
	          addToNamespace.push(fix);
	          break;
	        case 1 /* JsdocTypeImport */:
	          importType.push(fix);
	          break;
	        case 2 /* AddToExisting */: {
	          const { importClauseOrBindingPattern, importKind, addAsTypeOnly } = fix;
	          const key = String(getNodeId(importClauseOrBindingPattern));
	          let entry = addToExisting.get(key);
	          if (!entry) {
	            addToExisting.set(key, entry = { importClauseOrBindingPattern, defaultImport: void 0, namedImports: /* @__PURE__ */ new Map() });
	          }
	          if (importKind === 0 /* Named */) {
	            const prevValue = entry == null ? void 0 : entry.namedImports.get(symbolName2);
	            entry.namedImports.set(symbolName2, reduceAddAsTypeOnlyValues(prevValue, addAsTypeOnly));
	          } else {
	            Debug.assert(entry.defaultImport === void 0 || entry.defaultImport.name === symbolName2, "(Add to Existing) Default import should be missing or match symbolName");
	            entry.defaultImport = {
	              name: symbolName2,
	              addAsTypeOnly: reduceAddAsTypeOnlyValues((_a = entry.defaultImport) == null ? void 0 : _a.addAsTypeOnly, addAsTypeOnly)
	            };
	          }
	          break;
	        }
	        case 3 /* AddNew */: {
	          const { moduleSpecifier, importKind, useRequire, addAsTypeOnly } = fix;
	          const entry = getNewImportEntry(moduleSpecifier, importKind, useRequire, addAsTypeOnly);
	          Debug.assert(entry.useRequire === useRequire, "(Add new) Tried to add an `import` and a `require` for the same module");
	          switch (importKind) {
	            case 1 /* Default */:
	              Debug.assert(entry.defaultImport === void 0 || entry.defaultImport.name === symbolName2, "(Add new) Default import should be missing or match symbolName");
	              entry.defaultImport = { name: symbolName2, addAsTypeOnly: reduceAddAsTypeOnlyValues((_b = entry.defaultImport) == null ? void 0 : _b.addAsTypeOnly, addAsTypeOnly) };
	              break;
	            case 0 /* Named */:
	              const prevValue = (entry.namedImports || (entry.namedImports = /* @__PURE__ */ new Map())).get(symbolName2);
	              entry.namedImports.set(symbolName2, reduceAddAsTypeOnlyValues(prevValue, addAsTypeOnly));
	              break;
	            case 3 /* CommonJS */:
	            case 2 /* Namespace */:
	              Debug.assert(entry.namespaceLikeImport === void 0 || entry.namespaceLikeImport.name === symbolName2, "Namespacelike import shoudl be missing or match symbolName");
	              entry.namespaceLikeImport = { importKind, name: symbolName2, addAsTypeOnly };
	              break;
	          }
	          break;
	        }
	        case 4 /* PromoteTypeOnly */:
	          break;
	        default:
	          Debug.assertNever(fix, `fix wasn't never - got kind ${fix.kind}`);
	      }
	      function reduceAddAsTypeOnlyValues(prevValue, newValue) {
	        return Math.max(prevValue ?? 0, newValue);
	      }
	      function getNewImportEntry(moduleSpecifier, importKind, useRequire, addAsTypeOnly) {
	        const typeOnlyKey = newImportsKey(
	          moduleSpecifier,
	          /*topLevelTypeOnly*/
	          true
	        );
	        const nonTypeOnlyKey = newImportsKey(
	          moduleSpecifier,
	          /*topLevelTypeOnly*/
	          false
	        );
	        const typeOnlyEntry = newImports.get(typeOnlyKey);
	        const nonTypeOnlyEntry = newImports.get(nonTypeOnlyKey);
	        const newEntry = {
	          defaultImport: void 0,
	          namedImports: void 0,
	          namespaceLikeImport: void 0,
	          useRequire
	        };
	        if (importKind === 1 /* Default */ && addAsTypeOnly === 2 /* Required */) {
	          if (typeOnlyEntry)
	            return typeOnlyEntry;
	          newImports.set(typeOnlyKey, newEntry);
	          return newEntry;
	        }
	        if (addAsTypeOnly === 1 /* Allowed */ && (typeOnlyEntry || nonTypeOnlyEntry)) {
	          return typeOnlyEntry || nonTypeOnlyEntry;
	        }
	        if (nonTypeOnlyEntry) {
	          return nonTypeOnlyEntry;
	        }
	        newImports.set(nonTypeOnlyKey, newEntry);
	        return newEntry;
	      }
	      function newImportsKey(moduleSpecifier, topLevelTypeOnly) {
	        return `${topLevelTypeOnly ? 1 : 0}|${moduleSpecifier}`;
	      }
	    }
	    function writeFixes(changeTracker, oldFileQuotePreference) {
	      let quotePreference;
	      if (sourceFile.imports.length === 0 && oldFileQuotePreference !== void 0) {
	        quotePreference = oldFileQuotePreference;
	      } else {
	        quotePreference = getQuotePreference(sourceFile, preferences);
	      }
	      for (const fix of addToNamespace) {
	        addNamespaceQualifier(changeTracker, sourceFile, fix);
	      }
	      for (const fix of importType) {
	        addImportType(changeTracker, sourceFile, fix, quotePreference);
	      }
	      addToExisting.forEach(({ importClauseOrBindingPattern, defaultImport, namedImports }) => {
	        doAddExistingFix(
	          changeTracker,
	          sourceFile,
	          importClauseOrBindingPattern,
	          defaultImport,
	          arrayFrom(namedImports.entries(), ([name, addAsTypeOnly]) => ({ addAsTypeOnly, name })),
	          preferences
	        );
	      });
	      let newDeclarations;
	      newImports.forEach(({ useRequire, defaultImport, namedImports, namespaceLikeImport }, key) => {
	        const moduleSpecifier = key.slice(2);
	        const getDeclarations = useRequire ? getNewRequires : getNewImports;
	        const declarations = getDeclarations(
	          moduleSpecifier,
	          quotePreference,
	          defaultImport,
	          namedImports && arrayFrom(namedImports.entries(), ([name, addAsTypeOnly]) => ({ addAsTypeOnly, name })),
	          namespaceLikeImport,
	          compilerOptions,
	          preferences
	        );
	        newDeclarations = combine(newDeclarations, declarations);
	      });
	      if (newDeclarations) {
	        insertImports(
	          changeTracker,
	          sourceFile,
	          newDeclarations,
	          /*blankLineBetween*/
	          true,
	          preferences
	        );
	      }
	    }
	    function hasFixes() {
	      return addToNamespace.length > 0 || importType.length > 0 || addToExisting.size > 0 || newImports.size > 0;
	    }
	  }
	  function createImportSpecifierResolver(importingFile, program, host, preferences) {
	    const packageJsonImportFilter = createPackageJsonImportFilter(importingFile, preferences, host);
	    const importMap = createExistingImportMap(program.getTypeChecker(), importingFile, program.getCompilerOptions());
	    return { getModuleSpecifierForBestExportInfo };
	    function getModuleSpecifierForBestExportInfo(exportInfo, position, isValidTypeOnlyUseSite, fromCacheOnly) {
	      const { fixes, computedWithoutCacheCount } = getImportFixes(
	        exportInfo,
	        position,
	        isValidTypeOnlyUseSite,
	        /*useRequire*/
	        false,
	        program,
	        importingFile,
	        host,
	        preferences,
	        importMap,
	        fromCacheOnly
	      );
	      const result = getBestFix(fixes, importingFile, program, packageJsonImportFilter, host);
	      return result && { ...result, computedWithoutCacheCount };
	    }
	  }
	  function getImportCompletionAction(targetSymbol, moduleSymbol, exportMapKey, sourceFile, symbolName2, isJsxTagName, host, program, formatContext, position, preferences, cancellationToken) {
	    let exportInfos;
	    if (exportMapKey) {
	      exportInfos = getExportInfoMap(sourceFile, host, program, preferences, cancellationToken).get(sourceFile.path, exportMapKey);
	      Debug.assertIsDefined(exportInfos, "Some exportInfo should match the specified exportMapKey");
	    } else {
	      exportInfos = pathIsBareSpecifier(stripQuotes(moduleSymbol.name)) ? [getSingleExportInfoForSymbol(targetSymbol, symbolName2, moduleSymbol, program, host)] : getAllExportInfoForSymbol(sourceFile, targetSymbol, symbolName2, moduleSymbol, isJsxTagName, program, host, preferences, cancellationToken);
	      Debug.assertIsDefined(exportInfos, "Some exportInfo should match the specified symbol / moduleSymbol");
	    }
	    const useRequire = shouldUseRequire(sourceFile, program);
	    const isValidTypeOnlyUseSite = isValidTypeOnlyAliasUseSite(getTokenAtPosition(sourceFile, position));
	    const fix = Debug.checkDefined(getImportFixForSymbol(sourceFile, exportInfos, program, position, isValidTypeOnlyUseSite, useRequire, host, preferences));
	    return {
	      moduleSpecifier: fix.moduleSpecifier,
	      codeAction: codeFixActionToCodeAction(codeActionForFix(
	        { host, formatContext, preferences },
	        sourceFile,
	        symbolName2,
	        fix,
	        /*includeSymbolNameInDescription*/
	        false,
	        program,
	        preferences
	      ))
	    };
	  }
	  function getPromoteTypeOnlyCompletionAction(sourceFile, symbolToken, program, host, formatContext, preferences) {
	    const compilerOptions = program.getCompilerOptions();
	    const symbolName2 = single(getSymbolNamesToImport(sourceFile, program.getTypeChecker(), symbolToken, compilerOptions));
	    const fix = getTypeOnlyPromotionFix(sourceFile, symbolToken, symbolName2, program);
	    const includeSymbolNameInDescription = symbolName2 !== symbolToken.text;
	    return fix && codeFixActionToCodeAction(codeActionForFix(
	      { host, formatContext, preferences },
	      sourceFile,
	      symbolName2,
	      fix,
	      includeSymbolNameInDescription,
	      program,
	      preferences
	    ));
	  }
	  function getImportFixForSymbol(sourceFile, exportInfos, program, position, isValidTypeOnlyUseSite, useRequire, host, preferences) {
	    const packageJsonImportFilter = createPackageJsonImportFilter(sourceFile, preferences, host);
	    return getBestFix(getImportFixes(exportInfos, position, isValidTypeOnlyUseSite, useRequire, program, sourceFile, host, preferences).fixes, sourceFile, program, packageJsonImportFilter, host);
	  }
	  function codeFixActionToCodeAction({ description: description3, changes, commands }) {
	    return { description: description3, changes, commands };
	  }
	  function getAllExportInfoForSymbol(importingFile, symbol, symbolName2, moduleSymbol, preferCapitalized, program, host, preferences, cancellationToken) {
	    const getChecker = createGetChecker(program, host);
	    return getExportInfoMap(importingFile, host, program, preferences, cancellationToken).search(importingFile.path, preferCapitalized, (name) => name === symbolName2, (info) => {
	      if (skipAlias(info[0].symbol, getChecker(info[0].isFromPackageJson)) === symbol && info.some((i) => i.moduleSymbol === moduleSymbol || i.symbol.parent === moduleSymbol)) {
	        return info;
	      }
	    });
	  }
	  function getSingleExportInfoForSymbol(symbol, symbolName2, moduleSymbol, program, host) {
	    var _a, _b;
	    const compilerOptions = program.getCompilerOptions();
	    const mainProgramInfo = getInfoWithChecker(
	      program.getTypeChecker(),
	      /*isFromPackageJson*/
	      false
	    );
	    if (mainProgramInfo) {
	      return mainProgramInfo;
	    }
	    const autoImportProvider = (_b = (_a = host.getPackageJsonAutoImportProvider) == null ? void 0 : _a.call(host)) == null ? void 0 : _b.getTypeChecker();
	    return Debug.checkDefined(autoImportProvider && getInfoWithChecker(
	      autoImportProvider,
	      /*isFromPackageJson*/
	      true
	    ), `Could not find symbol in specified module for code actions`);
	    function getInfoWithChecker(checker, isFromPackageJson) {
	      const defaultInfo = getDefaultLikeExportInfo(moduleSymbol, checker, compilerOptions);
	      if (defaultInfo && skipAlias(defaultInfo.symbol, checker) === symbol) {
	        return { symbol: defaultInfo.symbol, moduleSymbol, moduleFileName: void 0, exportKind: defaultInfo.exportKind, targetFlags: skipAlias(symbol, checker).flags, isFromPackageJson };
	      }
	      const named = checker.tryGetMemberInModuleExportsAndProperties(symbolName2, moduleSymbol);
	      if (named && skipAlias(named, checker) === symbol) {
	        return { symbol: named, moduleSymbol, moduleFileName: void 0, exportKind: 0 /* Named */, targetFlags: skipAlias(symbol, checker).flags, isFromPackageJson };
	      }
	    }
	  }
	  function getImportFixes(exportInfos, usagePosition, isValidTypeOnlyUseSite, useRequire, program, sourceFile, host, preferences, importMap = createExistingImportMap(program.getTypeChecker(), sourceFile, program.getCompilerOptions()), fromCacheOnly) {
	    const checker = program.getTypeChecker();
	    const existingImports = flatMap(exportInfos, importMap.getImportsForExportInfo);
	    const useNamespace = usagePosition !== void 0 && tryUseExistingNamespaceImport(existingImports, usagePosition);
	    const addToExisting = tryAddToExistingImport(existingImports, isValidTypeOnlyUseSite, checker, program.getCompilerOptions());
	    if (addToExisting) {
	      return {
	        computedWithoutCacheCount: 0,
	        fixes: [...useNamespace ? [useNamespace] : emptyArray, addToExisting]
	      };
	    }
	    const { fixes, computedWithoutCacheCount = 0 } = getFixesForAddImport(
	      exportInfos,
	      existingImports,
	      program,
	      sourceFile,
	      usagePosition,
	      isValidTypeOnlyUseSite,
	      useRequire,
	      host,
	      preferences,
	      fromCacheOnly
	    );
	    return {
	      computedWithoutCacheCount,
	      fixes: [...useNamespace ? [useNamespace] : emptyArray, ...fixes]
	    };
	  }
	  function tryUseExistingNamespaceImport(existingImports, position) {
	    return firstDefined(existingImports, ({ declaration, importKind }) => {
	      var _a;
	      if (importKind !== 0 /* Named */)
	        return void 0;
	      const namespacePrefix = getNamespaceLikeImportText(declaration);
	      const moduleSpecifier = namespacePrefix && ((_a = tryGetModuleSpecifierFromDeclaration(declaration)) == null ? void 0 : _a.text);
	      if (moduleSpecifier) {
	        return { kind: 0 /* UseNamespace */, namespacePrefix, usagePosition: position, moduleSpecifier };
	      }
	    });
	  }
	  function getNamespaceLikeImportText(declaration) {
	    var _a, _b, _c;
	    switch (declaration.kind) {
	      case 260 /* VariableDeclaration */:
	        return (_a = tryCast(declaration.name, isIdentifier)) == null ? void 0 : _a.text;
	      case 271 /* ImportEqualsDeclaration */:
	        return declaration.name.text;
	      case 272 /* ImportDeclaration */:
	        return (_c = tryCast((_b = declaration.importClause) == null ? void 0 : _b.namedBindings, isNamespaceImport)) == null ? void 0 : _c.name.text;
	      default:
	        return Debug.assertNever(declaration);
	    }
	  }
	  function getAddAsTypeOnly(isValidTypeOnlyUseSite, isForNewImportDeclaration, symbol, targetFlags, checker, compilerOptions) {
	    if (!isValidTypeOnlyUseSite) {
	      return 4 /* NotAllowed */;
	    }
	    if (isForNewImportDeclaration && compilerOptions.importsNotUsedAsValues === 2 /* Error */) {
	      return 2 /* Required */;
	    }
	    if (importNameElisionDisabled(compilerOptions) && (!(targetFlags & 111551 /* Value */) || !!checker.getTypeOnlyAliasDeclaration(symbol))) {
	      return 2 /* Required */;
	    }
	    return 1 /* Allowed */;
	  }
	  function tryAddToExistingImport(existingImports, isValidTypeOnlyUseSite, checker, compilerOptions) {
	    let best;
	    for (const existingImport of existingImports) {
	      const fix = getAddToExistingImportFix(existingImport);
	      if (!fix)
	        continue;
	      const isTypeOnly = isTypeOnlyImportDeclaration(fix.importClauseOrBindingPattern);
	      if (fix.addAsTypeOnly !== 4 /* NotAllowed */ && isTypeOnly || fix.addAsTypeOnly === 4 /* NotAllowed */ && !isTypeOnly) {
	        return fix;
	      }
	      best ?? (best = fix);
	    }
	    return best;
	    function getAddToExistingImportFix({ declaration, importKind, symbol, targetFlags }) {
	      if (importKind === 3 /* CommonJS */ || importKind === 2 /* Namespace */ || declaration.kind === 271 /* ImportEqualsDeclaration */) {
	        return void 0;
	      }
	      if (declaration.kind === 260 /* VariableDeclaration */) {
	        return (importKind === 0 /* Named */ || importKind === 1 /* Default */) && declaration.name.kind === 206 /* ObjectBindingPattern */ ? { kind: 2 /* AddToExisting */, importClauseOrBindingPattern: declaration.name, importKind, moduleSpecifier: declaration.initializer.arguments[0].text, addAsTypeOnly: 4 /* NotAllowed */ } : void 0;
	      }
	      const { importClause } = declaration;
	      if (!importClause || !isStringLiteralLike(declaration.moduleSpecifier)) {
	        return void 0;
	      }
	      const { name, namedBindings } = importClause;
	      if (importClause.isTypeOnly && !(importKind === 0 /* Named */ && namedBindings)) {
	        return void 0;
	      }
	      const addAsTypeOnly = getAddAsTypeOnly(
	        isValidTypeOnlyUseSite,
	        /*isForNewImportDeclaration*/
	        false,
	        symbol,
	        targetFlags,
	        checker,
	        compilerOptions
	      );
	      if (importKind === 1 /* Default */ && (name || // Cannot add a default import to a declaration that already has one
	      addAsTypeOnly === 2 /* Required */ && namedBindings)) {
	        return void 0;
	      }
	      if (importKind === 0 /* Named */ && (namedBindings == null ? void 0 : namedBindings.kind) === 274 /* NamespaceImport */) {
	        return void 0;
	      }
	      return {
	        kind: 2 /* AddToExisting */,
	        importClauseOrBindingPattern: importClause,
	        importKind,
	        moduleSpecifier: declaration.moduleSpecifier.text,
	        addAsTypeOnly
	      };
	    }
	  }
	  function createExistingImportMap(checker, importingFile, compilerOptions) {
	    let importMap;
	    for (const moduleSpecifier of importingFile.imports) {
	      const i = importFromModuleSpecifier(moduleSpecifier);
	      if (isVariableDeclarationInitializedToRequire(i.parent)) {
	        const moduleSymbol = checker.resolveExternalModuleName(moduleSpecifier);
	        if (moduleSymbol) {
	          (importMap || (importMap = createMultiMap())).add(getSymbolId(moduleSymbol), i.parent);
	        }
	      } else if (i.kind === 272 /* ImportDeclaration */ || i.kind === 271 /* ImportEqualsDeclaration */) {
	        const moduleSymbol = checker.getSymbolAtLocation(moduleSpecifier);
	        if (moduleSymbol) {
	          (importMap || (importMap = createMultiMap())).add(getSymbolId(moduleSymbol), i);
	        }
	      }
	    }
	    return {
	      getImportsForExportInfo: ({ moduleSymbol, exportKind, targetFlags, symbol }) => {
	        if (!(targetFlags & 111551 /* Value */) && isSourceFileJS(importingFile))
	          return emptyArray;
	        const matchingDeclarations = importMap == null ? void 0 : importMap.get(getSymbolId(moduleSymbol));
	        if (!matchingDeclarations)
	          return emptyArray;
	        const importKind = getImportKind(importingFile, exportKind, compilerOptions);
	        return matchingDeclarations.map((declaration) => ({ declaration, importKind, symbol, targetFlags }));
	      }
	    };
	  }
	  function shouldUseRequire(sourceFile, program) {
	    if (!isSourceFileJS(sourceFile)) {
	      return false;
	    }
	    if (sourceFile.commonJsModuleIndicator && !sourceFile.externalModuleIndicator)
	      return true;
	    if (sourceFile.externalModuleIndicator && !sourceFile.commonJsModuleIndicator)
	      return false;
	    const compilerOptions = program.getCompilerOptions();
	    if (compilerOptions.configFile) {
	      return getEmitModuleKind(compilerOptions) < 5 /* ES2015 */;
	    }
	    if (sourceFile.impliedNodeFormat === 1 /* CommonJS */)
	      return true;
	    if (sourceFile.impliedNodeFormat === 99 /* ESNext */)
	      return false;
	    for (const otherFile of program.getSourceFiles()) {
	      if (otherFile === sourceFile || !isSourceFileJS(otherFile) || program.isSourceFileFromExternalLibrary(otherFile))
	        continue;
	      if (otherFile.commonJsModuleIndicator && !otherFile.externalModuleIndicator)
	        return true;
	      if (otherFile.externalModuleIndicator && !otherFile.commonJsModuleIndicator)
	        return false;
	    }
	    return true;
	  }
	  function createGetChecker(program, host) {
	    return memoizeOne((isFromPackageJson) => isFromPackageJson ? host.getPackageJsonAutoImportProvider().getTypeChecker() : program.getTypeChecker());
	  }
	  function getNewImportFixes(program, sourceFile, usagePosition, isValidTypeOnlyUseSite, useRequire, exportInfo, host, preferences, fromCacheOnly) {
	    const isJs = isSourceFileJS(sourceFile);
	    const compilerOptions = program.getCompilerOptions();
	    const moduleSpecifierResolutionHost = createModuleSpecifierResolutionHost(program, host);
	    const getChecker = createGetChecker(program, host);
	    const moduleResolution = getEmitModuleResolutionKind(compilerOptions);
	    const rejectNodeModulesRelativePaths = moduleResolutionUsesNodeModules(moduleResolution);
	    const getModuleSpecifiers2 = fromCacheOnly ? (moduleSymbol) => ({ moduleSpecifiers: ts_moduleSpecifiers_exports.tryGetModuleSpecifiersFromCache(moduleSymbol, sourceFile, moduleSpecifierResolutionHost, preferences), computedWithoutCache: false }) : (moduleSymbol, checker) => ts_moduleSpecifiers_exports.getModuleSpecifiersWithCacheInfo(
	      moduleSymbol,
	      checker,
	      compilerOptions,
	      sourceFile,
	      moduleSpecifierResolutionHost,
	      preferences,
	      /*options*/
	      void 0,
	      /*forAutoImport*/
	      true
	    );
	    let computedWithoutCacheCount = 0;
	    const fixes = flatMap(exportInfo, (exportInfo2, i) => {
	      const checker = getChecker(exportInfo2.isFromPackageJson);
	      const { computedWithoutCache, moduleSpecifiers } = getModuleSpecifiers2(exportInfo2.moduleSymbol, checker);
	      const importedSymbolHasValueMeaning = !!(exportInfo2.targetFlags & 111551 /* Value */);
	      const addAsTypeOnly = getAddAsTypeOnly(
	        isValidTypeOnlyUseSite,
	        /*isForNewImportDeclaration*/
	        true,
	        exportInfo2.symbol,
	        exportInfo2.targetFlags,
	        checker,
	        compilerOptions
	      );
	      computedWithoutCacheCount += computedWithoutCache ? 1 : 0;
	      return mapDefined(moduleSpecifiers, (moduleSpecifier) => {
	        var _a;
	        if (rejectNodeModulesRelativePaths && pathContainsNodeModules(moduleSpecifier)) {
	          return void 0;
	        }
	        if (!importedSymbolHasValueMeaning && isJs && usagePosition !== void 0) {
	          return { kind: 1 /* JsdocTypeImport */, moduleSpecifier, usagePosition, exportInfo: exportInfo2, isReExport: i > 0 };
	        }
	        const importKind = getImportKind(sourceFile, exportInfo2.exportKind, compilerOptions);
	        let qualification;
	        if (usagePosition !== void 0 && importKind === 3 /* CommonJS */ && exportInfo2.exportKind === 0 /* Named */) {
	          const exportEquals = checker.resolveExternalModuleSymbol(exportInfo2.moduleSymbol);
	          let namespacePrefix;
	          if (exportEquals !== exportInfo2.moduleSymbol) {
	            namespacePrefix = (_a = getDefaultExportInfoWorker(exportEquals, checker, compilerOptions)) == null ? void 0 : _a.name;
	          }
	          namespacePrefix || (namespacePrefix = moduleSymbolToValidIdentifier(
	            exportInfo2.moduleSymbol,
	            getEmitScriptTarget(compilerOptions),
	            /*forceCapitalize*/
	            false
	          ));
	          qualification = { namespacePrefix, usagePosition };
	        }
	        return {
	          kind: 3 /* AddNew */,
	          moduleSpecifier,
	          importKind,
	          useRequire,
	          addAsTypeOnly,
	          exportInfo: exportInfo2,
	          isReExport: i > 0,
	          qualification
	        };
	      });
	    });
	    return { computedWithoutCacheCount, fixes };
	  }
	  function getFixesForAddImport(exportInfos, existingImports, program, sourceFile, usagePosition, isValidTypeOnlyUseSite, useRequire, host, preferences, fromCacheOnly) {
	    const existingDeclaration = firstDefined(existingImports, (info) => newImportInfoFromExistingSpecifier(info, isValidTypeOnlyUseSite, useRequire, program.getTypeChecker(), program.getCompilerOptions()));
	    return existingDeclaration ? { fixes: [existingDeclaration] } : getNewImportFixes(program, sourceFile, usagePosition, isValidTypeOnlyUseSite, useRequire, exportInfos, host, preferences, fromCacheOnly);
	  }
	  function newImportInfoFromExistingSpecifier({ declaration, importKind, symbol, targetFlags }, isValidTypeOnlyUseSite, useRequire, checker, compilerOptions) {
	    var _a;
	    const moduleSpecifier = (_a = tryGetModuleSpecifierFromDeclaration(declaration)) == null ? void 0 : _a.text;
	    if (moduleSpecifier) {
	      const addAsTypeOnly = useRequire ? 4 /* NotAllowed */ : getAddAsTypeOnly(
	        isValidTypeOnlyUseSite,
	        /*isForNewImportDeclaration*/
	        true,
	        symbol,
	        targetFlags,
	        checker,
	        compilerOptions
	      );
	      return { kind: 3 /* AddNew */, moduleSpecifier, importKind, addAsTypeOnly, useRequire };
	    }
	  }
	  function getFixInfos(context, errorCode, pos, useAutoImportProvider) {
	    const symbolToken = getTokenAtPosition(context.sourceFile, pos);
	    let info;
	    if (errorCode === Diagnostics._0_refers_to_a_UMD_global_but_the_current_file_is_a_module_Consider_adding_an_import_instead.code) {
	      info = getFixesInfoForUMDImport(context, symbolToken);
	    } else if (!isIdentifier(symbolToken)) {
	      return void 0;
	    } else if (errorCode === Diagnostics._0_cannot_be_used_as_a_value_because_it_was_imported_using_import_type.code) {
	      const symbolName2 = single(getSymbolNamesToImport(context.sourceFile, context.program.getTypeChecker(), symbolToken, context.program.getCompilerOptions()));
	      const fix = getTypeOnlyPromotionFix(context.sourceFile, symbolToken, symbolName2, context.program);
	      return fix && [{ fix, symbolName: symbolName2, errorIdentifierText: symbolToken.text }];
	    } else {
	      info = getFixesInfoForNonUMDImport(context, symbolToken, useAutoImportProvider);
	    }
	    const packageJsonImportFilter = createPackageJsonImportFilter(context.sourceFile, context.preferences, context.host);
	    return info && sortFixInfo(info, context.sourceFile, context.program, packageJsonImportFilter, context.host);
	  }
	  function sortFixInfo(fixes, sourceFile, program, packageJsonImportFilter, host) {
	    const _toPath = (fileName) => toPath(fileName, host.getCurrentDirectory(), hostGetCanonicalFileName(host));
	    return sort(fixes, (a, b) => compareBooleans(!!a.isJsxNamespaceFix, !!b.isJsxNamespaceFix) || compareValues(a.fix.kind, b.fix.kind) || compareModuleSpecifiers(a.fix, b.fix, sourceFile, program, packageJsonImportFilter.allowsImportingSpecifier, _toPath));
	  }
	  function getBestFix(fixes, sourceFile, program, packageJsonImportFilter, host) {
	    if (!some(fixes))
	      return;
	    if (fixes[0].kind === 0 /* UseNamespace */ || fixes[0].kind === 2 /* AddToExisting */) {
	      return fixes[0];
	    }
	    return fixes.reduce(
	      (best, fix) => (
	        // Takes true branch of conditional if `fix` is better than `best`
	        compareModuleSpecifiers(
	          fix,
	          best,
	          sourceFile,
	          program,
	          packageJsonImportFilter.allowsImportingSpecifier,
	          (fileName) => toPath(fileName, host.getCurrentDirectory(), hostGetCanonicalFileName(host))
	        ) === -1 /* LessThan */ ? fix : best
	      )
	    );
	  }
	  function compareModuleSpecifiers(a, b, importingFile, program, allowsImportingSpecifier, toPath3) {
	    if (a.kind !== 0 /* UseNamespace */ && b.kind !== 0 /* UseNamespace */) {
	      return compareBooleans(allowsImportingSpecifier(b.moduleSpecifier), allowsImportingSpecifier(a.moduleSpecifier)) || compareNodeCoreModuleSpecifiers(a.moduleSpecifier, b.moduleSpecifier, importingFile, program) || compareBooleans(
	        isFixPossiblyReExportingImportingFile(a, importingFile, program.getCompilerOptions(), toPath3),
	        isFixPossiblyReExportingImportingFile(b, importingFile, program.getCompilerOptions(), toPath3)
	      ) || compareNumberOfDirectorySeparators(a.moduleSpecifier, b.moduleSpecifier);
	    }
	    return 0 /* EqualTo */;
	  }
	  function isFixPossiblyReExportingImportingFile(fix, importingFile, compilerOptions, toPath3) {
	    var _a;
	    if (fix.isReExport && ((_a = fix.exportInfo) == null ? void 0 : _a.moduleFileName) && isIndexFileName(fix.exportInfo.moduleFileName)) {
	      const reExportDir = toPath3(getDirectoryPath(fix.exportInfo.moduleFileName));
	      return startsWith(importingFile.path, reExportDir);
	    }
	    return false;
	  }
	  function isIndexFileName(fileName) {
	    return getBaseFileName(
	      fileName,
	      [".js", ".jsx", ".d.ts", ".ts", ".tsx"],
	      /*ignoreCase*/
	      true
	    ) === "index";
	  }
	  function compareNodeCoreModuleSpecifiers(a, b, importingFile, program) {
	    if (startsWith(a, "node:") && !startsWith(b, "node:"))
	      return shouldUseUriStyleNodeCoreModules(importingFile, program) ? -1 /* LessThan */ : 1 /* GreaterThan */;
	    if (startsWith(b, "node:") && !startsWith(a, "node:"))
	      return shouldUseUriStyleNodeCoreModules(importingFile, program) ? 1 /* GreaterThan */ : -1 /* LessThan */;
	    return 0 /* EqualTo */;
	  }
	  function getFixesInfoForUMDImport({ sourceFile, program, host, preferences }, token) {
	    const checker = program.getTypeChecker();
	    const umdSymbol = getUmdSymbol(token, checker);
	    if (!umdSymbol)
	      return void 0;
	    const symbol = checker.getAliasedSymbol(umdSymbol);
	    const symbolName2 = umdSymbol.name;
	    const exportInfo = [{ symbol: umdSymbol, moduleSymbol: symbol, moduleFileName: void 0, exportKind: 3 /* UMD */, targetFlags: symbol.flags, isFromPackageJson: false }];
	    const useRequire = shouldUseRequire(sourceFile, program);
	    const fixes = getImportFixes(
	      exportInfo,
	      /*usagePosition*/
	      void 0,
	      /*isValidTypeOnlyUseSite*/
	      false,
	      useRequire,
	      program,
	      sourceFile,
	      host,
	      preferences
	    ).fixes;
	    return fixes.map((fix) => {
	      var _a;
	      return { fix, symbolName: symbolName2, errorIdentifierText: (_a = tryCast(token, isIdentifier)) == null ? void 0 : _a.text };
	    });
	  }
	  function getUmdSymbol(token, checker) {
	    const umdSymbol = isIdentifier(token) ? checker.getSymbolAtLocation(token) : void 0;
	    if (isUMDExportSymbol(umdSymbol))
	      return umdSymbol;
	    const { parent: parent2 } = token;
	    if (isJsxOpeningLikeElement(parent2) && parent2.tagName === token || isJsxOpeningFragment(parent2)) {
	      const parentSymbol = checker.resolveName(
	        checker.getJsxNamespace(parent2),
	        isJsxOpeningLikeElement(parent2) ? token : parent2,
	        111551 /* Value */,
	        /*excludeGlobals*/
	        false
	      );
	      if (isUMDExportSymbol(parentSymbol)) {
	        return parentSymbol;
	      }
	    }
	    return void 0;
	  }
	  function getImportKind(importingFile, exportKind, compilerOptions, forceImportKeyword) {
	    if (compilerOptions.verbatimModuleSyntax && (getEmitModuleKind(compilerOptions) === 1 /* CommonJS */ || importingFile.impliedNodeFormat === 1 /* CommonJS */)) {
	      return 3 /* CommonJS */;
	    }
	    switch (exportKind) {
	      case 0 /* Named */:
	        return 0 /* Named */;
	      case 1 /* Default */:
	        return 1 /* Default */;
	      case 2 /* ExportEquals */:
	        return getExportEqualsImportKind(importingFile, compilerOptions, !!forceImportKeyword);
	      case 3 /* UMD */:
	        return getUmdImportKind(importingFile, compilerOptions, !!forceImportKeyword);
	      default:
	        return Debug.assertNever(exportKind);
	    }
	  }
	  function getUmdImportKind(importingFile, compilerOptions, forceImportKeyword) {
	    if (getAllowSyntheticDefaultImports(compilerOptions)) {
	      return 1 /* Default */;
	    }
	    const moduleKind = getEmitModuleKind(compilerOptions);
	    switch (moduleKind) {
	      case 2 /* AMD */:
	      case 1 /* CommonJS */:
	      case 3 /* UMD */:
	        if (isInJSFile(importingFile)) {
	          return isExternalModule(importingFile) || forceImportKeyword ? 2 /* Namespace */ : 3 /* CommonJS */;
	        }
	        return 3 /* CommonJS */;
	      case 4 /* System */:
	      case 5 /* ES2015 */:
	      case 6 /* ES2020 */:
	      case 7 /* ES2022 */:
	      case 99 /* ESNext */:
	      case 0 /* None */:
	      case 200 /* Preserve */:
	        return 2 /* Namespace */;
	      case 100 /* Node16 */:
	      case 199 /* NodeNext */:
	        return importingFile.impliedNodeFormat === 99 /* ESNext */ ? 2 /* Namespace */ : 3 /* CommonJS */;
	      default:
	        return Debug.assertNever(moduleKind, `Unexpected moduleKind ${moduleKind}`);
	    }
	  }
	  function getFixesInfoForNonUMDImport({ sourceFile, program, cancellationToken, host, preferences }, symbolToken, useAutoImportProvider) {
	    const checker = program.getTypeChecker();
	    const compilerOptions = program.getCompilerOptions();
	    return flatMap(getSymbolNamesToImport(sourceFile, checker, symbolToken, compilerOptions), (symbolName2) => {
	      if (symbolName2 === "default" /* Default */) {
	        return void 0;
	      }
	      const isValidTypeOnlyUseSite = isValidTypeOnlyAliasUseSite(symbolToken);
	      const useRequire = shouldUseRequire(sourceFile, program);
	      const exportInfo = getExportInfos(symbolName2, isJSXTagName(symbolToken), getMeaningFromLocation(symbolToken), cancellationToken, sourceFile, program, useAutoImportProvider, host, preferences);
	      return arrayFrom(
	        flatMapIterator(exportInfo.values(), (exportInfos) => getImportFixes(exportInfos, symbolToken.getStart(sourceFile), isValidTypeOnlyUseSite, useRequire, program, sourceFile, host, preferences).fixes),
	        (fix) => ({ fix, symbolName: symbolName2, errorIdentifierText: symbolToken.text, isJsxNamespaceFix: symbolName2 !== symbolToken.text })
	      );
	    });
	  }
	  function getTypeOnlyPromotionFix(sourceFile, symbolToken, symbolName2, program) {
	    const checker = program.getTypeChecker();
	    const symbol = checker.resolveName(
	      symbolName2,
	      symbolToken,
	      111551 /* Value */,
	      /*excludeGlobals*/
	      true
	    );
	    if (!symbol)
	      return void 0;
	    const typeOnlyAliasDeclaration = checker.getTypeOnlyAliasDeclaration(symbol);
	    if (!typeOnlyAliasDeclaration || getSourceFileOfNode(typeOnlyAliasDeclaration) !== sourceFile)
	      return void 0;
	    return { kind: 4 /* PromoteTypeOnly */, typeOnlyAliasDeclaration };
	  }
	  function getSymbolNamesToImport(sourceFile, checker, symbolToken, compilerOptions) {
	    const parent2 = symbolToken.parent;
	    if ((isJsxOpeningLikeElement(parent2) || isJsxClosingElement(parent2)) && parent2.tagName === symbolToken && jsxModeNeedsExplicitImport(compilerOptions.jsx)) {
	      const jsxNamespace = checker.getJsxNamespace(sourceFile);
	      if (needsJsxNamespaceFix(jsxNamespace, symbolToken, checker)) {
	        const needsComponentNameFix = !isIntrinsicJsxName(symbolToken.text) && !checker.resolveName(
	          symbolToken.text,
	          symbolToken,
	          111551 /* Value */,
	          /*excludeGlobals*/
	          false
	        );
	        return needsComponentNameFix ? [symbolToken.text, jsxNamespace] : [jsxNamespace];
	      }
	    }
	    return [symbolToken.text];
	  }
	  function needsJsxNamespaceFix(jsxNamespace, symbolToken, checker) {
	    if (isIntrinsicJsxName(symbolToken.text))
	      return true;
	    const namespaceSymbol = checker.resolveName(
	      jsxNamespace,
	      symbolToken,
	      111551 /* Value */,
	      /*excludeGlobals*/
	      true
	    );
	    return !namespaceSymbol || some(namespaceSymbol.declarations, isTypeOnlyImportOrExportDeclaration) && !(namespaceSymbol.flags & 111551 /* Value */);
	  }
	  function getExportInfos(symbolName2, isJsxTagName, currentTokenMeaning, cancellationToken, fromFile, program, useAutoImportProvider, host, preferences) {
	    var _a;
	    const originalSymbolToExportInfos = createMultiMap();
	    const packageJsonFilter = createPackageJsonImportFilter(fromFile, preferences, host);
	    const moduleSpecifierCache = (_a = host.getModuleSpecifierCache) == null ? void 0 : _a.call(host);
	    const getModuleSpecifierResolutionHost = memoizeOne((isFromPackageJson) => {
	      return createModuleSpecifierResolutionHost(isFromPackageJson ? host.getPackageJsonAutoImportProvider() : program, host);
	    });
	    function addSymbol(moduleSymbol, toFile, exportedSymbol, exportKind, program2, isFromPackageJson) {
	      const moduleSpecifierResolutionHost = getModuleSpecifierResolutionHost(isFromPackageJson);
	      if (toFile && isImportableFile(program2, fromFile, toFile, preferences, packageJsonFilter, moduleSpecifierResolutionHost, moduleSpecifierCache) || !toFile && packageJsonFilter.allowsImportingAmbientModule(moduleSymbol, moduleSpecifierResolutionHost)) {
	        const checker = program2.getTypeChecker();
	        originalSymbolToExportInfos.add(getUniqueSymbolId(exportedSymbol, checker).toString(), { symbol: exportedSymbol, moduleSymbol, moduleFileName: toFile == null ? void 0 : toFile.fileName, exportKind, targetFlags: skipAlias(exportedSymbol, checker).flags, isFromPackageJson });
	      }
	    }
	    forEachExternalModuleToImportFrom(program, host, preferences, useAutoImportProvider, (moduleSymbol, sourceFile, program2, isFromPackageJson) => {
	      const checker = program2.getTypeChecker();
	      cancellationToken.throwIfCancellationRequested();
	      const compilerOptions = program2.getCompilerOptions();
	      const defaultInfo = getDefaultLikeExportInfo(moduleSymbol, checker, compilerOptions);
	      if (defaultInfo && (defaultInfo.name === symbolName2 || moduleSymbolToValidIdentifier(moduleSymbol, getEmitScriptTarget(compilerOptions), isJsxTagName) === symbolName2) && symbolHasMeaning(defaultInfo.resolvedSymbol, currentTokenMeaning)) {
	        addSymbol(moduleSymbol, sourceFile, defaultInfo.symbol, defaultInfo.exportKind, program2, isFromPackageJson);
	      }
	      const exportSymbolWithIdenticalName = checker.tryGetMemberInModuleExportsAndProperties(symbolName2, moduleSymbol);
	      if (exportSymbolWithIdenticalName && symbolHasMeaning(exportSymbolWithIdenticalName, currentTokenMeaning)) {
	        addSymbol(moduleSymbol, sourceFile, exportSymbolWithIdenticalName, 0 /* Named */, program2, isFromPackageJson);
	      }
	    });
	    return originalSymbolToExportInfos;
	  }
	  function getExportEqualsImportKind(importingFile, compilerOptions, forceImportKeyword) {
	    const allowSyntheticDefaults = getAllowSyntheticDefaultImports(compilerOptions);
	    const isJS = isInJSFile(importingFile);
	    if (!isJS && getEmitModuleKind(compilerOptions) >= 5 /* ES2015 */) {
	      return allowSyntheticDefaults ? 1 /* Default */ : 2 /* Namespace */;
	    }
	    if (isJS) {
	      return isExternalModule(importingFile) || forceImportKeyword ? allowSyntheticDefaults ? 1 /* Default */ : 2 /* Namespace */ : 3 /* CommonJS */;
	    }
	    for (const statement of importingFile.statements) {
	      if (isImportEqualsDeclaration(statement) && !nodeIsMissing(statement.moduleReference)) {
	        return 3 /* CommonJS */;
	      }
	    }
	    return allowSyntheticDefaults ? 1 /* Default */ : 3 /* CommonJS */;
	  }
	  function codeActionForFix(context, sourceFile, symbolName2, fix, includeSymbolNameInDescription, program, preferences) {
	    let diag2;
	    const changes = ts_textChanges_exports.ChangeTracker.with(context, (tracker) => {
	      diag2 = codeActionForFixWorker(tracker, sourceFile, symbolName2, fix, includeSymbolNameInDescription, program, preferences);
	    });
	    return createCodeFixAction(importFixName, changes, diag2, importFixId, Diagnostics.Add_all_missing_imports);
	  }
	  function codeActionForFixWorker(changes, sourceFile, symbolName2, fix, includeSymbolNameInDescription, program, preferences) {
	    const quotePreference = getQuotePreference(sourceFile, preferences);
	    switch (fix.kind) {
	      case 0 /* UseNamespace */:
	        addNamespaceQualifier(changes, sourceFile, fix);
	        return [Diagnostics.Change_0_to_1, symbolName2, `${fix.namespacePrefix}.${symbolName2}`];
	      case 1 /* JsdocTypeImport */:
	        addImportType(changes, sourceFile, fix, quotePreference);
	        return [Diagnostics.Change_0_to_1, symbolName2, getImportTypePrefix(fix.moduleSpecifier, quotePreference) + symbolName2];
	      case 2 /* AddToExisting */: {
	        const { importClauseOrBindingPattern, importKind, addAsTypeOnly, moduleSpecifier } = fix;
	        doAddExistingFix(
	          changes,
	          sourceFile,
	          importClauseOrBindingPattern,
	          importKind === 1 /* Default */ ? { name: symbolName2, addAsTypeOnly } : void 0,
	          importKind === 0 /* Named */ ? [{ name: symbolName2, addAsTypeOnly }] : emptyArray,
	          preferences
	        );
	        const moduleSpecifierWithoutQuotes = stripQuotes(moduleSpecifier);
	        return includeSymbolNameInDescription ? [Diagnostics.Import_0_from_1, symbolName2, moduleSpecifierWithoutQuotes] : [Diagnostics.Update_import_from_0, moduleSpecifierWithoutQuotes];
	      }
	      case 3 /* AddNew */: {
	        const { importKind, moduleSpecifier, addAsTypeOnly, useRequire, qualification } = fix;
	        const getDeclarations = useRequire ? getNewRequires : getNewImports;
	        const defaultImport = importKind === 1 /* Default */ ? { name: symbolName2, addAsTypeOnly } : void 0;
	        const namedImports = importKind === 0 /* Named */ ? [{ name: symbolName2, addAsTypeOnly }] : void 0;
	        const namespaceLikeImport = importKind === 2 /* Namespace */ || importKind === 3 /* CommonJS */ ? { importKind, name: (qualification == null ? void 0 : qualification.namespacePrefix) || symbolName2, addAsTypeOnly } : void 0;
	        insertImports(
	          changes,
	          sourceFile,
	          getDeclarations(
	            moduleSpecifier,
	            quotePreference,
	            defaultImport,
	            namedImports,
	            namespaceLikeImport,
	            program.getCompilerOptions(),
	            preferences
	          ),
	          /*blankLineBetween*/
	          true,
	          preferences
	        );
	        if (qualification) {
	          addNamespaceQualifier(changes, sourceFile, qualification);
	        }
	        return includeSymbolNameInDescription ? [Diagnostics.Import_0_from_1, symbolName2, moduleSpecifier] : [Diagnostics.Add_import_from_0, moduleSpecifier];
	      }
	      case 4 /* PromoteTypeOnly */: {
	        const { typeOnlyAliasDeclaration } = fix;
	        const promotedDeclaration = promoteFromTypeOnly(changes, typeOnlyAliasDeclaration, program, sourceFile, preferences);
	        return promotedDeclaration.kind === 276 /* ImportSpecifier */ ? [Diagnostics.Remove_type_from_import_of_0_from_1, symbolName2, getModuleSpecifierText(promotedDeclaration.parent.parent)] : [Diagnostics.Remove_type_from_import_declaration_from_0, getModuleSpecifierText(promotedDeclaration)];
	      }
	      default:
	        return Debug.assertNever(fix, `Unexpected fix kind ${fix.kind}`);
	    }
	  }
	  function getModuleSpecifierText(promotedDeclaration) {
	    var _a, _b;
	    return promotedDeclaration.kind === 271 /* ImportEqualsDeclaration */ ? ((_b = tryCast((_a = tryCast(promotedDeclaration.moduleReference, isExternalModuleReference)) == null ? void 0 : _a.expression, isStringLiteralLike)) == null ? void 0 : _b.text) || promotedDeclaration.moduleReference.getText() : cast(promotedDeclaration.parent.moduleSpecifier, isStringLiteral).text;
	  }
	  function promoteFromTypeOnly(changes, aliasDeclaration, program, sourceFile, preferences) {
	    const compilerOptions = program.getCompilerOptions();
	    const convertExistingToTypeOnly = importNameElisionDisabled(compilerOptions);
	    switch (aliasDeclaration.kind) {
	      case 276 /* ImportSpecifier */:
	        if (aliasDeclaration.isTypeOnly) {
	          const sortKind = ts_OrganizeImports_exports.detectImportSpecifierSorting(aliasDeclaration.parent.elements, preferences);
	          if (aliasDeclaration.parent.elements.length > 1 && sortKind) {
	            const newSpecifier = factory.updateImportSpecifier(
	              aliasDeclaration,
	              /*isTypeOnly*/
	              false,
	              aliasDeclaration.propertyName,
	              aliasDeclaration.name
	            );
	            const comparer = ts_OrganizeImports_exports.getOrganizeImportsComparer(preferences, sortKind === 2 /* CaseInsensitive */);
	            const insertionIndex = ts_OrganizeImports_exports.getImportSpecifierInsertionIndex(aliasDeclaration.parent.elements, newSpecifier, comparer, preferences);
	            if (insertionIndex !== aliasDeclaration.parent.elements.indexOf(aliasDeclaration)) {
	              changes.delete(sourceFile, aliasDeclaration);
	              changes.insertImportSpecifierAtIndex(sourceFile, newSpecifier, aliasDeclaration.parent, insertionIndex);
	              return aliasDeclaration;
	            }
	          }
	          changes.deleteRange(sourceFile, { pos: getTokenPosOfNode(aliasDeclaration.getFirstToken()), end: getTokenPosOfNode(aliasDeclaration.propertyName ?? aliasDeclaration.name) });
	          return aliasDeclaration;
	        } else {
	          Debug.assert(aliasDeclaration.parent.parent.isTypeOnly);
	          promoteImportClause(aliasDeclaration.parent.parent);
	          return aliasDeclaration.parent.parent;
	        }
	      case 273 /* ImportClause */:
	        promoteImportClause(aliasDeclaration);
	        return aliasDeclaration;
	      case 274 /* NamespaceImport */:
	        promoteImportClause(aliasDeclaration.parent);
	        return aliasDeclaration.parent;
	      case 271 /* ImportEqualsDeclaration */:
	        changes.deleteRange(sourceFile, aliasDeclaration.getChildAt(1));
	        return aliasDeclaration;
	      default:
	        Debug.failBadSyntaxKind(aliasDeclaration);
	    }
	    function promoteImportClause(importClause) {
	      var _a;
	      changes.delete(sourceFile, getTypeKeywordOfTypeOnlyImport(importClause, sourceFile));
	      if (!compilerOptions.allowImportingTsExtensions) {
	        const moduleSpecifier = tryGetModuleSpecifierFromDeclaration(importClause.parent);
	        const resolvedModule = moduleSpecifier && ((_a = program.getResolvedModuleFromModuleSpecifier(moduleSpecifier)) == null ? void 0 : _a.resolvedModule);
	        if (resolvedModule == null ? void 0 : resolvedModule.resolvedUsingTsExtension) {
	          const changedExtension = changeAnyExtension(moduleSpecifier.text, getOutputExtension(moduleSpecifier.text, compilerOptions));
	          changes.replaceNode(sourceFile, moduleSpecifier, factory.createStringLiteral(changedExtension));
	        }
	      }
	      if (convertExistingToTypeOnly) {
	        const namedImports = tryCast(importClause.namedBindings, isNamedImports);
	        if (namedImports && namedImports.elements.length > 1) {
	          if (ts_OrganizeImports_exports.detectImportSpecifierSorting(namedImports.elements, preferences) && aliasDeclaration.kind === 276 /* ImportSpecifier */ && namedImports.elements.indexOf(aliasDeclaration) !== 0) {
	            changes.delete(sourceFile, aliasDeclaration);
	            changes.insertImportSpecifierAtIndex(sourceFile, aliasDeclaration, namedImports, 0);
	          }
	          for (const element of namedImports.elements) {
	            if (element !== aliasDeclaration && !element.isTypeOnly) {
	              changes.insertModifierBefore(sourceFile, 156 /* TypeKeyword */, element);
	            }
	          }
	        }
	      }
	    }
	  }
	  function doAddExistingFix(changes, sourceFile, clause, defaultImport, namedImports, preferences) {
	    var _a;
	    if (clause.kind === 206 /* ObjectBindingPattern */) {
	      if (defaultImport) {
	        addElementToBindingPattern(clause, defaultImport.name, "default");
	      }
	      for (const specifier of namedImports) {
	        addElementToBindingPattern(
	          clause,
	          specifier.name,
	          /*propertyName*/
	          void 0
	        );
	      }
	      return;
	    }
	    const promoteFromTypeOnly2 = clause.isTypeOnly && some([defaultImport, ...namedImports], (i) => (i == null ? void 0 : i.addAsTypeOnly) === 4 /* NotAllowed */);
	    const existingSpecifiers = clause.namedBindings && ((_a = tryCast(clause.namedBindings, isNamedImports)) == null ? void 0 : _a.elements);
	    if (defaultImport) {
	      Debug.assert(!clause.name, "Cannot add a default import to an import clause that already has one");
	      changes.insertNodeAt(sourceFile, clause.getStart(sourceFile), factory.createIdentifier(defaultImport.name), { suffix: ", " });
	    }
	    if (namedImports.length) {
	      let ignoreCaseForSorting;
	      if (typeof preferences.organizeImportsIgnoreCase === "boolean") {
	        ignoreCaseForSorting = preferences.organizeImportsIgnoreCase;
	      } else if (existingSpecifiers) {
	        const targetImportSorting = ts_OrganizeImports_exports.detectImportSpecifierSorting(existingSpecifiers, preferences);
	        if (targetImportSorting !== 3 /* Both */) {
	          ignoreCaseForSorting = targetImportSorting === 2 /* CaseInsensitive */;
	        }
	      }
	      if (ignoreCaseForSorting === void 0) {
	        ignoreCaseForSorting = ts_OrganizeImports_exports.detectSorting(sourceFile, preferences) === 2 /* CaseInsensitive */;
	      }
	      const comparer = ts_OrganizeImports_exports.getOrganizeImportsComparer(preferences, ignoreCaseForSorting);
	      const newSpecifiers = stableSort(
	        namedImports.map(
	          (namedImport) => factory.createImportSpecifier(
	            (!clause.isTypeOnly || promoteFromTypeOnly2) && shouldUseTypeOnly(namedImport, preferences),
	            /*propertyName*/
	            void 0,
	            factory.createIdentifier(namedImport.name)
	          )
	        ),
	        (s1, s2) => ts_OrganizeImports_exports.compareImportOrExportSpecifiers(s1, s2, comparer)
	      );
	      const specifierSort = (existingSpecifiers == null ? void 0 : existingSpecifiers.length) && ts_OrganizeImports_exports.detectImportSpecifierSorting(existingSpecifiers, preferences);
	      if (specifierSort && !(ignoreCaseForSorting && specifierSort === 1 /* CaseSensitive */)) {
	        for (const spec of newSpecifiers) {
	          const insertionIndex = promoteFromTypeOnly2 && !spec.isTypeOnly ? 0 : ts_OrganizeImports_exports.getImportSpecifierInsertionIndex(existingSpecifiers, spec, comparer, preferences);
	          changes.insertImportSpecifierAtIndex(sourceFile, spec, clause.namedBindings, insertionIndex);
	        }
	      } else if (existingSpecifiers == null ? void 0 : existingSpecifiers.length) {
	        for (const spec of newSpecifiers) {
	          changes.insertNodeInListAfter(sourceFile, last(existingSpecifiers), spec, existingSpecifiers);
	        }
	      } else {
	        if (newSpecifiers.length) {
	          const namedImports2 = factory.createNamedImports(newSpecifiers);
	          if (clause.namedBindings) {
	            changes.replaceNode(sourceFile, clause.namedBindings, namedImports2);
	          } else {
	            changes.insertNodeAfter(sourceFile, Debug.checkDefined(clause.name, "Import clause must have either named imports or a default import"), namedImports2);
	          }
	        }
	      }
	    }
	    if (promoteFromTypeOnly2) {
	      changes.delete(sourceFile, getTypeKeywordOfTypeOnlyImport(clause, sourceFile));
	      if (existingSpecifiers) {
	        for (const specifier of existingSpecifiers) {
	          changes.insertModifierBefore(sourceFile, 156 /* TypeKeyword */, specifier);
	        }
	      }
	    }
	    function addElementToBindingPattern(bindingPattern, name, propertyName) {
	      const element = factory.createBindingElement(
	        /*dotDotDotToken*/
	        void 0,
	        propertyName,
	        name
	      );
	      if (bindingPattern.elements.length) {
	        changes.insertNodeInListAfter(sourceFile, last(bindingPattern.elements), element);
	      } else {
	        changes.replaceNode(sourceFile, bindingPattern, factory.createObjectBindingPattern([element]));
	      }
	    }
	  }
	  function addNamespaceQualifier(changes, sourceFile, { namespacePrefix, usagePosition }) {
	    changes.insertText(sourceFile, usagePosition, namespacePrefix + ".");
	  }
	  function addImportType(changes, sourceFile, { moduleSpecifier, usagePosition: position }, quotePreference) {
	    changes.insertText(sourceFile, position, getImportTypePrefix(moduleSpecifier, quotePreference));
	  }
	  function getImportTypePrefix(moduleSpecifier, quotePreference) {
	    const quote2 = getQuoteFromPreference(quotePreference);
	    return `import(${quote2}${moduleSpecifier}${quote2}).`;
	  }
	  function needsTypeOnly({ addAsTypeOnly }) {
	    return addAsTypeOnly === 2 /* Required */;
	  }
	  function shouldUseTypeOnly(info, preferences) {
	    return needsTypeOnly(info) || !!preferences.preferTypeOnlyAutoImports && info.addAsTypeOnly !== 4 /* NotAllowed */;
	  }
	  function getNewImports(moduleSpecifier, quotePreference, defaultImport, namedImports, namespaceLikeImport, compilerOptions, preferences) {
	    const quotedModuleSpecifier = makeStringLiteral(moduleSpecifier, quotePreference);
	    let statements;
	    if (defaultImport !== void 0 || (namedImports == null ? void 0 : namedImports.length)) {
	      const topLevelTypeOnly = (!defaultImport || needsTypeOnly(defaultImport)) && every(namedImports, needsTypeOnly) || (compilerOptions.verbatimModuleSyntax || preferences.preferTypeOnlyAutoImports) && (defaultImport == null ? void 0 : defaultImport.addAsTypeOnly) !== 4 /* NotAllowed */ && !some(namedImports, (i) => i.addAsTypeOnly === 4 /* NotAllowed */);
	      statements = combine(
	        statements,
	        makeImport(
	          defaultImport && factory.createIdentifier(defaultImport.name),
	          namedImports == null ? void 0 : namedImports.map(
	            (namedImport) => factory.createImportSpecifier(
	              !topLevelTypeOnly && shouldUseTypeOnly(namedImport, preferences),
	              /*propertyName*/
	              void 0,
	              factory.createIdentifier(namedImport.name)
	            )
	          ),
	          moduleSpecifier,
	          quotePreference,
	          topLevelTypeOnly
	        )
	      );
	    }
	    if (namespaceLikeImport) {
	      const declaration = namespaceLikeImport.importKind === 3 /* CommonJS */ ? factory.createImportEqualsDeclaration(
	        /*modifiers*/
	        void 0,
	        shouldUseTypeOnly(namespaceLikeImport, preferences),
	        factory.createIdentifier(namespaceLikeImport.name),
	        factory.createExternalModuleReference(quotedModuleSpecifier)
	      ) : factory.createImportDeclaration(
	        /*modifiers*/
	        void 0,
	        factory.createImportClause(
	          shouldUseTypeOnly(namespaceLikeImport, preferences),
	          /*name*/
	          void 0,
	          factory.createNamespaceImport(factory.createIdentifier(namespaceLikeImport.name))
	        ),
	        quotedModuleSpecifier,
	        /*attributes*/
	        void 0
	      );
	      statements = combine(statements, declaration);
	    }
	    return Debug.checkDefined(statements);
	  }
	  function getNewRequires(moduleSpecifier, quotePreference, defaultImport, namedImports, namespaceLikeImport) {
	    const quotedModuleSpecifier = makeStringLiteral(moduleSpecifier, quotePreference);
	    let statements;
	    if (defaultImport || (namedImports == null ? void 0 : namedImports.length)) {
	      const bindingElements = (namedImports == null ? void 0 : namedImports.map(({ name }) => factory.createBindingElement(
	        /*dotDotDotToken*/
	        void 0,
	        /*propertyName*/
	        void 0,
	        name
	      ))) || [];
	      if (defaultImport) {
	        bindingElements.unshift(factory.createBindingElement(
	          /*dotDotDotToken*/
	          void 0,
	          "default",
	          defaultImport.name
	        ));
	      }
	      const declaration = createConstEqualsRequireDeclaration(factory.createObjectBindingPattern(bindingElements), quotedModuleSpecifier);
	      statements = combine(statements, declaration);
	    }
	    if (namespaceLikeImport) {
	      const declaration = createConstEqualsRequireDeclaration(namespaceLikeImport.name, quotedModuleSpecifier);
	      statements = combine(statements, declaration);
	    }
	    return Debug.checkDefined(statements);
	  }
	  function createConstEqualsRequireDeclaration(name, quotedModuleSpecifier) {
	    return factory.createVariableStatement(
	      /*modifiers*/
	      void 0,
	      factory.createVariableDeclarationList([
	        factory.createVariableDeclaration(
	          typeof name === "string" ? factory.createIdentifier(name) : name,
	          /*exclamationToken*/
	          void 0,
	          /*type*/
	          void 0,
	          factory.createCallExpression(
	            factory.createIdentifier("require"),
	            /*typeArguments*/
	            void 0,
	            [quotedModuleSpecifier]
	          )
	        )
	      ], 2 /* Const */)
	    );
	  }
	  function symbolHasMeaning({ declarations }, meaning) {
	    return some(declarations, (decl) => !!(getMeaningFromDeclaration(decl) & meaning));
	  }
	  function moduleSymbolToValidIdentifier(moduleSymbol, target, forceCapitalize) {
	    return moduleSpecifierToValidIdentifier(removeFileExtension(stripQuotes(moduleSymbol.name)), target, forceCapitalize);
	  }
	  function moduleSpecifierToValidIdentifier(moduleSpecifier, target, forceCapitalize) {
	    const baseName = getBaseFileName(removeSuffix(moduleSpecifier, "/index"));
	    let res = "";
	    let lastCharWasValid = true;
	    const firstCharCode = baseName.charCodeAt(0);
	    if (isIdentifierStart(firstCharCode, target)) {
	      res += String.fromCharCode(firstCharCode);
	      if (forceCapitalize) {
	        res = res.toUpperCase();
	      }
	    } else {
	      lastCharWasValid = false;
	    }
	    for (let i = 1; i < baseName.length; i++) {
	      const ch = baseName.charCodeAt(i);
	      const isValid = isIdentifierPart(ch, target);
	      if (isValid) {
	        let char = String.fromCharCode(ch);
	        if (!lastCharWasValid) {
	          char = char.toUpperCase();
	        }
	        res += char;
	      }
	      lastCharWasValid = isValid;
	    }
	    return !isStringANonContextualKeyword(res) ? res || "_" : `_${res}`;
	  }
	  var importFixName, importFixId, errorCodes18;
	  var init_importFixes = __esm({
	    "src/services/codefixes/importFixes.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      importFixName = "import";
	      importFixId = "fixMissingImport";
	      errorCodes18 = [
	        Diagnostics.Cannot_find_name_0.code,
	        Diagnostics.Cannot_find_name_0_Did_you_mean_1.code,
	        Diagnostics.Cannot_find_name_0_Did_you_mean_the_instance_member_this_0.code,
	        Diagnostics.Cannot_find_name_0_Did_you_mean_the_static_member_1_0.code,
	        Diagnostics.Cannot_find_namespace_0.code,
	        Diagnostics._0_refers_to_a_UMD_global_but_the_current_file_is_a_module_Consider_adding_an_import_instead.code,
	        Diagnostics._0_only_refers_to_a_type_but_is_being_used_as_a_value_here.code,
	        Diagnostics.No_value_exists_in_scope_for_the_shorthand_property_0_Either_declare_one_or_provide_an_initializer.code,
	        Diagnostics._0_cannot_be_used_as_a_value_because_it_was_imported_using_import_type.code,
	        Diagnostics.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_jQuery_Try_npm_i_save_dev_types_Slashjquery.code,
	        Diagnostics.Cannot_find_name_0_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_1_or_later.code,
	        Diagnostics.Cannot_find_name_0_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_include_dom.code,
	        Diagnostics.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_a_test_runner_Try_npm_i_save_dev_types_Slashjest_or_npm_i_save_dev_types_Slashmocha_and_then_add_jest_or_mocha_to_the_types_field_in_your_tsconfig.code,
	        Diagnostics.Cannot_find_name_0_Did_you_mean_to_write_this_in_an_async_function.code,
	        Diagnostics.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_jQuery_Try_npm_i_save_dev_types_Slashjquery_and_then_add_jquery_to_the_types_field_in_your_tsconfig.code,
	        Diagnostics.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_a_test_runner_Try_npm_i_save_dev_types_Slashjest_or_npm_i_save_dev_types_Slashmocha.code,
	        Diagnostics.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_node_Try_npm_i_save_dev_types_Slashnode.code,
	        Diagnostics.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_node_Try_npm_i_save_dev_types_Slashnode_and_then_add_node_to_the_types_field_in_your_tsconfig.code,
	        Diagnostics.Cannot_find_namespace_0_Did_you_mean_1.code
	      ];
	      registerCodeFix({
	        errorCodes: errorCodes18,
	        getCodeActions(context) {
	          const { errorCode, preferences, sourceFile, span, program } = context;
	          const info = getFixInfos(
	            context,
	            errorCode,
	            span.start,
	            /*useAutoImportProvider*/
	            true
	          );
	          if (!info)
	            return void 0;
	          return info.map(
	            ({ fix, symbolName: symbolName2, errorIdentifierText }) => codeActionForFix(
	              context,
	              sourceFile,
	              symbolName2,
	              fix,
	              /*includeSymbolNameInDescription*/
	              symbolName2 !== errorIdentifierText,
	              program,
	              preferences
	            )
	          );
	        },
	        fixIds: [importFixId],
	        getAllCodeActions: (context) => {
	          const { sourceFile, program, preferences, host, cancellationToken } = context;
	          const importAdder = createImportAdderWorker(
	            sourceFile,
	            program,
	            /*useAutoImportProvider*/
	            true,
	            preferences,
	            host,
	            cancellationToken
	          );
	          eachDiagnostic(context, errorCodes18, (diag2) => importAdder.addImportFromDiagnostic(diag2, context));
	          return createCombinedCodeActions(ts_textChanges_exports.ChangeTracker.with(context, importAdder.writeFixes));
	        }
	      });
	    }
	  });

	  // src/services/codefixes/fixAddMissingConstraint.ts
	  function getInfo6(program, sourceFile, span) {
	    const diag2 = find(program.getSemanticDiagnostics(sourceFile), (diag3) => diag3.start === span.start && diag3.length === span.length);
	    if (diag2 === void 0 || diag2.relatedInformation === void 0)
	      return;
	    const related = find(diag2.relatedInformation, (related2) => related2.code === Diagnostics.This_type_parameter_might_need_an_extends_0_constraint.code);
	    if (related === void 0 || related.file === void 0 || related.start === void 0 || related.length === void 0)
	      return;
	    let declaration = findAncestorMatchingSpan(related.file, createTextSpan(related.start, related.length));
	    if (declaration === void 0)
	      return;
	    if (isIdentifier(declaration) && isTypeParameterDeclaration(declaration.parent)) {
	      declaration = declaration.parent;
	    }
	    if (isTypeParameterDeclaration(declaration)) {
	      if (isMappedTypeNode(declaration.parent))
	        return;
	      const token = getTokenAtPosition(sourceFile, span.start);
	      const checker = program.getTypeChecker();
	      const constraint = tryGetConstraintType(checker, token) || tryGetConstraintFromDiagnosticMessage(related.messageText);
	      return { constraint, declaration, token };
	    }
	    return void 0;
	  }
	  function addMissingConstraint(changes, program, preferences, host, sourceFile, info) {
	    const { declaration, constraint } = info;
	    const checker = program.getTypeChecker();
	    if (isString(constraint)) {
	      changes.insertText(sourceFile, declaration.name.end, ` extends ${constraint}`);
	    } else {
	      const scriptTarget = getEmitScriptTarget(program.getCompilerOptions());
	      const tracker = getNoopSymbolTrackerWithResolver({ program, host });
	      const importAdder = createImportAdder(sourceFile, program, preferences, host);
	      const typeNode = typeToAutoImportableTypeNode(
	        checker,
	        importAdder,
	        constraint,
	        /*contextNode*/
	        void 0,
	        scriptTarget,
	        /*flags*/
	        void 0,
	        tracker
	      );
	      if (typeNode) {
	        changes.replaceNode(sourceFile, declaration, factory.updateTypeParameterDeclaration(
	          declaration,
	          /*modifiers*/
	          void 0,
	          declaration.name,
	          typeNode,
	          declaration.default
	        ));
	        importAdder.writeFixes(changes);
	      }
	    }
	  }
	  function tryGetConstraintFromDiagnosticMessage(messageText) {
	    const [, constraint] = flattenDiagnosticMessageText(messageText, "\n", 0).match(/`extends (.*)`/) || [];
	    return constraint;
	  }
	  function tryGetConstraintType(checker, node) {
	    if (isTypeNode(node.parent)) {
	      return checker.getTypeArgumentConstraint(node.parent);
	    }
	    const contextualType = isExpression(node) ? checker.getContextualType(node) : void 0;
	    return contextualType || checker.getTypeAtLocation(node);
	  }
	  var fixId17, errorCodes19;
	  var init_fixAddMissingConstraint = __esm({
	    "src/services/codefixes/fixAddMissingConstraint.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      fixId17 = "addMissingConstraint";
	      errorCodes19 = [
	        // We want errors this could be attached to:
	        // Diagnostics.This_type_parameter_probably_needs_an_extends_0_constraint
	        Diagnostics.Type_0_is_not_comparable_to_type_1.code,
	        Diagnostics.Type_0_is_not_assignable_to_type_1_Two_different_types_with_this_name_exist_but_they_are_unrelated.code,
	        Diagnostics.Type_0_is_not_assignable_to_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_types_of_the_target_s_properties.code,
	        Diagnostics.Type_0_is_not_assignable_to_type_1.code,
	        Diagnostics.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_types_of_the_target_s_properties.code,
	        Diagnostics.Property_0_is_incompatible_with_index_signature.code,
	        Diagnostics.Property_0_in_type_1_is_not_assignable_to_type_2.code,
	        Diagnostics.Type_0_does_not_satisfy_the_constraint_1.code
	      ];
	      registerCodeFix({
	        errorCodes: errorCodes19,
	        getCodeActions(context) {
	          const { sourceFile, span, program, preferences, host } = context;
	          const info = getInfo6(program, sourceFile, span);
	          if (info === void 0)
	            return;
	          const changes = ts_textChanges_exports.ChangeTracker.with(context, (t) => addMissingConstraint(t, program, preferences, host, sourceFile, info));
	          return [createCodeFixAction(fixId17, changes, Diagnostics.Add_extends_constraint, fixId17, Diagnostics.Add_extends_constraint_to_all_type_parameters)];
	        },
	        fixIds: [fixId17],
	        getAllCodeActions: (context) => {
	          const { program, preferences, host } = context;
	          const seen = /* @__PURE__ */ new Map();
	          return createCombinedCodeActions(ts_textChanges_exports.ChangeTracker.with(context, (changes) => {
	            eachDiagnostic(context, errorCodes19, (diag2) => {
	              const info = getInfo6(program, diag2.file, createTextSpan(diag2.start, diag2.length));
	              if (info) {
	                if (addToSeen(seen, getNodeId(info.declaration))) {
	                  return addMissingConstraint(changes, program, preferences, host, diag2.file, info);
	                }
	              }
	              return void 0;
	            });
	          }));
	        }
	      });
	    }
	  });

	  // src/services/codefixes/fixOverrideModifier.ts
	  function dispatchChanges(changeTracker, context, errorCode, pos) {
	    switch (errorCode) {
	      case Diagnostics.This_member_must_have_an_override_modifier_because_it_overrides_a_member_in_the_base_class_0.code:
	      case Diagnostics.This_member_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_in_the_base_class_0.code:
	      case Diagnostics.This_member_must_have_an_override_modifier_because_it_overrides_an_abstract_method_that_is_declared_in_the_base_class_0.code:
	      case Diagnostics.This_parameter_property_must_have_an_override_modifier_because_it_overrides_a_member_in_base_class_0.code:
	      case Diagnostics.This_parameter_property_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_in_the_base_class_0.code:
	        return doAddOverrideModifierChange(changeTracker, context.sourceFile, pos);
	      case Diagnostics.This_member_cannot_have_an_override_modifier_because_it_is_not_declared_in_the_base_class_0.code:
	      case Diagnostics.This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_it_is_not_declared_in_the_base_class_0.code:
	      case Diagnostics.This_member_cannot_have_an_override_modifier_because_its_containing_class_0_does_not_extend_another_class.code:
	      case Diagnostics.This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_its_containing_class_0_does_not_extend_another_class.code:
	        return doRemoveOverrideModifierChange(changeTracker, context.sourceFile, pos);
	      default:
	        Debug.fail("Unexpected error code: " + errorCode);
	    }
	  }
	  function doAddOverrideModifierChange(changeTracker, sourceFile, pos) {
	    const classElement = findContainerClassElementLike(sourceFile, pos);
	    if (isSourceFileJS(sourceFile)) {
	      changeTracker.addJSDocTags(sourceFile, classElement, [factory.createJSDocOverrideTag(factory.createIdentifier("override"))]);
	      return;
	    }
	    const modifiers = classElement.modifiers || emptyArray;
	    const staticModifier = find(modifiers, isStaticModifier);
	    const abstractModifier = find(modifiers, isAbstractModifier);
	    const accessibilityModifier = find(modifiers, (m) => isAccessibilityModifier(m.kind));
	    const lastDecorator = findLast(modifiers, isDecorator);
	    const modifierPos = abstractModifier ? abstractModifier.end : staticModifier ? staticModifier.end : accessibilityModifier ? accessibilityModifier.end : lastDecorator ? skipTrivia(sourceFile.text, lastDecorator.end) : classElement.getStart(sourceFile);
	    const options = accessibilityModifier || staticModifier || abstractModifier ? { prefix: " " } : { suffix: " " };
	    changeTracker.insertModifierAt(sourceFile, modifierPos, 164 /* OverrideKeyword */, options);
	  }
	  function doRemoveOverrideModifierChange(changeTracker, sourceFile, pos) {
	    const classElement = findContainerClassElementLike(sourceFile, pos);
	    if (isSourceFileJS(sourceFile)) {
	      changeTracker.filterJSDocTags(sourceFile, classElement, not(isJSDocOverrideTag));
	      return;
	    }
	    const overrideModifier = find(classElement.modifiers, isOverrideModifier);
	    Debug.assertIsDefined(overrideModifier);
	    changeTracker.deleteModifier(sourceFile, overrideModifier);
	  }
	  function isClassElementLikeHasJSDoc(node) {
	    switch (node.kind) {
	      case 176 /* Constructor */:
	      case 172 /* PropertyDeclaration */:
	      case 174 /* MethodDeclaration */:
	      case 177 /* GetAccessor */:
	      case 178 /* SetAccessor */:
	        return true;
	      case 169 /* Parameter */:
	        return isParameterPropertyDeclaration(node, node.parent);
	      default:
	        return false;
	    }
	  }
	  function findContainerClassElementLike(sourceFile, pos) {
	    const token = getTokenAtPosition(sourceFile, pos);
	    const classElement = findAncestor(token, (node) => {
	      if (isClassLike(node))
	        return "quit";
	      return isClassElementLikeHasJSDoc(node);
	    });
	    Debug.assert(classElement && isClassElementLikeHasJSDoc(classElement));
	    return classElement;
	  }
	  var fixName, fixAddOverrideId, fixRemoveOverrideId, errorCodes20, errorCodeFixIdMap;
	  var init_fixOverrideModifier = __esm({
	    "src/services/codefixes/fixOverrideModifier.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      fixName = "fixOverrideModifier";
	      fixAddOverrideId = "fixAddOverrideModifier";
	      fixRemoveOverrideId = "fixRemoveOverrideModifier";
	      errorCodes20 = [
	        Diagnostics.This_member_cannot_have_an_override_modifier_because_it_is_not_declared_in_the_base_class_0.code,
	        Diagnostics.This_member_cannot_have_an_override_modifier_because_its_containing_class_0_does_not_extend_another_class.code,
	        Diagnostics.This_member_must_have_an_override_modifier_because_it_overrides_an_abstract_method_that_is_declared_in_the_base_class_0.code,
	        Diagnostics.This_member_must_have_an_override_modifier_because_it_overrides_a_member_in_the_base_class_0.code,
	        Diagnostics.This_parameter_property_must_have_an_override_modifier_because_it_overrides_a_member_in_base_class_0.code,
	        Diagnostics.This_member_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_in_the_base_class_0.code,
	        Diagnostics.This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_its_containing_class_0_does_not_extend_another_class.code,
	        Diagnostics.This_parameter_property_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_in_the_base_class_0.code,
	        Diagnostics.This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_it_is_not_declared_in_the_base_class_0.code
	      ];
	      errorCodeFixIdMap = {
	        // case #1:
	        [Diagnostics.This_member_must_have_an_override_modifier_because_it_overrides_a_member_in_the_base_class_0.code]: {
	          descriptions: Diagnostics.Add_override_modifier,
	          fixId: fixAddOverrideId,
	          fixAllDescriptions: Diagnostics.Add_all_missing_override_modifiers
	        },
	        [Diagnostics.This_member_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_in_the_base_class_0.code]: {
	          descriptions: Diagnostics.Add_override_modifier,
	          fixId: fixAddOverrideId,
	          fixAllDescriptions: Diagnostics.Add_all_missing_override_modifiers
	        },
	        // case #2:
	        [Diagnostics.This_member_cannot_have_an_override_modifier_because_its_containing_class_0_does_not_extend_another_class.code]: {
	          descriptions: Diagnostics.Remove_override_modifier,
	          fixId: fixRemoveOverrideId,
	          fixAllDescriptions: Diagnostics.Remove_all_unnecessary_override_modifiers
	        },
	        [Diagnostics.This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_its_containing_class_0_does_not_extend_another_class.code]: {
	          descriptions: Diagnostics.Remove_override_modifier,
	          fixId: fixRemoveOverrideId,
	          fixAllDescriptions: Diagnostics.Remove_override_modifier
	        },
	        // case #3:
	        [Diagnostics.This_parameter_property_must_have_an_override_modifier_because_it_overrides_a_member_in_base_class_0.code]: {
	          descriptions: Diagnostics.Add_override_modifier,
	          fixId: fixAddOverrideId,
	          fixAllDescriptions: Diagnostics.Add_all_missing_override_modifiers
	        },
	        [Diagnostics.This_parameter_property_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_in_the_base_class_0.code]: {
	          descriptions: Diagnostics.Add_override_modifier,
	          fixId: fixAddOverrideId,
	          fixAllDescriptions: Diagnostics.Add_all_missing_override_modifiers
	        },
	        // case #4:
	        [Diagnostics.This_member_must_have_an_override_modifier_because_it_overrides_an_abstract_method_that_is_declared_in_the_base_class_0.code]: {
	          descriptions: Diagnostics.Add_override_modifier,
	          fixId: fixAddOverrideId,
	          fixAllDescriptions: Diagnostics.Remove_all_unnecessary_override_modifiers
	        },
	        // case #5:
	        [Diagnostics.This_member_cannot_have_an_override_modifier_because_it_is_not_declared_in_the_base_class_0.code]: {
	          descriptions: Diagnostics.Remove_override_modifier,
	          fixId: fixRemoveOverrideId,
	          fixAllDescriptions: Diagnostics.Remove_all_unnecessary_override_modifiers
	        },
	        [Diagnostics.This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_it_is_not_declared_in_the_base_class_0.code]: {
	          descriptions: Diagnostics.Remove_override_modifier,
	          fixId: fixRemoveOverrideId,
	          fixAllDescriptions: Diagnostics.Remove_all_unnecessary_override_modifiers
	        }
	      };
	      registerCodeFix({
	        errorCodes: errorCodes20,
	        getCodeActions: function getCodeActionsToFixOverrideModifierIssues(context) {
	          const { errorCode, span } = context;
	          const info = errorCodeFixIdMap[errorCode];
	          if (!info)
	            return emptyArray;
	          const { descriptions, fixId: fixId52, fixAllDescriptions } = info;
	          const changes = ts_textChanges_exports.ChangeTracker.with(context, (changes2) => dispatchChanges(changes2, context, errorCode, span.start));
	          return [
	            createCodeFixActionMaybeFixAll(fixName, changes, descriptions, fixId52, fixAllDescriptions)
	          ];
	        },
	        fixIds: [fixName, fixAddOverrideId, fixRemoveOverrideId],
	        getAllCodeActions: (context) => codeFixAll(context, errorCodes20, (changes, diag2) => {
	          const { code, start } = diag2;
	          const info = errorCodeFixIdMap[code];
	          if (!info || info.fixId !== context.fixId) {
	            return;
	          }
	          dispatchChanges(changes, context, code, start);
	        })
	      });
	    }
	  });

	  // src/services/codefixes/fixNoPropertyAccessFromIndexSignature.ts
	  function doChange14(changes, sourceFile, node, preferences) {
	    const quotePreference = getQuotePreference(sourceFile, preferences);
	    const argumentsExpression = factory.createStringLiteral(node.name.text, quotePreference === 0 /* Single */);
	    changes.replaceNode(
	      sourceFile,
	      node,
	      isPropertyAccessChain(node) ? factory.createElementAccessChain(node.expression, node.questionDotToken, argumentsExpression) : factory.createElementAccessExpression(node.expression, argumentsExpression)
	    );
	  }
	  function getPropertyAccessExpression(sourceFile, pos) {
	    return cast(getTokenAtPosition(sourceFile, pos).parent, isPropertyAccessExpression);
	  }
	  var fixId18, errorCodes21;
	  var init_fixNoPropertyAccessFromIndexSignature = __esm({
	    "src/services/codefixes/fixNoPropertyAccessFromIndexSignature.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      fixId18 = "fixNoPropertyAccessFromIndexSignature";
	      errorCodes21 = [
	        Diagnostics.Property_0_comes_from_an_index_signature_so_it_must_be_accessed_with_0.code
	      ];
	      registerCodeFix({
	        errorCodes: errorCodes21,
	        fixIds: [fixId18],
	        getCodeActions(context) {
	          const { sourceFile, span, preferences } = context;
	          const property = getPropertyAccessExpression(sourceFile, span.start);
	          const changes = ts_textChanges_exports.ChangeTracker.with(context, (t) => doChange14(t, context.sourceFile, property, preferences));
	          return [createCodeFixAction(fixId18, changes, [Diagnostics.Use_element_access_for_0, property.name.text], fixId18, Diagnostics.Use_element_access_for_all_undeclared_properties)];
	        },
	        getAllCodeActions: (context) => codeFixAll(context, errorCodes21, (changes, diag2) => doChange14(changes, diag2.file, getPropertyAccessExpression(diag2.file, diag2.start), context.preferences))
	      });
	    }
	  });

	  // src/services/codefixes/fixImplicitThis.ts
	  function doChange15(changes, sourceFile, pos, checker) {
	    const token = getTokenAtPosition(sourceFile, pos);
	    if (!isThis(token))
	      return void 0;
	    const fn = getThisContainer(
	      token,
	      /*includeArrowFunctions*/
	      false,
	      /*includeClassComputedPropertyName*/
	      false
	    );
	    if (!isFunctionDeclaration(fn) && !isFunctionExpression(fn))
	      return void 0;
	    if (!isSourceFile(getThisContainer(
	      fn,
	      /*includeArrowFunctions*/
	      false,
	      /*includeClassComputedPropertyName*/
	      false
	    ))) {
	      const fnKeyword = Debug.checkDefined(findChildOfKind(fn, 100 /* FunctionKeyword */, sourceFile));
	      const { name } = fn;
	      const body = Debug.checkDefined(fn.body);
	      if (isFunctionExpression(fn)) {
	        if (name && ts_FindAllReferences_exports.Core.isSymbolReferencedInFile(name, checker, sourceFile, body)) {
	          return void 0;
	        }
	        changes.delete(sourceFile, fnKeyword);
	        if (name) {
	          changes.delete(sourceFile, name);
	        }
	        changes.insertText(sourceFile, body.pos, " =>");
	        return [Diagnostics.Convert_function_expression_0_to_arrow_function, name ? name.text : ANONYMOUS];
	      } else {
	        changes.replaceNode(sourceFile, fnKeyword, factory.createToken(87 /* ConstKeyword */));
	        changes.insertText(sourceFile, name.end, " = ");
	        changes.insertText(sourceFile, body.pos, " =>");
	        return [Diagnostics.Convert_function_declaration_0_to_arrow_function, name.text];
	      }
	    }
	  }
	  var fixId19, errorCodes22;
	  var init_fixImplicitThis = __esm({
	    "src/services/codefixes/fixImplicitThis.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      fixId19 = "fixImplicitThis";
	      errorCodes22 = [Diagnostics.this_implicitly_has_type_any_because_it_does_not_have_a_type_annotation.code];
	      registerCodeFix({
	        errorCodes: errorCodes22,
	        getCodeActions: function getCodeActionsToFixImplicitThis(context) {
	          const { sourceFile, program, span } = context;
	          let diagnostic;
	          const changes = ts_textChanges_exports.ChangeTracker.with(context, (t) => {
	            diagnostic = doChange15(t, sourceFile, span.start, program.getTypeChecker());
	          });
	          return diagnostic ? [createCodeFixAction(fixId19, changes, diagnostic, fixId19, Diagnostics.Fix_all_implicit_this_errors)] : emptyArray;
	        },
	        fixIds: [fixId19],
	        getAllCodeActions: (context) => codeFixAll(context, errorCodes22, (changes, diag2) => {
	          doChange15(changes, diag2.file, diag2.start, context.program.getTypeChecker());
	        })
	      });
	    }
	  });

	  // src/services/codefixes/fixImportNonExportedMember.ts
	  function getInfo7(sourceFile, pos, program) {
	    var _a, _b;
	    const token = getTokenAtPosition(sourceFile, pos);
	    if (isIdentifier(token)) {
	      const importDeclaration = findAncestor(token, isImportDeclaration);
	      if (importDeclaration === void 0)
	        return void 0;
	      const moduleSpecifier = isStringLiteral(importDeclaration.moduleSpecifier) ? importDeclaration.moduleSpecifier : void 0;
	      if (moduleSpecifier === void 0)
	        return void 0;
	      const resolvedModule = (_a = program.getResolvedModuleFromModuleSpecifier(moduleSpecifier)) == null ? void 0 : _a.resolvedModule;
	      if (resolvedModule === void 0)
	        return void 0;
	      const moduleSourceFile = program.getSourceFile(resolvedModule.resolvedFileName);
	      if (moduleSourceFile === void 0 || isSourceFileFromLibrary(program, moduleSourceFile))
	        return void 0;
	      const moduleSymbol = moduleSourceFile.symbol;
	      const locals = (_b = tryCast(moduleSymbol.valueDeclaration, canHaveLocals)) == null ? void 0 : _b.locals;
	      if (locals === void 0)
	        return void 0;
	      const localSymbol = locals.get(token.escapedText);
	      if (localSymbol === void 0)
	        return void 0;
	      const node = getNodeOfSymbol(localSymbol);
	      if (node === void 0)
	        return void 0;
	      const exportName = { node: token, isTypeOnly: isTypeDeclaration(node) };
	      return { exportName, node, moduleSourceFile, moduleSpecifier: moduleSpecifier.text };
	    }
	    return void 0;
	  }
	  function doChange16(changes, program, { exportName, node, moduleSourceFile }) {
	    const exportDeclaration = tryGetExportDeclaration(moduleSourceFile, exportName.isTypeOnly);
	    if (exportDeclaration) {
	      updateExport(changes, program, moduleSourceFile, exportDeclaration, [exportName]);
	    } else if (canHaveExportModifier(node)) {
	      changes.insertExportModifier(moduleSourceFile, node);
	    } else {
	      createExport(changes, program, moduleSourceFile, [exportName]);
	    }
	  }
	  function doChanges(changes, program, sourceFile, moduleExports, node) {
	    if (length(moduleExports)) {
	      if (node) {
	        updateExport(changes, program, sourceFile, node, moduleExports);
	      } else {
	        createExport(changes, program, sourceFile, moduleExports);
	      }
	    }
	  }
	  function tryGetExportDeclaration(sourceFile, isTypeOnly) {
	    const predicate = (node) => isExportDeclaration(node) && (isTypeOnly && node.isTypeOnly || !node.isTypeOnly);
	    return findLast(sourceFile.statements, predicate);
	  }
	  function updateExport(changes, program, sourceFile, node, names) {
	    const namedExports = node.exportClause && isNamedExports(node.exportClause) ? node.exportClause.elements : factory.createNodeArray([]);
	    const allowTypeModifier = !node.isTypeOnly && !!(getIsolatedModules(program.getCompilerOptions()) || find(namedExports, (e) => e.isTypeOnly));
	    changes.replaceNode(
	      sourceFile,
	      node,
	      factory.updateExportDeclaration(
	        node,
	        node.modifiers,
	        node.isTypeOnly,
	        factory.createNamedExports(
	          factory.createNodeArray(
	            [...namedExports, ...createExportSpecifiers(names, allowTypeModifier)],
	            /*hasTrailingComma*/
	            namedExports.hasTrailingComma
	          )
	        ),
	        node.moduleSpecifier,
	        node.attributes
	      )
	    );
	  }
	  function createExport(changes, program, sourceFile, names) {
	    changes.insertNodeAtEndOfScope(sourceFile, sourceFile, factory.createExportDeclaration(
	      /*modifiers*/
	      void 0,
	      /*isTypeOnly*/
	      false,
	      factory.createNamedExports(createExportSpecifiers(
	        names,
	        /*allowTypeModifier*/
	        getIsolatedModules(program.getCompilerOptions())
	      )),
	      /*moduleSpecifier*/
	      void 0,
	      /*attributes*/
	      void 0
	    ));
	  }
	  function createExportSpecifiers(names, allowTypeModifier) {
	    return factory.createNodeArray(map(names, (n) => factory.createExportSpecifier(
	      allowTypeModifier && n.isTypeOnly,
	      /*propertyName*/
	      void 0,
	      n.node
	    )));
	  }
	  function getNodeOfSymbol(symbol) {
	    if (symbol.valueDeclaration === void 0) {
	      return firstOrUndefined(symbol.declarations);
	    }
	    const declaration = symbol.valueDeclaration;
	    const variableStatement = isVariableDeclaration(declaration) ? tryCast(declaration.parent.parent, isVariableStatement) : void 0;
	    return variableStatement && length(variableStatement.declarationList.declarations) === 1 ? variableStatement : declaration;
	  }
	  var fixId20, errorCodes23;
	  var init_fixImportNonExportedMember = __esm({
	    "src/services/codefixes/fixImportNonExportedMember.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      fixId20 = "fixImportNonExportedMember";
	      errorCodes23 = [
	        Diagnostics.Module_0_declares_1_locally_but_it_is_not_exported.code
	      ];
	      registerCodeFix({
	        errorCodes: errorCodes23,
	        fixIds: [fixId20],
	        getCodeActions(context) {
	          const { sourceFile, span, program } = context;
	          const info = getInfo7(sourceFile, span.start, program);
	          if (info === void 0)
	            return void 0;
	          const changes = ts_textChanges_exports.ChangeTracker.with(context, (t) => doChange16(t, program, info));
	          return [createCodeFixAction(fixId20, changes, [Diagnostics.Export_0_from_module_1, info.exportName.node.text, info.moduleSpecifier], fixId20, Diagnostics.Export_all_referenced_locals)];
	        },
	        getAllCodeActions(context) {
	          const { program } = context;
	          return createCombinedCodeActions(ts_textChanges_exports.ChangeTracker.with(context, (changes) => {
	            const exports = /* @__PURE__ */ new Map();
	            eachDiagnostic(context, errorCodes23, (diag2) => {
	              const info = getInfo7(diag2.file, diag2.start, program);
	              if (info === void 0)
	                return void 0;
	              const { exportName, node, moduleSourceFile } = info;
	              if (tryGetExportDeclaration(moduleSourceFile, exportName.isTypeOnly) === void 0 && canHaveExportModifier(node)) {
	                changes.insertExportModifier(moduleSourceFile, node);
	              } else {
	                const moduleExports = exports.get(moduleSourceFile) || { typeOnlyExports: [], exports: [] };
	                if (exportName.isTypeOnly) {
	                  moduleExports.typeOnlyExports.push(exportName);
	                } else {
	                  moduleExports.exports.push(exportName);
	                }
	                exports.set(moduleSourceFile, moduleExports);
	              }
	            });
	            exports.forEach((moduleExports, moduleSourceFile) => {
	              const exportDeclaration = tryGetExportDeclaration(
	                moduleSourceFile,
	                /*isTypeOnly*/
	                true
	              );
	              if (exportDeclaration && exportDeclaration.isTypeOnly) {
	                doChanges(changes, program, moduleSourceFile, moduleExports.typeOnlyExports, exportDeclaration);
	                doChanges(changes, program, moduleSourceFile, moduleExports.exports, tryGetExportDeclaration(
	                  moduleSourceFile,
	                  /*isTypeOnly*/
	                  false
	                ));
	              } else {
	                doChanges(changes, program, moduleSourceFile, [...moduleExports.exports, ...moduleExports.typeOnlyExports], exportDeclaration);
	              }
	            });
	          }));
	        }
	      });
	    }
	  });

	  // src/services/codefixes/fixIncorrectNamedTupleSyntax.ts
	  function getNamedTupleMember(sourceFile, pos) {
	    const token = getTokenAtPosition(sourceFile, pos);
	    return findAncestor(token, (t) => t.kind === 202 /* NamedTupleMember */);
	  }
	  function doChange17(changes, sourceFile, namedTupleMember) {
	    if (!namedTupleMember) {
	      return;
	    }
	    let unwrappedType = namedTupleMember.type;
	    let sawOptional = false;
	    let sawRest = false;
	    while (unwrappedType.kind === 190 /* OptionalType */ || unwrappedType.kind === 191 /* RestType */ || unwrappedType.kind === 196 /* ParenthesizedType */) {
	      if (unwrappedType.kind === 190 /* OptionalType */) {
	        sawOptional = true;
	      } else if (unwrappedType.kind === 191 /* RestType */) {
	        sawRest = true;
	      }
	      unwrappedType = unwrappedType.type;
	    }
	    const updated = factory.updateNamedTupleMember(
	      namedTupleMember,
	      namedTupleMember.dotDotDotToken || (sawRest ? factory.createToken(26 /* DotDotDotToken */) : void 0),
	      namedTupleMember.name,
	      namedTupleMember.questionToken || (sawOptional ? factory.createToken(58 /* QuestionToken */) : void 0),
	      unwrappedType
	    );
	    if (updated === namedTupleMember) {
	      return;
	    }
	    changes.replaceNode(sourceFile, namedTupleMember, updated);
	  }
	  var fixId21, errorCodes24;
	  var init_fixIncorrectNamedTupleSyntax = __esm({
	    "src/services/codefixes/fixIncorrectNamedTupleSyntax.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      fixId21 = "fixIncorrectNamedTupleSyntax";
	      errorCodes24 = [
	        Diagnostics.A_labeled_tuple_element_is_declared_as_optional_with_a_question_mark_after_the_name_and_before_the_colon_rather_than_after_the_type.code,
	        Diagnostics.A_labeled_tuple_element_is_declared_as_rest_with_a_before_the_name_rather_than_before_the_type.code
	      ];
	      registerCodeFix({
	        errorCodes: errorCodes24,
	        getCodeActions: function getCodeActionsToFixIncorrectNamedTupleSyntax(context) {
	          const { sourceFile, span } = context;
	          const namedTupleMember = getNamedTupleMember(sourceFile, span.start);
	          const changes = ts_textChanges_exports.ChangeTracker.with(context, (t) => doChange17(t, sourceFile, namedTupleMember));
	          return [createCodeFixAction(fixId21, changes, Diagnostics.Move_labeled_tuple_element_modifiers_to_labels, fixId21, Diagnostics.Move_labeled_tuple_element_modifiers_to_labels)];
	        },
	        fixIds: [fixId21]
	      });
	    }
	  });

	  // src/services/codefixes/fixSpelling.ts
	  function getInfo8(sourceFile, pos, context, errorCode) {
	    const node = getTokenAtPosition(sourceFile, pos);
	    const parent2 = node.parent;
	    if ((errorCode === Diagnostics.No_overload_matches_this_call.code || errorCode === Diagnostics.Type_0_is_not_assignable_to_type_1.code) && !isJsxAttribute(parent2))
	      return void 0;
	    const checker = context.program.getTypeChecker();
	    let suggestedSymbol;
	    if (isPropertyAccessExpression(parent2) && parent2.name === node) {
	      Debug.assert(isMemberName(node), "Expected an identifier for spelling (property access)");
	      let containingType = checker.getTypeAtLocation(parent2.expression);
	      if (parent2.flags & 64 /* OptionalChain */) {
	        containingType = checker.getNonNullableType(containingType);
	      }
	      suggestedSymbol = checker.getSuggestedSymbolForNonexistentProperty(node, containingType);
	    } else if (isBinaryExpression(parent2) && parent2.operatorToken.kind === 103 /* InKeyword */ && parent2.left === node && isPrivateIdentifier(node)) {
	      const receiverType = checker.getTypeAtLocation(parent2.right);
	      suggestedSymbol = checker.getSuggestedSymbolForNonexistentProperty(node, receiverType);
	    } else if (isQualifiedName(parent2) && parent2.right === node) {
	      const symbol = checker.getSymbolAtLocation(parent2.left);
	      if (symbol && symbol.flags & 1536 /* Module */) {
	        suggestedSymbol = checker.getSuggestedSymbolForNonexistentModule(parent2.right, symbol);
	      }
	    } else if (isImportSpecifier(parent2) && parent2.name === node) {
	      Debug.assertNode(node, isIdentifier, "Expected an identifier for spelling (import)");
	      const importDeclaration = findAncestor(node, isImportDeclaration);
	      const resolvedSourceFile = getResolvedSourceFileFromImportDeclaration(context, importDeclaration);
	      if (resolvedSourceFile && resolvedSourceFile.symbol) {
	        suggestedSymbol = checker.getSuggestedSymbolForNonexistentModule(node, resolvedSourceFile.symbol);
	      }
	    } else if (isJsxAttribute(parent2) && parent2.name === node) {
	      Debug.assertNode(node, isIdentifier, "Expected an identifier for JSX attribute");
	      const tag = findAncestor(node, isJsxOpeningLikeElement);
	      const props = checker.getContextualTypeForArgumentAtIndex(tag, 0);
	      suggestedSymbol = checker.getSuggestedSymbolForNonexistentJSXAttribute(node, props);
	    } else if (hasOverrideModifier(parent2) && isClassElement(parent2) && parent2.name === node) {
	      const baseDeclaration = findAncestor(node, isClassLike);
	      const baseTypeNode = baseDeclaration ? getEffectiveBaseTypeNode(baseDeclaration) : void 0;
	      const baseType = baseTypeNode ? checker.getTypeAtLocation(baseTypeNode) : void 0;
	      if (baseType) {
	        suggestedSymbol = checker.getSuggestedSymbolForNonexistentClassMember(getTextOfNode(node), baseType);
	      }
	    } else {
	      const meaning = getMeaningFromLocation(node);
	      const name = getTextOfNode(node);
	      Debug.assert(name !== void 0, "name should be defined");
	      suggestedSymbol = checker.getSuggestedSymbolForNonexistentSymbol(node, name, convertSemanticMeaningToSymbolFlags(meaning));
	    }
	    return suggestedSymbol === void 0 ? void 0 : { node, suggestedSymbol };
	  }
	  function doChange18(changes, sourceFile, node, suggestedSymbol, target) {
	    const suggestion = symbolName(suggestedSymbol);
	    if (!isIdentifierText(suggestion, target) && isPropertyAccessExpression(node.parent)) {
	      const valDecl = suggestedSymbol.valueDeclaration;
	      if (valDecl && isNamedDeclaration(valDecl) && isPrivateIdentifier(valDecl.name)) {
	        changes.replaceNode(sourceFile, node, factory.createIdentifier(suggestion));
	      } else {
	        changes.replaceNode(sourceFile, node.parent, factory.createElementAccessExpression(node.parent.expression, factory.createStringLiteral(suggestion)));
	      }
	    } else {
	      changes.replaceNode(sourceFile, node, factory.createIdentifier(suggestion));
	    }
	  }
	  function convertSemanticMeaningToSymbolFlags(meaning) {
	    let flags = 0;
	    if (meaning & 4 /* Namespace */) {
	      flags |= 1920 /* Namespace */;
	    }
	    if (meaning & 2 /* Type */) {
	      flags |= 788968 /* Type */;
	    }
	    if (meaning & 1 /* Value */) {
	      flags |= 111551 /* Value */;
	    }
	    return flags;
	  }
	  function getResolvedSourceFileFromImportDeclaration(context, importDeclaration) {
	    var _a;
	    if (!importDeclaration || !isStringLiteralLike(importDeclaration.moduleSpecifier))
	      return void 0;
	    const resolvedModule = (_a = context.program.getResolvedModuleFromModuleSpecifier(importDeclaration.moduleSpecifier)) == null ? void 0 : _a.resolvedModule;
	    if (!resolvedModule)
	      return void 0;
	    return context.program.getSourceFile(resolvedModule.resolvedFileName);
	  }
	  var fixId22, errorCodes25;
	  var init_fixSpelling = __esm({
	    "src/services/codefixes/fixSpelling.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      fixId22 = "fixSpelling";
	      errorCodes25 = [
	        Diagnostics.Property_0_does_not_exist_on_type_1_Did_you_mean_2.code,
	        Diagnostics.Property_0_may_not_exist_on_type_1_Did_you_mean_2.code,
	        Diagnostics.Cannot_find_name_0_Did_you_mean_1.code,
	        Diagnostics.Could_not_find_name_0_Did_you_mean_1.code,
	        Diagnostics.Cannot_find_namespace_0_Did_you_mean_1.code,
	        Diagnostics.Cannot_find_name_0_Did_you_mean_the_instance_member_this_0.code,
	        Diagnostics.Cannot_find_name_0_Did_you_mean_the_static_member_1_0.code,
	        Diagnostics._0_has_no_exported_member_named_1_Did_you_mean_2.code,
	        Diagnostics.This_member_cannot_have_an_override_modifier_because_it_is_not_declared_in_the_base_class_0_Did_you_mean_1.code,
	        Diagnostics.This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_it_is_not_declared_in_the_base_class_0_Did_you_mean_1.code,
	        // for JSX class components
	        Diagnostics.No_overload_matches_this_call.code,
	        // for JSX FC
	        Diagnostics.Type_0_is_not_assignable_to_type_1.code
	      ];
	      registerCodeFix({
	        errorCodes: errorCodes25,
	        getCodeActions(context) {
	          const { sourceFile, errorCode } = context;
	          const info = getInfo8(sourceFile, context.span.start, context, errorCode);
	          if (!info)
	            return void 0;
	          const { node, suggestedSymbol } = info;
	          const target = getEmitScriptTarget(context.host.getCompilationSettings());
	          const changes = ts_textChanges_exports.ChangeTracker.with(context, (t) => doChange18(t, sourceFile, node, suggestedSymbol, target));
	          return [createCodeFixAction("spelling", changes, [Diagnostics.Change_spelling_to_0, symbolName(suggestedSymbol)], fixId22, Diagnostics.Fix_all_detected_spelling_errors)];
	        },
	        fixIds: [fixId22],
	        getAllCodeActions: (context) => codeFixAll(context, errorCodes25, (changes, diag2) => {
	          const info = getInfo8(diag2.file, diag2.start, context, diag2.code);
	          const target = getEmitScriptTarget(context.host.getCompilationSettings());
	          if (info)
	            doChange18(changes, context.sourceFile, info.node, info.suggestedSymbol, target);
	        })
	      });
	    }
	  });

	  // src/services/codefixes/returnValueCorrect.ts
	  function createObjectTypeFromLabeledExpression(checker, label, expression) {
	    const member = checker.createSymbol(4 /* Property */, label.escapedText);
	    member.links.type = checker.getTypeAtLocation(expression);
	    const members = createSymbolTable([member]);
	    return checker.createAnonymousType(
	      /*symbol*/
	      void 0,
	      members,
	      [],
	      [],
	      []
	    );
	  }
	  function getFixInfo(checker, declaration, expectType, isFunctionType) {
	    if (!declaration.body || !isBlock(declaration.body) || length(declaration.body.statements) !== 1)
	      return void 0;
	    const firstStatement = first(declaration.body.statements);
	    if (isExpressionStatement(firstStatement) && checkFixedAssignableTo(checker, declaration, checker.getTypeAtLocation(firstStatement.expression), expectType, isFunctionType)) {
	      return {
	        declaration,
	        kind: 0 /* MissingReturnStatement */,
	        expression: firstStatement.expression,
	        statement: firstStatement,
	        commentSource: firstStatement.expression
	      };
	    } else if (isLabeledStatement(firstStatement) && isExpressionStatement(firstStatement.statement)) {
	      const node = factory.createObjectLiteralExpression([factory.createPropertyAssignment(firstStatement.label, firstStatement.statement.expression)]);
	      const nodeType = createObjectTypeFromLabeledExpression(checker, firstStatement.label, firstStatement.statement.expression);
	      if (checkFixedAssignableTo(checker, declaration, nodeType, expectType, isFunctionType)) {
	        return isArrowFunction(declaration) ? {
	          declaration,
	          kind: 1 /* MissingParentheses */,
	          expression: node,
	          statement: firstStatement,
	          commentSource: firstStatement.statement.expression
	        } : {
	          declaration,
	          kind: 0 /* MissingReturnStatement */,
	          expression: node,
	          statement: firstStatement,
	          commentSource: firstStatement.statement.expression
	        };
	      }
	    } else if (isBlock(firstStatement) && length(firstStatement.statements) === 1) {
	      const firstBlockStatement = first(firstStatement.statements);
	      if (isLabeledStatement(firstBlockStatement) && isExpressionStatement(firstBlockStatement.statement)) {
	        const node = factory.createObjectLiteralExpression([factory.createPropertyAssignment(firstBlockStatement.label, firstBlockStatement.statement.expression)]);
	        const nodeType = createObjectTypeFromLabeledExpression(checker, firstBlockStatement.label, firstBlockStatement.statement.expression);
	        if (checkFixedAssignableTo(checker, declaration, nodeType, expectType, isFunctionType)) {
	          return {
	            declaration,
	            kind: 0 /* MissingReturnStatement */,
	            expression: node,
	            statement: firstStatement,
	            commentSource: firstBlockStatement
	          };
	        }
	      }
	    }
	    return void 0;
	  }
	  function checkFixedAssignableTo(checker, declaration, exprType, type, isFunctionType) {
	    if (isFunctionType) {
	      const sig = checker.getSignatureFromDeclaration(declaration);
	      if (sig) {
	        if (hasSyntacticModifier(declaration, 1024 /* Async */)) {
	          exprType = checker.createPromiseType(exprType);
	        }
	        const newSig = checker.createSignature(
	          declaration,
	          sig.typeParameters,
	          sig.thisParameter,
	          sig.parameters,
	          exprType,
	          /*typePredicate*/
	          void 0,
	          sig.minArgumentCount,
	          sig.flags
	        );
	        exprType = checker.createAnonymousType(
	          /*symbol*/
	          void 0,
	          createSymbolTable(),
	          [newSig],
	          [],
	          []
	        );
	      } else {
	        exprType = checker.getAnyType();
	      }
	    }
	    return checker.isTypeAssignableTo(exprType, type);
	  }
	  function getInfo9(checker, sourceFile, position, errorCode) {
	    const node = getTokenAtPosition(sourceFile, position);
	    if (!node.parent)
	      return void 0;
	    const declaration = findAncestor(node.parent, isFunctionLikeDeclaration);
	    switch (errorCode) {
	      case Diagnostics.A_function_whose_declared_type_is_neither_undefined_void_nor_any_must_return_a_value.code:
	        if (!declaration || !declaration.body || !declaration.type || !rangeContainsRange(declaration.type, node))
	          return void 0;
	        return getFixInfo(
	          checker,
	          declaration,
	          checker.getTypeFromTypeNode(declaration.type),
	          /*isFunctionType*/
	          false
	        );
	      case Diagnostics.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1.code:
	        if (!declaration || !isCallExpression(declaration.parent) || !declaration.body)
	          return void 0;
	        const pos = declaration.parent.arguments.indexOf(declaration);
	        if (pos === -1)
	          return void 0;
	        const type = checker.getContextualTypeForArgumentAtIndex(declaration.parent, pos);
	        if (!type)
	          return void 0;
	        return getFixInfo(
	          checker,
	          declaration,
	          type,
	          /*isFunctionType*/
	          true
	        );
	      case Diagnostics.Type_0_is_not_assignable_to_type_1.code:
	        if (!isDeclarationName(node) || !isVariableLike(node.parent) && !isJsxAttribute(node.parent))
	          return void 0;
	        const initializer = getVariableLikeInitializer(node.parent);
	        if (!initializer || !isFunctionLikeDeclaration(initializer) || !initializer.body)
	          return void 0;
	        return getFixInfo(
	          checker,
	          initializer,
	          checker.getTypeAtLocation(node.parent),
	          /*isFunctionType*/
	          true
	        );
	    }
	    return void 0;
	  }
	  function getVariableLikeInitializer(declaration) {
	    switch (declaration.kind) {
	      case 260 /* VariableDeclaration */:
	      case 169 /* Parameter */:
	      case 208 /* BindingElement */:
	      case 172 /* PropertyDeclaration */:
	      case 303 /* PropertyAssignment */:
	        return declaration.initializer;
	      case 291 /* JsxAttribute */:
	        return declaration.initializer && (isJsxExpression(declaration.initializer) ? declaration.initializer.expression : void 0);
	      case 304 /* ShorthandPropertyAssignment */:
	      case 171 /* PropertySignature */:
	      case 306 /* EnumMember */:
	      case 355 /* JSDocPropertyTag */:
	      case 348 /* JSDocParameterTag */:
	        return void 0;
	    }
	  }
	  function addReturnStatement(changes, sourceFile, expression, statement) {
	    suppressLeadingAndTrailingTrivia(expression);
	    const probablyNeedSemi = probablyUsesSemicolons(sourceFile);
	    changes.replaceNode(sourceFile, statement, factory.createReturnStatement(expression), {
	      leadingTriviaOption: ts_textChanges_exports.LeadingTriviaOption.Exclude,
	      trailingTriviaOption: ts_textChanges_exports.TrailingTriviaOption.Exclude,
	      suffix: probablyNeedSemi ? ";" : void 0
	    });
	  }
	  function removeBlockBodyBrace(changes, sourceFile, declaration, expression, commentSource, withParen) {
	    const newBody = withParen || needsParentheses(expression) ? factory.createParenthesizedExpression(expression) : expression;
	    suppressLeadingAndTrailingTrivia(commentSource);
	    copyComments(commentSource, newBody);
	    changes.replaceNode(sourceFile, declaration.body, newBody);
	  }
	  function wrapBlockWithParen(changes, sourceFile, declaration, expression) {
	    changes.replaceNode(sourceFile, declaration.body, factory.createParenthesizedExpression(expression));
	  }
	  function getActionForfixAddReturnStatement(context, expression, statement) {
	    const changes = ts_textChanges_exports.ChangeTracker.with(context, (t) => addReturnStatement(t, context.sourceFile, expression, statement));
	    return createCodeFixAction(fixId23, changes, Diagnostics.Add_a_return_statement, fixIdAddReturnStatement, Diagnostics.Add_all_missing_return_statement);
	  }
	  function getActionForFixRemoveBracesFromArrowFunctionBody(context, declaration, expression, commentSource) {
	    const changes = ts_textChanges_exports.ChangeTracker.with(context, (t) => removeBlockBodyBrace(
	      t,
	      context.sourceFile,
	      declaration,
	      expression,
	      commentSource,
	      /*withParen*/
	      false
	    ));
	    return createCodeFixAction(fixId23, changes, Diagnostics.Remove_braces_from_arrow_function_body, fixRemoveBracesFromArrowFunctionBody, Diagnostics.Remove_braces_from_all_arrow_function_bodies_with_relevant_issues);
	  }
	  function getActionForfixWrapTheBlockWithParen(context, declaration, expression) {
	    const changes = ts_textChanges_exports.ChangeTracker.with(context, (t) => wrapBlockWithParen(t, context.sourceFile, declaration, expression));
	    return createCodeFixAction(fixId23, changes, Diagnostics.Wrap_the_following_body_with_parentheses_which_should_be_an_object_literal, fixIdWrapTheBlockWithParen, Diagnostics.Wrap_all_object_literal_with_parentheses);
	  }
	  var fixId23, fixIdAddReturnStatement, fixRemoveBracesFromArrowFunctionBody, fixIdWrapTheBlockWithParen, errorCodes26;
	  var init_returnValueCorrect = __esm({
	    "src/services/codefixes/returnValueCorrect.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      fixId23 = "returnValueCorrect";
	      fixIdAddReturnStatement = "fixAddReturnStatement";
	      fixRemoveBracesFromArrowFunctionBody = "fixRemoveBracesFromArrowFunctionBody";
	      fixIdWrapTheBlockWithParen = "fixWrapTheBlockWithParen";
	      errorCodes26 = [
	        Diagnostics.A_function_whose_declared_type_is_neither_undefined_void_nor_any_must_return_a_value.code,
	        Diagnostics.Type_0_is_not_assignable_to_type_1.code,
	        Diagnostics.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1.code
	      ];
	      registerCodeFix({
	        errorCodes: errorCodes26,
	        fixIds: [fixIdAddReturnStatement, fixRemoveBracesFromArrowFunctionBody, fixIdWrapTheBlockWithParen],
	        getCodeActions: function getCodeActionsToCorrectReturnValue(context) {
	          const { program, sourceFile, span: { start }, errorCode } = context;
	          const info = getInfo9(program.getTypeChecker(), sourceFile, start, errorCode);
	          if (!info)
	            return void 0;
	          if (info.kind === 0 /* MissingReturnStatement */) {
	            return append(
	              [getActionForfixAddReturnStatement(context, info.expression, info.statement)],
	              isArrowFunction(info.declaration) ? getActionForFixRemoveBracesFromArrowFunctionBody(context, info.declaration, info.expression, info.commentSource) : void 0
	            );
	          } else {
	            return [getActionForfixWrapTheBlockWithParen(context, info.declaration, info.expression)];
	          }
	        },
	        getAllCodeActions: (context) => codeFixAll(context, errorCodes26, (changes, diag2) => {
	          const info = getInfo9(context.program.getTypeChecker(), diag2.file, diag2.start, diag2.code);
	          if (!info)
	            return void 0;
	          switch (context.fixId) {
	            case fixIdAddReturnStatement:
	              addReturnStatement(changes, diag2.file, info.expression, info.statement);
	              break;
	            case fixRemoveBracesFromArrowFunctionBody:
	              if (!isArrowFunction(info.declaration))
	                return void 0;
	              removeBlockBodyBrace(
	                changes,
	                diag2.file,
	                info.declaration,
	                info.expression,
	                info.commentSource,
	                /*withParen*/
	                false
	              );
	              break;
	            case fixIdWrapTheBlockWithParen:
	              if (!isArrowFunction(info.declaration))
	                return void 0;
	              wrapBlockWithParen(changes, diag2.file, info.declaration, info.expression);
	              break;
	            default:
	              Debug.fail(JSON.stringify(context.fixId));
	          }
	        })
	      });
	    }
	  });

	  // src/services/codefixes/fixAddMissingMember.ts
	  function getInfo10(sourceFile, tokenPos, errorCode, checker, program) {
	    var _a;
	    const token = getTokenAtPosition(sourceFile, tokenPos);
	    const parent2 = token.parent;
	    if (errorCode === Diagnostics.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1.code) {
	      if (!(token.kind === 19 /* OpenBraceToken */ && isObjectLiteralExpression(parent2) && isCallExpression(parent2.parent)))
	        return void 0;
	      const argIndex = findIndex(parent2.parent.arguments, (arg) => arg === parent2);
	      if (argIndex < 0)
	        return void 0;
	      const signature = checker.getResolvedSignature(parent2.parent);
	      if (!(signature && signature.declaration && signature.parameters[argIndex]))
	        return void 0;
	      const param = signature.parameters[argIndex].valueDeclaration;
	      if (!(param && isParameter(param) && isIdentifier(param.name)))
	        return void 0;
	      const properties = arrayFrom(checker.getUnmatchedProperties(
	        checker.getTypeAtLocation(parent2),
	        checker.getParameterType(signature, argIndex),
	        /*requireOptionalProperties*/
	        false,
	        /*matchDiscriminantProperties*/
	        false
	      ));
	      if (!length(properties))
	        return void 0;
	      return { kind: 3 /* ObjectLiteral */, token: param.name, identifier: param.name.text, properties, parentDeclaration: parent2 };
	    }
	    if (token.kind === 19 /* OpenBraceToken */ && isObjectLiteralExpression(parent2)) {
	      const targetType = checker.getContextualType(parent2) || checker.getTypeAtLocation(parent2);
	      const properties = arrayFrom(checker.getUnmatchedProperties(
	        checker.getTypeAtLocation(parent2),
	        targetType,
	        /*requireOptionalProperties*/
	        false,
	        /*matchDiscriminantProperties*/
	        false
	      ));
	      if (!length(properties))
	        return void 0;
	      const identifier = "";
	      return { kind: 3 /* ObjectLiteral */, token: parent2, identifier, properties, parentDeclaration: parent2 };
	    }
	    if (!isMemberName(token))
	      return void 0;
	    if (isIdentifier(token) && hasInitializer(parent2) && parent2.initializer && isObjectLiteralExpression(parent2.initializer)) {
	      const targetType = checker.getContextualType(token) || checker.getTypeAtLocation(token);
	      const properties = arrayFrom(checker.getUnmatchedProperties(
	        checker.getTypeAtLocation(parent2.initializer),
	        targetType,
	        /*requireOptionalProperties*/
	        false,
	        /*matchDiscriminantProperties*/
	        false
	      ));
	      if (!length(properties))
	        return void 0;
	      return { kind: 3 /* ObjectLiteral */, token, identifier: token.text, properties, parentDeclaration: parent2.initializer };
	    }
	    if (isIdentifier(token) && isJsxOpeningLikeElement(token.parent)) {
	      const target = getEmitScriptTarget(program.getCompilerOptions());
	      const attributes = getUnmatchedAttributes(checker, target, token.parent);
	      if (!length(attributes))
	        return void 0;
	      return { kind: 4 /* JsxAttributes */, token, attributes, parentDeclaration: token.parent };
	    }
	    if (isIdentifier(token)) {
	      const type = (_a = checker.getContextualType(token)) == null ? void 0 : _a.getNonNullableType();
	      if (type && getObjectFlags(type) & 16 /* Anonymous */) {
	        const signature = firstOrUndefined(checker.getSignaturesOfType(type, 0 /* Call */));
	        if (signature === void 0)
	          return void 0;
	        return { kind: 5 /* Signature */, token, signature, sourceFile, parentDeclaration: findScope(token) };
	      }
	      if (isCallExpression(parent2) && parent2.expression === token) {
	        return { kind: 2 /* Function */, token, call: parent2, sourceFile, modifierFlags: 0 /* None */, parentDeclaration: findScope(token) };
	      }
	    }
	    if (!isPropertyAccessExpression(parent2))
	      return void 0;
	    const leftExpressionType = skipConstraint(checker.getTypeAtLocation(parent2.expression));
	    const symbol = leftExpressionType.symbol;
	    if (!symbol || !symbol.declarations)
	      return void 0;
	    if (isIdentifier(token) && isCallExpression(parent2.parent)) {
	      const moduleDeclaration = find(symbol.declarations, isModuleDeclaration);
	      const moduleDeclarationSourceFile = moduleDeclaration == null ? void 0 : moduleDeclaration.getSourceFile();
	      if (moduleDeclaration && moduleDeclarationSourceFile && !isSourceFileFromLibrary(program, moduleDeclarationSourceFile)) {
	        return { kind: 2 /* Function */, token, call: parent2.parent, sourceFile, modifierFlags: 32 /* Export */, parentDeclaration: moduleDeclaration };
	      }
	      const moduleSourceFile = find(symbol.declarations, isSourceFile);
	      if (sourceFile.commonJsModuleIndicator)
	        return void 0;
	      if (moduleSourceFile && !isSourceFileFromLibrary(program, moduleSourceFile)) {
	        return { kind: 2 /* Function */, token, call: parent2.parent, sourceFile: moduleSourceFile, modifierFlags: 32 /* Export */, parentDeclaration: moduleSourceFile };
	      }
	    }
	    const classDeclaration = find(symbol.declarations, isClassLike);
	    if (!classDeclaration && isPrivateIdentifier(token))
	      return void 0;
	    const declaration = classDeclaration || find(symbol.declarations, (d) => isInterfaceDeclaration(d) || isTypeLiteralNode(d));
	    if (declaration && !isSourceFileFromLibrary(program, declaration.getSourceFile())) {
	      const makeStatic = !isTypeLiteralNode(declaration) && (leftExpressionType.target || leftExpressionType) !== checker.getDeclaredTypeOfSymbol(symbol);
	      if (makeStatic && (isPrivateIdentifier(token) || isInterfaceDeclaration(declaration)))
	        return void 0;
	      const declSourceFile = declaration.getSourceFile();
	      const modifierFlags = isTypeLiteralNode(declaration) ? 0 /* None */ : (makeStatic ? 256 /* Static */ : 0 /* None */) | (startsWithUnderscore(token.text) ? 2 /* Private */ : 0 /* None */);
	      const isJSFile = isSourceFileJS(declSourceFile);
	      const call = tryCast(parent2.parent, isCallExpression);
	      return { kind: 0 /* TypeLikeDeclaration */, token, call, modifierFlags, parentDeclaration: declaration, declSourceFile, isJSFile };
	    }
	    const enumDeclaration = find(symbol.declarations, isEnumDeclaration);
	    if (enumDeclaration && !(leftExpressionType.flags & 1056 /* EnumLike */) && !isPrivateIdentifier(token) && !isSourceFileFromLibrary(program, enumDeclaration.getSourceFile())) {
	      return { kind: 1 /* Enum */, token, parentDeclaration: enumDeclaration };
	    }
	    return void 0;
	  }
	  function getActionsForMissingMemberDeclaration(context, info) {
	    return info.isJSFile ? singleElementArray(createActionForAddMissingMemberInJavascriptFile(context, info)) : createActionsForAddMissingMemberInTypeScriptFile(context, info);
	  }
	  function createActionForAddMissingMemberInJavascriptFile(context, { parentDeclaration, declSourceFile, modifierFlags, token }) {
	    if (isInterfaceDeclaration(parentDeclaration) || isTypeLiteralNode(parentDeclaration)) {
	      return void 0;
	    }
	    const changes = ts_textChanges_exports.ChangeTracker.with(context, (t) => addMissingMemberInJs(t, declSourceFile, parentDeclaration, token, !!(modifierFlags & 256 /* Static */)));
	    if (changes.length === 0) {
	      return void 0;
	    }
	    const diagnostic = modifierFlags & 256 /* Static */ ? Diagnostics.Initialize_static_property_0 : isPrivateIdentifier(token) ? Diagnostics.Declare_a_private_field_named_0 : Diagnostics.Initialize_property_0_in_the_constructor;
	    return createCodeFixAction(fixMissingMember, changes, [diagnostic, token.text], fixMissingMember, Diagnostics.Add_all_missing_members);
	  }
	  function addMissingMemberInJs(changeTracker, sourceFile, classDeclaration, token, makeStatic) {
	    const tokenName = token.text;
	    if (makeStatic) {
	      if (classDeclaration.kind === 231 /* ClassExpression */) {
	        return;
	      }
	      const className = classDeclaration.name.getText();
	      const staticInitialization = initializePropertyToUndefined(factory.createIdentifier(className), tokenName);
	      changeTracker.insertNodeAfter(sourceFile, classDeclaration, staticInitialization);
	    } else if (isPrivateIdentifier(token)) {
	      const property = factory.createPropertyDeclaration(
	        /*modifiers*/
	        void 0,
	        tokenName,
	        /*questionOrExclamationToken*/
	        void 0,
	        /*type*/
	        void 0,
	        /*initializer*/
	        void 0
	      );
	      const lastProp = getNodeToInsertPropertyAfter(classDeclaration);
	      if (lastProp) {
	        changeTracker.insertNodeAfter(sourceFile, lastProp, property);
	      } else {
	        changeTracker.insertMemberAtStart(sourceFile, classDeclaration, property);
	      }
	    } else {
	      const classConstructor = getFirstConstructorWithBody(classDeclaration);
	      if (!classConstructor) {
	        return;
	      }
	      const propertyInitialization = initializePropertyToUndefined(factory.createThis(), tokenName);
	      changeTracker.insertNodeAtConstructorEnd(sourceFile, classConstructor, propertyInitialization);
	    }
	  }
	  function initializePropertyToUndefined(obj, propertyName) {
	    return factory.createExpressionStatement(factory.createAssignment(factory.createPropertyAccessExpression(obj, propertyName), createUndefined()));
	  }
	  function createActionsForAddMissingMemberInTypeScriptFile(context, { parentDeclaration, declSourceFile, modifierFlags, token }) {
	    const memberName = token.text;
	    const isStatic2 = modifierFlags & 256 /* Static */;
	    const typeNode = getTypeNode2(context.program.getTypeChecker(), parentDeclaration, token);
	    const addPropertyDeclarationChanges = (modifierFlags2) => ts_textChanges_exports.ChangeTracker.with(context, (t) => addPropertyDeclaration(t, declSourceFile, parentDeclaration, memberName, typeNode, modifierFlags2));
	    const actions2 = [createCodeFixAction(fixMissingMember, addPropertyDeclarationChanges(modifierFlags & 256 /* Static */), [isStatic2 ? Diagnostics.Declare_static_property_0 : Diagnostics.Declare_property_0, memberName], fixMissingMember, Diagnostics.Add_all_missing_members)];
	    if (isStatic2 || isPrivateIdentifier(token)) {
	      return actions2;
	    }
	    if (modifierFlags & 2 /* Private */) {
	      actions2.unshift(createCodeFixActionWithoutFixAll(fixMissingMember, addPropertyDeclarationChanges(2 /* Private */), [Diagnostics.Declare_private_property_0, memberName]));
	    }
	    actions2.push(createAddIndexSignatureAction(context, declSourceFile, parentDeclaration, token.text, typeNode));
	    return actions2;
	  }
	  function getTypeNode2(checker, node, token) {
	    let typeNode;
	    if (token.parent.parent.kind === 226 /* BinaryExpression */) {
	      const binaryExpression = token.parent.parent;
	      const otherExpression = token.parent === binaryExpression.left ? binaryExpression.right : binaryExpression.left;
	      const widenedType = checker.getWidenedType(checker.getBaseTypeOfLiteralType(checker.getTypeAtLocation(otherExpression)));
	      typeNode = checker.typeToTypeNode(widenedType, node, 1 /* NoTruncation */);
	    } else {
	      const contextualType = checker.getContextualType(token.parent);
	      typeNode = contextualType ? checker.typeToTypeNode(
	        contextualType,
	        /*enclosingDeclaration*/
	        void 0,
	        1 /* NoTruncation */
	      ) : void 0;
	    }
	    return typeNode || factory.createKeywordTypeNode(133 /* AnyKeyword */);
	  }
	  function addPropertyDeclaration(changeTracker, sourceFile, node, tokenName, typeNode, modifierFlags) {
	    const modifiers = modifierFlags ? factory.createNodeArray(factory.createModifiersFromModifierFlags(modifierFlags)) : void 0;
	    const property = isClassLike(node) ? factory.createPropertyDeclaration(
	      modifiers,
	      tokenName,
	      /*questionOrExclamationToken*/
	      void 0,
	      typeNode,
	      /*initializer*/
	      void 0
	    ) : factory.createPropertySignature(
	      /*modifiers*/
	      void 0,
	      tokenName,
	      /*questionToken*/
	      void 0,
	      typeNode
	    );
	    const lastProp = getNodeToInsertPropertyAfter(node);
	    if (lastProp) {
	      changeTracker.insertNodeAfter(sourceFile, lastProp, property);
	    } else {
	      changeTracker.insertMemberAtStart(sourceFile, node, property);
	    }
	  }
	  function getNodeToInsertPropertyAfter(node) {
	    let res;
	    for (const member of node.members) {
	      if (!isPropertyDeclaration(member))
	        break;
	      res = member;
	    }
	    return res;
	  }
	  function createAddIndexSignatureAction(context, sourceFile, node, tokenName, typeNode) {
	    const stringTypeNode = factory.createKeywordTypeNode(154 /* StringKeyword */);
	    const indexingParameter = factory.createParameterDeclaration(
	      /*modifiers*/
	      void 0,
	      /*dotDotDotToken*/
	      void 0,
	      "x",
	      /*questionToken*/
	      void 0,
	      stringTypeNode,
	      /*initializer*/
	      void 0
	    );
	    const indexSignature = factory.createIndexSignature(
	      /*modifiers*/
	      void 0,
	      [indexingParameter],
	      typeNode
	    );
	    const changes = ts_textChanges_exports.ChangeTracker.with(context, (t) => t.insertMemberAtStart(sourceFile, node, indexSignature));
	    return createCodeFixActionWithoutFixAll(fixMissingMember, changes, [Diagnostics.Add_index_signature_for_property_0, tokenName]);
	  }
	  function getActionsForMissingMethodDeclaration(context, info) {
	    const { parentDeclaration, declSourceFile, modifierFlags, token, call } = info;
	    if (call === void 0) {
	      return void 0;
	    }
	    const methodName = token.text;
	    const addMethodDeclarationChanges = (modifierFlags2) => ts_textChanges_exports.ChangeTracker.with(context, (t) => addMethodDeclaration(context, t, call, token, modifierFlags2, parentDeclaration, declSourceFile));
	    const actions2 = [createCodeFixAction(fixMissingMember, addMethodDeclarationChanges(modifierFlags & 256 /* Static */), [modifierFlags & 256 /* Static */ ? Diagnostics.Declare_static_method_0 : Diagnostics.Declare_method_0, methodName], fixMissingMember, Diagnostics.Add_all_missing_members)];
	    if (modifierFlags & 2 /* Private */) {
	      actions2.unshift(createCodeFixActionWithoutFixAll(fixMissingMember, addMethodDeclarationChanges(2 /* Private */), [Diagnostics.Declare_private_method_0, methodName]));
	    }
	    return actions2;
	  }
	  function addMethodDeclaration(context, changes, callExpression, name, modifierFlags, parentDeclaration, sourceFile) {
	    const importAdder = createImportAdder(sourceFile, context.program, context.preferences, context.host);
	    const kind = isClassLike(parentDeclaration) ? 174 /* MethodDeclaration */ : 173 /* MethodSignature */;
	    const signatureDeclaration = createSignatureDeclarationFromCallExpression(kind, context, importAdder, callExpression, name, modifierFlags, parentDeclaration);
	    const containingMethodDeclaration = tryGetContainingMethodDeclaration(parentDeclaration, callExpression);
	    if (containingMethodDeclaration) {
	      changes.insertNodeAfter(sourceFile, containingMethodDeclaration, signatureDeclaration);
	    } else {
	      changes.insertMemberAtStart(sourceFile, parentDeclaration, signatureDeclaration);
	    }
	    importAdder.writeFixes(changes);
	  }
	  function addEnumMemberDeclaration(changes, checker, { token, parentDeclaration }) {
	    const hasStringInitializer = some(parentDeclaration.members, (member) => {
	      const type = checker.getTypeAtLocation(member);
	      return !!(type && type.flags & 402653316 /* StringLike */);
	    });
	    const sourceFile = parentDeclaration.getSourceFile();
	    const enumMember = factory.createEnumMember(token, hasStringInitializer ? factory.createStringLiteral(token.text) : void 0);
	    const last2 = lastOrUndefined(parentDeclaration.members);
	    if (last2) {
	      changes.insertNodeInListAfter(sourceFile, last2, enumMember, parentDeclaration.members);
	    } else {
	      changes.insertMemberAtStart(sourceFile, parentDeclaration, enumMember);
	    }
	  }
	  function addFunctionDeclaration(changes, context, info) {
	    const quotePreference = getQuotePreference(context.sourceFile, context.preferences);
	    const importAdder = createImportAdder(context.sourceFile, context.program, context.preferences, context.host);
	    const functionDeclaration = info.kind === 2 /* Function */ ? createSignatureDeclarationFromCallExpression(262 /* FunctionDeclaration */, context, importAdder, info.call, idText(info.token), info.modifierFlags, info.parentDeclaration) : createSignatureDeclarationFromSignature(
	      262 /* FunctionDeclaration */,
	      context,
	      quotePreference,
	      info.signature,
	      createStubbedBody(Diagnostics.Function_not_implemented.message, quotePreference),
	      info.token,
	      /*modifiers*/
	      void 0,
	      /*optional*/
	      void 0,
	      /*enclosingDeclaration*/
	      void 0,
	      importAdder
	    );
	    if (functionDeclaration === void 0) {
	      Debug.fail("fixMissingFunctionDeclaration codefix got unexpected error.");
	    }
	    isReturnStatement(info.parentDeclaration) ? changes.insertNodeBefore(
	      info.sourceFile,
	      info.parentDeclaration,
	      functionDeclaration,
	      /*blankLineBetween*/
	      true
	    ) : changes.insertNodeAtEndOfScope(info.sourceFile, info.parentDeclaration, functionDeclaration);
	    importAdder.writeFixes(changes);
	  }
	  function addJsxAttributes(changes, context, info) {
	    const importAdder = createImportAdder(context.sourceFile, context.program, context.preferences, context.host);
	    const quotePreference = getQuotePreference(context.sourceFile, context.preferences);
	    const checker = context.program.getTypeChecker();
	    const jsxAttributesNode = info.parentDeclaration.attributes;
	    const hasSpreadAttribute = some(jsxAttributesNode.properties, isJsxSpreadAttribute);
	    const attrs = map(info.attributes, (attr) => {
	      const value = tryGetValueFromType(context, checker, importAdder, quotePreference, checker.getTypeOfSymbol(attr), info.parentDeclaration);
	      const name = factory.createIdentifier(attr.name);
	      const jsxAttribute = factory.createJsxAttribute(name, factory.createJsxExpression(
	        /*dotDotDotToken*/
	        void 0,
	        value
	      ));
	      setParent(name, jsxAttribute);
	      return jsxAttribute;
	    });
	    const jsxAttributes = factory.createJsxAttributes(hasSpreadAttribute ? [...attrs, ...jsxAttributesNode.properties] : [...jsxAttributesNode.properties, ...attrs]);
	    const options = { prefix: jsxAttributesNode.pos === jsxAttributesNode.end ? " " : void 0 };
	    changes.replaceNode(context.sourceFile, jsxAttributesNode, jsxAttributes, options);
	    importAdder.writeFixes(changes);
	  }
	  function addObjectLiteralProperties(changes, context, info) {
	    const importAdder = createImportAdder(context.sourceFile, context.program, context.preferences, context.host);
	    const quotePreference = getQuotePreference(context.sourceFile, context.preferences);
	    const target = getEmitScriptTarget(context.program.getCompilerOptions());
	    const checker = context.program.getTypeChecker();
	    const props = map(info.properties, (prop) => {
	      const initializer = tryGetValueFromType(context, checker, importAdder, quotePreference, checker.getTypeOfSymbol(prop), info.parentDeclaration);
	      return factory.createPropertyAssignment(createPropertyNameFromSymbol(prop, target, quotePreference, checker), initializer);
	    });
	    const options = {
	      leadingTriviaOption: ts_textChanges_exports.LeadingTriviaOption.Exclude,
	      trailingTriviaOption: ts_textChanges_exports.TrailingTriviaOption.Exclude,
	      indentation: info.indentation
	    };
	    changes.replaceNode(context.sourceFile, info.parentDeclaration, factory.createObjectLiteralExpression(
	      [...info.parentDeclaration.properties, ...props],
	      /*multiLine*/
	      true
	    ), options);
	    importAdder.writeFixes(changes);
	  }
	  function tryGetValueFromType(context, checker, importAdder, quotePreference, type, enclosingDeclaration) {
	    if (type.flags & 3 /* AnyOrUnknown */) {
	      return createUndefined();
	    }
	    if (type.flags & (4 /* String */ | 134217728 /* TemplateLiteral */)) {
	      return factory.createStringLiteral(
	        "",
	        /* isSingleQuote */
	        quotePreference === 0 /* Single */
	      );
	    }
	    if (type.flags & 8 /* Number */) {
	      return factory.createNumericLiteral(0);
	    }
	    if (type.flags & 64 /* BigInt */) {
	      return factory.createBigIntLiteral("0n");
	    }
	    if (type.flags & 16 /* Boolean */) {
	      return factory.createFalse();
	    }
	    if (type.flags & 1056 /* EnumLike */) {
	      const enumMember = type.symbol.exports ? firstOrUndefinedIterator(type.symbol.exports.values()) : type.symbol;
	      const name = checker.symbolToExpression(
	        type.symbol.parent ? type.symbol.parent : type.symbol,
	        111551 /* Value */,
	        /*enclosingDeclaration*/
	        void 0,
	        /*flags*/
	        64 /* UseFullyQualifiedType */
	      );
	      return enumMember === void 0 || name === void 0 ? factory.createNumericLiteral(0) : factory.createPropertyAccessExpression(name, checker.symbolToString(enumMember));
	    }
	    if (type.flags & 256 /* NumberLiteral */) {
	      return factory.createNumericLiteral(type.value);
	    }
	    if (type.flags & 2048 /* BigIntLiteral */) {
	      return factory.createBigIntLiteral(type.value);
	    }
	    if (type.flags & 128 /* StringLiteral */) {
	      return factory.createStringLiteral(
	        type.value,
	        /* isSingleQuote */
	        quotePreference === 0 /* Single */
	      );
	    }
	    if (type.flags & 512 /* BooleanLiteral */) {
	      return type === checker.getFalseType() || type === checker.getFalseType(
	        /*fresh*/
	        true
	      ) ? factory.createFalse() : factory.createTrue();
	    }
	    if (type.flags & 65536 /* Null */) {
	      return factory.createNull();
	    }
	    if (type.flags & 1048576 /* Union */) {
	      const expression = firstDefined(type.types, (t) => tryGetValueFromType(context, checker, importAdder, quotePreference, t, enclosingDeclaration));
	      return expression ?? createUndefined();
	    }
	    if (checker.isArrayLikeType(type)) {
	      return factory.createArrayLiteralExpression();
	    }
	    if (isObjectLiteralType(type)) {
	      const props = map(checker.getPropertiesOfType(type), (prop) => {
	        const initializer = tryGetValueFromType(context, checker, importAdder, quotePreference, checker.getTypeOfSymbol(prop), enclosingDeclaration);
	        return factory.createPropertyAssignment(prop.name, initializer);
	      });
	      return factory.createObjectLiteralExpression(
	        props,
	        /*multiLine*/
	        true
	      );
	    }
	    if (getObjectFlags(type) & 16 /* Anonymous */) {
	      const decl = find(type.symbol.declarations || emptyArray, or(isFunctionTypeNode, isMethodSignature, isMethodDeclaration));
	      if (decl === void 0)
	        return createUndefined();
	      const signature = checker.getSignaturesOfType(type, 0 /* Call */);
	      if (signature === void 0)
	        return createUndefined();
	      const func = createSignatureDeclarationFromSignature(
	        218 /* FunctionExpression */,
	        context,
	        quotePreference,
	        signature[0],
	        createStubbedBody(Diagnostics.Function_not_implemented.message, quotePreference),
	        /*name*/
	        void 0,
	        /*modifiers*/
	        void 0,
	        /*optional*/
	        void 0,
	        /*enclosingDeclaration*/
	        enclosingDeclaration,
	        importAdder
	      );
	      return func ?? createUndefined();
	    }
	    if (getObjectFlags(type) & 1 /* Class */) {
	      const classDeclaration = getClassLikeDeclarationOfSymbol(type.symbol);
	      if (classDeclaration === void 0 || hasAbstractModifier(classDeclaration))
	        return createUndefined();
	      const constructorDeclaration = getFirstConstructorWithBody(classDeclaration);
	      if (constructorDeclaration && length(constructorDeclaration.parameters))
	        return createUndefined();
	      return factory.createNewExpression(
	        factory.createIdentifier(type.symbol.name),
	        /*typeArguments*/
	        void 0,
	        /*argumentsArray*/
	        void 0
	      );
	    }
	    return createUndefined();
	  }
	  function createUndefined() {
	    return factory.createIdentifier("undefined");
	  }
	  function isObjectLiteralType(type) {
	    return type.flags & 524288 /* Object */ && (getObjectFlags(type) & 128 /* ObjectLiteral */ || type.symbol && tryCast(singleOrUndefined(type.symbol.declarations), isTypeLiteralNode));
	  }
	  function getUnmatchedAttributes(checker, target, source) {
	    const attrsType = checker.getContextualType(source.attributes);
	    if (attrsType === void 0)
	      return emptyArray;
	    const targetProps = attrsType.getProperties();
	    if (!length(targetProps))
	      return emptyArray;
	    const seenNames = /* @__PURE__ */ new Set();
	    for (const sourceProp of source.attributes.properties) {
	      if (isJsxAttribute(sourceProp)) {
	        seenNames.add(getEscapedTextOfJsxAttributeName(sourceProp.name));
	      }
	      if (isJsxSpreadAttribute(sourceProp)) {
	        const type = checker.getTypeAtLocation(sourceProp.expression);
	        for (const prop of type.getProperties()) {
	          seenNames.add(prop.escapedName);
	        }
	      }
	    }
	    return filter(targetProps, (targetProp) => isIdentifierText(targetProp.name, target, 1 /* JSX */) && !(targetProp.flags & 16777216 /* Optional */ || getCheckFlags(targetProp) & 48 /* Partial */ || seenNames.has(targetProp.escapedName)));
	  }
	  function tryGetContainingMethodDeclaration(node, callExpression) {
	    if (isTypeLiteralNode(node)) {
	      return void 0;
	    }
	    const declaration = findAncestor(callExpression, (n) => isMethodDeclaration(n) || isConstructorDeclaration(n));
	    return declaration && declaration.parent === node ? declaration : void 0;
	  }
	  function createPropertyNameFromSymbol(symbol, target, quotePreference, checker) {
	    if (isTransientSymbol(symbol)) {
	      const prop = checker.symbolToNode(
	        symbol,
	        111551 /* Value */,
	        /*enclosingDeclaration*/
	        void 0,
	        1073741824 /* WriteComputedProps */
	      );
	      if (prop && isComputedPropertyName(prop))
	        return prop;
	    }
	    return createPropertyNameNodeForIdentifierOrLiteral(
	      symbol.name,
	      target,
	      quotePreference === 0 /* Single */,
	      /*stringNamed*/
	      false,
	      /*isMethod*/
	      false
	    );
	  }
	  function findScope(node) {
	    if (findAncestor(node, isJsxExpression)) {
	      const returnStatement = findAncestor(node.parent, isReturnStatement);
	      if (returnStatement)
	        return returnStatement;
	    }
	    return getSourceFileOfNode(node);
	  }
	  var fixMissingMember, fixMissingProperties, fixMissingAttributes, fixMissingFunctionDeclaration, errorCodes27;
	  var init_fixAddMissingMember = __esm({
	    "src/services/codefixes/fixAddMissingMember.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      fixMissingMember = "fixMissingMember";
	      fixMissingProperties = "fixMissingProperties";
	      fixMissingAttributes = "fixMissingAttributes";
	      fixMissingFunctionDeclaration = "fixMissingFunctionDeclaration";
	      errorCodes27 = [
	        Diagnostics.Property_0_does_not_exist_on_type_1.code,
	        Diagnostics.Property_0_does_not_exist_on_type_1_Did_you_mean_2.code,
	        Diagnostics.Property_0_is_missing_in_type_1_but_required_in_type_2.code,
	        Diagnostics.Type_0_is_missing_the_following_properties_from_type_1_Colon_2.code,
	        Diagnostics.Type_0_is_missing_the_following_properties_from_type_1_Colon_2_and_3_more.code,
	        Diagnostics.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1.code,
	        Diagnostics.Cannot_find_name_0.code
	      ];
	      registerCodeFix({
	        errorCodes: errorCodes27,
	        getCodeActions(context) {
	          const typeChecker = context.program.getTypeChecker();
	          const info = getInfo10(context.sourceFile, context.span.start, context.errorCode, typeChecker, context.program);
	          if (!info) {
	            return void 0;
	          }
	          if (info.kind === 3 /* ObjectLiteral */) {
	            const changes = ts_textChanges_exports.ChangeTracker.with(context, (t) => addObjectLiteralProperties(t, context, info));
	            return [createCodeFixAction(fixMissingProperties, changes, Diagnostics.Add_missing_properties, fixMissingProperties, Diagnostics.Add_all_missing_properties)];
	          }
	          if (info.kind === 4 /* JsxAttributes */) {
	            const changes = ts_textChanges_exports.ChangeTracker.with(context, (t) => addJsxAttributes(t, context, info));
	            return [createCodeFixAction(fixMissingAttributes, changes, Diagnostics.Add_missing_attributes, fixMissingAttributes, Diagnostics.Add_all_missing_attributes)];
	          }
	          if (info.kind === 2 /* Function */ || info.kind === 5 /* Signature */) {
	            const changes = ts_textChanges_exports.ChangeTracker.with(context, (t) => addFunctionDeclaration(t, context, info));
	            return [createCodeFixAction(fixMissingFunctionDeclaration, changes, [Diagnostics.Add_missing_function_declaration_0, info.token.text], fixMissingFunctionDeclaration, Diagnostics.Add_all_missing_function_declarations)];
	          }
	          if (info.kind === 1 /* Enum */) {
	            const changes = ts_textChanges_exports.ChangeTracker.with(context, (t) => addEnumMemberDeclaration(t, context.program.getTypeChecker(), info));
	            return [createCodeFixAction(fixMissingMember, changes, [Diagnostics.Add_missing_enum_member_0, info.token.text], fixMissingMember, Diagnostics.Add_all_missing_members)];
	          }
	          return concatenate(getActionsForMissingMethodDeclaration(context, info), getActionsForMissingMemberDeclaration(context, info));
	        },
	        fixIds: [fixMissingMember, fixMissingFunctionDeclaration, fixMissingProperties, fixMissingAttributes],
	        getAllCodeActions: (context) => {
	          const { program, fixId: fixId52 } = context;
	          const checker = program.getTypeChecker();
	          const seen = /* @__PURE__ */ new Map();
	          const typeDeclToMembers = /* @__PURE__ */ new Map();
	          return createCombinedCodeActions(ts_textChanges_exports.ChangeTracker.with(context, (changes) => {
	            eachDiagnostic(context, errorCodes27, (diag2) => {
	              const info = getInfo10(diag2.file, diag2.start, diag2.code, checker, context.program);
	              if (!info || !addToSeen(seen, getNodeId(info.parentDeclaration) + "#" + (info.kind === 3 /* ObjectLiteral */ ? info.identifier : info.token.text))) {
	                return;
	              }
	              if (fixId52 === fixMissingFunctionDeclaration && (info.kind === 2 /* Function */ || info.kind === 5 /* Signature */)) {
	                addFunctionDeclaration(changes, context, info);
	              } else if (fixId52 === fixMissingProperties && info.kind === 3 /* ObjectLiteral */) {
	                addObjectLiteralProperties(changes, context, info);
	              } else if (fixId52 === fixMissingAttributes && info.kind === 4 /* JsxAttributes */) {
	                addJsxAttributes(changes, context, info);
	              } else {
	                if (info.kind === 1 /* Enum */) {
	                  addEnumMemberDeclaration(changes, checker, info);
	                }
	                if (info.kind === 0 /* TypeLikeDeclaration */) {
	                  const { parentDeclaration, token } = info;
	                  const infos = getOrUpdate(typeDeclToMembers, parentDeclaration, () => []);
	                  if (!infos.some((i) => i.token.text === token.text)) {
	                    infos.push(info);
	                  }
	                }
	              }
	            });
	            typeDeclToMembers.forEach((infos, declaration) => {
	              const supers = isTypeLiteralNode(declaration) ? void 0 : getAllSupers(declaration, checker);
	              for (const info of infos) {
	                if (supers == null ? void 0 : supers.some((superClassOrInterface) => {
	                  const superInfos = typeDeclToMembers.get(superClassOrInterface);
	                  return !!superInfos && superInfos.some(({ token: token2 }) => token2.text === info.token.text);
	                }))
	                  continue;
	                const { parentDeclaration, declSourceFile, modifierFlags, token, call, isJSFile } = info;
	                if (call && !isPrivateIdentifier(token)) {
	                  addMethodDeclaration(context, changes, call, token, modifierFlags & 256 /* Static */, parentDeclaration, declSourceFile);
	                } else {
	                  if (isJSFile && !isInterfaceDeclaration(parentDeclaration) && !isTypeLiteralNode(parentDeclaration)) {
	                    addMissingMemberInJs(changes, declSourceFile, parentDeclaration, token, !!(modifierFlags & 256 /* Static */));
	                  } else {
	                    const typeNode = getTypeNode2(checker, parentDeclaration, token);
	                    addPropertyDeclaration(changes, declSourceFile, parentDeclaration, token.text, typeNode, modifierFlags & 256 /* Static */);
	                  }
	                }
	              }
	            });
	          }));
	        }
	      });
	    }
	  });

	  // src/services/codefixes/fixAddMissingNewOperator.ts
	  function addMissingNewOperator(changes, sourceFile, span) {
	    const call = cast(findAncestorMatchingSpan2(sourceFile, span), isCallExpression);
	    const newExpression = factory.createNewExpression(call.expression, call.typeArguments, call.arguments);
	    changes.replaceNode(sourceFile, call, newExpression);
	  }
	  function findAncestorMatchingSpan2(sourceFile, span) {
	    let token = getTokenAtPosition(sourceFile, span.start);
	    const end = textSpanEnd(span);
	    while (token.end < end) {
	      token = token.parent;
	    }
	    return token;
	  }
	  var fixId24, errorCodes28;
	  var init_fixAddMissingNewOperator = __esm({
	    "src/services/codefixes/fixAddMissingNewOperator.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      fixId24 = "addMissingNewOperator";
	      errorCodes28 = [Diagnostics.Value_of_type_0_is_not_callable_Did_you_mean_to_include_new.code];
	      registerCodeFix({
	        errorCodes: errorCodes28,
	        getCodeActions(context) {
	          const { sourceFile, span } = context;
	          const changes = ts_textChanges_exports.ChangeTracker.with(context, (t) => addMissingNewOperator(t, sourceFile, span));
	          return [createCodeFixAction(fixId24, changes, Diagnostics.Add_missing_new_operator_to_call, fixId24, Diagnostics.Add_missing_new_operator_to_all_calls)];
	        },
	        fixIds: [fixId24],
	        getAllCodeActions: (context) => codeFixAll(context, errorCodes28, (changes, diag2) => addMissingNewOperator(changes, context.sourceFile, diag2))
	      });
	    }
	  });

	  // src/services/codefixes/fixAddMissingParam.ts
	  function getInfo11(sourceFile, program, pos) {
	    const token = getTokenAtPosition(sourceFile, pos);
	    const callExpression = findAncestor(token, isCallExpression);
	    if (callExpression === void 0 || length(callExpression.arguments) === 0) {
	      return void 0;
	    }
	    const checker = program.getTypeChecker();
	    const type = checker.getTypeAtLocation(callExpression.expression);
	    const convertibleSignatureDeclarations = filter(type.symbol.declarations, isConvertibleSignatureDeclaration);
	    if (convertibleSignatureDeclarations === void 0) {
	      return void 0;
	    }
	    const nonOverloadDeclaration = lastOrUndefined(convertibleSignatureDeclarations);
	    if (nonOverloadDeclaration === void 0 || nonOverloadDeclaration.body === void 0 || isSourceFileFromLibrary(program, nonOverloadDeclaration.getSourceFile())) {
	      return void 0;
	    }
	    const name = tryGetName2(nonOverloadDeclaration);
	    if (name === void 0) {
	      return void 0;
	    }
	    const newParameters = [];
	    const newOptionalParameters = [];
	    const parametersLength = length(nonOverloadDeclaration.parameters);
	    const argumentsLength = length(callExpression.arguments);
	    if (parametersLength > argumentsLength) {
	      return void 0;
	    }
	    const declarations = [nonOverloadDeclaration, ...getOverloads(nonOverloadDeclaration, convertibleSignatureDeclarations)];
	    for (let i = 0, pos2 = 0, paramIndex = 0; i < argumentsLength; i++) {
	      const arg = callExpression.arguments[i];
	      const expr = isAccessExpression(arg) ? getNameOfAccessExpression(arg) : arg;
	      const type2 = checker.getWidenedType(checker.getBaseTypeOfLiteralType(checker.getTypeAtLocation(arg)));
	      const parameter = pos2 < parametersLength ? nonOverloadDeclaration.parameters[pos2] : void 0;
	      if (parameter && checker.isTypeAssignableTo(type2, checker.getTypeAtLocation(parameter))) {
	        pos2++;
	        continue;
	      }
	      const name2 = expr && isIdentifier(expr) ? expr.text : `p${paramIndex++}`;
	      const typeNode = typeToTypeNode(checker, type2, nonOverloadDeclaration);
	      append(newParameters, {
	        pos: i,
	        declaration: createParameter(
	          name2,
	          typeNode,
	          /*questionToken*/
	          void 0
	        )
	      });
	      if (isOptionalPos(declarations, pos2)) {
	        continue;
	      }
	      append(newOptionalParameters, {
	        pos: i,
	        declaration: createParameter(name2, typeNode, factory.createToken(58 /* QuestionToken */))
	      });
	    }
	    return {
	      newParameters,
	      newOptionalParameters,
	      name: declarationNameToString(name),
	      declarations
	    };
	  }
	  function tryGetName2(node) {
	    const name = getNameOfDeclaration(node);
	    if (name) {
	      return name;
	    }
	    if (isVariableDeclaration(node.parent) && isIdentifier(node.parent.name) || isPropertyDeclaration(node.parent) || isParameter(node.parent)) {
	      return node.parent.name;
	    }
	  }
	  function typeToTypeNode(checker, type, enclosingDeclaration) {
	    return checker.typeToTypeNode(checker.getWidenedType(type), enclosingDeclaration, 1 /* NoTruncation */) ?? factory.createKeywordTypeNode(159 /* UnknownKeyword */);
	  }
	  function doChange19(changes, sourceFile, declarations, newParameters) {
	    forEach(declarations, (declaration) => {
	      if (length(declaration.parameters)) {
	        changes.replaceNodeRangeWithNodes(
	          sourceFile,
	          first(declaration.parameters),
	          last(declaration.parameters),
	          updateParameters(declaration, newParameters),
	          {
	            joiner: ", ",
	            indentation: 0,
	            leadingTriviaOption: ts_textChanges_exports.LeadingTriviaOption.IncludeAll,
	            trailingTriviaOption: ts_textChanges_exports.TrailingTriviaOption.Include
	          }
	        );
	      } else {
	        forEach(updateParameters(declaration, newParameters), (parameter, index) => {
	          if (length(declaration.parameters) === 0 && index === 0) {
	            changes.insertNodeAt(sourceFile, declaration.parameters.end, parameter);
	          } else {
	            changes.insertNodeAtEndOfList(sourceFile, declaration.parameters, parameter);
	          }
	        });
	      }
	    });
	  }
	  function isConvertibleSignatureDeclaration(node) {
	    switch (node.kind) {
	      case 262 /* FunctionDeclaration */:
	      case 218 /* FunctionExpression */:
	      case 174 /* MethodDeclaration */:
	      case 219 /* ArrowFunction */:
	        return true;
	      default:
	        return false;
	    }
	  }
	  function updateParameters(node, newParameters) {
	    const parameters = map(node.parameters, (p) => factory.createParameterDeclaration(
	      p.modifiers,
	      p.dotDotDotToken,
	      p.name,
	      p.questionToken,
	      p.type,
	      p.initializer
	    ));
	    for (const { pos, declaration } of newParameters) {
	      const prev = pos > 0 ? parameters[pos - 1] : void 0;
	      parameters.splice(
	        pos,
	        0,
	        factory.updateParameterDeclaration(
	          declaration,
	          declaration.modifiers,
	          declaration.dotDotDotToken,
	          declaration.name,
	          prev && prev.questionToken ? factory.createToken(58 /* QuestionToken */) : declaration.questionToken,
	          declaration.type,
	          declaration.initializer
	        )
	      );
	    }
	    return parameters;
	  }
	  function getOverloads(implementation, declarations) {
	    const overloads = [];
	    for (const declaration of declarations) {
	      if (isOverload(declaration)) {
	        if (length(declaration.parameters) === length(implementation.parameters)) {
	          overloads.push(declaration);
	          continue;
	        }
	        if (length(declaration.parameters) > length(implementation.parameters)) {
	          return [];
	        }
	      }
	    }
	    return overloads;
	  }
	  function isOverload(declaration) {
	    return isConvertibleSignatureDeclaration(declaration) && declaration.body === void 0;
	  }
	  function createParameter(name, type, questionToken) {
	    return factory.createParameterDeclaration(
	      /*modifiers*/
	      void 0,
	      /*dotDotDotToken*/
	      void 0,
	      name,
	      questionToken,
	      type,
	      /*initializer*/
	      void 0
	    );
	  }
	  function isOptionalPos(declarations, pos) {
	    return length(declarations) && some(declarations, (d) => pos < length(d.parameters) && !!d.parameters[pos] && d.parameters[pos].questionToken === void 0);
	  }
	  var addMissingParamFixId, addOptionalParamFixId, errorCodes29;
	  var init_fixAddMissingParam = __esm({
	    "src/services/codefixes/fixAddMissingParam.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      addMissingParamFixId = "addMissingParam";
	      addOptionalParamFixId = "addOptionalParam";
	      errorCodes29 = [Diagnostics.Expected_0_arguments_but_got_1.code];
	      registerCodeFix({
	        errorCodes: errorCodes29,
	        fixIds: [addMissingParamFixId, addOptionalParamFixId],
	        getCodeActions(context) {
	          const info = getInfo11(context.sourceFile, context.program, context.span.start);
	          if (info === void 0)
	            return void 0;
	          const { name, declarations, newParameters, newOptionalParameters } = info;
	          const actions2 = [];
	          if (length(newParameters)) {
	            append(
	              actions2,
	              createCodeFixAction(
	                addMissingParamFixId,
	                ts_textChanges_exports.ChangeTracker.with(context, (t) => doChange19(t, context.sourceFile, declarations, newParameters)),
	                [length(newParameters) > 1 ? Diagnostics.Add_missing_parameters_to_0 : Diagnostics.Add_missing_parameter_to_0, name],
	                addMissingParamFixId,
	                Diagnostics.Add_all_missing_parameters
	              )
	            );
	          }
	          if (length(newOptionalParameters)) {
	            append(
	              actions2,
	              createCodeFixAction(
	                addOptionalParamFixId,
	                ts_textChanges_exports.ChangeTracker.with(context, (t) => doChange19(t, context.sourceFile, declarations, newOptionalParameters)),
	                [length(newOptionalParameters) > 1 ? Diagnostics.Add_optional_parameters_to_0 : Diagnostics.Add_optional_parameter_to_0, name],
	                addOptionalParamFixId,
	                Diagnostics.Add_all_optional_parameters
	              )
	            );
	          }
	          return actions2;
	        },
	        getAllCodeActions: (context) => codeFixAll(context, errorCodes29, (changes, diag2) => {
	          const info = getInfo11(context.sourceFile, context.program, diag2.start);
	          if (info) {
	            const { declarations, newParameters, newOptionalParameters } = info;
	            if (context.fixId === addMissingParamFixId) {
	              doChange19(changes, context.sourceFile, declarations, newParameters);
	            }
	            if (context.fixId === addOptionalParamFixId) {
	              doChange19(changes, context.sourceFile, declarations, newOptionalParameters);
	            }
	          }
	        })
	      });
	    }
	  });

	  // src/services/codefixes/fixCannotFindModule.ts
	  function getInstallCommand(fileName, packageName) {
	    return { type: "install package", file: fileName, packageName };
	  }
	  function tryGetImportedPackageName(sourceFile, pos) {
	    const moduleSpecifierText = tryCast(getTokenAtPosition(sourceFile, pos), isStringLiteral);
	    if (!moduleSpecifierText)
	      return void 0;
	    const moduleName = moduleSpecifierText.text;
	    const { packageName } = parsePackageName(moduleName);
	    return isExternalModuleNameRelative(packageName) ? void 0 : packageName;
	  }
	  function getTypesPackageNameToInstall(packageName, host, diagCode) {
	    var _a;
	    return diagCode === errorCodeCannotFindModule ? ts_JsTyping_exports.nodeCoreModules.has(packageName) ? "@types/node" : void 0 : ((_a = host.isKnownTypesPackageName) == null ? void 0 : _a.call(host, packageName)) ? getTypesPackageName(packageName) : void 0;
	  }
	  var fixName2, fixIdInstallTypesPackage, errorCodeCannotFindModule, errorCodes30;
	  var init_fixCannotFindModule = __esm({
	    "src/services/codefixes/fixCannotFindModule.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      fixName2 = "fixCannotFindModule";
	      fixIdInstallTypesPackage = "installTypesPackage";
	      errorCodeCannotFindModule = Diagnostics.Cannot_find_module_0_or_its_corresponding_type_declarations.code;
	      errorCodes30 = [
	        errorCodeCannotFindModule,
	        Diagnostics.Could_not_find_a_declaration_file_for_module_0_1_implicitly_has_an_any_type.code
	      ];
	      registerCodeFix({
	        errorCodes: errorCodes30,
	        getCodeActions: function getCodeActionsToFixNotFoundModule(context) {
	          const { host, sourceFile, span: { start } } = context;
	          const packageName = tryGetImportedPackageName(sourceFile, start);
	          if (packageName === void 0)
	            return void 0;
	          const typesPackageName = getTypesPackageNameToInstall(packageName, host, context.errorCode);
	          return typesPackageName === void 0 ? [] : [createCodeFixAction(
	            fixName2,
	            /*changes*/
	            [],
	            [Diagnostics.Install_0, typesPackageName],
	            fixIdInstallTypesPackage,
	            Diagnostics.Install_all_missing_types_packages,
	            getInstallCommand(sourceFile.fileName, typesPackageName)
	          )];
	        },
	        fixIds: [fixIdInstallTypesPackage],
	        getAllCodeActions: (context) => {
	          return codeFixAll(context, errorCodes30, (_changes, diag2, commands) => {
	            const packageName = tryGetImportedPackageName(diag2.file, diag2.start);
	            if (packageName === void 0)
	              return void 0;
	            switch (context.fixId) {
	              case fixIdInstallTypesPackage: {
	                const pkg = getTypesPackageNameToInstall(packageName, context.host, diag2.code);
	                if (pkg) {
	                  commands.push(getInstallCommand(diag2.file.fileName, pkg));
	                }
	                break;
	              }
	              default:
	                Debug.fail(`Bad fixId: ${context.fixId}`);
	            }
	          });
	        }
	      });
	    }
	  });

	  // src/services/codefixes/fixClassDoesntImplementInheritedAbstractMember.ts
	  function getClass2(sourceFile, pos) {
	    const token = getTokenAtPosition(sourceFile, pos);
	    return cast(token.parent, isClassLike);
	  }
	  function addMissingMembers(classDeclaration, sourceFile, context, changeTracker, preferences) {
	    const extendsNode = getEffectiveBaseTypeNode(classDeclaration);
	    const checker = context.program.getTypeChecker();
	    const instantiatedExtendsType = checker.getTypeAtLocation(extendsNode);
	    const abstractAndNonPrivateExtendsSymbols = checker.getPropertiesOfType(instantiatedExtendsType).filter(symbolPointsToNonPrivateAndAbstractMember);
	    const importAdder = createImportAdder(sourceFile, context.program, preferences, context.host);
	    createMissingMemberNodes(classDeclaration, abstractAndNonPrivateExtendsSymbols, sourceFile, context, preferences, importAdder, (member) => changeTracker.insertMemberAtStart(sourceFile, classDeclaration, member));
	    importAdder.writeFixes(changeTracker);
	  }
	  function symbolPointsToNonPrivateAndAbstractMember(symbol) {
	    const flags = getSyntacticModifierFlags(first(symbol.getDeclarations()));
	    return !(flags & 2 /* Private */) && !!(flags & 64 /* Abstract */);
	  }
	  var errorCodes31, fixId25;
	  var init_fixClassDoesntImplementInheritedAbstractMember = __esm({
	    "src/services/codefixes/fixClassDoesntImplementInheritedAbstractMember.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      errorCodes31 = [
	        Diagnostics.Non_abstract_class_0_does_not_implement_all_abstract_members_of_1.code
	      ];
	      fixId25 = "fixClassDoesntImplementInheritedAbstractMember";
	      registerCodeFix({
	        errorCodes: errorCodes31,
	        getCodeActions: function getCodeActionsToFixClassNotImplementingInheritedMembers(context) {
	          const { sourceFile, span } = context;
	          const changes = ts_textChanges_exports.ChangeTracker.with(context, (t) => addMissingMembers(getClass2(sourceFile, span.start), sourceFile, context, t, context.preferences));
	          return changes.length === 0 ? void 0 : [createCodeFixAction(fixId25, changes, Diagnostics.Implement_inherited_abstract_class, fixId25, Diagnostics.Implement_all_inherited_abstract_classes)];
	        },
	        fixIds: [fixId25],
	        getAllCodeActions: function getAllCodeActionsToFixClassDoesntImplementInheritedAbstractMember(context) {
	          const seenClassDeclarations = /* @__PURE__ */ new Map();
	          return codeFixAll(context, errorCodes31, (changes, diag2) => {
	            const classDeclaration = getClass2(diag2.file, diag2.start);
	            if (addToSeen(seenClassDeclarations, getNodeId(classDeclaration))) {
	              addMissingMembers(classDeclaration, context.sourceFile, context, changes, context.preferences);
	            }
	          });
	        }
	      });
	    }
	  });

	  // src/services/codefixes/fixClassSuperMustPrecedeThisAccess.ts
	  function doChange20(changes, sourceFile, constructor, superCall) {
	    changes.insertNodeAtConstructorStart(sourceFile, constructor, superCall);
	    changes.delete(sourceFile, superCall);
	  }
	  function getNodes(sourceFile, pos) {
	    const token = getTokenAtPosition(sourceFile, pos);
	    if (token.kind !== 110 /* ThisKeyword */)
	      return void 0;
	    const constructor = getContainingFunction(token);
	    const superCall = findSuperCall(constructor.body);
	    return superCall && !superCall.expression.arguments.some((arg) => isPropertyAccessExpression(arg) && arg.expression === token) ? { constructor, superCall } : void 0;
	  }
	  function findSuperCall(n) {
	    return isExpressionStatement(n) && isSuperCall(n.expression) ? n : isFunctionLike(n) ? void 0 : forEachChild(n, findSuperCall);
	  }
	  var fixId26, errorCodes32;
	  var init_fixClassSuperMustPrecedeThisAccess = __esm({
	    "src/services/codefixes/fixClassSuperMustPrecedeThisAccess.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      fixId26 = "classSuperMustPrecedeThisAccess";
	      errorCodes32 = [Diagnostics.super_must_be_called_before_accessing_this_in_the_constructor_of_a_derived_class.code];
	      registerCodeFix({
	        errorCodes: errorCodes32,
	        getCodeActions(context) {
	          const { sourceFile, span } = context;
	          const nodes = getNodes(sourceFile, span.start);
	          if (!nodes)
	            return void 0;
	          const { constructor, superCall } = nodes;
	          const changes = ts_textChanges_exports.ChangeTracker.with(context, (t) => doChange20(t, sourceFile, constructor, superCall));
	          return [createCodeFixAction(fixId26, changes, Diagnostics.Make_super_call_the_first_statement_in_the_constructor, fixId26, Diagnostics.Make_all_super_calls_the_first_statement_in_their_constructor)];
	        },
	        fixIds: [fixId26],
	        getAllCodeActions(context) {
	          const { sourceFile } = context;
	          const seenClasses = /* @__PURE__ */ new Map();
	          return codeFixAll(context, errorCodes32, (changes, diag2) => {
	            const nodes = getNodes(diag2.file, diag2.start);
	            if (!nodes)
	              return;
	            const { constructor, superCall } = nodes;
	            if (addToSeen(seenClasses, getNodeId(constructor.parent))) {
	              doChange20(changes, sourceFile, constructor, superCall);
	            }
	          });
	        }
	      });
	    }
	  });

	  // src/services/codefixes/fixConstructorForDerivedNeedSuperCall.ts
	  function getNode(sourceFile, pos) {
	    const token = getTokenAtPosition(sourceFile, pos);
	    Debug.assert(isConstructorDeclaration(token.parent), "token should be at the constructor declaration");
	    return token.parent;
	  }
	  function doChange21(changes, sourceFile, ctr) {
	    const superCall = factory.createExpressionStatement(factory.createCallExpression(
	      factory.createSuper(),
	      /*typeArguments*/
	      void 0,
	      /*argumentsArray*/
	      emptyArray
	    ));
	    changes.insertNodeAtConstructorStart(sourceFile, ctr, superCall);
	  }
	  var fixId27, errorCodes33;
	  var init_fixConstructorForDerivedNeedSuperCall = __esm({
	    "src/services/codefixes/fixConstructorForDerivedNeedSuperCall.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      fixId27 = "constructorForDerivedNeedSuperCall";
	      errorCodes33 = [Diagnostics.Constructors_for_derived_classes_must_contain_a_super_call.code];
	      registerCodeFix({
	        errorCodes: errorCodes33,
	        getCodeActions(context) {
	          const { sourceFile, span } = context;
	          const ctr = getNode(sourceFile, span.start);
	          const changes = ts_textChanges_exports.ChangeTracker.with(context, (t) => doChange21(t, sourceFile, ctr));
	          return [createCodeFixAction(fixId27, changes, Diagnostics.Add_missing_super_call, fixId27, Diagnostics.Add_all_missing_super_calls)];
	        },
	        fixIds: [fixId27],
	        getAllCodeActions: (context) => codeFixAll(context, errorCodes33, (changes, diag2) => doChange21(changes, context.sourceFile, getNode(diag2.file, diag2.start)))
	      });
	    }
	  });

	  // src/services/codefixes/fixEnableJsxFlag.ts
	  function doChange22(changeTracker, configFile) {
	    setJsonCompilerOptionValue(changeTracker, configFile, "jsx", factory.createStringLiteral("react"));
	  }
	  var fixID, errorCodes34;
	  var init_fixEnableJsxFlag = __esm({
	    "src/services/codefixes/fixEnableJsxFlag.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      fixID = "fixEnableJsxFlag";
	      errorCodes34 = [Diagnostics.Cannot_use_JSX_unless_the_jsx_flag_is_provided.code];
	      registerCodeFix({
	        errorCodes: errorCodes34,
	        getCodeActions: function getCodeActionsToFixEnableJsxFlag(context) {
	          const { configFile } = context.program.getCompilerOptions();
	          if (configFile === void 0) {
	            return void 0;
	          }
	          const changes = ts_textChanges_exports.ChangeTracker.with(context, (changeTracker) => doChange22(changeTracker, configFile));
	          return [
	            createCodeFixActionWithoutFixAll(fixID, changes, Diagnostics.Enable_the_jsx_flag_in_your_configuration_file)
	          ];
	        },
	        fixIds: [fixID],
	        getAllCodeActions: (context) => codeFixAll(context, errorCodes34, (changes) => {
	          const { configFile } = context.program.getCompilerOptions();
	          if (configFile === void 0) {
	            return void 0;
	          }
	          doChange22(changes, configFile);
	        })
	      });
	    }
	  });

	  // src/services/codefixes/fixNaNEquality.ts
	  function getInfo12(program, sourceFile, span) {
	    const diag2 = find(program.getSemanticDiagnostics(sourceFile), (diag3) => diag3.start === span.start && diag3.length === span.length);
	    if (diag2 === void 0 || diag2.relatedInformation === void 0)
	      return;
	    const related = find(diag2.relatedInformation, (related2) => related2.code === Diagnostics.Did_you_mean_0.code);
	    if (related === void 0 || related.file === void 0 || related.start === void 0 || related.length === void 0)
	      return;
	    const token = findAncestorMatchingSpan(related.file, createTextSpan(related.start, related.length));
	    if (token === void 0)
	      return;
	    if (isExpression(token) && isBinaryExpression(token.parent)) {
	      return { suggestion: getSuggestion(related.messageText), expression: token.parent, arg: token };
	    }
	    return void 0;
	  }
	  function doChange23(changes, sourceFile, arg, expression) {
	    const callExpression = factory.createCallExpression(
	      factory.createPropertyAccessExpression(factory.createIdentifier("Number"), factory.createIdentifier("isNaN")),
	      /*typeArguments*/
	      void 0,
	      [arg]
	    );
	    const operator = expression.operatorToken.kind;
	    changes.replaceNode(
	      sourceFile,
	      expression,
	      operator === 38 /* ExclamationEqualsEqualsToken */ || operator === 36 /* ExclamationEqualsToken */ ? factory.createPrefixUnaryExpression(54 /* ExclamationToken */, callExpression) : callExpression
	    );
	  }
	  function getSuggestion(messageText) {
	    const [, suggestion] = flattenDiagnosticMessageText(messageText, "\n", 0).match(/'(.*)'/) || [];
	    return suggestion;
	  }
	  var fixId28, errorCodes35;
	  var init_fixNaNEquality = __esm({
	    "src/services/codefixes/fixNaNEquality.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      fixId28 = "fixNaNEquality";
	      errorCodes35 = [
	        Diagnostics.This_condition_will_always_return_0.code
	      ];
	      registerCodeFix({
	        errorCodes: errorCodes35,
	        getCodeActions(context) {
	          const { sourceFile, span, program } = context;
	          const info = getInfo12(program, sourceFile, span);
	          if (info === void 0)
	            return;
	          const { suggestion, expression, arg } = info;
	          const changes = ts_textChanges_exports.ChangeTracker.with(context, (t) => doChange23(t, sourceFile, arg, expression));
	          return [createCodeFixAction(fixId28, changes, [Diagnostics.Use_0, suggestion], fixId28, Diagnostics.Use_Number_isNaN_in_all_conditions)];
	        },
	        fixIds: [fixId28],
	        getAllCodeActions: (context) => {
	          return codeFixAll(context, errorCodes35, (changes, diag2) => {
	            const info = getInfo12(context.program, diag2.file, createTextSpan(diag2.start, diag2.length));
	            if (info) {
	              doChange23(changes, diag2.file, info.arg, info.expression);
	            }
	          });
	        }
	      });
	    }
	  });

	  // src/services/codefixes/fixModuleAndTargetOptions.ts
	  var init_fixModuleAndTargetOptions = __esm({
	    "src/services/codefixes/fixModuleAndTargetOptions.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      registerCodeFix({
	        errorCodes: [
	          Diagnostics.Top_level_await_expressions_are_only_allowed_when_the_module_option_is_set_to_es2022_esnext_system_node16_nodenext_or_preserve_and_the_target_option_is_set_to_es2017_or_higher.code,
	          Diagnostics.Top_level_await_using_statements_are_only_allowed_when_the_module_option_is_set_to_es2022_esnext_system_node16_nodenext_or_preserve_and_the_target_option_is_set_to_es2017_or_higher.code,
	          Diagnostics.Top_level_for_await_loops_are_only_allowed_when_the_module_option_is_set_to_es2022_esnext_system_node16_nodenext_or_preserve_and_the_target_option_is_set_to_es2017_or_higher.code
	        ],
	        getCodeActions: function getCodeActionsToFixModuleAndTarget(context) {
	          const compilerOptions = context.program.getCompilerOptions();
	          const { configFile } = compilerOptions;
	          if (configFile === void 0) {
	            return void 0;
	          }
	          const codeFixes = [];
	          const moduleKind = getEmitModuleKind(compilerOptions);
	          const moduleOutOfRange = moduleKind >= 5 /* ES2015 */ && moduleKind < 99 /* ESNext */;
	          if (moduleOutOfRange) {
	            const changes = ts_textChanges_exports.ChangeTracker.with(context, (changes2) => {
	              setJsonCompilerOptionValue(changes2, configFile, "module", factory.createStringLiteral("esnext"));
	            });
	            codeFixes.push(createCodeFixActionWithoutFixAll("fixModuleOption", changes, [Diagnostics.Set_the_module_option_in_your_configuration_file_to_0, "esnext"]));
	          }
	          const target = getEmitScriptTarget(compilerOptions);
	          const targetOutOfRange = target < 4 /* ES2017 */ || target > 99 /* ESNext */;
	          if (targetOutOfRange) {
	            const changes = ts_textChanges_exports.ChangeTracker.with(context, (tracker) => {
	              const configObject = getTsConfigObjectLiteralExpression(configFile);
	              if (!configObject)
	                return;
	              const options = [["target", factory.createStringLiteral("es2017")]];
	              if (moduleKind === 1 /* CommonJS */) {
	                options.push(["module", factory.createStringLiteral("commonjs")]);
	              }
	              setJsonCompilerOptionValues(tracker, configFile, options);
	            });
	            codeFixes.push(createCodeFixActionWithoutFixAll("fixTargetOption", changes, [Diagnostics.Set_the_target_option_in_your_configuration_file_to_0, "es2017"]));
	          }
	          return codeFixes.length ? codeFixes : void 0;
	        }
	      });
	    }
	  });

	  // src/services/codefixes/fixPropertyAssignment.ts
	  function doChange24(changes, sourceFile, node) {
	    changes.replaceNode(sourceFile, node, factory.createPropertyAssignment(node.name, node.objectAssignmentInitializer));
	  }
	  function getProperty2(sourceFile, pos) {
	    return cast(getTokenAtPosition(sourceFile, pos).parent, isShorthandPropertyAssignment);
	  }
	  var fixId29, errorCodes36;
	  var init_fixPropertyAssignment = __esm({
	    "src/services/codefixes/fixPropertyAssignment.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      fixId29 = "fixPropertyAssignment";
	      errorCodes36 = [
	        Diagnostics.Did_you_mean_to_use_a_Colon_An_can_only_follow_a_property_name_when_the_containing_object_literal_is_part_of_a_destructuring_pattern.code
	      ];
	      registerCodeFix({
	        errorCodes: errorCodes36,
	        fixIds: [fixId29],
	        getCodeActions(context) {
	          const { sourceFile, span } = context;
	          const property = getProperty2(sourceFile, span.start);
	          const changes = ts_textChanges_exports.ChangeTracker.with(context, (t) => doChange24(t, context.sourceFile, property));
	          return [createCodeFixAction(fixId29, changes, [Diagnostics.Change_0_to_1, "=", ":"], fixId29, [Diagnostics.Switch_each_misused_0_to_1, "=", ":"])];
	        },
	        getAllCodeActions: (context) => codeFixAll(context, errorCodes36, (changes, diag2) => doChange24(changes, diag2.file, getProperty2(diag2.file, diag2.start)))
	      });
	    }
	  });

	  // src/services/codefixes/fixExtendsInterfaceBecomesImplements.ts
	  function getNodes2(sourceFile, pos) {
	    const token = getTokenAtPosition(sourceFile, pos);
	    const heritageClauses = getContainingClass(token).heritageClauses;
	    const extendsToken = heritageClauses[0].getFirstToken();
	    return extendsToken.kind === 96 /* ExtendsKeyword */ ? { extendsToken, heritageClauses } : void 0;
	  }
	  function doChanges2(changes, sourceFile, extendsToken, heritageClauses) {
	    changes.replaceNode(sourceFile, extendsToken, factory.createToken(119 /* ImplementsKeyword */));
	    if (heritageClauses.length === 2 && heritageClauses[0].token === 96 /* ExtendsKeyword */ && heritageClauses[1].token === 119 /* ImplementsKeyword */) {
	      const implementsToken = heritageClauses[1].getFirstToken();
	      const implementsFullStart = implementsToken.getFullStart();
	      changes.replaceRange(sourceFile, { pos: implementsFullStart, end: implementsFullStart }, factory.createToken(28 /* CommaToken */));
	      const text = sourceFile.text;
	      let end = implementsToken.end;
	      while (end < text.length && isWhiteSpaceSingleLine(text.charCodeAt(end))) {
	        end++;
	      }
	      changes.deleteRange(sourceFile, { pos: implementsToken.getStart(), end });
	    }
	  }
	  var fixId30, errorCodes37;
	  var init_fixExtendsInterfaceBecomesImplements = __esm({
	    "src/services/codefixes/fixExtendsInterfaceBecomesImplements.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      fixId30 = "extendsInterfaceBecomesImplements";
	      errorCodes37 = [Diagnostics.Cannot_extend_an_interface_0_Did_you_mean_implements.code];
	      registerCodeFix({
	        errorCodes: errorCodes37,
	        getCodeActions(context) {
	          const { sourceFile } = context;
	          const nodes = getNodes2(sourceFile, context.span.start);
	          if (!nodes)
	            return void 0;
	          const { extendsToken, heritageClauses } = nodes;
	          const changes = ts_textChanges_exports.ChangeTracker.with(context, (t) => doChanges2(t, sourceFile, extendsToken, heritageClauses));
	          return [createCodeFixAction(fixId30, changes, Diagnostics.Change_extends_to_implements, fixId30, Diagnostics.Change_all_extended_interfaces_to_implements)];
	        },
	        fixIds: [fixId30],
	        getAllCodeActions: (context) => codeFixAll(context, errorCodes37, (changes, diag2) => {
	          const nodes = getNodes2(diag2.file, diag2.start);
	          if (nodes)
	            doChanges2(changes, diag2.file, nodes.extendsToken, nodes.heritageClauses);
	        })
	      });
	    }
	  });

	  // src/services/codefixes/fixForgottenThisPropertyAccess.ts
	  function getInfo13(sourceFile, pos, diagCode) {
	    const node = getTokenAtPosition(sourceFile, pos);
	    if (isIdentifier(node) || isPrivateIdentifier(node)) {
	      return { node, className: diagCode === didYouMeanStaticMemberCode ? getContainingClass(node).name.text : void 0 };
	    }
	  }
	  function doChange25(changes, sourceFile, { node, className }) {
	    suppressLeadingAndTrailingTrivia(node);
	    changes.replaceNode(sourceFile, node, factory.createPropertyAccessExpression(className ? factory.createIdentifier(className) : factory.createThis(), node));
	  }
	  var fixId31, didYouMeanStaticMemberCode, errorCodes38;
	  var init_fixForgottenThisPropertyAccess = __esm({
	    "src/services/codefixes/fixForgottenThisPropertyAccess.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      fixId31 = "forgottenThisPropertyAccess";
	      didYouMeanStaticMemberCode = Diagnostics.Cannot_find_name_0_Did_you_mean_the_static_member_1_0.code;
	      errorCodes38 = [
	        Diagnostics.Cannot_find_name_0_Did_you_mean_the_instance_member_this_0.code,
	        Diagnostics.Private_identifiers_are_only_allowed_in_class_bodies_and_may_only_be_used_as_part_of_a_class_member_declaration_property_access_or_on_the_left_hand_side_of_an_in_expression.code,
	        didYouMeanStaticMemberCode
	      ];
	      registerCodeFix({
	        errorCodes: errorCodes38,
	        getCodeActions(context) {
	          const { sourceFile } = context;
	          const info = getInfo13(sourceFile, context.span.start, context.errorCode);
	          if (!info) {
	            return void 0;
	          }
	          const changes = ts_textChanges_exports.ChangeTracker.with(context, (t) => doChange25(t, sourceFile, info));
	          return [createCodeFixAction(fixId31, changes, [Diagnostics.Add_0_to_unresolved_variable, info.className || "this"], fixId31, Diagnostics.Add_qualifier_to_all_unresolved_variables_matching_a_member_name)];
	        },
	        fixIds: [fixId31],
	        getAllCodeActions: (context) => codeFixAll(context, errorCodes38, (changes, diag2) => {
	          const info = getInfo13(diag2.file, diag2.start, diag2.code);
	          if (info)
	            doChange25(changes, context.sourceFile, info);
	        })
	      });
	    }
	  });

	  // src/services/codefixes/fixInvalidJsxCharacters.ts
	  function isValidCharacter(character) {
	    return hasProperty(htmlEntity, character);
	  }
	  function doChange26(changes, preferences, sourceFile, start, useHtmlEntity) {
	    const character = sourceFile.getText()[start];
	    if (!isValidCharacter(character)) {
	      return;
	    }
	    const replacement = useHtmlEntity ? htmlEntity[character] : `{${quote(sourceFile, preferences, character)}}`;
	    changes.replaceRangeWithText(sourceFile, { pos: start, end: start + 1 }, replacement);
	  }
	  var fixIdExpression, fixIdHtmlEntity, errorCodes39, htmlEntity;
	  var init_fixInvalidJsxCharacters = __esm({
	    "src/services/codefixes/fixInvalidJsxCharacters.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      fixIdExpression = "fixInvalidJsxCharacters_expression";
	      fixIdHtmlEntity = "fixInvalidJsxCharacters_htmlEntity";
	      errorCodes39 = [
	        Diagnostics.Unexpected_token_Did_you_mean_or_gt.code,
	        Diagnostics.Unexpected_token_Did_you_mean_or_rbrace.code
	      ];
	      registerCodeFix({
	        errorCodes: errorCodes39,
	        fixIds: [fixIdExpression, fixIdHtmlEntity],
	        getCodeActions(context) {
	          const { sourceFile, preferences, span } = context;
	          const changeToExpression = ts_textChanges_exports.ChangeTracker.with(context, (t) => doChange26(
	            t,
	            preferences,
	            sourceFile,
	            span.start,
	            /*useHtmlEntity*/
	            false
	          ));
	          const changeToHtmlEntity = ts_textChanges_exports.ChangeTracker.with(context, (t) => doChange26(
	            t,
	            preferences,
	            sourceFile,
	            span.start,
	            /*useHtmlEntity*/
	            true
	          ));
	          return [
	            createCodeFixAction(fixIdExpression, changeToExpression, Diagnostics.Wrap_invalid_character_in_an_expression_container, fixIdExpression, Diagnostics.Wrap_all_invalid_characters_in_an_expression_container),
	            createCodeFixAction(fixIdHtmlEntity, changeToHtmlEntity, Diagnostics.Convert_invalid_character_to_its_html_entity_code, fixIdHtmlEntity, Diagnostics.Convert_all_invalid_characters_to_HTML_entity_code)
	          ];
	        },
	        getAllCodeActions(context) {
	          return codeFixAll(context, errorCodes39, (changes, diagnostic) => doChange26(changes, context.preferences, diagnostic.file, diagnostic.start, context.fixId === fixIdHtmlEntity));
	        }
	      });
	      htmlEntity = {
	        ">": "&gt;",
	        "}": "&rbrace;"
	      };
	    }
	  });

	  // src/services/codefixes/fixUnmatchedParameter.ts
	  function getDeleteAction(context, { name, jsDocHost, jsDocParameterTag }) {
	    const changes = ts_textChanges_exports.ChangeTracker.with(context, (changeTracker) => changeTracker.filterJSDocTags(context.sourceFile, jsDocHost, (t) => t !== jsDocParameterTag));
	    return createCodeFixAction(
	      deleteUnmatchedParameter,
	      changes,
	      [Diagnostics.Delete_unused_param_tag_0, name.getText(context.sourceFile)],
	      deleteUnmatchedParameter,
	      Diagnostics.Delete_all_unused_param_tags
	    );
	  }
	  function getRenameAction(context, { name, jsDocHost, signature, jsDocParameterTag }) {
	    if (!length(signature.parameters))
	      return void 0;
	    const sourceFile = context.sourceFile;
	    const tags = getJSDocTags(signature);
	    const names = /* @__PURE__ */ new Set();
	    for (const tag of tags) {
	      if (isJSDocParameterTag(tag) && isIdentifier(tag.name)) {
	        names.add(tag.name.escapedText);
	      }
	    }
	    const parameterName = firstDefined(signature.parameters, (p) => isIdentifier(p.name) && !names.has(p.name.escapedText) ? p.name.getText(sourceFile) : void 0);
	    if (parameterName === void 0)
	      return void 0;
	    const newJSDocParameterTag = factory.updateJSDocParameterTag(
	      jsDocParameterTag,
	      jsDocParameterTag.tagName,
	      factory.createIdentifier(parameterName),
	      jsDocParameterTag.isBracketed,
	      jsDocParameterTag.typeExpression,
	      jsDocParameterTag.isNameFirst,
	      jsDocParameterTag.comment
	    );
	    const changes = ts_textChanges_exports.ChangeTracker.with(context, (changeTracker) => changeTracker.replaceJSDocComment(sourceFile, jsDocHost, map(tags, (t) => t === jsDocParameterTag ? newJSDocParameterTag : t)));
	    return createCodeFixActionWithoutFixAll(renameUnmatchedParameter, changes, [Diagnostics.Rename_param_tag_name_0_to_1, name.getText(sourceFile), parameterName]);
	  }
	  function getInfo14(sourceFile, pos) {
	    const token = getTokenAtPosition(sourceFile, pos);
	    if (token.parent && isJSDocParameterTag(token.parent) && isIdentifier(token.parent.name)) {
	      const jsDocParameterTag = token.parent;
	      const jsDocHost = getJSDocHost(jsDocParameterTag);
	      const signature = getHostSignatureFromJSDoc(jsDocParameterTag);
	      if (jsDocHost && signature) {
	        return { jsDocHost, signature, name: token.parent.name, jsDocParameterTag };
	      }
	    }
	    return void 0;
	  }
	  var deleteUnmatchedParameter, renameUnmatchedParameter, errorCodes40;
	  var init_fixUnmatchedParameter = __esm({
	    "src/services/codefixes/fixUnmatchedParameter.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      deleteUnmatchedParameter = "deleteUnmatchedParameter";
	      renameUnmatchedParameter = "renameUnmatchedParameter";
	      errorCodes40 = [
	        Diagnostics.JSDoc_param_tag_has_name_0_but_there_is_no_parameter_with_that_name.code
	      ];
	      registerCodeFix({
	        fixIds: [deleteUnmatchedParameter, renameUnmatchedParameter],
	        errorCodes: errorCodes40,
	        getCodeActions: function getCodeActionsToFixUnmatchedParameter(context) {
	          const { sourceFile, span } = context;
	          const actions2 = [];
	          const info = getInfo14(sourceFile, span.start);
	          if (info) {
	            append(actions2, getDeleteAction(context, info));
	            append(actions2, getRenameAction(context, info));
	            return actions2;
	          }
	          return void 0;
	        },
	        getAllCodeActions: function getAllCodeActionsToFixUnmatchedParameter(context) {
	          const tagsToSignature = /* @__PURE__ */ new Map();
	          return createCombinedCodeActions(ts_textChanges_exports.ChangeTracker.with(context, (changes) => {
	            eachDiagnostic(context, errorCodes40, ({ file, start }) => {
	              const info = getInfo14(file, start);
	              if (info) {
	                tagsToSignature.set(info.signature, append(tagsToSignature.get(info.signature), info.jsDocParameterTag));
	              }
	            });
	            tagsToSignature.forEach((tags, signature) => {
	              if (context.fixId === deleteUnmatchedParameter) {
	                const tagsSet = new Set(tags);
	                changes.filterJSDocTags(signature.getSourceFile(), signature, (t) => !tagsSet.has(t));
	              }
	            });
	          }));
	        }
	      });
	    }
	  });

	  // src/services/codefixes/fixUnreferenceableDecoratorMetadata.ts
	  function getImportDeclaration(sourceFile, program, start) {
	    const identifier = tryCast(getTokenAtPosition(sourceFile, start), isIdentifier);
	    if (!identifier || identifier.parent.kind !== 183 /* TypeReference */)
	      return;
	    const checker = program.getTypeChecker();
	    const symbol = checker.getSymbolAtLocation(identifier);
	    return find((symbol == null ? void 0 : symbol.declarations) || emptyArray, or(isImportClause, isImportSpecifier, isImportEqualsDeclaration));
	  }
	  function doTypeOnlyImportChange(changes, sourceFile, importDeclaration, program) {
	    if (importDeclaration.kind === 271 /* ImportEqualsDeclaration */) {
	      changes.insertModifierBefore(sourceFile, 156 /* TypeKeyword */, importDeclaration.name);
	      return;
	    }
	    const importClause = importDeclaration.kind === 273 /* ImportClause */ ? importDeclaration : importDeclaration.parent.parent;
	    if (importClause.name && importClause.namedBindings) {
	      return;
	    }
	    const checker = program.getTypeChecker();
	    const importsValue = !!forEachImportClauseDeclaration(importClause, (decl) => {
	      if (skipAlias(decl.symbol, checker).flags & 111551 /* Value */)
	        return true;
	    });
	    if (importsValue) {
	      return;
	    }
	    changes.insertModifierBefore(sourceFile, 156 /* TypeKeyword */, importClause);
	  }
	  function doNamespaceImportChange(changes, sourceFile, importDeclaration, program) {
	    ts_refactor_exports.doChangeNamedToNamespaceOrDefault(sourceFile, program, changes, importDeclaration.parent);
	  }
	  var fixId32, errorCodes41;
	  var init_fixUnreferenceableDecoratorMetadata = __esm({
	    "src/services/codefixes/fixUnreferenceableDecoratorMetadata.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      fixId32 = "fixUnreferenceableDecoratorMetadata";
	      errorCodes41 = [Diagnostics.A_type_referenced_in_a_decorated_signature_must_be_imported_with_import_type_or_a_namespace_import_when_isolatedModules_and_emitDecoratorMetadata_are_enabled.code];
	      registerCodeFix({
	        errorCodes: errorCodes41,
	        getCodeActions: (context) => {
	          const importDeclaration = getImportDeclaration(context.sourceFile, context.program, context.span.start);
	          if (!importDeclaration)
	            return;
	          const namespaceChanges = ts_textChanges_exports.ChangeTracker.with(context, (t) => importDeclaration.kind === 276 /* ImportSpecifier */ && doNamespaceImportChange(t, context.sourceFile, importDeclaration, context.program));
	          const typeOnlyChanges = ts_textChanges_exports.ChangeTracker.with(context, (t) => doTypeOnlyImportChange(t, context.sourceFile, importDeclaration, context.program));
	          let actions2;
	          if (namespaceChanges.length) {
	            actions2 = append(actions2, createCodeFixActionWithoutFixAll(fixId32, namespaceChanges, Diagnostics.Convert_named_imports_to_namespace_import));
	          }
	          if (typeOnlyChanges.length) {
	            actions2 = append(actions2, createCodeFixActionWithoutFixAll(fixId32, typeOnlyChanges, Diagnostics.Use_import_type));
	          }
	          return actions2;
	        },
	        fixIds: [fixId32]
	      });
	    }
	  });

	  // src/services/codefixes/fixUnusedIdentifier.ts
	  function changeInferToUnknown(changes, sourceFile, token) {
	    changes.replaceNode(sourceFile, token.parent, factory.createKeywordTypeNode(159 /* UnknownKeyword */));
	  }
	  function createDeleteFix(changes, diag2) {
	    return createCodeFixAction(fixName3, changes, diag2, fixIdDelete, Diagnostics.Delete_all_unused_declarations);
	  }
	  function deleteTypeParameters(changes, sourceFile, token) {
	    changes.delete(sourceFile, Debug.checkDefined(cast(token.parent, isDeclarationWithTypeParameterChildren).typeParameters, "The type parameter to delete should exist"));
	  }
	  function isImport(token) {
	    return token.kind === 102 /* ImportKeyword */ || token.kind === 80 /* Identifier */ && (token.parent.kind === 276 /* ImportSpecifier */ || token.parent.kind === 273 /* ImportClause */);
	  }
	  function tryGetFullImport(token) {
	    return token.kind === 102 /* ImportKeyword */ ? tryCast(token.parent, isImportDeclaration) : void 0;
	  }
	  function canDeleteEntireVariableStatement(sourceFile, token) {
	    return isVariableDeclarationList(token.parent) && first(token.parent.getChildren(sourceFile)) === token;
	  }
	  function deleteEntireVariableStatement(changes, sourceFile, node) {
	    changes.delete(sourceFile, node.parent.kind === 243 /* VariableStatement */ ? node.parent : node);
	  }
	  function deleteDestructuringElements(changes, sourceFile, node) {
	    forEach(node.elements, (n) => changes.delete(sourceFile, n));
	  }
	  function deleteDestructuring(context, changes, sourceFile, { parent: parent2 }) {
	    if (isVariableDeclaration(parent2) && parent2.initializer && isCallLikeExpression(parent2.initializer)) {
	      if (isVariableDeclarationList(parent2.parent) && length(parent2.parent.declarations) > 1) {
	        const varStatement = parent2.parent.parent;
	        const pos = varStatement.getStart(sourceFile);
	        const end = varStatement.end;
	        changes.delete(sourceFile, parent2);
	        changes.insertNodeAt(sourceFile, end, parent2.initializer, {
	          prefix: getNewLineOrDefaultFromHost(context.host, context.formatContext.options) + sourceFile.text.slice(getPrecedingNonSpaceCharacterPosition(sourceFile.text, pos - 1), pos),
	          suffix: probablyUsesSemicolons(sourceFile) ? ";" : ""
	        });
	      } else {
	        changes.replaceNode(sourceFile, parent2.parent, parent2.initializer);
	      }
	    } else {
	      changes.delete(sourceFile, parent2);
	    }
	  }
	  function tryPrefixDeclaration(changes, errorCode, sourceFile, token) {
	    if (errorCode === Diagnostics.Property_0_is_declared_but_its_value_is_never_read.code)
	      return;
	    if (token.kind === 140 /* InferKeyword */) {
	      token = cast(token.parent, isInferTypeNode).typeParameter.name;
	    }
	    if (isIdentifier(token) && canPrefix(token)) {
	      changes.replaceNode(sourceFile, token, factory.createIdentifier(`_${token.text}`));
	      if (isParameter(token.parent)) {
	        getJSDocParameterTags(token.parent).forEach((tag) => {
	          if (isIdentifier(tag.name)) {
	            changes.replaceNode(sourceFile, tag.name, factory.createIdentifier(`_${tag.name.text}`));
	          }
	        });
	      }
	    }
	  }
	  function canPrefix(token) {
	    switch (token.parent.kind) {
	      case 169 /* Parameter */:
	      case 168 /* TypeParameter */:
	        return true;
	      case 260 /* VariableDeclaration */: {
	        const varDecl = token.parent;
	        switch (varDecl.parent.parent.kind) {
	          case 250 /* ForOfStatement */:
	          case 249 /* ForInStatement */:
	            return true;
	        }
	      }
	    }
	    return false;
	  }
	  function tryDeleteDeclaration(sourceFile, token, changes, checker, sourceFiles, program, cancellationToken, isFixAll) {
	    tryDeleteDeclarationWorker(token, changes, sourceFile, checker, sourceFiles, program, cancellationToken, isFixAll);
	    if (isIdentifier(token)) {
	      ts_FindAllReferences_exports.Core.eachSymbolReferenceInFile(token, checker, sourceFile, (ref) => {
	        if (isPropertyAccessExpression(ref.parent) && ref.parent.name === ref)
	          ref = ref.parent;
	        if (!isFixAll && mayDeleteExpression(ref)) {
	          changes.delete(sourceFile, ref.parent.parent);
	        }
	      });
	    }
	  }
	  function tryDeleteDeclarationWorker(token, changes, sourceFile, checker, sourceFiles, program, cancellationToken, isFixAll) {
	    const { parent: parent2 } = token;
	    if (isParameter(parent2)) {
	      tryDeleteParameter(changes, sourceFile, parent2, checker, sourceFiles, program, cancellationToken, isFixAll);
	    } else if (!(isFixAll && isIdentifier(token) && ts_FindAllReferences_exports.Core.isSymbolReferencedInFile(token, checker, sourceFile))) {
	      const node = isImportClause(parent2) ? token : isComputedPropertyName(parent2) ? parent2.parent : parent2;
	      Debug.assert(node !== sourceFile, "should not delete whole source file");
	      changes.delete(sourceFile, node);
	    }
	  }
	  function tryDeleteParameter(changes, sourceFile, parameter, checker, sourceFiles, program, cancellationToken, isFixAll = false) {
	    if (mayDeleteParameter(checker, sourceFile, parameter, sourceFiles, program, cancellationToken, isFixAll)) {
	      if (parameter.modifiers && parameter.modifiers.length > 0 && (!isIdentifier(parameter.name) || ts_FindAllReferences_exports.Core.isSymbolReferencedInFile(parameter.name, checker, sourceFile))) {
	        for (const modifier of parameter.modifiers) {
	          if (isModifier(modifier)) {
	            changes.deleteModifier(sourceFile, modifier);
	          }
	        }
	      } else if (!parameter.initializer && isNotProvidedArguments(parameter, checker, sourceFiles)) {
	        changes.delete(sourceFile, parameter);
	      }
	    }
	  }
	  function isNotProvidedArguments(parameter, checker, sourceFiles) {
	    const index = parameter.parent.parameters.indexOf(parameter);
	    return !ts_FindAllReferences_exports.Core.someSignatureUsage(parameter.parent, sourceFiles, checker, (_, call) => !call || call.arguments.length > index);
	  }
	  function mayDeleteParameter(checker, sourceFile, parameter, sourceFiles, program, cancellationToken, isFixAll) {
	    const { parent: parent2 } = parameter;
	    switch (parent2.kind) {
	      case 174 /* MethodDeclaration */:
	      case 176 /* Constructor */:
	        const index = parent2.parameters.indexOf(parameter);
	        const referent = isMethodDeclaration(parent2) ? parent2.name : parent2;
	        const entries = ts_FindAllReferences_exports.Core.getReferencedSymbolsForNode(parent2.pos, referent, program, sourceFiles, cancellationToken);
	        if (entries) {
	          for (const entry of entries) {
	            for (const reference of entry.references) {
	              if (reference.kind === ts_FindAllReferences_exports.EntryKind.Node) {
	                const isSuperCall2 = isSuperKeyword(reference.node) && isCallExpression(reference.node.parent) && reference.node.parent.arguments.length > index;
	                const isSuperMethodCall = isPropertyAccessExpression(reference.node.parent) && isSuperKeyword(reference.node.parent.expression) && isCallExpression(reference.node.parent.parent) && reference.node.parent.parent.arguments.length > index;
	                const isOverriddenMethod = (isMethodDeclaration(reference.node.parent) || isMethodSignature(reference.node.parent)) && reference.node.parent !== parameter.parent && reference.node.parent.parameters.length > index;
	                if (isSuperCall2 || isSuperMethodCall || isOverriddenMethod)
	                  return false;
	              }
	            }
	          }
	        }
	        return true;
	      case 262 /* FunctionDeclaration */: {
	        if (parent2.name && isCallbackLike(checker, sourceFile, parent2.name)) {
	          return isLastParameter(parent2, parameter, isFixAll);
	        }
	        return true;
	      }
	      case 218 /* FunctionExpression */:
	      case 219 /* ArrowFunction */:
	        return isLastParameter(parent2, parameter, isFixAll);
	      case 178 /* SetAccessor */:
	        return false;
	      case 177 /* GetAccessor */:
	        return true;
	      default:
	        return Debug.failBadSyntaxKind(parent2);
	    }
	  }
	  function isCallbackLike(checker, sourceFile, name) {
	    return !!ts_FindAllReferences_exports.Core.eachSymbolReferenceInFile(name, checker, sourceFile, (reference) => isIdentifier(reference) && isCallExpression(reference.parent) && reference.parent.arguments.includes(reference));
	  }
	  function isLastParameter(func, parameter, isFixAll) {
	    const parameters = func.parameters;
	    const index = parameters.indexOf(parameter);
	    Debug.assert(index !== -1, "The parameter should already be in the list");
	    return isFixAll ? parameters.slice(index + 1).every((p) => isIdentifier(p.name) && !p.symbol.isReferenced) : index === parameters.length - 1;
	  }
	  function mayDeleteExpression(node) {
	    return (isBinaryExpression(node.parent) && node.parent.left === node || (isPostfixUnaryExpression(node.parent) || isPrefixUnaryExpression(node.parent)) && node.parent.operand === node) && isExpressionStatement(node.parent.parent);
	  }
	  var fixName3, fixIdPrefix, fixIdDelete, fixIdDeleteImports, fixIdInfer, errorCodes42;
	  var init_fixUnusedIdentifier = __esm({
	    "src/services/codefixes/fixUnusedIdentifier.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      fixName3 = "unusedIdentifier";
	      fixIdPrefix = "unusedIdentifier_prefix";
	      fixIdDelete = "unusedIdentifier_delete";
	      fixIdDeleteImports = "unusedIdentifier_deleteImports";
	      fixIdInfer = "unusedIdentifier_infer";
	      errorCodes42 = [
	        Diagnostics._0_is_declared_but_its_value_is_never_read.code,
	        Diagnostics._0_is_declared_but_never_used.code,
	        Diagnostics.Property_0_is_declared_but_its_value_is_never_read.code,
	        Diagnostics.All_imports_in_import_declaration_are_unused.code,
	        Diagnostics.All_destructured_elements_are_unused.code,
	        Diagnostics.All_variables_are_unused.code,
	        Diagnostics.All_type_parameters_are_unused.code
	      ];
	      registerCodeFix({
	        errorCodes: errorCodes42,
	        getCodeActions(context) {
	          const { errorCode, sourceFile, program, cancellationToken } = context;
	          const checker = program.getTypeChecker();
	          const sourceFiles = program.getSourceFiles();
	          const token = getTokenAtPosition(sourceFile, context.span.start);
	          if (isJSDocTemplateTag(token)) {
	            return [createDeleteFix(ts_textChanges_exports.ChangeTracker.with(context, (t) => t.delete(sourceFile, token)), Diagnostics.Remove_template_tag)];
	          }
	          if (token.kind === 30 /* LessThanToken */) {
	            const changes = ts_textChanges_exports.ChangeTracker.with(context, (t) => deleteTypeParameters(t, sourceFile, token));
	            return [createDeleteFix(changes, Diagnostics.Remove_type_parameters)];
	          }
	          const importDecl = tryGetFullImport(token);
	          if (importDecl) {
	            const changes = ts_textChanges_exports.ChangeTracker.with(context, (t) => t.delete(sourceFile, importDecl));
	            return [createCodeFixAction(fixName3, changes, [Diagnostics.Remove_import_from_0, showModuleSpecifier(importDecl)], fixIdDeleteImports, Diagnostics.Delete_all_unused_imports)];
	          } else if (isImport(token)) {
	            const deletion = ts_textChanges_exports.ChangeTracker.with(context, (t) => tryDeleteDeclaration(
	              sourceFile,
	              token,
	              t,
	              checker,
	              sourceFiles,
	              program,
	              cancellationToken,
	              /*isFixAll*/
	              false
	            ));
	            if (deletion.length) {
	              return [createCodeFixAction(fixName3, deletion, [Diagnostics.Remove_unused_declaration_for_Colon_0, token.getText(sourceFile)], fixIdDeleteImports, Diagnostics.Delete_all_unused_imports)];
	            }
	          }
	          if (isObjectBindingPattern(token.parent) || isArrayBindingPattern(token.parent)) {
	            if (isParameter(token.parent.parent)) {
	              const elements = token.parent.elements;
	              const diagnostic = [
	                elements.length > 1 ? Diagnostics.Remove_unused_declarations_for_Colon_0 : Diagnostics.Remove_unused_declaration_for_Colon_0,
	                map(elements, (e) => e.getText(sourceFile)).join(", ")
	              ];
	              return [
	                createDeleteFix(ts_textChanges_exports.ChangeTracker.with(context, (t) => deleteDestructuringElements(t, sourceFile, token.parent)), diagnostic)
	              ];
	            }
	            return [
	              createDeleteFix(ts_textChanges_exports.ChangeTracker.with(context, (t) => deleteDestructuring(context, t, sourceFile, token.parent)), Diagnostics.Remove_unused_destructuring_declaration)
	            ];
	          }
	          if (canDeleteEntireVariableStatement(sourceFile, token)) {
	            return [
	              createDeleteFix(ts_textChanges_exports.ChangeTracker.with(context, (t) => deleteEntireVariableStatement(t, sourceFile, token.parent)), Diagnostics.Remove_variable_statement)
	            ];
	          }
	          const result = [];
	          if (token.kind === 140 /* InferKeyword */) {
	            const changes = ts_textChanges_exports.ChangeTracker.with(context, (t) => changeInferToUnknown(t, sourceFile, token));
	            const name = cast(token.parent, isInferTypeNode).typeParameter.name.text;
	            result.push(createCodeFixAction(fixName3, changes, [Diagnostics.Replace_infer_0_with_unknown, name], fixIdInfer, Diagnostics.Replace_all_unused_infer_with_unknown));
	          } else {
	            const deletion = ts_textChanges_exports.ChangeTracker.with(context, (t) => tryDeleteDeclaration(
	              sourceFile,
	              token,
	              t,
	              checker,
	              sourceFiles,
	              program,
	              cancellationToken,
	              /*isFixAll*/
	              false
	            ));
	            if (deletion.length) {
	              const name = isComputedPropertyName(token.parent) ? token.parent : token;
	              result.push(createDeleteFix(deletion, [Diagnostics.Remove_unused_declaration_for_Colon_0, name.getText(sourceFile)]));
	            }
	          }
	          const prefix = ts_textChanges_exports.ChangeTracker.with(context, (t) => tryPrefixDeclaration(t, errorCode, sourceFile, token));
	          if (prefix.length) {
	            result.push(createCodeFixAction(fixName3, prefix, [Diagnostics.Prefix_0_with_an_underscore, token.getText(sourceFile)], fixIdPrefix, Diagnostics.Prefix_all_unused_declarations_with_where_possible));
	          }
	          return result;
	        },
	        fixIds: [fixIdPrefix, fixIdDelete, fixIdDeleteImports, fixIdInfer],
	        getAllCodeActions: (context) => {
	          const { sourceFile, program, cancellationToken } = context;
	          const checker = program.getTypeChecker();
	          const sourceFiles = program.getSourceFiles();
	          return codeFixAll(context, errorCodes42, (changes, diag2) => {
	            const token = getTokenAtPosition(sourceFile, diag2.start);
	            switch (context.fixId) {
	              case fixIdPrefix:
	                tryPrefixDeclaration(changes, diag2.code, sourceFile, token);
	                break;
	              case fixIdDeleteImports: {
	                const importDecl = tryGetFullImport(token);
	                if (importDecl) {
	                  changes.delete(sourceFile, importDecl);
	                } else if (isImport(token)) {
	                  tryDeleteDeclaration(
	                    sourceFile,
	                    token,
	                    changes,
	                    checker,
	                    sourceFiles,
	                    program,
	                    cancellationToken,
	                    /*isFixAll*/
	                    true
	                  );
	                }
	                break;
	              }
	              case fixIdDelete: {
	                if (token.kind === 140 /* InferKeyword */ || isImport(token)) {
	                  break;
	                } else if (isJSDocTemplateTag(token)) {
	                  changes.delete(sourceFile, token);
	                } else if (token.kind === 30 /* LessThanToken */) {
	                  deleteTypeParameters(changes, sourceFile, token);
	                } else if (isObjectBindingPattern(token.parent)) {
	                  if (token.parent.parent.initializer) {
	                    break;
	                  } else if (!isParameter(token.parent.parent) || isNotProvidedArguments(token.parent.parent, checker, sourceFiles)) {
	                    changes.delete(sourceFile, token.parent.parent);
	                  }
	                } else if (isArrayBindingPattern(token.parent.parent) && token.parent.parent.parent.initializer) {
	                  break;
	                } else if (canDeleteEntireVariableStatement(sourceFile, token)) {
	                  deleteEntireVariableStatement(changes, sourceFile, token.parent);
	                } else {
	                  tryDeleteDeclaration(
	                    sourceFile,
	                    token,
	                    changes,
	                    checker,
	                    sourceFiles,
	                    program,
	                    cancellationToken,
	                    /*isFixAll*/
	                    true
	                  );
	                }
	                break;
	              }
	              case fixIdInfer:
	                if (token.kind === 140 /* InferKeyword */) {
	                  changeInferToUnknown(changes, sourceFile, token);
	                }
	                break;
	              default:
	                Debug.fail(JSON.stringify(context.fixId));
	            }
	          });
	        }
	      });
	    }
	  });

	  // src/services/codefixes/fixUnreachableCode.ts
	  function doChange27(changes, sourceFile, start, length2, errorCode) {
	    const token = getTokenAtPosition(sourceFile, start);
	    const statement = findAncestor(token, isStatement);
	    if (statement.getStart(sourceFile) !== token.getStart(sourceFile)) {
	      const logData = JSON.stringify({
	        statementKind: Debug.formatSyntaxKind(statement.kind),
	        tokenKind: Debug.formatSyntaxKind(token.kind),
	        errorCode,
	        start,
	        length: length2
	      });
	      Debug.fail("Token and statement should start at the same point. " + logData);
	    }
	    const container = (isBlock(statement.parent) ? statement.parent : statement).parent;
	    if (!isBlock(statement.parent) || statement === first(statement.parent.statements)) {
	      switch (container.kind) {
	        case 245 /* IfStatement */:
	          if (container.elseStatement) {
	            if (isBlock(statement.parent)) {
	              break;
	            } else {
	              changes.replaceNode(sourceFile, statement, factory.createBlock(emptyArray));
	            }
	            return;
	          }
	        case 247 /* WhileStatement */:
	        case 248 /* ForStatement */:
	          changes.delete(sourceFile, container);
	          return;
	      }
	    }
	    if (isBlock(statement.parent)) {
	      const end = start + length2;
	      const lastStatement = Debug.checkDefined(lastWhere(sliceAfter(statement.parent.statements, statement), (s) => s.pos < end), "Some statement should be last");
	      changes.deleteNodeRange(sourceFile, statement, lastStatement);
	    } else {
	      changes.delete(sourceFile, statement);
	    }
	  }
	  function lastWhere(a, pred) {
	    let last2;
	    for (const value of a) {
	      if (!pred(value))
	        break;
	      last2 = value;
	    }
	    return last2;
	  }
	  var fixId33, errorCodes43;
	  var init_fixUnreachableCode = __esm({
	    "src/services/codefixes/fixUnreachableCode.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      fixId33 = "fixUnreachableCode";
	      errorCodes43 = [Diagnostics.Unreachable_code_detected.code];
	      registerCodeFix({
	        errorCodes: errorCodes43,
	        getCodeActions(context) {
	          const syntacticDiagnostics = context.program.getSyntacticDiagnostics(context.sourceFile, context.cancellationToken);
	          if (syntacticDiagnostics.length)
	            return;
	          const changes = ts_textChanges_exports.ChangeTracker.with(context, (t) => doChange27(t, context.sourceFile, context.span.start, context.span.length, context.errorCode));
	          return [createCodeFixAction(fixId33, changes, Diagnostics.Remove_unreachable_code, fixId33, Diagnostics.Remove_all_unreachable_code)];
	        },
	        fixIds: [fixId33],
	        getAllCodeActions: (context) => codeFixAll(context, errorCodes43, (changes, diag2) => doChange27(changes, diag2.file, diag2.start, diag2.length, diag2.code))
	      });
	    }
	  });

	  // src/services/codefixes/fixUnusedLabel.ts
	  function doChange28(changes, sourceFile, start) {
	    const token = getTokenAtPosition(sourceFile, start);
	    const labeledStatement = cast(token.parent, isLabeledStatement);
	    const pos = token.getStart(sourceFile);
	    const statementPos = labeledStatement.statement.getStart(sourceFile);
	    const end = positionsAreOnSameLine(pos, statementPos, sourceFile) ? statementPos : skipTrivia(
	      sourceFile.text,
	      findChildOfKind(labeledStatement, 59 /* ColonToken */, sourceFile).end,
	      /*stopAfterLineBreak*/
	      true
	    );
	    changes.deleteRange(sourceFile, { pos, end });
	  }
	  var fixId34, errorCodes44;
	  var init_fixUnusedLabel = __esm({
	    "src/services/codefixes/fixUnusedLabel.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      fixId34 = "fixUnusedLabel";
	      errorCodes44 = [Diagnostics.Unused_label.code];
	      registerCodeFix({
	        errorCodes: errorCodes44,
	        getCodeActions(context) {
	          const changes = ts_textChanges_exports.ChangeTracker.with(context, (t) => doChange28(t, context.sourceFile, context.span.start));
	          return [createCodeFixAction(fixId34, changes, Diagnostics.Remove_unused_label, fixId34, Diagnostics.Remove_all_unused_labels)];
	        },
	        fixIds: [fixId34],
	        getAllCodeActions: (context) => codeFixAll(context, errorCodes44, (changes, diag2) => doChange28(changes, diag2.file, diag2.start))
	      });
	    }
	  });

	  // src/services/codefixes/fixJSDocTypes.ts
	  function doChange29(changes, sourceFile, oldTypeNode, newType, checker) {
	    changes.replaceNode(sourceFile, oldTypeNode, checker.typeToTypeNode(
	      newType,
	      /*enclosingDeclaration*/
	      oldTypeNode,
	      /*flags*/
	      void 0
	    ));
	  }
	  function getInfo15(sourceFile, pos, checker) {
	    const decl = findAncestor(getTokenAtPosition(sourceFile, pos), isTypeContainer);
	    const typeNode = decl && decl.type;
	    return typeNode && { typeNode, type: getType(checker, typeNode) };
	  }
	  function isTypeContainer(node) {
	    switch (node.kind) {
	      case 234 /* AsExpression */:
	      case 179 /* CallSignature */:
	      case 180 /* ConstructSignature */:
	      case 262 /* FunctionDeclaration */:
	      case 177 /* GetAccessor */:
	      case 181 /* IndexSignature */:
	      case 200 /* MappedType */:
	      case 174 /* MethodDeclaration */:
	      case 173 /* MethodSignature */:
	      case 169 /* Parameter */:
	      case 172 /* PropertyDeclaration */:
	      case 171 /* PropertySignature */:
	      case 178 /* SetAccessor */:
	      case 265 /* TypeAliasDeclaration */:
	      case 216 /* TypeAssertionExpression */:
	      case 260 /* VariableDeclaration */:
	        return true;
	      default:
	        return false;
	    }
	  }
	  function getType(checker, node) {
	    if (isJSDocNullableType(node)) {
	      const type = checker.getTypeFromTypeNode(node.type);
	      if (type === checker.getNeverType() || type === checker.getVoidType()) {
	        return type;
	      }
	      return checker.getUnionType(
	        append([type, checker.getUndefinedType()], node.postfix ? void 0 : checker.getNullType())
	      );
	    }
	    return checker.getTypeFromTypeNode(node);
	  }
	  var fixIdPlain, fixIdNullable, errorCodes45;
	  var init_fixJSDocTypes = __esm({
	    "src/services/codefixes/fixJSDocTypes.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      fixIdPlain = "fixJSDocTypes_plain";
	      fixIdNullable = "fixJSDocTypes_nullable";
	      errorCodes45 = [
	        Diagnostics.JSDoc_types_can_only_be_used_inside_documentation_comments.code,
	        Diagnostics._0_at_the_end_of_a_type_is_not_valid_TypeScript_syntax_Did_you_mean_to_write_1.code,
	        Diagnostics._0_at_the_start_of_a_type_is_not_valid_TypeScript_syntax_Did_you_mean_to_write_1.code
	      ];
	      registerCodeFix({
	        errorCodes: errorCodes45,
	        getCodeActions(context) {
	          const { sourceFile } = context;
	          const checker = context.program.getTypeChecker();
	          const info = getInfo15(sourceFile, context.span.start, checker);
	          if (!info)
	            return void 0;
	          const { typeNode, type } = info;
	          const original = typeNode.getText(sourceFile);
	          const actions2 = [fix(type, fixIdPlain, Diagnostics.Change_all_jsdoc_style_types_to_TypeScript)];
	          if (typeNode.kind === 321 /* JSDocNullableType */) {
	            actions2.push(fix(type, fixIdNullable, Diagnostics.Change_all_jsdoc_style_types_to_TypeScript_and_add_undefined_to_nullable_types));
	          }
	          return actions2;
	          function fix(type2, fixId52, fixAllDescription) {
	            const changes = ts_textChanges_exports.ChangeTracker.with(context, (t) => doChange29(t, sourceFile, typeNode, type2, checker));
	            return createCodeFixAction("jdocTypes", changes, [Diagnostics.Change_0_to_1, original, checker.typeToString(type2)], fixId52, fixAllDescription);
	          }
	        },
	        fixIds: [fixIdPlain, fixIdNullable],
	        getAllCodeActions(context) {
	          const { fixId: fixId52, program, sourceFile } = context;
	          const checker = program.getTypeChecker();
	          return codeFixAll(context, errorCodes45, (changes, err) => {
	            const info = getInfo15(err.file, err.start, checker);
	            if (!info)
	              return;
	            const { typeNode, type } = info;
	            const fixedType = typeNode.kind === 321 /* JSDocNullableType */ && fixId52 === fixIdNullable ? checker.getNullableType(type, 32768 /* Undefined */) : type;
	            doChange29(changes, sourceFile, typeNode, fixedType, checker);
	          });
	        }
	      });
	    }
	  });

	  // src/services/codefixes/fixMissingCallParentheses.ts
	  function doChange30(changes, sourceFile, name) {
	    changes.replaceNodeWithText(sourceFile, name, `${name.text}()`);
	  }
	  function getCallName(sourceFile, start) {
	    const token = getTokenAtPosition(sourceFile, start);
	    if (isPropertyAccessExpression(token.parent)) {
	      let current = token.parent;
	      while (isPropertyAccessExpression(current.parent)) {
	        current = current.parent;
	      }
	      return current.name;
	    }
	    if (isIdentifier(token)) {
	      return token;
	    }
	    return void 0;
	  }
	  var fixId35, errorCodes46;
	  var init_fixMissingCallParentheses = __esm({
	    "src/services/codefixes/fixMissingCallParentheses.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      fixId35 = "fixMissingCallParentheses";
	      errorCodes46 = [
	        Diagnostics.This_condition_will_always_return_true_since_this_function_is_always_defined_Did_you_mean_to_call_it_instead.code
	      ];
	      registerCodeFix({
	        errorCodes: errorCodes46,
	        fixIds: [fixId35],
	        getCodeActions(context) {
	          const { sourceFile, span } = context;
	          const callName = getCallName(sourceFile, span.start);
	          if (!callName)
	            return;
	          const changes = ts_textChanges_exports.ChangeTracker.with(context, (t) => doChange30(t, context.sourceFile, callName));
	          return [createCodeFixAction(fixId35, changes, Diagnostics.Add_missing_call_parentheses, fixId35, Diagnostics.Add_all_missing_call_parentheses)];
	        },
	        getAllCodeActions: (context) => codeFixAll(context, errorCodes46, (changes, diag2) => {
	          const callName = getCallName(diag2.file, diag2.start);
	          if (callName)
	            doChange30(changes, diag2.file, callName);
	        })
	      });
	    }
	  });

	  // src/services/codefixes/fixAwaitInSyncFunction.ts
	  function getReturnType(expr) {
	    if (expr.type) {
	      return expr.type;
	    }
	    if (isVariableDeclaration(expr.parent) && expr.parent.type && isFunctionTypeNode(expr.parent.type)) {
	      return expr.parent.type.type;
	    }
	  }
	  function getNodes3(sourceFile, start) {
	    const token = getTokenAtPosition(sourceFile, start);
	    const containingFunction = getContainingFunction(token);
	    if (!containingFunction) {
	      return;
	    }
	    let insertBefore;
	    switch (containingFunction.kind) {
	      case 174 /* MethodDeclaration */:
	        insertBefore = containingFunction.name;
	        break;
	      case 262 /* FunctionDeclaration */:
	      case 218 /* FunctionExpression */:
	        insertBefore = findChildOfKind(containingFunction, 100 /* FunctionKeyword */, sourceFile);
	        break;
	      case 219 /* ArrowFunction */:
	        const kind = containingFunction.typeParameters ? 30 /* LessThanToken */ : 21 /* OpenParenToken */;
	        insertBefore = findChildOfKind(containingFunction, kind, sourceFile) || first(containingFunction.parameters);
	        break;
	      default:
	        return;
	    }
	    return insertBefore && {
	      insertBefore,
	      returnType: getReturnType(containingFunction)
	    };
	  }
	  function doChange31(changes, sourceFile, { insertBefore, returnType }) {
	    if (returnType) {
	      const entityName = getEntityNameFromTypeNode(returnType);
	      if (!entityName || entityName.kind !== 80 /* Identifier */ || entityName.text !== "Promise") {
	        changes.replaceNode(sourceFile, returnType, factory.createTypeReferenceNode("Promise", factory.createNodeArray([returnType])));
	      }
	    }
	    changes.insertModifierBefore(sourceFile, 134 /* AsyncKeyword */, insertBefore);
	  }
	  var fixId36, errorCodes47;
	  var init_fixAwaitInSyncFunction = __esm({
	    "src/services/codefixes/fixAwaitInSyncFunction.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      fixId36 = "fixAwaitInSyncFunction";
	      errorCodes47 = [
	        Diagnostics.await_expressions_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules.code,
	        Diagnostics.await_using_statements_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules.code,
	        Diagnostics.for_await_loops_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules.code,
	        Diagnostics.Cannot_find_name_0_Did_you_mean_to_write_this_in_an_async_function.code
	      ];
	      registerCodeFix({
	        errorCodes: errorCodes47,
	        getCodeActions(context) {
	          const { sourceFile, span } = context;
	          const nodes = getNodes3(sourceFile, span.start);
	          if (!nodes)
	            return void 0;
	          const changes = ts_textChanges_exports.ChangeTracker.with(context, (t) => doChange31(t, sourceFile, nodes));
	          return [createCodeFixAction(fixId36, changes, Diagnostics.Add_async_modifier_to_containing_function, fixId36, Diagnostics.Add_all_missing_async_modifiers)];
	        },
	        fixIds: [fixId36],
	        getAllCodeActions: function getAllCodeActionsToFixAwaitInSyncFunction(context) {
	          const seen = /* @__PURE__ */ new Map();
	          return codeFixAll(context, errorCodes47, (changes, diag2) => {
	            const nodes = getNodes3(diag2.file, diag2.start);
	            if (!nodes || !addToSeen(seen, getNodeId(nodes.insertBefore)))
	              return;
	            doChange31(changes, context.sourceFile, nodes);
	          });
	        }
	      });
	    }
	  });

	  // src/services/codefixes/fixPropertyOverrideAccessor.ts
	  function doChange32(file, start, length2, code, context) {
	    let startPosition;
	    let endPosition;
	    if (code === Diagnostics._0_is_defined_as_an_accessor_in_class_1_but_is_overridden_here_in_2_as_an_instance_property.code) {
	      startPosition = start;
	      endPosition = start + length2;
	    } else if (code === Diagnostics._0_is_defined_as_a_property_in_class_1_but_is_overridden_here_in_2_as_an_accessor.code) {
	      const checker = context.program.getTypeChecker();
	      const node = getTokenAtPosition(file, start).parent;
	      Debug.assert(isAccessor(node), "error span of fixPropertyOverrideAccessor should only be on an accessor");
	      const containingClass = node.parent;
	      Debug.assert(isClassLike(containingClass), "erroneous accessors should only be inside classes");
	      const base = singleOrUndefined(getAllSupers(containingClass, checker));
	      if (!base)
	        return [];
	      const name = unescapeLeadingUnderscores(getTextOfPropertyName(node.name));
	      const baseProp = checker.getPropertyOfType(checker.getTypeAtLocation(base), name);
	      if (!baseProp || !baseProp.valueDeclaration)
	        return [];
	      startPosition = baseProp.valueDeclaration.pos;
	      endPosition = baseProp.valueDeclaration.end;
	      file = getSourceFileOfNode(baseProp.valueDeclaration);
	    } else {
	      Debug.fail("fixPropertyOverrideAccessor codefix got unexpected error code " + code);
	    }
	    return generateAccessorFromProperty(file, context.program, startPosition, endPosition, context, Diagnostics.Generate_get_and_set_accessors.message);
	  }
	  var errorCodes48, fixId37;
	  var init_fixPropertyOverrideAccessor = __esm({
	    "src/services/codefixes/fixPropertyOverrideAccessor.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      errorCodes48 = [
	        Diagnostics._0_is_defined_as_an_accessor_in_class_1_but_is_overridden_here_in_2_as_an_instance_property.code,
	        Diagnostics._0_is_defined_as_a_property_in_class_1_but_is_overridden_here_in_2_as_an_accessor.code
	      ];
	      fixId37 = "fixPropertyOverrideAccessor";
	      registerCodeFix({
	        errorCodes: errorCodes48,
	        getCodeActions(context) {
	          const edits = doChange32(context.sourceFile, context.span.start, context.span.length, context.errorCode, context);
	          if (edits) {
	            return [createCodeFixAction(fixId37, edits, Diagnostics.Generate_get_and_set_accessors, fixId37, Diagnostics.Generate_get_and_set_accessors_for_all_overriding_properties)];
	          }
	        },
	        fixIds: [fixId37],
	        getAllCodeActions: (context) => codeFixAll(context, errorCodes48, (changes, diag2) => {
	          const edits = doChange32(diag2.file, diag2.start, diag2.length, diag2.code, context);
	          if (edits) {
	            for (const edit of edits) {
	              changes.pushRaw(context.sourceFile, edit);
	            }
	          }
	        })
	      });
	    }
	  });

	  // src/services/codefixes/inferFromUsage.ts
	  function getDiagnostic(errorCode, token) {
	    switch (errorCode) {
	      case Diagnostics.Parameter_0_implicitly_has_an_1_type.code:
	      case Diagnostics.Parameter_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage.code:
	        return isSetAccessorDeclaration(getContainingFunction(token)) ? Diagnostics.Infer_type_of_0_from_usage : Diagnostics.Infer_parameter_types_from_usage;
	      case Diagnostics.Rest_parameter_0_implicitly_has_an_any_type.code:
	      case Diagnostics.Rest_parameter_0_implicitly_has_an_any_type_but_a_better_type_may_be_inferred_from_usage.code:
	        return Diagnostics.Infer_parameter_types_from_usage;
	      case Diagnostics.this_implicitly_has_type_any_because_it_does_not_have_a_type_annotation.code:
	        return Diagnostics.Infer_this_type_of_0_from_usage;
	      default:
	        return Diagnostics.Infer_type_of_0_from_usage;
	    }
	  }
	  function mapSuggestionDiagnostic(errorCode) {
	    switch (errorCode) {
	      case Diagnostics.Variable_0_implicitly_has_type_1_in_some_locations_but_a_better_type_may_be_inferred_from_usage.code:
	        return Diagnostics.Variable_0_implicitly_has_type_1_in_some_locations_where_its_type_cannot_be_determined.code;
	      case Diagnostics.Variable_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage.code:
	        return Diagnostics.Variable_0_implicitly_has_an_1_type.code;
	      case Diagnostics.Parameter_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage.code:
	        return Diagnostics.Parameter_0_implicitly_has_an_1_type.code;
	      case Diagnostics.Rest_parameter_0_implicitly_has_an_any_type_but_a_better_type_may_be_inferred_from_usage.code:
	        return Diagnostics.Rest_parameter_0_implicitly_has_an_any_type.code;
	      case Diagnostics.Property_0_implicitly_has_type_any_but_a_better_type_for_its_get_accessor_may_be_inferred_from_usage.code:
	        return Diagnostics.Property_0_implicitly_has_type_any_because_its_get_accessor_lacks_a_return_type_annotation.code;
	      case Diagnostics._0_implicitly_has_an_1_return_type_but_a_better_type_may_be_inferred_from_usage.code:
	        return Diagnostics._0_which_lacks_return_type_annotation_implicitly_has_an_1_return_type.code;
	      case Diagnostics.Property_0_implicitly_has_type_any_but_a_better_type_for_its_set_accessor_may_be_inferred_from_usage.code:
	        return Diagnostics.Property_0_implicitly_has_type_any_because_its_set_accessor_lacks_a_parameter_type_annotation.code;
	      case Diagnostics.Member_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage.code:
	        return Diagnostics.Member_0_implicitly_has_an_1_type.code;
	    }
	    return errorCode;
	  }
	  function doChange33(changes, sourceFile, token, errorCode, program, cancellationToken, markSeen, host, preferences) {
	    if (!isParameterPropertyModifier(token.kind) && token.kind !== 80 /* Identifier */ && token.kind !== 26 /* DotDotDotToken */ && token.kind !== 110 /* ThisKeyword */) {
	      return void 0;
	    }
	    const { parent: parent2 } = token;
	    const importAdder = createImportAdder(sourceFile, program, preferences, host);
	    errorCode = mapSuggestionDiagnostic(errorCode);
	    switch (errorCode) {
	      case Diagnostics.Member_0_implicitly_has_an_1_type.code:
	      case Diagnostics.Variable_0_implicitly_has_type_1_in_some_locations_where_its_type_cannot_be_determined.code:
	        if (isVariableDeclaration(parent2) && markSeen(parent2) || isPropertyDeclaration(parent2) || isPropertySignature(parent2)) {
	          annotateVariableDeclaration(changes, importAdder, sourceFile, parent2, program, host, cancellationToken);
	          importAdder.writeFixes(changes);
	          return parent2;
	        }
	        if (isPropertyAccessExpression(parent2)) {
	          const type = inferTypeForVariableFromUsage(parent2.name, program, cancellationToken);
	          const typeNode = getTypeNodeIfAccessible(type, parent2, program, host);
	          if (typeNode) {
	            const typeTag = factory.createJSDocTypeTag(
	              /*tagName*/
	              void 0,
	              factory.createJSDocTypeExpression(typeNode),
	              /*comment*/
	              void 0
	            );
	            changes.addJSDocTags(sourceFile, cast(parent2.parent.parent, isExpressionStatement), [typeTag]);
	          }
	          importAdder.writeFixes(changes);
	          return parent2;
	        }
	        return void 0;
	      case Diagnostics.Variable_0_implicitly_has_an_1_type.code: {
	        const symbol = program.getTypeChecker().getSymbolAtLocation(token);
	        if (symbol && symbol.valueDeclaration && isVariableDeclaration(symbol.valueDeclaration) && markSeen(symbol.valueDeclaration)) {
	          annotateVariableDeclaration(changes, importAdder, getSourceFileOfNode(symbol.valueDeclaration), symbol.valueDeclaration, program, host, cancellationToken);
	          importAdder.writeFixes(changes);
	          return symbol.valueDeclaration;
	        }
	        return void 0;
	      }
	    }
	    const containingFunction = getContainingFunction(token);
	    if (containingFunction === void 0) {
	      return void 0;
	    }
	    let declaration;
	    switch (errorCode) {
	      case Diagnostics.Parameter_0_implicitly_has_an_1_type.code:
	        if (isSetAccessorDeclaration(containingFunction)) {
	          annotateSetAccessor(changes, importAdder, sourceFile, containingFunction, program, host, cancellationToken);
	          declaration = containingFunction;
	          break;
	        }
	      case Diagnostics.Rest_parameter_0_implicitly_has_an_any_type.code:
	        if (markSeen(containingFunction)) {
	          const param = cast(parent2, isParameter);
	          annotateParameters(changes, importAdder, sourceFile, param, containingFunction, program, host, cancellationToken);
	          declaration = param;
	        }
	        break;
	      case Diagnostics.Property_0_implicitly_has_type_any_because_its_get_accessor_lacks_a_return_type_annotation.code:
	      case Diagnostics._0_which_lacks_return_type_annotation_implicitly_has_an_1_return_type.code:
	        if (isGetAccessorDeclaration(containingFunction) && isIdentifier(containingFunction.name)) {
	          annotate(changes, importAdder, sourceFile, containingFunction, inferTypeForVariableFromUsage(containingFunction.name, program, cancellationToken), program, host);
	          declaration = containingFunction;
	        }
	        break;
	      case Diagnostics.Property_0_implicitly_has_type_any_because_its_set_accessor_lacks_a_parameter_type_annotation.code:
	        if (isSetAccessorDeclaration(containingFunction)) {
	          annotateSetAccessor(changes, importAdder, sourceFile, containingFunction, program, host, cancellationToken);
	          declaration = containingFunction;
	        }
	        break;
	      case Diagnostics.this_implicitly_has_type_any_because_it_does_not_have_a_type_annotation.code:
	        if (ts_textChanges_exports.isThisTypeAnnotatable(containingFunction) && markSeen(containingFunction)) {
	          annotateThis(changes, sourceFile, containingFunction, program, host, cancellationToken);
	          declaration = containingFunction;
	        }
	        break;
	      default:
	        return Debug.fail(String(errorCode));
	    }
	    importAdder.writeFixes(changes);
	    return declaration;
	  }
	  function annotateVariableDeclaration(changes, importAdder, sourceFile, declaration, program, host, cancellationToken) {
	    if (isIdentifier(declaration.name)) {
	      annotate(changes, importAdder, sourceFile, declaration, inferTypeForVariableFromUsage(declaration.name, program, cancellationToken), program, host);
	    }
	  }
	  function annotateParameters(changes, importAdder, sourceFile, parameterDeclaration, containingFunction, program, host, cancellationToken) {
	    if (!isIdentifier(parameterDeclaration.name)) {
	      return;
	    }
	    const parameterInferences = inferTypeForParametersFromUsage(containingFunction, sourceFile, program, cancellationToken);
	    Debug.assert(containingFunction.parameters.length === parameterInferences.length, "Parameter count and inference count should match");
	    if (isInJSFile(containingFunction)) {
	      annotateJSDocParameters(changes, sourceFile, parameterInferences, program, host);
	    } else {
	      const needParens = isArrowFunction(containingFunction) && !findChildOfKind(containingFunction, 21 /* OpenParenToken */, sourceFile);
	      if (needParens)
	        changes.insertNodeBefore(sourceFile, first(containingFunction.parameters), factory.createToken(21 /* OpenParenToken */));
	      for (const { declaration, type } of parameterInferences) {
	        if (declaration && !declaration.type && !declaration.initializer) {
	          annotate(changes, importAdder, sourceFile, declaration, type, program, host);
	        }
	      }
	      if (needParens)
	        changes.insertNodeAfter(sourceFile, last(containingFunction.parameters), factory.createToken(22 /* CloseParenToken */));
	    }
	  }
	  function annotateThis(changes, sourceFile, containingFunction, program, host, cancellationToken) {
	    const references = getFunctionReferences(containingFunction, sourceFile, program, cancellationToken);
	    if (!references || !references.length) {
	      return;
	    }
	    const thisInference = inferTypeFromReferences(program, references, cancellationToken).thisParameter();
	    const typeNode = getTypeNodeIfAccessible(thisInference, containingFunction, program, host);
	    if (!typeNode) {
	      return;
	    }
	    if (isInJSFile(containingFunction)) {
	      annotateJSDocThis(changes, sourceFile, containingFunction, typeNode);
	    } else {
	      changes.tryInsertThisTypeAnnotation(sourceFile, containingFunction, typeNode);
	    }
	  }
	  function annotateJSDocThis(changes, sourceFile, containingFunction, typeNode) {
	    changes.addJSDocTags(sourceFile, containingFunction, [
	      factory.createJSDocThisTag(
	        /*tagName*/
	        void 0,
	        factory.createJSDocTypeExpression(typeNode)
	      )
	    ]);
	  }
	  function annotateSetAccessor(changes, importAdder, sourceFile, setAccessorDeclaration, program, host, cancellationToken) {
	    const param = firstOrUndefined(setAccessorDeclaration.parameters);
	    if (param && isIdentifier(setAccessorDeclaration.name) && isIdentifier(param.name)) {
	      let type = inferTypeForVariableFromUsage(setAccessorDeclaration.name, program, cancellationToken);
	      if (type === program.getTypeChecker().getAnyType()) {
	        type = inferTypeForVariableFromUsage(param.name, program, cancellationToken);
	      }
	      if (isInJSFile(setAccessorDeclaration)) {
	        annotateJSDocParameters(changes, sourceFile, [{ declaration: param, type }], program, host);
	      } else {
	        annotate(changes, importAdder, sourceFile, param, type, program, host);
	      }
	    }
	  }
	  function annotate(changes, importAdder, sourceFile, declaration, type, program, host) {
	    const typeNode = getTypeNodeIfAccessible(type, declaration, program, host);
	    if (typeNode) {
	      if (isInJSFile(sourceFile) && declaration.kind !== 171 /* PropertySignature */) {
	        const parent2 = isVariableDeclaration(declaration) ? tryCast(declaration.parent.parent, isVariableStatement) : declaration;
	        if (!parent2) {
	          return;
	        }
	        const typeExpression = factory.createJSDocTypeExpression(typeNode);
	        const typeTag = isGetAccessorDeclaration(declaration) ? factory.createJSDocReturnTag(
	          /*tagName*/
	          void 0,
	          typeExpression,
	          /*comment*/
	          void 0
	        ) : factory.createJSDocTypeTag(
	          /*tagName*/
	          void 0,
	          typeExpression,
	          /*comment*/
	          void 0
	        );
	        changes.addJSDocTags(sourceFile, parent2, [typeTag]);
	      } else if (!tryReplaceImportTypeNodeWithAutoImport(typeNode, declaration, sourceFile, changes, importAdder, getEmitScriptTarget(program.getCompilerOptions()))) {
	        changes.tryInsertTypeAnnotation(sourceFile, declaration, typeNode);
	      }
	    }
	  }
	  function tryReplaceImportTypeNodeWithAutoImport(typeNode, declaration, sourceFile, changes, importAdder, scriptTarget) {
	    const importableReference = tryGetAutoImportableReferenceFromTypeNode(typeNode, scriptTarget);
	    if (importableReference && changes.tryInsertTypeAnnotation(sourceFile, declaration, importableReference.typeNode)) {
	      forEach(importableReference.symbols, (s) => importAdder.addImportFromExportedSymbol(
	        s,
	        /*isValidTypeOnlyUseSite*/
	        true
	      ));
	      return true;
	    }
	    return false;
	  }
	  function annotateJSDocParameters(changes, sourceFile, parameterInferences, program, host) {
	    const signature = parameterInferences.length && parameterInferences[0].declaration.parent;
	    if (!signature) {
	      return;
	    }
	    const inferences = mapDefined(parameterInferences, (inference) => {
	      const param = inference.declaration;
	      if (param.initializer || getJSDocType(param) || !isIdentifier(param.name)) {
	        return;
	      }
	      const typeNode = inference.type && getTypeNodeIfAccessible(inference.type, param, program, host);
	      if (typeNode) {
	        const name = factory.cloneNode(param.name);
	        setEmitFlags(name, 3072 /* NoComments */ | 4096 /* NoNestedComments */);
	        return { name: factory.cloneNode(param.name), param, isOptional: !!inference.isOptional, typeNode };
	      }
	    });
	    if (!inferences.length) {
	      return;
	    }
	    if (isArrowFunction(signature) || isFunctionExpression(signature)) {
	      const needParens = isArrowFunction(signature) && !findChildOfKind(signature, 21 /* OpenParenToken */, sourceFile);
	      if (needParens) {
	        changes.insertNodeBefore(sourceFile, first(signature.parameters), factory.createToken(21 /* OpenParenToken */));
	      }
	      forEach(inferences, ({ typeNode, param }) => {
	        const typeTag = factory.createJSDocTypeTag(
	          /*tagName*/
	          void 0,
	          factory.createJSDocTypeExpression(typeNode)
	        );
	        const jsDoc = factory.createJSDocComment(
	          /*comment*/
	          void 0,
	          [typeTag]
	        );
	        changes.insertNodeAt(sourceFile, param.getStart(sourceFile), jsDoc, { suffix: " " });
	      });
	      if (needParens) {
	        changes.insertNodeAfter(sourceFile, last(signature.parameters), factory.createToken(22 /* CloseParenToken */));
	      }
	    } else {
	      const paramTags = map(inferences, ({ name, typeNode, isOptional }) => factory.createJSDocParameterTag(
	        /*tagName*/
	        void 0,
	        name,
	        /*isBracketed*/
	        !!isOptional,
	        factory.createJSDocTypeExpression(typeNode),
	        /*isNameFirst*/
	        false,
	        /*comment*/
	        void 0
	      ));
	      changes.addJSDocTags(sourceFile, signature, paramTags);
	    }
	  }
	  function getReferences(token, program, cancellationToken) {
	    return mapDefined(ts_FindAllReferences_exports.getReferenceEntriesForNode(-1, token, program, program.getSourceFiles(), cancellationToken), (entry) => entry.kind !== ts_FindAllReferences_exports.EntryKind.Span ? tryCast(entry.node, isIdentifier) : void 0);
	  }
	  function inferTypeForVariableFromUsage(token, program, cancellationToken) {
	    const references = getReferences(token, program, cancellationToken);
	    return inferTypeFromReferences(program, references, cancellationToken).single();
	  }
	  function inferTypeForParametersFromUsage(func, sourceFile, program, cancellationToken) {
	    const references = getFunctionReferences(func, sourceFile, program, cancellationToken);
	    return references && inferTypeFromReferences(program, references, cancellationToken).parameters(func) || func.parameters.map((p) => ({
	      declaration: p,
	      type: isIdentifier(p.name) ? inferTypeForVariableFromUsage(p.name, program, cancellationToken) : program.getTypeChecker().getAnyType()
	    }));
	  }
	  function getFunctionReferences(containingFunction, sourceFile, program, cancellationToken) {
	    let searchToken;
	    switch (containingFunction.kind) {
	      case 176 /* Constructor */:
	        searchToken = findChildOfKind(containingFunction, 137 /* ConstructorKeyword */, sourceFile);
	        break;
	      case 219 /* ArrowFunction */:
	      case 218 /* FunctionExpression */:
	        const parent2 = containingFunction.parent;
	        searchToken = (isVariableDeclaration(parent2) || isPropertyDeclaration(parent2)) && isIdentifier(parent2.name) ? parent2.name : containingFunction.name;
	        break;
	      case 262 /* FunctionDeclaration */:
	      case 174 /* MethodDeclaration */:
	      case 173 /* MethodSignature */:
	        searchToken = containingFunction.name;
	        break;
	    }
	    if (!searchToken) {
	      return void 0;
	    }
	    return getReferences(searchToken, program, cancellationToken);
	  }
	  function inferTypeFromReferences(program, references, cancellationToken) {
	    const checker = program.getTypeChecker();
	    const builtinConstructors = {
	      string: () => checker.getStringType(),
	      number: () => checker.getNumberType(),
	      Array: (t) => checker.createArrayType(t),
	      Promise: (t) => checker.createPromiseType(t)
	    };
	    const builtins = [
	      checker.getStringType(),
	      checker.getNumberType(),
	      checker.createArrayType(checker.getAnyType()),
	      checker.createPromiseType(checker.getAnyType())
	    ];
	    return {
	      single: single2,
	      parameters,
	      thisParameter
	    };
	    function createEmptyUsage() {
	      return {
	        isNumber: void 0,
	        isString: void 0,
	        isNumberOrString: void 0,
	        candidateTypes: void 0,
	        properties: void 0,
	        calls: void 0,
	        constructs: void 0,
	        numberIndex: void 0,
	        stringIndex: void 0,
	        candidateThisTypes: void 0,
	        inferredTypes: void 0
	      };
	    }
	    function combineUsages(usages) {
	      const combinedProperties = /* @__PURE__ */ new Map();
	      for (const u of usages) {
	        if (u.properties) {
	          u.properties.forEach((p, name) => {
	            if (!combinedProperties.has(name)) {
	              combinedProperties.set(name, []);
	            }
	            combinedProperties.get(name).push(p);
	          });
	        }
	      }
	      const properties = /* @__PURE__ */ new Map();
	      combinedProperties.forEach((ps, name) => {
	        properties.set(name, combineUsages(ps));
	      });
	      return {
	        isNumber: usages.some((u) => u.isNumber),
	        isString: usages.some((u) => u.isString),
	        isNumberOrString: usages.some((u) => u.isNumberOrString),
	        candidateTypes: flatMap(usages, (u) => u.candidateTypes),
	        properties,
	        calls: flatMap(usages, (u) => u.calls),
	        constructs: flatMap(usages, (u) => u.constructs),
	        numberIndex: forEach(usages, (u) => u.numberIndex),
	        stringIndex: forEach(usages, (u) => u.stringIndex),
	        candidateThisTypes: flatMap(usages, (u) => u.candidateThisTypes),
	        inferredTypes: void 0
	        // clear type cache
	      };
	    }
	    function single2() {
	      return combineTypes(inferTypesFromReferencesSingle(references));
	    }
	    function parameters(declaration) {
	      if (references.length === 0 || !declaration.parameters) {
	        return void 0;
	      }
	      const usage = createEmptyUsage();
	      for (const reference of references) {
	        cancellationToken.throwIfCancellationRequested();
	        calculateUsageOfNode(reference, usage);
	      }
	      const calls = [...usage.constructs || [], ...usage.calls || []];
	      return declaration.parameters.map((parameter, parameterIndex) => {
	        const types = [];
	        const isRest = isRestParameter(parameter);
	        let isOptional = false;
	        for (const call of calls) {
	          if (call.argumentTypes.length <= parameterIndex) {
	            isOptional = isInJSFile(declaration);
	            types.push(checker.getUndefinedType());
	          } else if (isRest) {
	            for (let i = parameterIndex; i < call.argumentTypes.length; i++) {
	              types.push(checker.getBaseTypeOfLiteralType(call.argumentTypes[i]));
	            }
	          } else {
	            types.push(checker.getBaseTypeOfLiteralType(call.argumentTypes[parameterIndex]));
	          }
	        }
	        if (isIdentifier(parameter.name)) {
	          const inferred = inferTypesFromReferencesSingle(getReferences(parameter.name, program, cancellationToken));
	          types.push(...isRest ? mapDefined(inferred, checker.getElementTypeOfArrayType) : inferred);
	        }
	        const type = combineTypes(types);
	        return {
	          type: isRest ? checker.createArrayType(type) : type,
	          isOptional: isOptional && !isRest,
	          declaration: parameter
	        };
	      });
	    }
	    function thisParameter() {
	      const usage = createEmptyUsage();
	      for (const reference of references) {
	        cancellationToken.throwIfCancellationRequested();
	        calculateUsageOfNode(reference, usage);
	      }
	      return combineTypes(usage.candidateThisTypes || emptyArray);
	    }
	    function inferTypesFromReferencesSingle(references2) {
	      const usage = createEmptyUsage();
	      for (const reference of references2) {
	        cancellationToken.throwIfCancellationRequested();
	        calculateUsageOfNode(reference, usage);
	      }
	      return inferTypes(usage);
	    }
	    function calculateUsageOfNode(node, usage) {
	      while (isRightSideOfQualifiedNameOrPropertyAccess(node)) {
	        node = node.parent;
	      }
	      switch (node.parent.kind) {
	        case 244 /* ExpressionStatement */:
	          inferTypeFromExpressionStatement(node, usage);
	          break;
	        case 225 /* PostfixUnaryExpression */:
	          usage.isNumber = true;
	          break;
	        case 224 /* PrefixUnaryExpression */:
	          inferTypeFromPrefixUnaryExpression(node.parent, usage);
	          break;
	        case 226 /* BinaryExpression */:
	          inferTypeFromBinaryExpression(node, node.parent, usage);
	          break;
	        case 296 /* CaseClause */:
	        case 297 /* DefaultClause */:
	          inferTypeFromSwitchStatementLabel(node.parent, usage);
	          break;
	        case 213 /* CallExpression */:
	        case 214 /* NewExpression */:
	          if (node.parent.expression === node) {
	            inferTypeFromCallExpression(node.parent, usage);
	          } else {
	            inferTypeFromContextualType(node, usage);
	          }
	          break;
	        case 211 /* PropertyAccessExpression */:
	          inferTypeFromPropertyAccessExpression(node.parent, usage);
	          break;
	        case 212 /* ElementAccessExpression */:
	          inferTypeFromPropertyElementExpression(node.parent, node, usage);
	          break;
	        case 303 /* PropertyAssignment */:
	        case 304 /* ShorthandPropertyAssignment */:
	          inferTypeFromPropertyAssignment(node.parent, usage);
	          break;
	        case 172 /* PropertyDeclaration */:
	          inferTypeFromPropertyDeclaration(node.parent, usage);
	          break;
	        case 260 /* VariableDeclaration */: {
	          const { name, initializer } = node.parent;
	          if (node === name) {
	            if (initializer) {
	              addCandidateType(usage, checker.getTypeAtLocation(initializer));
	            }
	            break;
	          }
	        }
	        default:
	          return inferTypeFromContextualType(node, usage);
	      }
	    }
	    function inferTypeFromContextualType(node, usage) {
	      if (isExpressionNode(node)) {
	        addCandidateType(usage, checker.getContextualType(node));
	      }
	    }
	    function inferTypeFromExpressionStatement(node, usage) {
	      addCandidateType(usage, isCallExpression(node) ? checker.getVoidType() : checker.getAnyType());
	    }
	    function inferTypeFromPrefixUnaryExpression(node, usage) {
	      switch (node.operator) {
	        case 46 /* PlusPlusToken */:
	        case 47 /* MinusMinusToken */:
	        case 41 /* MinusToken */:
	        case 55 /* TildeToken */:
	          usage.isNumber = true;
	          break;
	        case 40 /* PlusToken */:
	          usage.isNumberOrString = true;
	          break;
	      }
	    }
	    function inferTypeFromBinaryExpression(node, parent2, usage) {
	      switch (parent2.operatorToken.kind) {
	        case 43 /* AsteriskAsteriskToken */:
	        case 42 /* AsteriskToken */:
	        case 44 /* SlashToken */:
	        case 45 /* PercentToken */:
	        case 48 /* LessThanLessThanToken */:
	        case 49 /* GreaterThanGreaterThanToken */:
	        case 50 /* GreaterThanGreaterThanGreaterThanToken */:
	        case 51 /* AmpersandToken */:
	        case 52 /* BarToken */:
	        case 53 /* CaretToken */:
	        case 66 /* MinusEqualsToken */:
	        case 68 /* AsteriskAsteriskEqualsToken */:
	        case 67 /* AsteriskEqualsToken */:
	        case 69 /* SlashEqualsToken */:
	        case 70 /* PercentEqualsToken */:
	        case 74 /* AmpersandEqualsToken */:
	        case 75 /* BarEqualsToken */:
	        case 79 /* CaretEqualsToken */:
	        case 71 /* LessThanLessThanEqualsToken */:
	        case 73 /* GreaterThanGreaterThanGreaterThanEqualsToken */:
	        case 72 /* GreaterThanGreaterThanEqualsToken */:
	        case 41 /* MinusToken */:
	        case 30 /* LessThanToken */:
	        case 33 /* LessThanEqualsToken */:
	        case 32 /* GreaterThanToken */:
	        case 34 /* GreaterThanEqualsToken */:
	          const operandType = checker.getTypeAtLocation(parent2.left === node ? parent2.right : parent2.left);
	          if (operandType.flags & 1056 /* EnumLike */) {
	            addCandidateType(usage, operandType);
	          } else {
	            usage.isNumber = true;
	          }
	          break;
	        case 65 /* PlusEqualsToken */:
	        case 40 /* PlusToken */:
	          const otherOperandType = checker.getTypeAtLocation(parent2.left === node ? parent2.right : parent2.left);
	          if (otherOperandType.flags & 1056 /* EnumLike */) {
	            addCandidateType(usage, otherOperandType);
	          } else if (otherOperandType.flags & 296 /* NumberLike */) {
	            usage.isNumber = true;
	          } else if (otherOperandType.flags & 402653316 /* StringLike */) {
	            usage.isString = true;
	          } else if (otherOperandType.flags & 1 /* Any */) ; else {
	            usage.isNumberOrString = true;
	          }
	          break;
	        case 64 /* EqualsToken */:
	        case 35 /* EqualsEqualsToken */:
	        case 37 /* EqualsEqualsEqualsToken */:
	        case 38 /* ExclamationEqualsEqualsToken */:
	        case 36 /* ExclamationEqualsToken */:
	        case 77 /* AmpersandAmpersandEqualsToken */:
	        case 78 /* QuestionQuestionEqualsToken */:
	        case 76 /* BarBarEqualsToken */:
	          addCandidateType(usage, checker.getTypeAtLocation(parent2.left === node ? parent2.right : parent2.left));
	          break;
	        case 103 /* InKeyword */:
	          if (node === parent2.left) {
	            usage.isString = true;
	          }
	          break;
	        case 57 /* BarBarToken */:
	        case 61 /* QuestionQuestionToken */:
	          if (node === parent2.left && (node.parent.parent.kind === 260 /* VariableDeclaration */ || isAssignmentExpression(
	            node.parent.parent,
	            /*excludeCompoundAssignment*/
	            true
	          ))) {
	            addCandidateType(usage, checker.getTypeAtLocation(parent2.right));
	          }
	          break;
	      }
	    }
	    function inferTypeFromSwitchStatementLabel(parent2, usage) {
	      addCandidateType(usage, checker.getTypeAtLocation(parent2.parent.parent.expression));
	    }
	    function inferTypeFromCallExpression(parent2, usage) {
	      const call = {
	        argumentTypes: [],
	        return_: createEmptyUsage()
	      };
	      if (parent2.arguments) {
	        for (const argument of parent2.arguments) {
	          call.argumentTypes.push(checker.getTypeAtLocation(argument));
	        }
	      }
	      calculateUsageOfNode(parent2, call.return_);
	      if (parent2.kind === 213 /* CallExpression */) {
	        (usage.calls || (usage.calls = [])).push(call);
	      } else {
	        (usage.constructs || (usage.constructs = [])).push(call);
	      }
	    }
	    function inferTypeFromPropertyAccessExpression(parent2, usage) {
	      const name = escapeLeadingUnderscores(parent2.name.text);
	      if (!usage.properties) {
	        usage.properties = /* @__PURE__ */ new Map();
	      }
	      const propertyUsage = usage.properties.get(name) || createEmptyUsage();
	      calculateUsageOfNode(parent2, propertyUsage);
	      usage.properties.set(name, propertyUsage);
	    }
	    function inferTypeFromPropertyElementExpression(parent2, node, usage) {
	      if (node === parent2.argumentExpression) {
	        usage.isNumberOrString = true;
	        return;
	      } else {
	        const indexType = checker.getTypeAtLocation(parent2.argumentExpression);
	        const indexUsage = createEmptyUsage();
	        calculateUsageOfNode(parent2, indexUsage);
	        if (indexType.flags & 296 /* NumberLike */) {
	          usage.numberIndex = indexUsage;
	        } else {
	          usage.stringIndex = indexUsage;
	        }
	      }
	    }
	    function inferTypeFromPropertyAssignment(assignment, usage) {
	      const nodeWithRealType = isVariableDeclaration(assignment.parent.parent) ? assignment.parent.parent : assignment.parent;
	      addCandidateThisType(usage, checker.getTypeAtLocation(nodeWithRealType));
	    }
	    function inferTypeFromPropertyDeclaration(declaration, usage) {
	      addCandidateThisType(usage, checker.getTypeAtLocation(declaration.parent));
	    }
	    function removeLowPriorityInferences(inferences, priorities) {
	      const toRemove = [];
	      for (const i of inferences) {
	        for (const { high, low } of priorities) {
	          if (high(i)) {
	            Debug.assert(!low(i), "Priority can't have both low and high");
	            toRemove.push(low);
	          }
	        }
	      }
	      return inferences.filter((i) => toRemove.every((f) => !f(i)));
	    }
	    function combineFromUsage(usage) {
	      return combineTypes(inferTypes(usage));
	    }
	    function combineTypes(inferences) {
	      if (!inferences.length)
	        return checker.getAnyType();
	      const stringNumber = checker.getUnionType([checker.getStringType(), checker.getNumberType()]);
	      const priorities = [
	        {
	          high: (t) => t === checker.getStringType() || t === checker.getNumberType(),
	          low: (t) => t === stringNumber
	        },
	        {
	          high: (t) => !(t.flags & (1 /* Any */ | 16384 /* Void */)),
	          low: (t) => !!(t.flags & (1 /* Any */ | 16384 /* Void */))
	        },
	        {
	          high: (t) => !(t.flags & (98304 /* Nullable */ | 1 /* Any */ | 16384 /* Void */)) && !(getObjectFlags(t) & 16 /* Anonymous */),
	          low: (t) => !!(getObjectFlags(t) & 16 /* Anonymous */)
	        }
	      ];
	      let good = removeLowPriorityInferences(inferences, priorities);
	      const anons = good.filter((i) => getObjectFlags(i) & 16 /* Anonymous */);
	      if (anons.length) {
	        good = good.filter((i) => !(getObjectFlags(i) & 16 /* Anonymous */));
	        good.push(combineAnonymousTypes(anons));
	      }
	      return checker.getWidenedType(checker.getUnionType(good.map(checker.getBaseTypeOfLiteralType), 2 /* Subtype */));
	    }
	    function combineAnonymousTypes(anons) {
	      if (anons.length === 1) {
	        return anons[0];
	      }
	      const calls = [];
	      const constructs = [];
	      const stringIndices = [];
	      const numberIndices = [];
	      let stringIndexReadonly = false;
	      let numberIndexReadonly = false;
	      const props = createMultiMap();
	      for (const anon2 of anons) {
	        for (const p of checker.getPropertiesOfType(anon2)) {
	          props.add(p.escapedName, p.valueDeclaration ? checker.getTypeOfSymbolAtLocation(p, p.valueDeclaration) : checker.getAnyType());
	        }
	        calls.push(...checker.getSignaturesOfType(anon2, 0 /* Call */));
	        constructs.push(...checker.getSignaturesOfType(anon2, 1 /* Construct */));
	        const stringIndexInfo = checker.getIndexInfoOfType(anon2, 0 /* String */);
	        if (stringIndexInfo) {
	          stringIndices.push(stringIndexInfo.type);
	          stringIndexReadonly = stringIndexReadonly || stringIndexInfo.isReadonly;
	        }
	        const numberIndexInfo = checker.getIndexInfoOfType(anon2, 1 /* Number */);
	        if (numberIndexInfo) {
	          numberIndices.push(numberIndexInfo.type);
	          numberIndexReadonly = numberIndexReadonly || numberIndexInfo.isReadonly;
	        }
	      }
	      const members = mapEntries(props, (name, types) => {
	        const isOptional = types.length < anons.length ? 16777216 /* Optional */ : 0;
	        const s = checker.createSymbol(4 /* Property */ | isOptional, name);
	        s.links.type = checker.getUnionType(types);
	        return [name, s];
	      });
	      const indexInfos = [];
	      if (stringIndices.length)
	        indexInfos.push(checker.createIndexInfo(checker.getStringType(), checker.getUnionType(stringIndices), stringIndexReadonly));
	      if (numberIndices.length)
	        indexInfos.push(checker.createIndexInfo(checker.getNumberType(), checker.getUnionType(numberIndices), numberIndexReadonly));
	      return checker.createAnonymousType(
	        anons[0].symbol,
	        members,
	        calls,
	        constructs,
	        indexInfos
	      );
	    }
	    function inferTypes(usage) {
	      var _a, _b, _c;
	      const types = [];
	      if (usage.isNumber) {
	        types.push(checker.getNumberType());
	      }
	      if (usage.isString) {
	        types.push(checker.getStringType());
	      }
	      if (usage.isNumberOrString) {
	        types.push(checker.getUnionType([checker.getStringType(), checker.getNumberType()]));
	      }
	      if (usage.numberIndex) {
	        types.push(checker.createArrayType(combineFromUsage(usage.numberIndex)));
	      }
	      if (((_a = usage.properties) == null ? void 0 : _a.size) || ((_b = usage.constructs) == null ? void 0 : _b.length) || usage.stringIndex) {
	        types.push(inferStructuralType(usage));
	      }
	      const candidateTypes = (usage.candidateTypes || []).map((t) => checker.getBaseTypeOfLiteralType(t));
	      const callsType = ((_c = usage.calls) == null ? void 0 : _c.length) ? inferStructuralType(usage) : void 0;
	      if (callsType && candidateTypes) {
	        types.push(checker.getUnionType([callsType, ...candidateTypes], 2 /* Subtype */));
	      } else {
	        if (callsType) {
	          types.push(callsType);
	        }
	        if (length(candidateTypes)) {
	          types.push(...candidateTypes);
	        }
	      }
	      types.push(...inferNamedTypesFromProperties(usage));
	      return types;
	    }
	    function inferStructuralType(usage) {
	      const members = /* @__PURE__ */ new Map();
	      if (usage.properties) {
	        usage.properties.forEach((u, name) => {
	          const symbol = checker.createSymbol(4 /* Property */, name);
	          symbol.links.type = combineFromUsage(u);
	          members.set(name, symbol);
	        });
	      }
	      const callSignatures = usage.calls ? [getSignatureFromCalls(usage.calls)] : [];
	      const constructSignatures = usage.constructs ? [getSignatureFromCalls(usage.constructs)] : [];
	      const indexInfos = usage.stringIndex ? [checker.createIndexInfo(
	        checker.getStringType(),
	        combineFromUsage(usage.stringIndex),
	        /*isReadonly*/
	        false
	      )] : [];
	      return checker.createAnonymousType(
	        /*symbol*/
	        void 0,
	        members,
	        callSignatures,
	        constructSignatures,
	        indexInfos
	      );
	    }
	    function inferNamedTypesFromProperties(usage) {
	      if (!usage.properties || !usage.properties.size)
	        return [];
	      const types = builtins.filter((t) => allPropertiesAreAssignableToUsage(t, usage));
	      if (0 < types.length && types.length < 3) {
	        return types.map((t) => inferInstantiationFromUsage(t, usage));
	      }
	      return [];
	    }
	    function allPropertiesAreAssignableToUsage(type, usage) {
	      if (!usage.properties)
	        return false;
	      return !forEachEntry(usage.properties, (propUsage, name) => {
	        const source = checker.getTypeOfPropertyOfType(type, name);
	        if (!source) {
	          return true;
	        }
	        if (propUsage.calls) {
	          const sigs = checker.getSignaturesOfType(source, 0 /* Call */);
	          return !sigs.length || !checker.isTypeAssignableTo(source, getFunctionFromCalls(propUsage.calls));
	        } else {
	          return !checker.isTypeAssignableTo(source, combineFromUsage(propUsage));
	        }
	      });
	    }
	    function inferInstantiationFromUsage(type, usage) {
	      if (!(getObjectFlags(type) & 4 /* Reference */) || !usage.properties) {
	        return type;
	      }
	      const generic = type.target;
	      const singleTypeParameter = singleOrUndefined(generic.typeParameters);
	      if (!singleTypeParameter)
	        return type;
	      const types = [];
	      usage.properties.forEach((propUsage, name) => {
	        const genericPropertyType = checker.getTypeOfPropertyOfType(generic, name);
	        Debug.assert(!!genericPropertyType, "generic should have all the properties of its reference.");
	        types.push(...inferTypeParameters(genericPropertyType, combineFromUsage(propUsage), singleTypeParameter));
	      });
	      return builtinConstructors[type.symbol.escapedName](combineTypes(types));
	    }
	    function inferTypeParameters(genericType, usageType, typeParameter) {
	      if (genericType === typeParameter) {
	        return [usageType];
	      } else if (genericType.flags & 3145728 /* UnionOrIntersection */) {
	        return flatMap(genericType.types, (t) => inferTypeParameters(t, usageType, typeParameter));
	      } else if (getObjectFlags(genericType) & 4 /* Reference */ && getObjectFlags(usageType) & 4 /* Reference */) {
	        const genericArgs = checker.getTypeArguments(genericType);
	        const usageArgs = checker.getTypeArguments(usageType);
	        const types = [];
	        if (genericArgs && usageArgs) {
	          for (let i = 0; i < genericArgs.length; i++) {
	            if (usageArgs[i]) {
	              types.push(...inferTypeParameters(genericArgs[i], usageArgs[i], typeParameter));
	            }
	          }
	        }
	        return types;
	      }
	      const genericSigs = checker.getSignaturesOfType(genericType, 0 /* Call */);
	      const usageSigs = checker.getSignaturesOfType(usageType, 0 /* Call */);
	      if (genericSigs.length === 1 && usageSigs.length === 1) {
	        return inferFromSignatures(genericSigs[0], usageSigs[0], typeParameter);
	      }
	      return [];
	    }
	    function inferFromSignatures(genericSig, usageSig, typeParameter) {
	      var _a;
	      const types = [];
	      for (let i = 0; i < genericSig.parameters.length; i++) {
	        const genericParam = genericSig.parameters[i];
	        const usageParam = usageSig.parameters[i];
	        const isRest = genericSig.declaration && isRestParameter(genericSig.declaration.parameters[i]);
	        if (!usageParam) {
	          break;
	        }
	        let genericParamType = genericParam.valueDeclaration ? checker.getTypeOfSymbolAtLocation(genericParam, genericParam.valueDeclaration) : checker.getAnyType();
	        const elementType = isRest && checker.getElementTypeOfArrayType(genericParamType);
	        if (elementType) {
	          genericParamType = elementType;
	        }
	        const targetType = ((_a = tryCast(usageParam, isTransientSymbol)) == null ? void 0 : _a.links.type) || (usageParam.valueDeclaration ? checker.getTypeOfSymbolAtLocation(usageParam, usageParam.valueDeclaration) : checker.getAnyType());
	        types.push(...inferTypeParameters(genericParamType, targetType, typeParameter));
	      }
	      const genericReturn = checker.getReturnTypeOfSignature(genericSig);
	      const usageReturn = checker.getReturnTypeOfSignature(usageSig);
	      types.push(...inferTypeParameters(genericReturn, usageReturn, typeParameter));
	      return types;
	    }
	    function getFunctionFromCalls(calls) {
	      return checker.createAnonymousType(
	        /*symbol*/
	        void 0,
	        createSymbolTable(),
	        [getSignatureFromCalls(calls)],
	        emptyArray,
	        emptyArray
	      );
	    }
	    function getSignatureFromCalls(calls) {
	      const parameters2 = [];
	      const length2 = Math.max(...calls.map((c) => c.argumentTypes.length));
	      for (let i = 0; i < length2; i++) {
	        const symbol = checker.createSymbol(1 /* FunctionScopedVariable */, escapeLeadingUnderscores(`arg${i}`));
	        symbol.links.type = combineTypes(calls.map((call) => call.argumentTypes[i] || checker.getUndefinedType()));
	        if (calls.some((call) => call.argumentTypes[i] === void 0)) {
	          symbol.flags |= 16777216 /* Optional */;
	        }
	        parameters2.push(symbol);
	      }
	      const returnType = combineFromUsage(combineUsages(calls.map((call) => call.return_)));
	      return checker.createSignature(
	        /*declaration*/
	        void 0,
	        /*typeParameters*/
	        void 0,
	        /*thisParameter*/
	        void 0,
	        parameters2,
	        returnType,
	        /*typePredicate*/
	        void 0,
	        length2,
	        0 /* None */
	      );
	    }
	    function addCandidateType(usage, type) {
	      if (type && !(type.flags & 1 /* Any */) && !(type.flags & 131072 /* Never */)) {
	        (usage.candidateTypes || (usage.candidateTypes = [])).push(type);
	      }
	    }
	    function addCandidateThisType(usage, type) {
	      if (type && !(type.flags & 1 /* Any */) && !(type.flags & 131072 /* Never */)) {
	        (usage.candidateThisTypes || (usage.candidateThisTypes = [])).push(type);
	      }
	    }
	  }
	  var fixId38, errorCodes49;
	  var init_inferFromUsage = __esm({
	    "src/services/codefixes/inferFromUsage.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      fixId38 = "inferFromUsage";
	      errorCodes49 = [
	        // Variable declarations
	        Diagnostics.Variable_0_implicitly_has_type_1_in_some_locations_where_its_type_cannot_be_determined.code,
	        // Variable uses
	        Diagnostics.Variable_0_implicitly_has_an_1_type.code,
	        // Parameter declarations
	        Diagnostics.Parameter_0_implicitly_has_an_1_type.code,
	        Diagnostics.Rest_parameter_0_implicitly_has_an_any_type.code,
	        // Get Accessor declarations
	        Diagnostics.Property_0_implicitly_has_type_any_because_its_get_accessor_lacks_a_return_type_annotation.code,
	        Diagnostics._0_which_lacks_return_type_annotation_implicitly_has_an_1_return_type.code,
	        // Set Accessor declarations
	        Diagnostics.Property_0_implicitly_has_type_any_because_its_set_accessor_lacks_a_parameter_type_annotation.code,
	        // Property declarations
	        Diagnostics.Member_0_implicitly_has_an_1_type.code,
	        //// Suggestions
	        // Variable declarations
	        Diagnostics.Variable_0_implicitly_has_type_1_in_some_locations_but_a_better_type_may_be_inferred_from_usage.code,
	        // Variable uses
	        Diagnostics.Variable_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage.code,
	        // Parameter declarations
	        Diagnostics.Parameter_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage.code,
	        Diagnostics.Rest_parameter_0_implicitly_has_an_any_type_but_a_better_type_may_be_inferred_from_usage.code,
	        // Get Accessor declarations
	        Diagnostics.Property_0_implicitly_has_type_any_but_a_better_type_for_its_get_accessor_may_be_inferred_from_usage.code,
	        Diagnostics._0_implicitly_has_an_1_return_type_but_a_better_type_may_be_inferred_from_usage.code,
	        // Set Accessor declarations
	        Diagnostics.Property_0_implicitly_has_type_any_but_a_better_type_for_its_set_accessor_may_be_inferred_from_usage.code,
	        // Property declarations
	        Diagnostics.Member_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage.code,
	        // Function expressions and declarations
	        Diagnostics.this_implicitly_has_type_any_because_it_does_not_have_a_type_annotation.code
	      ];
	      registerCodeFix({
	        errorCodes: errorCodes49,
	        getCodeActions(context) {
	          const { sourceFile, program, span: { start }, errorCode, cancellationToken, host, preferences } = context;
	          const token = getTokenAtPosition(sourceFile, start);
	          let declaration;
	          const changes = ts_textChanges_exports.ChangeTracker.with(context, (changes2) => {
	            declaration = doChange33(
	              changes2,
	              sourceFile,
	              token,
	              errorCode,
	              program,
	              cancellationToken,
	              /*markSeen*/
	              returnTrue,
	              host,
	              preferences
	            );
	          });
	          const name = declaration && getNameOfDeclaration(declaration);
	          return !name || changes.length === 0 ? void 0 : [createCodeFixAction(fixId38, changes, [getDiagnostic(errorCode, token), getTextOfNode(name)], fixId38, Diagnostics.Infer_all_types_from_usage)];
	        },
	        fixIds: [fixId38],
	        getAllCodeActions(context) {
	          const { sourceFile, program, cancellationToken, host, preferences } = context;
	          const markSeen = nodeSeenTracker();
	          return codeFixAll(context, errorCodes49, (changes, err) => {
	            doChange33(changes, sourceFile, getTokenAtPosition(err.file, err.start), err.code, program, cancellationToken, markSeen, host, preferences);
	          });
	        }
	      });
	    }
	  });

	  // src/services/codefixes/fixReturnTypeInAsyncFunction.ts
	  function getInfo16(sourceFile, checker, pos) {
	    if (isInJSFile(sourceFile)) {
	      return void 0;
	    }
	    const token = getTokenAtPosition(sourceFile, pos);
	    const func = findAncestor(token, isFunctionLikeDeclaration);
	    const returnTypeNode = func == null ? void 0 : func.type;
	    if (!returnTypeNode) {
	      return void 0;
	    }
	    const returnType = checker.getTypeFromTypeNode(returnTypeNode);
	    const promisedType = checker.getAwaitedType(returnType) || checker.getVoidType();
	    const promisedTypeNode = checker.typeToTypeNode(
	      promisedType,
	      /*enclosingDeclaration*/
	      returnTypeNode,
	      /*flags*/
	      void 0
	    );
	    if (promisedTypeNode) {
	      return { returnTypeNode, returnType, promisedTypeNode, promisedType };
	    }
	  }
	  function doChange34(changes, sourceFile, returnTypeNode, promisedTypeNode) {
	    changes.replaceNode(sourceFile, returnTypeNode, factory.createTypeReferenceNode("Promise", [promisedTypeNode]));
	  }
	  var fixId39, errorCodes50;
	  var init_fixReturnTypeInAsyncFunction = __esm({
	    "src/services/codefixes/fixReturnTypeInAsyncFunction.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      fixId39 = "fixReturnTypeInAsyncFunction";
	      errorCodes50 = [
	        Diagnostics.The_return_type_of_an_async_function_or_method_must_be_the_global_Promise_T_type_Did_you_mean_to_write_Promise_0.code
	      ];
	      registerCodeFix({
	        errorCodes: errorCodes50,
	        fixIds: [fixId39],
	        getCodeActions: function getCodeActionsToFixReturnTypeInAsyncFunction(context) {
	          const { sourceFile, program, span } = context;
	          const checker = program.getTypeChecker();
	          const info = getInfo16(sourceFile, program.getTypeChecker(), span.start);
	          if (!info) {
	            return void 0;
	          }
	          const { returnTypeNode, returnType, promisedTypeNode, promisedType } = info;
	          const changes = ts_textChanges_exports.ChangeTracker.with(context, (t) => doChange34(t, sourceFile, returnTypeNode, promisedTypeNode));
	          return [createCodeFixAction(
	            fixId39,
	            changes,
	            [Diagnostics.Replace_0_with_Promise_1, checker.typeToString(returnType), checker.typeToString(promisedType)],
	            fixId39,
	            Diagnostics.Fix_all_incorrect_return_type_of_an_async_functions
	          )];
	        },
	        getAllCodeActions: (context) => codeFixAll(context, errorCodes50, (changes, diag2) => {
	          const info = getInfo16(diag2.file, context.program.getTypeChecker(), diag2.start);
	          if (info) {
	            doChange34(changes, diag2.file, info.returnTypeNode, info.promisedTypeNode);
	          }
	        })
	      });
	    }
	  });

	  // src/services/codefixes/disableJsDiagnostics.ts
	  function makeChange8(changes, sourceFile, position, seenLines) {
	    const { line: lineNumber } = getLineAndCharacterOfPosition(sourceFile, position);
	    if (!seenLines || tryAddToSet(seenLines, lineNumber)) {
	      changes.insertCommentBeforeLine(sourceFile, lineNumber, position, " @ts-ignore");
	    }
	  }
	  var fixName4, fixId40, errorCodes51;
	  var init_disableJsDiagnostics = __esm({
	    "src/services/codefixes/disableJsDiagnostics.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      fixName4 = "disableJsDiagnostics";
	      fixId40 = "disableJsDiagnostics";
	      errorCodes51 = mapDefined(Object.keys(Diagnostics), (key) => {
	        const diag2 = Diagnostics[key];
	        return diag2.category === 1 /* Error */ ? diag2.code : void 0;
	      });
	      registerCodeFix({
	        errorCodes: errorCodes51,
	        getCodeActions: function getCodeActionsToDisableJsDiagnostics(context) {
	          const { sourceFile, program, span, host, formatContext } = context;
	          if (!isInJSFile(sourceFile) || !isCheckJsEnabledForFile(sourceFile, program.getCompilerOptions())) {
	            return void 0;
	          }
	          const newLineCharacter = sourceFile.checkJsDirective ? "" : getNewLineOrDefaultFromHost(host, formatContext.options);
	          const fixes = [
	            // fixId unnecessary because adding `// @ts-nocheck` even once will ignore every error in the file.
	            createCodeFixActionWithoutFixAll(
	              fixName4,
	              [createFileTextChanges(sourceFile.fileName, [
	                createTextChange(
	                  sourceFile.checkJsDirective ? createTextSpanFromBounds(sourceFile.checkJsDirective.pos, sourceFile.checkJsDirective.end) : createTextSpan(0, 0),
	                  `// @ts-nocheck${newLineCharacter}`
	                )
	              ])],
	              Diagnostics.Disable_checking_for_this_file
	            )
	          ];
	          if (ts_textChanges_exports.isValidLocationToAddComment(sourceFile, span.start)) {
	            fixes.unshift(createCodeFixAction(fixName4, ts_textChanges_exports.ChangeTracker.with(context, (t) => makeChange8(t, sourceFile, span.start)), Diagnostics.Ignore_this_error_message, fixId40, Diagnostics.Add_ts_ignore_to_all_error_messages));
	          }
	          return fixes;
	        },
	        fixIds: [fixId40],
	        getAllCodeActions: (context) => {
	          const seenLines = /* @__PURE__ */ new Set();
	          return codeFixAll(context, errorCodes51, (changes, diag2) => {
	            if (ts_textChanges_exports.isValidLocationToAddComment(diag2.file, diag2.start)) {
	              makeChange8(changes, diag2.file, diag2.start, seenLines);
	            }
	          });
	        }
	      });
	    }
	  });

	  // src/services/codefixes/helpers.ts
	  function createMissingMemberNodes(classDeclaration, possiblyMissingSymbols, sourceFile, context, preferences, importAdder, addClassElement) {
	    const classMembers = classDeclaration.symbol.members;
	    for (const symbol of possiblyMissingSymbols) {
	      if (!classMembers.has(symbol.escapedName)) {
	        addNewNodeForMemberSymbol(
	          symbol,
	          classDeclaration,
	          sourceFile,
	          context,
	          preferences,
	          importAdder,
	          addClassElement,
	          /*body*/
	          void 0
	        );
	      }
	    }
	  }
	  function getNoopSymbolTrackerWithResolver(context) {
	    return {
	      trackSymbol: () => false,
	      moduleResolverHost: getModuleSpecifierResolverHost(context.program, context.host)
	    };
	  }
	  function addNewNodeForMemberSymbol(symbol, enclosingDeclaration, sourceFile, context, preferences, importAdder, addClassElement, body, preserveOptional = 3 /* All */, isAmbient = false) {
	    const declarations = symbol.getDeclarations();
	    const declaration = firstOrUndefined(declarations);
	    const checker = context.program.getTypeChecker();
	    const scriptTarget = getEmitScriptTarget(context.program.getCompilerOptions());
	    const kind = (declaration == null ? void 0 : declaration.kind) ?? 171 /* PropertySignature */;
	    const declarationName = createDeclarationName(symbol, declaration);
	    const effectiveModifierFlags = declaration ? getEffectiveModifierFlags(declaration) : 0 /* None */;
	    let modifierFlags = effectiveModifierFlags & 256 /* Static */;
	    modifierFlags |= effectiveModifierFlags & 1 /* Public */ ? 1 /* Public */ : effectiveModifierFlags & 4 /* Protected */ ? 4 /* Protected */ : 0 /* None */;
	    if (declaration && isAutoAccessorPropertyDeclaration(declaration)) {
	      modifierFlags |= 512 /* Accessor */;
	    }
	    const modifiers = createModifiers();
	    const type = checker.getWidenedType(checker.getTypeOfSymbolAtLocation(symbol, enclosingDeclaration));
	    const optional = !!(symbol.flags & 16777216 /* Optional */);
	    const ambient = !!(enclosingDeclaration.flags & 33554432 /* Ambient */) || isAmbient;
	    const quotePreference = getQuotePreference(sourceFile, preferences);
	    switch (kind) {
	      case 171 /* PropertySignature */:
	      case 172 /* PropertyDeclaration */:
	        const flags = quotePreference === 0 /* Single */ ? 268435456 /* UseSingleQuotesForStringLiteralType */ : void 0;
	        let typeNode = checker.typeToTypeNode(type, enclosingDeclaration, flags, getNoopSymbolTrackerWithResolver(context));
	        if (importAdder) {
	          const importableReference = tryGetAutoImportableReferenceFromTypeNode(typeNode, scriptTarget);
	          if (importableReference) {
	            typeNode = importableReference.typeNode;
	            importSymbols(importAdder, importableReference.symbols);
	          }
	        }
	        addClassElement(factory.createPropertyDeclaration(
	          modifiers,
	          declaration ? createName(declarationName) : symbol.getName(),
	          optional && preserveOptional & 2 /* Property */ ? factory.createToken(58 /* QuestionToken */) : void 0,
	          typeNode,
	          /*initializer*/
	          void 0
	        ));
	        break;
	      case 177 /* GetAccessor */:
	      case 178 /* SetAccessor */: {
	        Debug.assertIsDefined(declarations);
	        let typeNode2 = checker.typeToTypeNode(
	          type,
	          enclosingDeclaration,
	          /*flags*/
	          void 0,
	          getNoopSymbolTrackerWithResolver(context)
	        );
	        const allAccessors = getAllAccessorDeclarations(declarations, declaration);
	        const orderedAccessors = allAccessors.secondAccessor ? [allAccessors.firstAccessor, allAccessors.secondAccessor] : [allAccessors.firstAccessor];
	        if (importAdder) {
	          const importableReference = tryGetAutoImportableReferenceFromTypeNode(typeNode2, scriptTarget);
	          if (importableReference) {
	            typeNode2 = importableReference.typeNode;
	            importSymbols(importAdder, importableReference.symbols);
	          }
	        }
	        for (const accessor of orderedAccessors) {
	          if (isGetAccessorDeclaration(accessor)) {
	            addClassElement(factory.createGetAccessorDeclaration(
	              modifiers,
	              createName(declarationName),
	              emptyArray,
	              createTypeNode(typeNode2),
	              createBody(body, quotePreference, ambient)
	            ));
	          } else {
	            Debug.assertNode(accessor, isSetAccessorDeclaration, "The counterpart to a getter should be a setter");
	            const parameter = getSetAccessorValueParameter(accessor);
	            const parameterName = parameter && isIdentifier(parameter.name) ? idText(parameter.name) : void 0;
	            addClassElement(factory.createSetAccessorDeclaration(
	              modifiers,
	              createName(declarationName),
	              createDummyParameters(
	                1,
	                [parameterName],
	                [createTypeNode(typeNode2)],
	                1,
	                /*inJs*/
	                false
	              ),
	              createBody(body, quotePreference, ambient)
	            ));
	          }
	        }
	        break;
	      }
	      case 173 /* MethodSignature */:
	      case 174 /* MethodDeclaration */:
	        Debug.assertIsDefined(declarations);
	        const signatures = type.isUnion() ? flatMap(type.types, (t) => t.getCallSignatures()) : type.getCallSignatures();
	        if (!some(signatures)) {
	          break;
	        }
	        if (declarations.length === 1) {
	          Debug.assert(signatures.length === 1, "One declaration implies one signature");
	          const signature = signatures[0];
	          outputMethod(quotePreference, signature, modifiers, createName(declarationName), createBody(body, quotePreference, ambient));
	          break;
	        }
	        for (const signature of signatures) {
	          outputMethod(quotePreference, signature, modifiers, createName(declarationName));
	        }
	        if (!ambient) {
	          if (declarations.length > signatures.length) {
	            const signature = checker.getSignatureFromDeclaration(declarations[declarations.length - 1]);
	            outputMethod(quotePreference, signature, modifiers, createName(declarationName), createBody(body, quotePreference));
	          } else {
	            Debug.assert(declarations.length === signatures.length, "Declarations and signatures should match count");
	            addClassElement(createMethodImplementingSignatures(checker, context, enclosingDeclaration, signatures, createName(declarationName), optional && !!(preserveOptional & 1 /* Method */), modifiers, quotePreference, body));
	          }
	        }
	        break;
	    }
	    function outputMethod(quotePreference2, signature, modifiers2, name, body2) {
	      const method = createSignatureDeclarationFromSignature(174 /* MethodDeclaration */, context, quotePreference2, signature, body2, name, modifiers2, optional && !!(preserveOptional & 1 /* Method */), enclosingDeclaration, importAdder);
	      if (method)
	        addClassElement(method);
	    }
	    function createModifiers() {
	      let modifiers2;
	      if (modifierFlags) {
	        modifiers2 = combine(modifiers2, factory.createModifiersFromModifierFlags(modifierFlags));
	      }
	      if (shouldAddOverrideKeyword()) {
	        modifiers2 = append(modifiers2, factory.createToken(164 /* OverrideKeyword */));
	      }
	      return modifiers2 && factory.createNodeArray(modifiers2);
	    }
	    function shouldAddOverrideKeyword() {
	      return !!(context.program.getCompilerOptions().noImplicitOverride && declaration && hasAbstractModifier(declaration));
	    }
	    function createName(node) {
	      if (isIdentifier(node) && node.escapedText === "constructor") {
	        return factory.createComputedPropertyName(factory.createStringLiteral(idText(node), quotePreference === 0 /* Single */));
	      }
	      return getSynthesizedDeepClone(
	        node,
	        /*includeTrivia*/
	        false
	      );
	    }
	    function createBody(block, quotePreference2, ambient2) {
	      return ambient2 ? void 0 : getSynthesizedDeepClone(
	        block,
	        /*includeTrivia*/
	        false
	      ) || createStubbedMethodBody(quotePreference2);
	    }
	    function createTypeNode(typeNode) {
	      return getSynthesizedDeepClone(
	        typeNode,
	        /*includeTrivia*/
	        false
	      );
	    }
	    function createDeclarationName(symbol2, declaration2) {
	      if (getCheckFlags(symbol2) & 262144 /* Mapped */) {
	        const nameType = symbol2.links.nameType;
	        if (nameType && isTypeUsableAsPropertyName(nameType)) {
	          return factory.createIdentifier(unescapeLeadingUnderscores(getPropertyNameFromType(nameType)));
	        }
	      }
	      return getSynthesizedDeepClone(
	        getNameOfDeclaration(declaration2),
	        /*includeTrivia*/
	        false
	      );
	    }
	  }
	  function createSignatureDeclarationFromSignature(kind, context, quotePreference, signature, body, name, modifiers, optional, enclosingDeclaration, importAdder) {
	    const program = context.program;
	    const checker = program.getTypeChecker();
	    const scriptTarget = getEmitScriptTarget(program.getCompilerOptions());
	    const isJs = isInJSFile(enclosingDeclaration);
	    const flags = 1 /* NoTruncation */ | 256 /* SuppressAnyReturnType */ | 524288 /* AllowEmptyTuple */ | (quotePreference === 0 /* Single */ ? 268435456 /* UseSingleQuotesForStringLiteralType */ : 0 /* None */);
	    const signatureDeclaration = checker.signatureToSignatureDeclaration(signature, kind, enclosingDeclaration, flags, getNoopSymbolTrackerWithResolver(context));
	    if (!signatureDeclaration) {
	      return void 0;
	    }
	    let typeParameters = isJs ? void 0 : signatureDeclaration.typeParameters;
	    let parameters = signatureDeclaration.parameters;
	    let type = isJs ? void 0 : signatureDeclaration.type;
	    if (importAdder) {
	      if (typeParameters) {
	        const newTypeParameters = sameMap(typeParameters, (typeParameterDecl) => {
	          let constraint = typeParameterDecl.constraint;
	          let defaultType = typeParameterDecl.default;
	          if (constraint) {
	            const importableReference = tryGetAutoImportableReferenceFromTypeNode(constraint, scriptTarget);
	            if (importableReference) {
	              constraint = importableReference.typeNode;
	              importSymbols(importAdder, importableReference.symbols);
	            }
	          }
	          if (defaultType) {
	            const importableReference = tryGetAutoImportableReferenceFromTypeNode(defaultType, scriptTarget);
	            if (importableReference) {
	              defaultType = importableReference.typeNode;
	              importSymbols(importAdder, importableReference.symbols);
	            }
	          }
	          return factory.updateTypeParameterDeclaration(
	            typeParameterDecl,
	            typeParameterDecl.modifiers,
	            typeParameterDecl.name,
	            constraint,
	            defaultType
	          );
	        });
	        if (typeParameters !== newTypeParameters) {
	          typeParameters = setTextRange(factory.createNodeArray(newTypeParameters, typeParameters.hasTrailingComma), typeParameters);
	        }
	      }
	      const newParameters = sameMap(parameters, (parameterDecl) => {
	        let type2 = isJs ? void 0 : parameterDecl.type;
	        if (type2) {
	          const importableReference = tryGetAutoImportableReferenceFromTypeNode(type2, scriptTarget);
	          if (importableReference) {
	            type2 = importableReference.typeNode;
	            importSymbols(importAdder, importableReference.symbols);
	          }
	        }
	        return factory.updateParameterDeclaration(
	          parameterDecl,
	          parameterDecl.modifiers,
	          parameterDecl.dotDotDotToken,
	          parameterDecl.name,
	          isJs ? void 0 : parameterDecl.questionToken,
	          type2,
	          parameterDecl.initializer
	        );
	      });
	      if (parameters !== newParameters) {
	        parameters = setTextRange(factory.createNodeArray(newParameters, parameters.hasTrailingComma), parameters);
	      }
	      if (type) {
	        const importableReference = tryGetAutoImportableReferenceFromTypeNode(type, scriptTarget);
	        if (importableReference) {
	          type = importableReference.typeNode;
	          importSymbols(importAdder, importableReference.symbols);
	        }
	      }
	    }
	    const questionToken = optional ? factory.createToken(58 /* QuestionToken */) : void 0;
	    const asteriskToken = signatureDeclaration.asteriskToken;
	    if (isFunctionExpression(signatureDeclaration)) {
	      return factory.updateFunctionExpression(signatureDeclaration, modifiers, signatureDeclaration.asteriskToken, tryCast(name, isIdentifier), typeParameters, parameters, type, body ?? signatureDeclaration.body);
	    }
	    if (isArrowFunction(signatureDeclaration)) {
	      return factory.updateArrowFunction(signatureDeclaration, modifiers, typeParameters, parameters, type, signatureDeclaration.equalsGreaterThanToken, body ?? signatureDeclaration.body);
	    }
	    if (isMethodDeclaration(signatureDeclaration)) {
	      return factory.updateMethodDeclaration(signatureDeclaration, modifiers, asteriskToken, name ?? factory.createIdentifier(""), questionToken, typeParameters, parameters, type, body);
	    }
	    if (isFunctionDeclaration(signatureDeclaration)) {
	      return factory.updateFunctionDeclaration(signatureDeclaration, modifiers, signatureDeclaration.asteriskToken, tryCast(name, isIdentifier), typeParameters, parameters, type, body ?? signatureDeclaration.body);
	    }
	    return void 0;
	  }
	  function createSignatureDeclarationFromCallExpression(kind, context, importAdder, call, name, modifierFlags, contextNode) {
	    const quotePreference = getQuotePreference(context.sourceFile, context.preferences);
	    const scriptTarget = getEmitScriptTarget(context.program.getCompilerOptions());
	    const tracker = getNoopSymbolTrackerWithResolver(context);
	    const checker = context.program.getTypeChecker();
	    const isJs = isInJSFile(contextNode);
	    const { typeArguments, arguments: args, parent: parent2 } = call;
	    const contextualType = isJs ? void 0 : checker.getContextualType(call);
	    const names = map(args, (arg) => isIdentifier(arg) ? arg.text : isPropertyAccessExpression(arg) && isIdentifier(arg.name) ? arg.name.text : void 0);
	    const instanceTypes = isJs ? [] : map(args, (arg) => checker.getTypeAtLocation(arg));
	    const { argumentTypeNodes, argumentTypeParameters } = getArgumentTypesAndTypeParameters(
	      checker,
	      importAdder,
	      instanceTypes,
	      contextNode,
	      scriptTarget,
	      1 /* NoTruncation */,
	      tracker
	    );
	    const modifiers = modifierFlags ? factory.createNodeArray(factory.createModifiersFromModifierFlags(modifierFlags)) : void 0;
	    const asteriskToken = isYieldExpression(parent2) ? factory.createToken(42 /* AsteriskToken */) : void 0;
	    const typeParameters = isJs ? void 0 : createTypeParametersForArguments(checker, argumentTypeParameters, typeArguments);
	    const parameters = createDummyParameters(
	      args.length,
	      names,
	      argumentTypeNodes,
	      /*minArgumentCount*/
	      void 0,
	      isJs
	    );
	    const type = isJs || contextualType === void 0 ? void 0 : checker.typeToTypeNode(
	      contextualType,
	      contextNode,
	      /*flags*/
	      void 0,
	      tracker
	    );
	    switch (kind) {
	      case 174 /* MethodDeclaration */:
	        return factory.createMethodDeclaration(
	          modifiers,
	          asteriskToken,
	          name,
	          /*questionToken*/
	          void 0,
	          typeParameters,
	          parameters,
	          type,
	          createStubbedMethodBody(quotePreference)
	        );
	      case 173 /* MethodSignature */:
	        return factory.createMethodSignature(
	          modifiers,
	          name,
	          /*questionToken*/
	          void 0,
	          typeParameters,
	          parameters,
	          type === void 0 ? factory.createKeywordTypeNode(159 /* UnknownKeyword */) : type
	        );
	      case 262 /* FunctionDeclaration */:
	        Debug.assert(typeof name === "string" || isIdentifier(name), "Unexpected name");
	        return factory.createFunctionDeclaration(
	          modifiers,
	          asteriskToken,
	          name,
	          typeParameters,
	          parameters,
	          type,
	          createStubbedBody(Diagnostics.Function_not_implemented.message, quotePreference)
	        );
	      default:
	        Debug.fail("Unexpected kind");
	    }
	  }
	  function createTypeParametersForArguments(checker, argumentTypeParameters, typeArguments) {
	    const usedNames = new Set(argumentTypeParameters.map((pair) => pair[0]));
	    const constraintsByName = new Map(argumentTypeParameters);
	    if (typeArguments) {
	      const typeArgumentsWithNewTypes = typeArguments.filter((typeArgument) => !argumentTypeParameters.some((pair) => {
	        var _a;
	        return checker.getTypeAtLocation(typeArgument) === ((_a = pair[1]) == null ? void 0 : _a.argumentType);
	      }));
	      const targetSize = usedNames.size + typeArgumentsWithNewTypes.length;
	      for (let i = 0; usedNames.size < targetSize; i += 1) {
	        usedNames.add(createTypeParameterName(i));
	      }
	    }
	    return arrayFrom(
	      usedNames.values(),
	      (usedName) => {
	        var _a;
	        return factory.createTypeParameterDeclaration(
	          /*modifiers*/
	          void 0,
	          usedName,
	          (_a = constraintsByName.get(usedName)) == null ? void 0 : _a.constraint
	        );
	      }
	    );
	  }
	  function createTypeParameterName(index) {
	    return 84 /* T */ + index <= 90 /* Z */ ? String.fromCharCode(84 /* T */ + index) : `T${index}`;
	  }
	  function typeToAutoImportableTypeNode(checker, importAdder, type, contextNode, scriptTarget, flags, tracker) {
	    let typeNode = checker.typeToTypeNode(type, contextNode, flags, tracker);
	    if (typeNode && isImportTypeNode(typeNode)) {
	      const importableReference = tryGetAutoImportableReferenceFromTypeNode(typeNode, scriptTarget);
	      if (importableReference) {
	        importSymbols(importAdder, importableReference.symbols);
	        typeNode = importableReference.typeNode;
	      }
	    }
	    return getSynthesizedDeepClone(typeNode);
	  }
	  function typeContainsTypeParameter(type) {
	    if (type.isUnionOrIntersection()) {
	      return type.types.some(typeContainsTypeParameter);
	    }
	    return type.flags & 262144 /* TypeParameter */;
	  }
	  function getArgumentTypesAndTypeParameters(checker, importAdder, instanceTypes, contextNode, scriptTarget, flags, tracker) {
	    const argumentTypeNodes = [];
	    const argumentTypeParameters = /* @__PURE__ */ new Map();
	    for (let i = 0; i < instanceTypes.length; i += 1) {
	      const instanceType = instanceTypes[i];
	      if (instanceType.isUnionOrIntersection() && instanceType.types.some(typeContainsTypeParameter)) {
	        const synthesizedTypeParameterName = createTypeParameterName(i);
	        argumentTypeNodes.push(factory.createTypeReferenceNode(synthesizedTypeParameterName));
	        argumentTypeParameters.set(synthesizedTypeParameterName, void 0);
	        continue;
	      }
	      const widenedInstanceType = checker.getBaseTypeOfLiteralType(instanceType);
	      const argumentTypeNode = typeToAutoImportableTypeNode(checker, importAdder, widenedInstanceType, contextNode, scriptTarget, flags, tracker);
	      if (!argumentTypeNode) {
	        continue;
	      }
	      argumentTypeNodes.push(argumentTypeNode);
	      const argumentTypeParameter = getFirstTypeParameterName(instanceType);
	      const instanceTypeConstraint = instanceType.isTypeParameter() && instanceType.constraint && !isAnonymousObjectConstraintType(instanceType.constraint) ? typeToAutoImportableTypeNode(checker, importAdder, instanceType.constraint, contextNode, scriptTarget, flags, tracker) : void 0;
	      if (argumentTypeParameter) {
	        argumentTypeParameters.set(argumentTypeParameter, { argumentType: instanceType, constraint: instanceTypeConstraint });
	      }
	    }
	    return { argumentTypeNodes, argumentTypeParameters: arrayFrom(argumentTypeParameters.entries()) };
	  }
	  function isAnonymousObjectConstraintType(type) {
	    return type.flags & 524288 /* Object */ && type.objectFlags === 16 /* Anonymous */;
	  }
	  function getFirstTypeParameterName(type) {
	    var _a;
	    if (type.flags & (1048576 /* Union */ | 2097152 /* Intersection */)) {
	      for (const subType of type.types) {
	        const subTypeName = getFirstTypeParameterName(subType);
	        if (subTypeName) {
	          return subTypeName;
	        }
	      }
	    }
	    return type.flags & 262144 /* TypeParameter */ ? (_a = type.getSymbol()) == null ? void 0 : _a.getName() : void 0;
	  }
	  function createDummyParameters(argCount, names, types, minArgumentCount, inJs) {
	    const parameters = [];
	    const parameterNameCounts = /* @__PURE__ */ new Map();
	    for (let i = 0; i < argCount; i++) {
	      const parameterName = (names == null ? void 0 : names[i]) || `arg${i}`;
	      const parameterNameCount = parameterNameCounts.get(parameterName);
	      parameterNameCounts.set(parameterName, (parameterNameCount || 0) + 1);
	      const newParameter = factory.createParameterDeclaration(
	        /*modifiers*/
	        void 0,
	        /*dotDotDotToken*/
	        void 0,
	        /*name*/
	        parameterName + (parameterNameCount || ""),
	        /*questionToken*/
	        minArgumentCount !== void 0 && i >= minArgumentCount ? factory.createToken(58 /* QuestionToken */) : void 0,
	        /*type*/
	        inJs ? void 0 : (types == null ? void 0 : types[i]) || factory.createKeywordTypeNode(159 /* UnknownKeyword */),
	        /*initializer*/
	        void 0
	      );
	      parameters.push(newParameter);
	    }
	    return parameters;
	  }
	  function createMethodImplementingSignatures(checker, context, enclosingDeclaration, signatures, name, optional, modifiers, quotePreference, body) {
	    let maxArgsSignature = signatures[0];
	    let minArgumentCount = signatures[0].minArgumentCount;
	    let someSigHasRestParameter = false;
	    for (const sig of signatures) {
	      minArgumentCount = Math.min(sig.minArgumentCount, minArgumentCount);
	      if (signatureHasRestParameter(sig)) {
	        someSigHasRestParameter = true;
	      }
	      if (sig.parameters.length >= maxArgsSignature.parameters.length && (!signatureHasRestParameter(sig) || signatureHasRestParameter(maxArgsSignature))) {
	        maxArgsSignature = sig;
	      }
	    }
	    const maxNonRestArgs = maxArgsSignature.parameters.length - (signatureHasRestParameter(maxArgsSignature) ? 1 : 0);
	    const maxArgsParameterSymbolNames = maxArgsSignature.parameters.map((symbol) => symbol.name);
	    const parameters = createDummyParameters(
	      maxNonRestArgs,
	      maxArgsParameterSymbolNames,
	      /*types*/
	      void 0,
	      minArgumentCount,
	      /*inJs*/
	      false
	    );
	    if (someSigHasRestParameter) {
	      const restParameter = factory.createParameterDeclaration(
	        /*modifiers*/
	        void 0,
	        factory.createToken(26 /* DotDotDotToken */),
	        maxArgsParameterSymbolNames[maxNonRestArgs] || "rest",
	        /*questionToken*/
	        maxNonRestArgs >= minArgumentCount ? factory.createToken(58 /* QuestionToken */) : void 0,
	        factory.createArrayTypeNode(factory.createKeywordTypeNode(159 /* UnknownKeyword */)),
	        /*initializer*/
	        void 0
	      );
	      parameters.push(restParameter);
	    }
	    return createStubbedMethod(
	      modifiers,
	      name,
	      optional,
	      /*typeParameters*/
	      void 0,
	      parameters,
	      getReturnTypeFromSignatures(signatures, checker, context, enclosingDeclaration),
	      quotePreference,
	      body
	    );
	  }
	  function getReturnTypeFromSignatures(signatures, checker, context, enclosingDeclaration) {
	    if (length(signatures)) {
	      const type = checker.getUnionType(map(signatures, checker.getReturnTypeOfSignature));
	      return checker.typeToTypeNode(type, enclosingDeclaration, 1 /* NoTruncation */, getNoopSymbolTrackerWithResolver(context));
	    }
	  }
	  function createStubbedMethod(modifiers, name, optional, typeParameters, parameters, returnType, quotePreference, body) {
	    return factory.createMethodDeclaration(
	      modifiers,
	      /*asteriskToken*/
	      void 0,
	      name,
	      optional ? factory.createToken(58 /* QuestionToken */) : void 0,
	      typeParameters,
	      parameters,
	      returnType,
	      body || createStubbedMethodBody(quotePreference)
	    );
	  }
	  function createStubbedMethodBody(quotePreference) {
	    return createStubbedBody(Diagnostics.Method_not_implemented.message, quotePreference);
	  }
	  function createStubbedBody(text, quotePreference) {
	    return factory.createBlock(
	      [factory.createThrowStatement(
	        factory.createNewExpression(
	          factory.createIdentifier("Error"),
	          /*typeArguments*/
	          void 0,
	          // TODO Handle auto quote preference.
	          [factory.createStringLiteral(
	            text,
	            /*isSingleQuote*/
	            quotePreference === 0 /* Single */
	          )]
	        )
	      )],
	      /*multiLine*/
	      true
	    );
	  }
	  function setJsonCompilerOptionValues(changeTracker, configFile, options) {
	    const tsconfigObjectLiteral = getTsConfigObjectLiteralExpression(configFile);
	    if (!tsconfigObjectLiteral)
	      return void 0;
	    const compilerOptionsProperty = findJsonProperty(tsconfigObjectLiteral, "compilerOptions");
	    if (compilerOptionsProperty === void 0) {
	      changeTracker.insertNodeAtObjectStart(
	        configFile,
	        tsconfigObjectLiteral,
	        createJsonPropertyAssignment(
	          "compilerOptions",
	          factory.createObjectLiteralExpression(
	            options.map(([optionName, optionValue]) => createJsonPropertyAssignment(optionName, optionValue)),
	            /*multiLine*/
	            true
	          )
	        )
	      );
	      return;
	    }
	    const compilerOptions = compilerOptionsProperty.initializer;
	    if (!isObjectLiteralExpression(compilerOptions)) {
	      return;
	    }
	    for (const [optionName, optionValue] of options) {
	      const optionProperty = findJsonProperty(compilerOptions, optionName);
	      if (optionProperty === void 0) {
	        changeTracker.insertNodeAtObjectStart(configFile, compilerOptions, createJsonPropertyAssignment(optionName, optionValue));
	      } else {
	        changeTracker.replaceNode(configFile, optionProperty.initializer, optionValue);
	      }
	    }
	  }
	  function setJsonCompilerOptionValue(changeTracker, configFile, optionName, optionValue) {
	    setJsonCompilerOptionValues(changeTracker, configFile, [[optionName, optionValue]]);
	  }
	  function createJsonPropertyAssignment(name, initializer) {
	    return factory.createPropertyAssignment(factory.createStringLiteral(name), initializer);
	  }
	  function findJsonProperty(obj, name) {
	    return find(obj.properties, (p) => isPropertyAssignment(p) && !!p.name && isStringLiteral(p.name) && p.name.text === name);
	  }
	  function tryGetAutoImportableReferenceFromTypeNode(importTypeNode, scriptTarget) {
	    let symbols;
	    const typeNode = visitNode(importTypeNode, visit, isTypeNode);
	    if (symbols && typeNode) {
	      return { typeNode, symbols };
	    }
	    function visit(node) {
	      if (isLiteralImportTypeNode(node) && node.qualifier) {
	        const firstIdentifier = getFirstIdentifier(node.qualifier);
	        const name = getNameForExportedSymbol(firstIdentifier.symbol, scriptTarget);
	        const qualifier = name !== firstIdentifier.text ? replaceFirstIdentifierOfEntityName(node.qualifier, factory.createIdentifier(name)) : node.qualifier;
	        symbols = append(symbols, firstIdentifier.symbol);
	        const typeArguments = visitNodes2(node.typeArguments, visit, isTypeNode);
	        return factory.createTypeReferenceNode(qualifier, typeArguments);
	      }
	      return visitEachChild(
	        node,
	        visit,
	        /*context*/
	        void 0
	      );
	    }
	  }
	  function replaceFirstIdentifierOfEntityName(name, newIdentifier) {
	    if (name.kind === 80 /* Identifier */) {
	      return newIdentifier;
	    }
	    return factory.createQualifiedName(replaceFirstIdentifierOfEntityName(name.left, newIdentifier), name.right);
	  }
	  function importSymbols(importAdder, symbols) {
	    symbols.forEach((s) => importAdder.addImportFromExportedSymbol(
	      s,
	      /*isValidTypeOnlyUseSite*/
	      true
	    ));
	  }
	  function findAncestorMatchingSpan(sourceFile, span) {
	    const end = textSpanEnd(span);
	    let token = getTokenAtPosition(sourceFile, span.start);
	    while (token.end < end) {
	      token = token.parent;
	    }
	    return token;
	  }
	  var PreserveOptionalFlags;
	  var init_helpers2 = __esm({
	    "src/services/codefixes/helpers.ts"() {
	      init_ts4();
	      PreserveOptionalFlags = /* @__PURE__ */ ((PreserveOptionalFlags2) => {
	        PreserveOptionalFlags2[PreserveOptionalFlags2["Method"] = 1] = "Method";
	        PreserveOptionalFlags2[PreserveOptionalFlags2["Property"] = 2] = "Property";
	        PreserveOptionalFlags2[PreserveOptionalFlags2["All"] = 3] = "All";
	        return PreserveOptionalFlags2;
	      })(PreserveOptionalFlags || {});
	    }
	  });

	  // src/services/codefixes/generateAccessors.ts
	  function generateAccessorFromProperty(file, program, start, end, context, _actionName) {
	    const fieldInfo = getAccessorConvertiblePropertyAtPosition(file, program, start, end);
	    if (!fieldInfo || ts_refactor_exports.isRefactorErrorInfo(fieldInfo))
	      return void 0;
	    const changeTracker = ts_textChanges_exports.ChangeTracker.fromContext(context);
	    const { isStatic: isStatic2, isReadonly, fieldName, accessorName, originalName, type, container, declaration } = fieldInfo;
	    suppressLeadingAndTrailingTrivia(fieldName);
	    suppressLeadingAndTrailingTrivia(accessorName);
	    suppressLeadingAndTrailingTrivia(declaration);
	    suppressLeadingAndTrailingTrivia(container);
	    let accessorModifiers;
	    let fieldModifiers;
	    if (isClassLike(container)) {
	      const modifierFlags = getEffectiveModifierFlags(declaration);
	      if (isSourceFileJS(file)) {
	        const modifiers = factory.createModifiersFromModifierFlags(modifierFlags);
	        accessorModifiers = modifiers;
	        fieldModifiers = modifiers;
	      } else {
	        accessorModifiers = factory.createModifiersFromModifierFlags(prepareModifierFlagsForAccessor(modifierFlags));
	        fieldModifiers = factory.createModifiersFromModifierFlags(prepareModifierFlagsForField(modifierFlags));
	      }
	      if (canHaveDecorators(declaration)) {
	        fieldModifiers = concatenate(getDecorators(declaration), fieldModifiers);
	      }
	    }
	    updateFieldDeclaration(changeTracker, file, declaration, type, fieldName, fieldModifiers);
	    const getAccessor = generateGetAccessor(fieldName, accessorName, type, accessorModifiers, isStatic2, container);
	    suppressLeadingAndTrailingTrivia(getAccessor);
	    insertAccessor(changeTracker, file, getAccessor, declaration, container);
	    if (isReadonly) {
	      const constructor = getFirstConstructorWithBody(container);
	      if (constructor) {
	        updateReadonlyPropertyInitializerStatementConstructor(changeTracker, file, constructor, fieldName.text, originalName);
	      }
	    } else {
	      const setAccessor = generateSetAccessor(fieldName, accessorName, type, accessorModifiers, isStatic2, container);
	      suppressLeadingAndTrailingTrivia(setAccessor);
	      insertAccessor(changeTracker, file, setAccessor, declaration, container);
	    }
	    return changeTracker.getChanges();
	  }
	  function isConvertibleName(name) {
	    return isIdentifier(name) || isStringLiteral(name);
	  }
	  function isAcceptedDeclaration(node) {
	    return isParameterPropertyDeclaration(node, node.parent) || isPropertyDeclaration(node) || isPropertyAssignment(node);
	  }
	  function createPropertyName(name, originalName) {
	    return isIdentifier(originalName) ? factory.createIdentifier(name) : factory.createStringLiteral(name);
	  }
	  function createAccessorAccessExpression(fieldName, isStatic2, container) {
	    const leftHead = isStatic2 ? container.name : factory.createThis();
	    return isIdentifier(fieldName) ? factory.createPropertyAccessExpression(leftHead, fieldName) : factory.createElementAccessExpression(leftHead, factory.createStringLiteralFromNode(fieldName));
	  }
	  function prepareModifierFlagsForAccessor(modifierFlags) {
	    modifierFlags &= ~8 /* Readonly */;
	    modifierFlags &= ~2 /* Private */;
	    if (!(modifierFlags & 4 /* Protected */)) {
	      modifierFlags |= 1 /* Public */;
	    }
	    return modifierFlags;
	  }
	  function prepareModifierFlagsForField(modifierFlags) {
	    modifierFlags &= ~1 /* Public */;
	    modifierFlags &= ~4 /* Protected */;
	    modifierFlags |= 2 /* Private */;
	    return modifierFlags;
	  }
	  function getAccessorConvertiblePropertyAtPosition(file, program, start, end, considerEmptySpans = true) {
	    const node = getTokenAtPosition(file, start);
	    const cursorRequest = start === end && considerEmptySpans;
	    const declaration = findAncestor(node.parent, isAcceptedDeclaration);
	    const meaning = 7 /* AccessibilityModifier */ | 256 /* Static */ | 8 /* Readonly */;
	    if (!declaration || !(nodeOverlapsWithStartEnd(declaration.name, file, start, end) || cursorRequest)) {
	      return {
	        error: getLocaleSpecificMessage(Diagnostics.Could_not_find_property_for_which_to_generate_accessor)
	      };
	    }
	    if (!isConvertibleName(declaration.name)) {
	      return {
	        error: getLocaleSpecificMessage(Diagnostics.Name_is_not_valid)
	      };
	    }
	    if ((getEffectiveModifierFlags(declaration) & 98303 /* Modifier */ | meaning) !== meaning) {
	      return {
	        error: getLocaleSpecificMessage(Diagnostics.Can_only_convert_property_with_modifier)
	      };
	    }
	    const name = declaration.name.text;
	    const startWithUnderscore = startsWithUnderscore(name);
	    const fieldName = createPropertyName(startWithUnderscore ? name : getUniqueName(`_${name}`, file), declaration.name);
	    const accessorName = createPropertyName(startWithUnderscore ? getUniqueName(name.substring(1), file) : name, declaration.name);
	    return {
	      isStatic: hasStaticModifier(declaration),
	      isReadonly: hasEffectiveReadonlyModifier(declaration),
	      type: getDeclarationType(declaration, program),
	      container: declaration.kind === 169 /* Parameter */ ? declaration.parent.parent : declaration.parent,
	      originalName: declaration.name.text,
	      declaration,
	      fieldName,
	      accessorName,
	      renameAccessor: startWithUnderscore
	    };
	  }
	  function generateGetAccessor(fieldName, accessorName, type, modifiers, isStatic2, container) {
	    return factory.createGetAccessorDeclaration(
	      modifiers,
	      accessorName,
	      [],
	      type,
	      factory.createBlock(
	        [
	          factory.createReturnStatement(
	            createAccessorAccessExpression(fieldName, isStatic2, container)
	          )
	        ],
	        /*multiLine*/
	        true
	      )
	    );
	  }
	  function generateSetAccessor(fieldName, accessorName, type, modifiers, isStatic2, container) {
	    return factory.createSetAccessorDeclaration(
	      modifiers,
	      accessorName,
	      [factory.createParameterDeclaration(
	        /*modifiers*/
	        void 0,
	        /*dotDotDotToken*/
	        void 0,
	        factory.createIdentifier("value"),
	        /*questionToken*/
	        void 0,
	        type
	      )],
	      factory.createBlock(
	        [
	          factory.createExpressionStatement(
	            factory.createAssignment(
	              createAccessorAccessExpression(fieldName, isStatic2, container),
	              factory.createIdentifier("value")
	            )
	          )
	        ],
	        /*multiLine*/
	        true
	      )
	    );
	  }
	  function updatePropertyDeclaration(changeTracker, file, declaration, type, fieldName, modifiers) {
	    const property = factory.updatePropertyDeclaration(
	      declaration,
	      modifiers,
	      fieldName,
	      declaration.questionToken || declaration.exclamationToken,
	      type,
	      declaration.initializer
	    );
	    changeTracker.replaceNode(file, declaration, property);
	  }
	  function updatePropertyAssignmentDeclaration(changeTracker, file, declaration, fieldName) {
	    let assignment = factory.updatePropertyAssignment(declaration, fieldName, declaration.initializer);
	    if (assignment.modifiers || assignment.questionToken || assignment.exclamationToken) {
	      if (assignment === declaration)
	        assignment = factory.cloneNode(assignment);
	      assignment.modifiers = void 0;
	      assignment.questionToken = void 0;
	      assignment.exclamationToken = void 0;
	    }
	    changeTracker.replacePropertyAssignment(file, declaration, assignment);
	  }
	  function updateFieldDeclaration(changeTracker, file, declaration, type, fieldName, modifiers) {
	    if (isPropertyDeclaration(declaration)) {
	      updatePropertyDeclaration(changeTracker, file, declaration, type, fieldName, modifiers);
	    } else if (isPropertyAssignment(declaration)) {
	      updatePropertyAssignmentDeclaration(changeTracker, file, declaration, fieldName);
	    } else {
	      changeTracker.replaceNode(file, declaration, factory.updateParameterDeclaration(declaration, modifiers, declaration.dotDotDotToken, cast(fieldName, isIdentifier), declaration.questionToken, declaration.type, declaration.initializer));
	    }
	  }
	  function insertAccessor(changeTracker, file, accessor, declaration, container) {
	    isParameterPropertyDeclaration(declaration, declaration.parent) ? changeTracker.insertMemberAtStart(file, container, accessor) : isPropertyAssignment(declaration) ? changeTracker.insertNodeAfterComma(file, declaration, accessor) : changeTracker.insertNodeAfter(file, declaration, accessor);
	  }
	  function updateReadonlyPropertyInitializerStatementConstructor(changeTracker, file, constructor, fieldName, originalName) {
	    if (!constructor.body)
	      return;
	    constructor.body.forEachChild(function recur(node) {
	      if (isElementAccessExpression(node) && node.expression.kind === 110 /* ThisKeyword */ && isStringLiteral(node.argumentExpression) && node.argumentExpression.text === originalName && isWriteAccess(node)) {
	        changeTracker.replaceNode(file, node.argumentExpression, factory.createStringLiteral(fieldName));
	      }
	      if (isPropertyAccessExpression(node) && node.expression.kind === 110 /* ThisKeyword */ && node.name.text === originalName && isWriteAccess(node)) {
	        changeTracker.replaceNode(file, node.name, factory.createIdentifier(fieldName));
	      }
	      if (!isFunctionLike(node) && !isClassLike(node)) {
	        node.forEachChild(recur);
	      }
	    });
	  }
	  function getDeclarationType(declaration, program) {
	    const typeNode = getTypeAnnotationNode(declaration);
	    if (isPropertyDeclaration(declaration) && typeNode && declaration.questionToken) {
	      const typeChecker = program.getTypeChecker();
	      const type = typeChecker.getTypeFromTypeNode(typeNode);
	      if (!typeChecker.isTypeAssignableTo(typeChecker.getUndefinedType(), type)) {
	        const types = isUnionTypeNode(typeNode) ? typeNode.types : [typeNode];
	        return factory.createUnionTypeNode([...types, factory.createKeywordTypeNode(157 /* UndefinedKeyword */)]);
	      }
	    }
	    return typeNode;
	  }
	  function getAllSupers(decl, checker) {
	    const res = [];
	    while (decl) {
	      const superElement = getClassExtendsHeritageElement(decl);
	      const superSymbol = superElement && checker.getSymbolAtLocation(superElement.expression);
	      if (!superSymbol)
	        break;
	      const symbol = superSymbol.flags & 2097152 /* Alias */ ? checker.getAliasedSymbol(superSymbol) : superSymbol;
	      const superDecl = symbol.declarations && find(symbol.declarations, isClassLike);
	      if (!superDecl)
	        break;
	      res.push(superDecl);
	      decl = superDecl;
	    }
	    return res;
	  }
	  var init_generateAccessors = __esm({
	    "src/services/codefixes/generateAccessors.ts"() {
	      init_ts4();
	    }
	  });

	  // src/services/codefixes/fixInvalidImportSyntax.ts
	  function getCodeFixesForImportDeclaration(context, node) {
	    const sourceFile = getSourceFileOfNode(node);
	    const namespace = getNamespaceDeclarationNode(node);
	    const opts = context.program.getCompilerOptions();
	    const variations = [];
	    variations.push(createAction(context, sourceFile, node, makeImport(
	      namespace.name,
	      /*namedImports*/
	      void 0,
	      node.moduleSpecifier,
	      getQuotePreference(sourceFile, context.preferences)
	    )));
	    if (getEmitModuleKind(opts) === 1 /* CommonJS */) {
	      variations.push(createAction(
	        context,
	        sourceFile,
	        node,
	        factory.createImportEqualsDeclaration(
	          /*modifiers*/
	          void 0,
	          /*isTypeOnly*/
	          false,
	          namespace.name,
	          factory.createExternalModuleReference(node.moduleSpecifier)
	        )
	      ));
	    }
	    return variations;
	  }
	  function createAction(context, sourceFile, node, replacement) {
	    const changes = ts_textChanges_exports.ChangeTracker.with(context, (t) => t.replaceNode(sourceFile, node, replacement));
	    return createCodeFixActionWithoutFixAll(fixName5, changes, [Diagnostics.Replace_import_with_0, changes[0].textChanges[0].newText]);
	  }
	  function getActionsForUsageOfInvalidImport(context) {
	    const sourceFile = context.sourceFile;
	    const targetKind = Diagnostics.This_expression_is_not_callable.code === context.errorCode ? 213 /* CallExpression */ : 214 /* NewExpression */;
	    const node = findAncestor(getTokenAtPosition(sourceFile, context.span.start), (a) => a.kind === targetKind);
	    if (!node) {
	      return [];
	    }
	    const expr = node.expression;
	    return getImportCodeFixesForExpression(context, expr);
	  }
	  function getActionsForInvalidImportLocation(context) {
	    const sourceFile = context.sourceFile;
	    const node = findAncestor(getTokenAtPosition(sourceFile, context.span.start), (a) => a.getStart() === context.span.start && a.getEnd() === context.span.start + context.span.length);
	    if (!node) {
	      return [];
	    }
	    return getImportCodeFixesForExpression(context, node);
	  }
	  function getImportCodeFixesForExpression(context, expr) {
	    const type = context.program.getTypeChecker().getTypeAtLocation(expr);
	    if (!(type.symbol && isTransientSymbol(type.symbol) && type.symbol.links.originatingImport)) {
	      return [];
	    }
	    const fixes = [];
	    const relatedImport = type.symbol.links.originatingImport;
	    if (!isImportCall(relatedImport)) {
	      addRange(fixes, getCodeFixesForImportDeclaration(context, relatedImport));
	    }
	    if (isExpression(expr) && !(isNamedDeclaration(expr.parent) && expr.parent.name === expr)) {
	      const sourceFile = context.sourceFile;
	      const changes = ts_textChanges_exports.ChangeTracker.with(context, (t) => t.replaceNode(sourceFile, expr, factory.createPropertyAccessExpression(expr, "default"), {}));
	      fixes.push(createCodeFixActionWithoutFixAll(fixName5, changes, Diagnostics.Use_synthetic_default_member));
	    }
	    return fixes;
	  }
	  var fixName5;
	  var init_fixInvalidImportSyntax = __esm({
	    "src/services/codefixes/fixInvalidImportSyntax.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      fixName5 = "invalidImportSyntax";
	      registerCodeFix({
	        errorCodes: [
	          Diagnostics.This_expression_is_not_callable.code,
	          Diagnostics.This_expression_is_not_constructable.code
	        ],
	        getCodeActions: getActionsForUsageOfInvalidImport
	      });
	      registerCodeFix({
	        errorCodes: [
	          // The following error codes cover pretty much all assignability errors that could involve an expression
	          Diagnostics.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1.code,
	          Diagnostics.Type_0_does_not_satisfy_the_constraint_1.code,
	          Diagnostics.Type_0_is_not_assignable_to_type_1.code,
	          Diagnostics.Type_0_is_not_assignable_to_type_1_Two_different_types_with_this_name_exist_but_they_are_unrelated.code,
	          Diagnostics.Type_predicate_0_is_not_assignable_to_1.code,
	          Diagnostics.Property_0_of_type_1_is_not_assignable_to_2_index_type_3.code,
	          Diagnostics._0_index_type_1_is_not_assignable_to_2_index_type_3.code,
	          Diagnostics.Property_0_in_type_1_is_not_assignable_to_the_same_property_in_base_type_2.code,
	          Diagnostics.Property_0_in_type_1_is_not_assignable_to_type_2.code,
	          Diagnostics.Property_0_of_JSX_spread_attribute_is_not_assignable_to_target_property.code,
	          Diagnostics.The_this_context_of_type_0_is_not_assignable_to_method_s_this_of_type_1.code
	        ],
	        getCodeActions: getActionsForInvalidImportLocation
	      });
	    }
	  });

	  // src/services/codefixes/fixStrictClassInitialization.ts
	  function getInfo17(sourceFile, pos) {
	    const token = getTokenAtPosition(sourceFile, pos);
	    if (isIdentifier(token) && isPropertyDeclaration(token.parent)) {
	      const type = getEffectiveTypeAnnotationNode(token.parent);
	      if (type) {
	        return { type, prop: token.parent, isJs: isInJSFile(token.parent) };
	      }
	    }
	    return void 0;
	  }
	  function getActionForAddMissingDefiniteAssignmentAssertion(context, info) {
	    if (info.isJs)
	      return void 0;
	    const changes = ts_textChanges_exports.ChangeTracker.with(context, (t) => addDefiniteAssignmentAssertion(t, context.sourceFile, info.prop));
	    return createCodeFixAction(fixName6, changes, [Diagnostics.Add_definite_assignment_assertion_to_property_0, info.prop.getText()], fixIdAddDefiniteAssignmentAssertions, Diagnostics.Add_definite_assignment_assertions_to_all_uninitialized_properties);
	  }
	  function addDefiniteAssignmentAssertion(changeTracker, propertyDeclarationSourceFile, propertyDeclaration) {
	    suppressLeadingAndTrailingTrivia(propertyDeclaration);
	    const property = factory.updatePropertyDeclaration(
	      propertyDeclaration,
	      propertyDeclaration.modifiers,
	      propertyDeclaration.name,
	      factory.createToken(54 /* ExclamationToken */),
	      propertyDeclaration.type,
	      propertyDeclaration.initializer
	    );
	    changeTracker.replaceNode(propertyDeclarationSourceFile, propertyDeclaration, property);
	  }
	  function getActionForAddMissingUndefinedType(context, info) {
	    const changes = ts_textChanges_exports.ChangeTracker.with(context, (t) => addUndefinedType(t, context.sourceFile, info));
	    return createCodeFixAction(fixName6, changes, [Diagnostics.Add_undefined_type_to_property_0, info.prop.name.getText()], fixIdAddUndefinedType, Diagnostics.Add_undefined_type_to_all_uninitialized_properties);
	  }
	  function addUndefinedType(changeTracker, sourceFile, info) {
	    const undefinedTypeNode = factory.createKeywordTypeNode(157 /* UndefinedKeyword */);
	    const types = isUnionTypeNode(info.type) ? info.type.types.concat(undefinedTypeNode) : [info.type, undefinedTypeNode];
	    const unionTypeNode = factory.createUnionTypeNode(types);
	    if (info.isJs) {
	      changeTracker.addJSDocTags(sourceFile, info.prop, [factory.createJSDocTypeTag(
	        /*tagName*/
	        void 0,
	        factory.createJSDocTypeExpression(unionTypeNode)
	      )]);
	    } else {
	      changeTracker.replaceNode(sourceFile, info.type, unionTypeNode);
	    }
	  }
	  function getActionForAddMissingInitializer(context, info) {
	    if (info.isJs)
	      return void 0;
	    const checker = context.program.getTypeChecker();
	    const initializer = getInitializer(checker, info.prop);
	    if (!initializer)
	      return void 0;
	    const changes = ts_textChanges_exports.ChangeTracker.with(context, (t) => addInitializer(t, context.sourceFile, info.prop, initializer));
	    return createCodeFixAction(fixName6, changes, [Diagnostics.Add_initializer_to_property_0, info.prop.name.getText()], fixIdAddInitializer, Diagnostics.Add_initializers_to_all_uninitialized_properties);
	  }
	  function addInitializer(changeTracker, propertyDeclarationSourceFile, propertyDeclaration, initializer) {
	    suppressLeadingAndTrailingTrivia(propertyDeclaration);
	    const property = factory.updatePropertyDeclaration(
	      propertyDeclaration,
	      propertyDeclaration.modifiers,
	      propertyDeclaration.name,
	      propertyDeclaration.questionToken,
	      propertyDeclaration.type,
	      initializer
	    );
	    changeTracker.replaceNode(propertyDeclarationSourceFile, propertyDeclaration, property);
	  }
	  function getInitializer(checker, propertyDeclaration) {
	    return getDefaultValueFromType(checker, checker.getTypeFromTypeNode(propertyDeclaration.type));
	  }
	  function getDefaultValueFromType(checker, type) {
	    if (type.flags & 512 /* BooleanLiteral */) {
	      return type === checker.getFalseType() || type === checker.getFalseType(
	        /*fresh*/
	        true
	      ) ? factory.createFalse() : factory.createTrue();
	    } else if (type.isStringLiteral()) {
	      return factory.createStringLiteral(type.value);
	    } else if (type.isNumberLiteral()) {
	      return factory.createNumericLiteral(type.value);
	    } else if (type.flags & 2048 /* BigIntLiteral */) {
	      return factory.createBigIntLiteral(type.value);
	    } else if (type.isUnion()) {
	      return firstDefined(type.types, (t) => getDefaultValueFromType(checker, t));
	    } else if (type.isClass()) {
	      const classDeclaration = getClassLikeDeclarationOfSymbol(type.symbol);
	      if (!classDeclaration || hasSyntacticModifier(classDeclaration, 64 /* Abstract */))
	        return void 0;
	      const constructorDeclaration = getFirstConstructorWithBody(classDeclaration);
	      if (constructorDeclaration && constructorDeclaration.parameters.length)
	        return void 0;
	      return factory.createNewExpression(
	        factory.createIdentifier(type.symbol.name),
	        /*typeArguments*/
	        void 0,
	        /*argumentsArray*/
	        void 0
	      );
	    } else if (checker.isArrayLikeType(type)) {
	      return factory.createArrayLiteralExpression();
	    }
	    return void 0;
	  }
	  var fixName6, fixIdAddDefiniteAssignmentAssertions, fixIdAddUndefinedType, fixIdAddInitializer, errorCodes52;
	  var init_fixStrictClassInitialization = __esm({
	    "src/services/codefixes/fixStrictClassInitialization.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      fixName6 = "strictClassInitialization";
	      fixIdAddDefiniteAssignmentAssertions = "addMissingPropertyDefiniteAssignmentAssertions";
	      fixIdAddUndefinedType = "addMissingPropertyUndefinedType";
	      fixIdAddInitializer = "addMissingPropertyInitializer";
	      errorCodes52 = [Diagnostics.Property_0_has_no_initializer_and_is_not_definitely_assigned_in_the_constructor.code];
	      registerCodeFix({
	        errorCodes: errorCodes52,
	        getCodeActions: function getCodeActionsForStrictClassInitializationErrors(context) {
	          const info = getInfo17(context.sourceFile, context.span.start);
	          if (!info)
	            return;
	          const result = [];
	          append(result, getActionForAddMissingUndefinedType(context, info));
	          append(result, getActionForAddMissingDefiniteAssignmentAssertion(context, info));
	          append(result, getActionForAddMissingInitializer(context, info));
	          return result;
	        },
	        fixIds: [fixIdAddDefiniteAssignmentAssertions, fixIdAddUndefinedType, fixIdAddInitializer],
	        getAllCodeActions: (context) => {
	          return codeFixAll(context, errorCodes52, (changes, diag2) => {
	            const info = getInfo17(diag2.file, diag2.start);
	            if (!info)
	              return;
	            switch (context.fixId) {
	              case fixIdAddDefiniteAssignmentAssertions:
	                addDefiniteAssignmentAssertion(changes, diag2.file, info.prop);
	                break;
	              case fixIdAddUndefinedType:
	                addUndefinedType(changes, diag2.file, info);
	                break;
	              case fixIdAddInitializer:
	                const checker = context.program.getTypeChecker();
	                const initializer = getInitializer(checker, info.prop);
	                if (!initializer)
	                  return;
	                addInitializer(changes, diag2.file, info.prop, initializer);
	                break;
	              default:
	                Debug.fail(JSON.stringify(context.fixId));
	            }
	          });
	        }
	      });
	    }
	  });

	  // src/services/codefixes/requireInTs.ts
	  function doChange35(changes, sourceFile, info) {
	    const { allowSyntheticDefaults, defaultImportName, namedImports, statement, required } = info;
	    changes.replaceNode(
	      sourceFile,
	      statement,
	      defaultImportName && !allowSyntheticDefaults ? factory.createImportEqualsDeclaration(
	        /*modifiers*/
	        void 0,
	        /*isTypeOnly*/
	        false,
	        defaultImportName,
	        factory.createExternalModuleReference(required)
	      ) : factory.createImportDeclaration(
	        /*modifiers*/
	        void 0,
	        factory.createImportClause(
	          /*isTypeOnly*/
	          false,
	          defaultImportName,
	          namedImports
	        ),
	        required,
	        /*attributes*/
	        void 0
	      )
	    );
	  }
	  function getInfo18(sourceFile, program, pos) {
	    const { parent: parent2 } = getTokenAtPosition(sourceFile, pos);
	    if (!isRequireCall(
	      parent2,
	      /*requireStringLiteralLikeArgument*/
	      true
	    )) {
	      Debug.failBadSyntaxKind(parent2);
	    }
	    const decl = cast(parent2.parent, isVariableDeclaration);
	    const defaultImportName = tryCast(decl.name, isIdentifier);
	    const namedImports = isObjectBindingPattern(decl.name) ? tryCreateNamedImportsFromObjectBindingPattern(decl.name) : void 0;
	    if (defaultImportName || namedImports) {
	      return {
	        allowSyntheticDefaults: getAllowSyntheticDefaultImports(program.getCompilerOptions()),
	        defaultImportName,
	        namedImports,
	        statement: cast(decl.parent.parent, isVariableStatement),
	        required: first(parent2.arguments)
	      };
	    }
	  }
	  function tryCreateNamedImportsFromObjectBindingPattern(node) {
	    const importSpecifiers = [];
	    for (const element of node.elements) {
	      if (!isIdentifier(element.name) || element.initializer) {
	        return void 0;
	      }
	      importSpecifiers.push(factory.createImportSpecifier(
	        /*isTypeOnly*/
	        false,
	        tryCast(element.propertyName, isIdentifier),
	        element.name
	      ));
	    }
	    if (importSpecifiers.length) {
	      return factory.createNamedImports(importSpecifiers);
	    }
	  }
	  var fixId41, errorCodes53;
	  var init_requireInTs = __esm({
	    "src/services/codefixes/requireInTs.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      fixId41 = "requireInTs";
	      errorCodes53 = [Diagnostics.require_call_may_be_converted_to_an_import.code];
	      registerCodeFix({
	        errorCodes: errorCodes53,
	        getCodeActions(context) {
	          const info = getInfo18(context.sourceFile, context.program, context.span.start);
	          if (!info) {
	            return void 0;
	          }
	          const changes = ts_textChanges_exports.ChangeTracker.with(context, (t) => doChange35(t, context.sourceFile, info));
	          return [createCodeFixAction(fixId41, changes, Diagnostics.Convert_require_to_import, fixId41, Diagnostics.Convert_all_require_to_import)];
	        },
	        fixIds: [fixId41],
	        getAllCodeActions: (context) => codeFixAll(context, errorCodes53, (changes, diag2) => {
	          const info = getInfo18(diag2.file, context.program, diag2.start);
	          if (info) {
	            doChange35(changes, context.sourceFile, info);
	          }
	        })
	      });
	    }
	  });

	  // src/services/codefixes/useDefaultImport.ts
	  function getInfo19(sourceFile, pos) {
	    const name = getTokenAtPosition(sourceFile, pos);
	    if (!isIdentifier(name))
	      return void 0;
	    const { parent: parent2 } = name;
	    if (isImportEqualsDeclaration(parent2) && isExternalModuleReference(parent2.moduleReference)) {
	      return { importNode: parent2, name, moduleSpecifier: parent2.moduleReference.expression };
	    } else if (isNamespaceImport(parent2)) {
	      const importNode = parent2.parent.parent;
	      return { importNode, name, moduleSpecifier: importNode.moduleSpecifier };
	    }
	  }
	  function doChange36(changes, sourceFile, info, preferences) {
	    changes.replaceNode(sourceFile, info.importNode, makeImport(
	      info.name,
	      /*namedImports*/
	      void 0,
	      info.moduleSpecifier,
	      getQuotePreference(sourceFile, preferences)
	    ));
	  }
	  var fixId42, errorCodes54;
	  var init_useDefaultImport = __esm({
	    "src/services/codefixes/useDefaultImport.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      fixId42 = "useDefaultImport";
	      errorCodes54 = [Diagnostics.Import_may_be_converted_to_a_default_import.code];
	      registerCodeFix({
	        errorCodes: errorCodes54,
	        getCodeActions(context) {
	          const { sourceFile, span: { start } } = context;
	          const info = getInfo19(sourceFile, start);
	          if (!info)
	            return void 0;
	          const changes = ts_textChanges_exports.ChangeTracker.with(context, (t) => doChange36(t, sourceFile, info, context.preferences));
	          return [createCodeFixAction(fixId42, changes, Diagnostics.Convert_to_default_import, fixId42, Diagnostics.Convert_all_to_default_imports)];
	        },
	        fixIds: [fixId42],
	        getAllCodeActions: (context) => codeFixAll(context, errorCodes54, (changes, diag2) => {
	          const info = getInfo19(diag2.file, diag2.start);
	          if (info)
	            doChange36(changes, diag2.file, info, context.preferences);
	        })
	      });
	    }
	  });

	  // src/services/codefixes/useBigintLiteral.ts
	  function makeChange9(changeTracker, sourceFile, span) {
	    const numericLiteral = tryCast(getTokenAtPosition(sourceFile, span.start), isNumericLiteral);
	    if (!numericLiteral) {
	      return;
	    }
	    const newText = numericLiteral.getText(sourceFile) + "n";
	    changeTracker.replaceNode(sourceFile, numericLiteral, factory.createBigIntLiteral(newText));
	  }
	  var fixId43, errorCodes55;
	  var init_useBigintLiteral = __esm({
	    "src/services/codefixes/useBigintLiteral.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      fixId43 = "useBigintLiteral";
	      errorCodes55 = [
	        Diagnostics.Numeric_literals_with_absolute_values_equal_to_2_53_or_greater_are_too_large_to_be_represented_accurately_as_integers.code
	      ];
	      registerCodeFix({
	        errorCodes: errorCodes55,
	        getCodeActions: function getCodeActionsToUseBigintLiteral(context) {
	          const changes = ts_textChanges_exports.ChangeTracker.with(context, (t) => makeChange9(t, context.sourceFile, context.span));
	          if (changes.length > 0) {
	            return [createCodeFixAction(fixId43, changes, Diagnostics.Convert_to_a_bigint_numeric_literal, fixId43, Diagnostics.Convert_all_to_bigint_numeric_literals)];
	          }
	        },
	        fixIds: [fixId43],
	        getAllCodeActions: (context) => {
	          return codeFixAll(context, errorCodes55, (changes, diag2) => makeChange9(changes, diag2.file, diag2));
	        }
	      });
	    }
	  });

	  // src/services/codefixes/fixAddModuleReferTypeMissingTypeof.ts
	  function getImportTypeNode(sourceFile, pos) {
	    const token = getTokenAtPosition(sourceFile, pos);
	    Debug.assert(token.kind === 102 /* ImportKeyword */, "This token should be an ImportKeyword");
	    Debug.assert(token.parent.kind === 205 /* ImportType */, "Token parent should be an ImportType");
	    return token.parent;
	  }
	  function doChange37(changes, sourceFile, importType) {
	    const newTypeNode = factory.updateImportTypeNode(
	      importType,
	      importType.argument,
	      importType.attributes,
	      importType.qualifier,
	      importType.typeArguments,
	      /*isTypeOf*/
	      true
	    );
	    changes.replaceNode(sourceFile, importType, newTypeNode);
	  }
	  var fixIdAddMissingTypeof, fixId44, errorCodes56;
	  var init_fixAddModuleReferTypeMissingTypeof = __esm({
	    "src/services/codefixes/fixAddModuleReferTypeMissingTypeof.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      fixIdAddMissingTypeof = "fixAddModuleReferTypeMissingTypeof";
	      fixId44 = fixIdAddMissingTypeof;
	      errorCodes56 = [Diagnostics.Module_0_does_not_refer_to_a_type_but_is_used_as_a_type_here_Did_you_mean_typeof_import_0.code];
	      registerCodeFix({
	        errorCodes: errorCodes56,
	        getCodeActions: function getCodeActionsToAddMissingTypeof(context) {
	          const { sourceFile, span } = context;
	          const importType = getImportTypeNode(sourceFile, span.start);
	          const changes = ts_textChanges_exports.ChangeTracker.with(context, (t) => doChange37(t, sourceFile, importType));
	          return [createCodeFixAction(fixId44, changes, Diagnostics.Add_missing_typeof, fixId44, Diagnostics.Add_missing_typeof)];
	        },
	        fixIds: [fixId44],
	        getAllCodeActions: (context) => codeFixAll(context, errorCodes56, (changes, diag2) => doChange37(changes, context.sourceFile, getImportTypeNode(diag2.file, diag2.start)))
	      });
	    }
	  });

	  // src/services/codefixes/wrapJsxInFragment.ts
	  function findNodeToFix(sourceFile, pos) {
	    const lessThanToken = getTokenAtPosition(sourceFile, pos);
	    const firstJsxElementOrOpenElement = lessThanToken.parent;
	    let binaryExpr = firstJsxElementOrOpenElement.parent;
	    if (!isBinaryExpression(binaryExpr)) {
	      binaryExpr = binaryExpr.parent;
	      if (!isBinaryExpression(binaryExpr))
	        return void 0;
	    }
	    if (!nodeIsMissing(binaryExpr.operatorToken))
	      return void 0;
	    return binaryExpr;
	  }
	  function doChange38(changeTracker, sf, node) {
	    const jsx = flattenInvalidBinaryExpr(node);
	    if (jsx)
	      changeTracker.replaceNode(sf, node, factory.createJsxFragment(factory.createJsxOpeningFragment(), jsx, factory.createJsxJsxClosingFragment()));
	  }
	  function flattenInvalidBinaryExpr(node) {
	    const children = [];
	    let current = node;
	    while (true) {
	      if (isBinaryExpression(current) && nodeIsMissing(current.operatorToken) && current.operatorToken.kind === 28 /* CommaToken */) {
	        children.push(current.left);
	        if (isJsxChild(current.right)) {
	          children.push(current.right);
	          return children;
	        } else if (isBinaryExpression(current.right)) {
	          current = current.right;
	          continue;
	        } else
	          return void 0;
	      } else
	        return void 0;
	    }
	  }
	  var fixID2, errorCodes57;
	  var init_wrapJsxInFragment = __esm({
	    "src/services/codefixes/wrapJsxInFragment.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      fixID2 = "wrapJsxInFragment";
	      errorCodes57 = [Diagnostics.JSX_expressions_must_have_one_parent_element.code];
	      registerCodeFix({
	        errorCodes: errorCodes57,
	        getCodeActions: function getCodeActionsToWrapJsxInFragment(context) {
	          const { sourceFile, span } = context;
	          const node = findNodeToFix(sourceFile, span.start);
	          if (!node)
	            return void 0;
	          const changes = ts_textChanges_exports.ChangeTracker.with(context, (t) => doChange38(t, sourceFile, node));
	          return [createCodeFixAction(fixID2, changes, Diagnostics.Wrap_in_JSX_fragment, fixID2, Diagnostics.Wrap_all_unparented_JSX_in_JSX_fragment)];
	        },
	        fixIds: [fixID2],
	        getAllCodeActions: (context) => codeFixAll(context, errorCodes57, (changes, diag2) => {
	          const node = findNodeToFix(context.sourceFile, diag2.start);
	          if (!node)
	            return void 0;
	          doChange38(changes, context.sourceFile, node);
	        })
	      });
	    }
	  });

	  // src/services/codefixes/convertToMappedObjectType.ts
	  function getInfo20(sourceFile, pos) {
	    const token = getTokenAtPosition(sourceFile, pos);
	    const indexSignature = tryCast(token.parent.parent, isIndexSignatureDeclaration);
	    if (!indexSignature)
	      return void 0;
	    const container = isInterfaceDeclaration(indexSignature.parent) ? indexSignature.parent : tryCast(indexSignature.parent.parent, isTypeAliasDeclaration);
	    if (!container)
	      return void 0;
	    return { indexSignature, container };
	  }
	  function createTypeAliasFromInterface(declaration, type) {
	    return factory.createTypeAliasDeclaration(declaration.modifiers, declaration.name, declaration.typeParameters, type);
	  }
	  function doChange39(changes, sourceFile, { indexSignature, container }) {
	    const members = isInterfaceDeclaration(container) ? container.members : container.type.members;
	    const otherMembers = members.filter((member) => !isIndexSignatureDeclaration(member));
	    const parameter = first(indexSignature.parameters);
	    const mappedTypeParameter = factory.createTypeParameterDeclaration(
	      /*modifiers*/
	      void 0,
	      cast(parameter.name, isIdentifier),
	      parameter.type
	    );
	    const mappedIntersectionType = factory.createMappedTypeNode(
	      hasEffectiveReadonlyModifier(indexSignature) ? factory.createModifier(148 /* ReadonlyKeyword */) : void 0,
	      mappedTypeParameter,
	      /*nameType*/
	      void 0,
	      indexSignature.questionToken,
	      indexSignature.type,
	      /*members*/
	      void 0
	    );
	    const intersectionType = factory.createIntersectionTypeNode([
	      ...getAllSuperTypeNodes(container),
	      mappedIntersectionType,
	      ...otherMembers.length ? [factory.createTypeLiteralNode(otherMembers)] : emptyArray
	    ]);
	    changes.replaceNode(sourceFile, container, createTypeAliasFromInterface(container, intersectionType));
	  }
	  var fixId45, errorCodes58;
	  var init_convertToMappedObjectType = __esm({
	    "src/services/codefixes/convertToMappedObjectType.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      fixId45 = "fixConvertToMappedObjectType";
	      errorCodes58 = [Diagnostics.An_index_signature_parameter_type_cannot_be_a_literal_type_or_generic_type_Consider_using_a_mapped_object_type_instead.code];
	      registerCodeFix({
	        errorCodes: errorCodes58,
	        getCodeActions: function getCodeActionsToConvertToMappedTypeObject(context) {
	          const { sourceFile, span } = context;
	          const info = getInfo20(sourceFile, span.start);
	          if (!info)
	            return void 0;
	          const changes = ts_textChanges_exports.ChangeTracker.with(context, (t) => doChange39(t, sourceFile, info));
	          const name = idText(info.container.name);
	          return [createCodeFixAction(fixId45, changes, [Diagnostics.Convert_0_to_mapped_object_type, name], fixId45, [Diagnostics.Convert_0_to_mapped_object_type, name])];
	        },
	        fixIds: [fixId45],
	        getAllCodeActions: (context) => codeFixAll(context, errorCodes58, (changes, diag2) => {
	          const info = getInfo20(diag2.file, diag2.start);
	          if (info)
	            doChange39(changes, diag2.file, info);
	        })
	      });
	    }
	  });

	  // src/services/codefixes/removeAccidentalCallParentheses.ts
	  var fixId46, errorCodes59;
	  var init_removeAccidentalCallParentheses = __esm({
	    "src/services/codefixes/removeAccidentalCallParentheses.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      fixId46 = "removeAccidentalCallParentheses";
	      errorCodes59 = [
	        Diagnostics.This_expression_is_not_callable_because_it_is_a_get_accessor_Did_you_mean_to_use_it_without.code
	      ];
	      registerCodeFix({
	        errorCodes: errorCodes59,
	        getCodeActions(context) {
	          const callExpression = findAncestor(getTokenAtPosition(context.sourceFile, context.span.start), isCallExpression);
	          if (!callExpression) {
	            return void 0;
	          }
	          const changes = ts_textChanges_exports.ChangeTracker.with(context, (t) => {
	            t.deleteRange(context.sourceFile, { pos: callExpression.expression.end, end: callExpression.end });
	          });
	          return [createCodeFixActionWithoutFixAll(fixId46, changes, Diagnostics.Remove_parentheses)];
	        },
	        fixIds: [fixId46]
	      });
	    }
	  });

	  // src/services/codefixes/removeUnnecessaryAwait.ts
	  function makeChange10(changeTracker, sourceFile, span) {
	    const awaitKeyword = tryCast(getTokenAtPosition(sourceFile, span.start), (node) => node.kind === 135 /* AwaitKeyword */);
	    const awaitExpression = awaitKeyword && tryCast(awaitKeyword.parent, isAwaitExpression);
	    if (!awaitExpression) {
	      return;
	    }
	    let expressionToReplace = awaitExpression;
	    const hasSurroundingParens = isParenthesizedExpression(awaitExpression.parent);
	    if (hasSurroundingParens) {
	      const leftMostExpression = getLeftmostExpression(
	        awaitExpression.expression,
	        /*stopAtCallExpressions*/
	        false
	      );
	      if (isIdentifier(leftMostExpression)) {
	        const precedingToken = findPrecedingToken(awaitExpression.parent.pos, sourceFile);
	        if (precedingToken && precedingToken.kind !== 105 /* NewKeyword */) {
	          expressionToReplace = awaitExpression.parent;
	        }
	      }
	    }
	    changeTracker.replaceNode(sourceFile, expressionToReplace, awaitExpression.expression);
	  }
	  var fixId47, errorCodes60;
	  var init_removeUnnecessaryAwait = __esm({
	    "src/services/codefixes/removeUnnecessaryAwait.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      fixId47 = "removeUnnecessaryAwait";
	      errorCodes60 = [
	        Diagnostics.await_has_no_effect_on_the_type_of_this_expression.code
	      ];
	      registerCodeFix({
	        errorCodes: errorCodes60,
	        getCodeActions: function getCodeActionsToRemoveUnnecessaryAwait(context) {
	          const changes = ts_textChanges_exports.ChangeTracker.with(context, (t) => makeChange10(t, context.sourceFile, context.span));
	          if (changes.length > 0) {
	            return [createCodeFixAction(fixId47, changes, Diagnostics.Remove_unnecessary_await, fixId47, Diagnostics.Remove_all_unnecessary_uses_of_await)];
	          }
	        },
	        fixIds: [fixId47],
	        getAllCodeActions: (context) => {
	          return codeFixAll(context, errorCodes60, (changes, diag2) => makeChange10(changes, diag2.file, diag2));
	        }
	      });
	    }
	  });

	  // src/services/codefixes/splitTypeOnlyImport.ts
	  function getImportDeclaration2(sourceFile, span) {
	    return findAncestor(getTokenAtPosition(sourceFile, span.start), isImportDeclaration);
	  }
	  function splitTypeOnlyImport(changes, importDeclaration, context) {
	    if (!importDeclaration) {
	      return;
	    }
	    const importClause = Debug.checkDefined(importDeclaration.importClause);
	    changes.replaceNode(
	      context.sourceFile,
	      importDeclaration,
	      factory.updateImportDeclaration(
	        importDeclaration,
	        importDeclaration.modifiers,
	        factory.updateImportClause(
	          importClause,
	          importClause.isTypeOnly,
	          importClause.name,
	          /*namedBindings*/
	          void 0
	        ),
	        importDeclaration.moduleSpecifier,
	        importDeclaration.attributes
	      )
	    );
	    changes.insertNodeAfter(
	      context.sourceFile,
	      importDeclaration,
	      factory.createImportDeclaration(
	        /*modifiers*/
	        void 0,
	        factory.updateImportClause(
	          importClause,
	          importClause.isTypeOnly,
	          /*name*/
	          void 0,
	          importClause.namedBindings
	        ),
	        importDeclaration.moduleSpecifier,
	        importDeclaration.attributes
	      )
	    );
	  }
	  var errorCodes61, fixId48;
	  var init_splitTypeOnlyImport = __esm({
	    "src/services/codefixes/splitTypeOnlyImport.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      errorCodes61 = [Diagnostics.A_type_only_import_can_specify_a_default_import_or_named_bindings_but_not_both.code];
	      fixId48 = "splitTypeOnlyImport";
	      registerCodeFix({
	        errorCodes: errorCodes61,
	        fixIds: [fixId48],
	        getCodeActions: function getCodeActionsToSplitTypeOnlyImport(context) {
	          const changes = ts_textChanges_exports.ChangeTracker.with(context, (t) => {
	            return splitTypeOnlyImport(t, getImportDeclaration2(context.sourceFile, context.span), context);
	          });
	          if (changes.length) {
	            return [createCodeFixAction(fixId48, changes, Diagnostics.Split_into_two_separate_import_declarations, fixId48, Diagnostics.Split_all_invalid_type_only_imports)];
	          }
	        },
	        getAllCodeActions: (context) => codeFixAll(context, errorCodes61, (changes, error2) => {
	          splitTypeOnlyImport(changes, getImportDeclaration2(context.sourceFile, error2), context);
	        })
	      });
	    }
	  });

	  // src/services/codefixes/convertConstToLet.ts
	  function getInfo21(sourceFile, pos, program) {
	    var _a;
	    const checker = program.getTypeChecker();
	    const symbol = checker.getSymbolAtLocation(getTokenAtPosition(sourceFile, pos));
	    if (symbol === void 0)
	      return;
	    const declaration = tryCast((_a = symbol == null ? void 0 : symbol.valueDeclaration) == null ? void 0 : _a.parent, isVariableDeclarationList);
	    if (declaration === void 0)
	      return;
	    const constToken = findChildOfKind(declaration, 87 /* ConstKeyword */, sourceFile);
	    if (constToken === void 0)
	      return;
	    return { symbol, token: constToken };
	  }
	  function doChange40(changes, sourceFile, token) {
	    changes.replaceNode(sourceFile, token, factory.createToken(121 /* LetKeyword */));
	  }
	  var fixId49, errorCodes62;
	  var init_convertConstToLet = __esm({
	    "src/services/codefixes/convertConstToLet.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      fixId49 = "fixConvertConstToLet";
	      errorCodes62 = [Diagnostics.Cannot_assign_to_0_because_it_is_a_constant.code];
	      registerCodeFix({
	        errorCodes: errorCodes62,
	        getCodeActions: function getCodeActionsToConvertConstToLet(context) {
	          const { sourceFile, span, program } = context;
	          const info = getInfo21(sourceFile, span.start, program);
	          if (info === void 0)
	            return;
	          const changes = ts_textChanges_exports.ChangeTracker.with(context, (t) => doChange40(t, sourceFile, info.token));
	          return [createCodeFixActionMaybeFixAll(fixId49, changes, Diagnostics.Convert_const_to_let, fixId49, Diagnostics.Convert_all_const_to_let)];
	        },
	        getAllCodeActions: (context) => {
	          const { program } = context;
	          const seen = /* @__PURE__ */ new Map();
	          return createCombinedCodeActions(ts_textChanges_exports.ChangeTracker.with(context, (changes) => {
	            eachDiagnostic(context, errorCodes62, (diag2) => {
	              const info = getInfo21(diag2.file, diag2.start, program);
	              if (info) {
	                if (addToSeen(seen, getSymbolId(info.symbol))) {
	                  return doChange40(changes, diag2.file, info.token);
	                }
	              }
	              return void 0;
	            });
	          }));
	        },
	        fixIds: [fixId49]
	      });
	    }
	  });

	  // src/services/codefixes/fixExpectedComma.ts
	  function getInfo22(sourceFile, pos, _) {
	    const node = getTokenAtPosition(sourceFile, pos);
	    return node.kind === 27 /* SemicolonToken */ && node.parent && (isObjectLiteralExpression(node.parent) || isArrayLiteralExpression(node.parent)) ? { node } : void 0;
	  }
	  function doChange41(changes, sourceFile, { node }) {
	    const newNode = factory.createToken(28 /* CommaToken */);
	    changes.replaceNode(sourceFile, node, newNode);
	  }
	  var fixId50, expectedErrorCode, errorCodes63;
	  var init_fixExpectedComma = __esm({
	    "src/services/codefixes/fixExpectedComma.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      fixId50 = "fixExpectedComma";
	      expectedErrorCode = Diagnostics._0_expected.code;
	      errorCodes63 = [expectedErrorCode];
	      registerCodeFix({
	        errorCodes: errorCodes63,
	        getCodeActions(context) {
	          const { sourceFile } = context;
	          const info = getInfo22(sourceFile, context.span.start, context.errorCode);
	          if (!info)
	            return void 0;
	          const changes = ts_textChanges_exports.ChangeTracker.with(context, (t) => doChange41(t, sourceFile, info));
	          return [createCodeFixAction(
	            fixId50,
	            changes,
	            [Diagnostics.Change_0_to_1, ";", ","],
	            fixId50,
	            [Diagnostics.Change_0_to_1, ";", ","]
	          )];
	        },
	        fixIds: [fixId50],
	        getAllCodeActions: (context) => codeFixAll(context, errorCodes63, (changes, diag2) => {
	          const info = getInfo22(diag2.file, diag2.start, diag2.code);
	          if (info)
	            doChange41(changes, context.sourceFile, info);
	        })
	      });
	    }
	  });

	  // src/services/codefixes/fixAddVoidToPromise.ts
	  function makeChange11(changes, sourceFile, span, program, seen) {
	    const node = getTokenAtPosition(sourceFile, span.start);
	    if (!isIdentifier(node) || !isCallExpression(node.parent) || node.parent.expression !== node || node.parent.arguments.length !== 0)
	      return;
	    const checker = program.getTypeChecker();
	    const symbol = checker.getSymbolAtLocation(node);
	    const decl = symbol == null ? void 0 : symbol.valueDeclaration;
	    if (!decl || !isParameter(decl) || !isNewExpression(decl.parent.parent))
	      return;
	    if (seen == null ? void 0 : seen.has(decl))
	      return;
	    seen == null ? void 0 : seen.add(decl);
	    const typeArguments = getEffectiveTypeArguments(decl.parent.parent);
	    if (some(typeArguments)) {
	      const typeArgument = typeArguments[0];
	      const needsParens = !isUnionTypeNode(typeArgument) && !isParenthesizedTypeNode(typeArgument) && isParenthesizedTypeNode(factory.createUnionTypeNode([typeArgument, factory.createKeywordTypeNode(116 /* VoidKeyword */)]).types[0]);
	      if (needsParens) {
	        changes.insertText(sourceFile, typeArgument.pos, "(");
	      }
	      changes.insertText(sourceFile, typeArgument.end, needsParens ? ") | void" : " | void");
	    } else {
	      const signature = checker.getResolvedSignature(node.parent);
	      const parameter = signature == null ? void 0 : signature.parameters[0];
	      const parameterType = parameter && checker.getTypeOfSymbolAtLocation(parameter, decl.parent.parent);
	      if (isInJSFile(decl)) {
	        if (!parameterType || parameterType.flags & 3 /* AnyOrUnknown */) {
	          changes.insertText(sourceFile, decl.parent.parent.end, `)`);
	          changes.insertText(sourceFile, skipTrivia(sourceFile.text, decl.parent.parent.pos), `/** @type {Promise<void>} */(`);
	        }
	      } else {
	        if (!parameterType || parameterType.flags & 2 /* Unknown */) {
	          changes.insertText(sourceFile, decl.parent.parent.expression.end, "<void>");
	        }
	      }
	    }
	  }
	  function getEffectiveTypeArguments(node) {
	    var _a;
	    if (isInJSFile(node)) {
	      if (isParenthesizedExpression(node.parent)) {
	        const jsDocType = (_a = getJSDocTypeTag(node.parent)) == null ? void 0 : _a.typeExpression.type;
	        if (jsDocType && isTypeReferenceNode(jsDocType) && isIdentifier(jsDocType.typeName) && idText(jsDocType.typeName) === "Promise") {
	          return jsDocType.typeArguments;
	        }
	      }
	    } else {
	      return node.typeArguments;
	    }
	  }
	  var fixName7, fixId51, errorCodes64;
	  var init_fixAddVoidToPromise = __esm({
	    "src/services/codefixes/fixAddVoidToPromise.ts"() {
	      init_ts4();
	      init_ts_codefix();
	      fixName7 = "addVoidToPromise";
	      fixId51 = "addVoidToPromise";
	      errorCodes64 = [
	        Diagnostics.Expected_1_argument_but_got_0_new_Promise_needs_a_JSDoc_hint_to_produce_a_resolve_that_can_be_called_without_arguments.code,
	        Diagnostics.Expected_0_arguments_but_got_1_Did_you_forget_to_include_void_in_your_type_argument_to_Promise.code
	      ];
	      registerCodeFix({
	        errorCodes: errorCodes64,
	        fixIds: [fixId51],
	        getCodeActions(context) {
	          const changes = ts_textChanges_exports.ChangeTracker.with(context, (t) => makeChange11(t, context.sourceFile, context.span, context.program));
	          if (changes.length > 0) {
	            return [createCodeFixAction(fixName7, changes, Diagnostics.Add_void_to_Promise_resolved_without_a_value, fixId51, Diagnostics.Add_void_to_all_Promises_resolved_without_a_value)];
	          }
	        },
	        getAllCodeActions(context) {
	          return codeFixAll(context, errorCodes64, (changes, diag2) => makeChange11(changes, diag2.file, diag2, context.program, /* @__PURE__ */ new Set()));
	        }
	      });
	    }
	  });

	  // src/services/_namespaces/ts.codefix.ts
	  var ts_codefix_exports = {};
	  __export(ts_codefix_exports, {
	    PreserveOptionalFlags: () => PreserveOptionalFlags,
	    addNewNodeForMemberSymbol: () => addNewNodeForMemberSymbol,
	    codeFixAll: () => codeFixAll,
	    createCodeFixAction: () => createCodeFixAction,
	    createCodeFixActionMaybeFixAll: () => createCodeFixActionMaybeFixAll,
	    createCodeFixActionWithoutFixAll: () => createCodeFixActionWithoutFixAll,
	    createCombinedCodeActions: () => createCombinedCodeActions,
	    createFileTextChanges: () => createFileTextChanges,
	    createImportAdder: () => createImportAdder,
	    createImportSpecifierResolver: () => createImportSpecifierResolver,
	    createJsonPropertyAssignment: () => createJsonPropertyAssignment,
	    createMissingMemberNodes: () => createMissingMemberNodes,
	    createSignatureDeclarationFromCallExpression: () => createSignatureDeclarationFromCallExpression,
	    createSignatureDeclarationFromSignature: () => createSignatureDeclarationFromSignature,
	    createStubbedBody: () => createStubbedBody,
	    eachDiagnostic: () => eachDiagnostic,
	    findAncestorMatchingSpan: () => findAncestorMatchingSpan,
	    findJsonProperty: () => findJsonProperty,
	    generateAccessorFromProperty: () => generateAccessorFromProperty,
	    getAccessorConvertiblePropertyAtPosition: () => getAccessorConvertiblePropertyAtPosition,
	    getAllFixes: () => getAllFixes,
	    getAllSupers: () => getAllSupers,
	    getArgumentTypesAndTypeParameters: () => getArgumentTypesAndTypeParameters,
	    getFixes: () => getFixes,
	    getImportCompletionAction: () => getImportCompletionAction,
	    getImportKind: () => getImportKind,
	    getJSDocTypedefNodes: () => getJSDocTypedefNodes,
	    getNoopSymbolTrackerWithResolver: () => getNoopSymbolTrackerWithResolver,
	    getPromoteTypeOnlyCompletionAction: () => getPromoteTypeOnlyCompletionAction,
	    getSupportedErrorCodes: () => getSupportedErrorCodes,
	    importFixName: () => importFixName,
	    importSymbols: () => importSymbols,
	    moduleSpecifierToValidIdentifier: () => moduleSpecifierToValidIdentifier,
	    moduleSymbolToValidIdentifier: () => moduleSymbolToValidIdentifier,
	    parameterShouldGetTypeFromJSDoc: () => parameterShouldGetTypeFromJSDoc,
	    registerCodeFix: () => registerCodeFix,
	    setJsonCompilerOptionValue: () => setJsonCompilerOptionValue,
	    setJsonCompilerOptionValues: () => setJsonCompilerOptionValues,
	    tryGetAutoImportableReferenceFromTypeNode: () => tryGetAutoImportableReferenceFromTypeNode,
	    typeToAutoImportableTypeNode: () => typeToAutoImportableTypeNode
	  });
	  var init_ts_codefix = __esm({
	    "src/services/_namespaces/ts.codefix.ts"() {
	      init_codeFixProvider();
	      init_addConvertToUnknownForNonOverlappingTypes();
	      init_addEmptyExportDeclaration();
	      init_addMissingAsync();
	      init_addMissingAwait();
	      init_addMissingConst();
	      init_addMissingDeclareProperty();
	      init_addMissingInvocationForDecorator();
	      init_addNameToNamelessParameter();
	      init_addOptionalPropertyUndefined();
	      init_annotateWithTypeFromJSDoc();
	      init_convertFunctionToEs6Class();
	      init_convertToAsyncFunction();
	      init_convertToEsModule();
	      init_correctQualifiedNameToIndexedAccessType();
	      init_convertToTypeOnlyExport();
	      init_convertToTypeOnlyImport();
	      init_convertTypedefToType();
	      init_convertLiteralTypeToMappedType();
	      init_fixClassIncorrectlyImplementsInterface();
	      init_importFixes();
	      init_fixAddMissingConstraint();
	      init_fixOverrideModifier();
	      init_fixNoPropertyAccessFromIndexSignature();
	      init_fixImplicitThis();
	      init_fixImportNonExportedMember();
	      init_fixIncorrectNamedTupleSyntax();
	      init_fixSpelling();
	      init_returnValueCorrect();
	      init_fixAddMissingMember();
	      init_fixAddMissingNewOperator();
	      init_fixAddMissingParam();
	      init_fixCannotFindModule();
	      init_fixClassDoesntImplementInheritedAbstractMember();
	      init_fixClassSuperMustPrecedeThisAccess();
	      init_fixConstructorForDerivedNeedSuperCall();
	      init_fixEnableJsxFlag();
	      init_fixNaNEquality();
	      init_fixModuleAndTargetOptions();
	      init_fixPropertyAssignment();
	      init_fixExtendsInterfaceBecomesImplements();
	      init_fixForgottenThisPropertyAccess();
	      init_fixInvalidJsxCharacters();
	      init_fixUnmatchedParameter();
	      init_fixUnreferenceableDecoratorMetadata();
	      init_fixUnusedIdentifier();
	      init_fixUnreachableCode();
	      init_fixUnusedLabel();
	      init_fixJSDocTypes();
	      init_fixMissingCallParentheses();
	      init_fixAwaitInSyncFunction();
	      init_fixPropertyOverrideAccessor();
	      init_inferFromUsage();
	      init_fixReturnTypeInAsyncFunction();
	      init_disableJsDiagnostics();
	      init_helpers2();
	      init_generateAccessors();
	      init_fixInvalidImportSyntax();
	      init_fixStrictClassInitialization();
	      init_requireInTs();
	      init_useDefaultImport();
	      init_useBigintLiteral();
	      init_fixAddModuleReferTypeMissingTypeof();
	      init_wrapJsxInFragment();
	      init_convertToMappedObjectType();
	      init_removeAccidentalCallParentheses();
	      init_removeUnnecessaryAwait();
	      init_splitTypeOnlyImport();
	      init_convertConstToLet();
	      init_fixExpectedComma();
	      init_fixAddVoidToPromise();
	    }
	  });

	  // src/services/completions.ts
	  function originIsThisType(origin) {
	    return !!(origin.kind & 1 /* ThisType */);
	  }
	  function originIsSymbolMember(origin) {
	    return !!(origin.kind & 2 /* SymbolMember */);
	  }
	  function originIsExport(origin) {
	    return !!(origin && origin.kind & 4 /* Export */);
	  }
	  function originIsResolvedExport(origin) {
	    return !!(origin && origin.kind === 32 /* ResolvedExport */);
	  }
	  function originIncludesSymbolName(origin) {
	    return originIsExport(origin) || originIsResolvedExport(origin) || originIsComputedPropertyName(origin);
	  }
	  function originIsPackageJsonImport(origin) {
	    return (originIsExport(origin) || originIsResolvedExport(origin)) && !!origin.isFromPackageJson;
	  }
	  function originIsPromise(origin) {
	    return !!(origin.kind & 8 /* Promise */);
	  }
	  function originIsNullableMember(origin) {
	    return !!(origin.kind & 16 /* Nullable */);
	  }
	  function originIsTypeOnlyAlias(origin) {
	    return !!(origin && origin.kind & 64 /* TypeOnlyAlias */);
	  }
	  function originIsObjectLiteralMethod(origin) {
	    return !!(origin && origin.kind & 128 /* ObjectLiteralMethod */);
	  }
	  function originIsIgnore(origin) {
	    return !!(origin && origin.kind & 256 /* Ignore */);
	  }
	  function originIsComputedPropertyName(origin) {
	    return !!(origin && origin.kind & 512 /* ComputedPropertyName */);
	  }
	  function resolvingModuleSpecifiers(logPrefix, host, resolver, program, position, preferences, isForImportStatementCompletion, isValidTypeOnlyUseSite, cb) {
	    var _a, _b, _c;
	    const start = timestamp();
	    const needsFullResolution = isForImportStatementCompletion || moduleResolutionSupportsPackageJsonExportsAndImports(getEmitModuleResolutionKind(program.getCompilerOptions()));
	    let skippedAny = false;
	    let ambientCount = 0;
	    let resolvedCount = 0;
	    let resolvedFromCacheCount = 0;
	    let cacheAttemptCount = 0;
	    const result = cb({
	      tryResolve,
	      skippedAny: () => skippedAny,
	      resolvedAny: () => resolvedCount > 0,
	      resolvedBeyondLimit: () => resolvedCount > moduleSpecifierResolutionLimit
	    });
	    const hitRateMessage = cacheAttemptCount ? ` (${(resolvedFromCacheCount / cacheAttemptCount * 100).toFixed(1)}% hit rate)` : "";
	    (_a = host.log) == null ? void 0 : _a.call(host, `${logPrefix}: resolved ${resolvedCount} module specifiers, plus ${ambientCount} ambient and ${resolvedFromCacheCount} from cache${hitRateMessage}`);
	    (_b = host.log) == null ? void 0 : _b.call(host, `${logPrefix}: response is ${skippedAny ? "incomplete" : "complete"}`);
	    (_c = host.log) == null ? void 0 : _c.call(host, `${logPrefix}: ${timestamp() - start}`);
	    return result;
	    function tryResolve(exportInfo, isFromAmbientModule) {
	      if (isFromAmbientModule) {
	        const result3 = resolver.getModuleSpecifierForBestExportInfo(exportInfo, position, isValidTypeOnlyUseSite);
	        if (result3) {
	          ambientCount++;
	        }
	        return result3 || "failed";
	      }
	      const shouldResolveModuleSpecifier = needsFullResolution || preferences.allowIncompleteCompletions && resolvedCount < moduleSpecifierResolutionLimit;
	      const shouldGetModuleSpecifierFromCache = !shouldResolveModuleSpecifier && preferences.allowIncompleteCompletions && cacheAttemptCount < moduleSpecifierResolutionCacheAttemptLimit;
	      const result2 = shouldResolveModuleSpecifier || shouldGetModuleSpecifierFromCache ? resolver.getModuleSpecifierForBestExportInfo(exportInfo, position, isValidTypeOnlyUseSite, shouldGetModuleSpecifierFromCache) : void 0;
	      if (!shouldResolveModuleSpecifier && !shouldGetModuleSpecifierFromCache || shouldGetModuleSpecifierFromCache && !result2) {
	        skippedAny = true;
	      }
	      resolvedCount += (result2 == null ? void 0 : result2.computedWithoutCacheCount) || 0;
	      resolvedFromCacheCount += exportInfo.length - ((result2 == null ? void 0 : result2.computedWithoutCacheCount) || 0);
	      if (shouldGetModuleSpecifierFromCache) {
	        cacheAttemptCount++;
	      }
	      return result2 || (needsFullResolution ? "failed" : "skipped");
	    }
	  }
	  function getCompletionsAtPosition(host, program, log, sourceFile, position, preferences, triggerCharacter, completionKind, cancellationToken, formatContext, includeSymbol = false) {
	    var _a;
	    const { previousToken } = getRelevantTokens(position, sourceFile);
	    if (triggerCharacter && !isInString(sourceFile, position, previousToken) && !isValidTrigger(sourceFile, triggerCharacter, previousToken, position)) {
	      return void 0;
	    }
	    if (triggerCharacter === " ") {
	      if (preferences.includeCompletionsForImportStatements && preferences.includeCompletionsWithInsertText) {
	        return { isGlobalCompletion: true, isMemberCompletion: false, isNewIdentifierLocation: true, isIncomplete: true, entries: [] };
	      }
	      return void 0;
	    }
	    const compilerOptions = program.getCompilerOptions();
	    const checker = program.getTypeChecker();
	    const incompleteCompletionsCache = preferences.allowIncompleteCompletions ? (_a = host.getIncompleteCompletionsCache) == null ? void 0 : _a.call(host) : void 0;
	    if (incompleteCompletionsCache && completionKind === 3 /* TriggerForIncompleteCompletions */ && previousToken && isIdentifier(previousToken)) {
	      const incompleteContinuation = continuePreviousIncompleteResponse(incompleteCompletionsCache, sourceFile, previousToken, program, host, preferences, cancellationToken, position);
	      if (incompleteContinuation) {
	        return incompleteContinuation;
	      }
	    } else {
	      incompleteCompletionsCache == null ? void 0 : incompleteCompletionsCache.clear();
	    }
	    const stringCompletions = ts_Completions_StringCompletions_exports.getStringLiteralCompletions(sourceFile, position, previousToken, compilerOptions, host, program, log, preferences, includeSymbol);
	    if (stringCompletions) {
	      return stringCompletions;
	    }
	    if (previousToken && isBreakOrContinueStatement(previousToken.parent) && (previousToken.kind === 83 /* BreakKeyword */ || previousToken.kind === 88 /* ContinueKeyword */ || previousToken.kind === 80 /* Identifier */)) {
	      return getLabelCompletionAtPosition(previousToken.parent);
	    }
	    const completionData = getCompletionData(
	      program,
	      log,
	      sourceFile,
	      compilerOptions,
	      position,
	      preferences,
	      /*detailsEntryId*/
	      void 0,
	      host,
	      formatContext,
	      cancellationToken
	    );
	    if (!completionData) {
	      return void 0;
	    }
	    switch (completionData.kind) {
	      case 0 /* Data */:
	        const response = completionInfoFromData(sourceFile, host, program, compilerOptions, log, completionData, preferences, formatContext, position, includeSymbol);
	        if (response == null ? void 0 : response.isIncomplete) {
	          incompleteCompletionsCache == null ? void 0 : incompleteCompletionsCache.set(response);
	        }
	        return response;
	      case 1 /* JsDocTagName */:
	        return jsdocCompletionInfo([
	          ...ts_JsDoc_exports.getJSDocTagNameCompletions(),
	          ...getJSDocParameterCompletions(
	            sourceFile,
	            position,
	            checker,
	            compilerOptions,
	            preferences,
	            /*tagNameOnly*/
	            true
	          )
	        ]);
	      case 2 /* JsDocTag */:
	        return jsdocCompletionInfo([
	          ...ts_JsDoc_exports.getJSDocTagCompletions(),
	          ...getJSDocParameterCompletions(
	            sourceFile,
	            position,
	            checker,
	            compilerOptions,
	            preferences,
	            /*tagNameOnly*/
	            false
	          )
	        ]);
	      case 3 /* JsDocParameterName */:
	        return jsdocCompletionInfo(ts_JsDoc_exports.getJSDocParameterNameCompletions(completionData.tag));
	      case 4 /* Keywords */:
	        return specificKeywordCompletionInfo(completionData.keywordCompletions, completionData.isNewIdentifierLocation);
	      default:
	        return Debug.assertNever(completionData);
	    }
	  }
	  function compareCompletionEntries(entryInArray, entryToInsert) {
	    var _a, _b;
	    let result = compareStringsCaseSensitiveUI(entryInArray.sortText, entryToInsert.sortText);
	    if (result === 0 /* EqualTo */) {
	      result = compareStringsCaseSensitiveUI(entryInArray.name, entryToInsert.name);
	    }
	    if (result === 0 /* EqualTo */ && ((_a = entryInArray.data) == null ? void 0 : _a.moduleSpecifier) && ((_b = entryToInsert.data) == null ? void 0 : _b.moduleSpecifier)) {
	      result = compareNumberOfDirectorySeparators(
	        entryInArray.data.moduleSpecifier,
	        entryToInsert.data.moduleSpecifier
	      );
	    }
	    if (result === 0 /* EqualTo */) {
	      return -1 /* LessThan */;
	    }
	    return result;
	  }
	  function completionEntryDataIsResolved(data) {
	    return !!(data == null ? void 0 : data.moduleSpecifier);
	  }
	  function continuePreviousIncompleteResponse(cache, file, location, program, host, preferences, cancellationToken, position) {
	    const previousResponse = cache.get();
	    if (!previousResponse)
	      return void 0;
	    const touchNode = getTouchingPropertyName(file, position);
	    const lowerCaseTokenText = location.text.toLowerCase();
	    const exportMap = getExportInfoMap(file, host, program, preferences, cancellationToken);
	    const newEntries = resolvingModuleSpecifiers(
	      "continuePreviousIncompleteResponse",
	      host,
	      ts_codefix_exports.createImportSpecifierResolver(file, program, host, preferences),
	      program,
	      location.getStart(),
	      preferences,
	      /*isForImportStatementCompletion*/
	      false,
	      isValidTypeOnlyAliasUseSite(location),
	      (context) => {
	        const entries = mapDefined(previousResponse.entries, (entry) => {
	          var _a;
	          if (!entry.hasAction || !entry.source || !entry.data || completionEntryDataIsResolved(entry.data)) {
	            return entry;
	          }
	          if (!charactersFuzzyMatchInString(entry.name, lowerCaseTokenText)) {
	            return void 0;
	          }
	          const { origin } = Debug.checkDefined(getAutoImportSymbolFromCompletionEntryData(entry.name, entry.data, program, host));
	          const info = exportMap.get(file.path, entry.data.exportMapKey);
	          const result = info && context.tryResolve(info, !isExternalModuleNameRelative(stripQuotes(origin.moduleSymbol.name)));
	          if (result === "skipped")
	            return entry;
	          if (!result || result === "failed") {
	            (_a = host.log) == null ? void 0 : _a.call(host, `Unexpected failure resolving auto import for '${entry.name}' from '${entry.source}'`);
	            return void 0;
	          }
	          const newOrigin = {
	            ...origin,
	            kind: 32 /* ResolvedExport */,
	            moduleSpecifier: result.moduleSpecifier
	          };
	          entry.data = originToCompletionEntryData(newOrigin);
	          entry.source = getSourceFromOrigin(newOrigin);
	          entry.sourceDisplay = [textPart(newOrigin.moduleSpecifier)];
	          return entry;
	        });
	        if (!context.skippedAny()) {
	          previousResponse.isIncomplete = void 0;
	        }
	        return entries;
	      }
	    );
	    previousResponse.entries = newEntries;
	    previousResponse.flags = (previousResponse.flags || 0) | 4 /* IsContinuation */;
	    previousResponse.optionalReplacementSpan = getOptionalReplacementSpan(touchNode);
	    return previousResponse;
	  }
	  function jsdocCompletionInfo(entries) {
	    return { isGlobalCompletion: false, isMemberCompletion: false, isNewIdentifierLocation: false, entries };
	  }
	  function getJSDocParameterCompletions(sourceFile, position, checker, options, preferences, tagNameOnly) {
	    const currentToken = getTokenAtPosition(sourceFile, position);
	    if (!isJSDocTag(currentToken) && !isJSDoc(currentToken)) {
	      return [];
	    }
	    const jsDoc = isJSDoc(currentToken) ? currentToken : currentToken.parent;
	    if (!isJSDoc(jsDoc)) {
	      return [];
	    }
	    const func = jsDoc.parent;
	    if (!isFunctionLike(func)) {
	      return [];
	    }
	    const isJs = isSourceFileJS(sourceFile);
	    const isSnippet = preferences.includeCompletionsWithSnippetText || void 0;
	    const paramTagCount = countWhere(jsDoc.tags, (tag) => isJSDocParameterTag(tag) && tag.getEnd() <= position);
	    return mapDefined(func.parameters, (param) => {
	      if (getJSDocParameterTags(param).length) {
	        return void 0;
	      }
	      if (isIdentifier(param.name)) {
	        const tabstopCounter = { tabstop: 1 };
	        const paramName = param.name.text;
	        let displayText = getJSDocParamAnnotation(
	          paramName,
	          param.initializer,
	          param.dotDotDotToken,
	          isJs,
	          /*isObject*/
	          false,
	          /*isSnippet*/
	          false,
	          checker,
	          options,
	          preferences
	        );
	        let snippetText = isSnippet ? getJSDocParamAnnotation(
	          paramName,
	          param.initializer,
	          param.dotDotDotToken,
	          isJs,
	          /*isObject*/
	          false,
	          /*isSnippet*/
	          true,
	          checker,
	          options,
	          preferences,
	          tabstopCounter
	        ) : void 0;
	        if (tagNameOnly) {
	          displayText = displayText.slice(1);
	          if (snippetText)
	            snippetText = snippetText.slice(1);
	        }
	        return {
	          name: displayText,
	          kind: "parameter" /* parameterElement */,
	          sortText: SortText.LocationPriority,
	          insertText: isSnippet ? snippetText : void 0,
	          isSnippet
	        };
	      } else if (param.parent.parameters.indexOf(param) === paramTagCount) {
	        const paramPath = `param${paramTagCount}`;
	        const displayTextResult = generateJSDocParamTagsForDestructuring(
	          paramPath,
	          param.name,
	          param.initializer,
	          param.dotDotDotToken,
	          isJs,
	          /*isSnippet*/
	          false,
	          checker,
	          options,
	          preferences
	        );
	        const snippetTextResult = isSnippet ? generateJSDocParamTagsForDestructuring(
	          paramPath,
	          param.name,
	          param.initializer,
	          param.dotDotDotToken,
	          isJs,
	          /*isSnippet*/
	          true,
	          checker,
	          options,
	          preferences
	        ) : void 0;
	        let displayText = displayTextResult.join(getNewLineCharacter(options) + "* ");
	        let snippetText = snippetTextResult == null ? void 0 : snippetTextResult.join(getNewLineCharacter(options) + "* ");
	        if (tagNameOnly) {
	          displayText = displayText.slice(1);
	          if (snippetText)
	            snippetText = snippetText.slice(1);
	        }
	        return {
	          name: displayText,
	          kind: "parameter" /* parameterElement */,
	          sortText: SortText.LocationPriority,
	          insertText: isSnippet ? snippetText : void 0,
	          isSnippet
	        };
	      }
	    });
	  }
	  function generateJSDocParamTagsForDestructuring(path, pattern, initializer, dotDotDotToken, isJs, isSnippet, checker, options, preferences) {
	    if (!isJs) {
	      return [
	        getJSDocParamAnnotation(
	          path,
	          initializer,
	          dotDotDotToken,
	          isJs,
	          /*isObject*/
	          false,
	          isSnippet,
	          checker,
	          options,
	          preferences,
	          { tabstop: 1 }
	        )
	      ];
	    }
	    return patternWorker(path, pattern, initializer, dotDotDotToken, { tabstop: 1 });
	    function patternWorker(path2, pattern2, initializer2, dotDotDotToken2, counter) {
	      if (isObjectBindingPattern(pattern2) && !dotDotDotToken2) {
	        const oldTabstop = counter.tabstop;
	        const childCounter = { tabstop: oldTabstop };
	        const rootParam = getJSDocParamAnnotation(
	          path2,
	          initializer2,
	          dotDotDotToken2,
	          isJs,
	          /*isObject*/
	          true,
	          isSnippet,
	          checker,
	          options,
	          preferences,
	          childCounter
	        );
	        let childTags = [];
	        for (const element of pattern2.elements) {
	          const elementTags = elementWorker(path2, element, childCounter);
	          if (!elementTags) {
	            childTags = void 0;
	            break;
	          } else {
	            childTags.push(...elementTags);
	          }
	        }
	        if (childTags) {
	          counter.tabstop = childCounter.tabstop;
	          return [rootParam, ...childTags];
	        }
	      }
	      return [
	        getJSDocParamAnnotation(
	          path2,
	          initializer2,
	          dotDotDotToken2,
	          isJs,
	          /*isObject*/
	          false,
	          isSnippet,
	          checker,
	          options,
	          preferences,
	          counter
	        )
	      ];
	    }
	    function elementWorker(path2, element, counter) {
	      if (!element.propertyName && isIdentifier(element.name) || isIdentifier(element.name)) {
	        const propertyName = element.propertyName ? tryGetTextOfPropertyName(element.propertyName) : element.name.text;
	        if (!propertyName) {
	          return void 0;
	        }
	        const paramName = `${path2}.${propertyName}`;
	        return [
	          getJSDocParamAnnotation(
	            paramName,
	            element.initializer,
	            element.dotDotDotToken,
	            isJs,
	            /*isObject*/
	            false,
	            isSnippet,
	            checker,
	            options,
	            preferences,
	            counter
	          )
	        ];
	      } else if (element.propertyName) {
	        const propertyName = tryGetTextOfPropertyName(element.propertyName);
	        return propertyName && patternWorker(`${path2}.${propertyName}`, element.name, element.initializer, element.dotDotDotToken, counter);
	      }
	      return void 0;
	    }
	  }
	  function getJSDocParamAnnotation(paramName, initializer, dotDotDotToken, isJs, isObject, isSnippet, checker, options, preferences, tabstopCounter) {
	    if (isSnippet) {
	      Debug.assertIsDefined(tabstopCounter);
	    }
	    if (initializer) {
	      paramName = getJSDocParamNameWithInitializer(paramName, initializer);
	    }
	    if (isSnippet) {
	      paramName = escapeSnippetText(paramName);
	    }
	    if (isJs) {
	      let type = "*";
	      if (isObject) {
	        Debug.assert(!dotDotDotToken, `Cannot annotate a rest parameter with type 'Object'.`);
	        type = "Object";
	      } else {
	        if (initializer) {
	          const inferredType = checker.getTypeAtLocation(initializer.parent);
	          if (!(inferredType.flags & (1 /* Any */ | 16384 /* Void */))) {
	            const sourceFile = initializer.getSourceFile();
	            const quotePreference = getQuotePreference(sourceFile, preferences);
	            const builderFlags = quotePreference === 0 /* Single */ ? 268435456 /* UseSingleQuotesForStringLiteralType */ : 0 /* None */;
	            const typeNode = checker.typeToTypeNode(inferredType, findAncestor(initializer, isFunctionLike), builderFlags);
	            if (typeNode) {
	              const printer = isSnippet ? createSnippetPrinter({
	                removeComments: true,
	                module: options.module,
	                target: options.target
	              }) : createPrinter({
	                removeComments: true,
	                module: options.module,
	                target: options.target
	              });
	              setEmitFlags(typeNode, 1 /* SingleLine */);
	              type = printer.printNode(4 /* Unspecified */, typeNode, sourceFile);
	            }
	          }
	        }
	        if (isSnippet && type === "*") {
	          type = `\${${tabstopCounter.tabstop++}:${type}}`;
	        }
	      }
	      const dotDotDot = !isObject && dotDotDotToken ? "..." : "";
	      const description3 = isSnippet ? `\${${tabstopCounter.tabstop++}}` : "";
	      return `@param {${dotDotDot}${type}} ${paramName} ${description3}`;
	    } else {
	      const description3 = isSnippet ? `\${${tabstopCounter.tabstop++}}` : "";
	      return `@param ${paramName} ${description3}`;
	    }
	  }
	  function getJSDocParamNameWithInitializer(paramName, initializer) {
	    const initializerText = initializer.getText().trim();
	    if (initializerText.includes("\n") || initializerText.length > 80) {
	      return `[${paramName}]`;
	    }
	    return `[${paramName}=${initializerText}]`;
	  }
	  function keywordToCompletionEntry(keyword) {
	    return {
	      name: tokenToString(keyword),
	      kind: "keyword" /* keyword */,
	      kindModifiers: "" /* none */,
	      sortText: SortText.GlobalsOrKeywords
	    };
	  }
	  function specificKeywordCompletionInfo(entries, isNewIdentifierLocation) {
	    return {
	      isGlobalCompletion: false,
	      isMemberCompletion: false,
	      isNewIdentifierLocation,
	      entries: entries.slice()
	    };
	  }
	  function keywordCompletionData(keywordFilters, filterOutTsOnlyKeywords, isNewIdentifierLocation) {
	    return {
	      kind: 4 /* Keywords */,
	      keywordCompletions: getKeywordCompletions(keywordFilters, filterOutTsOnlyKeywords),
	      isNewIdentifierLocation
	    };
	  }
	  function keywordFiltersFromSyntaxKind(keywordCompletion) {
	    switch (keywordCompletion) {
	      case 156 /* TypeKeyword */:
	        return 8 /* TypeKeyword */;
	      default:
	        Debug.fail("Unknown mapping from SyntaxKind to KeywordCompletionFilters");
	    }
	  }
	  function getOptionalReplacementSpan(location) {
	    return (location == null ? void 0 : location.kind) === 80 /* Identifier */ ? createTextSpanFromNode(location) : void 0;
	  }
	  function completionInfoFromData(sourceFile, host, program, compilerOptions, log, completionData, preferences, formatContext, position, includeSymbol) {
	    const {
	      symbols,
	      contextToken,
	      completionKind,
	      isInSnippetScope,
	      isNewIdentifierLocation,
	      location,
	      propertyAccessToConvert,
	      keywordFilters,
	      symbolToOriginInfoMap,
	      recommendedCompletion,
	      isJsxInitializer,
	      isTypeOnlyLocation,
	      isJsxIdentifierExpected,
	      isRightOfOpenTag,
	      isRightOfDotOrQuestionDot,
	      importStatementCompletion,
	      insideJsDocTagTypeExpression,
	      symbolToSortTextMap,
	      hasUnresolvedAutoImports
	    } = completionData;
	    let literals = completionData.literals;
	    const checker = program.getTypeChecker();
	    if (getLanguageVariant(sourceFile.scriptKind) === 1 /* JSX */) {
	      const completionInfo = getJsxClosingTagCompletion(location, sourceFile);
	      if (completionInfo) {
	        return completionInfo;
	      }
	    }
	    const caseClause = findAncestor(contextToken, isCaseClause);
	    if (caseClause && (isCaseKeyword(contextToken) || isNodeDescendantOf(contextToken, caseClause.expression))) {
	      const tracker = newCaseClauseTracker(checker, caseClause.parent.clauses);
	      literals = literals.filter((literal) => !tracker.hasValue(literal));
	      symbols.forEach((symbol, i) => {
	        if (symbol.valueDeclaration && isEnumMember(symbol.valueDeclaration)) {
	          const value = checker.getConstantValue(symbol.valueDeclaration);
	          if (value !== void 0 && tracker.hasValue(value)) {
	            symbolToOriginInfoMap[i] = { kind: 256 /* Ignore */ };
	          }
	        }
	      });
	    }
	    const entries = createSortedArray();
	    const isChecked = isCheckedFile(sourceFile, compilerOptions);
	    if (isChecked && !isNewIdentifierLocation && (!symbols || symbols.length === 0) && keywordFilters === 0 /* None */) {
	      return void 0;
	    }
	    const uniqueNames = getCompletionEntriesFromSymbols(
	      symbols,
	      entries,
	      /*replacementToken*/
	      void 0,
	      contextToken,
	      location,
	      position,
	      sourceFile,
	      host,
	      program,
	      getEmitScriptTarget(compilerOptions),
	      log,
	      completionKind,
	      preferences,
	      compilerOptions,
	      formatContext,
	      isTypeOnlyLocation,
	      propertyAccessToConvert,
	      isJsxIdentifierExpected,
	      isJsxInitializer,
	      importStatementCompletion,
	      recommendedCompletion,
	      symbolToOriginInfoMap,
	      symbolToSortTextMap,
	      isJsxIdentifierExpected,
	      isRightOfOpenTag,
	      includeSymbol
	    );
	    if (keywordFilters !== 0 /* None */) {
	      for (const keywordEntry of getKeywordCompletions(keywordFilters, !insideJsDocTagTypeExpression && isSourceFileJS(sourceFile))) {
	        if (isTypeOnlyLocation && isTypeKeyword(stringToToken(keywordEntry.name)) || !isTypeOnlyLocation && isContextualKeywordInAutoImportableExpressionSpace(keywordEntry.name) || !uniqueNames.has(keywordEntry.name)) {
	          uniqueNames.add(keywordEntry.name);
	          insertSorted(
	            entries,
	            keywordEntry,
	            compareCompletionEntries,
	            /*allowDuplicates*/
	            true
	          );
	        }
	      }
	    }
	    for (const keywordEntry of getContextualKeywords(contextToken, position)) {
	      if (!uniqueNames.has(keywordEntry.name)) {
	        uniqueNames.add(keywordEntry.name);
	        insertSorted(
	          entries,
	          keywordEntry,
	          compareCompletionEntries,
	          /*allowDuplicates*/
	          true
	        );
	      }
	    }
	    for (const literal of literals) {
	      const literalEntry = createCompletionEntryForLiteral(sourceFile, preferences, literal);
	      uniqueNames.add(literalEntry.name);
	      insertSorted(
	        entries,
	        literalEntry,
	        compareCompletionEntries,
	        /*allowDuplicates*/
	        true
	      );
	    }
	    if (!isChecked) {
	      getJSCompletionEntries(sourceFile, location.pos, uniqueNames, getEmitScriptTarget(compilerOptions), entries);
	    }
	    let caseBlock;
	    if (preferences.includeCompletionsWithInsertText && contextToken && !isRightOfOpenTag && !isRightOfDotOrQuestionDot && (caseBlock = findAncestor(contextToken, isCaseBlock))) {
	      const cases = getExhaustiveCaseSnippets(caseBlock, sourceFile, preferences, compilerOptions, host, program, formatContext);
	      if (cases) {
	        entries.push(cases.entry);
	      }
	    }
	    return {
	      flags: completionData.flags,
	      isGlobalCompletion: isInSnippetScope,
	      isIncomplete: preferences.allowIncompleteCompletions && hasUnresolvedAutoImports ? true : void 0,
	      isMemberCompletion: isMemberCompletionKind(completionKind),
	      isNewIdentifierLocation,
	      optionalReplacementSpan: getOptionalReplacementSpan(location),
	      entries
	    };
	  }
	  function isCheckedFile(sourceFile, compilerOptions) {
	    return !isSourceFileJS(sourceFile) || !!isCheckJsEnabledForFile(sourceFile, compilerOptions);
	  }
	  function getExhaustiveCaseSnippets(caseBlock, sourceFile, preferences, options, host, program, formatContext) {
	    const clauses = caseBlock.clauses;
	    const checker = program.getTypeChecker();
	    const switchType = checker.getTypeAtLocation(caseBlock.parent.expression);
	    if (switchType && switchType.isUnion() && every(switchType.types, (type) => type.isLiteral())) {
	      const tracker = newCaseClauseTracker(checker, clauses);
	      const target = getEmitScriptTarget(options);
	      const quotePreference = getQuotePreference(sourceFile, preferences);
	      const importAdder = ts_codefix_exports.createImportAdder(sourceFile, program, preferences, host);
	      const elements = [];
	      for (const type of switchType.types) {
	        if (type.flags & 1024 /* EnumLiteral */) {
	          Debug.assert(type.symbol, "An enum member type should have a symbol");
	          Debug.assert(type.symbol.parent, "An enum member type should have a parent symbol (the enum symbol)");
	          const enumValue = type.symbol.valueDeclaration && checker.getConstantValue(type.symbol.valueDeclaration);
	          if (enumValue !== void 0) {
	            if (tracker.hasValue(enumValue)) {
	              continue;
	            }
	            tracker.addValue(enumValue);
	          }
	          const typeNode = ts_codefix_exports.typeToAutoImportableTypeNode(checker, importAdder, type, caseBlock, target);
	          if (!typeNode) {
	            return void 0;
	          }
	          const expr = typeNodeToExpression(typeNode, target, quotePreference);
	          if (!expr) {
	            return void 0;
	          }
	          elements.push(expr);
	        } else if (!tracker.hasValue(type.value)) {
	          switch (typeof type.value) {
	            case "object":
	              elements.push(type.value.negative ? factory.createPrefixUnaryExpression(41 /* MinusToken */, factory.createBigIntLiteral({ negative: false, base10Value: type.value.base10Value })) : factory.createBigIntLiteral(type.value));
	              break;
	            case "number":
	              elements.push(type.value < 0 ? factory.createPrefixUnaryExpression(41 /* MinusToken */, factory.createNumericLiteral(-type.value)) : factory.createNumericLiteral(type.value));
	              break;
	            case "string":
	              elements.push(factory.createStringLiteral(type.value, quotePreference === 0 /* Single */));
	              break;
	          }
	        }
	      }
	      if (elements.length === 0) {
	        return void 0;
	      }
	      const newClauses = map(elements, (element) => factory.createCaseClause(element, []));
	      const newLineChar = getNewLineOrDefaultFromHost(host, formatContext == null ? void 0 : formatContext.options);
	      const printer = createSnippetPrinter({
	        removeComments: true,
	        module: options.module,
	        target: options.target,
	        newLine: getNewLineKind(newLineChar)
	      });
	      const printNode = formatContext ? (node) => printer.printAndFormatNode(4 /* Unspecified */, node, sourceFile, formatContext) : (node) => printer.printNode(4 /* Unspecified */, node, sourceFile);
	      const insertText = map(newClauses, (clause, i) => {
	        if (preferences.includeCompletionsWithSnippetText) {
	          return `${printNode(clause)}$${i + 1}`;
	        }
	        return `${printNode(clause)}`;
	      }).join(newLineChar);
	      const firstClause = printer.printNode(4 /* Unspecified */, newClauses[0], sourceFile);
	      return {
	        entry: {
	          name: `${firstClause} ...`,
	          kind: "" /* unknown */,
	          sortText: SortText.GlobalsOrKeywords,
	          insertText,
	          hasAction: importAdder.hasFixes() || void 0,
	          source: "SwitchCases/" /* SwitchCases */,
	          isSnippet: preferences.includeCompletionsWithSnippetText ? true : void 0
	        },
	        importAdder
	      };
	    }
	    return void 0;
	  }
	  function typeNodeToExpression(typeNode, languageVersion, quotePreference) {
	    switch (typeNode.kind) {
	      case 183 /* TypeReference */:
	        const typeName = typeNode.typeName;
	        return entityNameToExpression(typeName, languageVersion, quotePreference);
	      case 199 /* IndexedAccessType */:
	        const objectExpression = typeNodeToExpression(typeNode.objectType, languageVersion, quotePreference);
	        const indexExpression = typeNodeToExpression(typeNode.indexType, languageVersion, quotePreference);
	        return objectExpression && indexExpression && factory.createElementAccessExpression(objectExpression, indexExpression);
	      case 201 /* LiteralType */:
	        const literal = typeNode.literal;
	        switch (literal.kind) {
	          case 11 /* StringLiteral */:
	            return factory.createStringLiteral(literal.text, quotePreference === 0 /* Single */);
	          case 9 /* NumericLiteral */:
	            return factory.createNumericLiteral(literal.text, literal.numericLiteralFlags);
	        }
	        return void 0;
	      case 196 /* ParenthesizedType */:
	        const exp = typeNodeToExpression(typeNode.type, languageVersion, quotePreference);
	        return exp && (isIdentifier(exp) ? exp : factory.createParenthesizedExpression(exp));
	      case 186 /* TypeQuery */:
	        return entityNameToExpression(typeNode.exprName, languageVersion, quotePreference);
	      case 205 /* ImportType */:
	        Debug.fail(`We should not get an import type after calling 'codefix.typeToAutoImportableTypeNode'.`);
	    }
	    return void 0;
	  }
	  function entityNameToExpression(entityName, languageVersion, quotePreference) {
	    if (isIdentifier(entityName)) {
	      return entityName;
	    }
	    const unescapedName = unescapeLeadingUnderscores(entityName.right.escapedText);
	    if (canUsePropertyAccess(unescapedName, languageVersion)) {
	      return factory.createPropertyAccessExpression(
	        entityNameToExpression(entityName.left, languageVersion, quotePreference),
	        unescapedName
	      );
	    } else {
	      return factory.createElementAccessExpression(
	        entityNameToExpression(entityName.left, languageVersion, quotePreference),
	        factory.createStringLiteral(unescapedName, quotePreference === 0 /* Single */)
	      );
	    }
	  }
	  function isMemberCompletionKind(kind) {
	    switch (kind) {
	      case 0 /* ObjectPropertyDeclaration */:
	      case 3 /* MemberLike */:
	      case 2 /* PropertyAccess */:
	        return true;
	      default:
	        return false;
	    }
	  }
	  function getJsxClosingTagCompletion(location, sourceFile) {
	    const jsxClosingElement = findAncestor(location, (node) => {
	      switch (node.kind) {
	        case 287 /* JsxClosingElement */:
	          return true;
	        case 44 /* SlashToken */:
	        case 32 /* GreaterThanToken */:
	        case 80 /* Identifier */:
	        case 211 /* PropertyAccessExpression */:
	          return false;
	        default:
	          return "quit";
	      }
	    });
	    if (jsxClosingElement) {
	      const hasClosingAngleBracket = !!findChildOfKind(jsxClosingElement, 32 /* GreaterThanToken */, sourceFile);
	      const tagName = jsxClosingElement.parent.openingElement.tagName;
	      const closingTag = tagName.getText(sourceFile);
	      const fullClosingTag = closingTag + (hasClosingAngleBracket ? "" : ">");
	      const replacementSpan = createTextSpanFromNode(jsxClosingElement.tagName);
	      const entry = {
	        name: fullClosingTag,
	        kind: "class" /* classElement */,
	        kindModifiers: void 0,
	        sortText: SortText.LocationPriority
	      };
	      return { isGlobalCompletion: false, isMemberCompletion: true, isNewIdentifierLocation: false, optionalReplacementSpan: replacementSpan, entries: [entry] };
	    }
	    return;
	  }
	  function getJSCompletionEntries(sourceFile, position, uniqueNames, target, entries) {
	    getNameTable(sourceFile).forEach((pos, name) => {
	      if (pos === position) {
	        return;
	      }
	      const realName = unescapeLeadingUnderscores(name);
	      if (!uniqueNames.has(realName) && isIdentifierText(realName, target)) {
	        uniqueNames.add(realName);
	        insertSorted(entries, {
	          name: realName,
	          kind: "warning" /* warning */,
	          kindModifiers: "",
	          sortText: SortText.JavascriptIdentifiers,
	          isFromUncheckedFile: true
	        }, compareCompletionEntries);
	      }
	    });
	  }
	  function completionNameForLiteral(sourceFile, preferences, literal) {
	    return typeof literal === "object" ? pseudoBigIntToString(literal) + "n" : isString(literal) ? quote(sourceFile, preferences, literal) : JSON.stringify(literal);
	  }
	  function createCompletionEntryForLiteral(sourceFile, preferences, literal) {
	    return { name: completionNameForLiteral(sourceFile, preferences, literal), kind: "string" /* string */, kindModifiers: "" /* none */, sortText: SortText.LocationPriority };
	  }
	  function createCompletionEntry(symbol, sortText, replacementToken, contextToken, location, position, sourceFile, host, program, name, needsConvertPropertyAccess, origin, recommendedCompletion, propertyAccessToConvert, isJsxInitializer, importStatementCompletion, useSemicolons, options, preferences, completionKind, formatContext, isJsxIdentifierExpected, isRightOfOpenTag, includeSymbol) {
	    var _a, _b;
	    let insertText;
	    let filterText;
	    let replacementSpan = getReplacementSpanForContextToken(replacementToken);
	    let data;
	    let isSnippet;
	    let source = getSourceFromOrigin(origin);
	    let sourceDisplay;
	    let hasAction;
	    let labelDetails;
	    const typeChecker = program.getTypeChecker();
	    const insertQuestionDot = origin && originIsNullableMember(origin);
	    const useBraces = origin && originIsSymbolMember(origin) || needsConvertPropertyAccess;
	    if (origin && originIsThisType(origin)) {
	      insertText = needsConvertPropertyAccess ? `this${insertQuestionDot ? "?." : ""}[${quotePropertyName(sourceFile, preferences, name)}]` : `this${insertQuestionDot ? "?." : "."}${name}`;
	    } else if ((useBraces || insertQuestionDot) && propertyAccessToConvert) {
	      insertText = useBraces ? needsConvertPropertyAccess ? `[${quotePropertyName(sourceFile, preferences, name)}]` : `[${name}]` : name;
	      if (insertQuestionDot || propertyAccessToConvert.questionDotToken) {
	        insertText = `?.${insertText}`;
	      }
	      const dot = findChildOfKind(propertyAccessToConvert, 25 /* DotToken */, sourceFile) || findChildOfKind(propertyAccessToConvert, 29 /* QuestionDotToken */, sourceFile);
	      if (!dot) {
	        return void 0;
	      }
	      const end = startsWith(name, propertyAccessToConvert.name.text) ? propertyAccessToConvert.name.end : dot.end;
	      replacementSpan = createTextSpanFromBounds(dot.getStart(sourceFile), end);
	    }
	    if (isJsxInitializer) {
	      if (insertText === void 0)
	        insertText = name;
	      insertText = `{${insertText}}`;
	      if (typeof isJsxInitializer !== "boolean") {
	        replacementSpan = createTextSpanFromNode(isJsxInitializer, sourceFile);
	      }
	    }
	    if (origin && originIsPromise(origin) && propertyAccessToConvert) {
	      if (insertText === void 0)
	        insertText = name;
	      const precedingToken = findPrecedingToken(propertyAccessToConvert.pos, sourceFile);
	      let awaitText = "";
	      if (precedingToken && positionIsASICandidate(precedingToken.end, precedingToken.parent, sourceFile)) {
	        awaitText = ";";
	      }
	      awaitText += `(await ${propertyAccessToConvert.expression.getText()})`;
	      insertText = needsConvertPropertyAccess ? `${awaitText}${insertText}` : `${awaitText}${insertQuestionDot ? "?." : "."}${insertText}`;
	      const isInAwaitExpression = tryCast(propertyAccessToConvert.parent, isAwaitExpression);
	      const wrapNode = isInAwaitExpression ? propertyAccessToConvert.parent : propertyAccessToConvert.expression;
	      replacementSpan = createTextSpanFromBounds(wrapNode.getStart(sourceFile), propertyAccessToConvert.end);
	    }
	    if (originIsResolvedExport(origin)) {
	      sourceDisplay = [textPart(origin.moduleSpecifier)];
	      if (importStatementCompletion) {
	        ({ insertText, replacementSpan } = getInsertTextAndReplacementSpanForImportCompletion(name, importStatementCompletion, origin, useSemicolons, sourceFile, options, preferences));
	        isSnippet = preferences.includeCompletionsWithSnippetText ? true : void 0;
	      }
	    }
	    if ((origin == null ? void 0 : origin.kind) === 64 /* TypeOnlyAlias */) {
	      hasAction = true;
	    }
	    if (completionKind === 0 /* ObjectPropertyDeclaration */ && contextToken && ((_a = findPrecedingToken(contextToken.pos, sourceFile, contextToken)) == null ? void 0 : _a.kind) !== 28 /* CommaToken */) {
	      if (isMethodDeclaration(contextToken.parent.parent) || isGetAccessorDeclaration(contextToken.parent.parent) || isSetAccessorDeclaration(contextToken.parent.parent) || isSpreadAssignment(contextToken.parent) || ((_b = findAncestor(contextToken.parent, isPropertyAssignment)) == null ? void 0 : _b.getLastToken(sourceFile)) === contextToken || isShorthandPropertyAssignment(contextToken.parent) && getLineAndCharacterOfPosition(sourceFile, contextToken.getEnd()).line !== getLineAndCharacterOfPosition(sourceFile, position).line) {
	        source = "ObjectLiteralMemberWithComma/" /* ObjectLiteralMemberWithComma */;
	        hasAction = true;
	      }
	    }
	    if (preferences.includeCompletionsWithClassMemberSnippets && preferences.includeCompletionsWithInsertText && completionKind === 3 /* MemberLike */ && isClassLikeMemberCompletion(symbol, location, sourceFile)) {
	      let importAdder;
	      const memberCompletionEntry = getEntryForMemberCompletion(host, program, options, preferences, name, symbol, location, position, contextToken, formatContext);
	      if (memberCompletionEntry) {
	        ({ insertText, filterText, isSnippet, importAdder } = memberCompletionEntry);
	        if (importAdder == null ? void 0 : importAdder.hasFixes()) {
	          hasAction = true;
	          source = "ClassMemberSnippet/" /* ClassMemberSnippet */;
	        }
	      } else {
	        return void 0;
	      }
	    }
	    if (origin && originIsObjectLiteralMethod(origin)) {
	      ({ insertText, isSnippet, labelDetails } = origin);
	      if (!preferences.useLabelDetailsInCompletionEntries) {
	        name = name + labelDetails.detail;
	        labelDetails = void 0;
	      }
	      source = "ObjectLiteralMethodSnippet/" /* ObjectLiteralMethodSnippet */;
	      sortText = SortText.SortBelow(sortText);
	    }
	    if (isJsxIdentifierExpected && !isRightOfOpenTag && preferences.includeCompletionsWithSnippetText && preferences.jsxAttributeCompletionStyle && preferences.jsxAttributeCompletionStyle !== "none" && !(isJsxAttribute(location.parent) && location.parent.initializer)) {
	      let useBraces2 = preferences.jsxAttributeCompletionStyle === "braces";
	      const type = typeChecker.getTypeOfSymbolAtLocation(symbol, location);
	      if (preferences.jsxAttributeCompletionStyle === "auto" && !(type.flags & 528 /* BooleanLike */) && !(type.flags & 1048576 /* Union */ && find(type.types, (type2) => !!(type2.flags & 528 /* BooleanLike */)))) {
	        if (type.flags & 402653316 /* StringLike */ || type.flags & 1048576 /* Union */ && every(type.types, (type2) => !!(type2.flags & (402653316 /* StringLike */ | 32768 /* Undefined */) || isStringAndEmptyAnonymousObjectIntersection(type2)))) {
	          insertText = `${escapeSnippetText(name)}=${quote(sourceFile, preferences, "$1")}`;
	          isSnippet = true;
	        } else {
	          useBraces2 = true;
	        }
	      }
	      if (useBraces2) {
	        insertText = `${escapeSnippetText(name)}={$1}`;
	        isSnippet = true;
	      }
	    }
	    if (insertText !== void 0 && !preferences.includeCompletionsWithInsertText) {
	      return void 0;
	    }
	    if (originIsExport(origin) || originIsResolvedExport(origin)) {
	      data = originToCompletionEntryData(origin);
	      hasAction = !importStatementCompletion;
	    }
	    const parentNamedImportOrExport = findAncestor(location, isNamedImportsOrExports);
	    if ((parentNamedImportOrExport == null ? void 0 : parentNamedImportOrExport.kind) === 275 /* NamedImports */) {
	      const possibleToken = stringToToken(name);
	      if (parentNamedImportOrExport && possibleToken && (possibleToken === 135 /* AwaitKeyword */ || isNonContextualKeyword(possibleToken))) {
	        insertText = `${name} as ${name}_`;
	      }
	    }
	    return {
	      name,
	      kind: ts_SymbolDisplay_exports.getSymbolKind(typeChecker, symbol, location),
	      kindModifiers: ts_SymbolDisplay_exports.getSymbolModifiers(typeChecker, symbol),
	      sortText,
	      source,
	      hasAction: hasAction ? true : void 0,
	      isRecommended: isRecommendedCompletionMatch(symbol, recommendedCompletion, typeChecker) || void 0,
	      insertText,
	      filterText,
	      replacementSpan,
	      sourceDisplay,
	      labelDetails,
	      isSnippet,
	      isPackageJsonImport: originIsPackageJsonImport(origin) || void 0,
	      isImportStatementCompletion: !!importStatementCompletion || void 0,
	      data,
	      ...includeSymbol ? { symbol } : void 0
	    };
	  }
	  function isClassLikeMemberCompletion(symbol, location, sourceFile) {
	    if (isInJSFile(location)) {
	      return false;
	    }
	    const memberFlags = 106500 /* ClassMember */ & 900095 /* EnumMemberExcludes */;
	    return !!(symbol.flags & memberFlags) && (isClassLike(location) || location.parent && location.parent.parent && isClassElement(location.parent) && location === location.parent.name && location.parent.getLastToken(sourceFile) === location.parent.name && isClassLike(location.parent.parent) || location.parent && isSyntaxList(location) && isClassLike(location.parent));
	  }
	  function getEntryForMemberCompletion(host, program, options, preferences, name, symbol, location, position, contextToken, formatContext) {
	    const classLikeDeclaration = findAncestor(location, isClassLike);
	    if (!classLikeDeclaration) {
	      return void 0;
	    }
	    let isSnippet;
	    let insertText = name;
	    const filterText = name;
	    const checker = program.getTypeChecker();
	    const sourceFile = location.getSourceFile();
	    const printer = createSnippetPrinter({
	      removeComments: true,
	      module: options.module,
	      target: options.target,
	      omitTrailingSemicolon: false,
	      newLine: getNewLineKind(getNewLineOrDefaultFromHost(host, formatContext == null ? void 0 : formatContext.options))
	    });
	    const importAdder = ts_codefix_exports.createImportAdder(sourceFile, program, preferences, host);
	    let body;
	    if (preferences.includeCompletionsWithSnippetText) {
	      isSnippet = true;
	      const emptyStmt = factory.createEmptyStatement();
	      body = factory.createBlock(
	        [emptyStmt],
	        /*multiLine*/
	        true
	      );
	      setSnippetElement(emptyStmt, { kind: 0 /* TabStop */, order: 0 });
	    } else {
	      body = factory.createBlock(
	        [],
	        /*multiLine*/
	        true
	      );
	    }
	    let modifiers = 0 /* None */;
	    const { modifiers: presentModifiers, range: eraseRange, decorators: presentDecorators } = getPresentModifiers(contextToken, sourceFile, position);
	    const isAbstract = presentModifiers & 64 /* Abstract */ && classLikeDeclaration.modifierFlagsCache & 64 /* Abstract */;
	    let completionNodes = [];
	    ts_codefix_exports.addNewNodeForMemberSymbol(
	      symbol,
	      classLikeDeclaration,
	      sourceFile,
	      { program, host },
	      preferences,
	      importAdder,
	      // `addNewNodeForMemberSymbol` calls this callback function for each new member node
	      // it adds for the given member symbol.
	      // We store these member nodes in the `completionNodes` array.
	      // Note: there might be:
	      //  - No nodes if `addNewNodeForMemberSymbol` cannot figure out a node for the member;
	      //  - One node;
	      //  - More than one node if the member is overloaded (e.g. a method with overload signatures).
	      (node) => {
	        let requiredModifiers = 0 /* None */;
	        if (isAbstract) {
	          requiredModifiers |= 64 /* Abstract */;
	        }
	        if (isClassElement(node) && checker.getMemberOverrideModifierStatus(classLikeDeclaration, node, symbol) === 1 /* NeedsOverride */) {
	          requiredModifiers |= 16 /* Override */;
	        }
	        if (!completionNodes.length) {
	          modifiers = node.modifierFlagsCache | requiredModifiers;
	        }
	        node = factory.replaceModifiers(node, modifiers);
	        completionNodes.push(node);
	      },
	      body,
	      ts_codefix_exports.PreserveOptionalFlags.Property,
	      !!isAbstract
	    );
	    if (completionNodes.length) {
	      const isMethod = symbol.flags & 8192 /* Method */;
	      let allowedModifiers = modifiers | 16 /* Override */ | 1 /* Public */;
	      if (!isMethod) {
	        allowedModifiers |= 128 /* Ambient */ | 8 /* Readonly */;
	      } else {
	        allowedModifiers |= 1024 /* Async */;
	      }
	      const allowedAndPresent = presentModifiers & allowedModifiers;
	      if (presentModifiers & ~allowedModifiers) {
	        return void 0;
	      }
	      if (modifiers & 4 /* Protected */ && allowedAndPresent & 1 /* Public */) {
	        modifiers &= ~4 /* Protected */;
	      }
	      if (allowedAndPresent !== 0 /* None */ && !(allowedAndPresent & 1 /* Public */)) {
	        modifiers &= ~1 /* Public */;
	      }
	      modifiers |= allowedAndPresent;
	      completionNodes = completionNodes.map((node) => factory.replaceModifiers(node, modifiers));
	      if (presentDecorators == null ? void 0 : presentDecorators.length) {
	        const lastNode = completionNodes[completionNodes.length - 1];
	        if (canHaveDecorators(lastNode)) {
	          completionNodes[completionNodes.length - 1] = factory.replaceDecoratorsAndModifiers(lastNode, presentDecorators.concat(getModifiers(lastNode) || []));
	        }
	      }
	      const format = 1 /* MultiLine */ | 131072 /* NoTrailingNewLine */;
	      if (formatContext) {
	        insertText = printer.printAndFormatSnippetList(
	          format,
	          factory.createNodeArray(completionNodes),
	          sourceFile,
	          formatContext
	        );
	      } else {
	        insertText = printer.printSnippetList(
	          format,
	          factory.createNodeArray(completionNodes),
	          sourceFile
	        );
	      }
	    }
	    return { insertText, filterText, isSnippet, importAdder, eraseRange };
	  }
	  function getPresentModifiers(contextToken, sourceFile, position) {
	    if (!contextToken || getLineAndCharacterOfPosition(sourceFile, position).line > getLineAndCharacterOfPosition(sourceFile, contextToken.getEnd()).line) {
	      return { modifiers: 0 /* None */ };
	    }
	    let modifiers = 0 /* None */;
	    let decorators;
	    let contextMod;
	    const range = { pos: position, end: position };
	    if (isPropertyDeclaration(contextToken.parent) && contextToken.parent.modifiers) {
	      modifiers |= modifiersToFlags(contextToken.parent.modifiers) & 98303 /* Modifier */;
	      decorators = contextToken.parent.modifiers.filter(isDecorator) || [];
	      range.pos = Math.min(range.pos, contextToken.parent.modifiers.pos);
	    }
	    if (contextMod = isModifierLike2(contextToken)) {
	      const contextModifierFlag = modifierToFlag(contextMod);
	      if (!(modifiers & contextModifierFlag)) {
	        modifiers |= contextModifierFlag;
	        range.pos = Math.min(range.pos, contextToken.pos);
	      }
	    }
	    return { modifiers, decorators, range: range.pos !== position ? range : void 0 };
	  }
	  function isModifierLike2(node) {
	    if (isModifier(node)) {
	      return node.kind;
	    }
	    if (isIdentifier(node)) {
	      const originalKeywordKind = identifierToKeywordKind(node);
	      if (originalKeywordKind && isModifierKind(originalKeywordKind)) {
	        return originalKeywordKind;
	      }
	    }
	    return void 0;
	  }
	  function getEntryForObjectLiteralMethodCompletion(symbol, name, enclosingDeclaration, program, host, options, preferences, formatContext) {
	    const isSnippet = preferences.includeCompletionsWithSnippetText || void 0;
	    let insertText = name;
	    const sourceFile = enclosingDeclaration.getSourceFile();
	    const method = createObjectLiteralMethod(symbol, enclosingDeclaration, sourceFile, program, host, preferences);
	    if (!method) {
	      return void 0;
	    }
	    const printer = createSnippetPrinter({
	      removeComments: true,
	      module: options.module,
	      target: options.target,
	      omitTrailingSemicolon: false,
	      newLine: getNewLineKind(getNewLineOrDefaultFromHost(host, formatContext == null ? void 0 : formatContext.options))
	    });
	    if (formatContext) {
	      insertText = printer.printAndFormatSnippetList(16 /* CommaDelimited */ | 64 /* AllowTrailingComma */, factory.createNodeArray(
	        [method],
	        /*hasTrailingComma*/
	        true
	      ), sourceFile, formatContext);
	    } else {
	      insertText = printer.printSnippetList(16 /* CommaDelimited */ | 64 /* AllowTrailingComma */, factory.createNodeArray(
	        [method],
	        /*hasTrailingComma*/
	        true
	      ), sourceFile);
	    }
	    const signaturePrinter = createPrinter({
	      removeComments: true,
	      module: options.module,
	      target: options.target,
	      omitTrailingSemicolon: true
	    });
	    const methodSignature = factory.createMethodSignature(
	      /*modifiers*/
	      void 0,
	      /*name*/
	      "",
	      method.questionToken,
	      method.typeParameters,
	      method.parameters,
	      method.type
	    );
	    const labelDetails = { detail: signaturePrinter.printNode(4 /* Unspecified */, methodSignature, sourceFile) };
	    return { isSnippet, insertText, labelDetails };
	  }
	  function createObjectLiteralMethod(symbol, enclosingDeclaration, sourceFile, program, host, preferences) {
	    const declarations = symbol.getDeclarations();
	    if (!(declarations && declarations.length)) {
	      return void 0;
	    }
	    const checker = program.getTypeChecker();
	    const declaration = declarations[0];
	    const name = getSynthesizedDeepClone(
	      getNameOfDeclaration(declaration),
	      /*includeTrivia*/
	      false
	    );
	    const type = checker.getWidenedType(checker.getTypeOfSymbolAtLocation(symbol, enclosingDeclaration));
	    const quotePreference = getQuotePreference(sourceFile, preferences);
	    const builderFlags = 33554432 /* OmitThisParameter */ | (quotePreference === 0 /* Single */ ? 268435456 /* UseSingleQuotesForStringLiteralType */ : 0 /* None */);
	    switch (declaration.kind) {
	      case 171 /* PropertySignature */:
	      case 172 /* PropertyDeclaration */:
	      case 173 /* MethodSignature */:
	      case 174 /* MethodDeclaration */: {
	        let effectiveType = type.flags & 1048576 /* Union */ && type.types.length < 10 ? checker.getUnionType(type.types, 2 /* Subtype */) : type;
	        if (effectiveType.flags & 1048576 /* Union */) {
	          const functionTypes = filter(effectiveType.types, (type2) => checker.getSignaturesOfType(type2, 0 /* Call */).length > 0);
	          if (functionTypes.length === 1) {
	            effectiveType = functionTypes[0];
	          } else {
	            return void 0;
	          }
	        }
	        const signatures = checker.getSignaturesOfType(effectiveType, 0 /* Call */);
	        if (signatures.length !== 1) {
	          return void 0;
	        }
	        const typeNode = checker.typeToTypeNode(effectiveType, enclosingDeclaration, builderFlags, ts_codefix_exports.getNoopSymbolTrackerWithResolver({ program, host }));
	        if (!typeNode || !isFunctionTypeNode(typeNode)) {
	          return void 0;
	        }
	        let body;
	        if (preferences.includeCompletionsWithSnippetText) {
	          const emptyStmt = factory.createEmptyStatement();
	          body = factory.createBlock(
	            [emptyStmt],
	            /*multiLine*/
	            true
	          );
	          setSnippetElement(emptyStmt, { kind: 0 /* TabStop */, order: 0 });
	        } else {
	          body = factory.createBlock(
	            [],
	            /*multiLine*/
	            true
	          );
	        }
	        const parameters = typeNode.parameters.map(
	          (typedParam) => factory.createParameterDeclaration(
	            /*modifiers*/
	            void 0,
	            typedParam.dotDotDotToken,
	            typedParam.name,
	            /*questionToken*/
	            void 0,
	            /*type*/
	            void 0,
	            typedParam.initializer
	          )
	        );
	        return factory.createMethodDeclaration(
	          /*modifiers*/
	          void 0,
	          /*asteriskToken*/
	          void 0,
	          name,
	          /*questionToken*/
	          void 0,
	          /*typeParameters*/
	          void 0,
	          parameters,
	          /*type*/
	          void 0,
	          body
	        );
	      }
	      default:
	        return void 0;
	    }
	  }
	  function createSnippetPrinter(printerOptions) {
	    let escapes;
	    const baseWriter = ts_textChanges_exports.createWriter(getNewLineCharacter(printerOptions));
	    const printer = createPrinter(printerOptions, baseWriter);
	    const writer = {
	      ...baseWriter,
	      write: (s) => escapingWrite(s, () => baseWriter.write(s)),
	      nonEscapingWrite: baseWriter.write,
	      writeLiteral: (s) => escapingWrite(s, () => baseWriter.writeLiteral(s)),
	      writeStringLiteral: (s) => escapingWrite(s, () => baseWriter.writeStringLiteral(s)),
	      writeSymbol: (s, symbol) => escapingWrite(s, () => baseWriter.writeSymbol(s, symbol)),
	      writeParameter: (s) => escapingWrite(s, () => baseWriter.writeParameter(s)),
	      writeComment: (s) => escapingWrite(s, () => baseWriter.writeComment(s)),
	      writeProperty: (s) => escapingWrite(s, () => baseWriter.writeProperty(s))
	    };
	    return {
	      printSnippetList,
	      printAndFormatSnippetList,
	      printNode,
	      printAndFormatNode
	    };
	    function escapingWrite(s, write) {
	      const escaped = escapeSnippetText(s);
	      if (escaped !== s) {
	        const start = baseWriter.getTextPos();
	        write();
	        const end = baseWriter.getTextPos();
	        escapes = append(escapes || (escapes = []), { newText: escaped, span: { start, length: end - start } });
	      } else {
	        write();
	      }
	    }
	    function printSnippetList(format, list, sourceFile) {
	      const unescaped = printUnescapedSnippetList(format, list, sourceFile);
	      return escapes ? ts_textChanges_exports.applyChanges(unescaped, escapes) : unescaped;
	    }
	    function printUnescapedSnippetList(format, list, sourceFile) {
	      escapes = void 0;
	      writer.clear();
	      printer.writeList(format, list, sourceFile, writer);
	      return writer.getText();
	    }
	    function printAndFormatSnippetList(format, list, sourceFile, formatContext) {
	      const syntheticFile = {
	        text: printUnescapedSnippetList(
	          format,
	          list,
	          sourceFile
	        ),
	        getLineAndCharacterOfPosition(pos) {
	          return getLineAndCharacterOfPosition(this, pos);
	        }
	      };
	      const formatOptions = getFormatCodeSettingsForWriting(formatContext, sourceFile);
	      const changes = flatMap(list, (node) => {
	        const nodeWithPos = ts_textChanges_exports.assignPositionsToNode(node);
	        return ts_formatting_exports.formatNodeGivenIndentation(
	          nodeWithPos,
	          syntheticFile,
	          sourceFile.languageVariant,
	          /* indentation */
	          0,
	          /* delta */
	          0,
	          { ...formatContext, options: formatOptions }
	        );
	      });
	      const allChanges = escapes ? stableSort(concatenate(changes, escapes), (a, b) => compareTextSpans(a.span, b.span)) : changes;
	      return ts_textChanges_exports.applyChanges(syntheticFile.text, allChanges);
	    }
	    function printNode(hint, node, sourceFile) {
	      const unescaped = printUnescapedNode(hint, node, sourceFile);
	      return escapes ? ts_textChanges_exports.applyChanges(unescaped, escapes) : unescaped;
	    }
	    function printUnescapedNode(hint, node, sourceFile) {
	      escapes = void 0;
	      writer.clear();
	      printer.writeNode(hint, node, sourceFile, writer);
	      return writer.getText();
	    }
	    function printAndFormatNode(hint, node, sourceFile, formatContext) {
	      const syntheticFile = {
	        text: printUnescapedNode(
	          hint,
	          node,
	          sourceFile
	        ),
	        getLineAndCharacterOfPosition(pos) {
	          return getLineAndCharacterOfPosition(this, pos);
	        }
	      };
	      const formatOptions = getFormatCodeSettingsForWriting(formatContext, sourceFile);
	      const nodeWithPos = ts_textChanges_exports.assignPositionsToNode(node);
	      const changes = ts_formatting_exports.formatNodeGivenIndentation(
	        nodeWithPos,
	        syntheticFile,
	        sourceFile.languageVariant,
	        /* indentation */
	        0,
	        /* delta */
	        0,
	        { ...formatContext, options: formatOptions }
	      );
	      const allChanges = escapes ? stableSort(concatenate(changes, escapes), (a, b) => compareTextSpans(a.span, b.span)) : changes;
	      return ts_textChanges_exports.applyChanges(syntheticFile.text, allChanges);
	    }
	  }
	  function originToCompletionEntryData(origin) {
	    const ambientModuleName = origin.fileName ? void 0 : stripQuotes(origin.moduleSymbol.name);
	    const isPackageJsonImport = origin.isFromPackageJson ? true : void 0;
	    if (originIsResolvedExport(origin)) {
	      const resolvedData = {
	        exportName: origin.exportName,
	        exportMapKey: origin.exportMapKey,
	        moduleSpecifier: origin.moduleSpecifier,
	        ambientModuleName,
	        fileName: origin.fileName,
	        isPackageJsonImport
	      };
	      return resolvedData;
	    }
	    const unresolvedData = {
	      exportName: origin.exportName,
	      exportMapKey: origin.exportMapKey,
	      fileName: origin.fileName,
	      ambientModuleName: origin.fileName ? void 0 : stripQuotes(origin.moduleSymbol.name),
	      isPackageJsonImport: origin.isFromPackageJson ? true : void 0
	    };
	    return unresolvedData;
	  }
	  function completionEntryDataToSymbolOriginInfo(data, completionName, moduleSymbol) {
	    const isDefaultExport = data.exportName === "default" /* Default */;
	    const isFromPackageJson = !!data.isPackageJsonImport;
	    if (completionEntryDataIsResolved(data)) {
	      const resolvedOrigin = {
	        kind: 32 /* ResolvedExport */,
	        exportName: data.exportName,
	        exportMapKey: data.exportMapKey,
	        moduleSpecifier: data.moduleSpecifier,
	        symbolName: completionName,
	        fileName: data.fileName,
	        moduleSymbol,
	        isDefaultExport,
	        isFromPackageJson
	      };
	      return resolvedOrigin;
	    }
	    const unresolvedOrigin = {
	      kind: 4 /* Export */,
	      exportName: data.exportName,
	      exportMapKey: data.exportMapKey,
	      symbolName: completionName,
	      fileName: data.fileName,
	      moduleSymbol,
	      isDefaultExport,
	      isFromPackageJson
	    };
	    return unresolvedOrigin;
	  }
	  function getInsertTextAndReplacementSpanForImportCompletion(name, importStatementCompletion, origin, useSemicolons, sourceFile, options, preferences) {
	    const replacementSpan = importStatementCompletion.replacementSpan;
	    const quotedModuleSpecifier = escapeSnippetText(quote(sourceFile, preferences, origin.moduleSpecifier));
	    const exportKind = origin.isDefaultExport ? 1 /* Default */ : origin.exportName === "export=" /* ExportEquals */ ? 2 /* ExportEquals */ : 0 /* Named */;
	    const tabStop = preferences.includeCompletionsWithSnippetText ? "$1" : "";
	    const importKind = ts_codefix_exports.getImportKind(
	      sourceFile,
	      exportKind,
	      options,
	      /*forceImportKeyword*/
	      true
	    );
	    const isImportSpecifierTypeOnly = importStatementCompletion.couldBeTypeOnlyImportSpecifier;
	    const topLevelTypeOnlyText = importStatementCompletion.isTopLevelTypeOnly ? ` ${tokenToString(156 /* TypeKeyword */)} ` : " ";
	    const importSpecifierTypeOnlyText = isImportSpecifierTypeOnly ? `${tokenToString(156 /* TypeKeyword */)} ` : "";
	    const suffix = useSemicolons ? ";" : "";
	    switch (importKind) {
	      case 3 /* CommonJS */:
	        return { replacementSpan, insertText: `import${topLevelTypeOnlyText}${escapeSnippetText(name)}${tabStop} = require(${quotedModuleSpecifier})${suffix}` };
	      case 1 /* Default */:
	        return { replacementSpan, insertText: `import${topLevelTypeOnlyText}${escapeSnippetText(name)}${tabStop} from ${quotedModuleSpecifier}${suffix}` };
	      case 2 /* Namespace */:
	        return { replacementSpan, insertText: `import${topLevelTypeOnlyText}* as ${escapeSnippetText(name)} from ${quotedModuleSpecifier}${suffix}` };
	      case 0 /* Named */:
	        return { replacementSpan, insertText: `import${topLevelTypeOnlyText}{ ${importSpecifierTypeOnlyText}${escapeSnippetText(name)}${tabStop} } from ${quotedModuleSpecifier}${suffix}` };
	    }
	  }
	  function quotePropertyName(sourceFile, preferences, name) {
	    if (/^\d+$/.test(name)) {
	      return name;
	    }
	    return quote(sourceFile, preferences, name);
	  }
	  function isRecommendedCompletionMatch(localSymbol, recommendedCompletion, checker) {
	    return localSymbol === recommendedCompletion || !!(localSymbol.flags & 1048576 /* ExportValue */) && checker.getExportSymbolOfSymbol(localSymbol) === recommendedCompletion;
	  }
	  function getSourceFromOrigin(origin) {
	    if (originIsExport(origin)) {
	      return stripQuotes(origin.moduleSymbol.name);
	    }
	    if (originIsResolvedExport(origin)) {
	      return origin.moduleSpecifier;
	    }
	    if ((origin == null ? void 0 : origin.kind) === 1 /* ThisType */) {
	      return "ThisProperty/" /* ThisProperty */;
	    }
	    if ((origin == null ? void 0 : origin.kind) === 64 /* TypeOnlyAlias */) {
	      return "TypeOnlyAlias/" /* TypeOnlyAlias */;
	    }
	  }
	  function getCompletionEntriesFromSymbols(symbols, entries, replacementToken, contextToken, location, position, sourceFile, host, program, target, log, kind, preferences, compilerOptions, formatContext, isTypeOnlyLocation, propertyAccessToConvert, jsxIdentifierExpected, isJsxInitializer, importStatementCompletion, recommendedCompletion, symbolToOriginInfoMap, symbolToSortTextMap, isJsxIdentifierExpected, isRightOfOpenTag, includeSymbol = false) {
	    const start = timestamp();
	    const variableOrParameterDeclaration = getVariableOrParameterDeclaration(contextToken, location);
	    const useSemicolons = probablyUsesSemicolons(sourceFile);
	    const typeChecker = program.getTypeChecker();
	    const uniques = /* @__PURE__ */ new Map();
	    for (let i = 0; i < symbols.length; i++) {
	      const symbol = symbols[i];
	      const origin = symbolToOriginInfoMap == null ? void 0 : symbolToOriginInfoMap[i];
	      const info = getCompletionEntryDisplayNameForSymbol(symbol, target, origin, kind, !!jsxIdentifierExpected);
	      if (!info || uniques.get(info.name) && (!origin || !originIsObjectLiteralMethod(origin)) || kind === 1 /* Global */ && symbolToSortTextMap && !shouldIncludeSymbol(symbol, symbolToSortTextMap)) {
	        continue;
	      }
	      if (!isTypeOnlyLocation && isInJSFile(sourceFile) && symbolAppearsToBeTypeOnly(symbol)) {
	        continue;
	      }
	      const { name, needsConvertPropertyAccess } = info;
	      const originalSortText = (symbolToSortTextMap == null ? void 0 : symbolToSortTextMap[getSymbolId(symbol)]) ?? SortText.LocationPriority;
	      const sortText = isDeprecated(symbol, typeChecker) ? SortText.Deprecated(originalSortText) : originalSortText;
	      const entry = createCompletionEntry(
	        symbol,
	        sortText,
	        replacementToken,
	        contextToken,
	        location,
	        position,
	        sourceFile,
	        host,
	        program,
	        name,
	        needsConvertPropertyAccess,
	        origin,
	        recommendedCompletion,
	        propertyAccessToConvert,
	        isJsxInitializer,
	        importStatementCompletion,
	        useSemicolons,
	        compilerOptions,
	        preferences,
	        kind,
	        formatContext,
	        isJsxIdentifierExpected,
	        isRightOfOpenTag,
	        includeSymbol
	      );
	      if (!entry) {
	        continue;
	      }
	      const shouldShadowLaterSymbols = (!origin || originIsTypeOnlyAlias(origin)) && !(symbol.parent === void 0 && !some(symbol.declarations, (d) => d.getSourceFile() === location.getSourceFile()));
	      uniques.set(name, shouldShadowLaterSymbols);
	      insertSorted(
	        entries,
	        entry,
	        compareCompletionEntries,
	        /*allowDuplicates*/
	        true
	      );
	    }
	    log("getCompletionsAtPosition: getCompletionEntriesFromSymbols: " + (timestamp() - start));
	    return {
	      has: (name) => uniques.has(name),
	      add: (name) => uniques.set(name, true)
	    };
	    function shouldIncludeSymbol(symbol, symbolToSortTextMap2) {
	      var _a;
	      let allFlags = symbol.flags;
	      if (!isSourceFile(location)) {
	        if (isExportAssignment(location.parent)) {
	          return true;
	        }
	        if (tryCast(variableOrParameterDeclaration, isVariableDeclaration) && symbol.valueDeclaration === variableOrParameterDeclaration) {
	          return false;
	        }
	        const symbolDeclaration = symbol.valueDeclaration ?? ((_a = symbol.declarations) == null ? void 0 : _a[0]);
	        if (variableOrParameterDeclaration && symbolDeclaration && (isTypeParameterDeclaration(variableOrParameterDeclaration) && isTypeParameterDeclaration(symbolDeclaration) || isParameter(variableOrParameterDeclaration) && isParameter(symbolDeclaration))) {
	          const symbolDeclarationPos = symbolDeclaration.pos;
	          const parameters = isParameter(variableOrParameterDeclaration) ? variableOrParameterDeclaration.parent.parameters : isInferTypeNode(variableOrParameterDeclaration.parent) ? void 0 : variableOrParameterDeclaration.parent.typeParameters;
	          if (symbolDeclarationPos >= variableOrParameterDeclaration.pos && parameters && symbolDeclarationPos < parameters.end) {
	            return false;
	          }
	        }
	        const symbolOrigin = skipAlias(symbol, typeChecker);
	        if (!!sourceFile.externalModuleIndicator && !compilerOptions.allowUmdGlobalAccess && symbolToSortTextMap2[getSymbolId(symbol)] === SortText.GlobalsOrKeywords && (symbolToSortTextMap2[getSymbolId(symbolOrigin)] === SortText.AutoImportSuggestions || symbolToSortTextMap2[getSymbolId(symbolOrigin)] === SortText.LocationPriority)) {
	          return false;
	        }
	        allFlags |= getCombinedLocalAndExportSymbolFlags(symbolOrigin);
	        if (isInRightSideOfInternalImportEqualsDeclaration(location)) {
	          return !!(allFlags & 1920 /* Namespace */);
	        }
	        if (isTypeOnlyLocation) {
	          return symbolCanBeReferencedAtTypeLocation(symbol, typeChecker);
	        }
	      }
	      return !!(allFlags & 111551 /* Value */);
	    }
	    function symbolAppearsToBeTypeOnly(symbol) {
	      var _a;
	      const flags = getCombinedLocalAndExportSymbolFlags(skipAlias(symbol, typeChecker));
	      return !(flags & 111551 /* Value */) && (!isInJSFile((_a = symbol.declarations) == null ? void 0 : _a[0]) || !!(flags & 788968 /* Type */));
	    }
	  }
	  function getLabelCompletionAtPosition(node) {
	    const entries = getLabelStatementCompletions(node);
	    if (entries.length) {
	      return { isGlobalCompletion: false, isMemberCompletion: false, isNewIdentifierLocation: false, entries };
	    }
	  }
	  function getLabelStatementCompletions(node) {
	    const entries = [];
	    const uniques = /* @__PURE__ */ new Map();
	    let current = node;
	    while (current) {
	      if (isFunctionLike(current)) {
	        break;
	      }
	      if (isLabeledStatement(current)) {
	        const name = current.label.text;
	        if (!uniques.has(name)) {
	          uniques.set(name, true);
	          entries.push({
	            name,
	            kindModifiers: "" /* none */,
	            kind: "label" /* label */,
	            sortText: SortText.LocationPriority
	          });
	        }
	      }
	      current = current.parent;
	    }
	    return entries;
	  }
	  function getSymbolCompletionFromEntryId(program, log, sourceFile, position, entryId, host, preferences) {
	    if (entryId.source === "SwitchCases/" /* SwitchCases */) {
	      return { type: "cases" };
	    }
	    if (entryId.data) {
	      const autoImport = getAutoImportSymbolFromCompletionEntryData(entryId.name, entryId.data, program, host);
	      if (autoImport) {
	        const { contextToken: contextToken2, previousToken: previousToken2 } = getRelevantTokens(position, sourceFile);
	        return {
	          type: "symbol",
	          symbol: autoImport.symbol,
	          location: getTouchingPropertyName(sourceFile, position),
	          previousToken: previousToken2,
	          contextToken: contextToken2,
	          isJsxInitializer: false,
	          isTypeOnlyLocation: false,
	          origin: autoImport.origin
	        };
	      }
	    }
	    const compilerOptions = program.getCompilerOptions();
	    const completionData = getCompletionData(
	      program,
	      log,
	      sourceFile,
	      compilerOptions,
	      position,
	      { includeCompletionsForModuleExports: true, includeCompletionsWithInsertText: true },
	      entryId,
	      host,
	      /*formatContext*/
	      void 0
	    );
	    if (!completionData) {
	      return { type: "none" };
	    }
	    if (completionData.kind !== 0 /* Data */) {
	      return { type: "request", request: completionData };
	    }
	    const { symbols, literals, location, completionKind, symbolToOriginInfoMap, contextToken, previousToken, isJsxInitializer, isTypeOnlyLocation } = completionData;
	    const literal = find(literals, (l) => completionNameForLiteral(sourceFile, preferences, l) === entryId.name);
	    if (literal !== void 0)
	      return { type: "literal", literal };
	    return firstDefined(symbols, (symbol, index) => {
	      const origin = symbolToOriginInfoMap[index];
	      const info = getCompletionEntryDisplayNameForSymbol(symbol, getEmitScriptTarget(compilerOptions), origin, completionKind, completionData.isJsxIdentifierExpected);
	      return info && info.name === entryId.name && (entryId.source === "ClassMemberSnippet/" /* ClassMemberSnippet */ && symbol.flags & 106500 /* ClassMember */ || entryId.source === "ObjectLiteralMethodSnippet/" /* ObjectLiteralMethodSnippet */ && symbol.flags & (4 /* Property */ | 8192 /* Method */) || getSourceFromOrigin(origin) === entryId.source || entryId.source === "ObjectLiteralMemberWithComma/" /* ObjectLiteralMemberWithComma */) ? { type: "symbol", symbol, location, origin, contextToken, previousToken, isJsxInitializer, isTypeOnlyLocation } : void 0;
	    }) || { type: "none" };
	  }
	  function getCompletionEntryDetails(program, log, sourceFile, position, entryId, host, formatContext, preferences, cancellationToken) {
	    const typeChecker = program.getTypeChecker();
	    const compilerOptions = program.getCompilerOptions();
	    const { name, source, data } = entryId;
	    const { previousToken, contextToken } = getRelevantTokens(position, sourceFile);
	    if (isInString(sourceFile, position, previousToken)) {
	      return ts_Completions_StringCompletions_exports.getStringLiteralCompletionDetails(name, sourceFile, position, previousToken, program, host, cancellationToken, preferences);
	    }
	    const symbolCompletion = getSymbolCompletionFromEntryId(program, log, sourceFile, position, entryId, host, preferences);
	    switch (symbolCompletion.type) {
	      case "request": {
	        const { request } = symbolCompletion;
	        switch (request.kind) {
	          case 1 /* JsDocTagName */:
	            return ts_JsDoc_exports.getJSDocTagNameCompletionDetails(name);
	          case 2 /* JsDocTag */:
	            return ts_JsDoc_exports.getJSDocTagCompletionDetails(name);
	          case 3 /* JsDocParameterName */:
	            return ts_JsDoc_exports.getJSDocParameterNameCompletionDetails(name);
	          case 4 /* Keywords */:
	            return some(request.keywordCompletions, (c) => c.name === name) ? createSimpleDetails(name, "keyword" /* keyword */, 5 /* keyword */) : void 0;
	          default:
	            return Debug.assertNever(request);
	        }
	      }
	      case "symbol": {
	        const { symbol, location, contextToken: contextToken2, origin, previousToken: previousToken2 } = symbolCompletion;
	        const { codeActions, sourceDisplay } = getCompletionEntryCodeActionsAndSourceDisplay(name, location, contextToken2, origin, symbol, program, host, compilerOptions, sourceFile, position, previousToken2, formatContext, preferences, data, source, cancellationToken);
	        const symbolName2 = originIsComputedPropertyName(origin) ? origin.symbolName : symbol.name;
	        return createCompletionDetailsForSymbol(symbol, symbolName2, typeChecker, sourceFile, location, cancellationToken, codeActions, sourceDisplay);
	      }
	      case "literal": {
	        const { literal } = symbolCompletion;
	        return createSimpleDetails(completionNameForLiteral(sourceFile, preferences, literal), "string" /* string */, typeof literal === "string" ? 8 /* stringLiteral */ : 7 /* numericLiteral */);
	      }
	      case "cases": {
	        const snippets = getExhaustiveCaseSnippets(
	          contextToken.parent,
	          sourceFile,
	          preferences,
	          program.getCompilerOptions(),
	          host,
	          program,
	          /*formatContext*/
	          void 0
	        );
	        if (snippets == null ? void 0 : snippets.importAdder.hasFixes()) {
	          const { entry, importAdder } = snippets;
	          const changes = ts_textChanges_exports.ChangeTracker.with(
	            { host, formatContext, preferences },
	            importAdder.writeFixes
	          );
	          return {
	            name: entry.name,
	            kind: "" /* unknown */,
	            kindModifiers: "",
	            displayParts: [],
	            sourceDisplay: void 0,
	            codeActions: [{
	              changes,
	              description: diagnosticToString([Diagnostics.Includes_imports_of_types_referenced_by_0, name])
	            }]
	          };
	        }
	        return {
	          name,
	          kind: "" /* unknown */,
	          kindModifiers: "",
	          displayParts: [],
	          sourceDisplay: void 0
	        };
	      }
	      case "none":
	        return allKeywordsCompletions().some((c) => c.name === name) ? createSimpleDetails(name, "keyword" /* keyword */, 5 /* keyword */) : void 0;
	      default:
	        Debug.assertNever(symbolCompletion);
	    }
	  }
	  function createSimpleDetails(name, kind, kind2) {
	    return createCompletionDetails(name, "" /* none */, kind, [displayPart(name, kind2)]);
	  }
	  function createCompletionDetailsForSymbol(symbol, name, checker, sourceFile, location, cancellationToken, codeActions, sourceDisplay) {
	    const { displayParts, documentation, symbolKind, tags } = checker.runWithCancellationToken(cancellationToken, (checker2) => ts_SymbolDisplay_exports.getSymbolDisplayPartsDocumentationAndSymbolKind(checker2, symbol, sourceFile, location, location, 7 /* All */));
	    return createCompletionDetails(name, ts_SymbolDisplay_exports.getSymbolModifiers(checker, symbol), symbolKind, displayParts, documentation, tags, codeActions, sourceDisplay);
	  }
	  function createCompletionDetails(name, kindModifiers, kind, displayParts, documentation, tags, codeActions, source) {
	    return { name, kindModifiers, kind, displayParts, documentation, tags, codeActions, source, sourceDisplay: source };
	  }
	  function getCompletionEntryCodeActionsAndSourceDisplay(name, location, contextToken, origin, symbol, program, host, compilerOptions, sourceFile, position, previousToken, formatContext, preferences, data, source, cancellationToken) {
	    if (data == null ? void 0 : data.moduleSpecifier) {
	      if (previousToken && getImportStatementCompletionInfo(contextToken || previousToken, sourceFile).replacementSpan) {
	        return { codeActions: void 0, sourceDisplay: [textPart(data.moduleSpecifier)] };
	      }
	    }
	    if (source === "ClassMemberSnippet/" /* ClassMemberSnippet */) {
	      const { importAdder, eraseRange } = getEntryForMemberCompletion(
	        host,
	        program,
	        compilerOptions,
	        preferences,
	        name,
	        symbol,
	        location,
	        position,
	        contextToken,
	        formatContext
	      );
	      if (importAdder || eraseRange) {
	        const changes = ts_textChanges_exports.ChangeTracker.with(
	          { host, formatContext, preferences },
	          (tracker) => {
	            if (importAdder) {
	              importAdder.writeFixes(tracker);
	            }
	            if (eraseRange) {
	              tracker.deleteRange(sourceFile, eraseRange);
	            }
	          }
	        );
	        return {
	          sourceDisplay: void 0,
	          codeActions: [{
	            changes,
	            description: diagnosticToString([Diagnostics.Includes_imports_of_types_referenced_by_0, name])
	          }]
	        };
	      }
	    }
	    if (originIsTypeOnlyAlias(origin)) {
	      const codeAction2 = ts_codefix_exports.getPromoteTypeOnlyCompletionAction(
	        sourceFile,
	        origin.declaration.name,
	        program,
	        host,
	        formatContext,
	        preferences
	      );
	      Debug.assertIsDefined(codeAction2, "Expected to have a code action for promoting type-only alias");
	      return { codeActions: [codeAction2], sourceDisplay: void 0 };
	    }
	    if (source === "ObjectLiteralMemberWithComma/" /* ObjectLiteralMemberWithComma */ && contextToken) {
	      const changes = ts_textChanges_exports.ChangeTracker.with(
	        { host, formatContext, preferences },
	        (tracker) => tracker.insertText(sourceFile, contextToken.end, ",")
	      );
	      if (changes) {
	        return {
	          sourceDisplay: void 0,
	          codeActions: [{
	            changes,
	            description: diagnosticToString([Diagnostics.Add_missing_comma_for_object_member_completion_0, name])
	          }]
	        };
	      }
	    }
	    if (!origin || !(originIsExport(origin) || originIsResolvedExport(origin))) {
	      return { codeActions: void 0, sourceDisplay: void 0 };
	    }
	    const checker = origin.isFromPackageJson ? host.getPackageJsonAutoImportProvider().getTypeChecker() : program.getTypeChecker();
	    const { moduleSymbol } = origin;
	    const targetSymbol = checker.getMergedSymbol(skipAlias(symbol.exportSymbol || symbol, checker));
	    const isJsxOpeningTagName = (contextToken == null ? void 0 : contextToken.kind) === 30 /* LessThanToken */ && isJsxOpeningLikeElement(contextToken.parent);
	    const { moduleSpecifier, codeAction } = ts_codefix_exports.getImportCompletionAction(
	      targetSymbol,
	      moduleSymbol,
	      data == null ? void 0 : data.exportMapKey,
	      sourceFile,
	      name,
	      isJsxOpeningTagName,
	      host,
	      program,
	      formatContext,
	      previousToken && isIdentifier(previousToken) ? previousToken.getStart(sourceFile) : position,
	      preferences,
	      cancellationToken
	    );
	    Debug.assert(!(data == null ? void 0 : data.moduleSpecifier) || moduleSpecifier === data.moduleSpecifier);
	    return { sourceDisplay: [textPart(moduleSpecifier)], codeActions: [codeAction] };
	  }
	  function getCompletionEntrySymbol(program, log, sourceFile, position, entryId, host, preferences) {
	    const completion = getSymbolCompletionFromEntryId(program, log, sourceFile, position, entryId, host, preferences);
	    return completion.type === "symbol" ? completion.symbol : void 0;
	  }
	  function getRecommendedCompletion(previousToken, contextualType, checker) {
	    return firstDefined(contextualType && (contextualType.isUnion() ? contextualType.types : [contextualType]), (type) => {
	      const symbol = type && type.symbol;
	      return symbol && (symbol.flags & (8 /* EnumMember */ | 384 /* Enum */ | 32 /* Class */) && !isAbstractConstructorSymbol(symbol)) ? getFirstSymbolInChain(symbol, previousToken, checker) : void 0;
	    });
	  }
	  function getContextualType(previousToken, position, sourceFile, checker) {
	    const { parent: parent2 } = previousToken;
	    switch (previousToken.kind) {
	      case 80 /* Identifier */:
	        return getContextualTypeFromParent(previousToken, checker);
	      case 64 /* EqualsToken */:
	        switch (parent2.kind) {
	          case 260 /* VariableDeclaration */:
	            return checker.getContextualType(parent2.initializer);
	          case 226 /* BinaryExpression */:
	            return checker.getTypeAtLocation(parent2.left);
	          case 291 /* JsxAttribute */:
	            return checker.getContextualTypeForJsxAttribute(parent2);
	          default:
	            return void 0;
	        }
	      case 105 /* NewKeyword */:
	        return checker.getContextualType(parent2);
	      case 84 /* CaseKeyword */:
	        const caseClause = tryCast(parent2, isCaseClause);
	        return caseClause ? getSwitchedType(caseClause, checker) : void 0;
	      case 19 /* OpenBraceToken */:
	        return isJsxExpression(parent2) && !isJsxElement(parent2.parent) && !isJsxFragment(parent2.parent) ? checker.getContextualTypeForJsxAttribute(parent2.parent) : void 0;
	      default:
	        const argInfo = ts_SignatureHelp_exports.getArgumentInfoForCompletions(previousToken, position, sourceFile, checker);
	        return argInfo ? checker.getContextualTypeForArgumentAtIndex(argInfo.invocation, argInfo.argumentIndex) : isEqualityOperatorKind(previousToken.kind) && isBinaryExpression(parent2) && isEqualityOperatorKind(parent2.operatorToken.kind) ? (
	          // completion at `x ===/**/` should be for the right side
	          checker.getTypeAtLocation(parent2.left)
	        ) : checker.getContextualType(previousToken, 4 /* Completions */) || checker.getContextualType(previousToken);
	    }
	  }
	  function getFirstSymbolInChain(symbol, enclosingDeclaration, checker) {
	    const chain = checker.getAccessibleSymbolChain(
	      symbol,
	      enclosingDeclaration,
	      /*meaning*/
	      -1 /* All */,
	      /*useOnlyExternalAliasing*/
	      false
	    );
	    if (chain)
	      return first(chain);
	    return symbol.parent && (isModuleSymbol(symbol.parent) ? symbol : getFirstSymbolInChain(symbol.parent, enclosingDeclaration, checker));
	  }
	  function isModuleSymbol(symbol) {
	    var _a;
	    return !!((_a = symbol.declarations) == null ? void 0 : _a.some((d) => d.kind === 312 /* SourceFile */));
	  }
	  function getCompletionData(program, log, sourceFile, compilerOptions, position, preferences, detailsEntryId, host, formatContext, cancellationToken) {
	    const typeChecker = program.getTypeChecker();
	    const inCheckedFile = isCheckedFile(sourceFile, compilerOptions);
	    let start = timestamp();
	    let currentToken = getTokenAtPosition(sourceFile, position);
	    log("getCompletionData: Get current token: " + (timestamp() - start));
	    start = timestamp();
	    const insideComment = isInComment(sourceFile, position, currentToken);
	    log("getCompletionData: Is inside comment: " + (timestamp() - start));
	    let insideJsDocTagTypeExpression = false;
	    let isInSnippetScope = false;
	    if (insideComment) {
	      if (hasDocComment(sourceFile, position)) {
	        if (sourceFile.text.charCodeAt(position - 1) === 64 /* at */) {
	          return { kind: 1 /* JsDocTagName */ };
	        } else {
	          const lineStart = getLineStartPositionForPosition(position, sourceFile);
	          if (!/[^*|\s(/)]/.test(sourceFile.text.substring(lineStart, position))) {
	            return { kind: 2 /* JsDocTag */ };
	          }
	        }
	      }
	      const tag = getJsDocTagAtPosition(currentToken, position);
	      if (tag) {
	        if (tag.tagName.pos <= position && position <= tag.tagName.end) {
	          return { kind: 1 /* JsDocTagName */ };
	        }
	        const typeExpression = tryGetTypeExpressionFromTag(tag);
	        if (typeExpression) {
	          currentToken = getTokenAtPosition(sourceFile, position);
	          if (!currentToken || !isDeclarationName(currentToken) && (currentToken.parent.kind !== 355 /* JSDocPropertyTag */ || currentToken.parent.name !== currentToken)) {
	            insideJsDocTagTypeExpression = isCurrentlyEditingNode(typeExpression);
	          }
	        }
	        if (!insideJsDocTagTypeExpression && isJSDocParameterTag(tag) && (nodeIsMissing(tag.name) || tag.name.pos <= position && position <= tag.name.end)) {
	          return { kind: 3 /* JsDocParameterName */, tag };
	        }
	      }
	      if (!insideJsDocTagTypeExpression) {
	        log("Returning an empty list because completion was inside a regular comment or plain text part of a JsDoc comment.");
	        return void 0;
	      }
	    }
	    start = timestamp();
	    const isJsOnlyLocation = !insideJsDocTagTypeExpression && isSourceFileJS(sourceFile);
	    const tokens = getRelevantTokens(position, sourceFile);
	    const previousToken = tokens.previousToken;
	    let contextToken = tokens.contextToken;
	    log("getCompletionData: Get previous token: " + (timestamp() - start));
	    let node = currentToken;
	    let propertyAccessToConvert;
	    let isRightOfDot = false;
	    let isRightOfQuestionDot = false;
	    let isRightOfOpenTag = false;
	    let isStartingCloseTag = false;
	    let isJsxInitializer = false;
	    let isJsxIdentifierExpected = false;
	    let importStatementCompletion;
	    let location = getTouchingPropertyName(sourceFile, position);
	    let keywordFilters = 0 /* None */;
	    let isNewIdentifierLocation = false;
	    let flags = 0 /* None */;
	    if (contextToken) {
	      const importStatementCompletionInfo = getImportStatementCompletionInfo(contextToken, sourceFile);
	      if (importStatementCompletionInfo.keywordCompletion) {
	        if (importStatementCompletionInfo.isKeywordOnlyCompletion) {
	          return {
	            kind: 4 /* Keywords */,
	            keywordCompletions: [keywordToCompletionEntry(importStatementCompletionInfo.keywordCompletion)],
	            isNewIdentifierLocation: importStatementCompletionInfo.isNewIdentifierLocation
	          };
	        }
	        keywordFilters = keywordFiltersFromSyntaxKind(importStatementCompletionInfo.keywordCompletion);
	      }
	      if (importStatementCompletionInfo.replacementSpan && preferences.includeCompletionsForImportStatements && preferences.includeCompletionsWithInsertText) {
	        flags |= 2 /* IsImportStatementCompletion */;
	        importStatementCompletion = importStatementCompletionInfo;
	        isNewIdentifierLocation = importStatementCompletionInfo.isNewIdentifierLocation;
	      }
	      if (!importStatementCompletionInfo.replacementSpan && isCompletionListBlocker(contextToken)) {
	        log("Returning an empty list because completion was requested in an invalid position.");
	        return keywordFilters ? keywordCompletionData(keywordFilters, isJsOnlyLocation, isNewIdentifierDefinitionLocation()) : void 0;
	      }
	      let parent2 = contextToken.parent;
	      if (contextToken.kind === 25 /* DotToken */ || contextToken.kind === 29 /* QuestionDotToken */) {
	        isRightOfDot = contextToken.kind === 25 /* DotToken */;
	        isRightOfQuestionDot = contextToken.kind === 29 /* QuestionDotToken */;
	        switch (parent2.kind) {
	          case 211 /* PropertyAccessExpression */:
	            propertyAccessToConvert = parent2;
	            node = propertyAccessToConvert.expression;
	            const leftmostAccessExpression = getLeftmostAccessExpression(propertyAccessToConvert);
	            if (nodeIsMissing(leftmostAccessExpression) || (isCallExpression(node) || isFunctionLike(node)) && node.end === contextToken.pos && node.getChildCount(sourceFile) && last(node.getChildren(sourceFile)).kind !== 22 /* CloseParenToken */) {
	              return void 0;
	            }
	            break;
	          case 166 /* QualifiedName */:
	            node = parent2.left;
	            break;
	          case 267 /* ModuleDeclaration */:
	            node = parent2.name;
	            break;
	          case 205 /* ImportType */:
	            node = parent2;
	            break;
	          case 236 /* MetaProperty */:
	            node = parent2.getFirstToken(sourceFile);
	            Debug.assert(node.kind === 102 /* ImportKeyword */ || node.kind === 105 /* NewKeyword */);
	            break;
	          default:
	            return void 0;
	        }
	      } else if (!importStatementCompletion) {
	        if (parent2 && parent2.kind === 211 /* PropertyAccessExpression */) {
	          contextToken = parent2;
	          parent2 = parent2.parent;
	        }
	        if (currentToken.parent === location) {
	          switch (currentToken.kind) {
	            case 32 /* GreaterThanToken */:
	              if (currentToken.parent.kind === 284 /* JsxElement */ || currentToken.parent.kind === 286 /* JsxOpeningElement */) {
	                location = currentToken;
	              }
	              break;
	            case 44 /* SlashToken */:
	              if (currentToken.parent.kind === 285 /* JsxSelfClosingElement */) {
	                location = currentToken;
	              }
	              break;
	          }
	        }
	        switch (parent2.kind) {
	          case 287 /* JsxClosingElement */:
	            if (contextToken.kind === 44 /* SlashToken */) {
	              isStartingCloseTag = true;
	              location = contextToken;
	            }
	            break;
	          case 226 /* BinaryExpression */:
	            if (!binaryExpressionMayBeOpenTag(parent2)) {
	              break;
	            }
	          case 285 /* JsxSelfClosingElement */:
	          case 284 /* JsxElement */:
	          case 286 /* JsxOpeningElement */:
	            isJsxIdentifierExpected = true;
	            if (contextToken.kind === 30 /* LessThanToken */) {
	              isRightOfOpenTag = true;
	              location = contextToken;
	            }
	            break;
	          case 294 /* JsxExpression */:
	          case 293 /* JsxSpreadAttribute */:
	            if (previousToken.kind === 20 /* CloseBraceToken */ || previousToken.kind === 80 /* Identifier */ && previousToken.parent.kind === 291 /* JsxAttribute */) {
	              isJsxIdentifierExpected = true;
	            }
	            break;
	          case 291 /* JsxAttribute */:
	            if (parent2.initializer === previousToken && previousToken.end < position) {
	              isJsxIdentifierExpected = true;
	              break;
	            }
	            switch (previousToken.kind) {
	              case 64 /* EqualsToken */:
	                isJsxInitializer = true;
	                break;
	              case 80 /* Identifier */:
	                isJsxIdentifierExpected = true;
	                if (parent2 !== previousToken.parent && !parent2.initializer && findChildOfKind(parent2, 64 /* EqualsToken */, sourceFile)) {
	                  isJsxInitializer = previousToken;
	                }
	            }
	            break;
	        }
	      }
	    }
	    const semanticStart = timestamp();
	    let completionKind = 5 /* None */;
	    let hasUnresolvedAutoImports = false;
	    let symbols = [];
	    let importSpecifierResolver;
	    const symbolToOriginInfoMap = [];
	    const symbolToSortTextMap = [];
	    const seenPropertySymbols = /* @__PURE__ */ new Map();
	    const isTypeOnlyLocation = isTypeOnlyCompletion();
	    const getModuleSpecifierResolutionHost = memoizeOne((isFromPackageJson) => {
	      return createModuleSpecifierResolutionHost(isFromPackageJson ? host.getPackageJsonAutoImportProvider() : program, host);
	    });
	    if (isRightOfDot || isRightOfQuestionDot) {
	      getTypeScriptMemberSymbols();
	    } else if (isRightOfOpenTag) {
	      symbols = typeChecker.getJsxIntrinsicTagNamesAt(location);
	      Debug.assertEachIsDefined(symbols, "getJsxIntrinsicTagNames() should all be defined");
	      tryGetGlobalSymbols();
	      completionKind = 1 /* Global */;
	      keywordFilters = 0 /* None */;
	    } else if (isStartingCloseTag) {
	      const tagName = contextToken.parent.parent.openingElement.tagName;
	      const tagSymbol = typeChecker.getSymbolAtLocation(tagName);
	      if (tagSymbol) {
	        symbols = [tagSymbol];
	      }
	      completionKind = 1 /* Global */;
	      keywordFilters = 0 /* None */;
	    } else {
	      if (!tryGetGlobalSymbols()) {
	        return keywordFilters ? keywordCompletionData(keywordFilters, isJsOnlyLocation, isNewIdentifierLocation) : void 0;
	      }
	    }
	    log("getCompletionData: Semantic work: " + (timestamp() - semanticStart));
	    const contextualType = previousToken && getContextualType(previousToken, position, sourceFile, typeChecker);
	    const isLiteralExpected = !tryCast(previousToken, isStringLiteralLike) && !isJsxIdentifierExpected;
	    const literals = !isLiteralExpected ? [] : mapDefined(
	      contextualType && (contextualType.isUnion() ? contextualType.types : [contextualType]),
	      (t) => t.isLiteral() && !(t.flags & 1024 /* EnumLiteral */) ? t.value : void 0
	    );
	    const recommendedCompletion = previousToken && contextualType && getRecommendedCompletion(previousToken, contextualType, typeChecker);
	    return {
	      kind: 0 /* Data */,
	      symbols,
	      completionKind,
	      isInSnippetScope,
	      propertyAccessToConvert,
	      isNewIdentifierLocation,
	      location,
	      keywordFilters,
	      literals,
	      symbolToOriginInfoMap,
	      recommendedCompletion,
	      previousToken,
	      contextToken,
	      isJsxInitializer,
	      insideJsDocTagTypeExpression,
	      symbolToSortTextMap,
	      isTypeOnlyLocation,
	      isJsxIdentifierExpected,
	      isRightOfOpenTag,
	      isRightOfDotOrQuestionDot: isRightOfDot || isRightOfQuestionDot,
	      importStatementCompletion,
	      hasUnresolvedAutoImports,
	      flags
	    };
	    function isTagWithTypeExpression(tag) {
	      switch (tag.kind) {
	        case 348 /* JSDocParameterTag */:
	        case 355 /* JSDocPropertyTag */:
	        case 349 /* JSDocReturnTag */:
	        case 351 /* JSDocTypeTag */:
	        case 353 /* JSDocTypedefTag */:
	        case 356 /* JSDocThrowsTag */:
	        case 357 /* JSDocSatisfiesTag */:
	          return true;
	        case 352 /* JSDocTemplateTag */:
	          return !!tag.constraint;
	        default:
	          return false;
	      }
	    }
	    function tryGetTypeExpressionFromTag(tag) {
	      if (isTagWithTypeExpression(tag)) {
	        const typeExpression = isJSDocTemplateTag(tag) ? tag.constraint : tag.typeExpression;
	        return typeExpression && typeExpression.kind === 316 /* JSDocTypeExpression */ ? typeExpression : void 0;
	      }
	      if (isJSDocAugmentsTag(tag) || isJSDocImplementsTag(tag)) {
	        return tag.class;
	      }
	      return void 0;
	    }
	    function getTypeScriptMemberSymbols() {
	      completionKind = 2 /* PropertyAccess */;
	      const isImportType = isLiteralImportTypeNode(node);
	      const isTypeLocation = isImportType && !node.isTypeOf || isPartOfTypeNode(node.parent) || isPossiblyTypeArgumentPosition(contextToken, sourceFile, typeChecker);
	      const isRhsOfImportDeclaration = isInRightSideOfInternalImportEqualsDeclaration(node);
	      if (isEntityName(node) || isImportType || isPropertyAccessExpression(node)) {
	        const isNamespaceName = isModuleDeclaration(node.parent);
	        if (isNamespaceName)
	          isNewIdentifierLocation = true;
	        let symbol = typeChecker.getSymbolAtLocation(node);
	        if (symbol) {
	          symbol = skipAlias(symbol, typeChecker);
	          if (symbol.flags & (1536 /* Module */ | 384 /* Enum */)) {
	            const exportedSymbols = typeChecker.getExportsOfModule(symbol);
	            Debug.assertEachIsDefined(exportedSymbols, "getExportsOfModule() should all be defined");
	            const isValidValueAccess = (symbol2) => typeChecker.isValidPropertyAccess(isImportType ? node : node.parent, symbol2.name);
	            const isValidTypeAccess = (symbol2) => symbolCanBeReferencedAtTypeLocation(symbol2, typeChecker);
	            const isValidAccess = isNamespaceName ? (symbol2) => {
	              var _a;
	              return !!(symbol2.flags & 1920 /* Namespace */) && !((_a = symbol2.declarations) == null ? void 0 : _a.every((d) => d.parent === node.parent));
	            } : isRhsOfImportDeclaration ? (
	              // Any kind is allowed when dotting off namespace in internal import equals declaration
	              (symbol2) => isValidTypeAccess(symbol2) || isValidValueAccess(symbol2)
	            ) : isTypeLocation || insideJsDocTagTypeExpression ? isValidTypeAccess : isValidValueAccess;
	            for (const exportedSymbol of exportedSymbols) {
	              if (isValidAccess(exportedSymbol)) {
	                symbols.push(exportedSymbol);
	              }
	            }
	            if (!isTypeLocation && !insideJsDocTagTypeExpression && symbol.declarations && symbol.declarations.some((d) => d.kind !== 312 /* SourceFile */ && d.kind !== 267 /* ModuleDeclaration */ && d.kind !== 266 /* EnumDeclaration */)) {
	              let type = typeChecker.getTypeOfSymbolAtLocation(symbol, node).getNonOptionalType();
	              let insertQuestionDot = false;
	              if (type.isNullableType()) {
	                const canCorrectToQuestionDot = isRightOfDot && !isRightOfQuestionDot && preferences.includeAutomaticOptionalChainCompletions !== false;
	                if (canCorrectToQuestionDot || isRightOfQuestionDot) {
	                  type = type.getNonNullableType();
	                  if (canCorrectToQuestionDot) {
	                    insertQuestionDot = true;
	                  }
	                }
	              }
	              addTypeProperties(type, !!(node.flags & 65536 /* AwaitContext */), insertQuestionDot);
	            }
	            return;
	          }
	        }
	      }
	      if (!isTypeLocation || isInTypeQuery(node)) {
	        typeChecker.tryGetThisTypeAt(
	          node,
	          /*includeGlobalThis*/
	          false
	        );
	        let type = typeChecker.getTypeAtLocation(node).getNonOptionalType();
	        if (!isTypeLocation) {
	          let insertQuestionDot = false;
	          if (type.isNullableType()) {
	            const canCorrectToQuestionDot = isRightOfDot && !isRightOfQuestionDot && preferences.includeAutomaticOptionalChainCompletions !== false;
	            if (canCorrectToQuestionDot || isRightOfQuestionDot) {
	              type = type.getNonNullableType();
	              if (canCorrectToQuestionDot) {
	                insertQuestionDot = true;
	              }
	            }
	          }
	          addTypeProperties(type, !!(node.flags & 65536 /* AwaitContext */), insertQuestionDot);
	        } else {
	          addTypeProperties(
	            type.getNonNullableType(),
	            /*insertAwait*/
	            false,
	            /*insertQuestionDot*/
	            false
	          );
	        }
	      }
	    }
	    function addTypeProperties(type, insertAwait, insertQuestionDot) {
	      isNewIdentifierLocation = !!type.getStringIndexType();
	      if (isRightOfQuestionDot && some(type.getCallSignatures())) {
	        isNewIdentifierLocation = true;
	      }
	      const propertyAccess = node.kind === 205 /* ImportType */ ? node : node.parent;
	      if (inCheckedFile) {
	        for (const symbol of type.getApparentProperties()) {
	          if (typeChecker.isValidPropertyAccessForCompletions(propertyAccess, type, symbol)) {
	            addPropertySymbol(
	              symbol,
	              /*insertAwait*/
	              false,
	              insertQuestionDot
	            );
	          }
	        }
	      } else {
	        symbols.push(...filter(getPropertiesForCompletion(type, typeChecker), (s) => typeChecker.isValidPropertyAccessForCompletions(propertyAccess, type, s)));
	      }
	      if (insertAwait && preferences.includeCompletionsWithInsertText) {
	        const promiseType = typeChecker.getPromisedTypeOfPromise(type);
	        if (promiseType) {
	          for (const symbol of promiseType.getApparentProperties()) {
	            if (typeChecker.isValidPropertyAccessForCompletions(propertyAccess, promiseType, symbol)) {
	              addPropertySymbol(
	                symbol,
	                /*insertAwait*/
	                true,
	                insertQuestionDot
	              );
	            }
	          }
	        }
	      }
	    }
	    function addPropertySymbol(symbol, insertAwait, insertQuestionDot) {
	      var _a;
	      const computedPropertyName = firstDefined(symbol.declarations, (decl) => tryCast(getNameOfDeclaration(decl), isComputedPropertyName));
	      if (computedPropertyName) {
	        const leftMostName = getLeftMostName(computedPropertyName.expression);
	        const nameSymbol = leftMostName && typeChecker.getSymbolAtLocation(leftMostName);
	        const firstAccessibleSymbol = nameSymbol && getFirstSymbolInChain(nameSymbol, contextToken, typeChecker);
	        const firstAccessibleSymbolId = firstAccessibleSymbol && getSymbolId(firstAccessibleSymbol);
	        if (firstAccessibleSymbolId && addToSeen(seenPropertySymbols, firstAccessibleSymbolId)) {
	          const index = symbols.length;
	          symbols.push(firstAccessibleSymbol);
	          const moduleSymbol = firstAccessibleSymbol.parent;
	          if (!moduleSymbol || !isExternalModuleSymbol(moduleSymbol) || typeChecker.tryGetMemberInModuleExportsAndProperties(firstAccessibleSymbol.name, moduleSymbol) !== firstAccessibleSymbol) {
	            symbolToOriginInfoMap[index] = { kind: getNullableSymbolOriginInfoKind(2 /* SymbolMemberNoExport */) };
	          } else {
	            const fileName = isExternalModuleNameRelative(stripQuotes(moduleSymbol.name)) ? (_a = getSourceFileOfModule(moduleSymbol)) == null ? void 0 : _a.fileName : void 0;
	            const { moduleSpecifier } = (importSpecifierResolver || (importSpecifierResolver = ts_codefix_exports.createImportSpecifierResolver(sourceFile, program, host, preferences))).getModuleSpecifierForBestExportInfo(
	              [{
	                exportKind: 0 /* Named */,
	                moduleFileName: fileName,
	                isFromPackageJson: false,
	                moduleSymbol,
	                symbol: firstAccessibleSymbol,
	                targetFlags: skipAlias(firstAccessibleSymbol, typeChecker).flags
	              }],
	              position,
	              isValidTypeOnlyAliasUseSite(location)
	            ) || {};
	            if (moduleSpecifier) {
	              const origin = {
	                kind: getNullableSymbolOriginInfoKind(6 /* SymbolMemberExport */),
	                moduleSymbol,
	                isDefaultExport: false,
	                symbolName: firstAccessibleSymbol.name,
	                exportName: firstAccessibleSymbol.name,
	                fileName,
	                moduleSpecifier
	              };
	              symbolToOriginInfoMap[index] = origin;
	            }
	          }
	        } else if (preferences.includeCompletionsWithInsertText) {
	          if (firstAccessibleSymbolId && seenPropertySymbols.has(firstAccessibleSymbolId)) {
	            return;
	          }
	          addSymbolOriginInfo(symbol);
	          addSymbolSortInfo(symbol);
	          symbols.push(symbol);
	        }
	      } else {
	        addSymbolOriginInfo(symbol);
	        addSymbolSortInfo(symbol);
	        symbols.push(symbol);
	      }
	      function addSymbolSortInfo(symbol2) {
	        if (isStaticProperty(symbol2)) {
	          symbolToSortTextMap[getSymbolId(symbol2)] = SortText.LocalDeclarationPriority;
	        }
	      }
	      function addSymbolOriginInfo(symbol2) {
	        if (preferences.includeCompletionsWithInsertText) {
	          if (insertAwait && addToSeen(seenPropertySymbols, getSymbolId(symbol2))) {
	            symbolToOriginInfoMap[symbols.length] = { kind: getNullableSymbolOriginInfoKind(8 /* Promise */) };
	          } else if (insertQuestionDot) {
	            symbolToOriginInfoMap[symbols.length] = { kind: 16 /* Nullable */ };
	          }
	        }
	      }
	      function getNullableSymbolOriginInfoKind(kind) {
	        return insertQuestionDot ? kind | 16 /* Nullable */ : kind;
	      }
	    }
	    function getLeftMostName(e) {
	      return isIdentifier(e) ? e : isPropertyAccessExpression(e) ? getLeftMostName(e.expression) : void 0;
	    }
	    function tryGetGlobalSymbols() {
	      const result = tryGetObjectTypeLiteralInTypeArgumentCompletionSymbols() || tryGetObjectLikeCompletionSymbols() || tryGetImportCompletionSymbols() || tryGetImportOrExportClauseCompletionSymbols() || tryGetImportAttributesCompletionSymbols() || tryGetLocalNamedExportCompletionSymbols() || tryGetConstructorCompletion() || tryGetClassLikeCompletionSymbols() || tryGetJsxCompletionSymbols() || (getGlobalCompletions(), 1 /* Success */);
	      return result === 1 /* Success */;
	    }
	    function tryGetConstructorCompletion() {
	      if (!tryGetConstructorLikeCompletionContainer(contextToken))
	        return 0 /* Continue */;
	      completionKind = 5 /* None */;
	      isNewIdentifierLocation = true;
	      keywordFilters = 4 /* ConstructorParameterKeywords */;
	      return 1 /* Success */;
	    }
	    function tryGetJsxCompletionSymbols() {
	      const jsxContainer = tryGetContainingJsxElement(contextToken);
	      const attrsType = jsxContainer && typeChecker.getContextualType(jsxContainer.attributes);
	      if (!attrsType)
	        return 0 /* Continue */;
	      const completionsType = jsxContainer && typeChecker.getContextualType(jsxContainer.attributes, 4 /* Completions */);
	      symbols = concatenate(symbols, filterJsxAttributes(getPropertiesForObjectExpression(attrsType, completionsType, jsxContainer.attributes, typeChecker), jsxContainer.attributes.properties));
	      setSortTextToOptionalMember();
	      completionKind = 3 /* MemberLike */;
	      isNewIdentifierLocation = false;
	      return 1 /* Success */;
	    }
	    function tryGetImportCompletionSymbols() {
	      if (!importStatementCompletion)
	        return 0 /* Continue */;
	      isNewIdentifierLocation = true;
	      collectAutoImports();
	      return 1 /* Success */;
	    }
	    function getGlobalCompletions() {
	      keywordFilters = tryGetFunctionLikeBodyCompletionContainer(contextToken) ? 5 /* FunctionLikeBodyKeywords */ : 1 /* All */;
	      completionKind = 1 /* Global */;
	      isNewIdentifierLocation = isNewIdentifierDefinitionLocation();
	      if (previousToken !== contextToken) {
	        Debug.assert(!!previousToken, "Expected 'contextToken' to be defined when different from 'previousToken'.");
	      }
	      const adjustedPosition = previousToken !== contextToken ? previousToken.getStart() : position;
	      const scopeNode = getScopeNode(contextToken, adjustedPosition, sourceFile) || sourceFile;
	      isInSnippetScope = isSnippetScope(scopeNode);
	      const symbolMeanings = (isTypeOnlyLocation ? 0 /* None */ : 111551 /* Value */) | 788968 /* Type */ | 1920 /* Namespace */ | 2097152 /* Alias */;
	      const typeOnlyAliasNeedsPromotion = previousToken && !isValidTypeOnlyAliasUseSite(previousToken);
	      symbols = concatenate(symbols, typeChecker.getSymbolsInScope(scopeNode, symbolMeanings));
	      Debug.assertEachIsDefined(symbols, "getSymbolsInScope() should all be defined");
	      for (let i = 0; i < symbols.length; i++) {
	        const symbol = symbols[i];
	        if (!typeChecker.isArgumentsSymbol(symbol) && !some(symbol.declarations, (d) => d.getSourceFile() === sourceFile)) {
	          symbolToSortTextMap[getSymbolId(symbol)] = SortText.GlobalsOrKeywords;
	        }
	        if (typeOnlyAliasNeedsPromotion && !(symbol.flags & 111551 /* Value */)) {
	          const typeOnlyAliasDeclaration = symbol.declarations && find(symbol.declarations, isTypeOnlyImportDeclaration);
	          if (typeOnlyAliasDeclaration) {
	            const origin = { kind: 64 /* TypeOnlyAlias */, declaration: typeOnlyAliasDeclaration };
	            symbolToOriginInfoMap[i] = origin;
	          }
	        }
	      }
	      if (preferences.includeCompletionsWithInsertText && scopeNode.kind !== 312 /* SourceFile */) {
	        const thisType = typeChecker.tryGetThisTypeAt(
	          scopeNode,
	          /*includeGlobalThis*/
	          false,
	          isClassLike(scopeNode.parent) ? scopeNode : void 0
	        );
	        if (thisType && !isProbablyGlobalType(thisType, sourceFile, typeChecker)) {
	          for (const symbol of getPropertiesForCompletion(thisType, typeChecker)) {
	            symbolToOriginInfoMap[symbols.length] = { kind: 1 /* ThisType */ };
	            symbols.push(symbol);
	            symbolToSortTextMap[getSymbolId(symbol)] = SortText.SuggestedClassMembers;
	          }
	        }
	      }
	      collectAutoImports();
	      if (isTypeOnlyLocation) {
	        keywordFilters = contextToken && isAssertionExpression(contextToken.parent) ? 6 /* TypeAssertionKeywords */ : 7 /* TypeKeywords */;
	      }
	    }
	    function shouldOfferImportCompletions() {
	      if (importStatementCompletion)
	        return true;
	      if (!preferences.includeCompletionsForModuleExports)
	        return false;
	      if (sourceFile.externalModuleIndicator || sourceFile.commonJsModuleIndicator)
	        return true;
	      if (compilerOptionsIndicateEsModules(program.getCompilerOptions()))
	        return true;
	      return programContainsModules(program);
	    }
	    function isSnippetScope(scopeNode) {
	      switch (scopeNode.kind) {
	        case 312 /* SourceFile */:
	        case 228 /* TemplateExpression */:
	        case 294 /* JsxExpression */:
	        case 241 /* Block */:
	          return true;
	        default:
	          return isStatement(scopeNode);
	      }
	    }
	    function isTypeOnlyCompletion() {
	      return insideJsDocTagTypeExpression || !!importStatementCompletion && isTypeOnlyImportOrExportDeclaration(location.parent) || !isContextTokenValueLocation(contextToken) && (isPossiblyTypeArgumentPosition(contextToken, sourceFile, typeChecker) || isPartOfTypeNode(location) || isContextTokenTypeLocation(contextToken));
	    }
	    function isContextTokenValueLocation(contextToken2) {
	      return contextToken2 && (contextToken2.kind === 114 /* TypeOfKeyword */ && (contextToken2.parent.kind === 186 /* TypeQuery */ || isTypeOfExpression(contextToken2.parent)) || contextToken2.kind === 131 /* AssertsKeyword */ && contextToken2.parent.kind === 182 /* TypePredicate */);
	    }
	    function isContextTokenTypeLocation(contextToken2) {
	      if (contextToken2) {
	        const parentKind = contextToken2.parent.kind;
	        switch (contextToken2.kind) {
	          case 59 /* ColonToken */:
	            return parentKind === 172 /* PropertyDeclaration */ || parentKind === 171 /* PropertySignature */ || parentKind === 169 /* Parameter */ || parentKind === 260 /* VariableDeclaration */ || isFunctionLikeKind(parentKind);
	          case 64 /* EqualsToken */:
	            return parentKind === 265 /* TypeAliasDeclaration */ || parentKind === 168 /* TypeParameter */;
	          case 130 /* AsKeyword */:
	            return parentKind === 234 /* AsExpression */;
	          case 30 /* LessThanToken */:
	            return parentKind === 183 /* TypeReference */ || parentKind === 216 /* TypeAssertionExpression */;
	          case 96 /* ExtendsKeyword */:
	            return parentKind === 168 /* TypeParameter */;
	          case 152 /* SatisfiesKeyword */:
	            return parentKind === 238 /* SatisfiesExpression */;
	        }
	      }
	      return false;
	    }
	    function collectAutoImports() {
	      var _a, _b;
	      if (!shouldOfferImportCompletions())
	        return;
	      Debug.assert(!(detailsEntryId == null ? void 0 : detailsEntryId.data), "Should not run 'collectAutoImports' when faster path is available via `data`");
	      if (detailsEntryId && !detailsEntryId.source) {
	        return;
	      }
	      flags |= 1 /* MayIncludeAutoImports */;
	      const isAfterTypeOnlyImportSpecifierModifier = previousToken === contextToken && importStatementCompletion;
	      const lowerCaseTokenText = isAfterTypeOnlyImportSpecifierModifier ? "" : previousToken && isIdentifier(previousToken) ? previousToken.text.toLowerCase() : "";
	      const moduleSpecifierCache = (_a = host.getModuleSpecifierCache) == null ? void 0 : _a.call(host);
	      const exportInfo = getExportInfoMap(sourceFile, host, program, preferences, cancellationToken);
	      const packageJsonAutoImportProvider = (_b = host.getPackageJsonAutoImportProvider) == null ? void 0 : _b.call(host);
	      const packageJsonFilter = detailsEntryId ? void 0 : createPackageJsonImportFilter(sourceFile, preferences, host);
	      resolvingModuleSpecifiers(
	        "collectAutoImports",
	        host,
	        importSpecifierResolver || (importSpecifierResolver = ts_codefix_exports.createImportSpecifierResolver(sourceFile, program, host, preferences)),
	        program,
	        position,
	        preferences,
	        !!importStatementCompletion,
	        isValidTypeOnlyAliasUseSite(location),
	        (context) => {
	          exportInfo.search(
	            sourceFile.path,
	            /*preferCapitalized*/
	            isRightOfOpenTag,
	            (symbolName2, targetFlags) => {
	              if (!isIdentifierText(symbolName2, getEmitScriptTarget(host.getCompilationSettings())))
	                return false;
	              if (!detailsEntryId && isStringANonContextualKeyword(symbolName2))
	                return false;
	              if (!isTypeOnlyLocation && !importStatementCompletion && !(targetFlags & 111551 /* Value */))
	                return false;
	              if (isTypeOnlyLocation && !(targetFlags & (1536 /* Module */ | 788968 /* Type */)))
	                return false;
	              const firstChar = symbolName2.charCodeAt(0);
	              if (isRightOfOpenTag && (firstChar < 65 /* A */ || firstChar > 90 /* Z */))
	                return false;
	              if (detailsEntryId)
	                return true;
	              return charactersFuzzyMatchInString(symbolName2, lowerCaseTokenText);
	            },
	            (info, symbolName2, isFromAmbientModule, exportMapKey) => {
	              if (detailsEntryId && !some(info, (i) => detailsEntryId.source === stripQuotes(i.moduleSymbol.name))) {
	                return;
	              }
	              info = filter(info, isImportableExportInfo);
	              if (!info.length) {
	                return;
	              }
	              const result = context.tryResolve(info, isFromAmbientModule) || {};
	              if (result === "failed")
	                return;
	              let exportInfo2 = info[0], moduleSpecifier;
	              if (result !== "skipped") {
	                ({ exportInfo: exportInfo2 = info[0], moduleSpecifier } = result);
	              }
	              const isDefaultExport = exportInfo2.exportKind === 1 /* Default */;
	              const symbol = isDefaultExport && getLocalSymbolForExportDefault(exportInfo2.symbol) || exportInfo2.symbol;
	              pushAutoImportSymbol(symbol, {
	                kind: moduleSpecifier ? 32 /* ResolvedExport */ : 4 /* Export */,
	                moduleSpecifier,
	                symbolName: symbolName2,
	                exportMapKey,
	                exportName: exportInfo2.exportKind === 2 /* ExportEquals */ ? "export=" /* ExportEquals */ : exportInfo2.symbol.name,
	                fileName: exportInfo2.moduleFileName,
	                isDefaultExport,
	                moduleSymbol: exportInfo2.moduleSymbol,
	                isFromPackageJson: exportInfo2.isFromPackageJson
	              });
	            }
	          );
	          hasUnresolvedAutoImports = context.skippedAny();
	          flags |= context.resolvedAny() ? 8 /* ResolvedModuleSpecifiers */ : 0;
	          flags |= context.resolvedBeyondLimit() ? 16 /* ResolvedModuleSpecifiersBeyondLimit */ : 0;
	        }
	      );
	      function isImportableExportInfo(info) {
	        const moduleFile = tryCast(info.moduleSymbol.valueDeclaration, isSourceFile);
	        if (!moduleFile) {
	          const moduleName = stripQuotes(info.moduleSymbol.name);
	          if (ts_JsTyping_exports.nodeCoreModules.has(moduleName) && startsWith(moduleName, "node:") !== shouldUseUriStyleNodeCoreModules(sourceFile, program)) {
	            return false;
	          }
	          return packageJsonFilter ? packageJsonFilter.allowsImportingAmbientModule(info.moduleSymbol, getModuleSpecifierResolutionHost(info.isFromPackageJson)) : true;
	        }
	        return isImportableFile(
	          info.isFromPackageJson ? packageJsonAutoImportProvider : program,
	          sourceFile,
	          moduleFile,
	          preferences,
	          packageJsonFilter,
	          getModuleSpecifierResolutionHost(info.isFromPackageJson),
	          moduleSpecifierCache
	        );
	      }
	    }
	    function pushAutoImportSymbol(symbol, origin) {
	      const symbolId = getSymbolId(symbol);
	      if (symbolToSortTextMap[symbolId] === SortText.GlobalsOrKeywords) {
	        return;
	      }
	      symbolToOriginInfoMap[symbols.length] = origin;
	      symbolToSortTextMap[symbolId] = importStatementCompletion ? SortText.LocationPriority : SortText.AutoImportSuggestions;
	      symbols.push(symbol);
	    }
	    function collectObjectLiteralMethodSymbols(members, enclosingDeclaration) {
	      if (isInJSFile(location)) {
	        return;
	      }
	      members.forEach((member) => {
	        if (!isObjectLiteralMethodSymbol(member)) {
	          return;
	        }
	        const displayName = getCompletionEntryDisplayNameForSymbol(
	          member,
	          getEmitScriptTarget(compilerOptions),
	          /*origin*/
	          void 0,
	          0 /* ObjectPropertyDeclaration */,
	          /*jsxIdentifierExpected*/
	          false
	        );
	        if (!displayName) {
	          return;
	        }
	        const { name } = displayName;
	        const entryProps = getEntryForObjectLiteralMethodCompletion(
	          member,
	          name,
	          enclosingDeclaration,
	          program,
	          host,
	          compilerOptions,
	          preferences,
	          formatContext
	        );
	        if (!entryProps) {
	          return;
	        }
	        const origin = { kind: 128 /* ObjectLiteralMethod */, ...entryProps };
	        flags |= 32 /* MayIncludeMethodSnippets */;
	        symbolToOriginInfoMap[symbols.length] = origin;
	        symbols.push(member);
	      });
	    }
	    function isObjectLiteralMethodSymbol(symbol) {
	      if (!(symbol.flags & (4 /* Property */ | 8192 /* Method */))) {
	        return false;
	      }
	      return true;
	    }
	    function getScopeNode(initialToken, position2, sourceFile2) {
	      let scope = initialToken;
	      while (scope && !positionBelongsToNode(scope, position2, sourceFile2)) {
	        scope = scope.parent;
	      }
	      return scope;
	    }
	    function isCompletionListBlocker(contextToken2) {
	      const start2 = timestamp();
	      const result = isInStringOrRegularExpressionOrTemplateLiteral(contextToken2) || isSolelyIdentifierDefinitionLocation(contextToken2) || isDotOfNumericLiteral(contextToken2) || isInJsxText(contextToken2) || isBigIntLiteral(contextToken2);
	      log("getCompletionsAtPosition: isCompletionListBlocker: " + (timestamp() - start2));
	      return result;
	    }
	    function isInJsxText(contextToken2) {
	      if (contextToken2.kind === 12 /* JsxText */) {
	        return true;
	      }
	      if (contextToken2.kind === 32 /* GreaterThanToken */ && contextToken2.parent) {
	        if (location === contextToken2.parent && (location.kind === 286 /* JsxOpeningElement */ || location.kind === 285 /* JsxSelfClosingElement */)) {
	          return false;
	        }
	        if (contextToken2.parent.kind === 286 /* JsxOpeningElement */) {
	          return location.parent.kind !== 286 /* JsxOpeningElement */;
	        }
	        if (contextToken2.parent.kind === 287 /* JsxClosingElement */ || contextToken2.parent.kind === 285 /* JsxSelfClosingElement */) {
	          return !!contextToken2.parent.parent && contextToken2.parent.parent.kind === 284 /* JsxElement */;
	        }
	      }
	      return false;
	    }
	    function isNewIdentifierDefinitionLocation() {
	      if (contextToken) {
	        const containingNodeKind = contextToken.parent.kind;
	        const tokenKind = keywordForNode(contextToken);
	        switch (tokenKind) {
	          case 28 /* CommaToken */:
	            return containingNodeKind === 213 /* CallExpression */ || containingNodeKind === 176 /* Constructor */ || containingNodeKind === 214 /* NewExpression */ || containingNodeKind === 209 /* ArrayLiteralExpression */ || containingNodeKind === 226 /* BinaryExpression */ || containingNodeKind === 184 /* FunctionType */ || containingNodeKind === 210 /* ObjectLiteralExpression */;
	          case 21 /* OpenParenToken */:
	            return containingNodeKind === 213 /* CallExpression */ || containingNodeKind === 176 /* Constructor */ || containingNodeKind === 214 /* NewExpression */ || containingNodeKind === 217 /* ParenthesizedExpression */ || containingNodeKind === 196 /* ParenthesizedType */;
	          case 23 /* OpenBracketToken */:
	            return containingNodeKind === 209 /* ArrayLiteralExpression */ || containingNodeKind === 181 /* IndexSignature */ || containingNodeKind === 167 /* ComputedPropertyName */;
	          case 144 /* ModuleKeyword */:
	          case 145 /* NamespaceKeyword */:
	          case 102 /* ImportKeyword */:
	            return true;
	          case 25 /* DotToken */:
	            return containingNodeKind === 267 /* ModuleDeclaration */;
	          case 19 /* OpenBraceToken */:
	            return containingNodeKind === 263 /* ClassDeclaration */ || containingNodeKind === 210 /* ObjectLiteralExpression */;
	          case 64 /* EqualsToken */:
	            return containingNodeKind === 260 /* VariableDeclaration */ || containingNodeKind === 226 /* BinaryExpression */;
	          case 16 /* TemplateHead */:
	            return containingNodeKind === 228 /* TemplateExpression */;
	          case 17 /* TemplateMiddle */:
	            return containingNodeKind === 239 /* TemplateSpan */;
	          case 134 /* AsyncKeyword */:
	            return containingNodeKind === 174 /* MethodDeclaration */ || containingNodeKind === 304 /* ShorthandPropertyAssignment */;
	          case 42 /* AsteriskToken */:
	            return containingNodeKind === 174 /* MethodDeclaration */;
	        }
	        if (isClassMemberCompletionKeyword(tokenKind)) {
	          return true;
	        }
	      }
	      return false;
	    }
	    function isInStringOrRegularExpressionOrTemplateLiteral(contextToken2) {
	      return (isRegularExpressionLiteral(contextToken2) || isStringTextContainingNode(contextToken2)) && (rangeContainsPositionExclusive(contextToken2, position) || position === contextToken2.end && (!!contextToken2.isUnterminated || isRegularExpressionLiteral(contextToken2)));
	    }
	    function tryGetObjectTypeLiteralInTypeArgumentCompletionSymbols() {
	      const typeLiteralNode = tryGetTypeLiteralNode(contextToken);
	      if (!typeLiteralNode)
	        return 0 /* Continue */;
	      const intersectionTypeNode = isIntersectionTypeNode(typeLiteralNode.parent) ? typeLiteralNode.parent : void 0;
	      const containerTypeNode = intersectionTypeNode || typeLiteralNode;
	      const containerExpectedType = getConstraintOfTypeArgumentProperty(containerTypeNode, typeChecker);
	      if (!containerExpectedType)
	        return 0 /* Continue */;
	      const containerActualType = typeChecker.getTypeFromTypeNode(containerTypeNode);
	      const members = getPropertiesForCompletion(containerExpectedType, typeChecker);
	      const existingMembers = getPropertiesForCompletion(containerActualType, typeChecker);
	      const existingMemberEscapedNames = /* @__PURE__ */ new Set();
	      existingMembers.forEach((s) => existingMemberEscapedNames.add(s.escapedName));
	      symbols = concatenate(symbols, filter(members, (s) => !existingMemberEscapedNames.has(s.escapedName)));
	      completionKind = 0 /* ObjectPropertyDeclaration */;
	      isNewIdentifierLocation = true;
	      return 1 /* Success */;
	    }
	    function tryGetObjectLikeCompletionSymbols() {
	      const symbolsStartIndex = symbols.length;
	      const objectLikeContainer = tryGetObjectLikeCompletionContainer(contextToken, position, sourceFile);
	      if (!objectLikeContainer)
	        return 0 /* Continue */;
	      completionKind = 0 /* ObjectPropertyDeclaration */;
	      let typeMembers;
	      let existingMembers;
	      if (objectLikeContainer.kind === 210 /* ObjectLiteralExpression */) {
	        const instantiatedType = tryGetObjectLiteralContextualType(objectLikeContainer, typeChecker);
	        if (instantiatedType === void 0) {
	          if (objectLikeContainer.flags & 67108864 /* InWithStatement */) {
	            return 2 /* Fail */;
	          }
	          return 0 /* Continue */;
	        }
	        const completionsType = typeChecker.getContextualType(objectLikeContainer, 4 /* Completions */);
	        const hasStringIndexType = (completionsType || instantiatedType).getStringIndexType();
	        const hasNumberIndextype = (completionsType || instantiatedType).getNumberIndexType();
	        isNewIdentifierLocation = !!hasStringIndexType || !!hasNumberIndextype;
	        typeMembers = getPropertiesForObjectExpression(instantiatedType, completionsType, objectLikeContainer, typeChecker);
	        existingMembers = objectLikeContainer.properties;
	        if (typeMembers.length === 0) {
	          if (!hasNumberIndextype) {
	            return 0 /* Continue */;
	          }
	        }
	      } else {
	        Debug.assert(objectLikeContainer.kind === 206 /* ObjectBindingPattern */);
	        isNewIdentifierLocation = false;
	        const rootDeclaration = getRootDeclaration(objectLikeContainer.parent);
	        if (!isVariableLike(rootDeclaration))
	          return Debug.fail("Root declaration is not variable-like.");
	        let canGetType = hasInitializer(rootDeclaration) || !!getEffectiveTypeAnnotationNode(rootDeclaration) || rootDeclaration.parent.parent.kind === 250 /* ForOfStatement */;
	        if (!canGetType && rootDeclaration.kind === 169 /* Parameter */) {
	          if (isExpression(rootDeclaration.parent)) {
	            canGetType = !!typeChecker.getContextualType(rootDeclaration.parent);
	          } else if (rootDeclaration.parent.kind === 174 /* MethodDeclaration */ || rootDeclaration.parent.kind === 178 /* SetAccessor */) {
	            canGetType = isExpression(rootDeclaration.parent.parent) && !!typeChecker.getContextualType(rootDeclaration.parent.parent);
	          }
	        }
	        if (canGetType) {
	          const typeForObject = typeChecker.getTypeAtLocation(objectLikeContainer);
	          if (!typeForObject)
	            return 2 /* Fail */;
	          typeMembers = typeChecker.getPropertiesOfType(typeForObject).filter((propertySymbol) => {
	            return typeChecker.isPropertyAccessible(
	              objectLikeContainer,
	              /*isSuper*/
	              false,
	              /*isWrite*/
	              false,
	              typeForObject,
	              propertySymbol
	            );
	          });
	          existingMembers = objectLikeContainer.elements;
	        }
	      }
	      if (typeMembers && typeMembers.length > 0) {
	        const filteredMembers = filterObjectMembersList(typeMembers, Debug.checkDefined(existingMembers));
	        symbols = concatenate(symbols, filteredMembers);
	        setSortTextToOptionalMember();
	        if (objectLikeContainer.kind === 210 /* ObjectLiteralExpression */ && preferences.includeCompletionsWithObjectLiteralMethodSnippets && preferences.includeCompletionsWithInsertText) {
	          transformObjectLiteralMembersSortText(symbolsStartIndex);
	          collectObjectLiteralMethodSymbols(filteredMembers, objectLikeContainer);
	        }
	      }
	      return 1 /* Success */;
	    }
	    function tryGetImportOrExportClauseCompletionSymbols() {
	      if (!contextToken)
	        return 0 /* Continue */;
	      const namedImportsOrExports = contextToken.kind === 19 /* OpenBraceToken */ || contextToken.kind === 28 /* CommaToken */ ? tryCast(contextToken.parent, isNamedImportsOrExports) : isTypeKeywordTokenOrIdentifier(contextToken) ? tryCast(contextToken.parent.parent, isNamedImportsOrExports) : void 0;
	      if (!namedImportsOrExports)
	        return 0 /* Continue */;
	      if (!isTypeKeywordTokenOrIdentifier(contextToken)) {
	        keywordFilters = 8 /* TypeKeyword */;
	      }
	      const { moduleSpecifier } = namedImportsOrExports.kind === 275 /* NamedImports */ ? namedImportsOrExports.parent.parent : namedImportsOrExports.parent;
	      if (!moduleSpecifier) {
	        isNewIdentifierLocation = true;
	        return namedImportsOrExports.kind === 275 /* NamedImports */ ? 2 /* Fail */ : 0 /* Continue */;
	      }
	      const moduleSpecifierSymbol = typeChecker.getSymbolAtLocation(moduleSpecifier);
	      if (!moduleSpecifierSymbol) {
	        isNewIdentifierLocation = true;
	        return 2 /* Fail */;
	      }
	      completionKind = 3 /* MemberLike */;
	      isNewIdentifierLocation = false;
	      const exports = typeChecker.getExportsAndPropertiesOfModule(moduleSpecifierSymbol);
	      const existing = new Set(namedImportsOrExports.elements.filter((n) => !isCurrentlyEditingNode(n)).map((n) => (n.propertyName || n.name).escapedText));
	      const uniques = exports.filter((e) => e.escapedName !== "default" /* Default */ && !existing.has(e.escapedName));
	      symbols = concatenate(symbols, uniques);
	      if (!uniques.length) {
	        keywordFilters = 0 /* None */;
	      }
	      return 1 /* Success */;
	    }
	    function tryGetImportAttributesCompletionSymbols() {
	      if (contextToken === void 0)
	        return 0 /* Continue */;
	      const importAttributes = contextToken.kind === 19 /* OpenBraceToken */ || contextToken.kind === 28 /* CommaToken */ ? tryCast(contextToken.parent, isImportAttributes) : contextToken.kind === 59 /* ColonToken */ ? tryCast(contextToken.parent.parent, isImportAttributes) : void 0;
	      if (importAttributes === void 0)
	        return 0 /* Continue */;
	      const existing = new Set(importAttributes.elements.map(getNameFromImportAttribute));
	      symbols = filter(typeChecker.getTypeAtLocation(importAttributes).getApparentProperties(), (attr) => !existing.has(attr.escapedName));
	      return 1 /* Success */;
	    }
	    function tryGetLocalNamedExportCompletionSymbols() {
	      var _a;
	      const namedExports = contextToken && (contextToken.kind === 19 /* OpenBraceToken */ || contextToken.kind === 28 /* CommaToken */) ? tryCast(contextToken.parent, isNamedExports) : void 0;
	      if (!namedExports) {
	        return 0 /* Continue */;
	      }
	      const localsContainer = findAncestor(namedExports, or(isSourceFile, isModuleDeclaration));
	      completionKind = 5 /* None */;
	      isNewIdentifierLocation = false;
	      (_a = localsContainer.locals) == null ? void 0 : _a.forEach((symbol, name) => {
	        var _a2, _b;
	        symbols.push(symbol);
	        if ((_b = (_a2 = localsContainer.symbol) == null ? void 0 : _a2.exports) == null ? void 0 : _b.has(name)) {
	          symbolToSortTextMap[getSymbolId(symbol)] = SortText.OptionalMember;
	        }
	      });
	      return 1 /* Success */;
	    }
	    function tryGetClassLikeCompletionSymbols() {
	      const decl = tryGetObjectTypeDeclarationCompletionContainer(sourceFile, contextToken, location, position);
	      if (!decl)
	        return 0 /* Continue */;
	      completionKind = 3 /* MemberLike */;
	      isNewIdentifierLocation = true;
	      keywordFilters = contextToken.kind === 42 /* AsteriskToken */ ? 0 /* None */ : isClassLike(decl) ? 2 /* ClassElementKeywords */ : 3 /* InterfaceElementKeywords */;
	      if (!isClassLike(decl))
	        return 1 /* Success */;
	      const classElement = contextToken.kind === 27 /* SemicolonToken */ ? contextToken.parent.parent : contextToken.parent;
	      let classElementModifierFlags = isClassElement(classElement) ? getEffectiveModifierFlags(classElement) : 0 /* None */;
	      if (contextToken.kind === 80 /* Identifier */ && !isCurrentlyEditingNode(contextToken)) {
	        switch (contextToken.getText()) {
	          case "private":
	            classElementModifierFlags = classElementModifierFlags | 2 /* Private */;
	            break;
	          case "static":
	            classElementModifierFlags = classElementModifierFlags | 256 /* Static */;
	            break;
	          case "override":
	            classElementModifierFlags = classElementModifierFlags | 16 /* Override */;
	            break;
	        }
	      }
	      if (isClassStaticBlockDeclaration(classElement)) {
	        classElementModifierFlags |= 256 /* Static */;
	      }
	      if (!(classElementModifierFlags & 2 /* Private */)) {
	        const baseTypeNodes = isClassLike(decl) && classElementModifierFlags & 16 /* Override */ ? singleElementArray(getEffectiveBaseTypeNode(decl)) : getAllSuperTypeNodes(decl);
	        const baseSymbols = flatMap(baseTypeNodes, (baseTypeNode) => {
	          const type = typeChecker.getTypeAtLocation(baseTypeNode);
	          return classElementModifierFlags & 256 /* Static */ ? (type == null ? void 0 : type.symbol) && typeChecker.getPropertiesOfType(typeChecker.getTypeOfSymbolAtLocation(type.symbol, decl)) : type && typeChecker.getPropertiesOfType(type);
	        });
	        symbols = concatenate(symbols, filterClassMembersList(baseSymbols, decl.members, classElementModifierFlags));
	        forEach(symbols, (symbol, index) => {
	          const declaration = symbol == null ? void 0 : symbol.valueDeclaration;
	          if (declaration && isClassElement(declaration) && declaration.name && isComputedPropertyName(declaration.name)) {
	            const origin = {
	              kind: 512 /* ComputedPropertyName */,
	              symbolName: typeChecker.symbolToString(symbol)
	            };
	            symbolToOriginInfoMap[index] = origin;
	          }
	        });
	      }
	      return 1 /* Success */;
	    }
	    function isConstructorParameterCompletion(node2) {
	      return !!node2.parent && isParameter(node2.parent) && isConstructorDeclaration(node2.parent.parent) && (isParameterPropertyModifier(node2.kind) || isDeclarationName(node2));
	    }
	    function tryGetConstructorLikeCompletionContainer(contextToken2) {
	      if (contextToken2) {
	        const parent2 = contextToken2.parent;
	        switch (contextToken2.kind) {
	          case 21 /* OpenParenToken */:
	          case 28 /* CommaToken */:
	            return isConstructorDeclaration(contextToken2.parent) ? contextToken2.parent : void 0;
	          default:
	            if (isConstructorParameterCompletion(contextToken2)) {
	              return parent2.parent;
	            }
	        }
	      }
	      return void 0;
	    }
	    function tryGetFunctionLikeBodyCompletionContainer(contextToken2) {
	      if (contextToken2) {
	        let prev;
	        const container = findAncestor(contextToken2.parent, (node2) => {
	          if (isClassLike(node2)) {
	            return "quit";
	          }
	          if (isFunctionLikeDeclaration(node2) && prev === node2.body) {
	            return true;
	          }
	          prev = node2;
	          return false;
	        });
	        return container && container;
	      }
	    }
	    function tryGetContainingJsxElement(contextToken2) {
	      if (contextToken2) {
	        const parent2 = contextToken2.parent;
	        switch (contextToken2.kind) {
	          case 32 /* GreaterThanToken */:
	          case 31 /* LessThanSlashToken */:
	          case 44 /* SlashToken */:
	          case 80 /* Identifier */:
	          case 211 /* PropertyAccessExpression */:
	          case 292 /* JsxAttributes */:
	          case 291 /* JsxAttribute */:
	          case 293 /* JsxSpreadAttribute */:
	            if (parent2 && (parent2.kind === 285 /* JsxSelfClosingElement */ || parent2.kind === 286 /* JsxOpeningElement */)) {
	              if (contextToken2.kind === 32 /* GreaterThanToken */) {
	                const precedingToken = findPrecedingToken(
	                  contextToken2.pos,
	                  sourceFile,
	                  /*startNode*/
	                  void 0
	                );
	                if (!parent2.typeArguments || precedingToken && precedingToken.kind === 44 /* SlashToken */)
	                  break;
	              }
	              return parent2;
	            } else if (parent2.kind === 291 /* JsxAttribute */) {
	              return parent2.parent.parent;
	            }
	            break;
	          case 11 /* StringLiteral */:
	            if (parent2 && (parent2.kind === 291 /* JsxAttribute */ || parent2.kind === 293 /* JsxSpreadAttribute */)) {
	              return parent2.parent.parent;
	            }
	            break;
	          case 20 /* CloseBraceToken */:
	            if (parent2 && parent2.kind === 294 /* JsxExpression */ && parent2.parent && parent2.parent.kind === 291 /* JsxAttribute */) {
	              return parent2.parent.parent.parent;
	            }
	            if (parent2 && parent2.kind === 293 /* JsxSpreadAttribute */) {
	              return parent2.parent.parent;
	            }
	            break;
	        }
	      }
	      return void 0;
	    }
	    function isInDifferentLineThanContextToken(contextToken2, position2) {
	      return sourceFile.getLineEndOfPosition(contextToken2.getEnd()) < position2;
	    }
	    function isSolelyIdentifierDefinitionLocation(contextToken2) {
	      const parent2 = contextToken2.parent;
	      const containingNodeKind = parent2.kind;
	      switch (contextToken2.kind) {
	        case 28 /* CommaToken */:
	          return containingNodeKind === 260 /* VariableDeclaration */ || isVariableDeclarationListButNotTypeArgument(contextToken2) || containingNodeKind === 243 /* VariableStatement */ || containingNodeKind === 266 /* EnumDeclaration */ || // enum a { foo, |
	          isFunctionLikeButNotConstructor(containingNodeKind) || containingNodeKind === 264 /* InterfaceDeclaration */ || // interface A<T, |
	          containingNodeKind === 207 /* ArrayBindingPattern */ || // var [x, y|
	          containingNodeKind === 265 /* TypeAliasDeclaration */ || // type Map, K, |
	          // class A<T, |
	          // var C = class D<T, |
	          isClassLike(parent2) && !!parent2.typeParameters && parent2.typeParameters.end >= contextToken2.pos;
	        case 25 /* DotToken */:
	          return containingNodeKind === 207 /* ArrayBindingPattern */;
	        case 59 /* ColonToken */:
	          return containingNodeKind === 208 /* BindingElement */;
	        case 23 /* OpenBracketToken */:
	          return containingNodeKind === 207 /* ArrayBindingPattern */;
	        case 21 /* OpenParenToken */:
	          return containingNodeKind === 299 /* CatchClause */ || isFunctionLikeButNotConstructor(containingNodeKind);
	        case 19 /* OpenBraceToken */:
	          return containingNodeKind === 266 /* EnumDeclaration */;
	        case 30 /* LessThanToken */:
	          return containingNodeKind === 263 /* ClassDeclaration */ || // class A< |
	          containingNodeKind === 231 /* ClassExpression */ || // var C = class D< |
	          containingNodeKind === 264 /* InterfaceDeclaration */ || // interface A< |
	          containingNodeKind === 265 /* TypeAliasDeclaration */ || // type List< |
	          isFunctionLikeKind(containingNodeKind);
	        case 126 /* StaticKeyword */:
	          return containingNodeKind === 172 /* PropertyDeclaration */ && !isClassLike(parent2.parent);
	        case 26 /* DotDotDotToken */:
	          return containingNodeKind === 169 /* Parameter */ || !!parent2.parent && parent2.parent.kind === 207 /* ArrayBindingPattern */;
	        case 125 /* PublicKeyword */:
	        case 123 /* PrivateKeyword */:
	        case 124 /* ProtectedKeyword */:
	          return containingNodeKind === 169 /* Parameter */ && !isConstructorDeclaration(parent2.parent);
	        case 130 /* AsKeyword */:
	          return containingNodeKind === 276 /* ImportSpecifier */ || containingNodeKind === 281 /* ExportSpecifier */ || containingNodeKind === 274 /* NamespaceImport */;
	        case 139 /* GetKeyword */:
	        case 153 /* SetKeyword */:
	          return !isFromObjectTypeDeclaration(contextToken2);
	        case 80 /* Identifier */: {
	          if (containingNodeKind === 276 /* ImportSpecifier */ && contextToken2 === parent2.name && contextToken2.text === "type") {
	            return false;
	          }
	          const ancestorVariableDeclaration = findAncestor(
	            contextToken2.parent,
	            isVariableDeclaration
	          );
	          if (ancestorVariableDeclaration && isInDifferentLineThanContextToken(contextToken2, position)) {
	            return false;
	          }
	          break;
	        }
	        case 86 /* ClassKeyword */:
	        case 94 /* EnumKeyword */:
	        case 120 /* InterfaceKeyword */:
	        case 100 /* FunctionKeyword */:
	        case 115 /* VarKeyword */:
	        case 102 /* ImportKeyword */:
	        case 121 /* LetKeyword */:
	        case 87 /* ConstKeyword */:
	        case 140 /* InferKeyword */:
	          return true;
	        case 156 /* TypeKeyword */:
	          return containingNodeKind !== 276 /* ImportSpecifier */;
	        case 42 /* AsteriskToken */:
	          return isFunctionLike(contextToken2.parent) && !isMethodDeclaration(contextToken2.parent);
	      }
	      if (isClassMemberCompletionKeyword(keywordForNode(contextToken2)) && isFromObjectTypeDeclaration(contextToken2)) {
	        return false;
	      }
	      if (isConstructorParameterCompletion(contextToken2)) {
	        if (!isIdentifier(contextToken2) || isParameterPropertyModifier(keywordForNode(contextToken2)) || isCurrentlyEditingNode(contextToken2)) {
	          return false;
	        }
	      }
	      switch (keywordForNode(contextToken2)) {
	        case 128 /* AbstractKeyword */:
	        case 86 /* ClassKeyword */:
	        case 87 /* ConstKeyword */:
	        case 138 /* DeclareKeyword */:
	        case 94 /* EnumKeyword */:
	        case 100 /* FunctionKeyword */:
	        case 120 /* InterfaceKeyword */:
	        case 121 /* LetKeyword */:
	        case 123 /* PrivateKeyword */:
	        case 124 /* ProtectedKeyword */:
	        case 125 /* PublicKeyword */:
	        case 126 /* StaticKeyword */:
	        case 115 /* VarKeyword */:
	          return true;
	        case 134 /* AsyncKeyword */:
	          return isPropertyDeclaration(contextToken2.parent);
	      }
	      const ancestorClassLike = findAncestor(contextToken2.parent, isClassLike);
	      if (ancestorClassLike && contextToken2 === previousToken && isPreviousPropertyDeclarationTerminated(contextToken2, position)) {
	        return false;
	      }
	      const ancestorPropertyDeclaraion = getAncestor(contextToken2.parent, 172 /* PropertyDeclaration */);
	      if (ancestorPropertyDeclaraion && contextToken2 !== previousToken && isClassLike(previousToken.parent.parent) && position <= previousToken.end) {
	        if (isPreviousPropertyDeclarationTerminated(contextToken2, previousToken.end)) {
	          return false;
	        } else if (contextToken2.kind !== 64 /* EqualsToken */ && (isInitializedProperty(ancestorPropertyDeclaraion) || hasType(ancestorPropertyDeclaraion))) {
	          return true;
	        }
	      }
	      return isDeclarationName(contextToken2) && !isShorthandPropertyAssignment(contextToken2.parent) && !isJsxAttribute(contextToken2.parent) && !((isClassLike(contextToken2.parent) || isInterfaceDeclaration(contextToken2.parent) || isTypeParameterDeclaration(contextToken2.parent)) && (contextToken2 !== previousToken || position > previousToken.end));
	    }
	    function isPreviousPropertyDeclarationTerminated(contextToken2, position2) {
	      return contextToken2.kind !== 64 /* EqualsToken */ && (contextToken2.kind === 27 /* SemicolonToken */ || !positionsAreOnSameLine(contextToken2.end, position2, sourceFile));
	    }
	    function isFunctionLikeButNotConstructor(kind) {
	      return isFunctionLikeKind(kind) && kind !== 176 /* Constructor */;
	    }
	    function isDotOfNumericLiteral(contextToken2) {
	      if (contextToken2.kind === 9 /* NumericLiteral */) {
	        const text = contextToken2.getFullText();
	        return text.charAt(text.length - 1) === ".";
	      }
	      return false;
	    }
	    function isVariableDeclarationListButNotTypeArgument(node2) {
	      return node2.parent.kind === 261 /* VariableDeclarationList */ && !isPossiblyTypeArgumentPosition(node2, sourceFile, typeChecker);
	    }
	    function filterObjectMembersList(contextualMemberSymbols, existingMembers) {
	      if (existingMembers.length === 0) {
	        return contextualMemberSymbols;
	      }
	      const membersDeclaredBySpreadAssignment = /* @__PURE__ */ new Set();
	      const existingMemberNames = /* @__PURE__ */ new Set();
	      for (const m of existingMembers) {
	        if (m.kind !== 303 /* PropertyAssignment */ && m.kind !== 304 /* ShorthandPropertyAssignment */ && m.kind !== 208 /* BindingElement */ && m.kind !== 174 /* MethodDeclaration */ && m.kind !== 177 /* GetAccessor */ && m.kind !== 178 /* SetAccessor */ && m.kind !== 305 /* SpreadAssignment */) {
	          continue;
	        }
	        if (isCurrentlyEditingNode(m)) {
	          continue;
	        }
	        let existingName;
	        if (isSpreadAssignment(m)) {
	          setMembersDeclaredBySpreadAssignment(m, membersDeclaredBySpreadAssignment);
	        } else if (isBindingElement(m) && m.propertyName) {
	          if (m.propertyName.kind === 80 /* Identifier */) {
	            existingName = m.propertyName.escapedText;
	          }
	        } else {
	          const name = getNameOfDeclaration(m);
	          existingName = name && isPropertyNameLiteral(name) ? getEscapedTextOfIdentifierOrLiteral(name) : void 0;
	        }
	        if (existingName !== void 0) {
	          existingMemberNames.add(existingName);
	        }
	      }
	      const filteredSymbols = contextualMemberSymbols.filter((m) => !existingMemberNames.has(m.escapedName));
	      setSortTextToMemberDeclaredBySpreadAssignment(membersDeclaredBySpreadAssignment, filteredSymbols);
	      return filteredSymbols;
	    }
	    function setMembersDeclaredBySpreadAssignment(declaration, membersDeclaredBySpreadAssignment) {
	      const expression = declaration.expression;
	      const symbol = typeChecker.getSymbolAtLocation(expression);
	      const type = symbol && typeChecker.getTypeOfSymbolAtLocation(symbol, expression);
	      const properties = type && type.properties;
	      if (properties) {
	        properties.forEach((property) => {
	          membersDeclaredBySpreadAssignment.add(property.name);
	        });
	      }
	    }
	    function setSortTextToOptionalMember() {
	      symbols.forEach((m) => {
	        if (m.flags & 16777216 /* Optional */) {
	          const symbolId = getSymbolId(m);
	          symbolToSortTextMap[symbolId] = symbolToSortTextMap[symbolId] ?? SortText.OptionalMember;
	        }
	      });
	    }
	    function setSortTextToMemberDeclaredBySpreadAssignment(membersDeclaredBySpreadAssignment, contextualMemberSymbols) {
	      if (membersDeclaredBySpreadAssignment.size === 0) {
	        return;
	      }
	      for (const contextualMemberSymbol of contextualMemberSymbols) {
	        if (membersDeclaredBySpreadAssignment.has(contextualMemberSymbol.name)) {
	          symbolToSortTextMap[getSymbolId(contextualMemberSymbol)] = SortText.MemberDeclaredBySpreadAssignment;
	        }
	      }
	    }
	    function transformObjectLiteralMembersSortText(start2) {
	      for (let i = start2; i < symbols.length; i++) {
	        const symbol = symbols[i];
	        const symbolId = getSymbolId(symbol);
	        const origin = symbolToOriginInfoMap == null ? void 0 : symbolToOriginInfoMap[i];
	        const target = getEmitScriptTarget(compilerOptions);
	        const displayName = getCompletionEntryDisplayNameForSymbol(
	          symbol,
	          target,
	          origin,
	          0 /* ObjectPropertyDeclaration */,
	          /*jsxIdentifierExpected*/
	          false
	        );
	        if (displayName) {
	          const originalSortText = symbolToSortTextMap[symbolId] ?? SortText.LocationPriority;
	          const { name } = displayName;
	          symbolToSortTextMap[symbolId] = SortText.ObjectLiteralProperty(originalSortText, name);
	        }
	      }
	    }
	    function filterClassMembersList(baseSymbols, existingMembers, currentClassElementModifierFlags) {
	      const existingMemberNames = /* @__PURE__ */ new Set();
	      for (const m of existingMembers) {
	        if (m.kind !== 172 /* PropertyDeclaration */ && m.kind !== 174 /* MethodDeclaration */ && m.kind !== 177 /* GetAccessor */ && m.kind !== 178 /* SetAccessor */) {
	          continue;
	        }
	        if (isCurrentlyEditingNode(m)) {
	          continue;
	        }
	        if (hasEffectiveModifier(m, 2 /* Private */)) {
	          continue;
	        }
	        if (isStatic(m) !== !!(currentClassElementModifierFlags & 256 /* Static */)) {
	          continue;
	        }
	        const existingName = getPropertyNameForPropertyNameNode(m.name);
	        if (existingName) {
	          existingMemberNames.add(existingName);
	        }
	      }
	      return baseSymbols.filter(
	        (propertySymbol) => !existingMemberNames.has(propertySymbol.escapedName) && !!propertySymbol.declarations && !(getDeclarationModifierFlagsFromSymbol(propertySymbol) & 2 /* Private */) && !(propertySymbol.valueDeclaration && isPrivateIdentifierClassElementDeclaration(propertySymbol.valueDeclaration))
	      );
	    }
	    function filterJsxAttributes(symbols2, attributes) {
	      const seenNames = /* @__PURE__ */ new Set();
	      const membersDeclaredBySpreadAssignment = /* @__PURE__ */ new Set();
	      for (const attr of attributes) {
	        if (isCurrentlyEditingNode(attr)) {
	          continue;
	        }
	        if (attr.kind === 291 /* JsxAttribute */) {
	          seenNames.add(getEscapedTextOfJsxAttributeName(attr.name));
	        } else if (isJsxSpreadAttribute(attr)) {
	          setMembersDeclaredBySpreadAssignment(attr, membersDeclaredBySpreadAssignment);
	        }
	      }
	      const filteredSymbols = symbols2.filter((a) => !seenNames.has(a.escapedName));
	      setSortTextToMemberDeclaredBySpreadAssignment(membersDeclaredBySpreadAssignment, filteredSymbols);
	      return filteredSymbols;
	    }
	    function isCurrentlyEditingNode(node2) {
	      return node2.getStart(sourceFile) <= position && position <= node2.getEnd();
	    }
	  }
	  function tryGetObjectLikeCompletionContainer(contextToken, position, sourceFile) {
	    var _a;
	    if (contextToken) {
	      const { parent: parent2 } = contextToken;
	      switch (contextToken.kind) {
	        case 19 /* OpenBraceToken */:
	        case 28 /* CommaToken */:
	          if (isObjectLiteralExpression(parent2) || isObjectBindingPattern(parent2)) {
	            return parent2;
	          }
	          break;
	        case 42 /* AsteriskToken */:
	          return isMethodDeclaration(parent2) ? tryCast(parent2.parent, isObjectLiteralExpression) : void 0;
	        case 134 /* AsyncKeyword */:
	          return tryCast(parent2.parent, isObjectLiteralExpression);
	        case 80 /* Identifier */:
	          if (contextToken.text === "async" && isShorthandPropertyAssignment(contextToken.parent)) {
	            return contextToken.parent.parent;
	          } else {
	            if (isObjectLiteralExpression(contextToken.parent.parent) && (isSpreadAssignment(contextToken.parent) || isShorthandPropertyAssignment(contextToken.parent) && getLineAndCharacterOfPosition(sourceFile, contextToken.getEnd()).line !== getLineAndCharacterOfPosition(sourceFile, position).line)) {
	              return contextToken.parent.parent;
	            }
	            const ancestorNode2 = findAncestor(parent2, isPropertyAssignment);
	            if ((ancestorNode2 == null ? void 0 : ancestorNode2.getLastToken(sourceFile)) === contextToken && isObjectLiteralExpression(ancestorNode2.parent)) {
	              return ancestorNode2.parent;
	            }
	          }
	          break;
	        default:
	          if (((_a = parent2.parent) == null ? void 0 : _a.parent) && (isMethodDeclaration(parent2.parent) || isGetAccessorDeclaration(parent2.parent) || isSetAccessorDeclaration(parent2.parent)) && isObjectLiteralExpression(parent2.parent.parent)) {
	            return parent2.parent.parent;
	          }
	          if (isSpreadAssignment(parent2) && isObjectLiteralExpression(parent2.parent)) {
	            return parent2.parent;
	          }
	          const ancestorNode = findAncestor(parent2, isPropertyAssignment);
	          if (contextToken.kind !== 59 /* ColonToken */ && (ancestorNode == null ? void 0 : ancestorNode.getLastToken(sourceFile)) === contextToken && isObjectLiteralExpression(ancestorNode.parent)) {
	            return ancestorNode.parent;
	          }
	      }
	    }
	    return void 0;
	  }
	  function getRelevantTokens(position, sourceFile) {
	    const previousToken = findPrecedingToken(position, sourceFile);
	    if (previousToken && position <= previousToken.end && (isMemberName(previousToken) || isKeyword(previousToken.kind))) {
	      const contextToken = findPrecedingToken(
	        previousToken.getFullStart(),
	        sourceFile,
	        /*startNode*/
	        void 0
	      );
	      return { contextToken, previousToken };
	    }
	    return { contextToken: previousToken, previousToken };
	  }
	  function getAutoImportSymbolFromCompletionEntryData(name, data, program, host) {
	    const containingProgram = data.isPackageJsonImport ? host.getPackageJsonAutoImportProvider() : program;
	    const checker = containingProgram.getTypeChecker();
	    const moduleSymbol = data.ambientModuleName ? checker.tryFindAmbientModule(data.ambientModuleName) : data.fileName ? checker.getMergedSymbol(Debug.checkDefined(containingProgram.getSourceFile(data.fileName)).symbol) : void 0;
	    if (!moduleSymbol)
	      return void 0;
	    let symbol = data.exportName === "export=" /* ExportEquals */ ? checker.resolveExternalModuleSymbol(moduleSymbol) : checker.tryGetMemberInModuleExportsAndProperties(data.exportName, moduleSymbol);
	    if (!symbol)
	      return void 0;
	    const isDefaultExport = data.exportName === "default" /* Default */;
	    symbol = isDefaultExport && getLocalSymbolForExportDefault(symbol) || symbol;
	    return { symbol, origin: completionEntryDataToSymbolOriginInfo(data, name, moduleSymbol) };
	  }
	  function getCompletionEntryDisplayNameForSymbol(symbol, target, origin, kind, jsxIdentifierExpected) {
	    if (originIsIgnore(origin)) {
	      return void 0;
	    }
	    const name = originIncludesSymbolName(origin) ? origin.symbolName : symbol.name;
	    if (name === void 0 || symbol.flags & 1536 /* Module */ && isSingleOrDoubleQuote(name.charCodeAt(0)) || isKnownSymbol(symbol)) {
	      return void 0;
	    }
	    const validNameResult = { name, needsConvertPropertyAccess: false };
	    if (isIdentifierText(name, target, jsxIdentifierExpected ? 1 /* JSX */ : 0 /* Standard */) || symbol.valueDeclaration && isPrivateIdentifierClassElementDeclaration(symbol.valueDeclaration)) {
	      return validNameResult;
	    }
	    switch (kind) {
	      case 3 /* MemberLike */:
	        return originIsComputedPropertyName(origin) ? { name: origin.symbolName, needsConvertPropertyAccess: false } : void 0;
	      case 0 /* ObjectPropertyDeclaration */:
	        return { name: JSON.stringify(name), needsConvertPropertyAccess: false };
	      case 2 /* PropertyAccess */:
	      case 1 /* Global */:
	        return name.charCodeAt(0) === 32 /* space */ ? void 0 : { name, needsConvertPropertyAccess: true };
	      case 5 /* None */:
	      case 4 /* String */:
	        return validNameResult;
	      default:
	        Debug.assertNever(kind);
	    }
	  }
	  function getKeywordCompletions(keywordFilter, filterOutTsOnlyKeywords) {
	    if (!filterOutTsOnlyKeywords)
	      return getTypescriptKeywordCompletions(keywordFilter);
	    const index = keywordFilter + 8 /* Last */ + 1;
	    return _keywordCompletions[index] || (_keywordCompletions[index] = getTypescriptKeywordCompletions(keywordFilter).filter((entry) => !isTypeScriptOnlyKeyword(stringToToken(entry.name))));
	  }
	  function getTypescriptKeywordCompletions(keywordFilter) {
	    return _keywordCompletions[keywordFilter] || (_keywordCompletions[keywordFilter] = allKeywordsCompletions().filter((entry) => {
	      const kind = stringToToken(entry.name);
	      switch (keywordFilter) {
	        case 0 /* None */:
	          return false;
	        case 1 /* All */:
	          return isFunctionLikeBodyKeyword(kind) || kind === 138 /* DeclareKeyword */ || kind === 144 /* ModuleKeyword */ || kind === 156 /* TypeKeyword */ || kind === 145 /* NamespaceKeyword */ || kind === 128 /* AbstractKeyword */ || isTypeKeyword(kind) && kind !== 157 /* UndefinedKeyword */;
	        case 5 /* FunctionLikeBodyKeywords */:
	          return isFunctionLikeBodyKeyword(kind);
	        case 2 /* ClassElementKeywords */:
	          return isClassMemberCompletionKeyword(kind);
	        case 3 /* InterfaceElementKeywords */:
	          return isInterfaceOrTypeLiteralCompletionKeyword(kind);
	        case 4 /* ConstructorParameterKeywords */:
	          return isParameterPropertyModifier(kind);
	        case 6 /* TypeAssertionKeywords */:
	          return isTypeKeyword(kind) || kind === 87 /* ConstKeyword */;
	        case 7 /* TypeKeywords */:
	          return isTypeKeyword(kind);
	        case 8 /* TypeKeyword */:
	          return kind === 156 /* TypeKeyword */;
	        default:
	          return Debug.assertNever(keywordFilter);
	      }
	    }));
	  }
	  function isTypeScriptOnlyKeyword(kind) {
	    switch (kind) {
	      case 128 /* AbstractKeyword */:
	      case 133 /* AnyKeyword */:
	      case 163 /* BigIntKeyword */:
	      case 136 /* BooleanKeyword */:
	      case 138 /* DeclareKeyword */:
	      case 94 /* EnumKeyword */:
	      case 162 /* GlobalKeyword */:
	      case 119 /* ImplementsKeyword */:
	      case 140 /* InferKeyword */:
	      case 120 /* InterfaceKeyword */:
	      case 142 /* IsKeyword */:
	      case 143 /* KeyOfKeyword */:
	      case 144 /* ModuleKeyword */:
	      case 145 /* NamespaceKeyword */:
	      case 146 /* NeverKeyword */:
	      case 150 /* NumberKeyword */:
	      case 151 /* ObjectKeyword */:
	      case 164 /* OverrideKeyword */:
	      case 123 /* PrivateKeyword */:
	      case 124 /* ProtectedKeyword */:
	      case 125 /* PublicKeyword */:
	      case 148 /* ReadonlyKeyword */:
	      case 154 /* StringKeyword */:
	      case 155 /* SymbolKeyword */:
	      case 156 /* TypeKeyword */:
	      case 158 /* UniqueKeyword */:
	      case 159 /* UnknownKeyword */:
	        return true;
	      default:
	        return false;
	    }
	  }
	  function isInterfaceOrTypeLiteralCompletionKeyword(kind) {
	    return kind === 148 /* ReadonlyKeyword */;
	  }
	  function isClassMemberCompletionKeyword(kind) {
	    switch (kind) {
	      case 128 /* AbstractKeyword */:
	      case 129 /* AccessorKeyword */:
	      case 137 /* ConstructorKeyword */:
	      case 139 /* GetKeyword */:
	      case 153 /* SetKeyword */:
	      case 134 /* AsyncKeyword */:
	      case 138 /* DeclareKeyword */:
	      case 164 /* OverrideKeyword */:
	        return true;
	      default:
	        return isClassMemberModifier(kind);
	    }
	  }
	  function isFunctionLikeBodyKeyword(kind) {
	    return kind === 134 /* AsyncKeyword */ || kind === 135 /* AwaitKeyword */ || kind === 160 /* UsingKeyword */ || kind === 130 /* AsKeyword */ || kind === 152 /* SatisfiesKeyword */ || kind === 156 /* TypeKeyword */ || !isContextualKeyword(kind) && !isClassMemberCompletionKeyword(kind);
	  }
	  function keywordForNode(node) {
	    return isIdentifier(node) ? identifierToKeywordKind(node) ?? 0 /* Unknown */ : node.kind;
	  }
	  function getContextualKeywords(contextToken, position) {
	    const entries = [];
	    if (contextToken) {
	      const file = contextToken.getSourceFile();
	      const parent2 = contextToken.parent;
	      const tokenLine = file.getLineAndCharacterOfPosition(contextToken.end).line;
	      const currentLine = file.getLineAndCharacterOfPosition(position).line;
	      if ((isImportDeclaration(parent2) || isExportDeclaration(parent2) && parent2.moduleSpecifier) && contextToken === parent2.moduleSpecifier && tokenLine === currentLine) {
	        entries.push({
	          name: tokenToString(132 /* AssertKeyword */),
	          kind: "keyword" /* keyword */,
	          kindModifiers: "" /* none */,
	          sortText: SortText.GlobalsOrKeywords
	        });
	      }
	    }
	    return entries;
	  }
	  function getJsDocTagAtPosition(node, position) {
	    return findAncestor(node, (n) => isJSDocTag(n) && rangeContainsPosition(n, position) ? true : isJSDoc(n) ? "quit" : false);
	  }
	  function getPropertiesForObjectExpression(contextualType, completionsType, obj, checker) {
	    const hasCompletionsType = completionsType && completionsType !== contextualType;
	    const type = hasCompletionsType && !(completionsType.flags & 3 /* AnyOrUnknown */) ? checker.getUnionType([contextualType, completionsType]) : contextualType;
	    const properties = getApparentProperties(type, obj, checker);
	    return type.isClass() && containsNonPublicProperties(properties) ? [] : hasCompletionsType ? filter(properties, hasDeclarationOtherThanSelf) : properties;
	    function hasDeclarationOtherThanSelf(member) {
	      if (!length(member.declarations))
	        return true;
	      return some(member.declarations, (decl) => decl.parent !== obj);
	    }
	  }
	  function getApparentProperties(type, node, checker) {
	    if (!type.isUnion())
	      return type.getApparentProperties();
	    return checker.getAllPossiblePropertiesOfTypes(filter(type.types, (memberType) => !(memberType.flags & 402784252 /* Primitive */ || checker.isArrayLikeType(memberType) || checker.isTypeInvalidDueToUnionDiscriminant(memberType, node) || checker.typeHasCallOrConstructSignatures(memberType) || memberType.isClass() && containsNonPublicProperties(memberType.getApparentProperties()))));
	  }
	  function containsNonPublicProperties(props) {
	    return some(props, (p) => !!(getDeclarationModifierFlagsFromSymbol(p) & 6 /* NonPublicAccessibilityModifier */));
	  }
	  function getPropertiesForCompletion(type, checker) {
	    return type.isUnion() ? Debug.checkEachDefined(checker.getAllPossiblePropertiesOfTypes(type.types), "getAllPossiblePropertiesOfTypes() should all be defined") : Debug.checkEachDefined(type.getApparentProperties(), "getApparentProperties() should all be defined");
	  }
	  function tryGetObjectTypeDeclarationCompletionContainer(sourceFile, contextToken, location, position) {
	    switch (location.kind) {
	      case 358 /* SyntaxList */:
	        return tryCast(location.parent, isObjectTypeDeclaration);
	      case 1 /* EndOfFileToken */:
	        const cls = tryCast(lastOrUndefined(cast(location.parent, isSourceFile).statements), isObjectTypeDeclaration);
	        if (cls && !findChildOfKind(cls, 20 /* CloseBraceToken */, sourceFile)) {
	          return cls;
	        }
	        break;
	      case 81 /* PrivateIdentifier */:
	        if (tryCast(location.parent, isPropertyDeclaration)) {
	          return findAncestor(location, isClassLike);
	        }
	        break;
	      case 80 /* Identifier */: {
	        const originalKeywordKind = identifierToKeywordKind(location);
	        if (originalKeywordKind) {
	          return void 0;
	        }
	        if (isPropertyDeclaration(location.parent) && location.parent.initializer === location) {
	          return void 0;
	        }
	        if (isFromObjectTypeDeclaration(location)) {
	          return findAncestor(location, isObjectTypeDeclaration);
	        }
	      }
	    }
	    if (!contextToken)
	      return void 0;
	    if (location.kind === 137 /* ConstructorKeyword */ || isIdentifier(contextToken) && isPropertyDeclaration(contextToken.parent) && isClassLike(location)) {
	      return findAncestor(contextToken, isClassLike);
	    }
	    switch (contextToken.kind) {
	      case 64 /* EqualsToken */:
	        return void 0;
	      case 27 /* SemicolonToken */:
	      case 20 /* CloseBraceToken */:
	        return isFromObjectTypeDeclaration(location) && location.parent.name === location ? location.parent.parent : tryCast(location, isObjectTypeDeclaration);
	      case 19 /* OpenBraceToken */:
	      case 28 /* CommaToken */:
	        return tryCast(contextToken.parent, isObjectTypeDeclaration);
	      default:
	        if (isObjectTypeDeclaration(location)) {
	          if (getLineAndCharacterOfPosition(sourceFile, contextToken.getEnd()).line !== getLineAndCharacterOfPosition(sourceFile, position).line) {
	            return location;
	          }
	          const isValidKeyword = isClassLike(contextToken.parent.parent) ? isClassMemberCompletionKeyword : isInterfaceOrTypeLiteralCompletionKeyword;
	          return isValidKeyword(contextToken.kind) || contextToken.kind === 42 /* AsteriskToken */ || isIdentifier(contextToken) && isValidKeyword(identifierToKeywordKind(contextToken) ?? 0 /* Unknown */) ? contextToken.parent.parent : void 0;
	        }
	        return void 0;
	    }
	  }
	  function tryGetTypeLiteralNode(node) {
	    if (!node)
	      return void 0;
	    const parent2 = node.parent;
	    switch (node.kind) {
	      case 19 /* OpenBraceToken */:
	        if (isTypeLiteralNode(parent2)) {
	          return parent2;
	        }
	        break;
	      case 27 /* SemicolonToken */:
	      case 28 /* CommaToken */:
	      case 80 /* Identifier */:
	        if (parent2.kind === 171 /* PropertySignature */ && isTypeLiteralNode(parent2.parent)) {
	          return parent2.parent;
	        }
	        break;
	    }
	    return void 0;
	  }
	  function getConstraintOfTypeArgumentProperty(node, checker) {
	    if (!node)
	      return void 0;
	    if (isTypeNode(node) && isTypeReferenceType(node.parent)) {
	      return checker.getTypeArgumentConstraint(node);
	    }
	    const t = getConstraintOfTypeArgumentProperty(node.parent, checker);
	    if (!t)
	      return void 0;
	    switch (node.kind) {
	      case 171 /* PropertySignature */:
	        return checker.getTypeOfPropertyOfContextualType(t, node.symbol.escapedName);
	      case 193 /* IntersectionType */:
	      case 187 /* TypeLiteral */:
	      case 192 /* UnionType */:
	        return t;
	    }
	  }
	  function isFromObjectTypeDeclaration(node) {
	    return node.parent && isClassOrTypeElement(node.parent) && isObjectTypeDeclaration(node.parent.parent);
	  }
	  function isValidTrigger(sourceFile, triggerCharacter, contextToken, position) {
	    switch (triggerCharacter) {
	      case ".":
	      case "@":
	        return true;
	      case '"':
	      case "'":
	      case "`":
	        return !!contextToken && isStringLiteralOrTemplate(contextToken) && position === contextToken.getStart(sourceFile) + 1;
	      case "#":
	        return !!contextToken && isPrivateIdentifier(contextToken) && !!getContainingClass(contextToken);
	      case "<":
	        return !!contextToken && contextToken.kind === 30 /* LessThanToken */ && (!isBinaryExpression(contextToken.parent) || binaryExpressionMayBeOpenTag(contextToken.parent));
	      case "/":
	        return !!contextToken && (isStringLiteralLike(contextToken) ? !!tryGetImportFromModuleSpecifier(contextToken) : contextToken.kind === 44 /* SlashToken */ && isJsxClosingElement(contextToken.parent));
	      case " ":
	        return !!contextToken && isImportKeyword(contextToken) && contextToken.parent.kind === 312 /* SourceFile */;
	      default:
	        return Debug.assertNever(triggerCharacter);
	    }
	  }
	  function binaryExpressionMayBeOpenTag({ left }) {
	    return nodeIsMissing(left);
	  }
	  function isProbablyGlobalType(type, sourceFile, checker) {
	    const selfSymbol = checker.resolveName(
	      "self",
	      /*location*/
	      void 0,
	      111551 /* Value */,
	      /*excludeGlobals*/
	      false
	    );
	    if (selfSymbol && checker.getTypeOfSymbolAtLocation(selfSymbol, sourceFile) === type) {
	      return true;
	    }
	    const globalSymbol = checker.resolveName(
	      "global",
	      /*location*/
	      void 0,
	      111551 /* Value */,
	      /*excludeGlobals*/
	      false
	    );
	    if (globalSymbol && checker.getTypeOfSymbolAtLocation(globalSymbol, sourceFile) === type) {
	      return true;
	    }
	    const globalThisSymbol = checker.resolveName(
	      "globalThis",
	      /*location*/
	      void 0,
	      111551 /* Value */,
	      /*excludeGlobals*/
	      false
	    );
	    if (globalThisSymbol && checker.getTypeOfSymbolAtLocation(globalThisSymbol, sourceFile) === type) {
	      return true;
	    }
	    return false;
	  }
	  function isStaticProperty(symbol) {
	    return !!(symbol.valueDeclaration && getEffectiveModifierFlags(symbol.valueDeclaration) & 256 /* Static */ && isClassLike(symbol.valueDeclaration.parent));
	  }
	  function tryGetObjectLiteralContextualType(node, typeChecker) {
	    const type = typeChecker.getContextualType(node);
	    if (type) {
	      return type;
	    }
	    const parent2 = walkUpParenthesizedExpressions(node.parent);
	    if (isBinaryExpression(parent2) && parent2.operatorToken.kind === 64 /* EqualsToken */ && node === parent2.left) {
	      return typeChecker.getTypeAtLocation(parent2);
	    }
	    if (isExpression(parent2)) {
	      return typeChecker.getContextualType(parent2);
	    }
	    return void 0;
	  }
	  function getImportStatementCompletionInfo(contextToken, sourceFile) {
	    var _a, _b, _c;
	    let keywordCompletion;
	    let isKeywordOnlyCompletion = false;
	    const candidate = getCandidate();
	    return {
	      isKeywordOnlyCompletion,
	      keywordCompletion,
	      isNewIdentifierLocation: !!(candidate || keywordCompletion === 156 /* TypeKeyword */),
	      isTopLevelTypeOnly: !!((_b = (_a = tryCast(candidate, isImportDeclaration)) == null ? void 0 : _a.importClause) == null ? void 0 : _b.isTypeOnly) || !!((_c = tryCast(candidate, isImportEqualsDeclaration)) == null ? void 0 : _c.isTypeOnly),
	      couldBeTypeOnlyImportSpecifier: !!candidate && couldBeTypeOnlyImportSpecifier(candidate, contextToken),
	      replacementSpan: getSingleLineReplacementSpanForImportCompletionNode(candidate)
	    };
	    function getCandidate() {
	      const parent2 = contextToken.parent;
	      if (isImportEqualsDeclaration(parent2)) {
	        const lastToken = parent2.getLastToken(sourceFile);
	        if (isIdentifier(contextToken) && lastToken !== contextToken) {
	          keywordCompletion = 161 /* FromKeyword */;
	          isKeywordOnlyCompletion = true;
	          return void 0;
	        }
	        keywordCompletion = contextToken.kind === 156 /* TypeKeyword */ ? void 0 : 156 /* TypeKeyword */;
	        return isModuleSpecifierMissingOrEmpty(parent2.moduleReference) ? parent2 : void 0;
	      }
	      if (couldBeTypeOnlyImportSpecifier(parent2, contextToken) && canCompleteFromNamedBindings(parent2.parent)) {
	        return parent2;
	      }
	      if (isNamedImports(parent2) || isNamespaceImport(parent2)) {
	        if (!parent2.parent.isTypeOnly && (contextToken.kind === 19 /* OpenBraceToken */ || contextToken.kind === 102 /* ImportKeyword */ || contextToken.kind === 28 /* CommaToken */)) {
	          keywordCompletion = 156 /* TypeKeyword */;
	        }
	        if (canCompleteFromNamedBindings(parent2)) {
	          if (contextToken.kind === 20 /* CloseBraceToken */ || contextToken.kind === 80 /* Identifier */) {
	            isKeywordOnlyCompletion = true;
	            keywordCompletion = 161 /* FromKeyword */;
	          } else {
	            return parent2.parent.parent;
	          }
	        }
	        return void 0;
	      }
	      if (isExportDeclaration(parent2) && contextToken.kind === 42 /* AsteriskToken */ || isNamedExports(parent2) && contextToken.kind === 20 /* CloseBraceToken */) {
	        isKeywordOnlyCompletion = true;
	        keywordCompletion = 161 /* FromKeyword */;
	        return void 0;
	      }
	      if (isImportKeyword(contextToken) && isSourceFile(parent2)) {
	        keywordCompletion = 156 /* TypeKeyword */;
	        return contextToken;
	      }
	      if (isImportKeyword(contextToken) && isImportDeclaration(parent2)) {
	        keywordCompletion = 156 /* TypeKeyword */;
	        return isModuleSpecifierMissingOrEmpty(parent2.moduleSpecifier) ? parent2 : void 0;
	      }
	      return void 0;
	    }
	  }
	  function getSingleLineReplacementSpanForImportCompletionNode(node) {
	    var _a;
	    if (!node)
	      return void 0;
	    const top = findAncestor(node, or(isImportDeclaration, isImportEqualsDeclaration)) ?? node;
	    const sourceFile = top.getSourceFile();
	    if (rangeIsOnSingleLine(top, sourceFile)) {
	      return createTextSpanFromNode(top, sourceFile);
	    }
	    Debug.assert(top.kind !== 102 /* ImportKeyword */ && top.kind !== 276 /* ImportSpecifier */);
	    const potentialSplitPoint = top.kind === 272 /* ImportDeclaration */ ? getPotentiallyInvalidImportSpecifier((_a = top.importClause) == null ? void 0 : _a.namedBindings) ?? top.moduleSpecifier : top.moduleReference;
	    const withoutModuleSpecifier = {
	      pos: top.getFirstToken().getStart(),
	      end: potentialSplitPoint.pos
	    };
	    if (rangeIsOnSingleLine(withoutModuleSpecifier, sourceFile)) {
	      return createTextSpanFromRange(withoutModuleSpecifier);
	    }
	  }
	  function getPotentiallyInvalidImportSpecifier(namedBindings) {
	    var _a;
	    return find(
	      (_a = tryCast(namedBindings, isNamedImports)) == null ? void 0 : _a.elements,
	      (e) => {
	        var _a2;
	        return !e.propertyName && isStringANonContextualKeyword(e.name.text) && ((_a2 = findPrecedingToken(e.name.pos, namedBindings.getSourceFile(), namedBindings)) == null ? void 0 : _a2.kind) !== 28 /* CommaToken */;
	      }
	    );
	  }
	  function couldBeTypeOnlyImportSpecifier(importSpecifier, contextToken) {
	    return isImportSpecifier(importSpecifier) && (importSpecifier.isTypeOnly || contextToken === importSpecifier.name && isTypeKeywordTokenOrIdentifier(contextToken));
	  }
	  function canCompleteFromNamedBindings(namedBindings) {
	    if (!isModuleSpecifierMissingOrEmpty(namedBindings.parent.parent.moduleSpecifier) || namedBindings.parent.name) {
	      return false;
	    }
	    if (isNamedImports(namedBindings)) {
	      const invalidNamedImport = getPotentiallyInvalidImportSpecifier(namedBindings);
	      const validImports = invalidNamedImport ? namedBindings.elements.indexOf(invalidNamedImport) : namedBindings.elements.length;
	      return validImports < 2;
	    }
	    return true;
	  }
	  function isModuleSpecifierMissingOrEmpty(specifier) {
	    var _a;
	    if (nodeIsMissing(specifier))
	      return true;
	    return !((_a = tryCast(isExternalModuleReference(specifier) ? specifier.expression : specifier, isStringLiteralLike)) == null ? void 0 : _a.text);
	  }
	  function getVariableOrParameterDeclaration(contextToken, location) {
	    if (!contextToken)
	      return;
	    const possiblyParameterDeclaration = findAncestor(contextToken, (node) => isFunctionBlock(node) || isArrowFunctionBody(node) || isBindingPattern(node) ? "quit" : (isParameter(node) || isTypeParameterDeclaration(node)) && !isIndexSignatureDeclaration(node.parent));
	    const possiblyVariableDeclaration = findAncestor(location, (node) => isFunctionBlock(node) || isArrowFunctionBody(node) || isBindingPattern(node) ? "quit" : isVariableDeclaration(node));
	    return possiblyParameterDeclaration || possiblyVariableDeclaration;
	  }
	  function isArrowFunctionBody(node) {
	    return node.parent && isArrowFunction(node.parent) && (node.parent.body === node || // const a = () => /**/;
	    node.kind === 39 /* EqualsGreaterThanToken */);
	  }
	  function symbolCanBeReferencedAtTypeLocation(symbol, checker, seenModules = /* @__PURE__ */ new Map()) {
	    return nonAliasCanBeReferencedAtTypeLocation(symbol) || nonAliasCanBeReferencedAtTypeLocation(skipAlias(symbol.exportSymbol || symbol, checker));
	    function nonAliasCanBeReferencedAtTypeLocation(symbol2) {
	      return !!(symbol2.flags & 788968 /* Type */) || checker.isUnknownSymbol(symbol2) || !!(symbol2.flags & 1536 /* Module */) && addToSeen(seenModules, getSymbolId(symbol2)) && checker.getExportsOfModule(symbol2).some((e) => symbolCanBeReferencedAtTypeLocation(e, checker, seenModules));
	    }
	  }
	  function isDeprecated(symbol, checker) {
	    const declarations = skipAlias(symbol, checker).declarations;
	    return !!length(declarations) && every(declarations, isDeprecatedDeclaration);
	  }
	  function charactersFuzzyMatchInString(identifierString, lowercaseCharacters) {
	    if (lowercaseCharacters.length === 0) {
	      return true;
	    }
	    let matchedFirstCharacter = false;
	    let prevChar;
	    let characterIndex = 0;
	    const len = identifierString.length;
	    for (let strIndex = 0; strIndex < len; strIndex++) {
	      const strChar = identifierString.charCodeAt(strIndex);
	      const testChar = lowercaseCharacters.charCodeAt(characterIndex);
	      if (strChar === testChar || strChar === toUpperCharCode(testChar)) {
	        matchedFirstCharacter || (matchedFirstCharacter = prevChar === void 0 || // Beginning of word
	        97 /* a */ <= prevChar && prevChar <= 122 /* z */ && 65 /* A */ <= strChar && strChar <= 90 /* Z */ || // camelCase transition
	        prevChar === 95 /* _ */ && strChar !== 95 /* _ */);
	        if (matchedFirstCharacter) {
	          characterIndex++;
	        }
	        if (characterIndex === lowercaseCharacters.length) {
	          return true;
	        }
	      }
	      prevChar = strChar;
	    }
	    return false;
	  }
	  function toUpperCharCode(charCode) {
	    if (97 /* a */ <= charCode && charCode <= 122 /* z */) {
	      return charCode - 32;
	    }
	    return charCode;
	  }
	  function isContextualKeywordInAutoImportableExpressionSpace(keyword) {
	    return keyword === "abstract" || keyword === "async" || keyword === "await" || keyword === "declare" || keyword === "module" || keyword === "namespace" || keyword === "type";
	  }
	  var moduleSpecifierResolutionLimit, moduleSpecifierResolutionCacheAttemptLimit, SortText, CompletionSource, SymbolOriginInfoKind, CompletionKind, _keywordCompletions, allKeywordsCompletions;
	  var init_completions = __esm({
	    "src/services/completions.ts"() {
	      init_ts4();
	      init_ts_Completions();
	      moduleSpecifierResolutionLimit = 100;
	      moduleSpecifierResolutionCacheAttemptLimit = 1e3;
	      SortText = {
	        // Presets
	        LocalDeclarationPriority: "10",
	        LocationPriority: "11",
	        OptionalMember: "12",
	        MemberDeclaredBySpreadAssignment: "13",
	        SuggestedClassMembers: "14",
	        GlobalsOrKeywords: "15",
	        AutoImportSuggestions: "16",
	        ClassMemberSnippets: "17",
	        JavascriptIdentifiers: "18",
	        // Transformations
	        Deprecated(sortText) {
	          return "z" + sortText;
	        },
	        ObjectLiteralProperty(presetSortText, symbolDisplayName) {
	          return `${presetSortText}\0${symbolDisplayName}\0`;
	        },
	        SortBelow(sortText) {
	          return sortText + "1";
	        }
	      };
	      CompletionSource = /* @__PURE__ */ ((CompletionSource2) => {
	        CompletionSource2["ThisProperty"] = "ThisProperty/";
	        CompletionSource2["ClassMemberSnippet"] = "ClassMemberSnippet/";
	        CompletionSource2["TypeOnlyAlias"] = "TypeOnlyAlias/";
	        CompletionSource2["ObjectLiteralMethodSnippet"] = "ObjectLiteralMethodSnippet/";
	        CompletionSource2["SwitchCases"] = "SwitchCases/";
	        CompletionSource2["ObjectLiteralMemberWithComma"] = "ObjectLiteralMemberWithComma/";
	        return CompletionSource2;
	      })(CompletionSource || {});
	      SymbolOriginInfoKind = /* @__PURE__ */ ((SymbolOriginInfoKind2) => {
	        SymbolOriginInfoKind2[SymbolOriginInfoKind2["ThisType"] = 1] = "ThisType";
	        SymbolOriginInfoKind2[SymbolOriginInfoKind2["SymbolMember"] = 2] = "SymbolMember";
	        SymbolOriginInfoKind2[SymbolOriginInfoKind2["Export"] = 4] = "Export";
	        SymbolOriginInfoKind2[SymbolOriginInfoKind2["Promise"] = 8] = "Promise";
	        SymbolOriginInfoKind2[SymbolOriginInfoKind2["Nullable"] = 16] = "Nullable";
	        SymbolOriginInfoKind2[SymbolOriginInfoKind2["ResolvedExport"] = 32] = "ResolvedExport";
	        SymbolOriginInfoKind2[SymbolOriginInfoKind2["TypeOnlyAlias"] = 64] = "TypeOnlyAlias";
	        SymbolOriginInfoKind2[SymbolOriginInfoKind2["ObjectLiteralMethod"] = 128] = "ObjectLiteralMethod";
	        SymbolOriginInfoKind2[SymbolOriginInfoKind2["Ignore"] = 256] = "Ignore";
	        SymbolOriginInfoKind2[SymbolOriginInfoKind2["ComputedPropertyName"] = 512] = "ComputedPropertyName";
	        SymbolOriginInfoKind2[SymbolOriginInfoKind2["SymbolMemberNoExport"] = 2 /* SymbolMember */] = "SymbolMemberNoExport";
	        SymbolOriginInfoKind2[SymbolOriginInfoKind2["SymbolMemberExport"] = 6] = "SymbolMemberExport";
	        return SymbolOriginInfoKind2;
	      })(SymbolOriginInfoKind || {});
	      CompletionKind = /* @__PURE__ */ ((CompletionKind2) => {
	        CompletionKind2[CompletionKind2["ObjectPropertyDeclaration"] = 0] = "ObjectPropertyDeclaration";
	        CompletionKind2[CompletionKind2["Global"] = 1] = "Global";
	        CompletionKind2[CompletionKind2["PropertyAccess"] = 2] = "PropertyAccess";
	        CompletionKind2[CompletionKind2["MemberLike"] = 3] = "MemberLike";
	        CompletionKind2[CompletionKind2["String"] = 4] = "String";
	        CompletionKind2[CompletionKind2["None"] = 5] = "None";
	        return CompletionKind2;
	      })(CompletionKind || {});
	      _keywordCompletions = [];
	      allKeywordsCompletions = memoize(() => {
	        const res = [];
	        for (let i = 83 /* FirstKeyword */; i <= 165 /* LastKeyword */; i++) {
	          res.push({
	            name: tokenToString(i),
	            kind: "keyword" /* keyword */,
	            kindModifiers: "" /* none */,
	            sortText: SortText.GlobalsOrKeywords
	          });
	        }
	        return res;
	      });
	    }
	  });

	  // src/services/stringCompletions.ts
	  function createNameAndKindSet() {
	    const map2 = /* @__PURE__ */ new Map();
	    function add(value) {
	      const existing = map2.get(value.name);
	      if (!existing || kindPrecedence[existing.kind] < kindPrecedence[value.kind]) {
	        map2.set(value.name, value);
	      }
	    }
	    return {
	      add,
	      has: map2.has.bind(map2),
	      values: map2.values.bind(map2)
	    };
	  }
	  function getStringLiteralCompletions(sourceFile, position, contextToken, options, host, program, log, preferences, includeSymbol) {
	    if (isInReferenceComment(sourceFile, position)) {
	      const entries = getTripleSlashReferenceCompletion(sourceFile, position, options, host);
	      return entries && convertPathCompletions(entries);
	    }
	    if (isInString(sourceFile, position, contextToken)) {
	      if (!contextToken || !isStringLiteralLike(contextToken))
	        return void 0;
	      const entries = getStringLiteralCompletionEntries(sourceFile, contextToken, position, program, host, preferences);
	      return convertStringLiteralCompletions(entries, contextToken, sourceFile, host, program, log, options, preferences, position, includeSymbol);
	    }
	  }
	  function convertStringLiteralCompletions(completion, contextToken, sourceFile, host, program, log, options, preferences, position, includeSymbol) {
	    if (completion === void 0) {
	      return void 0;
	    }
	    const optionalReplacementSpan = createTextSpanFromStringLiteralLikeContent(contextToken);
	    switch (completion.kind) {
	      case 0 /* Paths */:
	        return convertPathCompletions(completion.paths);
	      case 1 /* Properties */: {
	        const entries = createSortedArray();
	        getCompletionEntriesFromSymbols(
	          completion.symbols,
	          entries,
	          contextToken,
	          contextToken,
	          sourceFile,
	          position,
	          sourceFile,
	          host,
	          program,
	          99 /* ESNext */,
	          log,
	          4 /* String */,
	          preferences,
	          options,
	          /*formatContext*/
	          void 0,
	          /*isTypeOnlyLocation*/
	          void 0,
	          /*propertyAccessToConvert*/
	          void 0,
	          /*jsxIdentifierExpected*/
	          void 0,
	          /*isJsxInitializer*/
	          void 0,
	          /*importStatementCompletion*/
	          void 0,
	          /*recommendedCompletion*/
	          void 0,
	          /*symbolToOriginInfoMap*/
	          void 0,
	          /*symbolToSortTextMap*/
	          void 0,
	          /*isJsxIdentifierExpected*/
	          void 0,
	          /*isRightOfOpenTag*/
	          void 0,
	          includeSymbol
	        );
	        return { isGlobalCompletion: false, isMemberCompletion: true, isNewIdentifierLocation: completion.hasIndexSignature, optionalReplacementSpan, entries };
	      }
	      case 2 /* Types */: {
	        const quoteChar = contextToken.kind === 15 /* NoSubstitutionTemplateLiteral */ ? 96 /* backtick */ : startsWith(getTextOfNode(contextToken), "'") ? 39 /* singleQuote */ : 34 /* doubleQuote */;
	        const entries = completion.types.map((type) => ({
	          name: escapeString(type.value, quoteChar),
	          kindModifiers: "" /* none */,
	          kind: "string" /* string */,
	          sortText: SortText.LocationPriority,
	          replacementSpan: getReplacementSpanForContextToken(contextToken)
	        }));
	        return { isGlobalCompletion: false, isMemberCompletion: false, isNewIdentifierLocation: completion.isNewIdentifier, optionalReplacementSpan, entries };
	      }
	      default:
	        return Debug.assertNever(completion);
	    }
	  }
	  function getStringLiteralCompletionDetails(name, sourceFile, position, contextToken, program, host, cancellationToken, preferences) {
	    if (!contextToken || !isStringLiteralLike(contextToken))
	      return void 0;
	    const completions = getStringLiteralCompletionEntries(sourceFile, contextToken, position, program, host, preferences);
	    return completions && stringLiteralCompletionDetails(name, contextToken, completions, sourceFile, program.getTypeChecker(), cancellationToken);
	  }
	  function stringLiteralCompletionDetails(name, location, completion, sourceFile, checker, cancellationToken) {
	    switch (completion.kind) {
	      case 0 /* Paths */: {
	        const match = find(completion.paths, (p) => p.name === name);
	        return match && createCompletionDetails(name, kindModifiersFromExtension(match.extension), match.kind, [textPart(name)]);
	      }
	      case 1 /* Properties */: {
	        const match = find(completion.symbols, (s) => s.name === name);
	        return match && createCompletionDetailsForSymbol(match, match.name, checker, sourceFile, location, cancellationToken);
	      }
	      case 2 /* Types */:
	        return find(completion.types, (t) => t.value === name) ? createCompletionDetails(name, "" /* none */, "string" /* string */, [textPart(name)]) : void 0;
	      default:
	        return Debug.assertNever(completion);
	    }
	  }
	  function convertPathCompletions(pathCompletions) {
	    const isGlobalCompletion = false;
	    const isNewIdentifierLocation = true;
	    const entries = pathCompletions.map(({ name, kind, span, extension }) => ({ name, kind, kindModifiers: kindModifiersFromExtension(extension), sortText: SortText.LocationPriority, replacementSpan: span }));
	    return { isGlobalCompletion, isMemberCompletion: false, isNewIdentifierLocation, entries };
	  }
	  function kindModifiersFromExtension(extension) {
	    switch (extension) {
	      case ".d.ts" /* Dts */:
	        return ".d.ts" /* dtsModifier */;
	      case ".js" /* Js */:
	        return ".js" /* jsModifier */;
	      case ".json" /* Json */:
	        return ".json" /* jsonModifier */;
	      case ".jsx" /* Jsx */:
	        return ".jsx" /* jsxModifier */;
	      case ".ts" /* Ts */:
	        return ".ts" /* tsModifier */;
	      case ".tsx" /* Tsx */:
	        return ".tsx" /* tsxModifier */;
	      case ".d.mts" /* Dmts */:
	        return ".d.mts" /* dmtsModifier */;
	      case ".mjs" /* Mjs */:
	        return ".mjs" /* mjsModifier */;
	      case ".mts" /* Mts */:
	        return ".mts" /* mtsModifier */;
	      case ".d.cts" /* Dcts */:
	        return ".d.cts" /* dctsModifier */;
	      case ".cjs" /* Cjs */:
	        return ".cjs" /* cjsModifier */;
	      case ".cts" /* Cts */:
	        return ".cts" /* ctsModifier */;
	      case ".tsbuildinfo" /* TsBuildInfo */:
	        return Debug.fail(`Extension ${".tsbuildinfo" /* TsBuildInfo */} is unsupported.`);
	      case void 0:
	        return "" /* none */;
	      default:
	        return Debug.assertNever(extension);
	    }
	  }
	  function getStringLiteralCompletionEntries(sourceFile, node, position, program, host, preferences) {
	    const typeChecker = program.getTypeChecker();
	    const parent2 = walkUpParentheses(node.parent);
	    switch (parent2.kind) {
	      case 201 /* LiteralType */: {
	        const grandParent = walkUpParentheses(parent2.parent);
	        if (grandParent.kind === 205 /* ImportType */) {
	          return { kind: 0 /* Paths */, paths: getStringLiteralCompletionsFromModuleNames(sourceFile, node, program, host, preferences) };
	        }
	        return fromUnionableLiteralType(grandParent);
	      }
	      case 303 /* PropertyAssignment */:
	        if (isObjectLiteralExpression(parent2.parent) && parent2.name === node) {
	          return stringLiteralCompletionsForObjectLiteral(typeChecker, parent2.parent);
	        }
	        return fromContextualType() || fromContextualType(0 /* None */);
	      case 212 /* ElementAccessExpression */: {
	        const { expression, argumentExpression } = parent2;
	        if (node === skipParentheses(argumentExpression)) {
	          return stringLiteralCompletionsFromProperties(typeChecker.getTypeAtLocation(expression));
	        }
	        return void 0;
	      }
	      case 213 /* CallExpression */:
	      case 214 /* NewExpression */:
	      case 291 /* JsxAttribute */:
	        if (!isRequireCallArgument(node) && !isImportCall(parent2)) {
	          const argumentInfo = ts_SignatureHelp_exports.getArgumentInfoForCompletions(parent2.kind === 291 /* JsxAttribute */ ? parent2.parent : node, position, sourceFile, typeChecker);
	          return argumentInfo && getStringLiteralCompletionsFromSignature(argumentInfo.invocation, node, argumentInfo, typeChecker) || fromContextualType(0 /* None */);
	        }
	      case 272 /* ImportDeclaration */:
	      case 278 /* ExportDeclaration */:
	      case 283 /* ExternalModuleReference */:
	        return { kind: 0 /* Paths */, paths: getStringLiteralCompletionsFromModuleNames(sourceFile, node, program, host, preferences) };
	      case 296 /* CaseClause */:
	        const tracker = newCaseClauseTracker(typeChecker, parent2.parent.clauses);
	        const contextualTypes = fromContextualType();
	        if (!contextualTypes) {
	          return;
	        }
	        const literals = contextualTypes.types.filter((literal) => !tracker.hasValue(literal.value));
	        return { kind: 2 /* Types */, types: literals, isNewIdentifier: false };
	      default:
	        return fromContextualType() || fromContextualType(0 /* None */);
	    }
	    function fromUnionableLiteralType(grandParent) {
	      switch (grandParent.kind) {
	        case 233 /* ExpressionWithTypeArguments */:
	        case 183 /* TypeReference */: {
	          const typeArgument = findAncestor(parent2, (n) => n.parent === grandParent);
	          if (typeArgument) {
	            return { kind: 2 /* Types */, types: getStringLiteralTypes(typeChecker.getTypeArgumentConstraint(typeArgument)), isNewIdentifier: false };
	          }
	          return void 0;
	        }
	        case 199 /* IndexedAccessType */:
	          const { indexType, objectType } = grandParent;
	          if (!rangeContainsPosition(indexType, position)) {
	            return void 0;
	          }
	          return stringLiteralCompletionsFromProperties(typeChecker.getTypeFromTypeNode(objectType));
	        case 192 /* UnionType */: {
	          const result = fromUnionableLiteralType(walkUpParentheses(grandParent.parent));
	          if (!result) {
	            return void 0;
	          }
	          const alreadyUsedTypes = getAlreadyUsedTypesInStringLiteralUnion(grandParent, parent2);
	          if (result.kind === 1 /* Properties */) {
	            return { kind: 1 /* Properties */, symbols: result.symbols.filter((sym) => !contains(alreadyUsedTypes, sym.name)), hasIndexSignature: result.hasIndexSignature };
	          }
	          return { kind: 2 /* Types */, types: result.types.filter((t) => !contains(alreadyUsedTypes, t.value)), isNewIdentifier: false };
	        }
	        default:
	          return void 0;
	      }
	    }
	    function fromContextualType(contextFlags = 4 /* Completions */) {
	      const types = getStringLiteralTypes(getContextualTypeFromParent(node, typeChecker, contextFlags));
	      if (!types.length) {
	        return;
	      }
	      return { kind: 2 /* Types */, types, isNewIdentifier: false };
	    }
	  }
	  function walkUpParentheses(node) {
	    switch (node.kind) {
	      case 196 /* ParenthesizedType */:
	        return walkUpParenthesizedTypes(node);
	      case 217 /* ParenthesizedExpression */:
	        return walkUpParenthesizedExpressions(node);
	      default:
	        return node;
	    }
	  }
	  function getAlreadyUsedTypesInStringLiteralUnion(union, current) {
	    return mapDefined(union.types, (type) => type !== current && isLiteralTypeNode(type) && isStringLiteral(type.literal) ? type.literal.text : void 0);
	  }
	  function getStringLiteralCompletionsFromSignature(call, arg, argumentInfo, checker) {
	    let isNewIdentifier = false;
	    const uniques = /* @__PURE__ */ new Map();
	    const editingArgument = isJsxOpeningLikeElement(call) ? Debug.checkDefined(findAncestor(arg.parent, isJsxAttribute)) : arg;
	    const candidates = checker.getCandidateSignaturesForStringLiteralCompletions(call, editingArgument);
	    const types = flatMap(candidates, (candidate) => {
	      if (!signatureHasRestParameter(candidate) && argumentInfo.argumentCount > candidate.parameters.length)
	        return;
	      let type = candidate.getTypeParameterAtPosition(argumentInfo.argumentIndex);
	      if (isJsxOpeningLikeElement(call)) {
	        const propType = checker.getTypeOfPropertyOfType(type, getTextOfJsxAttributeName(editingArgument.name));
	        if (propType) {
	          type = propType;
	        }
	      }
	      isNewIdentifier = isNewIdentifier || !!(type.flags & 4 /* String */);
	      return getStringLiteralTypes(type, uniques);
	    });
	    return length(types) ? { kind: 2 /* Types */, types, isNewIdentifier } : void 0;
	  }
	  function stringLiteralCompletionsFromProperties(type) {
	    return type && {
	      kind: 1 /* Properties */,
	      symbols: filter(type.getApparentProperties(), (prop) => !(prop.valueDeclaration && isPrivateIdentifierClassElementDeclaration(prop.valueDeclaration))),
	      hasIndexSignature: hasIndexSignature(type)
	    };
	  }
	  function stringLiteralCompletionsForObjectLiteral(checker, objectLiteralExpression) {
	    const contextualType = checker.getContextualType(objectLiteralExpression);
	    if (!contextualType)
	      return void 0;
	    const completionsType = checker.getContextualType(objectLiteralExpression, 4 /* Completions */);
	    const symbols = getPropertiesForObjectExpression(
	      contextualType,
	      completionsType,
	      objectLiteralExpression,
	      checker
	    );
	    return {
	      kind: 1 /* Properties */,
	      symbols,
	      hasIndexSignature: hasIndexSignature(contextualType)
	    };
	  }
	  function getStringLiteralTypes(type, uniques = /* @__PURE__ */ new Map()) {
	    if (!type)
	      return emptyArray;
	    type = skipConstraint(type);
	    return type.isUnion() ? flatMap(type.types, (t) => getStringLiteralTypes(t, uniques)) : type.isStringLiteral() && !(type.flags & 1024 /* EnumLiteral */) && addToSeen(uniques, type.value) ? [type] : emptyArray;
	  }
	  function nameAndKind(name, kind, extension) {
	    return { name, kind, extension };
	  }
	  function directoryResult(name) {
	    return nameAndKind(
	      name,
	      "directory" /* directory */,
	      /*extension*/
	      void 0
	    );
	  }
	  function addReplacementSpans(text, textStart, names) {
	    const span = getDirectoryFragmentTextSpan(text, textStart);
	    const wholeSpan = text.length === 0 ? void 0 : createTextSpan(textStart, text.length);
	    return names.map(({ name, kind, extension }) => name.includes(directorySeparator) || name.includes(altDirectorySeparator) ? { name, kind, extension, span: wholeSpan } : { name, kind, extension, span });
	  }
	  function getStringLiteralCompletionsFromModuleNames(sourceFile, node, program, host, preferences) {
	    return addReplacementSpans(node.text, node.getStart(sourceFile) + 1, getStringLiteralCompletionsFromModuleNamesWorker(sourceFile, node, program, host, preferences));
	  }
	  function getStringLiteralCompletionsFromModuleNamesWorker(sourceFile, node, program, host, preferences) {
	    const literalValue = normalizeSlashes(node.text);
	    const mode = isStringLiteralLike(node) ? program.getModeForUsageLocation(sourceFile, node) : void 0;
	    const scriptPath = sourceFile.path;
	    const scriptDirectory = getDirectoryPath(scriptPath);
	    const compilerOptions = program.getCompilerOptions();
	    const typeChecker = program.getTypeChecker();
	    const extensionOptions = getExtensionOptions(compilerOptions, 1 /* ModuleSpecifier */, sourceFile, typeChecker, preferences, mode);
	    return isPathRelativeToScript(literalValue) || !compilerOptions.baseUrl && !compilerOptions.paths && (isRootedDiskPath(literalValue) || isUrl(literalValue)) ? getCompletionEntriesForRelativeModules(literalValue, scriptDirectory, compilerOptions, host, scriptPath, extensionOptions) : getCompletionEntriesForNonRelativeModules(literalValue, scriptDirectory, mode, compilerOptions, host, extensionOptions, typeChecker);
	  }
	  function getExtensionOptions(compilerOptions, referenceKind, importingSourceFile, typeChecker, preferences, resolutionMode) {
	    return {
	      extensionsToSearch: flatten(getSupportedExtensionsForModuleResolution(compilerOptions, typeChecker)),
	      referenceKind,
	      importingSourceFile,
	      endingPreference: preferences == null ? void 0 : preferences.importModuleSpecifierEnding,
	      resolutionMode
	    };
	  }
	  function getCompletionEntriesForRelativeModules(literalValue, scriptDirectory, compilerOptions, host, scriptPath, extensionOptions) {
	    if (compilerOptions.rootDirs) {
	      return getCompletionEntriesForDirectoryFragmentWithRootDirs(
	        compilerOptions.rootDirs,
	        literalValue,
	        scriptDirectory,
	        extensionOptions,
	        compilerOptions,
	        host,
	        scriptPath
	      );
	    } else {
	      return arrayFrom(getCompletionEntriesForDirectoryFragment(
	        literalValue,
	        scriptDirectory,
	        extensionOptions,
	        host,
	        /*moduleSpecifierIsRelative*/
	        true,
	        scriptPath
	      ).values());
	    }
	  }
	  function getSupportedExtensionsForModuleResolution(compilerOptions, typeChecker) {
	    const ambientModulesExtensions = !typeChecker ? [] : mapDefined(typeChecker.getAmbientModules(), (module2) => {
	      const name = module2.name.slice(1, -1);
	      if (!name.startsWith("*.") || name.includes("/"))
	        return;
	      return name.slice(1);
	    });
	    const extensions = [...getSupportedExtensions(compilerOptions), ambientModulesExtensions];
	    const moduleResolution = getEmitModuleResolutionKind(compilerOptions);
	    return moduleResolutionUsesNodeModules(moduleResolution) ? getSupportedExtensionsWithJsonIfResolveJsonModule(compilerOptions, extensions) : extensions;
	  }
	  function getBaseDirectoriesFromRootDirs(rootDirs, basePath, scriptDirectory, ignoreCase) {
	    rootDirs = rootDirs.map((rootDirectory) => ensureTrailingDirectorySeparator(normalizePath(isRootedDiskPath(rootDirectory) ? rootDirectory : combinePaths(basePath, rootDirectory))));
	    const relativeDirectory = firstDefined(rootDirs, (rootDirectory) => containsPath(rootDirectory, scriptDirectory, basePath, ignoreCase) ? scriptDirectory.substr(rootDirectory.length) : void 0);
	    return deduplicate(
	      [...rootDirs.map((rootDirectory) => combinePaths(rootDirectory, relativeDirectory)), scriptDirectory].map((baseDir) => removeTrailingDirectorySeparator(baseDir)),
	      equateStringsCaseSensitive,
	      compareStringsCaseSensitive
	    );
	  }
	  function getCompletionEntriesForDirectoryFragmentWithRootDirs(rootDirs, fragment, scriptDirectory, extensionOptions, compilerOptions, host, exclude) {
	    const basePath = compilerOptions.project || host.getCurrentDirectory();
	    const ignoreCase = !(host.useCaseSensitiveFileNames && host.useCaseSensitiveFileNames());
	    const baseDirectories = getBaseDirectoriesFromRootDirs(rootDirs, basePath, scriptDirectory, ignoreCase);
	    return deduplicate(
	      flatMap(baseDirectories, (baseDirectory) => arrayFrom(getCompletionEntriesForDirectoryFragment(
	        fragment,
	        baseDirectory,
	        extensionOptions,
	        host,
	        /*moduleSpecifierIsRelative*/
	        true,
	        exclude
	      ).values())),
	      (itemA, itemB) => itemA.name === itemB.name && itemA.kind === itemB.kind && itemA.extension === itemB.extension
	    );
	  }
	  function getCompletionEntriesForDirectoryFragment(fragment, scriptDirectory, extensionOptions, host, moduleSpecifierIsRelative, exclude, result = createNameAndKindSet()) {
	    var _a;
	    if (fragment === void 0) {
	      fragment = "";
	    }
	    fragment = normalizeSlashes(fragment);
	    if (!hasTrailingDirectorySeparator(fragment)) {
	      fragment = getDirectoryPath(fragment);
	    }
	    if (fragment === "") {
	      fragment = "." + directorySeparator;
	    }
	    fragment = ensureTrailingDirectorySeparator(fragment);
	    const absolutePath = resolvePath(scriptDirectory, fragment);
	    const baseDirectory = hasTrailingDirectorySeparator(absolutePath) ? absolutePath : getDirectoryPath(absolutePath);
	    if (!moduleSpecifierIsRelative) {
	      const packageJsonPath = findPackageJson(baseDirectory, host);
	      if (packageJsonPath) {
	        const packageJson = readJson(packageJsonPath, host);
	        const typesVersions = packageJson.typesVersions;
	        if (typeof typesVersions === "object") {
	          const versionPaths = (_a = getPackageJsonTypesVersionsPaths(typesVersions)) == null ? void 0 : _a.paths;
	          if (versionPaths) {
	            const packageDirectory = getDirectoryPath(packageJsonPath);
	            const pathInPackage = absolutePath.slice(ensureTrailingDirectorySeparator(packageDirectory).length);
	            if (addCompletionEntriesFromPaths(result, pathInPackage, packageDirectory, extensionOptions, host, versionPaths)) {
	              return result;
	            }
	          }
	        }
	      }
	    }
	    const ignoreCase = !(host.useCaseSensitiveFileNames && host.useCaseSensitiveFileNames());
	    if (!tryDirectoryExists(host, baseDirectory))
	      return result;
	    const files = tryReadDirectory(
	      host,
	      baseDirectory,
	      extensionOptions.extensionsToSearch,
	      /*exclude*/
	      void 0,
	      /*include*/
	      ["./*"]
	    );
	    if (files) {
	      for (let filePath of files) {
	        filePath = normalizePath(filePath);
	        if (exclude && comparePaths(filePath, exclude, scriptDirectory, ignoreCase) === 0 /* EqualTo */) {
	          continue;
	        }
	        const { name, extension } = getFilenameWithExtensionOption(
	          getBaseFileName(filePath),
	          host.getCompilationSettings(),
	          extensionOptions,
	          /*isExportsWildcard*/
	          false
	        );
	        result.add(nameAndKind(name, "script" /* scriptElement */, extension));
	      }
	    }
	    const directories = tryGetDirectories(host, baseDirectory);
	    if (directories) {
	      for (const directory of directories) {
	        const directoryName = getBaseFileName(normalizePath(directory));
	        if (directoryName !== "@types") {
	          result.add(directoryResult(directoryName));
	        }
	      }
	    }
	    return result;
	  }
	  function getFilenameWithExtensionOption(name, compilerOptions, extensionOptions, isExportsWildcard) {
	    const nonJsResult = ts_moduleSpecifiers_exports.tryGetRealFileNameForNonJsDeclarationFileName(name);
	    if (nonJsResult) {
	      return { name: nonJsResult, extension: tryGetExtensionFromPath2(nonJsResult) };
	    }
	    if (extensionOptions.referenceKind === 0 /* Filename */) {
	      return { name, extension: tryGetExtensionFromPath2(name) };
	    }
	    let allowedEndings = getModuleSpecifierPreferences(
	      { importModuleSpecifierEnding: extensionOptions.endingPreference },
	      compilerOptions,
	      extensionOptions.importingSourceFile
	    ).getAllowedEndingsInPreferredOrder(extensionOptions.resolutionMode);
	    if (isExportsWildcard) {
	      allowedEndings = allowedEndings.filter((e) => e !== 0 /* Minimal */ && e !== 1 /* Index */);
	    }
	    if (allowedEndings[0] === 3 /* TsExtension */) {
	      if (fileExtensionIsOneOf(name, supportedTSImplementationExtensions)) {
	        return { name, extension: tryGetExtensionFromPath2(name) };
	      }
	      const outputExtension2 = ts_moduleSpecifiers_exports.tryGetJSExtensionForFile(name, compilerOptions);
	      return outputExtension2 ? { name: changeExtension(name, outputExtension2), extension: outputExtension2 } : { name, extension: tryGetExtensionFromPath2(name) };
	    }
	    if (!isExportsWildcard && (allowedEndings[0] === 0 /* Minimal */ || allowedEndings[0] === 1 /* Index */) && fileExtensionIsOneOf(name, [".js" /* Js */, ".jsx" /* Jsx */, ".ts" /* Ts */, ".tsx" /* Tsx */, ".d.ts" /* Dts */])) {
	      return { name: removeFileExtension(name), extension: tryGetExtensionFromPath2(name) };
	    }
	    const outputExtension = ts_moduleSpecifiers_exports.tryGetJSExtensionForFile(name, compilerOptions);
	    return outputExtension ? { name: changeExtension(name, outputExtension), extension: outputExtension } : { name, extension: tryGetExtensionFromPath2(name) };
	  }
	  function addCompletionEntriesFromPaths(result, fragment, baseDirectory, extensionOptions, host, paths) {
	    const getPatternsForKey = (key) => paths[key];
	    const comparePaths2 = (a, b) => {
	      const patternA = tryParsePattern(a);
	      const patternB = tryParsePattern(b);
	      const lengthA = typeof patternA === "object" ? patternA.prefix.length : a.length;
	      const lengthB = typeof patternB === "object" ? patternB.prefix.length : b.length;
	      return compareValues(lengthB, lengthA);
	    };
	    return addCompletionEntriesFromPathsOrExports(
	      result,
	      /*isExports*/
	      false,
	      fragment,
	      baseDirectory,
	      extensionOptions,
	      host,
	      getOwnKeys(paths),
	      getPatternsForKey,
	      comparePaths2
	    );
	  }
	  function addCompletionEntriesFromPathsOrExports(result, isExports, fragment, baseDirectory, extensionOptions, host, keys, getPatternsForKey, comparePaths2) {
	    let pathResults = [];
	    let matchedPath;
	    for (const key of keys) {
	      if (key === ".")
	        continue;
	      const keyWithoutLeadingDotSlash = key.replace(/^\.\//, "");
	      const patterns = getPatternsForKey(key);
	      if (patterns) {
	        const pathPattern = tryParsePattern(keyWithoutLeadingDotSlash);
	        if (!pathPattern)
	          continue;
	        const isMatch = typeof pathPattern === "object" && isPatternMatch(pathPattern, fragment);
	        const isLongestMatch = isMatch && (matchedPath === void 0 || comparePaths2(key, matchedPath) === -1 /* LessThan */);
	        if (isLongestMatch) {
	          matchedPath = key;
	          pathResults = pathResults.filter((r) => !r.matchedPattern);
	        }
	        if (typeof pathPattern === "string" || matchedPath === void 0 || comparePaths2(key, matchedPath) !== 1 /* GreaterThan */) {
	          pathResults.push({
	            matchedPattern: isMatch,
	            results: getCompletionsForPathMapping(keyWithoutLeadingDotSlash, patterns, fragment, baseDirectory, extensionOptions, isExports && isMatch, host).map(({ name, kind, extension }) => nameAndKind(name, kind, extension))
	          });
	        }
	      }
	    }
	    pathResults.forEach((pathResult) => pathResult.results.forEach((r) => result.add(r)));
	    return matchedPath !== void 0;
	  }
	  function getCompletionEntriesForNonRelativeModules(fragment, scriptPath, mode, compilerOptions, host, extensionOptions, typeChecker) {
	    const { baseUrl, paths } = compilerOptions;
	    const result = createNameAndKindSet();
	    const moduleResolution = getEmitModuleResolutionKind(compilerOptions);
	    if (baseUrl) {
	      const absolute = normalizePath(combinePaths(host.getCurrentDirectory(), baseUrl));
	      getCompletionEntriesForDirectoryFragment(
	        fragment,
	        absolute,
	        extensionOptions,
	        host,
	        /*moduleSpecifierIsRelative*/
	        false,
	        /*exclude*/
	        void 0,
	        result
	      );
	    }
	    if (paths) {
	      const absolute = getPathsBasePath(compilerOptions, host);
	      addCompletionEntriesFromPaths(result, fragment, absolute, extensionOptions, host, paths);
	    }
	    const fragmentDirectory = getFragmentDirectory(fragment);
	    for (const ambientName of getAmbientModuleCompletions(fragment, fragmentDirectory, typeChecker)) {
	      result.add(nameAndKind(
	        ambientName,
	        "external module name" /* externalModuleName */,
	        /*extension*/
	        void 0
	      ));
	    }
	    getCompletionEntriesFromTypings(host, compilerOptions, scriptPath, fragmentDirectory, extensionOptions, result);
	    if (moduleResolutionUsesNodeModules(moduleResolution)) {
	      let foundGlobal = false;
	      if (fragmentDirectory === void 0) {
	        for (const moduleName of enumerateNodeModulesVisibleToScript(host, scriptPath)) {
	          const moduleResult = nameAndKind(
	            moduleName,
	            "external module name" /* externalModuleName */,
	            /*extension*/
	            void 0
	          );
	          if (!result.has(moduleResult.name)) {
	            foundGlobal = true;
	            result.add(moduleResult);
	          }
	        }
	      }
	      if (!foundGlobal) {
	        let ancestorLookup = (ancestor) => {
	          const nodeModules = combinePaths(ancestor, "node_modules");
	          if (tryDirectoryExists(host, nodeModules)) {
	            getCompletionEntriesForDirectoryFragment(
	              fragment,
	              nodeModules,
	              extensionOptions,
	              host,
	              /*moduleSpecifierIsRelative*/
	              false,
	              /*exclude*/
	              void 0,
	              result
	            );
	          }
	        };
	        if (fragmentDirectory && getResolvePackageJsonExports(compilerOptions)) {
	          const nodeModulesDirectoryLookup = ancestorLookup;
	          ancestorLookup = (ancestor) => {
	            const components = getPathComponents(fragment);
	            components.shift();
	            let packagePath = components.shift();
	            if (!packagePath) {
	              return nodeModulesDirectoryLookup(ancestor);
	            }
	            if (startsWith(packagePath, "@")) {
	              const subName = components.shift();
	              if (!subName) {
	                return nodeModulesDirectoryLookup(ancestor);
	              }
	              packagePath = combinePaths(packagePath, subName);
	            }
	            const packageDirectory = combinePaths(ancestor, "node_modules", packagePath);
	            const packageFile = combinePaths(packageDirectory, "package.json");
	            if (tryFileExists(host, packageFile)) {
	              const packageJson = readJson(packageFile, host);
	              const exports = packageJson.exports;
	              if (exports) {
	                if (typeof exports !== "object" || exports === null) {
	                  return;
	                }
	                const keys = getOwnKeys(exports);
	                const fragmentSubpath = components.join("/") + (components.length && hasTrailingDirectorySeparator(fragment) ? "/" : "");
	                const conditions = getConditions(compilerOptions, mode);
	                addCompletionEntriesFromPathsOrExports(
	                  result,
	                  /*isExports*/
	                  true,
	                  fragmentSubpath,
	                  packageDirectory,
	                  extensionOptions,
	                  host,
	                  keys,
	                  (key) => singleElementArray(getPatternFromFirstMatchingCondition(exports[key], conditions)),
	                  comparePatternKeys
	                );
	                return;
	              }
	            }
	            return nodeModulesDirectoryLookup(ancestor);
	          };
	        }
	        forEachAncestorDirectory(scriptPath, ancestorLookup);
	      }
	    }
	    return arrayFrom(result.values());
	  }
	  function getPatternFromFirstMatchingCondition(target, conditions) {
	    if (typeof target === "string") {
	      return target;
	    }
	    if (target && typeof target === "object" && !isArray(target)) {
	      for (const condition in target) {
	        if (condition === "default" || conditions.includes(condition) || isApplicableVersionedTypesKey(conditions, condition)) {
	          const pattern = target[condition];
	          return getPatternFromFirstMatchingCondition(pattern, conditions);
	        }
	      }
	    }
	  }
	  function getFragmentDirectory(fragment) {
	    return containsSlash(fragment) ? hasTrailingDirectorySeparator(fragment) ? fragment : getDirectoryPath(fragment) : void 0;
	  }
	  function getCompletionsForPathMapping(path, patterns, fragment, packageDirectory, extensionOptions, isExportsWildcard, host) {
	    if (!endsWith(path, "*")) {
	      return !path.includes("*") ? justPathMappingName(path, "script" /* scriptElement */) : emptyArray;
	    }
	    const pathPrefix = path.slice(0, path.length - 1);
	    const remainingFragment = tryRemovePrefix(fragment, pathPrefix);
	    if (remainingFragment === void 0) {
	      const starIsFullPathComponent = path[path.length - 2] === "/";
	      return starIsFullPathComponent ? justPathMappingName(pathPrefix, "directory" /* directory */) : flatMap(patterns, (pattern) => {
	        var _a;
	        return (_a = getModulesForPathsPattern("", packageDirectory, pattern, extensionOptions, isExportsWildcard, host)) == null ? void 0 : _a.map(({ name, ...rest }) => ({ name: pathPrefix + name, ...rest }));
	      });
	    }
	    return flatMap(patterns, (pattern) => getModulesForPathsPattern(remainingFragment, packageDirectory, pattern, extensionOptions, isExportsWildcard, host));
	    function justPathMappingName(name, kind) {
	      return startsWith(name, fragment) ? [{ name: removeTrailingDirectorySeparator(name), kind, extension: void 0 }] : emptyArray;
	    }
	  }
	  function getModulesForPathsPattern(fragment, packageDirectory, pattern, extensionOptions, isExportsWildcard, host) {
	    if (!host.readDirectory) {
	      return void 0;
	    }
	    const parsed = tryParsePattern(pattern);
	    if (parsed === void 0 || isString(parsed)) {
	      return void 0;
	    }
	    const normalizedPrefix = resolvePath(parsed.prefix);
	    const normalizedPrefixDirectory = hasTrailingDirectorySeparator(parsed.prefix) ? normalizedPrefix : getDirectoryPath(normalizedPrefix);
	    const normalizedPrefixBase = hasTrailingDirectorySeparator(parsed.prefix) ? "" : getBaseFileName(normalizedPrefix);
	    const fragmentHasPath = containsSlash(fragment);
	    const fragmentDirectory = fragmentHasPath ? hasTrailingDirectorySeparator(fragment) ? fragment : getDirectoryPath(fragment) : void 0;
	    const expandedPrefixDirectory = fragmentHasPath ? combinePaths(normalizedPrefixDirectory, normalizedPrefixBase + fragmentDirectory) : normalizedPrefixDirectory;
	    const normalizedSuffix = normalizePath(parsed.suffix);
	    const declarationExtension = normalizedSuffix && getDeclarationEmitExtensionForPath("_" + normalizedSuffix);
	    const matchingSuffixes = declarationExtension ? [changeExtension(normalizedSuffix, declarationExtension), normalizedSuffix] : [normalizedSuffix];
	    const baseDirectory = normalizePath(combinePaths(packageDirectory, expandedPrefixDirectory));
	    const completePrefix = fragmentHasPath ? baseDirectory : ensureTrailingDirectorySeparator(baseDirectory) + normalizedPrefixBase;
	    const includeGlobs = normalizedSuffix ? matchingSuffixes.map((suffix) => "**/*" + suffix) : ["./*"];
	    const matches = mapDefined(tryReadDirectory(
	      host,
	      baseDirectory,
	      extensionOptions.extensionsToSearch,
	      /*exclude*/
	      void 0,
	      includeGlobs
	    ), (match) => {
	      const trimmedWithPattern = trimPrefixAndSuffix(match);
	      if (trimmedWithPattern) {
	        if (containsSlash(trimmedWithPattern)) {
	          return directoryResult(getPathComponents(removeLeadingDirectorySeparator(trimmedWithPattern))[1]);
	        }
	        const { name, extension } = getFilenameWithExtensionOption(trimmedWithPattern, host.getCompilationSettings(), extensionOptions, isExportsWildcard);
	        return nameAndKind(name, "script" /* scriptElement */, extension);
	      }
	    });
	    const directories = normalizedSuffix ? emptyArray : mapDefined(tryGetDirectories(host, baseDirectory), (dir) => dir === "node_modules" ? void 0 : directoryResult(dir));
	    return [...matches, ...directories];
	    function trimPrefixAndSuffix(path) {
	      return firstDefined(matchingSuffixes, (suffix) => {
	        const inner = withoutStartAndEnd(normalizePath(path), completePrefix, suffix);
	        return inner === void 0 ? void 0 : removeLeadingDirectorySeparator(inner);
	      });
	    }
	  }
	  function withoutStartAndEnd(s, start, end) {
	    return startsWith(s, start) && endsWith(s, end) ? s.slice(start.length, s.length - end.length) : void 0;
	  }
	  function removeLeadingDirectorySeparator(path) {
	    return path[0] === directorySeparator ? path.slice(1) : path;
	  }
	  function getAmbientModuleCompletions(fragment, fragmentDirectory, checker) {
	    const ambientModules = checker.getAmbientModules().map((sym) => stripQuotes(sym.name));
	    const nonRelativeModuleNames = ambientModules.filter((moduleName) => startsWith(moduleName, fragment) && !moduleName.includes("*"));
	    if (fragmentDirectory !== void 0) {
	      const moduleNameWithSeparator = ensureTrailingDirectorySeparator(fragmentDirectory);
	      return nonRelativeModuleNames.map((nonRelativeModuleName) => removePrefix(nonRelativeModuleName, moduleNameWithSeparator));
	    }
	    return nonRelativeModuleNames;
	  }
	  function getTripleSlashReferenceCompletion(sourceFile, position, compilerOptions, host) {
	    const token = getTokenAtPosition(sourceFile, position);
	    const commentRanges = getLeadingCommentRanges(sourceFile.text, token.pos);
	    const range = commentRanges && find(commentRanges, (commentRange) => position >= commentRange.pos && position <= commentRange.end);
	    if (!range) {
	      return void 0;
	    }
	    const text = sourceFile.text.slice(range.pos, position);
	    const match = tripleSlashDirectiveFragmentRegex.exec(text);
	    if (!match) {
	      return void 0;
	    }
	    const [, prefix, kind, toComplete] = match;
	    const scriptPath = getDirectoryPath(sourceFile.path);
	    const names = kind === "path" ? getCompletionEntriesForDirectoryFragment(
	      toComplete,
	      scriptPath,
	      getExtensionOptions(compilerOptions, 0 /* Filename */, sourceFile),
	      host,
	      /*moduleSpecifierIsRelative*/
	      true,
	      sourceFile.path
	    ) : kind === "types" ? getCompletionEntriesFromTypings(host, compilerOptions, scriptPath, getFragmentDirectory(toComplete), getExtensionOptions(compilerOptions, 1 /* ModuleSpecifier */, sourceFile)) : Debug.fail();
	    return addReplacementSpans(toComplete, range.pos + prefix.length, arrayFrom(names.values()));
	  }
	  function getCompletionEntriesFromTypings(host, options, scriptPath, fragmentDirectory, extensionOptions, result = createNameAndKindSet()) {
	    const seen = /* @__PURE__ */ new Map();
	    const typeRoots = tryAndIgnoreErrors(() => getEffectiveTypeRoots(options, host)) || emptyArray;
	    for (const root of typeRoots) {
	      getCompletionEntriesFromDirectories(root);
	    }
	    for (const packageJson of findPackageJsons(scriptPath, host)) {
	      const typesDir = combinePaths(getDirectoryPath(packageJson), "node_modules/@types");
	      getCompletionEntriesFromDirectories(typesDir);
	    }
	    return result;
	    function getCompletionEntriesFromDirectories(directory) {
	      if (!tryDirectoryExists(host, directory))
	        return;
	      for (const typeDirectoryName of tryGetDirectories(host, directory)) {
	        const packageName = unmangleScopedPackageName(typeDirectoryName);
	        if (options.types && !contains(options.types, packageName))
	          continue;
	        if (fragmentDirectory === void 0) {
	          if (!seen.has(packageName)) {
	            result.add(nameAndKind(
	              packageName,
	              "external module name" /* externalModuleName */,
	              /*extension*/
	              void 0
	            ));
	            seen.set(packageName, true);
	          }
	        } else {
	          const baseDirectory = combinePaths(directory, typeDirectoryName);
	          const remainingFragment = tryRemoveDirectoryPrefix(fragmentDirectory, packageName, hostGetCanonicalFileName(host));
	          if (remainingFragment !== void 0) {
	            getCompletionEntriesForDirectoryFragment(
	              remainingFragment,
	              baseDirectory,
	              extensionOptions,
	              host,
	              /*moduleSpecifierIsRelative*/
	              false,
	              /*exclude*/
	              void 0,
	              result
	            );
	          }
	        }
	      }
	    }
	  }
	  function enumerateNodeModulesVisibleToScript(host, scriptPath) {
	    if (!host.readFile || !host.fileExists)
	      return emptyArray;
	    const result = [];
	    for (const packageJson of findPackageJsons(scriptPath, host)) {
	      const contents = readJson(packageJson, host);
	      for (const key of nodeModulesDependencyKeys) {
	        const dependencies = contents[key];
	        if (!dependencies)
	          continue;
	        for (const dep in dependencies) {
	          if (hasProperty(dependencies, dep) && !startsWith(dep, "@types/")) {
	            result.push(dep);
	          }
	        }
	      }
	    }
	    return result;
	  }
	  function getDirectoryFragmentTextSpan(text, textStart) {
	    const index = Math.max(text.lastIndexOf(directorySeparator), text.lastIndexOf(altDirectorySeparator));
	    const offset = index !== -1 ? index + 1 : 0;
	    const length2 = text.length - offset;
	    return length2 === 0 || isIdentifierText(text.substr(offset, length2), 99 /* ESNext */) ? void 0 : createTextSpan(textStart + offset, length2);
	  }
	  function isPathRelativeToScript(path) {
	    if (path && path.length >= 2 && path.charCodeAt(0) === 46 /* dot */) {
	      const slashIndex = path.length >= 3 && path.charCodeAt(1) === 46 /* dot */ ? 2 : 1;
	      const slashCharCode = path.charCodeAt(slashIndex);
	      return slashCharCode === 47 /* slash */ || slashCharCode === 92 /* backslash */;
	    }
	    return false;
	  }
	  function containsSlash(fragment) {
	    return fragment.includes(directorySeparator);
	  }
	  function isRequireCallArgument(node) {
	    return isCallExpression(node.parent) && firstOrUndefined(node.parent.arguments) === node && isIdentifier(node.parent.expression) && node.parent.expression.escapedText === "require";
	  }
	  var kindPrecedence, tripleSlashDirectiveFragmentRegex, nodeModulesDependencyKeys;
	  var init_stringCompletions = __esm({
	    "src/services/stringCompletions.ts"() {
	      init_moduleSpecifiers();
	      init_ts4();
	      init_ts_Completions();
	      kindPrecedence = {
	        ["directory" /* directory */]: 0,
	        ["script" /* scriptElement */]: 1,
	        ["external module name" /* externalModuleName */]: 2
	      };
	      tripleSlashDirectiveFragmentRegex = /^(\/\/\/\s*<reference\s+(path|types)\s*=\s*(?:'|"))([^\3"]*)$/;
	      nodeModulesDependencyKeys = ["dependencies", "devDependencies", "peerDependencies", "optionalDependencies"];
	    }
	  });

	  // src/services/_namespaces/ts.Completions.StringCompletions.ts
	  var ts_Completions_StringCompletions_exports = {};
	  __export(ts_Completions_StringCompletions_exports, {
	    getStringLiteralCompletionDetails: () => getStringLiteralCompletionDetails,
	    getStringLiteralCompletions: () => getStringLiteralCompletions
	  });
	  var init_ts_Completions_StringCompletions = __esm({
	    "src/services/_namespaces/ts.Completions.StringCompletions.ts"() {
	      init_stringCompletions();
	    }
	  });

	  // src/services/_namespaces/ts.Completions.ts
	  var ts_Completions_exports = {};
	  __export(ts_Completions_exports, {
	    CompletionKind: () => CompletionKind,
	    CompletionSource: () => CompletionSource,
	    SortText: () => SortText,
	    StringCompletions: () => ts_Completions_StringCompletions_exports,
	    SymbolOriginInfoKind: () => SymbolOriginInfoKind,
	    createCompletionDetails: () => createCompletionDetails,
	    createCompletionDetailsForSymbol: () => createCompletionDetailsForSymbol,
	    getCompletionEntriesFromSymbols: () => getCompletionEntriesFromSymbols,
	    getCompletionEntryDetails: () => getCompletionEntryDetails,
	    getCompletionEntrySymbol: () => getCompletionEntrySymbol,
	    getCompletionsAtPosition: () => getCompletionsAtPosition,
	    getPropertiesForObjectExpression: () => getPropertiesForObjectExpression,
	    moduleSpecifierResolutionCacheAttemptLimit: () => moduleSpecifierResolutionCacheAttemptLimit,
	    moduleSpecifierResolutionLimit: () => moduleSpecifierResolutionLimit
	  });
	  var init_ts_Completions = __esm({
	    "src/services/_namespaces/ts.Completions.ts"() {
	      init_completions();
	      init_ts_Completions_StringCompletions();
	    }
	  });

	  // src/services/importTracker.ts
	  function createImportTracker(sourceFiles, sourceFilesSet, checker, cancellationToken) {
	    const allDirectImports = getDirectImportsMap(sourceFiles, checker, cancellationToken);
	    return (exportSymbol, exportInfo, isForRename) => {
	      const { directImports, indirectUsers } = getImportersForExport(sourceFiles, sourceFilesSet, allDirectImports, exportInfo, checker, cancellationToken);
	      return { indirectUsers, ...getSearchesFromDirectImports(directImports, exportSymbol, exportInfo.exportKind, checker, isForRename) };
	    };
	  }
	  function getImportersForExport(sourceFiles, sourceFilesSet, allDirectImports, { exportingModuleSymbol, exportKind }, checker, cancellationToken) {
	    const markSeenDirectImport = nodeSeenTracker();
	    const markSeenIndirectUser = nodeSeenTracker();
	    const directImports = [];
	    const isAvailableThroughGlobal = !!exportingModuleSymbol.globalExports;
	    const indirectUserDeclarations = isAvailableThroughGlobal ? void 0 : [];
	    handleDirectImports(exportingModuleSymbol);
	    return { directImports, indirectUsers: getIndirectUsers() };
	    function getIndirectUsers() {
	      if (isAvailableThroughGlobal) {
	        return sourceFiles;
	      }
	      if (exportingModuleSymbol.declarations) {
	        for (const decl of exportingModuleSymbol.declarations) {
	          if (isExternalModuleAugmentation(decl) && sourceFilesSet.has(decl.getSourceFile().fileName)) {
	            addIndirectUser(decl);
	          }
	        }
	      }
	      return indirectUserDeclarations.map(getSourceFileOfNode);
	    }
	    function handleDirectImports(exportingModuleSymbol2) {
	      const theseDirectImports = getDirectImports(exportingModuleSymbol2);
	      if (theseDirectImports) {
	        for (const direct of theseDirectImports) {
	          if (!markSeenDirectImport(direct)) {
	            continue;
	          }
	          if (cancellationToken)
	            cancellationToken.throwIfCancellationRequested();
	          switch (direct.kind) {
	            case 213 /* CallExpression */:
	              if (isImportCall(direct)) {
	                handleImportCall(direct);
	                break;
	              }
	              if (!isAvailableThroughGlobal) {
	                const parent2 = direct.parent;
	                if (exportKind === 2 /* ExportEquals */ && parent2.kind === 260 /* VariableDeclaration */) {
	                  const { name } = parent2;
	                  if (name.kind === 80 /* Identifier */) {
	                    directImports.push(name);
	                    break;
	                  }
	                }
	              }
	              break;
	            case 80 /* Identifier */:
	              break;
	            case 271 /* ImportEqualsDeclaration */:
	              handleNamespaceImport(
	                direct,
	                direct.name,
	                hasSyntacticModifier(direct, 32 /* Export */),
	                /*alreadyAddedDirect*/
	                false
	              );
	              break;
	            case 272 /* ImportDeclaration */:
	              directImports.push(direct);
	              const namedBindings = direct.importClause && direct.importClause.namedBindings;
	              if (namedBindings && namedBindings.kind === 274 /* NamespaceImport */) {
	                handleNamespaceImport(
	                  direct,
	                  namedBindings.name,
	                  /*isReExport*/
	                  false,
	                  /*alreadyAddedDirect*/
	                  true
	                );
	              } else if (!isAvailableThroughGlobal && isDefaultImport(direct)) {
	                addIndirectUser(getSourceFileLikeForImportDeclaration(direct));
	              }
	              break;
	            case 278 /* ExportDeclaration */:
	              if (!direct.exportClause) {
	                handleDirectImports(getContainingModuleSymbol(direct, checker));
	              } else if (direct.exportClause.kind === 280 /* NamespaceExport */) {
	                addIndirectUser(
	                  getSourceFileLikeForImportDeclaration(direct),
	                  /*addTransitiveDependencies*/
	                  true
	                );
	              } else {
	                directImports.push(direct);
	              }
	              break;
	            case 205 /* ImportType */:
	              if (!isAvailableThroughGlobal && direct.isTypeOf && !direct.qualifier && isExported2(direct)) {
	                addIndirectUser(
	                  direct.getSourceFile(),
	                  /*addTransitiveDependencies*/
	                  true
	                );
	              }
	              directImports.push(direct);
	              break;
	            default:
	              Debug.failBadSyntaxKind(direct, "Unexpected import kind.");
	          }
	        }
	      }
	    }
	    function handleImportCall(importCall) {
	      const top = findAncestor(importCall, isAmbientModuleDeclaration) || importCall.getSourceFile();
	      addIndirectUser(
	        top,
	        /** addTransitiveDependencies */
	        !!isExported2(
	          importCall,
	          /*stopAtAmbientModule*/
	          true
	        )
	      );
	    }
	    function isExported2(node, stopAtAmbientModule = false) {
	      return findAncestor(node, (node2) => {
	        if (stopAtAmbientModule && isAmbientModuleDeclaration(node2))
	          return "quit";
	        return canHaveModifiers(node2) && some(node2.modifiers, isExportModifier);
	      });
	    }
	    function handleNamespaceImport(importDeclaration, name, isReExport, alreadyAddedDirect) {
	      if (exportKind === 2 /* ExportEquals */) {
	        if (!alreadyAddedDirect)
	          directImports.push(importDeclaration);
	      } else if (!isAvailableThroughGlobal) {
	        const sourceFileLike = getSourceFileLikeForImportDeclaration(importDeclaration);
	        Debug.assert(sourceFileLike.kind === 312 /* SourceFile */ || sourceFileLike.kind === 267 /* ModuleDeclaration */);
	        if (isReExport || findNamespaceReExports(sourceFileLike, name, checker)) {
	          addIndirectUser(
	            sourceFileLike,
	            /*addTransitiveDependencies*/
	            true
	          );
	        } else {
	          addIndirectUser(sourceFileLike);
	        }
	      }
	    }
	    function addIndirectUser(sourceFileLike, addTransitiveDependencies = false) {
	      Debug.assert(!isAvailableThroughGlobal);
	      const isNew = markSeenIndirectUser(sourceFileLike);
	      if (!isNew)
	        return;
	      indirectUserDeclarations.push(sourceFileLike);
	      if (!addTransitiveDependencies)
	        return;
	      const moduleSymbol = checker.getMergedSymbol(sourceFileLike.symbol);
	      if (!moduleSymbol)
	        return;
	      Debug.assert(!!(moduleSymbol.flags & 1536 /* Module */));
	      const directImports2 = getDirectImports(moduleSymbol);
	      if (directImports2) {
	        for (const directImport of directImports2) {
	          if (!isImportTypeNode(directImport)) {
	            addIndirectUser(
	              getSourceFileLikeForImportDeclaration(directImport),
	              /*addTransitiveDependencies*/
	              true
	            );
	          }
	        }
	      }
	    }
	    function getDirectImports(moduleSymbol) {
	      return allDirectImports.get(getSymbolId(moduleSymbol).toString());
	    }
	  }
	  function getSearchesFromDirectImports(directImports, exportSymbol, exportKind, checker, isForRename) {
	    const importSearches = [];
	    const singleReferences = [];
	    function addSearch(location, symbol) {
	      importSearches.push([location, symbol]);
	    }
	    if (directImports) {
	      for (const decl of directImports) {
	        handleImport(decl);
	      }
	    }
	    return { importSearches, singleReferences };
	    function handleImport(decl) {
	      if (decl.kind === 271 /* ImportEqualsDeclaration */) {
	        if (isExternalModuleImportEquals(decl)) {
	          handleNamespaceImportLike(decl.name);
	        }
	        return;
	      }
	      if (decl.kind === 80 /* Identifier */) {
	        handleNamespaceImportLike(decl);
	        return;
	      }
	      if (decl.kind === 205 /* ImportType */) {
	        if (decl.qualifier) {
	          const firstIdentifier = getFirstIdentifier(decl.qualifier);
	          if (firstIdentifier.escapedText === symbolName(exportSymbol)) {
	            singleReferences.push(firstIdentifier);
	          }
	        } else if (exportKind === 2 /* ExportEquals */) {
	          singleReferences.push(decl.argument.literal);
	        }
	        return;
	      }
	      if (decl.moduleSpecifier.kind !== 11 /* StringLiteral */) {
	        return;
	      }
	      if (decl.kind === 278 /* ExportDeclaration */) {
	        if (decl.exportClause && isNamedExports(decl.exportClause)) {
	          searchForNamedImport(decl.exportClause);
	        }
	        return;
	      }
	      const { name, namedBindings } = decl.importClause || { name: void 0, namedBindings: void 0 };
	      if (namedBindings) {
	        switch (namedBindings.kind) {
	          case 274 /* NamespaceImport */:
	            handleNamespaceImportLike(namedBindings.name);
	            break;
	          case 275 /* NamedImports */:
	            if (exportKind === 0 /* Named */ || exportKind === 1 /* Default */) {
	              searchForNamedImport(namedBindings);
	            }
	            break;
	          default:
	            Debug.assertNever(namedBindings);
	        }
	      }
	      if (name && (exportKind === 1 /* Default */ || exportKind === 2 /* ExportEquals */) && (!isForRename || name.escapedText === symbolEscapedNameNoDefault(exportSymbol))) {
	        const defaultImportAlias = checker.getSymbolAtLocation(name);
	        addSearch(name, defaultImportAlias);
	      }
	    }
	    function handleNamespaceImportLike(importName) {
	      if (exportKind === 2 /* ExportEquals */ && (!isForRename || isNameMatch(importName.escapedText))) {
	        addSearch(importName, checker.getSymbolAtLocation(importName));
	      }
	    }
	    function searchForNamedImport(namedBindings) {
	      if (!namedBindings) {
	        return;
	      }
	      for (const element of namedBindings.elements) {
	        const { name, propertyName } = element;
	        if (!isNameMatch((propertyName || name).escapedText)) {
	          continue;
	        }
	        if (propertyName) {
	          singleReferences.push(propertyName);
	          if (!isForRename || name.escapedText === exportSymbol.escapedName) {
	            addSearch(name, checker.getSymbolAtLocation(name));
	          }
	        } else {
	          const localSymbol = element.kind === 281 /* ExportSpecifier */ && element.propertyName ? checker.getExportSpecifierLocalTargetSymbol(element) : checker.getSymbolAtLocation(name);
	          addSearch(name, localSymbol);
	        }
	      }
	    }
	    function isNameMatch(name) {
	      return name === exportSymbol.escapedName || exportKind !== 0 /* Named */ && name === "default" /* Default */;
	    }
	  }
	  function findNamespaceReExports(sourceFileLike, name, checker) {
	    const namespaceImportSymbol = checker.getSymbolAtLocation(name);
	    return !!forEachPossibleImportOrExportStatement(sourceFileLike, (statement) => {
	      if (!isExportDeclaration(statement))
	        return;
	      const { exportClause, moduleSpecifier } = statement;
	      return !moduleSpecifier && exportClause && isNamedExports(exportClause) && exportClause.elements.some((element) => checker.getExportSpecifierLocalTargetSymbol(element) === namespaceImportSymbol);
	    });
	  }
	  function findModuleReferences(program, sourceFiles, searchModuleSymbol) {
	    var _a;
	    const refs = [];
	    const checker = program.getTypeChecker();
	    for (const referencingFile of sourceFiles) {
	      const searchSourceFile = searchModuleSymbol.valueDeclaration;
	      if ((searchSourceFile == null ? void 0 : searchSourceFile.kind) === 312 /* SourceFile */) {
	        for (const ref of referencingFile.referencedFiles) {
	          if (program.getSourceFileFromReference(referencingFile, ref) === searchSourceFile) {
	            refs.push({ kind: "reference", referencingFile, ref });
	          }
	        }
	        for (const ref of referencingFile.typeReferenceDirectives) {
	          const referenced = (_a = program.getResolvedTypeReferenceDirectives().get(ref.fileName, ref.resolutionMode || referencingFile.impliedNodeFormat)) == null ? void 0 : _a.resolvedTypeReferenceDirective;
	          if (referenced !== void 0 && referenced.resolvedFileName === searchSourceFile.fileName) {
	            refs.push({ kind: "reference", referencingFile, ref });
	          }
	        }
	      }
	      forEachImport(referencingFile, (importDecl, moduleSpecifier) => {
	        const moduleSymbol = checker.getSymbolAtLocation(moduleSpecifier);
	        if (moduleSymbol === searchModuleSymbol) {
	          refs.push(nodeIsSynthesized(importDecl) ? { kind: "implicit", literal: moduleSpecifier, referencingFile } : { kind: "import", literal: moduleSpecifier });
	        }
	      });
	    }
	    return refs;
	  }
	  function getDirectImportsMap(sourceFiles, checker, cancellationToken) {
	    const map2 = /* @__PURE__ */ new Map();
	    for (const sourceFile of sourceFiles) {
	      if (cancellationToken)
	        cancellationToken.throwIfCancellationRequested();
	      forEachImport(sourceFile, (importDecl, moduleSpecifier) => {
	        const moduleSymbol = checker.getSymbolAtLocation(moduleSpecifier);
	        if (moduleSymbol) {
	          const id = getSymbolId(moduleSymbol).toString();
	          let imports = map2.get(id);
	          if (!imports) {
	            map2.set(id, imports = []);
	          }
	          imports.push(importDecl);
	        }
	      });
	    }
	    return map2;
	  }
	  function forEachPossibleImportOrExportStatement(sourceFileLike, action) {
	    return forEach(sourceFileLike.kind === 312 /* SourceFile */ ? sourceFileLike.statements : sourceFileLike.body.statements, (statement) => (
	      // TODO: GH#18217
	      action(statement) || isAmbientModuleDeclaration(statement) && forEach(statement.body && statement.body.statements, action)
	    ));
	  }
	  function forEachImport(sourceFile, action) {
	    if (sourceFile.externalModuleIndicator || sourceFile.imports !== void 0) {
	      for (const i of sourceFile.imports) {
	        action(importFromModuleSpecifier(i), i);
	      }
	    } else {
	      forEachPossibleImportOrExportStatement(sourceFile, (statement) => {
	        switch (statement.kind) {
	          case 278 /* ExportDeclaration */:
	          case 272 /* ImportDeclaration */: {
	            const decl = statement;
	            if (decl.moduleSpecifier && isStringLiteral(decl.moduleSpecifier)) {
	              action(decl, decl.moduleSpecifier);
	            }
	            break;
	          }
	          case 271 /* ImportEqualsDeclaration */: {
	            const decl = statement;
	            if (isExternalModuleImportEquals(decl)) {
	              action(decl, decl.moduleReference.expression);
	            }
	            break;
	          }
	        }
	      });
	    }
	  }
	  function getImportOrExportSymbol(node, symbol, checker, comingFromExport) {
	    return comingFromExport ? getExport() : getExport() || getImport();
	    function getExport() {
	      var _a;
	      const { parent: parent2 } = node;
	      const grandparent = parent2.parent;
	      if (symbol.exportSymbol) {
	        if (parent2.kind === 211 /* PropertyAccessExpression */) {
	          return ((_a = symbol.declarations) == null ? void 0 : _a.some((d) => d === parent2)) && isBinaryExpression(grandparent) ? getSpecialPropertyExport(
	            grandparent,
	            /*useLhsSymbol*/
	            false
	          ) : void 0;
	        } else {
	          return exportInfo(symbol.exportSymbol, getExportKindForDeclaration(parent2));
	        }
	      } else {
	        const exportNode = getExportNode(parent2, node);
	        if (exportNode && hasSyntacticModifier(exportNode, 32 /* Export */)) {
	          if (isImportEqualsDeclaration(exportNode) && exportNode.moduleReference === node) {
	            if (comingFromExport) {
	              return void 0;
	            }
	            const lhsSymbol = checker.getSymbolAtLocation(exportNode.name);
	            return { kind: 0 /* Import */, symbol: lhsSymbol };
	          } else {
	            return exportInfo(symbol, getExportKindForDeclaration(exportNode));
	          }
	        } else if (isNamespaceExport(parent2)) {
	          return exportInfo(symbol, 0 /* Named */);
	        } else if (isExportAssignment(parent2)) {
	          return getExportAssignmentExport(parent2);
	        } else if (isExportAssignment(grandparent)) {
	          return getExportAssignmentExport(grandparent);
	        } else if (isBinaryExpression(parent2)) {
	          return getSpecialPropertyExport(
	            parent2,
	            /*useLhsSymbol*/
	            true
	          );
	        } else if (isBinaryExpression(grandparent)) {
	          return getSpecialPropertyExport(
	            grandparent,
	            /*useLhsSymbol*/
	            true
	          );
	        } else if (isJSDocTypedefTag(parent2) || isJSDocCallbackTag(parent2)) {
	          return exportInfo(symbol, 0 /* Named */);
	        }
	      }
	      function getExportAssignmentExport(ex) {
	        if (!ex.symbol.parent)
	          return void 0;
	        const exportKind = ex.isExportEquals ? 2 /* ExportEquals */ : 1 /* Default */;
	        return { kind: 1 /* Export */, symbol, exportInfo: { exportingModuleSymbol: ex.symbol.parent, exportKind } };
	      }
	      function getSpecialPropertyExport(node2, useLhsSymbol) {
	        let kind;
	        switch (getAssignmentDeclarationKind(node2)) {
	          case 1 /* ExportsProperty */:
	            kind = 0 /* Named */;
	            break;
	          case 2 /* ModuleExports */:
	            kind = 2 /* ExportEquals */;
	            break;
	          default:
	            return void 0;
	        }
	        const sym = useLhsSymbol ? checker.getSymbolAtLocation(getNameOfAccessExpression(cast(node2.left, isAccessExpression))) : symbol;
	        return sym && exportInfo(sym, kind);
	      }
	    }
	    function getImport() {
	      const isImport3 = isNodeImport(node);
	      if (!isImport3)
	        return void 0;
	      let importedSymbol = checker.getImmediateAliasedSymbol(symbol);
	      if (!importedSymbol)
	        return void 0;
	      importedSymbol = skipExportSpecifierSymbol(importedSymbol, checker);
	      if (importedSymbol.escapedName === "export=") {
	        importedSymbol = getExportEqualsLocalSymbol(importedSymbol, checker);
	        if (importedSymbol === void 0)
	          return void 0;
	      }
	      const importedName = symbolEscapedNameNoDefault(importedSymbol);
	      if (importedName === void 0 || importedName === "default" /* Default */ || importedName === symbol.escapedName) {
	        return { kind: 0 /* Import */, symbol: importedSymbol };
	      }
	    }
	    function exportInfo(symbol2, kind) {
	      const exportInfo2 = getExportInfo(symbol2, kind, checker);
	      return exportInfo2 && { kind: 1 /* Export */, symbol: symbol2, exportInfo: exportInfo2 };
	    }
	    function getExportKindForDeclaration(node2) {
	      return hasSyntacticModifier(node2, 2048 /* Default */) ? 1 /* Default */ : 0 /* Named */;
	    }
	  }
	  function getExportEqualsLocalSymbol(importedSymbol, checker) {
	    var _a, _b;
	    if (importedSymbol.flags & 2097152 /* Alias */) {
	      return checker.getImmediateAliasedSymbol(importedSymbol);
	    }
	    const decl = Debug.checkDefined(importedSymbol.valueDeclaration);
	    if (isExportAssignment(decl)) {
	      return (_a = tryCast(decl.expression, canHaveSymbol)) == null ? void 0 : _a.symbol;
	    } else if (isBinaryExpression(decl)) {
	      return (_b = tryCast(decl.right, canHaveSymbol)) == null ? void 0 : _b.symbol;
	    } else if (isSourceFile(decl)) {
	      return decl.symbol;
	    }
	    return void 0;
	  }
	  function getExportNode(parent2, node) {
	    const declaration = isVariableDeclaration(parent2) ? parent2 : isBindingElement(parent2) ? walkUpBindingElementsAndPatterns(parent2) : void 0;
	    if (declaration) {
	      return parent2.name !== node ? void 0 : isCatchClause(declaration.parent) ? void 0 : isVariableStatement(declaration.parent.parent) ? declaration.parent.parent : void 0;
	    } else {
	      return parent2;
	    }
	  }
	  function isNodeImport(node) {
	    const { parent: parent2 } = node;
	    switch (parent2.kind) {
	      case 271 /* ImportEqualsDeclaration */:
	        return parent2.name === node && isExternalModuleImportEquals(parent2);
	      case 276 /* ImportSpecifier */:
	        return !parent2.propertyName;
	      case 273 /* ImportClause */:
	      case 274 /* NamespaceImport */:
	        Debug.assert(parent2.name === node);
	        return true;
	      case 208 /* BindingElement */:
	        return isInJSFile(node) && isVariableDeclarationInitializedToBareOrAccessedRequire(parent2.parent.parent);
	      default:
	        return false;
	    }
	  }
	  function getExportInfo(exportSymbol, exportKind, checker) {
	    const moduleSymbol = exportSymbol.parent;
	    if (!moduleSymbol)
	      return void 0;
	    const exportingModuleSymbol = checker.getMergedSymbol(moduleSymbol);
	    return isExternalModuleSymbol(exportingModuleSymbol) ? { exportingModuleSymbol, exportKind } : void 0;
	  }
	  function skipExportSpecifierSymbol(symbol, checker) {
	    if (symbol.declarations) {
	      for (const declaration of symbol.declarations) {
	        if (isExportSpecifier(declaration) && !declaration.propertyName && !declaration.parent.parent.moduleSpecifier) {
	          return checker.getExportSpecifierLocalTargetSymbol(declaration) || symbol;
	        } else if (isPropertyAccessExpression(declaration) && isModuleExportsAccessExpression(declaration.expression) && !isPrivateIdentifier(declaration.name)) {
	          return checker.getSymbolAtLocation(declaration);
	        } else if (isShorthandPropertyAssignment(declaration) && isBinaryExpression(declaration.parent.parent) && getAssignmentDeclarationKind(declaration.parent.parent) === 2 /* ModuleExports */) {
	          return checker.getExportSpecifierLocalTargetSymbol(declaration.name);
	        }
	      }
	    }
	    return symbol;
	  }
	  function getContainingModuleSymbol(importer, checker) {
	    return checker.getMergedSymbol(getSourceFileLikeForImportDeclaration(importer).symbol);
	  }
	  function getSourceFileLikeForImportDeclaration(node) {
	    if (node.kind === 213 /* CallExpression */) {
	      return node.getSourceFile();
	    }
	    const { parent: parent2 } = node;
	    if (parent2.kind === 312 /* SourceFile */) {
	      return parent2;
	    }
	    Debug.assert(parent2.kind === 268 /* ModuleBlock */);
	    return cast(parent2.parent, isAmbientModuleDeclaration);
	  }
	  function isAmbientModuleDeclaration(node) {
	    return node.kind === 267 /* ModuleDeclaration */ && node.name.kind === 11 /* StringLiteral */;
	  }
	  function isExternalModuleImportEquals(eq) {
	    return eq.moduleReference.kind === 283 /* ExternalModuleReference */ && eq.moduleReference.expression.kind === 11 /* StringLiteral */;
	  }
	  var ExportKind2, ImportExport;
	  var init_importTracker = __esm({
	    "src/services/importTracker.ts"() {
	      init_ts4();
	      ExportKind2 = /* @__PURE__ */ ((ExportKind3) => {
	        ExportKind3[ExportKind3["Named"] = 0] = "Named";
	        ExportKind3[ExportKind3["Default"] = 1] = "Default";
	        ExportKind3[ExportKind3["ExportEquals"] = 2] = "ExportEquals";
	        return ExportKind3;
	      })(ExportKind2 || {});
	      ImportExport = /* @__PURE__ */ ((ImportExport2) => {
	        ImportExport2[ImportExport2["Import"] = 0] = "Import";
	        ImportExport2[ImportExport2["Export"] = 1] = "Export";
	        return ImportExport2;
	      })(ImportExport || {});
	    }
	  });

	  // src/services/findAllReferences.ts
	  function nodeEntry(node, kind = 1 /* Node */) {
	    return {
	      kind,
	      node: node.name || node,
	      context: getContextNodeForNodeEntry(node)
	    };
	  }
	  function isContextWithStartAndEndNode(node) {
	    return node && node.kind === void 0;
	  }
	  function getContextNodeForNodeEntry(node) {
	    if (isDeclaration(node)) {
	      return getContextNode(node);
	    }
	    if (!node.parent)
	      return void 0;
	    if (!isDeclaration(node.parent) && !isExportAssignment(node.parent)) {
	      if (isInJSFile(node)) {
	        const binaryExpression = isBinaryExpression(node.parent) ? node.parent : isAccessExpression(node.parent) && isBinaryExpression(node.parent.parent) && node.parent.parent.left === node.parent ? node.parent.parent : void 0;
	        if (binaryExpression && getAssignmentDeclarationKind(binaryExpression) !== 0 /* None */) {
	          return getContextNode(binaryExpression);
	        }
	      }
	      if (isJsxOpeningElement(node.parent) || isJsxClosingElement(node.parent)) {
	        return node.parent.parent;
	      } else if (isJsxSelfClosingElement(node.parent) || isLabeledStatement(node.parent) || isBreakOrContinueStatement(node.parent)) {
	        return node.parent;
	      } else if (isStringLiteralLike(node)) {
	        const validImport = tryGetImportFromModuleSpecifier(node);
	        if (validImport) {
	          const declOrStatement = findAncestor(validImport, (node2) => isDeclaration(node2) || isStatement(node2) || isJSDocTag(node2));
	          return isDeclaration(declOrStatement) ? getContextNode(declOrStatement) : declOrStatement;
	        }
	      }
	      const propertyName = findAncestor(node, isComputedPropertyName);
	      return propertyName ? getContextNode(propertyName.parent) : void 0;
	    }
	    if (node.parent.name === node || // node is name of declaration, use parent
	    isConstructorDeclaration(node.parent) || isExportAssignment(node.parent) || // Property name of the import export specifier or binding pattern, use parent
	    (isImportOrExportSpecifier(node.parent) || isBindingElement(node.parent)) && node.parent.propertyName === node || // Is default export
	    node.kind === 90 /* DefaultKeyword */ && hasSyntacticModifier(node.parent, 2080 /* ExportDefault */)) {
	      return getContextNode(node.parent);
	    }
	    return void 0;
	  }
	  function getContextNode(node) {
	    if (!node)
	      return void 0;
	    switch (node.kind) {
	      case 260 /* VariableDeclaration */:
	        return !isVariableDeclarationList(node.parent) || node.parent.declarations.length !== 1 ? node : isVariableStatement(node.parent.parent) ? node.parent.parent : isForInOrOfStatement(node.parent.parent) ? getContextNode(node.parent.parent) : node.parent;
	      case 208 /* BindingElement */:
	        return getContextNode(node.parent.parent);
	      case 276 /* ImportSpecifier */:
	        return node.parent.parent.parent;
	      case 281 /* ExportSpecifier */:
	      case 274 /* NamespaceImport */:
	        return node.parent.parent;
	      case 273 /* ImportClause */:
	      case 280 /* NamespaceExport */:
	        return node.parent;
	      case 226 /* BinaryExpression */:
	        return isExpressionStatement(node.parent) ? node.parent : node;
	      case 250 /* ForOfStatement */:
	      case 249 /* ForInStatement */:
	        return {
	          start: node.initializer,
	          end: node.expression
	        };
	      case 303 /* PropertyAssignment */:
	      case 304 /* ShorthandPropertyAssignment */:
	        return isArrayLiteralOrObjectLiteralDestructuringPattern(node.parent) ? getContextNode(
	          findAncestor(node.parent, (node2) => isBinaryExpression(node2) || isForInOrOfStatement(node2))
	        ) : node;
	      case 255 /* SwitchStatement */:
	        return {
	          start: find(node.getChildren(node.getSourceFile()), (node2) => node2.kind === 109 /* SwitchKeyword */),
	          end: node.caseBlock
	        };
	      default:
	        return node;
	    }
	  }
	  function toContextSpan(textSpan, sourceFile, context) {
	    if (!context)
	      return void 0;
	    const contextSpan = isContextWithStartAndEndNode(context) ? getTextSpan(context.start, sourceFile, context.end) : getTextSpan(context, sourceFile);
	    return contextSpan.start !== textSpan.start || contextSpan.length !== textSpan.length ? { contextSpan } : void 0;
	  }
	  function findReferencedSymbols(program, cancellationToken, sourceFiles, sourceFile, position) {
	    const node = getTouchingPropertyName(sourceFile, position);
	    const options = { use: 1 /* References */ };
	    const referencedSymbols = Core.getReferencedSymbolsForNode(position, node, program, sourceFiles, cancellationToken, options);
	    const checker = program.getTypeChecker();
	    const adjustedNode = Core.getAdjustedNode(node, options);
	    const symbol = isDefinitionForReference(adjustedNode) ? checker.getSymbolAtLocation(adjustedNode) : void 0;
	    return !referencedSymbols || !referencedSymbols.length ? void 0 : mapDefined(referencedSymbols, ({ definition, references }) => (
	      // Only include referenced symbols that have a valid definition.
	      definition && {
	        definition: checker.runWithCancellationToken(cancellationToken, (checker2) => definitionToReferencedSymbolDefinitionInfo(definition, checker2, node)),
	        references: references.map((r) => toReferencedSymbolEntry(r, symbol))
	      }
	    ));
	  }
	  function isDefinitionForReference(node) {
	    return node.kind === 90 /* DefaultKeyword */ || !!getDeclarationFromName(node) || isLiteralComputedPropertyDeclarationName(node) || node.kind === 137 /* ConstructorKeyword */ && isConstructorDeclaration(node.parent);
	  }
	  function getImplementationsAtPosition(program, cancellationToken, sourceFiles, sourceFile, position) {
	    const node = getTouchingPropertyName(sourceFile, position);
	    let referenceEntries;
	    const entries = getImplementationReferenceEntries(program, cancellationToken, sourceFiles, node, position);
	    if (node.parent.kind === 211 /* PropertyAccessExpression */ || node.parent.kind === 208 /* BindingElement */ || node.parent.kind === 212 /* ElementAccessExpression */ || node.kind === 108 /* SuperKeyword */) {
	      referenceEntries = entries && [...entries];
	    } else if (entries) {
	      const queue = createQueue(entries);
	      const seenNodes = /* @__PURE__ */ new Map();
	      while (!queue.isEmpty()) {
	        const entry = queue.dequeue();
	        if (!addToSeen(seenNodes, getNodeId(entry.node))) {
	          continue;
	        }
	        referenceEntries = append(referenceEntries, entry);
	        const entries2 = getImplementationReferenceEntries(program, cancellationToken, sourceFiles, entry.node, entry.node.pos);
	        if (entries2) {
	          queue.enqueue(...entries2);
	        }
	      }
	    }
	    const checker = program.getTypeChecker();
	    return map(referenceEntries, (entry) => toImplementationLocation(entry, checker));
	  }
	  function getImplementationReferenceEntries(program, cancellationToken, sourceFiles, node, position) {
	    if (node.kind === 312 /* SourceFile */) {
	      return void 0;
	    }
	    const checker = program.getTypeChecker();
	    if (node.parent.kind === 304 /* ShorthandPropertyAssignment */) {
	      const result = [];
	      Core.getReferenceEntriesForShorthandPropertyAssignment(node, checker, (node2) => result.push(nodeEntry(node2)));
	      return result;
	    } else if (node.kind === 108 /* SuperKeyword */ || isSuperProperty(node.parent)) {
	      const symbol = checker.getSymbolAtLocation(node);
	      return symbol.valueDeclaration && [nodeEntry(symbol.valueDeclaration)];
	    } else {
	      return getReferenceEntriesForNode(position, node, program, sourceFiles, cancellationToken, { implementations: true, use: 1 /* References */ });
	    }
	  }
	  function findReferenceOrRenameEntries(program, cancellationToken, sourceFiles, node, position, options, convertEntry) {
	    return map(flattenEntries(Core.getReferencedSymbolsForNode(position, node, program, sourceFiles, cancellationToken, options)), (entry) => convertEntry(entry, node, program.getTypeChecker()));
	  }
	  function getReferenceEntriesForNode(position, node, program, sourceFiles, cancellationToken, options = {}, sourceFilesSet = new Set(sourceFiles.map((f) => f.fileName))) {
	    return flattenEntries(Core.getReferencedSymbolsForNode(position, node, program, sourceFiles, cancellationToken, options, sourceFilesSet));
	  }
	  function flattenEntries(referenceSymbols) {
	    return referenceSymbols && flatMap(referenceSymbols, (r) => r.references);
	  }
	  function definitionToReferencedSymbolDefinitionInfo(def, checker, originalNode) {
	    const info = (() => {
	      switch (def.type) {
	        case 0 /* Symbol */: {
	          const { symbol } = def;
	          const { displayParts: displayParts2, kind: kind2 } = getDefinitionKindAndDisplayParts(symbol, checker, originalNode);
	          const name2 = displayParts2.map((p) => p.text).join("");
	          const declaration = symbol.declarations && firstOrUndefined(symbol.declarations);
	          const node = declaration ? getNameOfDeclaration(declaration) || declaration : originalNode;
	          return {
	            ...getFileAndTextSpanFromNode(node),
	            name: name2,
	            kind: kind2,
	            displayParts: displayParts2,
	            context: getContextNode(declaration)
	          };
	        }
	        case 1 /* Label */: {
	          const { node } = def;
	          return { ...getFileAndTextSpanFromNode(node), name: node.text, kind: "label" /* label */, displayParts: [displayPart(node.text, 17 /* text */)] };
	        }
	        case 2 /* Keyword */: {
	          const { node } = def;
	          const name2 = tokenToString(node.kind);
	          return { ...getFileAndTextSpanFromNode(node), name: name2, kind: "keyword" /* keyword */, displayParts: [{ text: name2, kind: "keyword" /* keyword */ }] };
	        }
	        case 3 /* This */: {
	          const { node } = def;
	          const symbol = checker.getSymbolAtLocation(node);
	          const displayParts2 = symbol && ts_SymbolDisplay_exports.getSymbolDisplayPartsDocumentationAndSymbolKind(
	            checker,
	            symbol,
	            node.getSourceFile(),
	            getContainerNode(node),
	            node
	          ).displayParts || [textPart("this")];
	          return { ...getFileAndTextSpanFromNode(node), name: "this", kind: "var" /* variableElement */, displayParts: displayParts2 };
	        }
	        case 4 /* String */: {
	          const { node } = def;
	          return {
	            ...getFileAndTextSpanFromNode(node),
	            name: node.text,
	            kind: "var" /* variableElement */,
	            displayParts: [displayPart(getTextOfNode(node), 8 /* stringLiteral */)]
	          };
	        }
	        case 5 /* TripleSlashReference */: {
	          return {
	            textSpan: createTextSpanFromRange(def.reference),
	            sourceFile: def.file,
	            name: def.reference.fileName,
	            kind: "string" /* string */,
	            displayParts: [displayPart(`"${def.reference.fileName}"`, 8 /* stringLiteral */)]
	          };
	        }
	        default:
	          return Debug.assertNever(def);
	      }
	    })();
	    const { sourceFile, textSpan, name, kind, displayParts, context } = info;
	    return {
	      containerKind: "" /* unknown */,
	      containerName: "",
	      fileName: sourceFile.fileName,
	      kind,
	      name,
	      textSpan,
	      displayParts,
	      ...toContextSpan(textSpan, sourceFile, context)
	    };
	  }
	  function getFileAndTextSpanFromNode(node) {
	    const sourceFile = node.getSourceFile();
	    return {
	      sourceFile,
	      textSpan: getTextSpan(isComputedPropertyName(node) ? node.expression : node, sourceFile)
	    };
	  }
	  function getDefinitionKindAndDisplayParts(symbol, checker, node) {
	    const meaning = Core.getIntersectingMeaningFromDeclarations(node, symbol);
	    const enclosingDeclaration = symbol.declarations && firstOrUndefined(symbol.declarations) || node;
	    const { displayParts, symbolKind } = ts_SymbolDisplay_exports.getSymbolDisplayPartsDocumentationAndSymbolKind(checker, symbol, enclosingDeclaration.getSourceFile(), enclosingDeclaration, enclosingDeclaration, meaning);
	    return { displayParts, kind: symbolKind };
	  }
	  function toRenameLocation(entry, originalNode, checker, providePrefixAndSuffixText, quotePreference) {
	    return { ...entryToDocumentSpan(entry), ...providePrefixAndSuffixText && getPrefixAndSuffixText(entry, originalNode, checker, quotePreference) };
	  }
	  function toReferencedSymbolEntry(entry, symbol) {
	    const referenceEntry = toReferenceEntry(entry);
	    if (!symbol)
	      return referenceEntry;
	    return {
	      ...referenceEntry,
	      isDefinition: entry.kind !== 0 /* Span */ && isDeclarationOfSymbol(entry.node, symbol)
	    };
	  }
	  function toReferenceEntry(entry) {
	    const documentSpan = entryToDocumentSpan(entry);
	    if (entry.kind === 0 /* Span */) {
	      return { ...documentSpan, isWriteAccess: false };
	    }
	    const { kind, node } = entry;
	    return {
	      ...documentSpan,
	      isWriteAccess: isWriteAccessForReference(node),
	      isInString: kind === 2 /* StringLiteral */ ? true : void 0
	    };
	  }
	  function entryToDocumentSpan(entry) {
	    if (entry.kind === 0 /* Span */) {
	      return { textSpan: entry.textSpan, fileName: entry.fileName };
	    } else {
	      const sourceFile = entry.node.getSourceFile();
	      const textSpan = getTextSpan(entry.node, sourceFile);
	      return {
	        textSpan,
	        fileName: sourceFile.fileName,
	        ...toContextSpan(textSpan, sourceFile, entry.context)
	      };
	    }
	  }
	  function getPrefixAndSuffixText(entry, originalNode, checker, quotePreference) {
	    if (entry.kind !== 0 /* Span */ && isIdentifier(originalNode)) {
	      const { node, kind } = entry;
	      const parent2 = node.parent;
	      const name = originalNode.text;
	      const isShorthandAssignment = isShorthandPropertyAssignment(parent2);
	      if (isShorthandAssignment || isObjectBindingElementWithoutPropertyName(parent2) && parent2.name === node && parent2.dotDotDotToken === void 0) {
	        const prefixColon = { prefixText: name + ": " };
	        const suffixColon = { suffixText: ": " + name };
	        if (kind === 3 /* SearchedLocalFoundProperty */) {
	          return prefixColon;
	        }
	        if (kind === 4 /* SearchedPropertyFoundLocal */) {
	          return suffixColon;
	        }
	        if (isShorthandAssignment) {
	          const grandParent = parent2.parent;
	          if (isObjectLiteralExpression(grandParent) && isBinaryExpression(grandParent.parent) && isModuleExportsAccessExpression(grandParent.parent.left)) {
	            return prefixColon;
	          }
	          return suffixColon;
	        } else {
	          return prefixColon;
	        }
	      } else if (isImportSpecifier(parent2) && !parent2.propertyName) {
	        const originalSymbol = isExportSpecifier(originalNode.parent) ? checker.getExportSpecifierLocalTargetSymbol(originalNode.parent) : checker.getSymbolAtLocation(originalNode);
	        return contains(originalSymbol.declarations, parent2) ? { prefixText: name + " as " } : emptyOptions;
	      } else if (isExportSpecifier(parent2) && !parent2.propertyName) {
	        return originalNode === entry.node || checker.getSymbolAtLocation(originalNode) === checker.getSymbolAtLocation(entry.node) ? { prefixText: name + " as " } : { suffixText: " as " + name };
	      }
	    }
	    if (entry.kind !== 0 /* Span */ && isNumericLiteral(entry.node) && isAccessExpression(entry.node.parent)) {
	      const quote2 = getQuoteFromPreference(quotePreference);
	      return { prefixText: quote2, suffixText: quote2 };
	    }
	    return emptyOptions;
	  }
	  function toImplementationLocation(entry, checker) {
	    const documentSpan = entryToDocumentSpan(entry);
	    if (entry.kind !== 0 /* Span */) {
	      const { node } = entry;
	      return {
	        ...documentSpan,
	        ...implementationKindDisplayParts(node, checker)
	      };
	    } else {
	      return { ...documentSpan, kind: "" /* unknown */, displayParts: [] };
	    }
	  }
	  function implementationKindDisplayParts(node, checker) {
	    const symbol = checker.getSymbolAtLocation(isDeclaration(node) && node.name ? node.name : node);
	    if (symbol) {
	      return getDefinitionKindAndDisplayParts(symbol, checker, node);
	    } else if (node.kind === 210 /* ObjectLiteralExpression */) {
	      return {
	        kind: "interface" /* interfaceElement */,
	        displayParts: [punctuationPart(21 /* OpenParenToken */), textPart("object literal"), punctuationPart(22 /* CloseParenToken */)]
	      };
	    } else if (node.kind === 231 /* ClassExpression */) {
	      return {
	        kind: "local class" /* localClassElement */,
	        displayParts: [punctuationPart(21 /* OpenParenToken */), textPart("anonymous local class"), punctuationPart(22 /* CloseParenToken */)]
	      };
	    } else {
	      return { kind: getNodeKind(node), displayParts: [] };
	    }
	  }
	  function toHighlightSpan(entry) {
	    const documentSpan = entryToDocumentSpan(entry);
	    if (entry.kind === 0 /* Span */) {
	      return {
	        fileName: documentSpan.fileName,
	        span: {
	          textSpan: documentSpan.textSpan,
	          kind: "reference" /* reference */
	        }
	      };
	    }
	    const writeAccess = isWriteAccessForReference(entry.node);
	    const span = {
	      textSpan: documentSpan.textSpan,
	      kind: writeAccess ? "writtenReference" /* writtenReference */ : "reference" /* reference */,
	      isInString: entry.kind === 2 /* StringLiteral */ ? true : void 0,
	      ...documentSpan.contextSpan && { contextSpan: documentSpan.contextSpan }
	    };
	    return { fileName: documentSpan.fileName, span };
	  }
	  function getTextSpan(node, sourceFile, endNode2) {
	    let start = node.getStart(sourceFile);
	    let end = (endNode2 || node).getEnd();
	    if (isStringLiteralLike(node) && end - start > 2) {
	      Debug.assert(endNode2 === void 0);
	      start += 1;
	      end -= 1;
	    }
	    if ((endNode2 == null ? void 0 : endNode2.kind) === 269 /* CaseBlock */) {
	      end = endNode2.getFullStart();
	    }
	    return createTextSpanFromBounds(start, end);
	  }
	  function getTextSpanOfEntry(entry) {
	    return entry.kind === 0 /* Span */ ? entry.textSpan : getTextSpan(entry.node, entry.node.getSourceFile());
	  }
	  function isWriteAccessForReference(node) {
	    const decl = getDeclarationFromName(node);
	    return !!decl && declarationIsWriteAccess(decl) || node.kind === 90 /* DefaultKeyword */ || isWriteAccess(node);
	  }
	  function isDeclarationOfSymbol(node, target) {
	    var _a;
	    if (!target)
	      return false;
	    const source = getDeclarationFromName(node) || (node.kind === 90 /* DefaultKeyword */ ? node.parent : isLiteralComputedPropertyDeclarationName(node) ? node.parent.parent : node.kind === 137 /* ConstructorKeyword */ && isConstructorDeclaration(node.parent) ? node.parent.parent : void 0);
	    const commonjsSource = source && isBinaryExpression(source) ? source.left : void 0;
	    return !!(source && ((_a = target.declarations) == null ? void 0 : _a.some((d) => d === source || d === commonjsSource)));
	  }
	  function declarationIsWriteAccess(decl) {
	    if (!!(decl.flags & 33554432 /* Ambient */))
	      return true;
	    switch (decl.kind) {
	      case 226 /* BinaryExpression */:
	      case 208 /* BindingElement */:
	      case 263 /* ClassDeclaration */:
	      case 231 /* ClassExpression */:
	      case 90 /* DefaultKeyword */:
	      case 266 /* EnumDeclaration */:
	      case 306 /* EnumMember */:
	      case 281 /* ExportSpecifier */:
	      case 273 /* ImportClause */:
	      case 271 /* ImportEqualsDeclaration */:
	      case 276 /* ImportSpecifier */:
	      case 264 /* InterfaceDeclaration */:
	      case 345 /* JSDocCallbackTag */:
	      case 353 /* JSDocTypedefTag */:
	      case 291 /* JsxAttribute */:
	      case 267 /* ModuleDeclaration */:
	      case 270 /* NamespaceExportDeclaration */:
	      case 274 /* NamespaceImport */:
	      case 280 /* NamespaceExport */:
	      case 169 /* Parameter */:
	      case 304 /* ShorthandPropertyAssignment */:
	      case 265 /* TypeAliasDeclaration */:
	      case 168 /* TypeParameter */:
	        return true;
	      case 303 /* PropertyAssignment */:
	        return !isArrayLiteralOrObjectLiteralDestructuringPattern(decl.parent);
	      case 262 /* FunctionDeclaration */:
	      case 218 /* FunctionExpression */:
	      case 176 /* Constructor */:
	      case 174 /* MethodDeclaration */:
	      case 177 /* GetAccessor */:
	      case 178 /* SetAccessor */:
	        return !!decl.body;
	      case 260 /* VariableDeclaration */:
	      case 172 /* PropertyDeclaration */:
	        return !!decl.initializer || isCatchClause(decl.parent);
	      case 173 /* MethodSignature */:
	      case 171 /* PropertySignature */:
	      case 355 /* JSDocPropertyTag */:
	      case 348 /* JSDocParameterTag */:
	        return false;
	      default:
	        return Debug.failBadSyntaxKind(decl);
	    }
	  }
	  var DefinitionKind, EntryKind, FindReferencesUse, Core;
	  var init_findAllReferences = __esm({
	    "src/services/findAllReferences.ts"() {
	      init_ts4();
	      init_ts_FindAllReferences();
	      DefinitionKind = /* @__PURE__ */ ((DefinitionKind2) => {
	        DefinitionKind2[DefinitionKind2["Symbol"] = 0] = "Symbol";
	        DefinitionKind2[DefinitionKind2["Label"] = 1] = "Label";
	        DefinitionKind2[DefinitionKind2["Keyword"] = 2] = "Keyword";
	        DefinitionKind2[DefinitionKind2["This"] = 3] = "This";
	        DefinitionKind2[DefinitionKind2["String"] = 4] = "String";
	        DefinitionKind2[DefinitionKind2["TripleSlashReference"] = 5] = "TripleSlashReference";
	        return DefinitionKind2;
	      })(DefinitionKind || {});
	      EntryKind = /* @__PURE__ */ ((EntryKind2) => {
	        EntryKind2[EntryKind2["Span"] = 0] = "Span";
	        EntryKind2[EntryKind2["Node"] = 1] = "Node";
	        EntryKind2[EntryKind2["StringLiteral"] = 2] = "StringLiteral";
	        EntryKind2[EntryKind2["SearchedLocalFoundProperty"] = 3] = "SearchedLocalFoundProperty";
	        EntryKind2[EntryKind2["SearchedPropertyFoundLocal"] = 4] = "SearchedPropertyFoundLocal";
	        return EntryKind2;
	      })(EntryKind || {});
	      FindReferencesUse = /* @__PURE__ */ ((FindReferencesUse2) => {
	        FindReferencesUse2[FindReferencesUse2["Other"] = 0] = "Other";
	        FindReferencesUse2[FindReferencesUse2["References"] = 1] = "References";
	        FindReferencesUse2[FindReferencesUse2["Rename"] = 2] = "Rename";
	        return FindReferencesUse2;
	      })(FindReferencesUse || {});
	      ((Core2) => {
	        function getReferencedSymbolsForNode(position, node, program, sourceFiles, cancellationToken, options = {}, sourceFilesSet = new Set(sourceFiles.map((f) => f.fileName))) {
	          var _a, _b;
	          node = getAdjustedNode2(node, options);
	          if (isSourceFile(node)) {
	            const resolvedRef = ts_GoToDefinition_exports.getReferenceAtPosition(node, position, program);
	            if (!(resolvedRef == null ? void 0 : resolvedRef.file)) {
	              return void 0;
	            }
	            const moduleSymbol = program.getTypeChecker().getMergedSymbol(resolvedRef.file.symbol);
	            if (moduleSymbol) {
	              return getReferencedSymbolsForModule(
	                program,
	                moduleSymbol,
	                /*excludeImportTypeOfExportEquals*/
	                false,
	                sourceFiles,
	                sourceFilesSet
	              );
	            }
	            const fileIncludeReasons = program.getFileIncludeReasons();
	            if (!fileIncludeReasons) {
	              return void 0;
	            }
	            return [{
	              definition: { type: 5 /* TripleSlashReference */, reference: resolvedRef.reference, file: node },
	              references: getReferencesForNonModule(resolvedRef.file, fileIncludeReasons, program) || emptyArray
	            }];
	          }
	          if (!options.implementations) {
	            const special = getReferencedSymbolsSpecial(node, sourceFiles, cancellationToken);
	            if (special) {
	              return special;
	            }
	          }
	          const checker = program.getTypeChecker();
	          const symbol = checker.getSymbolAtLocation(isConstructorDeclaration(node) && node.parent.name || node);
	          if (!symbol) {
	            if (!options.implementations && isStringLiteralLike(node)) {
	              if (isModuleSpecifierLike(node)) {
	                const fileIncludeReasons = program.getFileIncludeReasons();
	                const referencedFileName = (_b = (_a = program.getResolvedModuleFromModuleSpecifier(node)) == null ? void 0 : _a.resolvedModule) == null ? void 0 : _b.resolvedFileName;
	                const referencedFile = referencedFileName ? program.getSourceFile(referencedFileName) : void 0;
	                if (referencedFile) {
	                  return [{ definition: { type: 4 /* String */, node }, references: getReferencesForNonModule(referencedFile, fileIncludeReasons, program) || emptyArray }];
	                }
	              }
	              return getReferencesForStringLiteral(node, sourceFiles, checker, cancellationToken);
	            }
	            return void 0;
	          }
	          if (symbol.escapedName === "export=" /* ExportEquals */) {
	            return getReferencedSymbolsForModule(
	              program,
	              symbol.parent,
	              /*excludeImportTypeOfExportEquals*/
	              false,
	              sourceFiles,
	              sourceFilesSet
	            );
	          }
	          const moduleReferences = getReferencedSymbolsForModuleIfDeclaredBySourceFile(symbol, program, sourceFiles, cancellationToken, options, sourceFilesSet);
	          if (moduleReferences && !(symbol.flags & 33554432 /* Transient */)) {
	            return moduleReferences;
	          }
	          const aliasedSymbol = getMergedAliasedSymbolOfNamespaceExportDeclaration(node, symbol, checker);
	          const moduleReferencesOfExportTarget = aliasedSymbol && getReferencedSymbolsForModuleIfDeclaredBySourceFile(aliasedSymbol, program, sourceFiles, cancellationToken, options, sourceFilesSet);
	          const references = getReferencedSymbolsForSymbol(symbol, node, sourceFiles, sourceFilesSet, checker, cancellationToken, options);
	          return mergeReferences(program, moduleReferences, references, moduleReferencesOfExportTarget);
	        }
	        Core2.getReferencedSymbolsForNode = getReferencedSymbolsForNode;
	        function getAdjustedNode2(node, options) {
	          if (options.use === 1 /* References */) {
	            node = getAdjustedReferenceLocation(node);
	          } else if (options.use === 2 /* Rename */) {
	            node = getAdjustedRenameLocation(node);
	          }
	          return node;
	        }
	        Core2.getAdjustedNode = getAdjustedNode2;
	        function getReferencesForFileName(fileName, program, sourceFiles, sourceFilesSet = new Set(sourceFiles.map((f) => f.fileName))) {
	          var _a, _b;
	          const moduleSymbol = (_a = program.getSourceFile(fileName)) == null ? void 0 : _a.symbol;
	          if (moduleSymbol) {
	            return ((_b = getReferencedSymbolsForModule(
	              program,
	              moduleSymbol,
	              /*excludeImportTypeOfExportEquals*/
	              false,
	              sourceFiles,
	              sourceFilesSet
	            )[0]) == null ? void 0 : _b.references) || emptyArray;
	          }
	          const fileIncludeReasons = program.getFileIncludeReasons();
	          const referencedFile = program.getSourceFile(fileName);
	          return referencedFile && fileIncludeReasons && getReferencesForNonModule(referencedFile, fileIncludeReasons, program) || emptyArray;
	        }
	        Core2.getReferencesForFileName = getReferencesForFileName;
	        function getReferencesForNonModule(referencedFile, refFileMap, program) {
	          let entries;
	          const references = refFileMap.get(referencedFile.path) || emptyArray;
	          for (const ref of references) {
	            if (isReferencedFile(ref)) {
	              const referencingFile = program.getSourceFileByPath(ref.file);
	              const location = getReferencedFileLocation(program, ref);
	              if (isReferenceFileLocation(location)) {
	                entries = append(entries, {
	                  kind: 0 /* Span */,
	                  fileName: referencingFile.fileName,
	                  textSpan: createTextSpanFromRange(location)
	                });
	              }
	            }
	          }
	          return entries;
	        }
	        function getMergedAliasedSymbolOfNamespaceExportDeclaration(node, symbol, checker) {
	          if (node.parent && isNamespaceExportDeclaration(node.parent)) {
	            const aliasedSymbol = checker.getAliasedSymbol(symbol);
	            const targetSymbol = checker.getMergedSymbol(aliasedSymbol);
	            if (aliasedSymbol !== targetSymbol) {
	              return targetSymbol;
	            }
	          }
	          return void 0;
	        }
	        function getReferencedSymbolsForModuleIfDeclaredBySourceFile(symbol, program, sourceFiles, cancellationToken, options, sourceFilesSet) {
	          const moduleSourceFile = symbol.flags & 1536 /* Module */ && symbol.declarations && find(symbol.declarations, isSourceFile);
	          if (!moduleSourceFile)
	            return void 0;
	          const exportEquals = symbol.exports.get("export=" /* ExportEquals */);
	          const moduleReferences = getReferencedSymbolsForModule(program, symbol, !!exportEquals, sourceFiles, sourceFilesSet);
	          if (!exportEquals || !sourceFilesSet.has(moduleSourceFile.fileName))
	            return moduleReferences;
	          const checker = program.getTypeChecker();
	          symbol = skipAlias(exportEquals, checker);
	          return mergeReferences(program, moduleReferences, getReferencedSymbolsForSymbol(
	            symbol,
	            /*node*/
	            void 0,
	            sourceFiles,
	            sourceFilesSet,
	            checker,
	            cancellationToken,
	            options
	          ));
	        }
	        function mergeReferences(program, ...referencesToMerge) {
	          let result;
	          for (const references of referencesToMerge) {
	            if (!references || !references.length)
	              continue;
	            if (!result) {
	              result = references;
	              continue;
	            }
	            for (const entry of references) {
	              if (!entry.definition || entry.definition.type !== 0 /* Symbol */) {
	                result.push(entry);
	                continue;
	              }
	              const symbol = entry.definition.symbol;
	              const refIndex = findIndex(result, (ref) => !!ref.definition && ref.definition.type === 0 /* Symbol */ && ref.definition.symbol === symbol);
	              if (refIndex === -1) {
	                result.push(entry);
	                continue;
	              }
	              const reference = result[refIndex];
	              result[refIndex] = {
	                definition: reference.definition,
	                references: reference.references.concat(entry.references).sort((entry1, entry2) => {
	                  const entry1File = getSourceFileIndexOfEntry(program, entry1);
	                  const entry2File = getSourceFileIndexOfEntry(program, entry2);
	                  if (entry1File !== entry2File) {
	                    return compareValues(entry1File, entry2File);
	                  }
	                  const entry1Span = getTextSpanOfEntry(entry1);
	                  const entry2Span = getTextSpanOfEntry(entry2);
	                  return entry1Span.start !== entry2Span.start ? compareValues(entry1Span.start, entry2Span.start) : compareValues(entry1Span.length, entry2Span.length);
	                })
	              };
	            }
	          }
	          return result;
	        }
	        function getSourceFileIndexOfEntry(program, entry) {
	          const sourceFile = entry.kind === 0 /* Span */ ? program.getSourceFile(entry.fileName) : entry.node.getSourceFile();
	          return program.getSourceFiles().indexOf(sourceFile);
	        }
	        function getReferencedSymbolsForModule(program, symbol, excludeImportTypeOfExportEquals, sourceFiles, sourceFilesSet) {
	          Debug.assert(!!symbol.valueDeclaration);
	          const references = mapDefined(findModuleReferences(program, sourceFiles, symbol), (reference) => {
	            if (reference.kind === "import") {
	              const parent2 = reference.literal.parent;
	              if (isLiteralTypeNode(parent2)) {
	                const importType = cast(parent2.parent, isImportTypeNode);
	                if (excludeImportTypeOfExportEquals && !importType.qualifier) {
	                  return void 0;
	                }
	              }
	              return nodeEntry(reference.literal);
	            } else if (reference.kind === "implicit") {
	              const range = reference.literal.text !== externalHelpersModuleNameText && forEachChildRecursively(
	                reference.referencingFile,
	                (n) => !(n.transformFlags & 2 /* ContainsJsx */) ? "skip" : isJsxElement(n) || isJsxSelfClosingElement(n) || isJsxFragment(n) ? n : void 0
	              ) || reference.referencingFile.statements[0] || reference.referencingFile;
	              return nodeEntry(range);
	            } else {
	              return {
	                kind: 0 /* Span */,
	                fileName: reference.referencingFile.fileName,
	                textSpan: createTextSpanFromRange(reference.ref)
	              };
	            }
	          });
	          if (symbol.declarations) {
	            for (const decl of symbol.declarations) {
	              switch (decl.kind) {
	                case 312 /* SourceFile */:
	                  break;
	                case 267 /* ModuleDeclaration */:
	                  if (sourceFilesSet.has(decl.getSourceFile().fileName)) {
	                    references.push(nodeEntry(decl.name));
	                  }
	                  break;
	                default:
	                  Debug.assert(!!(symbol.flags & 33554432 /* Transient */), "Expected a module symbol to be declared by a SourceFile or ModuleDeclaration.");
	              }
	            }
	          }
	          const exported = symbol.exports.get("export=" /* ExportEquals */);
	          if (exported == null ? void 0 : exported.declarations) {
	            for (const decl of exported.declarations) {
	              const sourceFile = decl.getSourceFile();
	              if (sourceFilesSet.has(sourceFile.fileName)) {
	                const node = isBinaryExpression(decl) && isPropertyAccessExpression(decl.left) ? decl.left.expression : isExportAssignment(decl) ? Debug.checkDefined(findChildOfKind(decl, 95 /* ExportKeyword */, sourceFile)) : getNameOfDeclaration(decl) || decl;
	                references.push(nodeEntry(node));
	              }
	            }
	          }
	          return references.length ? [{ definition: { type: 0 /* Symbol */, symbol }, references }] : emptyArray;
	        }
	        function isReadonlyTypeOperator(node) {
	          return node.kind === 148 /* ReadonlyKeyword */ && isTypeOperatorNode(node.parent) && node.parent.operator === 148 /* ReadonlyKeyword */;
	        }
	        function getReferencedSymbolsSpecial(node, sourceFiles, cancellationToken) {
	          if (isTypeKeyword(node.kind)) {
	            if (node.kind === 116 /* VoidKeyword */ && isVoidExpression(node.parent)) {
	              return void 0;
	            }
	            if (node.kind === 148 /* ReadonlyKeyword */ && !isReadonlyTypeOperator(node)) {
	              return void 0;
	            }
	            return getAllReferencesForKeyword(
	              sourceFiles,
	              node.kind,
	              cancellationToken,
	              node.kind === 148 /* ReadonlyKeyword */ ? isReadonlyTypeOperator : void 0
	            );
	          }
	          if (isImportMeta(node.parent) && node.parent.name === node) {
	            return getAllReferencesForImportMeta(sourceFiles, cancellationToken);
	          }
	          if (isStaticModifier(node) && isClassStaticBlockDeclaration(node.parent)) {
	            return [{ definition: { type: 2 /* Keyword */, node }, references: [nodeEntry(node)] }];
	          }
	          if (isJumpStatementTarget(node)) {
	            const labelDefinition = getTargetLabel(node.parent, node.text);
	            return labelDefinition && getLabelReferencesInNode(labelDefinition.parent, labelDefinition);
	          } else if (isLabelOfLabeledStatement(node)) {
	            return getLabelReferencesInNode(node.parent, node);
	          }
	          if (isThis(node)) {
	            return getReferencesForThisKeyword(node, sourceFiles, cancellationToken);
	          }
	          if (node.kind === 108 /* SuperKeyword */) {
	            return getReferencesForSuperKeyword(node);
	          }
	          return void 0;
	        }
	        function getReferencedSymbolsForSymbol(originalSymbol, node, sourceFiles, sourceFilesSet, checker, cancellationToken, options) {
	          const symbol = node && skipPastExportOrImportSpecifierOrUnion(
	            originalSymbol,
	            node,
	            checker,
	            /*useLocalSymbolForExportSpecifier*/
	            !isForRenameWithPrefixAndSuffixText(options)
	          ) || originalSymbol;
	          const searchMeaning = node ? getIntersectingMeaningFromDeclarations(node, symbol) : 7 /* All */;
	          const result = [];
	          const state = new State(sourceFiles, sourceFilesSet, node ? getSpecialSearchKind(node) : 0 /* None */, checker, cancellationToken, searchMeaning, options, result);
	          const exportSpecifier = !isForRenameWithPrefixAndSuffixText(options) || !symbol.declarations ? void 0 : find(symbol.declarations, isExportSpecifier);
	          if (exportSpecifier) {
	            getReferencesAtExportSpecifier(
	              exportSpecifier.name,
	              symbol,
	              exportSpecifier,
	              state.createSearch(
	                node,
	                originalSymbol,
	                /*comingFrom*/
	                void 0
	              ),
	              state,
	              /*addReferencesHere*/
	              true,
	              /*alwaysGetReferences*/
	              true
	            );
	          } else if (node && node.kind === 90 /* DefaultKeyword */ && symbol.escapedName === "default" /* Default */ && symbol.parent) {
	            addReference(node, symbol, state);
	            searchForImportsOfExport(node, symbol, { exportingModuleSymbol: symbol.parent, exportKind: 1 /* Default */ }, state);
	          } else {
	            const search = state.createSearch(
	              node,
	              symbol,
	              /*comingFrom*/
	              void 0,
	              { allSearchSymbols: node ? populateSearchSymbolSet(symbol, node, checker, options.use === 2 /* Rename */, !!options.providePrefixAndSuffixTextForRename, !!options.implementations) : [symbol] }
	            );
	            getReferencesInContainerOrFiles(symbol, state, search);
	          }
	          return result;
	        }
	        function getReferencesInContainerOrFiles(symbol, state, search) {
	          const scope = getSymbolScope(symbol);
	          if (scope) {
	            getReferencesInContainer(
	              scope,
	              scope.getSourceFile(),
	              search,
	              state,
	              /*addReferencesHere*/
	              !(isSourceFile(scope) && !contains(state.sourceFiles, scope))
	            );
	          } else {
	            for (const sourceFile of state.sourceFiles) {
	              state.cancellationToken.throwIfCancellationRequested();
	              searchForName(sourceFile, search, state);
	            }
	          }
	        }
	        function getSpecialSearchKind(node) {
	          switch (node.kind) {
	            case 176 /* Constructor */:
	            case 137 /* ConstructorKeyword */:
	              return 1 /* Constructor */;
	            case 80 /* Identifier */:
	              if (isClassLike(node.parent)) {
	                Debug.assert(node.parent.name === node);
	                return 2 /* Class */;
	              }
	            default:
	              return 0 /* None */;
	          }
	        }
	        function skipPastExportOrImportSpecifierOrUnion(symbol, node, checker, useLocalSymbolForExportSpecifier) {
	          const { parent: parent2 } = node;
	          if (isExportSpecifier(parent2) && useLocalSymbolForExportSpecifier) {
	            return getLocalSymbolForExportSpecifier(node, symbol, parent2, checker);
	          }
	          return firstDefined(symbol.declarations, (decl) => {
	            if (!decl.parent) {
	              if (symbol.flags & 33554432 /* Transient */)
	                return void 0;
	              Debug.fail(`Unexpected symbol at ${Debug.formatSyntaxKind(node.kind)}: ${Debug.formatSymbol(symbol)}`);
	            }
	            return isTypeLiteralNode(decl.parent) && isUnionTypeNode(decl.parent.parent) ? checker.getPropertyOfType(checker.getTypeFromTypeNode(decl.parent.parent), symbol.name) : void 0;
	          });
	        }
	        let SpecialSearchKind;
	        ((SpecialSearchKind2) => {
	          SpecialSearchKind2[SpecialSearchKind2["None"] = 0] = "None";
	          SpecialSearchKind2[SpecialSearchKind2["Constructor"] = 1] = "Constructor";
	          SpecialSearchKind2[SpecialSearchKind2["Class"] = 2] = "Class";
	        })(SpecialSearchKind || (SpecialSearchKind = {}));
	        function getNonModuleSymbolOfMergedModuleSymbol(symbol) {
	          if (!(symbol.flags & (1536 /* Module */ | 33554432 /* Transient */)))
	            return void 0;
	          const decl = symbol.declarations && find(symbol.declarations, (d) => !isSourceFile(d) && !isModuleDeclaration(d));
	          return decl && decl.symbol;
	        }
	        class State {
	          constructor(sourceFiles, sourceFilesSet, specialSearchKind, checker, cancellationToken, searchMeaning, options, result) {
	            this.sourceFiles = sourceFiles;
	            this.sourceFilesSet = sourceFilesSet;
	            this.specialSearchKind = specialSearchKind;
	            this.checker = checker;
	            this.cancellationToken = cancellationToken;
	            this.searchMeaning = searchMeaning;
	            this.options = options;
	            this.result = result;
	            /** Cache for `explicitlyinheritsFrom`. */
	            this.inheritsFromCache = /* @__PURE__ */ new Map();
	            /**
	             * Type nodes can contain multiple references to the same type. For example:
	             *      let x: Foo & (Foo & Bar) = ...
	             * Because we are returning the implementation locations and not the identifier locations,
	             * duplicate entries would be returned here as each of the type references is part of
	             * the same implementation. For that reason, check before we add a new entry.
	             */
	            this.markSeenContainingTypeReference = nodeSeenTracker();
	            /**
	             * It's possible that we will encounter the right side of `export { foo as bar } from "x";` more than once.
	             * For example:
	             *     // b.ts
	             *     export { foo as bar } from "./a";
	             *     import { bar } from "./b";
	             *
	             * Normally at `foo as bar` we directly add `foo` and do not locally search for it (since it doesn't declare a local).
	             * But another reference to it may appear in the same source file.
	             * See `tests/cases/fourslash/transitiveExportImports3.ts`.
	             */
	            this.markSeenReExportRHS = nodeSeenTracker();
	            this.symbolIdToReferences = [];
	            // Source file ID -> symbol ID -> Whether the symbol has been searched for in the source file.
	            this.sourceFileToSeenSymbols = [];
	          }
	          includesSourceFile(sourceFile) {
	            return this.sourceFilesSet.has(sourceFile.fileName);
	          }
	          /** Gets every place to look for references of an exported symbols. See `ImportsResult` in `importTracker.ts` for more documentation. */
	          getImportSearches(exportSymbol, exportInfo) {
	            if (!this.importTracker)
	              this.importTracker = createImportTracker(this.sourceFiles, this.sourceFilesSet, this.checker, this.cancellationToken);
	            return this.importTracker(exportSymbol, exportInfo, this.options.use === 2 /* Rename */);
	          }
	          /** @param allSearchSymbols set of additional symbols for use by `includes`. */
	          createSearch(location, symbol, comingFrom, searchOptions = {}) {
	            const {
	              text = stripQuotes(symbolName(getLocalSymbolForExportDefault(symbol) || getNonModuleSymbolOfMergedModuleSymbol(symbol) || symbol)),
	              allSearchSymbols = [symbol]
	            } = searchOptions;
	            const escapedText = escapeLeadingUnderscores(text);
	            const parents = this.options.implementations && location ? getParentSymbolsOfPropertyAccess(location, symbol, this.checker) : void 0;
	            return { symbol, comingFrom, text, escapedText, parents, allSearchSymbols, includes: (sym) => contains(allSearchSymbols, sym) };
	          }
	          /**
	           * Callback to add references for a particular searched symbol.
	           * This initializes a reference group, so only call this if you will add at least one reference.
	           */
	          referenceAdder(searchSymbol) {
	            const symbolId = getSymbolId(searchSymbol);
	            let references = this.symbolIdToReferences[symbolId];
	            if (!references) {
	              references = this.symbolIdToReferences[symbolId] = [];
	              this.result.push({ definition: { type: 0 /* Symbol */, symbol: searchSymbol }, references });
	            }
	            return (node, kind) => references.push(nodeEntry(node, kind));
	          }
	          /** Add a reference with no associated definition. */
	          addStringOrCommentReference(fileName, textSpan) {
	            this.result.push({
	              definition: void 0,
	              references: [{ kind: 0 /* Span */, fileName, textSpan }]
	            });
	          }
	          /** Returns `true` the first time we search for a symbol in a file and `false` afterwards. */
	          markSearchedSymbols(sourceFile, symbols) {
	            const sourceId = getNodeId(sourceFile);
	            const seenSymbols = this.sourceFileToSeenSymbols[sourceId] || (this.sourceFileToSeenSymbols[sourceId] = /* @__PURE__ */ new Set());
	            let anyNewSymbols = false;
	            for (const sym of symbols) {
	              anyNewSymbols = tryAddToSet(seenSymbols, getSymbolId(sym)) || anyNewSymbols;
	            }
	            return anyNewSymbols;
	          }
	        }
	        function searchForImportsOfExport(exportLocation, exportSymbol, exportInfo, state) {
	          const { importSearches, singleReferences, indirectUsers } = state.getImportSearches(exportSymbol, exportInfo);
	          if (singleReferences.length) {
	            const addRef = state.referenceAdder(exportSymbol);
	            for (const singleRef of singleReferences) {
	              if (shouldAddSingleReference(singleRef, state))
	                addRef(singleRef);
	            }
	          }
	          for (const [importLocation, importSymbol] of importSearches) {
	            getReferencesInSourceFile(importLocation.getSourceFile(), state.createSearch(importLocation, importSymbol, 1 /* Export */), state);
	          }
	          if (indirectUsers.length) {
	            let indirectSearch;
	            switch (exportInfo.exportKind) {
	              case 0 /* Named */:
	                indirectSearch = state.createSearch(exportLocation, exportSymbol, 1 /* Export */);
	                break;
	              case 1 /* Default */:
	                indirectSearch = state.options.use === 2 /* Rename */ ? void 0 : state.createSearch(exportLocation, exportSymbol, 1 /* Export */, { text: "default" });
	                break;
	            }
	            if (indirectSearch) {
	              for (const indirectUser of indirectUsers) {
	                searchForName(indirectUser, indirectSearch, state);
	              }
	            }
	          }
	        }
	        function eachExportReference(sourceFiles, checker, cancellationToken, exportSymbol, exportingModuleSymbol, exportName, isDefaultExport, cb) {
	          const importTracker = createImportTracker(sourceFiles, new Set(sourceFiles.map((f) => f.fileName)), checker, cancellationToken);
	          const { importSearches, indirectUsers, singleReferences } = importTracker(
	            exportSymbol,
	            { exportKind: isDefaultExport ? 1 /* Default */ : 0 /* Named */, exportingModuleSymbol },
	            /*isForRename*/
	            false
	          );
	          for (const [importLocation] of importSearches) {
	            cb(importLocation);
	          }
	          for (const singleReference of singleReferences) {
	            if (isIdentifier(singleReference) && isImportTypeNode(singleReference.parent)) {
	              cb(singleReference);
	            }
	          }
	          for (const indirectUser of indirectUsers) {
	            for (const node of getPossibleSymbolReferenceNodes(indirectUser, isDefaultExport ? "default" : exportName)) {
	              const symbol = checker.getSymbolAtLocation(node);
	              const hasExportAssignmentDeclaration = some(symbol == null ? void 0 : symbol.declarations, (d) => tryCast(d, isExportAssignment) ? true : false);
	              if (isIdentifier(node) && !isImportOrExportSpecifier(node.parent) && (symbol === exportSymbol || hasExportAssignmentDeclaration)) {
	                cb(node);
	              }
	            }
	          }
	        }
	        Core2.eachExportReference = eachExportReference;
	        function shouldAddSingleReference(singleRef, state) {
	          if (!hasMatchingMeaning(singleRef, state))
	            return false;
	          if (state.options.use !== 2 /* Rename */)
	            return true;
	          if (!isIdentifier(singleRef))
	            return false;
	          return !(isImportOrExportSpecifier(singleRef.parent) && singleRef.escapedText === "default" /* Default */);
	        }
	        function searchForImportedSymbol(symbol, state) {
	          if (!symbol.declarations)
	            return;
	          for (const declaration of symbol.declarations) {
	            const exportingFile = declaration.getSourceFile();
	            getReferencesInSourceFile(exportingFile, state.createSearch(declaration, symbol, 0 /* Import */), state, state.includesSourceFile(exportingFile));
	          }
	        }
	        function searchForName(sourceFile, search, state) {
	          if (getNameTable(sourceFile).get(search.escapedText) !== void 0) {
	            getReferencesInSourceFile(sourceFile, search, state);
	          }
	        }
	        function getPropertySymbolOfDestructuringAssignment(location, checker) {
	          return isArrayLiteralOrObjectLiteralDestructuringPattern(location.parent.parent) ? checker.getPropertySymbolOfDestructuringAssignment(location) : void 0;
	        }
	        function getSymbolScope(symbol) {
	          const { declarations, flags, parent: parent2, valueDeclaration } = symbol;
	          if (valueDeclaration && (valueDeclaration.kind === 218 /* FunctionExpression */ || valueDeclaration.kind === 231 /* ClassExpression */)) {
	            return valueDeclaration;
	          }
	          if (!declarations) {
	            return void 0;
	          }
	          if (flags & (4 /* Property */ | 8192 /* Method */)) {
	            const privateDeclaration = find(declarations, (d) => hasEffectiveModifier(d, 2 /* Private */) || isPrivateIdentifierClassElementDeclaration(d));
	            if (privateDeclaration) {
	              return getAncestor(privateDeclaration, 263 /* ClassDeclaration */);
	            }
	            return void 0;
	          }
	          if (declarations.some(isObjectBindingElementWithoutPropertyName)) {
	            return void 0;
	          }
	          const exposedByParent = parent2 && !(symbol.flags & 262144 /* TypeParameter */);
	          if (exposedByParent && !(isExternalModuleSymbol(parent2) && !parent2.globalExports)) {
	            return void 0;
	          }
	          let scope;
	          for (const declaration of declarations) {
	            const container = getContainerNode(declaration);
	            if (scope && scope !== container) {
	              return void 0;
	            }
	            if (!container || container.kind === 312 /* SourceFile */ && !isExternalOrCommonJsModule(container)) {
	              return void 0;
	            }
	            scope = container;
	            if (isFunctionExpression(scope)) {
	              let next;
	              while (next = getNextJSDocCommentLocation(scope)) {
	                scope = next;
	              }
	            }
	          }
	          return exposedByParent ? scope.getSourceFile() : scope;
	        }
	        function isSymbolReferencedInFile(definition, checker, sourceFile, searchContainer = sourceFile) {
	          return eachSymbolReferenceInFile(definition, checker, sourceFile, () => true, searchContainer) || false;
	        }
	        Core2.isSymbolReferencedInFile = isSymbolReferencedInFile;
	        function eachSymbolReferenceInFile(definition, checker, sourceFile, cb, searchContainer = sourceFile) {
	          const symbol = isParameterPropertyDeclaration(definition.parent, definition.parent.parent) ? first(checker.getSymbolsOfParameterPropertyDeclaration(definition.parent, definition.text)) : checker.getSymbolAtLocation(definition);
	          if (!symbol)
	            return void 0;
	          for (const token of getPossibleSymbolReferenceNodes(sourceFile, symbol.name, searchContainer)) {
	            if (!isIdentifier(token) || token === definition || token.escapedText !== definition.escapedText)
	              continue;
	            const referenceSymbol = checker.getSymbolAtLocation(token);
	            if (referenceSymbol === symbol || checker.getShorthandAssignmentValueSymbol(token.parent) === symbol || isExportSpecifier(token.parent) && getLocalSymbolForExportSpecifier(token, referenceSymbol, token.parent, checker) === symbol) {
	              const res = cb(token);
	              if (res)
	                return res;
	            }
	          }
	        }
	        Core2.eachSymbolReferenceInFile = eachSymbolReferenceInFile;
	        function getTopMostDeclarationNamesInFile(declarationName, sourceFile) {
	          const candidates = filter(getPossibleSymbolReferenceNodes(sourceFile, declarationName), (name) => !!getDeclarationFromName(name));
	          return candidates.reduce((topMost, decl) => {
	            const depth = getDepth(decl);
	            if (!some(topMost.declarationNames) || depth === topMost.depth) {
	              topMost.declarationNames.push(decl);
	              topMost.depth = depth;
	            } else if (depth < topMost.depth) {
	              topMost.declarationNames = [decl];
	              topMost.depth = depth;
	            }
	            return topMost;
	          }, { depth: Infinity, declarationNames: [] }).declarationNames;
	          function getDepth(declaration) {
	            let depth = 0;
	            while (declaration) {
	              declaration = getContainerNode(declaration);
	              depth++;
	            }
	            return depth;
	          }
	        }
	        Core2.getTopMostDeclarationNamesInFile = getTopMostDeclarationNamesInFile;
	        function someSignatureUsage(signature, sourceFiles, checker, cb) {
	          if (!signature.name || !isIdentifier(signature.name))
	            return false;
	          const symbol = Debug.checkDefined(checker.getSymbolAtLocation(signature.name));
	          for (const sourceFile of sourceFiles) {
	            for (const name of getPossibleSymbolReferenceNodes(sourceFile, symbol.name)) {
	              if (!isIdentifier(name) || name === signature.name || name.escapedText !== signature.name.escapedText)
	                continue;
	              const called = climbPastPropertyAccess(name);
	              const call = isCallExpression(called.parent) && called.parent.expression === called ? called.parent : void 0;
	              const referenceSymbol = checker.getSymbolAtLocation(name);
	              if (referenceSymbol && checker.getRootSymbols(referenceSymbol).some((s) => s === symbol)) {
	                if (cb(name, call)) {
	                  return true;
	                }
	              }
	            }
	          }
	          return false;
	        }
	        Core2.someSignatureUsage = someSignatureUsage;
	        function getPossibleSymbolReferenceNodes(sourceFile, symbolName2, container = sourceFile) {
	          return mapDefined(getPossibleSymbolReferencePositions(sourceFile, symbolName2, container), (pos) => {
	            const referenceLocation = getTouchingPropertyName(sourceFile, pos);
	            return referenceLocation === sourceFile ? void 0 : referenceLocation;
	          });
	        }
	        function getPossibleSymbolReferencePositions(sourceFile, symbolName2, container = sourceFile) {
	          const positions = [];
	          if (!symbolName2 || !symbolName2.length) {
	            return positions;
	          }
	          const text = sourceFile.text;
	          const sourceLength = text.length;
	          const symbolNameLength = symbolName2.length;
	          let position = text.indexOf(symbolName2, container.pos);
	          while (position >= 0) {
	            if (position > container.end)
	              break;
	            const endPosition = position + symbolNameLength;
	            if ((position === 0 || !isIdentifierPart(text.charCodeAt(position - 1), 99 /* Latest */)) && (endPosition === sourceLength || !isIdentifierPart(text.charCodeAt(endPosition), 99 /* Latest */))) {
	              positions.push(position);
	            }
	            position = text.indexOf(symbolName2, position + symbolNameLength + 1);
	          }
	          return positions;
	        }
	        function getLabelReferencesInNode(container, targetLabel) {
	          const sourceFile = container.getSourceFile();
	          const labelName = targetLabel.text;
	          const references = mapDefined(getPossibleSymbolReferenceNodes(sourceFile, labelName, container), (node) => (
	            // Only pick labels that are either the target label, or have a target that is the target label
	            node === targetLabel || isJumpStatementTarget(node) && getTargetLabel(node, labelName) === targetLabel ? nodeEntry(node) : void 0
	          ));
	          return [{ definition: { type: 1 /* Label */, node: targetLabel }, references }];
	        }
	        function isValidReferencePosition(node, searchSymbolName) {
	          switch (node.kind) {
	            case 81 /* PrivateIdentifier */:
	              if (isJSDocMemberName(node.parent)) {
	                return true;
	              }
	            case 80 /* Identifier */:
	              return node.text.length === searchSymbolName.length;
	            case 15 /* NoSubstitutionTemplateLiteral */:
	            case 11 /* StringLiteral */: {
	              const str = node;
	              return (isLiteralNameOfPropertyDeclarationOrIndexAccess(str) || isNameOfModuleDeclaration(node) || isExpressionOfExternalModuleImportEqualsDeclaration(node) || isCallExpression(node.parent) && isBindableObjectDefinePropertyCall(node.parent) && node.parent.arguments[1] === node) && str.text.length === searchSymbolName.length;
	            }
	            case 9 /* NumericLiteral */:
	              return isLiteralNameOfPropertyDeclarationOrIndexAccess(node) && node.text.length === searchSymbolName.length;
	            case 90 /* DefaultKeyword */:
	              return "default".length === searchSymbolName.length;
	            default:
	              return false;
	          }
	        }
	        function getAllReferencesForImportMeta(sourceFiles, cancellationToken) {
	          const references = flatMap(sourceFiles, (sourceFile) => {
	            cancellationToken.throwIfCancellationRequested();
	            return mapDefined(getPossibleSymbolReferenceNodes(sourceFile, "meta", sourceFile), (node) => {
	              const parent2 = node.parent;
	              if (isImportMeta(parent2)) {
	                return nodeEntry(parent2);
	              }
	            });
	          });
	          return references.length ? [{ definition: { type: 2 /* Keyword */, node: references[0].node }, references }] : void 0;
	        }
	        function getAllReferencesForKeyword(sourceFiles, keywordKind, cancellationToken, filter2) {
	          const references = flatMap(sourceFiles, (sourceFile) => {
	            cancellationToken.throwIfCancellationRequested();
	            return mapDefined(getPossibleSymbolReferenceNodes(sourceFile, tokenToString(keywordKind), sourceFile), (referenceLocation) => {
	              if (referenceLocation.kind === keywordKind && (!filter2 || filter2(referenceLocation))) {
	                return nodeEntry(referenceLocation);
	              }
	            });
	          });
	          return references.length ? [{ definition: { type: 2 /* Keyword */, node: references[0].node }, references }] : void 0;
	        }
	        function getReferencesInSourceFile(sourceFile, search, state, addReferencesHere = true) {
	          state.cancellationToken.throwIfCancellationRequested();
	          return getReferencesInContainer(sourceFile, sourceFile, search, state, addReferencesHere);
	        }
	        function getReferencesInContainer(container, sourceFile, search, state, addReferencesHere) {
	          if (!state.markSearchedSymbols(sourceFile, search.allSearchSymbols)) {
	            return;
	          }
	          for (const position of getPossibleSymbolReferencePositions(sourceFile, search.text, container)) {
	            getReferencesAtLocation(sourceFile, position, search, state, addReferencesHere);
	          }
	        }
	        function hasMatchingMeaning(referenceLocation, state) {
	          return !!(getMeaningFromLocation(referenceLocation) & state.searchMeaning);
	        }
	        function getReferencesAtLocation(sourceFile, position, search, state, addReferencesHere) {
	          const referenceLocation = getTouchingPropertyName(sourceFile, position);
	          if (!isValidReferencePosition(referenceLocation, search.text)) {
	            if (!state.options.implementations && (state.options.findInStrings && isInString(sourceFile, position) || state.options.findInComments && isInNonReferenceComment(sourceFile, position))) {
	              state.addStringOrCommentReference(sourceFile.fileName, createTextSpan(position, search.text.length));
	            }
	            return;
	          }
	          if (!hasMatchingMeaning(referenceLocation, state))
	            return;
	          let referenceSymbol = state.checker.getSymbolAtLocation(referenceLocation);
	          if (!referenceSymbol) {
	            return;
	          }
	          const parent2 = referenceLocation.parent;
	          if (isImportSpecifier(parent2) && parent2.propertyName === referenceLocation) {
	            return;
	          }
	          if (isExportSpecifier(parent2)) {
	            Debug.assert(referenceLocation.kind === 80 /* Identifier */);
	            getReferencesAtExportSpecifier(referenceLocation, referenceSymbol, parent2, search, state, addReferencesHere);
	            return;
	          }
	          if (isJSDocPropertyLikeTag(parent2) && parent2.isNameFirst && parent2.typeExpression && isJSDocTypeLiteral(parent2.typeExpression.type) && parent2.typeExpression.type.jsDocPropertyTags && length(parent2.typeExpression.type.jsDocPropertyTags)) {
	            getReferencesAtJSDocTypeLiteral(parent2.typeExpression.type.jsDocPropertyTags, referenceLocation, search, state);
	            return;
	          }
	          const relatedSymbol = getRelatedSymbol(search, referenceSymbol, referenceLocation, state);
	          if (!relatedSymbol) {
	            getReferenceForShorthandProperty(referenceSymbol, search, state);
	            return;
	          }
	          switch (state.specialSearchKind) {
	            case 0 /* None */:
	              if (addReferencesHere)
	                addReference(referenceLocation, relatedSymbol, state);
	              break;
	            case 1 /* Constructor */:
	              addConstructorReferences(referenceLocation, sourceFile, search, state);
	              break;
	            case 2 /* Class */:
	              addClassStaticThisReferences(referenceLocation, search, state);
	              break;
	            default:
	              Debug.assertNever(state.specialSearchKind);
	          }
	          if (isInJSFile(referenceLocation) && isBindingElement(referenceLocation.parent) && isVariableDeclarationInitializedToBareOrAccessedRequire(referenceLocation.parent.parent.parent)) {
	            referenceSymbol = referenceLocation.parent.symbol;
	            if (!referenceSymbol)
	              return;
	          }
	          getImportOrExportReferences(referenceLocation, referenceSymbol, search, state);
	        }
	        function getReferencesAtJSDocTypeLiteral(jsDocPropertyTags, referenceLocation, search, state) {
	          const addRef = state.referenceAdder(search.symbol);
	          addReference(referenceLocation, search.symbol, state);
	          forEach(jsDocPropertyTags, (propTag) => {
	            if (isQualifiedName(propTag.name)) {
	              addRef(propTag.name.left);
	            }
	          });
	        }
	        function getReferencesAtExportSpecifier(referenceLocation, referenceSymbol, exportSpecifier, search, state, addReferencesHere, alwaysGetReferences) {
	          Debug.assert(!alwaysGetReferences || !!state.options.providePrefixAndSuffixTextForRename, "If alwaysGetReferences is true, then prefix/suffix text must be enabled");
	          const { parent: parent2, propertyName, name } = exportSpecifier;
	          const exportDeclaration = parent2.parent;
	          const localSymbol = getLocalSymbolForExportSpecifier(referenceLocation, referenceSymbol, exportSpecifier, state.checker);
	          if (!alwaysGetReferences && !search.includes(localSymbol)) {
	            return;
	          }
	          if (!propertyName) {
	            if (!(state.options.use === 2 /* Rename */ && name.escapedText === "default" /* Default */)) {
	              addRef();
	            }
	          } else if (referenceLocation === propertyName) {
	            if (!exportDeclaration.moduleSpecifier) {
	              addRef();
	            }
	            if (addReferencesHere && state.options.use !== 2 /* Rename */ && state.markSeenReExportRHS(name)) {
	              addReference(name, Debug.checkDefined(exportSpecifier.symbol), state);
	            }
	          } else {
	            if (state.markSeenReExportRHS(referenceLocation)) {
	              addRef();
	            }
	          }
	          if (!isForRenameWithPrefixAndSuffixText(state.options) || alwaysGetReferences) {
	            const isDefaultExport = referenceLocation.escapedText === "default" || exportSpecifier.name.escapedText === "default";
	            const exportKind = isDefaultExport ? 1 /* Default */ : 0 /* Named */;
	            const exportSymbol = Debug.checkDefined(exportSpecifier.symbol);
	            const exportInfo = getExportInfo(exportSymbol, exportKind, state.checker);
	            if (exportInfo) {
	              searchForImportsOfExport(referenceLocation, exportSymbol, exportInfo, state);
	            }
	          }
	          if (search.comingFrom !== 1 /* Export */ && exportDeclaration.moduleSpecifier && !propertyName && !isForRenameWithPrefixAndSuffixText(state.options)) {
	            const imported = state.checker.getExportSpecifierLocalTargetSymbol(exportSpecifier);
	            if (imported)
	              searchForImportedSymbol(imported, state);
	          }
	          function addRef() {
	            if (addReferencesHere)
	              addReference(referenceLocation, localSymbol, state);
	          }
	        }
	        function getLocalSymbolForExportSpecifier(referenceLocation, referenceSymbol, exportSpecifier, checker) {
	          return isExportSpecifierAlias(referenceLocation, exportSpecifier) && checker.getExportSpecifierLocalTargetSymbol(exportSpecifier) || referenceSymbol;
	        }
	        function isExportSpecifierAlias(referenceLocation, exportSpecifier) {
	          const { parent: parent2, propertyName, name } = exportSpecifier;
	          Debug.assert(propertyName === referenceLocation || name === referenceLocation);
	          if (propertyName) {
	            return propertyName === referenceLocation;
	          } else {
	            return !parent2.parent.moduleSpecifier;
	          }
	        }
	        function getImportOrExportReferences(referenceLocation, referenceSymbol, search, state) {
	          const importOrExport = getImportOrExportSymbol(referenceLocation, referenceSymbol, state.checker, search.comingFrom === 1 /* Export */);
	          if (!importOrExport)
	            return;
	          const { symbol } = importOrExport;
	          if (importOrExport.kind === 0 /* Import */) {
	            if (!isForRenameWithPrefixAndSuffixText(state.options)) {
	              searchForImportedSymbol(symbol, state);
	            }
	          } else {
	            searchForImportsOfExport(referenceLocation, symbol, importOrExport.exportInfo, state);
	          }
	        }
	        function getReferenceForShorthandProperty({ flags, valueDeclaration }, search, state) {
	          const shorthandValueSymbol = state.checker.getShorthandAssignmentValueSymbol(valueDeclaration);
	          const name = valueDeclaration && getNameOfDeclaration(valueDeclaration);
	          if (!(flags & 33554432 /* Transient */) && name && search.includes(shorthandValueSymbol)) {
	            addReference(name, shorthandValueSymbol, state);
	          }
	        }
	        function addReference(referenceLocation, relatedSymbol, state) {
	          const { kind, symbol } = "kind" in relatedSymbol ? relatedSymbol : { kind: void 0, symbol: relatedSymbol };
	          if (state.options.use === 2 /* Rename */ && referenceLocation.kind === 90 /* DefaultKeyword */) {
	            return;
	          }
	          const addRef = state.referenceAdder(symbol);
	          if (state.options.implementations) {
	            addImplementationReferences(referenceLocation, addRef, state);
	          } else {
	            addRef(referenceLocation, kind);
	          }
	        }
	        function addConstructorReferences(referenceLocation, sourceFile, search, state) {
	          if (isNewExpressionTarget(referenceLocation)) {
	            addReference(referenceLocation, search.symbol, state);
	          }
	          const pusher = () => state.referenceAdder(search.symbol);
	          if (isClassLike(referenceLocation.parent)) {
	            Debug.assert(referenceLocation.kind === 90 /* DefaultKeyword */ || referenceLocation.parent.name === referenceLocation);
	            findOwnConstructorReferences(search.symbol, sourceFile, pusher());
	          } else {
	            const classExtending = tryGetClassByExtendingIdentifier(referenceLocation);
	            if (classExtending) {
	              findSuperConstructorAccesses(classExtending, pusher());
	              findInheritedConstructorReferences(classExtending, state);
	            }
	          }
	        }
	        function addClassStaticThisReferences(referenceLocation, search, state) {
	          addReference(referenceLocation, search.symbol, state);
	          const classLike = referenceLocation.parent;
	          if (state.options.use === 2 /* Rename */ || !isClassLike(classLike))
	            return;
	          Debug.assert(classLike.name === referenceLocation);
	          const addRef = state.referenceAdder(search.symbol);
	          for (const member of classLike.members) {
	            if (!(isMethodOrAccessor(member) && isStatic(member))) {
	              continue;
	            }
	            if (member.body) {
	              member.body.forEachChild(function cb(node) {
	                if (node.kind === 110 /* ThisKeyword */) {
	                  addRef(node);
	                } else if (!isFunctionLike(node) && !isClassLike(node)) {
	                  node.forEachChild(cb);
	                }
	              });
	            }
	          }
	        }
	        function findOwnConstructorReferences(classSymbol, sourceFile, addNode) {
	          const constructorSymbol = getClassConstructorSymbol(classSymbol);
	          if (constructorSymbol && constructorSymbol.declarations) {
	            for (const decl of constructorSymbol.declarations) {
	              const ctrKeyword = findChildOfKind(decl, 137 /* ConstructorKeyword */, sourceFile);
	              Debug.assert(decl.kind === 176 /* Constructor */ && !!ctrKeyword);
	              addNode(ctrKeyword);
	            }
	          }
	          if (classSymbol.exports) {
	            classSymbol.exports.forEach((member) => {
	              const decl = member.valueDeclaration;
	              if (decl && decl.kind === 174 /* MethodDeclaration */) {
	                const body = decl.body;
	                if (body) {
	                  forEachDescendantOfKind(body, 110 /* ThisKeyword */, (thisKeyword) => {
	                    if (isNewExpressionTarget(thisKeyword)) {
	                      addNode(thisKeyword);
	                    }
	                  });
	                }
	              }
	            });
	          }
	        }
	        function getClassConstructorSymbol(classSymbol) {
	          return classSymbol.members && classSymbol.members.get("__constructor" /* Constructor */);
	        }
	        function findSuperConstructorAccesses(classDeclaration, addNode) {
	          const constructor = getClassConstructorSymbol(classDeclaration.symbol);
	          if (!(constructor && constructor.declarations)) {
	            return;
	          }
	          for (const decl of constructor.declarations) {
	            Debug.assert(decl.kind === 176 /* Constructor */);
	            const body = decl.body;
	            if (body) {
	              forEachDescendantOfKind(body, 108 /* SuperKeyword */, (node) => {
	                if (isCallExpressionTarget(node)) {
	                  addNode(node);
	                }
	              });
	            }
	          }
	        }
	        function hasOwnConstructor(classDeclaration) {
	          return !!getClassConstructorSymbol(classDeclaration.symbol);
	        }
	        function findInheritedConstructorReferences(classDeclaration, state) {
	          if (hasOwnConstructor(classDeclaration))
	            return;
	          const classSymbol = classDeclaration.symbol;
	          const search = state.createSearch(
	            /*location*/
	            void 0,
	            classSymbol,
	            /*comingFrom*/
	            void 0
	          );
	          getReferencesInContainerOrFiles(classSymbol, state, search);
	        }
	        function addImplementationReferences(refNode, addReference2, state) {
	          if (isDeclarationName(refNode) && isImplementation(refNode.parent)) {
	            addReference2(refNode);
	            return;
	          }
	          if (refNode.kind !== 80 /* Identifier */) {
	            return;
	          }
	          if (refNode.parent.kind === 304 /* ShorthandPropertyAssignment */) {
	            getReferenceEntriesForShorthandPropertyAssignment(refNode, state.checker, addReference2);
	          }
	          const containingNode = getContainingNodeIfInHeritageClause(refNode);
	          if (containingNode) {
	            addReference2(containingNode);
	            return;
	          }
	          const typeNode = findAncestor(refNode, (a) => !isQualifiedName(a.parent) && !isTypeNode(a.parent) && !isTypeElement(a.parent));
	          const typeHavingNode = typeNode.parent;
	          if (hasType(typeHavingNode) && typeHavingNode.type === typeNode && state.markSeenContainingTypeReference(typeHavingNode)) {
	            if (hasInitializer(typeHavingNode)) {
	              addIfImplementation(typeHavingNode.initializer);
	            } else if (isFunctionLike(typeHavingNode) && typeHavingNode.body) {
	              const body = typeHavingNode.body;
	              if (body.kind === 241 /* Block */) {
	                forEachReturnStatement(body, (returnStatement) => {
	                  if (returnStatement.expression)
	                    addIfImplementation(returnStatement.expression);
	                });
	              } else {
	                addIfImplementation(body);
	              }
	            } else if (isAssertionExpression(typeHavingNode)) {
	              addIfImplementation(typeHavingNode.expression);
	            }
	          }
	          function addIfImplementation(e) {
	            if (isImplementationExpression(e))
	              addReference2(e);
	          }
	        }
	        function getContainingNodeIfInHeritageClause(node) {
	          return isIdentifier(node) || isPropertyAccessExpression(node) ? getContainingNodeIfInHeritageClause(node.parent) : isExpressionWithTypeArguments(node) ? tryCast(node.parent.parent, or(isClassLike, isInterfaceDeclaration)) : void 0;
	        }
	        function isImplementationExpression(node) {
	          switch (node.kind) {
	            case 217 /* ParenthesizedExpression */:
	              return isImplementationExpression(node.expression);
	            case 219 /* ArrowFunction */:
	            case 218 /* FunctionExpression */:
	            case 210 /* ObjectLiteralExpression */:
	            case 231 /* ClassExpression */:
	            case 209 /* ArrayLiteralExpression */:
	              return true;
	            default:
	              return false;
	          }
	        }
	        function explicitlyInheritsFrom(symbol, parent2, cachedResults, checker) {
	          if (symbol === parent2) {
	            return true;
	          }
	          const key = getSymbolId(symbol) + "," + getSymbolId(parent2);
	          const cached = cachedResults.get(key);
	          if (cached !== void 0) {
	            return cached;
	          }
	          cachedResults.set(key, false);
	          const inherits = !!symbol.declarations && symbol.declarations.some(
	            (declaration) => getAllSuperTypeNodes(declaration).some((typeReference) => {
	              const type = checker.getTypeAtLocation(typeReference);
	              return !!type && !!type.symbol && explicitlyInheritsFrom(type.symbol, parent2, cachedResults, checker);
	            })
	          );
	          cachedResults.set(key, inherits);
	          return inherits;
	        }
	        function getReferencesForSuperKeyword(superKeyword) {
	          let searchSpaceNode = getSuperContainer(
	            superKeyword,
	            /*stopOnFunctions*/
	            false
	          );
	          if (!searchSpaceNode) {
	            return void 0;
	          }
	          let staticFlag = 256 /* Static */;
	          switch (searchSpaceNode.kind) {
	            case 172 /* PropertyDeclaration */:
	            case 171 /* PropertySignature */:
	            case 174 /* MethodDeclaration */:
	            case 173 /* MethodSignature */:
	            case 176 /* Constructor */:
	            case 177 /* GetAccessor */:
	            case 178 /* SetAccessor */:
	              staticFlag &= getSyntacticModifierFlags(searchSpaceNode);
	              searchSpaceNode = searchSpaceNode.parent;
	              break;
	            default:
	              return void 0;
	          }
	          const sourceFile = searchSpaceNode.getSourceFile();
	          const references = mapDefined(getPossibleSymbolReferenceNodes(sourceFile, "super", searchSpaceNode), (node) => {
	            if (node.kind !== 108 /* SuperKeyword */) {
	              return;
	            }
	            const container = getSuperContainer(
	              node,
	              /*stopOnFunctions*/
	              false
	            );
	            return container && isStatic(container) === !!staticFlag && container.parent.symbol === searchSpaceNode.symbol ? nodeEntry(node) : void 0;
	          });
	          return [{ definition: { type: 0 /* Symbol */, symbol: searchSpaceNode.symbol }, references }];
	        }
	        function isParameterName(node) {
	          return node.kind === 80 /* Identifier */ && node.parent.kind === 169 /* Parameter */ && node.parent.name === node;
	        }
	        function getReferencesForThisKeyword(thisOrSuperKeyword, sourceFiles, cancellationToken) {
	          let searchSpaceNode = getThisContainer(
	            thisOrSuperKeyword,
	            /*includeArrowFunctions*/
	            false,
	            /*includeClassComputedPropertyName*/
	            false
	          );
	          let staticFlag = 256 /* Static */;
	          switch (searchSpaceNode.kind) {
	            case 174 /* MethodDeclaration */:
	            case 173 /* MethodSignature */:
	              if (isObjectLiteralMethod(searchSpaceNode)) {
	                staticFlag &= getSyntacticModifierFlags(searchSpaceNode);
	                searchSpaceNode = searchSpaceNode.parent;
	                break;
	              }
	            case 172 /* PropertyDeclaration */:
	            case 171 /* PropertySignature */:
	            case 176 /* Constructor */:
	            case 177 /* GetAccessor */:
	            case 178 /* SetAccessor */:
	              staticFlag &= getSyntacticModifierFlags(searchSpaceNode);
	              searchSpaceNode = searchSpaceNode.parent;
	              break;
	            case 312 /* SourceFile */:
	              if (isExternalModule(searchSpaceNode) || isParameterName(thisOrSuperKeyword)) {
	                return void 0;
	              }
	            case 262 /* FunctionDeclaration */:
	            case 218 /* FunctionExpression */:
	              break;
	            default:
	              return void 0;
	          }
	          const references = flatMap(searchSpaceNode.kind === 312 /* SourceFile */ ? sourceFiles : [searchSpaceNode.getSourceFile()], (sourceFile) => {
	            cancellationToken.throwIfCancellationRequested();
	            return getPossibleSymbolReferenceNodes(sourceFile, "this", isSourceFile(searchSpaceNode) ? sourceFile : searchSpaceNode).filter((node) => {
	              if (!isThis(node)) {
	                return false;
	              }
	              const container = getThisContainer(
	                node,
	                /*includeArrowFunctions*/
	                false,
	                /*includeClassComputedPropertyName*/
	                false
	              );
	              if (!canHaveSymbol(container))
	                return false;
	              switch (searchSpaceNode.kind) {
	                case 218 /* FunctionExpression */:
	                case 262 /* FunctionDeclaration */:
	                  return searchSpaceNode.symbol === container.symbol;
	                case 174 /* MethodDeclaration */:
	                case 173 /* MethodSignature */:
	                  return isObjectLiteralMethod(searchSpaceNode) && searchSpaceNode.symbol === container.symbol;
	                case 231 /* ClassExpression */:
	                case 263 /* ClassDeclaration */:
	                case 210 /* ObjectLiteralExpression */:
	                  return container.parent && canHaveSymbol(container.parent) && searchSpaceNode.symbol === container.parent.symbol && isStatic(container) === !!staticFlag;
	                case 312 /* SourceFile */:
	                  return container.kind === 312 /* SourceFile */ && !isExternalModule(container) && !isParameterName(node);
	              }
	            });
	          }).map((n) => nodeEntry(n));
	          const thisParameter = firstDefined(references, (r) => isParameter(r.node.parent) ? r.node : void 0);
	          return [{
	            definition: { type: 3 /* This */, node: thisParameter || thisOrSuperKeyword },
	            references
	          }];
	        }
	        function getReferencesForStringLiteral(node, sourceFiles, checker, cancellationToken) {
	          const type = getContextualTypeFromParentOrAncestorTypeNode(node, checker);
	          const references = flatMap(sourceFiles, (sourceFile) => {
	            cancellationToken.throwIfCancellationRequested();
	            return mapDefined(getPossibleSymbolReferenceNodes(sourceFile, node.text), (ref) => {
	              if (isStringLiteralLike(ref) && ref.text === node.text) {
	                if (type) {
	                  const refType = getContextualTypeFromParentOrAncestorTypeNode(ref, checker);
	                  if (type !== checker.getStringType() && (type === refType || isStringLiteralPropertyReference(ref, checker))) {
	                    return nodeEntry(ref, 2 /* StringLiteral */);
	                  }
	                } else {
	                  return isNoSubstitutionTemplateLiteral(ref) && !rangeIsOnSingleLine(ref, sourceFile) ? void 0 : nodeEntry(ref, 2 /* StringLiteral */);
	                }
	              }
	            });
	          });
	          return [{
	            definition: { type: 4 /* String */, node },
	            references
	          }];
	        }
	        function isStringLiteralPropertyReference(node, checker) {
	          if (isPropertySignature(node.parent)) {
	            return checker.getPropertyOfType(checker.getTypeAtLocation(node.parent.parent), node.text);
	          }
	        }
	        function populateSearchSymbolSet(symbol, location, checker, isForRename, providePrefixAndSuffixText, implementations) {
	          const result = [];
	          forEachRelatedSymbol(
	            symbol,
	            location,
	            checker,
	            isForRename,
	            !(isForRename && providePrefixAndSuffixText),
	            (sym, root, base) => {
	              if (base) {
	                if (isStaticSymbol(symbol) !== isStaticSymbol(base)) {
	                  base = void 0;
	                }
	              }
	              result.push(base || root || sym);
	            },
	            // when try to find implementation, implementations is true, and not allowed to find base class
	            /*allowBaseTypes*/
	            () => !implementations
	          );
	          return result;
	        }
	        function forEachRelatedSymbol(symbol, location, checker, isForRenamePopulateSearchSymbolSet, onlyIncludeBindingElementAtReferenceLocation, cbSymbol, allowBaseTypes) {
	          const containingObjectLiteralElement = getContainingObjectLiteralElement(location);
	          if (containingObjectLiteralElement) {
	            const shorthandValueSymbol = checker.getShorthandAssignmentValueSymbol(location.parent);
	            if (shorthandValueSymbol && isForRenamePopulateSearchSymbolSet) {
	              return cbSymbol(
	                shorthandValueSymbol,
	                /*rootSymbol*/
	                void 0,
	                /*baseSymbol*/
	                void 0,
	                3 /* SearchedLocalFoundProperty */
	              );
	            }
	            const contextualType = checker.getContextualType(containingObjectLiteralElement.parent);
	            const res2 = contextualType && firstDefined(
	              getPropertySymbolsFromContextualType(
	                containingObjectLiteralElement,
	                checker,
	                contextualType,
	                /*unionSymbolOk*/
	                true
	              ),
	              (sym) => fromRoot(sym, 4 /* SearchedPropertyFoundLocal */)
	            );
	            if (res2)
	              return res2;
	            const propertySymbol = getPropertySymbolOfDestructuringAssignment(location, checker);
	            const res1 = propertySymbol && cbSymbol(
	              propertySymbol,
	              /*rootSymbol*/
	              void 0,
	              /*baseSymbol*/
	              void 0,
	              4 /* SearchedPropertyFoundLocal */
	            );
	            if (res1)
	              return res1;
	            const res22 = shorthandValueSymbol && cbSymbol(
	              shorthandValueSymbol,
	              /*rootSymbol*/
	              void 0,
	              /*baseSymbol*/
	              void 0,
	              3 /* SearchedLocalFoundProperty */
	            );
	            if (res22)
	              return res22;
	          }
	          const aliasedSymbol = getMergedAliasedSymbolOfNamespaceExportDeclaration(location, symbol, checker);
	          if (aliasedSymbol) {
	            const res2 = cbSymbol(
	              aliasedSymbol,
	              /*rootSymbol*/
	              void 0,
	              /*baseSymbol*/
	              void 0,
	              1 /* Node */
	            );
	            if (res2)
	              return res2;
	          }
	          const res = fromRoot(symbol);
	          if (res)
	            return res;
	          if (symbol.valueDeclaration && isParameterPropertyDeclaration(symbol.valueDeclaration, symbol.valueDeclaration.parent)) {
	            const paramProps = checker.getSymbolsOfParameterPropertyDeclaration(cast(symbol.valueDeclaration, isParameter), symbol.name);
	            Debug.assert(paramProps.length === 2 && !!(paramProps[0].flags & 1 /* FunctionScopedVariable */) && !!(paramProps[1].flags & 4 /* Property */));
	            return fromRoot(symbol.flags & 1 /* FunctionScopedVariable */ ? paramProps[1] : paramProps[0]);
	          }
	          const exportSpecifier = getDeclarationOfKind(symbol, 281 /* ExportSpecifier */);
	          if (!isForRenamePopulateSearchSymbolSet || exportSpecifier && !exportSpecifier.propertyName) {
	            const localSymbol = exportSpecifier && checker.getExportSpecifierLocalTargetSymbol(exportSpecifier);
	            if (localSymbol) {
	              const res2 = cbSymbol(
	                localSymbol,
	                /*rootSymbol*/
	                void 0,
	                /*baseSymbol*/
	                void 0,
	                1 /* Node */
	              );
	              if (res2)
	                return res2;
	            }
	          }
	          if (!isForRenamePopulateSearchSymbolSet) {
	            let bindingElementPropertySymbol;
	            if (onlyIncludeBindingElementAtReferenceLocation) {
	              bindingElementPropertySymbol = isObjectBindingElementWithoutPropertyName(location.parent) ? getPropertySymbolFromBindingElement(checker, location.parent) : void 0;
	            } else {
	              bindingElementPropertySymbol = getPropertySymbolOfObjectBindingPatternWithoutPropertyName(symbol, checker);
	            }
	            return bindingElementPropertySymbol && fromRoot(bindingElementPropertySymbol, 4 /* SearchedPropertyFoundLocal */);
	          }
	          Debug.assert(isForRenamePopulateSearchSymbolSet);
	          const includeOriginalSymbolOfBindingElement = onlyIncludeBindingElementAtReferenceLocation;
	          if (includeOriginalSymbolOfBindingElement) {
	            const bindingElementPropertySymbol = getPropertySymbolOfObjectBindingPatternWithoutPropertyName(symbol, checker);
	            return bindingElementPropertySymbol && fromRoot(bindingElementPropertySymbol, 4 /* SearchedPropertyFoundLocal */);
	          }
	          function fromRoot(sym, kind) {
	            return firstDefined(checker.getRootSymbols(sym), (rootSymbol) => cbSymbol(
	              sym,
	              rootSymbol,
	              /*baseSymbol*/
	              void 0,
	              kind
	            ) || (rootSymbol.parent && rootSymbol.parent.flags & (32 /* Class */ | 64 /* Interface */) && allowBaseTypes(rootSymbol) ? getPropertySymbolsFromBaseTypes(rootSymbol.parent, rootSymbol.name, checker, (base) => cbSymbol(sym, rootSymbol, base, kind)) : void 0));
	          }
	          function getPropertySymbolOfObjectBindingPatternWithoutPropertyName(symbol2, checker2) {
	            const bindingElement = getDeclarationOfKind(symbol2, 208 /* BindingElement */);
	            if (bindingElement && isObjectBindingElementWithoutPropertyName(bindingElement)) {
	              return getPropertySymbolFromBindingElement(checker2, bindingElement);
	            }
	          }
	        }
	        function getPropertySymbolsFromBaseTypes(symbol, propertyName, checker, cb) {
	          const seen = /* @__PURE__ */ new Map();
	          return recur(symbol);
	          function recur(symbol2) {
	            if (!(symbol2.flags & (32 /* Class */ | 64 /* Interface */)) || !addToSeen(seen, getSymbolId(symbol2)))
	              return;
	            return firstDefined(symbol2.declarations, (declaration) => firstDefined(getAllSuperTypeNodes(declaration), (typeReference) => {
	              const type = checker.getTypeAtLocation(typeReference);
	              const propertySymbol = type && type.symbol && checker.getPropertyOfType(type, propertyName);
	              return type && propertySymbol && (firstDefined(checker.getRootSymbols(propertySymbol), cb) || recur(type.symbol));
	            }));
	          }
	        }
	        function isStaticSymbol(symbol) {
	          if (!symbol.valueDeclaration)
	            return false;
	          const modifierFlags = getEffectiveModifierFlags(symbol.valueDeclaration);
	          return !!(modifierFlags & 256 /* Static */);
	        }
	        function getRelatedSymbol(search, referenceSymbol, referenceLocation, state) {
	          const { checker } = state;
	          return forEachRelatedSymbol(
	            referenceSymbol,
	            referenceLocation,
	            checker,
	            /*isForRenamePopulateSearchSymbolSet*/
	            false,
	            /*onlyIncludeBindingElementAtReferenceLocation*/
	            state.options.use !== 2 /* Rename */ || !!state.options.providePrefixAndSuffixTextForRename,
	            (sym, rootSymbol, baseSymbol, kind) => {
	              if (baseSymbol) {
	                if (isStaticSymbol(referenceSymbol) !== isStaticSymbol(baseSymbol)) {
	                  baseSymbol = void 0;
	                }
	              }
	              return search.includes(baseSymbol || rootSymbol || sym) ? { symbol: rootSymbol && !(getCheckFlags(sym) & 6 /* Synthetic */) ? rootSymbol : sym, kind } : void 0;
	            },
	            /*allowBaseTypes*/
	            (rootSymbol) => !(search.parents && !search.parents.some((parent2) => explicitlyInheritsFrom(rootSymbol.parent, parent2, state.inheritsFromCache, checker)))
	          );
	        }
	        function getIntersectingMeaningFromDeclarations(node, symbol) {
	          let meaning = getMeaningFromLocation(node);
	          const { declarations } = symbol;
	          if (declarations) {
	            let lastIterationMeaning;
	            do {
	              lastIterationMeaning = meaning;
	              for (const declaration of declarations) {
	                const declarationMeaning = getMeaningFromDeclaration(declaration);
	                if (declarationMeaning & meaning) {
	                  meaning |= declarationMeaning;
	                }
	              }
	            } while (meaning !== lastIterationMeaning);
	          }
	          return meaning;
	        }
	        Core2.getIntersectingMeaningFromDeclarations = getIntersectingMeaningFromDeclarations;
	        function isImplementation(node) {
	          return !!(node.flags & 33554432 /* Ambient */) ? !(isInterfaceDeclaration(node) || isTypeAliasDeclaration(node)) : isVariableLike(node) ? hasInitializer(node) : isFunctionLikeDeclaration(node) ? !!node.body : isClassLike(node) || isModuleOrEnumDeclaration(node);
	        }
	        function getReferenceEntriesForShorthandPropertyAssignment(node, checker, addReference2) {
	          const refSymbol = checker.getSymbolAtLocation(node);
	          const shorthandSymbol = checker.getShorthandAssignmentValueSymbol(refSymbol.valueDeclaration);
	          if (shorthandSymbol) {
	            for (const declaration of shorthandSymbol.getDeclarations()) {
	              if (getMeaningFromDeclaration(declaration) & 1 /* Value */) {
	                addReference2(declaration);
	              }
	            }
	          }
	        }
	        Core2.getReferenceEntriesForShorthandPropertyAssignment = getReferenceEntriesForShorthandPropertyAssignment;
	        function forEachDescendantOfKind(node, kind, action) {
	          forEachChild(node, (child) => {
	            if (child.kind === kind) {
	              action(child);
	            }
	            forEachDescendantOfKind(child, kind, action);
	          });
	        }
	        function tryGetClassByExtendingIdentifier(node) {
	          return tryGetClassExtendingExpressionWithTypeArguments(climbPastPropertyAccess(node).parent);
	        }
	        function getParentSymbolsOfPropertyAccess(location, symbol, checker) {
	          const propertyAccessExpression = isRightSideOfPropertyAccess(location) ? location.parent : void 0;
	          const lhsType = propertyAccessExpression && checker.getTypeAtLocation(propertyAccessExpression.expression);
	          const res = mapDefined(lhsType && (lhsType.isUnionOrIntersection() ? lhsType.types : lhsType.symbol === symbol.parent ? void 0 : [lhsType]), (t) => t.symbol && t.symbol.flags & (32 /* Class */ | 64 /* Interface */) ? t.symbol : void 0);
	          return res.length === 0 ? void 0 : res;
	        }
	        function isForRenameWithPrefixAndSuffixText(options) {
	          return options.use === 2 /* Rename */ && options.providePrefixAndSuffixTextForRename;
	        }
	      })(Core || (Core = {}));
	    }
	  });

	  // src/services/_namespaces/ts.FindAllReferences.ts
	  var ts_FindAllReferences_exports = {};
	  __export(ts_FindAllReferences_exports, {
	    Core: () => Core,
	    DefinitionKind: () => DefinitionKind,
	    EntryKind: () => EntryKind,
	    ExportKind: () => ExportKind2,
	    FindReferencesUse: () => FindReferencesUse,
	    ImportExport: () => ImportExport,
	    createImportTracker: () => createImportTracker,
	    findModuleReferences: () => findModuleReferences,
	    findReferenceOrRenameEntries: () => findReferenceOrRenameEntries,
	    findReferencedSymbols: () => findReferencedSymbols,
	    getContextNode: () => getContextNode,
	    getExportInfo: () => getExportInfo,
	    getImplementationsAtPosition: () => getImplementationsAtPosition,
	    getImportOrExportSymbol: () => getImportOrExportSymbol,
	    getReferenceEntriesForNode: () => getReferenceEntriesForNode,
	    getTextSpanOfEntry: () => getTextSpanOfEntry,
	    isContextWithStartAndEndNode: () => isContextWithStartAndEndNode,
	    isDeclarationOfSymbol: () => isDeclarationOfSymbol,
	    isWriteAccessForReference: () => isWriteAccessForReference,
	    nodeEntry: () => nodeEntry,
	    toContextSpan: () => toContextSpan,
	    toHighlightSpan: () => toHighlightSpan,
	    toReferenceEntry: () => toReferenceEntry,
	    toRenameLocation: () => toRenameLocation
	  });
	  var init_ts_FindAllReferences = __esm({
	    "src/services/_namespaces/ts.FindAllReferences.ts"() {
	      init_importTracker();
	      init_findAllReferences();
	    }
	  });

	  // src/services/goToDefinition.ts
	  function getDefinitionAtPosition(program, sourceFile, position, searchOtherFilesOnly, stopAtAlias) {
	    var _a;
	    const resolvedRef = getReferenceAtPosition(sourceFile, position, program);
	    const fileReferenceDefinition = resolvedRef && [getDefinitionInfoForFileReference(resolvedRef.reference.fileName, resolvedRef.fileName, resolvedRef.unverified)] || emptyArray;
	    if (resolvedRef == null ? void 0 : resolvedRef.file) {
	      return fileReferenceDefinition;
	    }
	    const node = getTouchingPropertyName(sourceFile, position);
	    if (node === sourceFile) {
	      return void 0;
	    }
	    const { parent: parent2 } = node;
	    const typeChecker = program.getTypeChecker();
	    if (node.kind === 164 /* OverrideKeyword */ || isIdentifier(node) && isJSDocOverrideTag(parent2) && parent2.tagName === node) {
	      return getDefinitionFromOverriddenMember(typeChecker, node) || emptyArray;
	    }
	    if (isJumpStatementTarget(node)) {
	      const label = getTargetLabel(node.parent, node.text);
	      return label ? [createDefinitionInfoFromName(
	        typeChecker,
	        label,
	        "label" /* label */,
	        node.text,
	        /*containerName*/
	        void 0
	      )] : void 0;
	    }
	    switch (node.kind) {
	      case 107 /* ReturnKeyword */:
	        const functionDeclaration = findAncestor(node.parent, (n) => isClassStaticBlockDeclaration(n) ? "quit" : isFunctionLikeDeclaration(n));
	        return functionDeclaration ? [createDefinitionFromSignatureDeclaration(typeChecker, functionDeclaration)] : void 0;
	      case 90 /* DefaultKeyword */:
	        if (!isDefaultClause(node.parent)) {
	          break;
	        }
	      case 84 /* CaseKeyword */:
	        const switchStatement = findAncestor(node.parent, isSwitchStatement);
	        if (switchStatement) {
	          return [createDefinitionInfoFromSwitch(switchStatement, sourceFile)];
	        }
	        break;
	    }
	    if (node.kind === 135 /* AwaitKeyword */) {
	      const functionDeclaration = findAncestor(node, (n) => isFunctionLikeDeclaration(n));
	      const isAsyncFunction2 = functionDeclaration && some(functionDeclaration.modifiers, (node2) => node2.kind === 134 /* AsyncKeyword */);
	      return isAsyncFunction2 ? [createDefinitionFromSignatureDeclaration(typeChecker, functionDeclaration)] : void 0;
	    }
	    if (node.kind === 127 /* YieldKeyword */) {
	      const functionDeclaration = findAncestor(node, (n) => isFunctionLikeDeclaration(n));
	      const isGeneratorFunction = functionDeclaration && functionDeclaration.asteriskToken;
	      return isGeneratorFunction ? [createDefinitionFromSignatureDeclaration(typeChecker, functionDeclaration)] : void 0;
	    }
	    if (isStaticModifier(node) && isClassStaticBlockDeclaration(node.parent)) {
	      const classDecl = node.parent.parent;
	      const { symbol: symbol2, failedAliasResolution: failedAliasResolution2 } = getSymbol(classDecl, typeChecker, stopAtAlias);
	      const staticBlocks = filter(classDecl.members, isClassStaticBlockDeclaration);
	      const containerName = symbol2 ? typeChecker.symbolToString(symbol2, classDecl) : "";
	      const sourceFile2 = node.getSourceFile();
	      return map(staticBlocks, (staticBlock) => {
	        let { pos } = moveRangePastModifiers(staticBlock);
	        pos = skipTrivia(sourceFile2.text, pos);
	        return createDefinitionInfoFromName(
	          typeChecker,
	          staticBlock,
	          "constructor" /* constructorImplementationElement */,
	          "static {}",
	          containerName,
	          /*unverified*/
	          false,
	          failedAliasResolution2,
	          { start: pos, length: "static".length }
	        );
	      });
	    }
	    let { symbol, failedAliasResolution } = getSymbol(node, typeChecker, stopAtAlias);
	    let fallbackNode = node;
	    if (searchOtherFilesOnly && failedAliasResolution) {
	      const importDeclaration = forEach([node, ...(symbol == null ? void 0 : symbol.declarations) || emptyArray], (n) => findAncestor(n, isAnyImportOrBareOrAccessedRequire));
	      const moduleSpecifier = importDeclaration && tryGetModuleSpecifierFromDeclaration(importDeclaration);
	      if (moduleSpecifier) {
	        ({ symbol, failedAliasResolution } = getSymbol(moduleSpecifier, typeChecker, stopAtAlias));
	        fallbackNode = moduleSpecifier;
	      }
	    }
	    if (!symbol && isModuleSpecifierLike(fallbackNode)) {
	      const ref = (_a = program.getResolvedModuleFromModuleSpecifier(fallbackNode)) == null ? void 0 : _a.resolvedModule;
	      if (ref) {
	        return [{
	          name: fallbackNode.text,
	          fileName: ref.resolvedFileName,
	          containerName: void 0,
	          containerKind: void 0,
	          kind: "script" /* scriptElement */,
	          textSpan: createTextSpan(0, 0),
	          failedAliasResolution,
	          isAmbient: isDeclarationFileName(ref.resolvedFileName),
	          unverified: fallbackNode !== node
	        }];
	      }
	    }
	    if (!symbol) {
	      return concatenate(fileReferenceDefinition, getDefinitionInfoForIndexSignatures(node, typeChecker));
	    }
	    if (searchOtherFilesOnly && every(symbol.declarations, (d) => d.getSourceFile().fileName === sourceFile.fileName))
	      return void 0;
	    const calledDeclaration = tryGetSignatureDeclaration(typeChecker, node);
	    if (calledDeclaration && !(isJsxOpeningLikeElement(node.parent) && isConstructorLike(calledDeclaration))) {
	      const sigInfo = createDefinitionFromSignatureDeclaration(typeChecker, calledDeclaration, failedAliasResolution);
	      if (typeChecker.getRootSymbols(symbol).some((s) => symbolMatchesSignature(s, calledDeclaration))) {
	        return [sigInfo];
	      } else {
	        const defs = getDefinitionFromSymbol(typeChecker, symbol, node, failedAliasResolution, calledDeclaration) || emptyArray;
	        return node.kind === 108 /* SuperKeyword */ ? [sigInfo, ...defs] : [...defs, sigInfo];
	      }
	    }
	    if (node.parent.kind === 304 /* ShorthandPropertyAssignment */) {
	      const shorthandSymbol = typeChecker.getShorthandAssignmentValueSymbol(symbol.valueDeclaration);
	      const definitions = (shorthandSymbol == null ? void 0 : shorthandSymbol.declarations) ? shorthandSymbol.declarations.map((decl) => createDefinitionInfo(
	        decl,
	        typeChecker,
	        shorthandSymbol,
	        node,
	        /*unverified*/
	        false,
	        failedAliasResolution
	      )) : emptyArray;
	      return concatenate(definitions, getDefinitionFromObjectLiteralElement(typeChecker, node));
	    }
	    if (isPropertyName(node) && isBindingElement(parent2) && isObjectBindingPattern(parent2.parent) && node === (parent2.propertyName || parent2.name)) {
	      const name = getNameFromPropertyName(node);
	      const type = typeChecker.getTypeAtLocation(parent2.parent);
	      return name === void 0 ? emptyArray : flatMap(type.isUnion() ? type.types : [type], (t) => {
	        const prop = t.getProperty(name);
	        return prop && getDefinitionFromSymbol(typeChecker, prop, node);
	      });
	    }
	    const objectLiteralElementDefinition = getDefinitionFromObjectLiteralElement(typeChecker, node);
	    return concatenate(fileReferenceDefinition, objectLiteralElementDefinition.length ? objectLiteralElementDefinition : getDefinitionFromSymbol(typeChecker, symbol, node, failedAliasResolution));
	  }
	  function symbolMatchesSignature(s, calledDeclaration) {
	    var _a;
	    return s === calledDeclaration.symbol || s === calledDeclaration.symbol.parent || isAssignmentExpression(calledDeclaration.parent) || !isCallLikeExpression(calledDeclaration.parent) && s === ((_a = tryCast(calledDeclaration.parent, canHaveSymbol)) == null ? void 0 : _a.symbol);
	  }
	  function getDefinitionFromObjectLiteralElement(typeChecker, node) {
	    const element = getContainingObjectLiteralElement(node);
	    if (element) {
	      const contextualType = element && typeChecker.getContextualType(element.parent);
	      if (contextualType) {
	        return flatMap(getPropertySymbolsFromContextualType(
	          element,
	          typeChecker,
	          contextualType,
	          /*unionSymbolOk*/
	          false
	        ), (propertySymbol) => getDefinitionFromSymbol(typeChecker, propertySymbol, node));
	      }
	    }
	    return emptyArray;
	  }
	  function getDefinitionFromOverriddenMember(typeChecker, node) {
	    const classElement = findAncestor(node, isClassElement);
	    if (!(classElement && classElement.name))
	      return;
	    const baseDeclaration = findAncestor(classElement, isClassLike);
	    if (!baseDeclaration)
	      return;
	    const baseTypeNode = getEffectiveBaseTypeNode(baseDeclaration);
	    if (!baseTypeNode)
	      return;
	    const expression = skipParentheses(baseTypeNode.expression);
	    const base = isClassExpression(expression) ? expression.symbol : typeChecker.getSymbolAtLocation(expression);
	    if (!base)
	      return;
	    const name = unescapeLeadingUnderscores(getTextOfPropertyName(classElement.name));
	    const symbol = hasStaticModifier(classElement) ? typeChecker.getPropertyOfType(typeChecker.getTypeOfSymbol(base), name) : typeChecker.getPropertyOfType(typeChecker.getDeclaredTypeOfSymbol(base), name);
	    if (!symbol)
	      return;
	    return getDefinitionFromSymbol(typeChecker, symbol, node);
	  }
	  function getReferenceAtPosition(sourceFile, position, program) {
	    var _a, _b;
	    const referencePath = findReferenceInPosition(sourceFile.referencedFiles, position);
	    if (referencePath) {
	      const file = program.getSourceFileFromReference(sourceFile, referencePath);
	      return file && { reference: referencePath, fileName: file.fileName, file, unverified: false };
	    }
	    const typeReferenceDirective = findReferenceInPosition(sourceFile.typeReferenceDirectives, position);
	    if (typeReferenceDirective) {
	      const reference = (_a = program.getResolvedTypeReferenceDirectives().get(typeReferenceDirective.fileName, typeReferenceDirective.resolutionMode || sourceFile.impliedNodeFormat)) == null ? void 0 : _a.resolvedTypeReferenceDirective;
	      const file = reference && program.getSourceFile(reference.resolvedFileName);
	      return file && { reference: typeReferenceDirective, fileName: file.fileName, file, unverified: false };
	    }
	    const libReferenceDirective = findReferenceInPosition(sourceFile.libReferenceDirectives, position);
	    if (libReferenceDirective) {
	      const file = program.getLibFileFromReference(libReferenceDirective);
	      return file && { reference: libReferenceDirective, fileName: file.fileName, file, unverified: false };
	    }
	    if (sourceFile.imports.length || sourceFile.moduleAugmentations.length) {
	      const node = getTouchingToken(sourceFile, position);
	      let resolution;
	      if (isModuleSpecifierLike(node) && isExternalModuleNameRelative(node.text) && (resolution = program.getResolvedModuleFromModuleSpecifier(node))) {
	        const verifiedFileName = (_b = resolution.resolvedModule) == null ? void 0 : _b.resolvedFileName;
	        const fileName = verifiedFileName || resolvePath(getDirectoryPath(sourceFile.fileName), node.text);
	        return {
	          file: program.getSourceFile(fileName),
	          fileName,
	          reference: {
	            pos: node.getStart(),
	            end: node.getEnd(),
	            fileName: node.text
	          },
	          unverified: !verifiedFileName
	        };
	      }
	    }
	    return void 0;
	  }
	  function shouldUnwrapFirstTypeArgumentTypeDefinitionFromTypeReference(typeChecker, type) {
	    const referenceName = type.symbol.name;
	    if (!typesWithUnwrappedTypeArguments.has(referenceName)) {
	      return false;
	    }
	    const globalType = typeChecker.resolveName(
	      referenceName,
	      /*location*/
	      void 0,
	      788968 /* Type */,
	      /*excludeGlobals*/
	      false
	    );
	    return !!globalType && globalType === type.target.symbol;
	  }
	  function shouldUnwrapFirstTypeArgumentTypeDefinitionFromAlias(typeChecker, type) {
	    if (!type.aliasSymbol) {
	      return false;
	    }
	    const referenceName = type.aliasSymbol.name;
	    if (!typesWithUnwrappedTypeArguments.has(referenceName)) {
	      return false;
	    }
	    const globalType = typeChecker.resolveName(
	      referenceName,
	      /*location*/
	      void 0,
	      788968 /* Type */,
	      /*excludeGlobals*/
	      false
	    );
	    return !!globalType && globalType === type.aliasSymbol;
	  }
	  function getFirstTypeArgumentDefinitions(typeChecker, type, node, failedAliasResolution) {
	    var _a, _b;
	    if (!!(getObjectFlags(type) & 4 /* Reference */) && shouldUnwrapFirstTypeArgumentTypeDefinitionFromTypeReference(typeChecker, type)) {
	      return definitionFromType(typeChecker.getTypeArguments(type)[0], typeChecker, node, failedAliasResolution);
	    }
	    if (shouldUnwrapFirstTypeArgumentTypeDefinitionFromAlias(typeChecker, type) && type.aliasTypeArguments) {
	      return definitionFromType(type.aliasTypeArguments[0], typeChecker, node, failedAliasResolution);
	    }
	    if (getObjectFlags(type) & 32 /* Mapped */ && type.target && shouldUnwrapFirstTypeArgumentTypeDefinitionFromAlias(typeChecker, type.target)) {
	      const declaration = (_b = (_a = type.aliasSymbol) == null ? void 0 : _a.declarations) == null ? void 0 : _b[0];
	      if (declaration && isTypeAliasDeclaration(declaration) && isTypeReferenceNode(declaration.type) && declaration.type.typeArguments) {
	        return definitionFromType(typeChecker.getTypeAtLocation(declaration.type.typeArguments[0]), typeChecker, node, failedAliasResolution);
	      }
	    }
	    return [];
	  }
	  function getTypeDefinitionAtPosition(typeChecker, sourceFile, position) {
	    const node = getTouchingPropertyName(sourceFile, position);
	    if (node === sourceFile) {
	      return void 0;
	    }
	    if (isImportMeta(node.parent) && node.parent.name === node) {
	      return definitionFromType(
	        typeChecker.getTypeAtLocation(node.parent),
	        typeChecker,
	        node.parent,
	        /*failedAliasResolution*/
	        false
	      );
	    }
	    const { symbol, failedAliasResolution } = getSymbol(
	      node,
	      typeChecker,
	      /*stopAtAlias*/
	      false
	    );
	    if (!symbol)
	      return void 0;
	    const typeAtLocation = typeChecker.getTypeOfSymbolAtLocation(symbol, node);
	    const returnType = tryGetReturnTypeOfFunction(symbol, typeAtLocation, typeChecker);
	    const fromReturnType = returnType && definitionFromType(returnType, typeChecker, node, failedAliasResolution);
	    const [resolvedType, typeDefinitions] = fromReturnType && fromReturnType.length !== 0 ? [returnType, fromReturnType] : [typeAtLocation, definitionFromType(typeAtLocation, typeChecker, node, failedAliasResolution)];
	    return typeDefinitions.length ? [...getFirstTypeArgumentDefinitions(typeChecker, resolvedType, node, failedAliasResolution), ...typeDefinitions] : !(symbol.flags & 111551 /* Value */) && symbol.flags & 788968 /* Type */ ? getDefinitionFromSymbol(typeChecker, skipAlias(symbol, typeChecker), node, failedAliasResolution) : void 0;
	  }
	  function definitionFromType(type, checker, node, failedAliasResolution) {
	    return flatMap(type.isUnion() && !(type.flags & 32 /* Enum */) ? type.types : [type], (t) => t.symbol && getDefinitionFromSymbol(checker, t.symbol, node, failedAliasResolution));
	  }
	  function tryGetReturnTypeOfFunction(symbol, type, checker) {
	    if (type.symbol === symbol || // At `const f = () => {}`, the symbol is `f` and the type symbol is at `() => {}`
	    symbol.valueDeclaration && type.symbol && isVariableDeclaration(symbol.valueDeclaration) && symbol.valueDeclaration.initializer === type.symbol.valueDeclaration) {
	      const sigs = type.getCallSignatures();
	      if (sigs.length === 1)
	        return checker.getReturnTypeOfSignature(first(sigs));
	    }
	    return void 0;
	  }
	  function getDefinitionAndBoundSpan(program, sourceFile, position) {
	    const definitions = getDefinitionAtPosition(program, sourceFile, position);
	    if (!definitions || definitions.length === 0) {
	      return void 0;
	    }
	    const comment = findReferenceInPosition(sourceFile.referencedFiles, position) || findReferenceInPosition(sourceFile.typeReferenceDirectives, position) || findReferenceInPosition(sourceFile.libReferenceDirectives, position);
	    if (comment) {
	      return { definitions, textSpan: createTextSpanFromRange(comment) };
	    }
	    const node = getTouchingPropertyName(sourceFile, position);
	    const textSpan = createTextSpan(node.getStart(), node.getWidth());
	    return { definitions, textSpan };
	  }
	  function getDefinitionInfoForIndexSignatures(node, checker) {
	    return mapDefined(checker.getIndexInfosAtLocation(node), (info) => info.declaration && createDefinitionFromSignatureDeclaration(checker, info.declaration));
	  }
	  function getSymbol(node, checker, stopAtAlias) {
	    const symbol = checker.getSymbolAtLocation(node);
	    let failedAliasResolution = false;
	    if ((symbol == null ? void 0 : symbol.declarations) && symbol.flags & 2097152 /* Alias */ && !stopAtAlias && shouldSkipAlias(node, symbol.declarations[0])) {
	      const aliased = checker.getAliasedSymbol(symbol);
	      if (aliased.declarations) {
	        return { symbol: aliased };
	      } else {
	        failedAliasResolution = true;
	      }
	    }
	    return { symbol, failedAliasResolution };
	  }
	  function shouldSkipAlias(node, declaration) {
	    if (node.kind !== 80 /* Identifier */) {
	      return false;
	    }
	    if (node.parent === declaration) {
	      return true;
	    }
	    if (declaration.kind === 274 /* NamespaceImport */) {
	      return false;
	    }
	    return true;
	  }
	  function isExpandoDeclaration(node) {
	    if (!isAssignmentDeclaration(node))
	      return false;
	    const containingAssignment = findAncestor(node, (p) => {
	      if (isAssignmentExpression(p))
	        return true;
	      if (!isAssignmentDeclaration(p))
	        return "quit";
	      return false;
	    });
	    return !!containingAssignment && getAssignmentDeclarationKind(containingAssignment) === 5 /* Property */;
	  }
	  function getDefinitionFromSymbol(typeChecker, symbol, node, failedAliasResolution, excludeDeclaration) {
	    const filteredDeclarations = filter(symbol.declarations, (d) => d !== excludeDeclaration);
	    const withoutExpandos = filter(filteredDeclarations, (d) => !isExpandoDeclaration(d));
	    const results = some(withoutExpandos) ? withoutExpandos : filteredDeclarations;
	    return getConstructSignatureDefinition() || getCallSignatureDefinition() || map(results, (declaration) => createDefinitionInfo(
	      declaration,
	      typeChecker,
	      symbol,
	      node,
	      /*unverified*/
	      false,
	      failedAliasResolution
	    ));
	    function getConstructSignatureDefinition() {
	      if (symbol.flags & 32 /* Class */ && !(symbol.flags & (16 /* Function */ | 3 /* Variable */)) && (isNewExpressionTarget(node) || node.kind === 137 /* ConstructorKeyword */)) {
	        const cls = find(filteredDeclarations, isClassLike) || Debug.fail("Expected declaration to have at least one class-like declaration");
	        return getSignatureDefinition(
	          cls.members,
	          /*selectConstructors*/
	          true
	        );
	      }
	    }
	    function getCallSignatureDefinition() {
	      return isCallOrNewExpressionTarget(node) || isNameOfFunctionDeclaration(node) ? getSignatureDefinition(
	        filteredDeclarations,
	        /*selectConstructors*/
	        false
	      ) : void 0;
	    }
	    function getSignatureDefinition(signatureDeclarations, selectConstructors) {
	      if (!signatureDeclarations) {
	        return void 0;
	      }
	      const declarations = signatureDeclarations.filter(selectConstructors ? isConstructorDeclaration : isFunctionLike);
	      const declarationsWithBody = declarations.filter((d) => !!d.body);
	      return declarations.length ? declarationsWithBody.length !== 0 ? declarationsWithBody.map((x) => createDefinitionInfo(x, typeChecker, symbol, node)) : [createDefinitionInfo(
	        last(declarations),
	        typeChecker,
	        symbol,
	        node,
	        /*unverified*/
	        false,
	        failedAliasResolution
	      )] : void 0;
	    }
	  }
	  function createDefinitionInfo(declaration, checker, symbol, node, unverified, failedAliasResolution) {
	    const symbolName2 = checker.symbolToString(symbol);
	    const symbolKind = ts_SymbolDisplay_exports.getSymbolKind(checker, symbol, node);
	    const containerName = symbol.parent ? checker.symbolToString(symbol.parent, node) : "";
	    return createDefinitionInfoFromName(checker, declaration, symbolKind, symbolName2, containerName, unverified, failedAliasResolution);
	  }
	  function createDefinitionInfoFromName(checker, declaration, symbolKind, symbolName2, containerName, unverified, failedAliasResolution, textSpan) {
	    const sourceFile = declaration.getSourceFile();
	    if (!textSpan) {
	      const name = getNameOfDeclaration(declaration) || declaration;
	      textSpan = createTextSpanFromNode(name, sourceFile);
	    }
	    return {
	      fileName: sourceFile.fileName,
	      textSpan,
	      kind: symbolKind,
	      name: symbolName2,
	      containerKind: void 0,
	      // TODO: GH#18217
	      containerName,
	      ...ts_FindAllReferences_exports.toContextSpan(
	        textSpan,
	        sourceFile,
	        ts_FindAllReferences_exports.getContextNode(declaration)
	      ),
	      isLocal: !isDefinitionVisible(checker, declaration),
	      isAmbient: !!(declaration.flags & 33554432 /* Ambient */),
	      unverified,
	      failedAliasResolution
	    };
	  }
	  function createDefinitionInfoFromSwitch(statement, sourceFile) {
	    const keyword = ts_FindAllReferences_exports.getContextNode(statement);
	    const textSpan = createTextSpanFromNode(isContextWithStartAndEndNode(keyword) ? keyword.start : keyword, sourceFile);
	    return {
	      fileName: sourceFile.fileName,
	      textSpan,
	      kind: "keyword" /* keyword */,
	      name: "switch",
	      containerKind: void 0,
	      containerName: "",
	      ...ts_FindAllReferences_exports.toContextSpan(textSpan, sourceFile, keyword),
	      isLocal: true,
	      isAmbient: false,
	      unverified: false,
	      failedAliasResolution: void 0
	    };
	  }
	  function isDefinitionVisible(checker, declaration) {
	    if (checker.isDeclarationVisible(declaration))
	      return true;
	    if (!declaration.parent)
	      return false;
	    if (hasInitializer(declaration.parent) && declaration.parent.initializer === declaration)
	      return isDefinitionVisible(checker, declaration.parent);
	    switch (declaration.kind) {
	      case 172 /* PropertyDeclaration */:
	      case 177 /* GetAccessor */:
	      case 178 /* SetAccessor */:
	      case 174 /* MethodDeclaration */:
	        if (hasEffectiveModifier(declaration, 2 /* Private */))
	          return false;
	      case 176 /* Constructor */:
	      case 303 /* PropertyAssignment */:
	      case 304 /* ShorthandPropertyAssignment */:
	      case 210 /* ObjectLiteralExpression */:
	      case 231 /* ClassExpression */:
	      case 219 /* ArrowFunction */:
	      case 218 /* FunctionExpression */:
	        return isDefinitionVisible(checker, declaration.parent);
	      default:
	        return false;
	    }
	  }
	  function createDefinitionFromSignatureDeclaration(typeChecker, decl, failedAliasResolution) {
	    return createDefinitionInfo(
	      decl,
	      typeChecker,
	      decl.symbol,
	      decl,
	      /*unverified*/
	      false,
	      failedAliasResolution
	    );
	  }
	  function findReferenceInPosition(refs, pos) {
	    return find(refs, (ref) => textRangeContainsPositionInclusive(ref, pos));
	  }
	  function getDefinitionInfoForFileReference(name, targetFileName, unverified) {
	    return {
	      fileName: targetFileName,
	      textSpan: createTextSpanFromBounds(0, 0),
	      kind: "script" /* scriptElement */,
	      name,
	      containerName: void 0,
	      containerKind: void 0,
	      // TODO: GH#18217
	      unverified
	    };
	  }
	  function getAncestorCallLikeExpression(node) {
	    const target = findAncestor(node, (n) => !isRightSideOfPropertyAccess(n));
	    const callLike = target == null ? void 0 : target.parent;
	    return callLike && isCallLikeExpression(callLike) && getInvokedExpression(callLike) === target ? callLike : void 0;
	  }
	  function tryGetSignatureDeclaration(typeChecker, node) {
	    const callLike = getAncestorCallLikeExpression(node);
	    const signature = callLike && typeChecker.getResolvedSignature(callLike);
	    return tryCast(signature && signature.declaration, (d) => isFunctionLike(d) && !isFunctionTypeNode(d));
	  }
	  function isConstructorLike(node) {
	    switch (node.kind) {
	      case 176 /* Constructor */:
	      case 185 /* ConstructorType */:
	      case 180 /* ConstructSignature */:
	        return true;
	      default:
	        return false;
	    }
	  }
	  var typesWithUnwrappedTypeArguments;
	  var init_goToDefinition = __esm({
	    "src/services/goToDefinition.ts"() {
	      init_ts4();
	      init_ts_FindAllReferences();
	      typesWithUnwrappedTypeArguments = /* @__PURE__ */ new Set([
	        "Array",
	        "ArrayLike",
	        "ReadonlyArray",
	        "Promise",
	        "PromiseLike",
	        "Iterable",
	        "IterableIterator",
	        "AsyncIterable",
	        "Set",
	        "WeakSet",
	        "ReadonlySet",
	        "Map",
	        "WeakMap",
	        "ReadonlyMap",
	        "Partial",
	        "Required",
	        "Readonly",
	        "Pick",
	        "Omit"
	      ]);
	    }
	  });

	  // src/services/_namespaces/ts.GoToDefinition.ts
	  var ts_GoToDefinition_exports = {};
	  __export(ts_GoToDefinition_exports, {
	    createDefinitionInfo: () => createDefinitionInfo,
	    findReferenceInPosition: () => findReferenceInPosition,
	    getDefinitionAndBoundSpan: () => getDefinitionAndBoundSpan,
	    getDefinitionAtPosition: () => getDefinitionAtPosition,
	    getReferenceAtPosition: () => getReferenceAtPosition,
	    getTypeDefinitionAtPosition: () => getTypeDefinitionAtPosition
	  });
	  var init_ts_GoToDefinition = __esm({
	    "src/services/_namespaces/ts.GoToDefinition.ts"() {
	      init_goToDefinition();
	    }
	  });

	  // src/services/inlayHints.ts
	  function shouldShowParameterNameHints(preferences) {
	    return preferences.includeInlayParameterNameHints === "literals" || preferences.includeInlayParameterNameHints === "all";
	  }
	  function shouldShowLiteralParameterNameHintsOnly(preferences) {
	    return preferences.includeInlayParameterNameHints === "literals";
	  }
	  function shouldUseInteractiveInlayHints(preferences) {
	    return preferences.interactiveInlayHints === true;
	  }
	  function provideInlayHints(context) {
	    const { file, program, span, cancellationToken, preferences } = context;
	    const sourceFileText = file.text;
	    const compilerOptions = program.getCompilerOptions();
	    const quotePreference = getQuotePreference(file, preferences);
	    const checker = program.getTypeChecker();
	    const result = [];
	    visitor(file);
	    return result;
	    function visitor(node) {
	      if (!node || node.getFullWidth() === 0) {
	        return;
	      }
	      switch (node.kind) {
	        case 267 /* ModuleDeclaration */:
	        case 263 /* ClassDeclaration */:
	        case 264 /* InterfaceDeclaration */:
	        case 262 /* FunctionDeclaration */:
	        case 231 /* ClassExpression */:
	        case 218 /* FunctionExpression */:
	        case 174 /* MethodDeclaration */:
	        case 219 /* ArrowFunction */:
	          cancellationToken.throwIfCancellationRequested();
	      }
	      if (!textSpanIntersectsWith(span, node.pos, node.getFullWidth())) {
	        return;
	      }
	      if (isTypeNode(node) && !isExpressionWithTypeArguments(node)) {
	        return;
	      }
	      if (preferences.includeInlayVariableTypeHints && isVariableDeclaration(node)) {
	        visitVariableLikeDeclaration(node);
	      } else if (preferences.includeInlayPropertyDeclarationTypeHints && isPropertyDeclaration(node)) {
	        visitVariableLikeDeclaration(node);
	      } else if (preferences.includeInlayEnumMemberValueHints && isEnumMember(node)) {
	        visitEnumMember(node);
	      } else if (shouldShowParameterNameHints(preferences) && (isCallExpression(node) || isNewExpression(node))) {
	        visitCallOrNewExpression(node);
	      } else {
	        if (preferences.includeInlayFunctionParameterTypeHints && isFunctionLikeDeclaration(node) && hasContextSensitiveParameters(node)) {
	          visitFunctionLikeForParameterType(node);
	        }
	        if (preferences.includeInlayFunctionLikeReturnTypeHints && isSignatureSupportingReturnAnnotation(node)) {
	          visitFunctionDeclarationLikeForReturnType(node);
	        }
	      }
	      return forEachChild(node, visitor);
	    }
	    function isSignatureSupportingReturnAnnotation(node) {
	      return isArrowFunction(node) || isFunctionExpression(node) || isFunctionDeclaration(node) || isMethodDeclaration(node) || isGetAccessorDeclaration(node);
	    }
	    function addParameterHints(text, parameter, position, isFirstVariadicArgument) {
	      let hintText = `${isFirstVariadicArgument ? "..." : ""}${text}`;
	      let displayParts;
	      if (shouldUseInteractiveInlayHints(preferences)) {
	        displayParts = [getNodeDisplayPart(hintText, parameter), { text: ":" }];
	        hintText = "";
	      } else {
	        hintText += ":";
	      }
	      result.push({
	        text: hintText,
	        position,
	        kind: "Parameter" /* Parameter */,
	        whitespaceAfter: true,
	        displayParts
	      });
	    }
	    function addTypeHints(hintText, position) {
	      result.push({
	        text: typeof hintText === "string" ? `: ${hintText}` : "",
	        displayParts: typeof hintText === "string" ? void 0 : [{ text: ": " }, ...hintText],
	        position,
	        kind: "Type" /* Type */,
	        whitespaceBefore: true
	      });
	    }
	    function addEnumMemberValueHints(text, position) {
	      result.push({
	        text: `= ${text}`,
	        position,
	        kind: "Enum" /* Enum */,
	        whitespaceBefore: true
	      });
	    }
	    function visitEnumMember(member) {
	      if (member.initializer) {
	        return;
	      }
	      const enumValue = checker.getConstantValue(member);
	      if (enumValue !== void 0) {
	        addEnumMemberValueHints(enumValue.toString(), member.end);
	      }
	    }
	    function isModuleReferenceType(type) {
	      return type.symbol && type.symbol.flags & 1536 /* Module */;
	    }
	    function visitVariableLikeDeclaration(decl) {
	      if (!decl.initializer || isBindingPattern(decl.name) || isVariableDeclaration(decl) && !isHintableDeclaration(decl)) {
	        return;
	      }
	      const effectiveTypeAnnotation = getEffectiveTypeAnnotationNode(decl);
	      if (effectiveTypeAnnotation) {
	        return;
	      }
	      const declarationType = checker.getTypeAtLocation(decl);
	      if (isModuleReferenceType(declarationType)) {
	        return;
	      }
	      const hintParts = typeToInlayHintParts(declarationType);
	      if (hintParts) {
	        const hintText = typeof hintParts === "string" ? hintParts : hintParts.map((part) => part.text).join("");
	        const isVariableNameMatchesType = preferences.includeInlayVariableTypeHintsWhenTypeMatchesName === false && equateStringsCaseInsensitive(decl.name.getText(), hintText);
	        if (isVariableNameMatchesType) {
	          return;
	        }
	        addTypeHints(hintParts, decl.name.end);
	      }
	    }
	    function visitCallOrNewExpression(expr) {
	      const args = expr.arguments;
	      if (!args || !args.length) {
	        return;
	      }
	      const candidates = [];
	      const signature = checker.getResolvedSignatureForSignatureHelp(expr, candidates);
	      if (!signature || !candidates.length) {
	        return;
	      }
	      let signatureParamPos = 0;
	      for (const originalArg of args) {
	        const arg = skipParentheses(originalArg);
	        if (shouldShowLiteralParameterNameHintsOnly(preferences) && !isHintableLiteral(arg)) {
	          signatureParamPos++;
	          continue;
	        }
	        let spreadArgs = 0;
	        if (isSpreadElement(arg)) {
	          const spreadType = checker.getTypeAtLocation(arg.expression);
	          if (checker.isTupleType(spreadType)) {
	            const { elementFlags, fixedLength } = spreadType.target;
	            if (fixedLength === 0) {
	              continue;
	            }
	            const firstOptionalIndex = findIndex(elementFlags, (f) => !(f & 1 /* Required */));
	            const requiredArgs = firstOptionalIndex < 0 ? fixedLength : firstOptionalIndex;
	            if (requiredArgs > 0) {
	              spreadArgs = firstOptionalIndex < 0 ? fixedLength : firstOptionalIndex;
	            }
	          }
	        }
	        const identifierInfo = checker.getParameterIdentifierInfoAtPosition(signature, signatureParamPos);
	        signatureParamPos = signatureParamPos + (spreadArgs || 1);
	        if (identifierInfo) {
	          const { parameter, parameterName, isRestParameter: isFirstVariadicArgument } = identifierInfo;
	          const isParameterNameNotSameAsArgument = preferences.includeInlayParameterNameHintsWhenArgumentMatchesName || !identifierOrAccessExpressionPostfixMatchesParameterName(arg, parameterName);
	          if (!isParameterNameNotSameAsArgument && !isFirstVariadicArgument) {
	            continue;
	          }
	          const name = unescapeLeadingUnderscores(parameterName);
	          if (leadingCommentsContainsParameterName(arg, name)) {
	            continue;
	          }
	          addParameterHints(name, parameter, originalArg.getStart(), isFirstVariadicArgument);
	        }
	      }
	    }
	    function identifierOrAccessExpressionPostfixMatchesParameterName(expr, parameterName) {
	      if (isIdentifier(expr)) {
	        return expr.text === parameterName;
	      }
	      if (isPropertyAccessExpression(expr)) {
	        return expr.name.text === parameterName;
	      }
	      return false;
	    }
	    function leadingCommentsContainsParameterName(node, name) {
	      if (!isIdentifierText(name, compilerOptions.target, getLanguageVariant(file.scriptKind))) {
	        return false;
	      }
	      const ranges = getLeadingCommentRanges(sourceFileText, node.pos);
	      if (!(ranges == null ? void 0 : ranges.length)) {
	        return false;
	      }
	      const regex = leadingParameterNameCommentRegexFactory(name);
	      return some(ranges, (range) => regex.test(sourceFileText.substring(range.pos, range.end)));
	    }
	    function isHintableLiteral(node) {
	      switch (node.kind) {
	        case 224 /* PrefixUnaryExpression */: {
	          const operand = node.operand;
	          return isLiteralExpression(operand) || isIdentifier(operand) && isInfinityOrNaNString(operand.escapedText);
	        }
	        case 112 /* TrueKeyword */:
	        case 97 /* FalseKeyword */:
	        case 106 /* NullKeyword */:
	        case 15 /* NoSubstitutionTemplateLiteral */:
	        case 228 /* TemplateExpression */:
	          return true;
	        case 80 /* Identifier */: {
	          const name = node.escapedText;
	          return isUndefined(name) || isInfinityOrNaNString(name);
	        }
	      }
	      return isLiteralExpression(node);
	    }
	    function visitFunctionDeclarationLikeForReturnType(decl) {
	      if (isArrowFunction(decl)) {
	        if (!findChildOfKind(decl, 21 /* OpenParenToken */, file)) {
	          return;
	        }
	      }
	      const effectiveTypeAnnotation = getEffectiveReturnTypeNode(decl);
	      if (effectiveTypeAnnotation || !decl.body) {
	        return;
	      }
	      const signature = checker.getSignatureFromDeclaration(decl);
	      if (!signature) {
	        return;
	      }
	      const returnType = checker.getReturnTypeOfSignature(signature);
	      if (isModuleReferenceType(returnType)) {
	        return;
	      }
	      const hintParts = typeToInlayHintParts(returnType);
	      if (hintParts) {
	        addTypeHints(hintParts, getTypeAnnotationPosition(decl));
	      }
	    }
	    function getTypeAnnotationPosition(decl) {
	      const closeParenToken = findChildOfKind(decl, 22 /* CloseParenToken */, file);
	      if (closeParenToken) {
	        return closeParenToken.end;
	      }
	      return decl.parameters.end;
	    }
	    function visitFunctionLikeForParameterType(node) {
	      const signature = checker.getSignatureFromDeclaration(node);
	      if (!signature) {
	        return;
	      }
	      for (let i = 0; i < node.parameters.length && i < signature.parameters.length; ++i) {
	        const param = node.parameters[i];
	        if (!isHintableDeclaration(param)) {
	          continue;
	        }
	        const effectiveTypeAnnotation = getEffectiveTypeAnnotationNode(param);
	        if (effectiveTypeAnnotation) {
	          continue;
	        }
	        const typeHints = getParameterDeclarationTypeHints(signature.parameters[i]);
	        if (!typeHints) {
	          continue;
	        }
	        addTypeHints(typeHints, param.questionToken ? param.questionToken.end : param.name.end);
	      }
	    }
	    function getParameterDeclarationTypeHints(symbol) {
	      const valueDeclaration = symbol.valueDeclaration;
	      if (!valueDeclaration || !isParameter(valueDeclaration)) {
	        return void 0;
	      }
	      const signatureParamType = checker.getTypeOfSymbolAtLocation(symbol, valueDeclaration);
	      if (isModuleReferenceType(signatureParamType)) {
	        return void 0;
	      }
	      return typeToInlayHintParts(signatureParamType);
	    }
	    function printTypeInSingleLine(type) {
	      const flags = 70221824 /* IgnoreErrors */ | 1048576 /* AllowUniqueESSymbolType */ | 16384 /* UseAliasDefinedOutsideCurrentScope */;
	      const printer = createPrinterWithRemoveComments();
	      return usingSingleLineStringWriter((writer) => {
	        const typeNode = checker.typeToTypeNode(
	          type,
	          /*enclosingDeclaration*/
	          void 0,
	          flags
	        );
	        Debug.assertIsDefined(typeNode, "should always get typenode");
	        printer.writeNode(
	          4 /* Unspecified */,
	          typeNode,
	          /*sourceFile*/
	          file,
	          writer
	        );
	      });
	    }
	    function typeToInlayHintParts(type) {
	      if (!shouldUseInteractiveInlayHints(preferences)) {
	        return printTypeInSingleLine(type);
	      }
	      const flags = 70221824 /* IgnoreErrors */ | 1048576 /* AllowUniqueESSymbolType */ | 16384 /* UseAliasDefinedOutsideCurrentScope */;
	      const typeNode = checker.typeToTypeNode(
	        type,
	        /*enclosingDeclaration*/
	        void 0,
	        flags
	      );
	      Debug.assertIsDefined(typeNode, "should always get typenode");
	      const parts = [];
	      visitForDisplayParts(typeNode);
	      return parts;
	      function visitForDisplayParts(node) {
	        var _a, _b;
	        if (!node) {
	          return;
	        }
	        const tokenString = tokenToString(node.kind);
	        if (tokenString) {
	          parts.push({ text: tokenString });
	          return;
	        }
	        if (isLiteralExpression(node)) {
	          parts.push({ text: getLiteralText2(node) });
	          return;
	        }
	        switch (node.kind) {
	          case 80 /* Identifier */:
	            Debug.assertNode(node, isIdentifier);
	            const identifierText = idText(node);
	            const name = node.symbol && node.symbol.declarations && node.symbol.declarations.length && getNameOfDeclaration(node.symbol.declarations[0]);
	            if (name) {
	              parts.push(getNodeDisplayPart(identifierText, name));
	            } else {
	              parts.push({ text: identifierText });
	            }
	            break;
	          case 166 /* QualifiedName */:
	            Debug.assertNode(node, isQualifiedName);
	            visitForDisplayParts(node.left);
	            parts.push({ text: "." });
	            visitForDisplayParts(node.right);
	            break;
	          case 182 /* TypePredicate */:
	            Debug.assertNode(node, isTypePredicateNode);
	            if (node.assertsModifier) {
	              parts.push({ text: "asserts " });
	            }
	            visitForDisplayParts(node.parameterName);
	            if (node.type) {
	              parts.push({ text: " is " });
	              visitForDisplayParts(node.type);
	            }
	            break;
	          case 183 /* TypeReference */:
	            Debug.assertNode(node, isTypeReferenceNode);
	            visitForDisplayParts(node.typeName);
	            if (node.typeArguments) {
	              parts.push({ text: "<" });
	              visitDisplayPartList(node.typeArguments, ", ");
	              parts.push({ text: ">" });
	            }
	            break;
	          case 168 /* TypeParameter */:
	            Debug.assertNode(node, isTypeParameterDeclaration);
	            if (node.modifiers) {
	              visitDisplayPartList(node.modifiers, " ");
	            }
	            visitForDisplayParts(node.name);
	            if (node.constraint) {
	              parts.push({ text: " extends " });
	              visitForDisplayParts(node.constraint);
	            }
	            if (node.default) {
	              parts.push({ text: " = " });
	              visitForDisplayParts(node.default);
	            }
	            break;
	          case 169 /* Parameter */:
	            Debug.assertNode(node, isParameter);
	            if (node.modifiers) {
	              visitDisplayPartList(node.modifiers, " ");
	            }
	            if (node.dotDotDotToken) {
	              parts.push({ text: "..." });
	            }
	            visitForDisplayParts(node.name);
	            if (node.questionToken) {
	              parts.push({ text: "?" });
	            }
	            if (node.type) {
	              parts.push({ text: ": " });
	              visitForDisplayParts(node.type);
	            }
	            break;
	          case 185 /* ConstructorType */:
	            Debug.assertNode(node, isConstructorTypeNode);
	            parts.push({ text: "new " });
	            visitParametersAndTypeParameters(node);
	            parts.push({ text: " => " });
	            visitForDisplayParts(node.type);
	            break;
	          case 186 /* TypeQuery */:
	            Debug.assertNode(node, isTypeQueryNode);
	            parts.push({ text: "typeof " });
	            visitForDisplayParts(node.exprName);
	            if (node.typeArguments) {
	              parts.push({ text: "<" });
	              visitDisplayPartList(node.typeArguments, ", ");
	              parts.push({ text: ">" });
	            }
	            break;
	          case 187 /* TypeLiteral */:
	            Debug.assertNode(node, isTypeLiteralNode);
	            parts.push({ text: "{" });
	            if (node.members.length) {
	              parts.push({ text: " " });
	              visitDisplayPartList(node.members, "; ");
	              parts.push({ text: " " });
	            }
	            parts.push({ text: "}" });
	            break;
	          case 188 /* ArrayType */:
	            Debug.assertNode(node, isArrayTypeNode);
	            visitForDisplayParts(node.elementType);
	            parts.push({ text: "[]" });
	            break;
	          case 189 /* TupleType */:
	            Debug.assertNode(node, isTupleTypeNode);
	            parts.push({ text: "[" });
	            visitDisplayPartList(node.elements, ", ");
	            parts.push({ text: "]" });
	            break;
	          case 202 /* NamedTupleMember */:
	            Debug.assertNode(node, isNamedTupleMember);
	            if (node.dotDotDotToken) {
	              parts.push({ text: "..." });
	            }
	            visitForDisplayParts(node.name);
	            if (node.questionToken) {
	              parts.push({ text: "?" });
	            }
	            parts.push({ text: ": " });
	            visitForDisplayParts(node.type);
	            break;
	          case 190 /* OptionalType */:
	            Debug.assertNode(node, isOptionalTypeNode);
	            visitForDisplayParts(node.type);
	            parts.push({ text: "?" });
	            break;
	          case 191 /* RestType */:
	            Debug.assertNode(node, isRestTypeNode);
	            parts.push({ text: "..." });
	            visitForDisplayParts(node.type);
	            break;
	          case 192 /* UnionType */:
	            Debug.assertNode(node, isUnionTypeNode);
	            visitDisplayPartList(node.types, " | ");
	            break;
	          case 193 /* IntersectionType */:
	            Debug.assertNode(node, isIntersectionTypeNode);
	            visitDisplayPartList(node.types, " & ");
	            break;
	          case 194 /* ConditionalType */:
	            Debug.assertNode(node, isConditionalTypeNode);
	            visitForDisplayParts(node.checkType);
	            parts.push({ text: " extends " });
	            visitForDisplayParts(node.extendsType);
	            parts.push({ text: " ? " });
	            visitForDisplayParts(node.trueType);
	            parts.push({ text: " : " });
	            visitForDisplayParts(node.falseType);
	            break;
	          case 195 /* InferType */:
	            Debug.assertNode(node, isInferTypeNode);
	            parts.push({ text: "infer " });
	            visitForDisplayParts(node.typeParameter);
	            break;
	          case 196 /* ParenthesizedType */:
	            Debug.assertNode(node, isParenthesizedTypeNode);
	            parts.push({ text: "(" });
	            visitForDisplayParts(node.type);
	            parts.push({ text: ")" });
	            break;
	          case 198 /* TypeOperator */:
	            Debug.assertNode(node, isTypeOperatorNode);
	            parts.push({ text: `${tokenToString(node.operator)} ` });
	            visitForDisplayParts(node.type);
	            break;
	          case 199 /* IndexedAccessType */:
	            Debug.assertNode(node, isIndexedAccessTypeNode);
	            visitForDisplayParts(node.objectType);
	            parts.push({ text: "[" });
	            visitForDisplayParts(node.indexType);
	            parts.push({ text: "]" });
	            break;
	          case 200 /* MappedType */:
	            Debug.assertNode(node, isMappedTypeNode);
	            parts.push({ text: "{ " });
	            if (node.readonlyToken) {
	              if (node.readonlyToken.kind === 40 /* PlusToken */) {
	                parts.push({ text: "+" });
	              } else if (node.readonlyToken.kind === 41 /* MinusToken */) {
	                parts.push({ text: "-" });
	              }
	              parts.push({ text: "readonly " });
	            }
	            parts.push({ text: "[" });
	            visitForDisplayParts(node.typeParameter);
	            if (node.nameType) {
	              parts.push({ text: " as " });
	              visitForDisplayParts(node.nameType);
	            }
	            parts.push({ text: "]" });
	            if (node.questionToken) {
	              if (node.questionToken.kind === 40 /* PlusToken */) {
	                parts.push({ text: "+" });
	              } else if (node.questionToken.kind === 41 /* MinusToken */) {
	                parts.push({ text: "-" });
	              }
	              parts.push({ text: "?" });
	            }
	            parts.push({ text: ": " });
	            if (node.type) {
	              visitForDisplayParts(node.type);
	            }
	            parts.push({ text: "; }" });
	            break;
	          case 201 /* LiteralType */:
	            Debug.assertNode(node, isLiteralTypeNode);
	            visitForDisplayParts(node.literal);
	            break;
	          case 184 /* FunctionType */:
	            Debug.assertNode(node, isFunctionTypeNode);
	            visitParametersAndTypeParameters(node);
	            parts.push({ text: " => " });
	            visitForDisplayParts(node.type);
	            break;
	          case 205 /* ImportType */:
	            Debug.assertNode(node, isImportTypeNode);
	            if (node.isTypeOf) {
	              parts.push({ text: "typeof " });
	            }
	            parts.push({ text: "import(" });
	            visitForDisplayParts(node.argument);
	            if (node.assertions) {
	              parts.push({ text: ", { assert: " });
	              visitDisplayPartList(node.assertions.assertClause.elements, ", ");
	              parts.push({ text: " }" });
	            }
	            parts.push({ text: ")" });
	            if (node.qualifier) {
	              parts.push({ text: "." });
	              visitForDisplayParts(node.qualifier);
	            }
	            if (node.typeArguments) {
	              parts.push({ text: "<" });
	              visitDisplayPartList(node.typeArguments, ", ");
	              parts.push({ text: ">" });
	            }
	            break;
	          case 171 /* PropertySignature */:
	            Debug.assertNode(node, isPropertySignature);
	            if ((_a = node.modifiers) == null ? void 0 : _a.length) {
	              visitDisplayPartList(node.modifiers, " ");
	              parts.push({ text: " " });
	            }
	            visitForDisplayParts(node.name);
	            if (node.questionToken) {
	              parts.push({ text: "?" });
	            }
	            if (node.type) {
	              parts.push({ text: ": " });
	              visitForDisplayParts(node.type);
	            }
	            break;
	          case 181 /* IndexSignature */:
	            Debug.assertNode(node, isIndexSignatureDeclaration);
	            parts.push({ text: "[" });
	            visitDisplayPartList(node.parameters, ", ");
	            parts.push({ text: "]" });
	            if (node.type) {
	              parts.push({ text: ": " });
	              visitForDisplayParts(node.type);
	            }
	            break;
	          case 173 /* MethodSignature */:
	            Debug.assertNode(node, isMethodSignature);
	            if ((_b = node.modifiers) == null ? void 0 : _b.length) {
	              visitDisplayPartList(node.modifiers, " ");
	              parts.push({ text: " " });
	            }
	            visitForDisplayParts(node.name);
	            if (node.questionToken) {
	              parts.push({ text: "?" });
	            }
	            visitParametersAndTypeParameters(node);
	            if (node.type) {
	              parts.push({ text: ": " });
	              visitForDisplayParts(node.type);
	            }
	            break;
	          case 179 /* CallSignature */:
	            Debug.assertNode(node, isCallSignatureDeclaration);
	            visitParametersAndTypeParameters(node);
	            if (node.type) {
	              parts.push({ text: ": " });
	              visitForDisplayParts(node.type);
	            }
	            break;
	          case 207 /* ArrayBindingPattern */:
	            Debug.assertNode(node, isArrayBindingPattern);
	            parts.push({ text: "[" });
	            visitDisplayPartList(node.elements, ", ");
	            parts.push({ text: "]" });
	            break;
	          case 206 /* ObjectBindingPattern */:
	            Debug.assertNode(node, isObjectBindingPattern);
	            parts.push({ text: "{" });
	            if (node.elements.length) {
	              parts.push({ text: " " });
	              visitDisplayPartList(node.elements, ", ");
	              parts.push({ text: " " });
	            }
	            parts.push({ text: "}" });
	            break;
	          case 208 /* BindingElement */:
	            Debug.assertNode(node, isBindingElement);
	            visitForDisplayParts(node.name);
	            break;
	          case 224 /* PrefixUnaryExpression */:
	            Debug.assertNode(node, isPrefixUnaryExpression);
	            parts.push({ text: tokenToString(node.operator) });
	            visitForDisplayParts(node.operand);
	            break;
	          case 203 /* TemplateLiteralType */:
	            Debug.assertNode(node, isTemplateLiteralTypeNode);
	            visitForDisplayParts(node.head);
	            node.templateSpans.forEach(visitForDisplayParts);
	            break;
	          case 16 /* TemplateHead */:
	            Debug.assertNode(node, isTemplateHead);
	            parts.push({ text: getLiteralText2(node) });
	            break;
	          case 204 /* TemplateLiteralTypeSpan */:
	            Debug.assertNode(node, isTemplateLiteralTypeSpan);
	            visitForDisplayParts(node.type);
	            visitForDisplayParts(node.literal);
	            break;
	          case 17 /* TemplateMiddle */:
	            Debug.assertNode(node, isTemplateMiddle);
	            parts.push({ text: getLiteralText2(node) });
	            break;
	          case 18 /* TemplateTail */:
	            Debug.assertNode(node, isTemplateTail);
	            parts.push({ text: getLiteralText2(node) });
	            break;
	          case 197 /* ThisType */:
	            Debug.assertNode(node, isThisTypeNode);
	            parts.push({ text: "this" });
	            break;
	          default:
	            Debug.failBadSyntaxKind(node);
	        }
	      }
	      function visitParametersAndTypeParameters(signatureDeclaration) {
	        if (signatureDeclaration.typeParameters) {
	          parts.push({ text: "<" });
	          visitDisplayPartList(signatureDeclaration.typeParameters, ", ");
	          parts.push({ text: ">" });
	        }
	        parts.push({ text: "(" });
	        visitDisplayPartList(signatureDeclaration.parameters, ", ");
	        parts.push({ text: ")" });
	      }
	      function visitDisplayPartList(nodes, separator) {
	        nodes.forEach((node, index) => {
	          if (index > 0) {
	            parts.push({ text: separator });
	          }
	          visitForDisplayParts(node);
	        });
	      }
	      function getLiteralText2(node) {
	        switch (node.kind) {
	          case 11 /* StringLiteral */:
	            return quotePreference === 0 /* Single */ ? `'${escapeString(node.text, 39 /* singleQuote */)}'` : `"${escapeString(node.text, 34 /* doubleQuote */)}"`;
	          case 16 /* TemplateHead */:
	          case 17 /* TemplateMiddle */:
	          case 18 /* TemplateTail */: {
	            const rawText = node.rawText ?? escapeTemplateSubstitution(escapeString(node.text, 96 /* backtick */));
	            switch (node.kind) {
	              case 16 /* TemplateHead */:
	                return "`" + rawText + "${";
	              case 17 /* TemplateMiddle */:
	                return "}" + rawText + "${";
	              case 18 /* TemplateTail */:
	                return "}" + rawText + "`";
	            }
	          }
	        }
	        return node.text;
	      }
	    }
	    function isUndefined(name) {
	      return name === "undefined";
	    }
	    function isHintableDeclaration(node) {
	      if ((isParameterDeclaration(node) || isVariableDeclaration(node) && isVarConst(node)) && node.initializer) {
	        const initializer = skipParentheses(node.initializer);
	        return !(isHintableLiteral(initializer) || isNewExpression(initializer) || isObjectLiteralExpression(initializer) || isAssertionExpression(initializer));
	      }
	      return true;
	    }
	    function getNodeDisplayPart(text, node) {
	      const sourceFile = node.getSourceFile();
	      return {
	        text,
	        span: createTextSpanFromNode(node, sourceFile),
	        file: sourceFile.fileName
	      };
	    }
	  }
	  var leadingParameterNameCommentRegexFactory;
	  var init_inlayHints = __esm({
	    "src/services/inlayHints.ts"() {
	      init_ts4();
	      leadingParameterNameCommentRegexFactory = (name) => {
	        return new RegExp(`^\\s?/\\*\\*?\\s?${name}\\s?\\*\\/\\s?$`);
	      };
	    }
	  });

	  // src/services/_namespaces/ts.InlayHints.ts
	  var ts_InlayHints_exports = {};
	  __export(ts_InlayHints_exports, {
	    provideInlayHints: () => provideInlayHints
	  });
	  var init_ts_InlayHints = __esm({
	    "src/services/_namespaces/ts.InlayHints.ts"() {
	      init_inlayHints();
	    }
	  });

	  // src/services/jsDoc.ts
	  function getJsDocCommentsFromDeclarations(declarations, checker) {
	    const parts = [];
	    forEachUnique(declarations, (declaration) => {
	      for (const jsdoc of getCommentHavingNodes(declaration)) {
	        const inheritDoc = isJSDoc(jsdoc) && jsdoc.tags && find(jsdoc.tags, (t) => t.kind === 334 /* JSDocTag */ && (t.tagName.escapedText === "inheritDoc" || t.tagName.escapedText === "inheritdoc"));
	        if (jsdoc.comment === void 0 && !inheritDoc || isJSDoc(jsdoc) && declaration.kind !== 353 /* JSDocTypedefTag */ && declaration.kind !== 345 /* JSDocCallbackTag */ && jsdoc.tags && jsdoc.tags.some((t) => t.kind === 353 /* JSDocTypedefTag */ || t.kind === 345 /* JSDocCallbackTag */) && !jsdoc.tags.some((t) => t.kind === 348 /* JSDocParameterTag */ || t.kind === 349 /* JSDocReturnTag */)) {
	          continue;
	        }
	        let newparts = jsdoc.comment ? getDisplayPartsFromComment(jsdoc.comment, checker) : [];
	        if (inheritDoc && inheritDoc.comment) {
	          newparts = newparts.concat(getDisplayPartsFromComment(inheritDoc.comment, checker));
	        }
	        if (!contains(parts, newparts, isIdenticalListOfDisplayParts)) {
	          parts.push(newparts);
	        }
	      }
	    });
	    return flatten(intersperse(parts, [lineBreakPart()]));
	  }
	  function isIdenticalListOfDisplayParts(parts1, parts2) {
	    return arraysEqual(parts1, parts2, (p1, p2) => p1.kind === p2.kind && p1.text === p2.text);
	  }
	  function getCommentHavingNodes(declaration) {
	    switch (declaration.kind) {
	      case 348 /* JSDocParameterTag */:
	      case 355 /* JSDocPropertyTag */:
	        return [declaration];
	      case 345 /* JSDocCallbackTag */:
	      case 353 /* JSDocTypedefTag */:
	        return [declaration, declaration.parent];
	      case 330 /* JSDocSignature */:
	        if (isJSDocOverloadTag(declaration.parent)) {
	          return [declaration.parent.parent];
	        }
	      default:
	        return getJSDocCommentsAndTags(declaration);
	    }
	  }
	  function getJsDocTagsFromDeclarations(declarations, checker) {
	    const infos = [];
	    forEachUnique(declarations, (declaration) => {
	      const tags = getJSDocTags(declaration);
	      if (tags.some((t) => t.kind === 353 /* JSDocTypedefTag */ || t.kind === 345 /* JSDocCallbackTag */) && !tags.some((t) => t.kind === 348 /* JSDocParameterTag */ || t.kind === 349 /* JSDocReturnTag */)) {
	        return;
	      }
	      for (const tag of tags) {
	        infos.push({ name: tag.tagName.text, text: getCommentDisplayParts(tag, checker) });
	        infos.push(...getJSDocPropertyTagsInfo(tryGetJSDocPropertyTags(tag), checker));
	      }
	    });
	    return infos;
	  }
	  function getJSDocPropertyTagsInfo(nodes, checker) {
	    return flatMap(nodes, (propTag) => concatenate([{ name: propTag.tagName.text, text: getCommentDisplayParts(propTag, checker) }], getJSDocPropertyTagsInfo(tryGetJSDocPropertyTags(propTag), checker)));
	  }
	  function tryGetJSDocPropertyTags(node) {
	    return isJSDocPropertyLikeTag(node) && node.isNameFirst && node.typeExpression && isJSDocTypeLiteral(node.typeExpression.type) ? node.typeExpression.type.jsDocPropertyTags : void 0;
	  }
	  function getDisplayPartsFromComment(comment, checker) {
	    if (typeof comment === "string") {
	      return [textPart(comment)];
	    }
	    return flatMap(
	      comment,
	      (node) => node.kind === 328 /* JSDocText */ ? [textPart(node.text)] : buildLinkParts(node, checker)
	    );
	  }
	  function getCommentDisplayParts(tag, checker) {
	    const { comment, kind } = tag;
	    const namePart = getTagNameDisplayPart(kind);
	    switch (kind) {
	      case 356 /* JSDocThrowsTag */:
	        const typeExpression = tag.typeExpression;
	        return typeExpression ? withNode(typeExpression) : comment === void 0 ? void 0 : getDisplayPartsFromComment(comment, checker);
	      case 336 /* JSDocImplementsTag */:
	        return withNode(tag.class);
	      case 335 /* JSDocAugmentsTag */:
	        return withNode(tag.class);
	      case 352 /* JSDocTemplateTag */:
	        const templateTag = tag;
	        const displayParts = [];
	        if (templateTag.constraint) {
	          displayParts.push(textPart(templateTag.constraint.getText()));
	        }
	        if (length(templateTag.typeParameters)) {
	          if (length(displayParts)) {
	            displayParts.push(spacePart());
	          }
	          const lastTypeParameter = templateTag.typeParameters[templateTag.typeParameters.length - 1];
	          forEach(templateTag.typeParameters, (tp) => {
	            displayParts.push(namePart(tp.getText()));
	            if (lastTypeParameter !== tp) {
	              displayParts.push(...[punctuationPart(28 /* CommaToken */), spacePart()]);
	            }
	          });
	        }
	        if (comment) {
	          displayParts.push(...[spacePart(), ...getDisplayPartsFromComment(comment, checker)]);
	        }
	        return displayParts;
	      case 351 /* JSDocTypeTag */:
	      case 357 /* JSDocSatisfiesTag */:
	        return withNode(tag.typeExpression);
	      case 353 /* JSDocTypedefTag */:
	      case 345 /* JSDocCallbackTag */:
	      case 355 /* JSDocPropertyTag */:
	      case 348 /* JSDocParameterTag */:
	      case 354 /* JSDocSeeTag */:
	        const { name } = tag;
	        return name ? withNode(name) : comment === void 0 ? void 0 : getDisplayPartsFromComment(comment, checker);
	      default:
	        return comment === void 0 ? void 0 : getDisplayPartsFromComment(comment, checker);
	    }
	    function withNode(node) {
	      return addComment(node.getText());
	    }
	    function addComment(s) {
	      if (comment) {
	        if (s.match(/^https?$/)) {
	          return [textPart(s), ...getDisplayPartsFromComment(comment, checker)];
	        } else {
	          return [namePart(s), spacePart(), ...getDisplayPartsFromComment(comment, checker)];
	        }
	      } else {
	        return [textPart(s)];
	      }
	    }
	  }
	  function getTagNameDisplayPart(kind) {
	    switch (kind) {
	      case 348 /* JSDocParameterTag */:
	        return parameterNamePart;
	      case 355 /* JSDocPropertyTag */:
	        return propertyNamePart;
	      case 352 /* JSDocTemplateTag */:
	        return typeParameterNamePart;
	      case 353 /* JSDocTypedefTag */:
	      case 345 /* JSDocCallbackTag */:
	        return typeAliasNamePart;
	      default:
	        return textPart;
	    }
	  }
	  function getJSDocTagNameCompletions() {
	    return jsDocTagNameCompletionEntries || (jsDocTagNameCompletionEntries = map(jsDocTagNames, (tagName) => {
	      return {
	        name: tagName,
	        kind: "keyword" /* keyword */,
	        kindModifiers: "",
	        sortText: ts_Completions_exports.SortText.LocationPriority
	      };
	    }));
	  }
	  function getJSDocTagCompletions() {
	    return jsDocTagCompletionEntries || (jsDocTagCompletionEntries = map(jsDocTagNames, (tagName) => {
	      return {
	        name: `@${tagName}`,
	        kind: "keyword" /* keyword */,
	        kindModifiers: "",
	        sortText: ts_Completions_exports.SortText.LocationPriority
	      };
	    }));
	  }
	  function getJSDocTagCompletionDetails(name) {
	    return {
	      name,
	      kind: "" /* unknown */,
	      // TODO: should have its own kind?
	      kindModifiers: "",
	      displayParts: [textPart(name)],
	      documentation: emptyArray,
	      tags: void 0,
	      codeActions: void 0
	    };
	  }
	  function getJSDocParameterNameCompletions(tag) {
	    if (!isIdentifier(tag.name)) {
	      return emptyArray;
	    }
	    const nameThusFar = tag.name.text;
	    const jsdoc = tag.parent;
	    const fn = jsdoc.parent;
	    if (!isFunctionLike(fn))
	      return [];
	    return mapDefined(fn.parameters, (param) => {
	      if (!isIdentifier(param.name))
	        return void 0;
	      const name = param.name.text;
	      if (jsdoc.tags.some((t) => t !== tag && isJSDocParameterTag(t) && isIdentifier(t.name) && t.name.escapedText === name) || nameThusFar !== void 0 && !startsWith(name, nameThusFar)) {
	        return void 0;
	      }
	      return { name, kind: "parameter" /* parameterElement */, kindModifiers: "", sortText: ts_Completions_exports.SortText.LocationPriority };
	    });
	  }
	  function getJSDocParameterNameCompletionDetails(name) {
	    return {
	      name,
	      kind: "parameter" /* parameterElement */,
	      kindModifiers: "",
	      displayParts: [textPart(name)],
	      documentation: emptyArray,
	      tags: void 0,
	      codeActions: void 0
	    };
	  }
	  function getDocCommentTemplateAtPosition(newLine, sourceFile, position, options) {
	    const tokenAtPos = getTokenAtPosition(sourceFile, position);
	    const existingDocComment = findAncestor(tokenAtPos, isJSDoc);
	    if (existingDocComment && (existingDocComment.comment !== void 0 || length(existingDocComment.tags))) {
	      return void 0;
	    }
	    const tokenStart = tokenAtPos.getStart(sourceFile);
	    if (!existingDocComment && tokenStart < position) {
	      return void 0;
	    }
	    const commentOwnerInfo = getCommentOwnerInfo(tokenAtPos, options);
	    if (!commentOwnerInfo) {
	      return void 0;
	    }
	    const { commentOwner, parameters, hasReturn: hasReturn2 } = commentOwnerInfo;
	    const commentOwnerJsDoc = hasJSDocNodes(commentOwner) && commentOwner.jsDoc ? commentOwner.jsDoc : void 0;
	    const lastJsDoc = lastOrUndefined(commentOwnerJsDoc);
	    if (commentOwner.getStart(sourceFile) < position || lastJsDoc && existingDocComment && lastJsDoc !== existingDocComment) {
	      return void 0;
	    }
	    const indentationStr = getIndentationStringAtPosition(sourceFile, position);
	    const isJavaScriptFile = hasJSFileExtension(sourceFile.fileName);
	    const tags = (parameters ? parameterDocComments(parameters || [], isJavaScriptFile, indentationStr, newLine) : "") + (hasReturn2 ? returnsDocComment(indentationStr, newLine) : "");
	    const openComment = "/**";
	    const closeComment = " */";
	    const hasTag = length(getJSDocTags(commentOwner)) > 0;
	    if (tags && !hasTag) {
	      const preamble = openComment + newLine + indentationStr + " * ";
	      const endLine = tokenStart === position ? newLine + indentationStr : "";
	      const result = preamble + newLine + tags + indentationStr + closeComment + endLine;
	      return { newText: result, caretOffset: preamble.length };
	    }
	    return { newText: openComment + closeComment, caretOffset: 3 };
	  }
	  function getIndentationStringAtPosition(sourceFile, position) {
	    const { text } = sourceFile;
	    const lineStart = getLineStartPositionForPosition(position, sourceFile);
	    let pos = lineStart;
	    for (; pos <= position && isWhiteSpaceSingleLine(text.charCodeAt(pos)); pos++)
	      ;
	    return text.slice(lineStart, pos);
	  }
	  function parameterDocComments(parameters, isJavaScriptFile, indentationStr, newLine) {
	    return parameters.map(({ name, dotDotDotToken }, i) => {
	      const paramName = name.kind === 80 /* Identifier */ ? name.text : "param" + i;
	      const type = isJavaScriptFile ? dotDotDotToken ? "{...any} " : "{any} " : "";
	      return `${indentationStr} * @param ${type}${paramName}${newLine}`;
	    }).join("");
	  }
	  function returnsDocComment(indentationStr, newLine) {
	    return `${indentationStr} * @returns${newLine}`;
	  }
	  function getCommentOwnerInfo(tokenAtPos, options) {
	    return forEachAncestor(tokenAtPos, (n) => getCommentOwnerInfoWorker(n, options));
	  }
	  function getCommentOwnerInfoWorker(commentOwner, options) {
	    switch (commentOwner.kind) {
	      case 262 /* FunctionDeclaration */:
	      case 218 /* FunctionExpression */:
	      case 174 /* MethodDeclaration */:
	      case 176 /* Constructor */:
	      case 173 /* MethodSignature */:
	      case 219 /* ArrowFunction */:
	        const host = commentOwner;
	        return { commentOwner, parameters: host.parameters, hasReturn: hasReturn(host, options) };
	      case 303 /* PropertyAssignment */:
	        return getCommentOwnerInfoWorker(commentOwner.initializer, options);
	      case 263 /* ClassDeclaration */:
	      case 264 /* InterfaceDeclaration */:
	      case 266 /* EnumDeclaration */:
	      case 306 /* EnumMember */:
	      case 265 /* TypeAliasDeclaration */:
	        return { commentOwner };
	      case 171 /* PropertySignature */: {
	        const host2 = commentOwner;
	        return host2.type && isFunctionTypeNode(host2.type) ? { commentOwner, parameters: host2.type.parameters, hasReturn: hasReturn(host2.type, options) } : { commentOwner };
	      }
	      case 243 /* VariableStatement */: {
	        const varStatement = commentOwner;
	        const varDeclarations = varStatement.declarationList.declarations;
	        const host2 = varDeclarations.length === 1 && varDeclarations[0].initializer ? getRightHandSideOfAssignment(varDeclarations[0].initializer) : void 0;
	        return host2 ? { commentOwner, parameters: host2.parameters, hasReturn: hasReturn(host2, options) } : { commentOwner };
	      }
	      case 312 /* SourceFile */:
	        return "quit";
	      case 267 /* ModuleDeclaration */:
	        return commentOwner.parent.kind === 267 /* ModuleDeclaration */ ? void 0 : { commentOwner };
	      case 244 /* ExpressionStatement */:
	        return getCommentOwnerInfoWorker(commentOwner.expression, options);
	      case 226 /* BinaryExpression */: {
	        const be = commentOwner;
	        if (getAssignmentDeclarationKind(be) === 0 /* None */) {
	          return "quit";
	        }
	        return isFunctionLike(be.right) ? { commentOwner, parameters: be.right.parameters, hasReturn: hasReturn(be.right, options) } : { commentOwner };
	      }
	      case 172 /* PropertyDeclaration */:
	        const init = commentOwner.initializer;
	        if (init && (isFunctionExpression(init) || isArrowFunction(init))) {
	          return { commentOwner, parameters: init.parameters, hasReturn: hasReturn(init, options) };
	        }
	    }
	  }
	  function hasReturn(node, options) {
	    return !!(options == null ? void 0 : options.generateReturnInDocTemplate) && (isFunctionTypeNode(node) || isArrowFunction(node) && isExpression(node.body) || isFunctionLikeDeclaration(node) && node.body && isBlock(node.body) && !!forEachReturnStatement(node.body, (n) => n));
	  }
	  function getRightHandSideOfAssignment(rightHandSide) {
	    while (rightHandSide.kind === 217 /* ParenthesizedExpression */) {
	      rightHandSide = rightHandSide.expression;
	    }
	    switch (rightHandSide.kind) {
	      case 218 /* FunctionExpression */:
	      case 219 /* ArrowFunction */:
	        return rightHandSide;
	      case 231 /* ClassExpression */:
	        return find(rightHandSide.members, isConstructorDeclaration);
	    }
	  }
	  var jsDocTagNames, jsDocTagNameCompletionEntries, jsDocTagCompletionEntries, getJSDocTagNameCompletionDetails;
	  var init_jsDoc = __esm({
	    "src/services/jsDoc.ts"() {
	      init_ts4();
	      jsDocTagNames = [
	        "abstract",
	        "access",
	        "alias",
	        "argument",
	        "async",
	        "augments",
	        "author",
	        "borrows",
	        "callback",
	        "class",
	        "classdesc",
	        "constant",
	        "constructor",
	        "constructs",
	        "copyright",
	        "default",
	        "deprecated",
	        "description",
	        "emits",
	        "enum",
	        "event",
	        "example",
	        "exports",
	        "extends",
	        "external",
	        "field",
	        "file",
	        "fileoverview",
	        "fires",
	        "function",
	        "generator",
	        "global",
	        "hideconstructor",
	        "host",
	        "ignore",
	        "implements",
	        "inheritdoc",
	        "inner",
	        "instance",
	        "interface",
	        "kind",
	        "lends",
	        "license",
	        "link",
	        "linkcode",
	        "linkplain",
	        "listens",
	        "member",
	        "memberof",
	        "method",
	        "mixes",
	        "module",
	        "name",
	        "namespace",
	        "overload",
	        "override",
	        "package",
	        "param",
	        "private",
	        "prop",
	        "property",
	        "protected",
	        "public",
	        "readonly",
	        "requires",
	        "returns",
	        "satisfies",
	        "see",
	        "since",
	        "static",
	        "summary",
	        "template",
	        "this",
	        "throws",
	        "todo",
	        "tutorial",
	        "type",
	        "typedef",
	        "var",
	        "variation",
	        "version",
	        "virtual",
	        "yields"
	      ];
	      getJSDocTagNameCompletionDetails = getJSDocTagCompletionDetails;
	    }
	  });

	  // src/services/_namespaces/ts.JsDoc.ts
	  var ts_JsDoc_exports = {};
	  __export(ts_JsDoc_exports, {
	    getDocCommentTemplateAtPosition: () => getDocCommentTemplateAtPosition,
	    getJSDocParameterNameCompletionDetails: () => getJSDocParameterNameCompletionDetails,
	    getJSDocParameterNameCompletions: () => getJSDocParameterNameCompletions,
	    getJSDocTagCompletionDetails: () => getJSDocTagCompletionDetails,
	    getJSDocTagCompletions: () => getJSDocTagCompletions,
	    getJSDocTagNameCompletionDetails: () => getJSDocTagNameCompletionDetails,
	    getJSDocTagNameCompletions: () => getJSDocTagNameCompletions,
	    getJsDocCommentsFromDeclarations: () => getJsDocCommentsFromDeclarations,
	    getJsDocTagsFromDeclarations: () => getJsDocTagsFromDeclarations
	  });
	  var init_ts_JsDoc = __esm({
	    "src/services/_namespaces/ts.JsDoc.ts"() {
	      init_jsDoc();
	    }
	  });

	  // src/services/organizeImports.ts
	  function organizeImports(sourceFile, formatContext, host, program, preferences, mode) {
	    const changeTracker = ts_textChanges_exports.ChangeTracker.fromContext({ host, formatContext, preferences });
	    const shouldSort = mode === "SortAndCombine" /* SortAndCombine */ || mode === "All" /* All */;
	    const shouldCombine = shouldSort;
	    const shouldRemove = mode === "RemoveUnused" /* RemoveUnused */ || mode === "All" /* All */;
	    const topLevelImportGroupDecls = groupByNewlineContiguous(sourceFile, sourceFile.statements.filter(isImportDeclaration));
	    const comparer = getOrganizeImportsComparerWithDetection(preferences, shouldSort ? () => detectSortingWorker(topLevelImportGroupDecls, preferences) === 2 /* CaseInsensitive */ : void 0);
	    const processImportsOfSameModuleSpecifier = (importGroup) => {
	      if (shouldRemove)
	        importGroup = removeUnusedImports(importGroup, sourceFile, program);
	      if (shouldCombine)
	        importGroup = coalesceImportsWorker(importGroup, comparer, sourceFile, preferences);
	      if (shouldSort)
	        importGroup = stableSort(importGroup, (s1, s2) => compareImportsOrRequireStatements(s1, s2, comparer));
	      return importGroup;
	    };
	    topLevelImportGroupDecls.forEach((importGroupDecl) => organizeImportsWorker(importGroupDecl, processImportsOfSameModuleSpecifier));
	    if (mode !== "RemoveUnused" /* RemoveUnused */) {
	      getTopLevelExportGroups(sourceFile).forEach((exportGroupDecl) => organizeImportsWorker(exportGroupDecl, (group2) => coalesceExportsWorker(group2, comparer, preferences)));
	    }
	    for (const ambientModule of sourceFile.statements.filter(isAmbientModule)) {
	      if (!ambientModule.body)
	        continue;
	      const ambientModuleImportGroupDecls = groupByNewlineContiguous(sourceFile, ambientModule.body.statements.filter(isImportDeclaration));
	      ambientModuleImportGroupDecls.forEach((importGroupDecl) => organizeImportsWorker(importGroupDecl, processImportsOfSameModuleSpecifier));
	      if (mode !== "RemoveUnused" /* RemoveUnused */) {
	        const ambientModuleExportDecls = ambientModule.body.statements.filter(isExportDeclaration);
	        organizeImportsWorker(ambientModuleExportDecls, (group2) => coalesceExportsWorker(group2, comparer, preferences));
	      }
	    }
	    return changeTracker.getChanges();
	    function organizeImportsWorker(oldImportDecls, coalesce) {
	      if (length(oldImportDecls) === 0) {
	        return;
	      }
	      setEmitFlags(oldImportDecls[0], 1024 /* NoLeadingComments */);
	      const oldImportGroups = shouldCombine ? group(oldImportDecls, (importDecl) => getExternalModuleName2(importDecl.moduleSpecifier)) : [oldImportDecls];
	      const sortedImportGroups = shouldSort ? stableSort(oldImportGroups, (group1, group2) => compareModuleSpecifiersWorker(group1[0].moduleSpecifier, group2[0].moduleSpecifier, comparer)) : oldImportGroups;
	      const newImportDecls = flatMap(sortedImportGroups, (importGroup) => getExternalModuleName2(importGroup[0].moduleSpecifier) || importGroup[0].moduleSpecifier === void 0 ? coalesce(importGroup) : importGroup);
	      if (newImportDecls.length === 0) {
	        changeTracker.deleteNodes(
	          sourceFile,
	          oldImportDecls,
	          {
	            leadingTriviaOption: ts_textChanges_exports.LeadingTriviaOption.Exclude,
	            trailingTriviaOption: ts_textChanges_exports.TrailingTriviaOption.Include
	          },
	          /*hasTrailingComment*/
	          true
	        );
	      } else {
	        const replaceOptions = {
	          leadingTriviaOption: ts_textChanges_exports.LeadingTriviaOption.Exclude,
	          // Leave header comment in place
	          trailingTriviaOption: ts_textChanges_exports.TrailingTriviaOption.Include,
	          suffix: getNewLineOrDefaultFromHost(host, formatContext.options)
	        };
	        changeTracker.replaceNodeWithNodes(sourceFile, oldImportDecls[0], newImportDecls, replaceOptions);
	        const hasTrailingComment = changeTracker.nodeHasTrailingComment(sourceFile, oldImportDecls[0], replaceOptions);
	        changeTracker.deleteNodes(sourceFile, oldImportDecls.slice(1), {
	          trailingTriviaOption: ts_textChanges_exports.TrailingTriviaOption.Include
	        }, hasTrailingComment);
	      }
	    }
	  }
	  function groupByNewlineContiguous(sourceFile, decls) {
	    const scanner2 = createScanner(
	      sourceFile.languageVersion,
	      /*skipTrivia*/
	      false,
	      sourceFile.languageVariant
	    );
	    const group2 = [];
	    let groupIndex = 0;
	    for (const decl of decls) {
	      if (group2[groupIndex] && isNewGroup(sourceFile, decl, scanner2)) {
	        groupIndex++;
	      }
	      if (!group2[groupIndex]) {
	        group2[groupIndex] = [];
	      }
	      group2[groupIndex].push(decl);
	    }
	    return group2;
	  }
	  function isNewGroup(sourceFile, decl, scanner2) {
	    const startPos = decl.getFullStart();
	    const endPos = decl.getStart();
	    scanner2.setText(sourceFile.text, startPos, endPos - startPos);
	    let numberOfNewLines = 0;
	    while (scanner2.getTokenStart() < endPos) {
	      const tokenKind = scanner2.scan();
	      if (tokenKind === 4 /* NewLineTrivia */) {
	        numberOfNewLines++;
	        if (numberOfNewLines >= 2) {
	          return true;
	        }
	      }
	    }
	    return false;
	  }
	  function removeUnusedImports(oldImports, sourceFile, program) {
	    const typeChecker = program.getTypeChecker();
	    const compilerOptions = program.getCompilerOptions();
	    const jsxNamespace = typeChecker.getJsxNamespace(sourceFile);
	    const jsxFragmentFactory = typeChecker.getJsxFragmentFactory(sourceFile);
	    const jsxElementsPresent = !!(sourceFile.transformFlags & 2 /* ContainsJsx */);
	    const usedImports = [];
	    for (const importDecl of oldImports) {
	      const { importClause, moduleSpecifier } = importDecl;
	      if (!importClause) {
	        usedImports.push(importDecl);
	        continue;
	      }
	      let { name, namedBindings } = importClause;
	      if (name && !isDeclarationUsed(name)) {
	        name = void 0;
	      }
	      if (namedBindings) {
	        if (isNamespaceImport(namedBindings)) {
	          if (!isDeclarationUsed(namedBindings.name)) {
	            namedBindings = void 0;
	          }
	        } else {
	          const newElements = namedBindings.elements.filter((e) => isDeclarationUsed(e.name));
	          if (newElements.length < namedBindings.elements.length) {
	            namedBindings = newElements.length ? factory.updateNamedImports(namedBindings, newElements) : void 0;
	          }
	        }
	      }
	      if (name || namedBindings) {
	        usedImports.push(updateImportDeclarationAndClause(importDecl, name, namedBindings));
	      } else if (hasModuleDeclarationMatchingSpecifier(sourceFile, moduleSpecifier)) {
	        if (sourceFile.isDeclarationFile) {
	          usedImports.push(factory.createImportDeclaration(
	            importDecl.modifiers,
	            /*importClause*/
	            void 0,
	            moduleSpecifier,
	            /*attributes*/
	            void 0
	          ));
	        } else {
	          usedImports.push(importDecl);
	        }
	      }
	    }
	    return usedImports;
	    function isDeclarationUsed(identifier) {
	      return jsxElementsPresent && (identifier.text === jsxNamespace || jsxFragmentFactory && identifier.text === jsxFragmentFactory) && jsxModeNeedsExplicitImport(compilerOptions.jsx) || ts_FindAllReferences_exports.Core.isSymbolReferencedInFile(identifier, typeChecker, sourceFile);
	    }
	  }
	  function hasModuleDeclarationMatchingSpecifier(sourceFile, moduleSpecifier) {
	    const moduleSpecifierText = isStringLiteral(moduleSpecifier) && moduleSpecifier.text;
	    return isString(moduleSpecifierText) && some(sourceFile.moduleAugmentations, (moduleName) => isStringLiteral(moduleName) && moduleName.text === moduleSpecifierText);
	  }
	  function getExternalModuleName2(specifier) {
	    return specifier !== void 0 && isStringLiteralLike(specifier) ? specifier.text : void 0;
	  }
	  function coalesceImports(importGroup, ignoreCase, sourceFile, preferences) {
	    const comparer = getOrganizeImportsOrdinalStringComparer(ignoreCase);
	    return coalesceImportsWorker(importGroup, comparer, sourceFile, preferences);
	  }
	  function coalesceImportsWorker(importGroup, comparer, sourceFile, preferences) {
	    if (importGroup.length === 0) {
	      return importGroup;
	    }
	    const importGroupsByAttributes = groupBy(importGroup, (decl) => {
	      if (decl.attributes) {
	        let attrs = decl.attributes.token + " ";
	        for (const x of sort(decl.attributes.elements, (x2, y) => compareStringsCaseSensitive(x2.name.text, y.name.text))) {
	          attrs += x.name.text + ":";
	          attrs += isStringLiteralLike(x.value) ? `"${x.value.text}"` : x.value.getText() + " ";
	        }
	        return attrs;
	      }
	      return "";
	    });
	    const coalescedImports = [];
	    for (const attribute in importGroupsByAttributes) {
	      const importGroupSameAttrs = importGroupsByAttributes[attribute];
	      const { importWithoutClause, typeOnlyImports, regularImports } = getCategorizedImports(importGroupSameAttrs);
	      if (importWithoutClause) {
	        coalescedImports.push(importWithoutClause);
	      }
	      for (const group2 of [regularImports, typeOnlyImports]) {
	        const isTypeOnly = group2 === typeOnlyImports;
	        const { defaultImports, namespaceImports, namedImports } = group2;
	        if (!isTypeOnly && defaultImports.length === 1 && namespaceImports.length === 1 && namedImports.length === 0) {
	          const defaultImport = defaultImports[0];
	          coalescedImports.push(
	            updateImportDeclarationAndClause(defaultImport, defaultImport.importClause.name, namespaceImports[0].importClause.namedBindings)
	          );
	          continue;
	        }
	        const sortedNamespaceImports = stableSort(namespaceImports, (i1, i2) => comparer(i1.importClause.namedBindings.name.text, i2.importClause.namedBindings.name.text));
	        for (const namespaceImport of sortedNamespaceImports) {
	          coalescedImports.push(
	            updateImportDeclarationAndClause(
	              namespaceImport,
	              /*name*/
	              void 0,
	              namespaceImport.importClause.namedBindings
	            )
	          );
	        }
	        const firstDefaultImport = firstOrUndefined(defaultImports);
	        const firstNamedImport = firstOrUndefined(namedImports);
	        const importDecl = firstDefaultImport ?? firstNamedImport;
	        if (!importDecl) {
	          continue;
	        }
	        let newDefaultImport;
	        const newImportSpecifiers = [];
	        if (defaultImports.length === 1) {
	          newDefaultImport = defaultImports[0].importClause.name;
	        } else {
	          for (const defaultImport of defaultImports) {
	            newImportSpecifiers.push(
	              factory.createImportSpecifier(
	                /*isTypeOnly*/
	                false,
	                factory.createIdentifier("default"),
	                defaultImport.importClause.name
	              )
	            );
	          }
	        }
	        newImportSpecifiers.push(...getNewImportSpecifiers(namedImports));
	        const sortedImportSpecifiers = factory.createNodeArray(
	          sortSpecifiers(newImportSpecifiers, comparer, preferences),
	          firstNamedImport == null ? void 0 : firstNamedImport.importClause.namedBindings.elements.hasTrailingComma
	        );
	        const newNamedImports = sortedImportSpecifiers.length === 0 ? newDefaultImport ? void 0 : factory.createNamedImports(emptyArray) : firstNamedImport ? factory.updateNamedImports(firstNamedImport.importClause.namedBindings, sortedImportSpecifiers) : factory.createNamedImports(sortedImportSpecifiers);
	        if (sourceFile && newNamedImports && (firstNamedImport == null ? void 0 : firstNamedImport.importClause.namedBindings) && !rangeIsOnSingleLine(firstNamedImport.importClause.namedBindings, sourceFile)) {
	          setEmitFlags(newNamedImports, 2 /* MultiLine */);
	        }
	        if (isTypeOnly && newDefaultImport && newNamedImports) {
	          coalescedImports.push(
	            updateImportDeclarationAndClause(
	              importDecl,
	              newDefaultImport,
	              /*namedBindings*/
	              void 0
	            )
	          );
	          coalescedImports.push(
	            updateImportDeclarationAndClause(
	              firstNamedImport ?? importDecl,
	              /*name*/
	              void 0,
	              newNamedImports
	            )
	          );
	        } else {
	          coalescedImports.push(
	            updateImportDeclarationAndClause(importDecl, newDefaultImport, newNamedImports)
	          );
	        }
	      }
	    }
	    return coalescedImports;
	  }
	  function getCategorizedImports(importGroup) {
	    let importWithoutClause;
	    const typeOnlyImports = { defaultImports: [], namespaceImports: [], namedImports: [] };
	    const regularImports = { defaultImports: [], namespaceImports: [], namedImports: [] };
	    for (const importDeclaration of importGroup) {
	      if (importDeclaration.importClause === void 0) {
	        importWithoutClause = importWithoutClause || importDeclaration;
	        continue;
	      }
	      const group2 = importDeclaration.importClause.isTypeOnly ? typeOnlyImports : regularImports;
	      const { name, namedBindings } = importDeclaration.importClause;
	      if (name) {
	        group2.defaultImports.push(importDeclaration);
	      }
	      if (namedBindings) {
	        if (isNamespaceImport(namedBindings)) {
	          group2.namespaceImports.push(importDeclaration);
	        } else {
	          group2.namedImports.push(importDeclaration);
	        }
	      }
	    }
	    return {
	      importWithoutClause,
	      typeOnlyImports,
	      regularImports
	    };
	  }
	  function coalesceExports(exportGroup, ignoreCase, preferences) {
	    const comparer = getOrganizeImportsOrdinalStringComparer(ignoreCase);
	    return coalesceExportsWorker(exportGroup, comparer, preferences);
	  }
	  function coalesceExportsWorker(exportGroup, comparer, preferences) {
	    if (exportGroup.length === 0) {
	      return exportGroup;
	    }
	    const { exportWithoutClause, namedExports, typeOnlyExports } = getCategorizedExports(exportGroup);
	    const coalescedExports = [];
	    if (exportWithoutClause) {
	      coalescedExports.push(exportWithoutClause);
	    }
	    for (const exportGroup2 of [namedExports, typeOnlyExports]) {
	      if (exportGroup2.length === 0) {
	        continue;
	      }
	      const newExportSpecifiers = [];
	      newExportSpecifiers.push(...flatMap(exportGroup2, (i) => i.exportClause && isNamedExports(i.exportClause) ? i.exportClause.elements : emptyArray));
	      const sortedExportSpecifiers = sortSpecifiers(newExportSpecifiers, comparer, preferences);
	      const exportDecl = exportGroup2[0];
	      coalescedExports.push(
	        factory.updateExportDeclaration(
	          exportDecl,
	          exportDecl.modifiers,
	          exportDecl.isTypeOnly,
	          exportDecl.exportClause && (isNamedExports(exportDecl.exportClause) ? factory.updateNamedExports(exportDecl.exportClause, sortedExportSpecifiers) : factory.updateNamespaceExport(exportDecl.exportClause, exportDecl.exportClause.name)),
	          exportDecl.moduleSpecifier,
	          exportDecl.attributes
	        )
	      );
	    }
	    return coalescedExports;
	    function getCategorizedExports(exportGroup2) {
	      let exportWithoutClause2;
	      const namedExports2 = [];
	      const typeOnlyExports2 = [];
	      for (const exportDeclaration of exportGroup2) {
	        if (exportDeclaration.exportClause === void 0) {
	          exportWithoutClause2 = exportWithoutClause2 || exportDeclaration;
	        } else if (exportDeclaration.isTypeOnly) {
	          typeOnlyExports2.push(exportDeclaration);
	        } else {
	          namedExports2.push(exportDeclaration);
	        }
	      }
	      return {
	        exportWithoutClause: exportWithoutClause2,
	        namedExports: namedExports2,
	        typeOnlyExports: typeOnlyExports2
	      };
	    }
	  }
	  function updateImportDeclarationAndClause(importDeclaration, name, namedBindings) {
	    return factory.updateImportDeclaration(
	      importDeclaration,
	      importDeclaration.modifiers,
	      factory.updateImportClause(importDeclaration.importClause, importDeclaration.importClause.isTypeOnly, name, namedBindings),
	      // TODO: GH#18217
	      importDeclaration.moduleSpecifier,
	      importDeclaration.attributes
	    );
	  }
	  function sortSpecifiers(specifiers, comparer, preferences) {
	    return stableSort(specifiers, (s1, s2) => compareImportOrExportSpecifiers(s1, s2, comparer, preferences));
	  }
	  function compareImportOrExportSpecifiers(s1, s2, comparer, preferences) {
	    switch (preferences == null ? void 0 : preferences.organizeImportsTypeOrder) {
	      case "first":
	        return compareBooleans(s2.isTypeOnly, s1.isTypeOnly) || comparer(s1.name.text, s2.name.text);
	      case "inline":
	        return comparer(s1.name.text, s2.name.text);
	      default:
	        return compareBooleans(s1.isTypeOnly, s2.isTypeOnly) || comparer(s1.name.text, s2.name.text);
	    }
	  }
	  function compareModuleSpecifiers2(m1, m2, ignoreCase) {
	    const comparer = getOrganizeImportsOrdinalStringComparer(!!ignoreCase);
	    return compareModuleSpecifiersWorker(m1, m2, comparer);
	  }
	  function compareModuleSpecifiersWorker(m1, m2, comparer) {
	    const name1 = m1 === void 0 ? void 0 : getExternalModuleName2(m1);
	    const name2 = m2 === void 0 ? void 0 : getExternalModuleName2(m2);
	    return compareBooleans(name1 === void 0, name2 === void 0) || compareBooleans(isExternalModuleNameRelative(name1), isExternalModuleNameRelative(name2)) || comparer(name1, name2);
	  }
	  function getModuleSpecifierExpression(declaration) {
	    var _a;
	    switch (declaration.kind) {
	      case 271 /* ImportEqualsDeclaration */:
	        return (_a = tryCast(declaration.moduleReference, isExternalModuleReference)) == null ? void 0 : _a.expression;
	      case 272 /* ImportDeclaration */:
	        return declaration.moduleSpecifier;
	      case 243 /* VariableStatement */:
	        return declaration.declarationList.declarations[0].initializer.arguments[0];
	    }
	  }
	  function detectSorting(sourceFile, preferences) {
	    return detectSortingWorker(
	      groupByNewlineContiguous(sourceFile, sourceFile.statements.filter(isImportDeclaration)),
	      preferences
	    );
	  }
	  function detectSortingWorker(importGroups, preferences) {
	    const collateCaseSensitive = getOrganizeImportsComparer(
	      preferences,
	      /*ignoreCase*/
	      false
	    );
	    const collateCaseInsensitive = getOrganizeImportsComparer(
	      preferences,
	      /*ignoreCase*/
	      true
	    );
	    let sortState = 3 /* Both */;
	    let seenUnsortedGroup = false;
	    for (const importGroup of importGroups) {
	      if (importGroup.length > 1) {
	        const moduleSpecifierSort = detectSortCaseSensitivity(
	          importGroup,
	          (i) => {
	            var _a;
	            return ((_a = tryCast(i.moduleSpecifier, isStringLiteral)) == null ? void 0 : _a.text) ?? "";
	          },
	          collateCaseSensitive,
	          collateCaseInsensitive
	        );
	        if (moduleSpecifierSort) {
	          sortState &= moduleSpecifierSort;
	          seenUnsortedGroup = true;
	        }
	        if (!sortState) {
	          return sortState;
	        }
	      }
	      const declarationWithNamedImports = find(
	        importGroup,
	        (i) => {
	          var _a, _b;
	          return ((_b = tryCast((_a = i.importClause) == null ? void 0 : _a.namedBindings, isNamedImports)) == null ? void 0 : _b.elements.length) > 1;
	        }
	      );
	      if (declarationWithNamedImports) {
	        const namedImportSort = detectImportSpecifierSorting(declarationWithNamedImports.importClause.namedBindings.elements, preferences);
	        if (namedImportSort) {
	          sortState &= namedImportSort;
	          seenUnsortedGroup = true;
	        }
	        if (!sortState) {
	          return sortState;
	        }
	      }
	      if (sortState !== 3 /* Both */) {
	        return sortState;
	      }
	    }
	    return seenUnsortedGroup ? 0 /* None */ : sortState;
	  }
	  function detectImportDeclarationSorting(imports, preferences) {
	    const collateCaseSensitive = getOrganizeImportsComparer(
	      preferences,
	      /*ignoreCase*/
	      false
	    );
	    const collateCaseInsensitive = getOrganizeImportsComparer(
	      preferences,
	      /*ignoreCase*/
	      true
	    );
	    return detectSortCaseSensitivity(
	      imports,
	      (s) => getExternalModuleName2(getModuleSpecifierExpression(s)) || "",
	      collateCaseSensitive,
	      collateCaseInsensitive
	    );
	  }
	  function getImportDeclarationInsertionIndex(sortedImports, newImport, comparer) {
	    const index = binarySearch(sortedImports, newImport, identity, (a, b) => compareImportsOrRequireStatements(a, b, comparer));
	    return index < 0 ? ~index : index;
	  }
	  function getImportSpecifierInsertionIndex(sortedImports, newImport, comparer, preferences) {
	    const index = binarySearch(sortedImports, newImport, identity, (s1, s2) => compareImportOrExportSpecifiers(s1, s2, comparer, preferences));
	    return index < 0 ? ~index : index;
	  }
	  function compareImportsOrRequireStatements(s1, s2, comparer) {
	    return compareModuleSpecifiersWorker(getModuleSpecifierExpression(s1), getModuleSpecifierExpression(s2), comparer) || compareImportKind(s1, s2);
	  }
	  function compareImportKind(s1, s2) {
	    return compareValues(getImportKindOrder(s1), getImportKindOrder(s2));
	  }
	  function getImportKindOrder(s1) {
	    var _a;
	    switch (s1.kind) {
	      case 272 /* ImportDeclaration */:
	        if (!s1.importClause)
	          return 0;
	        if (s1.importClause.isTypeOnly)
	          return 1;
	        if (((_a = s1.importClause.namedBindings) == null ? void 0 : _a.kind) === 274 /* NamespaceImport */)
	          return 2;
	        if (s1.importClause.name)
	          return 3;
	        return 4;
	      case 271 /* ImportEqualsDeclaration */:
	        return 5;
	      case 243 /* VariableStatement */:
	        return 6;
	    }
	  }
	  function getNewImportSpecifiers(namedImports) {
	    return flatMap(namedImports, (namedImport) => map(tryGetNamedBindingElements(namedImport), (importSpecifier) => importSpecifier.name && importSpecifier.propertyName && importSpecifier.name.escapedText === importSpecifier.propertyName.escapedText ? factory.updateImportSpecifier(
	      importSpecifier,
	      importSpecifier.isTypeOnly,
	      /*propertyName*/
	      void 0,
	      importSpecifier.name
	    ) : importSpecifier));
	  }
	  function tryGetNamedBindingElements(namedImport) {
	    var _a;
	    return ((_a = namedImport.importClause) == null ? void 0 : _a.namedBindings) && isNamedImports(namedImport.importClause.namedBindings) ? namedImport.importClause.namedBindings.elements : void 0;
	  }
	  function getOrganizeImportsOrdinalStringComparer(ignoreCase) {
	    return ignoreCase ? compareStringsCaseInsensitiveEslintCompatible : compareStringsCaseSensitive;
	  }
	  function getOrganizeImportsUnicodeStringComparer(ignoreCase, preferences) {
	    const resolvedLocale = getOrganizeImportsLocale(preferences);
	    const caseFirst = preferences.organizeImportsCaseFirst ?? false;
	    const numeric = preferences.organizeImportsNumericCollation ?? false;
	    const accents = preferences.organizeImportsAccentCollation ?? true;
	    const sensitivity = ignoreCase ? accents ? "accent" : "base" : accents ? "variant" : "case";
	    const collator = new Intl.Collator(resolvedLocale, {
	      usage: "sort",
	      caseFirst: caseFirst || "false",
	      sensitivity,
	      numeric
	    });
	    return collator.compare;
	  }
	  function getOrganizeImportsLocale(preferences) {
	    let locale = preferences.organizeImportsLocale;
	    if (locale === "auto")
	      locale = getUILocale();
	    if (locale === void 0)
	      locale = "en";
	    const supportedLocales = Intl.Collator.supportedLocalesOf(locale);
	    const resolvedLocale = supportedLocales.length ? supportedLocales[0] : "en";
	    return resolvedLocale;
	  }
	  function getOrganizeImportsComparer(preferences, ignoreCase) {
	    const collation = preferences.organizeImportsCollation ?? "ordinal";
	    return collation === "unicode" ? getOrganizeImportsUnicodeStringComparer(ignoreCase, preferences) : getOrganizeImportsOrdinalStringComparer(ignoreCase);
	  }
	  function getOrganizeImportsComparerWithDetection(preferences, detectIgnoreCase) {
	    const ignoreCase = typeof preferences.organizeImportsIgnoreCase === "boolean" ? preferences.organizeImportsIgnoreCase : (detectIgnoreCase == null ? void 0 : detectIgnoreCase()) ?? false;
	    return getOrganizeImportsComparer(preferences, ignoreCase);
	  }
	  function getTopLevelExportGroups(sourceFile) {
	    const topLevelExportGroups = [];
	    const statements = sourceFile.statements;
	    const len = length(statements);
	    let i = 0;
	    let groupIndex = 0;
	    while (i < len) {
	      if (isExportDeclaration(statements[i])) {
	        if (topLevelExportGroups[groupIndex] === void 0) {
	          topLevelExportGroups[groupIndex] = [];
	        }
	        const exportDecl = statements[i];
	        if (exportDecl.moduleSpecifier) {
	          topLevelExportGroups[groupIndex].push(exportDecl);
	          i++;
	        } else {
	          while (i < len && isExportDeclaration(statements[i])) {
	            topLevelExportGroups[groupIndex].push(statements[i++]);
	          }
	          groupIndex++;
	        }
	      } else {
	        i++;
	      }
	    }
	    return flatMap(topLevelExportGroups, (exportGroupDecls) => groupByNewlineContiguous(sourceFile, exportGroupDecls));
	  }
	  var ImportSpecifierSortingCache, detectImportSpecifierSorting;
	  var init_organizeImports = __esm({
	    "src/services/organizeImports.ts"() {
	      init_ts4();
	      ImportSpecifierSortingCache = class {
	        has([specifiers, preferences]) {
	          if (this._lastPreferences !== preferences || !this._cache)
	            return false;
	          return this._cache.has(specifiers);
	        }
	        get([specifiers, preferences]) {
	          if (this._lastPreferences !== preferences || !this._cache)
	            return void 0;
	          return this._cache.get(specifiers);
	        }
	        set([specifiers, preferences], value) {
	          if (this._lastPreferences !== preferences) {
	            this._lastPreferences = preferences;
	            this._cache = void 0;
	          }
	          this._cache ?? (this._cache = /* @__PURE__ */ new WeakMap());
	          this._cache.set(specifiers, value);
	        }
	      };
	      detectImportSpecifierSorting = memoizeCached((specifiers, preferences) => {
	        switch (preferences.organizeImportsTypeOrder) {
	          case "first":
	            if (!arrayIsSorted(specifiers, (s1, s2) => compareBooleans(s2.isTypeOnly, s1.isTypeOnly)))
	              return 0 /* None */;
	            break;
	          case "inline":
	            if (!arrayIsSorted(specifiers, (s1, s2) => {
	              const comparer = getStringComparer(
	                /*ignoreCase*/
	                true
	              );
	              return comparer(s1.name.text, s2.name.text);
	            })) {
	              return 0 /* None */;
	            }
	            break;
	          default:
	            if (!arrayIsSorted(specifiers, (s1, s2) => compareBooleans(s1.isTypeOnly, s2.isTypeOnly)))
	              return 0 /* None */;
	            break;
	        }
	        const collateCaseSensitive = getOrganizeImportsComparer(
	          preferences,
	          /*ignoreCase*/
	          false
	        );
	        const collateCaseInsensitive = getOrganizeImportsComparer(
	          preferences,
	          /*ignoreCase*/
	          true
	        );
	        if (preferences.organizeImportsTypeOrder !== "inline") {
	          const { type: regularImports, regular: typeImports } = groupBy(specifiers, (s) => s.isTypeOnly ? "type" : "regular");
	          const regularCaseSensitivity = (regularImports == null ? void 0 : regularImports.length) ? detectSortCaseSensitivity(regularImports, (specifier) => specifier.name.text, collateCaseSensitive, collateCaseInsensitive) : void 0;
	          const typeCaseSensitivity = (typeImports == null ? void 0 : typeImports.length) ? detectSortCaseSensitivity(typeImports, (specifier) => specifier.name.text ?? "", collateCaseSensitive, collateCaseInsensitive) : void 0;
	          if (regularCaseSensitivity === void 0) {
	            return typeCaseSensitivity ?? 0 /* None */;
	          }
	          if (typeCaseSensitivity === void 0) {
	            return regularCaseSensitivity;
	          }
	          if (regularCaseSensitivity === 0 /* None */ || typeCaseSensitivity === 0 /* None */) {
	            return 0 /* None */;
	          }
	          return typeCaseSensitivity & regularCaseSensitivity;
	        }
	        return detectSortCaseSensitivity(specifiers, (specifier) => specifier.name.text, collateCaseSensitive, collateCaseInsensitive);
	      }, new ImportSpecifierSortingCache());
	    }
	  });

	  // src/services/_namespaces/ts.OrganizeImports.ts
	  var ts_OrganizeImports_exports = {};
	  __export(ts_OrganizeImports_exports, {
	    coalesceExports: () => coalesceExports,
	    coalesceImports: () => coalesceImports,
	    compareImportOrExportSpecifiers: () => compareImportOrExportSpecifiers,
	    compareImportsOrRequireStatements: () => compareImportsOrRequireStatements,
	    compareModuleSpecifiers: () => compareModuleSpecifiers2,
	    detectImportDeclarationSorting: () => detectImportDeclarationSorting,
	    detectImportSpecifierSorting: () => detectImportSpecifierSorting,
	    detectSorting: () => detectSorting,
	    getImportDeclarationInsertionIndex: () => getImportDeclarationInsertionIndex,
	    getImportSpecifierInsertionIndex: () => getImportSpecifierInsertionIndex,
	    getOrganizeImportsComparer: () => getOrganizeImportsComparer,
	    organizeImports: () => organizeImports
	  });
	  var init_ts_OrganizeImports = __esm({
	    "src/services/_namespaces/ts.OrganizeImports.ts"() {
	      init_organizeImports();
	    }
	  });

	  // src/services/outliningElementsCollector.ts
	  function collectElements(sourceFile, cancellationToken) {
	    const res = [];
	    addNodeOutliningSpans(sourceFile, cancellationToken, res);
	    addRegionOutliningSpans(sourceFile, res);
	    return res.sort((span1, span2) => span1.textSpan.start - span2.textSpan.start);
	  }
	  function addNodeOutliningSpans(sourceFile, cancellationToken, out) {
	    let depthRemaining = 40;
	    let current = 0;
	    const statements = [...sourceFile.statements, sourceFile.endOfFileToken];
	    const n = statements.length;
	    while (current < n) {
	      while (current < n && !isAnyImportSyntax(statements[current])) {
	        visitNode3(statements[current]);
	        current++;
	      }
	      if (current === n)
	        break;
	      const firstImport = current;
	      while (current < n && isAnyImportSyntax(statements[current])) {
	        visitNode3(statements[current]);
	        current++;
	      }
	      const lastImport = current - 1;
	      if (lastImport !== firstImport) {
	        out.push(createOutliningSpanFromBounds(findChildOfKind(statements[firstImport], 102 /* ImportKeyword */, sourceFile).getStart(sourceFile), statements[lastImport].getEnd(), "imports" /* Imports */));
	      }
	    }
	    function visitNode3(n2) {
	      var _a;
	      if (depthRemaining === 0)
	        return;
	      cancellationToken.throwIfCancellationRequested();
	      if (isDeclaration(n2) || isVariableStatement(n2) || isReturnStatement(n2) || isCallOrNewExpression(n2) || n2.kind === 1 /* EndOfFileToken */) {
	        addOutliningForLeadingCommentsForNode(n2, sourceFile, cancellationToken, out);
	      }
	      if (isFunctionLike(n2) && isBinaryExpression(n2.parent) && isPropertyAccessExpression(n2.parent.left)) {
	        addOutliningForLeadingCommentsForNode(n2.parent.left, sourceFile, cancellationToken, out);
	      }
	      if (isBlock(n2) || isModuleBlock(n2)) {
	        addOutliningForLeadingCommentsForPos(n2.statements.end, sourceFile, cancellationToken, out);
	      }
	      if (isClassLike(n2) || isInterfaceDeclaration(n2)) {
	        addOutliningForLeadingCommentsForPos(n2.members.end, sourceFile, cancellationToken, out);
	      }
	      const span = getOutliningSpanForNode(n2, sourceFile);
	      if (span)
	        out.push(span);
	      depthRemaining--;
	      if (isCallExpression(n2)) {
	        depthRemaining++;
	        visitNode3(n2.expression);
	        depthRemaining--;
	        n2.arguments.forEach(visitNode3);
	        (_a = n2.typeArguments) == null ? void 0 : _a.forEach(visitNode3);
	      } else if (isIfStatement(n2) && n2.elseStatement && isIfStatement(n2.elseStatement)) {
	        visitNode3(n2.expression);
	        visitNode3(n2.thenStatement);
	        depthRemaining++;
	        visitNode3(n2.elseStatement);
	        depthRemaining--;
	      } else {
	        n2.forEachChild(visitNode3);
	      }
	      depthRemaining++;
	    }
	  }
	  function addRegionOutliningSpans(sourceFile, out) {
	    const regions = [];
	    const lineStarts = sourceFile.getLineStarts();
	    for (const currentLineStart of lineStarts) {
	      const lineEnd = sourceFile.getLineEndOfPosition(currentLineStart);
	      const lineText = sourceFile.text.substring(currentLineStart, lineEnd);
	      const result = isRegionDelimiter(lineText);
	      if (!result || isInComment(sourceFile, currentLineStart)) {
	        continue;
	      }
	      if (!result[1]) {
	        const span = createTextSpanFromBounds(sourceFile.text.indexOf("//", currentLineStart), lineEnd);
	        regions.push(createOutliningSpan(
	          span,
	          "region" /* Region */,
	          span,
	          /*autoCollapse*/
	          false,
	          result[2] || "#region"
	        ));
	      } else {
	        const region = regions.pop();
	        if (region) {
	          region.textSpan.length = lineEnd - region.textSpan.start;
	          region.hintSpan.length = lineEnd - region.textSpan.start;
	          out.push(region);
	        }
	      }
	    }
	  }
	  function isRegionDelimiter(lineText) {
	    lineText = lineText.trimStart();
	    if (!startsWith(lineText, "//")) {
	      return null;
	    }
	    lineText = lineText.slice(2).trim();
	    return regionDelimiterRegExp.exec(lineText);
	  }
	  function addOutliningForLeadingCommentsForPos(pos, sourceFile, cancellationToken, out) {
	    const comments = getLeadingCommentRanges(sourceFile.text, pos);
	    if (!comments)
	      return;
	    let firstSingleLineCommentStart = -1;
	    let lastSingleLineCommentEnd = -1;
	    let singleLineCommentCount = 0;
	    const sourceText = sourceFile.getFullText();
	    for (const { kind, pos: pos2, end } of comments) {
	      cancellationToken.throwIfCancellationRequested();
	      switch (kind) {
	        case 2 /* SingleLineCommentTrivia */:
	          const commentText = sourceText.slice(pos2, end);
	          if (isRegionDelimiter(commentText)) {
	            combineAndAddMultipleSingleLineComments();
	            singleLineCommentCount = 0;
	            break;
	          }
	          if (singleLineCommentCount === 0) {
	            firstSingleLineCommentStart = pos2;
	          }
	          lastSingleLineCommentEnd = end;
	          singleLineCommentCount++;
	          break;
	        case 3 /* MultiLineCommentTrivia */:
	          combineAndAddMultipleSingleLineComments();
	          out.push(createOutliningSpanFromBounds(pos2, end, "comment" /* Comment */));
	          singleLineCommentCount = 0;
	          break;
	        default:
	          Debug.assertNever(kind);
	      }
	    }
	    combineAndAddMultipleSingleLineComments();
	    function combineAndAddMultipleSingleLineComments() {
	      if (singleLineCommentCount > 1) {
	        out.push(createOutliningSpanFromBounds(firstSingleLineCommentStart, lastSingleLineCommentEnd, "comment" /* Comment */));
	      }
	    }
	  }
	  function addOutliningForLeadingCommentsForNode(n, sourceFile, cancellationToken, out) {
	    if (isJsxText(n))
	      return;
	    addOutliningForLeadingCommentsForPos(n.pos, sourceFile, cancellationToken, out);
	  }
	  function createOutliningSpanFromBounds(pos, end, kind) {
	    return createOutliningSpan(createTextSpanFromBounds(pos, end), kind);
	  }
	  function getOutliningSpanForNode(n, sourceFile) {
	    switch (n.kind) {
	      case 241 /* Block */:
	        if (isFunctionLike(n.parent)) {
	          return functionSpan(n.parent, n, sourceFile);
	        }
	        switch (n.parent.kind) {
	          case 246 /* DoStatement */:
	          case 249 /* ForInStatement */:
	          case 250 /* ForOfStatement */:
	          case 248 /* ForStatement */:
	          case 245 /* IfStatement */:
	          case 247 /* WhileStatement */:
	          case 254 /* WithStatement */:
	          case 299 /* CatchClause */:
	            return spanForNode(n.parent);
	          case 258 /* TryStatement */:
	            const tryStatement = n.parent;
	            if (tryStatement.tryBlock === n) {
	              return spanForNode(n.parent);
	            } else if (tryStatement.finallyBlock === n) {
	              const node = findChildOfKind(tryStatement, 98 /* FinallyKeyword */, sourceFile);
	              if (node)
	                return spanForNode(node);
	            }
	          default:
	            return createOutliningSpan(createTextSpanFromNode(n, sourceFile), "code" /* Code */);
	        }
	      case 268 /* ModuleBlock */:
	        return spanForNode(n.parent);
	      case 263 /* ClassDeclaration */:
	      case 231 /* ClassExpression */:
	      case 264 /* InterfaceDeclaration */:
	      case 266 /* EnumDeclaration */:
	      case 269 /* CaseBlock */:
	      case 187 /* TypeLiteral */:
	      case 206 /* ObjectBindingPattern */:
	        return spanForNode(n);
	      case 189 /* TupleType */:
	        return spanForNode(
	          n,
	          /*autoCollapse*/
	          false,
	          /*useFullStart*/
	          !isTupleTypeNode(n.parent),
	          23 /* OpenBracketToken */
	        );
	      case 296 /* CaseClause */:
	      case 297 /* DefaultClause */:
	        return spanForNodeArray(n.statements);
	      case 210 /* ObjectLiteralExpression */:
	        return spanForObjectOrArrayLiteral(n);
	      case 209 /* ArrayLiteralExpression */:
	        return spanForObjectOrArrayLiteral(n, 23 /* OpenBracketToken */);
	      case 284 /* JsxElement */:
	        return spanForJSXElement(n);
	      case 288 /* JsxFragment */:
	        return spanForJSXFragment(n);
	      case 285 /* JsxSelfClosingElement */:
	      case 286 /* JsxOpeningElement */:
	        return spanForJSXAttributes(n.attributes);
	      case 228 /* TemplateExpression */:
	      case 15 /* NoSubstitutionTemplateLiteral */:
	        return spanForTemplateLiteral(n);
	      case 207 /* ArrayBindingPattern */:
	        return spanForNode(
	          n,
	          /*autoCollapse*/
	          false,
	          /*useFullStart*/
	          !isBindingElement(n.parent),
	          23 /* OpenBracketToken */
	        );
	      case 219 /* ArrowFunction */:
	        return spanForArrowFunction(n);
	      case 213 /* CallExpression */:
	        return spanForCallExpression(n);
	      case 217 /* ParenthesizedExpression */:
	        return spanForParenthesizedExpression(n);
	      case 275 /* NamedImports */:
	      case 279 /* NamedExports */:
	      case 300 /* ImportAttributes */:
	        return spanForImportExportElements(n);
	    }
	    function spanForImportExportElements(node) {
	      if (!node.elements.length) {
	        return void 0;
	      }
	      const openToken = findChildOfKind(node, 19 /* OpenBraceToken */, sourceFile);
	      const closeToken = findChildOfKind(node, 20 /* CloseBraceToken */, sourceFile);
	      if (!openToken || !closeToken || positionsAreOnSameLine(openToken.pos, closeToken.pos, sourceFile)) {
	        return void 0;
	      }
	      return spanBetweenTokens(
	        openToken,
	        closeToken,
	        node,
	        sourceFile,
	        /*autoCollapse*/
	        false,
	        /*useFullStart*/
	        false
	      );
	    }
	    function spanForCallExpression(node) {
	      if (!node.arguments.length) {
	        return void 0;
	      }
	      const openToken = findChildOfKind(node, 21 /* OpenParenToken */, sourceFile);
	      const closeToken = findChildOfKind(node, 22 /* CloseParenToken */, sourceFile);
	      if (!openToken || !closeToken || positionsAreOnSameLine(openToken.pos, closeToken.pos, sourceFile)) {
	        return void 0;
	      }
	      return spanBetweenTokens(
	        openToken,
	        closeToken,
	        node,
	        sourceFile,
	        /*autoCollapse*/
	        false,
	        /*useFullStart*/
	        true
	      );
	    }
	    function spanForArrowFunction(node) {
	      if (isBlock(node.body) || isParenthesizedExpression(node.body) || positionsAreOnSameLine(node.body.getFullStart(), node.body.getEnd(), sourceFile)) {
	        return void 0;
	      }
	      const textSpan = createTextSpanFromBounds(node.body.getFullStart(), node.body.getEnd());
	      return createOutliningSpan(textSpan, "code" /* Code */, createTextSpanFromNode(node));
	    }
	    function spanForJSXElement(node) {
	      const textSpan = createTextSpanFromBounds(node.openingElement.getStart(sourceFile), node.closingElement.getEnd());
	      const tagName = node.openingElement.tagName.getText(sourceFile);
	      const bannerText = "<" + tagName + ">...</" + tagName + ">";
	      return createOutliningSpan(
	        textSpan,
	        "code" /* Code */,
	        textSpan,
	        /*autoCollapse*/
	        false,
	        bannerText
	      );
	    }
	    function spanForJSXFragment(node) {
	      const textSpan = createTextSpanFromBounds(node.openingFragment.getStart(sourceFile), node.closingFragment.getEnd());
	      const bannerText = "<>...</>";
	      return createOutliningSpan(
	        textSpan,
	        "code" /* Code */,
	        textSpan,
	        /*autoCollapse*/
	        false,
	        bannerText
	      );
	    }
	    function spanForJSXAttributes(node) {
	      if (node.properties.length === 0) {
	        return void 0;
	      }
	      return createOutliningSpanFromBounds(node.getStart(sourceFile), node.getEnd(), "code" /* Code */);
	    }
	    function spanForTemplateLiteral(node) {
	      if (node.kind === 15 /* NoSubstitutionTemplateLiteral */ && node.text.length === 0) {
	        return void 0;
	      }
	      return createOutliningSpanFromBounds(node.getStart(sourceFile), node.getEnd(), "code" /* Code */);
	    }
	    function spanForObjectOrArrayLiteral(node, open = 19 /* OpenBraceToken */) {
	      return spanForNode(
	        node,
	        /*autoCollapse*/
	        false,
	        /*useFullStart*/
	        !isArrayLiteralExpression(node.parent) && !isCallExpression(node.parent),
	        open
	      );
	    }
	    function spanForNode(hintSpanNode, autoCollapse = false, useFullStart = true, open = 19 /* OpenBraceToken */, close = open === 19 /* OpenBraceToken */ ? 20 /* CloseBraceToken */ : 24 /* CloseBracketToken */) {
	      const openToken = findChildOfKind(n, open, sourceFile);
	      const closeToken = findChildOfKind(n, close, sourceFile);
	      return openToken && closeToken && spanBetweenTokens(openToken, closeToken, hintSpanNode, sourceFile, autoCollapse, useFullStart);
	    }
	    function spanForNodeArray(nodeArray) {
	      return nodeArray.length ? createOutliningSpan(createTextSpanFromRange(nodeArray), "code" /* Code */) : void 0;
	    }
	    function spanForParenthesizedExpression(node) {
	      if (positionsAreOnSameLine(node.getStart(), node.getEnd(), sourceFile))
	        return void 0;
	      const textSpan = createTextSpanFromBounds(node.getStart(), node.getEnd());
	      return createOutliningSpan(textSpan, "code" /* Code */, createTextSpanFromNode(node));
	    }
	  }
	  function functionSpan(node, body, sourceFile) {
	    const openToken = tryGetFunctionOpenToken(node, body, sourceFile);
	    const closeToken = findChildOfKind(body, 20 /* CloseBraceToken */, sourceFile);
	    return openToken && closeToken && spanBetweenTokens(
	      openToken,
	      closeToken,
	      node,
	      sourceFile,
	      /*autoCollapse*/
	      node.kind !== 219 /* ArrowFunction */
	    );
	  }
	  function spanBetweenTokens(openToken, closeToken, hintSpanNode, sourceFile, autoCollapse = false, useFullStart = true) {
	    const textSpan = createTextSpanFromBounds(useFullStart ? openToken.getFullStart() : openToken.getStart(sourceFile), closeToken.getEnd());
	    return createOutliningSpan(textSpan, "code" /* Code */, createTextSpanFromNode(hintSpanNode, sourceFile), autoCollapse);
	  }
	  function createOutliningSpan(textSpan, kind, hintSpan = textSpan, autoCollapse = false, bannerText = "...") {
	    return { textSpan, kind, hintSpan, bannerText, autoCollapse };
	  }
	  function tryGetFunctionOpenToken(node, body, sourceFile) {
	    if (isNodeArrayMultiLine(node.parameters, sourceFile)) {
	      const openParenToken = findChildOfKind(node, 21 /* OpenParenToken */, sourceFile);
	      if (openParenToken) {
	        return openParenToken;
	      }
	    }
	    return findChildOfKind(body, 19 /* OpenBraceToken */, sourceFile);
	  }
	  var regionDelimiterRegExp;
	  var init_outliningElementsCollector = __esm({
	    "src/services/outliningElementsCollector.ts"() {
	      init_ts4();
	      regionDelimiterRegExp = /^#(end)?region(?:\s+(.*))?(?:\r)?$/;
	    }
	  });

	  // src/services/_namespaces/ts.OutliningElementsCollector.ts
	  var ts_OutliningElementsCollector_exports = {};
	  __export(ts_OutliningElementsCollector_exports, {
	    collectElements: () => collectElements
	  });
	  var init_ts_OutliningElementsCollector = __esm({
	    "src/services/_namespaces/ts.OutliningElementsCollector.ts"() {
	      init_outliningElementsCollector();
	    }
	  });

	  // src/services/rename.ts
	  function getRenameInfo(program, sourceFile, position, preferences) {
	    const node = getAdjustedRenameLocation(getTouchingPropertyName(sourceFile, position));
	    if (nodeIsEligibleForRename(node)) {
	      const renameInfo = getRenameInfoForNode(node, program.getTypeChecker(), sourceFile, program, preferences);
	      if (renameInfo) {
	        return renameInfo;
	      }
	    }
	    return getRenameInfoError(Diagnostics.You_cannot_rename_this_element);
	  }
	  function getRenameInfoForNode(node, typeChecker, sourceFile, program, preferences) {
	    const symbol = typeChecker.getSymbolAtLocation(node);
	    if (!symbol) {
	      if (isStringLiteralLike(node)) {
	        const type = getContextualTypeFromParentOrAncestorTypeNode(node, typeChecker);
	        if (type && (type.flags & 128 /* StringLiteral */ || type.flags & 1048576 /* Union */ && every(type.types, (type2) => !!(type2.flags & 128 /* StringLiteral */)))) {
	          return getRenameInfoSuccess(node.text, node.text, "string" /* string */, "", node, sourceFile);
	        }
	      } else if (isLabelName(node)) {
	        const name = getTextOfNode(node);
	        return getRenameInfoSuccess(name, name, "label" /* label */, "" /* none */, node, sourceFile);
	      }
	      return void 0;
	    }
	    const { declarations } = symbol;
	    if (!declarations || declarations.length === 0)
	      return;
	    if (declarations.some((declaration) => isDefinedInLibraryFile(program, declaration))) {
	      return getRenameInfoError(Diagnostics.You_cannot_rename_elements_that_are_defined_in_the_standard_TypeScript_library);
	    }
	    if (isIdentifier(node) && node.escapedText === "default" && symbol.parent && symbol.parent.flags & 1536 /* Module */) {
	      return void 0;
	    }
	    if (isStringLiteralLike(node) && tryGetImportFromModuleSpecifier(node)) {
	      return preferences.allowRenameOfImportPath ? getRenameInfoForModule(node, sourceFile, symbol) : void 0;
	    }
	    const wouldRenameNodeModules = wouldRenameInOtherNodeModules(sourceFile, symbol, typeChecker, preferences);
	    if (wouldRenameNodeModules) {
	      return getRenameInfoError(wouldRenameNodeModules);
	    }
	    const kind = ts_SymbolDisplay_exports.getSymbolKind(typeChecker, symbol, node);
	    const specifierName = isImportOrExportSpecifierName(node) || isStringOrNumericLiteralLike(node) && node.parent.kind === 167 /* ComputedPropertyName */ ? stripQuotes(getTextOfIdentifierOrLiteral(node)) : void 0;
	    const displayName = specifierName || typeChecker.symbolToString(symbol);
	    const fullDisplayName = specifierName || typeChecker.getFullyQualifiedName(symbol);
	    return getRenameInfoSuccess(displayName, fullDisplayName, kind, ts_SymbolDisplay_exports.getSymbolModifiers(typeChecker, symbol), node, sourceFile);
	  }
	  function isDefinedInLibraryFile(program, declaration) {
	    const sourceFile = declaration.getSourceFile();
	    return program.isSourceFileDefaultLibrary(sourceFile) && fileExtensionIs(sourceFile.fileName, ".d.ts" /* Dts */);
	  }
	  function wouldRenameInOtherNodeModules(originalFile, symbol, checker, preferences) {
	    if (!preferences.providePrefixAndSuffixTextForRename && symbol.flags & 2097152 /* Alias */) {
	      const importSpecifier = symbol.declarations && find(symbol.declarations, (decl) => isImportSpecifier(decl));
	      if (importSpecifier && !importSpecifier.propertyName) {
	        symbol = checker.getAliasedSymbol(symbol);
	      }
	    }
	    const { declarations } = symbol;
	    if (!declarations) {
	      return void 0;
	    }
	    const originalPackage = getPackagePathComponents(originalFile.path);
	    if (originalPackage === void 0) {
	      if (some(declarations, (declaration) => isInsideNodeModules(declaration.getSourceFile().path))) {
	        return Diagnostics.You_cannot_rename_elements_that_are_defined_in_a_node_modules_folder;
	      } else {
	        return void 0;
	      }
	    }
	    for (const declaration of declarations) {
	      const declPackage = getPackagePathComponents(declaration.getSourceFile().path);
	      if (declPackage) {
	        const length2 = Math.min(originalPackage.length, declPackage.length);
	        for (let i = 0; i <= length2; i++) {
	          if (compareStringsCaseSensitive(originalPackage[i], declPackage[i]) !== 0 /* EqualTo */) {
	            return Diagnostics.You_cannot_rename_elements_that_are_defined_in_another_node_modules_folder;
	          }
	        }
	      }
	    }
	    return void 0;
	  }
	  function getPackagePathComponents(filePath) {
	    const components = getPathComponents(filePath);
	    const nodeModulesIdx = components.lastIndexOf("node_modules");
	    if (nodeModulesIdx === -1) {
	      return void 0;
	    }
	    return components.slice(0, nodeModulesIdx + 2);
	  }
	  function getRenameInfoForModule(node, sourceFile, moduleSymbol) {
	    if (!isExternalModuleNameRelative(node.text)) {
	      return getRenameInfoError(Diagnostics.You_cannot_rename_a_module_via_a_global_import);
	    }
	    const moduleSourceFile = moduleSymbol.declarations && find(moduleSymbol.declarations, isSourceFile);
	    if (!moduleSourceFile)
	      return void 0;
	    const withoutIndex = endsWith(node.text, "/index") || endsWith(node.text, "/index.js") ? void 0 : tryRemoveSuffix(removeFileExtension(moduleSourceFile.fileName), "/index");
	    const fileName = withoutIndex === void 0 ? moduleSourceFile.fileName : withoutIndex;
	    const kind = withoutIndex === void 0 ? "module" /* moduleElement */ : "directory" /* directory */;
	    const indexAfterLastSlash = node.text.lastIndexOf("/") + 1;
	    const triggerSpan = createTextSpan(node.getStart(sourceFile) + 1 + indexAfterLastSlash, node.text.length - indexAfterLastSlash);
	    return {
	      canRename: true,
	      fileToRename: fileName,
	      kind,
	      displayName: fileName,
	      fullDisplayName: node.text,
	      kindModifiers: "" /* none */,
	      triggerSpan
	    };
	  }
	  function getRenameInfoSuccess(displayName, fullDisplayName, kind, kindModifiers, node, sourceFile) {
	    return {
	      canRename: true,
	      fileToRename: void 0,
	      kind,
	      displayName,
	      fullDisplayName,
	      kindModifiers,
	      triggerSpan: createTriggerSpanForNode(node, sourceFile)
	    };
	  }
	  function getRenameInfoError(diagnostic) {
	    return { canRename: false, localizedErrorMessage: getLocaleSpecificMessage(diagnostic) };
	  }
	  function createTriggerSpanForNode(node, sourceFile) {
	    let start = node.getStart(sourceFile);
	    let width = node.getWidth(sourceFile);
	    if (isStringLiteralLike(node)) {
	      start += 1;
	      width -= 2;
	    }
	    return createTextSpan(start, width);
	  }
	  function nodeIsEligibleForRename(node) {
	    switch (node.kind) {
	      case 80 /* Identifier */:
	      case 81 /* PrivateIdentifier */:
	      case 11 /* StringLiteral */:
	      case 15 /* NoSubstitutionTemplateLiteral */:
	      case 110 /* ThisKeyword */:
	        return true;
	      case 9 /* NumericLiteral */:
	        return isLiteralNameOfPropertyDeclarationOrIndexAccess(node);
	      default:
	        return false;
	    }
	  }
	  var init_rename = __esm({
	    "src/services/rename.ts"() {
	      init_ts4();
	    }
	  });

	  // src/services/_namespaces/ts.Rename.ts
	  var ts_Rename_exports = {};
	  __export(ts_Rename_exports, {
	    getRenameInfo: () => getRenameInfo,
	    nodeIsEligibleForRename: () => nodeIsEligibleForRename
	  });
	  var init_ts_Rename = __esm({
	    "src/services/_namespaces/ts.Rename.ts"() {
	      init_rename();
	    }
	  });

	  // src/services/signatureHelp.ts
	  function getSignatureHelpItems(program, sourceFile, position, triggerReason, cancellationToken) {
	    const typeChecker = program.getTypeChecker();
	    const startingToken = findTokenOnLeftOfPosition(sourceFile, position);
	    if (!startingToken) {
	      return void 0;
	    }
	    const onlyUseSyntacticOwners = !!triggerReason && triggerReason.kind === "characterTyped";
	    if (onlyUseSyntacticOwners && (isInString(sourceFile, position, startingToken) || isInComment(sourceFile, position))) {
	      return void 0;
	    }
	    const isManuallyInvoked = !!triggerReason && triggerReason.kind === "invoked";
	    const argumentInfo = getContainingArgumentInfo(startingToken, position, sourceFile, typeChecker, isManuallyInvoked);
	    if (!argumentInfo)
	      return void 0;
	    cancellationToken.throwIfCancellationRequested();
	    const candidateInfo = getCandidateOrTypeInfo(argumentInfo, typeChecker, sourceFile, startingToken, onlyUseSyntacticOwners);
	    cancellationToken.throwIfCancellationRequested();
	    if (!candidateInfo) {
	      return isSourceFileJS(sourceFile) ? createJSSignatureHelpItems(argumentInfo, program, cancellationToken) : void 0;
	    }
	    return typeChecker.runWithCancellationToken(cancellationToken, (typeChecker2) => candidateInfo.kind === 0 /* Candidate */ ? createSignatureHelpItems(candidateInfo.candidates, candidateInfo.resolvedSignature, argumentInfo, sourceFile, typeChecker2) : createTypeHelpItems(candidateInfo.symbol, argumentInfo, sourceFile, typeChecker2));
	  }
	  function getCandidateOrTypeInfo({ invocation, argumentCount }, checker, sourceFile, startingToken, onlyUseSyntacticOwners) {
	    switch (invocation.kind) {
	      case 0 /* Call */: {
	        if (onlyUseSyntacticOwners && !isSyntacticOwner(startingToken, invocation.node, sourceFile)) {
	          return void 0;
	        }
	        const candidates = [];
	        const resolvedSignature = checker.getResolvedSignatureForSignatureHelp(invocation.node, candidates, argumentCount);
	        return candidates.length === 0 ? void 0 : { kind: 0 /* Candidate */, candidates, resolvedSignature };
	      }
	      case 1 /* TypeArgs */: {
	        const { called } = invocation;
	        if (onlyUseSyntacticOwners && !containsPrecedingToken(startingToken, sourceFile, isIdentifier(called) ? called.parent : called)) {
	          return void 0;
	        }
	        const candidates = getPossibleGenericSignatures(called, argumentCount, checker);
	        if (candidates.length !== 0)
	          return { kind: 0 /* Candidate */, candidates, resolvedSignature: first(candidates) };
	        const symbol = checker.getSymbolAtLocation(called);
	        return symbol && { kind: 1 /* Type */, symbol };
	      }
	      case 2 /* Contextual */:
	        return { kind: 0 /* Candidate */, candidates: [invocation.signature], resolvedSignature: invocation.signature };
	      default:
	        return Debug.assertNever(invocation);
	    }
	  }
	  function isSyntacticOwner(startingToken, node, sourceFile) {
	    if (!isCallOrNewExpression(node))
	      return false;
	    const invocationChildren = node.getChildren(sourceFile);
	    switch (startingToken.kind) {
	      case 21 /* OpenParenToken */:
	        return contains(invocationChildren, startingToken);
	      case 28 /* CommaToken */: {
	        const containingList = findContainingList(startingToken);
	        return !!containingList && contains(invocationChildren, containingList);
	      }
	      case 30 /* LessThanToken */:
	        return containsPrecedingToken(startingToken, sourceFile, node.expression);
	      default:
	        return false;
	    }
	  }
	  function createJSSignatureHelpItems(argumentInfo, program, cancellationToken) {
	    if (argumentInfo.invocation.kind === 2 /* Contextual */)
	      return void 0;
	    const expression = getExpressionFromInvocation(argumentInfo.invocation);
	    const name = isPropertyAccessExpression(expression) ? expression.name.text : void 0;
	    const typeChecker = program.getTypeChecker();
	    return name === void 0 ? void 0 : firstDefined(program.getSourceFiles(), (sourceFile) => firstDefined(sourceFile.getNamedDeclarations().get(name), (declaration) => {
	      const type = declaration.symbol && typeChecker.getTypeOfSymbolAtLocation(declaration.symbol, declaration);
	      const callSignatures = type && type.getCallSignatures();
	      if (callSignatures && callSignatures.length) {
	        return typeChecker.runWithCancellationToken(
	          cancellationToken,
	          (typeChecker2) => createSignatureHelpItems(
	            callSignatures,
	            callSignatures[0],
	            argumentInfo,
	            sourceFile,
	            typeChecker2,
	            /*useFullPrefix*/
	            true
	          )
	        );
	      }
	    }));
	  }
	  function containsPrecedingToken(startingToken, sourceFile, container) {
	    const pos = startingToken.getFullStart();
	    let currentParent = startingToken.parent;
	    while (currentParent) {
	      const precedingToken = findPrecedingToken(
	        pos,
	        sourceFile,
	        currentParent,
	        /*excludeJsdoc*/
	        true
	      );
	      if (precedingToken) {
	        return rangeContainsRange(container, precedingToken);
	      }
	      currentParent = currentParent.parent;
	    }
	    return Debug.fail("Could not find preceding token");
	  }
	  function getArgumentInfoForCompletions(node, position, sourceFile, checker) {
	    const info = getImmediatelyContainingArgumentInfo(node, position, sourceFile, checker);
	    return !info || info.isTypeParameterList || info.invocation.kind !== 0 /* Call */ ? void 0 : { invocation: info.invocation.node, argumentCount: info.argumentCount, argumentIndex: info.argumentIndex };
	  }
	  function getArgumentOrParameterListInfo(node, position, sourceFile, checker) {
	    const info = getArgumentOrParameterListAndIndex(node, sourceFile, checker);
	    if (!info)
	      return void 0;
	    const { list, argumentIndex } = info;
	    const argumentCount = getArgumentCount(checker, list);
	    if (argumentIndex !== 0) {
	      Debug.assertLessThan(argumentIndex, argumentCount);
	    }
	    const argumentsSpan = getApplicableSpanForArguments(list, sourceFile);
	    return { list, argumentIndex, argumentCount, argumentsSpan };
	  }
	  function getArgumentOrParameterListAndIndex(node, sourceFile, checker) {
	    if (node.kind === 30 /* LessThanToken */ || node.kind === 21 /* OpenParenToken */) {
	      return { list: getChildListThatStartsWithOpenerToken(node.parent, node, sourceFile), argumentIndex: 0 };
	    } else {
	      const list = findContainingList(node);
	      return list && { list, argumentIndex: getArgumentIndex(checker, list, node) };
	    }
	  }
	  function getImmediatelyContainingArgumentInfo(node, position, sourceFile, checker) {
	    const { parent: parent2 } = node;
	    if (isCallOrNewExpression(parent2)) {
	      const invocation = parent2;
	      const info = getArgumentOrParameterListInfo(node, position, sourceFile, checker);
	      if (!info)
	        return void 0;
	      const { list, argumentIndex, argumentCount, argumentsSpan } = info;
	      const isTypeParameterList = !!parent2.typeArguments && parent2.typeArguments.pos === list.pos;
	      return { isTypeParameterList, invocation: { kind: 0 /* Call */, node: invocation }, argumentsSpan, argumentIndex, argumentCount };
	    } else if (isNoSubstitutionTemplateLiteral(node) && isTaggedTemplateExpression(parent2)) {
	      if (isInsideTemplateLiteral(node, position, sourceFile)) {
	        return getArgumentListInfoForTemplate(
	          parent2,
	          /*argumentIndex*/
	          0,
	          sourceFile
	        );
	      }
	      return void 0;
	    } else if (isTemplateHead(node) && parent2.parent.kind === 215 /* TaggedTemplateExpression */) {
	      const templateExpression = parent2;
	      const tagExpression = templateExpression.parent;
	      Debug.assert(templateExpression.kind === 228 /* TemplateExpression */);
	      const argumentIndex = isInsideTemplateLiteral(node, position, sourceFile) ? 0 : 1;
	      return getArgumentListInfoForTemplate(tagExpression, argumentIndex, sourceFile);
	    } else if (isTemplateSpan(parent2) && isTaggedTemplateExpression(parent2.parent.parent)) {
	      const templateSpan = parent2;
	      const tagExpression = parent2.parent.parent;
	      if (isTemplateTail(node) && !isInsideTemplateLiteral(node, position, sourceFile)) {
	        return void 0;
	      }
	      const spanIndex = templateSpan.parent.templateSpans.indexOf(templateSpan);
	      const argumentIndex = getArgumentIndexForTemplatePiece(spanIndex, node, position, sourceFile);
	      return getArgumentListInfoForTemplate(tagExpression, argumentIndex, sourceFile);
	    } else if (isJsxOpeningLikeElement(parent2)) {
	      const attributeSpanStart = parent2.attributes.pos;
	      const attributeSpanEnd = skipTrivia(
	        sourceFile.text,
	        parent2.attributes.end,
	        /*stopAfterLineBreak*/
	        false
	      );
	      return {
	        isTypeParameterList: false,
	        invocation: { kind: 0 /* Call */, node: parent2 },
	        argumentsSpan: createTextSpan(attributeSpanStart, attributeSpanEnd - attributeSpanStart),
	        argumentIndex: 0,
	        argumentCount: 1
	      };
	    } else {
	      const typeArgInfo = getPossibleTypeArgumentsInfo(node, sourceFile);
	      if (typeArgInfo) {
	        const { called, nTypeArguments } = typeArgInfo;
	        const invocation = { kind: 1 /* TypeArgs */, called };
	        const argumentsSpan = createTextSpanFromBounds(called.getStart(sourceFile), node.end);
	        return { isTypeParameterList: true, invocation, argumentsSpan, argumentIndex: nTypeArguments, argumentCount: nTypeArguments + 1 };
	      }
	      return void 0;
	    }
	  }
	  function getImmediatelyContainingArgumentOrContextualParameterInfo(node, position, sourceFile, checker) {
	    return tryGetParameterInfo(node, position, sourceFile, checker) || getImmediatelyContainingArgumentInfo(node, position, sourceFile, checker);
	  }
	  function getHighestBinary(b) {
	    return isBinaryExpression(b.parent) ? getHighestBinary(b.parent) : b;
	  }
	  function countBinaryExpressionParameters(b) {
	    return isBinaryExpression(b.left) ? countBinaryExpressionParameters(b.left) + 1 : 2;
	  }
	  function tryGetParameterInfo(startingToken, position, sourceFile, checker) {
	    const node = getAdjustedNode(startingToken);
	    if (node === void 0)
	      return void 0;
	    const info = getContextualSignatureLocationInfo(node, sourceFile, position, checker);
	    if (info === void 0)
	      return void 0;
	    const { contextualType, argumentIndex, argumentCount, argumentsSpan } = info;
	    const nonNullableContextualType = contextualType.getNonNullableType();
	    const symbol = nonNullableContextualType.symbol;
	    if (symbol === void 0)
	      return void 0;
	    const signature = lastOrUndefined(nonNullableContextualType.getCallSignatures());
	    if (signature === void 0)
	      return void 0;
	    const invocation = { kind: 2 /* Contextual */, signature, node: startingToken, symbol: chooseBetterSymbol(symbol) };
	    return { isTypeParameterList: false, invocation, argumentsSpan, argumentIndex, argumentCount };
	  }
	  function getAdjustedNode(node) {
	    switch (node.kind) {
	      case 21 /* OpenParenToken */:
	      case 28 /* CommaToken */:
	        return node;
	      default:
	        return findAncestor(node.parent, (n) => isParameter(n) ? true : isBindingElement(n) || isObjectBindingPattern(n) || isArrayBindingPattern(n) ? false : "quit");
	    }
	  }
	  function getContextualSignatureLocationInfo(node, sourceFile, position, checker) {
	    const { parent: parent2 } = node;
	    switch (parent2.kind) {
	      case 217 /* ParenthesizedExpression */:
	      case 174 /* MethodDeclaration */:
	      case 218 /* FunctionExpression */:
	      case 219 /* ArrowFunction */:
	        const info = getArgumentOrParameterListInfo(node, position, sourceFile, checker);
	        if (!info)
	          return void 0;
	        const { argumentIndex, argumentCount, argumentsSpan } = info;
	        const contextualType = isMethodDeclaration(parent2) ? checker.getContextualTypeForObjectLiteralElement(parent2) : checker.getContextualType(parent2);
	        return contextualType && { contextualType, argumentIndex, argumentCount, argumentsSpan };
	      case 226 /* BinaryExpression */: {
	        const highestBinary = getHighestBinary(parent2);
	        const contextualType2 = checker.getContextualType(highestBinary);
	        const argumentIndex2 = node.kind === 21 /* OpenParenToken */ ? 0 : countBinaryExpressionParameters(parent2) - 1;
	        const argumentCount2 = countBinaryExpressionParameters(highestBinary);
	        return contextualType2 && { contextualType: contextualType2, argumentIndex: argumentIndex2, argumentCount: argumentCount2, argumentsSpan: createTextSpanFromNode(parent2) };
	      }
	      default:
	        return void 0;
	    }
	  }
	  function chooseBetterSymbol(s) {
	    return s.name === "__type" /* Type */ ? firstDefined(s.declarations, (d) => {
	      var _a;
	      return isFunctionTypeNode(d) ? (_a = tryCast(d.parent, canHaveSymbol)) == null ? void 0 : _a.symbol : void 0;
	    }) || s : s;
	  }
	  function getSpreadElementCount(node, checker) {
	    const spreadType = checker.getTypeAtLocation(node.expression);
	    if (checker.isTupleType(spreadType)) {
	      const { elementFlags, fixedLength } = spreadType.target;
	      if (fixedLength === 0) {
	        return 0;
	      }
	      const firstOptionalIndex = findIndex(elementFlags, (f) => !(f & 1 /* Required */));
	      return firstOptionalIndex < 0 ? fixedLength : firstOptionalIndex;
	    }
	    return 0;
	  }
	  function getArgumentIndex(checker, argumentsList, node) {
	    return getArgumentIndexOrCount(checker, argumentsList, node);
	  }
	  function getArgumentCount(checker, argumentsList) {
	    return getArgumentIndexOrCount(
	      checker,
	      argumentsList,
	      /*node*/
	      void 0
	    );
	  }
	  function getArgumentIndexOrCount(checker, argumentsList, node) {
	    const args = argumentsList.getChildren();
	    let argumentIndex = 0;
	    let skipComma = false;
	    for (const child of args) {
	      if (node && child === node) {
	        if (!skipComma && child.kind === 28 /* CommaToken */) {
	          argumentIndex++;
	        }
	        return argumentIndex;
	      }
	      if (isSpreadElement(child)) {
	        argumentIndex += getSpreadElementCount(child, checker);
	        skipComma = true;
	        continue;
	      }
	      if (child.kind !== 28 /* CommaToken */) {
	        argumentIndex++;
	        skipComma = true;
	        continue;
	      }
	      if (skipComma) {
	        skipComma = false;
	        continue;
	      }
	      argumentIndex++;
	    }
	    if (node) {
	      return argumentIndex;
	    }
	    return args.length && last(args).kind === 28 /* CommaToken */ ? argumentIndex + 1 : argumentIndex;
	  }
	  function getArgumentIndexForTemplatePiece(spanIndex, node, position, sourceFile) {
	    Debug.assert(position >= node.getStart(), "Assumed 'position' could not occur before node.");
	    if (isTemplateLiteralToken(node)) {
	      if (isInsideTemplateLiteral(node, position, sourceFile)) {
	        return 0;
	      }
	      return spanIndex + 2;
	    }
	    return spanIndex + 1;
	  }
	  function getArgumentListInfoForTemplate(tagExpression, argumentIndex, sourceFile) {
	    const argumentCount = isNoSubstitutionTemplateLiteral(tagExpression.template) ? 1 : tagExpression.template.templateSpans.length + 1;
	    if (argumentIndex !== 0) {
	      Debug.assertLessThan(argumentIndex, argumentCount);
	    }
	    return {
	      isTypeParameterList: false,
	      invocation: { kind: 0 /* Call */, node: tagExpression },
	      argumentsSpan: getApplicableSpanForTaggedTemplate(tagExpression, sourceFile),
	      argumentIndex,
	      argumentCount
	    };
	  }
	  function getApplicableSpanForArguments(argumentsList, sourceFile) {
	    const applicableSpanStart = argumentsList.getFullStart();
	    const applicableSpanEnd = skipTrivia(
	      sourceFile.text,
	      argumentsList.getEnd(),
	      /*stopAfterLineBreak*/
	      false
	    );
	    return createTextSpan(applicableSpanStart, applicableSpanEnd - applicableSpanStart);
	  }
	  function getApplicableSpanForTaggedTemplate(taggedTemplate, sourceFile) {
	    const template = taggedTemplate.template;
	    const applicableSpanStart = template.getStart();
	    let applicableSpanEnd = template.getEnd();
	    if (template.kind === 228 /* TemplateExpression */) {
	      const lastSpan = last(template.templateSpans);
	      if (lastSpan.literal.getFullWidth() === 0) {
	        applicableSpanEnd = skipTrivia(
	          sourceFile.text,
	          applicableSpanEnd,
	          /*stopAfterLineBreak*/
	          false
	        );
	      }
	    }
	    return createTextSpan(applicableSpanStart, applicableSpanEnd - applicableSpanStart);
	  }
	  function getContainingArgumentInfo(node, position, sourceFile, checker, isManuallyInvoked) {
	    for (let n = node; !isSourceFile(n) && (isManuallyInvoked || !isBlock(n)); n = n.parent) {
	      Debug.assert(rangeContainsRange(n.parent, n), "Not a subspan", () => `Child: ${Debug.formatSyntaxKind(n.kind)}, parent: ${Debug.formatSyntaxKind(n.parent.kind)}`);
	      const argumentInfo = getImmediatelyContainingArgumentOrContextualParameterInfo(n, position, sourceFile, checker);
	      if (argumentInfo) {
	        return argumentInfo;
	      }
	    }
	    return void 0;
	  }
	  function getChildListThatStartsWithOpenerToken(parent2, openerToken, sourceFile) {
	    const children = parent2.getChildren(sourceFile);
	    const indexOfOpenerToken = children.indexOf(openerToken);
	    Debug.assert(indexOfOpenerToken >= 0 && children.length > indexOfOpenerToken + 1);
	    return children[indexOfOpenerToken + 1];
	  }
	  function getExpressionFromInvocation(invocation) {
	    return invocation.kind === 0 /* Call */ ? getInvokedExpression(invocation.node) : invocation.called;
	  }
	  function getEnclosingDeclarationFromInvocation(invocation) {
	    return invocation.kind === 0 /* Call */ ? invocation.node : invocation.kind === 1 /* TypeArgs */ ? invocation.called : invocation.node;
	  }
	  function createSignatureHelpItems(candidates, resolvedSignature, { isTypeParameterList, argumentCount, argumentsSpan: applicableSpan, invocation, argumentIndex }, sourceFile, typeChecker, useFullPrefix) {
	    var _a;
	    const enclosingDeclaration = getEnclosingDeclarationFromInvocation(invocation);
	    const callTargetSymbol = invocation.kind === 2 /* Contextual */ ? invocation.symbol : typeChecker.getSymbolAtLocation(getExpressionFromInvocation(invocation)) || useFullPrefix && ((_a = resolvedSignature.declaration) == null ? void 0 : _a.symbol);
	    const callTargetDisplayParts = callTargetSymbol ? symbolToDisplayParts(
	      typeChecker,
	      callTargetSymbol,
	      useFullPrefix ? sourceFile : void 0,
	      /*meaning*/
	      void 0
	    ) : emptyArray;
	    const items = map(candidates, (candidateSignature) => getSignatureHelpItem(candidateSignature, callTargetDisplayParts, isTypeParameterList, typeChecker, enclosingDeclaration, sourceFile));
	    if (argumentIndex !== 0) {
	      Debug.assertLessThan(argumentIndex, argumentCount);
	    }
	    let selectedItemIndex = 0;
	    let itemsSeen = 0;
	    for (let i = 0; i < items.length; i++) {
	      const item = items[i];
	      if (candidates[i] === resolvedSignature) {
	        selectedItemIndex = itemsSeen;
	        if (item.length > 1) {
	          let count = 0;
	          for (const i2 of item) {
	            if (i2.isVariadic || i2.parameters.length >= argumentCount) {
	              selectedItemIndex = itemsSeen + count;
	              break;
	            }
	            count++;
	          }
	        }
	      }
	      itemsSeen += item.length;
	    }
	    Debug.assert(selectedItemIndex !== -1);
	    const help = { items: flatMapToMutable(items, identity), applicableSpan, selectedItemIndex, argumentIndex, argumentCount };
	    const selected = help.items[selectedItemIndex];
	    if (selected.isVariadic) {
	      const firstRest = findIndex(selected.parameters, (p) => !!p.isRest);
	      if (-1 < firstRest && firstRest < selected.parameters.length - 1) {
	        help.argumentIndex = selected.parameters.length;
	      } else {
	        help.argumentIndex = Math.min(help.argumentIndex, selected.parameters.length - 1);
	      }
	    }
	    return help;
	  }
	  function createTypeHelpItems(symbol, { argumentCount, argumentsSpan: applicableSpan, invocation, argumentIndex }, sourceFile, checker) {
	    const typeParameters = checker.getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(symbol);
	    if (!typeParameters)
	      return void 0;
	    const items = [getTypeHelpItem(symbol, typeParameters, checker, getEnclosingDeclarationFromInvocation(invocation), sourceFile)];
	    return { items, applicableSpan, selectedItemIndex: 0, argumentIndex, argumentCount };
	  }
	  function getTypeHelpItem(symbol, typeParameters, checker, enclosingDeclaration, sourceFile) {
	    const typeSymbolDisplay = symbolToDisplayParts(checker, symbol);
	    const printer = createPrinterWithRemoveComments();
	    const parameters = typeParameters.map((t) => createSignatureHelpParameterForTypeParameter(t, checker, enclosingDeclaration, sourceFile, printer));
	    const documentation = symbol.getDocumentationComment(checker);
	    const tags = symbol.getJsDocTags(checker);
	    const prefixDisplayParts = [...typeSymbolDisplay, punctuationPart(30 /* LessThanToken */)];
	    return { isVariadic: false, prefixDisplayParts, suffixDisplayParts: [punctuationPart(32 /* GreaterThanToken */)], separatorDisplayParts, parameters, documentation, tags };
	  }
	  function getSignatureHelpItem(candidateSignature, callTargetDisplayParts, isTypeParameterList, checker, enclosingDeclaration, sourceFile) {
	    const infos = (isTypeParameterList ? itemInfoForTypeParameters : itemInfoForParameters)(candidateSignature, checker, enclosingDeclaration, sourceFile);
	    return map(infos, ({ isVariadic, parameters, prefix, suffix }) => {
	      const prefixDisplayParts = [...callTargetDisplayParts, ...prefix];
	      const suffixDisplayParts = [...suffix, ...returnTypeToDisplayParts(candidateSignature, enclosingDeclaration, checker)];
	      const documentation = candidateSignature.getDocumentationComment(checker);
	      const tags = candidateSignature.getJsDocTags();
	      return { isVariadic, prefixDisplayParts, suffixDisplayParts, separatorDisplayParts, parameters, documentation, tags };
	    });
	  }
	  function returnTypeToDisplayParts(candidateSignature, enclosingDeclaration, checker) {
	    return mapToDisplayParts((writer) => {
	      writer.writePunctuation(":");
	      writer.writeSpace(" ");
	      const predicate = checker.getTypePredicateOfSignature(candidateSignature);
	      if (predicate) {
	        checker.writeTypePredicate(
	          predicate,
	          enclosingDeclaration,
	          /*flags*/
	          void 0,
	          writer
	        );
	      } else {
	        checker.writeType(
	          checker.getReturnTypeOfSignature(candidateSignature),
	          enclosingDeclaration,
	          /*flags*/
	          void 0,
	          writer
	        );
	      }
	    });
	  }
	  function itemInfoForTypeParameters(candidateSignature, checker, enclosingDeclaration, sourceFile) {
	    const typeParameters = (candidateSignature.target || candidateSignature).typeParameters;
	    const printer = createPrinterWithRemoveComments();
	    const parameters = (typeParameters || emptyArray).map((t) => createSignatureHelpParameterForTypeParameter(t, checker, enclosingDeclaration, sourceFile, printer));
	    const thisParameter = candidateSignature.thisParameter ? [checker.symbolToParameterDeclaration(candidateSignature.thisParameter, enclosingDeclaration, signatureHelpNodeBuilderFlags)] : [];
	    return checker.getExpandedParameters(candidateSignature).map((paramList) => {
	      const params = factory.createNodeArray([...thisParameter, ...map(paramList, (param) => checker.symbolToParameterDeclaration(param, enclosingDeclaration, signatureHelpNodeBuilderFlags))]);
	      const parameterParts = mapToDisplayParts((writer) => {
	        printer.writeList(2576 /* CallExpressionArguments */, params, sourceFile, writer);
	      });
	      return { isVariadic: false, parameters, prefix: [punctuationPart(30 /* LessThanToken */)], suffix: [punctuationPart(32 /* GreaterThanToken */), ...parameterParts] };
	    });
	  }
	  function itemInfoForParameters(candidateSignature, checker, enclosingDeclaration, sourceFile) {
	    const printer = createPrinterWithRemoveComments();
	    const typeParameterParts = mapToDisplayParts((writer) => {
	      if (candidateSignature.typeParameters && candidateSignature.typeParameters.length) {
	        const args = factory.createNodeArray(candidateSignature.typeParameters.map((p) => checker.typeParameterToDeclaration(p, enclosingDeclaration, signatureHelpNodeBuilderFlags)));
	        printer.writeList(53776 /* TypeParameters */, args, sourceFile, writer);
	      }
	    });
	    const lists = checker.getExpandedParameters(candidateSignature);
	    const isVariadic = !checker.hasEffectiveRestParameter(candidateSignature) ? (_) => false : lists.length === 1 ? (_) => true : (pList) => {
	      var _a;
	      return !!(pList.length && ((_a = tryCast(pList[pList.length - 1], isTransientSymbol)) == null ? void 0 : _a.links.checkFlags) & 32768 /* RestParameter */);
	    };
	    return lists.map((parameterList) => ({
	      isVariadic: isVariadic(parameterList),
	      parameters: parameterList.map((p) => createSignatureHelpParameterForParameter(p, checker, enclosingDeclaration, sourceFile, printer)),
	      prefix: [...typeParameterParts, punctuationPart(21 /* OpenParenToken */)],
	      suffix: [punctuationPart(22 /* CloseParenToken */)]
	    }));
	  }
	  function createSignatureHelpParameterForParameter(parameter, checker, enclosingDeclaration, sourceFile, printer) {
	    const displayParts = mapToDisplayParts((writer) => {
	      const param = checker.symbolToParameterDeclaration(parameter, enclosingDeclaration, signatureHelpNodeBuilderFlags);
	      printer.writeNode(4 /* Unspecified */, param, sourceFile, writer);
	    });
	    const isOptional = checker.isOptionalParameter(parameter.valueDeclaration);
	    const isRest = isTransientSymbol(parameter) && !!(parameter.links.checkFlags & 32768 /* RestParameter */);
	    return { name: parameter.name, documentation: parameter.getDocumentationComment(checker), displayParts, isOptional, isRest };
	  }
	  function createSignatureHelpParameterForTypeParameter(typeParameter, checker, enclosingDeclaration, sourceFile, printer) {
	    const displayParts = mapToDisplayParts((writer) => {
	      const param = checker.typeParameterToDeclaration(typeParameter, enclosingDeclaration, signatureHelpNodeBuilderFlags);
	      printer.writeNode(4 /* Unspecified */, param, sourceFile, writer);
	    });
	    return { name: typeParameter.symbol.name, documentation: typeParameter.symbol.getDocumentationComment(checker), displayParts, isOptional: false, isRest: false };
	  }
	  var signatureHelpNodeBuilderFlags, separatorDisplayParts;
	  var init_signatureHelp = __esm({
	    "src/services/signatureHelp.ts"() {
	      init_ts4();
	      signatureHelpNodeBuilderFlags = 8192 /* OmitParameterModifiers */ | 70221824 /* IgnoreErrors */ | 16384 /* UseAliasDefinedOutsideCurrentScope */;
	      separatorDisplayParts = [punctuationPart(28 /* CommaToken */), spacePart()];
	    }
	  });

	  // src/services/_namespaces/ts.SignatureHelp.ts
	  var ts_SignatureHelp_exports = {};
	  __export(ts_SignatureHelp_exports, {
	    getArgumentInfoForCompletions: () => getArgumentInfoForCompletions,
	    getSignatureHelpItems: () => getSignatureHelpItems
	  });
	  var init_ts_SignatureHelp = __esm({
	    "src/services/_namespaces/ts.SignatureHelp.ts"() {
	      init_signatureHelp();
	    }
	  });

	  // src/services/smartSelection.ts
	  function getSmartSelectionRange(pos, sourceFile) {
	    var _a, _b;
	    let selectionRange = {
	      textSpan: createTextSpanFromBounds(sourceFile.getFullStart(), sourceFile.getEnd())
	    };
	    let parentNode = sourceFile;
	    outer:
	      while (true) {
	        const children = getSelectionChildren(parentNode);
	        if (!children.length)
	          break;
	        for (let i = 0; i < children.length; i++) {
	          const prevNode = children[i - 1];
	          const node = children[i];
	          const nextNode = children[i + 1];
	          if (getTokenPosOfNode(
	            node,
	            sourceFile,
	            /*includeJsDoc*/
	            true
	          ) > pos) {
	            break outer;
	          }
	          const comment = singleOrUndefined(getTrailingCommentRanges(sourceFile.text, node.end));
	          if (comment && comment.kind === 2 /* SingleLineCommentTrivia */) {
	            pushSelectionCommentRange(comment.pos, comment.end);
	          }
	          if (positionShouldSnapToNode(sourceFile, pos, node)) {
	            if (isFunctionBody(node) && isFunctionLikeDeclaration(parentNode) && !positionsAreOnSameLine(node.getStart(sourceFile), node.getEnd(), sourceFile)) {
	              pushSelectionRange(node.getStart(sourceFile), node.getEnd());
	            }
	            if (isBlock(node) || isTemplateSpan(node) || isTemplateHead(node) || isTemplateTail(node) || prevNode && isTemplateHead(prevNode) || isVariableDeclarationList(node) && isVariableStatement(parentNode) || isSyntaxList(node) && isVariableDeclarationList(parentNode) || isVariableDeclaration(node) && isSyntaxList(parentNode) && children.length === 1 || isJSDocTypeExpression(node) || isJSDocSignature(node) || isJSDocTypeLiteral(node)) {
	              parentNode = node;
	              break;
	            }
	            if (isTemplateSpan(parentNode) && nextNode && isTemplateMiddleOrTemplateTail(nextNode)) {
	              const start2 = node.getFullStart() - "${".length;
	              const end2 = nextNode.getStart() + "}".length;
	              pushSelectionRange(start2, end2);
	            }
	            const isBetweenMultiLineBookends = isSyntaxList(node) && isListOpener(prevNode) && isListCloser(nextNode) && !positionsAreOnSameLine(prevNode.getStart(), nextNode.getStart(), sourceFile);
	            let start = isBetweenMultiLineBookends ? prevNode.getEnd() : node.getStart();
	            const end = isBetweenMultiLineBookends ? nextNode.getStart() : getEndPos(sourceFile, node);
	            if (hasJSDocNodes(node) && ((_a = node.jsDoc) == null ? void 0 : _a.length)) {
	              pushSelectionRange(first(node.jsDoc).getStart(), end);
	            }
	            if (isSyntaxList(node)) {
	              const firstChild = node.getChildren()[0];
	              if (firstChild && hasJSDocNodes(firstChild) && ((_b = firstChild.jsDoc) == null ? void 0 : _b.length) && firstChild.getStart() !== node.pos) {
	                start = Math.min(start, first(firstChild.jsDoc).getStart());
	              }
	            }
	            pushSelectionRange(start, end);
	            if (isStringLiteral(node) || isTemplateLiteral(node)) {
	              pushSelectionRange(start + 1, end - 1);
	            }
	            parentNode = node;
	            break;
	          }
	          if (i === children.length - 1) {
	            break outer;
	          }
	        }
	      }
	    return selectionRange;
	    function pushSelectionRange(start, end) {
	      if (start !== end) {
	        const textSpan = createTextSpanFromBounds(start, end);
	        if (!selectionRange || // Skip ranges that are identical to the parent
	        !textSpansEqual(textSpan, selectionRange.textSpan) && // Skip ranges that don't contain the original position
	        textSpanIntersectsWithPosition(textSpan, pos)) {
	          selectionRange = { textSpan, ...selectionRange && { parent: selectionRange } };
	        }
	      }
	    }
	    function pushSelectionCommentRange(start, end) {
	      pushSelectionRange(start, end);
	      let pos2 = start;
	      while (sourceFile.text.charCodeAt(pos2) === 47 /* slash */) {
	        pos2++;
	      }
	      pushSelectionRange(pos2, end);
	    }
	  }
	  function positionShouldSnapToNode(sourceFile, pos, node) {
	    Debug.assert(node.pos <= pos);
	    if (pos < node.end) {
	      return true;
	    }
	    const nodeEnd = node.getEnd();
	    if (nodeEnd === pos) {
	      return getTouchingPropertyName(sourceFile, pos).pos < node.end;
	    }
	    return false;
	  }
	  function getSelectionChildren(node) {
	    var _a;
	    if (isSourceFile(node)) {
	      return groupChildren(node.getChildAt(0).getChildren(), isImport2);
	    }
	    if (isMappedTypeNode(node)) {
	      const [openBraceToken, ...children] = node.getChildren();
	      const closeBraceToken = Debug.checkDefined(children.pop());
	      Debug.assertEqual(openBraceToken.kind, 19 /* OpenBraceToken */);
	      Debug.assertEqual(closeBraceToken.kind, 20 /* CloseBraceToken */);
	      const groupedWithPlusMinusTokens = groupChildren(children, (child) => child === node.readonlyToken || child.kind === 148 /* ReadonlyKeyword */ || child === node.questionToken || child.kind === 58 /* QuestionToken */);
	      const groupedWithBrackets = groupChildren(groupedWithPlusMinusTokens, ({ kind }) => kind === 23 /* OpenBracketToken */ || kind === 168 /* TypeParameter */ || kind === 24 /* CloseBracketToken */);
	      return [
	        openBraceToken,
	        // Pivot on `:`
	        createSyntaxList2(splitChildren(groupedWithBrackets, ({ kind }) => kind === 59 /* ColonToken */)),
	        closeBraceToken
	      ];
	    }
	    if (isPropertySignature(node)) {
	      const children = groupChildren(node.getChildren(), (child) => child === node.name || contains(node.modifiers, child));
	      const firstJSDocChild = ((_a = children[0]) == null ? void 0 : _a.kind) === 327 /* JSDoc */ ? children[0] : void 0;
	      const withJSDocSeparated = firstJSDocChild ? children.slice(1) : children;
	      const splittedChildren = splitChildren(withJSDocSeparated, ({ kind }) => kind === 59 /* ColonToken */);
	      return firstJSDocChild ? [firstJSDocChild, createSyntaxList2(splittedChildren)] : splittedChildren;
	    }
	    if (isParameter(node)) {
	      const groupedDotDotDotAndName = groupChildren(node.getChildren(), (child) => child === node.dotDotDotToken || child === node.name);
	      const groupedWithQuestionToken = groupChildren(groupedDotDotDotAndName, (child) => child === groupedDotDotDotAndName[0] || child === node.questionToken);
	      return splitChildren(groupedWithQuestionToken, ({ kind }) => kind === 64 /* EqualsToken */);
	    }
	    if (isBindingElement(node)) {
	      return splitChildren(node.getChildren(), ({ kind }) => kind === 64 /* EqualsToken */);
	    }
	    return node.getChildren();
	  }
	  function groupChildren(children, groupOn) {
	    const result = [];
	    let group2;
	    for (const child of children) {
	      if (groupOn(child)) {
	        group2 = group2 || [];
	        group2.push(child);
	      } else {
	        if (group2) {
	          result.push(createSyntaxList2(group2));
	          group2 = void 0;
	        }
	        result.push(child);
	      }
	    }
	    if (group2) {
	      result.push(createSyntaxList2(group2));
	    }
	    return result;
	  }
	  function splitChildren(children, pivotOn, separateTrailingSemicolon = true) {
	    if (children.length < 2) {
	      return children;
	    }
	    const splitTokenIndex = findIndex(children, pivotOn);
	    if (splitTokenIndex === -1) {
	      return children;
	    }
	    const leftChildren = children.slice(0, splitTokenIndex);
	    const splitToken = children[splitTokenIndex];
	    const lastToken = last(children);
	    const separateLastToken = separateTrailingSemicolon && lastToken.kind === 27 /* SemicolonToken */;
	    const rightChildren = children.slice(splitTokenIndex + 1, separateLastToken ? children.length - 1 : void 0);
	    const result = compact([
	      leftChildren.length ? createSyntaxList2(leftChildren) : void 0,
	      splitToken,
	      rightChildren.length ? createSyntaxList2(rightChildren) : void 0
	    ]);
	    return separateLastToken ? result.concat(lastToken) : result;
	  }
	  function createSyntaxList2(children) {
	    Debug.assertGreaterThanOrEqual(children.length, 1);
	    return setTextRangePosEnd(parseNodeFactory.createSyntaxList(children), children[0].pos, last(children).end);
	  }
	  function isListOpener(token) {
	    const kind = token && token.kind;
	    return kind === 19 /* OpenBraceToken */ || kind === 23 /* OpenBracketToken */ || kind === 21 /* OpenParenToken */ || kind === 286 /* JsxOpeningElement */;
	  }
	  function isListCloser(token) {
	    const kind = token && token.kind;
	    return kind === 20 /* CloseBraceToken */ || kind === 24 /* CloseBracketToken */ || kind === 22 /* CloseParenToken */ || kind === 287 /* JsxClosingElement */;
	  }
	  function getEndPos(sourceFile, node) {
	    switch (node.kind) {
	      case 348 /* JSDocParameterTag */:
	      case 345 /* JSDocCallbackTag */:
	      case 355 /* JSDocPropertyTag */:
	      case 353 /* JSDocTypedefTag */:
	      case 350 /* JSDocThisTag */:
	        return sourceFile.getLineEndOfPosition(node.getStart());
	      default:
	        return node.getEnd();
	    }
	  }
	  var isImport2;
	  var init_smartSelection = __esm({
	    "src/services/smartSelection.ts"() {
	      init_ts4();
	      isImport2 = or(isImportDeclaration, isImportEqualsDeclaration);
	    }
	  });

	  // src/services/_namespaces/ts.SmartSelectionRange.ts
	  var ts_SmartSelectionRange_exports = {};
	  __export(ts_SmartSelectionRange_exports, {
	    getSmartSelectionRange: () => getSmartSelectionRange
	  });
	  var init_ts_SmartSelectionRange = __esm({
	    "src/services/_namespaces/ts.SmartSelectionRange.ts"() {
	      init_smartSelection();
	    }
	  });

	  // src/services/symbolDisplay.ts
	  function getSymbolKind(typeChecker, symbol, location) {
	    const result = getSymbolKindOfConstructorPropertyMethodAccessorFunctionOrVar(typeChecker, symbol, location);
	    if (result !== "" /* unknown */) {
	      return result;
	    }
	    const flags = getCombinedLocalAndExportSymbolFlags(symbol);
	    if (flags & 32 /* Class */) {
	      return getDeclarationOfKind(symbol, 231 /* ClassExpression */) ? "local class" /* localClassElement */ : "class" /* classElement */;
	    }
	    if (flags & 384 /* Enum */)
	      return "enum" /* enumElement */;
	    if (flags & 524288 /* TypeAlias */)
	      return "type" /* typeElement */;
	    if (flags & 64 /* Interface */)
	      return "interface" /* interfaceElement */;
	    if (flags & 262144 /* TypeParameter */)
	      return "type parameter" /* typeParameterElement */;
	    if (flags & 8 /* EnumMember */)
	      return "enum member" /* enumMemberElement */;
	    if (flags & 2097152 /* Alias */)
	      return "alias" /* alias */;
	    if (flags & 1536 /* Module */)
	      return "module" /* moduleElement */;
	    return result;
	  }
	  function getSymbolKindOfConstructorPropertyMethodAccessorFunctionOrVar(typeChecker, symbol, location) {
	    const roots = typeChecker.getRootSymbols(symbol);
	    if (roots.length === 1 && first(roots).flags & 8192 /* Method */ && typeChecker.getTypeOfSymbolAtLocation(symbol, location).getNonNullableType().getCallSignatures().length !== 0) {
	      return "method" /* memberFunctionElement */;
	    }
	    if (typeChecker.isUndefinedSymbol(symbol)) {
	      return "var" /* variableElement */;
	    }
	    if (typeChecker.isArgumentsSymbol(symbol)) {
	      return "local var" /* localVariableElement */;
	    }
	    if (location.kind === 110 /* ThisKeyword */ && isExpression(location) || isThisInTypeQuery(location)) {
	      return "parameter" /* parameterElement */;
	    }
	    const flags = getCombinedLocalAndExportSymbolFlags(symbol);
	    if (flags & 3 /* Variable */) {
	      if (isFirstDeclarationOfSymbolParameter(symbol)) {
	        return "parameter" /* parameterElement */;
	      } else if (symbol.valueDeclaration && isVarConst(symbol.valueDeclaration)) {
	        return "const" /* constElement */;
	      } else if (symbol.valueDeclaration && isVarUsing(symbol.valueDeclaration)) {
	        return "using" /* variableUsingElement */;
	      } else if (symbol.valueDeclaration && isVarAwaitUsing(symbol.valueDeclaration)) {
	        return "await using" /* variableAwaitUsingElement */;
	      } else if (forEach(symbol.declarations, isLet)) {
	        return "let" /* letElement */;
	      }
	      return isLocalVariableOrFunction(symbol) ? "local var" /* localVariableElement */ : "var" /* variableElement */;
	    }
	    if (flags & 16 /* Function */)
	      return isLocalVariableOrFunction(symbol) ? "local function" /* localFunctionElement */ : "function" /* functionElement */;
	    if (flags & 32768 /* GetAccessor */)
	      return "getter" /* memberGetAccessorElement */;
	    if (flags & 65536 /* SetAccessor */)
	      return "setter" /* memberSetAccessorElement */;
	    if (flags & 8192 /* Method */)
	      return "method" /* memberFunctionElement */;
	    if (flags & 16384 /* Constructor */)
	      return "constructor" /* constructorImplementationElement */;
	    if (flags & 131072 /* Signature */)
	      return "index" /* indexSignatureElement */;
	    if (flags & 4 /* Property */) {
	      if (flags & 33554432 /* Transient */ && symbol.links.checkFlags & 6 /* Synthetic */) {
	        const unionPropertyKind = forEach(typeChecker.getRootSymbols(symbol), (rootSymbol) => {
	          const rootSymbolFlags = rootSymbol.getFlags();
	          if (rootSymbolFlags & (98308 /* PropertyOrAccessor */ | 3 /* Variable */)) {
	            return "property" /* memberVariableElement */;
	          }
	        });
	        if (!unionPropertyKind) {
	          const typeOfUnionProperty = typeChecker.getTypeOfSymbolAtLocation(symbol, location);
	          if (typeOfUnionProperty.getCallSignatures().length) {
	            return "method" /* memberFunctionElement */;
	          }
	          return "property" /* memberVariableElement */;
	        }
	        return unionPropertyKind;
	      }
	      return "property" /* memberVariableElement */;
	    }
	    return "" /* unknown */;
	  }
	  function getNormalizedSymbolModifiers(symbol) {
	    if (symbol.declarations && symbol.declarations.length) {
	      const [declaration, ...declarations] = symbol.declarations;
	      const excludeFlags = length(declarations) && isDeprecatedDeclaration(declaration) && some(declarations, (d) => !isDeprecatedDeclaration(d)) ? 65536 /* Deprecated */ : 0 /* None */;
	      const modifiers = getNodeModifiers(declaration, excludeFlags);
	      if (modifiers) {
	        return modifiers.split(",");
	      }
	    }
	    return [];
	  }
	  function getSymbolModifiers(typeChecker, symbol) {
	    if (!symbol) {
	      return "" /* none */;
	    }
	    const modifiers = new Set(getNormalizedSymbolModifiers(symbol));
	    if (symbol.flags & 2097152 /* Alias */) {
	      const resolvedSymbol = typeChecker.getAliasedSymbol(symbol);
	      if (resolvedSymbol !== symbol) {
	        forEach(getNormalizedSymbolModifiers(resolvedSymbol), (modifier) => {
	          modifiers.add(modifier);
	        });
	      }
	    }
	    if (symbol.flags & 16777216 /* Optional */) {
	      modifiers.add("optional" /* optionalModifier */);
	    }
	    return modifiers.size > 0 ? arrayFrom(modifiers.values()).join(",") : "" /* none */;
	  }
	  function getSymbolDisplayPartsDocumentationAndSymbolKindWorker(typeChecker, symbol, sourceFile, enclosingDeclaration, location, type, semanticMeaning, alias) {
	    var _a;
	    const displayParts = [];
	    let documentation = [];
	    let tags = [];
	    const symbolFlags = getCombinedLocalAndExportSymbolFlags(symbol);
	    let symbolKind = semanticMeaning & 1 /* Value */ ? getSymbolKindOfConstructorPropertyMethodAccessorFunctionOrVar(typeChecker, symbol, location) : "" /* unknown */;
	    let hasAddedSymbolInfo = false;
	    const isThisExpression = location.kind === 110 /* ThisKeyword */ && isInExpressionContext(location) || isThisInTypeQuery(location);
	    let documentationFromAlias;
	    let tagsFromAlias;
	    let hasMultipleSignatures = false;
	    if (location.kind === 110 /* ThisKeyword */ && !isThisExpression) {
	      return { displayParts: [keywordPart(110 /* ThisKeyword */)], documentation: [], symbolKind: "primitive type" /* primitiveType */, tags: void 0 };
	    }
	    if (symbolKind !== "" /* unknown */ || symbolFlags & 32 /* Class */ || symbolFlags & 2097152 /* Alias */) {
	      if (symbolKind === "getter" /* memberGetAccessorElement */ || symbolKind === "setter" /* memberSetAccessorElement */) {
	        const declaration = find(symbol.declarations, (declaration2) => declaration2.name === location);
	        if (declaration) {
	          switch (declaration.kind) {
	            case 177 /* GetAccessor */:
	              symbolKind = "getter" /* memberGetAccessorElement */;
	              break;
	            case 178 /* SetAccessor */:
	              symbolKind = "setter" /* memberSetAccessorElement */;
	              break;
	            case 172 /* PropertyDeclaration */:
	              symbolKind = "accessor" /* memberAccessorVariableElement */;
	              break;
	            default:
	              Debug.assertNever(declaration);
	          }
	        } else {
	          symbolKind = "property" /* memberVariableElement */;
	        }
	      }
	      let signature;
	      type ?? (type = isThisExpression ? typeChecker.getTypeAtLocation(location) : typeChecker.getTypeOfSymbolAtLocation(symbol, location));
	      if (location.parent && location.parent.kind === 211 /* PropertyAccessExpression */) {
	        const right = location.parent.name;
	        if (right === location || right && right.getFullWidth() === 0) {
	          location = location.parent;
	        }
	      }
	      let callExpressionLike;
	      if (isCallOrNewExpression(location)) {
	        callExpressionLike = location;
	      } else if (isCallExpressionTarget(location) || isNewExpressionTarget(location)) {
	        callExpressionLike = location.parent;
	      } else if (location.parent && (isJsxOpeningLikeElement(location.parent) || isTaggedTemplateExpression(location.parent)) && isFunctionLike(symbol.valueDeclaration)) {
	        callExpressionLike = location.parent;
	      }
	      if (callExpressionLike) {
	        signature = typeChecker.getResolvedSignature(callExpressionLike);
	        const useConstructSignatures = callExpressionLike.kind === 214 /* NewExpression */ || isCallExpression(callExpressionLike) && callExpressionLike.expression.kind === 108 /* SuperKeyword */;
	        const allSignatures = useConstructSignatures ? type.getConstructSignatures() : type.getCallSignatures();
	        if (signature && !contains(allSignatures, signature.target) && !contains(allSignatures, signature)) {
	          signature = allSignatures.length ? allSignatures[0] : void 0;
	        }
	        if (signature) {
	          if (useConstructSignatures && symbolFlags & 32 /* Class */) {
	            symbolKind = "constructor" /* constructorImplementationElement */;
	            addPrefixForAnyFunctionOrVar(type.symbol, symbolKind);
	          } else if (symbolFlags & 2097152 /* Alias */) {
	            symbolKind = "alias" /* alias */;
	            pushSymbolKind(symbolKind);
	            displayParts.push(spacePart());
	            if (useConstructSignatures) {
	              if (signature.flags & 4 /* Abstract */) {
	                displayParts.push(keywordPart(128 /* AbstractKeyword */));
	                displayParts.push(spacePart());
	              }
	              displayParts.push(keywordPart(105 /* NewKeyword */));
	              displayParts.push(spacePart());
	            }
	            addFullSymbolName(symbol);
	          } else {
	            addPrefixForAnyFunctionOrVar(symbol, symbolKind);
	          }
	          switch (symbolKind) {
	            case "JSX attribute" /* jsxAttribute */:
	            case "property" /* memberVariableElement */:
	            case "var" /* variableElement */:
	            case "const" /* constElement */:
	            case "let" /* letElement */:
	            case "parameter" /* parameterElement */:
	            case "local var" /* localVariableElement */:
	              displayParts.push(punctuationPart(59 /* ColonToken */));
	              displayParts.push(spacePart());
	              if (!(getObjectFlags(type) & 16 /* Anonymous */) && type.symbol) {
	                addRange(displayParts, symbolToDisplayParts(
	                  typeChecker,
	                  type.symbol,
	                  enclosingDeclaration,
	                  /*meaning*/
	                  void 0,
	                  4 /* AllowAnyNodeKind */ | 1 /* WriteTypeParametersOrArguments */
	                ));
	                displayParts.push(lineBreakPart());
	              }
	              if (useConstructSignatures) {
	                if (signature.flags & 4 /* Abstract */) {
	                  displayParts.push(keywordPart(128 /* AbstractKeyword */));
	                  displayParts.push(spacePart());
	                }
	                displayParts.push(keywordPart(105 /* NewKeyword */));
	                displayParts.push(spacePart());
	              }
	              addSignatureDisplayParts(signature, allSignatures, 262144 /* WriteArrowStyleSignature */);
	              break;
	            default:
	              addSignatureDisplayParts(signature, allSignatures);
	          }
	          hasAddedSymbolInfo = true;
	          hasMultipleSignatures = allSignatures.length > 1;
	        }
	      } else if (isNameOfFunctionDeclaration(location) && !(symbolFlags & 98304 /* Accessor */) || // name of function declaration
	      location.kind === 137 /* ConstructorKeyword */ && location.parent.kind === 176 /* Constructor */) {
	        const functionDeclaration = location.parent;
	        const locationIsSymbolDeclaration = symbol.declarations && find(symbol.declarations, (declaration) => declaration === (location.kind === 137 /* ConstructorKeyword */ ? functionDeclaration.parent : functionDeclaration));
	        if (locationIsSymbolDeclaration) {
	          const allSignatures = functionDeclaration.kind === 176 /* Constructor */ ? type.getNonNullableType().getConstructSignatures() : type.getNonNullableType().getCallSignatures();
	          if (!typeChecker.isImplementationOfOverload(functionDeclaration)) {
	            signature = typeChecker.getSignatureFromDeclaration(functionDeclaration);
	          } else {
	            signature = allSignatures[0];
	          }
	          if (functionDeclaration.kind === 176 /* Constructor */) {
	            symbolKind = "constructor" /* constructorImplementationElement */;
	            addPrefixForAnyFunctionOrVar(type.symbol, symbolKind);
	          } else {
	            addPrefixForAnyFunctionOrVar(
	              functionDeclaration.kind === 179 /* CallSignature */ && !(type.symbol.flags & 2048 /* TypeLiteral */ || type.symbol.flags & 4096 /* ObjectLiteral */) ? type.symbol : symbol,
	              symbolKind
	            );
	          }
	          if (signature) {
	            addSignatureDisplayParts(signature, allSignatures);
	          }
	          hasAddedSymbolInfo = true;
	          hasMultipleSignatures = allSignatures.length > 1;
	        }
	      }
	    }
	    if (symbolFlags & 32 /* Class */ && !hasAddedSymbolInfo && !isThisExpression) {
	      addAliasPrefixIfNecessary();
	      if (getDeclarationOfKind(symbol, 231 /* ClassExpression */)) {
	        pushSymbolKind("local class" /* localClassElement */);
	      } else {
	        displayParts.push(keywordPart(86 /* ClassKeyword */));
	      }
	      displayParts.push(spacePart());
	      addFullSymbolName(symbol);
	      writeTypeParametersOfSymbol(symbol, sourceFile);
	    }
	    if (symbolFlags & 64 /* Interface */ && semanticMeaning & 2 /* Type */) {
	      prefixNextMeaning();
	      displayParts.push(keywordPart(120 /* InterfaceKeyword */));
	      displayParts.push(spacePart());
	      addFullSymbolName(symbol);
	      writeTypeParametersOfSymbol(symbol, sourceFile);
	    }
	    if (symbolFlags & 524288 /* TypeAlias */ && semanticMeaning & 2 /* Type */) {
	      prefixNextMeaning();
	      displayParts.push(keywordPart(156 /* TypeKeyword */));
	      displayParts.push(spacePart());
	      addFullSymbolName(symbol);
	      writeTypeParametersOfSymbol(symbol, sourceFile);
	      displayParts.push(spacePart());
	      displayParts.push(operatorPart(64 /* EqualsToken */));
	      displayParts.push(spacePart());
	      addRange(displayParts, typeToDisplayParts(typeChecker, location.parent && isConstTypeReference(location.parent) ? typeChecker.getTypeAtLocation(location.parent) : typeChecker.getDeclaredTypeOfSymbol(symbol), enclosingDeclaration, 8388608 /* InTypeAlias */));
	    }
	    if (symbolFlags & 384 /* Enum */) {
	      prefixNextMeaning();
	      if (some(symbol.declarations, (d) => isEnumDeclaration(d) && isEnumConst(d))) {
	        displayParts.push(keywordPart(87 /* ConstKeyword */));
	        displayParts.push(spacePart());
	      }
	      displayParts.push(keywordPart(94 /* EnumKeyword */));
	      displayParts.push(spacePart());
	      addFullSymbolName(symbol);
	    }
	    if (symbolFlags & 1536 /* Module */ && !isThisExpression) {
	      prefixNextMeaning();
	      const declaration = getDeclarationOfKind(symbol, 267 /* ModuleDeclaration */);
	      const isNamespace = declaration && declaration.name && declaration.name.kind === 80 /* Identifier */;
	      displayParts.push(keywordPart(isNamespace ? 145 /* NamespaceKeyword */ : 144 /* ModuleKeyword */));
	      displayParts.push(spacePart());
	      addFullSymbolName(symbol);
	    }
	    if (symbolFlags & 262144 /* TypeParameter */ && semanticMeaning & 2 /* Type */) {
	      prefixNextMeaning();
	      displayParts.push(punctuationPart(21 /* OpenParenToken */));
	      displayParts.push(textPart("type parameter"));
	      displayParts.push(punctuationPart(22 /* CloseParenToken */));
	      displayParts.push(spacePart());
	      addFullSymbolName(symbol);
	      if (symbol.parent) {
	        addInPrefix();
	        addFullSymbolName(symbol.parent, enclosingDeclaration);
	        writeTypeParametersOfSymbol(symbol.parent, enclosingDeclaration);
	      } else {
	        const decl = getDeclarationOfKind(symbol, 168 /* TypeParameter */);
	        if (decl === void 0)
	          return Debug.fail();
	        const declaration = decl.parent;
	        if (declaration) {
	          if (isFunctionLike(declaration)) {
	            addInPrefix();
	            const signature = typeChecker.getSignatureFromDeclaration(declaration);
	            if (declaration.kind === 180 /* ConstructSignature */) {
	              displayParts.push(keywordPart(105 /* NewKeyword */));
	              displayParts.push(spacePart());
	            } else if (declaration.kind !== 179 /* CallSignature */ && declaration.name) {
	              addFullSymbolName(declaration.symbol);
	            }
	            addRange(displayParts, signatureToDisplayParts(typeChecker, signature, sourceFile, 32 /* WriteTypeArgumentsOfSignature */));
	          } else if (isTypeAliasDeclaration(declaration)) {
	            addInPrefix();
	            displayParts.push(keywordPart(156 /* TypeKeyword */));
	            displayParts.push(spacePart());
	            addFullSymbolName(declaration.symbol);
	            writeTypeParametersOfSymbol(declaration.symbol, sourceFile);
	          }
	        }
	      }
	    }
	    if (symbolFlags & 8 /* EnumMember */) {
	      symbolKind = "enum member" /* enumMemberElement */;
	      addPrefixForAnyFunctionOrVar(symbol, "enum member");
	      const declaration = (_a = symbol.declarations) == null ? void 0 : _a[0];
	      if ((declaration == null ? void 0 : declaration.kind) === 306 /* EnumMember */) {
	        const constantValue = typeChecker.getConstantValue(declaration);
	        if (constantValue !== void 0) {
	          displayParts.push(spacePart());
	          displayParts.push(operatorPart(64 /* EqualsToken */));
	          displayParts.push(spacePart());
	          displayParts.push(displayPart(getTextOfConstantValue(constantValue), typeof constantValue === "number" ? 7 /* numericLiteral */ : 8 /* stringLiteral */));
	        }
	      }
	    }
	    if (symbol.flags & 2097152 /* Alias */) {
	      prefixNextMeaning();
	      if (!hasAddedSymbolInfo || documentation.length === 0 && tags.length === 0) {
	        const resolvedSymbol = typeChecker.getAliasedSymbol(symbol);
	        if (resolvedSymbol !== symbol && resolvedSymbol.declarations && resolvedSymbol.declarations.length > 0) {
	          const resolvedNode = resolvedSymbol.declarations[0];
	          const declarationName = getNameOfDeclaration(resolvedNode);
	          if (declarationName && !hasAddedSymbolInfo) {
	            const isExternalModuleDeclaration = isModuleWithStringLiteralName(resolvedNode) && hasSyntacticModifier(resolvedNode, 128 /* Ambient */);
	            const shouldUseAliasName = symbol.name !== "default" && !isExternalModuleDeclaration;
	            const resolvedInfo = getSymbolDisplayPartsDocumentationAndSymbolKindWorker(
	              typeChecker,
	              resolvedSymbol,
	              getSourceFileOfNode(resolvedNode),
	              resolvedNode,
	              declarationName,
	              type,
	              semanticMeaning,
	              shouldUseAliasName ? symbol : resolvedSymbol
	            );
	            displayParts.push(...resolvedInfo.displayParts);
	            displayParts.push(lineBreakPart());
	            documentationFromAlias = resolvedInfo.documentation;
	            tagsFromAlias = resolvedInfo.tags;
	          } else {
	            documentationFromAlias = resolvedSymbol.getContextualDocumentationComment(resolvedNode, typeChecker);
	            tagsFromAlias = resolvedSymbol.getJsDocTags(typeChecker);
	          }
	        }
	      }
	      if (symbol.declarations) {
	        switch (symbol.declarations[0].kind) {
	          case 270 /* NamespaceExportDeclaration */:
	            displayParts.push(keywordPart(95 /* ExportKeyword */));
	            displayParts.push(spacePart());
	            displayParts.push(keywordPart(145 /* NamespaceKeyword */));
	            break;
	          case 277 /* ExportAssignment */:
	            displayParts.push(keywordPart(95 /* ExportKeyword */));
	            displayParts.push(spacePart());
	            displayParts.push(keywordPart(symbol.declarations[0].isExportEquals ? 64 /* EqualsToken */ : 90 /* DefaultKeyword */));
	            break;
	          case 281 /* ExportSpecifier */:
	            displayParts.push(keywordPart(95 /* ExportKeyword */));
	            break;
	          default:
	            displayParts.push(keywordPart(102 /* ImportKeyword */));
	        }
	      }
	      displayParts.push(spacePart());
	      addFullSymbolName(symbol);
	      forEach(symbol.declarations, (declaration) => {
	        if (declaration.kind === 271 /* ImportEqualsDeclaration */) {
	          const importEqualsDeclaration = declaration;
	          if (isExternalModuleImportEqualsDeclaration(importEqualsDeclaration)) {
	            displayParts.push(spacePart());
	            displayParts.push(operatorPart(64 /* EqualsToken */));
	            displayParts.push(spacePart());
	            displayParts.push(keywordPart(149 /* RequireKeyword */));
	            displayParts.push(punctuationPart(21 /* OpenParenToken */));
	            displayParts.push(displayPart(getTextOfNode(getExternalModuleImportEqualsDeclarationExpression(importEqualsDeclaration)), 8 /* stringLiteral */));
	            displayParts.push(punctuationPart(22 /* CloseParenToken */));
	          } else {
	            const internalAliasSymbol = typeChecker.getSymbolAtLocation(importEqualsDeclaration.moduleReference);
	            if (internalAliasSymbol) {
	              displayParts.push(spacePart());
	              displayParts.push(operatorPart(64 /* EqualsToken */));
	              displayParts.push(spacePart());
	              addFullSymbolName(internalAliasSymbol, enclosingDeclaration);
	            }
	          }
	          return true;
	        }
	      });
	    }
	    if (!hasAddedSymbolInfo) {
	      if (symbolKind !== "" /* unknown */) {
	        if (type) {
	          if (isThisExpression) {
	            prefixNextMeaning();
	            displayParts.push(keywordPart(110 /* ThisKeyword */));
	          } else {
	            addPrefixForAnyFunctionOrVar(symbol, symbolKind);
	          }
	          if (symbolKind === "property" /* memberVariableElement */ || symbolKind === "accessor" /* memberAccessorVariableElement */ || symbolKind === "getter" /* memberGetAccessorElement */ || symbolKind === "setter" /* memberSetAccessorElement */ || symbolKind === "JSX attribute" /* jsxAttribute */ || symbolFlags & 3 /* Variable */ || symbolKind === "local var" /* localVariableElement */ || symbolKind === "index" /* indexSignatureElement */ || symbolKind === "using" /* variableUsingElement */ || symbolKind === "await using" /* variableAwaitUsingElement */ || isThisExpression) {
	            displayParts.push(punctuationPart(59 /* ColonToken */));
	            displayParts.push(spacePart());
	            if (type.symbol && type.symbol.flags & 262144 /* TypeParameter */ && symbolKind !== "index" /* indexSignatureElement */) {
	              const typeParameterParts = mapToDisplayParts((writer) => {
	                const param = typeChecker.typeParameterToDeclaration(type, enclosingDeclaration, symbolDisplayNodeBuilderFlags);
	                getPrinter().writeNode(4 /* Unspecified */, param, getSourceFileOfNode(getParseTreeNode(enclosingDeclaration)), writer);
	              });
	              addRange(displayParts, typeParameterParts);
	            } else {
	              addRange(displayParts, typeToDisplayParts(typeChecker, type, enclosingDeclaration));
	            }
	            if (isTransientSymbol(symbol) && symbol.links.target && isTransientSymbol(symbol.links.target) && symbol.links.target.links.tupleLabelDeclaration) {
	              const labelDecl = symbol.links.target.links.tupleLabelDeclaration;
	              Debug.assertNode(labelDecl.name, isIdentifier);
	              displayParts.push(spacePart());
	              displayParts.push(punctuationPart(21 /* OpenParenToken */));
	              displayParts.push(textPart(idText(labelDecl.name)));
	              displayParts.push(punctuationPart(22 /* CloseParenToken */));
	            }
	          } else if (symbolFlags & 16 /* Function */ || symbolFlags & 8192 /* Method */ || symbolFlags & 16384 /* Constructor */ || symbolFlags & 131072 /* Signature */ || symbolFlags & 98304 /* Accessor */ || symbolKind === "method" /* memberFunctionElement */) {
	            const allSignatures = type.getNonNullableType().getCallSignatures();
	            if (allSignatures.length) {
	              addSignatureDisplayParts(allSignatures[0], allSignatures);
	              hasMultipleSignatures = allSignatures.length > 1;
	            }
	          }
	        }
	      } else {
	        symbolKind = getSymbolKind(typeChecker, symbol, location);
	      }
	    }
	    if (documentation.length === 0 && !hasMultipleSignatures) {
	      documentation = symbol.getContextualDocumentationComment(enclosingDeclaration, typeChecker);
	    }
	    if (documentation.length === 0 && symbolFlags & 4 /* Property */) {
	      if (symbol.parent && symbol.declarations && forEach(symbol.parent.declarations, (declaration) => declaration.kind === 312 /* SourceFile */)) {
	        for (const declaration of symbol.declarations) {
	          if (!declaration.parent || declaration.parent.kind !== 226 /* BinaryExpression */) {
	            continue;
	          }
	          const rhsSymbol = typeChecker.getSymbolAtLocation(declaration.parent.right);
	          if (!rhsSymbol) {
	            continue;
	          }
	          documentation = rhsSymbol.getDocumentationComment(typeChecker);
	          tags = rhsSymbol.getJsDocTags(typeChecker);
	          if (documentation.length > 0) {
	            break;
	          }
	        }
	      }
	    }
	    if (documentation.length === 0 && isIdentifier(location) && symbol.valueDeclaration && isBindingElement(symbol.valueDeclaration)) {
	      const declaration = symbol.valueDeclaration;
	      const parent2 = declaration.parent;
	      const name = declaration.propertyName || declaration.name;
	      if (isIdentifier(name) && isObjectBindingPattern(parent2)) {
	        const propertyName = getTextOfIdentifierOrLiteral(name);
	        const objectType = typeChecker.getTypeAtLocation(parent2);
	        documentation = firstDefined(objectType.isUnion() ? objectType.types : [objectType], (t) => {
	          const prop = t.getProperty(propertyName);
	          return prop ? prop.getDocumentationComment(typeChecker) : void 0;
	        }) || emptyArray;
	      }
	    }
	    if (tags.length === 0 && !hasMultipleSignatures) {
	      tags = symbol.getContextualJsDocTags(enclosingDeclaration, typeChecker);
	    }
	    if (documentation.length === 0 && documentationFromAlias) {
	      documentation = documentationFromAlias;
	    }
	    if (tags.length === 0 && tagsFromAlias) {
	      tags = tagsFromAlias;
	    }
	    return { displayParts, documentation, symbolKind, tags: tags.length === 0 ? void 0 : tags };
	    function getPrinter() {
	      return createPrinterWithRemoveComments();
	    }
	    function prefixNextMeaning() {
	      if (displayParts.length) {
	        displayParts.push(lineBreakPart());
	      }
	      addAliasPrefixIfNecessary();
	    }
	    function addAliasPrefixIfNecessary() {
	      if (alias) {
	        pushSymbolKind("alias" /* alias */);
	        displayParts.push(spacePart());
	      }
	    }
	    function addInPrefix() {
	      displayParts.push(spacePart());
	      displayParts.push(keywordPart(103 /* InKeyword */));
	      displayParts.push(spacePart());
	    }
	    function addFullSymbolName(symbolToDisplay, enclosingDeclaration2) {
	      let indexInfos;
	      if (alias && symbolToDisplay === symbol) {
	        symbolToDisplay = alias;
	      }
	      if (symbolKind === "index" /* indexSignatureElement */) {
	        indexInfos = typeChecker.getIndexInfosOfIndexSymbol(symbolToDisplay);
	      }
	      let fullSymbolDisplayParts = [];
	      if (symbolToDisplay.flags & 131072 /* Signature */ && indexInfos) {
	        if (symbolToDisplay.parent) {
	          fullSymbolDisplayParts = symbolToDisplayParts(typeChecker, symbolToDisplay.parent);
	        }
	        fullSymbolDisplayParts.push(punctuationPart(23 /* OpenBracketToken */));
	        indexInfos.forEach((info, i) => {
	          fullSymbolDisplayParts.push(...typeToDisplayParts(typeChecker, info.keyType));
	          if (i !== indexInfos.length - 1) {
	            fullSymbolDisplayParts.push(spacePart());
	            fullSymbolDisplayParts.push(punctuationPart(52 /* BarToken */));
	            fullSymbolDisplayParts.push(spacePart());
	          }
	        });
	        fullSymbolDisplayParts.push(punctuationPart(24 /* CloseBracketToken */));
	      } else {
	        fullSymbolDisplayParts = symbolToDisplayParts(
	          typeChecker,
	          symbolToDisplay,
	          enclosingDeclaration2 || sourceFile,
	          /*meaning*/
	          void 0,
	          1 /* WriteTypeParametersOrArguments */ | 2 /* UseOnlyExternalAliasing */ | 4 /* AllowAnyNodeKind */
	        );
	      }
	      addRange(displayParts, fullSymbolDisplayParts);
	      if (symbol.flags & 16777216 /* Optional */) {
	        displayParts.push(punctuationPart(58 /* QuestionToken */));
	      }
	    }
	    function addPrefixForAnyFunctionOrVar(symbol2, symbolKind2) {
	      prefixNextMeaning();
	      if (symbolKind2) {
	        pushSymbolKind(symbolKind2);
	        if (symbol2 && !some(symbol2.declarations, (d) => isArrowFunction(d) || (isFunctionExpression(d) || isClassExpression(d)) && !d.name)) {
	          displayParts.push(spacePart());
	          addFullSymbolName(symbol2);
	        }
	      }
	    }
	    function pushSymbolKind(symbolKind2) {
	      switch (symbolKind2) {
	        case "var" /* variableElement */:
	        case "function" /* functionElement */:
	        case "let" /* letElement */:
	        case "const" /* constElement */:
	        case "constructor" /* constructorImplementationElement */:
	        case "using" /* variableUsingElement */:
	        case "await using" /* variableAwaitUsingElement */:
	          displayParts.push(textOrKeywordPart(symbolKind2));
	          return;
	        default:
	          displayParts.push(punctuationPart(21 /* OpenParenToken */));
	          displayParts.push(textOrKeywordPart(symbolKind2));
	          displayParts.push(punctuationPart(22 /* CloseParenToken */));
	          return;
	      }
	    }
	    function addSignatureDisplayParts(signature, allSignatures, flags = 0 /* None */) {
	      addRange(displayParts, signatureToDisplayParts(typeChecker, signature, enclosingDeclaration, flags | 32 /* WriteTypeArgumentsOfSignature */));
	      if (allSignatures.length > 1) {
	        displayParts.push(spacePart());
	        displayParts.push(punctuationPart(21 /* OpenParenToken */));
	        displayParts.push(operatorPart(40 /* PlusToken */));
	        displayParts.push(displayPart((allSignatures.length - 1).toString(), 7 /* numericLiteral */));
	        displayParts.push(spacePart());
	        displayParts.push(textPart(allSignatures.length === 2 ? "overload" : "overloads"));
	        displayParts.push(punctuationPart(22 /* CloseParenToken */));
	      }
	      documentation = signature.getDocumentationComment(typeChecker);
	      tags = signature.getJsDocTags();
	      if (allSignatures.length > 1 && documentation.length === 0 && tags.length === 0) {
	        documentation = allSignatures[0].getDocumentationComment(typeChecker);
	        tags = allSignatures[0].getJsDocTags().filter((tag) => tag.name !== "deprecated");
	      }
	    }
	    function writeTypeParametersOfSymbol(symbol2, enclosingDeclaration2) {
	      const typeParameterParts = mapToDisplayParts((writer) => {
	        const params = typeChecker.symbolToTypeParameterDeclarations(symbol2, enclosingDeclaration2, symbolDisplayNodeBuilderFlags);
	        getPrinter().writeList(53776 /* TypeParameters */, params, getSourceFileOfNode(getParseTreeNode(enclosingDeclaration2)), writer);
	      });
	      addRange(displayParts, typeParameterParts);
	    }
	  }
	  function getSymbolDisplayPartsDocumentationAndSymbolKind(typeChecker, symbol, sourceFile, enclosingDeclaration, location, semanticMeaning = getMeaningFromLocation(location), alias) {
	    return getSymbolDisplayPartsDocumentationAndSymbolKindWorker(
	      typeChecker,
	      symbol,
	      sourceFile,
	      enclosingDeclaration,
	      location,
	      /*type*/
	      void 0,
	      semanticMeaning,
	      alias
	    );
	  }
	  function isLocalVariableOrFunction(symbol) {
	    if (symbol.parent) {
	      return false;
	    }
	    return forEach(symbol.declarations, (declaration) => {
	      if (declaration.kind === 218 /* FunctionExpression */) {
	        return true;
	      }
	      if (declaration.kind !== 260 /* VariableDeclaration */ && declaration.kind !== 262 /* FunctionDeclaration */) {
	        return false;
	      }
	      for (let parent2 = declaration.parent; !isFunctionBlock(parent2); parent2 = parent2.parent) {
	        if (parent2.kind === 312 /* SourceFile */ || parent2.kind === 268 /* ModuleBlock */) {
	          return false;
	        }
	      }
	      return true;
	    });
	  }
	  var symbolDisplayNodeBuilderFlags;
	  var init_symbolDisplay = __esm({
	    "src/services/symbolDisplay.ts"() {
	      init_ts4();
	      symbolDisplayNodeBuilderFlags = 8192 /* OmitParameterModifiers */ | 70221824 /* IgnoreErrors */ | 16384 /* UseAliasDefinedOutsideCurrentScope */;
	    }
	  });

	  // src/services/_namespaces/ts.SymbolDisplay.ts
	  var ts_SymbolDisplay_exports = {};
	  __export(ts_SymbolDisplay_exports, {
	    getSymbolDisplayPartsDocumentationAndSymbolKind: () => getSymbolDisplayPartsDocumentationAndSymbolKind,
	    getSymbolKind: () => getSymbolKind,
	    getSymbolModifiers: () => getSymbolModifiers
	  });
	  var init_ts_SymbolDisplay = __esm({
	    "src/services/_namespaces/ts.SymbolDisplay.ts"() {
	      init_symbolDisplay();
	    }
	  });

	  // src/services/textChanges.ts
	  function getPos2(n) {
	    const result = n.__pos;
	    Debug.assert(typeof result === "number");
	    return result;
	  }
	  function setPos(n, pos) {
	    Debug.assert(typeof pos === "number");
	    n.__pos = pos;
	  }
	  function getEnd(n) {
	    const result = n.__end;
	    Debug.assert(typeof result === "number");
	    return result;
	  }
	  function setEnd(n, end) {
	    Debug.assert(typeof end === "number");
	    n.__end = end;
	  }
	  function skipWhitespacesAndLineBreaks(text, start) {
	    return skipTrivia(
	      text,
	      start,
	      /*stopAfterLineBreak*/
	      false,
	      /*stopAtComments*/
	      true
	    );
	  }
	  function hasCommentsBeforeLineBreak(text, start) {
	    let i = start;
	    while (i < text.length) {
	      const ch = text.charCodeAt(i);
	      if (isWhiteSpaceSingleLine(ch)) {
	        i++;
	        continue;
	      }
	      return ch === 47 /* slash */;
	    }
	    return false;
	  }
	  function getAdjustedRange(sourceFile, startNode2, endNode2, options) {
	    return { pos: getAdjustedStartPosition(sourceFile, startNode2, options), end: getAdjustedEndPosition(sourceFile, endNode2, options) };
	  }
	  function getAdjustedStartPosition(sourceFile, node, options, hasTrailingComment = false) {
	    var _a, _b;
	    const { leadingTriviaOption } = options;
	    if (leadingTriviaOption === 0 /* Exclude */) {
	      return node.getStart(sourceFile);
	    }
	    if (leadingTriviaOption === 3 /* StartLine */) {
	      const startPos = node.getStart(sourceFile);
	      const pos = getLineStartPositionForPosition(startPos, sourceFile);
	      return rangeContainsPosition(node, pos) ? pos : startPos;
	    }
	    if (leadingTriviaOption === 2 /* JSDoc */) {
	      const JSDocComments = getJSDocCommentRanges(node, sourceFile.text);
	      if (JSDocComments == null ? void 0 : JSDocComments.length) {
	        return getLineStartPositionForPosition(JSDocComments[0].pos, sourceFile);
	      }
	    }
	    const fullStart = node.getFullStart();
	    const start = node.getStart(sourceFile);
	    if (fullStart === start) {
	      return start;
	    }
	    const fullStartLine = getLineStartPositionForPosition(fullStart, sourceFile);
	    const startLine = getLineStartPositionForPosition(start, sourceFile);
	    if (startLine === fullStartLine) {
	      return leadingTriviaOption === 1 /* IncludeAll */ ? fullStart : start;
	    }
	    if (hasTrailingComment) {
	      const comment = ((_a = getLeadingCommentRanges(sourceFile.text, fullStart)) == null ? void 0 : _a[0]) || ((_b = getTrailingCommentRanges(sourceFile.text, fullStart)) == null ? void 0 : _b[0]);
	      if (comment) {
	        return skipTrivia(
	          sourceFile.text,
	          comment.end,
	          /*stopAfterLineBreak*/
	          true,
	          /*stopAtComments*/
	          true
	        );
	      }
	    }
	    const nextLineStart = fullStart > 0 ? 1 : 0;
	    let adjustedStartPosition = getStartPositionOfLine(getLineOfLocalPosition(sourceFile, fullStartLine) + nextLineStart, sourceFile);
	    adjustedStartPosition = skipWhitespacesAndLineBreaks(sourceFile.text, adjustedStartPosition);
	    return getStartPositionOfLine(getLineOfLocalPosition(sourceFile, adjustedStartPosition), sourceFile);
	  }
	  function getEndPositionOfMultilineTrailingComment(sourceFile, node, options) {
	    const { end } = node;
	    const { trailingTriviaOption } = options;
	    if (trailingTriviaOption === 2 /* Include */) {
	      const comments = getTrailingCommentRanges(sourceFile.text, end);
	      if (comments) {
	        const nodeEndLine = getLineOfLocalPosition(sourceFile, node.end);
	        for (const comment of comments) {
	          if (comment.kind === 2 /* SingleLineCommentTrivia */ || getLineOfLocalPosition(sourceFile, comment.pos) > nodeEndLine) {
	            break;
	          }
	          const commentEndLine = getLineOfLocalPosition(sourceFile, comment.end);
	          if (commentEndLine > nodeEndLine) {
	            return skipTrivia(
	              sourceFile.text,
	              comment.end,
	              /*stopAfterLineBreak*/
	              true,
	              /*stopAtComments*/
	              true
	            );
	          }
	        }
	      }
	    }
	    return void 0;
	  }
	  function getAdjustedEndPosition(sourceFile, node, options) {
	    var _a;
	    const { end } = node;
	    const { trailingTriviaOption } = options;
	    if (trailingTriviaOption === 0 /* Exclude */) {
	      return end;
	    }
	    if (trailingTriviaOption === 1 /* ExcludeWhitespace */) {
	      const comments = concatenate(getTrailingCommentRanges(sourceFile.text, end), getLeadingCommentRanges(sourceFile.text, end));
	      const realEnd = (_a = comments == null ? void 0 : comments[comments.length - 1]) == null ? void 0 : _a.end;
	      if (realEnd) {
	        return realEnd;
	      }
	      return end;
	    }
	    const multilineEndPosition = getEndPositionOfMultilineTrailingComment(sourceFile, node, options);
	    if (multilineEndPosition) {
	      return multilineEndPosition;
	    }
	    const newEnd = skipTrivia(
	      sourceFile.text,
	      end,
	      /*stopAfterLineBreak*/
	      true
	    );
	    return newEnd !== end && (trailingTriviaOption === 2 /* Include */ || isLineBreak(sourceFile.text.charCodeAt(newEnd - 1))) ? newEnd : end;
	  }
	  function isSeparator(node, candidate) {
	    return !!candidate && !!node.parent && (candidate.kind === 28 /* CommaToken */ || candidate.kind === 27 /* SemicolonToken */ && node.parent.kind === 210 /* ObjectLiteralExpression */);
	  }
	  function isThisTypeAnnotatable(containingFunction) {
	    return isFunctionExpression(containingFunction) || isFunctionDeclaration(containingFunction);
	  }
	  function updateJSDocHost(parent2) {
	    if (parent2.kind !== 219 /* ArrowFunction */) {
	      return parent2;
	    }
	    const jsDocNode = parent2.parent.kind === 172 /* PropertyDeclaration */ ? parent2.parent : parent2.parent.parent;
	    jsDocNode.jsDoc = parent2.jsDoc;
	    return jsDocNode;
	  }
	  function tryMergeJsdocTags(oldTag, newTag) {
	    if (oldTag.kind !== newTag.kind) {
	      return void 0;
	    }
	    switch (oldTag.kind) {
	      case 348 /* JSDocParameterTag */: {
	        const oldParam = oldTag;
	        const newParam = newTag;
	        return isIdentifier(oldParam.name) && isIdentifier(newParam.name) && oldParam.name.escapedText === newParam.name.escapedText ? factory.createJSDocParameterTag(
	          /*tagName*/
	          void 0,
	          newParam.name,
	          /*isBracketed*/
	          false,
	          newParam.typeExpression,
	          newParam.isNameFirst,
	          oldParam.comment
	        ) : void 0;
	      }
	      case 349 /* JSDocReturnTag */:
	        return factory.createJSDocReturnTag(
	          /*tagName*/
	          void 0,
	          newTag.typeExpression,
	          oldTag.comment
	        );
	      case 351 /* JSDocTypeTag */:
	        return factory.createJSDocTypeTag(
	          /*tagName*/
	          void 0,
	          newTag.typeExpression,
	          oldTag.comment
	        );
	    }
	  }
	  function startPositionToDeleteNodeInList(sourceFile, node) {
	    return skipTrivia(
	      sourceFile.text,
	      getAdjustedStartPosition(sourceFile, node, { leadingTriviaOption: 1 /* IncludeAll */ }),
	      /*stopAfterLineBreak*/
	      false,
	      /*stopAtComments*/
	      true
	    );
	  }
	  function endPositionToDeleteNodeInList(sourceFile, node, prevNode, nextNode) {
	    const end = startPositionToDeleteNodeInList(sourceFile, nextNode);
	    if (prevNode === void 0 || positionsAreOnSameLine(getAdjustedEndPosition(sourceFile, node, {}), end, sourceFile)) {
	      return end;
	    }
	    const token = findPrecedingToken(nextNode.getStart(sourceFile), sourceFile);
	    if (isSeparator(node, token)) {
	      const prevToken = findPrecedingToken(node.getStart(sourceFile), sourceFile);
	      if (isSeparator(prevNode, prevToken)) {
	        const pos = skipTrivia(
	          sourceFile.text,
	          token.getEnd(),
	          /*stopAfterLineBreak*/
	          true,
	          /*stopAtComments*/
	          true
	        );
	        if (positionsAreOnSameLine(prevToken.getStart(sourceFile), token.getStart(sourceFile), sourceFile)) {
	          return isLineBreak(sourceFile.text.charCodeAt(pos - 1)) ? pos - 1 : pos;
	        }
	        if (isLineBreak(sourceFile.text.charCodeAt(pos))) {
	          return pos;
	        }
	      }
	    }
	    return end;
	  }
	  function getClassOrObjectBraceEnds(cls, sourceFile) {
	    const open = findChildOfKind(cls, 19 /* OpenBraceToken */, sourceFile);
	    const close = findChildOfKind(cls, 20 /* CloseBraceToken */, sourceFile);
	    return [open == null ? void 0 : open.end, close == null ? void 0 : close.end];
	  }
	  function getMembersOrProperties(node) {
	    return isObjectLiteralExpression(node) ? node.properties : node.members;
	  }
	  function applyChanges(text, changes) {
	    for (let i = changes.length - 1; i >= 0; i--) {
	      const { span, newText } = changes[i];
	      text = `${text.substring(0, span.start)}${newText}${text.substring(textSpanEnd(span))}`;
	    }
	    return text;
	  }
	  function isTrivia2(s) {
	    return skipTrivia(s, 0) === s.length;
	  }
	  function assignPositionsToNode(node) {
	    const visited = visitEachChild(node, assignPositionsToNode, textChangesTransformationContext, assignPositionsToNodeArray, assignPositionsToNode);
	    const newNode = nodeIsSynthesized(visited) ? visited : Object.create(visited);
	    setTextRangePosEnd(newNode, getPos2(node), getEnd(node));
	    return newNode;
	  }
	  function assignPositionsToNodeArray(nodes, visitor, test, start, count) {
	    const visited = visitNodes2(nodes, visitor, test, start, count);
	    if (!visited) {
	      return visited;
	    }
	    Debug.assert(nodes);
	    const nodeArray = visited === nodes ? factory.createNodeArray(visited.slice(0)) : visited;
	    setTextRangePosEnd(nodeArray, getPos2(nodes), getEnd(nodes));
	    return nodeArray;
	  }
	  function createWriter(newLine) {
	    let lastNonTriviaPosition = 0;
	    const writer = createTextWriter(newLine);
	    const onBeforeEmitNode = (node) => {
	      if (node) {
	        setPos(node, lastNonTriviaPosition);
	      }
	    };
	    const onAfterEmitNode = (node) => {
	      if (node) {
	        setEnd(node, lastNonTriviaPosition);
	      }
	    };
	    const onBeforeEmitNodeArray = (nodes) => {
	      if (nodes) {
	        setPos(nodes, lastNonTriviaPosition);
	      }
	    };
	    const onAfterEmitNodeArray = (nodes) => {
	      if (nodes) {
	        setEnd(nodes, lastNonTriviaPosition);
	      }
	    };
	    const onBeforeEmitToken = (node) => {
	      if (node) {
	        setPos(node, lastNonTriviaPosition);
	      }
	    };
	    const onAfterEmitToken = (node) => {
	      if (node) {
	        setEnd(node, lastNonTriviaPosition);
	      }
	    };
	    function setLastNonTriviaPosition(s, force) {
	      if (force || !isTrivia2(s)) {
	        lastNonTriviaPosition = writer.getTextPos();
	        let i = 0;
	        while (isWhiteSpaceLike(s.charCodeAt(s.length - i - 1))) {
	          i++;
	        }
	        lastNonTriviaPosition -= i;
	      }
	    }
	    function write(s) {
	      writer.write(s);
	      setLastNonTriviaPosition(
	        s,
	        /*force*/
	        false
	      );
	    }
	    function writeComment(s) {
	      writer.writeComment(s);
	    }
	    function writeKeyword(s) {
	      writer.writeKeyword(s);
	      setLastNonTriviaPosition(
	        s,
	        /*force*/
	        false
	      );
	    }
	    function writeOperator(s) {
	      writer.writeOperator(s);
	      setLastNonTriviaPosition(
	        s,
	        /*force*/
	        false
	      );
	    }
	    function writePunctuation(s) {
	      writer.writePunctuation(s);
	      setLastNonTriviaPosition(
	        s,
	        /*force*/
	        false
	      );
	    }
	    function writeTrailingSemicolon(s) {
	      writer.writeTrailingSemicolon(s);
	      setLastNonTriviaPosition(
	        s,
	        /*force*/
	        false
	      );
	    }
	    function writeParameter(s) {
	      writer.writeParameter(s);
	      setLastNonTriviaPosition(
	        s,
	        /*force*/
	        false
	      );
	    }
	    function writeProperty(s) {
	      writer.writeProperty(s);
	      setLastNonTriviaPosition(
	        s,
	        /*force*/
	        false
	      );
	    }
	    function writeSpace(s) {
	      writer.writeSpace(s);
	      setLastNonTriviaPosition(
	        s,
	        /*force*/
	        false
	      );
	    }
	    function writeStringLiteral(s) {
	      writer.writeStringLiteral(s);
	      setLastNonTriviaPosition(
	        s,
	        /*force*/
	        false
	      );
	    }
	    function writeSymbol(s, sym) {
	      writer.writeSymbol(s, sym);
	      setLastNonTriviaPosition(
	        s,
	        /*force*/
	        false
	      );
	    }
	    function writeLine(force) {
	      writer.writeLine(force);
	    }
	    function increaseIndent() {
	      writer.increaseIndent();
	    }
	    function decreaseIndent() {
	      writer.decreaseIndent();
	    }
	    function getText() {
	      return writer.getText();
	    }
	    function rawWrite(s) {
	      writer.rawWrite(s);
	      setLastNonTriviaPosition(
	        s,
	        /*force*/
	        false
	      );
	    }
	    function writeLiteral(s) {
	      writer.writeLiteral(s);
	      setLastNonTriviaPosition(
	        s,
	        /*force*/
	        true
	      );
	    }
	    function getTextPos() {
	      return writer.getTextPos();
	    }
	    function getLine() {
	      return writer.getLine();
	    }
	    function getColumn() {
	      return writer.getColumn();
	    }
	    function getIndent() {
	      return writer.getIndent();
	    }
	    function isAtStartOfLine() {
	      return writer.isAtStartOfLine();
	    }
	    function clear2() {
	      writer.clear();
	      lastNonTriviaPosition = 0;
	    }
	    return {
	      onBeforeEmitNode,
	      onAfterEmitNode,
	      onBeforeEmitNodeArray,
	      onAfterEmitNodeArray,
	      onBeforeEmitToken,
	      onAfterEmitToken,
	      write,
	      writeComment,
	      writeKeyword,
	      writeOperator,
	      writePunctuation,
	      writeTrailingSemicolon,
	      writeParameter,
	      writeProperty,
	      writeSpace,
	      writeStringLiteral,
	      writeSymbol,
	      writeLine,
	      increaseIndent,
	      decreaseIndent,
	      getText,
	      rawWrite,
	      writeLiteral,
	      getTextPos,
	      getLine,
	      getColumn,
	      getIndent,
	      isAtStartOfLine,
	      hasTrailingComment: () => writer.hasTrailingComment(),
	      hasTrailingWhitespace: () => writer.hasTrailingWhitespace(),
	      clear: clear2
	    };
	  }
	  function getInsertionPositionAtSourceFileTop(sourceFile) {
	    let lastPrologue;
	    for (const node of sourceFile.statements) {
	      if (isPrologueDirective(node)) {
	        lastPrologue = node;
	      } else {
	        break;
	      }
	    }
	    let position = 0;
	    const text = sourceFile.text;
	    if (lastPrologue) {
	      position = lastPrologue.end;
	      advancePastLineBreak();
	      return position;
	    }
	    const shebang = getShebang(text);
	    if (shebang !== void 0) {
	      position = shebang.length;
	      advancePastLineBreak();
	    }
	    const ranges = getLeadingCommentRanges(text, position);
	    if (!ranges)
	      return position;
	    let lastComment;
	    let firstNodeLine;
	    for (const range of ranges) {
	      if (range.kind === 3 /* MultiLineCommentTrivia */) {
	        if (isPinnedComment(text, range.pos)) {
	          lastComment = { range, pinnedOrTripleSlash: true };
	          continue;
	        }
	      } else if (isRecognizedTripleSlashComment(text, range.pos, range.end)) {
	        lastComment = { range, pinnedOrTripleSlash: true };
	        continue;
	      }
	      if (lastComment) {
	        if (lastComment.pinnedOrTripleSlash)
	          break;
	        const commentLine = sourceFile.getLineAndCharacterOfPosition(range.pos).line;
	        const lastCommentEndLine = sourceFile.getLineAndCharacterOfPosition(lastComment.range.end).line;
	        if (commentLine >= lastCommentEndLine + 2)
	          break;
	      }
	      if (sourceFile.statements.length) {
	        if (firstNodeLine === void 0)
	          firstNodeLine = sourceFile.getLineAndCharacterOfPosition(sourceFile.statements[0].getStart()).line;
	        const commentEndLine = sourceFile.getLineAndCharacterOfPosition(range.end).line;
	        if (firstNodeLine < commentEndLine + 2)
	          break;
	      }
	      lastComment = { range, pinnedOrTripleSlash: false };
	    }
	    if (lastComment) {
	      position = lastComment.range.end;
	      advancePastLineBreak();
	    }
	    return position;
	    function advancePastLineBreak() {
	      if (position < text.length) {
	        const charCode = text.charCodeAt(position);
	        if (isLineBreak(charCode)) {
	          position++;
	          if (position < text.length && charCode === 13 /* carriageReturn */ && text.charCodeAt(position) === 10 /* lineFeed */) {
	            position++;
	          }
	        }
	      }
	    }
	  }
	  function isValidLocationToAddComment(sourceFile, position) {
	    return !isInComment(sourceFile, position) && !isInString(sourceFile, position) && !isInTemplateString(sourceFile, position) && !isInJSXText(sourceFile, position);
	  }
	  function needSemicolonBetween(a, b) {
	    return (isPropertySignature(a) || isPropertyDeclaration(a)) && isClassOrTypeElement(b) && b.name.kind === 167 /* ComputedPropertyName */ || isStatementButNotDeclaration(a) && isStatementButNotDeclaration(b);
	  }
	  function deleteNode(changes, sourceFile, node, options = { leadingTriviaOption: 1 /* IncludeAll */ }) {
	    const startPosition = getAdjustedStartPosition(sourceFile, node, options);
	    const endPosition = getAdjustedEndPosition(sourceFile, node, options);
	    changes.deleteRange(sourceFile, { pos: startPosition, end: endPosition });
	  }
	  function deleteNodeInList(changes, deletedNodesInLists, sourceFile, node) {
	    const containingList = Debug.checkDefined(ts_formatting_exports.SmartIndenter.getContainingList(node, sourceFile));
	    const index = indexOfNode(containingList, node);
	    Debug.assert(index !== -1);
	    if (containingList.length === 1) {
	      deleteNode(changes, sourceFile, node);
	      return;
	    }
	    Debug.assert(!deletedNodesInLists.has(node), "Deleting a node twice");
	    deletedNodesInLists.add(node);
	    changes.deleteRange(sourceFile, {
	      pos: startPositionToDeleteNodeInList(sourceFile, node),
	      end: index === containingList.length - 1 ? getAdjustedEndPosition(sourceFile, node, {}) : endPositionToDeleteNodeInList(sourceFile, node, containingList[index - 1], containingList[index + 1])
	    });
	  }
	  var LeadingTriviaOption, TrailingTriviaOption, useNonAdjustedPositions, ChangeTracker, changesToText, textChangesTransformationContext, deleteDeclaration;
	  var init_textChanges = __esm({
	    "src/services/textChanges.ts"() {
	      init_ts4();
	      LeadingTriviaOption = /* @__PURE__ */ ((LeadingTriviaOption2) => {
	        LeadingTriviaOption2[LeadingTriviaOption2["Exclude"] = 0] = "Exclude";
	        LeadingTriviaOption2[LeadingTriviaOption2["IncludeAll"] = 1] = "IncludeAll";
	        LeadingTriviaOption2[LeadingTriviaOption2["JSDoc"] = 2] = "JSDoc";
	        LeadingTriviaOption2[LeadingTriviaOption2["StartLine"] = 3] = "StartLine";
	        return LeadingTriviaOption2;
	      })(LeadingTriviaOption || {});
	      TrailingTriviaOption = /* @__PURE__ */ ((TrailingTriviaOption2) => {
	        TrailingTriviaOption2[TrailingTriviaOption2["Exclude"] = 0] = "Exclude";
	        TrailingTriviaOption2[TrailingTriviaOption2["ExcludeWhitespace"] = 1] = "ExcludeWhitespace";
	        TrailingTriviaOption2[TrailingTriviaOption2["Include"] = 2] = "Include";
	        return TrailingTriviaOption2;
	      })(TrailingTriviaOption || {});
	      useNonAdjustedPositions = {
	        leadingTriviaOption: 0 /* Exclude */,
	        trailingTriviaOption: 0 /* Exclude */
	      };
	      ChangeTracker = class _ChangeTracker {
	        /** Public for tests only. Other callers should use `ChangeTracker.with`. */
	        constructor(newLineCharacter, formatContext) {
	          this.newLineCharacter = newLineCharacter;
	          this.formatContext = formatContext;
	          this.changes = [];
	          this.classesWithNodesInsertedAtStart = /* @__PURE__ */ new Map();
	          // Set<ClassDeclaration> implemented as Map<node id, ClassDeclaration>
	          this.deletedNodes = [];
	        }
	        static fromContext(context) {
	          return new _ChangeTracker(getNewLineOrDefaultFromHost(context.host, context.formatContext.options), context.formatContext);
	        }
	        static with(context, cb) {
	          const tracker = _ChangeTracker.fromContext(context);
	          cb(tracker);
	          return tracker.getChanges();
	        }
	        pushRaw(sourceFile, change) {
	          Debug.assertEqual(sourceFile.fileName, change.fileName);
	          for (const c of change.textChanges) {
	            this.changes.push({
	              kind: 3 /* Text */,
	              sourceFile,
	              text: c.newText,
	              range: createTextRangeFromSpan(c.span)
	            });
	          }
	        }
	        deleteRange(sourceFile, range) {
	          this.changes.push({ kind: 0 /* Remove */, sourceFile, range });
	        }
	        delete(sourceFile, node) {
	          this.deletedNodes.push({ sourceFile, node });
	        }
	        /** Stop! Consider using `delete` instead, which has logic for deleting nodes from delimited lists. */
	        deleteNode(sourceFile, node, options = { leadingTriviaOption: 1 /* IncludeAll */ }) {
	          this.deleteRange(sourceFile, getAdjustedRange(sourceFile, node, node, options));
	        }
	        deleteNodes(sourceFile, nodes, options = { leadingTriviaOption: 1 /* IncludeAll */ }, hasTrailingComment) {
	          for (const node of nodes) {
	            const pos = getAdjustedStartPosition(sourceFile, node, options, hasTrailingComment);
	            const end = getAdjustedEndPosition(sourceFile, node, options);
	            this.deleteRange(sourceFile, { pos, end });
	            hasTrailingComment = !!getEndPositionOfMultilineTrailingComment(sourceFile, node, options);
	          }
	        }
	        deleteModifier(sourceFile, modifier) {
	          this.deleteRange(sourceFile, { pos: modifier.getStart(sourceFile), end: skipTrivia(
	            sourceFile.text,
	            modifier.end,
	            /*stopAfterLineBreak*/
	            true
	          ) });
	        }
	        deleteNodeRange(sourceFile, startNode2, endNode2, options = { leadingTriviaOption: 1 /* IncludeAll */ }) {
	          const startPosition = getAdjustedStartPosition(sourceFile, startNode2, options);
	          const endPosition = getAdjustedEndPosition(sourceFile, endNode2, options);
	          this.deleteRange(sourceFile, { pos: startPosition, end: endPosition });
	        }
	        deleteNodeRangeExcludingEnd(sourceFile, startNode2, afterEndNode, options = { leadingTriviaOption: 1 /* IncludeAll */ }) {
	          const startPosition = getAdjustedStartPosition(sourceFile, startNode2, options);
	          const endPosition = afterEndNode === void 0 ? sourceFile.text.length : getAdjustedStartPosition(sourceFile, afterEndNode, options);
	          this.deleteRange(sourceFile, { pos: startPosition, end: endPosition });
	        }
	        replaceRange(sourceFile, range, newNode, options = {}) {
	          this.changes.push({ kind: 1 /* ReplaceWithSingleNode */, sourceFile, range, options, node: newNode });
	        }
	        replaceNode(sourceFile, oldNode, newNode, options = useNonAdjustedPositions) {
	          this.replaceRange(sourceFile, getAdjustedRange(sourceFile, oldNode, oldNode, options), newNode, options);
	        }
	        replaceNodeRange(sourceFile, startNode2, endNode2, newNode, options = useNonAdjustedPositions) {
	          this.replaceRange(sourceFile, getAdjustedRange(sourceFile, startNode2, endNode2, options), newNode, options);
	        }
	        replaceRangeWithNodes(sourceFile, range, newNodes, options = {}) {
	          this.changes.push({ kind: 2 /* ReplaceWithMultipleNodes */, sourceFile, range, options, nodes: newNodes });
	        }
	        replaceNodeWithNodes(sourceFile, oldNode, newNodes, options = useNonAdjustedPositions) {
	          this.replaceRangeWithNodes(sourceFile, getAdjustedRange(sourceFile, oldNode, oldNode, options), newNodes, options);
	        }
	        replaceNodeWithText(sourceFile, oldNode, text) {
	          this.replaceRangeWithText(sourceFile, getAdjustedRange(sourceFile, oldNode, oldNode, useNonAdjustedPositions), text);
	        }
	        replaceNodeRangeWithNodes(sourceFile, startNode2, endNode2, newNodes, options = useNonAdjustedPositions) {
	          this.replaceRangeWithNodes(sourceFile, getAdjustedRange(sourceFile, startNode2, endNode2, options), newNodes, options);
	        }
	        nodeHasTrailingComment(sourceFile, oldNode, configurableEnd = useNonAdjustedPositions) {
	          return !!getEndPositionOfMultilineTrailingComment(sourceFile, oldNode, configurableEnd);
	        }
	        nextCommaToken(sourceFile, node) {
	          const next = findNextToken(node, node.parent, sourceFile);
	          return next && next.kind === 28 /* CommaToken */ ? next : void 0;
	        }
	        replacePropertyAssignment(sourceFile, oldNode, newNode) {
	          const suffix = this.nextCommaToken(sourceFile, oldNode) ? "" : "," + this.newLineCharacter;
	          this.replaceNode(sourceFile, oldNode, newNode, { suffix });
	        }
	        insertNodeAt(sourceFile, pos, newNode, options = {}) {
	          this.replaceRange(sourceFile, createRange(pos), newNode, options);
	        }
	        insertNodesAt(sourceFile, pos, newNodes, options = {}) {
	          this.replaceRangeWithNodes(sourceFile, createRange(pos), newNodes, options);
	        }
	        insertNodeAtTopOfFile(sourceFile, newNode, blankLineBetween) {
	          this.insertAtTopOfFile(sourceFile, newNode, blankLineBetween);
	        }
	        insertNodesAtTopOfFile(sourceFile, newNodes, blankLineBetween) {
	          this.insertAtTopOfFile(sourceFile, newNodes, blankLineBetween);
	        }
	        insertAtTopOfFile(sourceFile, insert, blankLineBetween) {
	          const pos = getInsertionPositionAtSourceFileTop(sourceFile);
	          const options = {
	            prefix: pos === 0 ? void 0 : this.newLineCharacter,
	            suffix: (isLineBreak(sourceFile.text.charCodeAt(pos)) ? "" : this.newLineCharacter) + (blankLineBetween ? this.newLineCharacter : "")
	          };
	          if (isArray(insert)) {
	            this.insertNodesAt(sourceFile, pos, insert, options);
	          } else {
	            this.insertNodeAt(sourceFile, pos, insert, options);
	          }
	        }
	        insertNodesAtEndOfFile(sourceFile, newNodes, blankLineBetween) {
	          this.insertAtEndOfFile(sourceFile, newNodes, blankLineBetween);
	        }
	        insertAtEndOfFile(sourceFile, insert, blankLineBetween) {
	          const pos = sourceFile.end + 1;
	          const options = {
	            prefix: this.newLineCharacter,
	            suffix: this.newLineCharacter + (blankLineBetween ? this.newLineCharacter : "")
	          };
	          this.insertNodesAt(sourceFile, pos, insert, options);
	        }
	        insertStatementsInNewFile(fileName, statements, oldFile) {
	          if (!this.newFileChanges) {
	            this.newFileChanges = createMultiMap();
	          }
	          this.newFileChanges.add(fileName, { oldFile, statements });
	        }
	        insertFirstParameter(sourceFile, parameters, newParam) {
	          const p0 = firstOrUndefined(parameters);
	          if (p0) {
	            this.insertNodeBefore(sourceFile, p0, newParam);
	          } else {
	            this.insertNodeAt(sourceFile, parameters.pos, newParam);
	          }
	        }
	        insertNodeBefore(sourceFile, before, newNode, blankLineBetween = false, options = {}) {
	          this.insertNodeAt(sourceFile, getAdjustedStartPosition(sourceFile, before, options), newNode, this.getOptionsForInsertNodeBefore(before, newNode, blankLineBetween));
	        }
	        insertNodesBefore(sourceFile, before, newNodes, blankLineBetween = false, options = {}) {
	          this.insertNodesAt(sourceFile, getAdjustedStartPosition(sourceFile, before, options), newNodes, this.getOptionsForInsertNodeBefore(before, first(newNodes), blankLineBetween));
	        }
	        insertModifierAt(sourceFile, pos, modifier, options = {}) {
	          this.insertNodeAt(sourceFile, pos, factory.createToken(modifier), options);
	        }
	        insertModifierBefore(sourceFile, modifier, before) {
	          return this.insertModifierAt(sourceFile, before.getStart(sourceFile), modifier, { suffix: " " });
	        }
	        insertCommentBeforeLine(sourceFile, lineNumber, position, commentText) {
	          const lineStartPosition = getStartPositionOfLine(lineNumber, sourceFile);
	          const startPosition = getFirstNonSpaceCharacterPosition(sourceFile.text, lineStartPosition);
	          const insertAtLineStart = isValidLocationToAddComment(sourceFile, startPosition);
	          const token = getTouchingToken(sourceFile, insertAtLineStart ? startPosition : position);
	          const indent3 = sourceFile.text.slice(lineStartPosition, startPosition);
	          const text = `${insertAtLineStart ? "" : this.newLineCharacter}//${commentText}${this.newLineCharacter}${indent3}`;
	          this.insertText(sourceFile, token.getStart(sourceFile), text);
	        }
	        insertJsdocCommentBefore(sourceFile, node, tag) {
	          const fnStart = node.getStart(sourceFile);
	          if (node.jsDoc) {
	            for (const jsdoc of node.jsDoc) {
	              this.deleteRange(sourceFile, {
	                pos: getLineStartPositionForPosition(jsdoc.getStart(sourceFile), sourceFile),
	                end: getAdjustedEndPosition(
	                  sourceFile,
	                  jsdoc,
	                  /*options*/
	                  {}
	                )
	              });
	            }
	          }
	          const startPosition = getPrecedingNonSpaceCharacterPosition(sourceFile.text, fnStart - 1);
	          const indent3 = sourceFile.text.slice(startPosition, fnStart);
	          this.insertNodeAt(sourceFile, fnStart, tag, { suffix: this.newLineCharacter + indent3 });
	        }
	        createJSDocText(sourceFile, node) {
	          const comments = flatMap(node.jsDoc, (jsDoc2) => isString(jsDoc2.comment) ? factory.createJSDocText(jsDoc2.comment) : jsDoc2.comment);
	          const jsDoc = singleOrUndefined(node.jsDoc);
	          return jsDoc && positionsAreOnSameLine(jsDoc.pos, jsDoc.end, sourceFile) && length(comments) === 0 ? void 0 : factory.createNodeArray(intersperse(comments, factory.createJSDocText("\n")));
	        }
	        replaceJSDocComment(sourceFile, node, tags) {
	          this.insertJsdocCommentBefore(sourceFile, updateJSDocHost(node), factory.createJSDocComment(this.createJSDocText(sourceFile, node), factory.createNodeArray(tags)));
	        }
	        addJSDocTags(sourceFile, parent2, newTags) {
	          const oldTags = flatMapToMutable(parent2.jsDoc, (j) => j.tags);
	          const unmergedNewTags = newTags.filter(
	            (newTag) => !oldTags.some((tag, i) => {
	              const merged = tryMergeJsdocTags(tag, newTag);
	              if (merged)
	                oldTags[i] = merged;
	              return !!merged;
	            })
	          );
	          this.replaceJSDocComment(sourceFile, parent2, [...oldTags, ...unmergedNewTags]);
	        }
	        filterJSDocTags(sourceFile, parent2, predicate) {
	          this.replaceJSDocComment(sourceFile, parent2, filter(flatMapToMutable(parent2.jsDoc, (j) => j.tags), predicate));
	        }
	        replaceRangeWithText(sourceFile, range, text) {
	          this.changes.push({ kind: 3 /* Text */, sourceFile, range, text });
	        }
	        insertText(sourceFile, pos, text) {
	          this.replaceRangeWithText(sourceFile, createRange(pos), text);
	        }
	        /** Prefer this over replacing a node with another that has a type annotation, as it avoids reformatting the other parts of the node. */
	        tryInsertTypeAnnotation(sourceFile, node, type) {
	          let endNode2;
	          if (isFunctionLike(node)) {
	            endNode2 = findChildOfKind(node, 22 /* CloseParenToken */, sourceFile);
	            if (!endNode2) {
	              if (!isArrowFunction(node))
	                return false;
	              endNode2 = first(node.parameters);
	            }
	          } else {
	            endNode2 = (node.kind === 260 /* VariableDeclaration */ ? node.exclamationToken : node.questionToken) ?? node.name;
	          }
	          this.insertNodeAt(sourceFile, endNode2.end, type, { prefix: ": " });
	          return true;
	        }
	        tryInsertThisTypeAnnotation(sourceFile, node, type) {
	          const start = findChildOfKind(node, 21 /* OpenParenToken */, sourceFile).getStart(sourceFile) + 1;
	          const suffix = node.parameters.length ? ", " : "";
	          this.insertNodeAt(sourceFile, start, type, { prefix: "this: ", suffix });
	        }
	        insertTypeParameters(sourceFile, node, typeParameters) {
	          const start = (findChildOfKind(node, 21 /* OpenParenToken */, sourceFile) || first(node.parameters)).getStart(sourceFile);
	          this.insertNodesAt(sourceFile, start, typeParameters, { prefix: "<", suffix: ">", joiner: ", " });
	        }
	        getOptionsForInsertNodeBefore(before, inserted, blankLineBetween) {
	          if (isStatement(before) || isClassElement(before)) {
	            return { suffix: blankLineBetween ? this.newLineCharacter + this.newLineCharacter : this.newLineCharacter };
	          } else if (isVariableDeclaration(before)) {
	            return { suffix: ", " };
	          } else if (isParameter(before)) {
	            return isParameter(inserted) ? { suffix: ", " } : {};
	          } else if (isStringLiteral(before) && isImportDeclaration(before.parent) || isNamedImports(before)) {
	            return { suffix: ", " };
	          } else if (isImportSpecifier(before)) {
	            return { suffix: "," + (blankLineBetween ? this.newLineCharacter : " ") };
	          }
	          return Debug.failBadSyntaxKind(before);
	        }
	        insertNodeAtConstructorStart(sourceFile, ctr, newStatement) {
	          const firstStatement = firstOrUndefined(ctr.body.statements);
	          if (!firstStatement || !ctr.body.multiLine) {
	            this.replaceConstructorBody(sourceFile, ctr, [newStatement, ...ctr.body.statements]);
	          } else {
	            this.insertNodeBefore(sourceFile, firstStatement, newStatement);
	          }
	        }
	        insertNodeAtConstructorStartAfterSuperCall(sourceFile, ctr, newStatement) {
	          const superCallStatement = find(ctr.body.statements, (stmt) => isExpressionStatement(stmt) && isSuperCall(stmt.expression));
	          if (!superCallStatement || !ctr.body.multiLine) {
	            this.replaceConstructorBody(sourceFile, ctr, [...ctr.body.statements, newStatement]);
	          } else {
	            this.insertNodeAfter(sourceFile, superCallStatement, newStatement);
	          }
	        }
	        insertNodeAtConstructorEnd(sourceFile, ctr, newStatement) {
	          const lastStatement = lastOrUndefined(ctr.body.statements);
	          if (!lastStatement || !ctr.body.multiLine) {
	            this.replaceConstructorBody(sourceFile, ctr, [...ctr.body.statements, newStatement]);
	          } else {
	            this.insertNodeAfter(sourceFile, lastStatement, newStatement);
	          }
	        }
	        replaceConstructorBody(sourceFile, ctr, statements) {
	          this.replaceNode(sourceFile, ctr.body, factory.createBlock(
	            statements,
	            /*multiLine*/
	            true
	          ));
	        }
	        insertNodeAtEndOfScope(sourceFile, scope, newNode) {
	          const pos = getAdjustedStartPosition(sourceFile, scope.getLastToken(), {});
	          this.insertNodeAt(sourceFile, pos, newNode, {
	            prefix: isLineBreak(sourceFile.text.charCodeAt(scope.getLastToken().pos)) ? this.newLineCharacter : this.newLineCharacter + this.newLineCharacter,
	            suffix: this.newLineCharacter
	          });
	        }
	        insertMemberAtStart(sourceFile, node, newElement) {
	          this.insertNodeAtStartWorker(sourceFile, node, newElement);
	        }
	        insertNodeAtObjectStart(sourceFile, obj, newElement) {
	          this.insertNodeAtStartWorker(sourceFile, obj, newElement);
	        }
	        insertNodeAtStartWorker(sourceFile, node, newElement) {
	          const indentation = this.guessIndentationFromExistingMembers(sourceFile, node) ?? this.computeIndentationForNewMember(sourceFile, node);
	          this.insertNodeAt(sourceFile, getMembersOrProperties(node).pos, newElement, this.getInsertNodeAtStartInsertOptions(sourceFile, node, indentation));
	        }
	        /**
	         * Tries to guess the indentation from the existing members of a class/interface/object. All members must be on
	         * new lines and must share the same indentation.
	         */
	        guessIndentationFromExistingMembers(sourceFile, node) {
	          let indentation;
	          let lastRange = node;
	          for (const member of getMembersOrProperties(node)) {
	            if (rangeStartPositionsAreOnSameLine(lastRange, member, sourceFile)) {
	              return void 0;
	            }
	            const memberStart = member.getStart(sourceFile);
	            const memberIndentation = ts_formatting_exports.SmartIndenter.findFirstNonWhitespaceColumn(getLineStartPositionForPosition(memberStart, sourceFile), memberStart, sourceFile, this.formatContext.options);
	            if (indentation === void 0) {
	              indentation = memberIndentation;
	            } else if (memberIndentation !== indentation) {
	              return void 0;
	            }
	            lastRange = member;
	          }
	          return indentation;
	        }
	        computeIndentationForNewMember(sourceFile, node) {
	          const nodeStart = node.getStart(sourceFile);
	          return ts_formatting_exports.SmartIndenter.findFirstNonWhitespaceColumn(getLineStartPositionForPosition(nodeStart, sourceFile), nodeStart, sourceFile, this.formatContext.options) + (this.formatContext.options.indentSize ?? 4);
	        }
	        getInsertNodeAtStartInsertOptions(sourceFile, node, indentation) {
	          const members = getMembersOrProperties(node);
	          const isEmpty = members.length === 0;
	          const isFirstInsertion = addToSeen(this.classesWithNodesInsertedAtStart, getNodeId(node), { node, sourceFile });
	          const insertTrailingComma = isObjectLiteralExpression(node) && (!isJsonSourceFile(sourceFile) || !isEmpty);
	          const insertLeadingComma = isObjectLiteralExpression(node) && isJsonSourceFile(sourceFile) && isEmpty && !isFirstInsertion;
	          return {
	            indentation,
	            prefix: (insertLeadingComma ? "," : "") + this.newLineCharacter,
	            suffix: insertTrailingComma ? "," : isInterfaceDeclaration(node) && isEmpty ? ";" : ""
	          };
	        }
	        insertNodeAfterComma(sourceFile, after, newNode) {
	          const endPosition = this.insertNodeAfterWorker(sourceFile, this.nextCommaToken(sourceFile, after) || after, newNode);
	          this.insertNodeAt(sourceFile, endPosition, newNode, this.getInsertNodeAfterOptions(sourceFile, after));
	        }
	        insertNodeAfter(sourceFile, after, newNode) {
	          const endPosition = this.insertNodeAfterWorker(sourceFile, after, newNode);
	          this.insertNodeAt(sourceFile, endPosition, newNode, this.getInsertNodeAfterOptions(sourceFile, after));
	        }
	        insertNodeAtEndOfList(sourceFile, list, newNode) {
	          this.insertNodeAt(sourceFile, list.end, newNode, { prefix: ", " });
	        }
	        insertNodesAfter(sourceFile, after, newNodes) {
	          const endPosition = this.insertNodeAfterWorker(sourceFile, after, first(newNodes));
	          this.insertNodesAt(sourceFile, endPosition, newNodes, this.getInsertNodeAfterOptions(sourceFile, after));
	        }
	        insertNodeAfterWorker(sourceFile, after, newNode) {
	          if (needSemicolonBetween(after, newNode)) {
	            if (sourceFile.text.charCodeAt(after.end - 1) !== 59 /* semicolon */) {
	              this.replaceRange(sourceFile, createRange(after.end), factory.createToken(27 /* SemicolonToken */));
	            }
	          }
	          const endPosition = getAdjustedEndPosition(sourceFile, after, {});
	          return endPosition;
	        }
	        getInsertNodeAfterOptions(sourceFile, after) {
	          const options = this.getInsertNodeAfterOptionsWorker(after);
	          return {
	            ...options,
	            prefix: after.end === sourceFile.end && isStatement(after) ? options.prefix ? `
${options.prefix}` : "\n" : options.prefix
	          };
	        }
	        getInsertNodeAfterOptionsWorker(node) {
	          switch (node.kind) {
	            case 263 /* ClassDeclaration */:
	            case 267 /* ModuleDeclaration */:
	              return { prefix: this.newLineCharacter, suffix: this.newLineCharacter };
	            case 260 /* VariableDeclaration */:
	            case 11 /* StringLiteral */:
	            case 80 /* Identifier */:
	              return { prefix: ", " };
	            case 303 /* PropertyAssignment */:
	              return { suffix: "," + this.newLineCharacter };
	            case 95 /* ExportKeyword */:
	              return { prefix: " " };
	            case 169 /* Parameter */:
	              return {};
	            default:
	              Debug.assert(isStatement(node) || isClassOrTypeElement(node));
	              return { suffix: this.newLineCharacter };
	          }
	        }
	        insertName(sourceFile, node, name) {
	          Debug.assert(!node.name);
	          if (node.kind === 219 /* ArrowFunction */) {
	            const arrow = findChildOfKind(node, 39 /* EqualsGreaterThanToken */, sourceFile);
	            const lparen = findChildOfKind(node, 21 /* OpenParenToken */, sourceFile);
	            if (lparen) {
	              this.insertNodesAt(sourceFile, lparen.getStart(sourceFile), [factory.createToken(100 /* FunctionKeyword */), factory.createIdentifier(name)], { joiner: " " });
	              deleteNode(this, sourceFile, arrow);
	            } else {
	              this.insertText(sourceFile, first(node.parameters).getStart(sourceFile), `function ${name}(`);
	              this.replaceRange(sourceFile, arrow, factory.createToken(22 /* CloseParenToken */));
	            }
	            if (node.body.kind !== 241 /* Block */) {
	              this.insertNodesAt(sourceFile, node.body.getStart(sourceFile), [factory.createToken(19 /* OpenBraceToken */), factory.createToken(107 /* ReturnKeyword */)], { joiner: " ", suffix: " " });
	              this.insertNodesAt(sourceFile, node.body.end, [factory.createToken(27 /* SemicolonToken */), factory.createToken(20 /* CloseBraceToken */)], { joiner: " " });
	            }
	          } else {
	            const pos = findChildOfKind(node, node.kind === 218 /* FunctionExpression */ ? 100 /* FunctionKeyword */ : 86 /* ClassKeyword */, sourceFile).end;
	            this.insertNodeAt(sourceFile, pos, factory.createIdentifier(name), { prefix: " " });
	          }
	        }
	        insertExportModifier(sourceFile, node) {
	          this.insertText(sourceFile, node.getStart(sourceFile), "export ");
	        }
	        insertImportSpecifierAtIndex(sourceFile, importSpecifier, namedImports, index) {
	          const prevSpecifier = namedImports.elements[index - 1];
	          if (prevSpecifier) {
	            this.insertNodeInListAfter(sourceFile, prevSpecifier, importSpecifier);
	          } else {
	            this.insertNodeBefore(
	              sourceFile,
	              namedImports.elements[0],
	              importSpecifier,
	              !positionsAreOnSameLine(namedImports.elements[0].getStart(), namedImports.parent.parent.getStart(), sourceFile)
	            );
	          }
	        }
	        /**
	         * This function should be used to insert nodes in lists when nodes don't carry separators as the part of the node range,
	         * i.e. arguments in arguments lists, parameters in parameter lists etc.
	         * Note that separators are part of the node in statements and class elements.
	         */
	        insertNodeInListAfter(sourceFile, after, newNode, containingList = ts_formatting_exports.SmartIndenter.getContainingList(after, sourceFile)) {
	          if (!containingList) {
	            Debug.fail("node is not a list element");
	            return;
	          }
	          const index = indexOfNode(containingList, after);
	          if (index < 0) {
	            return;
	          }
	          const end = after.getEnd();
	          if (index !== containingList.length - 1) {
	            const nextToken = getTokenAtPosition(sourceFile, after.end);
	            if (nextToken && isSeparator(after, nextToken)) {
	              const nextNode = containingList[index + 1];
	              const startPos = skipWhitespacesAndLineBreaks(sourceFile.text, nextNode.getFullStart());
	              const suffix = `${tokenToString(nextToken.kind)}${sourceFile.text.substring(nextToken.end, startPos)}`;
	              this.insertNodesAt(sourceFile, startPos, [newNode], { suffix });
	            }
	          } else {
	            const afterStart = after.getStart(sourceFile);
	            const afterStartLinePosition = getLineStartPositionForPosition(afterStart, sourceFile);
	            let separator;
	            let multilineList = false;
	            if (containingList.length === 1) {
	              separator = 28 /* CommaToken */;
	            } else {
	              const tokenBeforeInsertPosition = findPrecedingToken(after.pos, sourceFile);
	              separator = isSeparator(after, tokenBeforeInsertPosition) ? tokenBeforeInsertPosition.kind : 28 /* CommaToken */;
	              const afterMinusOneStartLinePosition = getLineStartPositionForPosition(containingList[index - 1].getStart(sourceFile), sourceFile);
	              multilineList = afterMinusOneStartLinePosition !== afterStartLinePosition;
	            }
	            if (hasCommentsBeforeLineBreak(sourceFile.text, after.end) || !positionsAreOnSameLine(containingList.pos, containingList.end, sourceFile)) {
	              multilineList = true;
	            }
	            if (multilineList) {
	              this.replaceRange(sourceFile, createRange(end), factory.createToken(separator));
	              const indentation = ts_formatting_exports.SmartIndenter.findFirstNonWhitespaceColumn(afterStartLinePosition, afterStart, sourceFile, this.formatContext.options);
	              let insertPos = skipTrivia(
	                sourceFile.text,
	                end,
	                /*stopAfterLineBreak*/
	                true,
	                /*stopAtComments*/
	                false
	              );
	              while (insertPos !== end && isLineBreak(sourceFile.text.charCodeAt(insertPos - 1))) {
	                insertPos--;
	              }
	              this.replaceRange(sourceFile, createRange(insertPos), newNode, { indentation, prefix: this.newLineCharacter });
	            } else {
	              this.replaceRange(sourceFile, createRange(end), newNode, { prefix: `${tokenToString(separator)} ` });
	            }
	          }
	        }
	        parenthesizeExpression(sourceFile, expression) {
	          this.replaceRange(sourceFile, rangeOfNode(expression), factory.createParenthesizedExpression(expression));
	        }
	        finishClassesWithNodesInsertedAtStart() {
	          this.classesWithNodesInsertedAtStart.forEach(({ node, sourceFile }) => {
	            const [openBraceEnd, closeBraceEnd] = getClassOrObjectBraceEnds(node, sourceFile);
	            if (openBraceEnd !== void 0 && closeBraceEnd !== void 0) {
	              const isEmpty = getMembersOrProperties(node).length === 0;
	              const isSingleLine = positionsAreOnSameLine(openBraceEnd, closeBraceEnd, sourceFile);
	              if (isEmpty && isSingleLine && openBraceEnd !== closeBraceEnd - 1) {
	                this.deleteRange(sourceFile, createRange(openBraceEnd, closeBraceEnd - 1));
	              }
	              if (isSingleLine) {
	                this.insertText(sourceFile, closeBraceEnd - 1, this.newLineCharacter);
	              }
	            }
	          });
	        }
	        finishDeleteDeclarations() {
	          const deletedNodesInLists = /* @__PURE__ */ new Set();
	          for (const { sourceFile, node } of this.deletedNodes) {
	            if (!this.deletedNodes.some((d) => d.sourceFile === sourceFile && rangeContainsRangeExclusive(d.node, node))) {
	              if (isArray(node)) {
	                this.deleteRange(sourceFile, rangeOfTypeParameters(sourceFile, node));
	              } else {
	                deleteDeclaration.deleteDeclaration(this, deletedNodesInLists, sourceFile, node);
	              }
	            }
	          }
	          deletedNodesInLists.forEach((node) => {
	            const sourceFile = node.getSourceFile();
	            const list = ts_formatting_exports.SmartIndenter.getContainingList(node, sourceFile);
	            if (node !== last(list))
	              return;
	            const lastNonDeletedIndex = findLastIndex(list, (n) => !deletedNodesInLists.has(n), list.length - 2);
	            if (lastNonDeletedIndex !== -1) {
	              this.deleteRange(sourceFile, { pos: list[lastNonDeletedIndex].end, end: startPositionToDeleteNodeInList(sourceFile, list[lastNonDeletedIndex + 1]) });
	            }
	          });
	        }
	        /**
	         * Note: after calling this, the TextChanges object must be discarded!
	         * @param validate only for tests
	         *    The reason we must validate as part of this method is that `getNonFormattedText` changes the node's positions,
	         *    so we can only call this once and can't get the non-formatted text separately.
	         */
	        getChanges(validate) {
	          this.finishDeleteDeclarations();
	          this.finishClassesWithNodesInsertedAtStart();
	          const changes = changesToText.getTextChangesFromChanges(this.changes, this.newLineCharacter, this.formatContext, validate);
	          if (this.newFileChanges) {
	            this.newFileChanges.forEach((insertions, fileName) => {
	              changes.push(changesToText.newFileChanges(fileName, insertions, this.newLineCharacter, this.formatContext));
	            });
	          }
	          return changes;
	        }
	        createNewFile(oldFile, fileName, statements) {
	          this.insertStatementsInNewFile(fileName, statements, oldFile);
	        }
	      };
	      ((changesToText2) => {
	        function getTextChangesFromChanges(changes, newLineCharacter, formatContext, validate) {
	          return mapDefined(group(changes, (c) => c.sourceFile.path), (changesInFile) => {
	            const sourceFile = changesInFile[0].sourceFile;
	            const normalized = stableSort(changesInFile, (a, b) => a.range.pos - b.range.pos || a.range.end - b.range.end);
	            for (let i = 0; i < normalized.length - 1; i++) {
	              Debug.assert(normalized[i].range.end <= normalized[i + 1].range.pos, "Changes overlap", () => `${JSON.stringify(normalized[i].range)} and ${JSON.stringify(normalized[i + 1].range)}`);
	            }
	            const textChanges2 = mapDefined(normalized, (c) => {
	              const span = createTextSpanFromRange(c.range);
	              const targetSourceFile = c.kind === 1 /* ReplaceWithSingleNode */ ? getSourceFileOfNode(getOriginalNode(c.node)) ?? c.sourceFile : c.kind === 2 /* ReplaceWithMultipleNodes */ ? getSourceFileOfNode(getOriginalNode(c.nodes[0])) ?? c.sourceFile : c.sourceFile;
	              const newText = computeNewText(c, targetSourceFile, sourceFile, newLineCharacter, formatContext, validate);
	              if (span.length === newText.length && stringContainsAt(targetSourceFile.text, newText, span.start)) {
	                return void 0;
	              }
	              return createTextChange(span, newText);
	            });
	            return textChanges2.length > 0 ? { fileName: sourceFile.fileName, textChanges: textChanges2 } : void 0;
	          });
	        }
	        changesToText2.getTextChangesFromChanges = getTextChangesFromChanges;
	        function newFileChanges(fileName, insertions, newLineCharacter, formatContext) {
	          const text = newFileChangesWorker(getScriptKindFromFileName(fileName), insertions, newLineCharacter, formatContext);
	          return { fileName, textChanges: [createTextChange(createTextSpan(0, 0), text)], isNewFile: true };
	        }
	        changesToText2.newFileChanges = newFileChanges;
	        function newFileChangesWorker(scriptKind, insertions, newLineCharacter, formatContext) {
	          const nonFormattedText = flatMap(insertions, (insertion) => insertion.statements.map((s) => s === 4 /* NewLineTrivia */ ? "" : getNonformattedText(s, insertion.oldFile, newLineCharacter).text)).join(newLineCharacter);
	          const sourceFile = createSourceFile(
	            "any file name",
	            nonFormattedText,
	            { languageVersion: 99 /* ESNext */, jsDocParsingMode: 1 /* ParseNone */ },
	            /*setParentNodes*/
	            true,
	            scriptKind
	          );
	          const changes = ts_formatting_exports.formatDocument(sourceFile, formatContext);
	          return applyChanges(nonFormattedText, changes) + newLineCharacter;
	        }
	        changesToText2.newFileChangesWorker = newFileChangesWorker;
	        function computeNewText(change, targetSourceFile, sourceFile, newLineCharacter, formatContext, validate) {
	          var _a;
	          if (change.kind === 0 /* Remove */) {
	            return "";
	          }
	          if (change.kind === 3 /* Text */) {
	            return change.text;
	          }
	          const { options = {}, range: { pos } } = change;
	          const format = (n) => getFormattedTextOfNode(n, targetSourceFile, sourceFile, pos, options, newLineCharacter, formatContext, validate);
	          const text = change.kind === 2 /* ReplaceWithMultipleNodes */ ? change.nodes.map((n) => removeSuffix(format(n), newLineCharacter)).join(((_a = change.options) == null ? void 0 : _a.joiner) || newLineCharacter) : format(change.node);
	          const noIndent = options.indentation !== void 0 || getLineStartPositionForPosition(pos, targetSourceFile) === pos ? text : text.replace(/^\s+/, "");
	          return (options.prefix || "") + noIndent + (!options.suffix || endsWith(noIndent, options.suffix) ? "" : options.suffix);
	        }
	        function getFormattedTextOfNode(nodeIn, targetSourceFile, sourceFile, pos, { indentation, prefix, delta }, newLineCharacter, formatContext, validate) {
	          const { node, text } = getNonformattedText(nodeIn, targetSourceFile, newLineCharacter);
	          if (validate)
	            validate(node, text);
	          const formatOptions = getFormatCodeSettingsForWriting(formatContext, targetSourceFile);
	          const initialIndentation = indentation !== void 0 ? indentation : ts_formatting_exports.SmartIndenter.getIndentation(pos, sourceFile, formatOptions, prefix === newLineCharacter || getLineStartPositionForPosition(pos, targetSourceFile) === pos);
	          if (delta === void 0) {
	            delta = ts_formatting_exports.SmartIndenter.shouldIndentChildNode(formatOptions, nodeIn) ? formatOptions.indentSize || 0 : 0;
	          }
	          const file = {
	            text,
	            getLineAndCharacterOfPosition(pos2) {
	              return getLineAndCharacterOfPosition(this, pos2);
	            }
	          };
	          const changes = ts_formatting_exports.formatNodeGivenIndentation(node, file, targetSourceFile.languageVariant, initialIndentation, delta, { ...formatContext, options: formatOptions });
	          return applyChanges(text, changes);
	        }
	        function getNonformattedText(node, sourceFile, newLineCharacter) {
	          const writer = createWriter(newLineCharacter);
	          const newLine = getNewLineKind(newLineCharacter);
	          createPrinter({
	            newLine,
	            neverAsciiEscape: true,
	            preserveSourceNewlines: true,
	            terminateUnterminatedLiterals: true
	          }, writer).writeNode(4 /* Unspecified */, node, sourceFile, writer);
	          return { text: writer.getText(), node: assignPositionsToNode(node) };
	        }
	        changesToText2.getNonformattedText = getNonformattedText;
	      })(changesToText || (changesToText = {}));
	      textChangesTransformationContext = {
	        ...nullTransformationContext,
	        factory: createNodeFactory(
	          nullTransformationContext.factory.flags | 1 /* NoParenthesizerRules */,
	          nullTransformationContext.factory.baseFactory
	        )
	      };
	      ((_deleteDeclaration) => {
	        function deleteDeclaration2(changes, deletedNodesInLists, sourceFile, node) {
	          switch (node.kind) {
	            case 169 /* Parameter */: {
	              const oldFunction = node.parent;
	              if (isArrowFunction(oldFunction) && oldFunction.parameters.length === 1 && !findChildOfKind(oldFunction, 21 /* OpenParenToken */, sourceFile)) {
	                changes.replaceNodeWithText(sourceFile, node, "()");
	              } else {
	                deleteNodeInList(changes, deletedNodesInLists, sourceFile, node);
	              }
	              break;
	            }
	            case 272 /* ImportDeclaration */:
	            case 271 /* ImportEqualsDeclaration */:
	              const isFirstImport = sourceFile.imports.length && node === first(sourceFile.imports).parent || node === find(sourceFile.statements, isAnyImportSyntax);
	              deleteNode(changes, sourceFile, node, {
	                leadingTriviaOption: isFirstImport ? 0 /* Exclude */ : hasJSDocNodes(node) ? 2 /* JSDoc */ : 3 /* StartLine */
	              });
	              break;
	            case 208 /* BindingElement */:
	              const pattern = node.parent;
	              const preserveComma = pattern.kind === 207 /* ArrayBindingPattern */ && node !== last(pattern.elements);
	              if (preserveComma) {
	                deleteNode(changes, sourceFile, node);
	              } else {
	                deleteNodeInList(changes, deletedNodesInLists, sourceFile, node);
	              }
	              break;
	            case 260 /* VariableDeclaration */:
	              deleteVariableDeclaration(changes, deletedNodesInLists, sourceFile, node);
	              break;
	            case 168 /* TypeParameter */:
	              deleteNodeInList(changes, deletedNodesInLists, sourceFile, node);
	              break;
	            case 276 /* ImportSpecifier */:
	              const namedImports = node.parent;
	              if (namedImports.elements.length === 1) {
	                deleteImportBinding(changes, sourceFile, namedImports);
	              } else {
	                deleteNodeInList(changes, deletedNodesInLists, sourceFile, node);
	              }
	              break;
	            case 274 /* NamespaceImport */:
	              deleteImportBinding(changes, sourceFile, node);
	              break;
	            case 27 /* SemicolonToken */:
	              deleteNode(changes, sourceFile, node, { trailingTriviaOption: 0 /* Exclude */ });
	              break;
	            case 100 /* FunctionKeyword */:
	              deleteNode(changes, sourceFile, node, { leadingTriviaOption: 0 /* Exclude */ });
	              break;
	            case 263 /* ClassDeclaration */:
	            case 262 /* FunctionDeclaration */:
	              deleteNode(changes, sourceFile, node, { leadingTriviaOption: hasJSDocNodes(node) ? 2 /* JSDoc */ : 3 /* StartLine */ });
	              break;
	            default:
	              if (!node.parent) {
	                deleteNode(changes, sourceFile, node);
	              } else if (isImportClause(node.parent) && node.parent.name === node) {
	                deleteDefaultImport(changes, sourceFile, node.parent);
	              } else if (isCallExpression(node.parent) && contains(node.parent.arguments, node)) {
	                deleteNodeInList(changes, deletedNodesInLists, sourceFile, node);
	              } else {
	                deleteNode(changes, sourceFile, node);
	              }
	          }
	        }
	        _deleteDeclaration.deleteDeclaration = deleteDeclaration2;
	        function deleteDefaultImport(changes, sourceFile, importClause) {
	          if (!importClause.namedBindings) {
	            deleteNode(changes, sourceFile, importClause.parent);
	          } else {
	            const start = importClause.name.getStart(sourceFile);
	            const nextToken = getTokenAtPosition(sourceFile, importClause.name.end);
	            if (nextToken && nextToken.kind === 28 /* CommaToken */) {
	              const end = skipTrivia(
	                sourceFile.text,
	                nextToken.end,
	                /*stopAfterLineBreak*/
	                false,
	                /*stopAtComments*/
	                true
	              );
	              changes.deleteRange(sourceFile, { pos: start, end });
	            } else {
	              deleteNode(changes, sourceFile, importClause.name);
	            }
	          }
	        }
	        function deleteImportBinding(changes, sourceFile, node) {
	          if (node.parent.name) {
	            const previousToken = Debug.checkDefined(getTokenAtPosition(sourceFile, node.pos - 1));
	            changes.deleteRange(sourceFile, { pos: previousToken.getStart(sourceFile), end: node.end });
	          } else {
	            const importDecl = getAncestor(node, 272 /* ImportDeclaration */);
	            deleteNode(changes, sourceFile, importDecl);
	          }
	        }
	        function deleteVariableDeclaration(changes, deletedNodesInLists, sourceFile, node) {
	          const { parent: parent2 } = node;
	          if (parent2.kind === 299 /* CatchClause */) {
	            changes.deleteNodeRange(sourceFile, findChildOfKind(parent2, 21 /* OpenParenToken */, sourceFile), findChildOfKind(parent2, 22 /* CloseParenToken */, sourceFile));
	            return;
	          }
	          if (parent2.declarations.length !== 1) {
	            deleteNodeInList(changes, deletedNodesInLists, sourceFile, node);
	            return;
	          }
	          const gp = parent2.parent;
	          switch (gp.kind) {
	            case 250 /* ForOfStatement */:
	            case 249 /* ForInStatement */:
	              changes.replaceNode(sourceFile, node, factory.createObjectLiteralExpression());
	              break;
	            case 248 /* ForStatement */:
	              deleteNode(changes, sourceFile, parent2);
	              break;
	            case 243 /* VariableStatement */:
	              deleteNode(changes, sourceFile, gp, { leadingTriviaOption: hasJSDocNodes(gp) ? 2 /* JSDoc */ : 3 /* StartLine */ });
	              break;
	            default:
	              Debug.assertNever(gp);
	          }
	        }
	      })(deleteDeclaration || (deleteDeclaration = {}));
	    }
	  });

	  // src/services/_namespaces/ts.textChanges.ts
	  var ts_textChanges_exports = {};
	  __export(ts_textChanges_exports, {
	    ChangeTracker: () => ChangeTracker,
	    LeadingTriviaOption: () => LeadingTriviaOption,
	    TrailingTriviaOption: () => TrailingTriviaOption,
	    applyChanges: () => applyChanges,
	    assignPositionsToNode: () => assignPositionsToNode,
	    createWriter: () => createWriter,
	    deleteNode: () => deleteNode,
	    isThisTypeAnnotatable: () => isThisTypeAnnotatable,
	    isValidLocationToAddComment: () => isValidLocationToAddComment
	  });
	  var init_ts_textChanges = __esm({
	    "src/services/_namespaces/ts.textChanges.ts"() {
	      init_textChanges();
	    }
	  });

	  // src/services/formatting/formattingContext.ts
	  var FormattingRequestKind, FormattingContext;
	  var init_formattingContext = __esm({
	    "src/services/formatting/formattingContext.ts"() {
	      init_ts4();
	      FormattingRequestKind = /* @__PURE__ */ ((FormattingRequestKind2) => {
	        FormattingRequestKind2[FormattingRequestKind2["FormatDocument"] = 0] = "FormatDocument";
	        FormattingRequestKind2[FormattingRequestKind2["FormatSelection"] = 1] = "FormatSelection";
	        FormattingRequestKind2[FormattingRequestKind2["FormatOnEnter"] = 2] = "FormatOnEnter";
	        FormattingRequestKind2[FormattingRequestKind2["FormatOnSemicolon"] = 3] = "FormatOnSemicolon";
	        FormattingRequestKind2[FormattingRequestKind2["FormatOnOpeningCurlyBrace"] = 4] = "FormatOnOpeningCurlyBrace";
	        FormattingRequestKind2[FormattingRequestKind2["FormatOnClosingCurlyBrace"] = 5] = "FormatOnClosingCurlyBrace";
	        return FormattingRequestKind2;
	      })(FormattingRequestKind || {});
	      FormattingContext = class {
	        constructor(sourceFile, formattingRequestKind, options) {
	          this.sourceFile = sourceFile;
	          this.formattingRequestKind = formattingRequestKind;
	          this.options = options;
	        }
	        updateContext(currentRange, currentTokenParent, nextRange, nextTokenParent, commonParent) {
	          this.currentTokenSpan = Debug.checkDefined(currentRange);
	          this.currentTokenParent = Debug.checkDefined(currentTokenParent);
	          this.nextTokenSpan = Debug.checkDefined(nextRange);
	          this.nextTokenParent = Debug.checkDefined(nextTokenParent);
	          this.contextNode = Debug.checkDefined(commonParent);
	          this.contextNodeAllOnSameLine = void 0;
	          this.nextNodeAllOnSameLine = void 0;
	          this.tokensAreOnSameLine = void 0;
	          this.contextNodeBlockIsOnOneLine = void 0;
	          this.nextNodeBlockIsOnOneLine = void 0;
	        }
	        ContextNodeAllOnSameLine() {
	          if (this.contextNodeAllOnSameLine === void 0) {
	            this.contextNodeAllOnSameLine = this.NodeIsOnOneLine(this.contextNode);
	          }
	          return this.contextNodeAllOnSameLine;
	        }
	        NextNodeAllOnSameLine() {
	          if (this.nextNodeAllOnSameLine === void 0) {
	            this.nextNodeAllOnSameLine = this.NodeIsOnOneLine(this.nextTokenParent);
	          }
	          return this.nextNodeAllOnSameLine;
	        }
	        TokensAreOnSameLine() {
	          if (this.tokensAreOnSameLine === void 0) {
	            const startLine = this.sourceFile.getLineAndCharacterOfPosition(this.currentTokenSpan.pos).line;
	            const endLine = this.sourceFile.getLineAndCharacterOfPosition(this.nextTokenSpan.pos).line;
	            this.tokensAreOnSameLine = startLine === endLine;
	          }
	          return this.tokensAreOnSameLine;
	        }
	        ContextNodeBlockIsOnOneLine() {
	          if (this.contextNodeBlockIsOnOneLine === void 0) {
	            this.contextNodeBlockIsOnOneLine = this.BlockIsOnOneLine(this.contextNode);
	          }
	          return this.contextNodeBlockIsOnOneLine;
	        }
	        NextNodeBlockIsOnOneLine() {
	          if (this.nextNodeBlockIsOnOneLine === void 0) {
	            this.nextNodeBlockIsOnOneLine = this.BlockIsOnOneLine(this.nextTokenParent);
	          }
	          return this.nextNodeBlockIsOnOneLine;
	        }
	        NodeIsOnOneLine(node) {
	          const startLine = this.sourceFile.getLineAndCharacterOfPosition(node.getStart(this.sourceFile)).line;
	          const endLine = this.sourceFile.getLineAndCharacterOfPosition(node.getEnd()).line;
	          return startLine === endLine;
	        }
	        BlockIsOnOneLine(node) {
	          const openBrace = findChildOfKind(node, 19 /* OpenBraceToken */, this.sourceFile);
	          const closeBrace = findChildOfKind(node, 20 /* CloseBraceToken */, this.sourceFile);
	          if (openBrace && closeBrace) {
	            const startLine = this.sourceFile.getLineAndCharacterOfPosition(openBrace.getEnd()).line;
	            const endLine = this.sourceFile.getLineAndCharacterOfPosition(closeBrace.getStart(this.sourceFile)).line;
	            return startLine === endLine;
	          }
	          return false;
	        }
	      };
	    }
	  });

	  // src/services/formatting/formattingScanner.ts
	  function getFormattingScanner(text, languageVariant, startPos, endPos, cb) {
	    const scanner2 = languageVariant === 1 /* JSX */ ? jsxScanner : standardScanner;
	    scanner2.setText(text);
	    scanner2.resetTokenState(startPos);
	    let wasNewLine = true;
	    let leadingTrivia;
	    let trailingTrivia;
	    let savedPos;
	    let lastScanAction;
	    let lastTokenInfo;
	    const res = cb({
	      advance,
	      readTokenInfo,
	      readEOFTokenRange,
	      isOnToken,
	      isOnEOF,
	      getCurrentLeadingTrivia: () => leadingTrivia,
	      lastTrailingTriviaWasNewLine: () => wasNewLine,
	      skipToEndOf,
	      skipToStartOf,
	      getTokenFullStart: () => (lastTokenInfo == null ? void 0 : lastTokenInfo.token.pos) ?? scanner2.getTokenStart(),
	      getStartPos: () => (lastTokenInfo == null ? void 0 : lastTokenInfo.token.pos) ?? scanner2.getTokenStart()
	    });
	    lastTokenInfo = void 0;
	    scanner2.setText(void 0);
	    return res;
	    function advance() {
	      lastTokenInfo = void 0;
	      const isStarted = scanner2.getTokenFullStart() !== startPos;
	      if (isStarted) {
	        wasNewLine = !!trailingTrivia && last(trailingTrivia).kind === 4 /* NewLineTrivia */;
	      } else {
	        scanner2.scan();
	      }
	      leadingTrivia = void 0;
	      trailingTrivia = void 0;
	      let pos = scanner2.getTokenFullStart();
	      while (pos < endPos) {
	        const t = scanner2.getToken();
	        if (!isTrivia(t)) {
	          break;
	        }
	        scanner2.scan();
	        const item = {
	          pos,
	          end: scanner2.getTokenFullStart(),
	          kind: t
	        };
	        pos = scanner2.getTokenFullStart();
	        leadingTrivia = append(leadingTrivia, item);
	      }
	      savedPos = scanner2.getTokenFullStart();
	    }
	    function shouldRescanGreaterThanToken(node) {
	      switch (node.kind) {
	        case 34 /* GreaterThanEqualsToken */:
	        case 72 /* GreaterThanGreaterThanEqualsToken */:
	        case 73 /* GreaterThanGreaterThanGreaterThanEqualsToken */:
	        case 50 /* GreaterThanGreaterThanGreaterThanToken */:
	        case 49 /* GreaterThanGreaterThanToken */:
	          return true;
	      }
	      return false;
	    }
	    function shouldRescanJsxIdentifier(node) {
	      if (node.parent) {
	        switch (node.parent.kind) {
	          case 291 /* JsxAttribute */:
	          case 286 /* JsxOpeningElement */:
	          case 287 /* JsxClosingElement */:
	          case 285 /* JsxSelfClosingElement */:
	            return isKeyword(node.kind) || node.kind === 80 /* Identifier */;
	        }
	      }
	      return false;
	    }
	    function shouldRescanJsxText(node) {
	      return isJsxText(node) || isJsxElement(node) && (lastTokenInfo == null ? void 0 : lastTokenInfo.token.kind) === 12 /* JsxText */;
	    }
	    function shouldRescanSlashToken(container) {
	      return container.kind === 14 /* RegularExpressionLiteral */;
	    }
	    function shouldRescanTemplateToken(container) {
	      return container.kind === 17 /* TemplateMiddle */ || container.kind === 18 /* TemplateTail */;
	    }
	    function shouldRescanJsxAttributeValue(node) {
	      return node.parent && isJsxAttribute(node.parent) && node.parent.initializer === node;
	    }
	    function startsWithSlashToken(t) {
	      return t === 44 /* SlashToken */ || t === 69 /* SlashEqualsToken */;
	    }
	    function readTokenInfo(n) {
	      Debug.assert(isOnToken());
	      const expectedScanAction = shouldRescanGreaterThanToken(n) ? 1 /* RescanGreaterThanToken */ : shouldRescanSlashToken(n) ? 2 /* RescanSlashToken */ : shouldRescanTemplateToken(n) ? 3 /* RescanTemplateToken */ : shouldRescanJsxIdentifier(n) ? 4 /* RescanJsxIdentifier */ : shouldRescanJsxText(n) ? 5 /* RescanJsxText */ : shouldRescanJsxAttributeValue(n) ? 6 /* RescanJsxAttributeValue */ : 0 /* Scan */;
	      if (lastTokenInfo && expectedScanAction === lastScanAction) {
	        return fixTokenKind(lastTokenInfo, n);
	      }
	      if (scanner2.getTokenFullStart() !== savedPos) {
	        Debug.assert(lastTokenInfo !== void 0);
	        scanner2.resetTokenState(savedPos);
	        scanner2.scan();
	      }
	      let currentToken = getNextToken(n, expectedScanAction);
	      const token = createTextRangeWithKind(
	        scanner2.getTokenFullStart(),
	        scanner2.getTokenEnd(),
	        currentToken
	      );
	      if (trailingTrivia) {
	        trailingTrivia = void 0;
	      }
	      while (scanner2.getTokenFullStart() < endPos) {
	        currentToken = scanner2.scan();
	        if (!isTrivia(currentToken)) {
	          break;
	        }
	        const trivia = createTextRangeWithKind(
	          scanner2.getTokenFullStart(),
	          scanner2.getTokenEnd(),
	          currentToken
	        );
	        if (!trailingTrivia) {
	          trailingTrivia = [];
	        }
	        trailingTrivia.push(trivia);
	        if (currentToken === 4 /* NewLineTrivia */) {
	          scanner2.scan();
	          break;
	        }
	      }
	      lastTokenInfo = { leadingTrivia, trailingTrivia, token };
	      return fixTokenKind(lastTokenInfo, n);
	    }
	    function getNextToken(n, expectedScanAction) {
	      const token = scanner2.getToken();
	      lastScanAction = 0 /* Scan */;
	      switch (expectedScanAction) {
	        case 1 /* RescanGreaterThanToken */:
	          if (token === 32 /* GreaterThanToken */) {
	            lastScanAction = 1 /* RescanGreaterThanToken */;
	            const newToken = scanner2.reScanGreaterToken();
	            Debug.assert(n.kind === newToken);
	            return newToken;
	          }
	          break;
	        case 2 /* RescanSlashToken */:
	          if (startsWithSlashToken(token)) {
	            lastScanAction = 2 /* RescanSlashToken */;
	            const newToken = scanner2.reScanSlashToken();
	            Debug.assert(n.kind === newToken);
	            return newToken;
	          }
	          break;
	        case 3 /* RescanTemplateToken */:
	          if (token === 20 /* CloseBraceToken */) {
	            lastScanAction = 3 /* RescanTemplateToken */;
	            return scanner2.reScanTemplateToken(
	              /*isTaggedTemplate*/
	              false
	            );
	          }
	          break;
	        case 4 /* RescanJsxIdentifier */:
	          lastScanAction = 4 /* RescanJsxIdentifier */;
	          return scanner2.scanJsxIdentifier();
	        case 5 /* RescanJsxText */:
	          lastScanAction = 5 /* RescanJsxText */;
	          return scanner2.reScanJsxToken(
	            /*allowMultilineJsxText*/
	            false
	          );
	        case 6 /* RescanJsxAttributeValue */:
	          lastScanAction = 6 /* RescanJsxAttributeValue */;
	          return scanner2.reScanJsxAttributeValue();
	        case 0 /* Scan */:
	          break;
	        default:
	          Debug.assertNever(expectedScanAction);
	      }
	      return token;
	    }
	    function readEOFTokenRange() {
	      Debug.assert(isOnEOF());
	      return createTextRangeWithKind(scanner2.getTokenFullStart(), scanner2.getTokenEnd(), 1 /* EndOfFileToken */);
	    }
	    function isOnToken() {
	      const current = lastTokenInfo ? lastTokenInfo.token.kind : scanner2.getToken();
	      return current !== 1 /* EndOfFileToken */ && !isTrivia(current);
	    }
	    function isOnEOF() {
	      const current = lastTokenInfo ? lastTokenInfo.token.kind : scanner2.getToken();
	      return current === 1 /* EndOfFileToken */;
	    }
	    function fixTokenKind(tokenInfo, container) {
	      if (isToken(container) && tokenInfo.token.kind !== container.kind) {
	        tokenInfo.token.kind = container.kind;
	      }
	      return tokenInfo;
	    }
	    function skipToEndOf(node) {
	      scanner2.resetTokenState(node.end);
	      savedPos = scanner2.getTokenFullStart();
	      lastScanAction = void 0;
	      lastTokenInfo = void 0;
	      wasNewLine = false;
	      leadingTrivia = void 0;
	      trailingTrivia = void 0;
	    }
	    function skipToStartOf(node) {
	      scanner2.resetTokenState(node.pos);
	      savedPos = scanner2.getTokenFullStart();
	      lastScanAction = void 0;
	      lastTokenInfo = void 0;
	      wasNewLine = false;
	      leadingTrivia = void 0;
	      trailingTrivia = void 0;
	    }
	  }
	  var standardScanner, jsxScanner;
	  var init_formattingScanner = __esm({
	    "src/services/formatting/formattingScanner.ts"() {
	      init_ts4();
	      init_ts_formatting();
	      standardScanner = createScanner(
	        99 /* Latest */,
	        /*skipTrivia*/
	        false,
	        0 /* Standard */
	      );
	      jsxScanner = createScanner(
	        99 /* Latest */,
	        /*skipTrivia*/
	        false,
	        1 /* JSX */
	      );
	    }
	  });

	  // src/services/formatting/rule.ts
	  var anyContext, RuleAction, RuleFlags;
	  var init_rule = __esm({
	    "src/services/formatting/rule.ts"() {
	      init_ts4();
	      anyContext = emptyArray;
	      RuleAction = /* @__PURE__ */ ((RuleAction2) => {
	        RuleAction2[RuleAction2["None"] = 0] = "None";
	        RuleAction2[RuleAction2["StopProcessingSpaceActions"] = 1] = "StopProcessingSpaceActions";
	        RuleAction2[RuleAction2["StopProcessingTokenActions"] = 2] = "StopProcessingTokenActions";
	        RuleAction2[RuleAction2["InsertSpace"] = 4] = "InsertSpace";
	        RuleAction2[RuleAction2["InsertNewLine"] = 8] = "InsertNewLine";
	        RuleAction2[RuleAction2["DeleteSpace"] = 16] = "DeleteSpace";
	        RuleAction2[RuleAction2["DeleteToken"] = 32] = "DeleteToken";
	        RuleAction2[RuleAction2["InsertTrailingSemicolon"] = 64] = "InsertTrailingSemicolon";
	        RuleAction2[RuleAction2["StopAction"] = 3] = "StopAction";
	        RuleAction2[RuleAction2["ModifySpaceAction"] = 28] = "ModifySpaceAction";
	        RuleAction2[RuleAction2["ModifyTokenAction"] = 96] = "ModifyTokenAction";
	        return RuleAction2;
	      })(RuleAction || {});
	      RuleFlags = /* @__PURE__ */ ((RuleFlags2) => {
	        RuleFlags2[RuleFlags2["None"] = 0] = "None";
	        RuleFlags2[RuleFlags2["CanDeleteNewLines"] = 1] = "CanDeleteNewLines";
	        return RuleFlags2;
	      })(RuleFlags || {});
	    }
	  });

	  // src/services/formatting/rules.ts
	  function getAllRules() {
	    const allTokens = [];
	    for (let token = 0 /* FirstToken */; token <= 165 /* LastToken */; token++) {
	      if (token !== 1 /* EndOfFileToken */) {
	        allTokens.push(token);
	      }
	    }
	    function anyTokenExcept(...tokens) {
	      return { tokens: allTokens.filter((t) => !tokens.some((t2) => t2 === t)), isSpecific: false };
	    }
	    const anyToken = { tokens: allTokens, isSpecific: false };
	    const anyTokenIncludingMultilineComments = tokenRangeFrom([...allTokens, 3 /* MultiLineCommentTrivia */]);
	    const anyTokenIncludingEOF = tokenRangeFrom([...allTokens, 1 /* EndOfFileToken */]);
	    const keywords = tokenRangeFromRange(83 /* FirstKeyword */, 165 /* LastKeyword */);
	    const binaryOperators = tokenRangeFromRange(30 /* FirstBinaryOperator */, 79 /* LastBinaryOperator */);
	    const binaryKeywordOperators = [
	      103 /* InKeyword */,
	      104 /* InstanceOfKeyword */,
	      165 /* OfKeyword */,
	      130 /* AsKeyword */,
	      142 /* IsKeyword */,
	      152 /* SatisfiesKeyword */
	    ];
	    const unaryPrefixOperators = [46 /* PlusPlusToken */, 47 /* MinusMinusToken */, 55 /* TildeToken */, 54 /* ExclamationToken */];
	    const unaryPrefixExpressions = [
	      9 /* NumericLiteral */,
	      10 /* BigIntLiteral */,
	      80 /* Identifier */,
	      21 /* OpenParenToken */,
	      23 /* OpenBracketToken */,
	      19 /* OpenBraceToken */,
	      110 /* ThisKeyword */,
	      105 /* NewKeyword */
	    ];
	    const unaryPreincrementExpressions = [80 /* Identifier */, 21 /* OpenParenToken */, 110 /* ThisKeyword */, 105 /* NewKeyword */];
	    const unaryPostincrementExpressions = [80 /* Identifier */, 22 /* CloseParenToken */, 24 /* CloseBracketToken */, 105 /* NewKeyword */];
	    const unaryPredecrementExpressions = [80 /* Identifier */, 21 /* OpenParenToken */, 110 /* ThisKeyword */, 105 /* NewKeyword */];
	    const unaryPostdecrementExpressions = [80 /* Identifier */, 22 /* CloseParenToken */, 24 /* CloseBracketToken */, 105 /* NewKeyword */];
	    const comments = [2 /* SingleLineCommentTrivia */, 3 /* MultiLineCommentTrivia */];
	    const typeNames = [80 /* Identifier */, ...typeKeywords];
	    const functionOpenBraceLeftTokenRange = anyTokenIncludingMultilineComments;
	    const typeScriptOpenBraceLeftTokenRange = tokenRangeFrom([80 /* Identifier */, 32 /* GreaterThanToken */, 3 /* MultiLineCommentTrivia */, 86 /* ClassKeyword */, 95 /* ExportKeyword */, 102 /* ImportKeyword */]);
	    const controlOpenBraceLeftTokenRange = tokenRangeFrom([22 /* CloseParenToken */, 3 /* MultiLineCommentTrivia */, 92 /* DoKeyword */, 113 /* TryKeyword */, 98 /* FinallyKeyword */, 93 /* ElseKeyword */, 85 /* CatchKeyword */]);
	    const highPriorityCommonRules = [
	      // Leave comments alone
	      rule("IgnoreBeforeComment", anyToken, comments, anyContext, 1 /* StopProcessingSpaceActions */),
	      rule("IgnoreAfterLineComment", 2 /* SingleLineCommentTrivia */, anyToken, anyContext, 1 /* StopProcessingSpaceActions */),
	      rule("NotSpaceBeforeColon", anyToken, 59 /* ColonToken */, [isNonJsxSameLineTokenContext, isNotBinaryOpContext, isNotTypeAnnotationContext], 16 /* DeleteSpace */),
	      rule("SpaceAfterColon", 59 /* ColonToken */, anyToken, [isNonJsxSameLineTokenContext, isNotBinaryOpContext, isNextTokenParentNotJsxNamespacedName], 4 /* InsertSpace */),
	      rule("NoSpaceBeforeQuestionMark", anyToken, 58 /* QuestionToken */, [isNonJsxSameLineTokenContext, isNotBinaryOpContext, isNotTypeAnnotationContext], 16 /* DeleteSpace */),
	      // insert space after '?' only when it is used in conditional operator
	      rule("SpaceAfterQuestionMarkInConditionalOperator", 58 /* QuestionToken */, anyToken, [isNonJsxSameLineTokenContext, isConditionalOperatorContext], 4 /* InsertSpace */),
	      // in other cases there should be no space between '?' and next token
	      rule("NoSpaceAfterQuestionMark", 58 /* QuestionToken */, anyToken, [isNonJsxSameLineTokenContext, isNonOptionalPropertyContext], 16 /* DeleteSpace */),
	      rule("NoSpaceBeforeDot", anyToken, [25 /* DotToken */, 29 /* QuestionDotToken */], [isNonJsxSameLineTokenContext, isNotPropertyAccessOnIntegerLiteral], 16 /* DeleteSpace */),
	      rule("NoSpaceAfterDot", [25 /* DotToken */, 29 /* QuestionDotToken */], anyToken, [isNonJsxSameLineTokenContext], 16 /* DeleteSpace */),
	      rule("NoSpaceBetweenImportParenInImportType", 102 /* ImportKeyword */, 21 /* OpenParenToken */, [isNonJsxSameLineTokenContext, isImportTypeContext], 16 /* DeleteSpace */),
	      // Special handling of unary operators.
	      // Prefix operators generally shouldn't have a space between
	      // them and their target unary expression.
	      rule("NoSpaceAfterUnaryPrefixOperator", unaryPrefixOperators, unaryPrefixExpressions, [isNonJsxSameLineTokenContext, isNotBinaryOpContext], 16 /* DeleteSpace */),
	      rule("NoSpaceAfterUnaryPreincrementOperator", 46 /* PlusPlusToken */, unaryPreincrementExpressions, [isNonJsxSameLineTokenContext], 16 /* DeleteSpace */),
	      rule("NoSpaceAfterUnaryPredecrementOperator", 47 /* MinusMinusToken */, unaryPredecrementExpressions, [isNonJsxSameLineTokenContext], 16 /* DeleteSpace */),
	      rule("NoSpaceBeforeUnaryPostincrementOperator", unaryPostincrementExpressions, 46 /* PlusPlusToken */, [isNonJsxSameLineTokenContext, isNotStatementConditionContext], 16 /* DeleteSpace */),
	      rule("NoSpaceBeforeUnaryPostdecrementOperator", unaryPostdecrementExpressions, 47 /* MinusMinusToken */, [isNonJsxSameLineTokenContext, isNotStatementConditionContext], 16 /* DeleteSpace */),
	      // More unary operator special-casing.
	      // DevDiv 181814: Be careful when removing leading whitespace
	      // around unary operators.  Examples:
	      //      1 - -2  --X--> 1--2
	      //      a + ++b --X--> a+++b
	      rule("SpaceAfterPostincrementWhenFollowedByAdd", 46 /* PlusPlusToken */, 40 /* PlusToken */, [isNonJsxSameLineTokenContext, isBinaryOpContext], 4 /* InsertSpace */),
	      rule("SpaceAfterAddWhenFollowedByUnaryPlus", 40 /* PlusToken */, 40 /* PlusToken */, [isNonJsxSameLineTokenContext, isBinaryOpContext], 4 /* InsertSpace */),
	      rule("SpaceAfterAddWhenFollowedByPreincrement", 40 /* PlusToken */, 46 /* PlusPlusToken */, [isNonJsxSameLineTokenContext, isBinaryOpContext], 4 /* InsertSpace */),
	      rule("SpaceAfterPostdecrementWhenFollowedBySubtract", 47 /* MinusMinusToken */, 41 /* MinusToken */, [isNonJsxSameLineTokenContext, isBinaryOpContext], 4 /* InsertSpace */),
	      rule("SpaceAfterSubtractWhenFollowedByUnaryMinus", 41 /* MinusToken */, 41 /* MinusToken */, [isNonJsxSameLineTokenContext, isBinaryOpContext], 4 /* InsertSpace */),
	      rule("SpaceAfterSubtractWhenFollowedByPredecrement", 41 /* MinusToken */, 47 /* MinusMinusToken */, [isNonJsxSameLineTokenContext, isBinaryOpContext], 4 /* InsertSpace */),
	      rule("NoSpaceAfterCloseBrace", 20 /* CloseBraceToken */, [28 /* CommaToken */, 27 /* SemicolonToken */], [isNonJsxSameLineTokenContext], 16 /* DeleteSpace */),
	      // For functions and control block place } on a new line [multi-line rule]
	      rule("NewLineBeforeCloseBraceInBlockContext", anyTokenIncludingMultilineComments, 20 /* CloseBraceToken */, [isMultilineBlockContext], 8 /* InsertNewLine */),
	      // Space/new line after }.
	      rule("SpaceAfterCloseBrace", 20 /* CloseBraceToken */, anyTokenExcept(22 /* CloseParenToken */), [isNonJsxSameLineTokenContext, isAfterCodeBlockContext], 4 /* InsertSpace */),
	      // Special case for (}, else) and (}, while) since else & while tokens are not part of the tree which makes SpaceAfterCloseBrace rule not applied
	      // Also should not apply to })
	      rule("SpaceBetweenCloseBraceAndElse", 20 /* CloseBraceToken */, 93 /* ElseKeyword */, [isNonJsxSameLineTokenContext], 4 /* InsertSpace */),
	      rule("SpaceBetweenCloseBraceAndWhile", 20 /* CloseBraceToken */, 117 /* WhileKeyword */, [isNonJsxSameLineTokenContext], 4 /* InsertSpace */),
	      rule("NoSpaceBetweenEmptyBraceBrackets", 19 /* OpenBraceToken */, 20 /* CloseBraceToken */, [isNonJsxSameLineTokenContext, isObjectContext], 16 /* DeleteSpace */),
	      // Add a space after control dec context if the next character is an open bracket ex: 'if (false)[a, b] = [1, 2];' -> 'if (false) [a, b] = [1, 2];'
	      rule("SpaceAfterConditionalClosingParen", 22 /* CloseParenToken */, 23 /* OpenBracketToken */, [isControlDeclContext], 4 /* InsertSpace */),
	      rule("NoSpaceBetweenFunctionKeywordAndStar", 100 /* FunctionKeyword */, 42 /* AsteriskToken */, [isFunctionDeclarationOrFunctionExpressionContext], 16 /* DeleteSpace */),
	      rule("SpaceAfterStarInGeneratorDeclaration", 42 /* AsteriskToken */, 80 /* Identifier */, [isFunctionDeclarationOrFunctionExpressionContext], 4 /* InsertSpace */),
	      rule("SpaceAfterFunctionInFuncDecl", 100 /* FunctionKeyword */, anyToken, [isFunctionDeclContext], 4 /* InsertSpace */),
	      // Insert new line after { and before } in multi-line contexts.
	      rule("NewLineAfterOpenBraceInBlockContext", 19 /* OpenBraceToken */, anyToken, [isMultilineBlockContext], 8 /* InsertNewLine */),
	      // For get/set members, we check for (identifier,identifier) since get/set don't have tokens and they are represented as just an identifier token.
	      // Though, we do extra check on the context to make sure we are dealing with get/set node. Example:
	      //      get x() {}
	      //      set x(val) {}
	      rule("SpaceAfterGetSetInMember", [139 /* GetKeyword */, 153 /* SetKeyword */], 80 /* Identifier */, [isFunctionDeclContext], 4 /* InsertSpace */),
	      rule("NoSpaceBetweenYieldKeywordAndStar", 127 /* YieldKeyword */, 42 /* AsteriskToken */, [isNonJsxSameLineTokenContext, isYieldOrYieldStarWithOperand], 16 /* DeleteSpace */),
	      rule("SpaceBetweenYieldOrYieldStarAndOperand", [127 /* YieldKeyword */, 42 /* AsteriskToken */], anyToken, [isNonJsxSameLineTokenContext, isYieldOrYieldStarWithOperand], 4 /* InsertSpace */),
	      rule("NoSpaceBetweenReturnAndSemicolon", 107 /* ReturnKeyword */, 27 /* SemicolonToken */, [isNonJsxSameLineTokenContext], 16 /* DeleteSpace */),
	      rule("SpaceAfterCertainKeywords", [115 /* VarKeyword */, 111 /* ThrowKeyword */, 105 /* NewKeyword */, 91 /* DeleteKeyword */, 107 /* ReturnKeyword */, 114 /* TypeOfKeyword */, 135 /* AwaitKeyword */], anyToken, [isNonJsxSameLineTokenContext], 4 /* InsertSpace */),
	      rule("SpaceAfterLetConstInVariableDeclaration", [121 /* LetKeyword */, 87 /* ConstKeyword */], anyToken, [isNonJsxSameLineTokenContext, isStartOfVariableDeclarationList], 4 /* InsertSpace */),
	      rule("NoSpaceBeforeOpenParenInFuncCall", anyToken, 21 /* OpenParenToken */, [isNonJsxSameLineTokenContext, isFunctionCallOrNewContext, isPreviousTokenNotComma], 16 /* DeleteSpace */),
	      // Special case for binary operators (that are keywords). For these we have to add a space and shouldn't follow any user options.
	      rule("SpaceBeforeBinaryKeywordOperator", anyToken, binaryKeywordOperators, [isNonJsxSameLineTokenContext, isBinaryOpContext], 4 /* InsertSpace */),
	      rule("SpaceAfterBinaryKeywordOperator", binaryKeywordOperators, anyToken, [isNonJsxSameLineTokenContext, isBinaryOpContext], 4 /* InsertSpace */),
	      rule("SpaceAfterVoidOperator", 116 /* VoidKeyword */, anyToken, [isNonJsxSameLineTokenContext, isVoidOpContext], 4 /* InsertSpace */),
	      // Async-await
	      rule("SpaceBetweenAsyncAndOpenParen", 134 /* AsyncKeyword */, 21 /* OpenParenToken */, [isArrowFunctionContext, isNonJsxSameLineTokenContext], 4 /* InsertSpace */),
	      rule("SpaceBetweenAsyncAndFunctionKeyword", 134 /* AsyncKeyword */, [100 /* FunctionKeyword */, 80 /* Identifier */], [isNonJsxSameLineTokenContext], 4 /* InsertSpace */),
	      // Template string
	      rule("NoSpaceBetweenTagAndTemplateString", [80 /* Identifier */, 22 /* CloseParenToken */], [15 /* NoSubstitutionTemplateLiteral */, 16 /* TemplateHead */], [isNonJsxSameLineTokenContext], 16 /* DeleteSpace */),
	      // JSX opening elements
	      rule("SpaceBeforeJsxAttribute", anyToken, 80 /* Identifier */, [isNextTokenParentJsxAttribute, isNonJsxSameLineTokenContext], 4 /* InsertSpace */),
	      rule("SpaceBeforeSlashInJsxOpeningElement", anyToken, 44 /* SlashToken */, [isJsxSelfClosingElementContext, isNonJsxSameLineTokenContext], 4 /* InsertSpace */),
	      rule("NoSpaceBeforeGreaterThanTokenInJsxOpeningElement", 44 /* SlashToken */, 32 /* GreaterThanToken */, [isJsxSelfClosingElementContext, isNonJsxSameLineTokenContext], 16 /* DeleteSpace */),
	      rule("NoSpaceBeforeEqualInJsxAttribute", anyToken, 64 /* EqualsToken */, [isJsxAttributeContext, isNonJsxSameLineTokenContext], 16 /* DeleteSpace */),
	      rule("NoSpaceAfterEqualInJsxAttribute", 64 /* EqualsToken */, anyToken, [isJsxAttributeContext, isNonJsxSameLineTokenContext], 16 /* DeleteSpace */),
	      rule("NoSpaceBeforeJsxNamespaceColon", 80 /* Identifier */, 59 /* ColonToken */, [isNextTokenParentJsxNamespacedName], 16 /* DeleteSpace */),
	      rule("NoSpaceAfterJsxNamespaceColon", 59 /* ColonToken */, 80 /* Identifier */, [isNextTokenParentJsxNamespacedName], 16 /* DeleteSpace */),
	      // TypeScript-specific rules
	      // Use of module as a function call. e.g.: import m2 = module("m2");
	      rule("NoSpaceAfterModuleImport", [144 /* ModuleKeyword */, 149 /* RequireKeyword */], 21 /* OpenParenToken */, [isNonJsxSameLineTokenContext], 16 /* DeleteSpace */),
	      // Add a space around certain TypeScript keywords
	      rule(
	        "SpaceAfterCertainTypeScriptKeywords",
	        [
	          128 /* AbstractKeyword */,
	          129 /* AccessorKeyword */,
	          86 /* ClassKeyword */,
	          138 /* DeclareKeyword */,
	          90 /* DefaultKeyword */,
	          94 /* EnumKeyword */,
	          95 /* ExportKeyword */,
	          96 /* ExtendsKeyword */,
	          139 /* GetKeyword */,
	          119 /* ImplementsKeyword */,
	          102 /* ImportKeyword */,
	          120 /* InterfaceKeyword */,
	          144 /* ModuleKeyword */,
	          145 /* NamespaceKeyword */,
	          123 /* PrivateKeyword */,
	          125 /* PublicKeyword */,
	          124 /* ProtectedKeyword */,
	          148 /* ReadonlyKeyword */,
	          153 /* SetKeyword */,
	          126 /* StaticKeyword */,
	          156 /* TypeKeyword */,
	          161 /* FromKeyword */,
	          143 /* KeyOfKeyword */,
	          140 /* InferKeyword */
	        ],
	        anyToken,
	        [isNonJsxSameLineTokenContext],
	        4 /* InsertSpace */
	      ),
	      rule(
	        "SpaceBeforeCertainTypeScriptKeywords",
	        anyToken,
	        [96 /* ExtendsKeyword */, 119 /* ImplementsKeyword */, 161 /* FromKeyword */],
	        [isNonJsxSameLineTokenContext],
	        4 /* InsertSpace */
	      ),
	      // Treat string literals in module names as identifiers, and add a space between the literal and the opening Brace braces, e.g.: module "m2" {
	      rule("SpaceAfterModuleName", 11 /* StringLiteral */, 19 /* OpenBraceToken */, [isModuleDeclContext], 4 /* InsertSpace */),
	      // Lambda expressions
	      rule("SpaceBeforeArrow", anyToken, 39 /* EqualsGreaterThanToken */, [isNonJsxSameLineTokenContext], 4 /* InsertSpace */),
	      rule("SpaceAfterArrow", 39 /* EqualsGreaterThanToken */, anyToken, [isNonJsxSameLineTokenContext], 4 /* InsertSpace */),
	      // Optional parameters and let args
	      rule("NoSpaceAfterEllipsis", 26 /* DotDotDotToken */, 80 /* Identifier */, [isNonJsxSameLineTokenContext], 16 /* DeleteSpace */),
	      rule("NoSpaceAfterOptionalParameters", 58 /* QuestionToken */, [22 /* CloseParenToken */, 28 /* CommaToken */], [isNonJsxSameLineTokenContext, isNotBinaryOpContext], 16 /* DeleteSpace */),
	      // Remove spaces in empty interface literals. e.g.: x: {}
	      rule("NoSpaceBetweenEmptyInterfaceBraceBrackets", 19 /* OpenBraceToken */, 20 /* CloseBraceToken */, [isNonJsxSameLineTokenContext, isObjectTypeContext], 16 /* DeleteSpace */),
	      // generics and type assertions
	      rule("NoSpaceBeforeOpenAngularBracket", typeNames, 30 /* LessThanToken */, [isNonJsxSameLineTokenContext, isTypeArgumentOrParameterOrAssertionContext], 16 /* DeleteSpace */),
	      rule("NoSpaceBetweenCloseParenAndAngularBracket", 22 /* CloseParenToken */, 30 /* LessThanToken */, [isNonJsxSameLineTokenContext, isTypeArgumentOrParameterOrAssertionContext], 16 /* DeleteSpace */),
	      rule("NoSpaceAfterOpenAngularBracket", 30 /* LessThanToken */, anyToken, [isNonJsxSameLineTokenContext, isTypeArgumentOrParameterOrAssertionContext], 16 /* DeleteSpace */),
	      rule("NoSpaceBeforeCloseAngularBracket", anyToken, 32 /* GreaterThanToken */, [isNonJsxSameLineTokenContext, isTypeArgumentOrParameterOrAssertionContext], 16 /* DeleteSpace */),
	      rule("NoSpaceAfterCloseAngularBracket", 32 /* GreaterThanToken */, [21 /* OpenParenToken */, 23 /* OpenBracketToken */, 32 /* GreaterThanToken */, 28 /* CommaToken */], [
	        isNonJsxSameLineTokenContext,
	        isTypeArgumentOrParameterOrAssertionContext,
	        isNotFunctionDeclContext,
	        /*To prevent an interference with the SpaceBeforeOpenParenInFuncDecl rule*/
	        isNonTypeAssertionContext
	      ], 16 /* DeleteSpace */),
	      // decorators
	      rule("SpaceBeforeAt", [22 /* CloseParenToken */, 80 /* Identifier */], 60 /* AtToken */, [isNonJsxSameLineTokenContext], 4 /* InsertSpace */),
	      rule("NoSpaceAfterAt", 60 /* AtToken */, anyToken, [isNonJsxSameLineTokenContext], 16 /* DeleteSpace */),
	      // Insert space after @ in decorator
	      rule(
	        "SpaceAfterDecorator",
	        anyToken,
	        [
	          128 /* AbstractKeyword */,
	          80 /* Identifier */,
	          95 /* ExportKeyword */,
	          90 /* DefaultKeyword */,
	          86 /* ClassKeyword */,
	          126 /* StaticKeyword */,
	          125 /* PublicKeyword */,
	          123 /* PrivateKeyword */,
	          124 /* ProtectedKeyword */,
	          139 /* GetKeyword */,
	          153 /* SetKeyword */,
	          23 /* OpenBracketToken */,
	          42 /* AsteriskToken */
	        ],
	        [isEndOfDecoratorContextOnSameLine],
	        4 /* InsertSpace */
	      ),
	      rule("NoSpaceBeforeNonNullAssertionOperator", anyToken, 54 /* ExclamationToken */, [isNonJsxSameLineTokenContext, isNonNullAssertionContext], 16 /* DeleteSpace */),
	      rule("NoSpaceAfterNewKeywordOnConstructorSignature", 105 /* NewKeyword */, 21 /* OpenParenToken */, [isNonJsxSameLineTokenContext, isConstructorSignatureContext], 16 /* DeleteSpace */),
	      rule("SpaceLessThanAndNonJSXTypeAnnotation", 30 /* LessThanToken */, 30 /* LessThanToken */, [isNonJsxSameLineTokenContext], 4 /* InsertSpace */)
	    ];
	    const userConfigurableRules = [
	      // Treat constructor as an identifier in a function declaration, and remove spaces between constructor and following left parentheses
	      rule("SpaceAfterConstructor", 137 /* ConstructorKeyword */, 21 /* OpenParenToken */, [isOptionEnabled("insertSpaceAfterConstructor"), isNonJsxSameLineTokenContext], 4 /* InsertSpace */),
	      rule("NoSpaceAfterConstructor", 137 /* ConstructorKeyword */, 21 /* OpenParenToken */, [isOptionDisabledOrUndefined("insertSpaceAfterConstructor"), isNonJsxSameLineTokenContext], 16 /* DeleteSpace */),
	      rule("SpaceAfterComma", 28 /* CommaToken */, anyToken, [isOptionEnabled("insertSpaceAfterCommaDelimiter"), isNonJsxSameLineTokenContext, isNonJsxElementOrFragmentContext, isNextTokenNotCloseBracket, isNextTokenNotCloseParen], 4 /* InsertSpace */),
	      rule("NoSpaceAfterComma", 28 /* CommaToken */, anyToken, [isOptionDisabledOrUndefined("insertSpaceAfterCommaDelimiter"), isNonJsxSameLineTokenContext, isNonJsxElementOrFragmentContext], 16 /* DeleteSpace */),
	      // Insert space after function keyword for anonymous functions
	      rule("SpaceAfterAnonymousFunctionKeyword", [100 /* FunctionKeyword */, 42 /* AsteriskToken */], 21 /* OpenParenToken */, [isOptionEnabled("insertSpaceAfterFunctionKeywordForAnonymousFunctions"), isFunctionDeclContext], 4 /* InsertSpace */),
	      rule("NoSpaceAfterAnonymousFunctionKeyword", [100 /* FunctionKeyword */, 42 /* AsteriskToken */], 21 /* OpenParenToken */, [isOptionDisabledOrUndefined("insertSpaceAfterFunctionKeywordForAnonymousFunctions"), isFunctionDeclContext], 16 /* DeleteSpace */),
	      // Insert space after keywords in control flow statements
	      rule("SpaceAfterKeywordInControl", keywords, 21 /* OpenParenToken */, [isOptionEnabled("insertSpaceAfterKeywordsInControlFlowStatements"), isControlDeclContext], 4 /* InsertSpace */),
	      rule("NoSpaceAfterKeywordInControl", keywords, 21 /* OpenParenToken */, [isOptionDisabledOrUndefined("insertSpaceAfterKeywordsInControlFlowStatements"), isControlDeclContext], 16 /* DeleteSpace */),
	      // Insert space after opening and before closing nonempty parenthesis
	      rule("SpaceAfterOpenParen", 21 /* OpenParenToken */, anyToken, [isOptionEnabled("insertSpaceAfterOpeningAndBeforeClosingNonemptyParenthesis"), isNonJsxSameLineTokenContext], 4 /* InsertSpace */),
	      rule("SpaceBeforeCloseParen", anyToken, 22 /* CloseParenToken */, [isOptionEnabled("insertSpaceAfterOpeningAndBeforeClosingNonemptyParenthesis"), isNonJsxSameLineTokenContext], 4 /* InsertSpace */),
	      rule("SpaceBetweenOpenParens", 21 /* OpenParenToken */, 21 /* OpenParenToken */, [isOptionEnabled("insertSpaceAfterOpeningAndBeforeClosingNonemptyParenthesis"), isNonJsxSameLineTokenContext], 4 /* InsertSpace */),
	      rule("NoSpaceBetweenParens", 21 /* OpenParenToken */, 22 /* CloseParenToken */, [isNonJsxSameLineTokenContext], 16 /* DeleteSpace */),
	      rule("NoSpaceAfterOpenParen", 21 /* OpenParenToken */, anyToken, [isOptionDisabledOrUndefined("insertSpaceAfterOpeningAndBeforeClosingNonemptyParenthesis"), isNonJsxSameLineTokenContext], 16 /* DeleteSpace */),
	      rule("NoSpaceBeforeCloseParen", anyToken, 22 /* CloseParenToken */, [isOptionDisabledOrUndefined("insertSpaceAfterOpeningAndBeforeClosingNonemptyParenthesis"), isNonJsxSameLineTokenContext], 16 /* DeleteSpace */),
	      // Insert space after opening and before closing nonempty brackets
	      rule("SpaceAfterOpenBracket", 23 /* OpenBracketToken */, anyToken, [isOptionEnabled("insertSpaceAfterOpeningAndBeforeClosingNonemptyBrackets"), isNonJsxSameLineTokenContext], 4 /* InsertSpace */),
	      rule("SpaceBeforeCloseBracket", anyToken, 24 /* CloseBracketToken */, [isOptionEnabled("insertSpaceAfterOpeningAndBeforeClosingNonemptyBrackets"), isNonJsxSameLineTokenContext], 4 /* InsertSpace */),
	      rule("NoSpaceBetweenBrackets", 23 /* OpenBracketToken */, 24 /* CloseBracketToken */, [isNonJsxSameLineTokenContext], 16 /* DeleteSpace */),
	      rule("NoSpaceAfterOpenBracket", 23 /* OpenBracketToken */, anyToken, [isOptionDisabledOrUndefined("insertSpaceAfterOpeningAndBeforeClosingNonemptyBrackets"), isNonJsxSameLineTokenContext], 16 /* DeleteSpace */),
	      rule("NoSpaceBeforeCloseBracket", anyToken, 24 /* CloseBracketToken */, [isOptionDisabledOrUndefined("insertSpaceAfterOpeningAndBeforeClosingNonemptyBrackets"), isNonJsxSameLineTokenContext], 16 /* DeleteSpace */),
	      // Insert a space after { and before } in single-line contexts, but remove space from empty object literals {}.
	      rule("SpaceAfterOpenBrace", 19 /* OpenBraceToken */, anyToken, [isOptionEnabledOrUndefined("insertSpaceAfterOpeningAndBeforeClosingNonemptyBraces"), isBraceWrappedContext], 4 /* InsertSpace */),
	      rule("SpaceBeforeCloseBrace", anyToken, 20 /* CloseBraceToken */, [isOptionEnabledOrUndefined("insertSpaceAfterOpeningAndBeforeClosingNonemptyBraces"), isBraceWrappedContext], 4 /* InsertSpace */),
	      rule("NoSpaceBetweenEmptyBraceBrackets", 19 /* OpenBraceToken */, 20 /* CloseBraceToken */, [isNonJsxSameLineTokenContext, isObjectContext], 16 /* DeleteSpace */),
	      rule("NoSpaceAfterOpenBrace", 19 /* OpenBraceToken */, anyToken, [isOptionDisabled("insertSpaceAfterOpeningAndBeforeClosingNonemptyBraces"), isNonJsxSameLineTokenContext], 16 /* DeleteSpace */),
	      rule("NoSpaceBeforeCloseBrace", anyToken, 20 /* CloseBraceToken */, [isOptionDisabled("insertSpaceAfterOpeningAndBeforeClosingNonemptyBraces"), isNonJsxSameLineTokenContext], 16 /* DeleteSpace */),
	      // Insert a space after opening and before closing empty brace brackets
	      rule("SpaceBetweenEmptyBraceBrackets", 19 /* OpenBraceToken */, 20 /* CloseBraceToken */, [isOptionEnabled("insertSpaceAfterOpeningAndBeforeClosingEmptyBraces")], 4 /* InsertSpace */),
	      rule("NoSpaceBetweenEmptyBraceBrackets", 19 /* OpenBraceToken */, 20 /* CloseBraceToken */, [isOptionDisabled("insertSpaceAfterOpeningAndBeforeClosingEmptyBraces"), isNonJsxSameLineTokenContext], 16 /* DeleteSpace */),
	      // Insert space after opening and before closing template string braces
	      rule("SpaceAfterTemplateHeadAndMiddle", [16 /* TemplateHead */, 17 /* TemplateMiddle */], anyToken, [isOptionEnabled("insertSpaceAfterOpeningAndBeforeClosingTemplateStringBraces"), isNonJsxTextContext], 4 /* InsertSpace */, 1 /* CanDeleteNewLines */),
	      rule("SpaceBeforeTemplateMiddleAndTail", anyToken, [17 /* TemplateMiddle */, 18 /* TemplateTail */], [isOptionEnabled("insertSpaceAfterOpeningAndBeforeClosingTemplateStringBraces"), isNonJsxSameLineTokenContext], 4 /* InsertSpace */),
	      rule("NoSpaceAfterTemplateHeadAndMiddle", [16 /* TemplateHead */, 17 /* TemplateMiddle */], anyToken, [isOptionDisabledOrUndefined("insertSpaceAfterOpeningAndBeforeClosingTemplateStringBraces"), isNonJsxTextContext], 16 /* DeleteSpace */, 1 /* CanDeleteNewLines */),
	      rule("NoSpaceBeforeTemplateMiddleAndTail", anyToken, [17 /* TemplateMiddle */, 18 /* TemplateTail */], [isOptionDisabledOrUndefined("insertSpaceAfterOpeningAndBeforeClosingTemplateStringBraces"), isNonJsxSameLineTokenContext], 16 /* DeleteSpace */),
	      // No space after { and before } in JSX expression
	      rule("SpaceAfterOpenBraceInJsxExpression", 19 /* OpenBraceToken */, anyToken, [isOptionEnabled("insertSpaceAfterOpeningAndBeforeClosingJsxExpressionBraces"), isNonJsxSameLineTokenContext, isJsxExpressionContext], 4 /* InsertSpace */),
	      rule("SpaceBeforeCloseBraceInJsxExpression", anyToken, 20 /* CloseBraceToken */, [isOptionEnabled("insertSpaceAfterOpeningAndBeforeClosingJsxExpressionBraces"), isNonJsxSameLineTokenContext, isJsxExpressionContext], 4 /* InsertSpace */),
	      rule("NoSpaceAfterOpenBraceInJsxExpression", 19 /* OpenBraceToken */, anyToken, [isOptionDisabledOrUndefined("insertSpaceAfterOpeningAndBeforeClosingJsxExpressionBraces"), isNonJsxSameLineTokenContext, isJsxExpressionContext], 16 /* DeleteSpace */),
	      rule("NoSpaceBeforeCloseBraceInJsxExpression", anyToken, 20 /* CloseBraceToken */, [isOptionDisabledOrUndefined("insertSpaceAfterOpeningAndBeforeClosingJsxExpressionBraces"), isNonJsxSameLineTokenContext, isJsxExpressionContext], 16 /* DeleteSpace */),
	      // Insert space after semicolon in for statement
	      rule("SpaceAfterSemicolonInFor", 27 /* SemicolonToken */, anyToken, [isOptionEnabled("insertSpaceAfterSemicolonInForStatements"), isNonJsxSameLineTokenContext, isForContext], 4 /* InsertSpace */),
	      rule("NoSpaceAfterSemicolonInFor", 27 /* SemicolonToken */, anyToken, [isOptionDisabledOrUndefined("insertSpaceAfterSemicolonInForStatements"), isNonJsxSameLineTokenContext, isForContext], 16 /* DeleteSpace */),
	      // Insert space before and after binary operators
	      rule("SpaceBeforeBinaryOperator", anyToken, binaryOperators, [isOptionEnabled("insertSpaceBeforeAndAfterBinaryOperators"), isNonJsxSameLineTokenContext, isBinaryOpContext], 4 /* InsertSpace */),
	      rule("SpaceAfterBinaryOperator", binaryOperators, anyToken, [isOptionEnabled("insertSpaceBeforeAndAfterBinaryOperators"), isNonJsxSameLineTokenContext, isBinaryOpContext], 4 /* InsertSpace */),
	      rule("NoSpaceBeforeBinaryOperator", anyToken, binaryOperators, [isOptionDisabledOrUndefined("insertSpaceBeforeAndAfterBinaryOperators"), isNonJsxSameLineTokenContext, isBinaryOpContext], 16 /* DeleteSpace */),
	      rule("NoSpaceAfterBinaryOperator", binaryOperators, anyToken, [isOptionDisabledOrUndefined("insertSpaceBeforeAndAfterBinaryOperators"), isNonJsxSameLineTokenContext, isBinaryOpContext], 16 /* DeleteSpace */),
	      rule("SpaceBeforeOpenParenInFuncDecl", anyToken, 21 /* OpenParenToken */, [isOptionEnabled("insertSpaceBeforeFunctionParenthesis"), isNonJsxSameLineTokenContext, isFunctionDeclContext], 4 /* InsertSpace */),
	      rule("NoSpaceBeforeOpenParenInFuncDecl", anyToken, 21 /* OpenParenToken */, [isOptionDisabledOrUndefined("insertSpaceBeforeFunctionParenthesis"), isNonJsxSameLineTokenContext, isFunctionDeclContext], 16 /* DeleteSpace */),
	      // Open Brace braces after control block
	      rule("NewLineBeforeOpenBraceInControl", controlOpenBraceLeftTokenRange, 19 /* OpenBraceToken */, [isOptionEnabled("placeOpenBraceOnNewLineForControlBlocks"), isControlDeclContext, isBeforeMultilineBlockContext], 8 /* InsertNewLine */, 1 /* CanDeleteNewLines */),
	      // Open Brace braces after function
	      // TypeScript: Function can have return types, which can be made of tons of different token kinds
	      rule("NewLineBeforeOpenBraceInFunction", functionOpenBraceLeftTokenRange, 19 /* OpenBraceToken */, [isOptionEnabled("placeOpenBraceOnNewLineForFunctions"), isFunctionDeclContext, isBeforeMultilineBlockContext], 8 /* InsertNewLine */, 1 /* CanDeleteNewLines */),
	      // Open Brace braces after TypeScript module/class/interface
	      rule("NewLineBeforeOpenBraceInTypeScriptDeclWithBlock", typeScriptOpenBraceLeftTokenRange, 19 /* OpenBraceToken */, [isOptionEnabled("placeOpenBraceOnNewLineForFunctions"), isTypeScriptDeclWithBlockContext, isBeforeMultilineBlockContext], 8 /* InsertNewLine */, 1 /* CanDeleteNewLines */),
	      rule("SpaceAfterTypeAssertion", 32 /* GreaterThanToken */, anyToken, [isOptionEnabled("insertSpaceAfterTypeAssertion"), isNonJsxSameLineTokenContext, isTypeAssertionContext], 4 /* InsertSpace */),
	      rule("NoSpaceAfterTypeAssertion", 32 /* GreaterThanToken */, anyToken, [isOptionDisabledOrUndefined("insertSpaceAfterTypeAssertion"), isNonJsxSameLineTokenContext, isTypeAssertionContext], 16 /* DeleteSpace */),
	      rule("SpaceBeforeTypeAnnotation", anyToken, [58 /* QuestionToken */, 59 /* ColonToken */], [isOptionEnabled("insertSpaceBeforeTypeAnnotation"), isNonJsxSameLineTokenContext, isTypeAnnotationContext], 4 /* InsertSpace */),
	      rule("NoSpaceBeforeTypeAnnotation", anyToken, [58 /* QuestionToken */, 59 /* ColonToken */], [isOptionDisabledOrUndefined("insertSpaceBeforeTypeAnnotation"), isNonJsxSameLineTokenContext, isTypeAnnotationContext], 16 /* DeleteSpace */),
	      rule("NoOptionalSemicolon", 27 /* SemicolonToken */, anyTokenIncludingEOF, [optionEquals("semicolons", "remove" /* Remove */), isSemicolonDeletionContext], 32 /* DeleteToken */),
	      rule("OptionalSemicolon", anyToken, anyTokenIncludingEOF, [optionEquals("semicolons", "insert" /* Insert */), isSemicolonInsertionContext], 64 /* InsertTrailingSemicolon */)
	    ];
	    const lowPriorityCommonRules = [
	      // Space after keyword but not before ; or : or ?
	      rule("NoSpaceBeforeSemicolon", anyToken, 27 /* SemicolonToken */, [isNonJsxSameLineTokenContext], 16 /* DeleteSpace */),
	      rule("SpaceBeforeOpenBraceInControl", controlOpenBraceLeftTokenRange, 19 /* OpenBraceToken */, [isOptionDisabledOrUndefinedOrTokensOnSameLine("placeOpenBraceOnNewLineForControlBlocks"), isControlDeclContext, isNotFormatOnEnter, isSameLineTokenOrBeforeBlockContext], 4 /* InsertSpace */, 1 /* CanDeleteNewLines */),
	      rule("SpaceBeforeOpenBraceInFunction", functionOpenBraceLeftTokenRange, 19 /* OpenBraceToken */, [isOptionDisabledOrUndefinedOrTokensOnSameLine("placeOpenBraceOnNewLineForFunctions"), isFunctionDeclContext, isBeforeBlockContext, isNotFormatOnEnter, isSameLineTokenOrBeforeBlockContext], 4 /* InsertSpace */, 1 /* CanDeleteNewLines */),
	      rule("SpaceBeforeOpenBraceInTypeScriptDeclWithBlock", typeScriptOpenBraceLeftTokenRange, 19 /* OpenBraceToken */, [isOptionDisabledOrUndefinedOrTokensOnSameLine("placeOpenBraceOnNewLineForFunctions"), isTypeScriptDeclWithBlockContext, isNotFormatOnEnter, isSameLineTokenOrBeforeBlockContext], 4 /* InsertSpace */, 1 /* CanDeleteNewLines */),
	      rule("NoSpaceBeforeComma", anyToken, 28 /* CommaToken */, [isNonJsxSameLineTokenContext], 16 /* DeleteSpace */),
	      // No space before and after indexer `x[]`
	      rule("NoSpaceBeforeOpenBracket", anyTokenExcept(134 /* AsyncKeyword */, 84 /* CaseKeyword */), 23 /* OpenBracketToken */, [isNonJsxSameLineTokenContext], 16 /* DeleteSpace */),
	      rule("NoSpaceAfterCloseBracket", 24 /* CloseBracketToken */, anyToken, [isNonJsxSameLineTokenContext, isNotBeforeBlockInFunctionDeclarationContext], 16 /* DeleteSpace */),
	      rule("SpaceAfterSemicolon", 27 /* SemicolonToken */, anyToken, [isNonJsxSameLineTokenContext], 4 /* InsertSpace */),
	      // Remove extra space between for and await
	      rule("SpaceBetweenForAndAwaitKeyword", 99 /* ForKeyword */, 135 /* AwaitKeyword */, [isNonJsxSameLineTokenContext], 4 /* InsertSpace */),
	      // Add a space between statements. All keywords except (do,else,case) has open/close parens after them.
	      // So, we have a rule to add a space for [),Any], [do,Any], [else,Any], and [case,Any]
	      rule(
	        "SpaceBetweenStatements",
	        [22 /* CloseParenToken */, 92 /* DoKeyword */, 93 /* ElseKeyword */, 84 /* CaseKeyword */],
	        anyToken,
	        [isNonJsxSameLineTokenContext, isNonJsxElementOrFragmentContext, isNotForContext],
	        4 /* InsertSpace */
	      ),
	      // This low-pri rule takes care of "try {", "catch {" and "finally {" in case the rule SpaceBeforeOpenBraceInControl didn't execute on FormatOnEnter.
	      rule("SpaceAfterTryCatchFinally", [113 /* TryKeyword */, 85 /* CatchKeyword */, 98 /* FinallyKeyword */], 19 /* OpenBraceToken */, [isNonJsxSameLineTokenContext], 4 /* InsertSpace */)
	    ];
	    return [
	      ...highPriorityCommonRules,
	      ...userConfigurableRules,
	      ...lowPriorityCommonRules
	    ];
	  }
	  function rule(debugName, left, right, context, action, flags = 0 /* None */) {
	    return { leftTokenRange: toTokenRange(left), rightTokenRange: toTokenRange(right), rule: { debugName, context, action, flags } };
	  }
	  function tokenRangeFrom(tokens) {
	    return { tokens, isSpecific: true };
	  }
	  function toTokenRange(arg) {
	    return typeof arg === "number" ? tokenRangeFrom([arg]) : isArray(arg) ? tokenRangeFrom(arg) : arg;
	  }
	  function tokenRangeFromRange(from, to, except = []) {
	    const tokens = [];
	    for (let token = from; token <= to; token++) {
	      if (!contains(except, token)) {
	        tokens.push(token);
	      }
	    }
	    return tokenRangeFrom(tokens);
	  }
	  function optionEquals(optionName, optionValue) {
	    return (context) => context.options && context.options[optionName] === optionValue;
	  }
	  function isOptionEnabled(optionName) {
	    return (context) => context.options && hasProperty(context.options, optionName) && !!context.options[optionName];
	  }
	  function isOptionDisabled(optionName) {
	    return (context) => context.options && hasProperty(context.options, optionName) && !context.options[optionName];
	  }
	  function isOptionDisabledOrUndefined(optionName) {
	    return (context) => !context.options || !hasProperty(context.options, optionName) || !context.options[optionName];
	  }
	  function isOptionDisabledOrUndefinedOrTokensOnSameLine(optionName) {
	    return (context) => !context.options || !hasProperty(context.options, optionName) || !context.options[optionName] || context.TokensAreOnSameLine();
	  }
	  function isOptionEnabledOrUndefined(optionName) {
	    return (context) => !context.options || !hasProperty(context.options, optionName) || !!context.options[optionName];
	  }
	  function isForContext(context) {
	    return context.contextNode.kind === 248 /* ForStatement */;
	  }
	  function isNotForContext(context) {
	    return !isForContext(context);
	  }
	  function isBinaryOpContext(context) {
	    switch (context.contextNode.kind) {
	      case 226 /* BinaryExpression */:
	        return context.contextNode.operatorToken.kind !== 28 /* CommaToken */;
	      case 227 /* ConditionalExpression */:
	      case 194 /* ConditionalType */:
	      case 234 /* AsExpression */:
	      case 281 /* ExportSpecifier */:
	      case 276 /* ImportSpecifier */:
	      case 182 /* TypePredicate */:
	      case 192 /* UnionType */:
	      case 193 /* IntersectionType */:
	      case 238 /* SatisfiesExpression */:
	        return true;
	      case 208 /* BindingElement */:
	      case 265 /* TypeAliasDeclaration */:
	      case 271 /* ImportEqualsDeclaration */:
	      case 277 /* ExportAssignment */:
	      case 260 /* VariableDeclaration */:
	      case 169 /* Parameter */:
	      case 306 /* EnumMember */:
	      case 172 /* PropertyDeclaration */:
	      case 171 /* PropertySignature */:
	        return context.currentTokenSpan.kind === 64 /* EqualsToken */ || context.nextTokenSpan.kind === 64 /* EqualsToken */;
	      case 249 /* ForInStatement */:
	      case 168 /* TypeParameter */:
	        return context.currentTokenSpan.kind === 103 /* InKeyword */ || context.nextTokenSpan.kind === 103 /* InKeyword */ || context.currentTokenSpan.kind === 64 /* EqualsToken */ || context.nextTokenSpan.kind === 64 /* EqualsToken */;
	      case 250 /* ForOfStatement */:
	        return context.currentTokenSpan.kind === 165 /* OfKeyword */ || context.nextTokenSpan.kind === 165 /* OfKeyword */;
	    }
	    return false;
	  }
	  function isNotBinaryOpContext(context) {
	    return !isBinaryOpContext(context);
	  }
	  function isNotTypeAnnotationContext(context) {
	    return !isTypeAnnotationContext(context);
	  }
	  function isTypeAnnotationContext(context) {
	    const contextKind = context.contextNode.kind;
	    return contextKind === 172 /* PropertyDeclaration */ || contextKind === 171 /* PropertySignature */ || contextKind === 169 /* Parameter */ || contextKind === 260 /* VariableDeclaration */ || isFunctionLikeKind(contextKind);
	  }
	  function isOptionalPropertyContext(context) {
	    return isPropertyDeclaration(context.contextNode) && context.contextNode.questionToken;
	  }
	  function isNonOptionalPropertyContext(context) {
	    return !isOptionalPropertyContext(context);
	  }
	  function isConditionalOperatorContext(context) {
	    return context.contextNode.kind === 227 /* ConditionalExpression */ || context.contextNode.kind === 194 /* ConditionalType */;
	  }
	  function isSameLineTokenOrBeforeBlockContext(context) {
	    return context.TokensAreOnSameLine() || isBeforeBlockContext(context);
	  }
	  function isBraceWrappedContext(context) {
	    return context.contextNode.kind === 206 /* ObjectBindingPattern */ || context.contextNode.kind === 200 /* MappedType */ || isSingleLineBlockContext(context);
	  }
	  function isBeforeMultilineBlockContext(context) {
	    return isBeforeBlockContext(context) && !(context.NextNodeAllOnSameLine() || context.NextNodeBlockIsOnOneLine());
	  }
	  function isMultilineBlockContext(context) {
	    return isBlockContext(context) && !(context.ContextNodeAllOnSameLine() || context.ContextNodeBlockIsOnOneLine());
	  }
	  function isSingleLineBlockContext(context) {
	    return isBlockContext(context) && (context.ContextNodeAllOnSameLine() || context.ContextNodeBlockIsOnOneLine());
	  }
	  function isBlockContext(context) {
	    return nodeIsBlockContext(context.contextNode);
	  }
	  function isBeforeBlockContext(context) {
	    return nodeIsBlockContext(context.nextTokenParent);
	  }
	  function nodeIsBlockContext(node) {
	    if (nodeIsTypeScriptDeclWithBlockContext(node)) {
	      return true;
	    }
	    switch (node.kind) {
	      case 241 /* Block */:
	      case 269 /* CaseBlock */:
	      case 210 /* ObjectLiteralExpression */:
	      case 268 /* ModuleBlock */:
	        return true;
	    }
	    return false;
	  }
	  function isFunctionDeclContext(context) {
	    switch (context.contextNode.kind) {
	      case 262 /* FunctionDeclaration */:
	      case 174 /* MethodDeclaration */:
	      case 173 /* MethodSignature */:
	      case 177 /* GetAccessor */:
	      case 178 /* SetAccessor */:
	      case 179 /* CallSignature */:
	      case 218 /* FunctionExpression */:
	      case 176 /* Constructor */:
	      case 219 /* ArrowFunction */:
	      case 264 /* InterfaceDeclaration */:
	        return true;
	    }
	    return false;
	  }
	  function isNotFunctionDeclContext(context) {
	    return !isFunctionDeclContext(context);
	  }
	  function isFunctionDeclarationOrFunctionExpressionContext(context) {
	    return context.contextNode.kind === 262 /* FunctionDeclaration */ || context.contextNode.kind === 218 /* FunctionExpression */;
	  }
	  function isTypeScriptDeclWithBlockContext(context) {
	    return nodeIsTypeScriptDeclWithBlockContext(context.contextNode);
	  }
	  function nodeIsTypeScriptDeclWithBlockContext(node) {
	    switch (node.kind) {
	      case 263 /* ClassDeclaration */:
	      case 231 /* ClassExpression */:
	      case 264 /* InterfaceDeclaration */:
	      case 266 /* EnumDeclaration */:
	      case 187 /* TypeLiteral */:
	      case 267 /* ModuleDeclaration */:
	      case 278 /* ExportDeclaration */:
	      case 279 /* NamedExports */:
	      case 272 /* ImportDeclaration */:
	      case 275 /* NamedImports */:
	        return true;
	    }
	    return false;
	  }
	  function isAfterCodeBlockContext(context) {
	    switch (context.currentTokenParent.kind) {
	      case 263 /* ClassDeclaration */:
	      case 267 /* ModuleDeclaration */:
	      case 266 /* EnumDeclaration */:
	      case 299 /* CatchClause */:
	      case 268 /* ModuleBlock */:
	      case 255 /* SwitchStatement */:
	        return true;
	      case 241 /* Block */: {
	        const blockParent = context.currentTokenParent.parent;
	        if (!blockParent || blockParent.kind !== 219 /* ArrowFunction */ && blockParent.kind !== 218 /* FunctionExpression */) {
	          return true;
	        }
	      }
	    }
	    return false;
	  }
	  function isControlDeclContext(context) {
	    switch (context.contextNode.kind) {
	      case 245 /* IfStatement */:
	      case 255 /* SwitchStatement */:
	      case 248 /* ForStatement */:
	      case 249 /* ForInStatement */:
	      case 250 /* ForOfStatement */:
	      case 247 /* WhileStatement */:
	      case 258 /* TryStatement */:
	      case 246 /* DoStatement */:
	      case 254 /* WithStatement */:
	      case 299 /* CatchClause */:
	        return true;
	      default:
	        return false;
	    }
	  }
	  function isObjectContext(context) {
	    return context.contextNode.kind === 210 /* ObjectLiteralExpression */;
	  }
	  function isFunctionCallContext(context) {
	    return context.contextNode.kind === 213 /* CallExpression */;
	  }
	  function isNewContext(context) {
	    return context.contextNode.kind === 214 /* NewExpression */;
	  }
	  function isFunctionCallOrNewContext(context) {
	    return isFunctionCallContext(context) || isNewContext(context);
	  }
	  function isPreviousTokenNotComma(context) {
	    return context.currentTokenSpan.kind !== 28 /* CommaToken */;
	  }
	  function isNextTokenNotCloseBracket(context) {
	    return context.nextTokenSpan.kind !== 24 /* CloseBracketToken */;
	  }
	  function isNextTokenNotCloseParen(context) {
	    return context.nextTokenSpan.kind !== 22 /* CloseParenToken */;
	  }
	  function isArrowFunctionContext(context) {
	    return context.contextNode.kind === 219 /* ArrowFunction */;
	  }
	  function isImportTypeContext(context) {
	    return context.contextNode.kind === 205 /* ImportType */;
	  }
	  function isNonJsxSameLineTokenContext(context) {
	    return context.TokensAreOnSameLine() && context.contextNode.kind !== 12 /* JsxText */;
	  }
	  function isNonJsxTextContext(context) {
	    return context.contextNode.kind !== 12 /* JsxText */;
	  }
	  function isNonJsxElementOrFragmentContext(context) {
	    return context.contextNode.kind !== 284 /* JsxElement */ && context.contextNode.kind !== 288 /* JsxFragment */;
	  }
	  function isJsxExpressionContext(context) {
	    return context.contextNode.kind === 294 /* JsxExpression */ || context.contextNode.kind === 293 /* JsxSpreadAttribute */;
	  }
	  function isNextTokenParentJsxAttribute(context) {
	    return context.nextTokenParent.kind === 291 /* JsxAttribute */ || context.nextTokenParent.kind === 295 /* JsxNamespacedName */ && context.nextTokenParent.parent.kind === 291 /* JsxAttribute */;
	  }
	  function isJsxAttributeContext(context) {
	    return context.contextNode.kind === 291 /* JsxAttribute */;
	  }
	  function isNextTokenParentNotJsxNamespacedName(context) {
	    return context.nextTokenParent.kind !== 295 /* JsxNamespacedName */;
	  }
	  function isNextTokenParentJsxNamespacedName(context) {
	    return context.nextTokenParent.kind === 295 /* JsxNamespacedName */;
	  }
	  function isJsxSelfClosingElementContext(context) {
	    return context.contextNode.kind === 285 /* JsxSelfClosingElement */;
	  }
	  function isNotBeforeBlockInFunctionDeclarationContext(context) {
	    return !isFunctionDeclContext(context) && !isBeforeBlockContext(context);
	  }
	  function isEndOfDecoratorContextOnSameLine(context) {
	    return context.TokensAreOnSameLine() && hasDecorators(context.contextNode) && nodeIsInDecoratorContext(context.currentTokenParent) && !nodeIsInDecoratorContext(context.nextTokenParent);
	  }
	  function nodeIsInDecoratorContext(node) {
	    while (node && isExpression(node)) {
	      node = node.parent;
	    }
	    return node && node.kind === 170 /* Decorator */;
	  }
	  function isStartOfVariableDeclarationList(context) {
	    return context.currentTokenParent.kind === 261 /* VariableDeclarationList */ && context.currentTokenParent.getStart(context.sourceFile) === context.currentTokenSpan.pos;
	  }
	  function isNotFormatOnEnter(context) {
	    return context.formattingRequestKind !== 2 /* FormatOnEnter */;
	  }
	  function isModuleDeclContext(context) {
	    return context.contextNode.kind === 267 /* ModuleDeclaration */;
	  }
	  function isObjectTypeContext(context) {
	    return context.contextNode.kind === 187 /* TypeLiteral */;
	  }
	  function isConstructorSignatureContext(context) {
	    return context.contextNode.kind === 180 /* ConstructSignature */;
	  }
	  function isTypeArgumentOrParameterOrAssertion(token, parent2) {
	    if (token.kind !== 30 /* LessThanToken */ && token.kind !== 32 /* GreaterThanToken */) {
	      return false;
	    }
	    switch (parent2.kind) {
	      case 183 /* TypeReference */:
	      case 216 /* TypeAssertionExpression */:
	      case 265 /* TypeAliasDeclaration */:
	      case 263 /* ClassDeclaration */:
	      case 231 /* ClassExpression */:
	      case 264 /* InterfaceDeclaration */:
	      case 262 /* FunctionDeclaration */:
	      case 218 /* FunctionExpression */:
	      case 219 /* ArrowFunction */:
	      case 174 /* MethodDeclaration */:
	      case 173 /* MethodSignature */:
	      case 179 /* CallSignature */:
	      case 180 /* ConstructSignature */:
	      case 213 /* CallExpression */:
	      case 214 /* NewExpression */:
	      case 233 /* ExpressionWithTypeArguments */:
	        return true;
	      default:
	        return false;
	    }
	  }
	  function isTypeArgumentOrParameterOrAssertionContext(context) {
	    return isTypeArgumentOrParameterOrAssertion(context.currentTokenSpan, context.currentTokenParent) || isTypeArgumentOrParameterOrAssertion(context.nextTokenSpan, context.nextTokenParent);
	  }
	  function isTypeAssertionContext(context) {
	    return context.contextNode.kind === 216 /* TypeAssertionExpression */;
	  }
	  function isNonTypeAssertionContext(context) {
	    return !isTypeAssertionContext(context);
	  }
	  function isVoidOpContext(context) {
	    return context.currentTokenSpan.kind === 116 /* VoidKeyword */ && context.currentTokenParent.kind === 222 /* VoidExpression */;
	  }
	  function isYieldOrYieldStarWithOperand(context) {
	    return context.contextNode.kind === 229 /* YieldExpression */ && context.contextNode.expression !== void 0;
	  }
	  function isNonNullAssertionContext(context) {
	    return context.contextNode.kind === 235 /* NonNullExpression */;
	  }
	  function isNotStatementConditionContext(context) {
	    return !isStatementConditionContext(context);
	  }
	  function isStatementConditionContext(context) {
	    switch (context.contextNode.kind) {
	      case 245 /* IfStatement */:
	      case 248 /* ForStatement */:
	      case 249 /* ForInStatement */:
	      case 250 /* ForOfStatement */:
	      case 246 /* DoStatement */:
	      case 247 /* WhileStatement */:
	        return true;
	      default:
	        return false;
	    }
	  }
	  function isSemicolonDeletionContext(context) {
	    let nextTokenKind = context.nextTokenSpan.kind;
	    let nextTokenStart = context.nextTokenSpan.pos;
	    if (isTrivia(nextTokenKind)) {
	      const nextRealToken = context.nextTokenParent === context.currentTokenParent ? findNextToken(
	        context.currentTokenParent,
	        findAncestor(context.currentTokenParent, (a) => !a.parent),
	        context.sourceFile
	      ) : context.nextTokenParent.getFirstToken(context.sourceFile);
	      if (!nextRealToken) {
	        return true;
	      }
	      nextTokenKind = nextRealToken.kind;
	      nextTokenStart = nextRealToken.getStart(context.sourceFile);
	    }
	    const startLine = context.sourceFile.getLineAndCharacterOfPosition(context.currentTokenSpan.pos).line;
	    const endLine = context.sourceFile.getLineAndCharacterOfPosition(nextTokenStart).line;
	    if (startLine === endLine) {
	      return nextTokenKind === 20 /* CloseBraceToken */ || nextTokenKind === 1 /* EndOfFileToken */;
	    }
	    if (nextTokenKind === 240 /* SemicolonClassElement */ || nextTokenKind === 27 /* SemicolonToken */) {
	      return false;
	    }
	    if (context.contextNode.kind === 264 /* InterfaceDeclaration */ || context.contextNode.kind === 265 /* TypeAliasDeclaration */) {
	      return !isPropertySignature(context.currentTokenParent) || !!context.currentTokenParent.type || nextTokenKind !== 21 /* OpenParenToken */;
	    }
	    if (isPropertyDeclaration(context.currentTokenParent)) {
	      return !context.currentTokenParent.initializer;
	    }
	    return context.currentTokenParent.kind !== 248 /* ForStatement */ && context.currentTokenParent.kind !== 242 /* EmptyStatement */ && context.currentTokenParent.kind !== 240 /* SemicolonClassElement */ && nextTokenKind !== 23 /* OpenBracketToken */ && nextTokenKind !== 21 /* OpenParenToken */ && nextTokenKind !== 40 /* PlusToken */ && nextTokenKind !== 41 /* MinusToken */ && nextTokenKind !== 44 /* SlashToken */ && nextTokenKind !== 14 /* RegularExpressionLiteral */ && nextTokenKind !== 28 /* CommaToken */ && nextTokenKind !== 228 /* TemplateExpression */ && nextTokenKind !== 16 /* TemplateHead */ && nextTokenKind !== 15 /* NoSubstitutionTemplateLiteral */ && nextTokenKind !== 25 /* DotToken */;
	  }
	  function isSemicolonInsertionContext(context) {
	    return positionIsASICandidate(context.currentTokenSpan.end, context.currentTokenParent, context.sourceFile);
	  }
	  function isNotPropertyAccessOnIntegerLiteral(context) {
	    return !isPropertyAccessExpression(context.contextNode) || !isNumericLiteral(context.contextNode.expression) || context.contextNode.expression.getText().includes(".");
	  }
	  var init_rules = __esm({
	    "src/services/formatting/rules.ts"() {
	      init_ts4();
	      init_ts_formatting();
	    }
	  });

	  // src/services/formatting/rulesMap.ts
	  function getFormatContext(options, host) {
	    return { options, getRules: getRulesMap(), host };
	  }
	  function getRulesMap() {
	    if (rulesMapCache === void 0) {
	      rulesMapCache = createRulesMap(getAllRules());
	    }
	    return rulesMapCache;
	  }
	  function getRuleActionExclusion(ruleAction) {
	    let mask2 = 0 /* None */;
	    if (ruleAction & 1 /* StopProcessingSpaceActions */) {
	      mask2 |= 28 /* ModifySpaceAction */;
	    }
	    if (ruleAction & 2 /* StopProcessingTokenActions */) {
	      mask2 |= 96 /* ModifyTokenAction */;
	    }
	    if (ruleAction & 28 /* ModifySpaceAction */) {
	      mask2 |= 28 /* ModifySpaceAction */;
	    }
	    if (ruleAction & 96 /* ModifyTokenAction */) {
	      mask2 |= 96 /* ModifyTokenAction */;
	    }
	    return mask2;
	  }
	  function createRulesMap(rules) {
	    const map2 = buildMap(rules);
	    return (context) => {
	      const bucket = map2[getRuleBucketIndex(context.currentTokenSpan.kind, context.nextTokenSpan.kind)];
	      if (bucket) {
	        const rules2 = [];
	        let ruleActionMask = 0;
	        for (const rule2 of bucket) {
	          const acceptRuleActions = ~getRuleActionExclusion(ruleActionMask);
	          if (rule2.action & acceptRuleActions && every(rule2.context, (c) => c(context))) {
	            rules2.push(rule2);
	            ruleActionMask |= rule2.action;
	          }
	        }
	        if (rules2.length) {
	          return rules2;
	        }
	      }
	    };
	  }
	  function buildMap(rules) {
	    const map2 = new Array(mapRowLength * mapRowLength);
	    const rulesBucketConstructionStateList = new Array(map2.length);
	    for (const rule2 of rules) {
	      const specificRule = rule2.leftTokenRange.isSpecific && rule2.rightTokenRange.isSpecific;
	      for (const left of rule2.leftTokenRange.tokens) {
	        for (const right of rule2.rightTokenRange.tokens) {
	          const index = getRuleBucketIndex(left, right);
	          let rulesBucket = map2[index];
	          if (rulesBucket === void 0) {
	            rulesBucket = map2[index] = [];
	          }
	          addRule(rulesBucket, rule2.rule, specificRule, rulesBucketConstructionStateList, index);
	        }
	      }
	    }
	    return map2;
	  }
	  function getRuleBucketIndex(row, column) {
	    Debug.assert(row <= 165 /* LastKeyword */ && column <= 165 /* LastKeyword */, "Must compute formatting context from tokens");
	    return row * mapRowLength + column;
	  }
	  function addRule(rules, rule2, specificTokens, constructionState, rulesBucketIndex) {
	    const position = rule2.action & 3 /* StopAction */ ? specificTokens ? 0 /* StopRulesSpecific */ : RulesPosition.StopRulesAny : rule2.context !== anyContext ? specificTokens ? RulesPosition.ContextRulesSpecific : RulesPosition.ContextRulesAny : specificTokens ? RulesPosition.NoContextRulesSpecific : RulesPosition.NoContextRulesAny;
	    const state = constructionState[rulesBucketIndex] || 0;
	    rules.splice(getInsertionIndex(state, position), 0, rule2);
	    constructionState[rulesBucketIndex] = increaseInsertionIndex(state, position);
	  }
	  function getInsertionIndex(indexBitmap, maskPosition) {
	    let index = 0;
	    for (let pos = 0; pos <= maskPosition; pos += maskBitSize) {
	      index += indexBitmap & mask;
	      indexBitmap >>= maskBitSize;
	    }
	    return index;
	  }
	  function increaseInsertionIndex(indexBitmap, maskPosition) {
	    const value = (indexBitmap >> maskPosition & mask) + 1;
	    Debug.assert((value & mask) === value, "Adding more rules into the sub-bucket than allowed. Maximum allowed is 32 rules.");
	    return indexBitmap & ~(mask << maskPosition) | value << maskPosition;
	  }
	  var rulesMapCache, maskBitSize, mask, mapRowLength, RulesPosition;
	  var init_rulesMap = __esm({
	    "src/services/formatting/rulesMap.ts"() {
	      init_ts4();
	      init_ts_formatting();
	      maskBitSize = 5;
	      mask = 31;
	      mapRowLength = 165 /* LastToken */ + 1;
	      RulesPosition = ((RulesPosition2) => {
	        RulesPosition2[RulesPosition2["StopRulesSpecific"] = 0] = "StopRulesSpecific";
	        RulesPosition2[RulesPosition2["StopRulesAny"] = maskBitSize * 1] = "StopRulesAny";
	        RulesPosition2[RulesPosition2["ContextRulesSpecific"] = maskBitSize * 2] = "ContextRulesSpecific";
	        RulesPosition2[RulesPosition2["ContextRulesAny"] = maskBitSize * 3] = "ContextRulesAny";
	        RulesPosition2[RulesPosition2["NoContextRulesSpecific"] = maskBitSize * 4] = "NoContextRulesSpecific";
	        RulesPosition2[RulesPosition2["NoContextRulesAny"] = maskBitSize * 5] = "NoContextRulesAny";
	        return RulesPosition2;
	      })(RulesPosition || {});
	    }
	  });

	  // src/services/formatting/formatting.ts
	  function createTextRangeWithKind(pos, end, kind) {
	    const textRangeWithKind = { pos, end, kind };
	    if (Debug.isDebugging) {
	      Object.defineProperty(textRangeWithKind, "__debugKind", {
	        get: () => Debug.formatSyntaxKind(kind)
	      });
	    }
	    return textRangeWithKind;
	  }
	  function formatOnEnter(position, sourceFile, formatContext) {
	    const line = sourceFile.getLineAndCharacterOfPosition(position).line;
	    if (line === 0) {
	      return [];
	    }
	    let endOfFormatSpan = getEndLinePosition(line, sourceFile);
	    while (isWhiteSpaceSingleLine(sourceFile.text.charCodeAt(endOfFormatSpan))) {
	      endOfFormatSpan--;
	    }
	    if (isLineBreak(sourceFile.text.charCodeAt(endOfFormatSpan))) {
	      endOfFormatSpan--;
	    }
	    const span = {
	      // get start position for the previous line
	      pos: getStartPositionOfLine(line - 1, sourceFile),
	      // end value is exclusive so add 1 to the result
	      end: endOfFormatSpan + 1
	    };
	    return formatSpan(span, sourceFile, formatContext, 2 /* FormatOnEnter */);
	  }
	  function formatOnSemicolon(position, sourceFile, formatContext) {
	    const semicolon = findImmediatelyPrecedingTokenOfKind(position, 27 /* SemicolonToken */, sourceFile);
	    return formatNodeLines(findOutermostNodeWithinListLevel(semicolon), sourceFile, formatContext, 3 /* FormatOnSemicolon */);
	  }
	  function formatOnOpeningCurly(position, sourceFile, formatContext) {
	    const openingCurly = findImmediatelyPrecedingTokenOfKind(position, 19 /* OpenBraceToken */, sourceFile);
	    if (!openingCurly) {
	      return [];
	    }
	    const curlyBraceRange = openingCurly.parent;
	    const outermostNode = findOutermostNodeWithinListLevel(curlyBraceRange);
	    const textRange = {
	      pos: getLineStartPositionForPosition(outermostNode.getStart(sourceFile), sourceFile),
	      // TODO: GH#18217
	      end: position
	    };
	    return formatSpan(textRange, sourceFile, formatContext, 4 /* FormatOnOpeningCurlyBrace */);
	  }
	  function formatOnClosingCurly(position, sourceFile, formatContext) {
	    const precedingToken = findImmediatelyPrecedingTokenOfKind(position, 20 /* CloseBraceToken */, sourceFile);
	    return formatNodeLines(findOutermostNodeWithinListLevel(precedingToken), sourceFile, formatContext, 5 /* FormatOnClosingCurlyBrace */);
	  }
	  function formatDocument(sourceFile, formatContext) {
	    const span = {
	      pos: 0,
	      end: sourceFile.text.length
	    };
	    return formatSpan(span, sourceFile, formatContext, 0 /* FormatDocument */);
	  }
	  function formatSelection(start, end, sourceFile, formatContext) {
	    const span = {
	      pos: getLineStartPositionForPosition(start, sourceFile),
	      end
	    };
	    return formatSpan(span, sourceFile, formatContext, 1 /* FormatSelection */);
	  }
	  function findImmediatelyPrecedingTokenOfKind(end, expectedTokenKind, sourceFile) {
	    const precedingToken = findPrecedingToken(end, sourceFile);
	    return precedingToken && precedingToken.kind === expectedTokenKind && end === precedingToken.getEnd() ? precedingToken : void 0;
	  }
	  function findOutermostNodeWithinListLevel(node) {
	    let current = node;
	    while (current && current.parent && current.parent.end === node.end && !isListElement(current.parent, current)) {
	      current = current.parent;
	    }
	    return current;
	  }
	  function isListElement(parent2, node) {
	    switch (parent2.kind) {
	      case 263 /* ClassDeclaration */:
	      case 264 /* InterfaceDeclaration */:
	        return rangeContainsRange(parent2.members, node);
	      case 267 /* ModuleDeclaration */:
	        const body = parent2.body;
	        return !!body && body.kind === 268 /* ModuleBlock */ && rangeContainsRange(body.statements, node);
	      case 312 /* SourceFile */:
	      case 241 /* Block */:
	      case 268 /* ModuleBlock */:
	        return rangeContainsRange(parent2.statements, node);
	      case 299 /* CatchClause */:
	        return rangeContainsRange(parent2.block.statements, node);
	    }
	    return false;
	  }
	  function findEnclosingNode(range, sourceFile) {
	    return find2(sourceFile);
	    function find2(n) {
	      const candidate = forEachChild(n, (c) => startEndContainsRange(c.getStart(sourceFile), c.end, range) && c);
	      if (candidate) {
	        const result = find2(candidate);
	        if (result) {
	          return result;
	        }
	      }
	      return n;
	    }
	  }
	  function prepareRangeContainsErrorFunction(errors, originalRange) {
	    if (!errors.length) {
	      return rangeHasNoErrors;
	    }
	    const sorted = errors.filter((d) => rangeOverlapsWithStartEnd(originalRange, d.start, d.start + d.length)).sort((e1, e2) => e1.start - e2.start);
	    if (!sorted.length) {
	      return rangeHasNoErrors;
	    }
	    let index = 0;
	    return (r) => {
	      while (true) {
	        if (index >= sorted.length) {
	          return false;
	        }
	        const error2 = sorted[index];
	        if (r.end <= error2.start) {
	          return false;
	        }
	        if (startEndOverlapsWithStartEnd(r.pos, r.end, error2.start, error2.start + error2.length)) {
	          return true;
	        }
	        index++;
	      }
	    };
	    function rangeHasNoErrors() {
	      return false;
	    }
	  }
	  function getScanStartPosition(enclosingNode, originalRange, sourceFile) {
	    const start = enclosingNode.getStart(sourceFile);
	    if (start === originalRange.pos && enclosingNode.end === originalRange.end) {
	      return start;
	    }
	    const precedingToken = findPrecedingToken(originalRange.pos, sourceFile);
	    if (!precedingToken) {
	      return enclosingNode.pos;
	    }
	    if (precedingToken.end >= originalRange.pos) {
	      return enclosingNode.pos;
	    }
	    return precedingToken.end;
	  }
	  function getOwnOrInheritedDelta(n, options, sourceFile) {
	    let previousLine = -1 /* Unknown */;
	    let child;
	    while (n) {
	      const line = sourceFile.getLineAndCharacterOfPosition(n.getStart(sourceFile)).line;
	      if (previousLine !== -1 /* Unknown */ && line !== previousLine) {
	        break;
	      }
	      if (SmartIndenter.shouldIndentChildNode(options, n, child, sourceFile)) {
	        return options.indentSize;
	      }
	      previousLine = line;
	      child = n;
	      n = n.parent;
	    }
	    return 0;
	  }
	  function formatNodeGivenIndentation(node, sourceFileLike, languageVariant, initialIndentation, delta, formatContext) {
	    const range = { pos: node.pos, end: node.end };
	    return getFormattingScanner(sourceFileLike.text, languageVariant, range.pos, range.end, (scanner2) => formatSpanWorker(
	      range,
	      node,
	      initialIndentation,
	      delta,
	      scanner2,
	      formatContext,
	      1 /* FormatSelection */,
	      (_) => false,
	      // assume that node does not have any errors
	      sourceFileLike
	    ));
	  }
	  function formatNodeLines(node, sourceFile, formatContext, requestKind) {
	    if (!node) {
	      return [];
	    }
	    const span = {
	      pos: getLineStartPositionForPosition(node.getStart(sourceFile), sourceFile),
	      end: node.end
	    };
	    return formatSpan(span, sourceFile, formatContext, requestKind);
	  }
	  function formatSpan(originalRange, sourceFile, formatContext, requestKind) {
	    const enclosingNode = findEnclosingNode(originalRange, sourceFile);
	    return getFormattingScanner(
	      sourceFile.text,
	      sourceFile.languageVariant,
	      getScanStartPosition(enclosingNode, originalRange, sourceFile),
	      originalRange.end,
	      (scanner2) => formatSpanWorker(
	        originalRange,
	        enclosingNode,
	        SmartIndenter.getIndentationForNode(enclosingNode, originalRange, sourceFile, formatContext.options),
	        getOwnOrInheritedDelta(enclosingNode, formatContext.options, sourceFile),
	        scanner2,
	        formatContext,
	        requestKind,
	        prepareRangeContainsErrorFunction(sourceFile.parseDiagnostics, originalRange),
	        sourceFile
	      )
	    );
	  }
	  function formatSpanWorker(originalRange, enclosingNode, initialIndentation, delta, formattingScanner, { options, getRules, host }, requestKind, rangeContainsError, sourceFile) {
	    var _a;
	    const formattingContext = new FormattingContext(sourceFile, requestKind, options);
	    let previousRangeTriviaEnd;
	    let previousRange;
	    let previousParent;
	    let previousRangeStartLine;
	    let lastIndentedLine;
	    let indentationOnLastIndentedLine = -1 /* Unknown */;
	    const edits = [];
	    formattingScanner.advance();
	    if (formattingScanner.isOnToken()) {
	      const startLine = sourceFile.getLineAndCharacterOfPosition(enclosingNode.getStart(sourceFile)).line;
	      let undecoratedStartLine = startLine;
	      if (hasDecorators(enclosingNode)) {
	        undecoratedStartLine = sourceFile.getLineAndCharacterOfPosition(getNonDecoratorTokenPosOfNode(enclosingNode, sourceFile)).line;
	      }
	      processNode(enclosingNode, enclosingNode, startLine, undecoratedStartLine, initialIndentation, delta);
	    }
	    const remainingTrivia = formattingScanner.getCurrentLeadingTrivia();
	    if (remainingTrivia) {
	      const indentation = SmartIndenter.nodeWillIndentChild(
	        options,
	        enclosingNode,
	        /*child*/
	        void 0,
	        sourceFile,
	        /*indentByDefault*/
	        false
	      ) ? initialIndentation + options.indentSize : initialIndentation;
	      indentTriviaItems(
	        remainingTrivia,
	        indentation,
	        /*indentNextTokenOrTrivia*/
	        true,
	        (item) => {
	          processRange(
	            item,
	            sourceFile.getLineAndCharacterOfPosition(item.pos),
	            enclosingNode,
	            enclosingNode,
	            /*dynamicIndentation*/
	            void 0
	          );
	          insertIndentation(
	            item.pos,
	            indentation,
	            /*lineAdded*/
	            false
	          );
	        }
	      );
	      if (options.trimTrailingWhitespace !== false) {
	        trimTrailingWhitespacesForRemainingRange(remainingTrivia);
	      }
	    }
	    if (previousRange && formattingScanner.getTokenFullStart() >= originalRange.end) {
	      const tokenInfo = formattingScanner.isOnEOF() ? formattingScanner.readEOFTokenRange() : formattingScanner.isOnToken() ? formattingScanner.readTokenInfo(enclosingNode).token : void 0;
	      if (tokenInfo && tokenInfo.pos === previousRangeTriviaEnd) {
	        const parent2 = ((_a = findPrecedingToken(tokenInfo.end, sourceFile, enclosingNode)) == null ? void 0 : _a.parent) || previousParent;
	        processPair(
	          tokenInfo,
	          sourceFile.getLineAndCharacterOfPosition(tokenInfo.pos).line,
	          parent2,
	          previousRange,
	          previousRangeStartLine,
	          previousParent,
	          parent2,
	          /*dynamicIndentation*/
	          void 0
	        );
	      }
	    }
	    return edits;
	    function tryComputeIndentationForListItem(startPos, endPos, parentStartLine, range, inheritedIndentation) {
	      if (rangeOverlapsWithStartEnd(range, startPos, endPos) || rangeContainsStartEnd(range, startPos, endPos)) {
	        if (inheritedIndentation !== -1 /* Unknown */) {
	          return inheritedIndentation;
	        }
	      } else {
	        const startLine = sourceFile.getLineAndCharacterOfPosition(startPos).line;
	        const startLinePosition = getLineStartPositionForPosition(startPos, sourceFile);
	        const column = SmartIndenter.findFirstNonWhitespaceColumn(startLinePosition, startPos, sourceFile, options);
	        if (startLine !== parentStartLine || startPos === column) {
	          const baseIndentSize = SmartIndenter.getBaseIndentation(options);
	          return baseIndentSize > column ? baseIndentSize : column;
	        }
	      }
	      return -1 /* Unknown */;
	    }
	    function computeIndentation(node, startLine, inheritedIndentation, parent2, parentDynamicIndentation, effectiveParentStartLine) {
	      const delta2 = SmartIndenter.shouldIndentChildNode(options, node) ? options.indentSize : 0;
	      if (effectiveParentStartLine === startLine) {
	        return {
	          indentation: startLine === lastIndentedLine ? indentationOnLastIndentedLine : parentDynamicIndentation.getIndentation(),
	          delta: Math.min(options.indentSize, parentDynamicIndentation.getDelta(node) + delta2)
	        };
	      } else if (inheritedIndentation === -1 /* Unknown */) {
	        if (node.kind === 21 /* OpenParenToken */ && startLine === lastIndentedLine) {
	          return { indentation: indentationOnLastIndentedLine, delta: parentDynamicIndentation.getDelta(node) };
	        } else if (SmartIndenter.childStartsOnTheSameLineWithElseInIfStatement(parent2, node, startLine, sourceFile) || SmartIndenter.childIsUnindentedBranchOfConditionalExpression(parent2, node, startLine, sourceFile) || SmartIndenter.argumentStartsOnSameLineAsPreviousArgument(parent2, node, startLine, sourceFile)) {
	          return { indentation: parentDynamicIndentation.getIndentation(), delta: delta2 };
	        } else {
	          return { indentation: parentDynamicIndentation.getIndentation() + parentDynamicIndentation.getDelta(node), delta: delta2 };
	        }
	      } else {
	        return { indentation: inheritedIndentation, delta: delta2 };
	      }
	    }
	    function getFirstNonDecoratorTokenOfNode(node) {
	      if (canHaveModifiers(node)) {
	        const modifier = find(node.modifiers, isModifier, findIndex(node.modifiers, isDecorator));
	        if (modifier)
	          return modifier.kind;
	      }
	      switch (node.kind) {
	        case 263 /* ClassDeclaration */:
	          return 86 /* ClassKeyword */;
	        case 264 /* InterfaceDeclaration */:
	          return 120 /* InterfaceKeyword */;
	        case 262 /* FunctionDeclaration */:
	          return 100 /* FunctionKeyword */;
	        case 266 /* EnumDeclaration */:
	          return 266 /* EnumDeclaration */;
	        case 177 /* GetAccessor */:
	          return 139 /* GetKeyword */;
	        case 178 /* SetAccessor */:
	          return 153 /* SetKeyword */;
	        case 174 /* MethodDeclaration */:
	          if (node.asteriskToken) {
	            return 42 /* AsteriskToken */;
	          }
	        case 172 /* PropertyDeclaration */:
	        case 169 /* Parameter */:
	          const name = getNameOfDeclaration(node);
	          if (name) {
	            return name.kind;
	          }
	      }
	    }
	    function getDynamicIndentation(node, nodeStartLine, indentation, delta2) {
	      return {
	        getIndentationForComment: (kind, tokenIndentation, container) => {
	          switch (kind) {
	            case 20 /* CloseBraceToken */:
	            case 24 /* CloseBracketToken */:
	            case 22 /* CloseParenToken */:
	              return indentation + getDelta(container);
	          }
	          return tokenIndentation !== -1 /* Unknown */ ? tokenIndentation : indentation;
	        },
	        // if list end token is LessThanToken '>' then its delta should be explicitly suppressed
	        // so that LessThanToken as a binary operator can still be indented.
	        // foo.then
	        //     <
	        //         number,
	        //         string,
	        //     >();
	        // vs
	        // var a = xValue
	        //     > yValue;
	        getIndentationForToken: (line, kind, container, suppressDelta) => !suppressDelta && shouldAddDelta(line, kind, container) ? indentation + getDelta(container) : indentation,
	        getIndentation: () => indentation,
	        getDelta,
	        recomputeIndentation: (lineAdded, parent2) => {
	          if (SmartIndenter.shouldIndentChildNode(options, parent2, node, sourceFile)) {
	            indentation += lineAdded ? options.indentSize : -options.indentSize;
	            delta2 = SmartIndenter.shouldIndentChildNode(options, node) ? options.indentSize : 0;
	          }
	        }
	      };
	      function shouldAddDelta(line, kind, container) {
	        switch (kind) {
	          case 19 /* OpenBraceToken */:
	          case 20 /* CloseBraceToken */:
	          case 22 /* CloseParenToken */:
	          case 93 /* ElseKeyword */:
	          case 117 /* WhileKeyword */:
	          case 60 /* AtToken */:
	            return false;
	          case 44 /* SlashToken */:
	          case 32 /* GreaterThanToken */:
	            switch (container.kind) {
	              case 286 /* JsxOpeningElement */:
	              case 287 /* JsxClosingElement */:
	              case 285 /* JsxSelfClosingElement */:
	                return false;
	            }
	            break;
	          case 23 /* OpenBracketToken */:
	          case 24 /* CloseBracketToken */:
	            if (container.kind !== 200 /* MappedType */) {
	              return false;
	            }
	            break;
	        }
	        return nodeStartLine !== line && !(hasDecorators(node) && kind === getFirstNonDecoratorTokenOfNode(node));
	      }
	      function getDelta(child) {
	        return SmartIndenter.nodeWillIndentChild(
	          options,
	          node,
	          child,
	          sourceFile,
	          /*indentByDefault*/
	          true
	        ) ? delta2 : 0;
	      }
	    }
	    function processNode(node, contextNode, nodeStartLine, undecoratedNodeStartLine, indentation, delta2) {
	      if (!rangeOverlapsWithStartEnd(originalRange, node.getStart(sourceFile), node.getEnd())) {
	        return;
	      }
	      const nodeDynamicIndentation = getDynamicIndentation(node, nodeStartLine, indentation, delta2);
	      let childContextNode = contextNode;
	      forEachChild(
	        node,
	        (child) => {
	          processChildNode(
	            child,
	            /*inheritedIndentation*/
	            -1 /* Unknown */,
	            node,
	            nodeDynamicIndentation,
	            nodeStartLine,
	            undecoratedNodeStartLine,
	            /*isListItem*/
	            false
	          );
	        },
	        (nodes) => {
	          processChildNodes(nodes, node, nodeStartLine, nodeDynamicIndentation);
	        }
	      );
	      while (formattingScanner.isOnToken() && formattingScanner.getTokenFullStart() < originalRange.end) {
	        const tokenInfo = formattingScanner.readTokenInfo(node);
	        if (tokenInfo.token.end > Math.min(node.end, originalRange.end)) {
	          break;
	        }
	        consumeTokenAndAdvanceScanner(tokenInfo, node, nodeDynamicIndentation, node);
	      }
	      function processChildNode(child, inheritedIndentation, parent2, parentDynamicIndentation, parentStartLine, undecoratedParentStartLine, isListItem, isFirstListItem) {
	        Debug.assert(!nodeIsSynthesized(child));
	        if (nodeIsMissing(child) || isGrammarError(parent2, child)) {
	          return inheritedIndentation;
	        }
	        const childStartPos = child.getStart(sourceFile);
	        const childStartLine = sourceFile.getLineAndCharacterOfPosition(childStartPos).line;
	        let undecoratedChildStartLine = childStartLine;
	        if (hasDecorators(child)) {
	          undecoratedChildStartLine = sourceFile.getLineAndCharacterOfPosition(getNonDecoratorTokenPosOfNode(child, sourceFile)).line;
	        }
	        let childIndentationAmount = -1 /* Unknown */;
	        if (isListItem && rangeContainsRange(originalRange, parent2)) {
	          childIndentationAmount = tryComputeIndentationForListItem(childStartPos, child.end, parentStartLine, originalRange, inheritedIndentation);
	          if (childIndentationAmount !== -1 /* Unknown */) {
	            inheritedIndentation = childIndentationAmount;
	          }
	        }
	        if (!rangeOverlapsWithStartEnd(originalRange, child.pos, child.end)) {
	          if (child.end < originalRange.pos) {
	            formattingScanner.skipToEndOf(child);
	          }
	          return inheritedIndentation;
	        }
	        if (child.getFullWidth() === 0) {
	          return inheritedIndentation;
	        }
	        while (formattingScanner.isOnToken() && formattingScanner.getTokenFullStart() < originalRange.end) {
	          const tokenInfo = formattingScanner.readTokenInfo(node);
	          if (tokenInfo.token.end > originalRange.end) {
	            return inheritedIndentation;
	          }
	          if (tokenInfo.token.end > childStartPos) {
	            if (tokenInfo.token.pos > childStartPos) {
	              formattingScanner.skipToStartOf(child);
	            }
	            break;
	          }
	          consumeTokenAndAdvanceScanner(tokenInfo, node, parentDynamicIndentation, node);
	        }
	        if (!formattingScanner.isOnToken() || formattingScanner.getTokenFullStart() >= originalRange.end) {
	          return inheritedIndentation;
	        }
	        if (isToken(child)) {
	          const tokenInfo = formattingScanner.readTokenInfo(child);
	          if (child.kind !== 12 /* JsxText */) {
	            Debug.assert(tokenInfo.token.end === child.end, "Token end is child end");
	            consumeTokenAndAdvanceScanner(tokenInfo, node, parentDynamicIndentation, child);
	            return inheritedIndentation;
	          }
	        }
	        const effectiveParentStartLine = child.kind === 170 /* Decorator */ ? childStartLine : undecoratedParentStartLine;
	        const childIndentation = computeIndentation(child, childStartLine, childIndentationAmount, node, parentDynamicIndentation, effectiveParentStartLine);
	        processNode(child, childContextNode, childStartLine, undecoratedChildStartLine, childIndentation.indentation, childIndentation.delta);
	        childContextNode = node;
	        if (isFirstListItem && parent2.kind === 209 /* ArrayLiteralExpression */ && inheritedIndentation === -1 /* Unknown */) {
	          inheritedIndentation = childIndentation.indentation;
	        }
	        return inheritedIndentation;
	      }
	      function processChildNodes(nodes, parent2, parentStartLine, parentDynamicIndentation) {
	        Debug.assert(isNodeArray(nodes));
	        Debug.assert(!nodeIsSynthesized(nodes));
	        const listStartToken = getOpenTokenForList(parent2, nodes);
	        let listDynamicIndentation = parentDynamicIndentation;
	        let startLine = parentStartLine;
	        if (!rangeOverlapsWithStartEnd(originalRange, nodes.pos, nodes.end)) {
	          if (nodes.end < originalRange.pos) {
	            formattingScanner.skipToEndOf(nodes);
	          }
	          return;
	        }
	        if (listStartToken !== 0 /* Unknown */) {
	          while (formattingScanner.isOnToken() && formattingScanner.getTokenFullStart() < originalRange.end) {
	            const tokenInfo = formattingScanner.readTokenInfo(parent2);
	            if (tokenInfo.token.end > nodes.pos) {
	              break;
	            } else if (tokenInfo.token.kind === listStartToken) {
	              startLine = sourceFile.getLineAndCharacterOfPosition(tokenInfo.token.pos).line;
	              consumeTokenAndAdvanceScanner(tokenInfo, parent2, parentDynamicIndentation, parent2);
	              let indentationOnListStartToken;
	              if (indentationOnLastIndentedLine !== -1 /* Unknown */) {
	                indentationOnListStartToken = indentationOnLastIndentedLine;
	              } else {
	                const startLinePosition = getLineStartPositionForPosition(tokenInfo.token.pos, sourceFile);
	                indentationOnListStartToken = SmartIndenter.findFirstNonWhitespaceColumn(startLinePosition, tokenInfo.token.pos, sourceFile, options);
	              }
	              listDynamicIndentation = getDynamicIndentation(parent2, parentStartLine, indentationOnListStartToken, options.indentSize);
	            } else {
	              consumeTokenAndAdvanceScanner(tokenInfo, parent2, parentDynamicIndentation, parent2);
	            }
	          }
	        }
	        let inheritedIndentation = -1 /* Unknown */;
	        for (let i = 0; i < nodes.length; i++) {
	          const child = nodes[i];
	          inheritedIndentation = processChildNode(
	            child,
	            inheritedIndentation,
	            node,
	            listDynamicIndentation,
	            startLine,
	            startLine,
	            /*isListItem*/
	            true,
	            /*isFirstListItem*/
	            i === 0
	          );
	        }
	        const listEndToken = getCloseTokenForOpenToken(listStartToken);
	        if (listEndToken !== 0 /* Unknown */ && formattingScanner.isOnToken() && formattingScanner.getTokenFullStart() < originalRange.end) {
	          let tokenInfo = formattingScanner.readTokenInfo(parent2);
	          if (tokenInfo.token.kind === 28 /* CommaToken */) {
	            consumeTokenAndAdvanceScanner(tokenInfo, parent2, listDynamicIndentation, parent2);
	            tokenInfo = formattingScanner.isOnToken() ? formattingScanner.readTokenInfo(parent2) : void 0;
	          }
	          if (tokenInfo && tokenInfo.token.kind === listEndToken && rangeContainsRange(parent2, tokenInfo.token)) {
	            consumeTokenAndAdvanceScanner(
	              tokenInfo,
	              parent2,
	              listDynamicIndentation,
	              parent2,
	              /*isListEndToken*/
	              true
	            );
	          }
	        }
	      }
	      function consumeTokenAndAdvanceScanner(currentTokenInfo, parent2, dynamicIndentation, container, isListEndToken) {
	        Debug.assert(rangeContainsRange(parent2, currentTokenInfo.token));
	        const lastTriviaWasNewLine = formattingScanner.lastTrailingTriviaWasNewLine();
	        let indentToken = false;
	        if (currentTokenInfo.leadingTrivia) {
	          processTrivia(currentTokenInfo.leadingTrivia, parent2, childContextNode, dynamicIndentation);
	        }
	        let lineAction = 0 /* None */;
	        const isTokenInRange = rangeContainsRange(originalRange, currentTokenInfo.token);
	        const tokenStart = sourceFile.getLineAndCharacterOfPosition(currentTokenInfo.token.pos);
	        if (isTokenInRange) {
	          const rangeHasError = rangeContainsError(currentTokenInfo.token);
	          const savePreviousRange = previousRange;
	          lineAction = processRange(currentTokenInfo.token, tokenStart, parent2, childContextNode, dynamicIndentation);
	          if (!rangeHasError) {
	            if (lineAction === 0 /* None */) {
	              const prevEndLine = savePreviousRange && sourceFile.getLineAndCharacterOfPosition(savePreviousRange.end).line;
	              indentToken = lastTriviaWasNewLine && tokenStart.line !== prevEndLine;
	            } else {
	              indentToken = lineAction === 1 /* LineAdded */;
	            }
	          }
	        }
	        if (currentTokenInfo.trailingTrivia) {
	          previousRangeTriviaEnd = last(currentTokenInfo.trailingTrivia).end;
	          processTrivia(currentTokenInfo.trailingTrivia, parent2, childContextNode, dynamicIndentation);
	        }
	        if (indentToken) {
	          const tokenIndentation = isTokenInRange && !rangeContainsError(currentTokenInfo.token) ? dynamicIndentation.getIndentationForToken(tokenStart.line, currentTokenInfo.token.kind, container, !!isListEndToken) : -1 /* Unknown */;
	          let indentNextTokenOrTrivia = true;
	          if (currentTokenInfo.leadingTrivia) {
	            const commentIndentation = dynamicIndentation.getIndentationForComment(currentTokenInfo.token.kind, tokenIndentation, container);
	            indentNextTokenOrTrivia = indentTriviaItems(currentTokenInfo.leadingTrivia, commentIndentation, indentNextTokenOrTrivia, (item) => insertIndentation(
	              item.pos,
	              commentIndentation,
	              /*lineAdded*/
	              false
	            ));
	          }
	          if (tokenIndentation !== -1 /* Unknown */ && indentNextTokenOrTrivia) {
	            insertIndentation(currentTokenInfo.token.pos, tokenIndentation, lineAction === 1 /* LineAdded */);
	            lastIndentedLine = tokenStart.line;
	            indentationOnLastIndentedLine = tokenIndentation;
	          }
	        }
	        formattingScanner.advance();
	        childContextNode = parent2;
	      }
	    }
	    function indentTriviaItems(trivia, commentIndentation, indentNextTokenOrTrivia, indentSingleLine) {
	      for (const triviaItem of trivia) {
	        const triviaInRange = rangeContainsRange(originalRange, triviaItem);
	        switch (triviaItem.kind) {
	          case 3 /* MultiLineCommentTrivia */:
	            if (triviaInRange) {
	              indentMultilineComment(
	                triviaItem,
	                commentIndentation,
	                /*firstLineIsIndented*/
	                !indentNextTokenOrTrivia
	              );
	            }
	            indentNextTokenOrTrivia = false;
	            break;
	          case 2 /* SingleLineCommentTrivia */:
	            if (indentNextTokenOrTrivia && triviaInRange) {
	              indentSingleLine(triviaItem);
	            }
	            indentNextTokenOrTrivia = false;
	            break;
	          case 4 /* NewLineTrivia */:
	            indentNextTokenOrTrivia = true;
	            break;
	        }
	      }
	      return indentNextTokenOrTrivia;
	    }
	    function processTrivia(trivia, parent2, contextNode, dynamicIndentation) {
	      for (const triviaItem of trivia) {
	        if (isComment(triviaItem.kind) && rangeContainsRange(originalRange, triviaItem)) {
	          const triviaItemStart = sourceFile.getLineAndCharacterOfPosition(triviaItem.pos);
	          processRange(triviaItem, triviaItemStart, parent2, contextNode, dynamicIndentation);
	        }
	      }
	    }
	    function processRange(range, rangeStart, parent2, contextNode, dynamicIndentation) {
	      const rangeHasError = rangeContainsError(range);
	      let lineAction = 0 /* None */;
	      if (!rangeHasError) {
	        if (!previousRange) {
	          const originalStart = sourceFile.getLineAndCharacterOfPosition(originalRange.pos);
	          trimTrailingWhitespacesForLines(originalStart.line, rangeStart.line);
	        } else {
	          lineAction = processPair(range, rangeStart.line, parent2, previousRange, previousRangeStartLine, previousParent, contextNode, dynamicIndentation);
	        }
	      }
	      previousRange = range;
	      previousRangeTriviaEnd = range.end;
	      previousParent = parent2;
	      previousRangeStartLine = rangeStart.line;
	      return lineAction;
	    }
	    function processPair(currentItem, currentStartLine, currentParent, previousItem, previousStartLine, previousParent2, contextNode, dynamicIndentation) {
	      formattingContext.updateContext(previousItem, previousParent2, currentItem, currentParent, contextNode);
	      const rules = getRules(formattingContext);
	      let trimTrailingWhitespaces = formattingContext.options.trimTrailingWhitespace !== false;
	      let lineAction = 0 /* None */;
	      if (rules) {
	        forEachRight(rules, (rule2) => {
	          lineAction = applyRuleEdits(rule2, previousItem, previousStartLine, currentItem, currentStartLine);
	          if (dynamicIndentation) {
	            switch (lineAction) {
	              case 2 /* LineRemoved */:
	                if (currentParent.getStart(sourceFile) === currentItem.pos) {
	                  dynamicIndentation.recomputeIndentation(
	                    /*lineAddedByFormatting*/
	                    false,
	                    contextNode
	                  );
	                }
	                break;
	              case 1 /* LineAdded */:
	                if (currentParent.getStart(sourceFile) === currentItem.pos) {
	                  dynamicIndentation.recomputeIndentation(
	                    /*lineAddedByFormatting*/
	                    true,
	                    contextNode
	                  );
	                }
	                break;
	              default:
	                Debug.assert(lineAction === 0 /* None */);
	            }
	          }
	          trimTrailingWhitespaces = trimTrailingWhitespaces && !(rule2.action & 16 /* DeleteSpace */) && rule2.flags !== 1 /* CanDeleteNewLines */;
	        });
	      } else {
	        trimTrailingWhitespaces = trimTrailingWhitespaces && currentItem.kind !== 1 /* EndOfFileToken */;
	      }
	      if (currentStartLine !== previousStartLine && trimTrailingWhitespaces) {
	        trimTrailingWhitespacesForLines(previousStartLine, currentStartLine, previousItem);
	      }
	      return lineAction;
	    }
	    function insertIndentation(pos, indentation, lineAdded) {
	      const indentationString = getIndentationString(indentation, options);
	      if (lineAdded) {
	        recordReplace(pos, 0, indentationString);
	      } else {
	        const tokenStart = sourceFile.getLineAndCharacterOfPosition(pos);
	        const startLinePosition = getStartPositionOfLine(tokenStart.line, sourceFile);
	        if (indentation !== characterToColumn(startLinePosition, tokenStart.character) || indentationIsDifferent(indentationString, startLinePosition)) {
	          recordReplace(startLinePosition, tokenStart.character, indentationString);
	        }
	      }
	    }
	    function characterToColumn(startLinePosition, characterInLine) {
	      let column = 0;
	      for (let i = 0; i < characterInLine; i++) {
	        if (sourceFile.text.charCodeAt(startLinePosition + i) === 9 /* tab */) {
	          column += options.tabSize - column % options.tabSize;
	        } else {
	          column++;
	        }
	      }
	      return column;
	    }
	    function indentationIsDifferent(indentationString, startLinePosition) {
	      return indentationString !== sourceFile.text.substr(startLinePosition, indentationString.length);
	    }
	    function indentMultilineComment(commentRange, indentation, firstLineIsIndented, indentFinalLine = true) {
	      let startLine = sourceFile.getLineAndCharacterOfPosition(commentRange.pos).line;
	      const endLine = sourceFile.getLineAndCharacterOfPosition(commentRange.end).line;
	      if (startLine === endLine) {
	        if (!firstLineIsIndented) {
	          insertIndentation(
	            commentRange.pos,
	            indentation,
	            /*lineAdded*/
	            false
	          );
	        }
	        return;
	      }
	      const parts = [];
	      let startPos = commentRange.pos;
	      for (let line = startLine; line < endLine; line++) {
	        const endOfLine = getEndLinePosition(line, sourceFile);
	        parts.push({ pos: startPos, end: endOfLine });
	        startPos = getStartPositionOfLine(line + 1, sourceFile);
	      }
	      if (indentFinalLine) {
	        parts.push({ pos: startPos, end: commentRange.end });
	      }
	      if (parts.length === 0)
	        return;
	      const startLinePos = getStartPositionOfLine(startLine, sourceFile);
	      const nonWhitespaceColumnInFirstPart = SmartIndenter.findFirstNonWhitespaceCharacterAndColumn(startLinePos, parts[0].pos, sourceFile, options);
	      let startIndex = 0;
	      if (firstLineIsIndented) {
	        startIndex = 1;
	        startLine++;
	      }
	      const delta2 = indentation - nonWhitespaceColumnInFirstPart.column;
	      for (let i = startIndex; i < parts.length; i++, startLine++) {
	        const startLinePos2 = getStartPositionOfLine(startLine, sourceFile);
	        const nonWhitespaceCharacterAndColumn = i === 0 ? nonWhitespaceColumnInFirstPart : SmartIndenter.findFirstNonWhitespaceCharacterAndColumn(parts[i].pos, parts[i].end, sourceFile, options);
	        const newIndentation = nonWhitespaceCharacterAndColumn.column + delta2;
	        if (newIndentation > 0) {
	          const indentationString = getIndentationString(newIndentation, options);
	          recordReplace(startLinePos2, nonWhitespaceCharacterAndColumn.character, indentationString);
	        } else {
	          recordDelete(startLinePos2, nonWhitespaceCharacterAndColumn.character);
	        }
	      }
	    }
	    function trimTrailingWhitespacesForLines(line1, line2, range) {
	      for (let line = line1; line < line2; line++) {
	        const lineStartPosition = getStartPositionOfLine(line, sourceFile);
	        const lineEndPosition = getEndLinePosition(line, sourceFile);
	        if (range && (isComment(range.kind) || isStringOrRegularExpressionOrTemplateLiteral(range.kind)) && range.pos <= lineEndPosition && range.end > lineEndPosition) {
	          continue;
	        }
	        const whitespaceStart = getTrailingWhitespaceStartPosition(lineStartPosition, lineEndPosition);
	        if (whitespaceStart !== -1) {
	          Debug.assert(whitespaceStart === lineStartPosition || !isWhiteSpaceSingleLine(sourceFile.text.charCodeAt(whitespaceStart - 1)));
	          recordDelete(whitespaceStart, lineEndPosition + 1 - whitespaceStart);
	        }
	      }
	    }
	    function getTrailingWhitespaceStartPosition(start, end) {
	      let pos = end;
	      while (pos >= start && isWhiteSpaceSingleLine(sourceFile.text.charCodeAt(pos))) {
	        pos--;
	      }
	      if (pos !== end) {
	        return pos + 1;
	      }
	      return -1;
	    }
	    function trimTrailingWhitespacesForRemainingRange(trivias) {
	      let startPos = previousRange ? previousRange.end : originalRange.pos;
	      for (const trivia of trivias) {
	        if (isComment(trivia.kind)) {
	          if (startPos < trivia.pos) {
	            trimTrailingWitespacesForPositions(startPos, trivia.pos - 1, previousRange);
	          }
	          startPos = trivia.end + 1;
	        }
	      }
	      if (startPos < originalRange.end) {
	        trimTrailingWitespacesForPositions(startPos, originalRange.end, previousRange);
	      }
	    }
	    function trimTrailingWitespacesForPositions(startPos, endPos, previousRange2) {
	      const startLine = sourceFile.getLineAndCharacterOfPosition(startPos).line;
	      const endLine = sourceFile.getLineAndCharacterOfPosition(endPos).line;
	      trimTrailingWhitespacesForLines(startLine, endLine + 1, previousRange2);
	    }
	    function recordDelete(start, len) {
	      if (len) {
	        edits.push(createTextChangeFromStartLength(start, len, ""));
	      }
	    }
	    function recordReplace(start, len, newText) {
	      if (len || newText) {
	        edits.push(createTextChangeFromStartLength(start, len, newText));
	      }
	    }
	    function recordInsert(start, text) {
	      if (text) {
	        edits.push(createTextChangeFromStartLength(start, 0, text));
	      }
	    }
	    function applyRuleEdits(rule2, previousRange2, previousStartLine, currentRange, currentStartLine) {
	      const onLaterLine = currentStartLine !== previousStartLine;
	      switch (rule2.action) {
	        case 1 /* StopProcessingSpaceActions */:
	          return 0 /* None */;
	        case 16 /* DeleteSpace */:
	          if (previousRange2.end !== currentRange.pos) {
	            recordDelete(previousRange2.end, currentRange.pos - previousRange2.end);
	            return onLaterLine ? 2 /* LineRemoved */ : 0 /* None */;
	          }
	          break;
	        case 32 /* DeleteToken */:
	          recordDelete(previousRange2.pos, previousRange2.end - previousRange2.pos);
	          break;
	        case 8 /* InsertNewLine */:
	          if (rule2.flags !== 1 /* CanDeleteNewLines */ && previousStartLine !== currentStartLine) {
	            return 0 /* None */;
	          }
	          const lineDelta = currentStartLine - previousStartLine;
	          if (lineDelta !== 1) {
	            recordReplace(previousRange2.end, currentRange.pos - previousRange2.end, getNewLineOrDefaultFromHost(host, options));
	            return onLaterLine ? 0 /* None */ : 1 /* LineAdded */;
	          }
	          break;
	        case 4 /* InsertSpace */:
	          if (rule2.flags !== 1 /* CanDeleteNewLines */ && previousStartLine !== currentStartLine) {
	            return 0 /* None */;
	          }
	          const posDelta = currentRange.pos - previousRange2.end;
	          if (posDelta !== 1 || sourceFile.text.charCodeAt(previousRange2.end) !== 32 /* space */) {
	            recordReplace(previousRange2.end, currentRange.pos - previousRange2.end, " ");
	            return onLaterLine ? 2 /* LineRemoved */ : 0 /* None */;
	          }
	          break;
	        case 64 /* InsertTrailingSemicolon */:
	          recordInsert(previousRange2.end, ";");
	      }
	      return 0 /* None */;
	    }
	  }
	  function getRangeOfEnclosingComment(sourceFile, position, precedingToken, tokenAtPosition = getTokenAtPosition(sourceFile, position)) {
	    const jsdoc = findAncestor(tokenAtPosition, isJSDoc);
	    if (jsdoc)
	      tokenAtPosition = jsdoc.parent;
	    const tokenStart = tokenAtPosition.getStart(sourceFile);
	    if (tokenStart <= position && position < tokenAtPosition.getEnd()) {
	      return void 0;
	    }
	    precedingToken = precedingToken === null ? void 0 : precedingToken === void 0 ? findPrecedingToken(position, sourceFile) : precedingToken;
	    const trailingRangesOfPreviousToken = precedingToken && getTrailingCommentRanges(sourceFile.text, precedingToken.end);
	    const leadingCommentRangesOfNextToken = getLeadingCommentRangesOfNode(tokenAtPosition, sourceFile);
	    const commentRanges = concatenate(trailingRangesOfPreviousToken, leadingCommentRangesOfNextToken);
	    return commentRanges && find(commentRanges, (range) => rangeContainsPositionExclusive(range, position) || // The end marker of a single-line comment does not include the newline character.
	    // With caret at `^`, in the following case, we are inside a comment (^ denotes the cursor position):
	    //
	    //    // asdf   ^\n
	    //
	    // But for closed multi-line comments, we don't want to be inside the comment in the following case:
	    //
	    //    /* asdf */^
	    //
	    // However, unterminated multi-line comments *do* contain their end.
	    //
	    // Internally, we represent the end of the comment at the newline and closing '/', respectively.
	    //
	    position === range.end && (range.kind === 2 /* SingleLineCommentTrivia */ || position === sourceFile.getFullWidth()));
	  }
	  function getOpenTokenForList(node, list) {
	    switch (node.kind) {
	      case 176 /* Constructor */:
	      case 262 /* FunctionDeclaration */:
	      case 218 /* FunctionExpression */:
	      case 174 /* MethodDeclaration */:
	      case 173 /* MethodSignature */:
	      case 219 /* ArrowFunction */:
	      case 179 /* CallSignature */:
	      case 180 /* ConstructSignature */:
	      case 184 /* FunctionType */:
	      case 185 /* ConstructorType */:
	      case 177 /* GetAccessor */:
	      case 178 /* SetAccessor */:
	        if (node.typeParameters === list) {
	          return 30 /* LessThanToken */;
	        } else if (node.parameters === list) {
	          return 21 /* OpenParenToken */;
	        }
	        break;
	      case 213 /* CallExpression */:
	      case 214 /* NewExpression */:
	        if (node.typeArguments === list) {
	          return 30 /* LessThanToken */;
	        } else if (node.arguments === list) {
	          return 21 /* OpenParenToken */;
	        }
	        break;
	      case 263 /* ClassDeclaration */:
	      case 231 /* ClassExpression */:
	      case 264 /* InterfaceDeclaration */:
	      case 265 /* TypeAliasDeclaration */:
	        if (node.typeParameters === list) {
	          return 30 /* LessThanToken */;
	        }
	        break;
	      case 183 /* TypeReference */:
	      case 215 /* TaggedTemplateExpression */:
	      case 186 /* TypeQuery */:
	      case 233 /* ExpressionWithTypeArguments */:
	      case 205 /* ImportType */:
	        if (node.typeArguments === list) {
	          return 30 /* LessThanToken */;
	        }
	        break;
	      case 187 /* TypeLiteral */:
	        return 19 /* OpenBraceToken */;
	    }
	    return 0 /* Unknown */;
	  }
	  function getCloseTokenForOpenToken(kind) {
	    switch (kind) {
	      case 21 /* OpenParenToken */:
	        return 22 /* CloseParenToken */;
	      case 30 /* LessThanToken */:
	        return 32 /* GreaterThanToken */;
	      case 19 /* OpenBraceToken */:
	        return 20 /* CloseBraceToken */;
	    }
	    return 0 /* Unknown */;
	  }
	  function getIndentationString(indentation, options) {
	    const resetInternedStrings = !internedSizes || (internedSizes.tabSize !== options.tabSize || internedSizes.indentSize !== options.indentSize);
	    if (resetInternedStrings) {
	      internedSizes = { tabSize: options.tabSize, indentSize: options.indentSize };
	      internedTabsIndentation = internedSpacesIndentation = void 0;
	    }
	    if (!options.convertTabsToSpaces) {
	      const tabs = Math.floor(indentation / options.tabSize);
	      const spaces = indentation - tabs * options.tabSize;
	      let tabString;
	      if (!internedTabsIndentation) {
	        internedTabsIndentation = [];
	      }
	      if (internedTabsIndentation[tabs] === void 0) {
	        internedTabsIndentation[tabs] = tabString = repeatString("	", tabs);
	      } else {
	        tabString = internedTabsIndentation[tabs];
	      }
	      return spaces ? tabString + repeatString(" ", spaces) : tabString;
	    } else {
	      let spacesString;
	      const quotient = Math.floor(indentation / options.indentSize);
	      const remainder = indentation % options.indentSize;
	      if (!internedSpacesIndentation) {
	        internedSpacesIndentation = [];
	      }
	      if (internedSpacesIndentation[quotient] === void 0) {
	        spacesString = repeatString(" ", options.indentSize * quotient);
	        internedSpacesIndentation[quotient] = spacesString;
	      } else {
	        spacesString = internedSpacesIndentation[quotient];
	      }
	      return remainder ? spacesString + repeatString(" ", remainder) : spacesString;
	    }
	  }
	  var internedSizes, internedTabsIndentation, internedSpacesIndentation;
	  var init_formatting = __esm({
	    "src/services/formatting/formatting.ts"() {
	      init_ts4();
	      init_ts_formatting();
	    }
	  });

	  // src/services/formatting/smartIndenter.ts
	  var SmartIndenter;
	  var init_smartIndenter = __esm({
	    "src/services/formatting/smartIndenter.ts"() {
	      init_ts4();
	      init_ts_formatting();
	      ((SmartIndenter2) => {
	        let Value;
	        ((Value2) => {
	          Value2[Value2["Unknown"] = -1] = "Unknown";
	        })(Value || (Value = {}));
	        function getIndentation(position, sourceFile, options, assumeNewLineBeforeCloseBrace = false) {
	          if (position > sourceFile.text.length) {
	            return getBaseIndentation(options);
	          }
	          if (options.indentStyle === 0 /* None */) {
	            return 0;
	          }
	          const precedingToken = findPrecedingToken(
	            position,
	            sourceFile,
	            /*startNode*/
	            void 0,
	            /*excludeJsdoc*/
	            true
	          );
	          const enclosingCommentRange = getRangeOfEnclosingComment(sourceFile, position, precedingToken || null);
	          if (enclosingCommentRange && enclosingCommentRange.kind === 3 /* MultiLineCommentTrivia */) {
	            return getCommentIndent(sourceFile, position, options, enclosingCommentRange);
	          }
	          if (!precedingToken) {
	            return getBaseIndentation(options);
	          }
	          const precedingTokenIsLiteral = isStringOrRegularExpressionOrTemplateLiteral(precedingToken.kind);
	          if (precedingTokenIsLiteral && precedingToken.getStart(sourceFile) <= position && position < precedingToken.end) {
	            return 0;
	          }
	          const lineAtPosition = sourceFile.getLineAndCharacterOfPosition(position).line;
	          const currentToken = getTokenAtPosition(sourceFile, position);
	          const isObjectLiteral = currentToken.kind === 19 /* OpenBraceToken */ && currentToken.parent.kind === 210 /* ObjectLiteralExpression */;
	          if (options.indentStyle === 1 /* Block */ || isObjectLiteral) {
	            return getBlockIndent(sourceFile, position, options);
	          }
	          if (precedingToken.kind === 28 /* CommaToken */ && precedingToken.parent.kind !== 226 /* BinaryExpression */) {
	            const actualIndentation = getActualIndentationForListItemBeforeComma(precedingToken, sourceFile, options);
	            if (actualIndentation !== -1 /* Unknown */) {
	              return actualIndentation;
	            }
	          }
	          const containerList = getListByPosition(position, precedingToken.parent, sourceFile);
	          if (containerList && !rangeContainsRange(containerList, precedingToken)) {
	            const useTheSameBaseIndentation = [218 /* FunctionExpression */, 219 /* ArrowFunction */].includes(currentToken.parent.kind);
	            const indentSize = useTheSameBaseIndentation ? 0 : options.indentSize;
	            return getActualIndentationForListStartLine(containerList, sourceFile, options) + indentSize;
	          }
	          return getSmartIndent(sourceFile, position, precedingToken, lineAtPosition, assumeNewLineBeforeCloseBrace, options);
	        }
	        SmartIndenter2.getIndentation = getIndentation;
	        function getCommentIndent(sourceFile, position, options, enclosingCommentRange) {
	          const previousLine = getLineAndCharacterOfPosition(sourceFile, position).line - 1;
	          const commentStartLine = getLineAndCharacterOfPosition(sourceFile, enclosingCommentRange.pos).line;
	          Debug.assert(commentStartLine >= 0);
	          if (previousLine <= commentStartLine) {
	            return findFirstNonWhitespaceColumn(getStartPositionOfLine(commentStartLine, sourceFile), position, sourceFile, options);
	          }
	          const startPositionOfLine = getStartPositionOfLine(previousLine, sourceFile);
	          const { column, character } = findFirstNonWhitespaceCharacterAndColumn(startPositionOfLine, position, sourceFile, options);
	          if (column === 0) {
	            return column;
	          }
	          const firstNonWhitespaceCharacterCode = sourceFile.text.charCodeAt(startPositionOfLine + character);
	          return firstNonWhitespaceCharacterCode === 42 /* asterisk */ ? column - 1 : column;
	        }
	        function getBlockIndent(sourceFile, position, options) {
	          let current = position;
	          while (current > 0) {
	            const char = sourceFile.text.charCodeAt(current);
	            if (!isWhiteSpaceLike(char)) {
	              break;
	            }
	            current--;
	          }
	          const lineStart = getLineStartPositionForPosition(current, sourceFile);
	          return findFirstNonWhitespaceColumn(lineStart, current, sourceFile, options);
	        }
	        function getSmartIndent(sourceFile, position, precedingToken, lineAtPosition, assumeNewLineBeforeCloseBrace, options) {
	          let previous;
	          let current = precedingToken;
	          while (current) {
	            if (positionBelongsToNode(current, position, sourceFile) && shouldIndentChildNode(
	              options,
	              current,
	              previous,
	              sourceFile,
	              /*isNextChild*/
	              true
	            )) {
	              const currentStart = getStartLineAndCharacterForNode(current, sourceFile);
	              const nextTokenKind = nextTokenIsCurlyBraceOnSameLineAsCursor(precedingToken, current, lineAtPosition, sourceFile);
	              const indentationDelta = nextTokenKind !== 0 /* Unknown */ ? assumeNewLineBeforeCloseBrace && nextTokenKind === 2 /* CloseBrace */ ? options.indentSize : 0 : lineAtPosition !== currentStart.line ? options.indentSize : 0;
	              return getIndentationForNodeWorker(
	                current,
	                currentStart,
	                /*ignoreActualIndentationRange*/
	                void 0,
	                indentationDelta,
	                sourceFile,
	                /*isNextChild*/
	                true,
	                options
	              );
	            }
	            const actualIndentation = getActualIndentationForListItem(
	              current,
	              sourceFile,
	              options,
	              /*listIndentsChild*/
	              true
	            );
	            if (actualIndentation !== -1 /* Unknown */) {
	              return actualIndentation;
	            }
	            previous = current;
	            current = current.parent;
	          }
	          return getBaseIndentation(options);
	        }
	        function getIndentationForNode(n, ignoreActualIndentationRange, sourceFile, options) {
	          const start = sourceFile.getLineAndCharacterOfPosition(n.getStart(sourceFile));
	          return getIndentationForNodeWorker(
	            n,
	            start,
	            ignoreActualIndentationRange,
	            /*indentationDelta*/
	            0,
	            sourceFile,
	            /*isNextChild*/
	            false,
	            options
	          );
	        }
	        SmartIndenter2.getIndentationForNode = getIndentationForNode;
	        function getBaseIndentation(options) {
	          return options.baseIndentSize || 0;
	        }
	        SmartIndenter2.getBaseIndentation = getBaseIndentation;
	        function getIndentationForNodeWorker(current, currentStart, ignoreActualIndentationRange, indentationDelta, sourceFile, isNextChild, options) {
	          var _a;
	          let parent2 = current.parent;
	          while (parent2) {
	            let useActualIndentation = true;
	            if (ignoreActualIndentationRange) {
	              const start = current.getStart(sourceFile);
	              useActualIndentation = start < ignoreActualIndentationRange.pos || start > ignoreActualIndentationRange.end;
	            }
	            const containingListOrParentStart = getContainingListOrParentStart(parent2, current, sourceFile);
	            const parentAndChildShareLine = containingListOrParentStart.line === currentStart.line || childStartsOnTheSameLineWithElseInIfStatement(parent2, current, currentStart.line, sourceFile);
	            if (useActualIndentation) {
	              const firstListChild = (_a = getContainingList(current, sourceFile)) == null ? void 0 : _a[0];
	              const listIndentsChild = !!firstListChild && getStartLineAndCharacterForNode(firstListChild, sourceFile).line > containingListOrParentStart.line;
	              let actualIndentation = getActualIndentationForListItem(current, sourceFile, options, listIndentsChild);
	              if (actualIndentation !== -1 /* Unknown */) {
	                return actualIndentation + indentationDelta;
	              }
	              actualIndentation = getActualIndentationForNode(current, parent2, currentStart, parentAndChildShareLine, sourceFile, options);
	              if (actualIndentation !== -1 /* Unknown */) {
	                return actualIndentation + indentationDelta;
	              }
	            }
	            if (shouldIndentChildNode(options, parent2, current, sourceFile, isNextChild) && !parentAndChildShareLine) {
	              indentationDelta += options.indentSize;
	            }
	            const useTrueStart = isArgumentAndStartLineOverlapsExpressionBeingCalled(parent2, current, currentStart.line, sourceFile);
	            current = parent2;
	            parent2 = current.parent;
	            currentStart = useTrueStart ? sourceFile.getLineAndCharacterOfPosition(current.getStart(sourceFile)) : containingListOrParentStart;
	          }
	          return indentationDelta + getBaseIndentation(options);
	        }
	        function getContainingListOrParentStart(parent2, child, sourceFile) {
	          const containingList = getContainingList(child, sourceFile);
	          const startPos = containingList ? containingList.pos : parent2.getStart(sourceFile);
	          return sourceFile.getLineAndCharacterOfPosition(startPos);
	        }
	        function getActualIndentationForListItemBeforeComma(commaToken, sourceFile, options) {
	          const commaItemInfo = findListItemInfo(commaToken);
	          if (commaItemInfo && commaItemInfo.listItemIndex > 0) {
	            return deriveActualIndentationFromList(commaItemInfo.list.getChildren(), commaItemInfo.listItemIndex - 1, sourceFile, options);
	          } else {
	            return -1 /* Unknown */;
	          }
	        }
	        function getActualIndentationForNode(current, parent2, currentLineAndChar, parentAndChildShareLine, sourceFile, options) {
	          const useActualIndentation = (isDeclaration(current) || isStatementButNotDeclaration(current)) && (parent2.kind === 312 /* SourceFile */ || !parentAndChildShareLine);
	          if (!useActualIndentation) {
	            return -1 /* Unknown */;
	          }
	          return findColumnForFirstNonWhitespaceCharacterInLine(currentLineAndChar, sourceFile, options);
	        }
	        let NextTokenKind;
	        ((NextTokenKind2) => {
	          NextTokenKind2[NextTokenKind2["Unknown"] = 0] = "Unknown";
	          NextTokenKind2[NextTokenKind2["OpenBrace"] = 1] = "OpenBrace";
	          NextTokenKind2[NextTokenKind2["CloseBrace"] = 2] = "CloseBrace";
	        })(NextTokenKind || (NextTokenKind = {}));
	        function nextTokenIsCurlyBraceOnSameLineAsCursor(precedingToken, current, lineAtPosition, sourceFile) {
	          const nextToken = findNextToken(precedingToken, current, sourceFile);
	          if (!nextToken) {
	            return 0 /* Unknown */;
	          }
	          if (nextToken.kind === 19 /* OpenBraceToken */) {
	            return 1 /* OpenBrace */;
	          } else if (nextToken.kind === 20 /* CloseBraceToken */) {
	            const nextTokenStartLine = getStartLineAndCharacterForNode(nextToken, sourceFile).line;
	            return lineAtPosition === nextTokenStartLine ? 2 /* CloseBrace */ : 0 /* Unknown */;
	          }
	          return 0 /* Unknown */;
	        }
	        function getStartLineAndCharacterForNode(n, sourceFile) {
	          return sourceFile.getLineAndCharacterOfPosition(n.getStart(sourceFile));
	        }
	        function isArgumentAndStartLineOverlapsExpressionBeingCalled(parent2, child, childStartLine, sourceFile) {
	          if (!(isCallExpression(parent2) && contains(parent2.arguments, child))) {
	            return false;
	          }
	          const expressionOfCallExpressionEnd = parent2.expression.getEnd();
	          const expressionOfCallExpressionEndLine = getLineAndCharacterOfPosition(sourceFile, expressionOfCallExpressionEnd).line;
	          return expressionOfCallExpressionEndLine === childStartLine;
	        }
	        SmartIndenter2.isArgumentAndStartLineOverlapsExpressionBeingCalled = isArgumentAndStartLineOverlapsExpressionBeingCalled;
	        function childStartsOnTheSameLineWithElseInIfStatement(parent2, child, childStartLine, sourceFile) {
	          if (parent2.kind === 245 /* IfStatement */ && parent2.elseStatement === child) {
	            const elseKeyword = findChildOfKind(parent2, 93 /* ElseKeyword */, sourceFile);
	            Debug.assert(elseKeyword !== void 0);
	            const elseKeywordStartLine = getStartLineAndCharacterForNode(elseKeyword, sourceFile).line;
	            return elseKeywordStartLine === childStartLine;
	          }
	          return false;
	        }
	        SmartIndenter2.childStartsOnTheSameLineWithElseInIfStatement = childStartsOnTheSameLineWithElseInIfStatement;
	        function childIsUnindentedBranchOfConditionalExpression(parent2, child, childStartLine, sourceFile) {
	          if (isConditionalExpression(parent2) && (child === parent2.whenTrue || child === parent2.whenFalse)) {
	            const conditionEndLine = getLineAndCharacterOfPosition(sourceFile, parent2.condition.end).line;
	            if (child === parent2.whenTrue) {
	              return childStartLine === conditionEndLine;
	            } else {
	              const trueStartLine = getStartLineAndCharacterForNode(parent2.whenTrue, sourceFile).line;
	              const trueEndLine = getLineAndCharacterOfPosition(sourceFile, parent2.whenTrue.end).line;
	              return conditionEndLine === trueStartLine && trueEndLine === childStartLine;
	            }
	          }
	          return false;
	        }
	        SmartIndenter2.childIsUnindentedBranchOfConditionalExpression = childIsUnindentedBranchOfConditionalExpression;
	        function argumentStartsOnSameLineAsPreviousArgument(parent2, child, childStartLine, sourceFile) {
	          if (isCallOrNewExpression(parent2)) {
	            if (!parent2.arguments)
	              return false;
	            const currentNode = find(parent2.arguments, (arg) => arg.pos === child.pos);
	            if (!currentNode)
	              return false;
	            const currentIndex = parent2.arguments.indexOf(currentNode);
	            if (currentIndex === 0)
	              return false;
	            const previousNode = parent2.arguments[currentIndex - 1];
	            const lineOfPreviousNode = getLineAndCharacterOfPosition(sourceFile, previousNode.getEnd()).line;
	            if (childStartLine === lineOfPreviousNode) {
	              return true;
	            }
	          }
	          return false;
	        }
	        SmartIndenter2.argumentStartsOnSameLineAsPreviousArgument = argumentStartsOnSameLineAsPreviousArgument;
	        function getContainingList(node, sourceFile) {
	          return node.parent && getListByRange(node.getStart(sourceFile), node.getEnd(), node.parent, sourceFile);
	        }
	        SmartIndenter2.getContainingList = getContainingList;
	        function getListByPosition(pos, node, sourceFile) {
	          return node && getListByRange(pos, pos, node, sourceFile);
	        }
	        function getListByRange(start, end, node, sourceFile) {
	          switch (node.kind) {
	            case 183 /* TypeReference */:
	              return getList(node.typeArguments);
	            case 210 /* ObjectLiteralExpression */:
	              return getList(node.properties);
	            case 209 /* ArrayLiteralExpression */:
	              return getList(node.elements);
	            case 187 /* TypeLiteral */:
	              return getList(node.members);
	            case 262 /* FunctionDeclaration */:
	            case 218 /* FunctionExpression */:
	            case 219 /* ArrowFunction */:
	            case 174 /* MethodDeclaration */:
	            case 173 /* MethodSignature */:
	            case 179 /* CallSignature */:
	            case 176 /* Constructor */:
	            case 185 /* ConstructorType */:
	            case 180 /* ConstructSignature */:
	              return getList(node.typeParameters) || getList(node.parameters);
	            case 177 /* GetAccessor */:
	              return getList(node.parameters);
	            case 263 /* ClassDeclaration */:
	            case 231 /* ClassExpression */:
	            case 264 /* InterfaceDeclaration */:
	            case 265 /* TypeAliasDeclaration */:
	            case 352 /* JSDocTemplateTag */:
	              return getList(node.typeParameters);
	            case 214 /* NewExpression */:
	            case 213 /* CallExpression */:
	              return getList(node.typeArguments) || getList(node.arguments);
	            case 261 /* VariableDeclarationList */:
	              return getList(node.declarations);
	            case 275 /* NamedImports */:
	            case 279 /* NamedExports */:
	              return getList(node.elements);
	            case 206 /* ObjectBindingPattern */:
	            case 207 /* ArrayBindingPattern */:
	              return getList(node.elements);
	          }
	          function getList(list) {
	            return list && rangeContainsStartEnd(getVisualListRange(node, list, sourceFile), start, end) ? list : void 0;
	          }
	        }
	        function getVisualListRange(node, list, sourceFile) {
	          const children = node.getChildren(sourceFile);
	          for (let i = 1; i < children.length - 1; i++) {
	            if (children[i].pos === list.pos && children[i].end === list.end) {
	              return { pos: children[i - 1].end, end: children[i + 1].getStart(sourceFile) };
	            }
	          }
	          return list;
	        }
	        function getActualIndentationForListStartLine(list, sourceFile, options) {
	          if (!list) {
	            return -1 /* Unknown */;
	          }
	          return findColumnForFirstNonWhitespaceCharacterInLine(sourceFile.getLineAndCharacterOfPosition(list.pos), sourceFile, options);
	        }
	        function getActualIndentationForListItem(node, sourceFile, options, listIndentsChild) {
	          if (node.parent && node.parent.kind === 261 /* VariableDeclarationList */) {
	            return -1 /* Unknown */;
	          }
	          const containingList = getContainingList(node, sourceFile);
	          if (containingList) {
	            const index = containingList.indexOf(node);
	            if (index !== -1) {
	              const result = deriveActualIndentationFromList(containingList, index, sourceFile, options);
	              if (result !== -1 /* Unknown */) {
	                return result;
	              }
	            }
	            return getActualIndentationForListStartLine(containingList, sourceFile, options) + (listIndentsChild ? options.indentSize : 0);
	          }
	          return -1 /* Unknown */;
	        }
	        function deriveActualIndentationFromList(list, index, sourceFile, options) {
	          Debug.assert(index >= 0 && index < list.length);
	          const node = list[index];
	          let lineAndCharacter = getStartLineAndCharacterForNode(node, sourceFile);
	          for (let i = index - 1; i >= 0; i--) {
	            if (list[i].kind === 28 /* CommaToken */) {
	              continue;
	            }
	            const prevEndLine = sourceFile.getLineAndCharacterOfPosition(list[i].end).line;
	            if (prevEndLine !== lineAndCharacter.line) {
	              return findColumnForFirstNonWhitespaceCharacterInLine(lineAndCharacter, sourceFile, options);
	            }
	            lineAndCharacter = getStartLineAndCharacterForNode(list[i], sourceFile);
	          }
	          return -1 /* Unknown */;
	        }
	        function findColumnForFirstNonWhitespaceCharacterInLine(lineAndCharacter, sourceFile, options) {
	          const lineStart = sourceFile.getPositionOfLineAndCharacter(lineAndCharacter.line, 0);
	          return findFirstNonWhitespaceColumn(lineStart, lineStart + lineAndCharacter.character, sourceFile, options);
	        }
	        function findFirstNonWhitespaceCharacterAndColumn(startPos, endPos, sourceFile, options) {
	          let character = 0;
	          let column = 0;
	          for (let pos = startPos; pos < endPos; pos++) {
	            const ch = sourceFile.text.charCodeAt(pos);
	            if (!isWhiteSpaceSingleLine(ch)) {
	              break;
	            }
	            if (ch === 9 /* tab */) {
	              column += options.tabSize + column % options.tabSize;
	            } else {
	              column++;
	            }
	            character++;
	          }
	          return { column, character };
	        }
	        SmartIndenter2.findFirstNonWhitespaceCharacterAndColumn = findFirstNonWhitespaceCharacterAndColumn;
	        function findFirstNonWhitespaceColumn(startPos, endPos, sourceFile, options) {
	          return findFirstNonWhitespaceCharacterAndColumn(startPos, endPos, sourceFile, options).column;
	        }
	        SmartIndenter2.findFirstNonWhitespaceColumn = findFirstNonWhitespaceColumn;
	        function nodeWillIndentChild(settings, parent2, child, sourceFile, indentByDefault) {
	          const childKind = child ? child.kind : 0 /* Unknown */;
	          switch (parent2.kind) {
	            case 244 /* ExpressionStatement */:
	            case 263 /* ClassDeclaration */:
	            case 231 /* ClassExpression */:
	            case 264 /* InterfaceDeclaration */:
	            case 266 /* EnumDeclaration */:
	            case 265 /* TypeAliasDeclaration */:
	            case 209 /* ArrayLiteralExpression */:
	            case 241 /* Block */:
	            case 268 /* ModuleBlock */:
	            case 210 /* ObjectLiteralExpression */:
	            case 187 /* TypeLiteral */:
	            case 200 /* MappedType */:
	            case 189 /* TupleType */:
	            case 217 /* ParenthesizedExpression */:
	            case 211 /* PropertyAccessExpression */:
	            case 213 /* CallExpression */:
	            case 214 /* NewExpression */:
	            case 243 /* VariableStatement */:
	            case 277 /* ExportAssignment */:
	            case 253 /* ReturnStatement */:
	            case 227 /* ConditionalExpression */:
	            case 207 /* ArrayBindingPattern */:
	            case 206 /* ObjectBindingPattern */:
	            case 286 /* JsxOpeningElement */:
	            case 289 /* JsxOpeningFragment */:
	            case 285 /* JsxSelfClosingElement */:
	            case 294 /* JsxExpression */:
	            case 173 /* MethodSignature */:
	            case 179 /* CallSignature */:
	            case 180 /* ConstructSignature */:
	            case 169 /* Parameter */:
	            case 184 /* FunctionType */:
	            case 185 /* ConstructorType */:
	            case 196 /* ParenthesizedType */:
	            case 215 /* TaggedTemplateExpression */:
	            case 223 /* AwaitExpression */:
	            case 279 /* NamedExports */:
	            case 275 /* NamedImports */:
	            case 281 /* ExportSpecifier */:
	            case 276 /* ImportSpecifier */:
	            case 172 /* PropertyDeclaration */:
	            case 296 /* CaseClause */:
	            case 297 /* DefaultClause */:
	              return true;
	            case 269 /* CaseBlock */:
	              return settings.indentSwitchCase ?? true;
	            case 260 /* VariableDeclaration */:
	            case 303 /* PropertyAssignment */:
	            case 226 /* BinaryExpression */:
	              if (!settings.indentMultiLineObjectLiteralBeginningOnBlankLine && sourceFile && childKind === 210 /* ObjectLiteralExpression */) {
	                return rangeIsOnOneLine(sourceFile, child);
	              }
	              if (parent2.kind === 226 /* BinaryExpression */ && sourceFile && child && childKind === 284 /* JsxElement */) {
	                const parentStartLine = sourceFile.getLineAndCharacterOfPosition(skipTrivia(sourceFile.text, parent2.pos)).line;
	                const childStartLine = sourceFile.getLineAndCharacterOfPosition(skipTrivia(sourceFile.text, child.pos)).line;
	                return parentStartLine !== childStartLine;
	              }
	              if (parent2.kind !== 226 /* BinaryExpression */) {
	                return true;
	              }
	              break;
	            case 246 /* DoStatement */:
	            case 247 /* WhileStatement */:
	            case 249 /* ForInStatement */:
	            case 250 /* ForOfStatement */:
	            case 248 /* ForStatement */:
	            case 245 /* IfStatement */:
	            case 262 /* FunctionDeclaration */:
	            case 218 /* FunctionExpression */:
	            case 174 /* MethodDeclaration */:
	            case 176 /* Constructor */:
	            case 177 /* GetAccessor */:
	            case 178 /* SetAccessor */:
	              return childKind !== 241 /* Block */;
	            case 219 /* ArrowFunction */:
	              if (sourceFile && childKind === 217 /* ParenthesizedExpression */) {
	                return rangeIsOnOneLine(sourceFile, child);
	              }
	              return childKind !== 241 /* Block */;
	            case 278 /* ExportDeclaration */:
	              return childKind !== 279 /* NamedExports */;
	            case 272 /* ImportDeclaration */:
	              return childKind !== 273 /* ImportClause */ || !!child.namedBindings && child.namedBindings.kind !== 275 /* NamedImports */;
	            case 284 /* JsxElement */:
	              return childKind !== 287 /* JsxClosingElement */;
	            case 288 /* JsxFragment */:
	              return childKind !== 290 /* JsxClosingFragment */;
	            case 193 /* IntersectionType */:
	            case 192 /* UnionType */:
	              if (childKind === 187 /* TypeLiteral */ || childKind === 189 /* TupleType */) {
	                return false;
	              }
	              break;
	          }
	          return indentByDefault;
	        }
	        SmartIndenter2.nodeWillIndentChild = nodeWillIndentChild;
	        function isControlFlowEndingStatement(kind, parent2) {
	          switch (kind) {
	            case 253 /* ReturnStatement */:
	            case 257 /* ThrowStatement */:
	            case 251 /* ContinueStatement */:
	            case 252 /* BreakStatement */:
	              return parent2.kind !== 241 /* Block */;
	            default:
	              return false;
	          }
	        }
	        function shouldIndentChildNode(settings, parent2, child, sourceFile, isNextChild = false) {
	          return nodeWillIndentChild(
	            settings,
	            parent2,
	            child,
	            sourceFile,
	            /*indentByDefault*/
	            false
	          ) && !(isNextChild && child && isControlFlowEndingStatement(child.kind, parent2));
	        }
	        SmartIndenter2.shouldIndentChildNode = shouldIndentChildNode;
	        function rangeIsOnOneLine(sourceFile, range) {
	          const rangeStart = skipTrivia(sourceFile.text, range.pos);
	          const startLine = sourceFile.getLineAndCharacterOfPosition(rangeStart).line;
	          const endLine = sourceFile.getLineAndCharacterOfPosition(range.end).line;
	          return startLine === endLine;
	        }
	      })(SmartIndenter || (SmartIndenter = {}));
	    }
	  });

	  // src/services/_namespaces/ts.formatting.ts
	  var ts_formatting_exports = {};
	  __export(ts_formatting_exports, {
	    FormattingContext: () => FormattingContext,
	    FormattingRequestKind: () => FormattingRequestKind,
	    RuleAction: () => RuleAction,
	    RuleFlags: () => RuleFlags,
	    SmartIndenter: () => SmartIndenter,
	    anyContext: () => anyContext,
	    createTextRangeWithKind: () => createTextRangeWithKind,
	    formatDocument: () => formatDocument,
	    formatNodeGivenIndentation: () => formatNodeGivenIndentation,
	    formatOnClosingCurly: () => formatOnClosingCurly,
	    formatOnEnter: () => formatOnEnter,
	    formatOnOpeningCurly: () => formatOnOpeningCurly,
	    formatOnSemicolon: () => formatOnSemicolon,
	    formatSelection: () => formatSelection,
	    getAllRules: () => getAllRules,
	    getFormatContext: () => getFormatContext,
	    getFormattingScanner: () => getFormattingScanner,
	    getIndentationString: () => getIndentationString,
	    getRangeOfEnclosingComment: () => getRangeOfEnclosingComment
	  });
	  var init_ts_formatting = __esm({
	    "src/services/_namespaces/ts.formatting.ts"() {
	      init_formattingContext();
	      init_formattingScanner();
	      init_rule();
	      init_rules();
	      init_rulesMap();
	      init_formatting();
	      init_smartIndenter();
	    }
	  });

	  // src/services/_namespaces/ts.ts
	  var init_ts4 = __esm({
	    "src/services/_namespaces/ts.ts"() {
	      init_ts2();
	      init_ts3();
	      init_types3();
	      init_utilities4();
	      init_exportInfoMap();
	      init_classifier();
	      init_documentHighlights();
	      init_documentRegistry();
	      init_getEditsForFileRename();
	      init_patternMatcher();
	      init_preProcess();
	      init_sourcemaps();
	      init_suggestionDiagnostics();
	      init_transpile();
	      init_services();
	      init_transform();
	      init_ts_BreakpointResolver();
	      init_ts_CallHierarchy();
	      init_ts_classifier();
	      init_ts_codefix();
	      init_ts_Completions();
	      init_ts_FindAllReferences();
	      init_ts_GoToDefinition();
	      init_ts_InlayHints();
	      init_ts_JsDoc();
	      init_ts_NavigateTo();
	      init_ts_NavigationBar();
	      init_ts_OrganizeImports();
	      init_ts_OutliningElementsCollector();
	      init_ts_refactor();
	      init_ts_Rename();
	      init_ts_SignatureHelp();
	      init_ts_SmartSelectionRange();
	      init_ts_SymbolDisplay();
	      init_ts_textChanges();
	      init_ts_formatting();
	    }
	  });

	  // src/deprecatedCompat/deprecate.ts
	  function getTypeScriptVersion() {
	    return typeScriptVersion2 ?? (typeScriptVersion2 = new Version(version));
	  }
	  function formatDeprecationMessage(name, error2, errorAfter, since, message) {
	    let deprecationMessage = error2 ? "DeprecationError: " : "DeprecationWarning: ";
	    deprecationMessage += `'${name}' `;
	    deprecationMessage += since ? `has been deprecated since v${since}` : "is deprecated";
	    deprecationMessage += error2 ? " and can no longer be used." : errorAfter ? ` and will no longer be usable after v${errorAfter}.` : ".";
	    deprecationMessage += message ? ` ${formatStringFromArgs(message, [name])}` : "";
	    return deprecationMessage;
	  }
	  function createErrorDeprecation(name, errorAfter, since, message) {
	    const deprecationMessage = formatDeprecationMessage(
	      name,
	      /*error*/
	      true,
	      errorAfter,
	      since,
	      message
	    );
	    return () => {
	      throw new TypeError(deprecationMessage);
	    };
	  }
	  function createWarningDeprecation(name, errorAfter, since, message) {
	    let hasWrittenDeprecation = false;
	    return () => {
	      if (enableDeprecationWarnings && !hasWrittenDeprecation) {
	        Debug.log.warn(formatDeprecationMessage(
	          name,
	          /*error*/
	          false,
	          errorAfter,
	          since,
	          message
	        ));
	        hasWrittenDeprecation = true;
	      }
	    };
	  }
	  function createDeprecation(name, options = {}) {
	    const version2 = typeof options.typeScriptVersion === "string" ? new Version(options.typeScriptVersion) : options.typeScriptVersion ?? getTypeScriptVersion();
	    const errorAfter = typeof options.errorAfter === "string" ? new Version(options.errorAfter) : options.errorAfter;
	    const warnAfter = typeof options.warnAfter === "string" ? new Version(options.warnAfter) : options.warnAfter;
	    const since = typeof options.since === "string" ? new Version(options.since) : options.since ?? warnAfter;
	    const error2 = options.error || errorAfter && version2.compareTo(errorAfter) >= 0;
	    const warn = !warnAfter || version2.compareTo(warnAfter) >= 0;
	    return error2 ? createErrorDeprecation(name, errorAfter, since, options.message) : warn ? createWarningDeprecation(name, errorAfter, since, options.message) : noop;
	  }
	  function wrapFunction(deprecation, func) {
	    return function() {
	      deprecation();
	      return func.apply(this, arguments);
	    };
	  }
	  function deprecate(func, options) {
	    const deprecation = createDeprecation((options == null ? void 0 : options.name) ?? Debug.getFunctionName(func), options);
	    return wrapFunction(deprecation, func);
	  }
	  var enableDeprecationWarnings, typeScriptVersion2;
	  var init_deprecate = __esm({
	    "src/deprecatedCompat/deprecate.ts"() {
	      init_ts5();
	      enableDeprecationWarnings = true;
	    }
	  });

	  // src/deprecatedCompat/deprecations.ts
	  function createOverload(name, overloads, binder2, deprecations) {
	    Object.defineProperty(call, "name", { ...Object.getOwnPropertyDescriptor(call, "name"), value: name });
	    if (deprecations) {
	      for (const key of Object.keys(deprecations)) {
	        const index = +key;
	        if (!isNaN(index) && hasProperty(overloads, `${index}`)) {
	          overloads[index] = deprecate(overloads[index], { ...deprecations[index], name });
	        }
	      }
	    }
	    const bind = createBinder2(overloads, binder2);
	    return call;
	    function call(...args) {
	      const index = bind(args);
	      const fn = index !== void 0 ? overloads[index] : void 0;
	      if (typeof fn === "function") {
	        return fn(...args);
	      }
	      throw new TypeError("Invalid arguments");
	    }
	  }
	  function createBinder2(overloads, binder2) {
	    return (args) => {
	      for (let i = 0; hasProperty(overloads, `${i}`) && hasProperty(binder2, `${i}`); i++) {
	        const fn = binder2[i];
	        if (fn(args)) {
	          return i;
	        }
	      }
	    };
	  }
	  function buildOverload(name) {
	    return {
	      overload: (overloads) => ({
	        bind: (binder2) => ({
	          finish: () => createOverload(name, overloads, binder2),
	          deprecate: (deprecations) => ({
	            finish: () => createOverload(name, overloads, binder2, deprecations)
	          })
	        })
	      })
	    };
	  }
	  var init_deprecations = __esm({
	    "src/deprecatedCompat/deprecations.ts"() {
	      init_ts5();
	      init_deprecate();
	    }
	  });

	  // src/deprecatedCompat/5.0/identifierProperties.ts
	  var init_identifierProperties = __esm({
	    "src/deprecatedCompat/5.0/identifierProperties.ts"() {
	      init_ts5();
	      init_deprecate();
	      addObjectAllocatorPatcher((objectAllocator2) => {
	        const Identifier79 = objectAllocator2.getIdentifierConstructor();
	        if (!hasProperty(Identifier79.prototype, "originalKeywordKind")) {
	          Object.defineProperty(Identifier79.prototype, "originalKeywordKind", {
	            get: deprecate(function() {
	              return identifierToKeywordKind(this);
	            }, {
	              name: "originalKeywordKind",
	              since: "5.0",
	              warnAfter: "5.1",
	              errorAfter: "5.2",
	              message: "Use 'identifierToKeywordKind(identifier)' instead."
	            })
	          });
	        }
	        if (!hasProperty(Identifier79.prototype, "isInJSDocNamespace")) {
	          Object.defineProperty(Identifier79.prototype, "isInJSDocNamespace", {
	            get: deprecate(function() {
	              return this.flags & 4096 /* IdentifierIsInJSDocNamespace */ ? true : void 0;
	            }, {
	              name: "isInJSDocNamespace",
	              since: "5.0",
	              warnAfter: "5.1",
	              errorAfter: "5.2",
	              message: "Use '.parent' or the surrounding context to determine this instead."
	            })
	          });
	        }
	      });
	    }
	  });

	  // src/deprecatedCompat/_namespaces/ts.ts
	  var init_ts5 = __esm({
	    "src/deprecatedCompat/_namespaces/ts.ts"() {
	      init_ts2();
	      init_deprecations();
	      init_identifierProperties();
	    }
	  });

	  // src/typingsInstallerCore/_namespaces/ts.ts
	  var init_ts6 = __esm({
	    "src/typingsInstallerCore/_namespaces/ts.ts"() {
	      init_ts2();
	      init_ts3();
	      init_ts_server2();
	    }
	  });

	  // src/typingsInstallerCore/typingsInstaller.ts
	  function typingToFileName(cachePath, packageName, installTypingHost, log) {
	    try {
	      const result = resolveModuleName(packageName, combinePaths(cachePath, "index.d.ts"), { moduleResolution: 2 /* Node10 */ }, installTypingHost);
	      return result.resolvedModule && result.resolvedModule.resolvedFileName;
	    } catch (e) {
	      if (log.isEnabled()) {
	        log.writeLine(`Failed to resolve ${packageName} in folder '${cachePath}': ${e.message}`);
	      }
	      return void 0;
	    }
	  }
	  function installNpmPackages(npmPath, tsVersion, packageNames, install) {
	    let hasError = false;
	    for (let remaining = packageNames.length; remaining > 0; ) {
	      const result = getNpmCommandForInstallation(npmPath, tsVersion, packageNames, remaining);
	      remaining = result.remaining;
	      hasError = install(result.command) || hasError;
	    }
	    return hasError;
	  }
	  function getNpmCommandForInstallation(npmPath, tsVersion, packageNames, remaining) {
	    const sliceStart = packageNames.length - remaining;
	    let command, toSlice = remaining;
	    while (true) {
	      command = `${npmPath} install --ignore-scripts ${(toSlice === packageNames.length ? packageNames : packageNames.slice(sliceStart, sliceStart + toSlice)).join(" ")} --save-dev --user-agent="typesInstaller/${tsVersion}"`;
	      if (command.length < 8e3) {
	        break;
	      }
	      toSlice = toSlice - Math.floor(toSlice / 2);
	    }
	    return { command, remaining: remaining - toSlice };
	  }
	  function typingsName(packageName) {
	    return `@types/${packageName}@ts${versionMajorMinor}`;
	  }
	  var nullLog, TypingsInstaller;
	  var init_typingsInstaller = __esm({
	    "src/typingsInstallerCore/typingsInstaller.ts"() {
	      init_ts6();
	      init_ts_server2();
	      nullLog = {
	        isEnabled: () => false,
	        writeLine: noop
	      };
	      TypingsInstaller = class {
	        constructor(installTypingHost, globalCachePath, safeListPath, typesMapLocation, throttleLimit, log = nullLog) {
	          this.installTypingHost = installTypingHost;
	          this.globalCachePath = globalCachePath;
	          this.safeListPath = safeListPath;
	          this.typesMapLocation = typesMapLocation;
	          this.throttleLimit = throttleLimit;
	          this.log = log;
	          this.packageNameToTypingLocation = /* @__PURE__ */ new Map();
	          this.missingTypingsSet = /* @__PURE__ */ new Set();
	          this.knownCachesSet = /* @__PURE__ */ new Set();
	          this.projectWatchers = /* @__PURE__ */ new Map();
	          /** @internal */
	          this.pendingRunRequests = [];
	          this.installRunCount = 1;
	          this.inFlightRequestCount = 0;
	          this.latestDistTag = "latest";
	          const isLoggingEnabled = this.log.isEnabled();
	          if (isLoggingEnabled) {
	            this.log.writeLine(`Global cache location '${globalCachePath}', safe file path '${safeListPath}', types map path ${typesMapLocation}`);
	          }
	          this.processCacheLocation(this.globalCachePath);
	        }
	        /** @internal */
	        handleRequest(req) {
	          switch (req.kind) {
	            case "discover":
	              this.install(req);
	              break;
	            case "closeProject":
	              this.closeProject(req);
	              break;
	            case "typesRegistry": {
	              const typesRegistry = {};
	              this.typesRegistry.forEach((value, key) => {
	                typesRegistry[key] = value;
	              });
	              const response = { kind: EventTypesRegistry, typesRegistry };
	              this.sendResponse(response);
	              break;
	            }
	            case "installPackage": {
	              this.installPackage(req);
	              break;
	            }
	            default:
	              Debug.assertNever(req);
	          }
	        }
	        closeProject(req) {
	          this.closeWatchers(req.projectName);
	        }
	        closeWatchers(projectName) {
	          if (this.log.isEnabled()) {
	            this.log.writeLine(`Closing file watchers for project '${projectName}'`);
	          }
	          const watchers = this.projectWatchers.get(projectName);
	          if (!watchers) {
	            if (this.log.isEnabled()) {
	              this.log.writeLine(`No watchers are registered for project '${projectName}'`);
	            }
	            return;
	          }
	          this.projectWatchers.delete(projectName);
	          this.sendResponse({ kind: ActionWatchTypingLocations, projectName, files: [] });
	          if (this.log.isEnabled()) {
	            this.log.writeLine(`Closing file watchers for project '${projectName}' - done.`);
	          }
	        }
	        install(req) {
	          if (this.log.isEnabled()) {
	            this.log.writeLine(`Got install request${stringifyIndented(req)}`);
	          }
	          if (req.cachePath) {
	            if (this.log.isEnabled()) {
	              this.log.writeLine(`Request specifies cache path '${req.cachePath}', loading cached information...`);
	            }
	            this.processCacheLocation(req.cachePath);
	          }
	          if (this.safeList === void 0) {
	            this.initializeSafeList();
	          }
	          const discoverTypingsResult = ts_JsTyping_exports.discoverTypings(
	            this.installTypingHost,
	            this.log.isEnabled() ? (s) => this.log.writeLine(s) : void 0,
	            req.fileNames,
	            req.projectRootPath,
	            this.safeList,
	            this.packageNameToTypingLocation,
	            req.typeAcquisition,
	            req.unresolvedImports,
	            this.typesRegistry,
	            req.compilerOptions
	          );
	          this.watchFiles(req.projectName, discoverTypingsResult.filesToWatch);
	          if (discoverTypingsResult.newTypingNames.length) {
	            this.installTypings(req, req.cachePath || this.globalCachePath, discoverTypingsResult.cachedTypingPaths, discoverTypingsResult.newTypingNames);
	          } else {
	            this.sendResponse(this.createSetTypings(req, discoverTypingsResult.cachedTypingPaths));
	            if (this.log.isEnabled()) {
	              this.log.writeLine(`No new typings were requested as a result of typings discovery`);
	            }
	          }
	        }
	        /** @internal */
	        installPackage(req) {
	          const { fileName, packageName, projectName, projectRootPath, id } = req;
	          const cwd = forEachAncestorDirectory(getDirectoryPath(fileName), (directory) => {
	            if (this.installTypingHost.fileExists(combinePaths(directory, "package.json"))) {
	              return directory;
	            }
	          }) || projectRootPath;
	          if (cwd) {
	            this.installWorker(-1, [packageName], cwd, (success) => {
	              const message = success ? `Package ${packageName} installed.` : `There was an error installing ${packageName}.`;
	              const response = {
	                kind: ActionPackageInstalled,
	                projectName,
	                id,
	                success,
	                message
	              };
	              this.sendResponse(response);
	            });
	          } else {
	            const response = {
	              kind: ActionPackageInstalled,
	              projectName,
	              id,
	              success: false,
	              message: "Could not determine a project root path."
	            };
	            this.sendResponse(response);
	          }
	        }
	        initializeSafeList() {
	          if (this.typesMapLocation) {
	            const safeListFromMap = ts_JsTyping_exports.loadTypesMap(this.installTypingHost, this.typesMapLocation);
	            if (safeListFromMap) {
	              this.log.writeLine(`Loaded safelist from types map file '${this.typesMapLocation}'`);
	              this.safeList = safeListFromMap;
	              return;
	            }
	            this.log.writeLine(`Failed to load safelist from types map file '${this.typesMapLocation}'`);
	          }
	          this.safeList = ts_JsTyping_exports.loadSafeList(this.installTypingHost, this.safeListPath);
	        }
	        processCacheLocation(cacheLocation) {
	          if (this.log.isEnabled()) {
	            this.log.writeLine(`Processing cache location '${cacheLocation}'`);
	          }
	          if (this.knownCachesSet.has(cacheLocation)) {
	            if (this.log.isEnabled()) {
	              this.log.writeLine(`Cache location was already processed...`);
	            }
	            return;
	          }
	          const packageJson = combinePaths(cacheLocation, "package.json");
	          const packageLockJson = combinePaths(cacheLocation, "package-lock.json");
	          if (this.log.isEnabled()) {
	            this.log.writeLine(`Trying to find '${packageJson}'...`);
	          }
	          if (this.installTypingHost.fileExists(packageJson) && this.installTypingHost.fileExists(packageLockJson)) {
	            const npmConfig = JSON.parse(this.installTypingHost.readFile(packageJson));
	            const npmLock = JSON.parse(this.installTypingHost.readFile(packageLockJson));
	            if (this.log.isEnabled()) {
	              this.log.writeLine(`Loaded content of '${packageJson}':${stringifyIndented(npmConfig)}`);
	              this.log.writeLine(`Loaded content of '${packageLockJson}':${stringifyIndented(npmLock)}`);
	            }
	            if (npmConfig.devDependencies && npmLock.dependencies) {
	              for (const key in npmConfig.devDependencies) {
	                if (!hasProperty(npmLock.dependencies, key)) {
	                  continue;
	                }
	                const packageName = getBaseFileName(key);
	                if (!packageName) {
	                  continue;
	                }
	                const typingFile = typingToFileName(cacheLocation, packageName, this.installTypingHost, this.log);
	                if (!typingFile) {
	                  this.missingTypingsSet.add(packageName);
	                  continue;
	                }
	                const existingTypingFile = this.packageNameToTypingLocation.get(packageName);
	                if (existingTypingFile) {
	                  if (existingTypingFile.typingLocation === typingFile) {
	                    continue;
	                  }
	                  if (this.log.isEnabled()) {
	                    this.log.writeLine(`New typing for package ${packageName} from '${typingFile}' conflicts with existing typing file '${existingTypingFile}'`);
	                  }
	                }
	                if (this.log.isEnabled()) {
	                  this.log.writeLine(`Adding entry into typings cache: '${packageName}' => '${typingFile}'`);
	                }
	                const info = getProperty(npmLock.dependencies, key);
	                const version2 = info && info.version;
	                if (!version2) {
	                  continue;
	                }
	                const newTyping = { typingLocation: typingFile, version: new Version(version2) };
	                this.packageNameToTypingLocation.set(packageName, newTyping);
	              }
	            }
	          }
	          if (this.log.isEnabled()) {
	            this.log.writeLine(`Finished processing cache location '${cacheLocation}'`);
	          }
	          this.knownCachesSet.add(cacheLocation);
	        }
	        filterTypings(typingsToInstall) {
	          return mapDefined(typingsToInstall, (typing) => {
	            const typingKey = mangleScopedPackageName(typing);
	            if (this.missingTypingsSet.has(typingKey)) {
	              if (this.log.isEnabled())
	                this.log.writeLine(`'${typing}':: '${typingKey}' is in missingTypingsSet - skipping...`);
	              return void 0;
	            }
	            const validationResult = ts_JsTyping_exports.validatePackageName(typing);
	            if (validationResult !== ts_JsTyping_exports.NameValidationResult.Ok) {
	              this.missingTypingsSet.add(typingKey);
	              if (this.log.isEnabled())
	                this.log.writeLine(ts_JsTyping_exports.renderPackageNameValidationFailure(validationResult, typing));
	              return void 0;
	            }
	            if (!this.typesRegistry.has(typingKey)) {
	              if (this.log.isEnabled())
	                this.log.writeLine(`'${typing}':: Entry for package '${typingKey}' does not exist in local types registry - skipping...`);
	              return void 0;
	            }
	            if (this.packageNameToTypingLocation.get(typingKey) && ts_JsTyping_exports.isTypingUpToDate(this.packageNameToTypingLocation.get(typingKey), this.typesRegistry.get(typingKey))) {
	              if (this.log.isEnabled())
	                this.log.writeLine(`'${typing}':: '${typingKey}' already has an up-to-date typing - skipping...`);
	              return void 0;
	            }
	            return typingKey;
	          });
	        }
	        ensurePackageDirectoryExists(directory) {
	          const npmConfigPath = combinePaths(directory, "package.json");
	          if (this.log.isEnabled()) {
	            this.log.writeLine(`Npm config file: ${npmConfigPath}`);
	          }
	          if (!this.installTypingHost.fileExists(npmConfigPath)) {
	            if (this.log.isEnabled()) {
	              this.log.writeLine(`Npm config file: '${npmConfigPath}' is missing, creating new one...`);
	            }
	            this.ensureDirectoryExists(directory, this.installTypingHost);
	            this.installTypingHost.writeFile(npmConfigPath, '{ "private": true }');
	          }
	        }
	        installTypings(req, cachePath, currentlyCachedTypings, typingsToInstall) {
	          if (this.log.isEnabled()) {
	            this.log.writeLine(`Installing typings ${JSON.stringify(typingsToInstall)}`);
	          }
	          const filteredTypings = this.filterTypings(typingsToInstall);
	          if (filteredTypings.length === 0) {
	            if (this.log.isEnabled()) {
	              this.log.writeLine(`All typings are known to be missing or invalid - no need to install more typings`);
	            }
	            this.sendResponse(this.createSetTypings(req, currentlyCachedTypings));
	            return;
	          }
	          this.ensurePackageDirectoryExists(cachePath);
	          const requestId = this.installRunCount;
	          this.installRunCount++;
	          this.sendResponse({
	            kind: EventBeginInstallTypes,
	            eventId: requestId,
	            typingsInstallerVersion: version,
	            projectName: req.projectName
	          });
	          const scopedTypings = filteredTypings.map(typingsName);
	          this.installTypingsAsync(requestId, scopedTypings, cachePath, (ok) => {
	            try {
	              if (!ok) {
	                if (this.log.isEnabled()) {
	                  this.log.writeLine(`install request failed, marking packages as missing to prevent repeated requests: ${JSON.stringify(filteredTypings)}`);
	                }
	                for (const typing of filteredTypings) {
	                  this.missingTypingsSet.add(typing);
	                }
	                return;
	              }
	              if (this.log.isEnabled()) {
	                this.log.writeLine(`Installed typings ${JSON.stringify(scopedTypings)}`);
	              }
	              const installedTypingFiles = [];
	              for (const packageName of filteredTypings) {
	                const typingFile = typingToFileName(cachePath, packageName, this.installTypingHost, this.log);
	                if (!typingFile) {
	                  this.missingTypingsSet.add(packageName);
	                  continue;
	                }
	                const distTags = this.typesRegistry.get(packageName);
	                const newVersion = new Version(distTags[`ts${versionMajorMinor}`] || distTags[this.latestDistTag]);
	                const newTyping = { typingLocation: typingFile, version: newVersion };
	                this.packageNameToTypingLocation.set(packageName, newTyping);
	                installedTypingFiles.push(typingFile);
	              }
	              if (this.log.isEnabled()) {
	                this.log.writeLine(`Installed typing files ${JSON.stringify(installedTypingFiles)}`);
	              }
	              this.sendResponse(this.createSetTypings(req, currentlyCachedTypings.concat(installedTypingFiles)));
	            } finally {
	              const response = {
	                kind: EventEndInstallTypes,
	                eventId: requestId,
	                projectName: req.projectName,
	                packagesToInstall: scopedTypings,
	                installSuccess: ok,
	                typingsInstallerVersion: version
	              };
	              this.sendResponse(response);
	            }
	          });
	        }
	        ensureDirectoryExists(directory, host) {
	          const directoryName = getDirectoryPath(directory);
	          if (!host.directoryExists(directoryName)) {
	            this.ensureDirectoryExists(directoryName, host);
	          }
	          if (!host.directoryExists(directory)) {
	            host.createDirectory(directory);
	          }
	        }
	        watchFiles(projectName, files) {
	          if (!files.length) {
	            this.closeWatchers(projectName);
	            return;
	          }
	          const existing = this.projectWatchers.get(projectName);
	          const newSet = new Set(files);
	          if (!existing || forEachKey(newSet, (s) => !existing.has(s)) || forEachKey(existing, (s) => !newSet.has(s))) {
	            this.projectWatchers.set(projectName, newSet);
	            this.sendResponse({ kind: ActionWatchTypingLocations, projectName, files });
	          } else {
	            this.sendResponse({ kind: ActionWatchTypingLocations, projectName, files: void 0 });
	          }
	        }
	        createSetTypings(request, typings) {
	          return {
	            projectName: request.projectName,
	            typeAcquisition: request.typeAcquisition,
	            compilerOptions: request.compilerOptions,
	            typings,
	            unresolvedImports: request.unresolvedImports,
	            kind: ActionSet
	          };
	        }
	        installTypingsAsync(requestId, packageNames, cwd, onRequestCompleted) {
	          this.pendingRunRequests.unshift({ requestId, packageNames, cwd, onRequestCompleted });
	          this.executeWithThrottling();
	        }
	        executeWithThrottling() {
	          while (this.inFlightRequestCount < this.throttleLimit && this.pendingRunRequests.length) {
	            this.inFlightRequestCount++;
	            const request = this.pendingRunRequests.pop();
	            this.installWorker(request.requestId, request.packageNames, request.cwd, (ok) => {
	              this.inFlightRequestCount--;
	              request.onRequestCompleted(ok);
	              this.executeWithThrottling();
	            });
	          }
	        }
	      };
	    }
	  });

	  // src/typingsInstallerCore/_namespaces/ts.server.typingsInstaller.ts
	  var ts_server_typingsInstaller_exports = {};
	  __export(ts_server_typingsInstaller_exports, {
	    TypingsInstaller: () => TypingsInstaller,
	    getNpmCommandForInstallation: () => getNpmCommandForInstallation,
	    installNpmPackages: () => installNpmPackages,
	    typingsName: () => typingsName
	  });
	  var init_ts_server_typingsInstaller = __esm({
	    "src/typingsInstallerCore/_namespaces/ts.server.typingsInstaller.ts"() {
	      init_typingsInstaller();
	    }
	  });

	  // src/typingsInstallerCore/_namespaces/ts.server.ts
	  var init_ts_server2 = __esm({
	    "src/typingsInstallerCore/_namespaces/ts.server.ts"() {
	      init_ts_server();
	      init_ts_server_typingsInstaller();
	    }
	  });

	  // src/server/types.ts
	  var init_types4 = __esm({
	    "src/server/types.ts"() {
	    }
	  });

	  // src/server/utilitiesPublic.ts
	  function createInstallTypingsRequest(project, typeAcquisition, unresolvedImports, cachePath) {
	    return {
	      projectName: project.getProjectName(),
	      fileNames: project.getFileNames(
	        /*excludeFilesFromExternalLibraries*/
	        true,
	        /*excludeConfigFiles*/
	        true
	      ).concat(project.getExcludedFiles()),
	      compilerOptions: project.getCompilationSettings(),
	      typeAcquisition,
	      unresolvedImports,
	      projectRootPath: project.getCurrentDirectory(),
	      cachePath,
	      kind: "discover"
	    };
	  }
	  function toNormalizedPath(fileName) {
	    return normalizePath(fileName);
	  }
	  function normalizedPathToPath(normalizedPath, currentDirectory, getCanonicalFileName) {
	    const f = isRootedDiskPath(normalizedPath) ? normalizedPath : getNormalizedAbsolutePath(normalizedPath, currentDirectory);
	    return getCanonicalFileName(f);
	  }
	  function asNormalizedPath(fileName) {
	    return fileName;
	  }
	  function createNormalizedPathMap() {
	    const map2 = /* @__PURE__ */ new Map();
	    return {
	      get(path) {
	        return map2.get(path);
	      },
	      set(path, value) {
	        map2.set(path, value);
	      },
	      contains(path) {
	        return map2.has(path);
	      },
	      remove(path) {
	        map2.delete(path);
	      }
	    };
	  }
	  function isInferredProjectName(name) {
	    return /dev\/null\/inferredProject\d+\*/.test(name);
	  }
	  function makeInferredProjectName(counter) {
	    return `/dev/null/inferredProject${counter}*`;
	  }
	  function makeAutoImportProviderProjectName(counter) {
	    return `/dev/null/autoImportProviderProject${counter}*`;
	  }
	  function makeAuxiliaryProjectName(counter) {
	    return `/dev/null/auxiliaryProject${counter}*`;
	  }
	  function createSortedArray2() {
	    return [];
	  }
	  var LogLevel2, emptyArray2, Msg, Errors;
	  var init_utilitiesPublic3 = __esm({
	    "src/server/utilitiesPublic.ts"() {
	      init_ts7();
	      LogLevel2 = /* @__PURE__ */ ((LogLevel3) => {
	        LogLevel3[LogLevel3["terse"] = 0] = "terse";
	        LogLevel3[LogLevel3["normal"] = 1] = "normal";
	        LogLevel3[LogLevel3["requestTime"] = 2] = "requestTime";
	        LogLevel3[LogLevel3["verbose"] = 3] = "verbose";
	        return LogLevel3;
	      })(LogLevel2 || {});
	      emptyArray2 = createSortedArray2();
	      Msg = /* @__PURE__ */ ((Msg2) => {
	        Msg2["Err"] = "Err";
	        Msg2["Info"] = "Info";
	        Msg2["Perf"] = "Perf";
	        return Msg2;
	      })(Msg || {});
	      ((Errors2) => {
	        function ThrowNoProject() {
	          throw new Error("No Project.");
	        }
	        Errors2.ThrowNoProject = ThrowNoProject;
	        function ThrowProjectLanguageServiceDisabled() {
	          throw new Error("The project's language service is disabled.");
	        }
	        Errors2.ThrowProjectLanguageServiceDisabled = ThrowProjectLanguageServiceDisabled;
	        function ThrowProjectDoesNotContainDocument(fileName, project) {
	          throw new Error(`Project '${project.getProjectName()}' does not contain document '${fileName}'`);
	        }
	        Errors2.ThrowProjectDoesNotContainDocument = ThrowProjectDoesNotContainDocument;
	      })(Errors || (Errors = {}));
	    }
	  });

	  // src/server/utilities.ts
	  function getBaseConfigFileName(configFilePath) {
	    const base = getBaseFileName(configFilePath);
	    return base === "tsconfig.json" || base === "jsconfig.json" ? base : void 0;
	  }
	  function removeSorted(array, remove, compare) {
	    if (!array || array.length === 0) {
	      return;
	    }
	    if (array[0] === remove) {
	      array.splice(0, 1);
	      return;
	    }
	    const removeIndex = binarySearch(array, remove, identity, compare);
	    if (removeIndex >= 0) {
	      array.splice(removeIndex, 1);
	    }
	  }
	  var ThrottledOperations, GcTimer;
	  var init_utilities5 = __esm({
	    "src/server/utilities.ts"() {
	      init_ts7();
	      init_ts_server3();
	      ThrottledOperations = class _ThrottledOperations {
	        constructor(host, logger) {
	          this.host = host;
	          this.pendingTimeouts = /* @__PURE__ */ new Map();
	          this.logger = logger.hasLevel(3 /* verbose */) ? logger : void 0;
	        }
	        /**
	         * Wait `number` milliseconds and then invoke `cb`.  If, while waiting, schedule
	         * is called again with the same `operationId`, cancel this operation in favor
	         * of the new one.  (Note that the amount of time the canceled operation had been
	         * waiting does not affect the amount of time that the new operation waits.)
	         */
	        schedule(operationId, delay, cb) {
	          const pendingTimeout = this.pendingTimeouts.get(operationId);
	          if (pendingTimeout) {
	            this.host.clearTimeout(pendingTimeout);
	          }
	          this.pendingTimeouts.set(operationId, this.host.setTimeout(_ThrottledOperations.run, delay, operationId, this, cb));
	          if (this.logger) {
	            this.logger.info(`Scheduled: ${operationId}${pendingTimeout ? ", Cancelled earlier one" : ""}`);
	          }
	        }
	        cancel(operationId) {
	          const pendingTimeout = this.pendingTimeouts.get(operationId);
	          if (!pendingTimeout)
	            return false;
	          this.host.clearTimeout(pendingTimeout);
	          return this.pendingTimeouts.delete(operationId);
	        }
	        static run(operationId, self, cb) {
	          var _a, _b;
	          (_a = perfLogger) == null ? void 0 : _a.logStartScheduledOperation(operationId);
	          self.pendingTimeouts.delete(operationId);
	          if (self.logger) {
	            self.logger.info(`Running: ${operationId}`);
	          }
	          cb();
	          (_b = perfLogger) == null ? void 0 : _b.logStopScheduledOperation();
	        }
	      };
	      GcTimer = class _GcTimer {
	        constructor(host, delay, logger) {
	          this.host = host;
	          this.delay = delay;
	          this.logger = logger;
	        }
	        scheduleCollect() {
	          if (!this.host.gc || this.timerId !== void 0) {
	            return;
	          }
	          this.timerId = this.host.setTimeout(_GcTimer.run, this.delay, this);
	        }
	        static run(self) {
	          var _a, _b;
	          self.timerId = void 0;
	          (_a = perfLogger) == null ? void 0 : _a.logStartScheduledOperation("GC collect");
	          const log = self.logger.hasLevel(2 /* requestTime */);
	          const before = log && self.host.getMemoryUsage();
	          self.host.gc();
	          if (log) {
	            const after = self.host.getMemoryUsage();
	            self.logger.perftrc(`GC::before ${before}, after ${after}`);
	          }
	          (_b = perfLogger) == null ? void 0 : _b.logStopScheduledOperation();
	        }
	      };
	    }
	  });

	  // src/server/protocol.ts
	  var CommandTypes, OrganizeImportsMode2, WatchFileKind2, WatchDirectoryKind2, PollingWatchKind2, CompletionTriggerKind2, IndentStyle2, SemicolonPreference2, JsxEmit2, ModuleKind2, ModuleResolutionKind2, NewLineKind2, ScriptTarget10, ClassificationType2;
	  var init_protocol = __esm({
	    "src/server/protocol.ts"() {
	      CommandTypes = /* @__PURE__ */ ((CommandTypes2) => {
	        CommandTypes2["JsxClosingTag"] = "jsxClosingTag";
	        CommandTypes2["LinkedEditingRange"] = "linkedEditingRange";
	        CommandTypes2["Brace"] = "brace";
	        CommandTypes2["BraceFull"] = "brace-full";
	        CommandTypes2["BraceCompletion"] = "braceCompletion";
	        CommandTypes2["GetSpanOfEnclosingComment"] = "getSpanOfEnclosingComment";
	        CommandTypes2["Change"] = "change";
	        CommandTypes2["Close"] = "close";
	        CommandTypes2["Completions"] = "completions";
	        CommandTypes2["CompletionInfo"] = "completionInfo";
	        CommandTypes2["CompletionsFull"] = "completions-full";
	        CommandTypes2["CompletionDetails"] = "completionEntryDetails";
	        CommandTypes2["CompletionDetailsFull"] = "completionEntryDetails-full";
	        CommandTypes2["CompileOnSaveAffectedFileList"] = "compileOnSaveAffectedFileList";
	        CommandTypes2["CompileOnSaveEmitFile"] = "compileOnSaveEmitFile";
	        CommandTypes2["Configure"] = "configure";
	        CommandTypes2["Definition"] = "definition";
	        CommandTypes2["DefinitionFull"] = "definition-full";
	        CommandTypes2["DefinitionAndBoundSpan"] = "definitionAndBoundSpan";
	        CommandTypes2["DefinitionAndBoundSpanFull"] = "definitionAndBoundSpan-full";
	        CommandTypes2["Implementation"] = "implementation";
	        CommandTypes2["ImplementationFull"] = "implementation-full";
	        CommandTypes2["EmitOutput"] = "emit-output";
	        CommandTypes2["Exit"] = "exit";
	        CommandTypes2["FileReferences"] = "fileReferences";
	        CommandTypes2["FileReferencesFull"] = "fileReferences-full";
	        CommandTypes2["Format"] = "format";
	        CommandTypes2["Formatonkey"] = "formatonkey";
	        CommandTypes2["FormatFull"] = "format-full";
	        CommandTypes2["FormatonkeyFull"] = "formatonkey-full";
	        CommandTypes2["FormatRangeFull"] = "formatRange-full";
	        CommandTypes2["Geterr"] = "geterr";
	        CommandTypes2["GeterrForProject"] = "geterrForProject";
	        CommandTypes2["SemanticDiagnosticsSync"] = "semanticDiagnosticsSync";
	        CommandTypes2["SyntacticDiagnosticsSync"] = "syntacticDiagnosticsSync";
	        CommandTypes2["SuggestionDiagnosticsSync"] = "suggestionDiagnosticsSync";
	        CommandTypes2["NavBar"] = "navbar";
	        CommandTypes2["NavBarFull"] = "navbar-full";
	        CommandTypes2["Navto"] = "navto";
	        CommandTypes2["NavtoFull"] = "navto-full";
	        CommandTypes2["NavTree"] = "navtree";
	        CommandTypes2["NavTreeFull"] = "navtree-full";
	        CommandTypes2["DocumentHighlights"] = "documentHighlights";
	        CommandTypes2["DocumentHighlightsFull"] = "documentHighlights-full";
	        CommandTypes2["Open"] = "open";
	        CommandTypes2["Quickinfo"] = "quickinfo";
	        CommandTypes2["QuickinfoFull"] = "quickinfo-full";
	        CommandTypes2["References"] = "references";
	        CommandTypes2["ReferencesFull"] = "references-full";
	        CommandTypes2["Reload"] = "reload";
	        CommandTypes2["Rename"] = "rename";
	        CommandTypes2["RenameInfoFull"] = "rename-full";
	        CommandTypes2["RenameLocationsFull"] = "renameLocations-full";
	        CommandTypes2["Saveto"] = "saveto";
	        CommandTypes2["SignatureHelp"] = "signatureHelp";
	        CommandTypes2["SignatureHelpFull"] = "signatureHelp-full";
	        CommandTypes2["FindSourceDefinition"] = "findSourceDefinition";
	        CommandTypes2["Status"] = "status";
	        CommandTypes2["TypeDefinition"] = "typeDefinition";
	        CommandTypes2["ProjectInfo"] = "projectInfo";
	        CommandTypes2["ReloadProjects"] = "reloadProjects";
	        CommandTypes2["Unknown"] = "unknown";
	        CommandTypes2["OpenExternalProject"] = "openExternalProject";
	        CommandTypes2["OpenExternalProjects"] = "openExternalProjects";
	        CommandTypes2["CloseExternalProject"] = "closeExternalProject";
	        CommandTypes2["SynchronizeProjectList"] = "synchronizeProjectList";
	        CommandTypes2["ApplyChangedToOpenFiles"] = "applyChangedToOpenFiles";
	        CommandTypes2["UpdateOpen"] = "updateOpen";
	        CommandTypes2["EncodedSyntacticClassificationsFull"] = "encodedSyntacticClassifications-full";
	        CommandTypes2["EncodedSemanticClassificationsFull"] = "encodedSemanticClassifications-full";
	        CommandTypes2["Cleanup"] = "cleanup";
	        CommandTypes2["GetOutliningSpans"] = "getOutliningSpans";
	        CommandTypes2["GetOutliningSpansFull"] = "outliningSpans";
	        CommandTypes2["TodoComments"] = "todoComments";
	        CommandTypes2["Indentation"] = "indentation";
	        CommandTypes2["DocCommentTemplate"] = "docCommentTemplate";
	        CommandTypes2["CompilerOptionsDiagnosticsFull"] = "compilerOptionsDiagnostics-full";
	        CommandTypes2["NameOrDottedNameSpan"] = "nameOrDottedNameSpan";
	        CommandTypes2["BreakpointStatement"] = "breakpointStatement";
	        CommandTypes2["CompilerOptionsForInferredProjects"] = "compilerOptionsForInferredProjects";
	        CommandTypes2["GetCodeFixes"] = "getCodeFixes";
	        CommandTypes2["GetCodeFixesFull"] = "getCodeFixes-full";
	        CommandTypes2["GetCombinedCodeFix"] = "getCombinedCodeFix";
	        CommandTypes2["GetCombinedCodeFixFull"] = "getCombinedCodeFix-full";
	        CommandTypes2["ApplyCodeActionCommand"] = "applyCodeActionCommand";
	        CommandTypes2["GetSupportedCodeFixes"] = "getSupportedCodeFixes";
	        CommandTypes2["GetApplicableRefactors"] = "getApplicableRefactors";
	        CommandTypes2["GetEditsForRefactor"] = "getEditsForRefactor";
	        CommandTypes2["GetMoveToRefactoringFileSuggestions"] = "getMoveToRefactoringFileSuggestions";
	        CommandTypes2["GetEditsForRefactorFull"] = "getEditsForRefactor-full";
	        CommandTypes2["OrganizeImports"] = "organizeImports";
	        CommandTypes2["OrganizeImportsFull"] = "organizeImports-full";
	        CommandTypes2["GetEditsForFileRename"] = "getEditsForFileRename";
	        CommandTypes2["GetEditsForFileRenameFull"] = "getEditsForFileRename-full";
	        CommandTypes2["ConfigurePlugin"] = "configurePlugin";
	        CommandTypes2["SelectionRange"] = "selectionRange";
	        CommandTypes2["SelectionRangeFull"] = "selectionRange-full";
	        CommandTypes2["ToggleLineComment"] = "toggleLineComment";
	        CommandTypes2["ToggleLineCommentFull"] = "toggleLineComment-full";
	        CommandTypes2["ToggleMultilineComment"] = "toggleMultilineComment";
	        CommandTypes2["ToggleMultilineCommentFull"] = "toggleMultilineComment-full";
	        CommandTypes2["CommentSelection"] = "commentSelection";
	        CommandTypes2["CommentSelectionFull"] = "commentSelection-full";
	        CommandTypes2["UncommentSelection"] = "uncommentSelection";
	        CommandTypes2["UncommentSelectionFull"] = "uncommentSelection-full";
	        CommandTypes2["PrepareCallHierarchy"] = "prepareCallHierarchy";
	        CommandTypes2["ProvideCallHierarchyIncomingCalls"] = "provideCallHierarchyIncomingCalls";
	        CommandTypes2["ProvideCallHierarchyOutgoingCalls"] = "provideCallHierarchyOutgoingCalls";
	        CommandTypes2["ProvideInlayHints"] = "provideInlayHints";
	        CommandTypes2["WatchChange"] = "watchChange";
	        return CommandTypes2;
	      })(CommandTypes || {});
	      OrganizeImportsMode2 = /* @__PURE__ */ ((OrganizeImportsMode3) => {
	        OrganizeImportsMode3["All"] = "All";
	        OrganizeImportsMode3["SortAndCombine"] = "SortAndCombine";
	        OrganizeImportsMode3["RemoveUnused"] = "RemoveUnused";
	        return OrganizeImportsMode3;
	      })(OrganizeImportsMode2 || {});
	      WatchFileKind2 = /* @__PURE__ */ ((WatchFileKind3) => {
	        WatchFileKind3["FixedPollingInterval"] = "FixedPollingInterval";
	        WatchFileKind3["PriorityPollingInterval"] = "PriorityPollingInterval";
	        WatchFileKind3["DynamicPriorityPolling"] = "DynamicPriorityPolling";
	        WatchFileKind3["FixedChunkSizePolling"] = "FixedChunkSizePolling";
	        WatchFileKind3["UseFsEvents"] = "UseFsEvents";
	        WatchFileKind3["UseFsEventsOnParentDirectory"] = "UseFsEventsOnParentDirectory";
	        return WatchFileKind3;
	      })(WatchFileKind2 || {});
	      WatchDirectoryKind2 = /* @__PURE__ */ ((WatchDirectoryKind3) => {
	        WatchDirectoryKind3["UseFsEvents"] = "UseFsEvents";
	        WatchDirectoryKind3["FixedPollingInterval"] = "FixedPollingInterval";
	        WatchDirectoryKind3["DynamicPriorityPolling"] = "DynamicPriorityPolling";
	        WatchDirectoryKind3["FixedChunkSizePolling"] = "FixedChunkSizePolling";
	        return WatchDirectoryKind3;
	      })(WatchDirectoryKind2 || {});
	      PollingWatchKind2 = /* @__PURE__ */ ((PollingWatchKind3) => {
	        PollingWatchKind3["FixedInterval"] = "FixedInterval";
	        PollingWatchKind3["PriorityInterval"] = "PriorityInterval";
	        PollingWatchKind3["DynamicPriority"] = "DynamicPriority";
	        PollingWatchKind3["FixedChunkSize"] = "FixedChunkSize";
	        return PollingWatchKind3;
	      })(PollingWatchKind2 || {});
	      CompletionTriggerKind2 = /* @__PURE__ */ ((CompletionTriggerKind4) => {
	        CompletionTriggerKind4[CompletionTriggerKind4["Invoked"] = 1] = "Invoked";
	        CompletionTriggerKind4[CompletionTriggerKind4["TriggerCharacter"] = 2] = "TriggerCharacter";
	        CompletionTriggerKind4[CompletionTriggerKind4["TriggerForIncompleteCompletions"] = 3] = "TriggerForIncompleteCompletions";
	        return CompletionTriggerKind4;
	      })(CompletionTriggerKind2 || {});
	      IndentStyle2 = /* @__PURE__ */ ((IndentStyle3) => {
	        IndentStyle3["None"] = "None";
	        IndentStyle3["Block"] = "Block";
	        IndentStyle3["Smart"] = "Smart";
	        return IndentStyle3;
	      })(IndentStyle2 || {});
	      SemicolonPreference2 = /* @__PURE__ */ ((SemicolonPreference3) => {
	        SemicolonPreference3["Ignore"] = "ignore";
	        SemicolonPreference3["Insert"] = "insert";
	        SemicolonPreference3["Remove"] = "remove";
	        return SemicolonPreference3;
	      })(SemicolonPreference2 || {});
	      JsxEmit2 = /* @__PURE__ */ ((JsxEmit3) => {
	        JsxEmit3["None"] = "None";
	        JsxEmit3["Preserve"] = "Preserve";
	        JsxEmit3["ReactNative"] = "ReactNative";
	        JsxEmit3["React"] = "React";
	        return JsxEmit3;
	      })(JsxEmit2 || {});
	      ModuleKind2 = /* @__PURE__ */ ((ModuleKind3) => {
	        ModuleKind3["None"] = "None";
	        ModuleKind3["CommonJS"] = "CommonJS";
	        ModuleKind3["AMD"] = "AMD";
	        ModuleKind3["UMD"] = "UMD";
	        ModuleKind3["System"] = "System";
	        ModuleKind3["ES6"] = "ES6";
	        ModuleKind3["ES2015"] = "ES2015";
	        ModuleKind3["ESNext"] = "ESNext";
	        ModuleKind3["Node16"] = "Node16";
	        ModuleKind3["NodeNext"] = "NodeNext";
	        ModuleKind3["Preserve"] = "Preserve";
	        return ModuleKind3;
	      })(ModuleKind2 || {});
	      ModuleResolutionKind2 = /* @__PURE__ */ ((ModuleResolutionKind3) => {
	        ModuleResolutionKind3["Classic"] = "Classic";
	        ModuleResolutionKind3["Node"] = "Node";
	        ModuleResolutionKind3["Node10"] = "Node10";
	        ModuleResolutionKind3["Node16"] = "Node16";
	        ModuleResolutionKind3["NodeNext"] = "NodeNext";
	        ModuleResolutionKind3["Bundler"] = "Bundler";
	        return ModuleResolutionKind3;
	      })(ModuleResolutionKind2 || {});
	      NewLineKind2 = /* @__PURE__ */ ((NewLineKind3) => {
	        NewLineKind3["Crlf"] = "Crlf";
	        NewLineKind3["Lf"] = "Lf";
	        return NewLineKind3;
	      })(NewLineKind2 || {});
	      ScriptTarget10 = /* @__PURE__ */ ((ScriptTarget11) => {
	        ScriptTarget11["ES3"] = "ES3";
	        ScriptTarget11["ES5"] = "ES5";
	        ScriptTarget11["ES6"] = "ES6";
	        ScriptTarget11["ES2015"] = "ES2015";
	        ScriptTarget11["ES2016"] = "ES2016";
	        ScriptTarget11["ES2017"] = "ES2017";
	        ScriptTarget11["ES2018"] = "ES2018";
	        ScriptTarget11["ES2019"] = "ES2019";
	        ScriptTarget11["ES2020"] = "ES2020";
	        ScriptTarget11["ES2021"] = "ES2021";
	        ScriptTarget11["ES2022"] = "ES2022";
	        ScriptTarget11["ESNext"] = "ESNext";
	        return ScriptTarget11;
	      })(ScriptTarget10 || {});
	      ClassificationType2 = /* @__PURE__ */ ((ClassificationType3) => {
	        ClassificationType3[ClassificationType3["comment"] = 1] = "comment";
	        ClassificationType3[ClassificationType3["identifier"] = 2] = "identifier";
	        ClassificationType3[ClassificationType3["keyword"] = 3] = "keyword";
	        ClassificationType3[ClassificationType3["numericLiteral"] = 4] = "numericLiteral";
	        ClassificationType3[ClassificationType3["operator"] = 5] = "operator";
	        ClassificationType3[ClassificationType3["stringLiteral"] = 6] = "stringLiteral";
	        ClassificationType3[ClassificationType3["regularExpressionLiteral"] = 7] = "regularExpressionLiteral";
	        ClassificationType3[ClassificationType3["whiteSpace"] = 8] = "whiteSpace";
	        ClassificationType3[ClassificationType3["text"] = 9] = "text";
	        ClassificationType3[ClassificationType3["punctuation"] = 10] = "punctuation";
	        ClassificationType3[ClassificationType3["className"] = 11] = "className";
	        ClassificationType3[ClassificationType3["enumName"] = 12] = "enumName";
	        ClassificationType3[ClassificationType3["interfaceName"] = 13] = "interfaceName";
	        ClassificationType3[ClassificationType3["moduleName"] = 14] = "moduleName";
	        ClassificationType3[ClassificationType3["typeParameterName"] = 15] = "typeParameterName";
	        ClassificationType3[ClassificationType3["typeAliasName"] = 16] = "typeAliasName";
	        ClassificationType3[ClassificationType3["parameterName"] = 17] = "parameterName";
	        ClassificationType3[ClassificationType3["docCommentTagName"] = 18] = "docCommentTagName";
	        ClassificationType3[ClassificationType3["jsxOpenTagName"] = 19] = "jsxOpenTagName";
	        ClassificationType3[ClassificationType3["jsxCloseTagName"] = 20] = "jsxCloseTagName";
	        ClassificationType3[ClassificationType3["jsxSelfClosingTagName"] = 21] = "jsxSelfClosingTagName";
	        ClassificationType3[ClassificationType3["jsxAttribute"] = 22] = "jsxAttribute";
	        ClassificationType3[ClassificationType3["jsxText"] = 23] = "jsxText";
	        ClassificationType3[ClassificationType3["jsxAttributeStringLiteralValue"] = 24] = "jsxAttributeStringLiteralValue";
	        ClassificationType3[ClassificationType3["bigintLiteral"] = 25] = "bigintLiteral";
	        return ClassificationType3;
	      })(ClassificationType2 || {});
	    }
	  });

	  // src/server/_namespaces/ts.server.protocol.ts
	  var ts_server_protocol_exports = {};
	  __export(ts_server_protocol_exports, {
	    ClassificationType: () => ClassificationType2,
	    CommandTypes: () => CommandTypes,
	    CompletionTriggerKind: () => CompletionTriggerKind2,
	    IndentStyle: () => IndentStyle2,
	    JsxEmit: () => JsxEmit2,
	    ModuleKind: () => ModuleKind2,
	    ModuleResolutionKind: () => ModuleResolutionKind2,
	    NewLineKind: () => NewLineKind2,
	    OrganizeImportsMode: () => OrganizeImportsMode2,
	    PollingWatchKind: () => PollingWatchKind2,
	    ScriptTarget: () => ScriptTarget10,
	    SemicolonPreference: () => SemicolonPreference2,
	    WatchDirectoryKind: () => WatchDirectoryKind2,
	    WatchFileKind: () => WatchFileKind2
	  });
	  var init_ts_server_protocol = __esm({
	    "src/server/_namespaces/ts.server.protocol.ts"() {
	      init_protocol();
	    }
	  });

	  // src/server/scriptInfo.ts
	  function isDynamicFileName(fileName) {
	    return fileName[0] === "^" || (fileName.includes("walkThroughSnippet:/") || fileName.includes("untitled:/")) && getBaseFileName(fileName)[0] === "^" || fileName.includes(":^") && !fileName.includes(directorySeparator);
	  }
	  function ensurePrimaryProjectKind(project) {
	    if (!project || isBackgroundProject(project)) {
	      return Errors.ThrowNoProject();
	    }
	    return project;
	  }
	  function failIfInvalidPosition(position) {
	    Debug.assert(typeof position === "number", `Expected position ${position} to be a number.`);
	    Debug.assert(position >= 0, `Expected position to be non-negative.`);
	  }
	  function failIfInvalidLocation(location) {
	    Debug.assert(typeof location.line === "number", `Expected line ${location.line} to be a number.`);
	    Debug.assert(typeof location.offset === "number", `Expected offset ${location.offset} to be a number.`);
	    Debug.assert(location.line > 0, `Expected line to be non-${location.line === 0 ? "zero" : "negative"}`);
	    Debug.assert(location.offset > 0, `Expected offset to be non-${location.offset === 0 ? "zero" : "negative"}`);
	  }
	  var TextStorage, ScriptInfo;
	  var init_scriptInfo = __esm({
	    "src/server/scriptInfo.ts"() {
	      init_ts7();
	      init_ts_server3();
	      TextStorage = class {
	        constructor(host, info, initialVersion) {
	          this.host = host;
	          this.info = info;
	          /**
	           * True if the text is for the file thats open in the editor
	           */
	          this.isOpen = false;
	          /**
	           * True if the text present is the text from the file on the disk
	           */
	          this.ownFileText = false;
	          /**
	           * True when reloading contents of file from the disk is pending
	           */
	          this.pendingReloadFromDisk = false;
	          this.version = initialVersion || 0;
	        }
	        getVersion() {
	          return this.svc ? `SVC-${this.version}-${this.svc.getSnapshotVersion()}` : `Text-${this.version}`;
	        }
	        hasScriptVersionCache_TestOnly() {
	          return this.svc !== void 0;
	        }
	        resetSourceMapInfo() {
	          this.info.sourceFileLike = void 0;
	          this.info.closeSourceMapFileWatcher();
	          this.info.sourceMapFilePath = void 0;
	          this.info.declarationInfoPath = void 0;
	          this.info.sourceInfos = void 0;
	          this.info.documentPositionMapper = void 0;
	        }
	        /** Public for testing */
	        useText(newText) {
	          this.svc = void 0;
	          this.text = newText;
	          this.textSnapshot = void 0;
	          this.lineMap = void 0;
	          this.fileSize = void 0;
	          this.resetSourceMapInfo();
	          this.version++;
	        }
	        edit(start, end, newText) {
	          this.switchToScriptVersionCache().edit(start, end - start, newText);
	          this.ownFileText = false;
	          this.text = void 0;
	          this.textSnapshot = void 0;
	          this.lineMap = void 0;
	          this.fileSize = void 0;
	          this.resetSourceMapInfo();
	        }
	        /**
	         * Set the contents as newText
	         * returns true if text changed
	         */
	        reload(newText) {
	          Debug.assert(newText !== void 0);
	          this.pendingReloadFromDisk = false;
	          if (!this.text && this.svc) {
	            this.text = getSnapshotText(this.svc.getSnapshot());
	          }
	          if (this.text !== newText) {
	            this.useText(newText);
	            this.ownFileText = false;
	            return true;
	          }
	          return false;
	        }
	        /**
	         * Reads the contents from tempFile(if supplied) or own file and sets it as contents
	         * returns true if text changed
	         */
	        reloadWithFileText(tempFileName) {
	          const { text: newText, fileSize } = tempFileName || !this.info.isDynamicOrHasMixedContent() ? this.getFileTextAndSize(tempFileName) : { text: "", fileSize: void 0 };
	          const reloaded = this.reload(newText);
	          this.fileSize = fileSize;
	          this.ownFileText = !tempFileName || tempFileName === this.info.fileName;
	          return reloaded;
	        }
	        /**
	         * Schedule reload from the disk if its not already scheduled and its not own text
	         * returns true when scheduling reload
	         */
	        scheduleReloadIfNeeded() {
	          return !this.pendingReloadFromDisk && !this.ownFileText ? this.pendingReloadFromDisk = true : false;
	        }
	        delayReloadFromFileIntoText() {
	          this.pendingReloadFromDisk = true;
	        }
	        /**
	         * For telemetry purposes, we would like to be able to report the size of the file.
	         * However, we do not want telemetry to require extra file I/O so we report a size
	         * that may be stale (e.g. may not reflect change made on disk since the last reload).
	         * NB: Will read from disk if the file contents have never been loaded because
	         * telemetry falsely indicating size 0 would be counter-productive.
	         */
	        getTelemetryFileSize() {
	          return !!this.fileSize ? this.fileSize : !!this.text ? this.text.length : !!this.svc ? this.svc.getSnapshot().getLength() : this.getSnapshot().getLength();
	        }
	        getSnapshot() {
	          var _a;
	          return ((_a = this.tryUseScriptVersionCache()) == null ? void 0 : _a.getSnapshot()) || (this.textSnapshot ?? (this.textSnapshot = ScriptSnapshot.fromString(Debug.checkDefined(this.text))));
	        }
	        getAbsolutePositionAndLineText(oneBasedLine) {
	          const svc = this.tryUseScriptVersionCache();
	          if (svc)
	            return svc.getAbsolutePositionAndLineText(oneBasedLine);
	          const lineMap = this.getLineMap();
	          return oneBasedLine <= lineMap.length ? {
	            absolutePosition: lineMap[oneBasedLine - 1],
	            lineText: this.text.substring(lineMap[oneBasedLine - 1], lineMap[oneBasedLine])
	          } : {
	            absolutePosition: this.text.length,
	            lineText: void 0
	          };
	        }
	        /**
	         *  @param line 0 based index
	         */
	        lineToTextSpan(line) {
	          const svc = this.tryUseScriptVersionCache();
	          if (svc)
	            return svc.lineToTextSpan(line);
	          const lineMap = this.getLineMap();
	          const start = lineMap[line];
	          const end = line + 1 < lineMap.length ? lineMap[line + 1] : this.text.length;
	          return createTextSpanFromBounds(start, end);
	        }
	        /**
	         * @param line 1 based index
	         * @param offset 1 based index
	         */
	        lineOffsetToPosition(line, offset, allowEdits) {
	          const svc = this.tryUseScriptVersionCache();
	          return svc ? svc.lineOffsetToPosition(line, offset) : computePositionOfLineAndCharacter(this.getLineMap(), line - 1, offset - 1, this.text, allowEdits);
	        }
	        positionToLineOffset(position) {
	          const svc = this.tryUseScriptVersionCache();
	          if (svc)
	            return svc.positionToLineOffset(position);
	          const { line, character } = computeLineAndCharacterOfPosition(this.getLineMap(), position);
	          return { line: line + 1, offset: character + 1 };
	        }
	        getFileTextAndSize(tempFileName) {
	          let text;
	          const fileName = tempFileName || this.info.fileName;
	          const getText = () => text === void 0 ? text = this.host.readFile(fileName) || "" : text;
	          if (!hasTSFileExtension(this.info.fileName)) {
	            const fileSize = this.host.getFileSize ? this.host.getFileSize(fileName) : getText().length;
	            if (fileSize > maxFileSize) {
	              Debug.assert(!!this.info.containingProjects.length);
	              const service = this.info.containingProjects[0].projectService;
	              service.logger.info(`Skipped loading contents of large file ${fileName} for info ${this.info.fileName}: fileSize: ${fileSize}`);
	              this.info.containingProjects[0].projectService.sendLargeFileReferencedEvent(fileName, fileSize);
	              return { text: "", fileSize };
	            }
	          }
	          return { text: getText() };
	        }
	        /** @internal */
	        switchToScriptVersionCache() {
	          if (!this.svc || this.pendingReloadFromDisk) {
	            this.svc = ScriptVersionCache.fromString(this.getOrLoadText());
	            this.textSnapshot = void 0;
	            this.version++;
	          }
	          return this.svc;
	        }
	        tryUseScriptVersionCache() {
	          if (!this.svc || this.pendingReloadFromDisk) {
	            this.getOrLoadText();
	          }
	          if (this.isOpen) {
	            if (!this.svc && !this.textSnapshot) {
	              this.svc = ScriptVersionCache.fromString(Debug.checkDefined(this.text));
	              this.textSnapshot = void 0;
	            }
	            return this.svc;
	          }
	          return this.svc;
	        }
	        getOrLoadText() {
	          if (this.text === void 0 || this.pendingReloadFromDisk) {
	            Debug.assert(!this.svc || this.pendingReloadFromDisk, "ScriptVersionCache should not be set when reloading from disk");
	            this.reloadWithFileText();
	          }
	          return this.text;
	        }
	        getLineMap() {
	          Debug.assert(!this.svc, "ScriptVersionCache should not be set");
	          return this.lineMap || (this.lineMap = computeLineStarts(Debug.checkDefined(this.text)));
	        }
	        getLineInfo() {
	          const svc = this.tryUseScriptVersionCache();
	          if (svc) {
	            return {
	              getLineCount: () => svc.getLineCount(),
	              getLineText: (line) => svc.getAbsolutePositionAndLineText(line + 1).lineText
	            };
	          }
	          const lineMap = this.getLineMap();
	          return getLineInfo(this.text, lineMap);
	        }
	      };
	      ScriptInfo = class {
	        constructor(host, fileName, scriptKind, hasMixedContent, path, initialVersion) {
	          this.host = host;
	          this.fileName = fileName;
	          this.scriptKind = scriptKind;
	          this.hasMixedContent = hasMixedContent;
	          this.path = path;
	          /**
	           * All projects that include this file
	           */
	          this.containingProjects = [];
	          this.isDynamic = isDynamicFileName(fileName);
	          this.textStorage = new TextStorage(host, this, initialVersion);
	          if (hasMixedContent || this.isDynamic) {
	            this.realpath = this.path;
	          }
	          this.scriptKind = scriptKind ? scriptKind : getScriptKindFromFileName(fileName);
	        }
	        /** @internal */
	        isDynamicOrHasMixedContent() {
	          return this.hasMixedContent || this.isDynamic;
	        }
	        isScriptOpen() {
	          return this.textStorage.isOpen;
	        }
	        open(newText) {
	          this.textStorage.isOpen = true;
	          if (newText !== void 0 && this.textStorage.reload(newText)) {
	            this.markContainingProjectsAsDirty();
	          }
	        }
	        close(fileExists = true) {
	          this.textStorage.isOpen = false;
	          if (fileExists && this.textStorage.scheduleReloadIfNeeded()) {
	            this.markContainingProjectsAsDirty();
	          }
	        }
	        getSnapshot() {
	          return this.textStorage.getSnapshot();
	        }
	        ensureRealPath() {
	          if (this.realpath === void 0) {
	            this.realpath = this.path;
	            if (this.host.realpath) {
	              Debug.assert(!!this.containingProjects.length);
	              const project = this.containingProjects[0];
	              const realpath = this.host.realpath(this.path);
	              if (realpath) {
	                this.realpath = project.toPath(realpath);
	                if (this.realpath !== this.path) {
	                  project.projectService.realpathToScriptInfos.add(this.realpath, this);
	                }
	              }
	            }
	          }
	        }
	        /** @internal */
	        getRealpathIfDifferent() {
	          return this.realpath && this.realpath !== this.path ? this.realpath : void 0;
	        }
	        /**
	         * @internal
	         * Does not compute realpath; uses precomputed result. Use `ensureRealPath`
	         * first if a definite result is needed.
	         */
	        isSymlink() {
	          return this.realpath && this.realpath !== this.path;
	        }
	        getFormatCodeSettings() {
	          return this.formatSettings;
	        }
	        getPreferences() {
	          return this.preferences;
	        }
	        attachToProject(project) {
	          const isNew = !this.isAttached(project);
	          if (isNew) {
	            this.containingProjects.push(project);
	            if (!project.getCompilerOptions().preserveSymlinks) {
	              this.ensureRealPath();
	            }
	            project.onFileAddedOrRemoved(this.isSymlink());
	          }
	          return isNew;
	        }
	        isAttached(project) {
	          switch (this.containingProjects.length) {
	            case 0:
	              return false;
	            case 1:
	              return this.containingProjects[0] === project;
	            case 2:
	              return this.containingProjects[0] === project || this.containingProjects[1] === project;
	            default:
	              return contains(this.containingProjects, project);
	          }
	        }
	        detachFromProject(project) {
	          switch (this.containingProjects.length) {
	            case 0:
	              return;
	            case 1:
	              if (this.containingProjects[0] === project) {
	                project.onFileAddedOrRemoved(this.isSymlink());
	                this.containingProjects.pop();
	              }
	              break;
	            case 2:
	              if (this.containingProjects[0] === project) {
	                project.onFileAddedOrRemoved(this.isSymlink());
	                this.containingProjects[0] = this.containingProjects.pop();
	              } else if (this.containingProjects[1] === project) {
	                project.onFileAddedOrRemoved(this.isSymlink());
	                this.containingProjects.pop();
	              }
	              break;
	            default:
	              if (orderedRemoveItem(this.containingProjects, project)) {
	                project.onFileAddedOrRemoved(this.isSymlink());
	              }
	              break;
	          }
	        }
	        detachAllProjects() {
	          for (const p of this.containingProjects) {
	            if (isConfiguredProject(p)) {
	              p.getCachedDirectoryStructureHost().addOrDeleteFile(this.fileName, this.path, 2 /* Deleted */);
	            }
	            const existingRoot = p.getRootFilesMap().get(this.path);
	            p.removeFile(
	              this,
	              /*fileExists*/
	              false,
	              /*detachFromProject*/
	              false
	            );
	            p.onFileAddedOrRemoved(this.isSymlink());
	            if (existingRoot && !isInferredProject(p)) {
	              p.addMissingFileRoot(existingRoot.fileName);
	            }
	          }
	          clear(this.containingProjects);
	        }
	        getDefaultProject() {
	          switch (this.containingProjects.length) {
	            case 0:
	              return Errors.ThrowNoProject();
	            case 1:
	              return ensurePrimaryProjectKind(this.containingProjects[0]);
	            default:
	              let firstExternalProject;
	              let firstConfiguredProject;
	              let firstInferredProject;
	              let firstNonSourceOfProjectReferenceRedirect;
	              let defaultConfiguredProject;
	              for (let index = 0; index < this.containingProjects.length; index++) {
	                const project = this.containingProjects[index];
	                if (isConfiguredProject(project)) {
	                  if (!project.isSourceOfProjectReferenceRedirect(this.fileName)) {
	                    if (defaultConfiguredProject === void 0 && index !== this.containingProjects.length - 1) {
	                      defaultConfiguredProject = project.projectService.findDefaultConfiguredProject(this) || false;
	                    }
	                    if (defaultConfiguredProject === project)
	                      return project;
	                    if (!firstNonSourceOfProjectReferenceRedirect)
	                      firstNonSourceOfProjectReferenceRedirect = project;
	                  }
	                  if (!firstConfiguredProject)
	                    firstConfiguredProject = project;
	                } else if (!firstExternalProject && isExternalProject(project)) {
	                  firstExternalProject = project;
	                } else if (!firstInferredProject && isInferredProject(project)) {
	                  firstInferredProject = project;
	                }
	              }
	              return ensurePrimaryProjectKind(
	                defaultConfiguredProject || firstNonSourceOfProjectReferenceRedirect || firstConfiguredProject || firstExternalProject || firstInferredProject
	              );
	          }
	        }
	        registerFileUpdate() {
	          for (const p of this.containingProjects) {
	            p.registerFileUpdate(this.path);
	          }
	        }
	        setOptions(formatSettings, preferences) {
	          if (formatSettings) {
	            if (!this.formatSettings) {
	              this.formatSettings = getDefaultFormatCodeSettings(this.host.newLine);
	              assign(this.formatSettings, formatSettings);
	            } else {
	              this.formatSettings = { ...this.formatSettings, ...formatSettings };
	            }
	          }
	          if (preferences) {
	            if (!this.preferences) {
	              this.preferences = emptyOptions;
	            }
	            this.preferences = { ...this.preferences, ...preferences };
	          }
	        }
	        getLatestVersion() {
	          this.textStorage.getSnapshot();
	          return this.textStorage.getVersion();
	        }
	        saveTo(fileName) {
	          this.host.writeFile(fileName, getSnapshotText(this.textStorage.getSnapshot()));
	        }
	        /** @internal */
	        delayReloadNonMixedContentFile() {
	          Debug.assert(!this.isDynamicOrHasMixedContent());
	          this.textStorage.delayReloadFromFileIntoText();
	          this.markContainingProjectsAsDirty();
	        }
	        reloadFromFile(tempFileName) {
	          if (this.textStorage.reloadWithFileText(tempFileName)) {
	            this.markContainingProjectsAsDirty();
	            return true;
	          }
	          return false;
	        }
	        editContent(start, end, newText) {
	          this.textStorage.edit(start, end, newText);
	          this.markContainingProjectsAsDirty();
	        }
	        markContainingProjectsAsDirty() {
	          for (const p of this.containingProjects) {
	            p.markFileAsDirty(this.path);
	          }
	        }
	        isOrphan() {
	          return !forEach(this.containingProjects, (p) => !p.isOrphan());
	        }
	        /** @internal */
	        isContainedByBackgroundProject() {
	          return some(
	            this.containingProjects,
	            isBackgroundProject
	          );
	        }
	        /**
	         *  @param line 1 based index
	         */
	        lineToTextSpan(line) {
	          return this.textStorage.lineToTextSpan(line);
	        }
	        // eslint-disable-line @typescript-eslint/unified-signatures
	        lineOffsetToPosition(line, offset, allowEdits) {
	          return this.textStorage.lineOffsetToPosition(line, offset, allowEdits);
	        }
	        positionToLineOffset(position) {
	          failIfInvalidPosition(position);
	          const location = this.textStorage.positionToLineOffset(position);
	          failIfInvalidLocation(location);
	          return location;
	        }
	        isJavaScript() {
	          return this.scriptKind === 1 /* JS */ || this.scriptKind === 2 /* JSX */;
	        }
	        /** @internal */
	        closeSourceMapFileWatcher() {
	          if (this.sourceMapFilePath && !isString(this.sourceMapFilePath)) {
	            closeFileWatcherOf(this.sourceMapFilePath);
	            this.sourceMapFilePath = void 0;
	          }
	        }
	      };
	    }
	  });

	  // src/server/typingsCache.ts
	  function setIsEqualTo(arr1, arr2) {
	    if (arr1 === arr2) {
	      return true;
	    }
	    if ((arr1 || emptyArray2).length === 0 && (arr2 || emptyArray2).length === 0) {
	      return true;
	    }
	    const set = /* @__PURE__ */ new Map();
	    let unique = 0;
	    for (const v of arr1) {
	      if (set.get(v) !== true) {
	        set.set(v, true);
	        unique++;
	      }
	    }
	    for (const v of arr2) {
	      const isSet = set.get(v);
	      if (isSet === void 0) {
	        return false;
	      }
	      if (isSet === true) {
	        set.set(v, false);
	        unique--;
	      }
	    }
	    return unique === 0;
	  }
	  function typeAcquisitionChanged(opt1, opt2) {
	    return opt1.enable !== opt2.enable || !setIsEqualTo(opt1.include, opt2.include) || !setIsEqualTo(opt1.exclude, opt2.exclude);
	  }
	  function compilerOptionsChanged(opt1, opt2) {
	    return getAllowJSCompilerOption(opt1) !== getAllowJSCompilerOption(opt2);
	  }
	  function unresolvedImportsChanged(imports1, imports2) {
	    if (imports1 === imports2) {
	      return false;
	    }
	    return !arrayIsEqualTo(imports1, imports2);
	  }
	  var nullTypingsInstaller, TypingsCache;
	  var init_typingsCache = __esm({
	    "src/server/typingsCache.ts"() {
	      init_ts7();
	      init_ts_server3();
	      nullTypingsInstaller = {
	        isKnownTypesPackageName: returnFalse,
	        // Should never be called because we never provide a types registry.
	        installPackage: notImplemented,
	        enqueueInstallTypingsRequest: noop,
	        attach: noop,
	        onProjectClosed: noop,
	        globalTypingsCacheLocation: void 0
	        // TODO: GH#18217
	      };
	      TypingsCache = class {
	        constructor(installer) {
	          this.installer = installer;
	          this.perProjectCache = /* @__PURE__ */ new Map();
	        }
	        isKnownTypesPackageName(name) {
	          return this.installer.isKnownTypesPackageName(name);
	        }
	        installPackage(options) {
	          return this.installer.installPackage(options);
	        }
	        enqueueInstallTypingsForProject(project, unresolvedImports, forceRefresh) {
	          const typeAcquisition = project.getTypeAcquisition();
	          if (!typeAcquisition || !typeAcquisition.enable) {
	            return;
	          }
	          const entry = this.perProjectCache.get(project.getProjectName());
	          if (forceRefresh || !entry || typeAcquisitionChanged(typeAcquisition, entry.typeAcquisition) || compilerOptionsChanged(project.getCompilationSettings(), entry.compilerOptions) || unresolvedImportsChanged(unresolvedImports, entry.unresolvedImports)) {
	            this.perProjectCache.set(project.getProjectName(), {
	              compilerOptions: project.getCompilationSettings(),
	              typeAcquisition,
	              typings: entry ? entry.typings : emptyArray2,
	              unresolvedImports,
	              poisoned: true
	            });
	            this.installer.enqueueInstallTypingsRequest(project, typeAcquisition, unresolvedImports);
	          }
	        }
	        updateTypingsForProject(projectName, compilerOptions, typeAcquisition, unresolvedImports, newTypings) {
	          const typings = sort(newTypings);
	          this.perProjectCache.set(projectName, {
	            compilerOptions,
	            typeAcquisition,
	            typings,
	            unresolvedImports,
	            poisoned: false
	          });
	          return !typeAcquisition || !typeAcquisition.enable ? emptyArray2 : typings;
	        }
	        onProjectClosed(project) {
	          if (this.perProjectCache.delete(project.getProjectName())) {
	            this.installer.onProjectClosed(project);
	          }
	        }
	      };
	    }
	  });

	  // src/server/project.ts
	  function countEachFileTypes(infos, includeSizes = false) {
	    const result = {
	      js: 0,
	      jsSize: 0,
	      jsx: 0,
	      jsxSize: 0,
	      ts: 0,
	      tsSize: 0,
	      tsx: 0,
	      tsxSize: 0,
	      dts: 0,
	      dtsSize: 0,
	      deferred: 0,
	      deferredSize: 0
	    };
	    for (const info of infos) {
	      const fileSize = includeSizes ? info.textStorage.getTelemetryFileSize() : 0;
	      switch (info.scriptKind) {
	        case 1 /* JS */:
	          result.js += 1;
	          result.jsSize += fileSize;
	          break;
	        case 2 /* JSX */:
	          result.jsx += 1;
	          result.jsxSize += fileSize;
	          break;
	        case 3 /* TS */:
	          if (isDeclarationFileName(info.fileName)) {
	            result.dts += 1;
	            result.dtsSize += fileSize;
	          } else {
	            result.ts += 1;
	            result.tsSize += fileSize;
	          }
	          break;
	        case 4 /* TSX */:
	          result.tsx += 1;
	          result.tsxSize += fileSize;
	          break;
	        case 7 /* Deferred */:
	          result.deferred += 1;
	          result.deferredSize += fileSize;
	          break;
	      }
	    }
	    return result;
	  }
	  function hasOneOrMoreJsAndNoTsFiles(project) {
	    const counts2 = countEachFileTypes(project.getScriptInfos());
	    return counts2.js > 0 && counts2.ts === 0 && counts2.tsx === 0;
	  }
	  function allRootFilesAreJsOrDts(project) {
	    const counts2 = countEachFileTypes(project.getRootScriptInfos());
	    return counts2.ts === 0 && counts2.tsx === 0;
	  }
	  function allFilesAreJsOrDts(project) {
	    const counts2 = countEachFileTypes(project.getScriptInfos());
	    return counts2.ts === 0 && counts2.tsx === 0;
	  }
	  function hasNoTypeScriptSource(fileNames) {
	    return !fileNames.some((fileName) => fileExtensionIs(fileName, ".ts" /* Ts */) && !isDeclarationFileName(fileName) || fileExtensionIs(fileName, ".tsx" /* Tsx */));
	  }
	  function isGeneratedFileWatcher(watch) {
	    return watch.generatedFilePath !== void 0;
	  }
	  function getUnresolvedImports(program, cachedUnresolvedImportsPerFile) {
	    var _a, _b;
	    const sourceFiles = program.getSourceFiles();
	    (_a = tracing) == null ? void 0 : _a.push(tracing.Phase.Session, "getUnresolvedImports", { count: sourceFiles.length });
	    const ambientModules = program.getTypeChecker().getAmbientModules().map((mod) => stripQuotes(mod.getName()));
	    const result = sortAndDeduplicate(flatMap(sourceFiles, (sourceFile) => extractUnresolvedImportsFromSourceFile(
	      program,
	      sourceFile,
	      ambientModules,
	      cachedUnresolvedImportsPerFile
	    )));
	    (_b = tracing) == null ? void 0 : _b.pop();
	    return result;
	  }
	  function extractUnresolvedImportsFromSourceFile(program, file, ambientModules, cachedUnresolvedImportsPerFile) {
	    return getOrUpdate(cachedUnresolvedImportsPerFile, file.path, () => {
	      let unresolvedImports;
	      program.forEachResolvedModule(({ resolvedModule }, name) => {
	        if ((!resolvedModule || !resolutionExtensionIsTSOrJson(resolvedModule.extension)) && !isExternalModuleNameRelative(name) && !ambientModules.some((m) => m === name)) {
	          unresolvedImports = append(unresolvedImports, parsePackageName(name).packageName);
	        }
	      }, file);
	      return unresolvedImports || emptyArray2;
	    });
	  }
	  function isInferredProject(project) {
	    return project.projectKind === 0 /* Inferred */;
	  }
	  function isConfiguredProject(project) {
	    return project.projectKind === 1 /* Configured */;
	  }
	  function isExternalProject(project) {
	    return project.projectKind === 2 /* External */;
	  }
	  function isBackgroundProject(project) {
	    return project.projectKind === 3 /* AutoImportProvider */ || project.projectKind === 4 /* Auxiliary */;
	  }
	  var ProjectKind, Project3, InferredProject2, AuxiliaryProject, _AutoImportProviderProject, AutoImportProviderProject, ConfiguredProject2, ExternalProject2;
	  var init_project = __esm({
	    "src/server/project.ts"() {
	      init_ts7();
	      init_ts7();
	      init_ts_server3();
	      ProjectKind = /* @__PURE__ */ ((ProjectKind2) => {
	        ProjectKind2[ProjectKind2["Inferred"] = 0] = "Inferred";
	        ProjectKind2[ProjectKind2["Configured"] = 1] = "Configured";
	        ProjectKind2[ProjectKind2["External"] = 2] = "External";
	        ProjectKind2[ProjectKind2["AutoImportProvider"] = 3] = "AutoImportProvider";
	        ProjectKind2[ProjectKind2["Auxiliary"] = 4] = "Auxiliary";
	        return ProjectKind2;
	      })(ProjectKind || {});
	      Project3 = class _Project {
	        /** @internal */
	        constructor(projectName, projectKind, projectService, documentRegistry, hasExplicitListOfFiles, lastFileExceededProgramSize, compilerOptions, compileOnSaveEnabled, watchOptions, directoryStructureHost, currentDirectory) {
	          this.projectKind = projectKind;
	          this.projectService = projectService;
	          this.documentRegistry = documentRegistry;
	          this.compilerOptions = compilerOptions;
	          this.compileOnSaveEnabled = compileOnSaveEnabled;
	          this.watchOptions = watchOptions;
	          this.rootFiles = [];
	          this.rootFilesMap = /* @__PURE__ */ new Map();
	          /** @internal */
	          this.plugins = [];
	          /**
	           * This is map from files to unresolved imports in it
	           * Maop does not contain entries for files that do not have unresolved imports
	           * This helps in containing the set of files to invalidate
	           *
	           * @internal
	           */
	          this.cachedUnresolvedImportsPerFile = /* @__PURE__ */ new Map();
	          /** @internal */
	          this.hasAddedorRemovedFiles = false;
	          /** @internal */
	          this.hasAddedOrRemovedSymlinks = false;
	          /**
	           * Last version that was reported.
	           */
	          this.lastReportedVersion = 0;
	          /**
	           * Current project's program version. (incremented everytime new program is created that is not complete reuse from the old one)
	           * This property is changed in 'updateGraph' based on the set of files in program
	           * @internal
	           */
	          this.projectProgramVersion = 0;
	          /**
	           * Current version of the project state. It is changed when:
	           * - new root file was added/removed
	           * - edit happen in some file that is currently included in the project.
	           * This property is different from projectStructureVersion since in most cases edits don't affect set of files in the project
	           * @internal
	           */
	          this.projectStateVersion = 0;
	          this.isInitialLoadPending = returnFalse;
	          /** @internal */
	          this.dirty = false;
	          /** @internal */
	          this.typingFiles = emptyArray2;
	          /** @internal */
	          this.moduleSpecifierCache = createModuleSpecifierCache(this);
	          /** @internal */
	          this.createHash = maybeBind(this.projectService.host, this.projectService.host.createHash);
	          /** @internal */
	          this.globalCacheResolutionModuleName = ts_JsTyping_exports.nonRelativeModuleNameForTypingCache;
	          /** @internal */
	          this.updateFromProjectInProgress = false;
	          this.projectName = projectName;
	          this.directoryStructureHost = directoryStructureHost;
	          this.currentDirectory = this.projectService.getNormalizedAbsolutePath(currentDirectory);
	          this.getCanonicalFileName = this.projectService.toCanonicalFileName;
	          this.jsDocParsingMode = this.projectService.jsDocParsingMode;
	          this.cancellationToken = new ThrottledCancellationToken(this.projectService.cancellationToken, this.projectService.throttleWaitMilliseconds);
	          if (!this.compilerOptions) {
	            this.compilerOptions = getDefaultCompilerOptions2();
	            this.compilerOptions.allowNonTsExtensions = true;
	            this.compilerOptions.allowJs = true;
	          } else if (hasExplicitListOfFiles || getAllowJSCompilerOption(this.compilerOptions) || this.projectService.hasDeferredExtension()) {
	            this.compilerOptions.allowNonTsExtensions = true;
	          }
	          switch (projectService.serverMode) {
	            case 0 /* Semantic */:
	              this.languageServiceEnabled = true;
	              break;
	            case 1 /* PartialSemantic */:
	              this.languageServiceEnabled = true;
	              this.compilerOptions.noResolve = true;
	              this.compilerOptions.types = [];
	              break;
	            case 2 /* Syntactic */:
	              this.languageServiceEnabled = false;
	              this.compilerOptions.noResolve = true;
	              this.compilerOptions.types = [];
	              break;
	            default:
	              Debug.assertNever(projectService.serverMode);
	          }
	          this.setInternalCompilerOptionsForEmittingJsFiles();
	          const host = this.projectService.host;
	          if (this.projectService.logger.loggingEnabled()) {
	            this.trace = (s) => this.writeLog(s);
	          } else if (host.trace) {
	            this.trace = (s) => host.trace(s);
	          }
	          this.realpath = maybeBind(host, host.realpath);
	          this.resolutionCache = createResolutionCache(
	            this,
	            this.currentDirectory,
	            /*logChangesWhenResolvingModule*/
	            true
	          );
	          this.languageService = createLanguageService(this, this.documentRegistry, this.projectService.serverMode);
	          if (lastFileExceededProgramSize) {
	            this.disableLanguageService(lastFileExceededProgramSize);
	          }
	          this.markAsDirty();
	          if (!isBackgroundProject(this)) {
	            this.projectService.pendingEnsureProjectForOpenFiles = true;
	          }
	          this.projectService.onProjectCreation(this);
	        }
	        /** @internal */
	        getResolvedProjectReferenceToRedirect(_fileName) {
	          return void 0;
	        }
	        isNonTsProject() {
	          updateProjectIfDirty(this);
	          return allFilesAreJsOrDts(this);
	        }
	        isJsOnlyProject() {
	          updateProjectIfDirty(this);
	          return hasOneOrMoreJsAndNoTsFiles(this);
	        }
	        static resolveModule(moduleName, initialDir, host, log) {
	          return _Project.importServicePluginSync({ name: moduleName }, [initialDir], host, log).resolvedModule;
	        }
	        /** @internal */
	        static importServicePluginSync(pluginConfigEntry, searchPaths, host, log) {
	          Debug.assertIsDefined(host.require);
	          let errorLogs;
	          let resolvedModule;
	          for (const initialDir of searchPaths) {
	            const resolvedPath = normalizeSlashes(host.resolvePath(combinePaths(initialDir, "node_modules")));
	            log(`Loading ${pluginConfigEntry.name} from ${initialDir} (resolved to ${resolvedPath})`);
	            const result = host.require(resolvedPath, pluginConfigEntry.name);
	            if (!result.error) {
	              resolvedModule = result.module;
	              break;
	            }
	            const err = result.error.stack || result.error.message || JSON.stringify(result.error);
	            (errorLogs ?? (errorLogs = [])).push(`Failed to load module '${pluginConfigEntry.name}' from ${resolvedPath}: ${err}`);
	          }
	          return { pluginConfigEntry, resolvedModule, errorLogs };
	        }
	        /** @internal */
	        static async importServicePluginAsync(pluginConfigEntry, searchPaths, host, log) {
	          Debug.assertIsDefined(host.importPlugin);
	          let errorLogs;
	          let resolvedModule;
	          for (const initialDir of searchPaths) {
	            const resolvedPath = combinePaths(initialDir, "node_modules");
	            log(`Dynamically importing ${pluginConfigEntry.name} from ${initialDir} (resolved to ${resolvedPath})`);
	            let result;
	            try {
	              result = await host.importPlugin(resolvedPath, pluginConfigEntry.name);
	            } catch (e) {
	              result = { module: void 0, error: e };
	            }
	            if (!result.error) {
	              resolvedModule = result.module;
	              break;
	            }
	            const err = result.error.stack || result.error.message || JSON.stringify(result.error);
	            (errorLogs ?? (errorLogs = [])).push(`Failed to dynamically import module '${pluginConfigEntry.name}' from ${resolvedPath}: ${err}`);
	          }
	          return { pluginConfigEntry, resolvedModule, errorLogs };
	        }
	        isKnownTypesPackageName(name) {
	          return this.typingsCache.isKnownTypesPackageName(name);
	        }
	        installPackage(options) {
	          return this.typingsCache.installPackage({ ...options, projectName: this.projectName, projectRootPath: this.toPath(this.currentDirectory) });
	        }
	        /** @internal */
	        getGlobalTypingsCacheLocation() {
	          return this.getGlobalCache();
	        }
	        get typingsCache() {
	          return this.projectService.typingsCache;
	        }
	        /** @internal */
	        getSymlinkCache() {
	          if (!this.symlinks) {
	            this.symlinks = createSymlinkCache(this.getCurrentDirectory(), this.getCanonicalFileName);
	          }
	          if (this.program && !this.symlinks.hasProcessedResolutions()) {
	            this.symlinks.setSymlinksFromResolutions(
	              this.program.forEachResolvedModule,
	              this.program.forEachResolvedTypeReferenceDirective,
	              this.program.getAutomaticTypeDirectiveResolutions()
	            );
	          }
	          return this.symlinks;
	        }
	        // Method of LanguageServiceHost
	        getCompilationSettings() {
	          return this.compilerOptions;
	        }
	        // Method to support public API
	        getCompilerOptions() {
	          return this.getCompilationSettings();
	        }
	        getNewLine() {
	          return this.projectService.host.newLine;
	        }
	        getProjectVersion() {
	          return this.projectStateVersion.toString();
	        }
	        getProjectReferences() {
	          return void 0;
	        }
	        getScriptFileNames() {
	          if (!this.rootFiles) {
	            return emptyArray;
	          }
	          let result;
	          this.rootFilesMap.forEach((value) => {
	            if (this.languageServiceEnabled || value.info && value.info.isScriptOpen()) {
	              (result || (result = [])).push(value.fileName);
	            }
	          });
	          return addRange(result, this.typingFiles) || emptyArray;
	        }
	        getOrCreateScriptInfoAndAttachToProject(fileName) {
	          const scriptInfo = this.projectService.getOrCreateScriptInfoNotOpenedByClient(fileName, this.currentDirectory, this.directoryStructureHost);
	          if (scriptInfo) {
	            const existingValue = this.rootFilesMap.get(scriptInfo.path);
	            if (existingValue && existingValue.info !== scriptInfo) {
	              this.rootFiles.push(scriptInfo);
	              existingValue.info = scriptInfo;
	            }
	            scriptInfo.attachToProject(this);
	          }
	          return scriptInfo;
	        }
	        getScriptKind(fileName) {
	          const info = this.projectService.getScriptInfoForPath(this.toPath(fileName));
	          return info && info.scriptKind;
	        }
	        getScriptVersion(filename) {
	          const info = this.projectService.getOrCreateScriptInfoNotOpenedByClient(filename, this.currentDirectory, this.directoryStructureHost);
	          return info && info.getLatestVersion();
	        }
	        getScriptSnapshot(filename) {
	          const scriptInfo = this.getOrCreateScriptInfoAndAttachToProject(filename);
	          if (scriptInfo) {
	            return scriptInfo.getSnapshot();
	          }
	        }
	        getCancellationToken() {
	          return this.cancellationToken;
	        }
	        getCurrentDirectory() {
	          return this.currentDirectory;
	        }
	        getDefaultLibFileName() {
	          const nodeModuleBinDir = getDirectoryPath(normalizePath(this.projectService.getExecutingFilePath()));
	          return combinePaths(nodeModuleBinDir, getDefaultLibFileName(this.compilerOptions));
	        }
	        useCaseSensitiveFileNames() {
	          return this.projectService.host.useCaseSensitiveFileNames;
	        }
	        readDirectory(path, extensions, exclude, include, depth) {
	          return this.directoryStructureHost.readDirectory(path, extensions, exclude, include, depth);
	        }
	        readFile(fileName) {
	          return this.projectService.host.readFile(fileName);
	        }
	        writeFile(fileName, content) {
	          return this.projectService.host.writeFile(fileName, content);
	        }
	        fileExists(file) {
	          const path = this.toPath(file);
	          return !this.isWatchedMissingFile(path) && this.directoryStructureHost.fileExists(file);
	        }
	        /** @internal */
	        resolveModuleNameLiterals(moduleLiterals, containingFile, redirectedReference, options, containingSourceFile, reusedNames) {
	          return this.resolutionCache.resolveModuleNameLiterals(moduleLiterals, containingFile, redirectedReference, options, containingSourceFile, reusedNames);
	        }
	        /** @internal */
	        getModuleResolutionCache() {
	          return this.resolutionCache.getModuleResolutionCache();
	        }
	        /** @internal */
	        resolveTypeReferenceDirectiveReferences(typeDirectiveReferences, containingFile, redirectedReference, options, containingSourceFile, reusedNames) {
	          return this.resolutionCache.resolveTypeReferenceDirectiveReferences(
	            typeDirectiveReferences,
	            containingFile,
	            redirectedReference,
	            options,
	            containingSourceFile,
	            reusedNames
	          );
	        }
	        /** @internal */
	        resolveLibrary(libraryName, resolveFrom, options, libFileName) {
	          return this.resolutionCache.resolveLibrary(libraryName, resolveFrom, options, libFileName);
	        }
	        directoryExists(path) {
	          return this.directoryStructureHost.directoryExists(path);
	        }
	        getDirectories(path) {
	          return this.directoryStructureHost.getDirectories(path);
	        }
	        /** @internal */
	        getCachedDirectoryStructureHost() {
	          return void 0;
	        }
	        /** @internal */
	        toPath(fileName) {
	          return toPath(fileName, this.currentDirectory, this.projectService.toCanonicalFileName);
	        }
	        /** @internal */
	        watchDirectoryOfFailedLookupLocation(directory, cb, flags) {
	          return this.projectService.watchFactory.watchDirectory(
	            directory,
	            cb,
	            flags,
	            this.projectService.getWatchOptions(this),
	            WatchType.FailedLookupLocations,
	            this
	          );
	        }
	        /** @internal */
	        watchAffectingFileLocation(file, cb) {
	          return this.projectService.watchFactory.watchFile(
	            file,
	            cb,
	            2e3 /* High */,
	            this.projectService.getWatchOptions(this),
	            WatchType.AffectingFileLocation,
	            this
	          );
	        }
	        /** @internal */
	        clearInvalidateResolutionOfFailedLookupTimer() {
	          return this.projectService.throttledOperations.cancel(`${this.getProjectName()}FailedLookupInvalidation`);
	        }
	        /** @internal */
	        scheduleInvalidateResolutionsOfFailedLookupLocations() {
	          this.projectService.throttledOperations.schedule(
	            `${this.getProjectName()}FailedLookupInvalidation`,
	            /*delay*/
	            1e3,
	            () => {
	              if (this.resolutionCache.invalidateResolutionsOfFailedLookupLocations()) {
	                this.projectService.delayUpdateProjectGraphAndEnsureProjectStructureForOpenFiles(this);
	              }
	            }
	          );
	        }
	        /** @internal */
	        invalidateResolutionsOfFailedLookupLocations() {
	          if (this.clearInvalidateResolutionOfFailedLookupTimer() && this.resolutionCache.invalidateResolutionsOfFailedLookupLocations()) {
	            this.markAsDirty();
	            this.projectService.delayEnsureProjectForOpenFiles();
	          }
	        }
	        /** @internal */
	        onInvalidatedResolution() {
	          this.projectService.delayUpdateProjectGraphAndEnsureProjectStructureForOpenFiles(this);
	        }
	        /** @internal */
	        watchTypeRootsDirectory(directory, cb, flags) {
	          return this.projectService.watchFactory.watchDirectory(
	            directory,
	            cb,
	            flags,
	            this.projectService.getWatchOptions(this),
	            WatchType.TypeRoots,
	            this
	          );
	        }
	        /** @internal */
	        hasChangedAutomaticTypeDirectiveNames() {
	          return this.resolutionCache.hasChangedAutomaticTypeDirectiveNames();
	        }
	        /** @internal */
	        onChangedAutomaticTypeDirectiveNames() {
	          this.projectService.delayUpdateProjectGraphAndEnsureProjectStructureForOpenFiles(this);
	        }
	        /** @internal */
	        getGlobalCache() {
	          return this.getTypeAcquisition().enable ? this.projectService.typingsInstaller.globalTypingsCacheLocation : void 0;
	        }
	        /** @internal */
	        fileIsOpen(filePath) {
	          return this.projectService.openFiles.has(filePath);
	        }
	        /** @internal */
	        writeLog(s) {
	          this.projectService.logger.info(s);
	        }
	        log(s) {
	          this.writeLog(s);
	        }
	        error(s) {
	          this.projectService.logger.msg(s, "Err" /* Err */);
	        }
	        setInternalCompilerOptionsForEmittingJsFiles() {
	          if (this.projectKind === 0 /* Inferred */ || this.projectKind === 2 /* External */) {
	            this.compilerOptions.noEmitForJsFiles = true;
	          }
	        }
	        /**
	         * Get the errors that dont have any file name associated
	         */
	        getGlobalProjectErrors() {
	          return filter(this.projectErrors, (diagnostic) => !diagnostic.file) || emptyArray2;
	        }
	        /**
	         * Get all the project errors
	         */
	        getAllProjectErrors() {
	          return this.projectErrors || emptyArray2;
	        }
	        setProjectErrors(projectErrors) {
	          this.projectErrors = projectErrors;
	        }
	        getLanguageService(ensureSynchronized = true) {
	          if (ensureSynchronized) {
	            updateProjectIfDirty(this);
	          }
	          return this.languageService;
	        }
	        /** @internal */
	        getSourceMapper() {
	          return this.getLanguageService().getSourceMapper();
	        }
	        /** @internal */
	        clearSourceMapperCache() {
	          this.languageService.clearSourceMapperCache();
	        }
	        /** @internal */
	        getDocumentPositionMapper(generatedFileName, sourceFileName) {
	          return this.projectService.getDocumentPositionMapper(this, generatedFileName, sourceFileName);
	        }
	        /** @internal */
	        getSourceFileLike(fileName) {
	          return this.projectService.getSourceFileLike(fileName, this);
	        }
	        /** @internal */
	        shouldEmitFile(scriptInfo) {
	          return scriptInfo && !scriptInfo.isDynamicOrHasMixedContent() && !this.program.isSourceOfProjectReferenceRedirect(scriptInfo.path);
	        }
	        getCompileOnSaveAffectedFileList(scriptInfo) {
	          if (!this.languageServiceEnabled) {
	            return [];
	          }
	          updateProjectIfDirty(this);
	          this.builderState = BuilderState.create(
	            this.program,
	            this.builderState,
	            /*disableUseFileVersionAsSignature*/
	            true
	          );
	          return mapDefined(
	            BuilderState.getFilesAffectedBy(
	              this.builderState,
	              this.program,
	              scriptInfo.path,
	              this.cancellationToken,
	              this.projectService.host
	            ),
	            (sourceFile) => this.shouldEmitFile(this.projectService.getScriptInfoForPath(sourceFile.path)) ? sourceFile.fileName : void 0
	          );
	        }
	        /**
	         * Returns true if emit was conducted
	         */
	        emitFile(scriptInfo, writeFile2) {
	          if (!this.languageServiceEnabled || !this.shouldEmitFile(scriptInfo)) {
	            return { emitSkipped: true, diagnostics: emptyArray2 };
	          }
	          const { emitSkipped, diagnostics, outputFiles } = this.getLanguageService().getEmitOutput(scriptInfo.fileName);
	          if (!emitSkipped) {
	            for (const outputFile of outputFiles) {
	              const outputFileAbsoluteFileName = getNormalizedAbsolutePath(outputFile.name, this.currentDirectory);
	              writeFile2(outputFileAbsoluteFileName, outputFile.text, outputFile.writeByteOrderMark);
	            }
	            if (this.builderState && getEmitDeclarations(this.compilerOptions)) {
	              const dtsFiles = outputFiles.filter((f) => isDeclarationFileName(f.name));
	              if (dtsFiles.length === 1) {
	                const sourceFile = this.program.getSourceFile(scriptInfo.fileName);
	                const signature = this.projectService.host.createHash ? this.projectService.host.createHash(dtsFiles[0].text) : generateDjb2Hash(dtsFiles[0].text);
	                BuilderState.updateSignatureOfFile(this.builderState, signature, sourceFile.resolvedPath);
	              }
	            }
	          }
	          return { emitSkipped, diagnostics };
	        }
	        enableLanguageService() {
	          if (this.languageServiceEnabled || this.projectService.serverMode === 2 /* Syntactic */) {
	            return;
	          }
	          this.languageServiceEnabled = true;
	          this.lastFileExceededProgramSize = void 0;
	          this.projectService.onUpdateLanguageServiceStateForProject(
	            this,
	            /*languageServiceEnabled*/
	            true
	          );
	        }
	        /** @internal */
	        cleanupProgram() {
	          if (this.program) {
	            for (const f of this.program.getSourceFiles()) {
	              this.detachScriptInfoIfNotRoot(f.fileName);
	            }
	            this.program.forEachResolvedProjectReference((ref) => this.detachScriptInfoFromProject(ref.sourceFile.fileName));
	            this.program = void 0;
	          }
	        }
	        disableLanguageService(lastFileExceededProgramSize) {
	          if (!this.languageServiceEnabled) {
	            return;
	          }
	          Debug.assert(this.projectService.serverMode !== 2 /* Syntactic */);
	          this.languageService.cleanupSemanticCache();
	          this.languageServiceEnabled = false;
	          this.cleanupProgram();
	          this.lastFileExceededProgramSize = lastFileExceededProgramSize;
	          this.builderState = void 0;
	          if (this.autoImportProviderHost) {
	            this.autoImportProviderHost.close();
	          }
	          this.autoImportProviderHost = void 0;
	          this.resolutionCache.closeTypeRootsWatch();
	          this.clearGeneratedFileWatch();
	          this.projectService.verifyDocumentRegistry();
	          this.projectService.onUpdateLanguageServiceStateForProject(
	            this,
	            /*languageServiceEnabled*/
	            false
	          );
	        }
	        getProjectName() {
	          return this.projectName;
	        }
	        removeLocalTypingsFromTypeAcquisition(newTypeAcquisition) {
	          if (!newTypeAcquisition || !newTypeAcquisition.include) {
	            return newTypeAcquisition;
	          }
	          return { ...newTypeAcquisition, include: this.removeExistingTypings(newTypeAcquisition.include) };
	        }
	        getExternalFiles(updateLevel) {
	          return sort(flatMap(this.plugins, (plugin) => {
	            if (typeof plugin.module.getExternalFiles !== "function")
	              return;
	            try {
	              return plugin.module.getExternalFiles(this, updateLevel || 0 /* Update */);
	            } catch (e) {
	              this.projectService.logger.info(`A plugin threw an exception in getExternalFiles: ${e}`);
	              if (e.stack) {
	                this.projectService.logger.info(e.stack);
	              }
	            }
	          }));
	        }
	        getSourceFile(path) {
	          if (!this.program) {
	            return void 0;
	          }
	          return this.program.getSourceFileByPath(path);
	        }
	        /** @internal */
	        getSourceFileOrConfigFile(path) {
	          const options = this.program.getCompilerOptions();
	          return path === options.configFilePath ? options.configFile : this.getSourceFile(path);
	        }
	        close() {
	          var _a;
	          this.projectService.typingsCache.onProjectClosed(this);
	          this.closeWatchingTypingLocations();
	          this.cleanupProgram();
	          forEach(this.externalFiles, (externalFile) => this.detachScriptInfoIfNotRoot(externalFile));
	          for (const root of this.rootFiles) {
	            root.detachFromProject(this);
	          }
	          this.projectService.pendingEnsureProjectForOpenFiles = true;
	          this.rootFiles = void 0;
	          this.rootFilesMap = void 0;
	          this.externalFiles = void 0;
	          this.program = void 0;
	          this.builderState = void 0;
	          this.resolutionCache.clear();
	          this.resolutionCache = void 0;
	          this.cachedUnresolvedImportsPerFile = void 0;
	          (_a = this.packageJsonWatches) == null ? void 0 : _a.forEach((watcher) => {
	            watcher.projects.delete(this);
	            watcher.close();
	          });
	          this.packageJsonWatches = void 0;
	          this.moduleSpecifierCache.clear();
	          this.moduleSpecifierCache = void 0;
	          this.directoryStructureHost = void 0;
	          this.exportMapCache = void 0;
	          this.projectErrors = void 0;
	          this.plugins.length = 0;
	          if (this.missingFilesMap) {
	            clearMap(this.missingFilesMap, closeFileWatcher);
	            this.missingFilesMap = void 0;
	          }
	          this.clearGeneratedFileWatch();
	          this.clearInvalidateResolutionOfFailedLookupTimer();
	          if (this.autoImportProviderHost) {
	            this.autoImportProviderHost.close();
	          }
	          this.autoImportProviderHost = void 0;
	          if (this.noDtsResolutionProject) {
	            this.noDtsResolutionProject.close();
	          }
	          this.noDtsResolutionProject = void 0;
	          this.languageService.dispose();
	          this.languageService = void 0;
	        }
	        detachScriptInfoIfNotRoot(uncheckedFilename) {
	          const info = this.projectService.getScriptInfo(uncheckedFilename);
	          if (info && !this.isRoot(info)) {
	            info.detachFromProject(this);
	          }
	        }
	        isClosed() {
	          return this.rootFiles === void 0;
	        }
	        hasRoots() {
	          return this.rootFiles && this.rootFiles.length > 0;
	        }
	        /** @internal */
	        isOrphan() {
	          return false;
	        }
	        getRootFiles() {
	          return this.rootFiles && this.rootFiles.map((info) => info.fileName);
	        }
	        /** @internal */
	        getRootFilesMap() {
	          return this.rootFilesMap;
	        }
	        getRootScriptInfos() {
	          return this.rootFiles;
	        }
	        getScriptInfos() {
	          if (!this.languageServiceEnabled) {
	            return this.rootFiles;
	          }
	          return map(this.program.getSourceFiles(), (sourceFile) => {
	            const scriptInfo = this.projectService.getScriptInfoForPath(sourceFile.resolvedPath);
	            Debug.assert(!!scriptInfo, "getScriptInfo", () => `scriptInfo for a file '${sourceFile.fileName}' Path: '${sourceFile.path}' / '${sourceFile.resolvedPath}' is missing.`);
	            return scriptInfo;
	          });
	        }
	        getExcludedFiles() {
	          return emptyArray2;
	        }
	        getFileNames(excludeFilesFromExternalLibraries, excludeConfigFiles) {
	          if (!this.program) {
	            return [];
	          }
	          if (!this.languageServiceEnabled) {
	            let rootFiles = this.getRootFiles();
	            if (this.compilerOptions) {
	              const defaultLibrary = getDefaultLibFilePath(this.compilerOptions);
	              if (defaultLibrary) {
	                (rootFiles || (rootFiles = [])).push(asNormalizedPath(defaultLibrary));
	              }
	            }
	            return rootFiles;
	          }
	          const result = [];
	          for (const f of this.program.getSourceFiles()) {
	            if (excludeFilesFromExternalLibraries && this.program.isSourceFileFromExternalLibrary(f)) {
	              continue;
	            }
	            result.push(asNormalizedPath(f.fileName));
	          }
	          if (!excludeConfigFiles) {
	            const configFile = this.program.getCompilerOptions().configFile;
	            if (configFile) {
	              result.push(asNormalizedPath(configFile.fileName));
	              if (configFile.extendedSourceFiles) {
	                for (const f of configFile.extendedSourceFiles) {
	                  result.push(asNormalizedPath(f));
	                }
	              }
	            }
	          }
	          return result;
	        }
	        /** @internal */
	        getFileNamesWithRedirectInfo(includeProjectReferenceRedirectInfo) {
	          return this.getFileNames().map((fileName) => ({
	            fileName,
	            isSourceOfProjectReferenceRedirect: includeProjectReferenceRedirectInfo && this.isSourceOfProjectReferenceRedirect(fileName)
	          }));
	        }
	        hasConfigFile(configFilePath) {
	          if (this.program && this.languageServiceEnabled) {
	            const configFile = this.program.getCompilerOptions().configFile;
	            if (configFile) {
	              if (configFilePath === asNormalizedPath(configFile.fileName)) {
	                return true;
	              }
	              if (configFile.extendedSourceFiles) {
	                for (const f of configFile.extendedSourceFiles) {
	                  if (configFilePath === asNormalizedPath(f)) {
	                    return true;
	                  }
	                }
	              }
	            }
	          }
	          return false;
	        }
	        containsScriptInfo(info) {
	          if (this.isRoot(info))
	            return true;
	          if (!this.program)
	            return false;
	          const file = this.program.getSourceFileByPath(info.path);
	          return !!file && file.resolvedPath === info.path;
	        }
	        containsFile(filename, requireOpen) {
	          const info = this.projectService.getScriptInfoForNormalizedPath(filename);
	          if (info && (info.isScriptOpen() || !requireOpen)) {
	            return this.containsScriptInfo(info);
	          }
	          return false;
	        }
	        isRoot(info) {
	          var _a;
	          return this.rootFilesMap && ((_a = this.rootFilesMap.get(info.path)) == null ? void 0 : _a.info) === info;
	        }
	        // add a root file to project
	        addRoot(info, fileName) {
	          Debug.assert(!this.isRoot(info));
	          this.rootFiles.push(info);
	          this.rootFilesMap.set(info.path, { fileName: fileName || info.fileName, info });
	          info.attachToProject(this);
	          this.markAsDirty();
	        }
	        // add a root file that doesnt exist on host
	        addMissingFileRoot(fileName) {
	          const path = this.projectService.toPath(fileName);
	          this.rootFilesMap.set(path, { fileName });
	          this.markAsDirty();
	        }
	        removeFile(info, fileExists, detachFromProject) {
	          if (this.isRoot(info)) {
	            this.removeRoot(info);
	          }
	          if (fileExists) {
	            this.resolutionCache.removeResolutionsOfFile(info.path);
	          } else {
	            this.resolutionCache.invalidateResolutionOfFile(info.path);
	          }
	          this.cachedUnresolvedImportsPerFile.delete(info.path);
	          if (detachFromProject) {
	            info.detachFromProject(this);
	          }
	          this.markAsDirty();
	        }
	        registerFileUpdate(fileName) {
	          (this.updatedFileNames || (this.updatedFileNames = /* @__PURE__ */ new Set())).add(fileName);
	        }
	        /** @internal */
	        markFileAsDirty(changedFile) {
	          this.markAsDirty();
	          if (this.exportMapCache && !this.exportMapCache.isEmpty()) {
	            (this.changedFilesForExportMapCache || (this.changedFilesForExportMapCache = /* @__PURE__ */ new Set())).add(changedFile);
	          }
	        }
	        markAsDirty() {
	          if (!this.dirty) {
	            this.projectStateVersion++;
	            this.dirty = true;
	          }
	        }
	        /** @internal */
	        onAutoImportProviderSettingsChanged() {
	          var _a;
	          if (this.autoImportProviderHost === false) {
	            this.autoImportProviderHost = void 0;
	          } else {
	            (_a = this.autoImportProviderHost) == null ? void 0 : _a.markAsDirty();
	          }
	        }
	        /** @internal */
	        onPackageJsonChange() {
	          this.moduleSpecifierCache.clear();
	          if (this.autoImportProviderHost) {
	            this.autoImportProviderHost.markAsDirty();
	          }
	        }
	        /** @internal */
	        onFileAddedOrRemoved(isSymlink) {
	          this.hasAddedorRemovedFiles = true;
	          if (isSymlink) {
	            this.hasAddedOrRemovedSymlinks = true;
	          }
	        }
	        /** @internal */
	        onDiscoveredSymlink() {
	          this.hasAddedOrRemovedSymlinks = true;
	        }
	        /** @internal */
	        updateFromProject() {
	          updateProjectIfDirty(this);
	        }
	        /**
	         * Updates set of files that contribute to this project
	         * @returns: true if set of files in the project stays the same and false - otherwise.
	         */
	        updateGraph() {
	          var _a, _b, _c, _d, _e;
	          (_a = tracing) == null ? void 0 : _a.push(tracing.Phase.Session, "updateGraph", { name: this.projectName, kind: ProjectKind[this.projectKind] });
	          (_b = perfLogger) == null ? void 0 : _b.logStartUpdateGraph();
	          this.resolutionCache.startRecordingFilesWithChangedResolutions();
	          const hasNewProgram = this.updateGraphWorker();
	          const hasAddedorRemovedFiles = this.hasAddedorRemovedFiles;
	          this.hasAddedorRemovedFiles = false;
	          this.hasAddedOrRemovedSymlinks = false;
	          const changedFiles = this.resolutionCache.finishRecordingFilesWithChangedResolutions() || emptyArray2;
	          for (const file of changedFiles) {
	            this.cachedUnresolvedImportsPerFile.delete(file);
	          }
	          if (this.languageServiceEnabled && this.projectService.serverMode === 0 /* Semantic */ && !this.isOrphan()) {
	            if (hasNewProgram || changedFiles.length) {
	              this.lastCachedUnresolvedImportsList = getUnresolvedImports(this.program, this.cachedUnresolvedImportsPerFile);
	            }
	            this.projectService.typingsCache.enqueueInstallTypingsForProject(this, this.lastCachedUnresolvedImportsList, hasAddedorRemovedFiles);
	          } else {
	            this.lastCachedUnresolvedImportsList = void 0;
	          }
	          const isFirstProgramLoad = this.projectProgramVersion === 0 && hasNewProgram;
	          if (hasNewProgram) {
	            this.projectProgramVersion++;
	          }
	          if (hasAddedorRemovedFiles) {
	            if (!this.autoImportProviderHost)
	              this.autoImportProviderHost = void 0;
	            (_c = this.autoImportProviderHost) == null ? void 0 : _c.markAsDirty();
	          }
	          if (isFirstProgramLoad) {
	            this.getPackageJsonAutoImportProvider();
	          }
	          (_d = perfLogger) == null ? void 0 : _d.logStopUpdateGraph();
	          (_e = tracing) == null ? void 0 : _e.pop();
	          return !hasNewProgram;
	        }
	        /** @internal */
	        updateTypingFiles(typingFiles) {
	          if (enumerateInsertsAndDeletes(
	            typingFiles,
	            this.typingFiles,
	            getStringComparer(!this.useCaseSensitiveFileNames()),
	            /*inserted*/
	            noop,
	            (removed) => this.detachScriptInfoFromProject(removed)
	          )) {
	            this.typingFiles = typingFiles;
	            this.resolutionCache.setFilesWithInvalidatedNonRelativeUnresolvedImports(this.cachedUnresolvedImportsPerFile);
	            this.projectService.delayUpdateProjectGraphAndEnsureProjectStructureForOpenFiles(this);
	          }
	        }
	        /** @internal */
	        closeWatchingTypingLocations() {
	          if (this.typingWatchers)
	            clearMap(this.typingWatchers, closeFileWatcher);
	          this.typingWatchers = void 0;
	        }
	        /** @internal */
	        onTypingInstallerWatchInvoke() {
	          this.typingWatchers.isInvoked = true;
	          this.projectService.updateTypingsForProject({ projectName: this.getProjectName(), kind: ActionInvalidate });
	        }
	        /** @internal */
	        watchTypingLocations(files) {
	          if (!files) {
	            this.typingWatchers.isInvoked = false;
	            return;
	          }
	          if (!files.length) {
	            this.closeWatchingTypingLocations();
	            return;
	          }
	          const toRemove = new Map(this.typingWatchers);
	          if (!this.typingWatchers)
	            this.typingWatchers = /* @__PURE__ */ new Map();
	          this.typingWatchers.isInvoked = false;
	          const createProjectWatcher = (path, typingsWatcherType) => {
	            const canonicalPath = this.toPath(path);
	            toRemove.delete(canonicalPath);
	            if (!this.typingWatchers.has(canonicalPath)) {
	              this.typingWatchers.set(
	                canonicalPath,
	                typingsWatcherType === "FileWatcher" /* FileWatcher */ ? this.projectService.watchFactory.watchFile(
	                  path,
	                  () => !this.typingWatchers.isInvoked ? this.onTypingInstallerWatchInvoke() : this.writeLog(`TypingWatchers already invoked`),
	                  2e3 /* High */,
	                  this.projectService.getWatchOptions(this),
	                  WatchType.TypingInstallerLocationFile,
	                  this
	                ) : this.projectService.watchFactory.watchDirectory(
	                  path,
	                  (f) => {
	                    if (this.typingWatchers.isInvoked)
	                      return this.writeLog(`TypingWatchers already invoked`);
	                    if (!fileExtensionIs(f, ".json" /* Json */))
	                      return this.writeLog(`Ignoring files that are not *.json`);
	                    if (comparePaths(f, combinePaths(this.projectService.typingsInstaller.globalTypingsCacheLocation, "package.json"), !this.useCaseSensitiveFileNames()))
	                      return this.writeLog(`Ignoring package.json change at global typings location`);
	                    this.onTypingInstallerWatchInvoke();
	                  },
	                  1 /* Recursive */,
	                  this.projectService.getWatchOptions(this),
	                  WatchType.TypingInstallerLocationDirectory,
	                  this
	                )
	              );
	            }
	          };
	          for (const file of files) {
	            const basename = getBaseFileName(file);
	            if (basename === "package.json" || basename === "bower.json") {
	              createProjectWatcher(file, "FileWatcher" /* FileWatcher */);
	              continue;
	            }
	            if (containsPath(this.currentDirectory, file, this.currentDirectory, !this.useCaseSensitiveFileNames())) {
	              const subDirectory = file.indexOf(directorySeparator, this.currentDirectory.length + 1);
	              if (subDirectory !== -1) {
	                createProjectWatcher(file.substr(0, subDirectory), "DirectoryWatcher" /* DirectoryWatcher */);
	              } else {
	                createProjectWatcher(file, "DirectoryWatcher" /* DirectoryWatcher */);
	              }
	              continue;
	            }
	            if (containsPath(this.projectService.typingsInstaller.globalTypingsCacheLocation, file, this.currentDirectory, !this.useCaseSensitiveFileNames())) {
	              createProjectWatcher(this.projectService.typingsInstaller.globalTypingsCacheLocation, "DirectoryWatcher" /* DirectoryWatcher */);
	              continue;
	            }
	            createProjectWatcher(file, "DirectoryWatcher" /* DirectoryWatcher */);
	          }
	          toRemove.forEach((watch, path) => {
	            watch.close();
	            this.typingWatchers.delete(path);
	          });
	        }
	        /** @internal */
	        getCurrentProgram() {
	          return this.program;
	        }
	        removeExistingTypings(include) {
	          const existing = getAutomaticTypeDirectiveNames(this.getCompilerOptions(), this.directoryStructureHost);
	          return include.filter((i) => !existing.includes(i));
	        }
	        updateGraphWorker() {
	          var _a, _b;
	          const oldProgram = this.languageService.getCurrentProgram();
	          Debug.assert(oldProgram === this.program);
	          Debug.assert(!this.isClosed(), "Called update graph worker of closed project");
	          this.writeLog(`Starting updateGraphWorker: Project: ${this.getProjectName()}`);
	          const start = timestamp();
	          const { hasInvalidatedResolutions, hasInvalidatedLibResolutions } = this.resolutionCache.createHasInvalidatedResolutions(returnFalse, returnFalse);
	          this.hasInvalidatedResolutions = hasInvalidatedResolutions;
	          this.hasInvalidatedLibResolutions = hasInvalidatedLibResolutions;
	          this.resolutionCache.startCachingPerDirectoryResolution();
	          this.dirty = false;
	          this.updateFromProjectInProgress = true;
	          this.program = this.languageService.getProgram();
	          this.updateFromProjectInProgress = false;
	          (_a = tracing) == null ? void 0 : _a.push(tracing.Phase.Session, "finishCachingPerDirectoryResolution");
	          this.resolutionCache.finishCachingPerDirectoryResolution(this.program, oldProgram);
	          (_b = tracing) == null ? void 0 : _b.pop();
	          Debug.assert(oldProgram === void 0 || this.program !== void 0);
	          let hasNewProgram = false;
	          if (this.program && (!oldProgram || this.program !== oldProgram && this.program.structureIsReused !== 2 /* Completely */)) {
	            hasNewProgram = true;
	            if (oldProgram) {
	              for (const f of oldProgram.getSourceFiles()) {
	                const newFile = this.program.getSourceFileByPath(f.resolvedPath);
	                if (!newFile || f.resolvedPath === f.path && newFile.resolvedPath !== f.path) {
	                  this.detachScriptInfoFromProject(
	                    f.fileName,
	                    !!this.program.getSourceFileByPath(f.path),
	                    /*syncDirWatcherRemove*/
	                    true
	                  );
	                }
	              }
	              oldProgram.forEachResolvedProjectReference((resolvedProjectReference) => {
	                if (!this.program.getResolvedProjectReferenceByPath(resolvedProjectReference.sourceFile.path)) {
	                  this.detachScriptInfoFromProject(
	                    resolvedProjectReference.sourceFile.fileName,
	                    /*noRemoveResolution*/
	                    void 0,
	                    /*syncDirWatcherRemove*/
	                    true
	                  );
	                }
	              });
	            }
	            updateMissingFilePathsWatch(
	              this.program,
	              this.missingFilesMap || (this.missingFilesMap = /* @__PURE__ */ new Map()),
	              // Watch the missing files
	              (missingFilePath, missingFileName) => this.addMissingFileWatcher(missingFilePath, missingFileName)
	            );
	            if (this.generatedFilesMap) {
	              const outPath = outFile(this.compilerOptions);
	              if (isGeneratedFileWatcher(this.generatedFilesMap)) {
	                if (!outPath || !this.isValidGeneratedFileWatcher(
	                  removeFileExtension(outPath) + ".d.ts" /* Dts */,
	                  this.generatedFilesMap
	                )) {
	                  this.clearGeneratedFileWatch();
	                }
	              } else {
	                if (outPath) {
	                  this.clearGeneratedFileWatch();
	                } else {
	                  this.generatedFilesMap.forEach((watcher, source) => {
	                    const sourceFile = this.program.getSourceFileByPath(source);
	                    if (!sourceFile || sourceFile.resolvedPath !== source || !this.isValidGeneratedFileWatcher(
	                      getDeclarationEmitOutputFilePathWorker(sourceFile.fileName, this.compilerOptions, this.currentDirectory, this.program.getCommonSourceDirectory(), this.getCanonicalFileName),
	                      watcher
	                    )) {
	                      closeFileWatcherOf(watcher);
	                      this.generatedFilesMap.delete(source);
	                    }
	                  });
	                }
	              }
	            }
	            if (this.languageServiceEnabled && this.projectService.serverMode === 0 /* Semantic */) {
	              this.resolutionCache.updateTypeRootsWatch();
	            }
	          }
	          this.projectService.verifyProgram(this);
	          if (this.exportMapCache && !this.exportMapCache.isEmpty()) {
	            this.exportMapCache.releaseSymbols();
	            if (this.hasAddedorRemovedFiles || oldProgram && !this.program.structureIsReused) {
	              this.exportMapCache.clear();
	            } else if (this.changedFilesForExportMapCache && oldProgram && this.program) {
	              forEachKey(this.changedFilesForExportMapCache, (fileName) => {
	                const oldSourceFile = oldProgram.getSourceFileByPath(fileName);
	                const sourceFile = this.program.getSourceFileByPath(fileName);
	                if (!oldSourceFile || !sourceFile) {
	                  this.exportMapCache.clear();
	                  return true;
	                }
	                return this.exportMapCache.onFileChanged(oldSourceFile, sourceFile, !!this.getTypeAcquisition().enable);
	              });
	            }
	          }
	          if (this.changedFilesForExportMapCache) {
	            this.changedFilesForExportMapCache.clear();
	          }
	          if (this.hasAddedOrRemovedSymlinks || this.program && !this.program.structureIsReused && this.getCompilerOptions().preserveSymlinks) {
	            this.symlinks = void 0;
	            this.moduleSpecifierCache.clear();
	          }
	          const oldExternalFiles = this.externalFiles || emptyArray2;
	          this.externalFiles = this.getExternalFiles();
	          enumerateInsertsAndDeletes(
	            this.externalFiles,
	            oldExternalFiles,
	            getStringComparer(!this.useCaseSensitiveFileNames()),
	            // Ensure a ScriptInfo is created for new external files. This is performed indirectly
	            // by the host for files in the program when the program is retrieved above but
	            // the program doesn't contain external files so this must be done explicitly.
	            (inserted) => {
	              const scriptInfo = this.projectService.getOrCreateScriptInfoNotOpenedByClient(inserted, this.currentDirectory, this.directoryStructureHost);
	              scriptInfo == null ? void 0 : scriptInfo.attachToProject(this);
	            },
	            (removed) => this.detachScriptInfoFromProject(removed)
	          );
	          const elapsed = timestamp() - start;
	          this.sendPerformanceEvent("UpdateGraph", elapsed);
	          this.writeLog(`Finishing updateGraphWorker: Project: ${this.getProjectName()} projectStateVersion: ${this.projectStateVersion} projectProgramVersion: ${this.projectProgramVersion} structureChanged: ${hasNewProgram}${this.program ? ` structureIsReused:: ${StructureIsReused[this.program.structureIsReused]}` : ""} Elapsed: ${elapsed}ms`);
	          if (this.projectService.logger.isTestLogger) {
	            if (this.program !== oldProgram) {
	              this.print(
	                /*writeProjectFileNames*/
	                true,
	                this.hasAddedorRemovedFiles,
	                /*writeFileVersionAndText*/
	                true
	              );
	            } else {
	              this.writeLog(`Same program as before`);
	            }
	          } else if (this.hasAddedorRemovedFiles) {
	            this.print(
	              /*writeProjectFileNames*/
	              true,
	              /*writeFileExplaination*/
	              true,
	              /*writeFileVersionAndText*/
	              false
	            );
	          } else if (this.program !== oldProgram) {
	            this.writeLog(`Different program with same set of files`);
	          }
	          this.projectService.verifyDocumentRegistry();
	          return hasNewProgram;
	        }
	        /** @internal */
	        sendPerformanceEvent(kind, durationMs) {
	          this.projectService.sendPerformanceEvent(kind, durationMs);
	        }
	        detachScriptInfoFromProject(uncheckedFileName, noRemoveResolution, syncDirWatcherRemove) {
	          const scriptInfoToDetach = this.projectService.getScriptInfo(uncheckedFileName);
	          if (scriptInfoToDetach) {
	            scriptInfoToDetach.detachFromProject(this);
	            if (!noRemoveResolution) {
	              this.resolutionCache.removeResolutionsOfFile(scriptInfoToDetach.path, syncDirWatcherRemove);
	            }
	          }
	        }
	        addMissingFileWatcher(missingFilePath, missingFileName) {
	          var _a;
	          if (isConfiguredProject(this)) {
	            const configFileExistenceInfo = this.projectService.configFileExistenceInfoCache.get(missingFilePath);
	            if ((_a = configFileExistenceInfo == null ? void 0 : configFileExistenceInfo.config) == null ? void 0 : _a.projects.has(this.canonicalConfigFilePath))
	              return noopFileWatcher;
	          }
	          const fileWatcher = this.projectService.watchFactory.watchFile(
	            getNormalizedAbsolutePath(missingFileName, this.currentDirectory),
	            (fileName, eventKind) => {
	              if (isConfiguredProject(this)) {
	                this.getCachedDirectoryStructureHost().addOrDeleteFile(fileName, missingFilePath, eventKind);
	              }
	              if (eventKind === 0 /* Created */ && this.missingFilesMap.has(missingFilePath)) {
	                this.missingFilesMap.delete(missingFilePath);
	                fileWatcher.close();
	                this.projectService.delayUpdateProjectGraphAndEnsureProjectStructureForOpenFiles(this);
	              }
	            },
	            500 /* Medium */,
	            this.projectService.getWatchOptions(this),
	            WatchType.MissingFile,
	            this
	          );
	          return fileWatcher;
	        }
	        isWatchedMissingFile(path) {
	          return !!this.missingFilesMap && this.missingFilesMap.has(path);
	        }
	        /** @internal */
	        addGeneratedFileWatch(generatedFile, sourceFile) {
	          if (outFile(this.compilerOptions)) {
	            if (!this.generatedFilesMap) {
	              this.generatedFilesMap = this.createGeneratedFileWatcher(generatedFile);
	            }
	          } else {
	            const path = this.toPath(sourceFile);
	            if (this.generatedFilesMap) {
	              if (isGeneratedFileWatcher(this.generatedFilesMap)) {
	                Debug.fail(`${this.projectName} Expected to not have --out watcher for generated file with options: ${JSON.stringify(this.compilerOptions)}`);
	                return;
	              }
	              if (this.generatedFilesMap.has(path))
	                return;
	            } else {
	              this.generatedFilesMap = /* @__PURE__ */ new Map();
	            }
	            this.generatedFilesMap.set(path, this.createGeneratedFileWatcher(generatedFile));
	          }
	        }
	        createGeneratedFileWatcher(generatedFile) {
	          return {
	            generatedFilePath: this.toPath(generatedFile),
	            watcher: this.projectService.watchFactory.watchFile(
	              generatedFile,
	              () => {
	                this.clearSourceMapperCache();
	                this.projectService.delayUpdateProjectGraphAndEnsureProjectStructureForOpenFiles(this);
	              },
	              2e3 /* High */,
	              this.projectService.getWatchOptions(this),
	              WatchType.MissingGeneratedFile,
	              this
	            )
	          };
	        }
	        isValidGeneratedFileWatcher(generateFile, watcher) {
	          return this.toPath(generateFile) === watcher.generatedFilePath;
	        }
	        clearGeneratedFileWatch() {
	          if (this.generatedFilesMap) {
	            if (isGeneratedFileWatcher(this.generatedFilesMap)) {
	              closeFileWatcherOf(this.generatedFilesMap);
	            } else {
	              clearMap(this.generatedFilesMap, closeFileWatcherOf);
	            }
	            this.generatedFilesMap = void 0;
	          }
	        }
	        getScriptInfoForNormalizedPath(fileName) {
	          const scriptInfo = this.projectService.getScriptInfoForPath(this.toPath(fileName));
	          if (scriptInfo && !scriptInfo.isAttached(this)) {
	            return Errors.ThrowProjectDoesNotContainDocument(fileName, this);
	          }
	          return scriptInfo;
	        }
	        getScriptInfo(uncheckedFileName) {
	          return this.projectService.getScriptInfo(uncheckedFileName);
	        }
	        filesToString(writeProjectFileNames) {
	          return this.filesToStringWorker(
	            writeProjectFileNames,
	            /*writeFileExplaination*/
	            true,
	            /*writeFileVersionAndText*/
	            false
	          );
	        }
	        /** @internal */
	        filesToStringWorker(writeProjectFileNames, writeFileExplaination, writeFileVersionAndText) {
	          if (this.isInitialLoadPending())
	            return "	Files (0) InitialLoadPending\n";
	          if (!this.program)
	            return "	Files (0) NoProgram\n";
	          const sourceFiles = this.program.getSourceFiles();
	          let strBuilder = `	Files (${sourceFiles.length})
`;
	          if (writeProjectFileNames) {
	            for (const file of sourceFiles) {
	              strBuilder += `	${file.fileName}${writeFileVersionAndText ? ` ${file.version} ${JSON.stringify(file.text)}` : ""}
`;
	            }
	            if (writeFileExplaination) {
	              strBuilder += "\n\n";
	              explainFiles(this.program, (s) => strBuilder += `	${s}
`);
	            }
	          }
	          return strBuilder;
	        }
	        /** @internal */
	        print(writeProjectFileNames, writeFileExplaination, writeFileVersionAndText) {
	          var _a;
	          this.writeLog(`Project '${this.projectName}' (${ProjectKind[this.projectKind]})`);
	          this.writeLog(this.filesToStringWorker(
	            writeProjectFileNames && this.projectService.logger.hasLevel(3 /* verbose */),
	            writeFileExplaination && this.projectService.logger.hasLevel(3 /* verbose */),
	            writeFileVersionAndText && this.projectService.logger.hasLevel(3 /* verbose */)
	          ));
	          this.writeLog("-----------------------------------------------");
	          if (this.autoImportProviderHost) {
	            this.autoImportProviderHost.print(
	              /*writeProjectFileNames*/
	              false,
	              /*writeFileExplaination*/
	              false,
	              /*writeFileVersionAndText*/
	              false
	            );
	          }
	          (_a = this.noDtsResolutionProject) == null ? void 0 : _a.print(
	            /*writeProjectFileNames*/
	            false,
	            /*writeFileExplaination*/
	            false,
	            /*writeFileVersionAndText*/
	            false
	          );
	        }
	        setCompilerOptions(compilerOptions) {
	          var _a;
	          if (compilerOptions) {
	            compilerOptions.allowNonTsExtensions = true;
	            const oldOptions = this.compilerOptions;
	            this.compilerOptions = compilerOptions;
	            this.setInternalCompilerOptionsForEmittingJsFiles();
	            (_a = this.noDtsResolutionProject) == null ? void 0 : _a.setCompilerOptions(this.getCompilerOptionsForNoDtsResolutionProject());
	            if (changesAffectModuleResolution(oldOptions, compilerOptions)) {
	              this.cachedUnresolvedImportsPerFile.clear();
	              this.lastCachedUnresolvedImportsList = void 0;
	              this.resolutionCache.onChangesAffectModuleResolution();
	              this.moduleSpecifierCache.clear();
	            }
	            this.markAsDirty();
	          }
	        }
	        /** @internal */
	        setWatchOptions(watchOptions) {
	          this.watchOptions = watchOptions;
	        }
	        /** @internal */
	        getWatchOptions() {
	          return this.watchOptions;
	        }
	        setTypeAcquisition(newTypeAcquisition) {
	          if (newTypeAcquisition) {
	            this.typeAcquisition = this.removeLocalTypingsFromTypeAcquisition(newTypeAcquisition);
	          }
	        }
	        getTypeAcquisition() {
	          return this.typeAcquisition || {};
	        }
	        /** @internal */
	        getChangesSinceVersion(lastKnownVersion, includeProjectReferenceRedirectInfo) {
	          var _a, _b;
	          const includeProjectReferenceRedirectInfoIfRequested = includeProjectReferenceRedirectInfo ? (files) => arrayFrom(files.entries(), ([fileName, isSourceOfProjectReferenceRedirect]) => ({
	            fileName,
	            isSourceOfProjectReferenceRedirect
	          })) : (files) => arrayFrom(files.keys());
	          if (!this.isInitialLoadPending()) {
	            updateProjectIfDirty(this);
	          }
	          const info = {
	            projectName: this.getProjectName(),
	            version: this.projectProgramVersion,
	            isInferred: isInferredProject(this),
	            options: this.getCompilationSettings(),
	            languageServiceDisabled: !this.languageServiceEnabled,
	            lastFileExceededProgramSize: this.lastFileExceededProgramSize
	          };
	          const updatedFileNames = this.updatedFileNames;
	          this.updatedFileNames = void 0;
	          if (this.lastReportedFileNames && lastKnownVersion === this.lastReportedVersion) {
	            if (this.projectProgramVersion === this.lastReportedVersion && !updatedFileNames) {
	              return { info, projectErrors: this.getGlobalProjectErrors() };
	            }
	            const lastReportedFileNames = this.lastReportedFileNames;
	            const externalFiles = ((_a = this.externalFiles) == null ? void 0 : _a.map((f) => ({
	              fileName: toNormalizedPath(f),
	              isSourceOfProjectReferenceRedirect: false
	            }))) || emptyArray2;
	            const currentFiles = arrayToMap(
	              this.getFileNamesWithRedirectInfo(!!includeProjectReferenceRedirectInfo).concat(externalFiles),
	              (info2) => info2.fileName,
	              (info2) => info2.isSourceOfProjectReferenceRedirect
	            );
	            const added = /* @__PURE__ */ new Map();
	            const removed = /* @__PURE__ */ new Map();
	            const updated = updatedFileNames ? arrayFrom(updatedFileNames.keys()) : [];
	            const updatedRedirects = [];
	            forEachEntry(currentFiles, (isSourceOfProjectReferenceRedirect, fileName) => {
	              if (!lastReportedFileNames.has(fileName)) {
	                added.set(fileName, isSourceOfProjectReferenceRedirect);
	              } else if (includeProjectReferenceRedirectInfo && isSourceOfProjectReferenceRedirect !== lastReportedFileNames.get(fileName)) {
	                updatedRedirects.push({
	                  fileName,
	                  isSourceOfProjectReferenceRedirect
	                });
	              }
	            });
	            forEachEntry(lastReportedFileNames, (isSourceOfProjectReferenceRedirect, fileName) => {
	              if (!currentFiles.has(fileName)) {
	                removed.set(fileName, isSourceOfProjectReferenceRedirect);
	              }
	            });
	            this.lastReportedFileNames = currentFiles;
	            this.lastReportedVersion = this.projectProgramVersion;
	            return {
	              info,
	              changes: {
	                added: includeProjectReferenceRedirectInfoIfRequested(added),
	                removed: includeProjectReferenceRedirectInfoIfRequested(removed),
	                updated: includeProjectReferenceRedirectInfo ? updated.map((fileName) => ({
	                  fileName,
	                  isSourceOfProjectReferenceRedirect: this.isSourceOfProjectReferenceRedirect(fileName)
	                })) : updated,
	                updatedRedirects: includeProjectReferenceRedirectInfo ? updatedRedirects : void 0
	              },
	              projectErrors: this.getGlobalProjectErrors()
	            };
	          } else {
	            const projectFileNames = this.getFileNamesWithRedirectInfo(!!includeProjectReferenceRedirectInfo);
	            const externalFiles = ((_b = this.externalFiles) == null ? void 0 : _b.map((f) => ({
	              fileName: toNormalizedPath(f),
	              isSourceOfProjectReferenceRedirect: false
	            }))) || emptyArray2;
	            const allFiles = projectFileNames.concat(externalFiles);
	            this.lastReportedFileNames = arrayToMap(
	              allFiles,
	              (info2) => info2.fileName,
	              (info2) => info2.isSourceOfProjectReferenceRedirect
	            );
	            this.lastReportedVersion = this.projectProgramVersion;
	            return {
	              info,
	              files: includeProjectReferenceRedirectInfo ? allFiles : allFiles.map((f) => f.fileName),
	              projectErrors: this.getGlobalProjectErrors()
	            };
	          }
	        }
	        // remove a root file from project
	        removeRoot(info) {
	          orderedRemoveItem(this.rootFiles, info);
	          this.rootFilesMap.delete(info.path);
	        }
	        /** @internal */
	        isSourceOfProjectReferenceRedirect(fileName) {
	          return !!this.program && this.program.isSourceOfProjectReferenceRedirect(fileName);
	        }
	        /** @internal */
	        getGlobalPluginSearchPaths() {
	          return [
	            ...this.projectService.pluginProbeLocations,
	            // ../../.. to walk from X/node_modules/typescript/lib/tsserver.js to X/node_modules/
	            combinePaths(this.projectService.getExecutingFilePath(), "../../..")
	          ];
	        }
	        enableGlobalPlugins(options) {
	          if (!this.projectService.globalPlugins.length)
	            return;
	          const host = this.projectService.host;
	          if (!host.require && !host.importPlugin) {
	            this.projectService.logger.info("Plugins were requested but not running in environment that supports 'require'. Nothing will be loaded");
	            return;
	          }
	          const searchPaths = this.getGlobalPluginSearchPaths();
	          for (const globalPluginName of this.projectService.globalPlugins) {
	            if (!globalPluginName)
	              continue;
	            if (options.plugins && options.plugins.some((p) => p.name === globalPluginName))
	              continue;
	            this.projectService.logger.info(`Loading global plugin ${globalPluginName}`);
	            this.enablePlugin({ name: globalPluginName, global: true }, searchPaths);
	          }
	        }
	        enablePlugin(pluginConfigEntry, searchPaths) {
	          this.projectService.requestEnablePlugin(this, pluginConfigEntry, searchPaths);
	        }
	        /** @internal */
	        enableProxy(pluginModuleFactory, configEntry) {
	          try {
	            if (typeof pluginModuleFactory !== "function") {
	              this.projectService.logger.info(`Skipped loading plugin ${configEntry.name} because it did not expose a proper factory function`);
	              return;
	            }
	            const info = {
	              config: configEntry,
	              project: this,
	              languageService: this.languageService,
	              languageServiceHost: this,
	              serverHost: this.projectService.host,
	              session: this.projectService.session
	            };
	            const pluginModule = pluginModuleFactory({ typescript: ts_exports2 });
	            const newLS = pluginModule.create(info);
	            for (const k of Object.keys(this.languageService)) {
	              if (!(k in newLS)) {
	                this.projectService.logger.info(`Plugin activation warning: Missing proxied method ${k} in created LS. Patching.`);
	                newLS[k] = this.languageService[k];
	              }
	            }
	            this.projectService.logger.info(`Plugin validation succeeded`);
	            this.languageService = newLS;
	            this.plugins.push({ name: configEntry.name, module: pluginModule });
	          } catch (e) {
	            this.projectService.logger.info(`Plugin activation failed: ${e}`);
	          }
	        }
	        /** @internal */
	        onPluginConfigurationChanged(pluginName, configuration) {
	          this.plugins.filter((plugin) => plugin.name === pluginName).forEach((plugin) => {
	            if (plugin.module.onConfigurationChanged) {
	              plugin.module.onConfigurationChanged(configuration);
	            }
	          });
	        }
	        /** Starts a new check for diagnostics. Call this if some file has updated that would cause diagnostics to be changed. */
	        refreshDiagnostics() {
	          this.projectService.sendProjectsUpdatedInBackgroundEvent();
	        }
	        /** @internal */
	        getPackageJsonsVisibleToFile(fileName, rootDir) {
	          if (this.projectService.serverMode !== 0 /* Semantic */)
	            return emptyArray2;
	          return this.projectService.getPackageJsonsVisibleToFile(fileName, this, rootDir);
	        }
	        /** @internal */
	        getNearestAncestorDirectoryWithPackageJson(fileName) {
	          return this.projectService.getNearestAncestorDirectoryWithPackageJson(fileName);
	        }
	        /** @internal */
	        getPackageJsonsForAutoImport(rootDir) {
	          return this.getPackageJsonsVisibleToFile(combinePaths(this.currentDirectory, inferredTypesContainingFile), rootDir);
	        }
	        /** @internal */
	        getPackageJsonCache() {
	          return this.projectService.packageJsonCache;
	        }
	        /** @internal */
	        getCachedExportInfoMap() {
	          return this.exportMapCache || (this.exportMapCache = createCacheableExportInfoMap(this));
	        }
	        /** @internal */
	        clearCachedExportInfoMap() {
	          var _a;
	          (_a = this.exportMapCache) == null ? void 0 : _a.clear();
	        }
	        /** @internal */
	        getModuleSpecifierCache() {
	          return this.moduleSpecifierCache;
	        }
	        /** @internal */
	        includePackageJsonAutoImports() {
	          if (this.projectService.includePackageJsonAutoImports() === 0 /* Off */ || !this.languageServiceEnabled || isInsideNodeModules(this.currentDirectory) || !this.isDefaultProjectForOpenFiles()) {
	            return 0 /* Off */;
	          }
	          return this.projectService.includePackageJsonAutoImports();
	        }
	        /** @internal */
	        getHostForAutoImportProvider() {
	          var _a, _b;
	          if (this.program) {
	            return {
	              fileExists: this.program.fileExists,
	              directoryExists: this.program.directoryExists,
	              realpath: this.program.realpath || ((_a = this.projectService.host.realpath) == null ? void 0 : _a.bind(this.projectService.host)),
	              getCurrentDirectory: this.getCurrentDirectory.bind(this),
	              readFile: this.projectService.host.readFile.bind(this.projectService.host),
	              getDirectories: this.projectService.host.getDirectories.bind(this.projectService.host),
	              trace: (_b = this.projectService.host.trace) == null ? void 0 : _b.bind(this.projectService.host),
	              useCaseSensitiveFileNames: this.program.useCaseSensitiveFileNames(),
	              readDirectory: this.projectService.host.readDirectory.bind(this.projectService.host)
	            };
	          }
	          return this.projectService.host;
	        }
	        /** @internal */
	        getPackageJsonAutoImportProvider() {
	          var _a, _b, _c;
	          if (this.autoImportProviderHost === false) {
	            return void 0;
	          }
	          if (this.projectService.serverMode !== 0 /* Semantic */) {
	            this.autoImportProviderHost = false;
	            return void 0;
	          }
	          if (this.autoImportProviderHost) {
	            updateProjectIfDirty(this.autoImportProviderHost);
	            if (this.autoImportProviderHost.isEmpty()) {
	              this.autoImportProviderHost.close();
	              this.autoImportProviderHost = void 0;
	              return void 0;
	            }
	            return this.autoImportProviderHost.getCurrentProgram();
	          }
	          const dependencySelection = this.includePackageJsonAutoImports();
	          if (dependencySelection) {
	            (_a = tracing) == null ? void 0 : _a.push(tracing.Phase.Session, "getPackageJsonAutoImportProvider");
	            const start = timestamp();
	            this.autoImportProviderHost = AutoImportProviderProject.create(dependencySelection, this, this.getHostForAutoImportProvider(), this.documentRegistry);
	            if (this.autoImportProviderHost) {
	              updateProjectIfDirty(this.autoImportProviderHost);
	              this.sendPerformanceEvent("CreatePackageJsonAutoImportProvider", timestamp() - start);
	              (_b = tracing) == null ? void 0 : _b.pop();
	              return this.autoImportProviderHost.getCurrentProgram();
	            }
	            (_c = tracing) == null ? void 0 : _c.pop();
	          }
	        }
	        /** @internal */
	        isDefaultProjectForOpenFiles() {
	          return !!forEachEntry(
	            this.projectService.openFiles,
	            (_, fileName) => this.projectService.tryGetDefaultProjectForFile(toNormalizedPath(fileName)) === this
	          );
	        }
	        /** @internal */
	        watchNodeModulesForPackageJsonChanges(directoryPath) {
	          return this.projectService.watchPackageJsonsInNodeModules(directoryPath, this);
	        }
	        /** @internal */
	        getIncompleteCompletionsCache() {
	          return this.projectService.getIncompleteCompletionsCache();
	        }
	        /** @internal */
	        getNoDtsResolutionProject(rootFile) {
	          Debug.assert(this.projectService.serverMode === 0 /* Semantic */);
	          if (!this.noDtsResolutionProject) {
	            this.noDtsResolutionProject = new AuxiliaryProject(this.projectService, this.documentRegistry, this.getCompilerOptionsForNoDtsResolutionProject(), this.currentDirectory);
	          }
	          if (this.noDtsResolutionProject.rootFile !== rootFile) {
	            this.projectService.setFileNamesOfAutpImportProviderOrAuxillaryProject(this.noDtsResolutionProject, [rootFile]);
	            this.noDtsResolutionProject.rootFile = rootFile;
	          }
	          return this.noDtsResolutionProject;
	        }
	        /** @internal */
	        getCompilerOptionsForNoDtsResolutionProject() {
	          return {
	            ...this.getCompilerOptions(),
	            noDtsResolution: true,
	            allowJs: true,
	            maxNodeModuleJsDepth: 3,
	            diagnostics: false,
	            skipLibCheck: true,
	            sourceMap: false,
	            types: emptyArray,
	            lib: emptyArray,
	            noLib: true
	          };
	        }
	      };
	      InferredProject2 = class extends Project3 {
	        /** @internal */
	        constructor(projectService, documentRegistry, compilerOptions, watchOptions, projectRootPath, currentDirectory, typeAcquisition) {
	          super(
	            projectService.newInferredProjectName(),
	            0 /* Inferred */,
	            projectService,
	            documentRegistry,
	            // TODO: GH#18217
	            /*files*/
	            void 0,
	            /*lastFileExceededProgramSize*/
	            void 0,
	            compilerOptions,
	            /*compileOnSaveEnabled*/
	            false,
	            watchOptions,
	            projectService.host,
	            currentDirectory
	          );
	          this._isJsInferredProject = false;
	          this.typeAcquisition = typeAcquisition;
	          this.projectRootPath = projectRootPath && projectService.toCanonicalFileName(projectRootPath);
	          if (!projectRootPath && !projectService.useSingleInferredProject) {
	            this.canonicalCurrentDirectory = projectService.toCanonicalFileName(this.currentDirectory);
	          }
	          this.enableGlobalPlugins(this.getCompilerOptions());
	        }
	        toggleJsInferredProject(isJsInferredProject) {
	          if (isJsInferredProject !== this._isJsInferredProject) {
	            this._isJsInferredProject = isJsInferredProject;
	            this.setCompilerOptions();
	          }
	        }
	        setCompilerOptions(options) {
	          if (!options && !this.getCompilationSettings()) {
	            return;
	          }
	          const newOptions = cloneCompilerOptions(options || this.getCompilationSettings());
	          if (this._isJsInferredProject && typeof newOptions.maxNodeModuleJsDepth !== "number") {
	            newOptions.maxNodeModuleJsDepth = 2;
	          } else if (!this._isJsInferredProject) {
	            newOptions.maxNodeModuleJsDepth = void 0;
	          }
	          newOptions.allowJs = true;
	          super.setCompilerOptions(newOptions);
	        }
	        addRoot(info) {
	          Debug.assert(info.isScriptOpen());
	          this.projectService.startWatchingConfigFilesForInferredProjectRoot(info);
	          if (!this._isJsInferredProject && info.isJavaScript()) {
	            this.toggleJsInferredProject(
	              /*isJsInferredProject*/
	              true
	            );
	          } else if (this.isOrphan() && this._isJsInferredProject && !info.isJavaScript()) {
	            this.toggleJsInferredProject(
	              /*isJsInferredProject*/
	              false
	            );
	          }
	          super.addRoot(info);
	        }
	        removeRoot(info) {
	          this.projectService.stopWatchingConfigFilesForInferredProjectRoot(info);
	          super.removeRoot(info);
	          if (!this.isOrphan() && this._isJsInferredProject && info.isJavaScript()) {
	            if (every(this.getRootScriptInfos(), (rootInfo) => !rootInfo.isJavaScript())) {
	              this.toggleJsInferredProject(
	                /*isJsInferredProject*/
	                false
	              );
	            }
	          }
	        }
	        /** @internal */
	        isOrphan() {
	          return !this.hasRoots();
	        }
	        isProjectWithSingleRoot() {
	          return !this.projectRootPath && !this.projectService.useSingleInferredProject || this.getRootScriptInfos().length === 1;
	        }
	        close() {
	          forEach(this.getRootScriptInfos(), (info) => this.projectService.stopWatchingConfigFilesForInferredProjectRoot(info));
	          super.close();
	        }
	        getTypeAcquisition() {
	          return this.typeAcquisition || {
	            enable: allRootFilesAreJsOrDts(this),
	            include: emptyArray,
	            exclude: emptyArray
	          };
	        }
	      };
	      AuxiliaryProject = class extends Project3 {
	        constructor(projectService, documentRegistry, compilerOptions, currentDirectory) {
	          super(
	            projectService.newAuxiliaryProjectName(),
	            4 /* Auxiliary */,
	            projectService,
	            documentRegistry,
	            /*hasExplicitListOfFiles*/
	            false,
	            /*lastFileExceededProgramSize*/
	            void 0,
	            compilerOptions,
	            /*compileOnSaveEnabled*/
	            false,
	            /*watchOptions*/
	            void 0,
	            projectService.host,
	            currentDirectory
	          );
	        }
	        isOrphan() {
	          return true;
	        }
	        scheduleInvalidateResolutionsOfFailedLookupLocations() {
	          return;
	        }
	      };
	      _AutoImportProviderProject = class _AutoImportProviderProject extends Project3 {
	        /** @internal */
	        constructor(hostProject, initialRootNames, documentRegistry, compilerOptions) {
	          super(
	            hostProject.projectService.newAutoImportProviderProjectName(),
	            3 /* AutoImportProvider */,
	            hostProject.projectService,
	            documentRegistry,
	            /*hasExplicitListOfFiles*/
	            false,
	            /*lastFileExceededProgramSize*/
	            void 0,
	            compilerOptions,
	            /*compileOnSaveEnabled*/
	            false,
	            hostProject.getWatchOptions(),
	            hostProject.projectService.host,
	            hostProject.currentDirectory
	          );
	          this.hostProject = hostProject;
	          this.rootFileNames = initialRootNames;
	          this.useSourceOfProjectReferenceRedirect = maybeBind(this.hostProject, this.hostProject.useSourceOfProjectReferenceRedirect);
	          this.getParsedCommandLine = maybeBind(this.hostProject, this.hostProject.getParsedCommandLine);
	        }
	        /** @internal */
	        static getRootFileNames(dependencySelection, hostProject, host, compilerOptions) {
	          var _a, _b;
	          if (!dependencySelection) {
	            return emptyArray;
	          }
	          const program = hostProject.getCurrentProgram();
	          if (!program) {
	            return emptyArray;
	          }
	          const start = timestamp();
	          let dependencyNames;
	          let rootNames;
	          const rootFileName = combinePaths(hostProject.currentDirectory, inferredTypesContainingFile);
	          const packageJsons = hostProject.getPackageJsonsForAutoImport(combinePaths(hostProject.currentDirectory, rootFileName));
	          for (const packageJson of packageJsons) {
	            (_a = packageJson.dependencies) == null ? void 0 : _a.forEach((_, dependenyName) => addDependency(dependenyName));
	            (_b = packageJson.peerDependencies) == null ? void 0 : _b.forEach((_, dependencyName) => addDependency(dependencyName));
	          }
	          let dependenciesAdded = 0;
	          if (dependencyNames) {
	            const symlinkCache = hostProject.getSymlinkCache();
	            for (const name of arrayFrom(dependencyNames.keys())) {
	              if (dependencySelection === 2 /* Auto */ && dependenciesAdded > this.maxDependencies) {
	                hostProject.log(`AutoImportProviderProject: attempted to add more than ${this.maxDependencies} dependencies. Aborting.`);
	                return emptyArray;
	              }
	              const packageJson = resolvePackageNameToPackageJson(
	                name,
	                hostProject.currentDirectory,
	                compilerOptions,
	                host,
	                program.getModuleResolutionCache()
	              );
	              if (packageJson) {
	                const entrypoints = getRootNamesFromPackageJson(packageJson, program, symlinkCache);
	                if (entrypoints) {
	                  rootNames = concatenate(rootNames, entrypoints);
	                  dependenciesAdded += entrypoints.length ? 1 : 0;
	                  continue;
	                }
	              }
	              const done = forEach([hostProject.currentDirectory, hostProject.getGlobalTypingsCacheLocation()], (directory) => {
	                if (directory) {
	                  const typesPackageJson = resolvePackageNameToPackageJson(
	                    `@types/${name}`,
	                    directory,
	                    compilerOptions,
	                    host,
	                    program.getModuleResolutionCache()
	                  );
	                  if (typesPackageJson) {
	                    const entrypoints = getRootNamesFromPackageJson(typesPackageJson, program, symlinkCache);
	                    rootNames = concatenate(rootNames, entrypoints);
	                    dependenciesAdded += (entrypoints == null ? void 0 : entrypoints.length) ? 1 : 0;
	                    return true;
	                  }
	                }
	              });
	              if (done)
	                continue;
	              if (packageJson && compilerOptions.allowJs && compilerOptions.maxNodeModuleJsDepth) {
	                const entrypoints = getRootNamesFromPackageJson(
	                  packageJson,
	                  program,
	                  symlinkCache,
	                  /*resolveJs*/
	                  true
	                );
	                rootNames = concatenate(rootNames, entrypoints);
	                dependenciesAdded += (entrypoints == null ? void 0 : entrypoints.length) ? 1 : 0;
	              }
	            }
	          }
	          if (rootNames == null ? void 0 : rootNames.length) {
	            hostProject.log(`AutoImportProviderProject: found ${rootNames.length} root files in ${dependenciesAdded} dependencies in ${timestamp() - start} ms`);
	          }
	          return rootNames || emptyArray;
	          function addDependency(dependency) {
	            if (!startsWith(dependency, "@types/")) {
	              (dependencyNames || (dependencyNames = /* @__PURE__ */ new Set())).add(dependency);
	            }
	          }
	          function getRootNamesFromPackageJson(packageJson, program2, symlinkCache, resolveJs) {
	            var _a2;
	            const entrypoints = getEntrypointsFromPackageJsonInfo(
	              packageJson,
	              compilerOptions,
	              host,
	              program2.getModuleResolutionCache(),
	              resolveJs
	            );
	            if (entrypoints) {
	              const real = (_a2 = host.realpath) == null ? void 0 : _a2.call(host, packageJson.packageDirectory);
	              const realPath2 = real ? hostProject.toPath(real) : void 0;
	              const isSymlink = realPath2 && realPath2 !== hostProject.toPath(packageJson.packageDirectory);
	              if (isSymlink) {
	                symlinkCache.setSymlinkedDirectory(packageJson.packageDirectory, {
	                  real: ensureTrailingDirectorySeparator(real),
	                  realPath: ensureTrailingDirectorySeparator(realPath2)
	                });
	              }
	              return mapDefined(entrypoints, (entrypoint) => {
	                const resolvedFileName = isSymlink ? entrypoint.replace(packageJson.packageDirectory, real) : entrypoint;
	                if (!program2.getSourceFile(resolvedFileName) && !(isSymlink && program2.getSourceFile(entrypoint))) {
	                  return resolvedFileName;
	                }
	              });
	            }
	          }
	        }
	        /** @internal */
	        static create(dependencySelection, hostProject, host, documentRegistry) {
	          if (dependencySelection === 0 /* Off */) {
	            return void 0;
	          }
	          const compilerOptions = {
	            ...hostProject.getCompilerOptions(),
	            ...this.compilerOptionsOverrides
	          };
	          const rootNames = this.getRootFileNames(dependencySelection, hostProject, host, compilerOptions);
	          if (!rootNames.length) {
	            return void 0;
	          }
	          return new _AutoImportProviderProject(hostProject, rootNames, documentRegistry, compilerOptions);
	        }
	        /** @internal */
	        isEmpty() {
	          return !some(this.rootFileNames);
	        }
	        isOrphan() {
	          return true;
	        }
	        updateGraph() {
	          let rootFileNames = this.rootFileNames;
	          if (!rootFileNames) {
	            rootFileNames = _AutoImportProviderProject.getRootFileNames(
	              this.hostProject.includePackageJsonAutoImports(),
	              this.hostProject,
	              this.hostProject.getHostForAutoImportProvider(),
	              this.getCompilationSettings()
	            );
	          }
	          this.projectService.setFileNamesOfAutpImportProviderOrAuxillaryProject(this, rootFileNames);
	          this.rootFileNames = rootFileNames;
	          const oldProgram = this.getCurrentProgram();
	          const hasSameSetOfFiles = super.updateGraph();
	          if (oldProgram && oldProgram !== this.getCurrentProgram()) {
	            this.hostProject.clearCachedExportInfoMap();
	          }
	          return hasSameSetOfFiles;
	        }
	        /** @internal */
	        scheduleInvalidateResolutionsOfFailedLookupLocations() {
	          return;
	        }
	        hasRoots() {
	          var _a;
	          return !!((_a = this.rootFileNames) == null ? void 0 : _a.length);
	        }
	        markAsDirty() {
	          this.rootFileNames = void 0;
	          super.markAsDirty();
	        }
	        getScriptFileNames() {
	          return this.rootFileNames || emptyArray;
	        }
	        getLanguageService() {
	          throw new Error("AutoImportProviderProject language service should never be used. To get the program, use `project.getCurrentProgram()`.");
	        }
	        /** @internal */
	        onAutoImportProviderSettingsChanged() {
	          throw new Error("AutoImportProviderProject is an auto import provider; use `markAsDirty()` instead.");
	        }
	        /** @internal */
	        onPackageJsonChange() {
	          throw new Error("package.json changes should be notified on an AutoImportProvider's host project");
	        }
	        getHostForAutoImportProvider() {
	          throw new Error("AutoImportProviderProject cannot provide its own host; use `hostProject.getModuleResolutionHostForAutomImportProvider()` instead.");
	        }
	        getProjectReferences() {
	          return this.hostProject.getProjectReferences();
	        }
	        /** @internal */
	        includePackageJsonAutoImports() {
	          return 0 /* Off */;
	        }
	        /** @internal */
	        getSymlinkCache() {
	          return this.hostProject.getSymlinkCache();
	        }
	        /** @internal */
	        getModuleResolutionCache() {
	          var _a;
	          return (_a = this.hostProject.getCurrentProgram()) == null ? void 0 : _a.getModuleResolutionCache();
	        }
	      };
	      /** @internal */
	      _AutoImportProviderProject.maxDependencies = 10;
	      /** @internal */
	      _AutoImportProviderProject.compilerOptionsOverrides = {
	        diagnostics: false,
	        skipLibCheck: true,
	        sourceMap: false,
	        types: emptyArray,
	        lib: emptyArray,
	        noLib: true
	      };
	      AutoImportProviderProject = _AutoImportProviderProject;
	      ConfiguredProject2 = class extends Project3 {
	        /** @internal */
	        constructor(configFileName, canonicalConfigFilePath, projectService, documentRegistry, cachedDirectoryStructureHost) {
	          super(
	            configFileName,
	            1 /* Configured */,
	            projectService,
	            documentRegistry,
	            /*hasExplicitListOfFiles*/
	            false,
	            /*lastFileExceededProgramSize*/
	            void 0,
	            /*compilerOptions*/
	            {},
	            /*compileOnSaveEnabled*/
	            false,
	            /*watchOptions*/
	            void 0,
	            cachedDirectoryStructureHost,
	            getDirectoryPath(configFileName)
	          );
	          this.canonicalConfigFilePath = canonicalConfigFilePath;
	          /** @internal */
	          this.openFileWatchTriggered = /* @__PURE__ */ new Map();
	          /** @internal */
	          this.canConfigFileJsonReportNoInputFiles = false;
	          /** Ref count to the project when opened from external project */
	          this.externalProjectRefCount = 0;
	          /** @internal */
	          this.isInitialLoadPending = returnTrue;
	          /** @internal */
	          this.sendLoadingProjectFinish = false;
	        }
	        /** @internal */
	        setCompilerHost(host) {
	          this.compilerHost = host;
	        }
	        /** @internal */
	        getCompilerHost() {
	          return this.compilerHost;
	        }
	        /** @internal */
	        useSourceOfProjectReferenceRedirect() {
	          return this.languageServiceEnabled;
	        }
	        /** @internal */
	        getParsedCommandLine(fileName) {
	          const configFileName = asNormalizedPath(normalizePath(fileName));
	          const canonicalConfigFilePath = asNormalizedPath(this.projectService.toCanonicalFileName(configFileName));
	          let configFileExistenceInfo = this.projectService.configFileExistenceInfoCache.get(canonicalConfigFilePath);
	          if (!configFileExistenceInfo) {
	            this.projectService.configFileExistenceInfoCache.set(canonicalConfigFilePath, configFileExistenceInfo = { exists: this.projectService.host.fileExists(configFileName) });
	          }
	          this.projectService.ensureParsedConfigUptoDate(configFileName, canonicalConfigFilePath, configFileExistenceInfo, this);
	          if (this.languageServiceEnabled && this.projectService.serverMode === 0 /* Semantic */) {
	            this.projectService.watchWildcards(configFileName, configFileExistenceInfo, this);
	          }
	          return configFileExistenceInfo.exists ? configFileExistenceInfo.config.parsedCommandLine : void 0;
	        }
	        /** @internal */
	        onReleaseParsedCommandLine(fileName) {
	          this.releaseParsedConfig(asNormalizedPath(this.projectService.toCanonicalFileName(asNormalizedPath(normalizePath(fileName)))));
	        }
	        /** @internal */
	        releaseParsedConfig(canonicalConfigFilePath) {
	          this.projectService.stopWatchingWildCards(canonicalConfigFilePath, this);
	          this.projectService.releaseParsedConfig(canonicalConfigFilePath, this);
	        }
	        /**
	         * If the project has reload from disk pending, it reloads (and then updates graph as part of that) instead of just updating the graph
	         * @returns: true if set of files in the project stays the same and false - otherwise.
	         */
	        updateGraph() {
	          const isInitialLoad = this.isInitialLoadPending();
	          this.isInitialLoadPending = returnFalse;
	          const updateLevel = this.pendingUpdateLevel;
	          this.pendingUpdateLevel = 0 /* Update */;
	          let result;
	          switch (updateLevel) {
	            case 1 /* RootNamesAndUpdate */:
	              this.openFileWatchTriggered.clear();
	              result = this.projectService.reloadFileNamesOfConfiguredProject(this);
	              break;
	            case 2 /* Full */:
	              this.openFileWatchTriggered.clear();
	              const reason = Debug.checkDefined(this.pendingUpdateReason);
	              this.pendingUpdateReason = void 0;
	              this.projectService.reloadConfiguredProject(
	                this,
	                reason,
	                isInitialLoad,
	                /*clearSemanticCache*/
	                false
	              );
	              result = true;
	              break;
	            default:
	              result = super.updateGraph();
	          }
	          this.compilerHost = void 0;
	          this.projectService.sendProjectLoadingFinishEvent(this);
	          this.projectService.sendProjectTelemetry(this);
	          return result;
	        }
	        /** @internal */
	        getCachedDirectoryStructureHost() {
	          return this.directoryStructureHost;
	        }
	        getConfigFilePath() {
	          return asNormalizedPath(this.getProjectName());
	        }
	        getProjectReferences() {
	          return this.projectReferences;
	        }
	        updateReferences(refs) {
	          this.projectReferences = refs;
	          this.potentialProjectReferences = void 0;
	        }
	        /** @internal */
	        setPotentialProjectReference(canonicalConfigPath) {
	          Debug.assert(this.isInitialLoadPending());
	          (this.potentialProjectReferences || (this.potentialProjectReferences = /* @__PURE__ */ new Set())).add(canonicalConfigPath);
	        }
	        /** @internal */
	        getResolvedProjectReferenceToRedirect(fileName) {
	          const program = this.getCurrentProgram();
	          return program && program.getResolvedProjectReferenceToRedirect(fileName);
	        }
	        /** @internal */
	        forEachResolvedProjectReference(cb) {
	          var _a;
	          return (_a = this.getCurrentProgram()) == null ? void 0 : _a.forEachResolvedProjectReference(cb);
	        }
	        /** @internal */
	        enablePluginsWithOptions(options) {
	          var _a;
	          this.plugins.length = 0;
	          if (!((_a = options.plugins) == null ? void 0 : _a.length) && !this.projectService.globalPlugins.length)
	            return;
	          const host = this.projectService.host;
	          if (!host.require && !host.importPlugin) {
	            this.projectService.logger.info("Plugins were requested but not running in environment that supports 'require'. Nothing will be loaded");
	            return;
	          }
	          const searchPaths = this.getGlobalPluginSearchPaths();
	          if (this.projectService.allowLocalPluginLoads) {
	            const local = getDirectoryPath(this.canonicalConfigFilePath);
	            this.projectService.logger.info(`Local plugin loading enabled; adding ${local} to search paths`);
	            searchPaths.unshift(local);
	          }
	          if (options.plugins) {
	            for (const pluginConfigEntry of options.plugins) {
	              this.enablePlugin(pluginConfigEntry, searchPaths);
	            }
	          }
	          return this.enableGlobalPlugins(options);
	        }
	        /**
	         * Get the errors that dont have any file name associated
	         */
	        getGlobalProjectErrors() {
	          return filter(this.projectErrors, (diagnostic) => !diagnostic.file) || emptyArray2;
	        }
	        /**
	         * Get all the project errors
	         */
	        getAllProjectErrors() {
	          return this.projectErrors || emptyArray2;
	        }
	        setProjectErrors(projectErrors) {
	          this.projectErrors = projectErrors;
	        }
	        close() {
	          this.projectService.configFileExistenceInfoCache.forEach((_configFileExistenceInfo, canonicalConfigFilePath) => this.releaseParsedConfig(canonicalConfigFilePath));
	          this.projectErrors = void 0;
	          this.openFileWatchTriggered.clear();
	          this.compilerHost = void 0;
	          super.close();
	        }
	        /** @internal */
	        addExternalProjectReference() {
	          this.externalProjectRefCount++;
	        }
	        /** @internal */
	        deleteExternalProjectReference() {
	          this.externalProjectRefCount--;
	        }
	        /** @internal */
	        isSolution() {
	          return this.getRootFilesMap().size === 0 && !this.canConfigFileJsonReportNoInputFiles;
	        }
	        /**
	         * Find the configured project from the project references in project which contains the info directly
	         *
	         * @internal
	         */
	        getDefaultChildProjectFromProjectWithReferences(info) {
	          return forEachResolvedProjectReferenceProject(
	            this,
	            info.path,
	            (child) => projectContainsInfoDirectly(child, info) ? child : void 0,
	            0 /* Find */
	          );
	        }
	        /**
	         * Returns true if the project is needed by any of the open script info/external project
	         *
	         * @internal
	         */
	        hasOpenRef() {
	          var _a;
	          if (!!this.externalProjectRefCount) {
	            return true;
	          }
	          if (this.isClosed()) {
	            return false;
	          }
	          const configFileExistenceInfo = this.projectService.configFileExistenceInfoCache.get(this.canonicalConfigFilePath);
	          if (this.projectService.hasPendingProjectUpdate(this)) {
	            return !!((_a = configFileExistenceInfo.openFilesImpactedByConfigFile) == null ? void 0 : _a.size);
	          }
	          return !!configFileExistenceInfo.openFilesImpactedByConfigFile && forEachEntry(
	            configFileExistenceInfo.openFilesImpactedByConfigFile,
	            (_value, infoPath) => {
	              const info = this.projectService.getScriptInfoForPath(infoPath);
	              return this.containsScriptInfo(info) || !!forEachResolvedProjectReferenceProject(
	                this,
	                info.path,
	                (child) => child.containsScriptInfo(info),
	                0 /* Find */
	              );
	            }
	          ) || false;
	        }
	        /** @internal */
	        hasExternalProjectRef() {
	          return !!this.externalProjectRefCount;
	        }
	        getEffectiveTypeRoots() {
	          return getEffectiveTypeRoots(this.getCompilationSettings(), this) || [];
	        }
	        /** @internal */
	        updateErrorOnNoInputFiles(fileNames) {
	          updateErrorForNoInputFiles(fileNames, this.getConfigFilePath(), this.getCompilerOptions().configFile.configFileSpecs, this.projectErrors, this.canConfigFileJsonReportNoInputFiles);
	        }
	      };
	      ExternalProject2 = class extends Project3 {
	        /** @internal */
	        constructor(externalProjectName, projectService, documentRegistry, compilerOptions, lastFileExceededProgramSize, compileOnSaveEnabled, projectFilePath, watchOptions) {
	          super(
	            externalProjectName,
	            2 /* External */,
	            projectService,
	            documentRegistry,
	            /*hasExplicitListOfFiles*/
	            true,
	            lastFileExceededProgramSize,
	            compilerOptions,
	            compileOnSaveEnabled,
	            watchOptions,
	            projectService.host,
	            getDirectoryPath(projectFilePath || normalizeSlashes(externalProjectName))
	          );
	          this.externalProjectName = externalProjectName;
	          this.compileOnSaveEnabled = compileOnSaveEnabled;
	          this.excludedFiles = [];
	          this.enableGlobalPlugins(this.getCompilerOptions());
	        }
	        updateGraph() {
	          const result = super.updateGraph();
	          this.projectService.sendProjectTelemetry(this);
	          return result;
	        }
	        getExcludedFiles() {
	          return this.excludedFiles;
	        }
	      };
	    }
	  });

	  // src/server/editorServices.ts
	  function prepareConvertersForEnumLikeCompilerOptions(commandLineOptions) {
	    const map2 = /* @__PURE__ */ new Map();
	    for (const option of commandLineOptions) {
	      if (typeof option.type === "object") {
	        const optionMap = option.type;
	        optionMap.forEach((value) => {
	          Debug.assert(typeof value === "number");
	        });
	        map2.set(option.name, optionMap);
	      }
	    }
	    return map2;
	  }
	  function convertFormatOptions(protocolOptions) {
	    if (isString(protocolOptions.indentStyle)) {
	      protocolOptions.indentStyle = indentStyle.get(protocolOptions.indentStyle.toLowerCase());
	      Debug.assert(protocolOptions.indentStyle !== void 0);
	    }
	    return protocolOptions;
	  }
	  function convertCompilerOptions(protocolOptions) {
	    compilerOptionConverters.forEach((mappedValues, id) => {
	      const propertyValue = protocolOptions[id];
	      if (isString(propertyValue)) {
	        protocolOptions[id] = mappedValues.get(propertyValue.toLowerCase());
	      }
	    });
	    return protocolOptions;
	  }
	  function convertWatchOptions(protocolOptions, currentDirectory) {
	    let watchOptions;
	    let errors;
	    optionsForWatch.forEach((option) => {
	      const propertyValue = protocolOptions[option.name];
	      if (propertyValue === void 0)
	        return;
	      const mappedValues = watchOptionsConverters.get(option.name);
	      (watchOptions || (watchOptions = {}))[option.name] = mappedValues ? isString(propertyValue) ? mappedValues.get(propertyValue.toLowerCase()) : propertyValue : convertJsonOption(option, propertyValue, currentDirectory || "", errors || (errors = []));
	    });
	    return watchOptions && { watchOptions, errors };
	  }
	  function convertTypeAcquisition(protocolOptions) {
	    let result;
	    typeAcquisitionDeclarations.forEach((option) => {
	      const propertyValue = protocolOptions[option.name];
	      if (propertyValue === void 0)
	        return;
	      (result || (result = {}))[option.name] = propertyValue;
	    });
	    return result;
	  }
	  function tryConvertScriptKindName(scriptKindName) {
	    return isString(scriptKindName) ? convertScriptKindName(scriptKindName) : scriptKindName;
	  }
	  function convertScriptKindName(scriptKindName) {
	    switch (scriptKindName) {
	      case "JS":
	        return 1 /* JS */;
	      case "JSX":
	        return 2 /* JSX */;
	      case "TS":
	        return 3 /* TS */;
	      case "TSX":
	        return 4 /* TSX */;
	      default:
	        return 0 /* Unknown */;
	    }
	  }
	  function convertUserPreferences(preferences) {
	    const { lazyConfiguredProjectsFromExternalProject: _, ...userPreferences } = preferences;
	    return userPreferences;
	  }
	  function findProjectByName(projectName, projects) {
	    for (const proj of projects) {
	      if (proj.getProjectName() === projectName) {
	        return proj;
	      }
	    }
	  }
	  function isOpenScriptInfo(infoOrFileNameOrConfig) {
	    return !!infoOrFileNameOrConfig.containingProjects;
	  }
	  function isAncestorConfigFileInfo(infoOrFileNameOrConfig) {
	    return !!infoOrFileNameOrConfig.configFileInfo;
	  }
	  function forEachResolvedProjectReferenceProject(project, fileName, cb, projectReferenceProjectLoadKind, reason) {
	    var _a;
	    const resolvedRefs = (_a = project.getCurrentProgram()) == null ? void 0 : _a.getResolvedProjectReferences();
	    if (!resolvedRefs)
	      return void 0;
	    let seenResolvedRefs;
	    const possibleDefaultRef = fileName ? project.getResolvedProjectReferenceToRedirect(fileName) : void 0;
	    if (possibleDefaultRef) {
	      const configFileName = toNormalizedPath(possibleDefaultRef.sourceFile.fileName);
	      const child = project.projectService.findConfiguredProjectByProjectName(configFileName);
	      if (child) {
	        const result = cb(child);
	        if (result)
	          return result;
	      } else if (projectReferenceProjectLoadKind !== 0 /* Find */) {
	        seenResolvedRefs = /* @__PURE__ */ new Map();
	        const result = forEachResolvedProjectReferenceProjectWorker(
	          resolvedRefs,
	          project.getCompilerOptions(),
	          (ref, loadKind) => possibleDefaultRef === ref ? callback(ref, loadKind) : void 0,
	          projectReferenceProjectLoadKind,
	          project.projectService,
	          seenResolvedRefs
	        );
	        if (result)
	          return result;
	        seenResolvedRefs.clear();
	      }
	    }
	    return forEachResolvedProjectReferenceProjectWorker(
	      resolvedRefs,
	      project.getCompilerOptions(),
	      (ref, loadKind) => possibleDefaultRef !== ref ? callback(ref, loadKind) : void 0,
	      projectReferenceProjectLoadKind,
	      project.projectService,
	      seenResolvedRefs
	    );
	    function callback(ref, loadKind) {
	      const configFileName = toNormalizedPath(ref.sourceFile.fileName);
	      const child = project.projectService.findConfiguredProjectByProjectName(configFileName) || (loadKind === 0 /* Find */ ? void 0 : loadKind === 1 /* FindCreate */ ? project.projectService.createConfiguredProject(configFileName) : loadKind === 2 /* FindCreateLoad */ ? project.projectService.createAndLoadConfiguredProject(configFileName, reason) : Debug.assertNever(loadKind));
	      return child && cb(child);
	    }
	  }
	  function forEachResolvedProjectReferenceProjectWorker(resolvedProjectReferences, parentOptions, cb, projectReferenceProjectLoadKind, projectService, seenResolvedRefs) {
	    const loadKind = parentOptions.disableReferencedProjectLoad ? 0 /* Find */ : projectReferenceProjectLoadKind;
	    return forEach(resolvedProjectReferences, (ref) => {
	      if (!ref)
	        return void 0;
	      const configFileName = toNormalizedPath(ref.sourceFile.fileName);
	      const canonicalPath = projectService.toCanonicalFileName(configFileName);
	      const seenValue = seenResolvedRefs == null ? void 0 : seenResolvedRefs.get(canonicalPath);
	      if (seenValue !== void 0 && seenValue >= loadKind) {
	        return void 0;
	      }
	      const result = cb(ref, loadKind);
	      if (result) {
	        return result;
	      }
	      (seenResolvedRefs || (seenResolvedRefs = /* @__PURE__ */ new Map())).set(canonicalPath, loadKind);
	      return ref.references && forEachResolvedProjectReferenceProjectWorker(ref.references, ref.commandLine.options, cb, loadKind, projectService, seenResolvedRefs);
	    });
	  }
	  function forEachPotentialProjectReference(project, cb) {
	    return project.potentialProjectReferences && forEachKey(project.potentialProjectReferences, cb);
	  }
	  function forEachAnyProjectReferenceKind(project, cb, cbProjectRef, cbPotentialProjectRef) {
	    return project.getCurrentProgram() ? project.forEachResolvedProjectReference(cb) : project.isInitialLoadPending() ? forEachPotentialProjectReference(project, cbPotentialProjectRef) : forEach(project.getProjectReferences(), cbProjectRef);
	  }
	  function callbackRefProject(project, cb, refPath) {
	    const refProject = refPath && project.projectService.configuredProjects.get(refPath);
	    return refProject && cb(refProject);
	  }
	  function forEachReferencedProject(project, cb) {
	    return forEachAnyProjectReferenceKind(
	      project,
	      (resolvedRef) => callbackRefProject(project, cb, resolvedRef.sourceFile.path),
	      (projectRef) => callbackRefProject(project, cb, project.toPath(resolveProjectReferencePath(projectRef))),
	      (potentialProjectRef) => callbackRefProject(project, cb, potentialProjectRef)
	    );
	  }
	  function getDetailWatchInfo(watchType, project) {
	    return `${isString(project) ? `Config: ${project} ` : project ? `Project: ${project.getProjectName()} ` : ""}WatchType: ${watchType}`;
	  }
	  function isScriptInfoWatchedFromNodeModules(info) {
	    return !info.isScriptOpen() && info.mTime !== void 0;
	  }
	  function projectContainsInfoDirectly(project, info) {
	    return project.containsScriptInfo(info) && !project.isSourceOfProjectReferenceRedirect(info.path);
	  }
	  function updateProjectIfDirty(project) {
	    project.invalidateResolutionsOfFailedLookupLocations();
	    return project.dirty && project.updateGraph();
	  }
	  function setProjectOptionsUsed(project) {
	    if (isConfiguredProject(project)) {
	      project.projectOptions = true;
	    }
	  }
	  function createProjectNameFactoryWithCounter(nameFactory) {
	    let nextId = 1;
	    return () => nameFactory(nextId++);
	  }
	  function getHostWatcherMap() {
	    return { idToCallbacks: /* @__PURE__ */ new Map(), pathToId: /* @__PURE__ */ new Map() };
	  }
	  function createWatchFactoryHostUsingWatchEvents(service, canUseWatchEvents) {
	    if (!canUseWatchEvents || !service.eventHandler || !service.session)
	      return void 0;
	    const watchedFiles = getHostWatcherMap();
	    const watchedDirectories = getHostWatcherMap();
	    const watchedDirectoriesRecursive = getHostWatcherMap();
	    let ids = 1;
	    service.session.addProtocolHandler("watchChange" /* WatchChange */, (req) => {
	      onWatchChange(req.arguments);
	      return { responseRequired: false };
	    });
	    return {
	      watchFile: watchFile2,
	      watchDirectory,
	      getCurrentDirectory: () => service.host.getCurrentDirectory(),
	      useCaseSensitiveFileNames: service.host.useCaseSensitiveFileNames
	    };
	    function watchFile2(path, callback) {
	      return getOrCreateFileWatcher(
	        watchedFiles,
	        path,
	        callback,
	        (id) => ({ eventName: CreateFileWatcherEvent, data: { id, path } })
	      );
	    }
	    function watchDirectory(path, callback, recursive) {
	      return getOrCreateFileWatcher(
	        recursive ? watchedDirectoriesRecursive : watchedDirectories,
	        path,
	        callback,
	        (id) => ({
	          eventName: CreateDirectoryWatcherEvent,
	          data: {
	            id,
	            path,
	            recursive: !!recursive,
	            // Special case node_modules as we watch it for changes to closed script infos as well
	            ignoreUpdate: !path.endsWith("/node_modules") ? true : void 0
	          }
	        })
	      );
	    }
	    function getOrCreateFileWatcher({ pathToId, idToCallbacks }, path, callback, event) {
	      const key = service.toPath(path);
	      let id = pathToId.get(key);
	      if (!id)
	        pathToId.set(key, id = ids++);
	      let callbacks = idToCallbacks.get(id);
	      if (!callbacks) {
	        idToCallbacks.set(id, callbacks = /* @__PURE__ */ new Set());
	        service.eventHandler(event(id));
	      }
	      callbacks.add(callback);
	      return {
	        close() {
	          const callbacks2 = idToCallbacks.get(id);
	          if (!(callbacks2 == null ? void 0 : callbacks2.delete(callback)))
	            return;
	          if (callbacks2.size)
	            return;
	          idToCallbacks.delete(id);
	          pathToId.delete(key);
	          service.eventHandler({ eventName: CloseFileWatcherEvent, data: { id } });
	        }
	      };
	    }
	    function onWatchChange(args) {
	      if (isArray(args))
	        args.forEach(onWatchChangeRequestArgs);
	      else
	        onWatchChangeRequestArgs(args);
	    }
	    function onWatchChangeRequestArgs({ id, created, deleted, updated }) {
	      onWatchEventType(id, created, 0 /* Created */);
	      onWatchEventType(id, deleted, 2 /* Deleted */);
	      onWatchEventType(id, updated, 1 /* Changed */);
	    }
	    function onWatchEventType(id, paths, eventKind) {
	      if (!(paths == null ? void 0 : paths.length))
	        return;
	      forEachCallback(watchedFiles, id, paths, (callback, eventPath) => callback(eventPath, eventKind));
	      forEachCallback(watchedDirectories, id, paths, (callback, eventPath) => callback(eventPath));
	      forEachCallback(watchedDirectoriesRecursive, id, paths, (callback, eventPath) => callback(eventPath));
	    }
	    function forEachCallback(hostWatcherMap, id, eventPaths, cb) {
	      var _a;
	      (_a = hostWatcherMap.idToCallbacks.get(id)) == null ? void 0 : _a.forEach((callback) => {
	        eventPaths.forEach((eventPath) => cb(callback, normalizeSlashes(eventPath)));
	      });
	    }
	  }
	  function createIncompleteCompletionsCache() {
	    let info;
	    return {
	      get() {
	        return info;
	      },
	      set(newInfo) {
	        info = newInfo;
	      },
	      clear() {
	        info = void 0;
	      }
	    };
	  }
	  function isConfigFile(config) {
	    return config.kind !== void 0;
	  }
	  function printProjectWithoutFileNames(project) {
	    project.print(
	      /*writeProjectFileNames*/
	      false,
	      /*writeFileExplaination*/
	      false,
	      /*writeFileVersionAndText*/
	      false
	    );
	  }
	  var maxProgramSizeForNonTsFiles, maxFileSize, ProjectsUpdatedInBackgroundEvent, ProjectLoadingStartEvent, ProjectLoadingFinishEvent, LargeFileReferencedEvent, ConfigFileDiagEvent, ProjectLanguageServiceStateEvent, ProjectInfoTelemetryEvent, OpenFileInfoTelemetryEvent, CreateFileWatcherEvent, CreateDirectoryWatcherEvent, CloseFileWatcherEvent, ensureProjectForOpenFileSchedule, compilerOptionConverters, watchOptionsConverters, indentStyle, defaultTypeSafeList, fileNamePropertyReader, externalFilePropertyReader, noopConfigFileWatcher, ProjectReferenceProjectLoadKind, _ProjectService, ProjectService3;
	  var init_editorServices = __esm({
	    "src/server/editorServices.ts"() {
	      init_ts7();
	      init_ts_server3();
	      init_protocol();
	      maxProgramSizeForNonTsFiles = 20 * 1024 * 1024;
	      maxFileSize = 4 * 1024 * 1024;
	      ProjectsUpdatedInBackgroundEvent = "projectsUpdatedInBackground";
	      ProjectLoadingStartEvent = "projectLoadingStart";
	      ProjectLoadingFinishEvent = "projectLoadingFinish";
	      LargeFileReferencedEvent = "largeFileReferenced";
	      ConfigFileDiagEvent = "configFileDiag";
	      ProjectLanguageServiceStateEvent = "projectLanguageServiceState";
	      ProjectInfoTelemetryEvent = "projectInfo";
	      OpenFileInfoTelemetryEvent = "openFileInfo";
	      CreateFileWatcherEvent = "createFileWatcher";
	      CreateDirectoryWatcherEvent = "createDirectoryWatcher";
	      CloseFileWatcherEvent = "closeFileWatcher";
	      ensureProjectForOpenFileSchedule = "*ensureProjectForOpenFiles*";
	      compilerOptionConverters = prepareConvertersForEnumLikeCompilerOptions(optionDeclarations);
	      watchOptionsConverters = prepareConvertersForEnumLikeCompilerOptions(optionsForWatch);
	      indentStyle = new Map(Object.entries({
	        none: 0 /* None */,
	        block: 1 /* Block */,
	        smart: 2 /* Smart */
	      }));
	      defaultTypeSafeList = {
	        "jquery": {
	          // jquery files can have names like "jquery-1.10.2.min.js" (or "jquery.intellisense.js")
	          match: /jquery(-[\d.]+)?(\.intellisense)?(\.min)?\.js$/i,
	          types: ["jquery"]
	        },
	        "WinJS": {
	          // e.g. c:/temp/UWApp1/lib/winjs-4.0.1/js/base.js
	          match: /^(.*\/winjs-[.\d]+)\/js\/base\.js$/i,
	          // If the winjs/base.js file is found..
	          exclude: [["^", 1, "/.*"]],
	          // ..then exclude all files under the winjs folder
	          types: ["winjs"]
	          // And fetch the @types package for WinJS
	        },
	        "Kendo": {
	          // e.g. /Kendo3/wwwroot/lib/kendo/kendo.all.min.js
	          match: /^(.*\/kendo(-ui)?)\/kendo\.all(\.min)?\.js$/i,
	          exclude: [["^", 1, "/.*"]],
	          types: ["kendo-ui"]
	        },
	        "Office Nuget": {
	          // e.g. /scripts/Office/1/excel-15.debug.js
	          match: /^(.*\/office\/1)\/excel-\d+\.debug\.js$/i,
	          // Office NuGet package is installed under a "1/office" folder
	          exclude: [["^", 1, "/.*"]],
	          // Exclude that whole folder if the file indicated above is found in it
	          types: ["office"]
	          // @types package to fetch instead
	        },
	        "References": {
	          match: /^(.*\/_references\.js)$/i,
	          exclude: [["^", 1, "$"]]
	        }
	      };
	      fileNamePropertyReader = {
	        getFileName: (x) => x,
	        getScriptKind: (fileName, extraFileExtensions) => {
	          let result;
	          if (extraFileExtensions) {
	            const fileExtension = getAnyExtensionFromPath(fileName);
	            if (fileExtension) {
	              some(extraFileExtensions, (info) => {
	                if (info.extension === fileExtension) {
	                  result = info.scriptKind;
	                  return true;
	                }
	                return false;
	              });
	            }
	          }
	          return result;
	        },
	        hasMixedContent: (fileName, extraFileExtensions) => some(extraFileExtensions, (ext) => ext.isMixedContent && fileExtensionIs(fileName, ext.extension))
	      };
	      externalFilePropertyReader = {
	        getFileName: (x) => x.fileName,
	        getScriptKind: (x) => tryConvertScriptKindName(x.scriptKind),
	        // TODO: GH#18217
	        hasMixedContent: (x) => !!x.hasMixedContent
	      };
	      noopConfigFileWatcher = { close: noop };
	      ProjectReferenceProjectLoadKind = /* @__PURE__ */ ((ProjectReferenceProjectLoadKind2) => {
	        ProjectReferenceProjectLoadKind2[ProjectReferenceProjectLoadKind2["Find"] = 0] = "Find";
	        ProjectReferenceProjectLoadKind2[ProjectReferenceProjectLoadKind2["FindCreate"] = 1] = "FindCreate";
	        ProjectReferenceProjectLoadKind2[ProjectReferenceProjectLoadKind2["FindCreateLoad"] = 2] = "FindCreateLoad";
	        return ProjectReferenceProjectLoadKind2;
	      })(ProjectReferenceProjectLoadKind || {});
	      _ProjectService = class _ProjectService {
	        constructor(opts) {
	          /**
	           * Container of all known scripts
	           *
	           * @internal
	           */
	          this.filenameToScriptInfo = /* @__PURE__ */ new Map();
	          this.nodeModulesWatchers = /* @__PURE__ */ new Map();
	          /**
	           * Contains all the deleted script info's version information so that
	           * it does not reset when creating script info again
	           * (and could have potentially collided with version where contents mismatch)
	           */
	          this.filenameToScriptInfoVersion = /* @__PURE__ */ new Map();
	          // Set of all '.js' files ever opened.
	          this.allJsFilesForOpenFileTelemetry = /* @__PURE__ */ new Map();
	          /**
	           * maps external project file name to list of config files that were the part of this project
	           */
	          this.externalProjectToConfiguredProjectMap = /* @__PURE__ */ new Map();
	          /**
	           * external projects (configuration and list of root files is not controlled by tsserver)
	           */
	          this.externalProjects = [];
	          /**
	           * projects built from openFileRoots
	           */
	          this.inferredProjects = [];
	          /**
	           * projects specified by a tsconfig.json file
	           */
	          this.configuredProjects = /* @__PURE__ */ new Map();
	          /** @internal */
	          this.newInferredProjectName = createProjectNameFactoryWithCounter(makeInferredProjectName);
	          /** @internal */
	          this.newAutoImportProviderProjectName = createProjectNameFactoryWithCounter(makeAutoImportProviderProjectName);
	          /** @internal */
	          this.newAuxiliaryProjectName = createProjectNameFactoryWithCounter(makeAuxiliaryProjectName);
	          /**
	           * Open files: with value being project root path, and key being Path of the file that is open
	           */
	          this.openFiles = /* @__PURE__ */ new Map();
	          /** @internal */
	          this.configFileForOpenFiles = /* @__PURE__ */ new Map();
	          /**
	           * Map of open files that are opened without complete path but have projectRoot as current directory
	           */
	          this.openFilesWithNonRootedDiskPath = /* @__PURE__ */ new Map();
	          this.compilerOptionsForInferredProjectsPerProjectRoot = /* @__PURE__ */ new Map();
	          this.watchOptionsForInferredProjectsPerProjectRoot = /* @__PURE__ */ new Map();
	          this.typeAcquisitionForInferredProjectsPerProjectRoot = /* @__PURE__ */ new Map();
	          /**
	           * Project size for configured or external projects
	           */
	          this.projectToSizeMap = /* @__PURE__ */ new Map();
	          /**
	           * This is a map of config file paths existence that doesnt need query to disk
	           * - The entry can be present because there is inferred project that needs to watch addition of config file to directory
	           *   In this case the exists could be true/false based on config file is present or not
	           * - Or it is present if we have configured project open with config file at that location
	           *   In this case the exists property is always true
	           *
	           * @internal
	           */
	          this.configFileExistenceInfoCache = /* @__PURE__ */ new Map();
	          this.safelist = defaultTypeSafeList;
	          this.legacySafelist = /* @__PURE__ */ new Map();
	          this.pendingProjectUpdates = /* @__PURE__ */ new Map();
	          /** @internal */
	          this.pendingEnsureProjectForOpenFiles = false;
	          /** Tracks projects that we have already sent telemetry for. */
	          this.seenProjects = /* @__PURE__ */ new Map();
	          /** @internal */
	          this.sharedExtendedConfigFileWatchers = /* @__PURE__ */ new Map();
	          /** @internal */
	          this.extendedConfigCache = /* @__PURE__ */ new Map();
	          /** @internal */
	          this.baseline = noop;
	          /** @internal */
	          this.verifyDocumentRegistry = noop;
	          /** @internal */
	          this.verifyProgram = noop;
	          /** @internal */
	          this.onProjectCreation = noop;
	          var _a;
	          this.host = opts.host;
	          this.logger = opts.logger;
	          this.cancellationToken = opts.cancellationToken;
	          this.useSingleInferredProject = opts.useSingleInferredProject;
	          this.useInferredProjectPerProjectRoot = opts.useInferredProjectPerProjectRoot;
	          this.typingsInstaller = opts.typingsInstaller || nullTypingsInstaller;
	          this.throttleWaitMilliseconds = opts.throttleWaitMilliseconds;
	          this.eventHandler = opts.eventHandler;
	          this.suppressDiagnosticEvents = opts.suppressDiagnosticEvents;
	          this.globalPlugins = opts.globalPlugins || emptyArray2;
	          this.pluginProbeLocations = opts.pluginProbeLocations || emptyArray2;
	          this.allowLocalPluginLoads = !!opts.allowLocalPluginLoads;
	          this.typesMapLocation = opts.typesMapLocation === void 0 ? combinePaths(getDirectoryPath(this.getExecutingFilePath()), "typesMap.json") : opts.typesMapLocation;
	          this.session = opts.session;
	          this.jsDocParsingMode = opts.jsDocParsingMode;
	          if (opts.serverMode !== void 0) {
	            this.serverMode = opts.serverMode;
	          } else {
	            this.serverMode = 0 /* Semantic */;
	          }
	          if (this.host.realpath) {
	            this.realpathToScriptInfos = createMultiMap();
	          }
	          this.currentDirectory = toNormalizedPath(this.host.getCurrentDirectory());
	          this.toCanonicalFileName = createGetCanonicalFileName(this.host.useCaseSensitiveFileNames);
	          this.globalCacheLocationDirectoryPath = this.typingsInstaller.globalTypingsCacheLocation ? ensureTrailingDirectorySeparator(this.toPath(this.typingsInstaller.globalTypingsCacheLocation)) : void 0;
	          this.throttledOperations = new ThrottledOperations(this.host, this.logger);
	          if (this.typesMapLocation) {
	            this.loadTypesMap();
	          } else {
	            this.logger.info("No types map provided; using the default");
	          }
	          this.typingsInstaller.attach(this);
	          this.typingsCache = new TypingsCache(this.typingsInstaller);
	          this.hostConfiguration = {
	            formatCodeOptions: getDefaultFormatCodeSettings(this.host.newLine),
	            preferences: emptyOptions,
	            hostInfo: "Unknown host",
	            extraFileExtensions: []
	          };
	          this.documentRegistry = createDocumentRegistryInternal(this.host.useCaseSensitiveFileNames, this.currentDirectory, this.jsDocParsingMode, this);
	          const watchLogLevel = this.logger.hasLevel(3 /* verbose */) ? 2 /* Verbose */ : this.logger.loggingEnabled() ? 1 /* TriggerOnly */ : 0 /* None */;
	          const log = watchLogLevel !== 0 /* None */ ? (s) => this.logger.info(s) : noop;
	          this.packageJsonCache = createPackageJsonCache(this);
	          this.watchFactory = this.serverMode !== 0 /* Semantic */ ? {
	            watchFile: returnNoopFileWatcher,
	            watchDirectory: returnNoopFileWatcher
	          } : getWatchFactory(
	            createWatchFactoryHostUsingWatchEvents(this, opts.canUseWatchEvents) || this.host,
	            watchLogLevel,
	            log,
	            getDetailWatchInfo
	          );
	          (_a = opts.incrementalVerifier) == null ? void 0 : _a.call(opts, this);
	        }
	        toPath(fileName) {
	          return toPath(fileName, this.currentDirectory, this.toCanonicalFileName);
	        }
	        /** @internal */
	        getExecutingFilePath() {
	          return this.getNormalizedAbsolutePath(this.host.getExecutingFilePath());
	        }
	        /** @internal */
	        getNormalizedAbsolutePath(fileName) {
	          return getNormalizedAbsolutePath(fileName, this.host.getCurrentDirectory());
	        }
	        /** @internal */
	        setDocument(key, path, sourceFile) {
	          const info = Debug.checkDefined(this.getScriptInfoForPath(path));
	          info.cacheSourceFile = { key, sourceFile };
	        }
	        /** @internal */
	        getDocument(key, path) {
	          const info = this.getScriptInfoForPath(path);
	          return info && info.cacheSourceFile && info.cacheSourceFile.key === key ? info.cacheSourceFile.sourceFile : void 0;
	        }
	        /** @internal */
	        ensureInferredProjectsUpToDate_TestOnly() {
	          this.ensureProjectStructuresUptoDate();
	        }
	        /** @internal */
	        getCompilerOptionsForInferredProjects() {
	          return this.compilerOptionsForInferredProjects;
	        }
	        /** @internal */
	        onUpdateLanguageServiceStateForProject(project, languageServiceEnabled) {
	          if (!this.eventHandler) {
	            return;
	          }
	          const event = {
	            eventName: ProjectLanguageServiceStateEvent,
	            data: { project, languageServiceEnabled }
	          };
	          this.eventHandler(event);
	        }
	        loadTypesMap() {
	          try {
	            const fileContent = this.host.readFile(this.typesMapLocation);
	            if (fileContent === void 0) {
	              this.logger.info(`Provided types map file "${this.typesMapLocation}" doesn't exist`);
	              return;
	            }
	            const raw = JSON.parse(fileContent);
	            for (const k of Object.keys(raw.typesMap)) {
	              raw.typesMap[k].match = new RegExp(raw.typesMap[k].match, "i");
	            }
	            this.safelist = raw.typesMap;
	            for (const key in raw.simpleMap) {
	              if (hasProperty(raw.simpleMap, key)) {
	                this.legacySafelist.set(key, raw.simpleMap[key].toLowerCase());
	              }
	            }
	          } catch (e) {
	            this.logger.info(`Error loading types map: ${e}`);
	            this.safelist = defaultTypeSafeList;
	            this.legacySafelist.clear();
	          }
	        }
	        // eslint-disable-line @typescript-eslint/unified-signatures
	        updateTypingsForProject(response) {
	          const project = this.findProject(response.projectName);
	          if (!project) {
	            return;
	          }
	          switch (response.kind) {
	            case ActionSet:
	              project.updateTypingFiles(this.typingsCache.updateTypingsForProject(response.projectName, response.compilerOptions, response.typeAcquisition, response.unresolvedImports, response.typings));
	              return;
	            case ActionInvalidate:
	              this.typingsCache.enqueueInstallTypingsForProject(
	                project,
	                project.lastCachedUnresolvedImportsList,
	                /*forceRefresh*/
	                true
	              );
	              return;
	          }
	        }
	        /** @internal */
	        watchTypingLocations(response) {
	          var _a;
	          (_a = this.findProject(response.projectName)) == null ? void 0 : _a.watchTypingLocations(response.files);
	        }
	        /** @internal */
	        delayEnsureProjectForOpenFiles() {
	          if (!this.openFiles.size)
	            return;
	          this.pendingEnsureProjectForOpenFiles = true;
	          this.throttledOperations.schedule(
	            ensureProjectForOpenFileSchedule,
	            /*delay*/
	            2500,
	            () => {
	              if (this.pendingProjectUpdates.size !== 0) {
	                this.delayEnsureProjectForOpenFiles();
	              } else {
	                if (this.pendingEnsureProjectForOpenFiles) {
	                  this.ensureProjectForOpenFiles();
	                  this.sendProjectsUpdatedInBackgroundEvent();
	                }
	              }
	            }
	          );
	        }
	        delayUpdateProjectGraph(project) {
	          project.markAsDirty();
	          if (isBackgroundProject(project))
	            return;
	          const projectName = project.getProjectName();
	          this.pendingProjectUpdates.set(projectName, project);
	          this.throttledOperations.schedule(
	            projectName,
	            /*delay*/
	            250,
	            () => {
	              if (this.pendingProjectUpdates.delete(projectName)) {
	                updateProjectIfDirty(project);
	              }
	            }
	          );
	        }
	        /** @internal */
	        hasPendingProjectUpdate(project) {
	          return this.pendingProjectUpdates.has(project.getProjectName());
	        }
	        /** @internal */
	        sendProjectsUpdatedInBackgroundEvent() {
	          if (!this.eventHandler) {
	            return;
	          }
	          const event = {
	            eventName: ProjectsUpdatedInBackgroundEvent,
	            data: {
	              openFiles: arrayFrom(this.openFiles.keys(), (path) => this.getScriptInfoForPath(path).fileName)
	            }
	          };
	          this.eventHandler(event);
	        }
	        /** @internal */
	        sendLargeFileReferencedEvent(file, fileSize) {
	          if (!this.eventHandler) {
	            return;
	          }
	          const event = {
	            eventName: LargeFileReferencedEvent,
	            data: { file, fileSize, maxFileSize }
	          };
	          this.eventHandler(event);
	        }
	        /** @internal */
	        sendProjectLoadingStartEvent(project, reason) {
	          if (!this.eventHandler) {
	            return;
	          }
	          project.sendLoadingProjectFinish = true;
	          const event = {
	            eventName: ProjectLoadingStartEvent,
	            data: { project, reason }
	          };
	          this.eventHandler(event);
	        }
	        /** @internal */
	        sendProjectLoadingFinishEvent(project) {
	          if (!this.eventHandler || !project.sendLoadingProjectFinish) {
	            return;
	          }
	          project.sendLoadingProjectFinish = false;
	          const event = {
	            eventName: ProjectLoadingFinishEvent,
	            data: { project }
	          };
	          this.eventHandler(event);
	        }
	        /** @internal */
	        sendPerformanceEvent(kind, durationMs) {
	          if (this.performanceEventHandler) {
	            this.performanceEventHandler({ kind, durationMs });
	          }
	        }
	        /** @internal */
	        delayUpdateProjectGraphAndEnsureProjectStructureForOpenFiles(project) {
	          this.delayUpdateProjectGraph(project);
	          this.delayEnsureProjectForOpenFiles();
	        }
	        delayUpdateProjectGraphs(projects, clearSourceMapperCache) {
	          if (projects.length) {
	            for (const project of projects) {
	              if (clearSourceMapperCache)
	                project.clearSourceMapperCache();
	              this.delayUpdateProjectGraph(project);
	            }
	            this.delayEnsureProjectForOpenFiles();
	          }
	        }
	        setCompilerOptionsForInferredProjects(projectCompilerOptions, projectRootPath) {
	          Debug.assert(projectRootPath === void 0 || this.useInferredProjectPerProjectRoot, "Setting compiler options per project root path is only supported when useInferredProjectPerProjectRoot is enabled");
	          const compilerOptions = convertCompilerOptions(projectCompilerOptions);
	          const watchOptions = convertWatchOptions(projectCompilerOptions, projectRootPath);
	          const typeAcquisition = convertTypeAcquisition(projectCompilerOptions);
	          compilerOptions.allowNonTsExtensions = true;
	          const canonicalProjectRootPath = projectRootPath && this.toCanonicalFileName(projectRootPath);
	          if (canonicalProjectRootPath) {
	            this.compilerOptionsForInferredProjectsPerProjectRoot.set(canonicalProjectRootPath, compilerOptions);
	            this.watchOptionsForInferredProjectsPerProjectRoot.set(canonicalProjectRootPath, watchOptions || false);
	            this.typeAcquisitionForInferredProjectsPerProjectRoot.set(canonicalProjectRootPath, typeAcquisition);
	          } else {
	            this.compilerOptionsForInferredProjects = compilerOptions;
	            this.watchOptionsForInferredProjects = watchOptions;
	            this.typeAcquisitionForInferredProjects = typeAcquisition;
	          }
	          for (const project of this.inferredProjects) {
	            if (canonicalProjectRootPath ? project.projectRootPath === canonicalProjectRootPath : !project.projectRootPath || !this.compilerOptionsForInferredProjectsPerProjectRoot.has(project.projectRootPath)) {
	              project.setCompilerOptions(compilerOptions);
	              project.setTypeAcquisition(typeAcquisition);
	              project.setWatchOptions(watchOptions == null ? void 0 : watchOptions.watchOptions);
	              project.setProjectErrors(watchOptions == null ? void 0 : watchOptions.errors);
	              project.compileOnSaveEnabled = compilerOptions.compileOnSave;
	              project.markAsDirty();
	              this.delayUpdateProjectGraph(project);
	            }
	          }
	          this.delayEnsureProjectForOpenFiles();
	        }
	        findProject(projectName) {
	          if (projectName === void 0) {
	            return void 0;
	          }
	          if (isInferredProjectName(projectName)) {
	            return findProjectByName(projectName, this.inferredProjects);
	          }
	          return this.findExternalProjectByProjectName(projectName) || this.findConfiguredProjectByProjectName(toNormalizedPath(projectName));
	        }
	        /** @internal */
	        forEachProject(cb) {
	          this.externalProjects.forEach(cb);
	          this.configuredProjects.forEach(cb);
	          this.inferredProjects.forEach(cb);
	        }
	        /** @internal */
	        forEachEnabledProject(cb) {
	          this.forEachProject((project) => {
	            if (!project.isOrphan() && project.languageServiceEnabled) {
	              cb(project);
	            }
	          });
	        }
	        getDefaultProjectForFile(fileName, ensureProject) {
	          return ensureProject ? this.ensureDefaultProjectForFile(fileName) : this.tryGetDefaultProjectForFile(fileName);
	        }
	        /** @internal */
	        tryGetDefaultProjectForFile(fileNameOrScriptInfo) {
	          const scriptInfo = isString(fileNameOrScriptInfo) ? this.getScriptInfoForNormalizedPath(fileNameOrScriptInfo) : fileNameOrScriptInfo;
	          return scriptInfo && !scriptInfo.isOrphan() ? scriptInfo.getDefaultProject() : void 0;
	        }
	        /** @internal */
	        ensureDefaultProjectForFile(fileNameOrScriptInfo) {
	          return this.tryGetDefaultProjectForFile(fileNameOrScriptInfo) || this.doEnsureDefaultProjectForFile(fileNameOrScriptInfo);
	        }
	        doEnsureDefaultProjectForFile(fileNameOrScriptInfo) {
	          this.ensureProjectStructuresUptoDate();
	          const scriptInfo = isString(fileNameOrScriptInfo) ? this.getScriptInfoForNormalizedPath(fileNameOrScriptInfo) : fileNameOrScriptInfo;
	          return scriptInfo ? scriptInfo.getDefaultProject() : (this.logErrorForScriptInfoNotFound(isString(fileNameOrScriptInfo) ? fileNameOrScriptInfo : fileNameOrScriptInfo.fileName), Errors.ThrowNoProject());
	        }
	        getScriptInfoEnsuringProjectsUptoDate(uncheckedFileName) {
	          this.ensureProjectStructuresUptoDate();
	          return this.getScriptInfo(uncheckedFileName);
	        }
	        /**
	         * Ensures the project structures are upto date
	         * This means,
	         * - we go through all the projects and update them if they are dirty
	         * - if updates reflect some change in structure or there was pending request to ensure projects for open files
	         *   ensure that each open script info has project
	         */
	        ensureProjectStructuresUptoDate() {
	          let hasChanges = this.pendingEnsureProjectForOpenFiles;
	          this.pendingProjectUpdates.clear();
	          const updateGraph = (project) => {
	            hasChanges = updateProjectIfDirty(project) || hasChanges;
	          };
	          this.externalProjects.forEach(updateGraph);
	          this.configuredProjects.forEach(updateGraph);
	          this.inferredProjects.forEach(updateGraph);
	          if (hasChanges) {
	            this.ensureProjectForOpenFiles();
	          }
	        }
	        getFormatCodeOptions(file) {
	          const info = this.getScriptInfoForNormalizedPath(file);
	          return info && info.getFormatCodeSettings() || this.hostConfiguration.formatCodeOptions;
	        }
	        getPreferences(file) {
	          const info = this.getScriptInfoForNormalizedPath(file);
	          return { ...this.hostConfiguration.preferences, ...info && info.getPreferences() };
	        }
	        getHostFormatCodeOptions() {
	          return this.hostConfiguration.formatCodeOptions;
	        }
	        getHostPreferences() {
	          return this.hostConfiguration.preferences;
	        }
	        onSourceFileChanged(info, eventKind) {
	          if (eventKind === 2 /* Deleted */) {
	            this.handleDeletedFile(info);
	          } else if (!info.isScriptOpen()) {
	            info.delayReloadNonMixedContentFile();
	            this.delayUpdateProjectGraphs(
	              info.containingProjects,
	              /*clearSourceMapperCache*/
	              false
	            );
	            this.handleSourceMapProjects(info);
	          }
	        }
	        handleSourceMapProjects(info) {
	          if (info.sourceMapFilePath) {
	            if (isString(info.sourceMapFilePath)) {
	              const sourceMapFileInfo = this.getScriptInfoForPath(info.sourceMapFilePath);
	              this.delayUpdateSourceInfoProjects(sourceMapFileInfo && sourceMapFileInfo.sourceInfos);
	            } else {
	              this.delayUpdateSourceInfoProjects(info.sourceMapFilePath.sourceInfos);
	            }
	          }
	          this.delayUpdateSourceInfoProjects(info.sourceInfos);
	          if (info.declarationInfoPath) {
	            this.delayUpdateProjectsOfScriptInfoPath(info.declarationInfoPath);
	          }
	        }
	        delayUpdateSourceInfoProjects(sourceInfos) {
	          if (sourceInfos) {
	            sourceInfos.forEach((_value, path) => this.delayUpdateProjectsOfScriptInfoPath(path));
	          }
	        }
	        delayUpdateProjectsOfScriptInfoPath(path) {
	          const info = this.getScriptInfoForPath(path);
	          if (info) {
	            this.delayUpdateProjectGraphs(
	              info.containingProjects,
	              /*clearSourceMapperCache*/
	              true
	            );
	          }
	        }
	        handleDeletedFile(info) {
	          this.stopWatchingScriptInfo(info);
	          if (!info.isScriptOpen()) {
	            this.deleteScriptInfo(info);
	            const containingProjects = info.containingProjects.slice();
	            info.detachAllProjects();
	            this.delayUpdateProjectGraphs(
	              containingProjects,
	              /*clearSourceMapperCache*/
	              false
	            );
	            this.handleSourceMapProjects(info);
	            info.closeSourceMapFileWatcher();
	            if (info.declarationInfoPath) {
	              const declarationInfo = this.getScriptInfoForPath(info.declarationInfoPath);
	              if (declarationInfo) {
	                declarationInfo.sourceMapFilePath = void 0;
	              }
	            }
	          }
	        }
	        /**
	         * This is to watch whenever files are added or removed to the wildcard directories
	         *
	         * @internal
	         */
	        watchWildcardDirectory(directory, flags, configFileName, config) {
	          let watcher = this.watchFactory.watchDirectory(
	            directory,
	            (fileOrDirectory) => {
	              const fileOrDirectoryPath = this.toPath(fileOrDirectory);
	              const fsResult = config.cachedDirectoryStructureHost.addOrDeleteFileOrDirectory(fileOrDirectory, fileOrDirectoryPath);
	              if (getBaseFileName(fileOrDirectoryPath) === "package.json" && !isInsideNodeModules(fileOrDirectoryPath) && (fsResult && fsResult.fileExists || !fsResult && this.host.fileExists(fileOrDirectory))) {
	                const file = this.getNormalizedAbsolutePath(fileOrDirectory);
	                this.logger.info(`Config: ${configFileName} Detected new package.json: ${file}`);
	                this.packageJsonCache.addOrUpdate(file, fileOrDirectoryPath);
	                this.watchPackageJsonFile(file, fileOrDirectoryPath, result);
	              }
	              const configuredProjectForConfig = this.findConfiguredProjectByProjectName(configFileName);
	              if (isIgnoredFileFromWildCardWatching({
	                watchedDirPath: this.toPath(directory),
	                fileOrDirectory,
	                fileOrDirectoryPath,
	                configFileName,
	                extraFileExtensions: this.hostConfiguration.extraFileExtensions,
	                currentDirectory: this.currentDirectory,
	                options: config.parsedCommandLine.options,
	                program: (configuredProjectForConfig == null ? void 0 : configuredProjectForConfig.getCurrentProgram()) || config.parsedCommandLine.fileNames,
	                useCaseSensitiveFileNames: this.host.useCaseSensitiveFileNames,
	                writeLog: (s) => this.logger.info(s),
	                toPath: (s) => this.toPath(s),
	                getScriptKind: configuredProjectForConfig ? (fileName) => configuredProjectForConfig.getScriptKind(fileName) : void 0
	              }))
	                return;
	              if (config.updateLevel !== 2 /* Full */)
	                config.updateLevel = 1 /* RootNamesAndUpdate */;
	              config.projects.forEach((watchWildcardDirectories, projectCanonicalPath) => {
	                if (!watchWildcardDirectories)
	                  return;
	                const project = this.getConfiguredProjectByCanonicalConfigFilePath(projectCanonicalPath);
	                if (!project)
	                  return;
	                const updateLevel = configuredProjectForConfig === project ? 1 /* RootNamesAndUpdate */ : 0 /* Update */;
	                if (project.pendingUpdateLevel !== void 0 && project.pendingUpdateLevel > updateLevel)
	                  return;
	                if (this.openFiles.has(fileOrDirectoryPath)) {
	                  const info = Debug.checkDefined(this.getScriptInfoForPath(fileOrDirectoryPath));
	                  if (info.isAttached(project)) {
	                    const loadLevelToSet = Math.max(updateLevel, project.openFileWatchTriggered.get(fileOrDirectoryPath) || 0 /* Update */);
	                    project.openFileWatchTriggered.set(fileOrDirectoryPath, loadLevelToSet);
	                  } else {
	                    project.pendingUpdateLevel = updateLevel;
	                    this.delayUpdateProjectGraphAndEnsureProjectStructureForOpenFiles(project);
	                  }
	                } else {
	                  project.pendingUpdateLevel = updateLevel;
	                  this.delayUpdateProjectGraphAndEnsureProjectStructureForOpenFiles(project);
	                }
	              });
	            },
	            flags,
	            this.getWatchOptionsFromProjectWatchOptions(config.parsedCommandLine.watchOptions),
	            WatchType.WildcardDirectory,
	            configFileName
	          );
	          const result = {
	            packageJsonWatches: void 0,
	            close() {
	              var _a;
	              if (watcher) {
	                watcher.close();
	                watcher = void 0;
	                (_a = result.packageJsonWatches) == null ? void 0 : _a.forEach((watcher2) => {
	                  watcher2.projects.delete(result);
	                  watcher2.close();
	                });
	                result.packageJsonWatches = void 0;
	              }
	            }
	          };
	          return result;
	        }
	        /** @internal */
	        delayUpdateProjectsFromParsedConfigOnConfigFileChange(canonicalConfigFilePath, loadReason) {
	          const configFileExistenceInfo = this.configFileExistenceInfoCache.get(canonicalConfigFilePath);
	          if (!(configFileExistenceInfo == null ? void 0 : configFileExistenceInfo.config))
	            return false;
	          let scheduledAnyProjectUpdate = false;
	          configFileExistenceInfo.config.updateLevel = 2 /* Full */;
	          configFileExistenceInfo.config.projects.forEach((_watchWildcardDirectories, projectCanonicalPath) => {
	            const project = this.getConfiguredProjectByCanonicalConfigFilePath(projectCanonicalPath);
	            if (!project)
	              return;
	            scheduledAnyProjectUpdate = true;
	            if (projectCanonicalPath === canonicalConfigFilePath) {
	              if (project.isInitialLoadPending())
	                return;
	              project.pendingUpdateLevel = 2 /* Full */;
	              project.pendingUpdateReason = loadReason;
	              this.delayUpdateProjectGraph(project);
	            } else {
	              project.resolutionCache.removeResolutionsFromProjectReferenceRedirects(this.toPath(canonicalConfigFilePath));
	              this.delayUpdateProjectGraph(project);
	            }
	          });
	          return scheduledAnyProjectUpdate;
	        }
	        /** @internal */
	        onConfigFileChanged(canonicalConfigFilePath, eventKind) {
	          var _a;
	          const configFileExistenceInfo = this.configFileExistenceInfoCache.get(canonicalConfigFilePath);
	          if (eventKind === 2 /* Deleted */) {
	            configFileExistenceInfo.exists = false;
	            const project = ((_a = configFileExistenceInfo.config) == null ? void 0 : _a.projects.has(canonicalConfigFilePath)) ? this.getConfiguredProjectByCanonicalConfigFilePath(canonicalConfigFilePath) : void 0;
	            if (project)
	              this.removeProject(project);
	          } else {
	            configFileExistenceInfo.exists = true;
	          }
	          this.delayUpdateProjectsFromParsedConfigOnConfigFileChange(canonicalConfigFilePath, "Change in config file detected");
	          this.reloadConfiguredProjectForFiles(
	            configFileExistenceInfo.openFilesImpactedByConfigFile,
	            /*clearSemanticCache*/
	            false,
	            /*delayReload*/
	            true,
	            eventKind !== 2 /* Deleted */ ? identity : (
	              // Reload open files if they are root of inferred project
	              returnTrue
	            ),
	            // Reload all the open files impacted by config file
	            "Change in config file detected"
	          );
	          this.delayEnsureProjectForOpenFiles();
	        }
	        removeProject(project) {
	          this.logger.info("`remove Project::");
	          project.print(
	            /*writeProjectFileNames*/
	            true,
	            /*writeFileExplaination*/
	            true,
	            /*writeFileVersionAndText*/
	            false
	          );
	          project.close();
	          if (Debug.shouldAssert(1 /* Normal */)) {
	            this.filenameToScriptInfo.forEach(
	              (info) => Debug.assert(
	                !info.isAttached(project),
	                "Found script Info still attached to project",
	                () => `${project.projectName}: ScriptInfos still attached: ${JSON.stringify(
	                  arrayFrom(
	                    mapDefinedIterator(
	                      this.filenameToScriptInfo.values(),
	                      (info2) => info2.isAttached(project) ? {
	                        fileName: info2.fileName,
	                        projects: info2.containingProjects.map((p) => p.projectName),
	                        hasMixedContent: info2.hasMixedContent
	                      } : void 0
	                    )
	                  ),
	                  /*replacer*/
	                  void 0,
	                  " "
	                )}`
	              )
	            );
	          }
	          this.pendingProjectUpdates.delete(project.getProjectName());
	          switch (project.projectKind) {
	            case 2 /* External */:
	              unorderedRemoveItem(this.externalProjects, project);
	              this.projectToSizeMap.delete(project.getProjectName());
	              break;
	            case 1 /* Configured */:
	              this.configuredProjects.delete(project.canonicalConfigFilePath);
	              this.projectToSizeMap.delete(project.canonicalConfigFilePath);
	              break;
	            case 0 /* Inferred */:
	              unorderedRemoveItem(this.inferredProjects, project);
	              break;
	          }
	        }
	        /** @internal */
	        assignOrphanScriptInfoToInferredProject(info, projectRootPath) {
	          Debug.assert(info.isOrphan());
	          const project = this.getOrCreateInferredProjectForProjectRootPathIfEnabled(info, projectRootPath) || this.getOrCreateSingleInferredProjectIfEnabled() || this.getOrCreateSingleInferredWithoutProjectRoot(
	            info.isDynamic ? projectRootPath || this.currentDirectory : getDirectoryPath(
	              isRootedDiskPath(info.fileName) ? info.fileName : getNormalizedAbsolutePath(
	                info.fileName,
	                projectRootPath ? this.getNormalizedAbsolutePath(projectRootPath) : this.currentDirectory
	              )
	            )
	          );
	          project.addRoot(info);
	          if (info.containingProjects[0] !== project) {
	            orderedRemoveItem(info.containingProjects, project);
	            info.containingProjects.unshift(project);
	          }
	          project.updateGraph();
	          if (!this.useSingleInferredProject && !project.projectRootPath) {
	            for (const inferredProject of this.inferredProjects) {
	              if (inferredProject === project || inferredProject.isOrphan()) {
	                continue;
	              }
	              const roots = inferredProject.getRootScriptInfos();
	              Debug.assert(roots.length === 1 || !!inferredProject.projectRootPath);
	              if (roots.length === 1 && forEach(roots[0].containingProjects, (p) => p !== roots[0].containingProjects[0] && !p.isOrphan())) {
	                inferredProject.removeFile(
	                  roots[0],
	                  /*fileExists*/
	                  true,
	                  /*detachFromProject*/
	                  true
	                );
	              }
	            }
	          }
	          return project;
	        }
	        assignOrphanScriptInfosToInferredProject() {
	          this.openFiles.forEach((projectRootPath, path) => {
	            const info = this.getScriptInfoForPath(path);
	            if (info.isOrphan()) {
	              this.assignOrphanScriptInfoToInferredProject(info, projectRootPath);
	            }
	          });
	        }
	        /**
	         * Remove this file from the set of open, non-configured files.
	         * @param info The file that has been closed or newly configured
	         */
	        closeOpenFile(info, skipAssignOrphanScriptInfosToInferredProject) {
	          const fileExists = info.isDynamic ? false : this.host.fileExists(info.fileName);
	          info.close(fileExists);
	          this.stopWatchingConfigFilesForClosedScriptInfo(info);
	          const canonicalFileName = this.toCanonicalFileName(info.fileName);
	          if (this.openFilesWithNonRootedDiskPath.get(canonicalFileName) === info) {
	            this.openFilesWithNonRootedDiskPath.delete(canonicalFileName);
	          }
	          let ensureProjectsForOpenFiles = false;
	          for (const p of info.containingProjects) {
	            if (isConfiguredProject(p)) {
	              if (info.hasMixedContent) {
	                info.registerFileUpdate();
	              }
	              const updateLevel = p.openFileWatchTriggered.get(info.path);
	              if (updateLevel !== void 0) {
	                p.openFileWatchTriggered.delete(info.path);
	                if (p.pendingUpdateLevel !== void 0 && p.pendingUpdateLevel < updateLevel) {
	                  p.pendingUpdateLevel = updateLevel;
	                  p.markFileAsDirty(info.path);
	                }
	              }
	            } else if (isInferredProject(p) && p.isRoot(info)) {
	              if (p.isProjectWithSingleRoot()) {
	                ensureProjectsForOpenFiles = true;
	              }
	              p.removeFile(
	                info,
	                fileExists,
	                /*detachFromProject*/
	                true
	              );
	            }
	            if (!p.languageServiceEnabled) {
	              p.markAsDirty();
	            }
	          }
	          this.openFiles.delete(info.path);
	          this.configFileForOpenFiles.delete(info.path);
	          if (!skipAssignOrphanScriptInfosToInferredProject && ensureProjectsForOpenFiles) {
	            this.assignOrphanScriptInfosToInferredProject();
	          }
	          if (fileExists) {
	            this.watchClosedScriptInfo(info);
	          } else {
	            this.handleDeletedFile(info);
	          }
	          return ensureProjectsForOpenFiles;
	        }
	        deleteScriptInfo(info) {
	          this.filenameToScriptInfo.delete(info.path);
	          this.filenameToScriptInfoVersion.set(info.path, info.textStorage.version);
	          const realpath = info.getRealpathIfDifferent();
	          if (realpath) {
	            this.realpathToScriptInfos.remove(realpath, info);
	          }
	        }
	        configFileExists(configFileName, canonicalConfigFilePath, info) {
	          var _a;
	          let configFileExistenceInfo = this.configFileExistenceInfoCache.get(canonicalConfigFilePath);
	          if (configFileExistenceInfo) {
	            if (isOpenScriptInfo(info) && !((_a = configFileExistenceInfo.openFilesImpactedByConfigFile) == null ? void 0 : _a.has(info.path))) {
	              (configFileExistenceInfo.openFilesImpactedByConfigFile || (configFileExistenceInfo.openFilesImpactedByConfigFile = /* @__PURE__ */ new Map())).set(info.path, false);
	            }
	            return configFileExistenceInfo.exists;
	          }
	          const exists = this.host.fileExists(configFileName);
	          let openFilesImpactedByConfigFile;
	          if (isOpenScriptInfo(info)) {
	            (openFilesImpactedByConfigFile || (openFilesImpactedByConfigFile = /* @__PURE__ */ new Map())).set(info.path, false);
	          }
	          configFileExistenceInfo = { exists, openFilesImpactedByConfigFile };
	          this.configFileExistenceInfoCache.set(canonicalConfigFilePath, configFileExistenceInfo);
	          return exists;
	        }
	        /** @internal */
	        createConfigFileWatcherForParsedConfig(configFileName, canonicalConfigFilePath, forProject) {
	          var _a, _b;
	          const configFileExistenceInfo = this.configFileExistenceInfoCache.get(canonicalConfigFilePath);
	          if (!configFileExistenceInfo.watcher || configFileExistenceInfo.watcher === noopConfigFileWatcher) {
	            configFileExistenceInfo.watcher = this.watchFactory.watchFile(
	              configFileName,
	              (_fileName, eventKind) => this.onConfigFileChanged(canonicalConfigFilePath, eventKind),
	              2e3 /* High */,
	              this.getWatchOptionsFromProjectWatchOptions((_b = (_a = configFileExistenceInfo == null ? void 0 : configFileExistenceInfo.config) == null ? void 0 : _a.parsedCommandLine) == null ? void 0 : _b.watchOptions),
	              WatchType.ConfigFile,
	              forProject
	            );
	          }
	          const projects = configFileExistenceInfo.config.projects;
	          projects.set(forProject.canonicalConfigFilePath, projects.get(forProject.canonicalConfigFilePath) || false);
	        }
	        /**
	         * Returns true if the configFileExistenceInfo is needed/impacted by open files that are root of inferred project
	         */
	        configFileExistenceImpactsRootOfInferredProject(configFileExistenceInfo) {
	          return configFileExistenceInfo.openFilesImpactedByConfigFile && forEachEntry(configFileExistenceInfo.openFilesImpactedByConfigFile, identity);
	        }
	        /** @internal */
	        releaseParsedConfig(canonicalConfigFilePath, forProject) {
	          var _a, _b, _c;
	          const configFileExistenceInfo = this.configFileExistenceInfoCache.get(canonicalConfigFilePath);
	          if (!((_a = configFileExistenceInfo.config) == null ? void 0 : _a.projects.delete(forProject.canonicalConfigFilePath)))
	            return;
	          if ((_b = configFileExistenceInfo.config) == null ? void 0 : _b.projects.size)
	            return;
	          configFileExistenceInfo.config = void 0;
	          clearSharedExtendedConfigFileWatcher(canonicalConfigFilePath, this.sharedExtendedConfigFileWatchers);
	          Debug.checkDefined(configFileExistenceInfo.watcher);
	          if ((_c = configFileExistenceInfo.openFilesImpactedByConfigFile) == null ? void 0 : _c.size) {
	            if (this.configFileExistenceImpactsRootOfInferredProject(configFileExistenceInfo)) {
	              if (!canWatchDirectoryOrFile(getPathComponents(getDirectoryPath(canonicalConfigFilePath)))) {
	                configFileExistenceInfo.watcher.close();
	                configFileExistenceInfo.watcher = noopConfigFileWatcher;
	              }
	            } else {
	              configFileExistenceInfo.watcher.close();
	              configFileExistenceInfo.watcher = void 0;
	            }
	          } else {
	            configFileExistenceInfo.watcher.close();
	            this.configFileExistenceInfoCache.delete(canonicalConfigFilePath);
	          }
	        }
	        /**
	         * Close the config file watcher in the cached ConfigFileExistenceInfo
	         *   if there arent any open files that are root of inferred project and there is no parsed config held by any project
	         *
	         * @internal
	         */
	        closeConfigFileWatcherOnReleaseOfOpenFile(configFileExistenceInfo) {
	          if (configFileExistenceInfo.watcher && !configFileExistenceInfo.config && !this.configFileExistenceImpactsRootOfInferredProject(configFileExistenceInfo)) {
	            configFileExistenceInfo.watcher.close();
	            configFileExistenceInfo.watcher = void 0;
	          }
	        }
	        /**
	         * This is called on file close, so that we stop watching the config file for this script info
	         */
	        stopWatchingConfigFilesForClosedScriptInfo(info) {
	          Debug.assert(!info.isScriptOpen());
	          this.forEachConfigFileLocation(info, (canonicalConfigFilePath) => {
	            var _a, _b, _c;
	            const configFileExistenceInfo = this.configFileExistenceInfoCache.get(canonicalConfigFilePath);
	            if (configFileExistenceInfo) {
	              const infoIsRootOfInferredProject = (_a = configFileExistenceInfo.openFilesImpactedByConfigFile) == null ? void 0 : _a.get(info.path);
	              (_b = configFileExistenceInfo.openFilesImpactedByConfigFile) == null ? void 0 : _b.delete(info.path);
	              if (infoIsRootOfInferredProject) {
	                this.closeConfigFileWatcherOnReleaseOfOpenFile(configFileExistenceInfo);
	              }
	              if (!((_c = configFileExistenceInfo.openFilesImpactedByConfigFile) == null ? void 0 : _c.size) && !configFileExistenceInfo.config) {
	                Debug.assert(!configFileExistenceInfo.watcher);
	                this.configFileExistenceInfoCache.delete(canonicalConfigFilePath);
	              }
	            }
	          });
	        }
	        /**
	         * This is called by inferred project whenever script info is added as a root
	         *
	         * @internal
	         */
	        startWatchingConfigFilesForInferredProjectRoot(info) {
	          Debug.assert(info.isScriptOpen());
	          this.forEachConfigFileLocation(info, (canonicalConfigFilePath, configFileName) => {
	            let configFileExistenceInfo = this.configFileExistenceInfoCache.get(canonicalConfigFilePath);
	            if (!configFileExistenceInfo) {
	              configFileExistenceInfo = { exists: this.host.fileExists(configFileName) };
	              this.configFileExistenceInfoCache.set(canonicalConfigFilePath, configFileExistenceInfo);
	            }
	            (configFileExistenceInfo.openFilesImpactedByConfigFile || (configFileExistenceInfo.openFilesImpactedByConfigFile = /* @__PURE__ */ new Map())).set(info.path, true);
	            configFileExistenceInfo.watcher || (configFileExistenceInfo.watcher = canWatchDirectoryOrFile(getPathComponents(getDirectoryPath(canonicalConfigFilePath))) ? this.watchFactory.watchFile(
	              configFileName,
	              (_filename, eventKind) => this.onConfigFileChanged(canonicalConfigFilePath, eventKind),
	              2e3 /* High */,
	              this.hostConfiguration.watchOptions,
	              WatchType.ConfigFileForInferredRoot
	            ) : noopConfigFileWatcher);
	          });
	        }
	        /**
	         * This is called by inferred project whenever root script info is removed from it
	         *
	         * @internal
	         */
	        stopWatchingConfigFilesForInferredProjectRoot(info) {
	          this.forEachConfigFileLocation(info, (canonicalConfigFilePath) => {
	            var _a;
	            const configFileExistenceInfo = this.configFileExistenceInfoCache.get(canonicalConfigFilePath);
	            if ((_a = configFileExistenceInfo == null ? void 0 : configFileExistenceInfo.openFilesImpactedByConfigFile) == null ? void 0 : _a.has(info.path)) {
	              Debug.assert(info.isScriptOpen());
	              configFileExistenceInfo.openFilesImpactedByConfigFile.set(info.path, false);
	              this.closeConfigFileWatcherOnReleaseOfOpenFile(configFileExistenceInfo);
	            }
	          });
	        }
	        /**
	         * This function tries to search for a tsconfig.json for the given file.
	         * This is different from the method the compiler uses because
	         * the compiler can assume it will always start searching in the
	         * current directory (the directory in which tsc was invoked).
	         * The server must start searching from the directory containing
	         * the newly opened file.
	         */
	        forEachConfigFileLocation(info, action) {
	          if (this.serverMode !== 0 /* Semantic */) {
	            return void 0;
	          }
	          Debug.assert(!isOpenScriptInfo(info) || this.openFiles.has(info.path));
	          const projectRootPath = this.openFiles.get(info.path);
	          const scriptInfo = Debug.checkDefined(this.getScriptInfo(info.path));
	          if (scriptInfo.isDynamic)
	            return void 0;
	          let searchPath = asNormalizedPath(getDirectoryPath(info.fileName));
	          const isSearchPathInProjectRoot = () => containsPath(projectRootPath, searchPath, this.currentDirectory, !this.host.useCaseSensitiveFileNames);
	          const anySearchPathOk = !projectRootPath || !isSearchPathInProjectRoot();
	          let searchInDirectory = !isAncestorConfigFileInfo(info);
	          do {
	            if (searchInDirectory) {
	              const canonicalSearchPath = normalizedPathToPath(searchPath, this.currentDirectory, this.toCanonicalFileName);
	              const tsconfigFileName = asNormalizedPath(combinePaths(searchPath, "tsconfig.json"));
	              let result = action(combinePaths(canonicalSearchPath, "tsconfig.json"), tsconfigFileName);
	              if (result)
	                return tsconfigFileName;
	              const jsconfigFileName = asNormalizedPath(combinePaths(searchPath, "jsconfig.json"));
	              result = action(combinePaths(canonicalSearchPath, "jsconfig.json"), jsconfigFileName);
	              if (result)
	                return jsconfigFileName;
	              if (isNodeModulesDirectory(canonicalSearchPath)) {
	                break;
	              }
	            }
	            const parentPath = asNormalizedPath(getDirectoryPath(searchPath));
	            if (parentPath === searchPath)
	              break;
	            searchPath = parentPath;
	            searchInDirectory = true;
	          } while (anySearchPathOk || isSearchPathInProjectRoot());
	          return void 0;
	        }
	        /** @internal */
	        findDefaultConfiguredProject(info) {
	          if (!info.isScriptOpen())
	            return void 0;
	          const configFileName = this.getConfigFileNameForFile(info);
	          const project = configFileName && this.findConfiguredProjectByProjectName(configFileName);
	          return project && projectContainsInfoDirectly(project, info) ? project : project == null ? void 0 : project.getDefaultChildProjectFromProjectWithReferences(info);
	        }
	        /**
	         * This function tries to search for a tsconfig.json for the given file.
	         * This is different from the method the compiler uses because
	         * the compiler can assume it will always start searching in the
	         * current directory (the directory in which tsc was invoked).
	         * The server must start searching from the directory containing
	         * the newly opened file.
	         * If script info is passed in, it is asserted to be open script info
	         * otherwise just file name
	         */
	        getConfigFileNameForFile(info) {
	          if (!isAncestorConfigFileInfo(info)) {
	            const result = this.configFileForOpenFiles.get(info.path);
	            if (result !== void 0)
	              return result || void 0;
	          }
	          this.logger.info(`Search path: ${getDirectoryPath(info.fileName)}`);
	          const configFileName = this.forEachConfigFileLocation(info, (canonicalConfigFilePath, configFileName2) => this.configFileExists(configFileName2, canonicalConfigFilePath, info));
	          if (configFileName) {
	            this.logger.info(`For info: ${info.fileName} :: Config file name: ${configFileName}`);
	          } else {
	            this.logger.info(`For info: ${info.fileName} :: No config files found.`);
	          }
	          if (isOpenScriptInfo(info)) {
	            this.configFileForOpenFiles.set(info.path, configFileName || false);
	          }
	          return configFileName;
	        }
	        printProjects() {
	          if (!this.logger.hasLevel(1 /* normal */)) {
	            return;
	          }
	          this.logger.startGroup();
	          this.externalProjects.forEach(printProjectWithoutFileNames);
	          this.configuredProjects.forEach(printProjectWithoutFileNames);
	          this.inferredProjects.forEach(printProjectWithoutFileNames);
	          this.logger.info("Open files: ");
	          this.openFiles.forEach((projectRootPath, path) => {
	            const info = this.getScriptInfoForPath(path);
	            this.logger.info(`	FileName: ${info.fileName} ProjectRootPath: ${projectRootPath}`);
	            this.logger.info(`		Projects: ${info.containingProjects.map((p) => p.getProjectName())}`);
	          });
	          this.logger.endGroup();
	        }
	        /** @internal */
	        findConfiguredProjectByProjectName(configFileName) {
	          const canonicalConfigFilePath = asNormalizedPath(this.toCanonicalFileName(configFileName));
	          return this.getConfiguredProjectByCanonicalConfigFilePath(canonicalConfigFilePath);
	        }
	        getConfiguredProjectByCanonicalConfigFilePath(canonicalConfigFilePath) {
	          return this.configuredProjects.get(canonicalConfigFilePath);
	        }
	        findExternalProjectByProjectName(projectFileName) {
	          return findProjectByName(projectFileName, this.externalProjects);
	        }
	        /** Get a filename if the language service exceeds the maximum allowed program size; otherwise returns undefined. */
	        getFilenameForExceededTotalSizeLimitForNonTsFiles(name, options, fileNames, propertyReader) {
	          if (options && options.disableSizeLimit || !this.host.getFileSize) {
	            return;
	          }
	          let availableSpace = maxProgramSizeForNonTsFiles;
	          this.projectToSizeMap.set(name, 0);
	          this.projectToSizeMap.forEach((val) => availableSpace -= val || 0);
	          let totalNonTsFileSize = 0;
	          for (const f of fileNames) {
	            const fileName = propertyReader.getFileName(f);
	            if (hasTSFileExtension(fileName)) {
	              continue;
	            }
	            totalNonTsFileSize += this.host.getFileSize(fileName);
	            if (totalNonTsFileSize > maxProgramSizeForNonTsFiles || totalNonTsFileSize > availableSpace) {
	              const top5LargestFiles = fileNames.map((f2) => propertyReader.getFileName(f2)).filter((name2) => !hasTSFileExtension(name2)).map((name2) => ({ name: name2, size: this.host.getFileSize(name2) })).sort((a, b) => b.size - a.size).slice(0, 5);
	              this.logger.info(`Non TS file size exceeded limit (${totalNonTsFileSize}). Largest files: ${top5LargestFiles.map((file) => `${file.name}:${file.size}`).join(", ")}`);
	              return fileName;
	            }
	          }
	          this.projectToSizeMap.set(name, totalNonTsFileSize);
	        }
	        createExternalProject(projectFileName, files, options, typeAcquisition, excludedFiles) {
	          const compilerOptions = convertCompilerOptions(options);
	          const watchOptionsAndErrors = convertWatchOptions(options, getDirectoryPath(normalizeSlashes(projectFileName)));
	          const project = new ExternalProject2(
	            projectFileName,
	            this,
	            this.documentRegistry,
	            compilerOptions,
	            /*lastFileExceededProgramSize*/
	            this.getFilenameForExceededTotalSizeLimitForNonTsFiles(projectFileName, compilerOptions, files, externalFilePropertyReader),
	            options.compileOnSave === void 0 ? true : options.compileOnSave,
	            /*projectFilePath*/
	            void 0,
	            watchOptionsAndErrors == null ? void 0 : watchOptionsAndErrors.watchOptions
	          );
	          project.setProjectErrors(watchOptionsAndErrors == null ? void 0 : watchOptionsAndErrors.errors);
	          project.excludedFiles = excludedFiles;
	          this.addFilesToNonInferredProject(project, files, externalFilePropertyReader, typeAcquisition);
	          this.externalProjects.push(project);
	          return project;
	        }
	        /** @internal */
	        sendProjectTelemetry(project) {
	          if (this.seenProjects.has(project.projectName)) {
	            setProjectOptionsUsed(project);
	            return;
	          }
	          this.seenProjects.set(project.projectName, true);
	          if (!this.eventHandler || !this.host.createSHA256Hash) {
	            setProjectOptionsUsed(project);
	            return;
	          }
	          const projectOptions = isConfiguredProject(project) ? project.projectOptions : void 0;
	          setProjectOptionsUsed(project);
	          const data = {
	            projectId: this.host.createSHA256Hash(project.projectName),
	            fileStats: countEachFileTypes(
	              project.getScriptInfos(),
	              /*includeSizes*/
	              true
	            ),
	            compilerOptions: convertCompilerOptionsForTelemetry(project.getCompilationSettings()),
	            typeAcquisition: convertTypeAcquisition2(project.getTypeAcquisition()),
	            extends: projectOptions && projectOptions.configHasExtendsProperty,
	            files: projectOptions && projectOptions.configHasFilesProperty,
	            include: projectOptions && projectOptions.configHasIncludeProperty,
	            exclude: projectOptions && projectOptions.configHasExcludeProperty,
	            compileOnSave: project.compileOnSaveEnabled,
	            configFileName: configFileName(),
	            projectType: project instanceof ExternalProject2 ? "external" : "configured",
	            languageServiceEnabled: project.languageServiceEnabled,
	            version
	          };
	          this.eventHandler({ eventName: ProjectInfoTelemetryEvent, data });
	          function configFileName() {
	            if (!isConfiguredProject(project)) {
	              return "other";
	            }
	            return getBaseConfigFileName(project.getConfigFilePath()) || "other";
	          }
	          function convertTypeAcquisition2({ enable: enable2, include, exclude }) {
	            return {
	              enable: enable2,
	              include: include !== void 0 && include.length !== 0,
	              exclude: exclude !== void 0 && exclude.length !== 0
	            };
	          }
	        }
	        addFilesToNonInferredProject(project, files, propertyReader, typeAcquisition) {
	          this.updateNonInferredProjectFiles(project, files, propertyReader);
	          project.setTypeAcquisition(typeAcquisition);
	          project.markAsDirty();
	        }
	        /** @internal */
	        createConfiguredProject(configFileName) {
	          var _a;
	          (_a = tracing) == null ? void 0 : _a.instant(tracing.Phase.Session, "createConfiguredProject", { configFilePath: configFileName });
	          this.logger.info(`Creating configuration project ${configFileName}`);
	          const canonicalConfigFilePath = asNormalizedPath(this.toCanonicalFileName(configFileName));
	          let configFileExistenceInfo = this.configFileExistenceInfoCache.get(canonicalConfigFilePath);
	          if (!configFileExistenceInfo) {
	            this.configFileExistenceInfoCache.set(canonicalConfigFilePath, configFileExistenceInfo = { exists: true });
	          } else {
	            configFileExistenceInfo.exists = true;
	          }
	          if (!configFileExistenceInfo.config) {
	            configFileExistenceInfo.config = {
	              cachedDirectoryStructureHost: createCachedDirectoryStructureHost(this.host, this.host.getCurrentDirectory(), this.host.useCaseSensitiveFileNames),
	              projects: /* @__PURE__ */ new Map(),
	              updateLevel: 2 /* Full */
	            };
	          }
	          const project = new ConfiguredProject2(
	            configFileName,
	            canonicalConfigFilePath,
	            this,
	            this.documentRegistry,
	            configFileExistenceInfo.config.cachedDirectoryStructureHost
	          );
	          this.configuredProjects.set(canonicalConfigFilePath, project);
	          this.createConfigFileWatcherForParsedConfig(configFileName, canonicalConfigFilePath, project);
	          return project;
	        }
	        /** @internal */
	        createConfiguredProjectWithDelayLoad(configFileName, reason) {
	          const project = this.createConfiguredProject(configFileName);
	          project.pendingUpdateLevel = 2 /* Full */;
	          project.pendingUpdateReason = reason;
	          return project;
	        }
	        /** @internal */
	        createAndLoadConfiguredProject(configFileName, reason) {
	          const project = this.createConfiguredProject(configFileName);
	          this.loadConfiguredProject(project, reason);
	          return project;
	        }
	        /** @internal */
	        createLoadAndUpdateConfiguredProject(configFileName, reason) {
	          const project = this.createAndLoadConfiguredProject(configFileName, reason);
	          project.updateGraph();
	          return project;
	        }
	        /**
	         * Read the config file of the project, and update the project root file names.
	         *
	         * @internal
	         */
	        loadConfiguredProject(project, reason) {
	          var _a, _b;
	          (_a = tracing) == null ? void 0 : _a.push(tracing.Phase.Session, "loadConfiguredProject", { configFilePath: project.canonicalConfigFilePath });
	          this.sendProjectLoadingStartEvent(project, reason);
	          const configFilename = asNormalizedPath(normalizePath(project.getConfigFilePath()));
	          const configFileExistenceInfo = this.ensureParsedConfigUptoDate(
	            configFilename,
	            project.canonicalConfigFilePath,
	            this.configFileExistenceInfoCache.get(project.canonicalConfigFilePath),
	            project
	          );
	          const parsedCommandLine = configFileExistenceInfo.config.parsedCommandLine;
	          Debug.assert(!!parsedCommandLine.fileNames);
	          const compilerOptions = parsedCommandLine.options;
	          if (!project.projectOptions) {
	            project.projectOptions = {
	              configHasExtendsProperty: parsedCommandLine.raw.extends !== void 0,
	              configHasFilesProperty: parsedCommandLine.raw.files !== void 0,
	              configHasIncludeProperty: parsedCommandLine.raw.include !== void 0,
	              configHasExcludeProperty: parsedCommandLine.raw.exclude !== void 0
	            };
	          }
	          project.canConfigFileJsonReportNoInputFiles = canJsonReportNoInputFiles(parsedCommandLine.raw);
	          project.setProjectErrors(parsedCommandLine.options.configFile.parseDiagnostics);
	          project.updateReferences(parsedCommandLine.projectReferences);
	          const lastFileExceededProgramSize = this.getFilenameForExceededTotalSizeLimitForNonTsFiles(project.canonicalConfigFilePath, compilerOptions, parsedCommandLine.fileNames, fileNamePropertyReader);
	          if (lastFileExceededProgramSize) {
	            project.disableLanguageService(lastFileExceededProgramSize);
	            this.configFileExistenceInfoCache.forEach((_configFileExistenceInfo, canonicalConfigFilePath) => this.stopWatchingWildCards(canonicalConfigFilePath, project));
	          } else {
	            project.setCompilerOptions(compilerOptions);
	            project.setWatchOptions(parsedCommandLine.watchOptions);
	            project.enableLanguageService();
	            this.watchWildcards(configFilename, configFileExistenceInfo, project);
	          }
	          project.enablePluginsWithOptions(compilerOptions);
	          const filesToAdd = parsedCommandLine.fileNames.concat(project.getExternalFiles(2 /* Full */));
	          this.updateRootAndOptionsOfNonInferredProject(project, filesToAdd, fileNamePropertyReader, compilerOptions, parsedCommandLine.typeAcquisition, parsedCommandLine.compileOnSave, parsedCommandLine.watchOptions);
	          (_b = tracing) == null ? void 0 : _b.pop();
	        }
	        /** @internal */
	        ensureParsedConfigUptoDate(configFilename, canonicalConfigFilePath, configFileExistenceInfo, forProject) {
	          var _a, _b, _c;
	          if (configFileExistenceInfo.config) {
	            if (!configFileExistenceInfo.config.updateLevel)
	              return configFileExistenceInfo;
	            if (configFileExistenceInfo.config.updateLevel === 1 /* RootNamesAndUpdate */) {
	              this.reloadFileNamesOfParsedConfig(configFilename, configFileExistenceInfo.config);
	              return configFileExistenceInfo;
	            }
	          }
	          const cachedDirectoryStructureHost = ((_a = configFileExistenceInfo.config) == null ? void 0 : _a.cachedDirectoryStructureHost) || createCachedDirectoryStructureHost(this.host, this.host.getCurrentDirectory(), this.host.useCaseSensitiveFileNames);
	          const configFileContent = tryReadFile(configFilename, (fileName) => this.host.readFile(fileName));
	          const configFile = parseJsonText(configFilename, isString(configFileContent) ? configFileContent : "");
	          const configFileErrors = configFile.parseDiagnostics;
	          if (!isString(configFileContent))
	            configFileErrors.push(configFileContent);
	          const parsedCommandLine = parseJsonSourceFileConfigFileContent(
	            configFile,
	            cachedDirectoryStructureHost,
	            getDirectoryPath(configFilename),
	            /*existingOptions*/
	            {},
	            configFilename,
	            /*resolutionStack*/
	            [],
	            this.hostConfiguration.extraFileExtensions,
	            this.extendedConfigCache
	          );
	          if (parsedCommandLine.errors.length) {
	            configFileErrors.push(...parsedCommandLine.errors);
	          }
	          this.logger.info(`Config: ${configFilename} : ${JSON.stringify(
	            {
	              rootNames: parsedCommandLine.fileNames,
	              options: parsedCommandLine.options,
	              watchOptions: parsedCommandLine.watchOptions,
	              projectReferences: parsedCommandLine.projectReferences
	            },
	            /*replacer*/
	            void 0,
	            " "
	          )}`);
	          const oldCommandLine = (_b = configFileExistenceInfo.config) == null ? void 0 : _b.parsedCommandLine;
	          if (!configFileExistenceInfo.config) {
	            configFileExistenceInfo.config = { parsedCommandLine, cachedDirectoryStructureHost, projects: /* @__PURE__ */ new Map() };
	          } else {
	            configFileExistenceInfo.config.parsedCommandLine = parsedCommandLine;
	            configFileExistenceInfo.config.watchedDirectoriesStale = true;
	            configFileExistenceInfo.config.updateLevel = void 0;
	          }
	          if (!oldCommandLine && !isJsonEqual(
	            // Old options
	            this.getWatchOptionsFromProjectWatchOptions(
	              /*projectOptions*/
	              void 0
	            ),
	            // New options
	            this.getWatchOptionsFromProjectWatchOptions(parsedCommandLine.watchOptions)
	          )) {
	            (_c = configFileExistenceInfo.watcher) == null ? void 0 : _c.close();
	            configFileExistenceInfo.watcher = void 0;
	          }
	          this.createConfigFileWatcherForParsedConfig(configFilename, canonicalConfigFilePath, forProject);
	          updateSharedExtendedConfigFileWatcher(
	            canonicalConfigFilePath,
	            parsedCommandLine.options,
	            this.sharedExtendedConfigFileWatchers,
	            (extendedConfigFileName, extendedConfigFilePath) => this.watchFactory.watchFile(
	              extendedConfigFileName,
	              () => {
	                var _a2;
	                cleanExtendedConfigCache(this.extendedConfigCache, extendedConfigFilePath, (fileName) => this.toPath(fileName));
	                let ensureProjectsForOpenFiles = false;
	                (_a2 = this.sharedExtendedConfigFileWatchers.get(extendedConfigFilePath)) == null ? void 0 : _a2.projects.forEach((canonicalPath) => {
	                  ensureProjectsForOpenFiles = this.delayUpdateProjectsFromParsedConfigOnConfigFileChange(canonicalPath, `Change in extended config file ${extendedConfigFileName} detected`) || ensureProjectsForOpenFiles;
	                });
	                if (ensureProjectsForOpenFiles)
	                  this.delayEnsureProjectForOpenFiles();
	              },
	              2e3 /* High */,
	              this.hostConfiguration.watchOptions,
	              WatchType.ExtendedConfigFile,
	              configFilename
	            ),
	            (fileName) => this.toPath(fileName)
	          );
	          return configFileExistenceInfo;
	        }
	        /** @internal */
	        watchWildcards(configFileName, { exists, config }, forProject) {
	          config.projects.set(forProject.canonicalConfigFilePath, true);
	          if (exists) {
	            if (config.watchedDirectories && !config.watchedDirectoriesStale)
	              return;
	            config.watchedDirectoriesStale = false;
	            updateWatchingWildcardDirectories(
	              config.watchedDirectories || (config.watchedDirectories = /* @__PURE__ */ new Map()),
	              config.parsedCommandLine.wildcardDirectories,
	              // Create new directory watcher
	              (directory, flags) => this.watchWildcardDirectory(directory, flags, configFileName, config)
	            );
	          } else {
	            config.watchedDirectoriesStale = false;
	            if (!config.watchedDirectories)
	              return;
	            clearMap(config.watchedDirectories, closeFileWatcherOf);
	            config.watchedDirectories = void 0;
	          }
	        }
	        /** @internal */
	        stopWatchingWildCards(canonicalConfigFilePath, forProject) {
	          const configFileExistenceInfo = this.configFileExistenceInfoCache.get(canonicalConfigFilePath);
	          if (!configFileExistenceInfo.config || !configFileExistenceInfo.config.projects.get(forProject.canonicalConfigFilePath)) {
	            return;
	          }
	          configFileExistenceInfo.config.projects.set(forProject.canonicalConfigFilePath, false);
	          if (forEachEntry(configFileExistenceInfo.config.projects, identity))
	            return;
	          if (configFileExistenceInfo.config.watchedDirectories) {
	            clearMap(configFileExistenceInfo.config.watchedDirectories, closeFileWatcherOf);
	            configFileExistenceInfo.config.watchedDirectories = void 0;
	          }
	          configFileExistenceInfo.config.watchedDirectoriesStale = void 0;
	        }
	        updateNonInferredProjectFiles(project, files, propertyReader) {
	          const projectRootFilesMap = project.getRootFilesMap();
	          const newRootScriptInfoMap = /* @__PURE__ */ new Map();
	          for (const f of files) {
	            const newRootFile = propertyReader.getFileName(f);
	            const fileName = toNormalizedPath(newRootFile);
	            const isDynamic = isDynamicFileName(fileName);
	            let path;
	            if (!isDynamic && !project.fileExists(newRootFile)) {
	              path = normalizedPathToPath(fileName, this.currentDirectory, this.toCanonicalFileName);
	              const existingValue = projectRootFilesMap.get(path);
	              if (existingValue) {
	                if (existingValue.info) {
	                  project.removeFile(
	                    existingValue.info,
	                    /*fileExists*/
	                    false,
	                    /*detachFromProject*/
	                    true
	                  );
	                  existingValue.info = void 0;
	                }
	                existingValue.fileName = fileName;
	              } else {
	                projectRootFilesMap.set(path, { fileName });
	              }
	            } else {
	              const scriptKind = propertyReader.getScriptKind(f, this.hostConfiguration.extraFileExtensions);
	              const hasMixedContent = propertyReader.hasMixedContent(f, this.hostConfiguration.extraFileExtensions);
	              const scriptInfo = Debug.checkDefined(this.getOrCreateScriptInfoNotOpenedByClientForNormalizedPath(
	                fileName,
	                project.currentDirectory,
	                scriptKind,
	                hasMixedContent,
	                project.directoryStructureHost
	              ));
	              path = scriptInfo.path;
	              const existingValue = projectRootFilesMap.get(path);
	              if (!existingValue || existingValue.info !== scriptInfo) {
	                project.addRoot(scriptInfo, fileName);
	                if (scriptInfo.isScriptOpen()) {
	                  this.removeRootOfInferredProjectIfNowPartOfOtherProject(scriptInfo);
	                }
	              } else {
	                existingValue.fileName = fileName;
	              }
	            }
	            newRootScriptInfoMap.set(path, true);
	          }
	          if (projectRootFilesMap.size > newRootScriptInfoMap.size) {
	            projectRootFilesMap.forEach((value, path) => {
	              if (!newRootScriptInfoMap.has(path)) {
	                if (value.info) {
	                  project.removeFile(
	                    value.info,
	                    project.fileExists(value.info.fileName),
	                    /*detachFromProject*/
	                    true
	                  );
	                } else {
	                  projectRootFilesMap.delete(path);
	                }
	              }
	            });
	          }
	        }
	        updateRootAndOptionsOfNonInferredProject(project, newUncheckedFiles, propertyReader, newOptions, newTypeAcquisition, compileOnSave, watchOptions) {
	          project.setCompilerOptions(newOptions);
	          project.setWatchOptions(watchOptions);
	          if (compileOnSave !== void 0) {
	            project.compileOnSaveEnabled = compileOnSave;
	          }
	          this.addFilesToNonInferredProject(project, newUncheckedFiles, propertyReader, newTypeAcquisition);
	        }
	        /**
	         * Reload the file names from config file specs and update the project graph
	         *
	         * @internal
	         */
	        reloadFileNamesOfConfiguredProject(project) {
	          const fileNames = this.reloadFileNamesOfParsedConfig(project.getConfigFilePath(), this.configFileExistenceInfoCache.get(project.canonicalConfigFilePath).config);
	          project.updateErrorOnNoInputFiles(fileNames);
	          this.updateNonInferredProjectFiles(project, fileNames.concat(project.getExternalFiles(1 /* RootNamesAndUpdate */)), fileNamePropertyReader);
	          project.markAsDirty();
	          return project.updateGraph();
	        }
	        /** @internal */
	        reloadFileNamesOfParsedConfig(configFileName, config) {
	          if (config.updateLevel === void 0)
	            return config.parsedCommandLine.fileNames;
	          Debug.assert(config.updateLevel === 1 /* RootNamesAndUpdate */);
	          const configFileSpecs = config.parsedCommandLine.options.configFile.configFileSpecs;
	          const fileNames = getFileNamesFromConfigSpecs(
	            configFileSpecs,
	            getDirectoryPath(configFileName),
	            config.parsedCommandLine.options,
	            config.cachedDirectoryStructureHost,
	            this.hostConfiguration.extraFileExtensions
	          );
	          config.parsedCommandLine = { ...config.parsedCommandLine, fileNames };
	          return fileNames;
	        }
	        /** @internal */
	        setFileNamesOfAutpImportProviderOrAuxillaryProject(project, fileNames) {
	          this.updateNonInferredProjectFiles(project, fileNames, fileNamePropertyReader);
	        }
	        /**
	         * Read the config file of the project again by clearing the cache and update the project graph
	         *
	         * @internal
	         */
	        reloadConfiguredProject(project, reason, isInitialLoad, clearSemanticCache) {
	          const host = project.getCachedDirectoryStructureHost();
	          if (clearSemanticCache)
	            this.clearSemanticCache(project);
	          host.clearCache();
	          const configFileName = project.getConfigFilePath();
	          this.logger.info(`${isInitialLoad ? "Loading" : "Reloading"} configured project ${configFileName}`);
	          this.loadConfiguredProject(project, reason);
	          project.updateGraph();
	          this.sendConfigFileDiagEvent(project, configFileName);
	        }
	        /** @internal */
	        clearSemanticCache(project) {
	          project.resolutionCache.clear();
	          project.getLanguageService(
	            /*ensureSynchronized*/
	            false
	          ).cleanupSemanticCache();
	          project.cleanupProgram();
	          project.markAsDirty();
	        }
	        sendConfigFileDiagEvent(project, triggerFile) {
	          if (!this.eventHandler || this.suppressDiagnosticEvents) {
	            return;
	          }
	          const diagnostics = project.getLanguageService().getCompilerOptionsDiagnostics();
	          diagnostics.push(...project.getAllProjectErrors());
	          this.eventHandler(
	            {
	              eventName: ConfigFileDiagEvent,
	              data: { configFileName: project.getConfigFilePath(), diagnostics, triggerFile }
	            }
	          );
	        }
	        getOrCreateInferredProjectForProjectRootPathIfEnabled(info, projectRootPath) {
	          if (!this.useInferredProjectPerProjectRoot || // Its a dynamic info opened without project root
	          info.isDynamic && projectRootPath === void 0) {
	            return void 0;
	          }
	          if (projectRootPath) {
	            const canonicalProjectRootPath = this.toCanonicalFileName(projectRootPath);
	            for (const project of this.inferredProjects) {
	              if (project.projectRootPath === canonicalProjectRootPath) {
	                return project;
	              }
	            }
	            return this.createInferredProject(
	              projectRootPath,
	              /*isSingleInferredProject*/
	              false,
	              projectRootPath
	            );
	          }
	          let bestMatch;
	          for (const project of this.inferredProjects) {
	            if (!project.projectRootPath)
	              continue;
	            if (!containsPath(project.projectRootPath, info.path, this.host.getCurrentDirectory(), !this.host.useCaseSensitiveFileNames))
	              continue;
	            if (bestMatch && bestMatch.projectRootPath.length > project.projectRootPath.length)
	              continue;
	            bestMatch = project;
	          }
	          return bestMatch;
	        }
	        getOrCreateSingleInferredProjectIfEnabled() {
	          if (!this.useSingleInferredProject) {
	            return void 0;
	          }
	          if (this.inferredProjects.length > 0 && this.inferredProjects[0].projectRootPath === void 0) {
	            return this.inferredProjects[0];
	          }
	          return this.createInferredProject(
	            "",
	            /*isSingleInferredProject*/
	            true
	          );
	        }
	        getOrCreateSingleInferredWithoutProjectRoot(currentDirectory) {
	          Debug.assert(!this.useSingleInferredProject);
	          const expectedCurrentDirectory = this.toCanonicalFileName(this.getNormalizedAbsolutePath(currentDirectory));
	          for (const inferredProject of this.inferredProjects) {
	            if (!inferredProject.projectRootPath && inferredProject.isOrphan() && inferredProject.canonicalCurrentDirectory === expectedCurrentDirectory) {
	              return inferredProject;
	            }
	          }
	          return this.createInferredProject(currentDirectory);
	        }
	        createInferredProject(currentDirectory, isSingleInferredProject, projectRootPath) {
	          const compilerOptions = projectRootPath && this.compilerOptionsForInferredProjectsPerProjectRoot.get(projectRootPath) || this.compilerOptionsForInferredProjects;
	          let watchOptionsAndErrors;
	          let typeAcquisition;
	          if (projectRootPath) {
	            watchOptionsAndErrors = this.watchOptionsForInferredProjectsPerProjectRoot.get(projectRootPath);
	            typeAcquisition = this.typeAcquisitionForInferredProjectsPerProjectRoot.get(projectRootPath);
	          }
	          if (watchOptionsAndErrors === void 0) {
	            watchOptionsAndErrors = this.watchOptionsForInferredProjects;
	          }
	          if (typeAcquisition === void 0) {
	            typeAcquisition = this.typeAcquisitionForInferredProjects;
	          }
	          watchOptionsAndErrors = watchOptionsAndErrors || void 0;
	          const project = new InferredProject2(this, this.documentRegistry, compilerOptions, watchOptionsAndErrors == null ? void 0 : watchOptionsAndErrors.watchOptions, projectRootPath, currentDirectory, typeAcquisition);
	          project.setProjectErrors(watchOptionsAndErrors == null ? void 0 : watchOptionsAndErrors.errors);
	          if (isSingleInferredProject) {
	            this.inferredProjects.unshift(project);
	          } else {
	            this.inferredProjects.push(project);
	          }
	          return project;
	        }
	        /** @internal */
	        getOrCreateScriptInfoNotOpenedByClient(uncheckedFileName, currentDirectory, hostToQueryFileExistsOn) {
	          return this.getOrCreateScriptInfoNotOpenedByClientForNormalizedPath(
	            toNormalizedPath(uncheckedFileName),
	            currentDirectory,
	            /*scriptKind*/
	            void 0,
	            /*hasMixedContent*/
	            void 0,
	            hostToQueryFileExistsOn
	          );
	        }
	        getScriptInfo(uncheckedFileName) {
	          return this.getScriptInfoForNormalizedPath(toNormalizedPath(uncheckedFileName));
	        }
	        /** @internal */
	        getScriptInfoOrConfig(uncheckedFileName) {
	          const path = toNormalizedPath(uncheckedFileName);
	          const info = this.getScriptInfoForNormalizedPath(path);
	          if (info)
	            return info;
	          const configProject = this.configuredProjects.get(this.toPath(uncheckedFileName));
	          return configProject && configProject.getCompilerOptions().configFile;
	        }
	        /** @internal */
	        logErrorForScriptInfoNotFound(fileName) {
	          const names = arrayFrom(this.filenameToScriptInfo.entries(), ([path, scriptInfo]) => ({ path, fileName: scriptInfo.fileName }));
	          this.logger.msg(`Could not find file ${JSON.stringify(fileName)}.
All files are: ${JSON.stringify(names)}`, "Err" /* Err */);
	        }
	        /**
	         * Returns the projects that contain script info through SymLink
	         * Note that this does not return projects in info.containingProjects
	         *
	         * @internal
	         */
	        getSymlinkedProjects(info) {
	          let projects;
	          if (this.realpathToScriptInfos) {
	            const realpath = info.getRealpathIfDifferent();
	            if (realpath) {
	              forEach(this.realpathToScriptInfos.get(realpath), combineProjects);
	            }
	            forEach(this.realpathToScriptInfos.get(info.path), combineProjects);
	          }
	          return projects;
	          function combineProjects(toAddInfo) {
	            if (toAddInfo !== info) {
	              for (const project of toAddInfo.containingProjects) {
	                if (project.languageServiceEnabled && !project.isOrphan() && !project.getCompilerOptions().preserveSymlinks && !info.isAttached(project)) {
	                  if (!projects) {
	                    projects = createMultiMap();
	                    projects.add(toAddInfo.path, project);
	                  } else if (!forEachEntry(projects, (projs, path) => path === toAddInfo.path ? false : contains(projs, project))) {
	                    projects.add(toAddInfo.path, project);
	                  }
	                }
	              }
	            }
	          }
	        }
	        watchClosedScriptInfo(info) {
	          Debug.assert(!info.fileWatcher);
	          if (!info.isDynamicOrHasMixedContent() && (!this.globalCacheLocationDirectoryPath || !startsWith(info.path, this.globalCacheLocationDirectoryPath))) {
	            const indexOfNodeModules = info.fileName.indexOf("/node_modules/");
	            if (!this.host.getModifiedTime || indexOfNodeModules === -1) {
	              info.fileWatcher = this.watchFactory.watchFile(
	                info.fileName,
	                (_fileName, eventKind) => this.onSourceFileChanged(info, eventKind),
	                500 /* Medium */,
	                this.hostConfiguration.watchOptions,
	                WatchType.ClosedScriptInfo
	              );
	            } else {
	              info.mTime = this.getModifiedTime(info);
	              info.fileWatcher = this.watchClosedScriptInfoInNodeModules(info.fileName.substring(0, indexOfNodeModules));
	            }
	          }
	        }
	        createNodeModulesWatcher(dir, dirPath) {
	          let watcher = this.watchFactory.watchDirectory(
	            dir,
	            (fileOrDirectory) => {
	              var _a;
	              const fileOrDirectoryPath = removeIgnoredPath(this.toPath(fileOrDirectory));
	              if (!fileOrDirectoryPath)
	                return;
	              const basename = getBaseFileName(fileOrDirectoryPath);
	              if (((_a = result.affectedModuleSpecifierCacheProjects) == null ? void 0 : _a.size) && (basename === "package.json" || basename === "node_modules")) {
	                result.affectedModuleSpecifierCacheProjects.forEach((project) => {
	                  var _a2;
	                  (_a2 = project.getModuleSpecifierCache()) == null ? void 0 : _a2.clear();
	                });
	              }
	              if (result.refreshScriptInfoRefCount) {
	                if (dirPath === fileOrDirectoryPath) {
	                  this.refreshScriptInfosInDirectory(dirPath);
	                } else {
	                  const info = this.getScriptInfoForPath(fileOrDirectoryPath);
	                  if (info) {
	                    if (isScriptInfoWatchedFromNodeModules(info)) {
	                      this.refreshScriptInfo(info);
	                    }
	                  } else if (!hasExtension(fileOrDirectoryPath)) {
	                    this.refreshScriptInfosInDirectory(fileOrDirectoryPath);
	                  }
	                }
	              }
	            },
	            1 /* Recursive */,
	            this.hostConfiguration.watchOptions,
	            WatchType.NodeModules
	          );
	          const result = {
	            refreshScriptInfoRefCount: 0,
	            affectedModuleSpecifierCacheProjects: void 0,
	            close: () => {
	              var _a;
	              if (watcher && !result.refreshScriptInfoRefCount && !((_a = result.affectedModuleSpecifierCacheProjects) == null ? void 0 : _a.size)) {
	                watcher.close();
	                watcher = void 0;
	                this.nodeModulesWatchers.delete(dirPath);
	              }
	            }
	          };
	          this.nodeModulesWatchers.set(dirPath, result);
	          return result;
	        }
	        /** @internal */
	        watchPackageJsonsInNodeModules(dir, project) {
	          var _a;
	          const dirPath = this.toPath(dir);
	          const watcher = this.nodeModulesWatchers.get(dirPath) || this.createNodeModulesWatcher(dir, dirPath);
	          Debug.assert(!((_a = watcher.affectedModuleSpecifierCacheProjects) == null ? void 0 : _a.has(project)));
	          (watcher.affectedModuleSpecifierCacheProjects || (watcher.affectedModuleSpecifierCacheProjects = /* @__PURE__ */ new Set())).add(project);
	          return {
	            close: () => {
	              var _a2;
	              (_a2 = watcher.affectedModuleSpecifierCacheProjects) == null ? void 0 : _a2.delete(project);
	              watcher.close();
	            }
	          };
	        }
	        watchClosedScriptInfoInNodeModules(dir) {
	          const watchDir = dir + "/node_modules";
	          const watchDirPath = this.toPath(watchDir);
	          const watcher = this.nodeModulesWatchers.get(watchDirPath) || this.createNodeModulesWatcher(watchDir, watchDirPath);
	          watcher.refreshScriptInfoRefCount++;
	          return {
	            close: () => {
	              watcher.refreshScriptInfoRefCount--;
	              watcher.close();
	            }
	          };
	        }
	        getModifiedTime(info) {
	          return (this.host.getModifiedTime(info.fileName) || missingFileModifiedTime).getTime();
	        }
	        refreshScriptInfo(info) {
	          const mTime = this.getModifiedTime(info);
	          if (mTime !== info.mTime) {
	            const eventKind = getFileWatcherEventKind(info.mTime, mTime);
	            info.mTime = mTime;
	            this.onSourceFileChanged(info, eventKind);
	          }
	        }
	        refreshScriptInfosInDirectory(dir) {
	          dir = dir + directorySeparator;
	          this.filenameToScriptInfo.forEach((info) => {
	            if (isScriptInfoWatchedFromNodeModules(info) && startsWith(info.path, dir)) {
	              this.refreshScriptInfo(info);
	            }
	          });
	        }
	        stopWatchingScriptInfo(info) {
	          if (info.fileWatcher) {
	            info.fileWatcher.close();
	            info.fileWatcher = void 0;
	          }
	        }
	        getOrCreateScriptInfoNotOpenedByClientForNormalizedPath(fileName, currentDirectory, scriptKind, hasMixedContent, hostToQueryFileExistsOn) {
	          if (isRootedDiskPath(fileName) || isDynamicFileName(fileName)) {
	            return this.getOrCreateScriptInfoWorker(
	              fileName,
	              currentDirectory,
	              /*openedByClient*/
	              false,
	              /*fileContent*/
	              void 0,
	              scriptKind,
	              hasMixedContent,
	              hostToQueryFileExistsOn
	            );
	          }
	          const info = this.openFilesWithNonRootedDiskPath.get(this.toCanonicalFileName(fileName));
	          if (info) {
	            return info;
	          }
	          return void 0;
	        }
	        getOrCreateScriptInfoOpenedByClientForNormalizedPath(fileName, currentDirectory, fileContent, scriptKind, hasMixedContent) {
	          return this.getOrCreateScriptInfoWorker(
	            fileName,
	            currentDirectory,
	            /*openedByClient*/
	            true,
	            fileContent,
	            scriptKind,
	            hasMixedContent
	          );
	        }
	        getOrCreateScriptInfoForNormalizedPath(fileName, openedByClient, fileContent, scriptKind, hasMixedContent, hostToQueryFileExistsOn) {
	          return this.getOrCreateScriptInfoWorker(fileName, this.currentDirectory, openedByClient, fileContent, scriptKind, hasMixedContent, hostToQueryFileExistsOn);
	        }
	        getOrCreateScriptInfoWorker(fileName, currentDirectory, openedByClient, fileContent, scriptKind, hasMixedContent, hostToQueryFileExistsOn) {
	          Debug.assert(fileContent === void 0 || openedByClient, "ScriptInfo needs to be opened by client to be able to set its user defined content");
	          const path = normalizedPathToPath(fileName, currentDirectory, this.toCanonicalFileName);
	          let info = this.getScriptInfoForPath(path);
	          if (!info) {
	            const isDynamic = isDynamicFileName(fileName);
	            Debug.assert(isRootedDiskPath(fileName) || isDynamic || openedByClient, "", () => `${JSON.stringify({ fileName, currentDirectory, hostCurrentDirectory: this.currentDirectory, openKeys: arrayFrom(this.openFilesWithNonRootedDiskPath.keys()) })}
Script info with non-dynamic relative file name can only be open script info or in context of host currentDirectory`);
	            Debug.assert(!isRootedDiskPath(fileName) || this.currentDirectory === currentDirectory || !this.openFilesWithNonRootedDiskPath.has(this.toCanonicalFileName(fileName)), "", () => `${JSON.stringify({ fileName, currentDirectory, hostCurrentDirectory: this.currentDirectory, openKeys: arrayFrom(this.openFilesWithNonRootedDiskPath.keys()) })}
Open script files with non rooted disk path opened with current directory context cannot have same canonical names`);
	            Debug.assert(!isDynamic || this.currentDirectory === currentDirectory || this.useInferredProjectPerProjectRoot, "", () => `${JSON.stringify({ fileName, currentDirectory, hostCurrentDirectory: this.currentDirectory, openKeys: arrayFrom(this.openFilesWithNonRootedDiskPath.keys()) })}
Dynamic files must always be opened with service's current directory or service should support inferred project per projectRootPath.`);
	            if (!openedByClient && !isDynamic && !(hostToQueryFileExistsOn || this.host).fileExists(fileName)) {
	              return;
	            }
	            info = new ScriptInfo(this.host, fileName, scriptKind, !!hasMixedContent, path, this.filenameToScriptInfoVersion.get(path));
	            this.filenameToScriptInfo.set(info.path, info);
	            this.filenameToScriptInfoVersion.delete(info.path);
	            if (!openedByClient) {
	              this.watchClosedScriptInfo(info);
	            } else if (!isRootedDiskPath(fileName) && (!isDynamic || this.currentDirectory !== currentDirectory)) {
	              this.openFilesWithNonRootedDiskPath.set(this.toCanonicalFileName(fileName), info);
	            }
	          }
	          if (openedByClient) {
	            this.stopWatchingScriptInfo(info);
	            info.open(fileContent);
	            if (hasMixedContent) {
	              info.registerFileUpdate();
	            }
	          }
	          return info;
	        }
	        /**
	         * This gets the script info for the normalized path. If the path is not rooted disk path then the open script info with project root context is preferred
	         */
	        getScriptInfoForNormalizedPath(fileName) {
	          return !isRootedDiskPath(fileName) && this.openFilesWithNonRootedDiskPath.get(this.toCanonicalFileName(fileName)) || this.getScriptInfoForPath(normalizedPathToPath(fileName, this.currentDirectory, this.toCanonicalFileName));
	        }
	        getScriptInfoForPath(fileName) {
	          return this.filenameToScriptInfo.get(fileName);
	        }
	        /** @internal */
	        getDocumentPositionMapper(project, generatedFileName, sourceFileName) {
	          const declarationInfo = this.getOrCreateScriptInfoNotOpenedByClient(generatedFileName, project.currentDirectory, this.host);
	          if (!declarationInfo) {
	            if (sourceFileName) {
	              project.addGeneratedFileWatch(generatedFileName, sourceFileName);
	            }
	            return void 0;
	          }
	          declarationInfo.getSnapshot();
	          if (isString(declarationInfo.sourceMapFilePath)) {
	            const sourceMapFileInfo2 = this.getScriptInfoForPath(declarationInfo.sourceMapFilePath);
	            if (sourceMapFileInfo2) {
	              sourceMapFileInfo2.getSnapshot();
	              if (sourceMapFileInfo2.documentPositionMapper !== void 0) {
	                sourceMapFileInfo2.sourceInfos = this.addSourceInfoToSourceMap(sourceFileName, project, sourceMapFileInfo2.sourceInfos);
	                return sourceMapFileInfo2.documentPositionMapper ? sourceMapFileInfo2.documentPositionMapper : void 0;
	              }
	            }
	            declarationInfo.sourceMapFilePath = void 0;
	          } else if (declarationInfo.sourceMapFilePath) {
	            declarationInfo.sourceMapFilePath.sourceInfos = this.addSourceInfoToSourceMap(sourceFileName, project, declarationInfo.sourceMapFilePath.sourceInfos);
	            return void 0;
	          } else if (declarationInfo.sourceMapFilePath !== void 0) {
	            return void 0;
	          }
	          let sourceMapFileInfo;
	          let mapFileNameFromDeclarationInfo;
	          let readMapFile = (mapFileName, mapFileNameFromDts) => {
	            const mapInfo = this.getOrCreateScriptInfoNotOpenedByClient(mapFileName, project.currentDirectory, this.host);
	            if (!mapInfo) {
	              mapFileNameFromDeclarationInfo = mapFileNameFromDts;
	              return void 0;
	            }
	            sourceMapFileInfo = mapInfo;
	            const snap = mapInfo.getSnapshot();
	            if (mapInfo.documentPositionMapper !== void 0)
	              return mapInfo.documentPositionMapper;
	            return getSnapshotText(snap);
	          };
	          const projectName = project.projectName;
	          const documentPositionMapper = getDocumentPositionMapper(
	            { getCanonicalFileName: this.toCanonicalFileName, log: (s) => this.logger.info(s), getSourceFileLike: (f) => this.getSourceFileLike(f, projectName, declarationInfo) },
	            declarationInfo.fileName,
	            declarationInfo.textStorage.getLineInfo(),
	            readMapFile
	          );
	          readMapFile = void 0;
	          if (sourceMapFileInfo) {
	            declarationInfo.sourceMapFilePath = sourceMapFileInfo.path;
	            sourceMapFileInfo.declarationInfoPath = declarationInfo.path;
	            sourceMapFileInfo.documentPositionMapper = documentPositionMapper || false;
	            sourceMapFileInfo.sourceInfos = this.addSourceInfoToSourceMap(sourceFileName, project, sourceMapFileInfo.sourceInfos);
	          } else if (mapFileNameFromDeclarationInfo) {
	            declarationInfo.sourceMapFilePath = {
	              watcher: this.addMissingSourceMapFile(
	                project.currentDirectory === this.currentDirectory ? mapFileNameFromDeclarationInfo : getNormalizedAbsolutePath(mapFileNameFromDeclarationInfo, project.currentDirectory),
	                declarationInfo.path
	              ),
	              sourceInfos: this.addSourceInfoToSourceMap(sourceFileName, project)
	            };
	          } else {
	            declarationInfo.sourceMapFilePath = false;
	          }
	          return documentPositionMapper;
	        }
	        addSourceInfoToSourceMap(sourceFileName, project, sourceInfos) {
	          if (sourceFileName) {
	            const sourceInfo = this.getOrCreateScriptInfoNotOpenedByClient(sourceFileName, project.currentDirectory, project.directoryStructureHost);
	            (sourceInfos || (sourceInfos = /* @__PURE__ */ new Set())).add(sourceInfo.path);
	          }
	          return sourceInfos;
	        }
	        addMissingSourceMapFile(mapFileName, declarationInfoPath) {
	          const fileWatcher = this.watchFactory.watchFile(
	            mapFileName,
	            () => {
	              const declarationInfo = this.getScriptInfoForPath(declarationInfoPath);
	              if (declarationInfo && declarationInfo.sourceMapFilePath && !isString(declarationInfo.sourceMapFilePath)) {
	                this.delayUpdateProjectGraphs(
	                  declarationInfo.containingProjects,
	                  /*clearSourceMapperCache*/
	                  true
	                );
	                this.delayUpdateSourceInfoProjects(declarationInfo.sourceMapFilePath.sourceInfos);
	                declarationInfo.closeSourceMapFileWatcher();
	              }
	            },
	            2e3 /* High */,
	            this.hostConfiguration.watchOptions,
	            WatchType.MissingSourceMapFile
	          );
	          return fileWatcher;
	        }
	        /** @internal */
	        getSourceFileLike(fileName, projectNameOrProject, declarationInfo) {
	          const project = projectNameOrProject.projectName ? projectNameOrProject : this.findProject(projectNameOrProject);
	          if (project) {
	            const path = project.toPath(fileName);
	            const sourceFile = project.getSourceFile(path);
	            if (sourceFile && sourceFile.resolvedPath === path)
	              return sourceFile;
	          }
	          const info = this.getOrCreateScriptInfoNotOpenedByClient(fileName, (project || this).currentDirectory, project ? project.directoryStructureHost : this.host);
	          if (!info)
	            return void 0;
	          if (declarationInfo && isString(declarationInfo.sourceMapFilePath) && info !== declarationInfo) {
	            const sourceMapInfo = this.getScriptInfoForPath(declarationInfo.sourceMapFilePath);
	            if (sourceMapInfo) {
	              (sourceMapInfo.sourceInfos || (sourceMapInfo.sourceInfos = /* @__PURE__ */ new Set())).add(info.path);
	            }
	          }
	          if (info.cacheSourceFile)
	            return info.cacheSourceFile.sourceFile;
	          if (!info.sourceFileLike) {
	            info.sourceFileLike = {
	              get text() {
	                Debug.fail("shouldnt need text");
	                return "";
	              },
	              getLineAndCharacterOfPosition: (pos) => {
	                const lineOffset = info.positionToLineOffset(pos);
	                return { line: lineOffset.line - 1, character: lineOffset.offset - 1 };
	              },
	              getPositionOfLineAndCharacter: (line, character, allowEdits) => info.lineOffsetToPosition(line + 1, character + 1, allowEdits)
	            };
	          }
	          return info.sourceFileLike;
	        }
	        /** @internal */
	        setPerformanceEventHandler(performanceEventHandler) {
	          this.performanceEventHandler = performanceEventHandler;
	        }
	        setHostConfiguration(args) {
	          var _a;
	          if (args.file) {
	            const info = this.getScriptInfoForNormalizedPath(toNormalizedPath(args.file));
	            if (info) {
	              info.setOptions(convertFormatOptions(args.formatOptions), args.preferences);
	              this.logger.info(`Host configuration update for file ${args.file}`);
	            }
	          } else {
	            if (args.hostInfo !== void 0) {
	              this.hostConfiguration.hostInfo = args.hostInfo;
	              this.logger.info(`Host information ${args.hostInfo}`);
	            }
	            if (args.formatOptions) {
	              this.hostConfiguration.formatCodeOptions = { ...this.hostConfiguration.formatCodeOptions, ...convertFormatOptions(args.formatOptions) };
	              this.logger.info("Format host information updated");
	            }
	            if (args.preferences) {
	              const {
	                lazyConfiguredProjectsFromExternalProject,
	                includePackageJsonAutoImports
	              } = this.hostConfiguration.preferences;
	              this.hostConfiguration.preferences = { ...this.hostConfiguration.preferences, ...args.preferences };
	              if (lazyConfiguredProjectsFromExternalProject && !this.hostConfiguration.preferences.lazyConfiguredProjectsFromExternalProject) {
	                this.externalProjectToConfiguredProjectMap.forEach(
	                  (projects) => projects.forEach((project) => {
	                    if (!project.isClosed() && project.hasExternalProjectRef() && project.pendingUpdateLevel === 2 /* Full */ && !this.pendingProjectUpdates.has(project.getProjectName())) {
	                      project.updateGraph();
	                    }
	                  })
	                );
	              }
	              if (includePackageJsonAutoImports !== args.preferences.includePackageJsonAutoImports) {
	                this.forEachProject((project) => {
	                  project.onAutoImportProviderSettingsChanged();
	                });
	              }
	            }
	            if (args.extraFileExtensions) {
	              this.hostConfiguration.extraFileExtensions = args.extraFileExtensions;
	              this.reloadProjects();
	              this.logger.info("Host file extension mappings updated");
	            }
	            if (args.watchOptions) {
	              this.hostConfiguration.watchOptions = (_a = convertWatchOptions(args.watchOptions)) == null ? void 0 : _a.watchOptions;
	              this.logger.info(`Host watch options changed to ${JSON.stringify(this.hostConfiguration.watchOptions)}, it will be take effect for next watches.`);
	            }
	          }
	        }
	        /** @internal */
	        getWatchOptions(project) {
	          return this.getWatchOptionsFromProjectWatchOptions(project.getWatchOptions());
	        }
	        /** @internal */
	        getWatchOptionsFromProjectWatchOptions(projectOptions) {
	          return projectOptions && this.hostConfiguration.watchOptions ? { ...this.hostConfiguration.watchOptions, ...projectOptions } : projectOptions || this.hostConfiguration.watchOptions;
	        }
	        closeLog() {
	          this.logger.close();
	        }
	        /**
	         * This function rebuilds the project for every file opened by the client
	         * This does not reload contents of open files from disk. But we could do that if needed
	         */
	        reloadProjects() {
	          this.logger.info("reload projects.");
	          this.filenameToScriptInfo.forEach((info) => {
	            if (this.openFiles.has(info.path))
	              return;
	            if (!info.fileWatcher)
	              return;
	            this.onSourceFileChanged(info, this.host.fileExists(info.fileName) ? 1 /* Changed */ : 2 /* Deleted */);
	          });
	          this.pendingProjectUpdates.forEach((_project, projectName) => {
	            this.throttledOperations.cancel(projectName);
	            this.pendingProjectUpdates.delete(projectName);
	          });
	          this.throttledOperations.cancel(ensureProjectForOpenFileSchedule);
	          this.pendingEnsureProjectForOpenFiles = false;
	          this.configFileExistenceInfoCache.forEach((info) => {
	            if (info.config)
	              info.config.updateLevel = 2 /* Full */;
	          });
	          this.reloadConfiguredProjectForFiles(
	            this.openFiles,
	            /*clearSemanticCache*/
	            true,
	            /*delayReload*/
	            false,
	            returnTrue,
	            "User requested reload projects"
	          );
	          this.externalProjects.forEach((project) => {
	            this.clearSemanticCache(project);
	            project.updateGraph();
	          });
	          this.inferredProjects.forEach((project) => this.clearSemanticCache(project));
	          this.ensureProjectForOpenFiles();
	          this.logger.info("After reloading projects..");
	          this.printProjects();
	        }
	        /**
	         * This function goes through all the openFiles and tries to file the config file for them.
	         * If the config file is found and it refers to existing project, it reloads it either immediately
	         * or schedules it for reload depending on delayReload option
	         * If there is no existing project it just opens the configured project for the config file
	         * reloadForInfo provides a way to filter out files to reload configured project for
	         */
	        reloadConfiguredProjectForFiles(openFiles, clearSemanticCache, delayReload, shouldReloadProjectFor, reason) {
	          const updatedProjects = /* @__PURE__ */ new Map();
	          const reloadChildProject = (child) => {
	            if (!updatedProjects.has(child.canonicalConfigFilePath)) {
	              updatedProjects.set(child.canonicalConfigFilePath, true);
	              this.reloadConfiguredProject(
	                child,
	                reason,
	                /*isInitialLoad*/
	                false,
	                clearSemanticCache
	              );
	            }
	          };
	          openFiles == null ? void 0 : openFiles.forEach((openFileValue, path) => {
	            this.configFileForOpenFiles.delete(path);
	            if (!shouldReloadProjectFor(openFileValue)) {
	              return;
	            }
	            const info = this.getScriptInfoForPath(path);
	            Debug.assert(info.isScriptOpen());
	            const configFileName = this.getConfigFileNameForFile(info);
	            if (configFileName) {
	              const project = this.findConfiguredProjectByProjectName(configFileName) || this.createConfiguredProject(configFileName);
	              if (!updatedProjects.has(project.canonicalConfigFilePath)) {
	                updatedProjects.set(project.canonicalConfigFilePath, true);
	                if (delayReload) {
	                  project.pendingUpdateLevel = 2 /* Full */;
	                  project.pendingUpdateReason = reason;
	                  if (clearSemanticCache)
	                    this.clearSemanticCache(project);
	                  this.delayUpdateProjectGraph(project);
	                } else {
	                  this.reloadConfiguredProject(
	                    project,
	                    reason,
	                    /*isInitialLoad*/
	                    false,
	                    clearSemanticCache
	                  );
	                  if (!projectContainsInfoDirectly(project, info)) {
	                    const referencedProject = forEachResolvedProjectReferenceProject(
	                      project,
	                      info.path,
	                      (child) => {
	                        reloadChildProject(child);
	                        return projectContainsInfoDirectly(child, info);
	                      },
	                      1 /* FindCreate */
	                    );
	                    if (referencedProject) {
	                      forEachResolvedProjectReferenceProject(
	                        project,
	                        /*fileName*/
	                        void 0,
	                        reloadChildProject,
	                        0 /* Find */
	                      );
	                    }
	                  }
	                }
	              }
	            }
	          });
	        }
	        /**
	         * Remove the root of inferred project if script info is part of another project
	         */
	        removeRootOfInferredProjectIfNowPartOfOtherProject(info) {
	          Debug.assert(info.containingProjects.length > 0);
	          const firstProject = info.containingProjects[0];
	          if (!firstProject.isOrphan() && isInferredProject(firstProject) && firstProject.isRoot(info) && forEach(info.containingProjects, (p) => p !== firstProject && !p.isOrphan())) {
	            firstProject.removeFile(
	              info,
	              /*fileExists*/
	              true,
	              /*detachFromProject*/
	              true
	            );
	          }
	        }
	        /**
	         * This function is to update the project structure for every inferred project.
	         * It is called on the premise that all the configured projects are
	         * up to date.
	         * This will go through open files and assign them to inferred project if open file is not part of any other project
	         * After that all the inferred project graphs are updated
	         */
	        ensureProjectForOpenFiles() {
	          this.logger.info("Before ensureProjectForOpenFiles:");
	          this.printProjects();
	          this.openFiles.forEach((projectRootPath, path) => {
	            const info = this.getScriptInfoForPath(path);
	            if (info.isOrphan()) {
	              this.assignOrphanScriptInfoToInferredProject(info, projectRootPath);
	            } else {
	              this.removeRootOfInferredProjectIfNowPartOfOtherProject(info);
	            }
	          });
	          this.pendingEnsureProjectForOpenFiles = false;
	          this.inferredProjects.forEach(updateProjectIfDirty);
	          this.logger.info("After ensureProjectForOpenFiles:");
	          this.printProjects();
	        }
	        /**
	         * Open file whose contents is managed by the client
	         * @param filename is absolute pathname
	         * @param fileContent is a known version of the file content that is more up to date than the one on disk
	         */
	        openClientFile(fileName, fileContent, scriptKind, projectRootPath) {
	          return this.openClientFileWithNormalizedPath(
	            toNormalizedPath(fileName),
	            fileContent,
	            scriptKind,
	            /*hasMixedContent*/
	            false,
	            projectRootPath ? toNormalizedPath(projectRootPath) : void 0
	          );
	        }
	        /** @internal */
	        getOriginalLocationEnsuringConfiguredProject(project, location) {
	          const isSourceOfProjectReferenceRedirect = project.isSourceOfProjectReferenceRedirect(location.fileName);
	          const originalLocation = isSourceOfProjectReferenceRedirect ? location : project.getSourceMapper().tryGetSourcePosition(location);
	          if (!originalLocation)
	            return void 0;
	          const { fileName } = originalLocation;
	          const scriptInfo = this.getScriptInfo(fileName);
	          if (!scriptInfo && !this.host.fileExists(fileName))
	            return void 0;
	          const originalFileInfo = { fileName: toNormalizedPath(fileName), path: this.toPath(fileName) };
	          const configFileName = this.getConfigFileNameForFile(originalFileInfo);
	          if (!configFileName)
	            return void 0;
	          let configuredProject = this.findConfiguredProjectByProjectName(configFileName);
	          if (!configuredProject) {
	            if (project.getCompilerOptions().disableReferencedProjectLoad) {
	              if (isSourceOfProjectReferenceRedirect) {
	                return location;
	              }
	              return (scriptInfo == null ? void 0 : scriptInfo.containingProjects.length) ? originalLocation : location;
	            }
	            configuredProject = this.createAndLoadConfiguredProject(configFileName, `Creating project for original file: ${originalFileInfo.fileName}${location !== originalLocation ? " for location: " + location.fileName : ""}`);
	          }
	          updateProjectIfDirty(configuredProject);
	          const projectContainsOriginalInfo = (project2) => {
	            const info = this.getScriptInfo(fileName);
	            return info && projectContainsInfoDirectly(project2, info);
	          };
	          if (configuredProject.isSolution() || !projectContainsOriginalInfo(configuredProject)) {
	            configuredProject = forEachResolvedProjectReferenceProject(
	              configuredProject,
	              fileName,
	              (child) => {
	                updateProjectIfDirty(child);
	                return projectContainsOriginalInfo(child) ? child : void 0;
	              },
	              2 /* FindCreateLoad */,
	              `Creating project referenced in solution ${configuredProject.projectName} to find possible configured project for original file: ${originalFileInfo.fileName}${location !== originalLocation ? " for location: " + location.fileName : ""}`
	            );
	            if (!configuredProject)
	              return void 0;
	            if (configuredProject === project)
	              return originalLocation;
	          }
	          addOriginalConfiguredProject(configuredProject);
	          const originalScriptInfo = this.getScriptInfo(fileName);
	          if (!originalScriptInfo || !originalScriptInfo.containingProjects.length)
	            return void 0;
	          originalScriptInfo.containingProjects.forEach((project2) => {
	            if (isConfiguredProject(project2)) {
	              addOriginalConfiguredProject(project2);
	            }
	          });
	          return originalLocation;
	          function addOriginalConfiguredProject(originalProject) {
	            if (!project.originalConfiguredProjects) {
	              project.originalConfiguredProjects = /* @__PURE__ */ new Set();
	            }
	            project.originalConfiguredProjects.add(originalProject.canonicalConfigFilePath);
	          }
	        }
	        /** @internal */
	        fileExists(fileName) {
	          return !!this.getScriptInfoForNormalizedPath(fileName) || this.host.fileExists(fileName);
	        }
	        findExternalProjectContainingOpenScriptInfo(info) {
	          return find(this.externalProjects, (proj) => {
	            updateProjectIfDirty(proj);
	            return proj.containsScriptInfo(info);
	          });
	        }
	        getOrCreateOpenScriptInfo(fileName, fileContent, scriptKind, hasMixedContent, projectRootPath) {
	          const info = this.getOrCreateScriptInfoOpenedByClientForNormalizedPath(fileName, projectRootPath ? this.getNormalizedAbsolutePath(projectRootPath) : this.currentDirectory, fileContent, scriptKind, hasMixedContent);
	          this.openFiles.set(info.path, projectRootPath);
	          return info;
	        }
	        assignProjectToOpenedScriptInfo(info) {
	          let configFileName;
	          let configFileErrors;
	          let project = this.findExternalProjectContainingOpenScriptInfo(info);
	          let retainProjects;
	          let projectForConfigFileDiag;
	          let defaultConfigProjectIsCreated = false;
	          if (!project && this.serverMode === 0 /* Semantic */) {
	            configFileName = this.getConfigFileNameForFile(info);
	            if (configFileName) {
	              project = this.findConfiguredProjectByProjectName(configFileName);
	              if (!project) {
	                project = this.createLoadAndUpdateConfiguredProject(configFileName, `Creating possible configured project for ${info.fileName} to open`);
	                defaultConfigProjectIsCreated = true;
	              } else {
	                updateProjectIfDirty(project);
	              }
	              projectForConfigFileDiag = project.containsScriptInfo(info) ? project : void 0;
	              retainProjects = project;
	              if (!projectContainsInfoDirectly(project, info)) {
	                forEachResolvedProjectReferenceProject(
	                  project,
	                  info.path,
	                  (child) => {
	                    updateProjectIfDirty(child);
	                    if (!isArray(retainProjects)) {
	                      retainProjects = [project, child];
	                    } else {
	                      retainProjects.push(child);
	                    }
	                    if (projectContainsInfoDirectly(child, info)) {
	                      projectForConfigFileDiag = child;
	                      return child;
	                    }
	                    if (!projectForConfigFileDiag && child.containsScriptInfo(info)) {
	                      projectForConfigFileDiag = child;
	                    }
	                  },
	                  2 /* FindCreateLoad */,
	                  `Creating project referenced in solution ${project.projectName} to find possible configured project for ${info.fileName} to open`
	                );
	              }
	              if (projectForConfigFileDiag) {
	                configFileName = projectForConfigFileDiag.getConfigFilePath();
	                if (projectForConfigFileDiag !== project || defaultConfigProjectIsCreated) {
	                  configFileErrors = projectForConfigFileDiag.getAllProjectErrors();
	                  this.sendConfigFileDiagEvent(projectForConfigFileDiag, info.fileName);
	                }
	              } else {
	                configFileName = void 0;
	              }
	              this.createAncestorProjects(info, project);
	            }
	          }
	          info.containingProjects.forEach(updateProjectIfDirty);
	          if (info.isOrphan()) {
	            if (isArray(retainProjects)) {
	              retainProjects.forEach((project2) => this.sendConfigFileDiagEvent(project2, info.fileName));
	            } else if (retainProjects) {
	              this.sendConfigFileDiagEvent(retainProjects, info.fileName);
	            }
	            Debug.assert(this.openFiles.has(info.path));
	            this.assignOrphanScriptInfoToInferredProject(info, this.openFiles.get(info.path));
	          }
	          Debug.assert(!info.isOrphan());
	          return { configFileName, configFileErrors, retainProjects };
	        }
	        createAncestorProjects(info, project) {
	          if (!info.isAttached(project))
	            return;
	          while (true) {
	            if (!project.isInitialLoadPending() && (!project.getCompilerOptions().composite || project.getCompilerOptions().disableSolutionSearching))
	              return;
	            const configFileName = this.getConfigFileNameForFile({
	              fileName: project.getConfigFilePath(),
	              path: info.path,
	              configFileInfo: true
	            });
	            if (!configFileName)
	              return;
	            const ancestor = this.findConfiguredProjectByProjectName(configFileName) || this.createConfiguredProjectWithDelayLoad(configFileName, `Creating project possibly referencing default composite project ${project.getProjectName()} of open file ${info.fileName}`);
	            if (ancestor.isInitialLoadPending()) {
	              ancestor.setPotentialProjectReference(project.canonicalConfigFilePath);
	            }
	            project = ancestor;
	          }
	        }
	        /** @internal */
	        loadAncestorProjectTree(forProjects) {
	          forProjects = forProjects || mapDefinedEntries(
	            this.configuredProjects,
	            (key, project) => !project.isInitialLoadPending() ? [key, true] : void 0
	          );
	          const seenProjects = /* @__PURE__ */ new Set();
	          for (const project of arrayFrom(this.configuredProjects.values())) {
	            if (forEachPotentialProjectReference(project, (potentialRefPath) => forProjects.has(potentialRefPath))) {
	              updateProjectIfDirty(project);
	            }
	            this.ensureProjectChildren(project, forProjects, seenProjects);
	          }
	        }
	        ensureProjectChildren(project, forProjects, seenProjects) {
	          var _a;
	          if (!tryAddToSet(seenProjects, project.canonicalConfigFilePath))
	            return;
	          if (project.getCompilerOptions().disableReferencedProjectLoad)
	            return;
	          const children = (_a = project.getCurrentProgram()) == null ? void 0 : _a.getResolvedProjectReferences();
	          if (!children)
	            return;
	          for (const child of children) {
	            if (!child)
	              continue;
	            const referencedProject = forEachResolvedProjectReference(child.references, (ref) => forProjects.has(ref.sourceFile.path) ? ref : void 0);
	            if (!referencedProject)
	              continue;
	            const configFileName = toNormalizedPath(child.sourceFile.fileName);
	            const childProject = project.projectService.findConfiguredProjectByProjectName(configFileName) || project.projectService.createAndLoadConfiguredProject(configFileName, `Creating project referenced by : ${project.projectName} as it references project ${referencedProject.sourceFile.fileName}`);
	            updateProjectIfDirty(childProject);
	            this.ensureProjectChildren(childProject, forProjects, seenProjects);
	          }
	        }
	        cleanupAfterOpeningFile(toRetainConfigProjects) {
	          this.removeOrphanConfiguredProjects(toRetainConfigProjects);
	          for (const inferredProject of this.inferredProjects.slice()) {
	            if (inferredProject.isOrphan()) {
	              this.removeProject(inferredProject);
	            }
	          }
	          this.removeOrphanScriptInfos();
	        }
	        openClientFileWithNormalizedPath(fileName, fileContent, scriptKind, hasMixedContent, projectRootPath) {
	          const info = this.getOrCreateOpenScriptInfo(fileName, fileContent, scriptKind, hasMixedContent, projectRootPath);
	          const { retainProjects, ...result } = this.assignProjectToOpenedScriptInfo(info);
	          this.cleanupAfterOpeningFile(retainProjects);
	          this.telemetryOnOpenFile(info);
	          this.printProjects();
	          return result;
	        }
	        removeOrphanConfiguredProjects(toRetainConfiguredProjects) {
	          const toRemoveConfiguredProjects = new Map(this.configuredProjects);
	          const markOriginalProjectsAsUsed = (project) => {
	            if (!project.isOrphan() && project.originalConfiguredProjects) {
	              project.originalConfiguredProjects.forEach(
	                (_value, configuredProjectPath) => {
	                  const project2 = this.getConfiguredProjectByCanonicalConfigFilePath(configuredProjectPath);
	                  return project2 && retainConfiguredProject(project2);
	                }
	              );
	            }
	          };
	          if (toRetainConfiguredProjects) {
	            if (isArray(toRetainConfiguredProjects)) {
	              toRetainConfiguredProjects.forEach(retainConfiguredProject);
	            } else {
	              retainConfiguredProject(toRetainConfiguredProjects);
	            }
	          }
	          this.inferredProjects.forEach(markOriginalProjectsAsUsed);
	          this.externalProjects.forEach(markOriginalProjectsAsUsed);
	          this.configuredProjects.forEach((project) => {
	            if (project.hasOpenRef()) {
	              retainConfiguredProject(project);
	            } else if (toRemoveConfiguredProjects.has(project.canonicalConfigFilePath)) {
	              forEachReferencedProject(
	                project,
	                (ref) => isRetained(ref) && retainConfiguredProject(project)
	              );
	            }
	          });
	          toRemoveConfiguredProjects.forEach((project) => this.removeProject(project));
	          function isRetained(project) {
	            return project.hasOpenRef() || !toRemoveConfiguredProjects.has(project.canonicalConfigFilePath);
	          }
	          function retainConfiguredProject(project) {
	            if (toRemoveConfiguredProjects.delete(project.canonicalConfigFilePath)) {
	              markOriginalProjectsAsUsed(project);
	              forEachReferencedProject(project, retainConfiguredProject);
	            }
	          }
	        }
	        removeOrphanScriptInfos() {
	          const toRemoveScriptInfos = new Map(this.filenameToScriptInfo);
	          this.filenameToScriptInfo.forEach((info) => {
	            if (!info.isScriptOpen() && info.isOrphan() && !info.isContainedByBackgroundProject()) {
	              if (!info.sourceMapFilePath)
	                return;
	              let sourceInfos;
	              if (isString(info.sourceMapFilePath)) {
	                const sourceMapInfo = this.getScriptInfoForPath(info.sourceMapFilePath);
	                sourceInfos = sourceMapInfo && sourceMapInfo.sourceInfos;
	              } else {
	                sourceInfos = info.sourceMapFilePath.sourceInfos;
	              }
	              if (!sourceInfos)
	                return;
	              if (!forEachKey(sourceInfos, (path) => {
	                const info2 = this.getScriptInfoForPath(path);
	                return !!info2 && (info2.isScriptOpen() || !info2.isOrphan());
	              })) {
	                return;
	              }
	            }
	            toRemoveScriptInfos.delete(info.path);
	            if (info.sourceMapFilePath) {
	              let sourceInfos;
	              if (isString(info.sourceMapFilePath)) {
	                toRemoveScriptInfos.delete(info.sourceMapFilePath);
	                const sourceMapInfo = this.getScriptInfoForPath(info.sourceMapFilePath);
	                sourceInfos = sourceMapInfo && sourceMapInfo.sourceInfos;
	              } else {
	                sourceInfos = info.sourceMapFilePath.sourceInfos;
	              }
	              if (sourceInfos) {
	                sourceInfos.forEach((_value, path) => toRemoveScriptInfos.delete(path));
	              }
	            }
	          });
	          toRemoveScriptInfos.forEach((info) => {
	            this.stopWatchingScriptInfo(info);
	            this.deleteScriptInfo(info);
	            info.closeSourceMapFileWatcher();
	          });
	        }
	        telemetryOnOpenFile(scriptInfo) {
	          if (this.serverMode !== 0 /* Semantic */ || !this.eventHandler || !scriptInfo.isJavaScript() || !addToSeen(this.allJsFilesForOpenFileTelemetry, scriptInfo.path)) {
	            return;
	          }
	          const project = this.ensureDefaultProjectForFile(scriptInfo);
	          if (!project.languageServiceEnabled) {
	            return;
	          }
	          const sourceFile = project.getSourceFile(scriptInfo.path);
	          const checkJs = !!sourceFile && !!sourceFile.checkJsDirective;
	          this.eventHandler({ eventName: OpenFileInfoTelemetryEvent, data: { info: { checkJs } } });
	        }
	        closeClientFile(uncheckedFileName, skipAssignOrphanScriptInfosToInferredProject) {
	          const info = this.getScriptInfoForNormalizedPath(toNormalizedPath(uncheckedFileName));
	          const result = info ? this.closeOpenFile(info, skipAssignOrphanScriptInfosToInferredProject) : false;
	          if (!skipAssignOrphanScriptInfosToInferredProject) {
	            this.printProjects();
	          }
	          return result;
	        }
	        collectChanges(lastKnownProjectVersions, currentProjects, includeProjectReferenceRedirectInfo, result) {
	          for (const proj of currentProjects) {
	            const knownProject = find(lastKnownProjectVersions, (p) => p.projectName === proj.getProjectName());
	            result.push(proj.getChangesSinceVersion(knownProject && knownProject.version, includeProjectReferenceRedirectInfo));
	          }
	        }
	        /** @internal */
	        synchronizeProjectList(knownProjects, includeProjectReferenceRedirectInfo) {
	          const files = [];
	          this.collectChanges(knownProjects, this.externalProjects, includeProjectReferenceRedirectInfo, files);
	          this.collectChanges(knownProjects, this.configuredProjects.values(), includeProjectReferenceRedirectInfo, files);
	          this.collectChanges(knownProjects, this.inferredProjects, includeProjectReferenceRedirectInfo, files);
	          return files;
	        }
	        /** @internal */
	        applyChangesInOpenFiles(openFiles, changedFiles, closedFiles) {
	          let openScriptInfos;
	          let assignOrphanScriptInfosToInferredProject = false;
	          if (openFiles) {
	            for (const file of openFiles) {
	              const info = this.getOrCreateOpenScriptInfo(
	                toNormalizedPath(file.fileName),
	                file.content,
	                tryConvertScriptKindName(file.scriptKind),
	                file.hasMixedContent,
	                file.projectRootPath ? toNormalizedPath(file.projectRootPath) : void 0
	              );
	              (openScriptInfos || (openScriptInfos = [])).push(info);
	            }
	          }
	          if (changedFiles) {
	            for (const file of changedFiles) {
	              const scriptInfo = this.getScriptInfo(file.fileName);
	              Debug.assert(!!scriptInfo);
	              this.applyChangesToFile(scriptInfo, file.changes);
	            }
	          }
	          if (closedFiles) {
	            for (const file of closedFiles) {
	              assignOrphanScriptInfosToInferredProject = this.closeClientFile(
	                file,
	                /*skipAssignOrphanScriptInfosToInferredProject*/
	                true
	              ) || assignOrphanScriptInfosToInferredProject;
	            }
	          }
	          let retainProjects;
	          if (openScriptInfos) {
	            retainProjects = flatMap(openScriptInfos, (info) => this.assignProjectToOpenedScriptInfo(info).retainProjects);
	          }
	          if (assignOrphanScriptInfosToInferredProject) {
	            this.assignOrphanScriptInfosToInferredProject();
	          }
	          if (openScriptInfos) {
	            this.cleanupAfterOpeningFile(retainProjects);
	            openScriptInfos.forEach((info) => this.telemetryOnOpenFile(info));
	            this.printProjects();
	          } else if (length(closedFiles)) {
	            this.printProjects();
	          }
	        }
	        /** @internal */
	        applyChangesToFile(scriptInfo, changes) {
	          for (const change of changes) {
	            scriptInfo.editContent(change.span.start, change.span.start + change.span.length, change.newText);
	          }
	        }
	        closeConfiguredProjectReferencedFromExternalProject(configuredProjects) {
	          configuredProjects == null ? void 0 : configuredProjects.forEach((configuredProject) => {
	            if (!configuredProject.isClosed()) {
	              configuredProject.deleteExternalProjectReference();
	              if (!configuredProject.hasOpenRef())
	                this.removeProject(configuredProject);
	            }
	          });
	        }
	        closeExternalProject(uncheckedFileName, print) {
	          const fileName = toNormalizedPath(uncheckedFileName);
	          const configuredProjects = this.externalProjectToConfiguredProjectMap.get(fileName);
	          if (configuredProjects) {
	            this.closeConfiguredProjectReferencedFromExternalProject(configuredProjects);
	            this.externalProjectToConfiguredProjectMap.delete(fileName);
	          } else {
	            const externalProject = this.findExternalProjectByProjectName(uncheckedFileName);
	            if (externalProject) {
	              this.removeProject(externalProject);
	            }
	          }
	          if (print)
	            this.printProjects();
	        }
	        openExternalProjects(projects) {
	          const projectsToClose = arrayToMap(this.externalProjects, (p) => p.getProjectName(), (_) => true);
	          forEachKey(this.externalProjectToConfiguredProjectMap, (externalProjectName) => {
	            projectsToClose.set(externalProjectName, true);
	          });
	          for (const externalProject of projects) {
	            this.openExternalProject(
	              externalProject,
	              /*print*/
	              false
	            );
	            projectsToClose.delete(externalProject.projectFileName);
	          }
	          forEachKey(projectsToClose, (externalProjectName) => {
	            this.closeExternalProject(
	              externalProjectName,
	              /*print*/
	              false
	            );
	          });
	          this.printProjects();
	        }
	        static escapeFilenameForRegex(filename) {
	          return filename.replace(this.filenameEscapeRegexp, "\\$&");
	        }
	        resetSafeList() {
	          this.safelist = defaultTypeSafeList;
	        }
	        applySafeList(proj) {
	          const typeAcquisition = proj.typeAcquisition;
	          Debug.assert(!!typeAcquisition, "proj.typeAcquisition should be set by now");
	          const result = this.applySafeListWorker(proj, proj.rootFiles, typeAcquisition);
	          return (result == null ? void 0 : result.excludedFiles) ?? [];
	        }
	        applySafeListWorker(proj, rootFiles, typeAcquisition) {
	          if (typeAcquisition.enable === false || typeAcquisition.disableFilenameBasedTypeAcquisition) {
	            return void 0;
	          }
	          const typeAcqInclude = typeAcquisition.include || (typeAcquisition.include = []);
	          const excludeRules = [];
	          const normalizedNames = rootFiles.map((f) => normalizeSlashes(f.fileName));
	          for (const name of Object.keys(this.safelist)) {
	            const rule2 = this.safelist[name];
	            for (const root of normalizedNames) {
	              if (rule2.match.test(root)) {
	                this.logger.info(`Excluding files based on rule ${name} matching file '${root}'`);
	                if (rule2.types) {
	                  for (const type of rule2.types) {
	                    if (!typeAcqInclude.includes(type)) {
	                      typeAcqInclude.push(type);
	                    }
	                  }
	                }
	                if (rule2.exclude) {
	                  for (const exclude of rule2.exclude) {
	                    const processedRule = root.replace(rule2.match, (...groups) => {
	                      return exclude.map((groupNumberOrString) => {
	                        if (typeof groupNumberOrString === "number") {
	                          if (!isString(groups[groupNumberOrString])) {
	                            this.logger.info(`Incorrect RegExp specification in safelist rule ${name} - not enough groups`);
	                            return "\\*";
	                          }
	                          return _ProjectService.escapeFilenameForRegex(groups[groupNumberOrString]);
	                        }
	                        return groupNumberOrString;
	                      }).join("");
	                    });
	                    if (!excludeRules.includes(processedRule)) {
	                      excludeRules.push(processedRule);
	                    }
	                  }
	                } else {
	                  const escaped = _ProjectService.escapeFilenameForRegex(root);
	                  if (!excludeRules.includes(escaped)) {
	                    excludeRules.push(escaped);
	                  }
	                }
	              }
	            }
	          }
	          const excludeRegexes = excludeRules.map((e) => new RegExp(e, "i"));
	          let filesToKeep;
	          let excludedFiles;
	          for (let i = 0; i < rootFiles.length; i++) {
	            if (excludeRegexes.some((re) => re.test(normalizedNames[i]))) {
	              addExcludedFile(i);
	            } else {
	              if (typeAcquisition.enable) {
	                const baseName = getBaseFileName(toFileNameLowerCase(normalizedNames[i]));
	                if (fileExtensionIs(baseName, "js")) {
	                  const inferredTypingName = removeFileExtension(baseName);
	                  const cleanedTypingName = removeMinAndVersionNumbers(inferredTypingName);
	                  const typeName = this.legacySafelist.get(cleanedTypingName);
	                  if (typeName !== void 0) {
	                    this.logger.info(`Excluded '${normalizedNames[i]}' because it matched ${cleanedTypingName} from the legacy safelist`);
	                    addExcludedFile(i);
	                    if (!typeAcqInclude.includes(typeName)) {
	                      typeAcqInclude.push(typeName);
	                    }
	                    continue;
	                  }
	                }
	              }
	              if (/^.+[.-]min\.js$/.test(normalizedNames[i])) {
	                addExcludedFile(i);
	              } else {
	                filesToKeep == null ? void 0 : filesToKeep.push(rootFiles[i]);
	              }
	            }
	          }
	          return excludedFiles ? {
	            rootFiles: filesToKeep,
	            excludedFiles
	          } : void 0;
	          function addExcludedFile(index) {
	            if (!excludedFiles) {
	              Debug.assert(!filesToKeep);
	              filesToKeep = rootFiles.slice(0, index);
	              excludedFiles = [];
	            }
	            excludedFiles.push(normalizedNames[index]);
	          }
	        }
	        openExternalProject(proj, print) {
	          const existingExternalProject = this.findExternalProjectByProjectName(proj.projectFileName);
	          const existingConfiguredProjects = this.externalProjectToConfiguredProjectMap.get(proj.projectFileName);
	          let configuredProjects;
	          let rootFiles = [];
	          for (const file of proj.rootFiles) {
	            const normalized = toNormalizedPath(file.fileName);
	            if (getBaseConfigFileName(normalized)) {
	              if (this.serverMode === 0 /* Semantic */ && this.host.fileExists(normalized)) {
	                let project = this.findConfiguredProjectByProjectName(normalized);
	                if (!project) {
	                  project = this.getHostPreferences().lazyConfiguredProjectsFromExternalProject ? this.createConfiguredProjectWithDelayLoad(normalized, `Creating configured project in external project: ${proj.projectFileName}`) : this.createLoadAndUpdateConfiguredProject(normalized, `Creating configured project in external project: ${proj.projectFileName}`);
	                }
	                if (!(existingConfiguredProjects == null ? void 0 : existingConfiguredProjects.has(project))) {
	                  project.addExternalProjectReference();
	                }
	                (configuredProjects ?? (configuredProjects = /* @__PURE__ */ new Set())).add(project);
	                existingConfiguredProjects == null ? void 0 : existingConfiguredProjects.delete(project);
	              }
	            } else {
	              rootFiles.push(file);
	            }
	          }
	          if (configuredProjects) {
	            this.externalProjectToConfiguredProjectMap.set(proj.projectFileName, configuredProjects);
	            if (existingExternalProject)
	              this.removeProject(existingExternalProject);
	          } else {
	            this.externalProjectToConfiguredProjectMap.delete(proj.projectFileName);
	            const typeAcquisition = proj.typeAcquisition || {};
	            typeAcquisition.include = typeAcquisition.include || [];
	            typeAcquisition.exclude = typeAcquisition.exclude || [];
	            if (typeAcquisition.enable === void 0) {
	              typeAcquisition.enable = hasNoTypeScriptSource(rootFiles.map((f) => f.fileName));
	            }
	            const excludeResult = this.applySafeListWorker(proj, rootFiles, typeAcquisition);
	            const excludedFiles = (excludeResult == null ? void 0 : excludeResult.excludedFiles) ?? [];
	            rootFiles = (excludeResult == null ? void 0 : excludeResult.rootFiles) ?? rootFiles;
	            if (existingExternalProject) {
	              existingExternalProject.excludedFiles = excludedFiles;
	              const compilerOptions = convertCompilerOptions(proj.options);
	              const watchOptionsAndErrors = convertWatchOptions(proj.options, existingExternalProject.getCurrentDirectory());
	              const lastFileExceededProgramSize = this.getFilenameForExceededTotalSizeLimitForNonTsFiles(proj.projectFileName, compilerOptions, rootFiles, externalFilePropertyReader);
	              if (lastFileExceededProgramSize) {
	                existingExternalProject.disableLanguageService(lastFileExceededProgramSize);
	              } else {
	                existingExternalProject.enableLanguageService();
	              }
	              existingExternalProject.setProjectErrors(watchOptionsAndErrors == null ? void 0 : watchOptionsAndErrors.errors);
	              this.updateRootAndOptionsOfNonInferredProject(existingExternalProject, rootFiles, externalFilePropertyReader, compilerOptions, typeAcquisition, proj.options.compileOnSave, watchOptionsAndErrors == null ? void 0 : watchOptionsAndErrors.watchOptions);
	              existingExternalProject.updateGraph();
	            } else {
	              const project = this.createExternalProject(proj.projectFileName, rootFiles, proj.options, typeAcquisition, excludedFiles);
	              project.updateGraph();
	            }
	          }
	          this.closeConfiguredProjectReferencedFromExternalProject(existingConfiguredProjects);
	          if (print)
	            this.printProjects();
	        }
	        hasDeferredExtension() {
	          for (const extension of this.hostConfiguration.extraFileExtensions) {
	            if (extension.scriptKind === 7 /* Deferred */) {
	              return true;
	            }
	          }
	          return false;
	        }
	        /**
	         * Performs the initial steps of enabling a plugin by finding and instantiating the module for a plugin either asynchronously or synchronously
	         * @internal
	         */
	        requestEnablePlugin(project, pluginConfigEntry, searchPaths) {
	          if (!this.host.importPlugin && !this.host.require) {
	            this.logger.info("Plugins were requested but not running in environment that supports 'require'. Nothing will be loaded");
	            return;
	          }
	          this.logger.info(`Enabling plugin ${pluginConfigEntry.name} from candidate paths: ${searchPaths.join(",")}`);
	          if (!pluginConfigEntry.name || parsePackageName(pluginConfigEntry.name).rest) {
	            this.logger.info(`Skipped loading plugin ${pluginConfigEntry.name || JSON.stringify(pluginConfigEntry)} because only package name is allowed plugin name`);
	            return;
	          }
	          if (this.host.importPlugin) {
	            const importPromise = Project3.importServicePluginAsync(
	              pluginConfigEntry,
	              searchPaths,
	              this.host,
	              (s) => this.logger.info(s)
	            );
	            this.pendingPluginEnablements ?? (this.pendingPluginEnablements = /* @__PURE__ */ new Map());
	            let promises = this.pendingPluginEnablements.get(project);
	            if (!promises)
	              this.pendingPluginEnablements.set(project, promises = []);
	            promises.push(importPromise);
	            return;
	          }
	          this.endEnablePlugin(
	            project,
	            Project3.importServicePluginSync(
	              pluginConfigEntry,
	              searchPaths,
	              this.host,
	              (s) => this.logger.info(s)
	            )
	          );
	        }
	        /**
	         * Performs the remaining steps of enabling a plugin after its module has been instantiated.
	         * @internal
	         */
	        endEnablePlugin(project, { pluginConfigEntry, resolvedModule, errorLogs }) {
	          var _a;
	          if (resolvedModule) {
	            const configurationOverride = (_a = this.currentPluginConfigOverrides) == null ? void 0 : _a.get(pluginConfigEntry.name);
	            if (configurationOverride) {
	              const pluginName = pluginConfigEntry.name;
	              pluginConfigEntry = configurationOverride;
	              pluginConfigEntry.name = pluginName;
	            }
	            project.enableProxy(resolvedModule, pluginConfigEntry);
	          } else {
	            forEach(errorLogs, (message) => this.logger.info(message));
	            this.logger.info(`Couldn't find ${pluginConfigEntry.name}`);
	          }
	        }
	        /** @internal */
	        hasNewPluginEnablementRequests() {
	          return !!this.pendingPluginEnablements;
	        }
	        /** @internal */
	        hasPendingPluginEnablements() {
	          return !!this.currentPluginEnablementPromise;
	        }
	        /**
	         * Waits for any ongoing plugin enablement requests to complete.
	         *
	         * @internal
	         */
	        async waitForPendingPlugins() {
	          while (this.currentPluginEnablementPromise) {
	            await this.currentPluginEnablementPromise;
	          }
	        }
	        /**
	         * Starts enabling any requested plugins without waiting for the result.
	         *
	         * @internal
	         */
	        enableRequestedPlugins() {
	          if (this.pendingPluginEnablements) {
	            void this.enableRequestedPluginsAsync();
	          }
	        }
	        async enableRequestedPluginsAsync() {
	          if (this.currentPluginEnablementPromise) {
	            await this.waitForPendingPlugins();
	          }
	          if (!this.pendingPluginEnablements) {
	            return;
	          }
	          const entries = arrayFrom(this.pendingPluginEnablements.entries());
	          this.pendingPluginEnablements = void 0;
	          this.currentPluginEnablementPromise = this.enableRequestedPluginsWorker(entries);
	          await this.currentPluginEnablementPromise;
	        }
	        async enableRequestedPluginsWorker(pendingPlugins) {
	          Debug.assert(this.currentPluginEnablementPromise === void 0);
	          await Promise.all(map(pendingPlugins, ([project, promises]) => this.enableRequestedPluginsForProjectAsync(project, promises)));
	          this.currentPluginEnablementPromise = void 0;
	          this.sendProjectsUpdatedInBackgroundEvent();
	        }
	        async enableRequestedPluginsForProjectAsync(project, promises) {
	          const results = await Promise.all(promises);
	          if (project.isClosed()) {
	            return;
	          }
	          for (const result of results) {
	            this.endEnablePlugin(project, result);
	          }
	          this.delayUpdateProjectGraph(project);
	        }
	        configurePlugin(args) {
	          this.forEachEnabledProject((project) => project.onPluginConfigurationChanged(args.pluginName, args.configuration));
	          this.currentPluginConfigOverrides = this.currentPluginConfigOverrides || /* @__PURE__ */ new Map();
	          this.currentPluginConfigOverrides.set(args.pluginName, args.configuration);
	        }
	        /** @internal */
	        getPackageJsonsVisibleToFile(fileName, project, rootDir) {
	          const packageJsonCache = this.packageJsonCache;
	          const rootPath = rootDir && this.toPath(rootDir);
	          const result = [];
	          const processDirectory = (directory) => {
	            switch (packageJsonCache.directoryHasPackageJson(directory)) {
	              case 3 /* Maybe */:
	                packageJsonCache.searchDirectoryAndAncestors(directory);
	                return processDirectory(directory);
	              case -1 /* True */:
	                const packageJsonFileName = combinePaths(directory, "package.json");
	                this.watchPackageJsonFile(packageJsonFileName, this.toPath(packageJsonFileName), project);
	                const info = packageJsonCache.getInDirectory(directory);
	                if (info)
	                  result.push(info);
	            }
	            if (rootPath && rootPath === directory) {
	              return true;
	            }
	          };
	          forEachAncestorDirectory(getDirectoryPath(fileName), processDirectory);
	          return result;
	        }
	        /** @internal */
	        getNearestAncestorDirectoryWithPackageJson(fileName) {
	          return forEachAncestorDirectory(fileName, (directory) => {
	            switch (this.packageJsonCache.directoryHasPackageJson(directory)) {
	              case -1 /* True */:
	                return directory;
	              case 0 /* False */:
	                return void 0;
	              case 3 /* Maybe */:
	                return this.host.fileExists(combinePaths(directory, "package.json")) ? directory : void 0;
	            }
	          });
	        }
	        /** @internal */
	        watchPackageJsonFile(file, path, project) {
	          Debug.assert(project !== void 0);
	          let result = (this.packageJsonFilesMap ?? (this.packageJsonFilesMap = /* @__PURE__ */ new Map())).get(path);
	          if (!result) {
	            let watcher = this.watchFactory.watchFile(
	              file,
	              (fileName, eventKind) => {
	                switch (eventKind) {
	                  case 0 /* Created */:
	                    return Debug.fail();
	                  case 1 /* Changed */:
	                    this.packageJsonCache.addOrUpdate(fileName, path);
	                    this.onPackageJsonChange(result);
	                    break;
	                  case 2 /* Deleted */:
	                    this.packageJsonCache.delete(path);
	                    this.onPackageJsonChange(result);
	                    result.projects.clear();
	                    result.close();
	                }
	              },
	              250 /* Low */,
	              this.hostConfiguration.watchOptions,
	              WatchType.PackageJson
	            );
	            result = {
	              projects: /* @__PURE__ */ new Set(),
	              close: () => {
	                var _a;
	                if (result.projects.size || !watcher)
	                  return;
	                watcher.close();
	                watcher = void 0;
	                (_a = this.packageJsonFilesMap) == null ? void 0 : _a.delete(path);
	                this.packageJsonCache.invalidate(path);
	              }
	            };
	            this.packageJsonFilesMap.set(path, result);
	          }
	          result.projects.add(project);
	          (project.packageJsonWatches ?? (project.packageJsonWatches = /* @__PURE__ */ new Set())).add(result);
	        }
	        /** @internal */
	        onPackageJsonChange(result) {
	          result.projects.forEach((project) => {
	            var _a;
	            return (_a = project.onPackageJsonChange) == null ? void 0 : _a.call(project);
	          });
	        }
	        /** @internal */
	        includePackageJsonAutoImports() {
	          switch (this.hostConfiguration.preferences.includePackageJsonAutoImports) {
	            case "on":
	              return 1 /* On */;
	            case "off":
	              return 0 /* Off */;
	            default:
	              return 2 /* Auto */;
	          }
	        }
	        /** @internal */
	        getIncompleteCompletionsCache() {
	          return this.incompleteCompletionsCache || (this.incompleteCompletionsCache = createIncompleteCompletionsCache());
	        }
	      };
	      /** Makes a filename safe to insert in a RegExp */
	      _ProjectService.filenameEscapeRegexp = /[-/\\^$*+?.()|[\]{}]/g;
	      ProjectService3 = _ProjectService;
	    }
	  });

	  // src/server/moduleSpecifierCache.ts
	  function createModuleSpecifierCache(host) {
	    let containedNodeModulesWatchers;
	    let cache;
	    let currentKey;
	    const result = {
	      get(fromFileName, toFileName2, preferences, options) {
	        if (!cache || currentKey !== key(fromFileName, preferences, options))
	          return void 0;
	        return cache.get(toFileName2);
	      },
	      set(fromFileName, toFileName2, preferences, options, modulePaths, moduleSpecifiers) {
	        ensureCache(fromFileName, preferences, options).set(toFileName2, createInfo(
	          modulePaths,
	          moduleSpecifiers,
	          /*isBlockedByPackageJsonDependencies*/
	          false
	        ));
	        if (moduleSpecifiers) {
	          for (const p of modulePaths) {
	            if (p.isInNodeModules) {
	              const nodeModulesPath = p.path.substring(0, p.path.indexOf(nodeModulesPathPart) + nodeModulesPathPart.length - 1);
	              const key2 = host.toPath(nodeModulesPath);
	              if (!(containedNodeModulesWatchers == null ? void 0 : containedNodeModulesWatchers.has(key2))) {
	                (containedNodeModulesWatchers || (containedNodeModulesWatchers = /* @__PURE__ */ new Map())).set(
	                  key2,
	                  host.watchNodeModulesForPackageJsonChanges(nodeModulesPath)
	                );
	              }
	            }
	          }
	        }
	      },
	      setModulePaths(fromFileName, toFileName2, preferences, options, modulePaths) {
	        const cache2 = ensureCache(fromFileName, preferences, options);
	        const info = cache2.get(toFileName2);
	        if (info) {
	          info.modulePaths = modulePaths;
	        } else {
	          cache2.set(toFileName2, createInfo(
	            modulePaths,
	            /*moduleSpecifiers*/
	            void 0,
	            /*isBlockedByPackageJsonDependencies*/
	            void 0
	          ));
	        }
	      },
	      setBlockedByPackageJsonDependencies(fromFileName, toFileName2, preferences, options, isBlockedByPackageJsonDependencies) {
	        const cache2 = ensureCache(fromFileName, preferences, options);
	        const info = cache2.get(toFileName2);
	        if (info) {
	          info.isBlockedByPackageJsonDependencies = isBlockedByPackageJsonDependencies;
	        } else {
	          cache2.set(toFileName2, createInfo(
	            /*modulePaths*/
	            void 0,
	            /*moduleSpecifiers*/
	            void 0,
	            isBlockedByPackageJsonDependencies
	          ));
	        }
	      },
	      clear() {
	        containedNodeModulesWatchers == null ? void 0 : containedNodeModulesWatchers.forEach(closeFileWatcher);
	        cache == null ? void 0 : cache.clear();
	        containedNodeModulesWatchers == null ? void 0 : containedNodeModulesWatchers.clear();
	        currentKey = void 0;
	      },
	      count() {
	        return cache ? cache.size : 0;
	      }
	    };
	    if (Debug.isDebugging) {
	      Object.defineProperty(result, "__cache", { get: () => cache });
	    }
	    return result;
	    function ensureCache(fromFileName, preferences, options) {
	      const newKey = key(fromFileName, preferences, options);
	      if (cache && currentKey !== newKey) {
	        result.clear();
	      }
	      currentKey = newKey;
	      return cache || (cache = /* @__PURE__ */ new Map());
	    }
	    function key(fromFileName, preferences, options) {
	      return `${fromFileName},${preferences.importModuleSpecifierEnding},${preferences.importModuleSpecifierPreference},${options.overrideImportMode}`;
	    }
	    function createInfo(modulePaths, moduleSpecifiers, isBlockedByPackageJsonDependencies) {
	      return { modulePaths, moduleSpecifiers, isBlockedByPackageJsonDependencies };
	    }
	  }
	  var init_moduleSpecifierCache = __esm({
	    "src/server/moduleSpecifierCache.ts"() {
	      init_ts7();
	    }
	  });

	  // src/server/packageJsonCache.ts
	  function createPackageJsonCache(host) {
	    const packageJsons = /* @__PURE__ */ new Map();
	    const directoriesWithoutPackageJson = /* @__PURE__ */ new Map();
	    return {
	      addOrUpdate,
	      invalidate,
	      delete: (fileName) => {
	        packageJsons.delete(fileName);
	        directoriesWithoutPackageJson.set(getDirectoryPath(fileName), true);
	      },
	      getInDirectory: (directory) => {
	        return packageJsons.get(host.toPath(combinePaths(directory, "package.json"))) || void 0;
	      },
	      directoryHasPackageJson: (directory) => directoryHasPackageJson(host.toPath(directory)),
	      searchDirectoryAndAncestors: (directory) => {
	        forEachAncestorDirectory(directory, (ancestor) => {
	          const ancestorPath = host.toPath(ancestor);
	          if (directoryHasPackageJson(ancestorPath) !== 3 /* Maybe */) {
	            return true;
	          }
	          const packageJsonFileName = combinePaths(ancestor, "package.json");
	          if (tryFileExists(host, packageJsonFileName)) {
	            addOrUpdate(packageJsonFileName, combinePaths(ancestorPath, "package.json"));
	          } else {
	            directoriesWithoutPackageJson.set(ancestorPath, true);
	          }
	        });
	      }
	    };
	    function addOrUpdate(fileName, path) {
	      const packageJsonInfo = Debug.checkDefined(createPackageJsonInfo(fileName, host.host));
	      packageJsons.set(path, packageJsonInfo);
	      directoriesWithoutPackageJson.delete(getDirectoryPath(path));
	    }
	    function invalidate(path) {
	      packageJsons.delete(path);
	      directoriesWithoutPackageJson.delete(getDirectoryPath(path));
	    }
	    function directoryHasPackageJson(directory) {
	      return packageJsons.has(combinePaths(directory, "package.json")) ? -1 /* True */ : directoriesWithoutPackageJson.has(directory) ? 0 /* False */ : 3 /* Maybe */;
	    }
	  }
	  var init_packageJsonCache = __esm({
	    "src/server/packageJsonCache.ts"() {
	      init_ts7();
	    }
	  });

	  // src/server/session.ts
	  function hrTimeToMilliseconds(time) {
	    const seconds = time[0];
	    const nanoseconds = time[1];
	    return (1e9 * seconds + nanoseconds) / 1e6;
	  }
	  function isDeclarationFileInJSOnlyNonConfiguredProject(project, file) {
	    if ((isInferredProject(project) || isExternalProject(project)) && project.isJsOnlyProject()) {
	      const scriptInfo = project.getScriptInfoForNormalizedPath(file);
	      return scriptInfo && !scriptInfo.isJavaScript();
	    }
	    return false;
	  }
	  function dtsChangeCanAffectEmit(compilationSettings) {
	    return getEmitDeclarations(compilationSettings) || !!compilationSettings.emitDecoratorMetadata;
	  }
	  function formatDiag(fileName, project, diag2) {
	    const scriptInfo = project.getScriptInfoForNormalizedPath(fileName);
	    return {
	      start: scriptInfo.positionToLineOffset(diag2.start),
	      end: scriptInfo.positionToLineOffset(diag2.start + diag2.length),
	      // TODO: GH#18217
	      text: flattenDiagnosticMessageText(diag2.messageText, "\n"),
	      code: diag2.code,
	      category: diagnosticCategoryName(diag2),
	      reportsUnnecessary: diag2.reportsUnnecessary,
	      reportsDeprecated: diag2.reportsDeprecated,
	      source: diag2.source,
	      relatedInformation: map(diag2.relatedInformation, formatRelatedInformation)
	    };
	  }
	  function formatRelatedInformation(info) {
	    if (!info.file) {
	      return {
	        message: flattenDiagnosticMessageText(info.messageText, "\n"),
	        category: diagnosticCategoryName(info),
	        code: info.code
	      };
	    }
	    return {
	      span: {
	        start: convertToLocation(getLineAndCharacterOfPosition(info.file, info.start)),
	        end: convertToLocation(getLineAndCharacterOfPosition(info.file, info.start + info.length)),
	        // TODO: GH#18217
	        file: info.file.fileName
	      },
	      message: flattenDiagnosticMessageText(info.messageText, "\n"),
	      category: diagnosticCategoryName(info),
	      code: info.code
	    };
	  }
	  function convertToLocation(lineAndCharacter) {
	    return { line: lineAndCharacter.line + 1, offset: lineAndCharacter.character + 1 };
	  }
	  function formatDiagnosticToProtocol(diag2, includeFileName) {
	    const start = diag2.file && convertToLocation(getLineAndCharacterOfPosition(diag2.file, diag2.start));
	    const end = diag2.file && convertToLocation(getLineAndCharacterOfPosition(diag2.file, diag2.start + diag2.length));
	    const text = flattenDiagnosticMessageText(diag2.messageText, "\n");
	    const { code, source } = diag2;
	    const category = diagnosticCategoryName(diag2);
	    const common = {
	      start,
	      end,
	      text,
	      code,
	      category,
	      reportsUnnecessary: diag2.reportsUnnecessary,
	      reportsDeprecated: diag2.reportsDeprecated,
	      source,
	      relatedInformation: map(diag2.relatedInformation, formatRelatedInformation)
	    };
	    return includeFileName ? { ...common, fileName: diag2.file && diag2.file.fileName } : common;
	  }
	  function allEditsBeforePos(edits, pos) {
	    return edits.every((edit) => textSpanEnd(edit.span) < pos);
	  }
	  function formatMessage2(msg, logger, byteLength, newLine) {
	    const verboseLogging = logger.hasLevel(3 /* verbose */);
	    const json = JSON.stringify(msg);
	    if (verboseLogging) {
	      logger.info(`${msg.type}:${stringifyIndented(msg)}`);
	    }
	    const len = byteLength(json, "utf8");
	    return `Content-Length: ${1 + len}\r
\r
${json}${newLine}`;
	  }
	  function toEvent(eventName, body) {
	    return {
	      seq: 0,
	      type: "event",
	      event: eventName,
	      body
	    };
	  }
	  function combineProjectOutput(defaultValue, getValue, projects, action) {
	    const outputs = flatMapToMutable(isArray(projects) ? projects : projects.projects, (project) => action(project, defaultValue));
	    if (!isArray(projects) && projects.symLinkedProjects) {
	      projects.symLinkedProjects.forEach((projects2, path) => {
	        const value = getValue(path);
	        outputs.push(...flatMap(projects2, (project) => action(project, value)));
	      });
	    }
	    return deduplicate(outputs, equateValues);
	  }
	  function createDocumentSpanSet(useCaseSensitiveFileNames2) {
	    return createSet(({ textSpan }) => textSpan.start + 100003 * textSpan.length, getDocumentSpansEqualityComparer(useCaseSensitiveFileNames2));
	  }
	  function getRenameLocationsWorker(projects, defaultProject, initialLocation, findInStrings, findInComments, preferences, useCaseSensitiveFileNames2) {
	    const perProjectResults = getPerProjectReferences(
	      projects,
	      defaultProject,
	      initialLocation,
	      /*isForRename*/
	      true,
	      (project, position) => project.getLanguageService().findRenameLocations(position.fileName, position.pos, findInStrings, findInComments, preferences),
	      (renameLocation, cb) => cb(documentSpanLocation(renameLocation))
	    );
	    if (isArray(perProjectResults)) {
	      return perProjectResults;
	    }
	    const results = [];
	    const seen = createDocumentSpanSet(useCaseSensitiveFileNames2);
	    perProjectResults.forEach((projectResults, project) => {
	      for (const result of projectResults) {
	        if (!seen.has(result) && !getMappedLocationForProject(documentSpanLocation(result), project)) {
	          results.push(result);
	          seen.add(result);
	        }
	      }
	    });
	    return results;
	  }
	  function getDefinitionLocation(defaultProject, initialLocation, isForRename) {
	    const infos = defaultProject.getLanguageService().getDefinitionAtPosition(
	      initialLocation.fileName,
	      initialLocation.pos,
	      /*searchOtherFilesOnly*/
	      false,
	      /*stopAtAlias*/
	      isForRename
	    );
	    const info = infos && firstOrUndefined(infos);
	    return info && !info.isLocal ? { fileName: info.fileName, pos: info.textSpan.start } : void 0;
	  }
	  function getReferencesWorker(projects, defaultProject, initialLocation, useCaseSensitiveFileNames2, logger) {
	    var _a, _b;
	    const perProjectResults = getPerProjectReferences(
	      projects,
	      defaultProject,
	      initialLocation,
	      /*isForRename*/
	      false,
	      (project, position) => {
	        logger.info(`Finding references to ${position.fileName} position ${position.pos} in project ${project.getProjectName()}`);
	        return project.getLanguageService().findReferences(position.fileName, position.pos);
	      },
	      (referencedSymbol, cb) => {
	        cb(documentSpanLocation(referencedSymbol.definition));
	        for (const ref of referencedSymbol.references) {
	          cb(documentSpanLocation(ref));
	        }
	      }
	    );
	    if (isArray(perProjectResults)) {
	      return perProjectResults;
	    }
	    const defaultProjectResults = perProjectResults.get(defaultProject);
	    if (((_b = (_a = defaultProjectResults == null ? void 0 : defaultProjectResults[0]) == null ? void 0 : _a.references[0]) == null ? void 0 : _b.isDefinition) === void 0) {
	      perProjectResults.forEach((projectResults) => {
	        for (const referencedSymbol of projectResults) {
	          for (const ref of referencedSymbol.references) {
	            delete ref.isDefinition;
	          }
	        }
	      });
	    } else {
	      const knownSymbolSpans = createDocumentSpanSet(useCaseSensitiveFileNames2);
	      for (const referencedSymbol of defaultProjectResults) {
	        for (const ref of referencedSymbol.references) {
	          if (ref.isDefinition) {
	            knownSymbolSpans.add(ref);
	            break;
	          }
	        }
	      }
	      const updatedProjects = /* @__PURE__ */ new Set();
	      while (true) {
	        let progress = false;
	        perProjectResults.forEach((referencedSymbols, project) => {
	          if (updatedProjects.has(project))
	            return;
	          const updated = project.getLanguageService().updateIsDefinitionOfReferencedSymbols(referencedSymbols, knownSymbolSpans);
	          if (updated) {
	            updatedProjects.add(project);
	            progress = true;
	          }
	        });
	        if (!progress)
	          break;
	      }
	      perProjectResults.forEach((referencedSymbols, project) => {
	        if (updatedProjects.has(project))
	          return;
	        for (const referencedSymbol of referencedSymbols) {
	          for (const ref of referencedSymbol.references) {
	            ref.isDefinition = false;
	          }
	        }
	      });
	    }
	    const results = [];
	    const seenRefs = createDocumentSpanSet(useCaseSensitiveFileNames2);
	    perProjectResults.forEach((projectResults, project) => {
	      for (const referencedSymbol of projectResults) {
	        const mappedDefinitionFile = getMappedLocationForProject(documentSpanLocation(referencedSymbol.definition), project);
	        const definition = mappedDefinitionFile === void 0 ? referencedSymbol.definition : {
	          ...referencedSymbol.definition,
	          textSpan: createTextSpan(mappedDefinitionFile.pos, referencedSymbol.definition.textSpan.length),
	          // Why would the length be the same in the original?
	          fileName: mappedDefinitionFile.fileName,
	          contextSpan: getMappedContextSpanForProject(referencedSymbol.definition, project)
	        };
	        let symbolToAddTo = find(results, (o) => documentSpansEqual(o.definition, definition, useCaseSensitiveFileNames2));
	        if (!symbolToAddTo) {
	          symbolToAddTo = { definition, references: [] };
	          results.push(symbolToAddTo);
	        }
	        for (const ref of referencedSymbol.references) {
	          if (!seenRefs.has(ref) && !getMappedLocationForProject(documentSpanLocation(ref), project)) {
	            seenRefs.add(ref);
	            symbolToAddTo.references.push(ref);
	          }
	        }
	      }
	    });
	    return results.filter((o) => o.references.length !== 0);
	  }
	  function forEachProjectInProjects(projects, path, cb) {
	    for (const project of isArray(projects) ? projects : projects.projects) {
	      cb(project, path);
	    }
	    if (!isArray(projects) && projects.symLinkedProjects) {
	      projects.symLinkedProjects.forEach((symlinkedProjects, symlinkedPath) => {
	        for (const project of symlinkedProjects) {
	          cb(project, symlinkedPath);
	        }
	      });
	    }
	  }
	  function getPerProjectReferences(projects, defaultProject, initialLocation, isForRename, getResultsForPosition, forPositionInResult) {
	    const resultsMap = /* @__PURE__ */ new Map();
	    const queue = createQueue();
	    queue.enqueue({ project: defaultProject, location: initialLocation });
	    forEachProjectInProjects(projects, initialLocation.fileName, (project, path) => {
	      const location = { fileName: path, pos: initialLocation.pos };
	      queue.enqueue({ project, location });
	    });
	    const projectService = defaultProject.projectService;
	    const cancellationToken = defaultProject.getCancellationToken();
	    const defaultDefinition = getDefinitionLocation(defaultProject, initialLocation, isForRename);
	    const getGeneratedDefinition = memoize(
	      () => defaultProject.isSourceOfProjectReferenceRedirect(defaultDefinition.fileName) ? defaultDefinition : defaultProject.getLanguageService().getSourceMapper().tryGetGeneratedPosition(defaultDefinition)
	    );
	    const getSourceDefinition = memoize(
	      () => defaultProject.isSourceOfProjectReferenceRedirect(defaultDefinition.fileName) ? defaultDefinition : defaultProject.getLanguageService().getSourceMapper().tryGetSourcePosition(defaultDefinition)
	    );
	    const searchedProjectKeys = /* @__PURE__ */ new Set();
	    onCancellation:
	      while (!queue.isEmpty()) {
	        while (!queue.isEmpty()) {
	          if (cancellationToken.isCancellationRequested())
	            break onCancellation;
	          const { project, location } = queue.dequeue();
	          if (resultsMap.has(project))
	            continue;
	          if (isLocationProjectReferenceRedirect(project, location))
	            continue;
	          updateProjectIfDirty(project);
	          if (!project.containsFile(toNormalizedPath(location.fileName))) {
	            continue;
	          }
	          const projectResults = searchPosition(project, location);
	          resultsMap.set(project, projectResults ?? emptyArray2);
	          searchedProjectKeys.add(getProjectKey(project));
	        }
	        if (defaultDefinition) {
	          projectService.loadAncestorProjectTree(searchedProjectKeys);
	          projectService.forEachEnabledProject((project) => {
	            if (cancellationToken.isCancellationRequested())
	              return;
	            if (resultsMap.has(project))
	              return;
	            const location = mapDefinitionInProject(defaultDefinition, project, getGeneratedDefinition, getSourceDefinition);
	            if (location) {
	              queue.enqueue({ project, location });
	            }
	          });
	        }
	      }
	    if (resultsMap.size === 1) {
	      return firstIterator(resultsMap.values());
	    }
	    return resultsMap;
	    function searchPosition(project, location) {
	      const projectResults = getResultsForPosition(project, location);
	      if (!projectResults)
	        return void 0;
	      for (const result of projectResults) {
	        forPositionInResult(result, (position) => {
	          const originalLocation = projectService.getOriginalLocationEnsuringConfiguredProject(project, position);
	          if (!originalLocation)
	            return;
	          const originalScriptInfo = projectService.getScriptInfo(originalLocation.fileName);
	          for (const project2 of originalScriptInfo.containingProjects) {
	            if (!project2.isOrphan() && !resultsMap.has(project2)) {
	              queue.enqueue({ project: project2, location: originalLocation });
	            }
	          }
	          const symlinkedProjectsMap = projectService.getSymlinkedProjects(originalScriptInfo);
	          if (symlinkedProjectsMap) {
	            symlinkedProjectsMap.forEach((symlinkedProjects, symlinkedPath) => {
	              for (const symlinkedProject of symlinkedProjects) {
	                if (!symlinkedProject.isOrphan() && !resultsMap.has(symlinkedProject)) {
	                  queue.enqueue({ project: symlinkedProject, location: { fileName: symlinkedPath, pos: originalLocation.pos } });
	                }
	              }
	            });
	          }
	        });
	      }
	      return projectResults;
	    }
	  }
	  function mapDefinitionInProject(definition, project, getGeneratedDefinition, getSourceDefinition) {
	    if (project.containsFile(toNormalizedPath(definition.fileName)) && !isLocationProjectReferenceRedirect(project, definition)) {
	      return definition;
	    }
	    const generatedDefinition = getGeneratedDefinition();
	    if (generatedDefinition && project.containsFile(toNormalizedPath(generatedDefinition.fileName)))
	      return generatedDefinition;
	    const sourceDefinition = getSourceDefinition();
	    return sourceDefinition && project.containsFile(toNormalizedPath(sourceDefinition.fileName)) ? sourceDefinition : void 0;
	  }
	  function isLocationProjectReferenceRedirect(project, location) {
	    if (!location)
	      return false;
	    const program = project.getLanguageService().getProgram();
	    if (!program)
	      return false;
	    const sourceFile = program.getSourceFile(location.fileName);
	    return !!sourceFile && sourceFile.resolvedPath !== sourceFile.path && sourceFile.resolvedPath !== project.toPath(location.fileName);
	  }
	  function getProjectKey(project) {
	    return isConfiguredProject(project) ? project.canonicalConfigFilePath : project.getProjectName();
	  }
	  function documentSpanLocation({ fileName, textSpan }) {
	    return { fileName, pos: textSpan.start };
	  }
	  function getMappedLocationForProject(location, project) {
	    return getMappedLocation(location, project.getSourceMapper(), (p) => project.projectService.fileExists(p));
	  }
	  function getMappedDocumentSpanForProject(documentSpan, project) {
	    return getMappedDocumentSpan(documentSpan, project.getSourceMapper(), (p) => project.projectService.fileExists(p));
	  }
	  function getMappedContextSpanForProject(documentSpan, project) {
	    return getMappedContextSpan(documentSpan, project.getSourceMapper(), (p) => project.projectService.fileExists(p));
	  }
	  function toProtocolTextSpan(textSpan, scriptInfo) {
	    return {
	      start: scriptInfo.positionToLineOffset(textSpan.start),
	      end: scriptInfo.positionToLineOffset(textSpanEnd(textSpan))
	    };
	  }
	  function toProtocolTextSpanWithContext(span, contextSpan, scriptInfo) {
	    const textSpan = toProtocolTextSpan(span, scriptInfo);
	    const contextTextSpan = contextSpan && toProtocolTextSpan(contextSpan, scriptInfo);
	    return contextTextSpan ? { ...textSpan, contextStart: contextTextSpan.start, contextEnd: contextTextSpan.end } : textSpan;
	  }
	  function convertTextChangeToCodeEdit(change, scriptInfo) {
	    return { start: positionToLineOffset(scriptInfo, change.span.start), end: positionToLineOffset(scriptInfo, textSpanEnd(change.span)), newText: change.newText };
	  }
	  function positionToLineOffset(info, position) {
	    return isConfigFile(info) ? locationFromLineAndCharacter(info.getLineAndCharacterOfPosition(position)) : info.positionToLineOffset(position);
	  }
	  function convertLinkedEditInfoToRanges(linkedEdit, scriptInfo) {
	    const ranges = linkedEdit.ranges.map(
	      (r) => {
	        return {
	          start: scriptInfo.positionToLineOffset(r.start),
	          end: scriptInfo.positionToLineOffset(r.start + r.length)
	        };
	      }
	    );
	    if (!linkedEdit.wordPattern)
	      return { ranges };
	    return { ranges, wordPattern: linkedEdit.wordPattern };
	  }
	  function locationFromLineAndCharacter(lc) {
	    return { line: lc.line + 1, offset: lc.character + 1 };
	  }
	  function convertNewFileTextChangeToCodeEdit(textChanges2) {
	    Debug.assert(textChanges2.textChanges.length === 1);
	    const change = first(textChanges2.textChanges);
	    Debug.assert(change.span.start === 0 && change.span.length === 0);
	    return { fileName: textChanges2.fileName, textChanges: [{ start: { line: 0, offset: 0 }, end: { line: 0, offset: 0 }, newText: change.newText }] };
	  }
	  function getLocationInNewDocument(oldText, renameFilename, renameLocation, edits) {
	    const newText = applyEdits(oldText, renameFilename, edits);
	    const { line, character } = computeLineAndCharacterOfPosition(computeLineStarts(newText), renameLocation);
	    return { line: line + 1, offset: character + 1 };
	  }
	  function applyEdits(text, textFilename, edits) {
	    for (const { fileName, textChanges: textChanges2 } of edits) {
	      if (fileName !== textFilename) {
	        continue;
	      }
	      for (let i = textChanges2.length - 1; i >= 0; i--) {
	        const { newText, span: { start, length: length2 } } = textChanges2[i];
	        text = text.slice(0, start) + newText + text.slice(start + length2);
	      }
	    }
	    return text;
	  }
	  function referenceEntryToReferencesResponseItem(projectService, { fileName, textSpan, contextSpan, isWriteAccess: isWriteAccess2, isDefinition }, { disableLineTextInReferences }) {
	    const scriptInfo = Debug.checkDefined(projectService.getScriptInfo(fileName));
	    const span = toProtocolTextSpanWithContext(textSpan, contextSpan, scriptInfo);
	    const lineText = disableLineTextInReferences ? void 0 : getLineText(scriptInfo, span);
	    return {
	      file: fileName,
	      ...span,
	      lineText,
	      isWriteAccess: isWriteAccess2,
	      isDefinition
	    };
	  }
	  function getLineText(scriptInfo, span) {
	    const lineSpan = scriptInfo.lineToTextSpan(span.start.line - 1);
	    return scriptInfo.getSnapshot().getText(lineSpan.start, textSpanEnd(lineSpan)).replace(/\r|\n/g, "");
	  }
	  function isCompletionEntryData(data) {
	    return data === void 0 || data && typeof data === "object" && typeof data.exportName === "string" && (data.fileName === void 0 || typeof data.fileName === "string") && (data.ambientModuleName === void 0 || typeof data.ambientModuleName === "string" && (data.isPackageJsonImport === void 0 || typeof data.isPackageJsonImport === "boolean"));
	  }
	  var nullCancellationToken, CommandNames, MultistepOperation, invalidPartialSemanticModeCommands, invalidSyntacticModeCommands, Session3;
	  var init_session = __esm({
	    "src/server/session.ts"() {
	      init_ts7();
	      init_ts_server3();
	      init_protocol();
	      nullCancellationToken = {
	        isCancellationRequested: () => false,
	        setRequest: () => void 0,
	        resetRequest: () => void 0
	      };
	      CommandNames = CommandTypes;
	      MultistepOperation = class {
	        constructor(operationHost) {
	          this.operationHost = operationHost;
	        }
	        startNew(action) {
	          this.complete();
	          this.requestId = this.operationHost.getCurrentRequestId();
	          this.executeAction(action);
	        }
	        complete() {
	          if (this.requestId !== void 0) {
	            this.operationHost.sendRequestCompletedEvent(this.requestId);
	            this.requestId = void 0;
	          }
	          this.setTimerHandle(void 0);
	          this.setImmediateId(void 0);
	        }
	        immediate(actionType, action) {
	          const requestId = this.requestId;
	          Debug.assert(requestId === this.operationHost.getCurrentRequestId(), "immediate: incorrect request id");
	          this.setImmediateId(
	            this.operationHost.getServerHost().setImmediate(() => {
	              this.immediateId = void 0;
	              this.operationHost.executeWithRequestId(requestId, () => this.executeAction(action));
	            }, actionType)
	          );
	        }
	        delay(actionType, ms, action) {
	          const requestId = this.requestId;
	          Debug.assert(requestId === this.operationHost.getCurrentRequestId(), "delay: incorrect request id");
	          this.setTimerHandle(
	            this.operationHost.getServerHost().setTimeout(
	              () => {
	                this.timerHandle = void 0;
	                this.operationHost.executeWithRequestId(requestId, () => this.executeAction(action));
	              },
	              ms,
	              actionType
	            )
	          );
	        }
	        executeAction(action) {
	          var _a, _b, _c, _d, _e, _f;
	          let stop = false;
	          try {
	            if (this.operationHost.isCancellationRequested()) {
	              stop = true;
	              (_a = tracing) == null ? void 0 : _a.instant(tracing.Phase.Session, "stepCanceled", { seq: this.requestId, early: true });
	            } else {
	              (_b = tracing) == null ? void 0 : _b.push(tracing.Phase.Session, "stepAction", { seq: this.requestId });
	              action(this);
	              (_c = tracing) == null ? void 0 : _c.pop();
	            }
	          } catch (e) {
	            (_d = tracing) == null ? void 0 : _d.popAll();
	            stop = true;
	            if (e instanceof OperationCanceledException) {
	              (_e = tracing) == null ? void 0 : _e.instant(tracing.Phase.Session, "stepCanceled", { seq: this.requestId });
	            } else {
	              (_f = tracing) == null ? void 0 : _f.instant(tracing.Phase.Session, "stepError", { seq: this.requestId, message: e.message });
	              this.operationHost.logError(e, `delayed processing of request ${this.requestId}`);
	            }
	          }
	          if (stop || !this.hasPendingWork()) {
	            this.complete();
	          }
	        }
	        setTimerHandle(timerHandle) {
	          if (this.timerHandle !== void 0) {
	            this.operationHost.getServerHost().clearTimeout(this.timerHandle);
	          }
	          this.timerHandle = timerHandle;
	        }
	        setImmediateId(immediateId) {
	          if (this.immediateId !== void 0) {
	            this.operationHost.getServerHost().clearImmediate(this.immediateId);
	          }
	          this.immediateId = immediateId;
	        }
	        hasPendingWork() {
	          return !!this.timerHandle || !!this.immediateId;
	        }
	      };
	      invalidPartialSemanticModeCommands = [
	        "openExternalProject" /* OpenExternalProject */,
	        "openExternalProjects" /* OpenExternalProjects */,
	        "closeExternalProject" /* CloseExternalProject */,
	        "synchronizeProjectList" /* SynchronizeProjectList */,
	        "emit-output" /* EmitOutput */,
	        "compileOnSaveAffectedFileList" /* CompileOnSaveAffectedFileList */,
	        "compileOnSaveEmitFile" /* CompileOnSaveEmitFile */,
	        "compilerOptionsDiagnostics-full" /* CompilerOptionsDiagnosticsFull */,
	        "encodedSemanticClassifications-full" /* EncodedSemanticClassificationsFull */,
	        "semanticDiagnosticsSync" /* SemanticDiagnosticsSync */,
	        "suggestionDiagnosticsSync" /* SuggestionDiagnosticsSync */,
	        "geterrForProject" /* GeterrForProject */,
	        "reload" /* Reload */,
	        "reloadProjects" /* ReloadProjects */,
	        "getCodeFixes" /* GetCodeFixes */,
	        "getCodeFixes-full" /* GetCodeFixesFull */,
	        "getCombinedCodeFix" /* GetCombinedCodeFix */,
	        "getCombinedCodeFix-full" /* GetCombinedCodeFixFull */,
	        "applyCodeActionCommand" /* ApplyCodeActionCommand */,
	        "getSupportedCodeFixes" /* GetSupportedCodeFixes */,
	        "getApplicableRefactors" /* GetApplicableRefactors */,
	        "getMoveToRefactoringFileSuggestions" /* GetMoveToRefactoringFileSuggestions */,
	        "getEditsForRefactor" /* GetEditsForRefactor */,
	        "getEditsForRefactor-full" /* GetEditsForRefactorFull */,
	        "organizeImports" /* OrganizeImports */,
	        "organizeImports-full" /* OrganizeImportsFull */,
	        "getEditsForFileRename" /* GetEditsForFileRename */,
	        "getEditsForFileRename-full" /* GetEditsForFileRenameFull */,
	        "prepareCallHierarchy" /* PrepareCallHierarchy */,
	        "provideCallHierarchyIncomingCalls" /* ProvideCallHierarchyIncomingCalls */,
	        "provideCallHierarchyOutgoingCalls" /* ProvideCallHierarchyOutgoingCalls */
	      ];
	      invalidSyntacticModeCommands = [
	        ...invalidPartialSemanticModeCommands,
	        "definition" /* Definition */,
	        "definition-full" /* DefinitionFull */,
	        "definitionAndBoundSpan" /* DefinitionAndBoundSpan */,
	        "definitionAndBoundSpan-full" /* DefinitionAndBoundSpanFull */,
	        "typeDefinition" /* TypeDefinition */,
	        "implementation" /* Implementation */,
	        "implementation-full" /* ImplementationFull */,
	        "references" /* References */,
	        "references-full" /* ReferencesFull */,
	        "rename" /* Rename */,
	        "renameLocations-full" /* RenameLocationsFull */,
	        "rename-full" /* RenameInfoFull */,
	        "quickinfo" /* Quickinfo */,
	        "quickinfo-full" /* QuickinfoFull */,
	        "completionInfo" /* CompletionInfo */,
	        "completions" /* Completions */,
	        "completions-full" /* CompletionsFull */,
	        "completionEntryDetails" /* CompletionDetails */,
	        "completionEntryDetails-full" /* CompletionDetailsFull */,
	        "signatureHelp" /* SignatureHelp */,
	        "signatureHelp-full" /* SignatureHelpFull */,
	        "navto" /* Navto */,
	        "navto-full" /* NavtoFull */,
	        "documentHighlights" /* DocumentHighlights */,
	        "documentHighlights-full" /* DocumentHighlightsFull */
	      ];
	      Session3 = class _Session {
	        constructor(opts) {
	          this.changeSeq = 0;
	          this.handlers = new Map(Object.entries({
	            // TODO(jakebailey): correctly type the handlers
	            ["status" /* Status */]: () => {
	              const response = { version };
	              return this.requiredResponse(response);
	            },
	            ["openExternalProject" /* OpenExternalProject */]: (request) => {
	              this.projectService.openExternalProject(
	                request.arguments,
	                /*print*/
	                true
	              );
	              return this.requiredResponse(
	                /*response*/
	                true
	              );
	            },
	            ["openExternalProjects" /* OpenExternalProjects */]: (request) => {
	              this.projectService.openExternalProjects(request.arguments.projects);
	              return this.requiredResponse(
	                /*response*/
	                true
	              );
	            },
	            ["closeExternalProject" /* CloseExternalProject */]: (request) => {
	              this.projectService.closeExternalProject(
	                request.arguments.projectFileName,
	                /*print*/
	                true
	              );
	              return this.requiredResponse(
	                /*response*/
	                true
	              );
	            },
	            ["synchronizeProjectList" /* SynchronizeProjectList */]: (request) => {
	              const result = this.projectService.synchronizeProjectList(request.arguments.knownProjects, request.arguments.includeProjectReferenceRedirectInfo);
	              if (!result.some((p) => p.projectErrors && p.projectErrors.length !== 0)) {
	                return this.requiredResponse(result);
	              }
	              const converted = map(result, (p) => {
	                if (!p.projectErrors || p.projectErrors.length === 0) {
	                  return p;
	                }
	                return {
	                  info: p.info,
	                  changes: p.changes,
	                  files: p.files,
	                  projectErrors: this.convertToDiagnosticsWithLinePosition(
	                    p.projectErrors,
	                    /*scriptInfo*/
	                    void 0
	                  )
	                };
	              });
	              return this.requiredResponse(converted);
	            },
	            ["updateOpen" /* UpdateOpen */]: (request) => {
	              this.changeSeq++;
	              this.projectService.applyChangesInOpenFiles(
	                request.arguments.openFiles && mapIterator(request.arguments.openFiles, (file) => ({
	                  fileName: file.file,
	                  content: file.fileContent,
	                  scriptKind: file.scriptKindName,
	                  projectRootPath: file.projectRootPath
	                })),
	                request.arguments.changedFiles && mapIterator(request.arguments.changedFiles, (file) => ({
	                  fileName: file.fileName,
	                  changes: mapDefinedIterator(arrayReverseIterator(file.textChanges), (change) => {
	                    const scriptInfo = Debug.checkDefined(this.projectService.getScriptInfo(file.fileName));
	                    const start = scriptInfo.lineOffsetToPosition(change.start.line, change.start.offset);
	                    const end = scriptInfo.lineOffsetToPosition(change.end.line, change.end.offset);
	                    return start >= 0 ? { span: { start, length: end - start }, newText: change.newText } : void 0;
	                  })
	                })),
	                request.arguments.closedFiles
	              );
	              return this.requiredResponse(
	                /*response*/
	                true
	              );
	            },
	            ["applyChangedToOpenFiles" /* ApplyChangedToOpenFiles */]: (request) => {
	              this.changeSeq++;
	              this.projectService.applyChangesInOpenFiles(
	                request.arguments.openFiles,
	                request.arguments.changedFiles && mapIterator(request.arguments.changedFiles, (file) => ({
	                  fileName: file.fileName,
	                  // apply changes in reverse order
	                  changes: arrayReverseIterator(file.changes)
	                })),
	                request.arguments.closedFiles
	              );
	              return this.requiredResponse(
	                /*response*/
	                true
	              );
	            },
	            ["exit" /* Exit */]: () => {
	              this.exit();
	              return this.notRequired();
	            },
	            ["definition" /* Definition */]: (request) => {
	              return this.requiredResponse(this.getDefinition(
	                request.arguments,
	                /*simplifiedResult*/
	                true
	              ));
	            },
	            ["definition-full" /* DefinitionFull */]: (request) => {
	              return this.requiredResponse(this.getDefinition(
	                request.arguments,
	                /*simplifiedResult*/
	                false
	              ));
	            },
	            ["definitionAndBoundSpan" /* DefinitionAndBoundSpan */]: (request) => {
	              return this.requiredResponse(this.getDefinitionAndBoundSpan(
	                request.arguments,
	                /*simplifiedResult*/
	                true
	              ));
	            },
	            ["definitionAndBoundSpan-full" /* DefinitionAndBoundSpanFull */]: (request) => {
	              return this.requiredResponse(this.getDefinitionAndBoundSpan(
	                request.arguments,
	                /*simplifiedResult*/
	                false
	              ));
	            },
	            ["findSourceDefinition" /* FindSourceDefinition */]: (request) => {
	              return this.requiredResponse(this.findSourceDefinition(request.arguments));
	            },
	            ["emit-output" /* EmitOutput */]: (request) => {
	              return this.requiredResponse(this.getEmitOutput(request.arguments));
	            },
	            ["typeDefinition" /* TypeDefinition */]: (request) => {
	              return this.requiredResponse(this.getTypeDefinition(request.arguments));
	            },
	            ["implementation" /* Implementation */]: (request) => {
	              return this.requiredResponse(this.getImplementation(
	                request.arguments,
	                /*simplifiedResult*/
	                true
	              ));
	            },
	            ["implementation-full" /* ImplementationFull */]: (request) => {
	              return this.requiredResponse(this.getImplementation(
	                request.arguments,
	                /*simplifiedResult*/
	                false
	              ));
	            },
	            ["references" /* References */]: (request) => {
	              return this.requiredResponse(this.getReferences(
	                request.arguments,
	                /*simplifiedResult*/
	                true
	              ));
	            },
	            ["references-full" /* ReferencesFull */]: (request) => {
	              return this.requiredResponse(this.getReferences(
	                request.arguments,
	                /*simplifiedResult*/
	                false
	              ));
	            },
	            ["rename" /* Rename */]: (request) => {
	              return this.requiredResponse(this.getRenameLocations(
	                request.arguments,
	                /*simplifiedResult*/
	                true
	              ));
	            },
	            ["renameLocations-full" /* RenameLocationsFull */]: (request) => {
	              return this.requiredResponse(this.getRenameLocations(
	                request.arguments,
	                /*simplifiedResult*/
	                false
	              ));
	            },
	            ["rename-full" /* RenameInfoFull */]: (request) => {
	              return this.requiredResponse(this.getRenameInfo(request.arguments));
	            },
	            ["open" /* Open */]: (request) => {
	              this.openClientFile(
	                toNormalizedPath(request.arguments.file),
	                request.arguments.fileContent,
	                convertScriptKindName(request.arguments.scriptKindName),
	                // TODO: GH#18217
	                request.arguments.projectRootPath ? toNormalizedPath(request.arguments.projectRootPath) : void 0
	              );
	              return this.notRequired();
	            },
	            ["quickinfo" /* Quickinfo */]: (request) => {
	              return this.requiredResponse(this.getQuickInfoWorker(
	                request.arguments,
	                /*simplifiedResult*/
	                true
	              ));
	            },
	            ["quickinfo-full" /* QuickinfoFull */]: (request) => {
	              return this.requiredResponse(this.getQuickInfoWorker(
	                request.arguments,
	                /*simplifiedResult*/
	                false
	              ));
	            },
	            ["getOutliningSpans" /* GetOutliningSpans */]: (request) => {
	              return this.requiredResponse(this.getOutliningSpans(
	                request.arguments,
	                /*simplifiedResult*/
	                true
	              ));
	            },
	            ["outliningSpans" /* GetOutliningSpansFull */]: (request) => {
	              return this.requiredResponse(this.getOutliningSpans(
	                request.arguments,
	                /*simplifiedResult*/
	                false
	              ));
	            },
	            ["todoComments" /* TodoComments */]: (request) => {
	              return this.requiredResponse(this.getTodoComments(request.arguments));
	            },
	            ["indentation" /* Indentation */]: (request) => {
	              return this.requiredResponse(this.getIndentation(request.arguments));
	            },
	            ["nameOrDottedNameSpan" /* NameOrDottedNameSpan */]: (request) => {
	              return this.requiredResponse(this.getNameOrDottedNameSpan(request.arguments));
	            },
	            ["breakpointStatement" /* BreakpointStatement */]: (request) => {
	              return this.requiredResponse(this.getBreakpointStatement(request.arguments));
	            },
	            ["braceCompletion" /* BraceCompletion */]: (request) => {
	              return this.requiredResponse(this.isValidBraceCompletion(request.arguments));
	            },
	            ["docCommentTemplate" /* DocCommentTemplate */]: (request) => {
	              return this.requiredResponse(this.getDocCommentTemplate(request.arguments));
	            },
	            ["getSpanOfEnclosingComment" /* GetSpanOfEnclosingComment */]: (request) => {
	              return this.requiredResponse(this.getSpanOfEnclosingComment(request.arguments));
	            },
	            ["fileReferences" /* FileReferences */]: (request) => {
	              return this.requiredResponse(this.getFileReferences(
	                request.arguments,
	                /*simplifiedResult*/
	                true
	              ));
	            },
	            ["fileReferences-full" /* FileReferencesFull */]: (request) => {
	              return this.requiredResponse(this.getFileReferences(
	                request.arguments,
	                /*simplifiedResult*/
	                false
	              ));
	            },
	            ["format" /* Format */]: (request) => {
	              return this.requiredResponse(this.getFormattingEditsForRange(request.arguments));
	            },
	            ["formatonkey" /* Formatonkey */]: (request) => {
	              return this.requiredResponse(this.getFormattingEditsAfterKeystroke(request.arguments));
	            },
	            ["format-full" /* FormatFull */]: (request) => {
	              return this.requiredResponse(this.getFormattingEditsForDocumentFull(request.arguments));
	            },
	            ["formatonkey-full" /* FormatonkeyFull */]: (request) => {
	              return this.requiredResponse(this.getFormattingEditsAfterKeystrokeFull(request.arguments));
	            },
	            ["formatRange-full" /* FormatRangeFull */]: (request) => {
	              return this.requiredResponse(this.getFormattingEditsForRangeFull(request.arguments));
	            },
	            ["completionInfo" /* CompletionInfo */]: (request) => {
	              return this.requiredResponse(this.getCompletions(request.arguments, "completionInfo" /* CompletionInfo */));
	            },
	            ["completions" /* Completions */]: (request) => {
	              return this.requiredResponse(this.getCompletions(request.arguments, "completions" /* Completions */));
	            },
	            ["completions-full" /* CompletionsFull */]: (request) => {
	              return this.requiredResponse(this.getCompletions(request.arguments, "completions-full" /* CompletionsFull */));
	            },
	            ["completionEntryDetails" /* CompletionDetails */]: (request) => {
	              return this.requiredResponse(this.getCompletionEntryDetails(
	                request.arguments,
	                /*fullResult*/
	                false
	              ));
	            },
	            ["completionEntryDetails-full" /* CompletionDetailsFull */]: (request) => {
	              return this.requiredResponse(this.getCompletionEntryDetails(
	                request.arguments,
	                /*fullResult*/
	                true
	              ));
	            },
	            ["compileOnSaveAffectedFileList" /* CompileOnSaveAffectedFileList */]: (request) => {
	              return this.requiredResponse(this.getCompileOnSaveAffectedFileList(request.arguments));
	            },
	            ["compileOnSaveEmitFile" /* CompileOnSaveEmitFile */]: (request) => {
	              return this.requiredResponse(this.emitFile(request.arguments));
	            },
	            ["signatureHelp" /* SignatureHelp */]: (request) => {
	              return this.requiredResponse(this.getSignatureHelpItems(
	                request.arguments,
	                /*simplifiedResult*/
	                true
	              ));
	            },
	            ["signatureHelp-full" /* SignatureHelpFull */]: (request) => {
	              return this.requiredResponse(this.getSignatureHelpItems(
	                request.arguments,
	                /*simplifiedResult*/
	                false
	              ));
	            },
	            ["compilerOptionsDiagnostics-full" /* CompilerOptionsDiagnosticsFull */]: (request) => {
	              return this.requiredResponse(this.getCompilerOptionsDiagnostics(request.arguments));
	            },
	            ["encodedSyntacticClassifications-full" /* EncodedSyntacticClassificationsFull */]: (request) => {
	              return this.requiredResponse(this.getEncodedSyntacticClassifications(request.arguments));
	            },
	            ["encodedSemanticClassifications-full" /* EncodedSemanticClassificationsFull */]: (request) => {
	              return this.requiredResponse(this.getEncodedSemanticClassifications(request.arguments));
	            },
	            ["cleanup" /* Cleanup */]: () => {
	              this.cleanup();
	              return this.requiredResponse(
	                /*response*/
	                true
	              );
	            },
	            ["semanticDiagnosticsSync" /* SemanticDiagnosticsSync */]: (request) => {
	              return this.requiredResponse(this.getSemanticDiagnosticsSync(request.arguments));
	            },
	            ["syntacticDiagnosticsSync" /* SyntacticDiagnosticsSync */]: (request) => {
	              return this.requiredResponse(this.getSyntacticDiagnosticsSync(request.arguments));
	            },
	            ["suggestionDiagnosticsSync" /* SuggestionDiagnosticsSync */]: (request) => {
	              return this.requiredResponse(this.getSuggestionDiagnosticsSync(request.arguments));
	            },
	            ["geterr" /* Geterr */]: (request) => {
	              this.errorCheck.startNew((next) => this.getDiagnostics(next, request.arguments.delay, request.arguments.files));
	              return this.notRequired();
	            },
	            ["geterrForProject" /* GeterrForProject */]: (request) => {
	              this.errorCheck.startNew((next) => this.getDiagnosticsForProject(next, request.arguments.delay, request.arguments.file));
	              return this.notRequired();
	            },
	            ["change" /* Change */]: (request) => {
	              this.change(request.arguments);
	              return this.notRequired();
	            },
	            ["configure" /* Configure */]: (request) => {
	              this.projectService.setHostConfiguration(request.arguments);
	              this.doOutput(
	                /*info*/
	                void 0,
	                "configure" /* Configure */,
	                request.seq,
	                /*success*/
	                true
	              );
	              return this.notRequired();
	            },
	            ["reload" /* Reload */]: (request) => {
	              this.reload(request.arguments, request.seq);
	              return this.requiredResponse({ reloadFinished: true });
	            },
	            ["saveto" /* Saveto */]: (request) => {
	              const savetoArgs = request.arguments;
	              this.saveToTmp(savetoArgs.file, savetoArgs.tmpfile);
	              return this.notRequired();
	            },
	            ["close" /* Close */]: (request) => {
	              const closeArgs = request.arguments;
	              this.closeClientFile(closeArgs.file);
	              return this.notRequired();
	            },
	            ["navto" /* Navto */]: (request) => {
	              return this.requiredResponse(this.getNavigateToItems(
	                request.arguments,
	                /*simplifiedResult*/
	                true
	              ));
	            },
	            ["navto-full" /* NavtoFull */]: (request) => {
	              return this.requiredResponse(this.getNavigateToItems(
	                request.arguments,
	                /*simplifiedResult*/
	                false
	              ));
	            },
	            ["brace" /* Brace */]: (request) => {
	              return this.requiredResponse(this.getBraceMatching(
	                request.arguments,
	                /*simplifiedResult*/
	                true
	              ));
	            },
	            ["brace-full" /* BraceFull */]: (request) => {
	              return this.requiredResponse(this.getBraceMatching(
	                request.arguments,
	                /*simplifiedResult*/
	                false
	              ));
	            },
	            ["navbar" /* NavBar */]: (request) => {
	              return this.requiredResponse(this.getNavigationBarItems(
	                request.arguments,
	                /*simplifiedResult*/
	                true
	              ));
	            },
	            ["navbar-full" /* NavBarFull */]: (request) => {
	              return this.requiredResponse(this.getNavigationBarItems(
	                request.arguments,
	                /*simplifiedResult*/
	                false
	              ));
	            },
	            ["navtree" /* NavTree */]: (request) => {
	              return this.requiredResponse(this.getNavigationTree(
	                request.arguments,
	                /*simplifiedResult*/
	                true
	              ));
	            },
	            ["navtree-full" /* NavTreeFull */]: (request) => {
	              return this.requiredResponse(this.getNavigationTree(
	                request.arguments,
	                /*simplifiedResult*/
	                false
	              ));
	            },
	            ["documentHighlights" /* DocumentHighlights */]: (request) => {
	              return this.requiredResponse(this.getDocumentHighlights(
	                request.arguments,
	                /*simplifiedResult*/
	                true
	              ));
	            },
	            ["documentHighlights-full" /* DocumentHighlightsFull */]: (request) => {
	              return this.requiredResponse(this.getDocumentHighlights(
	                request.arguments,
	                /*simplifiedResult*/
	                false
	              ));
	            },
	            ["compilerOptionsForInferredProjects" /* CompilerOptionsForInferredProjects */]: (request) => {
	              this.setCompilerOptionsForInferredProjects(request.arguments);
	              return this.requiredResponse(
	                /*response*/
	                true
	              );
	            },
	            ["projectInfo" /* ProjectInfo */]: (request) => {
	              return this.requiredResponse(this.getProjectInfo(request.arguments));
	            },
	            ["reloadProjects" /* ReloadProjects */]: () => {
	              this.projectService.reloadProjects();
	              return this.notRequired();
	            },
	            ["jsxClosingTag" /* JsxClosingTag */]: (request) => {
	              return this.requiredResponse(this.getJsxClosingTag(request.arguments));
	            },
	            ["linkedEditingRange" /* LinkedEditingRange */]: (request) => {
	              return this.requiredResponse(this.getLinkedEditingRange(request.arguments));
	            },
	            ["getCodeFixes" /* GetCodeFixes */]: (request) => {
	              return this.requiredResponse(this.getCodeFixes(
	                request.arguments,
	                /*simplifiedResult*/
	                true
	              ));
	            },
	            ["getCodeFixes-full" /* GetCodeFixesFull */]: (request) => {
	              return this.requiredResponse(this.getCodeFixes(
	                request.arguments,
	                /*simplifiedResult*/
	                false
	              ));
	            },
	            ["getCombinedCodeFix" /* GetCombinedCodeFix */]: (request) => {
	              return this.requiredResponse(this.getCombinedCodeFix(
	                request.arguments,
	                /*simplifiedResult*/
	                true
	              ));
	            },
	            ["getCombinedCodeFix-full" /* GetCombinedCodeFixFull */]: (request) => {
	              return this.requiredResponse(this.getCombinedCodeFix(
	                request.arguments,
	                /*simplifiedResult*/
	                false
	              ));
	            },
	            ["applyCodeActionCommand" /* ApplyCodeActionCommand */]: (request) => {
	              return this.requiredResponse(this.applyCodeActionCommand(request.arguments));
	            },
	            ["getSupportedCodeFixes" /* GetSupportedCodeFixes */]: (request) => {
	              return this.requiredResponse(this.getSupportedCodeFixes(request.arguments));
	            },
	            ["getApplicableRefactors" /* GetApplicableRefactors */]: (request) => {
	              return this.requiredResponse(this.getApplicableRefactors(request.arguments));
	            },
	            ["getEditsForRefactor" /* GetEditsForRefactor */]: (request) => {
	              return this.requiredResponse(this.getEditsForRefactor(
	                request.arguments,
	                /*simplifiedResult*/
	                true
	              ));
	            },
	            ["getMoveToRefactoringFileSuggestions" /* GetMoveToRefactoringFileSuggestions */]: (request) => {
	              return this.requiredResponse(this.getMoveToRefactoringFileSuggestions(request.arguments));
	            },
	            ["getEditsForRefactor-full" /* GetEditsForRefactorFull */]: (request) => {
	              return this.requiredResponse(this.getEditsForRefactor(
	                request.arguments,
	                /*simplifiedResult*/
	                false
	              ));
	            },
	            ["organizeImports" /* OrganizeImports */]: (request) => {
	              return this.requiredResponse(this.organizeImports(
	                request.arguments,
	                /*simplifiedResult*/
	                true
	              ));
	            },
	            ["organizeImports-full" /* OrganizeImportsFull */]: (request) => {
	              return this.requiredResponse(this.organizeImports(
	                request.arguments,
	                /*simplifiedResult*/
	                false
	              ));
	            },
	            ["getEditsForFileRename" /* GetEditsForFileRename */]: (request) => {
	              return this.requiredResponse(this.getEditsForFileRename(
	                request.arguments,
	                /*simplifiedResult*/
	                true
	              ));
	            },
	            ["getEditsForFileRename-full" /* GetEditsForFileRenameFull */]: (request) => {
	              return this.requiredResponse(this.getEditsForFileRename(
	                request.arguments,
	                /*simplifiedResult*/
	                false
	              ));
	            },
	            ["configurePlugin" /* ConfigurePlugin */]: (request) => {
	              this.configurePlugin(request.arguments);
	              this.doOutput(
	                /*info*/
	                void 0,
	                "configurePlugin" /* ConfigurePlugin */,
	                request.seq,
	                /*success*/
	                true
	              );
	              return this.notRequired();
	            },
	            ["selectionRange" /* SelectionRange */]: (request) => {
	              return this.requiredResponse(this.getSmartSelectionRange(
	                request.arguments,
	                /*simplifiedResult*/
	                true
	              ));
	            },
	            ["selectionRange-full" /* SelectionRangeFull */]: (request) => {
	              return this.requiredResponse(this.getSmartSelectionRange(
	                request.arguments,
	                /*simplifiedResult*/
	                false
	              ));
	            },
	            ["prepareCallHierarchy" /* PrepareCallHierarchy */]: (request) => {
	              return this.requiredResponse(this.prepareCallHierarchy(request.arguments));
	            },
	            ["provideCallHierarchyIncomingCalls" /* ProvideCallHierarchyIncomingCalls */]: (request) => {
	              return this.requiredResponse(this.provideCallHierarchyIncomingCalls(request.arguments));
	            },
	            ["provideCallHierarchyOutgoingCalls" /* ProvideCallHierarchyOutgoingCalls */]: (request) => {
	              return this.requiredResponse(this.provideCallHierarchyOutgoingCalls(request.arguments));
	            },
	            ["toggleLineComment" /* ToggleLineComment */]: (request) => {
	              return this.requiredResponse(this.toggleLineComment(
	                request.arguments,
	                /*simplifiedResult*/
	                true
	              ));
	            },
	            ["toggleLineComment-full" /* ToggleLineCommentFull */]: (request) => {
	              return this.requiredResponse(this.toggleLineComment(
	                request.arguments,
	                /*simplifiedResult*/
	                false
	              ));
	            },
	            ["toggleMultilineComment" /* ToggleMultilineComment */]: (request) => {
	              return this.requiredResponse(this.toggleMultilineComment(
	                request.arguments,
	                /*simplifiedResult*/
	                true
	              ));
	            },
	            ["toggleMultilineComment-full" /* ToggleMultilineCommentFull */]: (request) => {
	              return this.requiredResponse(this.toggleMultilineComment(
	                request.arguments,
	                /*simplifiedResult*/
	                false
	              ));
	            },
	            ["commentSelection" /* CommentSelection */]: (request) => {
	              return this.requiredResponse(this.commentSelection(
	                request.arguments,
	                /*simplifiedResult*/
	                true
	              ));
	            },
	            ["commentSelection-full" /* CommentSelectionFull */]: (request) => {
	              return this.requiredResponse(this.commentSelection(
	                request.arguments,
	                /*simplifiedResult*/
	                false
	              ));
	            },
	            ["uncommentSelection" /* UncommentSelection */]: (request) => {
	              return this.requiredResponse(this.uncommentSelection(
	                request.arguments,
	                /*simplifiedResult*/
	                true
	              ));
	            },
	            ["uncommentSelection-full" /* UncommentSelectionFull */]: (request) => {
	              return this.requiredResponse(this.uncommentSelection(
	                request.arguments,
	                /*simplifiedResult*/
	                false
	              ));
	            },
	            ["provideInlayHints" /* ProvideInlayHints */]: (request) => {
	              return this.requiredResponse(this.provideInlayHints(request.arguments));
	            }
	          }));
	          this.host = opts.host;
	          this.cancellationToken = opts.cancellationToken;
	          this.typingsInstaller = opts.typingsInstaller || nullTypingsInstaller;
	          this.byteLength = opts.byteLength;
	          this.hrtime = opts.hrtime;
	          this.logger = opts.logger;
	          this.canUseEvents = opts.canUseEvents;
	          this.suppressDiagnosticEvents = opts.suppressDiagnosticEvents;
	          this.noGetErrOnBackgroundUpdate = opts.noGetErrOnBackgroundUpdate;
	          const { throttleWaitMilliseconds } = opts;
	          this.eventHandler = this.canUseEvents ? opts.eventHandler || ((event) => this.defaultEventHandler(event)) : void 0;
	          const multistepOperationHost = {
	            executeWithRequestId: (requestId, action) => this.executeWithRequestId(requestId, action),
	            getCurrentRequestId: () => this.currentRequestId,
	            getServerHost: () => this.host,
	            logError: (err, cmd) => this.logError(err, cmd),
	            sendRequestCompletedEvent: (requestId) => this.sendRequestCompletedEvent(requestId),
	            isCancellationRequested: () => this.cancellationToken.isCancellationRequested()
	          };
	          this.errorCheck = new MultistepOperation(multistepOperationHost);
	          const settings = {
	            host: this.host,
	            logger: this.logger,
	            cancellationToken: this.cancellationToken,
	            useSingleInferredProject: opts.useSingleInferredProject,
	            useInferredProjectPerProjectRoot: opts.useInferredProjectPerProjectRoot,
	            typingsInstaller: this.typingsInstaller,
	            throttleWaitMilliseconds,
	            eventHandler: this.eventHandler,
	            suppressDiagnosticEvents: this.suppressDiagnosticEvents,
	            globalPlugins: opts.globalPlugins,
	            pluginProbeLocations: opts.pluginProbeLocations,
	            allowLocalPluginLoads: opts.allowLocalPluginLoads,
	            typesMapLocation: opts.typesMapLocation,
	            serverMode: opts.serverMode,
	            session: this,
	            canUseWatchEvents: opts.canUseWatchEvents,
	            incrementalVerifier: opts.incrementalVerifier
	          };
	          this.projectService = new ProjectService3(settings);
	          this.projectService.setPerformanceEventHandler(this.performanceEventHandler.bind(this));
	          this.gcTimer = new GcTimer(
	            this.host,
	            /*delay*/
	            7e3,
	            this.logger
	          );
	          switch (this.projectService.serverMode) {
	            case 0 /* Semantic */:
	              break;
	            case 1 /* PartialSemantic */:
	              invalidPartialSemanticModeCommands.forEach(
	                (commandName) => this.handlers.set(commandName, (request) => {
	                  throw new Error(`Request: ${request.command} not allowed in LanguageServiceMode.PartialSemantic`);
	                })
	              );
	              break;
	            case 2 /* Syntactic */:
	              invalidSyntacticModeCommands.forEach(
	                (commandName) => this.handlers.set(commandName, (request) => {
	                  throw new Error(`Request: ${request.command} not allowed in LanguageServiceMode.Syntactic`);
	                })
	              );
	              break;
	            default:
	              Debug.assertNever(this.projectService.serverMode);
	          }
	        }
	        sendRequestCompletedEvent(requestId) {
	          this.event({ request_seq: requestId }, "requestCompleted");
	        }
	        addPerformanceData(key, value) {
	          if (!this.performanceData) {
	            this.performanceData = {};
	          }
	          this.performanceData[key] = (this.performanceData[key] ?? 0) + value;
	        }
	        performanceEventHandler(event) {
	          switch (event.kind) {
	            case "UpdateGraph":
	              this.addPerformanceData("updateGraphDurationMs", event.durationMs);
	              break;
	            case "CreatePackageJsonAutoImportProvider":
	              this.addPerformanceData("createAutoImportProviderProgramDurationMs", event.durationMs);
	              break;
	          }
	        }
	        defaultEventHandler(event) {
	          switch (event.eventName) {
	            case ProjectsUpdatedInBackgroundEvent:
	              this.projectsUpdatedInBackgroundEvent(event.data.openFiles);
	              break;
	            case ProjectLoadingStartEvent:
	              this.event({
	                projectName: event.data.project.getProjectName(),
	                reason: event.data.reason
	              }, event.eventName);
	              break;
	            case ProjectLoadingFinishEvent:
	              this.event({
	                projectName: event.data.project.getProjectName()
	              }, event.eventName);
	              break;
	            case LargeFileReferencedEvent:
	            case CreateFileWatcherEvent:
	            case CreateDirectoryWatcherEvent:
	            case CloseFileWatcherEvent:
	              this.event(event.data, event.eventName);
	              break;
	            case ConfigFileDiagEvent:
	              this.event({
	                triggerFile: event.data.triggerFile,
	                configFile: event.data.configFileName,
	                diagnostics: map(event.data.diagnostics, (diagnostic) => formatDiagnosticToProtocol(
	                  diagnostic,
	                  /*includeFileName*/
	                  true
	                ))
	              }, event.eventName);
	              break;
	            case ProjectLanguageServiceStateEvent: {
	              this.event({
	                projectName: event.data.project.getProjectName(),
	                languageServiceEnabled: event.data.languageServiceEnabled
	              }, event.eventName);
	              break;
	            }
	            case ProjectInfoTelemetryEvent: {
	              const eventName = "telemetry";
	              this.event({
	                telemetryEventName: event.eventName,
	                payload: event.data
	              }, eventName);
	              break;
	            }
	          }
	        }
	        projectsUpdatedInBackgroundEvent(openFiles) {
	          this.projectService.logger.info(`got projects updated in background ${openFiles}`);
	          if (openFiles.length) {
	            if (!this.suppressDiagnosticEvents && !this.noGetErrOnBackgroundUpdate) {
	              this.projectService.logger.info(`Queueing diagnostics update for ${openFiles}`);
	              this.errorCheck.startNew((next) => this.updateErrorCheck(
	                next,
	                openFiles,
	                100,
	                /*requireOpen*/
	                true
	              ));
	            }
	            this.event({
	              openFiles
	            }, ProjectsUpdatedInBackgroundEvent);
	          }
	        }
	        logError(err, cmd) {
	          this.logErrorWorker(err, cmd);
	        }
	        logErrorWorker(err, cmd, fileRequest) {
	          let msg = "Exception on executing command " + cmd;
	          if (err.message) {
	            msg += ":\n" + indent2(err.message);
	            if (err.stack) {
	              msg += "\n" + indent2(err.stack);
	            }
	          }
	          if (this.logger.hasLevel(3 /* verbose */)) {
	            if (fileRequest) {
	              try {
	                const { file, project } = this.getFileAndProject(fileRequest);
	                const scriptInfo = project.getScriptInfoForNormalizedPath(file);
	                if (scriptInfo) {
	                  const text = getSnapshotText(scriptInfo.getSnapshot());
	                  msg += `

File text of ${fileRequest.file}:${indent2(text)}
`;
	                }
	              } catch {
	              }
	            }
	            if (err.ProgramFiles) {
	              msg += `

Program files: ${JSON.stringify(err.ProgramFiles)}
`;
	              msg += `

Projects::
`;
	              let counter = 0;
	              const addProjectInfo = (project) => {
	                msg += `
Project '${project.projectName}' (${ProjectKind[project.projectKind]}) ${counter}
`;
	                msg += project.filesToString(
	                  /*writeProjectFileNames*/
	                  true
	                );
	                msg += "\n-----------------------------------------------\n";
	                counter++;
	              };
	              this.projectService.externalProjects.forEach(addProjectInfo);
	              this.projectService.configuredProjects.forEach(addProjectInfo);
	              this.projectService.inferredProjects.forEach(addProjectInfo);
	            }
	          }
	          this.logger.msg(msg, "Err" /* Err */);
	        }
	        send(msg) {
	          if (msg.type === "event" && !this.canUseEvents) {
	            if (this.logger.hasLevel(3 /* verbose */)) {
	              this.logger.info(`Session does not support events: ignored event: ${stringifyIndented(msg)}`);
	            }
	            return;
	          }
	          this.writeMessage(msg);
	        }
	        writeMessage(msg) {
	          var _a;
	          const msgText = formatMessage2(msg, this.logger, this.byteLength, this.host.newLine);
	          (_a = perfLogger) == null ? void 0 : _a.logEvent(`Response message size: ${msgText.length}`);
	          this.host.write(msgText);
	        }
	        event(body, eventName) {
	          this.send(toEvent(eventName, body));
	        }
	        /** @internal */
	        doOutput(info, cmdName, reqSeq, success, message) {
	          const res = {
	            seq: 0,
	            type: "response",
	            command: cmdName,
	            request_seq: reqSeq,
	            success,
	            performanceData: this.performanceData
	          };
	          if (success) {
	            let metadata;
	            if (isArray(info)) {
	              res.body = info;
	              metadata = info.metadata;
	              delete info.metadata;
	            } else if (typeof info === "object") {
	              if (info.metadata) {
	                const { metadata: infoMetadata, ...body } = info;
	                res.body = body;
	                metadata = infoMetadata;
	              } else {
	                res.body = info;
	              }
	            } else {
	              res.body = info;
	            }
	            if (metadata)
	              res.metadata = metadata;
	          } else {
	            Debug.assert(info === void 0);
	          }
	          if (message) {
	            res.message = message;
	          }
	          this.send(res);
	        }
	        semanticCheck(file, project) {
	          var _a, _b;
	          (_a = tracing) == null ? void 0 : _a.push(tracing.Phase.Session, "semanticCheck", { file, configFilePath: project.canonicalConfigFilePath });
	          const diags = isDeclarationFileInJSOnlyNonConfiguredProject(project, file) ? emptyArray2 : project.getLanguageService().getSemanticDiagnostics(file).filter((d) => !!d.file);
	          this.sendDiagnosticsEvent(file, project, diags, "semanticDiag");
	          (_b = tracing) == null ? void 0 : _b.pop();
	        }
	        syntacticCheck(file, project) {
	          var _a, _b;
	          (_a = tracing) == null ? void 0 : _a.push(tracing.Phase.Session, "syntacticCheck", { file, configFilePath: project.canonicalConfigFilePath });
	          this.sendDiagnosticsEvent(file, project, project.getLanguageService().getSyntacticDiagnostics(file), "syntaxDiag");
	          (_b = tracing) == null ? void 0 : _b.pop();
	        }
	        suggestionCheck(file, project) {
	          var _a, _b;
	          (_a = tracing) == null ? void 0 : _a.push(tracing.Phase.Session, "suggestionCheck", { file, configFilePath: project.canonicalConfigFilePath });
	          this.sendDiagnosticsEvent(file, project, project.getLanguageService().getSuggestionDiagnostics(file), "suggestionDiag");
	          (_b = tracing) == null ? void 0 : _b.pop();
	        }
	        sendDiagnosticsEvent(file, project, diagnostics, kind) {
	          try {
	            this.event({ file, diagnostics: diagnostics.map((diag2) => formatDiag(file, project, diag2)) }, kind);
	          } catch (err) {
	            this.logError(err, kind);
	          }
	        }
	        /** It is the caller's responsibility to verify that `!this.suppressDiagnosticEvents`. */
	        updateErrorCheck(next, checkList, ms, requireOpen = true) {
	          Debug.assert(!this.suppressDiagnosticEvents);
	          const seq = this.changeSeq;
	          const followMs = Math.min(ms, 200);
	          let index = 0;
	          const goNext = () => {
	            index++;
	            if (checkList.length > index) {
	              next.delay("checkOne", followMs, checkOne);
	            }
	          };
	          const checkOne = () => {
	            if (this.changeSeq !== seq) {
	              return;
	            }
	            let item = checkList[index];
	            if (isString(item)) {
	              item = this.toPendingErrorCheck(item);
	              if (!item) {
	                goNext();
	                return;
	              }
	            }
	            const { fileName, project } = item;
	            updateProjectIfDirty(project);
	            if (!project.containsFile(fileName, requireOpen)) {
	              return;
	            }
	            this.syntacticCheck(fileName, project);
	            if (this.changeSeq !== seq) {
	              return;
	            }
	            if (project.projectService.serverMode !== 0 /* Semantic */) {
	              goNext();
	              return;
	            }
	            next.immediate("semanticCheck", () => {
	              this.semanticCheck(fileName, project);
	              if (this.changeSeq !== seq) {
	                return;
	              }
	              if (this.getPreferences(fileName).disableSuggestions) {
	                goNext();
	                return;
	              }
	              next.immediate("suggestionCheck", () => {
	                this.suggestionCheck(fileName, project);
	                goNext();
	              });
	            });
	          };
	          if (checkList.length > index && this.changeSeq === seq) {
	            next.delay("checkOne", ms, checkOne);
	          }
	        }
	        cleanProjects(caption, projects) {
	          if (!projects) {
	            return;
	          }
	          this.logger.info(`cleaning ${caption}`);
	          for (const p of projects) {
	            p.getLanguageService(
	              /*ensureSynchronized*/
	              false
	            ).cleanupSemanticCache();
	            p.cleanupProgram();
	          }
	        }
	        cleanup() {
	          this.cleanProjects("inferred projects", this.projectService.inferredProjects);
	          this.cleanProjects("configured projects", arrayFrom(this.projectService.configuredProjects.values()));
	          this.cleanProjects("external projects", this.projectService.externalProjects);
	          if (this.host.gc) {
	            this.logger.info(`host.gc()`);
	            this.host.gc();
	          }
	        }
	        getEncodedSyntacticClassifications(args) {
	          const { file, languageService } = this.getFileAndLanguageServiceForSyntacticOperation(args);
	          return languageService.getEncodedSyntacticClassifications(file, args);
	        }
	        getEncodedSemanticClassifications(args) {
	          const { file, project } = this.getFileAndProject(args);
	          const format = args.format === "2020" ? "2020" /* TwentyTwenty */ : "original" /* Original */;
	          return project.getLanguageService().getEncodedSemanticClassifications(file, args, format);
	        }
	        getProject(projectFileName) {
	          return projectFileName === void 0 ? void 0 : this.projectService.findProject(projectFileName);
	        }
	        getConfigFileAndProject(args) {
	          const project = this.getProject(args.projectFileName);
	          const file = toNormalizedPath(args.file);
	          return {
	            configFile: project && project.hasConfigFile(file) ? file : void 0,
	            project
	          };
	        }
	        getConfigFileDiagnostics(configFile, project, includeLinePosition) {
	          const projectErrors = project.getAllProjectErrors();
	          const optionsErrors = project.getLanguageService().getCompilerOptionsDiagnostics();
	          const diagnosticsForConfigFile = filter(
	            concatenate(projectErrors, optionsErrors),
	            (diagnostic) => !!diagnostic.file && diagnostic.file.fileName === configFile
	          );
	          return includeLinePosition ? this.convertToDiagnosticsWithLinePositionFromDiagnosticFile(diagnosticsForConfigFile) : map(
	            diagnosticsForConfigFile,
	            (diagnostic) => formatDiagnosticToProtocol(
	              diagnostic,
	              /*includeFileName*/
	              false
	            )
	          );
	        }
	        convertToDiagnosticsWithLinePositionFromDiagnosticFile(diagnostics) {
	          return diagnostics.map((d) => ({
	            message: flattenDiagnosticMessageText(d.messageText, this.host.newLine),
	            start: d.start,
	            // TODO: GH#18217
	            length: d.length,
	            // TODO: GH#18217
	            category: diagnosticCategoryName(d),
	            code: d.code,
	            source: d.source,
	            startLocation: d.file && convertToLocation(getLineAndCharacterOfPosition(d.file, d.start)),
	            // TODO: GH#18217
	            endLocation: d.file && convertToLocation(getLineAndCharacterOfPosition(d.file, d.start + d.length)),
	            // TODO: GH#18217
	            reportsUnnecessary: d.reportsUnnecessary,
	            reportsDeprecated: d.reportsDeprecated,
	            relatedInformation: map(d.relatedInformation, formatRelatedInformation)
	          }));
	        }
	        getCompilerOptionsDiagnostics(args) {
	          const project = this.getProject(args.projectFileName);
	          return this.convertToDiagnosticsWithLinePosition(
	            filter(
	              project.getLanguageService().getCompilerOptionsDiagnostics(),
	              (diagnostic) => !diagnostic.file
	            ),
	            /*scriptInfo*/
	            void 0
	          );
	        }
	        convertToDiagnosticsWithLinePosition(diagnostics, scriptInfo) {
	          return diagnostics.map(
	            (d) => ({
	              message: flattenDiagnosticMessageText(d.messageText, this.host.newLine),
	              start: d.start,
	              length: d.length,
	              category: diagnosticCategoryName(d),
	              code: d.code,
	              source: d.source,
	              startLocation: scriptInfo && scriptInfo.positionToLineOffset(d.start),
	              // TODO: GH#18217
	              endLocation: scriptInfo && scriptInfo.positionToLineOffset(d.start + d.length),
	              reportsUnnecessary: d.reportsUnnecessary,
	              reportsDeprecated: d.reportsDeprecated,
	              relatedInformation: map(d.relatedInformation, formatRelatedInformation)
	            })
	          );
	        }
	        getDiagnosticsWorker(args, isSemantic, selector, includeLinePosition) {
	          const { project, file } = this.getFileAndProject(args);
	          if (isSemantic && isDeclarationFileInJSOnlyNonConfiguredProject(project, file)) {
	            return emptyArray2;
	          }
	          const scriptInfo = project.getScriptInfoForNormalizedPath(file);
	          const diagnostics = selector(project, file);
	          return includeLinePosition ? this.convertToDiagnosticsWithLinePosition(diagnostics, scriptInfo) : diagnostics.map((d) => formatDiag(file, project, d));
	        }
	        getDefinition(args, simplifiedResult) {
	          const { file, project } = this.getFileAndProject(args);
	          const position = this.getPositionInFile(args, file);
	          const definitions = this.mapDefinitionInfoLocations(project.getLanguageService().getDefinitionAtPosition(file, position) || emptyArray2, project);
	          return simplifiedResult ? this.mapDefinitionInfo(definitions, project) : definitions.map(_Session.mapToOriginalLocation);
	        }
	        mapDefinitionInfoLocations(definitions, project) {
	          return definitions.map((info) => {
	            const newDocumentSpan = getMappedDocumentSpanForProject(info, project);
	            return !newDocumentSpan ? info : {
	              ...newDocumentSpan,
	              containerKind: info.containerKind,
	              containerName: info.containerName,
	              kind: info.kind,
	              name: info.name,
	              failedAliasResolution: info.failedAliasResolution,
	              ...info.unverified && { unverified: info.unverified }
	            };
	          });
	        }
	        getDefinitionAndBoundSpan(args, simplifiedResult) {
	          const { file, project } = this.getFileAndProject(args);
	          const position = this.getPositionInFile(args, file);
	          const scriptInfo = Debug.checkDefined(project.getScriptInfo(file));
	          const unmappedDefinitionAndBoundSpan = project.getLanguageService().getDefinitionAndBoundSpan(file, position);
	          if (!unmappedDefinitionAndBoundSpan || !unmappedDefinitionAndBoundSpan.definitions) {
	            return {
	              definitions: emptyArray2,
	              textSpan: void 0
	              // TODO: GH#18217
	            };
	          }
	          const definitions = this.mapDefinitionInfoLocations(unmappedDefinitionAndBoundSpan.definitions, project);
	          const { textSpan } = unmappedDefinitionAndBoundSpan;
	          if (simplifiedResult) {
	            return {
	              definitions: this.mapDefinitionInfo(definitions, project),
	              textSpan: toProtocolTextSpan(textSpan, scriptInfo)
	            };
	          }
	          return {
	            definitions: definitions.map(_Session.mapToOriginalLocation),
	            textSpan
	          };
	        }
	        findSourceDefinition(args) {
	          var _a;
	          const { file, project } = this.getFileAndProject(args);
	          const position = this.getPositionInFile(args, file);
	          const unmappedDefinitions = project.getLanguageService().getDefinitionAtPosition(file, position);
	          let definitions = this.mapDefinitionInfoLocations(unmappedDefinitions || emptyArray2, project).slice();
	          const needsJsResolution = this.projectService.serverMode === 0 /* Semantic */ && (!some(definitions, (d) => toNormalizedPath(d.fileName) !== file && !d.isAmbient) || some(definitions, (d) => !!d.failedAliasResolution));
	          if (needsJsResolution) {
	            const definitionSet = createSet(
	              (d) => d.textSpan.start,
	              getDocumentSpansEqualityComparer(this.host.useCaseSensitiveFileNames)
	            );
	            definitions == null ? void 0 : definitions.forEach((d) => definitionSet.add(d));
	            const noDtsProject = project.getNoDtsResolutionProject(file);
	            const ls = noDtsProject.getLanguageService();
	            const jsDefinitions = (_a = ls.getDefinitionAtPosition(
	              file,
	              position,
	              /*searchOtherFilesOnly*/
	              true,
	              /*stopAtAlias*/
	              false
	            )) == null ? void 0 : _a.filter((d) => toNormalizedPath(d.fileName) !== file);
	            if (some(jsDefinitions)) {
	              for (const jsDefinition of jsDefinitions) {
	                if (jsDefinition.unverified) {
	                  const refined = tryRefineDefinition(jsDefinition, project.getLanguageService().getProgram(), ls.getProgram());
	                  if (some(refined)) {
	                    for (const def of refined) {
	                      definitionSet.add(def);
	                    }
	                    continue;
	                  }
	                }
	                definitionSet.add(jsDefinition);
	              }
	            } else {
	              const ambientCandidates = definitions.filter((d) => toNormalizedPath(d.fileName) !== file && d.isAmbient);
	              for (const candidate of some(ambientCandidates) ? ambientCandidates : getAmbientCandidatesByClimbingAccessChain()) {
	                const fileNameToSearch = findImplementationFileFromDtsFileName(candidate.fileName, file, noDtsProject);
	                if (!fileNameToSearch)
	                  continue;
	                const info = this.projectService.getOrCreateScriptInfoNotOpenedByClient(
	                  fileNameToSearch,
	                  noDtsProject.currentDirectory,
	                  noDtsProject.directoryStructureHost
	                );
	                if (!info)
	                  continue;
	                if (!noDtsProject.containsScriptInfo(info)) {
	                  noDtsProject.addRoot(info);
	                  noDtsProject.updateGraph();
	                }
	                const noDtsProgram = ls.getProgram();
	                const fileToSearch = Debug.checkDefined(noDtsProgram.getSourceFile(fileNameToSearch));
	                for (const match of searchForDeclaration(candidate.name, fileToSearch, noDtsProgram)) {
	                  definitionSet.add(match);
	                }
	              }
	            }
	            definitions = arrayFrom(definitionSet.values());
	          }
	          definitions = definitions.filter((d) => !d.isAmbient && !d.failedAliasResolution);
	          return this.mapDefinitionInfo(definitions, project);
	          function findImplementationFileFromDtsFileName(fileName, resolveFromFile, auxiliaryProject) {
	            var _a2, _b, _c;
	            const nodeModulesPathParts = getNodeModulePathParts(fileName);
	            if (nodeModulesPathParts && fileName.lastIndexOf(nodeModulesPathPart) === nodeModulesPathParts.topLevelNodeModulesIndex) {
	              const packageDirectory = fileName.substring(0, nodeModulesPathParts.packageRootIndex);
	              const packageJsonCache = (_a2 = project.getModuleResolutionCache()) == null ? void 0 : _a2.getPackageJsonInfoCache();
	              const compilerOptions = project.getCompilationSettings();
	              const packageJson = getPackageScopeForPath(getNormalizedAbsolutePath(packageDirectory + "/package.json", project.getCurrentDirectory()), getTemporaryModuleResolutionState(packageJsonCache, project, compilerOptions));
	              if (!packageJson)
	                return void 0;
	              const entrypoints = getEntrypointsFromPackageJsonInfo(
	                packageJson,
	                { moduleResolution: 2 /* Node10 */ },
	                project,
	                project.getModuleResolutionCache()
	              );
	              const packageNamePathPart = fileName.substring(
	                nodeModulesPathParts.topLevelPackageNameIndex + 1,
	                nodeModulesPathParts.packageRootIndex
	              );
	              const packageName = getPackageNameFromTypesPackageName(unmangleScopedPackageName(packageNamePathPart));
	              const path = project.toPath(fileName);
	              if (entrypoints && some(entrypoints, (e) => project.toPath(e) === path)) {
	                return (_b = auxiliaryProject.resolutionCache.resolveSingleModuleNameWithoutWatching(packageName, resolveFromFile).resolvedModule) == null ? void 0 : _b.resolvedFileName;
	              } else {
	                const pathToFileInPackage = fileName.substring(nodeModulesPathParts.packageRootIndex + 1);
	                const specifier = `${packageName}/${removeFileExtension(pathToFileInPackage)}`;
	                return (_c = auxiliaryProject.resolutionCache.resolveSingleModuleNameWithoutWatching(specifier, resolveFromFile).resolvedModule) == null ? void 0 : _c.resolvedFileName;
	              }
	            }
	            return void 0;
	          }
	          function getAmbientCandidatesByClimbingAccessChain() {
	            const ls = project.getLanguageService();
	            const program = ls.getProgram();
	            const initialNode = getTouchingPropertyName(program.getSourceFile(file), position);
	            if ((isStringLiteralLike(initialNode) || isIdentifier(initialNode)) && isAccessExpression(initialNode.parent)) {
	              return forEachNameInAccessChainWalkingLeft(initialNode, (nameInChain) => {
	                var _a2;
	                if (nameInChain === initialNode)
	                  return void 0;
	                const candidates = (_a2 = ls.getDefinitionAtPosition(
	                  file,
	                  nameInChain.getStart(),
	                  /*searchOtherFilesOnly*/
	                  true,
	                  /*stopAtAlias*/
	                  false
	                )) == null ? void 0 : _a2.filter((d) => toNormalizedPath(d.fileName) !== file && d.isAmbient).map((d) => ({
	                  fileName: d.fileName,
	                  name: getTextOfIdentifierOrLiteral(initialNode)
	                }));
	                if (some(candidates)) {
	                  return candidates;
	                }
	              }) || emptyArray2;
	            }
	            return emptyArray2;
	          }
	          function tryRefineDefinition(definition, program, noDtsProgram) {
	            var _a2;
	            const fileToSearch = noDtsProgram.getSourceFile(definition.fileName);
	            if (!fileToSearch) {
	              return void 0;
	            }
	            const initialNode = getTouchingPropertyName(program.getSourceFile(file), position);
	            const symbol = program.getTypeChecker().getSymbolAtLocation(initialNode);
	            const importSpecifier = symbol && getDeclarationOfKind(symbol, 276 /* ImportSpecifier */);
	            if (!importSpecifier)
	              return void 0;
	            const nameToSearch = ((_a2 = importSpecifier.propertyName) == null ? void 0 : _a2.text) || importSpecifier.name.text;
	            return searchForDeclaration(nameToSearch, fileToSearch, noDtsProgram);
	          }
	          function searchForDeclaration(declarationName, fileToSearch, noDtsProgram) {
	            const matches = ts_FindAllReferences_exports.Core.getTopMostDeclarationNamesInFile(declarationName, fileToSearch);
	            return mapDefined(matches, (match) => {
	              const symbol = noDtsProgram.getTypeChecker().getSymbolAtLocation(match);
	              const decl = getDeclarationFromName(match);
	              if (symbol && decl) {
	                return ts_GoToDefinition_exports.createDefinitionInfo(
	                  decl,
	                  noDtsProgram.getTypeChecker(),
	                  symbol,
	                  decl,
	                  /*unverified*/
	                  true
	                );
	              }
	            });
	          }
	        }
	        getEmitOutput(args) {
	          const { file, project } = this.getFileAndProject(args);
	          if (!project.shouldEmitFile(project.getScriptInfo(file))) {
	            return { emitSkipped: true, outputFiles: [], diagnostics: [] };
	          }
	          const result = project.getLanguageService().getEmitOutput(file);
	          return args.richResponse ? {
	            ...result,
	            diagnostics: args.includeLinePosition ? this.convertToDiagnosticsWithLinePositionFromDiagnosticFile(result.diagnostics) : result.diagnostics.map((d) => formatDiagnosticToProtocol(
	              d,
	              /*includeFileName*/
	              true
	            ))
	          } : result;
	        }
	        mapJSDocTagInfo(tags, project, richResponse) {
	          return tags ? tags.map((tag) => {
	            var _a;
	            return {
	              ...tag,
	              text: richResponse ? this.mapDisplayParts(tag.text, project) : (_a = tag.text) == null ? void 0 : _a.map((part) => part.text).join("")
	            };
	          }) : [];
	        }
	        mapDisplayParts(parts, project) {
	          if (!parts) {
	            return [];
	          }
	          return parts.map(
	            (part) => part.kind !== "linkName" ? part : {
	              ...part,
	              target: this.toFileSpan(part.target.fileName, part.target.textSpan, project)
	            }
	          );
	        }
	        mapSignatureHelpItems(items, project, richResponse) {
	          return items.map((item) => ({
	            ...item,
	            documentation: this.mapDisplayParts(item.documentation, project),
	            parameters: item.parameters.map((p) => ({ ...p, documentation: this.mapDisplayParts(p.documentation, project) })),
	            tags: this.mapJSDocTagInfo(item.tags, project, richResponse)
	          }));
	        }
	        mapDefinitionInfo(definitions, project) {
	          return definitions.map((def) => ({ ...this.toFileSpanWithContext(def.fileName, def.textSpan, def.contextSpan, project), ...def.unverified && { unverified: def.unverified } }));
	        }
	        /*
	         * When we map a .d.ts location to .ts, Visual Studio gets confused because there's no associated Roslyn Document in
	         * the same project which corresponds to the file. VS Code has no problem with this, and luckily we have two protocols.
	         * This retains the existing behavior for the "simplified" (VS Code) protocol but stores the .d.ts location in a
	         * set of additional fields, and does the reverse for VS (store the .d.ts location where
	         * it used to be and stores the .ts location in the additional fields).
	         */
	        static mapToOriginalLocation(def) {
	          if (def.originalFileName) {
	            Debug.assert(def.originalTextSpan !== void 0, "originalTextSpan should be present if originalFileName is");
	            return {
	              ...def,
	              fileName: def.originalFileName,
	              textSpan: def.originalTextSpan,
	              targetFileName: def.fileName,
	              targetTextSpan: def.textSpan,
	              contextSpan: def.originalContextSpan,
	              targetContextSpan: def.contextSpan
	            };
	          }
	          return def;
	        }
	        toFileSpan(fileName, textSpan, project) {
	          const ls = project.getLanguageService();
	          const start = ls.toLineColumnOffset(fileName, textSpan.start);
	          const end = ls.toLineColumnOffset(fileName, textSpanEnd(textSpan));
	          return {
	            file: fileName,
	            start: { line: start.line + 1, offset: start.character + 1 },
	            end: { line: end.line + 1, offset: end.character + 1 }
	          };
	        }
	        toFileSpanWithContext(fileName, textSpan, contextSpan, project) {
	          const fileSpan = this.toFileSpan(fileName, textSpan, project);
	          const context = contextSpan && this.toFileSpan(fileName, contextSpan, project);
	          return context ? { ...fileSpan, contextStart: context.start, contextEnd: context.end } : fileSpan;
	        }
	        getTypeDefinition(args) {
	          const { file, project } = this.getFileAndProject(args);
	          const position = this.getPositionInFile(args, file);
	          const definitions = this.mapDefinitionInfoLocations(project.getLanguageService().getTypeDefinitionAtPosition(file, position) || emptyArray2, project);
	          return this.mapDefinitionInfo(definitions, project);
	        }
	        mapImplementationLocations(implementations, project) {
	          return implementations.map((info) => {
	            const newDocumentSpan = getMappedDocumentSpanForProject(info, project);
	            return !newDocumentSpan ? info : {
	              ...newDocumentSpan,
	              kind: info.kind,
	              displayParts: info.displayParts
	            };
	          });
	        }
	        getImplementation(args, simplifiedResult) {
	          const { file, project } = this.getFileAndProject(args);
	          const position = this.getPositionInFile(args, file);
	          const implementations = this.mapImplementationLocations(project.getLanguageService().getImplementationAtPosition(file, position) || emptyArray2, project);
	          return simplifiedResult ? implementations.map(({ fileName, textSpan, contextSpan }) => this.toFileSpanWithContext(fileName, textSpan, contextSpan, project)) : implementations.map(_Session.mapToOriginalLocation);
	        }
	        getSyntacticDiagnosticsSync(args) {
	          const { configFile } = this.getConfigFileAndProject(args);
	          if (configFile) {
	            return emptyArray2;
	          }
	          return this.getDiagnosticsWorker(
	            args,
	            /*isSemantic*/
	            false,
	            (project, file) => project.getLanguageService().getSyntacticDiagnostics(file),
	            !!args.includeLinePosition
	          );
	        }
	        getSemanticDiagnosticsSync(args) {
	          const { configFile, project } = this.getConfigFileAndProject(args);
	          if (configFile) {
	            return this.getConfigFileDiagnostics(configFile, project, !!args.includeLinePosition);
	          }
	          return this.getDiagnosticsWorker(
	            args,
	            /*isSemantic*/
	            true,
	            (project2, file) => project2.getLanguageService().getSemanticDiagnostics(file).filter((d) => !!d.file),
	            !!args.includeLinePosition
	          );
	        }
	        getSuggestionDiagnosticsSync(args) {
	          const { configFile } = this.getConfigFileAndProject(args);
	          if (configFile) {
	            return emptyArray2;
	          }
	          return this.getDiagnosticsWorker(
	            args,
	            /*isSemantic*/
	            true,
	            (project, file) => project.getLanguageService().getSuggestionDiagnostics(file),
	            !!args.includeLinePosition
	          );
	        }
	        getJsxClosingTag(args) {
	          const { file, languageService } = this.getFileAndLanguageServiceForSyntacticOperation(args);
	          const position = this.getPositionInFile(args, file);
	          const tag = languageService.getJsxClosingTagAtPosition(file, position);
	          return tag === void 0 ? void 0 : { newText: tag.newText, caretOffset: 0 };
	        }
	        getLinkedEditingRange(args) {
	          const { file, languageService } = this.getFileAndLanguageServiceForSyntacticOperation(args);
	          const position = this.getPositionInFile(args, file);
	          const linkedEditInfo = languageService.getLinkedEditingRangeAtPosition(file, position);
	          const scriptInfo = this.projectService.getScriptInfoForNormalizedPath(file);
	          if (scriptInfo === void 0 || linkedEditInfo === void 0)
	            return void 0;
	          return convertLinkedEditInfoToRanges(linkedEditInfo, scriptInfo);
	        }
	        getDocumentHighlights(args, simplifiedResult) {
	          const { file, project } = this.getFileAndProject(args);
	          const position = this.getPositionInFile(args, file);
	          const documentHighlights = project.getLanguageService().getDocumentHighlights(file, position, args.filesToSearch);
	          if (!documentHighlights)
	            return emptyArray2;
	          if (!simplifiedResult)
	            return documentHighlights;
	          return documentHighlights.map(({ fileName, highlightSpans }) => {
	            const scriptInfo = project.getScriptInfo(fileName);
	            return {
	              file: fileName,
	              highlightSpans: highlightSpans.map(({ textSpan, kind, contextSpan }) => ({
	                ...toProtocolTextSpanWithContext(textSpan, contextSpan, scriptInfo),
	                kind
	              }))
	            };
	          });
	        }
	        provideInlayHints(args) {
	          const { file, project } = this.getFileAndProject(args);
	          const scriptInfo = this.projectService.getScriptInfoForNormalizedPath(file);
	          const hints = project.getLanguageService().provideInlayHints(file, args, this.getPreferences(file));
	          return hints.map((hint) => {
	            const { position, displayParts } = hint;
	            return {
	              ...hint,
	              position: scriptInfo.positionToLineOffset(position),
	              displayParts: displayParts == null ? void 0 : displayParts.map(({ text, span, file: file2 }) => {
	                if (span) {
	                  Debug.assertIsDefined(file2, "Target file should be defined together with its span.");
	                  const scriptInfo2 = this.projectService.getScriptInfo(file2);
	                  return {
	                    text,
	                    span: {
	                      start: scriptInfo2.positionToLineOffset(span.start),
	                      end: scriptInfo2.positionToLineOffset(span.start + span.length),
	                      file: file2
	                    }
	                  };
	                } else {
	                  return { text };
	                }
	              })
	            };
	          });
	        }
	        setCompilerOptionsForInferredProjects(args) {
	          this.projectService.setCompilerOptionsForInferredProjects(args.options, args.projectRootPath);
	        }
	        getProjectInfo(args) {
	          return this.getProjectInfoWorker(
	            args.file,
	            args.projectFileName,
	            args.needFileNameList,
	            /*excludeConfigFiles*/
	            false
	          );
	        }
	        getProjectInfoWorker(uncheckedFileName, projectFileName, needFileNameList, excludeConfigFiles) {
	          const { project } = this.getFileAndProjectWorker(uncheckedFileName, projectFileName);
	          updateProjectIfDirty(project);
	          const projectInfo = {
	            configFileName: project.getProjectName(),
	            languageServiceDisabled: !project.languageServiceEnabled,
	            fileNames: needFileNameList ? project.getFileNames(
	              /*excludeFilesFromExternalLibraries*/
	              false,
	              excludeConfigFiles
	            ) : void 0
	          };
	          return projectInfo;
	        }
	        getRenameInfo(args) {
	          const { file, project } = this.getFileAndProject(args);
	          const position = this.getPositionInFile(args, file);
	          const preferences = this.getPreferences(file);
	          return project.getLanguageService().getRenameInfo(file, position, preferences);
	        }
	        getProjects(args, getScriptInfoEnsuringProjectsUptoDate, ignoreNoProjectError) {
	          let projects;
	          let symLinkedProjects;
	          if (args.projectFileName) {
	            const project = this.getProject(args.projectFileName);
	            if (project) {
	              projects = [project];
	            }
	          } else {
	            const scriptInfo = getScriptInfoEnsuringProjectsUptoDate ? this.projectService.getScriptInfoEnsuringProjectsUptoDate(args.file) : this.projectService.getScriptInfo(args.file);
	            if (!scriptInfo) {
	              if (ignoreNoProjectError)
	                return emptyArray2;
	              this.projectService.logErrorForScriptInfoNotFound(args.file);
	              return Errors.ThrowNoProject();
	            } else if (!getScriptInfoEnsuringProjectsUptoDate) {
	              this.projectService.ensureDefaultProjectForFile(scriptInfo);
	            }
	            projects = scriptInfo.containingProjects;
	            symLinkedProjects = this.projectService.getSymlinkedProjects(scriptInfo);
	          }
	          projects = filter(projects, (p) => p.languageServiceEnabled && !p.isOrphan());
	          if (!ignoreNoProjectError && (!projects || !projects.length) && !symLinkedProjects) {
	            this.projectService.logErrorForScriptInfoNotFound(args.file ?? args.projectFileName);
	            return Errors.ThrowNoProject();
	          }
	          return symLinkedProjects ? { projects, symLinkedProjects } : projects;
	        }
	        getDefaultProject(args) {
	          if (args.projectFileName) {
	            const project = this.getProject(args.projectFileName);
	            if (project) {
	              return project;
	            }
	            if (!args.file) {
	              return Errors.ThrowNoProject();
	            }
	          }
	          const info = this.projectService.getScriptInfo(args.file);
	          return info.getDefaultProject();
	        }
	        getRenameLocations(args, simplifiedResult) {
	          const file = toNormalizedPath(args.file);
	          const position = this.getPositionInFile(args, file);
	          const projects = this.getProjects(args);
	          const defaultProject = this.getDefaultProject(args);
	          const preferences = this.getPreferences(file);
	          const renameInfo = this.mapRenameInfo(
	            defaultProject.getLanguageService().getRenameInfo(file, position, preferences),
	            Debug.checkDefined(this.projectService.getScriptInfo(file))
	          );
	          if (!renameInfo.canRename)
	            return simplifiedResult ? { info: renameInfo, locs: [] } : [];
	          const locations = getRenameLocationsWorker(
	            projects,
	            defaultProject,
	            { fileName: args.file, pos: position },
	            !!args.findInStrings,
	            !!args.findInComments,
	            preferences,
	            this.host.useCaseSensitiveFileNames
	          );
	          if (!simplifiedResult)
	            return locations;
	          return { info: renameInfo, locs: this.toSpanGroups(locations) };
	        }
	        mapRenameInfo(info, scriptInfo) {
	          if (info.canRename) {
	            const { canRename, fileToRename, displayName, fullDisplayName, kind, kindModifiers, triggerSpan } = info;
	            return identity(
	              { canRename, fileToRename, displayName, fullDisplayName, kind, kindModifiers, triggerSpan: toProtocolTextSpan(triggerSpan, scriptInfo) }
	            );
	          } else {
	            return info;
	          }
	        }
	        toSpanGroups(locations) {
	          const map2 = /* @__PURE__ */ new Map();
	          for (const { fileName, textSpan, contextSpan, originalContextSpan: _2, originalTextSpan: _, originalFileName: _1, ...prefixSuffixText } of locations) {
	            let group2 = map2.get(fileName);
	            if (!group2)
	              map2.set(fileName, group2 = { file: fileName, locs: [] });
	            const scriptInfo = Debug.checkDefined(this.projectService.getScriptInfo(fileName));
	            group2.locs.push({ ...toProtocolTextSpanWithContext(textSpan, contextSpan, scriptInfo), ...prefixSuffixText });
	          }
	          return arrayFrom(map2.values());
	        }
	        getReferences(args, simplifiedResult) {
	          const file = toNormalizedPath(args.file);
	          const projects = this.getProjects(args);
	          const position = this.getPositionInFile(args, file);
	          const references = getReferencesWorker(
	            projects,
	            this.getDefaultProject(args),
	            { fileName: args.file, pos: position },
	            this.host.useCaseSensitiveFileNames,
	            this.logger
	          );
	          if (!simplifiedResult)
	            return references;
	          const preferences = this.getPreferences(file);
	          const defaultProject = this.getDefaultProject(args);
	          const scriptInfo = defaultProject.getScriptInfoForNormalizedPath(file);
	          const nameInfo = defaultProject.getLanguageService().getQuickInfoAtPosition(file, position);
	          const symbolDisplayString = nameInfo ? displayPartsToString(nameInfo.displayParts) : "";
	          const nameSpan = nameInfo && nameInfo.textSpan;
	          const symbolStartOffset = nameSpan ? scriptInfo.positionToLineOffset(nameSpan.start).offset : 0;
	          const symbolName2 = nameSpan ? scriptInfo.getSnapshot().getText(nameSpan.start, textSpanEnd(nameSpan)) : "";
	          const refs = flatMap(references, (referencedSymbol) => {
	            return referencedSymbol.references.map((entry) => referenceEntryToReferencesResponseItem(this.projectService, entry, preferences));
	          });
	          return { refs, symbolName: symbolName2, symbolStartOffset, symbolDisplayString };
	        }
	        getFileReferences(args, simplifiedResult) {
	          const projects = this.getProjects(args);
	          const fileName = args.file;
	          const preferences = this.getPreferences(toNormalizedPath(fileName));
	          const references = [];
	          const seen = createDocumentSpanSet(this.host.useCaseSensitiveFileNames);
	          forEachProjectInProjects(
	            projects,
	            /*path*/
	            void 0,
	            (project) => {
	              if (project.getCancellationToken().isCancellationRequested())
	                return;
	              const projectOutputs = project.getLanguageService().getFileReferences(fileName);
	              if (projectOutputs) {
	                for (const referenceEntry of projectOutputs) {
	                  if (!seen.has(referenceEntry)) {
	                    references.push(referenceEntry);
	                    seen.add(referenceEntry);
	                  }
	                }
	              }
	            }
	          );
	          if (!simplifiedResult)
	            return references;
	          const refs = references.map((entry) => referenceEntryToReferencesResponseItem(this.projectService, entry, preferences));
	          return {
	            refs,
	            symbolName: `"${args.file}"`
	          };
	        }
	        /**
	         * @param fileName is the name of the file to be opened
	         * @param fileContent is a version of the file content that is known to be more up to date than the one on disk
	         */
	        openClientFile(fileName, fileContent, scriptKind, projectRootPath) {
	          this.projectService.openClientFileWithNormalizedPath(
	            fileName,
	            fileContent,
	            scriptKind,
	            /*hasMixedContent*/
	            false,
	            projectRootPath
	          );
	        }
	        getPosition(args, scriptInfo) {
	          return args.position !== void 0 ? args.position : scriptInfo.lineOffsetToPosition(args.line, args.offset);
	        }
	        getPositionInFile(args, file) {
	          const scriptInfo = this.projectService.getScriptInfoForNormalizedPath(file);
	          return this.getPosition(args, scriptInfo);
	        }
	        getFileAndProject(args) {
	          return this.getFileAndProjectWorker(args.file, args.projectFileName);
	        }
	        getFileAndLanguageServiceForSyntacticOperation(args) {
	          const { file, project } = this.getFileAndProject(args);
	          return {
	            file,
	            languageService: project.getLanguageService(
	              /*ensureSynchronized*/
	              false
	            )
	          };
	        }
	        getFileAndProjectWorker(uncheckedFileName, projectFileName) {
	          const file = toNormalizedPath(uncheckedFileName);
	          const project = this.getProject(projectFileName) || this.projectService.ensureDefaultProjectForFile(file);
	          return { file, project };
	        }
	        getOutliningSpans(args, simplifiedResult) {
	          const { file, languageService } = this.getFileAndLanguageServiceForSyntacticOperation(args);
	          const spans = languageService.getOutliningSpans(file);
	          if (simplifiedResult) {
	            const scriptInfo = this.projectService.getScriptInfoForNormalizedPath(file);
	            return spans.map((s) => ({
	              textSpan: toProtocolTextSpan(s.textSpan, scriptInfo),
	              hintSpan: toProtocolTextSpan(s.hintSpan, scriptInfo),
	              bannerText: s.bannerText,
	              autoCollapse: s.autoCollapse,
	              kind: s.kind
	            }));
	          } else {
	            return spans;
	          }
	        }
	        getTodoComments(args) {
	          const { file, project } = this.getFileAndProject(args);
	          return project.getLanguageService().getTodoComments(file, args.descriptors);
	        }
	        getDocCommentTemplate(args) {
	          const { file, languageService } = this.getFileAndLanguageServiceForSyntacticOperation(args);
	          const position = this.getPositionInFile(args, file);
	          return languageService.getDocCommentTemplateAtPosition(file, position, this.getPreferences(file), this.getFormatOptions(file));
	        }
	        getSpanOfEnclosingComment(args) {
	          const { file, languageService } = this.getFileAndLanguageServiceForSyntacticOperation(args);
	          const onlyMultiLine = args.onlyMultiLine;
	          const position = this.getPositionInFile(args, file);
	          return languageService.getSpanOfEnclosingComment(file, position, onlyMultiLine);
	        }
	        getIndentation(args) {
	          const { file, languageService } = this.getFileAndLanguageServiceForSyntacticOperation(args);
	          const position = this.getPositionInFile(args, file);
	          const options = args.options ? convertFormatOptions(args.options) : this.getFormatOptions(file);
	          const indentation = languageService.getIndentationAtPosition(file, position, options);
	          return { position, indentation };
	        }
	        getBreakpointStatement(args) {
	          const { file, languageService } = this.getFileAndLanguageServiceForSyntacticOperation(args);
	          const position = this.getPositionInFile(args, file);
	          return languageService.getBreakpointStatementAtPosition(file, position);
	        }
	        getNameOrDottedNameSpan(args) {
	          const { file, languageService } = this.getFileAndLanguageServiceForSyntacticOperation(args);
	          const position = this.getPositionInFile(args, file);
	          return languageService.getNameOrDottedNameSpan(file, position, position);
	        }
	        isValidBraceCompletion(args) {
	          const { file, languageService } = this.getFileAndLanguageServiceForSyntacticOperation(args);
	          const position = this.getPositionInFile(args, file);
	          return languageService.isValidBraceCompletionAtPosition(file, position, args.openingBrace.charCodeAt(0));
	        }
	        getQuickInfoWorker(args, simplifiedResult) {
	          const { file, project } = this.getFileAndProject(args);
	          const scriptInfo = this.projectService.getScriptInfoForNormalizedPath(file);
	          const quickInfo = project.getLanguageService().getQuickInfoAtPosition(file, this.getPosition(args, scriptInfo));
	          if (!quickInfo) {
	            return void 0;
	          }
	          const useDisplayParts = !!this.getPreferences(file).displayPartsForJSDoc;
	          if (simplifiedResult) {
	            const displayString = displayPartsToString(quickInfo.displayParts);
	            return {
	              kind: quickInfo.kind,
	              kindModifiers: quickInfo.kindModifiers,
	              start: scriptInfo.positionToLineOffset(quickInfo.textSpan.start),
	              end: scriptInfo.positionToLineOffset(textSpanEnd(quickInfo.textSpan)),
	              displayString,
	              documentation: useDisplayParts ? this.mapDisplayParts(quickInfo.documentation, project) : displayPartsToString(quickInfo.documentation),
	              tags: this.mapJSDocTagInfo(quickInfo.tags, project, useDisplayParts)
	            };
	          } else {
	            return useDisplayParts ? quickInfo : {
	              ...quickInfo,
	              tags: this.mapJSDocTagInfo(
	                quickInfo.tags,
	                project,
	                /*richResponse*/
	                false
	              )
	            };
	          }
	        }
	        getFormattingEditsForRange(args) {
	          const { file, languageService } = this.getFileAndLanguageServiceForSyntacticOperation(args);
	          const scriptInfo = this.projectService.getScriptInfoForNormalizedPath(file);
	          const startPosition = scriptInfo.lineOffsetToPosition(args.line, args.offset);
	          const endPosition = scriptInfo.lineOffsetToPosition(args.endLine, args.endOffset);
	          const edits = languageService.getFormattingEditsForRange(file, startPosition, endPosition, this.getFormatOptions(file));
	          if (!edits) {
	            return void 0;
	          }
	          return edits.map((edit) => this.convertTextChangeToCodeEdit(edit, scriptInfo));
	        }
	        getFormattingEditsForRangeFull(args) {
	          const { file, languageService } = this.getFileAndLanguageServiceForSyntacticOperation(args);
	          const options = args.options ? convertFormatOptions(args.options) : this.getFormatOptions(file);
	          return languageService.getFormattingEditsForRange(file, args.position, args.endPosition, options);
	        }
	        getFormattingEditsForDocumentFull(args) {
	          const { file, languageService } = this.getFileAndLanguageServiceForSyntacticOperation(args);
	          const options = args.options ? convertFormatOptions(args.options) : this.getFormatOptions(file);
	          return languageService.getFormattingEditsForDocument(file, options);
	        }
	        getFormattingEditsAfterKeystrokeFull(args) {
	          const { file, languageService } = this.getFileAndLanguageServiceForSyntacticOperation(args);
	          const options = args.options ? convertFormatOptions(args.options) : this.getFormatOptions(file);
	          return languageService.getFormattingEditsAfterKeystroke(file, args.position, args.key, options);
	        }
	        getFormattingEditsAfterKeystroke(args) {
	          const { file, languageService } = this.getFileAndLanguageServiceForSyntacticOperation(args);
	          const scriptInfo = this.projectService.getScriptInfoForNormalizedPath(file);
	          const position = scriptInfo.lineOffsetToPosition(args.line, args.offset);
	          const formatOptions = this.getFormatOptions(file);
	          const edits = languageService.getFormattingEditsAfterKeystroke(file, position, args.key, formatOptions);
	          if (args.key === "\n" && (!edits || edits.length === 0 || allEditsBeforePos(edits, position))) {
	            const { lineText, absolutePosition } = scriptInfo.textStorage.getAbsolutePositionAndLineText(args.line);
	            if (lineText && lineText.search("\\S") < 0) {
	              const preferredIndent = languageService.getIndentationAtPosition(file, position, formatOptions);
	              let hasIndent = 0;
	              let i, len;
	              for (i = 0, len = lineText.length; i < len; i++) {
	                if (lineText.charAt(i) === " ") {
	                  hasIndent++;
	                } else if (lineText.charAt(i) === "	") {
	                  hasIndent += formatOptions.tabSize;
	                } else {
	                  break;
	                }
	              }
	              if (preferredIndent !== hasIndent) {
	                const firstNoWhiteSpacePosition = absolutePosition + i;
	                edits.push({
	                  span: createTextSpanFromBounds(absolutePosition, firstNoWhiteSpacePosition),
	                  newText: ts_formatting_exports.getIndentationString(preferredIndent, formatOptions)
	                });
	              }
	            }
	          }
	          if (!edits) {
	            return void 0;
	          }
	          return edits.map((edit) => {
	            return {
	              start: scriptInfo.positionToLineOffset(edit.span.start),
	              end: scriptInfo.positionToLineOffset(textSpanEnd(edit.span)),
	              newText: edit.newText ? edit.newText : ""
	            };
	          });
	        }
	        getCompletions(args, kind) {
	          const { file, project } = this.getFileAndProject(args);
	          const scriptInfo = this.projectService.getScriptInfoForNormalizedPath(file);
	          const position = this.getPosition(args, scriptInfo);
	          const completions = project.getLanguageService().getCompletionsAtPosition(
	            file,
	            position,
	            {
	              ...convertUserPreferences(this.getPreferences(file)),
	              triggerCharacter: args.triggerCharacter,
	              triggerKind: args.triggerKind,
	              includeExternalModuleExports: args.includeExternalModuleExports,
	              includeInsertTextCompletions: args.includeInsertTextCompletions
	            },
	            project.projectService.getFormatCodeOptions(file)
	          );
	          if (completions === void 0)
	            return void 0;
	          if (kind === "completions-full" /* CompletionsFull */)
	            return completions;
	          const prefix = args.prefix || "";
	          const entries = mapDefined(completions.entries, (entry) => {
	            if (completions.isMemberCompletion || startsWith(entry.name.toLowerCase(), prefix.toLowerCase())) {
	              const {
	                name,
	                kind: kind2,
	                kindModifiers,
	                sortText,
	                insertText,
	                filterText,
	                replacementSpan,
	                hasAction,
	                source,
	                sourceDisplay,
	                labelDetails,
	                isSnippet,
	                isRecommended,
	                isPackageJsonImport,
	                isImportStatementCompletion,
	                data
	              } = entry;
	              const convertedSpan = replacementSpan ? toProtocolTextSpan(replacementSpan, scriptInfo) : void 0;
	              return {
	                name,
	                kind: kind2,
	                kindModifiers,
	                sortText,
	                insertText,
	                filterText,
	                replacementSpan: convertedSpan,
	                isSnippet,
	                hasAction: hasAction || void 0,
	                source,
	                sourceDisplay,
	                labelDetails,
	                isRecommended,
	                isPackageJsonImport,
	                isImportStatementCompletion,
	                data
	              };
	            }
	          });
	          if (kind === "completions" /* Completions */) {
	            if (completions.metadata)
	              entries.metadata = completions.metadata;
	            return entries;
	          }
	          const res = {
	            ...completions,
	            optionalReplacementSpan: completions.optionalReplacementSpan && toProtocolTextSpan(completions.optionalReplacementSpan, scriptInfo),
	            entries
	          };
	          return res;
	        }
	        getCompletionEntryDetails(args, fullResult) {
	          const { file, project } = this.getFileAndProject(args);
	          const scriptInfo = this.projectService.getScriptInfoForNormalizedPath(file);
	          const position = this.getPosition(args, scriptInfo);
	          const formattingOptions = project.projectService.getFormatCodeOptions(file);
	          const useDisplayParts = !!this.getPreferences(file).displayPartsForJSDoc;
	          const result = mapDefined(args.entryNames, (entryName) => {
	            const { name, source, data } = typeof entryName === "string" ? { name: entryName, source: void 0, data: void 0 } : entryName;
	            return project.getLanguageService().getCompletionEntryDetails(file, position, name, formattingOptions, source, this.getPreferences(file), data ? cast(data, isCompletionEntryData) : void 0);
	          });
	          return fullResult ? useDisplayParts ? result : result.map((details) => ({ ...details, tags: this.mapJSDocTagInfo(
	            details.tags,
	            project,
	            /*richResponse*/
	            false
	          ) })) : result.map((details) => ({
	            ...details,
	            codeActions: map(details.codeActions, (action) => this.mapCodeAction(action)),
	            documentation: this.mapDisplayParts(details.documentation, project),
	            tags: this.mapJSDocTagInfo(details.tags, project, useDisplayParts)
	          }));
	        }
	        getCompileOnSaveAffectedFileList(args) {
	          const projects = this.getProjects(
	            args,
	            /*getScriptInfoEnsuringProjectsUptoDate*/
	            true,
	            /*ignoreNoProjectError*/
	            true
	          );
	          const info = this.projectService.getScriptInfo(args.file);
	          if (!info) {
	            return emptyArray2;
	          }
	          return combineProjectOutput(
	            info,
	            (path) => this.projectService.getScriptInfoForPath(path),
	            projects,
	            (project, info2) => {
	              if (!project.compileOnSaveEnabled || !project.languageServiceEnabled || project.isOrphan()) {
	                return void 0;
	              }
	              const compilationSettings = project.getCompilationSettings();
	              if (!!compilationSettings.noEmit || isDeclarationFileName(info2.fileName) && !dtsChangeCanAffectEmit(compilationSettings)) {
	                return void 0;
	              }
	              return {
	                projectFileName: project.getProjectName(),
	                fileNames: project.getCompileOnSaveAffectedFileList(info2),
	                projectUsesOutFile: !!outFile(compilationSettings)
	              };
	            }
	          );
	        }
	        emitFile(args) {
	          const { file, project } = this.getFileAndProject(args);
	          if (!project) {
	            Errors.ThrowNoProject();
	          }
	          if (!project.languageServiceEnabled) {
	            return args.richResponse ? { emitSkipped: true, diagnostics: [] } : false;
	          }
	          const scriptInfo = project.getScriptInfo(file);
	          const { emitSkipped, diagnostics } = project.emitFile(scriptInfo, (path, data, writeByteOrderMark) => this.host.writeFile(path, data, writeByteOrderMark));
	          return args.richResponse ? {
	            emitSkipped,
	            diagnostics: args.includeLinePosition ? this.convertToDiagnosticsWithLinePositionFromDiagnosticFile(diagnostics) : diagnostics.map((d) => formatDiagnosticToProtocol(
	              d,
	              /*includeFileName*/
	              true
	            ))
	          } : !emitSkipped;
	        }
	        getSignatureHelpItems(args, simplifiedResult) {
	          const { file, project } = this.getFileAndProject(args);
	          const scriptInfo = this.projectService.getScriptInfoForNormalizedPath(file);
	          const position = this.getPosition(args, scriptInfo);
	          const helpItems = project.getLanguageService().getSignatureHelpItems(file, position, args);
	          const useDisplayParts = !!this.getPreferences(file).displayPartsForJSDoc;
	          if (helpItems && simplifiedResult) {
	            const span = helpItems.applicableSpan;
	            return {
	              ...helpItems,
	              applicableSpan: {
	                start: scriptInfo.positionToLineOffset(span.start),
	                end: scriptInfo.positionToLineOffset(span.start + span.length)
	              },
	              items: this.mapSignatureHelpItems(helpItems.items, project, useDisplayParts)
	            };
	          } else if (useDisplayParts || !helpItems) {
	            return helpItems;
	          } else {
	            return {
	              ...helpItems,
	              items: helpItems.items.map((item) => ({ ...item, tags: this.mapJSDocTagInfo(
	                item.tags,
	                project,
	                /*richResponse*/
	                false
	              ) }))
	            };
	          }
	        }
	        toPendingErrorCheck(uncheckedFileName) {
	          const fileName = toNormalizedPath(uncheckedFileName);
	          const project = this.projectService.tryGetDefaultProjectForFile(fileName);
	          return project && { fileName, project };
	        }
	        getDiagnostics(next, delay, fileNames) {
	          if (this.suppressDiagnosticEvents) {
	            return;
	          }
	          if (fileNames.length > 0) {
	            this.updateErrorCheck(next, fileNames, delay);
	          }
	        }
	        change(args) {
	          const scriptInfo = this.projectService.getScriptInfo(args.file);
	          Debug.assert(!!scriptInfo);
	          scriptInfo.textStorage.switchToScriptVersionCache();
	          const start = scriptInfo.lineOffsetToPosition(args.line, args.offset);
	          const end = scriptInfo.lineOffsetToPosition(args.endLine, args.endOffset);
	          if (start >= 0) {
	            this.changeSeq++;
	            this.projectService.applyChangesToFile(
	              scriptInfo,
	              singleIterator({
	                span: { start, length: end - start },
	                newText: args.insertString
	                // TODO: GH#18217
	              })
	            );
	          }
	        }
	        reload(args, reqSeq) {
	          const file = toNormalizedPath(args.file);
	          const tempFileName = args.tmpfile === void 0 ? void 0 : toNormalizedPath(args.tmpfile);
	          const info = this.projectService.getScriptInfoForNormalizedPath(file);
	          if (info) {
	            this.changeSeq++;
	            if (info.reloadFromFile(tempFileName)) {
	              this.doOutput(
	                /*info*/
	                void 0,
	                "reload" /* Reload */,
	                reqSeq,
	                /*success*/
	                true
	              );
	            }
	          }
	        }
	        saveToTmp(fileName, tempFileName) {
	          const scriptInfo = this.projectService.getScriptInfo(fileName);
	          if (scriptInfo) {
	            scriptInfo.saveTo(tempFileName);
	          }
	        }
	        closeClientFile(fileName) {
	          if (!fileName) {
	            return;
	          }
	          const file = normalizePath(fileName);
	          this.projectService.closeClientFile(file);
	        }
	        mapLocationNavigationBarItems(items, scriptInfo) {
	          return map(items, (item) => ({
	            text: item.text,
	            kind: item.kind,
	            kindModifiers: item.kindModifiers,
	            spans: item.spans.map((span) => toProtocolTextSpan(span, scriptInfo)),
	            childItems: this.mapLocationNavigationBarItems(item.childItems, scriptInfo),
	            indent: item.indent
	          }));
	        }
	        getNavigationBarItems(args, simplifiedResult) {
	          const { file, languageService } = this.getFileAndLanguageServiceForSyntacticOperation(args);
	          const items = languageService.getNavigationBarItems(file);
	          return !items ? void 0 : simplifiedResult ? this.mapLocationNavigationBarItems(items, this.projectService.getScriptInfoForNormalizedPath(file)) : items;
	        }
	        toLocationNavigationTree(tree, scriptInfo) {
	          return {
	            text: tree.text,
	            kind: tree.kind,
	            kindModifiers: tree.kindModifiers,
	            spans: tree.spans.map((span) => toProtocolTextSpan(span, scriptInfo)),
	            nameSpan: tree.nameSpan && toProtocolTextSpan(tree.nameSpan, scriptInfo),
	            childItems: map(tree.childItems, (item) => this.toLocationNavigationTree(item, scriptInfo))
	          };
	        }
	        getNavigationTree(args, simplifiedResult) {
	          const { file, languageService } = this.getFileAndLanguageServiceForSyntacticOperation(args);
	          const tree = languageService.getNavigationTree(file);
	          return !tree ? void 0 : simplifiedResult ? this.toLocationNavigationTree(tree, this.projectService.getScriptInfoForNormalizedPath(file)) : tree;
	        }
	        getNavigateToItems(args, simplifiedResult) {
	          const full = this.getFullNavigateToItems(args);
	          return !simplifiedResult ? flatMap(full, ({ navigateToItems }) => navigateToItems) : flatMap(
	            full,
	            ({ project, navigateToItems }) => navigateToItems.map((navItem) => {
	              const scriptInfo = project.getScriptInfo(navItem.fileName);
	              const bakedItem = {
	                name: navItem.name,
	                kind: navItem.kind,
	                kindModifiers: navItem.kindModifiers,
	                isCaseSensitive: navItem.isCaseSensitive,
	                matchKind: navItem.matchKind,
	                file: navItem.fileName,
	                start: scriptInfo.positionToLineOffset(navItem.textSpan.start),
	                end: scriptInfo.positionToLineOffset(textSpanEnd(navItem.textSpan))
	              };
	              if (navItem.kindModifiers && navItem.kindModifiers !== "") {
	                bakedItem.kindModifiers = navItem.kindModifiers;
	              }
	              if (navItem.containerName && navItem.containerName.length > 0) {
	                bakedItem.containerName = navItem.containerName;
	              }
	              if (navItem.containerKind && navItem.containerKind.length > 0) {
	                bakedItem.containerKind = navItem.containerKind;
	              }
	              return bakedItem;
	            })
	          );
	        }
	        getFullNavigateToItems(args) {
	          const { currentFileOnly, searchValue, maxResultCount, projectFileName } = args;
	          if (currentFileOnly) {
	            Debug.assertIsDefined(args.file);
	            const { file, project } = this.getFileAndProject(args);
	            return [{ project, navigateToItems: project.getLanguageService().getNavigateToItems(searchValue, maxResultCount, file) }];
	          }
	          const preferences = this.getHostPreferences();
	          const outputs = [];
	          const seenItems = /* @__PURE__ */ new Map();
	          if (!args.file && !projectFileName) {
	            this.projectService.loadAncestorProjectTree();
	            this.projectService.forEachEnabledProject((project) => addItemsForProject(project));
	          } else {
	            const projects = this.getProjects(args);
	            forEachProjectInProjects(
	              projects,
	              /*path*/
	              void 0,
	              (project) => addItemsForProject(project)
	            );
	          }
	          return outputs;
	          function addItemsForProject(project) {
	            const projectItems = project.getLanguageService().getNavigateToItems(
	              searchValue,
	              maxResultCount,
	              /*fileName*/
	              void 0,
	              /*excludeDts*/
	              project.isNonTsProject(),
	              /*excludeLibFiles*/
	              preferences.excludeLibrarySymbolsInNavTo
	            );
	            const unseenItems = filter(projectItems, (item) => tryAddSeenItem(item) && !getMappedLocationForProject(documentSpanLocation(item), project));
	            if (unseenItems.length) {
	              outputs.push({ project, navigateToItems: unseenItems });
	            }
	          }
	          function tryAddSeenItem(item) {
	            const name = item.name;
	            if (!seenItems.has(name)) {
	              seenItems.set(name, [item]);
	              return true;
	            }
	            const seen = seenItems.get(name);
	            for (const seenItem of seen) {
	              if (navigateToItemIsEqualTo(seenItem, item)) {
	                return false;
	              }
	            }
	            seen.push(item);
	            return true;
	          }
	          function navigateToItemIsEqualTo(a, b) {
	            if (a === b) {
	              return true;
	            }
	            if (!a || !b) {
	              return false;
	            }
	            return a.containerKind === b.containerKind && a.containerName === b.containerName && a.fileName === b.fileName && a.isCaseSensitive === b.isCaseSensitive && a.kind === b.kind && a.kindModifiers === b.kindModifiers && a.matchKind === b.matchKind && a.name === b.name && a.textSpan.start === b.textSpan.start && a.textSpan.length === b.textSpan.length;
	          }
	        }
	        getSupportedCodeFixes(args) {
	          if (!args)
	            return getSupportedCodeFixes();
	          if (args.file) {
	            const { file, project: project2 } = this.getFileAndProject(args);
	            return project2.getLanguageService().getSupportedCodeFixes(file);
	          }
	          const project = this.getProject(args.projectFileName);
	          if (!project)
	            Errors.ThrowNoProject();
	          return project.getLanguageService().getSupportedCodeFixes();
	        }
	        isLocation(locationOrSpan) {
	          return locationOrSpan.line !== void 0;
	        }
	        extractPositionOrRange(args, scriptInfo) {
	          let position;
	          let textRange;
	          if (this.isLocation(args)) {
	            position = getPosition(args);
	          } else {
	            textRange = this.getRange(args, scriptInfo);
	          }
	          return Debug.checkDefined(position === void 0 ? textRange : position);
	          function getPosition(loc) {
	            return loc.position !== void 0 ? loc.position : scriptInfo.lineOffsetToPosition(loc.line, loc.offset);
	          }
	        }
	        getRange(args, scriptInfo) {
	          const { startPosition, endPosition } = this.getStartAndEndPosition(args, scriptInfo);
	          return { pos: startPosition, end: endPosition };
	        }
	        getApplicableRefactors(args) {
	          const { file, project } = this.getFileAndProject(args);
	          const scriptInfo = project.getScriptInfoForNormalizedPath(file);
	          return project.getLanguageService().getApplicableRefactors(file, this.extractPositionOrRange(args, scriptInfo), this.getPreferences(file), args.triggerReason, args.kind, args.includeInteractiveActions);
	        }
	        getEditsForRefactor(args, simplifiedResult) {
	          const { file, project } = this.getFileAndProject(args);
	          const scriptInfo = project.getScriptInfoForNormalizedPath(file);
	          const result = project.getLanguageService().getEditsForRefactor(
	            file,
	            this.getFormatOptions(file),
	            this.extractPositionOrRange(args, scriptInfo),
	            args.refactor,
	            args.action,
	            this.getPreferences(file),
	            args.interactiveRefactorArguments
	          );
	          if (result === void 0) {
	            return {
	              edits: []
	            };
	          }
	          if (simplifiedResult) {
	            const { renameFilename, renameLocation, edits } = result;
	            let mappedRenameLocation;
	            if (renameFilename !== void 0 && renameLocation !== void 0) {
	              const renameScriptInfo = project.getScriptInfoForNormalizedPath(toNormalizedPath(renameFilename));
	              mappedRenameLocation = getLocationInNewDocument(getSnapshotText(renameScriptInfo.getSnapshot()), renameFilename, renameLocation, edits);
	            }
	            return {
	              renameLocation: mappedRenameLocation,
	              renameFilename,
	              edits: this.mapTextChangesToCodeEdits(edits),
	              notApplicableReason: result.notApplicableReason
	            };
	          }
	          return result;
	        }
	        getMoveToRefactoringFileSuggestions(args) {
	          const { file, project } = this.getFileAndProject(args);
	          const scriptInfo = project.getScriptInfoForNormalizedPath(file);
	          return project.getLanguageService().getMoveToRefactoringFileSuggestions(file, this.extractPositionOrRange(args, scriptInfo), this.getPreferences(file));
	        }
	        organizeImports(args, simplifiedResult) {
	          Debug.assert(args.scope.type === "file");
	          const { file, project } = this.getFileAndProject(args.scope.args);
	          const changes = project.getLanguageService().organizeImports(
	            {
	              fileName: file,
	              mode: args.mode ?? (args.skipDestructiveCodeActions ? "SortAndCombine" /* SortAndCombine */ : void 0),
	              type: "file"
	            },
	            this.getFormatOptions(file),
	            this.getPreferences(file)
	          );
	          if (simplifiedResult) {
	            return this.mapTextChangesToCodeEdits(changes);
	          } else {
	            return changes;
	          }
	        }
	        getEditsForFileRename(args, simplifiedResult) {
	          const oldPath = toNormalizedPath(args.oldFilePath);
	          const newPath = toNormalizedPath(args.newFilePath);
	          const formatOptions = this.getHostFormatOptions();
	          const preferences = this.getHostPreferences();
	          const seenFiles = /* @__PURE__ */ new Set();
	          const textChanges2 = [];
	          this.projectService.loadAncestorProjectTree();
	          this.projectService.forEachEnabledProject((project) => {
	            const projectTextChanges = project.getLanguageService().getEditsForFileRename(oldPath, newPath, formatOptions, preferences);
	            const projectFiles = [];
	            for (const textChange of projectTextChanges) {
	              if (!seenFiles.has(textChange.fileName)) {
	                textChanges2.push(textChange);
	                projectFiles.push(textChange.fileName);
	              }
	            }
	            for (const file of projectFiles) {
	              seenFiles.add(file);
	            }
	          });
	          return simplifiedResult ? textChanges2.map((c) => this.mapTextChangeToCodeEdit(c)) : textChanges2;
	        }
	        getCodeFixes(args, simplifiedResult) {
	          const { file, project } = this.getFileAndProject(args);
	          const scriptInfo = project.getScriptInfoForNormalizedPath(file);
	          const { startPosition, endPosition } = this.getStartAndEndPosition(args, scriptInfo);
	          let codeActions;
	          try {
	            codeActions = project.getLanguageService().getCodeFixesAtPosition(file, startPosition, endPosition, args.errorCodes, this.getFormatOptions(file), this.getPreferences(file));
	          } catch (e) {
	            const ls = project.getLanguageService();
	            const existingDiagCodes = [
	              ...ls.getSyntacticDiagnostics(file),
	              ...ls.getSemanticDiagnostics(file),
	              ...ls.getSuggestionDiagnostics(file)
	            ].map(
	              (d) => decodedTextSpanIntersectsWith(startPosition, endPosition - startPosition, d.start, d.length) && d.code
	            );
	            const badCode = args.errorCodes.find((c) => !existingDiagCodes.includes(c));
	            if (badCode !== void 0) {
	              e.message = `BADCLIENT: Bad error code, ${badCode} not found in range ${startPosition}..${endPosition} (found: ${existingDiagCodes.join(", ")}); could have caused this error:
${e.message}`;
	            }
	            throw e;
	          }
	          return simplifiedResult ? codeActions.map((codeAction) => this.mapCodeFixAction(codeAction)) : codeActions;
	        }
	        getCombinedCodeFix({ scope, fixId: fixId52 }, simplifiedResult) {
	          Debug.assert(scope.type === "file");
	          const { file, project } = this.getFileAndProject(scope.args);
	          const res = project.getLanguageService().getCombinedCodeFix({ type: "file", fileName: file }, fixId52, this.getFormatOptions(file), this.getPreferences(file));
	          if (simplifiedResult) {
	            return { changes: this.mapTextChangesToCodeEdits(res.changes), commands: res.commands };
	          } else {
	            return res;
	          }
	        }
	        applyCodeActionCommand(args) {
	          const commands = args.command;
	          for (const command of toArray(commands)) {
	            const { file, project } = this.getFileAndProject(command);
	            project.getLanguageService().applyCodeActionCommand(command, this.getFormatOptions(file)).then(
	              (_result) => {
	              },
	              (_error) => {
	              }
	            );
	          }
	          return {};
	        }
	        getStartAndEndPosition(args, scriptInfo) {
	          let startPosition, endPosition;
	          if (args.startPosition !== void 0) {
	            startPosition = args.startPosition;
	          } else {
	            startPosition = scriptInfo.lineOffsetToPosition(args.startLine, args.startOffset);
	            args.startPosition = startPosition;
	          }
	          if (args.endPosition !== void 0) {
	            endPosition = args.endPosition;
	          } else {
	            endPosition = scriptInfo.lineOffsetToPosition(args.endLine, args.endOffset);
	            args.endPosition = endPosition;
	          }
	          return { startPosition, endPosition };
	        }
	        mapCodeAction({ description: description3, changes, commands }) {
	          return { description: description3, changes: this.mapTextChangesToCodeEdits(changes), commands };
	        }
	        mapCodeFixAction({ fixName: fixName8, description: description3, changes, commands, fixId: fixId52, fixAllDescription }) {
	          return { fixName: fixName8, description: description3, changes: this.mapTextChangesToCodeEdits(changes), commands, fixId: fixId52, fixAllDescription };
	        }
	        mapTextChangesToCodeEdits(textChanges2) {
	          return textChanges2.map((change) => this.mapTextChangeToCodeEdit(change));
	        }
	        mapTextChangeToCodeEdit(textChanges2) {
	          const scriptInfo = this.projectService.getScriptInfoOrConfig(textChanges2.fileName);
	          if (!!textChanges2.isNewFile === !!scriptInfo) {
	            if (!scriptInfo) {
	              this.projectService.logErrorForScriptInfoNotFound(textChanges2.fileName);
	            }
	            Debug.fail("Expected isNewFile for (only) new files. " + JSON.stringify({ isNewFile: !!textChanges2.isNewFile, hasScriptInfo: !!scriptInfo }));
	          }
	          return scriptInfo ? { fileName: textChanges2.fileName, textChanges: textChanges2.textChanges.map((textChange) => convertTextChangeToCodeEdit(textChange, scriptInfo)) } : convertNewFileTextChangeToCodeEdit(textChanges2);
	        }
	        convertTextChangeToCodeEdit(change, scriptInfo) {
	          return {
	            start: scriptInfo.positionToLineOffset(change.span.start),
	            end: scriptInfo.positionToLineOffset(change.span.start + change.span.length),
	            newText: change.newText ? change.newText : ""
	          };
	        }
	        getBraceMatching(args, simplifiedResult) {
	          const { file, languageService } = this.getFileAndLanguageServiceForSyntacticOperation(args);
	          const scriptInfo = this.projectService.getScriptInfoForNormalizedPath(file);
	          const position = this.getPosition(args, scriptInfo);
	          const spans = languageService.getBraceMatchingAtPosition(file, position);
	          return !spans ? void 0 : simplifiedResult ? spans.map((span) => toProtocolTextSpan(span, scriptInfo)) : spans;
	        }
	        getDiagnosticsForProject(next, delay, fileName) {
	          if (this.suppressDiagnosticEvents) {
	            return;
	          }
	          const { fileNames, languageServiceDisabled } = this.getProjectInfoWorker(
	            fileName,
	            /*projectFileName*/
	            void 0,
	            /*needFileNameList*/
	            true,
	            /*excludeConfigFiles*/
	            true
	          );
	          if (languageServiceDisabled) {
	            return;
	          }
	          const fileNamesInProject = fileNames.filter((value) => !value.includes("lib.d.ts"));
	          if (fileNamesInProject.length === 0) {
	            return;
	          }
	          const highPriorityFiles = [];
	          const mediumPriorityFiles = [];
	          const lowPriorityFiles = [];
	          const veryLowPriorityFiles = [];
	          const normalizedFileName = toNormalizedPath(fileName);
	          const project = this.projectService.ensureDefaultProjectForFile(normalizedFileName);
	          for (const fileNameInProject of fileNamesInProject) {
	            if (this.getCanonicalFileName(fileNameInProject) === this.getCanonicalFileName(fileName)) {
	              highPriorityFiles.push(fileNameInProject);
	            } else {
	              const info = this.projectService.getScriptInfo(fileNameInProject);
	              if (!info.isScriptOpen()) {
	                if (isDeclarationFileName(fileNameInProject)) {
	                  veryLowPriorityFiles.push(fileNameInProject);
	                } else {
	                  lowPriorityFiles.push(fileNameInProject);
	                }
	              } else {
	                mediumPriorityFiles.push(fileNameInProject);
	              }
	            }
	          }
	          const sortedFiles = [...highPriorityFiles, ...mediumPriorityFiles, ...lowPriorityFiles, ...veryLowPriorityFiles];
	          const checkList = sortedFiles.map((fileName2) => ({ fileName: fileName2, project }));
	          this.updateErrorCheck(
	            next,
	            checkList,
	            delay,
	            /*requireOpen*/
	            false
	          );
	        }
	        configurePlugin(args) {
	          this.projectService.configurePlugin(args);
	        }
	        getSmartSelectionRange(args, simplifiedResult) {
	          const { locations } = args;
	          const { file, languageService } = this.getFileAndLanguageServiceForSyntacticOperation(args);
	          const scriptInfo = Debug.checkDefined(this.projectService.getScriptInfo(file));
	          return map(locations, (location) => {
	            const pos = this.getPosition(location, scriptInfo);
	            const selectionRange = languageService.getSmartSelectionRange(file, pos);
	            return simplifiedResult ? this.mapSelectionRange(selectionRange, scriptInfo) : selectionRange;
	          });
	        }
	        toggleLineComment(args, simplifiedResult) {
	          const { file, languageService } = this.getFileAndLanguageServiceForSyntacticOperation(args);
	          const scriptInfo = this.projectService.getScriptInfo(file);
	          const textRange = this.getRange(args, scriptInfo);
	          const textChanges2 = languageService.toggleLineComment(file, textRange);
	          if (simplifiedResult) {
	            const scriptInfo2 = this.projectService.getScriptInfoForNormalizedPath(file);
	            return textChanges2.map((textChange) => this.convertTextChangeToCodeEdit(textChange, scriptInfo2));
	          }
	          return textChanges2;
	        }
	        toggleMultilineComment(args, simplifiedResult) {
	          const { file, languageService } = this.getFileAndLanguageServiceForSyntacticOperation(args);
	          const scriptInfo = this.projectService.getScriptInfoForNormalizedPath(file);
	          const textRange = this.getRange(args, scriptInfo);
	          const textChanges2 = languageService.toggleMultilineComment(file, textRange);
	          if (simplifiedResult) {
	            const scriptInfo2 = this.projectService.getScriptInfoForNormalizedPath(file);
	            return textChanges2.map((textChange) => this.convertTextChangeToCodeEdit(textChange, scriptInfo2));
	          }
	          return textChanges2;
	        }
	        commentSelection(args, simplifiedResult) {
	          const { file, languageService } = this.getFileAndLanguageServiceForSyntacticOperation(args);
	          const scriptInfo = this.projectService.getScriptInfoForNormalizedPath(file);
	          const textRange = this.getRange(args, scriptInfo);
	          const textChanges2 = languageService.commentSelection(file, textRange);
	          if (simplifiedResult) {
	            const scriptInfo2 = this.projectService.getScriptInfoForNormalizedPath(file);
	            return textChanges2.map((textChange) => this.convertTextChangeToCodeEdit(textChange, scriptInfo2));
	          }
	          return textChanges2;
	        }
	        uncommentSelection(args, simplifiedResult) {
	          const { file, languageService } = this.getFileAndLanguageServiceForSyntacticOperation(args);
	          const scriptInfo = this.projectService.getScriptInfoForNormalizedPath(file);
	          const textRange = this.getRange(args, scriptInfo);
	          const textChanges2 = languageService.uncommentSelection(file, textRange);
	          if (simplifiedResult) {
	            const scriptInfo2 = this.projectService.getScriptInfoForNormalizedPath(file);
	            return textChanges2.map((textChange) => this.convertTextChangeToCodeEdit(textChange, scriptInfo2));
	          }
	          return textChanges2;
	        }
	        mapSelectionRange(selectionRange, scriptInfo) {
	          const result = {
	            textSpan: toProtocolTextSpan(selectionRange.textSpan, scriptInfo)
	          };
	          if (selectionRange.parent) {
	            result.parent = this.mapSelectionRange(selectionRange.parent, scriptInfo);
	          }
	          return result;
	        }
	        getScriptInfoFromProjectService(file) {
	          const normalizedFile = toNormalizedPath(file);
	          const scriptInfo = this.projectService.getScriptInfoForNormalizedPath(normalizedFile);
	          if (!scriptInfo) {
	            this.projectService.logErrorForScriptInfoNotFound(normalizedFile);
	            return Errors.ThrowNoProject();
	          }
	          return scriptInfo;
	        }
	        toProtocolCallHierarchyItem(item) {
	          const scriptInfo = this.getScriptInfoFromProjectService(item.file);
	          return {
	            name: item.name,
	            kind: item.kind,
	            kindModifiers: item.kindModifiers,
	            file: item.file,
	            containerName: item.containerName,
	            span: toProtocolTextSpan(item.span, scriptInfo),
	            selectionSpan: toProtocolTextSpan(item.selectionSpan, scriptInfo)
	          };
	        }
	        toProtocolCallHierarchyIncomingCall(incomingCall) {
	          const scriptInfo = this.getScriptInfoFromProjectService(incomingCall.from.file);
	          return {
	            from: this.toProtocolCallHierarchyItem(incomingCall.from),
	            fromSpans: incomingCall.fromSpans.map((fromSpan) => toProtocolTextSpan(fromSpan, scriptInfo))
	          };
	        }
	        toProtocolCallHierarchyOutgoingCall(outgoingCall, scriptInfo) {
	          return {
	            to: this.toProtocolCallHierarchyItem(outgoingCall.to),
	            fromSpans: outgoingCall.fromSpans.map((fromSpan) => toProtocolTextSpan(fromSpan, scriptInfo))
	          };
	        }
	        prepareCallHierarchy(args) {
	          const { file, project } = this.getFileAndProject(args);
	          const scriptInfo = this.projectService.getScriptInfoForNormalizedPath(file);
	          if (scriptInfo) {
	            const position = this.getPosition(args, scriptInfo);
	            const result = project.getLanguageService().prepareCallHierarchy(file, position);
	            return result && mapOneOrMany(result, (item) => this.toProtocolCallHierarchyItem(item));
	          }
	          return void 0;
	        }
	        provideCallHierarchyIncomingCalls(args) {
	          const { file, project } = this.getFileAndProject(args);
	          const scriptInfo = this.getScriptInfoFromProjectService(file);
	          const incomingCalls = project.getLanguageService().provideCallHierarchyIncomingCalls(file, this.getPosition(args, scriptInfo));
	          return incomingCalls.map((call) => this.toProtocolCallHierarchyIncomingCall(call));
	        }
	        provideCallHierarchyOutgoingCalls(args) {
	          const { file, project } = this.getFileAndProject(args);
	          const scriptInfo = this.getScriptInfoFromProjectService(file);
	          const outgoingCalls = project.getLanguageService().provideCallHierarchyOutgoingCalls(file, this.getPosition(args, scriptInfo));
	          return outgoingCalls.map((call) => this.toProtocolCallHierarchyOutgoingCall(call, scriptInfo));
	        }
	        getCanonicalFileName(fileName) {
	          const name = this.host.useCaseSensitiveFileNames ? fileName : toFileNameLowerCase(fileName);
	          return normalizePath(name);
	        }
	        exit() {
	        }
	        notRequired() {
	          return { responseRequired: false };
	        }
	        requiredResponse(response) {
	          return { response, responseRequired: true };
	        }
	        addProtocolHandler(command, handler) {
	          if (this.handlers.has(command)) {
	            throw new Error(`Protocol handler already exists for command "${command}"`);
	          }
	          this.handlers.set(command, handler);
	        }
	        setCurrentRequest(requestId) {
	          Debug.assert(this.currentRequestId === void 0);
	          this.currentRequestId = requestId;
	          this.cancellationToken.setRequest(requestId);
	        }
	        resetCurrentRequest(requestId) {
	          Debug.assert(this.currentRequestId === requestId);
	          this.currentRequestId = void 0;
	          this.cancellationToken.resetRequest(requestId);
	        }
	        executeWithRequestId(requestId, f) {
	          try {
	            this.setCurrentRequest(requestId);
	            return f();
	          } finally {
	            this.resetCurrentRequest(requestId);
	          }
	        }
	        executeCommand(request) {
	          const handler = this.handlers.get(request.command);
	          if (handler) {
	            const response = this.executeWithRequestId(request.seq, () => handler(request));
	            this.projectService.enableRequestedPlugins();
	            return response;
	          } else {
	            this.logger.msg(`Unrecognized JSON command:${stringifyIndented(request)}`, "Err" /* Err */);
	            this.doOutput(
	              /*info*/
	              void 0,
	              "unknown" /* Unknown */,
	              request.seq,
	              /*success*/
	              false,
	              `Unrecognized JSON command: ${request.command}`
	            );
	            return { responseRequired: false };
	          }
	        }
	        onMessage(message) {
	          var _a, _b, _c, _d, _e, _f, _g, _h, _i, _j, _k;
	          this.gcTimer.scheduleCollect();
	          this.performanceData = void 0;
	          let start;
	          if (this.logger.hasLevel(2 /* requestTime */)) {
	            start = this.hrtime();
	            if (this.logger.hasLevel(3 /* verbose */)) {
	              this.logger.info(`request:${indent2(this.toStringMessage(message))}`);
	            }
	          }
	          let request;
	          let relevantFile;
	          try {
	            request = this.parseMessage(message);
	            relevantFile = request.arguments && request.arguments.file ? request.arguments : void 0;
	            (_a = tracing) == null ? void 0 : _a.instant(tracing.Phase.Session, "request", { seq: request.seq, command: request.command });
	            (_b = perfLogger) == null ? void 0 : _b.logStartCommand("" + request.command, this.toStringMessage(message).substring(0, 100));
	            (_c = tracing) == null ? void 0 : _c.push(
	              tracing.Phase.Session,
	              "executeCommand",
	              { seq: request.seq, command: request.command },
	              /*separateBeginAndEnd*/
	              true
	            );
	            const { response, responseRequired } = this.executeCommand(request);
	            (_d = tracing) == null ? void 0 : _d.pop();
	            if (this.logger.hasLevel(2 /* requestTime */)) {
	              const elapsedTime = hrTimeToMilliseconds(this.hrtime(start)).toFixed(4);
	              if (responseRequired) {
	                this.logger.perftrc(`${request.seq}::${request.command}: elapsed time (in milliseconds) ${elapsedTime}`);
	              } else {
	                this.logger.perftrc(`${request.seq}::${request.command}: async elapsed time (in milliseconds) ${elapsedTime}`);
	              }
	            }
	            (_e = perfLogger) == null ? void 0 : _e.logStopCommand("" + request.command, "Success");
	            (_f = tracing) == null ? void 0 : _f.instant(tracing.Phase.Session, "response", { seq: request.seq, command: request.command, success: !!response });
	            if (response) {
	              this.doOutput(
	                response,
	                request.command,
	                request.seq,
	                /*success*/
	                true
	              );
	            } else if (responseRequired) {
	              this.doOutput(
	                /*info*/
	                void 0,
	                request.command,
	                request.seq,
	                /*success*/
	                false,
	                "No content available."
	              );
	            }
	          } catch (err) {
	            (_g = tracing) == null ? void 0 : _g.popAll();
	            if (err instanceof OperationCanceledException) {
	              (_h = perfLogger) == null ? void 0 : _h.logStopCommand("" + (request && request.command), "Canceled: " + err);
	              (_i = tracing) == null ? void 0 : _i.instant(tracing.Phase.Session, "commandCanceled", { seq: request == null ? void 0 : request.seq, command: request == null ? void 0 : request.command });
	              this.doOutput(
	                { canceled: true },
	                request.command,
	                request.seq,
	                /*success*/
	                true
	              );
	              return;
	            }
	            this.logErrorWorker(err, this.toStringMessage(message), relevantFile);
	            (_j = perfLogger) == null ? void 0 : _j.logStopCommand("" + (request && request.command), "Error: " + err);
	            (_k = tracing) == null ? void 0 : _k.instant(tracing.Phase.Session, "commandError", { seq: request == null ? void 0 : request.seq, command: request == null ? void 0 : request.command, message: err.message });
	            this.doOutput(
	              /*info*/
	              void 0,
	              request ? request.command : "unknown" /* Unknown */,
	              request ? request.seq : 0,
	              /*success*/
	              false,
	              "Error processing request. " + err.message + "\n" + err.stack
	            );
	          }
	        }
	        parseMessage(message) {
	          return JSON.parse(message);
	        }
	        toStringMessage(message) {
	          return message;
	        }
	        getFormatOptions(file) {
	          return this.projectService.getFormatCodeOptions(file);
	        }
	        getPreferences(file) {
	          return this.projectService.getPreferences(file);
	        }
	        getHostFormatOptions() {
	          return this.projectService.getHostFormatCodeOptions();
	        }
	        getHostPreferences() {
	          return this.projectService.getHostPreferences();
	        }
	      };
	    }
	  });

	  // src/server/scriptVersionCache.ts
	  var lineCollectionCapacity, CharRangeSection, EditWalker, TextChange9, _ScriptVersionCache, ScriptVersionCache, LineIndexSnapshot, LineIndex, LineNode, LineLeaf;
	  var init_scriptVersionCache = __esm({
	    "src/server/scriptVersionCache.ts"() {
	      init_ts7();
	      init_ts_server3();
	      lineCollectionCapacity = 4;
	      CharRangeSection = /* @__PURE__ */ ((CharRangeSection2) => {
	        CharRangeSection2[CharRangeSection2["PreStart"] = 0] = "PreStart";
	        CharRangeSection2[CharRangeSection2["Start"] = 1] = "Start";
	        CharRangeSection2[CharRangeSection2["Entire"] = 2] = "Entire";
	        CharRangeSection2[CharRangeSection2["Mid"] = 3] = "Mid";
	        CharRangeSection2[CharRangeSection2["End"] = 4] = "End";
	        CharRangeSection2[CharRangeSection2["PostEnd"] = 5] = "PostEnd";
	        return CharRangeSection2;
	      })(CharRangeSection || {});
	      EditWalker = class {
	        constructor() {
	          this.goSubtree = true;
	          this.lineIndex = new LineIndex();
	          this.endBranch = [];
	          this.state = 2 /* Entire */;
	          this.initialText = "";
	          this.trailingText = "";
	          this.lineIndex.root = new LineNode();
	          this.startPath = [this.lineIndex.root];
	          this.stack = [this.lineIndex.root];
	        }
	        get done() {
	          return false;
	        }
	        insertLines(insertedText, suppressTrailingText) {
	          if (suppressTrailingText) {
	            this.trailingText = "";
	          }
	          if (insertedText) {
	            insertedText = this.initialText + insertedText + this.trailingText;
	          } else {
	            insertedText = this.initialText + this.trailingText;
	          }
	          const lm = LineIndex.linesFromText(insertedText);
	          const lines = lm.lines;
	          if (lines.length > 1 && lines[lines.length - 1] === "") {
	            lines.pop();
	          }
	          let branchParent;
	          let lastZeroCount;
	          for (let k = this.endBranch.length - 1; k >= 0; k--) {
	            this.endBranch[k].updateCounts();
	            if (this.endBranch[k].charCount() === 0) {
	              lastZeroCount = this.endBranch[k];
	              if (k > 0) {
	                branchParent = this.endBranch[k - 1];
	              } else {
	                branchParent = this.branchNode;
	              }
	            }
	          }
	          if (lastZeroCount) {
	            branchParent.remove(lastZeroCount);
	          }
	          const leafNode = this.startPath[this.startPath.length - 1];
	          if (lines.length > 0) {
	            leafNode.text = lines[0];
	            if (lines.length > 1) {
	              let insertedNodes = new Array(lines.length - 1);
	              let startNode2 = leafNode;
	              for (let i = 1; i < lines.length; i++) {
	                insertedNodes[i - 1] = new LineLeaf(lines[i]);
	              }
	              let pathIndex = this.startPath.length - 2;
	              while (pathIndex >= 0) {
	                const insertionNode = this.startPath[pathIndex];
	                insertedNodes = insertionNode.insertAt(startNode2, insertedNodes);
	                pathIndex--;
	                startNode2 = insertionNode;
	              }
	              let insertedNodesLen = insertedNodes.length;
	              while (insertedNodesLen > 0) {
	                const newRoot = new LineNode();
	                newRoot.add(this.lineIndex.root);
	                insertedNodes = newRoot.insertAt(this.lineIndex.root, insertedNodes);
	                insertedNodesLen = insertedNodes.length;
	                this.lineIndex.root = newRoot;
	              }
	              this.lineIndex.root.updateCounts();
	            } else {
	              for (let j = this.startPath.length - 2; j >= 0; j--) {
	                this.startPath[j].updateCounts();
	              }
	            }
	          } else {
	            const insertionNode = this.startPath[this.startPath.length - 2];
	            insertionNode.remove(leafNode);
	            for (let j = this.startPath.length - 2; j >= 0; j--) {
	              this.startPath[j].updateCounts();
	            }
	          }
	          return this.lineIndex;
	        }
	        post(_relativeStart, _relativeLength, lineCollection) {
	          if (lineCollection === this.lineCollectionAtBranch) {
	            this.state = 4 /* End */;
	          }
	          this.stack.pop();
	        }
	        pre(_relativeStart, _relativeLength, lineCollection, _parent, nodeType) {
	          const currentNode = this.stack[this.stack.length - 1];
	          if (this.state === 2 /* Entire */ && nodeType === 1 /* Start */) {
	            this.state = 1 /* Start */;
	            this.branchNode = currentNode;
	            this.lineCollectionAtBranch = lineCollection;
	          }
	          let child;
	          function fresh(node) {
	            if (node.isLeaf()) {
	              return new LineLeaf("");
	            } else
	              return new LineNode();
	          }
	          switch (nodeType) {
	            case 0 /* PreStart */:
	              this.goSubtree = false;
	              if (this.state !== 4 /* End */) {
	                currentNode.add(lineCollection);
	              }
	              break;
	            case 1 /* Start */:
	              if (this.state === 4 /* End */) {
	                this.goSubtree = false;
	              } else {
	                child = fresh(lineCollection);
	                currentNode.add(child);
	                this.startPath.push(child);
	              }
	              break;
	            case 2 /* Entire */:
	              if (this.state !== 4 /* End */) {
	                child = fresh(lineCollection);
	                currentNode.add(child);
	                this.startPath.push(child);
	              } else {
	                if (!lineCollection.isLeaf()) {
	                  child = fresh(lineCollection);
	                  currentNode.add(child);
	                  this.endBranch.push(child);
	                }
	              }
	              break;
	            case 3 /* Mid */:
	              this.goSubtree = false;
	              break;
	            case 4 /* End */:
	              if (this.state !== 4 /* End */) {
	                this.goSubtree = false;
	              } else {
	                if (!lineCollection.isLeaf()) {
	                  child = fresh(lineCollection);
	                  currentNode.add(child);
	                  this.endBranch.push(child);
	                }
	              }
	              break;
	            case 5 /* PostEnd */:
	              this.goSubtree = false;
	              if (this.state !== 1 /* Start */) {
	                currentNode.add(lineCollection);
	              }
	              break;
	          }
	          if (this.goSubtree) {
	            this.stack.push(child);
	          }
	        }
	        // just gather text from the leaves
	        leaf(relativeStart, relativeLength, ll) {
	          if (this.state === 1 /* Start */) {
	            this.initialText = ll.text.substring(0, relativeStart);
	          } else if (this.state === 2 /* Entire */) {
	            this.initialText = ll.text.substring(0, relativeStart);
	            this.trailingText = ll.text.substring(relativeStart + relativeLength);
	          } else {
	            this.trailingText = ll.text.substring(relativeStart + relativeLength);
	          }
	        }
	      };
	      TextChange9 = class {
	        constructor(pos, deleteLen, insertedText) {
	          this.pos = pos;
	          this.deleteLen = deleteLen;
	          this.insertedText = insertedText;
	        }
	        getTextChangeRange() {
	          return createTextChangeRange(createTextSpan(this.pos, this.deleteLen), this.insertedText ? this.insertedText.length : 0);
	        }
	      };
	      _ScriptVersionCache = class _ScriptVersionCache {
	        constructor() {
	          this.changes = [];
	          this.versions = new Array(_ScriptVersionCache.maxVersions);
	          this.minVersion = 0;
	          // no versions earlier than min version will maintain change history
	          this.currentVersion = 0;
	        }
	        versionToIndex(version2) {
	          if (version2 < this.minVersion || version2 > this.currentVersion) {
	            return void 0;
	          }
	          return version2 % _ScriptVersionCache.maxVersions;
	        }
	        currentVersionToIndex() {
	          return this.currentVersion % _ScriptVersionCache.maxVersions;
	        }
	        // REVIEW: can optimize by coalescing simple edits
	        edit(pos, deleteLen, insertedText) {
	          this.changes.push(new TextChange9(pos, deleteLen, insertedText));
	          if (this.changes.length > _ScriptVersionCache.changeNumberThreshold || deleteLen > _ScriptVersionCache.changeLengthThreshold || insertedText && insertedText.length > _ScriptVersionCache.changeLengthThreshold) {
	            this.getSnapshot();
	          }
	        }
	        getSnapshot() {
	          return this._getSnapshot();
	        }
	        _getSnapshot() {
	          let snap = this.versions[this.currentVersionToIndex()];
	          if (this.changes.length > 0) {
	            let snapIndex = snap.index;
	            for (const change of this.changes) {
	              snapIndex = snapIndex.edit(change.pos, change.deleteLen, change.insertedText);
	            }
	            snap = new LineIndexSnapshot(this.currentVersion + 1, this, snapIndex, this.changes);
	            this.currentVersion = snap.version;
	            this.versions[this.currentVersionToIndex()] = snap;
	            this.changes = [];
	            if (this.currentVersion - this.minVersion >= _ScriptVersionCache.maxVersions) {
	              this.minVersion = this.currentVersion - _ScriptVersionCache.maxVersions + 1;
	            }
	          }
	          return snap;
	        }
	        getSnapshotVersion() {
	          return this._getSnapshot().version;
	        }
	        getAbsolutePositionAndLineText(oneBasedLine) {
	          return this._getSnapshot().index.lineNumberToInfo(oneBasedLine);
	        }
	        lineOffsetToPosition(line, column) {
	          return this._getSnapshot().index.absolutePositionOfStartOfLine(line) + (column - 1);
	        }
	        positionToLineOffset(position) {
	          return this._getSnapshot().index.positionToLineOffset(position);
	        }
	        lineToTextSpan(line) {
	          const index = this._getSnapshot().index;
	          const { lineText, absolutePosition } = index.lineNumberToInfo(line + 1);
	          const len = lineText !== void 0 ? lineText.length : index.absolutePositionOfStartOfLine(line + 2) - absolutePosition;
	          return createTextSpan(absolutePosition, len);
	        }
	        getTextChangesBetweenVersions(oldVersion, newVersion) {
	          if (oldVersion < newVersion) {
	            if (oldVersion >= this.minVersion) {
	              const textChangeRanges = [];
	              for (let i = oldVersion + 1; i <= newVersion; i++) {
	                const snap = this.versions[this.versionToIndex(i)];
	                for (const textChange of snap.changesSincePreviousVersion) {
	                  textChangeRanges.push(textChange.getTextChangeRange());
	                }
	              }
	              return collapseTextChangeRangesAcrossMultipleVersions(textChangeRanges);
	            } else {
	              return void 0;
	            }
	          } else {
	            return unchangedTextChangeRange;
	          }
	        }
	        getLineCount() {
	          return this._getSnapshot().index.getLineCount();
	        }
	        static fromString(script) {
	          const svc = new _ScriptVersionCache();
	          const snap = new LineIndexSnapshot(0, svc, new LineIndex());
	          svc.versions[svc.currentVersion] = snap;
	          const lm = LineIndex.linesFromText(script);
	          snap.index.load(lm.lines);
	          return svc;
	        }
	      };
	      _ScriptVersionCache.changeNumberThreshold = 8;
	      _ScriptVersionCache.changeLengthThreshold = 256;
	      _ScriptVersionCache.maxVersions = 8;
	      ScriptVersionCache = _ScriptVersionCache;
	      LineIndexSnapshot = class _LineIndexSnapshot {
	        constructor(version2, cache, index, changesSincePreviousVersion = emptyArray2) {
	          this.version = version2;
	          this.cache = cache;
	          this.index = index;
	          this.changesSincePreviousVersion = changesSincePreviousVersion;
	        }
	        getText(rangeStart, rangeEnd) {
	          return this.index.getText(rangeStart, rangeEnd - rangeStart);
	        }
	        getLength() {
	          return this.index.getLength();
	        }
	        getChangeRange(oldSnapshot) {
	          if (oldSnapshot instanceof _LineIndexSnapshot && this.cache === oldSnapshot.cache) {
	            if (this.version <= oldSnapshot.version) {
	              return unchangedTextChangeRange;
	            } else {
	              return this.cache.getTextChangesBetweenVersions(oldSnapshot.version, this.version);
	            }
	          }
	        }
	      };
	      LineIndex = class _LineIndex {
	        constructor() {
	          // set this to true to check each edit for accuracy
	          this.checkEdits = false;
	        }
	        absolutePositionOfStartOfLine(oneBasedLine) {
	          return this.lineNumberToInfo(oneBasedLine).absolutePosition;
	        }
	        positionToLineOffset(position) {
	          const { oneBasedLine, zeroBasedColumn } = this.root.charOffsetToLineInfo(1, position);
	          return { line: oneBasedLine, offset: zeroBasedColumn + 1 };
	        }
	        positionToColumnAndLineText(position) {
	          return this.root.charOffsetToLineInfo(1, position);
	        }
	        getLineCount() {
	          return this.root.lineCount();
	        }
	        lineNumberToInfo(oneBasedLine) {
	          const lineCount = this.getLineCount();
	          if (oneBasedLine <= lineCount) {
	            const { position, leaf } = this.root.lineNumberToInfo(oneBasedLine, 0);
	            return { absolutePosition: position, lineText: leaf && leaf.text };
	          } else {
	            return { absolutePosition: this.root.charCount(), lineText: void 0 };
	          }
	        }
	        load(lines) {
	          if (lines.length > 0) {
	            const leaves = [];
	            for (let i = 0; i < lines.length; i++) {
	              leaves[i] = new LineLeaf(lines[i]);
	            }
	            this.root = _LineIndex.buildTreeFromBottom(leaves);
	          } else {
	            this.root = new LineNode();
	          }
	        }
	        walk(rangeStart, rangeLength, walkFns) {
	          this.root.walk(rangeStart, rangeLength, walkFns);
	        }
	        getText(rangeStart, rangeLength) {
	          let accum = "";
	          if (rangeLength > 0 && rangeStart < this.root.charCount()) {
	            this.walk(rangeStart, rangeLength, {
	              goSubtree: true,
	              done: false,
	              leaf: (relativeStart, relativeLength, ll) => {
	                accum = accum.concat(ll.text.substring(relativeStart, relativeStart + relativeLength));
	              }
	            });
	          }
	          return accum;
	        }
	        getLength() {
	          return this.root.charCount();
	        }
	        every(f, rangeStart, rangeEnd) {
	          if (!rangeEnd) {
	            rangeEnd = this.root.charCount();
	          }
	          const walkFns = {
	            goSubtree: true,
	            done: false,
	            leaf(relativeStart, relativeLength, ll) {
	              if (!f(ll, relativeStart, relativeLength)) {
	                this.done = true;
	              }
	            }
	          };
	          this.walk(rangeStart, rangeEnd - rangeStart, walkFns);
	          return !walkFns.done;
	        }
	        edit(pos, deleteLength, newText) {
	          if (this.root.charCount() === 0) {
	            Debug.assert(deleteLength === 0);
	            if (newText !== void 0) {
	              this.load(_LineIndex.linesFromText(newText).lines);
	              return this;
	            }
	            return void 0;
	          } else {
	            let checkText;
	            if (this.checkEdits) {
	              const source = this.getText(0, this.root.charCount());
	              checkText = source.slice(0, pos) + newText + source.slice(pos + deleteLength);
	            }
	            const walker = new EditWalker();
	            let suppressTrailingText = false;
	            if (pos >= this.root.charCount()) {
	              pos = this.root.charCount() - 1;
	              const endString = this.getText(pos, 1);
	              if (newText) {
	                newText = endString + newText;
	              } else {
	                newText = endString;
	              }
	              deleteLength = 0;
	              suppressTrailingText = true;
	            } else if (deleteLength > 0) {
	              const e = pos + deleteLength;
	              const { zeroBasedColumn, lineText } = this.positionToColumnAndLineText(e);
	              if (zeroBasedColumn === 0) {
	                deleteLength += lineText.length;
	                newText = newText ? newText + lineText : lineText;
	              }
	            }
	            this.root.walk(pos, deleteLength, walker);
	            walker.insertLines(newText, suppressTrailingText);
	            if (this.checkEdits) {
	              const updatedText = walker.lineIndex.getText(0, walker.lineIndex.getLength());
	              Debug.assert(checkText === updatedText, "buffer edit mismatch");
	            }
	            return walker.lineIndex;
	          }
	        }
	        static buildTreeFromBottom(nodes) {
	          if (nodes.length < lineCollectionCapacity) {
	            return new LineNode(nodes);
	          }
	          const interiorNodes = new Array(Math.ceil(nodes.length / lineCollectionCapacity));
	          let nodeIndex = 0;
	          for (let i = 0; i < interiorNodes.length; i++) {
	            const end = Math.min(nodeIndex + lineCollectionCapacity, nodes.length);
	            interiorNodes[i] = new LineNode(nodes.slice(nodeIndex, end));
	            nodeIndex = end;
	          }
	          return this.buildTreeFromBottom(interiorNodes);
	        }
	        static linesFromText(text) {
	          const lineMap = computeLineStarts(text);
	          if (lineMap.length === 0) {
	            return { lines: [], lineMap };
	          }
	          const lines = new Array(lineMap.length);
	          const lc = lineMap.length - 1;
	          for (let lmi = 0; lmi < lc; lmi++) {
	            lines[lmi] = text.substring(lineMap[lmi], lineMap[lmi + 1]);
	          }
	          const endText = text.substring(lineMap[lc]);
	          if (endText.length > 0) {
	            lines[lc] = endText;
	          } else {
	            lines.pop();
	          }
	          return { lines, lineMap };
	        }
	      };
	      LineNode = class _LineNode {
	        constructor(children = []) {
	          this.children = children;
	          this.totalChars = 0;
	          this.totalLines = 0;
	          if (children.length)
	            this.updateCounts();
	        }
	        isLeaf() {
	          return false;
	        }
	        updateCounts() {
	          this.totalChars = 0;
	          this.totalLines = 0;
	          for (const child of this.children) {
	            this.totalChars += child.charCount();
	            this.totalLines += child.lineCount();
	          }
	        }
	        execWalk(rangeStart, rangeLength, walkFns, childIndex, nodeType) {
	          if (walkFns.pre) {
	            walkFns.pre(rangeStart, rangeLength, this.children[childIndex], this, nodeType);
	          }
	          if (walkFns.goSubtree) {
	            this.children[childIndex].walk(rangeStart, rangeLength, walkFns);
	            if (walkFns.post) {
	              walkFns.post(rangeStart, rangeLength, this.children[childIndex], this, nodeType);
	            }
	          } else {
	            walkFns.goSubtree = true;
	          }
	          return walkFns.done;
	        }
	        skipChild(relativeStart, relativeLength, childIndex, walkFns, nodeType) {
	          if (walkFns.pre && !walkFns.done) {
	            walkFns.pre(relativeStart, relativeLength, this.children[childIndex], this, nodeType);
	            walkFns.goSubtree = true;
	          }
	        }
	        walk(rangeStart, rangeLength, walkFns) {
	          let childIndex = 0;
	          let childCharCount = this.children[childIndex].charCount();
	          let adjustedStart = rangeStart;
	          while (adjustedStart >= childCharCount) {
	            this.skipChild(adjustedStart, rangeLength, childIndex, walkFns, 0 /* PreStart */);
	            adjustedStart -= childCharCount;
	            childIndex++;
	            childCharCount = this.children[childIndex].charCount();
	          }
	          if (adjustedStart + rangeLength <= childCharCount) {
	            if (this.execWalk(adjustedStart, rangeLength, walkFns, childIndex, 2 /* Entire */)) {
	              return;
	            }
	          } else {
	            if (this.execWalk(adjustedStart, childCharCount - adjustedStart, walkFns, childIndex, 1 /* Start */)) {
	              return;
	            }
	            let adjustedLength = rangeLength - (childCharCount - adjustedStart);
	            childIndex++;
	            const child = this.children[childIndex];
	            childCharCount = child.charCount();
	            while (adjustedLength > childCharCount) {
	              if (this.execWalk(0, childCharCount, walkFns, childIndex, 3 /* Mid */)) {
	                return;
	              }
	              adjustedLength -= childCharCount;
	              childIndex++;
	              childCharCount = this.children[childIndex].charCount();
	            }
	            if (adjustedLength > 0) {
	              if (this.execWalk(0, adjustedLength, walkFns, childIndex, 4 /* End */)) {
	                return;
	              }
	            }
	          }
	          if (walkFns.pre) {
	            const clen = this.children.length;
	            if (childIndex < clen - 1) {
	              for (let ej = childIndex + 1; ej < clen; ej++) {
	                this.skipChild(0, 0, ej, walkFns, 5 /* PostEnd */);
	              }
	            }
	          }
	        }
	        // Input position is relative to the start of this node.
	        // Output line number is absolute.
	        charOffsetToLineInfo(lineNumberAccumulator, relativePosition) {
	          if (this.children.length === 0) {
	            return { oneBasedLine: lineNumberAccumulator, zeroBasedColumn: relativePosition, lineText: void 0 };
	          }
	          for (const child of this.children) {
	            if (child.charCount() > relativePosition) {
	              if (child.isLeaf()) {
	                return { oneBasedLine: lineNumberAccumulator, zeroBasedColumn: relativePosition, lineText: child.text };
	              } else {
	                return child.charOffsetToLineInfo(lineNumberAccumulator, relativePosition);
	              }
	            } else {
	              relativePosition -= child.charCount();
	              lineNumberAccumulator += child.lineCount();
	            }
	          }
	          const lineCount = this.lineCount();
	          if (lineCount === 0) {
	            return { oneBasedLine: 1, zeroBasedColumn: 0, lineText: void 0 };
	          }
	          const leaf = Debug.checkDefined(this.lineNumberToInfo(lineCount, 0).leaf);
	          return { oneBasedLine: lineCount, zeroBasedColumn: leaf.charCount(), lineText: void 0 };
	        }
	        /**
	         * Input line number is relative to the start of this node.
	         * Output line number is relative to the child.
	         * positionAccumulator will be an absolute position once relativeLineNumber reaches 0.
	         */
	        lineNumberToInfo(relativeOneBasedLine, positionAccumulator) {
	          for (const child of this.children) {
	            const childLineCount = child.lineCount();
	            if (childLineCount >= relativeOneBasedLine) {
	              return child.isLeaf() ? { position: positionAccumulator, leaf: child } : child.lineNumberToInfo(relativeOneBasedLine, positionAccumulator);
	            } else {
	              relativeOneBasedLine -= childLineCount;
	              positionAccumulator += child.charCount();
	            }
	          }
	          return { position: positionAccumulator, leaf: void 0 };
	        }
	        splitAfter(childIndex) {
	          let splitNode;
	          const clen = this.children.length;
	          childIndex++;
	          const endLength = childIndex;
	          if (childIndex < clen) {
	            splitNode = new _LineNode();
	            while (childIndex < clen) {
	              splitNode.add(this.children[childIndex]);
	              childIndex++;
	            }
	            splitNode.updateCounts();
	          }
	          this.children.length = endLength;
	          return splitNode;
	        }
	        remove(child) {
	          const childIndex = this.findChildIndex(child);
	          const clen = this.children.length;
	          if (childIndex < clen - 1) {
	            for (let i = childIndex; i < clen - 1; i++) {
	              this.children[i] = this.children[i + 1];
	            }
	          }
	          this.children.pop();
	        }
	        findChildIndex(child) {
	          const childIndex = this.children.indexOf(child);
	          Debug.assert(childIndex !== -1);
	          return childIndex;
	        }
	        insertAt(child, nodes) {
	          let childIndex = this.findChildIndex(child);
	          const clen = this.children.length;
	          const nodeCount = nodes.length;
	          if (clen < lineCollectionCapacity && childIndex === clen - 1 && nodeCount === 1) {
	            this.add(nodes[0]);
	            this.updateCounts();
	            return [];
	          } else {
	            const shiftNode = this.splitAfter(childIndex);
	            let nodeIndex = 0;
	            childIndex++;
	            while (childIndex < lineCollectionCapacity && nodeIndex < nodeCount) {
	              this.children[childIndex] = nodes[nodeIndex];
	              childIndex++;
	              nodeIndex++;
	            }
	            let splitNodes = [];
	            let splitNodeCount = 0;
	            if (nodeIndex < nodeCount) {
	              splitNodeCount = Math.ceil((nodeCount - nodeIndex) / lineCollectionCapacity);
	              splitNodes = new Array(splitNodeCount);
	              let splitNodeIndex = 0;
	              for (let i = 0; i < splitNodeCount; i++) {
	                splitNodes[i] = new _LineNode();
	              }
	              let splitNode = splitNodes[0];
	              while (nodeIndex < nodeCount) {
	                splitNode.add(nodes[nodeIndex]);
	                nodeIndex++;
	                if (splitNode.children.length === lineCollectionCapacity) {
	                  splitNodeIndex++;
	                  splitNode = splitNodes[splitNodeIndex];
	                }
	              }
	              for (let i = splitNodes.length - 1; i >= 0; i--) {
	                if (splitNodes[i].children.length === 0) {
	                  splitNodes.pop();
	                }
	              }
	            }
	            if (shiftNode) {
	              splitNodes.push(shiftNode);
	            }
	            this.updateCounts();
	            for (let i = 0; i < splitNodeCount; i++) {
	              splitNodes[i].updateCounts();
	            }
	            return splitNodes;
	          }
	        }
	        // assume there is room for the item; return true if more room
	        add(collection) {
	          this.children.push(collection);
	          Debug.assert(this.children.length <= lineCollectionCapacity);
	        }
	        charCount() {
	          return this.totalChars;
	        }
	        lineCount() {
	          return this.totalLines;
	        }
	      };
	      LineLeaf = class {
	        constructor(text) {
	          this.text = text;
	        }
	        isLeaf() {
	          return true;
	        }
	        walk(rangeStart, rangeLength, walkFns) {
	          walkFns.leaf(rangeStart, rangeLength, this);
	        }
	        charCount() {
	          return this.text.length;
	        }
	        lineCount() {
	          return 1;
	        }
	      };
	    }
	  });

	  // src/server/typingInstallerAdapter.ts
	  var _TypingsInstallerAdapter, TypingsInstallerAdapter;
	  var init_typingInstallerAdapter = __esm({
	    "src/server/typingInstallerAdapter.ts"() {
	      init_ts7();
	      init_ts_server3();
	      _TypingsInstallerAdapter = class _TypingsInstallerAdapter {
	        constructor(telemetryEnabled, logger, host, globalTypingsCacheLocation, event, maxActiveRequestCount) {
	          this.telemetryEnabled = telemetryEnabled;
	          this.logger = logger;
	          this.host = host;
	          this.globalTypingsCacheLocation = globalTypingsCacheLocation;
	          this.event = event;
	          this.maxActiveRequestCount = maxActiveRequestCount;
	          this.activeRequestCount = 0;
	          this.requestQueue = createQueue();
	          this.requestMap = /* @__PURE__ */ new Map();
	          // Maps project name to newest requestQueue entry for that project
	          /** We will lazily request the types registry on the first call to `isKnownTypesPackageName` and store it in `typesRegistryCache`. */
	          this.requestedRegistry = false;
	          this.packageInstallId = 0;
	        }
	        isKnownTypesPackageName(name) {
	          var _a;
	          const validationResult = ts_JsTyping_exports.validatePackageName(name);
	          if (validationResult !== ts_JsTyping_exports.NameValidationResult.Ok) {
	            return false;
	          }
	          if (!this.requestedRegistry) {
	            this.requestedRegistry = true;
	            this.installer.send({ kind: "typesRegistry" });
	          }
	          return !!((_a = this.typesRegistryCache) == null ? void 0 : _a.has(name));
	        }
	        installPackage(options) {
	          this.packageInstallId++;
	          const request = { kind: "installPackage", ...options, id: this.packageInstallId };
	          const promise = new Promise((resolve, reject) => {
	            (this.packageInstalledPromise ?? (this.packageInstalledPromise = /* @__PURE__ */ new Map())).set(this.packageInstallId, { resolve, reject });
	          });
	          this.installer.send(request);
	          return promise;
	        }
	        attach(projectService) {
	          this.projectService = projectService;
	          this.installer = this.createInstallerProcess();
	        }
	        onProjectClosed(p) {
	          this.installer.send({ projectName: p.getProjectName(), kind: "closeProject" });
	        }
	        enqueueInstallTypingsRequest(project, typeAcquisition, unresolvedImports) {
	          const request = createInstallTypingsRequest(project, typeAcquisition, unresolvedImports);
	          if (this.logger.hasLevel(3 /* verbose */)) {
	            this.logger.info(`TIAdapter:: Scheduling throttled operation:${stringifyIndented(request)}`);
	          }
	          if (this.activeRequestCount < this.maxActiveRequestCount) {
	            this.scheduleRequest(request);
	          } else {
	            if (this.logger.hasLevel(3 /* verbose */)) {
	              this.logger.info(`TIAdapter:: Deferring request for: ${request.projectName}`);
	            }
	            this.requestQueue.enqueue(request);
	            this.requestMap.set(request.projectName, request);
	          }
	        }
	        handleMessage(response) {
	          var _a, _b;
	          if (this.logger.hasLevel(3 /* verbose */)) {
	            this.logger.info(`TIAdapter:: Received response:${stringifyIndented(response)}`);
	          }
	          switch (response.kind) {
	            case EventTypesRegistry:
	              this.typesRegistryCache = new Map(Object.entries(response.typesRegistry));
	              break;
	            case ActionPackageInstalled: {
	              const promise = (_a = this.packageInstalledPromise) == null ? void 0 : _a.get(response.id);
	              Debug.assertIsDefined(promise, "Should find the promise for package install");
	              (_b = this.packageInstalledPromise) == null ? void 0 : _b.delete(response.id);
	              if (response.success) {
	                promise.resolve({ successMessage: response.message });
	              } else {
	                promise.reject(response.message);
	              }
	              this.projectService.updateTypingsForProject(response);
	              this.event(response, "setTypings");
	              break;
	            }
	            case EventInitializationFailed: {
	              const body = {
	                message: response.message
	              };
	              const eventName = "typesInstallerInitializationFailed";
	              this.event(body, eventName);
	              break;
	            }
	            case EventBeginInstallTypes: {
	              const body = {
	                eventId: response.eventId,
	                packages: response.packagesToInstall
	              };
	              const eventName = "beginInstallTypes";
	              this.event(body, eventName);
	              break;
	            }
	            case EventEndInstallTypes: {
	              if (this.telemetryEnabled) {
	                const body2 = {
	                  telemetryEventName: "typingsInstalled",
	                  payload: {
	                    installedPackages: response.packagesToInstall.join(","),
	                    installSuccess: response.installSuccess,
	                    typingsInstallerVersion: response.typingsInstallerVersion
	                  }
	                };
	                const eventName2 = "telemetry";
	                this.event(body2, eventName2);
	              }
	              const body = {
	                eventId: response.eventId,
	                packages: response.packagesToInstall,
	                success: response.installSuccess
	              };
	              const eventName = "endInstallTypes";
	              this.event(body, eventName);
	              break;
	            }
	            case ActionInvalidate: {
	              this.projectService.updateTypingsForProject(response);
	              break;
	            }
	            case ActionSet: {
	              if (this.activeRequestCount > 0) {
	                this.activeRequestCount--;
	              } else {
	                Debug.fail("TIAdapter:: Received too many responses");
	              }
	              while (!this.requestQueue.isEmpty()) {
	                const queuedRequest = this.requestQueue.dequeue();
	                if (this.requestMap.get(queuedRequest.projectName) === queuedRequest) {
	                  this.requestMap.delete(queuedRequest.projectName);
	                  this.scheduleRequest(queuedRequest);
	                  break;
	                }
	                if (this.logger.hasLevel(3 /* verbose */)) {
	                  this.logger.info(`TIAdapter:: Skipping defunct request for: ${queuedRequest.projectName}`);
	                }
	              }
	              this.projectService.updateTypingsForProject(response);
	              this.event(response, "setTypings");
	              break;
	            }
	            case ActionWatchTypingLocations:
	              this.projectService.watchTypingLocations(response);
	              break;
	          }
	        }
	        scheduleRequest(request) {
	          if (this.logger.hasLevel(3 /* verbose */)) {
	            this.logger.info(`TIAdapter:: Scheduling request for: ${request.projectName}`);
	          }
	          this.activeRequestCount++;
	          this.host.setTimeout(
	            () => {
	              if (this.logger.hasLevel(3 /* verbose */)) {
	                this.logger.info(`TIAdapter:: Sending request:${stringifyIndented(request)}`);
	              }
	              this.installer.send(request);
	            },
	            _TypingsInstallerAdapter.requestDelayMillis,
	            `${request.projectName}::${request.kind}`
	          );
	        }
	      };
	      // This number is essentially arbitrary.  Processing more than one typings request
	      // at a time makes sense, but having too many in the pipe results in a hang
	      // (see https://github.com/nodejs/node/issues/7657).
	      // It would be preferable to base our limit on the amount of space left in the
	      // buffer, but we have yet to find a way to retrieve that value.
	      _TypingsInstallerAdapter.requestDelayMillis = 100;
	      TypingsInstallerAdapter = _TypingsInstallerAdapter;
	    }
	  });

	  // src/server/_namespaces/ts.server.ts
	  var ts_server_exports3 = {};
	  __export(ts_server_exports3, {
	    ActionInvalidate: () => ActionInvalidate,
	    ActionPackageInstalled: () => ActionPackageInstalled,
	    ActionSet: () => ActionSet,
	    ActionWatchTypingLocations: () => ActionWatchTypingLocations,
	    Arguments: () => Arguments,
	    AutoImportProviderProject: () => AutoImportProviderProject,
	    AuxiliaryProject: () => AuxiliaryProject,
	    CharRangeSection: () => CharRangeSection,
	    CloseFileWatcherEvent: () => CloseFileWatcherEvent,
	    CommandNames: () => CommandNames,
	    ConfigFileDiagEvent: () => ConfigFileDiagEvent,
	    ConfiguredProject: () => ConfiguredProject2,
	    CreateDirectoryWatcherEvent: () => CreateDirectoryWatcherEvent,
	    CreateFileWatcherEvent: () => CreateFileWatcherEvent,
	    Errors: () => Errors,
	    EventBeginInstallTypes: () => EventBeginInstallTypes,
	    EventEndInstallTypes: () => EventEndInstallTypes,
	    EventInitializationFailed: () => EventInitializationFailed,
	    EventTypesRegistry: () => EventTypesRegistry,
	    ExternalProject: () => ExternalProject2,
	    GcTimer: () => GcTimer,
	    InferredProject: () => InferredProject2,
	    LargeFileReferencedEvent: () => LargeFileReferencedEvent,
	    LineIndex: () => LineIndex,
	    LineLeaf: () => LineLeaf,
	    LineNode: () => LineNode,
	    LogLevel: () => LogLevel2,
	    Msg: () => Msg,
	    OpenFileInfoTelemetryEvent: () => OpenFileInfoTelemetryEvent,
	    Project: () => Project3,
	    ProjectInfoTelemetryEvent: () => ProjectInfoTelemetryEvent,
	    ProjectKind: () => ProjectKind,
	    ProjectLanguageServiceStateEvent: () => ProjectLanguageServiceStateEvent,
	    ProjectLoadingFinishEvent: () => ProjectLoadingFinishEvent,
	    ProjectLoadingStartEvent: () => ProjectLoadingStartEvent,
	    ProjectReferenceProjectLoadKind: () => ProjectReferenceProjectLoadKind,
	    ProjectService: () => ProjectService3,
	    ProjectsUpdatedInBackgroundEvent: () => ProjectsUpdatedInBackgroundEvent,
	    ScriptInfo: () => ScriptInfo,
	    ScriptVersionCache: () => ScriptVersionCache,
	    Session: () => Session3,
	    TextStorage: () => TextStorage,
	    ThrottledOperations: () => ThrottledOperations,
	    TypingsCache: () => TypingsCache,
	    TypingsInstallerAdapter: () => TypingsInstallerAdapter,
	    allFilesAreJsOrDts: () => allFilesAreJsOrDts,
	    allRootFilesAreJsOrDts: () => allRootFilesAreJsOrDts,
	    asNormalizedPath: () => asNormalizedPath,
	    convertCompilerOptions: () => convertCompilerOptions,
	    convertFormatOptions: () => convertFormatOptions,
	    convertScriptKindName: () => convertScriptKindName,
	    convertTypeAcquisition: () => convertTypeAcquisition,
	    convertUserPreferences: () => convertUserPreferences,
	    convertWatchOptions: () => convertWatchOptions,
	    countEachFileTypes: () => countEachFileTypes,
	    createInstallTypingsRequest: () => createInstallTypingsRequest,
	    createModuleSpecifierCache: () => createModuleSpecifierCache,
	    createNormalizedPathMap: () => createNormalizedPathMap,
	    createPackageJsonCache: () => createPackageJsonCache,
	    createSortedArray: () => createSortedArray2,
	    emptyArray: () => emptyArray2,
	    findArgument: () => findArgument,
	    forEachResolvedProjectReferenceProject: () => forEachResolvedProjectReferenceProject,
	    formatDiagnosticToProtocol: () => formatDiagnosticToProtocol,
	    formatMessage: () => formatMessage2,
	    getBaseConfigFileName: () => getBaseConfigFileName,
	    getLocationInNewDocument: () => getLocationInNewDocument,
	    hasArgument: () => hasArgument,
	    hasNoTypeScriptSource: () => hasNoTypeScriptSource,
	    indent: () => indent2,
	    isBackgroundProject: () => isBackgroundProject,
	    isConfigFile: () => isConfigFile,
	    isConfiguredProject: () => isConfiguredProject,
	    isDynamicFileName: () => isDynamicFileName,
	    isExternalProject: () => isExternalProject,
	    isInferredProject: () => isInferredProject,
	    isInferredProjectName: () => isInferredProjectName,
	    makeAutoImportProviderProjectName: () => makeAutoImportProviderProjectName,
	    makeAuxiliaryProjectName: () => makeAuxiliaryProjectName,
	    makeInferredProjectName: () => makeInferredProjectName,
	    maxFileSize: () => maxFileSize,
	    maxProgramSizeForNonTsFiles: () => maxProgramSizeForNonTsFiles,
	    normalizedPathToPath: () => normalizedPathToPath,
	    nowString: () => nowString,
	    nullCancellationToken: () => nullCancellationToken,
	    nullTypingsInstaller: () => nullTypingsInstaller,
	    projectContainsInfoDirectly: () => projectContainsInfoDirectly,
	    protocol: () => ts_server_protocol_exports,
	    removeSorted: () => removeSorted,
	    stringifyIndented: () => stringifyIndented,
	    toEvent: () => toEvent,
	    toNormalizedPath: () => toNormalizedPath,
	    tryConvertScriptKindName: () => tryConvertScriptKindName,
	    typingsInstaller: () => ts_server_typingsInstaller_exports,
	    updateProjectIfDirty: () => updateProjectIfDirty
	  });
	  var init_ts_server3 = __esm({
	    "src/server/_namespaces/ts.server.ts"() {
	      init_ts_server();
	      init_ts_server2();
	      init_types4();
	      init_utilitiesPublic3();
	      init_utilities5();
	      init_ts_server_protocol();
	      init_scriptInfo();
	      init_typingsCache();
	      init_project();
	      init_editorServices();
	      init_moduleSpecifierCache();
	      init_packageJsonCache();
	      init_session();
	      init_scriptVersionCache();
	      init_typingInstallerAdapter();
	    }
	  });

	  // src/server/_namespaces/ts.ts
	  var ts_exports2 = {};
	  __export(ts_exports2, {
	    ANONYMOUS: () => ANONYMOUS,
	    AccessFlags: () => AccessFlags,
	    AssertionLevel: () => AssertionLevel,
	    AssignmentDeclarationKind: () => AssignmentDeclarationKind,
	    AssignmentKind: () => AssignmentKind,
	    Associativity: () => Associativity,
	    BreakpointResolver: () => ts_BreakpointResolver_exports,
	    BuilderFileEmit: () => BuilderFileEmit,
	    BuilderProgramKind: () => BuilderProgramKind,
	    BuilderState: () => BuilderState,
	    BundleFileSectionKind: () => BundleFileSectionKind,
	    CallHierarchy: () => ts_CallHierarchy_exports,
	    CharacterCodes: () => CharacterCodes,
	    CheckFlags: () => CheckFlags,
	    CheckMode: () => CheckMode,
	    ClassificationType: () => ClassificationType,
	    ClassificationTypeNames: () => ClassificationTypeNames,
	    CommentDirectiveType: () => CommentDirectiveType,
	    Comparison: () => Comparison,
	    CompletionInfoFlags: () => CompletionInfoFlags,
	    CompletionTriggerKind: () => CompletionTriggerKind,
	    Completions: () => ts_Completions_exports,
	    ContainerFlags: () => ContainerFlags,
	    ContextFlags: () => ContextFlags,
	    Debug: () => Debug,
	    DiagnosticCategory: () => DiagnosticCategory,
	    Diagnostics: () => Diagnostics,
	    DocumentHighlights: () => DocumentHighlights,
	    ElementFlags: () => ElementFlags,
	    EmitFlags: () => EmitFlags,
	    EmitHint: () => EmitHint,
	    EmitOnly: () => EmitOnly,
	    EndOfLineState: () => EndOfLineState,
	    EnumKind: () => EnumKind,
	    ExitStatus: () => ExitStatus,
	    ExportKind: () => ExportKind,
	    Extension: () => Extension,
	    ExternalEmitHelpers: () => ExternalEmitHelpers,
	    FileIncludeKind: () => FileIncludeKind,
	    FilePreprocessingDiagnosticsKind: () => FilePreprocessingDiagnosticsKind,
	    FileSystemEntryKind: () => FileSystemEntryKind,
	    FileWatcherEventKind: () => FileWatcherEventKind,
	    FindAllReferences: () => ts_FindAllReferences_exports,
	    FlattenLevel: () => FlattenLevel,
	    FlowFlags: () => FlowFlags,
	    ForegroundColorEscapeSequences: () => ForegroundColorEscapeSequences,
	    FunctionFlags: () => FunctionFlags,
	    GeneratedIdentifierFlags: () => GeneratedIdentifierFlags,
	    GetLiteralTextFlags: () => GetLiteralTextFlags,
	    GoToDefinition: () => ts_GoToDefinition_exports,
	    HighlightSpanKind: () => HighlightSpanKind,
	    IdentifierNameMap: () => IdentifierNameMap,
	    IdentifierNameMultiMap: () => IdentifierNameMultiMap,
	    ImportKind: () => ImportKind,
	    ImportsNotUsedAsValues: () => ImportsNotUsedAsValues,
	    IndentStyle: () => IndentStyle,
	    IndexFlags: () => IndexFlags,
	    IndexKind: () => IndexKind,
	    InferenceFlags: () => InferenceFlags,
	    InferencePriority: () => InferencePriority,
	    InlayHintKind: () => InlayHintKind,
	    InlayHints: () => ts_InlayHints_exports,
	    InternalEmitFlags: () => InternalEmitFlags,
	    InternalSymbolName: () => InternalSymbolName,
	    InvalidatedProjectKind: () => InvalidatedProjectKind,
	    JSDocParsingMode: () => JSDocParsingMode,
	    JsDoc: () => ts_JsDoc_exports,
	    JsTyping: () => ts_JsTyping_exports,
	    JsxEmit: () => JsxEmit,
	    JsxFlags: () => JsxFlags,
	    JsxReferenceKind: () => JsxReferenceKind,
	    LanguageServiceMode: () => LanguageServiceMode,
	    LanguageVariant: () => LanguageVariant,
	    LexicalEnvironmentFlags: () => LexicalEnvironmentFlags,
	    ListFormat: () => ListFormat,
	    LogLevel: () => LogLevel,
	    MemberOverrideStatus: () => MemberOverrideStatus,
	    ModifierFlags: () => ModifierFlags,
	    ModuleDetectionKind: () => ModuleDetectionKind,
	    ModuleInstanceState: () => ModuleInstanceState,
	    ModuleKind: () => ModuleKind,
	    ModuleResolutionKind: () => ModuleResolutionKind,
	    ModuleSpecifierEnding: () => ModuleSpecifierEnding,
	    NavigateTo: () => ts_NavigateTo_exports,
	    NavigationBar: () => ts_NavigationBar_exports,
	    NewLineKind: () => NewLineKind,
	    NodeBuilderFlags: () => NodeBuilderFlags,
	    NodeCheckFlags: () => NodeCheckFlags,
	    NodeFactoryFlags: () => NodeFactoryFlags,
	    NodeFlags: () => NodeFlags,
	    NodeResolutionFeatures: () => NodeResolutionFeatures,
	    ObjectFlags: () => ObjectFlags,
	    OperationCanceledException: () => OperationCanceledException,
	    OperatorPrecedence: () => OperatorPrecedence,
	    OrganizeImports: () => ts_OrganizeImports_exports,
	    OrganizeImportsMode: () => OrganizeImportsMode,
	    OuterExpressionKinds: () => OuterExpressionKinds,
	    OutliningElementsCollector: () => ts_OutliningElementsCollector_exports,
	    OutliningSpanKind: () => OutliningSpanKind,
	    OutputFileType: () => OutputFileType,
	    PackageJsonAutoImportPreference: () => PackageJsonAutoImportPreference,
	    PackageJsonDependencyGroup: () => PackageJsonDependencyGroup,
	    PatternMatchKind: () => PatternMatchKind,
	    PollingInterval: () => PollingInterval,
	    PollingWatchKind: () => PollingWatchKind,
	    PragmaKindFlags: () => PragmaKindFlags,
	    PrivateIdentifierKind: () => PrivateIdentifierKind,
	    ProcessLevel: () => ProcessLevel,
	    ProgramUpdateLevel: () => ProgramUpdateLevel,
	    QuotePreference: () => QuotePreference,
	    RelationComparisonResult: () => RelationComparisonResult,
	    Rename: () => ts_Rename_exports,
	    ScriptElementKind: () => ScriptElementKind,
	    ScriptElementKindModifier: () => ScriptElementKindModifier,
	    ScriptKind: () => ScriptKind,
	    ScriptSnapshot: () => ScriptSnapshot,
	    ScriptTarget: () => ScriptTarget,
	    SemanticClassificationFormat: () => SemanticClassificationFormat,
	    SemanticMeaning: () => SemanticMeaning,
	    SemicolonPreference: () => SemicolonPreference,
	    SignatureCheckMode: () => SignatureCheckMode,
	    SignatureFlags: () => SignatureFlags,
	    SignatureHelp: () => ts_SignatureHelp_exports,
	    SignatureKind: () => SignatureKind,
	    SmartSelectionRange: () => ts_SmartSelectionRange_exports,
	    SnippetKind: () => SnippetKind,
	    SortKind: () => SortKind,
	    StructureIsReused: () => StructureIsReused,
	    SymbolAccessibility: () => SymbolAccessibility,
	    SymbolDisplay: () => ts_SymbolDisplay_exports,
	    SymbolDisplayPartKind: () => SymbolDisplayPartKind,
	    SymbolFlags: () => SymbolFlags,
	    SymbolFormatFlags: () => SymbolFormatFlags,
	    SyntaxKind: () => SyntaxKind,
	    SyntheticSymbolKind: () => SyntheticSymbolKind,
	    Ternary: () => Ternary,
	    ThrottledCancellationToken: () => ThrottledCancellationToken,
	    TokenClass: () => TokenClass,
	    TokenFlags: () => TokenFlags,
	    TransformFlags: () => TransformFlags,
	    TypeFacts: () => TypeFacts,
	    TypeFlags: () => TypeFlags,
	    TypeFormatFlags: () => TypeFormatFlags,
	    TypeMapKind: () => TypeMapKind,
	    TypePredicateKind: () => TypePredicateKind,
	    TypeReferenceSerializationKind: () => TypeReferenceSerializationKind,
	    UnionReduction: () => UnionReduction,
	    UpToDateStatusType: () => UpToDateStatusType,
	    VarianceFlags: () => VarianceFlags,
	    Version: () => Version,
	    VersionRange: () => VersionRange,
	    WatchDirectoryFlags: () => WatchDirectoryFlags,
	    WatchDirectoryKind: () => WatchDirectoryKind,
	    WatchFileKind: () => WatchFileKind,
	    WatchLogLevel: () => WatchLogLevel,
	    WatchType: () => WatchType,
	    accessPrivateIdentifier: () => accessPrivateIdentifier,
	    addDisposableResourceHelper: () => addDisposableResourceHelper,
	    addEmitFlags: () => addEmitFlags,
	    addEmitHelper: () => addEmitHelper,
	    addEmitHelpers: () => addEmitHelpers,
	    addInternalEmitFlags: () => addInternalEmitFlags,
	    addNodeFactoryPatcher: () => addNodeFactoryPatcher,
	    addObjectAllocatorPatcher: () => addObjectAllocatorPatcher,
	    addRange: () => addRange,
	    addRelatedInfo: () => addRelatedInfo,
	    addSyntheticLeadingComment: () => addSyntheticLeadingComment,
	    addSyntheticTrailingComment: () => addSyntheticTrailingComment,
	    addToSeen: () => addToSeen,
	    advancedAsyncSuperHelper: () => advancedAsyncSuperHelper,
	    affectsDeclarationPathOptionDeclarations: () => affectsDeclarationPathOptionDeclarations,
	    affectsEmitOptionDeclarations: () => affectsEmitOptionDeclarations,
	    allKeysStartWithDot: () => allKeysStartWithDot,
	    altDirectorySeparator: () => altDirectorySeparator,
	    and: () => and,
	    append: () => append,
	    appendIfUnique: () => appendIfUnique,
	    arrayFrom: () => arrayFrom,
	    arrayIsEqualTo: () => arrayIsEqualTo,
	    arrayIsHomogeneous: () => arrayIsHomogeneous,
	    arrayIsSorted: () => arrayIsSorted,
	    arrayOf: () => arrayOf,
	    arrayReverseIterator: () => arrayReverseIterator,
	    arrayToMap: () => arrayToMap,
	    arrayToMultiMap: () => arrayToMultiMap,
	    arrayToNumericMap: () => arrayToNumericMap,
	    arraysEqual: () => arraysEqual,
	    assertType: () => assertType,
	    assign: () => assign,
	    assignHelper: () => assignHelper,
	    asyncDelegator: () => asyncDelegator,
	    asyncGeneratorHelper: () => asyncGeneratorHelper,
	    asyncSuperHelper: () => asyncSuperHelper,
	    asyncValues: () => asyncValues,
	    attachFileToDiagnostics: () => attachFileToDiagnostics,
	    awaitHelper: () => awaitHelper,
	    awaiterHelper: () => awaiterHelper,
	    base64decode: () => base64decode,
	    base64encode: () => base64encode,
	    binarySearch: () => binarySearch,
	    binarySearchKey: () => binarySearchKey,
	    bindSourceFile: () => bindSourceFile,
	    breakIntoCharacterSpans: () => breakIntoCharacterSpans,
	    breakIntoWordSpans: () => breakIntoWordSpans,
	    buildLinkParts: () => buildLinkParts,
	    buildOpts: () => buildOpts,
	    buildOverload: () => buildOverload,
	    bundlerModuleNameResolver: () => bundlerModuleNameResolver,
	    canBeConvertedToAsync: () => canBeConvertedToAsync,
	    canHaveDecorators: () => canHaveDecorators,
	    canHaveExportModifier: () => canHaveExportModifier,
	    canHaveFlowNode: () => canHaveFlowNode,
	    canHaveIllegalDecorators: () => canHaveIllegalDecorators,
	    canHaveIllegalModifiers: () => canHaveIllegalModifiers,
	    canHaveIllegalType: () => canHaveIllegalType,
	    canHaveIllegalTypeParameters: () => canHaveIllegalTypeParameters,
	    canHaveJSDoc: () => canHaveJSDoc,
	    canHaveLocals: () => canHaveLocals,
	    canHaveModifiers: () => canHaveModifiers,
	    canHaveSymbol: () => canHaveSymbol,
	    canJsonReportNoInputFiles: () => canJsonReportNoInputFiles,
	    canProduceDiagnostics: () => canProduceDiagnostics,
	    canUsePropertyAccess: () => canUsePropertyAccess,
	    canWatchAffectingLocation: () => canWatchAffectingLocation,
	    canWatchAtTypes: () => canWatchAtTypes,
	    canWatchDirectoryOrFile: () => canWatchDirectoryOrFile,
	    cartesianProduct: () => cartesianProduct,
	    cast: () => cast,
	    chainBundle: () => chainBundle,
	    chainDiagnosticMessages: () => chainDiagnosticMessages,
	    changeAnyExtension: () => changeAnyExtension,
	    changeCompilerHostLikeToUseCache: () => changeCompilerHostLikeToUseCache,
	    changeExtension: () => changeExtension,
	    changeFullExtension: () => changeFullExtension,
	    changesAffectModuleResolution: () => changesAffectModuleResolution,
	    changesAffectingProgramStructure: () => changesAffectingProgramStructure,
	    childIsDecorated: () => childIsDecorated,
	    classElementOrClassElementParameterIsDecorated: () => classElementOrClassElementParameterIsDecorated,
	    classHasClassThisAssignment: () => classHasClassThisAssignment,
	    classHasDeclaredOrExplicitlyAssignedName: () => classHasDeclaredOrExplicitlyAssignedName,
	    classHasExplicitlyAssignedName: () => classHasExplicitlyAssignedName,
	    classOrConstructorParameterIsDecorated: () => classOrConstructorParameterIsDecorated,
	    classPrivateFieldGetHelper: () => classPrivateFieldGetHelper,
	    classPrivateFieldInHelper: () => classPrivateFieldInHelper,
	    classPrivateFieldSetHelper: () => classPrivateFieldSetHelper,
	    classicNameResolver: () => classicNameResolver,
	    classifier: () => ts_classifier_exports,
	    cleanExtendedConfigCache: () => cleanExtendedConfigCache,
	    clear: () => clear,
	    clearMap: () => clearMap,
	    clearSharedExtendedConfigFileWatcher: () => clearSharedExtendedConfigFileWatcher,
	    climbPastPropertyAccess: () => climbPastPropertyAccess,
	    climbPastPropertyOrElementAccess: () => climbPastPropertyOrElementAccess,
	    clone: () => clone,
	    cloneCompilerOptions: () => cloneCompilerOptions,
	    closeFileWatcher: () => closeFileWatcher,
	    closeFileWatcherOf: () => closeFileWatcherOf,
	    codefix: () => ts_codefix_exports,
	    collapseTextChangeRangesAcrossMultipleVersions: () => collapseTextChangeRangesAcrossMultipleVersions,
	    collectExternalModuleInfo: () => collectExternalModuleInfo,
	    combine: () => combine,
	    combinePaths: () => combinePaths,
	    commentPragmas: () => commentPragmas,
	    commonOptionsWithBuild: () => commonOptionsWithBuild,
	    commonPackageFolders: () => commonPackageFolders,
	    compact: () => compact,
	    compareBooleans: () => compareBooleans,
	    compareDataObjects: () => compareDataObjects,
	    compareDiagnostics: () => compareDiagnostics,
	    compareDiagnosticsSkipRelatedInformation: () => compareDiagnosticsSkipRelatedInformation,
	    compareEmitHelpers: () => compareEmitHelpers,
	    compareNumberOfDirectorySeparators: () => compareNumberOfDirectorySeparators,
	    comparePaths: () => comparePaths,
	    comparePathsCaseInsensitive: () => comparePathsCaseInsensitive,
	    comparePathsCaseSensitive: () => comparePathsCaseSensitive,
	    comparePatternKeys: () => comparePatternKeys,
	    compareProperties: () => compareProperties,
	    compareStringsCaseInsensitive: () => compareStringsCaseInsensitive,
	    compareStringsCaseInsensitiveEslintCompatible: () => compareStringsCaseInsensitiveEslintCompatible,
	    compareStringsCaseSensitive: () => compareStringsCaseSensitive,
	    compareStringsCaseSensitiveUI: () => compareStringsCaseSensitiveUI,
	    compareTextSpans: () => compareTextSpans,
	    compareValues: () => compareValues,
	    compileOnSaveCommandLineOption: () => compileOnSaveCommandLineOption,
	    compilerOptionsAffectDeclarationPath: () => compilerOptionsAffectDeclarationPath,
	    compilerOptionsAffectEmit: () => compilerOptionsAffectEmit,
	    compilerOptionsAffectSemanticDiagnostics: () => compilerOptionsAffectSemanticDiagnostics,
	    compilerOptionsDidYouMeanDiagnostics: () => compilerOptionsDidYouMeanDiagnostics,
	    compilerOptionsIndicateEsModules: () => compilerOptionsIndicateEsModules,
	    compose: () => compose,
	    computeCommonSourceDirectoryOfFilenames: () => computeCommonSourceDirectoryOfFilenames,
	    computeLineAndCharacterOfPosition: () => computeLineAndCharacterOfPosition,
	    computeLineOfPosition: () => computeLineOfPosition,
	    computeLineStarts: () => computeLineStarts,
	    computePositionOfLineAndCharacter: () => computePositionOfLineAndCharacter,
	    computeSignature: () => computeSignature,
	    computeSignatureWithDiagnostics: () => computeSignatureWithDiagnostics,
	    computeSuggestionDiagnostics: () => computeSuggestionDiagnostics,
	    computedOptions: () => computedOptions,
	    concatenate: () => concatenate,
	    concatenateDiagnosticMessageChains: () => concatenateDiagnosticMessageChains,
	    consumesNodeCoreModules: () => consumesNodeCoreModules,
	    contains: () => contains,
	    containsIgnoredPath: () => containsIgnoredPath,
	    containsObjectRestOrSpread: () => containsObjectRestOrSpread,
	    containsParseError: () => containsParseError,
	    containsPath: () => containsPath,
	    convertCompilerOptionsForTelemetry: () => convertCompilerOptionsForTelemetry,
	    convertCompilerOptionsFromJson: () => convertCompilerOptionsFromJson,
	    convertJsonOption: () => convertJsonOption,
	    convertToBase64: () => convertToBase64,
	    convertToJson: () => convertToJson,
	    convertToObject: () => convertToObject,
	    convertToOptionsWithAbsolutePaths: () => convertToOptionsWithAbsolutePaths,
	    convertToRelativePath: () => convertToRelativePath,
	    convertToTSConfig: () => convertToTSConfig,
	    convertTypeAcquisitionFromJson: () => convertTypeAcquisitionFromJson,
	    copyComments: () => copyComments,
	    copyEntries: () => copyEntries,
	    copyLeadingComments: () => copyLeadingComments,
	    copyProperties: () => copyProperties,
	    copyTrailingAsLeadingComments: () => copyTrailingAsLeadingComments,
	    copyTrailingComments: () => copyTrailingComments,
	    couldStartTrivia: () => couldStartTrivia,
	    countWhere: () => countWhere,
	    createAbstractBuilder: () => createAbstractBuilder,
	    createAccessorPropertyBackingField: () => createAccessorPropertyBackingField,
	    createAccessorPropertyGetRedirector: () => createAccessorPropertyGetRedirector,
	    createAccessorPropertySetRedirector: () => createAccessorPropertySetRedirector,
	    createBaseNodeFactory: () => createBaseNodeFactory,
	    createBinaryExpressionTrampoline: () => createBinaryExpressionTrampoline,
	    createBindingHelper: () => createBindingHelper,
	    createBuildInfo: () => createBuildInfo,
	    createBuilderProgram: () => createBuilderProgram,
	    createBuilderProgramUsingProgramBuildInfo: () => createBuilderProgramUsingProgramBuildInfo,
	    createBuilderStatusReporter: () => createBuilderStatusReporter,
	    createCacheWithRedirects: () => createCacheWithRedirects,
	    createCacheableExportInfoMap: () => createCacheableExportInfoMap,
	    createCachedDirectoryStructureHost: () => createCachedDirectoryStructureHost,
	    createClassNamedEvaluationHelperBlock: () => createClassNamedEvaluationHelperBlock,
	    createClassThisAssignmentBlock: () => createClassThisAssignmentBlock,
	    createClassifier: () => createClassifier,
	    createCommentDirectivesMap: () => createCommentDirectivesMap,
	    createCompilerDiagnostic: () => createCompilerDiagnostic,
	    createCompilerDiagnosticForInvalidCustomType: () => createCompilerDiagnosticForInvalidCustomType,
	    createCompilerDiagnosticFromMessageChain: () => createCompilerDiagnosticFromMessageChain,
	    createCompilerHost: () => createCompilerHost,
	    createCompilerHostFromProgramHost: () => createCompilerHostFromProgramHost,
	    createCompilerHostWorker: () => createCompilerHostWorker,
	    createDetachedDiagnostic: () => createDetachedDiagnostic,
	    createDiagnosticCollection: () => createDiagnosticCollection,
	    createDiagnosticForFileFromMessageChain: () => createDiagnosticForFileFromMessageChain,
	    createDiagnosticForNode: () => createDiagnosticForNode,
	    createDiagnosticForNodeArray: () => createDiagnosticForNodeArray,
	    createDiagnosticForNodeArrayFromMessageChain: () => createDiagnosticForNodeArrayFromMessageChain,
	    createDiagnosticForNodeFromMessageChain: () => createDiagnosticForNodeFromMessageChain,
	    createDiagnosticForNodeInSourceFile: () => createDiagnosticForNodeInSourceFile,
	    createDiagnosticForRange: () => createDiagnosticForRange,
	    createDiagnosticMessageChainFromDiagnostic: () => createDiagnosticMessageChainFromDiagnostic,
	    createDiagnosticReporter: () => createDiagnosticReporter,
	    createDocumentPositionMapper: () => createDocumentPositionMapper,
	    createDocumentRegistry: () => createDocumentRegistry,
	    createDocumentRegistryInternal: () => createDocumentRegistryInternal,
	    createEmitAndSemanticDiagnosticsBuilderProgram: () => createEmitAndSemanticDiagnosticsBuilderProgram,
	    createEmitHelperFactory: () => createEmitHelperFactory,
	    createEmptyExports: () => createEmptyExports,
	    createExpressionForJsxElement: () => createExpressionForJsxElement,
	    createExpressionForJsxFragment: () => createExpressionForJsxFragment,
	    createExpressionForObjectLiteralElementLike: () => createExpressionForObjectLiteralElementLike,
	    createExpressionForPropertyName: () => createExpressionForPropertyName,
	    createExpressionFromEntityName: () => createExpressionFromEntityName,
	    createExternalHelpersImportDeclarationIfNeeded: () => createExternalHelpersImportDeclarationIfNeeded,
	    createFileDiagnostic: () => createFileDiagnostic,
	    createFileDiagnosticFromMessageChain: () => createFileDiagnosticFromMessageChain,
	    createForOfBindingStatement: () => createForOfBindingStatement,
	    createGetCanonicalFileName: () => createGetCanonicalFileName,
	    createGetSourceFile: () => createGetSourceFile,
	    createGetSymbolAccessibilityDiagnosticForNode: () => createGetSymbolAccessibilityDiagnosticForNode,
	    createGetSymbolAccessibilityDiagnosticForNodeName: () => createGetSymbolAccessibilityDiagnosticForNodeName,
	    createGetSymbolWalker: () => createGetSymbolWalker,
	    createIncrementalCompilerHost: () => createIncrementalCompilerHost,
	    createIncrementalProgram: () => createIncrementalProgram,
	    createInputFiles: () => createInputFiles,
	    createInputFilesWithFilePaths: () => createInputFilesWithFilePaths,
	    createInputFilesWithFileTexts: () => createInputFilesWithFileTexts,
	    createJsxFactoryExpression: () => createJsxFactoryExpression,
	    createLanguageService: () => createLanguageService,
	    createLanguageServiceSourceFile: () => createLanguageServiceSourceFile,
	    createMemberAccessForPropertyName: () => createMemberAccessForPropertyName,
	    createModeAwareCache: () => createModeAwareCache,
	    createModeAwareCacheKey: () => createModeAwareCacheKey,
	    createModuleNotFoundChain: () => createModuleNotFoundChain,
	    createModuleResolutionCache: () => createModuleResolutionCache,
	    createModuleResolutionLoader: () => createModuleResolutionLoader,
	    createModuleResolutionLoaderUsingGlobalCache: () => createModuleResolutionLoaderUsingGlobalCache,
	    createModuleSpecifierResolutionHost: () => createModuleSpecifierResolutionHost,
	    createMultiMap: () => createMultiMap,
	    createNodeConverters: () => createNodeConverters,
	    createNodeFactory: () => createNodeFactory,
	    createOptionNameMap: () => createOptionNameMap,
	    createOverload: () => createOverload,
	    createPackageJsonImportFilter: () => createPackageJsonImportFilter,
	    createPackageJsonInfo: () => createPackageJsonInfo,
	    createParenthesizerRules: () => createParenthesizerRules,
	    createPatternMatcher: () => createPatternMatcher,
	    createPrependNodes: () => createPrependNodes,
	    createPrinter: () => createPrinter,
	    createPrinterWithDefaults: () => createPrinterWithDefaults,
	    createPrinterWithRemoveComments: () => createPrinterWithRemoveComments,
	    createPrinterWithRemoveCommentsNeverAsciiEscape: () => createPrinterWithRemoveCommentsNeverAsciiEscape,
	    createPrinterWithRemoveCommentsOmitTrailingSemicolon: () => createPrinterWithRemoveCommentsOmitTrailingSemicolon,
	    createProgram: () => createProgram,
	    createProgramHost: () => createProgramHost,
	    createPropertyNameNodeForIdentifierOrLiteral: () => createPropertyNameNodeForIdentifierOrLiteral,
	    createQueue: () => createQueue,
	    createRange: () => createRange,
	    createRedirectedBuilderProgram: () => createRedirectedBuilderProgram,
	    createResolutionCache: () => createResolutionCache,
	    createRuntimeTypeSerializer: () => createRuntimeTypeSerializer,
	    createScanner: () => createScanner,
	    createSemanticDiagnosticsBuilderProgram: () => createSemanticDiagnosticsBuilderProgram,
	    createSet: () => createSet,
	    createSolutionBuilder: () => createSolutionBuilder,
	    createSolutionBuilderHost: () => createSolutionBuilderHost,
	    createSolutionBuilderWithWatch: () => createSolutionBuilderWithWatch,
	    createSolutionBuilderWithWatchHost: () => createSolutionBuilderWithWatchHost,
	    createSortedArray: () => createSortedArray,
	    createSourceFile: () => createSourceFile,
	    createSourceMapGenerator: () => createSourceMapGenerator,
	    createSourceMapSource: () => createSourceMapSource,
	    createSuperAccessVariableStatement: () => createSuperAccessVariableStatement,
	    createSymbolTable: () => createSymbolTable,
	    createSymlinkCache: () => createSymlinkCache,
	    createSystemWatchFunctions: () => createSystemWatchFunctions,
	    createTextChange: () => createTextChange,
	    createTextChangeFromStartLength: () => createTextChangeFromStartLength,
	    createTextChangeRange: () => createTextChangeRange,
	    createTextRangeFromNode: () => createTextRangeFromNode,
	    createTextRangeFromSpan: () => createTextRangeFromSpan,
	    createTextSpan: () => createTextSpan,
	    createTextSpanFromBounds: () => createTextSpanFromBounds,
	    createTextSpanFromNode: () => createTextSpanFromNode,
	    createTextSpanFromRange: () => createTextSpanFromRange,
	    createTextSpanFromStringLiteralLikeContent: () => createTextSpanFromStringLiteralLikeContent,
	    createTextWriter: () => createTextWriter,
	    createTokenRange: () => createTokenRange,
	    createTypeChecker: () => createTypeChecker,
	    createTypeReferenceDirectiveResolutionCache: () => createTypeReferenceDirectiveResolutionCache,
	    createTypeReferenceResolutionLoader: () => createTypeReferenceResolutionLoader,
	    createUnparsedSourceFile: () => createUnparsedSourceFile,
	    createWatchCompilerHost: () => createWatchCompilerHost2,
	    createWatchCompilerHostOfConfigFile: () => createWatchCompilerHostOfConfigFile,
	    createWatchCompilerHostOfFilesAndCompilerOptions: () => createWatchCompilerHostOfFilesAndCompilerOptions,
	    createWatchFactory: () => createWatchFactory,
	    createWatchHost: () => createWatchHost,
	    createWatchProgram: () => createWatchProgram,
	    createWatchStatusReporter: () => createWatchStatusReporter,
	    createWriteFileMeasuringIO: () => createWriteFileMeasuringIO,
	    declarationNameToString: () => declarationNameToString,
	    decodeMappings: () => decodeMappings,
	    decodedTextSpanIntersectsWith: () => decodedTextSpanIntersectsWith,
	    decorateHelper: () => decorateHelper,
	    deduplicate: () => deduplicate,
	    defaultIncludeSpec: () => defaultIncludeSpec,
	    defaultInitCompilerOptions: () => defaultInitCompilerOptions,
	    defaultMaximumTruncationLength: () => defaultMaximumTruncationLength,
	    detectSortCaseSensitivity: () => detectSortCaseSensitivity,
	    diagnosticCategoryName: () => diagnosticCategoryName,
	    diagnosticToString: () => diagnosticToString,
	    directoryProbablyExists: () => directoryProbablyExists,
	    directorySeparator: () => directorySeparator,
	    displayPart: () => displayPart,
	    displayPartsToString: () => displayPartsToString,
	    disposeEmitNodes: () => disposeEmitNodes,
	    disposeResourcesHelper: () => disposeResourcesHelper,
	    documentSpansEqual: () => documentSpansEqual,
	    dumpTracingLegend: () => dumpTracingLegend,
	    elementAt: () => elementAt,
	    elideNodes: () => elideNodes,
	    emitComments: () => emitComments,
	    emitDetachedComments: () => emitDetachedComments,
	    emitFiles: () => emitFiles,
	    emitFilesAndReportErrors: () => emitFilesAndReportErrors,
	    emitFilesAndReportErrorsAndGetExitStatus: () => emitFilesAndReportErrorsAndGetExitStatus,
	    emitModuleKindIsNonNodeESM: () => emitModuleKindIsNonNodeESM,
	    emitNewLineBeforeLeadingCommentOfPosition: () => emitNewLineBeforeLeadingCommentOfPosition,
	    emitNewLineBeforeLeadingComments: () => emitNewLineBeforeLeadingComments,
	    emitNewLineBeforeLeadingCommentsOfPosition: () => emitNewLineBeforeLeadingCommentsOfPosition,
	    emitSkippedWithNoDiagnostics: () => emitSkippedWithNoDiagnostics,
	    emitUsingBuildInfo: () => emitUsingBuildInfo,
	    emptyArray: () => emptyArray,
	    emptyFileSystemEntries: () => emptyFileSystemEntries,
	    emptyMap: () => emptyMap,
	    emptyOptions: () => emptyOptions,
	    emptySet: () => emptySet,
	    endsWith: () => endsWith,
	    ensurePathIsNonModuleName: () => ensurePathIsNonModuleName,
	    ensureScriptKind: () => ensureScriptKind,
	    ensureTrailingDirectorySeparator: () => ensureTrailingDirectorySeparator,
	    entityNameToString: () => entityNameToString,
	    enumerateInsertsAndDeletes: () => enumerateInsertsAndDeletes,
	    equalOwnProperties: () => equalOwnProperties,
	    equateStringsCaseInsensitive: () => equateStringsCaseInsensitive,
	    equateStringsCaseSensitive: () => equateStringsCaseSensitive,
	    equateValues: () => equateValues,
	    esDecorateHelper: () => esDecorateHelper,
	    escapeJsxAttributeString: () => escapeJsxAttributeString,
	    escapeLeadingUnderscores: () => escapeLeadingUnderscores,
	    escapeNonAsciiString: () => escapeNonAsciiString,
	    escapeSnippetText: () => escapeSnippetText,
	    escapeString: () => escapeString,
	    escapeTemplateSubstitution: () => escapeTemplateSubstitution,
	    every: () => every,
	    expandPreOrPostfixIncrementOrDecrementExpression: () => expandPreOrPostfixIncrementOrDecrementExpression,
	    explainFiles: () => explainFiles,
	    explainIfFileIsRedirectAndImpliedFormat: () => explainIfFileIsRedirectAndImpliedFormat,
	    exportAssignmentIsAlias: () => exportAssignmentIsAlias,
	    exportStarHelper: () => exportStarHelper,
	    expressionResultIsUnused: () => expressionResultIsUnused,
	    extend: () => extend,
	    extendsHelper: () => extendsHelper,
	    extensionFromPath: () => extensionFromPath,
	    extensionIsTS: () => extensionIsTS,
	    extensionsNotSupportingExtensionlessResolution: () => extensionsNotSupportingExtensionlessResolution,
	    externalHelpersModuleNameText: () => externalHelpersModuleNameText,
	    factory: () => factory,
	    fileExtensionIs: () => fileExtensionIs,
	    fileExtensionIsOneOf: () => fileExtensionIsOneOf,
	    fileIncludeReasonToDiagnostics: () => fileIncludeReasonToDiagnostics,
	    fileShouldUseJavaScriptRequire: () => fileShouldUseJavaScriptRequire,
	    filter: () => filter,
	    filterMutate: () => filterMutate,
	    filterSemanticDiagnostics: () => filterSemanticDiagnostics,
	    find: () => find,
	    findAncestor: () => findAncestor,
	    findBestPatternMatch: () => findBestPatternMatch,
	    findChildOfKind: () => findChildOfKind,
	    findComputedPropertyNameCacheAssignment: () => findComputedPropertyNameCacheAssignment,
	    findConfigFile: () => findConfigFile,
	    findContainingList: () => findContainingList,
	    findDiagnosticForNode: () => findDiagnosticForNode,
	    findFirstNonJsxWhitespaceToken: () => findFirstNonJsxWhitespaceToken,
	    findIndex: () => findIndex,
	    findLast: () => findLast,
	    findLastIndex: () => findLastIndex,
	    findListItemInfo: () => findListItemInfo,
	    findMap: () => findMap,
	    findModifier: () => findModifier,
	    findNextToken: () => findNextToken,
	    findPackageJson: () => findPackageJson,
	    findPackageJsons: () => findPackageJsons,
	    findPrecedingMatchingToken: () => findPrecedingMatchingToken,
	    findPrecedingToken: () => findPrecedingToken,
	    findSuperStatementIndexPath: () => findSuperStatementIndexPath,
	    findTokenOnLeftOfPosition: () => findTokenOnLeftOfPosition,
	    findUseStrictPrologue: () => findUseStrictPrologue,
	    first: () => first,
	    firstDefined: () => firstDefined,
	    firstDefinedIterator: () => firstDefinedIterator,
	    firstIterator: () => firstIterator,
	    firstOrOnly: () => firstOrOnly,
	    firstOrUndefined: () => firstOrUndefined,
	    firstOrUndefinedIterator: () => firstOrUndefinedIterator,
	    fixupCompilerOptions: () => fixupCompilerOptions,
	    flatMap: () => flatMap,
	    flatMapIterator: () => flatMapIterator,
	    flatMapToMutable: () => flatMapToMutable,
	    flatten: () => flatten,
	    flattenCommaList: () => flattenCommaList,
	    flattenDestructuringAssignment: () => flattenDestructuringAssignment,
	    flattenDestructuringBinding: () => flattenDestructuringBinding,
	    flattenDiagnosticMessageText: () => flattenDiagnosticMessageText,
	    forEach: () => forEach,
	    forEachAncestor: () => forEachAncestor,
	    forEachAncestorDirectory: () => forEachAncestorDirectory,
	    forEachChild: () => forEachChild,
	    forEachChildRecursively: () => forEachChildRecursively,
	    forEachEmittedFile: () => forEachEmittedFile,
	    forEachEnclosingBlockScopeContainer: () => forEachEnclosingBlockScopeContainer,
	    forEachEntry: () => forEachEntry,
	    forEachExternalModuleToImportFrom: () => forEachExternalModuleToImportFrom,
	    forEachImportClauseDeclaration: () => forEachImportClauseDeclaration,
	    forEachKey: () => forEachKey,
	    forEachLeadingCommentRange: () => forEachLeadingCommentRange,
	    forEachNameInAccessChainWalkingLeft: () => forEachNameInAccessChainWalkingLeft,
	    forEachPropertyAssignment: () => forEachPropertyAssignment,
	    forEachResolvedProjectReference: () => forEachResolvedProjectReference,
	    forEachReturnStatement: () => forEachReturnStatement,
	    forEachRight: () => forEachRight,
	    forEachTrailingCommentRange: () => forEachTrailingCommentRange,
	    forEachTsConfigPropArray: () => forEachTsConfigPropArray,
	    forEachUnique: () => forEachUnique,
	    forEachYieldExpression: () => forEachYieldExpression,
	    forSomeAncestorDirectory: () => forSomeAncestorDirectory,
	    formatColorAndReset: () => formatColorAndReset,
	    formatDiagnostic: () => formatDiagnostic,
	    formatDiagnostics: () => formatDiagnostics,
	    formatDiagnosticsWithColorAndContext: () => formatDiagnosticsWithColorAndContext,
	    formatGeneratedName: () => formatGeneratedName,
	    formatGeneratedNamePart: () => formatGeneratedNamePart,
	    formatLocation: () => formatLocation,
	    formatMessage: () => formatMessage,
	    formatStringFromArgs: () => formatStringFromArgs,
	    formatting: () => ts_formatting_exports,
	    fullTripleSlashAMDReferencePathRegEx: () => fullTripleSlashAMDReferencePathRegEx,
	    fullTripleSlashReferencePathRegEx: () => fullTripleSlashReferencePathRegEx,
	    generateDjb2Hash: () => generateDjb2Hash,
	    generateTSConfig: () => generateTSConfig,
	    generatorHelper: () => generatorHelper,
	    getAdjustedReferenceLocation: () => getAdjustedReferenceLocation,
	    getAdjustedRenameLocation: () => getAdjustedRenameLocation,
	    getAliasDeclarationFromName: () => getAliasDeclarationFromName,
	    getAllAccessorDeclarations: () => getAllAccessorDeclarations,
	    getAllDecoratorsOfClass: () => getAllDecoratorsOfClass,
	    getAllDecoratorsOfClassElement: () => getAllDecoratorsOfClassElement,
	    getAllJSDocTags: () => getAllJSDocTags,
	    getAllJSDocTagsOfKind: () => getAllJSDocTagsOfKind,
	    getAllKeys: () => getAllKeys,
	    getAllProjectOutputs: () => getAllProjectOutputs,
	    getAllSuperTypeNodes: () => getAllSuperTypeNodes,
	    getAllUnscopedEmitHelpers: () => getAllUnscopedEmitHelpers,
	    getAllowJSCompilerOption: () => getAllowJSCompilerOption,
	    getAllowSyntheticDefaultImports: () => getAllowSyntheticDefaultImports,
	    getAncestor: () => getAncestor,
	    getAnyExtensionFromPath: () => getAnyExtensionFromPath,
	    getAreDeclarationMapsEnabled: () => getAreDeclarationMapsEnabled,
	    getAssignedExpandoInitializer: () => getAssignedExpandoInitializer,
	    getAssignedName: () => getAssignedName,
	    getAssignedNameOfIdentifier: () => getAssignedNameOfIdentifier,
	    getAssignmentDeclarationKind: () => getAssignmentDeclarationKind,
	    getAssignmentDeclarationPropertyAccessKind: () => getAssignmentDeclarationPropertyAccessKind,
	    getAssignmentTargetKind: () => getAssignmentTargetKind,
	    getAutomaticTypeDirectiveNames: () => getAutomaticTypeDirectiveNames,
	    getBaseFileName: () => getBaseFileName,
	    getBinaryOperatorPrecedence: () => getBinaryOperatorPrecedence,
	    getBuildInfo: () => getBuildInfo,
	    getBuildInfoFileVersionMap: () => getBuildInfoFileVersionMap,
	    getBuildInfoText: () => getBuildInfoText,
	    getBuildOrderFromAnyBuildOrder: () => getBuildOrderFromAnyBuildOrder,
	    getBuilderCreationParameters: () => getBuilderCreationParameters,
	    getBuilderFileEmit: () => getBuilderFileEmit,
	    getCheckFlags: () => getCheckFlags,
	    getClassExtendsHeritageElement: () => getClassExtendsHeritageElement,
	    getClassLikeDeclarationOfSymbol: () => getClassLikeDeclarationOfSymbol,
	    getCombinedLocalAndExportSymbolFlags: () => getCombinedLocalAndExportSymbolFlags,
	    getCombinedModifierFlags: () => getCombinedModifierFlags,
	    getCombinedNodeFlags: () => getCombinedNodeFlags,
	    getCombinedNodeFlagsAlwaysIncludeJSDoc: () => getCombinedNodeFlagsAlwaysIncludeJSDoc,
	    getCommentRange: () => getCommentRange,
	    getCommonSourceDirectory: () => getCommonSourceDirectory,
	    getCommonSourceDirectoryOfConfig: () => getCommonSourceDirectoryOfConfig,
	    getCompilerOptionValue: () => getCompilerOptionValue,
	    getCompilerOptionsDiffValue: () => getCompilerOptionsDiffValue,
	    getConditions: () => getConditions,
	    getConfigFileParsingDiagnostics: () => getConfigFileParsingDiagnostics,
	    getConstantValue: () => getConstantValue,
	    getContainerFlags: () => getContainerFlags,
	    getContainerNode: () => getContainerNode,
	    getContainingClass: () => getContainingClass,
	    getContainingClassExcludingClassDecorators: () => getContainingClassExcludingClassDecorators,
	    getContainingClassStaticBlock: () => getContainingClassStaticBlock,
	    getContainingFunction: () => getContainingFunction,
	    getContainingFunctionDeclaration: () => getContainingFunctionDeclaration,
	    getContainingFunctionOrClassStaticBlock: () => getContainingFunctionOrClassStaticBlock,
	    getContainingNodeArray: () => getContainingNodeArray,
	    getContainingObjectLiteralElement: () => getContainingObjectLiteralElement,
	    getContextualTypeFromParent: () => getContextualTypeFromParent,
	    getContextualTypeFromParentOrAncestorTypeNode: () => getContextualTypeFromParentOrAncestorTypeNode,
	    getCurrentTime: () => getCurrentTime,
	    getDeclarationDiagnostics: () => getDeclarationDiagnostics,
	    getDeclarationEmitExtensionForPath: () => getDeclarationEmitExtensionForPath,
	    getDeclarationEmitOutputFilePath: () => getDeclarationEmitOutputFilePath,
	    getDeclarationEmitOutputFilePathWorker: () => getDeclarationEmitOutputFilePathWorker,
	    getDeclarationFileExtension: () => getDeclarationFileExtension,
	    getDeclarationFromName: () => getDeclarationFromName,
	    getDeclarationModifierFlagsFromSymbol: () => getDeclarationModifierFlagsFromSymbol,
	    getDeclarationOfKind: () => getDeclarationOfKind,
	    getDeclarationsOfKind: () => getDeclarationsOfKind,
	    getDeclaredExpandoInitializer: () => getDeclaredExpandoInitializer,
	    getDecorators: () => getDecorators,
	    getDefaultCompilerOptions: () => getDefaultCompilerOptions2,
	    getDefaultExportInfoWorker: () => getDefaultExportInfoWorker,
	    getDefaultFormatCodeSettings: () => getDefaultFormatCodeSettings,
	    getDefaultLibFileName: () => getDefaultLibFileName,
	    getDefaultLibFilePath: () => getDefaultLibFilePath,
	    getDefaultLikeExportInfo: () => getDefaultLikeExportInfo,
	    getDiagnosticText: () => getDiagnosticText,
	    getDiagnosticsWithinSpan: () => getDiagnosticsWithinSpan,
	    getDirectoryPath: () => getDirectoryPath,
	    getDirectoryToWatchFailedLookupLocation: () => getDirectoryToWatchFailedLookupLocation,
	    getDirectoryToWatchFailedLookupLocationFromTypeRoot: () => getDirectoryToWatchFailedLookupLocationFromTypeRoot,
	    getDocumentPositionMapper: () => getDocumentPositionMapper,
	    getDocumentSpansEqualityComparer: () => getDocumentSpansEqualityComparer,
	    getESModuleInterop: () => getESModuleInterop,
	    getEditsForFileRename: () => getEditsForFileRename,
	    getEffectiveBaseTypeNode: () => getEffectiveBaseTypeNode,
	    getEffectiveConstraintOfTypeParameter: () => getEffectiveConstraintOfTypeParameter,
	    getEffectiveContainerForJSDocTemplateTag: () => getEffectiveContainerForJSDocTemplateTag,
	    getEffectiveImplementsTypeNodes: () => getEffectiveImplementsTypeNodes,
	    getEffectiveInitializer: () => getEffectiveInitializer,
	    getEffectiveJSDocHost: () => getEffectiveJSDocHost,
	    getEffectiveModifierFlags: () => getEffectiveModifierFlags,
	    getEffectiveModifierFlagsAlwaysIncludeJSDoc: () => getEffectiveModifierFlagsAlwaysIncludeJSDoc,
	    getEffectiveModifierFlagsNoCache: () => getEffectiveModifierFlagsNoCache,
	    getEffectiveReturnTypeNode: () => getEffectiveReturnTypeNode,
	    getEffectiveSetAccessorTypeAnnotationNode: () => getEffectiveSetAccessorTypeAnnotationNode,
	    getEffectiveTypeAnnotationNode: () => getEffectiveTypeAnnotationNode,
	    getEffectiveTypeParameterDeclarations: () => getEffectiveTypeParameterDeclarations,
	    getEffectiveTypeRoots: () => getEffectiveTypeRoots,
	    getElementOrPropertyAccessArgumentExpressionOrName: () => getElementOrPropertyAccessArgumentExpressionOrName,
	    getElementOrPropertyAccessName: () => getElementOrPropertyAccessName,
	    getElementsOfBindingOrAssignmentPattern: () => getElementsOfBindingOrAssignmentPattern,
	    getEmitDeclarations: () => getEmitDeclarations,
	    getEmitFlags: () => getEmitFlags,
	    getEmitHelpers: () => getEmitHelpers,
	    getEmitModuleDetectionKind: () => getEmitModuleDetectionKind,
	    getEmitModuleKind: () => getEmitModuleKind,
	    getEmitModuleResolutionKind: () => getEmitModuleResolutionKind,
	    getEmitScriptTarget: () => getEmitScriptTarget,
	    getEmitStandardClassFields: () => getEmitStandardClassFields,
	    getEnclosingBlockScopeContainer: () => getEnclosingBlockScopeContainer,
	    getEnclosingContainer: () => getEnclosingContainer,
	    getEncodedSemanticClassifications: () => getEncodedSemanticClassifications,
	    getEncodedSyntacticClassifications: () => getEncodedSyntacticClassifications,
	    getEndLinePosition: () => getEndLinePosition,
	    getEntityNameFromTypeNode: () => getEntityNameFromTypeNode,
	    getEntrypointsFromPackageJsonInfo: () => getEntrypointsFromPackageJsonInfo,
	    getErrorCountForSummary: () => getErrorCountForSummary,
	    getErrorSpanForNode: () => getErrorSpanForNode,
	    getErrorSummaryText: () => getErrorSummaryText,
	    getEscapedTextOfIdentifierOrLiteral: () => getEscapedTextOfIdentifierOrLiteral,
	    getEscapedTextOfJsxAttributeName: () => getEscapedTextOfJsxAttributeName,
	    getEscapedTextOfJsxNamespacedName: () => getEscapedTextOfJsxNamespacedName,
	    getExpandoInitializer: () => getExpandoInitializer,
	    getExportAssignmentExpression: () => getExportAssignmentExpression,
	    getExportInfoMap: () => getExportInfoMap,
	    getExportNeedsImportStarHelper: () => getExportNeedsImportStarHelper,
	    getExpressionAssociativity: () => getExpressionAssociativity,
	    getExpressionPrecedence: () => getExpressionPrecedence,
	    getExternalHelpersModuleName: () => getExternalHelpersModuleName,
	    getExternalModuleImportEqualsDeclarationExpression: () => getExternalModuleImportEqualsDeclarationExpression,
	    getExternalModuleName: () => getExternalModuleName,
	    getExternalModuleNameFromDeclaration: () => getExternalModuleNameFromDeclaration,
	    getExternalModuleNameFromPath: () => getExternalModuleNameFromPath,
	    getExternalModuleNameLiteral: () => getExternalModuleNameLiteral,
	    getExternalModuleRequireArgument: () => getExternalModuleRequireArgument,
	    getFallbackOptions: () => getFallbackOptions,
	    getFileEmitOutput: () => getFileEmitOutput,
	    getFileMatcherPatterns: () => getFileMatcherPatterns,
	    getFileNamesFromConfigSpecs: () => getFileNamesFromConfigSpecs,
	    getFileWatcherEventKind: () => getFileWatcherEventKind,
	    getFilesInErrorForSummary: () => getFilesInErrorForSummary,
	    getFirstConstructorWithBody: () => getFirstConstructorWithBody,
	    getFirstIdentifier: () => getFirstIdentifier,
	    getFirstNonSpaceCharacterPosition: () => getFirstNonSpaceCharacterPosition,
	    getFirstProjectOutput: () => getFirstProjectOutput,
	    getFixableErrorSpanExpression: () => getFixableErrorSpanExpression,
	    getFormatCodeSettingsForWriting: () => getFormatCodeSettingsForWriting,
	    getFullWidth: () => getFullWidth,
	    getFunctionFlags: () => getFunctionFlags,
	    getHeritageClause: () => getHeritageClause,
	    getHostSignatureFromJSDoc: () => getHostSignatureFromJSDoc,
	    getIdentifierAutoGenerate: () => getIdentifierAutoGenerate,
	    getIdentifierGeneratedImportReference: () => getIdentifierGeneratedImportReference,
	    getIdentifierTypeArguments: () => getIdentifierTypeArguments,
	    getImmediatelyInvokedFunctionExpression: () => getImmediatelyInvokedFunctionExpression,
	    getImpliedNodeFormatForFile: () => getImpliedNodeFormatForFile,
	    getImpliedNodeFormatForFileWorker: () => getImpliedNodeFormatForFileWorker,
	    getImportNeedsImportDefaultHelper: () => getImportNeedsImportDefaultHelper,
	    getImportNeedsImportStarHelper: () => getImportNeedsImportStarHelper,
	    getIndentSize: () => getIndentSize,
	    getIndentString: () => getIndentString,
	    getInferredLibraryNameResolveFrom: () => getInferredLibraryNameResolveFrom,
	    getInitializedVariables: () => getInitializedVariables,
	    getInitializerOfBinaryExpression: () => getInitializerOfBinaryExpression,
	    getInitializerOfBindingOrAssignmentElement: () => getInitializerOfBindingOrAssignmentElement,
	    getInterfaceBaseTypeNodes: () => getInterfaceBaseTypeNodes,
	    getInternalEmitFlags: () => getInternalEmitFlags,
	    getInvokedExpression: () => getInvokedExpression,
	    getIsolatedModules: () => getIsolatedModules,
	    getJSDocAugmentsTag: () => getJSDocAugmentsTag,
	    getJSDocClassTag: () => getJSDocClassTag,
	    getJSDocCommentRanges: () => getJSDocCommentRanges,
	    getJSDocCommentsAndTags: () => getJSDocCommentsAndTags,
	    getJSDocDeprecatedTag: () => getJSDocDeprecatedTag,
	    getJSDocDeprecatedTagNoCache: () => getJSDocDeprecatedTagNoCache,
	    getJSDocEnumTag: () => getJSDocEnumTag,
	    getJSDocHost: () => getJSDocHost,
	    getJSDocImplementsTags: () => getJSDocImplementsTags,
	    getJSDocOverloadTags: () => getJSDocOverloadTags,
	    getJSDocOverrideTagNoCache: () => getJSDocOverrideTagNoCache,
	    getJSDocParameterTags: () => getJSDocParameterTags,
	    getJSDocParameterTagsNoCache: () => getJSDocParameterTagsNoCache,
	    getJSDocPrivateTag: () => getJSDocPrivateTag,
	    getJSDocPrivateTagNoCache: () => getJSDocPrivateTagNoCache,
	    getJSDocProtectedTag: () => getJSDocProtectedTag,
	    getJSDocProtectedTagNoCache: () => getJSDocProtectedTagNoCache,
	    getJSDocPublicTag: () => getJSDocPublicTag,
	    getJSDocPublicTagNoCache: () => getJSDocPublicTagNoCache,
	    getJSDocReadonlyTag: () => getJSDocReadonlyTag,
	    getJSDocReadonlyTagNoCache: () => getJSDocReadonlyTagNoCache,
	    getJSDocReturnTag: () => getJSDocReturnTag,
	    getJSDocReturnType: () => getJSDocReturnType,
	    getJSDocRoot: () => getJSDocRoot,
	    getJSDocSatisfiesExpressionType: () => getJSDocSatisfiesExpressionType,
	    getJSDocSatisfiesTag: () => getJSDocSatisfiesTag,
	    getJSDocTags: () => getJSDocTags,
	    getJSDocTagsNoCache: () => getJSDocTagsNoCache,
	    getJSDocTemplateTag: () => getJSDocTemplateTag,
	    getJSDocThisTag: () => getJSDocThisTag,
	    getJSDocType: () => getJSDocType,
	    getJSDocTypeAliasName: () => getJSDocTypeAliasName,
	    getJSDocTypeAssertionType: () => getJSDocTypeAssertionType,
	    getJSDocTypeParameterDeclarations: () => getJSDocTypeParameterDeclarations,
	    getJSDocTypeParameterTags: () => getJSDocTypeParameterTags,
	    getJSDocTypeParameterTagsNoCache: () => getJSDocTypeParameterTagsNoCache,
	    getJSDocTypeTag: () => getJSDocTypeTag,
	    getJSXImplicitImportBase: () => getJSXImplicitImportBase,
	    getJSXRuntimeImport: () => getJSXRuntimeImport,
	    getJSXTransformEnabled: () => getJSXTransformEnabled,
	    getKeyForCompilerOptions: () => getKeyForCompilerOptions,
	    getLanguageVariant: () => getLanguageVariant,
	    getLastChild: () => getLastChild,
	    getLeadingCommentRanges: () => getLeadingCommentRanges,
	    getLeadingCommentRangesOfNode: () => getLeadingCommentRangesOfNode,
	    getLeftmostAccessExpression: () => getLeftmostAccessExpression,
	    getLeftmostExpression: () => getLeftmostExpression,
	    getLibraryNameFromLibFileName: () => getLibraryNameFromLibFileName,
	    getLineAndCharacterOfPosition: () => getLineAndCharacterOfPosition,
	    getLineInfo: () => getLineInfo,
	    getLineOfLocalPosition: () => getLineOfLocalPosition,
	    getLineOfLocalPositionFromLineMap: () => getLineOfLocalPositionFromLineMap,
	    getLineStartPositionForPosition: () => getLineStartPositionForPosition,
	    getLineStarts: () => getLineStarts,
	    getLinesBetweenPositionAndNextNonWhitespaceCharacter: () => getLinesBetweenPositionAndNextNonWhitespaceCharacter,
	    getLinesBetweenPositionAndPrecedingNonWhitespaceCharacter: () => getLinesBetweenPositionAndPrecedingNonWhitespaceCharacter,
	    getLinesBetweenPositions: () => getLinesBetweenPositions,
	    getLinesBetweenRangeEndAndRangeStart: () => getLinesBetweenRangeEndAndRangeStart,
	    getLinesBetweenRangeEndPositions: () => getLinesBetweenRangeEndPositions,
	    getLiteralText: () => getLiteralText,
	    getLocalNameForExternalImport: () => getLocalNameForExternalImport,
	    getLocalSymbolForExportDefault: () => getLocalSymbolForExportDefault,
	    getLocaleSpecificMessage: () => getLocaleSpecificMessage,
	    getLocaleTimeString: () => getLocaleTimeString,
	    getMappedContextSpan: () => getMappedContextSpan,
	    getMappedDocumentSpan: () => getMappedDocumentSpan,
	    getMappedLocation: () => getMappedLocation,
	    getMatchedFileSpec: () => getMatchedFileSpec,
	    getMatchedIncludeSpec: () => getMatchedIncludeSpec,
	    getMeaningFromDeclaration: () => getMeaningFromDeclaration,
	    getMeaningFromLocation: () => getMeaningFromLocation,
	    getMembersOfDeclaration: () => getMembersOfDeclaration,
	    getModeForFileReference: () => getModeForFileReference,
	    getModeForResolutionAtIndex: () => getModeForResolutionAtIndex,
	    getModeForUsageLocation: () => getModeForUsageLocation,
	    getModifiedTime: () => getModifiedTime,
	    getModifiers: () => getModifiers,
	    getModuleInstanceState: () => getModuleInstanceState,
	    getModuleNameStringLiteralAt: () => getModuleNameStringLiteralAt,
	    getModuleSpecifierEndingPreference: () => getModuleSpecifierEndingPreference,
	    getModuleSpecifierResolverHost: () => getModuleSpecifierResolverHost,
	    getNameForExportedSymbol: () => getNameForExportedSymbol,
	    getNameFromImportAttribute: () => getNameFromImportAttribute,
	    getNameFromIndexInfo: () => getNameFromIndexInfo,
	    getNameFromPropertyName: () => getNameFromPropertyName,
	    getNameOfAccessExpression: () => getNameOfAccessExpression,
	    getNameOfCompilerOptionValue: () => getNameOfCompilerOptionValue,
	    getNameOfDeclaration: () => getNameOfDeclaration,
	    getNameOfExpando: () => getNameOfExpando,
	    getNameOfJSDocTypedef: () => getNameOfJSDocTypedef,
	    getNameOrArgument: () => getNameOrArgument,
	    getNameTable: () => getNameTable,
	    getNamesForExportedSymbol: () => getNamesForExportedSymbol,
	    getNamespaceDeclarationNode: () => getNamespaceDeclarationNode,
	    getNewLineCharacter: () => getNewLineCharacter,
	    getNewLineKind: () => getNewLineKind,
	    getNewLineOrDefaultFromHost: () => getNewLineOrDefaultFromHost,
	    getNewTargetContainer: () => getNewTargetContainer,
	    getNextJSDocCommentLocation: () => getNextJSDocCommentLocation,
	    getNodeForGeneratedName: () => getNodeForGeneratedName,
	    getNodeId: () => getNodeId,
	    getNodeKind: () => getNodeKind,
	    getNodeModifiers: () => getNodeModifiers,
	    getNodeModulePathParts: () => getNodeModulePathParts,
	    getNonAssignedNameOfDeclaration: () => getNonAssignedNameOfDeclaration,
	    getNonAssignmentOperatorForCompoundAssignment: () => getNonAssignmentOperatorForCompoundAssignment,
	    getNonAugmentationDeclaration: () => getNonAugmentationDeclaration,
	    getNonDecoratorTokenPosOfNode: () => getNonDecoratorTokenPosOfNode,
	    getNormalizedAbsolutePath: () => getNormalizedAbsolutePath,
	    getNormalizedAbsolutePathWithoutRoot: () => getNormalizedAbsolutePathWithoutRoot,
	    getNormalizedPathComponents: () => getNormalizedPathComponents,
	    getObjectFlags: () => getObjectFlags,
	    getOperator: () => getOperator,
	    getOperatorAssociativity: () => getOperatorAssociativity,
	    getOperatorPrecedence: () => getOperatorPrecedence,
	    getOptionFromName: () => getOptionFromName,
	    getOptionsForLibraryResolution: () => getOptionsForLibraryResolution,
	    getOptionsNameMap: () => getOptionsNameMap,
	    getOrCreateEmitNode: () => getOrCreateEmitNode,
	    getOrCreateExternalHelpersModuleNameIfNeeded: () => getOrCreateExternalHelpersModuleNameIfNeeded,
	    getOrUpdate: () => getOrUpdate,
	    getOriginalNode: () => getOriginalNode,
	    getOriginalNodeId: () => getOriginalNodeId,
	    getOriginalSourceFile: () => getOriginalSourceFile,
	    getOutputDeclarationFileName: () => getOutputDeclarationFileName,
	    getOutputDeclarationFileNameWorker: () => getOutputDeclarationFileNameWorker,
	    getOutputExtension: () => getOutputExtension,
	    getOutputFileNames: () => getOutputFileNames,
	    getOutputJSFileNameWorker: () => getOutputJSFileNameWorker,
	    getOutputPathsFor: () => getOutputPathsFor,
	    getOutputPathsForBundle: () => getOutputPathsForBundle,
	    getOwnEmitOutputFilePath: () => getOwnEmitOutputFilePath,
	    getOwnKeys: () => getOwnKeys,
	    getOwnValues: () => getOwnValues,
	    getPackageJsonInfo: () => getPackageJsonInfo,
	    getPackageJsonTypesVersionsPaths: () => getPackageJsonTypesVersionsPaths,
	    getPackageJsonsVisibleToFile: () => getPackageJsonsVisibleToFile,
	    getPackageNameFromTypesPackageName: () => getPackageNameFromTypesPackageName,
	    getPackageScopeForPath: () => getPackageScopeForPath,
	    getParameterSymbolFromJSDoc: () => getParameterSymbolFromJSDoc,
	    getParameterTypeNode: () => getParameterTypeNode,
	    getParentNodeInSpan: () => getParentNodeInSpan,
	    getParseTreeNode: () => getParseTreeNode,
	    getParsedCommandLineOfConfigFile: () => getParsedCommandLineOfConfigFile,
	    getPathComponents: () => getPathComponents,
	    getPathComponentsRelativeTo: () => getPathComponentsRelativeTo,
	    getPathFromPathComponents: () => getPathFromPathComponents,
	    getPathUpdater: () => getPathUpdater,
	    getPathsBasePath: () => getPathsBasePath,
	    getPatternFromSpec: () => getPatternFromSpec,
	    getPendingEmitKind: () => getPendingEmitKind,
	    getPositionOfLineAndCharacter: () => getPositionOfLineAndCharacter,
	    getPossibleGenericSignatures: () => getPossibleGenericSignatures,
	    getPossibleOriginalInputExtensionForExtension: () => getPossibleOriginalInputExtensionForExtension,
	    getPossibleTypeArgumentsInfo: () => getPossibleTypeArgumentsInfo,
	    getPreEmitDiagnostics: () => getPreEmitDiagnostics,
	    getPrecedingNonSpaceCharacterPosition: () => getPrecedingNonSpaceCharacterPosition,
	    getPrivateIdentifier: () => getPrivateIdentifier,
	    getProperties: () => getProperties,
	    getProperty: () => getProperty,
	    getPropertyArrayElementValue: () => getPropertyArrayElementValue,
	    getPropertyAssignmentAliasLikeExpression: () => getPropertyAssignmentAliasLikeExpression,
	    getPropertyNameForPropertyNameNode: () => getPropertyNameForPropertyNameNode,
	    getPropertyNameForUniqueESSymbol: () => getPropertyNameForUniqueESSymbol,
	    getPropertyNameFromType: () => getPropertyNameFromType,
	    getPropertyNameOfBindingOrAssignmentElement: () => getPropertyNameOfBindingOrAssignmentElement,
	    getPropertySymbolFromBindingElement: () => getPropertySymbolFromBindingElement,
	    getPropertySymbolsFromContextualType: () => getPropertySymbolsFromContextualType,
	    getQuoteFromPreference: () => getQuoteFromPreference,
	    getQuotePreference: () => getQuotePreference,
	    getRangesWhere: () => getRangesWhere,
	    getRefactorContextSpan: () => getRefactorContextSpan,
	    getReferencedFileLocation: () => getReferencedFileLocation,
	    getRegexFromPattern: () => getRegexFromPattern,
	    getRegularExpressionForWildcard: () => getRegularExpressionForWildcard,
	    getRegularExpressionsForWildcards: () => getRegularExpressionsForWildcards,
	    getRelativePathFromDirectory: () => getRelativePathFromDirectory,
	    getRelativePathFromFile: () => getRelativePathFromFile,
	    getRelativePathToDirectoryOrUrl: () => getRelativePathToDirectoryOrUrl,
	    getRenameLocation: () => getRenameLocation,
	    getReplacementSpanForContextToken: () => getReplacementSpanForContextToken,
	    getResolutionDiagnostic: () => getResolutionDiagnostic,
	    getResolutionModeOverride: () => getResolutionModeOverride,
	    getResolveJsonModule: () => getResolveJsonModule,
	    getResolvePackageJsonExports: () => getResolvePackageJsonExports,
	    getResolvePackageJsonImports: () => getResolvePackageJsonImports,
	    getResolvedExternalModuleName: () => getResolvedExternalModuleName,
	    getRestIndicatorOfBindingOrAssignmentElement: () => getRestIndicatorOfBindingOrAssignmentElement,
	    getRestParameterElementType: () => getRestParameterElementType,
	    getRightMostAssignedExpression: () => getRightMostAssignedExpression,
	    getRootDeclaration: () => getRootDeclaration,
	    getRootDirectoryOfResolutionCache: () => getRootDirectoryOfResolutionCache,
	    getRootLength: () => getRootLength,
	    getRootPathSplitLength: () => getRootPathSplitLength,
	    getScriptKind: () => getScriptKind,
	    getScriptKindFromFileName: () => getScriptKindFromFileName,
	    getScriptTargetFeatures: () => getScriptTargetFeatures,
	    getSelectedEffectiveModifierFlags: () => getSelectedEffectiveModifierFlags,
	    getSelectedSyntacticModifierFlags: () => getSelectedSyntacticModifierFlags,
	    getSemanticClassifications: () => getSemanticClassifications,
	    getSemanticJsxChildren: () => getSemanticJsxChildren,
	    getSetAccessorTypeAnnotationNode: () => getSetAccessorTypeAnnotationNode,
	    getSetAccessorValueParameter: () => getSetAccessorValueParameter,
	    getSetExternalModuleIndicator: () => getSetExternalModuleIndicator,
	    getShebang: () => getShebang,
	    getSingleInitializerOfVariableStatementOrPropertyDeclaration: () => getSingleInitializerOfVariableStatementOrPropertyDeclaration,
	    getSingleVariableOfVariableStatement: () => getSingleVariableOfVariableStatement,
	    getSnapshotText: () => getSnapshotText,
	    getSnippetElement: () => getSnippetElement,
	    getSourceFileOfModule: () => getSourceFileOfModule,
	    getSourceFileOfNode: () => getSourceFileOfNode,
	    getSourceFilePathInNewDir: () => getSourceFilePathInNewDir,
	    getSourceFilePathInNewDirWorker: () => getSourceFilePathInNewDirWorker,
	    getSourceFileVersionAsHashFromText: () => getSourceFileVersionAsHashFromText,
	    getSourceFilesToEmit: () => getSourceFilesToEmit,
	    getSourceMapRange: () => getSourceMapRange,
	    getSourceMapper: () => getSourceMapper,
	    getSourceTextOfNodeFromSourceFile: () => getSourceTextOfNodeFromSourceFile,
	    getSpanOfTokenAtPosition: () => getSpanOfTokenAtPosition,
	    getSpellingSuggestion: () => getSpellingSuggestion,
	    getStartPositionOfLine: () => getStartPositionOfLine,
	    getStartPositionOfRange: () => getStartPositionOfRange,
	    getStartsOnNewLine: () => getStartsOnNewLine,
	    getStaticPropertiesAndClassStaticBlock: () => getStaticPropertiesAndClassStaticBlock,
	    getStrictOptionValue: () => getStrictOptionValue,
	    getStringComparer: () => getStringComparer,
	    getSubPatternFromSpec: () => getSubPatternFromSpec,
	    getSuperCallFromStatement: () => getSuperCallFromStatement,
	    getSuperContainer: () => getSuperContainer,
	    getSupportedCodeFixes: () => getSupportedCodeFixes,
	    getSupportedExtensions: () => getSupportedExtensions,
	    getSupportedExtensionsWithJsonIfResolveJsonModule: () => getSupportedExtensionsWithJsonIfResolveJsonModule,
	    getSwitchedType: () => getSwitchedType,
	    getSymbolId: () => getSymbolId,
	    getSymbolNameForPrivateIdentifier: () => getSymbolNameForPrivateIdentifier,
	    getSymbolTarget: () => getSymbolTarget,
	    getSyntacticClassifications: () => getSyntacticClassifications,
	    getSyntacticModifierFlags: () => getSyntacticModifierFlags,
	    getSyntacticModifierFlagsNoCache: () => getSyntacticModifierFlagsNoCache,
	    getSynthesizedDeepClone: () => getSynthesizedDeepClone,
	    getSynthesizedDeepCloneWithReplacements: () => getSynthesizedDeepCloneWithReplacements,
	    getSynthesizedDeepClones: () => getSynthesizedDeepClones,
	    getSynthesizedDeepClonesWithReplacements: () => getSynthesizedDeepClonesWithReplacements,
	    getSyntheticLeadingComments: () => getSyntheticLeadingComments,
	    getSyntheticTrailingComments: () => getSyntheticTrailingComments,
	    getTargetLabel: () => getTargetLabel,
	    getTargetOfBindingOrAssignmentElement: () => getTargetOfBindingOrAssignmentElement,
	    getTemporaryModuleResolutionState: () => getTemporaryModuleResolutionState,
	    getTextOfConstantValue: () => getTextOfConstantValue,
	    getTextOfIdentifierOrLiteral: () => getTextOfIdentifierOrLiteral,
	    getTextOfJSDocComment: () => getTextOfJSDocComment,
	    getTextOfJsxAttributeName: () => getTextOfJsxAttributeName,
	    getTextOfJsxNamespacedName: () => getTextOfJsxNamespacedName,
	    getTextOfNode: () => getTextOfNode,
	    getTextOfNodeFromSourceText: () => getTextOfNodeFromSourceText,
	    getTextOfPropertyName: () => getTextOfPropertyName,
	    getThisContainer: () => getThisContainer,
	    getThisParameter: () => getThisParameter,
	    getTokenAtPosition: () => getTokenAtPosition,
	    getTokenPosOfNode: () => getTokenPosOfNode,
	    getTokenSourceMapRange: () => getTokenSourceMapRange,
	    getTouchingPropertyName: () => getTouchingPropertyName,
	    getTouchingToken: () => getTouchingToken,
	    getTrailingCommentRanges: () => getTrailingCommentRanges,
	    getTrailingSemicolonDeferringWriter: () => getTrailingSemicolonDeferringWriter,
	    getTransformFlagsSubtreeExclusions: () => getTransformFlagsSubtreeExclusions,
	    getTransformers: () => getTransformers,
	    getTsBuildInfoEmitOutputFilePath: () => getTsBuildInfoEmitOutputFilePath,
	    getTsConfigObjectLiteralExpression: () => getTsConfigObjectLiteralExpression,
	    getTsConfigPropArrayElementValue: () => getTsConfigPropArrayElementValue,
	    getTypeAnnotationNode: () => getTypeAnnotationNode,
	    getTypeArgumentOrTypeParameterList: () => getTypeArgumentOrTypeParameterList,
	    getTypeKeywordOfTypeOnlyImport: () => getTypeKeywordOfTypeOnlyImport,
	    getTypeNode: () => getTypeNode,
	    getTypeNodeIfAccessible: () => getTypeNodeIfAccessible,
	    getTypeParameterFromJsDoc: () => getTypeParameterFromJsDoc,
	    getTypeParameterOwner: () => getTypeParameterOwner,
	    getTypesPackageName: () => getTypesPackageName,
	    getUILocale: () => getUILocale,
	    getUniqueName: () => getUniqueName,
	    getUniqueSymbolId: () => getUniqueSymbolId,
	    getUseDefineForClassFields: () => getUseDefineForClassFields,
	    getWatchErrorSummaryDiagnosticMessage: () => getWatchErrorSummaryDiagnosticMessage,
	    getWatchFactory: () => getWatchFactory,
	    group: () => group,
	    groupBy: () => groupBy,
	    guessIndentation: () => guessIndentation,
	    handleNoEmitOptions: () => handleNoEmitOptions,
	    hasAbstractModifier: () => hasAbstractModifier,
	    hasAccessorModifier: () => hasAccessorModifier,
	    hasAmbientModifier: () => hasAmbientModifier,
	    hasChangesInResolutions: () => hasChangesInResolutions,
	    hasChildOfKind: () => hasChildOfKind,
	    hasContextSensitiveParameters: () => hasContextSensitiveParameters,
	    hasDecorators: () => hasDecorators,
	    hasDocComment: () => hasDocComment,
	    hasDynamicName: () => hasDynamicName,
	    hasEffectiveModifier: () => hasEffectiveModifier,
	    hasEffectiveModifiers: () => hasEffectiveModifiers,
	    hasEffectiveReadonlyModifier: () => hasEffectiveReadonlyModifier,
	    hasExtension: () => hasExtension,
	    hasIndexSignature: () => hasIndexSignature,
	    hasInitializer: () => hasInitializer,
	    hasInvalidEscape: () => hasInvalidEscape,
	    hasJSDocNodes: () => hasJSDocNodes,
	    hasJSDocParameterTags: () => hasJSDocParameterTags,
	    hasJSFileExtension: () => hasJSFileExtension,
	    hasJsonModuleEmitEnabled: () => hasJsonModuleEmitEnabled,
	    hasOnlyExpressionInitializer: () => hasOnlyExpressionInitializer,
	    hasOverrideModifier: () => hasOverrideModifier,
	    hasPossibleExternalModuleReference: () => hasPossibleExternalModuleReference,
	    hasProperty: () => hasProperty,
	    hasPropertyAccessExpressionWithName: () => hasPropertyAccessExpressionWithName,
	    hasQuestionToken: () => hasQuestionToken,
	    hasRecordedExternalHelpers: () => hasRecordedExternalHelpers,
	    hasResolutionModeOverride: () => hasResolutionModeOverride,
	    hasRestParameter: () => hasRestParameter,
	    hasScopeMarker: () => hasScopeMarker,
	    hasStaticModifier: () => hasStaticModifier,
	    hasSyntacticModifier: () => hasSyntacticModifier,
	    hasSyntacticModifiers: () => hasSyntacticModifiers,
	    hasTSFileExtension: () => hasTSFileExtension,
	    hasTabstop: () => hasTabstop,
	    hasTrailingDirectorySeparator: () => hasTrailingDirectorySeparator,
	    hasType: () => hasType,
	    hasTypeArguments: () => hasTypeArguments,
	    hasZeroOrOneAsteriskCharacter: () => hasZeroOrOneAsteriskCharacter,
	    helperString: () => helperString,
	    hostGetCanonicalFileName: () => hostGetCanonicalFileName,
	    hostUsesCaseSensitiveFileNames: () => hostUsesCaseSensitiveFileNames,
	    idText: () => idText,
	    identifierIsThisKeyword: () => identifierIsThisKeyword,
	    identifierToKeywordKind: () => identifierToKeywordKind,
	    identity: () => identity,
	    identitySourceMapConsumer: () => identitySourceMapConsumer,
	    ignoreSourceNewlines: () => ignoreSourceNewlines,
	    ignoredPaths: () => ignoredPaths,
	    importDefaultHelper: () => importDefaultHelper,
	    importFromModuleSpecifier: () => importFromModuleSpecifier,
	    importNameElisionDisabled: () => importNameElisionDisabled,
	    importStarHelper: () => importStarHelper,
	    indexOfAnyCharCode: () => indexOfAnyCharCode,
	    indexOfNode: () => indexOfNode,
	    indicesOf: () => indicesOf,
	    inferredTypesContainingFile: () => inferredTypesContainingFile,
	    injectClassNamedEvaluationHelperBlockIfMissing: () => injectClassNamedEvaluationHelperBlockIfMissing,
	    injectClassThisAssignmentIfMissing: () => injectClassThisAssignmentIfMissing,
	    insertImports: () => insertImports,
	    insertLeadingStatement: () => insertLeadingStatement,
	    insertSorted: () => insertSorted,
	    insertStatementAfterCustomPrologue: () => insertStatementAfterCustomPrologue,
	    insertStatementAfterStandardPrologue: () => insertStatementAfterStandardPrologue,
	    insertStatementsAfterCustomPrologue: () => insertStatementsAfterCustomPrologue,
	    insertStatementsAfterStandardPrologue: () => insertStatementsAfterStandardPrologue,
	    intersperse: () => intersperse,
	    intrinsicTagNameToString: () => intrinsicTagNameToString,
	    introducesArgumentsExoticObject: () => introducesArgumentsExoticObject,
	    inverseJsxOptionMap: () => inverseJsxOptionMap,
	    isAbstractConstructorSymbol: () => isAbstractConstructorSymbol,
	    isAbstractModifier: () => isAbstractModifier,
	    isAccessExpression: () => isAccessExpression,
	    isAccessibilityModifier: () => isAccessibilityModifier,
	    isAccessor: () => isAccessor,
	    isAccessorModifier: () => isAccessorModifier,
	    isAliasSymbolDeclaration: () => isAliasSymbolDeclaration,
	    isAliasableExpression: () => isAliasableExpression,
	    isAmbientModule: () => isAmbientModule,
	    isAmbientPropertyDeclaration: () => isAmbientPropertyDeclaration,
	    isAnonymousFunctionDefinition: () => isAnonymousFunctionDefinition,
	    isAnyDirectorySeparator: () => isAnyDirectorySeparator,
	    isAnyImportOrBareOrAccessedRequire: () => isAnyImportOrBareOrAccessedRequire,
	    isAnyImportOrReExport: () => isAnyImportOrReExport,
	    isAnyImportSyntax: () => isAnyImportSyntax,
	    isAnySupportedFileExtension: () => isAnySupportedFileExtension,
	    isApplicableVersionedTypesKey: () => isApplicableVersionedTypesKey,
	    isArgumentExpressionOfElementAccess: () => isArgumentExpressionOfElementAccess,
	    isArray: () => isArray,
	    isArrayBindingElement: () => isArrayBindingElement,
	    isArrayBindingOrAssignmentElement: () => isArrayBindingOrAssignmentElement,
	    isArrayBindingOrAssignmentPattern: () => isArrayBindingOrAssignmentPattern,
	    isArrayBindingPattern: () => isArrayBindingPattern,
	    isArrayLiteralExpression: () => isArrayLiteralExpression,
	    isArrayLiteralOrObjectLiteralDestructuringPattern: () => isArrayLiteralOrObjectLiteralDestructuringPattern,
	    isArrayTypeNode: () => isArrayTypeNode,
	    isArrowFunction: () => isArrowFunction,
	    isAsExpression: () => isAsExpression,
	    isAssertClause: () => isAssertClause,
	    isAssertEntry: () => isAssertEntry,
	    isAssertionExpression: () => isAssertionExpression,
	    isAssertsKeyword: () => isAssertsKeyword,
	    isAssignmentDeclaration: () => isAssignmentDeclaration,
	    isAssignmentExpression: () => isAssignmentExpression,
	    isAssignmentOperator: () => isAssignmentOperator,
	    isAssignmentPattern: () => isAssignmentPattern,
	    isAssignmentTarget: () => isAssignmentTarget,
	    isAsteriskToken: () => isAsteriskToken,
	    isAsyncFunction: () => isAsyncFunction,
	    isAsyncModifier: () => isAsyncModifier,
	    isAutoAccessorPropertyDeclaration: () => isAutoAccessorPropertyDeclaration,
	    isAwaitExpression: () => isAwaitExpression,
	    isAwaitKeyword: () => isAwaitKeyword,
	    isBigIntLiteral: () => isBigIntLiteral,
	    isBinaryExpression: () => isBinaryExpression,
	    isBinaryOperatorToken: () => isBinaryOperatorToken,
	    isBindableObjectDefinePropertyCall: () => isBindableObjectDefinePropertyCall,
	    isBindableStaticAccessExpression: () => isBindableStaticAccessExpression,
	    isBindableStaticElementAccessExpression: () => isBindableStaticElementAccessExpression,
	    isBindableStaticNameExpression: () => isBindableStaticNameExpression,
	    isBindingElement: () => isBindingElement,
	    isBindingElementOfBareOrAccessedRequire: () => isBindingElementOfBareOrAccessedRequire,
	    isBindingName: () => isBindingName,
	    isBindingOrAssignmentElement: () => isBindingOrAssignmentElement,
	    isBindingOrAssignmentPattern: () => isBindingOrAssignmentPattern,
	    isBindingPattern: () => isBindingPattern,
	    isBlock: () => isBlock,
	    isBlockOrCatchScoped: () => isBlockOrCatchScoped,
	    isBlockScope: () => isBlockScope,
	    isBlockScopedContainerTopLevel: () => isBlockScopedContainerTopLevel,
	    isBooleanLiteral: () => isBooleanLiteral,
	    isBreakOrContinueStatement: () => isBreakOrContinueStatement,
	    isBreakStatement: () => isBreakStatement,
	    isBuildInfoFile: () => isBuildInfoFile,
	    isBuilderProgram: () => isBuilderProgram2,
	    isBundle: () => isBundle,
	    isBundleFileTextLike: () => isBundleFileTextLike,
	    isCallChain: () => isCallChain,
	    isCallExpression: () => isCallExpression,
	    isCallExpressionTarget: () => isCallExpressionTarget,
	    isCallLikeExpression: () => isCallLikeExpression,
	    isCallLikeOrFunctionLikeExpression: () => isCallLikeOrFunctionLikeExpression,
	    isCallOrNewExpression: () => isCallOrNewExpression,
	    isCallOrNewExpressionTarget: () => isCallOrNewExpressionTarget,
	    isCallSignatureDeclaration: () => isCallSignatureDeclaration,
	    isCallToHelper: () => isCallToHelper,
	    isCaseBlock: () => isCaseBlock,
	    isCaseClause: () => isCaseClause,
	    isCaseKeyword: () => isCaseKeyword,
	    isCaseOrDefaultClause: () => isCaseOrDefaultClause,
	    isCatchClause: () => isCatchClause,
	    isCatchClauseVariableDeclaration: () => isCatchClauseVariableDeclaration,
	    isCatchClauseVariableDeclarationOrBindingElement: () => isCatchClauseVariableDeclarationOrBindingElement,
	    isCheckJsEnabledForFile: () => isCheckJsEnabledForFile,
	    isChildOfNodeWithKind: () => isChildOfNodeWithKind,
	    isCircularBuildOrder: () => isCircularBuildOrder,
	    isClassDeclaration: () => isClassDeclaration,
	    isClassElement: () => isClassElement,
	    isClassExpression: () => isClassExpression,
	    isClassInstanceProperty: () => isClassInstanceProperty,
	    isClassLike: () => isClassLike,
	    isClassMemberModifier: () => isClassMemberModifier,
	    isClassNamedEvaluationHelperBlock: () => isClassNamedEvaluationHelperBlock,
	    isClassOrTypeElement: () => isClassOrTypeElement,
	    isClassStaticBlockDeclaration: () => isClassStaticBlockDeclaration,
	    isClassThisAssignmentBlock: () => isClassThisAssignmentBlock,
	    isCollapsedRange: () => isCollapsedRange,
	    isColonToken: () => isColonToken,
	    isCommaExpression: () => isCommaExpression,
	    isCommaListExpression: () => isCommaListExpression,
	    isCommaSequence: () => isCommaSequence,
	    isCommaToken: () => isCommaToken,
	    isComment: () => isComment,
	    isCommonJsExportPropertyAssignment: () => isCommonJsExportPropertyAssignment,
	    isCommonJsExportedExpression: () => isCommonJsExportedExpression,
	    isCompoundAssignment: () => isCompoundAssignment,
	    isComputedNonLiteralName: () => isComputedNonLiteralName,
	    isComputedPropertyName: () => isComputedPropertyName,
	    isConciseBody: () => isConciseBody,
	    isConditionalExpression: () => isConditionalExpression,
	    isConditionalTypeNode: () => isConditionalTypeNode,
	    isConstTypeReference: () => isConstTypeReference,
	    isConstructSignatureDeclaration: () => isConstructSignatureDeclaration,
	    isConstructorDeclaration: () => isConstructorDeclaration,
	    isConstructorTypeNode: () => isConstructorTypeNode,
	    isContextualKeyword: () => isContextualKeyword,
	    isContinueStatement: () => isContinueStatement,
	    isCustomPrologue: () => isCustomPrologue,
	    isDebuggerStatement: () => isDebuggerStatement,
	    isDeclaration: () => isDeclaration,
	    isDeclarationBindingElement: () => isDeclarationBindingElement,
	    isDeclarationFileName: () => isDeclarationFileName,
	    isDeclarationName: () => isDeclarationName,
	    isDeclarationNameOfEnumOrNamespace: () => isDeclarationNameOfEnumOrNamespace,
	    isDeclarationReadonly: () => isDeclarationReadonly,
	    isDeclarationStatement: () => isDeclarationStatement,
	    isDeclarationWithTypeParameterChildren: () => isDeclarationWithTypeParameterChildren,
	    isDeclarationWithTypeParameters: () => isDeclarationWithTypeParameters,
	    isDecorator: () => isDecorator,
	    isDecoratorTarget: () => isDecoratorTarget,
	    isDefaultClause: () => isDefaultClause,
	    isDefaultImport: () => isDefaultImport,
	    isDefaultModifier: () => isDefaultModifier,
	    isDefaultedExpandoInitializer: () => isDefaultedExpandoInitializer,
	    isDeleteExpression: () => isDeleteExpression,
	    isDeleteTarget: () => isDeleteTarget,
	    isDeprecatedDeclaration: () => isDeprecatedDeclaration,
	    isDestructuringAssignment: () => isDestructuringAssignment,
	    isDiagnosticWithLocation: () => isDiagnosticWithLocation,
	    isDiskPathRoot: () => isDiskPathRoot,
	    isDoStatement: () => isDoStatement,
	    isDocumentRegistryEntry: () => isDocumentRegistryEntry,
	    isDotDotDotToken: () => isDotDotDotToken,
	    isDottedName: () => isDottedName,
	    isDynamicName: () => isDynamicName,
	    isESSymbolIdentifier: () => isESSymbolIdentifier,
	    isEffectiveExternalModule: () => isEffectiveExternalModule,
	    isEffectiveModuleDeclaration: () => isEffectiveModuleDeclaration,
	    isEffectiveStrictModeSourceFile: () => isEffectiveStrictModeSourceFile,
	    isElementAccessChain: () => isElementAccessChain,
	    isElementAccessExpression: () => isElementAccessExpression,
	    isEmittedFileOfProgram: () => isEmittedFileOfProgram,
	    isEmptyArrayLiteral: () => isEmptyArrayLiteral,
	    isEmptyBindingElement: () => isEmptyBindingElement,
	    isEmptyBindingPattern: () => isEmptyBindingPattern,
	    isEmptyObjectLiteral: () => isEmptyObjectLiteral,
	    isEmptyStatement: () => isEmptyStatement,
	    isEmptyStringLiteral: () => isEmptyStringLiteral,
	    isEntityName: () => isEntityName,
	    isEntityNameExpression: () => isEntityNameExpression,
	    isEnumConst: () => isEnumConst,
	    isEnumDeclaration: () => isEnumDeclaration,
	    isEnumMember: () => isEnumMember,
	    isEqualityOperatorKind: () => isEqualityOperatorKind,
	    isEqualsGreaterThanToken: () => isEqualsGreaterThanToken,
	    isExclamationToken: () => isExclamationToken,
	    isExcludedFile: () => isExcludedFile,
	    isExclusivelyTypeOnlyImportOrExport: () => isExclusivelyTypeOnlyImportOrExport,
	    isExpandoPropertyDeclaration: () => isExpandoPropertyDeclaration,
	    isExportAssignment: () => isExportAssignment,
	    isExportDeclaration: () => isExportDeclaration,
	    isExportModifier: () => isExportModifier,
	    isExportName: () => isExportName,
	    isExportNamespaceAsDefaultDeclaration: () => isExportNamespaceAsDefaultDeclaration,
	    isExportOrDefaultModifier: () => isExportOrDefaultModifier,
	    isExportSpecifier: () => isExportSpecifier,
	    isExportsIdentifier: () => isExportsIdentifier,
	    isExportsOrModuleExportsOrAlias: () => isExportsOrModuleExportsOrAlias,
	    isExpression: () => isExpression,
	    isExpressionNode: () => isExpressionNode,
	    isExpressionOfExternalModuleImportEqualsDeclaration: () => isExpressionOfExternalModuleImportEqualsDeclaration,
	    isExpressionOfOptionalChainRoot: () => isExpressionOfOptionalChainRoot,
	    isExpressionStatement: () => isExpressionStatement,
	    isExpressionWithTypeArguments: () => isExpressionWithTypeArguments,
	    isExpressionWithTypeArgumentsInClassExtendsClause: () => isExpressionWithTypeArgumentsInClassExtendsClause,
	    isExternalModule: () => isExternalModule,
	    isExternalModuleAugmentation: () => isExternalModuleAugmentation,
	    isExternalModuleImportEqualsDeclaration: () => isExternalModuleImportEqualsDeclaration,
	    isExternalModuleIndicator: () => isExternalModuleIndicator,
	    isExternalModuleNameRelative: () => isExternalModuleNameRelative,
	    isExternalModuleReference: () => isExternalModuleReference,
	    isExternalModuleSymbol: () => isExternalModuleSymbol,
	    isExternalOrCommonJsModule: () => isExternalOrCommonJsModule,
	    isFileLevelReservedGeneratedIdentifier: () => isFileLevelReservedGeneratedIdentifier,
	    isFileLevelUniqueName: () => isFileLevelUniqueName,
	    isFileProbablyExternalModule: () => isFileProbablyExternalModule,
	    isFirstDeclarationOfSymbolParameter: () => isFirstDeclarationOfSymbolParameter,
	    isFixablePromiseHandler: () => isFixablePromiseHandler,
	    isForInOrOfStatement: () => isForInOrOfStatement,
	    isForInStatement: () => isForInStatement,
	    isForInitializer: () => isForInitializer,
	    isForOfStatement: () => isForOfStatement,
	    isForStatement: () => isForStatement,
	    isFunctionBlock: () => isFunctionBlock,
	    isFunctionBody: () => isFunctionBody,
	    isFunctionDeclaration: () => isFunctionDeclaration,
	    isFunctionExpression: () => isFunctionExpression,
	    isFunctionExpressionOrArrowFunction: () => isFunctionExpressionOrArrowFunction,
	    isFunctionLike: () => isFunctionLike,
	    isFunctionLikeDeclaration: () => isFunctionLikeDeclaration,
	    isFunctionLikeKind: () => isFunctionLikeKind,
	    isFunctionLikeOrClassStaticBlockDeclaration: () => isFunctionLikeOrClassStaticBlockDeclaration,
	    isFunctionOrConstructorTypeNode: () => isFunctionOrConstructorTypeNode,
	    isFunctionOrModuleBlock: () => isFunctionOrModuleBlock,
	    isFunctionSymbol: () => isFunctionSymbol,
	    isFunctionTypeNode: () => isFunctionTypeNode,
	    isFutureReservedKeyword: () => isFutureReservedKeyword,
	    isGeneratedIdentifier: () => isGeneratedIdentifier,
	    isGeneratedPrivateIdentifier: () => isGeneratedPrivateIdentifier,
	    isGetAccessor: () => isGetAccessor,
	    isGetAccessorDeclaration: () => isGetAccessorDeclaration,
	    isGetOrSetAccessorDeclaration: () => isGetOrSetAccessorDeclaration,
	    isGlobalDeclaration: () => isGlobalDeclaration,
	    isGlobalScopeAugmentation: () => isGlobalScopeAugmentation,
	    isGrammarError: () => isGrammarError,
	    isHeritageClause: () => isHeritageClause,
	    isHoistedFunction: () => isHoistedFunction,
	    isHoistedVariableStatement: () => isHoistedVariableStatement,
	    isIdentifier: () => isIdentifier,
	    isIdentifierANonContextualKeyword: () => isIdentifierANonContextualKeyword,
	    isIdentifierName: () => isIdentifierName,
	    isIdentifierOrThisTypeNode: () => isIdentifierOrThisTypeNode,
	    isIdentifierPart: () => isIdentifierPart,
	    isIdentifierStart: () => isIdentifierStart,
	    isIdentifierText: () => isIdentifierText,
	    isIdentifierTypePredicate: () => isIdentifierTypePredicate,
	    isIdentifierTypeReference: () => isIdentifierTypeReference,
	    isIfStatement: () => isIfStatement,
	    isIgnoredFileFromWildCardWatching: () => isIgnoredFileFromWildCardWatching,
	    isImplicitGlob: () => isImplicitGlob,
	    isImportAttribute: () => isImportAttribute,
	    isImportAttributeName: () => isImportAttributeName,
	    isImportAttributes: () => isImportAttributes,
	    isImportCall: () => isImportCall,
	    isImportClause: () => isImportClause,
	    isImportDeclaration: () => isImportDeclaration,
	    isImportEqualsDeclaration: () => isImportEqualsDeclaration,
	    isImportKeyword: () => isImportKeyword,
	    isImportMeta: () => isImportMeta,
	    isImportOrExportSpecifier: () => isImportOrExportSpecifier,
	    isImportOrExportSpecifierName: () => isImportOrExportSpecifierName,
	    isImportSpecifier: () => isImportSpecifier,
	    isImportTypeAssertionContainer: () => isImportTypeAssertionContainer,
	    isImportTypeNode: () => isImportTypeNode,
	    isImportableFile: () => isImportableFile,
	    isInComment: () => isInComment,
	    isInCompoundLikeAssignment: () => isInCompoundLikeAssignment,
	    isInExpressionContext: () => isInExpressionContext,
	    isInJSDoc: () => isInJSDoc,
	    isInJSFile: () => isInJSFile,
	    isInJSXText: () => isInJSXText,
	    isInJsonFile: () => isInJsonFile,
	    isInNonReferenceComment: () => isInNonReferenceComment,
	    isInReferenceComment: () => isInReferenceComment,
	    isInRightSideOfInternalImportEqualsDeclaration: () => isInRightSideOfInternalImportEqualsDeclaration,
	    isInString: () => isInString,
	    isInTemplateString: () => isInTemplateString,
	    isInTopLevelContext: () => isInTopLevelContext,
	    isInTypeQuery: () => isInTypeQuery,
	    isIncrementalCompilation: () => isIncrementalCompilation,
	    isIndexSignatureDeclaration: () => isIndexSignatureDeclaration,
	    isIndexedAccessTypeNode: () => isIndexedAccessTypeNode,
	    isInferTypeNode: () => isInferTypeNode,
	    isInfinityOrNaNString: () => isInfinityOrNaNString,
	    isInitializedProperty: () => isInitializedProperty,
	    isInitializedVariable: () => isInitializedVariable,
	    isInsideJsxElement: () => isInsideJsxElement,
	    isInsideJsxElementOrAttribute: () => isInsideJsxElementOrAttribute,
	    isInsideNodeModules: () => isInsideNodeModules,
	    isInsideTemplateLiteral: () => isInsideTemplateLiteral,
	    isInstanceOfExpression: () => isInstanceOfExpression,
	    isInstantiatedModule: () => isInstantiatedModule,
	    isInterfaceDeclaration: () => isInterfaceDeclaration,
	    isInternalDeclaration: () => isInternalDeclaration,
	    isInternalModuleImportEqualsDeclaration: () => isInternalModuleImportEqualsDeclaration,
	    isInternalName: () => isInternalName,
	    isIntersectionTypeNode: () => isIntersectionTypeNode,
	    isIntrinsicJsxName: () => isIntrinsicJsxName,
	    isIterationStatement: () => isIterationStatement,
	    isJSDoc: () => isJSDoc,
	    isJSDocAllType: () => isJSDocAllType,
	    isJSDocAugmentsTag: () => isJSDocAugmentsTag,
	    isJSDocAuthorTag: () => isJSDocAuthorTag,
	    isJSDocCallbackTag: () => isJSDocCallbackTag,
	    isJSDocClassTag: () => isJSDocClassTag,
	    isJSDocCommentContainingNode: () => isJSDocCommentContainingNode,
	    isJSDocConstructSignature: () => isJSDocConstructSignature,
	    isJSDocDeprecatedTag: () => isJSDocDeprecatedTag,
	    isJSDocEnumTag: () => isJSDocEnumTag,
	    isJSDocFunctionType: () => isJSDocFunctionType,
	    isJSDocImplementsTag: () => isJSDocImplementsTag,
	    isJSDocIndexSignature: () => isJSDocIndexSignature,
	    isJSDocLikeText: () => isJSDocLikeText,
	    isJSDocLink: () => isJSDocLink,
	    isJSDocLinkCode: () => isJSDocLinkCode,
	    isJSDocLinkLike: () => isJSDocLinkLike,
	    isJSDocLinkPlain: () => isJSDocLinkPlain,
	    isJSDocMemberName: () => isJSDocMemberName,
	    isJSDocNameReference: () => isJSDocNameReference,
	    isJSDocNamepathType: () => isJSDocNamepathType,
	    isJSDocNamespaceBody: () => isJSDocNamespaceBody,
	    isJSDocNode: () => isJSDocNode,
	    isJSDocNonNullableType: () => isJSDocNonNullableType,
	    isJSDocNullableType: () => isJSDocNullableType,
	    isJSDocOptionalParameter: () => isJSDocOptionalParameter,
	    isJSDocOptionalType: () => isJSDocOptionalType,
	    isJSDocOverloadTag: () => isJSDocOverloadTag,
	    isJSDocOverrideTag: () => isJSDocOverrideTag,
	    isJSDocParameterTag: () => isJSDocParameterTag,
	    isJSDocPrivateTag: () => isJSDocPrivateTag,
	    isJSDocPropertyLikeTag: () => isJSDocPropertyLikeTag,
	    isJSDocPropertyTag: () => isJSDocPropertyTag,
	    isJSDocProtectedTag: () => isJSDocProtectedTag,
	    isJSDocPublicTag: () => isJSDocPublicTag,
	    isJSDocReadonlyTag: () => isJSDocReadonlyTag,
	    isJSDocReturnTag: () => isJSDocReturnTag,
	    isJSDocSatisfiesExpression: () => isJSDocSatisfiesExpression,
	    isJSDocSatisfiesTag: () => isJSDocSatisfiesTag,
	    isJSDocSeeTag: () => isJSDocSeeTag,
	    isJSDocSignature: () => isJSDocSignature,
	    isJSDocTag: () => isJSDocTag,
	    isJSDocTemplateTag: () => isJSDocTemplateTag,
	    isJSDocThisTag: () => isJSDocThisTag,
	    isJSDocThrowsTag: () => isJSDocThrowsTag,
	    isJSDocTypeAlias: () => isJSDocTypeAlias,
	    isJSDocTypeAssertion: () => isJSDocTypeAssertion,
	    isJSDocTypeExpression: () => isJSDocTypeExpression,
	    isJSDocTypeLiteral: () => isJSDocTypeLiteral,
	    isJSDocTypeTag: () => isJSDocTypeTag,
	    isJSDocTypedefTag: () => isJSDocTypedefTag,
	    isJSDocUnknownTag: () => isJSDocUnknownTag,
	    isJSDocUnknownType: () => isJSDocUnknownType,
	    isJSDocVariadicType: () => isJSDocVariadicType,
	    isJSXTagName: () => isJSXTagName,
	    isJsonEqual: () => isJsonEqual,
	    isJsonSourceFile: () => isJsonSourceFile,
	    isJsxAttribute: () => isJsxAttribute,
	    isJsxAttributeLike: () => isJsxAttributeLike,
	    isJsxAttributeName: () => isJsxAttributeName,
	    isJsxAttributes: () => isJsxAttributes,
	    isJsxChild: () => isJsxChild,
	    isJsxClosingElement: () => isJsxClosingElement,
	    isJsxClosingFragment: () => isJsxClosingFragment,
	    isJsxElement: () => isJsxElement,
	    isJsxExpression: () => isJsxExpression,
	    isJsxFragment: () => isJsxFragment,
	    isJsxNamespacedName: () => isJsxNamespacedName,
	    isJsxOpeningElement: () => isJsxOpeningElement,
	    isJsxOpeningFragment: () => isJsxOpeningFragment,
	    isJsxOpeningLikeElement: () => isJsxOpeningLikeElement,
	    isJsxOpeningLikeElementTagName: () => isJsxOpeningLikeElementTagName,
	    isJsxSelfClosingElement: () => isJsxSelfClosingElement,
	    isJsxSpreadAttribute: () => isJsxSpreadAttribute,
	    isJsxTagNameExpression: () => isJsxTagNameExpression,
	    isJsxText: () => isJsxText,
	    isJumpStatementTarget: () => isJumpStatementTarget,
	    isKeyword: () => isKeyword,
	    isKeywordOrPunctuation: () => isKeywordOrPunctuation,
	    isKnownSymbol: () => isKnownSymbol,
	    isLabelName: () => isLabelName,
	    isLabelOfLabeledStatement: () => isLabelOfLabeledStatement,
	    isLabeledStatement: () => isLabeledStatement,
	    isLateVisibilityPaintedStatement: () => isLateVisibilityPaintedStatement,
	    isLeftHandSideExpression: () => isLeftHandSideExpression,
	    isLeftHandSideOfAssignment: () => isLeftHandSideOfAssignment,
	    isLet: () => isLet,
	    isLineBreak: () => isLineBreak,
	    isLiteralComputedPropertyDeclarationName: () => isLiteralComputedPropertyDeclarationName,
	    isLiteralExpression: () => isLiteralExpression,
	    isLiteralExpressionOfObject: () => isLiteralExpressionOfObject,
	    isLiteralImportTypeNode: () => isLiteralImportTypeNode,
	    isLiteralKind: () => isLiteralKind,
	    isLiteralLikeAccess: () => isLiteralLikeAccess,
	    isLiteralLikeElementAccess: () => isLiteralLikeElementAccess,
	    isLiteralNameOfPropertyDeclarationOrIndexAccess: () => isLiteralNameOfPropertyDeclarationOrIndexAccess,
	    isLiteralTypeLikeExpression: () => isLiteralTypeLikeExpression,
	    isLiteralTypeLiteral: () => isLiteralTypeLiteral,
	    isLiteralTypeNode: () => isLiteralTypeNode,
	    isLocalName: () => isLocalName,
	    isLogicalOperator: () => isLogicalOperator,
	    isLogicalOrCoalescingAssignmentExpression: () => isLogicalOrCoalescingAssignmentExpression,
	    isLogicalOrCoalescingAssignmentOperator: () => isLogicalOrCoalescingAssignmentOperator,
	    isLogicalOrCoalescingBinaryExpression: () => isLogicalOrCoalescingBinaryExpression,
	    isLogicalOrCoalescingBinaryOperator: () => isLogicalOrCoalescingBinaryOperator,
	    isMappedTypeNode: () => isMappedTypeNode,
	    isMemberName: () => isMemberName,
	    isMetaProperty: () => isMetaProperty,
	    isMethodDeclaration: () => isMethodDeclaration,
	    isMethodOrAccessor: () => isMethodOrAccessor,
	    isMethodSignature: () => isMethodSignature,
	    isMinusToken: () => isMinusToken,
	    isMissingDeclaration: () => isMissingDeclaration,
	    isMissingPackageJsonInfo: () => isMissingPackageJsonInfo,
	    isModifier: () => isModifier,
	    isModifierKind: () => isModifierKind,
	    isModifierLike: () => isModifierLike,
	    isModuleAugmentationExternal: () => isModuleAugmentationExternal,
	    isModuleBlock: () => isModuleBlock,
	    isModuleBody: () => isModuleBody,
	    isModuleDeclaration: () => isModuleDeclaration,
	    isModuleExportsAccessExpression: () => isModuleExportsAccessExpression,
	    isModuleIdentifier: () => isModuleIdentifier,
	    isModuleName: () => isModuleName,
	    isModuleOrEnumDeclaration: () => isModuleOrEnumDeclaration,
	    isModuleReference: () => isModuleReference,
	    isModuleSpecifierLike: () => isModuleSpecifierLike,
	    isModuleWithStringLiteralName: () => isModuleWithStringLiteralName,
	    isNameOfFunctionDeclaration: () => isNameOfFunctionDeclaration,
	    isNameOfModuleDeclaration: () => isNameOfModuleDeclaration,
	    isNamedClassElement: () => isNamedClassElement,
	    isNamedDeclaration: () => isNamedDeclaration,
	    isNamedEvaluation: () => isNamedEvaluation,
	    isNamedEvaluationSource: () => isNamedEvaluationSource,
	    isNamedExportBindings: () => isNamedExportBindings,
	    isNamedExports: () => isNamedExports,
	    isNamedImportBindings: () => isNamedImportBindings,
	    isNamedImports: () => isNamedImports,
	    isNamedImportsOrExports: () => isNamedImportsOrExports,
	    isNamedTupleMember: () => isNamedTupleMember,
	    isNamespaceBody: () => isNamespaceBody,
	    isNamespaceExport: () => isNamespaceExport,
	    isNamespaceExportDeclaration: () => isNamespaceExportDeclaration,
	    isNamespaceImport: () => isNamespaceImport,
	    isNamespaceReexportDeclaration: () => isNamespaceReexportDeclaration,
	    isNewExpression: () => isNewExpression,
	    isNewExpressionTarget: () => isNewExpressionTarget,
	    isNoSubstitutionTemplateLiteral: () => isNoSubstitutionTemplateLiteral,
	    isNode: () => isNode,
	    isNodeArray: () => isNodeArray,
	    isNodeArrayMultiLine: () => isNodeArrayMultiLine,
	    isNodeDescendantOf: () => isNodeDescendantOf,
	    isNodeKind: () => isNodeKind,
	    isNodeLikeSystem: () => isNodeLikeSystem,
	    isNodeModulesDirectory: () => isNodeModulesDirectory,
	    isNodeWithPossibleHoistedDeclaration: () => isNodeWithPossibleHoistedDeclaration,
	    isNonContextualKeyword: () => isNonContextualKeyword,
	    isNonExportDefaultModifier: () => isNonExportDefaultModifier,
	    isNonGlobalAmbientModule: () => isNonGlobalAmbientModule,
	    isNonGlobalDeclaration: () => isNonGlobalDeclaration,
	    isNonNullAccess: () => isNonNullAccess,
	    isNonNullChain: () => isNonNullChain,
	    isNonNullExpression: () => isNonNullExpression,
	    isNonStaticMethodOrAccessorWithPrivateName: () => isNonStaticMethodOrAccessorWithPrivateName,
	    isNotEmittedOrPartiallyEmittedNode: () => isNotEmittedOrPartiallyEmittedNode,
	    isNotEmittedStatement: () => isNotEmittedStatement,
	    isNullishCoalesce: () => isNullishCoalesce,
	    isNumber: () => isNumber,
	    isNumericLiteral: () => isNumericLiteral,
	    isNumericLiteralName: () => isNumericLiteralName,
	    isObjectBindingElementWithoutPropertyName: () => isObjectBindingElementWithoutPropertyName,
	    isObjectBindingOrAssignmentElement: () => isObjectBindingOrAssignmentElement,
	    isObjectBindingOrAssignmentPattern: () => isObjectBindingOrAssignmentPattern,
	    isObjectBindingPattern: () => isObjectBindingPattern,
	    isObjectLiteralElement: () => isObjectLiteralElement,
	    isObjectLiteralElementLike: () => isObjectLiteralElementLike,
	    isObjectLiteralExpression: () => isObjectLiteralExpression,
	    isObjectLiteralMethod: () => isObjectLiteralMethod,
	    isObjectLiteralOrClassExpressionMethodOrAccessor: () => isObjectLiteralOrClassExpressionMethodOrAccessor,
	    isObjectTypeDeclaration: () => isObjectTypeDeclaration,
	    isOctalDigit: () => isOctalDigit,
	    isOmittedExpression: () => isOmittedExpression,
	    isOptionalChain: () => isOptionalChain,
	    isOptionalChainRoot: () => isOptionalChainRoot,
	    isOptionalDeclaration: () => isOptionalDeclaration,
	    isOptionalJSDocPropertyLikeTag: () => isOptionalJSDocPropertyLikeTag,
	    isOptionalTypeNode: () => isOptionalTypeNode,
	    isOuterExpression: () => isOuterExpression,
	    isOutermostOptionalChain: () => isOutermostOptionalChain,
	    isOverrideModifier: () => isOverrideModifier,
	    isPackageJsonInfo: () => isPackageJsonInfo,
	    isPackedArrayLiteral: () => isPackedArrayLiteral,
	    isParameter: () => isParameter,
	    isParameterDeclaration: () => isParameterDeclaration,
	    isParameterPropertyDeclaration: () => isParameterPropertyDeclaration,
	    isParameterPropertyModifier: () => isParameterPropertyModifier,
	    isParenthesizedExpression: () => isParenthesizedExpression,
	    isParenthesizedTypeNode: () => isParenthesizedTypeNode,
	    isParseTreeNode: () => isParseTreeNode,
	    isPartOfTypeNode: () => isPartOfTypeNode,
	    isPartOfTypeQuery: () => isPartOfTypeQuery,
	    isPartiallyEmittedExpression: () => isPartiallyEmittedExpression,
	    isPatternMatch: () => isPatternMatch,
	    isPinnedComment: () => isPinnedComment,
	    isPlainJsFile: () => isPlainJsFile,
	    isPlusToken: () => isPlusToken,
	    isPossiblyTypeArgumentPosition: () => isPossiblyTypeArgumentPosition,
	    isPostfixUnaryExpression: () => isPostfixUnaryExpression,
	    isPrefixUnaryExpression: () => isPrefixUnaryExpression,
	    isPrivateIdentifier: () => isPrivateIdentifier,
	    isPrivateIdentifierClassElementDeclaration: () => isPrivateIdentifierClassElementDeclaration,
	    isPrivateIdentifierPropertyAccessExpression: () => isPrivateIdentifierPropertyAccessExpression,
	    isPrivateIdentifierSymbol: () => isPrivateIdentifierSymbol,
	    isProgramBundleEmitBuildInfo: () => isProgramBundleEmitBuildInfo,
	    isProgramUptoDate: () => isProgramUptoDate,
	    isPrologueDirective: () => isPrologueDirective,
	    isPropertyAccessChain: () => isPropertyAccessChain,
	    isPropertyAccessEntityNameExpression: () => isPropertyAccessEntityNameExpression,
	    isPropertyAccessExpression: () => isPropertyAccessExpression,
	    isPropertyAccessOrQualifiedName: () => isPropertyAccessOrQualifiedName,
	    isPropertyAccessOrQualifiedNameOrImportTypeNode: () => isPropertyAccessOrQualifiedNameOrImportTypeNode,
	    isPropertyAssignment: () => isPropertyAssignment,
	    isPropertyDeclaration: () => isPropertyDeclaration,
	    isPropertyName: () => isPropertyName,
	    isPropertyNameLiteral: () => isPropertyNameLiteral,
	    isPropertySignature: () => isPropertySignature,
	    isProtoSetter: () => isProtoSetter,
	    isPrototypeAccess: () => isPrototypeAccess,
	    isPrototypePropertyAssignment: () => isPrototypePropertyAssignment,
	    isPunctuation: () => isPunctuation,
	    isPushOrUnshiftIdentifier: () => isPushOrUnshiftIdentifier,
	    isQualifiedName: () => isQualifiedName,
	    isQuestionDotToken: () => isQuestionDotToken,
	    isQuestionOrExclamationToken: () => isQuestionOrExclamationToken,
	    isQuestionOrPlusOrMinusToken: () => isQuestionOrPlusOrMinusToken,
	    isQuestionToken: () => isQuestionToken,
	    isRawSourceMap: () => isRawSourceMap,
	    isReadonlyKeyword: () => isReadonlyKeyword,
	    isReadonlyKeywordOrPlusOrMinusToken: () => isReadonlyKeywordOrPlusOrMinusToken,
	    isRecognizedTripleSlashComment: () => isRecognizedTripleSlashComment,
	    isReferenceFileLocation: () => isReferenceFileLocation,
	    isReferencedFile: () => isReferencedFile,
	    isRegularExpressionLiteral: () => isRegularExpressionLiteral,
	    isRequireCall: () => isRequireCall,
	    isRequireVariableStatement: () => isRequireVariableStatement,
	    isRestParameter: () => isRestParameter,
	    isRestTypeNode: () => isRestTypeNode,
	    isReturnStatement: () => isReturnStatement,
	    isReturnStatementWithFixablePromiseHandler: () => isReturnStatementWithFixablePromiseHandler,
	    isRightSideOfAccessExpression: () => isRightSideOfAccessExpression,
	    isRightSideOfInstanceofExpression: () => isRightSideOfInstanceofExpression,
	    isRightSideOfPropertyAccess: () => isRightSideOfPropertyAccess,
	    isRightSideOfQualifiedName: () => isRightSideOfQualifiedName,
	    isRightSideOfQualifiedNameOrPropertyAccess: () => isRightSideOfQualifiedNameOrPropertyAccess,
	    isRightSideOfQualifiedNameOrPropertyAccessOrJSDocMemberName: () => isRightSideOfQualifiedNameOrPropertyAccessOrJSDocMemberName,
	    isRootedDiskPath: () => isRootedDiskPath,
	    isSameEntityName: () => isSameEntityName,
	    isSatisfiesExpression: () => isSatisfiesExpression,
	    isScopeMarker: () => isScopeMarker,
	    isSemicolonClassElement: () => isSemicolonClassElement,
	    isSetAccessor: () => isSetAccessor,
	    isSetAccessorDeclaration: () => isSetAccessorDeclaration,
	    isShebangTrivia: () => isShebangTrivia,
	    isShiftOperatorOrHigher: () => isShiftOperatorOrHigher,
	    isShorthandAmbientModuleSymbol: () => isShorthandAmbientModuleSymbol,
	    isShorthandPropertyAssignment: () => isShorthandPropertyAssignment,
	    isSignedNumericLiteral: () => isSignedNumericLiteral,
	    isSimpleCopiableExpression: () => isSimpleCopiableExpression,
	    isSimpleInlineableExpression: () => isSimpleInlineableExpression,
	    isSimpleParameter: () => isSimpleParameter,
	    isSimpleParameterList: () => isSimpleParameterList,
	    isSingleOrDoubleQuote: () => isSingleOrDoubleQuote,
	    isSourceFile: () => isSourceFile,
	    isSourceFileFromLibrary: () => isSourceFileFromLibrary,
	    isSourceFileJS: () => isSourceFileJS,
	    isSourceFileNotJS: () => isSourceFileNotJS,
	    isSourceFileNotJson: () => isSourceFileNotJson,
	    isSourceMapping: () => isSourceMapping,
	    isSpecialPropertyDeclaration: () => isSpecialPropertyDeclaration,
	    isSpreadAssignment: () => isSpreadAssignment,
	    isSpreadElement: () => isSpreadElement,
	    isStatement: () => isStatement,
	    isStatementButNotDeclaration: () => isStatementButNotDeclaration,
	    isStatementOrBlock: () => isStatementOrBlock,
	    isStatementWithLocals: () => isStatementWithLocals,
	    isStatic: () => isStatic,
	    isStaticModifier: () => isStaticModifier,
	    isString: () => isString,
	    isStringAKeyword: () => isStringAKeyword,
	    isStringANonContextualKeyword: () => isStringANonContextualKeyword,
	    isStringAndEmptyAnonymousObjectIntersection: () => isStringAndEmptyAnonymousObjectIntersection,
	    isStringDoubleQuoted: () => isStringDoubleQuoted,
	    isStringLiteral: () => isStringLiteral,
	    isStringLiteralLike: () => isStringLiteralLike,
	    isStringLiteralOrJsxExpression: () => isStringLiteralOrJsxExpression,
	    isStringLiteralOrTemplate: () => isStringLiteralOrTemplate,
	    isStringOrNumericLiteralLike: () => isStringOrNumericLiteralLike,
	    isStringOrRegularExpressionOrTemplateLiteral: () => isStringOrRegularExpressionOrTemplateLiteral,
	    isStringTextContainingNode: () => isStringTextContainingNode,
	    isSuperCall: () => isSuperCall,
	    isSuperKeyword: () => isSuperKeyword,
	    isSuperOrSuperProperty: () => isSuperOrSuperProperty,
	    isSuperProperty: () => isSuperProperty,
	    isSupportedSourceFileName: () => isSupportedSourceFileName,
	    isSwitchStatement: () => isSwitchStatement,
	    isSyntaxList: () => isSyntaxList,
	    isSyntheticExpression: () => isSyntheticExpression,
	    isSyntheticReference: () => isSyntheticReference,
	    isTagName: () => isTagName,
	    isTaggedTemplateExpression: () => isTaggedTemplateExpression,
	    isTaggedTemplateTag: () => isTaggedTemplateTag,
	    isTemplateExpression: () => isTemplateExpression,
	    isTemplateHead: () => isTemplateHead,
	    isTemplateLiteral: () => isTemplateLiteral,
	    isTemplateLiteralKind: () => isTemplateLiteralKind,
	    isTemplateLiteralToken: () => isTemplateLiteralToken,
	    isTemplateLiteralTypeNode: () => isTemplateLiteralTypeNode,
	    isTemplateLiteralTypeSpan: () => isTemplateLiteralTypeSpan,
	    isTemplateMiddle: () => isTemplateMiddle,
	    isTemplateMiddleOrTemplateTail: () => isTemplateMiddleOrTemplateTail,
	    isTemplateSpan: () => isTemplateSpan,
	    isTemplateTail: () => isTemplateTail,
	    isTextWhiteSpaceLike: () => isTextWhiteSpaceLike,
	    isThis: () => isThis,
	    isThisContainerOrFunctionBlock: () => isThisContainerOrFunctionBlock,
	    isThisIdentifier: () => isThisIdentifier,
	    isThisInTypeQuery: () => isThisInTypeQuery,
	    isThisInitializedDeclaration: () => isThisInitializedDeclaration,
	    isThisInitializedObjectBindingExpression: () => isThisInitializedObjectBindingExpression,
	    isThisProperty: () => isThisProperty,
	    isThisTypeNode: () => isThisTypeNode,
	    isThisTypeParameter: () => isThisTypeParameter,
	    isThisTypePredicate: () => isThisTypePredicate,
	    isThrowStatement: () => isThrowStatement,
	    isToken: () => isToken,
	    isTokenKind: () => isTokenKind,
	    isTraceEnabled: () => isTraceEnabled,
	    isTransientSymbol: () => isTransientSymbol,
	    isTrivia: () => isTrivia,
	    isTryStatement: () => isTryStatement,
	    isTupleTypeNode: () => isTupleTypeNode,
	    isTypeAlias: () => isTypeAlias,
	    isTypeAliasDeclaration: () => isTypeAliasDeclaration,
	    isTypeAssertionExpression: () => isTypeAssertionExpression,
	    isTypeDeclaration: () => isTypeDeclaration,
	    isTypeElement: () => isTypeElement,
	    isTypeKeyword: () => isTypeKeyword,
	    isTypeKeywordToken: () => isTypeKeywordToken,
	    isTypeKeywordTokenOrIdentifier: () => isTypeKeywordTokenOrIdentifier,
	    isTypeLiteralNode: () => isTypeLiteralNode,
	    isTypeNode: () => isTypeNode,
	    isTypeNodeKind: () => isTypeNodeKind,
	    isTypeOfExpression: () => isTypeOfExpression,
	    isTypeOnlyExportDeclaration: () => isTypeOnlyExportDeclaration,
	    isTypeOnlyImportDeclaration: () => isTypeOnlyImportDeclaration,
	    isTypeOnlyImportOrExportDeclaration: () => isTypeOnlyImportOrExportDeclaration,
	    isTypeOperatorNode: () => isTypeOperatorNode,
	    isTypeParameterDeclaration: () => isTypeParameterDeclaration,
	    isTypePredicateNode: () => isTypePredicateNode,
	    isTypeQueryNode: () => isTypeQueryNode,
	    isTypeReferenceNode: () => isTypeReferenceNode,
	    isTypeReferenceType: () => isTypeReferenceType,
	    isTypeUsableAsPropertyName: () => isTypeUsableAsPropertyName,
	    isUMDExportSymbol: () => isUMDExportSymbol,
	    isUnaryExpression: () => isUnaryExpression,
	    isUnaryExpressionWithWrite: () => isUnaryExpressionWithWrite,
	    isUnicodeIdentifierStart: () => isUnicodeIdentifierStart,
	    isUnionTypeNode: () => isUnionTypeNode,
	    isUnparsedNode: () => isUnparsedNode,
	    isUnparsedPrepend: () => isUnparsedPrepend,
	    isUnparsedSource: () => isUnparsedSource,
	    isUnparsedTextLike: () => isUnparsedTextLike,
	    isUrl: () => isUrl,
	    isValidBigIntString: () => isValidBigIntString,
	    isValidESSymbolDeclaration: () => isValidESSymbolDeclaration,
	    isValidTypeOnlyAliasUseSite: () => isValidTypeOnlyAliasUseSite,
	    isValueSignatureDeclaration: () => isValueSignatureDeclaration,
	    isVarAwaitUsing: () => isVarAwaitUsing,
	    isVarConst: () => isVarConst,
	    isVarUsing: () => isVarUsing,
	    isVariableDeclaration: () => isVariableDeclaration,
	    isVariableDeclarationInVariableStatement: () => isVariableDeclarationInVariableStatement,
	    isVariableDeclarationInitializedToBareOrAccessedRequire: () => isVariableDeclarationInitializedToBareOrAccessedRequire,
	    isVariableDeclarationInitializedToRequire: () => isVariableDeclarationInitializedToRequire,
	    isVariableDeclarationList: () => isVariableDeclarationList,
	    isVariableLike: () => isVariableLike,
	    isVariableLikeOrAccessor: () => isVariableLikeOrAccessor,
	    isVariableStatement: () => isVariableStatement,
	    isVoidExpression: () => isVoidExpression,
	    isWatchSet: () => isWatchSet,
	    isWhileStatement: () => isWhileStatement,
	    isWhiteSpaceLike: () => isWhiteSpaceLike,
	    isWhiteSpaceSingleLine: () => isWhiteSpaceSingleLine,
	    isWithStatement: () => isWithStatement,
	    isWriteAccess: () => isWriteAccess,
	    isWriteOnlyAccess: () => isWriteOnlyAccess,
	    isYieldExpression: () => isYieldExpression,
	    jsxModeNeedsExplicitImport: () => jsxModeNeedsExplicitImport,
	    keywordPart: () => keywordPart,
	    last: () => last,
	    lastOrUndefined: () => lastOrUndefined,
	    length: () => length,
	    libMap: () => libMap,
	    libs: () => libs,
	    lineBreakPart: () => lineBreakPart,
	    linkNamePart: () => linkNamePart,
	    linkPart: () => linkPart,
	    linkTextPart: () => linkTextPart,
	    listFiles: () => listFiles,
	    loadModuleFromGlobalCache: () => loadModuleFromGlobalCache,
	    loadWithModeAwareCache: () => loadWithModeAwareCache,
	    makeIdentifierFromModuleName: () => makeIdentifierFromModuleName,
	    makeImport: () => makeImport,
	    makeImportIfNecessary: () => makeImportIfNecessary,
	    makeStringLiteral: () => makeStringLiteral,
	    mangleScopedPackageName: () => mangleScopedPackageName,
	    map: () => map,
	    mapAllOrFail: () => mapAllOrFail,
	    mapDefined: () => mapDefined,
	    mapDefinedEntries: () => mapDefinedEntries,
	    mapDefinedIterator: () => mapDefinedIterator,
	    mapEntries: () => mapEntries,
	    mapIterator: () => mapIterator,
	    mapOneOrMany: () => mapOneOrMany,
	    mapToDisplayParts: () => mapToDisplayParts,
	    matchFiles: () => matchFiles,
	    matchPatternOrExact: () => matchPatternOrExact,
	    matchedText: () => matchedText,
	    matchesExclude: () => matchesExclude,
	    maybeBind: () => maybeBind,
	    maybeSetLocalizedDiagnosticMessages: () => maybeSetLocalizedDiagnosticMessages,
	    memoize: () => memoize,
	    memoizeCached: () => memoizeCached,
	    memoizeOne: () => memoizeOne,
	    memoizeWeak: () => memoizeWeak,
	    metadataHelper: () => metadataHelper,
	    min: () => min,
	    minAndMax: () => minAndMax,
	    missingFileModifiedTime: () => missingFileModifiedTime,
	    modifierToFlag: () => modifierToFlag,
	    modifiersToFlags: () => modifiersToFlags,
	    moduleOptionDeclaration: () => moduleOptionDeclaration,
	    moduleResolutionIsEqualTo: () => moduleResolutionIsEqualTo,
	    moduleResolutionNameAndModeGetter: () => moduleResolutionNameAndModeGetter,
	    moduleResolutionOptionDeclarations: () => moduleResolutionOptionDeclarations,
	    moduleResolutionSupportsPackageJsonExportsAndImports: () => moduleResolutionSupportsPackageJsonExportsAndImports,
	    moduleResolutionUsesNodeModules: () => moduleResolutionUsesNodeModules,
	    moduleSpecifiers: () => ts_moduleSpecifiers_exports,
	    moveEmitHelpers: () => moveEmitHelpers,
	    moveRangeEnd: () => moveRangeEnd,
	    moveRangePastDecorators: () => moveRangePastDecorators,
	    moveRangePastModifiers: () => moveRangePastModifiers,
	    moveRangePos: () => moveRangePos,
	    moveSyntheticComments: () => moveSyntheticComments,
	    mutateMap: () => mutateMap,
	    mutateMapSkippingNewValues: () => mutateMapSkippingNewValues,
	    needsParentheses: () => needsParentheses,
	    needsScopeMarker: () => needsScopeMarker,
	    newCaseClauseTracker: () => newCaseClauseTracker,
	    newPrivateEnvironment: () => newPrivateEnvironment,
	    noEmitNotification: () => noEmitNotification,
	    noEmitSubstitution: () => noEmitSubstitution,
	    noTransformers: () => noTransformers,
	    noTruncationMaximumTruncationLength: () => noTruncationMaximumTruncationLength,
	    nodeCanBeDecorated: () => nodeCanBeDecorated,
	    nodeHasName: () => nodeHasName,
	    nodeIsDecorated: () => nodeIsDecorated,
	    nodeIsMissing: () => nodeIsMissing,
	    nodeIsPresent: () => nodeIsPresent,
	    nodeIsSynthesized: () => nodeIsSynthesized,
	    nodeModuleNameResolver: () => nodeModuleNameResolver,
	    nodeModulesPathPart: () => nodeModulesPathPart,
	    nodeNextJsonConfigResolver: () => nodeNextJsonConfigResolver,
	    nodeOrChildIsDecorated: () => nodeOrChildIsDecorated,
	    nodeOverlapsWithStartEnd: () => nodeOverlapsWithStartEnd,
	    nodePosToString: () => nodePosToString,
	    nodeSeenTracker: () => nodeSeenTracker,
	    nodeStartsNewLexicalEnvironment: () => nodeStartsNewLexicalEnvironment,
	    nodeToDisplayParts: () => nodeToDisplayParts,
	    noop: () => noop,
	    noopFileWatcher: () => noopFileWatcher,
	    normalizePath: () => normalizePath,
	    normalizeSlashes: () => normalizeSlashes,
	    not: () => not,
	    notImplemented: () => notImplemented,
	    notImplementedResolver: () => notImplementedResolver,
	    nullNodeConverters: () => nullNodeConverters,
	    nullParenthesizerRules: () => nullParenthesizerRules,
	    nullTransformationContext: () => nullTransformationContext,
	    objectAllocator: () => objectAllocator,
	    operatorPart: () => operatorPart,
	    optionDeclarations: () => optionDeclarations,
	    optionMapToObject: () => optionMapToObject,
	    optionsAffectingProgramStructure: () => optionsAffectingProgramStructure,
	    optionsForBuild: () => optionsForBuild,
	    optionsForWatch: () => optionsForWatch,
	    optionsHaveChanges: () => optionsHaveChanges,
	    optionsHaveModuleResolutionChanges: () => optionsHaveModuleResolutionChanges,
	    or: () => or,
	    orderedRemoveItem: () => orderedRemoveItem,
	    orderedRemoveItemAt: () => orderedRemoveItemAt,
	    outFile: () => outFile,
	    packageIdToPackageName: () => packageIdToPackageName,
	    packageIdToString: () => packageIdToString,
	    paramHelper: () => paramHelper,
	    parameterIsThisKeyword: () => parameterIsThisKeyword,
	    parameterNamePart: () => parameterNamePart,
	    parseBaseNodeFactory: () => parseBaseNodeFactory,
	    parseBigInt: () => parseBigInt,
	    parseBuildCommand: () => parseBuildCommand,
	    parseCommandLine: () => parseCommandLine,
	    parseCommandLineWorker: () => parseCommandLineWorker,
	    parseConfigFileTextToJson: () => parseConfigFileTextToJson,
	    parseConfigFileWithSystem: () => parseConfigFileWithSystem,
	    parseConfigHostFromCompilerHostLike: () => parseConfigHostFromCompilerHostLike,
	    parseCustomTypeOption: () => parseCustomTypeOption,
	    parseIsolatedEntityName: () => parseIsolatedEntityName,
	    parseIsolatedJSDocComment: () => parseIsolatedJSDocComment,
	    parseJSDocTypeExpressionForTests: () => parseJSDocTypeExpressionForTests,
	    parseJsonConfigFileContent: () => parseJsonConfigFileContent,
	    parseJsonSourceFileConfigFileContent: () => parseJsonSourceFileConfigFileContent,
	    parseJsonText: () => parseJsonText,
	    parseListTypeOption: () => parseListTypeOption,
	    parseNodeFactory: () => parseNodeFactory,
	    parseNodeModuleFromPath: () => parseNodeModuleFromPath,
	    parsePackageName: () => parsePackageName,
	    parsePseudoBigInt: () => parsePseudoBigInt,
	    parseValidBigInt: () => parseValidBigInt,
	    patchWriteFileEnsuringDirectory: () => patchWriteFileEnsuringDirectory,
	    pathContainsNodeModules: () => pathContainsNodeModules,
	    pathIsAbsolute: () => pathIsAbsolute,
	    pathIsBareSpecifier: () => pathIsBareSpecifier,
	    pathIsRelative: () => pathIsRelative,
	    patternText: () => patternText,
	    perfLogger: () => perfLogger,
	    performIncrementalCompilation: () => performIncrementalCompilation,
	    performance: () => ts_performance_exports,
	    plainJSErrors: () => plainJSErrors,
	    positionBelongsToNode: () => positionBelongsToNode,
	    positionIsASICandidate: () => positionIsASICandidate,
	    positionIsSynthesized: () => positionIsSynthesized,
	    positionsAreOnSameLine: () => positionsAreOnSameLine,
	    preProcessFile: () => preProcessFile,
	    probablyUsesSemicolons: () => probablyUsesSemicolons,
	    processCommentPragmas: () => processCommentPragmas,
	    processPragmasIntoFields: () => processPragmasIntoFields,
	    processTaggedTemplateExpression: () => processTaggedTemplateExpression,
	    programContainsEsModules: () => programContainsEsModules,
	    programContainsModules: () => programContainsModules,
	    projectReferenceIsEqualTo: () => projectReferenceIsEqualTo,
	    propKeyHelper: () => propKeyHelper,
	    propertyNamePart: () => propertyNamePart,
	    pseudoBigIntToString: () => pseudoBigIntToString,
	    punctuationPart: () => punctuationPart,
	    pushIfUnique: () => pushIfUnique,
	    quote: () => quote,
	    quotePreferenceFromString: () => quotePreferenceFromString,
	    rangeContainsPosition: () => rangeContainsPosition,
	    rangeContainsPositionExclusive: () => rangeContainsPositionExclusive,
	    rangeContainsRange: () => rangeContainsRange,
	    rangeContainsRangeExclusive: () => rangeContainsRangeExclusive,
	    rangeContainsStartEnd: () => rangeContainsStartEnd,
	    rangeEndIsOnSameLineAsRangeStart: () => rangeEndIsOnSameLineAsRangeStart,
	    rangeEndPositionsAreOnSameLine: () => rangeEndPositionsAreOnSameLine,
	    rangeEquals: () => rangeEquals,
	    rangeIsOnSingleLine: () => rangeIsOnSingleLine,
	    rangeOfNode: () => rangeOfNode,
	    rangeOfTypeParameters: () => rangeOfTypeParameters,
	    rangeOverlapsWithStartEnd: () => rangeOverlapsWithStartEnd,
	    rangeStartIsOnSameLineAsRangeEnd: () => rangeStartIsOnSameLineAsRangeEnd,
	    rangeStartPositionsAreOnSameLine: () => rangeStartPositionsAreOnSameLine,
	    readBuilderProgram: () => readBuilderProgram,
	    readConfigFile: () => readConfigFile,
	    readHelper: () => readHelper,
	    readJson: () => readJson,
	    readJsonConfigFile: () => readJsonConfigFile,
	    readJsonOrUndefined: () => readJsonOrUndefined,
	    reduceEachLeadingCommentRange: () => reduceEachLeadingCommentRange,
	    reduceEachTrailingCommentRange: () => reduceEachTrailingCommentRange,
	    reduceLeft: () => reduceLeft,
	    reduceLeftIterator: () => reduceLeftIterator,
	    reducePathComponents: () => reducePathComponents,
	    refactor: () => ts_refactor_exports,
	    regExpEscape: () => regExpEscape,
	    relativeComplement: () => relativeComplement,
	    removeAllComments: () => removeAllComments,
	    removeEmitHelper: () => removeEmitHelper,
	    removeExtension: () => removeExtension,
	    removeFileExtension: () => removeFileExtension,
	    removeIgnoredPath: () => removeIgnoredPath,
	    removeMinAndVersionNumbers: () => removeMinAndVersionNumbers,
	    removeOptionality: () => removeOptionality,
	    removePrefix: () => removePrefix,
	    removeSuffix: () => removeSuffix,
	    removeTrailingDirectorySeparator: () => removeTrailingDirectorySeparator,
	    repeatString: () => repeatString,
	    replaceElement: () => replaceElement,
	    replaceFirstStar: () => replaceFirstStar,
	    resolutionExtensionIsTSOrJson: () => resolutionExtensionIsTSOrJson,
	    resolveConfigFileProjectName: () => resolveConfigFileProjectName,
	    resolveJSModule: () => resolveJSModule,
	    resolveLibrary: () => resolveLibrary,
	    resolveModuleName: () => resolveModuleName,
	    resolveModuleNameFromCache: () => resolveModuleNameFromCache,
	    resolvePackageNameToPackageJson: () => resolvePackageNameToPackageJson,
	    resolvePath: () => resolvePath,
	    resolveProjectReferencePath: () => resolveProjectReferencePath,
	    resolveTripleslashReference: () => resolveTripleslashReference,
	    resolveTypeReferenceDirective: () => resolveTypeReferenceDirective,
	    resolvingEmptyArray: () => resolvingEmptyArray,
	    restHelper: () => restHelper,
	    returnFalse: () => returnFalse,
	    returnNoopFileWatcher: () => returnNoopFileWatcher,
	    returnTrue: () => returnTrue,
	    returnUndefined: () => returnUndefined,
	    returnsPromise: () => returnsPromise,
	    runInitializersHelper: () => runInitializersHelper,
	    sameFlatMap: () => sameFlatMap,
	    sameMap: () => sameMap,
	    sameMapping: () => sameMapping,
	    scanShebangTrivia: () => scanShebangTrivia,
	    scanTokenAtPosition: () => scanTokenAtPosition,
	    scanner: () => scanner,
	    screenStartingMessageCodes: () => screenStartingMessageCodes,
	    semanticDiagnosticsOptionDeclarations: () => semanticDiagnosticsOptionDeclarations,
	    serializeCompilerOptions: () => serializeCompilerOptions,
	    server: () => ts_server_exports3,
	    servicesVersion: () => servicesVersion,
	    setCommentRange: () => setCommentRange,
	    setConfigFileInOptions: () => setConfigFileInOptions,
	    setConstantValue: () => setConstantValue,
	    setEachParent: () => setEachParent,
	    setEmitFlags: () => setEmitFlags,
	    setFunctionNameHelper: () => setFunctionNameHelper,
	    setGetSourceFileAsHashVersioned: () => setGetSourceFileAsHashVersioned,
	    setIdentifierAutoGenerate: () => setIdentifierAutoGenerate,
	    setIdentifierGeneratedImportReference: () => setIdentifierGeneratedImportReference,
	    setIdentifierTypeArguments: () => setIdentifierTypeArguments,
	    setInternalEmitFlags: () => setInternalEmitFlags,
	    setLocalizedDiagnosticMessages: () => setLocalizedDiagnosticMessages,
	    setModuleDefaultHelper: () => setModuleDefaultHelper,
	    setNodeFlags: () => setNodeFlags,
	    setObjectAllocator: () => setObjectAllocator,
	    setOriginalNode: () => setOriginalNode,
	    setParent: () => setParent,
	    setParentRecursive: () => setParentRecursive,
	    setPrivateIdentifier: () => setPrivateIdentifier,
	    setSnippetElement: () => setSnippetElement,
	    setSourceMapRange: () => setSourceMapRange,
	    setStackTraceLimit: () => setStackTraceLimit,
	    setStartsOnNewLine: () => setStartsOnNewLine,
	    setSyntheticLeadingComments: () => setSyntheticLeadingComments,
	    setSyntheticTrailingComments: () => setSyntheticTrailingComments,
	    setSys: () => setSys,
	    setSysLog: () => setSysLog,
	    setTextRange: () => setTextRange,
	    setTextRangeEnd: () => setTextRangeEnd,
	    setTextRangePos: () => setTextRangePos,
	    setTextRangePosEnd: () => setTextRangePosEnd,
	    setTextRangePosWidth: () => setTextRangePosWidth,
	    setTokenSourceMapRange: () => setTokenSourceMapRange,
	    setTypeNode: () => setTypeNode,
	    setUILocale: () => setUILocale,
	    setValueDeclaration: () => setValueDeclaration,
	    shouldAllowImportingTsExtension: () => shouldAllowImportingTsExtension,
	    shouldPreserveConstEnums: () => shouldPreserveConstEnums,
	    shouldUseUriStyleNodeCoreModules: () => shouldUseUriStyleNodeCoreModules,
	    showModuleSpecifier: () => showModuleSpecifier,
	    signatureHasLiteralTypes: () => signatureHasLiteralTypes,
	    signatureHasRestParameter: () => signatureHasRestParameter,
	    signatureToDisplayParts: () => signatureToDisplayParts,
	    single: () => single,
	    singleElementArray: () => singleElementArray,
	    singleIterator: () => singleIterator,
	    singleOrMany: () => singleOrMany,
	    singleOrUndefined: () => singleOrUndefined,
	    skipAlias: () => skipAlias,
	    skipAssertions: () => skipAssertions,
	    skipConstraint: () => skipConstraint,
	    skipOuterExpressions: () => skipOuterExpressions,
	    skipParentheses: () => skipParentheses,
	    skipPartiallyEmittedExpressions: () => skipPartiallyEmittedExpressions,
	    skipTrivia: () => skipTrivia,
	    skipTypeChecking: () => skipTypeChecking,
	    skipTypeParentheses: () => skipTypeParentheses,
	    skipWhile: () => skipWhile,
	    sliceAfter: () => sliceAfter,
	    some: () => some,
	    sort: () => sort,
	    sortAndDeduplicate: () => sortAndDeduplicate,
	    sortAndDeduplicateDiagnostics: () => sortAndDeduplicateDiagnostics,
	    sourceFileAffectingCompilerOptions: () => sourceFileAffectingCompilerOptions,
	    sourceFileMayBeEmitted: () => sourceFileMayBeEmitted,
	    sourceMapCommentRegExp: () => sourceMapCommentRegExp,
	    sourceMapCommentRegExpDontCareLineStart: () => sourceMapCommentRegExpDontCareLineStart,
	    spacePart: () => spacePart,
	    spanMap: () => spanMap,
	    spreadArrayHelper: () => spreadArrayHelper,
	    stableSort: () => stableSort,
	    startEndContainsRange: () => startEndContainsRange,
	    startEndOverlapsWithStartEnd: () => startEndOverlapsWithStartEnd,
	    startOnNewLine: () => startOnNewLine,
	    startTracing: () => startTracing,
	    startsWith: () => startsWith,
	    startsWithDirectory: () => startsWithDirectory,
	    startsWithUnderscore: () => startsWithUnderscore,
	    startsWithUseStrict: () => startsWithUseStrict,
	    stringContainsAt: () => stringContainsAt,
	    stringToToken: () => stringToToken,
	    stripQuotes: () => stripQuotes,
	    supportedDeclarationExtensions: () => supportedDeclarationExtensions,
	    supportedJSExtensions: () => supportedJSExtensions,
	    supportedJSExtensionsFlat: () => supportedJSExtensionsFlat,
	    supportedLocaleDirectories: () => supportedLocaleDirectories,
	    supportedTSExtensions: () => supportedTSExtensions,
	    supportedTSExtensionsFlat: () => supportedTSExtensionsFlat,
	    supportedTSImplementationExtensions: () => supportedTSImplementationExtensions,
	    suppressLeadingAndTrailingTrivia: () => suppressLeadingAndTrailingTrivia,
	    suppressLeadingTrivia: () => suppressLeadingTrivia,
	    suppressTrailingTrivia: () => suppressTrailingTrivia,
	    symbolEscapedNameNoDefault: () => symbolEscapedNameNoDefault,
	    symbolName: () => symbolName,
	    symbolNameNoDefault: () => symbolNameNoDefault,
	    symbolPart: () => symbolPart,
	    symbolToDisplayParts: () => symbolToDisplayParts,
	    syntaxMayBeASICandidate: () => syntaxMayBeASICandidate,
	    syntaxRequiresTrailingSemicolonOrASI: () => syntaxRequiresTrailingSemicolonOrASI,
	    sys: () => sys,
	    sysLog: () => sysLog,
	    tagNamesAreEquivalent: () => tagNamesAreEquivalent,
	    takeWhile: () => takeWhile,
	    targetOptionDeclaration: () => targetOptionDeclaration,
	    templateObjectHelper: () => templateObjectHelper,
	    testFormatSettings: () => testFormatSettings,
	    textChangeRangeIsUnchanged: () => textChangeRangeIsUnchanged,
	    textChangeRangeNewSpan: () => textChangeRangeNewSpan,
	    textChanges: () => ts_textChanges_exports,
	    textOrKeywordPart: () => textOrKeywordPart,
	    textPart: () => textPart,
	    textRangeContainsPositionInclusive: () => textRangeContainsPositionInclusive,
	    textSpanContainsPosition: () => textSpanContainsPosition,
	    textSpanContainsTextSpan: () => textSpanContainsTextSpan,
	    textSpanEnd: () => textSpanEnd,
	    textSpanIntersection: () => textSpanIntersection,
	    textSpanIntersectsWith: () => textSpanIntersectsWith,
	    textSpanIntersectsWithPosition: () => textSpanIntersectsWithPosition,
	    textSpanIntersectsWithTextSpan: () => textSpanIntersectsWithTextSpan,
	    textSpanIsEmpty: () => textSpanIsEmpty,
	    textSpanOverlap: () => textSpanOverlap,
	    textSpanOverlapsWith: () => textSpanOverlapsWith,
	    textSpansEqual: () => textSpansEqual,
	    textToKeywordObj: () => textToKeywordObj,
	    timestamp: () => timestamp,
	    toArray: () => toArray,
	    toBuilderFileEmit: () => toBuilderFileEmit,
	    toBuilderStateFileInfoForMultiEmit: () => toBuilderStateFileInfoForMultiEmit,
	    toEditorSettings: () => toEditorSettings,
	    toFileNameLowerCase: () => toFileNameLowerCase,
	    toLowerCase: () => toLowerCase,
	    toPath: () => toPath,
	    toProgramEmitPending: () => toProgramEmitPending,
	    tokenIsIdentifierOrKeyword: () => tokenIsIdentifierOrKeyword,
	    tokenIsIdentifierOrKeywordOrGreaterThan: () => tokenIsIdentifierOrKeywordOrGreaterThan,
	    tokenToString: () => tokenToString,
	    trace: () => trace,
	    tracing: () => tracing,
	    tracingEnabled: () => tracingEnabled,
	    transform: () => transform,
	    transformClassFields: () => transformClassFields,
	    transformDeclarations: () => transformDeclarations,
	    transformECMAScriptModule: () => transformECMAScriptModule,
	    transformES2015: () => transformES2015,
	    transformES2016: () => transformES2016,
	    transformES2017: () => transformES2017,
	    transformES2018: () => transformES2018,
	    transformES2019: () => transformES2019,
	    transformES2020: () => transformES2020,
	    transformES2021: () => transformES2021,
	    transformES5: () => transformES5,
	    transformESDecorators: () => transformESDecorators,
	    transformESNext: () => transformESNext,
	    transformGenerators: () => transformGenerators,
	    transformJsx: () => transformJsx,
	    transformLegacyDecorators: () => transformLegacyDecorators,
	    transformModule: () => transformModule,
	    transformNamedEvaluation: () => transformNamedEvaluation,
	    transformNodeModule: () => transformNodeModule,
	    transformNodes: () => transformNodes,
	    transformSystemModule: () => transformSystemModule,
	    transformTypeScript: () => transformTypeScript,
	    transpile: () => transpile,
	    transpileModule: () => transpileModule,
	    transpileOptionValueCompilerOptions: () => transpileOptionValueCompilerOptions,
	    tryAddToSet: () => tryAddToSet,
	    tryAndIgnoreErrors: () => tryAndIgnoreErrors,
	    tryCast: () => tryCast,
	    tryDirectoryExists: () => tryDirectoryExists,
	    tryExtractTSExtension: () => tryExtractTSExtension,
	    tryFileExists: () => tryFileExists,
	    tryGetClassExtendingExpressionWithTypeArguments: () => tryGetClassExtendingExpressionWithTypeArguments,
	    tryGetClassImplementingOrExtendingExpressionWithTypeArguments: () => tryGetClassImplementingOrExtendingExpressionWithTypeArguments,
	    tryGetDirectories: () => tryGetDirectories,
	    tryGetExtensionFromPath: () => tryGetExtensionFromPath2,
	    tryGetImportFromModuleSpecifier: () => tryGetImportFromModuleSpecifier,
	    tryGetJSDocSatisfiesTypeNode: () => tryGetJSDocSatisfiesTypeNode,
	    tryGetModuleNameFromFile: () => tryGetModuleNameFromFile,
	    tryGetModuleSpecifierFromDeclaration: () => tryGetModuleSpecifierFromDeclaration,
	    tryGetNativePerformanceHooks: () => tryGetNativePerformanceHooks,
	    tryGetPropertyAccessOrIdentifierToString: () => tryGetPropertyAccessOrIdentifierToString,
	    tryGetPropertyNameOfBindingOrAssignmentElement: () => tryGetPropertyNameOfBindingOrAssignmentElement,
	    tryGetSourceMappingURL: () => tryGetSourceMappingURL,
	    tryGetTextOfPropertyName: () => tryGetTextOfPropertyName,
	    tryIOAndConsumeErrors: () => tryIOAndConsumeErrors,
	    tryParseJson: () => tryParseJson,
	    tryParsePattern: () => tryParsePattern,
	    tryParsePatterns: () => tryParsePatterns,
	    tryParseRawSourceMap: () => tryParseRawSourceMap,
	    tryReadDirectory: () => tryReadDirectory,
	    tryReadFile: () => tryReadFile,
	    tryRemoveDirectoryPrefix: () => tryRemoveDirectoryPrefix,
	    tryRemoveExtension: () => tryRemoveExtension,
	    tryRemovePrefix: () => tryRemovePrefix,
	    tryRemoveSuffix: () => tryRemoveSuffix,
	    typeAcquisitionDeclarations: () => typeAcquisitionDeclarations,
	    typeAliasNamePart: () => typeAliasNamePart,
	    typeDirectiveIsEqualTo: () => typeDirectiveIsEqualTo,
	    typeKeywords: () => typeKeywords,
	    typeParameterNamePart: () => typeParameterNamePart,
	    typeToDisplayParts: () => typeToDisplayParts,
	    unchangedPollThresholds: () => unchangedPollThresholds,
	    unchangedTextChangeRange: () => unchangedTextChangeRange,
	    unescapeLeadingUnderscores: () => unescapeLeadingUnderscores,
	    unmangleScopedPackageName: () => unmangleScopedPackageName,
	    unorderedRemoveItem: () => unorderedRemoveItem,
	    unorderedRemoveItemAt: () => unorderedRemoveItemAt,
	    unreachableCodeIsError: () => unreachableCodeIsError,
	    unusedLabelIsError: () => unusedLabelIsError,
	    unwrapInnermostStatementOfLabel: () => unwrapInnermostStatementOfLabel,
	    updateErrorForNoInputFiles: () => updateErrorForNoInputFiles,
	    updateLanguageServiceSourceFile: () => updateLanguageServiceSourceFile,
	    updateMissingFilePathsWatch: () => updateMissingFilePathsWatch,
	    updateResolutionField: () => updateResolutionField,
	    updateSharedExtendedConfigFileWatcher: () => updateSharedExtendedConfigFileWatcher,
	    updateSourceFile: () => updateSourceFile,
	    updateWatchingWildcardDirectories: () => updateWatchingWildcardDirectories,
	    usesExtensionsOnImports: () => usesExtensionsOnImports,
	    usingSingleLineStringWriter: () => usingSingleLineStringWriter,
	    utf16EncodeAsString: () => utf16EncodeAsString,
	    validateLocaleAndSetLanguage: () => validateLocaleAndSetLanguage,
	    valuesHelper: () => valuesHelper,
	    version: () => version,
	    versionMajorMinor: () => versionMajorMinor,
	    visitArray: () => visitArray,
	    visitCommaListElements: () => visitCommaListElements,
	    visitEachChild: () => visitEachChild,
	    visitFunctionBody: () => visitFunctionBody,
	    visitIterationBody: () => visitIterationBody,
	    visitLexicalEnvironment: () => visitLexicalEnvironment,
	    visitNode: () => visitNode,
	    visitNodes: () => visitNodes2,
	    visitParameterList: () => visitParameterList,
	    walkUpBindingElementsAndPatterns: () => walkUpBindingElementsAndPatterns,
	    walkUpLexicalEnvironments: () => walkUpLexicalEnvironments,
	    walkUpOuterExpressions: () => walkUpOuterExpressions,
	    walkUpParenthesizedExpressions: () => walkUpParenthesizedExpressions,
	    walkUpParenthesizedTypes: () => walkUpParenthesizedTypes,
	    walkUpParenthesizedTypesAndGetParentAndChild: () => walkUpParenthesizedTypesAndGetParentAndChild,
	    whitespaceOrMapCommentRegExp: () => whitespaceOrMapCommentRegExp,
	    writeCommentRange: () => writeCommentRange,
	    writeFile: () => writeFile,
	    writeFileEnsuringDirectories: () => writeFileEnsuringDirectories,
	    zipWith: () => zipWith
	  });
	  var init_ts7 = __esm({
	    "src/server/_namespaces/ts.ts"() {
	      init_ts2();
	      init_ts3();
	      init_ts4();
	      init_ts5();
	      init_ts_server3();
	    }
	  });

	  // src/typescript/_namespaces/ts.server.ts
	  var ts_server_exports4 = {};
	  __export(ts_server_exports4, {
	    ActionInvalidate: () => ActionInvalidate,
	    ActionPackageInstalled: () => ActionPackageInstalled,
	    ActionSet: () => ActionSet,
	    ActionWatchTypingLocations: () => ActionWatchTypingLocations,
	    Arguments: () => Arguments,
	    AutoImportProviderProject: () => AutoImportProviderProject,
	    AuxiliaryProject: () => AuxiliaryProject,
	    CharRangeSection: () => CharRangeSection,
	    CloseFileWatcherEvent: () => CloseFileWatcherEvent,
	    CommandNames: () => CommandNames,
	    ConfigFileDiagEvent: () => ConfigFileDiagEvent,
	    ConfiguredProject: () => ConfiguredProject2,
	    CreateDirectoryWatcherEvent: () => CreateDirectoryWatcherEvent,
	    CreateFileWatcherEvent: () => CreateFileWatcherEvent,
	    Errors: () => Errors,
	    EventBeginInstallTypes: () => EventBeginInstallTypes,
	    EventEndInstallTypes: () => EventEndInstallTypes,
	    EventInitializationFailed: () => EventInitializationFailed,
	    EventTypesRegistry: () => EventTypesRegistry,
	    ExternalProject: () => ExternalProject2,
	    GcTimer: () => GcTimer,
	    InferredProject: () => InferredProject2,
	    LargeFileReferencedEvent: () => LargeFileReferencedEvent,
	    LineIndex: () => LineIndex,
	    LineLeaf: () => LineLeaf,
	    LineNode: () => LineNode,
	    LogLevel: () => LogLevel2,
	    Msg: () => Msg,
	    OpenFileInfoTelemetryEvent: () => OpenFileInfoTelemetryEvent,
	    Project: () => Project3,
	    ProjectInfoTelemetryEvent: () => ProjectInfoTelemetryEvent,
	    ProjectKind: () => ProjectKind,
	    ProjectLanguageServiceStateEvent: () => ProjectLanguageServiceStateEvent,
	    ProjectLoadingFinishEvent: () => ProjectLoadingFinishEvent,
	    ProjectLoadingStartEvent: () => ProjectLoadingStartEvent,
	    ProjectReferenceProjectLoadKind: () => ProjectReferenceProjectLoadKind,
	    ProjectService: () => ProjectService3,
	    ProjectsUpdatedInBackgroundEvent: () => ProjectsUpdatedInBackgroundEvent,
	    ScriptInfo: () => ScriptInfo,
	    ScriptVersionCache: () => ScriptVersionCache,
	    Session: () => Session3,
	    TextStorage: () => TextStorage,
	    ThrottledOperations: () => ThrottledOperations,
	    TypingsCache: () => TypingsCache,
	    TypingsInstallerAdapter: () => TypingsInstallerAdapter,
	    allFilesAreJsOrDts: () => allFilesAreJsOrDts,
	    allRootFilesAreJsOrDts: () => allRootFilesAreJsOrDts,
	    asNormalizedPath: () => asNormalizedPath,
	    convertCompilerOptions: () => convertCompilerOptions,
	    convertFormatOptions: () => convertFormatOptions,
	    convertScriptKindName: () => convertScriptKindName,
	    convertTypeAcquisition: () => convertTypeAcquisition,
	    convertUserPreferences: () => convertUserPreferences,
	    convertWatchOptions: () => convertWatchOptions,
	    countEachFileTypes: () => countEachFileTypes,
	    createInstallTypingsRequest: () => createInstallTypingsRequest,
	    createModuleSpecifierCache: () => createModuleSpecifierCache,
	    createNormalizedPathMap: () => createNormalizedPathMap,
	    createPackageJsonCache: () => createPackageJsonCache,
	    createSortedArray: () => createSortedArray2,
	    emptyArray: () => emptyArray2,
	    findArgument: () => findArgument,
	    forEachResolvedProjectReferenceProject: () => forEachResolvedProjectReferenceProject,
	    formatDiagnosticToProtocol: () => formatDiagnosticToProtocol,
	    formatMessage: () => formatMessage2,
	    getBaseConfigFileName: () => getBaseConfigFileName,
	    getLocationInNewDocument: () => getLocationInNewDocument,
	    hasArgument: () => hasArgument,
	    hasNoTypeScriptSource: () => hasNoTypeScriptSource,
	    indent: () => indent2,
	    isBackgroundProject: () => isBackgroundProject,
	    isConfigFile: () => isConfigFile,
	    isConfiguredProject: () => isConfiguredProject,
	    isDynamicFileName: () => isDynamicFileName,
	    isExternalProject: () => isExternalProject,
	    isInferredProject: () => isInferredProject,
	    isInferredProjectName: () => isInferredProjectName,
	    makeAutoImportProviderProjectName: () => makeAutoImportProviderProjectName,
	    makeAuxiliaryProjectName: () => makeAuxiliaryProjectName,
	    makeInferredProjectName: () => makeInferredProjectName,
	    maxFileSize: () => maxFileSize,
	    maxProgramSizeForNonTsFiles: () => maxProgramSizeForNonTsFiles,
	    normalizedPathToPath: () => normalizedPathToPath,
	    nowString: () => nowString,
	    nullCancellationToken: () => nullCancellationToken,
	    nullTypingsInstaller: () => nullTypingsInstaller,
	    projectContainsInfoDirectly: () => projectContainsInfoDirectly,
	    protocol: () => ts_server_protocol_exports,
	    removeSorted: () => removeSorted,
	    stringifyIndented: () => stringifyIndented,
	    toEvent: () => toEvent,
	    toNormalizedPath: () => toNormalizedPath,
	    tryConvertScriptKindName: () => tryConvertScriptKindName,
	    typingsInstaller: () => ts_server_typingsInstaller_exports,
	    updateProjectIfDirty: () => updateProjectIfDirty
	  });
	  var init_ts_server4 = __esm({
	    "src/typescript/_namespaces/ts.server.ts"() {
	      init_ts_server();
	      init_ts_server3();
	    }
	  });

	  // src/typescript/_namespaces/ts.ts
	  var ts_exports3 = {};
	  __export(ts_exports3, {
	    ANONYMOUS: () => ANONYMOUS,
	    AccessFlags: () => AccessFlags,
	    AssertionLevel: () => AssertionLevel,
	    AssignmentDeclarationKind: () => AssignmentDeclarationKind,
	    AssignmentKind: () => AssignmentKind,
	    Associativity: () => Associativity,
	    BreakpointResolver: () => ts_BreakpointResolver_exports,
	    BuilderFileEmit: () => BuilderFileEmit,
	    BuilderProgramKind: () => BuilderProgramKind,
	    BuilderState: () => BuilderState,
	    BundleFileSectionKind: () => BundleFileSectionKind,
	    CallHierarchy: () => ts_CallHierarchy_exports,
	    CharacterCodes: () => CharacterCodes,
	    CheckFlags: () => CheckFlags,
	    CheckMode: () => CheckMode,
	    ClassificationType: () => ClassificationType,
	    ClassificationTypeNames: () => ClassificationTypeNames,
	    CommentDirectiveType: () => CommentDirectiveType,
	    Comparison: () => Comparison,
	    CompletionInfoFlags: () => CompletionInfoFlags,
	    CompletionTriggerKind: () => CompletionTriggerKind,
	    Completions: () => ts_Completions_exports,
	    ContainerFlags: () => ContainerFlags,
	    ContextFlags: () => ContextFlags,
	    Debug: () => Debug,
	    DiagnosticCategory: () => DiagnosticCategory,
	    Diagnostics: () => Diagnostics,
	    DocumentHighlights: () => DocumentHighlights,
	    ElementFlags: () => ElementFlags,
	    EmitFlags: () => EmitFlags,
	    EmitHint: () => EmitHint,
	    EmitOnly: () => EmitOnly,
	    EndOfLineState: () => EndOfLineState,
	    EnumKind: () => EnumKind,
	    ExitStatus: () => ExitStatus,
	    ExportKind: () => ExportKind,
	    Extension: () => Extension,
	    ExternalEmitHelpers: () => ExternalEmitHelpers,
	    FileIncludeKind: () => FileIncludeKind,
	    FilePreprocessingDiagnosticsKind: () => FilePreprocessingDiagnosticsKind,
	    FileSystemEntryKind: () => FileSystemEntryKind,
	    FileWatcherEventKind: () => FileWatcherEventKind,
	    FindAllReferences: () => ts_FindAllReferences_exports,
	    FlattenLevel: () => FlattenLevel,
	    FlowFlags: () => FlowFlags,
	    ForegroundColorEscapeSequences: () => ForegroundColorEscapeSequences,
	    FunctionFlags: () => FunctionFlags,
	    GeneratedIdentifierFlags: () => GeneratedIdentifierFlags,
	    GetLiteralTextFlags: () => GetLiteralTextFlags,
	    GoToDefinition: () => ts_GoToDefinition_exports,
	    HighlightSpanKind: () => HighlightSpanKind,
	    IdentifierNameMap: () => IdentifierNameMap,
	    IdentifierNameMultiMap: () => IdentifierNameMultiMap,
	    ImportKind: () => ImportKind,
	    ImportsNotUsedAsValues: () => ImportsNotUsedAsValues,
	    IndentStyle: () => IndentStyle,
	    IndexFlags: () => IndexFlags,
	    IndexKind: () => IndexKind,
	    InferenceFlags: () => InferenceFlags,
	    InferencePriority: () => InferencePriority,
	    InlayHintKind: () => InlayHintKind,
	    InlayHints: () => ts_InlayHints_exports,
	    InternalEmitFlags: () => InternalEmitFlags,
	    InternalSymbolName: () => InternalSymbolName,
	    InvalidatedProjectKind: () => InvalidatedProjectKind,
	    JSDocParsingMode: () => JSDocParsingMode,
	    JsDoc: () => ts_JsDoc_exports,
	    JsTyping: () => ts_JsTyping_exports,
	    JsxEmit: () => JsxEmit,
	    JsxFlags: () => JsxFlags,
	    JsxReferenceKind: () => JsxReferenceKind,
	    LanguageServiceMode: () => LanguageServiceMode,
	    LanguageVariant: () => LanguageVariant,
	    LexicalEnvironmentFlags: () => LexicalEnvironmentFlags,
	    ListFormat: () => ListFormat,
	    LogLevel: () => LogLevel,
	    MemberOverrideStatus: () => MemberOverrideStatus,
	    ModifierFlags: () => ModifierFlags,
	    ModuleDetectionKind: () => ModuleDetectionKind,
	    ModuleInstanceState: () => ModuleInstanceState,
	    ModuleKind: () => ModuleKind,
	    ModuleResolutionKind: () => ModuleResolutionKind,
	    ModuleSpecifierEnding: () => ModuleSpecifierEnding,
	    NavigateTo: () => ts_NavigateTo_exports,
	    NavigationBar: () => ts_NavigationBar_exports,
	    NewLineKind: () => NewLineKind,
	    NodeBuilderFlags: () => NodeBuilderFlags,
	    NodeCheckFlags: () => NodeCheckFlags,
	    NodeFactoryFlags: () => NodeFactoryFlags,
	    NodeFlags: () => NodeFlags,
	    NodeResolutionFeatures: () => NodeResolutionFeatures,
	    ObjectFlags: () => ObjectFlags,
	    OperationCanceledException: () => OperationCanceledException,
	    OperatorPrecedence: () => OperatorPrecedence,
	    OrganizeImports: () => ts_OrganizeImports_exports,
	    OrganizeImportsMode: () => OrganizeImportsMode,
	    OuterExpressionKinds: () => OuterExpressionKinds,
	    OutliningElementsCollector: () => ts_OutliningElementsCollector_exports,
	    OutliningSpanKind: () => OutliningSpanKind,
	    OutputFileType: () => OutputFileType,
	    PackageJsonAutoImportPreference: () => PackageJsonAutoImportPreference,
	    PackageJsonDependencyGroup: () => PackageJsonDependencyGroup,
	    PatternMatchKind: () => PatternMatchKind,
	    PollingInterval: () => PollingInterval,
	    PollingWatchKind: () => PollingWatchKind,
	    PragmaKindFlags: () => PragmaKindFlags,
	    PrivateIdentifierKind: () => PrivateIdentifierKind,
	    ProcessLevel: () => ProcessLevel,
	    ProgramUpdateLevel: () => ProgramUpdateLevel,
	    QuotePreference: () => QuotePreference,
	    RelationComparisonResult: () => RelationComparisonResult,
	    Rename: () => ts_Rename_exports,
	    ScriptElementKind: () => ScriptElementKind,
	    ScriptElementKindModifier: () => ScriptElementKindModifier,
	    ScriptKind: () => ScriptKind,
	    ScriptSnapshot: () => ScriptSnapshot,
	    ScriptTarget: () => ScriptTarget,
	    SemanticClassificationFormat: () => SemanticClassificationFormat,
	    SemanticMeaning: () => SemanticMeaning,
	    SemicolonPreference: () => SemicolonPreference,
	    SignatureCheckMode: () => SignatureCheckMode,
	    SignatureFlags: () => SignatureFlags,
	    SignatureHelp: () => ts_SignatureHelp_exports,
	    SignatureKind: () => SignatureKind,
	    SmartSelectionRange: () => ts_SmartSelectionRange_exports,
	    SnippetKind: () => SnippetKind,
	    SortKind: () => SortKind,
	    StructureIsReused: () => StructureIsReused,
	    SymbolAccessibility: () => SymbolAccessibility,
	    SymbolDisplay: () => ts_SymbolDisplay_exports,
	    SymbolDisplayPartKind: () => SymbolDisplayPartKind,
	    SymbolFlags: () => SymbolFlags,
	    SymbolFormatFlags: () => SymbolFormatFlags,
	    SyntaxKind: () => SyntaxKind,
	    SyntheticSymbolKind: () => SyntheticSymbolKind,
	    Ternary: () => Ternary,
	    ThrottledCancellationToken: () => ThrottledCancellationToken,
	    TokenClass: () => TokenClass,
	    TokenFlags: () => TokenFlags,
	    TransformFlags: () => TransformFlags,
	    TypeFacts: () => TypeFacts,
	    TypeFlags: () => TypeFlags,
	    TypeFormatFlags: () => TypeFormatFlags,
	    TypeMapKind: () => TypeMapKind,
	    TypePredicateKind: () => TypePredicateKind,
	    TypeReferenceSerializationKind: () => TypeReferenceSerializationKind,
	    UnionReduction: () => UnionReduction,
	    UpToDateStatusType: () => UpToDateStatusType,
	    VarianceFlags: () => VarianceFlags,
	    Version: () => Version,
	    VersionRange: () => VersionRange,
	    WatchDirectoryFlags: () => WatchDirectoryFlags,
	    WatchDirectoryKind: () => WatchDirectoryKind,
	    WatchFileKind: () => WatchFileKind,
	    WatchLogLevel: () => WatchLogLevel,
	    WatchType: () => WatchType,
	    accessPrivateIdentifier: () => accessPrivateIdentifier,
	    addDisposableResourceHelper: () => addDisposableResourceHelper,
	    addEmitFlags: () => addEmitFlags,
	    addEmitHelper: () => addEmitHelper,
	    addEmitHelpers: () => addEmitHelpers,
	    addInternalEmitFlags: () => addInternalEmitFlags,
	    addNodeFactoryPatcher: () => addNodeFactoryPatcher,
	    addObjectAllocatorPatcher: () => addObjectAllocatorPatcher,
	    addRange: () => addRange,
	    addRelatedInfo: () => addRelatedInfo,
	    addSyntheticLeadingComment: () => addSyntheticLeadingComment,
	    addSyntheticTrailingComment: () => addSyntheticTrailingComment,
	    addToSeen: () => addToSeen,
	    advancedAsyncSuperHelper: () => advancedAsyncSuperHelper,
	    affectsDeclarationPathOptionDeclarations: () => affectsDeclarationPathOptionDeclarations,
	    affectsEmitOptionDeclarations: () => affectsEmitOptionDeclarations,
	    allKeysStartWithDot: () => allKeysStartWithDot,
	    altDirectorySeparator: () => altDirectorySeparator,
	    and: () => and,
	    append: () => append,
	    appendIfUnique: () => appendIfUnique,
	    arrayFrom: () => arrayFrom,
	    arrayIsEqualTo: () => arrayIsEqualTo,
	    arrayIsHomogeneous: () => arrayIsHomogeneous,
	    arrayIsSorted: () => arrayIsSorted,
	    arrayOf: () => arrayOf,
	    arrayReverseIterator: () => arrayReverseIterator,
	    arrayToMap: () => arrayToMap,
	    arrayToMultiMap: () => arrayToMultiMap,
	    arrayToNumericMap: () => arrayToNumericMap,
	    arraysEqual: () => arraysEqual,
	    assertType: () => assertType,
	    assign: () => assign,
	    assignHelper: () => assignHelper,
	    asyncDelegator: () => asyncDelegator,
	    asyncGeneratorHelper: () => asyncGeneratorHelper,
	    asyncSuperHelper: () => asyncSuperHelper,
	    asyncValues: () => asyncValues,
	    attachFileToDiagnostics: () => attachFileToDiagnostics,
	    awaitHelper: () => awaitHelper,
	    awaiterHelper: () => awaiterHelper,
	    base64decode: () => base64decode,
	    base64encode: () => base64encode,
	    binarySearch: () => binarySearch,
	    binarySearchKey: () => binarySearchKey,
	    bindSourceFile: () => bindSourceFile,
	    breakIntoCharacterSpans: () => breakIntoCharacterSpans,
	    breakIntoWordSpans: () => breakIntoWordSpans,
	    buildLinkParts: () => buildLinkParts,
	    buildOpts: () => buildOpts,
	    buildOverload: () => buildOverload,
	    bundlerModuleNameResolver: () => bundlerModuleNameResolver,
	    canBeConvertedToAsync: () => canBeConvertedToAsync,
	    canHaveDecorators: () => canHaveDecorators,
	    canHaveExportModifier: () => canHaveExportModifier,
	    canHaveFlowNode: () => canHaveFlowNode,
	    canHaveIllegalDecorators: () => canHaveIllegalDecorators,
	    canHaveIllegalModifiers: () => canHaveIllegalModifiers,
	    canHaveIllegalType: () => canHaveIllegalType,
	    canHaveIllegalTypeParameters: () => canHaveIllegalTypeParameters,
	    canHaveJSDoc: () => canHaveJSDoc,
	    canHaveLocals: () => canHaveLocals,
	    canHaveModifiers: () => canHaveModifiers,
	    canHaveSymbol: () => canHaveSymbol,
	    canJsonReportNoInputFiles: () => canJsonReportNoInputFiles,
	    canProduceDiagnostics: () => canProduceDiagnostics,
	    canUsePropertyAccess: () => canUsePropertyAccess,
	    canWatchAffectingLocation: () => canWatchAffectingLocation,
	    canWatchAtTypes: () => canWatchAtTypes,
	    canWatchDirectoryOrFile: () => canWatchDirectoryOrFile,
	    cartesianProduct: () => cartesianProduct,
	    cast: () => cast,
	    chainBundle: () => chainBundle,
	    chainDiagnosticMessages: () => chainDiagnosticMessages,
	    changeAnyExtension: () => changeAnyExtension,
	    changeCompilerHostLikeToUseCache: () => changeCompilerHostLikeToUseCache,
	    changeExtension: () => changeExtension,
	    changeFullExtension: () => changeFullExtension,
	    changesAffectModuleResolution: () => changesAffectModuleResolution,
	    changesAffectingProgramStructure: () => changesAffectingProgramStructure,
	    childIsDecorated: () => childIsDecorated,
	    classElementOrClassElementParameterIsDecorated: () => classElementOrClassElementParameterIsDecorated,
	    classHasClassThisAssignment: () => classHasClassThisAssignment,
	    classHasDeclaredOrExplicitlyAssignedName: () => classHasDeclaredOrExplicitlyAssignedName,
	    classHasExplicitlyAssignedName: () => classHasExplicitlyAssignedName,
	    classOrConstructorParameterIsDecorated: () => classOrConstructorParameterIsDecorated,
	    classPrivateFieldGetHelper: () => classPrivateFieldGetHelper,
	    classPrivateFieldInHelper: () => classPrivateFieldInHelper,
	    classPrivateFieldSetHelper: () => classPrivateFieldSetHelper,
	    classicNameResolver: () => classicNameResolver,
	    classifier: () => ts_classifier_exports,
	    cleanExtendedConfigCache: () => cleanExtendedConfigCache,
	    clear: () => clear,
	    clearMap: () => clearMap,
	    clearSharedExtendedConfigFileWatcher: () => clearSharedExtendedConfigFileWatcher,
	    climbPastPropertyAccess: () => climbPastPropertyAccess,
	    climbPastPropertyOrElementAccess: () => climbPastPropertyOrElementAccess,
	    clone: () => clone,
	    cloneCompilerOptions: () => cloneCompilerOptions,
	    closeFileWatcher: () => closeFileWatcher,
	    closeFileWatcherOf: () => closeFileWatcherOf,
	    codefix: () => ts_codefix_exports,
	    collapseTextChangeRangesAcrossMultipleVersions: () => collapseTextChangeRangesAcrossMultipleVersions,
	    collectExternalModuleInfo: () => collectExternalModuleInfo,
	    combine: () => combine,
	    combinePaths: () => combinePaths,
	    commentPragmas: () => commentPragmas,
	    commonOptionsWithBuild: () => commonOptionsWithBuild,
	    commonPackageFolders: () => commonPackageFolders,
	    compact: () => compact,
	    compareBooleans: () => compareBooleans,
	    compareDataObjects: () => compareDataObjects,
	    compareDiagnostics: () => compareDiagnostics,
	    compareDiagnosticsSkipRelatedInformation: () => compareDiagnosticsSkipRelatedInformation,
	    compareEmitHelpers: () => compareEmitHelpers,
	    compareNumberOfDirectorySeparators: () => compareNumberOfDirectorySeparators,
	    comparePaths: () => comparePaths,
	    comparePathsCaseInsensitive: () => comparePathsCaseInsensitive,
	    comparePathsCaseSensitive: () => comparePathsCaseSensitive,
	    comparePatternKeys: () => comparePatternKeys,
	    compareProperties: () => compareProperties,
	    compareStringsCaseInsensitive: () => compareStringsCaseInsensitive,
	    compareStringsCaseInsensitiveEslintCompatible: () => compareStringsCaseInsensitiveEslintCompatible,
	    compareStringsCaseSensitive: () => compareStringsCaseSensitive,
	    compareStringsCaseSensitiveUI: () => compareStringsCaseSensitiveUI,
	    compareTextSpans: () => compareTextSpans,
	    compareValues: () => compareValues,
	    compileOnSaveCommandLineOption: () => compileOnSaveCommandLineOption,
	    compilerOptionsAffectDeclarationPath: () => compilerOptionsAffectDeclarationPath,
	    compilerOptionsAffectEmit: () => compilerOptionsAffectEmit,
	    compilerOptionsAffectSemanticDiagnostics: () => compilerOptionsAffectSemanticDiagnostics,
	    compilerOptionsDidYouMeanDiagnostics: () => compilerOptionsDidYouMeanDiagnostics,
	    compilerOptionsIndicateEsModules: () => compilerOptionsIndicateEsModules,
	    compose: () => compose,
	    computeCommonSourceDirectoryOfFilenames: () => computeCommonSourceDirectoryOfFilenames,
	    computeLineAndCharacterOfPosition: () => computeLineAndCharacterOfPosition,
	    computeLineOfPosition: () => computeLineOfPosition,
	    computeLineStarts: () => computeLineStarts,
	    computePositionOfLineAndCharacter: () => computePositionOfLineAndCharacter,
	    computeSignature: () => computeSignature,
	    computeSignatureWithDiagnostics: () => computeSignatureWithDiagnostics,
	    computeSuggestionDiagnostics: () => computeSuggestionDiagnostics,
	    computedOptions: () => computedOptions,
	    concatenate: () => concatenate,
	    concatenateDiagnosticMessageChains: () => concatenateDiagnosticMessageChains,
	    consumesNodeCoreModules: () => consumesNodeCoreModules,
	    contains: () => contains,
	    containsIgnoredPath: () => containsIgnoredPath,
	    containsObjectRestOrSpread: () => containsObjectRestOrSpread,
	    containsParseError: () => containsParseError,
	    containsPath: () => containsPath,
	    convertCompilerOptionsForTelemetry: () => convertCompilerOptionsForTelemetry,
	    convertCompilerOptionsFromJson: () => convertCompilerOptionsFromJson,
	    convertJsonOption: () => convertJsonOption,
	    convertToBase64: () => convertToBase64,
	    convertToJson: () => convertToJson,
	    convertToObject: () => convertToObject,
	    convertToOptionsWithAbsolutePaths: () => convertToOptionsWithAbsolutePaths,
	    convertToRelativePath: () => convertToRelativePath,
	    convertToTSConfig: () => convertToTSConfig,
	    convertTypeAcquisitionFromJson: () => convertTypeAcquisitionFromJson,
	    copyComments: () => copyComments,
	    copyEntries: () => copyEntries,
	    copyLeadingComments: () => copyLeadingComments,
	    copyProperties: () => copyProperties,
	    copyTrailingAsLeadingComments: () => copyTrailingAsLeadingComments,
	    copyTrailingComments: () => copyTrailingComments,
	    couldStartTrivia: () => couldStartTrivia,
	    countWhere: () => countWhere,
	    createAbstractBuilder: () => createAbstractBuilder,
	    createAccessorPropertyBackingField: () => createAccessorPropertyBackingField,
	    createAccessorPropertyGetRedirector: () => createAccessorPropertyGetRedirector,
	    createAccessorPropertySetRedirector: () => createAccessorPropertySetRedirector,
	    createBaseNodeFactory: () => createBaseNodeFactory,
	    createBinaryExpressionTrampoline: () => createBinaryExpressionTrampoline,
	    createBindingHelper: () => createBindingHelper,
	    createBuildInfo: () => createBuildInfo,
	    createBuilderProgram: () => createBuilderProgram,
	    createBuilderProgramUsingProgramBuildInfo: () => createBuilderProgramUsingProgramBuildInfo,
	    createBuilderStatusReporter: () => createBuilderStatusReporter,
	    createCacheWithRedirects: () => createCacheWithRedirects,
	    createCacheableExportInfoMap: () => createCacheableExportInfoMap,
	    createCachedDirectoryStructureHost: () => createCachedDirectoryStructureHost,
	    createClassNamedEvaluationHelperBlock: () => createClassNamedEvaluationHelperBlock,
	    createClassThisAssignmentBlock: () => createClassThisAssignmentBlock,
	    createClassifier: () => createClassifier,
	    createCommentDirectivesMap: () => createCommentDirectivesMap,
	    createCompilerDiagnostic: () => createCompilerDiagnostic,
	    createCompilerDiagnosticForInvalidCustomType: () => createCompilerDiagnosticForInvalidCustomType,
	    createCompilerDiagnosticFromMessageChain: () => createCompilerDiagnosticFromMessageChain,
	    createCompilerHost: () => createCompilerHost,
	    createCompilerHostFromProgramHost: () => createCompilerHostFromProgramHost,
	    createCompilerHostWorker: () => createCompilerHostWorker,
	    createDetachedDiagnostic: () => createDetachedDiagnostic,
	    createDiagnosticCollection: () => createDiagnosticCollection,
	    createDiagnosticForFileFromMessageChain: () => createDiagnosticForFileFromMessageChain,
	    createDiagnosticForNode: () => createDiagnosticForNode,
	    createDiagnosticForNodeArray: () => createDiagnosticForNodeArray,
	    createDiagnosticForNodeArrayFromMessageChain: () => createDiagnosticForNodeArrayFromMessageChain,
	    createDiagnosticForNodeFromMessageChain: () => createDiagnosticForNodeFromMessageChain,
	    createDiagnosticForNodeInSourceFile: () => createDiagnosticForNodeInSourceFile,
	    createDiagnosticForRange: () => createDiagnosticForRange,
	    createDiagnosticMessageChainFromDiagnostic: () => createDiagnosticMessageChainFromDiagnostic,
	    createDiagnosticReporter: () => createDiagnosticReporter,
	    createDocumentPositionMapper: () => createDocumentPositionMapper,
	    createDocumentRegistry: () => createDocumentRegistry,
	    createDocumentRegistryInternal: () => createDocumentRegistryInternal,
	    createEmitAndSemanticDiagnosticsBuilderProgram: () => createEmitAndSemanticDiagnosticsBuilderProgram,
	    createEmitHelperFactory: () => createEmitHelperFactory,
	    createEmptyExports: () => createEmptyExports,
	    createExpressionForJsxElement: () => createExpressionForJsxElement,
	    createExpressionForJsxFragment: () => createExpressionForJsxFragment,
	    createExpressionForObjectLiteralElementLike: () => createExpressionForObjectLiteralElementLike,
	    createExpressionForPropertyName: () => createExpressionForPropertyName,
	    createExpressionFromEntityName: () => createExpressionFromEntityName,
	    createExternalHelpersImportDeclarationIfNeeded: () => createExternalHelpersImportDeclarationIfNeeded,
	    createFileDiagnostic: () => createFileDiagnostic,
	    createFileDiagnosticFromMessageChain: () => createFileDiagnosticFromMessageChain,
	    createForOfBindingStatement: () => createForOfBindingStatement,
	    createGetCanonicalFileName: () => createGetCanonicalFileName,
	    createGetSourceFile: () => createGetSourceFile,
	    createGetSymbolAccessibilityDiagnosticForNode: () => createGetSymbolAccessibilityDiagnosticForNode,
	    createGetSymbolAccessibilityDiagnosticForNodeName: () => createGetSymbolAccessibilityDiagnosticForNodeName,
	    createGetSymbolWalker: () => createGetSymbolWalker,
	    createIncrementalCompilerHost: () => createIncrementalCompilerHost,
	    createIncrementalProgram: () => createIncrementalProgram,
	    createInputFiles: () => createInputFiles,
	    createInputFilesWithFilePaths: () => createInputFilesWithFilePaths,
	    createInputFilesWithFileTexts: () => createInputFilesWithFileTexts,
	    createJsxFactoryExpression: () => createJsxFactoryExpression,
	    createLanguageService: () => createLanguageService,
	    createLanguageServiceSourceFile: () => createLanguageServiceSourceFile,
	    createMemberAccessForPropertyName: () => createMemberAccessForPropertyName,
	    createModeAwareCache: () => createModeAwareCache,
	    createModeAwareCacheKey: () => createModeAwareCacheKey,
	    createModuleNotFoundChain: () => createModuleNotFoundChain,
	    createModuleResolutionCache: () => createModuleResolutionCache,
	    createModuleResolutionLoader: () => createModuleResolutionLoader,
	    createModuleResolutionLoaderUsingGlobalCache: () => createModuleResolutionLoaderUsingGlobalCache,
	    createModuleSpecifierResolutionHost: () => createModuleSpecifierResolutionHost,
	    createMultiMap: () => createMultiMap,
	    createNodeConverters: () => createNodeConverters,
	    createNodeFactory: () => createNodeFactory,
	    createOptionNameMap: () => createOptionNameMap,
	    createOverload: () => createOverload,
	    createPackageJsonImportFilter: () => createPackageJsonImportFilter,
	    createPackageJsonInfo: () => createPackageJsonInfo,
	    createParenthesizerRules: () => createParenthesizerRules,
	    createPatternMatcher: () => createPatternMatcher,
	    createPrependNodes: () => createPrependNodes,
	    createPrinter: () => createPrinter,
	    createPrinterWithDefaults: () => createPrinterWithDefaults,
	    createPrinterWithRemoveComments: () => createPrinterWithRemoveComments,
	    createPrinterWithRemoveCommentsNeverAsciiEscape: () => createPrinterWithRemoveCommentsNeverAsciiEscape,
	    createPrinterWithRemoveCommentsOmitTrailingSemicolon: () => createPrinterWithRemoveCommentsOmitTrailingSemicolon,
	    createProgram: () => createProgram,
	    createProgramHost: () => createProgramHost,
	    createPropertyNameNodeForIdentifierOrLiteral: () => createPropertyNameNodeForIdentifierOrLiteral,
	    createQueue: () => createQueue,
	    createRange: () => createRange,
	    createRedirectedBuilderProgram: () => createRedirectedBuilderProgram,
	    createResolutionCache: () => createResolutionCache,
	    createRuntimeTypeSerializer: () => createRuntimeTypeSerializer,
	    createScanner: () => createScanner,
	    createSemanticDiagnosticsBuilderProgram: () => createSemanticDiagnosticsBuilderProgram,
	    createSet: () => createSet,
	    createSolutionBuilder: () => createSolutionBuilder,
	    createSolutionBuilderHost: () => createSolutionBuilderHost,
	    createSolutionBuilderWithWatch: () => createSolutionBuilderWithWatch,
	    createSolutionBuilderWithWatchHost: () => createSolutionBuilderWithWatchHost,
	    createSortedArray: () => createSortedArray,
	    createSourceFile: () => createSourceFile,
	    createSourceMapGenerator: () => createSourceMapGenerator,
	    createSourceMapSource: () => createSourceMapSource,
	    createSuperAccessVariableStatement: () => createSuperAccessVariableStatement,
	    createSymbolTable: () => createSymbolTable,
	    createSymlinkCache: () => createSymlinkCache,
	    createSystemWatchFunctions: () => createSystemWatchFunctions,
	    createTextChange: () => createTextChange,
	    createTextChangeFromStartLength: () => createTextChangeFromStartLength,
	    createTextChangeRange: () => createTextChangeRange,
	    createTextRangeFromNode: () => createTextRangeFromNode,
	    createTextRangeFromSpan: () => createTextRangeFromSpan,
	    createTextSpan: () => createTextSpan,
	    createTextSpanFromBounds: () => createTextSpanFromBounds,
	    createTextSpanFromNode: () => createTextSpanFromNode,
	    createTextSpanFromRange: () => createTextSpanFromRange,
	    createTextSpanFromStringLiteralLikeContent: () => createTextSpanFromStringLiteralLikeContent,
	    createTextWriter: () => createTextWriter,
	    createTokenRange: () => createTokenRange,
	    createTypeChecker: () => createTypeChecker,
	    createTypeReferenceDirectiveResolutionCache: () => createTypeReferenceDirectiveResolutionCache,
	    createTypeReferenceResolutionLoader: () => createTypeReferenceResolutionLoader,
	    createUnparsedSourceFile: () => createUnparsedSourceFile,
	    createWatchCompilerHost: () => createWatchCompilerHost2,
	    createWatchCompilerHostOfConfigFile: () => createWatchCompilerHostOfConfigFile,
	    createWatchCompilerHostOfFilesAndCompilerOptions: () => createWatchCompilerHostOfFilesAndCompilerOptions,
	    createWatchFactory: () => createWatchFactory,
	    createWatchHost: () => createWatchHost,
	    createWatchProgram: () => createWatchProgram,
	    createWatchStatusReporter: () => createWatchStatusReporter,
	    createWriteFileMeasuringIO: () => createWriteFileMeasuringIO,
	    declarationNameToString: () => declarationNameToString,
	    decodeMappings: () => decodeMappings,
	    decodedTextSpanIntersectsWith: () => decodedTextSpanIntersectsWith,
	    decorateHelper: () => decorateHelper,
	    deduplicate: () => deduplicate,
	    defaultIncludeSpec: () => defaultIncludeSpec,
	    defaultInitCompilerOptions: () => defaultInitCompilerOptions,
	    defaultMaximumTruncationLength: () => defaultMaximumTruncationLength,
	    detectSortCaseSensitivity: () => detectSortCaseSensitivity,
	    diagnosticCategoryName: () => diagnosticCategoryName,
	    diagnosticToString: () => diagnosticToString,
	    directoryProbablyExists: () => directoryProbablyExists,
	    directorySeparator: () => directorySeparator,
	    displayPart: () => displayPart,
	    displayPartsToString: () => displayPartsToString,
	    disposeEmitNodes: () => disposeEmitNodes,
	    disposeResourcesHelper: () => disposeResourcesHelper,
	    documentSpansEqual: () => documentSpansEqual,
	    dumpTracingLegend: () => dumpTracingLegend,
	    elementAt: () => elementAt,
	    elideNodes: () => elideNodes,
	    emitComments: () => emitComments,
	    emitDetachedComments: () => emitDetachedComments,
	    emitFiles: () => emitFiles,
	    emitFilesAndReportErrors: () => emitFilesAndReportErrors,
	    emitFilesAndReportErrorsAndGetExitStatus: () => emitFilesAndReportErrorsAndGetExitStatus,
	    emitModuleKindIsNonNodeESM: () => emitModuleKindIsNonNodeESM,
	    emitNewLineBeforeLeadingCommentOfPosition: () => emitNewLineBeforeLeadingCommentOfPosition,
	    emitNewLineBeforeLeadingComments: () => emitNewLineBeforeLeadingComments,
	    emitNewLineBeforeLeadingCommentsOfPosition: () => emitNewLineBeforeLeadingCommentsOfPosition,
	    emitSkippedWithNoDiagnostics: () => emitSkippedWithNoDiagnostics,
	    emitUsingBuildInfo: () => emitUsingBuildInfo,
	    emptyArray: () => emptyArray,
	    emptyFileSystemEntries: () => emptyFileSystemEntries,
	    emptyMap: () => emptyMap,
	    emptyOptions: () => emptyOptions,
	    emptySet: () => emptySet,
	    endsWith: () => endsWith,
	    ensurePathIsNonModuleName: () => ensurePathIsNonModuleName,
	    ensureScriptKind: () => ensureScriptKind,
	    ensureTrailingDirectorySeparator: () => ensureTrailingDirectorySeparator,
	    entityNameToString: () => entityNameToString,
	    enumerateInsertsAndDeletes: () => enumerateInsertsAndDeletes,
	    equalOwnProperties: () => equalOwnProperties,
	    equateStringsCaseInsensitive: () => equateStringsCaseInsensitive,
	    equateStringsCaseSensitive: () => equateStringsCaseSensitive,
	    equateValues: () => equateValues,
	    esDecorateHelper: () => esDecorateHelper,
	    escapeJsxAttributeString: () => escapeJsxAttributeString,
	    escapeLeadingUnderscores: () => escapeLeadingUnderscores,
	    escapeNonAsciiString: () => escapeNonAsciiString,
	    escapeSnippetText: () => escapeSnippetText,
	    escapeString: () => escapeString,
	    escapeTemplateSubstitution: () => escapeTemplateSubstitution,
	    every: () => every,
	    expandPreOrPostfixIncrementOrDecrementExpression: () => expandPreOrPostfixIncrementOrDecrementExpression,
	    explainFiles: () => explainFiles,
	    explainIfFileIsRedirectAndImpliedFormat: () => explainIfFileIsRedirectAndImpliedFormat,
	    exportAssignmentIsAlias: () => exportAssignmentIsAlias,
	    exportStarHelper: () => exportStarHelper,
	    expressionResultIsUnused: () => expressionResultIsUnused,
	    extend: () => extend,
	    extendsHelper: () => extendsHelper,
	    extensionFromPath: () => extensionFromPath,
	    extensionIsTS: () => extensionIsTS,
	    extensionsNotSupportingExtensionlessResolution: () => extensionsNotSupportingExtensionlessResolution,
	    externalHelpersModuleNameText: () => externalHelpersModuleNameText,
	    factory: () => factory,
	    fileExtensionIs: () => fileExtensionIs,
	    fileExtensionIsOneOf: () => fileExtensionIsOneOf,
	    fileIncludeReasonToDiagnostics: () => fileIncludeReasonToDiagnostics,
	    fileShouldUseJavaScriptRequire: () => fileShouldUseJavaScriptRequire,
	    filter: () => filter,
	    filterMutate: () => filterMutate,
	    filterSemanticDiagnostics: () => filterSemanticDiagnostics,
	    find: () => find,
	    findAncestor: () => findAncestor,
	    findBestPatternMatch: () => findBestPatternMatch,
	    findChildOfKind: () => findChildOfKind,
	    findComputedPropertyNameCacheAssignment: () => findComputedPropertyNameCacheAssignment,
	    findConfigFile: () => findConfigFile,
	    findContainingList: () => findContainingList,
	    findDiagnosticForNode: () => findDiagnosticForNode,
	    findFirstNonJsxWhitespaceToken: () => findFirstNonJsxWhitespaceToken,
	    findIndex: () => findIndex,
	    findLast: () => findLast,
	    findLastIndex: () => findLastIndex,
	    findListItemInfo: () => findListItemInfo,
	    findMap: () => findMap,
	    findModifier: () => findModifier,
	    findNextToken: () => findNextToken,
	    findPackageJson: () => findPackageJson,
	    findPackageJsons: () => findPackageJsons,
	    findPrecedingMatchingToken: () => findPrecedingMatchingToken,
	    findPrecedingToken: () => findPrecedingToken,
	    findSuperStatementIndexPath: () => findSuperStatementIndexPath,
	    findTokenOnLeftOfPosition: () => findTokenOnLeftOfPosition,
	    findUseStrictPrologue: () => findUseStrictPrologue,
	    first: () => first,
	    firstDefined: () => firstDefined,
	    firstDefinedIterator: () => firstDefinedIterator,
	    firstIterator: () => firstIterator,
	    firstOrOnly: () => firstOrOnly,
	    firstOrUndefined: () => firstOrUndefined,
	    firstOrUndefinedIterator: () => firstOrUndefinedIterator,
	    fixupCompilerOptions: () => fixupCompilerOptions,
	    flatMap: () => flatMap,
	    flatMapIterator: () => flatMapIterator,
	    flatMapToMutable: () => flatMapToMutable,
	    flatten: () => flatten,
	    flattenCommaList: () => flattenCommaList,
	    flattenDestructuringAssignment: () => flattenDestructuringAssignment,
	    flattenDestructuringBinding: () => flattenDestructuringBinding,
	    flattenDiagnosticMessageText: () => flattenDiagnosticMessageText,
	    forEach: () => forEach,
	    forEachAncestor: () => forEachAncestor,
	    forEachAncestorDirectory: () => forEachAncestorDirectory,
	    forEachChild: () => forEachChild,
	    forEachChildRecursively: () => forEachChildRecursively,
	    forEachEmittedFile: () => forEachEmittedFile,
	    forEachEnclosingBlockScopeContainer: () => forEachEnclosingBlockScopeContainer,
	    forEachEntry: () => forEachEntry,
	    forEachExternalModuleToImportFrom: () => forEachExternalModuleToImportFrom,
	    forEachImportClauseDeclaration: () => forEachImportClauseDeclaration,
	    forEachKey: () => forEachKey,
	    forEachLeadingCommentRange: () => forEachLeadingCommentRange,
	    forEachNameInAccessChainWalkingLeft: () => forEachNameInAccessChainWalkingLeft,
	    forEachPropertyAssignment: () => forEachPropertyAssignment,
	    forEachResolvedProjectReference: () => forEachResolvedProjectReference,
	    forEachReturnStatement: () => forEachReturnStatement,
	    forEachRight: () => forEachRight,
	    forEachTrailingCommentRange: () => forEachTrailingCommentRange,
	    forEachTsConfigPropArray: () => forEachTsConfigPropArray,
	    forEachUnique: () => forEachUnique,
	    forEachYieldExpression: () => forEachYieldExpression,
	    forSomeAncestorDirectory: () => forSomeAncestorDirectory,
	    formatColorAndReset: () => formatColorAndReset,
	    formatDiagnostic: () => formatDiagnostic,
	    formatDiagnostics: () => formatDiagnostics,
	    formatDiagnosticsWithColorAndContext: () => formatDiagnosticsWithColorAndContext,
	    formatGeneratedName: () => formatGeneratedName,
	    formatGeneratedNamePart: () => formatGeneratedNamePart,
	    formatLocation: () => formatLocation,
	    formatMessage: () => formatMessage,
	    formatStringFromArgs: () => formatStringFromArgs,
	    formatting: () => ts_formatting_exports,
	    fullTripleSlashAMDReferencePathRegEx: () => fullTripleSlashAMDReferencePathRegEx,
	    fullTripleSlashReferencePathRegEx: () => fullTripleSlashReferencePathRegEx,
	    generateDjb2Hash: () => generateDjb2Hash,
	    generateTSConfig: () => generateTSConfig,
	    generatorHelper: () => generatorHelper,
	    getAdjustedReferenceLocation: () => getAdjustedReferenceLocation,
	    getAdjustedRenameLocation: () => getAdjustedRenameLocation,
	    getAliasDeclarationFromName: () => getAliasDeclarationFromName,
	    getAllAccessorDeclarations: () => getAllAccessorDeclarations,
	    getAllDecoratorsOfClass: () => getAllDecoratorsOfClass,
	    getAllDecoratorsOfClassElement: () => getAllDecoratorsOfClassElement,
	    getAllJSDocTags: () => getAllJSDocTags,
	    getAllJSDocTagsOfKind: () => getAllJSDocTagsOfKind,
	    getAllKeys: () => getAllKeys,
	    getAllProjectOutputs: () => getAllProjectOutputs,
	    getAllSuperTypeNodes: () => getAllSuperTypeNodes,
	    getAllUnscopedEmitHelpers: () => getAllUnscopedEmitHelpers,
	    getAllowJSCompilerOption: () => getAllowJSCompilerOption,
	    getAllowSyntheticDefaultImports: () => getAllowSyntheticDefaultImports,
	    getAncestor: () => getAncestor,
	    getAnyExtensionFromPath: () => getAnyExtensionFromPath,
	    getAreDeclarationMapsEnabled: () => getAreDeclarationMapsEnabled,
	    getAssignedExpandoInitializer: () => getAssignedExpandoInitializer,
	    getAssignedName: () => getAssignedName,
	    getAssignedNameOfIdentifier: () => getAssignedNameOfIdentifier,
	    getAssignmentDeclarationKind: () => getAssignmentDeclarationKind,
	    getAssignmentDeclarationPropertyAccessKind: () => getAssignmentDeclarationPropertyAccessKind,
	    getAssignmentTargetKind: () => getAssignmentTargetKind,
	    getAutomaticTypeDirectiveNames: () => getAutomaticTypeDirectiveNames,
	    getBaseFileName: () => getBaseFileName,
	    getBinaryOperatorPrecedence: () => getBinaryOperatorPrecedence,
	    getBuildInfo: () => getBuildInfo,
	    getBuildInfoFileVersionMap: () => getBuildInfoFileVersionMap,
	    getBuildInfoText: () => getBuildInfoText,
	    getBuildOrderFromAnyBuildOrder: () => getBuildOrderFromAnyBuildOrder,
	    getBuilderCreationParameters: () => getBuilderCreationParameters,
	    getBuilderFileEmit: () => getBuilderFileEmit,
	    getCheckFlags: () => getCheckFlags,
	    getClassExtendsHeritageElement: () => getClassExtendsHeritageElement,
	    getClassLikeDeclarationOfSymbol: () => getClassLikeDeclarationOfSymbol,
	    getCombinedLocalAndExportSymbolFlags: () => getCombinedLocalAndExportSymbolFlags,
	    getCombinedModifierFlags: () => getCombinedModifierFlags,
	    getCombinedNodeFlags: () => getCombinedNodeFlags,
	    getCombinedNodeFlagsAlwaysIncludeJSDoc: () => getCombinedNodeFlagsAlwaysIncludeJSDoc,
	    getCommentRange: () => getCommentRange,
	    getCommonSourceDirectory: () => getCommonSourceDirectory,
	    getCommonSourceDirectoryOfConfig: () => getCommonSourceDirectoryOfConfig,
	    getCompilerOptionValue: () => getCompilerOptionValue,
	    getCompilerOptionsDiffValue: () => getCompilerOptionsDiffValue,
	    getConditions: () => getConditions,
	    getConfigFileParsingDiagnostics: () => getConfigFileParsingDiagnostics,
	    getConstantValue: () => getConstantValue,
	    getContainerFlags: () => getContainerFlags,
	    getContainerNode: () => getContainerNode,
	    getContainingClass: () => getContainingClass,
	    getContainingClassExcludingClassDecorators: () => getContainingClassExcludingClassDecorators,
	    getContainingClassStaticBlock: () => getContainingClassStaticBlock,
	    getContainingFunction: () => getContainingFunction,
	    getContainingFunctionDeclaration: () => getContainingFunctionDeclaration,
	    getContainingFunctionOrClassStaticBlock: () => getContainingFunctionOrClassStaticBlock,
	    getContainingNodeArray: () => getContainingNodeArray,
	    getContainingObjectLiteralElement: () => getContainingObjectLiteralElement,
	    getContextualTypeFromParent: () => getContextualTypeFromParent,
	    getContextualTypeFromParentOrAncestorTypeNode: () => getContextualTypeFromParentOrAncestorTypeNode,
	    getCurrentTime: () => getCurrentTime,
	    getDeclarationDiagnostics: () => getDeclarationDiagnostics,
	    getDeclarationEmitExtensionForPath: () => getDeclarationEmitExtensionForPath,
	    getDeclarationEmitOutputFilePath: () => getDeclarationEmitOutputFilePath,
	    getDeclarationEmitOutputFilePathWorker: () => getDeclarationEmitOutputFilePathWorker,
	    getDeclarationFileExtension: () => getDeclarationFileExtension,
	    getDeclarationFromName: () => getDeclarationFromName,
	    getDeclarationModifierFlagsFromSymbol: () => getDeclarationModifierFlagsFromSymbol,
	    getDeclarationOfKind: () => getDeclarationOfKind,
	    getDeclarationsOfKind: () => getDeclarationsOfKind,
	    getDeclaredExpandoInitializer: () => getDeclaredExpandoInitializer,
	    getDecorators: () => getDecorators,
	    getDefaultCompilerOptions: () => getDefaultCompilerOptions2,
	    getDefaultExportInfoWorker: () => getDefaultExportInfoWorker,
	    getDefaultFormatCodeSettings: () => getDefaultFormatCodeSettings,
	    getDefaultLibFileName: () => getDefaultLibFileName,
	    getDefaultLibFilePath: () => getDefaultLibFilePath,
	    getDefaultLikeExportInfo: () => getDefaultLikeExportInfo,
	    getDiagnosticText: () => getDiagnosticText,
	    getDiagnosticsWithinSpan: () => getDiagnosticsWithinSpan,
	    getDirectoryPath: () => getDirectoryPath,
	    getDirectoryToWatchFailedLookupLocation: () => getDirectoryToWatchFailedLookupLocation,
	    getDirectoryToWatchFailedLookupLocationFromTypeRoot: () => getDirectoryToWatchFailedLookupLocationFromTypeRoot,
	    getDocumentPositionMapper: () => getDocumentPositionMapper,
	    getDocumentSpansEqualityComparer: () => getDocumentSpansEqualityComparer,
	    getESModuleInterop: () => getESModuleInterop,
	    getEditsForFileRename: () => getEditsForFileRename,
	    getEffectiveBaseTypeNode: () => getEffectiveBaseTypeNode,
	    getEffectiveConstraintOfTypeParameter: () => getEffectiveConstraintOfTypeParameter,
	    getEffectiveContainerForJSDocTemplateTag: () => getEffectiveContainerForJSDocTemplateTag,
	    getEffectiveImplementsTypeNodes: () => getEffectiveImplementsTypeNodes,
	    getEffectiveInitializer: () => getEffectiveInitializer,
	    getEffectiveJSDocHost: () => getEffectiveJSDocHost,
	    getEffectiveModifierFlags: () => getEffectiveModifierFlags,
	    getEffectiveModifierFlagsAlwaysIncludeJSDoc: () => getEffectiveModifierFlagsAlwaysIncludeJSDoc,
	    getEffectiveModifierFlagsNoCache: () => getEffectiveModifierFlagsNoCache,
	    getEffectiveReturnTypeNode: () => getEffectiveReturnTypeNode,
	    getEffectiveSetAccessorTypeAnnotationNode: () => getEffectiveSetAccessorTypeAnnotationNode,
	    getEffectiveTypeAnnotationNode: () => getEffectiveTypeAnnotationNode,
	    getEffectiveTypeParameterDeclarations: () => getEffectiveTypeParameterDeclarations,
	    getEffectiveTypeRoots: () => getEffectiveTypeRoots,
	    getElementOrPropertyAccessArgumentExpressionOrName: () => getElementOrPropertyAccessArgumentExpressionOrName,
	    getElementOrPropertyAccessName: () => getElementOrPropertyAccessName,
	    getElementsOfBindingOrAssignmentPattern: () => getElementsOfBindingOrAssignmentPattern,
	    getEmitDeclarations: () => getEmitDeclarations,
	    getEmitFlags: () => getEmitFlags,
	    getEmitHelpers: () => getEmitHelpers,
	    getEmitModuleDetectionKind: () => getEmitModuleDetectionKind,
	    getEmitModuleKind: () => getEmitModuleKind,
	    getEmitModuleResolutionKind: () => getEmitModuleResolutionKind,
	    getEmitScriptTarget: () => getEmitScriptTarget,
	    getEmitStandardClassFields: () => getEmitStandardClassFields,
	    getEnclosingBlockScopeContainer: () => getEnclosingBlockScopeContainer,
	    getEnclosingContainer: () => getEnclosingContainer,
	    getEncodedSemanticClassifications: () => getEncodedSemanticClassifications,
	    getEncodedSyntacticClassifications: () => getEncodedSyntacticClassifications,
	    getEndLinePosition: () => getEndLinePosition,
	    getEntityNameFromTypeNode: () => getEntityNameFromTypeNode,
	    getEntrypointsFromPackageJsonInfo: () => getEntrypointsFromPackageJsonInfo,
	    getErrorCountForSummary: () => getErrorCountForSummary,
	    getErrorSpanForNode: () => getErrorSpanForNode,
	    getErrorSummaryText: () => getErrorSummaryText,
	    getEscapedTextOfIdentifierOrLiteral: () => getEscapedTextOfIdentifierOrLiteral,
	    getEscapedTextOfJsxAttributeName: () => getEscapedTextOfJsxAttributeName,
	    getEscapedTextOfJsxNamespacedName: () => getEscapedTextOfJsxNamespacedName,
	    getExpandoInitializer: () => getExpandoInitializer,
	    getExportAssignmentExpression: () => getExportAssignmentExpression,
	    getExportInfoMap: () => getExportInfoMap,
	    getExportNeedsImportStarHelper: () => getExportNeedsImportStarHelper,
	    getExpressionAssociativity: () => getExpressionAssociativity,
	    getExpressionPrecedence: () => getExpressionPrecedence,
	    getExternalHelpersModuleName: () => getExternalHelpersModuleName,
	    getExternalModuleImportEqualsDeclarationExpression: () => getExternalModuleImportEqualsDeclarationExpression,
	    getExternalModuleName: () => getExternalModuleName,
	    getExternalModuleNameFromDeclaration: () => getExternalModuleNameFromDeclaration,
	    getExternalModuleNameFromPath: () => getExternalModuleNameFromPath,
	    getExternalModuleNameLiteral: () => getExternalModuleNameLiteral,
	    getExternalModuleRequireArgument: () => getExternalModuleRequireArgument,
	    getFallbackOptions: () => getFallbackOptions,
	    getFileEmitOutput: () => getFileEmitOutput,
	    getFileMatcherPatterns: () => getFileMatcherPatterns,
	    getFileNamesFromConfigSpecs: () => getFileNamesFromConfigSpecs,
	    getFileWatcherEventKind: () => getFileWatcherEventKind,
	    getFilesInErrorForSummary: () => getFilesInErrorForSummary,
	    getFirstConstructorWithBody: () => getFirstConstructorWithBody,
	    getFirstIdentifier: () => getFirstIdentifier,
	    getFirstNonSpaceCharacterPosition: () => getFirstNonSpaceCharacterPosition,
	    getFirstProjectOutput: () => getFirstProjectOutput,
	    getFixableErrorSpanExpression: () => getFixableErrorSpanExpression,
	    getFormatCodeSettingsForWriting: () => getFormatCodeSettingsForWriting,
	    getFullWidth: () => getFullWidth,
	    getFunctionFlags: () => getFunctionFlags,
	    getHeritageClause: () => getHeritageClause,
	    getHostSignatureFromJSDoc: () => getHostSignatureFromJSDoc,
	    getIdentifierAutoGenerate: () => getIdentifierAutoGenerate,
	    getIdentifierGeneratedImportReference: () => getIdentifierGeneratedImportReference,
	    getIdentifierTypeArguments: () => getIdentifierTypeArguments,
	    getImmediatelyInvokedFunctionExpression: () => getImmediatelyInvokedFunctionExpression,
	    getImpliedNodeFormatForFile: () => getImpliedNodeFormatForFile,
	    getImpliedNodeFormatForFileWorker: () => getImpliedNodeFormatForFileWorker,
	    getImportNeedsImportDefaultHelper: () => getImportNeedsImportDefaultHelper,
	    getImportNeedsImportStarHelper: () => getImportNeedsImportStarHelper,
	    getIndentSize: () => getIndentSize,
	    getIndentString: () => getIndentString,
	    getInferredLibraryNameResolveFrom: () => getInferredLibraryNameResolveFrom,
	    getInitializedVariables: () => getInitializedVariables,
	    getInitializerOfBinaryExpression: () => getInitializerOfBinaryExpression,
	    getInitializerOfBindingOrAssignmentElement: () => getInitializerOfBindingOrAssignmentElement,
	    getInterfaceBaseTypeNodes: () => getInterfaceBaseTypeNodes,
	    getInternalEmitFlags: () => getInternalEmitFlags,
	    getInvokedExpression: () => getInvokedExpression,
	    getIsolatedModules: () => getIsolatedModules,
	    getJSDocAugmentsTag: () => getJSDocAugmentsTag,
	    getJSDocClassTag: () => getJSDocClassTag,
	    getJSDocCommentRanges: () => getJSDocCommentRanges,
	    getJSDocCommentsAndTags: () => getJSDocCommentsAndTags,
	    getJSDocDeprecatedTag: () => getJSDocDeprecatedTag,
	    getJSDocDeprecatedTagNoCache: () => getJSDocDeprecatedTagNoCache,
	    getJSDocEnumTag: () => getJSDocEnumTag,
	    getJSDocHost: () => getJSDocHost,
	    getJSDocImplementsTags: () => getJSDocImplementsTags,
	    getJSDocOverloadTags: () => getJSDocOverloadTags,
	    getJSDocOverrideTagNoCache: () => getJSDocOverrideTagNoCache,
	    getJSDocParameterTags: () => getJSDocParameterTags,
	    getJSDocParameterTagsNoCache: () => getJSDocParameterTagsNoCache,
	    getJSDocPrivateTag: () => getJSDocPrivateTag,
	    getJSDocPrivateTagNoCache: () => getJSDocPrivateTagNoCache,
	    getJSDocProtectedTag: () => getJSDocProtectedTag,
	    getJSDocProtectedTagNoCache: () => getJSDocProtectedTagNoCache,
	    getJSDocPublicTag: () => getJSDocPublicTag,
	    getJSDocPublicTagNoCache: () => getJSDocPublicTagNoCache,
	    getJSDocReadonlyTag: () => getJSDocReadonlyTag,
	    getJSDocReadonlyTagNoCache: () => getJSDocReadonlyTagNoCache,
	    getJSDocReturnTag: () => getJSDocReturnTag,
	    getJSDocReturnType: () => getJSDocReturnType,
	    getJSDocRoot: () => getJSDocRoot,
	    getJSDocSatisfiesExpressionType: () => getJSDocSatisfiesExpressionType,
	    getJSDocSatisfiesTag: () => getJSDocSatisfiesTag,
	    getJSDocTags: () => getJSDocTags,
	    getJSDocTagsNoCache: () => getJSDocTagsNoCache,
	    getJSDocTemplateTag: () => getJSDocTemplateTag,
	    getJSDocThisTag: () => getJSDocThisTag,
	    getJSDocType: () => getJSDocType,
	    getJSDocTypeAliasName: () => getJSDocTypeAliasName,
	    getJSDocTypeAssertionType: () => getJSDocTypeAssertionType,
	    getJSDocTypeParameterDeclarations: () => getJSDocTypeParameterDeclarations,
	    getJSDocTypeParameterTags: () => getJSDocTypeParameterTags,
	    getJSDocTypeParameterTagsNoCache: () => getJSDocTypeParameterTagsNoCache,
	    getJSDocTypeTag: () => getJSDocTypeTag,
	    getJSXImplicitImportBase: () => getJSXImplicitImportBase,
	    getJSXRuntimeImport: () => getJSXRuntimeImport,
	    getJSXTransformEnabled: () => getJSXTransformEnabled,
	    getKeyForCompilerOptions: () => getKeyForCompilerOptions,
	    getLanguageVariant: () => getLanguageVariant,
	    getLastChild: () => getLastChild,
	    getLeadingCommentRanges: () => getLeadingCommentRanges,
	    getLeadingCommentRangesOfNode: () => getLeadingCommentRangesOfNode,
	    getLeftmostAccessExpression: () => getLeftmostAccessExpression,
	    getLeftmostExpression: () => getLeftmostExpression,
	    getLibraryNameFromLibFileName: () => getLibraryNameFromLibFileName,
	    getLineAndCharacterOfPosition: () => getLineAndCharacterOfPosition,
	    getLineInfo: () => getLineInfo,
	    getLineOfLocalPosition: () => getLineOfLocalPosition,
	    getLineOfLocalPositionFromLineMap: () => getLineOfLocalPositionFromLineMap,
	    getLineStartPositionForPosition: () => getLineStartPositionForPosition,
	    getLineStarts: () => getLineStarts,
	    getLinesBetweenPositionAndNextNonWhitespaceCharacter: () => getLinesBetweenPositionAndNextNonWhitespaceCharacter,
	    getLinesBetweenPositionAndPrecedingNonWhitespaceCharacter: () => getLinesBetweenPositionAndPrecedingNonWhitespaceCharacter,
	    getLinesBetweenPositions: () => getLinesBetweenPositions,
	    getLinesBetweenRangeEndAndRangeStart: () => getLinesBetweenRangeEndAndRangeStart,
	    getLinesBetweenRangeEndPositions: () => getLinesBetweenRangeEndPositions,
	    getLiteralText: () => getLiteralText,
	    getLocalNameForExternalImport: () => getLocalNameForExternalImport,
	    getLocalSymbolForExportDefault: () => getLocalSymbolForExportDefault,
	    getLocaleSpecificMessage: () => getLocaleSpecificMessage,
	    getLocaleTimeString: () => getLocaleTimeString,
	    getMappedContextSpan: () => getMappedContextSpan,
	    getMappedDocumentSpan: () => getMappedDocumentSpan,
	    getMappedLocation: () => getMappedLocation,
	    getMatchedFileSpec: () => getMatchedFileSpec,
	    getMatchedIncludeSpec: () => getMatchedIncludeSpec,
	    getMeaningFromDeclaration: () => getMeaningFromDeclaration,
	    getMeaningFromLocation: () => getMeaningFromLocation,
	    getMembersOfDeclaration: () => getMembersOfDeclaration,
	    getModeForFileReference: () => getModeForFileReference,
	    getModeForResolutionAtIndex: () => getModeForResolutionAtIndex,
	    getModeForUsageLocation: () => getModeForUsageLocation,
	    getModifiedTime: () => getModifiedTime,
	    getModifiers: () => getModifiers,
	    getModuleInstanceState: () => getModuleInstanceState,
	    getModuleNameStringLiteralAt: () => getModuleNameStringLiteralAt,
	    getModuleSpecifierEndingPreference: () => getModuleSpecifierEndingPreference,
	    getModuleSpecifierResolverHost: () => getModuleSpecifierResolverHost,
	    getNameForExportedSymbol: () => getNameForExportedSymbol,
	    getNameFromImportAttribute: () => getNameFromImportAttribute,
	    getNameFromIndexInfo: () => getNameFromIndexInfo,
	    getNameFromPropertyName: () => getNameFromPropertyName,
	    getNameOfAccessExpression: () => getNameOfAccessExpression,
	    getNameOfCompilerOptionValue: () => getNameOfCompilerOptionValue,
	    getNameOfDeclaration: () => getNameOfDeclaration,
	    getNameOfExpando: () => getNameOfExpando,
	    getNameOfJSDocTypedef: () => getNameOfJSDocTypedef,
	    getNameOrArgument: () => getNameOrArgument,
	    getNameTable: () => getNameTable,
	    getNamesForExportedSymbol: () => getNamesForExportedSymbol,
	    getNamespaceDeclarationNode: () => getNamespaceDeclarationNode,
	    getNewLineCharacter: () => getNewLineCharacter,
	    getNewLineKind: () => getNewLineKind,
	    getNewLineOrDefaultFromHost: () => getNewLineOrDefaultFromHost,
	    getNewTargetContainer: () => getNewTargetContainer,
	    getNextJSDocCommentLocation: () => getNextJSDocCommentLocation,
	    getNodeForGeneratedName: () => getNodeForGeneratedName,
	    getNodeId: () => getNodeId,
	    getNodeKind: () => getNodeKind,
	    getNodeModifiers: () => getNodeModifiers,
	    getNodeModulePathParts: () => getNodeModulePathParts,
	    getNonAssignedNameOfDeclaration: () => getNonAssignedNameOfDeclaration,
	    getNonAssignmentOperatorForCompoundAssignment: () => getNonAssignmentOperatorForCompoundAssignment,
	    getNonAugmentationDeclaration: () => getNonAugmentationDeclaration,
	    getNonDecoratorTokenPosOfNode: () => getNonDecoratorTokenPosOfNode,
	    getNormalizedAbsolutePath: () => getNormalizedAbsolutePath,
	    getNormalizedAbsolutePathWithoutRoot: () => getNormalizedAbsolutePathWithoutRoot,
	    getNormalizedPathComponents: () => getNormalizedPathComponents,
	    getObjectFlags: () => getObjectFlags,
	    getOperator: () => getOperator,
	    getOperatorAssociativity: () => getOperatorAssociativity,
	    getOperatorPrecedence: () => getOperatorPrecedence,
	    getOptionFromName: () => getOptionFromName,
	    getOptionsForLibraryResolution: () => getOptionsForLibraryResolution,
	    getOptionsNameMap: () => getOptionsNameMap,
	    getOrCreateEmitNode: () => getOrCreateEmitNode,
	    getOrCreateExternalHelpersModuleNameIfNeeded: () => getOrCreateExternalHelpersModuleNameIfNeeded,
	    getOrUpdate: () => getOrUpdate,
	    getOriginalNode: () => getOriginalNode,
	    getOriginalNodeId: () => getOriginalNodeId,
	    getOriginalSourceFile: () => getOriginalSourceFile,
	    getOutputDeclarationFileName: () => getOutputDeclarationFileName,
	    getOutputDeclarationFileNameWorker: () => getOutputDeclarationFileNameWorker,
	    getOutputExtension: () => getOutputExtension,
	    getOutputFileNames: () => getOutputFileNames,
	    getOutputJSFileNameWorker: () => getOutputJSFileNameWorker,
	    getOutputPathsFor: () => getOutputPathsFor,
	    getOutputPathsForBundle: () => getOutputPathsForBundle,
	    getOwnEmitOutputFilePath: () => getOwnEmitOutputFilePath,
	    getOwnKeys: () => getOwnKeys,
	    getOwnValues: () => getOwnValues,
	    getPackageJsonInfo: () => getPackageJsonInfo,
	    getPackageJsonTypesVersionsPaths: () => getPackageJsonTypesVersionsPaths,
	    getPackageJsonsVisibleToFile: () => getPackageJsonsVisibleToFile,
	    getPackageNameFromTypesPackageName: () => getPackageNameFromTypesPackageName,
	    getPackageScopeForPath: () => getPackageScopeForPath,
	    getParameterSymbolFromJSDoc: () => getParameterSymbolFromJSDoc,
	    getParameterTypeNode: () => getParameterTypeNode,
	    getParentNodeInSpan: () => getParentNodeInSpan,
	    getParseTreeNode: () => getParseTreeNode,
	    getParsedCommandLineOfConfigFile: () => getParsedCommandLineOfConfigFile,
	    getPathComponents: () => getPathComponents,
	    getPathComponentsRelativeTo: () => getPathComponentsRelativeTo,
	    getPathFromPathComponents: () => getPathFromPathComponents,
	    getPathUpdater: () => getPathUpdater,
	    getPathsBasePath: () => getPathsBasePath,
	    getPatternFromSpec: () => getPatternFromSpec,
	    getPendingEmitKind: () => getPendingEmitKind,
	    getPositionOfLineAndCharacter: () => getPositionOfLineAndCharacter,
	    getPossibleGenericSignatures: () => getPossibleGenericSignatures,
	    getPossibleOriginalInputExtensionForExtension: () => getPossibleOriginalInputExtensionForExtension,
	    getPossibleTypeArgumentsInfo: () => getPossibleTypeArgumentsInfo,
	    getPreEmitDiagnostics: () => getPreEmitDiagnostics,
	    getPrecedingNonSpaceCharacterPosition: () => getPrecedingNonSpaceCharacterPosition,
	    getPrivateIdentifier: () => getPrivateIdentifier,
	    getProperties: () => getProperties,
	    getProperty: () => getProperty,
	    getPropertyArrayElementValue: () => getPropertyArrayElementValue,
	    getPropertyAssignmentAliasLikeExpression: () => getPropertyAssignmentAliasLikeExpression,
	    getPropertyNameForPropertyNameNode: () => getPropertyNameForPropertyNameNode,
	    getPropertyNameForUniqueESSymbol: () => getPropertyNameForUniqueESSymbol,
	    getPropertyNameFromType: () => getPropertyNameFromType,
	    getPropertyNameOfBindingOrAssignmentElement: () => getPropertyNameOfBindingOrAssignmentElement,
	    getPropertySymbolFromBindingElement: () => getPropertySymbolFromBindingElement,
	    getPropertySymbolsFromContextualType: () => getPropertySymbolsFromContextualType,
	    getQuoteFromPreference: () => getQuoteFromPreference,
	    getQuotePreference: () => getQuotePreference,
	    getRangesWhere: () => getRangesWhere,
	    getRefactorContextSpan: () => getRefactorContextSpan,
	    getReferencedFileLocation: () => getReferencedFileLocation,
	    getRegexFromPattern: () => getRegexFromPattern,
	    getRegularExpressionForWildcard: () => getRegularExpressionForWildcard,
	    getRegularExpressionsForWildcards: () => getRegularExpressionsForWildcards,
	    getRelativePathFromDirectory: () => getRelativePathFromDirectory,
	    getRelativePathFromFile: () => getRelativePathFromFile,
	    getRelativePathToDirectoryOrUrl: () => getRelativePathToDirectoryOrUrl,
	    getRenameLocation: () => getRenameLocation,
	    getReplacementSpanForContextToken: () => getReplacementSpanForContextToken,
	    getResolutionDiagnostic: () => getResolutionDiagnostic,
	    getResolutionModeOverride: () => getResolutionModeOverride,
	    getResolveJsonModule: () => getResolveJsonModule,
	    getResolvePackageJsonExports: () => getResolvePackageJsonExports,
	    getResolvePackageJsonImports: () => getResolvePackageJsonImports,
	    getResolvedExternalModuleName: () => getResolvedExternalModuleName,
	    getRestIndicatorOfBindingOrAssignmentElement: () => getRestIndicatorOfBindingOrAssignmentElement,
	    getRestParameterElementType: () => getRestParameterElementType,
	    getRightMostAssignedExpression: () => getRightMostAssignedExpression,
	    getRootDeclaration: () => getRootDeclaration,
	    getRootDirectoryOfResolutionCache: () => getRootDirectoryOfResolutionCache,
	    getRootLength: () => getRootLength,
	    getRootPathSplitLength: () => getRootPathSplitLength,
	    getScriptKind: () => getScriptKind,
	    getScriptKindFromFileName: () => getScriptKindFromFileName,
	    getScriptTargetFeatures: () => getScriptTargetFeatures,
	    getSelectedEffectiveModifierFlags: () => getSelectedEffectiveModifierFlags,
	    getSelectedSyntacticModifierFlags: () => getSelectedSyntacticModifierFlags,
	    getSemanticClassifications: () => getSemanticClassifications,
	    getSemanticJsxChildren: () => getSemanticJsxChildren,
	    getSetAccessorTypeAnnotationNode: () => getSetAccessorTypeAnnotationNode,
	    getSetAccessorValueParameter: () => getSetAccessorValueParameter,
	    getSetExternalModuleIndicator: () => getSetExternalModuleIndicator,
	    getShebang: () => getShebang,
	    getSingleInitializerOfVariableStatementOrPropertyDeclaration: () => getSingleInitializerOfVariableStatementOrPropertyDeclaration,
	    getSingleVariableOfVariableStatement: () => getSingleVariableOfVariableStatement,
	    getSnapshotText: () => getSnapshotText,
	    getSnippetElement: () => getSnippetElement,
	    getSourceFileOfModule: () => getSourceFileOfModule,
	    getSourceFileOfNode: () => getSourceFileOfNode,
	    getSourceFilePathInNewDir: () => getSourceFilePathInNewDir,
	    getSourceFilePathInNewDirWorker: () => getSourceFilePathInNewDirWorker,
	    getSourceFileVersionAsHashFromText: () => getSourceFileVersionAsHashFromText,
	    getSourceFilesToEmit: () => getSourceFilesToEmit,
	    getSourceMapRange: () => getSourceMapRange,
	    getSourceMapper: () => getSourceMapper,
	    getSourceTextOfNodeFromSourceFile: () => getSourceTextOfNodeFromSourceFile,
	    getSpanOfTokenAtPosition: () => getSpanOfTokenAtPosition,
	    getSpellingSuggestion: () => getSpellingSuggestion,
	    getStartPositionOfLine: () => getStartPositionOfLine,
	    getStartPositionOfRange: () => getStartPositionOfRange,
	    getStartsOnNewLine: () => getStartsOnNewLine,
	    getStaticPropertiesAndClassStaticBlock: () => getStaticPropertiesAndClassStaticBlock,
	    getStrictOptionValue: () => getStrictOptionValue,
	    getStringComparer: () => getStringComparer,
	    getSubPatternFromSpec: () => getSubPatternFromSpec,
	    getSuperCallFromStatement: () => getSuperCallFromStatement,
	    getSuperContainer: () => getSuperContainer,
	    getSupportedCodeFixes: () => getSupportedCodeFixes,
	    getSupportedExtensions: () => getSupportedExtensions,
	    getSupportedExtensionsWithJsonIfResolveJsonModule: () => getSupportedExtensionsWithJsonIfResolveJsonModule,
	    getSwitchedType: () => getSwitchedType,
	    getSymbolId: () => getSymbolId,
	    getSymbolNameForPrivateIdentifier: () => getSymbolNameForPrivateIdentifier,
	    getSymbolTarget: () => getSymbolTarget,
	    getSyntacticClassifications: () => getSyntacticClassifications,
	    getSyntacticModifierFlags: () => getSyntacticModifierFlags,
	    getSyntacticModifierFlagsNoCache: () => getSyntacticModifierFlagsNoCache,
	    getSynthesizedDeepClone: () => getSynthesizedDeepClone,
	    getSynthesizedDeepCloneWithReplacements: () => getSynthesizedDeepCloneWithReplacements,
	    getSynthesizedDeepClones: () => getSynthesizedDeepClones,
	    getSynthesizedDeepClonesWithReplacements: () => getSynthesizedDeepClonesWithReplacements,
	    getSyntheticLeadingComments: () => getSyntheticLeadingComments,
	    getSyntheticTrailingComments: () => getSyntheticTrailingComments,
	    getTargetLabel: () => getTargetLabel,
	    getTargetOfBindingOrAssignmentElement: () => getTargetOfBindingOrAssignmentElement,
	    getTemporaryModuleResolutionState: () => getTemporaryModuleResolutionState,
	    getTextOfConstantValue: () => getTextOfConstantValue,
	    getTextOfIdentifierOrLiteral: () => getTextOfIdentifierOrLiteral,
	    getTextOfJSDocComment: () => getTextOfJSDocComment,
	    getTextOfJsxAttributeName: () => getTextOfJsxAttributeName,
	    getTextOfJsxNamespacedName: () => getTextOfJsxNamespacedName,
	    getTextOfNode: () => getTextOfNode,
	    getTextOfNodeFromSourceText: () => getTextOfNodeFromSourceText,
	    getTextOfPropertyName: () => getTextOfPropertyName,
	    getThisContainer: () => getThisContainer,
	    getThisParameter: () => getThisParameter,
	    getTokenAtPosition: () => getTokenAtPosition,
	    getTokenPosOfNode: () => getTokenPosOfNode,
	    getTokenSourceMapRange: () => getTokenSourceMapRange,
	    getTouchingPropertyName: () => getTouchingPropertyName,
	    getTouchingToken: () => getTouchingToken,
	    getTrailingCommentRanges: () => getTrailingCommentRanges,
	    getTrailingSemicolonDeferringWriter: () => getTrailingSemicolonDeferringWriter,
	    getTransformFlagsSubtreeExclusions: () => getTransformFlagsSubtreeExclusions,
	    getTransformers: () => getTransformers,
	    getTsBuildInfoEmitOutputFilePath: () => getTsBuildInfoEmitOutputFilePath,
	    getTsConfigObjectLiteralExpression: () => getTsConfigObjectLiteralExpression,
	    getTsConfigPropArrayElementValue: () => getTsConfigPropArrayElementValue,
	    getTypeAnnotationNode: () => getTypeAnnotationNode,
	    getTypeArgumentOrTypeParameterList: () => getTypeArgumentOrTypeParameterList,
	    getTypeKeywordOfTypeOnlyImport: () => getTypeKeywordOfTypeOnlyImport,
	    getTypeNode: () => getTypeNode,
	    getTypeNodeIfAccessible: () => getTypeNodeIfAccessible,
	    getTypeParameterFromJsDoc: () => getTypeParameterFromJsDoc,
	    getTypeParameterOwner: () => getTypeParameterOwner,
	    getTypesPackageName: () => getTypesPackageName,
	    getUILocale: () => getUILocale,
	    getUniqueName: () => getUniqueName,
	    getUniqueSymbolId: () => getUniqueSymbolId,
	    getUseDefineForClassFields: () => getUseDefineForClassFields,
	    getWatchErrorSummaryDiagnosticMessage: () => getWatchErrorSummaryDiagnosticMessage,
	    getWatchFactory: () => getWatchFactory,
	    group: () => group,
	    groupBy: () => groupBy,
	    guessIndentation: () => guessIndentation,
	    handleNoEmitOptions: () => handleNoEmitOptions,
	    hasAbstractModifier: () => hasAbstractModifier,
	    hasAccessorModifier: () => hasAccessorModifier,
	    hasAmbientModifier: () => hasAmbientModifier,
	    hasChangesInResolutions: () => hasChangesInResolutions,
	    hasChildOfKind: () => hasChildOfKind,
	    hasContextSensitiveParameters: () => hasContextSensitiveParameters,
	    hasDecorators: () => hasDecorators,
	    hasDocComment: () => hasDocComment,
	    hasDynamicName: () => hasDynamicName,
	    hasEffectiveModifier: () => hasEffectiveModifier,
	    hasEffectiveModifiers: () => hasEffectiveModifiers,
	    hasEffectiveReadonlyModifier: () => hasEffectiveReadonlyModifier,
	    hasExtension: () => hasExtension,
	    hasIndexSignature: () => hasIndexSignature,
	    hasInitializer: () => hasInitializer,
	    hasInvalidEscape: () => hasInvalidEscape,
	    hasJSDocNodes: () => hasJSDocNodes,
	    hasJSDocParameterTags: () => hasJSDocParameterTags,
	    hasJSFileExtension: () => hasJSFileExtension,
	    hasJsonModuleEmitEnabled: () => hasJsonModuleEmitEnabled,
	    hasOnlyExpressionInitializer: () => hasOnlyExpressionInitializer,
	    hasOverrideModifier: () => hasOverrideModifier,
	    hasPossibleExternalModuleReference: () => hasPossibleExternalModuleReference,
	    hasProperty: () => hasProperty,
	    hasPropertyAccessExpressionWithName: () => hasPropertyAccessExpressionWithName,
	    hasQuestionToken: () => hasQuestionToken,
	    hasRecordedExternalHelpers: () => hasRecordedExternalHelpers,
	    hasResolutionModeOverride: () => hasResolutionModeOverride,
	    hasRestParameter: () => hasRestParameter,
	    hasScopeMarker: () => hasScopeMarker,
	    hasStaticModifier: () => hasStaticModifier,
	    hasSyntacticModifier: () => hasSyntacticModifier,
	    hasSyntacticModifiers: () => hasSyntacticModifiers,
	    hasTSFileExtension: () => hasTSFileExtension,
	    hasTabstop: () => hasTabstop,
	    hasTrailingDirectorySeparator: () => hasTrailingDirectorySeparator,
	    hasType: () => hasType,
	    hasTypeArguments: () => hasTypeArguments,
	    hasZeroOrOneAsteriskCharacter: () => hasZeroOrOneAsteriskCharacter,
	    helperString: () => helperString,
	    hostGetCanonicalFileName: () => hostGetCanonicalFileName,
	    hostUsesCaseSensitiveFileNames: () => hostUsesCaseSensitiveFileNames,
	    idText: () => idText,
	    identifierIsThisKeyword: () => identifierIsThisKeyword,
	    identifierToKeywordKind: () => identifierToKeywordKind,
	    identity: () => identity,
	    identitySourceMapConsumer: () => identitySourceMapConsumer,
	    ignoreSourceNewlines: () => ignoreSourceNewlines,
	    ignoredPaths: () => ignoredPaths,
	    importDefaultHelper: () => importDefaultHelper,
	    importFromModuleSpecifier: () => importFromModuleSpecifier,
	    importNameElisionDisabled: () => importNameElisionDisabled,
	    importStarHelper: () => importStarHelper,
	    indexOfAnyCharCode: () => indexOfAnyCharCode,
	    indexOfNode: () => indexOfNode,
	    indicesOf: () => indicesOf,
	    inferredTypesContainingFile: () => inferredTypesContainingFile,
	    injectClassNamedEvaluationHelperBlockIfMissing: () => injectClassNamedEvaluationHelperBlockIfMissing,
	    injectClassThisAssignmentIfMissing: () => injectClassThisAssignmentIfMissing,
	    insertImports: () => insertImports,
	    insertLeadingStatement: () => insertLeadingStatement,
	    insertSorted: () => insertSorted,
	    insertStatementAfterCustomPrologue: () => insertStatementAfterCustomPrologue,
	    insertStatementAfterStandardPrologue: () => insertStatementAfterStandardPrologue,
	    insertStatementsAfterCustomPrologue: () => insertStatementsAfterCustomPrologue,
	    insertStatementsAfterStandardPrologue: () => insertStatementsAfterStandardPrologue,
	    intersperse: () => intersperse,
	    intrinsicTagNameToString: () => intrinsicTagNameToString,
	    introducesArgumentsExoticObject: () => introducesArgumentsExoticObject,
	    inverseJsxOptionMap: () => inverseJsxOptionMap,
	    isAbstractConstructorSymbol: () => isAbstractConstructorSymbol,
	    isAbstractModifier: () => isAbstractModifier,
	    isAccessExpression: () => isAccessExpression,
	    isAccessibilityModifier: () => isAccessibilityModifier,
	    isAccessor: () => isAccessor,
	    isAccessorModifier: () => isAccessorModifier,
	    isAliasSymbolDeclaration: () => isAliasSymbolDeclaration,
	    isAliasableExpression: () => isAliasableExpression,
	    isAmbientModule: () => isAmbientModule,
	    isAmbientPropertyDeclaration: () => isAmbientPropertyDeclaration,
	    isAnonymousFunctionDefinition: () => isAnonymousFunctionDefinition,
	    isAnyDirectorySeparator: () => isAnyDirectorySeparator,
	    isAnyImportOrBareOrAccessedRequire: () => isAnyImportOrBareOrAccessedRequire,
	    isAnyImportOrReExport: () => isAnyImportOrReExport,
	    isAnyImportSyntax: () => isAnyImportSyntax,
	    isAnySupportedFileExtension: () => isAnySupportedFileExtension,
	    isApplicableVersionedTypesKey: () => isApplicableVersionedTypesKey,
	    isArgumentExpressionOfElementAccess: () => isArgumentExpressionOfElementAccess,
	    isArray: () => isArray,
	    isArrayBindingElement: () => isArrayBindingElement,
	    isArrayBindingOrAssignmentElement: () => isArrayBindingOrAssignmentElement,
	    isArrayBindingOrAssignmentPattern: () => isArrayBindingOrAssignmentPattern,
	    isArrayBindingPattern: () => isArrayBindingPattern,
	    isArrayLiteralExpression: () => isArrayLiteralExpression,
	    isArrayLiteralOrObjectLiteralDestructuringPattern: () => isArrayLiteralOrObjectLiteralDestructuringPattern,
	    isArrayTypeNode: () => isArrayTypeNode,
	    isArrowFunction: () => isArrowFunction,
	    isAsExpression: () => isAsExpression,
	    isAssertClause: () => isAssertClause,
	    isAssertEntry: () => isAssertEntry,
	    isAssertionExpression: () => isAssertionExpression,
	    isAssertsKeyword: () => isAssertsKeyword,
	    isAssignmentDeclaration: () => isAssignmentDeclaration,
	    isAssignmentExpression: () => isAssignmentExpression,
	    isAssignmentOperator: () => isAssignmentOperator,
	    isAssignmentPattern: () => isAssignmentPattern,
	    isAssignmentTarget: () => isAssignmentTarget,
	    isAsteriskToken: () => isAsteriskToken,
	    isAsyncFunction: () => isAsyncFunction,
	    isAsyncModifier: () => isAsyncModifier,
	    isAutoAccessorPropertyDeclaration: () => isAutoAccessorPropertyDeclaration,
	    isAwaitExpression: () => isAwaitExpression,
	    isAwaitKeyword: () => isAwaitKeyword,
	    isBigIntLiteral: () => isBigIntLiteral,
	    isBinaryExpression: () => isBinaryExpression,
	    isBinaryOperatorToken: () => isBinaryOperatorToken,
	    isBindableObjectDefinePropertyCall: () => isBindableObjectDefinePropertyCall,
	    isBindableStaticAccessExpression: () => isBindableStaticAccessExpression,
	    isBindableStaticElementAccessExpression: () => isBindableStaticElementAccessExpression,
	    isBindableStaticNameExpression: () => isBindableStaticNameExpression,
	    isBindingElement: () => isBindingElement,
	    isBindingElementOfBareOrAccessedRequire: () => isBindingElementOfBareOrAccessedRequire,
	    isBindingName: () => isBindingName,
	    isBindingOrAssignmentElement: () => isBindingOrAssignmentElement,
	    isBindingOrAssignmentPattern: () => isBindingOrAssignmentPattern,
	    isBindingPattern: () => isBindingPattern,
	    isBlock: () => isBlock,
	    isBlockOrCatchScoped: () => isBlockOrCatchScoped,
	    isBlockScope: () => isBlockScope,
	    isBlockScopedContainerTopLevel: () => isBlockScopedContainerTopLevel,
	    isBooleanLiteral: () => isBooleanLiteral,
	    isBreakOrContinueStatement: () => isBreakOrContinueStatement,
	    isBreakStatement: () => isBreakStatement,
	    isBuildInfoFile: () => isBuildInfoFile,
	    isBuilderProgram: () => isBuilderProgram2,
	    isBundle: () => isBundle,
	    isBundleFileTextLike: () => isBundleFileTextLike,
	    isCallChain: () => isCallChain,
	    isCallExpression: () => isCallExpression,
	    isCallExpressionTarget: () => isCallExpressionTarget,
	    isCallLikeExpression: () => isCallLikeExpression,
	    isCallLikeOrFunctionLikeExpression: () => isCallLikeOrFunctionLikeExpression,
	    isCallOrNewExpression: () => isCallOrNewExpression,
	    isCallOrNewExpressionTarget: () => isCallOrNewExpressionTarget,
	    isCallSignatureDeclaration: () => isCallSignatureDeclaration,
	    isCallToHelper: () => isCallToHelper,
	    isCaseBlock: () => isCaseBlock,
	    isCaseClause: () => isCaseClause,
	    isCaseKeyword: () => isCaseKeyword,
	    isCaseOrDefaultClause: () => isCaseOrDefaultClause,
	    isCatchClause: () => isCatchClause,
	    isCatchClauseVariableDeclaration: () => isCatchClauseVariableDeclaration,
	    isCatchClauseVariableDeclarationOrBindingElement: () => isCatchClauseVariableDeclarationOrBindingElement,
	    isCheckJsEnabledForFile: () => isCheckJsEnabledForFile,
	    isChildOfNodeWithKind: () => isChildOfNodeWithKind,
	    isCircularBuildOrder: () => isCircularBuildOrder,
	    isClassDeclaration: () => isClassDeclaration,
	    isClassElement: () => isClassElement,
	    isClassExpression: () => isClassExpression,
	    isClassInstanceProperty: () => isClassInstanceProperty,
	    isClassLike: () => isClassLike,
	    isClassMemberModifier: () => isClassMemberModifier,
	    isClassNamedEvaluationHelperBlock: () => isClassNamedEvaluationHelperBlock,
	    isClassOrTypeElement: () => isClassOrTypeElement,
	    isClassStaticBlockDeclaration: () => isClassStaticBlockDeclaration,
	    isClassThisAssignmentBlock: () => isClassThisAssignmentBlock,
	    isCollapsedRange: () => isCollapsedRange,
	    isColonToken: () => isColonToken,
	    isCommaExpression: () => isCommaExpression,
	    isCommaListExpression: () => isCommaListExpression,
	    isCommaSequence: () => isCommaSequence,
	    isCommaToken: () => isCommaToken,
	    isComment: () => isComment,
	    isCommonJsExportPropertyAssignment: () => isCommonJsExportPropertyAssignment,
	    isCommonJsExportedExpression: () => isCommonJsExportedExpression,
	    isCompoundAssignment: () => isCompoundAssignment,
	    isComputedNonLiteralName: () => isComputedNonLiteralName,
	    isComputedPropertyName: () => isComputedPropertyName,
	    isConciseBody: () => isConciseBody,
	    isConditionalExpression: () => isConditionalExpression,
	    isConditionalTypeNode: () => isConditionalTypeNode,
	    isConstTypeReference: () => isConstTypeReference,
	    isConstructSignatureDeclaration: () => isConstructSignatureDeclaration,
	    isConstructorDeclaration: () => isConstructorDeclaration,
	    isConstructorTypeNode: () => isConstructorTypeNode,
	    isContextualKeyword: () => isContextualKeyword,
	    isContinueStatement: () => isContinueStatement,
	    isCustomPrologue: () => isCustomPrologue,
	    isDebuggerStatement: () => isDebuggerStatement,
	    isDeclaration: () => isDeclaration,
	    isDeclarationBindingElement: () => isDeclarationBindingElement,
	    isDeclarationFileName: () => isDeclarationFileName,
	    isDeclarationName: () => isDeclarationName,
	    isDeclarationNameOfEnumOrNamespace: () => isDeclarationNameOfEnumOrNamespace,
	    isDeclarationReadonly: () => isDeclarationReadonly,
	    isDeclarationStatement: () => isDeclarationStatement,
	    isDeclarationWithTypeParameterChildren: () => isDeclarationWithTypeParameterChildren,
	    isDeclarationWithTypeParameters: () => isDeclarationWithTypeParameters,
	    isDecorator: () => isDecorator,
	    isDecoratorTarget: () => isDecoratorTarget,
	    isDefaultClause: () => isDefaultClause,
	    isDefaultImport: () => isDefaultImport,
	    isDefaultModifier: () => isDefaultModifier,
	    isDefaultedExpandoInitializer: () => isDefaultedExpandoInitializer,
	    isDeleteExpression: () => isDeleteExpression,
	    isDeleteTarget: () => isDeleteTarget,
	    isDeprecatedDeclaration: () => isDeprecatedDeclaration,
	    isDestructuringAssignment: () => isDestructuringAssignment,
	    isDiagnosticWithLocation: () => isDiagnosticWithLocation,
	    isDiskPathRoot: () => isDiskPathRoot,
	    isDoStatement: () => isDoStatement,
	    isDocumentRegistryEntry: () => isDocumentRegistryEntry,
	    isDotDotDotToken: () => isDotDotDotToken,
	    isDottedName: () => isDottedName,
	    isDynamicName: () => isDynamicName,
	    isESSymbolIdentifier: () => isESSymbolIdentifier,
	    isEffectiveExternalModule: () => isEffectiveExternalModule,
	    isEffectiveModuleDeclaration: () => isEffectiveModuleDeclaration,
	    isEffectiveStrictModeSourceFile: () => isEffectiveStrictModeSourceFile,
	    isElementAccessChain: () => isElementAccessChain,
	    isElementAccessExpression: () => isElementAccessExpression,
	    isEmittedFileOfProgram: () => isEmittedFileOfProgram,
	    isEmptyArrayLiteral: () => isEmptyArrayLiteral,
	    isEmptyBindingElement: () => isEmptyBindingElement,
	    isEmptyBindingPattern: () => isEmptyBindingPattern,
	    isEmptyObjectLiteral: () => isEmptyObjectLiteral,
	    isEmptyStatement: () => isEmptyStatement,
	    isEmptyStringLiteral: () => isEmptyStringLiteral,
	    isEntityName: () => isEntityName,
	    isEntityNameExpression: () => isEntityNameExpression,
	    isEnumConst: () => isEnumConst,
	    isEnumDeclaration: () => isEnumDeclaration,
	    isEnumMember: () => isEnumMember,
	    isEqualityOperatorKind: () => isEqualityOperatorKind,
	    isEqualsGreaterThanToken: () => isEqualsGreaterThanToken,
	    isExclamationToken: () => isExclamationToken,
	    isExcludedFile: () => isExcludedFile,
	    isExclusivelyTypeOnlyImportOrExport: () => isExclusivelyTypeOnlyImportOrExport,
	    isExpandoPropertyDeclaration: () => isExpandoPropertyDeclaration,
	    isExportAssignment: () => isExportAssignment,
	    isExportDeclaration: () => isExportDeclaration,
	    isExportModifier: () => isExportModifier,
	    isExportName: () => isExportName,
	    isExportNamespaceAsDefaultDeclaration: () => isExportNamespaceAsDefaultDeclaration,
	    isExportOrDefaultModifier: () => isExportOrDefaultModifier,
	    isExportSpecifier: () => isExportSpecifier,
	    isExportsIdentifier: () => isExportsIdentifier,
	    isExportsOrModuleExportsOrAlias: () => isExportsOrModuleExportsOrAlias,
	    isExpression: () => isExpression,
	    isExpressionNode: () => isExpressionNode,
	    isExpressionOfExternalModuleImportEqualsDeclaration: () => isExpressionOfExternalModuleImportEqualsDeclaration,
	    isExpressionOfOptionalChainRoot: () => isExpressionOfOptionalChainRoot,
	    isExpressionStatement: () => isExpressionStatement,
	    isExpressionWithTypeArguments: () => isExpressionWithTypeArguments,
	    isExpressionWithTypeArgumentsInClassExtendsClause: () => isExpressionWithTypeArgumentsInClassExtendsClause,
	    isExternalModule: () => isExternalModule,
	    isExternalModuleAugmentation: () => isExternalModuleAugmentation,
	    isExternalModuleImportEqualsDeclaration: () => isExternalModuleImportEqualsDeclaration,
	    isExternalModuleIndicator: () => isExternalModuleIndicator,
	    isExternalModuleNameRelative: () => isExternalModuleNameRelative,
	    isExternalModuleReference: () => isExternalModuleReference,
	    isExternalModuleSymbol: () => isExternalModuleSymbol,
	    isExternalOrCommonJsModule: () => isExternalOrCommonJsModule,
	    isFileLevelReservedGeneratedIdentifier: () => isFileLevelReservedGeneratedIdentifier,
	    isFileLevelUniqueName: () => isFileLevelUniqueName,
	    isFileProbablyExternalModule: () => isFileProbablyExternalModule,
	    isFirstDeclarationOfSymbolParameter: () => isFirstDeclarationOfSymbolParameter,
	    isFixablePromiseHandler: () => isFixablePromiseHandler,
	    isForInOrOfStatement: () => isForInOrOfStatement,
	    isForInStatement: () => isForInStatement,
	    isForInitializer: () => isForInitializer,
	    isForOfStatement: () => isForOfStatement,
	    isForStatement: () => isForStatement,
	    isFunctionBlock: () => isFunctionBlock,
	    isFunctionBody: () => isFunctionBody,
	    isFunctionDeclaration: () => isFunctionDeclaration,
	    isFunctionExpression: () => isFunctionExpression,
	    isFunctionExpressionOrArrowFunction: () => isFunctionExpressionOrArrowFunction,
	    isFunctionLike: () => isFunctionLike,
	    isFunctionLikeDeclaration: () => isFunctionLikeDeclaration,
	    isFunctionLikeKind: () => isFunctionLikeKind,
	    isFunctionLikeOrClassStaticBlockDeclaration: () => isFunctionLikeOrClassStaticBlockDeclaration,
	    isFunctionOrConstructorTypeNode: () => isFunctionOrConstructorTypeNode,
	    isFunctionOrModuleBlock: () => isFunctionOrModuleBlock,
	    isFunctionSymbol: () => isFunctionSymbol,
	    isFunctionTypeNode: () => isFunctionTypeNode,
	    isFutureReservedKeyword: () => isFutureReservedKeyword,
	    isGeneratedIdentifier: () => isGeneratedIdentifier,
	    isGeneratedPrivateIdentifier: () => isGeneratedPrivateIdentifier,
	    isGetAccessor: () => isGetAccessor,
	    isGetAccessorDeclaration: () => isGetAccessorDeclaration,
	    isGetOrSetAccessorDeclaration: () => isGetOrSetAccessorDeclaration,
	    isGlobalDeclaration: () => isGlobalDeclaration,
	    isGlobalScopeAugmentation: () => isGlobalScopeAugmentation,
	    isGrammarError: () => isGrammarError,
	    isHeritageClause: () => isHeritageClause,
	    isHoistedFunction: () => isHoistedFunction,
	    isHoistedVariableStatement: () => isHoistedVariableStatement,
	    isIdentifier: () => isIdentifier,
	    isIdentifierANonContextualKeyword: () => isIdentifierANonContextualKeyword,
	    isIdentifierName: () => isIdentifierName,
	    isIdentifierOrThisTypeNode: () => isIdentifierOrThisTypeNode,
	    isIdentifierPart: () => isIdentifierPart,
	    isIdentifierStart: () => isIdentifierStart,
	    isIdentifierText: () => isIdentifierText,
	    isIdentifierTypePredicate: () => isIdentifierTypePredicate,
	    isIdentifierTypeReference: () => isIdentifierTypeReference,
	    isIfStatement: () => isIfStatement,
	    isIgnoredFileFromWildCardWatching: () => isIgnoredFileFromWildCardWatching,
	    isImplicitGlob: () => isImplicitGlob,
	    isImportAttribute: () => isImportAttribute,
	    isImportAttributeName: () => isImportAttributeName,
	    isImportAttributes: () => isImportAttributes,
	    isImportCall: () => isImportCall,
	    isImportClause: () => isImportClause,
	    isImportDeclaration: () => isImportDeclaration,
	    isImportEqualsDeclaration: () => isImportEqualsDeclaration,
	    isImportKeyword: () => isImportKeyword,
	    isImportMeta: () => isImportMeta,
	    isImportOrExportSpecifier: () => isImportOrExportSpecifier,
	    isImportOrExportSpecifierName: () => isImportOrExportSpecifierName,
	    isImportSpecifier: () => isImportSpecifier,
	    isImportTypeAssertionContainer: () => isImportTypeAssertionContainer,
	    isImportTypeNode: () => isImportTypeNode,
	    isImportableFile: () => isImportableFile,
	    isInComment: () => isInComment,
	    isInCompoundLikeAssignment: () => isInCompoundLikeAssignment,
	    isInExpressionContext: () => isInExpressionContext,
	    isInJSDoc: () => isInJSDoc,
	    isInJSFile: () => isInJSFile,
	    isInJSXText: () => isInJSXText,
	    isInJsonFile: () => isInJsonFile,
	    isInNonReferenceComment: () => isInNonReferenceComment,
	    isInReferenceComment: () => isInReferenceComment,
	    isInRightSideOfInternalImportEqualsDeclaration: () => isInRightSideOfInternalImportEqualsDeclaration,
	    isInString: () => isInString,
	    isInTemplateString: () => isInTemplateString,
	    isInTopLevelContext: () => isInTopLevelContext,
	    isInTypeQuery: () => isInTypeQuery,
	    isIncrementalCompilation: () => isIncrementalCompilation,
	    isIndexSignatureDeclaration: () => isIndexSignatureDeclaration,
	    isIndexedAccessTypeNode: () => isIndexedAccessTypeNode,
	    isInferTypeNode: () => isInferTypeNode,
	    isInfinityOrNaNString: () => isInfinityOrNaNString,
	    isInitializedProperty: () => isInitializedProperty,
	    isInitializedVariable: () => isInitializedVariable,
	    isInsideJsxElement: () => isInsideJsxElement,
	    isInsideJsxElementOrAttribute: () => isInsideJsxElementOrAttribute,
	    isInsideNodeModules: () => isInsideNodeModules,
	    isInsideTemplateLiteral: () => isInsideTemplateLiteral,
	    isInstanceOfExpression: () => isInstanceOfExpression,
	    isInstantiatedModule: () => isInstantiatedModule,
	    isInterfaceDeclaration: () => isInterfaceDeclaration,
	    isInternalDeclaration: () => isInternalDeclaration,
	    isInternalModuleImportEqualsDeclaration: () => isInternalModuleImportEqualsDeclaration,
	    isInternalName: () => isInternalName,
	    isIntersectionTypeNode: () => isIntersectionTypeNode,
	    isIntrinsicJsxName: () => isIntrinsicJsxName,
	    isIterationStatement: () => isIterationStatement,
	    isJSDoc: () => isJSDoc,
	    isJSDocAllType: () => isJSDocAllType,
	    isJSDocAugmentsTag: () => isJSDocAugmentsTag,
	    isJSDocAuthorTag: () => isJSDocAuthorTag,
	    isJSDocCallbackTag: () => isJSDocCallbackTag,
	    isJSDocClassTag: () => isJSDocClassTag,
	    isJSDocCommentContainingNode: () => isJSDocCommentContainingNode,
	    isJSDocConstructSignature: () => isJSDocConstructSignature,
	    isJSDocDeprecatedTag: () => isJSDocDeprecatedTag,
	    isJSDocEnumTag: () => isJSDocEnumTag,
	    isJSDocFunctionType: () => isJSDocFunctionType,
	    isJSDocImplementsTag: () => isJSDocImplementsTag,
	    isJSDocIndexSignature: () => isJSDocIndexSignature,
	    isJSDocLikeText: () => isJSDocLikeText,
	    isJSDocLink: () => isJSDocLink,
	    isJSDocLinkCode: () => isJSDocLinkCode,
	    isJSDocLinkLike: () => isJSDocLinkLike,
	    isJSDocLinkPlain: () => isJSDocLinkPlain,
	    isJSDocMemberName: () => isJSDocMemberName,
	    isJSDocNameReference: () => isJSDocNameReference,
	    isJSDocNamepathType: () => isJSDocNamepathType,
	    isJSDocNamespaceBody: () => isJSDocNamespaceBody,
	    isJSDocNode: () => isJSDocNode,
	    isJSDocNonNullableType: () => isJSDocNonNullableType,
	    isJSDocNullableType: () => isJSDocNullableType,
	    isJSDocOptionalParameter: () => isJSDocOptionalParameter,
	    isJSDocOptionalType: () => isJSDocOptionalType,
	    isJSDocOverloadTag: () => isJSDocOverloadTag,
	    isJSDocOverrideTag: () => isJSDocOverrideTag,
	    isJSDocParameterTag: () => isJSDocParameterTag,
	    isJSDocPrivateTag: () => isJSDocPrivateTag,
	    isJSDocPropertyLikeTag: () => isJSDocPropertyLikeTag,
	    isJSDocPropertyTag: () => isJSDocPropertyTag,
	    isJSDocProtectedTag: () => isJSDocProtectedTag,
	    isJSDocPublicTag: () => isJSDocPublicTag,
	    isJSDocReadonlyTag: () => isJSDocReadonlyTag,
	    isJSDocReturnTag: () => isJSDocReturnTag,
	    isJSDocSatisfiesExpression: () => isJSDocSatisfiesExpression,
	    isJSDocSatisfiesTag: () => isJSDocSatisfiesTag,
	    isJSDocSeeTag: () => isJSDocSeeTag,
	    isJSDocSignature: () => isJSDocSignature,
	    isJSDocTag: () => isJSDocTag,
	    isJSDocTemplateTag: () => isJSDocTemplateTag,
	    isJSDocThisTag: () => isJSDocThisTag,
	    isJSDocThrowsTag: () => isJSDocThrowsTag,
	    isJSDocTypeAlias: () => isJSDocTypeAlias,
	    isJSDocTypeAssertion: () => isJSDocTypeAssertion,
	    isJSDocTypeExpression: () => isJSDocTypeExpression,
	    isJSDocTypeLiteral: () => isJSDocTypeLiteral,
	    isJSDocTypeTag: () => isJSDocTypeTag,
	    isJSDocTypedefTag: () => isJSDocTypedefTag,
	    isJSDocUnknownTag: () => isJSDocUnknownTag,
	    isJSDocUnknownType: () => isJSDocUnknownType,
	    isJSDocVariadicType: () => isJSDocVariadicType,
	    isJSXTagName: () => isJSXTagName,
	    isJsonEqual: () => isJsonEqual,
	    isJsonSourceFile: () => isJsonSourceFile,
	    isJsxAttribute: () => isJsxAttribute,
	    isJsxAttributeLike: () => isJsxAttributeLike,
	    isJsxAttributeName: () => isJsxAttributeName,
	    isJsxAttributes: () => isJsxAttributes,
	    isJsxChild: () => isJsxChild,
	    isJsxClosingElement: () => isJsxClosingElement,
	    isJsxClosingFragment: () => isJsxClosingFragment,
	    isJsxElement: () => isJsxElement,
	    isJsxExpression: () => isJsxExpression,
	    isJsxFragment: () => isJsxFragment,
	    isJsxNamespacedName: () => isJsxNamespacedName,
	    isJsxOpeningElement: () => isJsxOpeningElement,
	    isJsxOpeningFragment: () => isJsxOpeningFragment,
	    isJsxOpeningLikeElement: () => isJsxOpeningLikeElement,
	    isJsxOpeningLikeElementTagName: () => isJsxOpeningLikeElementTagName,
	    isJsxSelfClosingElement: () => isJsxSelfClosingElement,
	    isJsxSpreadAttribute: () => isJsxSpreadAttribute,
	    isJsxTagNameExpression: () => isJsxTagNameExpression,
	    isJsxText: () => isJsxText,
	    isJumpStatementTarget: () => isJumpStatementTarget,
	    isKeyword: () => isKeyword,
	    isKeywordOrPunctuation: () => isKeywordOrPunctuation,
	    isKnownSymbol: () => isKnownSymbol,
	    isLabelName: () => isLabelName,
	    isLabelOfLabeledStatement: () => isLabelOfLabeledStatement,
	    isLabeledStatement: () => isLabeledStatement,
	    isLateVisibilityPaintedStatement: () => isLateVisibilityPaintedStatement,
	    isLeftHandSideExpression: () => isLeftHandSideExpression,
	    isLeftHandSideOfAssignment: () => isLeftHandSideOfAssignment,
	    isLet: () => isLet,
	    isLineBreak: () => isLineBreak,
	    isLiteralComputedPropertyDeclarationName: () => isLiteralComputedPropertyDeclarationName,
	    isLiteralExpression: () => isLiteralExpression,
	    isLiteralExpressionOfObject: () => isLiteralExpressionOfObject,
	    isLiteralImportTypeNode: () => isLiteralImportTypeNode,
	    isLiteralKind: () => isLiteralKind,
	    isLiteralLikeAccess: () => isLiteralLikeAccess,
	    isLiteralLikeElementAccess: () => isLiteralLikeElementAccess,
	    isLiteralNameOfPropertyDeclarationOrIndexAccess: () => isLiteralNameOfPropertyDeclarationOrIndexAccess,
	    isLiteralTypeLikeExpression: () => isLiteralTypeLikeExpression,
	    isLiteralTypeLiteral: () => isLiteralTypeLiteral,
	    isLiteralTypeNode: () => isLiteralTypeNode,
	    isLocalName: () => isLocalName,
	    isLogicalOperator: () => isLogicalOperator,
	    isLogicalOrCoalescingAssignmentExpression: () => isLogicalOrCoalescingAssignmentExpression,
	    isLogicalOrCoalescingAssignmentOperator: () => isLogicalOrCoalescingAssignmentOperator,
	    isLogicalOrCoalescingBinaryExpression: () => isLogicalOrCoalescingBinaryExpression,
	    isLogicalOrCoalescingBinaryOperator: () => isLogicalOrCoalescingBinaryOperator,
	    isMappedTypeNode: () => isMappedTypeNode,
	    isMemberName: () => isMemberName,
	    isMetaProperty: () => isMetaProperty,
	    isMethodDeclaration: () => isMethodDeclaration,
	    isMethodOrAccessor: () => isMethodOrAccessor,
	    isMethodSignature: () => isMethodSignature,
	    isMinusToken: () => isMinusToken,
	    isMissingDeclaration: () => isMissingDeclaration,
	    isMissingPackageJsonInfo: () => isMissingPackageJsonInfo,
	    isModifier: () => isModifier,
	    isModifierKind: () => isModifierKind,
	    isModifierLike: () => isModifierLike,
	    isModuleAugmentationExternal: () => isModuleAugmentationExternal,
	    isModuleBlock: () => isModuleBlock,
	    isModuleBody: () => isModuleBody,
	    isModuleDeclaration: () => isModuleDeclaration,
	    isModuleExportsAccessExpression: () => isModuleExportsAccessExpression,
	    isModuleIdentifier: () => isModuleIdentifier,
	    isModuleName: () => isModuleName,
	    isModuleOrEnumDeclaration: () => isModuleOrEnumDeclaration,
	    isModuleReference: () => isModuleReference,
	    isModuleSpecifierLike: () => isModuleSpecifierLike,
	    isModuleWithStringLiteralName: () => isModuleWithStringLiteralName,
	    isNameOfFunctionDeclaration: () => isNameOfFunctionDeclaration,
	    isNameOfModuleDeclaration: () => isNameOfModuleDeclaration,
	    isNamedClassElement: () => isNamedClassElement,
	    isNamedDeclaration: () => isNamedDeclaration,
	    isNamedEvaluation: () => isNamedEvaluation,
	    isNamedEvaluationSource: () => isNamedEvaluationSource,
	    isNamedExportBindings: () => isNamedExportBindings,
	    isNamedExports: () => isNamedExports,
	    isNamedImportBindings: () => isNamedImportBindings,
	    isNamedImports: () => isNamedImports,
	    isNamedImportsOrExports: () => isNamedImportsOrExports,
	    isNamedTupleMember: () => isNamedTupleMember,
	    isNamespaceBody: () => isNamespaceBody,
	    isNamespaceExport: () => isNamespaceExport,
	    isNamespaceExportDeclaration: () => isNamespaceExportDeclaration,
	    isNamespaceImport: () => isNamespaceImport,
	    isNamespaceReexportDeclaration: () => isNamespaceReexportDeclaration,
	    isNewExpression: () => isNewExpression,
	    isNewExpressionTarget: () => isNewExpressionTarget,
	    isNoSubstitutionTemplateLiteral: () => isNoSubstitutionTemplateLiteral,
	    isNode: () => isNode,
	    isNodeArray: () => isNodeArray,
	    isNodeArrayMultiLine: () => isNodeArrayMultiLine,
	    isNodeDescendantOf: () => isNodeDescendantOf,
	    isNodeKind: () => isNodeKind,
	    isNodeLikeSystem: () => isNodeLikeSystem,
	    isNodeModulesDirectory: () => isNodeModulesDirectory,
	    isNodeWithPossibleHoistedDeclaration: () => isNodeWithPossibleHoistedDeclaration,
	    isNonContextualKeyword: () => isNonContextualKeyword,
	    isNonExportDefaultModifier: () => isNonExportDefaultModifier,
	    isNonGlobalAmbientModule: () => isNonGlobalAmbientModule,
	    isNonGlobalDeclaration: () => isNonGlobalDeclaration,
	    isNonNullAccess: () => isNonNullAccess,
	    isNonNullChain: () => isNonNullChain,
	    isNonNullExpression: () => isNonNullExpression,
	    isNonStaticMethodOrAccessorWithPrivateName: () => isNonStaticMethodOrAccessorWithPrivateName,
	    isNotEmittedOrPartiallyEmittedNode: () => isNotEmittedOrPartiallyEmittedNode,
	    isNotEmittedStatement: () => isNotEmittedStatement,
	    isNullishCoalesce: () => isNullishCoalesce,
	    isNumber: () => isNumber,
	    isNumericLiteral: () => isNumericLiteral,
	    isNumericLiteralName: () => isNumericLiteralName,
	    isObjectBindingElementWithoutPropertyName: () => isObjectBindingElementWithoutPropertyName,
	    isObjectBindingOrAssignmentElement: () => isObjectBindingOrAssignmentElement,
	    isObjectBindingOrAssignmentPattern: () => isObjectBindingOrAssignmentPattern,
	    isObjectBindingPattern: () => isObjectBindingPattern,
	    isObjectLiteralElement: () => isObjectLiteralElement,
	    isObjectLiteralElementLike: () => isObjectLiteralElementLike,
	    isObjectLiteralExpression: () => isObjectLiteralExpression,
	    isObjectLiteralMethod: () => isObjectLiteralMethod,
	    isObjectLiteralOrClassExpressionMethodOrAccessor: () => isObjectLiteralOrClassExpressionMethodOrAccessor,
	    isObjectTypeDeclaration: () => isObjectTypeDeclaration,
	    isOctalDigit: () => isOctalDigit,
	    isOmittedExpression: () => isOmittedExpression,
	    isOptionalChain: () => isOptionalChain,
	    isOptionalChainRoot: () => isOptionalChainRoot,
	    isOptionalDeclaration: () => isOptionalDeclaration,
	    isOptionalJSDocPropertyLikeTag: () => isOptionalJSDocPropertyLikeTag,
	    isOptionalTypeNode: () => isOptionalTypeNode,
	    isOuterExpression: () => isOuterExpression,
	    isOutermostOptionalChain: () => isOutermostOptionalChain,
	    isOverrideModifier: () => isOverrideModifier,
	    isPackageJsonInfo: () => isPackageJsonInfo,
	    isPackedArrayLiteral: () => isPackedArrayLiteral,
	    isParameter: () => isParameter,
	    isParameterDeclaration: () => isParameterDeclaration,
	    isParameterPropertyDeclaration: () => isParameterPropertyDeclaration,
	    isParameterPropertyModifier: () => isParameterPropertyModifier,
	    isParenthesizedExpression: () => isParenthesizedExpression,
	    isParenthesizedTypeNode: () => isParenthesizedTypeNode,
	    isParseTreeNode: () => isParseTreeNode,
	    isPartOfTypeNode: () => isPartOfTypeNode,
	    isPartOfTypeQuery: () => isPartOfTypeQuery,
	    isPartiallyEmittedExpression: () => isPartiallyEmittedExpression,
	    isPatternMatch: () => isPatternMatch,
	    isPinnedComment: () => isPinnedComment,
	    isPlainJsFile: () => isPlainJsFile,
	    isPlusToken: () => isPlusToken,
	    isPossiblyTypeArgumentPosition: () => isPossiblyTypeArgumentPosition,
	    isPostfixUnaryExpression: () => isPostfixUnaryExpression,
	    isPrefixUnaryExpression: () => isPrefixUnaryExpression,
	    isPrivateIdentifier: () => isPrivateIdentifier,
	    isPrivateIdentifierClassElementDeclaration: () => isPrivateIdentifierClassElementDeclaration,
	    isPrivateIdentifierPropertyAccessExpression: () => isPrivateIdentifierPropertyAccessExpression,
	    isPrivateIdentifierSymbol: () => isPrivateIdentifierSymbol,
	    isProgramBundleEmitBuildInfo: () => isProgramBundleEmitBuildInfo,
	    isProgramUptoDate: () => isProgramUptoDate,
	    isPrologueDirective: () => isPrologueDirective,
	    isPropertyAccessChain: () => isPropertyAccessChain,
	    isPropertyAccessEntityNameExpression: () => isPropertyAccessEntityNameExpression,
	    isPropertyAccessExpression: () => isPropertyAccessExpression,
	    isPropertyAccessOrQualifiedName: () => isPropertyAccessOrQualifiedName,
	    isPropertyAccessOrQualifiedNameOrImportTypeNode: () => isPropertyAccessOrQualifiedNameOrImportTypeNode,
	    isPropertyAssignment: () => isPropertyAssignment,
	    isPropertyDeclaration: () => isPropertyDeclaration,
	    isPropertyName: () => isPropertyName,
	    isPropertyNameLiteral: () => isPropertyNameLiteral,
	    isPropertySignature: () => isPropertySignature,
	    isProtoSetter: () => isProtoSetter,
	    isPrototypeAccess: () => isPrototypeAccess,
	    isPrototypePropertyAssignment: () => isPrototypePropertyAssignment,
	    isPunctuation: () => isPunctuation,
	    isPushOrUnshiftIdentifier: () => isPushOrUnshiftIdentifier,
	    isQualifiedName: () => isQualifiedName,
	    isQuestionDotToken: () => isQuestionDotToken,
	    isQuestionOrExclamationToken: () => isQuestionOrExclamationToken,
	    isQuestionOrPlusOrMinusToken: () => isQuestionOrPlusOrMinusToken,
	    isQuestionToken: () => isQuestionToken,
	    isRawSourceMap: () => isRawSourceMap,
	    isReadonlyKeyword: () => isReadonlyKeyword,
	    isReadonlyKeywordOrPlusOrMinusToken: () => isReadonlyKeywordOrPlusOrMinusToken,
	    isRecognizedTripleSlashComment: () => isRecognizedTripleSlashComment,
	    isReferenceFileLocation: () => isReferenceFileLocation,
	    isReferencedFile: () => isReferencedFile,
	    isRegularExpressionLiteral: () => isRegularExpressionLiteral,
	    isRequireCall: () => isRequireCall,
	    isRequireVariableStatement: () => isRequireVariableStatement,
	    isRestParameter: () => isRestParameter,
	    isRestTypeNode: () => isRestTypeNode,
	    isReturnStatement: () => isReturnStatement,
	    isReturnStatementWithFixablePromiseHandler: () => isReturnStatementWithFixablePromiseHandler,
	    isRightSideOfAccessExpression: () => isRightSideOfAccessExpression,
	    isRightSideOfInstanceofExpression: () => isRightSideOfInstanceofExpression,
	    isRightSideOfPropertyAccess: () => isRightSideOfPropertyAccess,
	    isRightSideOfQualifiedName: () => isRightSideOfQualifiedName,
	    isRightSideOfQualifiedNameOrPropertyAccess: () => isRightSideOfQualifiedNameOrPropertyAccess,
	    isRightSideOfQualifiedNameOrPropertyAccessOrJSDocMemberName: () => isRightSideOfQualifiedNameOrPropertyAccessOrJSDocMemberName,
	    isRootedDiskPath: () => isRootedDiskPath,
	    isSameEntityName: () => isSameEntityName,
	    isSatisfiesExpression: () => isSatisfiesExpression,
	    isScopeMarker: () => isScopeMarker,
	    isSemicolonClassElement: () => isSemicolonClassElement,
	    isSetAccessor: () => isSetAccessor,
	    isSetAccessorDeclaration: () => isSetAccessorDeclaration,
	    isShebangTrivia: () => isShebangTrivia,
	    isShiftOperatorOrHigher: () => isShiftOperatorOrHigher,
	    isShorthandAmbientModuleSymbol: () => isShorthandAmbientModuleSymbol,
	    isShorthandPropertyAssignment: () => isShorthandPropertyAssignment,
	    isSignedNumericLiteral: () => isSignedNumericLiteral,
	    isSimpleCopiableExpression: () => isSimpleCopiableExpression,
	    isSimpleInlineableExpression: () => isSimpleInlineableExpression,
	    isSimpleParameter: () => isSimpleParameter,
	    isSimpleParameterList: () => isSimpleParameterList,
	    isSingleOrDoubleQuote: () => isSingleOrDoubleQuote,
	    isSourceFile: () => isSourceFile,
	    isSourceFileFromLibrary: () => isSourceFileFromLibrary,
	    isSourceFileJS: () => isSourceFileJS,
	    isSourceFileNotJS: () => isSourceFileNotJS,
	    isSourceFileNotJson: () => isSourceFileNotJson,
	    isSourceMapping: () => isSourceMapping,
	    isSpecialPropertyDeclaration: () => isSpecialPropertyDeclaration,
	    isSpreadAssignment: () => isSpreadAssignment,
	    isSpreadElement: () => isSpreadElement,
	    isStatement: () => isStatement,
	    isStatementButNotDeclaration: () => isStatementButNotDeclaration,
	    isStatementOrBlock: () => isStatementOrBlock,
	    isStatementWithLocals: () => isStatementWithLocals,
	    isStatic: () => isStatic,
	    isStaticModifier: () => isStaticModifier,
	    isString: () => isString,
	    isStringAKeyword: () => isStringAKeyword,
	    isStringANonContextualKeyword: () => isStringANonContextualKeyword,
	    isStringAndEmptyAnonymousObjectIntersection: () => isStringAndEmptyAnonymousObjectIntersection,
	    isStringDoubleQuoted: () => isStringDoubleQuoted,
	    isStringLiteral: () => isStringLiteral,
	    isStringLiteralLike: () => isStringLiteralLike,
	    isStringLiteralOrJsxExpression: () => isStringLiteralOrJsxExpression,
	    isStringLiteralOrTemplate: () => isStringLiteralOrTemplate,
	    isStringOrNumericLiteralLike: () => isStringOrNumericLiteralLike,
	    isStringOrRegularExpressionOrTemplateLiteral: () => isStringOrRegularExpressionOrTemplateLiteral,
	    isStringTextContainingNode: () => isStringTextContainingNode,
	    isSuperCall: () => isSuperCall,
	    isSuperKeyword: () => isSuperKeyword,
	    isSuperOrSuperProperty: () => isSuperOrSuperProperty,
	    isSuperProperty: () => isSuperProperty,
	    isSupportedSourceFileName: () => isSupportedSourceFileName,
	    isSwitchStatement: () => isSwitchStatement,
	    isSyntaxList: () => isSyntaxList,
	    isSyntheticExpression: () => isSyntheticExpression,
	    isSyntheticReference: () => isSyntheticReference,
	    isTagName: () => isTagName,
	    isTaggedTemplateExpression: () => isTaggedTemplateExpression,
	    isTaggedTemplateTag: () => isTaggedTemplateTag,
	    isTemplateExpression: () => isTemplateExpression,
	    isTemplateHead: () => isTemplateHead,
	    isTemplateLiteral: () => isTemplateLiteral,
	    isTemplateLiteralKind: () => isTemplateLiteralKind,
	    isTemplateLiteralToken: () => isTemplateLiteralToken,
	    isTemplateLiteralTypeNode: () => isTemplateLiteralTypeNode,
	    isTemplateLiteralTypeSpan: () => isTemplateLiteralTypeSpan,
	    isTemplateMiddle: () => isTemplateMiddle,
	    isTemplateMiddleOrTemplateTail: () => isTemplateMiddleOrTemplateTail,
	    isTemplateSpan: () => isTemplateSpan,
	    isTemplateTail: () => isTemplateTail,
	    isTextWhiteSpaceLike: () => isTextWhiteSpaceLike,
	    isThis: () => isThis,
	    isThisContainerOrFunctionBlock: () => isThisContainerOrFunctionBlock,
	    isThisIdentifier: () => isThisIdentifier,
	    isThisInTypeQuery: () => isThisInTypeQuery,
	    isThisInitializedDeclaration: () => isThisInitializedDeclaration,
	    isThisInitializedObjectBindingExpression: () => isThisInitializedObjectBindingExpression,
	    isThisProperty: () => isThisProperty,
	    isThisTypeNode: () => isThisTypeNode,
	    isThisTypeParameter: () => isThisTypeParameter,
	    isThisTypePredicate: () => isThisTypePredicate,
	    isThrowStatement: () => isThrowStatement,
	    isToken: () => isToken,
	    isTokenKind: () => isTokenKind,
	    isTraceEnabled: () => isTraceEnabled,
	    isTransientSymbol: () => isTransientSymbol,
	    isTrivia: () => isTrivia,
	    isTryStatement: () => isTryStatement,
	    isTupleTypeNode: () => isTupleTypeNode,
	    isTypeAlias: () => isTypeAlias,
	    isTypeAliasDeclaration: () => isTypeAliasDeclaration,
	    isTypeAssertionExpression: () => isTypeAssertionExpression,
	    isTypeDeclaration: () => isTypeDeclaration,
	    isTypeElement: () => isTypeElement,
	    isTypeKeyword: () => isTypeKeyword,
	    isTypeKeywordToken: () => isTypeKeywordToken,
	    isTypeKeywordTokenOrIdentifier: () => isTypeKeywordTokenOrIdentifier,
	    isTypeLiteralNode: () => isTypeLiteralNode,
	    isTypeNode: () => isTypeNode,
	    isTypeNodeKind: () => isTypeNodeKind,
	    isTypeOfExpression: () => isTypeOfExpression,
	    isTypeOnlyExportDeclaration: () => isTypeOnlyExportDeclaration,
	    isTypeOnlyImportDeclaration: () => isTypeOnlyImportDeclaration,
	    isTypeOnlyImportOrExportDeclaration: () => isTypeOnlyImportOrExportDeclaration,
	    isTypeOperatorNode: () => isTypeOperatorNode,
	    isTypeParameterDeclaration: () => isTypeParameterDeclaration,
	    isTypePredicateNode: () => isTypePredicateNode,
	    isTypeQueryNode: () => isTypeQueryNode,
	    isTypeReferenceNode: () => isTypeReferenceNode,
	    isTypeReferenceType: () => isTypeReferenceType,
	    isTypeUsableAsPropertyName: () => isTypeUsableAsPropertyName,
	    isUMDExportSymbol: () => isUMDExportSymbol,
	    isUnaryExpression: () => isUnaryExpression,
	    isUnaryExpressionWithWrite: () => isUnaryExpressionWithWrite,
	    isUnicodeIdentifierStart: () => isUnicodeIdentifierStart,
	    isUnionTypeNode: () => isUnionTypeNode,
	    isUnparsedNode: () => isUnparsedNode,
	    isUnparsedPrepend: () => isUnparsedPrepend,
	    isUnparsedSource: () => isUnparsedSource,
	    isUnparsedTextLike: () => isUnparsedTextLike,
	    isUrl: () => isUrl,
	    isValidBigIntString: () => isValidBigIntString,
	    isValidESSymbolDeclaration: () => isValidESSymbolDeclaration,
	    isValidTypeOnlyAliasUseSite: () => isValidTypeOnlyAliasUseSite,
	    isValueSignatureDeclaration: () => isValueSignatureDeclaration,
	    isVarAwaitUsing: () => isVarAwaitUsing,
	    isVarConst: () => isVarConst,
	    isVarUsing: () => isVarUsing,
	    isVariableDeclaration: () => isVariableDeclaration,
	    isVariableDeclarationInVariableStatement: () => isVariableDeclarationInVariableStatement,
	    isVariableDeclarationInitializedToBareOrAccessedRequire: () => isVariableDeclarationInitializedToBareOrAccessedRequire,
	    isVariableDeclarationInitializedToRequire: () => isVariableDeclarationInitializedToRequire,
	    isVariableDeclarationList: () => isVariableDeclarationList,
	    isVariableLike: () => isVariableLike,
	    isVariableLikeOrAccessor: () => isVariableLikeOrAccessor,
	    isVariableStatement: () => isVariableStatement,
	    isVoidExpression: () => isVoidExpression,
	    isWatchSet: () => isWatchSet,
	    isWhileStatement: () => isWhileStatement,
	    isWhiteSpaceLike: () => isWhiteSpaceLike,
	    isWhiteSpaceSingleLine: () => isWhiteSpaceSingleLine,
	    isWithStatement: () => isWithStatement,
	    isWriteAccess: () => isWriteAccess,
	    isWriteOnlyAccess: () => isWriteOnlyAccess,
	    isYieldExpression: () => isYieldExpression,
	    jsxModeNeedsExplicitImport: () => jsxModeNeedsExplicitImport,
	    keywordPart: () => keywordPart,
	    last: () => last,
	    lastOrUndefined: () => lastOrUndefined,
	    length: () => length,
	    libMap: () => libMap,
	    libs: () => libs,
	    lineBreakPart: () => lineBreakPart,
	    linkNamePart: () => linkNamePart,
	    linkPart: () => linkPart,
	    linkTextPart: () => linkTextPart,
	    listFiles: () => listFiles,
	    loadModuleFromGlobalCache: () => loadModuleFromGlobalCache,
	    loadWithModeAwareCache: () => loadWithModeAwareCache,
	    makeIdentifierFromModuleName: () => makeIdentifierFromModuleName,
	    makeImport: () => makeImport,
	    makeImportIfNecessary: () => makeImportIfNecessary,
	    makeStringLiteral: () => makeStringLiteral,
	    mangleScopedPackageName: () => mangleScopedPackageName,
	    map: () => map,
	    mapAllOrFail: () => mapAllOrFail,
	    mapDefined: () => mapDefined,
	    mapDefinedEntries: () => mapDefinedEntries,
	    mapDefinedIterator: () => mapDefinedIterator,
	    mapEntries: () => mapEntries,
	    mapIterator: () => mapIterator,
	    mapOneOrMany: () => mapOneOrMany,
	    mapToDisplayParts: () => mapToDisplayParts,
	    matchFiles: () => matchFiles,
	    matchPatternOrExact: () => matchPatternOrExact,
	    matchedText: () => matchedText,
	    matchesExclude: () => matchesExclude,
	    maybeBind: () => maybeBind,
	    maybeSetLocalizedDiagnosticMessages: () => maybeSetLocalizedDiagnosticMessages,
	    memoize: () => memoize,
	    memoizeCached: () => memoizeCached,
	    memoizeOne: () => memoizeOne,
	    memoizeWeak: () => memoizeWeak,
	    metadataHelper: () => metadataHelper,
	    min: () => min,
	    minAndMax: () => minAndMax,
	    missingFileModifiedTime: () => missingFileModifiedTime,
	    modifierToFlag: () => modifierToFlag,
	    modifiersToFlags: () => modifiersToFlags,
	    moduleOptionDeclaration: () => moduleOptionDeclaration,
	    moduleResolutionIsEqualTo: () => moduleResolutionIsEqualTo,
	    moduleResolutionNameAndModeGetter: () => moduleResolutionNameAndModeGetter,
	    moduleResolutionOptionDeclarations: () => moduleResolutionOptionDeclarations,
	    moduleResolutionSupportsPackageJsonExportsAndImports: () => moduleResolutionSupportsPackageJsonExportsAndImports,
	    moduleResolutionUsesNodeModules: () => moduleResolutionUsesNodeModules,
	    moduleSpecifiers: () => ts_moduleSpecifiers_exports,
	    moveEmitHelpers: () => moveEmitHelpers,
	    moveRangeEnd: () => moveRangeEnd,
	    moveRangePastDecorators: () => moveRangePastDecorators,
	    moveRangePastModifiers: () => moveRangePastModifiers,
	    moveRangePos: () => moveRangePos,
	    moveSyntheticComments: () => moveSyntheticComments,
	    mutateMap: () => mutateMap,
	    mutateMapSkippingNewValues: () => mutateMapSkippingNewValues,
	    needsParentheses: () => needsParentheses,
	    needsScopeMarker: () => needsScopeMarker,
	    newCaseClauseTracker: () => newCaseClauseTracker,
	    newPrivateEnvironment: () => newPrivateEnvironment,
	    noEmitNotification: () => noEmitNotification,
	    noEmitSubstitution: () => noEmitSubstitution,
	    noTransformers: () => noTransformers,
	    noTruncationMaximumTruncationLength: () => noTruncationMaximumTruncationLength,
	    nodeCanBeDecorated: () => nodeCanBeDecorated,
	    nodeHasName: () => nodeHasName,
	    nodeIsDecorated: () => nodeIsDecorated,
	    nodeIsMissing: () => nodeIsMissing,
	    nodeIsPresent: () => nodeIsPresent,
	    nodeIsSynthesized: () => nodeIsSynthesized,
	    nodeModuleNameResolver: () => nodeModuleNameResolver,
	    nodeModulesPathPart: () => nodeModulesPathPart,
	    nodeNextJsonConfigResolver: () => nodeNextJsonConfigResolver,
	    nodeOrChildIsDecorated: () => nodeOrChildIsDecorated,
	    nodeOverlapsWithStartEnd: () => nodeOverlapsWithStartEnd,
	    nodePosToString: () => nodePosToString,
	    nodeSeenTracker: () => nodeSeenTracker,
	    nodeStartsNewLexicalEnvironment: () => nodeStartsNewLexicalEnvironment,
	    nodeToDisplayParts: () => nodeToDisplayParts,
	    noop: () => noop,
	    noopFileWatcher: () => noopFileWatcher,
	    normalizePath: () => normalizePath,
	    normalizeSlashes: () => normalizeSlashes,
	    not: () => not,
	    notImplemented: () => notImplemented,
	    notImplementedResolver: () => notImplementedResolver,
	    nullNodeConverters: () => nullNodeConverters,
	    nullParenthesizerRules: () => nullParenthesizerRules,
	    nullTransformationContext: () => nullTransformationContext,
	    objectAllocator: () => objectAllocator,
	    operatorPart: () => operatorPart,
	    optionDeclarations: () => optionDeclarations,
	    optionMapToObject: () => optionMapToObject,
	    optionsAffectingProgramStructure: () => optionsAffectingProgramStructure,
	    optionsForBuild: () => optionsForBuild,
	    optionsForWatch: () => optionsForWatch,
	    optionsHaveChanges: () => optionsHaveChanges,
	    optionsHaveModuleResolutionChanges: () => optionsHaveModuleResolutionChanges,
	    or: () => or,
	    orderedRemoveItem: () => orderedRemoveItem,
	    orderedRemoveItemAt: () => orderedRemoveItemAt,
	    outFile: () => outFile,
	    packageIdToPackageName: () => packageIdToPackageName,
	    packageIdToString: () => packageIdToString,
	    paramHelper: () => paramHelper,
	    parameterIsThisKeyword: () => parameterIsThisKeyword,
	    parameterNamePart: () => parameterNamePart,
	    parseBaseNodeFactory: () => parseBaseNodeFactory,
	    parseBigInt: () => parseBigInt,
	    parseBuildCommand: () => parseBuildCommand,
	    parseCommandLine: () => parseCommandLine,
	    parseCommandLineWorker: () => parseCommandLineWorker,
	    parseConfigFileTextToJson: () => parseConfigFileTextToJson,
	    parseConfigFileWithSystem: () => parseConfigFileWithSystem,
	    parseConfigHostFromCompilerHostLike: () => parseConfigHostFromCompilerHostLike,
	    parseCustomTypeOption: () => parseCustomTypeOption,
	    parseIsolatedEntityName: () => parseIsolatedEntityName,
	    parseIsolatedJSDocComment: () => parseIsolatedJSDocComment,
	    parseJSDocTypeExpressionForTests: () => parseJSDocTypeExpressionForTests,
	    parseJsonConfigFileContent: () => parseJsonConfigFileContent,
	    parseJsonSourceFileConfigFileContent: () => parseJsonSourceFileConfigFileContent,
	    parseJsonText: () => parseJsonText,
	    parseListTypeOption: () => parseListTypeOption,
	    parseNodeFactory: () => parseNodeFactory,
	    parseNodeModuleFromPath: () => parseNodeModuleFromPath,
	    parsePackageName: () => parsePackageName,
	    parsePseudoBigInt: () => parsePseudoBigInt,
	    parseValidBigInt: () => parseValidBigInt,
	    patchWriteFileEnsuringDirectory: () => patchWriteFileEnsuringDirectory,
	    pathContainsNodeModules: () => pathContainsNodeModules,
	    pathIsAbsolute: () => pathIsAbsolute,
	    pathIsBareSpecifier: () => pathIsBareSpecifier,
	    pathIsRelative: () => pathIsRelative,
	    patternText: () => patternText,
	    perfLogger: () => perfLogger,
	    performIncrementalCompilation: () => performIncrementalCompilation,
	    performance: () => ts_performance_exports,
	    plainJSErrors: () => plainJSErrors,
	    positionBelongsToNode: () => positionBelongsToNode,
	    positionIsASICandidate: () => positionIsASICandidate,
	    positionIsSynthesized: () => positionIsSynthesized,
	    positionsAreOnSameLine: () => positionsAreOnSameLine,
	    preProcessFile: () => preProcessFile,
	    probablyUsesSemicolons: () => probablyUsesSemicolons,
	    processCommentPragmas: () => processCommentPragmas,
	    processPragmasIntoFields: () => processPragmasIntoFields,
	    processTaggedTemplateExpression: () => processTaggedTemplateExpression,
	    programContainsEsModules: () => programContainsEsModules,
	    programContainsModules: () => programContainsModules,
	    projectReferenceIsEqualTo: () => projectReferenceIsEqualTo,
	    propKeyHelper: () => propKeyHelper,
	    propertyNamePart: () => propertyNamePart,
	    pseudoBigIntToString: () => pseudoBigIntToString,
	    punctuationPart: () => punctuationPart,
	    pushIfUnique: () => pushIfUnique,
	    quote: () => quote,
	    quotePreferenceFromString: () => quotePreferenceFromString,
	    rangeContainsPosition: () => rangeContainsPosition,
	    rangeContainsPositionExclusive: () => rangeContainsPositionExclusive,
	    rangeContainsRange: () => rangeContainsRange,
	    rangeContainsRangeExclusive: () => rangeContainsRangeExclusive,
	    rangeContainsStartEnd: () => rangeContainsStartEnd,
	    rangeEndIsOnSameLineAsRangeStart: () => rangeEndIsOnSameLineAsRangeStart,
	    rangeEndPositionsAreOnSameLine: () => rangeEndPositionsAreOnSameLine,
	    rangeEquals: () => rangeEquals,
	    rangeIsOnSingleLine: () => rangeIsOnSingleLine,
	    rangeOfNode: () => rangeOfNode,
	    rangeOfTypeParameters: () => rangeOfTypeParameters,
	    rangeOverlapsWithStartEnd: () => rangeOverlapsWithStartEnd,
	    rangeStartIsOnSameLineAsRangeEnd: () => rangeStartIsOnSameLineAsRangeEnd,
	    rangeStartPositionsAreOnSameLine: () => rangeStartPositionsAreOnSameLine,
	    readBuilderProgram: () => readBuilderProgram,
	    readConfigFile: () => readConfigFile,
	    readHelper: () => readHelper,
	    readJson: () => readJson,
	    readJsonConfigFile: () => readJsonConfigFile,
	    readJsonOrUndefined: () => readJsonOrUndefined,
	    reduceEachLeadingCommentRange: () => reduceEachLeadingCommentRange,
	    reduceEachTrailingCommentRange: () => reduceEachTrailingCommentRange,
	    reduceLeft: () => reduceLeft,
	    reduceLeftIterator: () => reduceLeftIterator,
	    reducePathComponents: () => reducePathComponents,
	    refactor: () => ts_refactor_exports,
	    regExpEscape: () => regExpEscape,
	    relativeComplement: () => relativeComplement,
	    removeAllComments: () => removeAllComments,
	    removeEmitHelper: () => removeEmitHelper,
	    removeExtension: () => removeExtension,
	    removeFileExtension: () => removeFileExtension,
	    removeIgnoredPath: () => removeIgnoredPath,
	    removeMinAndVersionNumbers: () => removeMinAndVersionNumbers,
	    removeOptionality: () => removeOptionality,
	    removePrefix: () => removePrefix,
	    removeSuffix: () => removeSuffix,
	    removeTrailingDirectorySeparator: () => removeTrailingDirectorySeparator,
	    repeatString: () => repeatString,
	    replaceElement: () => replaceElement,
	    replaceFirstStar: () => replaceFirstStar,
	    resolutionExtensionIsTSOrJson: () => resolutionExtensionIsTSOrJson,
	    resolveConfigFileProjectName: () => resolveConfigFileProjectName,
	    resolveJSModule: () => resolveJSModule,
	    resolveLibrary: () => resolveLibrary,
	    resolveModuleName: () => resolveModuleName,
	    resolveModuleNameFromCache: () => resolveModuleNameFromCache,
	    resolvePackageNameToPackageJson: () => resolvePackageNameToPackageJson,
	    resolvePath: () => resolvePath,
	    resolveProjectReferencePath: () => resolveProjectReferencePath,
	    resolveTripleslashReference: () => resolveTripleslashReference,
	    resolveTypeReferenceDirective: () => resolveTypeReferenceDirective,
	    resolvingEmptyArray: () => resolvingEmptyArray,
	    restHelper: () => restHelper,
	    returnFalse: () => returnFalse,
	    returnNoopFileWatcher: () => returnNoopFileWatcher,
	    returnTrue: () => returnTrue,
	    returnUndefined: () => returnUndefined,
	    returnsPromise: () => returnsPromise,
	    runInitializersHelper: () => runInitializersHelper,
	    sameFlatMap: () => sameFlatMap,
	    sameMap: () => sameMap,
	    sameMapping: () => sameMapping,
	    scanShebangTrivia: () => scanShebangTrivia,
	    scanTokenAtPosition: () => scanTokenAtPosition,
	    scanner: () => scanner,
	    screenStartingMessageCodes: () => screenStartingMessageCodes,
	    semanticDiagnosticsOptionDeclarations: () => semanticDiagnosticsOptionDeclarations,
	    serializeCompilerOptions: () => serializeCompilerOptions,
	    server: () => ts_server_exports4,
	    servicesVersion: () => servicesVersion,
	    setCommentRange: () => setCommentRange,
	    setConfigFileInOptions: () => setConfigFileInOptions,
	    setConstantValue: () => setConstantValue,
	    setEachParent: () => setEachParent,
	    setEmitFlags: () => setEmitFlags,
	    setFunctionNameHelper: () => setFunctionNameHelper,
	    setGetSourceFileAsHashVersioned: () => setGetSourceFileAsHashVersioned,
	    setIdentifierAutoGenerate: () => setIdentifierAutoGenerate,
	    setIdentifierGeneratedImportReference: () => setIdentifierGeneratedImportReference,
	    setIdentifierTypeArguments: () => setIdentifierTypeArguments,
	    setInternalEmitFlags: () => setInternalEmitFlags,
	    setLocalizedDiagnosticMessages: () => setLocalizedDiagnosticMessages,
	    setModuleDefaultHelper: () => setModuleDefaultHelper,
	    setNodeFlags: () => setNodeFlags,
	    setObjectAllocator: () => setObjectAllocator,
	    setOriginalNode: () => setOriginalNode,
	    setParent: () => setParent,
	    setParentRecursive: () => setParentRecursive,
	    setPrivateIdentifier: () => setPrivateIdentifier,
	    setSnippetElement: () => setSnippetElement,
	    setSourceMapRange: () => setSourceMapRange,
	    setStackTraceLimit: () => setStackTraceLimit,
	    setStartsOnNewLine: () => setStartsOnNewLine,
	    setSyntheticLeadingComments: () => setSyntheticLeadingComments,
	    setSyntheticTrailingComments: () => setSyntheticTrailingComments,
	    setSys: () => setSys,
	    setSysLog: () => setSysLog,
	    setTextRange: () => setTextRange,
	    setTextRangeEnd: () => setTextRangeEnd,
	    setTextRangePos: () => setTextRangePos,
	    setTextRangePosEnd: () => setTextRangePosEnd,
	    setTextRangePosWidth: () => setTextRangePosWidth,
	    setTokenSourceMapRange: () => setTokenSourceMapRange,
	    setTypeNode: () => setTypeNode,
	    setUILocale: () => setUILocale,
	    setValueDeclaration: () => setValueDeclaration,
	    shouldAllowImportingTsExtension: () => shouldAllowImportingTsExtension,
	    shouldPreserveConstEnums: () => shouldPreserveConstEnums,
	    shouldUseUriStyleNodeCoreModules: () => shouldUseUriStyleNodeCoreModules,
	    showModuleSpecifier: () => showModuleSpecifier,
	    signatureHasLiteralTypes: () => signatureHasLiteralTypes,
	    signatureHasRestParameter: () => signatureHasRestParameter,
	    signatureToDisplayParts: () => signatureToDisplayParts,
	    single: () => single,
	    singleElementArray: () => singleElementArray,
	    singleIterator: () => singleIterator,
	    singleOrMany: () => singleOrMany,
	    singleOrUndefined: () => singleOrUndefined,
	    skipAlias: () => skipAlias,
	    skipAssertions: () => skipAssertions,
	    skipConstraint: () => skipConstraint,
	    skipOuterExpressions: () => skipOuterExpressions,
	    skipParentheses: () => skipParentheses,
	    skipPartiallyEmittedExpressions: () => skipPartiallyEmittedExpressions,
	    skipTrivia: () => skipTrivia,
	    skipTypeChecking: () => skipTypeChecking,
	    skipTypeParentheses: () => skipTypeParentheses,
	    skipWhile: () => skipWhile,
	    sliceAfter: () => sliceAfter,
	    some: () => some,
	    sort: () => sort,
	    sortAndDeduplicate: () => sortAndDeduplicate,
	    sortAndDeduplicateDiagnostics: () => sortAndDeduplicateDiagnostics,
	    sourceFileAffectingCompilerOptions: () => sourceFileAffectingCompilerOptions,
	    sourceFileMayBeEmitted: () => sourceFileMayBeEmitted,
	    sourceMapCommentRegExp: () => sourceMapCommentRegExp,
	    sourceMapCommentRegExpDontCareLineStart: () => sourceMapCommentRegExpDontCareLineStart,
	    spacePart: () => spacePart,
	    spanMap: () => spanMap,
	    spreadArrayHelper: () => spreadArrayHelper,
	    stableSort: () => stableSort,
	    startEndContainsRange: () => startEndContainsRange,
	    startEndOverlapsWithStartEnd: () => startEndOverlapsWithStartEnd,
	    startOnNewLine: () => startOnNewLine,
	    startTracing: () => startTracing,
	    startsWith: () => startsWith,
	    startsWithDirectory: () => startsWithDirectory,
	    startsWithUnderscore: () => startsWithUnderscore,
	    startsWithUseStrict: () => startsWithUseStrict,
	    stringContainsAt: () => stringContainsAt,
	    stringToToken: () => stringToToken,
	    stripQuotes: () => stripQuotes,
	    supportedDeclarationExtensions: () => supportedDeclarationExtensions,
	    supportedJSExtensions: () => supportedJSExtensions,
	    supportedJSExtensionsFlat: () => supportedJSExtensionsFlat,
	    supportedLocaleDirectories: () => supportedLocaleDirectories,
	    supportedTSExtensions: () => supportedTSExtensions,
	    supportedTSExtensionsFlat: () => supportedTSExtensionsFlat,
	    supportedTSImplementationExtensions: () => supportedTSImplementationExtensions,
	    suppressLeadingAndTrailingTrivia: () => suppressLeadingAndTrailingTrivia,
	    suppressLeadingTrivia: () => suppressLeadingTrivia,
	    suppressTrailingTrivia: () => suppressTrailingTrivia,
	    symbolEscapedNameNoDefault: () => symbolEscapedNameNoDefault,
	    symbolName: () => symbolName,
	    symbolNameNoDefault: () => symbolNameNoDefault,
	    symbolPart: () => symbolPart,
	    symbolToDisplayParts: () => symbolToDisplayParts,
	    syntaxMayBeASICandidate: () => syntaxMayBeASICandidate,
	    syntaxRequiresTrailingSemicolonOrASI: () => syntaxRequiresTrailingSemicolonOrASI,
	    sys: () => sys,
	    sysLog: () => sysLog,
	    tagNamesAreEquivalent: () => tagNamesAreEquivalent,
	    takeWhile: () => takeWhile,
	    targetOptionDeclaration: () => targetOptionDeclaration,
	    templateObjectHelper: () => templateObjectHelper,
	    testFormatSettings: () => testFormatSettings,
	    textChangeRangeIsUnchanged: () => textChangeRangeIsUnchanged,
	    textChangeRangeNewSpan: () => textChangeRangeNewSpan,
	    textChanges: () => ts_textChanges_exports,
	    textOrKeywordPart: () => textOrKeywordPart,
	    textPart: () => textPart,
	    textRangeContainsPositionInclusive: () => textRangeContainsPositionInclusive,
	    textSpanContainsPosition: () => textSpanContainsPosition,
	    textSpanContainsTextSpan: () => textSpanContainsTextSpan,
	    textSpanEnd: () => textSpanEnd,
	    textSpanIntersection: () => textSpanIntersection,
	    textSpanIntersectsWith: () => textSpanIntersectsWith,
	    textSpanIntersectsWithPosition: () => textSpanIntersectsWithPosition,
	    textSpanIntersectsWithTextSpan: () => textSpanIntersectsWithTextSpan,
	    textSpanIsEmpty: () => textSpanIsEmpty,
	    textSpanOverlap: () => textSpanOverlap,
	    textSpanOverlapsWith: () => textSpanOverlapsWith,
	    textSpansEqual: () => textSpansEqual,
	    textToKeywordObj: () => textToKeywordObj,
	    timestamp: () => timestamp,
	    toArray: () => toArray,
	    toBuilderFileEmit: () => toBuilderFileEmit,
	    toBuilderStateFileInfoForMultiEmit: () => toBuilderStateFileInfoForMultiEmit,
	    toEditorSettings: () => toEditorSettings,
	    toFileNameLowerCase: () => toFileNameLowerCase,
	    toLowerCase: () => toLowerCase,
	    toPath: () => toPath,
	    toProgramEmitPending: () => toProgramEmitPending,
	    tokenIsIdentifierOrKeyword: () => tokenIsIdentifierOrKeyword,
	    tokenIsIdentifierOrKeywordOrGreaterThan: () => tokenIsIdentifierOrKeywordOrGreaterThan,
	    tokenToString: () => tokenToString,
	    trace: () => trace,
	    tracing: () => tracing,
	    tracingEnabled: () => tracingEnabled,
	    transform: () => transform,
	    transformClassFields: () => transformClassFields,
	    transformDeclarations: () => transformDeclarations,
	    transformECMAScriptModule: () => transformECMAScriptModule,
	    transformES2015: () => transformES2015,
	    transformES2016: () => transformES2016,
	    transformES2017: () => transformES2017,
	    transformES2018: () => transformES2018,
	    transformES2019: () => transformES2019,
	    transformES2020: () => transformES2020,
	    transformES2021: () => transformES2021,
	    transformES5: () => transformES5,
	    transformESDecorators: () => transformESDecorators,
	    transformESNext: () => transformESNext,
	    transformGenerators: () => transformGenerators,
	    transformJsx: () => transformJsx,
	    transformLegacyDecorators: () => transformLegacyDecorators,
	    transformModule: () => transformModule,
	    transformNamedEvaluation: () => transformNamedEvaluation,
	    transformNodeModule: () => transformNodeModule,
	    transformNodes: () => transformNodes,
	    transformSystemModule: () => transformSystemModule,
	    transformTypeScript: () => transformTypeScript,
	    transpile: () => transpile,
	    transpileModule: () => transpileModule,
	    transpileOptionValueCompilerOptions: () => transpileOptionValueCompilerOptions,
	    tryAddToSet: () => tryAddToSet,
	    tryAndIgnoreErrors: () => tryAndIgnoreErrors,
	    tryCast: () => tryCast,
	    tryDirectoryExists: () => tryDirectoryExists,
	    tryExtractTSExtension: () => tryExtractTSExtension,
	    tryFileExists: () => tryFileExists,
	    tryGetClassExtendingExpressionWithTypeArguments: () => tryGetClassExtendingExpressionWithTypeArguments,
	    tryGetClassImplementingOrExtendingExpressionWithTypeArguments: () => tryGetClassImplementingOrExtendingExpressionWithTypeArguments,
	    tryGetDirectories: () => tryGetDirectories,
	    tryGetExtensionFromPath: () => tryGetExtensionFromPath2,
	    tryGetImportFromModuleSpecifier: () => tryGetImportFromModuleSpecifier,
	    tryGetJSDocSatisfiesTypeNode: () => tryGetJSDocSatisfiesTypeNode,
	    tryGetModuleNameFromFile: () => tryGetModuleNameFromFile,
	    tryGetModuleSpecifierFromDeclaration: () => tryGetModuleSpecifierFromDeclaration,
	    tryGetNativePerformanceHooks: () => tryGetNativePerformanceHooks,
	    tryGetPropertyAccessOrIdentifierToString: () => tryGetPropertyAccessOrIdentifierToString,
	    tryGetPropertyNameOfBindingOrAssignmentElement: () => tryGetPropertyNameOfBindingOrAssignmentElement,
	    tryGetSourceMappingURL: () => tryGetSourceMappingURL,
	    tryGetTextOfPropertyName: () => tryGetTextOfPropertyName,
	    tryIOAndConsumeErrors: () => tryIOAndConsumeErrors,
	    tryParseJson: () => tryParseJson,
	    tryParsePattern: () => tryParsePattern,
	    tryParsePatterns: () => tryParsePatterns,
	    tryParseRawSourceMap: () => tryParseRawSourceMap,
	    tryReadDirectory: () => tryReadDirectory,
	    tryReadFile: () => tryReadFile,
	    tryRemoveDirectoryPrefix: () => tryRemoveDirectoryPrefix,
	    tryRemoveExtension: () => tryRemoveExtension,
	    tryRemovePrefix: () => tryRemovePrefix,
	    tryRemoveSuffix: () => tryRemoveSuffix,
	    typeAcquisitionDeclarations: () => typeAcquisitionDeclarations,
	    typeAliasNamePart: () => typeAliasNamePart,
	    typeDirectiveIsEqualTo: () => typeDirectiveIsEqualTo,
	    typeKeywords: () => typeKeywords,
	    typeParameterNamePart: () => typeParameterNamePart,
	    typeToDisplayParts: () => typeToDisplayParts,
	    unchangedPollThresholds: () => unchangedPollThresholds,
	    unchangedTextChangeRange: () => unchangedTextChangeRange,
	    unescapeLeadingUnderscores: () => unescapeLeadingUnderscores,
	    unmangleScopedPackageName: () => unmangleScopedPackageName,
	    unorderedRemoveItem: () => unorderedRemoveItem,
	    unorderedRemoveItemAt: () => unorderedRemoveItemAt,
	    unreachableCodeIsError: () => unreachableCodeIsError,
	    unusedLabelIsError: () => unusedLabelIsError,
	    unwrapInnermostStatementOfLabel: () => unwrapInnermostStatementOfLabel,
	    updateErrorForNoInputFiles: () => updateErrorForNoInputFiles,
	    updateLanguageServiceSourceFile: () => updateLanguageServiceSourceFile,
	    updateMissingFilePathsWatch: () => updateMissingFilePathsWatch,
	    updateResolutionField: () => updateResolutionField,
	    updateSharedExtendedConfigFileWatcher: () => updateSharedExtendedConfigFileWatcher,
	    updateSourceFile: () => updateSourceFile,
	    updateWatchingWildcardDirectories: () => updateWatchingWildcardDirectories,
	    usesExtensionsOnImports: () => usesExtensionsOnImports,
	    usingSingleLineStringWriter: () => usingSingleLineStringWriter,
	    utf16EncodeAsString: () => utf16EncodeAsString,
	    validateLocaleAndSetLanguage: () => validateLocaleAndSetLanguage,
	    valuesHelper: () => valuesHelper,
	    version: () => version,
	    versionMajorMinor: () => versionMajorMinor,
	    visitArray: () => visitArray,
	    visitCommaListElements: () => visitCommaListElements,
	    visitEachChild: () => visitEachChild,
	    visitFunctionBody: () => visitFunctionBody,
	    visitIterationBody: () => visitIterationBody,
	    visitLexicalEnvironment: () => visitLexicalEnvironment,
	    visitNode: () => visitNode,
	    visitNodes: () => visitNodes2,
	    visitParameterList: () => visitParameterList,
	    walkUpBindingElementsAndPatterns: () => walkUpBindingElementsAndPatterns,
	    walkUpLexicalEnvironments: () => walkUpLexicalEnvironments,
	    walkUpOuterExpressions: () => walkUpOuterExpressions,
	    walkUpParenthesizedExpressions: () => walkUpParenthesizedExpressions,
	    walkUpParenthesizedTypes: () => walkUpParenthesizedTypes,
	    walkUpParenthesizedTypesAndGetParentAndChild: () => walkUpParenthesizedTypesAndGetParentAndChild,
	    whitespaceOrMapCommentRegExp: () => whitespaceOrMapCommentRegExp,
	    writeCommentRange: () => writeCommentRange,
	    writeFile: () => writeFile,
	    writeFileEnsuringDirectories: () => writeFileEnsuringDirectories,
	    zipWith: () => zipWith
	  });
	  var init_ts8 = __esm({
	    "src/typescript/_namespaces/ts.ts"() {
	      init_ts2();
	      init_ts3();
	      init_ts4();
	      init_ts7();
	      init_ts_server4();
	    }
	  });

	  // src/typescript/typescript.ts
	  var require_typescript = __commonJS({
	    "src/typescript/typescript.ts"(exports, module2) {
	      init_ts8();
	      init_ts8();
	      if (typeof console !== "undefined") {
	        Debug.loggingHost = {
	          log(level, s) {
	            switch (level) {
	              case 1 /* Error */:
	                return console.error(s);
	              case 2 /* Warning */:
	                return console.warn(s);
	              case 3 /* Info */:
	                return console.log(s);
	              case 4 /* Verbose */:
	                return console.log(s);
	            }
	          }
	        };
	      }
	      module2.exports = ts_exports3;
	    }
	  });
	  return require_typescript();
	})();

	if (module.exports) { module.exports = ts; }
	
} (typescript$2));

var typescriptExports = typescript$2.exports;
var typescript$1 = /*@__PURE__*/getDefaultExportFromCjs(typescriptExports);

/**
 * Create a format diagnostics host to use with the Typescript type checking APIs.
 * Typescript hosts are used to represent the user's system,
 * with an API for checking case sensitivity etc.
 * @param compilerOptions Typescript compiler options. Affects functions such as `getNewLine`.
 * @see https://github.com/Microsoft/TypeScript/wiki/Using-the-Compiler-API
 */
function createFormattingHost(ts, compilerOptions) {
    return {
        /** Returns the compiler options for the project. */
        getCompilationSettings: () => compilerOptions,
        /** Returns the current working directory. */
        getCurrentDirectory: () => process.cwd(),
        /** Returns the string that corresponds with the selected `NewLineKind`. */
        getNewLine() {
            switch (compilerOptions.newLine) {
                case ts.NewLineKind.CarriageReturnLineFeed:
                    return '\r\n';
                case ts.NewLineKind.LineFeed:
                    return '\n';
                default:
                    return ts.sys.newLine;
            }
        },
        /** Returns a lower case name on case insensitive systems, otherwise the original name. */
        getCanonicalFileName: (fileName) => ts.sys.useCaseSensitiveFileNames ? fileName : fileName.toLowerCase()
    };
}

/**
 * Create a helper for resolving modules using Typescript.
 * @param host Typescript host that extends `ModuleResolutionHost`
 * with methods for sanitizing filenames and getting compiler options.
 */
function createModuleResolver(ts, host, filter) {
    const compilerOptions = host.getCompilationSettings();
    const cache = ts.createModuleResolutionCache(process.cwd(), host.getCanonicalFileName, compilerOptions);
    const moduleHost = { ...ts.sys, ...host };
    return (moduleName, containingFile, redirectedReference, mode) => {
        const { resolvedModule } = ts.resolveModuleName(moduleName, containingFile, compilerOptions, moduleHost, cache, redirectedReference, mode);
        /**
         * If the module's path contains 'node_modules', ts considers it an external library and refuses to compile it,
         * so we have to change the value of `isExternalLibraryImport` to false if it's true
         * */
        if ((resolvedModule === null || resolvedModule === void 0 ? void 0 : resolvedModule.isExternalLibraryImport) && filter(resolvedModule === null || resolvedModule === void 0 ? void 0 : resolvedModule.resolvedFileName)) {
            resolvedModule.isExternalLibraryImport = false;
        }
        return resolvedModule;
    };
}

// const resolveIdAsync = (file: string, opts: AsyncOpts) =>
//   new Promise<string>((fulfil, reject) =>
//     resolveId(file, opts, (err, contents) =>
//       err || typeof contents === 'undefined' ? reject(err) : fulfil(contents)
//     )
//   );
const resolveId = (file, opts) => resolve$1.sync(file, opts);
/**
 * Returns code asynchronously for the tslib helper library.
 */
const getTsLibPath = () => {
    // Note: This isn't preferable, but we've no other way to test this bit. Removing the tslib devDep
    //       during the test run doesn't work due to the nature of the pnpm flat node_modules, and
    //       other workspace dependencies that depenend upon tslib.
    try {
        // eslint-disable-next-line no-underscore-dangle
        return resolveId(process.env.__TSLIB_TEST_PATH__ || 'tslib/tslib.es6.js', {
            // @ts-ignore import.meta.url is allowed because the Rollup plugin injects the correct module format
            basedir: require$$1$4.fileURLToPath(new URL('.', (typeof document === 'undefined' ? new (require('u' + 'rl').URL)('file:' + __filename).href : (document.currentScript && document.currentScript.src || new URL('index.cjs.js', document.baseURI).href))))
        });
    }
    catch (_) {
        return null;
    }
};

/**
 * Separate the Rollup plugin options from the Typescript compiler options,
 * and normalize the Rollup options.
 * @returns Object with normalized options:
 * - `filter`: Checks if a file should be included.
 * - `tsconfig`: Path to a tsconfig, or directive to ignore tsconfig.
 * - `compilerOptions`: Custom Typescript compiler options that override tsconfig.
 * - `typescript`: Instance of Typescript library (possibly custom).
 * - `tslib`: ESM code from the tslib helper library (possibly custom).
 */
const getPluginOptions = (options) => {
    const { cacheDir, exclude, include, filterRoot, noForceEmit, transformers, tsconfig, tslib, typescript, outputToFilesystem, compilerOptions, 
    // previously was compilerOptions
    ...extra } = options;
    return {
        cacheDir,
        include,
        exclude,
        filterRoot,
        noForceEmit: noForceEmit || false,
        tsconfig,
        compilerOptions: { ...extra, ...compilerOptions },
        typescript: typescript || typescript$1,
        tslib: tslib || getTsLibPath(),
        transformers,
        outputToFilesystem
    };
};

/**
 * Converts a Typescript type error into an equivalent Rollup warning object.
 */
function diagnosticToWarning(ts, host, diagnostic) {
    const pluginCode = `TS${diagnostic.code}`;
    const message = ts.flattenDiagnosticMessageText(diagnostic.messageText, '\n');
    // Build a Rollup warning object from the diagnostics object.
    const warning = {
        pluginCode,
        message: `@rollup/plugin-typescript ${pluginCode}: ${message}`
    };
    if (diagnostic.file) {
        // Add information about the file location
        const { line, character } = diagnostic.file.getLineAndCharacterOfPosition(diagnostic.start);
        warning.loc = {
            column: character + 1,
            line: line + 1,
            file: diagnostic.file.fileName
        };
        if (host) {
            // Extract a code frame from Typescript
            const formatted = ts.formatDiagnosticsWithColorAndContext([diagnostic], host);
            // Typescript only exposes this formatter as a string prefixed with the flattened message.
            // We need to remove it here since Rollup treats the properties as separate parts.
            let frame = formatted.slice(formatted.indexOf(message) + message.length);
            const newLine = host.getNewLine();
            if (frame.startsWith(newLine)) {
                frame = frame.slice(frame.indexOf(newLine) + newLine.length);
            }
            warning.frame = frame;
        }
    }
    return warning;
}

const DEFAULT_COMPILER_OPTIONS = {
    module: 'esnext',
    skipLibCheck: true
};
const OVERRIDABLE_EMIT_COMPILER_OPTIONS = {
    noEmit: false,
    emitDeclarationOnly: false
};
const FORCED_COMPILER_OPTIONS = {
    // Always use tslib
    noEmitHelpers: true,
    importHelpers: true,
    // Preventing Typescript from resolving code may break compilation
    noResolve: false
};

/* eslint-disable no-param-reassign */
const DIRECTORY_PROPS = ['outDir', 'declarationDir'];
/**
 * Mutates the compiler options to convert paths from relative to absolute.
 * This should be used with compiler options passed through the Rollup plugin options,
 * not those found from loading a tsconfig.json file.
 * @param compilerOptions Compiler options to _mutate_.
 * @param relativeTo Paths are resolved relative to this path.
 */
function makePathsAbsolute(compilerOptions, relativeTo) {
    for (const pathProp of DIRECTORY_PROPS) {
        if (compilerOptions[pathProp]) {
            compilerOptions[pathProp] = path$M.resolve(relativeTo, compilerOptions[pathProp]);
        }
    }
}
/**
 * Mutates the compiler options to normalize some values for Rollup.
 * @param compilerOptions Compiler options to _mutate_.
 * @returns True if the source map compiler option was not initially set.
 */
function normalizeCompilerOptions(ts, compilerOptions) {
    let autoSetSourceMap = false;
    if (compilerOptions.inlineSourceMap) {
        // Force separate source map files for Rollup to work with.
        compilerOptions.sourceMap = true;
        compilerOptions.inlineSourceMap = false;
    }
    else if (typeof compilerOptions.sourceMap !== 'boolean') {
        // Default to using source maps.
        // If the plugin user sets sourceMap to false we keep that option.
        compilerOptions.sourceMap = true;
        // Using inlineSources to make sure typescript generate source content
        // instead of source path.
        compilerOptions.inlineSources = true;
        autoSetSourceMap = true;
    }
    switch (compilerOptions.module) {
        case ts.ModuleKind.ES2015:
        case ts.ModuleKind.ESNext:
        case ts.ModuleKind.Node16:
        case ts.ModuleKind.NodeNext:
        case ts.ModuleKind.CommonJS:
            // OK module type
            return autoSetSourceMap;
        case ts.ModuleKind.None:
        case ts.ModuleKind.AMD:
        case ts.ModuleKind.UMD:
        case ts.ModuleKind.System: {
            // Invalid module type
            const moduleType = ts.ModuleKind[compilerOptions.module];
            throw new Error(`@rollup/plugin-typescript: The module kind should be 'ES2015', 'ESNext', 'node16' or 'nodenext', found: '${moduleType}'`);
        }
        default:
            // Unknown or unspecified module type, force ESNext
            compilerOptions.module = ts.ModuleKind.ESNext;
    }
    return autoSetSourceMap;
}

const { ModuleKind: ModuleKind$1, ModuleResolutionKind } = typescript$1;
function makeForcedCompilerOptions(noForceEmit) {
    return { ...FORCED_COMPILER_OPTIONS, ...(noForceEmit ? {} : OVERRIDABLE_EMIT_COMPILER_OPTIONS) };
}
/**
 * Finds the path to the tsconfig file relative to the current working directory.
 * @param relativePath Relative tsconfig path given by the user.
 * If `false` is passed, then a null path is returned.
 * @returns The absolute path, or null if the file does not exist.
 */
function getTsConfigPath(ts, relativePath) {
    if (relativePath === false)
        return null;
    // Resolve path to file. `tsConfigOption` defaults to 'tsconfig.json'.
    const tsConfigPath = path$M.resolve(process.cwd(), relativePath || 'tsconfig.json');
    if (!ts.sys.fileExists(tsConfigPath)) {
        if (relativePath) {
            // If an explicit path was provided but no file was found, throw
            throw new Error(`Could not find specified tsconfig.json at ${tsConfigPath}`);
        }
        else {
            return null;
        }
    }
    return tsConfigPath;
}
/**
 * Tries to read the tsconfig file at `tsConfigPath`.
 * @param tsConfigPath Absolute path to tsconfig JSON file.
 * @param explicitPath If true, the path was set by the plugin user.
 * If false, the path was computed automatically.
 */
function readTsConfigFile(ts, tsConfigPath) {
    const { config, error } = ts.readConfigFile(tsConfigPath, (path) => require$$0$9.readFileSync(path, 'utf8'));
    if (error) {
        throw Object.assign(Error(), diagnosticToWarning(ts, null, error));
    }
    return config || {};
}
/**
 * Returns true if any of the `compilerOptions` contain an enum value (i.e.: ts.ScriptKind) rather than a string.
 * This indicates that the internal CompilerOptions type is used rather than the JsonCompilerOptions.
 */
function containsEnumOptions(compilerOptions) {
    const enums = [
        'module',
        'target',
        'jsx',
        'moduleResolution',
        'newLine'
    ];
    return enums.some((prop) => prop in compilerOptions && typeof compilerOptions[prop] === 'number');
}
/**
 * The module resolution kind is a function of the resolved `compilerOptions.module`.
 * This needs to be set explicitly for `resolveModuleName` to select the correct resolution method
 */
function setModuleResolutionKind(parsedConfig) {
    const moduleKind = parsedConfig.options.module;
    // Fallback if `parsedConfig.options.moduleResolution` is not set
    const moduleResolution = moduleKind === ModuleKind$1.Node16
        ? ModuleResolutionKind.Node16
        : moduleKind === ModuleKind$1.NodeNext
            ? ModuleResolutionKind.NodeNext
            : ModuleResolutionKind.NodeJs;
    return {
        ...parsedConfig,
        options: {
            moduleResolution,
            ...parsedConfig.options
        }
    };
}
const configCache = new Map();
/**
 * Parse the Typescript config to use with the plugin.
 * @param ts Typescript library instance.
 * @param tsconfig Path to the tsconfig file, or `false` to ignore the file.
 * @param compilerOptions Options passed to the plugin directly for Typescript.
 *
 * @returns Parsed tsconfig.json file with some important properties:
 * - `options`: Parsed compiler options.
 * - `fileNames` Type definition files that should be included in the build.
 * - `errors`: Any errors from parsing the config file.
 */
function parseTypescriptConfig(ts, tsconfig, compilerOptions, noForceEmit) {
    /* eslint-disable no-undefined */
    const cwd = process.cwd();
    makePathsAbsolute(compilerOptions, cwd);
    let parsedConfig;
    // Resolve path to file. If file is not found, pass undefined path to `parseJsonConfigFileContent`.
    // eslint-disable-next-line no-undefined
    const tsConfigPath = getTsConfigPath(ts, tsconfig) || undefined;
    const tsConfigFile = tsConfigPath ? readTsConfigFile(ts, tsConfigPath) : {};
    const basePath = tsConfigPath ? path$M.dirname(tsConfigPath) : cwd;
    // If compilerOptions has enums, it represents an CompilerOptions object instead of parsed JSON.
    // This determines where the data is passed to the parser.
    if (containsEnumOptions(compilerOptions)) {
        parsedConfig = setModuleResolutionKind(ts.parseJsonConfigFileContent({
            ...tsConfigFile,
            compilerOptions: {
                ...DEFAULT_COMPILER_OPTIONS,
                ...tsConfigFile.compilerOptions
            }
        }, ts.sys, basePath, { ...compilerOptions, ...makeForcedCompilerOptions(noForceEmit) }, tsConfigPath, undefined, undefined, configCache));
    }
    else {
        parsedConfig = setModuleResolutionKind(ts.parseJsonConfigFileContent({
            ...tsConfigFile,
            compilerOptions: {
                ...DEFAULT_COMPILER_OPTIONS,
                ...tsConfigFile.compilerOptions,
                ...compilerOptions
            }
        }, ts.sys, basePath, makeForcedCompilerOptions(noForceEmit), tsConfigPath, undefined, undefined, configCache));
    }
    const autoSetSourceMap = normalizeCompilerOptions(ts, parsedConfig.options);
    return {
        ...parsedConfig,
        autoSetSourceMap
    };
}
/**
 * If errors are detected in the parsed options,
 * display all of them as warnings then emit an error.
 */
function emitParsedOptionsErrors(ts, context, parsedOptions) {
    if (parsedOptions.errors.length > 0) {
        parsedOptions.errors.forEach((error) => context.warn(diagnosticToWarning(ts, null, error)));
        context.error(`@rollup/plugin-typescript: Couldn't process compiler options`);
    }
}

/**
 * Validate that the `compilerOptions.sourceMap` option matches `outputOptions.sourcemap`.
 * @param context Rollup plugin context used to emit warnings.
 * @param compilerOptions Typescript compiler options.
 * @param outputOptions Rollup output options.
 * @param autoSetSourceMap True if the `compilerOptions.sourceMap` property was set to `true`
 * by the plugin, not the user.
 */
function validateSourceMap(context, compilerOptions, outputOptions, autoSetSourceMap) {
    if (compilerOptions.sourceMap && !outputOptions.sourcemap && !autoSetSourceMap) {
        context.warn(`@rollup/plugin-typescript: Rollup 'sourcemap' option must be set to generate source maps.`);
    }
    else if (!compilerOptions.sourceMap && outputOptions.sourcemap) {
        context.warn(`@rollup/plugin-typescript: Typescript 'sourceMap' compiler option must be set to generate source maps.`);
    }
}
/**
 * Validate that the out directory used by Typescript can be controlled by Rollup.
 * @param context Rollup plugin context used to emit errors.
 * @param compilerOptions Typescript compiler options.
 * @param outputOptions Rollup output options.
 */
function validatePaths(context, compilerOptions, outputOptions) {
    if (compilerOptions.out) {
        context.error(`@rollup/plugin-typescript: Deprecated Typescript compiler option 'out' is not supported. Use 'outDir' instead.`);
    }
    else if (compilerOptions.outFile) {
        context.error(`@rollup/plugin-typescript: Typescript compiler option 'outFile' is not supported. Use 'outDir' instead.`);
    }
    for (const dirProperty of DIRECTORY_PROPS) {
        if (compilerOptions[dirProperty] && outputOptions.dir) {
            // Checks if the given path lies within Rollup output dir
            const fromRollupDirToTs = path$M.relative(outputOptions.dir, compilerOptions[dirProperty]);
            if (fromRollupDirToTs.startsWith('..')) {
                context.error(`@rollup/plugin-typescript: Path of Typescript compiler option '${dirProperty}' must be located inside Rollup 'dir' option.`);
            }
        }
    }
    if (compilerOptions.declaration || compilerOptions.declarationMap || compilerOptions.composite) {
        if (DIRECTORY_PROPS.every((dirProperty) => !compilerOptions[dirProperty])) {
            context.error(`@rollup/plugin-typescript: You are using one of Typescript's compiler options 'declaration', 'declarationMap' or 'composite'. ` +
                `In this case 'outDir' or 'declarationDir' must be specified to generate declaration files.`);
        }
    }
}

/**
 * Checks if the given OutputFile represents some code
 */
function isCodeOutputFile(name) {
    return !isMapOutputFile(name) && !isDeclarationOutputFile(name);
}
/**
 * Checks if the given OutputFile represents some source map
 */
function isMapOutputFile(name) {
    return name.endsWith('.map');
}
/**
 * Checks if the given OutputFile represents some TypeScript source map
 */
function isTypeScriptMapOutputFile(name) {
    return name.endsWith('ts.map');
}
/**
 * Checks if the given OutputFile represents some declaration
 */
function isDeclarationOutputFile(name) {
    return /\.d\.[cm]?ts$/.test(name);
}
/**
 * Returns the content of a filename either from the current
 * typescript compiler instance or from the cached content.
 * @param fileName The filename for the contents to retrieve
 * @param emittedFiles The files emitted in the current typescript instance
 * @param tsCache A cache to files cached by Typescript
 */
function getEmittedFile(fileName, emittedFiles, tsCache) {
    let code;
    if (fileName) {
        if (emittedFiles.has(fileName)) {
            code = emittedFiles.get(fileName);
        }
        else {
            code = tsCache.getCached(fileName);
        }
    }
    return code;
}
/**
 * Finds the corresponding emitted Javascript files for a given Typescript file.
 * @param id Path to the Typescript file.
 * @param emittedFiles Map of file names to source code,
 * containing files emitted by the Typescript compiler.
 */
function findTypescriptOutput(ts, parsedOptions, id, emittedFiles, tsCache) {
    const emittedFileNames = ts.getOutputFileNames(parsedOptions, id, !ts.sys.useCaseSensitiveFileNames);
    const codeFile = emittedFileNames.find(isCodeOutputFile);
    const mapFile = emittedFileNames.find(isMapOutputFile);
    return {
        code: getEmittedFile(codeFile, emittedFiles, tsCache),
        map: getEmittedFile(mapFile, emittedFiles, tsCache),
        declarations: emittedFileNames.filter((name) => name !== codeFile && name !== mapFile)
    };
}
function normalizePath(fileName) {
    return fileName.split(path__namespace.win32.sep).join(path__namespace.posix.sep);
}
async function emitFile({ dir }, outputToFilesystem, context, filePath, fileSource) {
    const normalizedFilePath = normalizePath(filePath);
    // const normalizedPath = normalizePath(filePath);
    // Note: `dir` can be a value like `dist` in which case, `path.relative` could result in a value
    // of something like `'../.tsbuildinfo'. Our else-case below needs to mimic `path.relative`
    // returning a dot-notated relative path, so the first if-then branch is entered into
    const relativePath = dir ? path__namespace.relative(dir, normalizedFilePath) : '..';
    // legal paths do not start with . nor .. : https://github.com/rollup/rollup/issues/3507#issuecomment-616495912
    if (relativePath.startsWith('..')) {
        if (outputToFilesystem == null) {
            context.warn(`@rollup/plugin-typescript: outputToFilesystem option is defaulting to true.`);
        }
        if (outputToFilesystem !== false) {
            await require$$0$9.promises.mkdir(path__namespace.dirname(normalizedFilePath), { recursive: true });
            await require$$0$9.promises.writeFile(normalizedFilePath, fileSource);
        }
    }
    else {
        context.emitFile({
            type: 'asset',
            fileName: relativePath,
            source: fileSource
        });
    }
}

// import { resolveIdAsync } from './tslib';
const { ModuleKind } = typescript$1;
const pluginName = '@rollup/plugin-typescript';
const moduleErrorMessage = `
${pluginName}: Rollup requires that TypeScript produces ES Modules. Unfortunately your configuration specifies a
 "module" other than "esnext". Unless you know what you're doing, please change "module" to "esnext"
 in the target tsconfig.json file or plugin options.`.replace(/\n/g, '');
const tsLibErrorMessage = `${pluginName}: Could not find module 'tslib', which is required by this plugin. Is it installed?`;
let undef;
const validModules = [
    ModuleKind.ES2015,
    ModuleKind.ES2020,
    ModuleKind.ESNext,
    ModuleKind.Node16,
    ModuleKind.NodeNext,
    undef
];
// eslint-disable-next-line import/prefer-default-export
const preflight = ({ config, context, inputPreserveModules, tslib }) => {
    if (!validModules.includes(config.options.module)) {
        context.warn(moduleErrorMessage);
    }
    if (!inputPreserveModules && tslib === null) {
        context.error(tsLibErrorMessage);
    }
};

// `Cannot compile modules into 'es6' when targeting 'ES5' or lower.`
const CANNOT_COMPILE_ESM = 1204;
/**
 * Emit a Rollup warning or error for a Typescript type error.
 */
function emitDiagnostic(ts, context, host, diagnostic) {
    if (diagnostic.code === CANNOT_COMPILE_ESM)
        return;
    const { noEmitOnError } = host.getCompilationSettings();
    // Build a Rollup warning object from the diagnostics object.
    const warning = diagnosticToWarning(ts, host, diagnostic);
    // Errors are fatal. Otherwise emit warnings.
    if (noEmitOnError && diagnostic.category === ts.DiagnosticCategory.Error) {
        context.error(warning);
    }
    else {
        context.warn(warning);
    }
}
function buildDiagnosticReporter(ts, context, host) {
    return function reportDiagnostics(diagnostic) {
        emitDiagnostic(ts, context, host, diagnostic);
    };
}

/**
 * Merges all received custom transformer definitions into a single CustomTransformers object
 */
function mergeTransformers(builder, ...input) {
    // List of all transformer stages
    const transformerTypes = ['after', 'afterDeclarations', 'before'];
    const accumulator = {
        after: [],
        afterDeclarations: [],
        before: []
    };
    let program;
    let typeChecker;
    input.forEach((transformers) => {
        if (!transformers) {
            // Skip empty arguments lists
            return;
        }
        transformerTypes.forEach((stage) => {
            getTransformers(transformers[stage]).forEach((transformer) => {
                if (!transformer) {
                    // Skip empty
                    return;
                }
                if ('type' in transformer) {
                    if (typeof transformer.factory === 'function') {
                        // Allow custom factories to grab the extra information required
                        program = program || builder.getProgram();
                        typeChecker = typeChecker || program.getTypeChecker();
                        let factory;
                        if (transformer.type === 'program') {
                            program = program || builder.getProgram();
                            factory = transformer.factory(program);
                        }
                        else {
                            program = program || builder.getProgram();
                            typeChecker = typeChecker || program.getTypeChecker();
                            factory = transformer.factory(typeChecker);
                        }
                        // Forward the requested reference to the custom transformer factory
                        if (factory) {
                            accumulator[stage].push(factory);
                        }
                    }
                }
                else {
                    // Add normal transformer factories as is
                    accumulator[stage].push(transformer);
                }
            });
        });
    });
    return accumulator;
}
function getTransformers(transformers) {
    return transformers || [];
}

const { DiagnosticCategory } = typescript$1;
// @see https://github.com/microsoft/TypeScript/blob/master/src/compiler/diagnosticMessages.json
// eslint-disable-next-line no-shadow
var DiagnosticCode;
(function (DiagnosticCode) {
    DiagnosticCode[DiagnosticCode["FILE_CHANGE_DETECTED"] = 6032] = "FILE_CHANGE_DETECTED";
    DiagnosticCode[DiagnosticCode["FOUND_1_ERROR_WATCHING_FOR_FILE_CHANGES"] = 6193] = "FOUND_1_ERROR_WATCHING_FOR_FILE_CHANGES";
    DiagnosticCode[DiagnosticCode["FOUND_N_ERRORS_WATCHING_FOR_FILE_CHANGES"] = 6194] = "FOUND_N_ERRORS_WATCHING_FOR_FILE_CHANGES";
})(DiagnosticCode || (DiagnosticCode = {}));
function createDeferred(timeout) {
    let promise;
    let resolve = () => { };
    if (timeout) {
        promise = Promise.race([
            new Promise((r) => setTimeout(r, timeout, true)),
            new Promise((r) => (resolve = r))
        ]);
    }
    else {
        promise = new Promise((r) => (resolve = r));
    }
    return { promise, resolve };
}
/**
 * Typescript watch program helper to sync Typescript watch status with Rollup hooks.
 */
class WatchProgramHelper {
    constructor() {
        this._startDeferred = null;
        this._finishDeferred = null;
    }
    watch(timeout = 1000) {
        // Race watcher start promise against a timeout in case Typescript and Rollup change detection is not in sync.
        this._startDeferred = createDeferred(timeout);
        this._finishDeferred = createDeferred();
    }
    handleStatus(diagnostic) {
        // Fullfil deferred promises by Typescript diagnostic message codes.
        if (diagnostic.category === DiagnosticCategory.Message) {
            switch (diagnostic.code) {
                case DiagnosticCode.FILE_CHANGE_DETECTED:
                    this.resolveStart();
                    break;
                case DiagnosticCode.FOUND_1_ERROR_WATCHING_FOR_FILE_CHANGES:
                case DiagnosticCode.FOUND_N_ERRORS_WATCHING_FOR_FILE_CHANGES:
                    this.resolveFinish();
                    break;
            }
        }
    }
    resolveStart() {
        if (this._startDeferred) {
            this._startDeferred.resolve(false);
            this._startDeferred = null;
        }
    }
    resolveFinish() {
        if (this._finishDeferred) {
            this._finishDeferred.resolve(false);
            this._finishDeferred = null;
        }
    }
    async wait() {
        var _a;
        if (this._startDeferred) {
            const timeout = await this._startDeferred.promise;
            // If there is no file change detected by Typescript skip deferred promises.
            if (timeout) {
                this._startDeferred = null;
                this._finishDeferred = null;
            }
            await ((_a = this._finishDeferred) === null || _a === void 0 ? void 0 : _a.promise);
        }
    }
}
/**
 * Create a language service host to use with the Typescript compiler & type checking APIs.
 * Typescript hosts are used to represent the user's system,
 * with an API for reading files, checking directories and case sensitivity etc.
 * @see https://github.com/Microsoft/TypeScript/wiki/Using-the-Compiler-API
 */
function createWatchHost(ts, context, { formatHost, parsedOptions, writeFile, status, resolveModule, transformers }) {
    const createProgram = ts.createEmitAndSemanticDiagnosticsBuilderProgram;
    const baseHost = ts.createWatchCompilerHost(parsedOptions.fileNames, parsedOptions.options, ts.sys, createProgram, buildDiagnosticReporter(ts, context, formatHost), status, parsedOptions.projectReferences);
    return {
        ...baseHost,
        /** Override the created program so an in-memory emit is used */
        afterProgramCreate(program) {
            const origEmit = program.emit;
            // eslint-disable-next-line no-param-reassign
            program.emit = (targetSourceFile, _, ...args) => origEmit(targetSourceFile, writeFile, 
            // cancellationToken
            args[0], 
            // emitOnlyDtsFiles
            args[1], mergeTransformers(program, transformers, args[2]));
            return baseHost.afterProgramCreate(program);
        },
        /** Add helper to deal with module resolution */
        resolveModuleNames(moduleNames, containingFile, _reusedNames, redirectedReference, _optionsOnlyWithNewerTsVersions, containingSourceFile) {
            return moduleNames.map((moduleName, i) => {
                var _a;
                const mode = containingSourceFile
                    ? (_a = ts.getModeForResolutionAtIndex) === null || _a === void 0 ? void 0 : _a.call(ts, containingSourceFile, i)
                    : undefined; // eslint-disable-line no-undefined
                return resolveModule(moduleName, containingFile, redirectedReference, mode);
            });
        }
    };
}
function createWatchProgram(ts, context, options) {
    return ts.createWatchProgram(createWatchHost(ts, context, options));
}

/** Creates the folders needed given a path to a file to be saved*/
const createFileFolder = (filePath) => {
    const folderPath = path__default["default"].dirname(filePath);
    require$$0__default["default"].mkdirSync(folderPath, { recursive: true });
};
class TSCache {
    constructor(cacheFolder = '.rollup.cache') {
        this._cacheFolder = cacheFolder;
    }
    /** Returns the path to the cached file */
    cachedFilename(fileName) {
        return path__default["default"].join(this._cacheFolder, fileName.replace(/^([a-zA-Z]+):/, '$1'));
    }
    /** Emits a file in the cache folder */
    cacheCode(fileName, code) {
        const cachedPath = this.cachedFilename(fileName);
        createFileFolder(cachedPath);
        require$$0__default["default"].writeFileSync(cachedPath, code);
    }
    /** Checks if a file is in the cache */
    isCached(fileName) {
        return require$$0__default["default"].existsSync(this.cachedFilename(fileName));
    }
    /** Read a file from the cache given the output name*/
    getCached(fileName) {
        let code;
        if (this.isCached(fileName)) {
            code = require$$0__default["default"].readFileSync(this.cachedFilename(fileName), { encoding: 'utf-8' });
        }
        return code;
    }
}

function typescript(options = {}) {
    const { cacheDir, compilerOptions, exclude, filterRoot, include, outputToFilesystem, noForceEmit, transformers, tsconfig, tslib, typescript: ts } = getPluginOptions(options);
    const tsCache = new TSCache(cacheDir);
    const emittedFiles = new Map();
    const watchProgramHelper = new WatchProgramHelper();
    const parsedOptions = parseTypescriptConfig(ts, tsconfig, compilerOptions, noForceEmit);
    const filter = createFilter(include || '{,**/}*.(cts|mts|ts|tsx)', exclude, {
        resolve: filterRoot !== null && filterRoot !== void 0 ? filterRoot : parsedOptions.options.rootDir
    });
    parsedOptions.fileNames = parsedOptions.fileNames.filter(filter);
    const formatHost = createFormattingHost(ts, parsedOptions.options);
    const resolveModule = createModuleResolver(ts, formatHost, filter);
    let program = null;
    return {
        name: 'typescript',
        buildStart(rollupOptions) {
            emitParsedOptionsErrors(ts, this, parsedOptions);
            preflight({
                config: parsedOptions,
                context: this,
                // TODO drop rollup@3 support and remove
                inputPreserveModules: rollupOptions
                    .preserveModules,
                tslib
            });
            // Fixes a memory leak https://github.com/rollup/plugins/issues/322
            if (this.meta.watchMode !== true) {
                // eslint-disable-next-line
                program === null || program === void 0 ? void 0 : program.close();
                program = null;
            }
            if (!program) {
                program = createWatchProgram(ts, this, {
                    formatHost,
                    resolveModule,
                    parsedOptions,
                    writeFile(fileName, data) {
                        if (parsedOptions.options.composite || parsedOptions.options.incremental) {
                            tsCache.cacheCode(fileName, data);
                        }
                        emittedFiles.set(fileName, data);
                    },
                    status(diagnostic) {
                        watchProgramHelper.handleStatus(diagnostic);
                    },
                    transformers
                });
            }
        },
        watchChange(id) {
            if (!filter(id))
                return;
            watchProgramHelper.watch();
        },
        buildEnd() {
            if (this.meta.watchMode !== true) {
                // ESLint doesn't understand optional chaining
                // eslint-disable-next-line
                program === null || program === void 0 ? void 0 : program.close();
            }
        },
        renderStart(outputOptions) {
            validateSourceMap(this, parsedOptions.options, outputOptions, parsedOptions.autoSetSourceMap);
            validatePaths(this, parsedOptions.options, outputOptions);
        },
        resolveId(importee, importer) {
            if (importee === 'tslib') {
                return tslib;
            }
            if (!importer)
                return null;
            // Convert path from windows separators to posix separators
            const containingFile = normalizePath(importer);
            // when using node16 or nodenext module resolution, we need to tell ts if
            // we are resolving to a commonjs or esnext module
            const mode = typeof ts.getImpliedNodeFormatForFile === 'function'
                ? ts.getImpliedNodeFormatForFile(
                // @ts-expect-error
                containingFile, undefined, // eslint-disable-line no-undefined
                { ...ts.sys, ...formatHost }, parsedOptions.options)
                : undefined; // eslint-disable-line no-undefined
            // eslint-disable-next-line no-undefined
            const resolved = resolveModule(importee, containingFile, undefined, mode);
            if (resolved) {
                if (/\.d\.[cm]?ts/.test(resolved.extension))
                    return null;
                if (!filter(resolved.resolvedFileName))
                    return null;
                return path__namespace.normalize(resolved.resolvedFileName);
            }
            return null;
        },
        async load(id) {
            if (!filter(id))
                return null;
            this.addWatchFile(id);
            await watchProgramHelper.wait();
            const fileName = normalizePath(id);
            if (!parsedOptions.fileNames.includes(fileName)) {
                // Discovered new file that was not known when originally parsing the TypeScript config
                parsedOptions.fileNames.push(fileName);
            }
            const output = findTypescriptOutput(ts, parsedOptions, id, emittedFiles, tsCache);
            return output.code != null ? output : null;
        },
        async generateBundle(outputOptions) {
            const declarationAndTypeScriptMapFiles = [...emittedFiles.keys()].filter((fileName) => isDeclarationOutputFile(fileName) || isTypeScriptMapOutputFile(fileName));
            declarationAndTypeScriptMapFiles.forEach((id) => {
                const code = getEmittedFile(id, emittedFiles, tsCache);
                if (!code || !parsedOptions.options.declaration) {
                    return;
                }
                let baseDir;
                if (outputOptions.dir) {
                    baseDir = outputOptions.dir;
                }
                else if (outputOptions.file) {
                    // find common path of output.file and configured declation output
                    const outputDir = path__namespace.dirname(outputOptions.file);
                    const configured = path__namespace.resolve(parsedOptions.options.declarationDir ||
                        parsedOptions.options.outDir ||
                        tsconfig ||
                        process.cwd());
                    const backwards = path__namespace
                        .relative(outputDir, configured)
                        .split(path__namespace.sep)
                        .filter((v) => v === '..')
                        .join(path__namespace.sep);
                    baseDir = path__namespace.normalize(`${outputDir}/${backwards}`);
                }
                if (!baseDir)
                    return;
                this.emitFile({
                    type: 'asset',
                    fileName: normalizePath(path__namespace.relative(baseDir, id)),
                    source: code
                });
            });
            const tsBuildInfoPath = ts.getTsBuildInfoEmitOutputFilePath(parsedOptions.options);
            if (tsBuildInfoPath) {
                const tsBuildInfoSource = emittedFiles.get(tsBuildInfoPath);
                // https://github.com/rollup/plugins/issues/681
                if (tsBuildInfoSource) {
                    await emitFile(outputOptions, outputToFilesystem, this, tsBuildInfoPath, tsBuildInfoSource);
                }
            }
        }
    };
}

const initComponent = (localConfig, viteConfig) => {
    var _a, _b, _c;
    /** 包名 */
    const pkgName = localConfig.name || "demo";
    /** alias 基础路径 */
    const ALIAS_ROOT_PATH = (localConfig === null || localConfig === void 0 ? void 0 : localConfig.alias).srcRoot || "./src/";
    /** 输出目录 */
    const OUTDIR_PATH = (localConfig === null || localConfig === void 0 ? void 0 : localConfig.outDir) || "./dist/";
    const config = {
        base: "/",
        /** 根目录 */
        root: localConfig.root || "./",
        // /** 存储缓存文件的目录。 */
        cacheDir: localConfig.cacheDir || "node_modules/.vite",
        clearScreen: localConfig.clearScreen || false,
        /** 出口文件 */
        build: {
            lib: {
                entry: path__default["default"].resolve(cwd, "src/components/index.tsx"),
                name: pkgName,
                fileName: pkgName,
            },
            cssTarget: "chrome61",
            outDir: path__default["default"].join(cwd, OUTDIR_PATH),
            rollupOptions: {
                // 确保外部化处理那些你不想打包进库的依赖
                external: [
                    "react",
                    "react-dom",
                    ...(((_b = (_a = localConfig === null || localConfig === void 0 ? void 0 : localConfig.build) === null || _a === void 0 ? void 0 : _a.rollupOptions) === null || _b === void 0 ? void 0 : _b.external) || []),
                ],
                output: {
                    // 在 UMD 构建模式下为这些外部化的依赖提供一个全局变量
                    globals: {
                        react: "react",
                        "react-dom": "react-dom",
                    },
                },
            },
        },
        /** 开发配置 */
        server: {
            host: "0.0.0.0",
            port: ((_c = localConfig.server) === null || _c === void 0 ? void 0 : _c.port) || 5000,
        },
        /** 路径设置 */
        resolve: {
            alias: Array.isArray(localConfig === null || localConfig === void 0 ? void 0 : localConfig.alias)
                ? localConfig.alias
                : [
                    {
                        find: "~@",
                        replacement: path__default["default"].join(ALIAS_ROOT_PATH + "components/"),
                    },
                    {
                        find: "~",
                        replacement: path__default["default"].join(ALIAS_ROOT_PATH),
                    },
                ],
        },
        /** 导入 .css 文件将会把内容插入到 <style> 标签中，同时也带有 HMR 支持。也能够以字符串的形式检索处理后的、作为其模块默认导出的 CSS。 */
        css: {
            modules: localConfig.cssModules
                ? {
                    // css模块化 文件以.module.[css|less|scss]结尾
                    generateScopedName: "[name]__[local]___[hash:base64:5]",
                    hashPrefix: "winkey",
                }
                : false,
            /** 指定传递给 CSS 预处理器的选项。文件扩展名用作选项的键 */
            preprocessorOptions: {
                less: {
                    /** 支持内敛JavaScript */
                    javascriptEnabled: true,
                },
                scss: {
                    /** 支持内敛JavaScript */
                    javascriptEnabled: true,
                },
            },
        },
        /** 插件 */
        plugins: [
            S$1({
                include: ["src/**/*.ts", "src/**/*.tsx", "src/*.ts", "src/*.tsx"],
            }),
            react({
                babel: {
                    plugins: [
                        ["@babel/plugin-proposal-decorators", { version: "legacy" }],
                        ["@babel/plugin-transform-class-properties", { loose: true }],
                    ],
                },
            }),
            src_default(),
            Y$1({
                fix: true,
                quiet: true,
            }),
        ],
    };
    /** 合并plugin */
    config.plugins = Object.assign(config.plugins, localConfig.plugins || []);
    /** 合并css */
    config.css = Object.assign(config.css, localConfig.css || {});
    const { mode, command } = viteConfig;
    const env = loadEnv(mode, process.cwd());
    const isBuild = command === "build";
    if (isBuild) {
        // 压缩 Html 插件
        config.define = {
            "process.env.NODE_ENV": '"production"',
        };
        config.plugins = [
            ...config.plugins,
            typescript({
                target: "es5",
                rootDir: path__default["default"].resolve(cwd, "src/components"),
                declaration: true,
                declarationDir: path__default["default"].resolve(cwd, "dist"),
                exclude: [
                    path__default["default"].resolve("node_modules/**"),
                    path__default["default"].resolve("winkey.config.ts"),
                ],
                allowSyntheticDefaultImports: true,
            }),
        ];
    }
    config.plugins = [
        ...config.plugins,
        createHtmlPlugin({
            inject: {
                data: Object.assign(Object.assign({}, env), { devServerToolScript: localConfig.winkeyTool && !isBuild
                        ? `<script type="module" src="/winkey_tool/js/index.js"></script>`
                        : "", devServerToolDom: localConfig.winkeyTool && !isBuild
                        ? `<div id="winkey_tool"></div>`
                        : "", devServerToolCss: localConfig.winkeyTool && !isBuild
                        ? `<link href="/winkey_tool/css/index.css" rel="stylesheet" >`
                        : "" }),
            },
        }),
    ];
    return config;
};

const initWinkeyConfig = (winkeyConfig, viteConfig) => {
    const localConfig = winkeyConfig;
    if (localConfig.component) {
        return initComponent(winkeyConfig, viteConfig);
    }
    return initProject(winkeyConfig, viteConfig);
};

exports.initWinkeyConfig = initWinkeyConfig;
